var SQL = function(SQL) {
  SQL = SQL || {};

// The Module object: Our interface to the outside world. We import
// and export values on it. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to check if Module already exists (e.g. case 3 above).
// Substitution will be replaced with actual code on later stage of the build,
// this way Closure Compiler will not mangle it (e.g. case 4. above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module = typeof SQL !== 'undefined' ? SQL : {};

// --pre-jses are emitted after the Module integration code, so that they can
// refer to Module (if they choose; they can also define Module)
'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.3.1
// Global constants
var Database, NULL, RegisterExtensionFunctions, SQLite, Statement, apiTemp, listeners, sqlite3_bind_blob, sqlite3_bind_double, sqlite3_bind_int, sqlite3_bind_parameter_index, sqlite3_bind_text, sqlite3_changes, sqlite3_clear_bindings, sqlite3_close_v2, sqlite3_column_blob, sqlite3_column_bytes, sqlite3_column_double, sqlite3_column_name, sqlite3_column_text, sqlite3_column_type, sqlite3_create_function_v2, sqlite3_data_count, sqlite3_errmsg, sqlite3_exec, sqlite3_finalize, sqlite3_free, sqlite3_open, sqlite3_prepare_v2, sqlite3_prepare_v2_sqlptr, sqlite3_reset, sqlite3_result_double, sqlite3_result_null, sqlite3_result_text, sqlite3_step, sqlite3_value_blob, sqlite3_value_bytes, sqlite3_value_double, sqlite3_value_int, sqlite3_value_text, sqlite3_value_type;

NULL = 0; // Null pointer

SQLite = {};

SQLite.OK = 0;

SQLite.ERROR = 1;

SQLite.INTERNAL = 2;

SQLite.PERM = 3;

SQLite.ABORT = 4;

SQLite.BUSY = 5;

SQLite.LOCKED = 6;

SQLite.NOMEM = 7;

SQLite.READONLY = 8;

SQLite.INTERRUPT = 9;

SQLite.IOERR = 10;

SQLite.CORRUPT = 11;

SQLite.NOTFOUND = 12;

SQLite.FULL = 13;

SQLite.CANTOPEN = 14;

SQLite.PROTOCOL = 15;

SQLite.EMPTY = 16;

SQLite.SCHEMA = 17;

SQLite.TOOBIG = 18;

SQLite.CONSTRAINT = 19;

SQLite.MISMATCH = 20;

SQLite.MISUSE = 21;

SQLite.NOLFS = 22;

SQLite.AUTH = 23;

SQLite.FORMAT = 24;

SQLite.RANGE = 25;

SQLite.NOTADB = 26;

SQLite.NOTICE = 27;

SQLite.WARNING = 28;

SQLite.ROW = 100;

SQLite.DONE = 101;

// Data types
SQLite.INTEGER = 1;

SQLite.FLOAT = 2;

SQLite.TEXT = 3;

SQLite.BLOB = 4;

SQLite.NULL = 5;

// Encodings, used for registering functions.
SQLite.UTF8 = 1;

//@copyright Ophir LOJKINE
Module['locateFile'] = function (file) {
  return __dirname + '/' + file;
};

listeners = [];

apiTemp = null;

sqlite3_open = null;

sqlite3_close_v2 = null;

sqlite3_exec = null;

sqlite3_free = null;

sqlite3_changes = null;

sqlite3_prepare_v2 = null;

sqlite3_prepare_v2_sqlptr = null;

sqlite3_bind_text = null;

sqlite3_bind_blob = null;

sqlite3_bind_double = null;

sqlite3_bind_int = null;

sqlite3_bind_parameter_index = null;

sqlite3_step = null;

sqlite3_errmsg = null;

sqlite3_data_count = null;

sqlite3_column_double = null;

sqlite3_column_text = null;

sqlite3_column_blob = null;

sqlite3_column_bytes = null;

sqlite3_column_type = null;

sqlite3_column_name = null;

sqlite3_reset = null;

sqlite3_clear_bindings = null;

sqlite3_finalize = null;

sqlite3_create_function_v2 = null;

sqlite3_value_type = null;

sqlite3_value_bytes = null;

sqlite3_value_text = null;

sqlite3_value_int = null;

sqlite3_value_blob = null;

sqlite3_value_double = null;

sqlite3_result_double = null;

sqlite3_result_null = null;

sqlite3_result_text = null;

RegisterExtensionFunctions = null;

// Represents an SQLite database
Module['Database'] = Database = function () {
  // Open a new database either by creating a new one or opening an existing one,
  // stored in the byte array passed in first argument
  // @param data [Array<Integer>] An array of bytes representing an SQLite database file
  function Database(data) {
    _classCallCheck(this, Database);

    this.filename = 'dbfile_' + (0xffffffff * Math.random() >>> 0);
    if (data != null) {
      FS.createDataFile('/', this.filename, data, true, true);
    }
    this.handleError(sqlite3_open(this.filename, apiTemp));
    this.db = getValue(apiTemp, 'i32');
    //RegisterExtensionFunctions(@db)
    this.statements = {}; // A list of all prepared statements of the database
  }

  /* Execute an SQL query, ignoring the rows it returns.
   @param sql [String] a string containing some SQL text to execute
  @param params [Array] (*optional*) When the SQL statement contains placeholders, you can pass them in here. They will be bound to the statement before it is executed.
   If you use the params argument, you **cannot** provide an sql string that contains several
  queries (separated by ';')
   @example Insert values in a table
  db.run("INSERT INTO test VALUES (:age, :name)", {':age':18, ':name':'John'});
   @return [Database] The database object (useful for method chaining)
  */


  _createClass(Database, [{
    key: 'run',
    value: function run(sql, params) {
      var stmt;
      if (!this.db) {
        throw "Database closed";
      }
      if (params) {
        stmt = this['prepare'](sql, params);
        stmt['step']();
        stmt['free']();
      } else {
        this.handleError(sqlite3_exec(this.db, sql, 0, 0, apiTemp));
      }
      return this;
    }

    /* Execute an SQL query, and returns the result.
     This is a wrapper against Database.prepare, Statement.step, Statement.get,
    and Statement.free.
     The result is an array of result elements. There are as many result elements
    as the number of statements in your sql string (statements are separated by a semicolon)
     Each result element is an object with two properties:
    'columns' : the name of the columns of the result (as returned by Statement.getColumnNames())
    'values' : an array of rows. Each row is itself an array of values
     ## Example use
    We have the following table, named *test* :
     | id | age |  name  |
    |:--:|:---:|:------:|
    | 1  |  1  | Ling   |
    | 2  |  18 | Paul   |
    | 3  |  3  | Markus |
     We query it like that:
    ```javascript
    var db = new SQL.Database();
    var res = db.exec("SELECT id FROM test; SELECT age,name FROM test;");
    ```
     `res` is now :
    ```javascript
    [
    {columns: ['id'], values:[[1],[2],[3]]},
    {columns: ['age','name'], values:[[1,'Ling'],[18,'Paul'],[3,'Markus']]}
    ]
    ```
     @param sql [String] a string containing some SQL text to execute
    @return [Array<QueryResults>] An array of results.
     */

  }, {
    key: 'exec',
    value: function exec(sql) {
      var bufLen, curresult, nextSqlPtr, pStmt, pzTail, results, stack, stmt;
      if (!this.db) {
        throw "Database closed";
      }
      stack = stackSave();
      // Store the SQL string in memory. The string will be consumed, one statement
      // at a time, by sqlite3_prepare_v2_sqlptr.
      // Allocate at most 4 bytes per UTF8 char, +1 for the trailing '\0'
      bufLen = sql.length << 2 + 1;
      nextSqlPtr = stackAlloc(bufLen);
      stringToUTF8(sql, nextSqlPtr, bufLen);
      // Used to store a pointer to the next SQL statement in the string
      pzTail = stackAlloc(4);
      results = [];
      while (getValue(nextSqlPtr, 'i8') !== NULL) {
        setValue(apiTemp, 0, 'i32');
        setValue(pzTail, 0, 'i32');
        this.handleError(sqlite3_prepare_v2_sqlptr(this.db, nextSqlPtr, -1, apiTemp, pzTail));
        pStmt = getValue(apiTemp, 'i32'); //  pointer to a statement, or null
        nextSqlPtr = getValue(pzTail, 'i32');
        if (pStmt === NULL) {
          continue; // Empty statement
        }
        stmt = new Statement(pStmt, this);
        curresult = null;
        while (stmt['step']()) {
          if (curresult === null) {
            curresult = {
              'columns': stmt['getColumnNames'](),
              'values': []
            };
            results.push(curresult);
          }
          curresult['values'].push(stmt['get']());
        }
        stmt['free']();
      }
      stackRestore(stack);
      return results;
    }

    /* Execute an sql statement, and call a callback for each row of result.
     **Currently** this method is synchronous, it will not return until the callback has
    been called on every row of the result. But this might change.
     @param sql [String] A string of SQL text. Can contain placeholders that will be
    bound to the parameters given as the second argument
    @param params [Array<String,Number,null,Uint8Array>] (*optional*) Parameters to bind
    to the query
    @param callback [Function(Object)] A function that will be called on each row of result
    @param done [Function] A function that will be called when all rows have been retrieved
     @return [Database] The database object. Useful for method chaining
     @example Read values from a table
    db.each("SELECT name,age FROM users WHERE age >= $majority",
                {$majority:18},
                function(row){console.log(row.name + " is a grown-up.")}
            );
     */

  }, {
    key: 'each',
    value: function each(sql, params, callback, done) {
      var stmt;
      if (typeof params === 'function') {
        done = callback;
        callback = params;
        params = void 0;
      }
      stmt = this['prepare'](sql, params);
      while (stmt['step']()) {
        callback(stmt['getAsObject']());
      }
      stmt['free']();
      if (typeof done === 'function') {
        return done();
      }
    }

    /* Prepare an SQL statement
    @param sql [String] a string of SQL, that can contain placeholders ('?', ':VVV', ':AAA', '@AAA')
    @param params [Array] (*optional*) values to bind to placeholders
    @return [Statement] the resulting statement
    @throw [String] SQLite error
    */

  }, {
    key: 'prepare',
    value: function prepare(sql, params) {
      var pStmt, stmt;
      setValue(apiTemp, 0, 'i32');
      this.handleError(sqlite3_prepare_v2(this.db, sql, -1, apiTemp, NULL));
      pStmt = getValue(apiTemp, 'i32'); //  pointer to a statement, or null
      if (pStmt === NULL) {
        throw 'Nothing to prepare';
      }
      stmt = new Statement(pStmt, this);
      if (params != null) {
        stmt.bind(params);
      }
      this.statements[pStmt] = stmt;
      return stmt;
    }

    /* Exports the contents of the database to a binary array
    @return [Uint8Array] An array of bytes of the SQLite3 database file
    */

  }, {
    key: 'export',
    value: function _export() {
      var _, binaryDb, ref, stmt;
      ref = this.statements;
      for (_ in ref) {
        stmt = ref[_];
        stmt['free']();
      }
      this.handleError(sqlite3_close_v2(this.db));
      binaryDb = FS.readFile(this.filename, {
        encoding: 'binary'
      });
      this.handleError(sqlite3_open(this.filename, apiTemp));
      this.db = getValue(apiTemp, 'i32');
      return binaryDb;
    }

    /* Close the database, and all associated prepared statements.
     The memory associated to the database and all associated statements
    will be freed.
     **Warning**: A statement belonging to a database that has been closed cannot
    be used anymore.
     Databases **must** be closed, when you're finished with them, or the
    memory consumption will grow forever
     */

  }, {
    key: 'close',
    value: function close() {
      var _, ref, stmt;
      ref = this.statements;
      for (_ in ref) {
        stmt = ref[_];
        stmt['free']();
      }
      this.handleError(sqlite3_close_v2(this.db));
      FS.unlink('/' + this.filename);
      return this.db = null;
    }

    /* Analyze a result code, return null if no error occured, and throw
    an error with a descriptive message otherwise
    @nodoc
    */

  }, {
    key: 'handleError',
    value: function handleError(returnCode) {
      var errmsg;
      if (returnCode === SQLite.OK) {
        return null;
      } else {
        errmsg = sqlite3_errmsg(this.db);
        throw new Error(errmsg);
      }
    }

    /* Returns the number of rows modified, inserted or deleted by the
    most recently completed INSERT, UPDATE or DELETE statement on the
    database Executing any other type of SQL statement does not modify
    the value returned by this function.
     @return [Number] the number of rows modified
    */

  }, {
    key: 'getRowsModified',
    value: function getRowsModified() {
      return sqlite3_changes(this.db);
    }

    /* Register a custom function with SQLite
    @example Register a simple function
        db.create_function("addOne", function(x) {return x+1;})
        db.exec("SELECT addOne(1)") // = 2
     @param name [String] the name of the function as referenced in SQL statements.
    @param func [Function] the actual function to be executed.
    */

  }, {
    key: 'create_function',
    value: function create_function(name, func) {
      var func_ptr, wrapped_func;
      wrapped_func = function wrapped_func(cx, argc, argv) {
        var arg, args, data_func, i, k, ref, result, value_ptr, value_type;
        // Parse the args from sqlite into JS objects
        args = [];
        for (i = k = 0, ref = argc; 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
          value_ptr = getValue(argv + 4 * i, 'i32');
          value_type = sqlite3_value_type(value_ptr);
          data_func = function () {
            switch (false) {
              case value_type !== 1:
                return sqlite3_value_int;
              case value_type !== 2:
                return sqlite3_value_double;
              case value_type !== 3:
                return sqlite3_value_text;
              case value_type !== 4:
                return function (ptr) {
                  var blob_arg, blob_ptr, j, l, ref1, size;
                  size = sqlite3_value_bytes(ptr);
                  blob_ptr = sqlite3_value_blob(ptr);
                  blob_arg = new Uint8Array(size);
                  for (j = l = 0, ref1 = size; 0 <= ref1 ? l < ref1 : l > ref1; j = 0 <= ref1 ? ++l : --l) {
                    blob_arg[j] = HEAP8[blob_ptr + j];
                  }
                  return blob_arg;
                };
              default:
                return function (ptr) {
                  return null;
                };
            }
          }();
          arg = data_func(value_ptr);
          args.push(arg);
        }
        // Invoke the user defined function with arguments from SQLite
        result = func.apply(null, args);
        // Return the result of the user defined function to SQLite
        if (!result) {
          return sqlite3_result_null(cx);
        } else {
          switch (typeof result === 'undefined' ? 'undefined' : _typeof(result)) {
            case 'number':
              return sqlite3_result_double(cx, result);
            case 'string':
              return sqlite3_result_text(cx, result, -1, -1);
          }
        }
      };
      // Generate a pointer to the wrapped, user defined function, and register with SQLite.
      func_ptr = addFunction(wrapped_func);
      this.handleError(sqlite3_create_function_v2(this.db, name, func.length, SQLite.UTF8, 0, func_ptr, 0, 0, 0));
      return this;
    }
  }]);

  return Database;
}();

/* Represents an prepared statement.

Prepared statements allow you to have a template sql string,
that you can execute multiple times with different parameters.

You can't instantiate this class directly, you have to use a [Database](Database.html)
object in order to create a statement.

**Warning**: When you close a database (using db.close()), all its statements are
closed too and become unusable.

@see Database.html#prepare-dynamic
@see https://en.wikipedia.org/wiki/Prepared_statement
 */
Statement = function () {
  // Statements can't be created by the API user, only by Database::prepare
  // @private
  // @nodoc
  function Statement(stmt1, db) {
    _classCallCheck(this, Statement);

    this.stmt = stmt1;
    this.db = db;
    this.pos = 1; // Index of the leftmost parameter is 1
    this.allocatedmem = []; // Pointers to allocated memory, that need to be freed when the statemend is destroyed
  }

  /* Bind values to the parameters, after having reseted the statement
   SQL statements can have parameters, named *'?', '?NNN', ':VVV', '@VVV', '$VVV'*,
  where NNN is a number and VVV a string.
  This function binds these parameters to the given values.
   *Warning*: ':', '@', and '$' are included in the parameters names
   ## Binding values to named parameters
  @example Bind values to named parameters
  var stmt = db.prepare("UPDATE test SET a=@newval WHERE id BETWEEN $mini AND $maxi");
  stmt.bind({$mini:10, $maxi:20, '@newval':5});
  - Create a statement that contains parameters like '$VVV', ':VVV', '@VVV'
  - Call Statement.bind with an object as parameter
   ## Binding values to parameters
  @example Bind values to anonymous parameters
  var stmt = db.prepare("UPDATE test SET a=? WHERE id BETWEEN ? AND ?");
  stmt.bind([5, 10, 20]);
  - Create a statement that contains parameters like '?', '?NNN'
  - Call Statement.bind with an array as parameter
   ## Value types
  Javascript type | SQLite type
  --- | ---
  number | REAL, INTEGER
  boolean | INTEGER
  string | TEXT
  Array, Uint8Array | BLOB
  null | NULL
  @see http://www.sqlite.org/datatype3.html
   @see http://www.sqlite.org/lang_expr.html#varparam
  @param values [Array,Object] The values to bind
  @return [Boolean] true if it worked
  @throw [String] SQLite Error
   */


  _createClass(Statement, [{
    key: 'bind',
    value: function bind(values) {
      if (!this.stmt) {
        throw "Statement closed";
      }
      this['reset']();
      if (Array.isArray(values)) {
        return this.bindFromArray(values);
      } else {
        return this.bindFromObject(values);
      }
    }

    /* Execute the statement, fetching the the next line of result,
    that can be retrieved with [Statement.get()](#get-dynamic) .
     @return [Boolean] true if a row of result available
    @throw [String] SQLite Error
    */

  }, {
    key: 'step',
    value: function step() {
      var ret;
      if (!this.stmt) {
        throw "Statement closed";
      }
      this.pos = 1;
      switch (ret = sqlite3_step(this.stmt)) {
        case SQLite.ROW:
          return true;
        case SQLite.DONE:
          return false;
        default:
          return this.db.handleError(ret);
      }
    }

    // Internal methods to retrieve data from the results of a statement that has been executed
    // @nodoc

  }, {
    key: 'getNumber',
    value: function getNumber() {
      var pos = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.pos++;

      return sqlite3_column_double(this.stmt, pos);
    }

    // @nodoc

  }, {
    key: 'getString',
    value: function getString() {
      var pos = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.pos++;

      return sqlite3_column_text(this.stmt, pos);
    }

    // @nodoc

  }, {
    key: 'getBlob',
    value: function getBlob() {
      var pos = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.pos++;

      var i, k, ptr, ref, result, size;
      size = sqlite3_column_bytes(this.stmt, pos);
      ptr = sqlite3_column_blob(this.stmt, pos);
      result = new Uint8Array(size);
      for (i = k = 0, ref = size; 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
        result[i] = HEAP8[ptr + i];
      }
      return result;
    }

    /* Get one row of results of a statement.
    If the first parameter is not provided, step must have been called before get.
    @param [Array,Object] Optional: If set, the values will be bound to the statement, and it will be executed
    @return [Array<String,Number,Uint8Array,null>] One row of result
     @example Print all the rows of the table test to the console
     var stmt = db.prepare("SELECT * FROM test");
    while (stmt.step()) console.log(stmt.get());
    */

  }, {
    key: 'get',
    value: function get(params) {
      // Get all fields
      var field, k, ref, results1;
      if (params != null) {
        this['bind'](params) && this['step']();
      }
      results1 = [];
      for (field = k = 0, ref = sqlite3_data_count(this.stmt); 0 <= ref ? k < ref : k > ref; field = 0 <= ref ? ++k : --k) {
        switch (sqlite3_column_type(this.stmt, field)) {
          case SQLite.INTEGER:
          case SQLite.FLOAT:
            results1.push(this.getNumber(field));
            break;
          case SQLite.TEXT:
            results1.push(this.getString(field));
            break;
          case SQLite.BLOB:
            results1.push(this.getBlob(field));
            break;
          default:
            results1.push(null);
        }
      }
      return results1;
    }

    /* Get the list of column names of a row of result of a statement.
    @return [Array<String>] The names of the columns
    @example
         var stmt = db.prepare("SELECT 5 AS nbr, x'616200' AS data, NULL AS nothing;");
        stmt.step(); // Execute the statement
        console.log(stmt.getColumnNames()); // Will print ['nbr','data','nothing']
    */

  }, {
    key: 'getColumnNames',
    value: function getColumnNames() {
      var i, k, ref, results1;
      results1 = [];
      for (i = k = 0, ref = sqlite3_data_count(this.stmt); 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
        results1.push(sqlite3_column_name(this.stmt, i));
      }
      return results1;
    }

    /* Get one row of result as a javascript object, associating column names with
    their value in the current row.
    @param [Array,Object] Optional: If set, the values will be bound to the statement, and it will be executed
    @return [Object] The row of result
    @see [Statement.get](#get-dynamic)
     @example
         var stmt = db.prepare("SELECT 5 AS nbr, x'616200' AS data, NULL AS nothing;");
        stmt.step(); // Execute the statement
        console.log(stmt.getAsObject()); // Will print {nbr:5, data: Uint8Array([1,2,3]), nothing:null}
    */

  }, {
    key: 'getAsObject',
    value: function getAsObject(params) {
      var i, k, len, name, names, rowObject, values;
      values = this['get'](params);
      names = this['getColumnNames']();
      rowObject = {};
      for (i = k = 0, len = names.length; k < len; i = ++k) {
        name = names[i];
        rowObject[name] = values[i];
      }
      return rowObject;
    }

    /* Shorthand for bind + step + reset
    Bind the values, execute the statement, ignoring the rows it returns, and resets it
    @param [Array,Object] Value to bind to the statement
    */

  }, {
    key: 'run',
    value: function run(values) {
      if (values != null) {
        this['bind'](values);
      }
      this['step']();
      return this['reset']();
    }

    // Internal methods to bind values to parameters
    // @private
    // @nodoc

  }, {
    key: 'bindString',
    value: function bindString(string) {
      var pos = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.pos++;

      var bytes, strptr;
      bytes = intArrayFromString(string);
      this.allocatedmem.push(strptr = allocate(bytes, 'i8', ALLOC_NORMAL));
      this.db.handleError(sqlite3_bind_text(this.stmt, pos, strptr, bytes.length - 1, 0));
      return true;
    }

    // @nodoc

  }, {
    key: 'bindBlob',
    value: function bindBlob(array) {
      var pos = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.pos++;

      var blobptr;
      this.allocatedmem.push(blobptr = allocate(array, 'i8', ALLOC_NORMAL));
      this.db.handleError(sqlite3_bind_blob(this.stmt, pos, blobptr, array.length, 0));
      return true;
    }

    // @private
    // @nodoc

  }, {
    key: 'bindNumber',
    value: function bindNumber(num) {
      var pos = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.pos++;

      var bindfunc;
      bindfunc = num === (num | 0) ? sqlite3_bind_int : sqlite3_bind_double;
      this.db.handleError(bindfunc(this.stmt, pos, num));
      return true;
    }

    // @nodoc

  }, {
    key: 'bindNull',
    value: function bindNull() {
      var pos = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.pos++;

      return sqlite3_bind_blob(this.stmt, pos, 0, 0, 0) === SQLite.OK;
    }

    // Call bindNumber or bindString appropriatly
    // @private
    // @nodoc

  }, {
    key: 'bindValue',
    value: function bindValue(val) {
      var pos = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.pos++;

      switch (typeof val === 'undefined' ? 'undefined' : _typeof(val)) {
        case "string":
          return this.bindString(val, pos);
        case "number":
        case "boolean":
          return this.bindNumber(val + 0, pos);
        case "object":
          if (val === null) {
            return this.bindNull(pos);
          } else if (val.length != null) {
            return this.bindBlob(val, pos);
          } else {
            throw 'Wrong API use : tried to bind a value of an unknown type (' + val + ').';
          }
      }
    }

    /* Bind names and values of an object to the named parameters of the statement
    @param [Object]
    @private
    @nodoc
    */

  }, {
    key: 'bindFromObject',
    value: function bindFromObject(valuesObj) {
      var name, num, value;
      for (name in valuesObj) {
        value = valuesObj[name];
        num = sqlite3_bind_parameter_index(this.stmt, name);
        if (num !== 0) {
          this.bindValue(value, num);
        }
      }
      return true;
    }

    /* Bind values to numbered parameters
    @param [Array]
    @private
    @nodoc
    */

  }, {
    key: 'bindFromArray',
    value: function bindFromArray(values) {
      var k, len, num, value;
      for (num = k = 0, len = values.length; k < len; num = ++k) {
        value = values[num];
        this.bindValue(value, num + 1);
      }
      return true;
    }

    /* Reset a statement, so that it's parameters can be bound to new values
    It also clears all previous bindings, freeing the memory used by bound parameters.
    */

  }, {
    key: 'reset',
    value: function reset() {
      this.freemem();
      return sqlite3_clear_bindings(this.stmt) === SQLite.OK && sqlite3_reset(this.stmt) === SQLite.OK;
    }

    /* Free the memory allocated during parameter binding
    */

  }, {
    key: 'freemem',
    value: function freemem() {
      var mem;
      while (mem = this.allocatedmem.pop()) {
        _free(mem);
      }
      return null;
    }

    /* Free the memory used by the statement
    @return [Boolean] true in case of success
    */

  }, {
    key: 'free',
    value: function free() {
      var res;
      this.freemem();
      res = sqlite3_finalize(this.stmt) === SQLite.OK;
      delete this.db.statements[this.stmt];
      this.stmt = NULL;
      return res;
    }
  }]);

  return Statement;
}();

Module['onRuntimeInitialized'] = function () {
  var k, len, listener;
  apiTemp = stackAlloc(4);
  sqlite3_open = Module['cwrap']('sqlite3_open', 'number', ['string', 'number']);
  sqlite3_close_v2 = Module['cwrap']('sqlite3_close_v2', 'number', ['number']);
  sqlite3_exec = Module['cwrap']('sqlite3_exec', 'number', ['number', 'string', 'number', 'number', 'number']);
  sqlite3_free = Module['cwrap']('sqlite3_free', '', ['number']);
  sqlite3_changes = Module['cwrap']('sqlite3_changes', 'number', ['number']);
  // Prepared statements
  //# prepare
  sqlite3_prepare_v2 = Module['cwrap']('sqlite3_prepare_v2', 'number', ['number', 'string', 'number', 'number', 'number']);
  // Version of sqlite3_prepare_v2 to which a pointer to a string that is already
  // in memory is passed.
  sqlite3_prepare_v2_sqlptr = Module['cwrap']('sqlite3_prepare_v2', 'number', ['number', 'number', 'number', 'number', 'number']);
  //# Bind parameters

  //int sqlite3_bind_text(sqlite3_stmt*, int, const char*, int n, void(*)(void*));
  // We declare const char* as a number, because we will manually allocate the memory and pass a pointer to the function
  sqlite3_bind_text = Module['cwrap']('sqlite3_bind_text', 'number', ['number', 'number', 'number', 'number', 'number']);
  sqlite3_bind_blob = Module['cwrap']('sqlite3_bind_blob', 'number', ['number', 'number', 'number', 'number', 'number']);
  //int sqlite3_bind_double(sqlite3_stmt*, int, double);
  sqlite3_bind_double = Module['cwrap']('sqlite3_bind_double', 'number', ['number', 'number', 'number']);
  //int sqlite3_bind_double(sqlite3_stmt*, int, int);
  sqlite3_bind_int = Module['cwrap']('sqlite3_bind_int', 'number', ['number', 'number', 'number']);
  //int sqlite3_bind_parameter_index(sqlite3_stmt*, const char *zName);
  sqlite3_bind_parameter_index = Module['cwrap']('sqlite3_bind_parameter_index', 'number', ['number', 'string']);
  //# Get values
  // int sqlite3_step(sqlite3_stmt*)
  sqlite3_step = Module['cwrap']('sqlite3_step', 'number', ['number']);
  sqlite3_errmsg = Module['cwrap']('sqlite3_errmsg', 'string', ['number']);
  // int sqlite3_data_count(sqlite3_stmt *pStmt);
  sqlite3_data_count = Module['cwrap']('sqlite3_data_count', 'number', ['number']);
  sqlite3_column_double = Module['cwrap']('sqlite3_column_double', 'number', ['number', 'number']);
  sqlite3_column_text = Module['cwrap']('sqlite3_column_text', 'string', ['number', 'number']);
  sqlite3_column_blob = Module['cwrap']('sqlite3_column_blob', 'number', ['number', 'number']);
  sqlite3_column_bytes = Module['cwrap']('sqlite3_column_bytes', 'number', ['number', 'number']);
  sqlite3_column_type = Module['cwrap']('sqlite3_column_type', 'number', ['number', 'number']);
  //const char *sqlite3_column_name(sqlite3_stmt*, int N);
  sqlite3_column_name = Module['cwrap']('sqlite3_column_name', 'string', ['number', 'number']);
  // int sqlite3_reset(sqlite3_stmt *pStmt);
  sqlite3_reset = Module['cwrap']('sqlite3_reset', 'number', ['number']);
  sqlite3_clear_bindings = Module['cwrap']('sqlite3_clear_bindings', 'number', ['number']);
  // int sqlite3_finalize(sqlite3_stmt *pStmt);
  sqlite3_finalize = Module['cwrap']('sqlite3_finalize', 'number', ['number']);
  //# Create custom functions
  sqlite3_create_function_v2 = Module['cwrap']('sqlite3_create_function_v2', 'number', ['number', 'string', 'number', 'number', 'number', 'number', 'number', 'number', 'number']);
  sqlite3_value_type = Module['cwrap']('sqlite3_value_type', 'number', ['number']);
  sqlite3_value_bytes = Module['cwrap']('sqlite3_value_bytes', 'number', ['number']);
  sqlite3_value_text = Module['cwrap']('sqlite3_value_text', 'string', ['number']);
  sqlite3_value_int = Module['cwrap']('sqlite3_value_int', 'number', ['number']);
  sqlite3_value_blob = Module['cwrap']('sqlite3_value_blob', 'number', ['number']);
  sqlite3_value_double = Module['cwrap']('sqlite3_value_double', 'number', ['number']);
  sqlite3_result_double = Module['cwrap']('sqlite3_result_double', '', ['number', 'number']);
  sqlite3_result_null = Module['cwrap']('sqlite3_result_null', '', ['number']);
  sqlite3_result_text = Module['cwrap']('sqlite3_result_text', '', ['number', 'string', 'number', 'number']);
  RegisterExtensionFunctions = Module['cwrap']('RegisterExtensionFunctions', 'number', ['number']);
  for (k = 0, len = listeners.length; k < len; k++) {
    listener = listeners[k];
    listener(Database);
  }
  return listeners = null;
};

Module['init'] = function () {
  if (listeners) {
    return new Promise(function (resolve) {
      return listeners.push(resolve);
    });
  } else {
    return Promise.resolve(Module['Database']);
  }
};



// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
var key;
for (key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

Module['arguments'] = [];
Module['thisProgram'] = './this.program';
Module['quit'] = function(status, toThrow) {
  throw toThrow;
};
Module['preRun'] = [];
Module['postRun'] = [];

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_WEB = false;
var ENVIRONMENT_IS_WORKER = false;
var ENVIRONMENT_IS_NODE = false;
var ENVIRONMENT_IS_SHELL = false;

// Three configurations we can be running in:
// 1) We could be the application main() thread running in the main JS UI thread. (ENVIRONMENT_IS_WORKER == false and ENVIRONMENT_IS_PTHREAD == false)
// 2) We could be the application main() thread proxied to worker. (with Emscripten -s PROXY_TO_WORKER=1) (ENVIRONMENT_IS_WORKER == true, ENVIRONMENT_IS_PTHREAD == false)
// 3) We could be an application pthread running in a worker. (ENVIRONMENT_IS_WORKER == true and ENVIRONMENT_IS_PTHREAD == true)

if (Module['ENVIRONMENT']) {
  if (Module['ENVIRONMENT'] === 'WEB') {
    ENVIRONMENT_IS_WEB = true;
  } else if (Module['ENVIRONMENT'] === 'WORKER') {
    ENVIRONMENT_IS_WORKER = true;
  } else if (Module['ENVIRONMENT'] === 'NODE') {
    ENVIRONMENT_IS_NODE = true;
  } else if (Module['ENVIRONMENT'] === 'SHELL') {
    ENVIRONMENT_IS_SHELL = true;
  } else {
    throw new Error('Module[\'ENVIRONMENT\'] value is not valid. must be one of: WEB|WORKER|NODE|SHELL.');
  }
} else {
  ENVIRONMENT_IS_WEB = typeof window === 'object';
  ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
  ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function' && !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_WORKER;
  ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
}


if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  var nodeFS;
  var nodePath;

  Module['read'] = function shell_read(filename, binary) {
    var ret;
      if (!nodeFS) nodeFS = require('fs');
      if (!nodePath) nodePath = require('path');
      filename = nodePath['normalize'](filename);
      ret = nodeFS['readFileSync'](filename);
    return binary ? ret : ret.toString();
  };

  Module['readBinary'] = function readBinary(filename) {
    var ret = Module['read'](filename, true);
    if (!ret.buffer) {
      ret = new Uint8Array(ret);
    }
    assert(ret.buffer);
    return ret;
  };

  if (process['argv'].length > 1) {
    Module['thisProgram'] = process['argv'][1].replace(/\\/g, '/');
  }

  Module['arguments'] = process['argv'].slice(2);

  // MODULARIZE will export the module in the proper place outside, we don't need to export here

  process['on']('uncaughtException', function(ex) {
    // suppress ExitStatus exceptions from showing an error
    if (!(ex instanceof ExitStatus)) {
      throw ex;
    }
  });
  // Currently node will swallow unhandled rejections, but this behavior is
  // deprecated, and in the future it will exit with error status.
  process['on']('unhandledRejection', function(reason, p) {
    Module['printErr']('node.js exiting due to unhandled promise rejection');
    process['exit'](1);
  });

  Module['inspect'] = function () { return '[Emscripten Module object]'; };
} else
if (ENVIRONMENT_IS_SHELL) {
  if (typeof read != 'undefined') {
    Module['read'] = function shell_read(f) {
      return read(f);
    };
  }

  Module['readBinary'] = function readBinary(f) {
    var data;
    if (typeof readbuffer === 'function') {
      return new Uint8Array(readbuffer(f));
    }
    data = read(f, 'binary');
    assert(typeof data === 'object');
    return data;
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof quit === 'function') {
    Module['quit'] = function(status, toThrow) {
      quit(status);
    }
  }
} else
if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function shell_read(url) {
      var xhr = new XMLHttpRequest();
      xhr.open('GET', url, false);
      xhr.send(null);
      return xhr.responseText;
  };

  if (ENVIRONMENT_IS_WORKER) {
    Module['readBinary'] = function readBinary(url) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, false);
        xhr.responseType = 'arraybuffer';
        xhr.send(null);
        return new Uint8Array(xhr.response);
    };
  }

  Module['readAsync'] = function readAsync(url, onload, onerror) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'arraybuffer';
    xhr.onload = function xhr_onload() {
      if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
        onload(xhr.response);
        return;
      }
      onerror();
    };
    xhr.onerror = onerror;
    xhr.send(null);
  };

  Module['setWindowTitle'] = function(title) { document.title = title };
} else
{
  throw new Error('not compiled for this environment (did you build to HTML and try to run it not on the web, or set ENVIRONMENT to something - like node - and run it someplace else - like on the web?)');
}

// console.log is checked first, as 'print' on the web will open a print dialogue
// printErr is preferable to console.warn (works better in shells)
// bind(console) is necessary to fix IE/Edge closed dev tools panel behavior.
Module['print'] = typeof console !== 'undefined' ? console.log.bind(console) : (typeof print !== 'undefined' ? print : null);
Module['printErr'] = typeof printErr !== 'undefined' ? printErr : ((typeof console !== 'undefined' && console.warn.bind(console)) || Module['print']);

// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Merge back in the overrides
for (key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}
// Free the object hierarchy contained in the overrides, this lets the GC
// reclaim data used e.g. in memoryInitializerRequest, which is a large typed array.
moduleOverrides = undefined;



// {{PREAMBLE_ADDITIONS}}

var STACK_ALIGN = 16;

// stack management, and other functionality that is provided by the compiled code,
// should not be used before it is ready
stackSave = stackRestore = stackAlloc = setTempRet0 = getTempRet0 = function() {
  abort('cannot use the stack before compiled code is ready to run, and has provided stack access');
};

function staticAlloc(size) {
  assert(!staticSealed);
  var ret = STATICTOP;
  STATICTOP = (STATICTOP + size + 15) & -16;
  return ret;
}

function dynamicAlloc(size) {
  assert(DYNAMICTOP_PTR);
  var ret = HEAP32[DYNAMICTOP_PTR>>2];
  var end = (ret + size + 15) & -16;
  HEAP32[DYNAMICTOP_PTR>>2] = end;
  if (end >= TOTAL_MEMORY) {
    var success = enlargeMemory();
    if (!success) {
      HEAP32[DYNAMICTOP_PTR>>2] = ret;
      return 0;
    }
  }
  return ret;
}

function alignMemory(size, factor) {
  if (!factor) factor = STACK_ALIGN; // stack alignment (16-byte) by default
  var ret = size = Math.ceil(size / factor) * factor;
  return ret;
}

function getNativeTypeSize(type) {
  switch (type) {
    case 'i1': case 'i8': return 1;
    case 'i16': return 2;
    case 'i32': return 4;
    case 'i64': return 8;
    case 'float': return 4;
    case 'double': return 8;
    default: {
      if (type[type.length-1] === '*') {
        return 4; // A pointer
      } else if (type[0] === 'i') {
        var bits = parseInt(type.substr(1));
        assert(bits % 8 === 0);
        return bits / 8;
      } else {
        return 0;
      }
    }
  }
}

function warnOnce(text) {
  if (!warnOnce.shown) warnOnce.shown = {};
  if (!warnOnce.shown[text]) {
    warnOnce.shown[text] = 1;
    Module.printErr(text);
  }
}

var asm2wasmImports = { // special asm2wasm imports
    "f64-rem": function(x, y) {
        return x % y;
    },
    "debugger": function() {
        debugger;
    }
};



var jsCallStartIndex = 1;
var functionPointers = new Array(64);

// 'sig' parameter is only used on LLVM wasm backend
function addFunction(func, sig) {
  if (typeof sig === 'undefined') {
    Module.printErr('warning: addFunction(): You should provide a wasm function signature string as a second argument. This is not necessary for asm.js and asm2wasm, but is required for the LLVM wasm backend, so it is recommended for full portability.');
  }
  var base = 0;
  for (var i = base; i < base + 64; i++) {
    if (!functionPointers[i]) {
      functionPointers[i] = func;
      return jsCallStartIndex + i;
    }
  }
  throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
}

function removeFunction(index) {
  functionPointers[index-jsCallStartIndex] = null;
}

var funcWrappers = {};

function getFuncWrapper(func, sig) {
  if (!func) return; // on null pointer, return undefined
  assert(sig);
  if (!funcWrappers[sig]) {
    funcWrappers[sig] = {};
  }
  var sigCache = funcWrappers[sig];
  if (!sigCache[func]) {
    // optimize away arguments usage in common cases
    if (sig.length === 1) {
      sigCache[func] = function dynCall_wrapper() {
        return dynCall(sig, func);
      };
    } else if (sig.length === 2) {
      sigCache[func] = function dynCall_wrapper(arg) {
        return dynCall(sig, func, [arg]);
      };
    } else {
      // general case
      sigCache[func] = function dynCall_wrapper() {
        return dynCall(sig, func, Array.prototype.slice.call(arguments));
      };
    }
  }
  return sigCache[func];
}


function makeBigInt(low, high, unsigned) {
  return unsigned ? ((+((low>>>0)))+((+((high>>>0)))*4294967296.0)) : ((+((low>>>0)))+((+((high|0)))*4294967296.0));
}

function dynCall(sig, ptr, args) {
  if (args && args.length) {
    assert(args.length == sig.length-1);
    assert(('dynCall_' + sig) in Module, 'bad function pointer type - no table for sig \'' + sig + '\'');
    return Module['dynCall_' + sig].apply(null, [ptr].concat(args));
  } else {
    assert(sig.length == 1);
    assert(('dynCall_' + sig) in Module, 'bad function pointer type - no table for sig \'' + sig + '\'');
    return Module['dynCall_' + sig].call(null, ptr);
  }
}


function getCompilerSetting(name) {
  throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for getCompilerSetting or emscripten_get_compiler_setting to work';
}

var Runtime = {
  // FIXME backwards compatibility layer for ports. Support some Runtime.*
  //       for now, fix it there, then remove it from here. That way we
  //       can minimize any period of breakage.
  dynCall: dynCall, // for SDL2 port
  // helpful errors
  getTempRet0: function() { abort('getTempRet0() is now a top-level function, after removing the Runtime object. Remove "Runtime."') },
  staticAlloc: function() { abort('staticAlloc() is now a top-level function, after removing the Runtime object. Remove "Runtime."') },
  stackAlloc: function() { abort('stackAlloc() is now a top-level function, after removing the Runtime object. Remove "Runtime."') },
};

// The address globals begin at. Very low in memory, for code size and optimization opportunities.
// Above 0 is static memory, starting with globals.
// Then the stack.
// Then 'dynamic' memory for sbrk.
var GLOBAL_BASE = 8;


// === Preamble library stuff ===

// Documentation for the public APIs defined in this file must be updated in:
//    site/source/docs/api_reference/preamble.js.rst
// A prebuilt local version of the documentation is available at:
//    site/build/text/docs/api_reference/preamble.js.txt
// You can also build docs locally as HTML or other formats in site/
// An online HTML version (which may be of a different version of Emscripten)
//    is up at http://kripken.github.io/emscripten-site/docs/api_reference/preamble.js.html



//========================================
// Runtime essentials
//========================================

var ABORT = 0; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

/** @type {function(*, string=)} */
function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  var func = Module['_' + ident]; // closure exported function
  assert(func, 'Cannot call unknown function ' + ident + ', make sure it is exported');
  return func;
}

var JSfuncs = {
  // Helpers for cwrap -- it can't refer to Runtime directly because it might
  // be renamed by closure, instead it calls JSfuncs['stackSave'].body to find
  // out what the minified function name is.
  'stackSave': function() {
    stackSave()
  },
  'stackRestore': function() {
    stackRestore()
  },
  // type conversion from js to c
  'arrayToC' : function(arr) {
    var ret = stackAlloc(arr.length);
    writeArrayToMemory(arr, ret);
    return ret;
  },
  'stringToC' : function(str) {
    var ret = 0;
    if (str !== null && str !== undefined && str !== 0) { // null string
      // at most 4 bytes per UTF-8 code point, +1 for the trailing '\0'
      var len = (str.length << 2) + 1;
      ret = stackAlloc(len);
      stringToUTF8(str, ret, len);
    }
    return ret;
  }
};

// For fast lookup of conversion functions
var toC = {
  'string': JSfuncs['stringToC'], 'array': JSfuncs['arrayToC']
};

// C calling interface.
function ccall (ident, returnType, argTypes, args, opts) {
  var func = getCFunc(ident);
  var cArgs = [];
  var stack = 0;
  assert(returnType !== 'array', 'Return type should not be "array".');
  if (args) {
    for (var i = 0; i < args.length; i++) {
      var converter = toC[argTypes[i]];
      if (converter) {
        if (stack === 0) stack = stackSave();
        cArgs[i] = converter(args[i]);
      } else {
        cArgs[i] = args[i];
      }
    }
  }
  var ret = func.apply(null, cArgs);
  if (returnType === 'string') ret = Pointer_stringify(ret);
  else if (returnType === 'boolean') ret = Boolean(ret);
  if (stack !== 0) {
    stackRestore(stack);
  }
  return ret;
}

function cwrap (ident, returnType, argTypes) {
  argTypes = argTypes || [];
  var cfunc = getCFunc(ident);
  // When the function takes numbers and returns a number, we can just return
  // the original function
  var numericArgs = argTypes.every(function(type){ return type === 'number'});
  var numericRet = returnType !== 'string';
  if (numericRet && numericArgs) {
    return cfunc;
  }
  return function() {
    return ccall(ident, returnType, argTypes, arguments);
  }
}

/** @type {function(number, number, string, boolean=)} */
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[((ptr)>>0)]=value; break;
      case 'i8': HEAP8[((ptr)>>0)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= 1.0 ? (tempDouble > 0.0 ? ((Math_min((+(Math_floor((tempDouble)/4294967296.0))), 4294967295.0))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/4294967296.0)))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}

/** @type {function(number, string, boolean=)} */
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[((ptr)>>0)];
      case 'i8': return HEAP8[((ptr)>>0)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for getValue: ' + type);
    }
  return null;
}

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
/** @type {function((TypedArray|Array<number>|number), string, number, number=)} */
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [typeof _malloc === 'function' ? _malloc : staticAlloc, stackAlloc, staticAlloc, dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var stop;
    ptr = ret;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)>>0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(/** @type {!Uint8Array} */ (slab), ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    assert(type, 'Must know what type to store in allocate!');

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}

// Allocate memory during any stage of startup - static memory early on, dynamic memory later, malloc when ready
function getMemory(size) {
  if (!staticSealed) return staticAlloc(size);
  if (!runtimeInitialized) return dynamicAlloc(size);
  return _malloc(size);
}

/** @type {function(number, number=)} */
function Pointer_stringify(ptr, length) {
  if (length === 0 || !ptr) return '';
  // Find the length, and check for UTF while doing so
  var hasUtf = 0;
  var t;
  var i = 0;
  while (1) {
    assert(ptr + i < TOTAL_MEMORY);
    t = HEAPU8[(((ptr)+(i))>>0)];
    hasUtf |= t;
    if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (hasUtf < 128) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }
  return UTF8ToString(ptr);
}

// Given a pointer 'ptr' to a null-terminated ASCII-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.

function AsciiToString(ptr) {
  var str = '';
  while (1) {
    var ch = HEAP8[((ptr++)>>0)];
    if (!ch) return str;
    str += String.fromCharCode(ch);
  }
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in ASCII form. The copy will require at most str.length+1 bytes of space in the HEAP.

function stringToAscii(str, outPtr) {
  return writeAsciiToMemory(str, outPtr, false);
}

// Given a pointer 'ptr' to a null-terminated UTF8-encoded string in the given array that contains uint8 values, returns
// a copy of that string as a Javascript String object.

var UTF8Decoder = typeof TextDecoder !== 'undefined' ? new TextDecoder('utf8') : undefined;
function UTF8ArrayToString(u8Array, idx) {
  var endPtr = idx;
  // TextDecoder needs to know the byte length in advance, it doesn't stop on null terminator by itself.
  // Also, use the length info to avoid running tiny strings through TextDecoder, since .subarray() allocates garbage.
  while (u8Array[endPtr]) ++endPtr;

  if (endPtr - idx > 16 && u8Array.subarray && UTF8Decoder) {
    return UTF8Decoder.decode(u8Array.subarray(idx, endPtr));
  } else {
    var u0, u1, u2, u3, u4, u5;

    var str = '';
    while (1) {
      // For UTF8 byte structure, see http://en.wikipedia.org/wiki/UTF-8#Description and https://www.ietf.org/rfc/rfc2279.txt and https://tools.ietf.org/html/rfc3629
      u0 = u8Array[idx++];
      if (!u0) return str;
      if (!(u0 & 0x80)) { str += String.fromCharCode(u0); continue; }
      u1 = u8Array[idx++] & 63;
      if ((u0 & 0xE0) == 0xC0) { str += String.fromCharCode(((u0 & 31) << 6) | u1); continue; }
      u2 = u8Array[idx++] & 63;
      if ((u0 & 0xF0) == 0xE0) {
        u0 = ((u0 & 15) << 12) | (u1 << 6) | u2;
      } else {
        u3 = u8Array[idx++] & 63;
        if ((u0 & 0xF8) == 0xF0) {
          u0 = ((u0 & 7) << 18) | (u1 << 12) | (u2 << 6) | u3;
        } else {
          u4 = u8Array[idx++] & 63;
          if ((u0 & 0xFC) == 0xF8) {
            u0 = ((u0 & 3) << 24) | (u1 << 18) | (u2 << 12) | (u3 << 6) | u4;
          } else {
            u5 = u8Array[idx++] & 63;
            u0 = ((u0 & 1) << 30) | (u1 << 24) | (u2 << 18) | (u3 << 12) | (u4 << 6) | u5;
          }
        }
      }
      if (u0 < 0x10000) {
        str += String.fromCharCode(u0);
      } else {
        var ch = u0 - 0x10000;
        str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
      }
    }
  }
}

// Given a pointer 'ptr' to a null-terminated UTF8-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.

function UTF8ToString(ptr) {
  return UTF8ArrayToString(HEAPU8,ptr);
}

// Copies the given Javascript String object 'str' to the given byte array at address 'outIdx',
// encoded in UTF8 form and null-terminated. The copy will require at most str.length*4+1 bytes of space in the HEAP.
// Use the function lengthBytesUTF8 to compute the exact number of bytes (excluding null terminator) that this function will write.
// Parameters:
//   str: the Javascript string to copy.
//   outU8Array: the array to copy to. Each index in this array is assumed to be one 8-byte element.
//   outIdx: The starting offset in the array to begin the copying.
//   maxBytesToWrite: The maximum number of bytes this function can write to the array. This count should include the null
//                    terminator, i.e. if maxBytesToWrite=1, only the null terminator will be written and nothing else.
//                    maxBytesToWrite=0 does not write any bytes to the output, not even the null terminator.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF8Array(str, outU8Array, outIdx, maxBytesToWrite) {
  if (!(maxBytesToWrite > 0)) // Parameter maxBytesToWrite is not optional. Negative values, 0, null, undefined and false each don't write out any bytes.
    return 0;

  var startIdx = outIdx;
  var endIdx = outIdx + maxBytesToWrite - 1; // -1 for string null terminator.
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! So decode UTF16->UTF32->UTF8.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    // For UTF8 byte structure, see http://en.wikipedia.org/wiki/UTF-8#Description and https://www.ietf.org/rfc/rfc2279.txt and https://tools.ietf.org/html/rfc3629
    var u = str.charCodeAt(i); // possibly a lead surrogate
    if (u >= 0xD800 && u <= 0xDFFF) u = 0x10000 + ((u & 0x3FF) << 10) | (str.charCodeAt(++i) & 0x3FF);
    if (u <= 0x7F) {
      if (outIdx >= endIdx) break;
      outU8Array[outIdx++] = u;
    } else if (u <= 0x7FF) {
      if (outIdx + 1 >= endIdx) break;
      outU8Array[outIdx++] = 0xC0 | (u >> 6);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else if (u <= 0xFFFF) {
      if (outIdx + 2 >= endIdx) break;
      outU8Array[outIdx++] = 0xE0 | (u >> 12);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else if (u <= 0x1FFFFF) {
      if (outIdx + 3 >= endIdx) break;
      outU8Array[outIdx++] = 0xF0 | (u >> 18);
      outU8Array[outIdx++] = 0x80 | ((u >> 12) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else if (u <= 0x3FFFFFF) {
      if (outIdx + 4 >= endIdx) break;
      outU8Array[outIdx++] = 0xF8 | (u >> 24);
      outU8Array[outIdx++] = 0x80 | ((u >> 18) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 12) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else {
      if (outIdx + 5 >= endIdx) break;
      outU8Array[outIdx++] = 0xFC | (u >> 30);
      outU8Array[outIdx++] = 0x80 | ((u >> 24) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 18) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 12) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    }
  }
  // Null-terminate the pointer to the buffer.
  outU8Array[outIdx] = 0;
  return outIdx - startIdx;
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF8 form. The copy will require at most str.length*4+1 bytes of space in the HEAP.
// Use the function lengthBytesUTF8 to compute the exact number of bytes (excluding null terminator) that this function will write.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF8(str, outPtr, maxBytesToWrite) {
  assert(typeof maxBytesToWrite == 'number', 'stringToUTF8(str, outPtr, maxBytesToWrite) is missing the third parameter that specifies the length of the output buffer!');
  return stringToUTF8Array(str, HEAPU8,outPtr, maxBytesToWrite);
}

// Returns the number of bytes the given Javascript string takes if encoded as a UTF8 byte array, EXCLUDING the null terminator byte.

function lengthBytesUTF8(str) {
  var len = 0;
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! So decode UTF16->UTF32->UTF8.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    var u = str.charCodeAt(i); // possibly a lead surrogate
    if (u >= 0xD800 && u <= 0xDFFF) u = 0x10000 + ((u & 0x3FF) << 10) | (str.charCodeAt(++i) & 0x3FF);
    if (u <= 0x7F) {
      ++len;
    } else if (u <= 0x7FF) {
      len += 2;
    } else if (u <= 0xFFFF) {
      len += 3;
    } else if (u <= 0x1FFFFF) {
      len += 4;
    } else if (u <= 0x3FFFFFF) {
      len += 5;
    } else {
      len += 6;
    }
  }
  return len;
}

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.

var UTF16Decoder = typeof TextDecoder !== 'undefined' ? new TextDecoder('utf-16le') : undefined;
function UTF16ToString(ptr) {
  assert(ptr % 2 == 0, 'Pointer passed to UTF16ToString must be aligned to two bytes!');
  var endPtr = ptr;
  // TextDecoder needs to know the byte length in advance, it doesn't stop on null terminator by itself.
  // Also, use the length info to avoid running tiny strings through TextDecoder, since .subarray() allocates garbage.
  var idx = endPtr >> 1;
  while (HEAP16[idx]) ++idx;
  endPtr = idx << 1;

  if (endPtr - ptr > 32 && UTF16Decoder) {
    return UTF16Decoder.decode(HEAPU8.subarray(ptr, endPtr));
  } else {
    var i = 0;

    var str = '';
    while (1) {
      var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
      if (codeUnit == 0) return str;
      ++i;
      // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
      str += String.fromCharCode(codeUnit);
    }
  }
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16 form. The copy will require at most str.length*4+2 bytes of space in the HEAP.
// Use the function lengthBytesUTF16() to compute the exact number of bytes (excluding null terminator) that this function will write.
// Parameters:
//   str: the Javascript string to copy.
//   outPtr: Byte address in Emscripten HEAP where to write the string to.
//   maxBytesToWrite: The maximum number of bytes this function can write to the array. This count should include the null
//                    terminator, i.e. if maxBytesToWrite=2, only the null terminator will be written and nothing else.
//                    maxBytesToWrite<2 does not write any bytes to the output, not even the null terminator.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF16(str, outPtr, maxBytesToWrite) {
  assert(outPtr % 2 == 0, 'Pointer passed to stringToUTF16 must be aligned to two bytes!');
  assert(typeof maxBytesToWrite == 'number', 'stringToUTF16(str, outPtr, maxBytesToWrite) is missing the third parameter that specifies the length of the output buffer!');
  // Backwards compatibility: if max bytes is not specified, assume unsafe unbounded write is allowed.
  if (maxBytesToWrite === undefined) {
    maxBytesToWrite = 0x7FFFFFFF;
  }
  if (maxBytesToWrite < 2) return 0;
  maxBytesToWrite -= 2; // Null terminator.
  var startPtr = outPtr;
  var numCharsToWrite = (maxBytesToWrite < str.length*2) ? (maxBytesToWrite / 2) : str.length;
  for (var i = 0; i < numCharsToWrite; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[((outPtr)>>1)]=codeUnit;
    outPtr += 2;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[((outPtr)>>1)]=0;
  return outPtr - startPtr;
}

// Returns the number of bytes the given Javascript string takes if encoded as a UTF16 byte array, EXCLUDING the null terminator byte.

function lengthBytesUTF16(str) {
  return str.length*2;
}

function UTF32ToString(ptr) {
  assert(ptr % 4 == 0, 'Pointer passed to UTF32ToString must be aligned to four bytes!');
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32 form. The copy will require at most str.length*4+4 bytes of space in the HEAP.
// Use the function lengthBytesUTF32() to compute the exact number of bytes (excluding null terminator) that this function will write.
// Parameters:
//   str: the Javascript string to copy.
//   outPtr: Byte address in Emscripten HEAP where to write the string to.
//   maxBytesToWrite: The maximum number of bytes this function can write to the array. This count should include the null
//                    terminator, i.e. if maxBytesToWrite=4, only the null terminator will be written and nothing else.
//                    maxBytesToWrite<4 does not write any bytes to the output, not even the null terminator.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF32(str, outPtr, maxBytesToWrite) {
  assert(outPtr % 4 == 0, 'Pointer passed to stringToUTF32 must be aligned to four bytes!');
  assert(typeof maxBytesToWrite == 'number', 'stringToUTF32(str, outPtr, maxBytesToWrite) is missing the third parameter that specifies the length of the output buffer!');
  // Backwards compatibility: if max bytes is not specified, assume unsafe unbounded write is allowed.
  if (maxBytesToWrite === undefined) {
    maxBytesToWrite = 0x7FFFFFFF;
  }
  if (maxBytesToWrite < 4) return 0;
  var startPtr = outPtr;
  var endPtr = startPtr + maxBytesToWrite - 4;
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++i);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[((outPtr)>>2)]=codeUnit;
    outPtr += 4;
    if (outPtr + 4 > endPtr) break;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[((outPtr)>>2)]=0;
  return outPtr - startPtr;
}

// Returns the number of bytes the given Javascript string takes if encoded as a UTF16 byte array, EXCLUDING the null terminator byte.

function lengthBytesUTF32(str) {
  var len = 0;
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    var codeUnit = str.charCodeAt(i);
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) ++i; // possibly a lead surrogate, so skip over the tail surrogate.
    len += 4;
  }

  return len;
}

// Allocate heap space for a JS string, and write it there.
// It is the responsibility of the caller to free() that memory.
function allocateUTF8(str) {
  var size = lengthBytesUTF8(str) + 1;
  var ret = _malloc(size);
  if (ret) stringToUTF8Array(str, HEAP8, ret, size);
  return ret;
}

// Allocate stack space for a JS string, and write it there.
function allocateUTF8OnStack(str) {
  var size = lengthBytesUTF8(str) + 1;
  var ret = stackAlloc(size);
  stringToUTF8Array(str, HEAP8, ret, size);
  return ret;
}

function demangle(func) {
  warnOnce('warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling');
  return func;
}

function demangleAll(text) {
  var regex =
    /__Z[\w\d_]+/g;
  return text.replace(regex,
    function(x) {
      var y = demangle(x);
      return x === y ? x : (x + ' [' + y + ']');
    });
}

function jsStackTrace() {
  var err = new Error();
  if (!err.stack) {
    // IE10+ special cases: It does have callstack info, but it is only populated if an Error object is thrown,
    // so try that as a special-case.
    try {
      throw new Error(0);
    } catch(e) {
      err = e;
    }
    if (!err.stack) {
      return '(no stack trace available)';
    }
  }
  return err.stack.toString();
}

function stackTrace() {
  var js = jsStackTrace();
  if (Module['extraStackTrace']) js += '\n' + Module['extraStackTrace']();
  return demangleAll(js);
}

// Memory management

var PAGE_SIZE = 16384;
var WASM_PAGE_SIZE = 65536;
var ASMJS_PAGE_SIZE = 16777216;
var MIN_TOTAL_MEMORY = 16777216;

function alignUp(x, multiple) {
  if (x % multiple > 0) {
    x += multiple - (x % multiple);
  }
  return x;
}

var HEAP,
/** @type {ArrayBuffer} */
  buffer,
/** @type {Int8Array} */
  HEAP8,
/** @type {Uint8Array} */
  HEAPU8,
/** @type {Int16Array} */
  HEAP16,
/** @type {Uint16Array} */
  HEAPU16,
/** @type {Int32Array} */
  HEAP32,
/** @type {Uint32Array} */
  HEAPU32,
/** @type {Float32Array} */
  HEAPF32,
/** @type {Float64Array} */
  HEAPF64;

function updateGlobalBuffer(buf) {
  Module['buffer'] = buffer = buf;
}

function updateGlobalBufferViews() {
  Module['HEAP8'] = HEAP8 = new Int8Array(buffer);
  Module['HEAP16'] = HEAP16 = new Int16Array(buffer);
  Module['HEAP32'] = HEAP32 = new Int32Array(buffer);
  Module['HEAPU8'] = HEAPU8 = new Uint8Array(buffer);
  Module['HEAPU16'] = HEAPU16 = new Uint16Array(buffer);
  Module['HEAPU32'] = HEAPU32 = new Uint32Array(buffer);
  Module['HEAPF32'] = HEAPF32 = new Float32Array(buffer);
  Module['HEAPF64'] = HEAPF64 = new Float64Array(buffer);
}

var STATIC_BASE, STATICTOP, staticSealed; // static area
var STACK_BASE, STACKTOP, STACK_MAX; // stack area
var DYNAMIC_BASE, DYNAMICTOP_PTR; // dynamic area handled by sbrk

  STATIC_BASE = STATICTOP = STACK_BASE = STACKTOP = STACK_MAX = DYNAMIC_BASE = DYNAMICTOP_PTR = 0;
  staticSealed = false;


// Initializes the stack cookie. Called at the startup of main and at the startup of each thread in pthreads mode.
function writeStackCookie() {
  assert((STACK_MAX & 3) == 0);
  HEAPU32[(STACK_MAX >> 2)-1] = 0x02135467;
  HEAPU32[(STACK_MAX >> 2)-2] = 0x89BACDFE;
}

function checkStackCookie() {
  if (HEAPU32[(STACK_MAX >> 2)-1] != 0x02135467 || HEAPU32[(STACK_MAX >> 2)-2] != 0x89BACDFE) {
    abort('Stack overflow! Stack cookie has been overwritten, expected hex dwords 0x89BACDFE and 0x02135467, but received 0x' + HEAPU32[(STACK_MAX >> 2)-2].toString(16) + ' ' + HEAPU32[(STACK_MAX >> 2)-1].toString(16));
  }
  // Also test the global address 0 for integrity. This check is not compatible with SAFE_SPLIT_MEMORY though, since that mode already tests all address 0 accesses on its own.
  if (HEAP32[0] !== 0x63736d65 /* 'emsc' */) throw 'Runtime error: The application has corrupted its heap memory area (address zero)!';
}

function abortStackOverflow(allocSize) {
  abort('Stack overflow! Attempted to allocate ' + allocSize + ' bytes on the stack, but stack has only ' + (STACK_MAX - stackSave() + allocSize) + ' bytes available!');
}

function abortOnCannotGrowMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ');
}


function enlargeMemory() {
  abortOnCannotGrowMemory();
}


var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216;
if (TOTAL_MEMORY < TOTAL_STACK) Module.printErr('TOTAL_MEMORY should be larger than TOTAL_STACK, was ' + TOTAL_MEMORY + '! (TOTAL_STACK=' + TOTAL_STACK + ')');

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && Int32Array.prototype.subarray !== undefined && Int32Array.prototype.set !== undefined,
       'JS engine does not provide full typed array support');



// Use a provided buffer, if there is one, or else allocate a new one
if (Module['buffer']) {
  buffer = Module['buffer'];
  assert(buffer.byteLength === TOTAL_MEMORY, 'provided buffer should be ' + TOTAL_MEMORY + ' bytes, but it is ' + buffer.byteLength);
} else {
  // Use a WebAssembly memory where available
  {
    buffer = new ArrayBuffer(TOTAL_MEMORY);
  }
  assert(buffer.byteLength === TOTAL_MEMORY);
  Module['buffer'] = buffer;
}
updateGlobalBufferViews();


function getTotalMemory() {
  return TOTAL_MEMORY;
}

// Endianness check (note: assumes compiler arch was little-endian)
  HEAP32[0] = 0x63736d65; /* 'emsc' */
HEAP16[1] = 0x6373;
if (HEAPU8[2] !== 0x73 || HEAPU8[3] !== 0x63) throw 'Runtime error: expected the system to be little-endian!';

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Module['dynCall_v'](func);
      } else {
        Module['dynCall_vi'](func, callback.arg);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the main() is called

var runtimeInitialized = false;
var runtimeExited = false;


function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  checkStackCookie();
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  checkStackCookie();
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  checkStackCookie();
  callRuntimeCallbacks(__ATEXIT__);
  runtimeExited = true;
}

function postRun() {
  checkStackCookie();
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}

// Deprecated: This function should not be called because it is unsafe and does not provide
// a maximum length limit of how many bytes it is allowed to write. Prefer calling the
// function stringToUTF8Array() instead, which takes in a maximum length that can be used
// to be secure from out of bounds writes.
/** @deprecated */
function writeStringToMemory(string, buffer, dontAddNull) {
  warnOnce('writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!');

  var /** @type {number} */ lastChar, /** @type {number} */ end;
  if (dontAddNull) {
    // stringToUTF8Array always appends null. If we don't want to do that, remember the
    // character that existed at the location where the null will be placed, and restore
    // that after the write (below).
    end = buffer + lengthBytesUTF8(string);
    lastChar = HEAP8[end];
  }
  stringToUTF8(string, buffer, Infinity);
  if (dontAddNull) HEAP8[end] = lastChar; // Restore the value under the null character.
}

function writeArrayToMemory(array, buffer) {
  assert(array.length >= 0, 'writeArrayToMemory array must have a length (should be an array or typed array)')
  HEAP8.set(array, buffer);
}

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; ++i) {
    assert(str.charCodeAt(i) === str.charCodeAt(i)&0xff);
    HEAP8[((buffer++)>>0)]=str.charCodeAt(i);
  }
  // Null-terminate the pointer to the HEAP.
  if (!dontAddNull) HEAP8[((buffer)>>0)]=0;
}

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

assert(Math['imul'] && Math['fround'] && Math['clz32'] && Math['trunc'], 'this is a legacy browser, build with LEGACY_VM_SUPPORT');

var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_round = Math.round;
var Math_min = Math.min;
var Math_max = Math.max;
var Math_clz32 = Math.clz32;
var Math_trunc = Math.trunc;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
var runDependencyTracking = {};

function getUniqueRunDependency(id) {
  var orig = id;
  while (1) {
    if (!runDependencyTracking[id]) return id;
    id = orig + Math.random();
  }
  return id;
}

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(!runDependencyTracking[id]);
    runDependencyTracking[id] = 1;
    if (runDependencyWatcher === null && typeof setInterval !== 'undefined') {
      // Check for missing dependencies every few seconds
      runDependencyWatcher = setInterval(function() {
        if (ABORT) {
          clearInterval(runDependencyWatcher);
          runDependencyWatcher = null;
          return;
        }
        var shown = false;
        for (var dep in runDependencyTracking) {
          if (!shown) {
            shown = true;
            Module.printErr('still waiting on run dependencies:');
          }
          Module.printErr('dependency: ' + dep);
        }
        if (shown) {
          Module.printErr('(end of list)');
        }
      }, 10000);
    }
  } else {
    Module.printErr('warning: run dependency added without ID');
  }
}

function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(runDependencyTracking[id]);
    delete runDependencyTracking[id];
  } else {
    Module.printErr('warning: run dependency removed without ID');
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data



var memoryInitializer = null;






// Prefix of data URIs emitted by SINGLE_FILE and related options.
var dataURIPrefix = 'data:application/octet-stream;base64,';

// Indicates whether filename is a base64 data URI.
function isDataURI(filename) {
  return String.prototype.startsWith ?
      filename.startsWith(dataURIPrefix) :
      filename.indexOf(dataURIPrefix) === 0;
}





// === Body ===

var ASM_CONSTS = [];





STATIC_BASE = GLOBAL_BASE;

STATICTOP = STATIC_BASE + 42992;
/* global initializers */  __ATINIT__.push({ func: function() { ___emscripten_environ_constructor() } });


/* memory initializer */ allocate([1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,254,255,255,127,0,0,0,0,176,4,0,0,100,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,127,163,92,0,0,3,0,0,0,159,92,0,0,3,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,250,147,0,0,0,0,176,234,37,6,91,66,0,0,0,0,0,64,143,64,0,6,0,0,1,148,0,0,0,0,0,165,91,211,252,65,0,0,0,0,0,76,237,64,0,4,0,0,8,148,0,0,0,0,0,176,80,191,158,65,0,0,0,0,64,119,75,65,0,3,0,0,246,147,0,0,0,0,0,64,139,127,84,65,0,0,0,0,112,153,148,65,1,5,0,0,235,147,0,0,0,0,0,0,16,141,5,65,0,0,0,0,217,79,227,65,2,4,0,0,241,147,0,0,0,0,0,0,128,188,204,64,0,0,0,176,196,94,29,66,126,54,0,0,1,0,1,0,65,0,0,0,131,54,0,0,1,0,1,0,66,0,0,0,136,54,0,0,1,0,1,0,67,0,0,0,141,54,0,0,2,0,1,0,68,0,0,0,146,54,0,0,2,0,1,0,68,0,0,0,152,54,0,0,1,0,1,0,69,0,0,0,158,54,0,0,1,0,1,0,70,0,0,0,164,54,0,0,1,0,1,0,71,0,0,0,170,54,0,0,2,0,1,0,72,0,0,0,181,54,0,0,1,0,1,0,73,0,0,0,189,54,0,0,1,0,1,0,74,0,0,0,197,54,0,0,1,0,1,0,75,0,0,0,201,54,0,0,1,0,1,0,76,0,0,0,205,54,0,0,1,0,1,0,77,0,0,0,209,54,0,0,1,0,1,0,78,0,0,0,213,54,0,0,1,0,1,0,79,0,0,0,218,54,0,0,1,0,1,0,80,0,0,0,223,54,0,0,1,0,1,0,81,0,0,0,228,54,0,0,1,0,1,0,82,0,0,0,233,54,0,0,1,0,1,0,83,0,0,0,236,79,0,0,1,0,1,0,84,0,0,0,237,54,0,0,1,0,1,0,85,0,0,0,243,54,0,0,2,0,1,0,86,0,0,0,249,54,0,0,1,0,1,0,87,0,0,0,254,54,0,0,1,0,1,0,88,0,0,0,3,55,0,0,1,0,1,0,89,0,0,0,10,55,0,0,1,0,1,0,90,0,0,0,15,55,0,0,1,0,1,0,91,0,0,0,21,55,0,0,0,0,1,1,92,0,0,0,24,55,0,0,2,0,1,0,93,0,0,0,34,55,0,0,2,0,1,0,94,0,0,0,34,55,0,0,3,0,1,0,94,0,0,0,44,55,0,0,2,0,1,0,95,0,0,0,52,55,0,0,2,0,1,0,96,0,0,0,61,55,0,0,1,0,1,0,97,0,0,0,69,55,0,0,1,0,1,0,98,0,0,0,76,55,0,0,2,0,1,0,99,0,0,0,81,55,0,0,2,0,1,0,100,0,0,0,86,55,0,0,2,0,1,0,101,0,0,0,91,55,0,0,2,0,1,0,102,0,0,0,101,55,0,0,1,0,0,0,103,0,0,0,65,0,0,0,107,55,0,0,1,0,0,0,103,0,0,0,66,0,0,0,224,98,0,0,1,0,0,0,104,0,0,0,67,0,0,0,116,55,0,0,1,0,0,0,104,0,0,0,68,0,0,0,123,55,0,0,1,0,0,0,104,0,0,0,69,0,0,0,138,55,0,0,1,0,0,0,104,0,0,0,70,0,0,0,0,0,0,0,128,48,0,0,128,32,14,0,128,32,200,3,0,0,0,0,128,255,255,255,0,248,255,255,0,0,255,255,3,0,0,0,52,0,0,0,0,2,0,0,0,0,0,0,48,60,0,0,160,5,0,0,65,0,0,0,65,0,0,0,65,0,0,0,66,0,0,0,65,0,0,0,105,0,0,0,66,0,0,0,65,0,0,0,67,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,68,0,0,0,69,0,0,0,69,0,0,0,70,0,0,0,3,0,0,0,52,0,0,0,0,2,0,0,0,0,0,0,53,60,0,0,164,5,0,0,65,0,0,0,65,0,0,0,65,0,0,0,66,0,0,0,65,0,0,0,105,0,0,0,66,0,0,0,65,0,0,0,67,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,68,0,0,0,69,0,0,0,69,0,0,0,70,0,0,0,3,0,0,0,52,0,0,0,0,2,0,0,0,0,0,0,63,60,0,0,168,5,0,0,65,0,0,0,65,0,0,0,65,0,0,0,66,0,0,0,65,0,0,0,105,0,0,0,66,0,0,0,65,0,0,0,67,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,68,0,0,0,69,0,0,0,69,0,0,0,70,0,0,0,3,0,0,0,52,0,0,0,0,2,0,0,0,0,0,0,76,60,0,0,160,5,0,0,65,0,0,0,65,0,0,0,65,0,0,0,66,0,0,0,65,0,0,0,105,0,0,0,66,0,0,0,65,0,0,0,67,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,68,0,0,0,69,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,1,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,70,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,71,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,67,0,0,0,71,0,0,0,79,0,0,0,68,0,0,0,68,0,0,0,123,60,0,0,72,0,0,0,0,0,0,0,86,60,0,0,68,0,0,0,0,0,0,0,128,60,0,0,80,0,0,0,0,0,0,0,135,60,0,0,81,0,0,0,0,0,0,0,142,60,0,0,82,0,0,0,0,0,0,0,147,60,0,0,83,0,0,0,0,0,0,0,153,60,0,0,84,0,0,0,0,0,0,0,163,60,0,0,73,0,0,0,0,0,0,0,169,60,0,0,74,0,0,0,0,0,0,0,174,60,0,0,0,0,0,0,0,0,0,0,180,60,0,0,0,0,0,0,0,0,0,0,188,60,0,0,75,0,0,0,0,0,0,0,194,60,0,0,0,0,0,0,0,0,0,0,201,60,0,0,0,0,0,0,0,0,0,0,210,60,0,0,85,0,0,0,0,0,0,0,217,60,0,0,0,0,0,0,0,0,0,0,227,60,0,0,69,0,0,0,0,0,0,0,234,60,0,0,86,0,0,0,0,0,0,0,248,60,0,0,87,0,0,0,0,0,0,0,254,60,0,0,70,0,0,0,0,0,0,0,4,61,0,0,76,0,0,0,0,0,0,0,11,61,0,0,65,0,0,0,0,0,0,0,19,61,0,0,65,0,0,0,0,0,0,0,24,61,0,0,88,0,0,0,0,0,0,0,31,61,0,0,0,0,0,0,0,0,0,0,38,61,0,0,66,0,0,0,0,0,0,0,50,61,0,0,77,0,0,0,0,0,0,0,59,61,0,0,89,0,0,0,0,0,0,0,65,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,182,61,0,0,191,61,0,0,200,61,0,0,42,60,0,0,3,0,0,0,71,0,0,0,66,0,0,0,67,0,0,0,70,0,0,0,74,0,0,0,75,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,71,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,67,0,0,0,71,0,0,0,79,0,0,0,68,0,0,0,68,0,0,0,3,0,0,0,72,0,0,0,66,0,0,0,67,0,0,0,70,0,0,0,74,0,0,0,75,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,71,0,0,0,66,0,0,0,67,0,0,0,69,0,0,0,67,0,0,0,71,0,0,0,79,0,0,0,68,0,0,0,68,0,0,0,0,0,0,64,1,0,0,0,0,0,0,0,73,0,0,0,72,0,0,0,78,0,0,0,66,0,0,0,74,0,0,0,79,0,0,0,106,0,0,0,65,0,0,0,67,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,75,0,0,0,96,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,76,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,107,0,0,0,0,0,0,0,234,64,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,0,0,0,107,0,0,0,0,0,0,0,234,64,0,0,0,0,0,0,1,0,1,32,0,0,0,0,0,0,0,0,108,0,0,0,0,0,0,0,249,64,0,0,0,0,0,0,1,0,1,32,0,0,0,0,0,0,0,0,109,0,0,0,0,0,0,0,19,65,0,0,0,0,0,0,1,0,1,12,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,44,65,0,0,0,0,0,0,2,0,1,12,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,53,65,0,0,0,0,0,0,1,0,1,12,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,64,65,0,0,0,0,0,0,1,0,1,8,1,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,71,65,0,0,0,0,0,0,2,0,1,8,1,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,71,65,0,0,0,0,0,0,1,0,1,8,2,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,77,65,0,0,0,0,0,0,2,0,1,8,2,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,77,65,0,0,0,0,0,0,1,0,1,8,3,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,83,65,0,0,0,0,0,0,2,0,1,8,3,0,0,0,0,0,0,0,111,0,0,0,0,0,0,0,83,65,0,0,0,0,0,0,255,0,33,8,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,88,65,0,0,0,0,0,0,0,0,33,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,65,0,0,0,0,0,0,1,0,33,16,0,0,0,0,0,0,0,0,113,0,0,0,77,0,0,0,88,65,0,0,0,0,0,0,255,0,33,8,1,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,92,65,0,0,0,0,0,0,0,0,33,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,92,65,0,0,0,0,0,0,1,0,33,16,1,0,0,0,0,0,0,0,113,0,0,0,77,0,0,0,92,65,0,0,0,0,0,0,1,0,129,8,0,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,96,65,0,0,0,0,0,0,1,0,65,8,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,103,65,0,0,0,0,0,0,2,0,1,8,0,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,110,65,0,0,0,0,0,0,255,0,1,8,0,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,116,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,118,0,0,0,0,0,0,0,123,65,0,0,0,0,0,0,255,0,1,8,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,131,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,136,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,121,0,0,0,0,0,0,0,140,65,0,0,0,0,0,0,2,0,1,8,0,0,0,0,0,0,0,0,121,0,0,0,0,0,0,0,140,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,122,0,0,0,0,0,0,0,146,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,152,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,158,65,0,0,0,0,0,0,2,0,1,10,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,162,65,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,169,65,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,126,0,0,0,0,0,0,0,176,65,0,0,0,0,0,0,2,0,33,8,0,0,0,0,0,0,0,0,127,0,0,0,0,0,0,0,187,65,0,0,0,0,0,0,0,0,1,32,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,194,65,0,0,0,0,0,0,0,0,1,32,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,209,65,0,0,0,0,0,0,2,0,1,8,0,0,0,0,0,0,0,0,129,0,0,0,0,0,0,0,226,65,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,130,0,0,0,0,0,0,0,237,65,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,131,0,0,0,0,0,0,0,243,65,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,132,0,0,0,0,0,0,0,5,66,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,133,0,0,0,0,0,0,0,13,66,0,0,0,0,0,0,3,0,1,8,0,0,0,0,0,0,0,0,134,0,0,0,0,0,0,0,27,66,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,135,0,0,0,0,0,0,0,35,66,0,0,0,0,0,0,2,0,1,8,0,0,0,0,0,0,0,0,136,0,0,0,0,0,0,0,44,66,0,0,0,0,0,0,3,0,1,8,0,0,0,0,0,0,0,0,136,0,0,0,0,0,0,0,44,66,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,137,0,0,0,78,0,0,0,51,66,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,137,0,0,0,79,0,0,0,55,66,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,137,0,0,0,80,0,0,0,61,66,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,138,0,0,0,81,0,0,0,65,66,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,138,0,0,0,81,0,0,0,65,66,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,139,0,0,0,82,0,0,0,71,66,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,0,0,0,139,0,0,0,82,0,0,0,71,66,0,0,0,0,0,0,2,0,13,8,84,66,0,0,0,0,0,0,140,0,0,0,0,0,0,0,88,66,0,0,0,0,0,0,2,0,5,8,93,66,0,0,0,0,0,0,140,0,0,0,0,0,0,0,97,66,0,0,0,0,0,0,3,0,5,8,93,66,0,0,0,0,0,0,140,0,0,0,0,0,0,0,97,66,0,0,0,0,0,0,1,0,1,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,66,0,0,0,0,0,0,0,0,1,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,66,0,0,0,0,0,0,255,0,1,10,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,102,66,0,0,0,0,0,0,138,67,0,0,151,67,0,0,0,0,0,0,167,67,0,0,192,67,0,0,206,67,0,0,225,67,0,0,250,67,0,0,8,68,0,0,45,68,0,0,57,68,0,0,72,68,0,0,105,68,0,0,123,68,0,0,148,68,0,0,177,68,0,0,0,0,0,0,194,68,0,0,9,67,0,0,222,68,0,0,240,68,0,0,2,69,0,0,0,0,0,0,36,69,0,0,0,0,0,0,57,69,0,0,83,69,0,0,134,69,0,0,142,69,0,0,147,69,0,0,152,69,0,0,157,69,0,0,163,69,0,0,165,69,0,0,186,69,0,0,97,0,0,0,79,0,0,0,70,0,0,0,65,0,0,0,80,0,0,0,69,0,0,0,98,0,0,0,80,0,0,0,99,0,0,0,100,0,0,0,71,0,0,0,72,0,0,0,81,0,0,0,82,0,0,0,101,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,105,0,0,0,106,0,0,0,65,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,85,0,0,0,84,0,0,0,85,0,0,0,73,0,0,0,74,0,0,0,65,0,0,0,66,0,0,0,70,0,0,0,86,0,0,0,87,0,0,0,115,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,75,0,0,0,92,0,0,0,93,0,0,0,83,0,0,0,84,0,0,0,94,0,0,0,116,0,0,0,66,0,0,0,0,0,0,0,85,0,0,0,95,0,0,0,67,0,0,0,68,0,0,0,96,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,76,0,0,0,77,0,0,0,86,0,0,0,66,0,0,0,120,0,0,0,97,0,0,0,67,0,0,0,65,0,0,0,141,0,0,0,142,0,0,0,68,0,0,0,143,0,0,0,86,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,69,0,0,0,87,0,0,0,88,0,0,0,72,0,0,0,71,0,0,0,98,0,0,0,65,0,0,0,65,0,0,0,99,0,0,0,89,0,0,0,121,0,0,0,90,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,65,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,122,0,0,0,91,0,0,0,78,0,0,0,79,0,0,0,112,0,0,0,80,0,0,0,92,0,0,0,113,0,0,0,114,0,0,0,67,0,0,0,72,0,0,0,73,0,0,0,67,0,0,0,74,0,0,0,115,0,0,0,69,0,0,0,116,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,117,0,0,0,75,0,0,0,118,0,0,0,90,0,0,0,91,0,0,0,119,0,0,0,92,0,0,0,120,0,0,0,123,0,0,0,121,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,124,0,0,0,72,0,0,0,122,0,0,0,125,0,0,0,93,0,0,0,126,0,0,0,123,0,0,0,76,0,0,0,124,0,0,0,77,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,127,0,0,0,128,0,0,0,66,0,0,0,94,0,0,0,129,0,0,0,81,0,0,0,130,0,0,0,144,0,0,0,128,0,0,0,71,0,0,0,95,0,0,0,96,0,0,0,0,0,0,0,129,0,0,0,130,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,131,0,0,0,132,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,134,0,0,0,135,0,0,0,136,0,0,0,133,0,0,0,100,0,0,0,78,0,0,0,134,0,0,0,79,0,0,0,82,0,0,0,137,0,0,0,68,0,0,0,65,0,0,0,138,0,0,0,80,0,0,0,135,0,0,0,139,0,0,0,101,0,0,0,66,0,0,0,65,0,0,0,65,0,0,0,136,0,0,0,140,0,0,0,93,0,0,0,102,0,0,0,81,0,0,0,141,0,0,0,73,0,0,0,82,0,0,0,103,0,0,0,142,0,0,0,143,0,0,0,83,0,0,0,144,0,0,0,145,0,0,0,69,0,0,0,70,0,0,0,83,0,0,0,73,0,0,0,137,0,0,0,145,0,0,0,146,0,0,0,138,0,0,0,40,72,0,0,45,72,0,0,52,72,0,0,55,72,0,0,58,72,0,0,61,72,0,0,64,72,0,0,67,72,0,0,75,72,0,0,84,72,0,0,90,72,0,0,95,72,0,0,1,0,0,0,147,0,0,0,84,0,0,0,85,0,0,0,104,0,0,0,139,0,0,0,140,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,105,0,0,1,0,0,0,137,83,0,0,1,0,0,0,0,0,0,0,0,0,0,0,71,0,0,0,141,0,0,0,148,0,0,0,0,0,0,0,142,0,0,0,149,0,0,0,86,0,0,0,150,0,0,0,151,0,0,0,105,0,0,0,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,52,79,0,0,63,79,0,0,67,79,0,0,72,79,0,0,77,79,0,0,85,79,0,0,96,79,0,0,99,79,0,0,103,79,0,0,107,79,0,0,112,79,0,0,117,79,0,0,122,79,0,0,63,79,0,0,67,79,0,0,122,79,0,0,63,79,0,0,67,79,0,0,128,79,0,0,133,79,0,0,138,79,0,0,142,79,0,0,67,79,0,0,146,79,0,0,153,79,0,0,160,79,0,0,142,79,0,0,67,79,0,0,168,79,0,0,67,79,0,0,173,79,0,0,67,79,0,0,142,79,0,0,67,79,0,0,181,79,0,0,142,79,0,0,184,79,0,0,90,72,0,0,190,79,0,0,193,79,0,0,203,79,0,0,213,79,0,0,184,79,0,0,25,75,0,0,219,79,0,0,226,79,0,0,231,79,0,0,236,79,0,0,240,79,0,0,253,79,0,0,5,80,0,0,14,80,0,0,21,80,0,0,0,20,0,0,8,0,0,0,36,80,0,0,1,149,0,0,0,0,0,0,48,80,0,0,2,20,0,0,0,128,0,0,64,80,0,0,3,16,49,1,0,0,0,0,52,79,0,0,4,149,0,0,0,0,0,0,77,80,0,0,5,148,0,0,0,0,0,0,89,80,0,0,6,2,0,0,0,0,0,0,109,80,0,0,2,20,0,0,0,0,32,0,125,80,0,0,2,20,0,0,16,0,0,0,146,80,0,0,7,16,32,2,0,0,0,0,161,80,0,0,8,16,0,0,0,0,0,0,177,80,0,0,2,20,0,0,128,0,0,0,191,80,0,0,0,24,0,0,15,0,0,0,204,80,0,0,10,17,26,3,0,0,0,0,218,80,0,0,11,149,0,1,0,0,0,0,237,80,0,0,2,20,0,0,0,0,8,0,0,81,0,0,2,20,0,0,0,1,0,0,23,81,0,0,12,20,0,0,0,0,0,0,32,81,0,0,13,17,42,4,0,0,0,0,50,81,0,0,14,97,34,8,0,0,0,0,67,81,0,0,2,20,0,0,0,64,0,0,80,81,0,0,0,24,0,0,0,0,0,0,95,81,0,0,2,20,0,0,4,0,0,0,113,81,0,0,2,20,0,0,8,0,0,0,123,81,0,0,2,20,0,0,0,2,0,0,148,81,0,0,16,3,0,0,0,0,0,0,167,81,0,0,17,97,12,3,0,0,0,0,178,81,0,0,18,97,21,5,0,0,0,0,189,81,0,0,17,97,15,6,1,0,0,0,201,81,0,0,19,49,0,0,0,0,0,0,217,81,0,0,20,145,0,0,0,0,0,0,230,81,0,0,21,144,0,0,0,0,0,0,249,81,0,0,2,20,0,0,2,0,0,0,12,82,0,0,23,144,0,0,0,0,0,0,25,82,0,0,24,145,0,0,0,0,0,0,40,82,0,0,25,0,0,0,0,0,0,0,50,82,0,0,27,33,0,0,0,0,0,0,59,82,0,0,24,145,0,0,0,0,0,0,70,82,0,0,28,148,0,0,0,0,0,0,80,82,0,0,2,20,0,0,0,0,16,0,91,82,0,0,19,49,0,0,0,0,0,0,103,82,0,0,2,20,0,0,0,4,0,0,120,82,0,0,2,20,0,0,0,32,0,0,139,82,0,0,2,20,0,0,0,16,0,0,165,82,0,0,0,20,0,0,1,0,0,0,180,82,0,0,30,16,0,0,0,0,0,0,194,82,0,0,2,20,0,0,64,0,0,0,213,82,0,0,31,2,0,0,0,0,0,0,227,82,0,0,32,16,0,0,0,0,0,0,243,82,0,0,33,149,0,0,0,0,0,0,255,82,0,0,34,97,1,6,0,0,0,0,10,83,0,0,35,20,0,0,0,0,0,0,21,83,0,0,36,4,0,0,0,0,0,0,42,83,0,0,37,16,0,0,0,0,0,0,50,83,0,0,0,20,0,0,6,0,0,0,63,83,0,0,38,0,0,0,0,0,0,0,82,83,0,0,39,1,46,3,0,0,0,0,97,83,0,0,2,20,0,0,1,0,0,0,2,0,1,0,0,0,0,0,0,0,0,0,146,0,0,0,0,0,0,0,236,95,0,0,0,0,0,0,2,0,1,0,0,0,0,0,0,0,0,0,147,0,0,0,0,0,0,0,226,95,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,148,0,0,0,0,0,0,0,206,95,0,0,0,0,0,0,102,84,0,0,43,96,0,0,56,96,0,0,0,0,0,0,69,96,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,149,0,0,0,0,0,0,0,205,97,0,0,0,0,0,0,3,0,1,0,0,0,0,0,0,0,0,0,150,0,0,0,0,0,0,0,32,98,0,0,0,0,0,0,48,99,0,0,1,0,0,0,51,99,0,0,2,0,0,0,54,99,0,0,6,0,0,0,58,99,0,0,128,0,0,0,0,0,0,0,0,0,0,0,33,99,0,0,0,0,2,0,40,99,0,0,0,0,4,0,0,0,0,0,0,0,0,0,228,103,0,0,230,103,0,0,96,79,0,0,181,102,0,0,1,0,0,0,186,102,0,0,1,0,0,0,252,102,0,0,2,0,0,0,5,103,0,0,3,0,0,0,14,103,0,0,2,0,0,0,22,103,0,0,3,0,0,0,30,103,0,0,0,0,0,0,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55,104,0,0,62,104,0,0,70,104,0,0,225,102,0,0,58,99,0,0,74,104,0,0,213,79,0,0,64,0,0,0,88,66,0,0,66,0,0,0,97,66,0,0,65,0,0,0,155,108,0,0,67,0,0,0,172,161,0,0,149,117,0,0,155,117,0,0,160,117,0,0,165,117,0,0,53,122,0,0,59,122,0,0,67,122,0,0,227,138,0,0,236,138,0,0,243,138,0,0,249,138,0,0,234,3,0,0,0,64,0,0,235,3,0,0,0,0,4,0,236,3,0,0,0,0,64,0,237,3,0,0,0,0,1,0,238,3,0,0,0,8,0,0,239,3,0,0,0,0,128,0,240,3,0,0,0,0,0,1,0,202,154,59,0,202,154,59,208,7,0,0,232,3,0,0,244,1,0,0,128,178,230,14,127,0,0,0,10,0,0,0,80,195,0,0,231,3,0,0,232,3,0,0,8,0,0,0,44,141,0,0,54,141,0,0,65,141,0,0,77,141,0,0,88,141,0,0,99,141,0,0,110,141,0,0,115,141,0,0,120,141,0,0,131,141,0,0,143,141,0,0,150,141,0,0,158,141,0,0,166,141,0,0,171,141,0,0,177,141,0,0,191,141,0,0,197,141,0,0,207,141,0,0,212,141,0,0,216,141,0,0,221,141,0,0,224,141,0,0,230,141,0,0,240,141,0,0,247,141,0,0,254,141,0,0,5,142,0,0,12,142,0,0,23,142,0,0,32,142,0,0,38,142,0,0,48,142,0,0,58,142,0,0,63,142,0,0,73,142,0,0,84,142,0,0,89,142,0,0,96,142,0,0,102,142,0,0,108,142,0,0,114,142,0,0,120,142,0,0,131,142,0,0,134,142,0,0,138,142,0,0,149,142,0,0,157,142,0,0,166,142,0,0,172,142,0,0,182,142,0,0,189,142,0,0,197,142,0,0,200,142,0,0,203,142,0,0,206,142,0,0,209,142,0,0,212,142,0,0,215,142,0,0,225,142,0,0,238,142,0,0,249,142,0,0,255,142,0,0,4,143,0,0,11,143,0,0,24,143,0,0,35,143,0,0,40,143,0,0,48,143,0,0,54,143,0,0,61,143,0,0,66,143,0,0,75,143,0,0,80,143,0,0,89,143,0,0,94,143,0,0,99,143,0,0,105,143,0,0,113,143,0,0,123,143,0,0,131,143,0,0,138,143,0,0,151,143,0,0,156,143,0,0,168,143,0,0,175,143,0,0,181,143,0,0,191,143,0,0,202,143,0,0,206,143,0,0,215,143,0,0,224,143,0,0,231,143,0,0,241,143,0,0,248,143,0,0,0,144,0,0,7,144,0,0,14,144,0,0,22,144,0,0,29,144,0,0,38,144,0,0,49,144,0,0,55,144,0,0,66,144,0,0,76,144,0,0,86,144,0,0,95,144,0,0,105,144,0,0,113,144,0,0,127,144,0,0,141,144,0,0,152,144,0,0,165,144,0,0,176,144,0,0,182,144,0,0,194,144,0,0,203,144,0,0,212,144,0,0,219,144,0,0,229,144,0,0,236,144,0,0,247,144,0,0,5,145,0,0,16,145,0,0,24,145,0,0,30,145,0,0,38,145,0,0,46,145,0,0,59,145,0,0,69,145,0,0,79,145,0,0,92,145,0,0,101,145,0,0,106,145,0,0,114,145,0,0,120,145,0,0,132,145,0,0,144,145,0,0,152,145,0,0,164,145,0,0,177,145,0,0,187,145,0,0,197,145,0,0,209,145,0,0,221,145,0,0,231,145,0,0,237,145,0,0,247,145,0,0,254,145,0,0,10,146,0,0,19,146,0,0,27,146,0,0,36,146,0,0,43,146,0,0,53,146,0,0,60,146,0,0,68,146,0,0,77,146,0,0,83,146,0,0,91,146,0,0,99,146,0,0,109,146,0,0,118,146,0,0,128,146,0,0,138,146,0,0,147,146,0,0,156,146,0,0,162,146,0,0,173,146,0,0,178,146,0,0,255,0,1,40,8,0,0,0,0,0,0,0,151,0,0,0,0,0,0,0,88,147,0,0,0,0,0,0,255,0,1,40,8,0,0,0,0,0,0,0,152,0,0,0,0,0,0,0,98,147,0,0,0,0,0,0,255,0,1,40,8,0,0,0,0,0,0,0,153,0,0,0,0,0,0,0,103,147,0,0,0,0,0,0,255,0,1,40,8,0,0,0,0,0,0,0,154,0,0,0,0,0,0,0,108,147,0,0,0,0,0,0,255,0,1,40,8,0,0,0,0,0,0,0,155,0,0,0,0,0,0,0,117,147,0,0,0,0,0,0,0,0,1,32,0,0,0,0,0,0,0,0,156,0,0,0,0,0,0,0,126,147,0,0,0,0,0,0,0,0,1,32,0,0,0,0,0,0,0,0,157,0,0,0,0,0,0,0,139,147,0,0,0,0,0,0,0,0,1,32,0,0,0,0,0,0,0,0,158,0,0,0,0,0,0,0,157,147,0,0,0,0,0,0,2,0,1,8,0,0,0,0,0,0,0,0,159,0,0,0,0,0,0,0,199,148,0,0,0,0,0,0,2,0,1,8,0,0,0,0,0,0,0,0,160,0,0,0,0,0,0,0,219,148,0,0,0,0,0,0,3,0,1,8,0,0,0,0,0,0,0,0,161,0,0,0,0,0,0,0,241,148,0,0,0,0,0,0,72,0,0,0,73,0,0,0,152,0,0,0,94,0,0,0,95,0,0,0,153,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,75,0,0,0,154,0,0,0,97,0,0,0,98,0,0,0,155,0,0,0,99,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,156,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,106,0,0,0,107,0,0,0,235,163,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,148,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,255,117,255,122,255,120,255,115,255,64,0,114,0,116,0,98,255,108,255,39,255,96,0,51,3,103,3,110,3,219,0,14,1,118,3,16,1,146,255,157,1,150,3,204,3,228,0,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,62,0,67,1,121,1,24,2,27,2,66,3,180,3,252,3,0,4,7,4,15,4,24,4,26,4,39,4,41,4,44,4,50,4,56,4,59,4,64,4,67,4,70,4,73,4,75,4,79,4,82,4,87,4,90,4,98,4,102,4,105,4,107,4,113,4,115,4,117,4,121,4,125,4,130,4,132,4,140,4,144,4,149,4,156,4,160,4,163,4,168,4,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,42,255,132,0,211,255,97,0,8,0,164,0,123,1,175,0,255,0,42,255,178,0,42,255,42,255,42,255,42,255,88,255,88,255,88,255,124,0,73,1,143,1,145,1,127,255,91,1,91,1,75,1,133,0,195,1,196,1,242,1,244,1,246,1,247,1,249,1,231,1,250,1,232,1,234,1,251,1,31,2,35,2,130,255,76,2,34,1,27,0,60,2,245,1,85,2,25,2,70,2,183,0,87,2,88,2,89,2,137,2,138,2,141,2,252,1,26,2,227,255,100,255,104,255,119,255,177,255,135,0,74,0,130,0,242,0,82,1,122,1,137,1,141,1,95,2,136,2,179,2,188,2,196,2,197,2,216,2,245,2,251,2,1,3,28,3,42,3,50,3,77,3,202,0,236,2,24,3,93,3,94,3,47,3,98,3,135,3,137,3,82,3,163,3,164,3,128,3,169,3,171,3,177,3,74,0,181,3,183,3,196,3,197,3,199,3,200,3,120,3,52,3,155,3,158,3,191,3,192,3,47,3,212,3,140,3,241,3,217,3,218,3,202,3,206,3,174,3,220,3,179,3,250,3,243,3,254,3,1,4,223,3,214,3,8,4,14,4,247,3,251,3,40,4,216,3,47,4,48,4,224,3,225,3,61,4,37,4,45,4,43,4,69,4,92,4,100,4,104,4,109,4,108,4,114,4,62,4,112,4,119,4,122,4,151,4,142,4,84,4,89,4,169,4,172,4,177,4,154,4,179,4,181,4,184,4,182,4,166,4,171,4,173,4,175,4,170,4,176,4,180,4,183,4,186,4,187,4,188,4,189,4,135,4,143,4,145,4,150,4,148,4,152,4,155,4,153,4,198,4,146,4,208,4,147,4,197,4,157,4,158,4,199,4,178,4,190,4,192,4,191,4,195,4,221,4,225,4,237,4,238,4,242,4,247,4,251,4,159,4,161,4,165,4,234,4,229,4,230,4,232,4,235,4,239,4,228,4,231,4,244,4,245,4,246,4,254,4,240,4,238,3,156,0,156,0,2,0,22,5,90,0,87,0,179,0,90,0,87,0,179,0,204,1,24,4,204,1,209,1,242,3,204,1,77,1,106,4,79,1,246,0,74,1,112,0,47,1,183,1,234,4,48,1,163,1,105,4,63,4,72,0,30,3,50,0,50,0,50,0,50,0,75,1,30,0,30,0,31,3,183,3,108,1,115,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,120,0,115,1,114,1,120,0,92,1,22,0,90,0,87,0,179,0,182,1,167,1,182,1,184,1,79,1,164,1,129,1,90,0,87,0,179,0,116,0,73,0,163,0,80,3,80,3,92,3,95,3,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,206,2,109,1,83,1,93,0,93,0,92,0,92,0,92,0,91,0,105,1,99,0,115,1,197,1,79,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,84,3,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,92,0,92,0,92,0,91,0,105,1,70,3,132,0,195,0,58,0,244,0,156,1,153,1,152,1,79,1,201,1,201,1,201,1,48,1,59,0,76,1,63,3,151,1,138,1,194,3,62,3,135,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,170,1,101,1,204,1,62,3,62,3,64,3,91,0,105,1,194,3,195,3,196,3,195,0,203,1,79,1,156,1,153,1,152,1,24,1,105,1,52,3,132,0,11,0,11,0,50,0,50,0,151,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,204,1,221,0,204,1,8,1,119,1,254,0,182,1,172,1,252,4,252,4,127,1,50,4,29,4,79,1,245,0,166,1,43,1,201,2,15,1,15,1,50,4,50,0,50,0,50,0,50,0,194,3,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,90,0,87,0,179,0,26,5,182,1,181,1,182,1,162,1,112,1,253,0,194,3,195,3,196,3,79,1,104,1,104,1,104,1,194,2,103,1,102,1,68,1,194,3,1,5,183,3,108,1,230,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,1,3,204,1,120,0,226,0,226,0,110,1,194,3,195,3,196,3,65,4,222,3,132,3,222,3,79,1,33,4,169,1,165,1,71,3,247,2,247,2,169,1,171,1,50,0,50,0,176,1,125,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,204,1,3,1,204,1,120,0,117,0,98,1,174,3,52,5,174,3,53,5,52,5,22,1,53,5,79,1,168,2,169,2,170,2,57,3,201,0,176,0,47,1,50,0,50,0,49,0,49,0,148,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,199,0,204,1,124,1,9,1,177,1,124,1,9,1,127,1,0,1,158,0,2,1,63,1,235,3,79,1,155,0,172,3,177,0,172,3,17,1,123,1,20,1,66,1,34,0,34,0,46,1,194,3,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,137,3,137,3,141,1,204,1,45,1,158,0,101,0,63,1,173,3,84,1,194,3,195,3,196,3,57,1,27,1,193,1,79,1,71,1,146,0,242,4,236,3,1,1,234,0,248,0,35,0,35,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,197,2,17,3,203,4,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,194,3,203,4,205,4,245,0,166,1,70,3,198,0,197,0,196,0,55,4,55,4,53,4,53,4,236,3,54,5,64,1,79,1,172,0,171,0,197,2,63,3,159,0,15,1,15,1,62,3,76,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,194,3,195,3,196,3,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,62,3,62,3,64,3,133,4,133,4,199,0,133,4,173,0,203,4,231,0,232,0,2,5,2,0,79,1,15,1,252,2,15,1,52,3,15,1,15,1,251,2,133,1,133,1,133,1,132,0,79,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,204,1,8,1,223,0,204,1,233,4,15,3,199,4,133,4,62,4,58,4,80,0,15,1,78,0,79,1,84,1,7,4,85,1,88,1,89,1,134,3,90,1,10,0,10,0,134,3,25,0,25,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,97,0,86,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,133,4,14,1,139,1,117,0,233,0,7,1,235,0,70,0,200,1,85,1,225,0,176,0,79,1,25,5,86,1,133,0,224,2,198,3,212,3,249,0,126,4,140,1,69,1,61,4,4,4,178,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,98,0,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,15,3,15,3,132,0,120,0,198,3,120,0,120,0,120,0,30,3,252,0,169,3,79,1,97,1,65,1,173,1,99,1,31,3,54,3,180,2,134,1,203,0,190,1,194,1,116,1,204,2,198,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,88,0,215,3,215,3,91,3,94,3,83,3,83,3,95,0,95,0,96,0,96,0,96,0,96,0,84,0,199,1,201,4,3,0,185,4,120,0,120,0,126,1,131,1,120,0,203,0,247,4,204,2,128,1,168,0,10,1,203,0,202,1,72,0,4,1,222,4,84,0,199,1,178,0,3,0,122,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,94,1,202,1,221,4,106,1,174,1,213,0,228,0,34,1,159,1,29,1,158,1,200,0,15,3,114,3,188,1,214,2,213,2,149,1,27,1,153,3,209,0,153,3,25,1,132,0,106,1,72,0,70,3,33,1,147,0,221,2,222,2,136,1,81,0,82,0,154,3,188,1,154,3,11,1,32,1,83,0,106,1,206,1,205,1,16,1,132,0,62,3,23,0,70,3,132,1,155,3,192,4,155,3,32,4,81,0,82,0,84,0,199,1,131,3,3,0,131,3,83,0,106,1,206,1,205,1,249,2,194,3,62,3,75,0,1,0,187,1,19,1,235,2,202,1,5,0,194,3,204,0,62,3,62,3,64,3,65,3,18,0,236,2,229,0,194,3,21,1,19,0,153,0,61,1,61,1,60,1,216,0,58,1,23,1,204,1,177,2,106,1,31,4,62,3,62,3,64,3,65,3,18,0,194,3,195,3,196,3,194,3,188,1,181,0,204,1,251,0,213,3,194,3,195,3,196,3,8,0,8,0,20,0,250,0,70,3,46,4,194,3,195,3,196,3,161,1,81,0,82,0,0,3,204,0,91,1,36,0,36,0,83,0,106,1,206,1,205,1,30,4,28,1,62,3,84,0,199,1,99,4,3,0,194,3,195,3,196,3,204,1,183,0,194,3,213,3,252,2,121,3,83,4,204,1,184,0,251,2,202,1,132,0,182,0,74,0,199,1,204,1,3,0,213,3,130,3,66,3,130,3,8,0,8,0,62,3,62,3,64,3,65,3,18,0,8,0,8,0,202,1,219,0,132,4,106,1,79,4,93,1,8,0,8,0,240,0,194,3,195,3,196,3,236,0,121,3,188,1,24,3,80,1,158,0,203,0,117,3,179,1,188,2,209,0,106,1,114,0,213,3,70,3,66,3,227,0,78,1,90,4,185,1,81,0,82,0,188,1,186,1,49,1,16,3,50,1,83,0,106,1,206,1,205,1,113,1,138,4,62,3,70,3,204,1,13,4,237,0,6,4,237,0,81,0,82,0,7,0,96,0,96,0,96,0,96,0,83,0,106,1,206,1,205,1,251,3,250,3,62,3,252,3,9,5,37,0,37,0,144,1,96,0,96,0,96,0,96,0,89,0,62,3,62,3,64,3,65,3,18,0,76,4,62,1,194,3,36,1,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,62,3,62,3,64,3,65,3,18,0,94,0,94,0,94,0,94,0,93,0,93,0,92,0,92,0,92,0,91,0,105,1,103,1,102,1,226,0,226,0,215,2,38,1,40,1,204,1,194,3,195,3,196,3,204,1,221,3,160,0,169,1,170,0,15,5,6,1,204,1,219,3,118,1,220,3,130,1,121,4,255,0,70,1,204,1,117,1,38,0,38,0,154,1,174,0,39,0,39,0,157,1,204,1,31,1,204,1,29,4,40,0,40,0,42,1,216,2,196,4,222,3,189,1,222,3,26,0,26,0,195,4,204,1,55,1,204,1,169,0,12,5,204,1,27,0,27,0,29,0,29,0,230,3,204,1,206,0,135,0,227,3,241,4,239,4,204,1,57,0,60,0,204,1,41,0,41,0,42,0,42,0,204,1,43,0,43,0,204,1,87,1,95,1,204,1,9,0,9,0,204,1,144,0,204,1,130,0,44,0,44,0,204,1,103,0,103,0,204,1,137,0,70,0,45,0,45,0,204,1,46,0,46,0,204,1,31,0,31,0,118,4,47,0,47,0,48,0,48,0,204,1,120,1,32,0,32,0,204,1,122,0,122,0,204,1,157,0,204,1,123,0,123,0,139,0,124,0,124,0,204,1,186,0,204,1,121,1,204,1,115,0,54,0,54,0,204,1,147,1,33,0,33,0,204,1,104,0,104,0,51,0,51,0,204,1,161,0,204,1,140,0,105,0,105,0,106,0,106,0,102,0,102,0,204,1,141,0,121,0,121,0,204,1,142,0,119,0,119,0,190,0,204,1,128,4,110,0,110,0,109,0,109,0,190,2,204,1,148,0,137,1,65,0,204,1,107,0,107,0,204,1,67,1,108,0,108,0,143,1,204,1,210,4,53,0,53,0,190,4,13,1,154,0,160,1,91,4,55,0,55,0,220,0,145,1,52,0,52,0,191,0,24,0,24,0,18,1,192,0,193,0,28,0,28,0,253,3,72,1,190,2,49,4,96,1,48,4,206,2,47,4,175,1,87,4,40,4,73,1,21,4,69,0,205,0,6,0,35,1,20,4,30,1,88,4,19,4,24,5,86,4,37,1,44,1,39,1,41,1,39,4,176,4,85,4,77,0,241,0,192,1,100,1,196,1,180,1,100,0,214,0,71,0,178,1,3,4,69,4,21,0,207,1,242,0,243,0,189,3,215,0,217,0,218,0,208,1,53,1,51,1,52,1,54,1,248,3,125,0,226,4,227,4,243,3,225,4,126,0,127,0,224,4,113,0,164,2,81,1,238,0,82,1,134,0,107,1,167,0,17,4,16,4,56,0,247,0,111,1,180,0,129,3,111,0,127,3,136,0,14,4,50,3,128,0,138,0,238,2,5,1,143,3,185,0,143,0,145,0,61,0,62,0,63,0,64,0,129,0,146,3,187,0,188,0,142,3,118,0,12,0,189,0,135,3,12,1,224,3,203,0,162,0,142,1,150,0,149,0,179,2,146,1,32,1,194,0,150,1,151,0,155,1,66,0,13,0,217,2,239,0,26,1,14,0,67,0,131,0,69,3,68,3,97,3,246,2,15,0,4,0,68,0,250,2,175,0,222,0,224,0,168,1,152,0,101,3,23,3,202,0,18,3,75,0,72,0,112,3,98,3,96,3,16,0,17,0,152,3,207,0,151,3,208,0,191,1,178,3,164,0,211,0,179,3,210,0,165,0,195,1,100,3,166,0,59,1,67,3,189,2,85,0,212,0,17,5,56,1,184,3,16,5,33,0,32,0,30,0,28,0,26,0,0,0,2,0,3,0,5,0,6,0,7,0,8,0,9,0,16,16,2,16,0,0,2,0,2,0,8,0,9,0,14,0,16,0,20,0,23,0,25,0,25,0,29,0,33,0,36,0,41,0,46,0,48,0,53,0,54,0,59,0,62,0,65,0,67,0,69,0,78,0,81,0,86,0,91,0,95,0,96,0,101,0,105,0,109,0,117,0,122,0,128,0,136,0,142,0,152,0,159,0,162,0,162,0,165,0,167,0,167,0,171,0,176,0,179,0,184,0,184,0,188,0,192,0,199,0,204,0,209,0,212,0,218,0,221,0,225,0,234,0,240,0,240,0,240,0,243,0,246,0,250,0,251,0,255,0,5,1,9,1,16,1,22,1,34,1,40,1,49,1,51,1,57,1,62,1,64,1,71,1,76,1,81,1,87,1,93,1,98,1,102,1,105,1,111,1,115,1,122,1,124,1,131,1,133,1,135,1,144,1,148,1,154,1,160,1,168,1,173,1,173,1,189,1,196,1,203,1,204,1,211,1,215,1,219,1,223,1,227,1,230,1,232,1,234,1,240,1,244,1,252,1,1,2,9,2,12,2,17,2,22,2,28,2,32,2,37,2,39,0,54,3,187,3,75,3,229,3,229,3,229,3,229,3,0,0,0,0,104,0,118,2,229,3,229,3,229,3,229,3,229,3,229,3,229,3,53,4,53,4,126,0,161,0,155,0,52,0,156,0,208,0,4,1,56,1,108,1,160,1,212,1,11,2,66,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,118,2,170,2,118,2,221,2,15,3,15,3,146,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,249,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,229,3,46,4,30,4,30,4,30,4,30,4,30,4,40,0,25,0,72,0,232,0,20,3,172,1,248,0,248,0,232,0,69,2,111,1,127,0,209,1,138,0,5,6,5,6,5,6,16,3,16,3,16,3,10,2,10,2,119,3,119,3,125,3,150,1,152,1,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,114,1,84,1,202,2,186,2,186,2,209,1,89,0,89,0,89,0,89,0,89,0,89,0,5,6,5,6,5,6,248,1,85,0,85,0,116,3,70,0,24,1,134,3,184,1,198,3,156,3,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,110,4,110,4,110,4,232,0,232,0,155,2,232,0,232,0,232,0,161,3,232,0,232,0,117,3,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,232,0,162,1,166,2,213,3,213,3,213,3,213,3,254,2,15,1,143,3,254,1,173,1,105,2,18,3,18,3,62,3,105,2,62,3,4,0,218,2,83,2,0,3,18,3,49,2,0,3,0,3,220,2,23,2,55,0,141,4,81,4,81,4,167,4,167,4,81,4,204,4,185,4,106,4,233,4,233,4,233,4,233,4,81,4,0,5,106,4,204,4,185,4,185,4,106,4,81,4,0,5,174,4,2,5,81,4,81,4,0,5,48,5,81,4,0,5,81,4,0,5,48,5,220,4,220,4,220,4,28,5,48,5,220,4,243,4,220,4,28,5,220,4,220,4,226,4,249,4,226,4,249,4,226,4,249,4,226,4,249,4,81,4,80,5,81,4,236,4,48,5,26,5,26,5,48,5,250,4,252,4,253,4,255,4,106,4,99,5,103,5,120,5,120,5,130,5,130,5,130,5,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,5,6,34,0,151,1,207,1,255,1,161,1,223,1,248,4,10,3,173,3,17,3,57,3,63,3,65,3,104,3,109,3,244,2,25,3,132,3,36,3,151,3,21,4,201,3,25,4,35,3,141,3,27,4,215,3,35,4,148,5,154,5,136,5,20,5,149,5,82,5,150,5,142,5,144,5,50,5,37,5,60,5,49,5,153,5,51,5,158,5,174,5,54,5,47,5,126,5,127,5,128,5,129,5,72,5,88,5,151,5,64,5,186,5,183,5,167,5,83,5,52,5,124,5,168,5,131,5,119,5,155,5,90,5,171,5,179,5,181,5,89,5,97,5,182,5,137,5,184,5,185,5,187,5,189,5,139,5,180,5,190,5,143,5,176,5,191,5,192,5,193,5,194,5,101,5,196,5,198,5,197,5,199,5,100,5,200,5,201,5,132,5,195,5,204,5,106,5,205,5,202,5,206,5,203,5,210,5,205,5,211,5,212,5,215,5,213,5,217,5,219,5,216,5,220,5,222,5,218,5,221,5,223,5,226,5,225,5,221,5,227,5,229,5,230,5,231,5,233,5,123,5,134,5,135,5,138,5,235,5,237,5,2,6,6,5,252,4,252,4,252,4,185,4,185,4,185,4,185,4,109,4,109,4,236,4,12,4,237,3,237,3,237,3,237,3,237,3,237,3,184,4,237,3,237,3,237,3,237,3,84,4,115,4,237,3,237,3,237,3,237,3,186,4,187,4,237,3,237,3,237,3,235,4,237,4,125,4,124,4,123,4,122,4,218,4,96,4,120,4,113,4,117,4,186,4,180,4,181,4,179,4,183,4,187,4,237,3,116,4,150,4,164,4,149,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,158,4,163,4,170,4,162,4,159,4,152,4,151,4,153,4,154,4,237,3,2,4,51,4,237,3,237,3,237,3,252,4,12,4,155,4,237,3,156,4,167,4,166,4,165,4,243,4,14,5,13,5,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,12,4,6,5,252,4,8,4,8,4,237,3,252,4,252,4,252,4,252,4,252,4,252,4,248,4,84,4,75,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,240,4,238,4,237,3,200,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,80,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,8,5,237,3,213,4,80,4,80,4,80,4,80,4,82,4,64,4,74,4,12,4,244,3,119,4,98,4,98,4,47,5,119,4,47,5,26,4,28,5,23,4,109,4,98,4,182,4,109,4,109,4,81,4,74,4,237,3,50,5,89,4,89,4,49,5,49,5,89,4,130,4,54,4,119,4,60,4,60,4,60,4,60,4,89,4,255,3,119,4,130,4,54,4,54,4,119,4,89,4,255,3,217,4,44,5,89,4,89,4,255,3,193,4,89,4,255,3,89,4,255,3,193,4,52,4,52,4,52,4,41,4,193,4,52,4,26,4,52,4,41,4,52,4,52,4,102,4,97,4,102,4,97,4,102,4,97,4,102,4,97,4,89,4,188,4,89,4,237,3,193,4,197,4,197,4,193,4,114,4,103,4,112,4,110,4,119,4,5,4,44,4,11,5,11,5,7,5,7,5,7,5,55,5,55,5,248,4,23,5,12,4,12,4,12,4,12,4,23,5,28,4,28,4,12,4,12,4,12,4,12,4,23,5,237,3,237,3,237,3,237,3,237,3,237,3,18,5,237,3,202,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,135,4,237,3,240,3,245,4,237,3,237,3,244,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,46,5,237,3,237,3,237,3,237,3,237,3,237,3,216,4,215,4,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,66,4,237,3,237,3,237,3,32,5,237,3,237,3,237,3,237,3,237,3,237,3,237,3,111,4,237,3,104,4,237,3,237,3,37,5,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,237,3,254,4,237,3,237,3,237,3,253,4,237,3,237,3,237,3,237,3,237,3,137,4,237,3,136,4,140,4,237,3,249,3,237,3,16,0,2,2,111,0,117,0,116,0,32,0,111,0,102,0,32,0,109,0,101,0,109,0,111,0,114,0,121,0,0,0,98,0,97,0,100,0,32,0,112,0,97,0,114,0,97,0,109,0,101,0,116,0,101,0,114,0,32,0,111,0,114,0,32,0,111,0,116,0,104,0,101,0,114,0,32,0,65,0,80,0,73,0,32,0,109,0,105,0,115,0,117,0,115,0,101,0,0,0,12,0,14,0,24,0,31,0,59,0,15,39,97,99,111,115,0,97,115,105,110,0,97,116,97,110,0,97,116,110,50,0,97,116,97,110,50,0,97,99,111,115,104,0,97,115,105,110,104,0,97,116,97,110,104,0,100,105,102,102,101,114,101,110,99,101,0,100,101,103,114,101,101,115,0,114,97,100,105,97,110,115,0,99,111,115,0,115,105,110,0,116,97,110,0,99,111,116,0,99,111,115,104,0,115,105,110,104,0,116,97,110,104,0,99,111,116,104,0,101,120,112,0,108,111,103,49,48,0,112,111,119,101,114,0,115,105,103,110,0,115,113,114,116,0,115,113,117,97,114,101,0,99,101,105,108,0,102,108,111,111,114,0,112,105,0,114,101,112,108,105,99,97,116,101,0,99,104,97,114,105,110,100,101,120,0,108,101,102,116,115,116,114,0,114,105,103,104,116,115,116,114,0,114,101,118,101,114,115,101,0,112,114,111,112,101,114,0,112,97,100,108,0,112,97,100,114,0,112,97,100,99,0,115,116,114,102,105,108,116,101,114,0,115,116,100,101,118,0,118,97,114,105,97,110,99,101,0,109,101,100,105,97,110,0,108,111,119,101,114,95,113,117,97,114,116,105,108,101,0,117,112,112,101,114,95,113,117,97,114,116,105,108,101,0,97,114,103,99,61,61,49,0,99,47,101,120,116,101,110,115,105,111,110,45,102,117,110,99,116,105,111,110,115,46,99,0,97,99,111,115,70,117,110,99,0,97,115,105,110,70,117,110,99,0,97,116,97,110,70,117,110,99,0,97,114,103,99,61,61,50,0,97,116,110,50,70,117,110,99,0,97,99,111,115,104,70,117,110,99,0,97,115,105,110,104,70,117,110,99,0,97,116,97,110,104,70,117,110,99,0,100,105,102,102,101,114,101,110,99,101,70,117,110,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,0,1,2,0,0,2,2,4,5,5,0,1,2,6,2,3,0,1,0,2,0,2,0,0,0,0,0,0,0,1,2,3,0,1,2,0,0,2,2,4,5,5,0,1,2,6,2,3,0,1,0,2,0,2,0,0,0,0,0,63,48,48,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,114,97,100,50,100,101,103,70,117,110,99,0,100,101,103,50,114,97,100,70,117,110,99,0,99,111,115,70,117,110,99,0,115,105,110,70,117,110,99,0,116,97,110,70,117,110,99,0,99,111,116,70,117,110,99,0,99,111,115,104,70,117,110,99,0,115,105,110,104,70,117,110,99,0,116,97,110,104,70,117,110,99,0,99,111,116,104,70,117,110,99,0,101,120,112,70,117,110,99,0,108,111,103,70,117,110,99,0,108,111,103,49,48,70,117,110,99,0,112,111,119,101,114,70,117,110,99,0,115,105,103,110,70,117,110,99,0,115,113,114,116,70,117,110,99,0,115,113,117,97,114,101,70,117,110,99,0,99,101,105,108,70,117,110,99,0,102,108,111,111,114,70,117,110,99,0,100,111,109,97,105,110,32,101,114,114,111,114,0,97,114,103,99,61,61,51,32,124,124,97,114,103,99,61,61,50,0,99,104,97,114,105,110,100,101,120,70,117,110,99,0,108,101,102,116,70,117,110,99,0,114,105,103,104,116,70,117,110,99,0,49,61,61,97,114,103,99,0,114,101,118,101,114,115,101,70,117,110,99,0,112,114,111,112,101,114,70,117,110,99,0,112,97,100,108,70,117,110,99,0,112,97,100,114,70,117,110,99,0,112,97,100,99,70,117,110,99,0,115,116,114,102,105,108,116,101,114,70,117,110,99,0,118,97,114,105,97,110,99,101,83,116,101,112,0,109,111,100,101,83,116,101,112,0,51,46,50,50,46,48,0,109,105,115,117,115,101,0,37,115,32,97,116,32,108,105,110,101,32,37,100,32,111,102,32,91,37,46,49,48,115,93,0,50,48,49,56,45,48,49,45,50,50,32,49,56,58,52,53,58,53,55,32,48,99,53,53,100,49,55,57,55,51,51,98,52,54,100,56,100,48,98,97,52,100,56,56,101,48,49,97,50,53,101,49,48,54,55,55,48,52,54,101,101,51,100,97,49,100,53,98,49,53,56,49,101,56,54,55,50,54,102,50,49,55,49,100,0,37,0,100,10,1,16,0,0,115,0,4,5,0,0,103,0,1,3,30,0,122,0,4,6,0,0,113,0,4,9,0,0,81,0,4,10,0,0,119,0,4,14,0,0,99,0,0,8,0,0,111,8,0,0,0,2,117,10,0,16,0,0,120,16,0,0,16,1,88,16,0,0,0,4,102,0,1,1,0,0,101,0,1,2,30,0,69,0,1,2,14,0,71,0,1,3,14,0,105,10,1,16,0,0,110,0,0,4,0,0,37,0,0,7,0,0,112,16,0,13,0,1,84,0,0,11,0,0,83,0,0,12,0,0,114,10,1,15,0,0,116,104,115,116,110,100,114,100,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,45,120,48,0,88,48,0,78,85,76,76,0,40,78,85,76,76,41,0,46,0,78,97,78,0,117,110,105,120,0,117,110,105,120,45,110,111,110,101,0,117,110,105,120,45,100,111,116,102,105,108,101,0,117,110,105,120,45,101,120,99,108,0,99,108,111,115,101,0,111,115,95,117,110,105,120,46,99,58,37,100,58,32,40,37,100,41,32,37,115,40,37,115,41,32,45,32,37,115,0,111,112,101,110,0,97,99,99,101,115,115,0,103,101,116,99,119,100,0,115,116,97,116,0,102,115,116,97,116,0,102,116,114,117,110,99,97,116,101,0,102,99,110,116,108,0,114,101,97,100,0,112,114,101,97,100,0,112,114,101,97,100,54,52,0,119,114,105,116,101,0,112,119,114,105,116,101,0,112,119,114,105,116,101,54,52,0,102,99,104,109,111,100,0,102,97,108,108,111,99,97,116,101,0,117,110,108,105,110,107,0,111,112,101,110,68,105,114,101,99,116,111,114,121,0,109,107,100,105,114,0,114,109,100,105,114,0,102,99,104,111,119,110,0,103,101,116,101,117,105,100,0,109,109,97,112,0,109,117,110,109,97,112,0,109,114,101,109,97,112,0,103,101,116,112,97,103,101,115,105,122,101,0,114,101,97,100,108,105,110,107,0,108,115,116,97,116,0,105,111,99,116,108,0,37,115,0,99,97,110,110,111,116,32,111,112,101,110,32,102,105,108,101,0,97,116,116,101,109,112,116,32,116,111,32,111,112,101,110,32,34,37,115,34,32,97,115,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,37,100,0,47,100,101,118,47,110,117,108,108,0,37,115,47,101,116,105,108,113,115,95,37,108,108,120,37,99,0,83,81,76,73,84,69,95,84,77,80,68,73,82,0,84,77,80,68,73,82,0,47,118,97,114,47,116,109,112,0,47,117,115,114,47,116,109,112,0,47,116,109,112,0,102,117,108,108,95,102,115,121,110,99,0,47,100,101,118,47,117,114,97,110,100,111,109,0,102,115,121,110,99,0,112,115,111,119,0,37,115,46,108,111,99,107,0,99,97,110,110,111,116,32,102,115,116,97,116,32,100,98,32,102,105,108,101,32,37,115,0,102,105,108,101,32,117,110,108,105,110,107,101,100,32,119,104,105,108,101,32,111,112,101,110,58,32,37,115,0,109,117,108,116,105,112,108,101,32,108,105,110,107,115,32,116,111,32,102,105,108,101,58,32,37,115,0,102,105,108,101,32,114,101,110,97,109,101,100,32,119,104,105,108,101,32,111,112,101,110,58,32,37,115,0,37,115,45,115,104,109,0,114,101,97,100,111,110,108,121,95,115,104,109,0,111,110,111,102,102,97,108,115,101,121,101,115,116,114,117,101,120,116,114,97,102,117,108,108,0,1,0,0,0,1,1,3,2,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,128,0,64,0,0,128,0,0,0,0,0,0,0,0,12,12,12,12,12,12,12,12,12,12,0,0,0,0,0,0,0,10,10,10,10,10,10,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,128,0,0,0,64,128,42,42,42,42,42,42,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,34,0,0,0,0,0,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,109,111,100,101,111,102,0,102,97,105,108,101,100,32,109,101,109,111,114,121,32,114,101,115,105,122,101,32,37,117,32,116,111,32,37,117,32,98,121,116,101,115,0,102,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,37,117,32,98,121,116,101,115,32,111,102,32,109,101,109,111,114,121,0,108,111,97,100,95,101,120,116,101,110,115,105,111,110,0,115,113,108,105,116,101,95,99,111,109,112,105,108,101,111,112,116,105,111,110,95,117,115,101,100,0,115,113,108,105,116,101,95,99,111,109,112,105,108,101,111,112,116,105,111,110,95,103,101,116,0,117,110,108,105,107,101,108,121,0,108,105,107,101,108,105,104,111,111,100,0,108,105,107,101,108,121,0,108,116,114,105,109,0,114,116,114,105,109,0,116,114,105,109,0,109,105,110,0,109,97,120,0,116,121,112,101,111,102,0,108,101,110,103,116,104,0,105,110,115,116,114,0,112,114,105,110,116,102,0,117,110,105,99,111,100,101,0,99,104,97,114,0,97,98,115,0,114,111,117,110,100,0,117,112,112,101,114,0,108,111,119,101,114,0,104,101,120,0,105,102,110,117,108,108,0,114,97,110,100,111,109,0,114,97,110,100,111,109,98,108,111,98,0,110,117,108,108,105,102,0,115,113,108,105,116,101,95,118,101,114,115,105,111,110,0,115,113,108,105,116,101,95,115,111,117,114,99,101,95,105,100,0,115,113,108,105,116,101,95,108,111,103,0,113,117,111,116,101,0,108,97,115,116,95,105,110,115,101,114,116,95,114,111,119,105,100,0,99,104,97,110,103,101,115,0,116,111,116,97,108,95,99,104,97,110,103,101,115,0,114,101,112,108,97,99,101,0,122,101,114,111,98,108,111,98,0,115,117,98,115,116,114,0,115,117,109,0,116,111,116,97,108,0,97,118,103,0,99,111,117,110,116,0,103,114,111,117,112,95,99,111,110,99,97,116,0,42,63,91,0,103,108,111,98,0,37,95,0,1,108,105,107,101,0,99,111,97,108,101,115,99,101,0,76,73,75,69,32,111,114,32,71,76,79,66,32,112,97,116,116,101,114,110,32,116,111,111,32,99,111,109,112,108,101,120,0,69,83,67,65,80,69,32,101,120,112,114,101,115,115,105,111,110,32,109,117,115,116,32,98,101,32,97,32,115,105,110,103,108,101,32,99,104,97,114,97,99,116,101,114,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,0,1,2,3,4,5,6,7,0,1,2,3,0,1,0,0,37,108,108,100,0,37,33,46,49,53,103,0,115,116,114,105,110,103,32,111,114,32,98,108,111,98,32,116,111,111,32,98,105,103,0,44,0,4,5,3,5,1,5,1,5,2,5,2,5,1,5,1,5,4,5,3,5,1,5,1,5,2,5,2,5,1,5,1,5,105,110,116,101,103,101,114,32,111,118,101,114,102,108,111,119,0,57,50,50,51,51,55,50,48,51,54,56,53,52,55,55,53,56,48,0,117,110,107,110,111,119,110,32,101,114,114,111,114,0,97,98,111,114,116,32,100,117,101,32,116,111,32,82,79,76,76,66,65,67,75,0,110,111,116,32,97,110,32,101,114,114,111,114,0,83,81,76,32,108,111,103,105,99,32,101,114,114,111,114,0,97,99,99,101,115,115,32,112,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,113,117,101,114,121,32,97,98,111,114,116,101,100,0,100,97,116,97,98,97,115,101,32,105,115,32,108,111,99,107,101,100,0,100,97,116,97,98,97,115,101,32,116,97,98,108,101,32,105,115,32,108,111,99,107,101,100,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,97,116,116,101,109,112,116,32,116,111,32,119,114,105,116,101,32,97,32,114,101,97,100,111,110,108,121,32,100,97,116,97,98,97,115,101,0,105,110,116,101,114,114,117,112,116,101,100,0,100,105,115,107,32,73,47,79,32,101,114,114,111,114,0,100,97,116,97,98,97,115,101,32,100,105,115,107,32,105,109,97,103,101,32,105,115,32,109,97,108,102,111,114,109,101,100,0,117,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,0,100,97,116,97,98,97,115,101,32,111,114,32,100,105,115,107,32,105,115,32,102,117,108,108,0,117,110,97,98,108,101,32,116,111,32,111,112,101,110,32,100,97,116,97,98,97,115,101,32,102,105,108,101,0,108,111,99,107,105,110,103,32,112,114,111,116,111,99,111,108,0,100,97,116,97,98,97,115,101,32,115,99,104,101,109,97,32,104,97,115,32,99,104,97,110,103,101,100,0,99,111,110,115,116,114,97,105,110,116,32,102,97,105,108,101,100,0,100,97,116,97,116,121,112,101,32,109,105,115,109,97,116,99,104,0,98,97,100,32,112,97,114,97,109,101,116,101,114,32,111,114,32,111,116,104,101,114,32,65,80,73,32,109,105,115,117,115,101,0,97,117,116,104,111,114,105,122,97,116,105,111,110,32,100,101,110,105,101,100,0,99,111,108,117,109,110,32,105,110,100,101,120,32,111,117,116,32,111,102,32,114,97,110,103,101,0,102,105,108,101,32,105,115,32,110,111,116,32,97,32,100,97,116,97,98,97,115,101,0,37,33,46,50,48,101,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,37,46,42,102,0,105,110,116,101,103,101,114,0,114,101,97,108,0,116,101,120,116,0,98,108,111,98,0,110,117,108,108,0,1,32,0,67,79,77,80,73,76,69,82,61,99,108,97,110,103,45,54,46,48,46,49,0,84,72,82,69,65,68,83,65,70,69,61,49,0,83,81,76,73,84,69,95,0,110,111,116,32,97,117,116,104,111,114,105,122,101,100,0,115,113,108,105,116,101,51,95,101,120,116,101,110,115,105,111,110,95,105,110,105,116,0,37,115,46,37,115,0,115,111,0,117,110,97,98,108,101,32,116,111,32,111,112,101,110,32,115,104,97,114,101,100,32,108,105,98,114,97,114,121,32,91,37,115,93,0,108,105,98,0,95,105,110,105,116,0,110,111,32,101,110,116,114,121,32,112,111,105,110,116,32,91,37,115,93,32,105,110,32,115,104,97,114,101,100,32,108,105,98,114,97,114,121,32,91,37,115,93,0,101,114,114,111,114,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,58,32,37,115,0,66,73,78,65,82,89,0,110,111,32,115,117,99,104,32,99,111,108,108,97,116,105,111,110,32,115,101,113,117,101,110,99,101,58,32,37,115,0,98,105,110,100,32,111,110,32,97,32,98,117,115,121,32,112,114,101,112,97,114,101,100,32,115,116,97,116,101,109,101,110,116,58,32,91,37,115,93,0,65,80,73,32,99,97,108,108,101,100,32,119,105,116,104,32,78,85,76,76,32,112,114,101,112,97,114,101,100,32,115,116,97,116,101,109,101,110,116,0,65,80,73,32,99,97,108,108,101,100,32,119,105,116,104,32,102,105,110,97,108,105,122,101,100,32,112,114,101,112,97,114,101,100,32,115,116,97,116,101,109,101,110,116,0,100,97,116,97,98,97,115,101,32,115,99,104,101,109,97,32,105,115,32,108,111,99,107,101,100,58,32,37,115,0,115,116,97,116,101,109,101,110,116,32,116,111,111,32,108,111,110,103,0,83,81,76,105,116,101,32,102,111,114,109,97,116,32,51,0,100,97,116,97,98,97,115,101,32,99,111,114,114,117,112,116,105,111,110,0,217,213,5,249,32,161,99,215,37,115,45,109,106,88,88,88,88,88,88,57,88,88,122,0,77,74,32,99,111,108,108,105,100,101,58,32,37,115,0,77,74,32,100,101,108,101,116,101,58,32,37,115,0,45,109,106,37,48,54,88,57,37,48,50,88,0,114,101,99,111,118,101,114,101,100,32,37,100,32,112,97,103,101,115,32,102,114,111,109,32,37,115,0,99,97,110,110,111,116,32,108,105,109,105,116,32,87,65,76,32,115,105,122,101,58,32,37,115,0,114,101,99,111,118,101,114,101,100,32,37,100,32,102,114,97,109,101,115,32,102,114,111,109,32,87,65,76,32,102,105,108,101,32,37,115,0,70,79,82,69,73,71,78,32,75,69,89,32,99,111,110,115,116,114,97,105,110,116,32,102,97,105,108,101,100,0,97,100,100,114,0,111,112,99,111,100,101,0,112,49,0,112,50,0,112,51,0,112,52,0,112,53,0,99,111,109,109,101,110,116,0,115,101,108,101,99,116,105,100,0,111,114,100,101,114,0,102,114,111,109,0,100,101,116,97,105,108,0,64,32,32,0,117,110,114,101,99,111,103,110,105,122,101,100,32,116,111,107,101,110,58,32,34,37,46,42,115,34,0,147,255,147,253,148,255,149,253,150,0,150,255,150,255,150,255,149,254,149,254,149,254,149,253,149,251,154,250,156,255,158,0,158,253,157,255,157,0,155,251,155,254,162,0,162,254,164,254,166,0,166,252,166,250,167,254,171,0,172,254,172,252,172,252,172,252,172,252,172,253,172,253,172,251,172,254,172,252,172,252,172,255,172,254,177,0,177,255,179,0,179,254,181,254,181,253,181,253,181,253,182,254,182,254,182,255,182,255,182,254,180,253,180,254,183,0,183,254,183,254,161,0,185,255,186,254,186,249,186,251,186,251,186,246,189,0,175,0,175,253,190,0,190,254,191,255,191,255,149,252,193,254,193,0,149,247,149,252,149,255,163,254,195,253,198,255,198,254,198,255,196,247,207,252,207,251,199,255,199,255,199,0,210,0,200,251,200,253,200,251,211,254,211,0,201,0,201,254,213,254,213,0,212,249,212,247,212,249,212,249,159,0,159,254,194,254,214,255,214,254,214,253,214,252,216,254,216,0,215,0,215,253,215,254,217,252,217,0,205,0,205,253,187,252,187,254,176,255,176,255,176,0,203,0,203,253,204,0,204,254,206,0,206,254,206,252,206,252,149,250,202,0,202,254,149,248,219,251,219,249,219,253,219,251,149,250,149,249,220,254,220,255,221,0,221,253,218,253,218,255,174,253,174,255,174,255,174,253,174,251,173,255,173,255,173,255,174,255,174,253,174,250,174,251,174,252,173,255,174,251,174,253,174,253,174,253,174,253,174,253,174,253,174,253,174,253,222,254,174,253,174,251,174,254,174,253,174,253,174,252,174,254,174,254,174,254,174,254,223,255,223,254,174,251,224,255,224,254,174,251,174,253,174,251,174,251,174,252,174,251,227,251,227,252,228,254,228,0,226,255,226,0,209,0,208,253,208,255,225,0,225,253,149,244,229,255,229,0,178,0,178,253,188,251,188,253,230,0,230,254,149,252,149,255,149,254,149,253,149,251,149,250,149,251,149,250,169,254,170,254,149,251,232,245,234,255,234,254,234,0,235,255,235,255,235,253,237,0,237,254,233,253,233,254,239,253,240,253,240,254,238,248,238,249,238,250,238,253,174,252,174,250,192,255,192,255,192,255,149,252,149,250,149,253,242,0,242,254,149,255,149,253,149,255,149,253,149,250,149,249,243,255,149,255,149,252,245,248,247,0,248,255,248,253,249,255,197,0,197,254,197,253,251,250,251,248,144,255,145,254,145,255,146,255,146,253,147,0,151,0,151,255,151,254,153,255,153,0,149,254,160,252,160,254,152,255,152,255,152,255,166,255,167,255,168,255,168,255,165,254,165,0,172,254,161,254,184,253,184,255,185,0,189,255,191,255,195,255,196,255,210,254,211,255,174,255,222,255,209,255,231,255,231,255,231,255,231,255,231,255,169,255,236,0,236,253,239,255,240,0,241,255,241,0,244,0,244,255,246,255,246,253,247,254,250,0,250,252,250,254,114,111,119,105,100,0,117,110,107,110,111,119,110,32,116,97,98,108,101,32,111,112,116,105,111,110,58,32,37,46,42,115,0,115,101,116,32,108,105,115,116,0,110,101,97,114,32,34,37,84,34,58,32,115,121,110,116,97,120,32,101,114,114,111,114,0,116,111,111,32,109,97,110,121,32,97,114,103,117,109,101,110,116,115,32,111,110,32,102,117,110,99,116,105,111,110,32,37,84,0,113,117,97,108,105,102,105,101,100,32,116,97,98,108,101,32,110,97,109,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,73,78,83,69,82,84,44,32,85,80,68,65,84,69,44,32,97,110,100,32,68,69,76,69,84,69,32,115,116,97,116,101,109,101,110,116,115,32,119,105,116,104,105,110,32,116,114,105,103,103,101,114,115,0,116,104,101,32,73,78,68,69,88,69,68,32,66,89,32,99,108,97,117,115,101,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,85,80,68,65,84,69,32,111,114,32,68,69,76,69,84,69,32,115,116,97,116,101,109,101,110,116,115,32,119,105,116,104,105,110,32,116,114,105,103,103,101,114,115,0,116,104,101,32,78,79,84,32,73,78,68,69,88,69,68,32,99,108,97,117,115,101,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,85,80,68,65,84,69,32,111,114,32,68,69,76,69,84,69,32,115,116,97,116,101,109,101,110,116,115,32,119,105,116,104,105,110,32,116,114,105,103,103,101,114,115,0,100,117,112,108,105,99,97,116,101,32,87,73,84,72,32,116,97,98,108,101,32,110,97,109,101,58,32,37,115,0,97,117,116,104,111,114,105,122,101,114,32,109,97,108,102,117,110,99,116,105,111,110,0,67,82,69,65,84,69,32,86,73,82,84,85,65,76,32,84,65,66,76,69,32,37,84,0,85,80,68,65,84,69,32,37,81,46,37,115,32,83,69,84,32,116,121,112,101,61,39,116,97,98,108,101,39,44,32,110,97,109,101,61,37,81,44,32,116,98,108,95,110,97,109,101,61,37,81,44,32,114,111,111,116,112,97,103,101,61,48,44,32,115,113,108,61,37,81,32,87,72,69,82,69,32,114,111,119,105,100,61,35,37,100,0,115,113,108,105,116,101,95,109,97,115,116,101,114,0,110,97,109,101,61,39,37,113,39,32,65,78,68,32,116,121,112,101,61,39,116,97,98,108,101,39,0,118,105,114,116,117,97,108,32,116,97,98,108,101,115,32,109,97,121,32,110,111,116,32,98,101,32,97,108,116,101,114,101,100,0,67,97,110,110,111,116,32,97,100,100,32,97,32,99,111,108,117,109,110,32,116,111,32,97,32,118,105,101,119,0,115,113,108,105,116,101,95,97,108,116,101,114,116,97,98,95,37,115,0,117,110,97,98,108,101,32,116,111,32,111,112,101,110,32,97,32,116,101,109,112,111,114,97,114,121,32,100,97,116,97,98,97,115,101,32,102,105,108,101,32,102,111,114,32,115,116,111,114,105,110,103,32,116,101,109,112,111,114,97,114,121,32,116,97,98,108,101,115,0,58,109,101,109,111,114,121,58,0,45,106,111,117,114,110,97,108,0,0,45,119,97,108,0,0,110,111,108,111,99,107,0,105,109,109,117,116,97,98,108,101,0,115,113,108,105,116,101,95,0,116,97,98,108,101,32,37,115,32,109,97,121,32,110,111,116,32,98,101,32,97,108,116,101,114,101,100,0,110,111,32,115,117,99,104,32,116,97,98,108,101,0,110,111,32,115,117,99,104,32,118,105,101,119,0,112,114,97,103,109,97,95,0,37,115,58,32,37,115,46,37,115,0,37,115,58,32,37,115,0,118,116,97,98,108,101,32,99,111,110,115,116,114,117,99,116,111,114,32,99,97,108,108,101,100,32,114,101,99,117,114,115,105,118,101,108,121,58,32,37,115,0,118,116,97,98,108,101,32,99,111,110,115,116,114,117,99,116,111,114,32,102,97,105,108,101,100,58,32,37,115,0,118,116,97,98,108,101,32,99,111,110,115,116,114,117,99,116,111,114,32,100,105,100,32,110,111,116,32,100,101,99,108,97,114,101,32,115,99,104,101,109,97,58,32,37,115,0,104,105,100,100,101,110,0,80,82,65,71,77,65,32,0,37,81,46,0,61,37,81,0,67,82,69,65,84,69,32,84,65,66,76,69,32,120,0,37,99,34,37,115,34,0,40,34,37,115,34,0,44,97,114,103,32,72,73,68,68,69,78,0,44,115,99,104,101,109,97,32,72,73,68,68,69,78,0,41,0,99,97,99,104,101,95,115,105,122,101,0,99,105,100,0,110,97,109,101,0,116,121,112,101,0,110,111,116,110,117,108,108,0,100,102,108,116,95,118,97,108,117,101,0,112,107,0,116,98,108,0,105,100,120,0,119,100,116,104,0,104,103,104,116,0,102,108,103,115,0,115,101,113,110,111,0,100,101,115,99,0,99,111,108,108,0,107,101,121,0,115,101,113,0,117,110,105,113,117,101,0,111,114,105,103,105,110,0,112,97,114,116,105,97,108,0,102,105,108,101,0,98,117,105,108,116,105,110,0,105,100,0,116,97,98,108,101,0,116,111,0,111,110,95,117,112,100,97,116,101,0,111,110,95,100,101,108,101,116,101,0,109,97,116,99,104,0,112,97,114,101,110,116,0,102,107,105,100,0,98,117,115,121,0,108,111,103,0,99,104,101,99,107,112,111,105,110,116,101,100,0,116,105,109,101,111,117,116,0,100,97,116,97,98,97,115,101,0,115,116,97,116,117,115,0,97,112,112,108,105,99,97,116,105,111,110,95,105,100,0,97,117,116,111,95,118,97,99,117,117,109,0,97,117,116,111,109,97,116,105,99,95,105,110,100,101,120,0,98,117,115,121,95,116,105,109,101,111,117,116,0,99,97,99,104,101,95,115,112,105,108,108,0,99,97,115,101,95,115,101,110,115,105,116,105,118,101,95,108,105,107,101,0,99,101,108,108,95,115,105,122,101,95,99,104,101,99,107,0,99,104,101,99,107,112,111,105,110,116,95,102,117,108,108,102,115,121,110,99,0,99,111,108,108,97,116,105,111,110,95,108,105,115,116,0,99,111,109,112,105,108,101,95,111,112,116,105,111,110,115,0,99,111,117,110,116,95,99,104,97,110,103,101,115,0,100,97,116,97,95,118,101,114,115,105,111,110,0,100,97,116,97,98,97,115,101,95,108,105,115,116,0,100,101,102,97,117,108,116,95,99,97,99,104,101,95,115,105,122,101,0,100,101,102,101,114,95,102,111,114,101,105,103,110,95,107,101,121,115,0,101,109,112,116,121,95,114,101,115,117,108,116,95,99,97,108,108,98,97,99,107,115,0,101,110,99,111,100,105,110,103,0,102,111,114,101,105,103,110,95,107,101,121,95,99,104,101,99,107,0,102,111,114,101,105,103,110,95,107,101,121,95,108,105,115,116,0,102,111,114,101,105,103,110,95,107,101,121,115,0,102,114,101,101,108,105,115,116,95,99,111,117,110,116,0,102,117,108,108,95,99,111,108,117,109,110,95,110,97,109,101,115,0,102,117,108,108,102,115,121,110,99,0,105,103,110,111,114,101,95,99,104,101,99,107,95,99,111,110,115,116,114,97,105,110,116,115,0,105,110,99,114,101,109,101,110,116,97,108,95,118,97,99,117,117,109,0,105,110,100,101,120,95,105,110,102,111,0,105,110,100,101,120,95,108,105,115,116,0,105,110,100,101,120,95,120,105,110,102,111,0,105,110,116,101,103,114,105,116,121,95,99,104,101,99,107,0,106,111,117,114,110,97,108,95,109,111,100,101,0,106,111,117,114,110,97,108,95,115,105,122,101,95,108,105,109,105,116,0,108,101,103,97,99,121,95,102,105,108,101,95,102,111,114,109,97,116,0,108,111,99,107,105,110,103,95,109,111,100,101,0,109,97,120,95,112,97,103,101,95,99,111,117,110,116,0,109,109,97,112,95,115,105,122,101,0,111,112,116,105,109,105,122,101,0,112,97,103,101,95,99,111,117,110,116,0,112,97,103,101,95,115,105,122,101,0,113,117,101,114,121,95,111,110,108,121,0,113,117,105,99,107,95,99,104,101,99,107,0,114,101,97,100,95,117,110,99,111,109,109,105,116,116,101,100,0,114,101,99,117,114,115,105,118,101,95,116,114,105,103,103,101,114,115,0,114,101,118,101,114,115,101,95,117,110,111,114,100,101,114,101,100,95,115,101,108,101,99,116,115,0,115,99,104,101,109,97,95,118,101,114,115,105,111,110,0,115,101,99,117,114,101,95,100,101,108,101,116,101,0,115,104,111,114,116,95,99,111,108,117,109,110,95,110,97,109,101,115,0,115,104,114,105,110,107,95,109,101,109,111,114,121,0,115,111,102,116,95,104,101,97,112,95,108,105,109,105,116,0,115,121,110,99,104,114,111,110,111,117,115,0,116,97,98,108,101,95,105,110,102,111,0,116,101,109,112,95,115,116,111,114,101,0,116,101,109,112,95,115,116,111,114,101,95,100,105,114,101,99,116,111,114,121,0,116,104,114,101,97,100,115,0,117,115,101,114,95,118,101,114,115,105,111,110,0,119,97,108,95,97,117,116,111,99,104,101,99,107,112,111,105,110,116,0,119,97,108,95,99,104,101,99,107,112,111,105,110,116,0,119,114,105,116,97,98,108,101,95,115,99,104,101,109,97,0,109,97,105,110,0,115,113,108,105,116,101,95,116,101,109,112,95,109,97,115,116,101,114,0,49,0,67,82,69,65,84,69,32,84,65,66,76,69,32,120,40,116,121,112,101,32,116,101,120,116,44,110,97,109,101,32,116,101,120,116,44,116,98,108,95,110,97,109,101,32,116,101,120,116,44,114,111,111,116,112,97,103,101,32,105,110,116,44,115,113,108,32,116,101,120,116,41,0,97,116,116,97,99,104,101,100,32,100,97,116,97,98,97,115,101,115,32,109,117,115,116,32,117,115,101,32,116,104,101,32,115,97,109,101,32,116,101,120,116,32,101,110,99,111,100,105,110,103,32,97,115,32,109,97,105,110,32,100,97,116,97,98,97,115,101,0,117,110,115,117,112,112,111,114,116,101,100,32,102,105,108,101,32,102,111,114,109,97,116,0,83,69,76,69,67,84,32,110,97,109,101,44,32,114,111,111,116,112,97,103,101,44,32,115,113,108,32,70,82,79,77,32,34,37,119,34,46,37,115,32,79,82,68,69,82,32,66,89,32,114,111,119,105,100,0,115,113,108,105,116,101,95,115,116,97,116,49,0,83,69,76,69,67,84,32,116,98,108,44,105,100,120,44,115,116,97,116,32,70,82,79,77,32,37,81,46,115,113,108,105,116,101,95,115,116,97,116,49,0,117,110,111,114,100,101,114,101,100,42,0,115,122,61,91,48,45,57,93,42,0,110,111,115,107,105,112,115,99,97,110,42,0,99,114,101,97,116,101,32,0,105,110,118,97,108,105,100,32,114,111,111,116,112,97,103,101,0,63,0,109,97,108,102,111,114,109,101,100,32,100,97,116,97,98,97,115,101,32,115,99,104,101,109,97,32,40,37,115,41,0,37,122,32,45,32,37,115,0,67,97,110,110,111,116,32,97,100,100,32,97,32,80,82,73,77,65,82,89,32,75,69,89,32,99,111,108,117,109,110,0,67,97,110,110,111,116,32,97,100,100,32,97,32,85,78,73,81,85,69,32,99,111,108,117,109,110,0,67,97,110,110,111,116,32,97,100,100,32,97,32,82,69,70,69,82,69,78,67,69,83,32,99,111,108,117,109,110,32,119,105,116,104,32,110,111,110,45,78,85,76,76,32,100,101,102,97,117,108,116,32,118,97,108,117,101,0,67,97,110,110,111,116,32,97,100,100,32,97,32,78,79,84,32,78,85,76,76,32,99,111,108,117,109,110,32,119,105,116,104,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,78,85,76,76,0,67,97,110,110,111,116,32,97,100,100,32,97,32,99,111,108,117,109,110,32,119,105,116,104,32,110,111,110,45,99,111,110,115,116,97,110,116,32,100,101,102,97,117,108,116,0,85,80,68,65,84,69,32,34,37,119,34,46,37,115,32,83,69,84,32,115,113,108,32,61,32,115,117,98,115,116,114,40,115,113,108,44,49,44,37,100,41,32,124,124,32,39,44,32,39,32,124,124,32,37,81,32,124,124,32,115,117,98,115,116,114,40,115,113,108,44,37,100,41,32,87,72,69,82,69,32,116,121,112,101,32,61,32,39,116,97,98,108,101,39,32,65,78,68,32,110,97,109,101,32,61,32,37,81,0,116,98,108,95,110,97,109,101,61,37,81,0,116,121,112,101,61,39,116,114,105,103,103,101,114,39,32,65,78,68,32,40,37,115,41,0,110,97,109,101,61,37,81,0,37,115,32,79,82,32,110,97,109,101,61,37,81,0,45,0,37,115,37,115,0,116,104,101,114,101,32,105,115,32,97,108,114,101,97,100,121,32,97,110,111,116,104,101,114,32,116,97,98,108,101,32,111,114,32,105,110,100,101,120,32,119,105,116,104,32,116,104,105,115,32,110,97,109,101,58,32,37,115,0,118,105,101,119,32,37,115,32,109,97,121,32,110,111,116,32,98,101,32,97,108,116,101,114,101,100,0,85,80,68,65,84,69,32,34,37,119,34,46,37,115,32,83,69,84,32,115,113,108,32,61,32,115,113,108,105,116,101,95,114,101,110,97,109,101,95,112,97,114,101,110,116,40,115,113,108,44,32,37,81,44,32,37,81,41,32,87,72,69,82,69,32,37,115,59,0,85,80,68,65,84,69,32,37,81,46,37,115,32,83,69,84,32,115,113,108,32,61,32,67,65,83,69,32,87,72,69,78,32,116,121,112,101,32,61,32,39,116,114,105,103,103,101,114,39,32,84,72,69,78,32,115,113,108,105,116,101,95,114,101,110,97,109,101,95,116,114,105,103,103,101,114,40,115,113,108,44,32,37,81,41,69,76,83,69,32,115,113,108,105,116,101,95,114,101,110,97,109,101,95,116,97,98,108,101,40,115,113,108,44,32,37,81,41,32,69,78,68,44,32,116,98,108,95,110,97,109,101,32,61,32,37,81,44,32,110,97,109,101,32,61,32,67,65,83,69,32,87,72,69,78,32,116,121,112,101,61,39,116,97,98,108,101,39,32,84,72,69,78,32,37,81,32,87,72,69,78,32,110,97,109,101,32,76,73,75,69,32,39,115,113,108,105,116,101,95,97,117,116,111,105,110,100,101,120,37,37,39,32,65,78,68,32,116,121,112,101,61,39,105,110,100,101,120,39,32,84,72,69,78,32,39,115,113,108,105,116,101,95,97,117,116,111,105,110,100,101,120,95,39,32,124,124,32,37,81,32,124,124,32,115,117,98,115,116,114,40,110,97,109,101,44,37,100,43,49,56,41,32,69,76,83,69,32,110,97,109,101,32,69,78,68,32,87,72,69,82,69,32,116,98,108,95,110,97,109,101,61,37,81,32,67,79,76,76,65,84,69,32,110,111,99,97,115,101,32,65,78,68,32,40,116,121,112,101,61,39,116,97,98,108,101,39,32,79,82,32,116,121,112,101,61,39,105,110,100,101,120,39,32,79,82,32,116,121,112,101,61,39,116,114,105,103,103,101,114,39,41,59,0,115,113,108,105,116,101,95,115,101,113,117,101,110,99,101,0,85,80,68,65,84,69,32,34,37,119,34,46,115,113,108,105,116,101,95,115,101,113,117,101,110,99,101,32,115,101,116,32,110,97,109,101,32,61,32,37,81,32,87,72,69,82,69,32,110,97,109,101,32,61,32,37,81,0,85,80,68,65,84,69,32,115,113,108,105,116,101,95,116,101,109,112,95,109,97,115,116,101,114,32,83,69,84,32,115,113,108,32,61,32,115,113,108,105,116,101,95,114,101,110,97,109,101,95,116,114,105,103,103,101,114,40,115,113,108,44,32,37,81,41,44,32,116,98,108,95,110,97,109,101,32,61,32,37,81,32,87,72,69,82,69,32,37,115,59,0,118,105,101,119,32,37,115,32,105,115,32,99,105,114,99,117,108,97,114,108,121,32,100,101,102,105,110,101,100,0,73,78,84,69,71,69,82,0,99,111,108,117,109,110,37,100,0,37,46,42,122,58,37,117,0,97,32,71,82,79,85,80,32,66,89,32,99,108,97,117,115,101,32,105,115,32,114,101,113,117,105,114,101,100,32,98,101,102,111,114,101,32,72,65,86,73,78,71,0,79,82,68,69,82,0,71,82,79,85,80,0,97,103,103,114,101,103,97,116,101,32,102,117,110,99,116,105,111,110,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,116,104,101,32,71,82,79,85,80,32,66,89,32,99,108,97,117,115,101,0,116,111,111,32,109,97,110,121,32,116,101,114,109,115,32,105,110,32,79,82,68,69,82,32,66,89,32,99,108,97,117,115,101,0,37,114,32,79,82,68,69,82,32,66,89,32,116,101,114,109,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,97,110,121,32,99,111,108,117,109,110,32,105,110,32,116,104,101,32,114,101,115,117,108,116,32,115,101,116,0,37,114,32,37,115,32,66,89,32,116,101,114,109,32,111,117,116,32,111,102,32,114,97,110,103,101,32,45,32,115,104,111,117,108,100,32,98,101,32,98,101,116,119,101,101,110,32,49,32,97,110,100,32,37,100,0,97,108,108,32,86,65,76,85,69,83,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,116,101,114,109,115,0,83,69,76,69,67,84,115,32,116,111,32,116,104,101,32,108,101,102,116,32,97,110,100,32,114,105,103,104,116,32,111,102,32,37,115,32,100,111,32,110,111,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,114,101,115,117,108,116,32,99,111,108,117,109,110,115,0,73,78,84,69,82,83,69,67,84,0,69,88,67,69,80,84,0,85,78,73,79,78,0,85,78,73,79,78,32,65,76,76,0,116,111,111,32,109,97,110,121,32,116,101,114,109,115,32,105,110,32,37,115,32,66,89,32,99,108,97,117,115,101,0,69,120,112,114,101,115,115,105,111,110,32,116,114,101,101,32,105,115,32,116,111,111,32,108,97,114,103,101,32,40,109,97,120,105,109,117,109,32,100,101,112,116,104,32,37,100,41,0,116,104,101,32,34,46,34,32,111,112,101,114,97,116,111,114,0,115,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,108,105,107,101,108,105,104,111,111,100,40,41,32,109,117,115,116,32,98,101,32,97,32,99,111,110,115,116,97,110,116,32,98,101,116,119,101,101,110,32,48,46,48,32,97,110,100,32,49,46,48,0,110,111,116,32,97,117,116,104,111,114,105,122,101,100,32,116,111,32,117,115,101,32,102,117,110,99,116,105,111,110,58,32,37,115,0,110,111,110,45,100,101,116,101,114,109,105,110,105,115,116,105,99,32,102,117,110,99,116,105,111,110,115,0,109,105,115,117,115,101,32,111,102,32,97,103,103,114,101,103,97,116,101,32,102,117,110,99,116,105,111,110,32,37,46,42,115,40,41,0,110,111,32,115,117,99,104,32,102,117,110,99,116,105,111,110,58,32,37,46,42,115,0,119,114,111,110,103,32,110,117,109,98,101,114,32,111,102,32,97,114,103,117,109,101,110,116,115,32,116,111,32,102,117,110,99,116,105,111,110,32,37,46,42,115,40,41,0,115,117,98,113,117,101,114,105,101,115,0,112,97,114,97,109,101,116,101,114,115,0,114,111,119,32,118,97,108,117,101,32,109,105,115,117,115,101,100,0,110,101,119,0,111,108,100,0,109,105,115,117,115,101,32,111,102,32,97,108,105,97,115,101,100,32,97,103,103,114,101,103,97,116,101,32,37,115,0,110,111,32,115,117,99,104,32,99,111,108,117,109,110,0,97,109,98,105,103,117,111,117,115,32,99,111,108,117,109,110,32,110,97,109,101,0,37,115,58,32,37,115,46,37,115,46,37,115,0,82,79,87,73,68,0,37,115,46,37,122,0,97,99,99,101,115,115,32,116,111,32,37,122,32,105,115,32,112,114,111,104,105,98,105,116,101,100,0,95,82,79,87,73,68,95,0,79,73,68,0,112,97,114,116,105,97,108,32,105,110,100,101,120,32,87,72,69,82,69,32,99,108,97,117,115,101,115,0,67,72,69,67,75,32,99,111,110,115,116,114,97,105,110,116,115,0,105,110,100,101,120,32,101,120,112,114,101,115,115,105,111,110,115,0,37,115,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,37,115,0,115,117,98,113,117,101,114,121,95,37,112,0,116,111,111,32,109,97,110,121,32,114,101,102,101,114,101,110,99,101,115,32,116,111,32,34,37,115,34,58,32,109,97,120,32,54,53,53,51,53,0,42,0,37,115,46,37,115,46,37,115,0,110,111,32,115,117,99,104,32,116,97,98,108,101,58,32,37,115,0,110,111,32,116,97,98,108,101,115,32,115,112,101,99,105,102,105,101,100,0,116,111,111,32,109,97,110,121,32,99,111,108,117,109,110,115,32,105,110,32,114,101,115,117,108,116,32,115,101,116,0,97,32,78,65,84,85,82,65,76,32,106,111,105,110,32,109,97,121,32,110,111,116,32,104,97,118,101,32,97,110,32,79,78,32,111,114,32,85,83,73,78,71,32,99,108,97,117,115,101,0,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,79,78,32,97,110,100,32,85,83,73,78,71,32,99,108,97,117,115,101,115,32,105,110,32,116,104,101,32,115,97,109,101,32,106,111,105,110,0,99,97,110,110,111,116,32,106,111,105,110,32,117,115,105,110,103,32,99,111,108,117,109,110,32,37,115,32,45,32,99,111,108,117,109,110,32,110,111,116,32,112,114,101,115,101,110,116,32,105,110,32,98,111,116,104,32,116,97,98,108,101,115,0,110,111,32,115,117,99,104,32,105,110,100,101,120,58,32,37,115,0,39,37,115,39,32,105,115,32,110,111,116,32,97,32,102,117,110,99,116,105,111,110,0,109,117,108,116,105,112,108,101,32,114,101,102,101,114,101,110,99,101,115,32,116,111,32,114,101,99,117,114,115,105,118,101,32,116,97,98,108,101,58,32,37,115,0,99,105,114,99,117,108,97,114,32,114,101,102,101,114,101,110,99,101,58,32,37,115,0,116,97,98,108,101,32,37,115,32,104,97,115,32,37,100,32,118,97,108,117,101,115,32,102,111,114,32,37,100,32,99,111,108,117,109,110,115,0,114,101,99,117,114,115,105,118,101,32,114,101,102,101,114,101,110,99,101,32,105,110,32,97,32,115,117,98,113,117,101,114,121,58,32,37,115,0,109,117,108,116,105,112,108,101,32,114,101,99,117,114,115,105,118,101,32,114,101,102,101,114,101,110,99,101,115,58,32,37,115,0,110,111,32,115,117,99,104,32,109,111,100,117,108,101,58,32,37,115,0,111,98,106,101,99,116,32,110,97,109,101,32,114,101,115,101,114,118,101,100,32,102,111,114,32,105,110,116,101,114,110,97,108,32,117,115,101,58,32,37,115,0,115,113,108,105,116,101,95,37,0,66,66,66,0,115,116,97,116,95,103,101,116,0,37,108,108,117,0,32,37,108,108,117,0,115,116,97,116,95,112,117,115,104,0,115,116,97,116,95,105,110,105,116,0,67,82,69,65,84,69,32,84,65,66,76,69,32,37,81,46,37,115,40,37,115,41,0,68,69,76,69,84,69,32,70,82,79,77,32,37,81,46,37,115,32,87,72,69,82,69,32,37,115,61,37,81,0,116,98,108,44,105,100,120,44,115,116,97,116,0,115,113,108,105,116,101,95,115,116,97,116,51,0,115,113,108,105,116,101,95,115,116,97,116,52,0,99,111,114,114,117,112,116,32,100,97,116,97,98,97,115,101,0,117,110,107,110,111,119,110,32,100,97,116,97,98,97,115,101,32,37,84,0,117,110,97,98,108,101,32,116,111,32,105,100,101,110,116,105,102,121,32,116,104,101,32,111,98,106,101,99,116,32,116,111,32,98,101,32,114,101,105,110,100,101,120,101,100,0,105,110,100,101,120,32,39,37,113,39,0,44,32,0,109,105,115,117,115,101,32,111,102,32,97,103,103,114,101,103,97,116,101,58,32,37,115,40,41,0,117,110,107,110,111,119,110,32,102,117,110,99,116,105,111,110,58,32,37,115,40,41,0,37,100,32,99,111,108,117,109,110,115,32,97,115,115,105,103,110,101,100,32,37,100,32,118,97,108,117,101,115,0,82,65,73,83,69,40,41,32,109,97,121,32,111,110,108,121,32,98,101,32,117,115,101,100,32,119,105,116,104,105,110,32,97,32,116,114,105,103,103,101,114,45,112,114,111,103,114,97,109,0,85,83,73,78,71,32,73,78,68,69,88,32,37,115,32,70,79,82,32,73,78,45,79,80,69,82,65,84,79,82,0,67,79,82,82,69,76,65,84,69,68,32,0,76,73,83,84,0,83,67,65,76,65,82,0,69,88,69,67,85,84,69,32,37,115,37,115,32,83,85,66,81,85,69,82,89,32,37,100,0,115,117,98,45,115,101,108,101,99,116,32,114,101,116,117,114,110,115,32,37,100,32,99,111,108,117,109,110,115,32,45,32,101,120,112,101,99,116,101,100,32,37,100,0,48,120,0,104,101,120,32,108,105,116,101,114,97,108,32,116,111,111,32,98,105,103,58,32,37,115,37,115,0,115,113,108,105,116,101,95,100,101,116,97,99,104,0,110,111,32,115,117,99,104,32,100,97,116,97,98,97,115,101,58,32,37,115,0,99,97,110,110,111,116,32,100,101,116,97,99,104,32,100,97,116,97,98,97,115,101,32,37,115,0,100,97,116,97,98,97,115,101,32,37,115,32,105,115,32,108,111,99,107,101,100,0,115,113,108,105,116,101,95,97,116,116,97,99,104,0,116,111,111,32,109,97,110,121,32,97,116,116,97,99,104,101,100,32,100,97,116,97,98,97,115,101,115,32,45,32,109,97,120,32,37,100,0,100,97,116,97,98,97,115,101,32,37,115,32,105,115,32,97,108,114,101,97,100,121,32,105,110,32,117,115,101,0,100,97,116,97,98,97,115,101,32,105,115,32,97,108,114,101,97,100,121,32,97,116,116,97,99,104,101,100,0,117,110,97,98,108,101,32,116,111,32,111,112,101,110,32,100,97,116,97,98,97,115,101,58,32,37,115,0,102,105,108,101,58,0,108,111,99,97,108,104,111,115,116,0,105,110,118,97,108,105,100,32,117,114,105,32,97,117,116,104,111,114,105,116,121,58,32,37,46,42,115,0,118,102,115,0,99,97,99,104,101,0,109,111,100,101,0,110,111,32,115,117,99,104,32,37,115,32,109,111,100,101,58,32,37,115,0,37,115,32,109,111,100,101,32,110,111,116,32,97,108,108,111,119,101,100,58,32,37,115,0,110,111,32,115,117,99,104,32,118,102,115,58,32,37,115,0,115,104,97,114,101,100,0,112,114,105,118,97,116,101,0,114,111,0,114,119,0,114,119,99,0,109,101,109,111,114,121,0,110,111,32,115,117,99,104,32,116,114,105,103,103,101,114,58,32,37,83,0,68,69,76,69,84,69,32,70,82,79,77,32,37,81,46,37,115,32,87,72,69,82,69,32,110,97,109,101,61,37,81,32,65,78,68,32,116,121,112,101,61,39,116,114,105,103,103,101,114,39,0,116,101,109,112,111,114,97,114,121,32,116,114,105,103,103,101,114,32,109,97,121,32,110,111,116,32,104,97,118,101,32,113,117,97,108,105,102,105,101,100,32,110,97,109,101,0,116,114,105,103,103,101,114,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,116,114,105,103,103,101,114,115,32,111,110,32,118,105,114,116,117,97,108,32,116,97,98,108,101,115,0,116,114,105,103,103,101,114,32,37,84,32,97,108,114,101,97,100,121,32,101,120,105,115,116,115,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,116,114,105,103,103,101,114,32,111,110,32,115,121,115,116,101,109,32,116,97,98,108,101,0,66,69,70,79,82,69,0,65,70,84,69,82,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,37,115,32,116,114,105,103,103,101,114,32,111,110,32,118,105,101,119,58,32,37,83,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,73,78,83,84,69,65,68,32,79,70,32,116,114,105,103,103,101,114,32,111,110,32,116,97,98,108,101,58,32,37,83,0,37,115,32,37,84,32,99,97,110,110,111,116,32,114,101,102,101,114,101,110,99,101,32,111,98,106,101,99,116,115,32,105,110,32,100,97,116,97,98,97,115,101,32,37,115,0,37,115,32,99,97,110,110,111,116,32,117,115,101,32,118,97,114,105,97,98,108,101,115,0,73,78,83,69,82,84,32,73,78,84,79,32,37,81,46,37,115,32,86,65,76,85,69,83,40,39,116,114,105,103,103,101,114,39,44,37,81,44,37,81,44,48,44,39,67,82,69,65,84,69,32,84,82,73,71,71,69,82,32,37,113,39,41,0,116,121,112,101,61,39,116,114,105,103,103,101,114,39,32,65,78,68,32,110,97,109,101,61,39,37,113,39,0,45,37,84,0,2,0,0,0,102,0,1,3,48,1,8,0,67,0,2,0,89,1,2,1,48,1,8,0,67,0,1,0,168,0,0,0,78,1,1,0,102,97,115,116,0,110,111,114,109,97,108,0,101,120,99,108,117,115,105,118,101,0,2,0,1,0,102,0,1,4,21,1,0,0,66,0,2,0,103,0,7,0,110,111,116,32,97,32,119,114,105,116,97,98,108,101,32,100,105,114,101,99,116,111,114,121,0,83,97,102,101,116,121,32,108,101,118,101,108,32,109,97,121,32,110,111,116,32,98,101,32,99,104,97,110,103,101,100,32,105,110,115,105,100,101,32,97,32,116,114,97,110,115,97,99,116,105,111,110,0,105,115,115,105,115,105,0,105,105,115,88,0,105,115,105,88,0,105,115,105,115,105,0,105,115,115,0,105,115,0,105,105,115,115,115,115,115,115,0,78,79,78,69,0,115,105,88,0,42,42,42,32,105,110,32,100,97,116,97,98,97,115,101,32,37,115,32,42,42,42,10,0,78,85,76,76,32,118,97,108,117,101,32,105,110,32,37,115,46,37,115,0,67,72,69,67,75,32,99,111,110,115,116,114,97,105,110,116,32,102,97,105,108,101,100,32,105,110,32,37,115,0,114,111,119,32,0,32,109,105,115,115,105,110,103,32,102,114,111,109,32,105,110,100,101,120,32,0,110,111,110,45,117,110,105,113,117,101,32,101,110,116,114,121,32,105,110,32,105,110,100,101,120,32,0,119,114,111,110,103,32,35,32,111,102,32,101,110,116,114,105,101,115,32,105,110,32,105,110,100,101,120,32,0,80,1,0,0,49,1,4,0,97,0,3,0,78,3,1,0,66,0,0,0,97,0,3,0,13,0,3,0,111,107,0,85,84,70,56,0,85,84,70,45,56,0,2,0,1,0,103,0,0,0,2,0,0,0,102,0,1,0,78,1,1,0,102,117,108,108,0,114,101,115,116,97,114,116,0,116,114,117,110,99,97,116,101,0,65,78,65,76,89,90,69,32,34,37,119,34,46,34,37,119,34,0,85,84,70,45,49,54,108,101,0,85,84,70,45,49,54,98,101,0,85,84,70,49,54,108,101,0,85,84,70,49,54,98,101,0,85,84,70,45,49,54,0,85,84,70,49,54,0,117,110,115,117,112,112,111,114,116,101,100,32,101,110,99,111,100,105,110,103,58,32,37,115,0,37,95,0,0,117,110,97,98,108,101,32,116,111,32,100,101,108,101,116,101,47,109,111,100,105,102,121,32,117,115,101,114,45,102,117,110,99,116,105,111,110,32,100,117,101,32,116,111,32,97,99,116,105,118,101,32,115,116,97,116,101,109,101,110,116,115,0,102,111,114,101,105,103,110,32,107,101,121,32,109,105,115,109,97,116,99,104,32,45,32,34,37,119,34,32,114,101,102,101,114,101,110,99,105,110,103,32,34,37,119,34,0,83,69,84,32,68,69,70,65,85,76,84,0,67,65,83,67,65,68,69,0,82,69,83,84,82,73,67,84,0,78,79,32,65,67,84,73,79,78,0,83,69,84,32,78,85,76,76,0,99,0,117,0,116,101,109,112,111,114,97,114,121,32,115,116,111,114,97,103,101,32,99,97,110,110,111,116,32,98,101,32,99,104,97,110,103,101,100,32,102,114,111,109,32,119,105,116,104,105,110,32,97,32,116,114,97,110,115,97,99,116,105,111,110,0,110,111,110,101,0,105,110,99,114,101,109,101,110,116,97,108,0,100,101,108,101,116,101,0,112,101,114,115,105,115,116,0,111,102,102,0,119,97,108,0,0,0,0,1,1,1,1,1,0,16,0,1,0,1,1,1,3,3,1,18,1,3,3,1,9,9,9,9,9,9,9,9,9,1,1,1,1,1,1,1,1,1,35,38,38,11,1,1,3,3,3,3,11,11,11,11,11,11,1,3,1,1,1,2,2,8,0,16,16,16,16,0,16,16,0,0,16,16,0,0,2,2,2,0,38,38,38,38,38,38,38,38,38,38,0,18,32,16,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,16,0,0,4,4,0,0,16,16,16,0,0,16,0,0,0,0,0,0,0,6,16,0,4,26,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,110,111,32,115,117,99,104,32,105,110,100,101,120,58,32,37,83,0,105,110,100,101,120,32,97,115,115,111,99,105,97,116,101,100,32,119,105,116,104,32,85,78,73,81,85,69,32,111,114,32,80,82,73,77,65,82,89,32,75,69,89,32,99,111,110,115,116,114,97,105,110,116,32,99,97,110,110,111,116,32,98,101,32,100,114,111,112,112,101,100,0,68,69,76,69,84,69,32,70,82,79,77,32,37,81,46,37,115,32,87,72,69,82,69,32,110,97,109,101,61,37,81,32,65,78,68,32,116,121,112,101,61,39,105,110,100,101,120,39,0,85,80,68,65,84,69,32,37,81,46,37,115,32,83,69,84,32,114,111,111,116,112,97,103,101,61,37,100,32,87,72,69,82,69,32,35,37,100,32,65,78,68,32,114,111,111,116,112,97,103,101,61,35,37,100,0,115,113,108,105,116,101,95,115,116,97,116,37,100,0,115,121,110,116,97,120,32,101,114,114,111,114,32,97,102,116,101,114,32,99,111,108,117,109,110,32,110,97,109,101,32,34,37,46,42,115,34,0,48,0,118,97,114,105,97,98,108,101,32,110,117,109,98,101,114,32,109,117,115,116,32,98,101,32,98,101,116,119,101,101,110,32,63,49,32,97,110,100,32,63,37,100,0,116,111,111,32,109,97,110,121,32,83,81,76,32,118,97,114,105,97,98,108,101,115,0,116,97,98,108,101,32,37,83,32,104,97,115,32,110,111,32,99,111,108,117,109,110,32,110,97,109,101,100,32,37,115,0,116,97,98,108,101,32,37,83,32,104,97,115,32,37,100,32,99,111,108,117,109,110,115,32,98,117,116,32,37,100,32,118,97,108,117,101,115,32,119,101,114,101,32,115,117,112,112,108,105,101,100,0,37,100,32,118,97,108,117,101,115,32,102,111,114,32,37,100,32,99,111,108,117,109,110,115,0,114,111,119,115,32,105,110,115,101,114,116,101,100,0,51,0,2,0,116,0,0,0,100,0,2,0,117,0,0,0,113,0,0,0,97,116,32,109,111,115,116,32,37,100,32,116,97,98,108,101,115,32,105,110,32,97,32,106,111,105,110,0,27,25,24,26,0,0,37,33,27,24,26,25,41,39,38,40,7,6,37,33,83,69,65,82,67,72,0,83,67,65,78,0,32,83,85,66,81,85,69,82,89,32,37,100,0,32,84,65,66,76,69,32,37,115,0,32,65,83,32,37,115,0,73,78,68,69,88,32,37,115,0,67,79,86,69,82,73,78,71,32,73,78,68,69,88,32,37,115,0,65,85,84,79,77,65,84,73,67,32,67,79,86,69,82,73,78,71,32,73,78,68,69,88,0,65,85,84,79,77,65,84,73,67,32,80,65,82,84,73,65,76,32,67,79,86,69,82,73,78,71,32,73,78,68,69,88,0,80,82,73,77,65,82,89,32,75,69,89,0,32,85,83,73,78,71,32,0,60,0,62,0,62,63,32,65,78,68,32,114,111,119,105,100,60,0,61,0,32,85,83,73,78,71,32,73,78,84,69,71,69,82,32,80,82,73,77,65,82,89,32,75,69,89,32,40,114,111,119,105,100,37,115,63,41,0,32,86,73,82,84,85,65,76,32,84,65,66,76,69,32,73,78,68,69,88,32,37,100,58,37,115,0,32,40,0,32,65,78,68,32,0,65,78,89,40,37,115,41,0,37,115,61,63,0,40,0,60,101,120,112,114,62,0,97,117,116,111,109,97,116,105,99,32,105,110,100,101,120,32,111,110,32,37,115,40,37,115,41,0,97,117,116,111,45,105,110,100,101,120,0,110,111,32,113,117,101,114,121,32,115,111,108,117,116,105,111,110,0,10,10,9,9,8,8,7,7,7,6,6,6,5,5,5,4,4,4,4,3,3,3,3,3,3,2,2,2,2,2,2,2,37,115,46,120,66,101,115,116,73,110,100,101,120,32,109,97,108,102,117,110,99,116,105,111,110,0,79,78,32,99,108,97,117,115,101,32,114,101,102,101,114,101,110,99,101,115,32,116,97,98,108,101,115,32,116,111,32,105,116,115,32,114,105,103,104,116,0,78,79,67,65,83,69,0,114,101,103,101,120,112,0,116,111,111,32,109,97,110,121,32,97,114,103,117,109,101,110,116,115,32,111,110,32,37,115,40,41,32,45,32,109,97,120,32,37,100,0,45,45,32,84,82,73,71,71,69,82,32,37,115,0,0,1,2,3,4,6,8,8,0,0,0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,30,30,31,31,32,32,33,33,34,34,35,35,36,36,37,37,38,38,39,39,40,40,41,41,42,42,43,43,44,44,45,45,46,46,47,47,48,48,49,49,50,50,51,51,52,52,53,53,54,54,55,55,56,56,57,57,45,45,32,37,115,0,37,115,46,114,111,119,105,100,0,116,97,98,108,101,32,37,115,32,109,97,121,32,110,111,116,32,98,101,32,109,111,100,105,102,105,101,100,0,99,97,110,110,111,116,32,109,111,100,105,102,121,32,37,115,32,98,101,99,97,117,115,101,32,105,116,32,105,115,32,97,32,118,105,101,119,0,110,111,32,115,117,99,104,32,99,111,108,117,109,110,58,32,37,115,0,114,111,119,115,32,117,112,100,97,116,101,100,0,116,111,111,32,109,97,110,121,32,99,111,108,117,109,110,115,32,105,110,32,37,115,0,114,111,119,115,32,100,101,108,101,116,101,100,0,110,97,116,117,114,97,108,101,102,116,111,117,116,101,114,105,103,104,116,102,117,108,108,105,110,110,101,114,99,114,111,115,115,0,0,7,4,6,4,40,10,5,32,14,5,48,19,4,56,23,5,1,28,5,3,117,110,107,110,111,119,110,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,106,111,105,110,32,116,121,112,101,58,32,37,84,32,37,84,37,115,37,84,0,82,73,71,72,84,32,97,110,100,32,70,85,76,76,32,79,85,84,69,82,32,74,79,73,78,115,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,101,100,0,79,78,0,85,83,73,78,71,0,97,32,74,79,73,78,32,99,108,97,117,115,101,32,105,115,32,114,101,113,117,105,114,101,100,32,98,101,102,111,114,101,32,37,115,0,116,111,111,32,109,97,110,121,32,116,101,114,109,115,32,105,110,32,99,111,109,112,111,117,110,100,32,83,69,76,69,67,84,0,101,120,112,101,99,116,101,100,32,37,100,32,99,111,108,117,109,110,115,32,102,111,114,32,39,37,115,39,32,98,117,116,32,103,111,116,32,37,100,0,68,73,83,84,73,78,67,84,0,71,82,79,85,80,32,66,89,0,82,73,71,72,84,32,80,65,82,84,32,79,70,32,79,82,68,69,82,32,66,89,0,79,82,68,69,82,32,66,89,0,32,85,83,73,78,71,32,67,79,86,69,82,73,78,71,32,73,78,68,69,88,32,0,83,67,65,78,32,84,65,66,76,69,32,37,115,37,115,37,115,0,68,73,83,84,73,78,67,84,32,97,103,103,114,101,103,97,116,101,115,32,109,117,115,116,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,114,103,117,109,101,110,116,0,85,83,69,32,84,69,77,80,32,66,45,84,82,69,69,32,70,79,82,32,37,115,0,76,73,77,73,84,0,37,115,32,99,108,97,117,115,101,32,115,104,111,117,108,100,32,99,111,109,101,32,97,102,116,101,114,32,37,115,32,110,111,116,32,98,101,102,111,114,101,0,85,83,73,78,71,32,84,69,77,80,32,66,45,84,82,69,69,32,0,67,79,77,80,79,85,78,68,32,83,85,66,81,85,69,82,73,69,83,32,37,100,32,65,78,68,32,37,100,32,37,115,40,37,115,41,0,114,101,99,117,114,115,105,118,101,32,97,103,103,114,101,103,97,116,101,32,113,117,101,114,105,101,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,112,97,114,97,109,101,116,101,114,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,118,105,101,119,115,0,118,105,101,119,0,115,113,108,105,116,101,95,115,116,97,116,0,116,97,98,108,101,32,37,115,32,109,97,121,32,110,111,116,32,98,101,32,100,114,111,112,112,101,100,0,117,115,101,32,68,82,79,80,32,84,65,66,76,69,32,116,111,32,100,101,108,101,116,101,32,116,97,98,108,101,32,37,115,0,117,115,101,32,68,82,79,80,32,86,73,69,87,32,116,111,32,100,101,108,101,116,101,32,118,105,101,119,32,37,115,0,68,69,76,69,84,69,32,70,82,79,77,32,37,81,46,115,113,108,105,116,101,95,115,101,113,117,101,110,99,101,32,87,72,69,82,69,32,110,97,109,101,61,37,81,0,68,69,76,69,84,69,32,70,82,79,77,32,37,81,46,37,115,32,87,72,69,82,69,32,116,98,108,95,110,97,109,101,61,37,81,32,97,110,100,32,116,121,112,101,33,61,39,116,114,105,103,103,101,114,39,0,102,111,114,101,105,103,110,32,107,101,121,32,111,110,32,37,115,32,115,104,111,117,108,100,32,114,101,102,101,114,101,110,99,101,32,111,110,108,121,32,111,110,101,32,99,111,108,117,109,110,32,111,102,32,116,97,98,108,101,32,37,84,0,110,117,109,98,101,114,32,111,102,32,99,111,108,117,109,110,115,32,105,110,32,102,111,114,101,105,103,110,32,107,101,121,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,99,111,108,117,109,110,115,32,105,110,32,116,104,101,32,114,101,102,101,114,101,110,99,101,100,32,116,97,98,108,101,0,117,110,107,110,111,119,110,32,99,111,108,117,109,110,32,34,37,115,34,32,105,110,32,102,111,114,101,105,103,110,32,107,101,121,32,100,101,102,105,110,105,116,105,111,110,0,105,110,100,101,120,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,97,32,84,69,77,80,32,105,110,100,101,120,32,111,110,32,110,111,110,45,84,69,77,80,32,116,97,98,108,101,32,34,37,115,34,0,97,108,116,101,114,116,97,98,95,0,116,97,98,108,101,32,37,115,32,109,97,121,32,110,111,116,32,98,101,32,105,110,100,101,120,101,100,0,118,105,101,119,115,32,109,97,121,32,110,111,116,32,98,101,32,105,110,100,101,120,101,100,0,118,105,114,116,117,97,108,32,116,97,98,108,101,115,32,109,97,121,32,110,111,116,32,98,101,32,105,110,100,101,120,101,100,0,116,104,101,114,101,32,105,115,32,97,108,114,101,97,100,121,32,97,32,116,97,98,108,101,32,110,97,109,101,100,32,37,115,0,105,110,100,101,120,32,37,115,32,97,108,114,101,97,100,121,32,101,120,105,115,116,115,0,115,113,108,105,116,101,95,97,117,116,111,105,110,100,101,120,95,37,115,95,37,100,0,101,120,112,114,101,115,115,105,111,110,115,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,80,82,73,77,65,82,89,32,75,69,89,32,97,110,100,32,85,78,73,81,85,69,32,99,111,110,115,116,114,97,105,110,116,115,0,99,111,110,102,108,105,99,116,105,110,103,32,79,78,32,67,79,78,70,76,73,67,84,32,99,108,97,117,115,101,115,32,115,112,101,99,105,102,105,101,100,0,32,85,78,73,81,85,69,0,67,82,69,65,84,69,37,115,32,73,78,68,69,88,32,37,46,42,115,0,73,78,83,69,82,84,32,73,78,84,79,32,37,81,46,37,115,32,86,65,76,85,69,83,40,39,105,110,100,101,120,39,44,37,81,44,37,81,44,35,37,100,44,37,81,41,59,0,110,97,109,101,61,39,37,113,39,32,65,78,68,32,116,121,112,101,61,39,105,110,100,101,120,39,0,116,97,98,108,101,32,34,37,115,34,32,104,97,115,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,112,114,105,109,97,114,121,32,107,101,121,0,65,85,84,79,73,78,67,82,69,77,69,78,84,32,105,115,32,111,110,108,121,32,97,108,108,111,119,101,100,32,111,110,32,97,110,32,73,78,84,69,71,69,82,32,80,82,73,77,65,82,89,32,75,69,89,0,100,101,102,97,117,108,116,32,118,97,108,117,101,32,111,102,32,99,111,108,117,109,110,32,91,37,115,93,32,105,115,32,110,111,116,32,99,111,110,115,116,97,110,116,0,116,111,111,32,109,97,110,121,32,99,111,108,117,109,110,115,32,111,110,32,37,115,0,100,117,112,108,105,99,97,116,101,32,99,111,108,117,109,110,32,110,97,109,101,58,32,37,115,0,65,85,84,79,73,78,67,82,69,77,69,78,84,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,87,73,84,72,79,85,84,32,82,79,87,73,68,32,116,97,98,108,101,115,0,80,82,73,77,65,82,89,32,75,69,89,32,109,105,115,115,105,110,103,32,111,110,32,116,97,98,108,101,32,37,115,0,84,65,66,76,69,0,86,73,69,87,0,67,82,69,65,84,69,32,37,115,32,37,46,42,115,0,85,80,68,65,84,69,32,37,81,46,37,115,32,83,69,84,32,116,121,112,101,61,39,37,115,39,44,32,110,97,109,101,61,37,81,44,32,116,98,108,95,110,97,109,101,61,37,81,44,32,114,111,111,116,112,97,103,101,61,35,37,100,44,32,115,113,108,61,37,81,32,87,72,69,82,69,32,114,111,119,105,100,61,35,37,100,0,67,82,69,65,84,69,32,84,65,66,76,69,32,37,81,46,115,113,108,105,116,101,95,115,101,113,117,101,110,99,101,40,110,97,109,101,44,115,101,113,41,0,116,98,108,95,110,97,109,101,61,39,37,113,39,32,65,78,68,32,116,121,112,101,33,61,39,116,114,105,103,103,101,114,39,0,44,10,32,32,0,10,41,0,67,82,69,65,84,69,32,84,65,66,76,69,32,0,10,32,32,0,32,84,69,88,84,0,32,78,85,77,0,32,73,78,84,0,32,82,69,65,76,0,76,105,117,74,0,45,0,0,82,0,77,0,0,42,12,78,15,0,116,85,54,112,0,19,0,0,121,0,119,115,0,22,93,0,9,0,0,70,71,0,69,6,0,48,90,102,0,118,101,0,0,44,0,103,24,0,17,0,122,53,23,0,5,110,25,96,0,0,124,106,60,123,57,28,55,0,91,0,100,26,0,99,0,0,0,95,92,97,88,109,14,39,108,0,81,0,18,89,111,32,0,120,80,113,62,46,84,0,0,94,40,59,114,0,36,0,0,29,0,86,63,64,0,20,61,0,56,7,7,5,4,6,4,5,3,6,7,3,6,6,7,7,3,8,2,6,5,4,4,3,10,4,6,11,6,2,7,5,5,9,6,9,9,7,10,10,4,6,2,3,9,4,2,6,5,7,4,5,7,6,6,5,6,5,5,9,7,7,3,2,4,4,7,3,6,4,7,6,12,6,9,4,6,5,4,7,6,5,6,7,5,4,5,6,5,7,3,7,13,2,2,4,6,6,8,5,17,12,7,8,8,2,4,4,4,4,4,2,2,6,5,8,5,8,3,5,5,6,4,9,3,82,69,73,78,68,69,88,69,68,69,83,67,65,80,69,65,67,72,69,67,75,69,89,66,69,70,79,82,69,73,71,78,79,82,69,71,69,88,80,76,65,73,78,83,84,69,65,68,68,65,84,65,66,65,83,69,76,69,67,84,65,66,76,69,70,84,72,69,78,68,69,70,69,82,82,65,66,76,69,76,83,69,88,67,69,80,84,82,65,78,83,65,67,84,73,79,78,65,84,85,82,65,76,84,69,82,65,73,83,69,88,67,76,85,83,73,86,69,88,73,83,84,83,65,86,69,80,79,73,78,84,69,82,83,69,67,84,82,73,71,71,69,82,69,70,69,82,69,78,67,69,83,67,79,78,83,84,82,65,73,78,84,79,70,70,83,69,84,69,77,80,79,82,65,82,89,85,78,73,81,85,69,82,89,87,73,84,72,79,85,84,69,82,69,76,69,65,83,69,65,84,84,65,67,72,65,86,73,78,71,82,79,85,80,68,65,84,69,66,69,71,73,78,78,69,82,69,67,85,82,83,73,86,69,66,69,84,87,69,69,78,79,84,78,85,76,76,73,75,69,67,65,83,67,65,68,69,76,69,84,69,67,65,83,69,67,79,76,76,65,84,69,67,82,69,65,84,69,67,85,82,82,69,78,84,95,68,65,84,69,68,69,84,65,67,72,73,77,77,69,68,73,65,84,69,74,79,73,78,83,69,82,84,77,65,84,67,72,80,76,65,78,65,76,89,90,69,80,82,65,71,77,65,66,79,82,84,86,65,76,85,69,83,86,73,82,84,85,65,76,73,77,73,84,87,72,69,78,87,72,69,82,69,78,65,77,69,65,70,84,69,82,69,80,76,65,67,69,65,78,68,69,70,65,85,76,84,65,85,84,79,73,78,67,82,69,77,69,78,84,67,65,83,84,67,79,76,85,77,78,67,79,77,77,73,84,67,79,78,70,76,73,67,84,67,82,79,83,83,67,85,82,82,69,78,84,95,84,73,77,69,83,84,65,77,80,82,73,77,65,82,89,68,69,70,69,82,82,69,68,73,83,84,73,78,67,84,68,82,79,80,70,65,73,76,70,82,79,77,70,85,76,76,71,76,79,66,89,73,70,73,83,78,85,76,76,79,82,68,69,82,69,83,84,82,73,67,84,82,73,71,72,84,82,79,76,76,66,65,67,75,82,79,87,85,78,73,79,78,85,83,73,78,71,86,65,67,85,85,77,86,73,69,87,73,78,73,84,73,65,76,76,89,80,96,140,39,58,41,104,66,33,113,61,62,47,2,64,142,38,24,119,16,98,138,11,112,139,117,6,28,107,98,141,70,9,20,13,118,75,105,99,131,68,67,111,21,21,43,103,3,25,79,98,14,32,128,127,110,5,98,71,48,51,19,65,101,47,35,31,109,136,94,17,82,40,8,124,108,46,4,30,69,27,120,78,129,137,130,81,29,72,44,100,106,15,49,36,60,10,37,98,82,82,102,7,121,45,114,42,123,98,47,34,18,50,126,73,98,12,74,115,125,76,77,63,116,0,0,0,0,4,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,13,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,33,0,21,0,0,0,0,0,50,0,43,3,47,0,0,0,0,30,0,58,0,38,0,0,0,1,66,0,0,67,0,41,0,0,0,0,0,0,49,65,0,0,0,0,31,52,16,34,10,0,0,0,0,0,0,0,11,72,79,0,8,0,104,98,0,107,0,87,0,75,51,0,27,37,73,83,0,35,68,0,0,116,101,109,112,111,114,97,114,121,32,116,97,98,108,101,32,110,97,109,101,32,109,117,115,116,32,98,101,32,117,110,113,117,97,108,105,102,105,101,100,0,2,4,8,6,116,97,98,108,101,32,37,84,32,97,108,114,101,97,100,121,32,101,120,105,115,116,115,0,116,104,101,114,101,32,105,115,32,97,108,114,101,97,100,121,32,97,110,32,105,110,100,101,120,32,110,97,109,101,100,32,37,115,0,6,0,0,0,0,0,66,69,71,73,78,0,82,69,76,69,65,83,69,0,82,79,76,76,66,65,67,75,0,67,79,77,77,73,84,0,70,0,0,0,37,0,9,0,98,0,0,0,52,0,7,0,124,0,0,0,98,0,1,0,13,0,9,0,7,0,2,0,67,0,0,0,113,0,0,0,112,97,114,115,101,114,32,115,116,97,99,107,32,111,118,101,114,102,108,111,119,0,105,110,99,111,109,112,108,101,116,101,32,105,110,112,117,116,0,144,145,146,147,172,222,223,224,222,223,224,152,180,152,148,149,152,173,176,19,154,173,156,152,163,242,152,163,176,163,26,31,173,174,173,174,173,173,174,39,1,2,152,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,197,169,170,197,188,197,222,223,224,208,209,208,209,19,208,152,222,223,224,22,26,24,46,47,48,49,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,106,245,157,88,89,90,91,92,93,94,68,231,251,19,84,85,86,87,88,89,90,91,92,93,94,101,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,90,91,92,93,94,82,79,99,66,200,102,103,104,19,168,169,170,152,24,210,97,113,229,59,101,232,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,152,188,152,132,133,134,93,94,96,97,98,99,152,19,102,103,104,23,94,72,79,173,174,173,174,113,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,152,171,152,108,109,110,208,209,119,120,152,180,181,19,119,120,152,23,152,152,189,173,174,173,174,59,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,222,223,224,186,208,209,208,209,194,194,96,97,98,19,168,169,170,23,88,89,163,59,0,1,2,219,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,90,152,197,195,196,243,96,97,98,196,132,11,134,19,182,207,115,23,117,118,207,163,173,174,152,220,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,152,16,152,197,171,208,22,23,22,23,26,16,26,19,7,8,9,23,212,213,152,173,174,173,174,19,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,46,152,109,110,208,109,110,152,75,152,77,22,23,19,233,83,152,83,75,238,77,164,173,174,226,59,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,108,109,110,152,152,152,22,22,23,107,96,97,98,160,112,251,19,164,22,152,83,140,219,152,173,174,84,85,86,87,88,89,90,91,92,93,94,59,124,152,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,59,169,170,119,120,82,108,109,110,191,192,191,192,83,248,249,19,88,89,96,97,24,152,152,101,138,84,85,86,87,88,89,90,91,92,93,94,96,97,98,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,132,133,134,152,152,46,152,26,231,194,194,146,147,19,152,116,152,72,152,152,121,152,152,152,79,138,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,152,108,23,152,194,26,194,152,194,194,137,152,139,19,107,166,167,218,218,29,218,173,174,33,173,174,84,85,86,87,88,89,90,91,92,93,94,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,152,194,64,171,239,239,239,130,166,167,212,213,19,23,246,247,26,59,26,152,163,218,163,163,163,98,84,85,86,87,88,89,90,91,92,93,94,44,45,46,47,48,49,50,51,52,53,54,55,56,57,124,26,79,197,97,197,197,197,31,152,23,19,19,26,19,218,39,23,21,238,26,163,163,100,59,163,84,85,86,87,88,89,90,91,92,93,94,45,46,47,48,49,50,51,52,53,54,55,56,57,19,20,152,22,23,197,197,23,19,197,26,152,97,23,123,23,26,36,26,152,152,19,20,98,22,78,84,85,86,87,88,89,90,91,92,93,94,94,36,152,59,96,99,100,101,102,103,104,105,124,103,70,100,101,23,112,12,26,12,23,79,59,26,82,101,22,7,8,152,88,89,27,70,27,152,112,95,96,97,98,152,79,101,22,82,96,42,140,42,182,88,89,19,20,132,22,134,95,96,97,98,23,59,101,26,22,62,152,62,36,22,59,24,132,133,134,135,136,72,5,59,152,22,71,10,11,12,13,14,152,152,17,59,182,132,133,134,135,136,96,97,98,59,70,30,152,32,59,96,97,98,173,174,53,40,82,152,96,97,98,90,88,89,90,24,187,173,174,95,96,97,98,152,152,101,19,20,152,22,96,97,98,152,69,59,97,116,59,214,152,76,121,36,79,80,19,20,152,22,59,132,59,134,173,174,132,133,134,135,136,173,174,36,234,152,59,152,187,173,174,211,96,97,98,187,97,70,23,114,152,26,23,187,23,26,59,26,97,82,97,22,164,152,152,88,89,70,192,152,124,152,95,96,97,98,141,152,101,82,152,152,184,152,186,88,89,199,54,55,56,57,95,96,97,98,152,152,101,152,152,173,174,235,54,55,56,57,58,132,133,134,135,136,211,150,59,211,84,85,86,87,88,89,90,91,92,93,94,132,133,134,135,136,84,85,86,87,88,89,90,91,92,93,94,88,89,195,196,35,211,211,152,96,97,98,152,100,198,207,171,122,240,152,107,215,109,240,202,215,202,152,220,173,174,177,185,173,174,65,152,176,152,181,173,174,215,73,176,132,228,134,173,174,176,152,201,152,199,155,152,173,174,173,174,60,152,122,244,38,159,159,152,241,241,152,173,174,173,174,152,173,174,152,159,111,152,173,174,152,22,152,43,173,174,152,173,174,152,190,130,173,174,152,173,174,152,173,174,202,173,174,173,174,152,18,173,174,152,173,174,152,221,152,173,174,193,173,174,152,158,152,159,152,22,173,174,152,18,173,174,152,173,174,173,174,152,221,152,193,173,174,173,174,173,174,152,193,173,174,152,193,173,174,158,152,190,173,174,173,174,59,152,190,159,137,152,173,174,152,202,173,174,61,152,237,173,174,202,236,22,107,159,173,174,159,178,173,174,158,173,174,159,158,158,173,174,159,178,97,175,63,175,106,175,125,217,183,178,175,107,159,22,216,177,175,217,175,175,217,216,159,216,216,183,225,217,137,227,178,94,178,126,129,25,128,127,162,206,26,161,230,230,13,153,153,6,151,203,205,204,202,151,165,171,171,151,171,165,165,171,179,4,250,179,250,247,3,22,171,171,171,142,81,15,23,16,23,131,171,120,111,123,20,16,1,125,123,131,53,53,53,53,111,96,34,122,1,5,22,107,67,140,74,26,24,41,107,67,20,19,112,105,66,22,66,22,22,28,66,23,22,22,37,23,23,23,116,22,22,26,23,122,23,23,26,22,11,96,34,124,26,26,23,23,23,34,34,23,26,23,22,24,23,22,122,23,26,22,24,23,22,15,23,23,22,122,122,23,1,122,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,252,0,0,59,59,59,59,0,59,59,59,0,59,59,59,59,0,0,0,59,0,0,59,0,0,0,59,0,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,0,0,0,59,59,0,0,0,0,0,0,0,0,0,0,0,0,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,59,27,27,27,27,27,27,27,27,27,7,7,27,7,7,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,7,15,8,5,4,22,24,8,17,18,21,20,23,11,26,16,3,3,3,3,3,3,3,3,3,3,5,19,12,14,13,6,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,9,27,27,27,1,8,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,27,10,27,25,27,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,117,110,111,112,101,110,101,100,0,105,110,118,97,108,105,100,0,65,80,73,32,99,97,108,108,32,119,105,116,104,32,37,115,32,100,97,116,97,98,97,115,101,32,99,111,110,110,101,99,116,105,111,110,32,112,111,105,110,116,101,114,0,45,45,32,0,39,37,46,42,113,39,0,122,101,114,111,98,108,111,98,40,37,100,41,0,120,39,0,37,48,50,120,0,39,0,117,110,107,110,111,119,110,32,100,97,116,97,98,97,115,101,58,32,37,115,0,117,110,97,98,108,101,32,116,111,32,99,108,111,115,101,32,100,117,101,32,116,111,32,117,110,102,105,110,97,108,105,122,101,100,32,115,116,97,116,101,109,101,110,116,115,32,111,114,32,117,110,102,105,110,105,115,104,101,100,32,98,97,99,107,117,112,115,0,1,4,3,2,5,99,97,110,110,111,116,32,111,112,101,110,32,118,97,108,117,101,32,111,102,32,116,121,112,101,32,37,115,0,110,111,32,115,117,99,104,32,114,111,119,105,100,58,32,37,108,108,100,0,37,115,32,99,111,110,115,116,114,97,105,110,116,32,102,97,105,108,101,100,0,37,122,58,32,37,115,0,97,98,111,114,116,32,97,116,32,37,100,32,105,110,32,91,37,115,93,58,32,37,115,0,1,0,0,1,1,0,0,1,0,1,0,1,1,0,1,0,0,1,0,0,0,0,1,2,0,2,2,0,1,2,1,1,1,2,1,2,99,97,110,110,111,116,32,111,112,101,110,32,115,97,118,101,112,111,105,110,116,32,45,32,83,81,76,32,115,116,97,116,101,109,101,110,116,115,32,105,110,32,112,114,111,103,114,101,115,115,0,110,111,32,115,117,99,104,32,115,97,118,101,112,111,105,110,116,58,32,37,115,0,99,97,110,110,111,116,32,114,101,108,101,97,115,101,32,115,97,118,101,112,111,105,110,116,32,45,32,83,81,76,32,115,116,97,116,101,109,101,110,116,115,32,105,110,32,112,114,111,103,114,101,115,115,0,99,97,110,110,111,116,32,99,111,109,109,105,116,32,116,114,97,110,115,97,99,116,105,111,110,32,45,32,83,81,76,32,115,116,97,116,101,109,101,110,116,115,32,105,110,32,112,114,111,103,114,101,115,115,0,99,97,110,110,111,116,32,99,111,109,109,105,116,32,45,32,110,111,32,116,114,97,110,115,97,99,116,105,111,110,32,105,115,32,97,99,116,105,118,101,0,99,97,110,110,111,116,32,114,111,108,108,98,97,99,107,32,45,32,110,111,32,116,114,97,110,115,97,99,116,105,111,110,32,105,115,32,97,99,116,105,118,101,0,99,97,110,110,111,116,32,115,116,97,114,116,32,97,32,116,114,97,110,115,97,99,116,105,111,110,32,119,105,116,104,105,110,32,97,32,116,114,97,110,115,97,99,116,105,111,110,0,1,83,69,76,69,67,84,32,110,97,109,101,44,32,114,111,111,116,112,97,103,101,44,32,115,113,108,32,70,82,79,77,32,39,37,113,39,46,37,115,32,87,72,69,82,69,32,37,115,32,79,82,68,69,82,32,66,89,32,114,111,119,105,100,0,116,111,111,32,109,97,110,121,32,108,101,118,101,108,115,32,111,102,32,116,114,105,103,103,101,114,32,114,101,99,117,114,115,105,111,110,0,105,110,116,111,0,111,117,116,32,111,102,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,37,115,32,119,97,108,32,109,111,100,101,32,102,114,111,109,32,119,105,116,104,105,110,32,97,32,116,114,97,110,115,97,99,116,105,111,110,0,100,97,116,97,98,97,115,101,32,116,97,98,108,101,32,105,115,32,108,111,99,107,101,100,58,32,37,115,0,115,116,97,116,101,109,101,110,116,32,97,98,111,114,116,115,32,97,116,32,37,100,58,32,91,37,115,93,32,37,115,0,99,97,110,110,111,116,32,86,65,67,85,85,77,32,102,114,111,109,32,119,105,116,104,105,110,32,97,32,116,114,97,110,115,97,99,116,105,111,110,0,99,97,110,110,111,116,32,86,65,67,85,85,77,32,45,32,83,81,76,32,115,116,97,116,101,109,101,110,116,115,32,105,110,32,112,114,111,103,114,101,115,115,0,65,84,84,65,67,72,39,39,65,83,32,118,97,99,117,117,109,95,100,98,0,83,69,76,69,67,84,32,115,113,108,32,70,82,79,77,32,34,37,119,34,46,115,113,108,105,116,101,95,109,97,115,116,101,114,32,87,72,69,82,69,32,116,121,112,101,61,39,116,97,98,108,101,39,65,78,68,32,110,97,109,101,60,62,39,115,113,108,105,116,101,95,115,101,113,117,101,110,99,101,39,32,65,78,68,32,99,111,97,108,101,115,99,101,40,114,111,111,116,112,97,103,101,44,49,41,62,48,0,83,69,76,69,67,84,32,115,113,108,32,70,82,79,77,32,34,37,119,34,46,115,113,108,105,116,101,95,109,97,115,116,101,114,32,87,72,69,82,69,32,116,121,112,101,61,39,105,110,100,101,120,39,32,65,78,68,32,108,101,110,103,116,104,40,115,113,108,41,62,49,48,0,83,69,76,69,67,84,39,73,78,83,69,82,84,32,73,78,84,79,32,118,97,99,117,117,109,95,100,98,46,39,124,124,113,117,111,116,101,40,110,97,109,101,41,124,124,39,32,83,69,76,69,67,84,42,70,82,79,77,34,37,119,34,46,39,124,124,113,117,111,116,101,40,110,97,109,101,41,70,82,79,77,32,118,97,99,117,117,109,95,100,98,46,115,113,108,105,116,101,95,109,97,115,116,101,114,32,87,72,69,82,69,32,116,121,112,101,61,39,116,97,98,108,101,39,65,78,68,32,99,111,97,108,101,115,99,101,40,114,111,111,116,112,97,103,101,44,49,41,62,48,0,73,78,83,69,82,84,32,73,78,84,79,32,118,97,99,117,117,109,95,100,98,46,115,113,108,105,116,101,95,109,97,115,116,101,114,32,83,69,76,69,67,84,42,70,82,79,77,32,34,37,119,34,46,115,113,108,105,116,101,95,109,97,115,116,101,114,32,87,72,69,82,69,32,116,121,112,101,32,73,78,40,39,118,105,101,119,39,44,39,116,114,105,103,103,101,114,39,41,32,79,82,40,116,121,112,101,61,39,116,97,98,108,101,39,65,78,68,32,114,111,111,116,112,97,103,101,61,48,41,0,77,97,105,110,32,102,114,101,101,108,105,115,116,58,32,0,80,97,103,101,32,37,100,32,105,115,32,110,101,118,101,114,32,117,115,101,100,0,80,111,105,110,116,101,114,32,109,97,112,32,112,97,103,101,32,37,100,32,105,115,32,114,101,102,101,114,101,110,99,101,100,0,10,0,80,97,103,101,32,37,100,58,32,0,117,110,97,98,108,101,32,116,111,32,103,101,116,32,116,104,101,32,112,97,103,101,46,32,101,114,114,111,114,32,99,111,100,101,61,37,100,0,98,116,114,101,101,73,110,105,116,80,97,103,101,40,41,32,114,101,116,117,114,110,115,32,101,114,114,111,114,32,99,111,100,101,32,37,100,0,79,110,32,116,114,101,101,32,112,97,103,101,32,37,100,32,99,101,108,108,32,37,100,58,32,0,79,110,32,112,97,103,101,32,37,100,32,97,116,32,114,105,103,104,116,32,99,104,105,108,100,58,32,0,79,102,102,115,101,116,32,37,100,32,111,117,116,32,111,102,32,114,97,110,103,101,32,37,100,46,46,37,100,0,69,120,116,101,110,100,115,32,111,102,102,32,101,110,100,32,111,102,32,112,97,103,101,0,82,111,119,105,100,32,37,108,108,100,32,111,117,116,32,111,102,32,111,114,100,101,114,0,67,104,105,108,100,32,112,97,103,101,32,100,101,112,116,104,32,100,105,102,102,101,114,115,0,77,117,108,116,105,112,108,101,32,117,115,101,115,32,102,111,114,32,98,121,116,101,32,37,117,32,111,102,32,112,97,103,101,32,37,100,0,70,114,97,103,109,101,110,116,97,116,105,111,110,32,111,102,32,37,100,32,98,121,116,101,115,32,114,101,112,111,114,116,101,100,32,97,115,32,37,100,32,111,110,32,112,97,103,101,32,37,100,0,105,110,118,97,108,105,100,32,112,97,103,101,32,110,117,109,98,101,114,32,37,100,0,50,110,100,32,114,101,102,101,114,101,110,99,101,32,116,111,32,112,97,103,101,32,37,100,0,70,97,105,108,101,100,32,116,111,32,114,101,97,100,32,112,116,114,109,97,112,32,107,101,121,61,37,100,0,66,97,100,32,112,116,114,32,109,97,112,32,101,110,116,114,121,32,107,101,121,61,37,100,32,101,120,112,101,99,116,101,100,61,40,37,100,44,37,100,41,32,103,111,116,61,40,37,100,44,37,100,41,0,37,100,32,111,102,32,37,100,32,112,97,103,101,115,32,109,105,115,115,105,110,103,32,102,114,111,109,32,111,118,101,114,102,108,111,119,32,108,105,115,116,32,115,116,97,114,116,105,110,103,32,97,116,32,37,100,0,102,97,105,108,101,100,32,116,111,32,103,101,116,32,112,97,103,101,32,37,100,0,102,114,101,101,108,105,115,116,32,108,101,97,102,32,99,111,117,110,116,32,116,111,111,32,98,105,103,32,111,110,32,112,97,103,101,32,37,100,0,102,114,101,101,45,112,97,103,101,32,99,111,117,110,116,32,105,110,32,104,101,97,100,101,114,32,105,115,32,116,111,111,32,115,109,97,108,108,0,0,1,2,3,4,6,8,0,0,0,78,79,84,32,78,85,76,76,0,85,78,73,81,85,69,0,67,72,69,67,75,0,70,79,82,69,73,71,78,32,75,69,89,0,115,111,117,114,99,101,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,109,117,115,116,32,98,101,32,100,105,115,116,105,110,99,116,0,100,101,115,116,105,110,97,116,105,111,110,32,100,97,116,97,98,97,115,101,32,105,115,32,105,110,32,117,115,101,0,117,110,107,110,111,119,110,32,100,97,116,97,98,97,115,101,32,37,115,0,82,84,82,73,77,0,116,101,109,112,0,97,117,116,111,109,97,116,105,99,32,101,120,116,101,110,115,105,111,110,32,108,111,97,100,105,110,103,32,102,97,105,108,101,100,58,32,37,115,0,77,65,84,67,72,0,117,110,97,98,108,101,32,116,111,32,100,101,108,101,116,101,47,109,111,100,105,102,121,32,99,111,108,108,97,116,105,111,110,32,115,101,113,117,101,110,99,101,32,100,117,101,32,116,111,32,97,99,116,105,118,101,32,115,116,97,116,101,109,101,110,116,115,0,99,97,110,110,111,116,32,111,112,101,110,32,118,105,114,116,117,97,108,32,116,97,98,108,101,58,32,37,115,0,99,97,110,110,111,116,32,111,112,101,110,32,116,97,98,108,101,32,119,105,116,104,111,117,116,32,114,111,119,105,100,58,32,37,115,0,99,97,110,110,111,116,32,111,112,101,110,32,118,105,101,119,58,32,37,115,0,110,111,32,115,117,99,104,32,99,111,108,117,109,110,58,32,34,37,115,34,0,102,111,114,101,105,103,110,32,107,101,121,0,105,110,100,101,120,101,100,0,99,97,110,110,111,116,32,111,112,101,110,32,37,115,32,99,111,108,117,109,110,32,102,111,114,32,119,114,105,116,105,110,103,0,153,0,0,0,105,0,0,0,32,0,5,1,98,0,0,1,78,1,0,0,66,0,0,0,117,110,97,98,108,101,32,116,111,32,117,115,101,32,102,117,110,99,116,105,111,110,32,37,115,32,105,110,32,116,104,101,32,114,101,113,117,101,115,116,101,100,32,99,111,110,116,101,120,116,0,110,111,32,115,117,99,104,32,116,97,98,108,101,32,99,111,108,117,109,110,58,32,37,115,46,37,115,0,37,46,50,120,0,107,40,37,100,0,66,0,44,37,115,37,115,0,40,37,46,50,48,115,41,0,37,115,40,37,100,41,0,37,100,0,37,46,49,54,103,0,40,98,108,111,98,41,0,118,116,97,98,58,37,112,0,44,37,100,0,93,0,112,114,111,103,114,97,109,0,83,97,118,101,112,111,105,110,116,0,65,117,116,111,67,111,109,109,105,116,0,84,114,97,110,115,97,99,116,105,111,110,0,83,111,114,116,101,114,78,101,120,116,0,80,114,101,118,73,102,79,112,101,110,0,78,101,120,116,73,102,79,112,101,110,0,80,114,101,118,0,78,101,120,116,0,67,104,101,99,107,112,111,105,110,116,0,74,111,117,114,110,97,108,77,111,100,101,0,86,97,99,117,117,109,0,86,70,105,108,116,101,114,0,86,85,112,100,97,116,101,0,71,111,116,111,0,71,111,115,117,98,0,73,110,105,116,67,111,114,111,117,116,105,110,101,0,89,105,101,108,100,0,77,117,115,116,66,101,73,110,116,0,74,117,109,112,0,78,111,116,0,79,110,99,101,0,73,102,0,73,102,78,111,116,0,73,102,78,117,108,108,82,111,119,0,83,101,101,107,76,84,0,83,101,101,107,76,69,0,83,101,101,107,71,69,0,83,101,101,107,71,84,0,78,111,67,111,110,102,108,105,99,116,0,78,111,116,70,111,117,110,100,0,70,111,117,110,100,0,83,101,101,107,82,111,119,105,100,0,78,111,116,69,120,105,115,116,115,0,76,97,115,116,0,73,102,83,109,97,108,108,101,114,0,83,111,114,116,101,114,83,111,114,116,0,83,111,114,116,0,82,101,119,105,110,100,0,73,100,120,76,69,0,73,100,120,71,84,0,73,100,120,76,84,0,73,100,120,71,69,0,82,111,119,83,101,116,82,101,97,100,0,79,114,0,65,110,100,0,82,111,119,83,101,116,84,101,115,116,0,80,114,111,103,114,97,109,0,70,107,73,102,90,101,114,111,0,73,102,80,111,115,0,73,102,78,111,116,90,101,114,111,0,73,115,78,117,108,108,0,78,111,116,78,117,108,108,0,78,101,0,69,113,0,71,116,0,76,101,0,76,116,0,71,101,0,69,108,115,101,78,111,116,69,113,0,68,101,99,114,74,117,109,112,90,101,114,111,0,73,110,99,114,86,97,99,117,117,109,0,86,78,101,120,116,0,73,110,105,116,0,82,101,116,117,114,110,0,69,110,100,67,111,114,111,117,116,105,110,101,0,72,97,108,116,73,102,78,117,108,108,0,72,97,108,116,0,73,110,116,101,103,101,114,0,73,110,116,54,52,0,83,116,114,105,110,103,0,78,117,108,108,0,83,111,102,116,78,117,108,108,0,66,108,111,98,0,86,97,114,105,97,98,108,101,0,77,111,118,101,0,67,111,112,121,0,83,67,111,112,121,0,73,110,116,67,111,112,121,0,82,101,115,117,108,116,82,111,119,0,67,111,108,108,83,101,113,0,65,100,100,73,109,109,0,82,101,97,108,65,102,102,105,110,105,116,121,0,67,97,115,116,0,80,101,114,109,117,116,97,116,105,111,110,0,66,105,116,65,110,100,0,66,105,116,79,114,0,83,104,105,102,116,76,101,102,116,0,83,104,105,102,116,82,105,103,104,116,0,65,100,100,0,83,117,98,116,114,97,99,116,0,77,117,108,116,105,112,108,121,0,68,105,118,105,100,101,0,82,101,109,97,105,110,100,101,114,0,67,111,110,99,97,116,0,67,111,109,112,97,114,101,0,66,105,116,78,111,116,0,79,102,102,115,101,116,0,83,116,114,105,110,103,56,0,67,111,108,117,109,110,0,65,102,102,105,110,105,116,121,0,77,97,107,101,82,101,99,111,114,100,0,67,111,117,110,116,0,82,101,97,100,67,111,111,107,105,101,0,83,101,116,67,111,111,107,105,101,0,82,101,111,112,101,110,73,100,120,0,79,112,101,110,82,101,97,100,0,79,112,101,110,87,114,105,116,101,0,79,112,101,110,68,117,112,0,79,112,101,110,65,117,116,111,105,110,100,101,120,0,79,112,101,110,69,112,104,101,109,101,114,97,108,0,83,111,114,116,101,114,79,112,101,110,0,83,101,113,117,101,110,99,101,84,101,115,116,0,79,112,101,110,80,115,101,117,100,111,0,67,108,111,115,101,0,67,111,108,117,109,110,115,85,115,101,100,0,83,101,113,117,101,110,99,101,0,78,101,119,82,111,119,105,100,0,73,110,115,101,114,116,0,73,110,115,101,114,116,73,110,116,0,68,101,108,101,116,101,0,82,101,115,101,116,67,111,117,110,116,0,83,111,114,116,101,114,67,111,109,112,97,114,101,0,83,111,114,116,101,114,68,97,116,97,0,82,111,119,68,97,116,97,0,82,111,119,105,100,0,78,117,108,108,82,111,119,0,83,101,101,107,69,110,100,0,83,111,114,116,101,114,73,110,115,101,114,116,0,73,100,120,73,110,115,101,114,116,0,73,100,120,68,101,108,101,116,101,0,68,101,102,101,114,114,101,100,83,101,101,107,0,73,100,120,82,111,119,105,100,0,82,101,97,108,0,68,101,115,116,114,111,121,0,67,108,101,97,114,0,82,101,115,101,116,83,111,114,116,101,114,0,67,114,101,97,116,101,66,116,114,101,101,0,83,113,108,69,120,101,99,0,80,97,114,115,101,83,99,104,101,109,97,0,76,111,97,100,65,110,97,108,121,115,105,115,0,68,114,111,112,84,97,98,108,101,0,68,114,111,112,73,110,100,101,120,0,68,114,111,112,84,114,105,103,103,101,114,0,73,110,116,101,103,114,105,116,121,67,107,0,82,111,119,83,101,116,65,100,100,0,80,97,114,97,109,0,70,107,67,111,117,110,116,101,114,0,77,101,109,77,97,120,0,79,102,102,115,101,116,76,105,109,105,116,0,65,103,103,83,116,101,112,48,0,65,103,103,83,116,101,112,0,65,103,103,70,105,110,97,108,0,69,120,112,105,114,101,0,84,97,98,108,101,76,111,99,107,0,86,66,101,103,105,110,0,86,67,114,101,97,116,101,0,86,68,101,115,116,114,111,121,0,86,79,112,101,110,0,86,67,111,108,117,109,110,0,86,82,101,110,97,109,101,0,80,97,103,101,99,111,117,110,116,0,77,97,120,80,103,99,110,116,0,80,117,114,101,70,117,110,99,48,0,70,117,110,99,116,105,111,110,48,0,80,117,114,101,70,117,110,99,0,70,117,110,99,116,105,111,110,0,84,114,97,99,101,0,67,117,114,115,111,114,72,105,110,116,0,78,111,111,112,0,69,120,112,108,97,105,110,0,115,113,108,105,116,101,51,95,103,101,116,95,116,97,98,108,101,40,41,32,99,97,108,108,101,100,32,119,105,116,104,32,116,119,111,32,111,114,32,109,111,114,101,32,105,110,99,111,109,112,97,116,105,98,108,101,32,113,117,101,114,105,101,115,0,99,114,101,97,116,101,0,116,101,109,112,111,114,97,114,121,0,101,110,100,0,101,120,112,108,97,105,110,0,1,0,2,3,4,2,2,2,1,1,2,3,4,2,2,2,1,2,2,2,2,2,2,2,1,3,3,2,4,2,2,2,1,4,2,2,2,4,5,2,6,5,5,5,5,5,5,5,6,6,5,5,5,5,5,7,1,7,5,5,5,5,5,5,106,117,108,105,97,110,100,97,121,0,100,97,116,101,0,116,105,109,101,0,100,97,116,101,116,105,109,101,0,115,116,114,102,116,105,109,101,0,99,117,114,114,101,110,116,95,116,105,109,101,0,99,117,114,114,101,110,116,95,116,105,109,101,115,116,97,109,112,0,99,117,114,114,101,110,116,95,100,97,116,101,0,37,48,50,100,0,37,48,54,46,51,102,0,37,48,51,100,0,37,48,52,100,0,108,111,99,97,108,116,105,109,101,0,117,110,105,120,101,112,111,99,104,0,117,116,99,0,119,101,101,107,100,97,121,32,0,115,116,97,114,116,32,111,102,32,0,109,111,110,116,104,0,121,101,97,114,0,100,97,121,0,115,101,99,111,110,100,0,109,105,110,117,116,101,0,104,111,117,114,0,50,48,99,58,50,48,101,0,50,48,101,0,50,48,98,58,50,48,101,0,108,111,99,97,108,32,116,105,109,101,32,117,110,97,118,97,105,108,97,98,108,101,0,110,111,110,45,100,101,116,101,114,109,105,110,105,115,116,105,99,32,102,117,110,99,116,105,111,110,32,105,110,32,105,110,100,101,120,32,101,120,112,114,101,115,115,105,111,110,32,111,114,32,67,72,69,67,75,32,99,111,110,115,116,114,97,105,110,116,0,110,111,119,0,52,48,102,45,50,49,97,45,50,49,100,0,37,48,52,100,45,37,48,50,100,45,37,48,50,100,32,37,48,50,100,58,37,48,50,100,58,37,48,50,100,0,37,48,50,100,58,37,48,50,100,58,37,48,50,100,0,37,48,52,100,45,37,48,50,100,45,37,48,50,100,0,115,113,108,105,116,101,95,114,101,110,97,109,101,95,116,97,98,108,101,0,115,113,108,105,116,101,95,114,101,110,97,109,101,95,116,114,105,103,103,101,114,0,115,113,108,105,116,101,95,114,101,110,97,109,101,95,112,97,114,101,110,116,0,37,115,37,46,42,115,34,37,119,34,0,37,46,42,115,34,37,119,34,37,115,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,47,112,114,111,99,47,115,101,108,102,47,102,100,47,0], "i8", ALLOC_NONE, GLOBAL_BASE);





/* no memory initializer */
var tempDoublePtr = STATICTOP; STATICTOP += 16;

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}

// {{PRE_LIBRARY}}


  function ___assert_fail(condition, filename, line, func) {
      abort('Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function']);
    }

  
  var ENV={};function ___buildEnvironment(environ) {
      // WARNING: Arbitrary limit!
      var MAX_ENV_VALUES = 64;
      var TOTAL_ENV_SIZE = 1024;
  
      // Statically allocate memory for the environment.
      var poolPtr;
      var envPtr;
      if (!___buildEnvironment.called) {
        ___buildEnvironment.called = true;
        // Set default values. Use string keys for Closure Compiler compatibility.
        ENV['USER'] = ENV['LOGNAME'] = 'web_user';
        ENV['PATH'] = '/';
        ENV['PWD'] = '/';
        ENV['HOME'] = '/home/web_user';
        ENV['LANG'] = 'C.UTF-8';
        ENV['_'] = Module['thisProgram'];
        // Allocate memory.
        poolPtr = getMemory(TOTAL_ENV_SIZE);
        envPtr = getMemory(MAX_ENV_VALUES * 4);
        HEAP32[((envPtr)>>2)]=poolPtr;
        HEAP32[((environ)>>2)]=envPtr;
      } else {
        envPtr = HEAP32[((environ)>>2)];
        poolPtr = HEAP32[((envPtr)>>2)];
      }
  
      // Collect key=value lines.
      var strings = [];
      var totalSize = 0;
      for (var key in ENV) {
        if (typeof ENV[key] === 'string') {
          var line = key + '=' + ENV[key];
          strings.push(line);
          totalSize += line.length;
        }
      }
      if (totalSize > TOTAL_ENV_SIZE) {
        throw new Error('Environment size exceeded TOTAL_ENV_SIZE!');
      }
  
      // Make new.
      var ptrSize = 4;
      for (var i = 0; i < strings.length; i++) {
        var line = strings[i];
        writeAsciiToMemory(line, poolPtr);
        HEAP32[(((envPtr)+(i * ptrSize))>>2)]=poolPtr;
        poolPtr += line.length + 1;
      }
      HEAP32[(((envPtr)+(strings.length * ptrSize))>>2)]=0;
    }

  
  
   
  
   
  
     

  function ___lock() {}

  
    

   

  
  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  function ___setErrNo(value) {
      if (Module['___errno_location']) HEAP32[((Module['___errno_location']())>>2)]=value;
      else Module.printErr('failed to set errno from JS');
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up; up--) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            return ''; // an invalid portion invalidates the whole thing
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          stream.tty.ops.flush(stream.tty);
        },flush:function (stream) {
          stream.tty.ops.flush(stream.tty);
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              // we will read data by chunks of BUFSIZE
              var BUFSIZE = 256;
              var buf = new Buffer(BUFSIZE);
              var bytesRead = 0;
  
              var isPosixPlatform = (process.platform != 'win32'); // Node doesn't offer a direct check, so test by exclusion
  
              var fd = process.stdin.fd;
              if (isPosixPlatform) {
                // Linux and Mac cannot use process.stdin.fd (which isn't set up as sync)
                var usingDevice = false;
                try {
                  fd = fs.openSync('/dev/stdin', 'r');
                  usingDevice = true;
                } catch (e) {}
              }
  
              try {
                bytesRead = fs.readSync(fd, buf, 0, BUFSIZE, null);
              } catch(e) {
                // Cross-platform differences: on Windows, reading EOF throws an exception, but on other OSes,
                // reading EOF returns 0. Uniformize behavior by treating the EOF exception to return 0.
                if (e.toString().indexOf('EOF') != -1) bytesRead = 0;
                else throw e;
              }
  
              if (usingDevice) { fs.closeSync(fd); }
              if (bytesRead > 0) {
                result = buf.slice(0, bytesRead).toString('utf-8');
              } else {
                result = null;
              }
  
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](UTF8ArrayToString(tty.output, 0));
            tty.output = [];
          } else {
            if (val != 0) tty.output.push(val); // val == 0 would cut text output off in the middle.
          }
        },flush:function (tty) {
          if (tty.output && tty.output.length > 0) {
            Module['print'](UTF8ArrayToString(tty.output, 0));
            tty.output = [];
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](UTF8ArrayToString(tty.output, 0));
            tty.output = [];
          } else {
            if (val != 0) tty.output.push(val);
          }
        },flush:function (tty) {
          if (tty.output && tty.output.length > 0) {
            Module['printErr'](UTF8ArrayToString(tty.output, 0));
            tty.output = [];
          }
        }}};
  
  var MEMFS={ops_table:null,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap,
                msync: MEMFS.stream_ops.msync
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            }
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.usedBytes = 0; // The actual number of bytes used in the typed array, as opposed to contents.length which gives the whole capacity.
          // When the byte data of the file is populated, this will point to either a typed array, or a normal JS array. Typed arrays are preferred
          // for performance, and used by default. However, typed arrays are not resizable like normal JS arrays are, so there is a small disk size
          // penalty involved for appending file writes that continuously grow a file similar to std::vector capacity vs used -scheme.
          node.contents = null; 
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },getFileDataAsRegularArray:function (node) {
        if (node.contents && node.contents.subarray) {
          var arr = [];
          for (var i = 0; i < node.usedBytes; ++i) arr.push(node.contents[i]);
          return arr; // Returns a copy of the original data.
        }
        return node.contents; // No-op, the file contents are already in a JS array. Return as-is.
      },getFileDataAsTypedArray:function (node) {
        if (!node.contents) return new Uint8Array;
        if (node.contents.subarray) return node.contents.subarray(0, node.usedBytes); // Make sure to not return excess unused bytes.
        return new Uint8Array(node.contents);
      },expandFileStorage:function (node, newCapacity) {
        // If we are asked to expand the size of a file that already exists, revert to using a standard JS array to store the file
        // instead of a typed array. This makes resizing the array more flexible because we can just .push() elements at the back to
        // increase the size.
        if (node.contents && node.contents.subarray && newCapacity > node.contents.length) {
          node.contents = MEMFS.getFileDataAsRegularArray(node);
          node.usedBytes = node.contents.length; // We might be writing to a lazy-loaded file which had overridden this property, so force-reset it.
        }
  
        if (!node.contents || node.contents.subarray) { // Keep using a typed array if creating a new storage, or if old one was a typed array as well.
          var prevCapacity = node.contents ? node.contents.length : 0;
          if (prevCapacity >= newCapacity) return; // No need to expand, the storage was already large enough.
          // Don't expand strictly to the given requested limit if it's only a very small increase, but instead geometrically grow capacity.
          // For small filesizes (<1MB), perform size*2 geometric increase, but for large sizes, do a much more conservative size*1.125 increase to
          // avoid overshooting the allocation cap by a very large margin.
          var CAPACITY_DOUBLING_MAX = 1024 * 1024;
          newCapacity = Math.max(newCapacity, (prevCapacity * (prevCapacity < CAPACITY_DOUBLING_MAX ? 2.0 : 1.125)) | 0);
          if (prevCapacity != 0) newCapacity = Math.max(newCapacity, 256); // At minimum allocate 256b for each file when expanding.
          var oldContents = node.contents;
          node.contents = new Uint8Array(newCapacity); // Allocate new storage.
          if (node.usedBytes > 0) node.contents.set(oldContents.subarray(0, node.usedBytes), 0); // Copy old data over to the new storage.
          return;
        }
        // Not using a typed array to back the file storage. Use a standard JS array instead.
        if (!node.contents && newCapacity > 0) node.contents = [];
        while (node.contents.length < newCapacity) node.contents.push(0);
      },resizeFileStorage:function (node, newSize) {
        if (node.usedBytes == newSize) return;
        if (newSize == 0) {
          node.contents = null; // Fully decommit when requesting a resize to zero.
          node.usedBytes = 0;
          return;
        }
        if (!node.contents || node.contents.subarray) { // Resize a typed array if that is being used as the backing store.
          var oldContents = node.contents;
          node.contents = new Uint8Array(new ArrayBuffer(newSize)); // Allocate new storage.
          if (oldContents) {
            node.contents.set(oldContents.subarray(0, Math.min(newSize, node.usedBytes))); // Copy old data over to the new storage.
          }
          node.usedBytes = newSize;
          return;
        }
        // Backing with a JS array.
        if (!node.contents) node.contents = [];
        if (node.contents.length > newSize) node.contents.length = newSize;
        else while (node.contents.length < newSize) node.contents.push(0);
        node.usedBytes = newSize;
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.usedBytes;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.resizeFileStorage(node, attr.size);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= stream.node.usedBytes) return 0;
          var size = Math.min(stream.node.usedBytes - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else {
            for (var i = 0; i < size; i++) buffer[offset + i] = contents[position + i];
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          if (!length) return 0;
          var node = stream.node;
          node.timestamp = Date.now();
  
          if (buffer.subarray && (!node.contents || node.contents.subarray)) { // This write is from a typed array to a typed array?
            if (canOwn) {
              assert(position === 0, 'canOwn must imply no weird position inside the file');
              node.contents = buffer.subarray(offset, offset + length);
              node.usedBytes = length;
              return length;
            } else if (node.usedBytes === 0 && position === 0) { // If this is a simple first write to an empty file, do a fast set since we don't need to care about old data.
              node.contents = new Uint8Array(buffer.subarray(offset, offset + length));
              node.usedBytes = length;
              return length;
            } else if (position + length <= node.usedBytes) { // Writing to an already allocated and used subrange of the file?
              node.contents.set(buffer.subarray(offset, offset + length), position);
              return length;
            }
          }
  
          // Appending to an existing file and we need to reallocate, or source data did not come as a typed array.
          MEMFS.expandFileStorage(node, position+length);
          if (node.contents.subarray && buffer.subarray) node.contents.set(buffer.subarray(offset, offset + length), position); // Use typed array write if available.
          else {
            for (var i = 0; i < length; i++) {
             node.contents[position + i] = buffer[offset + i]; // Or fall back to manual write if not.
            }
          }
          node.usedBytes = Math.max(node.usedBytes, position+length);
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.usedBytes;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.expandFileStorage(stream.node, offset + length);
          stream.node.usedBytes = Math.max(stream.node.usedBytes, offset + length);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < stream.node.usedBytes) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        },msync:function (stream, buffer, offset, length, mmapFlags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          if (mmapFlags & 2) {
            // MAP_PRIVATE calls need not to be synced back to underlying fs
            return 0;
          }
  
          var bytesWritten = MEMFS.stream_ops.write(stream, buffer, 0, length, offset, false);
          // should we check if bytesWritten and length are the same?
          return 0;
        }}};
  
  var _stdin=STATICTOP; STATICTOP += 16;;
  
  var _stdout=STATICTOP; STATICTOP += 16;;
  
  var _stderr=STATICTOP; STATICTOP += 16;;var FS={root:null,mounts:[],devices:{},streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        if (!path) return { path: '', node: null };
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
  
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err, parent);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); }
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); }
            }
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var perms = ['r', 'w', 'rw'][flag & 3];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        var err = FS.nodePermissions(dir, 'x');
        if (err) return err;
        if (!dir.node_ops.lookup) return ERRNO_CODES.EACCES;
        return 0;
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if (FS.flagsToPermissionString(flags) !== 'r' || // opening for write
              (flags & 512)) { // TODO: check for O_SEARCH? (== search for dir only)
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        // clone it, so we can return an instance of FSStream
        var newStream = new FS.FSStream();
        for (var p in stream) {
          newStream[p] = stream[p];
        }
        stream = newStream;
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        FS.syncFSRequests++;
  
        if (FS.syncFSRequests > 1) {
          console.log('warning: ' + FS.syncFSRequests + ' FS.syncfs operations in flight at once, probably just doing extra work');
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function doCallback(err) {
          assert(FS.syncFSRequests > 0);
          FS.syncFSRequests--;
          return callback(err);
        }
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return doCallback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            doCallback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        if (!name || name === '.' || name === '..') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdirTree:function (path, mode) {
        var dirs = path.split('/');
        var d = '';
        for (var i = 0; i < dirs.length; ++i) {
          if (!dirs[i]) continue;
          d += '/' + dirs[i];
          try {
            FS.mkdir(d, mode);
          } catch(e) {
            if (e.errno != ERRNO_CODES.EEXIST) throw e;
          }
        }
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        if (!PATH.resolve(oldpath)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        if (!parent) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        if (!old_dir || !new_dir) throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        try {
          if (FS.trackingDelegate['willMovePath']) {
            FS.trackingDelegate['willMovePath'](old_path, new_path);
          }
        } catch(e) {
          console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: " + e.message);
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
        try {
          if (FS.trackingDelegate['onMovePath']) FS.trackingDelegate['onMovePath'](old_path, new_path);
        } catch(e) {
          console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: " + e.message);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        try {
          if (FS.trackingDelegate['willDeletePath']) {
            FS.trackingDelegate['willDeletePath'](path);
          }
        } catch(e) {
          console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: " + e.message);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
        try {
          if (FS.trackingDelegate['onDeletePath']) FS.trackingDelegate['onDeletePath'](path);
        } catch(e) {
          console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: " + e.message);
        }
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // According to POSIX, we should map EISDIR to EPERM, but
          // we instead do what Linux does (and we must, as we use
          // the musl linux libc).
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        try {
          if (FS.trackingDelegate['willDeletePath']) {
            FS.trackingDelegate['willDeletePath'](path);
          }
        } catch(e) {
          console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: " + e.message);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
        try {
          if (FS.trackingDelegate['onDeletePath']) FS.trackingDelegate['onDeletePath'](path);
        } catch(e) {
          console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: " + e.message);
        }
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return PATH.resolve(FS.getPath(link.parent), link.node_ops.readlink(link));
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        if (path === "") {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        var created = false;
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
            created = true;
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // if asked only for a directory, then this must be one
        if ((flags & 65536) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        // check permissions, if this is not a file we just created now (it is ok to
        // create and write to a file with read-only permissions; it is read-only
        // for later use)
        if (!created) {
          var err = FS.mayOpen(node, flags);
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        try {
          if (FS.trackingDelegate['onOpenFile']) {
            var trackingFlags = 0;
            if ((flags & 2097155) !== 1) {
              trackingFlags |= FS.tracking.openFlags.READ;
            }
            if ((flags & 2097155) !== 0) {
              trackingFlags |= FS.tracking.openFlags.WRITE;
            }
            FS.trackingDelegate['onOpenFile'](path, trackingFlags);
          }
        } catch(e) {
          console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: " + e.message);
        }
        return stream;
      },close:function (stream) {
        if (FS.isClosed(stream)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (stream.getdents) stream.getdents = null; // free readdir state
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
        stream.fd = null;
      },isClosed:function (stream) {
        return stream.fd === null;
      },llseek:function (stream, offset, whence) {
        if (FS.isClosed(stream)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        stream.position = stream.stream_ops.llseek(stream, offset, whence);
        stream.ungotten = [];
        return stream.position;
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if (FS.isClosed(stream)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = typeof position !== 'undefined';
        if (!seeking) {
          position = stream.position;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if (FS.isClosed(stream)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var seeking = typeof position !== 'undefined';
        if (!seeking) {
          position = stream.position;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        try {
          if (stream.path && FS.trackingDelegate['onWriteToFile']) FS.trackingDelegate['onWriteToFile'](stream.path);
        } catch(e) {
          console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: " + e.message);
        }
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (FS.isClosed(stream)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },msync:function (stream, buffer, offset, length, mmapFlags) {
        if (!stream || !stream.stream_ops.msync) {
          return 0;
        }
        return stream.stream_ops.msync(stream, buffer, offset, length, mmapFlags);
      },munmap:function (stream) {
        return 0;
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = UTF8ArrayToString(buf, 0);
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        var stream = FS.open(path, opts.flags, opts.mode);
        if (typeof data === 'string') {
          var buf = new Uint8Array(lengthBytesUTF8(data)+1);
          var actualNumBytes = stringToUTF8Array(data, buf, 0, buf.length);
          FS.write(stream, buf, 0, actualNumBytes, undefined, opts.canOwn);
        } else if (ArrayBuffer.isView(data)) {
          FS.write(stream, data, 0, data.byteLength, undefined, opts.canOwn);
        } else {
          throw new Error('Unsupported data type');
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (lookup.node === null) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
        FS.mkdir('/home');
        FS.mkdir('/home/web_user');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function(stream, buffer, offset, length, pos) { return length; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // setup /dev/[u]random
        var random_device;
        if (typeof crypto !== 'undefined') {
          // for modern web browsers
          var randomBuffer = new Uint8Array(1);
          random_device = function() { crypto.getRandomValues(randomBuffer); return randomBuffer[0]; };
        } else if (ENVIRONMENT_IS_NODE) {
          // for nodejs
          random_device = function() { return require('crypto')['randomBytes'](1)[0]; };
        } else {
          // default for ES5 platforms
          random_device = function() { return (Math.random()*256)|0; };
        }
        FS.createDevice('/dev', 'random', random_device);
        FS.createDevice('/dev', 'urandom', random_device);
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createSpecialDirectories:function () {
        // create /proc/self/fd which allows /proc/self/fd/6 => readlink gives the name of the stream for fd 6 (see test_unistd_ttyname)
        FS.mkdir('/proc');
        FS.mkdir('/proc/self');
        FS.mkdir('/proc/self/fd');
        FS.mount({
          mount: function() {
            var node = FS.createNode('/proc/self', 'fd', 16384 | 511 /* 0777 */, 73);
            node.node_ops = {
              lookup: function(parent, name) {
                var fd = +name;
                var stream = FS.getStream(fd);
                if (!stream) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
                var ret = {
                  parent: null,
                  mount: { mountpoint: 'fake' },
                  node_ops: { readlink: function() { return stream.path } }
                };
                ret.parent = ret; // make it look like a simple root node
                return ret;
              }
            };
            return node;
          }
        }, {}, '/proc/self/fd');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno, node) {
          //Module.printErr(stackTrace()); // useful for debugging
          this.node = node;
          this.setErrno = function(errno) {
            this.errno = errno;
            for (var key in ERRNO_CODES) {
              if (ERRNO_CODES[key] === errno) {
                this.code = key;
                break;
              }
            }
          };
          this.setErrno(errno);
          this.message = ERRNO_MESSAGES[errno];
          // Node.js compatibility: assigning on this.stack fails on Node 4 (but fixed on Node 8)
          if (this.stack) Object.defineProperty(this, "stack", { value: (new Error).stack, writable: true });
          if (this.stack) this.stack = demangleAll(this.stack);
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
        FS.createSpecialDirectories();
  
        FS.filesystems = {
          'MEMFS': MEMFS,
        };
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        // force-flush all streams, so we get musl std streams printed out
        var fflush = Module['_fflush'];
        if (fflush) fflush(0);
        // close all of our streams
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
            obj.usedBytes = obj.contents.length;
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
        function LazyUint8Array() {
          this.lengthKnown = false;
          this.chunks = []; // Loaded chunks. Index is the chunk number
        }
        LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
          if (idx > this.length-1 || idx < 0) {
            return undefined;
          }
          var chunkOffset = idx % this.chunkSize;
          var chunkNum = (idx / this.chunkSize)|0;
          return this.getter(chunkNum)[chunkOffset];
        }
        LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
          this.getter = getter;
        }
        LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
          // Find length
          var xhr = new XMLHttpRequest();
          xhr.open('HEAD', url, false);
          xhr.send(null);
          if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
          var datalength = Number(xhr.getResponseHeader("Content-length"));
          var header;
          var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
          var usesGzip = (header = xhr.getResponseHeader("Content-Encoding")) && header === "gzip";
  
          var chunkSize = 1024*1024; // Chunk size in bytes
  
          if (!hasByteServing) chunkSize = datalength;
  
          // Function to get a range from the remote URL.
          var doXHR = (function(from, to) {
            if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
            if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
            // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
            var xhr = new XMLHttpRequest();
            xhr.open('GET', url, false);
            if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
            // Some hints to the browser that we want binary data.
            if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
            if (xhr.overrideMimeType) {
              xhr.overrideMimeType('text/plain; charset=x-user-defined');
            }
  
            xhr.send(null);
            if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
            if (xhr.response !== undefined) {
              return new Uint8Array(xhr.response || []);
            } else {
              return intArrayFromString(xhr.responseText || '', true);
            }
          });
          var lazyArray = this;
          lazyArray.setDataGetter(function(chunkNum) {
            var start = chunkNum * chunkSize;
            var end = (chunkNum+1) * chunkSize - 1; // including this byte
            end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
            if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
              lazyArray.chunks[chunkNum] = doXHR(start, end);
            }
            if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
            return lazyArray.chunks[chunkNum];
          });
  
          if (usesGzip || !datalength) {
            // if the server uses gzip or doesn't supply the length, we have to download the whole file to get the (uncompressed) length
            chunkSize = datalength = 1; // this will force getter(0)/doXHR do download the whole file
            datalength = this.getter(0).length;
            chunkSize = datalength;
            console.log("LazyFiles on gzip forces download of the whole file when length is accessed");
          }
  
          this._length = datalength;
          this._chunkSize = chunkSize;
          this.lengthKnown = true;
        }
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          var lazyArray = new LazyUint8Array();
          Object.defineProperties(lazyArray, {
            length: {
              get: function() {
                if(!this.lengthKnown) {
                  this.cacheLength();
                }
                return this._length;
              }
            },
            chunkSize: {
              get: function() {
                if(!this.lengthKnown) {
                  this.cacheLength();
                }
                return this._chunkSize;
              }
            }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // Add a function that defers querying the file size until it is asked the first time.
        Object.defineProperties(node, {
          usedBytes: {
            get: function() { return this.contents.length; }
          }
        });
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn, preFinish) {
        Browser.init(); // XXX perhaps this method should move onto Browser?
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        var dep = getUniqueRunDependency('cp ' + fullname); // might have several active requests for the same fullname
        function processData(byteArray) {
          function finish(byteArray) {
            if (preFinish) preFinish();
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency(dep);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency(dep);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency(dep);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:function (dirfd, path) {
        if (path[0] !== '/') {
          // relative path
          var dir;
          if (dirfd === -100) {
            dir = FS.cwd();
          } else {
            var dirstream = FS.getStream(dirfd);
            if (!dirstream) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
            dir = dirstream.path;
          }
          path = PATH.join2(dir, path);
        }
        return path;
      },doStat:function (func, path, buf) {
        try {
          var stat = func(path);
        } catch (e) {
          if (e && e.node && PATH.normalize(path) !== PATH.normalize(FS.getPath(e.node))) {
            // an error occurred while trying to look up the path; we should just report ENOTDIR
            return -ERRNO_CODES.ENOTDIR;
          }
          throw e;
        }
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=(stat.atime.getTime() / 1000)|0;
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=(stat.mtime.getTime() / 1000)|0;
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=(stat.ctime.getTime() / 1000)|0;
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      },doMsync:function (addr, stream, len, flags) {
        var buffer = new Uint8Array(HEAPU8.subarray(addr, addr + len));
        FS.msync(stream, buffer, 0, len, flags);
      },doMkdir:function (path, mode) {
        // remove a trailing slash, if one - /a/b/ has basename of '', but
        // we want to create b in the context of this function
        path = PATH.normalize(path);
        if (path[path.length-1] === '/') path = path.substr(0, path.length-1);
        FS.mkdir(path, mode, 0);
        return 0;
      },doMknod:function (path, mode, dev) {
        // we don't want this in the JS API as it uses mknod to create all nodes.
        switch (mode & 61440) {
          case 32768:
          case 8192:
          case 24576:
          case 4096:
          case 49152:
            break;
          default: return -ERRNO_CODES.EINVAL;
        }
        FS.mknod(path, mode, dev);
        return 0;
      },doReadlink:function (path, buf, bufsize) {
        if (bufsize <= 0) return -ERRNO_CODES.EINVAL;
        var ret = FS.readlink(path);
  
        var len = Math.min(bufsize, lengthBytesUTF8(ret));
        var endChar = HEAP8[buf+len];
        stringToUTF8(ret, buf, bufsize+1);
        // readlink is one of the rare functions that write out a C string, but does never append a null to the output buffer(!)
        // stringToUTF8() always appends a null byte, so restore the character under the null byte after the write.
        HEAP8[buf+len] = endChar;
  
        return len;
      },doAccess:function (path, amode) {
        if (amode & ~7) {
          // need a valid mode
          return -ERRNO_CODES.EINVAL;
        }
        var node;
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
        var perms = '';
        if (amode & 4) perms += 'r';
        if (amode & 2) perms += 'w';
        if (amode & 1) perms += 'x';
        if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
          return -ERRNO_CODES.EACCES;
        }
        return 0;
      },doDup:function (path, flags, suggestFD) {
        var suggest = FS.getStream(suggestFD);
        if (suggest) FS.close(suggest);
        return FS.open(path, flags, 0, suggestFD, suggestFD).fd;
      },doReadv:function (stream, iov, iovcnt, offset) {
        var ret = 0;
        for (var i = 0; i < iovcnt; i++) {
          var ptr = HEAP32[(((iov)+(i*8))>>2)];
          var len = HEAP32[(((iov)+(i*8 + 4))>>2)];
          var curr = FS.read(stream, HEAP8,ptr, len, offset);
          if (curr < 0) return -1;
          ret += curr;
          if (curr < len) break; // nothing more to read
        }
        return ret;
      },doWritev:function (stream, iov, iovcnt, offset) {
        var ret = 0;
        for (var i = 0; i < iovcnt; i++) {
          var ptr = HEAP32[(((iov)+(i*8))>>2)];
          var len = HEAP32[(((iov)+(i*8 + 4))>>2)];
          var curr = FS.write(stream, HEAP8,ptr, len, offset);
          if (curr < 0) return -1;
          ret += curr;
        }
        return ret;
      },varargs:0,get:function (varargs) {
        SYSCALLS.varargs += 4;
        var ret = HEAP32[(((SYSCALLS.varargs)-(4))>>2)];
        return ret;
      },getStr:function () {
        var ret = Pointer_stringify(SYSCALLS.get());
        return ret;
      },getStreamFromFD:function () {
        var stream = FS.getStream(SYSCALLS.get());
        if (!stream) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        return stream;
      },getSocketFromFD:function () {
        var socket = SOCKFS.getSocket(SYSCALLS.get());
        if (!socket) throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        return socket;
      },getSocketAddress:function (allowNull) {
        var addrp = SYSCALLS.get(), addrlen = SYSCALLS.get();
        if (allowNull && addrp === 0) return null;
        var info = __read_sockaddr(addrp, addrlen);
        if (info.errno) throw new FS.ErrnoError(info.errno);
        info.addr = DNS.lookup_addr(info.addr) || info.addr;
        return info;
      },get64:function () {
        var low = SYSCALLS.get(), high = SYSCALLS.get();
        if (low >= 0) assert(high === 0);
        else assert(high === -1);
        return low;
      },getZero:function () {
        assert(SYSCALLS.get() === 0);
      }};function ___syscall10(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // unlink
      var path = SYSCALLS.getStr();
      FS.unlink(path);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall118(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // fsync
      var stream = SYSCALLS.getStreamFromFD();
      return 0; // we can't do anything synchronously; the in-memory FS is already synced to
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall140(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // llseek
      var stream = SYSCALLS.getStreamFromFD(), offset_high = SYSCALLS.get(), offset_low = SYSCALLS.get(), result = SYSCALLS.get(), whence = SYSCALLS.get();
      // NOTE: offset_high is unused - Emscripten's off_t is 32-bit
      var offset = offset_low;
      FS.llseek(stream, offset, whence);
      HEAP32[((result)>>2)]=stream.position;
      if (stream.getdents && offset === 0 && whence === 0) stream.getdents = null; // reset readdir state
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall146(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // writev
      var stream = SYSCALLS.getStreamFromFD(), iov = SYSCALLS.get(), iovcnt = SYSCALLS.get();
      return SYSCALLS.doWritev(stream, iov, iovcnt);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall15(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // chmod
      var path = SYSCALLS.getStr(), mode = SYSCALLS.get();
      FS.chmod(path, mode);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall183(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // getcwd
      var buf = SYSCALLS.get(), size = SYSCALLS.get();
      if (size === 0) return -ERRNO_CODES.EINVAL;
      var cwd = FS.cwd();
      var cwdLengthInBytes = lengthBytesUTF8(cwd);
      if (size < cwdLengthInBytes + 1) return -ERRNO_CODES.ERANGE;
      stringToUTF8(cwd, buf, size);
      return buf;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall192(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // mmap2
      var addr = SYSCALLS.get(), len = SYSCALLS.get(), prot = SYSCALLS.get(), flags = SYSCALLS.get(), fd = SYSCALLS.get(), off = SYSCALLS.get()
      off <<= 12; // undo pgoffset
      var ptr;
      var allocated = false;
      if (fd === -1) {
        ptr = _memalign(PAGE_SIZE, len);
        if (!ptr) return -ERRNO_CODES.ENOMEM;
        _memset(ptr, 0, len);
        allocated = true;
      } else {
        var info = FS.getStream(fd);
        if (!info) return -ERRNO_CODES.EBADF;
        var res = FS.mmap(info, HEAPU8, addr, len, off, prot, flags);
        ptr = res.ptr;
        allocated = res.allocated;
      }
      SYSCALLS.mappings[ptr] = { malloc: ptr, len: len, allocated: allocated, fd: fd, flags: flags };
      return ptr;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall194(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // ftruncate64
      var fd = SYSCALLS.get(), zero = SYSCALLS.getZero(), length = SYSCALLS.get64();
      FS.ftruncate(fd, length);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall195(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // SYS_stat64
      var path = SYSCALLS.getStr(), buf = SYSCALLS.get();
      return SYSCALLS.doStat(FS.stat, path, buf);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall196(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // SYS_lstat64
      var path = SYSCALLS.getStr(), buf = SYSCALLS.get();
      return SYSCALLS.doStat(FS.lstat, path, buf);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall197(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // SYS_fstat64
      var stream = SYSCALLS.getStreamFromFD(), buf = SYSCALLS.get();
      return SYSCALLS.doStat(FS.stat, stream.path, buf);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  
  var PROCINFO={ppid:1,pid:42,sid:42,pgid:42};function ___syscall20(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // getpid
      return PROCINFO.pid;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  
  function ___syscall202(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // getgid32
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }function ___syscall201() {
  return ___syscall202.apply(null, arguments)
  }

  function ___syscall207(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // fchown32
      var fd = SYSCALLS.get(), owner = SYSCALLS.get(), group = SYSCALLS.get();
      FS.fchown(fd, owner, group);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall212(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // chown32
      var path = SYSCALLS.getStr(), owner = SYSCALLS.get(), group = SYSCALLS.get();
      FS.chown(path, owner, group);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall221(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // fcntl64
      var stream = SYSCALLS.getStreamFromFD(), cmd = SYSCALLS.get();
      switch (cmd) {
        case 0: {
          var arg = SYSCALLS.get();
          if (arg < 0) {
            return -ERRNO_CODES.EINVAL;
          }
          var newStream;
          newStream = FS.open(stream.path, stream.flags, 0, arg);
          return newStream.fd;
        }
        case 1:
        case 2:
          return 0;  // FD_CLOEXEC makes no sense for a single process.
        case 3:
          return stream.flags;
        case 4: {
          var arg = SYSCALLS.get();
          stream.flags |= arg;
          return 0;
        }
        case 12:
        case 12: {
          var arg = SYSCALLS.get();
          var offset = 0;
          // We're always unlocked.
          HEAP16[(((arg)+(offset))>>1)]=2;
          return 0;
        }
        case 13:
        case 14:
        case 13:
        case 14:
          return 0; // Pretend that the locking is successful.
        case 16:
        case 8:
          return -ERRNO_CODES.EINVAL; // These are for sockets. We don't have them fully implemented yet.
        case 9:
          // musl trusts getown return values, due to a bug where they must be, as they overlap with errors. just return -1 here, so fnctl() returns that, and we set errno ourselves.
          ___setErrNo(ERRNO_CODES.EINVAL);
          return -1;
        default: {
          return -ERRNO_CODES.EINVAL;
        }
      }
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall3(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // read
      var stream = SYSCALLS.getStreamFromFD(), buf = SYSCALLS.get(), count = SYSCALLS.get();
      return FS.read(stream, HEAP8,buf, count);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall33(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // access
      var path = SYSCALLS.getStr(), amode = SYSCALLS.get();
      return SYSCALLS.doAccess(path, amode);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall39(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // mkdir
      var path = SYSCALLS.getStr(), mode = SYSCALLS.get();
      return SYSCALLS.doMkdir(path, mode);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall4(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // write
      var stream = SYSCALLS.getStreamFromFD(), buf = SYSCALLS.get(), count = SYSCALLS.get();
      return FS.write(stream, HEAP8,buf, count);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall40(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // rmdir
      var path = SYSCALLS.getStr();
      FS.rmdir(path);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall5(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // open
      var pathname = SYSCALLS.getStr(), flags = SYSCALLS.get(), mode = SYSCALLS.get() // optional TODO
      var stream = FS.open(pathname, flags, mode);
      return stream.fd;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall54(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // ioctl
      var stream = SYSCALLS.getStreamFromFD(), op = SYSCALLS.get();
      switch (op) {
        case 21509:
        case 21505: {
          if (!stream.tty) return -ERRNO_CODES.ENOTTY;
          return 0;
        }
        case 21510:
        case 21511:
        case 21512:
        case 21506:
        case 21507:
        case 21508: {
          if (!stream.tty) return -ERRNO_CODES.ENOTTY;
          return 0; // no-op, not actually adjusting terminal settings
        }
        case 21519: {
          if (!stream.tty) return -ERRNO_CODES.ENOTTY;
          var argp = SYSCALLS.get();
          HEAP32[((argp)>>2)]=0;
          return 0;
        }
        case 21520: {
          if (!stream.tty) return -ERRNO_CODES.ENOTTY;
          return -ERRNO_CODES.EINVAL; // not supported
        }
        case 21531: {
          var argp = SYSCALLS.get();
          return FS.ioctl(stream, op, argp);
        }
        case 21523: {
          // TODO: in theory we should write to the winsize struct that gets
          // passed in, but for now musl doesn't read anything on it
          if (!stream.tty) return -ERRNO_CODES.ENOTTY;
          return 0;
        }
        case 21524: {
          // TODO: technically, this ioctl call should change the window size.
          // but, since emscripten doesn't have any concept of a terminal window
          // yet, we'll just silently throw it away as we do TIOCGWINSZ
          if (!stream.tty) return -ERRNO_CODES.ENOTTY;
          return 0;
        }
        default: abort('bad ioctl syscall ' + op);
      }
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall6(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // close
      var stream = SYSCALLS.getStreamFromFD();
      FS.close(stream);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall85(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // readlink
      var path = SYSCALLS.getStr(), buf = SYSCALLS.get(), bufsize = SYSCALLS.get();
      return SYSCALLS.doReadlink(path, buf, bufsize);
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall91(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // munmap
      var addr = SYSCALLS.get(), len = SYSCALLS.get();
      // TODO: support unmmap'ing parts of allocations
      var info = SYSCALLS.mappings[addr];
      if (!info) return 0;
      if (len === info.len) {
        var stream = FS.getStream(info.fd);
        SYSCALLS.doMsync(addr, stream, len, info.flags)
        FS.munmap(stream);
        SYSCALLS.mappings[addr] = null;
        if (info.allocated) {
          _free(info.malloc);
        }
      }
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall94(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // fchmod
      var fd = SYSCALLS.get(), mode = SYSCALLS.get();
      FS.fchmod(fd, mode);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

   

  function ___unlock() {}

   

  function _abort() {
      Module['abort']();
    }

   

   

   

  
  var DLFCN={error:null,errorMsg:null,loadedLibs:{},loadedLibNames:{}};function _dlclose(handle) {
      // int dlclose(void *handle);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/dlclose.html
      if (!DLFCN.loadedLibs[handle]) {
        DLFCN.errorMsg = 'Tried to dlclose() unopened handle: ' + handle;
        return 1;
      } else {
        var lib_record = DLFCN.loadedLibs[handle];
        if (--lib_record.refcount == 0) {
          if (lib_record.module.cleanups) {
            lib_record.module.cleanups.forEach(function(cleanup) { cleanup() });
          }
          delete DLFCN.loadedLibNames[lib_record.name];
          delete DLFCN.loadedLibs[handle];
        }
        return 0;
      }
    }

  function _dlerror() {
      // char *dlerror(void);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/dlerror.html
      if (DLFCN.errorMsg === null) {
        return 0;
      } else {
        if (DLFCN.error) _free(DLFCN.error);
        var msgArr = intArrayFromString(DLFCN.errorMsg);
        DLFCN.error = allocate(msgArr, 'i8', ALLOC_NORMAL);
        DLFCN.errorMsg = null;
        return DLFCN.error;
      }
    }

  function _dlopen(filename, flag) {
      abort("To use dlopen, you need to use Emscripten's linking support, see https://github.com/kripken/emscripten/wiki/Linking");
      // void *dlopen(const char *file, int mode);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/dlopen.html
      var searchpaths = [];
      if (filename === 0) {
        filename = '__self__';
      } else {
        var strfilename = Pointer_stringify(filename);
        var isValidFile = function (filename) {
          var target = FS.findObject(filename);
          return target && !target.isFolder && !target.isDevice;
        };
  
        if (isValidFile(strfilename)) {
          filename = strfilename;
        } else {
          if (ENV['LD_LIBRARY_PATH']) {
            searchpaths = ENV['LD_LIBRARY_PATH'].split(':');
          }
  
          for (var ident in searchpaths) {
            var searchfile = PATH.join2(searchpaths[ident],strfilename);
            if (isValidFile(searchfile)) {
              filename = searchfile;
              break;
            }
          }
        }
      }
  
      if (DLFCN.loadedLibNames[filename]) {
        // Already loaded; increment ref count and return.
        var handle = DLFCN.loadedLibNames[filename];
        DLFCN.loadedLibs[handle].refcount++;
        return handle;
      }
  
      if (filename === '__self__') {
        var handle = -1;
        var lib_module = Module;
      } else {
        var target = FS.findObject(filename);
        if (!target || target.isFolder || target.isDevice) {
          DLFCN.errorMsg = 'Could not find dynamic lib: ' + filename;
          return 0;
        }
        FS.forceLoadFile(target);
  
        var lib_module;
        try {
          // the shared library is a JS file, which we eval
          var lib_data = FS.readFile(filename, { encoding: 'utf8' });
          lib_module = eval(lib_data)(
            alignFunctionTables(),
            Module
          );
        } catch (e) {
          Module.printErr('Error in loading dynamic library: ' + e);
          DLFCN.errorMsg = 'Could not evaluate dynamic lib: ' + filename + '\n' + e;
          return 0;
        }
  
        // Not all browsers support Object.keys().
        var handle = 1;
        for (var key in DLFCN.loadedLibs) {
          if (DLFCN.loadedLibs.hasOwnProperty(key)) handle++;
        }
  
        // We don't care about RTLD_NOW and RTLD_LAZY.
        if (flag & 256) { // RTLD_GLOBAL
          for (var ident in lib_module) {
            if (lib_module.hasOwnProperty(ident)) {
              // When RTLD_GLOBAL is enable, the symbols defined by this shared object will be made
              // available for symbol resolution of subsequently loaded shared objects.
              //
              // We should copy the symbols (which include methods and variables) from SIDE_MODULE to MAIN_MODULE.
              //
              // Module of SIDE_MODULE has not only the symbols (which should be copied)
              // but also others (print*, asmGlobal*, FUNCTION_TABLE_**, NAMED_GLOBALS, and so on).
              //
              // When the symbol (which should be copied) is method, Module._* 's type becomes function.
              // When the symbol (which should be copied) is variable, Module._* 's type becomes number.
              //
              // Except for the symbol prefix (_), there is no difference in the symbols (which should be copied) and others.
              // So this just copies over compiled symbols (which start with _).
              if (ident[0] == '_') {
                Module[ident] = lib_module[ident];
              }
            }
          }
        }
      }
      DLFCN.loadedLibs[handle] = {
        refcount: 1,
        name: filename,
        module: lib_module
      };
      DLFCN.loadedLibNames[filename] = handle;
  
      return handle;
    }

  function _dlsym(handle, symbol) {
      // void *dlsym(void *restrict handle, const char *restrict name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/dlsym.html
      symbol = Pointer_stringify(symbol);
  
      if (!DLFCN.loadedLibs[handle]) {
        DLFCN.errorMsg = 'Tried to dlsym() from an unopened handle: ' + handle;
        return 0;
      } else {
        var lib = DLFCN.loadedLibs[handle];
        symbol = '_' + symbol;
        if (!lib.module.hasOwnProperty(symbol)) {
          DLFCN.errorMsg = ('Tried to lookup unknown symbol "' + symbol +
                                 '" in dynamic lib: ' + lib.name);
          return 0;
        } else {
          var result = lib.module[symbol];
          if (typeof result === 'function') {
            // convert the exported function into a function pointer using our generic
            // JS mechanism.
            return addFunction(result);
          }
          return result;
        }
      }
    }

  function _getenv(name) {
      // char *getenv(const char *name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/getenv.html
      if (name === 0) return 0;
      name = Pointer_stringify(name);
      if (!ENV.hasOwnProperty(name)) return 0;
  
      if (_getenv.ret) _free(_getenv.ret);
      _getenv.ret = allocateUTF8(ENV[name]);
      return _getenv.ret;
    }

  function _gettimeofday(ptr) {
      var now = Date.now();
      HEAP32[((ptr)>>2)]=(now/1000)|0; // seconds
      HEAP32[(((ptr)+(4))>>2)]=((now % 1000)*1000)|0; // microseconds
      return 0;
    }



   

  var _llvm_ceil_f64=Math_ceil;

  var _llvm_floor_f64=Math_floor;

  
  function _llvm_log10_f32(x) {
      return Math.log(x) / Math.LN10; // TODO: Math.log10, when browser support is there
    }function _llvm_log10_f64() {
  return _llvm_log10_f32.apply(null, arguments)
  }

  
  var ___tm_current=STATICTOP; STATICTOP += 48;;
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      // timezone is specified as seconds west of UTC ("The external variable
      // `timezone` shall be set to the difference, in seconds, between
      // Coordinated Universal Time (UTC) and local standard time."), the same
      // as returned by getTimezoneOffset().
      // See http://pubs.opengroup.org/onlinepubs/009695399/functions/tzset.html
      HEAP32[((__get_timezone())>>2)]=(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((__get_daylight())>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      function extractZone(date) {
        var match = date.toTimeString().match(/\(([A-Za-z ]+)\)$/);
        return match ? match[1] : "GMT";
      };
      var winterName = extractZone(winter);
      var summerName = extractZone(summer);
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      if (summer.getTimezoneOffset() < winter.getTimezoneOffset()) {
        // Northern hemisphere
        HEAP32[((__get_tzname())>>2)]=winterNamePtr;
        HEAP32[(((__get_tzname())+(4))>>2)]=summerNamePtr;
      } else {
        HEAP32[((__get_tzname())>>2)]=summerNamePtr;
        HEAP32[(((__get_tzname())+(4))>>2)]=winterNamePtr;
      }
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = ((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24))|0;
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=-(date.getTimezoneOffset() * 60);
  
      // Attention: DST is in December in South, and some regions don't have DST at all.
      var summerOffset = new Date(2000, 6, 1).getTimezoneOffset();
      var winterOffset = start.getTimezoneOffset();
      var dst = (summerOffset != winterOffset && date.getTimezoneOffset() == Math.min(winterOffset, summerOffset))|0;
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      var zonePtr = HEAP32[(((__get_tzname())+(dst ? 4 : 0))>>2)];
      HEAP32[(((tmPtr)+(40))>>2)]=zonePtr;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 

   

   

  
  function _usleep(useconds) {
      // int usleep(useconds_t useconds);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/usleep.html
      // We're single-threaded, so use a busy loop. Super-ugly.
      var msec = useconds / 1000;
      if ((ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) && self['performance'] && self['performance']['now']) {
        var start = self['performance']['now']();
        while (self['performance']['now']() - start < msec) {
          // Do nothing.
        }
      } else {
        var start = Date.now();
        while (Date.now() - start < msec) {
          // Do nothing.
        }
      }
      return 0;
    }
  Module["_usleep"] = _usleep;function _nanosleep(rqtp, rmtp) {
      // int nanosleep(const struct timespec  *rqtp, struct timespec *rmtp);
      var seconds = HEAP32[((rqtp)>>2)];
      var nanoseconds = HEAP32[(((rqtp)+(4))>>2)];
      if (rmtp !== 0) {
        HEAP32[((rmtp)>>2)]=0;
        HEAP32[(((rmtp)+(4))>>2)]=0;
      }
      return _usleep((seconds * 1e6) + (nanoseconds / 1000));
    }

  function _pthread_create() {
      return 11;
    }

  function _pthread_join() {}

  function _pthread_mutex_destroy() {}

  function _pthread_mutex_init() {}

   

   

   

  function _pthread_mutexattr_destroy() {}

  function _pthread_mutexattr_init() {}

  function _pthread_mutexattr_settype() {}

   

  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 85:
          var maxHeapSize = 2*1024*1024*1024 - 16777216;
          maxHeapSize = HEAPU8.length;
          return maxHeapSize / PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 79:
          return 0;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: {
          if (typeof navigator === 'object') return navigator['hardwareConcurrency'] || 1;
          return 1;
        }
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  function _time(ptr) {
      var ret = (Date.now()/1000)|0;
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  function _utimes(path, times) {
      var time;
      if (times) {
        var offset = 8 + 0;
        time = HEAP32[(((times)+(offset))>>2)] * 1000;
        offset = 8 + 4;
        time += HEAP32[(((times)+(offset))>>2)] / 1000;
      } else {
        time = Date.now();
      }
      path = Pointer_stringify(path);
      try {
        FS.utime(path, time, time);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
FS.staticInit();__ATINIT__.unshift(function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() });__ATMAIN__.push(function() { FS.ignorePermissions = false });__ATEXIT__.push(function() { FS.quit() });;
__ATINIT__.unshift(function() { TTY.init() });__ATEXIT__.push(function() { TTY.shutdown() });;
DYNAMICTOP_PTR = staticAlloc(4);

STACK_BASE = STACKTOP = alignMemory(STATICTOP);

STACK_MAX = STACK_BASE + TOTAL_STACK;

DYNAMIC_BASE = alignMemory(STACK_MAX);

HEAP32[DYNAMICTOP_PTR>>2] = DYNAMIC_BASE;

staticSealed = true; // seal the static portion of memory

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

var ASSERTIONS = true;

/** @type {function(string, boolean=, number=)} */
function intArrayFromString(stringy, dontAddNull, length) {
  var len = length > 0 ? length : lengthBytesUTF8(stringy)+1;
  var u8array = new Array(len);
  var numBytesWritten = stringToUTF8Array(stringy, u8array, 0, u8array.length);
  if (dontAddNull) u8array.length = numBytesWritten;
  return u8array;
}

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      if (ASSERTIONS) {
        assert(false, 'Character code ' + chr + ' (' + String.fromCharCode(chr) + ')  at offset ' + i + ' not in 0x00-0xFF.');
      }
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}



function nullFunc_di(x) { Module["printErr"]("Invalid function pointer called with signature 'di'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_dii(x) { Module["printErr"]("Invalid function pointer called with signature 'dii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_i(x) { Module["printErr"]("Invalid function pointer called with signature 'i'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_ii(x) { Module["printErr"]("Invalid function pointer called with signature 'ii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iii(x) { Module["printErr"]("Invalid function pointer called with signature 'iii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiid(x) { Module["printErr"]("Invalid function pointer called with signature 'iiid'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiiiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiiiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiiiiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiiiiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiiiiiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiiiiiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'iiiiiiiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_v(x) { Module["printErr"]("Invalid function pointer called with signature 'v'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_vi(x) { Module["printErr"]("Invalid function pointer called with signature 'vi'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_vid(x) { Module["printErr"]("Invalid function pointer called with signature 'vid'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_vii(x) { Module["printErr"]("Invalid function pointer called with signature 'vii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viii(x) { Module["printErr"]("Invalid function pointer called with signature 'viii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viiii(x) { Module["printErr"]("Invalid function pointer called with signature 'viiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'viiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viiiiii(x) { Module["printErr"]("Invalid function pointer called with signature 'viiiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  Module["printErr"]("Build with ASSERTIONS=2 for more info.");abort(x) }

function invoke_di(index,a1) {
  try {
    return Module["dynCall_di"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_di(index,a1) {
    return functionPointers[index](a1);
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_dii(index,a1,a2) {
    return functionPointers[index](a1,a2);
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_i(index) {
    return functionPointers[index]();
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_ii(index,a1) {
    return functionPointers[index](a1);
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iii(index,a1,a2) {
    return functionPointers[index](a1,a2);
}

function invoke_iiid(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiid"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiid(index,a1,a2,a3) {
    return functionPointers[index](a1,a2,a3);
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiii(index,a1,a2,a3) {
    return functionPointers[index](a1,a2,a3);
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiiii(index,a1,a2,a3,a4) {
    return functionPointers[index](a1,a2,a3,a4);
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiiiii(index,a1,a2,a3,a4,a5) {
    return functionPointers[index](a1,a2,a3,a4,a5);
}

function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiiiiii(index,a1,a2,a3,a4,a5,a6) {
    return functionPointers[index](a1,a2,a3,a4,a5,a6);
}

function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
    return functionPointers[index](a1,a2,a3,a4,a5,a6,a7);
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
    return functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8);
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
    return functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9);
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_v(index) {
    functionPointers[index]();
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_vi(index,a1) {
    functionPointers[index](a1);
}

function invoke_vid(index,a1,a2) {
  try {
    Module["dynCall_vid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_vid(index,a1,a2) {
    functionPointers[index](a1,a2);
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_vii(index,a1,a2) {
    functionPointers[index](a1,a2);
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_viii(index,a1,a2,a3) {
    functionPointers[index](a1,a2,a3);
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_viiii(index,a1,a2,a3,a4) {
    functionPointers[index](a1,a2,a3,a4);
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_viiiii(index,a1,a2,a3,a4,a5) {
    functionPointers[index](a1,a2,a3,a4,a5);
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    Module["setThrew"](1, 0);
  }
}

function jsCall_viiiiii(index,a1,a2,a3,a4,a5,a6) {
    functionPointers[index](a1,a2,a3,a4,a5,a6);
}

Module.asmGlobalArg = { "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array, "NaN": NaN, "Infinity": Infinity };

Module.asmLibraryArg = { "abort": abort, "assert": assert, "enlargeMemory": enlargeMemory, "getTotalMemory": getTotalMemory, "abortOnCannotGrowMemory": abortOnCannotGrowMemory, "abortStackOverflow": abortStackOverflow, "nullFunc_di": nullFunc_di, "nullFunc_dii": nullFunc_dii, "nullFunc_i": nullFunc_i, "nullFunc_ii": nullFunc_ii, "nullFunc_iii": nullFunc_iii, "nullFunc_iiid": nullFunc_iiid, "nullFunc_iiii": nullFunc_iiii, "nullFunc_iiiii": nullFunc_iiiii, "nullFunc_iiiiii": nullFunc_iiiiii, "nullFunc_iiiiiii": nullFunc_iiiiiii, "nullFunc_iiiiiiii": nullFunc_iiiiiiii, "nullFunc_iiiiiiiii": nullFunc_iiiiiiiii, "nullFunc_iiiiiiiiii": nullFunc_iiiiiiiiii, "nullFunc_v": nullFunc_v, "nullFunc_vi": nullFunc_vi, "nullFunc_vid": nullFunc_vid, "nullFunc_vii": nullFunc_vii, "nullFunc_viii": nullFunc_viii, "nullFunc_viiii": nullFunc_viiii, "nullFunc_viiiii": nullFunc_viiiii, "nullFunc_viiiiii": nullFunc_viiiiii, "invoke_di": invoke_di, "jsCall_di": jsCall_di, "invoke_dii": invoke_dii, "jsCall_dii": jsCall_dii, "invoke_i": invoke_i, "jsCall_i": jsCall_i, "invoke_ii": invoke_ii, "jsCall_ii": jsCall_ii, "invoke_iii": invoke_iii, "jsCall_iii": jsCall_iii, "invoke_iiid": invoke_iiid, "jsCall_iiid": jsCall_iiid, "invoke_iiii": invoke_iiii, "jsCall_iiii": jsCall_iiii, "invoke_iiiii": invoke_iiiii, "jsCall_iiiii": jsCall_iiiii, "invoke_iiiiii": invoke_iiiiii, "jsCall_iiiiii": jsCall_iiiiii, "invoke_iiiiiii": invoke_iiiiiii, "jsCall_iiiiiii": jsCall_iiiiiii, "invoke_iiiiiiii": invoke_iiiiiiii, "jsCall_iiiiiiii": jsCall_iiiiiiii, "invoke_iiiiiiiii": invoke_iiiiiiiii, "jsCall_iiiiiiiii": jsCall_iiiiiiiii, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "jsCall_iiiiiiiiii": jsCall_iiiiiiiiii, "invoke_v": invoke_v, "jsCall_v": jsCall_v, "invoke_vi": invoke_vi, "jsCall_vi": jsCall_vi, "invoke_vid": invoke_vid, "jsCall_vid": jsCall_vid, "invoke_vii": invoke_vii, "jsCall_vii": jsCall_vii, "invoke_viii": invoke_viii, "jsCall_viii": jsCall_viii, "invoke_viiii": invoke_viiii, "jsCall_viiii": jsCall_viiii, "invoke_viiiii": invoke_viiiii, "jsCall_viiiii": jsCall_viiiii, "invoke_viiiiii": invoke_viiiiii, "jsCall_viiiiii": jsCall_viiiiii, "___assert_fail": ___assert_fail, "___buildEnvironment": ___buildEnvironment, "___lock": ___lock, "___setErrNo": ___setErrNo, "___syscall10": ___syscall10, "___syscall118": ___syscall118, "___syscall140": ___syscall140, "___syscall146": ___syscall146, "___syscall15": ___syscall15, "___syscall183": ___syscall183, "___syscall192": ___syscall192, "___syscall194": ___syscall194, "___syscall195": ___syscall195, "___syscall196": ___syscall196, "___syscall197": ___syscall197, "___syscall20": ___syscall20, "___syscall201": ___syscall201, "___syscall202": ___syscall202, "___syscall207": ___syscall207, "___syscall212": ___syscall212, "___syscall221": ___syscall221, "___syscall3": ___syscall3, "___syscall33": ___syscall33, "___syscall39": ___syscall39, "___syscall4": ___syscall4, "___syscall40": ___syscall40, "___syscall5": ___syscall5, "___syscall54": ___syscall54, "___syscall6": ___syscall6, "___syscall85": ___syscall85, "___syscall91": ___syscall91, "___syscall94": ___syscall94, "___unlock": ___unlock, "_abort": _abort, "_dlclose": _dlclose, "_dlerror": _dlerror, "_dlopen": _dlopen, "_dlsym": _dlsym, "_emscripten_memcpy_big": _emscripten_memcpy_big, "_getenv": _getenv, "_gettimeofday": _gettimeofday, "_llvm_ceil_f64": _llvm_ceil_f64, "_llvm_floor_f64": _llvm_floor_f64, "_llvm_log10_f32": _llvm_log10_f32, "_llvm_log10_f64": _llvm_log10_f64, "_localtime": _localtime, "_localtime_r": _localtime_r, "_nanosleep": _nanosleep, "_pthread_create": _pthread_create, "_pthread_join": _pthread_join, "_pthread_mutex_destroy": _pthread_mutex_destroy, "_pthread_mutex_init": _pthread_mutex_init, "_pthread_mutexattr_destroy": _pthread_mutexattr_destroy, "_pthread_mutexattr_init": _pthread_mutexattr_init, "_pthread_mutexattr_settype": _pthread_mutexattr_settype, "_sysconf": _sysconf, "_time": _time, "_tzset": _tzset, "_usleep": _usleep, "_utimes": _utimes, "DYNAMICTOP_PTR": DYNAMICTOP_PTR, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX };
// EMSCRIPTEN_START_ASM
var asm = (/** @suppress {uselessCode} */ function(global, env, buffer) {
'use asm';


  var HEAP8 = new global.Int8Array(buffer);
  var HEAP16 = new global.Int16Array(buffer);
  var HEAP32 = new global.Int32Array(buffer);
  var HEAPU8 = new global.Uint8Array(buffer);
  var HEAPU16 = new global.Uint16Array(buffer);
  var HEAPU32 = new global.Uint32Array(buffer);
  var HEAPF32 = new global.Float32Array(buffer);
  var HEAPF64 = new global.Float64Array(buffer);

  var DYNAMICTOP_PTR=env.DYNAMICTOP_PTR|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var ABORT=env.ABORT|0;
  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = global.NaN, inf = global.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntS = 0, tempValue = 0, tempDouble = 0.0;
  var tempRet0 = 0;

  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_min=global.Math.min;
  var Math_max=global.Math.max;
  var Math_clz32=global.Math.clz32;
  var abort=env.abort;
  var assert=env.assert;
  var enlargeMemory=env.enlargeMemory;
  var getTotalMemory=env.getTotalMemory;
  var abortOnCannotGrowMemory=env.abortOnCannotGrowMemory;
  var abortStackOverflow=env.abortStackOverflow;
  var nullFunc_di=env.nullFunc_di;
  var nullFunc_dii=env.nullFunc_dii;
  var nullFunc_i=env.nullFunc_i;
  var nullFunc_ii=env.nullFunc_ii;
  var nullFunc_iii=env.nullFunc_iii;
  var nullFunc_iiid=env.nullFunc_iiid;
  var nullFunc_iiii=env.nullFunc_iiii;
  var nullFunc_iiiii=env.nullFunc_iiiii;
  var nullFunc_iiiiii=env.nullFunc_iiiiii;
  var nullFunc_iiiiiii=env.nullFunc_iiiiiii;
  var nullFunc_iiiiiiii=env.nullFunc_iiiiiiii;
  var nullFunc_iiiiiiiii=env.nullFunc_iiiiiiiii;
  var nullFunc_iiiiiiiiii=env.nullFunc_iiiiiiiiii;
  var nullFunc_v=env.nullFunc_v;
  var nullFunc_vi=env.nullFunc_vi;
  var nullFunc_vid=env.nullFunc_vid;
  var nullFunc_vii=env.nullFunc_vii;
  var nullFunc_viii=env.nullFunc_viii;
  var nullFunc_viiii=env.nullFunc_viiii;
  var nullFunc_viiiii=env.nullFunc_viiiii;
  var nullFunc_viiiiii=env.nullFunc_viiiiii;
  var invoke_di=env.invoke_di;
  var jsCall_di=env.jsCall_di;
  var invoke_dii=env.invoke_dii;
  var jsCall_dii=env.jsCall_dii;
  var invoke_i=env.invoke_i;
  var jsCall_i=env.jsCall_i;
  var invoke_ii=env.invoke_ii;
  var jsCall_ii=env.jsCall_ii;
  var invoke_iii=env.invoke_iii;
  var jsCall_iii=env.jsCall_iii;
  var invoke_iiid=env.invoke_iiid;
  var jsCall_iiid=env.jsCall_iiid;
  var invoke_iiii=env.invoke_iiii;
  var jsCall_iiii=env.jsCall_iiii;
  var invoke_iiiii=env.invoke_iiiii;
  var jsCall_iiiii=env.jsCall_iiiii;
  var invoke_iiiiii=env.invoke_iiiiii;
  var jsCall_iiiiii=env.jsCall_iiiiii;
  var invoke_iiiiiii=env.invoke_iiiiiii;
  var jsCall_iiiiiii=env.jsCall_iiiiiii;
  var invoke_iiiiiiii=env.invoke_iiiiiiii;
  var jsCall_iiiiiiii=env.jsCall_iiiiiiii;
  var invoke_iiiiiiiii=env.invoke_iiiiiiiii;
  var jsCall_iiiiiiiii=env.jsCall_iiiiiiiii;
  var invoke_iiiiiiiiii=env.invoke_iiiiiiiiii;
  var jsCall_iiiiiiiiii=env.jsCall_iiiiiiiiii;
  var invoke_v=env.invoke_v;
  var jsCall_v=env.jsCall_v;
  var invoke_vi=env.invoke_vi;
  var jsCall_vi=env.jsCall_vi;
  var invoke_vid=env.invoke_vid;
  var jsCall_vid=env.jsCall_vid;
  var invoke_vii=env.invoke_vii;
  var jsCall_vii=env.jsCall_vii;
  var invoke_viii=env.invoke_viii;
  var jsCall_viii=env.jsCall_viii;
  var invoke_viiii=env.invoke_viiii;
  var jsCall_viiii=env.jsCall_viiii;
  var invoke_viiiii=env.invoke_viiiii;
  var jsCall_viiiii=env.jsCall_viiiii;
  var invoke_viiiiii=env.invoke_viiiiii;
  var jsCall_viiiiii=env.jsCall_viiiiii;
  var ___assert_fail=env.___assert_fail;
  var ___buildEnvironment=env.___buildEnvironment;
  var ___lock=env.___lock;
  var ___setErrNo=env.___setErrNo;
  var ___syscall10=env.___syscall10;
  var ___syscall118=env.___syscall118;
  var ___syscall140=env.___syscall140;
  var ___syscall146=env.___syscall146;
  var ___syscall15=env.___syscall15;
  var ___syscall183=env.___syscall183;
  var ___syscall192=env.___syscall192;
  var ___syscall194=env.___syscall194;
  var ___syscall195=env.___syscall195;
  var ___syscall196=env.___syscall196;
  var ___syscall197=env.___syscall197;
  var ___syscall20=env.___syscall20;
  var ___syscall201=env.___syscall201;
  var ___syscall202=env.___syscall202;
  var ___syscall207=env.___syscall207;
  var ___syscall212=env.___syscall212;
  var ___syscall221=env.___syscall221;
  var ___syscall3=env.___syscall3;
  var ___syscall33=env.___syscall33;
  var ___syscall39=env.___syscall39;
  var ___syscall4=env.___syscall4;
  var ___syscall40=env.___syscall40;
  var ___syscall5=env.___syscall5;
  var ___syscall54=env.___syscall54;
  var ___syscall6=env.___syscall6;
  var ___syscall85=env.___syscall85;
  var ___syscall91=env.___syscall91;
  var ___syscall94=env.___syscall94;
  var ___unlock=env.___unlock;
  var _abort=env._abort;
  var _dlclose=env._dlclose;
  var _dlerror=env._dlerror;
  var _dlopen=env._dlopen;
  var _dlsym=env._dlsym;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var _getenv=env._getenv;
  var _gettimeofday=env._gettimeofday;
  var _llvm_ceil_f64=env._llvm_ceil_f64;
  var _llvm_floor_f64=env._llvm_floor_f64;
  var _llvm_log10_f32=env._llvm_log10_f32;
  var _llvm_log10_f64=env._llvm_log10_f64;
  var _localtime=env._localtime;
  var _localtime_r=env._localtime_r;
  var _nanosleep=env._nanosleep;
  var _pthread_create=env._pthread_create;
  var _pthread_join=env._pthread_join;
  var _pthread_mutex_destroy=env._pthread_mutex_destroy;
  var _pthread_mutex_init=env._pthread_mutex_init;
  var _pthread_mutexattr_destroy=env._pthread_mutexattr_destroy;
  var _pthread_mutexattr_init=env._pthread_mutexattr_init;
  var _pthread_mutexattr_settype=env._pthread_mutexattr_settype;
  var _sysconf=env._sysconf;
  var _time=env._time;
  var _tzset=env._tzset;
  var _usleep=env._usleep;
  var _utimes=env._utimes;
  var tempFloat = 0.0;

// EMSCRIPTEN_START_FUNCS

function stackAlloc(size) {
  size = size|0;
  var ret = 0;
  ret = STACKTOP;
  STACKTOP = (STACKTOP + size)|0;
  STACKTOP = (STACKTOP + 15)&-16;
  if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(size|0);

  return ret|0;
}
function stackSave() {
  return STACKTOP|0;
}
function stackRestore(top) {
  top = top|0;
  STACKTOP = top;
}
function establishStackSpace(stackBase, stackMax) {
  stackBase = stackBase|0;
  stackMax = stackMax|0;
  STACKTOP = stackBase;
  STACK_MAX = stackMax;
}

function setThrew(threw, value) {
  threw = threw|0;
  value = value|0;
  if ((__THREW__|0) == 0) {
    __THREW__ = threw;
    threwValue = value;
  }
}

function setTempRet0(value) {
  value = value|0;
  tempRet0 = value;
}
function getTempRet0() {
  return tempRet0|0;
}

function _RegisterExtensionFunctions($0) {
 $0 = $0|0;
 var $$0 = 0, $$024 = 0, $$02527 = 0, $$126 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $exitcond28 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$02527 = 0;
 while(1) {
  $1 = (((480 + (($$02527*12)|0)|0)) + 5|0); //@line 1795 "c/extension-functions.c"
  $2 = HEAP8[$1>>0]|0; //@line 1795 "c/extension-functions.c"
  switch ($2<<24>>24) {
  case 1:  {
   $$024 = $0;
   break;
  }
  case 2:  {
   $$024 = (-1);
   break;
  }
  default: {
   $$024 = 0;
  }
  }
  $3 = ((0) + 180|0); //@line 1801 "c/extension-functions.c"
  $4 = HEAP32[$3>>2]|0; //@line 1801 "c/extension-functions.c"
  $5 = (480 + (($$02527*12)|0)|0); //@line 1801 "c/extension-functions.c"
  $6 = HEAP32[$5>>2]|0; //@line 1801 "c/extension-functions.c"
  $7 = (((480 + (($$02527*12)|0)|0)) + 4|0); //@line 1801 "c/extension-functions.c"
  $8 = HEAP8[$7>>0]|0; //@line 1801 "c/extension-functions.c"
  $9 = $8 << 24 >> 24; //@line 1801 "c/extension-functions.c"
  $10 = (((480 + (($$02527*12)|0)|0)) + 6|0); //@line 1802 "c/extension-functions.c"
  $11 = HEAP8[$10>>0]|0; //@line 1802 "c/extension-functions.c"
  $12 = $11&255; //@line 1802 "c/extension-functions.c"
  $13 = (((480 + (($$02527*12)|0)|0)) + 8|0); //@line 1802 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 1802 "c/extension-functions.c"
  (FUNCTION_TABLE_iiiiiiiii[$4 & 127]($0,$6,$9,$12,$$024,$14,0,0)|0); //@line 1801 "c/extension-functions.c"
  $15 = (($$02527) + 1)|0; //@line 1793 "c/extension-functions.c"
  $exitcond28 = ($15|0)==(40); //@line 1793 "c/extension-functions.c"
  if ($exitcond28) {
   break;
  } else {
   $$02527 = $15;
  }
 }
 $$126 = 0;
 while(1) {
  $16 = (((960 + ($$126<<4)|0)) + 5|0); //@line 1816 "c/extension-functions.c"
  $17 = HEAP8[$16>>0]|0; //@line 1816 "c/extension-functions.c"
  switch ($17<<24>>24) {
  case 1:  {
   $$0 = $0;
   break;
  }
  case 2:  {
   $$0 = (-1);
   break;
  }
  default: {
   $$0 = 0;
  }
  }
  $18 = ((0) + 180|0); //@line 1822 "c/extension-functions.c"
  $19 = HEAP32[$18>>2]|0; //@line 1822 "c/extension-functions.c"
  $20 = (960 + ($$126<<4)|0); //@line 1822 "c/extension-functions.c"
  $21 = HEAP32[$20>>2]|0; //@line 1822 "c/extension-functions.c"
  $22 = (((960 + ($$126<<4)|0)) + 4|0); //@line 1822 "c/extension-functions.c"
  $23 = HEAP8[$22>>0]|0; //@line 1822 "c/extension-functions.c"
  $24 = $23 << 24 >> 24; //@line 1822 "c/extension-functions.c"
  $25 = (((960 + ($$126<<4)|0)) + 8|0); //@line 1823 "c/extension-functions.c"
  $26 = HEAP32[$25>>2]|0; //@line 1823 "c/extension-functions.c"
  $27 = (((960 + ($$126<<4)|0)) + 12|0); //@line 1823 "c/extension-functions.c"
  $28 = HEAP32[$27>>2]|0; //@line 1823 "c/extension-functions.c"
  (FUNCTION_TABLE_iiiiiiiii[$19 & 127]($0,$21,$24,1,$$0,0,$26,$28)|0); //@line 1822 "c/extension-functions.c"
  $29 = (($$126) + 1)|0; //@line 1814 "c/extension-functions.c"
  $exitcond = ($29|0)==(6); //@line 1814 "c/extension-functions.c"
  if ($exitcond) {
   break;
  } else {
   $$126 = $29;
  }
 }
 return 0; //@line 1834 "c/extension-functions.c"
}
function _acosFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 378 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),378,(14265|0)); //@line 378 "c/extension-functions.c"
  // unreachable; //@line 378 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 378 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 378 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 378 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 378 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 378 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 378 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 378 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 378 "c/extension-functions.c"
  return; //@line 378 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 378 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 378 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 378 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 378 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 378 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 378 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 378 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 378 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 378 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_acos((+$13))); //@line 378 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 378 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 378 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 378 "c/extension-functions.c"
  return; //@line 378 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 378 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 378 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 378 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 378 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 378 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 378 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 378 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 378 "c/extension-functions.c"
  return; //@line 378 "c/extension-functions.c"
 }
}
function _asinFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 379 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),379,(14274|0)); //@line 379 "c/extension-functions.c"
  // unreachable; //@line 379 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 379 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 379 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 379 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 379 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 379 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 379 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 379 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 379 "c/extension-functions.c"
  return; //@line 379 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 379 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 379 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 379 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 379 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 379 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 379 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 379 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 379 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 379 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_asin((+$13))); //@line 379 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 379 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 379 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 379 "c/extension-functions.c"
  return; //@line 379 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 379 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 379 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 379 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 379 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 379 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 379 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 379 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 379 "c/extension-functions.c"
  return; //@line 379 "c/extension-functions.c"
 }
}
function _atanFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 380 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),380,(14283|0)); //@line 380 "c/extension-functions.c"
  // unreachable; //@line 380 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 380 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 380 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 380 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 380 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 380 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 380 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 380 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 380 "c/extension-functions.c"
  return; //@line 380 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 380 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 380 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 380 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 380 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 380 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 380 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 380 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 380 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 380 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_atan((+$13))); //@line 380 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 380 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 380 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 380 "c/extension-functions.c"
  return; //@line 380 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 380 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 380 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 380 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 380 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 380 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 380 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 380 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 380 "c/extension-functions.c"
  return; //@line 380 "c/extension-functions.c"
 }
}
function _atn2Func($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $23 = 0, $24 = 0.0, $25 = 0, $26 = 0, $27 = 0.0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 570 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),570,(14300|0)); //@line 570 "c/extension-functions.c"
  // unreachable; //@line 570 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 572 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 572 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 572 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 572 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 572 "c/extension-functions.c"
 if (!($8)) {
  $9 = ((0) + 452|0); //@line 572 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 572 "c/extension-functions.c"
  $11 = ((($2)) + 4|0); //@line 572 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 572 "c/extension-functions.c"
  $13 = (FUNCTION_TABLE_ii[$10 & 255]($12)|0); //@line 572 "c/extension-functions.c"
  $14 = ($13|0)==(5); //@line 572 "c/extension-functions.c"
  if (!($14)) {
   $17 = ((0) + 420|0); //@line 575 "c/extension-functions.c"
   $18 = HEAP32[$17>>2]|0; //@line 575 "c/extension-functions.c"
   $19 = HEAP32[$2>>2]|0; //@line 575 "c/extension-functions.c"
   $20 = (+FUNCTION_TABLE_di[$18 & 127]($19)); //@line 575 "c/extension-functions.c"
   $21 = ((0) + 420|0); //@line 576 "c/extension-functions.c"
   $22 = HEAP32[$21>>2]|0; //@line 576 "c/extension-functions.c"
   $23 = HEAP32[$11>>2]|0; //@line 576 "c/extension-functions.c"
   $24 = (+FUNCTION_TABLE_di[$22 & 127]($23)); //@line 576 "c/extension-functions.c"
   $25 = ((0) + 316|0); //@line 577 "c/extension-functions.c"
   $26 = HEAP32[$25>>2]|0; //@line 577 "c/extension-functions.c"
   $27 = (+Math_atan2((+$20),(+$24))); //@line 577 "c/extension-functions.c"
   FUNCTION_TABLE_vid[$26 & 127]($0,$27); //@line 577 "c/extension-functions.c"
   return; //@line 579 "c/extension-functions.c"
  }
 }
 $15 = ((0) + 336|0); //@line 573 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 573 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$16 & 127]($0); //@line 573 "c/extension-functions.c"
 return; //@line 579 "c/extension-functions.c"
}
function _acoshFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 394 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),394,(14309|0)); //@line 394 "c/extension-functions.c"
  // unreachable; //@line 394 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 394 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 394 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 394 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 394 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 394 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 394 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 394 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 394 "c/extension-functions.c"
  return; //@line 394 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 394 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 394 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 394 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 394 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 394 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 394 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 394 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 394 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 394 "c/extension-functions.c"
 if ($17) {
  $18 = (+_acosh($13)); //@line 394 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 394 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 394 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 394 "c/extension-functions.c"
  return; //@line 394 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 394 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 394 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 394 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 394 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 394 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 394 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 394 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 394 "c/extension-functions.c"
  return; //@line 394 "c/extension-functions.c"
 }
}
function _asinhFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 402 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),402,(14319|0)); //@line 402 "c/extension-functions.c"
  // unreachable; //@line 402 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 402 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 402 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 402 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 402 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 402 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 402 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 402 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 402 "c/extension-functions.c"
  return; //@line 402 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 402 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 402 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 402 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 402 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 402 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 402 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 402 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 402 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 402 "c/extension-functions.c"
 if ($17) {
  $18 = (+_asinh($13)); //@line 402 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 402 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 402 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 402 "c/extension-functions.c"
  return; //@line 402 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 402 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 402 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 402 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 402 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 402 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 402 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 402 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 402 "c/extension-functions.c"
  return; //@line 402 "c/extension-functions.c"
 }
}
function _atanhFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 410 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),410,(14329|0)); //@line 410 "c/extension-functions.c"
  // unreachable; //@line 410 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 410 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 410 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 410 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 410 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 410 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 410 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 410 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 410 "c/extension-functions.c"
  return; //@line 410 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 410 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 410 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 410 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 410 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 410 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 410 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 410 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 410 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 410 "c/extension-functions.c"
 if ($17) {
  $18 = (+_atanh($13)); //@line 410 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 410 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 410 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 410 "c/extension-functions.c"
  return; //@line 410 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 410 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 410 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 410 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 410 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 410 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 410 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 410 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 410 "c/extension-functions.c"
  return; //@line 410 "c/extension-functions.c"
 }
}
function _differenceFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$1 = 0, $$1$1 = 0, $$1$2 = 0, $$1$3 = 0, $$130 = 0, $$130$1 = 0, $$130$2 = 0, $$130$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $8 = 0, $9 = 0, $spec$select$1 = 0, $spec$select$2 = 0, $spec$select$3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 8|0;
 $4 = sp;
 $5 = ($1|0)==(2); //@line 1680 "c/extension-functions.c"
 if (!($5)) {
  ___assert_fail((14292|0),(14241|0),1680,(14339|0)); //@line 1680 "c/extension-functions.c"
  // unreachable; //@line 1680 "c/extension-functions.c"
 }
 $6 = ((0) + 452|0); //@line 1682 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1682 "c/extension-functions.c"
 $8 = HEAP32[$2>>2]|0; //@line 1682 "c/extension-functions.c"
 $9 = (FUNCTION_TABLE_ii[$7 & 255]($8)|0); //@line 1682 "c/extension-functions.c"
 $10 = ($9|0)==(5); //@line 1682 "c/extension-functions.c"
 if (!($10)) {
  $11 = ((0) + 452|0); //@line 1682 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 1682 "c/extension-functions.c"
  $13 = ((($2)) + 4|0); //@line 1682 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 1682 "c/extension-functions.c"
  $15 = (FUNCTION_TABLE_ii[$12 & 255]($14)|0); //@line 1682 "c/extension-functions.c"
  $16 = ($15|0)==(5); //@line 1682 "c/extension-functions.c"
  if (!($16)) {
   $19 = ((0) + 436|0); //@line 1687 "c/extension-functions.c"
   $20 = HEAP32[$19>>2]|0; //@line 1687 "c/extension-functions.c"
   $21 = HEAP32[$2>>2]|0; //@line 1687 "c/extension-functions.c"
   $22 = (FUNCTION_TABLE_ii[$20 & 255]($21)|0); //@line 1687 "c/extension-functions.c"
   $23 = ((0) + 436|0); //@line 1688 "c/extension-functions.c"
   $24 = HEAP32[$23>>2]|0; //@line 1688 "c/extension-functions.c"
   $25 = HEAP32[$13>>2]|0; //@line 1688 "c/extension-functions.c"
   $26 = (FUNCTION_TABLE_ii[$24 & 255]($25)|0); //@line 1688 "c/extension-functions.c"
   _soundex($22,$3); //@line 1690 "c/extension-functions.c"
   _soundex($26,$4); //@line 1691 "c/extension-functions.c"
   $27 = (_sqlite3ReadUtf8($3)|0); //@line 1694 "c/extension-functions.c"
   $28 = (_sqlite3ReadUtf8($4)|0); //@line 1694 "c/extension-functions.c"
   $29 = ($27|0)==($28|0); //@line 1694 "c/extension-functions.c"
   $30 = $29&1; //@line 1694 "c/extension-functions.c"
   $$1 = $3;
   while(1) {
    $31 = ((($$1)) + 1|0); //@line 1696 "c/extension-functions.c"
    $32 = HEAP8[$31>>0]|0; //@line 1696 "c/extension-functions.c"
    $33 = $32 & -64; //@line 1696 "c/extension-functions.c"
    $34 = ($33<<24>>24)==(-128); //@line 1696 "c/extension-functions.c"
    if ($34) {
     $$1 = $31;
    } else {
     break;
    }
   }
   $$130 = $4;
   while(1) {
    $35 = ((($$130)) + 1|0); //@line 1697 "c/extension-functions.c"
    $36 = HEAP8[$35>>0]|0; //@line 1697 "c/extension-functions.c"
    $37 = $36 & -64; //@line 1697 "c/extension-functions.c"
    $38 = ($37<<24>>24)==(-128); //@line 1697 "c/extension-functions.c"
    if ($38) {
     $$130 = $35;
    } else {
     break;
    }
   }
   $39 = (_sqlite3ReadUtf8($31)|0); //@line 1694 "c/extension-functions.c"
   $40 = (_sqlite3ReadUtf8($35)|0); //@line 1694 "c/extension-functions.c"
   $41 = ($39|0)==($40|0); //@line 1694 "c/extension-functions.c"
   $42 = $41&1; //@line 1694 "c/extension-functions.c"
   $$1$1 = $31;
   while(1) {
    $43 = ((($$1$1)) + 1|0); //@line 1696 "c/extension-functions.c"
    $44 = HEAP8[$43>>0]|0; //@line 1696 "c/extension-functions.c"
    $45 = $44 & -64; //@line 1696 "c/extension-functions.c"
    $46 = ($45<<24>>24)==(-128); //@line 1696 "c/extension-functions.c"
    if ($46) {
     $$1$1 = $43;
    } else {
     break;
    }
   }
   $$130$1 = $35;
   while(1) {
    $47 = ((($$130$1)) + 1|0); //@line 1697 "c/extension-functions.c"
    $48 = HEAP8[$47>>0]|0; //@line 1697 "c/extension-functions.c"
    $49 = $48 & -64; //@line 1697 "c/extension-functions.c"
    $50 = ($49<<24>>24)==(-128); //@line 1697 "c/extension-functions.c"
    if ($50) {
     $$130$1 = $47;
    } else {
     break;
    }
   }
   $spec$select$1 = (($30) + ($42))|0; //@line 1694 "c/extension-functions.c"
   $51 = (_sqlite3ReadUtf8($43)|0); //@line 1694 "c/extension-functions.c"
   $52 = (_sqlite3ReadUtf8($47)|0); //@line 1694 "c/extension-functions.c"
   $53 = ($51|0)==($52|0); //@line 1694 "c/extension-functions.c"
   $54 = $53&1; //@line 1694 "c/extension-functions.c"
   $$1$2 = $43;
   while(1) {
    $55 = ((($$1$2)) + 1|0); //@line 1696 "c/extension-functions.c"
    $56 = HEAP8[$55>>0]|0; //@line 1696 "c/extension-functions.c"
    $57 = $56 & -64; //@line 1696 "c/extension-functions.c"
    $58 = ($57<<24>>24)==(-128); //@line 1696 "c/extension-functions.c"
    if ($58) {
     $$1$2 = $55;
    } else {
     break;
    }
   }
   $$130$2 = $47;
   while(1) {
    $59 = ((($$130$2)) + 1|0); //@line 1697 "c/extension-functions.c"
    $60 = HEAP8[$59>>0]|0; //@line 1697 "c/extension-functions.c"
    $61 = $60 & -64; //@line 1697 "c/extension-functions.c"
    $62 = ($61<<24>>24)==(-128); //@line 1697 "c/extension-functions.c"
    if ($62) {
     $$130$2 = $59;
    } else {
     break;
    }
   }
   $spec$select$2 = (($spec$select$1) + ($54))|0; //@line 1694 "c/extension-functions.c"
   $63 = (_sqlite3ReadUtf8($55)|0); //@line 1694 "c/extension-functions.c"
   $64 = (_sqlite3ReadUtf8($59)|0); //@line 1694 "c/extension-functions.c"
   $65 = ($63|0)==($64|0); //@line 1694 "c/extension-functions.c"
   $66 = $65&1; //@line 1694 "c/extension-functions.c"
   $$1$3 = $55;
   while(1) {
    $67 = ((($$1$3)) + 1|0); //@line 1696 "c/extension-functions.c"
    $68 = HEAP8[$67>>0]|0; //@line 1696 "c/extension-functions.c"
    $69 = $68 & -64; //@line 1696 "c/extension-functions.c"
    $70 = ($69<<24>>24)==(-128); //@line 1696 "c/extension-functions.c"
    if ($70) {
     $$1$3 = $67;
    } else {
     break;
    }
   }
   $$130$3 = $59;
   while(1) {
    $71 = ((($$130$3)) + 1|0); //@line 1697 "c/extension-functions.c"
    $72 = HEAP8[$71>>0]|0; //@line 1697 "c/extension-functions.c"
    $73 = $72 & -64; //@line 1697 "c/extension-functions.c"
    $74 = ($73<<24>>24)==(-128); //@line 1697 "c/extension-functions.c"
    if ($74) {
     $$130$3 = $71;
    } else {
     break;
    }
   }
   $spec$select$3 = (($spec$select$2) + ($66))|0; //@line 1694 "c/extension-functions.c"
   $75 = ((0) + 328|0); //@line 1699 "c/extension-functions.c"
   $76 = HEAP32[$75>>2]|0; //@line 1699 "c/extension-functions.c"
   FUNCTION_TABLE_vii[$76 & 127]($0,$spec$select$3); //@line 1699 "c/extension-functions.c"
   STACKTOP = sp;return; //@line 1700 "c/extension-functions.c"
  }
 }
 $17 = ((0) + 336|0); //@line 1683 "c/extension-functions.c"
 $18 = HEAP32[$17>>2]|0; //@line 1683 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$18 & 127]($0); //@line 1683 "c/extension-functions.c"
 STACKTOP = sp;return; //@line 1700 "c/extension-functions.c"
}
function _rad2degFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 498 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),498,(14743|0)); //@line 498 "c/extension-functions.c"
  // unreachable; //@line 498 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 498 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 498 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 498 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 498 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 498 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 498 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 498 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 498 "c/extension-functions.c"
  return; //@line 498 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 498 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 498 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 498 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 498 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 498 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 498 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 498 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 498 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 498 "c/extension-functions.c"
 if ($17) {
  $18 = (+_rad2deg($13)); //@line 498 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 498 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 498 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 498 "c/extension-functions.c"
  return; //@line 498 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 498 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 498 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 498 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 498 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 498 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 498 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 498 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 498 "c/extension-functions.c"
  return; //@line 498 "c/extension-functions.c"
 }
}
function _deg2radFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 499 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),499,(14755|0)); //@line 499 "c/extension-functions.c"
  // unreachable; //@line 499 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 499 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 499 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 499 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 499 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 499 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 499 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 499 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 499 "c/extension-functions.c"
  return; //@line 499 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 499 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 499 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 499 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 499 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 499 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 499 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 499 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 499 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 499 "c/extension-functions.c"
 if ($17) {
  $18 = (+_deg2rad($13)); //@line 499 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 499 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 499 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 499 "c/extension-functions.c"
  return; //@line 499 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 499 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 499 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 499 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 499 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 499 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 499 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 499 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 499 "c/extension-functions.c"
  return; //@line 499 "c/extension-functions.c"
 }
}
function _cosFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 420 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),420,(14767|0)); //@line 420 "c/extension-functions.c"
  // unreachable; //@line 420 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 420 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 420 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 420 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 420 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 420 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 420 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 420 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 420 "c/extension-functions.c"
  return; //@line 420 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 420 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 420 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 420 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 420 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 420 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 420 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 420 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 420 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 420 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_cos((+$13))); //@line 420 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 420 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 420 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 420 "c/extension-functions.c"
  return; //@line 420 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 420 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 420 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 420 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 420 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 420 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 420 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 420 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 420 "c/extension-functions.c"
  return; //@line 420 "c/extension-functions.c"
 }
}
function _sinFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 419 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),419,(14775|0)); //@line 419 "c/extension-functions.c"
  // unreachable; //@line 419 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 419 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 419 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 419 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 419 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 419 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 419 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 419 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 419 "c/extension-functions.c"
  return; //@line 419 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 419 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 419 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 419 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 419 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 419 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 419 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 419 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 419 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 419 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_sin((+$13))); //@line 419 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 419 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 419 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 419 "c/extension-functions.c"
  return; //@line 419 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 419 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 419 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 419 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 419 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 419 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 419 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 419 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 419 "c/extension-functions.c"
  return; //@line 419 "c/extension-functions.c"
 }
}
function _tanFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 421 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),421,(14783|0)); //@line 421 "c/extension-functions.c"
  // unreachable; //@line 421 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 421 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 421 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 421 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 421 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 421 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 421 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 421 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 421 "c/extension-functions.c"
  return; //@line 421 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 421 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 421 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 421 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 421 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 421 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 421 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 421 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 421 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 421 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_tan((+$13))); //@line 421 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 421 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 421 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 421 "c/extension-functions.c"
  return; //@line 421 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 421 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 421 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 421 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 421 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 421 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 421 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 421 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 421 "c/extension-functions.c"
  return; //@line 421 "c/extension-functions.c"
 }
}
function _cotFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 422 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),422,(14791|0)); //@line 422 "c/extension-functions.c"
  // unreachable; //@line 422 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 422 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 422 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 422 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 422 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 422 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 422 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 422 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 422 "c/extension-functions.c"
  return; //@line 422 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 422 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 422 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 422 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 422 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 422 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 422 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 422 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 422 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 422 "c/extension-functions.c"
 if ($17) {
  $18 = (+_cot($13)); //@line 422 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 422 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 422 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 422 "c/extension-functions.c"
  return; //@line 422 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 422 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 422 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 422 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 422 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 422 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 422 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 422 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 422 "c/extension-functions.c"
  return; //@line 422 "c/extension-functions.c"
 }
}
function _coshFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 446 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),446,(14799|0)); //@line 446 "c/extension-functions.c"
  // unreachable; //@line 446 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 446 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 446 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 446 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 446 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 446 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 446 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 446 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 446 "c/extension-functions.c"
  return; //@line 446 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 446 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 446 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 446 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 446 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 446 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 446 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 446 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 446 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 446 "c/extension-functions.c"
 if ($17) {
  $18 = (+_cosh($13)); //@line 446 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 446 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 446 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 446 "c/extension-functions.c"
  return; //@line 446 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 446 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 446 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 446 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 446 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 446 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 446 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 446 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 446 "c/extension-functions.c"
  return; //@line 446 "c/extension-functions.c"
 }
}
function _sinhFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 438 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),438,(14808|0)); //@line 438 "c/extension-functions.c"
  // unreachable; //@line 438 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 438 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 438 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 438 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 438 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 438 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 438 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 438 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 438 "c/extension-functions.c"
  return; //@line 438 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 438 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 438 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 438 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 438 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 438 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 438 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 438 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 438 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 438 "c/extension-functions.c"
 if ($17) {
  $18 = (+_sinh($13)); //@line 438 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 438 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 438 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 438 "c/extension-functions.c"
  return; //@line 438 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 438 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 438 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 438 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 438 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 438 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 438 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 438 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 438 "c/extension-functions.c"
  return; //@line 438 "c/extension-functions.c"
 }
}
function _tanhFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 454 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),454,(14817|0)); //@line 454 "c/extension-functions.c"
  // unreachable; //@line 454 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 454 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 454 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 454 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 454 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 454 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 454 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 454 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 454 "c/extension-functions.c"
  return; //@line 454 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 454 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 454 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 454 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 454 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 454 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 454 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 454 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 454 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 454 "c/extension-functions.c"
 if ($17) {
  $18 = (+_tanh($13)); //@line 454 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 454 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 454 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 454 "c/extension-functions.c"
  return; //@line 454 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 454 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 454 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 454 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 454 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 454 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 454 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 454 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 454 "c/extension-functions.c"
  return; //@line 454 "c/extension-functions.c"
 }
}
function _cothFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 456 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),456,(14826|0)); //@line 456 "c/extension-functions.c"
  // unreachable; //@line 456 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 456 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 456 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 456 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 456 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 456 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 456 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 456 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 456 "c/extension-functions.c"
  return; //@line 456 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 456 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 456 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 456 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 456 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 456 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 456 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 456 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 456 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 456 "c/extension-functions.c"
 if ($17) {
  $18 = (+_coth($13)); //@line 456 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 456 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 456 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 456 "c/extension-functions.c"
  return; //@line 456 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 456 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 456 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 456 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 456 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 456 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 456 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 456 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 456 "c/extension-functions.c"
  return; //@line 456 "c/extension-functions.c"
 }
}
function _expFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 474 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),474,(14835|0)); //@line 474 "c/extension-functions.c"
  // unreachable; //@line 474 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 474 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 474 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 474 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 474 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 474 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 474 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 474 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 474 "c/extension-functions.c"
  return; //@line 474 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 474 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 474 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 474 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 474 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 474 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 474 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 474 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 474 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 474 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_exp((+$13))); //@line 474 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 474 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 474 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 474 "c/extension-functions.c"
  return; //@line 474 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 474 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 474 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 474 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 474 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 474 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 474 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 474 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 474 "c/extension-functions.c"
  return; //@line 474 "c/extension-functions.c"
 }
}
function _logFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 472 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),472,(14843|0)); //@line 472 "c/extension-functions.c"
  // unreachable; //@line 472 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 472 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 472 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 472 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 472 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 472 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 472 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 472 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 472 "c/extension-functions.c"
  return; //@line 472 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 472 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 472 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 472 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 472 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 472 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 472 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 472 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 472 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 472 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_log((+$13))); //@line 472 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 472 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 472 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 472 "c/extension-functions.c"
  return; //@line 472 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 472 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 472 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 472 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 472 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 472 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 472 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 472 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 472 "c/extension-functions.c"
  return; //@line 472 "c/extension-functions.c"
 }
}
function _log10Func($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 473 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),473,(14851|0)); //@line 473 "c/extension-functions.c"
  // unreachable; //@line 473 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 473 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 473 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 473 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 473 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 473 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 473 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 473 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 473 "c/extension-functions.c"
  return; //@line 473 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 473 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 473 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 473 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 473 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 473 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 473 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 473 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 473 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 473 "c/extension-functions.c"
 if ($17) {
  $18 = (+_llvm_log10_f64((+$13))); //@line 473 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 473 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 473 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 473 "c/extension-functions.c"
  return; //@line 473 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 473 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 473 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 473 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 473 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 473 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 473 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 473 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 473 "c/extension-functions.c"
  return; //@line 473 "c/extension-functions.c"
 }
}
function _powerFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $23 = 0, $24 = 0.0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0.0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 546 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),546,(14861|0)); //@line 546 "c/extension-functions.c"
  // unreachable; //@line 546 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 548 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 548 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 548 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 548 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 548 "c/extension-functions.c"
 if (!($8)) {
  $9 = ((0) + 452|0); //@line 548 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 548 "c/extension-functions.c"
  $11 = ((($2)) + 4|0); //@line 548 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 548 "c/extension-functions.c"
  $13 = (FUNCTION_TABLE_ii[$10 & 255]($12)|0); //@line 548 "c/extension-functions.c"
  $14 = ($13|0)==(5); //@line 548 "c/extension-functions.c"
  if (!($14)) {
   $17 = ((0) + 420|0); //@line 551 "c/extension-functions.c"
   $18 = HEAP32[$17>>2]|0; //@line 551 "c/extension-functions.c"
   $19 = HEAP32[$2>>2]|0; //@line 551 "c/extension-functions.c"
   $20 = (+FUNCTION_TABLE_di[$18 & 127]($19)); //@line 551 "c/extension-functions.c"
   $21 = ((0) + 420|0); //@line 552 "c/extension-functions.c"
   $22 = HEAP32[$21>>2]|0; //@line 552 "c/extension-functions.c"
   $23 = HEAP32[$11>>2]|0; //@line 552 "c/extension-functions.c"
   $24 = (+FUNCTION_TABLE_di[$22 & 127]($23)); //@line 552 "c/extension-functions.c"
   $25 = (___errno_location()|0); //@line 553 "c/extension-functions.c"
   HEAP32[$25>>2] = 0; //@line 553 "c/extension-functions.c"
   $26 = (___errno_location()|0); //@line 555 "c/extension-functions.c"
   $27 = HEAP32[$26>>2]|0; //@line 555 "c/extension-functions.c"
   $28 = ($27|0)==(0); //@line 555 "c/extension-functions.c"
   if ($28) {
    $29 = (+Math_pow((+$20),(+$24))); //@line 554 "c/extension-functions.c"
    $30 = ((0) + 316|0); //@line 556 "c/extension-functions.c"
    $31 = HEAP32[$30>>2]|0; //@line 556 "c/extension-functions.c"
    FUNCTION_TABLE_vid[$31 & 127]($0,$29); //@line 556 "c/extension-functions.c"
    return; //@line 561 "c/extension-functions.c"
   } else {
    $32 = ((0) + 320|0); //@line 558 "c/extension-functions.c"
    $33 = HEAP32[$32>>2]|0; //@line 558 "c/extension-functions.c"
    $34 = (___errno_location()|0); //@line 558 "c/extension-functions.c"
    $35 = HEAP32[$34>>2]|0; //@line 558 "c/extension-functions.c"
    $36 = (_strerror($35)|0); //@line 558 "c/extension-functions.c"
    $37 = (___errno_location()|0); //@line 558 "c/extension-functions.c"
    $38 = HEAP32[$37>>2]|0; //@line 558 "c/extension-functions.c"
    FUNCTION_TABLE_viii[$33 & 255]($0,$36,$38); //@line 558 "c/extension-functions.c"
    return; //@line 561 "c/extension-functions.c"
   }
  }
 }
 $15 = ((0) + 336|0); //@line 549 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 549 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$16 & 127]($0); //@line 549 "c/extension-functions.c"
 return; //@line 561 "c/extension-functions.c"
}
function _signFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp15 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 590 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),590,(14871|0)); //@line 590 "c/extension-functions.c"
  // unreachable; //@line 590 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 591 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 591 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 591 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 591 "c/extension-functions.c"
 switch ($7|0) {
 case 1:  {
  $8 = ((0) + 428|0); //@line 593 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 593 "c/extension-functions.c"
  $10 = HEAP32[$2>>2]|0; //@line 593 "c/extension-functions.c"
  $11 = (FUNCTION_TABLE_ii[$9 & 255]($10)|0); //@line 593 "c/extension-functions.c"
  $12 = tempRet0; //@line 593 "c/extension-functions.c"
  $13 = ($12|0)>(0); //@line 594 "c/extension-functions.c"
  $14 = ($11>>>0)>(0); //@line 594 "c/extension-functions.c"
  $15 = ($12|0)==(0); //@line 594 "c/extension-functions.c"
  $16 = $15 & $14; //@line 594 "c/extension-functions.c"
  $17 = $13 | $16; //@line 594 "c/extension-functions.c"
  $18 = ($11|0)!=(0); //@line 594 "c/extension-functions.c"
  $19 = ($12|0)!=(0); //@line 594 "c/extension-functions.c"
  $20 = $18 | $19; //@line 594 "c/extension-functions.c"
  $21 = $20 << 31 >> 31; //@line 594 "c/extension-functions.c"
  $22 = ($21|0)<(0); //@line 594 "c/extension-functions.c"
  $23 = $22 << 31 >> 31; //@line 594 "c/extension-functions.c"
  $24 = $17 ? 1 : $21; //@line 594 "c/extension-functions.c"
  $25 = $17 ? 0 : $23; //@line 594 "c/extension-functions.c"
  $26 = ((0) + 332|0); //@line 595 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 595 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$27 & 255]($0,$24,$25); //@line 595 "c/extension-functions.c"
  return; //@line 611 "c/extension-functions.c"
  break;
 }
 case 5:  {
  $28 = ((0) + 336|0); //@line 599 "c/extension-functions.c"
  $29 = HEAP32[$28>>2]|0; //@line 599 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$29 & 127]($0); //@line 599 "c/extension-functions.c"
  return; //@line 611 "c/extension-functions.c"
  break;
 }
 default: {
  $30 = ((0) + 420|0); //@line 605 "c/extension-functions.c"
  $31 = HEAP32[$30>>2]|0; //@line 605 "c/extension-functions.c"
  $32 = HEAP32[$2>>2]|0; //@line 605 "c/extension-functions.c"
  $33 = (+FUNCTION_TABLE_di[$31 & 127]($32)); //@line 605 "c/extension-functions.c"
  $34 = $33 > 0.0; //@line 606 "c/extension-functions.c"
  $35 = $33 < 0.0; //@line 606 "c/extension-functions.c"
  $phitmp15 = (+($35<<31>>31)); //@line 606 "c/extension-functions.c"
  $36 = $34 ? 1.0 : $phitmp15; //@line 606 "c/extension-functions.c"
  $37 = ((0) + 316|0); //@line 607 "c/extension-functions.c"
  $38 = HEAP32[$37>>2]|0; //@line 607 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$38 & 127]($0,$36); //@line 607 "c/extension-functions.c"
  return; //@line 611 "c/extension-functions.c"
 }
 }
}
function _sqrtFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 375 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),375,(14880|0)); //@line 375 "c/extension-functions.c"
  // unreachable; //@line 375 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 375 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 375 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 375 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 375 "c/extension-functions.c"
 $cond = ($7|0)==(5); //@line 375 "c/extension-functions.c"
 if ($cond) {
  $8 = ((0) + 336|0); //@line 375 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 375 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$9 & 127]($0); //@line 375 "c/extension-functions.c"
  return; //@line 375 "c/extension-functions.c"
 }
 $10 = ((0) + 420|0); //@line 375 "c/extension-functions.c"
 $11 = HEAP32[$10>>2]|0; //@line 375 "c/extension-functions.c"
 $12 = HEAP32[$2>>2]|0; //@line 375 "c/extension-functions.c"
 $13 = (+FUNCTION_TABLE_di[$11 & 127]($12)); //@line 375 "c/extension-functions.c"
 $14 = (___errno_location()|0); //@line 375 "c/extension-functions.c"
 HEAP32[$14>>2] = 0; //@line 375 "c/extension-functions.c"
 $15 = (___errno_location()|0); //@line 375 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 375 "c/extension-functions.c"
 $17 = ($16|0)==(0); //@line 375 "c/extension-functions.c"
 if ($17) {
  $18 = (+Math_sqrt((+$13))); //@line 375 "c/extension-functions.c"
  $19 = ((0) + 316|0); //@line 375 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 375 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$20 & 127]($0,$18); //@line 375 "c/extension-functions.c"
  return; //@line 375 "c/extension-functions.c"
 } else {
  $21 = ((0) + 320|0); //@line 375 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 375 "c/extension-functions.c"
  $23 = (___errno_location()|0); //@line 375 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 375 "c/extension-functions.c"
  $25 = (_strerror($24)|0); //@line 375 "c/extension-functions.c"
  $26 = (___errno_location()|0); //@line 375 "c/extension-functions.c"
  $27 = HEAP32[$26>>2]|0; //@line 375 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$25,$27); //@line 375 "c/extension-functions.c"
  return; //@line 375 "c/extension-functions.c"
 }
}
function _squareFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0.0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 514 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),514,(14889|0)); //@line 514 "c/extension-functions.c"
  // unreachable; //@line 514 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 515 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 515 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 515 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 515 "c/extension-functions.c"
 switch ($7|0) {
 case 1:  {
  $8 = ((0) + 428|0); //@line 517 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 517 "c/extension-functions.c"
  $10 = HEAP32[$2>>2]|0; //@line 517 "c/extension-functions.c"
  $11 = (FUNCTION_TABLE_ii[$9 & 255]($10)|0); //@line 517 "c/extension-functions.c"
  $12 = tempRet0; //@line 517 "c/extension-functions.c"
  $13 = ((0) + 332|0); //@line 518 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 518 "c/extension-functions.c"
  $15 = (___muldi3(($11|0),($12|0),($11|0),($12|0))|0); //@line 518 "c/extension-functions.c"
  $16 = tempRet0; //@line 518 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$14 & 255]($0,$15,$16); //@line 518 "c/extension-functions.c"
  return; //@line 531 "c/extension-functions.c"
  break;
 }
 case 5:  {
  $17 = ((0) + 336|0); //@line 522 "c/extension-functions.c"
  $18 = HEAP32[$17>>2]|0; //@line 522 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$18 & 127]($0); //@line 522 "c/extension-functions.c"
  return; //@line 531 "c/extension-functions.c"
  break;
 }
 default: {
  $19 = ((0) + 420|0); //@line 526 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 526 "c/extension-functions.c"
  $21 = HEAP32[$2>>2]|0; //@line 526 "c/extension-functions.c"
  $22 = (+FUNCTION_TABLE_di[$20 & 127]($21)); //@line 526 "c/extension-functions.c"
  $23 = ((0) + 316|0); //@line 527 "c/extension-functions.c"
  $24 = HEAP32[$23>>2]|0; //@line 527 "c/extension-functions.c"
  $25 = $22 * $22; //@line 527 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$24 & 127]($0,$25); //@line 527 "c/extension-functions.c"
  return; //@line 531 "c/extension-functions.c"
 }
 }
}
function _ceilFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 620 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),620,(14900|0)); //@line 620 "c/extension-functions.c"
  // unreachable; //@line 620 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 621 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 621 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 621 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 621 "c/extension-functions.c"
 switch ($7|0) {
 case 1:  {
  $8 = ((0) + 428|0); //@line 623 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 623 "c/extension-functions.c"
  $10 = HEAP32[$2>>2]|0; //@line 623 "c/extension-functions.c"
  $11 = (FUNCTION_TABLE_ii[$9 & 255]($10)|0); //@line 623 "c/extension-functions.c"
  $12 = tempRet0; //@line 623 "c/extension-functions.c"
  $13 = ((0) + 332|0); //@line 624 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 624 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$14 & 255]($0,$11,$12); //@line 624 "c/extension-functions.c"
  return; //@line 637 "c/extension-functions.c"
  break;
 }
 case 5:  {
  $15 = ((0) + 336|0); //@line 628 "c/extension-functions.c"
  $16 = HEAP32[$15>>2]|0; //@line 628 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$16 & 127]($0); //@line 628 "c/extension-functions.c"
  return; //@line 637 "c/extension-functions.c"
  break;
 }
 default: {
  $17 = ((0) + 420|0); //@line 632 "c/extension-functions.c"
  $18 = HEAP32[$17>>2]|0; //@line 632 "c/extension-functions.c"
  $19 = HEAP32[$2>>2]|0; //@line 632 "c/extension-functions.c"
  $20 = (+FUNCTION_TABLE_di[$18 & 127]($19)); //@line 632 "c/extension-functions.c"
  $21 = ((0) + 332|0); //@line 633 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 633 "c/extension-functions.c"
  $23 = (+Math_ceil((+$20))); //@line 633 "c/extension-functions.c"
  $24 = (~~$23)>>>0; //@line 633 "c/extension-functions.c"
  $25 = +Math_abs($23) >= 1.0 ? $23 > 0.0 ? (~~+Math_min(+Math_floor($23 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($23 - +(~~$23 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 633 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$24,$25); //@line 633 "c/extension-functions.c"
  return; //@line 637 "c/extension-functions.c"
 }
 }
}
function _floorFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 645 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),645,(14909|0)); //@line 645 "c/extension-functions.c"
  // unreachable; //@line 645 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 646 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 646 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 646 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 646 "c/extension-functions.c"
 switch ($7|0) {
 case 1:  {
  $8 = ((0) + 428|0); //@line 648 "c/extension-functions.c"
  $9 = HEAP32[$8>>2]|0; //@line 648 "c/extension-functions.c"
  $10 = HEAP32[$2>>2]|0; //@line 648 "c/extension-functions.c"
  $11 = (FUNCTION_TABLE_ii[$9 & 255]($10)|0); //@line 648 "c/extension-functions.c"
  $12 = tempRet0; //@line 648 "c/extension-functions.c"
  $13 = ((0) + 332|0); //@line 649 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 649 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$14 & 255]($0,$11,$12); //@line 649 "c/extension-functions.c"
  return; //@line 662 "c/extension-functions.c"
  break;
 }
 case 5:  {
  $15 = ((0) + 336|0); //@line 653 "c/extension-functions.c"
  $16 = HEAP32[$15>>2]|0; //@line 653 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$16 & 127]($0); //@line 653 "c/extension-functions.c"
  return; //@line 662 "c/extension-functions.c"
  break;
 }
 default: {
  $17 = ((0) + 420|0); //@line 657 "c/extension-functions.c"
  $18 = HEAP32[$17>>2]|0; //@line 657 "c/extension-functions.c"
  $19 = HEAP32[$2>>2]|0; //@line 657 "c/extension-functions.c"
  $20 = (+FUNCTION_TABLE_di[$18 & 127]($19)); //@line 657 "c/extension-functions.c"
  $21 = ((0) + 332|0); //@line 658 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 658 "c/extension-functions.c"
  $23 = (+Math_floor((+$20))); //@line 658 "c/extension-functions.c"
  $24 = (~~$23)>>>0; //@line 658 "c/extension-functions.c"
  $25 = +Math_abs($23) >= 1.0 ? $23 > 0.0 ? (~~+Math_min(+Math_floor($23 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($23 - +(~~$23 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 658 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$22 & 255]($0,$24,$25); //@line 658 "c/extension-functions.c"
  return; //@line 662 "c/extension-functions.c"
 }
 }
}
function _piFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((0) + 316|0); //@line 503 "c/extension-functions.c"
 $4 = HEAP32[$3>>2]|0; //@line 503 "c/extension-functions.c"
 FUNCTION_TABLE_vid[$4 & 127]($0,3.1415926535897931); //@line 503 "c/extension-functions.c"
 return; //@line 504 "c/extension-functions.c"
}
function _replicateFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 676 "c/extension-functions.c"
 if (!($3)) {
  return; //@line 705 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 676 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 676 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 676 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 676 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 676 "c/extension-functions.c"
 if ($8) {
  return; //@line 705 "c/extension-functions.c"
 }
 $9 = ((0) + 428|0); //@line 679 "c/extension-functions.c"
 $10 = HEAP32[$9>>2]|0; //@line 679 "c/extension-functions.c"
 $11 = ((($2)) + 4|0); //@line 679 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 679 "c/extension-functions.c"
 $13 = (FUNCTION_TABLE_ii[$10 & 255]($12)|0); //@line 679 "c/extension-functions.c"
 $14 = tempRet0; //@line 679 "c/extension-functions.c"
 $15 = ($14|0)<(0); //@line 681 "c/extension-functions.c"
 if ($15) {
  $16 = ((0) + 320|0); //@line 682 "c/extension-functions.c"
  $17 = HEAP32[$16>>2]|0; //@line 682 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$17 & 255]($0,14919,-1); //@line 682 "c/extension-functions.c"
  return; //@line 705 "c/extension-functions.c"
 }
 $18 = ((0) + 412|0); //@line 685 "c/extension-functions.c"
 $19 = HEAP32[$18>>2]|0; //@line 685 "c/extension-functions.c"
 $20 = HEAP32[$2>>2]|0; //@line 685 "c/extension-functions.c"
 $21 = (FUNCTION_TABLE_ii[$19 & 255]($20)|0); //@line 685 "c/extension-functions.c"
 $22 = ((0) + 272|0); //@line 687 "c/extension-functions.c"
 $23 = HEAP32[$22>>2]|0; //@line 687 "c/extension-functions.c"
 $24 = Math_imul($21, $13)|0; //@line 687 "c/extension-functions.c"
 $25 = (($24) + 1)|0; //@line 687 "c/extension-functions.c"
 $26 = (FUNCTION_TABLE_ii[$23 & 255]($25)|0); //@line 687 "c/extension-functions.c"
 $27 = ((0) + 272|0); //@line 688 "c/extension-functions.c"
 $28 = HEAP32[$27>>2]|0; //@line 688 "c/extension-functions.c"
 $29 = (($21) + 1)|0; //@line 688 "c/extension-functions.c"
 $30 = (FUNCTION_TABLE_ii[$28 & 255]($29)|0); //@line 688 "c/extension-functions.c"
 $31 = ($26|0)!=(0|0); //@line 689 "c/extension-functions.c"
 $32 = ($30|0)!=(0|0); //@line 689 "c/extension-functions.c"
 $or$cond = $31 & $32; //@line 689 "c/extension-functions.c"
 if ($or$cond) {
  $39 = ((0) + 436|0); //@line 695 "c/extension-functions.c"
  $40 = HEAP32[$39>>2]|0; //@line 695 "c/extension-functions.c"
  $41 = HEAP32[$2>>2]|0; //@line 695 "c/extension-functions.c"
  $42 = (FUNCTION_TABLE_ii[$40 & 255]($41)|0); //@line 695 "c/extension-functions.c"
  (_strcpy($30,$42)|0); //@line 695 "c/extension-functions.c"
  $43 = ($14|0)>(0); //@line 697 "c/extension-functions.c"
  $44 = ($13>>>0)>(0); //@line 697 "c/extension-functions.c"
  $45 = ($14|0)==(0); //@line 697 "c/extension-functions.c"
  $46 = $45 & $44; //@line 697 "c/extension-functions.c"
  $47 = $43 | $46; //@line 697 "c/extension-functions.c"
  if ($47) {
   $49 = 0;$51 = 0;
   while(1) {
    $48 = Math_imul($21, $49)|0; //@line 698 "c/extension-functions.c"
    $50 = (($26) + ($48)|0); //@line 698 "c/extension-functions.c"
    (_strcpy($50,$30)|0); //@line 698 "c/extension-functions.c"
    $52 = (_i64Add(($49|0),($51|0),1,0)|0); //@line 697 "c/extension-functions.c"
    $53 = tempRet0; //@line 697 "c/extension-functions.c"
    $54 = ($53|0)<($14|0); //@line 697 "c/extension-functions.c"
    $55 = ($52>>>0)<($13>>>0); //@line 697 "c/extension-functions.c"
    $56 = ($53|0)==($14|0); //@line 697 "c/extension-functions.c"
    $57 = $56 & $55; //@line 697 "c/extension-functions.c"
    $58 = $54 | $57; //@line 697 "c/extension-functions.c"
    if ($58) {
     $49 = $52;$51 = $53;
    } else {
     break;
    }
   }
  }
  $59 = ((0) + 340|0); //@line 701 "c/extension-functions.c"
  $60 = HEAP32[$59>>2]|0; //@line 701 "c/extension-functions.c"
  FUNCTION_TABLE_viiii[$60 & 127]($0,$26,-1,(-1)); //@line 701 "c/extension-functions.c"
  $61 = ((0) + 232|0); //@line 702 "c/extension-functions.c"
  $62 = HEAP32[$61>>2]|0; //@line 702 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$62 & 127]($26); //@line 702 "c/extension-functions.c"
  $63 = ((0) + 232|0); //@line 703 "c/extension-functions.c"
  $64 = HEAP32[$63>>2]|0; //@line 703 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$64 & 127]($30); //@line 703 "c/extension-functions.c"
  return; //@line 705 "c/extension-functions.c"
 }
 $33 = ((0) + 548|0); //@line 690 "c/extension-functions.c"
 $34 = HEAP32[$33>>2]|0; //@line 690 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$34 & 127]($0); //@line 690 "c/extension-functions.c"
 if ($31) {
  $35 = ((0) + 232|0); //@line 691 "c/extension-functions.c"
  $36 = HEAP32[$35>>2]|0; //@line 691 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$36 & 127]($26); //@line 691 "c/extension-functions.c"
 }
 if (!($32)) {
  return; //@line 705 "c/extension-functions.c"
 }
 $37 = ((0) + 232|0); //@line 692 "c/extension-functions.c"
 $38 = HEAP32[$37>>2]|0; //@line 692 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$38 & 127]($30); //@line 692 "c/extension-functions.c"
 return; //@line 705 "c/extension-functions.c"
}
function _charindexFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(3); //@line 1038 "c/extension-functions.c"
 $4 = $1 | 1; //@line 1038 "c/extension-functions.c"
 $5 = ($4|0)==(3); //@line 1038 "c/extension-functions.c"
 if (!($5)) {
  ___assert_fail((14932|0),(14241|0),1038,(14950|0)); //@line 1038 "c/extension-functions.c"
  // unreachable; //@line 1038 "c/extension-functions.c"
 }
 $6 = ((0) + 452|0); //@line 1040 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1040 "c/extension-functions.c"
 $8 = HEAP32[$2>>2]|0; //@line 1040 "c/extension-functions.c"
 $9 = (FUNCTION_TABLE_ii[$7 & 255]($8)|0); //@line 1040 "c/extension-functions.c"
 $10 = ($9|0)==(5); //@line 1040 "c/extension-functions.c"
 if (!($10)) {
  $11 = ((0) + 452|0); //@line 1040 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 1040 "c/extension-functions.c"
  $13 = ((($2)) + 4|0); //@line 1040 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 1040 "c/extension-functions.c"
  $15 = (FUNCTION_TABLE_ii[$12 & 255]($14)|0); //@line 1040 "c/extension-functions.c"
  $16 = ($15|0)==(5); //@line 1040 "c/extension-functions.c"
  if (!($16)) {
   $19 = ((0) + 436|0); //@line 1045 "c/extension-functions.c"
   $20 = HEAP32[$19>>2]|0; //@line 1045 "c/extension-functions.c"
   $21 = HEAP32[$2>>2]|0; //@line 1045 "c/extension-functions.c"
   $22 = (FUNCTION_TABLE_ii[$20 & 255]($21)|0); //@line 1045 "c/extension-functions.c"
   $23 = ($22|0)==(0|0); //@line 1046 "c/extension-functions.c"
   if ($23) {
    return; //@line 1059 "c/extension-functions.c"
   }
   $24 = ((0) + 436|0); //@line 1047 "c/extension-functions.c"
   $25 = HEAP32[$24>>2]|0; //@line 1047 "c/extension-functions.c"
   $26 = HEAP32[$13>>2]|0; //@line 1047 "c/extension-functions.c"
   $27 = (FUNCTION_TABLE_ii[$25 & 255]($26)|0); //@line 1047 "c/extension-functions.c"
   if ($3) {
    $28 = ((0) + 424|0); //@line 1049 "c/extension-functions.c"
    $29 = HEAP32[$28>>2]|0; //@line 1049 "c/extension-functions.c"
    $30 = ((($2)) + 8|0); //@line 1049 "c/extension-functions.c"
    $31 = HEAP32[$30>>2]|0; //@line 1049 "c/extension-functions.c"
    $32 = (FUNCTION_TABLE_ii[$29 & 255]($31)|0); //@line 1049 "c/extension-functions.c"
    $33 = (($32) + -1)|0; //@line 1049 "c/extension-functions.c"
    $34 = ($33|0)>(0); //@line 1050 "c/extension-functions.c"
    $spec$store$select = $34 ? $33 : 0; //@line 1050 "c/extension-functions.c"
    $$0 = $spec$store$select;
   } else {
    $$0 = 0;
   }
   $35 = (__substr($22,$27,$$0)|0); //@line 1057 "c/extension-functions.c"
   $36 = ((0) + 328|0); //@line 1058 "c/extension-functions.c"
   $37 = HEAP32[$36>>2]|0; //@line 1058 "c/extension-functions.c"
   $38 = (($35) + 1)|0; //@line 1058 "c/extension-functions.c"
   FUNCTION_TABLE_vii[$37 & 127]($0,$38); //@line 1058 "c/extension-functions.c"
   return; //@line 1059 "c/extension-functions.c"
  }
 }
 $17 = ((0) + 336|0); //@line 1041 "c/extension-functions.c"
 $18 = HEAP32[$17>>2]|0; //@line 1041 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$18 & 127]($0); //@line 1041 "c/extension-functions.c"
 return; //@line 1059 "c/extension-functions.c"
}
function _leftFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$036$lcssa = 0, $$03637 = 0, $$038 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 1073 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),1073,(14964|0)); //@line 1073 "c/extension-functions.c"
  // unreachable; //@line 1073 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 1075 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 1075 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 1075 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 1075 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 1075 "c/extension-functions.c"
 if (!($8)) {
  $9 = ((0) + 452|0); //@line 1075 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 1075 "c/extension-functions.c"
  $11 = ((($2)) + 4|0); //@line 1075 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 1075 "c/extension-functions.c"
  $13 = (FUNCTION_TABLE_ii[$10 & 255]($12)|0); //@line 1075 "c/extension-functions.c"
  $14 = ($13|0)==(5); //@line 1075 "c/extension-functions.c"
  if (!($14)) {
   $17 = ((0) + 436|0); //@line 1080 "c/extension-functions.c"
   $18 = HEAP32[$17>>2]|0; //@line 1080 "c/extension-functions.c"
   $19 = HEAP32[$2>>2]|0; //@line 1080 "c/extension-functions.c"
   $20 = (FUNCTION_TABLE_ii[$18 & 255]($19)|0); //@line 1080 "c/extension-functions.c"
   $21 = ((0) + 424|0); //@line 1081 "c/extension-functions.c"
   $22 = HEAP32[$21>>2]|0; //@line 1081 "c/extension-functions.c"
   $23 = HEAP32[$11>>2]|0; //@line 1081 "c/extension-functions.c"
   $24 = (FUNCTION_TABLE_ii[$22 & 255]($23)|0); //@line 1081 "c/extension-functions.c"
   $25 = (_sqlite3ReadUtf8($20)|0); //@line 1084 "c/extension-functions.c"
   $26 = ($25|0)==(0); //@line 1084 "c/extension-functions.c"
   L7: do {
    if ($26) {
     $$036$lcssa = $20;
    } else {
     $$03637 = $20;$$038 = 0;
     while(1) {
      $27 = (($$038) + 1)|0; //@line 1084 "c/extension-functions.c"
      $28 = ($$038|0)<($24|0); //@line 1084 "c/extension-functions.c"
      if (!($28)) {
       $$036$lcssa = $$03637;
       break L7;
      }
      $$1 = $$03637;
      while(1) {
       $29 = ((($$1)) + 1|0); //@line 1085 "c/extension-functions.c"
       $30 = HEAP8[$29>>0]|0; //@line 1085 "c/extension-functions.c"
       $31 = $30 & -64; //@line 1085 "c/extension-functions.c"
       $32 = ($31<<24>>24)==(-128); //@line 1085 "c/extension-functions.c"
       if ($32) {
        $$1 = $29;
       } else {
        break;
       }
      }
      $33 = (_sqlite3ReadUtf8($29)|0); //@line 1084 "c/extension-functions.c"
      $34 = ($33|0)==(0); //@line 1084 "c/extension-functions.c"
      if ($34) {
       $$036$lcssa = $29;
       break;
      } else {
       $$03637 = $29;$$038 = $27;
      }
     }
    }
   } while(0);
   $35 = $$036$lcssa; //@line 1087 "c/extension-functions.c"
   $36 = $20; //@line 1087 "c/extension-functions.c"
   $37 = (($35) - ($36))|0; //@line 1087 "c/extension-functions.c"
   $38 = ((0) + 272|0); //@line 1089 "c/extension-functions.c"
   $39 = HEAP32[$38>>2]|0; //@line 1089 "c/extension-functions.c"
   $40 = (($37) + 1)|0; //@line 1089 "c/extension-functions.c"
   $41 = (FUNCTION_TABLE_ii[$39 & 255]($40)|0); //@line 1089 "c/extension-functions.c"
   $42 = ($41|0)==(0|0); //@line 1090 "c/extension-functions.c"
   if ($42) {
    $43 = ((0) + 548|0); //@line 1091 "c/extension-functions.c"
    $44 = HEAP32[$43>>2]|0; //@line 1091 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$44 & 127]($0); //@line 1091 "c/extension-functions.c"
    return; //@line 1098 "c/extension-functions.c"
   } else {
    (_strncpy($41,$20,$37)|0); //@line 1094 "c/extension-functions.c"
    $45 = (($41) + ($37)|0); //@line 1095 "c/extension-functions.c"
    HEAP8[$45>>0] = 0; //@line 1095 "c/extension-functions.c"
    $46 = ((0) + 340|0); //@line 1096 "c/extension-functions.c"
    $47 = HEAP32[$46>>2]|0; //@line 1096 "c/extension-functions.c"
    FUNCTION_TABLE_viiii[$47 & 127]($0,$41,-1,(-1)); //@line 1096 "c/extension-functions.c"
    $48 = ((0) + 232|0); //@line 1097 "c/extension-functions.c"
    $49 = HEAP32[$48>>2]|0; //@line 1097 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$49 & 127]($41); //@line 1097 "c/extension-functions.c"
    return; //@line 1098 "c/extension-functions.c"
   }
  }
 }
 $15 = ((0) + 336|0); //@line 1076 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 1076 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$16 & 127]($0); //@line 1076 "c/extension-functions.c"
 return; //@line 1098 "c/extension-functions.c"
}
function _rightFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$038$lcssa = 0, $$03842 = 0, $$043 = 0, $$1 = 0, $$2$lcssa = 0, $$241 = 0, $$3 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 1113 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),1113,(14973|0)); //@line 1113 "c/extension-functions.c"
  // unreachable; //@line 1113 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 1115 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 1115 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 1115 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 1115 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 1115 "c/extension-functions.c"
 if (!($8)) {
  $9 = ((0) + 452|0); //@line 1115 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 1115 "c/extension-functions.c"
  $11 = ((($2)) + 4|0); //@line 1115 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 1115 "c/extension-functions.c"
  $13 = (FUNCTION_TABLE_ii[$10 & 255]($12)|0); //@line 1115 "c/extension-functions.c"
  $14 = ($13|0)==(5); //@line 1115 "c/extension-functions.c"
  if (!($14)) {
   $17 = ((0) + 436|0); //@line 1120 "c/extension-functions.c"
   $18 = HEAP32[$17>>2]|0; //@line 1120 "c/extension-functions.c"
   $19 = HEAP32[$2>>2]|0; //@line 1120 "c/extension-functions.c"
   $20 = (FUNCTION_TABLE_ii[$18 & 255]($19)|0); //@line 1120 "c/extension-functions.c"
   $21 = ((0) + 424|0); //@line 1121 "c/extension-functions.c"
   $22 = HEAP32[$21>>2]|0; //@line 1121 "c/extension-functions.c"
   $23 = HEAP32[$11>>2]|0; //@line 1121 "c/extension-functions.c"
   $24 = (FUNCTION_TABLE_ii[$22 & 255]($23)|0); //@line 1121 "c/extension-functions.c"
   $25 = (_sqlite3ReadUtf8($20)|0); //@line 1124 "c/extension-functions.c"
   $26 = ($25|0)==(0); //@line 1124 "c/extension-functions.c"
   if ($26) {
    $$0$lcssa = 0;$$038$lcssa = $20;
   } else {
    $$03842 = $20;$$043 = 0;
    while(1) {
     $$1 = $$03842;
     while(1) {
      $27 = ((($$1)) + 1|0); //@line 1125 "c/extension-functions.c"
      $28 = HEAP8[$27>>0]|0; //@line 1125 "c/extension-functions.c"
      $29 = $28 & -64; //@line 1125 "c/extension-functions.c"
      $30 = ($29<<24>>24)==(-128); //@line 1125 "c/extension-functions.c"
      if ($30) {
       $$1 = $27;
      } else {
       break;
      }
     }
     $31 = (($$043) + 1)|0; //@line 1126 "c/extension-functions.c"
     $32 = (_sqlite3ReadUtf8($27)|0); //@line 1124 "c/extension-functions.c"
     $33 = ($32|0)==(0); //@line 1124 "c/extension-functions.c"
     if ($33) {
      $$0$lcssa = $31;$$038$lcssa = $27;
      break;
     } else {
      $$03842 = $27;$$043 = $31;
     }
    }
   }
   $34 = (($$0$lcssa) - ($24))|0; //@line 1132 "c/extension-functions.c"
   $35 = ($34|0)>(0); //@line 1133 "c/extension-functions.c"
   if ($35) {
    $$241 = $20;$$in = $34;
    while(1) {
     $$3 = $$241;
     while(1) {
      $36 = ((($$3)) + 1|0); //@line 1137 "c/extension-functions.c"
      $37 = HEAP8[$36>>0]|0; //@line 1137 "c/extension-functions.c"
      $38 = $37 & -64; //@line 1137 "c/extension-functions.c"
      $39 = ($38<<24>>24)==(-128); //@line 1137 "c/extension-functions.c"
      if ($39) {
       $$3 = $36;
      } else {
       break;
      }
     }
     $40 = (($$in) + -1)|0; //@line 1136 "c/extension-functions.c"
     $41 = ($$in|0)>(1); //@line 1136 "c/extension-functions.c"
     if ($41) {
      $$241 = $36;$$in = $40;
     } else {
      $$2$lcssa = $36;
      break;
     }
    }
   } else {
    $$2$lcssa = $20;
   }
   $42 = ((0) + 272|0); //@line 1140 "c/extension-functions.c"
   $43 = HEAP32[$42>>2]|0; //@line 1140 "c/extension-functions.c"
   $44 = $$038$lcssa; //@line 1140 "c/extension-functions.c"
   $45 = $$2$lcssa; //@line 1140 "c/extension-functions.c"
   $46 = (($44) + 1)|0; //@line 1140 "c/extension-functions.c"
   $47 = (($46) - ($45))|0; //@line 1140 "c/extension-functions.c"
   $48 = (FUNCTION_TABLE_ii[$43 & 255]($47)|0); //@line 1140 "c/extension-functions.c"
   $49 = ($48|0)==(0|0); //@line 1141 "c/extension-functions.c"
   if ($49) {
    $50 = ((0) + 548|0); //@line 1142 "c/extension-functions.c"
    $51 = HEAP32[$50>>2]|0; //@line 1142 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$51 & 127]($0); //@line 1142 "c/extension-functions.c"
    return; //@line 1148 "c/extension-functions.c"
   } else {
    (_strcpy($48,$$2$lcssa)|0); //@line 1145 "c/extension-functions.c"
    $52 = ((0) + 340|0); //@line 1146 "c/extension-functions.c"
    $53 = HEAP32[$52>>2]|0; //@line 1146 "c/extension-functions.c"
    FUNCTION_TABLE_viiii[$53 & 127]($0,$48,-1,(-1)); //@line 1146 "c/extension-functions.c"
    $54 = ((0) + 232|0); //@line 1147 "c/extension-functions.c"
    $55 = HEAP32[$54>>2]|0; //@line 1147 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$55 & 127]($48); //@line 1147 "c/extension-functions.c"
    return; //@line 1148 "c/extension-functions.c"
   }
  }
 }
 $15 = ((0) + 336|0); //@line 1116 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 1116 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$16 & 127]($0); //@line 1116 "c/extension-functions.c"
 return; //@line 1148 "c/extension-functions.c"
}
function _reverseFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03541 = 0, $$03640 = 0, $$039 = 0, $$1$lcssa = 0, $$137 = 0, $$138 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 1323 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14983|0),(14241|0),1323,(14991|0)); //@line 1323 "c/extension-functions.c"
  // unreachable; //@line 1323 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 1325 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 1325 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 1325 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 1325 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 1325 "c/extension-functions.c"
 if ($8) {
  $9 = ((0) + 336|0); //@line 1326 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 1326 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$10 & 127]($0); //@line 1326 "c/extension-functions.c"
  return; //@line 1350 "c/extension-functions.c"
 }
 $11 = ((0) + 436|0); //@line 1329 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 1329 "c/extension-functions.c"
 $13 = HEAP32[$2>>2]|0; //@line 1329 "c/extension-functions.c"
 $14 = (FUNCTION_TABLE_ii[$12 & 255]($13)|0); //@line 1329 "c/extension-functions.c"
 $15 = (_strlen($14)|0); //@line 1330 "c/extension-functions.c"
 $16 = ((0) + 272|0); //@line 1331 "c/extension-functions.c"
 $17 = HEAP32[$16>>2]|0; //@line 1331 "c/extension-functions.c"
 $18 = (($15) + 1)|0; //@line 1331 "c/extension-functions.c"
 $19 = (FUNCTION_TABLE_ii[$17 & 255]($18)|0); //@line 1331 "c/extension-functions.c"
 $20 = ($19|0)==(0|0); //@line 1332 "c/extension-functions.c"
 if ($20) {
  $21 = ((0) + 548|0); //@line 1333 "c/extension-functions.c"
  $22 = HEAP32[$21>>2]|0; //@line 1333 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$22 & 127]($0); //@line 1333 "c/extension-functions.c"
  return; //@line 1350 "c/extension-functions.c"
 }
 $23 = (($19) + ($15)|0); //@line 1336 "c/extension-functions.c"
 HEAP8[$23>>0] = 0; //@line 1337 "c/extension-functions.c"
 $24 = (_sqlite3ReadUtf8($14)|0); //@line 1340 "c/extension-functions.c"
 $25 = ($24|0)==(0); //@line 1340 "c/extension-functions.c"
 if (!($25)) {
  $26 = ((($23)) + -1|0); //@line 1337 "c/extension-functions.c"
  $$03541 = $26;$$03640 = $14;
  while(1) {
   $$137 = $$03640;
   while(1) {
    $27 = ((($$137)) + 1|0); //@line 1342 "c/extension-functions.c"
    $28 = HEAP8[$27>>0]|0; //@line 1342 "c/extension-functions.c"
    $29 = $28 & -64; //@line 1342 "c/extension-functions.c"
    $30 = ($29<<24>>24)==(-128); //@line 1342 "c/extension-functions.c"
    if ($30) {
     $$137 = $27;
    } else {
     break;
    }
   }
   $31 = ($$137>>>0)<($$03640>>>0); //@line 1343 "c/extension-functions.c"
   if ($31) {
    $$1$lcssa = $$03541;
   } else {
    $$039 = 1;$$138 = $$03541;$33 = $$137;
    while(1) {
     $32 = HEAP8[$33>>0]|0; //@line 1344 "c/extension-functions.c"
     $34 = ((($$138)) + -1|0); //@line 1344 "c/extension-functions.c"
     HEAP8[$$138>>0] = $32; //@line 1344 "c/extension-functions.c"
     $35 = (($$039) + 1)|0; //@line 1343 "c/extension-functions.c"
     $36 = $$039 ^ -1; //@line 1343 "c/extension-functions.c"
     $37 = (($27) + ($36)|0); //@line 1343 "c/extension-functions.c"
     $38 = ($37>>>0)<($$03640>>>0); //@line 1343 "c/extension-functions.c"
     if ($38) {
      $$1$lcssa = $34;
      break;
     } else {
      $$039 = $35;$$138 = $34;$33 = $37;
     }
    }
   }
   $39 = (_sqlite3ReadUtf8($27)|0); //@line 1340 "c/extension-functions.c"
   $40 = ($39|0)==(0); //@line 1340 "c/extension-functions.c"
   if ($40) {
    break;
   } else {
    $$03541 = $$1$lcssa;$$03640 = $27;
   }
  }
 }
 $41 = ((0) + 340|0); //@line 1348 "c/extension-functions.c"
 $42 = HEAP32[$41>>2]|0; //@line 1348 "c/extension-functions.c"
 FUNCTION_TABLE_viiii[$42 & 127]($0,$19,-1,(-1)); //@line 1348 "c/extension-functions.c"
 $43 = ((0) + 232|0); //@line 1349 "c/extension-functions.c"
 $44 = HEAP32[$43>>2]|0; //@line 1349 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$44 & 127]($19); //@line 1349 "c/extension-functions.c"
 return; //@line 1350 "c/extension-functions.c"
}
function _properFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$024 = 0, $$024$in = 0, $$026$lcssa = 0, $$02628 = 0, $$029 = 0, $$1 = 0, $$125 = 0, $$pn = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 724 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),724,(15003|0)); //@line 724 "c/extension-functions.c"
  // unreachable; //@line 724 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 725 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 725 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 725 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 725 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 725 "c/extension-functions.c"
 if ($8) {
  $9 = ((0) + 336|0); //@line 726 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 726 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$10 & 127]($0); //@line 726 "c/extension-functions.c"
  return; //@line 755 "c/extension-functions.c"
 }
 $11 = ((0) + 436|0); //@line 730 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 730 "c/extension-functions.c"
 $13 = HEAP32[$2>>2]|0; //@line 730 "c/extension-functions.c"
 $14 = (FUNCTION_TABLE_ii[$12 & 255]($13)|0); //@line 730 "c/extension-functions.c"
 $15 = (_sqlite3StrDup($14)|0); //@line 731 "c/extension-functions.c"
 $16 = ($15|0)==(0|0); //@line 732 "c/extension-functions.c"
 if ($16) {
  $17 = ((0) + 548|0); //@line 733 "c/extension-functions.c"
  $18 = HEAP32[$17>>2]|0; //@line 733 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$18 & 127]($0); //@line 733 "c/extension-functions.c"
  return; //@line 755 "c/extension-functions.c"
 }
 $19 = HEAP8[$14>>0]|0; //@line 738 "c/extension-functions.c"
 $20 = ($19<<24>>24)==(0); //@line 738 "c/extension-functions.c"
 if ($20) {
  $$026$lcssa = $15;
 } else {
  $21 = $19 << 24 >> 24; //@line 738 "c/extension-functions.c"
  $$02628 = $15;$$029 = 1;$$pn = $14;$23 = $21;$37 = $19;
  while(1) {
   $22 = ((($$pn)) + 1|0); //@line 738 "c/extension-functions.c"
   $24 = (_isblank($23)|0); //@line 739 "c/extension-functions.c"
   $25 = ($24|0)==(0); //@line 739 "c/extension-functions.c"
   if ($25) {
    $26 = ($$029|0)==(1); //@line 742 "c/extension-functions.c"
    if ($26) {
     $27 = (_toupper($23)|0); //@line 743 "c/extension-functions.c"
     $$024$in = $27;
    } else {
     $28 = (_tolower($23)|0); //@line 745 "c/extension-functions.c"
     $$024$in = $28;
    }
    $$024 = $$024$in&255;
    $$1 = 0;$$125 = $$024;
   } else {
    $$1 = 1;$$125 = $37;
   }
   $29 = ((($$02628)) + 1|0); //@line 749 "c/extension-functions.c"
   HEAP8[$$02628>>0] = $$125; //@line 749 "c/extension-functions.c"
   $30 = HEAP8[$22>>0]|0; //@line 738 "c/extension-functions.c"
   $31 = $30 << 24 >> 24; //@line 738 "c/extension-functions.c"
   $32 = ($30<<24>>24)==(0); //@line 738 "c/extension-functions.c"
   if ($32) {
    $$026$lcssa = $29;
    break;
   } else {
    $$02628 = $29;$$029 = $$1;$$pn = $22;$23 = $31;$37 = $30;
   }
  }
 }
 HEAP8[$$026$lcssa>>0] = 0; //@line 751 "c/extension-functions.c"
 $33 = ((0) + 340|0); //@line 753 "c/extension-functions.c"
 $34 = HEAP32[$33>>2]|0; //@line 753 "c/extension-functions.c"
 FUNCTION_TABLE_viiii[$34 & 127]($0,$15,-1,(-1)); //@line 753 "c/extension-functions.c"
 $35 = ((0) + 232|0); //@line 754 "c/extension-functions.c"
 $36 = HEAP32[$35>>2]|0; //@line 754 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$36 & 127]($15); //@line 754 "c/extension-functions.c"
 return; //@line 755 "c/extension-functions.c"
}
function _padlFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$040 = 0, $$04142 = 0, $$043 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 771 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),771,(15014|0)); //@line 771 "c/extension-functions.c"
  // unreachable; //@line 771 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 773 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 773 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 773 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 773 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 773 "c/extension-functions.c"
 if ($8) {
  $9 = ((0) + 336|0); //@line 774 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 774 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$10 & 127]($0); //@line 774 "c/extension-functions.c"
  return; //@line 808 "c/extension-functions.c"
 }
 $11 = ((0) + 436|0); //@line 776 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 776 "c/extension-functions.c"
 $13 = HEAP32[$2>>2]|0; //@line 776 "c/extension-functions.c"
 $14 = (FUNCTION_TABLE_ii[$12 & 255]($13)|0); //@line 776 "c/extension-functions.c"
 $15 = ((0) + 428|0); //@line 777 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 777 "c/extension-functions.c"
 $17 = ((($2)) + 4|0); //@line 777 "c/extension-functions.c"
 $18 = HEAP32[$17>>2]|0; //@line 777 "c/extension-functions.c"
 $19 = (FUNCTION_TABLE_ii[$16 & 255]($18)|0); //@line 777 "c/extension-functions.c"
 $20 = tempRet0; //@line 777 "c/extension-functions.c"
 $21 = ($20|0)<(0); //@line 779 "c/extension-functions.c"
 if ($21) {
  $22 = ((0) + 320|0); //@line 780 "c/extension-functions.c"
  $23 = HEAP32[$22>>2]|0; //@line 780 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$23 & 255]($0,14919,-1); //@line 780 "c/extension-functions.c"
  return; //@line 808 "c/extension-functions.c"
 }
 $24 = (_sqlite3Utf8CharLen($14)|0); //@line 783 "c/extension-functions.c"
 $25 = ($24|0)<(0); //@line 783 "c/extension-functions.c"
 $26 = $25 << 31 >> 31; //@line 783 "c/extension-functions.c"
 $27 = ($20|0)>($26|0); //@line 784 "c/extension-functions.c"
 $28 = ($19>>>0)>($24>>>0); //@line 784 "c/extension-functions.c"
 $29 = ($20|0)==($26|0); //@line 784 "c/extension-functions.c"
 $30 = $29 & $28; //@line 784 "c/extension-functions.c"
 $31 = $27 | $30; //@line 784 "c/extension-functions.c"
 do {
  if ($31) {
   $38 = ((0) + 272|0); //@line 793 "c/extension-functions.c"
   $39 = HEAP32[$38>>2]|0; //@line 793 "c/extension-functions.c"
   $40 = (_strlen($14)|0); //@line 793 "c/extension-functions.c"
   $41 = (($19) + 1)|0; //@line 793 "c/extension-functions.c"
   $42 = (($41) - ($24))|0; //@line 793 "c/extension-functions.c"
   $43 = (($42) + ($40))|0; //@line 793 "c/extension-functions.c"
   $44 = (FUNCTION_TABLE_ii[$39 & 255]($43)|0); //@line 793 "c/extension-functions.c"
   $45 = ($44|0)==(0|0); //@line 794 "c/extension-functions.c"
   if ($45) {
    $46 = ((0) + 548|0); //@line 795 "c/extension-functions.c"
    $47 = HEAP32[$46>>2]|0; //@line 795 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$47 & 127]($0); //@line 795 "c/extension-functions.c"
    return; //@line 808 "c/extension-functions.c"
   }
   $$04142 = 1;$$043 = $44;
   while(1) {
    $48 = ((($$043)) + 1|0); //@line 800 "c/extension-functions.c"
    HEAP8[$$043>>0] = 32; //@line 800 "c/extension-functions.c"
    $49 = (($$04142) + 1)|0; //@line 799 "c/extension-functions.c"
    $50 = (_i64Add(($49|0),0,($24|0),($26|0))|0); //@line 799 "c/extension-functions.c"
    $51 = tempRet0; //@line 799 "c/extension-functions.c"
    $52 = ($51|0)>($20|0); //@line 799 "c/extension-functions.c"
    $53 = ($50>>>0)>($19>>>0); //@line 799 "c/extension-functions.c"
    $54 = ($51|0)==($20|0); //@line 799 "c/extension-functions.c"
    $55 = $54 & $53; //@line 799 "c/extension-functions.c"
    $56 = $52 | $55; //@line 799 "c/extension-functions.c"
    if ($56) {
     break;
    } else {
     $$04142 = $49;$$043 = $48;
    }
   }
   (_strcpy($48,$14)|0); //@line 803 "c/extension-functions.c"
   $$040 = $44;
  } else {
   $32 = (_sqlite3StrDup($14)|0); //@line 786 "c/extension-functions.c"
   $33 = ($32|0)==(0|0); //@line 787 "c/extension-functions.c"
   if (!($33)) {
    $36 = ((0) + 340|0); //@line 791 "c/extension-functions.c"
    $37 = HEAP32[$36>>2]|0; //@line 791 "c/extension-functions.c"
    FUNCTION_TABLE_viiii[$37 & 127]($0,$32,-1,(-1)); //@line 791 "c/extension-functions.c"
    $$040 = $32;
    break;
   }
   $34 = ((0) + 548|0); //@line 788 "c/extension-functions.c"
   $35 = HEAP32[$34>>2]|0; //@line 788 "c/extension-functions.c"
   FUNCTION_TABLE_vi[$35 & 127]($0); //@line 788 "c/extension-functions.c"
   return; //@line 808 "c/extension-functions.c"
  }
 } while(0);
 $57 = ((0) + 340|0); //@line 805 "c/extension-functions.c"
 $58 = HEAP32[$57>>2]|0; //@line 805 "c/extension-functions.c"
 FUNCTION_TABLE_viiii[$58 & 127]($0,$$040,-1,(-1)); //@line 805 "c/extension-functions.c"
 $59 = ((0) + 232|0); //@line 806 "c/extension-functions.c"
 $60 = HEAP32[$59>>2]|0; //@line 806 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$60 & 127]($$040); //@line 806 "c/extension-functions.c"
 return; //@line 808 "c/extension-functions.c"
}
function _padrFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$043 = 0, $$04445 = 0, $$046 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 825 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),825,(15023|0)); //@line 825 "c/extension-functions.c"
  // unreachable; //@line 825 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 827 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 827 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 827 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 827 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 827 "c/extension-functions.c"
 if ($8) {
  $9 = ((0) + 336|0); //@line 828 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 828 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$10 & 127]($0); //@line 828 "c/extension-functions.c"
  return; //@line 862 "c/extension-functions.c"
 }
 $11 = ((0) + 436|0); //@line 830 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 830 "c/extension-functions.c"
 $13 = HEAP32[$2>>2]|0; //@line 830 "c/extension-functions.c"
 $14 = (FUNCTION_TABLE_ii[$12 & 255]($13)|0); //@line 830 "c/extension-functions.c"
 $15 = ((0) + 428|0); //@line 831 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 831 "c/extension-functions.c"
 $17 = ((($2)) + 4|0); //@line 831 "c/extension-functions.c"
 $18 = HEAP32[$17>>2]|0; //@line 831 "c/extension-functions.c"
 $19 = (FUNCTION_TABLE_ii[$16 & 255]($18)|0); //@line 831 "c/extension-functions.c"
 $20 = tempRet0; //@line 831 "c/extension-functions.c"
 $21 = ($20|0)<(0); //@line 833 "c/extension-functions.c"
 if ($21) {
  $22 = ((0) + 320|0); //@line 834 "c/extension-functions.c"
  $23 = HEAP32[$22>>2]|0; //@line 834 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$23 & 255]($0,14919,-1); //@line 834 "c/extension-functions.c"
  return; //@line 862 "c/extension-functions.c"
 }
 $24 = (_sqlite3Utf8CharLen($14)|0); //@line 837 "c/extension-functions.c"
 $25 = ($24|0)<(0); //@line 837 "c/extension-functions.c"
 $26 = $25 << 31 >> 31; //@line 837 "c/extension-functions.c"
 $27 = ($20|0)>($26|0); //@line 838 "c/extension-functions.c"
 $28 = ($19>>>0)>($24>>>0); //@line 838 "c/extension-functions.c"
 $29 = ($20|0)==($26|0); //@line 838 "c/extension-functions.c"
 $30 = $29 & $28; //@line 838 "c/extension-functions.c"
 $31 = $27 | $30; //@line 838 "c/extension-functions.c"
 do {
  if ($31) {
   $38 = (_strlen($14)|0); //@line 847 "c/extension-functions.c"
   $39 = ((0) + 272|0); //@line 848 "c/extension-functions.c"
   $40 = HEAP32[$39>>2]|0; //@line 848 "c/extension-functions.c"
   $41 = (($19) + 1)|0; //@line 848 "c/extension-functions.c"
   $42 = (($41) - ($24))|0; //@line 848 "c/extension-functions.c"
   $43 = (($42) + ($38))|0; //@line 848 "c/extension-functions.c"
   $44 = (FUNCTION_TABLE_ii[$40 & 255]($43)|0); //@line 848 "c/extension-functions.c"
   $45 = ($44|0)==(0|0); //@line 849 "c/extension-functions.c"
   if ($45) {
    $46 = ((0) + 548|0); //@line 850 "c/extension-functions.c"
    $47 = HEAP32[$46>>2]|0; //@line 850 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$47 & 127]($0); //@line 850 "c/extension-functions.c"
    return; //@line 862 "c/extension-functions.c"
   }
   $48 = (_strcpy($44,$14)|0); //@line 853 "c/extension-functions.c"
   $49 = (($44) + ($38)|0); //@line 853 "c/extension-functions.c"
   $$04445 = 1;$$046 = $49;
   while(1) {
    $50 = ((($$046)) + 1|0); //@line 855 "c/extension-functions.c"
    HEAP8[$$046>>0] = 32; //@line 855 "c/extension-functions.c"
    $51 = (($$04445) + 1)|0; //@line 854 "c/extension-functions.c"
    $52 = (_i64Add(($51|0),0,($24|0),($26|0))|0); //@line 854 "c/extension-functions.c"
    $53 = tempRet0; //@line 854 "c/extension-functions.c"
    $54 = ($53|0)>($20|0); //@line 854 "c/extension-functions.c"
    $55 = ($52>>>0)>($19>>>0); //@line 854 "c/extension-functions.c"
    $56 = ($53|0)==($20|0); //@line 854 "c/extension-functions.c"
    $57 = $56 & $55; //@line 854 "c/extension-functions.c"
    $58 = $54 | $57; //@line 854 "c/extension-functions.c"
    if ($58) {
     break;
    } else {
     $$04445 = $51;$$046 = $50;
    }
   }
   HEAP8[$50>>0] = 0; //@line 857 "c/extension-functions.c"
   $$043 = $44;
  } else {
   $32 = (_sqlite3StrDup($14)|0); //@line 840 "c/extension-functions.c"
   $33 = ($32|0)==(0|0); //@line 841 "c/extension-functions.c"
   if (!($33)) {
    $36 = ((0) + 340|0); //@line 845 "c/extension-functions.c"
    $37 = HEAP32[$36>>2]|0; //@line 845 "c/extension-functions.c"
    FUNCTION_TABLE_viiii[$37 & 127]($0,$32,-1,(-1)); //@line 845 "c/extension-functions.c"
    $$043 = $32;
    break;
   }
   $34 = ((0) + 548|0); //@line 842 "c/extension-functions.c"
   $35 = HEAP32[$34>>2]|0; //@line 842 "c/extension-functions.c"
   FUNCTION_TABLE_vi[$35 & 127]($0); //@line 842 "c/extension-functions.c"
   return; //@line 862 "c/extension-functions.c"
  }
 } while(0);
 $59 = ((0) + 340|0); //@line 859 "c/extension-functions.c"
 $60 = HEAP32[$59>>2]|0; //@line 859 "c/extension-functions.c"
 FUNCTION_TABLE_viiii[$60 & 127]($0,$$043,-1,(-1)); //@line 859 "c/extension-functions.c"
 $61 = ((0) + 232|0); //@line 860 "c/extension-functions.c"
 $62 = HEAP32[$61>>2]|0; //@line 860 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$62 & 127]($$043); //@line 860 "c/extension-functions.c"
 return; //@line 862 "c/extension-functions.c"
}
function _padcFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$049 = 0, $$050$lcssa = 0, $$05054 = 0, $$055 = 0, $$1$lcssa = 0, $$15152 = 0, $$153 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 880 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),880,(15032|0)); //@line 880 "c/extension-functions.c"
  // unreachable; //@line 880 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 882 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 882 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 882 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 882 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 882 "c/extension-functions.c"
 if ($8) {
  $9 = ((0) + 336|0); //@line 883 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 883 "c/extension-functions.c"
  FUNCTION_TABLE_vi[$10 & 127]($0); //@line 883 "c/extension-functions.c"
  return; //@line 922 "c/extension-functions.c"
 }
 $11 = ((0) + 436|0); //@line 885 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 885 "c/extension-functions.c"
 $13 = HEAP32[$2>>2]|0; //@line 885 "c/extension-functions.c"
 $14 = (FUNCTION_TABLE_ii[$12 & 255]($13)|0); //@line 885 "c/extension-functions.c"
 $15 = ((0) + 428|0); //@line 886 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 886 "c/extension-functions.c"
 $17 = ((($2)) + 4|0); //@line 886 "c/extension-functions.c"
 $18 = HEAP32[$17>>2]|0; //@line 886 "c/extension-functions.c"
 $19 = (FUNCTION_TABLE_ii[$16 & 255]($18)|0); //@line 886 "c/extension-functions.c"
 $20 = tempRet0; //@line 886 "c/extension-functions.c"
 $21 = ($20|0)<(0); //@line 888 "c/extension-functions.c"
 if ($21) {
  $22 = ((0) + 320|0); //@line 889 "c/extension-functions.c"
  $23 = HEAP32[$22>>2]|0; //@line 889 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$23 & 255]($0,14919,-1); //@line 889 "c/extension-functions.c"
  return; //@line 922 "c/extension-functions.c"
 }
 $24 = (_sqlite3Utf8CharLen($14)|0); //@line 892 "c/extension-functions.c"
 $25 = ($24|0)<(0); //@line 892 "c/extension-functions.c"
 $26 = $25 << 31 >> 31; //@line 892 "c/extension-functions.c"
 $27 = ($20|0)>($26|0); //@line 893 "c/extension-functions.c"
 $28 = ($19>>>0)>($24>>>0); //@line 893 "c/extension-functions.c"
 $29 = ($20|0)==($26|0); //@line 893 "c/extension-functions.c"
 $30 = $29 & $28; //@line 893 "c/extension-functions.c"
 $31 = $27 | $30; //@line 893 "c/extension-functions.c"
 do {
  if ($31) {
   $38 = (_strlen($14)|0); //@line 902 "c/extension-functions.c"
   $39 = ((0) + 272|0); //@line 903 "c/extension-functions.c"
   $40 = HEAP32[$39>>2]|0; //@line 903 "c/extension-functions.c"
   $41 = (($19) + 1)|0; //@line 903 "c/extension-functions.c"
   $42 = (($41) - ($24))|0; //@line 903 "c/extension-functions.c"
   $43 = (($42) + ($38))|0; //@line 903 "c/extension-functions.c"
   $44 = (FUNCTION_TABLE_ii[$40 & 255]($43)|0); //@line 903 "c/extension-functions.c"
   $45 = ($44|0)==(0|0); //@line 904 "c/extension-functions.c"
   if ($45) {
    $46 = ((0) + 548|0); //@line 905 "c/extension-functions.c"
    $47 = HEAP32[$46>>2]|0; //@line 905 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$47 & 127]($0); //@line 905 "c/extension-functions.c"
    return; //@line 922 "c/extension-functions.c"
   }
   $48 = (_i64Add(($24|0),($26|0),2,0)|0); //@line 909 "c/extension-functions.c"
   $49 = tempRet0; //@line 909 "c/extension-functions.c"
   $50 = ($49|0)>($20|0); //@line 909 "c/extension-functions.c"
   $51 = ($48>>>0)>($19>>>0); //@line 909 "c/extension-functions.c"
   $52 = ($49|0)==($20|0); //@line 909 "c/extension-functions.c"
   $53 = $52 & $51; //@line 909 "c/extension-functions.c"
   $54 = $50 | $53; //@line 909 "c/extension-functions.c"
   if ($54) {
    $$0$lcssa = $44;$$050$lcssa = 1;
   } else {
    $$05054 = 1;$$055 = $44;
    while(1) {
     $55 = ((($$055)) + 1|0); //@line 910 "c/extension-functions.c"
     HEAP8[$$055>>0] = 32; //@line 910 "c/extension-functions.c"
     $56 = (($$05054) + 1)|0; //@line 909 "c/extension-functions.c"
     $57 = $56 << 1; //@line 909 "c/extension-functions.c"
     $58 = (_i64Add(($57|0),0,($24|0),($26|0))|0); //@line 909 "c/extension-functions.c"
     $59 = tempRet0; //@line 909 "c/extension-functions.c"
     $60 = ($59|0)>($20|0); //@line 909 "c/extension-functions.c"
     $61 = ($58>>>0)>($19>>>0); //@line 909 "c/extension-functions.c"
     $62 = ($59|0)==($20|0); //@line 909 "c/extension-functions.c"
     $63 = $62 & $61; //@line 909 "c/extension-functions.c"
     $64 = $60 | $63; //@line 909 "c/extension-functions.c"
     if ($64) {
      $$0$lcssa = $55;$$050$lcssa = $56;
      break;
     } else {
      $$05054 = $56;$$055 = $55;
     }
    }
   }
   (_strcpy($$0$lcssa,$14)|0); //@line 912 "c/extension-functions.c"
   $65 = (($$0$lcssa) + ($38)|0); //@line 913 "c/extension-functions.c"
   $66 = (_i64Add(($$050$lcssa|0),0,($24|0),($26|0))|0); //@line 914 "c/extension-functions.c"
   $67 = tempRet0; //@line 914 "c/extension-functions.c"
   $68 = ($67|0)>($20|0); //@line 914 "c/extension-functions.c"
   $69 = ($66>>>0)>($19>>>0); //@line 914 "c/extension-functions.c"
   $70 = ($67|0)==($20|0); //@line 914 "c/extension-functions.c"
   $71 = $70 & $69; //@line 914 "c/extension-functions.c"
   $72 = $68 | $71; //@line 914 "c/extension-functions.c"
   if ($72) {
    $$1$lcssa = $65;
   } else {
    $$15152 = $$050$lcssa;$$153 = $65;
    while(1) {
     $73 = ((($$153)) + 1|0); //@line 915 "c/extension-functions.c"
     HEAP8[$$153>>0] = 32; //@line 915 "c/extension-functions.c"
     $74 = (($$15152) + 1)|0; //@line 914 "c/extension-functions.c"
     $75 = (_i64Add(($74|0),0,($24|0),($26|0))|0); //@line 914 "c/extension-functions.c"
     $76 = tempRet0; //@line 914 "c/extension-functions.c"
     $77 = ($76|0)>($20|0); //@line 914 "c/extension-functions.c"
     $78 = ($75>>>0)>($19>>>0); //@line 914 "c/extension-functions.c"
     $79 = ($76|0)==($20|0); //@line 914 "c/extension-functions.c"
     $80 = $79 & $78; //@line 914 "c/extension-functions.c"
     $81 = $77 | $80; //@line 914 "c/extension-functions.c"
     if ($81) {
      $$1$lcssa = $73;
      break;
     } else {
      $$15152 = $74;$$153 = $73;
     }
    }
   }
   HEAP8[$$1$lcssa>>0] = 0; //@line 917 "c/extension-functions.c"
   $$049 = $44;
  } else {
   $32 = (_sqlite3StrDup($14)|0); //@line 895 "c/extension-functions.c"
   $33 = ($32|0)==(0|0); //@line 896 "c/extension-functions.c"
   if (!($33)) {
    $36 = ((0) + 340|0); //@line 900 "c/extension-functions.c"
    $37 = HEAP32[$36>>2]|0; //@line 900 "c/extension-functions.c"
    FUNCTION_TABLE_viiii[$37 & 127]($0,$32,-1,(-1)); //@line 900 "c/extension-functions.c"
    $$049 = $32;
    break;
   }
   $34 = ((0) + 548|0); //@line 897 "c/extension-functions.c"
   $35 = HEAP32[$34>>2]|0; //@line 897 "c/extension-functions.c"
   FUNCTION_TABLE_vi[$35 & 127]($0); //@line 897 "c/extension-functions.c"
   return; //@line 922 "c/extension-functions.c"
  }
 } while(0);
 $82 = ((0) + 340|0); //@line 919 "c/extension-functions.c"
 $83 = HEAP32[$82>>2]|0; //@line 919 "c/extension-functions.c"
 FUNCTION_TABLE_viiii[$83 & 127]($0,$$049,-1,(-1)); //@line 919 "c/extension-functions.c"
 $84 = ((0) + 232|0); //@line 920 "c/extension-functions.c"
 $85 = HEAP32[$84>>2]|0; //@line 920 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$85 & 127]($$049); //@line 920 "c/extension-functions.c"
 return; //@line 922 "c/extension-functions.c"
}
function _strfilterFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$04860 = 0, $$050 = 0, $$051$lcssa = 0, $$061 = 0, $$1 = 0, $$149 = 0, $$152 = 0, $$lcssa53 = 0, $$not = 0, $$not56 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond57 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(2); //@line 939 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14292|0),(14241|0),939,(15041|0)); //@line 939 "c/extension-functions.c"
  // unreachable; //@line 939 "c/extension-functions.c"
 }
 $4 = ((0) + 452|0); //@line 941 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 941 "c/extension-functions.c"
 $6 = HEAP32[$2>>2]|0; //@line 941 "c/extension-functions.c"
 $7 = (FUNCTION_TABLE_ii[$5 & 255]($6)|0); //@line 941 "c/extension-functions.c"
 $8 = ($7|0)==(5); //@line 941 "c/extension-functions.c"
 if (!($8)) {
  $9 = ((0) + 452|0); //@line 941 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 941 "c/extension-functions.c"
  $11 = ((($2)) + 4|0); //@line 941 "c/extension-functions.c"
  $12 = HEAP32[$11>>2]|0; //@line 941 "c/extension-functions.c"
  $13 = (FUNCTION_TABLE_ii[$10 & 255]($12)|0); //@line 941 "c/extension-functions.c"
  $14 = ($13|0)==(5); //@line 941 "c/extension-functions.c"
  if (!($14)) {
   $17 = ((0) + 436|0); //@line 944 "c/extension-functions.c"
   $18 = HEAP32[$17>>2]|0; //@line 944 "c/extension-functions.c"
   $19 = HEAP32[$2>>2]|0; //@line 944 "c/extension-functions.c"
   $20 = (FUNCTION_TABLE_ii[$18 & 255]($19)|0); //@line 944 "c/extension-functions.c"
   $21 = ((0) + 436|0); //@line 945 "c/extension-functions.c"
   $22 = HEAP32[$21>>2]|0; //@line 945 "c/extension-functions.c"
   $23 = HEAP32[$11>>2]|0; //@line 945 "c/extension-functions.c"
   $24 = (FUNCTION_TABLE_ii[$22 & 255]($23)|0); //@line 945 "c/extension-functions.c"
   $25 = ((0) + 272|0); //@line 950 "c/extension-functions.c"
   $26 = HEAP32[$25>>2]|0; //@line 950 "c/extension-functions.c"
   $27 = (_strlen($20)|0); //@line 950 "c/extension-functions.c"
   $28 = (($27) + 1)|0; //@line 950 "c/extension-functions.c"
   $29 = (FUNCTION_TABLE_ii[$26 & 255]($28)|0); //@line 950 "c/extension-functions.c"
   $30 = ($29|0)==(0|0); //@line 951 "c/extension-functions.c"
   if ($30) {
    $31 = ((0) + 548|0); //@line 952 "c/extension-functions.c"
    $32 = HEAP32[$31>>2]|0; //@line 952 "c/extension-functions.c"
    FUNCTION_TABLE_vi[$32 & 127]($0); //@line 952 "c/extension-functions.c"
    return; //@line 975 "c/extension-functions.c"
   }
   $33 = (_sqlite3ReadUtf8($20)|0); //@line 957 "c/extension-functions.c"
   $34 = ($33|0)==(0); //@line 957 "c/extension-functions.c"
   if ($34) {
    $$0$lcssa = $29;
   } else {
    $$04860 = $20;$$061 = $29;$38 = $33;
    while(1) {
     $35 = (_sqlite3ReadUtf8($24)|0); //@line 959 "c/extension-functions.c"
     $36 = ($35|0)!=(0); //@line 959 "c/extension-functions.c"
     $$not56 = $36 ^ 1; //@line 959 "c/extension-functions.c"
     $37 = ($35|0)==($38|0); //@line 959 "c/extension-functions.c"
     $or$cond57 = $37 | $$not56; //@line 959 "c/extension-functions.c"
     L15: do {
      if ($or$cond57) {
       $$051$lcssa = $24;$$lcssa53 = $36;
      } else {
       $$152 = $24;
       while(1) {
        $39 = ((($$152)) + 1|0); //@line 960 "c/extension-functions.c"
        $40 = HEAP8[$39>>0]|0; //@line 960 "c/extension-functions.c"
        $41 = $40 & -64; //@line 960 "c/extension-functions.c"
        $42 = ($41<<24>>24)==(-128); //@line 960 "c/extension-functions.c"
        if (!($42)) {
         $43 = (_sqlite3ReadUtf8($39)|0); //@line 959 "c/extension-functions.c"
         $44 = ($43|0)!=(0); //@line 959 "c/extension-functions.c"
         $$not = $44 ^ 1; //@line 959 "c/extension-functions.c"
         $45 = ($43|0)==($38|0); //@line 959 "c/extension-functions.c"
         $or$cond = $45 | $$not; //@line 959 "c/extension-functions.c"
         if ($or$cond) {
          $$051$lcssa = $39;$$lcssa53 = $44;
          break L15;
         }
        }
        $$152 = $39;
       }
      }
     } while(0);
     if ($$lcssa53) {
      $$050 = $$051$lcssa;
      while(1) {
       $46 = ((($$050)) + 1|0); //@line 964 "c/extension-functions.c"
       $47 = HEAP8[$46>>0]|0; //@line 964 "c/extension-functions.c"
       $48 = $47 & -64; //@line 964 "c/extension-functions.c"
       $49 = ($48<<24>>24)==(-128); //@line 964 "c/extension-functions.c"
       if ($49) {
        $$050 = $46;
       } else {
        break;
       }
      }
      $50 = $46; //@line 965 "c/extension-functions.c"
      $51 = $$051$lcssa; //@line 965 "c/extension-functions.c"
      $52 = (($50) - ($51))|0; //@line 965 "c/extension-functions.c"
      (_strncpy($$061,$$051$lcssa,$52)|0); //@line 965 "c/extension-functions.c"
      $53 = (($$061) + ($52)|0); //@line 966 "c/extension-functions.c"
      $$1 = $53;
     } else {
      $$1 = $$061;
     }
     $$149 = $$04860;
     while(1) {
      $54 = ((($$149)) + 1|0); //@line 968 "c/extension-functions.c"
      $55 = HEAP8[$54>>0]|0; //@line 968 "c/extension-functions.c"
      $56 = $55 & -64; //@line 968 "c/extension-functions.c"
      $57 = ($56<<24>>24)==(-128); //@line 968 "c/extension-functions.c"
      if ($57) {
       $$149 = $54;
      } else {
       break;
      }
     }
     $58 = (_sqlite3ReadUtf8($54)|0); //@line 957 "c/extension-functions.c"
     $59 = ($58|0)==(0); //@line 957 "c/extension-functions.c"
     if ($59) {
      $$0$lcssa = $$1;
      break;
     } else {
      $$04860 = $54;$$061 = $$1;$38 = $58;
     }
    }
   }
   HEAP8[$$0$lcssa>>0] = 0; //@line 970 "c/extension-functions.c"
   $60 = ((0) + 340|0); //@line 972 "c/extension-functions.c"
   $61 = HEAP32[$60>>2]|0; //@line 972 "c/extension-functions.c"
   FUNCTION_TABLE_viiii[$61 & 127]($0,$29,-1,(-1)); //@line 972 "c/extension-functions.c"
   $62 = ((0) + 232|0); //@line 973 "c/extension-functions.c"
   $63 = HEAP32[$62>>2]|0; //@line 973 "c/extension-functions.c"
   FUNCTION_TABLE_vi[$63 & 127]($29); //@line 973 "c/extension-functions.c"
   return; //@line 975 "c/extension-functions.c"
  }
 }
 $15 = ((0) + 336|0); //@line 942 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 942 "c/extension-functions.c"
 FUNCTION_TABLE_vi[$16 & 127]($0); //@line 942 "c/extension-functions.c"
 return; //@line 975 "c/extension-functions.c"
}
function _varianceStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0.0, $28 = 0.0, $29 = 0.0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0.0, $41 = 0, $42 = 0.0, $43 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(1); //@line 1395 "c/extension-functions.c"
 if (!($3)) {
  ___assert_fail((14233|0),(14241|0),1395,(15055|0)); //@line 1395 "c/extension-functions.c"
  // unreachable; //@line 1395 "c/extension-functions.c"
 }
 $4 = HEAP32[0>>2]|0; //@line 1396 "c/extension-functions.c"
 $5 = (FUNCTION_TABLE_iii[$4 & 255]($0,24)|0); //@line 1396 "c/extension-functions.c"
 $6 = ((0) + 432|0); //@line 1398 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1398 "c/extension-functions.c"
 $8 = HEAP32[$2>>2]|0; //@line 1398 "c/extension-functions.c"
 $9 = (FUNCTION_TABLE_ii[$7 & 255]($8)|0); //@line 1398 "c/extension-functions.c"
 $10 = ($9|0)==(5); //@line 1398 "c/extension-functions.c"
 if ($10) {
  return; //@line 1405 "c/extension-functions.c"
 }
 $11 = ((($5)) + 16|0); //@line 1399 "c/extension-functions.c"
 $12 = $11; //@line 1399 "c/extension-functions.c"
 $13 = $12; //@line 1399 "c/extension-functions.c"
 $14 = HEAP32[$13>>2]|0; //@line 1399 "c/extension-functions.c"
 $15 = (($12) + 4)|0; //@line 1399 "c/extension-functions.c"
 $16 = $15; //@line 1399 "c/extension-functions.c"
 $17 = HEAP32[$16>>2]|0; //@line 1399 "c/extension-functions.c"
 $18 = (_i64Add(($14|0),($17|0),1,0)|0); //@line 1399 "c/extension-functions.c"
 $19 = tempRet0; //@line 1399 "c/extension-functions.c"
 $20 = $11; //@line 1399 "c/extension-functions.c"
 $21 = $20; //@line 1399 "c/extension-functions.c"
 HEAP32[$21>>2] = $18; //@line 1399 "c/extension-functions.c"
 $22 = (($20) + 4)|0; //@line 1399 "c/extension-functions.c"
 $23 = $22; //@line 1399 "c/extension-functions.c"
 HEAP32[$23>>2] = $19; //@line 1399 "c/extension-functions.c"
 $24 = ((0) + 420|0); //@line 1400 "c/extension-functions.c"
 $25 = HEAP32[$24>>2]|0; //@line 1400 "c/extension-functions.c"
 $26 = HEAP32[$2>>2]|0; //@line 1400 "c/extension-functions.c"
 $27 = (+FUNCTION_TABLE_di[$25 & 127]($26)); //@line 1400 "c/extension-functions.c"
 $28 = +HEAPF64[$5>>3]; //@line 1401 "c/extension-functions.c"
 $29 = $27 - $28; //@line 1401 "c/extension-functions.c"
 $30 = $11; //@line 1402 "c/extension-functions.c"
 $31 = $30; //@line 1402 "c/extension-functions.c"
 $32 = HEAP32[$31>>2]|0; //@line 1402 "c/extension-functions.c"
 $33 = (($30) + 4)|0; //@line 1402 "c/extension-functions.c"
 $34 = $33; //@line 1402 "c/extension-functions.c"
 $35 = HEAP32[$34>>2]|0; //@line 1402 "c/extension-functions.c"
 $36 = (+($32>>>0)) + (4294967296.0*(+($35|0))); //@line 1402 "c/extension-functions.c"
 $37 = $29 / $36; //@line 1402 "c/extension-functions.c"
 $38 = $28 + $37; //@line 1402 "c/extension-functions.c"
 HEAPF64[$5>>3] = $38; //@line 1402 "c/extension-functions.c"
 $39 = $27 - $38; //@line 1403 "c/extension-functions.c"
 $40 = $29 * $39; //@line 1403 "c/extension-functions.c"
 $41 = ((($5)) + 8|0); //@line 1403 "c/extension-functions.c"
 $42 = +HEAPF64[$41>>3]; //@line 1403 "c/extension-functions.c"
 $43 = $42 + $40; //@line 1403 "c/extension-functions.c"
 HEAPF64[$41>>3] = $43; //@line 1403 "c/extension-functions.c"
 return; //@line 1405 "c/extension-functions.c"
}
function _stdevFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1608 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1608 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1609 "c/extension-functions.c"
 if (!($3)) {
  $4 = ((($2)) + 16|0); //@line 1609 "c/extension-functions.c"
  $5 = $4; //@line 1609 "c/extension-functions.c"
  $6 = $5; //@line 1609 "c/extension-functions.c"
  $7 = HEAP32[$6>>2]|0; //@line 1609 "c/extension-functions.c"
  $8 = (($5) + 4)|0; //@line 1609 "c/extension-functions.c"
  $9 = $8; //@line 1609 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 1609 "c/extension-functions.c"
  $11 = ($10|0)>(0); //@line 1609 "c/extension-functions.c"
  $12 = ($7>>>0)>(1); //@line 1609 "c/extension-functions.c"
  $13 = ($10|0)==(0); //@line 1609 "c/extension-functions.c"
  $14 = $13 & $12; //@line 1609 "c/extension-functions.c"
  $15 = $11 | $14; //@line 1609 "c/extension-functions.c"
  if ($15) {
   $16 = ((0) + 316|0); //@line 1610 "c/extension-functions.c"
   $17 = HEAP32[$16>>2]|0; //@line 1610 "c/extension-functions.c"
   $18 = ((($2)) + 8|0); //@line 1610 "c/extension-functions.c"
   $19 = +HEAPF64[$18>>3]; //@line 1610 "c/extension-functions.c"
   $20 = (_i64Add(($7|0),($10|0),-1,-1)|0); //@line 1610 "c/extension-functions.c"
   $21 = tempRet0; //@line 1610 "c/extension-functions.c"
   $22 = (+($20>>>0)) + (4294967296.0*(+($21|0))); //@line 1610 "c/extension-functions.c"
   $23 = $19 / $22; //@line 1610 "c/extension-functions.c"
   $24 = (+Math_sqrt((+$23))); //@line 1610 "c/extension-functions.c"
   FUNCTION_TABLE_vid[$17 & 127]($0,$24); //@line 1610 "c/extension-functions.c"
   return; //@line 1614 "c/extension-functions.c"
  }
 }
 $25 = ((0) + 316|0); //@line 1612 "c/extension-functions.c"
 $26 = HEAP32[$25>>2]|0; //@line 1612 "c/extension-functions.c"
 FUNCTION_TABLE_vid[$26 & 127]($0,0.0); //@line 1612 "c/extension-functions.c"
 return; //@line 1614 "c/extension-functions.c"
}
function _varianceFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0, $25 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1621 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1621 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1622 "c/extension-functions.c"
 if (!($3)) {
  $4 = ((($2)) + 16|0); //@line 1622 "c/extension-functions.c"
  $5 = $4; //@line 1622 "c/extension-functions.c"
  $6 = $5; //@line 1622 "c/extension-functions.c"
  $7 = HEAP32[$6>>2]|0; //@line 1622 "c/extension-functions.c"
  $8 = (($5) + 4)|0; //@line 1622 "c/extension-functions.c"
  $9 = $8; //@line 1622 "c/extension-functions.c"
  $10 = HEAP32[$9>>2]|0; //@line 1622 "c/extension-functions.c"
  $11 = ($10|0)>(0); //@line 1622 "c/extension-functions.c"
  $12 = ($7>>>0)>(1); //@line 1622 "c/extension-functions.c"
  $13 = ($10|0)==(0); //@line 1622 "c/extension-functions.c"
  $14 = $13 & $12; //@line 1622 "c/extension-functions.c"
  $15 = $11 | $14; //@line 1622 "c/extension-functions.c"
  if ($15) {
   $16 = ((0) + 316|0); //@line 1623 "c/extension-functions.c"
   $17 = HEAP32[$16>>2]|0; //@line 1623 "c/extension-functions.c"
   $18 = ((($2)) + 8|0); //@line 1623 "c/extension-functions.c"
   $19 = +HEAPF64[$18>>3]; //@line 1623 "c/extension-functions.c"
   $20 = (_i64Add(($7|0),($10|0),-1,-1)|0); //@line 1623 "c/extension-functions.c"
   $21 = tempRet0; //@line 1623 "c/extension-functions.c"
   $22 = (+($20>>>0)) + (4294967296.0*(+($21|0))); //@line 1623 "c/extension-functions.c"
   $23 = $19 / $22; //@line 1623 "c/extension-functions.c"
   FUNCTION_TABLE_vid[$17 & 127]($0,$23); //@line 1623 "c/extension-functions.c"
   return; //@line 1627 "c/extension-functions.c"
  }
 }
 $24 = ((0) + 316|0); //@line 1625 "c/extension-functions.c"
 $25 = HEAP32[$24>>2]|0; //@line 1625 "c/extension-functions.c"
 FUNCTION_TABLE_vid[$25 & 127]($0,0.0); //@line 1625 "c/extension-functions.c"
 return; //@line 1627 "c/extension-functions.c"
}
function _modeStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0.0;
 var $66 = 0, $67 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp + 12|0;
 $4 = sp;
 $5 = ($1|0)==(1); //@line 1418 "c/extension-functions.c"
 if (!($5)) {
  ___assert_fail((14233|0),(14241|0),1418,(15068|0)); //@line 1418 "c/extension-functions.c"
  // unreachable; //@line 1418 "c/extension-functions.c"
 }
 $6 = ((0) + 432|0); //@line 1419 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1419 "c/extension-functions.c"
 $8 = HEAP32[$2>>2]|0; //@line 1419 "c/extension-functions.c"
 $9 = (FUNCTION_TABLE_ii[$7 & 255]($8)|0); //@line 1419 "c/extension-functions.c"
 $10 = ($9|0)==(5); //@line 1421 "c/extension-functions.c"
 if ($10) {
  STACKTOP = sp;return; //@line 1452 "c/extension-functions.c"
 }
 $11 = HEAP32[0>>2]|0; //@line 1424 "c/extension-functions.c"
 $12 = (FUNCTION_TABLE_iii[$11 & 255]($0,64)|0); //@line 1424 "c/extension-functions.c"
 $13 = ((($12)) + 56|0); //@line 1426 "c/extension-functions.c"
 $14 = HEAP32[$13>>2]|0; //@line 1426 "c/extension-functions.c"
 $15 = ($14|0)==(0|0); //@line 1426 "c/extension-functions.c"
 do {
  if ($15) {
   $16 = (_calloc(1,12)|0); //@line 1427 "c/extension-functions.c"
   HEAP32[$13>>2] = $16; //@line 1427 "c/extension-functions.c"
   $17 = ($9|0)==(1); //@line 1428 "c/extension-functions.c"
   if ($17) {
    _map_make($3,144); //@line 1430 "c/extension-functions.c"
    ;HEAP32[$16>>2]=HEAP32[$3>>2]|0;HEAP32[$16+4>>2]=HEAP32[$3+4>>2]|0;HEAP32[$16+8>>2]=HEAP32[$3+8>>2]|0; //@line 1430 "c/extension-functions.c"
    $18 = ((($12)) + 48|0); //@line 1431 "c/extension-functions.c"
    $19 = $18; //@line 1431 "c/extension-functions.c"
    $20 = $19; //@line 1431 "c/extension-functions.c"
    HEAP32[$20>>2] = 0; //@line 1431 "c/extension-functions.c"
    $21 = (($19) + 4)|0; //@line 1431 "c/extension-functions.c"
    $22 = $21; //@line 1431 "c/extension-functions.c"
    HEAP32[$22>>2] = 0; //@line 1431 "c/extension-functions.c"
    break;
   } else {
    $23 = ((($12)) + 48|0); //@line 1433 "c/extension-functions.c"
    $24 = $23; //@line 1433 "c/extension-functions.c"
    $25 = $24; //@line 1433 "c/extension-functions.c"
    HEAP32[$25>>2] = 1; //@line 1433 "c/extension-functions.c"
    $26 = (($24) + 4)|0; //@line 1433 "c/extension-functions.c"
    $27 = $26; //@line 1433 "c/extension-functions.c"
    HEAP32[$27>>2] = 0; //@line 1433 "c/extension-functions.c"
    _map_make($4,145); //@line 1435 "c/extension-functions.c"
    ;HEAP32[$16>>2]=HEAP32[$4>>2]|0;HEAP32[$16+4>>2]=HEAP32[$4+4>>2]|0;HEAP32[$16+8>>2]=HEAP32[$4+8>>2]|0; //@line 1435 "c/extension-functions.c"
    break;
   }
  }
 } while(0);
 $28 = ((($12)) + 16|0); //@line 1439 "c/extension-functions.c"
 $29 = $28; //@line 1439 "c/extension-functions.c"
 $30 = $29; //@line 1439 "c/extension-functions.c"
 $31 = HEAP32[$30>>2]|0; //@line 1439 "c/extension-functions.c"
 $32 = (($29) + 4)|0; //@line 1439 "c/extension-functions.c"
 $33 = $32; //@line 1439 "c/extension-functions.c"
 $34 = HEAP32[$33>>2]|0; //@line 1439 "c/extension-functions.c"
 $35 = (_i64Add(($31|0),($34|0),1,0)|0); //@line 1439 "c/extension-functions.c"
 $36 = tempRet0; //@line 1439 "c/extension-functions.c"
 $37 = $28; //@line 1439 "c/extension-functions.c"
 $38 = $37; //@line 1439 "c/extension-functions.c"
 HEAP32[$38>>2] = $35; //@line 1439 "c/extension-functions.c"
 $39 = (($37) + 4)|0; //@line 1439 "c/extension-functions.c"
 $40 = $39; //@line 1439 "c/extension-functions.c"
 HEAP32[$40>>2] = $36; //@line 1439 "c/extension-functions.c"
 $41 = ((($12)) + 48|0); //@line 1441 "c/extension-functions.c"
 $42 = $41; //@line 1441 "c/extension-functions.c"
 $43 = $42; //@line 1441 "c/extension-functions.c"
 $44 = HEAP32[$43>>2]|0; //@line 1441 "c/extension-functions.c"
 $45 = (($42) + 4)|0; //@line 1441 "c/extension-functions.c"
 $46 = $45; //@line 1441 "c/extension-functions.c"
 $47 = HEAP32[$46>>2]|0; //@line 1441 "c/extension-functions.c"
 $48 = ($44|0)==(0); //@line 1441 "c/extension-functions.c"
 $49 = ($47|0)==(0); //@line 1441 "c/extension-functions.c"
 $50 = $48 & $49; //@line 1441 "c/extension-functions.c"
 if ($50) {
  $51 = ((0) + 428|0); //@line 1442 "c/extension-functions.c"
  $52 = HEAP32[$51>>2]|0; //@line 1442 "c/extension-functions.c"
  $53 = HEAP32[$2>>2]|0; //@line 1442 "c/extension-functions.c"
  $54 = (FUNCTION_TABLE_ii[$52 & 255]($53)|0); //@line 1442 "c/extension-functions.c"
  $55 = tempRet0; //@line 1442 "c/extension-functions.c"
  $56 = (_calloc(1,8)|0); //@line 1443 "c/extension-functions.c"
  $57 = $56; //@line 1444 "c/extension-functions.c"
  $58 = $57; //@line 1444 "c/extension-functions.c"
  HEAP32[$58>>2] = $54; //@line 1444 "c/extension-functions.c"
  $59 = (($57) + 4)|0; //@line 1444 "c/extension-functions.c"
  $60 = $59; //@line 1444 "c/extension-functions.c"
  HEAP32[$60>>2] = $55; //@line 1444 "c/extension-functions.c"
  $61 = HEAP32[$13>>2]|0; //@line 1445 "c/extension-functions.c"
  _map_insert($61,$56); //@line 1445 "c/extension-functions.c"
  STACKTOP = sp;return; //@line 1452 "c/extension-functions.c"
 } else {
  $62 = ((0) + 420|0); //@line 1447 "c/extension-functions.c"
  $63 = HEAP32[$62>>2]|0; //@line 1447 "c/extension-functions.c"
  $64 = HEAP32[$2>>2]|0; //@line 1447 "c/extension-functions.c"
  $65 = (+FUNCTION_TABLE_di[$63 & 127]($64)); //@line 1447 "c/extension-functions.c"
  $66 = (_calloc(1,8)|0); //@line 1448 "c/extension-functions.c"
  HEAPF64[$66>>3] = $65; //@line 1449 "c/extension-functions.c"
  $67 = HEAP32[$13>>2]|0; //@line 1450 "c/extension-functions.c"
  _map_insert($67,$66); //@line 1450 "c/extension-functions.c"
  STACKTOP = sp;return; //@line 1452 "c/extension-functions.c"
 }
}
function _modeFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1530 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1530 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1531 "c/extension-functions.c"
 if ($3) {
  return; //@line 1543 "c/extension-functions.c"
 }
 $4 = ((($2)) + 56|0); //@line 1531 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 1531 "c/extension-functions.c"
 $6 = ($5|0)==(0|0); //@line 1531 "c/extension-functions.c"
 if ($6) {
  return; //@line 1543 "c/extension-functions.c"
 }
 _map_iterate($5,74,$2); //@line 1532 "c/extension-functions.c"
 $7 = HEAP32[$4>>2]|0; //@line 1533 "c/extension-functions.c"
 _map_destroy($7); //@line 1533 "c/extension-functions.c"
 $8 = HEAP32[$4>>2]|0; //@line 1534 "c/extension-functions.c"
 _free($8); //@line 1534 "c/extension-functions.c"
 $9 = ((($2)) + 40|0); //@line 1536 "c/extension-functions.c"
 $10 = $9; //@line 1536 "c/extension-functions.c"
 $11 = $10; //@line 1536 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 1536 "c/extension-functions.c"
 $13 = (($10) + 4)|0; //@line 1536 "c/extension-functions.c"
 $14 = $13; //@line 1536 "c/extension-functions.c"
 $15 = HEAP32[$14>>2]|0; //@line 1536 "c/extension-functions.c"
 $16 = ($12|0)==(1); //@line 1536 "c/extension-functions.c"
 $17 = ($15|0)==(0); //@line 1536 "c/extension-functions.c"
 $18 = $16 & $17; //@line 1536 "c/extension-functions.c"
 if (!($18)) {
  return; //@line 1543 "c/extension-functions.c"
 }
 $19 = ((($2)) + 48|0); //@line 1537 "c/extension-functions.c"
 $20 = $19; //@line 1537 "c/extension-functions.c"
 $21 = $20; //@line 1537 "c/extension-functions.c"
 $22 = HEAP32[$21>>2]|0; //@line 1537 "c/extension-functions.c"
 $23 = (($20) + 4)|0; //@line 1537 "c/extension-functions.c"
 $24 = $23; //@line 1537 "c/extension-functions.c"
 $25 = HEAP32[$24>>2]|0; //@line 1537 "c/extension-functions.c"
 $26 = ($22|0)==(0); //@line 1537 "c/extension-functions.c"
 $27 = ($25|0)==(0); //@line 1537 "c/extension-functions.c"
 $28 = $26 & $27; //@line 1537 "c/extension-functions.c"
 if ($28) {
  $29 = ((0) + 332|0); //@line 1538 "c/extension-functions.c"
  $30 = HEAP32[$29>>2]|0; //@line 1538 "c/extension-functions.c"
  $31 = $2; //@line 1538 "c/extension-functions.c"
  $32 = $31; //@line 1538 "c/extension-functions.c"
  $33 = HEAP32[$32>>2]|0; //@line 1538 "c/extension-functions.c"
  $34 = (($31) + 4)|0; //@line 1538 "c/extension-functions.c"
  $35 = $34; //@line 1538 "c/extension-functions.c"
  $36 = HEAP32[$35>>2]|0; //@line 1538 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$30 & 255]($0,$33,$36); //@line 1538 "c/extension-functions.c"
  return; //@line 1543 "c/extension-functions.c"
 } else {
  $37 = ((0) + 316|0); //@line 1540 "c/extension-functions.c"
  $38 = HEAP32[$37>>2]|0; //@line 1540 "c/extension-functions.c"
  $39 = ((($2)) + 8|0); //@line 1540 "c/extension-functions.c"
  $40 = +HEAPF64[$39>>3]; //@line 1540 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$38 & 127]($0,$40); //@line 1540 "c/extension-functions.c"
  return; //@line 1543 "c/extension-functions.c"
 }
}
function _medianFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1572 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1572 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1573 "c/extension-functions.c"
 if ($3) {
  return; //@line 1577 "c/extension-functions.c"
 }
 $4 = ((($2)) + 16|0); //@line 1574 "c/extension-functions.c"
 $5 = $4; //@line 1574 "c/extension-functions.c"
 $6 = $5; //@line 1574 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1574 "c/extension-functions.c"
 $8 = (($5) + 4)|0; //@line 1574 "c/extension-functions.c"
 $9 = $8; //@line 1574 "c/extension-functions.c"
 $10 = HEAP32[$9>>2]|0; //@line 1574 "c/extension-functions.c"
 $11 = (+($7>>>0)) + (4294967296.0*(+($10|0))); //@line 1574 "c/extension-functions.c"
 $12 = $11 * 0.5; //@line 1574 "c/extension-functions.c"
 $13 = ((($2)) + 24|0); //@line 1574 "c/extension-functions.c"
 HEAPF64[$13>>3] = $12; //@line 1574 "c/extension-functions.c"
 __medianFinalize($0); //@line 1575 "c/extension-functions.c"
 return; //@line 1577 "c/extension-functions.c"
}
function _lower_quartileFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1584 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1584 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1585 "c/extension-functions.c"
 if ($3) {
  return; //@line 1589 "c/extension-functions.c"
 }
 $4 = ((($2)) + 16|0); //@line 1586 "c/extension-functions.c"
 $5 = $4; //@line 1586 "c/extension-functions.c"
 $6 = $5; //@line 1586 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1586 "c/extension-functions.c"
 $8 = (($5) + 4)|0; //@line 1586 "c/extension-functions.c"
 $9 = $8; //@line 1586 "c/extension-functions.c"
 $10 = HEAP32[$9>>2]|0; //@line 1586 "c/extension-functions.c"
 $11 = (+($7>>>0)) + (4294967296.0*(+($10|0))); //@line 1586 "c/extension-functions.c"
 $12 = $11 * 0.25; //@line 1586 "c/extension-functions.c"
 $13 = ((($2)) + 24|0); //@line 1586 "c/extension-functions.c"
 HEAPF64[$13>>3] = $12; //@line 1586 "c/extension-functions.c"
 __medianFinalize($0); //@line 1587 "c/extension-functions.c"
 return; //@line 1589 "c/extension-functions.c"
}
function _upper_quartileFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1596 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1596 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1597 "c/extension-functions.c"
 if ($3) {
  return; //@line 1601 "c/extension-functions.c"
 }
 $4 = ((($2)) + 16|0); //@line 1598 "c/extension-functions.c"
 $5 = $4; //@line 1598 "c/extension-functions.c"
 $6 = $5; //@line 1598 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1598 "c/extension-functions.c"
 $8 = (($5) + 4)|0; //@line 1598 "c/extension-functions.c"
 $9 = $8; //@line 1598 "c/extension-functions.c"
 $10 = HEAP32[$9>>2]|0; //@line 1598 "c/extension-functions.c"
 $11 = (___muldi3(($7|0),($10|0),3,0)|0); //@line 1598 "c/extension-functions.c"
 $12 = tempRet0; //@line 1598 "c/extension-functions.c"
 $13 = (+($11>>>0)) + (4294967296.0*(+($12|0))); //@line 1598 "c/extension-functions.c"
 $14 = $13 * 0.25; //@line 1598 "c/extension-functions.c"
 $15 = ((($2)) + 24|0); //@line 1598 "c/extension-functions.c"
 HEAPF64[$15>>3] = $14; //@line 1598 "c/extension-functions.c"
 __medianFinalize($0); //@line 1599 "c/extension-functions.c"
 return; //@line 1601 "c/extension-functions.c"
}
function _map_make($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$sroa$4$0$$sroa_idx2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = 0; //@line 1851 "c/extension-functions.c"
 $$sroa$4$0$$sroa_idx2 = ((($0)) + 4|0); //@line 1851 "c/extension-functions.c"
 HEAP32[$$sroa$4$0$$sroa_idx2>>2] = $1; //@line 1851 "c/extension-functions.c"
 return; //@line 1852 "c/extension-functions.c"
}
function _xcalloc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_calloc($0,$1)|0); //@line 1855 "c/extension-functions.c"
 return ($3|0); //@line 1856 "c/extension-functions.c"
}
function _xfree($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _free($0); //@line 1860 "c/extension-functions.c"
 return; //@line 1861 "c/extension-functions.c"
}
function _node_insert($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$tr$be = 0, $$tr$lcssa = 0, $$tr23 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 1866 "c/extension-functions.c"
 $4 = ($3|0)==(0|0); //@line 1866 "c/extension-functions.c"
 L1: do {
  if ($4) {
   $$tr$lcssa = $0;
  } else {
   $$tr23 = $0;$13 = $3;
   while(1) {
    $12 = ((($13)) + 8|0); //@line 1872 "c/extension-functions.c"
    $14 = HEAP32[$12>>2]|0; //@line 1872 "c/extension-functions.c"
    $15 = (FUNCTION_TABLE_iii[$1 & 255]($14,$2)|0); //@line 1872 "c/extension-functions.c"
    $16 = ($15|0)==(0); //@line 1873 "c/extension-functions.c"
    if ($16) {
     break;
    }
    $31 = ($15|0)>(0); //@line 1876 "c/extension-functions.c"
    $32 = HEAP32[$$tr23>>2]|0;
    $33 = ((($32)) + 4|0); //@line 1880 "c/extension-functions.c"
    $$tr$be = $31 ? $32 : $33; //@line 1876 "c/extension-functions.c"
    $34 = HEAP32[$$tr$be>>2]|0; //@line 1866 "c/extension-functions.c"
    $35 = ($34|0)==(0|0); //@line 1866 "c/extension-functions.c"
    if ($35) {
     $$tr$lcssa = $$tr$be;
     break L1;
    } else {
     $$tr23 = $$tr$be;$13 = $34;
    }
   }
   $17 = HEAP32[$$tr23>>2]|0; //@line 1874 "c/extension-functions.c"
   $18 = ((($17)) + 16|0); //@line 1874 "c/extension-functions.c"
   $19 = $18; //@line 1874 "c/extension-functions.c"
   $20 = $19; //@line 1874 "c/extension-functions.c"
   $21 = HEAP32[$20>>2]|0; //@line 1874 "c/extension-functions.c"
   $22 = (($19) + 4)|0; //@line 1874 "c/extension-functions.c"
   $23 = $22; //@line 1874 "c/extension-functions.c"
   $24 = HEAP32[$23>>2]|0; //@line 1874 "c/extension-functions.c"
   $25 = (_i64Add(($21|0),($24|0),1,0)|0); //@line 1874 "c/extension-functions.c"
   $26 = tempRet0; //@line 1874 "c/extension-functions.c"
   $27 = $18; //@line 1874 "c/extension-functions.c"
   $28 = $27; //@line 1874 "c/extension-functions.c"
   HEAP32[$28>>2] = $25; //@line 1874 "c/extension-functions.c"
   $29 = (($27) + 4)|0; //@line 1874 "c/extension-functions.c"
   $30 = $29; //@line 1874 "c/extension-functions.c"
   HEAP32[$30>>2] = $26; //@line 1874 "c/extension-functions.c"
   _xfree($2); //@line 1875 "c/extension-functions.c"
   return; //@line 1883 "c/extension-functions.c"
  }
 } while(0);
 $5 = (_xcalloc(1,24,0)|0); //@line 1867 "c/extension-functions.c"
 $6 = ((($5)) + 8|0); //@line 1868 "c/extension-functions.c"
 HEAP32[$6>>2] = $2; //@line 1868 "c/extension-functions.c"
 $7 = ((($5)) + 16|0); //@line 1869 "c/extension-functions.c"
 $8 = $7; //@line 1869 "c/extension-functions.c"
 $9 = $8; //@line 1869 "c/extension-functions.c"
 HEAP32[$9>>2] = 1; //@line 1869 "c/extension-functions.c"
 $10 = (($8) + 4)|0; //@line 1869 "c/extension-functions.c"
 $11 = $10; //@line 1869 "c/extension-functions.c"
 HEAP32[$11>>2] = 0; //@line 1869 "c/extension-functions.c"
 HEAP32[$$tr$lcssa>>2] = $5; //@line 1870 "c/extension-functions.c"
 return; //@line 1883 "c/extension-functions.c"
}
function _map_insert($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 1886 "c/extension-functions.c"
 $3 = HEAP32[$2>>2]|0; //@line 1886 "c/extension-functions.c"
 _node_insert($0,$3,$1); //@line 1886 "c/extension-functions.c"
 return; //@line 1887 "c/extension-functions.c"
}
function _node_iterate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$tr15 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 1890 "c/extension-functions.c"
 if ($3) {
  return; //@line 1897 "c/extension-functions.c"
 }
 $$tr15 = $0;
 while(1) {
  $4 = HEAP32[$$tr15>>2]|0; //@line 1891 "c/extension-functions.c"
  $5 = ($4|0)==(0|0); //@line 1891 "c/extension-functions.c"
  if (!($5)) {
   _node_iterate($4,$1,$2); //@line 1892 "c/extension-functions.c"
  }
  $6 = ((($$tr15)) + 8|0); //@line 1893 "c/extension-functions.c"
  $7 = HEAP32[$6>>2]|0; //@line 1893 "c/extension-functions.c"
  $8 = ((($$tr15)) + 16|0); //@line 1893 "c/extension-functions.c"
  $9 = $8; //@line 1893 "c/extension-functions.c"
  $10 = $9; //@line 1893 "c/extension-functions.c"
  $11 = HEAP32[$10>>2]|0; //@line 1893 "c/extension-functions.c"
  $12 = (($9) + 4)|0; //@line 1893 "c/extension-functions.c"
  $13 = $12; //@line 1893 "c/extension-functions.c"
  $14 = HEAP32[$13>>2]|0; //@line 1893 "c/extension-functions.c"
  FUNCTION_TABLE_viiii[$1 & 127]($7,$11,$14,$2); //@line 1893 "c/extension-functions.c"
  $15 = ((($$tr15)) + 4|0); //@line 1894 "c/extension-functions.c"
  $16 = HEAP32[$15>>2]|0; //@line 1894 "c/extension-functions.c"
  $17 = ($16|0)==(0|0); //@line 1894 "c/extension-functions.c"
  if ($17) {
   break;
  } else {
   $$tr15 = $16;
  }
 }
 return; //@line 1897 "c/extension-functions.c"
}
function _map_iterate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 1900 "c/extension-functions.c"
 _node_iterate($3,$1,$2); //@line 1900 "c/extension-functions.c"
 return; //@line 1901 "c/extension-functions.c"
}
function _node_destroy($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 1904 "c/extension-functions.c"
 if ($1) {
  return; //@line 1913 "c/extension-functions.c"
 }
 $2 = ((($0)) + 8|0); //@line 1905 "c/extension-functions.c"
 $3 = HEAP32[$2>>2]|0; //@line 1905 "c/extension-functions.c"
 _xfree($3); //@line 1905 "c/extension-functions.c"
 $4 = HEAP32[$0>>2]|0; //@line 1906 "c/extension-functions.c"
 $5 = ($4|0)==(0|0); //@line 1906 "c/extension-functions.c"
 if (!($5)) {
  _node_destroy($4); //@line 1907 "c/extension-functions.c"
 }
 $6 = ((($0)) + 4|0); //@line 1908 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1908 "c/extension-functions.c"
 $8 = ($7|0)==(0|0); //@line 1908 "c/extension-functions.c"
 if (!($8)) {
  _node_destroy($7); //@line 1909 "c/extension-functions.c"
 }
 _xfree($0); //@line 1911 "c/extension-functions.c"
 return; //@line 1913 "c/extension-functions.c"
}
function _map_destroy($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 1916 "c/extension-functions.c"
 _node_destroy($1); //@line 1916 "c/extension-functions.c"
 return; //@line 1917 "c/extension-functions.c"
}
function _int_cmp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $0; //@line 1920 "c/extension-functions.c"
 $3 = $2; //@line 1920 "c/extension-functions.c"
 $4 = HEAP32[$3>>2]|0; //@line 1920 "c/extension-functions.c"
 $5 = (($2) + 4)|0; //@line 1920 "c/extension-functions.c"
 $6 = $5; //@line 1920 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1920 "c/extension-functions.c"
 $8 = $1; //@line 1921 "c/extension-functions.c"
 $9 = $8; //@line 1921 "c/extension-functions.c"
 $10 = HEAP32[$9>>2]|0; //@line 1921 "c/extension-functions.c"
 $11 = (($8) + 4)|0; //@line 1921 "c/extension-functions.c"
 $12 = $11; //@line 1921 "c/extension-functions.c"
 $13 = HEAP32[$12>>2]|0; //@line 1921 "c/extension-functions.c"
 $14 = ($4|0)==($10|0); //@line 1923 "c/extension-functions.c"
 $15 = ($7|0)==($13|0); //@line 1923 "c/extension-functions.c"
 $16 = $14 & $15; //@line 1923 "c/extension-functions.c"
 $17 = ($7|0)<($13|0); //@line 1925 "c/extension-functions.c"
 $18 = ($4>>>0)<($10>>>0); //@line 1925 "c/extension-functions.c"
 $19 = ($7|0)==($13|0); //@line 1925 "c/extension-functions.c"
 $20 = $19 & $18; //@line 1925 "c/extension-functions.c"
 $21 = $17 | $20; //@line 1925 "c/extension-functions.c"
 $$ = $21 ? -1 : 1; //@line 1926 "c/extension-functions.c"
 $$0 = $16 ? 0 : $$; //@line 1923 "c/extension-functions.c"
 return ($$0|0); //@line 1929 "c/extension-functions.c"
}
function _double_cmp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = +HEAPF64[$0>>3]; //@line 1932 "c/extension-functions.c"
 $3 = +HEAPF64[$1>>3]; //@line 1933 "c/extension-functions.c"
 $4 = $2 == $3; //@line 1935 "c/extension-functions.c"
 $5 = $2 < $3; //@line 1937 "c/extension-functions.c"
 $$ = $5 ? -1 : 1; //@line 1938 "c/extension-functions.c"
 $$0 = $4 ? 0 : $$; //@line 1935 "c/extension-functions.c"
 return ($$0|0); //@line 1941 "c/extension-functions.c"
}
function _soundex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02934 = 0, $$036 = 0, $$130 = 0, $$135 = 0, $$2$lcssa = 0, $$233 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $scevgep = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 1649 "c/extension-functions.c"
 $3 = ($2<<24>>24)==(0); //@line 1649 "c/extension-functions.c"
 L1: do {
  if (!($3)) {
   $$036 = 0;$5 = $2;
   while(1) {
    $4 = $5&255; //@line 1649 "c/extension-functions.c"
    $6 = (_isalpha($4)|0); //@line 1649 "c/extension-functions.c"
    $7 = ($6|0)==(0); //@line 1649 "c/extension-functions.c"
    if (!($7)) {
     break;
    }
    $8 = (($$036) + 1)|0; //@line 1649 "c/extension-functions.c"
    $9 = (($0) + ($8)|0); //@line 1649 "c/extension-functions.c"
    $10 = HEAP8[$9>>0]|0; //@line 1649 "c/extension-functions.c"
    $11 = ($10<<24>>24)==(0); //@line 1649 "c/extension-functions.c"
    if ($11) {
     break L1;
    } else {
     $$036 = $8;$5 = $10;
    }
   }
   $12 = $5&255; //@line 1651 "c/extension-functions.c"
   $13 = (_toupper($12)|0); //@line 1651 "c/extension-functions.c"
   $14 = $13&255; //@line 1651 "c/extension-functions.c"
   HEAP8[$1>>0] = $14; //@line 1651 "c/extension-functions.c"
   $$02934 = 1;$$135 = $$036;
   while(1) {
    $15 = (($0) + ($$135)|0); //@line 1652 "c/extension-functions.c"
    $16 = HEAP8[$15>>0]|0; //@line 1652 "c/extension-functions.c"
    $17 = ($16<<24>>24)==(0); //@line 1652 "c/extension-functions.c"
    if ($17) {
     label = 10;
     break;
    }
    $18 = $16 & 127; //@line 1653 "c/extension-functions.c"
    $19 = $18&255; //@line 1653 "c/extension-functions.c"
    $20 = (14354 + ($19)|0); //@line 1653 "c/extension-functions.c"
    $21 = HEAP8[$20>>0]|0; //@line 1653 "c/extension-functions.c"
    $22 = ($21<<24>>24)==(0); //@line 1654 "c/extension-functions.c"
    if ($22) {
     $$130 = $$02934;
    } else {
     $23 = (($1) + ($$02934)|0); //@line 1655 "c/extension-functions.c"
     $24 = (($$02934) + 1)|0; //@line 1655 "c/extension-functions.c"
     $25 = $21&255; //@line 1653 "c/extension-functions.c"
     $26 = (($25) + 48)|0; //@line 1655 "c/extension-functions.c"
     $27 = $26&255; //@line 1655 "c/extension-functions.c"
     HEAP8[$23>>0] = $27; //@line 1655 "c/extension-functions.c"
     $$130 = $24;
    }
    $28 = (($$135) + 1)|0; //@line 1652 "c/extension-functions.c"
    $29 = ($$130|0)<(4); //@line 1652 "c/extension-functions.c"
    if ($29) {
     $$02934 = $$130;$$135 = $28;
    } else {
     $$2$lcssa = 4;
     break;
    }
   }
   if ((label|0) == 10) {
    $scevgep = (($1) + ($$02934)|0); //@line 1658 "c/extension-functions.c"
    $30 = (4 - ($$02934))|0; //@line 1658 "c/extension-functions.c"
    _memset(($scevgep|0),48,($30|0))|0; //@line 1659 "c/extension-functions.c"
    $$233 = $$02934;
    while(1) {
     $31 = (($$233) + 1)|0; //@line 1659 "c/extension-functions.c"
     $32 = ($$233|0)<(3); //@line 1658 "c/extension-functions.c"
     if ($32) {
      $$233 = $31;
     } else {
      $$2$lcssa = $31;
      break;
     }
    }
   }
   $33 = (($1) + ($$2$lcssa)|0); //@line 1661 "c/extension-functions.c"
   HEAP8[$33>>0] = 0; //@line 1661 "c/extension-functions.c"
   return; //@line 1665 "c/extension-functions.c"
  }
 } while(0);
 ;HEAP8[$1>>0]=HEAP8[14482>>0]|0;HEAP8[$1+1>>0]=HEAP8[14482+1>>0]|0;HEAP8[$1+2>>0]=HEAP8[14482+2>>0]|0;HEAP8[$1+3>>0]=HEAP8[14482+3>>0]|0;HEAP8[$1+4>>0]=HEAP8[14482+4>>0]|0; //@line 1663 "c/extension-functions.c"
 return; //@line 1665 "c/extension-functions.c"
}
function _sqlite3ReadUtf8($0) {
 $0 = $0|0;
 var $$0 = 0, $$018 = 0, $$1 = 0, $$119 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond22 = 0, $spec$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 1|0); //@line 293 "c/extension-functions.c"
 $2 = HEAP8[$0>>0]|0; //@line 293 "c/extension-functions.c"
 $3 = $2&255; //@line 293 "c/extension-functions.c"
 $4 = (14487 + ($3)|0); //@line 293 "c/extension-functions.c"
 $5 = HEAP8[$4>>0]|0; //@line 293 "c/extension-functions.c"
 $6 = $5&255; //@line 293 "c/extension-functions.c"
 switch ($5<<24>>24) {
 case 4:  {
  $$2 = 65533;
  return ($$2|0); //@line 294 "c/extension-functions.c"
  break;
 }
 case 3:  {
  $7 = $3 << 6; //@line 293 "c/extension-functions.c"
  $8 = ((($0)) + 2|0); //@line 293 "c/extension-functions.c"
  $9 = HEAP8[$1>>0]|0; //@line 293 "c/extension-functions.c"
  $10 = $9&255; //@line 293 "c/extension-functions.c"
  $11 = (($7) + ($10))|0; //@line 293 "c/extension-functions.c"
  $$0 = $8;$$018 = $11;
  label = 4;
  break;
 }
 case 2:  {
  $$0 = $1;$$018 = $3;
  label = 4;
  break;
 }
 case 1:  {
  $$1 = $1;$$119 = $3;
  break;
 }
 default: {
  $$2 = $3;
  return ($$2|0); //@line 294 "c/extension-functions.c"
 }
 }
 if ((label|0) == 4) {
  $12 = $$018 << 6; //@line 293 "c/extension-functions.c"
  $13 = ((($$0)) + 1|0); //@line 293 "c/extension-functions.c"
  $14 = HEAP8[$$0>>0]|0; //@line 293 "c/extension-functions.c"
  $15 = $14&255; //@line 293 "c/extension-functions.c"
  $16 = (($12) + ($15))|0; //@line 293 "c/extension-functions.c"
  $$1 = $13;$$119 = $16;
 }
 $17 = $$119 << 6; //@line 293 "c/extension-functions.c"
 $18 = HEAP8[$$1>>0]|0; //@line 293 "c/extension-functions.c"
 $19 = $18&255; //@line 293 "c/extension-functions.c"
 $20 = (($17) + ($19))|0; //@line 293 "c/extension-functions.c"
 $21 = (1056 + ($6<<2)|0); //@line 293 "c/extension-functions.c"
 $22 = HEAP32[$21>>2]|0; //@line 293 "c/extension-functions.c"
 $23 = (($20) - ($22))|0; //@line 293 "c/extension-functions.c"
 $24 = (1072 + ($6<<2)|0); //@line 293 "c/extension-functions.c"
 $25 = HEAP32[$24>>2]|0; //@line 293 "c/extension-functions.c"
 $26 = $23 & $25; //@line 293 "c/extension-functions.c"
 $27 = ($26|0)==(0); //@line 293 "c/extension-functions.c"
 $28 = $23 & -2048; //@line 293 "c/extension-functions.c"
 $29 = ($28|0)==(55296); //@line 293 "c/extension-functions.c"
 $or$cond = $27 | $29; //@line 293 "c/extension-functions.c"
 $30 = $23 & -2; //@line 293 "c/extension-functions.c"
 $31 = ($30|0)==(65534); //@line 293 "c/extension-functions.c"
 $or$cond22 = $31 | $or$cond; //@line 293 "c/extension-functions.c"
 $spec$select = $or$cond22 ? 65533 : $23; //@line 293 "c/extension-functions.c"
 return ($spec$select|0); //@line 293 "c/extension-functions.c"
}
function _rad2deg($0) {
 $0 = +$0;
 var $1 = 0.0, $2 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0 * 180.0; //@line 495 "c/extension-functions.c"
 $2 = $1 / 3.1415926535897931; //@line 495 "c/extension-functions.c"
 return (+$2); //@line 495 "c/extension-functions.c"
}
function _deg2rad($0) {
 $0 = +$0;
 var $1 = 0.0, $2 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0 * 3.1415926535897931; //@line 490 "c/extension-functions.c"
 $2 = $1 / 180.0; //@line 490 "c/extension-functions.c"
 return (+$2); //@line 490 "c/extension-functions.c"
}
function _cot($0) {
 $0 = +$0;
 var $1 = 0.0, $2 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (+Math_tan((+$0))); //@line 416 "c/extension-functions.c"
 $2 = 1.0 / $1; //@line 416 "c/extension-functions.c"
 return (+$2); //@line 416 "c/extension-functions.c"
}
function _coth($0) {
 $0 = +$0;
 var $1 = 0.0, $2 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (+_tanh($0)); //@line 425 "c/extension-functions.c"
 $2 = 1.0 / $1; //@line 425 "c/extension-functions.c"
 return (+$2); //@line 425 "c/extension-functions.c"
}
function __substr($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$041$lcssa = 0, $$04112 = 0, $$042 = 0, $$044 = 0, $$0461 = 0, $$04711 = 0, $$1 = 0, $$143 = 0, $$145 = 0, $$1486 = 0, $$27 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP8[$0>>0]|0; //@line 991 "c/extension-functions.c"
 $4 = ($3<<24>>24)==(0); //@line 991 "c/extension-functions.c"
 if ($4) {
  $$0 = -1;
  return ($$0|0); //@line 1023 "c/extension-functions.c"
 }
 $5 = (_sqlite3ReadUtf8($1)|0); //@line 995 "c/extension-functions.c"
 $6 = ($5|0)==(0); //@line 995 "c/extension-functions.c"
 L4: do {
  if ($6) {
   $$041$lcssa = $1;
  } else {
   $$04112 = $1;$$04711 = 0;
   while(1) {
    $7 = (($$04711) + 1)|0; //@line 995 "c/extension-functions.c"
    $8 = ($$04711|0)<($2|0); //@line 995 "c/extension-functions.c"
    if (!($8)) {
     $$041$lcssa = $$04112;
     break L4;
    }
    $$1 = $$04112;
    while(1) {
     $9 = ((($$1)) + 1|0); //@line 996 "c/extension-functions.c"
     $10 = HEAP8[$9>>0]|0; //@line 996 "c/extension-functions.c"
     $11 = $10 & -64; //@line 996 "c/extension-functions.c"
     $12 = ($11<<24>>24)==(-128); //@line 996 "c/extension-functions.c"
     if ($12) {
      $$1 = $9;
     } else {
      break;
     }
    }
    $13 = (_sqlite3ReadUtf8($9)|0); //@line 995 "c/extension-functions.c"
    $14 = ($13|0)==(0); //@line 995 "c/extension-functions.c"
    if ($14) {
     $$041$lcssa = $9;
     break;
    } else {
     $$04112 = $9;$$04711 = $7;
    }
   }
  }
 } while(0);
 $15 = (_sqlite3ReadUtf8($$041$lcssa)|0); //@line 1000 "c/extension-functions.c"
 $16 = ($15|0)==(0); //@line 1000 "c/extension-functions.c"
 L13: do {
  if ($16) {
   $$0461 = -1;$39 = 0;
  } else {
   $$1486 = 0;$$27 = $$041$lcssa;
   while(1) {
    $$042 = $$27;$$044 = $0;
    while(1) {
     $17 = (_sqlite3ReadUtf8($$044)|0); //@line 1005 "c/extension-functions.c"
     $18 = (_sqlite3ReadUtf8($$042)|0); //@line 1006 "c/extension-functions.c"
     $$145 = $$044;
     while(1) {
      $19 = ((($$145)) + 1|0); //@line 1007 "c/extension-functions.c"
      $20 = HEAP8[$19>>0]|0; //@line 1007 "c/extension-functions.c"
      $21 = $20 & -64; //@line 1007 "c/extension-functions.c"
      $22 = ($21<<24>>24)==(-128); //@line 1007 "c/extension-functions.c"
      if ($22) {
       $$145 = $19;
      } else {
       break;
      }
     }
     $$143 = $$042;
     while(1) {
      $23 = ((($$143)) + 1|0); //@line 1008 "c/extension-functions.c"
      $24 = HEAP8[$23>>0]|0; //@line 1008 "c/extension-functions.c"
      $25 = $24 & -64; //@line 1008 "c/extension-functions.c"
      $26 = ($25<<24>>24)==(-128); //@line 1008 "c/extension-functions.c"
      if ($26) {
       $$143 = $23;
      } else {
       break;
      }
     }
     $27 = ($17|0)==($18|0); //@line 1009 "c/extension-functions.c"
     $28 = ($17|0)!=(0); //@line 1009 "c/extension-functions.c"
     $or$cond = $28 & $27; //@line 1009 "c/extension-functions.c"
     $29 = ($18|0)!=(0); //@line 1009 "c/extension-functions.c"
     $or$cond4 = $29 & $or$cond; //@line 1009 "c/extension-functions.c"
     if ($or$cond4) {
      $$042 = $23;$$044 = $19;
     } else {
      break;
     }
    }
    $30 = ($17|0)==(0); //@line 1011 "c/extension-functions.c"
    if ($30) {
     $$0461 = $$1486;$39 = $2;
     break L13;
    }
    $$3 = $$27;
    while(1) {
     $31 = ((($$3)) + 1|0); //@line 1016 "c/extension-functions.c"
     $32 = HEAP8[$31>>0]|0; //@line 1016 "c/extension-functions.c"
     $33 = $32 & -64; //@line 1016 "c/extension-functions.c"
     $34 = ($33<<24>>24)==(-128); //@line 1016 "c/extension-functions.c"
     if ($34) {
      $$3 = $31;
     } else {
      break;
     }
    }
    $35 = (($$1486) + 1)|0; //@line 1017 "c/extension-functions.c"
    $36 = (_sqlite3ReadUtf8($31)|0); //@line 1000 "c/extension-functions.c"
    $37 = ($36|0)==(0); //@line 1000 "c/extension-functions.c"
    if ($37) {
     $$0461 = -1;$39 = 0;
     break;
    } else {
     $$1486 = $35;$$27 = $31;
    }
   }
  }
 } while(0);
 $38 = (($39) + ($$0461))|0; //@line 1022 "c/extension-functions.c"
 $$0 = $38;
 return ($$0|0); //@line 1023 "c/extension-functions.c"
}
function _sqlite3StrDup($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((0) + 272|0); //@line 205 "c/extension-functions.c"
 $2 = HEAP32[$1>>2]|0; //@line 205 "c/extension-functions.c"
 $3 = (_strlen($0)|0); //@line 205 "c/extension-functions.c"
 $4 = (($3) + 1)|0; //@line 205 "c/extension-functions.c"
 $5 = (FUNCTION_TABLE_ii[$2 & 255]($4)|0); //@line 205 "c/extension-functions.c"
 $6 = (_strcpy($5,$0)|0); //@line 206 "c/extension-functions.c"
 return ($6|0); //@line 206 "c/extension-functions.c"
}
function _sqlite3Utf8CharLen($0) {
 $0 = $0|0;
 var $$014$lcssa = 0, $$0143 = 0, $$0152 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond1 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 317 "c/extension-functions.c"
 $2 = ($1<<24>>24)==(0); //@line 317 "c/extension-functions.c"
 $3 = ($0|0)==((-1)|0); //@line 317 "c/extension-functions.c"
 $or$cond1 = $3 | $2; //@line 317 "c/extension-functions.c"
 if ($or$cond1) {
  $$014$lcssa = 0;
  return ($$014$lcssa|0); //@line 321 "c/extension-functions.c"
 }
 $$0143 = 0;$$0152 = $0;$5 = $1;
 while(1) {
  $4 = $5&255; //@line 318 "c/extension-functions.c"
  $6 = (14487 + ($4)|0); //@line 318 "c/extension-functions.c"
  $7 = HEAP8[$6>>0]|0; //@line 318 "c/extension-functions.c"
  $8 = $7&255; //@line 318 "c/extension-functions.c"
  $9 = (($8) + 1)|0; //@line 318 "c/extension-functions.c"
  $10 = (($$0152) + ($9)|0); //@line 318 "c/extension-functions.c"
  $11 = (($$0143) + 1)|0; //@line 319 "c/extension-functions.c"
  $12 = HEAP8[$10>>0]|0; //@line 317 "c/extension-functions.c"
  $13 = ($12<<24>>24)==(0); //@line 317 "c/extension-functions.c"
  $14 = ($10|0)==((-1)|0); //@line 317 "c/extension-functions.c"
  $or$cond = $14 | $13; //@line 317 "c/extension-functions.c"
  if ($or$cond) {
   $$014$lcssa = $11;
   break;
  } else {
   $$0143 = $11;$$0152 = $10;$5 = $12;
  }
 }
 return ($$014$lcssa|0); //@line 321 "c/extension-functions.c"
}
function _modeIterate($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0.0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($3)) + 48|0); //@line 1463 "c/extension-functions.c"
 $5 = $4; //@line 1463 "c/extension-functions.c"
 $6 = $5; //@line 1463 "c/extension-functions.c"
 $7 = HEAP32[$6>>2]|0; //@line 1463 "c/extension-functions.c"
 $8 = (($5) + 4)|0; //@line 1463 "c/extension-functions.c"
 $9 = $8; //@line 1463 "c/extension-functions.c"
 $10 = HEAP32[$9>>2]|0; //@line 1463 "c/extension-functions.c"
 $11 = ($7|0)==(0); //@line 1463 "c/extension-functions.c"
 $12 = ($10|0)==(0); //@line 1463 "c/extension-functions.c"
 $13 = $11 & $12; //@line 1463 "c/extension-functions.c"
 if ($13) {
  $14 = HEAP32[$0>>2]|0; //@line 1464 "c/extension-functions.c"
  $15 = ($14|0)<(0); //@line 1464 "c/extension-functions.c"
  $16 = $15 << 31 >> 31; //@line 1464 "c/extension-functions.c"
  $17 = ((($3)) + 32|0); //@line 1466 "c/extension-functions.c"
  $18 = $17; //@line 1466 "c/extension-functions.c"
  $19 = $18; //@line 1466 "c/extension-functions.c"
  $20 = HEAP32[$19>>2]|0; //@line 1466 "c/extension-functions.c"
  $21 = (($18) + 4)|0; //@line 1466 "c/extension-functions.c"
  $22 = $21; //@line 1466 "c/extension-functions.c"
  $23 = HEAP32[$22>>2]|0; //@line 1466 "c/extension-functions.c"
  $24 = ($20|0)==($1|0); //@line 1466 "c/extension-functions.c"
  $25 = ($23|0)==($2|0); //@line 1466 "c/extension-functions.c"
  $26 = $24 & $25; //@line 1466 "c/extension-functions.c"
  if ($26) {
   $27 = ((($3)) + 40|0); //@line 1467 "c/extension-functions.c"
   $28 = $27; //@line 1467 "c/extension-functions.c"
   $29 = $28; //@line 1467 "c/extension-functions.c"
   $30 = HEAP32[$29>>2]|0; //@line 1467 "c/extension-functions.c"
   $31 = (($28) + 4)|0; //@line 1467 "c/extension-functions.c"
   $32 = $31; //@line 1467 "c/extension-functions.c"
   $33 = HEAP32[$32>>2]|0; //@line 1467 "c/extension-functions.c"
   $34 = (_i64Add(($30|0),($33|0),1,0)|0); //@line 1467 "c/extension-functions.c"
   $35 = tempRet0; //@line 1467 "c/extension-functions.c"
   $36 = $27; //@line 1467 "c/extension-functions.c"
   $37 = $36; //@line 1467 "c/extension-functions.c"
   HEAP32[$37>>2] = $34; //@line 1467 "c/extension-functions.c"
   $38 = (($36) + 4)|0; //@line 1467 "c/extension-functions.c"
   $39 = $38; //@line 1467 "c/extension-functions.c"
   HEAP32[$39>>2] = $35; //@line 1467 "c/extension-functions.c"
   return; //@line 1484 "c/extension-functions.c"
  }
  $40 = ($23|0)<($2|0); //@line 1468 "c/extension-functions.c"
  $41 = ($20>>>0)<($1>>>0); //@line 1468 "c/extension-functions.c"
  $42 = ($23|0)==($2|0); //@line 1468 "c/extension-functions.c"
  $43 = $42 & $41; //@line 1468 "c/extension-functions.c"
  $44 = $40 | $43; //@line 1468 "c/extension-functions.c"
  if (!($44)) {
   return; //@line 1484 "c/extension-functions.c"
  }
  $45 = $3; //@line 1469 "c/extension-functions.c"
  $46 = $45; //@line 1469 "c/extension-functions.c"
  HEAP32[$46>>2] = $14; //@line 1469 "c/extension-functions.c"
  $47 = (($45) + 4)|0; //@line 1469 "c/extension-functions.c"
  $48 = $47; //@line 1469 "c/extension-functions.c"
  HEAP32[$48>>2] = $16; //@line 1469 "c/extension-functions.c"
  $49 = $17; //@line 1470 "c/extension-functions.c"
  $50 = $49; //@line 1470 "c/extension-functions.c"
  HEAP32[$50>>2] = $1; //@line 1470 "c/extension-functions.c"
  $51 = (($49) + 4)|0; //@line 1470 "c/extension-functions.c"
  $52 = $51; //@line 1470 "c/extension-functions.c"
  HEAP32[$52>>2] = $2; //@line 1470 "c/extension-functions.c"
  $53 = ((($3)) + 40|0); //@line 1471 "c/extension-functions.c"
  $54 = $53; //@line 1471 "c/extension-functions.c"
  $55 = $54; //@line 1471 "c/extension-functions.c"
  HEAP32[$55>>2] = 1; //@line 1471 "c/extension-functions.c"
  $56 = (($54) + 4)|0; //@line 1471 "c/extension-functions.c"
  $57 = $56; //@line 1471 "c/extension-functions.c"
  HEAP32[$57>>2] = 0; //@line 1471 "c/extension-functions.c"
  return; //@line 1484 "c/extension-functions.c"
 } else {
  $58 = +HEAPF64[$0>>3]; //@line 1474 "c/extension-functions.c"
  $59 = ((($3)) + 32|0); //@line 1476 "c/extension-functions.c"
  $60 = $59; //@line 1476 "c/extension-functions.c"
  $61 = $60; //@line 1476 "c/extension-functions.c"
  $62 = HEAP32[$61>>2]|0; //@line 1476 "c/extension-functions.c"
  $63 = (($60) + 4)|0; //@line 1476 "c/extension-functions.c"
  $64 = $63; //@line 1476 "c/extension-functions.c"
  $65 = HEAP32[$64>>2]|0; //@line 1476 "c/extension-functions.c"
  $66 = ($62|0)==($1|0); //@line 1476 "c/extension-functions.c"
  $67 = ($65|0)==($2|0); //@line 1476 "c/extension-functions.c"
  $68 = $66 & $67; //@line 1476 "c/extension-functions.c"
  if ($68) {
   $69 = ((($3)) + 40|0); //@line 1477 "c/extension-functions.c"
   $70 = $69; //@line 1477 "c/extension-functions.c"
   $71 = $70; //@line 1477 "c/extension-functions.c"
   $72 = HEAP32[$71>>2]|0; //@line 1477 "c/extension-functions.c"
   $73 = (($70) + 4)|0; //@line 1477 "c/extension-functions.c"
   $74 = $73; //@line 1477 "c/extension-functions.c"
   $75 = HEAP32[$74>>2]|0; //@line 1477 "c/extension-functions.c"
   $76 = (_i64Add(($72|0),($75|0),1,0)|0); //@line 1477 "c/extension-functions.c"
   $77 = tempRet0; //@line 1477 "c/extension-functions.c"
   $78 = $69; //@line 1477 "c/extension-functions.c"
   $79 = $78; //@line 1477 "c/extension-functions.c"
   HEAP32[$79>>2] = $76; //@line 1477 "c/extension-functions.c"
   $80 = (($78) + 4)|0; //@line 1477 "c/extension-functions.c"
   $81 = $80; //@line 1477 "c/extension-functions.c"
   HEAP32[$81>>2] = $77; //@line 1477 "c/extension-functions.c"
   return; //@line 1484 "c/extension-functions.c"
  }
  $82 = ($65|0)<($2|0); //@line 1478 "c/extension-functions.c"
  $83 = ($62>>>0)<($1>>>0); //@line 1478 "c/extension-functions.c"
  $84 = ($65|0)==($2|0); //@line 1478 "c/extension-functions.c"
  $85 = $84 & $83; //@line 1478 "c/extension-functions.c"
  $86 = $82 | $85; //@line 1478 "c/extension-functions.c"
  if (!($86)) {
   return; //@line 1484 "c/extension-functions.c"
  }
  $87 = ((($3)) + 8|0); //@line 1479 "c/extension-functions.c"
  HEAPF64[$87>>3] = $58; //@line 1479 "c/extension-functions.c"
  $88 = $59; //@line 1480 "c/extension-functions.c"
  $89 = $88; //@line 1480 "c/extension-functions.c"
  HEAP32[$89>>2] = $1; //@line 1480 "c/extension-functions.c"
  $90 = (($88) + 4)|0; //@line 1480 "c/extension-functions.c"
  $91 = $90; //@line 1480 "c/extension-functions.c"
  HEAP32[$91>>2] = $2; //@line 1480 "c/extension-functions.c"
  $92 = ((($3)) + 40|0); //@line 1481 "c/extension-functions.c"
  $93 = $92; //@line 1481 "c/extension-functions.c"
  $94 = $93; //@line 1481 "c/extension-functions.c"
  HEAP32[$94>>2] = 1; //@line 1481 "c/extension-functions.c"
  $95 = (($93) + 4)|0; //@line 1481 "c/extension-functions.c"
  $96 = $95; //@line 1481 "c/extension-functions.c"
  HEAP32[$96>>2] = 0; //@line 1481 "c/extension-functions.c"
  return; //@line 1484 "c/extension-functions.c"
 }
}
function __medianFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0.0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0.0, $61 = 0.0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[0>>2]|0; //@line 1550 "c/extension-functions.c"
 $2 = (FUNCTION_TABLE_iii[$1 & 255]($0,0)|0); //@line 1550 "c/extension-functions.c"
 $3 = ($2|0)==(0|0); //@line 1551 "c/extension-functions.c"
 if ($3) {
  return; //@line 1565 "c/extension-functions.c"
 }
 $4 = ((($2)) + 56|0); //@line 1551 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 1551 "c/extension-functions.c"
 $6 = ($5|0)==(0|0); //@line 1551 "c/extension-functions.c"
 if ($6) {
  return; //@line 1565 "c/extension-functions.c"
 }
 $7 = ((($2)) + 60|0); //@line 1552 "c/extension-functions.c"
 HEAP32[$7>>2] = 0; //@line 1552 "c/extension-functions.c"
 _map_iterate($5,75,$2); //@line 1553 "c/extension-functions.c"
 $8 = HEAP32[$4>>2]|0; //@line 1554 "c/extension-functions.c"
 _map_destroy($8); //@line 1554 "c/extension-functions.c"
 $9 = HEAP32[$4>>2]|0; //@line 1555 "c/extension-functions.c"
 _free($9); //@line 1555 "c/extension-functions.c"
 $10 = ((($2)) + 48|0); //@line 1557 "c/extension-functions.c"
 $11 = $10; //@line 1557 "c/extension-functions.c"
 $12 = $11; //@line 1557 "c/extension-functions.c"
 $13 = HEAP32[$12>>2]|0; //@line 1557 "c/extension-functions.c"
 $14 = (($11) + 4)|0; //@line 1557 "c/extension-functions.c"
 $15 = $14; //@line 1557 "c/extension-functions.c"
 $16 = HEAP32[$15>>2]|0; //@line 1557 "c/extension-functions.c"
 $17 = ($13|0)==(0); //@line 1557 "c/extension-functions.c"
 $18 = ($16|0)==(0); //@line 1557 "c/extension-functions.c"
 $19 = $17 & $18; //@line 1557 "c/extension-functions.c"
 if (!($19)) {
  $49 = ((0) + 316|0); //@line 1563 "c/extension-functions.c"
  $50 = HEAP32[$49>>2]|0; //@line 1563 "c/extension-functions.c"
  $51 = ((($2)) + 8|0); //@line 1563 "c/extension-functions.c"
  $52 = +HEAPF64[$51>>3]; //@line 1563 "c/extension-functions.c"
  $53 = ((($2)) + 40|0); //@line 1563 "c/extension-functions.c"
  $54 = $53; //@line 1563 "c/extension-functions.c"
  $55 = $54; //@line 1563 "c/extension-functions.c"
  $56 = HEAP32[$55>>2]|0; //@line 1563 "c/extension-functions.c"
  $57 = (($54) + 4)|0; //@line 1563 "c/extension-functions.c"
  $58 = $57; //@line 1563 "c/extension-functions.c"
  $59 = HEAP32[$58>>2]|0; //@line 1563 "c/extension-functions.c"
  $60 = (+($56>>>0)) + (4294967296.0*(+($59|0))); //@line 1563 "c/extension-functions.c"
  $61 = $52 / $60; //@line 1563 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$50 & 127]($0,$61); //@line 1563 "c/extension-functions.c"
  return; //@line 1565 "c/extension-functions.c"
 }
 $20 = ((($2)) + 40|0); //@line 1558 "c/extension-functions.c"
 $21 = $20; //@line 1558 "c/extension-functions.c"
 $22 = $21; //@line 1558 "c/extension-functions.c"
 $23 = HEAP32[$22>>2]|0; //@line 1558 "c/extension-functions.c"
 $24 = (($21) + 4)|0; //@line 1558 "c/extension-functions.c"
 $25 = $24; //@line 1558 "c/extension-functions.c"
 $26 = HEAP32[$25>>2]|0; //@line 1558 "c/extension-functions.c"
 $27 = ($23|0)==(1); //@line 1558 "c/extension-functions.c"
 $28 = ($26|0)==(0); //@line 1558 "c/extension-functions.c"
 $29 = $27 & $28; //@line 1558 "c/extension-functions.c"
 if ($29) {
  $30 = ((0) + 332|0); //@line 1559 "c/extension-functions.c"
  $31 = HEAP32[$30>>2]|0; //@line 1559 "c/extension-functions.c"
  $32 = $2; //@line 1559 "c/extension-functions.c"
  $33 = $32; //@line 1559 "c/extension-functions.c"
  $34 = HEAP32[$33>>2]|0; //@line 1559 "c/extension-functions.c"
  $35 = (($32) + 4)|0; //@line 1559 "c/extension-functions.c"
  $36 = $35; //@line 1559 "c/extension-functions.c"
  $37 = HEAP32[$36>>2]|0; //@line 1559 "c/extension-functions.c"
  FUNCTION_TABLE_viii[$31 & 255]($0,$34,$37); //@line 1559 "c/extension-functions.c"
  return; //@line 1565 "c/extension-functions.c"
 } else {
  $38 = ((0) + 316|0); //@line 1561 "c/extension-functions.c"
  $39 = HEAP32[$38>>2]|0; //@line 1561 "c/extension-functions.c"
  $40 = $2; //@line 1561 "c/extension-functions.c"
  $41 = $40; //@line 1561 "c/extension-functions.c"
  $42 = HEAP32[$41>>2]|0; //@line 1561 "c/extension-functions.c"
  $43 = (($40) + 4)|0; //@line 1561 "c/extension-functions.c"
  $44 = $43; //@line 1561 "c/extension-functions.c"
  $45 = HEAP32[$44>>2]|0; //@line 1561 "c/extension-functions.c"
  $46 = (+($42>>>0)) + (4294967296.0*(+($45|0))); //@line 1561 "c/extension-functions.c"
  $47 = (+($23>>>0)) + (4294967296.0*(+($26|0))); //@line 1561 "c/extension-functions.c"
  $48 = $46 / $47; //@line 1561 "c/extension-functions.c"
  FUNCTION_TABLE_vid[$39 & 127]($0,$48); //@line 1561 "c/extension-functions.c"
  return; //@line 1565 "c/extension-functions.c"
 }
}
function _medianIterate($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0, $28 = 0, $29 = 0.0;
 var $30 = 0.0, $31 = 0.0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0.0, $72 = 0, $73 = 0.0, $74 = 0.0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($3)) + 60|0); //@line 1500 "c/extension-functions.c"
 $5 = HEAP32[$4>>2]|0; //@line 1500 "c/extension-functions.c"
 $6 = ($5|0)>(0); //@line 1500 "c/extension-functions.c"
 if ($6) {
  return; //@line 1523 "c/extension-functions.c"
 }
 $7 = ((($3)) + 24|0); //@line 1503 "c/extension-functions.c"
 $8 = +HEAPF64[$7>>3]; //@line 1503 "c/extension-functions.c"
 $9 = ((($3)) + 16|0); //@line 1504 "c/extension-functions.c"
 $10 = $9; //@line 1504 "c/extension-functions.c"
 $11 = $10; //@line 1504 "c/extension-functions.c"
 $12 = HEAP32[$11>>2]|0; //@line 1504 "c/extension-functions.c"
 $13 = (($10) + 4)|0; //@line 1504 "c/extension-functions.c"
 $14 = $13; //@line 1504 "c/extension-functions.c"
 $15 = HEAP32[$14>>2]|0; //@line 1504 "c/extension-functions.c"
 $16 = ((($3)) + 32|0); //@line 1505 "c/extension-functions.c"
 $17 = $16; //@line 1505 "c/extension-functions.c"
 $18 = $17; //@line 1505 "c/extension-functions.c"
 $19 = HEAP32[$18>>2]|0; //@line 1505 "c/extension-functions.c"
 $20 = (($17) + 4)|0; //@line 1505 "c/extension-functions.c"
 $21 = $20; //@line 1505 "c/extension-functions.c"
 $22 = HEAP32[$21>>2]|0; //@line 1505 "c/extension-functions.c"
 $23 = (_i64Add(($19|0),($22|0),($1|0),($2|0))|0); //@line 1505 "c/extension-functions.c"
 $24 = tempRet0; //@line 1505 "c/extension-functions.c"
 $25 = (+($23|0)); //@line 1508 "c/extension-functions.c"
 $26 = !($8 <= $25); //@line 1508 "c/extension-functions.c"
 do {
  if (!($26)) {
   $27 = (_i64Subtract(($12|0),($15|0),($19|0),($22|0))|0); //@line 1506 "c/extension-functions.c"
   $28 = tempRet0; //@line 1506 "c/extension-functions.c"
   $29 = (+($12>>>0)) + (4294967296.0*(+($15|0))); //@line 1504 "c/extension-functions.c"
   $30 = $29 - $8; //@line 1504 "c/extension-functions.c"
   $31 = (+($27|0)); //@line 1509 "c/extension-functions.c"
   $32 = !($30 <= $31); //@line 1509 "c/extension-functions.c"
   if ($32) {
    HEAP32[$4>>2] = 1; //@line 1519 "c/extension-functions.c"
    break;
   }
   $33 = ((($3)) + 40|0); //@line 1510 "c/extension-functions.c"
   $34 = $33; //@line 1510 "c/extension-functions.c"
   $35 = $34; //@line 1510 "c/extension-functions.c"
   $36 = HEAP32[$35>>2]|0; //@line 1510 "c/extension-functions.c"
   $37 = (($34) + 4)|0; //@line 1510 "c/extension-functions.c"
   $38 = $37; //@line 1510 "c/extension-functions.c"
   $39 = HEAP32[$38>>2]|0; //@line 1510 "c/extension-functions.c"
   $40 = (_i64Add(($36|0),($39|0),1,0)|0); //@line 1510 "c/extension-functions.c"
   $41 = tempRet0; //@line 1510 "c/extension-functions.c"
   $42 = $33; //@line 1510 "c/extension-functions.c"
   $43 = $42; //@line 1510 "c/extension-functions.c"
   HEAP32[$43>>2] = $40; //@line 1510 "c/extension-functions.c"
   $44 = (($42) + 4)|0; //@line 1510 "c/extension-functions.c"
   $45 = $44; //@line 1510 "c/extension-functions.c"
   HEAP32[$45>>2] = $41; //@line 1510 "c/extension-functions.c"
   $46 = ((($3)) + 48|0); //@line 1511 "c/extension-functions.c"
   $47 = $46; //@line 1511 "c/extension-functions.c"
   $48 = $47; //@line 1511 "c/extension-functions.c"
   $49 = HEAP32[$48>>2]|0; //@line 1511 "c/extension-functions.c"
   $50 = (($47) + 4)|0; //@line 1511 "c/extension-functions.c"
   $51 = $50; //@line 1511 "c/extension-functions.c"
   $52 = HEAP32[$51>>2]|0; //@line 1511 "c/extension-functions.c"
   $53 = ($49|0)==(0); //@line 1511 "c/extension-functions.c"
   $54 = ($52|0)==(0); //@line 1511 "c/extension-functions.c"
   $55 = $53 & $54; //@line 1511 "c/extension-functions.c"
   if ($55) {
    $56 = HEAP32[$0>>2]|0; //@line 1512 "c/extension-functions.c"
    $57 = ($56|0)<(0); //@line 1512 "c/extension-functions.c"
    $58 = $57 << 31 >> 31; //@line 1512 "c/extension-functions.c"
    $59 = $3; //@line 1513 "c/extension-functions.c"
    $60 = $59; //@line 1513 "c/extension-functions.c"
    $61 = HEAP32[$60>>2]|0; //@line 1513 "c/extension-functions.c"
    $62 = (($59) + 4)|0; //@line 1513 "c/extension-functions.c"
    $63 = $62; //@line 1513 "c/extension-functions.c"
    $64 = HEAP32[$63>>2]|0; //@line 1513 "c/extension-functions.c"
    $65 = (_i64Add(($61|0),($64|0),($56|0),($58|0))|0); //@line 1513 "c/extension-functions.c"
    $66 = tempRet0; //@line 1513 "c/extension-functions.c"
    $67 = $3; //@line 1513 "c/extension-functions.c"
    $68 = $67; //@line 1513 "c/extension-functions.c"
    HEAP32[$68>>2] = $65; //@line 1513 "c/extension-functions.c"
    $69 = (($67) + 4)|0; //@line 1513 "c/extension-functions.c"
    $70 = $69; //@line 1513 "c/extension-functions.c"
    HEAP32[$70>>2] = $66; //@line 1513 "c/extension-functions.c"
    break;
   } else {
    $71 = +HEAPF64[$0>>3]; //@line 1515 "c/extension-functions.c"
    $72 = ((($3)) + 8|0); //@line 1516 "c/extension-functions.c"
    $73 = +HEAPF64[$72>>3]; //@line 1516 "c/extension-functions.c"
    $74 = $71 + $73; //@line 1516 "c/extension-functions.c"
    HEAPF64[$72>>3] = $74; //@line 1516 "c/extension-functions.c"
    break;
   }
  }
 } while(0);
 $75 = $16; //@line 1522 "c/extension-functions.c"
 $76 = $75; //@line 1522 "c/extension-functions.c"
 HEAP32[$76>>2] = $23; //@line 1522 "c/extension-functions.c"
 $77 = (($75) + 4)|0; //@line 1522 "c/extension-functions.c"
 $78 = $77; //@line 1522 "c/extension-functions.c"
 HEAP32[$78>>2] = $24; //@line 1522 "c/extension-functions.c"
 return; //@line 1523 "c/extension-functions.c"
}
function _sqlite3_status64($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($0>>>0)>(9); //@line 19320 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3MisuseError(19321)|0); //@line 19321 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 19336 "c/sqlite3.c"
 }
 $6 = 134 >>> $0; //@line 19326 "c/sqlite3.c"
 $7 = $6 & 1; //@line 19326 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 19326 "c/sqlite3.c"
 if ($8) {
  $10 = (_sqlite3MallocMutex()|0); //@line 19326 "c/sqlite3.c"
  $11 = $10;
 } else {
  $9 = (_sqlite3Pcache1Mutex()|0); //@line 19326 "c/sqlite3.c"
  $11 = $9;
 }
 _sqlite3_mutex_enter($11); //@line 19327 "c/sqlite3.c"
 $12 = (40108 + ($0<<2)|0); //@line 19328 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 19328 "c/sqlite3.c"
 $14 = $1; //@line 19328 "c/sqlite3.c"
 $15 = $14; //@line 19328 "c/sqlite3.c"
 HEAP32[$15>>2] = $13; //@line 19328 "c/sqlite3.c"
 $16 = (($14) + 4)|0; //@line 19328 "c/sqlite3.c"
 $17 = $16; //@line 19328 "c/sqlite3.c"
 HEAP32[$17>>2] = 0; //@line 19328 "c/sqlite3.c"
 $18 = (40148 + ($0<<2)|0); //@line 19329 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 19329 "c/sqlite3.c"
 $20 = $2; //@line 19329 "c/sqlite3.c"
 $21 = $20; //@line 19329 "c/sqlite3.c"
 HEAP32[$21>>2] = $19; //@line 19329 "c/sqlite3.c"
 $22 = (($20) + 4)|0; //@line 19329 "c/sqlite3.c"
 $23 = $22; //@line 19329 "c/sqlite3.c"
 HEAP32[$23>>2] = 0; //@line 19329 "c/sqlite3.c"
 $24 = ($3|0)==(0); //@line 19330 "c/sqlite3.c"
 if (!($24)) {
  HEAP32[$18>>2] = $13; //@line 19331 "c/sqlite3.c"
 }
 _sqlite3_mutex_leave($11); //@line 19333 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 19336 "c/sqlite3.c"
}
function _sqlite3MisuseError($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3ReportError(21,$0,15084)|0); //@line 146733 "c/sqlite3.c"
 return 21; //@line 146733 "c/sqlite3.c"
}
function _sqlite3Pcache1Mutex() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[(40272)>>2]|0; //@line 47250 "c/sqlite3.c"
 return ($0|0); //@line 47250 "c/sqlite3.c"
}
function _sqlite3MallocMutex() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[10020]|0; //@line 25195 "c/sqlite3.c"
 return ($0|0); //@line 25195 "c/sqlite3.c"
}
function _sqlite3_mutex_enter($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 23789 "c/sqlite3.c"
 if ($1) {
  return; //@line 23793 "c/sqlite3.c"
 }
 $2 = HEAP32[(100)>>2]|0; //@line 23791 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$2 & 127]($0); //@line 23791 "c/sqlite3.c"
 return; //@line 23793 "c/sqlite3.c"
}
function _sqlite3_mutex_leave($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 23815 "c/sqlite3.c"
 if ($1) {
  return; //@line 23819 "c/sqlite3.c"
 }
 $2 = HEAP32[(108)>>2]|0; //@line 23817 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$2 & 127]($0); //@line 23817 "c/sqlite3.c"
 return; //@line 23819 "c/sqlite3.c"
}
function _sqlite3ReportError($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 146722 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 146723 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 146723 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $1; //@line 146723 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 146723 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = (15136); //@line 146723 "c/sqlite3.c"
 _sqlite3_log($0,15091,$vararg_buffer); //@line 146723 "c/sqlite3.c"
 STACKTOP = sp;return ($0|0); //@line 146725 "c/sqlite3.c"
}
function _sqlite3_log($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[(260)>>2]|0; //@line 26931 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 26931 "c/sqlite3.c"
 if ($4) {
  STACKTOP = sp;return; //@line 26936 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = $varargs; //@line 26932 "c/sqlite3.c"
 _renderLogMsg($0,$1,$2); //@line 26933 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 26936 "c/sqlite3.c"
}
function _renderLogMsg($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 240|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(240|0);
 $3 = sp;
 $4 = sp + 24|0;
 _sqlite3StrAccumInit($3,0,$4,210,0); //@line 26920 "c/sqlite3.c"
 _sqlite3VXPrintf($3,$1,$2); //@line 26921 "c/sqlite3.c"
 $5 = HEAP32[(260)>>2]|0; //@line 26922 "c/sqlite3.c"
 $6 = HEAP32[(264)>>2]|0; //@line 26922 "c/sqlite3.c"
 $7 = (_sqlite3StrAccumFinish($3)|0); //@line 26923 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$5 & 255]($6,$0,$7); //@line 26922 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 26924 "c/sqlite3.c"
}
function _sqlite3StrAccumInit($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 4|0); //@line 26783 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 26783 "c/sqlite3.c"
 HEAP32[$0>>2] = $1; //@line 26784 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 26785 "c/sqlite3.c"
 HEAP32[$6>>2] = $3; //@line 26785 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 26786 "c/sqlite3.c"
 HEAP32[$7>>2] = $4; //@line 26786 "c/sqlite3.c"
 $8 = ((($0)) + 16|0); //@line 26787 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 26787 "c/sqlite3.c"
 $9 = ((($0)) + 20|0); //@line 26788 "c/sqlite3.c"
 HEAP8[$9>>0] = 0; //@line 26788 "c/sqlite3.c"
 $10 = ((($0)) + 21|0); //@line 26789 "c/sqlite3.c"
 HEAP8[$10>>0] = 0; //@line 26789 "c/sqlite3.c"
 return; //@line 26790 "c/sqlite3.c"
}
function _sqlite3VXPrintf($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$$6616 = 0, $$0 = 0, $$0489 = 0, $$0497 = 0, $$0507 = 0, $$0523719$lcssa = 0, $$0527 = 0, $$0535 = 0, $$0539 = 0, $$0541 = 0, $$0543 = 0, $$0546 = 0, $$0548$lcssa = 0, $$0548722 = 0, $$0550721 = 0, $$0551 = 0, $$0555$lcssa = 0, $$0555720 = 0, $$0557 = 0, $$0559 = 0;
 var $$0565779 = 0, $$0567 = 0.0, $$0570 = 0, $$0576799 = 0, $$0577795 = 0, $$0579794 = 0, $$0581 = 0, $$0585 = 0, $$0597 = 0, $$0610 = 0, $$0624$lcssa = 0, $$0624709 = 0, $$0625$lcssa = 0.0, $$0625742 = 0.0, $$0626$lcssa = 0, $$0626702 = 0, $$0628 = 0, $$1 = 0, $$10 = 0, $$11 = 0;
 var $$12761 = 0, $$13 = 0, $$14 = 0, $$1498 = 0, $$15$lcssa = 0, $$1508 = 0, $$1516$lcssa = 0, $$1524796 = 0, $$1536$ph = 0, $$1536651653852 = 0, $$1540 = 0, $$1542$ph = 0, $$1542650654 = 0, $$1542650655851 = 0, $$1544$ph = 0, $$1544647656 = 0, $$1544647657850 = 0, $$1547$ph = 0, $$1547645658 = 0, $$1547645659849 = 0;
 var $$1552$lcssa = 0, $$1552731 = 0, $$1556730 = 0, $$1558$ph = 0, $$1558644660 = 0, $$1558644661848 = 0, $$1560 = 0, $$1568 = 0.0, $$1571$ph = 0, $$1571640662 = 0, $$1571640663847 = 0, $$15767 = 0, $$1578 = 0, $$1580 = 0, $$1583 = 0, $$16$lcssa = 0, $$1603 = 0, $$1611 = 0, $$1620760 = 0, $$16774 = 0;
 var $$17 = 0, $$18 = 0, $$19 = 0, $$2 = 0, $$20 = 0, $$22 = 0, $$23 = 0, $$2491$lcssa = 0, $$2491$off = 0, $$2491$off701 = 0, $$2491703 = 0, $$2499 = 0, $$25 = 0, $$2525 = 0, $$2529 = 0, $$2553 = 0, $$2561 = 0, $$2569 = 0.0, $$2572 = 0, $$2584 = 0;
 var $$2600 = 0, $$2604 = 0, $$2612 = 0, $$2621 = 0, $$3 = 0, $$3492 = 0, $$3500 = 0, $$3518736 = 0, $$3526743 = 0, $$3530 = 0, $$3538 = 0, $$3554 = 0, $$3605 = 0, $$3613$lcssa = 0, $$3613748 = 0, $$3622 = 0, $$3622$in765 = 0, $$4493$lcssa = 0, $$4493$off = 0, $$4493$off708 = 0;
 var $$4493710 = 0, $$4501$lcssa = 0, $$4531 = 0, $$4606 = 0, $$4614$lcssa = 0, $$4614754 = 0, $$5$lcssa = 0, $$5494 = 0, $$5502 = 0, $$5615 = 0, $$5704 = 0, $$6 = 0, $$6495 = 0, $$6503 = 0, $$6513$lcssa = 0, $$6513766 = 0, $$6608 = 0, $$6616 = 0, $$7$lcssa = 0, $$7496 = 0;
 var $$7504800 = 0, $$7514773 = 0, $$7522 = 0, $$7534 = 0, $$7617 = 0, $$7711 = 0, $$8 = 0, $$8505 = 0, $$8618 = 0, $$9 = 0, $$in = 0, $$pr = 0.0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0;
 var $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0;
 var $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0;
 var $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0;
 var $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0;
 var $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0;
 var $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0;
 var $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0;
 var $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0;
 var $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0;
 var $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0;
 var $289 = 0.0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0.0, $297 = 0, $298 = 0, $299 = 0.0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0;
 var $306 = 0, $307 = 0, $308 = 0.0, $309 = 0, $31 = 0, $310 = 0, $311 = 0.0, $312 = 0.0, $313 = 0.0, $314 = 0, $315 = 0, $316 = 0.0, $317 = 0, $318 = 0.0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0.0;
 var $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0.0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0.0, $334 = 0, $335 = 0.0, $336 = 0.0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0.0, $341 = 0.0;
 var $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0.0, $35 = 0, $350 = 0.0, $351 = 0, $352 = 0, $353 = 0.0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0;
 var $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0;
 var $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0;
 var $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0;
 var $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0;
 var $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0;
 var $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0;
 var $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0;
 var $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0;
 var $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0;
 var $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0;
 var $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0;
 var $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0;
 var $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0;
 var $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0;
 var $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $arglist_current = 0, $arglist_current11 = 0, $arglist_current14 = 0;
 var $arglist_current17 = 0, $arglist_current2 = 0, $arglist_current20 = 0, $arglist_current23 = 0, $arglist_current26 = 0, $arglist_current29 = 0, $arglist_current32 = 0, $arglist_current35 = 0, $arglist_current38 = 0, $arglist_current41 = 0, $arglist_current44 = 0, $arglist_current47 = 0, $arglist_current5 = 0, $arglist_current8 = 0, $arglist_next = 0, $arglist_next12 = 0, $arglist_next15 = 0, $arglist_next18 = 0, $arglist_next21 = 0, $arglist_next24 = 0;
 var $arglist_next27 = 0, $arglist_next3 = 0, $arglist_next30 = 0, $arglist_next33 = 0, $arglist_next36 = 0, $arglist_next39 = 0, $arglist_next42 = 0, $arglist_next45 = 0, $arglist_next48 = 0, $arglist_next6 = 0, $arglist_next9 = 0, $exitcond = 0, $expanded = 0, $expanded100 = 0, $expanded101 = 0, $expanded102 = 0, $expanded104 = 0, $expanded105 = 0, $expanded107 = 0, $expanded108 = 0;
 var $expanded109 = 0, $expanded111 = 0, $expanded112 = 0, $expanded114 = 0, $expanded115 = 0, $expanded116 = 0, $expanded118 = 0, $expanded119 = 0, $expanded121 = 0, $expanded122 = 0, $expanded123 = 0, $expanded125 = 0, $expanded126 = 0, $expanded128 = 0, $expanded129 = 0, $expanded130 = 0, $expanded132 = 0, $expanded133 = 0, $expanded135 = 0, $expanded136 = 0;
 var $expanded137 = 0, $expanded139 = 0, $expanded140 = 0, $expanded142 = 0, $expanded143 = 0, $expanded144 = 0, $expanded146 = 0, $expanded147 = 0, $expanded149 = 0, $expanded150 = 0, $expanded151 = 0, $expanded153 = 0, $expanded154 = 0, $expanded156 = 0, $expanded157 = 0, $expanded158 = 0, $expanded160 = 0, $expanded161 = 0, $expanded163 = 0, $expanded164 = 0;
 var $expanded165 = 0, $expanded49 = 0, $expanded51 = 0, $expanded52 = 0, $expanded53 = 0, $expanded55 = 0, $expanded56 = 0, $expanded58 = 0, $expanded59 = 0, $expanded60 = 0, $expanded62 = 0, $expanded63 = 0, $expanded65 = 0, $expanded66 = 0, $expanded67 = 0, $expanded69 = 0, $expanded70 = 0, $expanded72 = 0, $expanded73 = 0, $expanded74 = 0;
 var $expanded76 = 0, $expanded77 = 0, $expanded79 = 0, $expanded80 = 0, $expanded81 = 0, $expanded83 = 0, $expanded84 = 0, $expanded86 = 0, $expanded87 = 0, $expanded88 = 0, $expanded90 = 0, $expanded91 = 0, $expanded93 = 0, $expanded94 = 0, $expanded95 = 0, $expanded97 = 0, $expanded98 = 0, $not$ = 0, $or$cond = 0, $or$cond1030 = 0;
 var $or$cond632 = 0, $or$cond633 = 0, $or$cond634 = 0, $or$cond7$not = 0, $or$cond9 = 0, $scevgep = 0, $scevgep843 = 0, $scevgep845 = 0, $spec$select629 = 0, $spec$select630 = 0, $spec$select631 = 0, $spec$select636 = 0, $spec$select638 = 0, $spec$select639 = 0, $spec$select673 = 0, $spec$select674 = 0, $spec$select675 = 0, $spec$select677 = 0, $spec$select678 = 0, $spec$select679 = 0;
 var $spec$select680 = 0, $spec$select681 = 0, $spec$select682 = 0, $storemerge = 0.0, $storemerge683 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $3 = sp;
 $4 = sp + 8|0;
 $5 = sp + 12|0;
 $6 = ((($0)) + 21|0); //@line 26068 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 26068 "c/sqlite3.c"
 $8 = $7 & 2; //@line 26068 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 26068 "c/sqlite3.c"
 if ($9) {
  $$0581 = 1;$$0628 = 0;
 } else {
  $arglist_current = HEAP32[$2>>2]|0; //@line 26069 "c/sqlite3.c"
  $10 = $arglist_current; //@line 26069 "c/sqlite3.c"
  $11 = ((0) + 4|0);
  $expanded49 = $11;
  $expanded = (($expanded49) - 1)|0;
  $12 = (($10) + ($expanded))|0; //@line 26069 "c/sqlite3.c"
  $13 = ((0) + 4|0);
  $expanded53 = $13;
  $expanded52 = (($expanded53) - 1)|0;
  $expanded51 = $expanded52 ^ -1;
  $14 = $12 & $expanded51; //@line 26069 "c/sqlite3.c"
  $15 = $14; //@line 26069 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 26069 "c/sqlite3.c"
  $arglist_next = ((($15)) + 4|0); //@line 26069 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next; //@line 26069 "c/sqlite3.c"
  $$0581 = 0;$$0628 = $16;
 }
 $17 = ((($0)) + 16|0);
 $$0 = $1;$$0497 = 0;
 L4: while(1) {
  $18 = HEAP8[$$0>>0]|0; //@line 26074 "c/sqlite3.c"
  switch ($18<<24>>24) {
  case 0:  {
   label = 228;
   break L4;
   break;
  }
  case 37:  {
   $$1498 = $$0497;$$2 = $$0;
   break;
  }
  default: {
   $$1 = $$0;
   L8: while(1) {
    $19 = ((($$1)) + 1|0); //@line 26080 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 26080 "c/sqlite3.c"
    switch ($20<<24>>24) {
    case 37: case 0:  {
     break L8;
     break;
    }
    default: {
     $$1 = $19;
    }
    }
   }
   $21 = $19; //@line 26082 "c/sqlite3.c"
   $22 = $$0; //@line 26082 "c/sqlite3.c"
   $23 = (($21) - ($22))|0; //@line 26082 "c/sqlite3.c"
   _sqlite3StrAccumAppend($0,$$0,$23); //@line 26082 "c/sqlite3.c"
   $24 = HEAP8[$19>>0]|0; //@line 26083 "c/sqlite3.c"
   $25 = ($24<<24>>24)==(0); //@line 26083 "c/sqlite3.c"
   if ($25) {
    label = 228;
    break L4;
   } else {
    $$1498 = $$0;$$2 = $19;
   }
  }
  }
  $26 = ((($$2)) + 1|0); //@line 26085 "c/sqlite3.c"
  $27 = HEAP8[$26>>0]|0; //@line 26085 "c/sqlite3.c"
  $28 = ($27<<24>>24)==(0); //@line 26085 "c/sqlite3.c"
  if ($28) {
   label = 9;
   break;
  }
  $29 = $27 << 24 >> 24; //@line 26085 "c/sqlite3.c"
  $$0489 = $29;$$0535 = 0;$$0541 = 0;$$0543 = 0;$$0546 = 0;$$0557 = 0;$$0570 = 0;$$3 = $26;
  L13: while(1) {
   switch ($$0489|0) {
   case 42:  {
    label = 19;
    break L13;
    break;
   }
   case 45:  {
    $$1536$ph = 1;$$1542$ph = $$0541;$$1544$ph = $$0543;$$1547$ph = $$0546;$$1558$ph = $$0557;$$1571$ph = $$0570;
    break;
   }
   case 43:  {
    $$1536$ph = $$0535;$$1542$ph = 43;$$1544$ph = $$0543;$$1547$ph = $$0546;$$1558$ph = $$0557;$$1571$ph = $$0570;
    break;
   }
   case 32:  {
    $$1536$ph = $$0535;$$1542$ph = 32;$$1544$ph = $$0543;$$1547$ph = $$0546;$$1558$ph = $$0557;$$1571$ph = $$0570;
    break;
   }
   case 35:  {
    $$1536$ph = $$0535;$$1542$ph = $$0541;$$1544$ph = 1;$$1547$ph = $$0546;$$1558$ph = $$0557;$$1571$ph = $$0570;
    break;
   }
   case 33:  {
    $$1536$ph = $$0535;$$1542$ph = $$0541;$$1544$ph = $$0543;$$1547$ph = 1;$$1558$ph = $$0557;$$1571$ph = $$0570;
    break;
   }
   case 48:  {
    $$1536$ph = $$0535;$$1542$ph = $$0541;$$1544$ph = $$0543;$$1547$ph = $$0546;$$1558$ph = 1;$$1571$ph = $$0570;
    break;
   }
   case 44:  {
    $$1536$ph = $$0535;$$1542$ph = $$0541;$$1544$ph = $$0543;$$1547$ph = $$0546;$$1558$ph = $$0557;$$1571$ph = 44;
    break;
   }
   default: {
    label = 23;
    break L13;
   }
   }
   $30 = ((($$3)) + 1|0); //@line 26104 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 26104 "c/sqlite3.c"
   $32 = $31 << 24 >> 24; //@line 26104 "c/sqlite3.c"
   $33 = ($31<<24>>24)==(0); //@line 26104 "c/sqlite3.c"
   if ($33) {
    $$0626$lcssa = 0;$$1536651653852 = $$1536$ph;$$1542650655851 = $$1542$ph;$$1544647657850 = $$1544$ph;$$1547645659849 = $$1547$ph;$$1558644661848 = $$1558$ph;$$1571640663847 = $$1571$ph;$$2491$lcssa = 0;$$5$lcssa = $30;
    label = 27;
    break;
   } else {
    $$0489 = $32;$$0535 = $$1536$ph;$$0541 = $$1542$ph;$$0543 = $$1544$ph;$$0546 = $$1547$ph;$$0557 = $$1558$ph;$$0570 = $$1571$ph;$$3 = $30;
   }
  }
  if ((label|0) == 19) {
   label = 0;
   if ($$0581) {
    $arglist_current2 = HEAP32[$2>>2]|0; //@line 26110 "c/sqlite3.c"
    $36 = $arglist_current2; //@line 26110 "c/sqlite3.c"
    $37 = ((0) + 4|0);
    $expanded56 = $37;
    $expanded55 = (($expanded56) - 1)|0;
    $38 = (($36) + ($expanded55))|0; //@line 26110 "c/sqlite3.c"
    $39 = ((0) + 4|0);
    $expanded60 = $39;
    $expanded59 = (($expanded60) - 1)|0;
    $expanded58 = $expanded59 ^ -1;
    $40 = $38 & $expanded58; //@line 26110 "c/sqlite3.c"
    $41 = $40; //@line 26110 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 26110 "c/sqlite3.c"
    $arglist_next3 = ((($41)) + 4|0); //@line 26110 "c/sqlite3.c"
    HEAP32[$2>>2] = $arglist_next3; //@line 26110 "c/sqlite3.c"
    $$0527 = $42;
   } else {
    $34 = (_getIntArg($$0628)|0); //@line 26108 "c/sqlite3.c"
    $35 = tempRet0; //@line 26108 "c/sqlite3.c"
    $$0527 = $34;
   }
   $43 = ($$0527|0)<(0); //@line 26112 "c/sqlite3.c"
   $44 = ($$0527|0)==(-2147483648); //@line 26114 "c/sqlite3.c"
   $45 = (0 - ($$0527))|0; //@line 26114 "c/sqlite3.c"
   $46 = $44 ? 0 : $45; //@line 26114 "c/sqlite3.c"
   $spec$select673 = $43 ? 1 : $$0535; //@line 26112 "c/sqlite3.c"
   $spec$select674 = $43 ? $46 : $$0527; //@line 26112 "c/sqlite3.c"
   $47 = ((($$3)) + 1|0); //@line 26116 "c/sqlite3.c"
   $48 = HEAP8[$47>>0]|0; //@line 26116 "c/sqlite3.c"
   $49 = $48 << 24 >> 24; //@line 26116 "c/sqlite3.c"
   $$1542650654 = $$0541;$$1544647656 = $$0543;$$1547645658 = $$0546;$$1558644660 = $$0557;$$1571640662 = $$0570;$$2529 = $spec$select674;$$3492 = $49;$$3538 = $spec$select673;$$6 = $47;
  }
  else if ((label|0) == 23) {
   label = 0;
   $$2491$off701 = (($$0489) + -48)|0; //@line 26119 "c/sqlite3.c"
   $50 = ($$2491$off701>>>0)<(10); //@line 26119 "c/sqlite3.c"
   if ($50) {
    $$0626702 = 0;$$2491703 = $$0489;$$5704 = $$3;
    while(1) {
     $51 = ($$0626702*10)|0; //@line 26120 "c/sqlite3.c"
     $52 = (($$2491703) + -48)|0; //@line 26120 "c/sqlite3.c"
     $53 = (($52) + ($51))|0; //@line 26120 "c/sqlite3.c"
     $54 = ((($$5704)) + 1|0); //@line 26121 "c/sqlite3.c"
     $55 = HEAP8[$54>>0]|0; //@line 26121 "c/sqlite3.c"
     $56 = $55 << 24 >> 24; //@line 26121 "c/sqlite3.c"
     $$2491$off = (($56) + -48)|0; //@line 26119 "c/sqlite3.c"
     $57 = ($$2491$off>>>0)<(10); //@line 26119 "c/sqlite3.c"
     if ($57) {
      $$0626702 = $53;$$2491703 = $56;$$5704 = $54;
     } else {
      break;
     }
    }
    $58 = $55 << 24 >> 24; //@line 26121 "c/sqlite3.c"
    $$0626$lcssa = $53;$$1536651653852 = $$0535;$$1542650655851 = $$0541;$$1544647657850 = $$0543;$$1547645659849 = $$0546;$$1558644661848 = $$0557;$$1571640663847 = $$0570;$$2491$lcssa = $58;$$5$lcssa = $54;
    label = 27;
   } else {
    $$0626$lcssa = 0;$$1536651653852 = $$0535;$$1542650655851 = $$0541;$$1544647657850 = $$0543;$$1547645659849 = $$0546;$$1558644661848 = $$0557;$$1571640663847 = $$0570;$$2491$lcssa = $$0489;$$5$lcssa = $$3;
    label = 27;
   }
  }
  if ((label|0) == 27) {
   label = 0;
   $59 = $$0626$lcssa & 2147483647; //@line 26124 "c/sqlite3.c"
   $$1542650654 = $$1542650655851;$$1544647656 = $$1544647657850;$$1547645658 = $$1547645659849;$$1558644660 = $$1558644661848;$$1571640662 = $$1571640663847;$$2529 = $59;$$3492 = $$2491$lcssa;$$3538 = $$1536651653852;$$6 = $$5$lcssa;
  }
  $60 = ($$3492|0)==(46); //@line 26134 "c/sqlite3.c"
  do {
   if ($60) {
    $61 = ((($$6)) + 1|0); //@line 26135 "c/sqlite3.c"
    $62 = HEAP8[$61>>0]|0; //@line 26135 "c/sqlite3.c"
    $63 = ($62<<24>>24)==(42); //@line 26136 "c/sqlite3.c"
    if ($63) {
     if ($$0581) {
      $arglist_current5 = HEAP32[$2>>2]|0; //@line 26140 "c/sqlite3.c"
      $66 = $arglist_current5; //@line 26140 "c/sqlite3.c"
      $67 = ((0) + 4|0);
      $expanded63 = $67;
      $expanded62 = (($expanded63) - 1)|0;
      $68 = (($66) + ($expanded62))|0; //@line 26140 "c/sqlite3.c"
      $69 = ((0) + 4|0);
      $expanded67 = $69;
      $expanded66 = (($expanded67) - 1)|0;
      $expanded65 = $expanded66 ^ -1;
      $70 = $68 & $expanded65; //@line 26140 "c/sqlite3.c"
      $71 = $70; //@line 26140 "c/sqlite3.c"
      $72 = HEAP32[$71>>2]|0; //@line 26140 "c/sqlite3.c"
      $arglist_next6 = ((($71)) + 4|0); //@line 26140 "c/sqlite3.c"
      HEAP32[$2>>2] = $arglist_next6; //@line 26140 "c/sqlite3.c"
      $$0507 = $72;
     } else {
      $64 = (_getIntArg($$0628)|0); //@line 26138 "c/sqlite3.c"
      $65 = tempRet0; //@line 26138 "c/sqlite3.c"
      $$0507 = $64;
     }
     $73 = ((($$6)) + 2|0); //@line 26142 "c/sqlite3.c"
     $74 = HEAP8[$73>>0]|0; //@line 26142 "c/sqlite3.c"
     $75 = $74 << 24 >> 24; //@line 26142 "c/sqlite3.c"
     $76 = ($$0507|0)<(0); //@line 26143 "c/sqlite3.c"
     $77 = ($$0507|0)==(-2147483648); //@line 26144 "c/sqlite3.c"
     $78 = (0 - ($$0507))|0; //@line 26144 "c/sqlite3.c"
     $79 = $77 ? -1 : $78; //@line 26144 "c/sqlite3.c"
     $spec$select675 = $76 ? $79 : $$0507; //@line 26143 "c/sqlite3.c"
     $$1508 = $spec$select675;$$5494 = $75;$$8 = $73;
     break;
    }
    $80 = $62 << 24 >> 24; //@line 26135 "c/sqlite3.c"
    $$4493$off708 = (($80) + -48)|0; //@line 26148 "c/sqlite3.c"
    $81 = ($$4493$off708>>>0)<(10); //@line 26148 "c/sqlite3.c"
    if ($81) {
     $$0624709 = 0;$$4493710 = $80;$$7711 = $61;
     while(1) {
      $82 = ($$0624709*10)|0; //@line 26149 "c/sqlite3.c"
      $83 = (($$4493710) + -48)|0; //@line 26149 "c/sqlite3.c"
      $84 = (($83) + ($82))|0; //@line 26149 "c/sqlite3.c"
      $85 = ((($$7711)) + 1|0); //@line 26150 "c/sqlite3.c"
      $86 = HEAP8[$85>>0]|0; //@line 26150 "c/sqlite3.c"
      $87 = $86 << 24 >> 24; //@line 26150 "c/sqlite3.c"
      $$4493$off = (($87) + -48)|0; //@line 26148 "c/sqlite3.c"
      $88 = ($$4493$off>>>0)<(10); //@line 26148 "c/sqlite3.c"
      if ($88) {
       $$0624709 = $84;$$4493710 = $87;$$7711 = $85;
      } else {
       break;
      }
     }
     $89 = $86 << 24 >> 24; //@line 26150 "c/sqlite3.c"
     $$0624$lcssa = $84;$$4493$lcssa = $89;$$7$lcssa = $85;
    } else {
     $$0624$lcssa = 0;$$4493$lcssa = $80;$$7$lcssa = $61;
    }
    $90 = $$0624$lcssa & 2147483647; //@line 26153 "c/sqlite3.c"
    $$1508 = $90;$$5494 = $$4493$lcssa;$$8 = $$7$lcssa;
   } else {
    $$1508 = -1;$$5494 = $$3492;$$8 = $$6;
   }
  } while(0);
  $91 = ($$5494|0)==(108); //@line 26167 "c/sqlite3.c"
  if ($91) {
   $92 = ((($$8)) + 1|0); //@line 26169 "c/sqlite3.c"
   $93 = HEAP8[$92>>0]|0; //@line 26169 "c/sqlite3.c"
   $94 = $93 << 24 >> 24; //@line 26169 "c/sqlite3.c"
   $95 = ($93<<24>>24)==(108); //@line 26170 "c/sqlite3.c"
   if ($95) {
    $96 = ((($$8)) + 2|0); //@line 26172 "c/sqlite3.c"
    $97 = HEAP8[$96>>0]|0; //@line 26172 "c/sqlite3.c"
    $98 = $97 << 24 >> 24; //@line 26172 "c/sqlite3.c"
    $$0559 = 2;$$6495 = $98;$$9 = $96;
   } else {
    $$0559 = 1;$$6495 = $94;$$9 = $92;
   }
  } else {
   $$0559 = 0;$$6495 = $$5494;$$9 = $$8;
  }
  do {
   switch ($$6495|0) {
   case 100:  {
    $$0523719$lcssa = 0;
    break;
   }
   case 115:  {
    $$0523719$lcssa = 1;
    break;
   }
   case 103:  {
    $$0523719$lcssa = 2;
    break;
   }
   case 122:  {
    $$0523719$lcssa = 3;
    break;
   }
   case 113:  {
    $$0523719$lcssa = 4;
    break;
   }
   case 81:  {
    $$0523719$lcssa = 5;
    break;
   }
   case 119:  {
    $$0523719$lcssa = 6;
    break;
   }
   case 99:  {
    $$0523719$lcssa = 7;
    break;
   }
   case 111:  {
    $$0523719$lcssa = 8;
    break;
   }
   case 117:  {
    $$0523719$lcssa = 9;
    break;
   }
   case 120:  {
    $$0523719$lcssa = 10;
    break;
   }
   case 88:  {
    $$0523719$lcssa = 11;
    break;
   }
   case 102:  {
    $$0523719$lcssa = 12;
    break;
   }
   case 101:  {
    $$0523719$lcssa = 13;
    break;
   }
   case 69:  {
    $$0523719$lcssa = 14;
    break;
   }
   case 71:  {
    $$0523719$lcssa = 15;
    break;
   }
   case 105:  {
    $$0523719$lcssa = 16;
    break;
   }
   case 110:  {
    $$0523719$lcssa = 17;
    break;
   }
   case 37:  {
    $$0523719$lcssa = 18;
    break;
   }
   case 112:  {
    $$0523719$lcssa = 19;
    break;
   }
   case 84:  {
    $$0523719$lcssa = 20;
    break;
   }
   case 83:  {
    $$0523719$lcssa = 21;
    break;
   }
   case 114:  {
    $$0523719$lcssa = 22;
    break;
   }
   default: {
    label = 228;
    break L4;
   }
   }
  } while(0);
  $99 = (((15203 + (($$0523719$lcssa*6)|0)|0)) + 3|0); //@line 26183 "c/sqlite3.c"
  $100 = HEAP8[$99>>0]|0; //@line 26183 "c/sqlite3.c"
  L81: do {
   switch ($100<<24>>24) {
   case 13:  {
    $$1560 = 1;
    label = 67;
    break;
   }
   case 0: case 15:  {
    $$1560 = $$0559;
    label = 67;
    break;
   }
   case 16:  {
    $$2561 = $$0559;$$2572 = $$1571640662;
    label = 68;
    break;
   }
   case 3: case 2: case 1:  {
    if ($$0581) {
     $arglist_current26 = HEAP32[$2>>2]|0; //@line 26321 "c/sqlite3.c"
     $290 = $arglist_current26; //@line 26321 "c/sqlite3.c"
     $291 = ((0) + 8|0);
     $expanded112 = $291;
     $expanded111 = (($expanded112) - 1)|0;
     $292 = (($290) + ($expanded111))|0; //@line 26321 "c/sqlite3.c"
     $293 = ((0) + 8|0);
     $expanded116 = $293;
     $expanded115 = (($expanded116) - 1)|0;
     $expanded114 = $expanded115 ^ -1;
     $294 = $292 & $expanded114; //@line 26321 "c/sqlite3.c"
     $295 = $294; //@line 26321 "c/sqlite3.c"
     $296 = +HEAPF64[$295>>3]; //@line 26321 "c/sqlite3.c"
     $arglist_next27 = ((($295)) + 8|0); //@line 26321 "c/sqlite3.c"
     HEAP32[$2>>2] = $arglist_next27; //@line 26321 "c/sqlite3.c"
     $storemerge = $296;
    } else {
     $289 = (+_getDoubleArg($$0628)); //@line 26319 "c/sqlite3.c"
     $storemerge = $289;
    }
    $297 = ($$1508|0)<(0); //@line 26326 "c/sqlite3.c"
    $spec$select630 = $297 ? 6 : $$1508; //@line 26326 "c/sqlite3.c"
    $298 = $storemerge < 0.0; //@line 26327 "c/sqlite3.c"
    $299 = - $storemerge; //@line 26328 "c/sqlite3.c"
    $storemerge683 = $298 ? $299 : $storemerge; //@line 26327 "c/sqlite3.c"
    $$2584 = $298 ? 45 : $$1542650654; //@line 26327 "c/sqlite3.c"
    HEAPF64[$3>>3] = $storemerge683;
    $300 = ($$0523719$lcssa|0)==(2); //@line 26333 "c/sqlite3.c"
    $301 = ($$0523719$lcssa|0)==(15); //@line 26333 "c/sqlite3.c"
    $302 = $300 | $301; //@line 26333 "c/sqlite3.c"
    $303 = ($spec$select630|0)>(0); //@line 26333 "c/sqlite3.c"
    $or$cond = $303 & $302; //@line 26333 "c/sqlite3.c"
    $304 = $or$cond << 31 >> 31; //@line 26333 "c/sqlite3.c"
    $spec$select631 = (($spec$select630) + ($304))|0; //@line 26333 "c/sqlite3.c"
    $305 = $spec$select631 & 4095; //@line 26335 "c/sqlite3.c"
    $306 = ($305|0)==(0); //@line 26335 "c/sqlite3.c"
    if ($306) {
     $$0625$lcssa = 0.5;
    } else {
     $$0625742 = 0.5;$$3526743 = $305;
     while(1) {
      $307 = (($$3526743) + -1)|0; //@line 26335 "c/sqlite3.c"
      $308 = $$0625742 * 0.10000000000000001; //@line 26335 "c/sqlite3.c"
      $309 = ($$3526743|0)>(1); //@line 26335 "c/sqlite3.c"
      if ($309) {
       $$0625742 = $308;$$3526743 = $307;
      } else {
       $$0625$lcssa = $308;
       break;
      }
     }
    }
    $310 = ($$0523719$lcssa|0)==(12); //@line 26336 "c/sqlite3.c"
    if ($310) {
     $311 = +HEAPF64[$3>>3]; //@line 26336 "c/sqlite3.c"
     $312 = $$0625$lcssa + $311; //@line 26336 "c/sqlite3.c"
     HEAPF64[$3>>3] = $312; //@line 26336 "c/sqlite3.c"
    }
    $313 = +HEAPF64[$3>>3]; //@line 26339 "c/sqlite3.c"
    $314 = (_sqlite3IsNaN($313)|0); //@line 26339 "c/sqlite3.c"
    $315 = ($314|0)==(0); //@line 26339 "c/sqlite3.c"
    if ($315) {
     $316 = +HEAPF64[$3>>3]; //@line 26344 "c/sqlite3.c"
     $317 = $316 > 0.0; //@line 26344 "c/sqlite3.c"
     if ($317) {
      $$0567 = 1.0;$$0610 = 0;
      while(1) {
       $318 = $$0567 * 1.0E+100; //@line 26346 "c/sqlite3.c"
       $319 = $316 >= $318; //@line 26346 "c/sqlite3.c"
       $320 = ($$0610>>>0)<(351); //@line 26346 "c/sqlite3.c"
       $321 = $320 & $319; //@line 26346 "c/sqlite3.c"
       $322 = (($$0610) + 100)|0; //@line 26346 "c/sqlite3.c"
       if ($321) {
        $$0567 = $318;$$0610 = $322;
       } else {
        break;
       }
      }
      $$1568 = $$0567;$$1611 = $$0610;
      while(1) {
       $323 = $$1568 * 1.0E+10; //@line 26347 "c/sqlite3.c"
       $324 = $316 >= $323; //@line 26347 "c/sqlite3.c"
       $325 = ($$1611>>>0)<(351); //@line 26347 "c/sqlite3.c"
       $326 = $325 & $324; //@line 26347 "c/sqlite3.c"
       $327 = (($$1611) + 10)|0; //@line 26347 "c/sqlite3.c"
       if ($326) {
        $$1568 = $323;$$1611 = $327;
       } else {
        break;
       }
      }
      $$2569 = $$1568;$$2612 = $$1611;
      while(1) {
       $328 = $$2569 * 10.0; //@line 26348 "c/sqlite3.c"
       $329 = $316 >= $328; //@line 26348 "c/sqlite3.c"
       $330 = ($$2612>>>0)<(351); //@line 26348 "c/sqlite3.c"
       $331 = $330 & $329; //@line 26348 "c/sqlite3.c"
       $332 = (($$2612) + 1)|0; //@line 26348 "c/sqlite3.c"
       if ($331) {
        $$2569 = $328;$$2612 = $332;
       } else {
        break;
       }
      }
      $333 = $316 / $$2569; //@line 26349 "c/sqlite3.c"
      HEAPF64[$3>>3] = $333; //@line 26349 "c/sqlite3.c"
      $334 = $333 < 1.0E-8; //@line 26350 "c/sqlite3.c"
      if ($334) {
       $$3613748 = $$2612;$336 = $333;
       while(1) {
        $335 = $336 * 1.0E+8; //@line 26350 "c/sqlite3.c"
        $337 = (($$3613748) + -8)|0; //@line 26350 "c/sqlite3.c"
        $338 = $335 < 1.0E-8; //@line 26350 "c/sqlite3.c"
        if ($338) {
         $$3613748 = $337;$336 = $335;
        } else {
         break;
        }
       }
       HEAPF64[$3>>3] = $335; //@line 26350 "c/sqlite3.c"
       $$3613$lcssa = $337;$$pr = $335;
      } else {
       $$3613$lcssa = $$2612;$$pr = $333;
      }
      $339 = $$pr < 1.0; //@line 26351 "c/sqlite3.c"
      if ($339) {
       $$4614754 = $$3613$lcssa;$341 = $$pr;
       while(1) {
        $340 = $341 * 10.0; //@line 26351 "c/sqlite3.c"
        $342 = (($$4614754) + -1)|0; //@line 26351 "c/sqlite3.c"
        $343 = $340 < 1.0; //@line 26351 "c/sqlite3.c"
        if ($343) {
         $$4614754 = $342;$341 = $340;
        } else {
         break;
        }
       }
       HEAPF64[$3>>3] = $340; //@line 26351 "c/sqlite3.c"
       $$4614$lcssa = $342;
      } else {
       $$4614$lcssa = $$3613$lcssa;
      }
      $344 = ($$4614$lcssa|0)>(350); //@line 26352 "c/sqlite3.c"
      $345 = ($$2584<<24>>24)!=(0); //@line 26355 "c/sqlite3.c"
      if ($344) {
       $346 = $345 ? 4 : 3; //@line 26356 "c/sqlite3.c"
       $347 = $345&1; //@line 26355 "c/sqlite3.c"
       $348 = (($5) + ($347)|0); //@line 26355 "c/sqlite3.c"
       HEAP8[$5>>0] = $$2584; //@line 26354 "c/sqlite3.c"
       HEAP8[$348>>0]=6712905&255;HEAP8[$348+1>>0]=(6712905>>8)&255;HEAP8[$348+2>>0]=(6712905>>16)&255;HEAP8[$348+3>>0]=6712905>>24; //@line 26355 "c/sqlite3.c"
       $$25 = $5;$$6608 = 0;$$7522 = $346;$$7534 = $$2529;
       break L81;
      } else {
       $$5615 = $$4614$lcssa;
      }
     } else {
      $$5615 = 0;
     }
     if ($310) {
      $$6616 = $$5615;
     } else {
      $349 = +HEAPF64[$3>>3]; //@line 26366 "c/sqlite3.c"
      $350 = $$0625$lcssa + $349; //@line 26366 "c/sqlite3.c"
      HEAPF64[$3>>3] = $350; //@line 26366 "c/sqlite3.c"
      $351 = !($350 >= 10.0); //@line 26367 "c/sqlite3.c"
      if ($351) {
       $$6616 = $$5615;
      } else {
       $352 = (($$5615) + 1)|0; //@line 26367 "c/sqlite3.c"
       $353 = $350 * 0.10000000000000001; //@line 26367 "c/sqlite3.c"
       HEAPF64[$3>>3] = $353; //@line 26367 "c/sqlite3.c"
       $$6616 = $352;
      }
     }
     $354 = ($$1544647656<<24>>24)==(0); //@line 26370 "c/sqlite3.c"
     $355 = $354&1; //@line 26370 "c/sqlite3.c"
     $356 = ($$6616|0)<(-4); //@line 26371 "c/sqlite3.c"
     $357 = ($spec$select631|0)<($$6616|0); //@line 26371 "c/sqlite3.c"
     $or$cond632 = $356 | $357; //@line 26371 "c/sqlite3.c"
     $spec$select638 = $or$cond632 ? 2 : 1; //@line 26371 "c/sqlite3.c"
     $358 = $or$cond632 ? 0 : $$6616; //@line 26371 "c/sqlite3.c"
     $spec$select639 = (($spec$select631) - ($358))|0; //@line 26371 "c/sqlite3.c"
     $spec$select679 = $302 ? $355 : $$1547645658; //@line 26369 "c/sqlite3.c"
     $spec$select680 = $302 ? $spec$select638 : $100; //@line 26369 "c/sqlite3.c"
     $spec$select681 = $302 ? $spec$select639 : $spec$select630; //@line 26369 "c/sqlite3.c"
     $359 = ($spec$select680<<24>>24)==(2); //@line 26380 "c/sqlite3.c"
     $$$6616 = $359 ? 0 : $$6616; //@line 26382 "c/sqlite3.c"
     $360 = ($$$6616|0)>(0); //@line 26385 "c/sqlite3.c"
     $361 = $360 ? $$$6616 : 0; //@line 26385 "c/sqlite3.c"
     $362 = ($spec$select681|0)<(0); //@line 26385 "c/sqlite3.c"
     $363 = $362 << 31 >> 31; //@line 26385 "c/sqlite3.c"
     $364 = ($$2529|0)<(0); //@line 26385 "c/sqlite3.c"
     $365 = $364 << 31 >> 31; //@line 26385 "c/sqlite3.c"
     $366 = (_i64Add(($spec$select681|0),($363|0),($$2529|0),($365|0))|0); //@line 26385 "c/sqlite3.c"
     $367 = tempRet0; //@line 26385 "c/sqlite3.c"
     $368 = (_i64Add(($366|0),($367|0),($361|0),0)|0); //@line 26385 "c/sqlite3.c"
     $369 = tempRet0; //@line 26385 "c/sqlite3.c"
     $370 = ($369|0)>(0); //@line 26385 "c/sqlite3.c"
     $371 = ($368>>>0)>(55); //@line 26385 "c/sqlite3.c"
     $372 = ($369|0)==(0); //@line 26385 "c/sqlite3.c"
     $373 = $372 & $371; //@line 26385 "c/sqlite3.c"
     $374 = $370 | $373; //@line 26385 "c/sqlite3.c"
     if ($374) {
      $375 = (_i64Add(($368|0),($369|0),15,0)|0); //@line 26387 "c/sqlite3.c"
      $376 = tempRet0; //@line 26387 "c/sqlite3.c"
      $377 = (_sqlite3Malloc($375,$376)|0); //@line 26387 "c/sqlite3.c"
      $378 = ($377|0)==(0|0); //@line 26388 "c/sqlite3.c"
      if ($378) {
       label = 136;
       break L4;
      } else {
       $$10 = $377;$$2604 = $377;
      }
     } else {
      $$10 = $5;$$2604 = 0;
     }
     $379 = $$1547645658&255; //@line 26394 "c/sqlite3.c"
     $380 = ($379*10)|0; //@line 26394 "c/sqlite3.c"
     $381 = (($380) + 16)|0; //@line 26394 "c/sqlite3.c"
     HEAP32[$4>>2] = $381; //@line 26394 "c/sqlite3.c"
     $382 = ($spec$select681|0)>(0); //@line 26395 "c/sqlite3.c"
     $383 = $382&1; //@line 26395 "c/sqlite3.c"
     $384 = $$1544647656 | $$1547645658; //@line 26395 "c/sqlite3.c"
     $385 = $384&255; //@line 26395 "c/sqlite3.c"
     $386 = $385 | $383; //@line 26395 "c/sqlite3.c"
     $387 = ($$2584<<24>>24)==(0); //@line 26397 "c/sqlite3.c"
     if ($387) {
      $$11 = $$10;
     } else {
      $388 = ((($$10)) + 1|0); //@line 26398 "c/sqlite3.c"
      HEAP8[$$10>>0] = $$2584; //@line 26398 "c/sqlite3.c"
      $$11 = $388;
     }
     $389 = ($$$6616|0)<(0); //@line 26401 "c/sqlite3.c"
     if ($389) {
      $390 = ((($$11)) + 1|0); //@line 26402 "c/sqlite3.c"
      HEAP8[$$11>>0] = 48; //@line 26402 "c/sqlite3.c"
      $$13 = $390;$$2621 = $$$6616;
     } else {
      $$12761 = $$11;$$1620760 = $$$6616;
      while(1) {
       $391 = (_et_getdigit($3,$4)|0); //@line 26405 "c/sqlite3.c"
       $392 = ((($$12761)) + 1|0); //@line 26405 "c/sqlite3.c"
       HEAP8[$$12761>>0] = $391; //@line 26405 "c/sqlite3.c"
       $393 = (($$1620760) + -1)|0; //@line 26404 "c/sqlite3.c"
       $394 = ($$1620760|0)>(0); //@line 26404 "c/sqlite3.c"
       if ($394) {
        $$12761 = $392;$$1620760 = $393;
       } else {
        $$13 = $392;$$2621 = -1;
        break;
       }
      }
     }
     $395 = ($386|0)==(0); //@line 26409 "c/sqlite3.c"
     if ($395) {
      $$14 = $$13;
     } else {
      $396 = ((($$13)) + 1|0); //@line 26410 "c/sqlite3.c"
      HEAP8[$$13>>0] = 46; //@line 26410 "c/sqlite3.c"
      $$14 = $396;
     }
     $397 = ($$2621|0)<(-1); //@line 26414 "c/sqlite3.c"
     if ($397) {
      $398 = $$2621 ^ -1; //@line 26414 "c/sqlite3.c"
      _memset(($$14|0),48,($398|0))|0; //@line 26416 "c/sqlite3.c"
      $$15767 = $$14;$$3622$in765 = $$2621;$$6513766 = $spec$select681;
      while(1) {
       $$3622 = (($$3622$in765) + 1)|0;
       $399 = ((($$15767)) + 1|0); //@line 26416 "c/sqlite3.c"
       $400 = (($$6513766) + -1)|0; //@line 26414 "c/sqlite3.c"
       $401 = ($$3622$in765|0)<(-2); //@line 26414 "c/sqlite3.c"
       if ($401) {
        $$15767 = $399;$$3622$in765 = $$3622;$$6513766 = $400;
       } else {
        $$15$lcssa = $399;$$6513$lcssa = $400;
        break;
       }
      }
     } else {
      $$15$lcssa = $$14;$$6513$lcssa = $spec$select681;
     }
     $402 = ($$6513$lcssa|0)>(0); //@line 26419 "c/sqlite3.c"
     if ($402) {
      $$16774 = $$15$lcssa;$$7514773 = $$6513$lcssa;
      while(1) {
       $403 = (($$7514773) + -1)|0; //@line 26419 "c/sqlite3.c"
       $404 = (_et_getdigit($3,$4)|0); //@line 26420 "c/sqlite3.c"
       $405 = ((($$16774)) + 1|0); //@line 26420 "c/sqlite3.c"
       HEAP8[$$16774>>0] = $404; //@line 26420 "c/sqlite3.c"
       $406 = ($$7514773|0)>(1); //@line 26419 "c/sqlite3.c"
       if ($406) {
        $$16774 = $405;$$7514773 = $403;
       } else {
        $$16$lcssa = $405;
        break;
       }
      }
     } else {
      $$16$lcssa = $$15$lcssa;
     }
     $407 = ($spec$select679<<24>>24)==(0); //@line 26423 "c/sqlite3.c"
     $or$cond633 = $407 | $395; //@line 26423 "c/sqlite3.c"
     L151: do {
      if ($or$cond633) {
       $$18 = $$16$lcssa;
      } else {
       $$17 = $$16$lcssa;
       L153: while(1) {
        $408 = ((($$17)) + -1|0); //@line 26424 "c/sqlite3.c"
        $409 = HEAP8[$408>>0]|0; //@line 26424 "c/sqlite3.c"
        switch ($409<<24>>24) {
        case 46:  {
         break L153;
         break;
        }
        case 48:  {
         break;
        }
        default: {
         $$18 = $$17;
         break L151;
        }
        }
        HEAP8[$408>>0] = 0; //@line 26424 "c/sqlite3.c"
        $$17 = $408;
       }
       $410 = ($$1547645658<<24>>24)==(0); //@line 26427 "c/sqlite3.c"
       if ($410) {
        HEAP8[$408>>0] = 0; //@line 26430 "c/sqlite3.c"
        $$18 = $408;
        break;
       } else {
        $411 = ((($$17)) + 1|0); //@line 26428 "c/sqlite3.c"
        HEAP8[$$17>>0] = 48; //@line 26428 "c/sqlite3.c"
        $$18 = $411;
        break;
       }
      }
     } while(0);
     if ($359) {
      $412 = (((15203 + (($$0523719$lcssa*6)|0)|0)) + 4|0); //@line 26436 "c/sqlite3.c"
      $413 = HEAP8[$412>>0]|0; //@line 26436 "c/sqlite3.c"
      $414 = $413&255; //@line 26436 "c/sqlite3.c"
      $415 = (15350 + ($414)|0); //@line 26436 "c/sqlite3.c"
      $416 = HEAP8[$415>>0]|0; //@line 26436 "c/sqlite3.c"
      $417 = ((($$18)) + 1|0); //@line 26436 "c/sqlite3.c"
      HEAP8[$$18>>0] = $416; //@line 26436 "c/sqlite3.c"
      $418 = ($$6616|0)<(0); //@line 26437 "c/sqlite3.c"
      $419 = ((($$18)) + 2|0);
      if ($418) {
       HEAP8[$417>>0] = 45; //@line 26438 "c/sqlite3.c"
       $420 = (0 - ($$6616))|0; //@line 26438 "c/sqlite3.c"
       $$7617 = $420;
      } else {
       HEAP8[$417>>0] = 43; //@line 26440 "c/sqlite3.c"
       $$7617 = $$6616;
      }
      $421 = ($$7617|0)>(99); //@line 26442 "c/sqlite3.c"
      if ($421) {
       $422 = (($$7617>>>0) / 100)&-1;
       $423 = (($422) + 48)|0; //@line 26443 "c/sqlite3.c"
       $424 = $423&255; //@line 26443 "c/sqlite3.c"
       $425 = ((($$18)) + 3|0); //@line 26443 "c/sqlite3.c"
       HEAP8[$419>>0] = $424; //@line 26443 "c/sqlite3.c"
       $426 = ($422*100)|0;
       $427 = (($$7617) - ($426))|0;
       $$19 = $425;$$8618 = $427;
      } else {
       $$19 = $419;$$8618 = $$7617;
      }
      $428 = (($$8618|0) / 10)&-1; //@line 26446 "c/sqlite3.c"
      $429 = (($428) + 48)|0; //@line 26446 "c/sqlite3.c"
      $430 = $429&255; //@line 26446 "c/sqlite3.c"
      $431 = ((($$19)) + 1|0); //@line 26446 "c/sqlite3.c"
      HEAP8[$$19>>0] = $430; //@line 26446 "c/sqlite3.c"
      $432 = ($428*10)|0;
      $433 = (($$8618) - ($432))|0;
      $434 = (($433) + 48)|0; //@line 26447 "c/sqlite3.c"
      $435 = $434&255; //@line 26447 "c/sqlite3.c"
      $436 = ((($$19)) + 2|0); //@line 26447 "c/sqlite3.c"
      HEAP8[$431>>0] = $435; //@line 26447 "c/sqlite3.c"
      $$20 = $436;
     } else {
      $$20 = $$18;
     }
     HEAP8[$$20>>0] = 0; //@line 26449 "c/sqlite3.c"
     $437 = $$20; //@line 26454 "c/sqlite3.c"
     $438 = $$10; //@line 26454 "c/sqlite3.c"
     $439 = (($437) - ($438))|0; //@line 26454 "c/sqlite3.c"
     $440 = ($$1558644660<<24>>24)!=(0); //@line 26459 "c/sqlite3.c"
     $441 = ($$3538<<24>>24)==(0); //@line 26459 "c/sqlite3.c"
     $or$cond7$not = $440 & $441; //@line 26459 "c/sqlite3.c"
     $442 = ($$2529|0)>($439|0); //@line 26459 "c/sqlite3.c"
     $or$cond634 = $or$cond7$not & $442; //@line 26459 "c/sqlite3.c"
     if (!($or$cond634)) {
      $$25 = $$10;$$6608 = $$2604;$$7522 = $439;$$7534 = $$2529;
      break L81;
     }
     $443 = (($$2529) - ($439))|0; //@line 26461 "c/sqlite3.c"
     $444 = ($439|0)<(0); //@line 26462 "c/sqlite3.c"
     if (!($444)) {
      $$0565779 = $$2529;
      while(1) {
       $445 = (($$0565779) - ($443))|0; //@line 26463 "c/sqlite3.c"
       $446 = (($$10) + ($445)|0); //@line 26463 "c/sqlite3.c"
       $447 = HEAP8[$446>>0]|0; //@line 26463 "c/sqlite3.c"
       $448 = (($$10) + ($$0565779)|0); //@line 26463 "c/sqlite3.c"
       HEAP8[$448>>0] = $447; //@line 26463 "c/sqlite3.c"
       $449 = (($$0565779) + -1)|0; //@line 26462 "c/sqlite3.c"
       $450 = ($$0565779|0)>($443|0); //@line 26462 "c/sqlite3.c"
       if ($450) {
        $$0565779 = $449;
       } else {
        break;
       }
      }
     }
     $451 = ($443|0)==(0); //@line 26466 "c/sqlite3.c"
     if ($451) {
      $$25 = $$10;$$6608 = $$2604;$$7522 = $$2529;$$7534 = $$2529;
      break L81;
     }
     $580 = ($$2584<<24>>24)!=(0); //@line 26465 "c/sqlite3.c"
     $581 = $580&1; //@line 26465 "c/sqlite3.c"
     $scevgep = (($$10) + ($581)|0); //@line 26466 "c/sqlite3.c"
     _memset(($scevgep|0),48,($443|0))|0; //@line 26466 "c/sqlite3.c"
     $$25 = $$10;$$6608 = $$2604;$$7522 = $$2529;$$7534 = $$2529;
    } else {
     $$25 = 15404;$$6608 = 0;$$7522 = 3;$$7534 = $$2529;
    }
    break;
   }
   case 4:  {
    if ($$0581) {
     $452 = HEAP32[$17>>2]|0; //@line 26473 "c/sqlite3.c"
     $arglist_current29 = HEAP32[$2>>2]|0; //@line 26473 "c/sqlite3.c"
     $453 = $arglist_current29; //@line 26473 "c/sqlite3.c"
     $454 = ((0) + 4|0);
     $expanded119 = $454;
     $expanded118 = (($expanded119) - 1)|0;
     $455 = (($453) + ($expanded118))|0; //@line 26473 "c/sqlite3.c"
     $456 = ((0) + 4|0);
     $expanded123 = $456;
     $expanded122 = (($expanded123) - 1)|0;
     $expanded121 = $expanded122 ^ -1;
     $457 = $455 & $expanded121; //@line 26473 "c/sqlite3.c"
     $458 = $457; //@line 26473 "c/sqlite3.c"
     $459 = HEAP32[$458>>2]|0; //@line 26473 "c/sqlite3.c"
     $arglist_next30 = ((($458)) + 4|0); //@line 26473 "c/sqlite3.c"
     HEAP32[$2>>2] = $arglist_next30; //@line 26473 "c/sqlite3.c"
     HEAP32[$459>>2] = $452; //@line 26473 "c/sqlite3.c"
     $$25 = $$1498;$$6608 = 0;$$7522 = 0;$$7534 = 0;
    } else {
     $$25 = $$1498;$$6608 = 0;$$7522 = 0;$$7534 = 0;
    }
    break;
   }
   case 7:  {
    HEAP8[$5>>0] = 37; //@line 26478 "c/sqlite3.c"
    $$25 = $5;$$6608 = 0;$$7522 = 1;$$7534 = $$2529;
    break;
   }
   case 8:  {
    if ($$0581) {
     $arglist_current32 = HEAP32[$2>>2]|0; //@line 26487 "c/sqlite3.c"
     $464 = $arglist_current32; //@line 26487 "c/sqlite3.c"
     $465 = ((0) + 4|0);
     $expanded126 = $465;
     $expanded125 = (($expanded126) - 1)|0;
     $466 = (($464) + ($expanded125))|0; //@line 26487 "c/sqlite3.c"
     $467 = ((0) + 4|0);
     $expanded130 = $467;
     $expanded129 = (($expanded130) - 1)|0;
     $expanded128 = $expanded129 ^ -1;
     $468 = $466 & $expanded128; //@line 26487 "c/sqlite3.c"
     $469 = $468; //@line 26487 "c/sqlite3.c"
     $470 = HEAP32[$469>>2]|0; //@line 26487 "c/sqlite3.c"
     $arglist_next33 = ((($469)) + 4|0); //@line 26487 "c/sqlite3.c"
     HEAP32[$2>>2] = $arglist_next33; //@line 26487 "c/sqlite3.c"
     $$7496 = $470;
    } else {
     $460 = (_getTextArg($$0628)|0); //@line 26484 "c/sqlite3.c"
     $461 = ($460|0)==(0|0); //@line 26485 "c/sqlite3.c"
     if ($461) {
      $$7496 = 0;
     } else {
      $462 = HEAP8[$460>>0]|0; //@line 26485 "c/sqlite3.c"
      $463 = $462 << 24 >> 24; //@line 26485 "c/sqlite3.c"
      $$7496 = $463;
     }
    }
    $471 = ($$1508|0)>(1); //@line 26489 "c/sqlite3.c"
    if ($471) {
     $472 = (($$1508) + -1)|0; //@line 26490 "c/sqlite3.c"
     $473 = (($$2529) - ($472))|0; //@line 26490 "c/sqlite3.c"
     $474 = ($473|0)<(2); //@line 26491 "c/sqlite3.c"
     $475 = ($$3538<<24>>24)!=(0); //@line 26491 "c/sqlite3.c"
     $or$cond9 = $475 | $474; //@line 26491 "c/sqlite3.c"
     if ($or$cond9) {
      $$3530 = $473;
     } else {
      $476 = (($473) + -1)|0; //@line 26492 "c/sqlite3.c"
      _sqlite3AppendChar($0,$476,32); //@line 26492 "c/sqlite3.c"
      $$3530 = 0;
     }
     $477 = $$7496&255; //@line 26495 "c/sqlite3.c"
     _sqlite3AppendChar($0,$472,$477); //@line 26495 "c/sqlite3.c"
     $$4531 = $$3530;
    } else {
     $$4531 = $$2529;
    }
    $478 = $$7496&255; //@line 26498 "c/sqlite3.c"
    HEAP8[$5>>0] = $478; //@line 26498 "c/sqlite3.c"
    $$25 = $5;$$6608 = 0;$$7522 = 1;$$7534 = $$4531;
    break;
   }
   case 6: case 5:  {
    if ($$0581) {
     $arglist_current35 = HEAP32[$2>>2]|0; //@line 26507 "c/sqlite3.c"
     $480 = $arglist_current35; //@line 26507 "c/sqlite3.c"
     $481 = ((0) + 4|0);
     $expanded133 = $481;
     $expanded132 = (($expanded133) - 1)|0;
     $482 = (($480) + ($expanded132))|0; //@line 26507 "c/sqlite3.c"
     $483 = ((0) + 4|0);
     $expanded137 = $483;
     $expanded136 = (($expanded137) - 1)|0;
     $expanded135 = $expanded136 ^ -1;
     $484 = $482 & $expanded135; //@line 26507 "c/sqlite3.c"
     $485 = $484; //@line 26507 "c/sqlite3.c"
     $486 = HEAP32[$485>>2]|0; //@line 26507 "c/sqlite3.c"
     $arglist_next36 = ((($485)) + 4|0); //@line 26507 "c/sqlite3.c"
     HEAP32[$2>>2] = $arglist_next36; //@line 26507 "c/sqlite3.c"
     $487 = ($$0523719$lcssa|0)==(3); //@line 26511 "c/sqlite3.c"
     $spec$select682 = $487 ? $486 : 0; //@line 26511 "c/sqlite3.c"
     $$in = $486;$489 = $spec$select682;
    } else {
     $479 = (_getTextArg($$0628)|0); //@line 26504 "c/sqlite3.c"
     $$in = $479;$489 = 0;
    }
    $488 = ($$in|0)==(0|0); //@line 26509 "c/sqlite3.c"
    $$3605 = $488 ? 0 : $489; //@line 26509 "c/sqlite3.c"
    $$22 = $488 ? 41388 : $$in; //@line 26509 "c/sqlite3.c"
    $490 = ($$1508|0)>(-1); //@line 26514 "c/sqlite3.c"
    if (!($490)) {
     $497 = (_strlen($$22)|0); //@line 26517 "c/sqlite3.c"
     $498 = $497 & 2147483647; //@line 26517 "c/sqlite3.c"
     $$25 = $$22;$$6608 = $$3605;$$7522 = $498;$$7534 = $$2529;
     break L81;
    }
    $491 = ($$1508|0)==(0); //@line 26515 "c/sqlite3.c"
    if ($491) {
     $$25 = $$22;$$6608 = $$3605;$$7522 = 0;$$7534 = $$2529;
    } else {
     $$3518736 = 0;
     while(1) {
      $492 = (($$22) + ($$3518736)|0); //@line 26515 "c/sqlite3.c"
      $493 = HEAP8[$492>>0]|0; //@line 26515 "c/sqlite3.c"
      $494 = ($493<<24>>24)==(0); //@line 26515 "c/sqlite3.c"
      if ($494) {
       $$25 = $$22;$$6608 = $$3605;$$7522 = $$3518736;$$7534 = $$2529;
       break L81;
      }
      $495 = (($$3518736) + 1)|0; //@line 26515 "c/sqlite3.c"
      $496 = ($495|0)<($$1508|0); //@line 26515 "c/sqlite3.c"
      if ($496) {
       $$3518736 = $495;
      } else {
       $$25 = $$22;$$6608 = $$3605;$$7522 = $495;$$7534 = $$2529;
       break;
      }
     }
    }
    break;
   }
   case 14: case 10: case 9:  {
    $499 = ($$0523719$lcssa|0)==(6); //@line 26526 "c/sqlite3.c"
    $500 = $499 ? 34 : 39; //@line 26526 "c/sqlite3.c"
    if ($$0581) {
     $arglist_current38 = HEAP32[$2>>2]|0; //@line 26532 "c/sqlite3.c"
     $502 = $arglist_current38; //@line 26532 "c/sqlite3.c"
     $503 = ((0) + 4|0);
     $expanded140 = $503;
     $expanded139 = (($expanded140) - 1)|0;
     $504 = (($502) + ($expanded139))|0; //@line 26532 "c/sqlite3.c"
     $505 = ((0) + 4|0);
     $expanded144 = $505;
     $expanded143 = (($expanded144) - 1)|0;
     $expanded142 = $expanded143 ^ -1;
     $506 = $504 & $expanded142; //@line 26532 "c/sqlite3.c"
     $507 = $506; //@line 26532 "c/sqlite3.c"
     $508 = HEAP32[$507>>2]|0; //@line 26532 "c/sqlite3.c"
     $arglist_next39 = ((($507)) + 4|0); //@line 26532 "c/sqlite3.c"
     HEAP32[$2>>2] = $arglist_next39; //@line 26532 "c/sqlite3.c"
     $$0539 = $508;
    } else {
     $501 = (_getTextArg($$0628)|0); //@line 26530 "c/sqlite3.c"
     $$0539 = $501;
    }
    $509 = ($$0539|0)==(0|0); //@line 26534 "c/sqlite3.c"
    $510 = ($$0523719$lcssa|0)==(5); //@line 26535 "c/sqlite3.c"
    $511 = $510 ? 15390 : 15395; //@line 26535 "c/sqlite3.c"
    $$1540 = $509 ? $511 : $$0539; //@line 26535 "c/sqlite3.c"
    $512 = ($$1508|0)==(0); //@line 26537 "c/sqlite3.c"
    L210: do {
     if ($512) {
      $$0548$lcssa = 0;$$0555$lcssa = 0;
     } else {
      $513 = $500&255;
      $$0548722 = 0;$$0550721 = $$1508;$$0555720 = 0;
      while(1) {
       $514 = (($$1540) + ($$0555720)|0); //@line 26537 "c/sqlite3.c"
       $515 = HEAP8[$514>>0]|0; //@line 26537 "c/sqlite3.c"
       $516 = ($515<<24>>24)==(0); //@line 26537 "c/sqlite3.c"
       if ($516) {
        $$0548$lcssa = $$0548722;$$0555$lcssa = $$0555720;
        break L210;
       }
       $517 = $515 << 24 >> 24; //@line 26537 "c/sqlite3.c"
       $518 = ($517|0)==($513|0); //@line 26538 "c/sqlite3.c"
       $519 = $518&1; //@line 26538 "c/sqlite3.c"
       $spec$select636 = (($$0548722) + ($519))|0; //@line 26538 "c/sqlite3.c"
       $520 = (($$0555720) + 1)|0; //@line 26537 "c/sqlite3.c"
       $521 = (($$0550721) + -1)|0; //@line 26537 "c/sqlite3.c"
       $522 = ($521|0)==(0); //@line 26537 "c/sqlite3.c"
       if ($522) {
        $$0548$lcssa = $spec$select636;$$0555$lcssa = $520;
        break;
       } else {
        $$0548722 = $spec$select636;$$0550721 = $521;$$0555720 = $520;
       }
      }
     }
    } while(0);
    $not$ = $509 ^ 1; //@line 26540 "c/sqlite3.c"
    $523 = $510 & $not$; //@line 26540 "c/sqlite3.c"
    $524 = (($$0555$lcssa) + 3)|0; //@line 26541 "c/sqlite3.c"
    $525 = (($524) + ($$0548$lcssa))|0; //@line 26541 "c/sqlite3.c"
    $526 = ($525>>>0)>(70); //@line 26542 "c/sqlite3.c"
    if ($526) {
     $527 = (_sqlite3Malloc($525,0)|0); //@line 26543 "c/sqlite3.c"
     $528 = ($527|0)==(0|0); //@line 26544 "c/sqlite3.c"
     if ($528) {
      label = 210;
      break L4;
     } else {
      $$23 = $527;$$4606 = $527;
     }
    } else {
     $$23 = $5;$$4606 = 0;
    }
    if ($523) {
     HEAP8[$$23>>0] = $500; //@line 26552 "c/sqlite3.c"
     $$0551 = 1;
    } else {
     $$0551 = 0;
    }
    $529 = ($$0555$lcssa|0)==(0); //@line 26554 "c/sqlite3.c"
    if ($529) {
     $$1552$lcssa = $$0551;
    } else {
     $530 = $500&255;
     $$1552731 = $$0551;$$1556730 = 0;
     while(1) {
      $531 = (($$1540) + ($$1556730)|0); //@line 26555 "c/sqlite3.c"
      $532 = HEAP8[$531>>0]|0; //@line 26555 "c/sqlite3.c"
      $533 = (($$1552731) + 1)|0; //@line 26555 "c/sqlite3.c"
      $534 = (($$23) + ($$1552731)|0); //@line 26555 "c/sqlite3.c"
      HEAP8[$534>>0] = $532; //@line 26555 "c/sqlite3.c"
      $535 = $532 << 24 >> 24; //@line 26556 "c/sqlite3.c"
      $536 = ($535|0)==($530|0); //@line 26556 "c/sqlite3.c"
      if ($536) {
       $537 = (($$23) + ($533)|0); //@line 26556 "c/sqlite3.c"
       $538 = (($$1552731) + 2)|0; //@line 26556 "c/sqlite3.c"
       HEAP8[$537>>0] = $532; //@line 26556 "c/sqlite3.c"
       $$2553 = $538;
      } else {
       $$2553 = $533;
      }
      $539 = (($$1556730) + 1)|0; //@line 26554 "c/sqlite3.c"
      $exitcond = ($539|0)==($$0555$lcssa|0); //@line 26554 "c/sqlite3.c"
      if ($exitcond) {
       $$1552$lcssa = $$2553;
       break;
      } else {
       $$1552731 = $$2553;$$1556730 = $539;
      }
     }
    }
    if ($523) {
     $540 = (($$23) + ($$1552$lcssa)|0); //@line 26558 "c/sqlite3.c"
     $541 = (($$1552$lcssa) + 1)|0; //@line 26558 "c/sqlite3.c"
     HEAP8[$540>>0] = $500; //@line 26558 "c/sqlite3.c"
     $$3554 = $541;
    } else {
     $$3554 = $$1552$lcssa;
    }
    $542 = (($$23) + ($$3554)|0); //@line 26559 "c/sqlite3.c"
    HEAP8[$542>>0] = 0; //@line 26559 "c/sqlite3.c"
    $$25 = $$23;$$6608 = $$4606;$$7522 = $$3554;$$7534 = $$2529;
    break;
   }
   case 11:  {
    $543 = HEAP8[$6>>0]|0; //@line 26568 "c/sqlite3.c"
    $544 = $543 & 1; //@line 26568 "c/sqlite3.c"
    $545 = ($544<<24>>24)==(0); //@line 26568 "c/sqlite3.c"
    if ($545) {
     label = 228;
     break L4;
    }
    $arglist_current41 = HEAP32[$2>>2]|0; //@line 26569 "c/sqlite3.c"
    $546 = $arglist_current41; //@line 26569 "c/sqlite3.c"
    $547 = ((0) + 4|0);
    $expanded147 = $547;
    $expanded146 = (($expanded147) - 1)|0;
    $548 = (($546) + ($expanded146))|0; //@line 26569 "c/sqlite3.c"
    $549 = ((0) + 4|0);
    $expanded151 = $549;
    $expanded150 = (($expanded151) - 1)|0;
    $expanded149 = $expanded150 ^ -1;
    $550 = $548 & $expanded149; //@line 26569 "c/sqlite3.c"
    $551 = $550; //@line 26569 "c/sqlite3.c"
    $552 = HEAP32[$551>>2]|0; //@line 26569 "c/sqlite3.c"
    $arglist_next42 = ((($551)) + 4|0); //@line 26569 "c/sqlite3.c"
    HEAP32[$2>>2] = $arglist_next42; //@line 26569 "c/sqlite3.c"
    $553 = ($552|0)==(0|0); //@line 26571 "c/sqlite3.c"
    if ($553) {
     $$25 = $$1498;$$6608 = 0;$$7522 = 0;$$7534 = 0;
    } else {
     $554 = ((($552)) + 4|0); //@line 26571 "c/sqlite3.c"
     $555 = HEAP32[$554>>2]|0; //@line 26571 "c/sqlite3.c"
     $556 = ($555|0)==(0); //@line 26571 "c/sqlite3.c"
     if ($556) {
      $$25 = $$1498;$$6608 = 0;$$7522 = 0;$$7534 = 0;
     } else {
      $557 = HEAP32[$552>>2]|0; //@line 26572 "c/sqlite3.c"
      _sqlite3StrAccumAppend($0,$557,$555); //@line 26572 "c/sqlite3.c"
      $$25 = $$1498;$$6608 = 0;$$7522 = 0;$$7534 = 0;
     }
    }
    break;
   }
   case 12:  {
    $558 = HEAP8[$6>>0]|0; //@line 26581 "c/sqlite3.c"
    $559 = $558 & 1; //@line 26581 "c/sqlite3.c"
    $560 = ($559<<24>>24)==(0); //@line 26581 "c/sqlite3.c"
    if ($560) {
     label = 228;
     break L4;
    }
    $arglist_current44 = HEAP32[$2>>2]|0; //@line 26582 "c/sqlite3.c"
    $561 = $arglist_current44; //@line 26582 "c/sqlite3.c"
    $562 = ((0) + 4|0);
    $expanded154 = $562;
    $expanded153 = (($expanded154) - 1)|0;
    $563 = (($561) + ($expanded153))|0; //@line 26582 "c/sqlite3.c"
    $564 = ((0) + 4|0);
    $expanded158 = $564;
    $expanded157 = (($expanded158) - 1)|0;
    $expanded156 = $expanded157 ^ -1;
    $565 = $563 & $expanded156; //@line 26582 "c/sqlite3.c"
    $566 = $565; //@line 26582 "c/sqlite3.c"
    $567 = HEAP32[$566>>2]|0; //@line 26582 "c/sqlite3.c"
    $arglist_next45 = ((($566)) + 4|0); //@line 26582 "c/sqlite3.c"
    HEAP32[$2>>2] = $arglist_next45; //@line 26582 "c/sqlite3.c"
    $arglist_current47 = HEAP32[$2>>2]|0; //@line 26583 "c/sqlite3.c"
    $568 = $arglist_current47; //@line 26583 "c/sqlite3.c"
    $569 = ((0) + 4|0);
    $expanded161 = $569;
    $expanded160 = (($expanded161) - 1)|0;
    $570 = (($568) + ($expanded160))|0; //@line 26583 "c/sqlite3.c"
    $571 = ((0) + 4|0);
    $expanded165 = $571;
    $expanded164 = (($expanded165) - 1)|0;
    $expanded163 = $expanded164 ^ -1;
    $572 = $570 & $expanded163; //@line 26583 "c/sqlite3.c"
    $573 = $572; //@line 26583 "c/sqlite3.c"
    $574 = HEAP32[$573>>2]|0; //@line 26583 "c/sqlite3.c"
    $arglist_next48 = ((($573)) + 4|0); //@line 26583 "c/sqlite3.c"
    HEAP32[$2>>2] = $arglist_next48; //@line 26583 "c/sqlite3.c"
    $575 = (((((($567)) + 8|0) + (($574*72)|0)|0)) + 4|0); //@line 26587 "c/sqlite3.c"
    $576 = HEAP32[$575>>2]|0; //@line 26587 "c/sqlite3.c"
    $577 = ($576|0)==(0|0); //@line 26587 "c/sqlite3.c"
    if (!($577)) {
     _sqlite3StrAccumAppendAll($0,$576); //@line 26588 "c/sqlite3.c"
     _sqlite3StrAccumAppend($0,15402,1); //@line 26589 "c/sqlite3.c"
    }
    $578 = (((((($567)) + 8|0) + (($574*72)|0)|0)) + 8|0); //@line 26591 "c/sqlite3.c"
    $579 = HEAP32[$578>>2]|0; //@line 26591 "c/sqlite3.c"
    _sqlite3StrAccumAppendAll($0,$579); //@line 26591 "c/sqlite3.c"
    $$25 = $$1498;$$6608 = 0;$$7522 = 0;$$7534 = 0;
    break;
   }
   default: {
    label = 228;
    break L4;
   }
   }
  } while(0);
  if ((label|0) == 67) {
   label = 0;
   $$2561 = $$1560;$$2572 = 0;
   label = 68;
  }
  if ((label|0) == 68) {
   label = 0;
   $101 = 4067322 >>> $$0523719$lcssa; //@line 26215 "c/sqlite3.c"
   $102 = $101 & 1; //@line 26215 "c/sqlite3.c"
   $103 = ($102|0)==(0); //@line 26215 "c/sqlite3.c"
   L246: do {
    if ($103) {
     L248: do {
      if ($$0581) {
       switch ($$2561<<24>>24) {
       case 0:  {
        $arglist_current14 = HEAP32[$2>>2]|0; //@line 26226 "c/sqlite3.c"
        $127 = $arglist_current14; //@line 26226 "c/sqlite3.c"
        $128 = ((0) + 4|0);
        $expanded84 = $128;
        $expanded83 = (($expanded84) - 1)|0;
        $129 = (($127) + ($expanded83))|0; //@line 26226 "c/sqlite3.c"
        $130 = ((0) + 4|0);
        $expanded88 = $130;
        $expanded87 = (($expanded88) - 1)|0;
        $expanded86 = $expanded87 ^ -1;
        $131 = $129 & $expanded86; //@line 26226 "c/sqlite3.c"
        $132 = $131; //@line 26226 "c/sqlite3.c"
        $133 = HEAP32[$132>>2]|0; //@line 26226 "c/sqlite3.c"
        $arglist_next15 = ((($132)) + 4|0); //@line 26226 "c/sqlite3.c"
        HEAP32[$2>>2] = $arglist_next15; //@line 26226 "c/sqlite3.c"
        $134 = ($133|0)<(0); //@line 26226 "c/sqlite3.c"
        $135 = $134 << 31 >> 31; //@line 26226 "c/sqlite3.c"
        $137 = $135;$139 = $133;
        break L248;
        break;
       }
       case 2:  {
        $arglist_current8 = HEAP32[$2>>2]|0; //@line 26221 "c/sqlite3.c"
        $106 = $arglist_current8; //@line 26221 "c/sqlite3.c"
        $107 = ((0) + 8|0);
        $expanded70 = $107;
        $expanded69 = (($expanded70) - 1)|0;
        $108 = (($106) + ($expanded69))|0; //@line 26221 "c/sqlite3.c"
        $109 = ((0) + 8|0);
        $expanded74 = $109;
        $expanded73 = (($expanded74) - 1)|0;
        $expanded72 = $expanded73 ^ -1;
        $110 = $108 & $expanded72; //@line 26221 "c/sqlite3.c"
        $111 = $110; //@line 26221 "c/sqlite3.c"
        $112 = $111; //@line 26221 "c/sqlite3.c"
        $113 = $112; //@line 26221 "c/sqlite3.c"
        $114 = HEAP32[$113>>2]|0; //@line 26221 "c/sqlite3.c"
        $115 = (($112) + 4)|0; //@line 26221 "c/sqlite3.c"
        $116 = $115; //@line 26221 "c/sqlite3.c"
        $117 = HEAP32[$116>>2]|0; //@line 26221 "c/sqlite3.c"
        $arglist_next9 = ((($111)) + 8|0); //@line 26221 "c/sqlite3.c"
        HEAP32[$2>>2] = $arglist_next9; //@line 26221 "c/sqlite3.c"
        $137 = $117;$139 = $114;
        break L248;
        break;
       }
       default: {
        $arglist_current11 = HEAP32[$2>>2]|0; //@line 26223 "c/sqlite3.c"
        $118 = $arglist_current11; //@line 26223 "c/sqlite3.c"
        $119 = ((0) + 4|0);
        $expanded77 = $119;
        $expanded76 = (($expanded77) - 1)|0;
        $120 = (($118) + ($expanded76))|0; //@line 26223 "c/sqlite3.c"
        $121 = ((0) + 4|0);
        $expanded81 = $121;
        $expanded80 = (($expanded81) - 1)|0;
        $expanded79 = $expanded80 ^ -1;
        $122 = $120 & $expanded79; //@line 26223 "c/sqlite3.c"
        $123 = $122; //@line 26223 "c/sqlite3.c"
        $124 = HEAP32[$123>>2]|0; //@line 26223 "c/sqlite3.c"
        $arglist_next12 = ((($123)) + 4|0); //@line 26223 "c/sqlite3.c"
        HEAP32[$2>>2] = $arglist_next12; //@line 26223 "c/sqlite3.c"
        $125 = ($124|0)<(0); //@line 26223 "c/sqlite3.c"
        $126 = $125 << 31 >> 31; //@line 26223 "c/sqlite3.c"
        $137 = $126;$139 = $124;
        break L248;
       }
       }
      } else {
       $104 = (_getIntArg($$0628)|0); //@line 26218 "c/sqlite3.c"
       $105 = tempRet0; //@line 26218 "c/sqlite3.c"
       $137 = $105;$139 = $104;
      }
     } while(0);
     $136 = ($137|0)<(0); //@line 26228 "c/sqlite3.c"
     $138 = ($139|0)==(0); //@line 26229 "c/sqlite3.c"
     $140 = ($137|0)==(-2147483648); //@line 26229 "c/sqlite3.c"
     $141 = $138 & $140; //@line 26229 "c/sqlite3.c"
     $142 = (_i64Subtract(0,0,($139|0),($137|0))|0); //@line 26232 "c/sqlite3.c"
     $143 = tempRet0; //@line 26232 "c/sqlite3.c"
     $144 = $141 ? 0 : $142; //@line 26229 "c/sqlite3.c"
     $145 = $141 ? -2147483648 : $143; //@line 26229 "c/sqlite3.c"
     $146 = $136 ? $144 : $139; //@line 26228 "c/sqlite3.c"
     $147 = $136 ? $145 : $137; //@line 26228 "c/sqlite3.c"
     $spec$select677 = $136 ? 45 : $$1542650654; //@line 26228 "c/sqlite3.c"
     $$1583 = $spec$select677;$177 = $146;$179 = $147;
    } else {
     if (!($$0581)) {
      $148 = (_getIntArg($$0628)|0); //@line 26241 "c/sqlite3.c"
      $149 = tempRet0; //@line 26241 "c/sqlite3.c"
      $$1583 = 0;$177 = $148;$179 = $149;
      break;
     }
     switch ($$2561<<24>>24) {
     case 0:  {
      $arglist_current23 = HEAP32[$2>>2]|0; //@line 26249 "c/sqlite3.c"
      $169 = $arglist_current23; //@line 26249 "c/sqlite3.c"
      $170 = ((0) + 4|0);
      $expanded105 = $170;
      $expanded104 = (($expanded105) - 1)|0;
      $171 = (($169) + ($expanded104))|0; //@line 26249 "c/sqlite3.c"
      $172 = ((0) + 4|0);
      $expanded109 = $172;
      $expanded108 = (($expanded109) - 1)|0;
      $expanded107 = $expanded108 ^ -1;
      $173 = $171 & $expanded107; //@line 26249 "c/sqlite3.c"
      $174 = $173; //@line 26249 "c/sqlite3.c"
      $175 = HEAP32[$174>>2]|0; //@line 26249 "c/sqlite3.c"
      $arglist_next24 = ((($174)) + 4|0); //@line 26249 "c/sqlite3.c"
      HEAP32[$2>>2] = $arglist_next24; //@line 26249 "c/sqlite3.c"
      $$1583 = 0;$177 = $175;$179 = 0;
      break L246;
      break;
     }
     case 2:  {
      $arglist_current17 = HEAP32[$2>>2]|0; //@line 26244 "c/sqlite3.c"
      $150 = $arglist_current17; //@line 26244 "c/sqlite3.c"
      $151 = ((0) + 8|0);
      $expanded91 = $151;
      $expanded90 = (($expanded91) - 1)|0;
      $152 = (($150) + ($expanded90))|0; //@line 26244 "c/sqlite3.c"
      $153 = ((0) + 8|0);
      $expanded95 = $153;
      $expanded94 = (($expanded95) - 1)|0;
      $expanded93 = $expanded94 ^ -1;
      $154 = $152 & $expanded93; //@line 26244 "c/sqlite3.c"
      $155 = $154; //@line 26244 "c/sqlite3.c"
      $156 = $155; //@line 26244 "c/sqlite3.c"
      $157 = $156; //@line 26244 "c/sqlite3.c"
      $158 = HEAP32[$157>>2]|0; //@line 26244 "c/sqlite3.c"
      $159 = (($156) + 4)|0; //@line 26244 "c/sqlite3.c"
      $160 = $159; //@line 26244 "c/sqlite3.c"
      $161 = HEAP32[$160>>2]|0; //@line 26244 "c/sqlite3.c"
      $arglist_next18 = ((($155)) + 8|0); //@line 26244 "c/sqlite3.c"
      HEAP32[$2>>2] = $arglist_next18; //@line 26244 "c/sqlite3.c"
      $$1583 = 0;$177 = $158;$179 = $161;
      break L246;
      break;
     }
     default: {
      $arglist_current20 = HEAP32[$2>>2]|0; //@line 26246 "c/sqlite3.c"
      $162 = $arglist_current20; //@line 26246 "c/sqlite3.c"
      $163 = ((0) + 4|0);
      $expanded98 = $163;
      $expanded97 = (($expanded98) - 1)|0;
      $164 = (($162) + ($expanded97))|0; //@line 26246 "c/sqlite3.c"
      $165 = ((0) + 4|0);
      $expanded102 = $165;
      $expanded101 = (($expanded102) - 1)|0;
      $expanded100 = $expanded101 ^ -1;
      $166 = $164 & $expanded100; //@line 26246 "c/sqlite3.c"
      $167 = $166; //@line 26246 "c/sqlite3.c"
      $168 = HEAP32[$167>>2]|0; //@line 26246 "c/sqlite3.c"
      $arglist_next21 = ((($167)) + 4|0); //@line 26246 "c/sqlite3.c"
      HEAP32[$2>>2] = $arglist_next21; //@line 26246 "c/sqlite3.c"
      $$1583 = 0;$177 = $168;$179 = 0;
      break L246;
     }
     }
    }
   } while(0);
   $176 = ($177|0)==(0); //@line 26253 "c/sqlite3.c"
   $178 = ($179|0)==(0); //@line 26253 "c/sqlite3.c"
   $180 = $176 & $178; //@line 26253 "c/sqlite3.c"
   $181 = ($$1558644660<<24>>24)==(0); //@line 26254 "c/sqlite3.c"
   $182 = ($$1583<<24>>24)!=(0); //@line 26254 "c/sqlite3.c"
   $183 = $182&1; //@line 26254 "c/sqlite3.c"
   $184 = (($$2529) - ($183))|0; //@line 26254 "c/sqlite3.c"
   $185 = ($$1508|0)<($184|0); //@line 26254 "c/sqlite3.c"
   $spec$select629 = $185 ? $184 : $$1508; //@line 26254 "c/sqlite3.c"
   $spec$select678 = $181 ? $$1508 : $spec$select629; //@line 26254 "c/sqlite3.c"
   $186 = ($spec$select678|0)<(37); //@line 26257 "c/sqlite3.c"
   if ($186) {
    $$0597 = $5;$$1603 = 0;$$2600 = 70;
   } else {
    $187 = ($spec$select678|0)<(0); //@line 26261 "c/sqlite3.c"
    $188 = $187 << 31 >> 31; //@line 26261 "c/sqlite3.c"
    $189 = (_i64Add(($spec$select678|0),($188|0),10,0)|0); //@line 26261 "c/sqlite3.c"
    $190 = tempRet0; //@line 26261 "c/sqlite3.c"
    $191 = (($spec$select678>>>0) / 3)&-1;
    $192 = (_i64Add(($189|0),($190|0),($191|0),0)|0); //@line 26261 "c/sqlite3.c"
    $193 = tempRet0; //@line 26261 "c/sqlite3.c"
    $194 = (_sqlite3Malloc($192,$193)|0); //@line 26262 "c/sqlite3.c"
    $195 = ($194|0)==(0|0); //@line 26263 "c/sqlite3.c"
    if ($195) {
     label = 85;
     break;
    }
    $$0597 = $194;$$1603 = $194;$$2600 = $192;
   }
   $196 = (($$2600) + -1)|0; //@line 26269 "c/sqlite3.c"
   $197 = (($$0597) + ($196)|0); //@line 26269 "c/sqlite3.c"
   $198 = ($$0523719$lcssa|0)==(22); //@line 26270 "c/sqlite3.c"
   if ($198) {
    $199 = (___udivdi3(($177|0),($179|0),10,0)|0); //@line 26273 "c/sqlite3.c"
    $200 = tempRet0; //@line 26273 "c/sqlite3.c"
    $201 = (___muldi3(($199|0),($200|0),10,0)|0);
    $202 = tempRet0;
    $203 = (_i64Subtract(($177|0),($179|0),($201|0),($202|0))|0);
    $204 = tempRet0;
    $205 = ($203|0)>(3); //@line 26273 "c/sqlite3.c"
    $206 = (___uremdi3(($199|0),($200|0),10,0)|0); //@line 26273 "c/sqlite3.c"
    $207 = tempRet0; //@line 26273 "c/sqlite3.c"
    $208 = ($206|0)==(1); //@line 26273 "c/sqlite3.c"
    $209 = ($207|0)==(0); //@line 26273 "c/sqlite3.c"
    $210 = $208 & $209; //@line 26273 "c/sqlite3.c"
    $or$cond1030 = $205 | $210; //@line 26273 "c/sqlite3.c"
    $$0585 = $or$cond1030 ? 0 : $203; //@line 26273 "c/sqlite3.c"
    $211 = $$0585 << 1; //@line 26276 "c/sqlite3.c"
    $212 = $211 | 1; //@line 26276 "c/sqlite3.c"
    $213 = (15341 + ($212)|0); //@line 26276 "c/sqlite3.c"
    $214 = HEAP8[$213>>0]|0; //@line 26276 "c/sqlite3.c"
    $215 = ((($197)) + -1|0); //@line 26276 "c/sqlite3.c"
    HEAP8[$215>>0] = $214; //@line 26276 "c/sqlite3.c"
    $216 = (15341 + ($211)|0); //@line 26277 "c/sqlite3.c"
    $217 = HEAP8[$216>>0]|0; //@line 26277 "c/sqlite3.c"
    $218 = ((($215)) + -1|0); //@line 26277 "c/sqlite3.c"
    HEAP8[$218>>0] = $217; //@line 26277 "c/sqlite3.c"
    $$2499 = $218;
   } else {
    $$2499 = $197;
   }
   $219 = (((15203 + (($$0523719$lcssa*6)|0)|0)) + 4|0); //@line 26280 "c/sqlite3.c"
   $220 = HEAP8[$219>>0]|0; //@line 26280 "c/sqlite3.c"
   $221 = $220&255; //@line 26280 "c/sqlite3.c"
   $222 = (15350 + ($221)|0); //@line 26280 "c/sqlite3.c"
   $223 = (((15203 + (($$0523719$lcssa*6)|0)|0)) + 1|0); //@line 26281 "c/sqlite3.c"
   $224 = HEAP8[$223>>0]|0; //@line 26281 "c/sqlite3.c"
   $225 = $224&255;
   $$3500 = $$2499;$226 = $177;$227 = $179;
   while(1) {
    $228 = (___udivdi3(($226|0),($227|0),($225|0),0)|0); //@line 26284 "c/sqlite3.c"
    $229 = tempRet0; //@line 26284 "c/sqlite3.c"
    $230 = (___muldi3(($228|0),($229|0),($225|0),0)|0);
    $231 = tempRet0;
    $232 = (_i64Subtract(($226|0),($227|0),($230|0),($231|0))|0);
    $233 = tempRet0;
    $234 = (($222) + ($232)|0); //@line 26283 "c/sqlite3.c"
    $235 = HEAP8[$234>>0]|0; //@line 26283 "c/sqlite3.c"
    $236 = ((($$3500)) + -1|0); //@line 26283 "c/sqlite3.c"
    HEAP8[$236>>0] = $235; //@line 26283 "c/sqlite3.c"
    $237 = ($227>>>0)<(0); //@line 26285 "c/sqlite3.c"
    $238 = ($226>>>0)<($225>>>0); //@line 26285 "c/sqlite3.c"
    $239 = ($227|0)==(0); //@line 26285 "c/sqlite3.c"
    $240 = $239 & $238; //@line 26285 "c/sqlite3.c"
    $241 = $237 | $240; //@line 26285 "c/sqlite3.c"
    if ($241) {
     break;
    } else {
     $$3500 = $236;$226 = $228;$227 = $229;
    }
   }
   $242 = $197; //@line 26287 "c/sqlite3.c"
   $243 = $236; //@line 26287 "c/sqlite3.c"
   $244 = (($242) - ($243))|0; //@line 26287 "c/sqlite3.c"
   $245 = ($spec$select678|0)>($244|0); //@line 26288 "c/sqlite3.c"
   if ($245) {
    $246 = (($242) - ($spec$select678))|0; //@line 26288 "c/sqlite3.c"
    $247 = (($246) - ($243))|0; //@line 26288 "c/sqlite3.c"
    $scevgep845 = (($236) + ($247)|0); //@line 26288 "c/sqlite3.c"
    $248 = (($spec$select678) + ($243))|0; //@line 26288 "c/sqlite3.c"
    $249 = (($248) - ($242))|0; //@line 26288 "c/sqlite3.c"
    _memset(($scevgep845|0),48,($249|0))|0; //@line 26289 "c/sqlite3.c"
    $scevgep843 = (($236) + ($247)|0); //@line 26288 "c/sqlite3.c"
    $$1516$lcssa = $spec$select678;$$4501$lcssa = $scevgep843;
   } else {
    $$1516$lcssa = $244;$$4501$lcssa = $236;
   }
   $250 = ($$2572<<24>>24)==(0); //@line 26292 "c/sqlite3.c"
   if ($250) {
    $$5502 = $$4501$lcssa;
   } else {
    $251 = (($$1516$lcssa) + -1)|0; //@line 26293 "c/sqlite3.c"
    $252 = (($251|0) / 3)&-1; //@line 26293 "c/sqlite3.c"
    $253 = (0 - ($252))|0; //@line 26295 "c/sqlite3.c"
    $254 = (($$4501$lcssa) + ($253)|0); //@line 26295 "c/sqlite3.c"
    $255 = ($$1516$lcssa|0)>(3); //@line 26296 "c/sqlite3.c"
    if ($255) {
     $256 = ($252*3)|0;
     $257 = (($251) - ($256))|0;
     $258 = (($257) + 1)|0; //@line 26294 "c/sqlite3.c"
     $$0577795 = $258;$$0579794 = $252;$$1524796 = 0;
     while(1) {
      $259 = (($$1524796) + ($$0579794))|0; //@line 26297 "c/sqlite3.c"
      $260 = (($254) + ($259)|0); //@line 26297 "c/sqlite3.c"
      $261 = HEAP8[$260>>0]|0; //@line 26297 "c/sqlite3.c"
      $262 = (($254) + ($$1524796)|0); //@line 26297 "c/sqlite3.c"
      HEAP8[$262>>0] = $261; //@line 26297 "c/sqlite3.c"
      $263 = (($$0577795) + -1)|0; //@line 26298 "c/sqlite3.c"
      $264 = ($263|0)==(0); //@line 26299 "c/sqlite3.c"
      $265 = (($$1524796) + 1)|0; //@line 26300 "c/sqlite3.c"
      if ($264) {
       $266 = (($$0579794) + -1)|0; //@line 26301 "c/sqlite3.c"
       $267 = (($254) + ($265)|0); //@line 26300 "c/sqlite3.c"
       HEAP8[$267>>0] = $$2572; //@line 26300 "c/sqlite3.c"
       $$1578 = 3;$$1580 = $266;$$2525 = $265;
      } else {
       $$1578 = $263;$$1580 = $$0579794;$$2525 = $$1524796;
      }
      $268 = (($$2525) + 1)|0; //@line 26296 "c/sqlite3.c"
      $269 = ($$1580|0)>(0); //@line 26296 "c/sqlite3.c"
      if ($269) {
       $$0577795 = $$1578;$$0579794 = $$1580;$$1524796 = $268;
      } else {
       $$5502 = $254;
       break;
      }
     }
    } else {
     $$5502 = $254;
    }
   }
   $270 = ($$1583<<24>>24)==(0); //@line 26306 "c/sqlite3.c"
   if ($270) {
    $$6503 = $$5502;
   } else {
    $271 = ((($$5502)) + -1|0); //@line 26306 "c/sqlite3.c"
    HEAP8[$271>>0] = $$1583; //@line 26306 "c/sqlite3.c"
    $$6503 = $271;
   }
   $272 = ($$1544647656<<24>>24)==(0); //@line 26307 "c/sqlite3.c"
   $273 = $272 | $180; //@line 26307 "c/sqlite3.c"
   if ($273) {
    $$8505 = $$6503;
   } else {
    $274 = 7860991 >>> $$0523719$lcssa; //@line 26307 "c/sqlite3.c"
    $275 = $274 & 1; //@line 26307 "c/sqlite3.c"
    $276 = ($275|0)==(0); //@line 26307 "c/sqlite3.c"
    if ($276) {
     $277 = (((15203 + (($$0523719$lcssa*6)|0)|0)) + 5|0); //@line 26307 "c/sqlite3.c"
     $278 = HEAP8[$277>>0]|0; //@line 26307 "c/sqlite3.c"
     $279 = $278&255; //@line 26307 "c/sqlite3.c"
     $280 = (15383 + ($279)|0); //@line 26310 "c/sqlite3.c"
     $281 = HEAP8[$280>>0]|0; //@line 26311 "c/sqlite3.c"
     $$0576799 = $280;$$7504800 = $$6503;$283 = $281;
     while(1) {
      $282 = ((($$7504800)) + -1|0); //@line 26311 "c/sqlite3.c"
      HEAP8[$282>>0] = $283; //@line 26311 "c/sqlite3.c"
      $284 = ((($$0576799)) + 1|0); //@line 26311 "c/sqlite3.c"
      $285 = HEAP8[$284>>0]|0; //@line 26311 "c/sqlite3.c"
      $286 = ($285<<24>>24)==(0); //@line 26311 "c/sqlite3.c"
      if ($286) {
       $$8505 = $282;
       break;
      } else {
       $$0576799 = $284;$$7504800 = $282;$283 = $285;
      }
     }
    } else {
     $$8505 = $$6503;
    }
   }
   $287 = $$8505; //@line 26313 "c/sqlite3.c"
   $288 = (($242) - ($287))|0; //@line 26313 "c/sqlite3.c"
   $$25 = $$8505;$$6608 = $$1603;$$7522 = $288;$$7534 = $$2529;
  }
  $582 = (($$7534) - ($$7522))|0; //@line 26605 "c/sqlite3.c"
  $583 = ($582|0)>(0); //@line 26606 "c/sqlite3.c"
  do {
   if ($583) {
    $584 = ($$3538<<24>>24)==(0); //@line 26607 "c/sqlite3.c"
    if ($584) {
     _sqlite3AppendChar($0,$582,32); //@line 26607 "c/sqlite3.c"
     _sqlite3StrAccumAppend($0,$$25,$$7522); //@line 26608 "c/sqlite3.c"
     break;
    } else {
     _sqlite3StrAccumAppend($0,$$25,$$7522); //@line 26608 "c/sqlite3.c"
     _sqlite3AppendChar($0,$582,32); //@line 26609 "c/sqlite3.c"
     break;
    }
   } else {
    _sqlite3StrAccumAppend($0,$$25,$$7522); //@line 26611 "c/sqlite3.c"
   }
  } while(0);
  $585 = ($$6608|0)==(0|0); //@line 26614 "c/sqlite3.c"
  if (!($585)) {
   $586 = HEAP32[$0>>2]|0; //@line 26615 "c/sqlite3.c"
   _sqlite3DbFree($586,$$6608); //@line 26615 "c/sqlite3.c"
  }
  $587 = ((($$9)) + 1|0); //@line 26074 "c/sqlite3.c"
  $$0 = $587;$$0497 = $$25;
 }
 if ((label|0) == 9) {
  _sqlite3StrAccumAppend($0,15201,1); //@line 26086 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 26619 "c/sqlite3.c"
 }
 else if ((label|0) == 85) {
  _setStrAccumError($0,1); //@line 26264 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 26619 "c/sqlite3.c"
 }
 else if ((label|0) == 136) {
  _setStrAccumError($0,1); //@line 26389 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 26619 "c/sqlite3.c"
 }
 else if ((label|0) == 210) {
  _setStrAccumError($0,1); //@line 26545 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 26619 "c/sqlite3.c"
 }
 else if ((label|0) == 228) {
  STACKTOP = sp;return; //@line 26619 "c/sqlite3.c"
 }
}
function _sqlite3StrAccumFinish($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 26748 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 26748 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 26748 "c/sqlite3.c"
 if (!($3)) {
  $4 = ((($0)) + 16|0); //@line 26749 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 26749 "c/sqlite3.c"
  $6 = (($2) + ($5)|0); //@line 26749 "c/sqlite3.c"
  HEAP8[$6>>0] = 0; //@line 26749 "c/sqlite3.c"
  $7 = ((($0)) + 12|0); //@line 26750 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 26750 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 26750 "c/sqlite3.c"
  if (!($9)) {
   $10 = ((($0)) + 21|0); //@line 26750 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 26750 "c/sqlite3.c"
   $12 = $11 & 4; //@line 26750 "c/sqlite3.c"
   $13 = ($12<<24>>24)==(0); //@line 26750 "c/sqlite3.c"
   if ($13) {
    $14 = (_strAccumFinishRealloc($0)|0); //@line 26751 "c/sqlite3.c"
    $$0 = $14;
    return ($$0|0); //@line 26755 "c/sqlite3.c"
   }
  }
 }
 $15 = HEAP32[$1>>2]|0; //@line 26754 "c/sqlite3.c"
 $$0 = $15;
 return ($$0|0); //@line 26755 "c/sqlite3.c"
}
function _strAccumFinishRealloc($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 26737 "c/sqlite3.c"
 $2 = ((($0)) + 16|0); //@line 26737 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 26737 "c/sqlite3.c"
 $4 = (($3) + 1)|0; //@line 26737 "c/sqlite3.c"
 $5 = (_sqlite3DbMallocRaw($1,$4,0)|0); //@line 26737 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 26738 "c/sqlite3.c"
 if ($6) {
  _setStrAccumError($0,1); //@line 26742 "c/sqlite3.c"
  $14 = ((($0)) + 4|0); //@line 26744 "c/sqlite3.c"
  HEAP32[$14>>2] = $5; //@line 26744 "c/sqlite3.c"
  return ($5|0); //@line 26745 "c/sqlite3.c"
 } else {
  $7 = ((($0)) + 4|0); //@line 26739 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 26739 "c/sqlite3.c"
  $9 = HEAP32[$2>>2]|0; //@line 26739 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 26739 "c/sqlite3.c"
  _memcpy(($5|0),($8|0),($10|0))|0; //@line 26739 "c/sqlite3.c"
  $11 = ((($0)) + 21|0); //@line 26740 "c/sqlite3.c"
  $12 = HEAP8[$11>>0]|0; //@line 26740 "c/sqlite3.c"
  $13 = $12 | 4; //@line 26740 "c/sqlite3.c"
  HEAP8[$11>>0] = $13; //@line 26740 "c/sqlite3.c"
  $14 = ((($0)) + 4|0); //@line 26744 "c/sqlite3.c"
  HEAP32[$14>>2] = $5; //@line 26744 "c/sqlite3.c"
  return ($5|0); //@line 26745 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3DbMallocRaw($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 25642 "c/sqlite3.c"
 if ($3) {
  $5 = (_sqlite3Malloc($1,$2)|0); //@line 25643 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 25646 "c/sqlite3.c"
 } else {
  $4 = (_sqlite3DbMallocRawNN($0,$1,$2)|0); //@line 25642 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 25646 "c/sqlite3.c"
 }
 return (0)|0;
}
function _setStrAccumError($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 25996 "c/sqlite3.c"
 HEAP8[$2>>0] = $1; //@line 25996 "c/sqlite3.c"
 $3 = ((($0)) + 8|0); //@line 25997 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 25997 "c/sqlite3.c"
 return; //@line 25998 "c/sqlite3.c"
}
function _sqlite3DbMallocRawNN($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 264|0); //@line 25653 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 25653 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 25653 "c/sqlite3.c"
 if ($5) {
  $6 = ((($0)) + 268|0); //@line 25655 "c/sqlite3.c"
  $7 = HEAP16[$6>>1]|0; //@line 25655 "c/sqlite3.c"
  $8 = $7&65535; //@line 25655 "c/sqlite3.c"
  $9 = (0)<($2>>>0); //@line 25655 "c/sqlite3.c"
  $10 = ($8>>>0)<($1>>>0); //@line 25655 "c/sqlite3.c"
  $11 = (0)==($2|0); //@line 25655 "c/sqlite3.c"
  $12 = $11 & $10; //@line 25655 "c/sqlite3.c"
  $13 = $9 | $12; //@line 25655 "c/sqlite3.c"
  do {
   if ($13) {
    $14 = ((($0)) + 280|0); //@line 25656 "c/sqlite3.c"
    $$sink = $14;
   } else {
    $15 = ((($0)) + 292|0); //@line 25657 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 25657 "c/sqlite3.c"
    $17 = ($16|0)==(0|0); //@line 25657 "c/sqlite3.c"
    if (!($17)) {
     $18 = HEAP32[$16>>2]|0; //@line 25658 "c/sqlite3.c"
     HEAP32[$15>>2] = $18; //@line 25658 "c/sqlite3.c"
     $19 = ((($0)) + 276|0); //@line 25659 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 25659 "c/sqlite3.c"
     $21 = (($20) + 1)|0; //@line 25659 "c/sqlite3.c"
     HEAP32[$19>>2] = $21; //@line 25659 "c/sqlite3.c"
     $$0 = $16;
     return ($$0|0); //@line 25680 "c/sqlite3.c"
    }
    $22 = ((($0)) + 288|0); //@line 25661 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 25661 "c/sqlite3.c"
    $24 = ($23|0)==(0|0); //@line 25661 "c/sqlite3.c"
    if ($24) {
     $29 = ((($0)) + 284|0); //@line 25666 "c/sqlite3.c"
     $$sink = $29;
     break;
    }
    $25 = HEAP32[$23>>2]|0; //@line 25662 "c/sqlite3.c"
    HEAP32[$22>>2] = $25; //@line 25662 "c/sqlite3.c"
    $26 = ((($0)) + 276|0); //@line 25663 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 25663 "c/sqlite3.c"
    $28 = (($27) + 1)|0; //@line 25663 "c/sqlite3.c"
    HEAP32[$26>>2] = $28; //@line 25663 "c/sqlite3.c"
    $$0 = $23;
    return ($$0|0); //@line 25680 "c/sqlite3.c"
   }
  } while(0);
  $33 = HEAP32[$$sink>>2]|0;
  $34 = (($33) + 1)|0;
  HEAP32[$$sink>>2] = $34;
 } else {
  $30 = ((($0)) + 73|0); //@line 25668 "c/sqlite3.c"
  $31 = HEAP8[$30>>0]|0; //@line 25668 "c/sqlite3.c"
  $32 = ($31<<24>>24)==(0); //@line 25668 "c/sqlite3.c"
  if (!($32)) {
   $$0 = 0;
   return ($$0|0); //@line 25680 "c/sqlite3.c"
  }
 }
 $35 = (_dbMallocRawFinish($0,$1,$2)|0); //@line 25679 "c/sqlite3.c"
 $$0 = $35;
 return ($$0|0); //@line 25680 "c/sqlite3.c"
}
function _sqlite3Malloc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = (_i64Add(($0|0),($1|0),-1,-1)|0); //@line 25371 "c/sqlite3.c"
 $4 = tempRet0; //@line 25371 "c/sqlite3.c"
 $5 = ($4>>>0)>(0); //@line 25371 "c/sqlite3.c"
 $6 = ($3>>>0)>(2147483390); //@line 25371 "c/sqlite3.c"
 $7 = ($4|0)==(0); //@line 25371 "c/sqlite3.c"
 $8 = $7 & $6; //@line 25371 "c/sqlite3.c"
 $9 = $5 | $8; //@line 25371 "c/sqlite3.c"
 do {
  if ($9) {
   HEAP32[$2>>2] = 0; //@line 25377 "c/sqlite3.c"
  } else {
   $10 = HEAP32[2]|0; //@line 25378 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 25378 "c/sqlite3.c"
   if ($11) {
    $14 = HEAP32[(52)>>2]|0; //@line 25383 "c/sqlite3.c"
    $15 = (FUNCTION_TABLE_ii[$14 & 255]($0)|0); //@line 25383 "c/sqlite3.c"
    HEAP32[$2>>2] = $15; //@line 25383 "c/sqlite3.c"
    break;
   } else {
    $12 = HEAP32[10020]|0; //@line 25379 "c/sqlite3.c"
    _sqlite3_mutex_enter($12); //@line 25379 "c/sqlite3.c"
    _mallocWithAlarm($0,$2); //@line 25380 "c/sqlite3.c"
    $13 = HEAP32[10020]|0; //@line 25381 "c/sqlite3.c"
    _sqlite3_mutex_leave($13); //@line 25381 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $16 = HEAP32[$2>>2]|0; //@line 25386 "c/sqlite3.c"
 STACKTOP = sp;return ($16|0); //@line 25386 "c/sqlite3.c"
}
function _mallocWithAlarm($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[(68)>>2]|0; //@line 25331 "c/sqlite3.c"
 $3 = (FUNCTION_TABLE_ii[$2 & 255]($0)|0); //@line 25331 "c/sqlite3.c"
 _sqlite3StatusHighwater(5,$0); //@line 25340 "c/sqlite3.c"
 $4 = (40088); //@line 25341 "c/sqlite3.c"
 $5 = $4; //@line 25341 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 25341 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 25341 "c/sqlite3.c"
 $8 = $7; //@line 25341 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 25341 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 25341 "c/sqlite3.c"
 $11 = ($6>>>0)>(0); //@line 25341 "c/sqlite3.c"
 $12 = ($9|0)==(0); //@line 25341 "c/sqlite3.c"
 $13 = $12 & $11; //@line 25341 "c/sqlite3.c"
 $14 = $10 | $13; //@line 25341 "c/sqlite3.c"
 do {
  if ($14) {
   $15 = (_sqlite3StatusValue()|0); //@line 25342 "c/sqlite3.c"
   $16 = tempRet0; //@line 25342 "c/sqlite3.c"
   $17 = ($3|0)<(0); //@line 25343 "c/sqlite3.c"
   $18 = $17 << 31 >> 31; //@line 25343 "c/sqlite3.c"
   $19 = (_i64Subtract(($6|0),($9|0),($3|0),($18|0))|0); //@line 25343 "c/sqlite3.c"
   $20 = tempRet0; //@line 25343 "c/sqlite3.c"
   $21 = ($16|0)<($20|0); //@line 25343 "c/sqlite3.c"
   $22 = ($15>>>0)<($19>>>0); //@line 25343 "c/sqlite3.c"
   $23 = ($16|0)==($20|0); //@line 25343 "c/sqlite3.c"
   $24 = $23 & $22; //@line 25343 "c/sqlite3.c"
   $25 = $21 | $24; //@line 25343 "c/sqlite3.c"
   if ($25) {
    HEAP32[(40096)>>2] = 0; //@line 25347 "c/sqlite3.c"
    break;
   } else {
    HEAP32[(40096)>>2] = 1; //@line 25344 "c/sqlite3.c"
    _sqlite3MallocAlarm($3); //@line 25345 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $26 = HEAP32[(52)>>2]|0; //@line 25350 "c/sqlite3.c"
 $27 = (FUNCTION_TABLE_ii[$26 & 255]($3)|0); //@line 25350 "c/sqlite3.c"
 $28 = ($27|0)==(0|0); //@line 25357 "c/sqlite3.c"
 if ($28) {
  HEAP32[$1>>2] = $27; //@line 25362 "c/sqlite3.c"
  return; //@line 25363 "c/sqlite3.c"
 }
 $29 = (_sqlite3MallocSize($27)|0); //@line 25358 "c/sqlite3.c"
 _sqlite3StatusUp(0,$29); //@line 25359 "c/sqlite3.c"
 _sqlite3StatusUp(9,1); //@line 25360 "c/sqlite3.c"
 HEAP32[$1>>2] = $27; //@line 25362 "c/sqlite3.c"
 return; //@line 25363 "c/sqlite3.c"
}
function _sqlite3StatusHighwater($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (40148 + ($0<<2)|0); //@line 19304 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 19304 "c/sqlite3.c"
 $4 = ($3>>>0)<($1>>>0); //@line 19304 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 19307 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = $1; //@line 19305 "c/sqlite3.c"
 return; //@line 19307 "c/sqlite3.c"
}
function _sqlite3StatusValue() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[10027]|0; //@line 19253 "c/sqlite3.c"
 tempRet0 = (0); //@line 19253 "c/sqlite3.c"
 return ($0|0); //@line 19253 "c/sqlite3.c"
}
function _sqlite3MallocAlarm($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (40088); //@line 25310 "c/sqlite3.c"
 $2 = $1; //@line 25310 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 25310 "c/sqlite3.c"
 $4 = (($1) + 4)|0; //@line 25310 "c/sqlite3.c"
 $5 = $4; //@line 25310 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 25310 "c/sqlite3.c"
 $7 = ($6|0)<(0); //@line 25310 "c/sqlite3.c"
 $8 = ($3>>>0)<(1); //@line 25310 "c/sqlite3.c"
 $9 = ($6|0)==(0); //@line 25310 "c/sqlite3.c"
 $10 = $9 & $8; //@line 25310 "c/sqlite3.c"
 $11 = $7 | $10; //@line 25310 "c/sqlite3.c"
 if ($11) {
  return; //@line 25314 "c/sqlite3.c"
 }
 $12 = HEAP32[10020]|0; //@line 25311 "c/sqlite3.c"
 _sqlite3_mutex_leave($12); //@line 25311 "c/sqlite3.c"
 $13 = HEAP32[10020]|0; //@line 25313 "c/sqlite3.c"
 _sqlite3_mutex_enter($13); //@line 25313 "c/sqlite3.c"
 return; //@line 25314 "c/sqlite3.c"
}
function _sqlite3MallocSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(64)>>2]|0; //@line 25424 "c/sqlite3.c"
 $2 = (FUNCTION_TABLE_ii[$1 & 255]($0)|0); //@line 25424 "c/sqlite3.c"
 return ($2|0); //@line 25424 "c/sqlite3.c"
}
function _sqlite3StatusUp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (40108 + ($0<<2)|0); //@line 19273 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 19273 "c/sqlite3.c"
 $4 = (($3) + ($1))|0; //@line 19273 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 19273 "c/sqlite3.c"
 $5 = (40148 + ($0<<2)|0); //@line 19274 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 19274 "c/sqlite3.c"
 $7 = ($4>>>0)>($6>>>0); //@line 19274 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 19277 "c/sqlite3.c"
 }
 HEAP32[$5>>2] = $4; //@line 19275 "c/sqlite3.c"
 return; //@line 19277 "c/sqlite3.c"
}
function _dbMallocRawFinish($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3Malloc($1,$2)|0); //@line 25611 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 25612 "c/sqlite3.c"
 if ($4) {
  _sqlite3OomFault($0); //@line 25612 "c/sqlite3.c"
 }
 return ($3|0); //@line 25615 "c/sqlite3.c"
}
function _sqlite3OomFault($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 73|0); //@line 25798 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 25798 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 25798 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 25805 "c/sqlite3.c"
 }
 $4 = ((($0)) + 74|0); //@line 25798 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 25798 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 25798 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 25805 "c/sqlite3.c"
 }
 HEAP8[$1>>0] = 1; //@line 25799 "c/sqlite3.c"
 $7 = ((($0)) + 172|0); //@line 25800 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 25800 "c/sqlite3.c"
 $9 = ($8|0)>(0); //@line 25800 "c/sqlite3.c"
 if ($9) {
  $10 = ((($0)) + 256|0); //@line 25801 "c/sqlite3.c"
  HEAP32[$10>>2] = 1; //@line 25801 "c/sqlite3.c"
 }
 $11 = ((($0)) + 264|0); //@line 25803 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 25803 "c/sqlite3.c"
 $13 = (($12) + 1)|0; //@line 25803 "c/sqlite3.c"
 HEAP32[$11>>2] = $13; //@line 25803 "c/sqlite3.c"
 return; //@line 25805 "c/sqlite3.c"
}
function _sqlite3StrAccumAppend($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 26712 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 26712 "c/sqlite3.c"
 $5 = (($4) + ($2))|0; //@line 26712 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 26712 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 26712 "c/sqlite3.c"
 $8 = ($5>>>0)<($7>>>0); //@line 26712 "c/sqlite3.c"
 if (!($8)) {
  _enlargeAndAppend($0,$1,$2); //@line 26713 "c/sqlite3.c"
  return; //@line 26719 "c/sqlite3.c"
 }
 $9 = ($2|0)==(0); //@line 26714 "c/sqlite3.c"
 if ($9) {
  return; //@line 26719 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = $5; //@line 26716 "c/sqlite3.c"
 $10 = ((($0)) + 4|0); //@line 26717 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 26717 "c/sqlite3.c"
 $12 = (($11) + ($4)|0); //@line 26717 "c/sqlite3.c"
 _memcpy(($12|0),($1|0),($2|0))|0; //@line 26717 "c/sqlite3.c"
 return; //@line 26719 "c/sqlite3.c"
}
function _getIntArg($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 26004 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 26004 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 26004 "c/sqlite3.c"
 $4 = ($1|0)>($3|0); //@line 26004 "c/sqlite3.c"
 if (!($4)) {
  $12 = 0;$13 = 0;
  tempRet0 = ($12); //@line 26006 "c/sqlite3.c"
  return ($13|0); //@line 26006 "c/sqlite3.c"
 }
 $5 = ((($0)) + 8|0); //@line 26005 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 26005 "c/sqlite3.c"
 $7 = (($3) + 1)|0; //@line 26005 "c/sqlite3.c"
 HEAP32[$2>>2] = $7; //@line 26005 "c/sqlite3.c"
 $8 = (($6) + ($3<<2)|0); //@line 26005 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 26005 "c/sqlite3.c"
 $10 = (_sqlite3_value_int64($9)|0); //@line 26005 "c/sqlite3.c"
 $11 = tempRet0; //@line 26005 "c/sqlite3.c"
 $12 = $11;$13 = $10;
 tempRet0 = ($12); //@line 26006 "c/sqlite3.c"
 return ($13|0); //@line 26006 "c/sqlite3.c"
}
function _getDoubleArg($0) {
 $0 = $0|0;
 var $$0 = 0.0, $1 = 0, $10 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 26008 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 26008 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 26008 "c/sqlite3.c"
 $4 = ($1|0)>($3|0); //@line 26008 "c/sqlite3.c"
 if (!($4)) {
  $$0 = 0.0;
  return (+$$0); //@line 26010 "c/sqlite3.c"
 }
 $5 = ((($0)) + 8|0); //@line 26009 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 26009 "c/sqlite3.c"
 $7 = (($3) + 1)|0; //@line 26009 "c/sqlite3.c"
 HEAP32[$2>>2] = $7; //@line 26009 "c/sqlite3.c"
 $8 = (($6) + ($3<<2)|0); //@line 26009 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 26009 "c/sqlite3.c"
 $10 = (+_sqlite3_value_double($9)); //@line 26009 "c/sqlite3.c"
 $$0 = $10;
 return (+$$0); //@line 26010 "c/sqlite3.c"
}
function _sqlite3IsNaN($0) {
 $0 = +$0;
 var $$0$$0$ = 0.0, $$0$$0$2 = 0.0, $$0$$0$3 = 0.0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp + 8|0;
 $2 = sp;
 HEAPF64[$1>>3] = $0; //@line 28556 "c/sqlite3.c"
 $$0$$0$2 = +HEAPF64[$1>>3]; //@line 28557 "c/sqlite3.c"
 HEAPF64[$2>>3] = $$0$$0$2; //@line 28557 "c/sqlite3.c"
 $$0$$0$3 = +HEAPF64[$1>>3]; //@line 28558 "c/sqlite3.c"
 $$0$$0$ = +HEAPF64[$2>>3]; //@line 28558 "c/sqlite3.c"
 $3 = $$0$$0$3 != $$0$$0$; //@line 28558 "c/sqlite3.c"
 $4 = $3&1; //@line 28558 "c/sqlite3.c"
 STACKTOP = sp;return ($4|0); //@line 28563 "c/sqlite3.c"
}
function _et_getdigit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0.0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 25981 "c/sqlite3.c"
 $3 = ($2|0)<(1); //@line 25981 "c/sqlite3.c"
 if ($3) {
  $$0 = 48;
  return ($$0|0); //@line 25988 "c/sqlite3.c"
 }
 $4 = (($2) + -1)|0; //@line 25982 "c/sqlite3.c"
 HEAP32[$1>>2] = $4; //@line 25982 "c/sqlite3.c"
 $5 = +HEAPF64[$0>>3]; //@line 25983 "c/sqlite3.c"
 $6 = (~~(($5))); //@line 25983 "c/sqlite3.c"
 $7 = (+($6|0)); //@line 25984 "c/sqlite3.c"
 $8 = (($6) + 48)|0; //@line 25985 "c/sqlite3.c"
 $9 = $5 - $7; //@line 25986 "c/sqlite3.c"
 $10 = $9 * 10.0; //@line 25986 "c/sqlite3.c"
 HEAPF64[$0>>3] = $10; //@line 25986 "c/sqlite3.c"
 $11 = $8&255; //@line 25987 "c/sqlite3.c"
 $$0 = $11;
 return ($$0|0); //@line 25988 "c/sqlite3.c"
}
function _getTextArg($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 26012 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 26012 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 26012 "c/sqlite3.c"
 $4 = ($1|0)>($3|0); //@line 26012 "c/sqlite3.c"
 if (!($4)) {
  $$0 = 0;
  return ($$0|0); //@line 26014 "c/sqlite3.c"
 }
 $5 = ((($0)) + 8|0); //@line 26013 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 26013 "c/sqlite3.c"
 $7 = (($3) + 1)|0; //@line 26013 "c/sqlite3.c"
 HEAP32[$2>>2] = $7; //@line 26013 "c/sqlite3.c"
 $8 = (($6) + ($3<<2)|0); //@line 26013 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 26013 "c/sqlite3.c"
 $10 = (_sqlite3_value_text($9)|0); //@line 26013 "c/sqlite3.c"
 $$0 = $10;
 return ($$0|0); //@line 26014 "c/sqlite3.c"
}
function _sqlite3AppendChar($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$09 = 0, $$18 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 26681 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 26681 "c/sqlite3.c"
 $5 = ($1|0)<(0); //@line 26681 "c/sqlite3.c"
 $6 = $5 << 31 >> 31; //@line 26681 "c/sqlite3.c"
 $7 = (_i64Add(($4|0),0,($1|0),($6|0))|0); //@line 26681 "c/sqlite3.c"
 $8 = tempRet0; //@line 26681 "c/sqlite3.c"
 $9 = ((($0)) + 8|0); //@line 26681 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 26681 "c/sqlite3.c"
 $11 = ($8|0)<(0); //@line 26681 "c/sqlite3.c"
 $12 = ($7>>>0)<($10>>>0); //@line 26681 "c/sqlite3.c"
 $13 = ($8|0)==(0); //@line 26681 "c/sqlite3.c"
 $14 = $13 & $12; //@line 26681 "c/sqlite3.c"
 $15 = $11 | $14; //@line 26681 "c/sqlite3.c"
 if ($15) {
  $18 = ($1|0)>(0); //@line 26684 "c/sqlite3.c"
  if ($18) {
   $$09 = $1;
  } else {
   return; //@line 26685 "c/sqlite3.c"
  }
 } else {
  $16 = (_sqlite3StrAccumEnlarge($0,$1)|0); //@line 26681 "c/sqlite3.c"
  $17 = ($16|0)<(1); //@line 26681 "c/sqlite3.c"
  if ($17) {
   return; //@line 26685 "c/sqlite3.c"
  } else {
   $$09 = $16;
  }
 }
 $19 = ((($0)) + 4|0);
 $$18 = $$09;
 while(1) {
  $20 = (($$18) + -1)|0; //@line 26684 "c/sqlite3.c"
  $21 = HEAP32[$19>>2]|0; //@line 26684 "c/sqlite3.c"
  $22 = HEAP32[$3>>2]|0; //@line 26684 "c/sqlite3.c"
  $23 = (($22) + 1)|0; //@line 26684 "c/sqlite3.c"
  HEAP32[$3>>2] = $23; //@line 26684 "c/sqlite3.c"
  $24 = (($21) + ($22)|0); //@line 26684 "c/sqlite3.c"
  HEAP8[$24>>0] = $2; //@line 26684 "c/sqlite3.c"
  $25 = ($$18|0)>(1); //@line 26684 "c/sqlite3.c"
  if ($25) {
   $$18 = $20;
  } else {
   break;
  }
 }
 return; //@line 26685 "c/sqlite3.c"
}
function _sqlite3StrAccumAppendAll($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3Strlen30($1)|0); //@line 26725 "c/sqlite3.c"
 _sqlite3StrAccumAppend($0,$1,$2); //@line 26725 "c/sqlite3.c"
 return; //@line 26726 "c/sqlite3.c"
}
function _sqlite3DbFree($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 25508 "c/sqlite3.c"
 if (!($2)) {
  _sqlite3DbFreeNN($0,$1); //@line 25508 "c/sqlite3.c"
 }
 return; //@line 25509 "c/sqlite3.c"
}
function _sqlite3DbFreeNN($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 25484 "c/sqlite3.c"
 if (!($2)) {
  $3 = ((($0)) + 464|0); //@line 25485 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 25485 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 25485 "c/sqlite3.c"
  if (!($5)) {
   _measureAllocationSize($0,$1); //@line 25486 "c/sqlite3.c"
   return; //@line 25505 "c/sqlite3.c"
  }
  $6 = (_isLookaside($0,$1)|0); //@line 25489 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 25489 "c/sqlite3.c"
  if (!($7)) {
   $8 = ((($0)) + 292|0); //@line 25495 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 25495 "c/sqlite3.c"
   HEAP32[$1>>2] = $9; //@line 25495 "c/sqlite3.c"
   HEAP32[$8>>2] = $1; //@line 25496 "c/sqlite3.c"
   return; //@line 25505 "c/sqlite3.c"
  }
 }
 _sqlite3_free($1); //@line 25504 "c/sqlite3.c"
 return; //@line 25505 "c/sqlite3.c"
}
function _measureAllocationSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3DbMallocSize($0,$1)|0); //@line 25473 "c/sqlite3.c"
 $3 = ((($0)) + 464|0); //@line 25473 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 25473 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 25473 "c/sqlite3.c"
 $6 = (($5) + ($2))|0; //@line 25473 "c/sqlite3.c"
 HEAP32[$4>>2] = $6; //@line 25473 "c/sqlite3.c"
 return; //@line 25474 "c/sqlite3.c"
}
function _isLookaside($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1; //@line 25412 "c/sqlite3.c"
 $3 = ((($0)) + 296|0); //@line 25412 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 25412 "c/sqlite3.c"
 $5 = ($4>>>0)>($2>>>0); //@line 25412 "c/sqlite3.c"
 if ($5) {
  $9 = 0;
  return ($9|0); //@line 25412 "c/sqlite3.c"
 }
 $6 = ((($0)) + 300|0); //@line 25412 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 25412 "c/sqlite3.c"
 $8 = ($7>>>0)>($2>>>0); //@line 25412 "c/sqlite3.c"
 $phitmp = $8&1;
 $9 = $phitmp;
 return ($9|0); //@line 25412 "c/sqlite3.c"
}
function _sqlite3_free($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 25454 "c/sqlite3.c"
 if ($1) {
  return; //@line 25466 "c/sqlite3.c"
 }
 $2 = HEAP32[2]|0; //@line 25457 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 25457 "c/sqlite3.c"
 if ($3) {
  $8 = HEAP32[(56)>>2]|0; //@line 25464 "c/sqlite3.c"
  FUNCTION_TABLE_vi[$8 & 127]($0); //@line 25464 "c/sqlite3.c"
  return; //@line 25466 "c/sqlite3.c"
 } else {
  $4 = HEAP32[10020]|0; //@line 25458 "c/sqlite3.c"
  _sqlite3_mutex_enter($4); //@line 25458 "c/sqlite3.c"
  $5 = (_sqlite3MallocSize($0)|0); //@line 25459 "c/sqlite3.c"
  _sqlite3StatusDown(0,$5); //@line 25459 "c/sqlite3.c"
  _sqlite3StatusDown(9,1); //@line 25460 "c/sqlite3.c"
  $6 = HEAP32[(56)>>2]|0; //@line 25461 "c/sqlite3.c"
  FUNCTION_TABLE_vi[$6 & 127]($0); //@line 25461 "c/sqlite3.c"
  $7 = HEAP32[10020]|0; //@line 25462 "c/sqlite3.c"
  _sqlite3_mutex_leave($7); //@line 25462 "c/sqlite3.c"
  return; //@line 25466 "c/sqlite3.c"
 }
}
function _sqlite3StatusDown($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (40108 + ($0<<2)|0); //@line 19285 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 19285 "c/sqlite3.c"
 $4 = (($3) - ($1))|0; //@line 19285 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 19285 "c/sqlite3.c"
 return; //@line 19286 "c/sqlite3.c"
}
function _sqlite3DbMallocSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 25428 "c/sqlite3.c"
 if (!($2)) {
  $3 = (_isLookaside($0,$1)|0); //@line 25428 "c/sqlite3.c"
  $4 = ($3|0)==(0); //@line 25428 "c/sqlite3.c"
  if (!($4)) {
   $7 = ((($0)) + 268|0); //@line 25441 "c/sqlite3.c"
   $8 = HEAP16[$7>>1]|0; //@line 25441 "c/sqlite3.c"
   $9 = $8&65535; //@line 25441 "c/sqlite3.c"
   $$0 = $9;
   return ($$0|0); //@line 25443 "c/sqlite3.c"
  }
 }
 $5 = HEAP32[(64)>>2]|0; //@line 25438 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_ii[$5 & 255]($1)|0); //@line 25438 "c/sqlite3.c"
 $$0 = $6;
 return ($$0|0); //@line 25443 "c/sqlite3.c"
}
function _sqlite3Strlen30($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 28576 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
 } else {
  $2 = (_strlen($0)|0); //@line 28577 "c/sqlite3.c"
  $3 = $2 & 1073741823; //@line 28577 "c/sqlite3.c"
  $$0 = $3;
 }
 return ($$0|0); //@line 28578 "c/sqlite3.c"
}
function _sqlite3StrAccumEnlarge($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$050 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 26631 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 26631 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 26631 "c/sqlite3.c"
 if (!($4)) {
  $60 = 0;
  return ($60|0);
 }
 $5 = ((($0)) + 12|0); //@line 26636 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 26636 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 26636 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 8|0); //@line 26637 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 26637 "c/sqlite3.c"
  $10 = ((($0)) + 16|0); //@line 26637 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 26637 "c/sqlite3.c"
  $12 = (($9) + -1)|0; //@line 26637 "c/sqlite3.c"
  $13 = (($12) - ($11))|0; //@line 26637 "c/sqlite3.c"
  _setStrAccumError($0,2); //@line 26638 "c/sqlite3.c"
  $60 = $13;
  return ($60|0);
 }
 $14 = ((($0)) + 21|0); //@line 26641 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 26641 "c/sqlite3.c"
 $16 = $15 & 4; //@line 26641 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 26641 "c/sqlite3.c"
 if ($17) {
  $44 = 0;
 } else {
  $18 = ((($0)) + 4|0); //@line 26641 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 26641 "c/sqlite3.c"
  $44 = $19;
 }
 $20 = ((($0)) + 16|0); //@line 26642 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 26642 "c/sqlite3.c"
 $22 = (($1) + 1)|0; //@line 26643 "c/sqlite3.c"
 $23 = ($22|0)<(0); //@line 26643 "c/sqlite3.c"
 $24 = $23 << 31 >> 31; //@line 26643 "c/sqlite3.c"
 $25 = (_i64Add(($21|0),0,($22|0),($24|0))|0); //@line 26643 "c/sqlite3.c"
 $26 = tempRet0; //@line 26643 "c/sqlite3.c"
 $27 = (_i64Add(($25|0),($26|0),($21|0),0)|0); //@line 26644 "c/sqlite3.c"
 $28 = tempRet0; //@line 26644 "c/sqlite3.c"
 $29 = ($28|0)>(0); //@line 26644 "c/sqlite3.c"
 $30 = ($27>>>0)>($6>>>0); //@line 26644 "c/sqlite3.c"
 $31 = ($28|0)==(0); //@line 26644 "c/sqlite3.c"
 $32 = $31 & $30; //@line 26644 "c/sqlite3.c"
 $33 = $29 | $32; //@line 26644 "c/sqlite3.c"
 $34 = $33 ? $25 : $27; //@line 26644 "c/sqlite3.c"
 $35 = $33 ? $26 : $28; //@line 26644 "c/sqlite3.c"
 $36 = ($35|0)>(0); //@line 26649 "c/sqlite3.c"
 $37 = ($34>>>0)>($6>>>0); //@line 26649 "c/sqlite3.c"
 $38 = ($35|0)==(0); //@line 26649 "c/sqlite3.c"
 $39 = $38 & $37; //@line 26649 "c/sqlite3.c"
 $40 = $36 | $39; //@line 26649 "c/sqlite3.c"
 if ($40) {
  _sqlite3StrAccumReset($0); //@line 26650 "c/sqlite3.c"
  _setStrAccumError($0,2); //@line 26651 "c/sqlite3.c"
  $60 = 0;
  return ($60|0);
 }
 $41 = ((($0)) + 8|0); //@line 26654 "c/sqlite3.c"
 HEAP32[$41>>2] = $34; //@line 26654 "c/sqlite3.c"
 $42 = HEAP32[$0>>2]|0; //@line 26656 "c/sqlite3.c"
 $43 = ($42|0)==(0|0); //@line 26656 "c/sqlite3.c"
 if ($43) {
  $46 = (_sqlite3_realloc64($44,$34,0)|0); //@line 26659 "c/sqlite3.c"
  $$050 = $46;
 } else {
  $45 = (_sqlite3DbRealloc($42,$44,$34,0)|0); //@line 26657 "c/sqlite3.c"
  $$050 = $45;
 }
 $47 = ($$050|0)==(0|0); //@line 26661 "c/sqlite3.c"
 if ($47) {
  _sqlite3StrAccumReset($0); //@line 26668 "c/sqlite3.c"
  _setStrAccumError($0,1); //@line 26669 "c/sqlite3.c"
  $60 = 0;
  return ($60|0);
 }
 $48 = HEAP8[$14>>0]|0; //@line 26663 "c/sqlite3.c"
 $49 = $48 & 4; //@line 26663 "c/sqlite3.c"
 $50 = ($49<<24>>24)==(0); //@line 26663 "c/sqlite3.c"
 if ($50) {
  $51 = HEAP32[$20>>2]|0; //@line 26663 "c/sqlite3.c"
  $52 = ($51|0)==(0); //@line 26663 "c/sqlite3.c"
  if (!($52)) {
   $53 = ((($0)) + 4|0); //@line 26663 "c/sqlite3.c"
   $54 = HEAP32[$53>>2]|0; //@line 26663 "c/sqlite3.c"
   _memcpy(($$050|0),($54|0),($51|0))|0; //@line 26663 "c/sqlite3.c"
  }
 }
 $55 = ((($0)) + 4|0); //@line 26664 "c/sqlite3.c"
 HEAP32[$55>>2] = $$050; //@line 26664 "c/sqlite3.c"
 $56 = HEAP32[$0>>2]|0; //@line 26665 "c/sqlite3.c"
 $57 = (_sqlite3DbMallocSize($56,$$050)|0); //@line 26665 "c/sqlite3.c"
 HEAP32[$41>>2] = $57; //@line 26665 "c/sqlite3.c"
 $58 = HEAP8[$14>>0]|0; //@line 26666 "c/sqlite3.c"
 $59 = $58 | 4; //@line 26666 "c/sqlite3.c"
 HEAP8[$14>>0] = $59; //@line 26666 "c/sqlite3.c"
 $60 = $1;
 return ($60|0);
}
function _sqlite3StrAccumReset($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 21|0); //@line 26761 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 26761 "c/sqlite3.c"
 $3 = $2 & 4; //@line 26761 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 26761 "c/sqlite3.c"
 if (!($4)) {
  $5 = HEAP32[$0>>2]|0; //@line 26762 "c/sqlite3.c"
  $6 = ((($0)) + 4|0); //@line 26762 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 26762 "c/sqlite3.c"
  _sqlite3DbFree($5,$7); //@line 26762 "c/sqlite3.c"
  $8 = HEAP8[$1>>0]|0; //@line 26763 "c/sqlite3.c"
  $9 = $8 & -5; //@line 26763 "c/sqlite3.c"
  HEAP8[$1>>0] = $9; //@line 26763 "c/sqlite3.c"
 }
 $10 = ((($0)) + 4|0); //@line 26765 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 26765 "c/sqlite3.c"
 return; //@line 26766 "c/sqlite3.c"
}
function _sqlite3DbRealloc($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 25691 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3DbMallocRawNN($0,$2,$3)|0); //@line 25691 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 25695 "c/sqlite3.c"
 }
 $6 = (_isLookaside($0,$1)|0); //@line 25693 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 25693 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($0)) + 268|0); //@line 25693 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 25693 "c/sqlite3.c"
  $10 = $9&65535; //@line 25693 "c/sqlite3.c"
  $11 = (0)<($3>>>0); //@line 25693 "c/sqlite3.c"
  $12 = ($10>>>0)<($2>>>0); //@line 25693 "c/sqlite3.c"
  $13 = (0)==($3|0); //@line 25693 "c/sqlite3.c"
  $14 = $13 & $12; //@line 25693 "c/sqlite3.c"
  $15 = $11 | $14; //@line 25693 "c/sqlite3.c"
  if (!($15)) {
   $$0 = $1;
   return ($$0|0); //@line 25695 "c/sqlite3.c"
  }
 }
 $16 = (_dbReallocFinish($0,$1,$2,$3)|0); //@line 25694 "c/sqlite3.c"
 $$0 = $16;
 return ($$0|0); //@line 25695 "c/sqlite3.c"
}
function _sqlite3_realloc64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_initialize()|0); //@line 25575 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 25575 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3Realloc($0,$1,$2)|0); //@line 25577 "c/sqlite3.c"
  $$0 = $5;
 } else {
  $$0 = 0;
 }
 return ($$0|0); //@line 25578 "c/sqlite3.c"
}
function _sqlite3_initialize() {
 var $$019 = 0, $$122$ph = 0, $$327 = 0, $$4 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $0 = HEAP32[(232)>>2]|0; //@line 143529 "c/sqlite3.c"
 $1 = ($0|0)==(0); //@line 143529 "c/sqlite3.c"
 if (!($1)) {
  $$019 = 0;
  return ($$019|0); //@line 143661 "c/sqlite3.c"
 }
 $2 = (_sqlite3MutexInit()|0); //@line 143539 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 143540 "c/sqlite3.c"
 if (!($3)) {
  $$019 = $2;
  return ($$019|0); //@line 143661 "c/sqlite3.c"
 }
 $4 = (_sqlite3MutexAlloc(2)|0); //@line 143548 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 143549 "c/sqlite3.c"
 HEAP32[(240)>>2] = 1; //@line 143550 "c/sqlite3.c"
 $5 = HEAP32[(244)>>2]|0; //@line 143551 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 143551 "c/sqlite3.c"
 if ($6) {
  $7 = (_sqlite3MallocInit()|0); //@line 143552 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 143554 "c/sqlite3.c"
  if ($8) {
   label = 5;
  } else {
   $$122$ph = $7;
  }
 } else {
  label = 5;
 }
 do {
  if ((label|0) == 5) {
   HEAP32[(244)>>2] = 1; //@line 143555 "c/sqlite3.c"
   $9 = HEAP32[(256)>>2]|0; //@line 143556 "c/sqlite3.c"
   $10 = ($9|0)==(0|0); //@line 143556 "c/sqlite3.c"
   if ($10) {
    $11 = (_sqlite3MutexAlloc(1)|0); //@line 143558 "c/sqlite3.c"
    HEAP32[(256)>>2] = $11; //@line 143557 "c/sqlite3.c"
    $12 = HEAP32[(12)>>2]|0; //@line 143559 "c/sqlite3.c"
    $13 = ($12|0)==(0); //@line 143559 "c/sqlite3.c"
    $14 = ($11|0)!=(0|0); //@line 143559 "c/sqlite3.c"
    $or$cond = $14 | $13; //@line 143559 "c/sqlite3.c"
    if (!($or$cond)) {
     $$122$ph = 7;
     break;
    }
   }
   $15 = HEAP32[(252)>>2]|0; //@line 143565 "c/sqlite3.c"
   $16 = (($15) + 1)|0; //@line 143565 "c/sqlite3.c"
   HEAP32[(252)>>2] = $16; //@line 143565 "c/sqlite3.c"
   _sqlite3_mutex_leave($4); //@line 143567 "c/sqlite3.c"
   $17 = HEAP32[(256)>>2]|0; //@line 143589 "c/sqlite3.c"
   _sqlite3_mutex_enter($17); //@line 143589 "c/sqlite3.c"
   $18 = HEAP32[(232)>>2]|0; //@line 143590 "c/sqlite3.c"
   $19 = HEAP32[(236)>>2]|0; //@line 143590 "c/sqlite3.c"
   $20 = $19 | $18; //@line 143590 "c/sqlite3.c"
   $21 = ($20|0)==(0); //@line 143590 "c/sqlite3.c"
   if ($21) {
    HEAP32[(236)>>2] = 1; //@line 143591 "c/sqlite3.c"
    dest=40288; stop=dest+92|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 143598 "c/sqlite3.c"
    _sqlite3RegisterBuiltinFunctions(); //@line 143599 "c/sqlite3.c"
    $22 = HEAP32[(248)>>2]|0; //@line 143600 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 143600 "c/sqlite3.c"
    if ($23) {
     $24 = (_sqlite3PcacheInitialize()|0); //@line 143601 "c/sqlite3.c"
     $25 = ($24|0)==(0); //@line 143603 "c/sqlite3.c"
     if ($25) {
      label = 11;
     } else {
      $$327 = $24;
     }
    } else {
     label = 11;
    }
    if ((label|0) == 11) {
     HEAP32[(248)>>2] = 1; //@line 143604 "c/sqlite3.c"
     $26 = (_sqlite3OsInit()|0); //@line 143605 "c/sqlite3.c"
     $27 = ($26|0)==(0); //@line 143607 "c/sqlite3.c"
     if ($27) {
      $28 = HEAP32[(208)>>2]|0; //@line 143608 "c/sqlite3.c"
      $29 = HEAP32[(212)>>2]|0; //@line 143609 "c/sqlite3.c"
      $30 = HEAP32[(216)>>2]|0; //@line 143609 "c/sqlite3.c"
      _sqlite3PCacheBufferSetup($28,$29,$30); //@line 143608 "c/sqlite3.c"
      HEAP32[(232)>>2] = 1; //@line 143610 "c/sqlite3.c"
      $$327 = 0;
     } else {
      $$327 = $26;
     }
    }
    HEAP32[(236)>>2] = 0; //@line 143615 "c/sqlite3.c"
    $$4 = $$327;
   } else {
    $$4 = 0;
   }
   $31 = HEAP32[(256)>>2]|0; //@line 143617 "c/sqlite3.c"
   _sqlite3_mutex_leave($31); //@line 143617 "c/sqlite3.c"
   _sqlite3_mutex_enter($4); //@line 143622 "c/sqlite3.c"
   $32 = HEAP32[(252)>>2]|0; //@line 143623 "c/sqlite3.c"
   $33 = (($32) + -1)|0; //@line 143623 "c/sqlite3.c"
   HEAP32[(252)>>2] = $33; //@line 143623 "c/sqlite3.c"
   $34 = ($32|0)<(2); //@line 143624 "c/sqlite3.c"
   if ($34) {
    $35 = HEAP32[(256)>>2]|0; //@line 143626 "c/sqlite3.c"
    _sqlite3_mutex_free($35); //@line 143626 "c/sqlite3.c"
    HEAP32[(256)>>2] = 0; //@line 143627 "c/sqlite3.c"
   }
   _sqlite3_mutex_leave($4); //@line 143629 "c/sqlite3.c"
   $$019 = $$4;
   return ($$019|0); //@line 143661 "c/sqlite3.c"
  }
 } while(0);
 _sqlite3_mutex_leave($4); //@line 143567 "c/sqlite3.c"
 $$019 = $$122$ph;
 return ($$019|0); //@line 143661 "c/sqlite3.c"
}
function _sqlite3Realloc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$036 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 25519 "c/sqlite3.c"
 if ($3) {
  $4 = (_sqlite3Malloc($1,$2)|0); //@line 25520 "c/sqlite3.c"
  $$036 = $4;
  return ($$036|0); //@line 25560 "c/sqlite3.c"
 }
 $5 = ($1|0)==(0); //@line 25522 "c/sqlite3.c"
 $6 = ($2|0)==(0); //@line 25522 "c/sqlite3.c"
 $7 = $5 & $6; //@line 25522 "c/sqlite3.c"
 if ($7) {
  _sqlite3_free($0); //@line 25523 "c/sqlite3.c"
  $$036 = 0;
  return ($$036|0); //@line 25560 "c/sqlite3.c"
 }
 $8 = ($2>>>0)>(0); //@line 25526 "c/sqlite3.c"
 $9 = ($1>>>0)>(2147483391); //@line 25526 "c/sqlite3.c"
 $10 = ($2|0)==(0); //@line 25526 "c/sqlite3.c"
 $11 = $10 & $9; //@line 25526 "c/sqlite3.c"
 $12 = $8 | $11; //@line 25526 "c/sqlite3.c"
 if ($12) {
  $$036 = 0;
  return ($$036|0); //@line 25560 "c/sqlite3.c"
 }
 $13 = (_sqlite3MallocSize($0)|0); //@line 25530 "c/sqlite3.c"
 $14 = HEAP32[(68)>>2]|0; //@line 25534 "c/sqlite3.c"
 $15 = (FUNCTION_TABLE_ii[$14 & 255]($1)|0); //@line 25534 "c/sqlite3.c"
 $16 = ($15|0)==($13|0); //@line 25535 "c/sqlite3.c"
 if ($16) {
  $$036 = $0;
  return ($$036|0); //@line 25560 "c/sqlite3.c"
 }
 $17 = HEAP32[2]|0; //@line 25537 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 25537 "c/sqlite3.c"
 if ($18) {
  $59 = HEAP32[(60)>>2]|0; //@line 25556 "c/sqlite3.c"
  $60 = (FUNCTION_TABLE_iii[$59 & 255]($0,$15)|0); //@line 25556 "c/sqlite3.c"
  $$036 = $60;
  return ($$036|0); //@line 25560 "c/sqlite3.c"
 }
 $19 = HEAP32[10020]|0; //@line 25538 "c/sqlite3.c"
 _sqlite3_mutex_enter($19); //@line 25538 "c/sqlite3.c"
 _sqlite3StatusHighwater(5,$1); //@line 25539 "c/sqlite3.c"
 $20 = (($15) - ($13))|0; //@line 25540 "c/sqlite3.c"
 $21 = ($20|0)>(0); //@line 25541 "c/sqlite3.c"
 if ($21) {
  $22 = (_sqlite3StatusValue()|0); //@line 25541 "c/sqlite3.c"
  $23 = tempRet0; //@line 25541 "c/sqlite3.c"
  $24 = (40088); //@line 25542 "c/sqlite3.c"
  $25 = $24; //@line 25542 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 25542 "c/sqlite3.c"
  $27 = (($24) + 4)|0; //@line 25542 "c/sqlite3.c"
  $28 = $27; //@line 25542 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 25542 "c/sqlite3.c"
  $30 = ($20|0)<(0); //@line 25542 "c/sqlite3.c"
  $31 = $30 << 31 >> 31; //@line 25542 "c/sqlite3.c"
  $32 = (_i64Subtract(($26|0),($29|0),($20|0),($31|0))|0); //@line 25542 "c/sqlite3.c"
  $33 = tempRet0; //@line 25542 "c/sqlite3.c"
  $34 = ($23|0)<($33|0); //@line 25541 "c/sqlite3.c"
  $35 = ($22>>>0)<($32>>>0); //@line 25541 "c/sqlite3.c"
  $36 = ($23|0)==($33|0); //@line 25541 "c/sqlite3.c"
  $37 = $36 & $35; //@line 25541 "c/sqlite3.c"
  $38 = $34 | $37; //@line 25541 "c/sqlite3.c"
  if (!($38)) {
   _sqlite3MallocAlarm($20); //@line 25543 "c/sqlite3.c"
  }
 }
 $39 = HEAP32[(60)>>2]|0; //@line 25545 "c/sqlite3.c"
 $40 = (FUNCTION_TABLE_iii[$39 & 255]($0,$15)|0); //@line 25545 "c/sqlite3.c"
 $41 = ($40|0)==(0|0); //@line 25546 "c/sqlite3.c"
 $42 = (40088); //@line 25546 "c/sqlite3.c"
 $43 = $42; //@line 25546 "c/sqlite3.c"
 $44 = HEAP32[$43>>2]|0; //@line 25546 "c/sqlite3.c"
 $45 = (($42) + 4)|0; //@line 25546 "c/sqlite3.c"
 $46 = $45; //@line 25546 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 25546 "c/sqlite3.c"
 $48 = ($47|0)>(0); //@line 25546 "c/sqlite3.c"
 $49 = ($44>>>0)>(0); //@line 25546 "c/sqlite3.c"
 $50 = ($47|0)==(0); //@line 25546 "c/sqlite3.c"
 $51 = $50 & $49; //@line 25546 "c/sqlite3.c"
 $52 = $48 | $51; //@line 25546 "c/sqlite3.c"
 $or$cond = $41 & $52; //@line 25546 "c/sqlite3.c"
 if ($or$cond) {
  _sqlite3MallocAlarm($1); //@line 25547 "c/sqlite3.c"
  $53 = HEAP32[(60)>>2]|0; //@line 25548 "c/sqlite3.c"
  $54 = (FUNCTION_TABLE_iii[$53 & 255]($0,$15)|0); //@line 25548 "c/sqlite3.c"
  $$0 = $54;
 } else {
  $$0 = $40;
 }
 $55 = ($$0|0)==(0|0); //@line 25550 "c/sqlite3.c"
 if (!($55)) {
  $56 = (_sqlite3MallocSize($$0)|0); //@line 25551 "c/sqlite3.c"
  $57 = (($56) - ($13))|0; //@line 25552 "c/sqlite3.c"
  _sqlite3StatusUp(0,$57); //@line 25552 "c/sqlite3.c"
 }
 $58 = HEAP32[10020]|0; //@line 25554 "c/sqlite3.c"
 _sqlite3_mutex_leave($58); //@line 25554 "c/sqlite3.c"
 $$036 = $$0;
 return ($$036|0); //@line 25560 "c/sqlite3.c"
}
function _sqlite3MutexInit() {
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $spec$select23 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[(92)>>2]|0; //@line 23697 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 23697 "c/sqlite3.c"
 if (!($1)) {
  $21 = HEAP32[(84)>>2]|0; //@line 23727 "c/sqlite3.c"
  $22 = (FUNCTION_TABLE_i[$21 & 127]()|0); //@line 23727 "c/sqlite3.c"
  return ($22|0); //@line 23733 "c/sqlite3.c"
 }
 $2 = HEAP32[(12)>>2]|0; //@line 23706 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 23706 "c/sqlite3.c"
 $spec$select23 = $3 ? 7500 : 7536; //@line 23706 "c/sqlite3.c"
 $4 = $3 ? (72) : (74); //@line 23715 "c/sqlite3.c"
 HEAP32[(84)>>2] = $4; //@line 23715 "c/sqlite3.c"
 $5 = ((($spec$select23)) + 4|0); //@line 23716 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 23716 "c/sqlite3.c"
 HEAP32[(88)>>2] = $6; //@line 23716 "c/sqlite3.c"
 $7 = ((($spec$select23)) + 12|0); //@line 23717 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 23717 "c/sqlite3.c"
 HEAP32[(96)>>2] = $8; //@line 23717 "c/sqlite3.c"
 $9 = ((($spec$select23)) + 16|0); //@line 23718 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 23718 "c/sqlite3.c"
 HEAP32[(100)>>2] = $10; //@line 23718 "c/sqlite3.c"
 $11 = ((($spec$select23)) + 20|0); //@line 23719 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 23719 "c/sqlite3.c"
 HEAP32[(104)>>2] = $12; //@line 23719 "c/sqlite3.c"
 $13 = ((($spec$select23)) + 24|0); //@line 23720 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 23720 "c/sqlite3.c"
 HEAP32[(108)>>2] = $14; //@line 23720 "c/sqlite3.c"
 $15 = ((($spec$select23)) + 28|0); //@line 23721 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 23721 "c/sqlite3.c"
 HEAP32[(112)>>2] = $16; //@line 23721 "c/sqlite3.c"
 $17 = ((($spec$select23)) + 32|0); //@line 23722 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 23722 "c/sqlite3.c"
 HEAP32[(116)>>2] = $18; //@line 23722 "c/sqlite3.c"
 _sqlite3MemoryBarrier(); //@line 23723 "c/sqlite3.c"
 $19 = ((($spec$select23)) + 8|0); //@line 23724 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 23724 "c/sqlite3.c"
 HEAP32[(92)>>2] = $20; //@line 23724 "c/sqlite3.c"
 $21 = HEAP32[(84)>>2]|0; //@line 23727 "c/sqlite3.c"
 $22 = (FUNCTION_TABLE_i[$21 & 127]()|0); //@line 23727 "c/sqlite3.c"
 return ($22|0); //@line 23733 "c/sqlite3.c"
}
function _sqlite3MutexAlloc($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(12)>>2]|0; //@line 23766 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 23766 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 23772 "c/sqlite3.c"
 }
 $3 = HEAP32[(92)>>2]|0; //@line 23771 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_ii[$3 & 255]($0)|0); //@line 23771 "c/sqlite3.c"
 $$0 = $4;
 return ($$0|0); //@line 23772 "c/sqlite3.c"
}
function _sqlite3MallocInit() {
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[(52)>>2]|0; //@line 25252 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 25252 "c/sqlite3.c"
 if ($1) {
  _sqlite3MemSetDefault(); //@line 25253 "c/sqlite3.c"
 }
 ;HEAP32[40080>>2]=0|0;HEAP32[40080+4>>2]=0|0;HEAP32[40080+8>>2]=0|0;HEAP32[40080+12>>2]=0|0;HEAP32[40080+16>>2]=0|0;HEAP32[40080+20>>2]=0|0; //@line 25255 "c/sqlite3.c"
 $2 = (_sqlite3MutexAlloc(3)|0); //@line 25256 "c/sqlite3.c"
 HEAP32[10020] = $2; //@line 25256 "c/sqlite3.c"
 $3 = HEAP32[(208)>>2]|0; //@line 25257 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 25257 "c/sqlite3.c"
 $5 = HEAP32[(212)>>2]|0; //@line 25257 "c/sqlite3.c"
 $6 = ($5|0)<(512); //@line 25257 "c/sqlite3.c"
 $or$cond = $4 | $6; //@line 25257 "c/sqlite3.c"
 $7 = HEAP32[(216)>>2]|0; //@line 25258 "c/sqlite3.c"
 $8 = ($7|0)<(1); //@line 25258 "c/sqlite3.c"
 $or$cond3 = $or$cond | $8; //@line 25257 "c/sqlite3.c"
 if ($or$cond3) {
  HEAP32[(208)>>2] = 0; //@line 25259 "c/sqlite3.c"
  HEAP32[(212)>>2] = 0; //@line 25260 "c/sqlite3.c"
 }
 $9 = HEAP32[(72)>>2]|0; //@line 25262 "c/sqlite3.c"
 $10 = HEAP32[(80)>>2]|0; //@line 25262 "c/sqlite3.c"
 $11 = (FUNCTION_TABLE_ii[$9 & 255]($10)|0); //@line 25262 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 25263 "c/sqlite3.c"
 if ($12) {
  return ($11|0); //@line 25264 "c/sqlite3.c"
 }
 ;HEAP32[40080>>2]=0|0;HEAP32[40080+4>>2]=0|0;HEAP32[40080+8>>2]=0|0;HEAP32[40080+12>>2]=0|0;HEAP32[40080+16>>2]=0|0;HEAP32[40080+20>>2]=0|0; //@line 25263 "c/sqlite3.c"
 return ($11|0); //@line 25264 "c/sqlite3.c"
}
function _sqlite3RegisterBuiltinFunctions() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3AlterFunctions(); //@line 109387 "c/sqlite3.c"
 _sqlite3RegisterDateTimeFunctions(); //@line 109392 "c/sqlite3.c"
 _sqlite3InsertBuiltinFuncs(2140,59); //@line 109393 "c/sqlite3.c"
 return; //@line 109410 "c/sqlite3.c"
}
function _sqlite3PcacheInitialize() {
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[(128)>>2]|0; //@line 45437 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 45437 "c/sqlite3.c"
 if ($1) {
  _sqlite3PCacheSetDefault(); //@line 45441 "c/sqlite3.c"
 }
 $2 = HEAP32[(128)>>2]|0; //@line 45443 "c/sqlite3.c"
 $3 = HEAP32[(124)>>2]|0; //@line 45443 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_ii[$2 & 255]($3)|0); //@line 45443 "c/sqlite3.c"
 return ($4|0); //@line 45443 "c/sqlite3.c"
}
function _sqlite3OsInit() {
 var $$0 = 0, $0 = 0, $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_sqlite3_malloc(10)|0); //@line 21129 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 21130 "c/sqlite3.c"
 if ($1) {
  $$0 = 7;
  return ($$0|0); //@line 21133 "c/sqlite3.c"
 }
 _sqlite3_free($0); //@line 21131 "c/sqlite3.c"
 (_sqlite3_os_init()|0); //@line 21132 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 21133 "c/sqlite3.c"
}
function _sqlite3PCacheBufferSetup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$019 = 0, $$118 = 0, $$op = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $scevgep = 0;
 var $spec$select17 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[(40240)>>2]|0; //@line 46304 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 46304 "c/sqlite3.c"
 if ($4) {
  return; //@line 46323 "c/sqlite3.c"
 }
 $5 = ($0|0)==(0|0); //@line 46306 "c/sqlite3.c"
 $spec$select17 = $5 ? 0 : $2; //@line 46306 "c/sqlite3.c"
 $6 = ($spec$select17|0)==(0); //@line 46307 "c/sqlite3.c"
 $7 = $5 | $6; //@line 46307 "c/sqlite3.c"
 $$op = $1 & -8; //@line 46308 "c/sqlite3.c"
 $8 = $7 ? 0 : $$op; //@line 46308 "c/sqlite3.c"
 HEAP32[(40252)>>2] = $8; //@line 46309 "c/sqlite3.c"
 HEAP32[(40280)>>2] = $spec$select17; //@line 46310 "c/sqlite3.c"
 HEAP32[(40256)>>2] = $spec$select17; //@line 46310 "c/sqlite3.c"
 $9 = ($spec$select17|0)>(90); //@line 46311 "c/sqlite3.c"
 if ($9) {
  HEAP32[(40260)>>2] = 10; //@line 46311 "c/sqlite3.c"
  HEAP32[(40264)>>2] = $0; //@line 46312 "c/sqlite3.c"
  HEAP32[(40276)>>2] = 0; //@line 46313 "c/sqlite3.c"
  HEAP32[(40284)>>2] = 0; //@line 46314 "c/sqlite3.c"
  label = 5;
 } else {
  $10 = (($spec$select17|0) / 10)&-1; //@line 46311 "c/sqlite3.c"
  $11 = (($10) + 1)|0; //@line 46311 "c/sqlite3.c"
  HEAP32[(40260)>>2] = $11; //@line 46311 "c/sqlite3.c"
  HEAP32[(40264)>>2] = $0; //@line 46312 "c/sqlite3.c"
  HEAP32[(40276)>>2] = 0; //@line 46313 "c/sqlite3.c"
  HEAP32[(40284)>>2] = 0; //@line 46314 "c/sqlite3.c"
  $12 = ($spec$select17|0)==(0); //@line 46315 "c/sqlite3.c"
  if ($12) {
   $$0$lcssa = $0;
  } else {
   label = 5;
  }
 }
 if ((label|0) == 5) {
  $13 = Math_imul($spec$select17, $8)|0; //@line 46315 "c/sqlite3.c"
  $$019 = $0;$$118 = $spec$select17;
  while(1) {
   $14 = (($$118) + -1)|0; //@line 46315 "c/sqlite3.c"
   $15 = HEAP32[(40276)>>2]|0; //@line 46317 "c/sqlite3.c"
   HEAP32[$$019>>2] = $15; //@line 46317 "c/sqlite3.c"
   HEAP32[(40276)>>2] = $$019; //@line 46318 "c/sqlite3.c"
   $16 = (($$019) + ($8)|0); //@line 46319 "c/sqlite3.c"
   $17 = ($14|0)==(0); //@line 46315 "c/sqlite3.c"
   if ($17) {
    break;
   } else {
    $$019 = $16;$$118 = $14;
   }
  }
  $scevgep = (($0) + ($13)|0); //@line 46315 "c/sqlite3.c"
  $$0$lcssa = $scevgep;
 }
 HEAP32[(40268)>>2] = $$0$lcssa; //@line 46321 "c/sqlite3.c"
 return; //@line 46323 "c/sqlite3.c"
}
function _sqlite3_mutex_free($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 23778 "c/sqlite3.c"
 if ($1) {
  return; //@line 23782 "c/sqlite3.c"
 }
 $2 = HEAP32[(96)>>2]|0; //@line 23780 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$2 & 127]($0); //@line 23780 "c/sqlite3.c"
 return; //@line 23782 "c/sqlite3.c"
}
function _sqlite3_malloc($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_initialize()|0); //@line 25396 "c/sqlite3.c"
 $2 = ($1|0)!=(0); //@line 25396 "c/sqlite3.c"
 $3 = ($0|0)<(1); //@line 25398 "c/sqlite3.c"
 $or$cond = $3 | $2; //@line 25396 "c/sqlite3.c"
 if ($or$cond) {
  $$0 = 0;
  return ($$0|0); //@line 25399 "c/sqlite3.c"
 }
 $4 = ($0|0)<(0); //@line 25398 "c/sqlite3.c"
 $5 = $4 << 31 >> 31; //@line 25398 "c/sqlite3.c"
 $6 = (_sqlite3Malloc($0,$5)|0); //@line 25398 "c/sqlite3.c"
 $$0 = $6;
 return ($$0|0); //@line 25399 "c/sqlite3.c"
}
function _sqlite3_os_init() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3_vfs_register(1088,1)|0); //@line 38466 "c/sqlite3.c"
 (_sqlite3_vfs_register((1176),0)|0); //@line 38466 "c/sqlite3.c"
 (_sqlite3_vfs_register((1264),0)|0); //@line 38466 "c/sqlite3.c"
 (_sqlite3_vfs_register((1352),0)|0); //@line 38466 "c/sqlite3.c"
 return 0; //@line 38468 "c/sqlite3.c"
}
function _sqlite3_vfs_register($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$sink = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3_initialize()|0); //@line 21194 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 21195 "c/sqlite3.c"
 if (!($3)) {
  $$0 = $2;
  return ($$0|0); //@line 21214 "c/sqlite3.c"
 }
 $4 = (_sqlite3MutexAlloc(2)|0); //@line 21201 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 21202 "c/sqlite3.c"
 _vfsUnlink($0); //@line 21203 "c/sqlite3.c"
 $5 = ($1|0)!=(0); //@line 21204 "c/sqlite3.c"
 $6 = HEAP32[10095]|0; //@line 21204 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 21204 "c/sqlite3.c"
 $or$cond = $5 | $7; //@line 21204 "c/sqlite3.c"
 if ($or$cond) {
  $8 = ((($0)) + 12|0); //@line 21205 "c/sqlite3.c"
  HEAP32[$8>>2] = $6; //@line 21205 "c/sqlite3.c"
  $$sink = 40380;
 } else {
  $9 = ((($6)) + 12|0); //@line 21208 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 21208 "c/sqlite3.c"
  $11 = ((($0)) + 12|0); //@line 21208 "c/sqlite3.c"
  HEAP32[$11>>2] = $10; //@line 21208 "c/sqlite3.c"
  $$sink = $9;
 }
 HEAP32[$$sink>>2] = $0;
 _sqlite3_mutex_leave($4); //@line 21212 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 21214 "c/sqlite3.c"
}
function _vfsUnlink($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 21171 "c/sqlite3.c"
 if ($1) {
  return; //@line 21184 "c/sqlite3.c"
 }
 $2 = HEAP32[10095]|0; //@line 21173 "c/sqlite3.c"
 $3 = ($2|0)==($0|0); //@line 21173 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 12|0); //@line 21174 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 21174 "c/sqlite3.c"
  HEAP32[10095] = $5; //@line 21174 "c/sqlite3.c"
  return; //@line 21184 "c/sqlite3.c"
 }
 $6 = ($2|0)==(0|0); //@line 21175 "c/sqlite3.c"
 if ($6) {
  return; //@line 21184 "c/sqlite3.c"
 }
 $$0 = $2;
 while(1) {
  $7 = ((($$0)) + 12|0); //@line 21177 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 21177 "c/sqlite3.c"
  $9 = ($8|0)!=(0|0); //@line 21177 "c/sqlite3.c"
  $10 = ($8|0)!=($0|0); //@line 21177 "c/sqlite3.c"
  $spec$select = $10 & $9; //@line 21177 "c/sqlite3.c"
  if ($spec$select) {
   $$0 = $8;
  } else {
   break;
  }
 }
 $11 = ($8|0)==($0|0); //@line 21180 "c/sqlite3.c"
 if (!($11)) {
  return; //@line 21184 "c/sqlite3.c"
 }
 $12 = ((($$0)) + 12|0); //@line 21177 "c/sqlite3.c"
 $13 = ((($0)) + 12|0); //@line 21181 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 21181 "c/sqlite3.c"
 HEAP32[$12>>2] = $14; //@line 21181 "c/sqlite3.c"
 return; //@line 21184 "c/sqlite3.c"
}
function _unixOpen($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0124 = 0, $$0125 = 0, $$0126162 = 0, $$0129 = 0, $$0133160 = 0, $$0140154 = 0, $$1145 = 0, $$2128 = 0, $$2131 = 0, $$2135 = 0, $$3 = 0, $$3132161 = 0, $$3139 = 0, $$3143 = 0, $$3147 = 0, $$5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0;
 var $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $9 = 0, $or$cond3 = 0, $spec$select = 0, $spec$select151 = 0, $switch$split2D = 0, $switch$split42D = 0;
 var dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 528|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(528|0);
 $5 = sp + 12|0;
 $6 = sp + 8|0;
 $7 = sp + 4|0;
 $8 = sp;
 $9 = $3 & -256; //@line 36525 "c/sqlite3.c"
 $10 = $3 & 16; //@line 36530 "c/sqlite3.c"
 $11 = $3 & 8; //@line 36531 "c/sqlite3.c"
 $12 = $3 & 4; //@line 36532 "c/sqlite3.c"
 $13 = $3 & 1; //@line 36533 "c/sqlite3.c"
 $14 = $3 & 2; //@line 36534 "c/sqlite3.c"
 $15 = ($12|0)==(0); //@line 36546 "c/sqlite3.c"
 L1: do {
  if ($15) {
   $77 = 0;
  } else {
   $switch$split2D = ($9|0)<(16384);
   L3: do {
    if ($switch$split2D) {
     switch ($9|0) {
     case 2048:  {
      $77 = 1;
      break L1;
      break;
     }
     default: {
     }
     }
    } else {
     $switch$split42D = ($9|0)<(524288);
     if ($switch$split42D) {
      switch ($9|0) {
      case 16384:  {
       $77 = 1;
       break L1;
       break;
      }
      default: {
       break L3;
      }
      }
     } else {
      switch ($9|0) {
      case 524288:  {
       $77 = 1;
       break L1;
       break;
      }
      default: {
       break L3;
      }
      }
     }
    }
   } while(0);
   $77 = 0;
  }
 } while(0);
 $16 = HEAP32[10096]|0; //@line 36589 "c/sqlite3.c"
 $17 = (_getpid()|0); //@line 36589 "c/sqlite3.c"
 $18 = ($16|0)==($17|0); //@line 36589 "c/sqlite3.c"
 if (!($18)) {
  $19 = (_getpid()|0); //@line 36590 "c/sqlite3.c"
  HEAP32[10096] = $19; //@line 36590 "c/sqlite3.c"
  _sqlite3_randomness(0,0); //@line 36591 "c/sqlite3.c"
 }
 dest=$2; stop=dest+52|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 36594 "c/sqlite3.c"
 $20 = ($9|0)==(256); //@line 36596 "c/sqlite3.c"
 if ($20) {
  $21 = (_findReusableFd($1,$3)|0); //@line 36598 "c/sqlite3.c"
  $22 = ($21|0)==(0|0); //@line 36599 "c/sqlite3.c"
  if ($22) {
   $24 = (_sqlite3_malloc64(12,0)|0); //@line 36602 "c/sqlite3.c"
   $25 = ($24|0)==(0|0); //@line 36603 "c/sqlite3.c"
   if ($25) {
    $$3 = 7;
    STACKTOP = sp;return ($$3|0); //@line 36774 "c/sqlite3.c"
   } else {
    $$0124 = $24;$$0129 = -1;
   }
  } else {
   $23 = HEAP32[$21>>2]|0; //@line 36600 "c/sqlite3.c"
   $$0124 = $21;$$0129 = $23;
  }
  $26 = ((($2)) + 28|0); //@line 36607 "c/sqlite3.c"
  HEAP32[$26>>2] = $$0124; //@line 36607 "c/sqlite3.c"
  $$0125 = $1;$$2131 = $$0129;
 } else {
  $27 = ($1|0)==(0|0); //@line 36614 "c/sqlite3.c"
  if ($27) {
   $28 = ((($0)) + 8|0); //@line 36617 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 36617 "c/sqlite3.c"
   $30 = (_unixGetTempname($29,$5)|0); //@line 36617 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 36618 "c/sqlite3.c"
   if ($31) {
    $$0125 = $5;$$2131 = -1;
   } else {
    $$3 = $30;
    STACKTOP = sp;return ($$3|0); //@line 36774 "c/sqlite3.c"
   }
  } else {
   $$0125 = $1;$$2131 = -1;
  }
 }
 $32 = ($14|0)!=(0); //@line 36633 "c/sqlite3.c"
 $33 = $12 << 4; //@line 36634 "c/sqlite3.c"
 $34 = $33 | $14; //@line 36634 "c/sqlite3.c"
 $35 = ($10|0)==(0); //@line 36635 "c/sqlite3.c"
 $36 = $34 | 131200; //@line 36635 "c/sqlite3.c"
 $$3139 = $35 ? $34 : $36; //@line 36635 "c/sqlite3.c"
 $37 = $$3139 | 32768; //@line 36636 "c/sqlite3.c"
 $38 = ($$2131|0)<(0); //@line 36638 "c/sqlite3.c"
 L25: do {
  if ($38) {
   $39 = (_findCreateFileMode($$0125,$3,$6,$7,$8)|0); //@line 36642 "c/sqlite3.c"
   $40 = ($39|0)==(0); //@line 36643 "c/sqlite3.c"
   if (!($40)) {
    $$3 = $39;
    STACKTOP = sp;return ($$3|0); //@line 36774 "c/sqlite3.c"
   }
   $41 = HEAP32[$6>>2]|0; //@line 36648 "c/sqlite3.c"
   $42 = (_robust_open($$0125,$37,$41)|0); //@line 36648 "c/sqlite3.c"
   $43 = ($42|0)<(0); //@line 36651 "c/sqlite3.c"
   do {
    if ($43) {
     if ($77) {
      $44 = (___errno_location()|0); //@line 36652 "c/sqlite3.c"
      $45 = HEAP32[$44>>2]|0; //@line 36652 "c/sqlite3.c"
      $46 = ($45|0)==(13); //@line 36652 "c/sqlite3.c"
      if ($46) {
       $47 = HEAP32[(1556)>>2]|0; //@line 36652 "c/sqlite3.c"
       $48 = (FUNCTION_TABLE_iii[$47 & 255]($$0125,0)|0); //@line 36652 "c/sqlite3.c"
       $49 = ($48|0)==(0); //@line 36652 "c/sqlite3.c"
       if ($49) {
        label = 20;
       } else {
        $$0140154 = 1544;
       }
      } else {
       label = 20;
      }
     } else {
      label = 20;
     }
     if ((label|0) == 20) {
      $50 = (___errno_location()|0); //@line 36656 "c/sqlite3.c"
      $51 = HEAP32[$50>>2]|0; //@line 36656 "c/sqlite3.c"
      $52 = ($51|0)!=(21); //@line 36656 "c/sqlite3.c"
      $or$cond3 = $32 & $52; //@line 36656 "c/sqlite3.c"
      if ($or$cond3) {
       $53 = $3 & -8; //@line 36658 "c/sqlite3.c"
       $54 = $53 | 1; //@line 36660 "c/sqlite3.c"
       $55 = $37 & -80; //@line 36659 "c/sqlite3.c"
       $56 = (_robust_open($$0125,$55,$41)|0); //@line 36663 "c/sqlite3.c"
       $57 = ($56|0)<(0); //@line 36666 "c/sqlite3.c"
       if ($57) {
        $$0140154 = 0;
       } else {
        $$0126162 = $54;$$0133160 = 1;$$3132161 = $56;
        break;
       }
      } else {
       $$0140154 = 0;
      }
     }
     $62 = (_sqlite3CantopenError(36667)|0); //@line 36667 "c/sqlite3.c"
     $63 = (_unixLogErrorAtLine($62,15483,$$0125,36667)|0); //@line 36667 "c/sqlite3.c"
     $64 = ($$0140154|0)==(0); //@line 36668 "c/sqlite3.c"
     $spec$select = $64 ? $63 : $$0140154; //@line 36668 "c/sqlite3.c"
     $$3143 = $spec$select;
     break L25;
    } else {
     $$0126162 = $3;$$0133160 = $13;$$3132161 = $42;
    }
   } while(0);
   $58 = $$0126162 & 526336; //@line 36676 "c/sqlite3.c"
   $59 = ($58|0)==(0); //@line 36676 "c/sqlite3.c"
   if (!($59)) {
    $60 = HEAP32[$7>>2]|0; //@line 36677 "c/sqlite3.c"
    $61 = HEAP32[$8>>2]|0; //@line 36677 "c/sqlite3.c"
    _robustFchown($$3132161,$60,$61); //@line 36677 "c/sqlite3.c"
   }
   $$2128 = $$0126162;$$2135 = $$0133160;$$5 = $$3132161;
   label = 26;
  } else {
   $$2128 = $3;$$2135 = $13;$$5 = $$2131;
   label = 26;
  }
 } while(0);
 if ((label|0) == 26) {
  $65 = ($4|0)==(0|0); //@line 36681 "c/sqlite3.c"
  if (!($65)) {
   HEAP32[$4>>2] = $$2128; //@line 36682 "c/sqlite3.c"
  }
  $66 = ((($2)) + 28|0); //@line 36685 "c/sqlite3.c"
  $67 = HEAP32[$66>>2]|0; //@line 36685 "c/sqlite3.c"
  $68 = ($67|0)==(0|0); //@line 36685 "c/sqlite3.c"
  if (!($68)) {
   HEAP32[$67>>2] = $$5; //@line 36686 "c/sqlite3.c"
   $69 = ((($67)) + 4|0); //@line 36687 "c/sqlite3.c"
   HEAP32[$69>>2] = $$2128; //@line 36687 "c/sqlite3.c"
  }
  $70 = ($11|0)==(0); //@line 36690 "c/sqlite3.c"
  if (!($70)) {
   $71 = HEAP32[(1724)>>2]|0; //@line 36700 "c/sqlite3.c"
   (FUNCTION_TABLE_ii[$71 & 255]($$0125)|0); //@line 36700 "c/sqlite3.c"
  }
  $72 = $11 << 2; //@line 36724 "c/sqlite3.c"
  $73 = ($$2135|0)==(0); //@line 36725 "c/sqlite3.c"
  $74 = $72 | 2; //@line 36725 "c/sqlite3.c"
  $$1145 = $73 ? $72 : $74; //@line 36725 "c/sqlite3.c"
  $75 = $$1145 | 128; //@line 36727 "c/sqlite3.c"
  $spec$select151 = $20 ? $$1145 : $75; //@line 36727 "c/sqlite3.c"
  $76 = $spec$select151 | 8; //@line 36728 "c/sqlite3.c"
  $$3147 = $77 ? $76 : $spec$select151; //@line 36728 "c/sqlite3.c"
  $78 = $$2128 & 64; //@line 36729 "c/sqlite3.c"
  $79 = $$3147 | $78; //@line 36729 "c/sqlite3.c"
  $80 = (_fillInUnixFile($0,$$5,$2,$1,$79)|0); //@line 36767 "c/sqlite3.c"
  $$3143 = $80;
 }
 $81 = ($$3143|0)==(0); //@line 36770 "c/sqlite3.c"
 if ($81) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 36774 "c/sqlite3.c"
 }
 $82 = ((($2)) + 28|0); //@line 36771 "c/sqlite3.c"
 $83 = HEAP32[$82>>2]|0; //@line 36771 "c/sqlite3.c"
 _sqlite3_free($83); //@line 36771 "c/sqlite3.c"
 $$3 = $$3143;
 STACKTOP = sp;return ($$3|0); //@line 36774 "c/sqlite3.c"
}
function _unixDelete($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$010 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = HEAP32[(1724)>>2]|0; //@line 36789 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_ii[$4 & 255]($1)|0); //@line 36789 "c/sqlite3.c"
 $6 = ($5|0)==(-1); //@line 36789 "c/sqlite3.c"
 if ($6) {
  $7 = (___errno_location()|0); //@line 36790 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 36790 "c/sqlite3.c"
  $9 = ($8|0)==(2); //@line 36790 "c/sqlite3.c"
  if ($9) {
   $$010 = 5898;
   STACKTOP = sp;return ($$010|0); //@line 36817 "c/sqlite3.c"
  }
  (_unixLogErrorAtLine(2570,15587,$1,36797)|0); //@line 36797 "c/sqlite3.c"
  $$010 = 2570;
  STACKTOP = sp;return ($$010|0); //@line 36817 "c/sqlite3.c"
 }
 $10 = $2 & 1; //@line 36802 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 36802 "c/sqlite3.c"
 if ($11) {
  $$010 = 0;
  STACKTOP = sp;return ($$010|0); //@line 36817 "c/sqlite3.c"
 }
 $12 = HEAP32[(1736)>>2]|0; //@line 36804 "c/sqlite3.c"
 $13 = (FUNCTION_TABLE_iii[$12 & 255]($1,$3)|0); //@line 36804 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 36805 "c/sqlite3.c"
 if ($14) {
  $15 = HEAP32[$3>>2]|0; //@line 36806 "c/sqlite3.c"
  $16 = (_full_fsync($15)|0); //@line 36806 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 36806 "c/sqlite3.c"
  if ($17) {
   $$1 = 0;
  } else {
   (_unixLogErrorAtLine(1290,15845,$1,36807)|0); //@line 36807 "c/sqlite3.c"
   $$1 = 1290;
  }
  $18 = HEAP32[$3>>2]|0; //@line 36809 "c/sqlite3.c"
  _robust_close(0,$18,36809); //@line 36809 "c/sqlite3.c"
  $$2 = $$1;
 } else {
  $$2 = 0;
 }
 $$010 = $$2;
 STACKTOP = sp;return ($$010|0); //@line 36817 "c/sqlite3.c"
}
function _unixAccess($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $4 = sp;
 $5 = ($2|0)==(0); //@line 36843 "c/sqlite3.c"
 if ($5) {
  $6 = HEAP32[(1580)>>2]|0; //@line 36845 "c/sqlite3.c"
  $7 = (FUNCTION_TABLE_iii[$6 & 255]($1,$4)|0); //@line 36845 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 36845 "c/sqlite3.c"
  $9 = ((($4)) + 36|0); //@line 36845 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 36845 "c/sqlite3.c"
  $11 = ($10|0)>(0); //@line 36845 "c/sqlite3.c"
  $12 = $8 & $11; //@line 36845 "c/sqlite3.c"
  $13 = $12&1; //@line 36845 "c/sqlite3.c"
  HEAP32[$3>>2] = $13; //@line 36845 "c/sqlite3.c"
  STACKTOP = sp;return 0; //@line 36849 "c/sqlite3.c"
 } else {
  $14 = HEAP32[(1556)>>2]|0; //@line 36847 "c/sqlite3.c"
  $15 = (FUNCTION_TABLE_iii[$14 & 255]($1,6)|0); //@line 36847 "c/sqlite3.c"
  $16 = ($15|0)==(0); //@line 36847 "c/sqlite3.c"
  $17 = $16&1; //@line 36847 "c/sqlite3.c"
  HEAP32[$3>>2] = $17; //@line 36847 "c/sqlite3.c"
  STACKTOP = sp;return 0; //@line 36849 "c/sqlite3.c"
 }
 return (0)|0;
}
function _unixFullPathname($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$061$lcssa = 0, $$06195 = 0, $$063 = 0, $$064 = 0, $$067 = 0, $$165 = 0, $$165$ = 0, $$16879 = 0, $$171 = 0, $$180 = 0, $$2 = 0, $$2$ph = 0, $$269 = 0, $$28792 = 0, $$4 = 0, $$6 = 0, $$6$ph = 0, $$7 = 0, $$793 = 0, $10 = 0;
 var $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $not$ = 0, $or$cond = 0, $or$cond75 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $4 = sp;
 $5 = ((($4)) + 12|0);
 $6 = (($2) + -1)|0;
 $$063 = 0;$$064 = $1;$$067 = 1;
 L1: while(1) {
  $7 = HEAP32[(1856)>>2]|0; //@line 36919 "c/sqlite3.c"
  $8 = (FUNCTION_TABLE_iii[$7 & 255]($$064,$4)|0); //@line 36919 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 36919 "c/sqlite3.c"
  do {
   if ($9) {
    $15 = HEAP32[$5>>2]|0; //@line 36924 "c/sqlite3.c"
    $16 = $15 & 61440; //@line 36924 "c/sqlite3.c"
    $17 = ($16|0)!=(40960); //@line 36924 "c/sqlite3.c"
    if ($17) {
     $$165 = $$064;$$2 = $$063;$$269 = $$067;$$6 = 0;$48 = 1;
    } else {
     $18 = ($$063|0)==(0|0); //@line 36928 "c/sqlite3.c"
     if ($18) {
      $19 = (_sqlite3_malloc($2)|0); //@line 36929 "c/sqlite3.c"
      $20 = ($19|0)==(0|0); //@line 36930 "c/sqlite3.c"
      if ($20) {
       $$2$ph = 0;$$6$ph = 7;
       break L1;
      } else {
       $$16879 = $$067;$$180 = $19;
      }
     } else {
      $21 = (($$067) + 1)|0; //@line 36931 "c/sqlite3.c"
      $22 = ($$067|0)>(99); //@line 36931 "c/sqlite3.c"
      if ($22) {
       $23 = (_sqlite3CantopenError(36932)|0); //@line 36932 "c/sqlite3.c"
       $24 = ($23|0)==(0); //@line 36935 "c/sqlite3.c"
       if ($24) {
        $$16879 = $21;$$180 = $$063;
       } else {
        $$2$ph = $$063;$$6$ph = $23;
        break L1;
       }
      } else {
       $$16879 = $21;$$180 = $$063;
      }
     }
     $25 = HEAP32[(1844)>>2]|0; //@line 36936 "c/sqlite3.c"
     $26 = (FUNCTION_TABLE_iiii[$25 & 127]($$064,$$180,$6)|0); //@line 36936 "c/sqlite3.c"
     $27 = ($26|0)<(0); //@line 36937 "c/sqlite3.c"
     if ($27) {
      $28 = (_sqlite3CantopenError(36938)|0); //@line 36938 "c/sqlite3.c"
      $29 = (_unixLogErrorAtLine($28,15666,$$064,36938)|0); //@line 36938 "c/sqlite3.c"
      $$165 = $$180;$$2 = $$180;$$269 = $$16879;$$6 = $29;$48 = 0;
      break;
     }
     $30 = HEAP8[$$180>>0]|0; //@line 36940 "c/sqlite3.c"
     $31 = ($30<<24>>24)==(47); //@line 36940 "c/sqlite3.c"
     do {
      if ($31) {
       $$171 = $26;$$4 = 0;
      } else {
       $32 = (_sqlite3Strlen30($$064)|0); //@line 36942 "c/sqlite3.c"
       $33 = ($32|0)>(0); //@line 36942 "c/sqlite3.c"
       L16: do {
        if ($33) {
         $$06195 = $32;
         while(1) {
          $35 = (($$06195) + -1)|0; //@line 36942 "c/sqlite3.c"
          $36 = (($$064) + ($35)|0); //@line 36942 "c/sqlite3.c"
          $37 = HEAP8[$36>>0]|0; //@line 36942 "c/sqlite3.c"
          $38 = ($37<<24>>24)==(47); //@line 36942 "c/sqlite3.c"
          if ($38) {
           $$061$lcssa = $$06195;
           break L16;
          }
          $34 = ($$06195|0)>(1); //@line 36942 "c/sqlite3.c"
          if ($34) {
           $$06195 = $35;
          } else {
           $$061$lcssa = $35;
           break;
          }
         }
        } else {
         $$061$lcssa = $32;
        }
       } while(0);
       $39 = (($$061$lcssa) + ($26))|0; //@line 36943 "c/sqlite3.c"
       $40 = ($39|0)<($2|0); //@line 36943 "c/sqlite3.c"
       if ($40) {
        $42 = (($$180) + ($$061$lcssa)|0); //@line 36946 "c/sqlite3.c"
        $43 = (($26) + 1)|0; //@line 36946 "c/sqlite3.c"
        _memmove(($42|0),($$180|0),($43|0))|0; //@line 36946 "c/sqlite3.c"
        _memcpy(($$180|0),($$064|0),($$061$lcssa|0))|0; //@line 36947 "c/sqlite3.c"
        $$171 = $39;$$4 = 0;
        break;
       } else {
        $41 = (_sqlite3CantopenError(36944)|0); //@line 36944 "c/sqlite3.c"
        $$171 = $26;$$4 = $41;
        break;
       }
      }
     } while(0);
     $44 = (($$180) + ($$171)|0); //@line 36951 "c/sqlite3.c"
     HEAP8[$44>>0] = 0; //@line 36951 "c/sqlite3.c"
     $$165 = $$180;$$2 = $$180;$$269 = $$16879;$$6 = $$4;$48 = $17;
    }
   } else {
    $10 = (___errno_location()|0); //@line 36920 "c/sqlite3.c"
    $11 = HEAP32[$10>>2]|0; //@line 36920 "c/sqlite3.c"
    $12 = ($11|0)==(2); //@line 36920 "c/sqlite3.c"
    if ($12) {
     $$165 = $$064;$$2 = $$063;$$269 = $$067;$$6 = 0;$48 = 1;
    } else {
     $13 = (_sqlite3CantopenError(36921)|0); //@line 36921 "c/sqlite3.c"
     $14 = (_unixLogErrorAtLine($13,15675,$$064,36921)|0); //@line 36921 "c/sqlite3.c"
     $$165 = $$064;$$2 = $$063;$$269 = $$067;$$6 = $14;$48 = 1;
    }
   }
  } while(0);
  $45 = ($$6|0)!=(0); //@line 36959 "c/sqlite3.c"
  $46 = ($$165|0)==($3|0); //@line 36959 "c/sqlite3.c"
  $or$cond75 = $45 | $46; //@line 36959 "c/sqlite3.c"
  if ($or$cond75) {
   $$7 = $$6;
  } else {
   $47 = (_mkFullPathname($$165,$3,$2)|0); //@line 36960 "c/sqlite3.c"
   $$7 = $47;
  }
  $$165$ = $48 ? $$165 : $3; //@line 36962 "c/sqlite3.c"
  $not$ = $48 ^ 1; //@line 36962 "c/sqlite3.c"
  $49 = ($$7|0)==(0); //@line 36964 "c/sqlite3.c"
  $or$cond = $49 & $not$;
  if ($or$cond) {
   $$063 = $$2;$$064 = $$165$;$$067 = $$269;
  } else {
   $$28792 = $$2;$$793 = $$7;
   label = 25;
   break;
  }
 }
 if ((label|0) == 25) {
  _sqlite3_free($$28792); //@line 36966 "c/sqlite3.c"
  STACKTOP = sp;return ($$793|0); //@line 36967 "c/sqlite3.c"
 }
 $$28792 = $$2$ph;$$793 = $$6$ph;
 _sqlite3_free($$28792); //@line 36966 "c/sqlite3.c"
 STACKTOP = sp;return ($$793|0); //@line 36967 "c/sqlite3.c"
}
function _unixDlOpen($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_dlopen(($1|0),258)|0); //@line 36980 "c/sqlite3.c"
 return ($2|0); //@line 36980 "c/sqlite3.c"
}
function _unixDlError($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 36990 "c/sqlite3.c"
 _unixEnterMutex(); //@line 36993 "c/sqlite3.c"
 $3 = (_dlerror()|0); //@line 36994 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 36995 "c/sqlite3.c"
 if (!($4)) {
  HEAP32[$vararg_buffer>>2] = $3; //@line 36996 "c/sqlite3.c"
  (_sqlite3_snprintf($1,$2,15687,$vararg_buffer)|0); //@line 36996 "c/sqlite3.c"
 }
 _unixLeaveMutex(); //@line 36998 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 36999 "c/sqlite3.c"
}
function _unixDlSym($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_dlsym(($1|0),($2|0))|0); //@line 37021 "c/sqlite3.c"
 return ($3|0); //@line 37021 "c/sqlite3.c"
}
function _unixDlClose($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_dlclose(($1|0))|0); //@line 37025 "c/sqlite3.c"
 return; //@line 37026 "c/sqlite3.c"
}
function _unixRandomness($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 _memset(($2|0),0,($1|0))|0; //@line 37053 "c/sqlite3.c"
 $4 = (_getpid()|0); //@line 37054 "c/sqlite3.c"
 HEAP32[10096] = $4; //@line 37054 "c/sqlite3.c"
 $5 = (_robust_open(15832,0,0)|0); //@line 37058 "c/sqlite3.c"
 $6 = ($5|0)<(0); //@line 37059 "c/sqlite3.c"
 if ($6) {
  (_time(($3|0))|0); //@line 37061 "c/sqlite3.c"
  $7 = HEAP32[$3>>2]|0; //@line 37062 "c/sqlite3.c"
  HEAP8[$2>>0]=$7&255;HEAP8[$2+1>>0]=($7>>8)&255;HEAP8[$2+2>>0]=($7>>16)&255;HEAP8[$2+3>>0]=$7>>24; //@line 37062 "c/sqlite3.c"
  $8 = ((($2)) + 4|0); //@line 37063 "c/sqlite3.c"
  $9 = HEAP32[10096]|0; //@line 37063 "c/sqlite3.c"
  HEAP8[$8>>0]=$9&255;HEAP8[$8+1>>0]=($9>>8)&255;HEAP8[$8+2>>0]=($9>>16)&255;HEAP8[$8+3>>0]=$9>>24; //@line 37063 "c/sqlite3.c"
  $$0 = 8;
  STACKTOP = sp;return ($$0|0); //@line 37072 "c/sqlite3.c"
 }
 while(1) {
  $10 = HEAP32[(1628)>>2]|0; //@line 37067 "c/sqlite3.c"
  $11 = (FUNCTION_TABLE_iiii[$10 & 127]($5,$2,$1)|0); //@line 37067 "c/sqlite3.c"
  $12 = ($11|0)<(0); //@line 37067 "c/sqlite3.c"
  if (!($12)) {
   break;
  }
  $13 = (___errno_location()|0); //@line 37067 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 37067 "c/sqlite3.c"
  $15 = ($14|0)==(4); //@line 37067 "c/sqlite3.c"
  if (!($15)) {
   break;
  }
 }
 _robust_close(0,$5,37068); //@line 37068 "c/sqlite3.c"
 $$0 = $1;
 STACKTOP = sp;return ($$0|0); //@line 37072 "c/sqlite3.c"
}
function _unixSleep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (($1) + 999999)|0; //@line 37098 "c/sqlite3.c"
 $3 = (($2|0) / 1000000)&-1; //@line 37098 "c/sqlite3.c"
 (_sleep($3)|0); //@line 37099 "c/sqlite3.c"
 $4 = ($3*1000000)|0; //@line 37101 "c/sqlite3.c"
 return ($4|0); //@line 37101 "c/sqlite3.c"
}
function _unixCurrentTime($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = $2; //@line 37157 "c/sqlite3.c"
 $4 = $3; //@line 37157 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 37157 "c/sqlite3.c"
 $5 = (($3) + 4)|0; //@line 37157 "c/sqlite3.c"
 $6 = $5; //@line 37157 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 37157 "c/sqlite3.c"
 (_unixCurrentTimeInt64(0,$2)|0); //@line 37160 "c/sqlite3.c"
 $7 = $2; //@line 37161 "c/sqlite3.c"
 $8 = $7; //@line 37161 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 37161 "c/sqlite3.c"
 $10 = (($7) + 4)|0; //@line 37161 "c/sqlite3.c"
 $11 = $10; //@line 37161 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 37161 "c/sqlite3.c"
 $13 = (+($9>>>0)) + (4294967296.0*(+($12|0))); //@line 37161 "c/sqlite3.c"
 $14 = $13 / 8.64E+7; //@line 37161 "c/sqlite3.c"
 HEAPF64[$1>>3] = $14; //@line 37161 "c/sqlite3.c"
 STACKTOP = sp;return 0; //@line 37162 "c/sqlite3.c"
}
function _unixGetLastError($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (___errno_location()|0); //@line 37178 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 37178 "c/sqlite3.c"
 return ($4|0); //@line 37178 "c/sqlite3.c"
}
function _unixCurrentTimeInt64($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 (_gettimeofday(($2|0),(0|0))|0); //@line 37137 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 37138 "c/sqlite3.c"
 $4 = ($3|0)<(0); //@line 37138 "c/sqlite3.c"
 $5 = $4 << 31 >> 31; //@line 37138 "c/sqlite3.c"
 $6 = (___muldi3(($3|0),($5|0),1000,0)|0); //@line 37138 "c/sqlite3.c"
 $7 = tempRet0; //@line 37138 "c/sqlite3.c"
 $8 = (_i64Add(($6|0),($7|0),1045635584,49096)|0); //@line 37138 "c/sqlite3.c"
 $9 = tempRet0; //@line 37138 "c/sqlite3.c"
 $10 = ((($2)) + 4|0); //@line 37138 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 37138 "c/sqlite3.c"
 $12 = (($11|0) / 1000)&-1; //@line 37138 "c/sqlite3.c"
 $13 = ($12|0)<(0); //@line 37138 "c/sqlite3.c"
 $14 = $13 << 31 >> 31; //@line 37138 "c/sqlite3.c"
 $15 = (_i64Add(($8|0),($9|0),($12|0),($14|0))|0); //@line 37138 "c/sqlite3.c"
 $16 = tempRet0; //@line 37138 "c/sqlite3.c"
 $17 = $1; //@line 37138 "c/sqlite3.c"
 $18 = $17; //@line 37138 "c/sqlite3.c"
 HEAP32[$18>>2] = $15; //@line 37138 "c/sqlite3.c"
 $19 = (($17) + 4)|0; //@line 37138 "c/sqlite3.c"
 $20 = $19; //@line 37138 "c/sqlite3.c"
 HEAP32[$20>>2] = $16; //@line 37138 "c/sqlite3.c"
 STACKTOP = sp;return 0; //@line 37147 "c/sqlite3.c"
}
function _unixSetSystemCall($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$02024 = 0, $$021 = 0, $$125 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 31298 "c/sqlite3.c"
 if ($3) {
  $$02024 = 0;
  while(1) {
   $4 = (((1528 + (($$02024*12)|0)|0)) + 8|0); //@line 31304 "c/sqlite3.c"
   $5 = HEAP32[$4>>2]|0; //@line 31304 "c/sqlite3.c"
   $6 = ($5|0)==(0|0); //@line 31304 "c/sqlite3.c"
   if (!($6)) {
    $7 = (((1528 + (($$02024*12)|0)|0)) + 4|0); //@line 31305 "c/sqlite3.c"
    HEAP32[$7>>2] = $5; //@line 31305 "c/sqlite3.c"
   }
   $8 = (($$02024) + 1)|0; //@line 31303 "c/sqlite3.c"
   $exitcond = ($8|0)==(29); //@line 31303 "c/sqlite3.c"
   if ($exitcond) {
    $$0 = 0;
    break;
   } else {
    $$02024 = $8;
   }
  }
  return ($$0|0); //@line 31324 "c/sqlite3.c"
 }
 $$125 = 0;
 while(1) {
  $9 = (1528 + (($$125*12)|0)|0); //@line 31313 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 31313 "c/sqlite3.c"
  $11 = (_strcmp($1,$10)|0); //@line 31313 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 31313 "c/sqlite3.c"
  if ($12) {
   break;
  }
  $21 = (($$125) + 1)|0; //@line 31312 "c/sqlite3.c"
  $22 = ($21>>>0)<(29); //@line 31312 "c/sqlite3.c"
  if ($22) {
   $$125 = $21;
  } else {
   $$0 = 12;
   label = 14;
   break;
  }
 }
 if ((label|0) == 14) {
  return ($$0|0); //@line 31324 "c/sqlite3.c"
 }
 $13 = (((1528 + (($$125*12)|0)|0)) + 8|0); //@line 31314 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 31314 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 31314 "c/sqlite3.c"
 if ($15) {
  $16 = (((1528 + (($$125*12)|0)|0)) + 4|0); //@line 31315 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 31315 "c/sqlite3.c"
  HEAP32[$13>>2] = $17; //@line 31315 "c/sqlite3.c"
 }
 $18 = ($2|0)==(0|0); //@line 31318 "c/sqlite3.c"
 if ($18) {
  $19 = HEAP32[$13>>2]|0; //@line 31318 "c/sqlite3.c"
  $$021 = $19;
 } else {
  $$021 = $2;
 }
 $20 = (((1528 + (($$125*12)|0)|0)) + 4|0); //@line 31319 "c/sqlite3.c"
 HEAP32[$20>>2] = $$021; //@line 31319 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 31324 "c/sqlite3.c"
}
function _unixGetSystemCall($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$06 = 0, $$08 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$08 = 0;
 while(1) {
  $2 = (1528 + (($$08*12)|0)|0); //@line 31340 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 31340 "c/sqlite3.c"
  $4 = (_strcmp($1,$3)|0); //@line 31340 "c/sqlite3.c"
  $5 = ($4|0)==(0); //@line 31340 "c/sqlite3.c"
  if ($5) {
   break;
  }
  $8 = (($$08) + 1)|0; //@line 31339 "c/sqlite3.c"
  $9 = ($8>>>0)<(29); //@line 31339 "c/sqlite3.c"
  if ($9) {
   $$08 = $8;
  } else {
   $$06 = 0;
   label = 5;
   break;
  }
 }
 if ((label|0) == 5) {
  return ($$06|0); //@line 31343 "c/sqlite3.c"
 }
 $6 = (((1528 + (($$08*12)|0)|0)) + 4|0); //@line 31340 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 31340 "c/sqlite3.c"
 $$06 = $7;
 return ($$06|0); //@line 31343 "c/sqlite3.c"
}
function _unixNextSystemCall($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$011 = 0, $$016 = 0, $$215 = 0, $$215$in = 0, $$215$in$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 31355 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$215$in$ph = -1;
  } else {
   $$016 = 0;
   while(1) {
    $3 = (1528 + (($$016*12)|0)|0); //@line 31357 "c/sqlite3.c"
    $4 = HEAP32[$3>>2]|0; //@line 31357 "c/sqlite3.c"
    $5 = (_strcmp($1,$4)|0); //@line 31357 "c/sqlite3.c"
    $6 = ($5|0)==(0); //@line 31357 "c/sqlite3.c"
    if ($6) {
     $$215$in$ph = $$016;
     break L1;
    }
    $7 = (($$016) + 1)|0; //@line 31356 "c/sqlite3.c"
    $8 = ($7>>>0)<(28); //@line 31356 "c/sqlite3.c"
    if ($8) {
     $$016 = $7;
    } else {
     $$011 = 0;
     break;
    }
   }
   return ($$011|0); //@line 31364 "c/sqlite3.c"
  }
 } while(0);
 $$215$in = $$215$in$ph;
 while(1) {
  $$215 = (($$215$in) + 1)|0;
  $10 = (((1528 + (($$215*12)|0)|0)) + 4|0); //@line 31361 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 31361 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 31361 "c/sqlite3.c"
  if (!($12)) {
   break;
  }
  $9 = ($$215$in|0)<(27); //@line 31360 "c/sqlite3.c"
  if ($9) {
   $$215$in = $$215;
  } else {
   $$011 = 0;
   label = 9;
   break;
  }
 }
 if ((label|0) == 9) {
  return ($$011|0); //@line 31364 "c/sqlite3.c"
 }
 $13 = (1528 + (($$215*12)|0)|0); //@line 31361 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 31361 "c/sqlite3.c"
 $$011 = $14;
 return ($$011|0); //@line 31364 "c/sqlite3.c"
}
function _dotlockIoFinderImpl($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (1452|0); //@line 35884 "c/sqlite3.c"
}
function _dotlockClose($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 (_dotlockUnlock($0,0)|0); //@line 32987 "c/sqlite3.c"
 $1 = ((($0)) + 24|0); //@line 32988 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 32988 "c/sqlite3.c"
 _sqlite3_free($2); //@line 32988 "c/sqlite3.c"
 _closeUnixFile($0); //@line 32989 "c/sqlite3.c"
 return 0; //@line 32989 "c/sqlite3.c"
}
function _unixRead($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_seekAndRead($0,$3,$4,$1,$2)|0); //@line 33979 "c/sqlite3.c"
 $6 = ($5|0)==($2|0); //@line 33980 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;
 } else {
  $7 = ($5|0)<(0); //@line 33982 "c/sqlite3.c"
  if ($7) {
   $$0 = 266;
  } else {
   $8 = (($2) - ($5))|0; //@line 33988 "c/sqlite3.c"
   $9 = (($1) + ($5)|0); //@line 33988 "c/sqlite3.c"
   _storeLastErrno($0,0); //@line 33986 "c/sqlite3.c"
   _memset(($9|0),0,($8|0))|0; //@line 33988 "c/sqlite3.c"
   $$0 = 522;
  }
 }
 return ($$0|0); //@line 33991 "c/sqlite3.c"
}
function _unixWrite($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$02226 = 0, $$02325 = 0, $$lcssa = 0, $$lcssa24 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_seekAndWrite($0,$3,$4,$1,$2)|0); //@line 34114 "c/sqlite3.c"
 $6 = ($5|0)<($2|0); //@line 34114 "c/sqlite3.c"
 $7 = ($5|0)>(0); //@line 34114 "c/sqlite3.c"
 $8 = $6 & $7; //@line 34114 "c/sqlite3.c"
 if ($8) {
  $$02226 = $2;$$02325 = $1;$10 = $5;$13 = $3;$14 = $4;
  while(1) {
   $9 = (($$02226) - ($10))|0; //@line 34115 "c/sqlite3.c"
   $11 = ($10|0)<(0); //@line 34116 "c/sqlite3.c"
   $12 = $11 << 31 >> 31; //@line 34116 "c/sqlite3.c"
   $15 = (_i64Add(($13|0),($14|0),($10|0),($12|0))|0); //@line 34116 "c/sqlite3.c"
   $16 = tempRet0; //@line 34116 "c/sqlite3.c"
   $17 = (($$02325) + ($10)|0); //@line 34117 "c/sqlite3.c"
   $18 = (_seekAndWrite($0,$15,$16,$17,$9)|0); //@line 34114 "c/sqlite3.c"
   $19 = ($9|0)>($18|0); //@line 34114 "c/sqlite3.c"
   $20 = ($18|0)>(0); //@line 34114 "c/sqlite3.c"
   $21 = $19 & $20; //@line 34114 "c/sqlite3.c"
   if ($21) {
    $$02226 = $9;$$02325 = $17;$10 = $18;$13 = $15;$14 = $16;
   } else {
    $$lcssa = $19;$$lcssa24 = $18;
    break;
   }
  }
 } else {
  $$lcssa = $6;$$lcssa24 = $5;
 }
 if (!($$lcssa)) {
  $$0 = 0;
  return ($$0|0); //@line 34133 "c/sqlite3.c"
 }
 $22 = ($$lcssa24|0)<(0); //@line 34123 "c/sqlite3.c"
 if ($22) {
  $23 = ((($0)) + 20|0); //@line 34123 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 34123 "c/sqlite3.c"
  $25 = ($24|0)==(28); //@line 34123 "c/sqlite3.c"
  if (!($25)) {
   $$0 = 778;
   return ($$0|0); //@line 34133 "c/sqlite3.c"
  }
 }
 _storeLastErrno($0,0); //@line 34127 "c/sqlite3.c"
 $$0 = 13;
 return ($$0|0); //@line 34133 "c/sqlite3.c"
}
function _unixTruncate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 40|0); //@line 34384 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 34384 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 34384 "c/sqlite3.c"
 $6 = ($4|0)<(0); //@line 34385 "c/sqlite3.c"
 $7 = $6 << 31 >> 31; //@line 34385 "c/sqlite3.c"
 $8 = (_i64Add(($1|0),($2|0),-1,-1)|0); //@line 34385 "c/sqlite3.c"
 $9 = tempRet0; //@line 34385 "c/sqlite3.c"
 $10 = (_i64Add(($8|0),($9|0),($4|0),($7|0))|0); //@line 34385 "c/sqlite3.c"
 $11 = tempRet0; //@line 34385 "c/sqlite3.c"
 if ($5) {
  $12 = (___remdi3(($10|0),($11|0),($4|0),($7|0))|0); //@line 34385 "c/sqlite3.c"
  $13 = tempRet0; //@line 34385 "c/sqlite3.c"
  $14 = (_i64Subtract(($10|0),($11|0),($12|0),($13|0))|0); //@line 34385 "c/sqlite3.c"
  $15 = tempRet0; //@line 34385 "c/sqlite3.c"
  $18 = $14;$19 = $15;
 } else {
  $18 = $1;$19 = $2;
 }
 $16 = ((($0)) + 12|0); //@line 34388 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 34388 "c/sqlite3.c"
 $20 = (_robust_ftruncate($17,$18,$19)|0); //@line 34388 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 34389 "c/sqlite3.c"
 if ($21) {
  $$0 = 0;
  return ($$0|0); //@line 34418 "c/sqlite3.c"
 }
 $22 = (___errno_location()|0); //@line 34390 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 34390 "c/sqlite3.c"
 _storeLastErrno($0,$23); //@line 34390 "c/sqlite3.c"
 $24 = ((($0)) + 32|0); //@line 34391 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 34391 "c/sqlite3.c"
 (_unixLogErrorAtLine(1546,15513,$25,34391)|0); //@line 34391 "c/sqlite3.c"
 $$0 = 1546;
 return ($$0|0); //@line 34418 "c/sqlite3.c"
}
function _unixSync($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 12|0); //@line 34342 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 34342 "c/sqlite3.c"
 $5 = (_full_fsync($4)|0); //@line 34342 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 34344 "c/sqlite3.c"
 if (!($6)) {
  $7 = (___errno_location()|0); //@line 34345 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 34345 "c/sqlite3.c"
  _storeLastErrno($0,$8); //@line 34345 "c/sqlite3.c"
  $9 = ((($0)) + 32|0); //@line 34346 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 34346 "c/sqlite3.c"
  (_unixLogErrorAtLine(1034,15821,$10,34346)|0); //@line 34346 "c/sqlite3.c"
  $$0 = 1034;
  STACKTOP = sp;return ($$0|0); //@line 34368 "c/sqlite3.c"
 }
 $11 = ((($0)) + 18|0); //@line 34353 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 34353 "c/sqlite3.c"
 $13 = $12 & 8; //@line 34353 "c/sqlite3.c"
 $14 = ($13<<16>>16)==(0); //@line 34353 "c/sqlite3.c"
 if ($14) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 34368 "c/sqlite3.c"
 }
 $15 = HEAP32[(1736)>>2]|0; //@line 34357 "c/sqlite3.c"
 $16 = ((($0)) + 32|0); //@line 34357 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 34357 "c/sqlite3.c"
 $18 = (FUNCTION_TABLE_iii[$15 & 255]($17,$2)|0); //@line 34357 "c/sqlite3.c"
 $19 = ($18|0)==(0); //@line 34358 "c/sqlite3.c"
 if ($19) {
  $20 = HEAP32[$2>>2]|0; //@line 34359 "c/sqlite3.c"
  (_full_fsync($20)|0); //@line 34359 "c/sqlite3.c"
  $21 = HEAP32[$2>>2]|0; //@line 34360 "c/sqlite3.c"
  _robust_close($0,$21,34360); //@line 34360 "c/sqlite3.c"
 }
 $22 = HEAP16[$11>>1]|0; //@line 34365 "c/sqlite3.c"
 $23 = $22 & -9; //@line 34365 "c/sqlite3.c"
 HEAP16[$11>>1] = $23; //@line 34365 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 34368 "c/sqlite3.c"
}
function _unixFileSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $2 = sp;
 $3 = HEAP32[(1592)>>2]|0; //@line 34427 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 34427 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 34427 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iii[$3 & 255]($5,$2)|0); //@line 34427 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 34429 "c/sqlite3.c"
 if ($7) {
  $10 = ((($2)) + 36|0); //@line 34433 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 34433 "c/sqlite3.c"
  $12 = ($11|0)<(0); //@line 34433 "c/sqlite3.c"
  $13 = $12 << 31 >> 31; //@line 34433 "c/sqlite3.c"
  $14 = ($11|0)==(1); //@line 34441 "c/sqlite3.c"
  $15 = $14 ? 0 : $11; //@line 34441 "c/sqlite3.c"
  $16 = $14 ? 0 : $13; //@line 34441 "c/sqlite3.c"
  $17 = $1;
  $18 = $17;
  HEAP32[$18>>2] = $15;
  $19 = (($17) + 4)|0;
  $20 = $19;
  HEAP32[$20>>2] = $16;
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 34445 "c/sqlite3.c"
 } else {
  $8 = (___errno_location()|0); //@line 34430 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 34430 "c/sqlite3.c"
  _storeLastErrno($0,$9); //@line 34430 "c/sqlite3.c"
  $$0 = 1802;
  STACKTOP = sp;return ($$0|0); //@line 34445 "c/sqlite3.c"
 }
 return (0)|0;
}
function _dotlockLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 32893 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 32893 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 32900 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 32900 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 32900 "c/sqlite3.c"
 if (!($6)) {
  $7 = $1&255; //@line 32901 "c/sqlite3.c"
  HEAP8[$4>>0] = $7; //@line 32901 "c/sqlite3.c"
  (_utimes(($3|0),(0|0))|0); //@line 32906 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 32930 "c/sqlite3.c"
 }
 $8 = HEAP32[(1748)>>2]|0; //@line 32912 "c/sqlite3.c"
 $9 = (FUNCTION_TABLE_iii[$8 & 255]($3,511)|0); //@line 32912 "c/sqlite3.c"
 $10 = ($9|0)<(0); //@line 32913 "c/sqlite3.c"
 if (!($10)) {
  $16 = $1&255; //@line 32928 "c/sqlite3.c"
  HEAP8[$4>>0] = $16; //@line 32928 "c/sqlite3.c"
  $$0 = $9;
  return ($$0|0); //@line 32930 "c/sqlite3.c"
 }
 $11 = (___errno_location()|0); //@line 32915 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 32915 "c/sqlite3.c"
 $13 = ($12|0)==(17); //@line 32916 "c/sqlite3.c"
 if ($13) {
  $$0 = 5;
  return ($$0|0); //@line 32930 "c/sqlite3.c"
 }
 $14 = (_sqliteErrorFromPosixError($12)|0); //@line 32919 "c/sqlite3.c"
 $15 = ($14|0)==(5); //@line 32920 "c/sqlite3.c"
 if ($15) {
  $$0 = 5;
  return ($$0|0); //@line 32930 "c/sqlite3.c"
 }
 _storeLastErrno($0,$12); //@line 32921 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 32930 "c/sqlite3.c"
}
function _dotlockUnlock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 32943 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 32943 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 32952 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 32952 "c/sqlite3.c"
 $6 = $5&255; //@line 32952 "c/sqlite3.c"
 $7 = ($6|0)==($1|0); //@line 32952 "c/sqlite3.c"
 do {
  if ($7) {
   $$0 = 0;
  } else {
   $8 = ($1|0)==(1); //@line 32959 "c/sqlite3.c"
   if ($8) {
    HEAP8[$4>>0] = 1; //@line 32960 "c/sqlite3.c"
    $$0 = 0;
    break;
   }
   $9 = HEAP32[(1760)>>2]|0; //@line 32966 "c/sqlite3.c"
   $10 = (FUNCTION_TABLE_ii[$9 & 255]($3)|0); //@line 32966 "c/sqlite3.c"
   $11 = ($10|0)<(0); //@line 32967 "c/sqlite3.c"
   if (!($11)) {
    HEAP8[$4>>0] = 0; //@line 32977 "c/sqlite3.c"
    $$0 = 0;
    break;
   }
   $12 = (___errno_location()|0); //@line 32968 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 32968 "c/sqlite3.c"
   $14 = ($13|0)==(2); //@line 32969 "c/sqlite3.c"
   if ($14) {
    $$0 = 0;
   } else {
    _storeLastErrno($0,$13); //@line 32973 "c/sqlite3.c"
    $$0 = 2058;
   }
  }
 } while(0);
 return ($$0|0); //@line 32979 "c/sqlite3.c"
}
function _dotlockCheckReservedLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[(1556)>>2]|0; //@line 32858 "c/sqlite3.c"
 $3 = ((($0)) + 24|0); //@line 32858 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 32858 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iii[$2 & 255]($4,0)|0); //@line 32858 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 32858 "c/sqlite3.c"
 $7 = $6&1; //@line 32858 "c/sqlite3.c"
 HEAP32[$1>>2] = $7; //@line 32860 "c/sqlite3.c"
 return 0; //@line 32861 "c/sqlite3.c"
}
function _unixFileControl($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 34546 "c/sqlite3.c"
 switch ($1|0) {
 case 1:  {
  $3 = ((($0)) + 16|0); //@line 34565 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 34565 "c/sqlite3.c"
  $5 = $4&255; //@line 34565 "c/sqlite3.c"
  HEAP32[$2>>2] = $5; //@line 34565 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 4:  {
  $6 = ((($0)) + 20|0); //@line 34569 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 34569 "c/sqlite3.c"
  HEAP32[$2>>2] = $7; //@line 34569 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 6:  {
  $8 = HEAP32[$2>>2]|0; //@line 34573 "c/sqlite3.c"
  $9 = ((($0)) + 40|0); //@line 34573 "c/sqlite3.c"
  HEAP32[$9>>2] = $8; //@line 34573 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 5:  {
  $10 = $2; //@line 34579 "c/sqlite3.c"
  $11 = $10; //@line 34579 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 34579 "c/sqlite3.c"
  $13 = (($10) + 4)|0; //@line 34579 "c/sqlite3.c"
  $14 = $13; //@line 34579 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 34579 "c/sqlite3.c"
  $16 = (_fcntlSizeHint($0,$12,$15)|0); //@line 34579 "c/sqlite3.c"
  $$0 = $16;
  break;
 }
 case 10:  {
  _unixModeBit($0,4,$2); //@line 34584 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 13:  {
  _unixModeBit($0,16,$2); //@line 34588 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 12:  {
  $17 = ((($0)) + 4|0); //@line 34592 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 34592 "c/sqlite3.c"
  $19 = ((($18)) + 16|0); //@line 34592 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 34592 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $20; //@line 34592 "c/sqlite3.c"
  $21 = (_sqlite3_mprintf(15687,$vararg_buffer)|0); //@line 34592 "c/sqlite3.c"
  HEAP32[$2>>2] = $21; //@line 34592 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 16:  {
  $22 = ((($0)) + 4|0); //@line 34596 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 34596 "c/sqlite3.c"
  $24 = ((($23)) + 8|0); //@line 34596 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 34596 "c/sqlite3.c"
  $26 = ($25|0)<(0); //@line 34596 "c/sqlite3.c"
  $27 = $26 << 31 >> 31; //@line 34596 "c/sqlite3.c"
  $28 = (_sqlite3_malloc64($25,$27)|0); //@line 34596 "c/sqlite3.c"
  $29 = ($28|0)==(0|0); //@line 34597 "c/sqlite3.c"
  if ($29) {
   $$0 = 0;
  } else {
   $30 = HEAP32[$22>>2]|0; //@line 34598 "c/sqlite3.c"
   $31 = ((($30)) + 8|0); //@line 34598 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 34598 "c/sqlite3.c"
   (_unixGetTempname($32,$28)|0); //@line 34598 "c/sqlite3.c"
   HEAP32[$2>>2] = $28; //@line 34599 "c/sqlite3.c"
   $$0 = 0;
  }
  break;
 }
 case 20:  {
  $33 = (_fileHasMoved($0)|0); //@line 34604 "c/sqlite3.c"
  HEAP32[$2>>2] = $33; //@line 34604 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 default: {
  $$0 = 12;
 }
 }
 STACKTOP = sp;return ($$0|0); //@line 34652 "c/sqlite3.c"
}
function _unixSectorSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _setDeviceCharacteristics($0); //@line 34773 "c/sqlite3.c"
 $1 = ((($0)) + 44|0); //@line 34774 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 34774 "c/sqlite3.c"
 return ($2|0); //@line 34774 "c/sqlite3.c"
}
function _unixDeviceCharacteristics($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _setDeviceCharacteristics($0); //@line 34792 "c/sqlite3.c"
 $1 = ((($0)) + 48|0); //@line 34793 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 34793 "c/sqlite3.c"
 return ($2|0); //@line 34793 "c/sqlite3.c"
}
function _unixShmLock($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$lcssa = 0, $$072$lcssa = 0, $$07295 = 0, $$073 = 0, $$07394 = 0, $$07396 = 0, $$089 = 0, $$1 = 0, $$174 = 0, $$17490 = 0, $$2 = 0, $$286 = 0, $$287 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 36|0); //@line 35400 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 35400 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 35402 "c/sqlite3.c"
 $7 = (($2) + ($1))|0; //@line 35418 "c/sqlite3.c"
 $8 = 1 << $7; //@line 35418 "c/sqlite3.c"
 $9 = 1 << $1; //@line 35418 "c/sqlite3.c"
 $10 = (($8) - ($9))|0; //@line 35418 "c/sqlite3.c"
 $11 = ((($6)) + 4|0); //@line 35420 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 35420 "c/sqlite3.c"
 _sqlite3_mutex_enter($12); //@line 35420 "c/sqlite3.c"
 $13 = $3 & 1; //@line 35421 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 35421 "c/sqlite3.c"
 L1: do {
  if ($14) {
   $41 = $3 & 4; //@line 35443 "c/sqlite3.c"
   $42 = ($41|0)==(0); //@line 35443 "c/sqlite3.c"
   $43 = ((($6)) + 32|0);
   $$286 = HEAP32[$43>>2]|0;
   $44 = ($$286|0)==(0|0);
   if ($42) {
    if (!($44)) {
     $$287 = $$286;
     while(1) {
      $68 = ((($$287)) + 12|0); //@line 35476 "c/sqlite3.c"
      $69 = HEAP16[$68>>1]|0; //@line 35476 "c/sqlite3.c"
      $70 = $69&65535; //@line 35476 "c/sqlite3.c"
      $71 = $10 & $70; //@line 35476 "c/sqlite3.c"
      $72 = ($71|0)==(0); //@line 35476 "c/sqlite3.c"
      if (!($72)) {
       $$4 = 5;
       break L1;
      }
      $73 = ((($$287)) + 10|0); //@line 35476 "c/sqlite3.c"
      $74 = HEAP16[$73>>1]|0; //@line 35476 "c/sqlite3.c"
      $75 = $74&65535; //@line 35476 "c/sqlite3.c"
      $76 = $10 & $75; //@line 35476 "c/sqlite3.c"
      $77 = ($76|0)==(0); //@line 35476 "c/sqlite3.c"
      if (!($77)) {
       $$4 = 5;
       break L1;
      }
      $66 = ((($$287)) + 4|0); //@line 35475 "c/sqlite3.c"
      $$2 = HEAP32[$66>>2]|0;
      $67 = ($$2|0)==(0|0); //@line 35475 "c/sqlite3.c"
      if ($67) {
       break;
      } else {
       $$287 = $$2;
      }
     }
    }
    $78 = (($1) + 120)|0; //@line 35486 "c/sqlite3.c"
    $79 = (_unixShmSystemLock($0,1,$78,$2)|0); //@line 35486 "c/sqlite3.c"
    $80 = ($79|0)==(0); //@line 35487 "c/sqlite3.c"
    if (!($80)) {
     $$4 = $79;
     break;
    }
    $81 = ((($5)) + 12|0); //@line 35489 "c/sqlite3.c"
    $82 = HEAP16[$81>>1]|0; //@line 35489 "c/sqlite3.c"
    $83 = $82&65535; //@line 35489 "c/sqlite3.c"
    $84 = $10 | $83; //@line 35489 "c/sqlite3.c"
    $85 = $84&65535; //@line 35489 "c/sqlite3.c"
    HEAP16[$81>>1] = $85; //@line 35489 "c/sqlite3.c"
    $$4 = 0;
    break;
   } else {
    if ($44) {
     $$0$lcssa = 0;
    } else {
     $$089 = 0;$$17490 = $$286;
     while(1) {
      $45 = ((($$17490)) + 12|0); //@line 35451 "c/sqlite3.c"
      $46 = HEAP16[$45>>1]|0; //@line 35451 "c/sqlite3.c"
      $47 = $46&65535; //@line 35451 "c/sqlite3.c"
      $48 = $10 & $47; //@line 35451 "c/sqlite3.c"
      $49 = ($48|0)==(0); //@line 35451 "c/sqlite3.c"
      if (!($49)) {
       $$4 = 5;
       break L1;
      }
      $50 = ((($$17490)) + 10|0); //@line 35455 "c/sqlite3.c"
      $51 = HEAP16[$50>>1]|0; //@line 35455 "c/sqlite3.c"
      $52 = $51 | $$089; //@line 35455 "c/sqlite3.c"
      $53 = ((($$17490)) + 4|0); //@line 35450 "c/sqlite3.c"
      $$174 = HEAP32[$53>>2]|0;
      $54 = ($$174|0)==(0|0); //@line 35450 "c/sqlite3.c"
      if ($54) {
       $$0$lcssa = $52;
       break;
      } else {
       $$089 = $52;$$17490 = $$174;
      }
     }
    }
    $55 = $$0$lcssa&65535; //@line 35460 "c/sqlite3.c"
    $56 = $10 & $55; //@line 35460 "c/sqlite3.c"
    $57 = ($56|0)==(0); //@line 35460 "c/sqlite3.c"
    if ($57) {
     $58 = (($1) + 120)|0; //@line 35461 "c/sqlite3.c"
     $59 = (_unixShmSystemLock($0,0,$58,$2)|0); //@line 35461 "c/sqlite3.c"
     $60 = ($59|0)==(0); //@line 35468 "c/sqlite3.c"
     if (!($60)) {
      $$4 = $59;
      break;
     }
    }
    $61 = ((($5)) + 10|0); //@line 35469 "c/sqlite3.c"
    $62 = HEAP16[$61>>1]|0; //@line 35469 "c/sqlite3.c"
    $63 = $62&65535; //@line 35469 "c/sqlite3.c"
    $64 = $10 | $63; //@line 35469 "c/sqlite3.c"
    $65 = $64&65535; //@line 35469 "c/sqlite3.c"
    HEAP16[$61>>1] = $65; //@line 35469 "c/sqlite3.c"
    $$4 = 0;
    break;
   }
  } else {
   $15 = ((($6)) + 32|0); //@line 35425 "c/sqlite3.c"
   $$07394 = HEAP32[$15>>2]|0;
   $16 = ($$07394|0)==(0|0); //@line 35425 "c/sqlite3.c"
   if ($16) {
    $$072$lcssa = 0;
   } else {
    $$07295 = 0;$$07396 = $$07394;
    while(1) {
     $17 = ($$07396|0)==($5|0); //@line 35426 "c/sqlite3.c"
     if ($17) {
      $$1 = $$07295;
     } else {
      $18 = ((($$07396)) + 10|0); //@line 35428 "c/sqlite3.c"
      $19 = HEAP16[$18>>1]|0; //@line 35428 "c/sqlite3.c"
      $20 = $19 | $$07295; //@line 35428 "c/sqlite3.c"
      $$1 = $20;
     }
     $21 = ((($$07396)) + 4|0); //@line 35425 "c/sqlite3.c"
     $$073 = HEAP32[$21>>2]|0;
     $22 = ($$073|0)==(0|0); //@line 35425 "c/sqlite3.c"
     if ($22) {
      $$072$lcssa = $$1;
      break;
     } else {
      $$07295 = $$1;$$07396 = $$073;
     }
    }
   }
   $23 = $10 & 65535; //@line 35432 "c/sqlite3.c"
   $24 = $$072$lcssa&65535; //@line 35432 "c/sqlite3.c"
   $25 = $10 & $24; //@line 35432 "c/sqlite3.c"
   $26 = ($25|0)==(0); //@line 35432 "c/sqlite3.c"
   if ($26) {
    $27 = (($1) + 120)|0; //@line 35433 "c/sqlite3.c"
    $28 = (_unixShmSystemLock($0,2,$27,$2)|0); //@line 35433 "c/sqlite3.c"
    $29 = ($28|0)==(0); //@line 35439 "c/sqlite3.c"
    if (!($29)) {
     $$4 = $28;
     break;
    }
   }
   $30 = $23 ^ -1; //@line 35440 "c/sqlite3.c"
   $31 = ((($5)) + 12|0); //@line 35440 "c/sqlite3.c"
   $32 = HEAP16[$31>>1]|0; //@line 35440 "c/sqlite3.c"
   $33 = $32&65535; //@line 35440 "c/sqlite3.c"
   $34 = $33 & $30; //@line 35440 "c/sqlite3.c"
   $35 = $34&65535; //@line 35440 "c/sqlite3.c"
   HEAP16[$31>>1] = $35; //@line 35440 "c/sqlite3.c"
   $36 = ((($5)) + 10|0); //@line 35441 "c/sqlite3.c"
   $37 = HEAP16[$36>>1]|0; //@line 35441 "c/sqlite3.c"
   $38 = $37&65535; //@line 35441 "c/sqlite3.c"
   $39 = $38 & $30; //@line 35441 "c/sqlite3.c"
   $40 = $39&65535; //@line 35441 "c/sqlite3.c"
   HEAP16[$36>>1] = $40; //@line 35441 "c/sqlite3.c"
   $$4 = 0;
  }
 } while(0);
 $86 = HEAP32[$11>>2]|0; //@line 35493 "c/sqlite3.c"
 _sqlite3_mutex_leave($86); //@line 35493 "c/sqlite3.c"
 return ($$4|0); //@line 35496 "c/sqlite3.c"
}
function _unixShmBarrier($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3MemoryBarrier(); //@line 35509 "c/sqlite3.c"
 _unixEnterMutex(); //@line 35510 "c/sqlite3.c"
 _unixLeaveMutex(); //@line 35511 "c/sqlite3.c"
 return; //@line 35512 "c/sqlite3.c"
}
function _unixShmUnmap($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$027 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 36|0); //@line 35531 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 35531 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 35532 "c/sqlite3.c"
 if ($4) {
  return 0; //@line 35563 "c/sqlite3.c"
 }
 $5 = HEAP32[$3>>2]|0; //@line 35533 "c/sqlite3.c"
 $6 = ((($5)) + 4|0); //@line 35540 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 35540 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 35540 "c/sqlite3.c"
 $8 = ((($5)) + 32|0); //@line 35541 "c/sqlite3.c"
 $$027 = $8;
 while(1) {
  $9 = HEAP32[$$027>>2]|0; //@line 35541 "c/sqlite3.c"
  $10 = ($9|0)==($3|0); //@line 35541 "c/sqlite3.c"
  $11 = ((($9)) + 4|0); //@line 35541 "c/sqlite3.c"
  if ($10) {
   break;
  } else {
   $$027 = $11;
  }
 }
 $12 = ((($3)) + 4|0); //@line 35542 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 35542 "c/sqlite3.c"
 HEAP32[$$027>>2] = $13; //@line 35542 "c/sqlite3.c"
 _sqlite3_free($3); //@line 35545 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 35546 "c/sqlite3.c"
 $14 = HEAP32[$6>>2]|0; //@line 35547 "c/sqlite3.c"
 _sqlite3_mutex_leave($14); //@line 35547 "c/sqlite3.c"
 _unixEnterMutex(); //@line 35551 "c/sqlite3.c"
 $15 = ((($5)) + 28|0); //@line 35553 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 35553 "c/sqlite3.c"
 $17 = (($16) + -1)|0; //@line 35553 "c/sqlite3.c"
 HEAP32[$15>>2] = $17; //@line 35553 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 35554 "c/sqlite3.c"
 if ($18) {
  $19 = ($1|0)==(0); //@line 35555 "c/sqlite3.c"
  if (!($19)) {
   $20 = ((($5)) + 12|0); //@line 35555 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 35555 "c/sqlite3.c"
   $22 = ($21|0)>(-1); //@line 35555 "c/sqlite3.c"
   if ($22) {
    $23 = HEAP32[(1724)>>2]|0; //@line 35556 "c/sqlite3.c"
    $24 = ((($5)) + 8|0); //@line 35556 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 35556 "c/sqlite3.c"
    (FUNCTION_TABLE_ii[$23 & 255]($25)|0); //@line 35556 "c/sqlite3.c"
   }
  }
  _unixShmPurge($0); //@line 35558 "c/sqlite3.c"
 }
 _unixLeaveMutex(); //@line 35560 "c/sqlite3.c"
 return 0; //@line 35563 "c/sqlite3.c"
}
function _unixFetch($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$4>>2] = 0; //@line 35735 "c/sqlite3.c"
 return 0; //@line 35749 "c/sqlite3.c"
}
function _unixUnfetch($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 35787 "c/sqlite3.c"
}
function _unixEnterMutex() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_sqlite3MutexAlloc(11)|0); //@line 31444 "c/sqlite3.c"
 _sqlite3_mutex_enter($0); //@line 31444 "c/sqlite3.c"
 return; //@line 31445 "c/sqlite3.c"
}
function _unixShmPurge($0) {
 $0 = $0|0;
 var $$024 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 34994 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 34994 "c/sqlite3.c"
 $3 = ((($2)) + 28|0); //@line 34994 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 34994 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 34996 "c/sqlite3.c"
 if ($5) {
  return; //@line 35016 "c/sqlite3.c"
 }
 $6 = ((($4)) + 28|0); //@line 34996 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 34996 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 34996 "c/sqlite3.c"
 if (!($8)) {
  return; //@line 35016 "c/sqlite3.c"
 }
 $9 = (_unixShmRegionPerMap()|0); //@line 34997 "c/sqlite3.c"
 $10 = ((($4)) + 4|0); //@line 35000 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 35000 "c/sqlite3.c"
 _sqlite3_mutex_free($11); //@line 35000 "c/sqlite3.c"
 $12 = ((($4)) + 20|0); //@line 35001 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 35001 "c/sqlite3.c"
 $14 = ($13<<16>>16)==(0); //@line 35001 "c/sqlite3.c"
 if (!($14)) {
  $15 = ((($4)) + 12|0);
  $16 = ((($4)) + 24|0);
  $17 = ((($4)) + 16|0);
  $18 = ((($4)) + 24|0);
  $$024 = 0;
  while(1) {
   $19 = HEAP32[$15>>2]|0; //@line 35002 "c/sqlite3.c"
   $20 = ($19|0)>(-1); //@line 35002 "c/sqlite3.c"
   if ($20) {
    $21 = HEAP32[(1808)>>2]|0; //@line 35003 "c/sqlite3.c"
    $22 = HEAP32[$16>>2]|0; //@line 35003 "c/sqlite3.c"
    $23 = (($22) + ($$024<<2)|0); //@line 35003 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 35003 "c/sqlite3.c"
    $25 = HEAP32[$17>>2]|0; //@line 35003 "c/sqlite3.c"
    (FUNCTION_TABLE_iii[$21 & 255]($24,$25)|0); //@line 35003 "c/sqlite3.c"
   } else {
    $26 = HEAP32[$18>>2]|0; //@line 35005 "c/sqlite3.c"
    $27 = (($26) + ($$024<<2)|0); //@line 35005 "c/sqlite3.c"
    $28 = HEAP32[$27>>2]|0; //@line 35005 "c/sqlite3.c"
    _sqlite3_free($28); //@line 35005 "c/sqlite3.c"
   }
   $29 = (($$024) + ($9))|0; //@line 35001 "c/sqlite3.c"
   $30 = HEAP16[$12>>1]|0; //@line 35001 "c/sqlite3.c"
   $31 = $30&65535; //@line 35001 "c/sqlite3.c"
   $32 = ($29|0)<($31|0); //@line 35001 "c/sqlite3.c"
   if ($32) {
    $$024 = $29;
   } else {
    break;
   }
  }
 }
 $33 = ((($4)) + 24|0); //@line 35008 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 35008 "c/sqlite3.c"
 _sqlite3_free($34); //@line 35008 "c/sqlite3.c"
 $35 = ((($4)) + 12|0); //@line 35009 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 35009 "c/sqlite3.c"
 $37 = ($36|0)>(-1); //@line 35009 "c/sqlite3.c"
 if ($37) {
  _robust_close($0,$36,35010); //@line 35010 "c/sqlite3.c"
  HEAP32[$35>>2] = -1; //@line 35011 "c/sqlite3.c"
 }
 $38 = HEAP32[$4>>2]|0; //@line 35013 "c/sqlite3.c"
 $39 = ((($38)) + 28|0); //@line 35013 "c/sqlite3.c"
 HEAP32[$39>>2] = 0; //@line 35013 "c/sqlite3.c"
 _sqlite3_free($4); //@line 35014 "c/sqlite3.c"
 return; //@line 35016 "c/sqlite3.c"
}
function _unixLeaveMutex() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_sqlite3MutexAlloc(11)|0); //@line 31447 "c/sqlite3.c"
 _sqlite3_mutex_leave($0); //@line 31447 "c/sqlite3.c"
 return; //@line 31448 "c/sqlite3.c"
}
function _unixShmRegionPerMap() {
 var $$0 = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[(1832)>>2]|0; //@line 34981 "c/sqlite3.c"
 $1 = (FUNCTION_TABLE_i[$0 & 127]()|0); //@line 34981 "c/sqlite3.c"
 $2 = ($1|0)<(32768); //@line 34983 "c/sqlite3.c"
 $3 = (($1|0) / 32768)&-1; //@line 34984 "c/sqlite3.c"
 $$0 = $2 ? 1 : $3; //@line 34983 "c/sqlite3.c"
 return ($$0|0); //@line 34985 "c/sqlite3.c"
}
function _robust_close($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[(1544)>>2]|0; //@line 31957 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_ii[$3 & 255]($1)|0); //@line 31957 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 31957 "c/sqlite3.c"
 if ($5) {
  return; //@line 31961 "c/sqlite3.c"
 }
 $6 = ($0|0)==(0|0); //@line 31959 "c/sqlite3.c"
 if ($6) {
  $9 = 0;
 } else {
  $7 = ((($0)) + 32|0); //@line 31959 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 31959 "c/sqlite3.c"
  $9 = $8;
 }
 (_unixLogErrorAtLine(4106,15446,$9,$2)|0); //@line 31958 "c/sqlite3.c"
 return; //@line 31961 "c/sqlite3.c"
}
function _unixLogErrorAtLine($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp; //@line 31892 "c/sqlite3.c"
 $4 = (___errno_location()|0); //@line 31898 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 31898 "c/sqlite3.c"
 $6 = ($2|0)==(0|0); //@line 31934 "c/sqlite3.c"
 $spec$select = $6 ? 41388 : $2; //@line 31934 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $3; //@line 31935 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 31935 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $5; //@line 31935 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 31935 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $1; //@line 31935 "c/sqlite3.c"
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 31935 "c/sqlite3.c"
 HEAP32[$vararg_ptr3>>2] = $spec$select; //@line 31935 "c/sqlite3.c"
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0); //@line 31935 "c/sqlite3.c"
 HEAP32[$vararg_ptr4>>2] = 41388; //@line 31935 "c/sqlite3.c"
 _sqlite3_log($0,15452,$vararg_buffer); //@line 31935 "c/sqlite3.c"
 STACKTOP = sp;return ($0|0); //@line 31940 "c/sqlite3.c"
}
function _posixOpen($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 31096 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 31097 "c/sqlite3.c"
 $3 = (_open($0,$1,$vararg_buffer)|0); //@line 31097 "c/sqlite3.c"
 STACKTOP = sp;return ($3|0); //@line 31097 "c/sqlite3.c"
}
function _openDirectory($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$013 = 0, $$015 = 0, $$sink19 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 528|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(528|0);
 $vararg_buffer = sp;
 $2 = sp + 4|0;
 HEAP32[$vararg_buffer>>2] = $0; //@line 34291 "c/sqlite3.c"
 (_sqlite3_snprintf(512,$2,15687,$vararg_buffer)|0); //@line 34291 "c/sqlite3.c"
 $3 = (_strlen($2)|0); //@line 34292 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 34292 "c/sqlite3.c"
 L1: do {
  if ($4) {
   $$015 = $3;
   while(1) {
    $7 = (($2) + ($$015)|0); //@line 34292 "c/sqlite3.c"
    $8 = HEAP8[$7>>0]|0; //@line 34292 "c/sqlite3.c"
    $9 = ($8<<24>>24)==(47); //@line 34292 "c/sqlite3.c"
    if ($9) {
     $$sink19 = $$015;
     break L1;
    }
    $5 = (($$015) + -1)|0; //@line 34292 "c/sqlite3.c"
    $6 = ($$015|0)>(1); //@line 34292 "c/sqlite3.c"
    if ($6) {
     $$015 = $5;
    } else {
     label = 5;
     break;
    }
   }
  } else {
   label = 5;
  }
 } while(0);
 if ((label|0) == 5) {
  $10 = HEAP8[$2>>0]|0; //@line 34296 "c/sqlite3.c"
  $11 = ($10<<24>>24)==(47); //@line 34296 "c/sqlite3.c"
  if ($11) {
   $$sink19 = 1;
  } else {
   HEAP8[$2>>0] = 46; //@line 34296 "c/sqlite3.c"
   $$sink19 = 1;
  }
 }
 $12 = (($2) + ($$sink19)|0);
 HEAP8[$12>>0] = 0;
 $13 = (_robust_open($2,0,0)|0); //@line 34299 "c/sqlite3.c"
 HEAP32[$1>>2] = $13; //@line 34303 "c/sqlite3.c"
 $14 = ($13|0)>(-1); //@line 34304 "c/sqlite3.c"
 if ($14) {
  $$013 = 0;
  STACKTOP = sp;return ($$013|0); //@line 34306 "c/sqlite3.c"
 }
 $15 = (_sqlite3CantopenError(34305)|0); //@line 34305 "c/sqlite3.c"
 $16 = (_unixLogErrorAtLine($15,15594,$2,34305)|0); //@line 34305 "c/sqlite3.c"
 $$013 = $16;
 STACKTOP = sp;return ($$013|0); //@line 34306 "c/sqlite3.c"
}
function _unixGetpagesize() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_sysconf(30)|0); //@line 34810 "c/sqlite3.c"
 return ($0|0); //@line 34810 "c/sqlite3.c"
}
function _sqlite3_snprintf($0,$1,$2,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $varargs = $varargs|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 HEAP32[$3>>2] = $varargs; //@line 26896 "c/sqlite3.c"
 $4 = (_sqlite3_vsnprintf($0,$1,$2,$3)|0); //@line 26897 "c/sqlite3.c"
 STACKTOP = sp;return ($4|0); //@line 26899 "c/sqlite3.c"
}
function _robust_open($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$023 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $vararg_buffer = sp;
 $3 = sp + 8|0;
 $4 = ($2|0)!=(0); //@line 31394 "c/sqlite3.c"
 $5 = $4 ? $2 : 420; //@line 31394 "c/sqlite3.c"
 $6 = $1 | 524288;
 while(1) {
  $7 = HEAP32[(1532)>>2]|0; //@line 31397 "c/sqlite3.c"
  $8 = (FUNCTION_TABLE_iiii[$7 & 127]($0,$6,$5)|0); //@line 31397 "c/sqlite3.c"
  $9 = ($8|0)<(0); //@line 31401 "c/sqlite3.c"
  if ($9) {
   $10 = (___errno_location()|0); //@line 31402 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 31402 "c/sqlite3.c"
   $12 = ($11|0)==(4); //@line 31402 "c/sqlite3.c"
   if (!($12)) {
    $$023 = $8;
    label = 13;
    break;
   }
  } else {
   $13 = ($8|0)>(2); //@line 31405 "c/sqlite3.c"
   if ($13) {
    label = 7;
    break;
   }
   $14 = HEAP32[(1544)>>2]|0; //@line 31406 "c/sqlite3.c"
   (FUNCTION_TABLE_ii[$14 & 255]($8)|0); //@line 31406 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $0; //@line 31407 "c/sqlite3.c"
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 31407 "c/sqlite3.c"
   HEAP32[$vararg_ptr1>>2] = $8; //@line 31407 "c/sqlite3.c"
   _sqlite3_log(28,15707,$vararg_buffer); //@line 31407 "c/sqlite3.c"
   $15 = HEAP32[(1532)>>2]|0; //@line 31410 "c/sqlite3.c"
   $16 = (FUNCTION_TABLE_iiii[$15 & 127](15750,$1,$2)|0); //@line 31410 "c/sqlite3.c"
   $17 = ($16|0)<(0); //@line 31410 "c/sqlite3.c"
   if ($17) {
    $$023 = -1;
    label = 13;
    break;
   }
  }
 }
 if ((label|0) == 7) {
  if (!($4)) {
   $$023 = $8;
   STACKTOP = sp;return ($$023|0); //@line 31426 "c/sqlite3.c"
  }
  $18 = HEAP32[(1592)>>2]|0; //@line 31415 "c/sqlite3.c"
  $19 = (FUNCTION_TABLE_iii[$18 & 255]($8,$3)|0); //@line 31415 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 31415 "c/sqlite3.c"
  if ($20) {
   $21 = ((($3)) + 36|0); //@line 31416 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 31416 "c/sqlite3.c"
   $23 = ($22|0)==(0); //@line 31416 "c/sqlite3.c"
   if ($23) {
    $24 = ((($3)) + 12|0); //@line 31417 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 31417 "c/sqlite3.c"
    $26 = $25 & 511; //@line 31417 "c/sqlite3.c"
    $27 = ($26|0)==($2|0); //@line 31417 "c/sqlite3.c"
    if (!($27)) {
     $28 = HEAP32[(1700)>>2]|0; //@line 31419 "c/sqlite3.c"
     (FUNCTION_TABLE_iii[$28 & 255]($8,$2)|0); //@line 31419 "c/sqlite3.c"
    }
   }
  }
  $$023 = $8;
  STACKTOP = sp;return ($$023|0); //@line 31426 "c/sqlite3.c"
 }
 else if ((label|0) == 13) {
  STACKTOP = sp;return ($$023|0); //@line 31426 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3CantopenError($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3ReportError(14,$0,15690)|0); //@line 146737 "c/sqlite3.c"
 return 14; //@line 146737 "c/sqlite3.c"
}
function _sqlite3_vsnprintf($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp;
 $5 = ($0|0)<(1); //@line 26880 "c/sqlite3.c"
 if ($5) {
  STACKTOP = sp;return ($1|0); //@line 26892 "c/sqlite3.c"
 }
 _sqlite3StrAccumInit($4,0,$1,$0,0); //@line 26888 "c/sqlite3.c"
 _sqlite3VXPrintf($4,$2,$3); //@line 26889 "c/sqlite3.c"
 $6 = ((($4)) + 16|0); //@line 26890 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 26890 "c/sqlite3.c"
 $8 = (($1) + ($7)|0); //@line 26890 "c/sqlite3.c"
 HEAP8[$8>>0] = 0; //@line 26890 "c/sqlite3.c"
 STACKTOP = sp;return ($1|0); //@line 26892 "c/sqlite3.c"
}
function _sqlite3MemoryBarrier() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 24154 "c/sqlite3.c"
}
function _unixShmSystemLock($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $4 = sp + 8|0;
 $5 = ((($0)) + 8|0); //@line 34911 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 34911 "c/sqlite3.c"
 $7 = ((($6)) + 28|0); //@line 34911 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 34911 "c/sqlite3.c"
 $9 = ((($8)) + 12|0); //@line 34920 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 34920 "c/sqlite3.c"
 $11 = ($10|0)>(-1); //@line 34920 "c/sqlite3.c"
 if (!($11)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 34967 "c/sqlite3.c"
 }
 $12 = ((($4)) + 12|0);
 HEAP32[$12>>2] = 0; //@line 34922 "c/sqlite3.c"
 $13 = $1&65535; //@line 34923 "c/sqlite3.c"
 HEAP16[$4>>1] = $13; //@line 34923 "c/sqlite3.c"
 $14 = ((($4)) + 2|0); //@line 34924 "c/sqlite3.c"
 HEAP16[$14>>1] = 0; //@line 34924 "c/sqlite3.c"
 $15 = ((($4)) + 4|0); //@line 34925 "c/sqlite3.c"
 HEAP32[$15>>2] = $2; //@line 34925 "c/sqlite3.c"
 $16 = ((($4)) + 8|0); //@line 34926 "c/sqlite3.c"
 HEAP32[$16>>2] = $3; //@line 34926 "c/sqlite3.c"
 $17 = HEAP32[(1616)>>2]|0; //@line 34928 "c/sqlite3.c"
 $18 = HEAP32[$9>>2]|0; //@line 34928 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $4; //@line 34928 "c/sqlite3.c"
 $19 = (FUNCTION_TABLE_iiii[$17 & 127]($18,13,$vararg_buffer)|0); //@line 34928 "c/sqlite3.c"
 $20 = ($19|0)==(-1); //@line 34929 "c/sqlite3.c"
 $21 = $20 ? 5 : 0; //@line 34929 "c/sqlite3.c"
 $$0 = $21;
 STACKTOP = sp;return ($$0|0); //@line 34967 "c/sqlite3.c"
}
function _setDeviceCharacteristics($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 44|0); //@line 34666 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 34666 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 34666 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 34685 "c/sqlite3.c"
 }
 $4 = ((($0)) + 18|0); //@line 34679 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 34679 "c/sqlite3.c"
 $6 = $5 & 16; //@line 34679 "c/sqlite3.c"
 $7 = ($6<<16>>16)==(0); //@line 34679 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($0)) + 48|0); //@line 34680 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 34680 "c/sqlite3.c"
  $10 = $9 | 4096; //@line 34680 "c/sqlite3.c"
  HEAP32[$8>>2] = $10; //@line 34680 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = 4096; //@line 34683 "c/sqlite3.c"
 return; //@line 34685 "c/sqlite3.c"
}
function _fcntlSizeHint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $3 = sp;
 $4 = ((($0)) + 40|0); //@line 34462 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 34462 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 34462 "c/sqlite3.c"
 if (!($6)) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 34522 "c/sqlite3.c"
 }
 $7 = HEAP32[(1592)>>2]|0; //@line 34466 "c/sqlite3.c"
 $8 = ((($0)) + 12|0); //@line 34466 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 34466 "c/sqlite3.c"
 $10 = (FUNCTION_TABLE_iii[$7 & 255]($9,$3)|0); //@line 34466 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 34466 "c/sqlite3.c"
 L4: do {
  if ($11) {
   $12 = HEAP32[$4>>2]|0; //@line 34470 "c/sqlite3.c"
   $13 = ($12|0)<(0); //@line 34470 "c/sqlite3.c"
   $14 = $13 << 31 >> 31; //@line 34470 "c/sqlite3.c"
   $15 = (_i64Add(($1|0),($2|0),-1,-1)|0); //@line 34470 "c/sqlite3.c"
   $16 = tempRet0; //@line 34470 "c/sqlite3.c"
   $17 = (_i64Add(($15|0),($16|0),($12|0),($14|0))|0); //@line 34470 "c/sqlite3.c"
   $18 = tempRet0; //@line 34470 "c/sqlite3.c"
   $19 = (___remdi3(($17|0),($18|0),($12|0),($14|0))|0); //@line 34470 "c/sqlite3.c"
   $20 = tempRet0; //@line 34470 "c/sqlite3.c"
   $21 = (_i64Subtract(($17|0),($18|0),($19|0),($20|0))|0); //@line 34470 "c/sqlite3.c"
   $22 = tempRet0; //@line 34470 "c/sqlite3.c"
   $23 = ((($3)) + 36|0); //@line 34471 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 34471 "c/sqlite3.c"
   $25 = ($24|0)<(0); //@line 34471 "c/sqlite3.c"
   $26 = $25 << 31 >> 31; //@line 34471 "c/sqlite3.c"
   $27 = ($22|0)>($26|0); //@line 34471 "c/sqlite3.c"
   $28 = ($21>>>0)>($24>>>0); //@line 34471 "c/sqlite3.c"
   $29 = ($22|0)==($26|0); //@line 34471 "c/sqlite3.c"
   $30 = $29 & $28; //@line 34471 "c/sqlite3.c"
   $31 = $27 | $30; //@line 34471 "c/sqlite3.c"
   if ($31) {
    $32 = ((($3)) + 40|0); //@line 34490 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 34490 "c/sqlite3.c"
    $34 = (($24|0) % ($33|0))&-1; //@line 34494 "c/sqlite3.c"
    $35 = (($24) + -1)|0; //@line 34494 "c/sqlite3.c"
    $36 = (($35) + ($33))|0; //@line 34494 "c/sqlite3.c"
    $37 = (($36) - ($34))|0; //@line 34494 "c/sqlite3.c"
    $38 = ($37|0)<(0); //@line 34494 "c/sqlite3.c"
    $39 = $38 << 31 >> 31; //@line 34494 "c/sqlite3.c"
    $40 = ($33|0)<(0); //@line 34497 "c/sqlite3.c"
    $41 = $40 << 31 >> 31; //@line 34497 "c/sqlite3.c"
    $42 = (_i64Add(($21|0),($22|0),-1,-1)|0); //@line 34497 "c/sqlite3.c"
    $43 = tempRet0; //@line 34497 "c/sqlite3.c"
    $44 = (_i64Add(($42|0),($43|0),($33|0),($41|0))|0); //@line 34497 "c/sqlite3.c"
    $45 = tempRet0; //@line 34497 "c/sqlite3.c"
    $46 = ($45|0)>($39|0); //@line 34497 "c/sqlite3.c"
    $47 = ($44>>>0)>($37>>>0); //@line 34497 "c/sqlite3.c"
    $48 = ($45|0)==($39|0); //@line 34497 "c/sqlite3.c"
    $49 = $48 & $47; //@line 34497 "c/sqlite3.c"
    $50 = $46 | $49; //@line 34497 "c/sqlite3.c"
    if ($50) {
     $51 = (_i64Add(($21|0),($22|0),-1,-1)|0);
     $52 = tempRet0;
     $61 = $39;$63 = $37;
     while(1) {
      $60 = ($61|0)<($22|0); //@line 34498 "c/sqlite3.c"
      $62 = ($63>>>0)<($21>>>0); //@line 34498 "c/sqlite3.c"
      $64 = ($61|0)==($22|0); //@line 34498 "c/sqlite3.c"
      $65 = $64 & $62; //@line 34498 "c/sqlite3.c"
      $66 = $60 | $65; //@line 34498 "c/sqlite3.c"
      $67 = $66 ? $63 : $51; //@line 34498 "c/sqlite3.c"
      $68 = $66 ? $61 : $52; //@line 34498 "c/sqlite3.c"
      $69 = (_seekAndWrite($0,$67,$68,41388,1)|0); //@line 34499 "c/sqlite3.c"
      $70 = ($69|0)==(1); //@line 34500 "c/sqlite3.c"
      $56 = (_i64Add(($67|0),($68|0),($33|0),($41|0))|0); //@line 34497 "c/sqlite3.c"
      $54 = tempRet0; //@line 34497 "c/sqlite3.c"
      if (!($70)) {
       $$2 = 778;
       break L4;
      }
      $53 = ($54|0)<($45|0); //@line 34497 "c/sqlite3.c"
      $55 = ($56>>>0)<($44>>>0); //@line 34497 "c/sqlite3.c"
      $57 = ($54|0)==($45|0); //@line 34497 "c/sqlite3.c"
      $58 = $57 & $55; //@line 34497 "c/sqlite3.c"
      $59 = $53 | $58; //@line 34497 "c/sqlite3.c"
      if ($59) {
       $61 = $54;$63 = $56;
      } else {
       break;
      }
     }
    }
   }
   $$3 = 0;
   STACKTOP = sp;return ($$3|0); //@line 34522 "c/sqlite3.c"
  } else {
   $$2 = 1802;
  }
 } while(0);
 $$3 = $$2;
 STACKTOP = sp;return ($$3|0); //@line 34522 "c/sqlite3.c"
}
function _unixModeBit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 34531 "c/sqlite3.c"
 $4 = ($3|0)<(0); //@line 34531 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 18|0); //@line 34532 "c/sqlite3.c"
  $6 = HEAP16[$5>>1]|0; //@line 34532 "c/sqlite3.c"
  $7 = $6&65535; //@line 34532 "c/sqlite3.c"
  $8 = $1&255; //@line 34532 "c/sqlite3.c"
  $9 = $7 & $8; //@line 34532 "c/sqlite3.c"
  $10 = ($9|0)!=(0); //@line 34532 "c/sqlite3.c"
  $11 = $10&1; //@line 34532 "c/sqlite3.c"
  HEAP32[$2>>2] = $11; //@line 34532 "c/sqlite3.c"
  return; //@line 34538 "c/sqlite3.c"
 }
 $12 = ($3|0)==(0); //@line 34533 "c/sqlite3.c"
 $13 = $1&255;
 if ($12) {
  $14 = $13 ^ 65535; //@line 34534 "c/sqlite3.c"
  $15 = ((($0)) + 18|0); //@line 34534 "c/sqlite3.c"
  $16 = HEAP16[$15>>1]|0; //@line 34534 "c/sqlite3.c"
  $17 = $16&65535; //@line 34534 "c/sqlite3.c"
  $18 = $14 & $17; //@line 34534 "c/sqlite3.c"
  $19 = $18&65535; //@line 34534 "c/sqlite3.c"
  HEAP16[$15>>1] = $19; //@line 34534 "c/sqlite3.c"
  return; //@line 34538 "c/sqlite3.c"
 } else {
  $20 = ((($0)) + 18|0); //@line 34536 "c/sqlite3.c"
  $21 = HEAP16[$20>>1]|0; //@line 34536 "c/sqlite3.c"
  $22 = $21&65535; //@line 34536 "c/sqlite3.c"
  $23 = $22 | $13; //@line 34536 "c/sqlite3.c"
  $24 = $23&65535; //@line 34536 "c/sqlite3.c"
  HEAP16[$20>>1] = $24; //@line 34536 "c/sqlite3.c"
  return; //@line 34538 "c/sqlite3.c"
 }
}
function _sqlite3_mprintf($0,$varargs) {
 $0 = $0|0;
 $varargs = $varargs|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = (_sqlite3_initialize()|0); //@line 26857 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 26857 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 26863 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = $varargs; //@line 26859 "c/sqlite3.c"
 $4 = (_sqlite3_vmprintf($0,$1)|0); //@line 26860 "c/sqlite3.c"
 $$0 = $4;
 STACKTOP = sp;return ($$0|0); //@line 26863 "c/sqlite3.c"
}
function _sqlite3_malloc64($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3_initialize()|0); //@line 25402 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 25402 "c/sqlite3.c"
 if ($3) {
  $4 = (_sqlite3Malloc($0,$1)|0); //@line 25404 "c/sqlite3.c"
  $$0 = $4;
 } else {
  $$0 = 0;
 }
 return ($$0|0); //@line 25405 "c/sqlite3.c"
}
function _unixGetTempname($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$015 = 0, $$218 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $brmerge = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp + 8|0;
 $2 = sp;
 HEAP8[$1>>0] = 0; //@line 36310 "c/sqlite3.c"
 $3 = (_unixTempFileDir()|0); //@line 36313 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 36314 "c/sqlite3.c"
 if ($4) {
  $$218 = 6410;
  STACKTOP = sp;return ($$218|0); //@line 36325 "c/sqlite3.c"
 }
 $5 = (($0) + -2)|0;
 $6 = (($1) + ($5)|0);
 $$015 = 0;
 while(1) {
  _sqlite3_randomness(8,$2); //@line 36317 "c/sqlite3.c"
  HEAP8[$6>>0] = 0; //@line 36319 "c/sqlite3.c"
  $7 = $2; //@line 36321 "c/sqlite3.c"
  $8 = $7; //@line 36321 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 36321 "c/sqlite3.c"
  $10 = (($7) + 4)|0; //@line 36321 "c/sqlite3.c"
  $11 = $10; //@line 36321 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 36321 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $3; //@line 36320 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 8|0); //@line 36320 "c/sqlite3.c"
  $13 = $vararg_ptr1; //@line 36320 "c/sqlite3.c"
  $14 = $13; //@line 36320 "c/sqlite3.c"
  HEAP32[$14>>2] = $9; //@line 36320 "c/sqlite3.c"
  $15 = (($13) + 4)|0; //@line 36320 "c/sqlite3.c"
  $16 = $15; //@line 36320 "c/sqlite3.c"
  HEAP32[$16>>2] = $12; //@line 36320 "c/sqlite3.c"
  $vararg_ptr2 = ((($vararg_buffer)) + 16|0); //@line 36320 "c/sqlite3.c"
  HEAP32[$vararg_ptr2>>2] = 0; //@line 36320 "c/sqlite3.c"
  (_sqlite3_snprintf($0,$1,15760,$vararg_buffer)|0); //@line 36320 "c/sqlite3.c"
  $17 = HEAP8[$6>>0]|0; //@line 36322 "c/sqlite3.c"
  $18 = ($17<<24>>24)!=(0); //@line 36322 "c/sqlite3.c"
  $19 = ($$015>>>0)>(10); //@line 36322 "c/sqlite3.c"
  $brmerge = $19 | $18; //@line 36322 "c/sqlite3.c"
  if ($brmerge) {
   $$218 = 1;
   label = 5;
   break;
  }
  $20 = (($$015) + 1)|0; //@line 36322 "c/sqlite3.c"
  $21 = HEAP32[(1556)>>2]|0; //@line 36323 "c/sqlite3.c"
  $22 = (FUNCTION_TABLE_iii[$21 & 255]($1,0)|0); //@line 36323 "c/sqlite3.c"
  $23 = ($22|0)==(0); //@line 36323 "c/sqlite3.c"
  if ($23) {
   $$015 = $20;
  } else {
   $$218 = 0;
   label = 5;
   break;
  }
 }
 if ((label|0) == 5) {
  STACKTOP = sp;return ($$218|0); //@line 36325 "c/sqlite3.c"
 }
 return (0)|0;
}
function _fileHasMoved($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $1 = sp;
 $2 = ((($0)) + 8|0); //@line 32117 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 32117 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 32117 "c/sqlite3.c"
 if ($4) {
  $23 = 0;
  STACKTOP = sp;return ($23|0); //@line 32117 "c/sqlite3.c"
 }
 $5 = HEAP32[(1580)>>2]|0; //@line 32118 "c/sqlite3.c"
 $6 = ((($0)) + 32|0); //@line 32118 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 32118 "c/sqlite3.c"
 $8 = (FUNCTION_TABLE_iii[$5 & 255]($7,$1)|0); //@line 32118 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 32118 "c/sqlite3.c"
 if (!($9)) {
  $23 = 1;
  STACKTOP = sp;return ($23|0); //@line 32117 "c/sqlite3.c"
 }
 $10 = ((($1)) + 72|0); //@line 32119 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 32119 "c/sqlite3.c"
 $12 = HEAP32[$2>>2]|0; //@line 32119 "c/sqlite3.c"
 $13 = ((($12)) + 8|0); //@line 32119 "c/sqlite3.c"
 $14 = $13; //@line 32119 "c/sqlite3.c"
 $15 = $14; //@line 32119 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 32119 "c/sqlite3.c"
 $17 = (($14) + 4)|0; //@line 32119 "c/sqlite3.c"
 $18 = $17; //@line 32119 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 32119 "c/sqlite3.c"
 $20 = ($16|0)!=($11|0); //@line 32119 "c/sqlite3.c"
 $21 = ($19|0)!=(0); //@line 32119 "c/sqlite3.c"
 $22 = $20 | $21; //@line 32119 "c/sqlite3.c"
 $phitmp = $22&1; //@line 32119 "c/sqlite3.c"
 $23 = $phitmp;
 STACKTOP = sp;return ($23|0); //@line 32117 "c/sqlite3.c"
}
function _unixTempFileDir() {
 var $$0 = 0, $$010 = 0, $$09 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $0 = sp;
 $1 = HEAP32[10026]|0; //@line 36279 "c/sqlite3.c"
 $2 = HEAP32[469]|0; //@line 36281 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 36281 "c/sqlite3.c"
 if ($3) {
  $4 = (_getenv((15777|0))|0); //@line 36281 "c/sqlite3.c"
  HEAP32[469] = $4; //@line 36281 "c/sqlite3.c"
 }
 $5 = HEAP32[(1880)>>2]|0; //@line 36282 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 36282 "c/sqlite3.c"
 if ($6) {
  $7 = (_getenv((15791|0))|0); //@line 36282 "c/sqlite3.c"
  HEAP32[(1880)>>2] = $7; //@line 36282 "c/sqlite3.c"
 }
 $8 = ((($0)) + 12|0);
 $$0 = $1;$$09 = 0;
 while(1) {
  $9 = ($$0|0)==(0|0); //@line 36284 "c/sqlite3.c"
  if (!($9)) {
   $10 = HEAP32[(1580)>>2]|0; //@line 36285 "c/sqlite3.c"
   $11 = (FUNCTION_TABLE_iii[$10 & 255]($$0,$0)|0); //@line 36285 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 36285 "c/sqlite3.c"
   if ($12) {
    $13 = HEAP32[$8>>2]|0; //@line 36286 "c/sqlite3.c"
    $14 = $13 & 61440; //@line 36286 "c/sqlite3.c"
    $15 = ($14|0)==(16384); //@line 36286 "c/sqlite3.c"
    if ($15) {
     $16 = HEAP32[(1556)>>2]|0; //@line 36287 "c/sqlite3.c"
     $17 = (FUNCTION_TABLE_iii[$16 & 255]($$0,3)|0); //@line 36287 "c/sqlite3.c"
     $18 = ($17|0)==(0); //@line 36287 "c/sqlite3.c"
     if ($18) {
      $$010 = $$0;
      label = 12;
      break;
     }
    }
   }
  }
  $19 = ($$09>>>0)>(5); //@line 36291 "c/sqlite3.c"
  if ($19) {
   $$010 = 0;
   label = 12;
   break;
  }
  $20 = (($$09) + 1)|0; //@line 36292 "c/sqlite3.c"
  $21 = (1876 + ($$09<<2)|0); //@line 36292 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 36292 "c/sqlite3.c"
  $$0 = $22;$$09 = $20;
 }
 if ((label|0) == 12) {
  STACKTOP = sp;return ($$010|0); //@line 36295 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_randomness($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$028 = 0, $$029 = 0, $$031 = 0, $$130 = 0, $$promoted = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $exitcond32 = 0, $or$cond = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 256|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(256|0);
 $2 = sp;
 $3 = (_sqlite3_initialize()|0); //@line 27574 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 27574 "c/sqlite3.c"
 if (!($4)) {
  STACKTOP = sp;return; //@line 27626 "c/sqlite3.c"
 }
 $5 = (_sqlite3MutexAlloc(5)|0); //@line 27578 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 27581 "c/sqlite3.c"
 $6 = ($0|0)<(1); //@line 27582 "c/sqlite3.c"
 $7 = ($1|0)==(0|0); //@line 27582 "c/sqlite3.c"
 $or$cond = $6 | $7; //@line 27582 "c/sqlite3.c"
 if ($or$cond) {
  HEAP8[41389] = 0; //@line 27583 "c/sqlite3.c"
  _sqlite3_mutex_leave($5); //@line 27584 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 27626 "c/sqlite3.c"
 }
 $8 = HEAP8[41389]|0; //@line 27597 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 27597 "c/sqlite3.c"
 if ($9) {
  HEAP8[(41391)>>0] = 0; //@line 27600 "c/sqlite3.c"
  HEAP8[(41390)>>0] = 0; //@line 27601 "c/sqlite3.c"
  $10 = (_sqlite3_vfs_find(0)|0); //@line 27602 "c/sqlite3.c"
  _sqlite3OsRandomness($10,$2); //@line 27602 "c/sqlite3.c"
  $$031 = 0;
  while(1) {
   $11 = $$031&255; //@line 27604 "c/sqlite3.c"
   $12 = (41392 + ($$031)|0); //@line 27604 "c/sqlite3.c"
   HEAP8[$12>>0] = $11; //@line 27604 "c/sqlite3.c"
   $13 = (($$031) + 1)|0; //@line 27603 "c/sqlite3.c"
   $exitcond32 = ($13|0)==(256); //@line 27603 "c/sqlite3.c"
   if ($exitcond32) {
    break;
   } else {
    $$031 = $13;
   }
  }
  $$promoted = HEAP8[(41391)>>0]|0; //@line 27607 "c/sqlite3.c"
  $$130 = 0;$22 = $$promoted;
  while(1) {
   $14 = (41392 + ($$130)|0); //@line 27607 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 27607 "c/sqlite3.c"
   $16 = $15&255; //@line 27607 "c/sqlite3.c"
   $17 = (($2) + ($$130)|0); //@line 27607 "c/sqlite3.c"
   $18 = HEAP8[$17>>0]|0; //@line 27607 "c/sqlite3.c"
   $19 = $18&255; //@line 27607 "c/sqlite3.c"
   $20 = (($19) + ($16))|0; //@line 27607 "c/sqlite3.c"
   $21 = $22&255; //@line 27607 "c/sqlite3.c"
   $23 = (($20) + ($21))|0; //@line 27607 "c/sqlite3.c"
   $24 = $23&255; //@line 27607 "c/sqlite3.c"
   $25 = $23 & 255; //@line 27608 "c/sqlite3.c"
   $26 = (41392 + ($25)|0); //@line 27608 "c/sqlite3.c"
   $27 = HEAP8[$26>>0]|0; //@line 27608 "c/sqlite3.c"
   HEAP8[$26>>0] = $15; //@line 27609 "c/sqlite3.c"
   HEAP8[$14>>0] = $27; //@line 27610 "c/sqlite3.c"
   $28 = (($$130) + 1)|0; //@line 27606 "c/sqlite3.c"
   $exitcond = ($28|0)==(256); //@line 27606 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$130 = $28;$22 = $24;
   }
  }
  HEAP8[(41391)>>0] = $24; //@line 27607 "c/sqlite3.c"
  HEAP8[41389] = 1; //@line 27612 "c/sqlite3.c"
 }
 $$028 = $0;$$029 = $1;
 while(1) {
  $29 = HEAP8[(41390)>>0]|0; //@line 27617 "c/sqlite3.c"
  $30 = (($29) + 1)<<24>>24; //@line 27617 "c/sqlite3.c"
  HEAP8[(41390)>>0] = $30; //@line 27617 "c/sqlite3.c"
  $31 = $30&255; //@line 27618 "c/sqlite3.c"
  $32 = (41392 + ($31)|0); //@line 27618 "c/sqlite3.c"
  $33 = HEAP8[$32>>0]|0; //@line 27618 "c/sqlite3.c"
  $34 = $33&255; //@line 27619 "c/sqlite3.c"
  $35 = HEAP8[(41391)>>0]|0; //@line 27619 "c/sqlite3.c"
  $36 = $35&255; //@line 27619 "c/sqlite3.c"
  $37 = (($36) + ($34))|0; //@line 27619 "c/sqlite3.c"
  $38 = $37&255; //@line 27619 "c/sqlite3.c"
  HEAP8[(41391)>>0] = $38; //@line 27619 "c/sqlite3.c"
  $39 = $37 & 255; //@line 27620 "c/sqlite3.c"
  $40 = (41392 + ($39)|0); //@line 27620 "c/sqlite3.c"
  $41 = HEAP8[$40>>0]|0; //@line 27620 "c/sqlite3.c"
  HEAP8[$32>>0] = $41; //@line 27620 "c/sqlite3.c"
  $42 = $37 & 255; //@line 27621 "c/sqlite3.c"
  $43 = (41392 + ($42)|0); //@line 27621 "c/sqlite3.c"
  HEAP8[$43>>0] = $33; //@line 27621 "c/sqlite3.c"
  $44 = HEAP8[$32>>0]|0; //@line 27622 "c/sqlite3.c"
  $45 = $44&255; //@line 27622 "c/sqlite3.c"
  $46 = (($45) + ($34))|0; //@line 27622 "c/sqlite3.c"
  $47 = $46 & 255; //@line 27623 "c/sqlite3.c"
  $48 = (41392 + ($47)|0); //@line 27623 "c/sqlite3.c"
  $49 = HEAP8[$48>>0]|0; //@line 27623 "c/sqlite3.c"
  $50 = ((($$029)) + 1|0); //@line 27623 "c/sqlite3.c"
  HEAP8[$$029>>0] = $49; //@line 27623 "c/sqlite3.c"
  $51 = (($$028) + -1)|0; //@line 27624 "c/sqlite3.c"
  $52 = ($51|0)==(0); //@line 27624 "c/sqlite3.c"
  if ($52) {
   break;
  } else {
   $$028 = $51;$$029 = $50;
  }
 }
 _sqlite3_mutex_leave($5); //@line 27625 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 27626 "c/sqlite3.c"
}
function _sqlite3_vfs_find($0) {
 $0 = $0|0;
 var $$0 = 0, $$015 = 0, $$015$lcssa = 0, $$01516 = 0, $$01518 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond17 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_initialize()|0); //@line 21151 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 21152 "c/sqlite3.c"
 if (!($2)) {
  $$0 = 0;
  return ($$0|0); //@line 21164 "c/sqlite3.c"
 }
 $3 = (_sqlite3MutexAlloc(2)|0); //@line 21155 "c/sqlite3.c"
 _sqlite3_mutex_enter($3); //@line 21157 "c/sqlite3.c"
 $$01516 = HEAP32[10095]|0;
 $4 = ($$01516|0)==(0|0); //@line 21158 "c/sqlite3.c"
 $5 = ($0|0)==(0|0); //@line 21159 "c/sqlite3.c"
 $or$cond17 = $5 | $4; //@line 21158 "c/sqlite3.c"
 L4: do {
  if ($or$cond17) {
   $$015$lcssa = $$01516;
  } else {
   $$01518 = $$01516;
   while(1) {
    $6 = ((($$01518)) + 16|0); //@line 21160 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 21160 "c/sqlite3.c"
    $8 = (_strcmp($0,$7)|0); //@line 21160 "c/sqlite3.c"
    $9 = ($8|0)==(0); //@line 21160 "c/sqlite3.c"
    if ($9) {
     $$015$lcssa = $$01518;
     break L4;
    }
    $10 = ((($$01518)) + 12|0); //@line 21158 "c/sqlite3.c"
    $$015 = HEAP32[$10>>2]|0;
    $11 = ($$015|0)==(0|0); //@line 21158 "c/sqlite3.c"
    $or$cond = $5 | $11; //@line 21158 "c/sqlite3.c"
    if ($or$cond) {
     $$015$lcssa = $$015;
     break;
    } else {
     $$01518 = $$015;
    }
   }
  }
 } while(0);
 _sqlite3_mutex_leave($3); //@line 21162 "c/sqlite3.c"
 $$0 = $$015$lcssa;
 return ($$0|0); //@line 21164 "c/sqlite3.c"
}
function _sqlite3OsRandomness($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 56|0); //@line 21068 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 21068 "c/sqlite3.c"
 (FUNCTION_TABLE_iiii[$3 & 127]($0,256,$1)|0); //@line 21068 "c/sqlite3.c"
 return;
}
function _sqlite3_vmprintf($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $2 = sp + 24|0;
 $3 = sp;
 $4 = (_sqlite3_initialize()|0); //@line 26841 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 26841 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 26847 "c/sqlite3.c"
 }
 _sqlite3StrAccumInit($3,0,$2,70,1000000000); //@line 26843 "c/sqlite3.c"
 _sqlite3VXPrintf($3,$0,$1); //@line 26844 "c/sqlite3.c"
 $6 = (_sqlite3StrAccumFinish($3)|0); //@line 26845 "c/sqlite3.c"
 $$0 = $6;
 STACKTOP = sp;return ($$0|0); //@line 26847 "c/sqlite3.c"
}
function _seekAndWrite($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 12|0); //@line 34047 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 34047 "c/sqlite3.c"
 $7 = ((($0)) + 20|0); //@line 34047 "c/sqlite3.c"
 $8 = (_seekAndWriteFd($6,$1,$2,$3,$4,$7)|0); //@line 34047 "c/sqlite3.c"
 return ($8|0); //@line 34047 "c/sqlite3.c"
}
function _seekAndWriteFd($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0151718 = 0, $$0151719 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = $4 & 131071; //@line 34012 "c/sqlite3.c"
 while(1) {
  $7 = (_lseek($0,$1,0)|0); //@line 34021 "c/sqlite3.c"
  $8 = ($7|0)<(0); //@line 34023 "c/sqlite3.c"
  if ($8) {
   $$0151719 = -1;
   break;
  }
  $9 = HEAP32[(1664)>>2]|0; //@line 34027 "c/sqlite3.c"
  $10 = (FUNCTION_TABLE_iiii[$9 & 127]($0,$3,$6)|0); //@line 34027 "c/sqlite3.c"
  $11 = ($10|0)<(0); //@line 34028 "c/sqlite3.c"
  if (!($11)) {
   $$0151718 = $10;
   label = 6;
   break;
  }
  $12 = (___errno_location()|0); //@line 34028 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 34028 "c/sqlite3.c"
  $14 = ($13|0)==(4); //@line 34028 "c/sqlite3.c"
  if (!($14)) {
   $$0151719 = $10;
   break;
  }
 }
 if ((label|0) == 6) {
  return ($$0151718|0); //@line 34035 "c/sqlite3.c"
 }
 $15 = (___errno_location()|0); //@line 34034 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 34034 "c/sqlite3.c"
 HEAP32[$5>>2] = $16; //@line 34034 "c/sqlite3.c"
 $$0151718 = $$0151719;
 return ($$0151718|0); //@line 34035 "c/sqlite3.c"
}
function _storeLastErrno($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 31968 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 31968 "c/sqlite3.c"
 return; //@line 31969 "c/sqlite3.c"
}
function _sqliteErrorFromPosixError($0) {
 $0 = $0|0;
 var $$0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0|0) {
 case 37: case 4: case 16: case 110: case 11: case 13:  {
  $$0 = 5;
  break;
 }
 case 1:  {
  $$0 = 3;
  break;
 }
 default: {
  $$0 = 3850;
 }
 }
 return ($$0|0); //@line 31588 "c/sqlite3.c"
}
function _full_fsync($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_fsync($0)|0); //@line 34249 "c/sqlite3.c"
 return ($1|0); //@line 34260 "c/sqlite3.c"
}
function _robust_ftruncate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 while(1) {
  $3 = HEAP32[(1604)>>2]|0; //@line 31552 "c/sqlite3.c"
  $4 = (FUNCTION_TABLE_iii[$3 & 255]($0,$1)|0); //@line 31552 "c/sqlite3.c"
  $5 = ($4|0)<(0); //@line 31552 "c/sqlite3.c"
  if (!($5)) {
   label = 4;
   break;
  }
  $6 = (___errno_location()|0); //@line 31552 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 31552 "c/sqlite3.c"
  $8 = ($7|0)==(4); //@line 31552 "c/sqlite3.c"
  if (!($8)) {
   label = 4;
   break;
  }
 }
 if ((label|0) == 4) {
  return ($4|0); //@line 31553 "c/sqlite3.c"
 }
 return (0)|0;
}
function _seekAndRead($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$028 = 0, $$029 = 0, $$031 = 0, $$033 = 0, $$1 = 0, $$130 = 0, $$132 = 0, $$134 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select37 = 0, $spec$select38 = 0;
 var $spec$select40 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 12|0);
 $$028 = 0;$$031 = $4;$$033 = $3;$26 = $2;$7 = $1;
 while(1) {
  $6 = HEAP32[$5>>2]|0; //@line 33909 "c/sqlite3.c"
  $8 = (_lseek($6,$7,0)|0); //@line 33909 "c/sqlite3.c"
  $9 = ($8|0)<(0); //@line 33911 "c/sqlite3.c"
  if ($9) {
   label = 3;
   break;
  }
  $12 = HEAP32[(1628)>>2]|0; //@line 33915 "c/sqlite3.c"
  $13 = HEAP32[$5>>2]|0; //@line 33915 "c/sqlite3.c"
  $14 = (FUNCTION_TABLE_iiii[$12 & 127]($13,$$033,$$031)|0); //@line 33915 "c/sqlite3.c"
  $15 = ($$031|0)==($14|0); //@line 33917 "c/sqlite3.c"
  if ($15) {
   $$130 = $14;$$2 = $$028;
   break;
  }
  $16 = ($14|0)<(0); //@line 33918 "c/sqlite3.c"
  if ($16) {
   $17 = (___errno_location()|0); //@line 33919 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 33919 "c/sqlite3.c"
   $19 = ($18|0)==(4); //@line 33919 "c/sqlite3.c"
   if ($19) {
    $$029 = 1;$$1 = $$028;$$132 = $$031;$$134 = $$033;$31 = $7;$32 = $26;
   } else {
    label = 7;
    break;
   }
  } else {
   $22 = ($14|0)==(0); //@line 33923 "c/sqlite3.c"
   $23 = ($14|0)<(0); //@line 33925 "c/sqlite3.c"
   $24 = $23 << 31 >> 31; //@line 33925 "c/sqlite3.c"
   $25 = (($$033) + ($14)|0); //@line 33927 "c/sqlite3.c"
   $27 = (_i64Add(($7|0),($26|0),($14|0),($24|0))|0); //@line 33923 "c/sqlite3.c"
   $28 = tempRet0; //@line 33923 "c/sqlite3.c"
   $spec$select37 = $22 ? $$033 : $25; //@line 33923 "c/sqlite3.c"
   $spec$select38 = (($$031) - ($14))|0; //@line 33923 "c/sqlite3.c"
   $spec$select40 = (($14) + ($$028))|0; //@line 33923 "c/sqlite3.c"
   $$029 = $14;$$1 = $spec$select40;$$132 = $spec$select38;$$134 = $spec$select37;$31 = $27;$32 = $28;
  }
  $29 = ($$029|0)>(0); //@line 33929 "c/sqlite3.c"
  if ($29) {
   $$028 = $$1;$$031 = $$132;$$033 = $$134;$26 = $32;$7 = $31;
  } else {
   $$130 = 0;$$2 = $$1;
   break;
  }
 }
 if ((label|0) == 3) {
  $10 = (___errno_location()|0); //@line 33912 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 33912 "c/sqlite3.c"
  _storeLastErrno($0,$11); //@line 33912 "c/sqlite3.c"
  $$0 = -1;
  return ($$0|0); //@line 33934 "c/sqlite3.c"
 }
 else if ((label|0) == 7) {
  $20 = (___errno_location()|0); //@line 33921 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 33921 "c/sqlite3.c"
  _storeLastErrno($0,$21); //@line 33921 "c/sqlite3.c"
  $$130 = $14;$$2 = 0;
 }
 $30 = (($$2) + ($$130))|0; //@line 33933 "c/sqlite3.c"
 $$0 = $30;
 return ($$0|0); //@line 33934 "c/sqlite3.c"
}
function _closeUnixFile($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 32713 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 32713 "c/sqlite3.c"
 $3 = ($2|0)>(-1); //@line 32713 "c/sqlite3.c"
 if ($3) {
  _robust_close($0,$2,32714); //@line 32714 "c/sqlite3.c"
  HEAP32[$1>>2] = -1; //@line 32715 "c/sqlite3.c"
 }
 $4 = ((($0)) + 28|0); //@line 32735 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 32735 "c/sqlite3.c"
 _sqlite3_free($5); //@line 32735 "c/sqlite3.c"
 dest=$0; stop=dest+52|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 32736 "c/sqlite3.c"
 return;
}
function _nolockIoFinderImpl($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (1900|0); //@line 35874 "c/sqlite3.c"
}
function _nolockClose($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _closeUnixFile($0); //@line 32806 "c/sqlite3.c"
 return 0; //@line 32806 "c/sqlite3.c"
}
function _nolockLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 32795 "c/sqlite3.c"
}
function _nolockUnlock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 32799 "c/sqlite3.c"
}
function _nolockCheckReservedLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$1>>2] = 0; //@line 32790 "c/sqlite3.c"
 return 0; //@line 32791 "c/sqlite3.c"
}
function _mkFullPathname($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$021 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 36856 "c/sqlite3.c"
 $3 = (_sqlite3Strlen30($0)|0); //@line 36860 "c/sqlite3.c"
 $4 = HEAP8[$0>>0]|0; //@line 36862 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(47); //@line 36862 "c/sqlite3.c"
 do {
  if ($5) {
   $$0 = 0;
  } else {
   $6 = HEAP32[(1568)>>2]|0; //@line 36863 "c/sqlite3.c"
   $7 = (($2) + -2)|0; //@line 36863 "c/sqlite3.c"
   $8 = (FUNCTION_TABLE_iii[$6 & 255]($1,$7)|0); //@line 36863 "c/sqlite3.c"
   $9 = ($8|0)==(0|0); //@line 36863 "c/sqlite3.c"
   if (!($9)) {
    $12 = (_sqlite3Strlen30($1)|0); //@line 36866 "c/sqlite3.c"
    $13 = (($12) + 1)|0; //@line 36867 "c/sqlite3.c"
    $14 = (($1) + ($12)|0); //@line 36867 "c/sqlite3.c"
    HEAP8[$14>>0] = 47; //@line 36867 "c/sqlite3.c"
    $$0 = $13;
    break;
   }
   $10 = (_sqlite3CantopenError(36864)|0); //@line 36864 "c/sqlite3.c"
   $11 = (_unixLogErrorAtLine($10,15495,$0,36864)|0); //@line 36864 "c/sqlite3.c"
   $$021 = $11;
   STACKTOP = sp;return ($$021|0); //@line 36877 "c/sqlite3.c"
  }
 } while(0);
 $15 = (($$0) + ($3))|0; //@line 36869 "c/sqlite3.c"
 $16 = ($15|0)<($2|0); //@line 36869 "c/sqlite3.c"
 if ($16) {
  $19 = (($2) - ($$0))|0; //@line 36875 "c/sqlite3.c"
  $20 = (($1) + ($$0)|0); //@line 36875 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $0; //@line 36875 "c/sqlite3.c"
  (_sqlite3_snprintf($19,$20,15687,$vararg_buffer)|0); //@line 36875 "c/sqlite3.c"
  $$021 = 0;
  STACKTOP = sp;return ($$021|0); //@line 36877 "c/sqlite3.c"
 } else {
  $17 = (($1) + ($$0)|0); //@line 36872 "c/sqlite3.c"
  HEAP8[$17>>0] = 0; //@line 36872 "c/sqlite3.c"
  $18 = (_sqlite3CantopenError(36873)|0); //@line 36873 "c/sqlite3.c"
  $$021 = $18;
  STACKTOP = sp;return ($$021|0); //@line 36877 "c/sqlite3.c"
 }
 return (0)|0;
}
function _findReusableFd($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$019 = 0, $$01929 = 0, $$01930 = 0, $$028 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $2 = sp;
 _unixEnterMutex(); //@line 36363 "c/sqlite3.c"
 $3 = HEAP32[10098]|0; //@line 36373 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 36373 "c/sqlite3.c"
 L1: do {
  if ($4) {
   $$1 = 0;
  } else {
   $5 = HEAP32[(1580)>>2]|0; //@line 36373 "c/sqlite3.c"
   $6 = (FUNCTION_TABLE_iii[$5 & 255]($0,$2)|0); //@line 36373 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 36373 "c/sqlite3.c"
   if ($7) {
    $$01929 = HEAP32[10097]|0;
    $8 = ($$01929|0)==(0|0); //@line 36377 "c/sqlite3.c"
    if ($8) {
     $$1 = 0;
    } else {
     $9 = HEAP32[$2>>2]|0;
     $10 = ((($2)) + 72|0);
     $11 = HEAP32[$10>>2]|0;
     $$01930 = $$01929;
     while(1) {
      $12 = HEAP32[$$01930>>2]|0; //@line 36377 "c/sqlite3.c"
      $13 = ($12|0)==($9|0); //@line 36377 "c/sqlite3.c"
      if ($13) {
       $14 = ((($$01930)) + 8|0); //@line 36378 "c/sqlite3.c"
       $15 = $14; //@line 36378 "c/sqlite3.c"
       $16 = $15; //@line 36378 "c/sqlite3.c"
       $17 = HEAP32[$16>>2]|0; //@line 36378 "c/sqlite3.c"
       $18 = (($15) + 4)|0; //@line 36378 "c/sqlite3.c"
       $19 = $18; //@line 36378 "c/sqlite3.c"
       $20 = HEAP32[$19>>2]|0; //@line 36378 "c/sqlite3.c"
       $21 = ($17|0)==($11|0); //@line 36378 "c/sqlite3.c"
       $22 = ($20|0)==(0); //@line 36378 "c/sqlite3.c"
       $23 = $21 & $22; //@line 36378 "c/sqlite3.c"
       if ($23) {
        break;
       }
      }
      $24 = ((($$01930)) + 40|0); //@line 36379 "c/sqlite3.c"
      $$019 = HEAP32[$24>>2]|0;
      $25 = ($$019|0)==(0|0); //@line 36377 "c/sqlite3.c"
      if ($25) {
       $$1 = 0;
       break L1;
      } else {
       $$01930 = $$019;
      }
     }
     $26 = ((($$01930)) + 36|0); //@line 36383 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 36383 "c/sqlite3.c"
     $28 = ($27|0)==(0|0); //@line 36383 "c/sqlite3.c"
     if ($28) {
      $$1 = 0;
     } else {
      $$028 = $26;$30 = $27;
      while(1) {
       $29 = ((($30)) + 4|0); //@line 36383 "c/sqlite3.c"
       $31 = HEAP32[$29>>2]|0; //@line 36383 "c/sqlite3.c"
       $32 = ($31|0)==($1|0); //@line 36383 "c/sqlite3.c"
       if ($32) {
        break;
       }
       $33 = ((($30)) + 8|0); //@line 36383 "c/sqlite3.c"
       $34 = HEAP32[$33>>2]|0; //@line 36383 "c/sqlite3.c"
       $35 = ($34|0)==(0|0); //@line 36383 "c/sqlite3.c"
       if ($35) {
        $$1 = 0;
        break L1;
       } else {
        $$028 = $33;$30 = $34;
       }
      }
      $36 = HEAP32[10098]|0; //@line 36386 "c/sqlite3.c"
      $37 = (($36) + -1)|0; //@line 36386 "c/sqlite3.c"
      HEAP32[10098] = $37; //@line 36386 "c/sqlite3.c"
      $38 = ((($30)) + 8|0); //@line 36387 "c/sqlite3.c"
      $39 = HEAP32[$38>>2]|0; //@line 36387 "c/sqlite3.c"
      HEAP32[$$028>>2] = $39; //@line 36387 "c/sqlite3.c"
      $$1 = $30;
     }
    }
   } else {
    $$1 = 0;
   }
  }
 } while(0);
 _unixLeaveMutex(); //@line 36391 "c/sqlite3.c"
 STACKTOP = sp;return ($$1|0); //@line 36393 "c/sqlite3.c"
}
function _findCreateFileMode($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$034 = 0, $$034$lcssa = 0, $$03438 = 0, $$03439 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 528|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(528|0);
 $5 = sp;
 HEAP32[$2>>2] = 0; //@line 36446 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 36447 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 36448 "c/sqlite3.c"
 $6 = $1 & 526336; //@line 36449 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 36449 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_sqlite3Strlen30($0)|0); //@line 36465 "c/sqlite3.c"
  $$03438 = (($8) + -1)|0;
  $9 = (($0) + ($$03438)|0); //@line 36466 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 36466 "c/sqlite3.c"
  $11 = ($10<<24>>24)==(45); //@line 36466 "c/sqlite3.c"
  L3: do {
   if ($11) {
    $$034$lcssa = $$03438;
   } else {
    $$03439 = $$03438;$17 = $10;
    while(1) {
     $15 = ($$03439|0)==(0); //@line 36471 "c/sqlite3.c"
     $16 = ($17<<24>>24)==(46); //@line 36471 "c/sqlite3.c"
     $or$cond = $15 | $16; //@line 36471 "c/sqlite3.c"
     if ($or$cond) {
      break;
     }
     $$034 = (($$03439) + -1)|0;
     $12 = (($0) + ($$034)|0); //@line 36466 "c/sqlite3.c"
     $13 = HEAP8[$12>>0]|0; //@line 36466 "c/sqlite3.c"
     $14 = ($13<<24>>24)==(45); //@line 36466 "c/sqlite3.c"
     if ($14) {
      $$034$lcssa = $$034;
      break L3;
     } else {
      $$03439 = $$034;$17 = $13;
     }
    }
    $$1 = 0;
    STACKTOP = sp;return ($$1|0); //@line 36491 "c/sqlite3.c"
   }
  } while(0);
  _memcpy(($5|0),($0|0),($$034$lcssa|0))|0; //@line 36474 "c/sqlite3.c"
  $18 = (($5) + ($$034$lcssa)|0); //@line 36475 "c/sqlite3.c"
  HEAP8[$18>>0] = 0; //@line 36475 "c/sqlite3.c"
  $19 = (_getFileMode($5,$2,$3,$4)|0); //@line 36477 "c/sqlite3.c"
  $$1 = $19;
  STACKTOP = sp;return ($$1|0); //@line 36491 "c/sqlite3.c"
 }
 $20 = $1 & 8; //@line 36478 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 36478 "c/sqlite3.c"
 if (!($21)) {
  HEAP32[$2>>2] = 384; //@line 36479 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 36491 "c/sqlite3.c"
 }
 $22 = $1 & 64; //@line 36480 "c/sqlite3.c"
 $23 = ($22|0)==(0); //@line 36480 "c/sqlite3.c"
 if ($23) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 36491 "c/sqlite3.c"
 }
 $24 = (_sqlite3_uri_parameter($0,16537)|0); //@line 36485 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 36486 "c/sqlite3.c"
 if ($25) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 36491 "c/sqlite3.c"
 }
 $26 = (_getFileMode($24,$2,$3,$4)|0); //@line 36487 "c/sqlite3.c"
 $$1 = $26;
 STACKTOP = sp;return ($$1|0); //@line 36491 "c/sqlite3.c"
}
function _robustFchown($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[(1784)>>2]|0; //@line 31277 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_i[$3 & 127]()|0); //@line 31277 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 31277 "c/sqlite3.c"
 if (!($5)) {
  return;
 }
 $6 = HEAP32[(1772)>>2]|0; //@line 31277 "c/sqlite3.c"
 (FUNCTION_TABLE_iiii[$6 & 127]($0,$1,$2)|0); //@line 31277 "c/sqlite3.c"
 return;
}
function _fillInUnixFile($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$05053 = 0, $$05053$ph = 0, $$0505357 = 0, $$051 = 0, $$1 = 0, $$152 = 0, $$15258 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 36093 "c/sqlite3.c"
 $5 = ((($2)) + 12|0); //@line 36109 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 36109 "c/sqlite3.c"
 $6 = ((($2)) + 4|0); //@line 36110 "c/sqlite3.c"
 HEAP32[$6>>2] = $0; //@line 36110 "c/sqlite3.c"
 $7 = ((($2)) + 32|0); //@line 36111 "c/sqlite3.c"
 HEAP32[$7>>2] = $3; //@line 36111 "c/sqlite3.c"
 $8 = $4&65535; //@line 36112 "c/sqlite3.c"
 $9 = $8 & 255; //@line 36112 "c/sqlite3.c"
 $10 = ((($2)) + 18|0); //@line 36112 "c/sqlite3.c"
 HEAP16[$10>>1] = $9; //@line 36112 "c/sqlite3.c"
 $11 = $4 & 64; //@line 36116 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 36116 "c/sqlite3.c"
 $13 = $12 ? 0 : $3; //@line 36116 "c/sqlite3.c"
 $14 = (_sqlite3_uri_boolean($13,15851,1)|0); //@line 36116 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 36116 "c/sqlite3.c"
 if (!($15)) {
  $16 = HEAP16[$10>>1]|0; //@line 36118 "c/sqlite3.c"
  $17 = $16 | 16; //@line 36118 "c/sqlite3.c"
  HEAP16[$10>>1] = $17; //@line 36118 "c/sqlite3.c"
 }
 $18 = ((($0)) + 16|0); //@line 36120 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 36120 "c/sqlite3.c"
 $20 = (_strcmp($19,15436)|0); //@line 36120 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 36120 "c/sqlite3.c"
 if ($21) {
  $22 = HEAP16[$10>>1]|0; //@line 36121 "c/sqlite3.c"
  $23 = $22 | 1; //@line 36121 "c/sqlite3.c"
  HEAP16[$10>>1] = $23; //@line 36121 "c/sqlite3.c"
 }
 $24 = $4 & 128; //@line 36132 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 36132 "c/sqlite3.c"
 do {
  if ($25) {
   $26 = ((($0)) + 20|0); //@line 36135 "c/sqlite3.c"
   $27 = HEAP32[$26>>2]|0; //@line 36135 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 36135 "c/sqlite3.c"
   $29 = (FUNCTION_TABLE_iii[$28 & 255]($3,$2)|0); //@line 36135 "c/sqlite3.c"
   $30 = ($29|0)==(1976|0); //@line 36144 "c/sqlite3.c"
   if ($30) {
    _unixEnterMutex(); //@line 36149 "c/sqlite3.c"
    $31 = ((($2)) + 8|0); //@line 36150 "c/sqlite3.c"
    $32 = (_findInodeInfo($2,$31)|0); //@line 36150 "c/sqlite3.c"
    $33 = ($32|0)==(0); //@line 36151 "c/sqlite3.c"
    if ($33) {
     $$0 = $1;
    } else {
     _robust_close($2,$1,36170); //@line 36170 "c/sqlite3.c"
     $$0 = -1;
    }
    _unixLeaveMutex(); //@line 36173 "c/sqlite3.c"
    $$05053 = 1976;$$1 = $$0;$$152 = $32;
   } else {
    $34 = ($29|0)==(1452|0); //@line 36204 "c/sqlite3.c"
    if (!($34)) {
     $$05053$ph = $29;
     label = 14;
     break;
    }
    $35 = (_strlen($3)|0); //@line 36211 "c/sqlite3.c"
    $36 = (($35) + 6)|0; //@line 36211 "c/sqlite3.c"
    $37 = ($36|0)<(0); //@line 36212 "c/sqlite3.c"
    $38 = $37 << 31 >> 31; //@line 36212 "c/sqlite3.c"
    $39 = (_sqlite3_malloc64($36,$38)|0); //@line 36212 "c/sqlite3.c"
    $40 = ($39|0)==(0|0); //@line 36213 "c/sqlite3.c"
    if ($40) {
     $$051 = 7;
    } else {
     HEAP32[$vararg_buffer>>2] = $3; //@line 36216 "c/sqlite3.c"
     (_sqlite3_snprintf($36,$39,15856,$vararg_buffer)|0); //@line 36216 "c/sqlite3.c"
     $$051 = 0;
    }
    $41 = ((($2)) + 24|0); //@line 36218 "c/sqlite3.c"
    HEAP32[$41>>2] = $39; //@line 36218 "c/sqlite3.c"
    $$05053 = 1452;$$1 = $1;$$152 = $$051;
   }
   _storeLastErrno($2,0); //@line 36245 "c/sqlite3.c"
   $42 = ($$152|0)==(0); //@line 36254 "c/sqlite3.c"
   if ($42) {
    $$0505357 = $$05053;
   } else {
    $43 = ($$1|0)>(-1); //@line 36255 "c/sqlite3.c"
    if (!($43)) {
     $$15258 = $$152;
     STACKTOP = sp;return ($$15258|0); //@line 36261 "c/sqlite3.c"
    }
    _robust_close($2,$$1,36255); //@line 36255 "c/sqlite3.c"
    $$15258 = $$152;
    STACKTOP = sp;return ($$15258|0); //@line 36261 "c/sqlite3.c"
   }
  } else {
   $$05053$ph = 1900;
   label = 14;
  }
 } while(0);
 if ((label|0) == 14) {
  _storeLastErrno($2,0); //@line 36245 "c/sqlite3.c"
  $$0505357 = $$05053$ph;
 }
 HEAP32[$2>>2] = $$0505357; //@line 36257 "c/sqlite3.c"
 _verifyDbFile($2); //@line 36259 "c/sqlite3.c"
 $$15258 = 0;
 STACKTOP = sp;return ($$15258|0); //@line 36261 "c/sqlite3.c"
}
function _sqlite3_uri_boolean($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_uri_parameter($0,$1)|0); //@line 147329 "c/sqlite3.c"
 $4 = ($2|0)!=(0); //@line 147330 "c/sqlite3.c"
 $5 = ($3|0)==(0|0); //@line 147331 "c/sqlite3.c"
 if ($5) {
  $9 = $4&1; //@line 147330 "c/sqlite3.c"
  $10 = $9;
  return ($10|0); //@line 147331 "c/sqlite3.c"
 } else {
  $6 = $4&1; //@line 147331 "c/sqlite3.c"
  $7 = (_sqlite3GetBoolean($3,$6)|0); //@line 147331 "c/sqlite3.c"
  $8 = $7&255; //@line 147331 "c/sqlite3.c"
  $10 = $8;
  return ($10|0); //@line 147331 "c/sqlite3.c"
 }
 return (0)|0;
}
function _findInodeInfo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$023 = 0, $$025 = 0, $$027 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $cond = 0, $cond26 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $2 = sp;
 $3 = sp + 16|0;
 $4 = ((($0)) + 12|0); //@line 32043 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 32043 "c/sqlite3.c"
 $6 = HEAP32[(1592)>>2]|0; //@line 32044 "c/sqlite3.c"
 $7 = (FUNCTION_TABLE_iii[$6 & 255]($5,$3)|0); //@line 32044 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 32045 "c/sqlite3.c"
 if (!($8)) {
  $9 = (___errno_location()|0); //@line 32046 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 32046 "c/sqlite3.c"
  _storeLastErrno($0,$10); //@line 32046 "c/sqlite3.c"
  $$023 = 10;
  STACKTOP = sp;return ($$023|0); //@line 32107 "c/sqlite3.c"
 }
 $11 = $2; //@line 32078 "c/sqlite3.c"
 $12 = $11; //@line 32078 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 32078 "c/sqlite3.c"
 $13 = (($11) + 4)|0; //@line 32078 "c/sqlite3.c"
 $14 = $13; //@line 32078 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 32078 "c/sqlite3.c"
 $15 = HEAP32[$3>>2]|0; //@line 32079 "c/sqlite3.c"
 HEAP32[$2>>2] = $15; //@line 32079 "c/sqlite3.c"
 $16 = ((($3)) + 72|0); //@line 32083 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 32083 "c/sqlite3.c"
 $18 = ((($2)) + 8|0); //@line 32083 "c/sqlite3.c"
 $19 = $18; //@line 32083 "c/sqlite3.c"
 $20 = $19; //@line 32083 "c/sqlite3.c"
 HEAP32[$20>>2] = $17; //@line 32083 "c/sqlite3.c"
 $21 = (($19) + 4)|0; //@line 32083 "c/sqlite3.c"
 $22 = $21; //@line 32083 "c/sqlite3.c"
 HEAP32[$22>>2] = 0; //@line 32083 "c/sqlite3.c"
 $$025 = HEAP32[10097]|0;
 $cond26 = ($$025|0)==(0|0); //@line 32087 "c/sqlite3.c"
 L5: do {
  if ($cond26) {
   label = 7;
  } else {
   $$027 = $$025;
   while(1) {
    $23 = (_memcmp($2,$$027,16)|0); //@line 32087 "c/sqlite3.c"
    $24 = ($23|0)==(0); //@line 32087 "c/sqlite3.c"
    if ($24) {
     break;
    }
    $25 = ((($$027)) + 40|0); //@line 32088 "c/sqlite3.c"
    $$0 = HEAP32[$25>>2]|0;
    $cond = ($$0|0)==(0|0); //@line 32087 "c/sqlite3.c"
    if ($cond) {
     label = 7;
     break L5;
    } else {
     $$027 = $$0;
    }
   }
   $36 = ((($$027)) + 24|0); //@line 32103 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 32103 "c/sqlite3.c"
   $38 = (($37) + 1)|0; //@line 32103 "c/sqlite3.c"
   HEAP32[$36>>2] = $38; //@line 32103 "c/sqlite3.c"
   $$1 = $$027;
  }
 } while(0);
 if ((label|0) == 7) {
  $26 = (_sqlite3_malloc64(48,0)|0); //@line 32091 "c/sqlite3.c"
  $27 = ($26|0)==(0|0); //@line 32092 "c/sqlite3.c"
  if ($27) {
   $$023 = 7;
   STACKTOP = sp;return ($$023|0); //@line 32107 "c/sqlite3.c"
  }
  $28 = ((($26)) + 16|0); //@line 32096 "c/sqlite3.c"
  ;HEAP32[$28>>2]=0|0;HEAP32[$28+4>>2]=0|0;HEAP32[$28+8>>2]=0|0;HEAP32[$28+12>>2]=0|0;HEAP32[$28+16>>2]=0|0;HEAP32[$28+20>>2]=0|0; //@line 32096 "c/sqlite3.c"
  ;HEAP32[$26>>2]=HEAP32[$2>>2]|0;HEAP32[$26+4>>2]=HEAP32[$2+4>>2]|0;HEAP32[$26+8>>2]=HEAP32[$2+8>>2]|0;HEAP32[$26+12>>2]=HEAP32[$2+12>>2]|0; //@line 32096 "c/sqlite3.c"
  $29 = ((($26)) + 24|0); //@line 32097 "c/sqlite3.c"
  HEAP32[$29>>2] = 1; //@line 32097 "c/sqlite3.c"
  $30 = HEAP32[10097]|0; //@line 32098 "c/sqlite3.c"
  $31 = ((($26)) + 40|0); //@line 32098 "c/sqlite3.c"
  HEAP32[$31>>2] = $30; //@line 32098 "c/sqlite3.c"
  $32 = ((($26)) + 44|0); //@line 32099 "c/sqlite3.c"
  HEAP32[$32>>2] = 0; //@line 32099 "c/sqlite3.c"
  $33 = HEAP32[10097]|0; //@line 32100 "c/sqlite3.c"
  $34 = ($33|0)==(0|0); //@line 32100 "c/sqlite3.c"
  if (!($34)) {
   $35 = ((($33)) + 44|0); //@line 32100 "c/sqlite3.c"
   HEAP32[$35>>2] = $26; //@line 32100 "c/sqlite3.c"
  }
  HEAP32[10097] = $26; //@line 32101 "c/sqlite3.c"
  $$1 = $26;
 }
 HEAP32[$1>>2] = $$1; //@line 32105 "c/sqlite3.c"
 $$023 = 0;
 STACKTOP = sp;return ($$023|0); //@line 32107 "c/sqlite3.c"
}
function _verifyDbFile($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $1 = sp + 28|0;
 $2 = ((($0)) + 18|0); //@line 32138 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 32138 "c/sqlite3.c"
 $4 = $3 & 128; //@line 32138 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 32138 "c/sqlite3.c"
 if (!($5)) {
  STACKTOP = sp;return; //@line 32157 "c/sqlite3.c"
 }
 $6 = HEAP32[(1592)>>2]|0; //@line 32140 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 32140 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 32140 "c/sqlite3.c"
 $9 = (FUNCTION_TABLE_iii[$6 & 255]($8,$1)|0); //@line 32140 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 32141 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($0)) + 32|0); //@line 32142 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 32142 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $12; //@line 32142 "c/sqlite3.c"
  _sqlite3_log(28,15864,$vararg_buffer); //@line 32142 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 32157 "c/sqlite3.c"
 }
 $13 = ((($1)) + 16|0); //@line 32145 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 32145 "c/sqlite3.c"
 switch ($14|0) {
 case 0:  {
  $15 = ((($0)) + 32|0); //@line 32146 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 32146 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = $16; //@line 32146 "c/sqlite3.c"
  _sqlite3_log(28,15888,$vararg_buffer1); //@line 32146 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 32157 "c/sqlite3.c"
  break;
 }
 case 1:  {
  $19 = (_fileHasMoved($0)|0); //@line 32153 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 32153 "c/sqlite3.c"
  if ($20) {
   STACKTOP = sp;return; //@line 32157 "c/sqlite3.c"
  }
  $21 = ((($0)) + 32|0); //@line 32154 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 32154 "c/sqlite3.c"
  HEAP32[$vararg_buffer7>>2] = $22; //@line 32154 "c/sqlite3.c"
  _sqlite3_log(28,15944,$vararg_buffer7); //@line 32154 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 32157 "c/sqlite3.c"
  break;
 }
 default: {
  $17 = ((($0)) + 32|0); //@line 32150 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 32150 "c/sqlite3.c"
  HEAP32[$vararg_buffer4>>2] = $18; //@line 32150 "c/sqlite3.c"
  _sqlite3_log(28,15917,$vararg_buffer4); //@line 32150 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 32157 "c/sqlite3.c"
 }
 }
}
function _unixClose($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _verifyDbFile($0); //@line 32746 "c/sqlite3.c"
 (_unixUnlock($0,0)|0); //@line 32747 "c/sqlite3.c"
 _unixEnterMutex(); //@line 32748 "c/sqlite3.c"
 $1 = ((($0)) + 8|0); //@line 32754 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 32754 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 32754 "c/sqlite3.c"
 if (!($3)) {
  $4 = ((($2)) + 32|0); //@line 32754 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 32754 "c/sqlite3.c"
  $6 = ($5|0)==(0); //@line 32754 "c/sqlite3.c"
  if (!($6)) {
   _setPendingFd($0); //@line 32760 "c/sqlite3.c"
  }
 }
 _releaseInodeInfo($0); //@line 32762 "c/sqlite3.c"
 _closeUnixFile($0); //@line 32763 "c/sqlite3.c"
 _unixLeaveMutex(); //@line 32764 "c/sqlite3.c"
 return 0; //@line 32765 "c/sqlite3.c"
}
function _unixLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$061 = 0, $$062 = 0, $$16366 = 0, $$167 = 0, $$275 = 0, $$27576 = 0, $$3 = 0, $$off = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $9 = 0, $not$ = 0, $or$cond = 0, $or$cond3 = 0, $storemerge = 0, $switch = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 16|0); //@line 32332 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 32332 "c/sqlite3.c"
 $5 = $4&255; //@line 32332 "c/sqlite3.c"
 $6 = ($5|0)<($1|0); //@line 32332 "c/sqlite3.c"
 if (!($6)) {
  $$061 = 0;
  STACKTOP = sp;return ($$061|0); //@line 32497 "c/sqlite3.c"
 }
 _unixEnterMutex(); //@line 32349 "c/sqlite3.c"
 $7 = ((($0)) + 8|0); //@line 32350 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 32350 "c/sqlite3.c"
 $9 = HEAP8[$3>>0]|0; //@line 32355 "c/sqlite3.c"
 $10 = ((($8)) + 20|0); //@line 32355 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 32355 "c/sqlite3.c"
 $12 = ($9<<24>>24)==($11<<24>>24); //@line 32355 "c/sqlite3.c"
 if ($12) {
  label = 4;
 } else {
  $13 = ($11&255)>(2); //@line 32356 "c/sqlite3.c"
  $14 = ($1|0)>(1); //@line 32356 "c/sqlite3.c"
  $or$cond = $14 | $13; //@line 32356 "c/sqlite3.c"
  if ($or$cond) {
   $$3 = 5;
  } else {
   label = 4;
  }
 }
 L6: do {
  if ((label|0) == 4) {
   $15 = ($1|0)==(1); //@line 32366 "c/sqlite3.c"
   do {
    if ($15) {
     $$off = (($11) + -1)<<24>>24; //@line 32367 "c/sqlite3.c"
     $switch = ($$off&255)<(2); //@line 32367 "c/sqlite3.c"
     if ($switch) {
      HEAP8[$3>>0] = 1; //@line 32371 "c/sqlite3.c"
      $18 = ((($8)) + 16|0); //@line 32372 "c/sqlite3.c"
      $19 = HEAP32[$18>>2]|0; //@line 32372 "c/sqlite3.c"
      $20 = (($19) + 1)|0; //@line 32372 "c/sqlite3.c"
      HEAP32[$18>>2] = $20; //@line 32372 "c/sqlite3.c"
      $21 = ((($8)) + 32|0); //@line 32373 "c/sqlite3.c"
      $22 = HEAP32[$21>>2]|0; //@line 32373 "c/sqlite3.c"
      $23 = (($22) + 1)|0; //@line 32373 "c/sqlite3.c"
      HEAP32[$21>>2] = $23; //@line 32373 "c/sqlite3.c"
      $$3 = 0;
      break L6;
     } else {
      $16 = ((($2)) + 8|0); //@line 32382 "c/sqlite3.c"
      HEAP32[$16>>2] = 1; //@line 32382 "c/sqlite3.c"
      $17 = ((($2)) + 2|0); //@line 32383 "c/sqlite3.c"
      HEAP16[$17>>1] = 0; //@line 32383 "c/sqlite3.c"
      $40 = $16;
      label = 10;
      break;
     }
    } else {
     $24 = ((($2)) + 8|0); //@line 32382 "c/sqlite3.c"
     HEAP32[$24>>2] = 1; //@line 32382 "c/sqlite3.c"
     $25 = ((($2)) + 2|0); //@line 32383 "c/sqlite3.c"
     HEAP16[$25>>1] = 0; //@line 32383 "c/sqlite3.c"
     $26 = ($1|0)==(4); //@line 32385 "c/sqlite3.c"
     if ($26) {
      $27 = ($9&255)<(3); //@line 32385 "c/sqlite3.c"
      if ($27) {
       $40 = $24;
       label = 10;
      } else {
       $78 = $24;
       label = 22;
      }
     } else {
      $77 = $24;
      label = 21;
     }
    }
   } while(0);
   L15: do {
    if ((label|0) == 10) {
     $not$ = $15 ^ 1; //@line 32387 "c/sqlite3.c"
     $28 = $not$&1; //@line 32387 "c/sqlite3.c"
     HEAP16[$2>>1] = $28; //@line 32387 "c/sqlite3.c"
     $29 = HEAP32[513]|0; //@line 32388 "c/sqlite3.c"
     $30 = ((($2)) + 4|0); //@line 32388 "c/sqlite3.c"
     HEAP32[$30>>2] = $29; //@line 32388 "c/sqlite3.c"
     $31 = (_unixFileLock($0,$2)|0); //@line 32389 "c/sqlite3.c"
     $32 = ($31|0)==(0); //@line 32389 "c/sqlite3.c"
     if (!($32)) {
      $33 = (___errno_location()|0); //@line 32390 "c/sqlite3.c"
      $34 = HEAP32[$33>>2]|0; //@line 32390 "c/sqlite3.c"
      $35 = (_sqliteErrorFromPosixError($34)|0); //@line 32391 "c/sqlite3.c"
      $36 = ($35|0)==(5); //@line 32392 "c/sqlite3.c"
      if ($36) {
       $$3 = 5;
       break L6;
      }
      _storeLastErrno($0,$34); //@line 32393 "c/sqlite3.c"
      $$3 = $35;
      break L6;
     }
     if ($15) {
      $37 = HEAP32[513]|0; //@line 32409 "c/sqlite3.c"
      $38 = (($37) + 2)|0; //@line 32409 "c/sqlite3.c"
      $39 = ((($2)) + 4|0); //@line 32409 "c/sqlite3.c"
      HEAP32[$39>>2] = $38; //@line 32409 "c/sqlite3.c"
      HEAP32[$40>>2] = 510; //@line 32410 "c/sqlite3.c"
      $41 = (_unixFileLock($0,$2)|0); //@line 32411 "c/sqlite3.c"
      $42 = ($41|0)==(0); //@line 32411 "c/sqlite3.c"
      if ($42) {
       $$0 = 0;$$062 = 0;
      } else {
       $43 = (___errno_location()|0); //@line 32412 "c/sqlite3.c"
       $44 = HEAP32[$43>>2]|0; //@line 32412 "c/sqlite3.c"
       $45 = (_sqliteErrorFromPosixError($44)|0); //@line 32413 "c/sqlite3.c"
       $$0 = $44;$$062 = $45;
      }
      $46 = HEAP32[513]|0; //@line 32417 "c/sqlite3.c"
      HEAP32[$39>>2] = $46; //@line 32417 "c/sqlite3.c"
      HEAP32[$40>>2] = 1; //@line 32418 "c/sqlite3.c"
      HEAP16[$2>>1] = 2; //@line 32419 "c/sqlite3.c"
      $47 = (_unixFileLock($0,$2)|0); //@line 32420 "c/sqlite3.c"
      $48 = ($47|0)!=(0); //@line 32420 "c/sqlite3.c"
      $49 = ($$062|0)==(0); //@line 32420 "c/sqlite3.c"
      $or$cond3 = $49 & $48; //@line 32420 "c/sqlite3.c"
      L25: do {
       if ($or$cond3) {
        $50 = (___errno_location()|0); //@line 32422 "c/sqlite3.c"
        $51 = HEAP32[$50>>2]|0; //@line 32422 "c/sqlite3.c"
        $$16366 = 2058;$$167 = $51;
       } else {
        switch ($$062|0) {
        case 5:  {
         $$3 = $$062;
         break L6;
         break;
        }
        case 0:  {
         break;
        }
        default: {
         $$16366 = $$062;$$167 = $$0;
         break L25;
        }
        }
        HEAP8[$3>>0] = 1; //@line 32432 "c/sqlite3.c"
        $52 = ((($8)) + 32|0); //@line 32433 "c/sqlite3.c"
        $53 = HEAP32[$52>>2]|0; //@line 32433 "c/sqlite3.c"
        $54 = (($53) + 1)|0; //@line 32433 "c/sqlite3.c"
        HEAP32[$52>>2] = $54; //@line 32433 "c/sqlite3.c"
        $55 = ((($8)) + 16|0); //@line 32434 "c/sqlite3.c"
        HEAP32[$55>>2] = 1; //@line 32434 "c/sqlite3.c"
        label = 30;
        break L15;
       }
      } while(0);
      _storeLastErrno($0,$$167); //@line 32428 "c/sqlite3.c"
      $$3 = $$16366;
      break L6;
     } else {
      $77 = $40;
      label = 21;
     }
    }
   } while(0);
   if ((label|0) == 21) {
    $56 = ($1|0)==(4); //@line 32436 "c/sqlite3.c"
    if ($56) {
     $78 = $77;
     label = 22;
    } else {
     HEAP16[$2>>1] = 1; //@line 32446 "c/sqlite3.c"
     $61 = ($1|0)==(2); //@line 32449 "c/sqlite3.c"
     $62 = HEAP32[513]|0;
     if ($61) {
      $63 = (($62) + 1)|0; //@line 32450 "c/sqlite3.c"
      $$sink = $63;$67 = $77;$storemerge = 1;
      label = 27;
     } else {
      $65 = $62;$79 = $77;
      label = 26;
     }
    }
   }
   if ((label|0) == 22) {
    $57 = ((($8)) + 16|0); //@line 32436 "c/sqlite3.c"
    $58 = HEAP32[$57>>2]|0; //@line 32436 "c/sqlite3.c"
    $59 = ($58|0)>(1); //@line 32436 "c/sqlite3.c"
    if ($59) {
     $$27576 = 5;
     label = 32;
    } else {
     HEAP16[$2>>1] = 1; //@line 32446 "c/sqlite3.c"
     $60 = HEAP32[513]|0;
     $65 = $60;$79 = $78;
     label = 26;
    }
   }
   if ((label|0) == 26) {
    $64 = (($65) + 2)|0; //@line 32453 "c/sqlite3.c"
    $$sink = $64;$67 = $79;$storemerge = 510;
    label = 27;
   }
   do {
    if ((label|0) == 27) {
     $66 = ((($2)) + 4|0);
     HEAP32[$66>>2] = $$sink;
     HEAP32[$67>>2] = $storemerge;
     $68 = (_unixFileLock($0,$2)|0); //@line 32457 "c/sqlite3.c"
     $69 = ($68|0)==(0); //@line 32457 "c/sqlite3.c"
     if ($69) {
      label = 30;
     } else {
      $70 = (___errno_location()|0); //@line 32458 "c/sqlite3.c"
      $71 = HEAP32[$70>>2]|0; //@line 32458 "c/sqlite3.c"
      $72 = (_sqliteErrorFromPosixError($71)|0); //@line 32459 "c/sqlite3.c"
      $73 = ($72|0)==(5); //@line 32460 "c/sqlite3.c"
      if ($73) {
       $$275 = 5;
      } else {
       _storeLastErrno($0,$71); //@line 32461 "c/sqlite3.c"
       $74 = ($72|0)==(0); //@line 32484 "c/sqlite3.c"
       if ($74) {
        label = 30;
        break;
       } else {
        $$275 = $72;
       }
      }
      $76 = ($1|0)==(4); //@line 32487 "c/sqlite3.c"
      if ($76) {
       $$27576 = $$275;
       label = 32;
      } else {
       $$3 = $$275;
       break L6;
      }
     }
    }
   } while(0);
   if ((label|0) == 30) {
    $75 = $1&255; //@line 32485 "c/sqlite3.c"
    HEAP8[$3>>0] = $75; //@line 32485 "c/sqlite3.c"
    HEAP8[$10>>0] = $75; //@line 32486 "c/sqlite3.c"
    $$3 = 0;
    break;
   }
   else if ((label|0) == 32) {
    HEAP8[$3>>0] = 3; //@line 32488 "c/sqlite3.c"
    HEAP8[$10>>0] = 3; //@line 32489 "c/sqlite3.c"
    $$3 = $$27576;
    break;
   }
  }
 } while(0);
 _unixLeaveMutex(); //@line 32493 "c/sqlite3.c"
 $$061 = $$3;
 STACKTOP = sp;return ($$061|0); //@line 32497 "c/sqlite3.c"
}
function _unixUnlock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_posixUnlock($0,$1)|0); //@line 32690 "c/sqlite3.c"
 return ($2|0); //@line 32690 "c/sqlite3.c"
}
function _unixCheckReservedLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$1 = 0, $$114 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $narrow = 0, $spec$select15 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $2 = sp + 8|0;
 _unixEnterMutex(); //@line 32175 "c/sqlite3.c"
 $3 = ((($0)) + 8|0); //@line 32178 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 32178 "c/sqlite3.c"
 $5 = ((($4)) + 20|0); //@line 32178 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 32178 "c/sqlite3.c"
 $7 = ($6&255)>(1); //@line 32178 "c/sqlite3.c"
 if ($7) {
  $$1 = 0;$$2 = 1;
  _unixLeaveMutex(); //@line 32200 "c/sqlite3.c"
  HEAP32[$1>>2] = $$2; //@line 32203 "c/sqlite3.c"
  STACKTOP = sp;return ($$1|0); //@line 32204 "c/sqlite3.c"
 }
 $8 = ((($4)) + 21|0); //@line 32185 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 32185 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 32185 "c/sqlite3.c"
 if (!($10)) {
  $$1 = 0;$$2 = 0;
  _unixLeaveMutex(); //@line 32200 "c/sqlite3.c"
  HEAP32[$1>>2] = $$2; //@line 32203 "c/sqlite3.c"
  STACKTOP = sp;return ($$1|0); //@line 32204 "c/sqlite3.c"
 }
 $11 = ((($2)) + 2|0); //@line 32187 "c/sqlite3.c"
 HEAP16[$11>>1] = 0; //@line 32187 "c/sqlite3.c"
 $12 = HEAP32[513]|0; //@line 32188 "c/sqlite3.c"
 $13 = (($12) + 1)|0; //@line 32188 "c/sqlite3.c"
 $14 = ((($2)) + 4|0); //@line 32188 "c/sqlite3.c"
 HEAP32[$14>>2] = $13; //@line 32188 "c/sqlite3.c"
 $15 = ((($2)) + 8|0); //@line 32189 "c/sqlite3.c"
 HEAP32[$15>>2] = 1; //@line 32189 "c/sqlite3.c"
 HEAP16[$2>>1] = 1; //@line 32190 "c/sqlite3.c"
 $16 = HEAP32[(1616)>>2]|0; //@line 32191 "c/sqlite3.c"
 $17 = ((($0)) + 12|0); //@line 32191 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 32191 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 32191 "c/sqlite3.c"
 $19 = (FUNCTION_TABLE_iiii[$16 & 127]($18,12,$vararg_buffer)|0); //@line 32191 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 32191 "c/sqlite3.c"
 if ($20) {
  $23 = HEAP16[$2>>1]|0; //@line 32194 "c/sqlite3.c"
  $24 = ($23<<16>>16)!=(2); //@line 32194 "c/sqlite3.c"
  $narrow = $7 | $24; //@line 32194 "c/sqlite3.c"
  $spec$select15 = $narrow&1; //@line 32194 "c/sqlite3.c"
  $$0 = 0;$$114 = $spec$select15;
 } else {
  $21 = (___errno_location()|0); //@line 32193 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 32193 "c/sqlite3.c"
  _storeLastErrno($0,$22); //@line 32193 "c/sqlite3.c"
  $$0 = 3594;$$114 = 0;
 }
 $$1 = $$0;$$2 = $$114;
 _unixLeaveMutex(); //@line 32200 "c/sqlite3.c"
 HEAP32[$1>>2] = $$2; //@line 32203 "c/sqlite3.c"
 STACKTOP = sp;return ($$1|0); //@line 32204 "c/sqlite3.c"
}
function _unixShmMap($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0108121 = 0, $$0109 = 0, $$0111126 = 0, $$8 = 0, $$9 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $spec$select = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $5 = sp + 4|0;
 $6 = sp;
 $7 = (_unixShmRegionPerMap()|0); //@line 35261 "c/sqlite3.c"
 $8 = ((($0)) + 36|0); //@line 35265 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 35265 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 35265 "c/sqlite3.c"
 if ($10) {
  $11 = (_unixOpenSharedMemory($0)|0); //@line 35266 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 35267 "c/sqlite3.c"
  if (!($12)) {
   $$0109 = $11;
   STACKTOP = sp;return ($$0109|0); //@line 35383 "c/sqlite3.c"
  }
 }
 $13 = HEAP32[$8>>2]|0; //@line 35270 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 35271 "c/sqlite3.c"
 $15 = ((($14)) + 4|0); //@line 35272 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 35272 "c/sqlite3.c"
 _sqlite3_mutex_enter($16); //@line 35272 "c/sqlite3.c"
 $17 = ((($14)) + 23|0); //@line 35273 "c/sqlite3.c"
 $18 = HEAP8[$17>>0]|0; //@line 35273 "c/sqlite3.c"
 $19 = ($18<<24>>24)==(0); //@line 35273 "c/sqlite3.c"
 if ($19) {
  label = 6;
 } else {
  $20 = (_unixLockSharedMemory($0,$14)|0); //@line 35274 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 35275 "c/sqlite3.c"
  if ($21) {
   HEAP8[$17>>0] = 0; //@line 35276 "c/sqlite3.c"
   label = 6;
  } else {
   $$9 = $20;
  }
 }
 if ((label|0) == 6) {
  $22 = (($7) + ($1))|0; //@line 35284 "c/sqlite3.c"
  $23 = (($22|0) % ($7|0))&-1; //@line 35284 "c/sqlite3.c"
  $24 = (($22) - ($23))|0; //@line 35284 "c/sqlite3.c"
  $25 = ((($14)) + 20|0); //@line 35286 "c/sqlite3.c"
  $26 = HEAP16[$25>>1]|0; //@line 35286 "c/sqlite3.c"
  $27 = $26&65535; //@line 35286 "c/sqlite3.c"
  $28 = ($24|0)>($27|0); //@line 35286 "c/sqlite3.c"
  if ($28) {
   $29 = Math_imul($24, $2)|0; //@line 35288 "c/sqlite3.c"
   $30 = ((($14)) + 16|0); //@line 35291 "c/sqlite3.c"
   HEAP32[$30>>2] = $2; //@line 35291 "c/sqlite3.c"
   $31 = ((($14)) + 12|0); //@line 35293 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 35293 "c/sqlite3.c"
   $33 = ($32|0)>(-1); //@line 35293 "c/sqlite3.c"
   L11: do {
    if ($33) {
     $34 = HEAP32[(1592)>>2]|0; //@line 35298 "c/sqlite3.c"
     $35 = (FUNCTION_TABLE_iii[$34 & 255]($32,$5)|0); //@line 35298 "c/sqlite3.c"
     $36 = ($35|0)==(0); //@line 35298 "c/sqlite3.c"
     if ($36) {
      $37 = ((($5)) + 36|0); //@line 35303 "c/sqlite3.c"
      $38 = HEAP32[$37>>2]|0; //@line 35303 "c/sqlite3.c"
      $39 = ($38|0)<($29|0); //@line 35303 "c/sqlite3.c"
      if ($39) {
       $40 = ($3|0)==(0); //@line 35307 "c/sqlite3.c"
       if ($40) {
        $$8 = 0;
       } else {
        $41 = (($38|0) / 4096)&-1; //@line 35324 "c/sqlite3.c"
        $42 = (($29|0) / 4096)&-1; //@line 35324 "c/sqlite3.c"
        $43 = ($41|0)<($42|0); //@line 35324 "c/sqlite3.c"
        if ($43) {
         $$0111126 = $41;
         while(1) {
          HEAP32[$6>>2] = 0; //@line 35325 "c/sqlite3.c"
          $44 = HEAP32[$31>>2]|0; //@line 35326 "c/sqlite3.c"
          $45 = $$0111126 << 12; //@line 35326 "c/sqlite3.c"
          $46 = $45 | 4095; //@line 35326 "c/sqlite3.c"
          $47 = ($46|0)<(0); //@line 35326 "c/sqlite3.c"
          $48 = $47 << 31 >> 31; //@line 35326 "c/sqlite3.c"
          $49 = (_seekAndWriteFd($44,$46,$48,41388,1,$6)|0); //@line 35326 "c/sqlite3.c"
          $50 = ($49|0)==(1); //@line 35326 "c/sqlite3.c"
          if (!($50)) {
           break;
          }
          $51 = (($$0111126) + 1)|0; //@line 35324 "c/sqlite3.c"
          $52 = ($51|0)<($42|0); //@line 35324 "c/sqlite3.c"
          if ($52) {
           $$0111126 = $51;
          } else {
           label = 16;
           break L11;
          }
         }
         $53 = ((($14)) + 8|0); //@line 35327 "c/sqlite3.c"
         $54 = HEAP32[$53>>2]|0; //@line 35327 "c/sqlite3.c"
         (_unixLogErrorAtLine(4874,15548,$54,35328)|0); //@line 35328 "c/sqlite3.c"
         $$8 = 4874;
        } else {
         label = 16;
        }
       }
      } else {
       label = 16;
      }
     } else {
      $$8 = 4874;
     }
    } else {
     label = 16;
    }
   } while(0);
   L21: do {
    if ((label|0) == 16) {
     $55 = ((($14)) + 24|0); //@line 35338 "c/sqlite3.c"
     $56 = HEAP32[$55>>2]|0; //@line 35338 "c/sqlite3.c"
     $57 = $24 << 2; //@line 35338 "c/sqlite3.c"
     $58 = (_sqlite3_realloc($56,$57)|0); //@line 35337 "c/sqlite3.c"
     $59 = ($58|0)==(0|0); //@line 35340 "c/sqlite3.c"
     if ($59) {
      $$8 = 3082;
     } else {
      HEAP32[$55>>2] = $58; //@line 35344 "c/sqlite3.c"
      $60 = HEAP16[$25>>1]|0; //@line 35345 "c/sqlite3.c"
      $61 = $60&65535; //@line 35345 "c/sqlite3.c"
      $62 = ($24|0)>($61|0); //@line 35345 "c/sqlite3.c"
      if ($62) {
       $63 = Math_imul($7, $2)|0;
       $64 = ((($14)) + 22|0);
       $65 = ($7|0)>(0);
       $66 = ($2|0)<(0);
       $67 = $66 << 31 >> 31;
       $75 = $61;
       while(1) {
        $68 = HEAP32[$31>>2]|0; //@line 35349 "c/sqlite3.c"
        $69 = ($68|0)>(-1); //@line 35349 "c/sqlite3.c"
        if ($69) {
         $70 = HEAP32[(1796)>>2]|0; //@line 35350 "c/sqlite3.c"
         $71 = HEAP8[$64>>0]|0; //@line 35351 "c/sqlite3.c"
         $72 = ($71<<24>>24)==(0); //@line 35351 "c/sqlite3.c"
         $73 = $72 ? 3 : 1; //@line 35351 "c/sqlite3.c"
         $74 = Math_imul($75, $2)|0; //@line 35352 "c/sqlite3.c"
         $76 = (FUNCTION_TABLE_iiiiiii[$70 & 127](0,$63,$73,1,$68,$74)|0); //@line 35350 "c/sqlite3.c"
         $77 = ($76|0)==((-1)|0); //@line 35354 "c/sqlite3.c"
         if ($77) {
          break;
         } else {
          $$0 = $76;
         }
        } else {
         $80 = (_sqlite3_malloc64($2,$67)|0); //@line 35359 "c/sqlite3.c"
         $81 = ($80|0)==(0|0); //@line 35360 "c/sqlite3.c"
         if ($81) {
          $$8 = 7;
          break L21;
         }
         _memset(($80|0),0,($2|0))|0; //@line 35364 "c/sqlite3.c"
         $$0 = $80;
        }
        if ($65) {
         $82 = HEAP16[$25>>1]|0;
         $83 = $82&65535;
         $$0108121 = 0;
         while(1) {
          $84 = Math_imul($$0108121, $2)|0; //@line 35368 "c/sqlite3.c"
          $85 = (($$0) + ($84)|0); //@line 35368 "c/sqlite3.c"
          $86 = HEAP32[$55>>2]|0; //@line 35368 "c/sqlite3.c"
          $87 = (($$0108121) + ($83))|0; //@line 35368 "c/sqlite3.c"
          $88 = (($86) + ($87<<2)|0); //@line 35368 "c/sqlite3.c"
          HEAP32[$88>>2] = $85; //@line 35368 "c/sqlite3.c"
          $89 = (($$0108121) + 1)|0; //@line 35367 "c/sqlite3.c"
          $exitcond = ($89|0)==($7|0); //@line 35367 "c/sqlite3.c"
          if ($exitcond) {
           break;
          } else {
           $$0108121 = $89;
          }
         }
        }
        $90 = HEAP16[$25>>1]|0; //@line 35370 "c/sqlite3.c"
        $91 = $90&65535; //@line 35370 "c/sqlite3.c"
        $92 = (($7) + ($91))|0; //@line 35370 "c/sqlite3.c"
        $93 = $92&65535; //@line 35370 "c/sqlite3.c"
        HEAP16[$25>>1] = $93; //@line 35370 "c/sqlite3.c"
        $94 = $92 & 65535; //@line 35345 "c/sqlite3.c"
        $95 = ($24|0)>($94|0); //@line 35345 "c/sqlite3.c"
        if ($95) {
         $75 = $94;
        } else {
         $$8 = 0;
         break L21;
        }
       }
       $78 = ((($14)) + 8|0); //@line 35355 "c/sqlite3.c"
       $79 = HEAP32[$78>>2]|0; //@line 35355 "c/sqlite3.c"
       (_unixLogErrorAtLine(5386,15635,$79,35355)|0); //@line 35355 "c/sqlite3.c"
       $$8 = 5386;
      } else {
       $$8 = 0;
      }
     }
    }
   } while(0);
   $$9 = $$8;
  } else {
   $$9 = 0;
  }
 }
 $96 = ((($14)) + 20|0); //@line 35375 "c/sqlite3.c"
 $97 = HEAP16[$96>>1]|0; //@line 35375 "c/sqlite3.c"
 $98 = $97&65535; //@line 35375 "c/sqlite3.c"
 $99 = ($98|0)>($1|0); //@line 35375 "c/sqlite3.c"
 if ($99) {
  $100 = ((($14)) + 24|0); //@line 35376 "c/sqlite3.c"
  $101 = HEAP32[$100>>2]|0; //@line 35376 "c/sqlite3.c"
  $102 = (($101) + ($1<<2)|0); //@line 35376 "c/sqlite3.c"
  $103 = HEAP32[$102>>2]|0; //@line 35376 "c/sqlite3.c"
  $storemerge = $103;
 } else {
  $storemerge = 0;
 }
 HEAP32[$4>>2] = $storemerge;
 $104 = ((($14)) + 22|0); //@line 35380 "c/sqlite3.c"
 $105 = HEAP8[$104>>0]|0; //@line 35380 "c/sqlite3.c"
 $106 = ($105<<24>>24)!=(0); //@line 35380 "c/sqlite3.c"
 $107 = ($$9|0)==(0); //@line 35380 "c/sqlite3.c"
 $or$cond = $107 & $106; //@line 35380 "c/sqlite3.c"
 $spec$select = $or$cond ? 8 : $$9; //@line 35380 "c/sqlite3.c"
 $108 = HEAP32[$15>>2]|0; //@line 35381 "c/sqlite3.c"
 _sqlite3_mutex_leave($108); //@line 35381 "c/sqlite3.c"
 $$0109 = $spec$select;
 STACKTOP = sp;return ($$0109|0); //@line 35383 "c/sqlite3.c"
}
function _unixOpenSharedMemory($0) {
 $0 = $0|0;
 var $$0 = 0, $$071 = 0, $$1 = 0, $$172$ph = 0, $$2 = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $vararg_buffer = sp;
 $1 = sp + 4|0;
 $2 = (_sqlite3_malloc64(16,0)|0); //@line 35120 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 35121 "c/sqlite3.c"
 if ($3) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 35229 "c/sqlite3.c"
 }
 ;HEAP32[$2>>2]=0|0;HEAP32[$2+4>>2]=0|0;HEAP32[$2+8>>2]=0|0;HEAP32[$2+12>>2]=0|0; //@line 35122 "c/sqlite3.c"
 _unixEnterMutex(); //@line 35128 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 35129 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 35129 "c/sqlite3.c"
 $6 = ((($5)) + 28|0); //@line 35130 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 35130 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 35131 "c/sqlite3.c"
 L4: do {
  if ($8) {
   $9 = ((($0)) + 32|0); //@line 35134 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 35134 "c/sqlite3.c"
   $11 = HEAP32[(1592)>>2]|0; //@line 35141 "c/sqlite3.c"
   $12 = ((($0)) + 12|0); //@line 35141 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 35141 "c/sqlite3.c"
   $14 = (FUNCTION_TABLE_iii[$11 & 255]($13,$1)|0); //@line 35141 "c/sqlite3.c"
   $15 = ($14|0)==(0); //@line 35141 "c/sqlite3.c"
   L6: do {
    if ($15) {
     $16 = (_strlen($10)|0); //@line 35149 "c/sqlite3.c"
     $17 = (($16) + 42)|0; //@line 35151 "c/sqlite3.c"
     $18 = (_sqlite3_malloc64($17,0)|0); //@line 35151 "c/sqlite3.c"
     $19 = ($18|0)==(0|0); //@line 35152 "c/sqlite3.c"
     if ($19) {
      $$172$ph = 7;
     } else {
      $20 = (($16) + 6)|0; //@line 35149 "c/sqlite3.c"
      _memset(($18|0),0,($17|0))|0; //@line 35156 "c/sqlite3.c"
      $21 = ((($18)) + 36|0); //@line 35157 "c/sqlite3.c"
      $22 = ((($18)) + 8|0); //@line 35157 "c/sqlite3.c"
      HEAP32[$22>>2] = $21; //@line 35157 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $10; //@line 35163 "c/sqlite3.c"
      (_sqlite3_snprintf($20,$21,15972,$vararg_buffer)|0); //@line 35163 "c/sqlite3.c"
      $23 = ((($18)) + 12|0); //@line 35166 "c/sqlite3.c"
      HEAP32[$23>>2] = -1; //@line 35166 "c/sqlite3.c"
      $24 = HEAP32[$4>>2]|0; //@line 35167 "c/sqlite3.c"
      $25 = ((($24)) + 28|0); //@line 35167 "c/sqlite3.c"
      HEAP32[$25>>2] = $18; //@line 35167 "c/sqlite3.c"
      $26 = HEAP32[$4>>2]|0; //@line 35168 "c/sqlite3.c"
      HEAP32[$18>>2] = $26; //@line 35168 "c/sqlite3.c"
      $27 = HEAP32[(12)>>2]|0; //@line 35169 "c/sqlite3.c"
      $28 = ($27|0)==(0); //@line 35169 "c/sqlite3.c"
      if (!($28)) {
       $29 = (_sqlite3_mutex_alloc(0)|0); //@line 35170 "c/sqlite3.c"
       $30 = ((($18)) + 4|0); //@line 35170 "c/sqlite3.c"
       HEAP32[$30>>2] = $29; //@line 35170 "c/sqlite3.c"
       $31 = ($29|0)==(0|0); //@line 35171 "c/sqlite3.c"
       if ($31) {
        $$172$ph = 7;
        break;
       }
      }
      $32 = ((($5)) + 21|0); //@line 35177 "c/sqlite3.c"
      $33 = HEAP8[$32>>0]|0; //@line 35177 "c/sqlite3.c"
      $34 = ($33<<24>>24)==(0); //@line 35177 "c/sqlite3.c"
      if ($34) {
       $35 = HEAP32[$9>>2]|0; //@line 35178 "c/sqlite3.c"
       $36 = (_sqlite3_uri_boolean($35,15979,0)|0); //@line 35178 "c/sqlite3.c"
       $37 = ($36|0)==(0); //@line 35178 "c/sqlite3.c"
       if ($37) {
        $38 = ((($1)) + 12|0); //@line 35179 "c/sqlite3.c"
        $39 = HEAP32[$38>>2]|0; //@line 35179 "c/sqlite3.c"
        $40 = $39 & 511; //@line 35179 "c/sqlite3.c"
        $41 = (_robust_open($21,66,$40)|0); //@line 35179 "c/sqlite3.c"
        HEAP32[$23>>2] = $41; //@line 35179 "c/sqlite3.c"
        $43 = $41;
       } else {
        $$pr = HEAP32[$23>>2]|0; //@line 35181 "c/sqlite3.c"
        $43 = $$pr;
       }
       $42 = ($43|0)<(0); //@line 35181 "c/sqlite3.c"
       do {
        if ($42) {
         $44 = ((($1)) + 12|0); //@line 35182 "c/sqlite3.c"
         $45 = HEAP32[$44>>2]|0; //@line 35182 "c/sqlite3.c"
         $46 = $45 & 511; //@line 35182 "c/sqlite3.c"
         $47 = (_robust_open($21,0,$46)|0); //@line 35182 "c/sqlite3.c"
         HEAP32[$23>>2] = $47; //@line 35182 "c/sqlite3.c"
         $48 = ($47|0)<(0); //@line 35183 "c/sqlite3.c"
         if ($48) {
          $49 = (_sqlite3CantopenError(35184)|0); //@line 35184 "c/sqlite3.c"
          $50 = (_unixLogErrorAtLine($49,15483,$21,35184)|0); //@line 35184 "c/sqlite3.c"
          $$172$ph = $50;
          break L6;
         } else {
          $51 = ((($18)) + 22|0); //@line 35187 "c/sqlite3.c"
          HEAP8[$51>>0] = 1; //@line 35187 "c/sqlite3.c"
          break;
         }
        }
       } while(0);
       $52 = HEAP32[$23>>2]|0; //@line 35194 "c/sqlite3.c"
       $53 = ((($1)) + 20|0); //@line 35194 "c/sqlite3.c"
       $54 = HEAP32[$53>>2]|0; //@line 35194 "c/sqlite3.c"
       $55 = ((($1)) + 24|0); //@line 35194 "c/sqlite3.c"
       $56 = HEAP32[$55>>2]|0; //@line 35194 "c/sqlite3.c"
       _robustFchown($52,$54,$56); //@line 35194 "c/sqlite3.c"
       $57 = (_unixLockSharedMemory($0,$18)|0); //@line 35196 "c/sqlite3.c"
       switch ($57|0) {
       case 0: case 1288:  {
        $$071 = $57;
        break;
       }
       default: {
        $$172$ph = $57;
        break L6;
       }
       }
      } else {
       $$071 = 0;
      }
      $$1 = $18;$$2 = $$071;
      break L4;
     }
    } else {
     $$172$ph = 1802;
    }
   } while(0);
   _unixShmPurge($0); //@line 35225 "c/sqlite3.c"
   _sqlite3_free($2); //@line 35226 "c/sqlite3.c"
   _unixLeaveMutex(); //@line 35227 "c/sqlite3.c"
   $$0 = $$172$ph;
   STACKTOP = sp;return ($$0|0); //@line 35229 "c/sqlite3.c"
  } else {
   $$1 = $7;$$2 = 0;
  }
 } while(0);
 HEAP32[$2>>2] = $$1; //@line 35202 "c/sqlite3.c"
 $58 = ((($$1)) + 28|0); //@line 35206 "c/sqlite3.c"
 $59 = HEAP32[$58>>2]|0; //@line 35206 "c/sqlite3.c"
 $60 = (($59) + 1)|0; //@line 35206 "c/sqlite3.c"
 HEAP32[$58>>2] = $60; //@line 35206 "c/sqlite3.c"
 $61 = ((($0)) + 36|0); //@line 35207 "c/sqlite3.c"
 HEAP32[$61>>2] = $2; //@line 35207 "c/sqlite3.c"
 _unixLeaveMutex(); //@line 35208 "c/sqlite3.c"
 $62 = ((($$1)) + 4|0); //@line 35217 "c/sqlite3.c"
 $63 = HEAP32[$62>>2]|0; //@line 35217 "c/sqlite3.c"
 _sqlite3_mutex_enter($63); //@line 35217 "c/sqlite3.c"
 $64 = ((($$1)) + 32|0); //@line 35218 "c/sqlite3.c"
 $65 = HEAP32[$64>>2]|0; //@line 35218 "c/sqlite3.c"
 $66 = ((($2)) + 4|0); //@line 35218 "c/sqlite3.c"
 HEAP32[$66>>2] = $65; //@line 35218 "c/sqlite3.c"
 HEAP32[$64>>2] = $2; //@line 35219 "c/sqlite3.c"
 $67 = HEAP32[$62>>2]|0; //@line 35220 "c/sqlite3.c"
 _sqlite3_mutex_leave($67); //@line 35220 "c/sqlite3.c"
 $$0 = $$2;
 STACKTOP = sp;return ($$0|0); //@line 35229 "c/sqlite3.c"
}
function _unixLockSharedMemory($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $2 = sp + 8|0;
 $3 = ((($2)) + 2|0); //@line 35049 "c/sqlite3.c"
 HEAP16[$3>>1] = 0; //@line 35049 "c/sqlite3.c"
 $4 = ((($2)) + 4|0); //@line 35050 "c/sqlite3.c"
 HEAP32[$4>>2] = 128; //@line 35050 "c/sqlite3.c"
 $5 = ((($2)) + 8|0); //@line 35051 "c/sqlite3.c"
 HEAP32[$5>>2] = 1; //@line 35051 "c/sqlite3.c"
 HEAP16[$2>>1] = 1; //@line 35052 "c/sqlite3.c"
 $6 = HEAP32[(1616)>>2]|0; //@line 35053 "c/sqlite3.c"
 $7 = ((($1)) + 12|0); //@line 35053 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 35053 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 35053 "c/sqlite3.c"
 $9 = (FUNCTION_TABLE_iiii[$6 & 127]($8,12,$vararg_buffer)|0); //@line 35053 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 35053 "c/sqlite3.c"
 if (!($10)) {
  $$1 = 3850;
  STACKTOP = sp;return ($$1|0); //@line 35073 "c/sqlite3.c"
 }
 $11 = HEAP16[$2>>1]|0; //@line 35055 "c/sqlite3.c"
 switch ($11<<16>>16) {
 case 2:  {
  label = 3;
  break;
 }
 case 1:  {
  $$1 = 5;
  STACKTOP = sp;return ($$1|0); //@line 35073 "c/sqlite3.c"
  break;
 }
 default: {
 }
 }
 if ((label|0) == 3) {
  $12 = ((($1)) + 22|0); //@line 35056 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 35056 "c/sqlite3.c"
  $14 = ($13<<24>>24)==(0); //@line 35056 "c/sqlite3.c"
  if (!($14)) {
   $15 = ((($1)) + 23|0); //@line 35057 "c/sqlite3.c"
   HEAP8[$15>>0] = 1; //@line 35057 "c/sqlite3.c"
   $$1 = 1288;
   STACKTOP = sp;return ($$1|0); //@line 35073 "c/sqlite3.c"
  }
  $16 = (_unixShmSystemLock($0,1,128,1)|0); //@line 35060 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 35061 "c/sqlite3.c"
  if (!($17)) {
   $$1 = $16;
   STACKTOP = sp;return ($$1|0); //@line 35073 "c/sqlite3.c"
  }
  $18 = HEAP32[$7>>2]|0; //@line 35061 "c/sqlite3.c"
  $19 = (_robust_ftruncate($18,0,0)|0); //@line 35061 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 35061 "c/sqlite3.c"
  if (!($20)) {
   $21 = ((($1)) + 8|0); //@line 35062 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 35062 "c/sqlite3.c"
   (_unixLogErrorAtLine(4618,15513,$22,35062)|0); //@line 35062 "c/sqlite3.c"
   $$1 = 4618;
   STACKTOP = sp;return ($$1|0); //@line 35073 "c/sqlite3.c"
  }
 }
 $23 = (_unixShmSystemLock($0,0,128,1)|0); //@line 35071 "c/sqlite3.c"
 $$1 = $23;
 STACKTOP = sp;return ($$1|0); //@line 35073 "c/sqlite3.c"
}
function _sqlite3_realloc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$03 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3_initialize()|0); //@line 25568 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 25568 "c/sqlite3.c"
 if (!($3)) {
  $$03 = 0;
  return ($$03|0); //@line 25572 "c/sqlite3.c"
 }
 $4 = ($1|0)>(0); //@line 25570 "c/sqlite3.c"
 $spec$select = $4 ? $1 : 0; //@line 25570 "c/sqlite3.c"
 $5 = (_sqlite3Realloc($0,$spec$select,0)|0); //@line 25571 "c/sqlite3.c"
 $$03 = $5;
 return ($$03|0); //@line 25572 "c/sqlite3.c"
}
function _sqlite3_mutex_alloc($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)<(2); //@line 23758 "c/sqlite3.c"
 if ($1) {
  $2 = (_sqlite3_initialize()|0); //@line 23758 "c/sqlite3.c"
  $3 = ($2|0)==(0); //@line 23758 "c/sqlite3.c"
  if ($3) {
   label = 4;
  } else {
   $$0 = 0;
  }
 } else {
  $4 = (_sqlite3MutexInit()|0); //@line 23759 "c/sqlite3.c"
  $5 = ($4|0)==(0); //@line 23759 "c/sqlite3.c"
  if ($5) {
   label = 4;
  } else {
   $$0 = 0;
  }
 }
 if ((label|0) == 4) {
  $6 = HEAP32[(92)>>2]|0; //@line 23762 "c/sqlite3.c"
  $7 = (FUNCTION_TABLE_ii[$6 & 255]($0)|0); //@line 23762 "c/sqlite3.c"
  $$0 = $7;
 }
 return ($$0|0); //@line 23763 "c/sqlite3.c"
}
function _posixUnlock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$ph = 0, $$032 = 0, $$1$ph = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 16|0); //@line 32538 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 32538 "c/sqlite3.c"
 $5 = $4&255; //@line 32538 "c/sqlite3.c"
 $6 = ($5|0)>($1|0); //@line 32538 "c/sqlite3.c"
 if (!($6)) {
  $$032 = 0;
  STACKTOP = sp;return ($$032|0); //@line 32677 "c/sqlite3.c"
 }
 _unixEnterMutex(); //@line 32541 "c/sqlite3.c"
 $7 = ((($0)) + 8|0); //@line 32542 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 32542 "c/sqlite3.c"
 $9 = HEAP8[$3>>0]|0; //@line 32544 "c/sqlite3.c"
 $10 = ($9&255)>(1); //@line 32544 "c/sqlite3.c"
 L4: do {
  if ($10) {
   $11 = ($1|0)==(1); //@line 32568 "c/sqlite3.c"
   if ($11) {
    HEAP16[$2>>1] = 0; //@line 32613 "c/sqlite3.c"
    $12 = ((($2)) + 2|0); //@line 32614 "c/sqlite3.c"
    HEAP16[$12>>1] = 0; //@line 32614 "c/sqlite3.c"
    $13 = HEAP32[513]|0; //@line 32615 "c/sqlite3.c"
    $14 = (($13) + 2)|0; //@line 32615 "c/sqlite3.c"
    $15 = ((($2)) + 4|0); //@line 32615 "c/sqlite3.c"
    HEAP32[$15>>2] = $14; //@line 32615 "c/sqlite3.c"
    $16 = ((($2)) + 8|0); //@line 32616 "c/sqlite3.c"
    HEAP32[$16>>2] = 510; //@line 32616 "c/sqlite3.c"
    $17 = (_unixFileLock($0,$2)|0); //@line 32617 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 32617 "c/sqlite3.c"
    if ($18) {
     label = 6;
    } else {
     $19 = (___errno_location()|0); //@line 32625 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 32625 "c/sqlite3.c"
     _storeLastErrno($0,$20); //@line 32625 "c/sqlite3.c"
     $$1$ph = 2314;
    }
   } else {
    label = 6;
   }
   do {
    if ((label|0) == 6) {
     HEAP16[$2>>1] = 2; //@line 32630 "c/sqlite3.c"
     $21 = ((($2)) + 2|0); //@line 32631 "c/sqlite3.c"
     HEAP16[$21>>1] = 0; //@line 32631 "c/sqlite3.c"
     $22 = HEAP32[513]|0; //@line 32632 "c/sqlite3.c"
     $23 = ((($2)) + 4|0); //@line 32632 "c/sqlite3.c"
     HEAP32[$23>>2] = $22; //@line 32632 "c/sqlite3.c"
     $24 = ((($2)) + 8|0); //@line 32633 "c/sqlite3.c"
     HEAP32[$24>>2] = 2; //@line 32633 "c/sqlite3.c"
     $25 = (_unixFileLock($0,$2)|0); //@line 32634 "c/sqlite3.c"
     $26 = ($25|0)==(0); //@line 32634 "c/sqlite3.c"
     if ($26) {
      $27 = ((($8)) + 20|0); //@line 32635 "c/sqlite3.c"
      HEAP8[$27>>0] = 1; //@line 32635 "c/sqlite3.c"
      break L4;
     } else {
      $28 = (___errno_location()|0); //@line 32638 "c/sqlite3.c"
      $29 = HEAP32[$28>>2]|0; //@line 32638 "c/sqlite3.c"
      _storeLastErrno($0,$29); //@line 32638 "c/sqlite3.c"
      $$1$ph = 2058;
      break;
     }
    }
   } while(0);
   _unixLeaveMutex(); //@line 32674 "c/sqlite3.c"
   $$032 = $$1$ph;
   STACKTOP = sp;return ($$032|0); //@line 32677 "c/sqlite3.c"
  }
 } while(0);
 $30 = ($1|0)==(0); //@line 32642 "c/sqlite3.c"
 if ($30) {
  $31 = ((($8)) + 16|0); //@line 32647 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 32647 "c/sqlite3.c"
  $33 = (($32) + -1)|0; //@line 32647 "c/sqlite3.c"
  HEAP32[$31>>2] = $33; //@line 32647 "c/sqlite3.c"
  $34 = ($33|0)==(0); //@line 32648 "c/sqlite3.c"
  if ($34) {
   HEAP16[$2>>1] = 2; //@line 32649 "c/sqlite3.c"
   $35 = ((($2)) + 2|0); //@line 32650 "c/sqlite3.c"
   HEAP16[$35>>1] = 0; //@line 32650 "c/sqlite3.c"
   $36 = ((($2)) + 8|0); //@line 32651 "c/sqlite3.c"
   HEAP32[$36>>2] = 0; //@line 32651 "c/sqlite3.c"
   $37 = ((($2)) + 4|0); //@line 32651 "c/sqlite3.c"
   HEAP32[$37>>2] = 0; //@line 32651 "c/sqlite3.c"
   $38 = (_unixFileLock($0,$2)|0); //@line 32652 "c/sqlite3.c"
   $39 = ($38|0)==(0); //@line 32652 "c/sqlite3.c"
   if ($39) {
    $40 = ((($8)) + 20|0); //@line 32653 "c/sqlite3.c"
    $$0$ph = 0;$$sink = $40;
   } else {
    $41 = (___errno_location()|0); //@line 32656 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 32656 "c/sqlite3.c"
    _storeLastErrno($0,$42); //@line 32656 "c/sqlite3.c"
    $43 = ((($8)) + 20|0); //@line 32657 "c/sqlite3.c"
    HEAP8[$43>>0] = 0; //@line 32657 "c/sqlite3.c"
    $$0$ph = 2058;$$sink = $3;
   }
   HEAP8[$$sink>>0] = 0;
   $$0 = $$0$ph;
  } else {
   $$0 = 0;
  }
  $44 = ((($8)) + 32|0); //@line 32666 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 32666 "c/sqlite3.c"
  $46 = (($45) + -1)|0; //@line 32666 "c/sqlite3.c"
  HEAP32[$44>>2] = $46; //@line 32666 "c/sqlite3.c"
  $47 = ($46|0)==(0); //@line 32668 "c/sqlite3.c"
  if ($47) {
   _closePendingFds($0); //@line 32669 "c/sqlite3.c"
  }
  _unixLeaveMutex(); //@line 32674 "c/sqlite3.c"
  $48 = ($$0|0)==(0); //@line 32675 "c/sqlite3.c"
  if (!($48)) {
   $$032 = $$0;
   STACKTOP = sp;return ($$032|0); //@line 32677 "c/sqlite3.c"
  }
 } else {
  _unixLeaveMutex(); //@line 32674 "c/sqlite3.c"
 }
 $49 = $1&255; //@line 32675 "c/sqlite3.c"
 HEAP8[$3>>0] = $49; //@line 32675 "c/sqlite3.c"
 $$032 = 0;
 STACKTOP = sp;return ($$032|0); //@line 32677 "c/sqlite3.c"
}
function _unixFileLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 16|0;
 $3 = ((($0)) + 8|0); //@line 32228 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 32228 "c/sqlite3.c"
 $5 = ((($0)) + 18|0); //@line 32231 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 32231 "c/sqlite3.c"
 $7 = $6 & 3; //@line 32231 "c/sqlite3.c"
 $8 = ($7<<16>>16)==(1); //@line 32231 "c/sqlite3.c"
 if (!($8)) {
  $25 = HEAP32[(1616)>>2]|0; //@line 32247 "c/sqlite3.c"
  $26 = ((($0)) + 12|0); //@line 32247 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 32247 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = $1; //@line 32247 "c/sqlite3.c"
  $28 = (FUNCTION_TABLE_iiii[$25 & 127]($27,13,$vararg_buffer1)|0); //@line 32247 "c/sqlite3.c"
  $$1 = $28;
  STACKTOP = sp;return ($$1|0); //@line 32250 "c/sqlite3.c"
 }
 $9 = ((($4)) + 21|0); //@line 32232 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 32232 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 32232 "c/sqlite3.c"
 if (!($11)) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 32250 "c/sqlite3.c"
 }
 $12 = ((($2)) + 2|0); //@line 32235 "c/sqlite3.c"
 HEAP16[$12>>1] = 0; //@line 32235 "c/sqlite3.c"
 $13 = HEAP32[513]|0; //@line 32236 "c/sqlite3.c"
 $14 = (($13) + 2)|0; //@line 32236 "c/sqlite3.c"
 $15 = ((($2)) + 4|0); //@line 32236 "c/sqlite3.c"
 HEAP32[$15>>2] = $14; //@line 32236 "c/sqlite3.c"
 $16 = ((($2)) + 8|0); //@line 32237 "c/sqlite3.c"
 HEAP32[$16>>2] = 510; //@line 32237 "c/sqlite3.c"
 HEAP16[$2>>1] = 1; //@line 32238 "c/sqlite3.c"
 $17 = HEAP32[(1616)>>2]|0; //@line 32239 "c/sqlite3.c"
 $18 = ((($0)) + 12|0); //@line 32239 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 32239 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 32239 "c/sqlite3.c"
 $20 = (FUNCTION_TABLE_iiii[$17 & 127]($19,13,$vararg_buffer)|0); //@line 32239 "c/sqlite3.c"
 $21 = ($20|0)<(0); //@line 32240 "c/sqlite3.c"
 if ($21) {
  $$1 = $20;
  STACKTOP = sp;return ($$1|0); //@line 32250 "c/sqlite3.c"
 } else {
  HEAP8[$9>>0] = 1; //@line 32241 "c/sqlite3.c"
  $22 = ((($4)) + 32|0); //@line 32242 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 32242 "c/sqlite3.c"
  $24 = (($23) + 1)|0; //@line 32242 "c/sqlite3.c"
  HEAP32[$22>>2] = $24; //@line 32242 "c/sqlite3.c"
  $$1 = $20;
  STACKTOP = sp;return ($$1|0); //@line 32250 "c/sqlite3.c"
 }
 return (0)|0;
}
function _closePendingFds($0) {
 $0 = $0|0;
 var $$in1415 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 31975 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 31975 "c/sqlite3.c"
 $3 = ((($2)) + 36|0); //@line 31978 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 31978 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 31978 "c/sqlite3.c"
 if ($5) {
  HEAP32[$3>>2] = 0; //@line 31984 "c/sqlite3.c"
  return; //@line 31985 "c/sqlite3.c"
 }
 $$in1415 = $4;
 while(1) {
  $6 = ((($$in1415)) + 8|0); //@line 31979 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 31979 "c/sqlite3.c"
  $8 = HEAP32[$$in1415>>2]|0; //@line 31980 "c/sqlite3.c"
  _robust_close($0,$8,31980); //@line 31980 "c/sqlite3.c"
  _sqlite3_free($$in1415); //@line 31981 "c/sqlite3.c"
  $9 = HEAP32[10098]|0; //@line 31982 "c/sqlite3.c"
  $10 = (($9) + -1)|0; //@line 31982 "c/sqlite3.c"
  HEAP32[10098] = $10; //@line 31982 "c/sqlite3.c"
  $11 = ($7|0)==(0|0); //@line 31978 "c/sqlite3.c"
  if ($11) {
   break;
  } else {
   $$in1415 = $7;
  }
 }
 HEAP32[$3>>2] = 0; //@line 31984 "c/sqlite3.c"
 return; //@line 31985 "c/sqlite3.c"
}
function _setPendingFd($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 32504 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 32504 "c/sqlite3.c"
 $3 = ((($0)) + 28|0); //@line 32505 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 32505 "c/sqlite3.c"
 $5 = ((($2)) + 36|0); //@line 32506 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 32506 "c/sqlite3.c"
 $7 = ((($4)) + 8|0); //@line 32506 "c/sqlite3.c"
 HEAP32[$7>>2] = $6; //@line 32506 "c/sqlite3.c"
 HEAP32[$5>>2] = $4; //@line 32507 "c/sqlite3.c"
 $8 = ((($0)) + 12|0); //@line 32508 "c/sqlite3.c"
 HEAP32[$8>>2] = -1; //@line 32508 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 32509 "c/sqlite3.c"
 $9 = HEAP32[10098]|0; //@line 32510 "c/sqlite3.c"
 $10 = (($9) + 1)|0; //@line 32510 "c/sqlite3.c"
 HEAP32[10098] = $10; //@line 32510 "c/sqlite3.c"
 return; //@line 32511 "c/sqlite3.c"
}
function _releaseInodeInfo($0) {
 $0 = $0|0;
 var $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 31994 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 31994 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 31996 "c/sqlite3.c"
 if ($3) {
  return; //@line 32016 "c/sqlite3.c"
 }
 $4 = ((($2)) + 24|0); //@line 31997 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 31997 "c/sqlite3.c"
 $6 = (($5) + -1)|0; //@line 31997 "c/sqlite3.c"
 HEAP32[$4>>2] = $6; //@line 31997 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 31998 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 32016 "c/sqlite3.c"
 }
 _closePendingFds($0); //@line 32000 "c/sqlite3.c"
 $8 = ((($2)) + 44|0); //@line 32001 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 32001 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 32001 "c/sqlite3.c"
 $11 = ((($2)) + 40|0);
 $12 = HEAP32[$11>>2]|0;
 if ($10) {
  HEAP32[10097] = $12; //@line 32006 "c/sqlite3.c"
  $14 = $12;
  $16 = $14;
 } else {
  $13 = ((($9)) + 40|0); //@line 32003 "c/sqlite3.c"
  HEAP32[$13>>2] = $12; //@line 32003 "c/sqlite3.c"
  $$pr = HEAP32[$11>>2]|0; //@line 32008 "c/sqlite3.c"
  $16 = $$pr;
 }
 $15 = ($16|0)==(0|0); //@line 32008 "c/sqlite3.c"
 if (!($15)) {
  $17 = HEAP32[$8>>2]|0; //@line 32010 "c/sqlite3.c"
  $18 = ((($16)) + 44|0); //@line 32010 "c/sqlite3.c"
  HEAP32[$18>>2] = $17; //@line 32010 "c/sqlite3.c"
 }
 _sqlite3_free($2); //@line 32012 "c/sqlite3.c"
 return; //@line 32016 "c/sqlite3.c"
}
function _sqlite3_uri_parameter($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01620 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 147314 "c/sqlite3.c"
 $3 = ($1|0)==(0|0); //@line 147314 "c/sqlite3.c"
 $or$cond = $2 | $3; //@line 147314 "c/sqlite3.c"
 if ($or$cond) {
  $$2 = 0;
  return ($$2|0); //@line 147323 "c/sqlite3.c"
 }
 $4 = (_sqlite3Strlen30($0)|0); //@line 147315 "c/sqlite3.c"
 $5 = (($4) + 1)|0; //@line 147315 "c/sqlite3.c"
 $6 = (($0) + ($5)|0); //@line 147315 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 147316 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 147316 "c/sqlite3.c"
 if ($8) {
  $$2 = 0;
  return ($$2|0); //@line 147323 "c/sqlite3.c"
 }
 $$01620 = $6;
 while(1) {
  $9 = (_strcmp($$01620,$1)|0); //@line 147317 "c/sqlite3.c"
  $10 = (_sqlite3Strlen30($$01620)|0); //@line 147318 "c/sqlite3.c"
  $11 = (($10) + 1)|0; //@line 147318 "c/sqlite3.c"
  $12 = (($$01620) + ($11)|0); //@line 147318 "c/sqlite3.c"
  $13 = ($9|0)==(0); //@line 147319 "c/sqlite3.c"
  if ($13) {
   $$2 = $12;
   label = 6;
   break;
  }
  $14 = (_sqlite3Strlen30($12)|0); //@line 147320 "c/sqlite3.c"
  $15 = (($14) + 1)|0; //@line 147320 "c/sqlite3.c"
  $16 = (($12) + ($15)|0); //@line 147320 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 147316 "c/sqlite3.c"
  $18 = ($17<<24>>24)==(0); //@line 147316 "c/sqlite3.c"
  if ($18) {
   $$2 = 0;
   label = 6;
   break;
  } else {
   $$01620 = $16;
  }
 }
 if ((label|0) == 6) {
  return ($$2|0); //@line 147323 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3GetBoolean($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_getSafetyLevel($0,1,$1)|0); //@line 115363 "c/sqlite3.c"
 $3 = ($2<<24>>24)!=(0); //@line 115363 "c/sqlite3.c"
 $4 = $3&1; //@line 115363 "c/sqlite3.c"
 return ($4|0); //@line 115363 "c/sqlite3.c"
}
function _getSafetyLevel($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$01619$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP8[$0>>0]|0; //@line 115345 "c/sqlite3.c"
 $4 = $3&255; //@line 115345 "c/sqlite3.c"
 $5 = (($4) + -48)|0; //@line 115345 "c/sqlite3.c"
 $6 = ($5>>>0)<(10); //@line 115345 "c/sqlite3.c"
 if ($6) {
  $7 = (_sqlite3Atoi($0)|0); //@line 115346 "c/sqlite3.c"
  $8 = $7&255; //@line 115346 "c/sqlite3.c"
  $$0 = $8;
  return ($$0|0); //@line 115357 "c/sqlite3.c"
 }
 $9 = (_sqlite3Strlen30($0)|0); //@line 115348 "c/sqlite3.c"
 switch ($9|0) {
 case 2:  {
  $10 = (_sqlite3_strnicmp(15992,$0,$9)|0); //@line 115350 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 115350 "c/sqlite3.c"
  if ($11) {
   $$01619$lcssa = 0;
  } else {
   $14 = (_sqlite3_strnicmp((15993),$0,$9)|0); //@line 115350 "c/sqlite3.c"
   $15 = ($14|0)==(0); //@line 115350 "c/sqlite3.c"
   if ($15) {
    $$01619$lcssa = 1;
   } else {
    $$0 = $2;
    return ($$0|0); //@line 115357 "c/sqlite3.c"
   }
  }
  break;
 }
 case 3:  {
  $16 = (_sqlite3_strnicmp((15994),$0,$9)|0); //@line 115350 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 115350 "c/sqlite3.c"
  if ($17) {
   $$01619$lcssa = 2;
  } else {
   $20 = (_sqlite3_strnicmp((16001),$0,$9)|0); //@line 115350 "c/sqlite3.c"
   $21 = ($20|0)==(0); //@line 115350 "c/sqlite3.c"
   if ($21) {
    $$01619$lcssa = 4;
   } else {
    $$0 = $2;
    return ($$0|0); //@line 115357 "c/sqlite3.c"
   }
  }
  break;
 }
 case 5:  {
  $18 = (_sqlite3_strnicmp((15996),$0,$9)|0); //@line 115350 "c/sqlite3.c"
  $19 = ($18|0)==(0); //@line 115350 "c/sqlite3.c"
  if ($19) {
   $$01619$lcssa = 3;
  } else {
   $24 = (_sqlite3_strnicmp((16007),$0,$9)|0); //@line 115350 "c/sqlite3.c"
   $25 = $24 | $1; //@line 115351 "c/sqlite3.c"
   $26 = ($25|0)==(0); //@line 115351 "c/sqlite3.c"
   if ($26) {
    $$01619$lcssa = 6;
   } else {
    $$0 = $2;
    return ($$0|0); //@line 115357 "c/sqlite3.c"
   }
  }
  break;
 }
 case 4:  {
  $22 = (_sqlite3_strnicmp((16004),$0,$9)|0); //@line 115350 "c/sqlite3.c"
  $23 = ($22|0)==(0); //@line 115350 "c/sqlite3.c"
  if ($23) {
   $$01619$lcssa = 5;
  } else {
   $27 = (_sqlite3_strnicmp((16012),$0,$9)|0); //@line 115350 "c/sqlite3.c"
   $28 = $27 | $1; //@line 115351 "c/sqlite3.c"
   $29 = ($28|0)==(0); //@line 115351 "c/sqlite3.c"
   if ($29) {
    $$01619$lcssa = 7;
   } else {
    $$0 = $2;
    return ($$0|0); //@line 115357 "c/sqlite3.c"
   }
  }
  break;
 }
 default: {
  $$0 = $2;
  return ($$0|0); //@line 115357 "c/sqlite3.c"
 }
 }
 $12 = (16017 + ($$01619$lcssa)|0); //@line 115353 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 115353 "c/sqlite3.c"
 $$0 = $13;
 return ($$0|0); //@line 115357 "c/sqlite3.c"
}
function _sqlite3Atoi($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 29256 "c/sqlite3.c"
 $2 = ($0|0)==(0|0); //@line 29257 "c/sqlite3.c"
 if (!($2)) {
  (_sqlite3GetInt32($0,$1)|0); //@line 29257 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 29258 "c/sqlite3.c"
 STACKTOP = sp;return ($3|0); //@line 29258 "c/sqlite3.c"
}
function _sqlite3_strnicmp($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$01722 = 0, $$019 = 0, $$023 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 28780 "c/sqlite3.c"
 if ($3) {
  $4 = ($1|0)!=(0|0); //@line 28781 "c/sqlite3.c"
  $5 = $4 << 31 >> 31; //@line 28781 "c/sqlite3.c"
  $$019 = $5;
  return ($$019|0); //@line 28789 "c/sqlite3.c"
 }
 $6 = ($1|0)==(0|0); //@line 28782 "c/sqlite3.c"
 if ($6) {
  $$019 = 1;
  return ($$019|0); //@line 28789 "c/sqlite3.c"
 }
 $7 = ($2|0)>(0); //@line 28787 "c/sqlite3.c"
 if (!($7)) {
  $$019 = 0;
  return ($$019|0); //@line 28789 "c/sqlite3.c"
 }
 $$01722 = $0;$$023 = $1;$$in = $2;
 while(1) {
  $8 = (($$in) + -1)|0; //@line 28787 "c/sqlite3.c"
  $9 = HEAP8[$$01722>>0]|0; //@line 28787 "c/sqlite3.c"
  $10 = ($9<<24>>24)==(0); //@line 28787 "c/sqlite3.c"
  if ($10) {
   break;
  }
  $11 = $9&255; //@line 28787 "c/sqlite3.c"
  $12 = (16025 + ($11)|0); //@line 28787 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 28787 "c/sqlite3.c"
  $14 = HEAP8[$$023>>0]|0; //@line 28787 "c/sqlite3.c"
  $15 = $14&255; //@line 28787 "c/sqlite3.c"
  $16 = (16025 + ($15)|0); //@line 28787 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 28787 "c/sqlite3.c"
  $18 = ($13<<24>>24)==($17<<24>>24); //@line 28787 "c/sqlite3.c"
  if (!($18)) {
   break;
  }
  $19 = ((($$01722)) + 1|0); //@line 28787 "c/sqlite3.c"
  $20 = ((($$023)) + 1|0); //@line 28787 "c/sqlite3.c"
  $21 = ($$in|0)>(1); //@line 28787 "c/sqlite3.c"
  if ($21) {
   $$01722 = $19;$$023 = $20;$$in = $8;
  } else {
   $$019 = 0;
   label = 10;
   break;
  }
 }
 if ((label|0) == 10) {
  return ($$019|0); //@line 28789 "c/sqlite3.c"
 }
 $22 = HEAP8[$$01722>>0]|0; //@line 28788 "c/sqlite3.c"
 $23 = $22&255; //@line 28788 "c/sqlite3.c"
 $24 = (16025 + ($23)|0); //@line 28788 "c/sqlite3.c"
 $25 = HEAP8[$24>>0]|0; //@line 28788 "c/sqlite3.c"
 $26 = $25&255; //@line 28788 "c/sqlite3.c"
 $27 = HEAP8[$$023>>0]|0; //@line 28788 "c/sqlite3.c"
 $28 = $27&255; //@line 28788 "c/sqlite3.c"
 $29 = (16025 + ($28)|0); //@line 28788 "c/sqlite3.c"
 $30 = HEAP8[$29>>0]|0; //@line 28788 "c/sqlite3.c"
 $31 = $30&255; //@line 28788 "c/sqlite3.c"
 $32 = (($26) - ($31))|0; //@line 28788 "c/sqlite3.c"
 $$019 = $32;
 return ($$019|0); //@line 28789 "c/sqlite3.c"
}
function _sqlite3GetInt32($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$048 = 0, $$048$ph = 0, $$05061 = 0, $$054 = 0, $$062 = 0, $$1 = 0, $$153$off0 = 0, $$155 = 0, $$155$ph = 0, $$2$lcssa = 0, $$260 = 0, $$lcssa = 0, $$off = 0, $$off$1 = 0, $$off$10 = 0, $$off$2 = 0, $$off$3 = 0, $$off$4 = 0, $$off$5 = 0;
 var $$off$6 = 0, $$off$7 = 0, $$off$8 = 0, $$off$9 = 0, $$pr = 0, $$pr73 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0;
 var $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $extract$t = 0, $or$cond = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 29200 "c/sqlite3.c"
 L1: do {
  switch ($2<<24>>24) {
  case 45:  {
   $3 = ((($0)) + 1|0); //@line 29202 "c/sqlite3.c"
   $$048$ph = 1;$$155$ph = $3;
   label = 14;
   break;
  }
  case 43:  {
   $4 = ((($0)) + 1|0); //@line 29204 "c/sqlite3.c"
   $$048$ph = 0;$$155$ph = $4;
   label = 14;
   break;
  }
  case 48:  {
   $5 = ((($0)) + 1|0); //@line 29208 "c/sqlite3.c"
   $6 = HEAP8[$5>>0]|0; //@line 29208 "c/sqlite3.c"
   switch ($6<<24>>24) {
   case 88: case 120:  {
    break;
   }
   default: {
    $$048 = 0;$$155 = $0;$41 = 48;
    break L1;
   }
   }
   $7 = ((($0)) + 2|0); //@line 29209 "c/sqlite3.c"
   $8 = HEAP8[$7>>0]|0; //@line 29209 "c/sqlite3.c"
   $9 = $8&255; //@line 29209 "c/sqlite3.c"
   $10 = (16281 + ($9)|0); //@line 29209 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 29209 "c/sqlite3.c"
   $12 = $11 & 8; //@line 29209 "c/sqlite3.c"
   $13 = ($12<<24>>24)==(0); //@line 29209 "c/sqlite3.c"
   if ($13) {
    $$048$ph = 0;$$155$ph = $0;
    label = 14;
   } else {
    $$054 = $7;
    while(1) {
     $14 = HEAP8[$$054>>0]|0; //@line 29213 "c/sqlite3.c"
     $15 = ($14<<24>>24)==(48); //@line 29213 "c/sqlite3.c"
     $16 = ((($$054)) + 1|0); //@line 29213 "c/sqlite3.c"
     if ($15) {
      $$054 = $16;
     } else {
      break;
     }
    }
    $17 = HEAP8[$$054>>0]|0; //@line 29214 "c/sqlite3.c"
    $18 = $17&255; //@line 29214 "c/sqlite3.c"
    $19 = (16281 + ($18)|0); //@line 29214 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 29214 "c/sqlite3.c"
    $21 = $20 & 8; //@line 29214 "c/sqlite3.c"
    $22 = ($21<<24>>24)==(0); //@line 29214 "c/sqlite3.c"
    if ($22) {
     $$0$lcssa = 0;$$lcssa = 1;
    } else {
     $$05061 = 0;$$062 = 0;$25 = $17;
     while(1) {
      $23 = $$062 << 4; //@line 29215 "c/sqlite3.c"
      $24 = $25 << 24 >> 24; //@line 29215 "c/sqlite3.c"
      $26 = (_sqlite3HexToInt($24)|0); //@line 29215 "c/sqlite3.c"
      $27 = $26&255; //@line 29215 "c/sqlite3.c"
      $28 = (($23) + ($27))|0; //@line 29215 "c/sqlite3.c"
      $29 = (($$05061) + 1)|0; //@line 29214 "c/sqlite3.c"
      $30 = (($$054) + ($29)|0); //@line 29214 "c/sqlite3.c"
      $31 = HEAP8[$30>>0]|0; //@line 29214 "c/sqlite3.c"
      $32 = $31&255; //@line 29214 "c/sqlite3.c"
      $33 = (16281 + ($32)|0); //@line 29214 "c/sqlite3.c"
      $34 = HEAP8[$33>>0]|0; //@line 29214 "c/sqlite3.c"
      $35 = $34 & 8; //@line 29214 "c/sqlite3.c"
      $36 = ($35<<24>>24)!=(0); //@line 29214 "c/sqlite3.c"
      $37 = ($29>>>0)<(8); //@line 29214 "c/sqlite3.c"
      $38 = $37 & $36; //@line 29214 "c/sqlite3.c"
      if ($38) {
       $$05061 = $29;$$062 = $28;$25 = $31;
      } else {
       break;
      }
     }
     $phitmp = ($35<<24>>24)==(0); //@line 29217 "c/sqlite3.c"
     $$0$lcssa = $28;$$lcssa = $phitmp;
    }
    $39 = ($$0$lcssa|0)>(-1); //@line 29217 "c/sqlite3.c"
    $or$cond = $39 & $$lcssa; //@line 29217 "c/sqlite3.c"
    if (!($or$cond)) {
     $$1 = 0;
     return ($$1|0); //@line 29249 "c/sqlite3.c"
    }
    HEAP32[$1>>2] = $$0$lcssa; //@line 29218 "c/sqlite3.c"
    $$1 = 1;
    return ($$1|0); //@line 29249 "c/sqlite3.c"
   }
   break;
  }
  default: {
   $$048 = 0;$$155 = $0;$41 = $2;
  }
  }
 } while(0);
 if ((label|0) == 14) {
  $$pr73 = HEAP8[$$155$ph>>0]|0; //@line 29225 "c/sqlite3.c"
  $$048 = $$048$ph;$$155 = $$155$ph;$41 = $$pr73;
 }
 $40 = $41&255; //@line 29225 "c/sqlite3.c"
 $42 = (($40) + -48)|0; //@line 29225 "c/sqlite3.c"
 $43 = ($42>>>0)<(10); //@line 29225 "c/sqlite3.c"
 if (!($43)) {
  $$1 = 0;
  return ($$1|0); //@line 29249 "c/sqlite3.c"
 }
 $44 = ($41<<24>>24)==(48); //@line 29226 "c/sqlite3.c"
 if ($44) {
  $$260 = $$155;
  while(1) {
   $45 = ((($$260)) + 1|0); //@line 29226 "c/sqlite3.c"
   $$pr = HEAP8[$45>>0]|0; //@line 29226 "c/sqlite3.c"
   $46 = ($$pr<<24>>24)==(48); //@line 29226 "c/sqlite3.c"
   if ($46) {
    $$260 = $45;
   } else {
    $$2$lcssa = $45;
    break;
   }
  }
 } else {
  $$2$lcssa = $$155;
 }
 $47 = HEAP8[$$2$lcssa>>0]|0; //@line 29227 "c/sqlite3.c"
 $$off = (($47) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
 $48 = ($$off&255)<(10); //@line 29227 "c/sqlite3.c"
 if ($48) {
  $49 = $47 << 24 >> 24; //@line 29227 "c/sqlite3.c"
  $50 = (($49) + -48)|0; //@line 29227 "c/sqlite3.c"
  $51 = ($50|0)<(0); //@line 29228 "c/sqlite3.c"
  $52 = $51 << 31 >> 31; //@line 29228 "c/sqlite3.c"
  $53 = ((($$2$lcssa)) + 1|0); //@line 29227 "c/sqlite3.c"
  $54 = HEAP8[$53>>0]|0; //@line 29227 "c/sqlite3.c"
  $$off$1 = (($54) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
  $55 = ($$off$1&255)<(10); //@line 29227 "c/sqlite3.c"
  if ($55) {
   $66 = $54 << 24 >> 24; //@line 29227 "c/sqlite3.c"
   $67 = (($66) + -48)|0; //@line 29227 "c/sqlite3.c"
   $68 = (___muldi3(($50|0),($52|0),10,0)|0); //@line 29228 "c/sqlite3.c"
   $69 = tempRet0; //@line 29228 "c/sqlite3.c"
   $70 = ($67|0)<(0); //@line 29228 "c/sqlite3.c"
   $71 = $70 << 31 >> 31; //@line 29228 "c/sqlite3.c"
   $72 = (_i64Add(($68|0),($69|0),($67|0),($71|0))|0); //@line 29228 "c/sqlite3.c"
   $73 = tempRet0; //@line 29228 "c/sqlite3.c"
   $74 = ((($$2$lcssa)) + 2|0); //@line 29227 "c/sqlite3.c"
   $75 = HEAP8[$74>>0]|0; //@line 29227 "c/sqlite3.c"
   $$off$2 = (($75) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
   $76 = ($$off$2&255)<(10); //@line 29227 "c/sqlite3.c"
   if ($76) {
    $77 = $75 << 24 >> 24; //@line 29227 "c/sqlite3.c"
    $78 = (($77) + -48)|0; //@line 29227 "c/sqlite3.c"
    $79 = (___muldi3(($72|0),($73|0),10,0)|0); //@line 29228 "c/sqlite3.c"
    $80 = tempRet0; //@line 29228 "c/sqlite3.c"
    $81 = ($78|0)<(0); //@line 29228 "c/sqlite3.c"
    $82 = $81 << 31 >> 31; //@line 29228 "c/sqlite3.c"
    $83 = (_i64Add(($79|0),($80|0),($78|0),($82|0))|0); //@line 29228 "c/sqlite3.c"
    $84 = tempRet0; //@line 29228 "c/sqlite3.c"
    $85 = ((($$2$lcssa)) + 3|0); //@line 29227 "c/sqlite3.c"
    $86 = HEAP8[$85>>0]|0; //@line 29227 "c/sqlite3.c"
    $$off$3 = (($86) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
    $87 = ($$off$3&255)<(10); //@line 29227 "c/sqlite3.c"
    if ($87) {
     $88 = $86 << 24 >> 24; //@line 29227 "c/sqlite3.c"
     $89 = (($88) + -48)|0; //@line 29227 "c/sqlite3.c"
     $90 = (___muldi3(($83|0),($84|0),10,0)|0); //@line 29228 "c/sqlite3.c"
     $91 = tempRet0; //@line 29228 "c/sqlite3.c"
     $92 = ($89|0)<(0); //@line 29228 "c/sqlite3.c"
     $93 = $92 << 31 >> 31; //@line 29228 "c/sqlite3.c"
     $94 = (_i64Add(($90|0),($91|0),($89|0),($93|0))|0); //@line 29228 "c/sqlite3.c"
     $95 = tempRet0; //@line 29228 "c/sqlite3.c"
     $96 = ((($$2$lcssa)) + 4|0); //@line 29227 "c/sqlite3.c"
     $97 = HEAP8[$96>>0]|0; //@line 29227 "c/sqlite3.c"
     $$off$4 = (($97) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
     $98 = ($$off$4&255)<(10); //@line 29227 "c/sqlite3.c"
     if ($98) {
      $99 = $97 << 24 >> 24; //@line 29227 "c/sqlite3.c"
      $100 = (($99) + -48)|0; //@line 29227 "c/sqlite3.c"
      $101 = (___muldi3(($94|0),($95|0),10,0)|0); //@line 29228 "c/sqlite3.c"
      $102 = tempRet0; //@line 29228 "c/sqlite3.c"
      $103 = ($100|0)<(0); //@line 29228 "c/sqlite3.c"
      $104 = $103 << 31 >> 31; //@line 29228 "c/sqlite3.c"
      $105 = (_i64Add(($101|0),($102|0),($100|0),($104|0))|0); //@line 29228 "c/sqlite3.c"
      $106 = tempRet0; //@line 29228 "c/sqlite3.c"
      $107 = ((($$2$lcssa)) + 5|0); //@line 29227 "c/sqlite3.c"
      $108 = HEAP8[$107>>0]|0; //@line 29227 "c/sqlite3.c"
      $$off$5 = (($108) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
      $109 = ($$off$5&255)<(10); //@line 29227 "c/sqlite3.c"
      if ($109) {
       $110 = $108 << 24 >> 24; //@line 29227 "c/sqlite3.c"
       $111 = (($110) + -48)|0; //@line 29227 "c/sqlite3.c"
       $112 = (___muldi3(($105|0),($106|0),10,0)|0); //@line 29228 "c/sqlite3.c"
       $113 = tempRet0; //@line 29228 "c/sqlite3.c"
       $114 = ($111|0)<(0); //@line 29228 "c/sqlite3.c"
       $115 = $114 << 31 >> 31; //@line 29228 "c/sqlite3.c"
       $116 = (_i64Add(($112|0),($113|0),($111|0),($115|0))|0); //@line 29228 "c/sqlite3.c"
       $117 = tempRet0; //@line 29228 "c/sqlite3.c"
       $118 = ((($$2$lcssa)) + 6|0); //@line 29227 "c/sqlite3.c"
       $119 = HEAP8[$118>>0]|0; //@line 29227 "c/sqlite3.c"
       $$off$6 = (($119) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
       $120 = ($$off$6&255)<(10); //@line 29227 "c/sqlite3.c"
       if ($120) {
        $121 = $119 << 24 >> 24; //@line 29227 "c/sqlite3.c"
        $122 = (($121) + -48)|0; //@line 29227 "c/sqlite3.c"
        $123 = (___muldi3(($116|0),($117|0),10,0)|0); //@line 29228 "c/sqlite3.c"
        $124 = tempRet0; //@line 29228 "c/sqlite3.c"
        $125 = ($122|0)<(0); //@line 29228 "c/sqlite3.c"
        $126 = $125 << 31 >> 31; //@line 29228 "c/sqlite3.c"
        $127 = (_i64Add(($123|0),($124|0),($122|0),($126|0))|0); //@line 29228 "c/sqlite3.c"
        $128 = tempRet0; //@line 29228 "c/sqlite3.c"
        $129 = ((($$2$lcssa)) + 7|0); //@line 29227 "c/sqlite3.c"
        $130 = HEAP8[$129>>0]|0; //@line 29227 "c/sqlite3.c"
        $$off$7 = (($130) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
        $131 = ($$off$7&255)<(10); //@line 29227 "c/sqlite3.c"
        if ($131) {
         $132 = $130 << 24 >> 24; //@line 29227 "c/sqlite3.c"
         $133 = (($132) + -48)|0; //@line 29227 "c/sqlite3.c"
         $134 = (___muldi3(($127|0),($128|0),10,0)|0); //@line 29228 "c/sqlite3.c"
         $135 = tempRet0; //@line 29228 "c/sqlite3.c"
         $136 = ($133|0)<(0); //@line 29228 "c/sqlite3.c"
         $137 = $136 << 31 >> 31; //@line 29228 "c/sqlite3.c"
         $138 = (_i64Add(($134|0),($135|0),($133|0),($137|0))|0); //@line 29228 "c/sqlite3.c"
         $139 = tempRet0; //@line 29228 "c/sqlite3.c"
         $140 = ((($$2$lcssa)) + 8|0); //@line 29227 "c/sqlite3.c"
         $141 = HEAP8[$140>>0]|0; //@line 29227 "c/sqlite3.c"
         $$off$8 = (($141) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
         $142 = ($$off$8&255)<(10); //@line 29227 "c/sqlite3.c"
         if ($142) {
          $143 = $141 << 24 >> 24; //@line 29227 "c/sqlite3.c"
          $144 = (($143) + -48)|0; //@line 29227 "c/sqlite3.c"
          $145 = (___muldi3(($138|0),($139|0),10,0)|0); //@line 29228 "c/sqlite3.c"
          $146 = tempRet0; //@line 29228 "c/sqlite3.c"
          $147 = ($144|0)<(0); //@line 29228 "c/sqlite3.c"
          $148 = $147 << 31 >> 31; //@line 29228 "c/sqlite3.c"
          $149 = (_i64Add(($145|0),($146|0),($144|0),($148|0))|0); //@line 29228 "c/sqlite3.c"
          $150 = tempRet0; //@line 29228 "c/sqlite3.c"
          $151 = ((($$2$lcssa)) + 9|0); //@line 29227 "c/sqlite3.c"
          $152 = HEAP8[$151>>0]|0; //@line 29227 "c/sqlite3.c"
          $$off$9 = (($152) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
          $153 = ($$off$9&255)<(10); //@line 29227 "c/sqlite3.c"
          if ($153) {
           $154 = $152 << 24 >> 24; //@line 29227 "c/sqlite3.c"
           $155 = (($154) + -48)|0; //@line 29227 "c/sqlite3.c"
           $156 = (___muldi3(($149|0),($150|0),10,0)|0); //@line 29228 "c/sqlite3.c"
           $157 = tempRet0; //@line 29228 "c/sqlite3.c"
           $158 = ($155|0)<(0); //@line 29228 "c/sqlite3.c"
           $159 = $158 << 31 >> 31; //@line 29228 "c/sqlite3.c"
           $160 = (_i64Add(($156|0),($157|0),($155|0),($159|0))|0); //@line 29228 "c/sqlite3.c"
           $161 = tempRet0; //@line 29228 "c/sqlite3.c"
           $162 = ((($$2$lcssa)) + 10|0); //@line 29227 "c/sqlite3.c"
           $163 = HEAP8[$162>>0]|0; //@line 29227 "c/sqlite3.c"
           $$off$10 = (($163) + -48)<<24>>24; //@line 29227 "c/sqlite3.c"
           $164 = ($$off$10&255)<(10); //@line 29227 "c/sqlite3.c"
           if ($164) {
            $$1 = 0;
            return ($$1|0); //@line 29249 "c/sqlite3.c"
           } else {
            $56 = $160;$57 = $161;
           }
          } else {
           $56 = $149;$57 = $150;
          }
         } else {
          $56 = $138;$57 = $139;
         }
        } else {
         $56 = $127;$57 = $128;
        }
       } else {
        $56 = $116;$57 = $117;
       }
      } else {
       $56 = $105;$57 = $106;
      }
     } else {
      $56 = $94;$57 = $95;
     }
    } else {
     $56 = $83;$57 = $84;
    }
   } else {
    $56 = $72;$57 = $73;
   }
  } else {
   $56 = $50;$57 = $52;
  }
 } else {
  $56 = 0;$57 = 0;
 }
 $58 = (_i64Subtract(($56|0),($57|0),($$048|0),0)|0); //@line 29241 "c/sqlite3.c"
 $59 = tempRet0; //@line 29241 "c/sqlite3.c"
 $60 = ($59|0)>(0); //@line 29241 "c/sqlite3.c"
 $61 = ($58>>>0)>(2147483647); //@line 29241 "c/sqlite3.c"
 $62 = ($59|0)==(0); //@line 29241 "c/sqlite3.c"
 $63 = $62 & $61; //@line 29241 "c/sqlite3.c"
 $64 = $60 | $63; //@line 29241 "c/sqlite3.c"
 if ($64) {
  $$1 = 0;
  return ($$1|0); //@line 29249 "c/sqlite3.c"
 }
 $65 = ($$048|0)==(0); //@line 29244 "c/sqlite3.c"
 $extract$t = (0 - ($56))|0; //@line 29246 "c/sqlite3.c"
 $$153$off0 = $65 ? $56 : $extract$t; //@line 29244 "c/sqlite3.c"
 HEAP32[$1>>2] = $$153$off0; //@line 29247 "c/sqlite3.c"
 $$1 = 1;
 return ($$1|0); //@line 29249 "c/sqlite3.c"
}
function _sqlite3HexToInt($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0 >>> 6; //@line 29693 "c/sqlite3.c"
 $2 = $1 & 1; //@line 29693 "c/sqlite3.c"
 $3 = (0 - ($2))|0; //@line 29693 "c/sqlite3.c"
 $4 = $3 & 9; //@line 29693 "c/sqlite3.c"
 $5 = (($4) + ($0))|0; //@line 29693 "c/sqlite3.c"
 $6 = $5 & 15; //@line 29698 "c/sqlite3.c"
 $7 = $6&255; //@line 29698 "c/sqlite3.c"
 return ($7|0); //@line 29698 "c/sqlite3.c"
}
function _getFileMode($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $4 = sp;
 $5 = HEAP32[(1580)>>2]|0; //@line 36407 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iii[$5 & 255]($0,$4)|0); //@line 36407 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 36407 "c/sqlite3.c"
 if (!($7)) {
  $$0 = 1802;
  STACKTOP = sp;return ($$0|0); //@line 36414 "c/sqlite3.c"
 }
 $8 = ((($4)) + 12|0); //@line 36408 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 36408 "c/sqlite3.c"
 $10 = $9 & 511; //@line 36408 "c/sqlite3.c"
 HEAP32[$1>>2] = $10; //@line 36408 "c/sqlite3.c"
 $11 = ((($4)) + 20|0); //@line 36409 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 36409 "c/sqlite3.c"
 HEAP32[$2>>2] = $12; //@line 36409 "c/sqlite3.c"
 $13 = ((($4)) + 24|0); //@line 36410 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 36410 "c/sqlite3.c"
 HEAP32[$3>>2] = $14; //@line 36410 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 36414 "c/sqlite3.c"
}
function _posixIoFinderImpl($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (1976|0); //@line 35864 "c/sqlite3.c"
}
function _sqlite3PCacheSetDefault() {
 var $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 47237 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = 2056; //@line 47237 "c/sqlite3.c"
 (_sqlite3_config(18,$vararg_buffer)|0); //@line 47237 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 47238 "c/sqlite3.c"
}
function _sqlite3_config($0,$varargs) {
 $0 = $0|0;
 $varargs = $varargs|0;
 var $$0 = 0, $$038 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $arglist_current = 0, $arglist_current11 = 0, $arglist_current14 = 0, $arglist_current17 = 0, $arglist_current2 = 0, $arglist_current20 = 0, $arglist_current23 = 0, $arglist_current26 = 0, $arglist_current29 = 0, $arglist_current32 = 0, $arglist_current35 = 0, $arglist_current38 = 0, $arglist_current41 = 0, $arglist_current44 = 0, $arglist_current47 = 0, $arglist_current5 = 0, $arglist_current50 = 0, $arglist_current53 = 0;
 var $arglist_current56 = 0, $arglist_current59 = 0, $arglist_current62 = 0, $arglist_current8 = 0, $arglist_next = 0, $arglist_next12 = 0, $arglist_next15 = 0, $arglist_next18 = 0, $arglist_next21 = 0, $arglist_next24 = 0, $arglist_next27 = 0, $arglist_next3 = 0, $arglist_next30 = 0, $arglist_next33 = 0, $arglist_next36 = 0, $arglist_next39 = 0, $arglist_next42 = 0, $arglist_next45 = 0, $arglist_next48 = 0, $arglist_next51 = 0;
 var $arglist_next54 = 0, $arglist_next57 = 0, $arglist_next6 = 0, $arglist_next60 = 0, $arglist_next63 = 0, $arglist_next9 = 0, $expanded = 0, $expanded10 = 0, $expanded100 = 0, $expanded101 = 0, $expanded103 = 0, $expanded104 = 0, $expanded105 = 0, $expanded107 = 0, $expanded108 = 0, $expanded110 = 0, $expanded111 = 0, $expanded112 = 0, $expanded114 = 0, $expanded115 = 0;
 var $expanded117 = 0, $expanded118 = 0, $expanded119 = 0, $expanded12 = 0, $expanded121 = 0, $expanded122 = 0, $expanded124 = 0, $expanded125 = 0, $expanded126 = 0, $expanded128 = 0, $expanded129 = 0, $expanded13 = 0, $expanded131 = 0, $expanded132 = 0, $expanded133 = 0, $expanded135 = 0, $expanded136 = 0, $expanded138 = 0, $expanded139 = 0, $expanded14 = 0;
 var $expanded140 = 0, $expanded142 = 0, $expanded143 = 0, $expanded145 = 0, $expanded146 = 0, $expanded147 = 0, $expanded149 = 0, $expanded150 = 0, $expanded152 = 0, $expanded153 = 0, $expanded154 = 0, $expanded16 = 0, $expanded17 = 0, $expanded19 = 0, $expanded20 = 0, $expanded21 = 0, $expanded23 = 0, $expanded24 = 0, $expanded26 = 0, $expanded27 = 0;
 var $expanded28 = 0, $expanded3 = 0, $expanded30 = 0, $expanded31 = 0, $expanded33 = 0, $expanded34 = 0, $expanded35 = 0, $expanded37 = 0, $expanded38 = 0, $expanded40 = 0, $expanded41 = 0, $expanded42 = 0, $expanded44 = 0, $expanded45 = 0, $expanded47 = 0, $expanded48 = 0, $expanded49 = 0, $expanded5 = 0, $expanded51 = 0, $expanded52 = 0;
 var $expanded54 = 0, $expanded55 = 0, $expanded56 = 0, $expanded58 = 0, $expanded59 = 0, $expanded6 = 0, $expanded61 = 0, $expanded62 = 0, $expanded63 = 0, $expanded65 = 0, $expanded66 = 0, $expanded68 = 0, $expanded69 = 0, $expanded7 = 0, $expanded70 = 0, $expanded72 = 0, $expanded73 = 0, $expanded75 = 0, $expanded76 = 0, $expanded77 = 0;
 var $expanded79 = 0, $expanded80 = 0, $expanded82 = 0, $expanded83 = 0, $expanded84 = 0, $expanded86 = 0, $expanded87 = 0, $expanded89 = 0, $expanded9 = 0, $expanded90 = 0, $expanded91 = 0, $expanded93 = 0, $expanded94 = 0, $expanded96 = 0, $expanded97 = 0, $expanded98 = 0, dest = 0, label = 0, sp = 0, src = 0;
 var stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = HEAP32[(232)>>2]|0; //@line 143731 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 143731 "c/sqlite3.c"
 if (!($3)) {
  $4 = (_sqlite3MisuseError(143731)|0); //@line 143731 "c/sqlite3.c"
  $$0 = $4;
  STACKTOP = sp;return ($$0|0); //@line 144012 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = $varargs; //@line 143733 "c/sqlite3.c"
 do {
  switch ($0|0) {
  case 1:  {
   HEAP32[(12)>>2] = 0; //@line 143743 "c/sqlite3.c"
   HEAP32[(16)>>2] = 0; //@line 143744 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 2:  {
   HEAP32[(12)>>2] = 1; //@line 143752 "c/sqlite3.c"
   HEAP32[(16)>>2] = 0; //@line 143753 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 3:  {
   HEAP32[(12)>>2] = 1; //@line 143761 "c/sqlite3.c"
   HEAP32[(16)>>2] = 1; //@line 143762 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 10:  {
   $arglist_current = HEAP32[$1>>2]|0; //@line 143769 "c/sqlite3.c"
   $5 = $arglist_current; //@line 143769 "c/sqlite3.c"
   $6 = ((0) + 4|0);
   $expanded3 = $6;
   $expanded = (($expanded3) - 1)|0;
   $7 = (($5) + ($expanded))|0; //@line 143769 "c/sqlite3.c"
   $8 = ((0) + 4|0);
   $expanded7 = $8;
   $expanded6 = (($expanded7) - 1)|0;
   $expanded5 = $expanded6 ^ -1;
   $9 = $7 & $expanded5; //@line 143769 "c/sqlite3.c"
   $10 = $9; //@line 143769 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 143769 "c/sqlite3.c"
   $arglist_next = ((($10)) + 4|0); //@line 143769 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next; //@line 143769 "c/sqlite3.c"
   dest=(84); src=$11; stop=dest+36|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 143769 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 11:  {
   $arglist_current2 = HEAP32[$1>>2]|0; //@line 143776 "c/sqlite3.c"
   $12 = $arglist_current2; //@line 143776 "c/sqlite3.c"
   $13 = ((0) + 4|0);
   $expanded10 = $13;
   $expanded9 = (($expanded10) - 1)|0;
   $14 = (($12) + ($expanded9))|0; //@line 143776 "c/sqlite3.c"
   $15 = ((0) + 4|0);
   $expanded14 = $15;
   $expanded13 = (($expanded14) - 1)|0;
   $expanded12 = $expanded13 ^ -1;
   $16 = $14 & $expanded12; //@line 143776 "c/sqlite3.c"
   $17 = $16; //@line 143776 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 143776 "c/sqlite3.c"
   $arglist_next3 = ((($17)) + 4|0); //@line 143776 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next3; //@line 143776 "c/sqlite3.c"
   dest=$18; src=(84); stop=dest+36|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 143776 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 4:  {
   $arglist_current5 = HEAP32[$1>>2]|0; //@line 143787 "c/sqlite3.c"
   $19 = $arglist_current5; //@line 143787 "c/sqlite3.c"
   $20 = ((0) + 4|0);
   $expanded17 = $20;
   $expanded16 = (($expanded17) - 1)|0;
   $21 = (($19) + ($expanded16))|0; //@line 143787 "c/sqlite3.c"
   $22 = ((0) + 4|0);
   $expanded21 = $22;
   $expanded20 = (($expanded21) - 1)|0;
   $expanded19 = $expanded20 ^ -1;
   $23 = $21 & $expanded19; //@line 143787 "c/sqlite3.c"
   $24 = $23; //@line 143787 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 143787 "c/sqlite3.c"
   $arglist_next6 = ((($24)) + 4|0); //@line 143787 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next6; //@line 143787 "c/sqlite3.c"
   ;HEAP32[(52)>>2]=HEAP32[$25>>2]|0;HEAP32[(52)+4>>2]=HEAP32[$25+4>>2]|0;HEAP32[(52)+8>>2]=HEAP32[$25+8>>2]|0;HEAP32[(52)+12>>2]=HEAP32[$25+12>>2]|0;HEAP32[(52)+16>>2]=HEAP32[$25+16>>2]|0;HEAP32[(52)+20>>2]=HEAP32[$25+20>>2]|0;HEAP32[(52)+24>>2]=HEAP32[$25+24>>2]|0;HEAP32[(52)+28>>2]=HEAP32[$25+28>>2]|0; //@line 143787 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 5:  {
   $26 = HEAP32[(52)>>2]|0; //@line 143795 "c/sqlite3.c"
   $27 = ($26|0)==(0|0); //@line 143795 "c/sqlite3.c"
   if ($27) {
    _sqlite3MemSetDefault(); //@line 143795 "c/sqlite3.c"
   }
   $arglist_current8 = HEAP32[$1>>2]|0; //@line 143796 "c/sqlite3.c"
   $28 = $arglist_current8; //@line 143796 "c/sqlite3.c"
   $29 = ((0) + 4|0);
   $expanded24 = $29;
   $expanded23 = (($expanded24) - 1)|0;
   $30 = (($28) + ($expanded23))|0; //@line 143796 "c/sqlite3.c"
   $31 = ((0) + 4|0);
   $expanded28 = $31;
   $expanded27 = (($expanded28) - 1)|0;
   $expanded26 = $expanded27 ^ -1;
   $32 = $30 & $expanded26; //@line 143796 "c/sqlite3.c"
   $33 = $32; //@line 143796 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 143796 "c/sqlite3.c"
   $arglist_next9 = ((($33)) + 4|0); //@line 143796 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next9; //@line 143796 "c/sqlite3.c"
   ;HEAP32[$34>>2]=HEAP32[(52)>>2]|0;HEAP32[$34+4>>2]=HEAP32[(52)+4>>2]|0;HEAP32[$34+8>>2]=HEAP32[(52)+8>>2]|0;HEAP32[$34+12>>2]=HEAP32[(52)+12>>2]|0;HEAP32[$34+16>>2]=HEAP32[(52)+16>>2]|0;HEAP32[$34+20>>2]=HEAP32[(52)+20>>2]|0;HEAP32[$34+24>>2]=HEAP32[(52)+24>>2]|0;HEAP32[$34+28>>2]=HEAP32[(52)+28>>2]|0; //@line 143796 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 9:  {
   $arglist_current11 = HEAP32[$1>>2]|0; //@line 143803 "c/sqlite3.c"
   $35 = $arglist_current11; //@line 143803 "c/sqlite3.c"
   $36 = ((0) + 4|0);
   $expanded31 = $36;
   $expanded30 = (($expanded31) - 1)|0;
   $37 = (($35) + ($expanded30))|0; //@line 143803 "c/sqlite3.c"
   $38 = ((0) + 4|0);
   $expanded35 = $38;
   $expanded34 = (($expanded35) - 1)|0;
   $expanded33 = $expanded34 ^ -1;
   $39 = $37 & $expanded33; //@line 143803 "c/sqlite3.c"
   $40 = $39; //@line 143803 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 143803 "c/sqlite3.c"
   $arglist_next12 = ((($40)) + 4|0); //@line 143803 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next12; //@line 143803 "c/sqlite3.c"
   HEAP32[2] = $41; //@line 143803 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 27:  {
   $arglist_current14 = HEAP32[$1>>2]|0; //@line 143807 "c/sqlite3.c"
   $42 = $arglist_current14; //@line 143807 "c/sqlite3.c"
   $43 = ((0) + 4|0);
   $expanded38 = $43;
   $expanded37 = (($expanded38) - 1)|0;
   $44 = (($42) + ($expanded37))|0; //@line 143807 "c/sqlite3.c"
   $45 = ((0) + 4|0);
   $expanded42 = $45;
   $expanded41 = (($expanded42) - 1)|0;
   $expanded40 = $expanded41 ^ -1;
   $46 = $44 & $expanded40; //@line 143807 "c/sqlite3.c"
   $47 = $46; //@line 143807 "c/sqlite3.c"
   $48 = HEAP32[$47>>2]|0; //@line 143807 "c/sqlite3.c"
   $arglist_next15 = ((($47)) + 4|0); //@line 143807 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next15; //@line 143807 "c/sqlite3.c"
   HEAP32[(28)>>2] = $48; //@line 143807 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 7:  {
   $arglist_current17 = HEAP32[$1>>2]|0; //@line 143815 "c/sqlite3.c"
   $49 = $arglist_current17; //@line 143815 "c/sqlite3.c"
   $50 = ((0) + 4|0);
   $expanded45 = $50;
   $expanded44 = (($expanded45) - 1)|0;
   $51 = (($49) + ($expanded44))|0; //@line 143815 "c/sqlite3.c"
   $52 = ((0) + 4|0);
   $expanded49 = $52;
   $expanded48 = (($expanded49) - 1)|0;
   $expanded47 = $expanded48 ^ -1;
   $53 = $51 & $expanded47; //@line 143815 "c/sqlite3.c"
   $54 = $53; //@line 143815 "c/sqlite3.c"
   $55 = HEAP32[$54>>2]|0; //@line 143815 "c/sqlite3.c"
   $arglist_next18 = ((($54)) + 4|0); //@line 143815 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next18; //@line 143815 "c/sqlite3.c"
   HEAP32[(208)>>2] = $55; //@line 143815 "c/sqlite3.c"
   $arglist_current20 = HEAP32[$1>>2]|0; //@line 143816 "c/sqlite3.c"
   $56 = $arglist_current20; //@line 143816 "c/sqlite3.c"
   $57 = ((0) + 4|0);
   $expanded52 = $57;
   $expanded51 = (($expanded52) - 1)|0;
   $58 = (($56) + ($expanded51))|0; //@line 143816 "c/sqlite3.c"
   $59 = ((0) + 4|0);
   $expanded56 = $59;
   $expanded55 = (($expanded56) - 1)|0;
   $expanded54 = $expanded55 ^ -1;
   $60 = $58 & $expanded54; //@line 143816 "c/sqlite3.c"
   $61 = $60; //@line 143816 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 143816 "c/sqlite3.c"
   $arglist_next21 = ((($61)) + 4|0); //@line 143816 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next21; //@line 143816 "c/sqlite3.c"
   HEAP32[(212)>>2] = $62; //@line 143816 "c/sqlite3.c"
   $arglist_current23 = HEAP32[$1>>2]|0; //@line 143817 "c/sqlite3.c"
   $63 = $arglist_current23; //@line 143817 "c/sqlite3.c"
   $64 = ((0) + 4|0);
   $expanded59 = $64;
   $expanded58 = (($expanded59) - 1)|0;
   $65 = (($63) + ($expanded58))|0; //@line 143817 "c/sqlite3.c"
   $66 = ((0) + 4|0);
   $expanded63 = $66;
   $expanded62 = (($expanded63) - 1)|0;
   $expanded61 = $expanded62 ^ -1;
   $67 = $65 & $expanded61; //@line 143817 "c/sqlite3.c"
   $68 = $67; //@line 143817 "c/sqlite3.c"
   $69 = HEAP32[$68>>2]|0; //@line 143817 "c/sqlite3.c"
   $arglist_next24 = ((($68)) + 4|0); //@line 143817 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next24; //@line 143817 "c/sqlite3.c"
   HEAP32[(216)>>2] = $69; //@line 143817 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 24:  {
   $arglist_current26 = HEAP32[$1>>2]|0; //@line 143825 "c/sqlite3.c"
   $70 = $arglist_current26; //@line 143825 "c/sqlite3.c"
   $71 = ((0) + 4|0);
   $expanded66 = $71;
   $expanded65 = (($expanded66) - 1)|0;
   $72 = (($70) + ($expanded65))|0; //@line 143825 "c/sqlite3.c"
   $73 = ((0) + 4|0);
   $expanded70 = $73;
   $expanded69 = (($expanded70) - 1)|0;
   $expanded68 = $expanded69 ^ -1;
   $74 = $72 & $expanded68; //@line 143825 "c/sqlite3.c"
   $75 = $74; //@line 143825 "c/sqlite3.c"
   $76 = HEAP32[$75>>2]|0; //@line 143825 "c/sqlite3.c"
   $arglist_next27 = ((($75)) + 4|0); //@line 143825 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next27; //@line 143825 "c/sqlite3.c"
   HEAP32[$76>>2] = 160; //@line 143825 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 14:  {
   $$038 = 0;
   break;
  }
  case 15:  {
   $$038 = 1;
   break;
  }
  case 18:  {
   $arglist_current29 = HEAP32[$1>>2]|0; //@line 143847 "c/sqlite3.c"
   $77 = $arglist_current29; //@line 143847 "c/sqlite3.c"
   $78 = ((0) + 4|0);
   $expanded73 = $78;
   $expanded72 = (($expanded73) - 1)|0;
   $79 = (($77) + ($expanded72))|0; //@line 143847 "c/sqlite3.c"
   $80 = ((0) + 4|0);
   $expanded77 = $80;
   $expanded76 = (($expanded77) - 1)|0;
   $expanded75 = $expanded76 ^ -1;
   $81 = $79 & $expanded75; //@line 143847 "c/sqlite3.c"
   $82 = $81; //@line 143847 "c/sqlite3.c"
   $83 = HEAP32[$82>>2]|0; //@line 143847 "c/sqlite3.c"
   $arglist_next30 = ((($82)) + 4|0); //@line 143847 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next30; //@line 143847 "c/sqlite3.c"
   dest=(120); src=$83; stop=dest+52|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 143847 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 19:  {
   $84 = HEAP32[(128)>>2]|0; //@line 143855 "c/sqlite3.c"
   $85 = ($84|0)==(0|0); //@line 143855 "c/sqlite3.c"
   if ($85) {
    _sqlite3PCacheSetDefault(); //@line 143856 "c/sqlite3.c"
   }
   $arglist_current32 = HEAP32[$1>>2]|0; //@line 143858 "c/sqlite3.c"
   $86 = $arglist_current32; //@line 143858 "c/sqlite3.c"
   $87 = ((0) + 4|0);
   $expanded80 = $87;
   $expanded79 = (($expanded80) - 1)|0;
   $88 = (($86) + ($expanded79))|0; //@line 143858 "c/sqlite3.c"
   $89 = ((0) + 4|0);
   $expanded84 = $89;
   $expanded83 = (($expanded84) - 1)|0;
   $expanded82 = $expanded83 ^ -1;
   $90 = $88 & $expanded82; //@line 143858 "c/sqlite3.c"
   $91 = $90; //@line 143858 "c/sqlite3.c"
   $92 = HEAP32[$91>>2]|0; //@line 143858 "c/sqlite3.c"
   $arglist_next33 = ((($91)) + 4|0); //@line 143858 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next33; //@line 143858 "c/sqlite3.c"
   dest=$92; src=(120); stop=dest+52|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 143858 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 13:  {
   $arglist_current35 = HEAP32[$1>>2]|0; //@line 143908 "c/sqlite3.c"
   $93 = $arglist_current35; //@line 143908 "c/sqlite3.c"
   $94 = ((0) + 4|0);
   $expanded87 = $94;
   $expanded86 = (($expanded87) - 1)|0;
   $95 = (($93) + ($expanded86))|0; //@line 143908 "c/sqlite3.c"
   $96 = ((0) + 4|0);
   $expanded91 = $96;
   $expanded90 = (($expanded91) - 1)|0;
   $expanded89 = $expanded90 ^ -1;
   $97 = $95 & $expanded89; //@line 143908 "c/sqlite3.c"
   $98 = $97; //@line 143908 "c/sqlite3.c"
   $99 = HEAP32[$98>>2]|0; //@line 143908 "c/sqlite3.c"
   $arglist_next36 = ((($98)) + 4|0); //@line 143908 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next36; //@line 143908 "c/sqlite3.c"
   HEAP32[(40)>>2] = $99; //@line 143908 "c/sqlite3.c"
   $arglist_current38 = HEAP32[$1>>2]|0; //@line 143909 "c/sqlite3.c"
   $100 = $arglist_current38; //@line 143909 "c/sqlite3.c"
   $101 = ((0) + 4|0);
   $expanded94 = $101;
   $expanded93 = (($expanded94) - 1)|0;
   $102 = (($100) + ($expanded93))|0; //@line 143909 "c/sqlite3.c"
   $103 = ((0) + 4|0);
   $expanded98 = $103;
   $expanded97 = (($expanded98) - 1)|0;
   $expanded96 = $expanded97 ^ -1;
   $104 = $102 & $expanded96; //@line 143909 "c/sqlite3.c"
   $105 = $104; //@line 143909 "c/sqlite3.c"
   $106 = HEAP32[$105>>2]|0; //@line 143909 "c/sqlite3.c"
   $arglist_next39 = ((($105)) + 4|0); //@line 143909 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next39; //@line 143909 "c/sqlite3.c"
   HEAP32[(44)>>2] = $106; //@line 143909 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 16:  {
   $arglist_current41 = HEAP32[$1>>2]|0; //@line 143923 "c/sqlite3.c"
   $107 = $arglist_current41; //@line 143923 "c/sqlite3.c"
   $108 = ((0) + 4|0);
   $expanded101 = $108;
   $expanded100 = (($expanded101) - 1)|0;
   $109 = (($107) + ($expanded100))|0; //@line 143923 "c/sqlite3.c"
   $110 = ((0) + 4|0);
   $expanded105 = $110;
   $expanded104 = (($expanded105) - 1)|0;
   $expanded103 = $expanded104 ^ -1;
   $111 = $109 & $expanded103; //@line 143923 "c/sqlite3.c"
   $112 = $111; //@line 143923 "c/sqlite3.c"
   $113 = HEAP32[$112>>2]|0; //@line 143923 "c/sqlite3.c"
   $arglist_next42 = ((($112)) + 4|0); //@line 143923 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next42; //@line 143923 "c/sqlite3.c"
   HEAP32[(260)>>2] = $113; //@line 143923 "c/sqlite3.c"
   $arglist_current44 = HEAP32[$1>>2]|0; //@line 143924 "c/sqlite3.c"
   $114 = $arglist_current44; //@line 143924 "c/sqlite3.c"
   $115 = ((0) + 4|0);
   $expanded108 = $115;
   $expanded107 = (($expanded108) - 1)|0;
   $116 = (($114) + ($expanded107))|0; //@line 143924 "c/sqlite3.c"
   $117 = ((0) + 4|0);
   $expanded112 = $117;
   $expanded111 = (($expanded112) - 1)|0;
   $expanded110 = $expanded111 ^ -1;
   $118 = $116 & $expanded110; //@line 143924 "c/sqlite3.c"
   $119 = $118; //@line 143924 "c/sqlite3.c"
   $120 = HEAP32[$119>>2]|0; //@line 143924 "c/sqlite3.c"
   $arglist_next45 = ((($119)) + 4|0); //@line 143924 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next45; //@line 143924 "c/sqlite3.c"
   HEAP32[(264)>>2] = $120; //@line 143924 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 17:  {
   $arglist_current47 = HEAP32[$1>>2]|0; //@line 143938 "c/sqlite3.c"
   $121 = $arglist_current47; //@line 143938 "c/sqlite3.c"
   $122 = ((0) + 4|0);
   $expanded115 = $122;
   $expanded114 = (($expanded115) - 1)|0;
   $123 = (($121) + ($expanded114))|0; //@line 143938 "c/sqlite3.c"
   $124 = ((0) + 4|0);
   $expanded119 = $124;
   $expanded118 = (($expanded119) - 1)|0;
   $expanded117 = $expanded118 ^ -1;
   $125 = $123 & $expanded117; //@line 143938 "c/sqlite3.c"
   $126 = $125; //@line 143938 "c/sqlite3.c"
   $127 = HEAP32[$126>>2]|0; //@line 143938 "c/sqlite3.c"
   $arglist_next48 = ((($126)) + 4|0); //@line 143938 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next48; //@line 143938 "c/sqlite3.c"
   HEAP32[(20)>>2] = $127; //@line 143938 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 20:  {
   $arglist_current50 = HEAP32[$1>>2]|0; //@line 143947 "c/sqlite3.c"
   $128 = $arglist_current50; //@line 143947 "c/sqlite3.c"
   $129 = ((0) + 4|0);
   $expanded122 = $129;
   $expanded121 = (($expanded122) - 1)|0;
   $130 = (($128) + ($expanded121))|0; //@line 143947 "c/sqlite3.c"
   $131 = ((0) + 4|0);
   $expanded126 = $131;
   $expanded125 = (($expanded126) - 1)|0;
   $expanded124 = $expanded125 ^ -1;
   $132 = $130 & $expanded124; //@line 143947 "c/sqlite3.c"
   $133 = $132; //@line 143947 "c/sqlite3.c"
   $134 = HEAP32[$133>>2]|0; //@line 143947 "c/sqlite3.c"
   $arglist_next51 = ((($133)) + 4|0); //@line 143947 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next51; //@line 143947 "c/sqlite3.c"
   HEAP32[(24)>>2] = $134; //@line 143947 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 22:  {
   $arglist_current53 = HEAP32[$1>>2]|0; //@line 143965 "c/sqlite3.c"
   $135 = $arglist_current53; //@line 143965 "c/sqlite3.c"
   $136 = ((0) + 8|0);
   $expanded129 = $136;
   $expanded128 = (($expanded129) - 1)|0;
   $137 = (($135) + ($expanded128))|0; //@line 143965 "c/sqlite3.c"
   $138 = ((0) + 8|0);
   $expanded133 = $138;
   $expanded132 = (($expanded133) - 1)|0;
   $expanded131 = $expanded132 ^ -1;
   $139 = $137 & $expanded131; //@line 143965 "c/sqlite3.c"
   $140 = $139; //@line 143965 "c/sqlite3.c"
   $arglist_next54 = ((($140)) + 8|0); //@line 143965 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next54; //@line 143965 "c/sqlite3.c"
   $arglist_current56 = HEAP32[$1>>2]|0; //@line 143966 "c/sqlite3.c"
   $141 = $arglist_current56; //@line 143966 "c/sqlite3.c"
   $142 = ((0) + 8|0);
   $expanded136 = $142;
   $expanded135 = (($expanded136) - 1)|0;
   $143 = (($141) + ($expanded135))|0; //@line 143966 "c/sqlite3.c"
   $144 = ((0) + 8|0);
   $expanded140 = $144;
   $expanded139 = (($expanded140) - 1)|0;
   $expanded138 = $expanded139 ^ -1;
   $145 = $143 & $expanded138; //@line 143966 "c/sqlite3.c"
   $146 = $145; //@line 143966 "c/sqlite3.c"
   $arglist_next57 = ((($146)) + 8|0); //@line 143966 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next57; //@line 143966 "c/sqlite3.c"
   ;HEAP32[(192)>>2]=0|0;HEAP32[(192)+4>>2]=0|0;HEAP32[(192)+8>>2]=0|0;HEAP32[(192)+12>>2]=0|0; //@line 143981 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 25:  {
   $arglist_current59 = HEAP32[$1>>2]|0; //@line 143996 "c/sqlite3.c"
   $147 = $arglist_current59; //@line 143996 "c/sqlite3.c"
   $148 = ((0) + 4|0);
   $expanded143 = $148;
   $expanded142 = (($expanded143) - 1)|0;
   $149 = (($147) + ($expanded142))|0; //@line 143996 "c/sqlite3.c"
   $150 = ((0) + 4|0);
   $expanded147 = $150;
   $expanded146 = (($expanded147) - 1)|0;
   $expanded145 = $expanded146 ^ -1;
   $151 = $149 & $expanded145; //@line 143996 "c/sqlite3.c"
   $152 = $151; //@line 143996 "c/sqlite3.c"
   $153 = HEAP32[$152>>2]|0; //@line 143996 "c/sqlite3.c"
   $arglist_next60 = ((($152)) + 4|0); //@line 143996 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next60; //@line 143996 "c/sqlite3.c"
   HEAP32[(228)>>2] = $153; //@line 143996 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  case 26:  {
   $arglist_current62 = HEAP32[$1>>2]|0; //@line 144001 "c/sqlite3.c"
   $154 = $arglist_current62; //@line 144001 "c/sqlite3.c"
   $155 = ((0) + 4|0);
   $expanded150 = $155;
   $expanded149 = (($expanded150) - 1)|0;
   $156 = (($154) + ($expanded149))|0; //@line 144001 "c/sqlite3.c"
   $157 = ((0) + 4|0);
   $expanded154 = $157;
   $expanded153 = (($expanded154) - 1)|0;
   $expanded152 = $expanded153 ^ -1;
   $158 = $156 & $expanded152; //@line 144001 "c/sqlite3.c"
   $159 = $158; //@line 144001 "c/sqlite3.c"
   $160 = HEAP32[$159>>2]|0; //@line 144001 "c/sqlite3.c"
   $arglist_next63 = ((($159)) + 4|0); //@line 144001 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next63; //@line 144001 "c/sqlite3.c"
   HEAP32[(48)>>2] = $160; //@line 144001 "c/sqlite3.c"
   $$038 = 0;
   break;
  }
  default: {
   $$038 = 1;
  }
  }
 } while(0);
 $$0 = $$038;
 STACKTOP = sp;return ($$0|0); //@line 144012 "c/sqlite3.c"
}
function _sqlite3MemSetDefault() {
 var $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 21670 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = 2108; //@line 21670 "c/sqlite3.c"
 (_sqlite3_config(4,$vararg_buffer)|0); //@line 21670 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 21671 "c/sqlite3.c"
}
function _sqlite3MemMalloc($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 21510 "c/sqlite3.c"
 $1 = (($0) + 8)|0; //@line 21524 "c/sqlite3.c"
 $2 = (_malloc($1)|0); //@line 21524 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 21525 "c/sqlite3.c"
 if ($3) {
  HEAP32[$vararg_buffer>>2] = $0; //@line 21530 "c/sqlite3.c"
  _sqlite3_log(7,16580,$vararg_buffer); //@line 21530 "c/sqlite3.c"
  $11 = 0;
  STACKTOP = sp;return ($11|0); //@line 21532 "c/sqlite3.c"
 } else {
  $4 = ($0|0)<(0); //@line 21526 "c/sqlite3.c"
  $5 = $4 << 31 >> 31; //@line 21526 "c/sqlite3.c"
  $6 = $2; //@line 21526 "c/sqlite3.c"
  $7 = $6; //@line 21526 "c/sqlite3.c"
  HEAP32[$7>>2] = $0; //@line 21526 "c/sqlite3.c"
  $8 = (($6) + 4)|0; //@line 21526 "c/sqlite3.c"
  $9 = $8; //@line 21526 "c/sqlite3.c"
  HEAP32[$9>>2] = $5; //@line 21526 "c/sqlite3.c"
  $10 = ((($2)) + 8|0); //@line 21527 "c/sqlite3.c"
  $11 = $10;
  STACKTOP = sp;return ($11|0); //@line 21532 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3MemFree($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + -8|0); //@line 21550 "c/sqlite3.c"
 _free($1); //@line 21551 "c/sqlite3.c"
 return; //@line 21553 "c/sqlite3.c"
}
function _sqlite3MemRealloc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 21582 "c/sqlite3.c"
 $2 = ((($0)) + -8|0); //@line 21596 "c/sqlite3.c"
 $3 = (($1) + 8)|0; //@line 21597 "c/sqlite3.c"
 $4 = (_realloc($2,$3)|0); //@line 21597 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 21598 "c/sqlite3.c"
 if ($5) {
  $13 = (_sqlite3MemSize($0)|0); //@line 21605 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $13; //@line 21603 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 21603 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $1; //@line 21603 "c/sqlite3.c"
  _sqlite3_log(7,16544,$vararg_buffer); //@line 21603 "c/sqlite3.c"
  $14 = 0;
  STACKTOP = sp;return ($14|0); //@line 21607 "c/sqlite3.c"
 } else {
  $6 = ($1|0)<(0); //@line 21599 "c/sqlite3.c"
  $7 = $6 << 31 >> 31; //@line 21599 "c/sqlite3.c"
  $8 = $4; //@line 21599 "c/sqlite3.c"
  $9 = $8; //@line 21599 "c/sqlite3.c"
  HEAP32[$9>>2] = $1; //@line 21599 "c/sqlite3.c"
  $10 = (($8) + 4)|0; //@line 21599 "c/sqlite3.c"
  $11 = $10; //@line 21599 "c/sqlite3.c"
  HEAP32[$11>>2] = $7; //@line 21599 "c/sqlite3.c"
  $12 = ((($4)) + 8|0); //@line 21600 "c/sqlite3.c"
  $14 = $12;
  STACKTOP = sp;return ($14|0); //@line 21607 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3MemSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + -8|0); //@line 21567 "c/sqlite3.c"
 $2 = $1; //@line 21568 "c/sqlite3.c"
 $3 = $2; //@line 21568 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 21568 "c/sqlite3.c"
 $5 = (($2) + 4)|0; //@line 21568 "c/sqlite3.c"
 $6 = $5; //@line 21568 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 21568 "c/sqlite3.c"
 return ($4|0); //@line 21568 "c/sqlite3.c"
}
function _sqlite3MemRoundup($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (($0) + 7)|0; //@line 21615 "c/sqlite3.c"
 $2 = $1 & -8; //@line 21615 "c/sqlite3.c"
 return ($2|0); //@line 21615 "c/sqlite3.c"
}
function _sqlite3MemInit($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 21642 "c/sqlite3.c"
}
function _sqlite3MemShutdown($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 21650 "c/sqlite3.c"
}
function _pcache1Init($0) {
 $0 = $0|0;
 var $$ = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, dest = 0, label = 0;
 var sp = 0, stop = 0;
 sp = STACKTOP;
 dest=40188; stop=dest+100|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 46736 "c/sqlite3.c"
 $1 = HEAP32[(208)>>2]|0; //@line 46756 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 46756 "c/sqlite3.c"
 $3 = HEAP32[(12)>>2]|0; //@line 46757 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 46757 "c/sqlite3.c"
 $5 = $2 | $4; //@line 46757 "c/sqlite3.c"
 $6 = $5&1; //@line 46757 "c/sqlite3.c"
 HEAP32[(40244)>>2] = $6; //@line 46756 "c/sqlite3.c"
 $7 = ($3|0)==(0); //@line 46763 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_sqlite3MutexAlloc(6)|0); //@line 46764 "c/sqlite3.c"
  HEAP32[10047] = $8; //@line 46764 "c/sqlite3.c"
  $9 = (_sqlite3MutexAlloc(7)|0); //@line 46765 "c/sqlite3.c"
  HEAP32[(40272)>>2] = $9; //@line 46765 "c/sqlite3.c"
 }
 $10 = HEAP32[(40244)>>2]|0; //@line 46768 "c/sqlite3.c"
 $11 = ($10|0)!=(0); //@line 46768 "c/sqlite3.c"
 $12 = HEAP32[(216)>>2]|0; //@line 46769 "c/sqlite3.c"
 $13 = ($12|0)!=(0); //@line 46769 "c/sqlite3.c"
 $or$cond = $11 & $13; //@line 46769 "c/sqlite3.c"
 $14 = HEAP32[(208)>>2]|0; //@line 46770 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 46770 "c/sqlite3.c"
 $or$cond3 = $or$cond & $15; //@line 46769 "c/sqlite3.c"
 $$ = $or$cond3 ? $12 : 0; //@line 46773 "c/sqlite3.c"
 HEAP32[(40248)>>2] = $$;
 HEAP32[(40200)>>2] = 10; //@line 46776 "c/sqlite3.c"
 HEAP32[(40240)>>2] = 1; //@line 46777 "c/sqlite3.c"
 return 0; //@line 46778 "c/sqlite3.c"
}
function _pcache1Shutdown($0) {
 $0 = $0|0;
 var dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=40188; stop=dest+100|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 46789 "c/sqlite3.c"
 return; //@line 46790 "c/sqlite3.c"
}
function _pcache1Create($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$037 = 0, $$neg = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $pcache1Create$dummyCurrentPage$sink = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[(40244)>>2]|0; //@line 46808 "c/sqlite3.c"
 $4 = ($3*52)|0; //@line 46808 "c/sqlite3.c"
 $5 = (($4) + 64)|0; //@line 46808 "c/sqlite3.c"
 $6 = ($5|0)<(0); //@line 46809 "c/sqlite3.c"
 $7 = $6 << 31 >> 31; //@line 46809 "c/sqlite3.c"
 $8 = (_sqlite3MallocZero($5,$7)|0); //@line 46809 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 46810 "c/sqlite3.c"
 if ($9) {
  $$0 = $8;
  return ($$0|0); //@line 46843 "c/sqlite3.c"
 }
 $10 = HEAP32[(40244)>>2]|0; //@line 46811 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 46811 "c/sqlite3.c"
 if ($11) {
  $$037 = 40188;
 } else {
  $12 = ((($8)) + 64|0); //@line 46812 "c/sqlite3.c"
  $13 = ((($8)) + 76|0); //@line 46813 "c/sqlite3.c"
  HEAP32[$13>>2] = 10; //@line 46813 "c/sqlite3.c"
  $$037 = $12;
 }
 $14 = ((($$037)) + 20|0); //@line 46817 "c/sqlite3.c"
 $15 = ((($$037)) + 33|0); //@line 46817 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 46817 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 46817 "c/sqlite3.c"
 if ($17) {
  HEAP8[$15>>0] = 1; //@line 46818 "c/sqlite3.c"
  $18 = ((($$037)) + 44|0); //@line 46819 "c/sqlite3.c"
  HEAP32[$18>>2] = $14; //@line 46819 "c/sqlite3.c"
  $19 = ((($$037)) + 48|0); //@line 46819 "c/sqlite3.c"
  HEAP32[$19>>2] = $14; //@line 46819 "c/sqlite3.c"
 }
 HEAP32[$8>>2] = $$037; //@line 46821 "c/sqlite3.c"
 $20 = ((($8)) + 8|0); //@line 46822 "c/sqlite3.c"
 HEAP32[$20>>2] = $0; //@line 46822 "c/sqlite3.c"
 $21 = ((($8)) + 12|0); //@line 46823 "c/sqlite3.c"
 HEAP32[$21>>2] = $1; //@line 46823 "c/sqlite3.c"
 $22 = (($0) + 32)|0; //@line 46824 "c/sqlite3.c"
 $23 = (($22) + ($1))|0; //@line 46824 "c/sqlite3.c"
 $24 = ((($8)) + 16|0); //@line 46824 "c/sqlite3.c"
 HEAP32[$24>>2] = $23; //@line 46824 "c/sqlite3.c"
 $25 = ($2|0)!=(0); //@line 46825 "c/sqlite3.c"
 $26 = $25&1; //@line 46825 "c/sqlite3.c"
 $27 = ((($8)) + 20|0); //@line 46825 "c/sqlite3.c"
 HEAP32[$27>>2] = $26; //@line 46825 "c/sqlite3.c"
 _pcache1ResizeHash($8); //@line 46827 "c/sqlite3.c"
 if ($25) {
  $28 = ((($8)) + 24|0); //@line 46829 "c/sqlite3.c"
  HEAP32[$28>>2] = 10; //@line 46829 "c/sqlite3.c"
  $29 = ((($$037)) + 8|0); //@line 46830 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 46830 "c/sqlite3.c"
  $31 = (($30) + 10)|0; //@line 46830 "c/sqlite3.c"
  HEAP32[$29>>2] = $31; //@line 46830 "c/sqlite3.c"
  $32 = ((($$037)) + 4|0); //@line 46831 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 46831 "c/sqlite3.c"
  $$neg = (-10 - ($30))|0;
  $34 = (($$neg) + 10)|0; //@line 46831 "c/sqlite3.c"
  $35 = (($34) + ($33))|0; //@line 46831 "c/sqlite3.c"
  $36 = ((($$037)) + 12|0); //@line 46831 "c/sqlite3.c"
  HEAP32[$36>>2] = $35; //@line 46831 "c/sqlite3.c"
  $37 = ((($$037)) + 16|0); //@line 46832 "c/sqlite3.c"
  $pcache1Create$dummyCurrentPage$sink = $37;
 } else {
  $pcache1Create$dummyCurrentPage$sink = 40404;
 }
 $38 = ((($8)) + 4|0);
 HEAP32[$38>>2] = $pcache1Create$dummyCurrentPage$sink;
 $39 = ((($8)) + 48|0); //@line 46838 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 46838 "c/sqlite3.c"
 $41 = ($40|0)==(0); //@line 46838 "c/sqlite3.c"
 if (!($41)) {
  $$0 = $8;
  return ($$0|0); //@line 46843 "c/sqlite3.c"
 }
 _pcache1Destroy($8); //@line 46839 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 46843 "c/sqlite3.c"
}
function _pcache1Cachesize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 46853 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 46853 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 46853 "c/sqlite3.c"
 if ($4) {
  return; //@line 46863 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 46854 "c/sqlite3.c"
 $6 = ((($0)) + 28|0); //@line 46856 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 46856 "c/sqlite3.c"
 $8 = (($1) - ($7))|0; //@line 46856 "c/sqlite3.c"
 $9 = ((($5)) + 4|0); //@line 46856 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 46856 "c/sqlite3.c"
 $11 = (($10) + ($8))|0; //@line 46856 "c/sqlite3.c"
 HEAP32[$9>>2] = $11; //@line 46856 "c/sqlite3.c"
 $12 = (($11) + 10)|0; //@line 46857 "c/sqlite3.c"
 $13 = ((($5)) + 8|0); //@line 46857 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 46857 "c/sqlite3.c"
 $15 = (($12) - ($14))|0; //@line 46857 "c/sqlite3.c"
 $16 = ((($5)) + 12|0); //@line 46857 "c/sqlite3.c"
 HEAP32[$16>>2] = $15; //@line 46857 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 46858 "c/sqlite3.c"
 $17 = ($1*9)|0; //@line 46859 "c/sqlite3.c"
 $18 = (($17>>>0) / 10)&-1; //@line 46859 "c/sqlite3.c"
 $19 = ((($0)) + 32|0); //@line 46859 "c/sqlite3.c"
 HEAP32[$19>>2] = $18; //@line 46859 "c/sqlite3.c"
 _pcache1EnforceMaxPage($0); //@line 46860 "c/sqlite3.c"
 return; //@line 46863 "c/sqlite3.c"
}
function _pcache1Pagecount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 44|0); //@line 46891 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 46891 "c/sqlite3.c"
 return ($2|0); //@line 46893 "c/sqlite3.c"
}
function _pcache1Fetch($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_pcache1FetchNoMutex($0,$1,$2)|0); //@line 47098 "c/sqlite3.c"
 return ($3|0); //@line 47098 "c/sqlite3.c"
}
function _pcache1Unpin($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 47115 "c/sqlite3.c"
 $4 = ($2|0)==(0); //@line 47126 "c/sqlite3.c"
 if ($4) {
  $5 = ((($3)) + 16|0); //@line 47126 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 47126 "c/sqlite3.c"
  $7 = ((($3)) + 4|0); //@line 47126 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 47126 "c/sqlite3.c"
  $9 = ($6>>>0)>($8>>>0); //@line 47126 "c/sqlite3.c"
  if (!($9)) {
   $10 = ((($3)) + 20|0); //@line 47130 "c/sqlite3.c"
   $11 = ((($3)) + 44|0); //@line 47130 "c/sqlite3.c"
   $12 = ((($1)) + 28|0); //@line 47131 "c/sqlite3.c"
   HEAP32[$12>>2] = $10; //@line 47131 "c/sqlite3.c"
   $13 = HEAP32[$11>>2]|0; //@line 47132 "c/sqlite3.c"
   $14 = ((($1)) + 24|0); //@line 47132 "c/sqlite3.c"
   HEAP32[$14>>2] = $13; //@line 47132 "c/sqlite3.c"
   $15 = ((($13)) + 28|0); //@line 47132 "c/sqlite3.c"
   HEAP32[$15>>2] = $1; //@line 47132 "c/sqlite3.c"
   HEAP32[$11>>2] = $1; //@line 47133 "c/sqlite3.c"
   $16 = ((($0)) + 40|0); //@line 47134 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 47134 "c/sqlite3.c"
   $18 = (($17) + 1)|0; //@line 47134 "c/sqlite3.c"
   HEAP32[$16>>2] = $18; //@line 47134 "c/sqlite3.c"
   return; //@line 47138 "c/sqlite3.c"
  }
 }
 _pcache1RemoveFromHash($1,1); //@line 47127 "c/sqlite3.c"
 return; //@line 47138 "c/sqlite3.c"
}
function _pcache1Rekey($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 48|0); //@line 47158 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 47158 "c/sqlite3.c"
 $6 = (($2>>>0) % ($5>>>0))&-1; //@line 47158 "c/sqlite3.c"
 $7 = ((($0)) + 52|0); //@line 47159 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 47159 "c/sqlite3.c"
 $9 = (($8) + ($6<<2)|0); //@line 47159 "c/sqlite3.c"
 $$0 = $9;
 while(1) {
  $10 = HEAP32[$$0>>2]|0; //@line 47160 "c/sqlite3.c"
  $11 = ($10|0)==($1|0); //@line 47160 "c/sqlite3.c"
  $12 = ((($10)) + 16|0); //@line 47161 "c/sqlite3.c"
  if ($11) {
   break;
  } else {
   $$0 = $12;
  }
 }
 $13 = ((($1)) + 16|0); //@line 47163 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 47163 "c/sqlite3.c"
 HEAP32[$$0>>2] = $14; //@line 47163 "c/sqlite3.c"
 $15 = (($3>>>0) % ($5>>>0))&-1; //@line 47165 "c/sqlite3.c"
 $16 = ((($1)) + 8|0); //@line 47166 "c/sqlite3.c"
 HEAP32[$16>>2] = $3; //@line 47166 "c/sqlite3.c"
 $17 = HEAP32[$7>>2]|0; //@line 47167 "c/sqlite3.c"
 $18 = (($17) + ($15<<2)|0); //@line 47167 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 47167 "c/sqlite3.c"
 HEAP32[$13>>2] = $19; //@line 47167 "c/sqlite3.c"
 HEAP32[$18>>2] = $1; //@line 47168 "c/sqlite3.c"
 $20 = ((($0)) + 36|0); //@line 47169 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 47169 "c/sqlite3.c"
 $22 = ($21>>>0)<($3>>>0); //@line 47169 "c/sqlite3.c"
 if (!($22)) {
  return; //@line 47174 "c/sqlite3.c"
 }
 HEAP32[$20>>2] = $3; //@line 47170 "c/sqlite3.c"
 return; //@line 47174 "c/sqlite3.c"
}
function _pcache1Truncate($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 36|0); //@line 47186 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 47186 "c/sqlite3.c"
 $4 = ($3>>>0)<($1>>>0); //@line 47186 "c/sqlite3.c"
 if ($4) {
  return; //@line 47191 "c/sqlite3.c"
 }
 $5 = (($1) + -1)|0; //@line 47188 "c/sqlite3.c"
 _pcache1TruncateUnsafe($0,$1); //@line 47187 "c/sqlite3.c"
 HEAP32[$2>>2] = $5; //@line 47188 "c/sqlite3.c"
 return; //@line 47191 "c/sqlite3.c"
}
function _pcache1Destroy($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 47200 "c/sqlite3.c"
 $2 = ((($0)) + 44|0); //@line 47203 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 47203 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 47203 "c/sqlite3.c"
 if (!($4)) {
  _pcache1TruncateUnsafe($0,0); //@line 47203 "c/sqlite3.c"
 }
 $5 = ((($0)) + 28|0); //@line 47205 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 47205 "c/sqlite3.c"
 $7 = ((($1)) + 4|0); //@line 47205 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 47205 "c/sqlite3.c"
 $9 = (($8) - ($6))|0; //@line 47205 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 47205 "c/sqlite3.c"
 $10 = ((($0)) + 24|0); //@line 47207 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 47207 "c/sqlite3.c"
 $12 = ((($1)) + 8|0); //@line 47207 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 47207 "c/sqlite3.c"
 $14 = (($13) - ($11))|0; //@line 47207 "c/sqlite3.c"
 HEAP32[$12>>2] = $14; //@line 47207 "c/sqlite3.c"
 $15 = (($9) + 10)|0; //@line 47208 "c/sqlite3.c"
 $16 = (($15) - ($14))|0; //@line 47208 "c/sqlite3.c"
 $17 = ((($1)) + 12|0); //@line 47208 "c/sqlite3.c"
 HEAP32[$17>>2] = $16; //@line 47208 "c/sqlite3.c"
 _pcache1EnforceMaxPage($0); //@line 47209 "c/sqlite3.c"
 $18 = ((($0)) + 60|0); //@line 47211 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 47211 "c/sqlite3.c"
 _sqlite3_free($19); //@line 47211 "c/sqlite3.c"
 $20 = ((($0)) + 52|0); //@line 47212 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 47212 "c/sqlite3.c"
 _sqlite3_free($21); //@line 47212 "c/sqlite3.c"
 _sqlite3_free($0); //@line 47213 "c/sqlite3.c"
 return; //@line 47214 "c/sqlite3.c"
}
function _pcache1Shrink($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 46872 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 46872 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 46872 "c/sqlite3.c"
 if ($3) {
  return; //@line 46882 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 46873 "c/sqlite3.c"
 $5 = ((($4)) + 4|0); //@line 46876 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 46876 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 46877 "c/sqlite3.c"
 _pcache1EnforceMaxPage($0); //@line 46878 "c/sqlite3.c"
 HEAP32[$5>>2] = $6; //@line 46879 "c/sqlite3.c"
 return; //@line 46882 "c/sqlite3.c"
}
function _pcache1EnforceMaxPage($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 46658 "c/sqlite3.c"
 $2 = ((($1)) + 48|0); //@line 46662 "c/sqlite3.c"
 $3 = ((($1)) + 16|0); //@line 46661 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 46661 "c/sqlite3.c"
 $5 = ((($1)) + 4|0); //@line 46661 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 46661 "c/sqlite3.c"
 $7 = ($4>>>0)>($6>>>0); //@line 46661 "c/sqlite3.c"
 L1: do {
  if ($7) {
   while(1) {
    $8 = HEAP32[$2>>2]|0; //@line 46662 "c/sqlite3.c"
    $9 = ((($8)) + 13|0); //@line 46662 "c/sqlite3.c"
    $10 = HEAP8[$9>>0]|0; //@line 46662 "c/sqlite3.c"
    $11 = ($10<<24>>24)==(0); //@line 46662 "c/sqlite3.c"
    if (!($11)) {
     break L1;
    }
    (_pcache1PinPage($8)|0); //@line 46666 "c/sqlite3.c"
    _pcache1RemoveFromHash($8,1); //@line 46667 "c/sqlite3.c"
    $12 = HEAP32[$3>>2]|0; //@line 46661 "c/sqlite3.c"
    $13 = HEAP32[$5>>2]|0; //@line 46661 "c/sqlite3.c"
    $14 = ($12>>>0)>($13>>>0); //@line 46661 "c/sqlite3.c"
    if (!($14)) {
     break;
    }
   }
  }
 } while(0);
 $15 = ((($0)) + 44|0); //@line 46669 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 46669 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 46669 "c/sqlite3.c"
 if (!($17)) {
  return; //@line 46673 "c/sqlite3.c"
 }
 $18 = ((($0)) + 60|0); //@line 46669 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 46669 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 46669 "c/sqlite3.c"
 if ($20) {
  return; //@line 46673 "c/sqlite3.c"
 }
 _sqlite3_free($19); //@line 46670 "c/sqlite3.c"
 $21 = ((($0)) + 56|0); //@line 46671 "c/sqlite3.c"
 HEAP32[$21>>2] = 0; //@line 46671 "c/sqlite3.c"
 HEAP32[$18>>2] = 0; //@line 46671 "c/sqlite3.c"
 return; //@line 46673 "c/sqlite3.c"
}
function _pcache1PinPage($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 46621 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 46621 "c/sqlite3.c"
 $3 = ((($0)) + 28|0); //@line 46621 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 46621 "c/sqlite3.c"
 $5 = ((($4)) + 24|0); //@line 46621 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 46621 "c/sqlite3.c"
 $6 = HEAP32[$3>>2]|0; //@line 46622 "c/sqlite3.c"
 $7 = HEAP32[$1>>2]|0; //@line 46622 "c/sqlite3.c"
 $8 = ((($7)) + 28|0); //@line 46622 "c/sqlite3.c"
 HEAP32[$8>>2] = $6; //@line 46622 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 46623 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 46624 "c/sqlite3.c"
 $9 = ((($0)) + 20|0); //@line 46627 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 46627 "c/sqlite3.c"
 $11 = ((($10)) + 40|0); //@line 46627 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 46627 "c/sqlite3.c"
 $13 = (($12) + -1)|0; //@line 46627 "c/sqlite3.c"
 HEAP32[$11>>2] = $13; //@line 46627 "c/sqlite3.c"
 return ($0|0); //@line 46628 "c/sqlite3.c"
}
function _pcache1RemoveFromHash($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 46641 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 46641 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 46645 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 46645 "c/sqlite3.c"
 $6 = ((($3)) + 48|0); //@line 46645 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 46645 "c/sqlite3.c"
 $8 = (($5>>>0) % ($7>>>0))&-1; //@line 46645 "c/sqlite3.c"
 $9 = ((($3)) + 52|0); //@line 46646 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 46646 "c/sqlite3.c"
 $11 = (($10) + ($8<<2)|0); //@line 46646 "c/sqlite3.c"
 $$0 = $11;
 while(1) {
  $12 = HEAP32[$$0>>2]|0; //@line 46646 "c/sqlite3.c"
  $13 = ($12|0)==($0|0); //@line 46646 "c/sqlite3.c"
  $14 = ((($12)) + 16|0);
  if ($13) {
   break;
  } else {
   $$0 = $14;
  }
 }
 $15 = HEAP32[$14>>2]|0; //@line 46647 "c/sqlite3.c"
 HEAP32[$$0>>2] = $15; //@line 46647 "c/sqlite3.c"
 $16 = ((($3)) + 44|0); //@line 46649 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 46649 "c/sqlite3.c"
 $18 = (($17) + -1)|0; //@line 46649 "c/sqlite3.c"
 HEAP32[$16>>2] = $18; //@line 46649 "c/sqlite3.c"
 $19 = ($1|0)==(0); //@line 46650 "c/sqlite3.c"
 if ($19) {
  return; //@line 46651 "c/sqlite3.c"
 }
 _pcache1FreePage($0); //@line 46650 "c/sqlite3.c"
 return; //@line 46651 "c/sqlite3.c"
}
function _pcache1FreePage($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 46510 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 46510 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 46512 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 46512 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 46512 "c/sqlite3.c"
 if ($5) {
  $9 = HEAP32[$0>>2]|0; //@line 46516 "c/sqlite3.c"
  _pcache1Free($9); //@line 46516 "c/sqlite3.c"
 } else {
  $6 = ((($2)) + 56|0); //@line 46513 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 46513 "c/sqlite3.c"
  $8 = ((($0)) + 16|0); //@line 46513 "c/sqlite3.c"
  HEAP32[$8>>2] = $7; //@line 46513 "c/sqlite3.c"
  HEAP32[$6>>2] = $0; //@line 46514 "c/sqlite3.c"
 }
 $10 = ((($2)) + 4|0); //@line 46521 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 46521 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 46521 "c/sqlite3.c"
 $13 = (($12) + -1)|0; //@line 46521 "c/sqlite3.c"
 HEAP32[$11>>2] = $13; //@line 46521 "c/sqlite3.c"
 return; //@line 46522 "c/sqlite3.c"
}
function _pcache1Free($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 46410 "c/sqlite3.c"
 if ($1) {
  return; //@line 46436 "c/sqlite3.c"
 }
 $2 = $0; //@line 46411 "c/sqlite3.c"
 $3 = HEAP32[(40264)>>2]|0; //@line 46411 "c/sqlite3.c"
 $4 = ($3>>>0)<=($2>>>0); //@line 46411 "c/sqlite3.c"
 $5 = HEAP32[(40268)>>2]|0; //@line 46411 "c/sqlite3.c"
 $6 = ($5>>>0)>($2>>>0); //@line 46411 "c/sqlite3.c"
 $or$cond = $4 & $6; //@line 46411 "c/sqlite3.c"
 if ($or$cond) {
  $7 = HEAP32[(40272)>>2]|0; //@line 46413 "c/sqlite3.c"
  _sqlite3_mutex_enter($7); //@line 46413 "c/sqlite3.c"
  _sqlite3StatusDown(1,1); //@line 46414 "c/sqlite3.c"
  $8 = HEAP32[(40276)>>2]|0; //@line 46416 "c/sqlite3.c"
  HEAP32[$0>>2] = $8; //@line 46416 "c/sqlite3.c"
  HEAP32[(40276)>>2] = $0; //@line 46417 "c/sqlite3.c"
  $9 = HEAP32[(40280)>>2]|0; //@line 46418 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 46418 "c/sqlite3.c"
  HEAP32[(40280)>>2] = $10; //@line 46418 "c/sqlite3.c"
  $11 = HEAP32[(40260)>>2]|0; //@line 46419 "c/sqlite3.c"
  $12 = ($10|0)<($11|0); //@line 46419 "c/sqlite3.c"
  $13 = $12&1; //@line 46419 "c/sqlite3.c"
  HEAP32[(40284)>>2] = $13; //@line 46419 "c/sqlite3.c"
  $14 = HEAP32[(40272)>>2]|0; //@line 46421 "c/sqlite3.c"
  _sqlite3_mutex_leave($14); //@line 46421 "c/sqlite3.c"
  return; //@line 46436 "c/sqlite3.c"
 } else {
  $15 = (_sqlite3MallocSize($0)|0); //@line 46428 "c/sqlite3.c"
  $16 = HEAP32[(40272)>>2]|0; //@line 46429 "c/sqlite3.c"
  _sqlite3_mutex_enter($16); //@line 46429 "c/sqlite3.c"
  _sqlite3StatusDown(2,$15); //@line 46430 "c/sqlite3.c"
  $17 = HEAP32[(40272)>>2]|0; //@line 46431 "c/sqlite3.c"
  _sqlite3_mutex_leave($17); //@line 46431 "c/sqlite3.c"
  _sqlite3_free($0); //@line 46434 "c/sqlite3.c"
  return; //@line 46436 "c/sqlite3.c"
 }
}
function _pcache1TruncateUnsafe($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$032 = 0, $$03337 = 0, $$035 = 0, $$1 = 0, $$134 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 36|0); //@line 46691 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 46691 "c/sqlite3.c"
 $4 = (($3) - ($1))|0; //@line 46691 "c/sqlite3.c"
 $5 = ((($0)) + 48|0); //@line 46691 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 46691 "c/sqlite3.c"
 $7 = ($4>>>0)<($6>>>0); //@line 46691 "c/sqlite3.c"
 if ($7) {
  $8 = (($1>>>0) % ($6>>>0))&-1; //@line 46696 "c/sqlite3.c"
  $9 = (($3>>>0) % ($6>>>0))&-1; //@line 46697 "c/sqlite3.c"
  $$032 = $8;$$035 = $9;
 } else {
  $10 = $6 >>> 1; //@line 46702 "c/sqlite3.c"
  $11 = (($10) + -1)|0; //@line 46703 "c/sqlite3.c"
  $$032 = $10;$$035 = $11;
 }
 $12 = ((($0)) + 52|0);
 $13 = ((($0)) + 44|0);
 $$1 = $$032;
 while(1) {
  $14 = HEAP32[$12>>2]|0; //@line 46709 "c/sqlite3.c"
  $15 = (($14) + ($$1<<2)|0); //@line 46709 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 46710 "c/sqlite3.c"
  $17 = ($16|0)==(0|0); //@line 46710 "c/sqlite3.c"
  if (!($17)) {
   $$03337 = $15;$19 = $16;
   while(1) {
    $18 = ((($19)) + 8|0); //@line 46711 "c/sqlite3.c"
    $20 = HEAP32[$18>>2]|0; //@line 46711 "c/sqlite3.c"
    $21 = ($20>>>0)<($1>>>0); //@line 46711 "c/sqlite3.c"
    if ($21) {
     $29 = ((($19)) + 16|0); //@line 46717 "c/sqlite3.c"
     $$134 = $29;
    } else {
     $22 = HEAP32[$13>>2]|0; //@line 46712 "c/sqlite3.c"
     $23 = (($22) + -1)|0; //@line 46712 "c/sqlite3.c"
     HEAP32[$13>>2] = $23; //@line 46712 "c/sqlite3.c"
     $24 = ((($19)) + 16|0); //@line 46713 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 46713 "c/sqlite3.c"
     HEAP32[$$03337>>2] = $25; //@line 46713 "c/sqlite3.c"
     $26 = ((($19)) + 24|0); //@line 46714 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 46714 "c/sqlite3.c"
     $28 = ($27|0)==(0|0); //@line 46714 "c/sqlite3.c"
     if (!($28)) {
      (_pcache1PinPage($19)|0); //@line 46714 "c/sqlite3.c"
     }
     _pcache1FreePage($19); //@line 46715 "c/sqlite3.c"
     $$134 = $$03337;
    }
    $30 = HEAP32[$$134>>2]|0; //@line 46710 "c/sqlite3.c"
    $31 = ($30|0)==(0|0); //@line 46710 "c/sqlite3.c"
    if ($31) {
     break;
    } else {
     $$03337 = $$134;$19 = $30;
    }
   }
  }
  $32 = ($$1|0)==($$035|0); //@line 46721 "c/sqlite3.c"
  if ($32) {
   break;
  }
  $33 = (($$1) + 1)|0; //@line 46722 "c/sqlite3.c"
  $34 = HEAP32[$5>>2]|0; //@line 46722 "c/sqlite3.c"
  $35 = (($33>>>0) % ($34>>>0))&-1; //@line 46722 "c/sqlite3.c"
  $$1 = $35;
 }
 return; //@line 46725 "c/sqlite3.c"
}
function _pcache1FetchNoMutex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$017 = 0, $$020 = 0, $$021 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 52|0); //@line 47041 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 47041 "c/sqlite3.c"
 $5 = ((($0)) + 48|0); //@line 47041 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 47041 "c/sqlite3.c"
 $7 = (($1>>>0) % ($6>>>0))&-1; //@line 47041 "c/sqlite3.c"
 $8 = (($4) + ($7<<2)|0); //@line 47041 "c/sqlite3.c"
 $$020 = HEAP32[$8>>2]|0;
 $9 = ($$020|0)==(0|0); //@line 47042 "c/sqlite3.c"
 L1: do {
  if (!($9)) {
   $$021 = $$020;
   while(1) {
    $10 = ((($$021)) + 8|0); //@line 47042 "c/sqlite3.c"
    $11 = HEAP32[$10>>2]|0; //@line 47042 "c/sqlite3.c"
    $12 = ($11|0)==($1|0); //@line 47042 "c/sqlite3.c"
    if ($12) {
     break;
    }
    $13 = ((($$021)) + 16|0); //@line 47042 "c/sqlite3.c"
    $$0 = HEAP32[$13>>2]|0;
    $14 = ($$0|0)==(0|0); //@line 47042 "c/sqlite3.c"
    if ($14) {
     break L1;
    } else {
     $$021 = $$0;
    }
   }
   $15 = ((($$021)) + 24|0); //@line 47049 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 47049 "c/sqlite3.c"
   $17 = ($16|0)==(0|0); //@line 47049 "c/sqlite3.c"
   if ($17) {
    $$017 = $$021;
    return ($$017|0); //@line 47060 "c/sqlite3.c"
   }
   $18 = (_pcache1PinPage($$021)|0); //@line 47050 "c/sqlite3.c"
   $$017 = $$021;
   return ($$017|0); //@line 47060 "c/sqlite3.c"
  }
 } while(0);
 $19 = ($2|0)==(0); //@line 47054 "c/sqlite3.c"
 if ($19) {
  $$017 = 0;
  return ($$017|0); //@line 47060 "c/sqlite3.c"
 }
 $20 = (_pcache1FetchStage2($0,$1,$2)|0); //@line 47056 "c/sqlite3.c"
 $$017 = $20;
 return ($$017|0); //@line 47060 "c/sqlite3.c"
}
function _pcache1FetchStage2($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$264 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 46911 "c/sqlite3.c"
 $4 = ((($0)) + 44|0); //@line 46916 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 46916 "c/sqlite3.c"
 $6 = ((($0)) + 40|0); //@line 46916 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 46916 "c/sqlite3.c"
 $8 = (($5) - ($7))|0; //@line 46916 "c/sqlite3.c"
 $9 = ($2|0)==(1); //@line 46919 "c/sqlite3.c"
 if ($9) {
  $10 = ((($3)) + 12|0); //@line 46920 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 46920 "c/sqlite3.c"
  $12 = ($8>>>0)<($11>>>0); //@line 46920 "c/sqlite3.c"
  if (!($12)) {
   $$0 = 0;
   return ($$0|0); //@line 46971 "c/sqlite3.c"
  }
  $13 = ((($0)) + 32|0); //@line 46921 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 46921 "c/sqlite3.c"
  $15 = ($8>>>0)<($14>>>0); //@line 46921 "c/sqlite3.c"
  if (!($15)) {
   $$0 = 0;
   return ($$0|0); //@line 46971 "c/sqlite3.c"
  }
  $16 = (_pcache1UnderMemoryPressure($0)|0); //@line 46922 "c/sqlite3.c"
  $17 = ($16|0)!=(0); //@line 46922 "c/sqlite3.c"
  $18 = ($7>>>0)<($8>>>0); //@line 46922 "c/sqlite3.c"
  $or$cond = $18 & $17; //@line 46922 "c/sqlite3.c"
  if ($or$cond) {
   $$0 = 0;
   return ($$0|0); //@line 46971 "c/sqlite3.c"
  }
 }
 $19 = ((($0)) + 48|0); //@line 46927 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 46927 "c/sqlite3.c"
 $21 = ($5>>>0)<($20>>>0); //@line 46927 "c/sqlite3.c"
 if (!($21)) {
  _pcache1ResizeHash($0); //@line 46927 "c/sqlite3.c"
 }
 $22 = ((($0)) + 20|0); //@line 46931 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 46931 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 46931 "c/sqlite3.c"
 do {
  if ($24) {
   label = 14;
  } else {
   $25 = ((($3)) + 48|0); //@line 46932 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 46932 "c/sqlite3.c"
   $27 = ((($26)) + 13|0); //@line 46932 "c/sqlite3.c"
   $28 = HEAP8[$27>>0]|0; //@line 46932 "c/sqlite3.c"
   $29 = ($28<<24>>24)==(0); //@line 46932 "c/sqlite3.c"
   if ($29) {
    $30 = HEAP32[$4>>2]|0; //@line 46933 "c/sqlite3.c"
    $31 = (($30) + 1)|0; //@line 46933 "c/sqlite3.c"
    $32 = ((($0)) + 28|0); //@line 46933 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 46933 "c/sqlite3.c"
    $34 = ($31>>>0)<($33>>>0); //@line 46933 "c/sqlite3.c"
    if ($34) {
     $35 = (_pcache1UnderMemoryPressure($0)|0); //@line 46933 "c/sqlite3.c"
     $36 = ($35|0)==(0); //@line 46933 "c/sqlite3.c"
     if ($36) {
      label = 14;
      break;
     }
    }
    _pcache1RemoveFromHash($26,0); //@line 46938 "c/sqlite3.c"
    (_pcache1PinPage($26)|0); //@line 46939 "c/sqlite3.c"
    $37 = ((($26)) + 20|0); //@line 46940 "c/sqlite3.c"
    $38 = HEAP32[$37>>2]|0; //@line 46940 "c/sqlite3.c"
    $39 = ((($38)) + 16|0); //@line 46941 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 46941 "c/sqlite3.c"
    $41 = ((($0)) + 16|0); //@line 46941 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 46941 "c/sqlite3.c"
    $43 = ($40|0)==($42|0); //@line 46941 "c/sqlite3.c"
    if ($43) {
     $44 = ((($38)) + 20|0); //@line 46945 "c/sqlite3.c"
     $45 = HEAP32[$44>>2]|0; //@line 46945 "c/sqlite3.c"
     $46 = HEAP32[$22>>2]|0; //@line 46945 "c/sqlite3.c"
     $47 = ((($3)) + 16|0); //@line 46945 "c/sqlite3.c"
     $48 = HEAP32[$47>>2]|0; //@line 46945 "c/sqlite3.c"
     $49 = (($46) - ($45))|0; //@line 46945 "c/sqlite3.c"
     $50 = (($49) + ($48))|0; //@line 46945 "c/sqlite3.c"
     HEAP32[$47>>2] = $50; //@line 46945 "c/sqlite3.c"
     $$264 = $26;
     break;
    } else {
     _pcache1FreePage($26); //@line 46942 "c/sqlite3.c"
     label = 14;
     break;
    }
   } else {
    label = 14;
   }
  }
 } while(0);
 if ((label|0) == 14) {
  $51 = $9&1; //@line 46953 "c/sqlite3.c"
  $52 = (_pcache1AllocPage($0,$51)|0); //@line 46953 "c/sqlite3.c"
  $53 = ($52|0)==(0|0); //@line 46956 "c/sqlite3.c"
  if ($53) {
   $$0 = 0;
   return ($$0|0); //@line 46971 "c/sqlite3.c"
  } else {
   $$264 = $52;
  }
 }
 $54 = HEAP32[$19>>2]|0; //@line 46957 "c/sqlite3.c"
 $55 = (($1>>>0) % ($54>>>0))&-1; //@line 46957 "c/sqlite3.c"
 $56 = HEAP32[$4>>2]|0; //@line 46958 "c/sqlite3.c"
 $57 = (($56) + 1)|0; //@line 46958 "c/sqlite3.c"
 HEAP32[$4>>2] = $57; //@line 46958 "c/sqlite3.c"
 $58 = ((($$264)) + 8|0); //@line 46959 "c/sqlite3.c"
 HEAP32[$58>>2] = $1; //@line 46959 "c/sqlite3.c"
 $59 = ((($0)) + 52|0); //@line 46960 "c/sqlite3.c"
 $60 = HEAP32[$59>>2]|0; //@line 46960 "c/sqlite3.c"
 $61 = (($60) + ($55<<2)|0); //@line 46960 "c/sqlite3.c"
 $62 = HEAP32[$61>>2]|0; //@line 46960 "c/sqlite3.c"
 $63 = ((($$264)) + 16|0); //@line 46960 "c/sqlite3.c"
 HEAP32[$63>>2] = $62; //@line 46960 "c/sqlite3.c"
 $64 = ((($$264)) + 20|0); //@line 46961 "c/sqlite3.c"
 HEAP32[$64>>2] = $0; //@line 46961 "c/sqlite3.c"
 $65 = ((($$264)) + 28|0); //@line 46962 "c/sqlite3.c"
 HEAP32[$65>>2] = 0; //@line 46962 "c/sqlite3.c"
 $66 = ((($$264)) + 24|0); //@line 46963 "c/sqlite3.c"
 HEAP32[$66>>2] = 0; //@line 46963 "c/sqlite3.c"
 $67 = ((($$264)) + 4|0); //@line 46964 "c/sqlite3.c"
 $68 = HEAP32[$67>>2]|0; //@line 46964 "c/sqlite3.c"
 HEAP32[$68>>2] = 0; //@line 46964 "c/sqlite3.c"
 $69 = HEAP32[$59>>2]|0; //@line 46965 "c/sqlite3.c"
 $70 = (($69) + ($55<<2)|0); //@line 46965 "c/sqlite3.c"
 HEAP32[$70>>2] = $$264; //@line 46965 "c/sqlite3.c"
 $71 = ((($0)) + 36|0); //@line 46966 "c/sqlite3.c"
 $72 = HEAP32[$71>>2]|0; //@line 46966 "c/sqlite3.c"
 $73 = ($72>>>0)<($1>>>0); //@line 46966 "c/sqlite3.c"
 if (!($73)) {
  $$0 = $$264;
  return ($$0|0); //@line 46971 "c/sqlite3.c"
 }
 HEAP32[$71>>2] = $1; //@line 46967 "c/sqlite3.c"
 $$0 = $$264;
 return ($$0|0); //@line 46971 "c/sqlite3.c"
}
function _pcache1UnderMemoryPressure($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(40256)>>2]|0; //@line 46558 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 46558 "c/sqlite3.c"
 if (!($2)) {
  $3 = ((($0)) + 8|0); //@line 46558 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 46558 "c/sqlite3.c"
  $5 = ((($0)) + 12|0); //@line 46558 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 46558 "c/sqlite3.c"
  $7 = (($6) + ($4))|0; //@line 46558 "c/sqlite3.c"
  $8 = HEAP32[(40252)>>2]|0; //@line 46558 "c/sqlite3.c"
  $9 = ($7|0)>($8|0); //@line 46558 "c/sqlite3.c"
  if (!($9)) {
   $10 = HEAP32[(40284)>>2]|0; //@line 46559 "c/sqlite3.c"
   $$0 = $10;
   return ($$0|0); //@line 46563 "c/sqlite3.c"
  }
 }
 $11 = (_sqlite3HeapNearlyFull()|0); //@line 46561 "c/sqlite3.c"
 $$0 = $11;
 return ($$0|0); //@line 46563 "c/sqlite3.c"
}
function _pcache1ResizeHash($0) {
 $0 = $0|0;
 var $$03638 = 0, $$037 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 48|0); //@line 46581 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 46581 "c/sqlite3.c"
 $3 = $2 << 1; //@line 46581 "c/sqlite3.c"
 $4 = ($3>>>0)>(256); //@line 46582 "c/sqlite3.c"
 $spec$store$select = $4 ? $3 : 256; //@line 46582 "c/sqlite3.c"
 $5 = ($2|0)==(0); //@line 46587 "c/sqlite3.c"
 if (!($5)) {
  _sqlite3BeginBenignMalloc(); //@line 46587 "c/sqlite3.c"
 }
 $6 = $spec$store$select << 2; //@line 46588 "c/sqlite3.c"
 $7 = (_sqlite3MallocZero($6,0)|0); //@line 46588 "c/sqlite3.c"
 $8 = HEAP32[$1>>2]|0; //@line 46589 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 46589 "c/sqlite3.c"
 if (!($9)) {
  _sqlite3EndBenignMalloc(); //@line 46589 "c/sqlite3.c"
 }
 $10 = ($7|0)==(0|0); //@line 46591 "c/sqlite3.c"
 if ($10) {
  return; //@line 46606 "c/sqlite3.c"
 }
 $11 = HEAP32[$1>>2]|0; //@line 46592 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 46592 "c/sqlite3.c"
 $13 = ((($0)) + 52|0);
 if (!($12)) {
  $14 = HEAP32[$1>>2]|0;
  $$03638 = 0;
  while(1) {
   $15 = HEAP32[$13>>2]|0; //@line 46594 "c/sqlite3.c"
   $16 = (($15) + ($$03638<<2)|0); //@line 46594 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 46594 "c/sqlite3.c"
   $18 = ($17|0)==(0|0); //@line 46595 "c/sqlite3.c"
   if (!($18)) {
    $$037 = $17;
    while(1) {
     $19 = ((($$037)) + 8|0); //@line 46596 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 46596 "c/sqlite3.c"
     $21 = (($20>>>0) % ($spec$store$select>>>0))&-1; //@line 46596 "c/sqlite3.c"
     $22 = ((($$037)) + 16|0); //@line 46597 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 46597 "c/sqlite3.c"
     $24 = (($7) + ($21<<2)|0); //@line 46598 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 46598 "c/sqlite3.c"
     HEAP32[$22>>2] = $25; //@line 46598 "c/sqlite3.c"
     HEAP32[$24>>2] = $$037; //@line 46599 "c/sqlite3.c"
     $26 = ($23|0)==(0|0); //@line 46595 "c/sqlite3.c"
     if ($26) {
      break;
     } else {
      $$037 = $23;
     }
    }
   }
   $27 = (($$03638) + 1)|0; //@line 46592 "c/sqlite3.c"
   $28 = ($27>>>0)<($14>>>0); //@line 46592 "c/sqlite3.c"
   if ($28) {
    $$03638 = $27;
   } else {
    break;
   }
  }
 }
 $29 = HEAP32[$13>>2]|0; //@line 46602 "c/sqlite3.c"
 _sqlite3_free($29); //@line 46602 "c/sqlite3.c"
 HEAP32[$13>>2] = $7; //@line 46603 "c/sqlite3.c"
 HEAP32[$1>>2] = $spec$store$select; //@line 46604 "c/sqlite3.c"
 return; //@line 46606 "c/sqlite3.c"
}
function _pcache1AllocPage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$024 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 56|0); //@line 46464 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 46464 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 46464 "c/sqlite3.c"
 do {
  if ($4) {
   $5 = ((($0)) + 44|0); //@line 46464 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 46464 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 46464 "c/sqlite3.c"
   if ($7) {
    $8 = (_pcache1InitBulk($0)|0); //@line 46464 "c/sqlite3.c"
    $9 = ($8|0)==(0); //@line 46464 "c/sqlite3.c"
    if (!($9)) {
     label = 4;
     break;
    }
   }
   $13 = ($1|0)!=(0); //@line 46477 "c/sqlite3.c"
   if ($13) {
    _sqlite3BeginBenignMalloc(); //@line 46477 "c/sqlite3.c"
   }
   $14 = ((($0)) + 16|0); //@line 46487 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 46487 "c/sqlite3.c"
   $16 = (_pcache1Alloc($15)|0); //@line 46487 "c/sqlite3.c"
   $17 = ((($0)) + 8|0); //@line 46488 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 46488 "c/sqlite3.c"
   $19 = (($16) + ($18)|0); //@line 46488 "c/sqlite3.c"
   if ($13) {
    _sqlite3EndBenignMalloc(); //@line 46490 "c/sqlite3.c"
   }
   $20 = ($16|0)==(0|0); //@line 46494 "c/sqlite3.c"
   if ($20) {
    $$0 = 0;
    return ($$0|0); //@line 46502 "c/sqlite3.c"
   } else {
    HEAP32[$19>>2] = $16; //@line 46495 "c/sqlite3.c"
    $21 = ((($19)) + 32|0); //@line 46496 "c/sqlite3.c"
    $22 = ((($19)) + 4|0); //@line 46496 "c/sqlite3.c"
    HEAP32[$22>>2] = $21; //@line 46496 "c/sqlite3.c"
    $23 = ((($19)) + 12|0); //@line 46497 "c/sqlite3.c"
    HEAP8[$23>>0] = 0; //@line 46497 "c/sqlite3.c"
    $24 = ((($19)) + 13|0); //@line 46498 "c/sqlite3.c"
    HEAP8[$24>>0] = 0; //@line 46498 "c/sqlite3.c"
    $$024 = $19;
    break;
   }
  } else {
   label = 4;
  }
 } while(0);
 if ((label|0) == 4) {
  $10 = HEAP32[$2>>2]|0; //@line 46465 "c/sqlite3.c"
  $11 = ((($10)) + 16|0); //@line 46466 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 46466 "c/sqlite3.c"
  HEAP32[$2>>2] = $12; //@line 46466 "c/sqlite3.c"
  HEAP32[$11>>2] = 0; //@line 46467 "c/sqlite3.c"
  $$024 = $10;
 }
 $25 = ((($0)) + 4|0); //@line 46500 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 46500 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 46500 "c/sqlite3.c"
 $28 = (($27) + 1)|0; //@line 46500 "c/sqlite3.c"
 HEAP32[$26>>2] = $28; //@line 46500 "c/sqlite3.c"
 $$0 = $$024;
 return ($$0|0); //@line 46502 "c/sqlite3.c"
}
function _pcache1InitBulk($0) {
 $0 = $0|0;
 var $$0 = 0, $$035 = 0, $$036 = 0, $$sink$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(40248)>>2]|0; //@line 46332 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 46332 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 46360 "c/sqlite3.c"
 }
 $3 = ((($0)) + 28|0); //@line 46334 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 46334 "c/sqlite3.c"
 $5 = ($4>>>0)<(3); //@line 46334 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 46360 "c/sqlite3.c"
 }
 _sqlite3BeginBenignMalloc(); //@line 46335 "c/sqlite3.c"
 $6 = HEAP32[(40248)>>2]|0; //@line 46336 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 46336 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 16|0); //@line 46337 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 46337 "c/sqlite3.c"
  $10 = ($6|0)<(0); //@line 46337 "c/sqlite3.c"
  $11 = $10 << 31 >> 31; //@line 46337 "c/sqlite3.c"
  $$sink$in = $9;$14 = $6;$15 = $11;
 } else {
  $$sink$in = $6;$14 = -1024;$15 = -1;
 }
 $12 = ($$sink$in|0)<(0);
 $13 = $12 << 31 >> 31;
 $16 = (___muldi3(($14|0),($15|0),($$sink$in|0),($13|0))|0);
 $17 = tempRet0;
 $18 = ((($0)) + 16|0); //@line 46341 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 46341 "c/sqlite3.c"
 $20 = ($19|0)<(0); //@line 46341 "c/sqlite3.c"
 $21 = $20 << 31 >> 31; //@line 46341 "c/sqlite3.c"
 $22 = HEAP32[$3>>2]|0; //@line 46341 "c/sqlite3.c"
 $23 = (___muldi3(($22|0),0,($19|0),($21|0))|0); //@line 46341 "c/sqlite3.c"
 $24 = tempRet0; //@line 46341 "c/sqlite3.c"
 $25 = ($17|0)>($24|0); //@line 46341 "c/sqlite3.c"
 $26 = ($16>>>0)>($23>>>0); //@line 46341 "c/sqlite3.c"
 $27 = ($17|0)==($24|0); //@line 46341 "c/sqlite3.c"
 $28 = $27 & $26; //@line 46341 "c/sqlite3.c"
 $29 = $25 | $28; //@line 46341 "c/sqlite3.c"
 $30 = $29 ? $23 : $16; //@line 46341 "c/sqlite3.c"
 $31 = $29 ? $24 : $17; //@line 46341 "c/sqlite3.c"
 $32 = (_sqlite3Malloc($30,$31)|0); //@line 46344 "c/sqlite3.c"
 $33 = ((($0)) + 60|0); //@line 46344 "c/sqlite3.c"
 HEAP32[$33>>2] = $32; //@line 46344 "c/sqlite3.c"
 _sqlite3EndBenignMalloc(); //@line 46345 "c/sqlite3.c"
 $34 = ($32|0)==(0|0); //@line 46346 "c/sqlite3.c"
 if (!($34)) {
  $35 = (_sqlite3MallocSize($32)|0); //@line 46347 "c/sqlite3.c"
  $36 = HEAP32[$18>>2]|0; //@line 46347 "c/sqlite3.c"
  $37 = (($35|0) / ($36|0))&-1; //@line 46347 "c/sqlite3.c"
  $38 = ((($0)) + 8|0);
  $39 = HEAP32[$38>>2]|0;
  $40 = ((($0)) + 56|0);
  $$035 = $37;$$036 = $32;
  while(1) {
   $41 = (($$036) + ($39)|0); //@line 46349 "c/sqlite3.c"
   HEAP32[$41>>2] = $$036; //@line 46350 "c/sqlite3.c"
   $42 = ((($41)) + 32|0); //@line 46351 "c/sqlite3.c"
   $43 = ((($41)) + 4|0); //@line 46351 "c/sqlite3.c"
   HEAP32[$43>>2] = $42; //@line 46351 "c/sqlite3.c"
   $44 = ((($41)) + 12|0); //@line 46352 "c/sqlite3.c"
   HEAP8[$44>>0] = 1; //@line 46352 "c/sqlite3.c"
   $45 = ((($41)) + 13|0); //@line 46353 "c/sqlite3.c"
   HEAP8[$45>>0] = 0; //@line 46353 "c/sqlite3.c"
   $46 = HEAP32[$40>>2]|0; //@line 46354 "c/sqlite3.c"
   $47 = ((($41)) + 16|0); //@line 46354 "c/sqlite3.c"
   HEAP32[$47>>2] = $46; //@line 46354 "c/sqlite3.c"
   HEAP32[$40>>2] = $41; //@line 46355 "c/sqlite3.c"
   $48 = (($$036) + ($36)|0); //@line 46356 "c/sqlite3.c"
   $49 = (($$035) + -1)|0; //@line 46357 "c/sqlite3.c"
   $50 = ($49|0)==(0); //@line 46357 "c/sqlite3.c"
   if ($50) {
    break;
   } else {
    $$035 = $49;$$036 = $48;
   }
  }
 }
 $51 = ((($0)) + 56|0); //@line 46359 "c/sqlite3.c"
 $52 = HEAP32[$51>>2]|0; //@line 46359 "c/sqlite3.c"
 $53 = ($52|0)!=(0|0); //@line 46359 "c/sqlite3.c"
 $54 = $53&1; //@line 46359 "c/sqlite3.c"
 $$0 = $54;
 return ($$0|0); //@line 46360 "c/sqlite3.c"
}
function _sqlite3BeginBenignMalloc() {
 var $0 = 0, $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[10100]|0; //@line 21306 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 21306 "c/sqlite3.c"
 if ($1) {
  return; //@line 21309 "c/sqlite3.c"
 }
 FUNCTION_TABLE_v[$0 & 127](); //@line 21307 "c/sqlite3.c"
 return; //@line 21309 "c/sqlite3.c"
}
function _pcache1Alloc($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(40252)>>2]|0; //@line 46374 "c/sqlite3.c"
 $2 = ($1|0)<($0|0); //@line 46374 "c/sqlite3.c"
 do {
  if (!($2)) {
   $3 = HEAP32[(40272)>>2]|0; //@line 46375 "c/sqlite3.c"
   _sqlite3_mutex_enter($3); //@line 46375 "c/sqlite3.c"
   $4 = HEAP32[(40276)>>2]|0; //@line 46376 "c/sqlite3.c"
   $5 = ($4|0)==(0|0); //@line 46377 "c/sqlite3.c"
   if ($5) {
    $13 = HEAP32[(40272)>>2]|0; //@line 46385 "c/sqlite3.c"
    _sqlite3_mutex_leave($13); //@line 46385 "c/sqlite3.c"
    break;
   }
   $6 = HEAP32[$4>>2]|0; //@line 46378 "c/sqlite3.c"
   HEAP32[(40276)>>2] = $6; //@line 46378 "c/sqlite3.c"
   $7 = HEAP32[(40280)>>2]|0; //@line 46379 "c/sqlite3.c"
   $8 = (($7) + -1)|0; //@line 46379 "c/sqlite3.c"
   HEAP32[(40280)>>2] = $8; //@line 46379 "c/sqlite3.c"
   $9 = HEAP32[(40260)>>2]|0; //@line 46380 "c/sqlite3.c"
   $10 = ($7|0)<=($9|0); //@line 46380 "c/sqlite3.c"
   $11 = $10&1; //@line 46380 "c/sqlite3.c"
   HEAP32[(40284)>>2] = $11; //@line 46380 "c/sqlite3.c"
   _sqlite3StatusHighwater(7,$0); //@line 46382 "c/sqlite3.c"
   _sqlite3StatusUp(1,1); //@line 46383 "c/sqlite3.c"
   $12 = HEAP32[(40272)>>2]|0; //@line 46385 "c/sqlite3.c"
   _sqlite3_mutex_leave($12); //@line 46385 "c/sqlite3.c"
   $$1 = $4;
   return ($$1|0); //@line 46403 "c/sqlite3.c"
  }
 } while(0);
 $14 = ($0|0)<(0); //@line 46391 "c/sqlite3.c"
 $15 = $14 << 31 >> 31; //@line 46391 "c/sqlite3.c"
 $16 = (_sqlite3Malloc($0,$15)|0); //@line 46391 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 46393 "c/sqlite3.c"
 if ($17) {
  $$1 = 0;
  return ($$1|0); //@line 46403 "c/sqlite3.c"
 }
 $18 = (_sqlite3MallocSize($16)|0); //@line 46394 "c/sqlite3.c"
 $19 = HEAP32[(40272)>>2]|0; //@line 46395 "c/sqlite3.c"
 _sqlite3_mutex_enter($19); //@line 46395 "c/sqlite3.c"
 _sqlite3StatusHighwater(7,$0); //@line 46396 "c/sqlite3.c"
 _sqlite3StatusUp(2,$18); //@line 46397 "c/sqlite3.c"
 $20 = HEAP32[(40272)>>2]|0; //@line 46398 "c/sqlite3.c"
 _sqlite3_mutex_leave($20); //@line 46398 "c/sqlite3.c"
 $$1 = $16;
 return ($$1|0); //@line 46403 "c/sqlite3.c"
}
function _sqlite3EndBenignMalloc() {
 var $0 = 0, $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[10099]|0; //@line 21312 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 21312 "c/sqlite3.c"
 if ($1) {
  return; //@line 21315 "c/sqlite3.c"
 }
 FUNCTION_TABLE_v[$0 & 127](); //@line 21313 "c/sqlite3.c"
 return; //@line 21315 "c/sqlite3.c"
}
function _sqlite3MallocZero($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3Malloc($0,$1)|0); //@line 25585 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 25586 "c/sqlite3.c"
 if (!($3)) {
  _memset(($2|0),0,($0|0))|0; //@line 25587 "c/sqlite3.c"
 }
 return ($2|0); //@line 25589 "c/sqlite3.c"
}
function _sqlite3HeapNearlyFull() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[(40096)>>2]|0; //@line 25273 "c/sqlite3.c"
 return ($0|0); //@line 25273 "c/sqlite3.c"
}
function _sqlite3AlterFunctions() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3InsertBuiltinFuncs(7416,3); //@line 98260 "c/sqlite3.c"
 return; //@line 98261 "c/sqlite3.c"
}
function _sqlite3RegisterDateTimeFunctions() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3InsertBuiltinFuncs(7192,8); //@line 20806 "c/sqlite3.c"
 return; //@line 20807 "c/sqlite3.c"
}
function _sqlite3InsertBuiltinFuncs($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$033 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 106385 "c/sqlite3.c"
 if (!($2)) {
  return; //@line 106402 "c/sqlite3.c"
 }
 $$033 = 0;
 while(1) {
  $3 = (($0) + (($$033*28)|0)|0); //@line 106387 "c/sqlite3.c"
  $4 = (((($0) + (($$033*28)|0)|0)) + 20|0); //@line 106387 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 106387 "c/sqlite3.c"
  $6 = (_sqlite3Strlen30($5)|0); //@line 106388 "c/sqlite3.c"
  $7 = HEAP8[$5>>0]|0; //@line 106389 "c/sqlite3.c"
  $8 = $7 << 24 >> 24; //@line 106389 "c/sqlite3.c"
  $9 = (($6) + ($8))|0; //@line 106389 "c/sqlite3.c"
  $10 = (($9|0) % 23)&-1; //@line 106389 "c/sqlite3.c"
  $11 = (_functionSearch($10,$5)|0); //@line 106391 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 106392 "c/sqlite3.c"
  if ($12) {
   $16 = (((($0) + (($$033*28)|0)|0)) + 8|0); //@line 106397 "c/sqlite3.c"
   HEAP32[$16>>2] = 0; //@line 106397 "c/sqlite3.c"
   $17 = (40288 + ($10<<2)|0); //@line 106398 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 106398 "c/sqlite3.c"
   $19 = (((($0) + (($$033*28)|0)|0)) + 24|0); //@line 106398 "c/sqlite3.c"
   HEAP32[$19>>2] = $18; //@line 106398 "c/sqlite3.c"
   $$sink = $17;
  } else {
   $13 = ((($11)) + 8|0); //@line 106394 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 106394 "c/sqlite3.c"
   $15 = (((($0) + (($$033*28)|0)|0)) + 8|0); //@line 106394 "c/sqlite3.c"
   HEAP32[$15>>2] = $14; //@line 106394 "c/sqlite3.c"
   $$sink = $13;
  }
  HEAP32[$$sink>>2] = $3;
  $20 = (($$033) + 1)|0; //@line 106385 "c/sqlite3.c"
  $exitcond = ($20|0)==($1|0); //@line 106385 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$033 = $20;
  }
 }
 return; //@line 106402 "c/sqlite3.c"
}
function _functionSearch($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$06 = 0, $$07 = 0, $$08 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (40288 + ($0<<2)|0); //@line 106369 "c/sqlite3.c"
 $$07 = HEAP32[$2>>2]|0;
 $3 = ($$07|0)==(0|0); //@line 106369 "c/sqlite3.c"
 if ($3) {
  $$06 = 0;
  return ($$06|0); //@line 106375 "c/sqlite3.c"
 }
 $$08 = $$07;
 while(1) {
  $4 = ((($$08)) + 20|0); //@line 106370 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 106370 "c/sqlite3.c"
  $6 = (_sqlite3StrICmp($5,$1)|0); //@line 106370 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 106370 "c/sqlite3.c"
  if ($7) {
   $$06 = $$08;
   label = 5;
   break;
  }
  $8 = ((($$08)) + 24|0); //@line 106369 "c/sqlite3.c"
  $$0 = HEAP32[$8>>2]|0;
  $9 = ($$0|0)==(0|0); //@line 106369 "c/sqlite3.c"
  if ($9) {
   $$06 = 0;
   label = 5;
   break;
  } else {
   $$08 = $$0;
  }
 }
 if ((label|0) == 5) {
  return ($$06|0); //@line 106375 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3StrICmp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01315 = 0, $$016 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond14 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 28771 "c/sqlite3.c"
 $3 = $2&255; //@line 28771 "c/sqlite3.c"
 $4 = (16025 + ($3)|0); //@line 28771 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 28771 "c/sqlite3.c"
 $6 = $5&255; //@line 28771 "c/sqlite3.c"
 $7 = HEAP8[$1>>0]|0; //@line 28771 "c/sqlite3.c"
 $8 = $7&255; //@line 28771 "c/sqlite3.c"
 $9 = (16025 + ($8)|0); //@line 28771 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 28771 "c/sqlite3.c"
 $11 = $10&255; //@line 28771 "c/sqlite3.c"
 $12 = (($6) - ($11))|0; //@line 28771 "c/sqlite3.c"
 $13 = ($12|0)!=(0); //@line 28772 "c/sqlite3.c"
 $14 = ($2<<24>>24)==(0); //@line 28772 "c/sqlite3.c"
 $or$cond14 = $14 | $13; //@line 28772 "c/sqlite3.c"
 if ($or$cond14) {
  $$lcssa = $12;
  return ($$lcssa|0); //@line 28776 "c/sqlite3.c"
 }
 $$01315 = $1;$$016 = $0;
 while(1) {
  $15 = ((($$016)) + 1|0); //@line 28773 "c/sqlite3.c"
  $16 = ((($$01315)) + 1|0); //@line 28774 "c/sqlite3.c"
  $17 = HEAP8[$15>>0]|0; //@line 28771 "c/sqlite3.c"
  $18 = $17&255; //@line 28771 "c/sqlite3.c"
  $19 = (16025 + ($18)|0); //@line 28771 "c/sqlite3.c"
  $20 = HEAP8[$19>>0]|0; //@line 28771 "c/sqlite3.c"
  $21 = $20&255; //@line 28771 "c/sqlite3.c"
  $22 = HEAP8[$16>>0]|0; //@line 28771 "c/sqlite3.c"
  $23 = $22&255; //@line 28771 "c/sqlite3.c"
  $24 = (16025 + ($23)|0); //@line 28771 "c/sqlite3.c"
  $25 = HEAP8[$24>>0]|0; //@line 28771 "c/sqlite3.c"
  $26 = $25&255; //@line 28771 "c/sqlite3.c"
  $27 = (($21) - ($26))|0; //@line 28771 "c/sqlite3.c"
  $28 = ($27|0)!=(0); //@line 28772 "c/sqlite3.c"
  $29 = ($17<<24>>24)==(0); //@line 28772 "c/sqlite3.c"
  $or$cond = $29 | $28; //@line 28772 "c/sqlite3.c"
  if ($or$cond) {
   $$lcssa = $27;
   break;
  } else {
   $$01315 = $16;$$016 = $15;
  }
 }
 return ($$lcssa|0); //@line 28776 "c/sqlite3.c"
}
function _loadExt($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = HEAP32[$2>>2]|0; //@line 108946 "c/sqlite3.c"
 $5 = (_sqlite3_value_text($4)|0); //@line 108946 "c/sqlite3.c"
 $6 = (_sqlite3_context_db_handle($0)|0); //@line 108948 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 108949 "c/sqlite3.c"
 $7 = ((($6)) + 28|0); //@line 108954 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 108954 "c/sqlite3.c"
 $9 = $8 & 131072; //@line 108954 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 108954 "c/sqlite3.c"
 if ($10) {
  _sqlite3_result_error($0,17871,-1); //@line 108955 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108968 "c/sqlite3.c"
 }
 $11 = ($1|0)==(2); //@line 108959 "c/sqlite3.c"
 if ($11) {
  $12 = ((($2)) + 4|0); //@line 108960 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 108960 "c/sqlite3.c"
  $14 = (_sqlite3_value_text($13)|0); //@line 108960 "c/sqlite3.c"
  $$0 = $14;
 } else {
  $$0 = 0;
 }
 $15 = ($5|0)==(0|0); //@line 108964 "c/sqlite3.c"
 if ($15) {
  STACKTOP = sp;return; //@line 108968 "c/sqlite3.c"
 }
 $16 = (_sqlite3_load_extension($6,$5,$$0,$3)|0); //@line 108964 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 108964 "c/sqlite3.c"
 if ($17) {
  STACKTOP = sp;return; //@line 108968 "c/sqlite3.c"
 }
 $18 = HEAP32[$3>>2]|0; //@line 108965 "c/sqlite3.c"
 _sqlite3_result_error($0,$18,-1); //@line 108965 "c/sqlite3.c"
 $19 = HEAP32[$3>>2]|0; //@line 108966 "c/sqlite3.c"
 _sqlite3_free($19); //@line 108966 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 108968 "c/sqlite3.c"
}
function _compileoptionusedFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108471 "c/sqlite3.c"
 $4 = (_sqlite3_value_text($3)|0); //@line 108471 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 108471 "c/sqlite3.c"
 if ($5) {
  return; //@line 108474 "c/sqlite3.c"
 }
 $6 = (_sqlite3_compileoption_used($4)|0); //@line 108472 "c/sqlite3.c"
 _sqlite3_result_int($0,$6); //@line 108472 "c/sqlite3.c"
 return; //@line 108474 "c/sqlite3.c"
}
function _compileoptiongetFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108494 "c/sqlite3.c"
 $4 = (_sqlite3_value_int($3)|0); //@line 108494 "c/sqlite3.c"
 $5 = (_sqlite3_compileoption_get($4)|0); //@line 108495 "c/sqlite3.c"
 _sqlite3_result_text($0,$5,-1,0); //@line 108495 "c/sqlite3.c"
 return; //@line 108496 "c/sqlite3.c"
}
function _versionFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3_result_text($0,15077,-1,0); //@line 108419 "c/sqlite3.c"
 return; //@line 108420 "c/sqlite3.c"
}
function _trimFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0103183 = 0, $$0108182 = 0, $$0119166 = 0, $$0121174 = 0, $$0125173 = 0, $$0131133 = 0, $$1104 = 0, $$1109178 = 0, $$1120159 = 0, $$2 = 0, $$2115136 = 0, $$2118134 = 0, $$2123 = 0, $$2123200 = 0, $$2127 = 0, $$3124 = 0, $$3128163 = 0, $$3179 = 0, $$4 = 0, $$4112138 = 0;
 var $$5 = 0, $$5130 = 0, $$6 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $9 = 0, $or$cond = 0, $or$cond188 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108794 "c/sqlite3.c"
 $4 = (_sqlite3_value_type($3)|0); //@line 108794 "c/sqlite3.c"
 $5 = ($4|0)==(5); //@line 108794 "c/sqlite3.c"
 if ($5) {
  return; //@line 108858 "c/sqlite3.c"
 }
 $6 = (_sqlite3_value_text($3)|0); //@line 108797 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 108798 "c/sqlite3.c"
 if ($7) {
  return; //@line 108858 "c/sqlite3.c"
 }
 $8 = HEAP32[$2>>2]|0; //@line 108799 "c/sqlite3.c"
 $9 = (_sqlite3_value_bytes($8)|0); //@line 108799 "c/sqlite3.c"
 $10 = ($1|0)==(1); //@line 108801 "c/sqlite3.c"
 if ($10) {
  $$0131133 = 0;$$2115136 = 3920;$$2118134 = 17826;$$4112138 = 1;$88 = 3920;
  label = 19;
 } else {
  $11 = ((($2)) + 4|0); //@line 108808 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 108808 "c/sqlite3.c"
  $13 = (_sqlite3_value_text($12)|0); //@line 108808 "c/sqlite3.c"
  $14 = ($13|0)==(0|0); //@line 108808 "c/sqlite3.c"
  if ($14) {
   return; //@line 108858 "c/sqlite3.c"
  }
  $15 = HEAP8[$13>>0]|0; //@line 108812 "c/sqlite3.c"
  $16 = ($15<<24>>24)==(0); //@line 108812 "c/sqlite3.c"
  if ($16) {
   $$3124 = $6;$$6 = $9;
  } else {
   $$0103183 = $13;$$0108182 = 0;$19 = $15;
   while(1) {
    $17 = ((($$0103183)) + 1|0); //@line 108813 "c/sqlite3.c"
    $18 = ($19&255)>(191); //@line 108813 "c/sqlite3.c"
    if ($18) {
     $$1104 = $17;
     while(1) {
      $20 = HEAP8[$$1104>>0]|0; //@line 108813 "c/sqlite3.c"
      $21 = $20 & -64; //@line 108813 "c/sqlite3.c"
      $22 = ($21<<24>>24)==(-128); //@line 108813 "c/sqlite3.c"
      $23 = ((($$1104)) + 1|0); //@line 108813 "c/sqlite3.c"
      if ($22) {
       $$1104 = $23;
      } else {
       $$2 = $$1104;$26 = $20;
       break;
      }
     }
    } else {
     $$pr = HEAP8[$17>>0]|0; //@line 108812 "c/sqlite3.c"
     $$2 = $17;$26 = $$pr;
    }
    $24 = (($$0108182) + 1)|0; //@line 108812 "c/sqlite3.c"
    $25 = ($26<<24>>24)==(0); //@line 108812 "c/sqlite3.c"
    if ($25) {
     break;
    } else {
     $$0103183 = $$2;$$0108182 = $24;$19 = $26;
    }
   }
   $27 = (___muldi3(($24|0),0,5,0)|0); //@line 108816 "c/sqlite3.c"
   $28 = tempRet0; //@line 108816 "c/sqlite3.c"
   $29 = (_contextMalloc($0,$27,$28)|0); //@line 108816 "c/sqlite3.c"
   $30 = ($29|0)==(0|0); //@line 108817 "c/sqlite3.c"
   if ($30) {
    return; //@line 108858 "c/sqlite3.c"
   }
   $31 = (($29) + ($24<<2)|0); //@line 108820 "c/sqlite3.c"
   $32 = HEAP8[$13>>0]|0; //@line 108821 "c/sqlite3.c"
   $33 = ($32<<24>>24)==(0); //@line 108821 "c/sqlite3.c"
   if ($33) {
    $$3124 = $6;$$6 = $9;
   } else {
    $$1109178 = 0;$$3179 = $13;
    while(1) {
     $34 = (($29) + ($$1109178<<2)|0); //@line 108822 "c/sqlite3.c"
     HEAP32[$34>>2] = $$3179; //@line 108822 "c/sqlite3.c"
     $35 = ((($$3179)) + 1|0); //@line 108823 "c/sqlite3.c"
     $36 = HEAP8[$$3179>>0]|0; //@line 108823 "c/sqlite3.c"
     $37 = ($36&255)>(191); //@line 108823 "c/sqlite3.c"
     if ($37) {
      $$4 = $35;
      while(1) {
       $38 = HEAP8[$$4>>0]|0; //@line 108823 "c/sqlite3.c"
       $39 = $38 & -64; //@line 108823 "c/sqlite3.c"
       $40 = ($39<<24>>24)==(-128); //@line 108823 "c/sqlite3.c"
       $41 = ((($$4)) + 1|0); //@line 108823 "c/sqlite3.c"
       if ($40) {
        $$4 = $41;
       } else {
        $$5 = $$4;
        break;
       }
      }
     } else {
      $$5 = $35;
     }
     $42 = HEAP32[$34>>2]|0; //@line 108824 "c/sqlite3.c"
     $43 = $$5; //@line 108824 "c/sqlite3.c"
     $44 = (($43) - ($42))|0; //@line 108824 "c/sqlite3.c"
     $45 = $44&255; //@line 108824 "c/sqlite3.c"
     $46 = (($31) + ($$1109178)|0); //@line 108824 "c/sqlite3.c"
     HEAP8[$46>>0] = $45; //@line 108824 "c/sqlite3.c"
     $47 = (($$1109178) + 1)|0; //@line 108821 "c/sqlite3.c"
     $48 = HEAP8[$$5>>0]|0; //@line 108821 "c/sqlite3.c"
     $49 = ($48<<24>>24)==(0); //@line 108821 "c/sqlite3.c"
     if ($49) {
      $$0131133 = $13;$$2115136 = $29;$$2118134 = $31;$$4112138 = $47;$88 = $29;
      label = 19;
      break;
     } else {
      $$1109178 = $47;$$3179 = $$5;
     }
    }
   }
  }
 }
 if ((label|0) == 19) {
  $50 = (_sqlite3_user_data($0)|0); //@line 108829 "c/sqlite3.c"
  $51 = $50; //@line 108829 "c/sqlite3.c"
  $52 = $51 & 1; //@line 108830 "c/sqlite3.c"
  $53 = ($52|0)!=(0); //@line 108830 "c/sqlite3.c"
  $54 = ($9|0)>(0); //@line 108831 "c/sqlite3.c"
  $or$cond = $53 & $54; //@line 108830 "c/sqlite3.c"
  L35: do {
   if ($or$cond) {
    $$0121174 = $6;$$0125173 = $9;
    while(1) {
     $$0119166 = 0;
     while(1) {
      $55 = (($$2118134) + ($$0119166)|0); //@line 108834 "c/sqlite3.c"
      $56 = HEAP8[$55>>0]|0; //@line 108834 "c/sqlite3.c"
      $57 = $56&255; //@line 108834 "c/sqlite3.c"
      $58 = ($$0125173|0)<($57|0); //@line 108835 "c/sqlite3.c"
      if (!($58)) {
       $59 = (($$2115136) + ($$0119166<<2)|0); //@line 108835 "c/sqlite3.c"
       $60 = HEAP32[$59>>2]|0; //@line 108835 "c/sqlite3.c"
       $61 = (_memcmp($$0121174,$60,$57)|0); //@line 108835 "c/sqlite3.c"
       $62 = ($61|0)==(0); //@line 108835 "c/sqlite3.c"
       if ($62) {
        break;
       }
      }
      $63 = (($$0119166) + 1)|0; //@line 108833 "c/sqlite3.c"
      $64 = ($63>>>0)<($$4112138>>>0); //@line 108833 "c/sqlite3.c"
      if ($64) {
       $$0119166 = $63;
      } else {
       $$2123 = $$0121174;$$2127 = $$0125173;
       label = 26;
       break L35;
      }
     }
     $65 = $56&255; //@line 108834 "c/sqlite3.c"
     $66 = (($$0121174) + ($65)|0); //@line 108838 "c/sqlite3.c"
     $67 = (($$0125173) - ($65))|0; //@line 108839 "c/sqlite3.c"
     $68 = ($67|0)>(0); //@line 108831 "c/sqlite3.c"
     if ($68) {
      $$0121174 = $66;$$0125173 = $67;
     } else {
      $$2123200 = $66;$$5130 = $67;
      break;
     }
    }
   } else {
    $$2123 = $6;$$2127 = $9;
    label = 26;
   }
  } while(0);
  L45: do {
   if ((label|0) == 26) {
    $69 = $51 & 2; //@line 108842 "c/sqlite3.c"
    $70 = ($69|0)!=(0); //@line 108842 "c/sqlite3.c"
    $71 = ($$2127|0)>(0); //@line 108843 "c/sqlite3.c"
    $or$cond188 = $70 & $71; //@line 108842 "c/sqlite3.c"
    if ($or$cond188) {
     $$3128163 = $$2127;
     while(1) {
      $$1120159 = 0;
      while(1) {
       $72 = (($$2118134) + ($$1120159)|0); //@line 108846 "c/sqlite3.c"
       $73 = HEAP8[$72>>0]|0; //@line 108846 "c/sqlite3.c"
       $74 = $73&255; //@line 108846 "c/sqlite3.c"
       $75 = ($$3128163|0)<($74|0); //@line 108847 "c/sqlite3.c"
       if (!($75)) {
        $76 = (($$3128163) - ($74))|0; //@line 108847 "c/sqlite3.c"
        $77 = (($$2123) + ($76)|0); //@line 108847 "c/sqlite3.c"
        $78 = (($$2115136) + ($$1120159<<2)|0); //@line 108847 "c/sqlite3.c"
        $79 = HEAP32[$78>>2]|0; //@line 108847 "c/sqlite3.c"
        $80 = (_memcmp($77,$79,$74)|0); //@line 108847 "c/sqlite3.c"
        $81 = ($80|0)==(0); //@line 108847 "c/sqlite3.c"
        if ($81) {
         break;
        }
       }
       $82 = (($$1120159) + 1)|0; //@line 108845 "c/sqlite3.c"
       $83 = ($82>>>0)<($$4112138>>>0); //@line 108845 "c/sqlite3.c"
       if ($83) {
        $$1120159 = $82;
       } else {
        $$2123200 = $$2123;$$5130 = $$3128163;
        break L45;
       }
      }
      $84 = $73&255; //@line 108846 "c/sqlite3.c"
      $85 = (($$3128163) - ($84))|0; //@line 108850 "c/sqlite3.c"
      $86 = ($85|0)>(0); //@line 108843 "c/sqlite3.c"
      if ($86) {
       $$3128163 = $85;
      } else {
       $$2123200 = $$2123;$$5130 = $85;
       break;
      }
     }
    } else {
     $$2123200 = $$2123;$$5130 = $$2127;
    }
   }
  } while(0);
  $87 = ($$0131133|0)==(0|0); //@line 108853 "c/sqlite3.c"
  if ($87) {
   $$3124 = $$2123200;$$6 = $$5130;
  } else {
   _sqlite3_free($88); //@line 108854 "c/sqlite3.c"
   $$3124 = $$2123200;$$6 = $$5130;
  }
 }
 _sqlite3_result_text($0,$$3124,$$6,(-1)); //@line 108857 "c/sqlite3.c"
 return; //@line 108858 "c/sqlite3.c"
}
function _minmaxFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$024$lcssa = 0, $$02426 = 0, $$027 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_user_data($0)|0); //@line 107568 "c/sqlite3.c"
 $4 = ($3|0)!=(0|0); //@line 107568 "c/sqlite3.c"
 $5 = $4 << 31 >> 31; //@line 107568 "c/sqlite3.c"
 $6 = (_sqlite3GetFuncCollSeq($0)|0); //@line 107569 "c/sqlite3.c"
 $7 = HEAP32[$2>>2]|0; //@line 107573 "c/sqlite3.c"
 $8 = (_sqlite3_value_type($7)|0); //@line 107573 "c/sqlite3.c"
 $9 = ($8|0)==(5); //@line 107573 "c/sqlite3.c"
 if ($9) {
  return; //@line 107582 "c/sqlite3.c"
 }
 $10 = ($1|0)>(1); //@line 107574 "c/sqlite3.c"
 L4: do {
  if ($10) {
   $$02426 = 0;$$027 = 1;
   while(1) {
    $11 = (($2) + ($$027<<2)|0); //@line 107575 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 107575 "c/sqlite3.c"
    $13 = (_sqlite3_value_type($12)|0); //@line 107575 "c/sqlite3.c"
    $14 = ($13|0)==(5); //@line 107575 "c/sqlite3.c"
    if ($14) {
     break;
    }
    $15 = (($2) + ($$02426<<2)|0); //@line 107576 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 107576 "c/sqlite3.c"
    $17 = (_sqlite3MemCompare($16,$12,$6)|0); //@line 107576 "c/sqlite3.c"
    $18 = $17 ^ $5; //@line 107576 "c/sqlite3.c"
    $19 = ($18|0)>(-1); //@line 107576 "c/sqlite3.c"
    $spec$select = $19 ? $$027 : $$02426; //@line 107576 "c/sqlite3.c"
    $20 = (($$027) + 1)|0; //@line 107574 "c/sqlite3.c"
    $21 = ($20|0)<($1|0); //@line 107574 "c/sqlite3.c"
    if ($21) {
     $$02426 = $spec$select;$$027 = $20;
    } else {
     $$024$lcssa = $spec$select;
     break L4;
    }
   }
   return; //@line 107582 "c/sqlite3.c"
  } else {
   $$024$lcssa = 0;
  }
 } while(0);
 $22 = (($2) + ($$024$lcssa<<2)|0); //@line 107581 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 107581 "c/sqlite3.c"
 _sqlite3_result_value($0,$23); //@line 107581 "c/sqlite3.c"
 return; //@line 107582 "c/sqlite3.c"
}
function _minmaxStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 109085 "c/sqlite3.c"
 $4 = (_sqlite3_aggregate_context($0,40)|0); //@line 109089 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 109090 "c/sqlite3.c"
 if ($5) {
  return; //@line 109117 "c/sqlite3.c"
 }
 $6 = HEAP32[$2>>2]|0; //@line 109092 "c/sqlite3.c"
 $7 = (_sqlite3_value_type($6)|0); //@line 109092 "c/sqlite3.c"
 $8 = ($7|0)==(5); //@line 109092 "c/sqlite3.c"
 $9 = ((($4)) + 8|0);
 $10 = HEAP16[$9>>1]|0;
 $11 = ($10<<16>>16)!=(0);
 if ($8) {
  if (!($11)) {
   return; //@line 109117 "c/sqlite3.c"
  }
  _sqlite3SkipAccumulatorLoad($0); //@line 109093 "c/sqlite3.c"
  return; //@line 109117 "c/sqlite3.c"
 }
 if (!($11)) {
  $19 = (_sqlite3_context_db_handle($0)|0); //@line 109114 "c/sqlite3.c"
  $20 = ((($4)) + 32|0); //@line 109114 "c/sqlite3.c"
  HEAP32[$20>>2] = $19; //@line 109114 "c/sqlite3.c"
  (_sqlite3VdbeMemCopy($4,$3)|0); //@line 109115 "c/sqlite3.c"
  return; //@line 109117 "c/sqlite3.c"
 }
 $12 = (_sqlite3GetFuncCollSeq($0)|0); //@line 109097 "c/sqlite3.c"
 $13 = (_sqlite3_user_data($0)|0); //@line 109106 "c/sqlite3.c"
 $14 = ($13|0)!=(0|0); //@line 109106 "c/sqlite3.c"
 $15 = (_sqlite3MemCompare($4,$3,$12)|0); //@line 109107 "c/sqlite3.c"
 $16 = ($15|0)<(0); //@line 109108 "c/sqlite3.c"
 $or$cond = $14 & $16; //@line 109108 "c/sqlite3.c"
 if (!($or$cond)) {
  $17 = $14 ^ 1; //@line 109108 "c/sqlite3.c"
  $18 = ($15|0)>(0); //@line 109108 "c/sqlite3.c"
  $or$cond3 = $18 & $17; //@line 109108 "c/sqlite3.c"
  if (!($or$cond3)) {
   _sqlite3SkipAccumulatorLoad($0); //@line 109111 "c/sqlite3.c"
   return; //@line 109117 "c/sqlite3.c"
  }
 }
 (_sqlite3VdbeMemCopy($4,$3)|0); //@line 109109 "c/sqlite3.c"
 return; //@line 109117 "c/sqlite3.c"
}
function _minMaxFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_aggregate_context($0,0)|0); //@line 109120 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 109121 "c/sqlite3.c"
 if ($2) {
  return; //@line 109127 "c/sqlite3.c"
 }
 $3 = ((($1)) + 8|0); //@line 109122 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 109122 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 109122 "c/sqlite3.c"
 if (!($5)) {
  _sqlite3_result_value($0,$1); //@line 109123 "c/sqlite3.c"
 }
 _sqlite3VdbeMemRelease($1); //@line 109125 "c/sqlite3.c"
 return; //@line 109127 "c/sqlite3.c"
}
function _typeofFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 107593 "c/sqlite3.c"
 $4 = (_sqlite3_value_type($3)|0); //@line 107593 "c/sqlite3.c"
 $5 = (($4) + -1)|0; //@line 107593 "c/sqlite3.c"
 $6 = (3900 + ($5<<2)|0); //@line 107605 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 107605 "c/sqlite3.c"
 _sqlite3_result_text($0,$7,-1,0); //@line 107605 "c/sqlite3.c"
 return; //@line 107606 "c/sqlite3.c"
}
function _lengthFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$01720 = 0, $$018$lcssa = 0, $$01819 = 0, $$1 = 0, $$2 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 107621 "c/sqlite3.c"
 $4 = (_sqlite3_value_type($3)|0); //@line 107621 "c/sqlite3.c"
 switch ($4|0) {
 case 2: case 1: case 4:  {
  $5 = (_sqlite3_value_bytes($3)|0); //@line 107625 "c/sqlite3.c"
  _sqlite3_result_int($0,$5); //@line 107625 "c/sqlite3.c"
  return; //@line 107644 "c/sqlite3.c"
  break;
 }
 case 3:  {
  $6 = (_sqlite3_value_text($3)|0); //@line 107629 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 107630 "c/sqlite3.c"
  if ($7) {
   return; //@line 107644 "c/sqlite3.c"
  }
  $8 = HEAP8[$6>>0]|0; //@line 107632 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 107632 "c/sqlite3.c"
  if ($9) {
   $$018$lcssa = 0;
  } else {
   $$01720 = $6;$$01819 = 0;$13 = $8;
   while(1) {
    $10 = (($$01819) + 1)|0; //@line 107633 "c/sqlite3.c"
    $11 = ((($$01720)) + 1|0); //@line 107634 "c/sqlite3.c"
    $12 = ($13&255)>(191); //@line 107634 "c/sqlite3.c"
    if ($12) {
     $$1 = $11;
     while(1) {
      $14 = HEAP8[$$1>>0]|0; //@line 107634 "c/sqlite3.c"
      $15 = $14 & -64; //@line 107634 "c/sqlite3.c"
      $16 = ($15<<24>>24)==(-128); //@line 107634 "c/sqlite3.c"
      $17 = ((($$1)) + 1|0); //@line 107634 "c/sqlite3.c"
      if ($16) {
       $$1 = $17;
      } else {
       $$2 = $$1;$19 = $14;
       break;
      }
     }
    } else {
     $$pr = HEAP8[$11>>0]|0; //@line 107632 "c/sqlite3.c"
     $$2 = $11;$19 = $$pr;
    }
    $18 = ($19<<24>>24)==(0); //@line 107632 "c/sqlite3.c"
    if ($18) {
     $$018$lcssa = $10;
     break;
    } else {
     $$01720 = $$2;$$01819 = $10;$13 = $19;
    }
   }
  }
  _sqlite3_result_int($0,$$018$lcssa); //@line 107636 "c/sqlite3.c"
  return; //@line 107644 "c/sqlite3.c"
  break;
 }
 default: {
  _sqlite3_result_null($0); //@line 107640 "c/sqlite3.c"
  return; //@line 107644 "c/sqlite3.c"
 }
 }
}
function _instrFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$05060 = 0, $$051 = 0, $$053 = 0, $$05458 = 0, $$1 = 0, $$15259 = 0, $$155 = 0, $$155$lcssa = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, $or$cond5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 107715 "c/sqlite3.c"
 $4 = (_sqlite3_value_type($3)|0); //@line 107715 "c/sqlite3.c"
 $5 = ((($2)) + 4|0); //@line 107716 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 107716 "c/sqlite3.c"
 $7 = (_sqlite3_value_type($6)|0); //@line 107716 "c/sqlite3.c"
 $8 = ($4|0)==(5); //@line 107717 "c/sqlite3.c"
 $9 = ($7|0)==(5); //@line 107717 "c/sqlite3.c"
 $or$cond = $8 | $9; //@line 107717 "c/sqlite3.c"
 if ($or$cond) {
  return; //@line 107741 "c/sqlite3.c"
 }
 $10 = (_sqlite3_value_bytes($3)|0); //@line 107718 "c/sqlite3.c"
 $11 = HEAP32[$5>>2]|0; //@line 107719 "c/sqlite3.c"
 $12 = (_sqlite3_value_bytes($11)|0); //@line 107719 "c/sqlite3.c"
 $13 = ($12|0)>(0); //@line 107720 "c/sqlite3.c"
 L4: do {
  if ($13) {
   $14 = ($4|0)==(4); //@line 107721 "c/sqlite3.c"
   $15 = ($7|0)==(4); //@line 107721 "c/sqlite3.c"
   $or$cond3 = $14 & $15; //@line 107721 "c/sqlite3.c"
   $16 = HEAP32[$2>>2]|0;
   if ($or$cond3) {
    $17 = (_sqlite3_value_blob($16)|0); //@line 107722 "c/sqlite3.c"
    $18 = HEAP32[$5>>2]|0; //@line 107723 "c/sqlite3.c"
    $19 = (_sqlite3_value_blob($18)|0); //@line 107723 "c/sqlite3.c"
    $$0 = 0;$$051 = $17;$$053 = $19;
   } else {
    $20 = (_sqlite3_value_text($16)|0); //@line 107726 "c/sqlite3.c"
    $21 = HEAP32[$5>>2]|0; //@line 107727 "c/sqlite3.c"
    $22 = (_sqlite3_value_text($21)|0); //@line 107727 "c/sqlite3.c"
    $$0 = 1;$$051 = $20;$$053 = $22;
   }
   $23 = ($$053|0)==(0|0); //@line 107730 "c/sqlite3.c"
   if ($23) {
    return; //@line 107741 "c/sqlite3.c"
   }
   $24 = ($10|0)!=(0); //@line 107730 "c/sqlite3.c"
   $25 = ($$051|0)==(0|0); //@line 107730 "c/sqlite3.c"
   $or$cond5 = $24 & $25; //@line 107730 "c/sqlite3.c"
   if ($or$cond5) {
    return; //@line 107741 "c/sqlite3.c"
   }
   $26 = ($12|0)>($10|0); //@line 107731 "c/sqlite3.c"
   if ($26) {
    $$1 = 0;
   } else {
    $27 = ($$0|0)==(0);
    $$05060 = 1;$$05458 = $10;$$15259 = $$051;
    while(1) {
     $28 = (_memcmp($$15259,$$053,$12)|0); //@line 107731 "c/sqlite3.c"
     $29 = ($28|0)==(0); //@line 107731 "c/sqlite3.c"
     if ($29) {
      $$1 = $$05060;
      break L4;
     }
     $30 = (($$05060) + 1)|0; //@line 107732 "c/sqlite3.c"
     $$155 = $$05458;$$2 = $$15259;
     while(1) {
      $31 = (($$155) + -1)|0; //@line 107734 "c/sqlite3.c"
      $32 = ((($$2)) + 1|0); //@line 107735 "c/sqlite3.c"
      if ($27) {
       $$155$lcssa = $$05458;
       break;
      }
      $33 = HEAP8[$32>>0]|0; //@line 107736 "c/sqlite3.c"
      $34 = $33 & -64; //@line 107736 "c/sqlite3.c"
      $35 = ($34<<24>>24)==(-128); //@line 107736 "c/sqlite3.c"
      if ($35) {
       $$155 = $31;$$2 = $32;
      } else {
       $$155$lcssa = $$155;
       break;
      }
     }
     $36 = ($12|0)<($$155$lcssa|0); //@line 107731 "c/sqlite3.c"
     if ($36) {
      $$05060 = $30;$$05458 = $31;$$15259 = $32;
     } else {
      $$1 = 0;
      break;
     }
    }
   }
  } else {
   $$1 = 1;
  }
 } while(0);
 _sqlite3_result_int($0,$$1); //@line 107740 "c/sqlite3.c"
 return; //@line 107741 "c/sqlite3.c"
}
function _printfFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer = sp;
 $3 = sp + 32|0;
 $4 = sp + 8|0;
 $5 = (_sqlite3_context_db_handle($0)|0); //@line 107755 "c/sqlite3.c"
 $6 = ($1|0)>(0); //@line 107757 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return; //@line 107768 "c/sqlite3.c"
 }
 $7 = HEAP32[$2>>2]|0; //@line 107757 "c/sqlite3.c"
 $8 = (_sqlite3_value_text($7)|0); //@line 107757 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 107757 "c/sqlite3.c"
 if ($9) {
  STACKTOP = sp;return; //@line 107768 "c/sqlite3.c"
 }
 $10 = (($1) + -1)|0; //@line 107758 "c/sqlite3.c"
 HEAP32[$3>>2] = $10; //@line 107758 "c/sqlite3.c"
 $11 = ((($3)) + 4|0); //@line 107759 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 107759 "c/sqlite3.c"
 $12 = ((($2)) + 4|0); //@line 107760 "c/sqlite3.c"
 $13 = ((($3)) + 8|0); //@line 107760 "c/sqlite3.c"
 HEAP32[$13>>2] = $12; //@line 107760 "c/sqlite3.c"
 $14 = ((($5)) + 100|0); //@line 107761 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 107761 "c/sqlite3.c"
 _sqlite3StrAccumInit($4,$5,0,0,$15); //@line 107761 "c/sqlite3.c"
 $16 = ((($4)) + 21|0); //@line 107762 "c/sqlite3.c"
 HEAP8[$16>>0] = 2; //@line 107762 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $3; //@line 107763 "c/sqlite3.c"
 _sqlite3XPrintf($4,$8,$vararg_buffer); //@line 107763 "c/sqlite3.c"
 $17 = ((($4)) + 16|0); //@line 107764 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 107764 "c/sqlite3.c"
 $19 = (_sqlite3StrAccumFinish($4)|0); //@line 107765 "c/sqlite3.c"
 _sqlite3_result_text($0,$19,$18,157); //@line 107765 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 107768 "c/sqlite3.c"
}
function _unicodeFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = HEAP32[$2>>2]|0; //@line 108594 "c/sqlite3.c"
 $5 = (_sqlite3_value_text($4)|0); //@line 108594 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 108594 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 108596 "c/sqlite3.c"
 if (!($6)) {
  $7 = HEAP8[$5>>0]|0; //@line 108596 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(0); //@line 108596 "c/sqlite3.c"
  if (!($8)) {
   $9 = (_sqlite3Utf8Read($3)|0); //@line 108596 "c/sqlite3.c"
   _sqlite3_result_int($0,$9); //@line 108596 "c/sqlite3.c"
  }
 }
 STACKTOP = sp;return; //@line 108597 "c/sqlite3.c"
}
function _charFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$04445 = 0, $$046 = 0, $$046$sink = 0, $$046$sink55 = 0, $$sink47 = 0, $$sink48 = 0, $$sink48$ph = 0, $$sink48$ph$ph = 0, $$sink49 = 0, $$sink50 = 0, $$sink50$ph = 0, $$sink52 = 0, $$sink54 = 0, $$sink56 = 0, $$sink58 = 0, $$sink60 = 0, $10 = 0, $11 = 0, $12 = 0;
 var $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $1 << 2; //@line 108611 "c/sqlite3.c"
 $4 = $3 | 1; //@line 108611 "c/sqlite3.c"
 $5 = ($4|0)<(0); //@line 108611 "c/sqlite3.c"
 $6 = $5 << 31 >> 31; //@line 108611 "c/sqlite3.c"
 $7 = (_sqlite3_malloc64($4,$6)|0); //@line 108611 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 108612 "c/sqlite3.c"
 if ($8) {
  _sqlite3_result_error_nomem($0); //@line 108613 "c/sqlite3.c"
  return; //@line 108639 "c/sqlite3.c"
 }
 $9 = ($1|0)>(0); //@line 108616 "c/sqlite3.c"
 if ($9) {
  $$04445 = 0;$$046 = $7;
  while(1) {
   $10 = (($2) + ($$04445<<2)|0); //@line 108619 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 108619 "c/sqlite3.c"
   $12 = (_sqlite3_value_int64($11)|0); //@line 108619 "c/sqlite3.c"
   $13 = tempRet0; //@line 108619 "c/sqlite3.c"
   $14 = ($13>>>0)>(0); //@line 108620 "c/sqlite3.c"
   $15 = ($12>>>0)>(1114111); //@line 108620 "c/sqlite3.c"
   $16 = ($13|0)==(0); //@line 108620 "c/sqlite3.c"
   $17 = $16 & $15; //@line 108620 "c/sqlite3.c"
   $18 = $14 | $17; //@line 108620 "c/sqlite3.c"
   $19 = $12 & 2097151; //@line 108621 "c/sqlite3.c"
   $20 = $18 ? 65533 : $19; //@line 108621 "c/sqlite3.c"
   $21 = ($20>>>0)<(128); //@line 108622 "c/sqlite3.c"
   if ($21) {
    $$sink47 = $$046;$$sink48 = 1;$$sink49 = $20;
   } else {
    $22 = ($20>>>0)<(2048); //@line 108624 "c/sqlite3.c"
    if ($22) {
     $$046$sink = $$046;$$sink48$ph = 2;$$sink50 = 1;$$sink52 = 192;$$sink54 = 31;
    } else {
     $23 = ($20>>>0)<(65536); //@line 108627 "c/sqlite3.c"
     if ($23) {
      $$046$sink55 = $$046;$$sink48$ph$ph = 3;$$sink50$ph = 2;$$sink56 = 1;$$sink58 = 224;$$sink60 = 15;
     } else {
      $24 = $20 >>> 18; //@line 108632 "c/sqlite3.c"
      $25 = $24 | 240; //@line 108632 "c/sqlite3.c"
      $26 = $25&255; //@line 108632 "c/sqlite3.c"
      $27 = ((($$046)) + 1|0); //@line 108632 "c/sqlite3.c"
      HEAP8[$$046>>0] = $26; //@line 108632 "c/sqlite3.c"
      $$046$sink55 = $27;$$sink48$ph$ph = 4;$$sink50$ph = 3;$$sink56 = 2;$$sink58 = 128;$$sink60 = 63;
     }
     $28 = $20 >>> 12;
     $29 = $28 & $$sink60;
     $30 = $29 | $$sink58;
     $31 = $30&255;
     $32 = (($$046) + ($$sink56)|0);
     HEAP8[$$046$sink55>>0] = $31;
     $$046$sink = $32;$$sink48$ph = $$sink48$ph$ph;$$sink50 = $$sink50$ph;$$sink52 = 128;$$sink54 = 63;
    }
    $33 = $20 >>> 6;
    $34 = $33 & $$sink54;
    $35 = $34 | $$sink52;
    $36 = $35&255;
    $37 = (($$046) + ($$sink50)|0);
    HEAP8[$$046$sink>>0] = $36;
    $38 = $20 & 63;
    $39 = $38 | 128;
    $$sink47 = $37;$$sink48 = $$sink48$ph;$$sink49 = $39;
   }
   $40 = $$sink49&255;
   $41 = (($$046) + ($$sink48)|0);
   HEAP8[$$sink47>>0] = $40;
   $42 = (($$04445) + 1)|0; //@line 108616 "c/sqlite3.c"
   $exitcond = ($42|0)==($1|0); //@line 108616 "c/sqlite3.c"
   if ($exitcond) {
    $$0$lcssa = $41;
    break;
   } else {
    $$04445 = $42;$$046 = $41;
   }
  }
 } else {
  $$0$lcssa = $7;
 }
 $43 = $$0$lcssa; //@line 108638 "c/sqlite3.c"
 $44 = $7; //@line 108638 "c/sqlite3.c"
 $45 = (($43) - ($44))|0; //@line 108638 "c/sqlite3.c"
 $46 = ($45|0)<(0); //@line 108638 "c/sqlite3.c"
 $47 = $46 << 31 >> 31; //@line 108638 "c/sqlite3.c"
 _sqlite3_result_text64($0,$7,$45,$47,83,1); //@line 108638 "c/sqlite3.c"
 return; //@line 108639 "c/sqlite3.c"
}
function _absFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0.0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0.0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 107655 "c/sqlite3.c"
 $4 = (_sqlite3_value_type($3)|0); //@line 107655 "c/sqlite3.c"
 switch ($4|0) {
 case 1:  {
  $5 = (_sqlite3_value_int64($3)|0); //@line 107657 "c/sqlite3.c"
  $6 = tempRet0; //@line 107657 "c/sqlite3.c"
  $7 = ($6|0)<(0); //@line 107658 "c/sqlite3.c"
  do {
   if ($7) {
    $8 = ($5|0)==(0); //@line 107659 "c/sqlite3.c"
    $9 = ($6|0)==(-2147483648); //@line 107659 "c/sqlite3.c"
    $10 = $8 & $9; //@line 107659 "c/sqlite3.c"
    if (!($10)) {
     $11 = (_i64Subtract(0,0,($5|0),($6|0))|0); //@line 107666 "c/sqlite3.c"
     $12 = tempRet0; //@line 107666 "c/sqlite3.c"
     $13 = $11;$14 = $12;
     break;
    }
    _sqlite3_result_error($0,17218,-1); //@line 107663 "c/sqlite3.c"
    return; //@line 107688 "c/sqlite3.c"
   } else {
    $13 = $5;$14 = $6;
   }
  } while(0);
  _sqlite3_result_int64($0,$13,$14); //@line 107668 "c/sqlite3.c"
  return; //@line 107688 "c/sqlite3.c"
  break;
 }
 case 5:  {
  _sqlite3_result_null($0); //@line 107673 "c/sqlite3.c"
  return; //@line 107688 "c/sqlite3.c"
  break;
 }
 default: {
  $15 = (+_sqlite3_value_double($3)); //@line 107682 "c/sqlite3.c"
  $16 = $15 < 0.0; //@line 107683 "c/sqlite3.c"
  $17 = - $15; //@line 107683 "c/sqlite3.c"
  $$0 = $16 ? $17 : $15; //@line 107683 "c/sqlite3.c"
  _sqlite3_result_double($0,$$0); //@line 107684 "c/sqlite3.c"
  return; //@line 107688 "c/sqlite3.c"
 }
 }
}
function _roundFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0, $28 = 0.0;
 var $29 = 0.0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond24 = 0, $or$cond3 = 0, $or$cond5 = 0, $spec$store$select = 0, $spec$store$select6 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp + 8|0;
 $3 = sp;
 $4 = ($1|0)==(2); //@line 107882 "c/sqlite3.c"
 do {
  if ($4) {
   $5 = ((($2)) + 4|0); //@line 107883 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 107883 "c/sqlite3.c"
   $7 = (_sqlite3_value_type($6)|0); //@line 107883 "c/sqlite3.c"
   $8 = ($7|0)==(5); //@line 107883 "c/sqlite3.c"
   if ($8) {
    STACKTOP = sp;return; //@line 107908 "c/sqlite3.c"
   } else {
    $9 = (_sqlite3_value_int($6)|0); //@line 107884 "c/sqlite3.c"
    $10 = ($9|0)<(30); //@line 107885 "c/sqlite3.c"
    $spec$store$select = $10 ? $9 : 30; //@line 107885 "c/sqlite3.c"
    $11 = ($spec$store$select|0)>(0); //@line 107886 "c/sqlite3.c"
    $spec$store$select6 = $11 ? $spec$store$select : 0; //@line 107886 "c/sqlite3.c"
    $$0 = $spec$store$select6;
    break;
   }
  } else {
   $$0 = 0;
  }
 } while(0);
 $12 = HEAP32[$2>>2]|0; //@line 107888 "c/sqlite3.c"
 $13 = (_sqlite3_value_type($12)|0); //@line 107888 "c/sqlite3.c"
 $14 = ($13|0)==(5); //@line 107888 "c/sqlite3.c"
 if ($14) {
  STACKTOP = sp;return; //@line 107908 "c/sqlite3.c"
 }
 $15 = (+_sqlite3_value_double($12)); //@line 107889 "c/sqlite3.c"
 HEAPF64[$3>>3] = $15; //@line 107889 "c/sqlite3.c"
 $16 = ($$0|0)==(0); //@line 107894 "c/sqlite3.c"
 $17 = $15 >= 0.0; //@line 107894 "c/sqlite3.c"
 $or$cond = $16 & $17; //@line 107894 "c/sqlite3.c"
 $18 = $15 < 9.2233720368547758E+18; //@line 107894 "c/sqlite3.c"
 $or$cond3 = $18 & $or$cond; //@line 107894 "c/sqlite3.c"
 do {
  if ($or$cond3) {
   $19 = $15 + 0.5; //@line 107895 "c/sqlite3.c"
   $20 = (~~$19)>>>0; //@line 107895 "c/sqlite3.c"
   $21 = +Math_abs($19) >= 1.0 ? $19 > 0.0 ? (~~+Math_min(+Math_floor($19 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($19 - +(~~$19 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 107895 "c/sqlite3.c"
   $22 = (+($20>>>0)) + (4294967296.0*(+($21|0))); //@line 107895 "c/sqlite3.c"
   HEAPF64[$3>>3] = $22; //@line 107895 "c/sqlite3.c"
  } else {
   $23 = $15 < 0.0; //@line 107896 "c/sqlite3.c"
   $or$cond5 = $16 & $23; //@line 107896 "c/sqlite3.c"
   $24 = $15 > -9.2233720368547758E+18; //@line 107896 "c/sqlite3.c"
   $or$cond24 = $24 & $or$cond5; //@line 107896 "c/sqlite3.c"
   if ($or$cond24) {
    $25 = 0.5 - $15; //@line 107897 "c/sqlite3.c"
    $26 = (~~$25)>>>0; //@line 107897 "c/sqlite3.c"
    $27 = +Math_abs($25) >= 1.0 ? $25 > 0.0 ? (~~+Math_min(+Math_floor($25 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($25 - +(~~$25 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 107897 "c/sqlite3.c"
    $28 = (+($26>>>0)) + (4294967296.0*(+($27|0))); //@line 107897 "c/sqlite3.c"
    $29 = - $28; //@line 107897 "c/sqlite3.c"
    HEAPF64[$3>>3] = $29; //@line 107897 "c/sqlite3.c"
    break;
   }
   HEAP32[$vararg_buffer>>2] = $$0; //@line 107899 "c/sqlite3.c"
   $vararg_ptr1 = ((($vararg_buffer)) + 8|0); //@line 107899 "c/sqlite3.c"
   HEAPF64[$vararg_ptr1>>3] = $15; //@line 107899 "c/sqlite3.c"
   $30 = (_sqlite3_mprintf(17793,$vararg_buffer)|0); //@line 107899 "c/sqlite3.c"
   $31 = ($30|0)==(0|0); //@line 107900 "c/sqlite3.c"
   if (!($31)) {
    $32 = (_sqlite3Strlen30($30)|0); //@line 107904 "c/sqlite3.c"
    (_sqlite3AtoF($30,$3,$32,1)|0); //@line 107904 "c/sqlite3.c"
    _sqlite3_free($30); //@line 107905 "c/sqlite3.c"
    break;
   }
   _sqlite3_result_error_nomem($0); //@line 107901 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 107908 "c/sqlite3.c"
  }
 } while(0);
 $33 = +HEAPF64[$3>>3]; //@line 107907 "c/sqlite3.c"
 _sqlite3_result_double($0,$33); //@line 107907 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 107908 "c/sqlite3.c"
}
function _upperFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$025 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 107944 "c/sqlite3.c"
 $4 = (_sqlite3_value_text($3)|0); //@line 107944 "c/sqlite3.c"
 $5 = HEAP32[$2>>2]|0; //@line 107945 "c/sqlite3.c"
 $6 = (_sqlite3_value_bytes($5)|0); //@line 107945 "c/sqlite3.c"
 $7 = ($4|0)==(0|0); //@line 107948 "c/sqlite3.c"
 if ($7) {
  return; //@line 107957 "c/sqlite3.c"
 }
 $8 = ($6|0)<(0); //@line 107949 "c/sqlite3.c"
 $9 = $8 << 31 >> 31; //@line 107949 "c/sqlite3.c"
 $10 = (_i64Add(($6|0),($9|0),1,0)|0); //@line 107949 "c/sqlite3.c"
 $11 = tempRet0; //@line 107949 "c/sqlite3.c"
 $12 = (_contextMalloc($0,$10,$11)|0); //@line 107949 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 107950 "c/sqlite3.c"
 if ($13) {
  return; //@line 107957 "c/sqlite3.c"
 }
 $14 = ($6|0)>(0); //@line 107951 "c/sqlite3.c"
 if ($14) {
  $$025 = 0;
  while(1) {
   $15 = (($4) + ($$025)|0); //@line 107952 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 107952 "c/sqlite3.c"
   $17 = $16&255; //@line 107952 "c/sqlite3.c"
   $18 = (16281 + ($17)|0); //@line 107952 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 107952 "c/sqlite3.c"
   $20 = $19 & 32; //@line 107952 "c/sqlite3.c"
   $21 = $20 ^ -1; //@line 107952 "c/sqlite3.c"
   $22 = $16 & $21; //@line 107952 "c/sqlite3.c"
   $23 = (($12) + ($$025)|0); //@line 107952 "c/sqlite3.c"
   HEAP8[$23>>0] = $22; //@line 107952 "c/sqlite3.c"
   $24 = (($$025) + 1)|0; //@line 107951 "c/sqlite3.c"
   $exitcond = ($24|0)==($6|0); //@line 107951 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$025 = $24;
   }
  }
 }
 _sqlite3_result_text($0,$12,$6,83); //@line 107954 "c/sqlite3.c"
 return; //@line 107957 "c/sqlite3.c"
}
function _lowerFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$023 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 107963 "c/sqlite3.c"
 $4 = (_sqlite3_value_text($3)|0); //@line 107963 "c/sqlite3.c"
 $5 = HEAP32[$2>>2]|0; //@line 107964 "c/sqlite3.c"
 $6 = (_sqlite3_value_bytes($5)|0); //@line 107964 "c/sqlite3.c"
 $7 = ($4|0)==(0|0); //@line 107967 "c/sqlite3.c"
 if ($7) {
  return; //@line 107976 "c/sqlite3.c"
 }
 $8 = ($6|0)<(0); //@line 107968 "c/sqlite3.c"
 $9 = $8 << 31 >> 31; //@line 107968 "c/sqlite3.c"
 $10 = (_i64Add(($6|0),($9|0),1,0)|0); //@line 107968 "c/sqlite3.c"
 $11 = tempRet0; //@line 107968 "c/sqlite3.c"
 $12 = (_contextMalloc($0,$10,$11)|0); //@line 107968 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 107969 "c/sqlite3.c"
 if ($13) {
  return; //@line 107976 "c/sqlite3.c"
 }
 $14 = ($6|0)>(0); //@line 107970 "c/sqlite3.c"
 if ($14) {
  $$023 = 0;
  while(1) {
   $15 = (($4) + ($$023)|0); //@line 107971 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 107971 "c/sqlite3.c"
   $17 = $16&255; //@line 107971 "c/sqlite3.c"
   $18 = (16025 + ($17)|0); //@line 107971 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 107971 "c/sqlite3.c"
   $20 = (($12) + ($$023)|0); //@line 107971 "c/sqlite3.c"
   HEAP8[$20>>0] = $19; //@line 107971 "c/sqlite3.c"
   $21 = (($$023) + 1)|0; //@line 107970 "c/sqlite3.c"
   $exitcond = ($21|0)==($6|0); //@line 107970 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$023 = $21;
   }
  }
 }
 _sqlite3_result_text($0,$12,$6,83); //@line 107973 "c/sqlite3.c"
 return; //@line 107976 "c/sqlite3.c"
}
function _hexFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$027$lcssa = 0, $$02730 = 0, $$02829 = 0, $$031 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $scevgep = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108655 "c/sqlite3.c"
 $4 = (_sqlite3_value_blob($3)|0); //@line 108655 "c/sqlite3.c"
 $5 = HEAP32[$2>>2]|0; //@line 108656 "c/sqlite3.c"
 $6 = (_sqlite3_value_bytes($5)|0); //@line 108656 "c/sqlite3.c"
 $7 = ($6|0)<(0); //@line 108658 "c/sqlite3.c"
 $8 = $7 << 31 >> 31; //@line 108658 "c/sqlite3.c"
 $9 = (_bitshift64Shl(($6|0),($8|0),1)|0); //@line 108658 "c/sqlite3.c"
 $10 = tempRet0; //@line 108658 "c/sqlite3.c"
 $11 = $9 | 1; //@line 108658 "c/sqlite3.c"
 $12 = (_contextMalloc($0,$11,$10)|0); //@line 108658 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 108659 "c/sqlite3.c"
 if ($13) {
  return; //@line 108668 "c/sqlite3.c"
 }
 $14 = ($6|0)>(0); //@line 108660 "c/sqlite3.c"
 if ($14) {
  $15 = $6 << 1; //@line 108660 "c/sqlite3.c"
  $$02730 = $12;$$02829 = $4;$$031 = 0;
  while(1) {
   $16 = HEAP8[$$02829>>0]|0; //@line 108661 "c/sqlite3.c"
   $17 = $16&255; //@line 108662 "c/sqlite3.c"
   $18 = $17 >>> 4; //@line 108662 "c/sqlite3.c"
   $19 = (17777 + ($18)|0); //@line 108662 "c/sqlite3.c"
   $20 = HEAP8[$19>>0]|0; //@line 108662 "c/sqlite3.c"
   $21 = ((($$02730)) + 1|0); //@line 108662 "c/sqlite3.c"
   HEAP8[$$02730>>0] = $20; //@line 108662 "c/sqlite3.c"
   $22 = $17 & 15; //@line 108663 "c/sqlite3.c"
   $23 = (17777 + ($22)|0); //@line 108663 "c/sqlite3.c"
   $24 = HEAP8[$23>>0]|0; //@line 108663 "c/sqlite3.c"
   $25 = ((($$02730)) + 2|0); //@line 108663 "c/sqlite3.c"
   HEAP8[$21>>0] = $24; //@line 108663 "c/sqlite3.c"
   $26 = (($$031) + 1)|0; //@line 108660 "c/sqlite3.c"
   $27 = ((($$02829)) + 1|0); //@line 108660 "c/sqlite3.c"
   $exitcond = ($26|0)==($6|0); //@line 108660 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$02730 = $25;$$02829 = $27;$$031 = $26;
   }
  }
  $scevgep = (($12) + ($15)|0); //@line 108660 "c/sqlite3.c"
  $$027$lcssa = $scevgep;
 } else {
  $$027$lcssa = $12;
 }
 HEAP8[$$027$lcssa>>0] = 0; //@line 108665 "c/sqlite3.c"
 $28 = $6 << 1; //@line 108666 "c/sqlite3.c"
 _sqlite3_result_text($0,$12,$28,83); //@line 108666 "c/sqlite3.c"
 return; //@line 108668 "c/sqlite3.c"
}
function _randomFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 _sqlite3_randomness(8,$3); //@line 107998 "c/sqlite3.c"
 $4 = $3; //@line 107999 "c/sqlite3.c"
 $5 = $4; //@line 107999 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 107999 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 107999 "c/sqlite3.c"
 $8 = $7; //@line 107999 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 107999 "c/sqlite3.c"
 $10 = ($9|0)<(0); //@line 107999 "c/sqlite3.c"
 if ($10) {
  $11 = $9 & 2147483647; //@line 108008 "c/sqlite3.c"
  $12 = (_i64Subtract(0,0,($6|0),($11|0))|0); //@line 108008 "c/sqlite3.c"
  $13 = tempRet0; //@line 108008 "c/sqlite3.c"
  $14 = $3; //@line 108008 "c/sqlite3.c"
  $15 = $14; //@line 108008 "c/sqlite3.c"
  HEAP32[$15>>2] = $12; //@line 108008 "c/sqlite3.c"
  $16 = (($14) + 4)|0; //@line 108008 "c/sqlite3.c"
  $17 = $16; //@line 108008 "c/sqlite3.c"
  HEAP32[$17>>2] = $13; //@line 108008 "c/sqlite3.c"
 }
 $18 = $3; //@line 108010 "c/sqlite3.c"
 $19 = $18; //@line 108010 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 108010 "c/sqlite3.c"
 $21 = (($18) + 4)|0; //@line 108010 "c/sqlite3.c"
 $22 = $21; //@line 108010 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 108010 "c/sqlite3.c"
 _sqlite3_result_int64($0,$20,$23); //@line 108010 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 108011 "c/sqlite3.c"
}
function _randomBlob($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108026 "c/sqlite3.c"
 $4 = (_sqlite3_value_int($3)|0); //@line 108026 "c/sqlite3.c"
 $5 = ($4|0)>(1); //@line 108027 "c/sqlite3.c"
 $spec$store$select = $5 ? $4 : 1; //@line 108027 "c/sqlite3.c"
 $6 = (_contextMalloc($0,$spec$store$select,0)|0); //@line 108030 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 108031 "c/sqlite3.c"
 if ($7) {
  return; //@line 108035 "c/sqlite3.c"
 }
 _sqlite3_randomness($spec$store$select,$6); //@line 108032 "c/sqlite3.c"
 _sqlite3_result_blob($0,$6,$spec$store$select,83); //@line 108033 "c/sqlite3.c"
 return; //@line 108035 "c/sqlite3.c"
}
function _nullifFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3GetFuncCollSeq($0)|0); //@line 108400 "c/sqlite3.c"
 $4 = HEAP32[$2>>2]|0; //@line 108402 "c/sqlite3.c"
 $5 = ((($2)) + 4|0); //@line 108402 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 108402 "c/sqlite3.c"
 $7 = (_sqlite3MemCompare($4,$6,$3)|0); //@line 108402 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 108402 "c/sqlite3.c"
 if ($8) {
  return; //@line 108405 "c/sqlite3.c"
 }
 $9 = HEAP32[$2>>2]|0; //@line 108403 "c/sqlite3.c"
 _sqlite3_result_value($0,$9); //@line 108403 "c/sqlite3.c"
 return; //@line 108405 "c/sqlite3.c"
}
function _sourceidFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3_result_text($0,15116,-1,0); //@line 108435 "c/sqlite3.c"
 return; //@line 108436 "c/sqlite3.c"
}
function _errlogFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 108444 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 108450 "c/sqlite3.c"
 $4 = (_sqlite3_value_int($3)|0); //@line 108450 "c/sqlite3.c"
 $5 = ((($2)) + 4|0); //@line 108450 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 108450 "c/sqlite3.c"
 $7 = (_sqlite3_value_text($6)|0); //@line 108450 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $7; //@line 108450 "c/sqlite3.c"
 _sqlite3_log($4,15687,$vararg_buffer); //@line 108450 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 108451 "c/sqlite3.c"
}
function _quoteFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$08592 = 0, $$087 = 0, $$090 = 0, $$186 = 0, $$18891 = 0, $$lcssa = 0, $$lcssa89 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0.0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $8 = 0.0, $9 = 0, $addconv = 0, $exitcond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $vararg_buffer1 = sp + 16|0;
 $vararg_buffer = sp + 8|0;
 $3 = sp;
 $4 = sp + 24|0;
 $5 = HEAP32[$2>>2]|0; //@line 108516 "c/sqlite3.c"
 $6 = (_sqlite3_value_type($5)|0); //@line 108516 "c/sqlite3.c"
 switch ($6|0) {
 case 2:  {
  $7 = (+_sqlite3_value_double($5)); //@line 108520 "c/sqlite3.c"
  HEAPF64[$vararg_buffer>>3] = $7; //@line 108521 "c/sqlite3.c"
  (_sqlite3_snprintf(50,$4,17154,$vararg_buffer)|0); //@line 108521 "c/sqlite3.c"
  (_sqlite3AtoF($4,$3,20,1)|0); //@line 108522 "c/sqlite3.c"
  $8 = +HEAPF64[$3>>3]; //@line 108523 "c/sqlite3.c"
  $9 = $7 != $8; //@line 108523 "c/sqlite3.c"
  if ($9) {
   HEAPF64[$vararg_buffer1>>3] = $7; //@line 108524 "c/sqlite3.c"
   (_sqlite3_snprintf(50,$4,17770,$vararg_buffer1)|0); //@line 108524 "c/sqlite3.c"
  }
  _sqlite3_result_text($0,$4,-1,(-1)); //@line 108526 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  break;
 }
 case 1:  {
  _sqlite3_result_value($0,$5); //@line 108530 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  break;
 }
 case 4:  {
  $10 = (_sqlite3_value_blob($5)|0); //@line 108535 "c/sqlite3.c"
  $11 = HEAP32[$2>>2]|0; //@line 108536 "c/sqlite3.c"
  $12 = (_sqlite3_value_bytes($11)|0); //@line 108536 "c/sqlite3.c"
  $13 = ($12|0)<(0); //@line 108538 "c/sqlite3.c"
  $14 = $13 << 31 >> 31; //@line 108538 "c/sqlite3.c"
  $15 = (_bitshift64Shl(($12|0),($14|0),1)|0); //@line 108538 "c/sqlite3.c"
  $16 = tempRet0; //@line 108538 "c/sqlite3.c"
  $17 = (_i64Add(($15|0),($16|0),4,0)|0); //@line 108538 "c/sqlite3.c"
  $18 = tempRet0; //@line 108538 "c/sqlite3.c"
  $19 = (_contextMalloc($0,$17,$18)|0); //@line 108538 "c/sqlite3.c"
  $20 = ($19|0)==(0|0); //@line 108539 "c/sqlite3.c"
  if ($20) {
   STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  }
  $21 = ($12|0)>(0); //@line 108541 "c/sqlite3.c"
  if ($21) {
   $$090 = 0;
   while(1) {
    $22 = (($10) + ($$090)|0); //@line 108542 "c/sqlite3.c"
    $23 = HEAP8[$22>>0]|0; //@line 108542 "c/sqlite3.c"
    $24 = $23&255; //@line 108542 "c/sqlite3.c"
    $25 = $24 >>> 4; //@line 108542 "c/sqlite3.c"
    $26 = (17777 + ($25)|0); //@line 108542 "c/sqlite3.c"
    $27 = HEAP8[$26>>0]|0; //@line 108542 "c/sqlite3.c"
    $28 = $$090 << 1; //@line 108542 "c/sqlite3.c"
    $29 = (($28) + 2)|0; //@line 108542 "c/sqlite3.c"
    $30 = (($19) + ($29)|0); //@line 108542 "c/sqlite3.c"
    HEAP8[$30>>0] = $27; //@line 108542 "c/sqlite3.c"
    $31 = HEAP8[$22>>0]|0; //@line 108543 "c/sqlite3.c"
    $32 = $31 & 15; //@line 108543 "c/sqlite3.c"
    $33 = $32&255; //@line 108543 "c/sqlite3.c"
    $34 = (17777 + ($33)|0); //@line 108543 "c/sqlite3.c"
    $35 = HEAP8[$34>>0]|0; //@line 108543 "c/sqlite3.c"
    $36 = (($28) + 3)|0; //@line 108543 "c/sqlite3.c"
    $37 = (($19) + ($36)|0); //@line 108543 "c/sqlite3.c"
    HEAP8[$37>>0] = $35; //@line 108543 "c/sqlite3.c"
    $38 = (($$090) + 1)|0; //@line 108541 "c/sqlite3.c"
    $exitcond = ($38|0)==($12|0); //@line 108541 "c/sqlite3.c"
    if ($exitcond) {
     break;
    } else {
     $$090 = $38;
    }
   }
  }
  $39 = $12 << 1; //@line 108545 "c/sqlite3.c"
  $40 = (($39) + 2)|0; //@line 108545 "c/sqlite3.c"
  $41 = (($19) + ($40)|0); //@line 108545 "c/sqlite3.c"
  HEAP8[$41>>0] = 39; //@line 108545 "c/sqlite3.c"
  $42 = (($39) + 3)|0; //@line 108546 "c/sqlite3.c"
  $43 = (($19) + ($42)|0); //@line 108546 "c/sqlite3.c"
  HEAP8[$43>>0] = 0; //@line 108546 "c/sqlite3.c"
  HEAP8[$19>>0] = 88; //@line 108547 "c/sqlite3.c"
  $44 = ((($19)) + 1|0); //@line 108548 "c/sqlite3.c"
  HEAP8[$44>>0] = 39; //@line 108548 "c/sqlite3.c"
  _sqlite3_result_text($0,$19,-1,(-1)); //@line 108549 "c/sqlite3.c"
  _sqlite3_free($19); //@line 108550 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  break;
 }
 case 3:  {
  $45 = (_sqlite3_value_text($5)|0); //@line 108557 "c/sqlite3.c"
  $46 = ($45|0)==(0|0); //@line 108560 "c/sqlite3.c"
  if ($46) {
   STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  }
  $$087 = 0;$49 = 0;$50 = 0;
  L25: while(1) {
   $47 = (($45) + ($$087)|0); //@line 108561 "c/sqlite3.c"
   $48 = HEAP8[$47>>0]|0; //@line 108561 "c/sqlite3.c"
   switch ($48<<24>>24) {
   case 0:  {
    break L25;
    break;
   }
   case 39:  {
    $51 = (_i64Add(($49|0),($50|0),1,0)|0); //@line 108561 "c/sqlite3.c"
    $52 = tempRet0; //@line 108561 "c/sqlite3.c"
    $76 = $51;$77 = $52;
    break;
   }
   default: {
    $76 = $49;$77 = $50;
   }
   }
   $53 = (($$087) + 1)|0; //@line 108561 "c/sqlite3.c"
   $$087 = $53;$49 = $76;$50 = $77;
  }
  $addconv = (($$087) + 3)|0; //@line 108562 "c/sqlite3.c"
  $54 = (_i64Add(($49|0),($50|0),($addconv|0),0)|0); //@line 108562 "c/sqlite3.c"
  $55 = tempRet0; //@line 108562 "c/sqlite3.c"
  $56 = (_contextMalloc($0,$54,$55)|0); //@line 108562 "c/sqlite3.c"
  $57 = ($56|0)==(0|0); //@line 108563 "c/sqlite3.c"
  if ($57) {
   STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  }
  HEAP8[$56>>0] = 39; //@line 108564 "c/sqlite3.c"
  $58 = HEAP8[$45>>0]|0; //@line 108565 "c/sqlite3.c"
  $59 = ($58<<24>>24)==(0); //@line 108565 "c/sqlite3.c"
  $60 = ((($56)) + 1|0);
  if ($59) {
   $$lcssa = $60;$$lcssa89 = 2;
  } else {
   $$08592 = 1;$$18891 = 0;$61 = $58;$62 = $60;$64 = $45;$67 = 2;
   while(1) {
    HEAP8[$62>>0] = $61; //@line 108566 "c/sqlite3.c"
    $63 = HEAP8[$64>>0]|0; //@line 108567 "c/sqlite3.c"
    $65 = ($63<<24>>24)==(39); //@line 108567 "c/sqlite3.c"
    if ($65) {
     $66 = (($56) + ($67)|0); //@line 108568 "c/sqlite3.c"
     $68 = (($$08592) + 2)|0; //@line 108568 "c/sqlite3.c"
     HEAP8[$66>>0] = 39; //@line 108568 "c/sqlite3.c"
     $$186 = $68;
    } else {
     $$186 = $67;
    }
    $69 = (($$18891) + 1)|0; //@line 108565 "c/sqlite3.c"
    $70 = (($45) + ($69)|0); //@line 108565 "c/sqlite3.c"
    $71 = HEAP8[$70>>0]|0; //@line 108565 "c/sqlite3.c"
    $72 = ($71<<24>>24)==(0); //@line 108565 "c/sqlite3.c"
    $73 = (($$186) + 1)|0;
    $74 = (($56) + ($$186)|0);
    if ($72) {
     $$lcssa = $74;$$lcssa89 = $73;
     break;
    } else {
     $$08592 = $$186;$$18891 = $69;$61 = $71;$62 = $74;$64 = $70;$67 = $73;
    }
   }
  }
  HEAP8[$$lcssa>>0] = 39; //@line 108571 "c/sqlite3.c"
  $75 = (($56) + ($$lcssa89)|0); //@line 108572 "c/sqlite3.c"
  HEAP8[$75>>0] = 0; //@line 108572 "c/sqlite3.c"
  _sqlite3_result_text($0,$56,$$lcssa89,83); //@line 108573 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
  break;
 }
 default: {
  _sqlite3_result_text($0,15390,4,0); //@line 108579 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108583 "c/sqlite3.c"
 }
 }
}
function _last_insert_rowid($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_context_db_handle($0)|0); //@line 108046 "c/sqlite3.c"
 $4 = (_sqlite3_last_insert_rowid($3)|0); //@line 108051 "c/sqlite3.c"
 $5 = tempRet0; //@line 108051 "c/sqlite3.c"
 _sqlite3_result_int64($0,$4,$5); //@line 108051 "c/sqlite3.c"
 return; //@line 108052 "c/sqlite3.c"
}
function _changes($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_context_db_handle($0)|0); //@line 108066 "c/sqlite3.c"
 $4 = (_sqlite3_changes($3)|0); //@line 108068 "c/sqlite3.c"
 _sqlite3_result_int($0,$4); //@line 108068 "c/sqlite3.c"
 return; //@line 108069 "c/sqlite3.c"
}
function _total_changes($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_context_db_handle($0)|0); //@line 108080 "c/sqlite3.c"
 $4 = (_sqlite3_total_changes($3)|0); //@line 108084 "c/sqlite3.c"
 _sqlite3_result_int($0,$4); //@line 108084 "c/sqlite3.c"
 return; //@line 108085 "c/sqlite3.c"
}
function _replaceFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$0100$lcssa = 0, $$0100109 = 0, $$0112 = 0, $$097$lcssa = 0, $$097110 = 0, $$2 = 0, $$2102 = 0, $$299 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108714 "c/sqlite3.c"
 $4 = (_sqlite3_value_text($3)|0); //@line 108714 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 108715 "c/sqlite3.c"
 if ($5) {
  return; //@line 108774 "c/sqlite3.c"
 }
 $6 = HEAP32[$2>>2]|0; //@line 108716 "c/sqlite3.c"
 $7 = (_sqlite3_value_bytes($6)|0); //@line 108716 "c/sqlite3.c"
 $8 = ((($2)) + 4|0); //@line 108718 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 108718 "c/sqlite3.c"
 $10 = (_sqlite3_value_text($9)|0); //@line 108718 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 108719 "c/sqlite3.c"
 if ($11) {
  return; //@line 108774 "c/sqlite3.c"
 }
 $12 = HEAP8[$10>>0]|0; //@line 108724 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 108724 "c/sqlite3.c"
 if ($13) {
  $14 = HEAP32[$2>>2]|0; //@line 108726 "c/sqlite3.c"
  _sqlite3_result_value($0,$14); //@line 108726 "c/sqlite3.c"
  return; //@line 108774 "c/sqlite3.c"
 }
 $15 = HEAP32[$8>>2]|0; //@line 108729 "c/sqlite3.c"
 $16 = (_sqlite3_value_bytes($15)|0); //@line 108729 "c/sqlite3.c"
 $17 = ((($2)) + 8|0); //@line 108731 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 108731 "c/sqlite3.c"
 $19 = (_sqlite3_value_text($18)|0); //@line 108731 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 108732 "c/sqlite3.c"
 if ($20) {
  return; //@line 108774 "c/sqlite3.c"
 }
 $21 = HEAP32[$17>>2]|0; //@line 108733 "c/sqlite3.c"
 $22 = (_sqlite3_value_bytes($21)|0); //@line 108733 "c/sqlite3.c"
 $23 = (($7) + 1)|0; //@line 108735 "c/sqlite3.c"
 $24 = ($23|0)<(0); //@line 108735 "c/sqlite3.c"
 $25 = $24 << 31 >> 31; //@line 108735 "c/sqlite3.c"
 $26 = (_contextMalloc($0,$23,$25)|0); //@line 108737 "c/sqlite3.c"
 $27 = ($26|0)==(0|0); //@line 108738 "c/sqlite3.c"
 if ($27) {
  return; //@line 108774 "c/sqlite3.c"
 }
 $28 = (($7) - ($16))|0; //@line 108741 "c/sqlite3.c"
 $29 = ($28|0)<(0); //@line 108742 "c/sqlite3.c"
 L17: do {
  if ($29) {
   $$0$lcssa = $26;$$0100$lcssa = 0;$$097$lcssa = 0;
  } else {
   $30 = (($22) - ($16))|0;
   $31 = ($30|0)<(0);
   $32 = $31 << 31 >> 31;
   $33 = (($16) + -1)|0;
   $$0100109 = 0;$$0112 = $26;$$097110 = 0;$43 = $23;$44 = $25;
   while(1) {
    $34 = (($4) + ($$0100109)|0); //@line 108743 "c/sqlite3.c"
    $35 = HEAP8[$34>>0]|0; //@line 108743 "c/sqlite3.c"
    $36 = HEAP8[$10>>0]|0; //@line 108743 "c/sqlite3.c"
    $37 = ($35<<24>>24)==($36<<24>>24); //@line 108743 "c/sqlite3.c"
    if ($37) {
     $38 = (_memcmp($34,$10,$16)|0); //@line 108743 "c/sqlite3.c"
     $39 = ($38|0)==(0); //@line 108743 "c/sqlite3.c"
     if ($39) {
      $42 = (_sqlite3_context_db_handle($0)|0); //@line 108747 "c/sqlite3.c"
      $45 = (_i64Add(($43|0),($44|0),($30|0),($32|0))|0); //@line 108748 "c/sqlite3.c"
      $46 = tempRet0; //@line 108748 "c/sqlite3.c"
      $47 = (_i64Add(($45|0),($46|0),-1,-1)|0); //@line 108751 "c/sqlite3.c"
      $48 = tempRet0; //@line 108751 "c/sqlite3.c"
      $49 = ((($42)) + 100|0); //@line 108751 "c/sqlite3.c"
      $50 = HEAP32[$49>>2]|0; //@line 108751 "c/sqlite3.c"
      $51 = ($50|0)<(0); //@line 108751 "c/sqlite3.c"
      $52 = $51 << 31 >> 31; //@line 108751 "c/sqlite3.c"
      $53 = ($48|0)>($52|0); //@line 108751 "c/sqlite3.c"
      $54 = ($47>>>0)>($50>>>0); //@line 108751 "c/sqlite3.c"
      $55 = ($48|0)==($52|0); //@line 108751 "c/sqlite3.c"
      $56 = $55 & $54; //@line 108751 "c/sqlite3.c"
      $57 = $53 | $56; //@line 108751 "c/sqlite3.c"
      if ($57) {
       label = 13;
       break;
      }
      $58 = (_bitshift64Ashr(0,($45|0),32)|0); //@line 108757 "c/sqlite3.c"
      $59 = tempRet0; //@line 108757 "c/sqlite3.c"
      $60 = (_sqlite3_realloc64($$0112,$58,$59)|0); //@line 108757 "c/sqlite3.c"
      $61 = ($60|0)==(0|0); //@line 108758 "c/sqlite3.c"
      if ($61) {
       label = 15;
       break;
      }
      $62 = (($60) + ($$097110)|0); //@line 108763 "c/sqlite3.c"
      _memcpy(($62|0),($19|0),($22|0))|0; //@line 108763 "c/sqlite3.c"
      $63 = (($$097110) + ($22))|0; //@line 108764 "c/sqlite3.c"
      $64 = (($33) + ($$0100109))|0; //@line 108765 "c/sqlite3.c"
      $$2 = $60;$$2102 = $64;$$299 = $63;$72 = $45;$73 = $46;
     } else {
      label = 11;
     }
    } else {
     label = 11;
    }
    if ((label|0) == 11) {
     label = 0;
     $40 = (($$097110) + 1)|0; //@line 108744 "c/sqlite3.c"
     $41 = (($$0112) + ($$097110)|0); //@line 108744 "c/sqlite3.c"
     HEAP8[$41>>0] = $35; //@line 108744 "c/sqlite3.c"
     $$2 = $$0112;$$2102 = $$0100109;$$299 = $40;$72 = $43;$73 = $44;
    }
    $65 = (($$2102) + 1)|0; //@line 108742 "c/sqlite3.c"
    $66 = ($$2102|0)<($28|0); //@line 108742 "c/sqlite3.c"
    if ($66) {
     $$0100109 = $65;$$0112 = $$2;$$097110 = $$299;$43 = $72;$44 = $73;
    } else {
     $$0$lcssa = $$2;$$0100$lcssa = $65;$$097$lcssa = $$299;
     break L17;
    }
   }
   if ((label|0) == 13) {
    _sqlite3_result_error_toobig($0); //@line 108752 "c/sqlite3.c"
    _sqlite3_free($$0112); //@line 108753 "c/sqlite3.c"
    return; //@line 108774 "c/sqlite3.c"
   }
   else if ((label|0) == 15) {
    _sqlite3_result_error_nomem($0); //@line 108759 "c/sqlite3.c"
    _sqlite3_free($$0112); //@line 108760 "c/sqlite3.c"
    return; //@line 108774 "c/sqlite3.c"
   }
  }
 } while(0);
 $67 = (($$0$lcssa) + ($$097$lcssa)|0); //@line 108769 "c/sqlite3.c"
 $68 = (($4) + ($$0100$lcssa)|0); //@line 108769 "c/sqlite3.c"
 $69 = (($7) - ($$0100$lcssa))|0; //@line 108769 "c/sqlite3.c"
 _memcpy(($67|0),($68|0),($69|0))|0; //@line 108769 "c/sqlite3.c"
 $70 = (($$097$lcssa) + ($69))|0; //@line 108770 "c/sqlite3.c"
 $71 = (($$0$lcssa) + ($70)|0); //@line 108772 "c/sqlite3.c"
 HEAP8[$71>>0] = 0; //@line 108772 "c/sqlite3.c"
 _sqlite3_result_text($0,$$0$lcssa,$70,83); //@line 108773 "c/sqlite3.c"
 return; //@line 108774 "c/sqlite3.c"
}
function _zeroblobFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 108682 "c/sqlite3.c"
 $4 = (_sqlite3_value_int64($3)|0); //@line 108682 "c/sqlite3.c"
 $5 = tempRet0; //@line 108682 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 108683 "c/sqlite3.c"
 $7 = ($4>>>0)>(0); //@line 108683 "c/sqlite3.c"
 $8 = ($5|0)==(0); //@line 108683 "c/sqlite3.c"
 $9 = $8 & $7; //@line 108683 "c/sqlite3.c"
 $10 = $6 | $9; //@line 108683 "c/sqlite3.c"
 $11 = $10 ? $4 : 0; //@line 108683 "c/sqlite3.c"
 $12 = $10 ? $5 : 0; //@line 108683 "c/sqlite3.c"
 $13 = (_sqlite3_result_zeroblob64($0,$11,$12)|0); //@line 108684 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 108685 "c/sqlite3.c"
 if ($14) {
  return; //@line 108688 "c/sqlite3.c"
 }
 _sqlite3_result_error_code($0,$13); //@line 108686 "c/sqlite3.c"
 return; //@line 108688 "c/sqlite3.c"
}
function _substrFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$083 = 0, $$087116 = 0, $$089115 = 0, $$184$lcssa = 0, $$184108 = 0, $$188 = 0, $$190 = 0, $$285 = 0, $$291 = 0, $$386 = 0, $$392$lcssa = 0, $$392106 = 0, $$493 = 0, $$5 = 0, $$lcssa = 0, $$lobit = 0, $$pr = 0, $$pr122 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0;
 var $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0;
 var $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0;
 var $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($2)) + 4|0); //@line 107795 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 107795 "c/sqlite3.c"
 $5 = (_sqlite3_value_type($4)|0); //@line 107795 "c/sqlite3.c"
 $6 = ($5|0)==(5); //@line 107795 "c/sqlite3.c"
 if ($6) {
  return; //@line 107871 "c/sqlite3.c"
 }
 $7 = ($1|0)==(3); //@line 107796 "c/sqlite3.c"
 if ($7) {
  $8 = ((($2)) + 8|0); //@line 107796 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 107796 "c/sqlite3.c"
  $10 = (_sqlite3_value_type($9)|0); //@line 107796 "c/sqlite3.c"
  $11 = ($10|0)==(5); //@line 107796 "c/sqlite3.c"
  if ($11) {
   return; //@line 107871 "c/sqlite3.c"
  }
 }
 $12 = HEAP32[$2>>2]|0; //@line 107800 "c/sqlite3.c"
 $13 = (_sqlite3_value_type($12)|0); //@line 107800 "c/sqlite3.c"
 $14 = (_sqlite3_value_int($4)|0); //@line 107801 "c/sqlite3.c"
 $15 = ($14|0)<(0); //@line 107801 "c/sqlite3.c"
 $16 = $15 << 31 >> 31; //@line 107801 "c/sqlite3.c"
 $17 = ($13|0)==(4); //@line 107802 "c/sqlite3.c"
 $18 = HEAP32[$2>>2]|0;
 if ($17) {
  $19 = (_sqlite3_value_bytes($18)|0); //@line 107803 "c/sqlite3.c"
  $20 = HEAP32[$2>>2]|0; //@line 107804 "c/sqlite3.c"
  $21 = (_sqlite3_value_blob($20)|0); //@line 107804 "c/sqlite3.c"
  $22 = ($21|0)==(0|0); //@line 107805 "c/sqlite3.c"
  if ($22) {
   return; //@line 107871 "c/sqlite3.c"
  } else {
   $$083 = $21;$$188 = $19;
  }
 } else {
  $23 = (_sqlite3_value_text($18)|0); //@line 107808 "c/sqlite3.c"
  $24 = ($23|0)==(0|0); //@line 107809 "c/sqlite3.c"
  if ($24) {
   return; //@line 107871 "c/sqlite3.c"
  }
  $25 = ($14|0)<(0); //@line 107811 "c/sqlite3.c"
  if ($25) {
   $26 = HEAP8[$23>>0]|0; //@line 107812 "c/sqlite3.c"
   $27 = ($26<<24>>24)==(0); //@line 107812 "c/sqlite3.c"
   if ($27) {
    $$083 = $23;$$188 = 0;
   } else {
    $$087116 = 0;$$089115 = $23;$30 = $26;
    while(1) {
     $28 = ((($$089115)) + 1|0); //@line 107813 "c/sqlite3.c"
     $29 = ($30&255)>(191); //@line 107813 "c/sqlite3.c"
     if ($29) {
      $$190 = $28;
      while(1) {
       $31 = HEAP8[$$190>>0]|0; //@line 107813 "c/sqlite3.c"
       $32 = $31 & -64; //@line 107813 "c/sqlite3.c"
       $33 = ($32<<24>>24)==(-128); //@line 107813 "c/sqlite3.c"
       $34 = ((($$190)) + 1|0); //@line 107813 "c/sqlite3.c"
       if ($33) {
        $$190 = $34;
       } else {
        $$291 = $$190;$37 = $31;
        break;
       }
      }
     } else {
      $$pr122 = HEAP8[$28>>0]|0; //@line 107812 "c/sqlite3.c"
      $$291 = $28;$37 = $$pr122;
     }
     $35 = (($$087116) + 1)|0; //@line 107812 "c/sqlite3.c"
     $36 = ($37<<24>>24)==(0); //@line 107812 "c/sqlite3.c"
     if ($36) {
      $$083 = $23;$$188 = $35;
      break;
     } else {
      $$087116 = $35;$$089115 = $$291;$30 = $37;
     }
    }
   }
  } else {
   $$083 = $23;$$188 = 0;
  }
 }
 if ($7) {
  $38 = ((($2)) + 8|0); //@line 107826 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 107826 "c/sqlite3.c"
  $40 = (_sqlite3_value_int($39)|0); //@line 107826 "c/sqlite3.c"
  $41 = ($40|0)<(0); //@line 107826 "c/sqlite3.c"
  $42 = $41 << 31 >> 31; //@line 107826 "c/sqlite3.c"
  $43 = ($40|0)<(0); //@line 107827 "c/sqlite3.c"
  $44 = (_i64Subtract(0,0,($40|0),($42|0))|0); //@line 107828 "c/sqlite3.c"
  $45 = tempRet0; //@line 107828 "c/sqlite3.c"
  $46 = $43 ? $44 : $40; //@line 107827 "c/sqlite3.c"
  $47 = $43 ? $45 : $42; //@line 107827 "c/sqlite3.c"
  $$lobit = $40 >>> 31; //@line 107827 "c/sqlite3.c"
  $$0 = $$lobit;$59 = $46;$60 = $47;
 } else {
  $48 = (_sqlite3_context_db_handle($0)|0); //@line 107832 "c/sqlite3.c"
  $49 = ((($48)) + 100|0); //@line 107832 "c/sqlite3.c"
  $50 = HEAP32[$49>>2]|0; //@line 107832 "c/sqlite3.c"
  $51 = ($50|0)<(0); //@line 107832 "c/sqlite3.c"
  $52 = $51 << 31 >> 31; //@line 107832 "c/sqlite3.c"
  $$0 = 0;$59 = $50;$60 = $52;
 }
 $53 = ($14|0)<(0); //@line 107834 "c/sqlite3.c"
 do {
  if ($53) {
   $54 = ($$188|0)<(0); //@line 107835 "c/sqlite3.c"
   $55 = $54 << 31 >> 31; //@line 107835 "c/sqlite3.c"
   $56 = (_i64Add(($$188|0),($55|0),($14|0),($16|0))|0); //@line 107835 "c/sqlite3.c"
   $57 = tempRet0; //@line 107835 "c/sqlite3.c"
   $58 = ($57|0)<(0); //@line 107836 "c/sqlite3.c"
   $61 = (_i64Add(($59|0),($60|0),($56|0),($57|0))|0); //@line 107837 "c/sqlite3.c"
   $62 = tempRet0; //@line 107837 "c/sqlite3.c"
   $63 = ($62|0)>(0); //@line 107838 "c/sqlite3.c"
   $64 = ($61>>>0)>(0); //@line 107838 "c/sqlite3.c"
   $65 = ($62|0)==(0); //@line 107838 "c/sqlite3.c"
   $66 = $65 & $64; //@line 107838 "c/sqlite3.c"
   $67 = $63 | $66; //@line 107838 "c/sqlite3.c"
   $68 = $67 ? $61 : 0; //@line 107838 "c/sqlite3.c"
   $69 = $67 ? $62 : 0; //@line 107838 "c/sqlite3.c"
   $70 = $58 ? 0 : $56; //@line 107836 "c/sqlite3.c"
   $71 = $58 ? 0 : $57; //@line 107836 "c/sqlite3.c"
   $72 = $58 ? $68 : $59; //@line 107836 "c/sqlite3.c"
   $73 = $58 ? $69 : $60; //@line 107836 "c/sqlite3.c"
   $88 = $70;$89 = $71;$90 = $72;$91 = $73;
  } else {
   $74 = ($14|0)==(0); //@line 107841 "c/sqlite3.c"
   if ($74) {
    $77 = ($60|0)>(0); //@line 107843 "c/sqlite3.c"
    $78 = ($59>>>0)>(0); //@line 107843 "c/sqlite3.c"
    $79 = ($60|0)==(0); //@line 107843 "c/sqlite3.c"
    $80 = $79 & $78; //@line 107843 "c/sqlite3.c"
    $81 = $77 | $80; //@line 107843 "c/sqlite3.c"
    $82 = $81 << 31 >> 31; //@line 107843 "c/sqlite3.c"
    $83 = ($82|0)<(0); //@line 107843 "c/sqlite3.c"
    $84 = $83 << 31 >> 31; //@line 107843 "c/sqlite3.c"
    $85 = (_i64Add(($59|0),($60|0),($82|0),($84|0))|0); //@line 107843 "c/sqlite3.c"
    $86 = tempRet0; //@line 107843 "c/sqlite3.c"
    $88 = 0;$89 = 0;$90 = $85;$91 = $86;
    break;
   } else {
    $75 = (_i64Add(($14|0),($16|0),-1,-1)|0); //@line 107842 "c/sqlite3.c"
    $76 = tempRet0; //@line 107842 "c/sqlite3.c"
    $88 = $75;$89 = $76;$90 = $59;$91 = $60;
    break;
   }
  }
 } while(0);
 $87 = ($$0|0)==(0); //@line 107846 "c/sqlite3.c"
 $92 = (_i64Subtract(($88|0),($89|0),($90|0),($91|0))|0); //@line 107847 "c/sqlite3.c"
 $93 = tempRet0; //@line 107847 "c/sqlite3.c"
 $94 = ($93|0)<(0); //@line 107848 "c/sqlite3.c"
 $95 = $94 ? 0 : $92; //@line 107848 "c/sqlite3.c"
 $96 = $94 ? 0 : $93; //@line 107848 "c/sqlite3.c"
 $97 = $94 ? $88 : $90; //@line 107848 "c/sqlite3.c"
 $98 = $94 ? $89 : $91; //@line 107848 "c/sqlite3.c"
 $99 = $87 ? $88 : $95; //@line 107846 "c/sqlite3.c"
 $100 = $87 ? $89 : $96; //@line 107846 "c/sqlite3.c"
 $101 = $87 ? $90 : $97; //@line 107846 "c/sqlite3.c"
 $102 = $87 ? $91 : $98; //@line 107846 "c/sqlite3.c"
 if ($17) {
  $152 = (_i64Add(($99|0),($100|0),($101|0),($102|0))|0); //@line 107865 "c/sqlite3.c"
  $153 = tempRet0; //@line 107865 "c/sqlite3.c"
  $154 = ($$188|0)<(0); //@line 107865 "c/sqlite3.c"
  $155 = $154 << 31 >> 31; //@line 107865 "c/sqlite3.c"
  $156 = ($153|0)>($155|0); //@line 107865 "c/sqlite3.c"
  $157 = ($152>>>0)>($$188>>>0); //@line 107865 "c/sqlite3.c"
  $158 = ($153|0)==($155|0); //@line 107865 "c/sqlite3.c"
  $159 = $158 & $157; //@line 107865 "c/sqlite3.c"
  $160 = $156 | $159; //@line 107865 "c/sqlite3.c"
  $161 = (_i64Subtract(($$188|0),($155|0),($99|0),($100|0))|0); //@line 107866 "c/sqlite3.c"
  $162 = tempRet0; //@line 107866 "c/sqlite3.c"
  $163 = ($162|0)>(0); //@line 107867 "c/sqlite3.c"
  $164 = ($161>>>0)>(0); //@line 107867 "c/sqlite3.c"
  $165 = ($162|0)==(0); //@line 107867 "c/sqlite3.c"
  $166 = $165 & $164; //@line 107867 "c/sqlite3.c"
  $167 = $163 | $166; //@line 107867 "c/sqlite3.c"
  $168 = $167 ? $161 : 0; //@line 107867 "c/sqlite3.c"
  $169 = $167 ? $162 : 0; //@line 107867 "c/sqlite3.c"
  $170 = $160 ? $168 : $101; //@line 107865 "c/sqlite3.c"
  $171 = $160 ? $169 : $102; //@line 107865 "c/sqlite3.c"
  $172 = (($$083) + ($99)|0); //@line 107869 "c/sqlite3.c"
  _sqlite3_result_blob64($0,$172,$170,$171,(-1)); //@line 107869 "c/sqlite3.c"
  return; //@line 107871 "c/sqlite3.c"
 }
 $103 = HEAP8[$$083>>0]|0; //@line 107855 "c/sqlite3.c"
 $104 = ($103<<24>>24)!=(0); //@line 107855 "c/sqlite3.c"
 $105 = ($99|0)!=(0); //@line 107855 "c/sqlite3.c"
 $106 = ($100|0)!=(0); //@line 107855 "c/sqlite3.c"
 $107 = $105 | $106; //@line 107855 "c/sqlite3.c"
 $108 = $107 & $104; //@line 107855 "c/sqlite3.c"
 if ($108) {
  $$184108 = $$083;$111 = $103;$116 = $99;$117 = $100;
  while(1) {
   $109 = ((($$184108)) + 1|0); //@line 107856 "c/sqlite3.c"
   $110 = ($111&255)>(191); //@line 107856 "c/sqlite3.c"
   if ($110) {
    $$285 = $109;
    while(1) {
     $112 = HEAP8[$$285>>0]|0; //@line 107856 "c/sqlite3.c"
     $113 = $112 & -64; //@line 107856 "c/sqlite3.c"
     $114 = ($113<<24>>24)==(-128); //@line 107856 "c/sqlite3.c"
     $115 = ((($$285)) + 1|0); //@line 107856 "c/sqlite3.c"
     if ($114) {
      $$285 = $115;
     } else {
      $$386 = $$285;
      break;
     }
    }
   } else {
    $$386 = $109;
   }
   $118 = (_i64Add(($116|0),($117|0),-1,-1)|0); //@line 107857 "c/sqlite3.c"
   $119 = tempRet0; //@line 107857 "c/sqlite3.c"
   $120 = HEAP8[$$386>>0]|0; //@line 107855 "c/sqlite3.c"
   $121 = ($120<<24>>24)!=(0); //@line 107855 "c/sqlite3.c"
   $122 = ($118|0)!=(0); //@line 107855 "c/sqlite3.c"
   $123 = ($119|0)!=(0); //@line 107855 "c/sqlite3.c"
   $124 = $122 | $123; //@line 107855 "c/sqlite3.c"
   $125 = $124 & $121; //@line 107855 "c/sqlite3.c"
   if ($125) {
    $$184108 = $$386;$111 = $120;$116 = $118;$117 = $119;
   } else {
    $$184$lcssa = $$386;$$lcssa = $120;
    break;
   }
  }
 } else {
  $$184$lcssa = $$083;$$lcssa = $103;
 }
 $126 = ($$lcssa<<24>>24)!=(0); //@line 107859 "c/sqlite3.c"
 $127 = ($101|0)!=(0); //@line 107859 "c/sqlite3.c"
 $128 = ($102|0)!=(0); //@line 107859 "c/sqlite3.c"
 $129 = $127 | $128; //@line 107859 "c/sqlite3.c"
 $130 = $126 & $129; //@line 107859 "c/sqlite3.c"
 if ($130) {
  $$392106 = $$184$lcssa;$133 = $$lcssa;$138 = $101;$139 = $102;
  while(1) {
   $131 = ((($$392106)) + 1|0); //@line 107860 "c/sqlite3.c"
   $132 = ($133&255)>(191); //@line 107860 "c/sqlite3.c"
   if ($132) {
    $$493 = $131;
    while(1) {
     $134 = HEAP8[$$493>>0]|0; //@line 107860 "c/sqlite3.c"
     $135 = $134 & -64; //@line 107860 "c/sqlite3.c"
     $136 = ($135<<24>>24)==(-128); //@line 107860 "c/sqlite3.c"
     $137 = ((($$493)) + 1|0); //@line 107860 "c/sqlite3.c"
     if ($136) {
      $$493 = $137;
     } else {
      $$5 = $$493;
      break;
     }
    }
   } else {
    $$5 = $131;
   }
   $140 = (_i64Add(($138|0),($139|0),-1,-1)|0); //@line 107859 "c/sqlite3.c"
   $141 = tempRet0; //@line 107859 "c/sqlite3.c"
   $$pr = HEAP8[$$5>>0]|0; //@line 107859 "c/sqlite3.c"
   $142 = ($$pr<<24>>24)!=(0); //@line 107859 "c/sqlite3.c"
   $143 = ($140|0)!=(0); //@line 107859 "c/sqlite3.c"
   $144 = ($141|0)!=(0); //@line 107859 "c/sqlite3.c"
   $145 = $143 | $144; //@line 107859 "c/sqlite3.c"
   $146 = $142 & $145; //@line 107859 "c/sqlite3.c"
   if ($146) {
    $$392106 = $$5;$133 = $$pr;$138 = $140;$139 = $141;
   } else {
    $$392$lcssa = $$5;
    break;
   }
  }
 } else {
  $$392$lcssa = $$184$lcssa;
 }
 $147 = $$392$lcssa; //@line 107862 "c/sqlite3.c"
 $148 = $$184$lcssa; //@line 107862 "c/sqlite3.c"
 $149 = (($147) - ($148))|0; //@line 107862 "c/sqlite3.c"
 $150 = ($149|0)<(0); //@line 107862 "c/sqlite3.c"
 $151 = $150 << 31 >> 31; //@line 107862 "c/sqlite3.c"
 _sqlite3_result_text64($0,$$184$lcssa,$149,$151,(-1),1); //@line 107862 "c/sqlite3.c"
 return; //@line 107871 "c/sqlite3.c"
}
function _sumStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0.0, $27 = 0.0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_aggregate_context($0,32)|0); //@line 109000 "c/sqlite3.c"
 $4 = HEAP32[$2>>2]|0; //@line 109001 "c/sqlite3.c"
 $5 = (_sqlite3_value_numeric_type($4)|0); //@line 109001 "c/sqlite3.c"
 $6 = ($3|0)!=(0|0); //@line 109002 "c/sqlite3.c"
 $7 = ($5|0)!=(5); //@line 109002 "c/sqlite3.c"
 $or$cond = $6 & $7; //@line 109002 "c/sqlite3.c"
 if (!($or$cond)) {
  return; //@line 109015 "c/sqlite3.c"
 }
 $8 = ((($3)) + 16|0); //@line 109003 "c/sqlite3.c"
 $9 = $8; //@line 109003 "c/sqlite3.c"
 $10 = $9; //@line 109003 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 109003 "c/sqlite3.c"
 $12 = (($9) + 4)|0; //@line 109003 "c/sqlite3.c"
 $13 = $12; //@line 109003 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 109003 "c/sqlite3.c"
 $15 = (_i64Add(($11|0),($14|0),1,0)|0); //@line 109003 "c/sqlite3.c"
 $16 = tempRet0; //@line 109003 "c/sqlite3.c"
 $17 = $8; //@line 109003 "c/sqlite3.c"
 $18 = $17; //@line 109003 "c/sqlite3.c"
 HEAP32[$18>>2] = $15; //@line 109003 "c/sqlite3.c"
 $19 = (($17) + 4)|0; //@line 109003 "c/sqlite3.c"
 $20 = $19; //@line 109003 "c/sqlite3.c"
 HEAP32[$20>>2] = $16; //@line 109003 "c/sqlite3.c"
 $21 = ($5|0)==(1); //@line 109004 "c/sqlite3.c"
 $22 = HEAP32[$2>>2]|0;
 if (!($21)) {
  $37 = (+_sqlite3_value_double($22)); //@line 109011 "c/sqlite3.c"
  $38 = +HEAPF64[$3>>3]; //@line 109011 "c/sqlite3.c"
  $39 = $37 + $38; //@line 109011 "c/sqlite3.c"
  HEAPF64[$3>>3] = $39; //@line 109011 "c/sqlite3.c"
  $40 = ((($3)) + 25|0); //@line 109012 "c/sqlite3.c"
  HEAP8[$40>>0] = 1; //@line 109012 "c/sqlite3.c"
  return; //@line 109015 "c/sqlite3.c"
 }
 $23 = (_sqlite3_value_int64($22)|0); //@line 109005 "c/sqlite3.c"
 $24 = tempRet0; //@line 109005 "c/sqlite3.c"
 $25 = (+($23>>>0)) + (4294967296.0*(+($24|0))); //@line 109006 "c/sqlite3.c"
 $26 = +HEAPF64[$3>>3]; //@line 109006 "c/sqlite3.c"
 $27 = $26 + $25; //@line 109006 "c/sqlite3.c"
 HEAPF64[$3>>3] = $27; //@line 109006 "c/sqlite3.c"
 $28 = ((($3)) + 25|0); //@line 109007 "c/sqlite3.c"
 $29 = HEAP8[$28>>0]|0; //@line 109007 "c/sqlite3.c"
 $30 = ((($3)) + 24|0); //@line 109007 "c/sqlite3.c"
 $31 = HEAP8[$30>>0]|0; //@line 109007 "c/sqlite3.c"
 $32 = $31 | $29; //@line 109007 "c/sqlite3.c"
 $33 = ($32<<24>>24)==(0); //@line 109007 "c/sqlite3.c"
 if (!($33)) {
  return; //@line 109015 "c/sqlite3.c"
 }
 $34 = ((($3)) + 8|0); //@line 109007 "c/sqlite3.c"
 $35 = (_sqlite3AddInt64($34,$23,$24)|0); //@line 109007 "c/sqlite3.c"
 $36 = ($35|0)==(0); //@line 109007 "c/sqlite3.c"
 if ($36) {
  return; //@line 109015 "c/sqlite3.c"
 }
 HEAP8[$30>>0] = 1; //@line 109008 "c/sqlite3.c"
 return; //@line 109015 "c/sqlite3.c"
}
function _sumFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_aggregate_context($0,0)|0); //@line 109018 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 109019 "c/sqlite3.c"
 if ($2) {
  return; //@line 109028 "c/sqlite3.c"
 }
 $3 = ((($1)) + 16|0); //@line 109019 "c/sqlite3.c"
 $4 = $3; //@line 109019 "c/sqlite3.c"
 $5 = $4; //@line 109019 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 109019 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 109019 "c/sqlite3.c"
 $8 = $7; //@line 109019 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 109019 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 109019 "c/sqlite3.c"
 $11 = ($6>>>0)>(0); //@line 109019 "c/sqlite3.c"
 $12 = ($9|0)==(0); //@line 109019 "c/sqlite3.c"
 $13 = $12 & $11; //@line 109019 "c/sqlite3.c"
 $14 = $10 | $13; //@line 109019 "c/sqlite3.c"
 if (!($14)) {
  return; //@line 109028 "c/sqlite3.c"
 }
 $15 = ((($1)) + 24|0); //@line 109020 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 109020 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 109020 "c/sqlite3.c"
 if (!($17)) {
  _sqlite3_result_error($0,17218,-1); //@line 109021 "c/sqlite3.c"
  return; //@line 109028 "c/sqlite3.c"
 }
 $18 = ((($1)) + 25|0); //@line 109022 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 109022 "c/sqlite3.c"
 $20 = ($19<<24>>24)==(0); //@line 109022 "c/sqlite3.c"
 if ($20) {
  $22 = ((($1)) + 8|0); //@line 109025 "c/sqlite3.c"
  $23 = $22; //@line 109025 "c/sqlite3.c"
  $24 = $23; //@line 109025 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 109025 "c/sqlite3.c"
  $26 = (($23) + 4)|0; //@line 109025 "c/sqlite3.c"
  $27 = $26; //@line 109025 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 109025 "c/sqlite3.c"
  _sqlite3_result_int64($0,$25,$28); //@line 109025 "c/sqlite3.c"
  return; //@line 109028 "c/sqlite3.c"
 } else {
  $21 = +HEAPF64[$1>>3]; //@line 109023 "c/sqlite3.c"
  _sqlite3_result_double($0,$21); //@line 109023 "c/sqlite3.c"
  return; //@line 109028 "c/sqlite3.c"
 }
}
function _totalFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_aggregate_context($0,0)|0); //@line 109038 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 109040 "c/sqlite3.c"
 if ($2) {
  $4 = 0.0;
 } else {
  $3 = +HEAPF64[$1>>3]; //@line 109040 "c/sqlite3.c"
  $4 = $3;
 }
 _sqlite3_result_double($0,$4); //@line 109040 "c/sqlite3.c"
 return; //@line 109041 "c/sqlite3.c"
}
function _avgFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_aggregate_context($0,0)|0); //@line 109031 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 109032 "c/sqlite3.c"
 if ($2) {
  return; //@line 109035 "c/sqlite3.c"
 }
 $3 = ((($1)) + 16|0); //@line 109032 "c/sqlite3.c"
 $4 = $3; //@line 109032 "c/sqlite3.c"
 $5 = $4; //@line 109032 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 109032 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 109032 "c/sqlite3.c"
 $8 = $7; //@line 109032 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 109032 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 109032 "c/sqlite3.c"
 $11 = ($6>>>0)>(0); //@line 109032 "c/sqlite3.c"
 $12 = ($9|0)==(0); //@line 109032 "c/sqlite3.c"
 $13 = $12 & $11; //@line 109032 "c/sqlite3.c"
 $14 = $10 | $13; //@line 109032 "c/sqlite3.c"
 if (!($14)) {
  return; //@line 109035 "c/sqlite3.c"
 }
 $15 = (+($6>>>0)) + (4294967296.0*(+($9|0))); //@line 109033 "c/sqlite3.c"
 $16 = +HEAPF64[$1>>3]; //@line 109033 "c/sqlite3.c"
 $17 = $16 / $15; //@line 109033 "c/sqlite3.c"
 _sqlite3_result_double($0,$17); //@line 109033 "c/sqlite3.c"
 return; //@line 109035 "c/sqlite3.c"
}
function _countStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$old1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_aggregate_context($0,8)|0); //@line 109057 "c/sqlite3.c"
 $4 = ($1|0)==(0); //@line 109058 "c/sqlite3.c"
 if ($4) {
  $$old1 = ($3|0)==(0|0); //@line 109058 "c/sqlite3.c"
  if ($$old1) {
   return; //@line 109070 "c/sqlite3.c"
  }
 } else {
  $5 = HEAP32[$2>>2]|0; //@line 109058 "c/sqlite3.c"
  $6 = (_sqlite3_value_type($5)|0); //@line 109058 "c/sqlite3.c"
  $7 = ($6|0)!=(5); //@line 109058 "c/sqlite3.c"
  $8 = ($3|0)!=(0|0); //@line 109058 "c/sqlite3.c"
  $or$cond = $8 & $7; //@line 109058 "c/sqlite3.c"
  if (!($or$cond)) {
   return; //@line 109070 "c/sqlite3.c"
  }
 }
 $9 = $3; //@line 109059 "c/sqlite3.c"
 $10 = $9; //@line 109059 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 109059 "c/sqlite3.c"
 $12 = (($9) + 4)|0; //@line 109059 "c/sqlite3.c"
 $13 = $12; //@line 109059 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 109059 "c/sqlite3.c"
 $15 = (_i64Add(($11|0),($14|0),1,0)|0); //@line 109059 "c/sqlite3.c"
 $16 = tempRet0; //@line 109059 "c/sqlite3.c"
 $17 = $3; //@line 109059 "c/sqlite3.c"
 $18 = $17; //@line 109059 "c/sqlite3.c"
 HEAP32[$18>>2] = $15; //@line 109059 "c/sqlite3.c"
 $19 = (($17) + 4)|0; //@line 109059 "c/sqlite3.c"
 $20 = $19; //@line 109059 "c/sqlite3.c"
 HEAP32[$20>>2] = $16; //@line 109059 "c/sqlite3.c"
 return; //@line 109070 "c/sqlite3.c"
}
function _countFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_aggregate_context($0,0)|0); //@line 109073 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 109074 "c/sqlite3.c"
 if ($2) {
  $10 = 0;$9 = 0;
 } else {
  $3 = $1; //@line 109074 "c/sqlite3.c"
  $4 = $3; //@line 109074 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 109074 "c/sqlite3.c"
  $6 = (($3) + 4)|0; //@line 109074 "c/sqlite3.c"
  $7 = $6; //@line 109074 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 109074 "c/sqlite3.c"
  $10 = $8;$9 = $5;
 }
 _sqlite3_result_int64($0,$9,$10); //@line 109074 "c/sqlite3.c"
 return; //@line 109075 "c/sqlite3.c"
}
function _groupConcatStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03334 = 0, $$035 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 109142 "c/sqlite3.c"
 $4 = (_sqlite3_value_type($3)|0); //@line 109142 "c/sqlite3.c"
 $5 = ($4|0)==(5); //@line 109142 "c/sqlite3.c"
 if ($5) {
  return; //@line 109163 "c/sqlite3.c"
 }
 $6 = (_sqlite3_aggregate_context($0,24)|0); //@line 109143 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 109145 "c/sqlite3.c"
 if ($7) {
  return; //@line 109163 "c/sqlite3.c"
 }
 $8 = (_sqlite3_context_db_handle($0)|0); //@line 109146 "c/sqlite3.c"
 $9 = ((($6)) + 12|0); //@line 109147 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 109147 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 109147 "c/sqlite3.c"
 $12 = ((($8)) + 100|0); //@line 109148 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 109148 "c/sqlite3.c"
 HEAP32[$9>>2] = $13; //@line 109148 "c/sqlite3.c"
 do {
  if (!($11)) {
   $14 = ($1|0)==(2); //@line 109150 "c/sqlite3.c"
   if ($14) {
    $15 = ((($2)) + 4|0); //@line 109151 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 109151 "c/sqlite3.c"
    $17 = (_sqlite3_value_text($16)|0); //@line 109151 "c/sqlite3.c"
    $18 = HEAP32[$15>>2]|0; //@line 109152 "c/sqlite3.c"
    $19 = (_sqlite3_value_bytes($18)|0); //@line 109152 "c/sqlite3.c"
    $20 = ($17|0)==(0|0); //@line 109157 "c/sqlite3.c"
    if ($20) {
     break;
    } else {
     $$03334 = $19;$$035 = $17;
    }
   } else {
    $$03334 = 1;$$035 = 17184;
   }
   _sqlite3StrAccumAppend($6,$$035,$$03334); //@line 109157 "c/sqlite3.c"
  }
 } while(0);
 $21 = HEAP32[$2>>2]|0; //@line 109159 "c/sqlite3.c"
 $22 = (_sqlite3_value_text($21)|0); //@line 109159 "c/sqlite3.c"
 $23 = HEAP32[$2>>2]|0; //@line 109160 "c/sqlite3.c"
 $24 = (_sqlite3_value_bytes($23)|0); //@line 109160 "c/sqlite3.c"
 $25 = ($22|0)==(0|0); //@line 109161 "c/sqlite3.c"
 if ($25) {
  return; //@line 109163 "c/sqlite3.c"
 }
 _sqlite3StrAccumAppend($6,$22,$24); //@line 109161 "c/sqlite3.c"
 return; //@line 109163 "c/sqlite3.c"
}
function _groupConcatFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_aggregate_context($0,0)|0); //@line 109166 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 109167 "c/sqlite3.c"
 L1: do {
  if (!($2)) {
   $3 = ((($1)) + 20|0); //@line 109168 "c/sqlite3.c"
   $4 = HEAP8[$3>>0]|0; //@line 109168 "c/sqlite3.c"
   switch ($4<<24>>24) {
   case 2:  {
    _sqlite3_result_error_toobig($0); //@line 109169 "c/sqlite3.c"
    break L1;
    break;
   }
   case 1:  {
    _sqlite3_result_error_nomem($0); //@line 109171 "c/sqlite3.c"
    break L1;
    break;
   }
   default: {
    $5 = (_sqlite3StrAccumFinish($1)|0); //@line 109173 "c/sqlite3.c"
    _sqlite3_result_text($0,$5,-1,83); //@line 109173 "c/sqlite3.c"
    break L1;
   }
   }
  }
 } while(0);
 return; //@line 109177 "c/sqlite3.c"
}
function _likeFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = (_sqlite3_context_db_handle($0)|0); //@line 108337 "c/sqlite3.c"
 $5 = (_sqlite3_user_data($0)|0); //@line 108338 "c/sqlite3.c"
 $6 = HEAP32[$2>>2]|0; //@line 108351 "c/sqlite3.c"
 $7 = (_sqlite3_value_text($6)|0); //@line 108351 "c/sqlite3.c"
 $8 = ((($2)) + 4|0); //@line 108352 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 108352 "c/sqlite3.c"
 $10 = (_sqlite3_value_text($9)|0); //@line 108352 "c/sqlite3.c"
 $11 = HEAP32[$2>>2]|0; //@line 108357 "c/sqlite3.c"
 $12 = (_sqlite3_value_bytes($11)|0); //@line 108357 "c/sqlite3.c"
 $13 = ((($4)) + 132|0); //@line 108360 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 108360 "c/sqlite3.c"
 $15 = ($12|0)>($14|0); //@line 108360 "c/sqlite3.c"
 if ($15) {
  _sqlite3_result_error($0,17007,-1); //@line 108361 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 108388 "c/sqlite3.c"
 }
 $16 = ($1|0)==(3); //@line 108366 "c/sqlite3.c"
 L5: do {
  if ($16) {
   $17 = ((($2)) + 8|0); //@line 108370 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 108370 "c/sqlite3.c"
   $19 = (_sqlite3_value_text($18)|0); //@line 108370 "c/sqlite3.c"
   HEAP32[$3>>2] = $19; //@line 108370 "c/sqlite3.c"
   $20 = ($19|0)==(0|0); //@line 108371 "c/sqlite3.c"
   do {
    if (!($20)) {
     $21 = (_sqlite3Utf8CharLen_70($19,-1)|0); //@line 108372 "c/sqlite3.c"
     $22 = ($21|0)==(1); //@line 108372 "c/sqlite3.c"
     if ($22) {
      $23 = (_sqlite3Utf8Read($3)|0); //@line 108377 "c/sqlite3.c"
      $$1 = $23;
      break L5;
     } else {
      _sqlite3_result_error($0,17040,-1); //@line 108373 "c/sqlite3.c"
      break;
     }
    }
   } while(0);
   STACKTOP = sp;return; //@line 108388 "c/sqlite3.c"
  } else {
   $24 = ((($5)) + 2|0); //@line 108379 "c/sqlite3.c"
   $25 = HEAP8[$24>>0]|0; //@line 108379 "c/sqlite3.c"
   $26 = $25&255; //@line 108379 "c/sqlite3.c"
   $$1 = $26;
  }
 } while(0);
 $27 = ($10|0)!=(0|0); //@line 108381 "c/sqlite3.c"
 $28 = ($7|0)!=(0|0); //@line 108381 "c/sqlite3.c"
 $or$cond = $28 & $27; //@line 108381 "c/sqlite3.c"
 if (!($or$cond)) {
  STACKTOP = sp;return; //@line 108388 "c/sqlite3.c"
 }
 $29 = (_patternCompare($7,$10,$5,$$1)|0); //@line 108386 "c/sqlite3.c"
 $30 = ($29|0)==(0); //@line 108386 "c/sqlite3.c"
 $31 = $30&1; //@line 108386 "c/sqlite3.c"
 _sqlite3_result_int($0,$31); //@line 108385 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 108388 "c/sqlite3.c"
}
function _sqlite3_context_db_handle($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 78455 "c/sqlite3.c"
 $2 = ((($1)) + 32|0); //@line 78455 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 78455 "c/sqlite3.c"
 return ($3|0); //@line 78455 "c/sqlite3.c"
}
function _sqlite3_user_data($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 78440 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 78440 "c/sqlite3.c"
 $3 = ((($2)) + 4|0); //@line 78440 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 78440 "c/sqlite3.c"
 return ($4|0); //@line 78440 "c/sqlite3.c"
}
function _sqlite3_value_text($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueText($0,1)|0); //@line 77921 "c/sqlite3.c"
 return ($1|0); //@line 77921 "c/sqlite3.c"
}
function _sqlite3_value_bytes($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueBytes($0,1)|0); //@line 77889 "c/sqlite3.c"
 return ($1|0); //@line 77889 "c/sqlite3.c"
}
function _sqlite3_result_error($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 20|0); //@line 78079 "c/sqlite3.c"
 HEAP32[$3>>2] = 1; //@line 78079 "c/sqlite3.c"
 $4 = ((($0)) + 25|0); //@line 78080 "c/sqlite3.c"
 HEAP8[$4>>0] = 1; //@line 78080 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 78081 "c/sqlite3.c"
 (_sqlite3VdbeMemSetStr($5,$1,$2,1,(-1))|0); //@line 78081 "c/sqlite3.c"
 return; //@line 78082 "c/sqlite3.c"
}
function _sqlite3Utf8CharLen_70($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$01620 = 0, $$017$lcssa = 0, $$01719 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, $or$cond18 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(-1); //@line 28322 "c/sqlite3.c"
 $3 = (($0) + ($1)|0); //@line 28323 "c/sqlite3.c"
 $$0 = $2 ? $3 : (-1); //@line 28322 "c/sqlite3.c"
 $4 = HEAP8[$0>>0]|0; //@line 28328 "c/sqlite3.c"
 $5 = ($4<<24>>24)!=(0); //@line 28328 "c/sqlite3.c"
 $6 = ($$0>>>0)>($0>>>0); //@line 28328 "c/sqlite3.c"
 $or$cond18 = $6 & $5; //@line 28328 "c/sqlite3.c"
 if (!($or$cond18)) {
  $$017$lcssa = 0;
  return ($$017$lcssa|0); //@line 28332 "c/sqlite3.c"
 }
 $$01620 = $0;$$01719 = 0;$9 = $4;
 while(1) {
  $7 = ((($$01620)) + 1|0); //@line 28329 "c/sqlite3.c"
  $8 = ($9&255)>(191); //@line 28329 "c/sqlite3.c"
  if ($8) {
   $$1 = $7;
   while(1) {
    $10 = HEAP8[$$1>>0]|0; //@line 28329 "c/sqlite3.c"
    $11 = $10 & -64; //@line 28329 "c/sqlite3.c"
    $12 = ($11<<24>>24)==(-128); //@line 28329 "c/sqlite3.c"
    $13 = ((($$1)) + 1|0); //@line 28329 "c/sqlite3.c"
    if ($12) {
     $$1 = $13;
    } else {
     $$2 = $$1;
     break;
    }
   }
  } else {
   $$2 = $7;
  }
  $14 = (($$01719) + 1)|0; //@line 28330 "c/sqlite3.c"
  $15 = HEAP8[$$2>>0]|0; //@line 28328 "c/sqlite3.c"
  $16 = ($15<<24>>24)!=(0); //@line 28328 "c/sqlite3.c"
  $17 = ($$2>>>0)<($$0>>>0); //@line 28328 "c/sqlite3.c"
  $or$cond = $17 & $16; //@line 28328 "c/sqlite3.c"
  if ($or$cond) {
   $$01620 = $$2;$$01719 = $14;$9 = $15;
  } else {
   $$017$lcssa = $14;
   break;
  }
 }
 return ($$017$lcssa|0); //@line 28332 "c/sqlite3.c"
}
function _sqlite3Utf8Read($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $$012 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond11 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 28107 "c/sqlite3.c"
 $2 = ((($1)) + 1|0); //@line 28107 "c/sqlite3.c"
 HEAP32[$0>>2] = $2; //@line 28107 "c/sqlite3.c"
 $3 = HEAP8[$1>>0]|0; //@line 28107 "c/sqlite3.c"
 $4 = $3&255; //@line 28107 "c/sqlite3.c"
 $5 = ($3&255)>(191); //@line 28108 "c/sqlite3.c"
 if (!($5)) {
  return ($4|0); //@line 28117 "c/sqlite3.c"
 }
 $6 = (($4) + -192)|0; //@line 28109 "c/sqlite3.c"
 $7 = (17085 + ($6)|0); //@line 28109 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 28109 "c/sqlite3.c"
 $9 = $8&255; //@line 28109 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 28110 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 28110 "c/sqlite3.c"
 $12 = $11 & -64; //@line 28110 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(-128); //@line 28110 "c/sqlite3.c"
 if ($13) {
  $$012 = $9;$16 = $10;
  while(1) {
   $14 = $$012 << 6; //@line 28111 "c/sqlite3.c"
   $15 = ((($16)) + 1|0); //@line 28111 "c/sqlite3.c"
   HEAP32[$0>>2] = $15; //@line 28111 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 28111 "c/sqlite3.c"
   $18 = $17 & 63; //@line 28111 "c/sqlite3.c"
   $19 = $18&255; //@line 28111 "c/sqlite3.c"
   $20 = $14 | $19; //@line 28111 "c/sqlite3.c"
   $21 = HEAP8[$15>>0]|0; //@line 28110 "c/sqlite3.c"
   $22 = $21 & -64; //@line 28110 "c/sqlite3.c"
   $23 = ($22<<24>>24)==(-128); //@line 28110 "c/sqlite3.c"
   if ($23) {
    $$012 = $20;$16 = $15;
   } else {
    $$0$lcssa = $20;
    break;
   }
  }
 } else {
  $$0$lcssa = $9;
 }
 $24 = ($$0$lcssa>>>0)<(128); //@line 28113 "c/sqlite3.c"
 $25 = $$0$lcssa & -2048; //@line 28114 "c/sqlite3.c"
 $26 = ($25|0)==(55296); //@line 28114 "c/sqlite3.c"
 $or$cond = $24 | $26; //@line 28114 "c/sqlite3.c"
 $27 = $$0$lcssa & -2; //@line 28115 "c/sqlite3.c"
 $28 = ($27|0)==(65534); //@line 28115 "c/sqlite3.c"
 $or$cond11 = $28 | $or$cond; //@line 28114 "c/sqlite3.c"
 $spec$select = $or$cond11 ? 65533 : $$0$lcssa; //@line 28114 "c/sqlite3.c"
 return ($spec$select|0); //@line 28114 "c/sqlite3.c"
}
function _patternCompare($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$0101 = 0, $$0101$ph = 0, $$0109 = 0, $$0111 = 0, $$0118$ph = 0, $$1110 = 0, $$1119 = 0, $$2 = 0, $$2$ph = 0, $$2113 = 0, $$3 = 0, $$6 = 0, $$lcssa144148 = 0, $$lcssa144150 = 0, $$promoted = 0, $$sink218 = 0, $10 = 0, $100 = 0, $101 = 0;
 var $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0;
 var $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0;
 var $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0;
 var $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond10 = 0, $or$cond121 = 0, $or$cond195 = 0, $spec$select = 0, $spec$select120 = 0, $spec$select122 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 $6 = sp + 8|0;
 HEAP32[$4>>2] = $0;
 HEAP32[$5>>2] = $1;
 $7 = ((($2)) + 1|0); //@line 108170 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 108170 "c/sqlite3.c"
 $9 = $8&255; //@line 108170 "c/sqlite3.c"
 $10 = HEAP8[$2>>0]|0; //@line 108171 "c/sqlite3.c"
 $11 = $10&255; //@line 108171 "c/sqlite3.c"
 $12 = ((($2)) + 3|0); //@line 108172 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 108172 "c/sqlite3.c"
 $14 = ((($2)) + 2|0);
 $15 = ($13<<24>>24)==(0);
 $$0118$ph = 0;
 L1: while(1) {
  while(1) {
   $16 = HEAP32[$4>>2]|0; //@line 108175 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 108175 "c/sqlite3.c"
   $18 = ($17<<24>>24)>(-1); //@line 108175 "c/sqlite3.c"
   if ($18) {
    $19 = ((($16)) + 1|0); //@line 108175 "c/sqlite3.c"
    HEAP32[$4>>2] = $19; //@line 108175 "c/sqlite3.c"
    $20 = $17&255; //@line 108175 "c/sqlite3.c"
    $23 = $20;
   } else {
    $21 = (_sqlite3Utf8Read($4)|0); //@line 108175 "c/sqlite3.c"
    $23 = $21;
   }
   $22 = ($23|0)==(0); //@line 108175 "c/sqlite3.c"
   if ($22) {
    label = 71;
    break L1;
   }
   $24 = ($23|0)==($11|0); //@line 108176 "c/sqlite3.c"
   if ($24) {
    label = 8;
    break L1;
   }
   $106 = ($23|0)==($3|0); //@line 108241 "c/sqlite3.c"
   if (!($106)) {
    $$1110 = $23;$$1119 = $$0118$ph;
    break;
   }
   $107 = HEAP8[$14>>0]|0; //@line 108242 "c/sqlite3.c"
   $108 = ($107<<24>>24)==(0); //@line 108242 "c/sqlite3.c"
   if ($108) {
    label = 48;
    break;
   }
   $112 = (_sqlite3Utf8Read($5)|0); //@line 108250 "c/sqlite3.c"
   $113 = ($112|0)==(0); //@line 108251 "c/sqlite3.c"
   if ($113) {
    $$6 = 1;
    label = 74;
    break L1;
   }
   $114 = (_sqlite3Utf8Read($4)|0); //@line 108252 "c/sqlite3.c"
   $115 = ($114|0)==(94); //@line 108253 "c/sqlite3.c"
   if ($115) {
    $116 = (_sqlite3Utf8Read($4)|0); //@line 108255 "c/sqlite3.c"
    $$0 = 1;$$0111 = $116;
   } else {
    $$0 = 0;$$0111 = $114;
   }
   $117 = ($$0111|0)==(93); //@line 108257 "c/sqlite3.c"
   if ($117) {
    $118 = ($112|0)==(93); //@line 108258 "c/sqlite3.c"
    $spec$select120 = $118&1; //@line 108258 "c/sqlite3.c"
    $$0101$ph = 0;$$2$ph = $spec$select120;
    label = 55;
   } else {
    $$0101 = 0;$$2 = 0;$$2113 = $$0111;
   }
   L19: while(1) {
    if ((label|0) == 55) {
     label = 0;
     $119 = (_sqlite3Utf8Read($4)|0);
     $$0101 = $$0101$ph;$$2 = $$2$ph;$$2113 = $119;
    }
    switch ($$2113|0) {
    case 0:  {
     $$6 = 1;
     label = 74;
     break L1;
     break;
    }
    case 93:  {
     break L19;
     break;
    }
    case 45:  {
     $120 = HEAP32[$4>>2]|0; //@line 108262 "c/sqlite3.c"
     $121 = HEAP8[$120>>0]|0; //@line 108262 "c/sqlite3.c"
     $122 = ($121<<24>>24)==(93); //@line 108262 "c/sqlite3.c"
     if (!($122)) {
      $123 = ($121<<24>>24)!=(0); //@line 108262 "c/sqlite3.c"
      $124 = ($$0101|0)!=(0); //@line 108262 "c/sqlite3.c"
      $or$cond = $124 & $123; //@line 108262 "c/sqlite3.c"
      if ($or$cond) {
       $125 = (_sqlite3Utf8Read($4)|0); //@line 108263 "c/sqlite3.c"
       $126 = ($112>>>0)<($$0101>>>0); //@line 108264 "c/sqlite3.c"
       $127 = ($112>>>0)>($125>>>0); //@line 108264 "c/sqlite3.c"
       $or$cond121 = $126 | $127; //@line 108264 "c/sqlite3.c"
       $$3 = $or$cond121 ? $$2 : 1; //@line 108264 "c/sqlite3.c"
       $$0101$ph = 0;$$2$ph = $$3;
       label = 55;
       continue L19;
      }
     }
     break;
    }
    default: {
    }
    }
    $128 = ($112|0)==($$2113|0); //@line 108267 "c/sqlite3.c"
    $spec$select122 = $128 ? 1 : $$2; //@line 108267 "c/sqlite3.c"
    $$0101$ph = $$2113;$$2$ph = $spec$select122;
    label = 55;
   }
   $129 = ($$2|0)==($$0|0); //@line 108274 "c/sqlite3.c"
   if ($129) {
    $$6 = 1;
    label = 74;
    break L1;
   }
  }
  if ((label|0) == 48) {
   label = 0;
   $109 = (_sqlite3Utf8Read($4)|0); //@line 108243 "c/sqlite3.c"
   $110 = ($109|0)==(0); //@line 108244 "c/sqlite3.c"
   if ($110) {
    $$6 = 1;
    label = 74;
    break;
   }
   $111 = HEAP32[$4>>2]|0; //@line 108245 "c/sqlite3.c"
   $$1110 = $109;$$1119 = $111;
  }
  $130 = HEAP32[$5>>2]|0; //@line 108280 "c/sqlite3.c"
  $131 = HEAP8[$130>>0]|0; //@line 108280 "c/sqlite3.c"
  $132 = ($131<<24>>24)>(-1); //@line 108280 "c/sqlite3.c"
  if ($132) {
   $133 = ((($130)) + 1|0); //@line 108280 "c/sqlite3.c"
   HEAP32[$5>>2] = $133; //@line 108280 "c/sqlite3.c"
   $134 = $131&255; //@line 108280 "c/sqlite3.c"
   $137 = $134;
  } else {
   $135 = (_sqlite3Utf8Read($5)|0); //@line 108280 "c/sqlite3.c"
   $137 = $135;
  }
  $136 = ($$1110|0)==($137|0); //@line 108281 "c/sqlite3.c"
  do {
   if (!($136)) {
    if (!($15)) {
     $138 = $$1110 & 255; //@line 108282 "c/sqlite3.c"
     $139 = (16025 + ($138)|0); //@line 108282 "c/sqlite3.c"
     $140 = HEAP8[$139>>0]|0; //@line 108282 "c/sqlite3.c"
     $141 = $137 & 255; //@line 108282 "c/sqlite3.c"
     $142 = (16025 + ($141)|0); //@line 108282 "c/sqlite3.c"
     $143 = HEAP8[$142>>0]|0; //@line 108282 "c/sqlite3.c"
     $144 = ($140<<24>>24)==($143<<24>>24); //@line 108282 "c/sqlite3.c"
     $145 = $137 | $$1110; //@line 108282 "c/sqlite3.c"
     $146 = ($145>>>0)<(128); //@line 108282 "c/sqlite3.c"
     $147 = $146 & $144; //@line 108282 "c/sqlite3.c"
     if ($147) {
      break;
     }
    }
    $148 = ($$1110|0)==($9|0); //@line 108285 "c/sqlite3.c"
    if (!($148)) {
     $$6 = 1;
     label = 74;
     break L1;
    }
    $149 = HEAP32[$4>>2]|0; //@line 108285 "c/sqlite3.c"
    $150 = ($149|0)!=($$1119|0); //@line 108285 "c/sqlite3.c"
    $151 = ($137|0)!=(0); //@line 108285 "c/sqlite3.c"
    $or$cond10 = $151 & $150; //@line 108285 "c/sqlite3.c"
    if (!($or$cond10)) {
     $$6 = 1;
     label = 74;
     break L1;
    }
   }
  } while(0);
  $$0118$ph = $$1119;
 }
 if ((label|0) == 8) {
  while(1) {
   $25 = HEAP32[$4>>2]|0; //@line 108180 "c/sqlite3.c"
   $26 = HEAP8[$25>>0]|0; //@line 108180 "c/sqlite3.c"
   $27 = ($26<<24>>24)>(-1); //@line 108180 "c/sqlite3.c"
   if ($27) {
    $28 = ((($25)) + 1|0); //@line 108180 "c/sqlite3.c"
    HEAP32[$4>>2] = $28; //@line 108180 "c/sqlite3.c"
    $29 = $26&255; //@line 108180 "c/sqlite3.c"
    $32 = $29;
   } else {
    $30 = (_sqlite3Utf8Read($4)|0); //@line 108180 "c/sqlite3.c"
    $32 = $30;
   }
   $31 = ($32|0)==($11|0); //@line 108180 "c/sqlite3.c"
   $33 = ($32|0)==($9|0); //@line 108180 "c/sqlite3.c"
   $spec$select = $31 | $33; //@line 108180 "c/sqlite3.c"
   if (!($spec$select)) {
    break;
   }
   if ($33) {
    $34 = (_sqlite3Utf8Read($5)|0); //@line 108181 "c/sqlite3.c"
    $35 = ($34|0)==(0); //@line 108181 "c/sqlite3.c"
    if ($35) {
     $$6 = 2;
     label = 74;
     break;
    }
   }
  }
  if ((label|0) == 74) {
   STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
  }
  $36 = ($32|0)==(0); //@line 108185 "c/sqlite3.c"
  if ($36) {
   $$6 = 0;
   STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
  }
  $37 = ($32|0)==($3|0); //@line 108187 "c/sqlite3.c"
  do {
   if ($37) {
    $38 = ((($2)) + 2|0); //@line 108188 "c/sqlite3.c"
    $39 = HEAP8[$38>>0]|0; //@line 108188 "c/sqlite3.c"
    $40 = ($39<<24>>24)==(0); //@line 108188 "c/sqlite3.c"
    if ($40) {
     $41 = (_sqlite3Utf8Read($4)|0); //@line 108189 "c/sqlite3.c"
     $42 = ($41|0)==(0); //@line 108190 "c/sqlite3.c"
     if ($42) {
      $$6 = 2;
     } else {
      $$0109 = $41;
      break;
     }
     STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
    }
    $43 = HEAP32[$5>>2]|0; //@line 108195 "c/sqlite3.c"
    $44 = HEAP8[$43>>0]|0; //@line 108195 "c/sqlite3.c"
    $45 = ($44<<24>>24)==(0); //@line 108195 "c/sqlite3.c"
    if ($45) {
     $$6 = 2;
     STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
    }
    $$promoted = HEAP32[$5>>2]|0; //@line 108198 "c/sqlite3.c"
    $$lcssa144150 = $$promoted;$48 = $43;
    while(1) {
     $46 = HEAP32[$4>>2]|0; //@line 108196 "c/sqlite3.c"
     $47 = ((($46)) + -1|0); //@line 108196 "c/sqlite3.c"
     $49 = (_patternCompare($47,$48,$2,$3)|0); //@line 108196 "c/sqlite3.c"
     $50 = ($49|0)==(1); //@line 108197 "c/sqlite3.c"
     if (!($50)) {
      label = 73;
      break;
     }
     $51 = ((($48)) + 1|0); //@line 108198 "c/sqlite3.c"
     $52 = HEAP8[$48>>0]|0; //@line 108198 "c/sqlite3.c"
     $53 = ($52&255)>(191); //@line 108198 "c/sqlite3.c"
     $54 = HEAP8[$51>>0]|0;
     $55 = $54 & -64; //@line 108198 "c/sqlite3.c"
     $56 = ($55<<24>>24)==(-128); //@line 108198 "c/sqlite3.c"
     $or$cond195 = $53 & $56; //@line 108198 "c/sqlite3.c"
     if ($or$cond195) {
      $58 = $51;
      while(1) {
       $57 = ((($58)) + 1|0); //@line 108198 "c/sqlite3.c"
       $59 = HEAP8[$57>>0]|0; //@line 108198 "c/sqlite3.c"
       $60 = $59 & -64; //@line 108198 "c/sqlite3.c"
       $61 = ($60<<24>>24)==(-128); //@line 108198 "c/sqlite3.c"
       if ($61) {
        $58 = $57;
       } else {
        $$lcssa144148 = $57;$63 = $59;
        break;
       }
      }
     } else {
      $$lcssa144148 = $51;$63 = $54;
     }
     $62 = ($63<<24>>24)==(0); //@line 108195 "c/sqlite3.c"
     if ($62) {
      label = 72;
      break;
     } else {
      $$lcssa144150 = $$lcssa144148;$48 = $$lcssa144148;
     }
    }
    if ((label|0) == 72) {
     HEAP32[$5>>2] = $$lcssa144148; //@line 108198 "c/sqlite3.c"
     $$6 = 2;
     STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
    }
    else if ((label|0) == 73) {
     HEAP32[$5>>2] = $$lcssa144150; //@line 108198 "c/sqlite3.c"
     $$6 = $49;
     STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
    }
   } else {
    $$0109 = $32;
   }
  } while(0);
  $64 = ($$0109>>>0)<(129); //@line 108213 "c/sqlite3.c"
  if (!($64)) {
   $93 = HEAP32[$4>>2]|0;
   while(1) {
    $94 = HEAP32[$5>>2]|0; //@line 108233 "c/sqlite3.c"
    $95 = HEAP8[$94>>0]|0; //@line 108233 "c/sqlite3.c"
    $96 = ($95<<24>>24)>(-1); //@line 108233 "c/sqlite3.c"
    if ($96) {
     $97 = ((($94)) + 1|0); //@line 108233 "c/sqlite3.c"
     HEAP32[$5>>2] = $97; //@line 108233 "c/sqlite3.c"
     $98 = $95&255; //@line 108233 "c/sqlite3.c"
     $101 = $98;
    } else {
     $99 = (_sqlite3Utf8Read($5)|0); //@line 108233 "c/sqlite3.c"
     $101 = $99;
    }
    $100 = ($101|0)==(0); //@line 108233 "c/sqlite3.c"
    if ($100) {
     $$6 = 2;
     label = 74;
     break;
    }
    $102 = ($101|0)==($$0109|0); //@line 108234 "c/sqlite3.c"
    if ($102) {
     $103 = HEAP32[$5>>2]|0; //@line 108235 "c/sqlite3.c"
     $104 = (_patternCompare($93,$103,$2,$3)|0); //@line 108235 "c/sqlite3.c"
     $105 = ($104|0)==(1); //@line 108236 "c/sqlite3.c"
     if (!($105)) {
      $$6 = $104;
      label = 74;
      break;
     }
    }
   }
   if ((label|0) == 74) {
    STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
   }
  }
  $65 = ($13<<24>>24)==(0); //@line 108216 "c/sqlite3.c"
  if ($65) {
   $77 = $$0109&255; //@line 108221 "c/sqlite3.c"
   HEAP8[$6>>0] = $77; //@line 108221 "c/sqlite3.c"
   $$sink218 = 1;
  } else {
   $66 = $$0109 & 255; //@line 108217 "c/sqlite3.c"
   $67 = (16281 + ($66)|0); //@line 108217 "c/sqlite3.c"
   $68 = HEAP8[$67>>0]|0; //@line 108217 "c/sqlite3.c"
   $69 = $68 & 32; //@line 108217 "c/sqlite3.c"
   $70 = $69 ^ -1; //@line 108217 "c/sqlite3.c"
   $71 = $70&255; //@line 108217 "c/sqlite3.c"
   $72 = $$0109 & $71; //@line 108217 "c/sqlite3.c"
   $73 = $72&255; //@line 108217 "c/sqlite3.c"
   HEAP8[$6>>0] = $73; //@line 108217 "c/sqlite3.c"
   $74 = (16025 + ($66)|0); //@line 108218 "c/sqlite3.c"
   $75 = HEAP8[$74>>0]|0; //@line 108218 "c/sqlite3.c"
   $76 = ((($6)) + 1|0); //@line 108218 "c/sqlite3.c"
   HEAP8[$76>>0] = $75; //@line 108218 "c/sqlite3.c"
   $$sink218 = 2;
  }
  $78 = (($6) + ($$sink218)|0);
  HEAP8[$78>>0] = 0;
  $79 = HEAP32[$5>>2]|0; //@line 108225 "c/sqlite3.c"
  $80 = (_strcspn($79,$6)|0); //@line 108225 "c/sqlite3.c"
  $81 = (($79) + ($80)|0); //@line 108225 "c/sqlite3.c"
  HEAP32[$5>>2] = $81; //@line 108225 "c/sqlite3.c"
  $82 = HEAP8[$81>>0]|0; //@line 108226 "c/sqlite3.c"
  $83 = ($82<<24>>24)==(0); //@line 108226 "c/sqlite3.c"
  do {
   if (!($83)) {
    $84 = HEAP32[$4>>2]|0;
    $90 = $81;
    while(1) {
     $85 = ((($90)) + 1|0); //@line 108227 "c/sqlite3.c"
     $91 = (_patternCompare($84,$85,$2,$3)|0); //@line 108228 "c/sqlite3.c"
     $92 = ($91|0)==(1); //@line 108229 "c/sqlite3.c"
     if (!($92)) {
      break;
     }
     $86 = (_strcspn($85,$6)|0); //@line 108225 "c/sqlite3.c"
     $87 = (($85) + ($86)|0); //@line 108225 "c/sqlite3.c"
     $88 = HEAP8[$87>>0]|0; //@line 108226 "c/sqlite3.c"
     $89 = ($88<<24>>24)==(0); //@line 108226 "c/sqlite3.c"
     if ($89) {
      label = 34;
      break;
     } else {
      $90 = $87;
     }
    }
    if ((label|0) == 34) {
     HEAP32[$5>>2] = $87; //@line 108227 "c/sqlite3.c"
     break;
    }
    HEAP32[$5>>2] = $85; //@line 108227 "c/sqlite3.c"
    $$6 = $91;
    STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
   }
  } while(0);
  $$6 = 2;
  STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
 }
 else if ((label|0) == 71) {
  $152 = HEAP32[$5>>2]|0; //@line 108288 "c/sqlite3.c"
  $153 = HEAP8[$152>>0]|0; //@line 108288 "c/sqlite3.c"
  $154 = ($153<<24>>24)!=(0); //@line 108288 "c/sqlite3.c"
  $155 = $154&1; //@line 108288 "c/sqlite3.c"
  $$6 = $155;
  STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
 }
 else if ((label|0) == 74) {
  STACKTOP = sp;return ($$6|0); //@line 108289 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_result_int($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 78093 "c/sqlite3.c"
 $3 = ($1|0)<(0); //@line 78093 "c/sqlite3.c"
 $4 = $3 << 31 >> 31; //@line 78093 "c/sqlite3.c"
 _sqlite3VdbeMemSetInt64($2,$1,$4); //@line 78093 "c/sqlite3.c"
 return; //@line 78094 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetInt64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 71917 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 71917 "c/sqlite3.c"
 $5 = $4 & 9312; //@line 71917 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 71917 "c/sqlite3.c"
 if ($6) {
  $7 = $0; //@line 71920 "c/sqlite3.c"
  $8 = $7; //@line 71920 "c/sqlite3.c"
  HEAP32[$8>>2] = $1; //@line 71920 "c/sqlite3.c"
  $9 = (($7) + 4)|0; //@line 71920 "c/sqlite3.c"
  $10 = $9; //@line 71920 "c/sqlite3.c"
  HEAP32[$10>>2] = $2; //@line 71920 "c/sqlite3.c"
  HEAP16[$3>>1] = 4; //@line 71921 "c/sqlite3.c"
  return; //@line 71923 "c/sqlite3.c"
 } else {
  _vdbeReleaseAndSetInt64($0,$1,$2); //@line 71918 "c/sqlite3.c"
  return; //@line 71923 "c/sqlite3.c"
 }
}
function _vdbeReleaseAndSetInt64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3VdbeMemSetNull($0); //@line 71907 "c/sqlite3.c"
 $3 = $0; //@line 71908 "c/sqlite3.c"
 $4 = $3; //@line 71908 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 71908 "c/sqlite3.c"
 $5 = (($3) + 4)|0; //@line 71908 "c/sqlite3.c"
 $6 = $5; //@line 71908 "c/sqlite3.c"
 HEAP32[$6>>2] = $2; //@line 71908 "c/sqlite3.c"
 $7 = ((($0)) + 8|0); //@line 71909 "c/sqlite3.c"
 HEAP16[$7>>1] = 4; //@line 71909 "c/sqlite3.c"
 return; //@line 71910 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetNull($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71877 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71877 "c/sqlite3.c"
 $3 = $2 & 9312; //@line 71877 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 71877 "c/sqlite3.c"
 if ($4) {
  HEAP16[$1>>1] = 1; //@line 71880 "c/sqlite3.c"
  return; //@line 71882 "c/sqlite3.c"
 } else {
  _vdbeMemClearExternAndSetNull($0); //@line 71878 "c/sqlite3.c"
  return; //@line 71882 "c/sqlite3.c"
 }
}
function _vdbeMemClearExternAndSetNull($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71575 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71575 "c/sqlite3.c"
 $3 = $2 & 8192; //@line 71575 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 71575 "c/sqlite3.c"
 if (!($4)) {
  $5 = HEAP32[$0>>2]|0; //@line 71576 "c/sqlite3.c"
  (_sqlite3VdbeMemFinalize($0,$5)|0); //@line 71576 "c/sqlite3.c"
 }
 $6 = HEAP16[$1>>1]|0; //@line 71580 "c/sqlite3.c"
 $7 = $6&65535; //@line 71580 "c/sqlite3.c"
 $8 = $7 & 1024; //@line 71580 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 71580 "c/sqlite3.c"
 if (!($9)) {
  $10 = ((($0)) + 36|0); //@line 71583 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 71583 "c/sqlite3.c"
  $12 = ((($0)) + 16|0); //@line 71583 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 71583 "c/sqlite3.c"
  FUNCTION_TABLE_vi[$11 & 127]($13); //@line 71583 "c/sqlite3.c"
  HEAP16[$1>>1] = 1; //@line 71591 "c/sqlite3.c"
  return; //@line 71592 "c/sqlite3.c"
 }
 $14 = $7 & 32; //@line 71584 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 71584 "c/sqlite3.c"
 if (!($15)) {
  $16 = HEAP32[$0>>2]|0; //@line 71585 "c/sqlite3.c"
  _sqlite3RowSetClear($16); //@line 71585 "c/sqlite3.c"
  HEAP16[$1>>1] = 1; //@line 71591 "c/sqlite3.c"
  return; //@line 71592 "c/sqlite3.c"
 }
 $17 = $7 & 64; //@line 71586 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 71586 "c/sqlite3.c"
 if ($18) {
  HEAP16[$1>>1] = 1; //@line 71591 "c/sqlite3.c"
  return; //@line 71592 "c/sqlite3.c"
 }
 $19 = HEAP32[$0>>2]|0; //@line 71587 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 71588 "c/sqlite3.c"
 $21 = ((($20)) + 196|0); //@line 71588 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 71588 "c/sqlite3.c"
 $23 = ((($19)) + 4|0); //@line 71588 "c/sqlite3.c"
 HEAP32[$23>>2] = $22; //@line 71588 "c/sqlite3.c"
 HEAP32[$21>>2] = $19; //@line 71589 "c/sqlite3.c"
 HEAP16[$1>>1] = 1; //@line 71591 "c/sqlite3.c"
 return; //@line 71592 "c/sqlite3.c"
}
function _sqlite3VdbeMemFinalize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0;
 var label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $2 = sp + 40|0;
 $3 = sp;
 $4 = ((($2)) + 12|0);
 ;HEAP32[$4>>2]=0|0;HEAP32[$4+4>>2]=0|0;HEAP32[$4+8>>2]=0|0;HEAP32[$4+12>>2]=0|0;HEAP32[$4+16>>2]=0|0; //@line 71549 "c/sqlite3.c"
 dest=$3; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 71550 "c/sqlite3.c"
 $5 = ((($3)) + 8|0); //@line 71551 "c/sqlite3.c"
 HEAP16[$5>>1] = 1; //@line 71551 "c/sqlite3.c"
 $6 = ((($0)) + 32|0); //@line 71552 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 71552 "c/sqlite3.c"
 $8 = ((($3)) + 32|0); //@line 71552 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 71552 "c/sqlite3.c"
 HEAP32[$2>>2] = $3; //@line 71553 "c/sqlite3.c"
 $9 = ((($2)) + 8|0); //@line 71554 "c/sqlite3.c"
 HEAP32[$9>>2] = $0; //@line 71554 "c/sqlite3.c"
 $10 = ((($2)) + 4|0); //@line 71555 "c/sqlite3.c"
 HEAP32[$10>>2] = $1; //@line 71555 "c/sqlite3.c"
 $11 = ((($1)) + 16|0); //@line 71556 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 71556 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$12 & 127]($2); //@line 71556 "c/sqlite3.c"
 $13 = ((($0)) + 24|0); //@line 71558 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 71558 "c/sqlite3.c"
 $15 = ($14|0)>(0); //@line 71558 "c/sqlite3.c"
 if (!($15)) {
  dest=$0; src=$3; stop=dest+40|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 71559 "c/sqlite3.c"
  $19 = ((($2)) + 20|0); //@line 71560 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 71560 "c/sqlite3.c"
  STACKTOP = sp;return ($20|0); //@line 71560 "c/sqlite3.c"
 }
 $16 = HEAP32[$6>>2]|0; //@line 71558 "c/sqlite3.c"
 $17 = ((($0)) + 20|0); //@line 71558 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 71558 "c/sqlite3.c"
 _sqlite3DbFreeNN($16,$18); //@line 71558 "c/sqlite3.c"
 dest=$0; src=$3; stop=dest+40|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 71559 "c/sqlite3.c"
 $19 = ((($2)) + 20|0); //@line 71560 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 71560 "c/sqlite3.c"
 STACKTOP = sp;return ($20|0); //@line 71560 "c/sqlite3.c"
}
function _sqlite3RowSetClear($0) {
 $0 = $0|0;
 var $$in1516 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 47474 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 47474 "c/sqlite3.c"
 if (!($2)) {
  $3 = ((($0)) + 4|0);
  $$in1516 = $1;
  while(1) {
   $4 = HEAP32[$$in1516>>2]|0; //@line 47475 "c/sqlite3.c"
   $5 = HEAP32[$3>>2]|0; //@line 47476 "c/sqlite3.c"
   _sqlite3DbFree($5,$$in1516); //@line 47476 "c/sqlite3.c"
   $6 = ($4|0)==(0|0); //@line 47474 "c/sqlite3.c"
   if ($6) {
    break;
   } else {
    $$in1516 = $4;
   }
  }
 }
 HEAP32[$0>>2] = 0; //@line 47478 "c/sqlite3.c"
 $7 = ((($0)) + 24|0); //@line 47479 "c/sqlite3.c"
 HEAP16[$7>>1] = 0; //@line 47479 "c/sqlite3.c"
 $8 = ((($0)) + 8|0); //@line 47480 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 47480 "c/sqlite3.c"
 $9 = ((($0)) + 12|0); //@line 47481 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 47481 "c/sqlite3.c"
 $10 = ((($0)) + 20|0); //@line 47482 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 47482 "c/sqlite3.c"
 $11 = ((($0)) + 26|0); //@line 47483 "c/sqlite3.c"
 HEAP16[$11>>1] = 1; //@line 47483 "c/sqlite3.c"
 return; //@line 47484 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetStr($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$ = 0, $$064 = 0, $$065 = 0, $$06671 = 0, $$1 = 0, $$167 = 0, $$169 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$select70 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)==(0|0); //@line 72112 "c/sqlite3.c"
 if ($5) {
  _sqlite3VdbeMemSetNull($0); //@line 72113 "c/sqlite3.c"
  $$169 = 0;
  return ($$169|0); //@line 72179 "c/sqlite3.c"
 }
 $6 = ((($0)) + 32|0); //@line 72117 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 72117 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 72117 "c/sqlite3.c"
 if ($8) {
  $$065 = 1000000000;
 } else {
  $9 = ((($7)) + 100|0); //@line 72118 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 72118 "c/sqlite3.c"
  $$065 = $10;
 }
 $11 = ($3<<24>>24)==(0); //@line 72122 "c/sqlite3.c"
 $12 = $11 ? 16 : 2; //@line 72122 "c/sqlite3.c"
 $13 = ($2|0)<(0); //@line 72123 "c/sqlite3.c"
 if ($13) {
  $14 = ($3<<24>>24)==(1); //@line 72125 "c/sqlite3.c"
  L10: do {
   if ($14) {
    $15 = (_strlen($1)|0); //@line 72126 "c/sqlite3.c"
    $16 = $15 & 2147483647; //@line 72126 "c/sqlite3.c"
    $17 = ($16|0)>($$065|0); //@line 72127 "c/sqlite3.c"
    $18 = (($$065) + 1)|0; //@line 72127 "c/sqlite3.c"
    $spec$select = $17 ? $18 : $16; //@line 72127 "c/sqlite3.c"
    $$167 = $spec$select;
   } else {
    $19 = ($$065|0)<(0); //@line 72129 "c/sqlite3.c"
    if ($19) {
     $$167 = 0;
    } else {
     $$06671 = 0;
     while(1) {
      $20 = (($1) + ($$06671)|0); //@line 72129 "c/sqlite3.c"
      $21 = HEAP8[$20>>0]|0; //@line 72129 "c/sqlite3.c"
      $22 = $$06671 | 1; //@line 72129 "c/sqlite3.c"
      $23 = (($1) + ($22)|0); //@line 72129 "c/sqlite3.c"
      $24 = HEAP8[$23>>0]|0; //@line 72129 "c/sqlite3.c"
      $25 = $24 | $21; //@line 72129 "c/sqlite3.c"
      $26 = ($25<<24>>24)==(0); //@line 72129 "c/sqlite3.c"
      if ($26) {
       $$167 = $$06671;
       break L10;
      }
      $27 = (($$06671) + 2)|0; //@line 72129 "c/sqlite3.c"
      $28 = ($27|0)>($$065|0); //@line 72129 "c/sqlite3.c"
      if ($28) {
       $$167 = $27;
       break;
      } else {
       $$06671 = $27;
      }
     }
    }
   }
  } while(0);
  $29 = $12 | 512; //@line 72131 "c/sqlite3.c"
  $$064 = $29;$$2 = $$167;
 } else {
  $$064 = $12;$$2 = $2;
 }
 $30 = ($4|0)==((-1)|0); //@line 72138 "c/sqlite3.c"
 do {
  if ($30) {
   $31 = $$064 & 512; //@line 72140 "c/sqlite3.c"
   $32 = ($31<<16>>16)==(0); //@line 72140 "c/sqlite3.c"
   $33 = ($3<<24>>24)==(1); //@line 72141 "c/sqlite3.c"
   $34 = $33 ? 1 : 2; //@line 72141 "c/sqlite3.c"
   $35 = $32 ? 0 : $34; //@line 72140 "c/sqlite3.c"
   $spec$select70 = (($35) + ($$2))|0; //@line 72140 "c/sqlite3.c"
   $36 = ($$2|0)>($$065|0); //@line 72143 "c/sqlite3.c"
   if ($36) {
    $$169 = 18;
    return ($$169|0); //@line 72179 "c/sqlite3.c"
   }
   $37 = ($spec$select70|0)>(32); //@line 72149 "c/sqlite3.c"
   $38 = $37 ? $spec$select70 : 32; //@line 72149 "c/sqlite3.c"
   $39 = (_sqlite3VdbeMemClearAndResize($0,$38)|0); //@line 72149 "c/sqlite3.c"
   $40 = ($39|0)==(0); //@line 72149 "c/sqlite3.c"
   if ($40) {
    $41 = ((($0)) + 16|0); //@line 72152 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 72152 "c/sqlite3.c"
    _memcpy(($42|0),($1|0),($spec$select70|0))|0; //@line 72152 "c/sqlite3.c"
    $$1 = $$064;
    break;
   } else {
    $$169 = 7;
    return ($$169|0); //@line 72179 "c/sqlite3.c"
   }
  } else {
   $43 = ($4|0)==(157|0); //@line 72153 "c/sqlite3.c"
   _sqlite3VdbeMemRelease($0);
   $44 = ((($0)) + 16|0);
   HEAP32[$44>>2] = $1;
   if ($43) {
    $45 = ((($0)) + 20|0); //@line 72155 "c/sqlite3.c"
    HEAP32[$45>>2] = $1; //@line 72155 "c/sqlite3.c"
    $46 = HEAP32[$6>>2]|0; //@line 72156 "c/sqlite3.c"
    $47 = (_sqlite3DbMallocSize($46,$1)|0); //@line 72156 "c/sqlite3.c"
    $48 = ((($0)) + 24|0); //@line 72156 "c/sqlite3.c"
    HEAP32[$48>>2] = $47; //@line 72156 "c/sqlite3.c"
    $$1 = $$064;
    break;
   } else {
    $49 = ((($0)) + 36|0); //@line 72160 "c/sqlite3.c"
    HEAP32[$49>>2] = $4; //@line 72160 "c/sqlite3.c"
    $50 = ($4|0)==(0|0); //@line 72161 "c/sqlite3.c"
    $51 = $50 ? 2048 : 1024; //@line 72161 "c/sqlite3.c"
    $52 = $$064&65535; //@line 72161 "c/sqlite3.c"
    $53 = $51 | $52; //@line 72161 "c/sqlite3.c"
    $54 = $53&65535; //@line 72161 "c/sqlite3.c"
    $$1 = $54;
    break;
   }
  }
 } while(0);
 $55 = ((($0)) + 12|0); //@line 72164 "c/sqlite3.c"
 HEAP32[$55>>2] = $$2; //@line 72164 "c/sqlite3.c"
 $56 = ((($0)) + 8|0); //@line 72165 "c/sqlite3.c"
 HEAP16[$56>>1] = $$1; //@line 72165 "c/sqlite3.c"
 $57 = $11 ? 1 : $3; //@line 72166 "c/sqlite3.c"
 $58 = ((($0)) + 10|0); //@line 72166 "c/sqlite3.c"
 HEAP8[$58>>0] = $57; //@line 72166 "c/sqlite3.c"
 $59 = ($57<<24>>24)==(1); //@line 72169 "c/sqlite3.c"
 if (!($59)) {
  $60 = (_sqlite3VdbeMemHandleBom($0)|0); //@line 72169 "c/sqlite3.c"
  $61 = ($60|0)==(0); //@line 72169 "c/sqlite3.c"
  if (!($61)) {
   $$169 = 7;
   return ($$169|0); //@line 72179 "c/sqlite3.c"
  }
 }
 $62 = ($$2|0)>($$065|0); //@line 72174 "c/sqlite3.c"
 $$ = $62 ? 18 : 0; //@line 72175 "c/sqlite3.c"
 $$169 = $$;
 return ($$169|0); //@line 72179 "c/sqlite3.c"
}
function _sqlite3VdbeMemClearAndResize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 71394 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 71394 "c/sqlite3.c"
 $4 = ($3|0)<($1|0); //@line 71394 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3VdbeMemGrow($0,$1,0)|0); //@line 71395 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 71401 "c/sqlite3.c"
 } else {
  $6 = ((($0)) + 20|0); //@line 71398 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 71398 "c/sqlite3.c"
  $8 = ((($0)) + 16|0); //@line 71398 "c/sqlite3.c"
  HEAP32[$8>>2] = $7; //@line 71398 "c/sqlite3.c"
  $9 = ((($0)) + 8|0); //@line 71399 "c/sqlite3.c"
  $10 = HEAP16[$9>>1]|0; //@line 71399 "c/sqlite3.c"
  $11 = $10 & 13; //@line 71399 "c/sqlite3.c"
  HEAP16[$9>>1] = $11; //@line 71399 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 71401 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeMemRelease($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71625 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71625 "c/sqlite3.c"
 $3 = $2 & 9312; //@line 71625 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 71625 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 24|0); //@line 71625 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 71625 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 71625 "c/sqlite3.c"
  if ($7) {
   return; //@line 71628 "c/sqlite3.c"
  }
 }
 _vdbeMemClear($0); //@line 71626 "c/sqlite3.c"
 return; //@line 71628 "c/sqlite3.c"
}
function _sqlite3VdbeMemHandleBom($0) {
 $0 = $0|0;
 var $$0 = 0, $$022 = 0, $$225 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $not$or$cond$demorgan = 0, $or$cond = 0, $or$cond23 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 28285 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 28285 "c/sqlite3.c"
 $3 = ($2|0)>(1); //@line 28285 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 28307 "c/sqlite3.c"
 }
 $4 = ((($0)) + 16|0); //@line 28286 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 28286 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 28286 "c/sqlite3.c"
 $7 = ((($5)) + 1|0); //@line 28287 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 28287 "c/sqlite3.c"
 $9 = ($6<<24>>24)==(-2); //@line 28288 "c/sqlite3.c"
 $10 = ($8<<24>>24)==(-1); //@line 28288 "c/sqlite3.c"
 $11 = ($6<<24>>24)==(-1); //@line 28291 "c/sqlite3.c"
 $12 = ($8<<24>>24)==(-2); //@line 28291 "c/sqlite3.c"
 $or$cond23 = $11 & $12; //@line 28291 "c/sqlite3.c"
 if ($or$cond23) {
  $$225 = 2;
 } else {
  $or$cond = $9 & $10; //@line 28288 "c/sqlite3.c"
  $$022 = $or$cond ? 3 : 0; //@line 28288 "c/sqlite3.c"
  $not$or$cond$demorgan = $9 & $10; //@line 28296 "c/sqlite3.c"
  if ($not$or$cond$demorgan) {
   $$225 = $$022;
  } else {
   $$0 = 0;
   return ($$0|0); //@line 28307 "c/sqlite3.c"
  }
 }
 $13 = (_sqlite3VdbeMemMakeWriteable($0)|0); //@line 28297 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 28298 "c/sqlite3.c"
 if (!($14)) {
  $$0 = $13;
  return ($$0|0); //@line 28307 "c/sqlite3.c"
 }
 $15 = HEAP32[$1>>2]|0; //@line 28299 "c/sqlite3.c"
 $16 = (($15) + -2)|0; //@line 28299 "c/sqlite3.c"
 HEAP32[$1>>2] = $16; //@line 28299 "c/sqlite3.c"
 $17 = ((($0)) + 16|0); //@line 28300 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 28300 "c/sqlite3.c"
 $19 = ((($18)) + 2|0); //@line 28300 "c/sqlite3.c"
 _memmove(($18|0),($19|0),($16|0))|0; //@line 28300 "c/sqlite3.c"
 $20 = HEAP32[$17>>2]|0; //@line 28301 "c/sqlite3.c"
 $21 = HEAP32[$1>>2]|0; //@line 28301 "c/sqlite3.c"
 $22 = (($20) + ($21)|0); //@line 28301 "c/sqlite3.c"
 HEAP8[$22>>0] = 0; //@line 28301 "c/sqlite3.c"
 $23 = HEAP32[$17>>2]|0; //@line 28302 "c/sqlite3.c"
 $24 = HEAP32[$1>>2]|0; //@line 28302 "c/sqlite3.c"
 $25 = (($24) + 1)|0; //@line 28302 "c/sqlite3.c"
 $26 = (($23) + ($25)|0); //@line 28302 "c/sqlite3.c"
 HEAP8[$26>>0] = 0; //@line 28302 "c/sqlite3.c"
 $27 = ((($0)) + 8|0); //@line 28303 "c/sqlite3.c"
 $28 = HEAP16[$27>>1]|0; //@line 28303 "c/sqlite3.c"
 $29 = $28 | 512; //@line 28303 "c/sqlite3.c"
 HEAP16[$27>>1] = $29; //@line 28303 "c/sqlite3.c"
 $30 = ((($0)) + 10|0); //@line 28304 "c/sqlite3.c"
 HEAP8[$30>>0] = $$225; //@line 28304 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 28307 "c/sqlite3.c"
}
function _sqlite3VdbeMemMakeWriteable($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71426 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71426 "c/sqlite3.c"
 $3 = $2&65535; //@line 71426 "c/sqlite3.c"
 $4 = $3 & 18; //@line 71426 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 71426 "c/sqlite3.c"
 do {
  if (!($5)) {
   $6 = $3 & 16384; //@line 71427 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 71427 "c/sqlite3.c"
   if (!($7)) {
    $8 = (_sqlite3VdbeMemExpandBlob($0)|0); //@line 71427 "c/sqlite3.c"
    $9 = ($8|0)==(0); //@line 71427 "c/sqlite3.c"
    if (!($9)) {
     $$1 = 7;
     return ($$1|0); //@line 71439 "c/sqlite3.c"
    }
   }
   $10 = ((($0)) + 24|0); //@line 71428 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 71428 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 71428 "c/sqlite3.c"
   if (!($12)) {
    $13 = ((($0)) + 16|0); //@line 71428 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 71428 "c/sqlite3.c"
    $15 = ((($0)) + 20|0); //@line 71428 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 71428 "c/sqlite3.c"
    $17 = ($14|0)==($16|0); //@line 71428 "c/sqlite3.c"
    if ($17) {
     break;
    }
   }
   $18 = (_vdbeMemAddTerminator($0)|0); //@line 71429 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 71430 "c/sqlite3.c"
   if (!($19)) {
    $$1 = $18;
    return ($$1|0); //@line 71439 "c/sqlite3.c"
   }
  }
 } while(0);
 $20 = HEAP16[$1>>1]|0; //@line 71433 "c/sqlite3.c"
 $21 = $20 & -4097; //@line 71433 "c/sqlite3.c"
 HEAP16[$1>>1] = $21; //@line 71433 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 71439 "c/sqlite3.c"
}
function _sqlite3VdbeMemExpandBlob($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$store$select = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 71454 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 71454 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 71454 "c/sqlite3.c"
 $4 = (($3) + ($2))|0; //@line 71454 "c/sqlite3.c"
 $5 = ($4|0)>(1); //@line 71455 "c/sqlite3.c"
 $spec$store$select = $5 ? $4 : 1; //@line 71455 "c/sqlite3.c"
 $6 = (_sqlite3VdbeMemGrow($0,$spec$store$select,1)|0); //@line 71458 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 71458 "c/sqlite3.c"
 if (!($7)) {
  $$0 = 7;
  return ($$0|0); //@line 71466 "c/sqlite3.c"
 }
 $8 = ((($0)) + 16|0); //@line 71462 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 71462 "c/sqlite3.c"
 $10 = HEAP32[$1>>2]|0; //@line 71462 "c/sqlite3.c"
 $11 = (($9) + ($10)|0); //@line 71462 "c/sqlite3.c"
 $12 = HEAP32[$0>>2]|0; //@line 71462 "c/sqlite3.c"
 _memset(($11|0),0,($12|0))|0; //@line 71462 "c/sqlite3.c"
 $13 = HEAP32[$0>>2]|0; //@line 71463 "c/sqlite3.c"
 $14 = HEAP32[$1>>2]|0; //@line 71463 "c/sqlite3.c"
 $15 = (($14) + ($13))|0; //@line 71463 "c/sqlite3.c"
 HEAP32[$1>>2] = $15; //@line 71463 "c/sqlite3.c"
 $16 = ((($0)) + 8|0); //@line 71464 "c/sqlite3.c"
 $17 = HEAP16[$16>>1]|0; //@line 71464 "c/sqlite3.c"
 $18 = $17 & -16897; //@line 71464 "c/sqlite3.c"
 HEAP16[$16>>1] = $18; //@line 71464 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 71466 "c/sqlite3.c"
}
function _vdbeMemAddTerminator($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 71408 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 71408 "c/sqlite3.c"
 $3 = (($2) + 2)|0; //@line 71408 "c/sqlite3.c"
 $4 = (_sqlite3VdbeMemGrow($0,$3,1)|0); //@line 71408 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 71408 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 7;
  return ($$0|0); //@line 71415 "c/sqlite3.c"
 }
 $6 = ((($0)) + 16|0); //@line 71411 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 71411 "c/sqlite3.c"
 $8 = HEAP32[$1>>2]|0; //@line 71411 "c/sqlite3.c"
 $9 = (($7) + ($8)|0); //@line 71411 "c/sqlite3.c"
 HEAP8[$9>>0] = 0; //@line 71411 "c/sqlite3.c"
 $10 = HEAP32[$6>>2]|0; //@line 71412 "c/sqlite3.c"
 $11 = HEAP32[$1>>2]|0; //@line 71412 "c/sqlite3.c"
 $12 = (($11) + 1)|0; //@line 71412 "c/sqlite3.c"
 $13 = (($10) + ($12)|0); //@line 71412 "c/sqlite3.c"
 HEAP8[$13>>0] = 0; //@line 71412 "c/sqlite3.c"
 $14 = ((($0)) + 8|0); //@line 71413 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 71413 "c/sqlite3.c"
 $16 = $15 | 512; //@line 71413 "c/sqlite3.c"
 HEAP16[$14>>1] = $16; //@line 71413 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 71415 "c/sqlite3.c"
}
function _sqlite3VdbeMemGrow($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$035 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)>(32); //@line 71347 "c/sqlite3.c"
 $spec$select = $3 ? $1 : 32; //@line 71347 "c/sqlite3.c"
 $4 = ((($0)) + 24|0); //@line 71348 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 71348 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 71348 "c/sqlite3.c"
 $7 = ($2|0)!=(0); //@line 71348 "c/sqlite3.c"
 $or$cond = $7 & $6; //@line 71348 "c/sqlite3.c"
 if ($or$cond) {
  $8 = ((($0)) + 16|0); //@line 71348 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 71348 "c/sqlite3.c"
  $10 = ((($0)) + 20|0); //@line 71348 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 71348 "c/sqlite3.c"
  $12 = ($9|0)==($11|0); //@line 71348 "c/sqlite3.c"
  if ($12) {
   $13 = ((($0)) + 32|0); //@line 71349 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 71349 "c/sqlite3.c"
   $15 = (_sqlite3DbReallocOrFree($14,$9,$spec$select,0)|0); //@line 71349 "c/sqlite3.c"
   HEAP32[$10>>2] = $15; //@line 71349 "c/sqlite3.c"
   HEAP32[$8>>2] = $15; //@line 71349 "c/sqlite3.c"
   $$0 = 0;
  } else {
   label = 4;
  }
 } else {
  label = 4;
 }
 if ((label|0) == 4) {
  if ($6) {
   $16 = ((($0)) + 32|0); //@line 71352 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 71352 "c/sqlite3.c"
   $18 = ((($0)) + 20|0); //@line 71352 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 71352 "c/sqlite3.c"
   _sqlite3DbFreeNN($17,$19); //@line 71352 "c/sqlite3.c"
  }
  $20 = ((($0)) + 32|0); //@line 71353 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 71353 "c/sqlite3.c"
  $22 = (_sqlite3DbMallocRaw($21,$spec$select,0)|0); //@line 71353 "c/sqlite3.c"
  $23 = ((($0)) + 20|0); //@line 71353 "c/sqlite3.c"
  HEAP32[$23>>2] = $22; //@line 71353 "c/sqlite3.c"
  $$0 = $2;
 }
 $24 = ((($0)) + 20|0); //@line 71355 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 71355 "c/sqlite3.c"
 $26 = ($25|0)==(0|0); //@line 71355 "c/sqlite3.c"
 if ($26) {
  _sqlite3VdbeMemSetNull($0); //@line 71356 "c/sqlite3.c"
  $27 = ((($0)) + 16|0); //@line 71357 "c/sqlite3.c"
  HEAP32[$27>>2] = 0; //@line 71357 "c/sqlite3.c"
  HEAP32[$4>>2] = 0; //@line 71358 "c/sqlite3.c"
  $$035 = 7;
  return ($$035|0); //@line 71376 "c/sqlite3.c"
 }
 $28 = ((($0)) + 32|0); //@line 71361 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 71361 "c/sqlite3.c"
 $30 = (_sqlite3DbMallocSize($29,$25)|0); //@line 71361 "c/sqlite3.c"
 HEAP32[$4>>2] = $30; //@line 71361 "c/sqlite3.c"
 $31 = ($$0|0)==(0); //@line 71364 "c/sqlite3.c"
 if (!($31)) {
  $32 = ((($0)) + 16|0); //@line 71364 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 71364 "c/sqlite3.c"
  $34 = ($33|0)==(0|0); //@line 71364 "c/sqlite3.c"
  if (!($34)) {
   $35 = HEAP32[$24>>2]|0; //@line 71366 "c/sqlite3.c"
   $36 = ((($0)) + 12|0); //@line 71366 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 71366 "c/sqlite3.c"
   _memcpy(($35|0),($33|0),($37|0))|0; //@line 71366 "c/sqlite3.c"
  }
 }
 $38 = ((($0)) + 8|0); //@line 71368 "c/sqlite3.c"
 $39 = HEAP16[$38>>1]|0; //@line 71368 "c/sqlite3.c"
 $40 = $39 & 1024; //@line 71368 "c/sqlite3.c"
 $41 = ($40<<16>>16)==(0); //@line 71368 "c/sqlite3.c"
 if (!($41)) {
  $42 = ((($0)) + 36|0); //@line 71370 "c/sqlite3.c"
  $43 = HEAP32[$42>>2]|0; //@line 71370 "c/sqlite3.c"
  $44 = ((($0)) + 16|0); //@line 71370 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 71370 "c/sqlite3.c"
  FUNCTION_TABLE_vi[$43 & 127]($45); //@line 71370 "c/sqlite3.c"
 }
 $46 = HEAP32[$24>>2]|0; //@line 71373 "c/sqlite3.c"
 $47 = ((($0)) + 16|0); //@line 71373 "c/sqlite3.c"
 HEAP32[$47>>2] = $46; //@line 71373 "c/sqlite3.c"
 $48 = HEAP16[$38>>1]|0; //@line 71374 "c/sqlite3.c"
 $49 = $48 & -7169; //@line 71374 "c/sqlite3.c"
 HEAP16[$38>>1] = $49; //@line 71374 "c/sqlite3.c"
 $$035 = 0;
 return ($$035|0); //@line 71376 "c/sqlite3.c"
}
function _sqlite3DbReallocOrFree($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3DbRealloc($0,$1,$2,$3)|0); //@line 25728 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 25729 "c/sqlite3.c"
 if ($5) {
  _sqlite3DbFree($0,$1); //@line 25730 "c/sqlite3.c"
 }
 return ($4|0); //@line 25732 "c/sqlite3.c"
}
function _vdbeMemClear($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71603 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71603 "c/sqlite3.c"
 $3 = $2 & 9312; //@line 71603 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 71603 "c/sqlite3.c"
 if (!($4)) {
  _vdbeMemClearExternAndSetNull($0); //@line 71604 "c/sqlite3.c"
 }
 $5 = ((($0)) + 24|0); //@line 71606 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 71606 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 71606 "c/sqlite3.c"
 if ($7) {
  $12 = ((($0)) + 16|0); //@line 71610 "c/sqlite3.c"
  HEAP32[$12>>2] = 0; //@line 71610 "c/sqlite3.c"
  return; //@line 71611 "c/sqlite3.c"
 }
 $8 = ((($0)) + 32|0); //@line 71607 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 71607 "c/sqlite3.c"
 $10 = ((($0)) + 20|0); //@line 71607 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 71607 "c/sqlite3.c"
 _sqlite3DbFreeNN($9,$11); //@line 71607 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 71608 "c/sqlite3.c"
 $12 = ((($0)) + 16|0); //@line 71610 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 71610 "c/sqlite3.c"
 return; //@line 71611 "c/sqlite3.c"
}
function _sqlite3ValueBytes($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 72945 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 72945 "c/sqlite3.c"
 $4 = $3 & 2; //@line 72945 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 72945 "c/sqlite3.c"
 if (!($5)) {
  $6 = ((($0)) + 10|0); //@line 72945 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 72945 "c/sqlite3.c"
  $8 = ($7<<24>>24)==($1<<24>>24); //@line 72945 "c/sqlite3.c"
  if ($8) {
   $9 = ((($0)) + 12|0); //@line 72946 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 72946 "c/sqlite3.c"
   $$0 = $10;
   return ($$0|0); //@line 72957 "c/sqlite3.c"
  }
 }
 $11 = $3&65535; //@line 72948 "c/sqlite3.c"
 $12 = $11 & 16; //@line 72948 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 72948 "c/sqlite3.c"
 if ($13) {
  $20 = $11 & 1; //@line 72955 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 72955 "c/sqlite3.c"
  if (!($21)) {
   $$0 = 0;
   return ($$0|0); //@line 72957 "c/sqlite3.c"
  }
  $22 = (_valueBytes($0,$1)|0); //@line 72956 "c/sqlite3.c"
  $$0 = $22;
  return ($$0|0); //@line 72957 "c/sqlite3.c"
 } else {
  $14 = $11 & 16384; //@line 72949 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 72949 "c/sqlite3.c"
  $16 = ((($0)) + 12|0);
  $17 = HEAP32[$16>>2]|0;
  if ($15) {
   $$0 = $17;
   return ($$0|0); //@line 72957 "c/sqlite3.c"
  }
  $18 = HEAP32[$0>>2]|0; //@line 72950 "c/sqlite3.c"
  $19 = (($18) + ($17))|0; //@line 72950 "c/sqlite3.c"
  $$0 = $19;
  return ($$0|0); //@line 72957 "c/sqlite3.c"
 }
 return (0)|0;
}
function _valueBytes($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_valueToText($0,$1)|0); //@line 72940 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 72940 "c/sqlite3.c"
 if ($3) {
  $6 = 0;
  return ($6|0); //@line 72940 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0); //@line 72940 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 72940 "c/sqlite3.c"
 $6 = $5;
 return ($6|0); //@line 72940 "c/sqlite3.c"
}
function _valueToText($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 72257 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 72257 "c/sqlite3.c"
 $4 = $3&65535; //@line 72257 "c/sqlite3.c"
 $5 = $4 & 18; //@line 72257 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 72257 "c/sqlite3.c"
 if ($6) {
  (_sqlite3VdbeMemStringify($0,$1,0)|0); //@line 72271 "c/sqlite3.c"
 } else {
  $7 = $4 & 16384; //@line 72258 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 72258 "c/sqlite3.c"
  if (!($8)) {
   $9 = (_sqlite3VdbeMemExpandBlob($0)|0); //@line 72258 "c/sqlite3.c"
   $10 = ($9|0)==(0); //@line 72258 "c/sqlite3.c"
   if (!($10)) {
    $$0 = 0;
    return ($$0|0); //@line 72281 "c/sqlite3.c"
   }
  }
  $11 = HEAP16[$2>>1]|0; //@line 72259 "c/sqlite3.c"
  $12 = $11 | 2; //@line 72259 "c/sqlite3.c"
  HEAP16[$2>>1] = $12; //@line 72259 "c/sqlite3.c"
  $13 = ((($0)) + 10|0); //@line 72260 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 72260 "c/sqlite3.c"
  $15 = $14&255; //@line 72260 "c/sqlite3.c"
  $16 = $1&255; //@line 72260 "c/sqlite3.c"
  $17 = $16 & 247; //@line 72260 "c/sqlite3.c"
  $18 = ($17|0)==($15|0); //@line 72260 "c/sqlite3.c"
  if (!($18)) {
   (_sqlite3VdbeChangeEncoding($0,$17)|0); //@line 72261 "c/sqlite3.c"
  }
  $19 = $16 & 8; //@line 72263 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 72263 "c/sqlite3.c"
  if (!($20)) {
   $21 = ((($0)) + 16|0); //@line 72263 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 72263 "c/sqlite3.c"
   $23 = $22 & 1; //@line 72263 "c/sqlite3.c"
   $24 = ($23|0)==(0); //@line 72263 "c/sqlite3.c"
   if (!($24)) {
    $25 = (_sqlite3VdbeMemMakeWriteable($0)|0); //@line 72265 "c/sqlite3.c"
    $26 = ($25|0)==(0); //@line 72265 "c/sqlite3.c"
    if (!($26)) {
     $$0 = 0;
     return ($$0|0); //@line 72281 "c/sqlite3.c"
    }
   }
  }
  _sqlite3VdbeMemNulTerminate($0); //@line 72269 "c/sqlite3.c"
 }
 $27 = ((($0)) + 10|0); //@line 72276 "c/sqlite3.c"
 $28 = HEAP8[$27>>0]|0; //@line 72276 "c/sqlite3.c"
 $29 = $1 & -9; //@line 72276 "c/sqlite3.c"
 $30 = ($28<<24>>24)==($29<<24>>24); //@line 72276 "c/sqlite3.c"
 if (!($30)) {
  $$0 = 0;
  return ($$0|0); //@line 72281 "c/sqlite3.c"
 }
 $31 = ((($0)) + 16|0); //@line 72277 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 72277 "c/sqlite3.c"
 $$0 = $32;
 return ($$0|0); //@line 72281 "c/sqlite3.c"
}
function _sqlite3VdbeChangeEncoding($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 71307 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 71307 "c/sqlite3.c"
 $4 = $3 & 2; //@line 71307 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 71307 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 71324 "c/sqlite3.c"
 }
 $6 = ((($0)) + 10|0); //@line 71307 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 71307 "c/sqlite3.c"
 $8 = $7&255; //@line 71307 "c/sqlite3.c"
 $9 = ($8|0)==($1|0); //@line 71307 "c/sqlite3.c"
 if ($9) {
  $$0 = 0;
  return ($$0|0); //@line 71324 "c/sqlite3.c"
 }
 $10 = $1&255; //@line 71318 "c/sqlite3.c"
 $11 = (_sqlite3VdbeMemTranslate($0,$10)|0); //@line 71318 "c/sqlite3.c"
 $$0 = $11;
 return ($$0|0); //@line 71324 "c/sqlite3.c"
}
function _sqlite3VdbeMemNulTerminate($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71476 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71476 "c/sqlite3.c"
 $3 = $2 & 514; //@line 71476 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(2); //@line 71476 "c/sqlite3.c"
 if (!($4)) {
  return;
 }
 (_vdbeMemAddTerminator($0)|0); //@line 71479 "c/sqlite3.c"
 return;
}
function _sqlite3VdbeMemStringify($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 71497 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 71497 "c/sqlite3.c"
 $3 = ((($0)) + 8|0); //@line 71498 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 71498 "c/sqlite3.c"
 $5 = (_sqlite3VdbeMemClearAndResize($0,32)|0); //@line 71509 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 71509 "c/sqlite3.c"
 if (!($6)) {
  $7 = ((($0)) + 10|0); //@line 71510 "c/sqlite3.c"
  HEAP8[$7>>0] = 0; //@line 71510 "c/sqlite3.c"
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 71532 "c/sqlite3.c"
 }
 $8 = $4 & 4; //@line 71520 "c/sqlite3.c"
 $9 = ($8<<16>>16)==(0); //@line 71520 "c/sqlite3.c"
 $10 = ((($0)) + 16|0);
 $11 = HEAP32[$10>>2]|0;
 if ($9) {
  $22 = +HEAPF64[$0>>3]; //@line 71524 "c/sqlite3.c"
  HEAPF64[$vararg_buffer1>>3] = $22; //@line 71524 "c/sqlite3.c"
  (_sqlite3_snprintf(32,$11,17154,$vararg_buffer1)|0); //@line 71524 "c/sqlite3.c"
 } else {
  $12 = $0; //@line 71521 "c/sqlite3.c"
  $13 = $12; //@line 71521 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 71521 "c/sqlite3.c"
  $15 = (($12) + 4)|0; //@line 71521 "c/sqlite3.c"
  $16 = $15; //@line 71521 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 71521 "c/sqlite3.c"
  $18 = $vararg_buffer; //@line 71521 "c/sqlite3.c"
  $19 = $18; //@line 71521 "c/sqlite3.c"
  HEAP32[$19>>2] = $14; //@line 71521 "c/sqlite3.c"
  $20 = (($18) + 4)|0; //@line 71521 "c/sqlite3.c"
  $21 = $20; //@line 71521 "c/sqlite3.c"
  HEAP32[$21>>2] = $17; //@line 71521 "c/sqlite3.c"
  (_sqlite3_snprintf(32,$11,17149,$vararg_buffer)|0); //@line 71521 "c/sqlite3.c"
 }
 $23 = HEAP32[$10>>2]|0; //@line 71526 "c/sqlite3.c"
 $24 = (_sqlite3Strlen30($23)|0); //@line 71526 "c/sqlite3.c"
 $25 = ((($0)) + 12|0); //@line 71526 "c/sqlite3.c"
 HEAP32[$25>>2] = $24; //@line 71526 "c/sqlite3.c"
 $26 = ((($0)) + 10|0); //@line 71527 "c/sqlite3.c"
 HEAP8[$26>>0] = 1; //@line 71527 "c/sqlite3.c"
 $27 = HEAP16[$3>>1]|0; //@line 71528 "c/sqlite3.c"
 $28 = $27 | 514; //@line 71528 "c/sqlite3.c"
 $29 = ($2<<24>>24)==(0); //@line 71529 "c/sqlite3.c"
 $30 = $28 & -13; //@line 71529 "c/sqlite3.c"
 $spec$select = $29 ? $28 : $30; //@line 71529 "c/sqlite3.c"
 HEAP16[$3>>1] = $spec$select;
 $31 = $1&255; //@line 71530 "c/sqlite3.c"
 (_sqlite3VdbeChangeEncoding($0,$31)|0); //@line 71530 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 71532 "c/sqlite3.c"
}
function _sqlite3VdbeMemTranslate($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0192 = 0, $$0194269 = 0, $$0196$lcssa = 0, $$0196241 = 0, $$0202249 = 0, $$1 = 0, $$10 = 0, $$10212 = 0, $$1195250 = 0, $$1197227 = 0, $$2$lcssa = 0, $$2198$lcssa = 0, $$2198$lcssa$sink = 0, $$2198253 = 0, $$2204261 = 0, $$2242 = 0, $$3199233 = 0, $$3228 = 0, $$3229 = 0, $$4200 = 0;
 var $$4206 = 0, $$4262 = 0, $$5$lcssa = 0, $$5201 = 0, $$5207265 = 0, $$5207265$sink = 0, $$5207265$sink302 = 0, $$5254 = 0, $$6234 = 0, $$6235 = 0, $$7209239 = 0, $$7209239$sink = 0, $$7209239$sink308 = 0, $$7266 = 0, $$8 = 0, $$9211 = 0, $$9240 = 0, $$masked = 0, $$masked213 = 0, $$sink277 = 0;
 var $$sink278 = 0, $$sink279 = 0, $$sink281 = 0, $$sink282 = 0, $$sink283 = 0, $$sink284 = 0, $$sink285 = 0, $$sink286 = 0, $$sink286$ph = 0, $$sink286$ph$ph = 0, $$sink287 = 0, $$sink288 = 0, $$sink289 = 0, $$sink289$ph = 0, $$sink289$ph$ph = 0, $$sink290 = 0, $$sink291 = 0, $$sink291$ph = 0, $$sink293 = 0, $$sink295 = 0;
 var $$sink297 = 0, $$sink297$ph = 0, $$sink299 = 0, $$sink301 = 0, $$sink303 = 0, $$sink305 = 0, $$sink307 = 0, $$sink309 = 0, $$sink311 = 0, $$sink313 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0;
 var $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0;
 var $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0;
 var $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0;
 var $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0;
 var $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0;
 var $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0;
 var $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0;
 var $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0;
 var $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond216 = 0, $or$cond218 = 0;
 var $or$cond221 = 0, $or$cond223 = 0, $or$cond224 = 0, $or$cond225 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 10|0); //@line 28161 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 28161 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(1); //@line 28161 "c/sqlite3.c"
 $5 = ($1<<24>>24)==(1); //@line 28161 "c/sqlite3.c"
 $or$cond = $5 | $4; //@line 28161 "c/sqlite3.c"
 if (!($or$cond)) {
  $6 = (_sqlite3VdbeMemMakeWriteable($0)|0); //@line 28164 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 28165 "c/sqlite3.c"
  if (!($7)) {
   $$1 = 7;
   return ($$1|0); //@line 28267 "c/sqlite3.c"
  }
  $8 = ((($0)) + 16|0); //@line 28169 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 28169 "c/sqlite3.c"
  $10 = ((($0)) + 12|0); //@line 28170 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 28170 "c/sqlite3.c"
  $12 = $11 & -2; //@line 28170 "c/sqlite3.c"
  $13 = (($9) + ($12)|0); //@line 28170 "c/sqlite3.c"
  $14 = ($12|0)>(0); //@line 28171 "c/sqlite3.c"
  if ($14) {
   $$0194269 = $9;
   while(1) {
    $15 = HEAP8[$$0194269>>0]|0; //@line 28172 "c/sqlite3.c"
    $16 = ((($$0194269)) + 1|0); //@line 28173 "c/sqlite3.c"
    $17 = HEAP8[$16>>0]|0; //@line 28173 "c/sqlite3.c"
    HEAP8[$$0194269>>0] = $17; //@line 28173 "c/sqlite3.c"
    $18 = ((($$0194269)) + 2|0); //@line 28175 "c/sqlite3.c"
    HEAP8[$16>>0] = $15; //@line 28175 "c/sqlite3.c"
    $19 = ($18>>>0)<($13>>>0); //@line 28171 "c/sqlite3.c"
    if ($19) {
     $$0194269 = $18;
    } else {
     break;
    }
   }
  }
  HEAP8[$2>>0] = $1; //@line 28177 "c/sqlite3.c"
  $$1 = 0;
  return ($$1|0); //@line 28267 "c/sqlite3.c"
 }
 $20 = ((($0)) + 12|0);
 $21 = HEAP32[$20>>2]|0;
 if ($5) {
  $22 = $21 & -2; //@line 28188 "c/sqlite3.c"
  HEAP32[$20>>2] = $22; //@line 28188 "c/sqlite3.c"
  $23 = $22 << 1; //@line 28189 "c/sqlite3.c"
  $24 = $23 | 1; //@line 28189 "c/sqlite3.c"
  $$0192 = $24;$30 = $22;
 } else {
  $25 = $21 << 1; //@line 28196 "c/sqlite3.c"
  $26 = (($25) + 2)|0; //@line 28196 "c/sqlite3.c"
  $$0192 = $26;$30 = $21;
 }
 $27 = ((($0)) + 16|0); //@line 28205 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 28205 "c/sqlite3.c"
 $29 = (($28) + ($30)|0); //@line 28206 "c/sqlite3.c"
 $31 = ((($0)) + 32|0); //@line 28207 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 28207 "c/sqlite3.c"
 $33 = ($$0192|0)<(0); //@line 28207 "c/sqlite3.c"
 $34 = $33 << 31 >> 31; //@line 28207 "c/sqlite3.c"
 $35 = (_sqlite3DbMallocRaw($32,$$0192,$34)|0); //@line 28207 "c/sqlite3.c"
 $36 = ($35|0)==(0|0); //@line 28208 "c/sqlite3.c"
 if ($36) {
  $$1 = 7;
  return ($$1|0); //@line 28267 "c/sqlite3.c"
 }
 $37 = HEAP8[$2>>0]|0; //@line 28213 "c/sqlite3.c"
 switch ($37<<24>>24) {
 case 1:  {
  $38 = ($1<<24>>24)==(2); //@line 28214 "c/sqlite3.c"
  $39 = ($30|0)>(0);
  if ($38) {
   if ($39) {
    $$0202249 = $35;$$1195250 = $28;
    while(1) {
     $40 = ((($$1195250)) + 1|0); //@line 28217 "c/sqlite3.c"
     $41 = HEAP8[$$1195250>>0]|0; //@line 28217 "c/sqlite3.c"
     $42 = $41&255; //@line 28217 "c/sqlite3.c"
     $43 = ($41&255)>(191); //@line 28217 "c/sqlite3.c"
     if ($43) {
      $44 = (($42) + -192)|0; //@line 28217 "c/sqlite3.c"
      $45 = (17085 + ($44)|0); //@line 28217 "c/sqlite3.c"
      $46 = HEAP8[$45>>0]|0; //@line 28217 "c/sqlite3.c"
      $47 = $46&255; //@line 28217 "c/sqlite3.c"
      $48 = ($40|0)==($29|0); //@line 28217 "c/sqlite3.c"
      L45: do {
       if ($48) {
        $$0196$lcssa = $47;$$2$lcssa = $40;
       } else {
        $$0196241 = $47;$$2242 = $40;
        while(1) {
         $49 = HEAP8[$$2242>>0]|0; //@line 28217 "c/sqlite3.c"
         $50 = $49 & -64; //@line 28217 "c/sqlite3.c"
         $51 = ($50<<24>>24)==(-128); //@line 28217 "c/sqlite3.c"
         if (!($51)) {
          $$0196$lcssa = $$0196241;$$2$lcssa = $$2242;
          break L45;
         }
         $52 = $$0196241 << 6; //@line 28217 "c/sqlite3.c"
         $53 = ((($$2242)) + 1|0); //@line 28217 "c/sqlite3.c"
         $54 = $49 & 63; //@line 28217 "c/sqlite3.c"
         $55 = $54&255; //@line 28217 "c/sqlite3.c"
         $56 = $52 | $55; //@line 28217 "c/sqlite3.c"
         $57 = ($53|0)==($29|0); //@line 28217 "c/sqlite3.c"
         if ($57) {
          $$0196$lcssa = $56;$$2$lcssa = $53;
          break;
         } else {
          $$0196241 = $56;$$2242 = $53;
         }
        }
       }
      } while(0);
      $58 = ($$0196$lcssa>>>0)<(128); //@line 28217 "c/sqlite3.c"
      $59 = $$0196$lcssa & -2048; //@line 28217 "c/sqlite3.c"
      $60 = ($59|0)==(55296); //@line 28217 "c/sqlite3.c"
      $or$cond216 = $58 | $60; //@line 28217 "c/sqlite3.c"
      $61 = $$0196$lcssa & -2; //@line 28217 "c/sqlite3.c"
      $62 = ($61|0)==(65534); //@line 28217 "c/sqlite3.c"
      $or$cond218 = $62 | $or$cond216; //@line 28217 "c/sqlite3.c"
      if ($or$cond218) {
       $$1197227 = 65533;$$3229 = $$2$lcssa;
       label = 22;
      } else {
       $63 = ($$0196$lcssa>>>0)<(65536); //@line 28218 "c/sqlite3.c"
       if ($63) {
        $$1197227 = $$0196$lcssa;$$3229 = $$2$lcssa;
        label = 22;
       } else {
        $67 = $$0196$lcssa >>> 10; //@line 28218 "c/sqlite3.c"
        $68 = $67 & 63; //@line 28218 "c/sqlite3.c"
        $69 = (($$0196$lcssa) + -65536)|0; //@line 28218 "c/sqlite3.c"
        $70 = $69 >>> 10; //@line 28218 "c/sqlite3.c"
        $71 = $70 & 192; //@line 28218 "c/sqlite3.c"
        $72 = $71 | $68; //@line 28218 "c/sqlite3.c"
        $73 = $72&255; //@line 28218 "c/sqlite3.c"
        $74 = ((($$0202249)) + 1|0); //@line 28218 "c/sqlite3.c"
        HEAP8[$$0202249>>0] = $73; //@line 28218 "c/sqlite3.c"
        $75 = $69 >>> 18; //@line 28218 "c/sqlite3.c"
        $76 = $75 & 3; //@line 28218 "c/sqlite3.c"
        $77 = $76 | 216; //@line 28218 "c/sqlite3.c"
        $78 = $77&255; //@line 28218 "c/sqlite3.c"
        $79 = ((($$0202249)) + 2|0); //@line 28218 "c/sqlite3.c"
        HEAP8[$74>>0] = $78; //@line 28218 "c/sqlite3.c"
        $80 = $$0196$lcssa&255; //@line 28218 "c/sqlite3.c"
        $81 = ((($$0202249)) + 3|0); //@line 28218 "c/sqlite3.c"
        HEAP8[$79>>0] = $80; //@line 28218 "c/sqlite3.c"
        $82 = $$0196$lcssa >>> 8; //@line 28218 "c/sqlite3.c"
        $83 = $82 & 3; //@line 28218 "c/sqlite3.c"
        $84 = $83 | 220; //@line 28218 "c/sqlite3.c"
        $$3228 = $$2$lcssa;$$sink277 = $81;$$sink278 = 4;$$sink279 = $84;
       }
      }
     } else {
      $$1197227 = $42;$$3229 = $40;
      label = 22;
     }
     if ((label|0) == 22) {
      label = 0;
      $64 = $$1197227&255; //@line 28218 "c/sqlite3.c"
      $65 = ((($$0202249)) + 1|0); //@line 28218 "c/sqlite3.c"
      HEAP8[$$0202249>>0] = $64; //@line 28218 "c/sqlite3.c"
      $66 = $$1197227 >>> 8; //@line 28218 "c/sqlite3.c"
      $$3228 = $$3229;$$sink277 = $65;$$sink278 = 2;$$sink279 = $66;
     }
     $85 = $$sink279&255; //@line 28218 "c/sqlite3.c"
     $86 = (($$0202249) + ($$sink278)|0); //@line 28218 "c/sqlite3.c"
     HEAP8[$$sink277>>0] = $85; //@line 28218 "c/sqlite3.c"
     $87 = ($$3228>>>0)<($29>>>0); //@line 28216 "c/sqlite3.c"
     if ($87) {
      $$0202249 = $86;$$1195250 = $$3228;
     } else {
      $$4206 = $86;
      break;
     }
    }
   } else {
    $$4206 = $35;
   }
  } else {
   if ($39) {
    $$2204261 = $35;$$4262 = $28;
    while(1) {
     $88 = ((($$4262)) + 1|0); //@line 28224 "c/sqlite3.c"
     $89 = HEAP8[$$4262>>0]|0; //@line 28224 "c/sqlite3.c"
     $90 = $89&255; //@line 28224 "c/sqlite3.c"
     $91 = ($89&255)>(191); //@line 28224 "c/sqlite3.c"
     if ($91) {
      $92 = (($90) + -192)|0; //@line 28224 "c/sqlite3.c"
      $93 = (17085 + ($92)|0); //@line 28224 "c/sqlite3.c"
      $94 = HEAP8[$93>>0]|0; //@line 28224 "c/sqlite3.c"
      $95 = $94&255; //@line 28224 "c/sqlite3.c"
      $96 = ($88|0)==($29|0); //@line 28224 "c/sqlite3.c"
      L62: do {
       if ($96) {
        $$2198$lcssa = $95;$$5$lcssa = $88;
       } else {
        $$2198253 = $95;$$5254 = $88;
        while(1) {
         $97 = HEAP8[$$5254>>0]|0; //@line 28224 "c/sqlite3.c"
         $98 = $97 & -64; //@line 28224 "c/sqlite3.c"
         $99 = ($98<<24>>24)==(-128); //@line 28224 "c/sqlite3.c"
         if (!($99)) {
          $$2198$lcssa = $$2198253;$$5$lcssa = $$5254;
          break L62;
         }
         $100 = $$2198253 << 6; //@line 28224 "c/sqlite3.c"
         $101 = ((($$5254)) + 1|0); //@line 28224 "c/sqlite3.c"
         $102 = $97 & 63; //@line 28224 "c/sqlite3.c"
         $103 = $102&255; //@line 28224 "c/sqlite3.c"
         $104 = $100 | $103; //@line 28224 "c/sqlite3.c"
         $105 = ($101|0)==($29|0); //@line 28224 "c/sqlite3.c"
         if ($105) {
          $$2198$lcssa = $104;$$5$lcssa = $101;
          break;
         } else {
          $$2198253 = $104;$$5254 = $101;
         }
        }
       }
      } while(0);
      $106 = ($$2198$lcssa>>>0)<(128); //@line 28224 "c/sqlite3.c"
      $107 = $$2198$lcssa & -2048; //@line 28224 "c/sqlite3.c"
      $108 = ($107|0)==(55296); //@line 28224 "c/sqlite3.c"
      $or$cond221 = $106 | $108; //@line 28224 "c/sqlite3.c"
      $109 = $$2198$lcssa & -2; //@line 28224 "c/sqlite3.c"
      $110 = ($109|0)==(65534); //@line 28224 "c/sqlite3.c"
      $or$cond223 = $110 | $or$cond221; //@line 28224 "c/sqlite3.c"
      if ($or$cond223) {
       $$3199233 = 65533;$$6235 = $$5$lcssa;
       label = 34;
      } else {
       $111 = ($$2198$lcssa>>>0)<(65536); //@line 28225 "c/sqlite3.c"
       if ($111) {
        $$3199233 = $$2198$lcssa;$$6235 = $$5$lcssa;
        label = 34;
       } else {
        $113 = (($$2198$lcssa) + -65536)|0; //@line 28225 "c/sqlite3.c"
        $114 = $113 >>> 18; //@line 28225 "c/sqlite3.c"
        $115 = $114 & 3; //@line 28225 "c/sqlite3.c"
        $116 = $115 | 216; //@line 28225 "c/sqlite3.c"
        $117 = $116&255; //@line 28225 "c/sqlite3.c"
        $118 = ((($$2204261)) + 1|0); //@line 28225 "c/sqlite3.c"
        HEAP8[$$2204261>>0] = $117; //@line 28225 "c/sqlite3.c"
        $119 = $$2198$lcssa >>> 10; //@line 28225 "c/sqlite3.c"
        $120 = $119 & 63; //@line 28225 "c/sqlite3.c"
        $121 = $113 >>> 10; //@line 28225 "c/sqlite3.c"
        $122 = $121 & 192; //@line 28225 "c/sqlite3.c"
        $123 = $122 | $120; //@line 28225 "c/sqlite3.c"
        $124 = $123&255; //@line 28225 "c/sqlite3.c"
        $125 = ((($$2204261)) + 2|0); //@line 28225 "c/sqlite3.c"
        HEAP8[$118>>0] = $124; //@line 28225 "c/sqlite3.c"
        $126 = $$2198$lcssa >>> 8; //@line 28225 "c/sqlite3.c"
        $127 = $126 & 3; //@line 28225 "c/sqlite3.c"
        $128 = $127 | 220; //@line 28225 "c/sqlite3.c"
        $$2198$lcssa$sink = $$2198$lcssa;$$6234 = $$5$lcssa;$$sink281 = 4;$$sink282 = $125;$$sink283 = 3;$$sink284 = $128;
       }
      }
     } else {
      $$3199233 = $90;$$6235 = $88;
      label = 34;
     }
     if ((label|0) == 34) {
      label = 0;
      $112 = $$3199233 >>> 8; //@line 28225 "c/sqlite3.c"
      $$2198$lcssa$sink = $$3199233;$$6234 = $$6235;$$sink281 = 2;$$sink282 = $$2204261;$$sink283 = 1;$$sink284 = $112;
     }
     $129 = $$sink284&255; //@line 28225 "c/sqlite3.c"
     $130 = (($$2204261) + ($$sink283)|0); //@line 28225 "c/sqlite3.c"
     HEAP8[$$sink282>>0] = $129; //@line 28225 "c/sqlite3.c"
     $131 = $$2198$lcssa$sink&255; //@line 28225 "c/sqlite3.c"
     $132 = (($$2204261) + ($$sink281)|0); //@line 28225 "c/sqlite3.c"
     HEAP8[$130>>0] = $131; //@line 28225 "c/sqlite3.c"
     $133 = ($$6234>>>0)<($29>>>0); //@line 28223 "c/sqlite3.c"
     if ($133) {
      $$2204261 = $132;$$4262 = $$6234;
     } else {
      $$4206 = $132;
      break;
     }
    }
   } else {
    $$4206 = $35;
   }
  }
  $134 = $$4206; //@line 28228 "c/sqlite3.c"
  $135 = $35; //@line 28228 "c/sqlite3.c"
  $136 = (($134) - ($135))|0; //@line 28228 "c/sqlite3.c"
  HEAP32[$20>>2] = $136; //@line 28228 "c/sqlite3.c"
  $137 = ((($$4206)) + 1|0); //@line 28229 "c/sqlite3.c"
  HEAP8[$$4206>>0] = 0; //@line 28229 "c/sqlite3.c"
  $$10212 = $137;
  break;
 }
 case 2:  {
  $138 = ($30|0)>(0); //@line 28234 "c/sqlite3.c"
  if ($138) {
   $$5207265 = $35;$$7266 = $28;
   while(1) {
    $139 = ((($$7266)) + 1|0); //@line 28235 "c/sqlite3.c"
    $140 = HEAP8[$$7266>>0]|0; //@line 28235 "c/sqlite3.c"
    $141 = $140&255; //@line 28235 "c/sqlite3.c"
    $142 = ((($$7266)) + 2|0); //@line 28235 "c/sqlite3.c"
    $143 = HEAP8[$139>>0]|0; //@line 28235 "c/sqlite3.c"
    $144 = $143&255; //@line 28235 "c/sqlite3.c"
    $145 = $144 << 8; //@line 28235 "c/sqlite3.c"
    $146 = $145 | $141; //@line 28235 "c/sqlite3.c"
    $147 = $144 & 248; //@line 28235 "c/sqlite3.c"
    $148 = ($147|0)==(216); //@line 28235 "c/sqlite3.c"
    $149 = ($142>>>0)<($29>>>0); //@line 28235 "c/sqlite3.c"
    $or$cond224 = $149 & $148; //@line 28235 "c/sqlite3.c"
    if ($or$cond224) {
     $150 = ((($$7266)) + 3|0); //@line 28235 "c/sqlite3.c"
     $151 = HEAP8[$142>>0]|0; //@line 28235 "c/sqlite3.c"
     $152 = $151&255; //@line 28235 "c/sqlite3.c"
     $153 = ((($$7266)) + 4|0); //@line 28235 "c/sqlite3.c"
     $154 = HEAP8[$150>>0]|0; //@line 28235 "c/sqlite3.c"
     $155 = $154&255; //@line 28235 "c/sqlite3.c"
     $156 = $155 << 8; //@line 28235 "c/sqlite3.c"
     $$masked213 = $156 & 768; //@line 28235 "c/sqlite3.c"
     $157 = $141 << 10; //@line 28235 "c/sqlite3.c"
     $158 = $157 & 64512; //@line 28235 "c/sqlite3.c"
     $159 = $146 << 10; //@line 28235 "c/sqlite3.c"
     $160 = $159 & 983040; //@line 28235 "c/sqlite3.c"
     $161 = (($160) + 65536)|0; //@line 28235 "c/sqlite3.c"
     $162 = $161 | $158; //@line 28235 "c/sqlite3.c"
     $163 = $162 | $152; //@line 28235 "c/sqlite3.c"
     $164 = $163 | $$masked213; //@line 28235 "c/sqlite3.c"
     $$4200 = $164;$$8 = $153;
    } else {
     $$4200 = $146;$$8 = $142;
    }
    $165 = ($$4200>>>0)<(128); //@line 28236 "c/sqlite3.c"
    if ($165) {
     $$sink285 = $$5207265;$$sink286 = 1;$$sink287 = $$4200;
    } else {
     $166 = ($$4200>>>0)<(2048); //@line 28236 "c/sqlite3.c"
     if ($166) {
      $$5207265$sink = $$5207265;$$sink286$ph = 2;$$sink291 = 1;$$sink293 = 192;$$sink295 = 31;
     } else {
      $167 = ($$4200>>>0)<(65536); //@line 28236 "c/sqlite3.c"
      if ($167) {
       $$5207265$sink302 = $$5207265;$$sink286$ph$ph = 3;$$sink291$ph = 2;$$sink303 = 1;$$sink305 = 224;$$sink307 = 15;
      } else {
       $168 = $$4200 >>> 18; //@line 28236 "c/sqlite3.c"
       $169 = $168 & 7; //@line 28236 "c/sqlite3.c"
       $170 = $169 | 240; //@line 28236 "c/sqlite3.c"
       $171 = $170&255; //@line 28236 "c/sqlite3.c"
       $172 = ((($$5207265)) + 1|0); //@line 28236 "c/sqlite3.c"
       HEAP8[$$5207265>>0] = $171; //@line 28236 "c/sqlite3.c"
       $$5207265$sink302 = $172;$$sink286$ph$ph = 4;$$sink291$ph = 3;$$sink303 = 2;$$sink305 = 128;$$sink307 = 63;
      }
      $173 = $$4200 >>> 12; //@line 28236 "c/sqlite3.c"
      $174 = $173 & $$sink307; //@line 28236 "c/sqlite3.c"
      $175 = $174 | $$sink305; //@line 28236 "c/sqlite3.c"
      $176 = $175&255; //@line 28236 "c/sqlite3.c"
      $177 = (($$5207265) + ($$sink303)|0); //@line 28236 "c/sqlite3.c"
      HEAP8[$$5207265$sink302>>0] = $176; //@line 28236 "c/sqlite3.c"
      $$5207265$sink = $177;$$sink286$ph = $$sink286$ph$ph;$$sink291 = $$sink291$ph;$$sink293 = 128;$$sink295 = 63;
     }
     $178 = $$4200 >>> 6; //@line 28236 "c/sqlite3.c"
     $179 = $178 & $$sink295; //@line 28236 "c/sqlite3.c"
     $180 = $179 | $$sink293; //@line 28236 "c/sqlite3.c"
     $181 = $180&255; //@line 28236 "c/sqlite3.c"
     $182 = (($$5207265) + ($$sink291)|0); //@line 28236 "c/sqlite3.c"
     HEAP8[$$5207265$sink>>0] = $181; //@line 28236 "c/sqlite3.c"
     $183 = $$4200 & 63; //@line 28236 "c/sqlite3.c"
     $184 = $183 | 128; //@line 28236 "c/sqlite3.c"
     $$sink285 = $182;$$sink286 = $$sink286$ph;$$sink287 = $184;
    }
    $185 = $$sink287&255; //@line 28236 "c/sqlite3.c"
    $186 = (($$5207265) + ($$sink286)|0); //@line 28236 "c/sqlite3.c"
    HEAP8[$$sink285>>0] = $185; //@line 28236 "c/sqlite3.c"
    $187 = ($$8>>>0)<($29>>>0); //@line 28234 "c/sqlite3.c"
    if ($187) {
     $$5207265 = $186;$$7266 = $$8;
    } else {
     $$9211 = $186;
     label = 60;
     break;
    }
   }
  } else {
   $$9211 = $35;
   label = 60;
  }
  break;
 }
 default: {
  $188 = ($30|0)>(0); //@line 28240 "c/sqlite3.c"
  if ($188) {
   $$7209239 = $35;$$9240 = $28;
   while(1) {
    $189 = ((($$9240)) + 1|0); //@line 28241 "c/sqlite3.c"
    $190 = HEAP8[$$9240>>0]|0; //@line 28241 "c/sqlite3.c"
    $191 = $190&255; //@line 28241 "c/sqlite3.c"
    $192 = $191 << 8; //@line 28241 "c/sqlite3.c"
    $193 = ((($$9240)) + 2|0); //@line 28241 "c/sqlite3.c"
    $194 = HEAP8[$189>>0]|0; //@line 28241 "c/sqlite3.c"
    $195 = $194&255; //@line 28241 "c/sqlite3.c"
    $196 = $192 | $195; //@line 28241 "c/sqlite3.c"
    $197 = $191 & 248; //@line 28241 "c/sqlite3.c"
    $198 = ($197|0)==(216); //@line 28241 "c/sqlite3.c"
    $199 = ($193>>>0)<($29>>>0); //@line 28241 "c/sqlite3.c"
    $or$cond225 = $199 & $198; //@line 28241 "c/sqlite3.c"
    if ($or$cond225) {
     $200 = ((($$9240)) + 3|0); //@line 28241 "c/sqlite3.c"
     $201 = HEAP8[$193>>0]|0; //@line 28241 "c/sqlite3.c"
     $202 = $201&255; //@line 28241 "c/sqlite3.c"
     $203 = $202 << 8; //@line 28241 "c/sqlite3.c"
     $204 = ((($$9240)) + 4|0); //@line 28241 "c/sqlite3.c"
     $205 = HEAP8[$200>>0]|0; //@line 28241 "c/sqlite3.c"
     $206 = $205&255; //@line 28241 "c/sqlite3.c"
     $$masked = $203 & 768; //@line 28241 "c/sqlite3.c"
     $207 = $195 << 10; //@line 28241 "c/sqlite3.c"
     $208 = $207 & 64512; //@line 28241 "c/sqlite3.c"
     $209 = $196 << 10; //@line 28241 "c/sqlite3.c"
     $210 = $209 & 983040; //@line 28241 "c/sqlite3.c"
     $211 = (($210) + 65536)|0; //@line 28241 "c/sqlite3.c"
     $212 = $211 | $208; //@line 28241 "c/sqlite3.c"
     $213 = $212 | $206; //@line 28241 "c/sqlite3.c"
     $214 = $213 | $$masked; //@line 28241 "c/sqlite3.c"
     $$10 = $204;$$5201 = $214;
    } else {
     $$10 = $193;$$5201 = $196;
    }
    $215 = ($$5201>>>0)<(128); //@line 28242 "c/sqlite3.c"
    if ($215) {
     $$sink288 = $$7209239;$$sink289 = 1;$$sink290 = $$5201;
    } else {
     $216 = ($$5201>>>0)<(2048); //@line 28242 "c/sqlite3.c"
     if ($216) {
      $$7209239$sink = $$7209239;$$sink289$ph = 2;$$sink297 = 1;$$sink299 = 192;$$sink301 = 31;
     } else {
      $217 = ($$5201>>>0)<(65536); //@line 28242 "c/sqlite3.c"
      if ($217) {
       $$7209239$sink308 = $$7209239;$$sink289$ph$ph = 3;$$sink297$ph = 2;$$sink309 = 1;$$sink311 = 224;$$sink313 = 15;
      } else {
       $218 = $$5201 >>> 18; //@line 28242 "c/sqlite3.c"
       $219 = $218 & 7; //@line 28242 "c/sqlite3.c"
       $220 = $219 | 240; //@line 28242 "c/sqlite3.c"
       $221 = $220&255; //@line 28242 "c/sqlite3.c"
       $222 = ((($$7209239)) + 1|0); //@line 28242 "c/sqlite3.c"
       HEAP8[$$7209239>>0] = $221; //@line 28242 "c/sqlite3.c"
       $$7209239$sink308 = $222;$$sink289$ph$ph = 4;$$sink297$ph = 3;$$sink309 = 2;$$sink311 = 128;$$sink313 = 63;
      }
      $223 = $$5201 >>> 12; //@line 28242 "c/sqlite3.c"
      $224 = $223 & $$sink313; //@line 28242 "c/sqlite3.c"
      $225 = $224 | $$sink311; //@line 28242 "c/sqlite3.c"
      $226 = $225&255; //@line 28242 "c/sqlite3.c"
      $227 = (($$7209239) + ($$sink309)|0); //@line 28242 "c/sqlite3.c"
      HEAP8[$$7209239$sink308>>0] = $226; //@line 28242 "c/sqlite3.c"
      $$7209239$sink = $227;$$sink289$ph = $$sink289$ph$ph;$$sink297 = $$sink297$ph;$$sink299 = 128;$$sink301 = 63;
     }
     $228 = $$5201 >>> 6; //@line 28242 "c/sqlite3.c"
     $229 = $228 & $$sink301; //@line 28242 "c/sqlite3.c"
     $230 = $229 | $$sink299; //@line 28242 "c/sqlite3.c"
     $231 = $230&255; //@line 28242 "c/sqlite3.c"
     $232 = (($$7209239) + ($$sink297)|0); //@line 28242 "c/sqlite3.c"
     HEAP8[$$7209239$sink>>0] = $231; //@line 28242 "c/sqlite3.c"
     $233 = $$5201 & 63; //@line 28242 "c/sqlite3.c"
     $234 = $233 | 128; //@line 28242 "c/sqlite3.c"
     $$sink288 = $232;$$sink289 = $$sink289$ph;$$sink290 = $234;
    }
    $235 = $$sink290&255; //@line 28242 "c/sqlite3.c"
    $236 = (($$7209239) + ($$sink289)|0); //@line 28242 "c/sqlite3.c"
    HEAP8[$$sink288>>0] = $235; //@line 28242 "c/sqlite3.c"
    $237 = ($$10>>>0)<($29>>>0); //@line 28240 "c/sqlite3.c"
    if ($237) {
     $$7209239 = $236;$$9240 = $$10;
    } else {
     $$9211 = $236;
     label = 60;
     break;
    }
   }
  } else {
   $$9211 = $35;
   label = 60;
  }
 }
 }
 if ((label|0) == 60) {
  $238 = $$9211; //@line 28245 "c/sqlite3.c"
  $239 = $35; //@line 28245 "c/sqlite3.c"
  $240 = (($238) - ($239))|0; //@line 28245 "c/sqlite3.c"
  HEAP32[$20>>2] = $240; //@line 28245 "c/sqlite3.c"
  $$10212 = $$9211;
 }
 HEAP8[$$10212>>0] = 0; //@line 28247 "c/sqlite3.c"
 $241 = ((($0)) + 8|0); //@line 28250 "c/sqlite3.c"
 $242 = HEAP16[$241>>1]|0; //@line 28250 "c/sqlite3.c"
 _sqlite3VdbeMemRelease($0); //@line 28251 "c/sqlite3.c"
 $243 = $242 & -32739; //@line 28252 "c/sqlite3.c"
 $244 = $243 | 514; //@line 28252 "c/sqlite3.c"
 HEAP16[$241>>1] = $244; //@line 28252 "c/sqlite3.c"
 HEAP8[$2>>0] = $1; //@line 28253 "c/sqlite3.c"
 HEAP32[$27>>2] = $35; //@line 28254 "c/sqlite3.c"
 $245 = ((($0)) + 20|0); //@line 28255 "c/sqlite3.c"
 HEAP32[$245>>2] = $35; //@line 28255 "c/sqlite3.c"
 $246 = HEAP32[$31>>2]|0; //@line 28256 "c/sqlite3.c"
 $247 = (_sqlite3DbMallocSize($246,$35)|0); //@line 28256 "c/sqlite3.c"
 $248 = ((($0)) + 24|0); //@line 28256 "c/sqlite3.c"
 HEAP32[$248>>2] = $247; //@line 28256 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 28267 "c/sqlite3.c"
}
function _sqlite3ValueText($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 72294 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 72305 "c/sqlite3.c"
 }
 $3 = ((($0)) + 8|0); //@line 72298 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 72298 "c/sqlite3.c"
 $5 = $4 & 514; //@line 72298 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(514); //@line 72298 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 10|0); //@line 72298 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 72298 "c/sqlite3.c"
  $9 = ($8<<24>>24)==($1<<24>>24); //@line 72298 "c/sqlite3.c"
  if ($9) {
   $10 = ((($0)) + 16|0); //@line 72299 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 72299 "c/sqlite3.c"
   $$0 = $11;
   return ($$0|0); //@line 72305 "c/sqlite3.c"
  }
 }
 $12 = $4 & 1; //@line 72301 "c/sqlite3.c"
 $13 = ($12<<16>>16)==(0); //@line 72301 "c/sqlite3.c"
 if (!($13)) {
  $$0 = 0;
  return ($$0|0); //@line 72305 "c/sqlite3.c"
 }
 $14 = (_valueToText($0,$1)|0); //@line 72304 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 72305 "c/sqlite3.c"
}
function _sqlite3_aggregate_context($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 78552 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 78552 "c/sqlite3.c"
 $4 = ((($3)) + 8|0); //@line 78552 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 78552 "c/sqlite3.c"
 $6 = $5 & 8192; //@line 78552 "c/sqlite3.c"
 $7 = ($6<<16>>16)==(0); //@line 78552 "c/sqlite3.c"
 if ($7) {
  $8 = (_createAggContext($0,$1)|0); //@line 78553 "c/sqlite3.c"
  $$0 = $8;
  return ($$0|0); //@line 78557 "c/sqlite3.c"
 } else {
  $9 = ((($3)) + 16|0); //@line 78555 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 78555 "c/sqlite3.c"
  $$0 = $10;
  return ($$0|0); //@line 78557 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_result_error_toobig($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 78207 "c/sqlite3.c"
 HEAP32[$1>>2] = 18; //@line 78207 "c/sqlite3.c"
 $2 = ((($0)) + 25|0); //@line 78208 "c/sqlite3.c"
 HEAP8[$2>>0] = 1; //@line 78208 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 78209 "c/sqlite3.c"
 (_sqlite3VdbeMemSetStr($3,17161,-1,1,0)|0); //@line 78209 "c/sqlite3.c"
 return; //@line 78211 "c/sqlite3.c"
}
function _sqlite3_result_error_nomem($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 78216 "c/sqlite3.c"
 _sqlite3VdbeMemSetNull($1); //@line 78216 "c/sqlite3.c"
 $2 = ((($0)) + 20|0); //@line 78217 "c/sqlite3.c"
 HEAP32[$2>>2] = 7; //@line 78217 "c/sqlite3.c"
 $3 = ((($0)) + 25|0); //@line 78218 "c/sqlite3.c"
 HEAP8[$3>>0] = 1; //@line 78218 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 78219 "c/sqlite3.c"
 $5 = ((($4)) + 32|0); //@line 78219 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 78219 "c/sqlite3.c"
 _sqlite3OomFault($6); //@line 78219 "c/sqlite3.c"
 return; //@line 78220 "c/sqlite3.c"
}
function _sqlite3_result_text($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _setResultStrOrError($0,$1,$2,1,$3); //@line 78128 "c/sqlite3.c"
 return; //@line 78129 "c/sqlite3.c"
}
function _setResultStrOrError($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$0>>2]|0; //@line 78029 "c/sqlite3.c"
 $6 = (_sqlite3VdbeMemSetStr($5,$1,$2,$3,$4)|0); //@line 78029 "c/sqlite3.c"
 $7 = ($6|0)==(18); //@line 78029 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 78032 "c/sqlite3.c"
 }
 _sqlite3_result_error_toobig($0); //@line 78030 "c/sqlite3.c"
 return; //@line 78032 "c/sqlite3.c"
}
function _createAggContext($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 78527 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 78527 "c/sqlite3.c"
 $4 = ($1|0)<(1); //@line 78529 "c/sqlite3.c"
 if ($4) {
  _sqlite3VdbeMemSetNull($3); //@line 78530 "c/sqlite3.c"
  $5 = ((($3)) + 16|0); //@line 78531 "c/sqlite3.c"
  HEAP32[$5>>2] = 0; //@line 78531 "c/sqlite3.c"
 } else {
  (_sqlite3VdbeMemClearAndResize($3,$1)|0); //@line 78533 "c/sqlite3.c"
  $6 = ((($3)) + 8|0); //@line 78534 "c/sqlite3.c"
  HEAP16[$6>>1] = 8192; //@line 78534 "c/sqlite3.c"
  $7 = ((($0)) + 4|0); //@line 78535 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 78535 "c/sqlite3.c"
  HEAP32[$3>>2] = $8; //@line 78535 "c/sqlite3.c"
  $9 = ((($3)) + 16|0); //@line 78536 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 78536 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 78536 "c/sqlite3.c"
  if (!($11)) {
   _memset(($10|0),0,($1|0))|0; //@line 78537 "c/sqlite3.c"
  }
 }
 $12 = ((($3)) + 16|0); //@line 78540 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 78540 "c/sqlite3.c"
 return ($13|0); //@line 78540 "c/sqlite3.c"
}
function _sqlite3_value_type($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 77973 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 77973 "c/sqlite3.c"
 $3 = $2 & 31; //@line 77973 "c/sqlite3.c"
 $4 = $3&65535; //@line 77973 "c/sqlite3.c"
 $5 = (17186 + ($4)|0); //@line 77973 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 77973 "c/sqlite3.c"
 $7 = $6&255; //@line 77973 "c/sqlite3.c"
 return ($7|0); //@line 77973 "c/sqlite3.c"
}
function _sqlite3_result_int64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 78097 "c/sqlite3.c"
 _sqlite3VdbeMemSetInt64($3,$1,$2); //@line 78097 "c/sqlite3.c"
 return; //@line 78098 "c/sqlite3.c"
}
function _sqlite3_result_double($0,$1) {
 $0 = $0|0;
 $1 = +$1;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 78075 "c/sqlite3.c"
 _sqlite3VdbeMemSetDouble($2,$1); //@line 78075 "c/sqlite3.c"
 return; //@line 78076 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetDouble($0,$1) {
 $0 = $0|0;
 $1 = +$1;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3VdbeMemSetNull($0); //@line 71952 "c/sqlite3.c"
 $2 = (_sqlite3IsNaN($1)|0); //@line 71953 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 71953 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 71957 "c/sqlite3.c"
 }
 HEAPF64[$0>>3] = $1; //@line 71954 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 71955 "c/sqlite3.c"
 HEAP16[$4>>1] = 8; //@line 71955 "c/sqlite3.c"
 return; //@line 71957 "c/sqlite3.c"
}
function _sqlite3_value_numeric_type($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_value_type($0)|0); //@line 80215 "c/sqlite3.c"
 $2 = ($1|0)==(3); //@line 80216 "c/sqlite3.c"
 if (!($2)) {
  $$0 = $1;
  return ($$0|0); //@line 80221 "c/sqlite3.c"
 }
 _applyNumericAffinity($0,0); //@line 80218 "c/sqlite3.c"
 $3 = (_sqlite3_value_type($0)|0); //@line 80219 "c/sqlite3.c"
 $$0 = $3;
 return ($$0|0); //@line 80221 "c/sqlite3.c"
}
function _sqlite3_value_int64($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3VdbeIntValue($0)|0); //@line 77901 "c/sqlite3.c"
 $2 = tempRet0; //@line 77901 "c/sqlite3.c"
 tempRet0 = ($2); //@line 77901 "c/sqlite3.c"
 return ($1|0); //@line 77901 "c/sqlite3.c"
}
function _sqlite3AddInt64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $0; //@line 29791 "c/sqlite3.c"
 $4 = $3; //@line 29791 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 29791 "c/sqlite3.c"
 $6 = (($3) + 4)|0; //@line 29791 "c/sqlite3.c"
 $7 = $6; //@line 29791 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 29791 "c/sqlite3.c"
 $9 = ($2|0)>(-1); //@line 29794 "c/sqlite3.c"
 $10 = ($1>>>0)>(4294967295); //@line 29794 "c/sqlite3.c"
 $11 = ($2|0)==(-1); //@line 29794 "c/sqlite3.c"
 $12 = $11 & $10; //@line 29794 "c/sqlite3.c"
 $13 = $9 | $12; //@line 29794 "c/sqlite3.c"
 if ($13) {
  $14 = ($8|0)>(0); //@line 29797 "c/sqlite3.c"
  $15 = ($5>>>0)>(0); //@line 29797 "c/sqlite3.c"
  $16 = ($8|0)==(0); //@line 29797 "c/sqlite3.c"
  $17 = $16 & $15; //@line 29797 "c/sqlite3.c"
  $18 = $14 | $17; //@line 29797 "c/sqlite3.c"
  $19 = (_i64Subtract(-1,2147483647,($5|0),($8|0))|0); //@line 29797 "c/sqlite3.c"
  $20 = tempRet0; //@line 29797 "c/sqlite3.c"
  $21 = ($20|0)<($2|0); //@line 29797 "c/sqlite3.c"
  $22 = ($19>>>0)<($1>>>0); //@line 29797 "c/sqlite3.c"
  $23 = ($20|0)==($2|0); //@line 29797 "c/sqlite3.c"
  $24 = $23 & $22; //@line 29797 "c/sqlite3.c"
  $25 = $21 | $24; //@line 29797 "c/sqlite3.c"
  $or$cond = $18 & $25; //@line 29797 "c/sqlite3.c"
  if ($or$cond) {
   $$0 = 1;
   return ($$0|0); //@line 29806 "c/sqlite3.c"
  }
 } else {
  $26 = ($8|0)<(0); //@line 29801 "c/sqlite3.c"
  if ($26) {
   $27 = (_i64Subtract(1,-2147483648,($5|0),($8|0))|0); //@line 29801 "c/sqlite3.c"
   $28 = tempRet0; //@line 29801 "c/sqlite3.c"
   $29 = (_i64Add(($1|0),($2|0),1,0)|0); //@line 29801 "c/sqlite3.c"
   $30 = tempRet0; //@line 29801 "c/sqlite3.c"
   $31 = ($28|0)>($30|0); //@line 29801 "c/sqlite3.c"
   $32 = ($27>>>0)>($29>>>0); //@line 29801 "c/sqlite3.c"
   $33 = ($28|0)==($30|0); //@line 29801 "c/sqlite3.c"
   $34 = $33 & $32; //@line 29801 "c/sqlite3.c"
   $35 = $31 | $34; //@line 29801 "c/sqlite3.c"
   if ($35) {
    $$0 = 1;
    return ($$0|0); //@line 29806 "c/sqlite3.c"
   }
  }
 }
 $36 = (_i64Add(($5|0),($8|0),($1|0),($2|0))|0); //@line 29803 "c/sqlite3.c"
 $37 = tempRet0; //@line 29803 "c/sqlite3.c"
 $38 = $0; //@line 29803 "c/sqlite3.c"
 $39 = $38; //@line 29803 "c/sqlite3.c"
 HEAP32[$39>>2] = $36; //@line 29803 "c/sqlite3.c"
 $40 = (($38) + 4)|0; //@line 29803 "c/sqlite3.c"
 $41 = $40; //@line 29803 "c/sqlite3.c"
 HEAP32[$41>>2] = $37; //@line 29803 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 29806 "c/sqlite3.c"
}
function _sqlite3_value_double($0) {
 $0 = $0|0;
 var $1 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (+_sqlite3VdbeRealValue($0)); //@line 77895 "c/sqlite3.c"
 return (+$1); //@line 77895 "c/sqlite3.c"
}
function _sqlite3VdbeRealValue($0) {
 $0 = $0|0;
 var $$0 = 0.0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0, $18 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71708 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71708 "c/sqlite3.c"
 $3 = $2&65535; //@line 71708 "c/sqlite3.c"
 $4 = $3 & 8; //@line 71708 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 71708 "c/sqlite3.c"
 if (!($5)) {
  $6 = +HEAPF64[$0>>3]; //@line 71709 "c/sqlite3.c"
  $$0 = $6;
  return (+$$0); //@line 71718 "c/sqlite3.c"
 }
 $7 = $3 & 4; //@line 71710 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 71710 "c/sqlite3.c"
 if (!($8)) {
  $9 = $0; //@line 71711 "c/sqlite3.c"
  $10 = $9; //@line 71711 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 71711 "c/sqlite3.c"
  $12 = (($9) + 4)|0; //@line 71711 "c/sqlite3.c"
  $13 = $12; //@line 71711 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 71711 "c/sqlite3.c"
  $15 = (+($11>>>0)) + (4294967296.0*(+($14|0))); //@line 71711 "c/sqlite3.c"
  $$0 = $15;
  return (+$$0); //@line 71718 "c/sqlite3.c"
 }
 $16 = $3 & 18; //@line 71712 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 71712 "c/sqlite3.c"
 if ($17) {
  $$0 = 0.0;
  return (+$$0); //@line 71718 "c/sqlite3.c"
 }
 $18 = (+_memRealValue($0)); //@line 71713 "c/sqlite3.c"
 $$0 = $18;
 return (+$$0); //@line 71718 "c/sqlite3.c"
}
function _memRealValue($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAPF64[$1>>3] = 0.0; //@line 71701 "c/sqlite3.c"
 $2 = ((($0)) + 16|0); //@line 71702 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 71702 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 71702 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 71702 "c/sqlite3.c"
 $6 = ((($0)) + 10|0); //@line 71702 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 71702 "c/sqlite3.c"
 (_sqlite3AtoF($3,$1,$5,$7)|0); //@line 71702 "c/sqlite3.c"
 $8 = +HEAPF64[$1>>3]; //@line 71703 "c/sqlite3.c"
 STACKTOP = sp;return (+$8); //@line 71703 "c/sqlite3.c"
}
function _sqlite3AtoF($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$0164 = 0, $$0165$lcssa = 0, $$0165272 = 0, $$0166 = 0, $$0167$lcssa = 0, $$0167258 = 0, $$0175223 = 0, $$0178222 = 0, $$0183 = 0, $$0187250 = 0, $$0199 = 0, $$0200 = 0, $$0201 = 0, $$10217 = 0, $$11 = 0, $$1168251 = 0, $$1173 = 0.0, $$1176 = 0, $$1179 = 0;
 var $$1184 = 0, $$1188236 = 0, $$1269 = 0, $$2 = 0, $$2169237 = 0, $$2174 = 0.0, $$2177 = 0, $$2180 = 0, $$2185 = 0, $$3$lcssa = 0, $$3170 = 0, $$3181 = 0, $$3190 = 0, $$3259 = 0, $$4171 = 0, $$4182$lcssa = 0, $$4182208 = 0, $$4182215 = 0, $$4191 = 0, $$4252 = 0;
 var $$5 = 0, $$5234 = 0, $$5238 = 0, $$6 = 0, $$7 = 0, $$8224 = 0, $$9 = 0, $$lcssa = 0, $$pn = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0.0, $127 = 0;
 var $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0;
 var $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0.0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0;
 var $164 = 0, $165 = 0, $166 = 0, $167 = 0.0, $168 = 0.0, $169 = 0.0, $17 = 0, $170 = 0.0, $171 = 0.0, $172 = 0.0, $173 = 0.0, $174 = 0.0, $175 = 0.0, $176 = 0.0, $177 = 0.0, $178 = 0, $179 = 0, $18 = 0, $180 = 0.0, $181 = 0.0;
 var $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond10 = 0, $or$cond12 = 0, $spec$select = 0;
 var $spec$select204 = 0, $spec$select205 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[$1>>3] = 0.0; //@line 28868 "c/sqlite3.c"
 $4 = $3&255; //@line 28870 "c/sqlite3.c"
 $5 = ($3<<24>>24)==(1); //@line 28870 "c/sqlite3.c"
 if ($5) {
  $$0164 = $0;$$0166 = 1;$$0201 = 1;$$pn = $2;
 } else {
  $6 = (3 - ($4))|0; //@line 28876 "c/sqlite3.c"
  $7 = ($6|0)<($2|0); //@line 28876 "c/sqlite3.c"
  L3: do {
   if ($7) {
    $$0165272 = $6;
    while(1) {
     $8 = (($0) + ($$0165272)|0); //@line 28876 "c/sqlite3.c"
     $9 = HEAP8[$8>>0]|0; //@line 28876 "c/sqlite3.c"
     $10 = ($9<<24>>24)==(0); //@line 28876 "c/sqlite3.c"
     if (!($10)) {
      $$0165$lcssa = $$0165272;$$lcssa = 0;
      break L3;
     }
     $11 = (($$0165272) + 2)|0; //@line 28876 "c/sqlite3.c"
     $12 = ($11|0)<($2|0); //@line 28876 "c/sqlite3.c"
     if ($12) {
      $$0165272 = $11;
     } else {
      $$0165$lcssa = $11;$$lcssa = 1;
      break;
     }
    }
   } else {
    $$0165$lcssa = $6;$$lcssa = 1;
   }
  } while(0);
  $13 = $$0165$lcssa ^ 1; //@line 28878 "c/sqlite3.c"
  $14 = $4 & 1; //@line 28879 "c/sqlite3.c"
  $15 = (($0) + ($14)|0); //@line 28879 "c/sqlite3.c"
  $$0164 = $15;$$0166 = $$lcssa;$$0201 = 2;$$pn = $13;
 }
 $$0200 = (($0) + ($$pn)|0);
 $16 = ($$0164>>>0)<($$0200>>>0); //@line 28883 "c/sqlite3.c"
 if (!($16)) {
  $$0 = 0;
  return ($$0|0); //@line 29026 "c/sqlite3.c"
 }
 $$1269 = $$0164;
 while(1) {
  $17 = HEAP8[$$1269>>0]|0; //@line 28883 "c/sqlite3.c"
  $18 = $17&255; //@line 28883 "c/sqlite3.c"
  $19 = (16281 + ($18)|0); //@line 28883 "c/sqlite3.c"
  $20 = HEAP8[$19>>0]|0; //@line 28883 "c/sqlite3.c"
  $21 = $20 & 1; //@line 28883 "c/sqlite3.c"
  $22 = ($21<<24>>24)==(0); //@line 28883 "c/sqlite3.c"
  if ($22) {
   break;
  }
  $23 = (($$1269) + ($$0201)|0); //@line 28883 "c/sqlite3.c"
  $24 = ($23>>>0)<($$0200>>>0); //@line 28883 "c/sqlite3.c"
  if ($24) {
   $$1269 = $23;
  } else {
   $$0 = 0;
   label = 62;
   break;
  }
 }
 if ((label|0) == 62) {
  return ($$0|0); //@line 29026 "c/sqlite3.c"
 }
 $25 = HEAP8[$$1269>>0]|0; //@line 28887 "c/sqlite3.c"
 switch ($25<<24>>24) {
 case 45:  {
  $26 = (($$1269) + ($$0201)|0); //@line 28889 "c/sqlite3.c"
  $$0199 = -1;$$2 = $26;
  break;
 }
 case 43:  {
  $27 = (($$1269) + ($$0201)|0); //@line 28891 "c/sqlite3.c"
  $$0199 = 1;$$2 = $27;
  break;
 }
 default: {
  $$0199 = 1;$$2 = $$1269;
 }
 }
 $28 = ($$2>>>0)<($$0200>>>0); //@line 28895 "c/sqlite3.c"
 L23: do {
  if ($28) {
   $$0167258 = 0;$$3259 = $$2;$34 = 0;$36 = 0;
   while(1) {
    $29 = HEAP8[$$3259>>0]|0; //@line 28895 "c/sqlite3.c"
    $30 = $29&255; //@line 28895 "c/sqlite3.c"
    $31 = (($30) + -48)|0; //@line 28895 "c/sqlite3.c"
    $32 = ($31>>>0)<(10); //@line 28895 "c/sqlite3.c"
    $33 = ($34|0)<(214748364); //@line 28895 "c/sqlite3.c"
    $35 = ($36>>>0)<(3435973835); //@line 28895 "c/sqlite3.c"
    $37 = ($34|0)==(214748364); //@line 28895 "c/sqlite3.c"
    $38 = $37 & $35; //@line 28895 "c/sqlite3.c"
    $39 = $33 | $38; //@line 28895 "c/sqlite3.c"
    $or$cond12 = $39 & $32; //@line 28895 "c/sqlite3.c"
    if (!($or$cond12)) {
     $$0167$lcssa = $$0167258;$$3$lcssa = $$3259;$185 = $36;$186 = $34;
     break L23;
    }
    $40 = (___muldi3(($36|0),($34|0),10,0)|0); //@line 28896 "c/sqlite3.c"
    $41 = tempRet0; //@line 28896 "c/sqlite3.c"
    $42 = $29 << 24 >> 24; //@line 28896 "c/sqlite3.c"
    $43 = (($42) + -48)|0; //@line 28896 "c/sqlite3.c"
    $44 = ($43|0)<(0); //@line 28896 "c/sqlite3.c"
    $45 = $44 << 31 >> 31; //@line 28896 "c/sqlite3.c"
    $46 = (_i64Add(($40|0),($41|0),($43|0),($45|0))|0); //@line 28896 "c/sqlite3.c"
    $47 = tempRet0; //@line 28896 "c/sqlite3.c"
    $48 = (($$3259) + ($$0201)|0); //@line 28897 "c/sqlite3.c"
    $49 = (($$0167258) + 1)|0; //@line 28897 "c/sqlite3.c"
    $50 = ($48>>>0)<($$0200>>>0); //@line 28895 "c/sqlite3.c"
    if ($50) {
     $$0167258 = $49;$$3259 = $48;$34 = $47;$36 = $46;
    } else {
     $$0167$lcssa = $49;$$3$lcssa = $48;$185 = $46;$186 = $47;
     break;
    }
   }
  } else {
   $$0167$lcssa = 0;$$3$lcssa = $$2;$185 = 0;$186 = 0;
  }
 } while(0);
 $51 = ($$3$lcssa>>>0)<($$0200>>>0); //@line 28902 "c/sqlite3.c"
 L29: do {
  if ($51) {
   $$0187250 = 0;$$1168251 = $$0167$lcssa;$$4252 = $$3$lcssa;
   while(1) {
    $52 = HEAP8[$$4252>>0]|0; //@line 28902 "c/sqlite3.c"
    $53 = $52&255; //@line 28902 "c/sqlite3.c"
    $54 = (($53) + -48)|0; //@line 28902 "c/sqlite3.c"
    $55 = ($54>>>0)<(10); //@line 28902 "c/sqlite3.c"
    if (!($55)) {
     break;
    }
    $56 = (($$4252) + ($$0201)|0); //@line 28902 "c/sqlite3.c"
    $57 = (($$1168251) + 1)|0; //@line 28902 "c/sqlite3.c"
    $58 = (($$0187250) + 1)|0; //@line 28902 "c/sqlite3.c"
    $59 = ($56>>>0)<($$0200>>>0); //@line 28902 "c/sqlite3.c"
    if ($59) {
     $$0187250 = $58;$$1168251 = $57;$$4252 = $56;
    } else {
     $$11 = $56;$$2177 = 1;$$2180 = 0;$$2185 = 1;$$4171 = $57;$$4191 = $58;$121 = $185;$123 = $186;
     break L29;
    }
   }
   $60 = HEAP8[$$4252>>0]|0; //@line 28906 "c/sqlite3.c"
   $61 = ($60<<24>>24)==(46); //@line 28906 "c/sqlite3.c"
   L35: do {
    if ($61) {
     $$5234 = (($$4252) + ($$0201)|0);
     $62 = ($$5234>>>0)<($$0200>>>0); //@line 28910 "c/sqlite3.c"
     if ($62) {
      $$1188236 = $$0187250;$$2169237 = $$1168251;$$5238 = $$5234;$68 = $186;$70 = $185;
      while(1) {
       $63 = HEAP8[$$5238>>0]|0; //@line 28910 "c/sqlite3.c"
       $64 = $63&255; //@line 28910 "c/sqlite3.c"
       $65 = (($64) + -48)|0; //@line 28910 "c/sqlite3.c"
       $66 = ($65>>>0)<(10); //@line 28910 "c/sqlite3.c"
       if (!($66)) {
        $$3170 = $$2169237;$$3190 = $$1188236;$$6 = $$5238;$187 = $70;$188 = $68;
        break L35;
       }
       $67 = ($68|0)<(214748364); //@line 28911 "c/sqlite3.c"
       $69 = ($70>>>0)<(3435973835); //@line 28911 "c/sqlite3.c"
       $71 = ($68|0)==(214748364); //@line 28911 "c/sqlite3.c"
       $72 = $71 & $69; //@line 28911 "c/sqlite3.c"
       $73 = $67 | $72; //@line 28911 "c/sqlite3.c"
       $74 = (___muldi3(($70|0),($68|0),10,0)|0); //@line 28912 "c/sqlite3.c"
       $75 = tempRet0; //@line 28912 "c/sqlite3.c"
       $76 = $63 << 24 >> 24; //@line 28912 "c/sqlite3.c"
       $77 = (($76) + -48)|0; //@line 28912 "c/sqlite3.c"
       $78 = ($77|0)<(0); //@line 28912 "c/sqlite3.c"
       $79 = $78 << 31 >> 31; //@line 28912 "c/sqlite3.c"
       $80 = (_i64Add(($74|0),($75|0),($77|0),($79|0))|0); //@line 28912 "c/sqlite3.c"
       $81 = tempRet0; //@line 28912 "c/sqlite3.c"
       $82 = $73 ? $80 : $70; //@line 28911 "c/sqlite3.c"
       $83 = $73 ? $81 : $68; //@line 28911 "c/sqlite3.c"
       $84 = $73 << 31 >> 31; //@line 28911 "c/sqlite3.c"
       $spec$select204 = (($$1188236) + ($84))|0; //@line 28911 "c/sqlite3.c"
       $85 = (($$2169237) + 1)|0; //@line 28915 "c/sqlite3.c"
       $$5 = (($$5238) + ($$0201)|0);
       $86 = ($$5>>>0)<($$0200>>>0); //@line 28910 "c/sqlite3.c"
       if ($86) {
        $$1188236 = $spec$select204;$$2169237 = $85;$$5238 = $$5;$68 = $83;$70 = $82;
       } else {
        $$3170 = $85;$$3190 = $spec$select204;$$6 = $$5;$187 = $82;$188 = $83;
        break;
       }
      }
     } else {
      $$3170 = $$1168251;$$3190 = $$0187250;$$6 = $$5234;$187 = $185;$188 = $186;
     }
    } else {
     $$3170 = $$1168251;$$3190 = $$0187250;$$6 = $$4252;$187 = $185;$188 = $186;
    }
   } while(0);
   $87 = ($$6>>>0)<($$0200>>>0); //@line 28918 "c/sqlite3.c"
   if ($87) {
    $88 = HEAP8[$$6>>0]|0; //@line 28921 "c/sqlite3.c"
    L43: do {
     switch ($88<<24>>24) {
     case 69: case 101:  {
      $89 = (($$6) + ($$0201)|0); //@line 28922 "c/sqlite3.c"
      $90 = ($89>>>0)<($$0200>>>0); //@line 28928 "c/sqlite3.c"
      if (!($90)) {
       $$11 = $89;$$2177 = 0;$$2180 = 0;$$2185 = 1;$$4171 = $$3170;$$4191 = $$3190;$121 = $187;$123 = $188;
       break L29;
      }
      $91 = HEAP8[$89>>0]|0; //@line 28931 "c/sqlite3.c"
      switch ($91<<24>>24) {
      case 45:  {
       $92 = (($89) + ($$0201)|0); //@line 28933 "c/sqlite3.c"
       $$0183 = -1;$$7 = $92;
       break;
      }
      case 43:  {
       $93 = (($89) + ($$0201)|0); //@line 28935 "c/sqlite3.c"
       $$0183 = 1;$$7 = $93;
       break;
      }
      default: {
       $$0183 = 1;$$7 = $89;
      }
      }
      $94 = ($$7>>>0)<($$0200>>>0); //@line 28938 "c/sqlite3.c"
      if ($94) {
       $$0175223 = 0;$$0178222 = 0;$$8224 = $$7;
       while(1) {
        $95 = HEAP8[$$8224>>0]|0; //@line 28938 "c/sqlite3.c"
        $96 = $95&255; //@line 28938 "c/sqlite3.c"
        $97 = (($96) + -48)|0; //@line 28938 "c/sqlite3.c"
        $98 = ($97>>>0)<(10); //@line 28938 "c/sqlite3.c"
        if (!($98)) {
         $$1176 = $$0175223;$$1179 = $$0178222;$$1184 = $$0183;$$9 = $$8224;
         break L43;
        }
        $99 = ($$0178222|0)<(10000); //@line 28939 "c/sqlite3.c"
        $100 = ($$0178222*10)|0; //@line 28939 "c/sqlite3.c"
        $101 = $95 << 24 >> 24; //@line 28939 "c/sqlite3.c"
        $102 = (($100) + -48)|0; //@line 28939 "c/sqlite3.c"
        $103 = (($102) + ($101))|0; //@line 28939 "c/sqlite3.c"
        $spec$select205 = $99 ? $103 : 10000; //@line 28939 "c/sqlite3.c"
        $104 = (($$8224) + ($$0201)|0); //@line 28940 "c/sqlite3.c"
        $105 = ($104>>>0)<($$0200>>>0); //@line 28938 "c/sqlite3.c"
        if ($105) {
         $$0175223 = 1;$$0178222 = $spec$select205;$$8224 = $104;
        } else {
         $$1176 = 1;$$1179 = $spec$select205;$$1184 = $$0183;$$9 = $104;
         break;
        }
       }
      } else {
       $$1176 = 0;$$1179 = 0;$$1184 = $$0183;$$9 = $$7;
      }
      break;
     }
     default: {
      $$1176 = 1;$$1179 = 0;$$1184 = 1;$$9 = $$6;
     }
     }
    } while(0);
    $106 = ($$9>>>0)<($$0200>>>0); //@line 28946 "c/sqlite3.c"
    if ($106) {
     $$10217 = $$9;
     while(1) {
      $107 = HEAP8[$$10217>>0]|0; //@line 28946 "c/sqlite3.c"
      $108 = $107&255; //@line 28946 "c/sqlite3.c"
      $109 = (16281 + ($108)|0); //@line 28946 "c/sqlite3.c"
      $110 = HEAP8[$109>>0]|0; //@line 28946 "c/sqlite3.c"
      $111 = $110 & 1; //@line 28946 "c/sqlite3.c"
      $112 = ($111<<24>>24)==(0); //@line 28946 "c/sqlite3.c"
      if ($112) {
       $$11 = $$10217;$$2177 = $$1176;$$2180 = $$1179;$$2185 = $$1184;$$4171 = $$3170;$$4191 = $$3190;$121 = $187;$123 = $188;
       break L29;
      }
      $113 = (($$10217) + ($$0201)|0); //@line 28946 "c/sqlite3.c"
      $114 = ($113>>>0)<($$0200>>>0); //@line 28946 "c/sqlite3.c"
      if ($114) {
       $$10217 = $113;
      } else {
       $$11 = $113;$$2177 = $$1176;$$2180 = $$1179;$$2185 = $$1184;$$4171 = $$3170;$$4191 = $$3190;$121 = $187;$123 = $188;
       break;
      }
     }
    } else {
     $$11 = $$9;$$2177 = $$1176;$$2180 = $$1179;$$2185 = $$1184;$$4171 = $$3170;$$4191 = $$3190;$121 = $187;$123 = $188;
    }
   } else {
    $$11 = $$6;$$2177 = 1;$$2180 = 0;$$2185 = 1;$$4171 = $$3170;$$4191 = $$3190;$121 = $187;$123 = $188;
   }
  } else {
   $$11 = $$3$lcssa;$$2177 = 1;$$2180 = 0;$$2185 = 1;$$4171 = $$0167$lcssa;$$4191 = 0;$121 = $185;$123 = $186;
  }
 } while(0);
 $115 = Math_imul($$2180, $$2185)|0; //@line 28950 "c/sqlite3.c"
 $116 = (($115) + ($$4191))|0; //@line 28950 "c/sqlite3.c"
 $117 = ($116|0)<(0); //@line 28951 "c/sqlite3.c"
 $118 = $116 >> 31; //@line 28951 "c/sqlite3.c"
 $119 = $118 | 1; //@line 28951 "c/sqlite3.c"
 $120 = ($121|0)==(0); //@line 28958 "c/sqlite3.c"
 $122 = ($123|0)==(0); //@line 28958 "c/sqlite3.c"
 $124 = $120 & $122; //@line 28958 "c/sqlite3.c"
 L60: do {
  if ($124) {
   $125 = ($$0199|0)<(0); //@line 28960 "c/sqlite3.c"
   $126 = $125 ? -0.0 : 0.0; //@line 28960 "c/sqlite3.c"
   $$2174 = $126;
  } else {
   $127 = (0 - ($116))|0; //@line 28953 "c/sqlite3.c"
   $$3181 = $117 ? $127 : $116; //@line 28951 "c/sqlite3.c"
   $128 = ($$3181|0)>(0); //@line 28968 "c/sqlite3.c"
   L63: do {
    if ($128) {
     $129 = ($119|0)>(0);
     $$4182215 = $$3181;$131 = $123;$133 = $121;
     while(1) {
      if ($129) {
       $130 = ($131|0)>(214748364); //@line 28970 "c/sqlite3.c"
       $132 = ($133>>>0)>(3435973835); //@line 28970 "c/sqlite3.c"
       $134 = ($131|0)==(214748364); //@line 28970 "c/sqlite3.c"
       $135 = $134 & $132; //@line 28970 "c/sqlite3.c"
       $136 = $130 | $135; //@line 28970 "c/sqlite3.c"
       if ($136) {
        break;
       }
       $137 = (___muldi3(($133|0),($131|0),10,0)|0); //@line 28971 "c/sqlite3.c"
       $138 = tempRet0; //@line 28971 "c/sqlite3.c"
       $189 = $137;$190 = $138;
      } else {
       $139 = (___divdi3(($133|0),($131|0),10,0)|0); //@line 28974 "c/sqlite3.c"
       $140 = tempRet0; //@line 28974 "c/sqlite3.c"
       $141 = (___muldi3(($139|0),($140|0),10,0)|0);
       $142 = tempRet0;
       $143 = (_i64Subtract(($133|0),($131|0),($141|0),($142|0))|0);
       $144 = tempRet0;
       $145 = ($143|0)==(0); //@line 28973 "c/sqlite3.c"
       $146 = ($144|0)==(0); //@line 28973 "c/sqlite3.c"
       $147 = $145 & $146; //@line 28973 "c/sqlite3.c"
       if ($147) {
        $189 = $139;$190 = $140;
       } else {
        break;
       }
      }
      $148 = (($$4182215) + -1)|0; //@line 28976 "c/sqlite3.c"
      $149 = ($$4182215|0)>(1); //@line 28968 "c/sqlite3.c"
      if ($149) {
       $$4182215 = $148;$131 = $190;$133 = $189;
      } else {
       $$4182$lcssa = $148;$151 = $189;$152 = $190;
       label = 50;
       break L63;
      }
     }
     $159 = ($$0199|0)<(0); //@line 28980 "c/sqlite3.c"
     $160 = (_i64Subtract(0,0,($133|0),($131|0))|0); //@line 28980 "c/sqlite3.c"
     $161 = tempRet0; //@line 28980 "c/sqlite3.c"
     $162 = $159 ? $160 : $133; //@line 28980 "c/sqlite3.c"
     $163 = $159 ? $161 : $131; //@line 28980 "c/sqlite3.c"
     $164 = ($$4182215|0)>(307); //@line 28986 "c/sqlite3.c"
     if ($164) {
      $165 = ($$4182215|0)<(342); //@line 28987 "c/sqlite3.c"
      if ($165) {
       $166 = (($$4182215) + -308)|0; //@line 28988 "c/sqlite3.c"
       $167 = (+_sqlite3Pow10($166)); //@line 28988 "c/sqlite3.c"
       $168 = (+($162>>>0)) + (4294967296.0*(+($163|0)));
       if ($117) {
        $169 = $168 / $167; //@line 28990 "c/sqlite3.c"
        $170 = $169 / 1.0E+308; //@line 28991 "c/sqlite3.c"
        $$2174 = $170;
        break L60;
       } else {
        $171 = $167 * $168; //@line 28993 "c/sqlite3.c"
        $172 = $171 * 1.0E+308; //@line 28994 "c/sqlite3.c"
        $$2174 = $172;
        break L60;
       }
      } else {
       $173 = (+($162>>>0)) + (4294967296.0*(+($163|0)));
       if ($117) {
        $174 = $173 * 0.0; //@line 28998 "c/sqlite3.c"
        $$2174 = $174;
        break L60;
       } else {
        $175 = $173 * inf; //@line 29003 "c/sqlite3.c"
        $$2174 = $175;
        break L60;
       }
      }
     } else {
      $$4182208 = $$4182215;$178 = $162;$179 = $163;
     }
    } else {
     $$4182$lcssa = $$3181;$151 = $121;$152 = $123;
     label = 50;
    }
   } while(0);
   if ((label|0) == 50) {
    $150 = ($$0199|0)<(0); //@line 28980 "c/sqlite3.c"
    $153 = (_i64Subtract(0,0,($151|0),($152|0))|0); //@line 28980 "c/sqlite3.c"
    $154 = tempRet0; //@line 28980 "c/sqlite3.c"
    $155 = $150 ? $153 : $151; //@line 28980 "c/sqlite3.c"
    $156 = $150 ? $154 : $152; //@line 28980 "c/sqlite3.c"
    $157 = ($$4182$lcssa|0)==(0); //@line 28982 "c/sqlite3.c"
    if ($157) {
     $158 = (+($155>>>0)) + (4294967296.0*(+($156|0))); //@line 28983 "c/sqlite3.c"
     $$2174 = $158;
     break;
    } else {
     $$4182208 = $$4182$lcssa;$178 = $155;$179 = $156;
    }
   }
   $176 = (+_sqlite3Pow10($$4182208)); //@line 29008 "c/sqlite3.c"
   $177 = (+($178>>>0)) + (4294967296.0*(+($179|0)));
   $180 = $177 / $176; //@line 29010 "c/sqlite3.c"
   $181 = $176 * $177; //@line 29012 "c/sqlite3.c"
   $$1173 = $117 ? $180 : $181; //@line 29009 "c/sqlite3.c"
   $$2174 = $$1173;
  }
 } while(0);
 HEAPF64[$1>>3] = $$2174; //@line 29019 "c/sqlite3.c"
 $182 = ($$11|0)==($$0200|0); //@line 29022 "c/sqlite3.c"
 $183 = ($$4171|0)>(0); //@line 29022 "c/sqlite3.c"
 $or$cond = $183 & $182; //@line 29022 "c/sqlite3.c"
 $184 = ($$2177|0)!=(0); //@line 29022 "c/sqlite3.c"
 $or$cond10 = $184 & $or$cond; //@line 29022 "c/sqlite3.c"
 $spec$select = $or$cond10 ? $$0166 : 0; //@line 29022 "c/sqlite3.c"
 $$0 = $spec$select;
 return ($$0|0); //@line 29026 "c/sqlite3.c"
}
function _sqlite3Pow10($0) {
 $0 = $0|0;
 var $$01013 = 0.0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0, $9 = 0.0, $spec$select = 0.0, $spec$select$lcssa = 0.0, $spec$select12 = 0.0, $spec$select14 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0 & 1; //@line 28821 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 28821 "c/sqlite3.c"
 $spec$select12 = $2 ? 1.0 : 10.0; //@line 28821 "c/sqlite3.c"
 $3 = $0 >> 1; //@line 28822 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 28823 "c/sqlite3.c"
 if ($4) {
  $spec$select$lcssa = $spec$select12;
  return (+$spec$select$lcssa); //@line 28826 "c/sqlite3.c"
 }
 $$01013 = 10.0;$7 = $3;$spec$select14 = $spec$select12;
 while(1) {
  $5 = $$01013 * $$01013; //@line 28824 "c/sqlite3.c"
  $6 = $7 & 1; //@line 28821 "c/sqlite3.c"
  $8 = ($6|0)==(0); //@line 28821 "c/sqlite3.c"
  $9 = $5 * $spec$select14; //@line 28821 "c/sqlite3.c"
  $spec$select = $8 ? $spec$select14 : $9; //@line 28821 "c/sqlite3.c"
  $10 = $7 >> 1; //@line 28822 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 28823 "c/sqlite3.c"
  if ($11) {
   $spec$select$lcssa = $spec$select;
   break;
  } else {
   $$01013 = $5;$7 = $10;$spec$select14 = $spec$select;
  }
 }
 return (+$spec$select$lcssa); //@line 28826 "c/sqlite3.c"
}
function _sqlite3VdbeIntValue($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71680 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71680 "c/sqlite3.c"
 $3 = $2&65535; //@line 71680 "c/sqlite3.c"
 $4 = $3 & 4; //@line 71681 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 71681 "c/sqlite3.c"
 do {
  if ($5) {
   $12 = $3 & 8; //@line 71683 "c/sqlite3.c"
   $13 = ($12|0)==(0); //@line 71683 "c/sqlite3.c"
   if (!($13)) {
    $14 = +HEAPF64[$0>>3]; //@line 71684 "c/sqlite3.c"
    $15 = (_doubleToInt64($14)|0); //@line 71684 "c/sqlite3.c"
    $16 = tempRet0; //@line 71684 "c/sqlite3.c"
    $21 = $16;$22 = $15;
    break;
   }
   $17 = $3 & 18; //@line 71685 "c/sqlite3.c"
   $18 = ($17|0)==(0); //@line 71685 "c/sqlite3.c"
   if ($18) {
    $21 = 0;$22 = 0;
   } else {
    $19 = (_memIntValue($0)|0); //@line 71687 "c/sqlite3.c"
    $20 = tempRet0; //@line 71687 "c/sqlite3.c"
    $21 = $20;$22 = $19;
   }
  } else {
   $6 = $0; //@line 71682 "c/sqlite3.c"
   $7 = $6; //@line 71682 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 71682 "c/sqlite3.c"
   $9 = (($6) + 4)|0; //@line 71682 "c/sqlite3.c"
   $10 = $9; //@line 71682 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 71682 "c/sqlite3.c"
   $21 = $11;$22 = $8;
  }
 } while(0);
 tempRet0 = ($21); //@line 71691 "c/sqlite3.c"
 return ($22|0); //@line 71691 "c/sqlite3.c"
}
function _doubleToInt64($0) {
 $0 = +$0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = !($0 <= -9.2233720368547758E+18); //@line 71650 "c/sqlite3.c"
 if ($1) {
  $2 = !($0 >= 9.2233720368547758E+18); //@line 71652 "c/sqlite3.c"
  if ($2) {
   $3 = (~~$0)>>>0; //@line 71655 "c/sqlite3.c"
   $4 = +Math_abs($0) >= 1.0 ? $0 > 0.0 ? (~~+Math_min(+Math_floor($0 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($0 - +(~~$0 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 71655 "c/sqlite3.c"
   $5 = $4;$6 = $3;
  } else {
   $5 = 2147483647;$6 = -1;
  }
 } else {
  $5 = -2147483648;$6 = 0;
 }
 tempRet0 = ($5); //@line 71658 "c/sqlite3.c"
 return ($6|0); //@line 71658 "c/sqlite3.c"
}
function _memIntValue($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = $1; //@line 71672 "c/sqlite3.c"
 $3 = $2; //@line 71672 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 71672 "c/sqlite3.c"
 $4 = (($2) + 4)|0; //@line 71672 "c/sqlite3.c"
 $5 = $4; //@line 71672 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 71672 "c/sqlite3.c"
 $6 = ((($0)) + 16|0); //@line 71673 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 71673 "c/sqlite3.c"
 $8 = ((($0)) + 12|0); //@line 71673 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 71673 "c/sqlite3.c"
 $10 = ((($0)) + 10|0); //@line 71673 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 71673 "c/sqlite3.c"
 (_sqlite3Atoi64($7,$1,$9,$11)|0); //@line 71673 "c/sqlite3.c"
 $12 = $1; //@line 71674 "c/sqlite3.c"
 $13 = $12; //@line 71674 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 71674 "c/sqlite3.c"
 $15 = (($12) + 4)|0; //@line 71674 "c/sqlite3.c"
 $16 = $15; //@line 71674 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 71674 "c/sqlite3.c"
 tempRet0 = ($17); //@line 71674 "c/sqlite3.c"
 STACKTOP = sp;return ($14|0); //@line 71674 "c/sqlite3.c"
}
function _sqlite3Atoi64($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$089 = 0, $$090 = 0, $$091 = 0, $$093$lcssa = 0, $$093121 = 0, $$095 = 0, $$097 = 0, $$098 = 0, $$194$lcssa = 0, $$194$lcssa133143148 = 0, $$194$lcssa133144 = 0, $$194106 = 0, $$199118 = 0, $$2 = 0, $$3$lcssa = 0, $$3113 = 0, $$lcssa = 0, $$lcssa104 = 0, $$off = 0;
 var $$old3 = 0, $$pn = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $9 = 0, $or$cond = 0, $spec$select101 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = $3&255; //@line 29085 "c/sqlite3.c"
 $5 = ($3<<24>>24)==(1); //@line 29085 "c/sqlite3.c"
 if ($5) {
  $$091 = 0;$$097 = 1;$$098 = $0;$$pn = $2;
 } else {
  $6 = (3 - ($4))|0; //@line 29090 "c/sqlite3.c"
  $7 = ($6|0)<($2|0); //@line 29090 "c/sqlite3.c"
  L3: do {
   if ($7) {
    $$093121 = $6;
    while(1) {
     $8 = (($0) + ($$093121)|0); //@line 29090 "c/sqlite3.c"
     $9 = HEAP8[$8>>0]|0; //@line 29090 "c/sqlite3.c"
     $10 = ($9<<24>>24)==(0); //@line 29090 "c/sqlite3.c"
     if (!($10)) {
      $$093$lcssa = $$093121;$$lcssa104 = 1;
      break L3;
     }
     $11 = (($$093121) + 2)|0; //@line 29090 "c/sqlite3.c"
     $12 = ($11|0)<($2|0); //@line 29090 "c/sqlite3.c"
     if ($12) {
      $$093121 = $11;
     } else {
      $$093$lcssa = $11;$$lcssa104 = 0;
      break;
     }
    }
   } else {
    $$093$lcssa = $6;$$lcssa104 = 0;
   }
  } while(0);
  $13 = $$093$lcssa ^ 1; //@line 29092 "c/sqlite3.c"
  $14 = $4 & 1; //@line 29093 "c/sqlite3.c"
  $15 = (($0) + ($14)|0); //@line 29093 "c/sqlite3.c"
  $$091 = $$lcssa104;$$097 = 2;$$098 = $15;$$pn = $13;
 }
 $$0 = (($0) + ($$pn)|0);
 $16 = ($$098>>>0)<($$0>>>0); //@line 29095 "c/sqlite3.c"
 L10: do {
  if ($16) {
   $$199118 = $$098;
   while(1) {
    $17 = HEAP8[$$199118>>0]|0; //@line 29095 "c/sqlite3.c"
    $18 = $17&255; //@line 29095 "c/sqlite3.c"
    $19 = (16281 + ($18)|0); //@line 29095 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 29095 "c/sqlite3.c"
    $21 = $20 & 1; //@line 29095 "c/sqlite3.c"
    $22 = ($21<<24>>24)==(0); //@line 29095 "c/sqlite3.c"
    if ($22) {
     break;
    }
    $23 = (($$199118) + ($$097)|0); //@line 29095 "c/sqlite3.c"
    $24 = ($23>>>0)<($$0>>>0); //@line 29095 "c/sqlite3.c"
    if ($24) {
     $$199118 = $23;
    } else {
     $$095 = 0;$$2 = $23;
     break L10;
    }
   }
   switch ($17<<24>>24) {
   case 45:  {
    $25 = (($$199118) + ($$097)|0); //@line 29099 "c/sqlite3.c"
    $$095 = 1;$$2 = $25;
    break L10;
    break;
   }
   case 43:  {
    $26 = (($$199118) + ($$097)|0); //@line 29101 "c/sqlite3.c"
    $$095 = 0;$$2 = $26;
    break L10;
    break;
   }
   default: {
    $$095 = 0;$$2 = $$199118;
    break L10;
   }
   }
  } else {
   $$095 = 0;$$2 = $$098;
  }
 } while(0);
 $27 = ($$2>>>0)<($$0>>>0); //@line 29105 "c/sqlite3.c"
 L20: do {
  if ($27) {
   $$3113 = $$2;
   while(1) {
    $28 = HEAP8[$$3113>>0]|0; //@line 29105 "c/sqlite3.c"
    $29 = ($28<<24>>24)==(48); //@line 29105 "c/sqlite3.c"
    if (!($29)) {
     $$3$lcssa = $$3113;
     break L20;
    }
    $30 = (($$3113) + ($$097)|0); //@line 29105 "c/sqlite3.c"
    $31 = ($30>>>0)<($$0>>>0); //@line 29105 "c/sqlite3.c"
    if ($31) {
     $$3113 = $30;
    } else {
     $$3$lcssa = $30;
     break;
    }
   }
  } else {
   $$3$lcssa = $$2;
  }
 } while(0);
 $32 = ($$3$lcssa>>>0)<($$0>>>0); //@line 29106 "c/sqlite3.c"
 L26: do {
  if ($32) {
   $$194106 = 0;$39 = $$3$lcssa;$41 = 0;$42 = 0;
   while(1) {
    $38 = HEAP8[$39>>0]|0; //@line 29106 "c/sqlite3.c"
    $$off = (($38) + -48)<<24>>24; //@line 29106 "c/sqlite3.c"
    $40 = ($$off&255)<(10); //@line 29106 "c/sqlite3.c"
    if (!($40)) {
     $$194$lcssa = $$194106;$$lcssa = 1;$56 = $42;$58 = $41;
     break;
    }
    $43 = (___muldi3(($41|0),($42|0),10,0)|0); //@line 29107 "c/sqlite3.c"
    $44 = tempRet0; //@line 29107 "c/sqlite3.c"
    $45 = $38 << 24 >> 24; //@line 29107 "c/sqlite3.c"
    $46 = ($45|0)<(0); //@line 29107 "c/sqlite3.c"
    $47 = $46 << 31 >> 31; //@line 29107 "c/sqlite3.c"
    $48 = (_i64Add(($43|0),($44|0),-48,-1)|0); //@line 29107 "c/sqlite3.c"
    $49 = tempRet0; //@line 29107 "c/sqlite3.c"
    $50 = (_i64Add(($48|0),($49|0),($45|0),($47|0))|0); //@line 29107 "c/sqlite3.c"
    $51 = tempRet0; //@line 29107 "c/sqlite3.c"
    $52 = (($$194106) + ($$097))|0; //@line 29106 "c/sqlite3.c"
    $53 = (($$3$lcssa) + ($52)|0); //@line 29106 "c/sqlite3.c"
    $54 = ($53>>>0)<($$0>>>0); //@line 29106 "c/sqlite3.c"
    if ($54) {
     $$194106 = $52;$39 = $53;$41 = $50;$42 = $51;
    } else {
     $$194$lcssa = $52;$$lcssa = 0;$56 = $51;$58 = $50;
     break;
    }
   }
   $55 = ($56|0)<(0); //@line 29109 "c/sqlite3.c"
   $57 = ($$095|0)!=(0);
   do {
    if ($55) {
     $69 = $57 ? 0 : -1; //@line 29110 "c/sqlite3.c"
     $70 = $57 ? -2147483648 : 2147483647; //@line 29110 "c/sqlite3.c"
     $71 = $1; //@line 29110 "c/sqlite3.c"
     $72 = $71; //@line 29110 "c/sqlite3.c"
     HEAP32[$72>>2] = $69; //@line 29110 "c/sqlite3.c"
     $73 = (($71) + 4)|0; //@line 29110 "c/sqlite3.c"
     $74 = $73; //@line 29110 "c/sqlite3.c"
     HEAP32[$74>>2] = $70; //@line 29110 "c/sqlite3.c"
     if ($$lcssa) {
      $$090 = 1;$$194$lcssa133144 = $$194$lcssa;$84 = $57;
      break L26;
     } else {
      $87 = $57;
     }
    } else {
     if ($57) {
      $59 = (_i64Subtract(0,0,($58|0),($56|0))|0); //@line 29112 "c/sqlite3.c"
      $60 = tempRet0; //@line 29112 "c/sqlite3.c"
      $61 = $1; //@line 29112 "c/sqlite3.c"
      $62 = $61; //@line 29112 "c/sqlite3.c"
      HEAP32[$62>>2] = $59; //@line 29112 "c/sqlite3.c"
      $63 = (($61) + 4)|0; //@line 29112 "c/sqlite3.c"
      $64 = $63; //@line 29112 "c/sqlite3.c"
      HEAP32[$64>>2] = $60; //@line 29112 "c/sqlite3.c"
      if ($$lcssa) {
       $$090 = 1;$$194$lcssa133144 = $$194$lcssa;$84 = 1;
       break L26;
      } else {
       $87 = 1;
       break;
      }
     } else {
      $65 = $1; //@line 29114 "c/sqlite3.c"
      $66 = $65; //@line 29114 "c/sqlite3.c"
      HEAP32[$66>>2] = $58; //@line 29114 "c/sqlite3.c"
      $67 = (($65) + 4)|0; //@line 29114 "c/sqlite3.c"
      $68 = $67; //@line 29114 "c/sqlite3.c"
      HEAP32[$68>>2] = $56; //@line 29114 "c/sqlite3.c"
      if ($$lcssa) {
       $$090 = 1;$$194$lcssa133144 = $$194$lcssa;$84 = 0;
       break L26;
      } else {
       $87 = 0;
       break;
      }
     }
    }
   } while(0);
   $75 = ($$194$lcssa|0)==(0); //@line 29120 "c/sqlite3.c"
   if ($75) {
    $86 = $87;
    label = 29;
   } else {
    $$old3 = ($$091|0)==(0); //@line 29121 "c/sqlite3.c"
    if ($$old3) {
     $$194$lcssa133143148 = $$194$lcssa;$88 = $87;
     label = 31;
    } else {
     $$090 = 1;$$194$lcssa133144 = $$194$lcssa;$84 = $87;
    }
   }
  } else {
   $33 = ($$095|0)!=(0);
   $34 = $1;
   $35 = $34;
   HEAP32[$35>>2] = 0;
   $36 = (($34) + 4)|0;
   $37 = $36;
   HEAP32[$37>>2] = 0;
   $86 = $33;
   label = 29;
  }
 } while(0);
 if ((label|0) == 29) {
  $76 = ($$2|0)==($$3$lcssa|0); //@line 29120 "c/sqlite3.c"
  $77 = ($$091|0)!=(0); //@line 29121 "c/sqlite3.c"
  $or$cond = $77 | $76; //@line 29121 "c/sqlite3.c"
  if ($or$cond) {
   $$090 = 1;$$194$lcssa133144 = 0;$84 = $86;
  } else {
   $$194$lcssa133143148 = 0;$88 = $86;
   label = 31;
  }
 }
 if ((label|0) == 31) {
  $$090 = 0;$$194$lcssa133144 = $$194$lcssa133143148;$84 = $88;
 }
 $78 = ($$097*19)|0; //@line 29127 "c/sqlite3.c"
 $79 = ($$194$lcssa133144>>>0)>($78>>>0); //@line 29127 "c/sqlite3.c"
 if ($79) {
  $$089 = 2;
  return ($$089|0); //@line 29152 "c/sqlite3.c"
 }
 $80 = ($$194$lcssa133144>>>0)<($78>>>0); //@line 29131 "c/sqlite3.c"
 if ($80) {
  $$089 = $$090;
  return ($$089|0); //@line 29152 "c/sqlite3.c"
 }
 $81 = (_compare2pow63($$3$lcssa,$$097)|0); //@line 29137 "c/sqlite3.c"
 $82 = ($81|0)<(0); //@line 29138 "c/sqlite3.c"
 if ($82) {
  $$089 = $$090;
  return ($$089|0); //@line 29152 "c/sqlite3.c"
 } else {
  $83 = ($81|0)==(0); //@line 29142 "c/sqlite3.c"
  $85 = $84 ? $$090 : 3; //@line 29149 "c/sqlite3.c"
  $spec$select101 = $83 ? $85 : 2; //@line 29142 "c/sqlite3.c"
  return ($spec$select101|0); //@line 29142 "c/sqlite3.c"
 }
 return (0)|0;
}
function _compare2pow63($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01617 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $$01617 = 0;
 while(1) {
  $2 = Math_imul($$01617, $1)|0; //@line 29048 "c/sqlite3.c"
  $3 = (($0) + ($2)|0); //@line 29048 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 29048 "c/sqlite3.c"
  $5 = $4 << 24 >> 24; //@line 29048 "c/sqlite3.c"
  $6 = (17235 + ($$01617)|0); //@line 29048 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 29048 "c/sqlite3.c"
  $8 = $7 << 24 >> 24; //@line 29048 "c/sqlite3.c"
  $9 = (($5) - ($8))|0; //@line 29048 "c/sqlite3.c"
  $10 = (($$01617) + 1)|0; //@line 29047 "c/sqlite3.c"
  $11 = ($9|0)==(0); //@line 29047 "c/sqlite3.c"
  $12 = ($10>>>0)<(18); //@line 29047 "c/sqlite3.c"
  $13 = $12 & $11; //@line 29047 "c/sqlite3.c"
  if ($13) {
   $$01617 = $10;
  } else {
   break;
  }
 }
 $14 = ($9*10)|0; //@line 29048 "c/sqlite3.c"
 if (!($11)) {
  $$1 = $14;
  return ($$1|0); //@line 29056 "c/sqlite3.c"
 }
 $15 = ($1*18)|0; //@line 29051 "c/sqlite3.c"
 $16 = (($0) + ($15)|0); //@line 29051 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 29051 "c/sqlite3.c"
 $18 = $17 << 24 >> 24; //@line 29051 "c/sqlite3.c"
 $19 = (($18) + -56)|0; //@line 29051 "c/sqlite3.c"
 $$1 = $19;
 return ($$1|0); //@line 29056 "c/sqlite3.c"
}
function _applyNumericAffinity($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0.0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 8|0;
 $3 = sp;
 $4 = ((($0)) + 10|0); //@line 80147 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 80147 "c/sqlite3.c"
 $6 = ((($0)) + 16|0); //@line 80149 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 80149 "c/sqlite3.c"
 $8 = ((($0)) + 12|0); //@line 80149 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 80149 "c/sqlite3.c"
 $10 = (_sqlite3AtoF($7,$2,$9,$5)|0); //@line 80149 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 80149 "c/sqlite3.c"
 if ($11) {
  STACKTOP = sp;return; //@line 80158 "c/sqlite3.c"
 }
 $12 = HEAP32[$6>>2]|0; //@line 80150 "c/sqlite3.c"
 $13 = HEAP32[$8>>2]|0; //@line 80150 "c/sqlite3.c"
 $14 = (_sqlite3Atoi64($12,$3,$13,$5)|0); //@line 80150 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 80150 "c/sqlite3.c"
 if ($15) {
  $16 = $3; //@line 80151 "c/sqlite3.c"
  $17 = $16; //@line 80151 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 80151 "c/sqlite3.c"
  $19 = (($16) + 4)|0; //@line 80151 "c/sqlite3.c"
  $20 = $19; //@line 80151 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 80151 "c/sqlite3.c"
  $22 = $0; //@line 80151 "c/sqlite3.c"
  $23 = $22; //@line 80151 "c/sqlite3.c"
  HEAP32[$23>>2] = $18; //@line 80151 "c/sqlite3.c"
  $24 = (($22) + 4)|0; //@line 80151 "c/sqlite3.c"
  $25 = $24; //@line 80151 "c/sqlite3.c"
  HEAP32[$25>>2] = $21; //@line 80151 "c/sqlite3.c"
  $26 = ((($0)) + 8|0); //@line 80152 "c/sqlite3.c"
  $27 = HEAP16[$26>>1]|0; //@line 80152 "c/sqlite3.c"
  $28 = $27 | 4; //@line 80152 "c/sqlite3.c"
  HEAP16[$26>>1] = $28; //@line 80152 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 80158 "c/sqlite3.c"
 }
 $29 = +HEAPF64[$2>>3]; //@line 80154 "c/sqlite3.c"
 HEAPF64[$0>>3] = $29; //@line 80154 "c/sqlite3.c"
 $30 = ((($0)) + 8|0); //@line 80155 "c/sqlite3.c"
 $31 = HEAP16[$30>>1]|0; //@line 80155 "c/sqlite3.c"
 $32 = $31 | 8; //@line 80155 "c/sqlite3.c"
 HEAP16[$30>>1] = $32; //@line 80155 "c/sqlite3.c"
 $33 = ($1|0)==(0); //@line 80156 "c/sqlite3.c"
 if ($33) {
  STACKTOP = sp;return; //@line 80158 "c/sqlite3.c"
 }
 _sqlite3VdbeIntegerAffinity($0); //@line 80156 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 80158 "c/sqlite3.c"
}
function _sqlite3VdbeIntegerAffinity($0) {
 $0 = $0|0;
 var $1 = 0.0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = +HEAPF64[$0>>3]; //@line 71731 "c/sqlite3.c"
 $2 = (_doubleToInt64($1)|0); //@line 71731 "c/sqlite3.c"
 $3 = tempRet0; //@line 71731 "c/sqlite3.c"
 $4 = (+($2>>>0)) + (4294967296.0*(+($3|0))); //@line 71743 "c/sqlite3.c"
 $5 = $1 == $4; //@line 71743 "c/sqlite3.c"
 $6 = (_i64Add(($2|0),($3|0),1,-2147483648)|0); //@line 71743 "c/sqlite3.c"
 $7 = tempRet0; //@line 71743 "c/sqlite3.c"
 $8 = ($7>>>0)>(0); //@line 71743 "c/sqlite3.c"
 $9 = ($6>>>0)>(1); //@line 71743 "c/sqlite3.c"
 $10 = ($7|0)==(0); //@line 71743 "c/sqlite3.c"
 $11 = $10 & $9; //@line 71743 "c/sqlite3.c"
 $12 = $8 | $11; //@line 71743 "c/sqlite3.c"
 $13 = $12 & $5; //@line 71743 "c/sqlite3.c"
 if (!($13)) {
  return; //@line 71747 "c/sqlite3.c"
 }
 $14 = $0; //@line 71744 "c/sqlite3.c"
 $15 = $14; //@line 71744 "c/sqlite3.c"
 HEAP32[$15>>2] = $2; //@line 71744 "c/sqlite3.c"
 $16 = (($14) + 4)|0; //@line 71744 "c/sqlite3.c"
 $17 = $16; //@line 71744 "c/sqlite3.c"
 HEAP32[$17>>2] = $3; //@line 71744 "c/sqlite3.c"
 $18 = ((($0)) + 8|0); //@line 71745 "c/sqlite3.c"
 $19 = HEAP16[$18>>1]|0; //@line 71745 "c/sqlite3.c"
 $20 = $19 & 15872; //@line 71745 "c/sqlite3.c"
 $21 = $20 | 4; //@line 71745 "c/sqlite3.c"
 HEAP16[$18>>1] = $21; //@line 71745 "c/sqlite3.c"
 return; //@line 71747 "c/sqlite3.c"
}
function _sqlite3_value_int($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3VdbeIntValue($0)|0); //@line 77898 "c/sqlite3.c"
 $2 = tempRet0; //@line 77898 "c/sqlite3.c"
 return ($1|0); //@line 77898 "c/sqlite3.c"
}
function _sqlite3_value_blob($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 77877 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 77877 "c/sqlite3.c"
 $3 = $2&65535; //@line 77877 "c/sqlite3.c"
 $4 = $3 & 18; //@line 77877 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 77877 "c/sqlite3.c"
 if ($5) {
  $16 = (_sqlite3_value_text($0)|0); //@line 77885 "c/sqlite3.c"
  $$0 = $16;
  return ($$0|0); //@line 77887 "c/sqlite3.c"
 }
 $6 = $3 & 16384; //@line 77878 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 77878 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_sqlite3VdbeMemExpandBlob($0)|0); //@line 77878 "c/sqlite3.c"
  $phitmp = ($8|0)==(0); //@line 77878 "c/sqlite3.c"
  if (!($phitmp)) {
   $$0 = 0;
   return ($$0|0); //@line 77887 "c/sqlite3.c"
  }
 }
 $9 = HEAP16[$1>>1]|0; //@line 77882 "c/sqlite3.c"
 $10 = $9 | 16; //@line 77882 "c/sqlite3.c"
 HEAP16[$1>>1] = $10; //@line 77882 "c/sqlite3.c"
 $11 = ((($0)) + 12|0); //@line 77883 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 77883 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 77883 "c/sqlite3.c"
 if ($13) {
  $$0 = 0;
  return ($$0|0); //@line 77887 "c/sqlite3.c"
 }
 $14 = ((($0)) + 16|0); //@line 77883 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 77883 "c/sqlite3.c"
 $$0 = $15;
 return ($$0|0); //@line 77887 "c/sqlite3.c"
}
function _sqlite3_result_text64($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $10 = 0, $11 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ($3>>>0)>(0); //@line 78140 "c/sqlite3.c"
 $7 = ($2>>>0)>(2147483647); //@line 78140 "c/sqlite3.c"
 $8 = ($3|0)==(0); //@line 78140 "c/sqlite3.c"
 $9 = $8 & $7; //@line 78140 "c/sqlite3.c"
 $10 = $6 | $9; //@line 78140 "c/sqlite3.c"
 if ($10) {
  _invokeValueDestructor($1,$4,$0); //@line 78141 "c/sqlite3.c"
  return; //@line 78145 "c/sqlite3.c"
 } else {
  $11 = ($5<<24>>24)==(4); //@line 78139 "c/sqlite3.c"
  $spec$select = $11 ? 2 : $5; //@line 78139 "c/sqlite3.c"
  _setResultStrOrError($0,$1,$2,$spec$select,$4); //@line 78143 "c/sqlite3.c"
  return; //@line 78145 "c/sqlite3.c"
 }
}
function _sqlite3_result_blob64($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($3>>>0)>(0); //@line 78067 "c/sqlite3.c"
 $6 = ($2>>>0)>(2147483647); //@line 78067 "c/sqlite3.c"
 $7 = ($3|0)==(0); //@line 78067 "c/sqlite3.c"
 $8 = $7 & $6; //@line 78067 "c/sqlite3.c"
 $9 = $5 | $8; //@line 78067 "c/sqlite3.c"
 if ($9) {
  _invokeValueDestructor($1,$4,$0); //@line 78068 "c/sqlite3.c"
  return; //@line 78072 "c/sqlite3.c"
 } else {
  _setResultStrOrError($0,$1,$2,0,$4); //@line 78070 "c/sqlite3.c"
  return; //@line 78072 "c/sqlite3.c"
 }
}
function _invokeValueDestructor($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $magicptr = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $magicptr = $1; //@line 78039 "c/sqlite3.c"
 switch ($magicptr|0) {
 case 0: case -1:  {
  break;
 }
 default: {
  FUNCTION_TABLE_vi[$1 & 127]($0); //@line 78044 "c/sqlite3.c"
 }
 }
 $3 = ($2|0)==(0|0); //@line 78046 "c/sqlite3.c"
 if ($3) {
  return;
 }
 _sqlite3_result_error_toobig($2); //@line 78046 "c/sqlite3.c"
 return;
}
function _sqlite3_result_zeroblob64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 78184 "c/sqlite3.c"
 $4 = ((($3)) + 32|0); //@line 78186 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 78186 "c/sqlite3.c"
 $6 = ((($5)) + 100|0); //@line 78186 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 78186 "c/sqlite3.c"
 $8 = ($7|0)<(0); //@line 78186 "c/sqlite3.c"
 $9 = $8 << 31 >> 31; //@line 78186 "c/sqlite3.c"
 $10 = ($9>>>0)<($2>>>0); //@line 78186 "c/sqlite3.c"
 $11 = ($7>>>0)<($1>>>0); //@line 78186 "c/sqlite3.c"
 $12 = ($9|0)==($2|0); //@line 78186 "c/sqlite3.c"
 $13 = $12 & $11; //@line 78186 "c/sqlite3.c"
 $14 = $10 | $13; //@line 78186 "c/sqlite3.c"
 if ($14) {
  $$0 = 18;
  return ($$0|0); //@line 78191 "c/sqlite3.c"
 }
 _sqlite3VdbeMemSetZeroBlob($3,$1); //@line 78189 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 78191 "c/sqlite3.c"
}
function _sqlite3_result_error_code($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 78193 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 78193 "c/sqlite3.c"
 $3 = ((($0)) + 25|0); //@line 78194 "c/sqlite3.c"
 HEAP8[$3>>0] = 1; //@line 78194 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 78198 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 78198 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 78198 "c/sqlite3.c"
 $7 = $6 & 1; //@line 78198 "c/sqlite3.c"
 $8 = ($7<<16>>16)==(0); //@line 78198 "c/sqlite3.c"
 if ($8) {
  return; //@line 78202 "c/sqlite3.c"
 }
 $9 = (_sqlite3ErrStr($1)|0); //@line 78199 "c/sqlite3.c"
 (_sqlite3VdbeMemSetStr($4,$9,-1,1,0)|0); //@line 78199 "c/sqlite3.c"
 return; //@line 78202 "c/sqlite3.c"
}
function _sqlite3ErrStr($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cond = ($0|0)==(516); //@line 144808 "c/sqlite3.c"
 if ($cond) {
  $$0 = 17268;
 } else {
  $1 = $0 & 255; //@line 144814 "c/sqlite3.c"
  $2 = ($1>>>0)<(27); //@line 144815 "c/sqlite3.c"
  if ($2) {
   $3 = 113180667 >>> $1; //@line 144815 "c/sqlite3.c"
   $4 = $3 & 1; //@line 144815 "c/sqlite3.c"
   $5 = ($4|0)==(0); //@line 144815 "c/sqlite3.c"
   if ($5) {
    $$0 = 17254;
   } else {
    $6 = (3792 + ($1<<2)|0); //@line 144815 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 144815 "c/sqlite3.c"
    $$0 = $7;
   }
  } else {
   $$0 = 17254;
  }
 }
 return ($$0|0); //@line 144821 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetZeroBlob($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3VdbeMemRelease($0); //@line 71892 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 71893 "c/sqlite3.c"
 HEAP16[$2>>1] = 16400; //@line 71893 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 71894 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 71894 "c/sqlite3.c"
 $4 = ($1|0)>(0); //@line 71895 "c/sqlite3.c"
 $spec$select = $4 ? $1 : 0; //@line 71895 "c/sqlite3.c"
 HEAP32[$0>>2] = $spec$select; //@line 71896 "c/sqlite3.c"
 $5 = ((($0)) + 10|0); //@line 71897 "c/sqlite3.c"
 HEAP8[$5>>0] = 1; //@line 71897 "c/sqlite3.c"
 $6 = ((($0)) + 16|0); //@line 71898 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 71898 "c/sqlite3.c"
 return; //@line 71899 "c/sqlite3.c"
}
function _sqlite3_result_value($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 78177 "c/sqlite3.c"
 (_sqlite3VdbeMemCopy($2,$1)|0); //@line 78177 "c/sqlite3.c"
 return; //@line 78178 "c/sqlite3.c"
}
function _contextMalloc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_context_db_handle($0)|0); //@line 107920 "c/sqlite3.c"
 $4 = ((($3)) + 100|0); //@line 107924 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 107924 "c/sqlite3.c"
 $6 = ($5|0)<(0); //@line 107924 "c/sqlite3.c"
 $7 = $6 << 31 >> 31; //@line 107924 "c/sqlite3.c"
 $8 = ($7|0)<($2|0); //@line 107924 "c/sqlite3.c"
 $9 = ($5>>>0)<($1>>>0); //@line 107924 "c/sqlite3.c"
 $10 = ($7|0)==($2|0); //@line 107924 "c/sqlite3.c"
 $11 = $10 & $9; //@line 107924 "c/sqlite3.c"
 $12 = $8 | $11; //@line 107924 "c/sqlite3.c"
 if ($12) {
  _sqlite3_result_error_toobig($0); //@line 107925 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 107933 "c/sqlite3.c"
 }
 $13 = (_sqlite3Malloc($1,$2)|0); //@line 107928 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 107929 "c/sqlite3.c"
 if (!($14)) {
  $$0 = $13;
  return ($$0|0); //@line 107933 "c/sqlite3.c"
 }
 _sqlite3_result_error_nomem($0); //@line 107930 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 107933 "c/sqlite3.c"
}
function _sqlite3VdbeMemCopy($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 72052 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 72052 "c/sqlite3.c"
 $4 = $3 & 9312; //@line 72052 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 72052 "c/sqlite3.c"
 if (!($5)) {
  _vdbeMemClearExternAndSetNull($0); //@line 72052 "c/sqlite3.c"
 }
 ;HEAP32[$0>>2]=HEAP32[$1>>2]|0;HEAP32[$0+4>>2]=HEAP32[$1+4>>2]|0;HEAP32[$0+8>>2]=HEAP32[$1+8>>2]|0;HEAP32[$0+12>>2]=HEAP32[$1+12>>2]|0;HEAP32[$0+16>>2]=HEAP32[$1+16>>2]|0; //@line 72053 "c/sqlite3.c"
 $6 = HEAP16[$2>>1]|0; //@line 72054 "c/sqlite3.c"
 $7 = $6 & -1025; //@line 72054 "c/sqlite3.c"
 HEAP16[$2>>1] = $7; //@line 72054 "c/sqlite3.c"
 $8 = $7&65535; //@line 72055 "c/sqlite3.c"
 $9 = $8 & 18; //@line 72055 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 72055 "c/sqlite3.c"
 if ($10) {
  $$0 = 0;
  return ($$0|0); //@line 72062 "c/sqlite3.c"
 }
 $11 = ((($1)) + 8|0); //@line 72056 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 72056 "c/sqlite3.c"
 $13 = $12 & 2048; //@line 72056 "c/sqlite3.c"
 $14 = ($13<<16>>16)==(0); //@line 72056 "c/sqlite3.c"
 if (!($14)) {
  $$0 = 0;
  return ($$0|0); //@line 72062 "c/sqlite3.c"
 }
 $15 = $8 | 4096; //@line 72057 "c/sqlite3.c"
 $16 = $15&65535; //@line 72057 "c/sqlite3.c"
 HEAP16[$2>>1] = $16; //@line 72057 "c/sqlite3.c"
 $17 = (_sqlite3VdbeMemMakeWriteable($0)|0); //@line 72058 "c/sqlite3.c"
 $$0 = $17;
 return ($$0|0); //@line 72062 "c/sqlite3.c"
}
function _sqlite3_total_changes($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 96|0); //@line 144335 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144335 "c/sqlite3.c"
 return ($2|0); //@line 144335 "c/sqlite3.c"
}
function _sqlite3_changes($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 92|0); //@line 144322 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144322 "c/sqlite3.c"
 return ($2|0); //@line 144322 "c/sqlite3.c"
}
function _sqlite3_last_insert_rowid($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 32|0); //@line 144294 "c/sqlite3.c"
 $2 = $1; //@line 144294 "c/sqlite3.c"
 $3 = $2; //@line 144294 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 144294 "c/sqlite3.c"
 $5 = (($2) + 4)|0; //@line 144294 "c/sqlite3.c"
 $6 = $5; //@line 144294 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 144294 "c/sqlite3.c"
 tempRet0 = ($7); //@line 144294 "c/sqlite3.c"
 return ($4|0); //@line 144294 "c/sqlite3.c"
}
function _sqlite3GetFuncCollSeq($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 107540 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 107540 "c/sqlite3.c"
 $3 = ((($2)) + 88|0); //@line 107540 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 107540 "c/sqlite3.c"
 $5 = ((($0)) + 16|0); //@line 107540 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 107540 "c/sqlite3.c"
 $7 = (($6) + -1)|0; //@line 107540 "c/sqlite3.c"
 $8 = (((($4) + (($7*20)|0)|0)) + 16|0); //@line 107543 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 107543 "c/sqlite3.c"
 return ($9|0); //@line 107543 "c/sqlite3.c"
}
function _sqlite3MemCompare($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$0 = 0, $$42 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0.0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0.0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0.0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $82 = 0, $83 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 76838 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 76838 "c/sqlite3.c"
 $5 = $4&65535; //@line 76838 "c/sqlite3.c"
 $6 = ((($1)) + 8|0); //@line 76839 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 76839 "c/sqlite3.c"
 $8 = $7&65535; //@line 76839 "c/sqlite3.c"
 $9 = $7 | $4; //@line 76840 "c/sqlite3.c"
 $10 = $9&65535; //@line 76840 "c/sqlite3.c"
 $11 = $10 & 1; //@line 76846 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 76846 "c/sqlite3.c"
 if (!($12)) {
  $13 = $8 & 1; //@line 76847 "c/sqlite3.c"
  $14 = $5 & 1; //@line 76847 "c/sqlite3.c"
  $15 = (($13) - ($14))|0; //@line 76847 "c/sqlite3.c"
  $$0 = $15;
  return ($$0|0); //@line 76910 "c/sqlite3.c"
 }
 $16 = $10 & 12; //@line 76852 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 76852 "c/sqlite3.c"
 if ($17) {
  $75 = $10 & 2; //@line 76883 "c/sqlite3.c"
  $76 = ($75|0)==(0); //@line 76883 "c/sqlite3.c"
  if (!($76)) {
   $77 = $5 & 2; //@line 76884 "c/sqlite3.c"
   $78 = ($77|0)==(0); //@line 76884 "c/sqlite3.c"
   if ($78) {
    $$0 = 1;
    return ($$0|0); //@line 76910 "c/sqlite3.c"
   }
   $79 = $8 & 2; //@line 76887 "c/sqlite3.c"
   $80 = ($79|0)==(0); //@line 76887 "c/sqlite3.c"
   if ($80) {
    $$0 = -1;
    return ($$0|0); //@line 76910 "c/sqlite3.c"
   }
   $81 = ($2|0)==(0|0); //@line 76901 "c/sqlite3.c"
   if (!($81)) {
    $82 = (_vdbeCompareMemString($0,$1,$2,0)|0); //@line 76902 "c/sqlite3.c"
    $$0 = $82;
    return ($$0|0); //@line 76910 "c/sqlite3.c"
   }
  }
  $83 = (_sqlite3BlobCompare($0,$1)|0); //@line 76909 "c/sqlite3.c"
  $$0 = $83;
  return ($$0|0); //@line 76910 "c/sqlite3.c"
 }
 $18 = $7 & $4; //@line 76853 "c/sqlite3.c"
 $19 = $18&65535; //@line 76853 "c/sqlite3.c"
 $20 = $19 & 4; //@line 76853 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 76853 "c/sqlite3.c"
 if (!($21)) {
  $22 = $0; //@line 76854 "c/sqlite3.c"
  $23 = $22; //@line 76854 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 76854 "c/sqlite3.c"
  $25 = (($22) + 4)|0; //@line 76854 "c/sqlite3.c"
  $26 = $25; //@line 76854 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 76854 "c/sqlite3.c"
  $28 = $1; //@line 76854 "c/sqlite3.c"
  $29 = $28; //@line 76854 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 76854 "c/sqlite3.c"
  $31 = (($28) + 4)|0; //@line 76854 "c/sqlite3.c"
  $32 = $31; //@line 76854 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 76854 "c/sqlite3.c"
  $34 = ($27|0)<($33|0); //@line 76854 "c/sqlite3.c"
  $35 = ($24>>>0)<($30>>>0); //@line 76854 "c/sqlite3.c"
  $36 = ($27|0)==($33|0); //@line 76854 "c/sqlite3.c"
  $37 = $36 & $35; //@line 76854 "c/sqlite3.c"
  $38 = $34 | $37; //@line 76854 "c/sqlite3.c"
  $39 = ($27|0)>($33|0); //@line 76855 "c/sqlite3.c"
  $40 = ($24>>>0)>($30>>>0); //@line 76855 "c/sqlite3.c"
  $41 = ($27|0)==($33|0); //@line 76855 "c/sqlite3.c"
  $42 = $41 & $40; //@line 76855 "c/sqlite3.c"
  $43 = $39 | $42; //@line 76855 "c/sqlite3.c"
  $$ = $43&1; //@line 76855 "c/sqlite3.c"
  $spec$select = $38 ? -1 : $$; //@line 76854 "c/sqlite3.c"
  return ($spec$select|0); //@line 76854 "c/sqlite3.c"
 }
 $44 = $19 & 8; //@line 76858 "c/sqlite3.c"
 $45 = ($44|0)==(0); //@line 76858 "c/sqlite3.c"
 if (!($45)) {
  $46 = +HEAPF64[$0>>3]; //@line 76859 "c/sqlite3.c"
  $47 = +HEAPF64[$1>>3]; //@line 76859 "c/sqlite3.c"
  $48 = $46 < $47; //@line 76859 "c/sqlite3.c"
  if ($48) {
   $$0 = -1;
   return ($$0|0); //@line 76910 "c/sqlite3.c"
  }
  $49 = $46 > $47; //@line 76860 "c/sqlite3.c"
  $$42 = $49&1; //@line 76860 "c/sqlite3.c"
  $$0 = $$42;
  return ($$0|0); //@line 76910 "c/sqlite3.c"
 }
 $50 = $5 & 4; //@line 76863 "c/sqlite3.c"
 $51 = ($50|0)==(0); //@line 76863 "c/sqlite3.c"
 if (!($51)) {
  $52 = $8 & 8; //@line 76864 "c/sqlite3.c"
  $53 = ($52|0)==(0); //@line 76864 "c/sqlite3.c"
  if ($53) {
   $$0 = -1;
   return ($$0|0); //@line 76910 "c/sqlite3.c"
  }
  $54 = $0; //@line 76865 "c/sqlite3.c"
  $55 = $54; //@line 76865 "c/sqlite3.c"
  $56 = HEAP32[$55>>2]|0; //@line 76865 "c/sqlite3.c"
  $57 = (($54) + 4)|0; //@line 76865 "c/sqlite3.c"
  $58 = $57; //@line 76865 "c/sqlite3.c"
  $59 = HEAP32[$58>>2]|0; //@line 76865 "c/sqlite3.c"
  $60 = +HEAPF64[$1>>3]; //@line 76865 "c/sqlite3.c"
  $61 = (_sqlite3IntFloatCompare($56,$59,$60)|0); //@line 76865 "c/sqlite3.c"
  $$0 = $61;
  return ($$0|0); //@line 76910 "c/sqlite3.c"
 }
 $62 = $5 & 8; //@line 76870 "c/sqlite3.c"
 $63 = ($62|0)==(0); //@line 76870 "c/sqlite3.c"
 if ($63) {
  $$0 = 1;
  return ($$0|0); //@line 76910 "c/sqlite3.c"
 }
 $64 = $8 & 4; //@line 76871 "c/sqlite3.c"
 $65 = ($64|0)==(0); //@line 76871 "c/sqlite3.c"
 if ($65) {
  $$0 = -1;
  return ($$0|0); //@line 76910 "c/sqlite3.c"
 }
 $66 = $1; //@line 76872 "c/sqlite3.c"
 $67 = $66; //@line 76872 "c/sqlite3.c"
 $68 = HEAP32[$67>>2]|0; //@line 76872 "c/sqlite3.c"
 $69 = (($66) + 4)|0; //@line 76872 "c/sqlite3.c"
 $70 = $69; //@line 76872 "c/sqlite3.c"
 $71 = HEAP32[$70>>2]|0; //@line 76872 "c/sqlite3.c"
 $72 = +HEAPF64[$0>>3]; //@line 76872 "c/sqlite3.c"
 $73 = (_sqlite3IntFloatCompare($68,$71,$72)|0); //@line 76872 "c/sqlite3.c"
 $74 = (0 - ($73))|0; //@line 76872 "c/sqlite3.c"
 $$0 = $74;
 return ($$0|0); //@line 76910 "c/sqlite3.c"
}
function _sqlite3IntFloatCompare($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = +$2;
 var $$ = 0, $$0 = 0, $$18 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0.0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $2 < -9.2233720368547758E+18; //@line 76810 "c/sqlite3.c"
 if ($3) {
  $$0 = 1;
  return ($$0|0); //@line 76823 "c/sqlite3.c"
 }
 $4 = $2 > 9.2233720368547758E+18; //@line 76811 "c/sqlite3.c"
 if ($4) {
  $$0 = -1;
  return ($$0|0); //@line 76823 "c/sqlite3.c"
 }
 $5 = (~~$2)>>>0; //@line 76812 "c/sqlite3.c"
 $6 = +Math_abs($2) >= 1.0 ? $2 > 0.0 ? (~~+Math_min(+Math_floor($2 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($2 - +(~~$2 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 76812 "c/sqlite3.c"
 $7 = ($6|0)>($1|0); //@line 76813 "c/sqlite3.c"
 $8 = ($5>>>0)>($0>>>0); //@line 76813 "c/sqlite3.c"
 $9 = ($6|0)==($1|0); //@line 76813 "c/sqlite3.c"
 $10 = $9 & $8; //@line 76813 "c/sqlite3.c"
 $11 = $7 | $10; //@line 76813 "c/sqlite3.c"
 if ($11) {
  $$0 = -1;
  return ($$0|0); //@line 76823 "c/sqlite3.c"
 }
 $12 = ($6|0)<($1|0); //@line 76814 "c/sqlite3.c"
 $13 = ($5>>>0)<($0>>>0); //@line 76814 "c/sqlite3.c"
 $14 = ($6|0)==($1|0); //@line 76814 "c/sqlite3.c"
 $15 = $14 & $13; //@line 76814 "c/sqlite3.c"
 $16 = $12 | $15; //@line 76814 "c/sqlite3.c"
 if ($16) {
  $17 = ($5|0)==(0); //@line 76815 "c/sqlite3.c"
  $18 = ($6|0)==(-2147483648); //@line 76815 "c/sqlite3.c"
  $19 = $17 & $18; //@line 76815 "c/sqlite3.c"
  $20 = $2 > 0.0; //@line 76815 "c/sqlite3.c"
  $or$cond = $20 & $19; //@line 76815 "c/sqlite3.c"
  $$ = $or$cond ? -1 : 1; //@line 76815 "c/sqlite3.c"
  $$0 = $$;
  return ($$0|0); //@line 76823 "c/sqlite3.c"
 }
 $21 = (+($0>>>0)) + (4294967296.0*(+($1|0))); //@line 76818 "c/sqlite3.c"
 $22 = $21 < $2; //@line 76819 "c/sqlite3.c"
 if ($22) {
  $$0 = -1;
  return ($$0|0); //@line 76823 "c/sqlite3.c"
 }
 $23 = $21 > $2; //@line 76820 "c/sqlite3.c"
 $$18 = $23&1; //@line 76820 "c/sqlite3.c"
 $$0 = $$18;
 return ($$0|0); //@line 76823 "c/sqlite3.c"
}
function _vdbeCompareMemString($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$029 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $4 = sp + 40|0;
 $5 = sp;
 $6 = ((($0)) + 10|0); //@line 76724 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 76724 "c/sqlite3.c"
 $8 = ((($2)) + 4|0); //@line 76724 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 76724 "c/sqlite3.c"
 $10 = ($7<<24>>24)==($9<<24>>24); //@line 76724 "c/sqlite3.c"
 if ($10) {
  $11 = ((($2)) + 12|0); //@line 76727 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 76727 "c/sqlite3.c"
  $13 = ((($2)) + 8|0); //@line 76727 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 76727 "c/sqlite3.c"
  $15 = ((($0)) + 12|0); //@line 76727 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 76727 "c/sqlite3.c"
  $17 = ((($0)) + 16|0); //@line 76727 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 76727 "c/sqlite3.c"
  $19 = ((($1)) + 12|0); //@line 76727 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 76727 "c/sqlite3.c"
  $21 = ((($1)) + 16|0); //@line 76727 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 76727 "c/sqlite3.c"
  $23 = (FUNCTION_TABLE_iiiiii[$12 & 127]($14,$16,$18,$20,$22)|0); //@line 76727 "c/sqlite3.c"
  $$0 = $23;
  STACKTOP = sp;return ($$0|0); //@line 76749 "c/sqlite3.c"
 }
 $24 = ((($0)) + 32|0); //@line 76733 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 76733 "c/sqlite3.c"
 _sqlite3VdbeMemInit($4,$25,1); //@line 76733 "c/sqlite3.c"
 $26 = HEAP32[$24>>2]|0; //@line 76734 "c/sqlite3.c"
 _sqlite3VdbeMemInit($5,$26,1); //@line 76734 "c/sqlite3.c"
 _sqlite3VdbeMemShallowCopy($4,$0,4096); //@line 76735 "c/sqlite3.c"
 _sqlite3VdbeMemShallowCopy($5,$1,4096); //@line 76736 "c/sqlite3.c"
 $27 = HEAP8[$8>>0]|0; //@line 76737 "c/sqlite3.c"
 $28 = (_sqlite3ValueText($4,$27)|0); //@line 76737 "c/sqlite3.c"
 $29 = HEAP8[$8>>0]|0; //@line 76738 "c/sqlite3.c"
 $30 = (_sqlite3ValueText($5,$29)|0); //@line 76738 "c/sqlite3.c"
 $31 = ($28|0)==(0|0); //@line 76739 "c/sqlite3.c"
 $32 = ($30|0)==(0|0); //@line 76739 "c/sqlite3.c"
 $or$cond = $31 | $32; //@line 76739 "c/sqlite3.c"
 if ($or$cond) {
  $33 = ($3|0)==(0|0); //@line 76740 "c/sqlite3.c"
  if ($33) {
   $$029 = 0;
  } else {
   HEAP8[$3>>0] = 7; //@line 76740 "c/sqlite3.c"
   $$029 = 0;
  }
 } else {
  $34 = ((($2)) + 12|0); //@line 76743 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 76743 "c/sqlite3.c"
  $36 = ((($2)) + 8|0); //@line 76743 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 76743 "c/sqlite3.c"
  $38 = ((($4)) + 12|0); //@line 76743 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 76743 "c/sqlite3.c"
  $40 = ((($5)) + 12|0); //@line 76743 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 76743 "c/sqlite3.c"
  $42 = (FUNCTION_TABLE_iiiiii[$35 & 127]($37,$39,$28,$41,$30)|0); //@line 76743 "c/sqlite3.c"
  $$029 = $42;
 }
 _sqlite3VdbeMemRelease($4); //@line 76745 "c/sqlite3.c"
 _sqlite3VdbeMemRelease($5); //@line 76746 "c/sqlite3.c"
 $$0 = $$029;
 STACKTOP = sp;return ($$0|0); //@line 76749 "c/sqlite3.c"
}
function _sqlite3BlobCompare($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 76770 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 76770 "c/sqlite3.c"
 $4 = ((($1)) + 12|0); //@line 76771 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 76771 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 76780 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 76780 "c/sqlite3.c"
 $8 = ((($1)) + 8|0); //@line 76780 "c/sqlite3.c"
 $9 = HEAP16[$8>>1]|0; //@line 76780 "c/sqlite3.c"
 $10 = $9 | $7; //@line 76780 "c/sqlite3.c"
 $11 = $10 & 16384; //@line 76780 "c/sqlite3.c"
 $12 = ($11<<16>>16)==(0); //@line 76780 "c/sqlite3.c"
 if ($12) {
  $33 = ((($0)) + 16|0); //@line 76791 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 76791 "c/sqlite3.c"
  $35 = ((($1)) + 16|0); //@line 76791 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 76791 "c/sqlite3.c"
  $37 = ($3|0)>($5|0); //@line 76791 "c/sqlite3.c"
  $38 = $37 ? $5 : $3; //@line 76791 "c/sqlite3.c"
  $39 = (_memcmp($34,$36,$38)|0); //@line 76791 "c/sqlite3.c"
  $40 = ($39|0)==(0); //@line 76792 "c/sqlite3.c"
  $41 = (($3) - ($5))|0; //@line 76793 "c/sqlite3.c"
  $spec$select = $40 ? $41 : $39; //@line 76792 "c/sqlite3.c"
  return ($spec$select|0); //@line 76792 "c/sqlite3.c"
 }
 $13 = $7 & 16384; //@line 76781 "c/sqlite3.c"
 $14 = $13 & $9; //@line 76781 "c/sqlite3.c"
 $15 = ($14<<16>>16)==(0); //@line 76781 "c/sqlite3.c"
 if (!($15)) {
  $16 = HEAP32[$0>>2]|0; //@line 76782 "c/sqlite3.c"
  $17 = HEAP32[$1>>2]|0; //@line 76782 "c/sqlite3.c"
  $18 = (($16) - ($17))|0; //@line 76782 "c/sqlite3.c"
  $$0 = $18;
  return ($$0|0); //@line 76794 "c/sqlite3.c"
 }
 $19 = $7 & 16384; //@line 76783 "c/sqlite3.c"
 $20 = ($19<<16>>16)==(0); //@line 76783 "c/sqlite3.c"
 if ($20) {
  $27 = ((($0)) + 16|0); //@line 76787 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 76787 "c/sqlite3.c"
  $29 = (_isAllZero($28,$3)|0); //@line 76787 "c/sqlite3.c"
  $30 = ($29|0)==(0); //@line 76787 "c/sqlite3.c"
  if ($30) {
   $$0 = 1;
   return ($$0|0); //@line 76794 "c/sqlite3.c"
  }
  $31 = HEAP32[$1>>2]|0; //@line 76788 "c/sqlite3.c"
  $32 = (($3) - ($31))|0; //@line 76788 "c/sqlite3.c"
  $$0 = $32;
  return ($$0|0); //@line 76794 "c/sqlite3.c"
 } else {
  $21 = ((($1)) + 16|0); //@line 76784 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 76784 "c/sqlite3.c"
  $23 = (_isAllZero($22,$5)|0); //@line 76784 "c/sqlite3.c"
  $24 = ($23|0)==(0); //@line 76784 "c/sqlite3.c"
  if ($24) {
   $$0 = -1;
   return ($$0|0); //@line 76794 "c/sqlite3.c"
  }
  $25 = HEAP32[$0>>2]|0; //@line 76785 "c/sqlite3.c"
  $26 = (($25) - ($5))|0; //@line 76785 "c/sqlite3.c"
  $$0 = $26;
  return ($$0|0); //@line 76794 "c/sqlite3.c"
 }
 return (0)|0;
}
function _isAllZero($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$06 = 0, $$07 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 76757 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$07 = 0;
   while(1) {
    $5 = (($0) + ($$07)|0); //@line 76758 "c/sqlite3.c"
    $6 = HEAP8[$5>>0]|0; //@line 76758 "c/sqlite3.c"
    $7 = ($6<<24>>24)==(0); //@line 76758 "c/sqlite3.c"
    $4 = (($$07) + 1)|0; //@line 76757 "c/sqlite3.c"
    if (!($7)) {
     $$06 = 0;
     break L1;
    }
    $3 = ($4|0)<($1|0); //@line 76757 "c/sqlite3.c"
    if ($3) {
     $$07 = $4;
    } else {
     $$06 = 1;
     break;
    }
   }
  } else {
   $$06 = 1;
  }
 } while(0);
 return ($$06|0); //@line 76761 "c/sqlite3.c"
}
function _sqlite3VdbeMemInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 71858 "c/sqlite3.c"
 HEAP16[$3>>1] = $2; //@line 71858 "c/sqlite3.c"
 $4 = ((($0)) + 32|0); //@line 71859 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 71859 "c/sqlite3.c"
 $5 = ((($0)) + 24|0); //@line 71860 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 71860 "c/sqlite3.c"
 return; //@line 71861 "c/sqlite3.c"
}
function _sqlite3VdbeMemShallowCopy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 72035 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 72035 "c/sqlite3.c"
 $5 = $4 & 9312; //@line 72035 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 72035 "c/sqlite3.c"
 if (!($6)) {
  _vdbeClrCopy($0,$1,$2); //@line 72035 "c/sqlite3.c"
  return; //@line 72042 "c/sqlite3.c"
 }
 ;HEAP32[$0>>2]=HEAP32[$1>>2]|0;HEAP32[$0+4>>2]=HEAP32[$1+4>>2]|0;HEAP32[$0+8>>2]=HEAP32[$1+8>>2]|0;HEAP32[$0+12>>2]=HEAP32[$1+12>>2]|0;HEAP32[$0+16>>2]=HEAP32[$1+16>>2]|0; //@line 72036 "c/sqlite3.c"
 $7 = ((($1)) + 8|0); //@line 72037 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 72037 "c/sqlite3.c"
 $9 = $8 & 2048; //@line 72037 "c/sqlite3.c"
 $10 = ($9<<16>>16)==(0); //@line 72037 "c/sqlite3.c"
 if (!($10)) {
  return; //@line 72042 "c/sqlite3.c"
 }
 $11 = HEAP16[$3>>1]|0; //@line 72038 "c/sqlite3.c"
 $12 = $11 & -7169; //@line 72038 "c/sqlite3.c"
 $13 = $12&65535; //@line 72040 "c/sqlite3.c"
 $14 = $13 | $2; //@line 72040 "c/sqlite3.c"
 $15 = $14&65535; //@line 72040 "c/sqlite3.c"
 HEAP16[$3>>1] = $15; //@line 72040 "c/sqlite3.c"
 return; //@line 72042 "c/sqlite3.c"
}
function _vdbeClrCopy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _vdbeMemClearExternAndSetNull($0); //@line 72028 "c/sqlite3.c"
 _sqlite3VdbeMemShallowCopy($0,$1,$2); //@line 72030 "c/sqlite3.c"
 return; //@line 72031 "c/sqlite3.c"
}
function _sqlite3_result_blob($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _setResultStrOrError($0,$1,$2,0,$3); //@line 78057 "c/sqlite3.c"
 return; //@line 78058 "c/sqlite3.c"
}
function _sqlite3_result_null($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 78101 "c/sqlite3.c"
 _sqlite3VdbeMemSetNull($1); //@line 78101 "c/sqlite3.c"
 return; //@line 78102 "c/sqlite3.c"
}
function _sqlite3XPrintf($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$2>>2] = $varargs; //@line 26972 "c/sqlite3.c"
 _sqlite3VXPrintf($0,$1,$2); //@line 26973 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 26975 "c/sqlite3.c"
}
function _sqlite3SkipAccumulatorLoad($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 107551 "c/sqlite3.c"
 HEAP8[$1>>0] = 1; //@line 107551 "c/sqlite3.c"
 return; //@line 107552 "c/sqlite3.c"
}
function _sqlite3_compileoption_get($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 _sqlite3CompileOptions($1); //@line 147549 "c/sqlite3.c"
 $2 = ($0|0)>(-1); //@line 147550 "c/sqlite3.c"
 $3 = HEAP32[$1>>2]|0; //@line 147550 "c/sqlite3.c"
 $4 = ($3|0)>($0|0); //@line 147550 "c/sqlite3.c"
 $or$cond = $2 & $4; //@line 147550 "c/sqlite3.c"
 if (!($or$cond)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 147554 "c/sqlite3.c"
 }
 $5 = (3924 + ($0<<2)|0); //@line 147551 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 147551 "c/sqlite3.c"
 $$0 = $6;
 STACKTOP = sp;return ($$0|0); //@line 147554 "c/sqlite3.c"
}
function _sqlite3CompileOptions($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = 2; //@line 773 "c/sqlite3.c"
 return;
}
function _sqlite3_compileoption_used($0) {
 $0 = $0|0;
 var $$0 = 0, $$01819 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 _sqlite3CompileOptions($1); //@line 147525 "c/sqlite3.c"
 $2 = (_sqlite3_strnicmp($0,17863,7)|0); //@line 147527 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 147527 "c/sqlite3.c"
 $4 = ((($0)) + 7|0); //@line 147527 "c/sqlite3.c"
 $spec$select = $3 ? $4 : $0; //@line 147527 "c/sqlite3.c"
 $5 = (_sqlite3Strlen30($spec$select)|0); //@line 147528 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 147532 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 147532 "c/sqlite3.c"
 if (!($7)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 147540 "c/sqlite3.c"
 }
 $8 = HEAP32[$1>>2]|0;
 $$01819 = 0;
 while(1) {
  $9 = (3924 + ($$01819<<2)|0); //@line 147533 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 147533 "c/sqlite3.c"
  $11 = (_sqlite3_strnicmp($spec$select,$10,$5)|0); //@line 147533 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 147533 "c/sqlite3.c"
  if ($12) {
   $13 = (($10) + ($5)|0); //@line 147534 "c/sqlite3.c"
   $14 = HEAP8[$13>>0]|0; //@line 147534 "c/sqlite3.c"
   $15 = (_sqlite3IsIdChar($14)|0); //@line 147534 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 147534 "c/sqlite3.c"
   if ($16) {
    $$0 = 1;
    label = 6;
    break;
   }
  }
  $17 = (($$01819) + 1)|0; //@line 147532 "c/sqlite3.c"
  $18 = ($17|0)<($8|0); //@line 147532 "c/sqlite3.c"
  if ($18) {
   $$01819 = $17;
  } else {
   $$0 = 0;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  STACKTOP = sp;return ($$0|0); //@line 147540 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3IsIdChar($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0&255; //@line 142546 "c/sqlite3.c"
 $2 = (16281 + ($1)|0); //@line 142546 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 142546 "c/sqlite3.c"
 $4 = $3 & 70; //@line 142546 "c/sqlite3.c"
 $5 = ($4<<24>>24)!=(0); //@line 142546 "c/sqlite3.c"
 $6 = $5&1; //@line 142546 "c/sqlite3.c"
 return ($6|0); //@line 142546 "c/sqlite3.c"
}
function _sqlite3_load_extension($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 12|0); //@line 114436 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 114436 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 114436 "c/sqlite3.c"
 $6 = (_sqlite3LoadExtension($0,$1,$2,$3)|0); //@line 114437 "c/sqlite3.c"
 $7 = (_sqlite3ApiExit($0,$6)|0); //@line 114438 "c/sqlite3.c"
 $8 = HEAP32[$4>>2]|0; //@line 114439 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 114439 "c/sqlite3.c"
 return ($7|0); //@line 114440 "c/sqlite3.c"
}
function _sqlite3LoadExtension($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0132$lcssa163 = 0, $$0135 = 0, $$0137$in$lcssa = 0, $$0137155 = 0, $$0137155$in = 0, $$0147 = 0, $$1133 = 0, $$1136 = 0, $$1141$in = 0, $$1145 = 0, $$2139 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0;
 var $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $or$cond = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, $vararg_ptr10 = 0, $vararg_ptr3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer11 = sp + 32|0;
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $4 = sp + 36|0;
 $5 = HEAP32[$0>>2]|0; //@line 114292 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 114295 "c/sqlite3.c"
 $6 = (_sqlite3Strlen30($1)|0); //@line 114299 "c/sqlite3.c"
 $7 = (($6) + 300)|0; //@line 114299 "c/sqlite3.c"
 $8 = ($7|0)<(0); //@line 114299 "c/sqlite3.c"
 $9 = $8 << 31 >> 31; //@line 114299 "c/sqlite3.c"
 $10 = ($3|0)!=(0|0); //@line 114315 "c/sqlite3.c"
 if ($10) {
  HEAP32[$3>>2] = 0; //@line 114315 "c/sqlite3.c"
 }
 $11 = ((($0)) + 28|0); //@line 114324 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 114324 "c/sqlite3.c"
 $13 = $12 & 65536; //@line 114324 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 114324 "c/sqlite3.c"
 if ($14) {
  if (!($10)) {
   $$3 = 1;
   STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  }
  $15 = (_sqlite3_mprintf(17871,$vararg_buffer)|0); //@line 114326 "c/sqlite3.c"
  HEAP32[$3>>2] = $15; //@line 114326 "c/sqlite3.c"
  $$3 = 1;
  STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
 }
 $16 = ($2|0)==(0|0); //@line 114331 "c/sqlite3.c"
 $17 = $16 ? 17886 : $2; //@line 114331 "c/sqlite3.c"
 $18 = (_sqlite3OsDlOpen($5,$1)|0); //@line 114333 "c/sqlite3.c"
 $19 = ($18|0)==(0|0); //@line 114335 "c/sqlite3.c"
 if ($19) {
  HEAP32[$vararg_buffer1>>2] = $1; //@line 114336 "c/sqlite3.c"
  $vararg_ptr3 = ((($vararg_buffer1)) + 4|0); //@line 114336 "c/sqlite3.c"
  HEAP32[$vararg_ptr3>>2] = 17915; //@line 114336 "c/sqlite3.c"
  $20 = (_sqlite3_mprintf(17909,$vararg_buffer1)|0); //@line 114336 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = 0; //@line 114337 "c/sqlite3.c"
  $21 = ($20|0)==(0|0); //@line 114338 "c/sqlite3.c"
  if ($21) {
   $$3 = 7;
   STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  }
  (_sqlite3OsAccess($5,$20,0,$vararg_buffer1)|0); //@line 114339 "c/sqlite3.c"
  $22 = HEAP32[$vararg_buffer1>>2]|0; //@line 114340 "c/sqlite3.c"
  $23 = ($22|0)==(0); //@line 114340 "c/sqlite3.c"
  if ($23) {
   $$1133 = 0;
  } else {
   $24 = (_sqlite3OsDlOpen($5,$20)|0); //@line 114340 "c/sqlite3.c"
   $$1133 = $24;
  }
  _sqlite3_free($20); //@line 114341 "c/sqlite3.c"
  $25 = ($$1133|0)==(0|0); //@line 114335 "c/sqlite3.c"
  if ($25) {
   if (!($10)) {
    $$3 = 1;
    STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
   }
   $26 = (_sqlite3_malloc64($7,$9)|0); //@line 114346 "c/sqlite3.c"
   HEAP32[$4>>2] = $26; //@line 114346 "c/sqlite3.c"
   HEAP32[$3>>2] = $26; //@line 114346 "c/sqlite3.c"
   $27 = ($26|0)==(0|0); //@line 114347 "c/sqlite3.c"
   if ($27) {
    $$3 = 1;
    STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
   }
   $28 = (($6) + 299)|0; //@line 114350 "c/sqlite3.c"
   HEAP32[$vararg_buffer4>>2] = $1; //@line 114348 "c/sqlite3.c"
   (_sqlite3_snprintf($7,$26,17918,$vararg_buffer4)|0); //@line 114348 "c/sqlite3.c"
   $29 = HEAP32[$4>>2]|0; //@line 114350 "c/sqlite3.c"
   _sqlite3OsDlError($5,$28,$29); //@line 114350 "c/sqlite3.c"
   $$3 = 1;
   STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  } else {
   $$0132$lcssa163 = $$1133;
  }
 } else {
  $$0132$lcssa163 = $18;
 }
 $30 = (_sqlite3OsDlSym($5,$$0132$lcssa163,$17)|0); //@line 114355 "c/sqlite3.c"
 $31 = ($30|0)==(0|0); //@line 114368 "c/sqlite3.c"
 $or$cond = $16 & $31; //@line 114368 "c/sqlite3.c"
 if ($or$cond) {
  $32 = (_sqlite3Strlen30($1)|0); //@line 114370 "c/sqlite3.c"
  $33 = (($32) + 30)|0; //@line 114371 "c/sqlite3.c"
  $34 = ($33|0)<(0); //@line 114371 "c/sqlite3.c"
  $35 = $34 << 31 >> 31; //@line 114371 "c/sqlite3.c"
  $36 = (_sqlite3_malloc64($33,$35)|0); //@line 114371 "c/sqlite3.c"
  $37 = ($36|0)==(0|0); //@line 114372 "c/sqlite3.c"
  if ($37) {
   _sqlite3OsDlClose($5,$$0132$lcssa163); //@line 114373 "c/sqlite3.c"
   $$3 = 7;
   STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  }
  $38 = $36; //@line 114376 "c/sqlite3.c"
  $39 = $38; //@line 114376 "c/sqlite3.c"
  HEAP8[$39>>0]=1768714611&255;HEAP8[$39+1>>0]=(1768714611>>8)&255;HEAP8[$39+2>>0]=(1768714611>>16)&255;HEAP8[$39+3>>0]=1768714611>>24; //@line 114376 "c/sqlite3.c"
  $40 = (($38) + 4)|0; //@line 114376 "c/sqlite3.c"
  $41 = $40; //@line 114376 "c/sqlite3.c"
  HEAP8[$41>>0]=1597203828&255;HEAP8[$41+1>>0]=(1597203828>>8)&255;HEAP8[$41+2>>0]=(1597203828>>16)&255;HEAP8[$41+3>>0]=1597203828>>24; //@line 114376 "c/sqlite3.c"
  $42 = ($32|0)>(0); //@line 114377 "c/sqlite3.c"
  L35: do {
   if ($42) {
    $$0137155$in = $32;
    while(1) {
     $$0137155 = (($$0137155$in) + -1)|0;
     $44 = (($1) + ($$0137155)|0); //@line 114377 "c/sqlite3.c"
     $45 = HEAP8[$44>>0]|0; //@line 114377 "c/sqlite3.c"
     $46 = ($45<<24>>24)==(47); //@line 114377 "c/sqlite3.c"
     if ($46) {
      $$0137$in$lcssa = $$0137155$in;
      break L35;
     }
     $43 = ($$0137155$in|0)>(1); //@line 114377 "c/sqlite3.c"
     if ($43) {
      $$0137155$in = $$0137155;
     } else {
      $$0137$in$lcssa = $$0137155;
      break;
     }
    }
   } else {
    $$0137$in$lcssa = $32;
   }
  } while(0);
  $47 = (($1) + ($$0137$in$lcssa)|0); //@line 114379 "c/sqlite3.c"
  $48 = (_sqlite3_strnicmp($47,17953,3)|0); //@line 114379 "c/sqlite3.c"
  $49 = ($48|0)==(0); //@line 114379 "c/sqlite3.c"
  $50 = (($$0137$in$lcssa) + 3)|0; //@line 114379 "c/sqlite3.c"
  $spec$select = $49 ? $50 : $$0137$in$lcssa; //@line 114379 "c/sqlite3.c"
  $$0135 = 8;$$2139 = $spec$select;
  L41: while(1) {
   $51 = (($1) + ($$2139)|0); //@line 114380 "c/sqlite3.c"
   $52 = HEAP8[$51>>0]|0; //@line 114380 "c/sqlite3.c"
   switch ($52<<24>>24) {
   case 0: case 46:  {
    break L41;
    break;
   }
   default: {
   }
   }
   $53 = $52&255; //@line 114381 "c/sqlite3.c"
   $54 = (16281 + ($53)|0); //@line 114381 "c/sqlite3.c"
   $55 = HEAP8[$54>>0]|0; //@line 114381 "c/sqlite3.c"
   $56 = $55 & 2; //@line 114381 "c/sqlite3.c"
   $57 = ($56<<24>>24)==(0); //@line 114381 "c/sqlite3.c"
   if ($57) {
    $$1136 = $$0135;
   } else {
    $58 = (($36) + ($$0135)|0); //@line 114382 "c/sqlite3.c"
    $59 = (($$0135) + 1)|0; //@line 114382 "c/sqlite3.c"
    $60 = $52 << 24 >> 24; //@line 114380 "c/sqlite3.c"
    $61 = (16025 + ($60)|0); //@line 114382 "c/sqlite3.c"
    $62 = HEAP8[$61>>0]|0; //@line 114382 "c/sqlite3.c"
    HEAP8[$58>>0] = $62; //@line 114382 "c/sqlite3.c"
    $$1136 = $59;
   }
   $63 = (($$2139) + 1)|0; //@line 114380 "c/sqlite3.c"
   $$0135 = $$1136;$$2139 = $63;
  }
  $64 = (($36) + ($$0135)|0); //@line 114385 "c/sqlite3.c"
  ;HEAP8[$64>>0]=HEAP8[17957>>0]|0;HEAP8[$64+1>>0]=HEAP8[17957+1>>0]|0;HEAP8[$64+2>>0]=HEAP8[17957+2>>0]|0;HEAP8[$64+3>>0]=HEAP8[17957+3>>0]|0;HEAP8[$64+4>>0]=HEAP8[17957+4>>0]|0;HEAP8[$64+5>>0]=HEAP8[17957+5>>0]|0; //@line 114385 "c/sqlite3.c"
  $65 = (_sqlite3OsDlSym($5,$$0132$lcssa163,$36)|0); //@line 114387 "c/sqlite3.c"
  $$0147 = $36;$$1141$in = $65;$$1145 = $36;
 } else {
  $$0147 = 0;$$1141$in = $30;$$1145 = $17;
 }
 $66 = ($$1141$in|0)==(0|0); //@line 114389 "c/sqlite3.c"
 if ($66) {
  if ($10) {
   $67 = (_sqlite3Strlen30($$1145)|0); //@line 114391 "c/sqlite3.c"
   $68 = ($67|0)<(0); //@line 114391 "c/sqlite3.c"
   $69 = $68 << 31 >> 31; //@line 114391 "c/sqlite3.c"
   $70 = (_i64Add(($67|0),($69|0),($7|0),($9|0))|0); //@line 114391 "c/sqlite3.c"
   $71 = tempRet0; //@line 114391 "c/sqlite3.c"
   $72 = (_sqlite3_malloc64($70,$71)|0); //@line 114392 "c/sqlite3.c"
   HEAP32[$4>>2] = $72; //@line 114392 "c/sqlite3.c"
   HEAP32[$3>>2] = $72; //@line 114392 "c/sqlite3.c"
   $73 = ($72|0)==(0|0); //@line 114393 "c/sqlite3.c"
   if (!($73)) {
    HEAP32[$vararg_buffer7>>2] = $$1145; //@line 114394 "c/sqlite3.c"
    $vararg_ptr10 = ((($vararg_buffer7)) + 4|0); //@line 114394 "c/sqlite3.c"
    HEAP32[$vararg_ptr10>>2] = $1; //@line 114394 "c/sqlite3.c"
    (_sqlite3_snprintf($70,$72,17963,$vararg_buffer7)|0); //@line 114394 "c/sqlite3.c"
    $74 = (($70) + -1)|0; //@line 114396 "c/sqlite3.c"
    $75 = HEAP32[$4>>2]|0; //@line 114396 "c/sqlite3.c"
    _sqlite3OsDlError($5,$74,$75); //@line 114396 "c/sqlite3.c"
   }
  }
  _sqlite3OsDlClose($5,$$0132$lcssa163); //@line 114399 "c/sqlite3.c"
  _sqlite3_free($$0147); //@line 114400 "c/sqlite3.c"
  $$3 = 1;
  STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
 }
 _sqlite3_free($$0147); //@line 114403 "c/sqlite3.c"
 $76 = (FUNCTION_TABLE_iiii[$$1141$in & 127]($0,$4,3932)|0); //@line 114404 "c/sqlite3.c"
 switch ($76|0) {
 case 0:  {
  $80 = ((($0)) + 180|0); //@line 114416 "c/sqlite3.c"
  $81 = HEAP32[$80>>2]|0; //@line 114416 "c/sqlite3.c"
  $82 = $81 << 2; //@line 114416 "c/sqlite3.c"
  $83 = (($82) + 4)|0; //@line 114416 "c/sqlite3.c"
  $84 = (_sqlite3DbMallocZero($0,$83,0)|0); //@line 114416 "c/sqlite3.c"
  $85 = ($84|0)==(0|0); //@line 114417 "c/sqlite3.c"
  if ($85) {
   $$3 = 7;
   STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  }
  $86 = HEAP32[$80>>2]|0; //@line 114420 "c/sqlite3.c"
  $87 = ($86|0)>(0); //@line 114420 "c/sqlite3.c"
  if ($87) {
   $88 = $86 << 2; //@line 114421 "c/sqlite3.c"
   $89 = ((($0)) + 184|0); //@line 114421 "c/sqlite3.c"
   $90 = HEAP32[$89>>2]|0; //@line 114421 "c/sqlite3.c"
   _memcpy(($84|0),($90|0),($88|0))|0; //@line 114421 "c/sqlite3.c"
  }
  $91 = ((($0)) + 184|0); //@line 114423 "c/sqlite3.c"
  $92 = HEAP32[$91>>2]|0; //@line 114423 "c/sqlite3.c"
  _sqlite3DbFree($0,$92); //@line 114423 "c/sqlite3.c"
  HEAP32[$91>>2] = $84; //@line 114424 "c/sqlite3.c"
  $93 = HEAP32[$80>>2]|0; //@line 114426 "c/sqlite3.c"
  $94 = (($93) + 1)|0; //@line 114426 "c/sqlite3.c"
  HEAP32[$80>>2] = $94; //@line 114426 "c/sqlite3.c"
  $95 = (($84) + ($93<<2)|0); //@line 114426 "c/sqlite3.c"
  HEAP32[$95>>2] = $$0132$lcssa163; //@line 114426 "c/sqlite3.c"
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  break;
 }
 case 256:  {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
  break;
 }
 default: {
  if ($10) {
   $77 = HEAP32[$4>>2]|0; //@line 114408 "c/sqlite3.c"
   HEAP32[$vararg_buffer11>>2] = $77; //@line 114408 "c/sqlite3.c"
   $78 = (_sqlite3_mprintf(18006,$vararg_buffer11)|0); //@line 114408 "c/sqlite3.c"
   HEAP32[$3>>2] = $78; //@line 114408 "c/sqlite3.c"
  }
  $79 = HEAP32[$4>>2]|0; //@line 114410 "c/sqlite3.c"
  _sqlite3_free($79); //@line 114410 "c/sqlite3.c"
  _sqlite3OsDlClose($5,$$0132$lcssa163); //@line 114411 "c/sqlite3.c"
  $$3 = 1;
  STACKTOP = sp;return ($$3|0); //@line 114428 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3ApiExit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 73|0); //@line 25851 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 25851 "c/sqlite3.c"
 $4 = ($3<<24>>24)!=(0); //@line 25851 "c/sqlite3.c"
 $5 = ($1|0)==(3082); //@line 25851 "c/sqlite3.c"
 $or$cond = $5 | $4; //@line 25851 "c/sqlite3.c"
 if ($or$cond) {
  _apiOomError($0); //@line 25852 "c/sqlite3.c"
  $$0 = 7;
  return ($$0|0); //@line 25855 "c/sqlite3.c"
 } else {
  $6 = ((($0)) + 60|0); //@line 25854 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 25854 "c/sqlite3.c"
  $8 = $7 & $1; //@line 25854 "c/sqlite3.c"
  $$0 = $8;
  return ($$0|0); //@line 25855 "c/sqlite3.c"
 }
 return (0)|0;
}
function _apiOomError($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3OomClear($0); //@line 25827 "c/sqlite3.c"
 _sqlite3Error($0,7); //@line 25828 "c/sqlite3.c"
 return;
}
function _sqlite3OomClear($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 73|0); //@line 25815 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 25815 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 25815 "c/sqlite3.c"
 if ($3) {
  return; //@line 25821 "c/sqlite3.c"
 }
 $4 = ((($0)) + 172|0); //@line 25815 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 25815 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 25815 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 25821 "c/sqlite3.c"
 }
 HEAP8[$1>>0] = 0; //@line 25816 "c/sqlite3.c"
 $7 = ((($0)) + 256|0); //@line 25817 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 25817 "c/sqlite3.c"
 $8 = ((($0)) + 264|0); //@line 25819 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 25819 "c/sqlite3.c"
 $10 = (($9) + -1)|0; //@line 25819 "c/sqlite3.c"
 HEAP32[$8>>2] = $10; //@line 25819 "c/sqlite3.c"
 return; //@line 25821 "c/sqlite3.c"
}
function _sqlite3Error($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 56|0); //@line 28609 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 28609 "c/sqlite3.c"
 $3 = ($1|0)==(0); //@line 28610 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 248|0); //@line 28610 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 28610 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 28610 "c/sqlite3.c"
  if ($6) {
   return; //@line 28611 "c/sqlite3.c"
  }
 }
 _sqlite3ErrorFinish($0,$1); //@line 28610 "c/sqlite3.c"
 return; //@line 28611 "c/sqlite3.c"
}
function _sqlite3ErrorFinish($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 248|0); //@line 28598 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 28598 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 28598 "c/sqlite3.c"
 if (!($4)) {
  _sqlite3ValueSetNull($3); //@line 28598 "c/sqlite3.c"
 }
 _sqlite3SystemError($0,$1); //@line 28599 "c/sqlite3.c"
 return; //@line 28600 "c/sqlite3.c"
}
function _sqlite3ValueSetNull($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3VdbeMemSetNull($0); //@line 71884 "c/sqlite3.c"
 return; //@line 71885 "c/sqlite3.c"
}
function _sqlite3SystemError($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(3082); //@line 28618 "c/sqlite3.c"
 if ($2) {
  return; //@line 28623 "c/sqlite3.c"
 }
 $3 = $1 & 251; //@line 28619 "c/sqlite3.c"
 $4 = $3 | 4; //@line 28620 "c/sqlite3.c"
 $5 = ($4|0)==(14); //@line 28620 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 28623 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0; //@line 28621 "c/sqlite3.c"
 $7 = (_sqlite3OsGetLastError($6)|0); //@line 28621 "c/sqlite3.c"
 $8 = ((($0)) + 64|0); //@line 28621 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 28621 "c/sqlite3.c"
 return; //@line 28623 "c/sqlite3.c"
}
function _sqlite3OsGetLastError($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 68|0); //@line 21074 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 21074 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 21074 "c/sqlite3.c"
 if ($3) {
  $5 = 0;
  return ($5|0); //@line 21074 "c/sqlite3.c"
 }
 $4 = (FUNCTION_TABLE_iiii[$2 & 127]($0,0,0)|0); //@line 21074 "c/sqlite3.c"
 $5 = $4;
 return ($5|0); //@line 21074 "c/sqlite3.c"
}
function _sqlite3OsDlOpen($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 40|0); //@line 21055 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 21055 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_iii[$3 & 255]($0,$1)|0); //@line 21055 "c/sqlite3.c"
 return ($4|0); //@line 21055 "c/sqlite3.c"
}
function _sqlite3OsAccess($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 32|0); //@line 21041 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 21041 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iiiii[$5 & 127]($0,$1,$2,$3)|0); //@line 21041 "c/sqlite3.c"
 return ($6|0); //@line 21041 "c/sqlite3.c"
}
function _sqlite3OsDlError($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 44|0); //@line 21058 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 21058 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$4 & 255]($0,$1,$2); //@line 21058 "c/sqlite3.c"
 return; //@line 21059 "c/sqlite3.c"
}
function _sqlite3OsDlSym($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 48|0); //@line 21061 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 21061 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iiii[$4 & 127]($0,$1,$2)|0); //@line 21061 "c/sqlite3.c"
 return ($5|0); //@line 21061 "c/sqlite3.c"
}
function _sqlite3OsDlClose($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 52|0); //@line 21064 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 21064 "c/sqlite3.c"
 FUNCTION_TABLE_vii[$3 & 127]($0,$1); //@line 21064 "c/sqlite3.c"
 return; //@line 21065 "c/sqlite3.c"
}
function _sqlite3DbMallocZero($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3DbMallocRaw($0,$1,$2)|0); //@line 25599 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 25600 "c/sqlite3.c"
 if ($4) {
  return ($3|0); //@line 25601 "c/sqlite3.c"
 }
 _memset(($3|0),0,($1|0))|0; //@line 25600 "c/sqlite3.c"
 return ($3|0); //@line 25601 "c/sqlite3.c"
}
function _sqlite3_aggregate_count($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 78655 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 78655 "c/sqlite3.c"
 $3 = ((($2)) + 12|0); //@line 78655 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 78655 "c/sqlite3.c"
 return ($4|0); //@line 78655 "c/sqlite3.c"
}
function _sqlite3_bind_blob($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_bindText($0,$1,$2,$3,$4,0)|0); //@line 79087 "c/sqlite3.c"
 return ($5|0); //@line 79087 "c/sqlite3.c"
}
function _sqlite3_bind_double($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = +$2;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_vdbeUnbind($0,$1)|0); //@line 79106 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 79107 "c/sqlite3.c"
 if (!($4)) {
  return ($3|0); //@line 79111 "c/sqlite3.c"
 }
 $5 = ((($0)) + 116|0); //@line 79108 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 79108 "c/sqlite3.c"
 $7 = (($1) + -1)|0; //@line 79108 "c/sqlite3.c"
 $8 = (($6) + (($7*40)|0)|0); //@line 79108 "c/sqlite3.c"
 _sqlite3VdbeMemSetDouble($8,$2); //@line 79108 "c/sqlite3.c"
 $9 = HEAP32[$0>>2]|0; //@line 79109 "c/sqlite3.c"
 $10 = ((($9)) + 12|0); //@line 79109 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 79109 "c/sqlite3.c"
 _sqlite3_mutex_leave($11); //@line 79109 "c/sqlite3.c"
 return ($3|0); //@line 79111 "c/sqlite3.c"
}
function _sqlite3_bind_int($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)<(0); //@line 79114 "c/sqlite3.c"
 $4 = $3 << 31 >> 31; //@line 79114 "c/sqlite3.c"
 $5 = (_sqlite3_bind_int64($0,$1,$2,$4)|0); //@line 79114 "c/sqlite3.c"
 return ($5|0); //@line 79114 "c/sqlite3.c"
}
function _sqlite3_bind_int64($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_vdbeUnbind($0,$1)|0); //@line 79119 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 79120 "c/sqlite3.c"
 if (!($5)) {
  return ($4|0); //@line 79124 "c/sqlite3.c"
 }
 $6 = ((($0)) + 116|0); //@line 79121 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 79121 "c/sqlite3.c"
 $8 = (($1) + -1)|0; //@line 79121 "c/sqlite3.c"
 $9 = (($7) + (($8*40)|0)|0); //@line 79121 "c/sqlite3.c"
 _sqlite3VdbeMemSetInt64($9,$2,$3); //@line 79121 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 79122 "c/sqlite3.c"
 $11 = ((($10)) + 12|0); //@line 79122 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 79122 "c/sqlite3.c"
 _sqlite3_mutex_leave($12); //@line 79122 "c/sqlite3.c"
 return ($4|0); //@line 79124 "c/sqlite3.c"
}
function _sqlite3_bind_null($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_vdbeUnbind($0,$1)|0); //@line 79129 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 79130 "c/sqlite3.c"
 if (!($3)) {
  return ($2|0); //@line 79133 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 79131 "c/sqlite3.c"
 $5 = ((($4)) + 12|0); //@line 79131 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 79131 "c/sqlite3.c"
 _sqlite3_mutex_leave($6); //@line 79131 "c/sqlite3.c"
 return ($2|0); //@line 79133 "c/sqlite3.c"
}
function _sqlite3_bind_parameter_count($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 79251 "c/sqlite3.c"
 if ($1) {
  $5 = 0;
  return ($5|0); //@line 79251 "c/sqlite3.c"
 }
 $2 = ((($0)) + 16|0); //@line 79251 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 79251 "c/sqlite3.c"
 $4 = $3 << 16 >> 16; //@line 79251 "c/sqlite3.c"
 $5 = $4;
 return ($5|0); //@line 79251 "c/sqlite3.c"
}
function _sqlite3_bind_parameter_index($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3Strlen30($1)|0); //@line 79276 "c/sqlite3.c"
 $3 = (_sqlite3VdbeParameterIndex($0,$1,$2)|0); //@line 79276 "c/sqlite3.c"
 return ($3|0); //@line 79276 "c/sqlite3.c"
}
function _sqlite3_bind_parameter_name($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 79262 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 79264 "c/sqlite3.c"
 }
 $3 = ((($0)) + 120|0); //@line 79263 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 79263 "c/sqlite3.c"
 $5 = (_sqlite3VListNumToName($4,$1)|0); //@line 79263 "c/sqlite3.c"
 $$0 = $5;
 return ($$0|0); //@line 79264 "c/sqlite3.c"
}
function _sqlite3_bind_text($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_bindText($0,$1,$2,$3,$4,1)|0); //@line 79160 "c/sqlite3.c"
 return ($5|0); //@line 79160 "c/sqlite3.c"
}
function _sqlite3_bind_text16($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_bindText($0,$1,$2,$3,$4,2)|0); //@line 79186 "c/sqlite3.c"
 return ($5|0); //@line 79186 "c/sqlite3.c"
}
function _sqlite3_bind_value($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3_value_type($2)|0); //@line 79191 "c/sqlite3.c"
 switch ($3|0) {
 case 1:  {
  $4 = $2; //@line 79193 "c/sqlite3.c"
  $5 = $4; //@line 79193 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 79193 "c/sqlite3.c"
  $7 = (($4) + 4)|0; //@line 79193 "c/sqlite3.c"
  $8 = $7; //@line 79193 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 79193 "c/sqlite3.c"
  $10 = (_sqlite3_bind_int64($0,$1,$6,$9)|0); //@line 79193 "c/sqlite3.c"
  $$0 = $10;
  return ($$0|0); //@line 79218 "c/sqlite3.c"
  break;
 }
 case 2:  {
  $11 = +HEAPF64[$2>>3]; //@line 79197 "c/sqlite3.c"
  $12 = (_sqlite3_bind_double($0,$1,$11)|0); //@line 79197 "c/sqlite3.c"
  $$0 = $12;
  return ($$0|0); //@line 79218 "c/sqlite3.c"
  break;
 }
 case 4:  {
  $13 = ((($2)) + 8|0); //@line 79201 "c/sqlite3.c"
  $14 = HEAP16[$13>>1]|0; //@line 79201 "c/sqlite3.c"
  $15 = $14 & 16384; //@line 79201 "c/sqlite3.c"
  $16 = ($15<<16>>16)==(0); //@line 79201 "c/sqlite3.c"
  if ($16) {
   $19 = ((($2)) + 16|0); //@line 79204 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 79204 "c/sqlite3.c"
   $21 = ((($2)) + 12|0); //@line 79204 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 79204 "c/sqlite3.c"
   $23 = (_sqlite3_bind_blob($0,$1,$20,$22,(-1))|0); //@line 79204 "c/sqlite3.c"
   $$0 = $23;
   return ($$0|0); //@line 79218 "c/sqlite3.c"
  } else {
   $17 = HEAP32[$2>>2]|0; //@line 79202 "c/sqlite3.c"
   $18 = (_sqlite3_bind_zeroblob($0,$1,$17)|0); //@line 79202 "c/sqlite3.c"
   $$0 = $18;
   return ($$0|0); //@line 79218 "c/sqlite3.c"
  }
  break;
 }
 case 3:  {
  $24 = ((($2)) + 16|0); //@line 79209 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 79209 "c/sqlite3.c"
  $26 = ((($2)) + 12|0); //@line 79209 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 79209 "c/sqlite3.c"
  $28 = ((($2)) + 10|0); //@line 79210 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 79210 "c/sqlite3.c"
  $30 = (_bindText($0,$1,$25,$27,(-1),$29)|0); //@line 79209 "c/sqlite3.c"
  $$0 = $30;
  return ($$0|0); //@line 79218 "c/sqlite3.c"
  break;
 }
 default: {
  $31 = (_sqlite3_bind_null($0,$1)|0); //@line 79214 "c/sqlite3.c"
  $$0 = $31;
  return ($$0|0); //@line 79218 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3_busy_handler($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 144900 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 144900 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 144900 "c/sqlite3.c"
 $5 = ((($0)) + 388|0); //@line 144901 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 144901 "c/sqlite3.c"
 $6 = ((($0)) + 392|0); //@line 144902 "c/sqlite3.c"
 HEAP32[$6>>2] = $2; //@line 144902 "c/sqlite3.c"
 $7 = ((($0)) + 396|0); //@line 144903 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 144903 "c/sqlite3.c"
 $8 = ((($0)) + 436|0); //@line 144904 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 144904 "c/sqlite3.c"
 $9 = HEAP32[$3>>2]|0; //@line 144905 "c/sqlite3.c"
 _sqlite3_mutex_leave($9); //@line 144905 "c/sqlite3.c"
 return 0; //@line 144906 "c/sqlite3.c"
}
function _sqlite3_busy_timeout($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 144950 "c/sqlite3.c"
 if ($2) {
  (_sqlite3_busy_handler($0,146,$0)|0); //@line 144951 "c/sqlite3.c"
  $3 = ((($0)) + 436|0); //@line 144952 "c/sqlite3.c"
  HEAP32[$3>>2] = $1; //@line 144952 "c/sqlite3.c"
  return 0; //@line 144956 "c/sqlite3.c"
 } else {
  (_sqlite3_busy_handler($0,0,0)|0); //@line 144954 "c/sqlite3.c"
  return 0; //@line 144956 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_close($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3Close($0,0)|0); //@line 144479 "c/sqlite3.c"
 return ($1|0); //@line 144479 "c/sqlite3.c"
}
function _sqlite3_collation_needed($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 146655 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 146655 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 146655 "c/sqlite3.c"
 $5 = ((($0)) + 236|0); //@line 146656 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 146656 "c/sqlite3.c"
 $6 = ((($0)) + 240|0); //@line 146657 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 146657 "c/sqlite3.c"
 $7 = ((($0)) + 244|0); //@line 146658 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 146658 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 146659 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 146659 "c/sqlite3.c"
 return 0; //@line 146660 "c/sqlite3.c"
}
function _sqlite3_collation_needed16($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 146676 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 146676 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 146676 "c/sqlite3.c"
 $5 = ((($0)) + 236|0); //@line 146677 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 146677 "c/sqlite3.c"
 $6 = ((($0)) + 240|0); //@line 146678 "c/sqlite3.c"
 HEAP32[$6>>2] = $2; //@line 146678 "c/sqlite3.c"
 $7 = ((($0)) + 244|0); //@line 146679 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 146679 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 146680 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 146680 "c/sqlite3.c"
 return 0; //@line 146681 "c/sqlite3.c"
}
function _sqlite3_column_blob($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78777 "c/sqlite3.c"
 $3 = (_sqlite3_value_blob($2)|0); //@line 78777 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78782 "c/sqlite3.c"
 return ($3|0); //@line 78783 "c/sqlite3.c"
}
function _sqlite3_column_bytes($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78786 "c/sqlite3.c"
 $3 = (_sqlite3_value_bytes($2)|0); //@line 78786 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78787 "c/sqlite3.c"
 return ($3|0); //@line 78788 "c/sqlite3.c"
}
function _sqlite3_column_bytes16($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78791 "c/sqlite3.c"
 $3 = (_sqlite3_value_bytes16($2)|0); //@line 78791 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78792 "c/sqlite3.c"
 return ($3|0); //@line 78793 "c/sqlite3.c"
}
function _sqlite3_column_count($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 78664 "c/sqlite3.c"
 if ($1) {
  $5 = 0;
  return ($5|0); //@line 78664 "c/sqlite3.c"
 }
 $2 = ((($0)) + 140|0); //@line 78664 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 78664 "c/sqlite3.c"
 $4 = $3&65535; //@line 78664 "c/sqlite3.c"
 $5 = $4;
 return ($5|0); //@line 78664 "c/sqlite3.c"
}
function _sqlite3_column_decltype($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnName($0,$1,107,1)|0); //@line 78921 "c/sqlite3.c"
 return ($2|0); //@line 78921 "c/sqlite3.c"
}
function _sqlite3_column_decltype16($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnName($0,$1,108,1)|0); //@line 78926 "c/sqlite3.c"
 return ($2|0); //@line 78926 "c/sqlite3.c"
}
function _sqlite3_column_double($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78796 "c/sqlite3.c"
 $3 = (+_sqlite3_value_double($2)); //@line 78796 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78797 "c/sqlite3.c"
 return (+$3); //@line 78798 "c/sqlite3.c"
}
function _sqlite3_column_int($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78801 "c/sqlite3.c"
 $3 = (_sqlite3_value_int($2)|0); //@line 78801 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78802 "c/sqlite3.c"
 return ($3|0); //@line 78803 "c/sqlite3.c"
}
function _sqlite3_column_int64($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78806 "c/sqlite3.c"
 $3 = (_sqlite3_value_int64($2)|0); //@line 78806 "c/sqlite3.c"
 $4 = tempRet0; //@line 78806 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78807 "c/sqlite3.c"
 tempRet0 = ($4); //@line 78808 "c/sqlite3.c"
 return ($3|0); //@line 78808 "c/sqlite3.c"
}
function _sqlite3_column_name($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnName($0,$1,107,0)|0); //@line 78896 "c/sqlite3.c"
 return ($2|0); //@line 78896 "c/sqlite3.c"
}
function _sqlite3_column_name16($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnName($0,$1,108,0)|0); //@line 78901 "c/sqlite3.c"
 return ($2|0); //@line 78901 "c/sqlite3.c"
}
function _sqlite3_column_text($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78811 "c/sqlite3.c"
 $3 = (_sqlite3_value_text($2)|0); //@line 78811 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78812 "c/sqlite3.c"
 return ($3|0); //@line 78813 "c/sqlite3.c"
}
function _sqlite3_column_text16($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78826 "c/sqlite3.c"
 $3 = (_sqlite3_value_text16($2)|0); //@line 78826 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78827 "c/sqlite3.c"
 return ($3|0); //@line 78828 "c/sqlite3.c"
}
function _sqlite3_column_type($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78832 "c/sqlite3.c"
 $3 = (_sqlite3_value_type($2)|0); //@line 78832 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78833 "c/sqlite3.c"
 return ($3|0); //@line 78834 "c/sqlite3.c"
}
function _sqlite3_column_value($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_columnMem($0,$1)|0); //@line 78816 "c/sqlite3.c"
 $3 = ((($2)) + 8|0); //@line 78817 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 78817 "c/sqlite3.c"
 $5 = $4&65535; //@line 78817 "c/sqlite3.c"
 $6 = $5 & 2048; //@line 78817 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 78817 "c/sqlite3.c"
 if ($7) {
  _columnMallocFailure($0); //@line 78821 "c/sqlite3.c"
  return ($2|0); //@line 78822 "c/sqlite3.c"
 }
 $8 = $5 & 59391; //@line 78818 "c/sqlite3.c"
 $9 = $8 | 4096; //@line 78819 "c/sqlite3.c"
 $10 = $9&65535; //@line 78819 "c/sqlite3.c"
 HEAP16[$3>>1] = $10; //@line 78819 "c/sqlite3.c"
 _columnMallocFailure($0); //@line 78821 "c/sqlite3.c"
 return ($2|0); //@line 78822 "c/sqlite3.c"
}
function _sqlite3_commit_hook($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145299 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145299 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145299 "c/sqlite3.c"
 $5 = ((($0)) + 204|0); //@line 145300 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145300 "c/sqlite3.c"
 $7 = ((($0)) + 208|0); //@line 145301 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 145301 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 145302 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 145303 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 145303 "c/sqlite3.c"
 return ($6|0); //@line 145304 "c/sqlite3.c"
}
function _sqlite3_complete($0) {
 $0 = $0|0;
 var $$05780 = 0, $$058$pn = 0, $$058$pn62 = 0, $$05878 = 0, $$159 = 0, $$255 = 0, $$260 = 0, $$3 = 0, $$3$shrunk = 0, $$356 = 0, $$361 = 0, $$4 = 0, $$5 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0;
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $7 = 0, $8 = 0, $9 = 0, $not$ = 0, $phitmp = 0, $spec$select = 0, $spec$select64 = 0;
 var $spec$select65 = 0, $trunc = 0, $trunc$clear = 0, $trunc69$clear = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 143121 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(0); //@line 143121 "c/sqlite3.c"
 if ($2) {
  $$3$shrunk = 0;
  $$3 = $$3$shrunk&1;
  return ($$3|0); //@line 143238 "c/sqlite3.c"
 }
 $$05780 = 0;$$05878 = $0;$4 = $1;
 L4: while(1) {
  $3 = $4 << 24 >> 24; //@line 143122 "c/sqlite3.c"
  switch ($3|0) {
  case 59:  {
   $$356 = 0;$$5 = $$05878;
   break;
  }
  case 12: case 10: case 9: case 13: case 32:  {
   $$356 = 1;$$5 = $$05878;
   break;
  }
  case 47:  {
   $5 = ((($$05878)) + 1|0); //@line 143136 "c/sqlite3.c"
   $6 = HEAP8[$5>>0]|0; //@line 143136 "c/sqlite3.c"
   $7 = ($6<<24>>24)==(42); //@line 143136 "c/sqlite3.c"
   if ($7) {
    $8 = ((($$05878)) + 2|0); //@line 143140 "c/sqlite3.c"
    $$159 = $8;
    L32: while(1) {
     $9 = HEAP8[$$159>>0]|0; //@line 143141 "c/sqlite3.c"
     switch ($9<<24>>24) {
     case 0:  {
      $$3$shrunk = 0;
      label = 41;
      break L4;
      break;
     }
     case 42:  {
      $10 = ((($$159)) + 1|0); //@line 143141 "c/sqlite3.c"
      $11 = HEAP8[$10>>0]|0; //@line 143141 "c/sqlite3.c"
      $12 = ($11<<24>>24)==(47); //@line 143141 "c/sqlite3.c"
      if ($12) {
       break L32;
      }
      break;
     }
     default: {
     }
     }
     $13 = ((($$159)) + 1|0); //@line 143141 "c/sqlite3.c"
     $$159 = $13;
    }
    $14 = ((($$159)) + 1|0); //@line 143143 "c/sqlite3.c"
    $$356 = 1;$$5 = $14;
   } else {
    $$356 = 2;$$5 = $$05878;
   }
   break;
  }
  case 45:  {
   $15 = ((($$05878)) + 1|0); //@line 143148 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 143148 "c/sqlite3.c"
   $17 = ($16<<24>>24)==(45); //@line 143148 "c/sqlite3.c"
   if ($17) {
    $$260 = $$05878;
    while(1) {
     $18 = HEAP8[$$260>>0]|0; //@line 143152 "c/sqlite3.c"
     $19 = ($18<<24>>24)==(0); //@line 143152 "c/sqlite3.c"
     $20 = ($18<<24>>24)!=(10); //@line 143152 "c/sqlite3.c"
     $spec$select = $19 ^ $20; //@line 143152 "c/sqlite3.c"
     $21 = ((($$260)) + 1|0); //@line 143152 "c/sqlite3.c"
     if ($spec$select) {
      $$260 = $21;
     } else {
      break;
     }
    }
    if ($19) {
     label = 17;
     break L4;
    } else {
     $$356 = 1;$$5 = $$260;
    }
   } else {
    $$356 = 2;$$5 = $$05878;
   }
   break;
  }
  case 91:  {
   $$058$pn62 = $$05878;
   while(1) {
    $$361 = ((($$058$pn62)) + 1|0);
    $23 = HEAP8[$$361>>0]|0; //@line 143159 "c/sqlite3.c"
    $24 = ($23<<24>>24)==(0); //@line 143159 "c/sqlite3.c"
    $25 = ($23<<24>>24)!=(93); //@line 143159 "c/sqlite3.c"
    $spec$select64 = $24 ^ $25; //@line 143159 "c/sqlite3.c"
    if ($spec$select64) {
     $$058$pn62 = $$361;
    } else {
     break;
    }
   }
   if ($24) {
    $$3$shrunk = 0;
    label = 41;
    break L4;
   } else {
    $$356 = 2;$$5 = $$361;
   }
   break;
  }
  case 39: case 34: case 96:  {
   $$058$pn = $$05878;
   while(1) {
    $$4 = ((($$058$pn)) + 1|0);
    $26 = HEAP8[$$4>>0]|0; //@line 143169 "c/sqlite3.c"
    $27 = ($26<<24>>24)==(0); //@line 143169 "c/sqlite3.c"
    $28 = ($26<<24>>24)!=($4<<24>>24); //@line 143169 "c/sqlite3.c"
    $not$ = $27 ^ 1; //@line 143169 "c/sqlite3.c"
    $spec$select65 = $28 & $not$; //@line 143169 "c/sqlite3.c"
    if ($spec$select65) {
     $$058$pn = $$4;
    } else {
     break;
    }
   }
   if ($27) {
    $$3$shrunk = 0;
    label = 41;
    break L4;
   } else {
    $$356 = 2;$$5 = $$4;
   }
   break;
  }
  default: {
   $29 = $4&255; //@line 143178 "c/sqlite3.c"
   $30 = (16281 + ($29)|0); //@line 143178 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 143178 "c/sqlite3.c"
   $32 = $31 & 70; //@line 143178 "c/sqlite3.c"
   $33 = ($32<<24>>24)==(0); //@line 143178 "c/sqlite3.c"
   if ($33) {
    $$356 = 2;$$5 = $$05878;
   } else {
    $trunc = 1;
    while(1) {
     $34 = (($$05878) + ($trunc)|0); //@line 143181 "c/sqlite3.c"
     $35 = HEAP8[$34>>0]|0; //@line 143181 "c/sqlite3.c"
     $36 = $35&255; //@line 143181 "c/sqlite3.c"
     $37 = (16281 + ($36)|0); //@line 143181 "c/sqlite3.c"
     $38 = HEAP8[$37>>0]|0; //@line 143181 "c/sqlite3.c"
     $39 = $38 & 70; //@line 143181 "c/sqlite3.c"
     $40 = ($39<<24>>24)==(0); //@line 143181 "c/sqlite3.c"
     $41 = (($trunc) + 1)|0; //@line 143181 "c/sqlite3.c"
     if ($40) {
      break;
     } else {
      $trunc = $41;
     }
    }
    L12: do {
     switch ($3|0) {
     case 67: case 99:  {
      $42 = ($trunc|0)==(6); //@line 143187 "c/sqlite3.c"
      if ($42) {
       $43 = (_sqlite3_strnicmp($$05878,37627,6)|0); //@line 143187 "c/sqlite3.c"
       $44 = ($43|0)==(0); //@line 143187 "c/sqlite3.c"
       if ($44) {
        $$255 = 4;
        break L12;
       }
      }
      $$255 = 2;
      break;
     }
     case 84: case 116:  {
      $trunc69$clear = $trunc & 2147483647; //@line 143195 "c/sqlite3.c"
      switch ($trunc69$clear|0) {
      case 7:  {
       $45 = (_sqlite3_strnicmp($$05878,25526,7)|0); //@line 143195 "c/sqlite3.c"
       $46 = ($45|0)==(0); //@line 143195 "c/sqlite3.c"
       if ($46) {
        $$255 = 6;
        break L12;
       }
       break;
      }
      case 4:  {
       $47 = (_sqlite3_strnicmp($$05878,35686,4)|0); //@line 143197 "c/sqlite3.c"
       $48 = ($47|0)==(0); //@line 143197 "c/sqlite3.c"
       if ($48) {
        $$255 = 5;
        break L12;
       }
       break;
      }
      case 9:  {
       $49 = (_sqlite3_strnicmp($$05878,37634,9)|0); //@line 143199 "c/sqlite3.c"
       $50 = ($49|0)==(0); //@line 143199 "c/sqlite3.c"
       if ($50) {
        $$255 = 5;
        break L12;
       }
       break;
      }
      default: {
      }
      }
      $$255 = 2;
      break;
     }
     case 69: case 101:  {
      $trunc$clear = $trunc & 2147483647; //@line 143207 "c/sqlite3.c"
      switch ($trunc$clear|0) {
      case 3:  {
       $51 = (_sqlite3_strnicmp($$05878,37644,3)|0); //@line 143207 "c/sqlite3.c"
       $52 = ($51|0)==(0); //@line 143207 "c/sqlite3.c"
       if ($52) {
        $$255 = 7;
        break L12;
       }
       break;
      }
      case 7:  {
       $53 = (_sqlite3_strnicmp($$05878,37648,7)|0); //@line 143211 "c/sqlite3.c"
       $54 = ($53|0)==(0); //@line 143211 "c/sqlite3.c"
       if ($54) {
        $$255 = 3;
        break L12;
       }
       break;
      }
      default: {
      }
      }
      $$255 = 2;
      break;
     }
     default: {
      $$255 = 2;
     }
     }
    } while(0);
    $55 = (($trunc) + -1)|0; //@line 143226 "c/sqlite3.c"
    $56 = (($$05878) + ($55)|0); //@line 143226 "c/sqlite3.c"
    $$356 = $$255;$$5 = $56;
   }
  }
  }
  $57 = $$05780&255; //@line 143234 "c/sqlite3.c"
  $58 = $$356 & 255; //@line 143234 "c/sqlite3.c"
  $59 = ((37656 + ($57<<3)|0) + ($58)|0); //@line 143234 "c/sqlite3.c"
  $60 = HEAP8[$59>>0]|0; //@line 143234 "c/sqlite3.c"
  $61 = ((($$5)) + 1|0); //@line 143235 "c/sqlite3.c"
  $62 = HEAP8[$61>>0]|0; //@line 143121 "c/sqlite3.c"
  $63 = ($62<<24>>24)==(0); //@line 143121 "c/sqlite3.c"
  if ($63) {
   label = 40;
   break;
  } else {
   $$05780 = $60;$$05878 = $61;$4 = $62;
  }
 }
 if ((label|0) == 17) {
  $22 = ($$05780<<24>>24)==(1); //@line 143153 "c/sqlite3.c"
  $$3$shrunk = $22;
  $$3 = $$3$shrunk&1;
  return ($$3|0); //@line 143238 "c/sqlite3.c"
 }
 else if ((label|0) == 40) {
  $phitmp = ($60<<24>>24)==(1); //@line 143237 "c/sqlite3.c"
  $$3$shrunk = $phitmp;
  $$3 = $$3$shrunk&1;
  return ($$3|0); //@line 143238 "c/sqlite3.c"
 }
 else if ((label|0) == 41) {
  $$3 = $$3$shrunk&1;
  return ($$3|0); //@line 143238 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_complete16($0) {
 $0 = $0|0;
 var $$0 = 0, $$014 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_initialize()|0); //@line 143252 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 143253 "c/sqlite3.c"
 if (!($2)) {
  $$014 = $1;
  return ($$014|0); //@line 143265 "c/sqlite3.c"
 }
 $3 = (_sqlite3ValueNew(0)|0); //@line 143255 "c/sqlite3.c"
 _sqlite3ValueSetStr($3,$0,2,0); //@line 143256 "c/sqlite3.c"
 $4 = (_sqlite3ValueText($3,1)|0); //@line 143257 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 143258 "c/sqlite3.c"
 if ($5) {
  $$0 = 7;
 } else {
  $6 = (_sqlite3_complete($4)|0); //@line 143259 "c/sqlite3.c"
  $phitmp = $6 & 255; //@line 143260 "c/sqlite3.c"
  $$0 = $phitmp;
 }
 _sqlite3ValueFree($3); //@line 143263 "c/sqlite3.c"
 $$014 = $$0;
 return ($$014|0); //@line 143265 "c/sqlite3.c"
}
function _sqlite3_create_collation($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3_create_collation_v2($0,$1,$2,$3,$4,0)|0); //@line 146586 "c/sqlite3.c"
 return ($5|0); //@line 146586 "c/sqlite3.c"
}
function _sqlite3_create_collation16($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 12|0); //@line 146630 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 146630 "c/sqlite3.c"
 _sqlite3_mutex_enter($6); //@line 146630 "c/sqlite3.c"
 $7 = (_sqlite3Utf16to8($0,$1,-1)|0); //@line 146632 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 146633 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
 } else {
  $9 = $2&255; //@line 146634 "c/sqlite3.c"
  $10 = (_createCollation($0,$7,$9,$3,$4,0)|0); //@line 146634 "c/sqlite3.c"
  _sqlite3DbFree($0,$7); //@line 146635 "c/sqlite3.c"
  $$0 = $10;
 }
 $11 = (_sqlite3ApiExit($0,$$0)|0); //@line 146637 "c/sqlite3.c"
 $12 = HEAP32[$5>>2]|0; //@line 146638 "c/sqlite3.c"
 _sqlite3_mutex_leave($12); //@line 146638 "c/sqlite3.c"
 return ($11|0); //@line 146639 "c/sqlite3.c"
}
function _sqlite3_create_function($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = (_sqlite3_create_function_v2($0,$1,$2,$3,$4,$5,$6,$7,0)|0); //@line 145088 "c/sqlite3.c"
 return ($8|0); //@line 145088 "c/sqlite3.c"
}
function _sqlite3_create_function16($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = ((($0)) + 12|0); //@line 145151 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 145151 "c/sqlite3.c"
 _sqlite3_mutex_enter($9); //@line 145151 "c/sqlite3.c"
 $10 = (_sqlite3Utf16to8($0,$1,-1)|0); //@line 145153 "c/sqlite3.c"
 $11 = (_sqlite3CreateFunc($0,$10,$2,$3,$4,$5,$6,$7,0)|0); //@line 145154 "c/sqlite3.c"
 _sqlite3DbFree($0,$10); //@line 145155 "c/sqlite3.c"
 $12 = (_sqlite3ApiExit($0,$11)|0); //@line 145156 "c/sqlite3.c"
 $13 = HEAP32[$8>>2]|0; //@line 145157 "c/sqlite3.c"
 _sqlite3_mutex_leave($13); //@line 145157 "c/sqlite3.c"
 return ($12|0); //@line 145158 "c/sqlite3.c"
}
function _sqlite3_create_module($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_createModule($0,$1,$2,$3,0)|0); //@line 127466 "c/sqlite3.c"
 return ($4|0); //@line 127466 "c/sqlite3.c"
}
function _sqlite3_data_count($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 78673 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
 } else {
  $2 = ((($0)) + 104|0); //@line 78673 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 78673 "c/sqlite3.c"
  $4 = ($3|0)==(0|0); //@line 78673 "c/sqlite3.c"
  if ($4) {
   $$0 = 0;
  } else {
   $5 = ((($0)) + 140|0); //@line 78674 "c/sqlite3.c"
   $6 = HEAP16[$5>>1]|0; //@line 78674 "c/sqlite3.c"
   $7 = $6&65535; //@line 78674 "c/sqlite3.c"
   $$0 = $7;
  }
 }
 return ($$0|0); //@line 78675 "c/sqlite3.c"
}
function _sqlite3_db_handle($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 79334 "c/sqlite3.c"
 if ($1) {
  $3 = 0;
 } else {
  $2 = HEAP32[$0>>2]|0; //@line 79334 "c/sqlite3.c"
  $3 = $2;
 }
 return ($3|0); //@line 79334 "c/sqlite3.c"
}
function _sqlite3_declare_vtab($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$046 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 496|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(496|0);
 $vararg_buffer = sp;
 $2 = sp + 480|0;
 $3 = sp + 8|0;
 HEAP32[$2>>2] = 0; //@line 128101 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 128109 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 128109 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 128109 "c/sqlite3.c"
 $6 = ((($0)) + 344|0); //@line 128110 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 128110 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 128111 "c/sqlite3.c"
 if (!($8)) {
  $9 = ((($7)) + 12|0); //@line 128111 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 128111 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 128111 "c/sqlite3.c"
  if ($11) {
   $14 = ((($7)) + 4|0); //@line 128116 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 128116 "c/sqlite3.c"
   $16 = ((($3)) + 4|0);
   _memset(($16|0),0,468)|0; //@line 128119 "c/sqlite3.c"
   $17 = ((($3)) + 400|0); //@line 128120 "c/sqlite3.c"
   HEAP8[$17>>0] = 1; //@line 128120 "c/sqlite3.c"
   HEAP32[$3>>2] = $0; //@line 128121 "c/sqlite3.c"
   $18 = ((($3)) + 132|0); //@line 128122 "c/sqlite3.c"
   HEAP32[$18>>2] = 1; //@line 128122 "c/sqlite3.c"
   $19 = (_sqlite3RunParser($3,$1,$2)|0); //@line 128123 "c/sqlite3.c"
   $20 = ($19|0)==(0); //@line 128123 "c/sqlite3.c"
   if ($20) {
    $21 = ((($3)) + 432|0); //@line 128124 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 128124 "c/sqlite3.c"
    $23 = ($22|0)==(0|0); //@line 128124 "c/sqlite3.c"
    if ($23) {
     label = 16;
    } else {
     $24 = ((($0)) + 73|0); //@line 128125 "c/sqlite3.c"
     $25 = HEAP8[$24>>0]|0; //@line 128125 "c/sqlite3.c"
     $26 = ($25<<24>>24)==(0); //@line 128125 "c/sqlite3.c"
     if ($26) {
      $27 = ((($22)) + 12|0); //@line 128126 "c/sqlite3.c"
      $28 = HEAP32[$27>>2]|0; //@line 128126 "c/sqlite3.c"
      $29 = ($28|0)==(0|0); //@line 128126 "c/sqlite3.c"
      if ($29) {
       $30 = ((($22)) + 56|0); //@line 128127 "c/sqlite3.c"
       $31 = HEAP32[$30>>2]|0; //@line 128127 "c/sqlite3.c"
       $32 = ($31|0)==(0); //@line 128127 "c/sqlite3.c"
       if ($32) {
        $33 = ((($15)) + 4|0); //@line 128129 "c/sqlite3.c"
        $34 = HEAP32[$33>>2]|0; //@line 128129 "c/sqlite3.c"
        $35 = ($34|0)==(0|0); //@line 128129 "c/sqlite3.c"
        if ($35) {
         $36 = ((($22)) + 4|0); //@line 128132 "c/sqlite3.c"
         $37 = HEAP32[$36>>2]|0; //@line 128132 "c/sqlite3.c"
         HEAP32[$33>>2] = $37; //@line 128132 "c/sqlite3.c"
         $38 = ((($22)) + 42|0); //@line 128133 "c/sqlite3.c"
         $39 = HEAP16[$38>>1]|0; //@line 128133 "c/sqlite3.c"
         $40 = ((($15)) + 42|0); //@line 128133 "c/sqlite3.c"
         HEAP16[$40>>1] = $39; //@line 128133 "c/sqlite3.c"
         $41 = ((($22)) + 36|0); //@line 128134 "c/sqlite3.c"
         $42 = HEAP32[$41>>2]|0; //@line 128134 "c/sqlite3.c"
         $43 = $42 & 96; //@line 128134 "c/sqlite3.c"
         $44 = ((($15)) + 36|0); //@line 128134 "c/sqlite3.c"
         $45 = HEAP32[$44>>2]|0; //@line 128134 "c/sqlite3.c"
         $46 = $45 | $43; //@line 128134 "c/sqlite3.c"
         HEAP32[$44>>2] = $46; //@line 128134 "c/sqlite3.c"
         HEAP16[$38>>1] = 0; //@line 128135 "c/sqlite3.c"
         HEAP32[$36>>2] = 0; //@line 128136 "c/sqlite3.c"
         $47 = HEAP32[$41>>2]|0; //@line 128139 "c/sqlite3.c"
         $48 = $47 & 32; //@line 128139 "c/sqlite3.c"
         $49 = ($48|0)==(0); //@line 128139 "c/sqlite3.c"
         if ($49) {
          $$046 = 0;
         } else {
          $50 = HEAP32[$7>>2]|0; //@line 128140 "c/sqlite3.c"
          $51 = ((($50)) + 4|0); //@line 128140 "c/sqlite3.c"
          $52 = HEAP32[$51>>2]|0; //@line 128140 "c/sqlite3.c"
          $53 = HEAP32[$52>>2]|0; //@line 128140 "c/sqlite3.c"
          $54 = ((($53)) + 52|0); //@line 128140 "c/sqlite3.c"
          $55 = HEAP32[$54>>2]|0; //@line 128140 "c/sqlite3.c"
          $56 = ($55|0)==(0|0); //@line 128140 "c/sqlite3.c"
          if ($56) {
           $$046 = 0;
          } else {
           $57 = (_sqlite3PrimaryKeyIndex($22)|0); //@line 128141 "c/sqlite3.c"
           $58 = ((($57)) + 50|0); //@line 128141 "c/sqlite3.c"
           $59 = HEAP16[$58>>1]|0; //@line 128141 "c/sqlite3.c"
           $60 = ($59<<16>>16)!=(1); //@line 128141 "c/sqlite3.c"
           $spec$select = $60&1; //@line 128139 "c/sqlite3.c"
           $$046 = $spec$select;
          }
         }
         $61 = ((($22)) + 8|0); //@line 128147 "c/sqlite3.c"
         $62 = HEAP32[$61>>2]|0; //@line 128147 "c/sqlite3.c"
         $63 = ($62|0)==(0|0); //@line 128148 "c/sqlite3.c"
         if ($63) {
          $$1 = $$046;
         } else {
          $64 = ((($15)) + 8|0); //@line 128150 "c/sqlite3.c"
          HEAP32[$64>>2] = $62; //@line 128150 "c/sqlite3.c"
          HEAP32[$61>>2] = 0; //@line 128151 "c/sqlite3.c"
          $65 = ((($62)) + 12|0); //@line 128152 "c/sqlite3.c"
          HEAP32[$65>>2] = $15; //@line 128152 "c/sqlite3.c"
          $$1 = $$046;
         }
        } else {
         $$1 = 0;
        }
        HEAP32[$9>>2] = 1; //@line 128155 "c/sqlite3.c"
        $$2 = $$1;
       } else {
        label = 16;
       }
      } else {
       label = 16;
      }
     } else {
      label = 16;
     }
    }
   } else {
    label = 16;
   }
   if ((label|0) == 16) {
    $66 = HEAP32[$2>>2]|0; //@line 128157 "c/sqlite3.c"
    $67 = ($66|0)==(0|0); //@line 128157 "c/sqlite3.c"
    $68 = $67 ? 0 : 15687; //@line 128157 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $66; //@line 128157 "c/sqlite3.c"
    _sqlite3ErrorWithMsg($0,1,$68,$vararg_buffer); //@line 128157 "c/sqlite3.c"
    _sqlite3DbFree($0,$66); //@line 128158 "c/sqlite3.c"
    $$2 = 1;
   }
   HEAP8[$17>>0] = 0; //@line 128161 "c/sqlite3.c"
   $69 = ((($3)) + 8|0); //@line 128163 "c/sqlite3.c"
   $70 = HEAP32[$69>>2]|0; //@line 128163 "c/sqlite3.c"
   $71 = ($70|0)==(0|0); //@line 128163 "c/sqlite3.c"
   if (!($71)) {
    (_sqlite3VdbeFinalize($70)|0); //@line 128164 "c/sqlite3.c"
   }
   $72 = ((($3)) + 432|0); //@line 128166 "c/sqlite3.c"
   $73 = HEAP32[$72>>2]|0; //@line 128166 "c/sqlite3.c"
   _sqlite3DeleteTable($0,$73); //@line 128166 "c/sqlite3.c"
   _sqlite3ParserReset($3); //@line 128167 "c/sqlite3.c"
   $74 = (_sqlite3ApiExit($0,$$2)|0); //@line 128170 "c/sqlite3.c"
   $75 = HEAP32[$4>>2]|0; //@line 128171 "c/sqlite3.c"
   _sqlite3_mutex_leave($75); //@line 128171 "c/sqlite3.c"
   $$0 = $74;
   STACKTOP = sp;return ($$0|0); //@line 128173 "c/sqlite3.c"
  }
 }
 _sqlite3Error($0,21); //@line 128112 "c/sqlite3.c"
 $12 = HEAP32[$4>>2]|0; //@line 128113 "c/sqlite3.c"
 _sqlite3_mutex_leave($12); //@line 128113 "c/sqlite3.c"
 $13 = (_sqlite3MisuseError(128114)|0); //@line 128114 "c/sqlite3.c"
 $$0 = $13;
 STACKTOP = sp;return ($$0|0); //@line 128173 "c/sqlite3.c"
}
function _sqlite3_enable_shared_cache($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[(224)>>2] = $0; //@line 60493 "c/sqlite3.c"
 return 0; //@line 60494 "c/sqlite3.c"
}
function _sqlite3_errcode($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 145684 "c/sqlite3.c"
 if ($1) {
  $$0 = 7;
  return ($$0|0); //@line 145691 "c/sqlite3.c"
 }
 $2 = (_sqlite3SafetyCheckSickOrOk($0)|0); //@line 145684 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 145684 "c/sqlite3.c"
 if ($3) {
  $4 = (_sqlite3MisuseError(145685)|0); //@line 145685 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 145691 "c/sqlite3.c"
 }
 $5 = ((($0)) + 73|0); //@line 145687 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 145687 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 145687 "c/sqlite3.c"
 if (!($7)) {
  $$0 = 7;
  return ($$0|0); //@line 145691 "c/sqlite3.c"
 }
 $8 = ((($0)) + 56|0); //@line 145690 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 145690 "c/sqlite3.c"
 $10 = ((($0)) + 60|0); //@line 145690 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 145690 "c/sqlite3.c"
 $12 = $11 & $9; //@line 145690 "c/sqlite3.c"
 $$0 = $12;
 return ($$0|0); //@line 145691 "c/sqlite3.c"
}
function _sqlite3_errmsg($0) {
 $0 = $0|0;
 var $$0 = 0, $$011 = 0, $$sink = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 145615 "c/sqlite3.c"
 if ($1) {
  $2 = (_sqlite3ErrStr(7)|0); //@line 145616 "c/sqlite3.c"
  $$011 = $2;
  return ($$011|0); //@line 145634 "c/sqlite3.c"
 }
 $3 = (_sqlite3SafetyCheckSickOrOk($0)|0); //@line 145618 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 145618 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3MisuseError(145619)|0); //@line 145619 "c/sqlite3.c"
  $6 = (_sqlite3ErrStr($5)|0); //@line 145619 "c/sqlite3.c"
  $$011 = $6;
  return ($$011|0); //@line 145634 "c/sqlite3.c"
 }
 $7 = ((($0)) + 12|0); //@line 145621 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 145621 "c/sqlite3.c"
 _sqlite3_mutex_enter($8); //@line 145621 "c/sqlite3.c"
 $9 = ((($0)) + 73|0); //@line 145622 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 145622 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 145622 "c/sqlite3.c"
 if ($11) {
  $12 = ((($0)) + 248|0); //@line 145626 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 145626 "c/sqlite3.c"
  $14 = (_sqlite3_value_text($13)|0); //@line 145626 "c/sqlite3.c"
  $15 = ($14|0)==(0|0); //@line 145628 "c/sqlite3.c"
  if ($15) {
   $16 = ((($0)) + 56|0); //@line 145629 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 145629 "c/sqlite3.c"
   $$sink = $17;
   label = 8;
  } else {
   $$0 = $14;
  }
 } else {
  $$sink = 7;
  label = 8;
 }
 if ((label|0) == 8) {
  $18 = (_sqlite3ErrStr($$sink)|0);
  $$0 = $18;
 }
 $19 = HEAP32[$7>>2]|0; //@line 145632 "c/sqlite3.c"
 _sqlite3_mutex_leave($19); //@line 145632 "c/sqlite3.c"
 $$011 = $$0;
 return ($$011|0); //@line 145634 "c/sqlite3.c"
}
function _sqlite3_errmsg16($0) {
 $0 = $0|0;
 var $$0 = 0, $$015 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 145641 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 145652 "c/sqlite3.c"
 if ($1) {
  $$015 = 13842;
  STACKTOP = sp;return ($$015|0); //@line 145676 "c/sqlite3.c"
 }
 $2 = (_sqlite3SafetyCheckSickOrOk($0)|0); //@line 145655 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 145655 "c/sqlite3.c"
 if ($3) {
  $$015 = 13870;
  STACKTOP = sp;return ($$015|0); //@line 145676 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0); //@line 145658 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 145658 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 145658 "c/sqlite3.c"
 $6 = ((($0)) + 73|0); //@line 145659 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 145659 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 145659 "c/sqlite3.c"
 if ($8) {
  $9 = ((($0)) + 248|0); //@line 145662 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 145662 "c/sqlite3.c"
  $11 = (_sqlite3_value_text16($10)|0); //@line 145662 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 145663 "c/sqlite3.c"
  if ($12) {
   $13 = ((($0)) + 56|0); //@line 145664 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 145664 "c/sqlite3.c"
   $15 = (_sqlite3ErrStr($14)|0); //@line 145664 "c/sqlite3.c"
   _sqlite3ErrorWithMsg($0,$14,$15,$vararg_buffer); //@line 145664 "c/sqlite3.c"
   $16 = HEAP32[$9>>2]|0; //@line 145665 "c/sqlite3.c"
   $17 = (_sqlite3_value_text16($16)|0); //@line 145665 "c/sqlite3.c"
   $$0 = $17;
  } else {
   $$0 = $11;
  }
  _sqlite3OomClear($0); //@line 145672 "c/sqlite3.c"
  $$1 = $$0;
 } else {
  $$1 = 13842;
 }
 $18 = HEAP32[$4>>2]|0; //@line 145674 "c/sqlite3.c"
 _sqlite3_mutex_leave($18); //@line 145674 "c/sqlite3.c"
 $$015 = $$1;
 STACKTOP = sp;return ($$015|0); //@line 145676 "c/sqlite3.c"
}
function _sqlite3_exec($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0123 = 0, $$080 = 0, $$082 = 0, $$083 = 0, $$083$clear = 0, $$085 = 0, $$089128 = 0, $$1$lcssa = 0, $$1124 = 0, $$181 = 0, $$186107 = 0, $$186108 = 0, $$190 = 0, $$194 = 0, $$199127 = 0, $$2 = 0, $$2100 = 0, $$2112 = 0, $$287 = 0, $$287111 = 0;
 var $$291105 = 0, $$291106 = 0, $$295140 = 0, $$3 = 0, $$3101 = 0, $$388 = 0, $$392 = 0, $$392110 = 0, $$396 = 0, $$4 = 0, $$4102 = 0, $$497 = 0, $$5103138 = 0, $$5141 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0;
 var $91 = 0, $92 = 0, $exitcond = 0, $or$cond = 0, $or$cond3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp + 4|0;
 $6 = sp;
 HEAP32[$6>>2] = 0; //@line 113139 "c/sqlite3.c"
 $7 = (_sqlite3SafetyCheckOk($0)|0); //@line 113143 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 113143 "c/sqlite3.c"
 if ($8) {
  $9 = (_sqlite3MisuseError(113143)|0); //@line 113143 "c/sqlite3.c"
  $$082 = $9;
  STACKTOP = sp;return ($$082|0); //@line 113242 "c/sqlite3.c"
 }
 $10 = ($1|0)==(0|0); //@line 113144 "c/sqlite3.c"
 $spec$select = $10 ? 41388 : $1; //@line 113144 "c/sqlite3.c"
 $11 = ((($0)) + 12|0); //@line 113146 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 113146 "c/sqlite3.c"
 _sqlite3_mutex_enter($12); //@line 113146 "c/sqlite3.c"
 _sqlite3Error($0,0); //@line 113147 "c/sqlite3.c"
 $13 = ($2|0)==(0|0);
 $14 = ((($0)) + 28|0);
 $$089128 = 0;$$199127 = $spec$select;$78 = 0;$79 = 0;
 L5: while(1) {
  $15 = HEAP8[$$199127>>0]|0; //@line 113148 "c/sqlite3.c"
  $16 = ($15<<24>>24)==(0); //@line 113148 "c/sqlite3.c"
  if ($16) {
   $$396 = 0;$70 = $79;
   break;
  }
  HEAP32[$6>>2] = 0; //@line 113152 "c/sqlite3.c"
  $17 = (_sqlite3_prepare_v2($0,$$199127,-1,$6,$5)|0); //@line 113153 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 113155 "c/sqlite3.c"
  L8: do {
   if ($18) {
    $19 = HEAP32[$6>>2]|0; //@line 113158 "c/sqlite3.c"
    $20 = ($19|0)==(0|0); //@line 113158 "c/sqlite3.c"
    if ($20) {
     $21 = HEAP32[$5>>2]|0; //@line 113160 "c/sqlite3.c"
     $$295140 = 0;$$5103138 = $21;$$5141 = $$089128;$80 = $78;$81 = $79;
     break;
    }
    $22 = (_sqlite3_column_count($19)|0); //@line 113165 "c/sqlite3.c"
    $23 = $22 << 3;
    $24 = $23 | 4;
    $25 = ($22|0)>(0);
    $26 = ($22|0)>(0);
    $$080 = 0;$$085 = 0;$$190 = $$089128;$$2100 = $$199127;$82 = $79;$83 = $78;
    L13: while(1) {
     $27 = HEAP32[$6>>2]|0; //@line 113169 "c/sqlite3.c"
     $28 = (_sqlite3_step($27)|0); //@line 113169 "c/sqlite3.c"
     L15: do {
      if ($13) {
       $$2 = $$080;$$287 = $$085;$$392 = $$190;$84 = $82;$85 = $83;
       label = 28;
      } else {
       $29 = ($28|0)==(100); //@line 113172 "c/sqlite3.c"
       if ($29) {
        $35 = ($$085|0)==(0); //@line 113175 "c/sqlite3.c"
        if ($35) {
         label = 14;
        } else {
         $$186107 = $$085;$$291105 = $$190;$88 = $83;$89 = $82;
         label = 19;
        }
       } else {
        $30 = ($28|0)!=(101); //@line 113173 "c/sqlite3.c"
        $31 = ($$085|0)!=(0); //@line 113173 "c/sqlite3.c"
        $or$cond = $31 | $30; //@line 113173 "c/sqlite3.c"
        if ($or$cond) {
         $$2112 = $$080;$$287111 = $$085;$$392110 = $$190;$86 = $83;$87 = $82;
         label = 29;
         break;
        }
        $32 = HEAP32[$14>>2]|0; //@line 113174 "c/sqlite3.c"
        $33 = $32 & 256; //@line 113174 "c/sqlite3.c"
        $34 = ($33|0)==(0); //@line 113174 "c/sqlite3.c"
        if ($34) {
         $$2112 = $$080;$$287111 = 0;$$392110 = $$190;$86 = $83;$87 = $82;
         label = 29;
         break;
        } else {
         label = 14;
        }
       }
       if ((label|0) == 14) {
        label = 0;
        $36 = (_sqlite3DbMallocRaw($0,$24,0)|0); //@line 113176 "c/sqlite3.c"
        $37 = ($36|0)==(0|0); //@line 113177 "c/sqlite3.c"
        if ($37) {
         $$083 = 6;$$194 = $28;$$3 = $$080;$$388 = 0;$$4 = $36;$$4102 = $$2100;$66 = 0;$90 = 0;
         break;
        }
        if ($26) {
         $$0123 = 0;
         while(1) {
          $38 = (_sqlite3_column_name($27,$$0123)|0); //@line 113181 "c/sqlite3.c"
          $39 = (($36) + ($$0123<<2)|0); //@line 113181 "c/sqlite3.c"
          HEAP32[$39>>2] = $38; //@line 113181 "c/sqlite3.c"
          $40 = (($$0123) + 1)|0; //@line 113180 "c/sqlite3.c"
          $exitcond = ($40|0)==($22|0); //@line 113180 "c/sqlite3.c"
          if ($exitcond) {
           break;
          } else {
           $$0123 = $40;
          }
         }
        }
        if ($29) {
         $$186107 = 1;$$291105 = $36;$88 = $36;$89 = $36;
         label = 19;
        } else {
         $$181 = $$080;$$186108 = 1;$$291106 = $36;$91 = $36;$92 = $36;
        }
       }
       if ((label|0) == 19) {
        label = 0;
        $41 = (($$291105) + ($22<<2)|0); //@line 113189 "c/sqlite3.c"
        L31: do {
         if ($25) {
          $$1124 = 0;
          while(1) {
           $42 = HEAP32[$6>>2]|0; //@line 113191 "c/sqlite3.c"
           $43 = (_sqlite3_column_text($42,$$1124)|0); //@line 113191 "c/sqlite3.c"
           $44 = (($41) + ($$1124<<2)|0); //@line 113191 "c/sqlite3.c"
           HEAP32[$44>>2] = $43; //@line 113191 "c/sqlite3.c"
           $45 = ($43|0)==(0|0); //@line 113192 "c/sqlite3.c"
           if ($45) {
            $46 = HEAP32[$6>>2]|0; //@line 113192 "c/sqlite3.c"
            $47 = (_sqlite3_column_type($46,$$1124)|0); //@line 113192 "c/sqlite3.c"
            $48 = ($47|0)==(5); //@line 113192 "c/sqlite3.c"
            if (!($48)) {
             break;
            }
           }
           $49 = (($$1124) + 1)|0; //@line 113190 "c/sqlite3.c"
           $50 = ($49|0)<($22|0); //@line 113190 "c/sqlite3.c"
           if ($50) {
            $$1124 = $49;
           } else {
            $$1$lcssa = $49;
            break L31;
           }
          }
          _sqlite3OomFault($0); //@line 113193 "c/sqlite3.c"
          $$083 = 6;$$194 = $28;$$3 = $41;$$388 = $$186107;$$4 = $$291105;$$4102 = $$2100;$66 = $88;$90 = $89;
          break L15;
         } else {
          $$1$lcssa = 0;
         }
        } while(0);
        $51 = (($41) + ($$1$lcssa<<2)|0); //@line 113197 "c/sqlite3.c"
        HEAP32[$51>>2] = 0; //@line 113197 "c/sqlite3.c"
        $$181 = $41;$$186108 = $$186107;$$291106 = $$291105;$91 = $88;$92 = $89;
       }
       $52 = (FUNCTION_TABLE_iiiii[$2 & 127]($3,$22,$$181,$$291106)|0); //@line 113199 "c/sqlite3.c"
       $53 = ($52|0)==(0); //@line 113199 "c/sqlite3.c"
       if ($53) {
        $$2 = $$181;$$287 = $$186108;$$392 = $$291106;$84 = $92;$85 = $91;
        label = 28;
       } else {
        $54 = HEAP32[$6>>2]|0; //@line 113204 "c/sqlite3.c"
        (_sqlite3VdbeFinalize($54)|0); //@line 113204 "c/sqlite3.c"
        HEAP32[$6>>2] = 0; //@line 113205 "c/sqlite3.c"
        _sqlite3Error($0,4); //@line 113206 "c/sqlite3.c"
        $$083 = 6;$$194 = 4;$$3 = $$181;$$388 = $$186108;$$4 = $$291106;$$4102 = $$2100;$66 = $91;$90 = $92;
       }
      }
     } while(0);
     if ((label|0) == 28) {
      label = 0;
      $55 = ($28|0)==(100); //@line 113211 "c/sqlite3.c"
      if ($55) {
       $$083 = 0;$$194 = 100;$$3 = $$2;$$388 = $$287;$$4 = $$392;$$4102 = $$2100;$66 = $85;$90 = $84;
      } else {
       $$2112 = $$2;$$287111 = $$287;$$392110 = $$392;$86 = $85;$87 = $84;
       label = 29;
      }
     }
     if ((label|0) == 29) {
      label = 0;
      $56 = HEAP32[$6>>2]|0; //@line 113212 "c/sqlite3.c"
      $57 = (_sqlite3VdbeFinalize($56)|0); //@line 113212 "c/sqlite3.c"
      HEAP32[$6>>2] = 0; //@line 113213 "c/sqlite3.c"
      $58 = HEAP32[$5>>2]|0; //@line 113214 "c/sqlite3.c"
      $$3101 = $58;
      while(1) {
       $59 = HEAP8[$$3101>>0]|0; //@line 113215 "c/sqlite3.c"
       $60 = $59&255; //@line 113215 "c/sqlite3.c"
       $61 = (16281 + ($60)|0); //@line 113215 "c/sqlite3.c"
       $62 = HEAP8[$61>>0]|0; //@line 113215 "c/sqlite3.c"
       $63 = $62 & 1; //@line 113215 "c/sqlite3.c"
       $64 = ($63<<24>>24)==(0); //@line 113215 "c/sqlite3.c"
       $65 = ((($$3101)) + 1|0); //@line 113215 "c/sqlite3.c"
       if ($64) {
        $$083 = 5;$$194 = $57;$$3 = $$2112;$$388 = $$287111;$$4 = $$392110;$$4102 = $$3101;$66 = $86;$90 = $87;
        break;
       } else {
        $$3101 = $65;
       }
      }
     }
     $$083$clear = $$083 & 7;
     switch ($$083$clear<<24>>24) {
     case 6:  {
      $$396 = $$194;$70 = $90;
      break L5;
      break;
     }
     case 2:  {
      $$295140 = $$194;$$5103138 = $$4102;$$5141 = $$4;$80 = $66;$81 = $90;
      break L8;
      break;
     }
     case 0:  {
      $$080 = $$3;$$085 = $$388;$$190 = $$4;$$2100 = $$4102;$82 = $90;$83 = $66;
      break;
     }
     case 5:  {
      break L13;
      break;
     }
     default: {
      $$082 = 0;
      label = 42;
      break L5;
     }
     }
    }
    _sqlite3DbFree($0,$66); //@line 113220 "c/sqlite3.c"
    $$295140 = $$194;$$5103138 = $$4102;$$5141 = 0;$80 = 0;$81 = 0;
   } else {
    $$295140 = $17;$$5103138 = $$199127;$$5141 = $$089128;$80 = $78;$81 = $79;
   }
  } while(0);
  $67 = ($$295140|0)==(0); //@line 113148 "c/sqlite3.c"
  if ($67) {
   $$089128 = $$5141;$$199127 = $$5103138;$78 = $80;$79 = $81;
  } else {
   $$396 = $$295140;$70 = $81;
   break;
  }
 }
 if ((label|0) == 42) {
  STACKTOP = sp;return ($$082|0); //@line 113242 "c/sqlite3.c"
 }
 $68 = HEAP32[$6>>2]|0; //@line 113225 "c/sqlite3.c"
 $69 = ($68|0)==(0|0); //@line 113225 "c/sqlite3.c"
 if (!($69)) {
  (_sqlite3VdbeFinalize($68)|0); //@line 113225 "c/sqlite3.c"
 }
 _sqlite3DbFree($0,$70); //@line 113226 "c/sqlite3.c"
 $71 = (_sqlite3ApiExit($0,$$396)|0); //@line 113228 "c/sqlite3.c"
 $72 = ($71|0)!=(0); //@line 113229 "c/sqlite3.c"
 $73 = ($4|0)!=(0|0); //@line 113229 "c/sqlite3.c"
 $or$cond3 = $73 & $72; //@line 113229 "c/sqlite3.c"
 if ($or$cond3) {
  $74 = (_sqlite3_errmsg($0)|0); //@line 113230 "c/sqlite3.c"
  $75 = (_sqlite3DbStrDup(0,$74)|0); //@line 113230 "c/sqlite3.c"
  HEAP32[$4>>2] = $75; //@line 113230 "c/sqlite3.c"
  $76 = ($75|0)==(0|0); //@line 113231 "c/sqlite3.c"
  if ($76) {
   _sqlite3Error($0,7); //@line 113233 "c/sqlite3.c"
   $$497 = 7;
  } else {
   $$497 = $71;
  }
 } else {
  if ($73) {
   HEAP32[$4>>2] = 0; //@line 113236 "c/sqlite3.c"
   $$497 = $71;
  } else {
   $$497 = $71;
  }
 }
 $77 = HEAP32[$11>>2]|0; //@line 113240 "c/sqlite3.c"
 _sqlite3_mutex_leave($77); //@line 113240 "c/sqlite3.c"
 $$082 = $$497;
 STACKTOP = sp;return ($$082|0); //@line 113242 "c/sqlite3.c"
}
function _sqlite3_expired($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 77735 "c/sqlite3.c"
 if ($1) {
  $6 = 1;
  return ($6|0); //@line 77735 "c/sqlite3.c"
 }
 $2 = ((($0)) + 145|0); //@line 77735 "c/sqlite3.c"
 $3 = HEAPU8[$2>>0]|(HEAPU8[$2+1>>0]<<8); //@line 77735 "c/sqlite3.c"
 $4 = $3 & 1; //@line 77735 "c/sqlite3.c"
 $5 = $4&65535; //@line 77735 "c/sqlite3.c"
 $6 = $5;
 return ($6|0); //@line 77735 "c/sqlite3.c"
}
function _sqlite3_finalize($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 77804 "c/sqlite3.c"
 if ($1) {
  $$1 = 0;
  return ($$1|0); //@line 77819 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 77810 "c/sqlite3.c"
 $3 = (_vdbeSafety($0)|0); //@line 77811 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 77811 "c/sqlite3.c"
 if (!($4)) {
  $21 = (_sqlite3MisuseError(77811)|0); //@line 77811 "c/sqlite3.c"
  $$1 = $21;
  return ($$1|0); //@line 77819 "c/sqlite3.c"
 }
 $5 = ((($2)) + 12|0); //@line 77812 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 77812 "c/sqlite3.c"
 _sqlite3_mutex_enter($6); //@line 77812 "c/sqlite3.c"
 $7 = ((($0)) + 128|0); //@line 77813 "c/sqlite3.c"
 $8 = $7; //@line 77813 "c/sqlite3.c"
 $9 = $8; //@line 77813 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 77813 "c/sqlite3.c"
 $11 = (($8) + 4)|0; //@line 77813 "c/sqlite3.c"
 $12 = $11; //@line 77813 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 77813 "c/sqlite3.c"
 $14 = ($13|0)>(0); //@line 77813 "c/sqlite3.c"
 $15 = ($10>>>0)>(0); //@line 77813 "c/sqlite3.c"
 $16 = ($13|0)==(0); //@line 77813 "c/sqlite3.c"
 $17 = $16 & $15; //@line 77813 "c/sqlite3.c"
 $18 = $14 | $17; //@line 77813 "c/sqlite3.c"
 if ($18) {
  _invokeProfileCallback($2,$0); //@line 77813 "c/sqlite3.c"
 }
 $19 = (_sqlite3VdbeFinalize($0)|0); //@line 77814 "c/sqlite3.c"
 $20 = (_sqlite3ApiExit($2,$19)|0); //@line 77815 "c/sqlite3.c"
 _sqlite3LeaveMutexAndCloseZombie($2); //@line 77816 "c/sqlite3.c"
 $$1 = $20;
 return ($$1|0); //@line 77819 "c/sqlite3.c"
}
function _sqlite3_free_table($0) {
 $0 = $0|0;
 var $$012 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 124925 "c/sqlite3.c"
 if ($1) {
  return; //@line 124933 "c/sqlite3.c"
 }
 $2 = ((($0)) + -4|0); //@line 124927 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 124929 "c/sqlite3.c"
 $4 = ($3|0)>(1); //@line 124930 "c/sqlite3.c"
 if ($4) {
  $$012 = 1;
  while(1) {
   $5 = (($2) + ($$012<<2)|0); //@line 124930 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 124930 "c/sqlite3.c"
   $7 = ($6|0)==(0|0); //@line 124930 "c/sqlite3.c"
   if (!($7)) {
    _sqlite3_free($6); //@line 124930 "c/sqlite3.c"
   }
   $8 = (($$012) + 1)|0; //@line 124930 "c/sqlite3.c"
   $exitcond = ($8|0)==($3|0); //@line 124930 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$012 = $8;
   }
  }
 }
 _sqlite3_free($2); //@line 124931 "c/sqlite3.c"
 return; //@line 124933 "c/sqlite3.c"
}
function _sqlite3_get_autocommit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 71|0); //@line 146708 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 146708 "c/sqlite3.c"
 $3 = $2&255; //@line 146708 "c/sqlite3.c"
 return ($3|0); //@line 146708 "c/sqlite3.c"
}
function _sqlite3_get_auxdata($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$011 = 0, $$013 = 0, $$014 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 78578 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 78578 "c/sqlite3.c"
 $4 = ((($3)) + 212|0); //@line 78578 "c/sqlite3.c"
 $$013 = HEAP32[$4>>2]|0;
 $5 = ($$013|0)==(0|0); //@line 78578 "c/sqlite3.c"
 if ($5) {
  $$011 = 0;
  return ($$011|0); //@line 78584 "c/sqlite3.c"
 }
 $6 = ((($0)) + 16|0);
 $7 = ($1|0)<(0);
 $$014 = $$013;
 while(1) {
  $8 = ((($$014)) + 4|0); //@line 78579 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 78579 "c/sqlite3.c"
  $10 = ($9|0)==($1|0); //@line 78579 "c/sqlite3.c"
  if ($10) {
   $11 = HEAP32[$$014>>2]|0; //@line 78579 "c/sqlite3.c"
   $12 = HEAP32[$6>>2]|0; //@line 78579 "c/sqlite3.c"
   $13 = ($11|0)==($12|0); //@line 78579 "c/sqlite3.c"
   $or$cond = $7 | $13; //@line 78579 "c/sqlite3.c"
   if ($or$cond) {
    break;
   }
  }
  $16 = ((($$014)) + 16|0); //@line 78578 "c/sqlite3.c"
  $$0 = HEAP32[$16>>2]|0;
  $17 = ($$0|0)==(0|0); //@line 78578 "c/sqlite3.c"
  if ($17) {
   $$011 = 0;
   label = 7;
   break;
  } else {
   $$014 = $$0;
  }
 }
 if ((label|0) == 7) {
  return ($$011|0); //@line 78584 "c/sqlite3.c"
 }
 $14 = ((($$014)) + 8|0); //@line 78580 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 78580 "c/sqlite3.c"
 $$011 = $15;
 return ($$011|0); //@line 78584 "c/sqlite3.c"
}
function _sqlite3_get_table($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $6 = sp + 4|0;
 HEAP32[$2>>2] = 0; //@line 124867 "c/sqlite3.c"
 $7 = ($4|0)!=(0|0); //@line 124868 "c/sqlite3.c"
 if ($7) {
  HEAP32[$4>>2] = 0; //@line 124868 "c/sqlite3.c"
 }
 $8 = ($3|0)!=(0|0); //@line 124869 "c/sqlite3.c"
 if ($8) {
  HEAP32[$3>>2] = 0; //@line 124869 "c/sqlite3.c"
 }
 $9 = ($5|0)!=(0|0); //@line 124870 "c/sqlite3.c"
 if ($9) {
  HEAP32[$5>>2] = 0; //@line 124870 "c/sqlite3.c"
 }
 $10 = ((($6)) + 4|0); //@line 124871 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 124871 "c/sqlite3.c"
 $11 = ((($6)) + 12|0); //@line 124872 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 124872 "c/sqlite3.c"
 $12 = ((($6)) + 16|0); //@line 124873 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 124873 "c/sqlite3.c"
 $13 = ((($6)) + 20|0); //@line 124874 "c/sqlite3.c"
 HEAP32[$13>>2] = 1; //@line 124874 "c/sqlite3.c"
 $14 = ((($6)) + 8|0); //@line 124875 "c/sqlite3.c"
 HEAP32[$14>>2] = 20; //@line 124875 "c/sqlite3.c"
 $15 = ((($6)) + 24|0); //@line 124876 "c/sqlite3.c"
 HEAP32[$15>>2] = 0; //@line 124876 "c/sqlite3.c"
 $16 = (_sqlite3_malloc64(80,0)|0); //@line 124877 "c/sqlite3.c"
 HEAP32[$6>>2] = $16; //@line 124877 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 124878 "c/sqlite3.c"
 if ($17) {
  $18 = ((($0)) + 56|0); //@line 124879 "c/sqlite3.c"
  HEAP32[$18>>2] = 7; //@line 124879 "c/sqlite3.c"
  $$1 = 7;
  STACKTOP = sp;return ($$1|0); //@line 124917 "c/sqlite3.c"
 }
 HEAP32[$16>>2] = 0; //@line 124882 "c/sqlite3.c"
 $19 = (_sqlite3_exec($0,$1,84,$6,$5)|0); //@line 124883 "c/sqlite3.c"
 $20 = HEAP32[$13>>2]|0; //@line 124885 "c/sqlite3.c"
 $21 = HEAP32[$6>>2]|0; //@line 124885 "c/sqlite3.c"
 HEAP32[$21>>2] = $20; //@line 124885 "c/sqlite3.c"
 $22 = $19 & 255; //@line 124886 "c/sqlite3.c"
 $23 = ($22|0)==(4); //@line 124886 "c/sqlite3.c"
 if ($23) {
  $24 = HEAP32[$6>>2]|0; //@line 124887 "c/sqlite3.c"
  $25 = ((($24)) + 4|0); //@line 124887 "c/sqlite3.c"
  _sqlite3_free_table($25); //@line 124887 "c/sqlite3.c"
  $26 = HEAP32[$10>>2]|0; //@line 124888 "c/sqlite3.c"
  $27 = ($26|0)==(0|0); //@line 124888 "c/sqlite3.c"
  if (!($27)) {
   if ($9) {
    $28 = HEAP32[$5>>2]|0; //@line 124890 "c/sqlite3.c"
    _sqlite3_free($28); //@line 124890 "c/sqlite3.c"
    $29 = HEAP32[$10>>2]|0; //@line 124891 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $29; //@line 124891 "c/sqlite3.c"
    $30 = (_sqlite3_mprintf(15687,$vararg_buffer)|0); //@line 124891 "c/sqlite3.c"
    HEAP32[$5>>2] = $30; //@line 124891 "c/sqlite3.c"
   }
   $31 = HEAP32[$10>>2]|0; //@line 124893 "c/sqlite3.c"
   _sqlite3_free($31); //@line 124893 "c/sqlite3.c"
  }
  $32 = HEAP32[$15>>2]|0; //@line 124895 "c/sqlite3.c"
  $33 = ((($0)) + 56|0); //@line 124895 "c/sqlite3.c"
  HEAP32[$33>>2] = $32; //@line 124895 "c/sqlite3.c"
  $$1 = $32;
  STACKTOP = sp;return ($$1|0); //@line 124917 "c/sqlite3.c"
 }
 $34 = HEAP32[$10>>2]|0; //@line 124898 "c/sqlite3.c"
 _sqlite3_free($34); //@line 124898 "c/sqlite3.c"
 $35 = ($19|0)==(0); //@line 124899 "c/sqlite3.c"
 if (!($35)) {
  $36 = HEAP32[$6>>2]|0; //@line 124900 "c/sqlite3.c"
  $37 = ((($36)) + 4|0); //@line 124900 "c/sqlite3.c"
  _sqlite3_free_table($37); //@line 124900 "c/sqlite3.c"
  $$1 = $19;
  STACKTOP = sp;return ($$1|0); //@line 124917 "c/sqlite3.c"
 }
 $38 = HEAP32[$14>>2]|0; //@line 124903 "c/sqlite3.c"
 $39 = HEAP32[$13>>2]|0; //@line 124903 "c/sqlite3.c"
 $40 = ($38>>>0)>($39>>>0); //@line 124903 "c/sqlite3.c"
 do {
  if ($40) {
   $41 = HEAP32[$6>>2]|0; //@line 124905 "c/sqlite3.c"
   $42 = $39 << 2; //@line 124905 "c/sqlite3.c"
   $43 = (_sqlite3_realloc64($41,$42,0)|0); //@line 124905 "c/sqlite3.c"
   $44 = ($43|0)==(0|0); //@line 124906 "c/sqlite3.c"
   if (!($44)) {
    HEAP32[$6>>2] = $43; //@line 124911 "c/sqlite3.c"
    break;
   }
   $45 = HEAP32[$6>>2]|0; //@line 124907 "c/sqlite3.c"
   $46 = ((($45)) + 4|0); //@line 124907 "c/sqlite3.c"
   _sqlite3_free_table($46); //@line 124907 "c/sqlite3.c"
   $47 = ((($0)) + 56|0); //@line 124908 "c/sqlite3.c"
   HEAP32[$47>>2] = 7; //@line 124908 "c/sqlite3.c"
   $$1 = 7;
   STACKTOP = sp;return ($$1|0); //@line 124917 "c/sqlite3.c"
  }
 } while(0);
 $48 = HEAP32[$6>>2]|0; //@line 124913 "c/sqlite3.c"
 $49 = ((($48)) + 4|0); //@line 124913 "c/sqlite3.c"
 HEAP32[$2>>2] = $49; //@line 124913 "c/sqlite3.c"
 if ($7) {
  $50 = HEAP32[$12>>2]|0; //@line 124914 "c/sqlite3.c"
  HEAP32[$4>>2] = $50; //@line 124914 "c/sqlite3.c"
 }
 if (!($8)) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 124917 "c/sqlite3.c"
 }
 $51 = HEAP32[$11>>2]|0; //@line 124915 "c/sqlite3.c"
 HEAP32[$3>>2] = $51; //@line 124915 "c/sqlite3.c"
 $$1 = 0;
 STACKTOP = sp;return ($$1|0); //@line 124917 "c/sqlite3.c"
}
function _sqlite3_interrupt($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 256|0); //@line 144969 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 144969 "c/sqlite3.c"
 return; //@line 144970 "c/sqlite3.c"
}
function _sqlite3_libversion() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (15077|0); //@line 143413 "c/sqlite3.c"
}
function _sqlite3_libversion_number() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 3022000; //@line 143426 "c/sqlite3.c"
}
function _sqlite3_open($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_openDatabase($0,$1,6,0)|0); //@line 146524 "c/sqlite3.c"
 return ($2|0); //@line 146524 "c/sqlite3.c"
}
function _sqlite3_open16($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$021 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$1>>2] = 0; //@line 146551 "c/sqlite3.c"
 $2 = (_sqlite3_initialize()|0); //@line 146553 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 146554 "c/sqlite3.c"
 if (!($3)) {
  $$021 = $2;
  return ($$021|0); //@line 146573 "c/sqlite3.c"
 }
 $4 = ($0|0)==(0|0); //@line 146556 "c/sqlite3.c"
 $spec$select = $4 ? 41952 : $0; //@line 146556 "c/sqlite3.c"
 $5 = (_sqlite3ValueNew(0)|0); //@line 146557 "c/sqlite3.c"
 _sqlite3ValueSetStr($5,$spec$select,2,0); //@line 146558 "c/sqlite3.c"
 $6 = (_sqlite3ValueText($5,1)|0); //@line 146559 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 146560 "c/sqlite3.c"
 if ($7) {
  $$0 = 7;
 } else {
  $8 = (_openDatabase($6,$1,6,0)|0); //@line 146561 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 146564 "c/sqlite3.c"
  if ($9) {
   $10 = HEAP32[$1>>2]|0; //@line 146564 "c/sqlite3.c"
   $11 = ((($10)) + 16|0); //@line 146564 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 146564 "c/sqlite3.c"
   $13 = ((($12)) + 12|0); //@line 146564 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 146564 "c/sqlite3.c"
   $15 = ((($14)) + 78|0); //@line 146564 "c/sqlite3.c"
   $16 = HEAP16[$15>>1]|0; //@line 146564 "c/sqlite3.c"
   $17 = $16 & 1; //@line 146564 "c/sqlite3.c"
   $18 = ($17<<16>>16)==(0); //@line 146564 "c/sqlite3.c"
   if ($18) {
    $19 = ((($10)) + 70|0); //@line 146565 "c/sqlite3.c"
    HEAP8[$19>>0] = 2; //@line 146565 "c/sqlite3.c"
    $20 = ((($14)) + 77|0); //@line 146565 "c/sqlite3.c"
    HEAP8[$20>>0] = 2; //@line 146565 "c/sqlite3.c"
    $$0 = 0;
   } else {
    $$0 = 0;
   }
  } else {
   $$0 = $8;
  }
 }
 _sqlite3ValueFree($5); //@line 146570 "c/sqlite3.c"
 $21 = $$0 & 255; //@line 146572 "c/sqlite3.c"
 $$021 = $21;
 return ($$021|0); //@line 146573 "c/sqlite3.c"
}
function _sqlite3_prepare($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3LockAndPrepare($0,$1,$2,0,0,$3,$4)|0); //@line 118535 "c/sqlite3.c"
 return ($5|0); //@line 118537 "c/sqlite3.c"
}
function _sqlite3_prepare16($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3Prepare16($0,$1,$2,0,$3,$4)|0); //@line 118651 "c/sqlite3.c"
 return ($5|0); //@line 118653 "c/sqlite3.c"
}
function _sqlite3_profile($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145271 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145271 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145271 "c/sqlite3.c"
 $5 = ((($0)) + 200|0); //@line 145272 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145272 "c/sqlite3.c"
 $7 = ((($0)) + 196|0); //@line 145273 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 145273 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 145274 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 145275 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 145275 "c/sqlite3.c"
 return ($6|0); //@line 145276 "c/sqlite3.c"
}
function _sqlite3_progress_handler($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$sink = 0, $$sink12 = 0, $$sink14 = 0, $10 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 12|0); //@line 144927 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 144927 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 144927 "c/sqlite3.c"
 $6 = ($1|0)>(0); //@line 144928 "c/sqlite3.c"
 $7 = ((($0)) + 312|0);
 $$sink14 = $6 ? $2 : 0; //@line 144928 "c/sqlite3.c"
 $$sink12 = $6 ? $1 : 0; //@line 144928 "c/sqlite3.c"
 $$sink = $6 ? $3 : 0; //@line 144928 "c/sqlite3.c"
 HEAP32[$7>>2] = $$sink14;
 $8 = ((($0)) + 320|0);
 HEAP32[$8>>2] = $$sink12;
 $9 = ((($0)) + 316|0);
 HEAP32[$9>>2] = $$sink;
 $10 = HEAP32[$4>>2]|0; //@line 144937 "c/sqlite3.c"
 _sqlite3_mutex_leave($10); //@line 144937 "c/sqlite3.c"
 return; //@line 144938 "c/sqlite3.c"
}
function _sqlite3_reset($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 77831 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
  return ($$0|0); //@line 77844 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 77835 "c/sqlite3.c"
 $3 = ((($2)) + 12|0); //@line 77836 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 77836 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 77836 "c/sqlite3.c"
 $5 = ((($0)) + 128|0); //@line 77837 "c/sqlite3.c"
 $6 = $5; //@line 77837 "c/sqlite3.c"
 $7 = $6; //@line 77837 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 77837 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 77837 "c/sqlite3.c"
 $10 = $9; //@line 77837 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 77837 "c/sqlite3.c"
 $12 = ($11|0)>(0); //@line 77837 "c/sqlite3.c"
 $13 = ($8>>>0)>(0); //@line 77837 "c/sqlite3.c"
 $14 = ($11|0)==(0); //@line 77837 "c/sqlite3.c"
 $15 = $14 & $13; //@line 77837 "c/sqlite3.c"
 $16 = $12 | $15; //@line 77837 "c/sqlite3.c"
 if ($16) {
  _invokeProfileCallback($2,$0); //@line 77837 "c/sqlite3.c"
 }
 $17 = (_sqlite3VdbeReset($0)|0); //@line 77838 "c/sqlite3.c"
 _sqlite3VdbeRewind($0); //@line 77839 "c/sqlite3.c"
 $18 = (_sqlite3ApiExit($2,$17)|0); //@line 77841 "c/sqlite3.c"
 $19 = HEAP32[$3>>2]|0; //@line 77842 "c/sqlite3.c"
 _sqlite3_mutex_leave($19); //@line 77842 "c/sqlite3.c"
 $$0 = $18;
 return ($$0|0); //@line 77844 "c/sqlite3.c"
}
function _sqlite3_result_error16($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 20|0); //@line 78086 "c/sqlite3.c"
 HEAP32[$3>>2] = 1; //@line 78086 "c/sqlite3.c"
 $4 = ((($0)) + 25|0); //@line 78087 "c/sqlite3.c"
 HEAP8[$4>>0] = 1; //@line 78087 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 78088 "c/sqlite3.c"
 (_sqlite3VdbeMemSetStr($5,$1,$2,2,(-1))|0); //@line 78088 "c/sqlite3.c"
 return; //@line 78089 "c/sqlite3.c"
}
function _sqlite3_result_text16($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _setResultStrOrError($0,$1,$2,2,$3); //@line 78154 "c/sqlite3.c"
 return; //@line 78155 "c/sqlite3.c"
}
function _sqlite3_result_text16be($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _setResultStrOrError($0,$1,$2,3,$3); //@line 78163 "c/sqlite3.c"
 return; //@line 78164 "c/sqlite3.c"
}
function _sqlite3_result_text16le($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _setResultStrOrError($0,$1,$2,2,$3); //@line 78172 "c/sqlite3.c"
 return; //@line 78173 "c/sqlite3.c"
}
function _sqlite3_rollback_hook($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145349 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145349 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145349 "c/sqlite3.c"
 $5 = ((($0)) + 212|0); //@line 145350 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145350 "c/sqlite3.c"
 $7 = ((($0)) + 216|0); //@line 145351 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 145351 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 145352 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 145353 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 145353 "c/sqlite3.c"
 return ($6|0); //@line 145354 "c/sqlite3.c"
}
function _sqlite3_set_authorizer($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 101422 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 101422 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 101422 "c/sqlite3.c"
 $5 = ((($0)) + 304|0); //@line 101423 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 101423 "c/sqlite3.c"
 $6 = ((($0)) + 308|0); //@line 101424 "c/sqlite3.c"
 HEAP32[$6>>2] = $2; //@line 101424 "c/sqlite3.c"
 _sqlite3ExpirePreparedStatements($0); //@line 101425 "c/sqlite3.c"
 $7 = HEAP32[$3>>2]|0; //@line 101426 "c/sqlite3.c"
 _sqlite3_mutex_leave($7); //@line 101426 "c/sqlite3.c"
 return 0; //@line 101427 "c/sqlite3.c"
}
function _sqlite3_set_auxdata($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$037 = 0, $$039 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, $cond38 = 0, $or$cond = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 12|0); //@line 78604 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 78604 "c/sqlite3.c"
 $6 = ((($5)) + 212|0); //@line 78613 "c/sqlite3.c"
 $$037 = HEAP32[$6>>2]|0;
 $cond38 = ($$037|0)==(0|0); //@line 78613 "c/sqlite3.c"
 L1: do {
  if ($cond38) {
   label = 6;
  } else {
   $7 = ((($0)) + 16|0);
   $8 = ($1|0)<(0);
   $$039 = $$037;
   while(1) {
    $9 = ((($$039)) + 4|0); //@line 78614 "c/sqlite3.c"
    $10 = HEAP32[$9>>2]|0; //@line 78614 "c/sqlite3.c"
    $11 = ($10|0)==($1|0); //@line 78614 "c/sqlite3.c"
    if ($11) {
     $12 = HEAP32[$$039>>2]|0; //@line 78614 "c/sqlite3.c"
     $13 = HEAP32[$7>>2]|0; //@line 78614 "c/sqlite3.c"
     $14 = ($12|0)==($13|0); //@line 78614 "c/sqlite3.c"
     $or$cond = $8 | $14; //@line 78614 "c/sqlite3.c"
     if ($or$cond) {
      break;
     }
    }
    $15 = ((($$039)) + 16|0); //@line 78613 "c/sqlite3.c"
    $$0 = HEAP32[$15>>2]|0;
    $cond = ($$0|0)==(0|0); //@line 78613 "c/sqlite3.c"
    if ($cond) {
     label = 6;
     break L1;
    } else {
     $$039 = $$0;
    }
   }
   $28 = ((($$039)) + 12|0); //@line 78629 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 78629 "c/sqlite3.c"
   $30 = ($29|0)==(0|0); //@line 78629 "c/sqlite3.c"
   if ($30) {
    $$1 = $$039;
   } else {
    $31 = ((($$039)) + 8|0); //@line 78630 "c/sqlite3.c"
    $32 = HEAP32[$31>>2]|0; //@line 78630 "c/sqlite3.c"
    FUNCTION_TABLE_vi[$29 & 127]($32); //@line 78630 "c/sqlite3.c"
    $$1 = $$039;
   }
  }
 } while(0);
 do {
  if ((label|0) == 6) {
   $16 = HEAP32[$5>>2]|0; //@line 78619 "c/sqlite3.c"
   $17 = (_sqlite3DbMallocZero($16,20,0)|0); //@line 78619 "c/sqlite3.c"
   $18 = ($17|0)==(0|0); //@line 78620 "c/sqlite3.c"
   if (!($18)) {
    $19 = ((($0)) + 16|0); //@line 78621 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 78621 "c/sqlite3.c"
    HEAP32[$17>>2] = $20; //@line 78621 "c/sqlite3.c"
    $21 = ((($17)) + 4|0); //@line 78622 "c/sqlite3.c"
    HEAP32[$21>>2] = $1; //@line 78622 "c/sqlite3.c"
    $22 = HEAP32[$6>>2]|0; //@line 78623 "c/sqlite3.c"
    $23 = ((($17)) + 16|0); //@line 78623 "c/sqlite3.c"
    HEAP32[$23>>2] = $22; //@line 78623 "c/sqlite3.c"
    HEAP32[$6>>2] = $17; //@line 78624 "c/sqlite3.c"
    $24 = ((($0)) + 25|0); //@line 78625 "c/sqlite3.c"
    $25 = HEAP8[$24>>0]|0; //@line 78625 "c/sqlite3.c"
    $26 = ($25<<24>>24)==(0); //@line 78625 "c/sqlite3.c"
    if (!($26)) {
     $$1 = $17;
     break;
    }
    $27 = ((($0)) + 20|0); //@line 78626 "c/sqlite3.c"
    HEAP32[$27>>2] = 0; //@line 78626 "c/sqlite3.c"
    HEAP8[$24>>0] = 1; //@line 78627 "c/sqlite3.c"
    $$1 = $17;
    break;
   }
   $35 = ($3|0)==(0|0); //@line 78638 "c/sqlite3.c"
   if ($35) {
    return; //@line 78641 "c/sqlite3.c"
   }
   FUNCTION_TABLE_vi[$3 & 127]($2); //@line 78639 "c/sqlite3.c"
   return; //@line 78641 "c/sqlite3.c"
  }
 } while(0);
 $33 = ((($$1)) + 8|0); //@line 78633 "c/sqlite3.c"
 HEAP32[$33>>2] = $2; //@line 78633 "c/sqlite3.c"
 $34 = ((($$1)) + 12|0); //@line 78634 "c/sqlite3.c"
 HEAP32[$34>>2] = $3; //@line 78634 "c/sqlite3.c"
 return; //@line 78641 "c/sqlite3.c"
}
function _sqlite3_step($0) {
 $0 = $0|0;
 var $$0 = 0, $$04142 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_vdbeSafetyNotNull($0)|0); //@line 78395 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 78395 "c/sqlite3.c"
 if (!($2)) {
  $3 = (_sqlite3MisuseError(78396)|0); //@line 78396 "c/sqlite3.c"
  $$0 = $3;
  return ($$0|0); //@line 78431 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 78398 "c/sqlite3.c"
 $5 = ((($4)) + 12|0); //@line 78399 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 78399 "c/sqlite3.c"
 _sqlite3_mutex_enter($6); //@line 78399 "c/sqlite3.c"
 $7 = ((($0)) + 145|0); //@line 78400 "c/sqlite3.c"
 $8 = HEAPU8[$7>>0]|(HEAPU8[$7+1>>0]<<8); //@line 78400 "c/sqlite3.c"
 $9 = $8 & -3; //@line 78400 "c/sqlite3.c"
 HEAP8[$7>>0]=$9&255;HEAP8[$7+1>>0]=$9>>8; //@line 78400 "c/sqlite3.c"
 $10 = (_sqlite3Step($0)|0); //@line 78401 "c/sqlite3.c"
 $11 = ($10|0)==(17); //@line 78401 "c/sqlite3.c"
 L5: do {
  if ($11) {
   $12 = ((($0)) + 36|0);
   $$04142 = 0;
   while(1) {
    $13 = (($$04142) + 1)|0; //@line 78402 "c/sqlite3.c"
    $14 = ($$04142>>>0)<(50); //@line 78402 "c/sqlite3.c"
    if (!($14)) {
     $$2 = 17;
     break L5;
    }
    $15 = HEAP32[$12>>2]|0; //@line 78403 "c/sqlite3.c"
    $16 = (_sqlite3Reprepare($0)|0); //@line 78404 "c/sqlite3.c"
    $17 = ($16|0)==(0); //@line 78405 "c/sqlite3.c"
    if (!($17)) {
     break;
    }
    (_sqlite3_reset($0)|0); //@line 78425 "c/sqlite3.c"
    $30 = ($15|0)>(-1); //@line 78426 "c/sqlite3.c"
    if ($30) {
     $31 = HEAPU8[$7>>0]|(HEAPU8[$7+1>>0]<<8); //@line 78426 "c/sqlite3.c"
     $32 = $31 | 2; //@line 78426 "c/sqlite3.c"
     HEAP8[$7>>0]=$32&255;HEAP8[$7+1>>0]=$32>>8; //@line 78426 "c/sqlite3.c"
    }
    $33 = (_sqlite3Step($0)|0); //@line 78401 "c/sqlite3.c"
    $34 = ($33|0)==(17); //@line 78401 "c/sqlite3.c"
    if ($34) {
     $$04142 = $13;
    } else {
     $$2 = $33;
     break L5;
    }
   }
   $18 = ((($4)) + 248|0); //@line 78414 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 78414 "c/sqlite3.c"
   $20 = (_sqlite3_value_text($19)|0); //@line 78414 "c/sqlite3.c"
   $21 = ((($0)) + 108|0); //@line 78415 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 78415 "c/sqlite3.c"
   _sqlite3DbFree($4,$22); //@line 78415 "c/sqlite3.c"
   $23 = ((($4)) + 73|0); //@line 78416 "c/sqlite3.c"
   $24 = HEAP8[$23>>0]|0; //@line 78416 "c/sqlite3.c"
   $25 = ($24<<24>>24)==(0); //@line 78416 "c/sqlite3.c"
   if ($25) {
    $26 = (_sqlite3DbStrDup($4,$20)|0); //@line 78417 "c/sqlite3.c"
    HEAP32[$21>>2] = $26; //@line 78417 "c/sqlite3.c"
    $27 = (_sqlite3ApiExit($4,$16)|0); //@line 78418 "c/sqlite3.c"
    $28 = ((($0)) + 40|0); //@line 78418 "c/sqlite3.c"
    HEAP32[$28>>2] = $27; //@line 78418 "c/sqlite3.c"
    $$2 = $27;
    break;
   } else {
    HEAP32[$21>>2] = 0; //@line 78420 "c/sqlite3.c"
    $29 = ((($0)) + 40|0); //@line 78421 "c/sqlite3.c"
    HEAP32[$29>>2] = 7; //@line 78421 "c/sqlite3.c"
    $$2 = 7;
    break;
   }
  } else {
   $$2 = $10;
  }
 } while(0);
 $35 = HEAP32[$5>>2]|0; //@line 78429 "c/sqlite3.c"
 _sqlite3_mutex_leave($35); //@line 78429 "c/sqlite3.c"
 $$0 = $$2;
 return ($$0|0); //@line 78431 "c/sqlite3.c"
}
function _sqlite3_table_column_metadata($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$0 = 0, $$080 = 0, $$082 = 0, $$084 = 0, $$086 = 0, $$088$lcssa = 0, $$08894 = 0, $$092 = 0, $$093 = 0, $$1 = 0, $$181 = 0, $$183 = 0, $$185 = 0, $$187 = 0, $$189 = 0, $$191 = 0, $$2 = 0, $$lcssa = 0, $$lobit = 0, $10 = 0;
 var $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_ptr1 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 $9 = sp + 12|0;
 HEAP32[$9>>2] = 0; //@line 146784 "c/sqlite3.c"
 $10 = ((($0)) + 12|0); //@line 146802 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 146802 "c/sqlite3.c"
 _sqlite3_mutex_enter($11); //@line 146802 "c/sqlite3.c"
 _sqlite3BtreeEnterAll($0); //@line 146803 "c/sqlite3.c"
 $12 = (_sqlite3Init($0,$9)|0); //@line 146804 "c/sqlite3.c"
 $13 = ($12|0)!=(0); //@line 146805 "c/sqlite3.c"
 L1: do {
  if ($13) {
   $$092 = 0;$$1 = 0;$$181 = 0;$$183 = 0;$$185 = 0;$$187 = 0;
  } else {
   $14 = (_sqlite3FindTable($0,$2,$1)|0); //@line 146810 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 146811 "c/sqlite3.c"
   if ($15) {
    $$092 = 0;$$1 = 0;$$181 = 0;$$183 = 0;$$185 = 0;$$187 = 0;
   } else {
    $16 = ((($14)) + 12|0); //@line 146811 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 146811 "c/sqlite3.c"
    $18 = ($17|0)==(0|0); //@line 146811 "c/sqlite3.c"
    if ($18) {
     $19 = ($3|0)==(0|0); //@line 146817 "c/sqlite3.c"
     do {
      if ($19) {
       $$0 = 0;$$080 = 1;$$082 = 0;$$084 = 0;$$086 = 22885;
      } else {
       $20 = ((($14)) + 42|0); //@line 146820 "c/sqlite3.c"
       $21 = HEAP16[$20>>1]|0; //@line 146820 "c/sqlite3.c"
       $22 = $21 << 16 >> 16; //@line 146820 "c/sqlite3.c"
       $23 = ($21<<16>>16)>(0); //@line 146820 "c/sqlite3.c"
       L7: do {
        if ($23) {
         $24 = ((($14)) + 4|0); //@line 146821 "c/sqlite3.c"
         $25 = HEAP32[$24>>2]|0;
         $$08894 = 0;$83 = $22;
         while(1) {
          $26 = (($25) + ($$08894<<4)|0); //@line 146821 "c/sqlite3.c"
          $27 = HEAP32[$26>>2]|0; //@line 146822 "c/sqlite3.c"
          $28 = (_sqlite3StrICmp($27,$3)|0); //@line 146822 "c/sqlite3.c"
          $29 = ($28|0)==(0); //@line 146822 "c/sqlite3.c"
          if ($29) {
           $$088$lcssa = $$08894;$$191 = $26;$$lcssa = $83;
           break L7;
          }
          $30 = (($$08894) + 1)|0; //@line 146820 "c/sqlite3.c"
          $31 = HEAP16[$20>>1]|0; //@line 146820 "c/sqlite3.c"
          $32 = $31 << 16 >> 16; //@line 146820 "c/sqlite3.c"
          $33 = ($30|0)<($32|0); //@line 146820 "c/sqlite3.c"
          if ($33) {
           $$08894 = $30;$83 = $32;
          } else {
           break;
          }
         }
         $34 = $31 << 16 >> 16; //@line 146820 "c/sqlite3.c"
         $$088$lcssa = $30;$$191 = $26;$$lcssa = $34;
        } else {
         $$088$lcssa = 0;$$191 = 0;$$lcssa = $22;
        }
       } while(0);
       $35 = ($$088$lcssa|0)==($$lcssa|0); //@line 146826 "c/sqlite3.c"
       if ($35) {
        $36 = ((($14)) + 36|0); //@line 146827 "c/sqlite3.c"
        $37 = HEAP32[$36>>2]|0; //@line 146827 "c/sqlite3.c"
        $38 = $37 & 32; //@line 146827 "c/sqlite3.c"
        $39 = ($38|0)==(0); //@line 146827 "c/sqlite3.c"
        if (!($39)) {
         $$092 = 0;$$1 = 0;$$181 = 0;$$183 = 0;$$185 = 0;$$187 = 0;
         break L1;
        }
        $40 = (_sqlite3IsRowid($3)|0); //@line 146827 "c/sqlite3.c"
        $41 = ($40|0)==(0); //@line 146827 "c/sqlite3.c"
        if ($41) {
         $$092 = 0;$$1 = 0;$$181 = 0;$$183 = 0;$$185 = 0;$$187 = 0;
         break L1;
        }
        $42 = ((($14)) + 40|0); //@line 146828 "c/sqlite3.c"
        $43 = HEAP16[$42>>1]|0; //@line 146828 "c/sqlite3.c"
        $44 = $43 << 16 >> 16; //@line 146828 "c/sqlite3.c"
        $45 = ($43<<16>>16)>(-1); //@line 146829 "c/sqlite3.c"
        if (!($45)) {
         $$0 = 0;$$080 = 1;$$082 = 0;$$084 = 0;$$086 = 22885;
         break;
        }
        $46 = ((($14)) + 4|0); //@line 146829 "c/sqlite3.c"
        $47 = HEAP32[$46>>2]|0; //@line 146829 "c/sqlite3.c"
        $48 = (($47) + ($44<<4)|0); //@line 146829 "c/sqlite3.c"
        $$189 = $44;$$2 = $48;
       } else {
        $$189 = $$088$lcssa;$$2 = $$191;
       }
       $49 = ($$2|0)==(0|0); //@line 146847 "c/sqlite3.c"
       if ($49) {
        $$0 = 0;$$080 = 1;$$082 = 0;$$084 = 0;$$086 = 22885;
       } else {
        $50 = (_sqlite3ColumnType($$2,0)|0); //@line 146848 "c/sqlite3.c"
        $51 = ((($$2)) + 8|0); //@line 146849 "c/sqlite3.c"
        $52 = HEAP32[$51>>2]|0; //@line 146849 "c/sqlite3.c"
        $53 = ((($$2)) + 12|0); //@line 146850 "c/sqlite3.c"
        $54 = HEAP8[$53>>0]|0; //@line 146850 "c/sqlite3.c"
        $55 = ($54<<24>>24)!=(0); //@line 146850 "c/sqlite3.c"
        $56 = $55&1; //@line 146850 "c/sqlite3.c"
        $57 = ((($$2)) + 15|0); //@line 146851 "c/sqlite3.c"
        $58 = HEAP8[$57>>0]|0; //@line 146851 "c/sqlite3.c"
        $59 = $58 & 1; //@line 146851 "c/sqlite3.c"
        $60 = $59&255; //@line 146851 "c/sqlite3.c"
        $61 = ((($14)) + 40|0); //@line 146852 "c/sqlite3.c"
        $62 = HEAP16[$61>>1]|0; //@line 146852 "c/sqlite3.c"
        $63 = $62 << 16 >> 16; //@line 146852 "c/sqlite3.c"
        $64 = ($$189|0)==($63|0); //@line 146852 "c/sqlite3.c"
        if ($64) {
         $65 = ((($14)) + 36|0); //@line 146852 "c/sqlite3.c"
         $66 = HEAP32[$65>>2]|0; //@line 146852 "c/sqlite3.c"
         $67 = $66 >>> 3;
         $$lobit = $67 & 1;
         $$0 = $$lobit;$$080 = $60;$$082 = $56;$$084 = $52;$$086 = $50;
        } else {
         $$0 = 0;$$080 = $60;$$082 = $56;$$084 = $52;$$086 = $50;
        }
       }
      }
     } while(0);
     $68 = ($$084|0)==(0|0); //@line 146857 "c/sqlite3.c"
     $spec$select = $68 ? 18038 : $$084; //@line 146857 "c/sqlite3.c"
     $$092 = $14;$$1 = $$0;$$181 = $$080;$$183 = $$082;$$185 = $spec$select;$$187 = $$086;
    } else {
     $$092 = 0;$$1 = 0;$$181 = 0;$$183 = 0;$$185 = 0;$$187 = 0;
    }
   }
  }
 } while(0);
 _sqlite3BtreeLeaveAll($0); //@line 146862 "c/sqlite3.c"
 $69 = ($4|0)==(0|0); //@line 146868 "c/sqlite3.c"
 if (!($69)) {
  HEAP32[$4>>2] = $$187; //@line 146868 "c/sqlite3.c"
 }
 $70 = ($5|0)==(0|0); //@line 146869 "c/sqlite3.c"
 if (!($70)) {
  HEAP32[$5>>2] = $$185; //@line 146869 "c/sqlite3.c"
 }
 $71 = ($6|0)==(0|0); //@line 146870 "c/sqlite3.c"
 if (!($71)) {
  HEAP32[$6>>2] = $$183; //@line 146870 "c/sqlite3.c"
 }
 $72 = ($7|0)==(0|0); //@line 146871 "c/sqlite3.c"
 if (!($72)) {
  HEAP32[$7>>2] = $$181; //@line 146871 "c/sqlite3.c"
 }
 $73 = ($8|0)==(0|0); //@line 146872 "c/sqlite3.c"
 if (!($73)) {
  HEAP32[$8>>2] = $$1; //@line 146872 "c/sqlite3.c"
 }
 $74 = ($$092|0)!=(0|0); //@line 146874 "c/sqlite3.c"
 $or$cond = $13 | $74; //@line 146874 "c/sqlite3.c"
 if ($or$cond) {
  $$093 = $12;
  $77 = HEAP32[$9>>2]|0; //@line 146880 "c/sqlite3.c"
  $78 = ($77|0)==(0|0); //@line 146880 "c/sqlite3.c"
  $79 = $78 ? 0 : 15687; //@line 146880 "c/sqlite3.c"
  HEAP32[$vararg_buffer2>>2] = $77; //@line 146880 "c/sqlite3.c"
  _sqlite3ErrorWithMsg($0,$$093,$79,$vararg_buffer2); //@line 146880 "c/sqlite3.c"
  $80 = HEAP32[$9>>2]|0; //@line 146881 "c/sqlite3.c"
  _sqlite3DbFree($0,$80); //@line 146881 "c/sqlite3.c"
  $81 = (_sqlite3ApiExit($0,$$093)|0); //@line 146882 "c/sqlite3.c"
  $82 = HEAP32[$10>>2]|0; //@line 146883 "c/sqlite3.c"
  _sqlite3_mutex_leave($82); //@line 146883 "c/sqlite3.c"
  STACKTOP = sp;return ($81|0); //@line 146884 "c/sqlite3.c"
 }
 $75 = HEAP32[$9>>2]|0; //@line 146875 "c/sqlite3.c"
 _sqlite3DbFree($0,$75); //@line 146875 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 146876 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 146876 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $3; //@line 146876 "c/sqlite3.c"
 $76 = (_sqlite3MPrintf($0,36041,$vararg_buffer)|0); //@line 146876 "c/sqlite3.c"
 HEAP32[$9>>2] = $76; //@line 146876 "c/sqlite3.c"
 $$093 = 1;
 $77 = HEAP32[$9>>2]|0; //@line 146880 "c/sqlite3.c"
 $78 = ($77|0)==(0|0); //@line 146880 "c/sqlite3.c"
 $79 = $78 ? 0 : 15687; //@line 146880 "c/sqlite3.c"
 HEAP32[$vararg_buffer2>>2] = $77; //@line 146880 "c/sqlite3.c"
 _sqlite3ErrorWithMsg($0,$$093,$79,$vararg_buffer2); //@line 146880 "c/sqlite3.c"
 $80 = HEAP32[$9>>2]|0; //@line 146881 "c/sqlite3.c"
 _sqlite3DbFree($0,$80); //@line 146881 "c/sqlite3.c"
 $81 = (_sqlite3ApiExit($0,$$093)|0); //@line 146882 "c/sqlite3.c"
 $82 = HEAP32[$10>>2]|0; //@line 146883 "c/sqlite3.c"
 _sqlite3_mutex_leave($82); //@line 146883 "c/sqlite3.c"
 STACKTOP = sp;return ($81|0); //@line 146884 "c/sqlite3.c"
}
function _sqlite3_thread_cleanup() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 146765 "c/sqlite3.c"
}
function _sqlite3_trace($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145216 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145216 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145216 "c/sqlite3.c"
 $5 = ((($0)) + 192|0); //@line 145217 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145217 "c/sqlite3.c"
 $7 = ($1|0)==(0|0); //@line 145218 "c/sqlite3.c"
 $8 = $7 ? 0 : -128; //@line 145218 "c/sqlite3.c"
 $9 = ((($0)) + 80|0); //@line 145218 "c/sqlite3.c"
 HEAP8[$9>>0] = $8; //@line 145218 "c/sqlite3.c"
 $10 = ((($0)) + 188|0); //@line 145219 "c/sqlite3.c"
 HEAP32[$10>>2] = $1; //@line 145219 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 145220 "c/sqlite3.c"
 $11 = HEAP32[$3>>2]|0; //@line 145221 "c/sqlite3.c"
 _sqlite3_mutex_leave($11); //@line 145221 "c/sqlite3.c"
 return ($6|0); //@line 145222 "c/sqlite3.c"
}
function _sqlite3_transfer_bindings($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 16|0); //@line 79312 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 79312 "c/sqlite3.c"
 $4 = ((($1)) + 16|0); //@line 79312 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 79312 "c/sqlite3.c"
 $6 = ($3<<16>>16)==($5<<16>>16); //@line 79312 "c/sqlite3.c"
 if (!($6)) {
  $$0 = 1;
  return ($$0|0); //@line 79324 "c/sqlite3.c"
 }
 $7 = ((($1)) + 204|0); //@line 79316 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 79316 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 79316 "c/sqlite3.c"
 if (!($9)) {
  $10 = ((($1)) + 145|0); //@line 79317 "c/sqlite3.c"
  $11 = HEAPU8[$10>>0]|(HEAPU8[$10+1>>0]<<8); //@line 79317 "c/sqlite3.c"
  $12 = $11 | 1; //@line 79317 "c/sqlite3.c"
  HEAP8[$10>>0]=$12&255;HEAP8[$10+1>>0]=$12>>8; //@line 79317 "c/sqlite3.c"
 }
 $13 = ((($0)) + 204|0); //@line 79320 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 79320 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 79320 "c/sqlite3.c"
 if (!($15)) {
  $16 = ((($0)) + 145|0); //@line 79321 "c/sqlite3.c"
  $17 = HEAPU8[$16>>0]|(HEAPU8[$16+1>>0]<<8); //@line 79321 "c/sqlite3.c"
  $18 = $17 | 1; //@line 79321 "c/sqlite3.c"
  HEAP8[$16>>0]=$18&255;HEAP8[$16+1>>0]=$18>>8; //@line 79321 "c/sqlite3.c"
 }
 _sqlite3TransferBindings($0,$1); //@line 79323 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 79324 "c/sqlite3.c"
}
function _sqlite3_update_hook($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145324 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145324 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145324 "c/sqlite3.c"
 $5 = ((($0)) + 220|0); //@line 145325 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145325 "c/sqlite3.c"
 $7 = ((($0)) + 224|0); //@line 145326 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 145326 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 145327 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 145328 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 145328 "c/sqlite3.c"
 return ($6|0); //@line 145329 "c/sqlite3.c"
}
function _sqlite3_value_bytes16($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueBytes($0,2)|0); //@line 77892 "c/sqlite3.c"
 return ($1|0); //@line 77892 "c/sqlite3.c"
}
function _sqlite3_value_text16($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueText($0,2)|0); //@line 77925 "c/sqlite3.c"
 return ($1|0); //@line 77925 "c/sqlite3.c"
}
function _sqlite3_value_text16be($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueText($0,3)|0); //@line 77928 "c/sqlite3.c"
 return ($1|0); //@line 77928 "c/sqlite3.c"
}
function _sqlite3_value_text16le($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueText($0,2)|0); //@line 77931 "c/sqlite3.c"
 return ($1|0); //@line 77931 "c/sqlite3.c"
}
function _sqlite3_overload_function($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145187 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145187 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145187 "c/sqlite3.c"
 $5 = (_sqlite3FindFunction($0,$1,$2,1,0)|0); //@line 145188 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 145188 "c/sqlite3.c"
 if ($6) {
  $7 = (_sqlite3CreateFunc($0,$1,$2,1,0,162,0,0,0)|0); //@line 145189 "c/sqlite3.c"
  $$0 = $7;
 } else {
  $$0 = 0;
 }
 $8 = (_sqlite3ApiExit($0,$$0)|0); //@line 145192 "c/sqlite3.c"
 $9 = HEAP32[$3>>2]|0; //@line 145193 "c/sqlite3.c"
 _sqlite3_mutex_leave($9); //@line 145193 "c/sqlite3.c"
 return ($8|0); //@line 145194 "c/sqlite3.c"
}
function _sqlite3_prepare_v2($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3LockAndPrepare($0,$1,$2,128,0,$3,$4)|0); //@line 118552 "c/sqlite3.c"
 return ($5|0); //@line 118555 "c/sqlite3.c"
}
function _sqlite3_prepare16_v2($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3Prepare16($0,$1,$2,128,$3,$4)|0); //@line 118663 "c/sqlite3.c"
 return ($5|0); //@line 118665 "c/sqlite3.c"
}
function _sqlite3_clear_bindings($0) {
 $0 = $0|0;
 var $$019 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 77855 "c/sqlite3.c"
 $2 = ((($1)) + 12|0); //@line 77855 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 77855 "c/sqlite3.c"
 _sqlite3_mutex_enter($3); //@line 77857 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 77858 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 77858 "c/sqlite3.c"
 $6 = ($5<<16>>16)>(0); //@line 77858 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 116|0);
  $$019 = 0;
  while(1) {
   $8 = HEAP32[$7>>2]|0; //@line 77859 "c/sqlite3.c"
   $9 = (($8) + (($$019*40)|0)|0); //@line 77859 "c/sqlite3.c"
   _sqlite3VdbeMemRelease($9); //@line 77859 "c/sqlite3.c"
   $10 = HEAP32[$7>>2]|0; //@line 77860 "c/sqlite3.c"
   $11 = (((($10) + (($$019*40)|0)|0)) + 8|0); //@line 77860 "c/sqlite3.c"
   HEAP16[$11>>1] = 1; //@line 77860 "c/sqlite3.c"
   $12 = (($$019) + 1)|0; //@line 77858 "c/sqlite3.c"
   $13 = HEAP16[$4>>1]|0; //@line 77858 "c/sqlite3.c"
   $14 = $13 << 16 >> 16; //@line 77858 "c/sqlite3.c"
   $15 = ($12|0)<($14|0); //@line 77858 "c/sqlite3.c"
   if ($15) {
    $$019 = $12;
   } else {
    break;
   }
  }
 }
 $16 = ((($0)) + 204|0); //@line 77863 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 77863 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 77863 "c/sqlite3.c"
 if ($18) {
  _sqlite3_mutex_leave($3); //@line 77866 "c/sqlite3.c"
  return 0; //@line 77867 "c/sqlite3.c"
 }
 $19 = ((($0)) + 145|0); //@line 77864 "c/sqlite3.c"
 $20 = HEAPU8[$19>>0]|(HEAPU8[$19+1>>0]<<8); //@line 77864 "c/sqlite3.c"
 $21 = $20 | 1; //@line 77864 "c/sqlite3.c"
 HEAP8[$19>>0]=$21&255;HEAP8[$19+1>>0]=$21>>8; //@line 77864 "c/sqlite3.c"
 _sqlite3_mutex_leave($3); //@line 77866 "c/sqlite3.c"
 return 0; //@line 77867 "c/sqlite3.c"
}
function _sqlite3_create_module_v2($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_createModule($0,$1,$2,$3,$4)|0); //@line 127482 "c/sqlite3.c"
 return ($5|0); //@line 127482 "c/sqlite3.c"
}
function _sqlite3_bind_zeroblob($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_vdbeUnbind($0,$1)|0); //@line 79223 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 79224 "c/sqlite3.c"
 if (!($4)) {
  return ($3|0); //@line 79228 "c/sqlite3.c"
 }
 $5 = ((($0)) + 116|0); //@line 79225 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 79225 "c/sqlite3.c"
 $7 = (($1) + -1)|0; //@line 79225 "c/sqlite3.c"
 $8 = (($6) + (($7*40)|0)|0); //@line 79225 "c/sqlite3.c"
 _sqlite3VdbeMemSetZeroBlob($8,$2); //@line 79225 "c/sqlite3.c"
 $9 = HEAP32[$0>>2]|0; //@line 79226 "c/sqlite3.c"
 $10 = ((($9)) + 12|0); //@line 79226 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 79226 "c/sqlite3.c"
 _sqlite3_mutex_leave($11); //@line 79226 "c/sqlite3.c"
 return ($3|0); //@line 79228 "c/sqlite3.c"
}
function _sqlite3_blob_bytes($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 87755 "c/sqlite3.c"
 if ($1) {
  $6 = 0;
 } else {
  $2 = ((($0)) + 16|0); //@line 87755 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 87755 "c/sqlite3.c"
  $4 = ($3|0)==(0|0); //@line 87755 "c/sqlite3.c"
  if ($4) {
   $6 = 0;
  } else {
   $5 = HEAP32[$0>>2]|0; //@line 87755 "c/sqlite3.c"
   $6 = $5;
  }
 }
 return ($6|0); //@line 87755 "c/sqlite3.c"
}
function _sqlite3_blob_close($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 87648 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
  return ($$0|0); //@line 87657 "c/sqlite3.c"
 }
 $2 = ((($0)) + 20|0); //@line 87649 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 87649 "c/sqlite3.c"
 $4 = ((($3)) + 12|0); //@line 87650 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 87650 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 87650 "c/sqlite3.c"
 $6 = ((($0)) + 16|0); //@line 87651 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 87651 "c/sqlite3.c"
 $8 = (_sqlite3_finalize($7)|0); //@line 87651 "c/sqlite3.c"
 _sqlite3DbFree($3,$0); //@line 87652 "c/sqlite3.c"
 $9 = HEAP32[$4>>2]|0; //@line 87653 "c/sqlite3.c"
 _sqlite3_mutex_leave($9); //@line 87653 "c/sqlite3.c"
 $$0 = $8;
 return ($$0|0); //@line 87657 "c/sqlite3.c"
}
function _sqlite3_blob_open($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0155 = 0, $$0157215 = 0, $$0158202 = 0, $$0159 = 0, $$0159207 = 0, $$0159209 = 0, $$0160 = 0, $$0160220 = 0, $$0160222 = 0, $$0161208 = 0, $$0165 = 0, $$0169$lcssa = 0, $$0169193 = 0, $$1$lcssa = 0, $$1201 = 0, $$3 = 0, $$3168 = 0, $$3168180 = 0, $$3168181 = 0, $$3168181182 = 0;
 var $$3168181183 = 0, $$4$lcssa = 0, $$4221 = 0, $$5$lcssa = 0, $$5214 = 0, $$6 = 0, $$lcssa = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0;
 var $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0;
 var $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0;
 var $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer10 = 0;
 var $vararg_buffer13 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 528|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(528|0);
 $vararg_buffer13 = sp + 40|0;
 $vararg_buffer10 = sp + 32|0;
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $8 = sp + 520|0;
 $9 = sp + 48|0;
 HEAP32[$8>>2] = 0; //@line 87422 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 87432 "c/sqlite3.c"
 $10 = ($6|0)!=(0); //@line 87438 "c/sqlite3.c"
 $11 = $10&1; //@line 87438 "c/sqlite3.c"
 $12 = ((($0)) + 12|0); //@line 87440 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 87440 "c/sqlite3.c"
 _sqlite3_mutex_enter($13); //@line 87440 "c/sqlite3.c"
 $14 = (_sqlite3DbMallocZero($0,32,0)|0); //@line 87442 "c/sqlite3.c"
 $15 = ($14|0)!=(0|0);
 $16 = ((($14)) + 28|0);
 $17 = ((($0)) + 16|0);
 $18 = ((($14)) + 24|0);
 $19 = ((($0)) + 28|0);
 $20 = ((($14)) + 16|0);
 $21 = ((($14)) + 8|0);
 $22 = ((($14)) + 20|0);
 $23 = ((($0)) + 73|0);
 $24 = ((($0)) + 73|0);
 $25 = ((($9)) + 396|0);
 $26 = ((($9)) + 44|0);
 $27 = ((($9)) + 40|0);
 $$0155 = 0;$$0165 = 0;
 while(1) {
  _memset(($9|0),0,472)|0; //@line 87444 "c/sqlite3.c"
  if (!($15)) {
   label = 45;
   break;
  }
  HEAP32[$9>>2] = $0; //@line 87446 "c/sqlite3.c"
  $28 = HEAP32[$8>>2]|0; //@line 87447 "c/sqlite3.c"
  _sqlite3DbFree($0,$28); //@line 87447 "c/sqlite3.c"
  HEAP32[$8>>2] = 0; //@line 87448 "c/sqlite3.c"
  _sqlite3BtreeEnterAll($0); //@line 87450 "c/sqlite3.c"
  $29 = (_sqlite3LocateTable($9,0,$2,$1)|0); //@line 87451 "c/sqlite3.c"
  $30 = ($29|0)==(0|0); //@line 87452 "c/sqlite3.c"
  if ($30) {
   label = 10;
   break;
  }
  $31 = ((($29)) + 56|0); //@line 87452 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 87452 "c/sqlite3.c"
  $33 = ($32|0)==(0); //@line 87452 "c/sqlite3.c"
  if (!($33)) {
   label = 5;
   break;
  }
  $34 = ((($29)) + 36|0); //@line 87456 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 87456 "c/sqlite3.c"
  $36 = $35 & 32; //@line 87456 "c/sqlite3.c"
  $37 = ($36|0)==(0); //@line 87456 "c/sqlite3.c"
  if (!($37)) {
   label = 7;
   break;
  }
  $38 = ((($29)) + 12|0); //@line 87461 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 87461 "c/sqlite3.c"
  $40 = ($39|0)==(0|0); //@line 87461 "c/sqlite3.c"
  if (!($40)) {
   label = 9;
   break;
  }
  HEAP32[$16>>2] = $29; //@line 87476 "c/sqlite3.c"
  $45 = HEAP32[$17>>2]|0; //@line 87477 "c/sqlite3.c"
  $46 = ((($29)) + 72|0); //@line 87477 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 87477 "c/sqlite3.c"
  $48 = (_sqlite3SchemaToIndex($0,$47)|0); //@line 87477 "c/sqlite3.c"
  $49 = (($45) + ($48<<4)|0); //@line 87477 "c/sqlite3.c"
  $50 = HEAP32[$49>>2]|0; //@line 87477 "c/sqlite3.c"
  HEAP32[$18>>2] = $50; //@line 87477 "c/sqlite3.c"
  $51 = ((($29)) + 42|0); //@line 87480 "c/sqlite3.c"
  $52 = HEAP16[$51>>1]|0; //@line 87480 "c/sqlite3.c"
  $53 = $52 << 16 >> 16; //@line 87480 "c/sqlite3.c"
  $54 = ($52<<16>>16)>(0); //@line 87480 "c/sqlite3.c"
  L8: do {
   if ($54) {
    $55 = ((($29)) + 4|0); //@line 87481 "c/sqlite3.c"
    $56 = HEAP32[$55>>2]|0;
    $$0169193 = 0;$154 = $53;
    while(1) {
     $57 = (($56) + ($$0169193<<4)|0); //@line 87481 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 87481 "c/sqlite3.c"
     $59 = (_sqlite3StrICmp($58,$3)|0); //@line 87481 "c/sqlite3.c"
     $60 = ($59|0)==(0); //@line 87481 "c/sqlite3.c"
     if ($60) {
      $$0169$lcssa = $$0169193;$$lcssa = $154;
      break L8;
     }
     $61 = (($$0169193) + 1)|0; //@line 87480 "c/sqlite3.c"
     $62 = HEAP16[$51>>1]|0; //@line 87480 "c/sqlite3.c"
     $63 = $62 << 16 >> 16; //@line 87480 "c/sqlite3.c"
     $64 = ($61|0)<($63|0); //@line 87480 "c/sqlite3.c"
     if ($64) {
      $$0169193 = $61;$154 = $63;
     } else {
      break;
     }
    }
    $65 = $62 << 16 >> 16; //@line 87480 "c/sqlite3.c"
    $$0169$lcssa = $61;$$lcssa = $65;
   } else {
    $$0169$lcssa = 0;$$lcssa = $53;
   }
  } while(0);
  $66 = ($$0169$lcssa|0)==($$lcssa|0); //@line 87485 "c/sqlite3.c"
  if ($66) {
   label = 19;
   break;
  }
  if ($10) {
   $68 = HEAP32[$19>>2]|0; //@line 87500 "c/sqlite3.c"
   $69 = $68 & 16384; //@line 87500 "c/sqlite3.c"
   $70 = ($69|0)==(0); //@line 87500 "c/sqlite3.c"
   if ($70) {
    $$3 = 0;
   } else {
    $71 = ((($29)) + 16|0); //@line 87506 "c/sqlite3.c"
    $$0159207 = HEAP32[$71>>2]|0;
    $72 = ($$0159207|0)==(0|0); //@line 87506 "c/sqlite3.c"
    if ($72) {
     $$3 = 0;
    } else {
     $$0159209 = $$0159207;$$0161208 = 0;
     while(1) {
      $73 = ((($$0159209)) + 20|0); //@line 87508 "c/sqlite3.c"
      $74 = HEAP32[$73>>2]|0; //@line 87508 "c/sqlite3.c"
      $75 = ($74|0)>(0); //@line 87508 "c/sqlite3.c"
      if ($75) {
       $76 = HEAP32[$73>>2]|0;
       $$0158202 = 0;$$1201 = $$0161208;
       while(1) {
        $77 = (((($$0159209)) + 36|0) + ($$0158202<<3)|0); //@line 87509 "c/sqlite3.c"
        $78 = HEAP32[$77>>2]|0; //@line 87509 "c/sqlite3.c"
        $79 = ($78|0)==($$0169$lcssa|0); //@line 87509 "c/sqlite3.c"
        $spec$select = $79 ? 35912 : $$1201; //@line 87509 "c/sqlite3.c"
        $80 = (($$0158202) + 1)|0; //@line 87508 "c/sqlite3.c"
        $81 = ($80|0)<($76|0); //@line 87508 "c/sqlite3.c"
        if ($81) {
         $$0158202 = $80;$$1201 = $spec$select;
        } else {
         $$1$lcssa = $spec$select;
         break;
        }
       }
      } else {
       $$1$lcssa = $$0161208;
      }
      $82 = ((($$0159209)) + 4|0); //@line 87506 "c/sqlite3.c"
      $$0159 = HEAP32[$82>>2]|0;
      $83 = ($$0159|0)==(0|0); //@line 87506 "c/sqlite3.c"
      if ($83) {
       $$3 = $$1$lcssa;
       break;
      } else {
       $$0159209 = $$0159;$$0161208 = $$1$lcssa;
      }
     }
    }
   }
   $84 = ((($29)) + 8|0); //@line 87516 "c/sqlite3.c"
   $$0160220 = HEAP32[$84>>2]|0;
   $85 = ($$0160220|0)==(0|0); //@line 87516 "c/sqlite3.c"
   if ($85) {
    $$4$lcssa = $$3;
   } else {
    $$0160222 = $$0160220;$$4221 = $$3;
    while(1) {
     $86 = ((($$0160222)) + 50|0); //@line 87518 "c/sqlite3.c"
     $87 = HEAP16[$86>>1]|0; //@line 87518 "c/sqlite3.c"
     $88 = ($87<<16>>16)==(0); //@line 87518 "c/sqlite3.c"
     if ($88) {
      $$5$lcssa = $$4221;
     } else {
      $89 = ((($$0160222)) + 4|0);
      $90 = HEAP32[$89>>2]|0;
      $91 = HEAP16[$86>>1]|0;
      $92 = $91&65535;
      $$0157215 = 0;$$5214 = $$4221;
      while(1) {
       $93 = (($90) + ($$0157215<<1)|0); //@line 87520 "c/sqlite3.c"
       $94 = HEAP16[$93>>1]|0; //@line 87520 "c/sqlite3.c"
       $95 = $94 << 16 >> 16; //@line 87520 "c/sqlite3.c"
       $96 = ($$0169$lcssa|0)==($95|0); //@line 87520 "c/sqlite3.c"
       $97 = ($94<<16>>16)==(-2); //@line 87520 "c/sqlite3.c"
       $or$cond = $97 | $96; //@line 87520 "c/sqlite3.c"
       $$6 = $or$cond ? 35924 : $$5214; //@line 87520 "c/sqlite3.c"
       $98 = (($$0157215) + 1)|0; //@line 87518 "c/sqlite3.c"
       $99 = ($98>>>0)<($92>>>0); //@line 87518 "c/sqlite3.c"
       if ($99) {
        $$0157215 = $98;$$5214 = $$6;
       } else {
        $$5$lcssa = $$6;
        break;
       }
      }
     }
     $100 = ((($$0160222)) + 20|0); //@line 87516 "c/sqlite3.c"
     $$0160 = HEAP32[$100>>2]|0;
     $101 = ($$0160|0)==(0|0); //@line 87516 "c/sqlite3.c"
     if ($101) {
      $$4$lcssa = $$5$lcssa;
      break;
     } else {
      $$0160222 = $$0160;$$4221 = $$5$lcssa;
     }
    }
   }
   $102 = ($$4$lcssa|0)==(0|0); //@line 87525 "c/sqlite3.c"
   if (!($102)) {
    label = 35;
    break;
   }
  }
  $104 = (_sqlite3VdbeCreate($9)|0); //@line 87534 "c/sqlite3.c"
  HEAP32[$20>>2] = $104; //@line 87534 "c/sqlite3.c"
  $105 = ($104|0)==(0|0); //@line 87536 "c/sqlite3.c"
  if (!($105)) {
   $106 = HEAP32[$46>>2]|0; //@line 87564 "c/sqlite3.c"
   $107 = (_sqlite3SchemaToIndex($0,$106)|0); //@line 87564 "c/sqlite3.c"
   $108 = HEAP32[$106>>2]|0; //@line 87568 "c/sqlite3.c"
   $109 = ((($106)) + 4|0); //@line 87569 "c/sqlite3.c"
   $110 = HEAP32[$109>>2]|0; //@line 87569 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4Int($104,2,$107,$11,$108,$110)|0); //@line 87567 "c/sqlite3.c"
   _sqlite3VdbeChangeP5($104,1); //@line 87570 "c/sqlite3.c"
   $111 = (_sqlite3VdbeAddOpList($104,6,35966)|0); //@line 87572 "c/sqlite3.c"
   _sqlite3VdbeUsesBtree($104,$107); //@line 87575 "c/sqlite3.c"
   $112 = HEAP8[$24>>0]|0; //@line 87577 "c/sqlite3.c"
   $113 = ($112<<24>>24)==(0); //@line 87577 "c/sqlite3.c"
   if ($113) {
    $114 = ((($111)) + 4|0); //@line 87583 "c/sqlite3.c"
    HEAP32[$114>>2] = $107; //@line 87583 "c/sqlite3.c"
    $115 = ((($29)) + 28|0); //@line 87584 "c/sqlite3.c"
    $116 = HEAP32[$115>>2]|0; //@line 87584 "c/sqlite3.c"
    $117 = ((($111)) + 8|0); //@line 87584 "c/sqlite3.c"
    HEAP32[$117>>2] = $116; //@line 87584 "c/sqlite3.c"
    $118 = ((($111)) + 12|0); //@line 87585 "c/sqlite3.c"
    HEAP32[$118>>2] = $11; //@line 87585 "c/sqlite3.c"
    $119 = HEAP32[$29>>2]|0; //@line 87586 "c/sqlite3.c"
    _sqlite3VdbeChangeP4($104,2,$119,0); //@line 87586 "c/sqlite3.c"
    $$pr = HEAP8[$24>>0]|0; //@line 87588 "c/sqlite3.c"
    $120 = ($$pr<<24>>24)==(0); //@line 87588 "c/sqlite3.c"
    if ($120) {
     if ($10) {
      $121 = ((($111)) + 20|0); //@line 87593 "c/sqlite3.c"
      HEAP8[$121>>0] = 106; //@line 87593 "c/sqlite3.c"
     }
     $122 = ((($29)) + 28|0); //@line 87594 "c/sqlite3.c"
     $123 = HEAP32[$122>>2]|0; //@line 87594 "c/sqlite3.c"
     $124 = ((($111)) + 28|0); //@line 87594 "c/sqlite3.c"
     HEAP32[$124>>2] = $123; //@line 87594 "c/sqlite3.c"
     $125 = ((($111)) + 32|0); //@line 87595 "c/sqlite3.c"
     HEAP32[$125>>2] = $107; //@line 87595 "c/sqlite3.c"
     $126 = ((($111)) + 21|0); //@line 87604 "c/sqlite3.c"
     HEAP8[$126>>0] = -3; //@line 87604 "c/sqlite3.c"
     $127 = HEAP16[$51>>1]|0; //@line 87605 "c/sqlite3.c"
     $128 = $127 << 16 >> 16; //@line 87605 "c/sqlite3.c"
     $129 = (($128) + 1)|0; //@line 87605 "c/sqlite3.c"
     $130 = ((($111)) + 36|0); //@line 87605 "c/sqlite3.c"
     HEAP32[$130>>2] = $129; //@line 87605 "c/sqlite3.c"
     $131 = HEAP16[$51>>1]|0; //@line 87606 "c/sqlite3.c"
     $132 = $131 << 16 >> 16; //@line 87606 "c/sqlite3.c"
     $133 = ((($111)) + 68|0); //@line 87606 "c/sqlite3.c"
     HEAP32[$133>>2] = $132; //@line 87606 "c/sqlite3.c"
     HEAP16[$25>>1] = 0; //@line 87608 "c/sqlite3.c"
     HEAP32[$26>>2] = 1; //@line 87609 "c/sqlite3.c"
     HEAP32[$27>>2] = 1; //@line 87610 "c/sqlite3.c"
     _sqlite3VdbeMakeReady($104,$9); //@line 87611 "c/sqlite3.c"
    }
   }
  }
  $134 = $$0169$lcssa&65535; //@line 87615 "c/sqlite3.c"
  HEAP16[$21>>1] = $134; //@line 87615 "c/sqlite3.c"
  HEAP32[$22>>2] = $0; //@line 87616 "c/sqlite3.c"
  _sqlite3BtreeLeaveAll($0); //@line 87617 "c/sqlite3.c"
  $135 = HEAP8[$23>>0]|0; //@line 87618 "c/sqlite3.c"
  $136 = ($135<<24>>24)==(0); //@line 87618 "c/sqlite3.c"
  if (!($136)) {
   $$3168 = $$0165;
   label = 44;
   break;
  }
  $137 = (_blobSeekToRow($14,$4,$5,$8)|0); //@line 87621 "c/sqlite3.c"
  $138 = (($$0155) + 1)|0; //@line 87622 "c/sqlite3.c"
  $139 = ($138>>>0)<(50); //@line 87622 "c/sqlite3.c"
  $140 = ($137|0)==(17); //@line 87622 "c/sqlite3.c"
  $141 = $139 & $140; //@line 87622 "c/sqlite3.c"
  if ($141) {
   $$0155 = $138;$$0165 = 17;
  } else {
   $$3168 = $137;
   label = 44;
   break;
  }
 }
 if ((label|0) == 5) {
  HEAP32[$vararg_buffer>>2] = $2; //@line 87454 "c/sqlite3.c"
  _sqlite3ErrorMsg($9,35804,$vararg_buffer); //@line 87454 "c/sqlite3.c"
  label = 10;
 }
 else if ((label|0) == 7) {
  HEAP32[$vararg_buffer1>>2] = $2; //@line 87458 "c/sqlite3.c"
  _sqlite3ErrorMsg($9,35834,$vararg_buffer1); //@line 87458 "c/sqlite3.c"
  label = 10;
 }
 else if ((label|0) == 9) {
  HEAP32[$vararg_buffer4>>2] = $2; //@line 87463 "c/sqlite3.c"
  _sqlite3ErrorMsg($9,35870,$vararg_buffer4); //@line 87463 "c/sqlite3.c"
  label = 10;
 }
 else if ((label|0) == 19) {
  _sqlite3DbFree($0,0); //@line 87486 "c/sqlite3.c"
  HEAP32[$vararg_buffer7>>2] = $3; //@line 87487 "c/sqlite3.c"
  $67 = (_sqlite3MPrintf($0,35891,$vararg_buffer7)|0); //@line 87487 "c/sqlite3.c"
  HEAP32[$8>>2] = $67; //@line 87487 "c/sqlite3.c"
  _sqlite3BtreeLeaveAll($0); //@line 87489 "c/sqlite3.c"
  $$3168181 = 1;
  label = 47;
 }
 else if ((label|0) == 35) {
  _sqlite3DbFree($0,0); //@line 87526 "c/sqlite3.c"
  HEAP32[$vararg_buffer10>>2] = $$4$lcssa; //@line 87527 "c/sqlite3.c"
  $103 = (_sqlite3MPrintf($0,35932,$vararg_buffer10)|0); //@line 87527 "c/sqlite3.c"
  HEAP32[$8>>2] = $103; //@line 87527 "c/sqlite3.c"
  _sqlite3BtreeLeaveAll($0); //@line 87529 "c/sqlite3.c"
  $$3168181 = 1;
  label = 47;
 }
 else if ((label|0) == 44) {
  $142 = ($$3168|0)==(0); //@line 87625 "c/sqlite3.c"
  if ($142) {
   label = 45;
  } else {
   $$3168181 = $$3168;
   label = 47;
  }
 }
 if ((label|0) == 10) {
  $41 = ((($9)) + 4|0); //@line 87467 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 87467 "c/sqlite3.c"
  $43 = ($42|0)==(0|0); //@line 87467 "c/sqlite3.c"
  if (!($43)) {
   _sqlite3DbFree($0,0); //@line 87468 "c/sqlite3.c"
   $44 = HEAP32[$41>>2]|0; //@line 87469 "c/sqlite3.c"
   HEAP32[$8>>2] = $44; //@line 87469 "c/sqlite3.c"
   HEAP32[$41>>2] = 0; //@line 87470 "c/sqlite3.c"
  }
  _sqlite3BtreeLeaveAll($0); //@line 87473 "c/sqlite3.c"
  $$3168181183 = 1;
  label = 48;
 }
 else if ((label|0) == 45) {
  $143 = ((($0)) + 73|0); //@line 87625 "c/sqlite3.c"
  $144 = HEAP8[$143>>0]|0; //@line 87625 "c/sqlite3.c"
  $145 = ($144<<24>>24)==(0); //@line 87625 "c/sqlite3.c"
  if ($145) {
   HEAP32[$7>>2] = $14; //@line 87626 "c/sqlite3.c"
   $$3168180 = 0;
   $149 = HEAP32[$8>>2]|0; //@line 87631 "c/sqlite3.c"
   $150 = ($149|0)==(0|0); //@line 87631 "c/sqlite3.c"
   $151 = $150 ? 0 : 15687; //@line 87631 "c/sqlite3.c"
   HEAP32[$vararg_buffer13>>2] = $149; //@line 87631 "c/sqlite3.c"
   _sqlite3ErrorWithMsg($0,$$3168180,$151,$vararg_buffer13); //@line 87631 "c/sqlite3.c"
   _sqlite3DbFree($0,$149); //@line 87632 "c/sqlite3.c"
   _sqlite3ParserReset($9); //@line 87633 "c/sqlite3.c"
   $152 = (_sqlite3ApiExit($0,$$3168180)|0); //@line 87634 "c/sqlite3.c"
   $153 = HEAP32[$12>>2]|0; //@line 87635 "c/sqlite3.c"
   _sqlite3_mutex_leave($153); //@line 87635 "c/sqlite3.c"
   STACKTOP = sp;return ($152|0); //@line 87637 "c/sqlite3.c"
  } else {
   $$3168181 = 0;
   label = 47;
  }
 }
 if ((label|0) == 47) {
  if ($15) {
   $$3168181183 = $$3168181;
   label = 48;
  } else {
   $$3168181182 = $$3168181;
  }
 }
 if ((label|0) == 48) {
  $146 = ((($14)) + 16|0); //@line 87628 "c/sqlite3.c"
  $147 = HEAP32[$146>>2]|0; //@line 87628 "c/sqlite3.c"
  $148 = ($147|0)==(0|0); //@line 87628 "c/sqlite3.c"
  if ($148) {
   $$3168181182 = $$3168181183;
  } else {
   (_sqlite3VdbeFinalize($147)|0); //@line 87628 "c/sqlite3.c"
   $$3168181182 = $$3168181183;
  }
 }
 _sqlite3DbFree($0,$14); //@line 87629 "c/sqlite3.c"
 $$3168180 = $$3168181182;
 $149 = HEAP32[$8>>2]|0; //@line 87631 "c/sqlite3.c"
 $150 = ($149|0)==(0|0); //@line 87631 "c/sqlite3.c"
 $151 = $150 ? 0 : 15687; //@line 87631 "c/sqlite3.c"
 HEAP32[$vararg_buffer13>>2] = $149; //@line 87631 "c/sqlite3.c"
 _sqlite3ErrorWithMsg($0,$$3168180,$151,$vararg_buffer13); //@line 87631 "c/sqlite3.c"
 _sqlite3DbFree($0,$149); //@line 87632 "c/sqlite3.c"
 _sqlite3ParserReset($9); //@line 87633 "c/sqlite3.c"
 $152 = (_sqlite3ApiExit($0,$$3168180)|0); //@line 87634 "c/sqlite3.c"
 $153 = HEAP32[$12>>2]|0; //@line 87635 "c/sqlite3.c"
 _sqlite3_mutex_leave($153); //@line 87635 "c/sqlite3.c"
 STACKTOP = sp;return ($152|0); //@line 87637 "c/sqlite3.c"
}
function _sqlite3_blob_read($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_blobReadWrite($0,$1,$2,$3,85)|0); //@line 87737 "c/sqlite3.c"
 return ($4|0); //@line 87737 "c/sqlite3.c"
}
function _sqlite3_blob_write($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_blobReadWrite($0,$1,$2,$3,86)|0); //@line 87744 "c/sqlite3.c"
 return ($4|0); //@line 87744 "c/sqlite3.c"
}
function _sqlite3_create_collation_v2($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $10 = 0, $11 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ((($0)) + 12|0); //@line 146605 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 146605 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 146605 "c/sqlite3.c"
 $8 = $2&255; //@line 146607 "c/sqlite3.c"
 $9 = (_createCollation($0,$1,$8,$3,$4,$5)|0); //@line 146607 "c/sqlite3.c"
 $10 = (_sqlite3ApiExit($0,$9)|0); //@line 146608 "c/sqlite3.c"
 $11 = HEAP32[$6>>2]|0; //@line 146609 "c/sqlite3.c"
 _sqlite3_mutex_leave($11); //@line 146609 "c/sqlite3.c"
 return ($10|0); //@line 146610 "c/sqlite3.c"
}
function _sqlite3_file_control($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 12|0); //@line 146926 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 146926 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 146926 "c/sqlite3.c"
 $6 = (_sqlite3DbNameToBtree($0,$1)|0); //@line 146927 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 146928 "c/sqlite3.c"
 if ($7) {
  $$1 = 1;
  $15 = HEAP32[$4>>2]|0; //@line 146952 "c/sqlite3.c"
  _sqlite3_mutex_leave($15); //@line 146952 "c/sqlite3.c"
  return ($$1|0); //@line 146953 "c/sqlite3.c"
 }
 _sqlite3BtreeEnter($6); //@line 146931 "c/sqlite3.c"
 $8 = (_sqlite3BtreePager($6)|0); //@line 146932 "c/sqlite3.c"
 $9 = (_sqlite3PagerFile($8)|0); //@line 146934 "c/sqlite3.c"
 switch ($2|0) {
 case 7:  {
  HEAP32[$3>>2] = $9; //@line 146937 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 27:  {
  $10 = (_sqlite3PagerVfs($8)|0); //@line 146940 "c/sqlite3.c"
  HEAP32[$3>>2] = $10; //@line 146940 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 case 28:  {
  $11 = (_sqlite3PagerJrnlFile($8)|0); //@line 146943 "c/sqlite3.c"
  HEAP32[$3>>2] = $11; //@line 146943 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 default: {
  $12 = HEAP32[$9>>2]|0; //@line 146945 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 146945 "c/sqlite3.c"
  if ($13) {
   $$0 = 12;
  } else {
   $14 = (_sqlite3OsFileControl($9,$2,$3)|0); //@line 146946 "c/sqlite3.c"
   $$0 = $14;
  }
 }
 }
 _sqlite3BtreeLeave($6); //@line 146950 "c/sqlite3.c"
 $$1 = $$0;
 $15 = HEAP32[$4>>2]|0; //@line 146952 "c/sqlite3.c"
 _sqlite3_mutex_leave($15); //@line 146952 "c/sqlite3.c"
 return ($$1|0); //@line 146953 "c/sqlite3.c"
}
function _sqlite3_memory_highwater($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp + 8|0;
 $2 = sp;
 (_sqlite3_status64(0,$1,$2,$0)|0); //@line 25302 "c/sqlite3.c"
 $3 = $2; //@line 25303 "c/sqlite3.c"
 $4 = $3; //@line 25303 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 25303 "c/sqlite3.c"
 $6 = (($3) + 4)|0; //@line 25303 "c/sqlite3.c"
 $7 = $6; //@line 25303 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 25303 "c/sqlite3.c"
 tempRet0 = ($8); //@line 25303 "c/sqlite3.c"
 STACKTOP = sp;return ($5|0); //@line 25303 "c/sqlite3.c"
}
function _sqlite3_memory_used() {
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $0 = sp + 8|0;
 $1 = sp;
 (_sqlite3_status64(0,$0,$1,0)|0); //@line 25291 "c/sqlite3.c"
 $2 = $0; //@line 25292 "c/sqlite3.c"
 $3 = $2; //@line 25292 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 25292 "c/sqlite3.c"
 $5 = (($2) + 4)|0; //@line 25292 "c/sqlite3.c"
 $6 = $5; //@line 25292 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 25292 "c/sqlite3.c"
 tempRet0 = ($7); //@line 25292 "c/sqlite3.c"
 STACKTOP = sp;return ($4|0); //@line 25292 "c/sqlite3.c"
}
function _sqlite3_mutex_try($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 23801 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
 } else {
  $2 = HEAP32[(104)>>2]|0; //@line 23803 "c/sqlite3.c"
  $3 = (FUNCTION_TABLE_ii[$2 & 255]($0)|0); //@line 23803 "c/sqlite3.c"
  $$0 = $3;
 }
 return ($$0|0); //@line 23806 "c/sqlite3.c"
}
function _sqlite3_open_v2($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_openDatabase($0,$1,$2,$3)|0); //@line 146533 "c/sqlite3.c"
 return ($4|0); //@line 146533 "c/sqlite3.c"
}
function _sqlite3_release_memory($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 25171 "c/sqlite3.c"
}
function _sqlite3_sleep($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_vfs_find(0)|0); //@line 146893 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 146894 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 146901 "c/sqlite3.c"
 }
 $3 = ($0*1000)|0; //@line 146899 "c/sqlite3.c"
 $4 = (_sqlite3OsSleep($1,$3)|0); //@line 146899 "c/sqlite3.c"
 $5 = (($4|0) / 1000)&-1; //@line 146899 "c/sqlite3.c"
 $$0 = $5;
 return ($$0|0); //@line 146901 "c/sqlite3.c"
}
function _sqlite3_soft_heap_limit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)>(0); //@line 25243 "c/sqlite3.c"
 $spec$store$select = $1 ? $0 : 0; //@line 25243 "c/sqlite3.c"
 (_sqlite3_soft_heap_limit64($spec$store$select,0)|0); //@line 25244 "c/sqlite3.c"
 $2 = tempRet0; //@line 25244 "c/sqlite3.c"
 return; //@line 25245 "c/sqlite3.c"
}
function _sqlite3_vfs_unregister($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3MutexAlloc(2)|0); //@line 21221 "c/sqlite3.c"
 _sqlite3_mutex_enter($1); //@line 21223 "c/sqlite3.c"
 _vfsUnlink($0); //@line 21224 "c/sqlite3.c"
 _sqlite3_mutex_leave($1); //@line 21225 "c/sqlite3.c"
 return 0; //@line 21226 "c/sqlite3.c"
}
function _sqlite3_threadsafe() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 1; //@line 143432 "c/sqlite3.c"
}
function _sqlite3_result_zeroblob($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 78181 "c/sqlite3.c"
 _sqlite3VdbeMemSetZeroBlob($2,$1); //@line 78181 "c/sqlite3.c"
 return; //@line 78182 "c/sqlite3.c"
}
function _sqlite3_test_control($0,$varargs) {
 $0 = $0|0;
 $varargs = $varargs|0;
 var $$0 = 0, $$0$$0$50 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $arglist_current = 0, $arglist_current11 = 0, $arglist_current14 = 0, $arglist_current17 = 0, $arglist_current2 = 0, $arglist_current20 = 0, $arglist_current23 = 0, $arglist_current26 = 0, $arglist_current29 = 0, $arglist_current32 = 0, $arglist_current35 = 0, $arglist_current38 = 0, $arglist_current41 = 0, $arglist_current44 = 0, $arglist_current47 = 0, $arglist_current5 = 0;
 var $arglist_current50 = 0, $arglist_current53 = 0, $arglist_current56 = 0, $arglist_current59 = 0, $arglist_current8 = 0, $arglist_next = 0, $arglist_next12 = 0, $arglist_next15 = 0, $arglist_next18 = 0, $arglist_next21 = 0, $arglist_next24 = 0, $arglist_next27 = 0, $arglist_next3 = 0, $arglist_next30 = 0, $arglist_next33 = 0, $arglist_next36 = 0, $arglist_next39 = 0, $arglist_next42 = 0, $arglist_next45 = 0, $arglist_next48 = 0;
 var $arglist_next51 = 0, $arglist_next54 = 0, $arglist_next57 = 0, $arglist_next6 = 0, $arglist_next60 = 0, $arglist_next9 = 0, $expanded = 0, $expanded10 = 0, $expanded100 = 0, $expanded101 = 0, $expanded103 = 0, $expanded104 = 0, $expanded105 = 0, $expanded107 = 0, $expanded108 = 0, $expanded110 = 0, $expanded111 = 0, $expanded112 = 0, $expanded114 = 0, $expanded115 = 0;
 var $expanded117 = 0, $expanded118 = 0, $expanded119 = 0, $expanded12 = 0, $expanded121 = 0, $expanded122 = 0, $expanded124 = 0, $expanded125 = 0, $expanded126 = 0, $expanded128 = 0, $expanded129 = 0, $expanded13 = 0, $expanded131 = 0, $expanded132 = 0, $expanded133 = 0, $expanded135 = 0, $expanded136 = 0, $expanded138 = 0, $expanded139 = 0, $expanded14 = 0;
 var $expanded140 = 0, $expanded142 = 0, $expanded143 = 0, $expanded145 = 0, $expanded146 = 0, $expanded147 = 0, $expanded16 = 0, $expanded17 = 0, $expanded19 = 0, $expanded20 = 0, $expanded21 = 0, $expanded23 = 0, $expanded24 = 0, $expanded26 = 0, $expanded27 = 0, $expanded28 = 0, $expanded3 = 0, $expanded30 = 0, $expanded31 = 0, $expanded33 = 0;
 var $expanded34 = 0, $expanded35 = 0, $expanded37 = 0, $expanded38 = 0, $expanded40 = 0, $expanded41 = 0, $expanded42 = 0, $expanded44 = 0, $expanded45 = 0, $expanded47 = 0, $expanded48 = 0, $expanded49 = 0, $expanded5 = 0, $expanded51 = 0, $expanded52 = 0, $expanded54 = 0, $expanded55 = 0, $expanded56 = 0, $expanded58 = 0, $expanded59 = 0;
 var $expanded6 = 0, $expanded61 = 0, $expanded62 = 0, $expanded63 = 0, $expanded65 = 0, $expanded66 = 0, $expanded68 = 0, $expanded69 = 0, $expanded7 = 0, $expanded70 = 0, $expanded72 = 0, $expanded73 = 0, $expanded75 = 0, $expanded76 = 0, $expanded77 = 0, $expanded79 = 0, $expanded80 = 0, $expanded82 = 0, $expanded83 = 0, $expanded84 = 0;
 var $expanded86 = 0, $expanded87 = 0, $expanded89 = 0, $expanded9 = 0, $expanded90 = 0, $expanded91 = 0, $expanded93 = 0, $expanded94 = 0, $expanded96 = 0, $expanded97 = 0, $expanded98 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $1 = sp + 8|0;
 $2 = sp;
 HEAP32[$1>>2] = $varargs; //@line 146965 "c/sqlite3.c"
 do {
  switch ($0|0) {
  case 5:  {
   _sqlite3PrngSaveState(); //@line 146972 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 6:  {
   _sqlite3PrngRestoreState(); //@line 146982 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 7:  {
   _sqlite3_randomness(0,0); //@line 146992 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 8:  {
   $arglist_current = HEAP32[$1>>2]|0; //@line 147005 "c/sqlite3.c"
   $3 = $arglist_current; //@line 147005 "c/sqlite3.c"
   $4 = ((0) + 4|0);
   $expanded3 = $4;
   $expanded = (($expanded3) - 1)|0;
   $5 = (($3) + ($expanded))|0; //@line 147005 "c/sqlite3.c"
   $6 = ((0) + 4|0);
   $expanded7 = $6;
   $expanded6 = (($expanded7) - 1)|0;
   $expanded5 = $expanded6 ^ -1;
   $7 = $5 & $expanded5; //@line 147005 "c/sqlite3.c"
   $8 = $7; //@line 147005 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 147005 "c/sqlite3.c"
   $arglist_next = ((($8)) + 4|0); //@line 147005 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next; //@line 147005 "c/sqlite3.c"
   $arglist_current2 = HEAP32[$1>>2]|0; //@line 147006 "c/sqlite3.c"
   $10 = $arglist_current2; //@line 147006 "c/sqlite3.c"
   $11 = ((0) + 4|0);
   $expanded10 = $11;
   $expanded9 = (($expanded10) - 1)|0;
   $12 = (($10) + ($expanded9))|0; //@line 147006 "c/sqlite3.c"
   $13 = ((0) + 4|0);
   $expanded14 = $13;
   $expanded13 = (($expanded14) - 1)|0;
   $expanded12 = $expanded13 ^ -1;
   $14 = $12 & $expanded12; //@line 147006 "c/sqlite3.c"
   $15 = $14; //@line 147006 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 147006 "c/sqlite3.c"
   $arglist_next3 = ((($15)) + 4|0); //@line 147006 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next3; //@line 147006 "c/sqlite3.c"
   $17 = (_sqlite3BitvecBuiltinTest($9,$16)|0); //@line 147007 "c/sqlite3.c"
   $$0 = $17;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 9:  {
   $arglist_current5 = HEAP32[$1>>2]|0; //@line 147028 "c/sqlite3.c"
   $18 = $arglist_current5; //@line 147028 "c/sqlite3.c"
   $19 = ((0) + 4|0);
   $expanded17 = $19;
   $expanded16 = (($expanded17) - 1)|0;
   $20 = (($18) + ($expanded16))|0; //@line 147028 "c/sqlite3.c"
   $21 = ((0) + 4|0);
   $expanded21 = $21;
   $expanded20 = (($expanded21) - 1)|0;
   $expanded19 = $expanded20 ^ -1;
   $22 = $20 & $expanded19; //@line 147028 "c/sqlite3.c"
   $23 = $22; //@line 147028 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 147028 "c/sqlite3.c"
   $arglist_next6 = ((($23)) + 4|0); //@line 147028 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next6; //@line 147028 "c/sqlite3.c"
   HEAP32[(268)>>2] = $24; //@line 147028 "c/sqlite3.c"
   $25 = (_sqlite3FaultSim(0)|0); //@line 147029 "c/sqlite3.c"
   $$0 = $25;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 10:  {
   $arglist_current8 = HEAP32[$1>>2]|0; //@line 147043 "c/sqlite3.c"
   $26 = $arglist_current8; //@line 147043 "c/sqlite3.c"
   $27 = ((0) + 4|0);
   $expanded24 = $27;
   $expanded23 = (($expanded24) - 1)|0;
   $28 = (($26) + ($expanded23))|0; //@line 147043 "c/sqlite3.c"
   $29 = ((0) + 4|0);
   $expanded28 = $29;
   $expanded27 = (($expanded28) - 1)|0;
   $expanded26 = $expanded27 ^ -1;
   $30 = $28 & $expanded26; //@line 147043 "c/sqlite3.c"
   $31 = $30; //@line 147043 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 147043 "c/sqlite3.c"
   $arglist_next9 = ((($31)) + 4|0); //@line 147043 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next9; //@line 147043 "c/sqlite3.c"
   $arglist_current11 = HEAP32[$1>>2]|0; //@line 147044 "c/sqlite3.c"
   $33 = $arglist_current11; //@line 147044 "c/sqlite3.c"
   $34 = ((0) + 4|0);
   $expanded31 = $34;
   $expanded30 = (($expanded31) - 1)|0;
   $35 = (($33) + ($expanded30))|0; //@line 147044 "c/sqlite3.c"
   $36 = ((0) + 4|0);
   $expanded35 = $36;
   $expanded34 = (($expanded35) - 1)|0;
   $expanded33 = $expanded34 ^ -1;
   $37 = $35 & $expanded33; //@line 147044 "c/sqlite3.c"
   $38 = $37; //@line 147044 "c/sqlite3.c"
   $39 = HEAP32[$38>>2]|0; //@line 147044 "c/sqlite3.c"
   $arglist_next12 = ((($38)) + 4|0); //@line 147044 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next12; //@line 147044 "c/sqlite3.c"
   _sqlite3BenignMallocHooks($32,$39); //@line 147045 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 11:  {
   $40 = HEAP32[513]|0; //@line 147062 "c/sqlite3.c"
   $arglist_current14 = HEAP32[$1>>2]|0; //@line 147065 "c/sqlite3.c"
   $41 = $arglist_current14; //@line 147065 "c/sqlite3.c"
   $42 = ((0) + 4|0);
   $expanded38 = $42;
   $expanded37 = (($expanded38) - 1)|0;
   $43 = (($41) + ($expanded37))|0; //@line 147065 "c/sqlite3.c"
   $44 = ((0) + 4|0);
   $expanded42 = $44;
   $expanded41 = (($expanded42) - 1)|0;
   $expanded40 = $expanded41 ^ -1;
   $45 = $43 & $expanded40; //@line 147065 "c/sqlite3.c"
   $46 = $45; //@line 147065 "c/sqlite3.c"
   $47 = HEAP32[$46>>2]|0; //@line 147065 "c/sqlite3.c"
   $arglist_next15 = ((($46)) + 4|0); //@line 147065 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next15; //@line 147065 "c/sqlite3.c"
   $48 = ($47|0)==(0); //@line 147066 "c/sqlite3.c"
   if ($48) {
    $$0 = $40;
    STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   }
   HEAP32[513] = $47; //@line 147066 "c/sqlite3.c"
   $$0 = $40;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 12:  {
   HEAP32[$2>>2] = 0; //@line 147084 "c/sqlite3.c"
   $$0$$0$50 = HEAP32[$2>>2]|0; //@line 147086 "c/sqlite3.c"
   $$0 = $$0$$0$50;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 13:  {
   $arglist_current17 = HEAP32[$1>>2]|0; //@line 147119 "c/sqlite3.c"
   $49 = $arglist_current17; //@line 147119 "c/sqlite3.c"
   $50 = ((0) + 4|0);
   $expanded45 = $50;
   $expanded44 = (($expanded45) - 1)|0;
   $51 = (($49) + ($expanded44))|0; //@line 147119 "c/sqlite3.c"
   $52 = ((0) + 4|0);
   $expanded49 = $52;
   $expanded48 = (($expanded49) - 1)|0;
   $expanded47 = $expanded48 ^ -1;
   $53 = $51 & $expanded47; //@line 147119 "c/sqlite3.c"
   $54 = $53; //@line 147119 "c/sqlite3.c"
   $55 = HEAP32[$54>>2]|0; //@line 147119 "c/sqlite3.c"
   $arglist_next18 = ((($54)) + 4|0); //@line 147119 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next18; //@line 147119 "c/sqlite3.c"
   $$0 = $55;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 22:  {
   $$0 = 10;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 14:  {
   $arglist_current20 = HEAP32[$1>>2]|0; //@line 147146 "c/sqlite3.c"
   $56 = $arglist_current20; //@line 147146 "c/sqlite3.c"
   $57 = ((0) + 4|0);
   $expanded52 = $57;
   $expanded51 = (($expanded52) - 1)|0;
   $58 = (($56) + ($expanded51))|0; //@line 147146 "c/sqlite3.c"
   $59 = ((0) + 4|0);
   $expanded56 = $59;
   $expanded55 = (($expanded56) - 1)|0;
   $expanded54 = $expanded55 ^ -1;
   $60 = $58 & $expanded54; //@line 147146 "c/sqlite3.c"
   $61 = $60; //@line 147146 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 147146 "c/sqlite3.c"
   $arglist_next21 = ((($61)) + 4|0); //@line 147146 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next21; //@line 147146 "c/sqlite3.c"
   $arglist_current23 = HEAP32[$1>>2]|0; //@line 147147 "c/sqlite3.c"
   $63 = $arglist_current23; //@line 147147 "c/sqlite3.c"
   $64 = ((0) + 4|0);
   $expanded59 = $64;
   $expanded58 = (($expanded59) - 1)|0;
   $65 = (($63) + ($expanded58))|0; //@line 147147 "c/sqlite3.c"
   $66 = ((0) + 4|0);
   $expanded63 = $66;
   $expanded62 = (($expanded63) - 1)|0;
   $expanded61 = $expanded62 ^ -1;
   $67 = $65 & $expanded61; //@line 147147 "c/sqlite3.c"
   $68 = $67; //@line 147147 "c/sqlite3.c"
   $69 = HEAP32[$68>>2]|0; //@line 147147 "c/sqlite3.c"
   $arglist_next24 = ((($68)) + 4|0); //@line 147147 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next24; //@line 147147 "c/sqlite3.c"
   $70 = ((($62)) + 12|0); //@line 147148 "c/sqlite3.c"
   $71 = HEAP32[$70>>2]|0; //@line 147148 "c/sqlite3.c"
   _sqlite3_mutex_enter($71); //@line 147148 "c/sqlite3.c"
   $72 = ((($62)) + 16|0); //@line 147149 "c/sqlite3.c"
   $73 = HEAP32[$72>>2]|0; //@line 147149 "c/sqlite3.c"
   $74 = ((($73)) + 4|0); //@line 147149 "c/sqlite3.c"
   $75 = HEAP32[$74>>2]|0; //@line 147149 "c/sqlite3.c"
   (_sqlite3BtreeSetPageSize($75,0,$69,0)|0); //@line 147149 "c/sqlite3.c"
   $76 = HEAP32[$70>>2]|0; //@line 147150 "c/sqlite3.c"
   _sqlite3_mutex_leave($76); //@line 147150 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 15:  {
   $arglist_current26 = HEAP32[$1>>2]|0; //@line 147164 "c/sqlite3.c"
   $77 = $arglist_current26; //@line 147164 "c/sqlite3.c"
   $78 = ((0) + 4|0);
   $expanded66 = $78;
   $expanded65 = (($expanded66) - 1)|0;
   $79 = (($77) + ($expanded65))|0; //@line 147164 "c/sqlite3.c"
   $80 = ((0) + 4|0);
   $expanded70 = $80;
   $expanded69 = (($expanded70) - 1)|0;
   $expanded68 = $expanded69 ^ -1;
   $81 = $79 & $expanded68; //@line 147164 "c/sqlite3.c"
   $82 = $81; //@line 147164 "c/sqlite3.c"
   $83 = HEAP32[$82>>2]|0; //@line 147164 "c/sqlite3.c"
   $arglist_next27 = ((($82)) + 4|0); //@line 147164 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next27; //@line 147164 "c/sqlite3.c"
   $arglist_current29 = HEAP32[$1>>2]|0; //@line 147165 "c/sqlite3.c"
   $84 = $arglist_current29; //@line 147165 "c/sqlite3.c"
   $85 = ((0) + 4|0);
   $expanded73 = $85;
   $expanded72 = (($expanded73) - 1)|0;
   $86 = (($84) + ($expanded72))|0; //@line 147165 "c/sqlite3.c"
   $87 = ((0) + 4|0);
   $expanded77 = $87;
   $expanded76 = (($expanded77) - 1)|0;
   $expanded75 = $expanded76 ^ -1;
   $88 = $86 & $expanded75; //@line 147165 "c/sqlite3.c"
   $89 = $88; //@line 147165 "c/sqlite3.c"
   $90 = HEAP32[$89>>2]|0; //@line 147165 "c/sqlite3.c"
   $arglist_next30 = ((($89)) + 4|0); //@line 147165 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next30; //@line 147165 "c/sqlite3.c"
   $91 = $90&65535; //@line 147165 "c/sqlite3.c"
   $92 = ((($83)) + 68|0); //@line 147165 "c/sqlite3.c"
   HEAP16[$92>>1] = $91; //@line 147165 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 16:  {
   $arglist_current32 = HEAP32[$1>>2]|0; //@line 147180 "c/sqlite3.c"
   $93 = $arglist_current32; //@line 147180 "c/sqlite3.c"
   $94 = ((0) + 4|0);
   $expanded80 = $94;
   $expanded79 = (($expanded80) - 1)|0;
   $95 = (($93) + ($expanded79))|0; //@line 147180 "c/sqlite3.c"
   $96 = ((0) + 4|0);
   $expanded84 = $96;
   $expanded83 = (($expanded84) - 1)|0;
   $expanded82 = $expanded83 ^ -1;
   $97 = $95 & $expanded82; //@line 147180 "c/sqlite3.c"
   $98 = $97; //@line 147180 "c/sqlite3.c"
   $99 = HEAP32[$98>>2]|0; //@line 147180 "c/sqlite3.c"
   $arglist_next33 = ((($98)) + 4|0); //@line 147180 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next33; //@line 147180 "c/sqlite3.c"
   $100 = (_sqlite3Strlen30($99)|0); //@line 147181 "c/sqlite3.c"
   $101 = (_sqlite3KeywordCode($99,$100)|0); //@line 147182 "c/sqlite3.c"
   $102 = ($101|0)==(59); //@line 147182 "c/sqlite3.c"
   $103 = $102 ? 0 : 124; //@line 147182 "c/sqlite3.c"
   $$0 = $103;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 18:  {
   $arglist_current35 = HEAP32[$1>>2]|0; //@line 147194 "c/sqlite3.c"
   $104 = $arglist_current35; //@line 147194 "c/sqlite3.c"
   $105 = ((0) + 4|0);
   $expanded87 = $105;
   $expanded86 = (($expanded87) - 1)|0;
   $106 = (($104) + ($expanded86))|0; //@line 147194 "c/sqlite3.c"
   $107 = ((0) + 4|0);
   $expanded91 = $107;
   $expanded90 = (($expanded91) - 1)|0;
   $expanded89 = $expanded90 ^ -1;
   $108 = $106 & $expanded89; //@line 147194 "c/sqlite3.c"
   $109 = $108; //@line 147194 "c/sqlite3.c"
   $110 = HEAP32[$109>>2]|0; //@line 147194 "c/sqlite3.c"
   $arglist_next36 = ((($109)) + 4|0); //@line 147194 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next36; //@line 147194 "c/sqlite3.c"
   HEAP32[(272)>>2] = $110; //@line 147194 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 20:  {
   $arglist_current38 = HEAP32[$1>>2]|0; //@line 147207 "c/sqlite3.c"
   $111 = $arglist_current38; //@line 147207 "c/sqlite3.c"
   $112 = ((0) + 4|0);
   $expanded94 = $112;
   $expanded93 = (($expanded94) - 1)|0;
   $113 = (($111) + ($expanded93))|0; //@line 147207 "c/sqlite3.c"
   $114 = ((0) + 4|0);
   $expanded98 = $114;
   $expanded97 = (($expanded98) - 1)|0;
   $expanded96 = $expanded97 ^ -1;
   $115 = $113 & $expanded96; //@line 147207 "c/sqlite3.c"
   $116 = $115; //@line 147207 "c/sqlite3.c"
   $117 = HEAP32[$116>>2]|0; //@line 147207 "c/sqlite3.c"
   $arglist_next39 = ((($116)) + 4|0); //@line 147207 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next39; //@line 147207 "c/sqlite3.c"
   HEAP32[(36)>>2] = $117; //@line 147207 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 19:  {
   $arglist_current41 = HEAP32[$1>>2]|0; //@line 147217 "c/sqlite3.c"
   $118 = $arglist_current41; //@line 147217 "c/sqlite3.c"
   $119 = ((0) + 4|0);
   $expanded101 = $119;
   $expanded100 = (($expanded101) - 1)|0;
   $120 = (($118) + ($expanded100))|0; //@line 147217 "c/sqlite3.c"
   $121 = ((0) + 4|0);
   $expanded105 = $121;
   $expanded104 = (($expanded105) - 1)|0;
   $expanded103 = $expanded104 ^ -1;
   $122 = $120 & $expanded103; //@line 147217 "c/sqlite3.c"
   $123 = $122; //@line 147217 "c/sqlite3.c"
   $124 = HEAP32[$123>>2]|0; //@line 147217 "c/sqlite3.c"
   $arglist_next42 = ((($123)) + 4|0); //@line 147217 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next42; //@line 147217 "c/sqlite3.c"
   HEAP32[(276)>>2] = $124; //@line 147217 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 25:  {
   $arglist_current50 = HEAP32[$1>>2]|0; //@line 147269 "c/sqlite3.c"
   $142 = $arglist_current50; //@line 147269 "c/sqlite3.c"
   $143 = ((0) + 4|0);
   $expanded122 = $143;
   $expanded121 = (($expanded122) - 1)|0;
   $144 = (($142) + ($expanded121))|0; //@line 147269 "c/sqlite3.c"
   $145 = ((0) + 4|0);
   $expanded126 = $145;
   $expanded125 = (($expanded126) - 1)|0;
   $expanded124 = $expanded125 ^ -1;
   $146 = $144 & $expanded124; //@line 147269 "c/sqlite3.c"
   $147 = $146; //@line 147269 "c/sqlite3.c"
   $148 = HEAP32[$147>>2]|0; //@line 147269 "c/sqlite3.c"
   $arglist_next51 = ((($147)) + 4|0); //@line 147269 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next51; //@line 147269 "c/sqlite3.c"
   $149 = ((($148)) + 12|0); //@line 147270 "c/sqlite3.c"
   $150 = HEAP32[$149>>2]|0; //@line 147270 "c/sqlite3.c"
   _sqlite3_mutex_enter($150); //@line 147270 "c/sqlite3.c"
   $arglist_current53 = HEAP32[$1>>2]|0; //@line 147271 "c/sqlite3.c"
   $151 = $arglist_current53; //@line 147271 "c/sqlite3.c"
   $152 = ((0) + 4|0);
   $expanded129 = $152;
   $expanded128 = (($expanded129) - 1)|0;
   $153 = (($151) + ($expanded128))|0; //@line 147271 "c/sqlite3.c"
   $154 = ((0) + 4|0);
   $expanded133 = $154;
   $expanded132 = (($expanded133) - 1)|0;
   $expanded131 = $expanded132 ^ -1;
   $155 = $153 & $expanded131; //@line 147271 "c/sqlite3.c"
   $156 = $155; //@line 147271 "c/sqlite3.c"
   $157 = HEAP32[$156>>2]|0; //@line 147271 "c/sqlite3.c"
   $arglist_next54 = ((($156)) + 4|0); //@line 147271 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next54; //@line 147271 "c/sqlite3.c"
   $158 = (_sqlite3FindDbName($148,$157)|0); //@line 147271 "c/sqlite3.c"
   $159 = $158&255; //@line 147271 "c/sqlite3.c"
   $160 = ((($148)) + 156|0); //@line 147271 "c/sqlite3.c"
   HEAP8[$160>>0] = $159; //@line 147271 "c/sqlite3.c"
   $arglist_current56 = HEAP32[$1>>2]|0; //@line 147272 "c/sqlite3.c"
   $161 = $arglist_current56; //@line 147272 "c/sqlite3.c"
   $162 = ((0) + 4|0);
   $expanded136 = $162;
   $expanded135 = (($expanded136) - 1)|0;
   $163 = (($161) + ($expanded135))|0; //@line 147272 "c/sqlite3.c"
   $164 = ((0) + 4|0);
   $expanded140 = $164;
   $expanded139 = (($expanded140) - 1)|0;
   $expanded138 = $expanded139 ^ -1;
   $165 = $163 & $expanded138; //@line 147272 "c/sqlite3.c"
   $166 = $165; //@line 147272 "c/sqlite3.c"
   $167 = HEAP32[$166>>2]|0; //@line 147272 "c/sqlite3.c"
   $arglist_next57 = ((($166)) + 4|0); //@line 147272 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next57; //@line 147272 "c/sqlite3.c"
   $168 = $167&255; //@line 147272 "c/sqlite3.c"
   $169 = ((($148)) + 159|0); //@line 147272 "c/sqlite3.c"
   HEAP8[$169>>0] = $168; //@line 147272 "c/sqlite3.c"
   $170 = ((($148)) + 157|0); //@line 147272 "c/sqlite3.c"
   HEAP8[$170>>0] = $168; //@line 147272 "c/sqlite3.c"
   $arglist_current59 = HEAP32[$1>>2]|0; //@line 147273 "c/sqlite3.c"
   $171 = $arglist_current59; //@line 147273 "c/sqlite3.c"
   $172 = ((0) + 4|0);
   $expanded143 = $172;
   $expanded142 = (($expanded143) - 1)|0;
   $173 = (($171) + ($expanded142))|0; //@line 147273 "c/sqlite3.c"
   $174 = ((0) + 4|0);
   $expanded147 = $174;
   $expanded146 = (($expanded147) - 1)|0;
   $expanded145 = $expanded146 ^ -1;
   $175 = $173 & $expanded145; //@line 147273 "c/sqlite3.c"
   $176 = $175; //@line 147273 "c/sqlite3.c"
   $177 = HEAP32[$176>>2]|0; //@line 147273 "c/sqlite3.c"
   $arglist_next60 = ((($176)) + 4|0); //@line 147273 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next60; //@line 147273 "c/sqlite3.c"
   $178 = ((($148)) + 152|0); //@line 147273 "c/sqlite3.c"
   HEAP32[$178>>2] = $177; //@line 147273 "c/sqlite3.c"
   $179 = HEAP8[$170>>0]|0; //@line 147274 "c/sqlite3.c"
   $180 = ($179<<24>>24)==(0); //@line 147274 "c/sqlite3.c"
   $181 = ($177|0)>(0); //@line 147274 "c/sqlite3.c"
   $or$cond = $181 & $180; //@line 147274 "c/sqlite3.c"
   if ($or$cond) {
    _sqlite3ResetAllSchemasOfConnection($148); //@line 147275 "c/sqlite3.c"
   }
   $182 = HEAP32[$149>>2]|0; //@line 147277 "c/sqlite3.c"
   _sqlite3_mutex_leave($182); //@line 147277 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 24:  {
   $arglist_current44 = HEAP32[$1>>2]|0; //@line 147237 "c/sqlite3.c"
   $125 = $arglist_current44; //@line 147237 "c/sqlite3.c"
   $126 = ((0) + 4|0);
   $expanded108 = $126;
   $expanded107 = (($expanded108) - 1)|0;
   $127 = (($125) + ($expanded107))|0; //@line 147237 "c/sqlite3.c"
   $128 = ((0) + 4|0);
   $expanded112 = $128;
   $expanded111 = (($expanded112) - 1)|0;
   $expanded110 = $expanded111 ^ -1;
   $129 = $127 & $expanded110; //@line 147237 "c/sqlite3.c"
   $130 = $129; //@line 147237 "c/sqlite3.c"
   $131 = HEAP32[$130>>2]|0; //@line 147237 "c/sqlite3.c"
   $arglist_next45 = ((($130)) + 4|0); //@line 147237 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next45; //@line 147237 "c/sqlite3.c"
   $arglist_current47 = HEAP32[$1>>2]|0; //@line 147238 "c/sqlite3.c"
   $132 = $arglist_current47; //@line 147238 "c/sqlite3.c"
   $133 = ((0) + 4|0);
   $expanded115 = $133;
   $expanded114 = (($expanded115) - 1)|0;
   $134 = (($132) + ($expanded114))|0; //@line 147238 "c/sqlite3.c"
   $135 = ((0) + 4|0);
   $expanded119 = $135;
   $expanded118 = (($expanded119) - 1)|0;
   $expanded117 = $expanded118 ^ -1;
   $136 = $134 & $expanded117; //@line 147238 "c/sqlite3.c"
   $137 = $136; //@line 147238 "c/sqlite3.c"
   $138 = HEAP32[$137>>2]|0; //@line 147238 "c/sqlite3.c"
   $arglist_next48 = ((($137)) + 4|0); //@line 147238 "c/sqlite3.c"
   HEAP32[$1>>2] = $arglist_next48; //@line 147238 "c/sqlite3.c"
   $139 = ((($131)) + 148|0); //@line 147238 "c/sqlite3.c"
   HEAP32[$139>>2] = $138; //@line 147238 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  case 23:  {
   $140 = HEAP32[(232)>>2]|0; //@line 147248 "c/sqlite3.c"
   $141 = ($140|0)==(0); //@line 147248 "c/sqlite3.c"
   $spec$select = $141&1; //@line 147248 "c/sqlite3.c"
   $$0 = $spec$select;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
   break;
  }
  default: {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 147299 "c/sqlite3.c"
  }
  }
 } while(0);
 return (0)|0;
}
function _sqlite3_extended_result_codes($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 146910 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 146910 "c/sqlite3.c"
 _sqlite3_mutex_enter($3); //@line 146910 "c/sqlite3.c"
 $4 = ($1|0)==(0); //@line 146911 "c/sqlite3.c"
 $5 = $4 ? 255 : -1; //@line 146911 "c/sqlite3.c"
 $6 = ((($0)) + 60|0); //@line 146911 "c/sqlite3.c"
 HEAP32[$6>>2] = $5; //@line 146911 "c/sqlite3.c"
 $7 = HEAP32[$2>>2]|0; //@line 146912 "c/sqlite3.c"
 _sqlite3_mutex_leave($7); //@line 146912 "c/sqlite3.c"
 return 0; //@line 146913 "c/sqlite3.c"
}
function _sqlite3_limit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1>>>0)>(11); //@line 145889 "c/sqlite3.c"
 if ($3) {
  $$0 = -1;
  return ($$0|0); //@line 145900 "c/sqlite3.c"
 }
 $4 = (((($0)) + 100|0) + ($1<<2)|0); //@line 145892 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 145892 "c/sqlite3.c"
 $6 = ($2|0)>(-1); //@line 145893 "c/sqlite3.c"
 if (!($6)) {
  $$0 = $5;
  return ($$0|0); //@line 145900 "c/sqlite3.c"
 }
 $7 = (6464 + ($1<<2)|0); //@line 145894 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 145894 "c/sqlite3.c"
 $9 = ($8|0)<($2|0); //@line 145894 "c/sqlite3.c"
 $spec$select = $9 ? $8 : $2; //@line 145894 "c/sqlite3.c"
 HEAP32[$4>>2] = $spec$select; //@line 145897 "c/sqlite3.c"
 $$0 = $5;
 return ($$0|0); //@line 145900 "c/sqlite3.c"
}
function _sqlite3_next_stmt($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$in$in = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 79367 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 79367 "c/sqlite3.c"
 _sqlite3_mutex_enter($3); //@line 79367 "c/sqlite3.c"
 $4 = ($1|0)==(0|0); //@line 79368 "c/sqlite3.c"
 $5 = ((($0)) + 4|0); //@line 79369 "c/sqlite3.c"
 $6 = ((($1)) + 8|0); //@line 79371 "c/sqlite3.c"
 $$0$in$in = $4 ? $5 : $6; //@line 79368 "c/sqlite3.c"
 $$0 = HEAP32[$$0$in$in>>2]|0;
 $7 = HEAP32[$2>>2]|0; //@line 79373 "c/sqlite3.c"
 _sqlite3_mutex_leave($7); //@line 79373 "c/sqlite3.c"
 return ($$0|0); //@line 79374 "c/sqlite3.c"
}
function _sqlite3_sql($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 79410 "c/sqlite3.c"
 if ($1) {
  $4 = 0;
 } else {
  $2 = ((($0)) + 184|0); //@line 79410 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 79410 "c/sqlite3.c"
  $4 = $3;
 }
 return ($4|0); //@line 79410 "c/sqlite3.c"
}
function _sqlite3_status($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 8|0;
 $5 = sp;
 $6 = $4; //@line 19338 "c/sqlite3.c"
 $7 = $6; //@line 19338 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 19338 "c/sqlite3.c"
 $8 = (($6) + 4)|0; //@line 19338 "c/sqlite3.c"
 $9 = $8; //@line 19338 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 19338 "c/sqlite3.c"
 $10 = $5; //@line 19338 "c/sqlite3.c"
 $11 = $10; //@line 19338 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 19338 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 19338 "c/sqlite3.c"
 $13 = $12; //@line 19338 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 19338 "c/sqlite3.c"
 $14 = (_sqlite3_status64($0,$4,$5,$3)|0); //@line 19343 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 19344 "c/sqlite3.c"
 if (!($15)) {
  STACKTOP = sp;return ($14|0); //@line 19348 "c/sqlite3.c"
 }
 $16 = $4; //@line 19345 "c/sqlite3.c"
 $17 = $16; //@line 19345 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 19345 "c/sqlite3.c"
 $19 = (($16) + 4)|0; //@line 19345 "c/sqlite3.c"
 $20 = $19; //@line 19345 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 19345 "c/sqlite3.c"
 HEAP32[$1>>2] = $18; //@line 19345 "c/sqlite3.c"
 $22 = $5; //@line 19346 "c/sqlite3.c"
 $23 = $22; //@line 19346 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 19346 "c/sqlite3.c"
 $25 = (($22) + 4)|0; //@line 19346 "c/sqlite3.c"
 $26 = $25; //@line 19346 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 19346 "c/sqlite3.c"
 HEAP32[$2>>2] = $24; //@line 19346 "c/sqlite3.c"
 STACKTOP = sp;return ($14|0); //@line 19348 "c/sqlite3.c"
}
function _sqlite3_backup_finish($0) {
 $0 = $0|0;
 var $$0 = 0, $$032 = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 70995 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
  return ($$0|0); //@line 71035 "c/sqlite3.c"
 }
 $2 = ((($0)) + 20|0); //@line 70996 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 70996 "c/sqlite3.c"
 $4 = ((($3)) + 12|0); //@line 70997 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 70997 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 70997 "c/sqlite3.c"
 $6 = ((($0)) + 24|0); //@line 70998 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 70998 "c/sqlite3.c"
 _sqlite3BtreeEnter($7); //@line 70998 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 70999 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 70999 "c/sqlite3.c"
 if (!($9)) {
  $10 = ((($8)) + 12|0); //@line 71000 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 71000 "c/sqlite3.c"
  _sqlite3_mutex_enter($11); //@line 71000 "c/sqlite3.c"
  $$pr = HEAP32[$0>>2]|0; //@line 71004 "c/sqlite3.c"
  $12 = ($$pr|0)==(0|0); //@line 71004 "c/sqlite3.c"
  if (!($12)) {
   $13 = HEAP32[$6>>2]|0; //@line 71005 "c/sqlite3.c"
   $14 = ((($13)) + 16|0); //@line 71005 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 71005 "c/sqlite3.c"
   $16 = (($15) + -1)|0; //@line 71005 "c/sqlite3.c"
   HEAP32[$14>>2] = $16; //@line 71005 "c/sqlite3.c"
  }
 }
 $17 = ((($0)) + 40|0); //@line 71007 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 71007 "c/sqlite3.c"
 $19 = ($18|0)==(0); //@line 71007 "c/sqlite3.c"
 if (!($19)) {
  $20 = HEAP32[$6>>2]|0; //@line 71008 "c/sqlite3.c"
  $21 = (_sqlite3BtreePager($20)|0); //@line 71008 "c/sqlite3.c"
  $22 = (_sqlite3PagerBackupPtr($21)|0); //@line 71008 "c/sqlite3.c"
  $$032 = $22;
  while(1) {
   $23 = HEAP32[$$032>>2]|0; //@line 71009 "c/sqlite3.c"
   $24 = ($23|0)==($0|0); //@line 71009 "c/sqlite3.c"
   $25 = ((($23)) + 44|0); //@line 71010 "c/sqlite3.c"
   if ($24) {
    break;
   } else {
    $$032 = $25;
   }
  }
  $26 = ((($0)) + 44|0); //@line 71012 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 71012 "c/sqlite3.c"
  HEAP32[$$032>>2] = $27; //@line 71012 "c/sqlite3.c"
 }
 $28 = ((($0)) + 4|0); //@line 71016 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 71016 "c/sqlite3.c"
 _sqlite3BtreeRollback($29,0,0); //@line 71016 "c/sqlite3.c"
 $30 = ((($0)) + 28|0); //@line 71019 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 71019 "c/sqlite3.c"
 $32 = ($31|0)==(101); //@line 71019 "c/sqlite3.c"
 $spec$select = $32 ? 0 : $31; //@line 71019 "c/sqlite3.c"
 $33 = HEAP32[$0>>2]|0; //@line 71020 "c/sqlite3.c"
 $34 = ($33|0)==(0|0); //@line 71020 "c/sqlite3.c"
 if (!($34)) {
  _sqlite3Error($33,$spec$select); //@line 71021 "c/sqlite3.c"
  $35 = HEAP32[$0>>2]|0; //@line 71024 "c/sqlite3.c"
  _sqlite3LeaveMutexAndCloseZombie($35); //@line 71024 "c/sqlite3.c"
 }
 $36 = HEAP32[$6>>2]|0; //@line 71026 "c/sqlite3.c"
 _sqlite3BtreeLeave($36); //@line 71026 "c/sqlite3.c"
 $37 = HEAP32[$0>>2]|0; //@line 71027 "c/sqlite3.c"
 $38 = ($37|0)==(0|0); //@line 71027 "c/sqlite3.c"
 if (!($38)) {
  _sqlite3_free($0); //@line 71031 "c/sqlite3.c"
 }
 _sqlite3LeaveMutexAndCloseZombie($3); //@line 71033 "c/sqlite3.c"
 $$0 = $spec$select;
 return ($$0|0); //@line 71035 "c/sqlite3.c"
}
function _sqlite3_backup_init($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$134 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 70529 "c/sqlite3.c"
 $4 = ((($2)) + 12|0); //@line 70551 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 70551 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 70551 "c/sqlite3.c"
 $6 = ((($0)) + 12|0); //@line 70552 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 70552 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 70552 "c/sqlite3.c"
 $8 = ($2|0)==($0|0); //@line 70554 "c/sqlite3.c"
 do {
  if ($8) {
   _sqlite3ErrorWithMsg($0,1,35589,$vararg_buffer); //@line 70555 "c/sqlite3.c"
   $$134 = 0;
  } else {
   $9 = (_sqlite3MallocZero(48,0)|0); //@line 70564 "c/sqlite3.c"
   $10 = ($9|0)==(0|0); //@line 70565 "c/sqlite3.c"
   if ($10) {
    _sqlite3Error($0,7); //@line 70566 "c/sqlite3.c"
    $$134 = 0;
    break;
   }
   $11 = (_findBtree($0,$2,$3)|0); //@line 70572 "c/sqlite3.c"
   $12 = ((($9)) + 24|0); //@line 70572 "c/sqlite3.c"
   HEAP32[$12>>2] = $11; //@line 70572 "c/sqlite3.c"
   $13 = (_findBtree($0,$0,$1)|0); //@line 70573 "c/sqlite3.c"
   $14 = ((($9)) + 4|0); //@line 70573 "c/sqlite3.c"
   HEAP32[$14>>2] = $13; //@line 70573 "c/sqlite3.c"
   HEAP32[$9>>2] = $0; //@line 70574 "c/sqlite3.c"
   $15 = ((($9)) + 20|0); //@line 70575 "c/sqlite3.c"
   HEAP32[$15>>2] = $2; //@line 70575 "c/sqlite3.c"
   $16 = ((($9)) + 16|0); //@line 70576 "c/sqlite3.c"
   HEAP32[$16>>2] = 1; //@line 70576 "c/sqlite3.c"
   $17 = ((($9)) + 40|0); //@line 70577 "c/sqlite3.c"
   HEAP32[$17>>2] = 0; //@line 70577 "c/sqlite3.c"
   $18 = HEAP32[$12>>2]|0; //@line 70579 "c/sqlite3.c"
   $19 = ($18|0)==(0|0); //@line 70579 "c/sqlite3.c"
   $20 = ($13|0)==(0|0); //@line 70579 "c/sqlite3.c"
   $or$cond = $20 | $19; //@line 70579 "c/sqlite3.c"
   if (!($or$cond)) {
    $21 = (_checkReadTransaction($0,$13)|0); //@line 70580 "c/sqlite3.c"
    $22 = ($21|0)==(0); //@line 70580 "c/sqlite3.c"
    if ($22) {
     $23 = ((($9)) + 24|0); //@line 70592 "c/sqlite3.c"
     $24 = HEAP32[$23>>2]|0; //@line 70592 "c/sqlite3.c"
     $25 = ((($24)) + 16|0); //@line 70592 "c/sqlite3.c"
     $26 = HEAP32[$25>>2]|0; //@line 70592 "c/sqlite3.c"
     $27 = (($26) + 1)|0; //@line 70592 "c/sqlite3.c"
     HEAP32[$25>>2] = $27; //@line 70592 "c/sqlite3.c"
     $$134 = $9;
     break;
    }
   }
   _sqlite3_free($9); //@line 70587 "c/sqlite3.c"
   $$134 = 0;
  }
 } while(0);
 $28 = HEAP32[$6>>2]|0; //@line 70595 "c/sqlite3.c"
 _sqlite3_mutex_leave($28); //@line 70595 "c/sqlite3.c"
 $29 = HEAP32[$4>>2]|0; //@line 70596 "c/sqlite3.c"
 _sqlite3_mutex_leave($29); //@line 70596 "c/sqlite3.c"
 STACKTOP = sp;return ($$134|0); //@line 70597 "c/sqlite3.c"
}
function _sqlite3_backup_pagecount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 36|0); //@line 71062 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 71062 "c/sqlite3.c"
 return ($2|0); //@line 71062 "c/sqlite3.c"
}
function _sqlite3_backup_remaining($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 32|0); //@line 71048 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 71048 "c/sqlite3.c"
 return ($2|0); //@line 71048 "c/sqlite3.c"
}
function _sqlite3_backup_step($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0184218 = 0, $$0185223 = 0, $$0186202 = 0, $$0187 = 0, $$1 = 0, $$12219 = 0, $$13 = 0, $$14 = 0, $$15 = 0, $$16$lcssa = 0, $$17 = 0, $$19 = 0, $$20 = 0, $$22 = 0, $$24 = 0, $$3 = 0, $$4 = 0, $$5$lcssa = 0, $$5224 = 0, $$6 = 0;
 var $$7 = 0, $$lcssa = 0, $$not = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0;
 var $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0;
 var $205 = 0, $206 = 0, $207 = 0, $208 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond191 = 0, $or$cond194 = 0, $or$cond195 = 0, $or$cond195215 = 0, $or$cond3 = 0, $or$cond3$not = 0, $spec$select192 = 0, $spec$select196 = 0, $spec$store$select = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 4|0;
 $3 = sp;
 $4 = ((($0)) + 20|0); //@line 70744 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 70744 "c/sqlite3.c"
 $6 = ((($5)) + 12|0); //@line 70744 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 70744 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 70744 "c/sqlite3.c"
 $8 = ((($0)) + 24|0); //@line 70745 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 70745 "c/sqlite3.c"
 _sqlite3BtreeEnter($9); //@line 70745 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 70746 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 70746 "c/sqlite3.c"
 if (!($11)) {
  $12 = ((($10)) + 12|0); //@line 70747 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 70747 "c/sqlite3.c"
  _sqlite3_mutex_enter($13); //@line 70747 "c/sqlite3.c"
 }
 $14 = ((($0)) + 28|0); //@line 70750 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 70750 "c/sqlite3.c"
 $16 = (_isFatalError($15)|0); //@line 70751 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 70751 "c/sqlite3.c"
 if ($17) {
  $18 = HEAP32[$8>>2]|0; //@line 70752 "c/sqlite3.c"
  $19 = (_sqlite3BtreePager($18)|0); //@line 70752 "c/sqlite3.c"
  $20 = ((($0)) + 4|0); //@line 70753 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 70753 "c/sqlite3.c"
  $22 = (_sqlite3BtreePager($21)|0); //@line 70753 "c/sqlite3.c"
  $23 = HEAP32[$0>>2]|0; //@line 70761 "c/sqlite3.c"
  $24 = ($23|0)==(0|0); //@line 70761 "c/sqlite3.c"
  if ($24) {
   label = 6;
  } else {
   $25 = ((($18)) + 4|0); //@line 70761 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 70761 "c/sqlite3.c"
   $27 = ((($26)) + 20|0); //@line 70761 "c/sqlite3.c"
   $28 = HEAP8[$27>>0]|0; //@line 70761 "c/sqlite3.c"
   $29 = ($28<<24>>24)==(2); //@line 70761 "c/sqlite3.c"
   if ($29) {
    $$0187 = 0;$$1 = 5;
   } else {
    label = 6;
   }
  }
  if ((label|0) == 6) {
   $30 = (_sqlite3BtreeIsInReadTrans($18)|0); //@line 70771 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 70771 "c/sqlite3.c"
   if ($31) {
    $32 = (_sqlite3BtreeBeginTrans($18,0)|0); //@line 70772 "c/sqlite3.c"
    $$0187 = 1;$$1 = $32;
   } else {
    $$0187 = 0;$$1 = 0;
   }
  }
  $33 = ((($0)) + 12|0); //@line 70782 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 70782 "c/sqlite3.c"
  $35 = $34 | $$1; //@line 70782 "c/sqlite3.c"
  $36 = ($35|0)==(0); //@line 70782 "c/sqlite3.c"
  if ($36) {
   $37 = (_setDestPgsz($0)|0); //@line 70782 "c/sqlite3.c"
   $38 = ($37|0)==(7); //@line 70782 "c/sqlite3.c"
   if ($38) {
    $$3 = 7;
   } else {
    label = 10;
   }
  } else {
   label = 10;
  }
  if ((label|0) == 10) {
   $39 = ($$1|0)==(0); //@line 70787 "c/sqlite3.c"
   if ($39) {
    $40 = HEAP32[$33>>2]|0; //@line 70787 "c/sqlite3.c"
    $41 = ($40|0)==(0); //@line 70787 "c/sqlite3.c"
    if ($41) {
     $42 = HEAP32[$20>>2]|0; //@line 70788 "c/sqlite3.c"
     $43 = (_sqlite3BtreeBeginTrans($42,2)|0); //@line 70788 "c/sqlite3.c"
     $44 = ($43|0)==(0); //@line 70788 "c/sqlite3.c"
     if ($44) {
      HEAP32[$33>>2] = 1; //@line 70790 "c/sqlite3.c"
      $45 = HEAP32[$20>>2]|0; //@line 70791 "c/sqlite3.c"
      $46 = ((($0)) + 8|0); //@line 70791 "c/sqlite3.c"
      _sqlite3BtreeGetMeta($45,1,$46); //@line 70791 "c/sqlite3.c"
      $$3 = 0;
     } else {
      $$3 = $43;
     }
    } else {
     $$3 = 0;
    }
   } else {
    $$3 = $$1;
   }
  }
  $47 = HEAP32[$8>>2]|0; //@line 70796 "c/sqlite3.c"
  $48 = (_sqlite3BtreeGetPageSize($47)|0); //@line 70796 "c/sqlite3.c"
  $49 = HEAP32[$20>>2]|0; //@line 70797 "c/sqlite3.c"
  $50 = (_sqlite3BtreeGetPageSize($49)|0); //@line 70797 "c/sqlite3.c"
  $51 = (_sqlite3BtreePager($49)|0); //@line 70798 "c/sqlite3.c"
  $52 = (_sqlite3PagerGetJournalMode($51)|0); //@line 70798 "c/sqlite3.c"
  $53 = ($$3|0)==(0); //@line 70799 "c/sqlite3.c"
  $54 = ($52|0)==(5); //@line 70799 "c/sqlite3.c"
  $or$cond3 = $53 & $54; //@line 70799 "c/sqlite3.c"
  $or$cond3$not = $or$cond3 ^ 1; //@line 70799 "c/sqlite3.c"
  $55 = ($48|0)==($50|0); //@line 70799 "c/sqlite3.c"
  $or$cond = $55 | $or$cond3$not; //@line 70799 "c/sqlite3.c"
  $$4 = $or$cond ? $$3 : 8; //@line 70799 "c/sqlite3.c"
  $56 = (_sqlite3BtreeLastPage($47)|0); //@line 70806 "c/sqlite3.c"
  $57 = ($1|0)==(0); //@line 70808 "c/sqlite3.c"
  L20: do {
   if ($57) {
    $$5$lcssa = $$4;
   } else {
    $58 = ((($0)) + 16|0);
    $$0185223 = 0;$$5224 = $$4;
    while(1) {
     $59 = HEAP32[$58>>2]|0; //@line 70808 "c/sqlite3.c"
     $60 = ($59>>>0)<=($56>>>0); //@line 70808 "c/sqlite3.c"
     $61 = ($$5224|0)==(0); //@line 70808 "c/sqlite3.c"
     $or$cond191 = $61 & $60; //@line 70808 "c/sqlite3.c"
     if (!($or$cond191)) {
      $$5$lcssa = $$5224;
      break L20;
     }
     $62 = HEAP32[513]|0; //@line 70810 "c/sqlite3.c"
     $63 = HEAP32[$8>>2]|0; //@line 70810 "c/sqlite3.c"
     $64 = ((($63)) + 4|0); //@line 70810 "c/sqlite3.c"
     $65 = HEAP32[$64>>2]|0; //@line 70810 "c/sqlite3.c"
     $66 = ((($65)) + 32|0); //@line 70810 "c/sqlite3.c"
     $67 = HEAP32[$66>>2]|0; //@line 70810 "c/sqlite3.c"
     $68 = (($62>>>0) / ($67>>>0))&-1; //@line 70810 "c/sqlite3.c"
     $69 = (($68) + 1)|0; //@line 70810 "c/sqlite3.c"
     $70 = ($59|0)==($69|0); //@line 70810 "c/sqlite3.c"
     if ($70) {
      $$7 = 0;
     } else {
      $71 = (_sqlite3PagerGet($19,$59,$2,2)|0); //@line 70812 "c/sqlite3.c"
      $72 = ($71|0)==(0); //@line 70813 "c/sqlite3.c"
      if ($72) {
       $73 = HEAP32[$2>>2]|0; //@line 70814 "c/sqlite3.c"
       $74 = (_sqlite3PagerGetData($73)|0); //@line 70814 "c/sqlite3.c"
       $75 = (_backupOnePage($0,$59,$74,0)|0); //@line 70814 "c/sqlite3.c"
       $76 = HEAP32[$2>>2]|0; //@line 70815 "c/sqlite3.c"
       _sqlite3PagerUnref($76); //@line 70815 "c/sqlite3.c"
       $$6 = $75;
      } else {
       $$6 = $71;
      }
      $$7 = $$6;
     }
     $77 = HEAP32[$58>>2]|0; //@line 70818 "c/sqlite3.c"
     $78 = (($77) + 1)|0; //@line 70818 "c/sqlite3.c"
     HEAP32[$58>>2] = $78; //@line 70818 "c/sqlite3.c"
     $79 = (($$0185223) + 1)|0; //@line 70808 "c/sqlite3.c"
     $80 = ($79>>>0)<($1>>>0); //@line 70808 "c/sqlite3.c"
     if ($80) {
      $$0185223 = $79;$$5224 = $$7;
     } else {
      $$5$lcssa = $$7;
      break;
     }
    }
   }
  } while(0);
  switch ($$5$lcssa|0) {
  case 0:  {
   $81 = ((($0)) + 36|0); //@line 70821 "c/sqlite3.c"
   HEAP32[$81>>2] = $56; //@line 70821 "c/sqlite3.c"
   $82 = (($56) + 1)|0; //@line 70822 "c/sqlite3.c"
   $83 = ((($0)) + 16|0); //@line 70822 "c/sqlite3.c"
   $84 = HEAP32[$83>>2]|0; //@line 70822 "c/sqlite3.c"
   $85 = (($82) - ($84))|0; //@line 70822 "c/sqlite3.c"
   $86 = ((($0)) + 32|0); //@line 70822 "c/sqlite3.c"
   HEAP32[$86>>2] = $85; //@line 70822 "c/sqlite3.c"
   $87 = ($84>>>0)>($56>>>0); //@line 70823 "c/sqlite3.c"
   if ($87) {
    label = 26;
   } else {
    $88 = ((($0)) + 40|0); //@line 70825 "c/sqlite3.c"
    $89 = HEAP32[$88>>2]|0; //@line 70825 "c/sqlite3.c"
    $90 = ($89|0)==(0); //@line 70825 "c/sqlite3.c"
    if ($90) {
     _attachBackupObject($0); //@line 70826 "c/sqlite3.c"
     $$22 = 0;
    } else {
     $$22 = 0;
    }
   }
   break;
  }
  case 101:  {
   label = 26;
   break;
  }
  default: {
   $$22 = $$5$lcssa;
  }
  }
  L36: do {
   if ((label|0) == 26) {
    $91 = ($56|0)==(0); //@line 70836 "c/sqlite3.c"
    if ($91) {
     $92 = HEAP32[$20>>2]|0; //@line 70837 "c/sqlite3.c"
     $93 = (_sqlite3BtreeNewDb($92)|0); //@line 70837 "c/sqlite3.c"
     switch ($93|0) {
     case 0: case 101:  {
      $$0186202 = 1;
      break;
     }
     default: {
      $$22 = $93;
      break L36;
     }
     }
    } else {
     $$0186202 = $56;
    }
    $94 = HEAP32[$20>>2]|0; //@line 70841 "c/sqlite3.c"
    $95 = ((($0)) + 8|0); //@line 70841 "c/sqlite3.c"
    $96 = HEAP32[$95>>2]|0; //@line 70841 "c/sqlite3.c"
    $97 = (($96) + 1)|0; //@line 70841 "c/sqlite3.c"
    $98 = (_sqlite3BtreeUpdateMeta($94,1,$97)|0); //@line 70841 "c/sqlite3.c"
    $99 = ($98|0)==(0); //@line 70843 "c/sqlite3.c"
    if ($99) {
     $100 = HEAP32[$0>>2]|0; //@line 70844 "c/sqlite3.c"
     $101 = ($100|0)==(0|0); //@line 70844 "c/sqlite3.c"
     if (!($101)) {
      _sqlite3ResetAllSchemasOfConnection($100); //@line 70845 "c/sqlite3.c"
     }
     if ($54) {
      $102 = HEAP32[$20>>2]|0; //@line 70848 "c/sqlite3.c"
      $103 = (_sqlite3BtreeSetVersion($102,2)|0); //@line 70848 "c/sqlite3.c"
      $104 = ($103|0)==(0); //@line 70851 "c/sqlite3.c"
      if (!($104)) {
       $$22 = $103;
       break;
      }
     }
     $105 = ($48|0)<($50|0); //@line 70867 "c/sqlite3.c"
     if ($105) {
      $106 = (($50|0) / ($48|0))&-1; //@line 70868 "c/sqlite3.c"
      $107 = (($$0186202) + -1)|0; //@line 70869 "c/sqlite3.c"
      $108 = (($107) + ($106))|0; //@line 70869 "c/sqlite3.c"
      $109 = (($108|0) / ($106|0))&-1; //@line 70869 "c/sqlite3.c"
      $110 = HEAP32[513]|0; //@line 70870 "c/sqlite3.c"
      $111 = HEAP32[$20>>2]|0; //@line 70870 "c/sqlite3.c"
      $112 = ((($111)) + 4|0); //@line 70870 "c/sqlite3.c"
      $113 = HEAP32[$112>>2]|0; //@line 70870 "c/sqlite3.c"
      $114 = ((($113)) + 32|0); //@line 70870 "c/sqlite3.c"
      $115 = HEAP32[$114>>2]|0; //@line 70870 "c/sqlite3.c"
      $116 = (($110>>>0) / ($115>>>0))&-1; //@line 70870 "c/sqlite3.c"
      $117 = (($116) + 1)|0; //@line 70870 "c/sqlite3.c"
      $118 = ($109|0)==($117|0); //@line 70870 "c/sqlite3.c"
      $119 = $118 << 31 >> 31; //@line 70870 "c/sqlite3.c"
      $spec$select192 = (($109) + ($119))|0; //@line 70870 "c/sqlite3.c"
      $120 = ($48|0)<(0); //@line 70888 "c/sqlite3.c"
      $121 = $120 << 31 >> 31; //@line 70888 "c/sqlite3.c"
      $122 = ($$0186202|0)<(0); //@line 70888 "c/sqlite3.c"
      $123 = $122 << 31 >> 31; //@line 70888 "c/sqlite3.c"
      $124 = (___muldi3(($$0186202|0),($123|0),($48|0),($121|0))|0); //@line 70888 "c/sqlite3.c"
      $125 = tempRet0; //@line 70888 "c/sqlite3.c"
      $126 = (_sqlite3PagerFile($22)|0); //@line 70889 "c/sqlite3.c"
      _sqlite3PagerPagecount($22,$2); //@line 70908 "c/sqlite3.c"
      $127 = HEAP32[$2>>2]|0; //@line 70909 "c/sqlite3.c"
      $128 = ($spec$select192>>>0)>($127>>>0); //@line 70909 "c/sqlite3.c"
      if ($128) {
       label = 42;
      } else {
       $129 = HEAP32[$2>>2]|0;
       $$0184218 = $spec$select192;$$12219 = 0;
       while(1) {
        $130 = HEAP32[513]|0; //@line 70910 "c/sqlite3.c"
        $131 = HEAP32[$20>>2]|0; //@line 70910 "c/sqlite3.c"
        $132 = ((($131)) + 4|0); //@line 70910 "c/sqlite3.c"
        $133 = HEAP32[$132>>2]|0; //@line 70910 "c/sqlite3.c"
        $134 = ((($133)) + 32|0); //@line 70910 "c/sqlite3.c"
        $135 = HEAP32[$134>>2]|0; //@line 70910 "c/sqlite3.c"
        $136 = (($130>>>0) / ($135>>>0))&-1; //@line 70910 "c/sqlite3.c"
        $137 = (($136) + 1)|0; //@line 70910 "c/sqlite3.c"
        $138 = ($$0184218|0)==($137|0); //@line 70910 "c/sqlite3.c"
        if ($138) {
         $$14 = $$12219;
        } else {
         $139 = (_sqlite3PagerGet($22,$$0184218,$3,0)|0); //@line 70912 "c/sqlite3.c"
         $140 = ($139|0)==(0); //@line 70913 "c/sqlite3.c"
         if ($140) {
          $141 = HEAP32[$3>>2]|0; //@line 70914 "c/sqlite3.c"
          $142 = (_sqlite3PagerWrite($141)|0); //@line 70914 "c/sqlite3.c"
          $143 = HEAP32[$3>>2]|0; //@line 70915 "c/sqlite3.c"
          _sqlite3PagerUnref($143); //@line 70915 "c/sqlite3.c"
          $$13 = $142;
         } else {
          $$13 = $139;
         }
         $$14 = $$13;
        }
        $144 = (($$0184218) + 1)|0; //@line 70909 "c/sqlite3.c"
        $145 = ($$14|0)==(0); //@line 70909 "c/sqlite3.c"
        $$not = $145 ^ 1; //@line 70909 "c/sqlite3.c"
        $146 = ($144>>>0)>($129>>>0); //@line 70909 "c/sqlite3.c"
        $or$cond194 = $146 | $$not; //@line 70909 "c/sqlite3.c"
        if ($or$cond194) {
         break;
        } else {
         $$0184218 = $144;$$12219 = $$14;
        }
       }
       if ($145) {
        label = 42;
       } else {
        $$15 = $$14;
       }
      }
      if ((label|0) == 42) {
       $147 = (_sqlite3PagerCommitPhaseOne($22,0,1)|0); //@line 70920 "c/sqlite3.c"
       $$15 = $147;
      }
      $148 = HEAP32[513]|0; //@line 70924 "c/sqlite3.c"
      $149 = (($148) + ($50))|0; //@line 70924 "c/sqlite3.c"
      $150 = ($149|0)<(0); //@line 70924 "c/sqlite3.c"
      $151 = $150 << 31 >> 31; //@line 70924 "c/sqlite3.c"
      $152 = ($125|0)>($151|0); //@line 70924 "c/sqlite3.c"
      $153 = ($124>>>0)>($149>>>0); //@line 70924 "c/sqlite3.c"
      $154 = ($125|0)==($151|0); //@line 70924 "c/sqlite3.c"
      $155 = $154 & $153; //@line 70924 "c/sqlite3.c"
      $156 = $152 | $155; //@line 70924 "c/sqlite3.c"
      $157 = $156 ? $149 : $124; //@line 70924 "c/sqlite3.c"
      $158 = $156 ? $151 : $125; //@line 70924 "c/sqlite3.c"
      $159 = (($148) + ($48))|0; //@line 70926 "c/sqlite3.c"
      $160 = ($159|0)<(0); //@line 70926 "c/sqlite3.c"
      $161 = $160 << 31 >> 31; //@line 70926 "c/sqlite3.c"
      $162 = ($$15|0)==(0); //@line 70927 "c/sqlite3.c"
      $163 = ($158|0)>($161|0); //@line 70927 "c/sqlite3.c"
      $164 = ($157>>>0)>($159>>>0); //@line 70927 "c/sqlite3.c"
      $165 = ($158|0)==($161|0); //@line 70927 "c/sqlite3.c"
      $166 = $165 & $164; //@line 70927 "c/sqlite3.c"
      $167 = $163 | $166; //@line 70927 "c/sqlite3.c"
      $or$cond195215 = $167 & $162; //@line 70927 "c/sqlite3.c"
      if ($or$cond195215) {
       $168 = $159;$169 = $161;
       while(1) {
        HEAP32[$3>>2] = 0; //@line 70930 "c/sqlite3.c"
        $170 = (___divdi3(($168|0),($169|0),($48|0),($121|0))|0); //@line 70931 "c/sqlite3.c"
        $171 = tempRet0; //@line 70931 "c/sqlite3.c"
        $172 = (($170) + 1)|0; //@line 70931 "c/sqlite3.c"
        $173 = (_sqlite3PagerGet($19,$172,$3,0)|0); //@line 70932 "c/sqlite3.c"
        $174 = ($173|0)==(0); //@line 70933 "c/sqlite3.c"
        if ($174) {
         $175 = HEAP32[$3>>2]|0; //@line 70934 "c/sqlite3.c"
         $176 = (_sqlite3PagerGetData($175)|0); //@line 70934 "c/sqlite3.c"
         $177 = (_sqlite3OsWrite($126,$176,$48,$168,$169)|0); //@line 70935 "c/sqlite3.c"
         $$17 = $177;
        } else {
         $$17 = $173;
        }
        $178 = HEAP32[$3>>2]|0; //@line 70937 "c/sqlite3.c"
        _sqlite3PagerUnref($178); //@line 70937 "c/sqlite3.c"
        $179 = (_i64Add(($168|0),($169|0),($48|0),($121|0))|0); //@line 70928 "c/sqlite3.c"
        $180 = tempRet0; //@line 70928 "c/sqlite3.c"
        $181 = ($$17|0)==(0); //@line 70927 "c/sqlite3.c"
        $182 = ($180|0)<($158|0); //@line 70927 "c/sqlite3.c"
        $183 = ($179>>>0)<($157>>>0); //@line 70927 "c/sqlite3.c"
        $184 = ($180|0)==($158|0); //@line 70927 "c/sqlite3.c"
        $185 = $184 & $183; //@line 70927 "c/sqlite3.c"
        $186 = $182 | $185; //@line 70927 "c/sqlite3.c"
        $or$cond195 = $186 & $181; //@line 70927 "c/sqlite3.c"
        if ($or$cond195) {
         $168 = $179;$169 = $180;
        } else {
         $$16$lcssa = $$17;$$lcssa = $181;
         break;
        }
       }
      } else {
       $$16$lcssa = $$15;$$lcssa = $162;
      }
      if ($$lcssa) {
       $187 = (_backupTruncateFile($126,$124,$125)|0); //@line 70940 "c/sqlite3.c"
       $188 = ($187|0)==(0); //@line 70944 "c/sqlite3.c"
       if ($188) {
        $189 = (_sqlite3PagerSync($22,0)|0); //@line 70945 "c/sqlite3.c"
        $$19 = $189;
       } else {
        $$19 = $187;
       }
      } else {
       $$19 = $$16$lcssa;
      }
      $$20 = $$19;
     } else {
      $190 = (($48|0) / ($50|0))&-1; //@line 70874 "c/sqlite3.c"
      $191 = Math_imul($190, $$0186202)|0; //@line 70874 "c/sqlite3.c"
      _sqlite3PagerTruncateImage($22,$191); //@line 70948 "c/sqlite3.c"
      $192 = (_sqlite3PagerCommitPhaseOne($22,0,0)|0); //@line 70949 "c/sqlite3.c"
      $$20 = $192;
     }
     $193 = ($$20|0)==(0); //@line 70953 "c/sqlite3.c"
     if ($193) {
      $194 = HEAP32[$20>>2]|0; //@line 70954 "c/sqlite3.c"
      $195 = (_sqlite3BtreeCommitPhaseTwo($194,0)|0); //@line 70954 "c/sqlite3.c"
      $196 = ($195|0)==(0); //@line 70954 "c/sqlite3.c"
      $spec$store$select = $196 ? 101 : $195; //@line 70953 "c/sqlite3.c"
      $$22 = $spec$store$select;
     } else {
      $$22 = $$20;
     }
    } else {
     $$22 = $98;
    }
   }
  } while(0);
  $197 = ($$0187|0)==(0); //@line 70966 "c/sqlite3.c"
  if (!($197)) {
   $198 = HEAP32[$8>>2]|0; //@line 70968 "c/sqlite3.c"
   (_sqlite3BtreeCommitPhaseOne($198,0)|0); //@line 70968 "c/sqlite3.c"
   $199 = HEAP32[$8>>2]|0; //@line 70969 "c/sqlite3.c"
   (_sqlite3BtreeCommitPhaseTwo($199,0)|0); //@line 70969 "c/sqlite3.c"
  }
  $200 = ($$22|0)==(3082); //@line 70973 "c/sqlite3.c"
  $spec$select196 = $200 ? 7 : $$22; //@line 70973 "c/sqlite3.c"
  HEAP32[$14>>2] = $spec$select196; //@line 70976 "c/sqlite3.c"
  $$24 = $spec$select196;
 } else {
  $$24 = $15;
 }
 $201 = HEAP32[$0>>2]|0; //@line 70978 "c/sqlite3.c"
 $202 = ($201|0)==(0|0); //@line 70978 "c/sqlite3.c"
 if ($202) {
  $205 = HEAP32[$8>>2]|0; //@line 70981 "c/sqlite3.c"
  _sqlite3BtreeLeave($205); //@line 70981 "c/sqlite3.c"
  $206 = HEAP32[$4>>2]|0; //@line 70982 "c/sqlite3.c"
  $207 = ((($206)) + 12|0); //@line 70982 "c/sqlite3.c"
  $208 = HEAP32[$207>>2]|0; //@line 70982 "c/sqlite3.c"
  _sqlite3_mutex_leave($208); //@line 70982 "c/sqlite3.c"
  STACKTOP = sp;return ($$24|0); //@line 70983 "c/sqlite3.c"
 }
 $203 = ((($201)) + 12|0); //@line 70979 "c/sqlite3.c"
 $204 = HEAP32[$203>>2]|0; //@line 70979 "c/sqlite3.c"
 _sqlite3_mutex_leave($204); //@line 70979 "c/sqlite3.c"
 $205 = HEAP32[$8>>2]|0; //@line 70981 "c/sqlite3.c"
 _sqlite3BtreeLeave($205); //@line 70981 "c/sqlite3.c"
 $206 = HEAP32[$4>>2]|0; //@line 70982 "c/sqlite3.c"
 $207 = ((($206)) + 12|0); //@line 70982 "c/sqlite3.c"
 $208 = HEAP32[$207>>2]|0; //@line 70982 "c/sqlite3.c"
 _sqlite3_mutex_leave($208); //@line 70982 "c/sqlite3.c"
 STACKTOP = sp;return ($$24|0); //@line 70983 "c/sqlite3.c"
}
function _sqlite3_create_function_v2($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$030 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $9 = ((($0)) + 12|0); //@line 145111 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 145111 "c/sqlite3.c"
 _sqlite3_mutex_enter($10); //@line 145111 "c/sqlite3.c"
 $11 = ($8|0)==(0|0); //@line 145112 "c/sqlite3.c"
 do {
  if ($11) {
   $12 = (_sqlite3CreateFunc($0,$1,$2,$3,$4,$5,$6,$7,0)|0); //@line 145121 "c/sqlite3.c"
   $$030 = $12;
  } else {
   $13 = (_sqlite3DbMallocZero($0,12,0)|0); //@line 145113 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 145114 "c/sqlite3.c"
   if ($14) {
    FUNCTION_TABLE_vi[$8 & 127]($4); //@line 145115 "c/sqlite3.c"
    $$030 = 1;
    break;
   }
   $15 = ((($13)) + 4|0); //@line 145118 "c/sqlite3.c"
   HEAP32[$15>>2] = $8; //@line 145118 "c/sqlite3.c"
   $16 = ((($13)) + 8|0); //@line 145119 "c/sqlite3.c"
   HEAP32[$16>>2] = $4; //@line 145119 "c/sqlite3.c"
   $17 = (_sqlite3CreateFunc($0,$1,$2,$3,$4,$5,$6,$7,$13)|0); //@line 145121 "c/sqlite3.c"
   $18 = HEAP32[$13>>2]|0; //@line 145122 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 145122 "c/sqlite3.c"
   if ($19) {
    FUNCTION_TABLE_vi[$8 & 127]($4); //@line 145124 "c/sqlite3.c"
    _sqlite3DbFree($0,$13); //@line 145125 "c/sqlite3.c"
    $$030 = $17;
   } else {
    $$030 = $17;
   }
  }
 } while(0);
 $20 = (_sqlite3ApiExit($0,$$030)|0); //@line 145129 "c/sqlite3.c"
 $21 = HEAP32[$9>>2]|0; //@line 145130 "c/sqlite3.c"
 _sqlite3_mutex_leave($21); //@line 145130 "c/sqlite3.c"
 return ($20|0); //@line 145131 "c/sqlite3.c"
}
function _sqlite3_db_config($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $$04547$lcssa = 0, $$1 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $7 = 0, $8 = 0, $9 = 0, $arglist_current = 0, $arglist_current11 = 0, $arglist_current14 = 0, $arglist_current2 = 0, $arglist_current5 = 0, $arglist_current8 = 0, $arglist_next = 0, $arglist_next12 = 0, $arglist_next15 = 0, $arglist_next3 = 0, $arglist_next6 = 0;
 var $arglist_next9 = 0, $expanded = 0, $expanded10 = 0, $expanded12 = 0, $expanded13 = 0, $expanded14 = 0, $expanded16 = 0, $expanded17 = 0, $expanded19 = 0, $expanded20 = 0, $expanded21 = 0, $expanded23 = 0, $expanded24 = 0, $expanded26 = 0, $expanded27 = 0, $expanded28 = 0, $expanded3 = 0, $expanded30 = 0, $expanded31 = 0, $expanded33 = 0;
 var $expanded34 = 0, $expanded35 = 0, $expanded37 = 0, $expanded38 = 0, $expanded40 = 0, $expanded41 = 0, $expanded42 = 0, $expanded5 = 0, $expanded6 = 0, $expanded7 = 0, $expanded9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$2>>2] = $varargs; //@line 144158 "c/sqlite3.c"
 switch ($1|0) {
 case 1000:  {
  $arglist_current = HEAP32[$2>>2]|0; //@line 144163 "c/sqlite3.c"
  $3 = $arglist_current; //@line 144163 "c/sqlite3.c"
  $4 = ((0) + 4|0);
  $expanded3 = $4;
  $expanded = (($expanded3) - 1)|0;
  $5 = (($3) + ($expanded))|0; //@line 144163 "c/sqlite3.c"
  $6 = ((0) + 4|0);
  $expanded7 = $6;
  $expanded6 = (($expanded7) - 1)|0;
  $expanded5 = $expanded6 ^ -1;
  $7 = $5 & $expanded5; //@line 144163 "c/sqlite3.c"
  $8 = $7; //@line 144163 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 144163 "c/sqlite3.c"
  $arglist_next = ((($8)) + 4|0); //@line 144163 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next; //@line 144163 "c/sqlite3.c"
  $10 = ((($0)) + 16|0); //@line 144163 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 144163 "c/sqlite3.c"
  HEAP32[$11>>2] = $9; //@line 144163 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 144213 "c/sqlite3.c"
  break;
 }
 case 1001:  {
  $arglist_current2 = HEAP32[$2>>2]|0; //@line 144168 "c/sqlite3.c"
  $12 = $arglist_current2; //@line 144168 "c/sqlite3.c"
  $13 = ((0) + 4|0);
  $expanded10 = $13;
  $expanded9 = (($expanded10) - 1)|0;
  $14 = (($12) + ($expanded9))|0; //@line 144168 "c/sqlite3.c"
  $15 = ((0) + 4|0);
  $expanded14 = $15;
  $expanded13 = (($expanded14) - 1)|0;
  $expanded12 = $expanded13 ^ -1;
  $16 = $14 & $expanded12; //@line 144168 "c/sqlite3.c"
  $17 = $16; //@line 144168 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 144168 "c/sqlite3.c"
  $arglist_next3 = ((($17)) + 4|0); //@line 144168 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next3; //@line 144168 "c/sqlite3.c"
  $arglist_current5 = HEAP32[$2>>2]|0; //@line 144169 "c/sqlite3.c"
  $19 = $arglist_current5; //@line 144169 "c/sqlite3.c"
  $20 = ((0) + 4|0);
  $expanded17 = $20;
  $expanded16 = (($expanded17) - 1)|0;
  $21 = (($19) + ($expanded16))|0; //@line 144169 "c/sqlite3.c"
  $22 = ((0) + 4|0);
  $expanded21 = $22;
  $expanded20 = (($expanded21) - 1)|0;
  $expanded19 = $expanded20 ^ -1;
  $23 = $21 & $expanded19; //@line 144169 "c/sqlite3.c"
  $24 = $23; //@line 144169 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 144169 "c/sqlite3.c"
  $arglist_next6 = ((($24)) + 4|0); //@line 144169 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next6; //@line 144169 "c/sqlite3.c"
  $arglist_current8 = HEAP32[$2>>2]|0; //@line 144170 "c/sqlite3.c"
  $26 = $arglist_current8; //@line 144170 "c/sqlite3.c"
  $27 = ((0) + 4|0);
  $expanded24 = $27;
  $expanded23 = (($expanded24) - 1)|0;
  $28 = (($26) + ($expanded23))|0; //@line 144170 "c/sqlite3.c"
  $29 = ((0) + 4|0);
  $expanded28 = $29;
  $expanded27 = (($expanded28) - 1)|0;
  $expanded26 = $expanded27 ^ -1;
  $30 = $28 & $expanded26; //@line 144170 "c/sqlite3.c"
  $31 = $30; //@line 144170 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 144170 "c/sqlite3.c"
  $arglist_next9 = ((($31)) + 4|0); //@line 144170 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next9; //@line 144170 "c/sqlite3.c"
  $33 = (_setupLookaside($0,$18,$25,$32)|0); //@line 144171 "c/sqlite3.c"
  $$1 = $33;
  STACKTOP = sp;return ($$1|0); //@line 144213 "c/sqlite3.c"
  break;
 }
 case 1002:  {
  $$04547$lcssa = 0;
  break;
 }
 case 1003:  {
  $$04547$lcssa = 1;
  break;
 }
 case 1004:  {
  $$04547$lcssa = 2;
  break;
 }
 case 1005:  {
  $$04547$lcssa = 3;
  break;
 }
 case 1006:  {
  $$04547$lcssa = 4;
  break;
 }
 case 1007:  {
  $$04547$lcssa = 5;
  break;
 }
 case 1008:  {
  $$04547$lcssa = 6;
  break;
 }
 default: {
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 144213 "c/sqlite3.c"
 }
 }
 $arglist_current11 = HEAP32[$2>>2]|0; //@line 144191 "c/sqlite3.c"
 $34 = $arglist_current11; //@line 144191 "c/sqlite3.c"
 $35 = ((0) + 4|0);
 $expanded31 = $35;
 $expanded30 = (($expanded31) - 1)|0;
 $36 = (($34) + ($expanded30))|0; //@line 144191 "c/sqlite3.c"
 $37 = ((0) + 4|0);
 $expanded35 = $37;
 $expanded34 = (($expanded35) - 1)|0;
 $expanded33 = $expanded34 ^ -1;
 $38 = $36 & $expanded33; //@line 144191 "c/sqlite3.c"
 $39 = $38; //@line 144191 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 144191 "c/sqlite3.c"
 $arglist_next12 = ((($39)) + 4|0); //@line 144191 "c/sqlite3.c"
 HEAP32[$2>>2] = $arglist_next12; //@line 144191 "c/sqlite3.c"
 $arglist_current14 = HEAP32[$2>>2]|0; //@line 144192 "c/sqlite3.c"
 $41 = $arglist_current14; //@line 144192 "c/sqlite3.c"
 $42 = ((0) + 4|0);
 $expanded38 = $42;
 $expanded37 = (($expanded38) - 1)|0;
 $43 = (($41) + ($expanded37))|0; //@line 144192 "c/sqlite3.c"
 $44 = ((0) + 4|0);
 $expanded42 = $44;
 $expanded41 = (($expanded42) - 1)|0;
 $expanded40 = $expanded41 ^ -1;
 $45 = $43 & $expanded40; //@line 144192 "c/sqlite3.c"
 $46 = $45; //@line 144192 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 144192 "c/sqlite3.c"
 $arglist_next15 = ((($46)) + 4|0); //@line 144192 "c/sqlite3.c"
 HEAP32[$2>>2] = $arglist_next15; //@line 144192 "c/sqlite3.c"
 $48 = ((($0)) + 28|0); //@line 144193 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 144193 "c/sqlite3.c"
 $50 = ($40|0)>(0); //@line 144194 "c/sqlite3.c"
 if ($50) {
  $51 = (((6408 + ($$04547$lcssa<<3)|0)) + 4|0); //@line 144195 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 144195 "c/sqlite3.c"
  $53 = $52 | $49; //@line 144195 "c/sqlite3.c"
  $$sink = $53;
  label = 14;
 } else {
  $54 = ($40|0)==(0); //@line 144196 "c/sqlite3.c"
  if ($54) {
   $55 = (((6408 + ($$04547$lcssa<<3)|0)) + 4|0); //@line 144197 "c/sqlite3.c"
   $56 = HEAP32[$55>>2]|0; //@line 144197 "c/sqlite3.c"
   $57 = $56 ^ -1; //@line 144197 "c/sqlite3.c"
   $58 = $49 & $57; //@line 144197 "c/sqlite3.c"
   $$sink = $58;
   label = 14;
  }
 }
 if ((label|0) == 14) {
  HEAP32[$48>>2] = $$sink;
 }
 $59 = HEAP32[$48>>2]|0; //@line 144199 "c/sqlite3.c"
 $60 = ($49|0)==($59|0); //@line 144199 "c/sqlite3.c"
 if (!($60)) {
  _sqlite3ExpirePreparedStatements($0); //@line 144200 "c/sqlite3.c"
 }
 $61 = ($47|0)==(0|0); //@line 144202 "c/sqlite3.c"
 if ($61) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 144213 "c/sqlite3.c"
 }
 $62 = HEAP32[$48>>2]|0; //@line 144203 "c/sqlite3.c"
 $63 = (((6408 + ($$04547$lcssa<<3)|0)) + 4|0); //@line 144203 "c/sqlite3.c"
 $64 = HEAP32[$63>>2]|0; //@line 144203 "c/sqlite3.c"
 $65 = $64 & $62; //@line 144203 "c/sqlite3.c"
 $66 = ($65|0)!=(0); //@line 144203 "c/sqlite3.c"
 $67 = $66&1; //@line 144203 "c/sqlite3.c"
 HEAP32[$47>>2] = $67; //@line 144203 "c/sqlite3.c"
 $$1 = 0;
 STACKTOP = sp;return ($$1|0); //@line 144213 "c/sqlite3.c"
}
function _sqlite3_db_mutex($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 144095 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144095 "c/sqlite3.c"
 return ($2|0); //@line 144095 "c/sqlite3.c"
}
function _sqlite3_db_status($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0122151 = 0, $$0123 = 0, $$0123146 = 0, $$0123147 = 0, $$0124 = 0, $$0124133 = 0, $$0124134 = 0, $$0125 = 0, $$0126142 = 0, $$0127 = 0, $$0128$lcssa = 0, $$0128132 = 0, $$0130131 = 0, $$1 = 0, $$1129 = 0, $$1138 = 0, $$1139 = 0, $10 = 0, $100 = 0;
 var $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0;
 var $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0;
 var $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0;
 var $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = ((($0)) + 12|0); //@line 19389 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 19389 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 19389 "c/sqlite3.c"
 switch ($1|0) {
 case 0:  {
  $8 = (_sqlite3LookasideUsed($0,$3)|0); //@line 19392 "c/sqlite3.c"
  HEAP32[$2>>2] = $8; //@line 19392 "c/sqlite3.c"
  $9 = ($4|0)==(0); //@line 19393 "c/sqlite3.c"
  if ($9) {
   $$0 = 0;
   $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
   _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
   STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  }
  $10 = ((($0)) + 292|0); //@line 19394 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 19394 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 19395 "c/sqlite3.c"
  if ($12) {
   $$0 = 0;
   $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
   _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
   STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  }
  $$0125 = $11;
  while(1) {
   $13 = HEAP32[$$0125>>2]|0; //@line 19396 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 19396 "c/sqlite3.c"
   if ($14) {
    break;
   } else {
    $$0125 = $13;
   }
  }
  $15 = ((($0)) + 288|0); //@line 19397 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 19397 "c/sqlite3.c"
  HEAP32[$$0125>>2] = $16; //@line 19397 "c/sqlite3.c"
  $17 = HEAP32[$10>>2]|0; //@line 19398 "c/sqlite3.c"
  HEAP32[$15>>2] = $17; //@line 19398 "c/sqlite3.c"
  HEAP32[$10>>2] = 0; //@line 19399 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 case 6: case 5: case 4:  {
  HEAP32[$2>>2] = 0; //@line 19413 "c/sqlite3.c"
  $18 = (($1) + -4)|0; //@line 19414 "c/sqlite3.c"
  $19 = (((($0)) + 276|0) + ($18<<2)|0); //@line 19414 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 19414 "c/sqlite3.c"
  HEAP32[$3>>2] = $20; //@line 19414 "c/sqlite3.c"
  $21 = ($4|0)==(0); //@line 19415 "c/sqlite3.c"
  if ($21) {
   $$0 = 0;
   $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
   _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
   STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  }
  HEAP32[$19>>2] = 0; //@line 19416 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 case 1: case 11:  {
  _sqlite3BtreeEnterAll($0); //@line 19430 "c/sqlite3.c"
  $22 = ((($0)) + 20|0); //@line 19431 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 19431 "c/sqlite3.c"
  $24 = ($23|0)>(0); //@line 19431 "c/sqlite3.c"
  if ($24) {
   $25 = ((($0)) + 16|0);
   $26 = ($1|0)==(11);
   $$0128132 = 0;$$0130131 = 0;
   while(1) {
    $27 = HEAP32[$25>>2]|0; //@line 19432 "c/sqlite3.c"
    $28 = (((($27) + ($$0130131<<4)|0)) + 4|0); //@line 19432 "c/sqlite3.c"
    $29 = HEAP32[$28>>2]|0; //@line 19432 "c/sqlite3.c"
    $30 = ($29|0)==(0|0); //@line 19433 "c/sqlite3.c"
    if ($30) {
     $$1129 = $$0128132;
    } else {
     $31 = (_sqlite3BtreePager($29)|0); //@line 19434 "c/sqlite3.c"
     $32 = (_sqlite3PagerMemUsed($31)|0); //@line 19435 "c/sqlite3.c"
     if ($26) {
      $33 = (_sqlite3BtreeConnectionCount($29)|0); //@line 19437 "c/sqlite3.c"
      $34 = (($32|0) / ($33|0))&-1; //@line 19437 "c/sqlite3.c"
      $$0127 = $34;
     } else {
      $$0127 = $32;
     }
     $35 = (($$0127) + ($$0128132))|0; //@line 19439 "c/sqlite3.c"
     $$1129 = $35;
    }
    $36 = (($$0130131) + 1)|0; //@line 19431 "c/sqlite3.c"
    $37 = HEAP32[$22>>2]|0; //@line 19431 "c/sqlite3.c"
    $38 = ($36|0)<($37|0); //@line 19431 "c/sqlite3.c"
    if ($38) {
     $$0128132 = $$1129;$$0130131 = $36;
    } else {
     $$0128$lcssa = $$1129;
     break;
    }
   }
  } else {
   $$0128$lcssa = 0;
  }
  _sqlite3BtreeLeaveAll($0); //@line 19442 "c/sqlite3.c"
  HEAP32[$2>>2] = $$0128$lcssa; //@line 19443 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 19444 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 case 2:  {
  HEAP32[$5>>2] = 0; //@line 19455 "c/sqlite3.c"
  _sqlite3BtreeEnterAll($0); //@line 19457 "c/sqlite3.c"
  $39 = ((($0)) + 464|0); //@line 19458 "c/sqlite3.c"
  HEAP32[$39>>2] = $5; //@line 19458 "c/sqlite3.c"
  $40 = ((($0)) + 20|0); //@line 19459 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 19459 "c/sqlite3.c"
  $42 = ($41|0)>(0); //@line 19459 "c/sqlite3.c"
  if ($42) {
   $43 = ((($0)) + 16|0);
   $$0126142 = 0;
   while(1) {
    $44 = HEAP32[$43>>2]|0; //@line 19460 "c/sqlite3.c"
    $45 = (((($44) + ($$0126142<<4)|0)) + 12|0); //@line 19460 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 19460 "c/sqlite3.c"
    $47 = ($46|0)==(0|0); //@line 19461 "c/sqlite3.c"
    if (!($47)) {
     $48 = HEAP32[(68)>>2]|0; //@line 19464 "c/sqlite3.c"
     $49 = (FUNCTION_TABLE_ii[$48 & 255](16)|0); //@line 19464 "c/sqlite3.c"
     $50 = ((($46)) + 12|0); //@line 19465 "c/sqlite3.c"
     $51 = HEAP32[$50>>2]|0; //@line 19465 "c/sqlite3.c"
     $52 = ((($46)) + 44|0); //@line 19466 "c/sqlite3.c"
     $53 = HEAP32[$52>>2]|0; //@line 19466 "c/sqlite3.c"
     $54 = (($53) + ($51))|0; //@line 19466 "c/sqlite3.c"
     $55 = ((($46)) + 28|0); //@line 19467 "c/sqlite3.c"
     $56 = HEAP32[$55>>2]|0; //@line 19467 "c/sqlite3.c"
     $57 = (($54) + ($56))|0; //@line 19467 "c/sqlite3.c"
     $58 = ((($46)) + 60|0); //@line 19468 "c/sqlite3.c"
     $59 = HEAP32[$58>>2]|0; //@line 19468 "c/sqlite3.c"
     $60 = (($57) + ($59))|0; //@line 19468 "c/sqlite3.c"
     $61 = Math_imul($60, $49)|0; //@line 19464 "c/sqlite3.c"
     $62 = HEAP32[$5>>2]|0; //@line 19464 "c/sqlite3.c"
     $63 = (($61) + ($62))|0; //@line 19464 "c/sqlite3.c"
     HEAP32[$5>>2] = $63; //@line 19464 "c/sqlite3.c"
     $64 = ((($46)) + 20|0); //@line 19470 "c/sqlite3.c"
     $65 = HEAP32[$64>>2]|0; //@line 19470 "c/sqlite3.c"
     $66 = (_sqlite3_msize($65)|0); //@line 19470 "c/sqlite3.c"
     $67 = tempRet0; //@line 19470 "c/sqlite3.c"
     $68 = HEAP32[$5>>2]|0; //@line 19470 "c/sqlite3.c"
     $69 = (($68) + ($66))|0; //@line 19470 "c/sqlite3.c"
     HEAP32[$5>>2] = $69; //@line 19470 "c/sqlite3.c"
     $70 = ((($46)) + 52|0); //@line 19471 "c/sqlite3.c"
     $71 = HEAP32[$70>>2]|0; //@line 19471 "c/sqlite3.c"
     $72 = (_sqlite3_msize($71)|0); //@line 19471 "c/sqlite3.c"
     $73 = tempRet0; //@line 19471 "c/sqlite3.c"
     $74 = HEAP32[$5>>2]|0; //@line 19471 "c/sqlite3.c"
     $75 = (($74) + ($72))|0; //@line 19471 "c/sqlite3.c"
     HEAP32[$5>>2] = $75; //@line 19471 "c/sqlite3.c"
     $76 = ((($46)) + 36|0); //@line 19472 "c/sqlite3.c"
     $77 = HEAP32[$76>>2]|0; //@line 19472 "c/sqlite3.c"
     $78 = (_sqlite3_msize($77)|0); //@line 19472 "c/sqlite3.c"
     $79 = tempRet0; //@line 19472 "c/sqlite3.c"
     $80 = HEAP32[$5>>2]|0; //@line 19472 "c/sqlite3.c"
     $81 = (($80) + ($78))|0; //@line 19472 "c/sqlite3.c"
     HEAP32[$5>>2] = $81; //@line 19472 "c/sqlite3.c"
     $82 = ((($46)) + 68|0); //@line 19473 "c/sqlite3.c"
     $83 = HEAP32[$82>>2]|0; //@line 19473 "c/sqlite3.c"
     $84 = (_sqlite3_msize($83)|0); //@line 19473 "c/sqlite3.c"
     $85 = tempRet0; //@line 19473 "c/sqlite3.c"
     $86 = HEAP32[$5>>2]|0; //@line 19473 "c/sqlite3.c"
     $87 = (($86) + ($84))|0; //@line 19473 "c/sqlite3.c"
     HEAP32[$5>>2] = $87; //@line 19473 "c/sqlite3.c"
     $88 = ((($46)) + 48|0); //@line 19475 "c/sqlite3.c"
     $$0124133 = HEAP32[$88>>2]|0;
     $89 = ($$0124133|0)==(0|0); //@line 19475 "c/sqlite3.c"
     if (!($89)) {
      $$0124134 = $$0124133;
      while(1) {
       $90 = ((($$0124134)) + 8|0); //@line 19476 "c/sqlite3.c"
       $91 = HEAP32[$90>>2]|0; //@line 19476 "c/sqlite3.c"
       _sqlite3DeleteTrigger($0,$91); //@line 19476 "c/sqlite3.c"
       $$0124 = HEAP32[$$0124134>>2]|0;
       $92 = ($$0124|0)==(0|0); //@line 19475 "c/sqlite3.c"
       if ($92) {
        break;
       } else {
        $$0124134 = $$0124;
       }
      }
     }
     $93 = ((($46)) + 16|0); //@line 19478 "c/sqlite3.c"
     $$1138 = HEAP32[$93>>2]|0;
     $94 = ($$1138|0)==(0|0); //@line 19478 "c/sqlite3.c"
     if (!($94)) {
      $$1139 = $$1138;
      while(1) {
       $95 = ((($$1139)) + 8|0); //@line 19479 "c/sqlite3.c"
       $96 = HEAP32[$95>>2]|0; //@line 19479 "c/sqlite3.c"
       _sqlite3DeleteTable($0,$96); //@line 19479 "c/sqlite3.c"
       $$1 = HEAP32[$$1139>>2]|0;
       $97 = ($$1|0)==(0|0); //@line 19478 "c/sqlite3.c"
       if ($97) {
        break;
       } else {
        $$1139 = $$1;
       }
      }
     }
    }
    $98 = (($$0126142) + 1)|0; //@line 19459 "c/sqlite3.c"
    $99 = HEAP32[$40>>2]|0; //@line 19459 "c/sqlite3.c"
    $100 = ($98|0)<($99|0); //@line 19459 "c/sqlite3.c"
    if ($100) {
     $$0126142 = $98;
    } else {
     break;
    }
   }
  }
  HEAP32[$39>>2] = 0; //@line 19483 "c/sqlite3.c"
  _sqlite3BtreeLeaveAll($0); //@line 19484 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 19486 "c/sqlite3.c"
  $101 = HEAP32[$5>>2]|0; //@line 19487 "c/sqlite3.c"
  HEAP32[$2>>2] = $101; //@line 19487 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 case 3:  {
  HEAP32[$5>>2] = 0; //@line 19498 "c/sqlite3.c"
  $102 = ((($0)) + 464|0); //@line 19500 "c/sqlite3.c"
  HEAP32[$102>>2] = $5; //@line 19500 "c/sqlite3.c"
  $103 = ((($0)) + 4|0); //@line 19501 "c/sqlite3.c"
  $$0123146 = HEAP32[$103>>2]|0;
  $104 = ($$0123146|0)==(0|0); //@line 19501 "c/sqlite3.c"
  if (!($104)) {
   $$0123147 = $$0123146;
   while(1) {
    _sqlite3VdbeClearObject($0,$$0123147); //@line 19502 "c/sqlite3.c"
    _sqlite3DbFree($0,$$0123147); //@line 19503 "c/sqlite3.c"
    $105 = ((($$0123147)) + 8|0); //@line 19501 "c/sqlite3.c"
    $$0123 = HEAP32[$105>>2]|0;
    $106 = ($$0123|0)==(0|0); //@line 19501 "c/sqlite3.c"
    if ($106) {
     break;
    } else {
     $$0123147 = $$0123;
    }
   }
  }
  HEAP32[$102>>2] = 0; //@line 19505 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 19507 "c/sqlite3.c"
  $107 = HEAP32[$5>>2]|0; //@line 19508 "c/sqlite3.c"
  HEAP32[$2>>2] = $107; //@line 19508 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 case 9: case 8: case 7:  {
  HEAP32[$5>>2] = 0; //@line 19522 "c/sqlite3.c"
  $108 = ((($0)) + 20|0); //@line 19526 "c/sqlite3.c"
  $109 = HEAP32[$108>>2]|0; //@line 19526 "c/sqlite3.c"
  $110 = ($109|0)>(0); //@line 19526 "c/sqlite3.c"
  if ($110) {
   $111 = ((($0)) + 16|0);
   $$0122151 = 0;
   while(1) {
    $112 = HEAP32[$111>>2]|0; //@line 19527 "c/sqlite3.c"
    $113 = (((($112) + ($$0122151<<4)|0)) + 4|0); //@line 19527 "c/sqlite3.c"
    $114 = HEAP32[$113>>2]|0; //@line 19527 "c/sqlite3.c"
    $115 = ($114|0)==(0|0); //@line 19527 "c/sqlite3.c"
    if (!($115)) {
     $116 = (_sqlite3BtreePager($114)|0); //@line 19528 "c/sqlite3.c"
     _sqlite3PagerCacheStat($116,$1,$4,$5); //@line 19529 "c/sqlite3.c"
    }
    $117 = (($$0122151) + 1)|0; //@line 19526 "c/sqlite3.c"
    $118 = HEAP32[$108>>2]|0; //@line 19526 "c/sqlite3.c"
    $119 = ($117|0)<($118|0); //@line 19526 "c/sqlite3.c"
    if ($119) {
     $$0122151 = $117;
    } else {
     break;
    }
   }
  }
  HEAP32[$3>>2] = 0; //@line 19532 "c/sqlite3.c"
  $120 = HEAP32[$5>>2]|0; //@line 19535 "c/sqlite3.c"
  HEAP32[$2>>2] = $120; //@line 19535 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 case 10:  {
  HEAP32[$3>>2] = 0; //@line 19544 "c/sqlite3.c"
  $121 = ((($0)) + 456|0); //@line 19545 "c/sqlite3.c"
  $122 = $121; //@line 19545 "c/sqlite3.c"
  $123 = $122; //@line 19545 "c/sqlite3.c"
  $124 = HEAP32[$123>>2]|0; //@line 19545 "c/sqlite3.c"
  $125 = (($122) + 4)|0; //@line 19545 "c/sqlite3.c"
  $126 = $125; //@line 19545 "c/sqlite3.c"
  $127 = HEAP32[$126>>2]|0; //@line 19545 "c/sqlite3.c"
  $128 = ($127|0)>(0); //@line 19545 "c/sqlite3.c"
  $129 = ($124>>>0)>(0); //@line 19545 "c/sqlite3.c"
  $130 = ($127|0)==(0); //@line 19545 "c/sqlite3.c"
  $131 = $130 & $129; //@line 19545 "c/sqlite3.c"
  $132 = $128 | $131; //@line 19545 "c/sqlite3.c"
  if ($132) {
   $145 = 1;
  } else {
   $133 = ((($0)) + 448|0); //@line 19545 "c/sqlite3.c"
   $134 = $133; //@line 19545 "c/sqlite3.c"
   $135 = $134; //@line 19545 "c/sqlite3.c"
   $136 = HEAP32[$135>>2]|0; //@line 19545 "c/sqlite3.c"
   $137 = (($134) + 4)|0; //@line 19545 "c/sqlite3.c"
   $138 = $137; //@line 19545 "c/sqlite3.c"
   $139 = HEAP32[$138>>2]|0; //@line 19545 "c/sqlite3.c"
   $140 = ($139|0)>(0); //@line 19545 "c/sqlite3.c"
   $141 = ($136>>>0)>(0); //@line 19545 "c/sqlite3.c"
   $142 = ($139|0)==(0); //@line 19545 "c/sqlite3.c"
   $143 = $142 & $141; //@line 19545 "c/sqlite3.c"
   $144 = $140 | $143; //@line 19545 "c/sqlite3.c"
   $phitmp = $144&1; //@line 19545 "c/sqlite3.c"
   $145 = $phitmp;
  }
  HEAP32[$2>>2] = $145; //@line 19545 "c/sqlite3.c"
  $$0 = 0;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
  break;
 }
 default: {
  $$0 = 1;
  $146 = HEAP32[$6>>2]|0; //@line 19553 "c/sqlite3.c"
  _sqlite3_mutex_leave($146); //@line 19553 "c/sqlite3.c"
  STACKTOP = sp;return ($$0|0); //@line 19554 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3_extended_errcode($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 145693 "c/sqlite3.c"
 do {
  if ($1) {
   $$0 = 7;
  } else {
   $2 = (_sqlite3SafetyCheckSickOrOk($0)|0); //@line 145693 "c/sqlite3.c"
   $3 = ($2|0)==(0); //@line 145693 "c/sqlite3.c"
   if ($3) {
    $4 = (_sqlite3MisuseError(145694)|0); //@line 145694 "c/sqlite3.c"
    $$0 = $4;
    break;
   }
   $5 = ((($0)) + 73|0); //@line 145696 "c/sqlite3.c"
   $6 = HEAP8[$5>>0]|0; //@line 145696 "c/sqlite3.c"
   $7 = ($6<<24>>24)==(0); //@line 145696 "c/sqlite3.c"
   if ($7) {
    $8 = ((($0)) + 56|0); //@line 145699 "c/sqlite3.c"
    $9 = HEAP32[$8>>2]|0; //@line 145699 "c/sqlite3.c"
    $$0 = $9;
   } else {
    $$0 = 7;
   }
  }
 } while(0);
 return ($$0|0); //@line 145700 "c/sqlite3.c"
}
function _sqlite3_soft_heap_limit64($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $narrow = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3_initialize()|0); //@line 25225 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 25226 "c/sqlite3.c"
 if (!($3)) {
  $30 = -1;$31 = -1;
  tempRet0 = ($30); //@line 25241 "c/sqlite3.c"
  return ($31|0); //@line 25241 "c/sqlite3.c"
 }
 $4 = HEAP32[10020]|0; //@line 25228 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 25228 "c/sqlite3.c"
 $5 = (40088); //@line 25229 "c/sqlite3.c"
 $6 = $5; //@line 25229 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 25229 "c/sqlite3.c"
 $8 = (($5) + 4)|0; //@line 25229 "c/sqlite3.c"
 $9 = $8; //@line 25229 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 25229 "c/sqlite3.c"
 $11 = ($1|0)<(0); //@line 25230 "c/sqlite3.c"
 if ($11) {
  $12 = HEAP32[10020]|0; //@line 25231 "c/sqlite3.c"
  _sqlite3_mutex_leave($12); //@line 25231 "c/sqlite3.c"
  $30 = $10;$31 = $7;
  tempRet0 = ($30); //@line 25241 "c/sqlite3.c"
  return ($31|0); //@line 25241 "c/sqlite3.c"
 } else {
  $13 = (40088); //@line 25234 "c/sqlite3.c"
  $14 = $13; //@line 25234 "c/sqlite3.c"
  HEAP32[$14>>2] = $0; //@line 25234 "c/sqlite3.c"
  $15 = (($13) + 4)|0; //@line 25234 "c/sqlite3.c"
  $16 = $15; //@line 25234 "c/sqlite3.c"
  HEAP32[$16>>2] = $1; //@line 25234 "c/sqlite3.c"
  $17 = (_sqlite3StatusValue()|0); //@line 25235 "c/sqlite3.c"
  $18 = tempRet0; //@line 25235 "c/sqlite3.c"
  $19 = ($0|0)!=(0); //@line 25236 "c/sqlite3.c"
  $20 = ($1|0)!=(0); //@line 25236 "c/sqlite3.c"
  $21 = $19 | $20; //@line 25236 "c/sqlite3.c"
  $22 = ($18|0)>($1|0); //@line 25236 "c/sqlite3.c"
  $23 = ($17>>>0)>=($0>>>0); //@line 25236 "c/sqlite3.c"
  $24 = ($18|0)==($1|0); //@line 25236 "c/sqlite3.c"
  $25 = $24 & $23; //@line 25236 "c/sqlite3.c"
  $26 = $22 | $25; //@line 25236 "c/sqlite3.c"
  $narrow = $21 & $26; //@line 25236 "c/sqlite3.c"
  $27 = $narrow&1; //@line 25236 "c/sqlite3.c"
  HEAP32[(40096)>>2] = $27; //@line 25236 "c/sqlite3.c"
  $28 = HEAP32[10020]|0; //@line 25237 "c/sqlite3.c"
  _sqlite3_mutex_leave($28); //@line 25237 "c/sqlite3.c"
  (_sqlite3_memory_used()|0); //@line 25238 "c/sqlite3.c"
  $29 = tempRet0; //@line 25238 "c/sqlite3.c"
  $30 = $10;$31 = $7;
  tempRet0 = ($30); //@line 25241 "c/sqlite3.c"
  return ($31|0); //@line 25241 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_sourceid() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (15116|0); //@line 207609 "c/sqlite3.c"
}
function _sqlite3_stmt_status($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ($1|0)==(99); //@line 79389 "c/sqlite3.c"
 if ($4) {
  $5 = HEAP32[$0>>2]|0; //@line 79390 "c/sqlite3.c"
  $6 = ((($5)) + 12|0); //@line 79391 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 79391 "c/sqlite3.c"
  _sqlite3_mutex_enter($7); //@line 79391 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 79392 "c/sqlite3.c"
  $8 = ((($5)) + 464|0); //@line 79393 "c/sqlite3.c"
  HEAP32[$8>>2] = $3; //@line 79393 "c/sqlite3.c"
  _sqlite3VdbeClearObject($5,$0); //@line 79394 "c/sqlite3.c"
  _sqlite3DbFree($5,$0); //@line 79395 "c/sqlite3.c"
  HEAP32[$8>>2] = 0; //@line 79396 "c/sqlite3.c"
  $9 = HEAP32[$6>>2]|0; //@line 79397 "c/sqlite3.c"
  _sqlite3_mutex_leave($9); //@line 79397 "c/sqlite3.c"
 } else {
  $10 = (((($0)) + 156|0) + ($1<<2)|0); //@line 79399 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 79399 "c/sqlite3.c"
  HEAP32[$3>>2] = $11; //@line 79399 "c/sqlite3.c"
  $12 = ($2|0)==(0); //@line 79400 "c/sqlite3.c"
  if (!($12)) {
   HEAP32[$10>>2] = 0; //@line 79400 "c/sqlite3.c"
  }
 }
 $13 = HEAP32[$3>>2]|0; //@line 79402 "c/sqlite3.c"
 STACKTOP = sp;return ($13|0); //@line 79402 "c/sqlite3.c"
}
function _sqlite3_wal_autocheckpoint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 145419 "c/sqlite3.c"
 if ($2) {
  $3 = $1; //@line 145420 "c/sqlite3.c"
  (_sqlite3_wal_hook($0,87,$3)|0); //@line 145420 "c/sqlite3.c"
  return 0; //@line 145425 "c/sqlite3.c"
 } else {
  (_sqlite3_wal_hook($0,0,0)|0); //@line 145422 "c/sqlite3.c"
  return 0; //@line 145425 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_wal_checkpoint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3_wal_checkpoint_v2($0,$1,0,0,0)|0); //@line 145524 "c/sqlite3.c"
 return ($2|0); //@line 145524 "c/sqlite3.c"
}
function _sqlite3_wal_hook($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 145445 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 145445 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 145445 "c/sqlite3.c"
 $5 = ((($0)) + 232|0); //@line 145446 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145446 "c/sqlite3.c"
 $7 = ((($0)) + 228|0); //@line 145447 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 145447 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 145448 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 145449 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 145449 "c/sqlite3.c"
 return ($6|0); //@line 145450 "c/sqlite3.c"
}
function _sqlite3_blob_reopen($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$020 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $3 = sp + 4|0;
 $4 = ($0|0)==(0|0); //@line 87773 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3MisuseError(87773)|0); //@line 87773 "c/sqlite3.c"
  $$0 = $5;
  STACKTOP = sp;return ($$0|0); //@line 87796 "c/sqlite3.c"
 }
 $6 = ((($0)) + 20|0); //@line 87774 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 87774 "c/sqlite3.c"
 $8 = ((($7)) + 12|0); //@line 87775 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 87775 "c/sqlite3.c"
 _sqlite3_mutex_enter($9); //@line 87775 "c/sqlite3.c"
 $10 = ((($0)) + 16|0); //@line 87777 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 87777 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 87777 "c/sqlite3.c"
 if ($12) {
  $$020 = 4;
 } else {
  $13 = (_blobSeekToRow($0,$1,$2,$3)|0); //@line 87784 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 87785 "c/sqlite3.c"
  if (!($14)) {
   $15 = HEAP32[$3>>2]|0; //@line 87786 "c/sqlite3.c"
   $16 = ($15|0)==(0|0); //@line 87786 "c/sqlite3.c"
   $17 = $16 ? 0 : 15687; //@line 87786 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $15; //@line 87786 "c/sqlite3.c"
   _sqlite3ErrorWithMsg($7,$13,$17,$vararg_buffer); //@line 87786 "c/sqlite3.c"
   _sqlite3DbFree($7,$15); //@line 87787 "c/sqlite3.c"
  }
  $$020 = $13;
 }
 $18 = (_sqlite3ApiExit($7,$$020)|0); //@line 87792 "c/sqlite3.c"
 $19 = HEAP32[$8>>2]|0; //@line 87794 "c/sqlite3.c"
 _sqlite3_mutex_leave($19); //@line 87794 "c/sqlite3.c"
 $$0 = $18;
 STACKTOP = sp;return ($$0|0); //@line 87796 "c/sqlite3.c"
}
function _sqlite3_vtab_config($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $$113 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $arglist_current = 0, $arglist_next = 0, $cond = 0, $expanded = 0, $expanded2 = 0, $expanded4 = 0, $expanded5 = 0, $expanded6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 12|0); //@line 128578 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 128578 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 128578 "c/sqlite3.c"
 HEAP32[$2>>2] = $varargs; //@line 128579 "c/sqlite3.c"
 $cond = ($1|0)==(1); //@line 128580 "c/sqlite3.c"
 if ($cond) {
  $5 = ((($0)) + 344|0); //@line 128582 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 128582 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 128583 "c/sqlite3.c"
  if ($7) {
   $$sink = 128584;
   label = 4;
  } else {
   $arglist_current = HEAP32[$2>>2]|0; //@line 128587 "c/sqlite3.c"
   $8 = $arglist_current; //@line 128587 "c/sqlite3.c"
   $9 = ((0) + 4|0);
   $expanded2 = $9;
   $expanded = (($expanded2) - 1)|0;
   $10 = (($8) + ($expanded))|0; //@line 128587 "c/sqlite3.c"
   $11 = ((0) + 4|0);
   $expanded6 = $11;
   $expanded5 = (($expanded6) - 1)|0;
   $expanded4 = $expanded5 ^ -1;
   $12 = $10 & $expanded4; //@line 128587 "c/sqlite3.c"
   $13 = $12; //@line 128587 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 128587 "c/sqlite3.c"
   $arglist_next = ((($13)) + 4|0); //@line 128587 "c/sqlite3.c"
   HEAP32[$2>>2] = $arglist_next; //@line 128587 "c/sqlite3.c"
   $15 = $14&255; //@line 128587 "c/sqlite3.c"
   $16 = HEAP32[$6>>2]|0; //@line 128587 "c/sqlite3.c"
   $17 = ((($16)) + 16|0); //@line 128587 "c/sqlite3.c"
   HEAP8[$17>>0] = $15; //@line 128587 "c/sqlite3.c"
   $$113 = 0;
  }
 } else {
  $$sink = 128592;
  label = 4;
 }
 if ((label|0) == 4) {
  $18 = (_sqlite3MisuseError($$sink)|0);
  $19 = ($18|0)==(0); //@line 128597 "c/sqlite3.c"
  if ($19) {
   $$113 = 0;
  } else {
   _sqlite3Error($0,$18); //@line 128597 "c/sqlite3.c"
   $$113 = $18;
  }
 }
 $20 = HEAP32[$3>>2]|0; //@line 128598 "c/sqlite3.c"
 _sqlite3_mutex_leave($20); //@line 128598 "c/sqlite3.c"
 STACKTOP = sp;return ($$113|0); //@line 128599 "c/sqlite3.c"
}
function _sqlite3_vtab_on_conflict($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 78|0); //@line 128563 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 128563 "c/sqlite3.c"
 $3 = $2&255; //@line 128563 "c/sqlite3.c"
 $4 = (($3) + -1)|0; //@line 128563 "c/sqlite3.c"
 $5 = (33602 + ($4)|0); //@line 128563 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 128563 "c/sqlite3.c"
 $7 = $6&255; //@line 128563 "c/sqlite3.c"
 return ($7|0); //@line 128563 "c/sqlite3.c"
}
function _sqlite3_close_v2($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3Close($0,1)|0); //@line 144480 "c/sqlite3.c"
 return ($1|0); //@line 144480 "c/sqlite3.c"
}
function _sqlite3_db_filename($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3DbNameToBtree($0,$1)|0); //@line 147370 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 147371 "c/sqlite3.c"
 if ($3) {
  $5 = 0;
  return ($5|0); //@line 147371 "c/sqlite3.c"
 }
 $4 = (_sqlite3BtreeGetFilename($2)|0); //@line 147371 "c/sqlite3.c"
 $5 = $4;
 return ($5|0); //@line 147371 "c/sqlite3.c"
}
function _sqlite3_db_readonly($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3DbNameToBtree($0,$1)|0); //@line 147386 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 147387 "c/sqlite3.c"
 if ($3) {
  $5 = -1;
  return ($5|0); //@line 147387 "c/sqlite3.c"
 }
 $4 = (_sqlite3BtreeIsReadonly($2)|0); //@line 147387 "c/sqlite3.c"
 $5 = $4;
 return ($5|0); //@line 147387 "c/sqlite3.c"
}
function _sqlite3_db_release_memory($0) {
 $0 = $0|0;
 var $$016 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 144108 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144108 "c/sqlite3.c"
 _sqlite3_mutex_enter($2); //@line 144108 "c/sqlite3.c"
 _sqlite3BtreeEnterAll($0); //@line 144109 "c/sqlite3.c"
 $3 = ((($0)) + 20|0); //@line 144110 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 144110 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 144110 "c/sqlite3.c"
 if (!($5)) {
  _sqlite3BtreeLeaveAll($0); //@line 144117 "c/sqlite3.c"
  $15 = HEAP32[$1>>2]|0; //@line 144118 "c/sqlite3.c"
  _sqlite3_mutex_leave($15); //@line 144118 "c/sqlite3.c"
  return 0; //@line 144119 "c/sqlite3.c"
 }
 $6 = ((($0)) + 16|0);
 $$016 = 0;
 while(1) {
  $7 = HEAP32[$6>>2]|0; //@line 144111 "c/sqlite3.c"
  $8 = (((($7) + ($$016<<4)|0)) + 4|0); //@line 144111 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 144111 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 144112 "c/sqlite3.c"
  if (!($10)) {
   $11 = (_sqlite3BtreePager($9)|0); //@line 144113 "c/sqlite3.c"
   _sqlite3PagerShrink($11); //@line 144114 "c/sqlite3.c"
  }
  $12 = (($$016) + 1)|0; //@line 144110 "c/sqlite3.c"
  $13 = HEAP32[$3>>2]|0; //@line 144110 "c/sqlite3.c"
  $14 = ($12|0)<($13|0); //@line 144110 "c/sqlite3.c"
  if ($14) {
   $$016 = $12;
  } else {
   break;
  }
 }
 _sqlite3BtreeLeaveAll($0); //@line 144117 "c/sqlite3.c"
 $15 = HEAP32[$1>>2]|0; //@line 144118 "c/sqlite3.c"
 _sqlite3_mutex_leave($15); //@line 144118 "c/sqlite3.c"
 return 0; //@line 144119 "c/sqlite3.c"
}
function _sqlite3_errstr($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ErrStr($0)|0); //@line 145711 "c/sqlite3.c"
 return ($1|0); //@line 145711 "c/sqlite3.c"
}
function _sqlite3_stmt_busy($0) {
 $0 = $0|0;
 var $$lobit = 0, $$lobit$not = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 79350 "c/sqlite3.c"
 if ($1) {
  $7 = 0;
 } else {
  $2 = ((($0)) + 20|0); //@line 79350 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 79350 "c/sqlite3.c"
  $4 = ($3|0)==(770837923); //@line 79350 "c/sqlite3.c"
  if ($4) {
   $5 = ((($0)) + 36|0); //@line 79350 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 79350 "c/sqlite3.c"
   $$lobit = $6 >>> 31;
   $$lobit$not = $$lobit ^ 1;
   $7 = $$lobit$not;
  } else {
   $7 = 0;
  }
 }
 return ($7|0); //@line 79350 "c/sqlite3.c"
}
function _sqlite3_stmt_readonly($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 79342 "c/sqlite3.c"
 if ($1) {
  $7 = 1;
  return ($7|0); //@line 79342 "c/sqlite3.c"
 }
 $2 = ((($0)) + 145|0); //@line 79342 "c/sqlite3.c"
 $3 = HEAPU8[$2>>0]|(HEAPU8[$2+1>>0]<<8); //@line 79342 "c/sqlite3.c"
 $4 = ($3&65535) >>> 7; //@line 79342 "c/sqlite3.c"
 $5 = $4 & 1; //@line 79342 "c/sqlite3.c"
 $6 = $5&65535; //@line 79342 "c/sqlite3.c"
 $7 = $6;
 return ($7|0); //@line 79342 "c/sqlite3.c"
}
function _sqlite3_stricmp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 28758 "c/sqlite3.c"
 if ($2) {
  $3 = ($1|0)!=(0|0); //@line 28759 "c/sqlite3.c"
  $4 = $3 << 31 >> 31; //@line 28759 "c/sqlite3.c"
  $$0 = $4;
 } else {
  $5 = ($1|0)==(0|0); //@line 28760 "c/sqlite3.c"
  if ($5) {
   $$0 = 1;
  } else {
   $6 = (_sqlite3StrICmp($0,$1)|0); //@line 28763 "c/sqlite3.c"
   $$0 = $6;
  }
 }
 return ($$0|0); //@line 28764 "c/sqlite3.c"
}
function _sqlite3_uri_int64($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = (_sqlite3_uri_parameter($0,$1)|0); //@line 147342 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 147344 "c/sqlite3.c"
 if ($6) {
  $17 = $3;$18 = $2;
  tempRet0 = ($17); //@line 147347 "c/sqlite3.c"
  STACKTOP = sp;return ($18|0); //@line 147347 "c/sqlite3.c"
 }
 $7 = (_sqlite3DecOrHexToI64($5,$4)|0); //@line 147344 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 147344 "c/sqlite3.c"
 $9 = $4; //@line 147345 "c/sqlite3.c"
 $10 = $9; //@line 147345 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 147345 "c/sqlite3.c"
 $12 = (($9) + 4)|0; //@line 147345 "c/sqlite3.c"
 $13 = $12; //@line 147345 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 147345 "c/sqlite3.c"
 $15 = $8 ? $11 : $2; //@line 147344 "c/sqlite3.c"
 $16 = $8 ? $14 : $3; //@line 147344 "c/sqlite3.c"
 $17 = $16;$18 = $15;
 tempRet0 = ($17); //@line 147347 "c/sqlite3.c"
 STACKTOP = sp;return ($18|0); //@line 147347 "c/sqlite3.c"
}
function _sqlite3_wal_checkpoint_v2($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$032 = 0, $$033 = 0, $$034 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 145460 "c/sqlite3.c"
 $5 = ($3|0)==(0|0); //@line 145477 "c/sqlite3.c"
 if (!($5)) {
  HEAP32[$3>>2] = -1; //@line 145477 "c/sqlite3.c"
 }
 $6 = ($4|0)==(0|0); //@line 145478 "c/sqlite3.c"
 if (!($6)) {
  HEAP32[$4>>2] = -1; //@line 145478 "c/sqlite3.c"
 }
 $7 = ($2>>>0)>(3); //@line 145484 "c/sqlite3.c"
 if ($7) {
  $$033 = 21;
  STACKTOP = sp;return ($$033|0); //@line 145513 "c/sqlite3.c"
 }
 $8 = ((($0)) + 12|0); //@line 145490 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 145490 "c/sqlite3.c"
 _sqlite3_mutex_enter($9); //@line 145490 "c/sqlite3.c"
 $10 = ($1|0)==(0|0); //@line 145491 "c/sqlite3.c"
 if ($10) {
  $$034 = 10;
  label = 10;
 } else {
  $11 = HEAP8[$1>>0]|0; //@line 145491 "c/sqlite3.c"
  $12 = ($11<<24>>24)==(0); //@line 145491 "c/sqlite3.c"
  if ($12) {
   $$034 = 10;
   label = 10;
  } else {
   $13 = (_sqlite3FindDbName($0,$1)|0); //@line 145492 "c/sqlite3.c"
   $14 = ($13|0)<(0); //@line 145494 "c/sqlite3.c"
   if ($14) {
    HEAP32[$vararg_buffer>>2] = $1; //@line 145496 "c/sqlite3.c"
    _sqlite3ErrorWithMsg($0,1,33513,$vararg_buffer); //@line 145496 "c/sqlite3.c"
    $$032 = 1;
   } else {
    $$034 = $13;
    label = 10;
   }
  }
 }
 if ((label|0) == 10) {
  $15 = ((($0)) + 396|0); //@line 145498 "c/sqlite3.c"
  HEAP32[$15>>2] = 0; //@line 145498 "c/sqlite3.c"
  $16 = (_sqlite3Checkpoint($0,$$034,$2,$3,$4)|0); //@line 145499 "c/sqlite3.c"
  _sqlite3Error($0,$16); //@line 145500 "c/sqlite3.c"
  $$032 = $16;
 }
 $17 = (_sqlite3ApiExit($0,$$032)|0); //@line 145502 "c/sqlite3.c"
 $18 = ((($0)) + 160|0); //@line 145506 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 145506 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 145506 "c/sqlite3.c"
 if ($20) {
  $21 = ((($0)) + 256|0); //@line 145507 "c/sqlite3.c"
  HEAP32[$21>>2] = 0; //@line 145507 "c/sqlite3.c"
 }
 $22 = HEAP32[$8>>2]|0; //@line 145510 "c/sqlite3.c"
 _sqlite3_mutex_leave($22); //@line 145510 "c/sqlite3.c"
 $$033 = $17;
 STACKTOP = sp;return ($$033|0); //@line 145513 "c/sqlite3.c"
}
function _sqlite3_auto_extension($0) {
 $0 = $0|0;
 var $$0 = 0, $$024$lcssa = 0, $$02425 = 0, $$1 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_initialize()|0); //@line 114511 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 114512 "c/sqlite3.c"
 if (!($2)) {
  $$0 = $1;
  return ($$0|0); //@line 114542 "c/sqlite3.c"
 }
 $3 = (_sqlite3MutexAlloc(2)|0); //@line 114519 "c/sqlite3.c"
 _sqlite3_mutex_enter($3); //@line 114522 "c/sqlite3.c"
 $4 = HEAP32[10113]|0; //@line 114523 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 114523 "c/sqlite3.c"
 L4: do {
  if ($5) {
   $$024$lcssa = 0;$$lcssa = 0;
  } else {
   $6 = HEAP32[10112]|0;
   $7 = HEAP32[10113]|0;
   $$02425 = 0;$22 = $4;
   while(1) {
    $8 = (($6) + ($$02425<<2)|0); //@line 114524 "c/sqlite3.c"
    $9 = HEAP32[$8>>2]|0; //@line 114524 "c/sqlite3.c"
    $10 = ($9|0)==($0|0); //@line 114524 "c/sqlite3.c"
    if ($10) {
     $$024$lcssa = $$02425;$$lcssa = $22;
     break L4;
    }
    $11 = (($$02425) + 1)|0; //@line 114523 "c/sqlite3.c"
    $12 = ($11>>>0)<($7>>>0); //@line 114523 "c/sqlite3.c"
    if ($12) {
     $$02425 = $11;$22 = $7;
    } else {
     $$024$lcssa = $11;$$lcssa = $7;
     break;
    }
   }
  }
 } while(0);
 $13 = ($$024$lcssa|0)==($$lcssa|0); //@line 114526 "c/sqlite3.c"
 if ($13) {
  $14 = $$lcssa << 2; //@line 114527 "c/sqlite3.c"
  $15 = (($14) + 4)|0; //@line 114527 "c/sqlite3.c"
  $16 = HEAP32[10112]|0; //@line 114529 "c/sqlite3.c"
  $17 = (_sqlite3_realloc64($16,$15,0)|0); //@line 114529 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 114530 "c/sqlite3.c"
  if ($18) {
   $$1 = 7;
  } else {
   HEAP32[10112] = $17; //@line 114533 "c/sqlite3.c"
   $19 = HEAP32[10113]|0; //@line 114534 "c/sqlite3.c"
   $20 = (($17) + ($19<<2)|0); //@line 114534 "c/sqlite3.c"
   HEAP32[$20>>2] = $0; //@line 114534 "c/sqlite3.c"
   $21 = (($19) + 1)|0; //@line 114535 "c/sqlite3.c"
   HEAP32[10113] = $21; //@line 114535 "c/sqlite3.c"
   $$1 = $1;
  }
 } else {
  $$1 = $1;
 }
 _sqlite3_mutex_leave($3); //@line 114538 "c/sqlite3.c"
 $$0 = $$1;
 return ($$0|0); //@line 114542 "c/sqlite3.c"
}
function _sqlite3_bind_blob64($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $10 = 0, $11 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ($4>>>0)>(0); //@line 79097 "c/sqlite3.c"
 $7 = ($3>>>0)>(2147483647); //@line 79097 "c/sqlite3.c"
 $8 = ($4|0)==(0); //@line 79097 "c/sqlite3.c"
 $9 = $8 & $7; //@line 79097 "c/sqlite3.c"
 $10 = $6 | $9; //@line 79097 "c/sqlite3.c"
 if ($10) {
  _invokeValueDestructor($2,$5,0); //@line 79098 "c/sqlite3.c"
  $$0 = 18;
  return ($$0|0); //@line 79102 "c/sqlite3.c"
 } else {
  $11 = (_bindText($0,$1,$2,$3,$5,0)|0); //@line 79100 "c/sqlite3.c"
  $$0 = $11;
  return ($$0|0); //@line 79102 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_bind_text64($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$010 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $7 = ($4>>>0)>(0); //@line 79171 "c/sqlite3.c"
 $8 = ($3>>>0)>(2147483647); //@line 79171 "c/sqlite3.c"
 $9 = ($4|0)==(0); //@line 79171 "c/sqlite3.c"
 $10 = $9 & $8; //@line 79171 "c/sqlite3.c"
 $11 = $7 | $10; //@line 79171 "c/sqlite3.c"
 if ($11) {
  _invokeValueDestructor($2,$5,0); //@line 79172 "c/sqlite3.c"
  $$010 = 18;
  return ($$010|0); //@line 79177 "c/sqlite3.c"
 } else {
  $12 = ($6<<24>>24)==(4); //@line 79174 "c/sqlite3.c"
  $spec$select = $12 ? 2 : $6; //@line 79174 "c/sqlite3.c"
  $13 = (_bindText($0,$1,$2,$3,$5,$spec$select)|0); //@line 79175 "c/sqlite3.c"
  $$010 = $13;
  return ($$010|0); //@line 79177 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3_cancel_auto_extension($0) {
 $0 = $0|0;
 var $$0 = 0, $$01316 = 0, $$01316$in = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3MutexAlloc(2)|0); //@line 114557 "c/sqlite3.c"
 _sqlite3_mutex_enter($1); //@line 114562 "c/sqlite3.c"
 $2 = HEAP32[10113]|0; //@line 114563 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 114563 "c/sqlite3.c"
 L1: do {
  if ($3) {
   $4 = HEAP32[10112]|0;
   $$01316$in = $2;
   while(1) {
    $$01316 = (($$01316$in) + -1)|0;
    $6 = (($4) + ($$01316<<2)|0); //@line 114564 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 114564 "c/sqlite3.c"
    $8 = ($7|0)==($0|0); //@line 114564 "c/sqlite3.c"
    if ($8) {
     break;
    }
    $5 = ($$01316$in|0)>(1); //@line 114563 "c/sqlite3.c"
    if ($5) {
     $$01316$in = $$01316;
    } else {
     $$0 = 0;
     break L1;
    }
   }
   $9 = (($2) + -1)|0; //@line 114565 "c/sqlite3.c"
   HEAP32[10113] = $9; //@line 114565 "c/sqlite3.c"
   $10 = (($4) + ($9<<2)|0); //@line 114566 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 114566 "c/sqlite3.c"
   HEAP32[$6>>2] = $11; //@line 114566 "c/sqlite3.c"
   $$0 = 1;
  } else {
   $$0 = 0;
  }
 } while(0);
 _sqlite3_mutex_leave($1); //@line 114571 "c/sqlite3.c"
 return ($$0|0); //@line 114572 "c/sqlite3.c"
}
function _sqlite3_msize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 25447 "c/sqlite3.c"
 if ($1) {
  $6 = 0;$7 = 0;
 } else {
  $2 = HEAP32[(64)>>2]|0; //@line 25447 "c/sqlite3.c"
  $3 = (FUNCTION_TABLE_ii[$2 & 255]($0)|0); //@line 25447 "c/sqlite3.c"
  $4 = ($3|0)<(0); //@line 25447 "c/sqlite3.c"
  $5 = $4 << 31 >> 31; //@line 25447 "c/sqlite3.c"
  $6 = $5;$7 = $3;
 }
 tempRet0 = ($6); //@line 25447 "c/sqlite3.c"
 return ($7|0); //@line 25447 "c/sqlite3.c"
}
function _sqlite3_reset_auto_extension() {
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_sqlite3_initialize()|0); //@line 114580 "c/sqlite3.c"
 $1 = ($0|0)==(0); //@line 114580 "c/sqlite3.c"
 if (!($1)) {
  return; //@line 114593 "c/sqlite3.c"
 }
 $2 = (_sqlite3MutexAlloc(2)|0); //@line 114584 "c/sqlite3.c"
 _sqlite3_mutex_enter($2); //@line 114587 "c/sqlite3.c"
 $3 = HEAP32[10112]|0; //@line 114588 "c/sqlite3.c"
 _sqlite3_free($3); //@line 114588 "c/sqlite3.c"
 HEAP32[10112] = 0; //@line 114589 "c/sqlite3.c"
 HEAP32[10113] = 0; //@line 114590 "c/sqlite3.c"
 _sqlite3_mutex_leave($2); //@line 114591 "c/sqlite3.c"
 return; //@line 114593 "c/sqlite3.c"
}
function _sqlite3_strglob($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_patternCompare($0,$1,16980,91)|0); //@line 108296 "c/sqlite3.c"
 return ($2|0); //@line 108296 "c/sqlite3.c"
}
function _sqlite3_value_dup($0) {
 $0 = $0|0;
 var $$015 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 77985 "c/sqlite3.c"
 if ($1) {
  $$015 = 0;
  return ($$015|0); //@line 78001 "c/sqlite3.c"
 }
 $2 = (_sqlite3_malloc(40)|0); //@line 77986 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 77987 "c/sqlite3.c"
 if ($3) {
  $$015 = 0;
  return ($$015|0); //@line 78001 "c/sqlite3.c"
 }
 $4 = ((($2)) + 20|0); //@line 77989 "c/sqlite3.c"
 ;HEAP32[$4>>2]=0|0;HEAP32[$4+4>>2]=0|0;HEAP32[$4+8>>2]=0|0;HEAP32[$4+12>>2]=0|0;HEAP32[$4+16>>2]=0|0; //@line 77989 "c/sqlite3.c"
 ;HEAP32[$2>>2]=HEAP32[$0>>2]|0;HEAP32[$2+4>>2]=HEAP32[$0+4>>2]|0;HEAP32[$2+8>>2]=HEAP32[$0+8>>2]|0;HEAP32[$2+12>>2]=HEAP32[$0+12>>2]|0;HEAP32[$2+16>>2]=HEAP32[$0+16>>2]|0; //@line 77989 "c/sqlite3.c"
 $5 = ((($2)) + 8|0); //@line 77990 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 77990 "c/sqlite3.c"
 $7 = $6 & -1025; //@line 77990 "c/sqlite3.c"
 HEAP16[$5>>1] = $7; //@line 77990 "c/sqlite3.c"
 $8 = ((($2)) + 32|0); //@line 77991 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 77991 "c/sqlite3.c"
 $9 = $7&65535; //@line 77992 "c/sqlite3.c"
 $10 = $9 & 18; //@line 77992 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 77992 "c/sqlite3.c"
 if ($11) {
  $$015 = $2;
  return ($$015|0); //@line 78001 "c/sqlite3.c"
 }
 $12 = $9 & 58367; //@line 77993 "c/sqlite3.c"
 $13 = $12 | 4096; //@line 77994 "c/sqlite3.c"
 $14 = $13&65535; //@line 77994 "c/sqlite3.c"
 HEAP16[$5>>1] = $14; //@line 77994 "c/sqlite3.c"
 $15 = (_sqlite3VdbeMemMakeWriteable($2)|0); //@line 77995 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 77995 "c/sqlite3.c"
 if ($16) {
  $$015 = $2;
  return ($$015|0); //@line 78001 "c/sqlite3.c"
 }
 _sqlite3ValueFree($2); //@line 77996 "c/sqlite3.c"
 $$015 = 0;
 return ($$015|0); //@line 78001 "c/sqlite3.c"
}
function _sqlite3_value_free($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3ValueFree($0); //@line 78007 "c/sqlite3.c"
 return; //@line 78008 "c/sqlite3.c"
}
function _sqlite3_bind_zeroblob64($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 79233 "c/sqlite3.c"
 $5 = ((($4)) + 12|0); //@line 79233 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 79233 "c/sqlite3.c"
 _sqlite3_mutex_enter($6); //@line 79233 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 79234 "c/sqlite3.c"
 $8 = ((($7)) + 100|0); //@line 79234 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 79234 "c/sqlite3.c"
 $10 = ($9|0)<(0); //@line 79234 "c/sqlite3.c"
 $11 = $10 << 31 >> 31; //@line 79234 "c/sqlite3.c"
 $12 = ($11>>>0)<($3>>>0); //@line 79234 "c/sqlite3.c"
 $13 = ($9>>>0)<($2>>>0); //@line 79234 "c/sqlite3.c"
 $14 = ($11|0)==($3|0); //@line 79234 "c/sqlite3.c"
 $15 = $14 & $13; //@line 79234 "c/sqlite3.c"
 $16 = $12 | $15; //@line 79234 "c/sqlite3.c"
 if ($16) {
  $$0 = 18;
 } else {
  $17 = (_sqlite3_bind_zeroblob($0,$1,$2)|0); //@line 79238 "c/sqlite3.c"
  $$0 = $17;
 }
 $18 = HEAP32[$0>>2]|0; //@line 79240 "c/sqlite3.c"
 $19 = (_sqlite3ApiExit($18,$$0)|0); //@line 79240 "c/sqlite3.c"
 $20 = HEAP32[$0>>2]|0; //@line 79241 "c/sqlite3.c"
 $21 = ((($20)) + 12|0); //@line 79241 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 79241 "c/sqlite3.c"
 _sqlite3_mutex_leave($22); //@line 79241 "c/sqlite3.c"
 return ($19|0); //@line 79242 "c/sqlite3.c"
}
function _sqlite3_value_subtype($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 77905 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 77905 "c/sqlite3.c"
 $3 = ($2<<16>>16)<(0); //@line 77905 "c/sqlite3.c"
 if (!($3)) {
  $7 = 0;
  return ($7|0); //@line 77905 "c/sqlite3.c"
 }
 $4 = ((($0)) + 11|0); //@line 77905 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 77905 "c/sqlite3.c"
 $6 = $5&255; //@line 77905 "c/sqlite3.c"
 $7 = $6;
 return ($7|0); //@line 77905 "c/sqlite3.c"
}
function _sqlite3_result_subtype($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 78116 "c/sqlite3.c"
 $3 = $1&255; //@line 78118 "c/sqlite3.c"
 $4 = ((($2)) + 11|0); //@line 78118 "c/sqlite3.c"
 HEAP8[$4>>0] = $3; //@line 78118 "c/sqlite3.c"
 $5 = ((($2)) + 8|0); //@line 78119 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 78119 "c/sqlite3.c"
 $7 = $6 | -32768; //@line 78119 "c/sqlite3.c"
 HEAP16[$5>>1] = $7; //@line 78119 "c/sqlite3.c"
 return; //@line 78120 "c/sqlite3.c"
}
function _sqlite3_strlike($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_patternCompare($0,$1,16989,$2)|0); //@line 108304 "c/sqlite3.c"
 return ($3|0); //@line 108304 "c/sqlite3.c"
}
function _sqlite3_db_cacheflush($0) {
 $0 = $0|0;
 var $$027$lcssa = 0, $$028$lcssa = 0, $$02832 = 0, $$034 = 0, $$2 = 0, $$230 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, $spec$select35 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 144134 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144134 "c/sqlite3.c"
 _sqlite3_mutex_enter($2); //@line 144134 "c/sqlite3.c"
 _sqlite3BtreeEnterAll($0); //@line 144135 "c/sqlite3.c"
 $3 = ((($0)) + 20|0); //@line 144136 "c/sqlite3.c"
 $4 = ((($0)) + 16|0);
 $$02832 = 0;$$034 = 0;
 while(1) {
  $5 = HEAP32[$3>>2]|0; //@line 144136 "c/sqlite3.c"
  $6 = ($$034|0)<($5|0); //@line 144136 "c/sqlite3.c"
  if (!($6)) {
   $$027$lcssa = 0;$$028$lcssa = $$02832;$$lcssa = 1;
   break;
  }
  $7 = HEAP32[$4>>2]|0; //@line 144137 "c/sqlite3.c"
  $8 = (((($7) + ($$034<<4)|0)) + 4|0); //@line 144137 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 144137 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 144138 "c/sqlite3.c"
  if ($10) {
   $$2 = 0;$$230 = $$02832;
  } else {
   $11 = (_sqlite3BtreeIsInTrans($9)|0); //@line 144138 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 144138 "c/sqlite3.c"
   if ($12) {
    $$2 = 0;$$230 = $$02832;
   } else {
    $13 = (_sqlite3BtreePager($9)|0); //@line 144139 "c/sqlite3.c"
    $14 = (_sqlite3PagerFlush($13)|0); //@line 144140 "c/sqlite3.c"
    $15 = ($14|0)==(5); //@line 144141 "c/sqlite3.c"
    $spec$select = $15 ? 1 : $$02832;
    $spec$select35 = $15 ? 0 : $14;
    $$2 = $spec$select35;$$230 = $spec$select;
   }
  }
  $16 = (($$034) + 1)|0; //@line 144136 "c/sqlite3.c"
  $17 = ($$2|0)==(0); //@line 144136 "c/sqlite3.c"
  if ($17) {
   $$02832 = $$230;$$034 = $16;
  } else {
   $$027$lcssa = $$2;$$028$lcssa = $$230;$$lcssa = 0;
   break;
  }
 }
 _sqlite3BtreeLeaveAll($0); //@line 144147 "c/sqlite3.c"
 $18 = HEAP32[$1>>2]|0; //@line 144148 "c/sqlite3.c"
 _sqlite3_mutex_leave($18); //@line 144148 "c/sqlite3.c"
 $19 = ($$028$lcssa|0)!=(0); //@line 144149 "c/sqlite3.c"
 $or$cond = $19 & $$lcssa; //@line 144149 "c/sqlite3.c"
 $20 = $or$cond ? 5 : $$027$lcssa; //@line 144149 "c/sqlite3.c"
 return ($20|0); //@line 144149 "c/sqlite3.c"
}
function _sqlite3_system_errno($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 145702 "c/sqlite3.c"
 if ($1) {
  $4 = 0;
 } else {
  $2 = ((($0)) + 64|0); //@line 145702 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 145702 "c/sqlite3.c"
  $4 = $3;
 }
 return ($4|0); //@line 145702 "c/sqlite3.c"
}
function _sqlite3_trace_v2($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 12|0); //@line 145239 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 145239 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 145239 "c/sqlite3.c"
 $6 = ($1|0)==(0); //@line 145240 "c/sqlite3.c"
 $spec$select = $6 ? 0 : $2; //@line 145240 "c/sqlite3.c"
 $7 = ($spec$select|0)==(0|0); //@line 145241 "c/sqlite3.c"
 $8 = $1&255; //@line 145242 "c/sqlite3.c"
 $9 = $7 ? 0 : $8; //@line 145242 "c/sqlite3.c"
 $10 = ((($0)) + 80|0); //@line 145242 "c/sqlite3.c"
 HEAP8[$10>>0] = $9; //@line 145242 "c/sqlite3.c"
 $11 = ((($0)) + 188|0); //@line 145243 "c/sqlite3.c"
 HEAP32[$11>>2] = $spec$select; //@line 145243 "c/sqlite3.c"
 $12 = ((($0)) + 192|0); //@line 145244 "c/sqlite3.c"
 HEAP32[$12>>2] = $3; //@line 145244 "c/sqlite3.c"
 $13 = HEAP32[$4>>2]|0; //@line 145245 "c/sqlite3.c"
 _sqlite3_mutex_leave($13); //@line 145245 "c/sqlite3.c"
 return 0; //@line 145246 "c/sqlite3.c"
}
function _sqlite3_expanded_sql($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_sql($0)|0); //@line 79427 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 79428 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 79434 "c/sqlite3.c"
 }
 $3 = HEAP32[$0>>2]|0; //@line 79430 "c/sqlite3.c"
 $4 = ((($3)) + 12|0); //@line 79430 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 79430 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 79430 "c/sqlite3.c"
 $6 = (_sqlite3VdbeExpandSql($0,$1)|0); //@line 79431 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 79432 "c/sqlite3.c"
 $8 = ((($7)) + 12|0); //@line 79432 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 79432 "c/sqlite3.c"
 _sqlite3_mutex_leave($9); //@line 79432 "c/sqlite3.c"
 $$0 = $6;
 return ($$0|0); //@line 79434 "c/sqlite3.c"
}
function _sqlite3_set_last_insert_rowid($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 144307 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 144307 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 144307 "c/sqlite3.c"
 $5 = ((($0)) + 32|0); //@line 144308 "c/sqlite3.c"
 $6 = $5; //@line 144308 "c/sqlite3.c"
 $7 = $6; //@line 144308 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 144308 "c/sqlite3.c"
 $8 = (($6) + 4)|0; //@line 144308 "c/sqlite3.c"
 $9 = $8; //@line 144308 "c/sqlite3.c"
 HEAP32[$9>>2] = $2; //@line 144308 "c/sqlite3.c"
 $10 = HEAP32[$3>>2]|0; //@line 144309 "c/sqlite3.c"
 _sqlite3_mutex_leave($10); //@line 144309 "c/sqlite3.c"
 return; //@line 144310 "c/sqlite3.c"
}
function _sqlite3_prepare_v3($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = $3 & 15; //@line 118574 "c/sqlite3.c"
 $7 = $6 | 128; //@line 118574 "c/sqlite3.c"
 $8 = (_sqlite3LockAndPrepare($0,$1,$2,$7,0,$4,$5)|0); //@line 118573 "c/sqlite3.c"
 return ($8|0); //@line 118577 "c/sqlite3.c"
}
function _sqlite3_prepare16_v3($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = $3 & 15; //@line 118677 "c/sqlite3.c"
 $7 = $6 | 128; //@line 118677 "c/sqlite3.c"
 $8 = (_sqlite3Prepare16($0,$1,$2,$7,$4,$5)|0); //@line 118676 "c/sqlite3.c"
 return ($8|0); //@line 118680 "c/sqlite3.c"
}
function _sqlite3_bind_pointer($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_vdbeUnbind($0,$1)|0); //@line 79144 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 79145 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 116|0); //@line 79146 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 79146 "c/sqlite3.c"
  $9 = (($1) + -1)|0; //@line 79146 "c/sqlite3.c"
  $10 = (($8) + (($9*40)|0)|0); //@line 79146 "c/sqlite3.c"
  _sqlite3VdbeMemSetPointer($10,$2,$3,$4); //@line 79146 "c/sqlite3.c"
  $11 = HEAP32[$0>>2]|0; //@line 79147 "c/sqlite3.c"
  $12 = ((($11)) + 12|0); //@line 79147 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 79147 "c/sqlite3.c"
  _sqlite3_mutex_leave($13); //@line 79147 "c/sqlite3.c"
  return ($5|0); //@line 79151 "c/sqlite3.c"
 }
 $14 = ($4|0)==(0|0); //@line 79148 "c/sqlite3.c"
 if ($14) {
  return ($5|0); //@line 79151 "c/sqlite3.c"
 }
 FUNCTION_TABLE_vi[$4 & 127]($2); //@line 79149 "c/sqlite3.c"
 return ($5|0); //@line 79151 "c/sqlite3.c"
}
function _sqlite3_result_pointer($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 78109 "c/sqlite3.c"
 _sqlite3VdbeMemRelease($4); //@line 78111 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 78112 "c/sqlite3.c"
 HEAP16[$5>>1] = 1; //@line 78112 "c/sqlite3.c"
 _sqlite3VdbeMemSetPointer($4,$1,$2,$3); //@line 78113 "c/sqlite3.c"
 return; //@line 78114 "c/sqlite3.c"
}
function _sqlite3_value_pointer($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 77909 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 77909 "c/sqlite3.c"
 $4 = $3 & -15361; //@line 77909 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(-32255); //@line 77909 "c/sqlite3.c"
 $6 = ($1|0)!=(0|0); //@line 77911 "c/sqlite3.c"
 $or$cond = $6 & $5; //@line 77911 "c/sqlite3.c"
 if (!($or$cond)) {
  $$0 = 0;
  return ($$0|0); //@line 77919 "c/sqlite3.c"
 }
 $7 = ((($0)) + 11|0); //@line 77912 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 77912 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(112); //@line 77912 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 0;
  return ($$0|0); //@line 77919 "c/sqlite3.c"
 }
 $10 = HEAP32[$0>>2]|0; //@line 77913 "c/sqlite3.c"
 $11 = (_strcmp($10,$1)|0); //@line 77913 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 77913 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 0;
  return ($$0|0); //@line 77919 "c/sqlite3.c"
 }
 $13 = ((($0)) + 16|0); //@line 77915 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 77915 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 77919 "c/sqlite3.c"
}
function _sqlite3_vtab_nochange($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 78474 "c/sqlite3.c"
 $2 = (_sqlite3_value_nochange($1)|0); //@line 78474 "c/sqlite3.c"
 return ($2|0); //@line 78474 "c/sqlite3.c"
}
function _sqlite3_value_nochange($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 77978 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 77978 "c/sqlite3.c"
 $3 = $2 & 16385; //@line 77978 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(16385); //@line 77978 "c/sqlite3.c"
 $5 = $4&1; //@line 77978 "c/sqlite3.c"
 return ($5|0); //@line 77978 "c/sqlite3.c"
}
function _sqlite3_vtab_collation($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 72|0); //@line 136076 "c/sqlite3.c"
 $3 = ($1|0)>(-1); //@line 136078 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 136087 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 136078 "c/sqlite3.c"
 $5 = ($4|0)>($1|0); //@line 136078 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  return ($$0|0); //@line 136087 "c/sqlite3.c"
 }
 $6 = ((($0)) + 4|0); //@line 136080 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 136080 "c/sqlite3.c"
 $8 = (((($7) + (($1*12)|0)|0)) + 8|0); //@line 136080 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 136080 "c/sqlite3.c"
 $10 = HEAP32[$2>>2]|0; //@line 136081 "c/sqlite3.c"
 $11 = ((($10)) + 20|0); //@line 136081 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 136081 "c/sqlite3.c"
 $13 = (($12) + (($9*48)|0)|0); //@line 136081 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 136081 "c/sqlite3.c"
 $15 = ((($14)) + 12|0); //@line 136082 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 136082 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 136082 "c/sqlite3.c"
 if ($17) {
  $$0 = 18038;
  return ($$0|0); //@line 136087 "c/sqlite3.c"
 }
 $18 = ((($0)) + 76|0); //@line 136083 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 136083 "c/sqlite3.c"
 $20 = ((($14)) + 16|0); //@line 136083 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 136083 "c/sqlite3.c"
 $22 = (_sqlite3BinaryCompareCollSeq($19,$16,$21)|0); //@line 136083 "c/sqlite3.c"
 $23 = ($22|0)==(0|0); //@line 136085 "c/sqlite3.c"
 if ($23) {
  $$0 = 18038;
  return ($$0|0); //@line 136087 "c/sqlite3.c"
 }
 $24 = HEAP32[$22>>2]|0; //@line 136085 "c/sqlite3.c"
 $$0 = $24;
 return ($$0|0); //@line 136087 "c/sqlite3.c"
}
function _sqlite3BinaryCompareCollSeq($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 4|0); //@line 93005 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 93005 "c/sqlite3.c"
 $5 = $4 & 256; //@line 93005 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 93005 "c/sqlite3.c"
 if (!($6)) {
  $7 = (_sqlite3ExprCollSeq($0,$1)|0); //@line 93006 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 93015 "c/sqlite3.c"
 }
 $8 = ($2|0)==(0|0); //@line 93007 "c/sqlite3.c"
 if (!($8)) {
  $9 = ((($2)) + 4|0); //@line 93007 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 93007 "c/sqlite3.c"
  $11 = $10 & 256; //@line 93007 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 93007 "c/sqlite3.c"
  if (!($12)) {
   $13 = (_sqlite3ExprCollSeq($0,$2)|0); //@line 93008 "c/sqlite3.c"
   $$0 = $13;
   return ($$0|0); //@line 93015 "c/sqlite3.c"
  }
 }
 $14 = (_sqlite3ExprCollSeq($0,$1)|0); //@line 93010 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 93011 "c/sqlite3.c"
 if (!($15)) {
  $$0 = $14;
  return ($$0|0); //@line 93015 "c/sqlite3.c"
 }
 $16 = (_sqlite3ExprCollSeq($0,$2)|0); //@line 93012 "c/sqlite3.c"
 $$0 = $16;
 return ($$0|0); //@line 93015 "c/sqlite3.c"
}
function _sqlite3ExprCollSeq($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$069$be = 0, $$06983 = 0, $$080 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 92825 "c/sqlite3.c"
 $3 = ($1|0)==(0|0); //@line 92828 "c/sqlite3.c"
 L1: do {
  if ($3) {
   $$3 = 0;
  } else {
   $$06983 = $1;
   L3: while(1) {
    $4 = ((($$06983)) + 4|0); //@line 92830 "c/sqlite3.c"
    $5 = HEAP32[$4>>2]|0; //@line 92830 "c/sqlite3.c"
    $6 = $5 & 512; //@line 92830 "c/sqlite3.c"
    $7 = ($6|0)==(0); //@line 92830 "c/sqlite3.c"
    if (!($7)) {
     $$3 = 0;
     break L1;
    }
    $8 = HEAP8[$$06983>>0]|0; //@line 92829 "c/sqlite3.c"
    switch ($8<<24>>24) {
    case 94:  {
     label = 6;
     break L3;
     break;
    }
    case 36: case -107:  {
     $58 = ((($$06983)) + 12|0); //@line 92832 "c/sqlite3.c"
     $59 = HEAP32[$58>>2]|0; //@line 92832 "c/sqlite3.c"
     $$069$be = $59;
     break;
    }
    case -106:  {
     $9 = ((($$06983)) + 38|0); //@line 92835 "c/sqlite3.c"
     $10 = HEAP8[$9>>0]|0; //@line 92835 "c/sqlite3.c"
     $11 = ($10<<24>>24)==(94); //@line 92835 "c/sqlite3.c"
     if ($11) {
      label = 6;
      break L3;
     } else {
      label = 7;
     }
     break;
    }
    case 75: case -111: case -109:  {
     label = 7;
     break;
    }
    default: {
     label = 10;
    }
    }
    if ((label|0) == 7) {
     label = 0;
     $17 = ((($$06983)) + 44|0); //@line 92841 "c/sqlite3.c"
     $18 = HEAP32[$17>>2]|0; //@line 92841 "c/sqlite3.c"
     $19 = ($18|0)==(0|0); //@line 92841 "c/sqlite3.c"
     if ($19) {
      label = 10;
     } else {
      break;
     }
    }
    L11: do {
     if ((label|0) == 10) {
      label = 0;
      $31 = $5 & 256; //@line 92852 "c/sqlite3.c"
      $32 = ($31|0)==(0); //@line 92852 "c/sqlite3.c"
      if ($32) {
       $$3 = 0;
       break L1;
      }
      $33 = ((($$06983)) + 12|0); //@line 92853 "c/sqlite3.c"
      $34 = HEAP32[$33>>2]|0; //@line 92853 "c/sqlite3.c"
      $35 = ($34|0)==(0|0); //@line 92853 "c/sqlite3.c"
      if (!($35)) {
       $36 = ((($34)) + 4|0); //@line 92853 "c/sqlite3.c"
       $37 = HEAP32[$36>>2]|0; //@line 92853 "c/sqlite3.c"
       $38 = $37 & 256; //@line 92853 "c/sqlite3.c"
       $39 = ($38|0)==(0); //@line 92853 "c/sqlite3.c"
       if (!($39)) {
        $$069$be = $34;
        break;
       }
      }
      $40 = ((($$06983)) + 16|0); //@line 92856 "c/sqlite3.c"
      $41 = HEAP32[$40>>2]|0; //@line 92856 "c/sqlite3.c"
      $42 = ((($$06983)) + 20|0); //@line 92862 "c/sqlite3.c"
      $43 = HEAP32[$42>>2]|0; //@line 92862 "c/sqlite3.c"
      $44 = ($43|0)!=(0|0); //@line 92862 "c/sqlite3.c"
      $45 = $5 & 2048; //@line 92862 "c/sqlite3.c"
      $46 = ($45|0)==(0); //@line 92862 "c/sqlite3.c"
      $or$cond = $46 & $44; //@line 92862 "c/sqlite3.c"
      if ($or$cond) {
       $47 = HEAP32[$43>>2]|0; //@line 92864 "c/sqlite3.c"
       $48 = ($47|0)>(0); //@line 92864 "c/sqlite3.c"
       if ($48) {
        $$080 = 0;
        while(1) {
         $52 = (((($43)) + 4|0) + (($$080*20)|0)|0); //@line 92865 "c/sqlite3.c"
         $53 = HEAP32[$52>>2]|0; //@line 92865 "c/sqlite3.c"
         $54 = ((($53)) + 4|0); //@line 92865 "c/sqlite3.c"
         $55 = HEAP32[$54>>2]|0; //@line 92865 "c/sqlite3.c"
         $56 = $55 & 256; //@line 92865 "c/sqlite3.c"
         $57 = ($56|0)==(0); //@line 92865 "c/sqlite3.c"
         $51 = (($$080) + 1)|0; //@line 92864 "c/sqlite3.c"
         if (!($57)) {
          $$069$be = $53;
          break L11;
         }
         $49 = HEAP32[$43>>2]|0; //@line 92864 "c/sqlite3.c"
         $50 = ($51|0)<($49|0); //@line 92864 "c/sqlite3.c"
         if ($50) {
          $$080 = $51;
         } else {
          $$069$be = $41;
          break;
         }
        }
       } else {
        $$069$be = $41;
       }
      } else {
       $$069$be = $41;
      }
     }
    } while(0);
    $60 = ($$069$be|0)==(0|0); //@line 92828 "c/sqlite3.c"
    if ($60) {
     $$3 = 0;
     break L1;
    } else {
     $$06983 = $$069$be;
    }
   }
   if ((label|0) == 6) {
    $12 = ((($2)) + 70|0); //@line 92836 "c/sqlite3.c"
    $13 = HEAP8[$12>>0]|0; //@line 92836 "c/sqlite3.c"
    $14 = ((($$06983)) + 8|0); //@line 92836 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 92836 "c/sqlite3.c"
    $16 = (_sqlite3GetCollSeq($0,$13,0,$15)|0); //@line 92836 "c/sqlite3.c"
    $$3 = $16;
    break;
   }
   $20 = ((($$06983)) + 32|0); //@line 92845 "c/sqlite3.c"
   $21 = HEAP16[$20>>1]|0; //@line 92845 "c/sqlite3.c"
   $22 = ($21<<16>>16)>(-1); //@line 92846 "c/sqlite3.c"
   if ($22) {
    $23 = $21 << 16 >> 16; //@line 92845 "c/sqlite3.c"
    $24 = ((($18)) + 4|0); //@line 92847 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 92847 "c/sqlite3.c"
    $26 = (((($25) + ($23<<4)|0)) + 8|0); //@line 92847 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 92847 "c/sqlite3.c"
    $28 = ((($2)) + 70|0); //@line 92848 "c/sqlite3.c"
    $29 = HEAP8[$28>>0]|0; //@line 92848 "c/sqlite3.c"
    $30 = (_sqlite3FindCollSeq($2,$29,$27,0)|0); //@line 92848 "c/sqlite3.c"
    $$3 = $30;
   } else {
    $$3 = 0;
   }
  }
 } while(0);
 $61 = (_sqlite3CheckCollSeq($0,$$3)|0); //@line 92877 "c/sqlite3.c"
 $62 = ($61|0)==(0); //@line 92877 "c/sqlite3.c"
 $spec$select = $62 ? $$3 : 0; //@line 92877 "c/sqlite3.c"
 return ($spec$select|0); //@line 92880 "c/sqlite3.c"
}
function _sqlite3GetCollSeq($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$025 = 0, $$127 = 0, $$229 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 106161 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 106167 "c/sqlite3.c"
 $5 = ($2|0)==(0|0); //@line 106170 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3FindCollSeq($4,$1,$3,0)|0); //@line 106171 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 106173 "c/sqlite3.c"
  if ($7) {
   label = 4;
  } else {
   $$025 = $6;
   label = 3;
  }
 } else {
  $$025 = $2;
  label = 3;
 }
 if ((label|0) == 3) {
  $8 = ((($$025)) + 12|0); //@line 106173 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 106173 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 106173 "c/sqlite3.c"
  if ($10) {
   label = 4;
  } else {
   $$127 = $$025;
   label = 5;
  }
 }
 if ((label|0) == 4) {
  $11 = $1&255; //@line 106177 "c/sqlite3.c"
  _callCollNeeded($4,$11,$3); //@line 106177 "c/sqlite3.c"
  $12 = (_sqlite3FindCollSeq($4,$1,$3,0)|0); //@line 106178 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 106180 "c/sqlite3.c"
  if (!($13)) {
   $$127 = $12;
   label = 5;
  }
 }
 if ((label|0) == 5) {
  $14 = ((($$127)) + 12|0); //@line 106180 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 106180 "c/sqlite3.c"
  $16 = ($15|0)==(0|0); //@line 106180 "c/sqlite3.c"
  if (!($16)) {
   $$229 = $$127;
   STACKTOP = sp;return ($$229|0); //@line 106188 "c/sqlite3.c"
  }
  $17 = (_synthCollSeq($4,$$127)|0); //@line 106180 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 106180 "c/sqlite3.c"
  if ($18) {
   $$229 = $$127;
   STACKTOP = sp;return ($$229|0); //@line 106188 "c/sqlite3.c"
  }
 }
 HEAP32[$vararg_buffer>>2] = $3; //@line 106185 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,18045,$vararg_buffer); //@line 106185 "c/sqlite3.c"
 $19 = ((($0)) + 12|0); //@line 106186 "c/sqlite3.c"
 HEAP32[$19>>2] = 257; //@line 106186 "c/sqlite3.c"
 $$229 = 0;
 STACKTOP = sp;return ($$229|0); //@line 106188 "c/sqlite3.c"
}
function _sqlite3FindCollSeq($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($2|0)==(0|0); //@line 106289 "c/sqlite3.c"
 if ($4) {
  $6 = ((($0)) + 8|0); //@line 106292 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 106292 "c/sqlite3.c"
  $$0 = $7;
 } else {
  $5 = (_findCollSeqEntry($0,$2,$3)|0); //@line 106290 "c/sqlite3.c"
  $$0 = $5;
 }
 $8 = ($$0|0)==(0|0); //@line 106296 "c/sqlite3.c"
 $9 = $1&255; //@line 106296 "c/sqlite3.c"
 $10 = (($9) + -1)|0; //@line 106296 "c/sqlite3.c"
 $11 = (($$0) + (($10*20)|0)|0); //@line 106296 "c/sqlite3.c"
 $spec$select = $8 ? 0 : $11; //@line 106296 "c/sqlite3.c"
 return ($spec$select|0); //@line 106297 "c/sqlite3.c"
}
function _sqlite3CheckCollSeq($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 106203 "c/sqlite3.c"
 if (!($2)) {
  $3 = ((($1)) + 12|0); //@line 106203 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 106203 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 106203 "c/sqlite3.c"
  if ($5) {
   $6 = HEAP32[$1>>2]|0; //@line 106204 "c/sqlite3.c"
   $7 = HEAP32[$0>>2]|0; //@line 106205 "c/sqlite3.c"
   $8 = ((($7)) + 70|0); //@line 106206 "c/sqlite3.c"
   $9 = HEAP8[$8>>0]|0; //@line 106206 "c/sqlite3.c"
   $10 = (_sqlite3GetCollSeq($0,$9,$1,$6)|0); //@line 106206 "c/sqlite3.c"
   $11 = ($10|0)==(0|0); //@line 106207 "c/sqlite3.c"
   if ($11) {
    $$1 = 1;
    return ($$1|0); //@line 106213 "c/sqlite3.c"
   }
  }
 }
 $$1 = 0;
 return ($$1|0); //@line 106213 "c/sqlite3.c"
}
function _findCollSeqEntry($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 372|0); //@line 106236 "c/sqlite3.c"
 $4 = (_sqlite3HashFind($3,$1)|0); //@line 106236 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 106238 "c/sqlite3.c"
 $6 = ($2|0)!=(0); //@line 106238 "c/sqlite3.c"
 $or$cond = $6 & $5; //@line 106238 "c/sqlite3.c"
 if (!($or$cond)) {
  $$2 = $4;
  return ($$2|0); //@line 106264 "c/sqlite3.c"
 }
 $7 = (_sqlite3Strlen30($1)|0); //@line 106239 "c/sqlite3.c"
 $8 = (($7) + 61)|0; //@line 106240 "c/sqlite3.c"
 $9 = (_sqlite3DbMallocZero($0,$8,0)|0); //@line 106240 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 106241 "c/sqlite3.c"
 if ($10) {
  $$2 = $9;
  return ($$2|0); //@line 106264 "c/sqlite3.c"
 }
 $11 = (($7) + 1)|0; //@line 106239 "c/sqlite3.c"
 $12 = ((($9)) + 60|0); //@line 106243 "c/sqlite3.c"
 HEAP32[$9>>2] = $12; //@line 106243 "c/sqlite3.c"
 $13 = ((($9)) + 4|0); //@line 106244 "c/sqlite3.c"
 HEAP8[$13>>0] = 1; //@line 106244 "c/sqlite3.c"
 $14 = ((($9)) + 20|0); //@line 106245 "c/sqlite3.c"
 HEAP32[$14>>2] = $12; //@line 106245 "c/sqlite3.c"
 $15 = ((($9)) + 24|0); //@line 106246 "c/sqlite3.c"
 HEAP8[$15>>0] = 2; //@line 106246 "c/sqlite3.c"
 $16 = ((($9)) + 40|0); //@line 106247 "c/sqlite3.c"
 HEAP32[$16>>2] = $12; //@line 106247 "c/sqlite3.c"
 $17 = ((($9)) + 44|0); //@line 106248 "c/sqlite3.c"
 HEAP8[$17>>0] = 3; //@line 106248 "c/sqlite3.c"
 _memcpy(($12|0),($1|0),($11|0))|0; //@line 106249 "c/sqlite3.c"
 $18 = HEAP32[$9>>2]|0; //@line 106250 "c/sqlite3.c"
 $19 = (_sqlite3HashInsert($3,$18,$9)|0); //@line 106250 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 106257 "c/sqlite3.c"
 if ($20) {
  $$2 = $9;
  return ($$2|0); //@line 106264 "c/sqlite3.c"
 }
 _sqlite3OomFault($0); //@line 106258 "c/sqlite3.c"
 _sqlite3DbFree($0,$19); //@line 106259 "c/sqlite3.c"
 $$2 = 0;
 return ($$2|0); //@line 106264 "c/sqlite3.c"
}
function _sqlite3HashFind($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_findElementWithHash($0,$1,0)|0); //@line 30305 "c/sqlite3.c"
 $3 = ((($2)) + 8|0); //@line 30305 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 30305 "c/sqlite3.c"
 return ($4|0); //@line 30305 "c/sqlite3.c"
}
function _sqlite3HashInsert($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = (_findElementWithHash($0,$1,$3)|0); //@line 30329 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 30330 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 30330 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 30330 "c/sqlite3.c"
 $8 = ($2|0)==(0|0);
 if (!($7)) {
  if ($8) {
   $9 = HEAP32[$3>>2]|0; //@line 30333 "c/sqlite3.c"
   _removeElementGivenHash($0,$4,$9); //@line 30333 "c/sqlite3.c"
   $$0 = $6;
   STACKTOP = sp;return ($$0|0); //@line 30354 "c/sqlite3.c"
  } else {
   HEAP32[$5>>2] = $2; //@line 30335 "c/sqlite3.c"
   $10 = ((($4)) + 12|0); //@line 30336 "c/sqlite3.c"
   HEAP32[$10>>2] = $1; //@line 30336 "c/sqlite3.c"
   $$0 = $6;
   STACKTOP = sp;return ($$0|0); //@line 30354 "c/sqlite3.c"
  }
 }
 if ($8) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 30354 "c/sqlite3.c"
 }
 $11 = (_sqlite3Malloc(16,0)|0); //@line 30341 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 30342 "c/sqlite3.c"
 if ($12) {
  $$0 = $2;
  STACKTOP = sp;return ($$0|0); //@line 30354 "c/sqlite3.c"
 }
 $13 = ((($11)) + 12|0); //@line 30343 "c/sqlite3.c"
 HEAP32[$13>>2] = $1; //@line 30343 "c/sqlite3.c"
 $14 = ((($11)) + 8|0); //@line 30344 "c/sqlite3.c"
 HEAP32[$14>>2] = $2; //@line 30344 "c/sqlite3.c"
 $15 = ((($0)) + 4|0); //@line 30345 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 30345 "c/sqlite3.c"
 $17 = (($16) + 1)|0; //@line 30345 "c/sqlite3.c"
 HEAP32[$15>>2] = $17; //@line 30345 "c/sqlite3.c"
 $18 = ($17>>>0)>(9); //@line 30346 "c/sqlite3.c"
 if ($18) {
  $19 = HEAP32[$0>>2]|0; //@line 30346 "c/sqlite3.c"
  $20 = $19 << 1; //@line 30346 "c/sqlite3.c"
  $21 = ($17>>>0)>($20>>>0); //@line 30346 "c/sqlite3.c"
  if ($21) {
   $22 = $17 << 1; //@line 30347 "c/sqlite3.c"
   $23 = (_rehash($0,$22)|0); //@line 30347 "c/sqlite3.c"
   $24 = ($23|0)==(0); //@line 30347 "c/sqlite3.c"
   if (!($24)) {
    $25 = (_strHash($1)|0); //@line 30349 "c/sqlite3.c"
    $26 = HEAP32[$0>>2]|0; //@line 30349 "c/sqlite3.c"
    $27 = (($25>>>0) % ($26>>>0))&-1; //@line 30349 "c/sqlite3.c"
    HEAP32[$3>>2] = $27; //@line 30349 "c/sqlite3.c"
   }
  }
 }
 $28 = ((($0)) + 12|0); //@line 30352 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 30352 "c/sqlite3.c"
 $30 = ($29|0)==(0|0); //@line 30352 "c/sqlite3.c"
 $31 = HEAP32[$3>>2]|0; //@line 30352 "c/sqlite3.c"
 $32 = (($29) + ($31<<3)|0); //@line 30352 "c/sqlite3.c"
 $33 = $30 ? 0 : $32; //@line 30352 "c/sqlite3.c"
 _insertElement($0,$33,$11); //@line 30352 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 30354 "c/sqlite3.c"
}
function _findElementWithHash($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$023 = 0, $$024 = 0, $$024$in = 0, $$025 = 0, $$025$in = 0, $$12627 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 30242 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 30242 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 30242 "c/sqlite3.c"
 if ($5) {
  $11 = ((($0)) + 8|0); //@line 30250 "c/sqlite3.c"
  $12 = ((($0)) + 4|0); //@line 30251 "c/sqlite3.c"
  $$023 = 0;$$024$in = $12;$$025$in = $11;
 } else {
  $6 = (_strHash($1)|0); //@line 30244 "c/sqlite3.c"
  $7 = HEAP32[$0>>2]|0; //@line 30244 "c/sqlite3.c"
  $8 = (($6>>>0) % ($7>>>0))&-1; //@line 30244 "c/sqlite3.c"
  $9 = (((($4) + ($8<<3)|0)) + 4|0); //@line 30246 "c/sqlite3.c"
  $10 = (($4) + ($8<<3)|0); //@line 30247 "c/sqlite3.c"
  $$023 = $8;$$024$in = $10;$$025$in = $9;
 }
 $$024 = HEAP32[$$024$in>>2]|0;
 $$025 = HEAP32[$$025$in>>2]|0;
 $13 = ($2|0)==(0|0); //@line 30253 "c/sqlite3.c"
 if (!($13)) {
  HEAP32[$2>>2] = $$023; //@line 30253 "c/sqlite3.c"
 }
 $14 = ($$024|0)==(0); //@line 30254 "c/sqlite3.c"
 if ($14) {
  $$0 = 40408;
  return ($$0|0); //@line 30262 "c/sqlite3.c"
 }
 $$12627 = $$025;$$in = $$024;
 while(1) {
  $15 = (($$in) + -1)|0; //@line 30254 "c/sqlite3.c"
  $16 = ((($$12627)) + 12|0); //@line 30256 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 30256 "c/sqlite3.c"
  $18 = (_sqlite3StrICmp($17,$1)|0); //@line 30256 "c/sqlite3.c"
  $19 = ($18|0)==(0); //@line 30256 "c/sqlite3.c"
  if ($19) {
   $$0 = $$12627;
   label = 10;
   break;
  }
  $20 = HEAP32[$$12627>>2]|0; //@line 30259 "c/sqlite3.c"
  $21 = ($15|0)==(0); //@line 30254 "c/sqlite3.c"
  if ($21) {
   $$0 = 40408;
   label = 10;
   break;
  } else {
   $$12627 = $20;$$in = $15;
  }
 }
 if ((label|0) == 10) {
  return ($$0|0); //@line 30262 "c/sqlite3.c"
 }
 return (0)|0;
}
function _removeElementGivenHash($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 4|0); //@line 30273 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 30273 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 30273 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0;
 $7 = ((($0)) + 8|0); //@line 30276 "c/sqlite3.c"
 $$sink = $5 ? $7 : $4; //@line 30273 "c/sqlite3.c"
 HEAP32[$$sink>>2] = $6;
 $8 = HEAP32[$1>>2]|0; //@line 30278 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 30278 "c/sqlite3.c"
 if (!($9)) {
  $10 = HEAP32[$3>>2]|0; //@line 30279 "c/sqlite3.c"
  $11 = ((($8)) + 4|0); //@line 30279 "c/sqlite3.c"
  HEAP32[$11>>2] = $10; //@line 30279 "c/sqlite3.c"
 }
 $12 = ((($0)) + 12|0); //@line 30281 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 30281 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 30281 "c/sqlite3.c"
 if (!($14)) {
  $15 = (((($13) + ($2<<3)|0)) + 4|0); //@line 30283 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 30283 "c/sqlite3.c"
  $17 = ($16|0)==($1|0); //@line 30283 "c/sqlite3.c"
  if ($17) {
   $18 = HEAP32[$1>>2]|0; //@line 30284 "c/sqlite3.c"
   HEAP32[$15>>2] = $18; //@line 30284 "c/sqlite3.c"
  }
  $19 = (($13) + ($2<<3)|0); //@line 30286 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 30286 "c/sqlite3.c"
  $21 = (($20) + -1)|0; //@line 30286 "c/sqlite3.c"
  HEAP32[$19>>2] = $21; //@line 30286 "c/sqlite3.c"
 }
 _sqlite3_free($1); //@line 30289 "c/sqlite3.c"
 $22 = ((($0)) + 4|0); //@line 30290 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 30290 "c/sqlite3.c"
 $24 = (($23) + -1)|0; //@line 30290 "c/sqlite3.c"
 HEAP32[$22>>2] = $24; //@line 30290 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 30291 "c/sqlite3.c"
 if (!($25)) {
  return; //@line 30296 "c/sqlite3.c"
 }
 _sqlite3HashClear($0); //@line 30294 "c/sqlite3.c"
 return; //@line 30296 "c/sqlite3.c"
}
function _rehash($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$03132 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1 << 3; //@line 30196 "c/sqlite3.c"
 $3 = ($2>>>0)>(1024); //@line 30196 "c/sqlite3.c"
 $spec$select = $3 ? 128 : $1; //@line 30196 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 30199 "c/sqlite3.c"
 $5 = ($spec$select|0)==($4|0); //@line 30199 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 30225 "c/sqlite3.c"
 }
 _sqlite3BeginBenignMalloc(); //@line 30210 "c/sqlite3.c"
 $6 = $spec$select << 3; //@line 30211 "c/sqlite3.c"
 $7 = (_sqlite3Malloc($6,0)|0); //@line 30211 "c/sqlite3.c"
 _sqlite3EndBenignMalloc(); //@line 30212 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 30214 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 30225 "c/sqlite3.c"
 }
 $9 = ((($0)) + 12|0); //@line 30215 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 30215 "c/sqlite3.c"
 _sqlite3_free($10); //@line 30215 "c/sqlite3.c"
 HEAP32[$9>>2] = $7; //@line 30216 "c/sqlite3.c"
 $11 = (_sqlite3MallocSize($7)|0); //@line 30217 "c/sqlite3.c"
 $12 = $11 >>> 3; //@line 30217 "c/sqlite3.c"
 HEAP32[$0>>2] = $12; //@line 30217 "c/sqlite3.c"
 $13 = $11 & -8; //@line 30218 "c/sqlite3.c"
 _memset(($7|0),0,($13|0))|0; //@line 30218 "c/sqlite3.c"
 $14 = ((($0)) + 8|0); //@line 30219 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 30219 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 30219 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 30219 "c/sqlite3.c"
 if ($16) {
  $$0 = 1;
  return ($$0|0); //@line 30225 "c/sqlite3.c"
 }
 $$03132 = $15;
 while(1) {
  $17 = ((($$03132)) + 12|0); //@line 30220 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 30220 "c/sqlite3.c"
  $19 = (_strHash($18)|0); //@line 30220 "c/sqlite3.c"
  $20 = (($19>>>0) % ($12>>>0))&-1; //@line 30220 "c/sqlite3.c"
  $21 = HEAP32[$$03132>>2]|0; //@line 30221 "c/sqlite3.c"
  $22 = (($7) + ($20<<3)|0); //@line 30222 "c/sqlite3.c"
  _insertElement($0,$22,$$03132); //@line 30222 "c/sqlite3.c"
  $23 = ($21|0)==(0|0); //@line 30219 "c/sqlite3.c"
  if ($23) {
   $$0 = 1;
   break;
  } else {
   $$03132 = $21;
  }
 }
 return ($$0|0); //@line 30225 "c/sqlite3.c"
}
function _strHash($0) {
 $0 = $0|0;
 var $$05$lcssa = 0, $$056 = 0, $$07 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 30143 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(0); //@line 30143 "c/sqlite3.c"
 if ($2) {
  $$05$lcssa = 0;
  return ($$05$lcssa|0); //@line 30150 "c/sqlite3.c"
 }
 $$056 = 0;$$07 = $0;$4 = $1;
 while(1) {
  $3 = $4&255; //@line 30143 "c/sqlite3.c"
  $5 = ((($$07)) + 1|0); //@line 30143 "c/sqlite3.c"
  $6 = (16025 + ($3)|0); //@line 30147 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 30147 "c/sqlite3.c"
  $8 = $7&255; //@line 30147 "c/sqlite3.c"
  $9 = (($$056) + ($8))|0; //@line 30147 "c/sqlite3.c"
  $10 = Math_imul($9, -1640531535)|0; //@line 30148 "c/sqlite3.c"
  $11 = HEAP8[$5>>0]|0; //@line 30143 "c/sqlite3.c"
  $12 = ($11<<24>>24)==(0); //@line 30143 "c/sqlite3.c"
  if ($12) {
   $$05$lcssa = $10;
   break;
  } else {
   $$056 = $10;$$07 = $5;$4 = $11;
  }
 }
 return ($$05$lcssa|0); //@line 30150 "c/sqlite3.c"
}
function _insertElement($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$sink = 0, $$sink27 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 30163 "c/sqlite3.c"
 do {
  if (!($3)) {
   $4 = HEAP32[$1>>2]|0; //@line 30164 "c/sqlite3.c"
   $5 = ($4|0)==(0); //@line 30164 "c/sqlite3.c"
   if ($5) {
    $6 = (($4) + 1)|0; //@line 30165 "c/sqlite3.c"
    HEAP32[$1>>2] = $6; //@line 30165 "c/sqlite3.c"
    $7 = ((($1)) + 4|0); //@line 30166 "c/sqlite3.c"
    HEAP32[$7>>2] = $2; //@line 30166 "c/sqlite3.c"
    break;
   }
   $8 = ((($1)) + 4|0); //@line 30164 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 30164 "c/sqlite3.c"
   $10 = (($4) + 1)|0; //@line 30165 "c/sqlite3.c"
   HEAP32[$1>>2] = $10; //@line 30165 "c/sqlite3.c"
   $11 = ((($1)) + 4|0); //@line 30166 "c/sqlite3.c"
   HEAP32[$11>>2] = $2; //@line 30166 "c/sqlite3.c"
   $12 = ($9|0)==(0|0); //@line 30170 "c/sqlite3.c"
   if (!($12)) {
    HEAP32[$2>>2] = $9; //@line 30171 "c/sqlite3.c"
    $13 = ((($9)) + 4|0); //@line 30172 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 30172 "c/sqlite3.c"
    $15 = ((($2)) + 4|0); //@line 30172 "c/sqlite3.c"
    HEAP32[$15>>2] = $14; //@line 30172 "c/sqlite3.c"
    $16 = HEAP32[$13>>2]|0; //@line 30173 "c/sqlite3.c"
    $17 = ($16|0)==(0|0); //@line 30173 "c/sqlite3.c"
    $18 = ((($0)) + 8|0); //@line 30174 "c/sqlite3.c"
    $$sink = $17 ? $18 : $16; //@line 30173 "c/sqlite3.c"
    HEAP32[$$sink>>2] = $2;
    $$sink27 = $13;
    HEAP32[$$sink27>>2] = $2;
    return; //@line 30182 "c/sqlite3.c"
   }
  }
 } while(0);
 $19 = ((($0)) + 8|0); //@line 30177 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 30177 "c/sqlite3.c"
 HEAP32[$2>>2] = $20; //@line 30177 "c/sqlite3.c"
 $21 = HEAP32[$19>>2]|0; //@line 30178 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 30178 "c/sqlite3.c"
 if (!($22)) {
  $23 = ((($21)) + 4|0); //@line 30178 "c/sqlite3.c"
  HEAP32[$23>>2] = $2; //@line 30178 "c/sqlite3.c"
 }
 $24 = ((($2)) + 4|0); //@line 30179 "c/sqlite3.c"
 HEAP32[$24>>2] = 0; //@line 30179 "c/sqlite3.c"
 $$sink27 = $19;
 HEAP32[$$sink27>>2] = $2;
 return; //@line 30182 "c/sqlite3.c"
}
function _sqlite3HashClear($0) {
 $0 = $0|0;
 var $$in1314 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 30124 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 30124 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 30125 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 30126 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 30126 "c/sqlite3.c"
 _sqlite3_free($4); //@line 30126 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 30127 "c/sqlite3.c"
 HEAP32[$0>>2] = 0; //@line 30128 "c/sqlite3.c"
 $5 = ($2|0)==(0|0); //@line 30129 "c/sqlite3.c"
 if ($5) {
  $8 = ((($0)) + 4|0); //@line 30134 "c/sqlite3.c"
  HEAP32[$8>>2] = 0; //@line 30134 "c/sqlite3.c"
  return; //@line 30135 "c/sqlite3.c"
 }
 $$in1314 = $2;
 while(1) {
  $6 = HEAP32[$$in1314>>2]|0; //@line 30130 "c/sqlite3.c"
  _sqlite3_free($$in1314); //@line 30131 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 30129 "c/sqlite3.c"
  if ($7) {
   break;
  } else {
   $$in1314 = $6;
  }
 }
 $8 = ((($0)) + 4|0); //@line 30134 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 30134 "c/sqlite3.c"
 return; //@line 30135 "c/sqlite3.c"
}
function _callCollNeeded($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 236|0); //@line 106103 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 106103 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 106103 "c/sqlite3.c"
 do {
  if (!($5)) {
   $6 = (_sqlite3DbStrDup($0,$2)|0); //@line 106104 "c/sqlite3.c"
   $7 = ($6|0)==(0|0); //@line 106105 "c/sqlite3.c"
   if ($7) {
    return; //@line 106121 "c/sqlite3.c"
   } else {
    $8 = HEAP32[$3>>2]|0; //@line 106106 "c/sqlite3.c"
    $9 = ((($0)) + 244|0); //@line 106106 "c/sqlite3.c"
    $10 = HEAP32[$9>>2]|0; //@line 106106 "c/sqlite3.c"
    FUNCTION_TABLE_viiii[$8 & 127]($10,$0,$1,$6); //@line 106106 "c/sqlite3.c"
    _sqlite3DbFree($0,$6); //@line 106107 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $11 = ((($0)) + 240|0); //@line 106110 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 106110 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 106110 "c/sqlite3.c"
 if ($13) {
  return; //@line 106121 "c/sqlite3.c"
 }
 $14 = (_sqlite3ValueNew($0)|0); //@line 106112 "c/sqlite3.c"
 _sqlite3ValueSetStr($14,$2,1,0); //@line 106113 "c/sqlite3.c"
 $15 = (_sqlite3ValueText($14,2)|0); //@line 106114 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 106115 "c/sqlite3.c"
 if (!($16)) {
  $17 = HEAP32[$11>>2]|0; //@line 106116 "c/sqlite3.c"
  $18 = ((($0)) + 244|0); //@line 106116 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 106116 "c/sqlite3.c"
  $20 = ((($0)) + 70|0); //@line 106116 "c/sqlite3.c"
  $21 = HEAP8[$20>>0]|0; //@line 106116 "c/sqlite3.c"
  $22 = $21&255; //@line 106116 "c/sqlite3.c"
  FUNCTION_TABLE_viiii[$17 & 127]($19,$0,$22,$15); //@line 106116 "c/sqlite3.c"
 }
 _sqlite3ValueFree($14); //@line 106118 "c/sqlite3.c"
 return; //@line 106121 "c/sqlite3.c"
}
function _synthCollSeq($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$015 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 106132 "c/sqlite3.c"
 $3 = (_sqlite3FindCollSeq($0,3,$2,0)|0); //@line 106136 "c/sqlite3.c"
 $4 = ((($3)) + 12|0); //@line 106137 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 106137 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 106137 "c/sqlite3.c"
 if ($6) {
  $7 = (_sqlite3FindCollSeq($0,2,$2,0)|0); //@line 106136 "c/sqlite3.c"
  $8 = ((($7)) + 12|0); //@line 106137 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 106137 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 106137 "c/sqlite3.c"
  if ($10) {
   $12 = (_sqlite3FindCollSeq($0,1,$2,0)|0); //@line 106136 "c/sqlite3.c"
   $13 = ((($12)) + 12|0); //@line 106137 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 106137 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 106137 "c/sqlite3.c"
   if ($15) {
    $$015 = 1;
    return ($$015|0); //@line 106144 "c/sqlite3.c"
   } else {
    $$lcssa = $12;
   }
  } else {
   $$lcssa = $7;
  }
 } else {
  $$lcssa = $3;
 }
 ;HEAP32[$1>>2]=HEAP32[$$lcssa>>2]|0;HEAP32[$1+4>>2]=HEAP32[$$lcssa+4>>2]|0;HEAP32[$1+8>>2]=HEAP32[$$lcssa+8>>2]|0;HEAP32[$1+12>>2]=HEAP32[$$lcssa+12>>2]|0; //@line 106138 "c/sqlite3.c"
 $11 = ((($1)) + 16|0); //@line 106139 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 106139 "c/sqlite3.c"
 $$015 = 0;
 return ($$015|0); //@line 106144 "c/sqlite3.c"
}
function _sqlite3ErrorMsg($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 28682 "c/sqlite3.c"
 HEAP32[$2>>2] = $varargs; //@line 28683 "c/sqlite3.c"
 $4 = (_sqlite3VMPrintf($3,$1,$2)|0); //@line 28684 "c/sqlite3.c"
 $5 = ((($3)) + 77|0); //@line 28686 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 28686 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 28686 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 36|0); //@line 28689 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 28689 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 28689 "c/sqlite3.c"
  HEAP32[$8>>2] = $10; //@line 28689 "c/sqlite3.c"
  $11 = ((($0)) + 4|0); //@line 28690 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 28690 "c/sqlite3.c"
  _sqlite3DbFree($3,$12); //@line 28690 "c/sqlite3.c"
  HEAP32[$11>>2] = $4; //@line 28691 "c/sqlite3.c"
  $13 = ((($0)) + 12|0); //@line 28692 "c/sqlite3.c"
  HEAP32[$13>>2] = 1; //@line 28692 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 28694 "c/sqlite3.c"
 } else {
  _sqlite3DbFree($3,$4); //@line 28687 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 28694 "c/sqlite3.c"
 }
}
function _sqlite3VMPrintf($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $3 = sp + 24|0;
 $4 = sp;
 $5 = ((($0)) + 100|0); //@line 26802 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 26802 "c/sqlite3.c"
 _sqlite3StrAccumInit($4,$0,$3,70,$6); //@line 26801 "c/sqlite3.c"
 $7 = ((($4)) + 21|0); //@line 26803 "c/sqlite3.c"
 HEAP8[$7>>0] = 1; //@line 26803 "c/sqlite3.c"
 _sqlite3VXPrintf($4,$1,$2); //@line 26804 "c/sqlite3.c"
 $8 = (_sqlite3StrAccumFinish($4)|0); //@line 26805 "c/sqlite3.c"
 $9 = ((($4)) + 20|0); //@line 26806 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 26806 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(1); //@line 26806 "c/sqlite3.c"
 if (!($11)) {
  STACKTOP = sp;return ($8|0); //@line 26809 "c/sqlite3.c"
 }
 _sqlite3OomFault($0); //@line 26807 "c/sqlite3.c"
 STACKTOP = sp;return ($8|0); //@line 26809 "c/sqlite3.c"
}
function _sqlite3DbStrDup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 25745 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
 } else {
  $3 = (_strlen($1)|0); //@line 25748 "c/sqlite3.c"
  $4 = (($3) + 1)|0; //@line 25748 "c/sqlite3.c"
  $5 = (_sqlite3DbMallocRaw($0,$4,0)|0); //@line 25749 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 25750 "c/sqlite3.c"
  if ($6) {
   $$0 = 0;
  } else {
   _memcpy(($5|0),($1|0),($4|0))|0; //@line 25751 "c/sqlite3.c"
   $$0 = $5;
  }
 }
 return ($$0|0); //@line 25754 "c/sqlite3.c"
}
function _sqlite3ValueNew($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3DbMallocZero($0,40,0)|0); //@line 72311 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 72312 "c/sqlite3.c"
 if ($2) {
  return ($1|0); //@line 72316 "c/sqlite3.c"
 }
 $3 = ((($1)) + 8|0); //@line 72313 "c/sqlite3.c"
 HEAP16[$3>>1] = 1; //@line 72313 "c/sqlite3.c"
 $4 = ((($1)) + 32|0); //@line 72314 "c/sqlite3.c"
 HEAP32[$4>>2] = $0; //@line 72314 "c/sqlite3.c"
 return ($1|0); //@line 72316 "c/sqlite3.c"
}
function _sqlite3ValueSetStr($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($0|0)==(0|0); //@line 72922 "c/sqlite3.c"
 if (!($4)) {
  (_sqlite3VdbeMemSetStr($0,$1,-1,$2,$3)|0); //@line 72922 "c/sqlite3.c"
 }
 return; //@line 72923 "c/sqlite3.c"
}
function _sqlite3ValueFree($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 72929 "c/sqlite3.c"
 if ($1) {
  return; //@line 72932 "c/sqlite3.c"
 }
 _sqlite3VdbeMemRelease($0); //@line 72930 "c/sqlite3.c"
 $2 = ((($0)) + 32|0); //@line 72931 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 72931 "c/sqlite3.c"
 _sqlite3DbFreeNN($3,$0); //@line 72931 "c/sqlite3.c"
 return; //@line 72932 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetPointer($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($2|0)==(0|0); //@line 71939 "c/sqlite3.c"
 $5 = $4 ? 41388 : $2; //@line 71939 "c/sqlite3.c"
 HEAP32[$0>>2] = $5; //@line 71939 "c/sqlite3.c"
 $6 = ((($0)) + 16|0); //@line 71940 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 71940 "c/sqlite3.c"
 $7 = ((($0)) + 8|0); //@line 71941 "c/sqlite3.c"
 HEAP16[$7>>1] = -31231; //@line 71941 "c/sqlite3.c"
 $8 = ((($0)) + 11|0); //@line 71942 "c/sqlite3.c"
 HEAP8[$8>>0] = 112; //@line 71942 "c/sqlite3.c"
 $9 = ($3|0)==(0|0); //@line 71943 "c/sqlite3.c"
 $10 = $9 ? 100 : $3; //@line 71943 "c/sqlite3.c"
 $11 = ((($0)) + 36|0); //@line 71943 "c/sqlite3.c"
 HEAP32[$11>>2] = $10; //@line 71943 "c/sqlite3.c"
 return; //@line 71944 "c/sqlite3.c"
}
function _sqlite3NoopDestructor($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 71926 "c/sqlite3.c"
}
function _vdbeUnbind($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 78998 "c/sqlite3.c"
 $2 = (_vdbeSafetyNotNull($0)|0); //@line 79000 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 79000 "c/sqlite3.c"
 if (!($3)) {
  $4 = (_sqlite3MisuseError(79001)|0); //@line 79001 "c/sqlite3.c"
  $$0 = $4;
  STACKTOP = sp;return ($$0|0); //@line 79036 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 79003 "c/sqlite3.c"
 $6 = ((($5)) + 12|0); //@line 79003 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 79003 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 79003 "c/sqlite3.c"
 $8 = ((($0)) + 20|0); //@line 79004 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 79004 "c/sqlite3.c"
 $10 = ($9|0)==(770837923); //@line 79004 "c/sqlite3.c"
 if ($10) {
  $11 = ((($0)) + 36|0); //@line 79004 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 79004 "c/sqlite3.c"
  $13 = ($12|0)>(-1); //@line 79004 "c/sqlite3.c"
  if (!($13)) {
   $21 = ($1|0)<(1); //@line 79011 "c/sqlite3.c"
   if (!($21)) {
    $22 = ((($0)) + 16|0); //@line 79011 "c/sqlite3.c"
    $23 = HEAP16[$22>>1]|0; //@line 79011 "c/sqlite3.c"
    $24 = $23 << 16 >> 16; //@line 79011 "c/sqlite3.c"
    $25 = ($24|0)<($1|0); //@line 79011 "c/sqlite3.c"
    if (!($25)) {
     $30 = (($1) + -1)|0; //@line 79016 "c/sqlite3.c"
     $31 = ((($0)) + 116|0); //@line 79017 "c/sqlite3.c"
     $32 = HEAP32[$31>>2]|0; //@line 79017 "c/sqlite3.c"
     $33 = (($32) + (($30*40)|0)|0); //@line 79017 "c/sqlite3.c"
     _sqlite3VdbeMemRelease($33); //@line 79018 "c/sqlite3.c"
     $34 = (((($32) + (($30*40)|0)|0)) + 8|0); //@line 79019 "c/sqlite3.c"
     HEAP16[$34>>1] = 1; //@line 79019 "c/sqlite3.c"
     $35 = HEAP32[$0>>2]|0; //@line 79020 "c/sqlite3.c"
     _sqlite3Error($35,0); //@line 79020 "c/sqlite3.c"
     $36 = ((($0)) + 204|0); //@line 79032 "c/sqlite3.c"
     $37 = HEAP32[$36>>2]|0; //@line 79032 "c/sqlite3.c"
     $38 = ($37|0)==(0); //@line 79032 "c/sqlite3.c"
     if ($38) {
      $$0 = 0;
      STACKTOP = sp;return ($$0|0); //@line 79036 "c/sqlite3.c"
     }
     $39 = ($1|0)>(31); //@line 79032 "c/sqlite3.c"
     $40 = 1 << $30; //@line 79032 "c/sqlite3.c"
     $41 = $39 ? -2147483648 : $40; //@line 79032 "c/sqlite3.c"
     $42 = $37 & $41; //@line 79032 "c/sqlite3.c"
     $43 = ($42|0)==(0); //@line 79032 "c/sqlite3.c"
     if ($43) {
      $$0 = 0;
      STACKTOP = sp;return ($$0|0); //@line 79036 "c/sqlite3.c"
     }
     $44 = ((($0)) + 145|0); //@line 79033 "c/sqlite3.c"
     $45 = HEAPU8[$44>>0]|(HEAPU8[$44+1>>0]<<8); //@line 79033 "c/sqlite3.c"
     $46 = $45 | 1; //@line 79033 "c/sqlite3.c"
     HEAP8[$44>>0]=$46&255;HEAP8[$44+1>>0]=$46>>8; //@line 79033 "c/sqlite3.c"
     $$0 = 0;
     STACKTOP = sp;return ($$0|0); //@line 79036 "c/sqlite3.c"
    }
   }
   $26 = HEAP32[$0>>2]|0; //@line 79012 "c/sqlite3.c"
   _sqlite3Error($26,25); //@line 79012 "c/sqlite3.c"
   $27 = HEAP32[$0>>2]|0; //@line 79013 "c/sqlite3.c"
   $28 = ((($27)) + 12|0); //@line 79013 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 79013 "c/sqlite3.c"
   _sqlite3_mutex_leave($29); //@line 79013 "c/sqlite3.c"
   $$0 = 25;
   STACKTOP = sp;return ($$0|0); //@line 79036 "c/sqlite3.c"
  }
 }
 $14 = HEAP32[$0>>2]|0; //@line 79005 "c/sqlite3.c"
 _sqlite3Error($14,21); //@line 79005 "c/sqlite3.c"
 $15 = HEAP32[$0>>2]|0; //@line 79006 "c/sqlite3.c"
 $16 = ((($15)) + 12|0); //@line 79006 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 79006 "c/sqlite3.c"
 _sqlite3_mutex_leave($17); //@line 79006 "c/sqlite3.c"
 $18 = ((($0)) + 184|0); //@line 79008 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 79008 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $19; //@line 79007 "c/sqlite3.c"
 _sqlite3_log(21,18076,$vararg_buffer); //@line 79007 "c/sqlite3.c"
 $20 = (_sqlite3MisuseError(79009)|0); //@line 79009 "c/sqlite3.c"
 $$0 = $20;
 STACKTOP = sp;return ($$0|0); //@line 79036 "c/sqlite3.c"
}
function _vdbeSafetyNotNull($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 77752 "c/sqlite3.c"
 $1 = ($0|0)==(0|0); //@line 77753 "c/sqlite3.c"
 if ($1) {
  _sqlite3_log(21,18116,$vararg_buffer); //@line 77754 "c/sqlite3.c"
  $$0 = 1;
 } else {
  $2 = (_vdbeSafety($0)|0); //@line 77757 "c/sqlite3.c"
  $$0 = $2;
 }
 STACKTOP = sp;return ($$0|0); //@line 77759 "c/sqlite3.c"
}
function _vdbeSafety($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 77744 "c/sqlite3.c"
 $1 = HEAP32[$0>>2]|0; //@line 77745 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 77745 "c/sqlite3.c"
 if ($2) {
  _sqlite3_log(21,18156,$vararg_buffer); //@line 77746 "c/sqlite3.c"
  $$0 = 1;
 } else {
  $$0 = 0;
 }
 STACKTOP = sp;return ($$0|0); //@line 77751 "c/sqlite3.c"
}
function _sqlite3Prepare16($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $$048 = 0, $$04951 = 0, $$050 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp;
 HEAP32[$6>>2] = 0; //@line 118598 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 118604 "c/sqlite3.c"
 $7 = (_sqlite3SafetyCheckOk($0)|0); //@line 118605 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 118605 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 118605 "c/sqlite3.c"
 $or$cond = $9 | $8; //@line 118605 "c/sqlite3.c"
 if ($or$cond) {
  $10 = (_sqlite3MisuseError(118606)|0); //@line 118606 "c/sqlite3.c"
  $$0 = $10;
  STACKTOP = sp;return ($$0|0); //@line 118633 "c/sqlite3.c"
 }
 $11 = ($2|0)>(-1); //@line 118608 "c/sqlite3.c"
 L5: do {
  if ($11) {
   $12 = ($2|0)==(0); //@line 118611 "c/sqlite3.c"
   if ($12) {
    $$048 = 0;
   } else {
    $$04951 = 0;
    while(1) {
     $13 = (($1) + ($$04951)|0); //@line 118611 "c/sqlite3.c"
     $14 = HEAP8[$13>>0]|0; //@line 118611 "c/sqlite3.c"
     $15 = ($14<<24>>24)==(0); //@line 118611 "c/sqlite3.c"
     if ($15) {
      $16 = $$04951 | 1; //@line 118611 "c/sqlite3.c"
      $17 = (($1) + ($16)|0); //@line 118611 "c/sqlite3.c"
      $18 = HEAP8[$17>>0]|0; //@line 118611 "c/sqlite3.c"
      $19 = ($18<<24>>24)==(0); //@line 118611 "c/sqlite3.c"
      if ($19) {
       $$048 = $$04951;
       break L5;
      }
     }
     $20 = (($$04951) + 2)|0; //@line 118611 "c/sqlite3.c"
     $21 = ($20|0)<($2|0); //@line 118611 "c/sqlite3.c"
     if ($21) {
      $$04951 = $20;
     } else {
      $$048 = $20;
      break;
     }
    }
   }
  } else {
   $$048 = $2;
  }
 } while(0);
 $22 = ((($0)) + 12|0); //@line 118614 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 118614 "c/sqlite3.c"
 _sqlite3_mutex_enter($23); //@line 118614 "c/sqlite3.c"
 $24 = (_sqlite3Utf16to8($0,$1,$$048)|0); //@line 118615 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 118616 "c/sqlite3.c"
 if ($25) {
  $$050 = 0;
 } else {
  $26 = (_sqlite3LockAndPrepare($0,$24,-1,$3,0,$4,$6)|0); //@line 118617 "c/sqlite3.c"
  $$050 = $26;
 }
 $27 = HEAP32[$6>>2]|0; //@line 118620 "c/sqlite3.c"
 $28 = ($27|0)!=(0|0); //@line 118620 "c/sqlite3.c"
 $29 = ($5|0)!=(0|0); //@line 118620 "c/sqlite3.c"
 $or$cond4 = $29 & $28; //@line 118620 "c/sqlite3.c"
 if ($or$cond4) {
  $30 = $27; //@line 118626 "c/sqlite3.c"
  $31 = $24; //@line 118626 "c/sqlite3.c"
  $32 = (($30) - ($31))|0; //@line 118626 "c/sqlite3.c"
  $33 = (_sqlite3Utf8CharLen_70($24,$32)|0); //@line 118626 "c/sqlite3.c"
  $34 = (_sqlite3Utf16ByteLen($1,$33)|0); //@line 118627 "c/sqlite3.c"
  $35 = (($1) + ($34)|0); //@line 118627 "c/sqlite3.c"
  HEAP32[$5>>2] = $35; //@line 118627 "c/sqlite3.c"
 }
 _sqlite3DbFree($0,$24); //@line 118629 "c/sqlite3.c"
 $36 = (_sqlite3ApiExit($0,$$050)|0); //@line 118630 "c/sqlite3.c"
 $37 = HEAP32[$22>>2]|0; //@line 118631 "c/sqlite3.c"
 _sqlite3_mutex_leave($37); //@line 118631 "c/sqlite3.c"
 $$0 = $36;
 STACKTOP = sp;return ($$0|0); //@line 118633 "c/sqlite3.c"
}
function _sqlite3SafetyCheckOk($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 29752 "c/sqlite3.c"
 if ($1) {
  _logBadConnection(15390); //@line 29753 "c/sqlite3.c"
  $$0 = 0;
 } else {
  $2 = ((($0)) + 88|0); //@line 29756 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 29756 "c/sqlite3.c"
  $4 = ($3|0)==(-1607883113); //@line 29757 "c/sqlite3.c"
  if ($4) {
   $$0 = 1;
  } else {
   $5 = (_sqlite3SafetyCheckSickOrOk($0)|0); //@line 29758 "c/sqlite3.c"
   $6 = ($5|0)==(0); //@line 29758 "c/sqlite3.c"
   if ($6) {
    $$0 = 0;
   } else {
    _logBadConnection(33417); //@line 29760 "c/sqlite3.c"
    $$0 = 0;
   }
  }
 }
 return ($$0|0); //@line 29766 "c/sqlite3.c"
}
function _sqlite3Utf16to8($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $3 = sp;
 dest=$3; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 28374 "c/sqlite3.c"
 $4 = ((($3)) + 32|0); //@line 28375 "c/sqlite3.c"
 HEAP32[$4>>2] = $0; //@line 28375 "c/sqlite3.c"
 (_sqlite3VdbeMemSetStr($3,$1,$2,2,0)|0); //@line 28376 "c/sqlite3.c"
 (_sqlite3VdbeChangeEncoding($3,1)|0); //@line 28377 "c/sqlite3.c"
 $5 = ((($0)) + 73|0); //@line 28378 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 28378 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 28378 "c/sqlite3.c"
 if ($7) {
  $9 = ((($3)) + 16|0); //@line 28385 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 28385 "c/sqlite3.c"
  STACKTOP = sp;return ($10|0); //@line 28385 "c/sqlite3.c"
 }
 _sqlite3VdbeMemRelease($3); //@line 28379 "c/sqlite3.c"
 $8 = ((($3)) + 16|0); //@line 28380 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 28380 "c/sqlite3.c"
 $9 = ((($3)) + 16|0); //@line 28385 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 28385 "c/sqlite3.c"
 STACKTOP = sp;return ($10|0); //@line 28385 "c/sqlite3.c"
}
function _sqlite3LockAndPrepare($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$026 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$5>>2] = 0; //@line 118459 "c/sqlite3.c"
 $7 = (_sqlite3SafetyCheckOk($0)|0); //@line 118460 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 118460 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 118460 "c/sqlite3.c"
 $or$cond = $9 | $8; //@line 118460 "c/sqlite3.c"
 if ($or$cond) {
  $10 = (_sqlite3MisuseError(118461)|0); //@line 118461 "c/sqlite3.c"
  $$026 = $10;
  return ($$026|0); //@line 118478 "c/sqlite3.c"
 }
 $11 = ((($0)) + 12|0); //@line 118463 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 118463 "c/sqlite3.c"
 _sqlite3_mutex_enter($12); //@line 118463 "c/sqlite3.c"
 _sqlite3BtreeEnterAll($0); //@line 118464 "c/sqlite3.c"
 L5: while(1) {
  $13 = (_sqlite3Prepare($0,$1,$2,$3,$4,$5,$6)|0); //@line 118469 "c/sqlite3.c"
  switch ($13|0) {
  case 513:  {
   break;
  }
  case 17:  {
   label = 5;
   break L5;
   break;
  }
  default: {
   $14 = $13;
   break L5;
  }
  }
 }
 L7: do {
  if ((label|0) == 5) {
   _sqlite3ResetOneSchema($0,-1); //@line 118472 "c/sqlite3.c"
   L9: while(1) {
    $17 = (_sqlite3Prepare($0,$1,$2,$3,$4,$5,$6)|0); //@line 118469 "c/sqlite3.c"
    switch ($17|0) {
    case 513:  {
     break;
    }
    case 17:  {
     break L9;
     break;
    }
    default: {
     $14 = $17;
     break L7;
    }
    }
   }
   _sqlite3ResetOneSchema($0,-1); //@line 118472 "c/sqlite3.c"
   $14 = 17;
  }
 } while(0);
 _sqlite3BtreeLeaveAll($0); //@line 118473 "c/sqlite3.c"
 $15 = (_sqlite3ApiExit($0,$14)|0); //@line 118474 "c/sqlite3.c"
 $16 = HEAP32[$11>>2]|0; //@line 118476 "c/sqlite3.c"
 _sqlite3_mutex_leave($16); //@line 118476 "c/sqlite3.c"
 $$026 = $15;
 return ($$026|0); //@line 118478 "c/sqlite3.c"
}
function _sqlite3Utf16ByteLen($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$14344 = 0, $$2$lcssa = 0, $$245 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 28404 "c/sqlite3.c"
 if ($2) {
  $$14344 = 0;$$245 = $0;
  while(1) {
   $3 = ((($$245)) + 1|0); //@line 28405 "c/sqlite3.c"
   $4 = ((($$245)) + 2|0); //@line 28405 "c/sqlite3.c"
   $5 = HEAP8[$3>>0]|0; //@line 28405 "c/sqlite3.c"
   $6 = $5 & -8; //@line 28405 "c/sqlite3.c"
   $7 = ($6<<24>>24)==(-40); //@line 28405 "c/sqlite3.c"
   $8 = ((($$245)) + 4|0); //@line 28405 "c/sqlite3.c"
   $spec$select = $7 ? $8 : $4; //@line 28405 "c/sqlite3.c"
   $9 = (($$14344) + 1)|0; //@line 28406 "c/sqlite3.c"
   $exitcond = ($9|0)==($1|0); //@line 28404 "c/sqlite3.c"
   if ($exitcond) {
    $$2$lcssa = $spec$select;
    break;
   } else {
    $$14344 = $9;$$245 = $spec$select;
   }
  }
 } else {
  $$2$lcssa = $0;
 }
 $10 = $$2$lcssa; //@line 28409 "c/sqlite3.c"
 $11 = $0; //@line 28409 "c/sqlite3.c"
 $12 = (($10) - ($11))|0; //@line 28409 "c/sqlite3.c"
 return ($12|0); //@line 28409 "c/sqlite3.c"
}
function _sqlite3BtreeEnterAll($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 81|0); //@line 60293 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 60293 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 60293 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 60294 "c/sqlite3.c"
 }
 _btreeEnterAll($0); //@line 60293 "c/sqlite3.c"
 return; //@line 60294 "c/sqlite3.c"
}
function _sqlite3Prepare($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$082 = 0, $$083 = 0, $$08595 = 0, $$18693 = 0, $$4 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0;
 var $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 512|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(512|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $7 = sp + 496|0;
 $8 = sp + 24|0;
 HEAP32[$7>>2] = 0; //@line 118297 "c/sqlite3.c"
 _memset(($8|0),0,148)|0; //@line 118302 "c/sqlite3.c"
 $9 = ((($8)) + 388|0); //@line 118303 "c/sqlite3.c"
 dest=$9; stop=dest+84|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 118303 "c/sqlite3.c"
 $10 = ((($8)) + 424|0); //@line 118304 "c/sqlite3.c"
 HEAP32[$10>>2] = $4; //@line 118304 "c/sqlite3.c"
 $11 = $3 & 1; //@line 118312 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 118312 "c/sqlite3.c"
 if (!($12)) {
  $13 = ((($8)) + 24|0); //@line 118313 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 118313 "c/sqlite3.c"
  $15 = (($14) + 1)<<24>>24; //@line 118313 "c/sqlite3.c"
  HEAP8[$13>>0] = $15; //@line 118313 "c/sqlite3.c"
  $16 = ((($0)) + 264|0); //@line 118314 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 118314 "c/sqlite3.c"
  $18 = (($17) + 1)|0; //@line 118314 "c/sqlite3.c"
  HEAP32[$16>>2] = $18; //@line 118314 "c/sqlite3.c"
 }
 $19 = ((($0)) + 20|0); //@line 118340 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 118340 "c/sqlite3.c"
 $21 = ($20|0)>(0); //@line 118340 "c/sqlite3.c"
 L4: do {
  if ($21) {
   $22 = ((($0)) + 16|0);
   $$08595 = 0;
   while(1) {
    $23 = HEAP32[$22>>2]|0; //@line 118341 "c/sqlite3.c"
    $24 = (((($23) + ($$08595<<4)|0)) + 4|0); //@line 118341 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 118341 "c/sqlite3.c"
    $26 = ($25|0)==(0|0); //@line 118342 "c/sqlite3.c"
    if (!($26)) {
     $27 = (_sqlite3BtreeSchemaLocked($25)|0); //@line 118344 "c/sqlite3.c"
     $28 = ($27|0)==(0); //@line 118345 "c/sqlite3.c"
     if (!($28)) {
      break;
     }
    }
    $33 = (($$08595) + 1)|0; //@line 118340 "c/sqlite3.c"
    $34 = HEAP32[$19>>2]|0; //@line 118340 "c/sqlite3.c"
    $35 = ($33|0)<($34|0); //@line 118340 "c/sqlite3.c"
    if ($35) {
     $$08595 = $33;
    } else {
     break L4;
    }
   }
   $29 = ((($0)) + 16|0); //@line 118341 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 118346 "c/sqlite3.c"
   $31 = (($30) + ($$08595<<4)|0); //@line 118346 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 118346 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $32; //@line 118347 "c/sqlite3.c"
   _sqlite3ErrorWithMsg($0,$27,18201,$vararg_buffer); //@line 118347 "c/sqlite3.c"
   $$4 = $27;
   _sqlite3ParserReset($8); //@line 118441 "c/sqlite3.c"
   STACKTOP = sp;return ($$4|0); //@line 118443 "c/sqlite3.c"
  }
 } while(0);
 _sqlite3VtabUnlockList($0); //@line 118354 "c/sqlite3.c"
 HEAP32[$8>>2] = $0; //@line 118356 "c/sqlite3.c"
 $36 = ($2|0)>(-1); //@line 118357 "c/sqlite3.c"
 do {
  if ($36) {
   $37 = ($2|0)==(0); //@line 118357 "c/sqlite3.c"
   if (!($37)) {
    $38 = (($2) + -1)|0; //@line 118357 "c/sqlite3.c"
    $39 = (($1) + ($38)|0); //@line 118357 "c/sqlite3.c"
    $40 = HEAP8[$39>>0]|0; //@line 118357 "c/sqlite3.c"
    $41 = ($40<<24>>24)==(0); //@line 118357 "c/sqlite3.c"
    if ($41) {
     label = 17;
     break;
    }
   }
   $42 = ((($0)) + 104|0); //@line 118359 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 118359 "c/sqlite3.c"
   $44 = ($43|0)<($2|0); //@line 118362 "c/sqlite3.c"
   if ($44) {
    _sqlite3ErrorWithMsg($0,18,18231,$vararg_buffer1); //@line 118363 "c/sqlite3.c"
    $56 = (_sqlite3ApiExit($0,18)|0); //@line 118364 "c/sqlite3.c"
    $$4 = $56;
    _sqlite3ParserReset($8); //@line 118441 "c/sqlite3.c"
    STACKTOP = sp;return ($$4|0); //@line 118443 "c/sqlite3.c"
   }
   $45 = ($2|0)<(0); //@line 118367 "c/sqlite3.c"
   $46 = $45 << 31 >> 31; //@line 118367 "c/sqlite3.c"
   $47 = (_sqlite3DbStrNDup($0,$1,$2,$46)|0); //@line 118367 "c/sqlite3.c"
   $48 = ($47|0)==(0|0); //@line 118368 "c/sqlite3.c"
   if ($48) {
    $54 = (($1) + ($2)|0); //@line 118373 "c/sqlite3.c"
    $55 = ((($8)) + 428|0); //@line 118373 "c/sqlite3.c"
    HEAP32[$55>>2] = $54; //@line 118373 "c/sqlite3.c"
    break;
   } else {
    (_sqlite3RunParser($8,$47,$7)|0); //@line 118369 "c/sqlite3.c"
    $49 = ((($8)) + 428|0); //@line 118370 "c/sqlite3.c"
    $50 = HEAP32[$49>>2]|0; //@line 118370 "c/sqlite3.c"
    $51 = $47; //@line 118370 "c/sqlite3.c"
    $52 = (($50) - ($51))|0; //@line 118370 "c/sqlite3.c"
    $53 = (($1) + ($52)|0); //@line 118370 "c/sqlite3.c"
    HEAP32[$49>>2] = $53; //@line 118370 "c/sqlite3.c"
    _sqlite3DbFree($0,$47); //@line 118371 "c/sqlite3.c"
    break;
   }
  } else {
   label = 17;
  }
 } while(0);
 if ((label|0) == 17) {
  (_sqlite3RunParser($8,$1,$7)|0); //@line 118376 "c/sqlite3.c"
 }
 $57 = ((($8)) + 12|0); //@line 118380 "c/sqlite3.c"
 $58 = HEAP32[$57>>2]|0; //@line 118380 "c/sqlite3.c"
 $59 = ($58|0)==(101); //@line 118380 "c/sqlite3.c"
 if ($59) {
  HEAP32[$57>>2] = 0; //@line 118380 "c/sqlite3.c"
 }
 $60 = ((($8)) + 17|0); //@line 118381 "c/sqlite3.c"
 $61 = HEAP8[$60>>0]|0; //@line 118381 "c/sqlite3.c"
 $62 = ($61<<24>>24)==(0); //@line 118381 "c/sqlite3.c"
 if (!($62)) {
  _schemaIsValid($8); //@line 118382 "c/sqlite3.c"
 }
 $63 = ((($0)) + 73|0); //@line 118384 "c/sqlite3.c"
 $64 = HEAP8[$63>>0]|0; //@line 118384 "c/sqlite3.c"
 $65 = ($64<<24>>24)==(0); //@line 118384 "c/sqlite3.c"
 if (!($65)) {
  HEAP32[$57>>2] = 7; //@line 118385 "c/sqlite3.c"
 }
 $66 = ($6|0)==(0|0); //@line 118387 "c/sqlite3.c"
 if (!($66)) {
  $67 = ((($8)) + 428|0); //@line 118388 "c/sqlite3.c"
  $68 = HEAP32[$67>>2]|0; //@line 118388 "c/sqlite3.c"
  HEAP32[$6>>2] = $68; //@line 118388 "c/sqlite3.c"
 }
 $69 = HEAP32[$57>>2]|0; //@line 118390 "c/sqlite3.c"
 $70 = ($69|0)==(0); //@line 118393 "c/sqlite3.c"
 L41: do {
  if ($70) {
   $71 = ((($8)) + 8|0); //@line 118393 "c/sqlite3.c"
   $72 = HEAP32[$71>>2]|0; //@line 118393 "c/sqlite3.c"
   $73 = ($72|0)==(0|0); //@line 118393 "c/sqlite3.c"
   if (!($73)) {
    $74 = ((($8)) + 399|0); //@line 118393 "c/sqlite3.c"
    $75 = HEAP8[$74>>0]|0; //@line 118393 "c/sqlite3.c"
    switch ($75<<24>>24) {
    case 0:  {
     break L41;
     break;
    }
    case 2:  {
     _sqlite3VdbeSetNumCols($72,4); //@line 118400 "c/sqlite3.c"
     $$082 = 12;$$083 = 8;
     break;
    }
    default: {
     _sqlite3VdbeSetNumCols($72,8); //@line 118404 "c/sqlite3.c"
     $$082 = 8;$$083 = 0;
    }
    }
    $$18693 = $$083;
    while(1) {
     $76 = HEAP32[$71>>2]|0; //@line 118409 "c/sqlite3.c"
     $77 = (($$18693) - ($$083))|0; //@line 118409 "c/sqlite3.c"
     $78 = (4832 + ($$18693<<2)|0); //@line 118410 "c/sqlite3.c"
     $79 = HEAP32[$78>>2]|0; //@line 118410 "c/sqlite3.c"
     _sqlite3VdbeSetColName($76,$77,0,$79,0); //@line 118409 "c/sqlite3.c"
     $80 = (($$18693) + 1)|0; //@line 118408 "c/sqlite3.c"
     $81 = ($80>>>0)<($$082>>>0); //@line 118408 "c/sqlite3.c"
     if ($81) {
      $$18693 = $80;
     } else {
      break;
     }
    }
   }
  }
 } while(0);
 $82 = ((($0)) + 157|0); //@line 118415 "c/sqlite3.c"
 $83 = HEAP8[$82>>0]|0; //@line 118415 "c/sqlite3.c"
 $84 = ($83<<24>>24)==(0); //@line 118415 "c/sqlite3.c"
 if ($84) {
  $85 = ((($8)) + 8|0); //@line 118416 "c/sqlite3.c"
  $86 = HEAP32[$85>>2]|0; //@line 118416 "c/sqlite3.c"
  $87 = ((($8)) + 428|0); //@line 118416 "c/sqlite3.c"
  $88 = HEAP32[$87>>2]|0; //@line 118416 "c/sqlite3.c"
  $89 = $1; //@line 118416 "c/sqlite3.c"
  $90 = (($88) - ($89))|0; //@line 118416 "c/sqlite3.c"
  $91 = $3&255; //@line 118416 "c/sqlite3.c"
  _sqlite3VdbeSetSql($86,$1,$90,$91); //@line 118416 "c/sqlite3.c"
 }
 $92 = ((($8)) + 8|0); //@line 118418 "c/sqlite3.c"
 $93 = HEAP32[$92>>2]|0; //@line 118418 "c/sqlite3.c"
 $94 = ($93|0)==(0|0); //@line 118418 "c/sqlite3.c"
 do {
  if ($94) {
   label = 39;
  } else {
   if ($70) {
    $95 = HEAP8[$63>>0]|0; //@line 118418 "c/sqlite3.c"
    $96 = ($95<<24>>24)==(0); //@line 118418 "c/sqlite3.c"
    if ($96) {
     label = 39;
     break;
    }
   }
   (_sqlite3VdbeFinalize($93)|0); //@line 118419 "c/sqlite3.c"
  }
 } while(0);
 if ((label|0) == 39) {
  $97 = HEAP32[$92>>2]|0; //@line 118422 "c/sqlite3.c"
  HEAP32[$5>>2] = $97; //@line 118422 "c/sqlite3.c"
 }
 $98 = HEAP32[$7>>2]|0; //@line 118425 "c/sqlite3.c"
 $99 = ($98|0)==(0|0); //@line 118425 "c/sqlite3.c"
 if ($99) {
  _sqlite3Error($0,$69); //@line 118429 "c/sqlite3.c"
 } else {
  HEAP32[$vararg_buffer3>>2] = $98; //@line 118426 "c/sqlite3.c"
  _sqlite3ErrorWithMsg($0,$69,15687,$vararg_buffer3); //@line 118426 "c/sqlite3.c"
  _sqlite3DbFree($0,$98); //@line 118427 "c/sqlite3.c"
 }
 $100 = ((($8)) + 460|0); //@line 118433 "c/sqlite3.c"
 $101 = HEAP32[$100>>2]|0; //@line 118433 "c/sqlite3.c"
 $102 = ($101|0)==(0|0); //@line 118433 "c/sqlite3.c"
 if ($102) {
  $$4 = $69;
  _sqlite3ParserReset($8); //@line 118441 "c/sqlite3.c"
  STACKTOP = sp;return ($$4|0); //@line 118443 "c/sqlite3.c"
 }
 $104 = $101;
 while(1) {
  $103 = ((($104)) + 4|0); //@line 118435 "c/sqlite3.c"
  $105 = HEAP32[$103>>2]|0; //@line 118435 "c/sqlite3.c"
  HEAP32[$100>>2] = $105; //@line 118435 "c/sqlite3.c"
  _sqlite3DbFree($0,$104); //@line 118436 "c/sqlite3.c"
  $106 = HEAP32[$100>>2]|0; //@line 118433 "c/sqlite3.c"
  $107 = ($106|0)==(0|0); //@line 118433 "c/sqlite3.c"
  if ($107) {
   $$4 = $69;
   break;
  } else {
   $104 = $106;
  }
 }
 _sqlite3ParserReset($8); //@line 118441 "c/sqlite3.c"
 STACKTOP = sp;return ($$4|0); //@line 118443 "c/sqlite3.c"
}
function _sqlite3ResetOneSchema($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(-1); //@line 102142 "c/sqlite3.c"
 if ($2) {
  $3 = ((($0)) + 16|0); //@line 102144 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 102144 "c/sqlite3.c"
  $5 = (((($4) + ($1<<4)|0)) + 12|0); //@line 102144 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 102144 "c/sqlite3.c"
  $7 = ((($6)) + 78|0); //@line 102144 "c/sqlite3.c"
  $8 = HEAP16[$7>>1]|0; //@line 102144 "c/sqlite3.c"
  $9 = $8 | 8; //@line 102144 "c/sqlite3.c"
  HEAP16[$7>>1] = $9; //@line 102144 "c/sqlite3.c"
  $10 = ((($4)) + 28|0); //@line 102145 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 102145 "c/sqlite3.c"
  $12 = ((($11)) + 78|0); //@line 102145 "c/sqlite3.c"
  $13 = HEAP16[$12>>1]|0; //@line 102145 "c/sqlite3.c"
  $14 = $13 | 8; //@line 102145 "c/sqlite3.c"
  HEAP16[$12>>1] = $14; //@line 102145 "c/sqlite3.c"
 }
 $15 = ((($0)) + 48|0); //@line 102148 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 102148 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 102148 "c/sqlite3.c"
 if (!($17)) {
  return; //@line 102155 "c/sqlite3.c"
 }
 $18 = ((($0)) + 20|0); //@line 102149 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 102149 "c/sqlite3.c"
 $20 = ($19|0)>(0); //@line 102149 "c/sqlite3.c"
 if (!($20)) {
  return; //@line 102155 "c/sqlite3.c"
 }
 $21 = ((($0)) + 16|0);
 $$012 = 0;
 while(1) {
  $22 = HEAP32[$21>>2]|0; //@line 102150 "c/sqlite3.c"
  $23 = (((($22) + ($$012<<4)|0)) + 12|0); //@line 102150 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 102150 "c/sqlite3.c"
  $25 = ((($24)) + 78|0); //@line 102150 "c/sqlite3.c"
  $26 = HEAP16[$25>>1]|0; //@line 102150 "c/sqlite3.c"
  $27 = $26 & 8; //@line 102150 "c/sqlite3.c"
  $28 = ($27<<16>>16)==(0); //@line 102150 "c/sqlite3.c"
  if (!($28)) {
   _sqlite3SchemaClear($24); //@line 102151 "c/sqlite3.c"
  }
  $29 = (($$012) + 1)|0; //@line 102149 "c/sqlite3.c"
  $30 = HEAP32[$18>>2]|0; //@line 102149 "c/sqlite3.c"
  $31 = ($29|0)<($30|0); //@line 102149 "c/sqlite3.c"
  if ($31) {
   $$012 = $29;
  } else {
   break;
  }
 }
 return; //@line 102155 "c/sqlite3.c"
}
function _sqlite3BtreeLeaveAll($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 81|0); //@line 60305 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 60305 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 60305 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 60306 "c/sqlite3.c"
 }
 _btreeLeaveAll($0); //@line 60305 "c/sqlite3.c"
 return; //@line 60306 "c/sqlite3.c"
}
function _btreeLeaveAll($0) {
 $0 = $0|0;
 var $$09 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 60299 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60299 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 60299 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 60303 "c/sqlite3.c"
 }
 $4 = ((($0)) + 16|0);
 $$09 = 0;
 while(1) {
  $5 = HEAP32[$4>>2]|0; //@line 60300 "c/sqlite3.c"
  $6 = (((($5) + ($$09<<4)|0)) + 4|0); //@line 60300 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 60300 "c/sqlite3.c"
  $8 = ($7|0)==(0|0); //@line 60301 "c/sqlite3.c"
  if (!($8)) {
   _sqlite3BtreeLeave($7); //@line 60301 "c/sqlite3.c"
  }
  $9 = (($$09) + 1)|0; //@line 60299 "c/sqlite3.c"
  $10 = HEAP32[$1>>2]|0; //@line 60299 "c/sqlite3.c"
  $11 = ($9|0)<($10|0); //@line 60299 "c/sqlite3.c"
  if ($11) {
   $$09 = $9;
  } else {
   break;
  }
 }
 return; //@line 60303 "c/sqlite3.c"
}
function _sqlite3BtreeLeave($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 9|0); //@line 60237 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 60237 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 60237 "c/sqlite3.c"
 if ($3) {
  return; //@line 60244 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0); //@line 60239 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 60239 "c/sqlite3.c"
 $6 = (($5) + -1)|0; //@line 60239 "c/sqlite3.c"
 HEAP32[$4>>2] = $6; //@line 60239 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 60240 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 60244 "c/sqlite3.c"
 }
 _unlockBtreeMutex($0); //@line 60241 "c/sqlite3.c"
 return; //@line 60244 "c/sqlite3.c"
}
function _unlockBtreeMutex($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 60134 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60134 "c/sqlite3.c"
 $3 = ((($2)) + 56|0); //@line 60140 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60140 "c/sqlite3.c"
 _sqlite3_mutex_leave($4); //@line 60140 "c/sqlite3.c"
 $5 = ((($0)) + 10|0); //@line 60141 "c/sqlite3.c"
 HEAP8[$5>>0] = 0; //@line 60141 "c/sqlite3.c"
 return; //@line 60142 "c/sqlite3.c"
}
function _sqlite3SchemaClear($0) {
 $0 = $0|0;
 var $$024 = 0, $$123 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $1 = sp + 16|0;
 $2 = sp;
 $3 = ((($0)) + 8|0); //@line 106521 "c/sqlite3.c"
 ;HEAP32[$1>>2]=HEAP32[$3>>2]|0;HEAP32[$1+4>>2]=HEAP32[$3+4>>2]|0;HEAP32[$1+8>>2]=HEAP32[$3+8>>2]|0;HEAP32[$1+12>>2]=HEAP32[$3+12>>2]|0; //@line 106521 "c/sqlite3.c"
 $4 = ((($0)) + 40|0); //@line 106522 "c/sqlite3.c"
 ;HEAP32[$2>>2]=HEAP32[$4>>2]|0;HEAP32[$2+4>>2]=HEAP32[$4+4>>2]|0;HEAP32[$2+8>>2]=HEAP32[$4+8>>2]|0;HEAP32[$2+12>>2]=HEAP32[$4+12>>2]|0; //@line 106522 "c/sqlite3.c"
 _sqlite3HashInit($4); //@line 106523 "c/sqlite3.c"
 $5 = ((($0)) + 24|0); //@line 106524 "c/sqlite3.c"
 _sqlite3HashClear($5); //@line 106524 "c/sqlite3.c"
 $6 = ((($2)) + 8|0); //@line 106525 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 106525 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 106525 "c/sqlite3.c"
 if (!($8)) {
  $$024 = $7;
  while(1) {
   $9 = ((($$024)) + 8|0); //@line 106526 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 106526 "c/sqlite3.c"
   _sqlite3DeleteTrigger(0,$10); //@line 106526 "c/sqlite3.c"
   $11 = HEAP32[$$024>>2]|0; //@line 106525 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 106525 "c/sqlite3.c"
   if ($12) {
    break;
   } else {
    $$024 = $11;
   }
  }
 }
 _sqlite3HashClear($2); //@line 106528 "c/sqlite3.c"
 _sqlite3HashInit($3); //@line 106529 "c/sqlite3.c"
 $13 = ((($1)) + 8|0); //@line 106530 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 106530 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 106530 "c/sqlite3.c"
 if (!($15)) {
  $$123 = $14;
  while(1) {
   $16 = ((($$123)) + 8|0); //@line 106531 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 106531 "c/sqlite3.c"
   _sqlite3DeleteTable(0,$17); //@line 106532 "c/sqlite3.c"
   $18 = HEAP32[$$123>>2]|0; //@line 106530 "c/sqlite3.c"
   $19 = ($18|0)==(0|0); //@line 106530 "c/sqlite3.c"
   if ($19) {
    break;
   } else {
    $$123 = $18;
   }
  }
 }
 _sqlite3HashClear($1); //@line 106534 "c/sqlite3.c"
 $20 = ((($0)) + 56|0); //@line 106535 "c/sqlite3.c"
 _sqlite3HashClear($20); //@line 106535 "c/sqlite3.c"
 $21 = ((($0)) + 72|0); //@line 106536 "c/sqlite3.c"
 HEAP32[$21>>2] = 0; //@line 106536 "c/sqlite3.c"
 $22 = ((($0)) + 78|0); //@line 106537 "c/sqlite3.c"
 $23 = HEAP16[$22>>1]|0; //@line 106537 "c/sqlite3.c"
 $24 = $23 & 1; //@line 106537 "c/sqlite3.c"
 $25 = ($24<<16>>16)==(0); //@line 106537 "c/sqlite3.c"
 if ($25) {
  $29 = $23 & -10; //@line 106540 "c/sqlite3.c"
  HEAP16[$22>>1] = $29; //@line 106540 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 106541 "c/sqlite3.c"
 }
 $26 = ((($0)) + 4|0); //@line 106538 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 106538 "c/sqlite3.c"
 $28 = (($27) + 1)|0; //@line 106538 "c/sqlite3.c"
 HEAP32[$26>>2] = $28; //@line 106538 "c/sqlite3.c"
 $29 = $23 & -10; //@line 106540 "c/sqlite3.c"
 HEAP16[$22>>1] = $29; //@line 106540 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 106541 "c/sqlite3.c"
}
function _sqlite3HashInit($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 ;HEAP32[$0>>2]=0|0;HEAP32[$0+4>>2]=0|0;HEAP32[$0+8>>2]=0|0;HEAP32[$0+12>>2]=0|0; //@line 30111 "c/sqlite3.c"
 return; //@line 30114 "c/sqlite3.c"
}
function _sqlite3DeleteTrigger($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 125431 "c/sqlite3.c"
 if ($2) {
  return; //@line 125438 "c/sqlite3.c"
 }
 $3 = ((($1)) + 28|0); //@line 125432 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 125432 "c/sqlite3.c"
 _sqlite3DeleteTriggerStep($0,$4); //@line 125432 "c/sqlite3.c"
 $5 = HEAP32[$1>>2]|0; //@line 125433 "c/sqlite3.c"
 _sqlite3DbFree($0,$5); //@line 125433 "c/sqlite3.c"
 $6 = ((($1)) + 4|0); //@line 125434 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 125434 "c/sqlite3.c"
 _sqlite3DbFree($0,$7); //@line 125434 "c/sqlite3.c"
 $8 = ((($1)) + 12|0); //@line 125435 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 125435 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$9); //@line 125435 "c/sqlite3.c"
 $10 = ((($1)) + 16|0); //@line 125436 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 125436 "c/sqlite3.c"
 _sqlite3IdListDelete($0,$11); //@line 125436 "c/sqlite3.c"
 _sqlite3DbFree($0,$1); //@line 125437 "c/sqlite3.c"
 return; //@line 125438 "c/sqlite3.c"
}
function _sqlite3DeleteTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 102266 "c/sqlite3.c"
 if ($2) {
  return; //@line 102269 "c/sqlite3.c"
 }
 $3 = ($0|0)==(0|0); //@line 102267 "c/sqlite3.c"
 if ($3) {
  label = 4;
 } else {
  $4 = ((($0)) + 464|0); //@line 102267 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 102267 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 102267 "c/sqlite3.c"
  if ($6) {
   label = 4;
  }
 }
 if ((label|0) == 4) {
  $7 = ((($1)) + 32|0); //@line 102267 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 102267 "c/sqlite3.c"
  $9 = (($8) + -1)|0; //@line 102267 "c/sqlite3.c"
  HEAP32[$7>>2] = $9; //@line 102267 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 102267 "c/sqlite3.c"
  if (!($10)) {
   return; //@line 102269 "c/sqlite3.c"
  }
 }
 _deleteTable($0,$1); //@line 102268 "c/sqlite3.c"
 return; //@line 102269 "c/sqlite3.c"
}
function _deleteTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$033 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 8|0); //@line 102231 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 102231 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 102231 "c/sqlite3.c"
 if (!($4)) {
  $5 = ($0|0)==(0|0);
  $6 = ((($1)) + 56|0);
  $7 = ((($0)) + 464|0);
  $$033 = $3;
  while(1) {
   $8 = ((($$033)) + 20|0); //@line 102232 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 102232 "c/sqlite3.c"
   if ($5) {
    label = 5;
   } else {
    $10 = HEAP32[$7>>2]|0; //@line 102235 "c/sqlite3.c"
    $11 = ($10|0)==(0|0); //@line 102235 "c/sqlite3.c"
    if ($11) {
     label = 5;
    }
   }
   if ((label|0) == 5) {
    label = 0;
    $12 = HEAP32[$6>>2]|0; //@line 102235 "c/sqlite3.c"
    $13 = ($12|0)==(0); //@line 102235 "c/sqlite3.c"
    if ($13) {
     $14 = HEAP32[$$033>>2]|0; //@line 102236 "c/sqlite3.c"
     $15 = ((($$033)) + 24|0); //@line 102238 "c/sqlite3.c"
     $16 = HEAP32[$15>>2]|0; //@line 102238 "c/sqlite3.c"
     $17 = ((($16)) + 24|0); //@line 102238 "c/sqlite3.c"
     (_sqlite3HashInsert($17,$14,0)|0); //@line 102237 "c/sqlite3.c"
    }
   }
   _freeIndex($0,$$033); //@line 102243 "c/sqlite3.c"
   $18 = ($9|0)==(0|0); //@line 102231 "c/sqlite3.c"
   if ($18) {
    break;
   } else {
    $$033 = $9;
   }
  }
 }
 _sqlite3FkDelete($0,$1); //@line 102247 "c/sqlite3.c"
 _sqlite3DeleteColumnNames($0,$1); //@line 102251 "c/sqlite3.c"
 $19 = HEAP32[$1>>2]|0; //@line 102252 "c/sqlite3.c"
 _sqlite3DbFree($0,$19); //@line 102252 "c/sqlite3.c"
 $20 = ((($1)) + 20|0); //@line 102253 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 102253 "c/sqlite3.c"
 _sqlite3DbFree($0,$21); //@line 102253 "c/sqlite3.c"
 $22 = ((($1)) + 12|0); //@line 102254 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 102254 "c/sqlite3.c"
 _sqlite3SelectDelete($0,$23); //@line 102254 "c/sqlite3.c"
 $24 = ((($1)) + 24|0); //@line 102255 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 102255 "c/sqlite3.c"
 _sqlite3ExprListDelete($0,$25); //@line 102255 "c/sqlite3.c"
 _sqlite3VtabClear($0,$1); //@line 102257 "c/sqlite3.c"
 _sqlite3DbFree($0,$1); //@line 102259 "c/sqlite3.c"
 return; //@line 102263 "c/sqlite3.c"
}
function _freeIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 36|0); //@line 102062 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 102062 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$3); //@line 102062 "c/sqlite3.c"
 $4 = ((($1)) + 40|0); //@line 102063 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 102063 "c/sqlite3.c"
 _sqlite3ExprListDelete($0,$5); //@line 102063 "c/sqlite3.c"
 $6 = ((($1)) + 16|0); //@line 102064 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 102064 "c/sqlite3.c"
 _sqlite3DbFree($0,$7); //@line 102064 "c/sqlite3.c"
 $8 = ((($1)) + 55|0); //@line 102065 "c/sqlite3.c"
 $9 = HEAPU8[$8>>0]|(HEAPU8[$8+1>>0]<<8); //@line 102065 "c/sqlite3.c"
 $10 = $9 & 16; //@line 102065 "c/sqlite3.c"
 $11 = ($10<<16>>16)==(0); //@line 102065 "c/sqlite3.c"
 if ($11) {
  _sqlite3DbFree($0,$1); //@line 102069 "c/sqlite3.c"
  return; //@line 102070 "c/sqlite3.c"
 }
 $12 = ((($1)) + 32|0); //@line 102065 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 102065 "c/sqlite3.c"
 _sqlite3DbFree($0,$13); //@line 102065 "c/sqlite3.c"
 _sqlite3DbFree($0,$1); //@line 102069 "c/sqlite3.c"
 return; //@line 102070 "c/sqlite3.c"
}
function _sqlite3FkDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$in = 0, $$in31$ = 0, $$in34 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 16|0); //@line 110803 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 110803 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 110803 "c/sqlite3.c"
 if ($4) {
  return; //@line 110833 "c/sqlite3.c"
 }
 $5 = ($0|0)==(0|0);
 $6 = ((($0)) + 464|0);
 $7 = ((($1)) + 72|0);
 $$in34 = $3;
 while(1) {
  if ($5) {
   label = 5;
  } else {
   $8 = HEAP32[$6>>2]|0; //@line 110806 "c/sqlite3.c"
   $9 = ($8|0)==(0|0); //@line 110806 "c/sqlite3.c"
   if ($9) {
    label = 5;
   }
  }
  if ((label|0) == 5) {
   label = 0;
   $10 = ((($$in34)) + 16|0); //@line 110807 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 110807 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 110807 "c/sqlite3.c"
   $13 = ((($$in34)) + 12|0);
   if ($12) {
    $16 = HEAP32[$13>>2]|0; //@line 110810 "c/sqlite3.c"
    $17 = ($16|0)==(0|0); //@line 110811 "c/sqlite3.c"
    $$in31$ = $17 ? $$in34 : $16; //@line 110811 "c/sqlite3.c"
    $$in = ((($$in31$)) + 8|0);
    $18 = HEAP32[$$in>>2]|0; //@line 110811 "c/sqlite3.c"
    $19 = HEAP32[$7>>2]|0; //@line 110812 "c/sqlite3.c"
    $20 = ((($19)) + 56|0); //@line 110812 "c/sqlite3.c"
    (_sqlite3HashInsert($20,$18,$16)|0); //@line 110812 "c/sqlite3.c"
   } else {
    $14 = HEAP32[$13>>2]|0; //@line 110808 "c/sqlite3.c"
    $15 = ((($11)) + 12|0); //@line 110808 "c/sqlite3.c"
    HEAP32[$15>>2] = $14; //@line 110808 "c/sqlite3.c"
   }
   $21 = HEAP32[$13>>2]|0; //@line 110814 "c/sqlite3.c"
   $22 = ($21|0)==(0|0); //@line 110814 "c/sqlite3.c"
   if (!($22)) {
    $23 = HEAP32[$10>>2]|0; //@line 110815 "c/sqlite3.c"
    $24 = ((($21)) + 16|0); //@line 110815 "c/sqlite3.c"
    HEAP32[$24>>2] = $23; //@line 110815 "c/sqlite3.c"
   }
  }
  $25 = ((($$in34)) + 28|0); //@line 110826 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 110826 "c/sqlite3.c"
  _fkTriggerDelete($0,$26); //@line 110826 "c/sqlite3.c"
  $27 = ((($$in34)) + 32|0); //@line 110827 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 110827 "c/sqlite3.c"
  _fkTriggerDelete($0,$28); //@line 110827 "c/sqlite3.c"
  $29 = ((($$in34)) + 4|0); //@line 110830 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 110830 "c/sqlite3.c"
  _sqlite3DbFree($0,$$in34); //@line 110831 "c/sqlite3.c"
  $31 = ($30|0)==(0|0); //@line 110803 "c/sqlite3.c"
  if ($31) {
   break;
  } else {
   $$in34 = $30;
  }
 }
 return; //@line 110833 "c/sqlite3.c"
}
function _sqlite3DeleteColumnNames($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01415 = 0, $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 4|0); //@line 102192 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 102192 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 102192 "c/sqlite3.c"
 if ($4) {
  return; //@line 102200 "c/sqlite3.c"
 }
 $5 = ((($1)) + 42|0); //@line 102193 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 102193 "c/sqlite3.c"
 $7 = ($6<<16>>16)>(0); //@line 102193 "c/sqlite3.c"
 if ($7) {
  $$01415 = 0;$$016 = $3;
  while(1) {
   $8 = HEAP32[$$016>>2]|0; //@line 102194 "c/sqlite3.c"
   _sqlite3DbFree($0,$8); //@line 102194 "c/sqlite3.c"
   $9 = ((($$016)) + 4|0); //@line 102195 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 102195 "c/sqlite3.c"
   _sqlite3ExprDelete($0,$10); //@line 102195 "c/sqlite3.c"
   $11 = ((($$016)) + 8|0); //@line 102196 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 102196 "c/sqlite3.c"
   _sqlite3DbFree($0,$12); //@line 102196 "c/sqlite3.c"
   $13 = (($$01415) + 1)|0; //@line 102193 "c/sqlite3.c"
   $14 = ((($$016)) + 16|0); //@line 102193 "c/sqlite3.c"
   $15 = HEAP16[$5>>1]|0; //@line 102193 "c/sqlite3.c"
   $16 = $15 << 16 >> 16; //@line 102193 "c/sqlite3.c"
   $17 = ($13|0)<($16|0); //@line 102193 "c/sqlite3.c"
   if ($17) {
    $$01415 = $13;$$016 = $14;
   } else {
    break;
   }
  }
 }
 $18 = HEAP32[$2>>2]|0; //@line 102198 "c/sqlite3.c"
 _sqlite3DbFree($0,$18); //@line 102198 "c/sqlite3.c"
 return; //@line 102200 "c/sqlite3.c"
}
function _sqlite3SelectDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 118855 "c/sqlite3.c"
 if (!($2)) {
  _clearSelect($0,$1,1); //@line 118855 "c/sqlite3.c"
 }
 return; //@line 118856 "c/sqlite3.c"
}
function _sqlite3ExprListDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 94390 "c/sqlite3.c"
 if (!($2)) {
  _exprListDeleteNN($0,$1); //@line 94390 "c/sqlite3.c"
 }
 return; //@line 94391 "c/sqlite3.c"
}
function _sqlite3VtabClear($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$013 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 127648 "c/sqlite3.c"
 if ($2) {
  label = 3;
 } else {
  $3 = ((($0)) + 464|0); //@line 127648 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 127648 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 127648 "c/sqlite3.c"
  if ($5) {
   label = 3;
  }
 }
 if ((label|0) == 3) {
  (_vtabDisconnectAll(0,$1)|0); //@line 127648 "c/sqlite3.c"
 }
 $6 = ((($1)) + 60|0); //@line 127649 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 127649 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 127649 "c/sqlite3.c"
 if ($8) {
  return; //@line 127656 "c/sqlite3.c"
 }
 $9 = ((($1)) + 56|0); //@line 127651 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 127651 "c/sqlite3.c"
 $11 = ($10|0)>(0); //@line 127651 "c/sqlite3.c"
 if ($11) {
  $$013 = 0;
  while(1) {
   $12 = ($$013|0)==(1); //@line 127652 "c/sqlite3.c"
   if (!($12)) {
    $13 = HEAP32[$6>>2]|0; //@line 127652 "c/sqlite3.c"
    $14 = (($13) + ($$013<<2)|0); //@line 127652 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 127652 "c/sqlite3.c"
    _sqlite3DbFree($0,$15); //@line 127652 "c/sqlite3.c"
   }
   $16 = (($$013) + 1)|0; //@line 127651 "c/sqlite3.c"
   $17 = HEAP32[$9>>2]|0; //@line 127651 "c/sqlite3.c"
   $18 = ($16|0)<($17|0); //@line 127651 "c/sqlite3.c"
   if ($18) {
    $$013 = $16;
   } else {
    break;
   }
  }
 }
 $19 = HEAP32[$6>>2]|0; //@line 127654 "c/sqlite3.c"
 _sqlite3DbFree($0,$19); //@line 127654 "c/sqlite3.c"
 return; //@line 127656 "c/sqlite3.c"
}
function _vtabDisconnectAll($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$02425 = 0, $$026 = 0, $$1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 64|0); //@line 127540 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 127540 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 127541 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 127551 "c/sqlite3.c"
 if ($4) {
  $$0$lcssa = 0;
  return ($$0$lcssa|0); //@line 127567 "c/sqlite3.c"
 }
 $$02425 = $3;$$026 = 0;
 while(1) {
  $5 = HEAP32[$$02425>>2]|0; //@line 127552 "c/sqlite3.c"
  $6 = ((($$02425)) + 24|0); //@line 127553 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 127553 "c/sqlite3.c"
  $8 = ($5|0)==($0|0); //@line 127555 "c/sqlite3.c"
  if ($8) {
   HEAP32[$2>>2] = $$02425; //@line 127557 "c/sqlite3.c"
   HEAP32[$6>>2] = 0; //@line 127558 "c/sqlite3.c"
   $$1 = $$02425;
  } else {
   $9 = ((($5)) + 352|0); //@line 127560 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 127560 "c/sqlite3.c"
   HEAP32[$6>>2] = $10; //@line 127560 "c/sqlite3.c"
   HEAP32[$9>>2] = $$02425; //@line 127561 "c/sqlite3.c"
   $$1 = $$026;
  }
  $11 = ($7|0)==(0|0); //@line 127551 "c/sqlite3.c"
  if ($11) {
   $$0$lcssa = $$1;
   break;
  } else {
   $$02425 = $7;$$026 = $$1;
  }
 }
 return ($$0$lcssa|0); //@line 127567 "c/sqlite3.c"
}
function _exprListDeleteNN($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$014 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 94378 "c/sqlite3.c"
 $3 = ((($1)) + 4|0); //@line 94379 "c/sqlite3.c"
 $$0 = $3;$$014 = $2;
 while(1) {
  $4 = HEAP32[$$0>>2]|0; //@line 94382 "c/sqlite3.c"
  _sqlite3ExprDelete($0,$4); //@line 94382 "c/sqlite3.c"
  $5 = ((($$0)) + 4|0); //@line 94383 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 94383 "c/sqlite3.c"
  _sqlite3DbFree($0,$6); //@line 94383 "c/sqlite3.c"
  $7 = ((($$0)) + 8|0); //@line 94384 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 94384 "c/sqlite3.c"
  _sqlite3DbFree($0,$8); //@line 94384 "c/sqlite3.c"
  $9 = ((($$0)) + 20|0); //@line 94385 "c/sqlite3.c"
  $10 = (($$014) + -1)|0; //@line 94386 "c/sqlite3.c"
  $11 = ($$014|0)>(1); //@line 94386 "c/sqlite3.c"
  if ($11) {
   $$0 = $9;$$014 = $10;
  } else {
   break;
  }
 }
 _sqlite3DbFreeNN($0,$1); //@line 94387 "c/sqlite3.c"
 return; //@line 94388 "c/sqlite3.c"
}
function _sqlite3ExprDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 93760 "c/sqlite3.c"
 if (!($2)) {
  _sqlite3ExprDeleteNN($0,$1); //@line 93760 "c/sqlite3.c"
 }
 return; //@line 93761 "c/sqlite3.c"
}
function _sqlite3ExprDeleteNN($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 4|0); //@line 93742 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 93742 "c/sqlite3.c"
 $4 = $3 & 8404992; //@line 93742 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 93742 "c/sqlite3.c"
 do {
  if ($5) {
   $6 = ((($1)) + 12|0); //@line 93745 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 93745 "c/sqlite3.c"
   $8 = ($7|0)==(0|0); //@line 93745 "c/sqlite3.c"
   if (!($8)) {
    $9 = HEAP8[$1>>0]|0; //@line 93745 "c/sqlite3.c"
    $10 = ($9<<24>>24)==(-104); //@line 93745 "c/sqlite3.c"
    if (!($10)) {
     _sqlite3ExprDeleteNN($0,$7); //@line 93745 "c/sqlite3.c"
    }
   }
   $11 = ((($1)) + 16|0); //@line 93746 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 93746 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 93746 "c/sqlite3.c"
   if (!($13)) {
    _sqlite3ExprDeleteNN($0,$12); //@line 93747 "c/sqlite3.c"
    break;
   }
   $14 = HEAP32[$2>>2]|0; //@line 93748 "c/sqlite3.c"
   $15 = $14 & 2048; //@line 93748 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 93748 "c/sqlite3.c"
   $17 = ((($1)) + 20|0);
   if ($16) {
    $19 = HEAP32[$17>>2]|0; //@line 93751 "c/sqlite3.c"
    _sqlite3ExprListDelete($0,$19); //@line 93751 "c/sqlite3.c"
    break;
   } else {
    $18 = HEAP32[$17>>2]|0; //@line 93749 "c/sqlite3.c"
    _sqlite3SelectDelete($0,$18); //@line 93749 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $20 = HEAP32[$2>>2]|0; //@line 93754 "c/sqlite3.c"
 $21 = $20 & 65536; //@line 93754 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 93754 "c/sqlite3.c"
 if (!($22)) {
  $23 = ((($1)) + 8|0); //@line 93754 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 93754 "c/sqlite3.c"
  _sqlite3DbFree($0,$24); //@line 93754 "c/sqlite3.c"
 }
 $25 = HEAP32[$2>>2]|0; //@line 93755 "c/sqlite3.c"
 $26 = $25 & 32768; //@line 93755 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 93755 "c/sqlite3.c"
 if (!($27)) {
  return; //@line 93758 "c/sqlite3.c"
 }
 _sqlite3DbFreeNN($0,$1); //@line 93756 "c/sqlite3.c"
 return; //@line 93758 "c/sqlite3.c"
}
function _clearSelect($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$025 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 118754 "c/sqlite3.c"
 if ($3) {
  return; //@line 118768 "c/sqlite3.c"
 }
 $4 = ((($1)) + 48|0); //@line 118755 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 118755 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 118756 "c/sqlite3.c"
 _sqlite3ExprListDelete($0,$6); //@line 118756 "c/sqlite3.c"
 $7 = ((($1)) + 28|0); //@line 118757 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 118757 "c/sqlite3.c"
 _sqlite3SrcListDelete($0,$8); //@line 118757 "c/sqlite3.c"
 $9 = ((($1)) + 32|0); //@line 118758 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 118758 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$10); //@line 118758 "c/sqlite3.c"
 $11 = ((($1)) + 36|0); //@line 118759 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 118759 "c/sqlite3.c"
 _sqlite3ExprListDelete($0,$12); //@line 118759 "c/sqlite3.c"
 $13 = ((($1)) + 40|0); //@line 118760 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 118760 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$14); //@line 118760 "c/sqlite3.c"
 $15 = ((($1)) + 44|0); //@line 118761 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 118761 "c/sqlite3.c"
 _sqlite3ExprListDelete($0,$16); //@line 118761 "c/sqlite3.c"
 $17 = ((($1)) + 56|0); //@line 118762 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 118762 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$18); //@line 118762 "c/sqlite3.c"
 $19 = ((($1)) + 60|0); //@line 118763 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 118763 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 118763 "c/sqlite3.c"
 if (!($21)) {
  _sqlite3WithDelete($0,$20); //@line 118763 "c/sqlite3.c"
 }
 $22 = ($2|0)==(0); //@line 118764 "c/sqlite3.c"
 if (!($22)) {
  _sqlite3DbFreeNN($0,$1); //@line 118764 "c/sqlite3.c"
 }
 $23 = ($5|0)==(0|0); //@line 118754 "c/sqlite3.c"
 if ($23) {
  return; //@line 118768 "c/sqlite3.c"
 }
 $$025 = $5;
 while(1) {
  $24 = ((($$025)) + 48|0); //@line 118755 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 118755 "c/sqlite3.c"
  $26 = HEAP32[$$025>>2]|0; //@line 118756 "c/sqlite3.c"
  _sqlite3ExprListDelete($0,$26); //@line 118756 "c/sqlite3.c"
  $27 = ((($$025)) + 28|0); //@line 118757 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 118757 "c/sqlite3.c"
  _sqlite3SrcListDelete($0,$28); //@line 118757 "c/sqlite3.c"
  $29 = ((($$025)) + 32|0); //@line 118758 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 118758 "c/sqlite3.c"
  _sqlite3ExprDelete($0,$30); //@line 118758 "c/sqlite3.c"
  $31 = ((($$025)) + 36|0); //@line 118759 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 118759 "c/sqlite3.c"
  _sqlite3ExprListDelete($0,$32); //@line 118759 "c/sqlite3.c"
  $33 = ((($$025)) + 40|0); //@line 118760 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 118760 "c/sqlite3.c"
  _sqlite3ExprDelete($0,$34); //@line 118760 "c/sqlite3.c"
  $35 = ((($$025)) + 44|0); //@line 118761 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 118761 "c/sqlite3.c"
  _sqlite3ExprListDelete($0,$36); //@line 118761 "c/sqlite3.c"
  $37 = ((($$025)) + 56|0); //@line 118762 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 118762 "c/sqlite3.c"
  _sqlite3ExprDelete($0,$38); //@line 118762 "c/sqlite3.c"
  $39 = ((($$025)) + 60|0); //@line 118763 "c/sqlite3.c"
  $40 = HEAP32[$39>>2]|0; //@line 118763 "c/sqlite3.c"
  $41 = ($40|0)==(0|0); //@line 118763 "c/sqlite3.c"
  if (!($41)) {
   _sqlite3WithDelete($0,$40); //@line 118763 "c/sqlite3.c"
  }
  _sqlite3DbFreeNN($0,$$025); //@line 118764 "c/sqlite3.c"
  $42 = ($25|0)==(0|0); //@line 118754 "c/sqlite3.c"
  if ($42) {
   break;
  } else {
   $$025 = $25;
  }
 }
 return; //@line 118768 "c/sqlite3.c"
}
function _sqlite3SrcListDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02930 = 0, $$031 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 105427 "c/sqlite3.c"
 if ($2) {
  return; //@line 105440 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 105428 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 105428 "c/sqlite3.c"
 if ($4) {
  $5 = ((($1)) + 8|0); //@line 105428 "c/sqlite3.c"
  $$02930 = 0;$$031 = $5;
  while(1) {
   $6 = ((($$031)) + 4|0); //@line 105429 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 105429 "c/sqlite3.c"
   _sqlite3DbFree($0,$7); //@line 105429 "c/sqlite3.c"
   $8 = ((($$031)) + 8|0); //@line 105430 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 105430 "c/sqlite3.c"
   _sqlite3DbFree($0,$9); //@line 105430 "c/sqlite3.c"
   $10 = ((($$031)) + 12|0); //@line 105431 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 105431 "c/sqlite3.c"
   _sqlite3DbFree($0,$11); //@line 105431 "c/sqlite3.c"
   $12 = ((($$031)) + 37|0); //@line 105432 "c/sqlite3.c"
   $13 = HEAP8[$12>>0]|0; //@line 105432 "c/sqlite3.c"
   $14 = $13 & 2; //@line 105432 "c/sqlite3.c"
   $15 = ($14<<24>>24)==(0); //@line 105432 "c/sqlite3.c"
   if (!($15)) {
    $16 = ((($$031)) + 64|0); //@line 105432 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 105432 "c/sqlite3.c"
    _sqlite3DbFree($0,$17); //@line 105432 "c/sqlite3.c"
   }
   $18 = HEAP8[$12>>0]|0; //@line 105433 "c/sqlite3.c"
   $19 = $18 & 4; //@line 105433 "c/sqlite3.c"
   $20 = ($19<<24>>24)==(0); //@line 105433 "c/sqlite3.c"
   if (!($20)) {
    $21 = ((($$031)) + 64|0); //@line 105433 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 105433 "c/sqlite3.c"
    _sqlite3ExprListDelete($0,$22); //@line 105433 "c/sqlite3.c"
   }
   $23 = ((($$031)) + 16|0); //@line 105434 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 105434 "c/sqlite3.c"
   _sqlite3DeleteTable($0,$24); //@line 105434 "c/sqlite3.c"
   $25 = ((($$031)) + 20|0); //@line 105435 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 105435 "c/sqlite3.c"
   _sqlite3SelectDelete($0,$26); //@line 105435 "c/sqlite3.c"
   $27 = ((($$031)) + 48|0); //@line 105436 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 105436 "c/sqlite3.c"
   _sqlite3ExprDelete($0,$28); //@line 105436 "c/sqlite3.c"
   $29 = ((($$031)) + 52|0); //@line 105437 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 105437 "c/sqlite3.c"
   _sqlite3IdListDelete($0,$30); //@line 105437 "c/sqlite3.c"
   $31 = (($$02930) + 1)|0; //@line 105428 "c/sqlite3.c"
   $32 = ((($$031)) + 72|0); //@line 105428 "c/sqlite3.c"
   $33 = HEAP32[$1>>2]|0; //@line 105428 "c/sqlite3.c"
   $34 = ($31|0)<($33|0); //@line 105428 "c/sqlite3.c"
   if ($34) {
    $$02930 = $31;$$031 = $32;
   } else {
    break;
   }
  }
 }
 _sqlite3DbFreeNN($0,$1); //@line 105439 "c/sqlite3.c"
 return; //@line 105440 "c/sqlite3.c"
}
function _sqlite3WithDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 106064 "c/sqlite3.c"
 if ($2) {
  return; //@line 106074 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 106066 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 106066 "c/sqlite3.c"
 if ($4) {
  $$016 = 0;
  while(1) {
   $5 = (((((($1)) + 8|0) + ($$016<<4)|0)) + 4|0); //@line 106068 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 106068 "c/sqlite3.c"
   _sqlite3ExprListDelete($0,$6); //@line 106068 "c/sqlite3.c"
   $7 = (((((($1)) + 8|0) + ($$016<<4)|0)) + 8|0); //@line 106069 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 106069 "c/sqlite3.c"
   _sqlite3SelectDelete($0,$8); //@line 106069 "c/sqlite3.c"
   $9 = (((($1)) + 8|0) + ($$016<<4)|0); //@line 106070 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 106070 "c/sqlite3.c"
   _sqlite3DbFree($0,$10); //@line 106070 "c/sqlite3.c"
   $11 = (($$016) + 1)|0; //@line 106066 "c/sqlite3.c"
   $12 = HEAP32[$1>>2]|0; //@line 106066 "c/sqlite3.c"
   $13 = ($11|0)<($12|0); //@line 106066 "c/sqlite3.c"
   if ($13) {
    $$016 = $11;
   } else {
    break;
   }
  }
 }
 _sqlite3DbFree($0,$1); //@line 106072 "c/sqlite3.c"
 return; //@line 106074 "c/sqlite3.c"
}
function _sqlite3IdListDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$09 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 105244 "c/sqlite3.c"
 if ($2) {
  return; //@line 105250 "c/sqlite3.c"
 }
 $3 = ((($1)) + 4|0); //@line 105245 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 105245 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 105245 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0;
 if ($5) {
  $$09 = 0;$8 = $6;
  while(1) {
   $7 = (($8) + ($$09<<3)|0); //@line 105246 "c/sqlite3.c"
   $9 = HEAP32[$7>>2]|0; //@line 105246 "c/sqlite3.c"
   _sqlite3DbFree($0,$9); //@line 105246 "c/sqlite3.c"
   $10 = (($$09) + 1)|0; //@line 105245 "c/sqlite3.c"
   $11 = HEAP32[$3>>2]|0; //@line 105245 "c/sqlite3.c"
   $12 = ($10|0)<($11|0); //@line 105245 "c/sqlite3.c"
   $13 = HEAP32[$1>>2]|0;
   if ($12) {
    $$09 = $10;$8 = $13;
   } else {
    $$lcssa = $13;
    break;
   }
  }
 } else {
  $$lcssa = $6;
 }
 _sqlite3DbFree($0,$$lcssa); //@line 105248 "c/sqlite3.c"
 _sqlite3DbFreeNN($0,$1); //@line 105249 "c/sqlite3.c"
 return; //@line 105250 "c/sqlite3.c"
}
function _fkTriggerDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 110091 "c/sqlite3.c"
 if ($2) {
  return; //@line 110099 "c/sqlite3.c"
 }
 $3 = ((($1)) + 28|0); //@line 110092 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 110092 "c/sqlite3.c"
 $5 = ((($4)) + 16|0); //@line 110093 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 110093 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$6); //@line 110093 "c/sqlite3.c"
 $7 = ((($4)) + 20|0); //@line 110094 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 110094 "c/sqlite3.c"
 _sqlite3ExprListDelete($0,$8); //@line 110094 "c/sqlite3.c"
 $9 = ((($4)) + 8|0); //@line 110095 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 110095 "c/sqlite3.c"
 _sqlite3SelectDelete($0,$10); //@line 110095 "c/sqlite3.c"
 $11 = ((($1)) + 12|0); //@line 110096 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 110096 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$12); //@line 110096 "c/sqlite3.c"
 _sqlite3DbFree($0,$1); //@line 110097 "c/sqlite3.c"
 return; //@line 110099 "c/sqlite3.c"
}
function _sqlite3DeleteTriggerStep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 124958 "c/sqlite3.c"
 if ($2) {
  return; //@line 124970 "c/sqlite3.c"
 }
 $$016 = $1;
 while(1) {
  $3 = ((($$016)) + 32|0); //@line 124960 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 124960 "c/sqlite3.c"
  $5 = ((($$016)) + 16|0); //@line 124962 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 124962 "c/sqlite3.c"
  _sqlite3ExprDelete($0,$6); //@line 124962 "c/sqlite3.c"
  $7 = ((($$016)) + 20|0); //@line 124963 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 124963 "c/sqlite3.c"
  _sqlite3ExprListDelete($0,$8); //@line 124963 "c/sqlite3.c"
  $9 = ((($$016)) + 8|0); //@line 124964 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 124964 "c/sqlite3.c"
  _sqlite3SelectDelete($0,$10); //@line 124964 "c/sqlite3.c"
  $11 = ((($$016)) + 24|0); //@line 124965 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 124965 "c/sqlite3.c"
  _sqlite3IdListDelete($0,$12); //@line 124965 "c/sqlite3.c"
  $13 = ((($$016)) + 28|0); //@line 124966 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 124966 "c/sqlite3.c"
  _sqlite3DbFree($0,$14); //@line 124966 "c/sqlite3.c"
  _sqlite3DbFree($0,$$016); //@line 124968 "c/sqlite3.c"
  $15 = ($4|0)==(0|0); //@line 124958 "c/sqlite3.c"
  if ($15) {
   break;
  } else {
   $$016 = $4;
  }
 }
 return; //@line 124970 "c/sqlite3.c"
}
function _sqlite3BtreeSchemaLocked($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 70213 "c/sqlite3.c"
 $1 = (_querySharedCacheTableLock($0,1,1)|0); //@line 70214 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 70216 "c/sqlite3.c"
 return ($1|0); //@line 70217 "c/sqlite3.c"
}
function _sqlite3ErrorWithMsg($0,$1,$2,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $varargs = $varargs|0;
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($0)) + 56|0); //@line 28648 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 28648 "c/sqlite3.c"
 _sqlite3SystemError($0,$1); //@line 28649 "c/sqlite3.c"
 $5 = ($2|0)==(0|0); //@line 28650 "c/sqlite3.c"
 if ($5) {
  _sqlite3Error($0,$1); //@line 28651 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 28660 "c/sqlite3.c"
 }
 $6 = ((($0)) + 248|0); //@line 28652 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 28652 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 28652 "c/sqlite3.c"
 if ($8) {
  $9 = (_sqlite3ValueNew($0)|0); //@line 28652 "c/sqlite3.c"
  HEAP32[$6>>2] = $9; //@line 28652 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 28652 "c/sqlite3.c"
  if ($10) {
   STACKTOP = sp;return; //@line 28660 "c/sqlite3.c"
  }
 }
 HEAP32[$3>>2] = $varargs; //@line 28655 "c/sqlite3.c"
 $11 = (_sqlite3VMPrintf($0,$2,$3)|0); //@line 28656 "c/sqlite3.c"
 $12 = HEAP32[$6>>2]|0; //@line 28658 "c/sqlite3.c"
 _sqlite3ValueSetStr($12,$11,1,157); //@line 28658 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 28660 "c/sqlite3.c"
}
function _sqlite3VtabUnlockList($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 352|0); //@line 127617 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 127617 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 127618 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 127623 "c/sqlite3.c"
 if ($3) {
  return; //@line 127631 "c/sqlite3.c"
 }
 _sqlite3ExpirePreparedStatements($0); //@line 127624 "c/sqlite3.c"
 $$0 = $2;
 while(1) {
  $4 = ((($$0)) + 24|0); //@line 127626 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 127626 "c/sqlite3.c"
  _sqlite3VtabUnlock($$0); //@line 127627 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 127629 "c/sqlite3.c"
  if ($6) {
   break;
  } else {
   $$0 = $5;
  }
 }
 return; //@line 127631 "c/sqlite3.c"
}
function _sqlite3DbStrNDup($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 25758 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  return ($$0|0); //@line 25768 "c/sqlite3.c"
 }
 $5 = (_i64Add(($2|0),($3|0),1,0)|0); //@line 25762 "c/sqlite3.c"
 $6 = tempRet0; //@line 25762 "c/sqlite3.c"
 $7 = (_sqlite3DbMallocRawNN($0,$5,$6)|0); //@line 25762 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 25763 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 25768 "c/sqlite3.c"
 }
 _memcpy(($7|0),($1|0),($2|0))|0; //@line 25764 "c/sqlite3.c"
 $9 = (($7) + ($2)|0); //@line 25765 "c/sqlite3.c"
 HEAP8[$9>>0] = 0; //@line 25765 "c/sqlite3.c"
 $$0 = $7;
 return ($$0|0); //@line 25768 "c/sqlite3.c"
}
function _sqlite3RunParser($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0$ph = 0, $$0100 = 0, $$0101 = 0, $$0101$ph = 0, $$0103106 = 0, $$0104$ph = 0, $$1102108 = 0, $$2 = 0, $$byval_copy = 0, $$pr = 0, $$pr109 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0;
 var $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0;
 var $91 = 0, $storemerge = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer5 = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 1248|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(1248|0);
 $$byval_copy = sp + 1240|0;
 $vararg_buffer5 = sp + 16|0;
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = sp + 1232|0;
 $4 = sp + 20|0;
 $5 = HEAP32[$0>>2]|0; //@line 142840 "c/sqlite3.c"
 $6 = ((($5)) + 104|0); //@line 142847 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 142847 "c/sqlite3.c"
 $8 = ((($5)) + 160|0); //@line 142848 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 142848 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 142848 "c/sqlite3.c"
 if ($10) {
  $11 = ((($5)) + 256|0); //@line 142849 "c/sqlite3.c"
  HEAP32[$11>>2] = 0; //@line 142849 "c/sqlite3.c"
 }
 $12 = ((($0)) + 12|0); //@line 142851 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 142851 "c/sqlite3.c"
 $13 = ((($0)) + 428|0); //@line 142852 "c/sqlite3.c"
 HEAP32[$13>>2] = $1; //@line 142852 "c/sqlite3.c"
 _sqlite3ParserInit($4); //@line 142857 "c/sqlite3.c"
 $14 = ((($0)) + 388|0);
 $15 = ((($0)) + 392|0);
 $16 = ((($5)) + 73|0);
 $17 = ((($5)) + 256|0);
 $$0$ph = $1;$$0101$ph = $7;$$0104$ph = -1;
 L4: while(1) {
  $$0 = $$0$ph;$$0101 = $$0101$ph;
  while(1) {
   $18 = HEAP8[$$0>>0]|0; //@line 142870 "c/sqlite3.c"
   $19 = ($18<<24>>24)==(0); //@line 142870 "c/sqlite3.c"
   if ($19) {
    label = 8;
    break;
   }
   $20 = (_sqlite3GetToken($$0,$3)|0); //@line 142871 "c/sqlite3.c"
   $21 = (($$0101) - ($20))|0; //@line 142872 "c/sqlite3.c"
   $22 = ($21|0)<(0); //@line 142873 "c/sqlite3.c"
   if ($22) {
    label = 7;
    break L4;
   }
   $$pr = HEAP32[$3>>2]|0; //@line 142889 "c/sqlite3.c"
   $23 = ($$pr|0)>(157); //@line 142889 "c/sqlite3.c"
   if (!($23)) {
    $$0103106 = $20;$$1102108 = $21;$28 = $$pr;
    break;
   }
   $24 = HEAP32[$17>>2]|0; //@line 142891 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 142891 "c/sqlite3.c"
   if (!($25)) {
    label = 13;
    break L4;
   }
   $26 = ($$pr|0)==(159); //@line 142895 "c/sqlite3.c"
   if ($26) {
    label = 15;
    break L4;
   }
   $27 = (($$0) + ($20)|0); //@line 142899 "c/sqlite3.c"
   $$0 = $27;$$0101 = $21;
  }
  if ((label|0) == 8) {
   label = 0;
   switch ($$0104$ph|0) {
   case 0:  {
    $$2 = $$0;
    break L4;
    break;
   }
   case 1:  {
    $storemerge = 0;
    break;
   }
   default: {
    $storemerge = 1;
   }
   }
   HEAP32[$3>>2] = $storemerge;
   $$0103106 = 0;$$1102108 = $$0101;$28 = $storemerge;
  }
  HEAP32[$14>>2] = $$0; //@line 142901 "c/sqlite3.c"
  HEAP32[$15>>2] = $$0103106; //@line 142902 "c/sqlite3.c"
  ;HEAP32[$$byval_copy>>2]=HEAP32[$14>>2]|0;HEAP32[$$byval_copy+4>>2]=HEAP32[$14+4>>2]|0; //@line 142903 "c/sqlite3.c"
  _sqlite3Parser($4,$28,$$byval_copy,$0); //@line 142903 "c/sqlite3.c"
  $29 = (($$0) + ($$0103106)|0); //@line 142905 "c/sqlite3.c"
  $30 = HEAP32[$12>>2]|0; //@line 142906 "c/sqlite3.c"
  $31 = ($30|0)==(0); //@line 142906 "c/sqlite3.c"
  if (!($31)) {
   $$2 = $29;
   break;
  }
  $32 = HEAP32[$3>>2]|0; //@line 142904 "c/sqlite3.c"
  $33 = HEAP8[$16>>0]|0; //@line 142906 "c/sqlite3.c"
  $34 = ($33<<24>>24)==(0); //@line 142906 "c/sqlite3.c"
  if ($34) {
   $$0$ph = $29;$$0101$ph = $$1102108;$$0104$ph = $32;
  } else {
   $$2 = $29;
   break;
  }
 }
 if ((label|0) == 7) {
  HEAP32[$12>>2] = 18; //@line 142874 "c/sqlite3.c"
  $$2 = $$0;
 }
 else if ((label|0) == 13) {
  HEAP32[$12>>2] = 9; //@line 142892 "c/sqlite3.c"
  $$2 = $$0;
 }
 else if ((label|0) == 15) {
  HEAP32[$vararg_buffer>>2] = $20; //@line 142896 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 142896 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $$0; //@line 142896 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,18538,$vararg_buffer); //@line 142896 "c/sqlite3.c"
  $$2 = $$0;
 }
 HEAP32[$13>>2] = $$2; //@line 142910 "c/sqlite3.c"
 _sqlite3ParserFinalize($4); //@line 142919 "c/sqlite3.c"
 $35 = ((($5)) + 73|0); //@line 142923 "c/sqlite3.c"
 $36 = HEAP8[$35>>0]|0; //@line 142923 "c/sqlite3.c"
 $37 = ($36<<24>>24)==(0); //@line 142923 "c/sqlite3.c"
 if ($37) {
  $$pr109 = HEAP32[$12>>2]|0; //@line 142926 "c/sqlite3.c"
  switch ($$pr109|0) {
  case 101: case 0:  {
   break;
  }
  default: {
   $41 = $$pr109;
   label = 22;
  }
  }
 } else {
  HEAP32[$12>>2] = 7; //@line 142924 "c/sqlite3.c"
  $41 = 7;
  label = 22;
 }
 if ((label|0) == 22) {
  $38 = ((($0)) + 4|0); //@line 142926 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 142926 "c/sqlite3.c"
  $40 = ($39|0)==(0|0); //@line 142926 "c/sqlite3.c"
  if ($40) {
   $42 = (_sqlite3ErrStr($41)|0); //@line 142927 "c/sqlite3.c"
   HEAP32[$vararg_buffer2>>2] = $42; //@line 142927 "c/sqlite3.c"
   $43 = (_sqlite3MPrintf($5,15687,$vararg_buffer2)|0); //@line 142927 "c/sqlite3.c"
   HEAP32[$38>>2] = $43; //@line 142927 "c/sqlite3.c"
  }
 }
 $44 = ((($0)) + 4|0); //@line 142930 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 142930 "c/sqlite3.c"
 $46 = ($45|0)==(0|0); //@line 142930 "c/sqlite3.c"
 if ($46) {
  $$0100 = 0;
 } else {
  HEAP32[$2>>2] = $45; //@line 142931 "c/sqlite3.c"
  $47 = HEAP32[$12>>2]|0; //@line 142932 "c/sqlite3.c"
  HEAP32[$vararg_buffer5>>2] = $45; //@line 142932 "c/sqlite3.c"
  _sqlite3_log($47,15687,$vararg_buffer5); //@line 142932 "c/sqlite3.c"
  HEAP32[$44>>2] = 0; //@line 142933 "c/sqlite3.c"
  $$0100 = 1;
 }
 $48 = ((($0)) + 8|0); //@line 142936 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 142936 "c/sqlite3.c"
 $50 = ($49|0)==(0|0); //@line 142936 "c/sqlite3.c"
 if (!($50)) {
  $51 = ((($0)) + 36|0); //@line 142936 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 142936 "c/sqlite3.c"
  $53 = ($52|0)>(0); //@line 142936 "c/sqlite3.c"
  if ($53) {
   $54 = ((($0)) + 18|0); //@line 142936 "c/sqlite3.c"
   $55 = HEAP8[$54>>0]|0; //@line 142936 "c/sqlite3.c"
   $56 = ($55<<24>>24)==(0); //@line 142936 "c/sqlite3.c"
   if ($56) {
    _sqlite3VdbeDelete($49); //@line 142937 "c/sqlite3.c"
    HEAP32[$48>>2] = 0; //@line 142938 "c/sqlite3.c"
   }
  }
 }
 $57 = ((($0)) + 18|0); //@line 142941 "c/sqlite3.c"
 $58 = HEAP8[$57>>0]|0; //@line 142941 "c/sqlite3.c"
 $59 = ($58<<24>>24)==(0); //@line 142941 "c/sqlite3.c"
 if ($59) {
  $60 = ((($0)) + 112|0); //@line 142942 "c/sqlite3.c"
  $61 = HEAP32[$60>>2]|0; //@line 142942 "c/sqlite3.c"
  _sqlite3DbFree($5,$61); //@line 142942 "c/sqlite3.c"
  HEAP32[$60>>2] = 0; //@line 142943 "c/sqlite3.c"
  $62 = ((($0)) + 108|0); //@line 142944 "c/sqlite3.c"
  HEAP32[$62>>2] = 0; //@line 142944 "c/sqlite3.c"
 }
 $63 = ((($0)) + 452|0); //@line 142948 "c/sqlite3.c"
 $64 = HEAP32[$63>>2]|0; //@line 142948 "c/sqlite3.c"
 _sqlite3_free($64); //@line 142948 "c/sqlite3.c"
 $65 = ((($0)) + 400|0); //@line 142951 "c/sqlite3.c"
 $66 = HEAP8[$65>>0]|0; //@line 142951 "c/sqlite3.c"
 $67 = ($66<<24>>24)==(0); //@line 142951 "c/sqlite3.c"
 if ($67) {
  $68 = ((($0)) + 432|0); //@line 142956 "c/sqlite3.c"
  $69 = HEAP32[$68>>2]|0; //@line 142956 "c/sqlite3.c"
  _sqlite3DeleteTable($5,$69); //@line 142956 "c/sqlite3.c"
 }
 $70 = ((($0)) + 468|0); //@line 142959 "c/sqlite3.c"
 $71 = HEAP32[$70>>2]|0; //@line 142959 "c/sqlite3.c"
 $72 = ($71|0)==(0|0); //@line 142959 "c/sqlite3.c"
 if (!($72)) {
  _sqlite3WithDelete($5,$71); //@line 142959 "c/sqlite3.c"
 }
 $73 = ((($0)) + 436|0); //@line 142960 "c/sqlite3.c"
 $74 = HEAP32[$73>>2]|0; //@line 142960 "c/sqlite3.c"
 _sqlite3DeleteTrigger($5,$74); //@line 142960 "c/sqlite3.c"
 $75 = ((($0)) + 420|0); //@line 142961 "c/sqlite3.c"
 $76 = HEAP32[$75>>2]|0; //@line 142961 "c/sqlite3.c"
 _sqlite3DbFree($5,$76); //@line 142961 "c/sqlite3.c"
 $77 = ((($0)) + 116|0); //@line 142962 "c/sqlite3.c"
 $78 = HEAP32[$77>>2]|0; //@line 142962 "c/sqlite3.c"
 $79 = ($78|0)==(0|0); //@line 142962 "c/sqlite3.c"
 if (!($79)) {
  $81 = $78;
  while(1) {
   $80 = HEAP32[$81>>2]|0; //@line 142964 "c/sqlite3.c"
   HEAP32[$77>>2] = $80; //@line 142964 "c/sqlite3.c"
   _sqlite3DbFreeNN($5,$81); //@line 142965 "c/sqlite3.c"
   $82 = HEAP32[$77>>2]|0; //@line 142962 "c/sqlite3.c"
   $83 = ($82|0)==(0|0); //@line 142962 "c/sqlite3.c"
   if ($83) {
    break;
   } else {
    $81 = $82;
   }
  }
 }
 $84 = ((($0)) + 456|0); //@line 142967 "c/sqlite3.c"
 $85 = HEAP32[$84>>2]|0; //@line 142967 "c/sqlite3.c"
 $86 = ($85|0)==(0|0); //@line 142967 "c/sqlite3.c"
 if ($86) {
  STACKTOP = sp;return ($$0100|0); //@line 142973 "c/sqlite3.c"
 }
 $88 = $85;
 while(1) {
  $87 = ((($88)) + 76|0); //@line 142969 "c/sqlite3.c"
  $89 = HEAP32[$87>>2]|0; //@line 142969 "c/sqlite3.c"
  HEAP32[$84>>2] = $89; //@line 142969 "c/sqlite3.c"
  _sqlite3DeleteTable($5,$88); //@line 142970 "c/sqlite3.c"
  $90 = HEAP32[$84>>2]|0; //@line 142967 "c/sqlite3.c"
  $91 = ($90|0)==(0|0); //@line 142967 "c/sqlite3.c"
  if ($91) {
   break;
  } else {
   $88 = $90;
  }
 }
 STACKTOP = sp;return ($$0100|0); //@line 142973 "c/sqlite3.c"
}
function _schemaIsValid($0) {
 $0 = $0|0;
 var $$03133 = 0, $$032 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $switch$split12D = 0, $switch$split2D = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = HEAP32[$0>>2]|0; //@line 118197 "c/sqlite3.c"
 $3 = ((($2)) + 20|0); //@line 118204 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 118204 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 118204 "c/sqlite3.c"
 if (!($5)) {
  STACKTOP = sp;return; //@line 118236 "c/sqlite3.c"
 }
 $6 = ((($2)) + 16|0);
 $7 = ((($0)) + 12|0);
 $$03133 = 0;
 L4: while(1) {
  $8 = HEAP32[$6>>2]|0; //@line 118206 "c/sqlite3.c"
  $9 = (((($8) + ($$03133<<4)|0)) + 4|0); //@line 118206 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 118206 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 118207 "c/sqlite3.c"
  if (!($11)) {
   $12 = (_sqlite3BtreeIsInReadTrans($10)|0); //@line 118212 "c/sqlite3.c"
   $13 = ($12|0)==(0); //@line 118212 "c/sqlite3.c"
   if ($13) {
    $14 = (_sqlite3BtreeBeginTrans($10,0)|0); //@line 118213 "c/sqlite3.c"
    $switch$split2D = ($14|0)<(7);
    if (!($switch$split2D)) {
     label = 14;
     break;
    }
    switch ($14|0) {
    case 0:  {
     $$032 = 1;
     break;
    }
    default: {
     label = 12;
     break L4;
    }
    }
   } else {
    $$032 = 0;
   }
   _sqlite3BtreeGetMeta($10,1,$1); //@line 118224 "c/sqlite3.c"
   $15 = HEAP32[$1>>2]|0; //@line 118226 "c/sqlite3.c"
   $16 = HEAP32[$6>>2]|0; //@line 118226 "c/sqlite3.c"
   $17 = (((($16) + ($$03133<<4)|0)) + 12|0); //@line 118226 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 118226 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 118226 "c/sqlite3.c"
   $20 = ($15|0)==($19|0); //@line 118226 "c/sqlite3.c"
   if (!($20)) {
    _sqlite3ResetOneSchema($2,$$03133); //@line 118227 "c/sqlite3.c"
    HEAP32[$7>>2] = 17; //@line 118228 "c/sqlite3.c"
   }
   $21 = ($$032|0)==(0); //@line 118232 "c/sqlite3.c"
   if (!($21)) {
    (_sqlite3BtreeCommit($10)|0); //@line 118233 "c/sqlite3.c"
   }
  }
  $22 = (($$03133) + 1)|0; //@line 118204 "c/sqlite3.c"
  $23 = HEAP32[$3>>2]|0; //@line 118204 "c/sqlite3.c"
  $24 = ($22|0)<($23|0); //@line 118204 "c/sqlite3.c"
  if ($24) {
   $$03133 = $22;
  } else {
   label = 12;
   break;
  }
 }
 if ((label|0) == 12) {
  STACKTOP = sp;return; //@line 118236 "c/sqlite3.c"
 }
 else if ((label|0) == 14) {
  $switch$split12D = ($14|0)<(3082);
  L21: do {
   if ($switch$split12D) {
    switch ($14|0) {
    case 7:  {
     break L21;
     break;
    }
    default: {
    }
    }
    STACKTOP = sp;return; //@line 118236 "c/sqlite3.c"
   } else {
    switch ($14|0) {
    case 3082:  {
     break L21;
     break;
    }
    default: {
    }
    }
    STACKTOP = sp;return; //@line 118236 "c/sqlite3.c"
   }
  } while(0);
  _sqlite3OomFault($2); //@line 118215 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 118236 "c/sqlite3.c"
 }
}
function _sqlite3VdbeSetNumCols($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 75145 "c/sqlite3.c"
 $3 = ((($0)) + 140|0); //@line 75147 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 75147 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 75147 "c/sqlite3.c"
 $6 = ((($0)) + 100|0); //@line 75148 "c/sqlite3.c"
 if (!($5)) {
  $7 = $4&65535; //@line 75148 "c/sqlite3.c"
  $8 = $7 << 1; //@line 75148 "c/sqlite3.c"
  $9 = HEAP32[$6>>2]|0; //@line 75148 "c/sqlite3.c"
  _releaseMemArray($9,$8); //@line 75148 "c/sqlite3.c"
  $10 = HEAP32[$6>>2]|0; //@line 75149 "c/sqlite3.c"
  _sqlite3DbFree($2,$10); //@line 75149 "c/sqlite3.c"
 }
 $11 = $1&65535; //@line 75152 "c/sqlite3.c"
 HEAP16[$3>>1] = $11; //@line 75152 "c/sqlite3.c"
 $12 = ($1*80)|0; //@line 75153 "c/sqlite3.c"
 $13 = (_sqlite3DbMallocRawNN($2,$12,0)|0); //@line 75153 "c/sqlite3.c"
 $14 = ((($0)) + 100|0); //@line 75153 "c/sqlite3.c"
 HEAP32[$14>>2] = $13; //@line 75153 "c/sqlite3.c"
 $15 = ($13|0)==(0|0); //@line 75154 "c/sqlite3.c"
 if ($15) {
  return; //@line 75156 "c/sqlite3.c"
 }
 $16 = $1 << 1; //@line 75151 "c/sqlite3.c"
 _initMemArray($13,$16,$2,1); //@line 75155 "c/sqlite3.c"
 return; //@line 75156 "c/sqlite3.c"
}
function _sqlite3VdbeSetColName($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$0>>2]|0; //@line 75179 "c/sqlite3.c"
 $6 = ((($5)) + 73|0); //@line 75179 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 75179 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 75179 "c/sqlite3.c"
 if (!($8)) {
  return;
 }
 $9 = ((($0)) + 100|0); //@line 75184 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 75184 "c/sqlite3.c"
 $11 = ((($0)) + 140|0); //@line 75184 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 75184 "c/sqlite3.c"
 $13 = $12&65535; //@line 75184 "c/sqlite3.c"
 $14 = Math_imul($13, $2)|0; //@line 75184 "c/sqlite3.c"
 $15 = (($14) + ($1))|0; //@line 75184 "c/sqlite3.c"
 $16 = (($10) + (($15*40)|0)|0); //@line 75184 "c/sqlite3.c"
 (_sqlite3VdbeMemSetStr($16,$3,-1,1,$4)|0); //@line 75185 "c/sqlite3.c"
 return;
}
function _sqlite3VdbeSetSql($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($0|0)==(0|0); //@line 73020 "c/sqlite3.c"
 if ($4) {
  return; //@line 73027 "c/sqlite3.c"
 }
 $5 = ((($0)) + 144|0); //@line 73021 "c/sqlite3.c"
 HEAP8[$5>>0] = $3; //@line 73021 "c/sqlite3.c"
 $6 = ($3<<24>>24)>(-1); //@line 73022 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 204|0); //@line 73023 "c/sqlite3.c"
  HEAP32[$7>>2] = 0; //@line 73023 "c/sqlite3.c"
 }
 $8 = HEAP32[$0>>2]|0; //@line 73026 "c/sqlite3.c"
 $9 = ($2|0)<(0); //@line 73026 "c/sqlite3.c"
 $10 = $9 << 31 >> 31; //@line 73026 "c/sqlite3.c"
 $11 = (_sqlite3DbStrNDup($8,$1,$2,$10)|0); //@line 73026 "c/sqlite3.c"
 $12 = ((($0)) + 184|0); //@line 73026 "c/sqlite3.c"
 HEAP32[$12>>2] = $11; //@line 73026 "c/sqlite3.c"
 return; //@line 73027 "c/sqlite3.c"
}
function _sqlite3VdbeFinalize($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $switch$split2D = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 75935 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 75935 "c/sqlite3.c"
 $switch$split2D = ($2|0)<(832317811);
 if ($switch$split2D) {
  switch ($2|0) {
  case 770837923:  {
   label = 2;
   break;
  }
  default: {
   $$0 = 0;
  }
  }
 } else {
  switch ($2|0) {
  case 832317811:  {
   label = 2;
   break;
  }
  default: {
   $$0 = 0;
  }
  }
 }
 if ((label|0) == 2) {
  $3 = (_sqlite3VdbeReset($0)|0); //@line 75936 "c/sqlite3.c"
  $$0 = $3;
 }
 _sqlite3VdbeDelete($0); //@line 75939 "c/sqlite3.c"
 return ($$0|0); //@line 75940 "c/sqlite3.c"
}
function _sqlite3ParserReset($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 118275 "c/sqlite3.c"
 $2 = ((($0)) + 72|0); //@line 118276 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 118276 "c/sqlite3.c"
 _sqlite3DbFree($1,$3); //@line 118276 "c/sqlite3.c"
 $4 = ((($0)) + 76|0); //@line 118277 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 118277 "c/sqlite3.c"
 _sqlite3ExprListDelete($1,$5); //@line 118277 "c/sqlite3.c"
 $6 = ($1|0)==(0|0); //@line 118278 "c/sqlite3.c"
 if ($6) {
  $13 = ((($0)) + 24|0); //@line 118282 "c/sqlite3.c"
  HEAP8[$13>>0] = 0; //@line 118282 "c/sqlite3.c"
  return; //@line 118283 "c/sqlite3.c"
 }
 $7 = ((($0)) + 24|0); //@line 118280 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 118280 "c/sqlite3.c"
 $9 = $8&255; //@line 118280 "c/sqlite3.c"
 $10 = ((($1)) + 264|0); //@line 118280 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 118280 "c/sqlite3.c"
 $12 = (($11) - ($9))|0; //@line 118280 "c/sqlite3.c"
 HEAP32[$10>>2] = $12; //@line 118280 "c/sqlite3.c"
 $13 = ((($0)) + 24|0); //@line 118282 "c/sqlite3.c"
 HEAP8[$13>>0] = 0; //@line 118282 "c/sqlite3.c"
 return; //@line 118283 "c/sqlite3.c"
}
function _sqlite3VdbeReset($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 75845 "c/sqlite3.c"
 $1 = HEAP32[$0>>2]|0; //@line 75851 "c/sqlite3.c"
 (_sqlite3VdbeHalt($0)|0); //@line 75857 "c/sqlite3.c"
 $2 = ((($0)) + 36|0); //@line 75864 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 75864 "c/sqlite3.c"
 $4 = ($3|0)>(-1); //@line 75864 "c/sqlite3.c"
 if ($4) {
  (_sqlite3VdbeTransferError($0)|0); //@line 75866 "c/sqlite3.c"
  $5 = ((($0)) + 145|0); //@line 75867 "c/sqlite3.c"
  $6 = HEAPU8[$5>>0]|(HEAPU8[$5+1>>0]<<8); //@line 75867 "c/sqlite3.c"
  $7 = $6 & 32; //@line 75867 "c/sqlite3.c"
  $8 = ($7<<16>>16)==(0); //@line 75867 "c/sqlite3.c"
  if (!($8)) {
   $9 = $6 | 1; //@line 75867 "c/sqlite3.c"
   HEAP8[$5>>0]=$9&255;HEAP8[$5+1>>0]=$9>>8; //@line 75867 "c/sqlite3.c"
  }
 } else {
  $10 = ((($0)) + 40|0); //@line 75868 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 75868 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 75868 "c/sqlite3.c"
  if (!($12)) {
   $13 = ((($0)) + 145|0); //@line 75868 "c/sqlite3.c"
   $14 = HEAPU8[$13>>0]|(HEAPU8[$13+1>>0]<<8); //@line 75868 "c/sqlite3.c"
   $15 = $14 & 1; //@line 75868 "c/sqlite3.c"
   $16 = ($15<<16>>16)==(0); //@line 75868 "c/sqlite3.c"
   if (!($16)) {
    $17 = ((($0)) + 108|0); //@line 75873 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 75873 "c/sqlite3.c"
    $19 = ($18|0)==(0|0); //@line 75873 "c/sqlite3.c"
    $20 = $19 ? 0 : 15687; //@line 75873 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $18; //@line 75873 "c/sqlite3.c"
    _sqlite3ErrorWithMsg($1,$11,$20,$vararg_buffer); //@line 75873 "c/sqlite3.c"
   }
  }
 }
 $21 = ((($0)) + 108|0); //@line 75886 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 75886 "c/sqlite3.c"
 _sqlite3DbFree($1,$22); //@line 75886 "c/sqlite3.c"
 HEAP32[$21>>2] = 0; //@line 75887 "c/sqlite3.c"
 $23 = ((($0)) + 104|0); //@line 75888 "c/sqlite3.c"
 HEAP32[$23>>2] = 0; //@line 75888 "c/sqlite3.c"
 $24 = ((($0)) + 20|0); //@line 75925 "c/sqlite3.c"
 HEAP32[$24>>2] = 1224384374; //@line 75925 "c/sqlite3.c"
 $25 = ((($0)) + 40|0); //@line 75926 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 75926 "c/sqlite3.c"
 $27 = ((($1)) + 60|0); //@line 75926 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 75926 "c/sqlite3.c"
 $29 = $28 & $26; //@line 75926 "c/sqlite3.c"
 STACKTOP = sp;return ($29|0); //@line 75926 "c/sqlite3.c"
}
function _sqlite3VdbeDelete($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 76022 "c/sqlite3.c"
 _sqlite3VdbeClearObject($1,$0); //@line 76024 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 76025 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 76025 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 76025 "c/sqlite3.c"
 $5 = ((($0)) + 8|0);
 $6 = HEAP32[$5>>2]|0;
 if ($4) {
  $8 = ((($1)) + 4|0); //@line 76029 "c/sqlite3.c"
  HEAP32[$8>>2] = $6; //@line 76029 "c/sqlite3.c"
 } else {
  $7 = ((($3)) + 8|0); //@line 76026 "c/sqlite3.c"
  HEAP32[$7>>2] = $6; //@line 76026 "c/sqlite3.c"
 }
 $9 = HEAP32[$5>>2]|0; //@line 76031 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 76031 "c/sqlite3.c"
 if (!($10)) {
  $11 = HEAP32[$2>>2]|0; //@line 76032 "c/sqlite3.c"
  $12 = ((($9)) + 4|0); //@line 76032 "c/sqlite3.c"
  HEAP32[$12>>2] = $11; //@line 76032 "c/sqlite3.c"
 }
 $13 = ((($0)) + 20|0); //@line 76034 "c/sqlite3.c"
 HEAP32[$13>>2] = 1443283912; //@line 76034 "c/sqlite3.c"
 HEAP32[$0>>2] = 0; //@line 76035 "c/sqlite3.c"
 _sqlite3DbFreeNN($1,$0); //@line 76036 "c/sqlite3.c"
 return; //@line 76037 "c/sqlite3.c"
}
function _sqlite3VdbeClearObject($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$in2829 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 100|0); //@line 75990 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 75990 "c/sqlite3.c"
 $4 = ((($1)) + 140|0); //@line 75990 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 75990 "c/sqlite3.c"
 $6 = $5&65535; //@line 75990 "c/sqlite3.c"
 $7 = $6 << 1; //@line 75990 "c/sqlite3.c"
 _releaseMemArray($3,$7); //@line 75990 "c/sqlite3.c"
 $8 = ((($1)) + 208|0); //@line 75991 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 75991 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 75991 "c/sqlite3.c"
 if (!($10)) {
  $$in2829 = $9;
  while(1) {
   $11 = ((($$in2829)) + 24|0); //@line 75992 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 75992 "c/sqlite3.c"
   $13 = HEAP32[$$in2829>>2]|0; //@line 75993 "c/sqlite3.c"
   $14 = ((($$in2829)) + 4|0); //@line 75993 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 75993 "c/sqlite3.c"
   _vdbeFreeOpArray($0,$13,$15); //@line 75993 "c/sqlite3.c"
   _sqlite3DbFree($0,$$in2829); //@line 75994 "c/sqlite3.c"
   $16 = ($12|0)==(0|0); //@line 75991 "c/sqlite3.c"
   if ($16) {
    break;
   } else {
    $$in2829 = $12;
   }
  }
 }
 $17 = ((($1)) + 20|0); //@line 75996 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 75996 "c/sqlite3.c"
 $19 = ($18|0)==(381479589); //@line 75996 "c/sqlite3.c"
 if (!($19)) {
  $20 = ((($1)) + 116|0); //@line 75997 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 75997 "c/sqlite3.c"
  $22 = ((($1)) + 16|0); //@line 75997 "c/sqlite3.c"
  $23 = HEAP16[$22>>1]|0; //@line 75997 "c/sqlite3.c"
  $24 = $23 << 16 >> 16; //@line 75997 "c/sqlite3.c"
  _releaseMemArray($21,$24); //@line 75997 "c/sqlite3.c"
  $25 = ((($1)) + 120|0); //@line 75998 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 75998 "c/sqlite3.c"
  _sqlite3DbFree($0,$26); //@line 75998 "c/sqlite3.c"
  $27 = ((($1)) + 188|0); //@line 75999 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 75999 "c/sqlite3.c"
  _sqlite3DbFree($0,$28); //@line 75999 "c/sqlite3.c"
 }
 $29 = ((($1)) + 88|0); //@line 76001 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 76001 "c/sqlite3.c"
 $31 = ((($1)) + 136|0); //@line 76001 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 76001 "c/sqlite3.c"
 _vdbeFreeOpArray($0,$30,$32); //@line 76001 "c/sqlite3.c"
 $33 = HEAP32[$2>>2]|0; //@line 76002 "c/sqlite3.c"
 _sqlite3DbFree($0,$33); //@line 76002 "c/sqlite3.c"
 $34 = ((($1)) + 184|0); //@line 76003 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 76003 "c/sqlite3.c"
 _sqlite3DbFree($0,$35); //@line 76003 "c/sqlite3.c"
 return; //@line 76013 "c/sqlite3.c"
}
function _releaseMemArray($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)!=(0|0); //@line 74520 "c/sqlite3.c"
 $3 = ($1|0)!=(0); //@line 74520 "c/sqlite3.c"
 $or$cond = $2 & $3; //@line 74520 "c/sqlite3.c"
 if (!($or$cond)) {
  return;
 }
 $4 = (($0) + (($1*40)|0)|0); //@line 74521 "c/sqlite3.c"
 $5 = ((($0)) + 32|0); //@line 74522 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 74522 "c/sqlite3.c"
 $7 = ((($6)) + 464|0); //@line 74523 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 74523 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 74523 "c/sqlite3.c"
 if (!($9)) {
  $$0 = $0;
  while(1) {
   $10 = ((($$0)) + 24|0); //@line 74525 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 74525 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 74525 "c/sqlite3.c"
   if (!($12)) {
    $13 = ((($$0)) + 20|0); //@line 74525 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 74525 "c/sqlite3.c"
    _sqlite3DbFree($6,$14); //@line 74525 "c/sqlite3.c"
   }
   $15 = ((($$0)) + 40|0); //@line 74526 "c/sqlite3.c"
   $16 = ($15>>>0)<($4>>>0); //@line 74526 "c/sqlite3.c"
   if ($16) {
    $$0 = $15;
   } else {
    break;
   }
  }
  return;
 }
 $$1 = $0;
 while(1) {
  $17 = ((($$1)) + 8|0); //@line 74549 "c/sqlite3.c"
  $18 = HEAP16[$17>>1]|0; //@line 74549 "c/sqlite3.c"
  $19 = $18 & 9312; //@line 74549 "c/sqlite3.c"
  $20 = ($19<<16>>16)==(0); //@line 74549 "c/sqlite3.c"
  if ($20) {
   $21 = ((($$1)) + 24|0); //@line 74551 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 74551 "c/sqlite3.c"
   $23 = ($22|0)==(0); //@line 74551 "c/sqlite3.c"
   if (!($23)) {
    $24 = ((($$1)) + 20|0); //@line 74552 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 74552 "c/sqlite3.c"
    _sqlite3DbFreeNN($6,$25); //@line 74552 "c/sqlite3.c"
    HEAP32[$21>>2] = 0; //@line 74553 "c/sqlite3.c"
   }
  } else {
   _sqlite3VdbeMemRelease($$1); //@line 74550 "c/sqlite3.c"
  }
  HEAP16[$17>>1] = 128; //@line 74556 "c/sqlite3.c"
  $26 = ((($$1)) + 40|0); //@line 74557 "c/sqlite3.c"
  $27 = ($26>>>0)<($4>>>0); //@line 74557 "c/sqlite3.c"
  if ($27) {
   $$1 = $26;
  } else {
   break;
  }
 }
 return;
}
function _vdbeFreeOpArray($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 73869 "c/sqlite3.c"
 if ($3) {
  return; //@line 73879 "c/sqlite3.c"
 }
 $4 = ($2|0)<(1); //@line 73871 "c/sqlite3.c"
 if (!($4)) {
  $5 = (($2) + -1)|0; //@line 73871 "c/sqlite3.c"
  $6 = (($1) + (($5*20)|0)|0); //@line 73871 "c/sqlite3.c"
  $$012 = $6;
  while(1) {
   $7 = ((($$012)) + 1|0); //@line 73872 "c/sqlite3.c"
   $8 = HEAP8[$7>>0]|0; //@line 73872 "c/sqlite3.c"
   $9 = ($8<<24>>24)<(-6); //@line 73872 "c/sqlite3.c"
   if ($9) {
    $10 = ((($$012)) + 16|0); //@line 73872 "c/sqlite3.c"
    $11 = $8 << 24 >> 24; //@line 73872 "c/sqlite3.c"
    $12 = HEAP32[$10>>2]|0; //@line 73872 "c/sqlite3.c"
    _freeP4($0,$11,$12); //@line 73872 "c/sqlite3.c"
   }
   $13 = ((($$012)) + -20|0); //@line 73871 "c/sqlite3.c"
   $14 = ($13>>>0)<($1>>>0); //@line 73871 "c/sqlite3.c"
   if ($14) {
    break;
   } else {
    $$012 = $13;
   }
  }
 }
 _sqlite3DbFreeNN($0,$1); //@line 73877 "c/sqlite3.c"
 return; //@line 73879 "c/sqlite3.c"
}
function _freeP4($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 L1: do {
  switch ($1|0) {
  case -16:  {
   _freeP4FuncCtx($0,$2); //@line 73823 "c/sqlite3.c"
   break;
  }
  case -15: case -17: case -7: case -14: case -13:  {
   _sqlite3DbFree($0,$2); //@line 73831 "c/sqlite3.c"
   break;
  }
  case -9:  {
   $3 = ((($0)) + 464|0); //@line 73835 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 73835 "c/sqlite3.c"
   $5 = ($4|0)==(0|0); //@line 73835 "c/sqlite3.c"
   if ($5) {
    _sqlite3KeyInfoUnref($2); //@line 73835 "c/sqlite3.c"
   }
   break;
  }
  case -8:  {
   _freeEphemeralFunction($0,$2); //@line 73845 "c/sqlite3.c"
   break;
  }
  case -11:  {
   $6 = ((($0)) + 464|0); //@line 73849 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 73849 "c/sqlite3.c"
   $8 = ($7|0)==(0|0); //@line 73849 "c/sqlite3.c"
   if ($8) {
    _sqlite3ValueFree($2); //@line 73850 "c/sqlite3.c"
    break L1;
   } else {
    _freeP4Mem($0,$2); //@line 73852 "c/sqlite3.c"
    break L1;
   }
   break;
  }
  case -12:  {
   $9 = ((($0)) + 464|0); //@line 73857 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 73857 "c/sqlite3.c"
   $11 = ($10|0)==(0|0); //@line 73857 "c/sqlite3.c"
   if ($11) {
    _sqlite3VtabUnlock($2); //@line 73857 "c/sqlite3.c"
   }
   break;
  }
  default: {
  }
  }
 } while(0);
 return; //@line 73861 "c/sqlite3.c"
}
function _freeP4FuncCtx($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 4|0); //@line 73816 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73816 "c/sqlite3.c"
 _freeEphemeralFunction($0,$3); //@line 73816 "c/sqlite3.c"
 _sqlite3DbFreeNN($0,$1); //@line 73817 "c/sqlite3.c"
 return; //@line 73818 "c/sqlite3.c"
}
function _sqlite3KeyInfoUnref($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 119736 "c/sqlite3.c"
 if ($1) {
  return; //@line 119741 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 119738 "c/sqlite3.c"
 $3 = (($2) + -1)|0; //@line 119738 "c/sqlite3.c"
 HEAP32[$0>>2] = $3; //@line 119738 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 119739 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 119741 "c/sqlite3.c"
 }
 $5 = ((($0)) + 12|0); //@line 119739 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 119739 "c/sqlite3.c"
 _sqlite3DbFreeNN($6,$0); //@line 119739 "c/sqlite3.c"
 return; //@line 119741 "c/sqlite3.c"
}
function _freeEphemeralFunction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 2|0); //@line 73801 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 73801 "c/sqlite3.c"
 $4 = $3 & 16; //@line 73801 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 73801 "c/sqlite3.c"
 if ($5) {
  return; //@line 73804 "c/sqlite3.c"
 }
 _sqlite3DbFreeNN($0,$1); //@line 73802 "c/sqlite3.c"
 return; //@line 73804 "c/sqlite3.c"
}
function _freeP4Mem($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 24|0); //@line 73812 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73812 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 73812 "c/sqlite3.c"
 if (!($4)) {
  $5 = ((($1)) + 20|0); //@line 73812 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 73812 "c/sqlite3.c"
  _sqlite3DbFree($0,$6); //@line 73812 "c/sqlite3.c"
 }
 _sqlite3DbFreeNN($0,$1); //@line 73813 "c/sqlite3.c"
 return; //@line 73814 "c/sqlite3.c"
}
function _sqlite3VtabUnlock($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 127515 "c/sqlite3.c"
 $2 = ((($0)) + 12|0); //@line 127521 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 127521 "c/sqlite3.c"
 $4 = (($3) + -1)|0; //@line 127521 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 127521 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 127522 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 127529 "c/sqlite3.c"
 }
 $6 = ((($0)) + 8|0); //@line 127523 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 127523 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 127524 "c/sqlite3.c"
 if (!($8)) {
  $9 = HEAP32[$7>>2]|0; //@line 127525 "c/sqlite3.c"
  $10 = ((($9)) + 16|0); //@line 127525 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 127525 "c/sqlite3.c"
  (FUNCTION_TABLE_ii[$11 & 255]($7)|0); //@line 127525 "c/sqlite3.c"
 }
 _sqlite3DbFree($1,$0); //@line 127527 "c/sqlite3.c"
 return; //@line 127529 "c/sqlite3.c"
}
function _sqlite3VdbeHalt($0) {
 $0 = $0|0;
 var $$0113 = 0, $$0113$ph = 0, $$0115118 = 0, $$1 = 0, $$1114120 = 0, $$1114121 = 0, $$lobit = 0, $$pr = 0, $$pr125 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond5 = 0, $or$cond9 = 0, $trunc = 0, $trunc127 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 75585 "c/sqlite3.c"
 $2 = ((($0)) + 20|0); //@line 75603 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 75603 "c/sqlite3.c"
 $4 = ($3|0)==(770837923); //@line 75603 "c/sqlite3.c"
 if (!($4)) {
  $$1 = 0;
  return ($$1|0); //@line 75777 "c/sqlite3.c"
 }
 $5 = ((($1)) + 73|0); //@line 75606 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 75606 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 75606 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($0)) + 40|0); //@line 75607 "c/sqlite3.c"
  HEAP32[$8>>2] = 7; //@line 75607 "c/sqlite3.c"
 }
 _closeAllCursors($0); //@line 75609 "c/sqlite3.c"
 $9 = ((($0)) + 36|0); //@line 75614 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 75614 "c/sqlite3.c"
 $11 = ($10|0)>(-1); //@line 75614 "c/sqlite3.c"
 if ($11) {
  $12 = ((($0)) + 145|0); //@line 75614 "c/sqlite3.c"
  $13 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 75614 "c/sqlite3.c"
  $14 = $13 & 256; //@line 75614 "c/sqlite3.c"
  $15 = ($14<<16>>16)==(0); //@line 75614 "c/sqlite3.c"
  if (!($15)) {
   _sqlite3VdbeEnter($0); //@line 75620 "c/sqlite3.c"
   $16 = ((($0)) + 40|0); //@line 75623 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 75623 "c/sqlite3.c"
   $trunc = $17&255; //@line 75624 "c/sqlite3.c"
   switch ($trunc<<24>>24) {
   case 13: case 7: case 9: case 10:  {
    $18 = $17 & 255; //@line 75623 "c/sqlite3.c"
    $19 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 75639 "c/sqlite3.c"
    $20 = $19 & 128; //@line 75639 "c/sqlite3.c"
    $21 = ($20<<16>>16)==(0); //@line 75639 "c/sqlite3.c"
    $22 = ($18|0)!=(9); //@line 75639 "c/sqlite3.c"
    $or$cond5 = $22 | $21; //@line 75639 "c/sqlite3.c"
    L13: do {
     if ($or$cond5) {
      $trunc127 = $17&255; //@line 75640 "c/sqlite3.c"
      switch ($trunc127<<24>>24) {
      case 7: case 13:  {
       $23 = $19 & 64; //@line 75640 "c/sqlite3.c"
       $24 = ($23<<16>>16)==(0); //@line 75640 "c/sqlite3.c"
       if (!($24)) {
        $$0113$ph = 2;
        break L13;
       }
       break;
      }
      default: {
      }
      }
      _sqlite3RollbackAll($1,516); //@line 75646 "c/sqlite3.c"
      _sqlite3CloseSavepoints($1); //@line 75647 "c/sqlite3.c"
      $25 = ((($1)) + 71|0); //@line 75648 "c/sqlite3.c"
      HEAP8[$25>>0] = 1; //@line 75648 "c/sqlite3.c"
      $26 = ((($0)) + 44|0); //@line 75649 "c/sqlite3.c"
      HEAP32[$26>>2] = 0; //@line 75649 "c/sqlite3.c"
      $$0113$ph = 0;
     } else {
      $$0113$ph = 0;
     }
    } while(0);
    $$pr = HEAP32[$16>>2]|0; //@line 75655 "c/sqlite3.c"
    $$0113 = $$0113$ph;$28 = $$pr;$50 = 1;
    break;
   }
   default: {
    $$0113 = 0;$28 = $17;$50 = 0;
   }
   }
   $27 = ($28|0)==(0); //@line 75655 "c/sqlite3.c"
   if ($27) {
    (_sqlite3VdbeCheckFk($0,0)|0); //@line 75656 "c/sqlite3.c"
   }
   $29 = ((($1)) + 324|0); //@line 75665 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 75665 "c/sqlite3.c"
   $31 = ($30|0)>(0); //@line 75665 "c/sqlite3.c"
   if ($31) {
    $32 = ((($1)) + 348|0); //@line 75665 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 75665 "c/sqlite3.c"
    $34 = ($33|0)==(0|0); //@line 75665 "c/sqlite3.c"
    if ($34) {
     label = 29;
    } else {
     label = 16;
    }
   } else {
    label = 16;
   }
   if ((label|0) == 16) {
    $35 = ((($1)) + 71|0); //@line 75666 "c/sqlite3.c"
    $36 = HEAP8[$35>>0]|0; //@line 75666 "c/sqlite3.c"
    $37 = ($36<<24>>24)==(0); //@line 75666 "c/sqlite3.c"
    if ($37) {
     label = 29;
    } else {
     $38 = ((($1)) + 168|0); //@line 75667 "c/sqlite3.c"
     $39 = HEAP32[$38>>2]|0; //@line 75667 "c/sqlite3.c"
     $40 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 75667 "c/sqlite3.c"
     $41 = ($40&65535) >>> 7; //@line 75667 "c/sqlite3.c"
     $$lobit = $41 & 1; //@line 75667 "c/sqlite3.c"
     $42 = $$lobit ^ 1; //@line 75667 "c/sqlite3.c"
     $43 = $42&65535; //@line 75667 "c/sqlite3.c"
     $44 = ($39|0)==($43|0); //@line 75667 "c/sqlite3.c"
     if ($44) {
      $45 = HEAP32[$16>>2]|0; //@line 75669 "c/sqlite3.c"
      $46 = ($45|0)==(0); //@line 75669 "c/sqlite3.c"
      if ($46) {
       label = 20;
      } else {
       $47 = ((($0)) + 142|0); //@line 75669 "c/sqlite3.c"
       $48 = HEAP8[$47>>0]|0; //@line 75669 "c/sqlite3.c"
       $49 = ($48<<24>>24)!=(3); //@line 75669 "c/sqlite3.c"
       $or$cond9 = $50 | $49; //@line 75669 "c/sqlite3.c"
       if ($or$cond9) {
        _sqlite3RollbackAll($1,0); //@line 75698 "c/sqlite3.c"
        $65 = ((($0)) + 44|0); //@line 75699 "c/sqlite3.c"
        HEAP32[$65>>2] = 0; //@line 75699 "c/sqlite3.c"
       } else {
        label = 20;
       }
      }
      L32: do {
       if ((label|0) == 20) {
        $51 = (_sqlite3VdbeCheckFk($0,1)|0); //@line 75670 "c/sqlite3.c"
        $52 = ($51|0)==(0); //@line 75671 "c/sqlite3.c"
        L34: do {
         if ($52) {
          $56 = (_vdbeCommit($1,$0)|0); //@line 75682 "c/sqlite3.c"
          switch ($56|0) {
          case 5:  {
           break;
          }
          case 0:  {
           $61 = ((($1)) + 448|0); //@line 75692 "c/sqlite3.c"
           $62 = ((($1)) + 28|0); //@line 75694 "c/sqlite3.c"
           ;HEAP32[$61>>2]=0|0;HEAP32[$61+4>>2]=0|0;HEAP32[$61+8>>2]=0|0;HEAP32[$61+12>>2]=0|0; //@line 75693 "c/sqlite3.c"
           $63 = HEAP32[$62>>2]|0; //@line 75694 "c/sqlite3.c"
           $64 = $63 & -524289; //@line 75694 "c/sqlite3.c"
           HEAP32[$62>>2] = $64; //@line 75694 "c/sqlite3.c"
           _sqlite3CommitInternalChanges($1); //@line 75695 "c/sqlite3.c"
           break L32;
           break;
          }
          default: {
           $$0115118 = $56;
           break L34;
          }
          }
          $57 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 75684 "c/sqlite3.c"
          $58 = $57 & 128; //@line 75684 "c/sqlite3.c"
          $59 = ($58<<16>>16)==(0); //@line 75684 "c/sqlite3.c"
          if ($59) {
           $$0115118 = 5;
          } else {
           _sqlite3VdbeLeave($0); //@line 75685 "c/sqlite3.c"
           $$1 = 5;
           return ($$1|0); //@line 75777 "c/sqlite3.c"
          }
         } else {
          $53 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 75672 "c/sqlite3.c"
          $54 = $53 & 128; //@line 75672 "c/sqlite3.c"
          $55 = ($54<<16>>16)==(0); //@line 75672 "c/sqlite3.c"
          if ($55) {
           $$0115118 = 787;
          } else {
           _sqlite3VdbeLeave($0); //@line 75673 "c/sqlite3.c"
           $$1 = 1;
           return ($$1|0); //@line 75777 "c/sqlite3.c"
          }
         }
        } while(0);
        HEAP32[$16>>2] = $$0115118; //@line 75688 "c/sqlite3.c"
        _sqlite3RollbackAll($1,0); //@line 75689 "c/sqlite3.c"
        $60 = ((($0)) + 44|0); //@line 75690 "c/sqlite3.c"
        HEAP32[$60>>2] = 0; //@line 75690 "c/sqlite3.c"
       }
      } while(0);
      $73 = ((($1)) + 444|0); //@line 75701 "c/sqlite3.c"
      HEAP32[$73>>2] = 0; //@line 75701 "c/sqlite3.c"
      $74 = ($$0113|0)==(0); //@line 75721 "c/sqlite3.c"
      if ($74) {
       $$1114121 = 0;
      } else {
       $$1114120 = $$0113;
       label = 35;
      }
     } else {
      label = 29;
     }
    }
   }
   L46: do {
    if ((label|0) == 29) {
     $66 = ($$0113|0)==(0); //@line 75702 "c/sqlite3.c"
     if ($66) {
      $67 = HEAP32[$16>>2]|0; //@line 75703 "c/sqlite3.c"
      $68 = ($67|0)==(0); //@line 75703 "c/sqlite3.c"
      if ($68) {
       $$1114120 = 1;
       label = 35;
      } else {
       $69 = ((($0)) + 142|0); //@line 75703 "c/sqlite3.c"
       $70 = HEAP8[$69>>0]|0; //@line 75703 "c/sqlite3.c"
       switch ($70<<24>>24) {
       case 3:  {
        $$1114120 = 1;
        label = 35;
        break L46;
        break;
       }
       case 2:  {
        $$1114120 = 2;
        label = 35;
        break L46;
        break;
       }
       default: {
        _sqlite3RollbackAll($1,516); //@line 75708 "c/sqlite3.c"
        _sqlite3CloseSavepoints($1); //@line 75709 "c/sqlite3.c"
        $71 = ((($1)) + 71|0); //@line 75710 "c/sqlite3.c"
        HEAP8[$71>>0] = 1; //@line 75710 "c/sqlite3.c"
        $72 = ((($0)) + 44|0); //@line 75711 "c/sqlite3.c"
        HEAP32[$72>>2] = 0; //@line 75711 "c/sqlite3.c"
        $$1114121 = 0;
        break L46;
       }
       }
      }
     } else {
      $$1114120 = $$0113;
      label = 35;
     }
    }
   } while(0);
   if ((label|0) == 35) {
    $75 = (_sqlite3VdbeCloseStatement($0,$$1114120)|0); //@line 75722 "c/sqlite3.c"
    $76 = ($75|0)==(0); //@line 75723 "c/sqlite3.c"
    if ($76) {
     $$1114121 = $$1114120;
    } else {
     $77 = HEAP32[$16>>2]|0; //@line 75724 "c/sqlite3.c"
     $78 = ($77|0)==(0); //@line 75724 "c/sqlite3.c"
     $79 = $77 & 255; //@line 75724 "c/sqlite3.c"
     $80 = ($79|0)==(19); //@line 75724 "c/sqlite3.c"
     $or$cond = $78 | $80; //@line 75724 "c/sqlite3.c"
     if ($or$cond) {
      HEAP32[$16>>2] = $75; //@line 75725 "c/sqlite3.c"
      $81 = ((($0)) + 108|0); //@line 75726 "c/sqlite3.c"
      $82 = HEAP32[$81>>2]|0; //@line 75726 "c/sqlite3.c"
      _sqlite3DbFree($1,$82); //@line 75726 "c/sqlite3.c"
      HEAP32[$81>>2] = 0; //@line 75727 "c/sqlite3.c"
     }
     _sqlite3RollbackAll($1,516); //@line 75729 "c/sqlite3.c"
     _sqlite3CloseSavepoints($1); //@line 75730 "c/sqlite3.c"
     $83 = ((($1)) + 71|0); //@line 75731 "c/sqlite3.c"
     HEAP8[$83>>0] = 1; //@line 75731 "c/sqlite3.c"
     $84 = ((($0)) + 44|0); //@line 75732 "c/sqlite3.c"
     HEAP32[$84>>2] = 0; //@line 75732 "c/sqlite3.c"
     $$1114121 = $$1114120;
    }
   }
   $85 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 75739 "c/sqlite3.c"
   $86 = $85 & 16; //@line 75739 "c/sqlite3.c"
   $87 = ($86<<16>>16)==(0); //@line 75739 "c/sqlite3.c"
   if (!($87)) {
    $88 = ($$1114121|0)==(2); //@line 75740 "c/sqlite3.c"
    if ($88) {
     _sqlite3VdbeSetChanges($1,0); //@line 75743 "c/sqlite3.c"
    } else {
     $89 = ((($0)) + 44|0); //@line 75741 "c/sqlite3.c"
     $90 = HEAP32[$89>>2]|0; //@line 75741 "c/sqlite3.c"
     _sqlite3VdbeSetChanges($1,$90); //@line 75741 "c/sqlite3.c"
    }
    $91 = ((($0)) + 44|0); //@line 75745 "c/sqlite3.c"
    HEAP32[$91>>2] = 0; //@line 75745 "c/sqlite3.c"
   }
   _sqlite3VdbeLeave($0); //@line 75749 "c/sqlite3.c"
  }
  $$pr125 = HEAP32[$9>>2]|0; //@line 75753 "c/sqlite3.c"
  $92 = ($$pr125|0)>(-1); //@line 75753 "c/sqlite3.c"
  if ($92) {
   $93 = ((($1)) + 160|0); //@line 75754 "c/sqlite3.c"
   $94 = HEAP32[$93>>2]|0; //@line 75754 "c/sqlite3.c"
   $95 = (($94) + -1)|0; //@line 75754 "c/sqlite3.c"
   HEAP32[$93>>2] = $95; //@line 75754 "c/sqlite3.c"
   $96 = ((($0)) + 145|0); //@line 75755 "c/sqlite3.c"
   $97 = HEAPU8[$96>>0]|(HEAPU8[$96+1>>0]<<8); //@line 75755 "c/sqlite3.c"
   $98 = $97 & 128; //@line 75755 "c/sqlite3.c"
   $99 = ($98<<16>>16)==(0); //@line 75755 "c/sqlite3.c"
   if ($99) {
    $100 = ((($1)) + 168|0); //@line 75755 "c/sqlite3.c"
    $101 = HEAP32[$100>>2]|0; //@line 75755 "c/sqlite3.c"
    $102 = (($101) + -1)|0; //@line 75755 "c/sqlite3.c"
    HEAP32[$100>>2] = $102; //@line 75755 "c/sqlite3.c"
   }
   $103 = HEAPU8[$96>>0]|(HEAPU8[$96+1>>0]<<8); //@line 75756 "c/sqlite3.c"
   $104 = $103 & 256; //@line 75756 "c/sqlite3.c"
   $105 = ($104<<16>>16)==(0); //@line 75756 "c/sqlite3.c"
   if (!($105)) {
    $106 = ((($1)) + 164|0); //@line 75756 "c/sqlite3.c"
    $107 = HEAP32[$106>>2]|0; //@line 75756 "c/sqlite3.c"
    $108 = (($107) + -1)|0; //@line 75756 "c/sqlite3.c"
    HEAP32[$106>>2] = $108; //@line 75756 "c/sqlite3.c"
   }
  }
 }
 HEAP32[$2>>2] = 832317811; //@line 75761 "c/sqlite3.c"
 $109 = HEAP8[$5>>0]|0; //@line 75763 "c/sqlite3.c"
 $110 = ($109<<24>>24)==(0); //@line 75763 "c/sqlite3.c"
 if (!($110)) {
  $111 = ((($0)) + 40|0); //@line 75764 "c/sqlite3.c"
  HEAP32[$111>>2] = 7; //@line 75764 "c/sqlite3.c"
 }
 $112 = ((($0)) + 40|0); //@line 75776 "c/sqlite3.c"
 $113 = HEAP32[$112>>2]|0; //@line 75776 "c/sqlite3.c"
 $114 = ($113|0)==(5); //@line 75776 "c/sqlite3.c"
 $115 = $114 ? 5 : 0; //@line 75776 "c/sqlite3.c"
 $$1 = $115;
 return ($$1|0); //@line 75777 "c/sqlite3.c"
}
function _sqlite3VdbeTransferError($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 75797 "c/sqlite3.c"
 $2 = ((($0)) + 40|0); //@line 75798 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 75798 "c/sqlite3.c"
 $4 = ((($0)) + 108|0); //@line 75799 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 75799 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 75799 "c/sqlite3.c"
 if ($6) {
  $18 = ((($1)) + 248|0); //@line 75806 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 75806 "c/sqlite3.c"
  $20 = ($19|0)==(0|0); //@line 75806 "c/sqlite3.c"
  if ($20) {
   $21 = ((($1)) + 56|0); //@line 75809 "c/sqlite3.c"
   HEAP32[$21>>2] = $3; //@line 75809 "c/sqlite3.c"
   return ($3|0); //@line 75810 "c/sqlite3.c"
  }
  _sqlite3ValueSetNull($19); //@line 75807 "c/sqlite3.c"
  $21 = ((($1)) + 56|0); //@line 75809 "c/sqlite3.c"
  HEAP32[$21>>2] = $3; //@line 75809 "c/sqlite3.c"
  return ($3|0); //@line 75810 "c/sqlite3.c"
 } else {
  $7 = ((($1)) + 74|0); //@line 75800 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 75800 "c/sqlite3.c"
  $9 = (($8) + 1)<<24>>24; //@line 75800 "c/sqlite3.c"
  HEAP8[$7>>0] = $9; //@line 75800 "c/sqlite3.c"
  _sqlite3BeginBenignMalloc(); //@line 75801 "c/sqlite3.c"
  $10 = ((($1)) + 248|0); //@line 75802 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 75802 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 75802 "c/sqlite3.c"
  if ($12) {
   $13 = (_sqlite3ValueNew($1)|0); //@line 75802 "c/sqlite3.c"
   HEAP32[$10>>2] = $13; //@line 75802 "c/sqlite3.c"
  }
  $14 = HEAP32[$10>>2]|0; //@line 75803 "c/sqlite3.c"
  $15 = HEAP32[$4>>2]|0; //@line 75803 "c/sqlite3.c"
  _sqlite3ValueSetStr($14,$15,1,(-1)); //@line 75803 "c/sqlite3.c"
  _sqlite3EndBenignMalloc(); //@line 75804 "c/sqlite3.c"
  $16 = HEAP8[$7>>0]|0; //@line 75805 "c/sqlite3.c"
  $17 = (($16) + -1)<<24>>24; //@line 75805 "c/sqlite3.c"
  HEAP8[$7>>0] = $17; //@line 75805 "c/sqlite3.c"
  $21 = ((($1)) + 56|0); //@line 75809 "c/sqlite3.c"
  HEAP32[$21>>2] = $3; //@line 75809 "c/sqlite3.c"
  return ($3|0); //@line 75810 "c/sqlite3.c"
 }
 return (0)|0;
}
function _closeAllCursors($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 192|0); //@line 75114 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 75114 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 75114 "c/sqlite3.c"
 if (!($3)) {
  $$0 = $2;
  while(1) {
   $4 = ((($$0)) + 4|0); //@line 75116 "c/sqlite3.c"
   $5 = HEAP32[$4>>2]|0; //@line 75116 "c/sqlite3.c"
   $6 = ($5|0)==(0|0); //@line 75116 "c/sqlite3.c"
   if ($6) {
    break;
   } else {
    $$0 = $5;
   }
  }
  (_sqlite3VdbeFrameRestore($$0)|0); //@line 75117 "c/sqlite3.c"
  HEAP32[$1>>2] = 0; //@line 75118 "c/sqlite3.c"
  $7 = ((($0)) + 200|0); //@line 75119 "c/sqlite3.c"
  HEAP32[$7>>2] = 0; //@line 75119 "c/sqlite3.c"
 }
 _closeCursorsInFrame($0); //@line 75122 "c/sqlite3.c"
 $8 = ((($0)) + 92|0); //@line 75123 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 75123 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 75123 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($0)) + 24|0); //@line 75124 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 75124 "c/sqlite3.c"
  _releaseMemArray($9,$12); //@line 75124 "c/sqlite3.c"
 }
 $13 = ((($0)) + 196|0); //@line 75126 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 75126 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 75126 "c/sqlite3.c"
 if (!($15)) {
  $17 = $14;
  while(1) {
   $16 = ((($17)) + 4|0); //@line 75128 "c/sqlite3.c"
   $18 = HEAP32[$16>>2]|0; //@line 75128 "c/sqlite3.c"
   HEAP32[$13>>2] = $18; //@line 75128 "c/sqlite3.c"
   _sqlite3VdbeFrameDelete($17); //@line 75129 "c/sqlite3.c"
   $19 = HEAP32[$13>>2]|0; //@line 75126 "c/sqlite3.c"
   $20 = ($19|0)==(0|0); //@line 75126 "c/sqlite3.c"
   if ($20) {
    break;
   } else {
    $17 = $19;
   }
  }
 }
 $21 = ((($0)) + 212|0); //@line 75133 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 75133 "c/sqlite3.c"
 $23 = ($22|0)==(0|0); //@line 75133 "c/sqlite3.c"
 if ($23) {
  return; //@line 75135 "c/sqlite3.c"
 }
 $24 = HEAP32[$0>>2]|0; //@line 75133 "c/sqlite3.c"
 _sqlite3VdbeDeleteAuxData($24,$21,-1,0); //@line 75133 "c/sqlite3.c"
 return; //@line 75135 "c/sqlite3.c"
}
function _sqlite3VdbeEnter($0) {
 $0 = $0|0;
 var $$020 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 152|0); //@line 74438 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 74438 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 74438 "c/sqlite3.c"
 if ($3) {
  return; //@line 74447 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 74439 "c/sqlite3.c"
 $5 = ((($4)) + 16|0); //@line 74440 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 74440 "c/sqlite3.c"
 $7 = ((($4)) + 20|0); //@line 74441 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 74441 "c/sqlite3.c"
 $9 = ($8|0)>(0); //@line 74442 "c/sqlite3.c"
 if (!($9)) {
  return; //@line 74447 "c/sqlite3.c"
 }
 $$020 = 0;
 while(1) {
  $10 = ($$020|0)==(1); //@line 74443 "c/sqlite3.c"
  if (!($10)) {
   $11 = HEAP32[$1>>2]|0; //@line 74443 "c/sqlite3.c"
   $12 = 1 << $$020; //@line 74443 "c/sqlite3.c"
   $13 = $11 & $12; //@line 74443 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 74443 "c/sqlite3.c"
   if (!($14)) {
    $15 = (((($6) + ($$020<<4)|0)) + 4|0); //@line 74443 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 74443 "c/sqlite3.c"
    $17 = ($16|0)==(0|0); //@line 74443 "c/sqlite3.c"
    if (!($17)) {
     _sqlite3BtreeEnter($16); //@line 74444 "c/sqlite3.c"
    }
   }
  }
  $18 = (($$020) + 1)|0; //@line 74442 "c/sqlite3.c"
  $exitcond = ($18|0)==($8|0); //@line 74442 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$020 = $18;
  }
 }
 return; //@line 74447 "c/sqlite3.c"
}
function _sqlite3RollbackAll($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$033$lcssa = 0, $$03334 = 0, $$035 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BeginBenignMalloc(); //@line 144619 "c/sqlite3.c"
 _sqlite3BtreeEnterAll($0); //@line 144627 "c/sqlite3.c"
 $2 = ((($0)) + 24|0); //@line 144628 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 144628 "c/sqlite3.c"
 $4 = $3 & 1; //@line 144628 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 144628 "c/sqlite3.c"
 if ($5) {
  $19 = 1;
 } else {
  $6 = ((($0)) + 157|0); //@line 144628 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 144628 "c/sqlite3.c"
  $8 = ($7<<24>>24)!=(0); //@line 144628 "c/sqlite3.c"
  $phitmp = $8&1;
  $19 = $phitmp;
 }
 $9 = ((($0)) + 20|0); //@line 144630 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 144630 "c/sqlite3.c"
 $11 = ($10|0)>(0); //@line 144630 "c/sqlite3.c"
 if ($11) {
  $12 = ((($0)) + 16|0);
  $$03334 = 0;$$035 = 0;
  while(1) {
   $13 = HEAP32[$12>>2]|0; //@line 144631 "c/sqlite3.c"
   $14 = (((($13) + ($$035<<4)|0)) + 4|0); //@line 144631 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 144631 "c/sqlite3.c"
   $16 = ($15|0)==(0|0); //@line 144632 "c/sqlite3.c"
   if ($16) {
    $$2 = $$03334;
   } else {
    $17 = (_sqlite3BtreeIsInTrans($15)|0); //@line 144633 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 144633 "c/sqlite3.c"
    $spec$select = $18 ? $$03334 : 1; //@line 144633 "c/sqlite3.c"
    _sqlite3BtreeRollback($15,$1,$19); //@line 144636 "c/sqlite3.c"
    $$2 = $spec$select;
   }
   $20 = (($$035) + 1)|0; //@line 144630 "c/sqlite3.c"
   $21 = HEAP32[$9>>2]|0; //@line 144630 "c/sqlite3.c"
   $22 = ($20|0)<($21|0); //@line 144630 "c/sqlite3.c"
   if ($22) {
    $$03334 = $$2;$$035 = $20;
   } else {
    $$033$lcssa = $$2;
    break;
   }
  }
 } else {
  $$033$lcssa = 0;
 }
 _sqlite3VtabRollback($0); //@line 144639 "c/sqlite3.c"
 _sqlite3EndBenignMalloc(); //@line 144640 "c/sqlite3.c"
 $23 = HEAP32[$2>>2]|0; //@line 144642 "c/sqlite3.c"
 $24 = $23 & 1; //@line 144642 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 144642 "c/sqlite3.c"
 if (!($25)) {
  $26 = ((($0)) + 157|0); //@line 144642 "c/sqlite3.c"
  $27 = HEAP8[$26>>0]|0; //@line 144642 "c/sqlite3.c"
  $28 = ($27<<24>>24)==(0); //@line 144642 "c/sqlite3.c"
  if ($28) {
   _sqlite3ExpirePreparedStatements($0); //@line 144643 "c/sqlite3.c"
   _sqlite3ResetAllSchemasOfConnection($0); //@line 144644 "c/sqlite3.c"
  }
 }
 _sqlite3BtreeLeaveAll($0); //@line 144646 "c/sqlite3.c"
 $29 = ((($0)) + 448|0); //@line 144649 "c/sqlite3.c"
 $30 = ((($0)) + 28|0); //@line 144651 "c/sqlite3.c"
 ;HEAP32[$29>>2]=0|0;HEAP32[$29+4>>2]=0|0;HEAP32[$29+8>>2]=0|0;HEAP32[$29+12>>2]=0|0; //@line 144650 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 144651 "c/sqlite3.c"
 $32 = $31 & -524289; //@line 144651 "c/sqlite3.c"
 HEAP32[$30>>2] = $32; //@line 144651 "c/sqlite3.c"
 $33 = ((($0)) + 216|0); //@line 144654 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 144654 "c/sqlite3.c"
 $35 = ($34|0)==(0|0); //@line 144654 "c/sqlite3.c"
 if ($35) {
  return; //@line 144657 "c/sqlite3.c"
 }
 $36 = ($$033$lcssa|0)==(0); //@line 144654 "c/sqlite3.c"
 if ($36) {
  $37 = ((($0)) + 71|0); //@line 144654 "c/sqlite3.c"
  $38 = HEAP8[$37>>0]|0; //@line 144654 "c/sqlite3.c"
  $39 = ($38<<24>>24)==(0); //@line 144654 "c/sqlite3.c"
  if (!($39)) {
   return; //@line 144657 "c/sqlite3.c"
  }
 }
 $40 = ((($0)) + 212|0); //@line 144655 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 144655 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$34 & 127]($41); //@line 144655 "c/sqlite3.c"
 return; //@line 144657 "c/sqlite3.c"
}
function _sqlite3CloseSavepoints($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 432|0); //@line 144344 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144344 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 144344 "c/sqlite3.c"
 if (!($3)) {
  $5 = $2;
  while(1) {
   $4 = ((($5)) + 24|0); //@line 144346 "c/sqlite3.c"
   $6 = HEAP32[$4>>2]|0; //@line 144346 "c/sqlite3.c"
   HEAP32[$1>>2] = $6; //@line 144346 "c/sqlite3.c"
   _sqlite3DbFree($0,$5); //@line 144347 "c/sqlite3.c"
   $7 = HEAP32[$1>>2]|0; //@line 144344 "c/sqlite3.c"
   $8 = ($7|0)==(0|0); //@line 144344 "c/sqlite3.c"
   if ($8) {
    break;
   } else {
    $5 = $7;
   }
  }
 }
 $9 = ((($0)) + 440|0); //@line 144349 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 144349 "c/sqlite3.c"
 $10 = ((($0)) + 444|0); //@line 144350 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 144350 "c/sqlite3.c"
 $11 = ((($0)) + 79|0); //@line 144351 "c/sqlite3.c"
 HEAP8[$11>>0] = 0; //@line 144351 "c/sqlite3.c"
 return; //@line 144352 "c/sqlite3.c"
}
function _sqlite3VdbeCheckFk($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 75556 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 75557 "c/sqlite3.c"
 $3 = ($1|0)==(0); //@line 75558 "c/sqlite3.c"
 if ($3) {
  $25 = ((($0)) + 64|0); //@line 75559 "c/sqlite3.c"
  $26 = $25; //@line 75559 "c/sqlite3.c"
  $27 = $26; //@line 75559 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 75559 "c/sqlite3.c"
  $29 = (($26) + 4)|0; //@line 75559 "c/sqlite3.c"
  $30 = $29; //@line 75559 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 75559 "c/sqlite3.c"
  $32 = ($31|0)>(0); //@line 75559 "c/sqlite3.c"
  $33 = ($28>>>0)>(0); //@line 75559 "c/sqlite3.c"
  $34 = ($31|0)==(0); //@line 75559 "c/sqlite3.c"
  $35 = $34 & $33; //@line 75559 "c/sqlite3.c"
  $36 = $32 | $35; //@line 75559 "c/sqlite3.c"
  if (!($36)) {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 75567 "c/sqlite3.c"
  }
 } else {
  $4 = ((($2)) + 448|0); //@line 75558 "c/sqlite3.c"
  $5 = $4; //@line 75558 "c/sqlite3.c"
  $6 = $5; //@line 75558 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 75558 "c/sqlite3.c"
  $8 = (($5) + 4)|0; //@line 75558 "c/sqlite3.c"
  $9 = $8; //@line 75558 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 75558 "c/sqlite3.c"
  $11 = ((($2)) + 456|0); //@line 75558 "c/sqlite3.c"
  $12 = $11; //@line 75558 "c/sqlite3.c"
  $13 = $12; //@line 75558 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 75558 "c/sqlite3.c"
  $15 = (($12) + 4)|0; //@line 75558 "c/sqlite3.c"
  $16 = $15; //@line 75558 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 75558 "c/sqlite3.c"
  $18 = (_i64Add(($14|0),($17|0),($7|0),($10|0))|0); //@line 75558 "c/sqlite3.c"
  $19 = tempRet0; //@line 75558 "c/sqlite3.c"
  $20 = ($19|0)>(0); //@line 75558 "c/sqlite3.c"
  $21 = ($18>>>0)>(0); //@line 75558 "c/sqlite3.c"
  $22 = ($19|0)==(0); //@line 75558 "c/sqlite3.c"
  $23 = $22 & $21; //@line 75558 "c/sqlite3.c"
  $24 = $20 | $23; //@line 75558 "c/sqlite3.c"
  if (!($24)) {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 75567 "c/sqlite3.c"
  }
 }
 $37 = ((($0)) + 40|0); //@line 75561 "c/sqlite3.c"
 HEAP32[$37>>2] = 787; //@line 75561 "c/sqlite3.c"
 $38 = ((($0)) + 142|0); //@line 75562 "c/sqlite3.c"
 HEAP8[$38>>0] = 2; //@line 75562 "c/sqlite3.c"
 _sqlite3VdbeError($0,18442,$vararg_buffer); //@line 75563 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 75567 "c/sqlite3.c"
}
function _sqlite3VdbeLeave($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 152|0); //@line 74469 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 74469 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 74469 "c/sqlite3.c"
 if ($3) {
  return; //@line 74471 "c/sqlite3.c"
 }
 _vdbeLeave($0); //@line 74470 "c/sqlite3.c"
 return; //@line 74471 "c/sqlite3.c"
}
function _vdbeCommit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0167236 = 0, $$0173235 = 0, $$0182234 = 0, $$0184 = 0, $$1168224 = 0, $$1174 = 0, $$1177 = 0, $$1183 = 0, $$16 = 0, $$2169222 = 0, $$2175 = 0, $$3170229 = 0, $$4$ph = 0, $$4171227 = 0, $$4180 = 0, $$5 = 0, $$5172225 = 0, $$6 = 0, $$9200 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0;
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0;
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0;
 var $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond195 = 0, $cond195233 = 0, $or$cond = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0;
 var $vararg_ptr10 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 36|0;
 $3 = sp + 32|0;
 $4 = (_sqlite3VtabSync($0,$1)|0); //@line 75217 "c/sqlite3.c"
 $cond195233 = ($4|0)==(0); //@line 75225 "c/sqlite3.c"
 if (!($cond195233)) {
  $$5 = $4;
  STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
 }
 $5 = ((($0)) + 20|0);
 $6 = ((($0)) + 16|0);
 $$0167236 = 0;$$0173235 = 0;$$0182234 = 0;
 while(1) {
  $7 = HEAP32[$5>>2]|0; //@line 75225 "c/sqlite3.c"
  $8 = ($$0167236|0)<($7|0); //@line 75225 "c/sqlite3.c"
  if (!($8)) {
   break;
  }
  $9 = HEAP32[$6>>2]|0; //@line 75226 "c/sqlite3.c"
  $10 = (((($9) + ($$0167236<<4)|0)) + 4|0); //@line 75226 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 75226 "c/sqlite3.c"
  $12 = (_sqlite3BtreeIsInTrans($11)|0); //@line 75227 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 75227 "c/sqlite3.c"
  if ($13) {
   $$1177 = 0;$$1183 = $$0182234;$$2175 = $$0173235;
  } else {
   _sqlite3BtreeEnter($11); //@line 75241 "c/sqlite3.c"
   $14 = (_sqlite3BtreePager($11)|0); //@line 75242 "c/sqlite3.c"
   $15 = HEAP32[$6>>2]|0; //@line 75243 "c/sqlite3.c"
   $16 = (((($15) + ($$0167236<<4)|0)) + 8|0); //@line 75243 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 75243 "c/sqlite3.c"
   $18 = ($17<<24>>24)==(1); //@line 75243 "c/sqlite3.c"
   if ($18) {
    $$1174 = $$0173235;
   } else {
    $19 = (_sqlite3PagerGetJournalMode($14)|0); //@line 75244 "c/sqlite3.c"
    $20 = 11 >>> $19; //@line 75244 "c/sqlite3.c"
    $21 = $20 & 1; //@line 75244 "c/sqlite3.c"
    $22 = ($21|0)==(0); //@line 75244 "c/sqlite3.c"
    if ($22) {
     $$1174 = $$0173235;
    } else {
     $23 = (_sqlite3PagerIsMemdb($14)|0); //@line 75245 "c/sqlite3.c"
     $24 = ($23|0)==(0); //@line 75245 "c/sqlite3.c"
     $25 = $24&1; //@line 75243 "c/sqlite3.c"
     $spec$select = (($$0173235) + ($25))|0; //@line 75243 "c/sqlite3.c"
     $$1174 = $spec$select;
    }
   }
   $26 = (_sqlite3PagerExclusiveLock($14)|0); //@line 75250 "c/sqlite3.c"
   _sqlite3BtreeLeave($11); //@line 75251 "c/sqlite3.c"
   $$1177 = $26;$$1183 = 1;$$2175 = $$1174;
  }
  $27 = (($$0167236) + 1)|0; //@line 75225 "c/sqlite3.c"
  $cond195 = ($$1177|0)==(0); //@line 75225 "c/sqlite3.c"
  if ($cond195) {
   $$0167236 = $27;$$0173235 = $$2175;$$0182234 = $$1183;
  } else {
   $$5 = $$1177;
   label = 60;
   break;
  }
 }
 if ((label|0) == 60) {
  STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
 }
 $28 = ((($0)) + 20|0); //@line 75225 "c/sqlite3.c"
 $29 = ($$0182234|0)==(0); //@line 75259 "c/sqlite3.c"
 if (!($29)) {
  $30 = ((($0)) + 208|0); //@line 75259 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 75259 "c/sqlite3.c"
  $32 = ($31|0)==(0|0); //@line 75259 "c/sqlite3.c"
  if (!($32)) {
   $33 = ((($0)) + 204|0); //@line 75260 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 75260 "c/sqlite3.c"
   $35 = (FUNCTION_TABLE_ii[$31 & 255]($34)|0); //@line 75260 "c/sqlite3.c"
   $36 = ($35|0)==(0); //@line 75261 "c/sqlite3.c"
   if (!($36)) {
    $$5 = 531;
    STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
   }
  }
 }
 $37 = ((($0)) + 16|0); //@line 75275 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 75275 "c/sqlite3.c"
 $39 = ((($38)) + 4|0); //@line 75275 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 75275 "c/sqlite3.c"
 $41 = (_sqlite3BtreeGetFilename($40)|0); //@line 75275 "c/sqlite3.c"
 $42 = (_sqlite3Strlen30($41)|0); //@line 75275 "c/sqlite3.c"
 $43 = ($42|0)==(0); //@line 75275 "c/sqlite3.c"
 $44 = ($$0173235|0)<(2); //@line 75276 "c/sqlite3.c"
 $or$cond = $44 | $43; //@line 75276 "c/sqlite3.c"
 if ($or$cond) {
  $$1168224 = 0;
  while(1) {
   $45 = HEAP32[$28>>2]|0; //@line 75278 "c/sqlite3.c"
   $46 = ($$1168224|0)<($45|0); //@line 75278 "c/sqlite3.c"
   if (!($46)) {
    break;
   }
   $47 = HEAP32[$37>>2]|0; //@line 75279 "c/sqlite3.c"
   $48 = (((($47) + ($$1168224<<4)|0)) + 4|0); //@line 75279 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 75279 "c/sqlite3.c"
   $50 = ($49|0)==(0|0); //@line 75280 "c/sqlite3.c"
   if ($50) {
    $$4180 = 0;
   } else {
    $51 = (_sqlite3BtreeCommitPhaseOne($49,0)|0); //@line 75281 "c/sqlite3.c"
    $$4180 = $51;
   }
   $52 = (($$1168224) + 1)|0; //@line 75278 "c/sqlite3.c"
   $53 = ($$4180|0)==(0); //@line 75278 "c/sqlite3.c"
   if ($53) {
    $$1168224 = $52;
   } else {
    $$5 = $$4180;
    label = 60;
    break;
   }
  }
  if ((label|0) == 60) {
   STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
  }
  $$2169222 = 0;
  while(1) {
   $54 = HEAP32[$28>>2]|0; //@line 75290 "c/sqlite3.c"
   $55 = ($$2169222|0)<($54|0); //@line 75290 "c/sqlite3.c"
   if (!($55)) {
    break;
   }
   $56 = HEAP32[$37>>2]|0; //@line 75291 "c/sqlite3.c"
   $57 = (((($56) + ($$2169222<<4)|0)) + 4|0); //@line 75291 "c/sqlite3.c"
   $58 = HEAP32[$57>>2]|0; //@line 75291 "c/sqlite3.c"
   $59 = ($58|0)==(0|0); //@line 75292 "c/sqlite3.c"
   if ($59) {
    $$6 = 0;
   } else {
    $60 = (_sqlite3BtreeCommitPhaseTwo($58,0)|0); //@line 75293 "c/sqlite3.c"
    $$6 = $60;
   }
   $61 = (($$2169222) + 1)|0; //@line 75290 "c/sqlite3.c"
   $62 = ($$6|0)==(0); //@line 75290 "c/sqlite3.c"
   if ($62) {
    $$2169222 = $61;
   } else {
    $$5 = $$6;
    label = 60;
    break;
   }
  }
  if ((label|0) == 60) {
   STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
  }
  _sqlite3VtabCommit($0); //@line 75297 "c/sqlite3.c"
  $$5 = 0;
  STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
 }
 $63 = HEAP32[$0>>2]|0; //@line 75307 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 75310 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $41; //@line 75318 "c/sqlite3.c"
 $64 = (_sqlite3MPrintf($0,18294,$vararg_buffer)|0); //@line 75318 "c/sqlite3.c"
 $65 = ($64|0)==(0|0); //@line 75319 "c/sqlite3.c"
 L44: do {
  if ($65) {
   $$4$ph = 7;
  } else {
   $66 = (($64) + ($42)|0);
   $$0184 = 0;
   while(1) {
    $67 = ($$0184|0)==(0); //@line 75322 "c/sqlite3.c"
    if (!($67)) {
     $68 = ($$0184>>>0)>(100); //@line 75323 "c/sqlite3.c"
     if ($68) {
      label = 31;
      break;
     }
     $69 = ($$0184|0)==(1); //@line 75327 "c/sqlite3.c"
     if ($69) {
      HEAP32[$vararg_buffer1>>2] = $64; //@line 75328 "c/sqlite3.c"
      _sqlite3_log(13,18310,$vararg_buffer1); //@line 75328 "c/sqlite3.c"
     }
    }
    $70 = (($$0184) + 1)|0; //@line 75331 "c/sqlite3.c"
    _sqlite3_randomness(4,$vararg_buffer); //@line 75332 "c/sqlite3.c"
    $71 = HEAP32[$vararg_buffer>>2]|0; //@line 75334 "c/sqlite3.c"
    $72 = $71 >>> 8; //@line 75334 "c/sqlite3.c"
    $73 = $71 & 255; //@line 75334 "c/sqlite3.c"
    HEAP32[$vararg_buffer7>>2] = $72; //@line 75333 "c/sqlite3.c"
    $vararg_ptr10 = ((($vararg_buffer7)) + 4|0); //@line 75333 "c/sqlite3.c"
    HEAP32[$vararg_ptr10>>2] = $73; //@line 75333 "c/sqlite3.c"
    (_sqlite3_snprintf(13,$66,18339,$vararg_buffer7)|0); //@line 75333 "c/sqlite3.c"
    $74 = (_sqlite3OsAccess($63,$64,0,$3)|0); //@line 75339 "c/sqlite3.c"
    $75 = ($74|0)==(0); //@line 75340 "c/sqlite3.c"
    $76 = HEAP32[$3>>2]|0; //@line 75340 "c/sqlite3.c"
    $77 = ($76|0)!=(0); //@line 75340 "c/sqlite3.c"
    $78 = $75 & $77; //@line 75340 "c/sqlite3.c"
    if ($78) {
     $$0184 = $70;
    } else {
     label = 33;
     break;
    }
   }
   if ((label|0) == 31) {
    HEAP32[$vararg_buffer4>>2] = $64; //@line 75324 "c/sqlite3.c"
    _sqlite3_log(13,18325,$vararg_buffer4); //@line 75324 "c/sqlite3.c"
    (_sqlite3OsDelete($63,$64,0)|0); //@line 75325 "c/sqlite3.c"
    label = 34;
   }
   else if ((label|0) == 33) {
    $79 = ($74|0)==(0); //@line 75341 "c/sqlite3.c"
    if ($79) {
     label = 34;
    } else {
     $$9200 = $74;
    }
   }
   if ((label|0) == 34) {
    $80 = (_sqlite3OsOpenMalloc($63,$64,$2,16406,0)|0); //@line 75343 "c/sqlite3.c"
    $81 = ($80|0)==(0); //@line 75348 "c/sqlite3.c"
    if ($81) {
     $82 = HEAP32[$28>>2]|0; //@line 75359 "c/sqlite3.c"
     $83 = ($82|0)>(0); //@line 75359 "c/sqlite3.c"
     L59: do {
      if ($83) {
       $84 = HEAP32[$2>>2]|0;
       $$3170229 = 0;$94 = 0;$95 = 0;
       while(1) {
        $85 = HEAP32[$37>>2]|0; //@line 75360 "c/sqlite3.c"
        $86 = (((($85) + ($$3170229<<4)|0)) + 4|0); //@line 75360 "c/sqlite3.c"
        $87 = HEAP32[$86>>2]|0; //@line 75360 "c/sqlite3.c"
        $88 = (_sqlite3BtreeIsInTrans($87)|0); //@line 75361 "c/sqlite3.c"
        $89 = ($88|0)==(0); //@line 75361 "c/sqlite3.c"
        if ($89) {
         $133 = $94;$134 = $95;
        } else {
         $90 = (_sqlite3BtreeGetJournalname($87)|0); //@line 75362 "c/sqlite3.c"
         $91 = ($90|0)==(0|0); //@line 75363 "c/sqlite3.c"
         if ($91) {
          $133 = $94;$134 = $95;
         } else {
          $92 = (_sqlite3Strlen30($90)|0); //@line 75367 "c/sqlite3.c"
          $93 = (($92) + 1)|0; //@line 75367 "c/sqlite3.c"
          $96 = (_sqlite3OsWrite($84,$90,$93,$94,$95)|0); //@line 75367 "c/sqlite3.c"
          $97 = (_sqlite3Strlen30($90)|0); //@line 75368 "c/sqlite3.c"
          $98 = (($97) + 1)|0; //@line 75368 "c/sqlite3.c"
          $99 = ($98|0)<(0); //@line 75368 "c/sqlite3.c"
          $100 = $99 << 31 >> 31; //@line 75368 "c/sqlite3.c"
          $101 = (_i64Add(($94|0),($95|0),($98|0),($100|0))|0); //@line 75368 "c/sqlite3.c"
          $102 = tempRet0; //@line 75368 "c/sqlite3.c"
          $103 = ($96|0)==(0); //@line 75369 "c/sqlite3.c"
          if ($103) {
           $133 = $101;$134 = $102;
          } else {
           break;
          }
         }
        }
        $104 = (($$3170229) + 1)|0; //@line 75359 "c/sqlite3.c"
        $105 = HEAP32[$28>>2]|0; //@line 75359 "c/sqlite3.c"
        $106 = ($104|0)<($105|0); //@line 75359 "c/sqlite3.c"
        if ($106) {
         $$3170229 = $104;$94 = $133;$95 = $134;
        } else {
         break L59;
        }
       }
       _sqlite3OsCloseFree($84); //@line 75370 "c/sqlite3.c"
       (_sqlite3OsDelete($63,$64,0)|0); //@line 75371 "c/sqlite3.c"
       _sqlite3DbFree($0,$64); //@line 75372 "c/sqlite3.c"
       $$4$ph = $96;
       break L44;
      }
     } while(0);
     $107 = HEAP32[$2>>2]|0; //@line 75381 "c/sqlite3.c"
     $108 = (_sqlite3OsDeviceCharacteristics($107)|0); //@line 75381 "c/sqlite3.c"
     $109 = $108 & 1024; //@line 75381 "c/sqlite3.c"
     $110 = ($109|0)==(0); //@line 75381 "c/sqlite3.c"
     if ($110) {
      $111 = (_sqlite3OsSync($107,2)|0); //@line 75382 "c/sqlite3.c"
      $112 = ($111|0)==(0); //@line 75382 "c/sqlite3.c"
      if (!($112)) {
       _sqlite3OsCloseFree($107); //@line 75384 "c/sqlite3.c"
       (_sqlite3OsDelete($63,$64,0)|0); //@line 75385 "c/sqlite3.c"
       _sqlite3DbFree($0,$64); //@line 75386 "c/sqlite3.c"
       $$4$ph = $111;
       break;
      }
     }
     $$4171227 = 0;
     while(1) {
      $113 = HEAP32[$28>>2]|0; //@line 75400 "c/sqlite3.c"
      $114 = ($$4171227|0)<($113|0); //@line 75400 "c/sqlite3.c"
      if (!($114)) {
       break;
      }
      $115 = HEAP32[$37>>2]|0; //@line 75401 "c/sqlite3.c"
      $116 = (((($115) + ($$4171227<<4)|0)) + 4|0); //@line 75401 "c/sqlite3.c"
      $117 = HEAP32[$116>>2]|0; //@line 75401 "c/sqlite3.c"
      $118 = ($117|0)==(0|0); //@line 75402 "c/sqlite3.c"
      if ($118) {
       $$16 = 0;
      } else {
       $119 = (_sqlite3BtreeCommitPhaseOne($117,$64)|0); //@line 75403 "c/sqlite3.c"
       $$16 = $119;
      }
      $120 = (($$4171227) + 1)|0; //@line 75400 "c/sqlite3.c"
      $121 = ($$16|0)==(0); //@line 75400 "c/sqlite3.c"
      if ($121) {
       $$4171227 = $120;
      } else {
       label = 51;
       break;
      }
     }
     if ((label|0) == 51) {
      _sqlite3OsCloseFree($107); //@line 75406 "c/sqlite3.c"
      _sqlite3DbFree($0,$64); //@line 75409 "c/sqlite3.c"
      $$4$ph = $$16;
      break;
     }
     _sqlite3OsCloseFree($107); //@line 75406 "c/sqlite3.c"
     $122 = (_sqlite3OsDelete($63,$64,1)|0); //@line 75417 "c/sqlite3.c"
     _sqlite3DbFree($0,$64); //@line 75418 "c/sqlite3.c"
     $123 = ($122|0)==(0); //@line 75420 "c/sqlite3.c"
     if (!($123)) {
      $$4$ph = $122;
      break;
     }
     _sqlite3BeginBenignMalloc(); //@line 75432 "c/sqlite3.c"
     $124 = HEAP32[$28>>2]|0; //@line 75433 "c/sqlite3.c"
     $125 = ($124|0)>(0); //@line 75433 "c/sqlite3.c"
     if ($125) {
      $$5172225 = 0;
      while(1) {
       $126 = HEAP32[$37>>2]|0; //@line 75434 "c/sqlite3.c"
       $127 = (((($126) + ($$5172225<<4)|0)) + 4|0); //@line 75434 "c/sqlite3.c"
       $128 = HEAP32[$127>>2]|0; //@line 75434 "c/sqlite3.c"
       $129 = ($128|0)==(0|0); //@line 75435 "c/sqlite3.c"
       if (!($129)) {
        (_sqlite3BtreeCommitPhaseTwo($128,1)|0); //@line 75436 "c/sqlite3.c"
       }
       $130 = (($$5172225) + 1)|0; //@line 75433 "c/sqlite3.c"
       $131 = HEAP32[$28>>2]|0; //@line 75433 "c/sqlite3.c"
       $132 = ($130|0)<($131|0); //@line 75433 "c/sqlite3.c"
       if ($132) {
        $$5172225 = $130;
       } else {
        break;
       }
      }
     }
     _sqlite3EndBenignMalloc(); //@line 75439 "c/sqlite3.c"
     _sqlite3VtabCommit($0); //@line 75442 "c/sqlite3.c"
     $$5 = $122;
     STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
    } else {
     $$9200 = $80;
    }
   }
   _sqlite3DbFree($0,$64); //@line 75349 "c/sqlite3.c"
   $$4$ph = $$9200;
  }
 } while(0);
 $$5 = $$4$ph;
 STACKTOP = sp;return ($$5|0); //@line 75447 "c/sqlite3.c"
}
function _sqlite3CommitInternalChanges($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 102181 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 102181 "c/sqlite3.c"
 $3 = $2 & -2; //@line 102181 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 102181 "c/sqlite3.c"
 return; //@line 102182 "c/sqlite3.c"
}
function _sqlite3VdbeCloseStatement($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 75538 "c/sqlite3.c"
 $3 = ((($2)) + 444|0); //@line 75538 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 75538 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 75538 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 75542 "c/sqlite3.c"
 }
 $6 = ((($0)) + 48|0); //@line 75538 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 75538 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 75538 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 75542 "c/sqlite3.c"
 }
 $9 = (_vdbeCloseStatement($0,$1)|0); //@line 75539 "c/sqlite3.c"
 $$0 = $9;
 return ($$0|0); //@line 75542 "c/sqlite3.c"
}
function _sqlite3VdbeSetChanges($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 92|0); //@line 77493 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 77493 "c/sqlite3.c"
 $3 = ((($0)) + 96|0); //@line 77494 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 77494 "c/sqlite3.c"
 $5 = (($4) + ($1))|0; //@line 77494 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 77494 "c/sqlite3.c"
 return; //@line 77495 "c/sqlite3.c"
}
function _vdbeCloseStatement($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$04348 = 0, $$049 = 0, $$1 = 0, $$142 = 0, $$3 = 0, $$346 = 0, $$347 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 75492 "c/sqlite3.c"
 $3 = ((($0)) + 48|0); //@line 75495 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 75495 "c/sqlite3.c"
 $5 = (($4) + -1)|0; //@line 75495 "c/sqlite3.c"
 $6 = ((($2)) + 20|0); //@line 75501 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 75501 "c/sqlite3.c"
 $8 = ($7|0)>(0); //@line 75501 "c/sqlite3.c"
 if ($8) {
  $12 = ((($2)) + 16|0);
  $13 = ($1|0)==(2);
  $$04348 = 0;$$049 = 0;
  while(1) {
   $14 = HEAP32[$12>>2]|0; //@line 75503 "c/sqlite3.c"
   $15 = (((($14) + ($$04348<<4)|0)) + 4|0); //@line 75503 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 75503 "c/sqlite3.c"
   $17 = ($16|0)==(0|0); //@line 75504 "c/sqlite3.c"
   if ($17) {
    $$1 = $$049;
   } else {
    if ($13) {
     $18 = (_sqlite3BtreeSavepoint($16,2,$5)|0); //@line 75506 "c/sqlite3.c"
     $19 = ($18|0)==(0); //@line 75508 "c/sqlite3.c"
     if ($19) {
      label = 7;
     } else {
      $$142 = $18;
     }
    } else {
     label = 7;
    }
    if ((label|0) == 7) {
     label = 0;
     $20 = (_sqlite3BtreeSavepoint($16,1,$5)|0); //@line 75509 "c/sqlite3.c"
     $$142 = $20;
    }
    $21 = ($$049|0)==(0); //@line 75511 "c/sqlite3.c"
    $spec$select = $21 ? $$142 : $$049; //@line 75511 "c/sqlite3.c"
    $$1 = $spec$select;
   }
   $22 = (($$04348) + 1)|0; //@line 75501 "c/sqlite3.c"
   $23 = HEAP32[$6>>2]|0; //@line 75501 "c/sqlite3.c"
   $24 = ($22|0)<($23|0); //@line 75501 "c/sqlite3.c"
   if ($24) {
    $$04348 = $22;$$049 = $$1;
   } else {
    break;
   }
  }
  $25 = ((($2)) + 444|0); //@line 75516 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 75516 "c/sqlite3.c"
  $27 = (($26) + -1)|0; //@line 75516 "c/sqlite3.c"
  HEAP32[$25>>2] = $27; //@line 75516 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 75517 "c/sqlite3.c"
  $28 = ($$1|0)==(0); //@line 75519 "c/sqlite3.c"
  if ($28) {
   label = 11;
  } else {
   $$3 = $$1;
   label = 14;
  }
 } else {
  $9 = ((($2)) + 444|0); //@line 75516 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 75516 "c/sqlite3.c"
  $11 = (($10) + -1)|0; //@line 75516 "c/sqlite3.c"
  HEAP32[$9>>2] = $11; //@line 75516 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 75517 "c/sqlite3.c"
  label = 11;
 }
 do {
  if ((label|0) == 11) {
   $29 = ($1|0)==(2); //@line 75520 "c/sqlite3.c"
   if ($29) {
    $30 = (_sqlite3VtabSavepoint($2,2,$5)|0); //@line 75521 "c/sqlite3.c"
    $31 = ($30|0)==(0); //@line 75523 "c/sqlite3.c"
    if (!($31)) {
     $$347 = $30;
     break;
    }
   }
   $32 = (_sqlite3VtabSavepoint($2,1,$5)|0); //@line 75524 "c/sqlite3.c"
   $$3 = $32;
   label = 14;
  }
 } while(0);
 if ((label|0) == 14) {
  $33 = ($1|0)==(2); //@line 75531 "c/sqlite3.c"
  if ($33) {
   $$347 = $$3;
  } else {
   $$346 = $$3;
   return ($$346|0); //@line 75535 "c/sqlite3.c"
  }
 }
 $34 = ((($0)) + 72|0); //@line 75532 "c/sqlite3.c"
 $35 = $34; //@line 75532 "c/sqlite3.c"
 $36 = $35; //@line 75532 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 75532 "c/sqlite3.c"
 $38 = (($35) + 4)|0; //@line 75532 "c/sqlite3.c"
 $39 = $38; //@line 75532 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 75532 "c/sqlite3.c"
 $41 = ((($2)) + 448|0); //@line 75532 "c/sqlite3.c"
 $42 = $41; //@line 75532 "c/sqlite3.c"
 $43 = $42; //@line 75532 "c/sqlite3.c"
 HEAP32[$43>>2] = $37; //@line 75532 "c/sqlite3.c"
 $44 = (($42) + 4)|0; //@line 75532 "c/sqlite3.c"
 $45 = $44; //@line 75532 "c/sqlite3.c"
 HEAP32[$45>>2] = $40; //@line 75532 "c/sqlite3.c"
 $46 = ((($0)) + 80|0); //@line 75533 "c/sqlite3.c"
 $47 = $46; //@line 75533 "c/sqlite3.c"
 $48 = $47; //@line 75533 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 75533 "c/sqlite3.c"
 $50 = (($47) + 4)|0; //@line 75533 "c/sqlite3.c"
 $51 = $50; //@line 75533 "c/sqlite3.c"
 $52 = HEAP32[$51>>2]|0; //@line 75533 "c/sqlite3.c"
 $53 = ((($2)) + 456|0); //@line 75533 "c/sqlite3.c"
 $54 = $53; //@line 75533 "c/sqlite3.c"
 $55 = $54; //@line 75533 "c/sqlite3.c"
 HEAP32[$55>>2] = $49; //@line 75533 "c/sqlite3.c"
 $56 = (($54) + 4)|0; //@line 75533 "c/sqlite3.c"
 $57 = $56; //@line 75533 "c/sqlite3.c"
 HEAP32[$57>>2] = $52; //@line 75533 "c/sqlite3.c"
 $$346 = $$347;
 return ($$346|0); //@line 75535 "c/sqlite3.c"
}
function _sqlite3BtreeSavepoint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 64582 "c/sqlite3.c"
 if ($3) {
  $$3 = 0;
  return ($$3|0); //@line 64607 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0); //@line 64582 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 64582 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(2); //@line 64582 "c/sqlite3.c"
 if (!($6)) {
  $$3 = 0;
  return ($$3|0); //@line 64607 "c/sqlite3.c"
 }
 $7 = ((($0)) + 4|0); //@line 64583 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 64583 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 64586 "c/sqlite3.c"
 $9 = ($1|0)==(2); //@line 64587 "c/sqlite3.c"
 if ($9) {
  $10 = (_saveAllCursors($8,0,0)|0); //@line 64588 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 64590 "c/sqlite3.c"
  if ($11) {
   label = 5;
  } else {
   $$2 = $10;
  }
 } else {
  label = 5;
 }
 if ((label|0) == 5) {
  $12 = HEAP32[$8>>2]|0; //@line 64591 "c/sqlite3.c"
  $13 = (_sqlite3PagerSavepoint($12,$1,$2)|0); //@line 64591 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 64593 "c/sqlite3.c"
  if ($14) {
   $15 = ($2|0)<(0); //@line 64594 "c/sqlite3.c"
   if ($15) {
    $16 = ((($8)) + 22|0); //@line 64594 "c/sqlite3.c"
    $17 = HEAP16[$16>>1]|0; //@line 64594 "c/sqlite3.c"
    $18 = $17 & 16; //@line 64594 "c/sqlite3.c"
    $19 = ($18<<16>>16)==(0); //@line 64594 "c/sqlite3.c"
    if (!($19)) {
     $20 = ((($8)) + 44|0); //@line 64595 "c/sqlite3.c"
     HEAP32[$20>>2] = 0; //@line 64595 "c/sqlite3.c"
    }
   }
   $21 = (_newDatabase($8)|0); //@line 64597 "c/sqlite3.c"
   $22 = ((($8)) + 12|0); //@line 64598 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 64598 "c/sqlite3.c"
   $24 = ((($23)) + 56|0); //@line 64598 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 64598 "c/sqlite3.c"
   $26 = ((($25)) + 28|0); //@line 64598 "c/sqlite3.c"
   $27 = (_sqlite3Get4byte($26)|0); //@line 64598 "c/sqlite3.c"
   $28 = ((($8)) + 44|0); //@line 64598 "c/sqlite3.c"
   HEAP32[$28>>2] = $27; //@line 64598 "c/sqlite3.c"
   $$2 = $21;
  } else {
   $$2 = $13;
  }
 }
 _sqlite3BtreeLeave($0); //@line 64605 "c/sqlite3.c"
 $$3 = $$2;
 return ($$3|0); //@line 64607 "c/sqlite3.c"
}
function _sqlite3VtabSavepoint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$03233 = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 348|0); //@line 128357 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 128357 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 128357 "c/sqlite3.c"
 if ($5) {
  $$3 = 0;
  return ($$3|0); //@line 128382 "c/sqlite3.c"
 }
 $6 = ((($0)) + 324|0); //@line 128359 "c/sqlite3.c"
 $7 = (($2) + 1)|0;
 $$03233 = 0;
 while(1) {
  $8 = HEAP32[$6>>2]|0; //@line 128359 "c/sqlite3.c"
  $9 = ($$03233|0)<($8|0); //@line 128359 "c/sqlite3.c"
  if (!($9)) {
   $$3 = 0;
   label = 14;
   break;
  }
  $10 = HEAP32[$3>>2]|0; //@line 128360 "c/sqlite3.c"
  $11 = (($10) + ($$03233<<2)|0); //@line 128360 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 128360 "c/sqlite3.c"
  $13 = ((($12)) + 4|0); //@line 128361 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 128361 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 128361 "c/sqlite3.c"
  $16 = ((($12)) + 8|0); //@line 128362 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 128362 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 128362 "c/sqlite3.c"
  if ($18) {
   $$2 = 0;
  } else {
   $19 = HEAP32[$15>>2]|0; //@line 128362 "c/sqlite3.c"
   $20 = ($19|0)>(1); //@line 128362 "c/sqlite3.c"
   if ($20) {
    switch ($1|0) {
    case 0:  {
     $21 = ((($15)) + 80|0); //@line 128366 "c/sqlite3.c"
     $22 = HEAP32[$21>>2]|0; //@line 128366 "c/sqlite3.c"
     $23 = ((($12)) + 20|0); //@line 128367 "c/sqlite3.c"
     HEAP32[$23>>2] = $7; //@line 128367 "c/sqlite3.c"
     $$0 = $22;
     break;
    }
    case 2:  {
     $24 = ((($15)) + 88|0); //@line 128370 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 128370 "c/sqlite3.c"
     $$0 = $25;
     break;
    }
    default: {
     $26 = ((($15)) + 84|0); //@line 128373 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 128373 "c/sqlite3.c"
     $$0 = $27;
    }
    }
    $28 = ($$0|0)==(0|0); //@line 128376 "c/sqlite3.c"
    if ($28) {
     $$2 = 0;
    } else {
     $29 = ((($12)) + 20|0); //@line 128376 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 128376 "c/sqlite3.c"
     $31 = ($30|0)>($2|0); //@line 128376 "c/sqlite3.c"
     if ($31) {
      $32 = (FUNCTION_TABLE_iii[$$0 & 255]($17,$2)|0); //@line 128377 "c/sqlite3.c"
      $$2 = $32;
     } else {
      $$2 = 0;
     }
    }
   } else {
    $$2 = 0;
   }
  }
  $33 = (($$03233) + 1)|0; //@line 128359 "c/sqlite3.c"
  $34 = ($$2|0)==(0); //@line 128359 "c/sqlite3.c"
  if ($34) {
   $$03233 = $33;
  } else {
   $$3 = $$2;
   label = 14;
   break;
  }
 }
 if ((label|0) == 14) {
  return ($$3|0); //@line 128382 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeEnter($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 9|0); //@line 60185 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 60185 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 60185 "c/sqlite3.c"
 if ($3) {
  return; //@line 60189 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0); //@line 60186 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 60186 "c/sqlite3.c"
 $6 = (($5) + 1)|0; //@line 60186 "c/sqlite3.c"
 HEAP32[$4>>2] = $6; //@line 60186 "c/sqlite3.c"
 $7 = ((($0)) + 10|0); //@line 60187 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 60187 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 60187 "c/sqlite3.c"
 if (!($9)) {
  return; //@line 60189 "c/sqlite3.c"
 }
 _btreeLockCarefully($0); //@line 60188 "c/sqlite3.c"
 return; //@line 60189 "c/sqlite3.c"
}
function _saveAllCursors($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$015 = 0, $$017 = 0, $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 61143 "c/sqlite3.c"
 $$017 = HEAP32[$3>>2]|0;
 $4 = ($$017|0)==(0|0); //@line 61143 "c/sqlite3.c"
 L1: do {
  if (!($4)) {
   $5 = ($1|0)==(0);
   $$018 = $$017;
   while(1) {
    $6 = ($$018|0)==($2|0); //@line 61144 "c/sqlite3.c"
    if (!($6)) {
     if ($5) {
      break;
     }
     $7 = ((($$018)) + 60|0); //@line 61144 "c/sqlite3.c"
     $8 = HEAP32[$7>>2]|0; //@line 61144 "c/sqlite3.c"
     $9 = ($8|0)==($1|0); //@line 61144 "c/sqlite3.c"
     if ($9) {
      break;
     }
    }
    $10 = ((($$018)) + 16|0); //@line 61143 "c/sqlite3.c"
    $$0 = HEAP32[$10>>2]|0;
    $11 = ($$0|0)==(0|0); //@line 61143 "c/sqlite3.c"
    if ($11) {
     break L1;
    } else {
     $$018 = $$0;
    }
   }
   $12 = (_saveCursorsOnList($$018,$1,$2)|0); //@line 61146 "c/sqlite3.c"
   $$015 = $12;
   return ($$015|0); //@line 61149 "c/sqlite3.c"
  }
 } while(0);
 $13 = ($2|0)==(0|0); //@line 61147 "c/sqlite3.c"
 if ($13) {
  $$015 = 0;
  return ($$015|0); //@line 61149 "c/sqlite3.c"
 }
 $14 = ((($2)) + 1|0); //@line 61147 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 61147 "c/sqlite3.c"
 $16 = $15 & -33; //@line 61147 "c/sqlite3.c"
 HEAP8[$14>>0] = $16; //@line 61147 "c/sqlite3.c"
 $$015 = 0;
 return ($$015|0); //@line 61149 "c/sqlite3.c"
}
function _sqlite3PagerSavepoint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$03435 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $not$ = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 40|0); //@line 54821 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 54821 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 54830 "c/sqlite3.c"
 if (!($5)) {
  $$2 = $4;
  return ($$2|0); //@line 54883 "c/sqlite3.c"
 }
 $6 = ((($0)) + 96|0); //@line 54830 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 54830 "c/sqlite3.c"
 $8 = ($7|0)>($2|0); //@line 54830 "c/sqlite3.c"
 if (!($8)) {
  $$2 = 0;
  return ($$2|0); //@line 54883 "c/sqlite3.c"
 }
 $9 = ($1|0)==(1); //@line 54838 "c/sqlite3.c"
 $not$ = $9 ^ 1; //@line 54838 "c/sqlite3.c"
 $10 = $not$&1; //@line 54838 "c/sqlite3.c"
 $11 = (($10) + ($2))|0; //@line 54838 "c/sqlite3.c"
 $12 = HEAP32[$6>>2]|0; //@line 54839 "c/sqlite3.c"
 $13 = ($11|0)<($12|0); //@line 54839 "c/sqlite3.c"
 if ($13) {
  $14 = ((($0)) + 92|0);
  $$03435 = $11;
  while(1) {
   $15 = HEAP32[$14>>2]|0; //@line 54840 "c/sqlite3.c"
   $16 = (((($15) + (($$03435*48)|0)|0)) + 16|0); //@line 54840 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 54840 "c/sqlite3.c"
   _sqlite3BitvecDestroy($17); //@line 54840 "c/sqlite3.c"
   $18 = (($$03435) + 1)|0; //@line 54839 "c/sqlite3.c"
   $19 = HEAP32[$6>>2]|0; //@line 54839 "c/sqlite3.c"
   $20 = ($18|0)<($19|0); //@line 54839 "c/sqlite3.c"
   if ($20) {
    $$03435 = $18;
   } else {
    break;
   }
  }
 }
 HEAP32[$6>>2] = $11; //@line 54842 "c/sqlite3.c"
 if (!($9)) {
  $30 = ((($0)) + 212|0); //@line 54861 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 54861 "c/sqlite3.c"
  $32 = ($31|0)==(0|0); //@line 54861 "c/sqlite3.c"
  if ($32) {
   $33 = ((($0)) + 64|0); //@line 54861 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 54861 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 54861 "c/sqlite3.c"
   $36 = ($35|0)==(0|0); //@line 54861 "c/sqlite3.c"
   if ($36) {
    $$2 = $4;
    return ($$2|0); //@line 54883 "c/sqlite3.c"
   }
  }
  $37 = ($11|0)==(0); //@line 54862 "c/sqlite3.c"
  if ($37) {
   $42 = 0;
  } else {
   $38 = (($11) + -1)|0; //@line 54862 "c/sqlite3.c"
   $39 = ((($0)) + 92|0); //@line 54862 "c/sqlite3.c"
   $40 = HEAP32[$39>>2]|0; //@line 54862 "c/sqlite3.c"
   $41 = (($40) + (($38*48)|0)|0); //@line 54862 "c/sqlite3.c"
   $42 = $41;
  }
  $43 = (_pagerPlaybackSavepoint($0,$42)|0); //@line 54863 "c/sqlite3.c"
  $$2 = $43;
  return ($$2|0); //@line 54883 "c/sqlite3.c"
 }
 $21 = ($11|0)==(0); //@line 54847 "c/sqlite3.c"
 if (!($21)) {
  $$2 = $4;
  return ($$2|0); //@line 54883 "c/sqlite3.c"
 }
 $22 = ((($0)) + 68|0); //@line 54847 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 54847 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 54847 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 54847 "c/sqlite3.c"
 if ($25) {
  $$2 = $4;
  return ($$2|0); //@line 54883 "c/sqlite3.c"
 }
 $26 = (_sqlite3JournalIsInMemory($23)|0); //@line 54849 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 54849 "c/sqlite3.c"
 if ($27) {
  $$0 = $4;
 } else {
  $28 = (_sqlite3OsTruncate($23,0,0)|0); //@line 54850 "c/sqlite3.c"
  $$0 = $28;
 }
 $29 = ((($0)) + 52|0); //@line 54853 "c/sqlite3.c"
 HEAP32[$29>>2] = 0; //@line 54853 "c/sqlite3.c"
 $$2 = $$0;
 return ($$2|0); //@line 54883 "c/sqlite3.c"
}
function _newDatabase($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 44|0); //@line 63612 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63612 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 63612 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 63643 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0); //@line 63615 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 63615 "c/sqlite3.c"
 $6 = ((($5)) + 56|0); //@line 63617 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 63617 "c/sqlite3.c"
 $8 = ((($5)) + 72|0); //@line 63618 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 63618 "c/sqlite3.c"
 $10 = (_sqlite3PagerWrite($9)|0); //@line 63618 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 63619 "c/sqlite3.c"
 if (!($11)) {
  $$0 = $10;
  return ($$0|0); //@line 63643 "c/sqlite3.c"
 }
 dest=$7; src=18250; stop=dest+16|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 63620 "c/sqlite3.c"
 $12 = ((($0)) + 32|0); //@line 63622 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 63622 "c/sqlite3.c"
 $14 = $13 >>> 8; //@line 63622 "c/sqlite3.c"
 $15 = $14&255; //@line 63622 "c/sqlite3.c"
 $16 = ((($7)) + 16|0); //@line 63622 "c/sqlite3.c"
 HEAP8[$16>>0] = $15; //@line 63622 "c/sqlite3.c"
 $17 = HEAP32[$12>>2]|0; //@line 63623 "c/sqlite3.c"
 $18 = $17 >>> 16; //@line 63623 "c/sqlite3.c"
 $19 = $18&255; //@line 63623 "c/sqlite3.c"
 $20 = ((($7)) + 17|0); //@line 63623 "c/sqlite3.c"
 HEAP8[$20>>0] = $19; //@line 63623 "c/sqlite3.c"
 $21 = ((($7)) + 18|0); //@line 63624 "c/sqlite3.c"
 HEAP8[$21>>0] = 1; //@line 63624 "c/sqlite3.c"
 $22 = ((($7)) + 19|0); //@line 63625 "c/sqlite3.c"
 HEAP8[$22>>0] = 1; //@line 63625 "c/sqlite3.c"
 $23 = HEAP32[$12>>2]|0; //@line 63627 "c/sqlite3.c"
 $24 = ((($0)) + 36|0); //@line 63627 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 63627 "c/sqlite3.c"
 $26 = (($23) - ($25))|0; //@line 63627 "c/sqlite3.c"
 $27 = $26&255; //@line 63627 "c/sqlite3.c"
 $28 = ((($7)) + 20|0); //@line 63627 "c/sqlite3.c"
 HEAP8[$28>>0] = $27; //@line 63627 "c/sqlite3.c"
 $29 = ((($7)) + 21|0); //@line 63628 "c/sqlite3.c"
 HEAP8[$29>>0] = 64; //@line 63628 "c/sqlite3.c"
 $30 = ((($7)) + 22|0); //@line 63629 "c/sqlite3.c"
 HEAP8[$30>>0] = 32; //@line 63629 "c/sqlite3.c"
 $31 = ((($7)) + 23|0); //@line 63630 "c/sqlite3.c"
 HEAP8[$31>>0] = 32; //@line 63630 "c/sqlite3.c"
 $32 = ((($7)) + 24|0); //@line 63631 "c/sqlite3.c"
 dest=$32; stop=dest+76|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 63631 "c/sqlite3.c"
 _zeroPage($5,13); //@line 63632 "c/sqlite3.c"
 $33 = ((($0)) + 22|0); //@line 63633 "c/sqlite3.c"
 $34 = HEAP16[$33>>1]|0; //@line 63633 "c/sqlite3.c"
 $35 = $34 | 2; //@line 63633 "c/sqlite3.c"
 HEAP16[$33>>1] = $35; //@line 63633 "c/sqlite3.c"
 $36 = ((($7)) + 52|0); //@line 63637 "c/sqlite3.c"
 $37 = ((($0)) + 17|0); //@line 63637 "c/sqlite3.c"
 $38 = HEAP8[$37>>0]|0; //@line 63637 "c/sqlite3.c"
 $39 = $38&255; //@line 63637 "c/sqlite3.c"
 _sqlite3Put4byte($36,$39); //@line 63637 "c/sqlite3.c"
 $40 = ((($7)) + 64|0); //@line 63638 "c/sqlite3.c"
 $41 = ((($0)) + 18|0); //@line 63638 "c/sqlite3.c"
 $42 = HEAP8[$41>>0]|0; //@line 63638 "c/sqlite3.c"
 $43 = $42&255; //@line 63638 "c/sqlite3.c"
 _sqlite3Put4byte($40,$43); //@line 63638 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 63640 "c/sqlite3.c"
 $44 = ((($7)) + 31|0); //@line 63641 "c/sqlite3.c"
 HEAP8[$44>>0] = 1; //@line 63641 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 63643 "c/sqlite3.c"
}
function _sqlite3Get4byte($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 29663 "c/sqlite3.c"
 $2 = $1&255; //@line 29663 "c/sqlite3.c"
 $3 = $2 << 24; //@line 29663 "c/sqlite3.c"
 $4 = ((($0)) + 1|0); //@line 29663 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 29663 "c/sqlite3.c"
 $6 = $5&255; //@line 29663 "c/sqlite3.c"
 $7 = $6 << 16; //@line 29663 "c/sqlite3.c"
 $8 = $7 | $3; //@line 29663 "c/sqlite3.c"
 $9 = ((($0)) + 2|0); //@line 29663 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 29663 "c/sqlite3.c"
 $11 = $10&255; //@line 29663 "c/sqlite3.c"
 $12 = $11 << 8; //@line 29663 "c/sqlite3.c"
 $13 = $8 | $12; //@line 29663 "c/sqlite3.c"
 $14 = ((($0)) + 3|0); //@line 29663 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 29663 "c/sqlite3.c"
 $16 = $15&255; //@line 29663 "c/sqlite3.c"
 $17 = $13 | $16; //@line 29663 "c/sqlite3.c"
 return ($17|0); //@line 29663 "c/sqlite3.c"
}
function _sqlite3PagerWrite($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 54075 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54075 "c/sqlite3.c"
 $3 = ((($0)) + 28|0); //@line 54079 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 54079 "c/sqlite3.c"
 $5 = $4 & 4; //@line 54079 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 54079 "c/sqlite3.c"
 if (!($6)) {
  $7 = ((($2)) + 24|0); //@line 54079 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 54079 "c/sqlite3.c"
  $9 = ((($0)) + 24|0); //@line 54079 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 54079 "c/sqlite3.c"
  $11 = ($8>>>0)<($10>>>0); //@line 54079 "c/sqlite3.c"
  if (!($11)) {
   $12 = ((($2)) + 96|0); //@line 54080 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 54080 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 54080 "c/sqlite3.c"
   if ($14) {
    $$0 = 0;
    return ($$0|0); //@line 54090 "c/sqlite3.c"
   }
   $15 = (_subjournalPageIfRequired($0)|0); //@line 54080 "c/sqlite3.c"
   $$0 = $15;
   return ($$0|0); //@line 54090 "c/sqlite3.c"
  }
 }
 $16 = ((($2)) + 40|0); //@line 54082 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 54082 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 54082 "c/sqlite3.c"
 if (!($18)) {
  $$0 = $17;
  return ($$0|0); //@line 54090 "c/sqlite3.c"
 }
 $19 = ((($2)) + 148|0); //@line 54084 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 54084 "c/sqlite3.c"
 $21 = ((($2)) + 152|0); //@line 54084 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 54084 "c/sqlite3.c"
 $23 = ($20>>>0)>($22>>>0); //@line 54084 "c/sqlite3.c"
 if ($23) {
  $24 = (_pagerWriteLargeSector($0)|0); //@line 54086 "c/sqlite3.c"
  $$0 = $24;
  return ($$0|0); //@line 54090 "c/sqlite3.c"
 } else {
  $25 = (_pager_write($0)|0); //@line 54088 "c/sqlite3.c"
  $$0 = $25;
  return ($$0|0); //@line 54090 "c/sqlite3.c"
 }
 return (0)|0;
}
function _zeroPage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 56|0); //@line 62373 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 62373 "c/sqlite3.c"
 $4 = ((($0)) + 52|0); //@line 62374 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 62374 "c/sqlite3.c"
 $6 = ((($0)) + 9|0); //@line 62375 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 62375 "c/sqlite3.c"
 $8 = ((($5)) + 22|0); //@line 62383 "c/sqlite3.c"
 $9 = HEAP16[$8>>1]|0; //@line 62383 "c/sqlite3.c"
 $10 = $9 & 12; //@line 62383 "c/sqlite3.c"
 $11 = ($10<<16>>16)==(0); //@line 62383 "c/sqlite3.c"
 $12 = $7&255; //@line 62384 "c/sqlite3.c"
 if (!($11)) {
  $13 = ((($5)) + 36|0); //@line 62384 "c/sqlite3.c"
  $14 = (($3) + ($12)|0); //@line 62384 "c/sqlite3.c"
  $15 = HEAP32[$13>>2]|0; //@line 62384 "c/sqlite3.c"
  $16 = (($15) - ($12))|0; //@line 62384 "c/sqlite3.c"
  _memset(($14|0),0,($16|0))|0; //@line 62384 "c/sqlite3.c"
 }
 $17 = $1&255; //@line 62386 "c/sqlite3.c"
 $18 = $7&255; //@line 62386 "c/sqlite3.c"
 $19 = (($3) + ($18)|0); //@line 62386 "c/sqlite3.c"
 HEAP8[$19>>0] = $17; //@line 62386 "c/sqlite3.c"
 $20 = $1 >>> 1; //@line 62387 "c/sqlite3.c"
 $21 = $20 & 4; //@line 62387 "c/sqlite3.c"
 $22 = $21 ^ 12; //@line 62387 "c/sqlite3.c"
 $23 = (($22) + ($18))|0; //@line 62387 "c/sqlite3.c"
 $24 = $23&65535; //@line 62387 "c/sqlite3.c"
 $25 = (($18) + 1)|0; //@line 62388 "c/sqlite3.c"
 $26 = (($3) + ($25)|0); //@line 62388 "c/sqlite3.c"
 HEAP8[$26>>0]=0&255;HEAP8[$26+1>>0]=(0>>8)&255;HEAP8[$26+2>>0]=(0>>16)&255;HEAP8[$26+3>>0]=0>>24; //@line 62388 "c/sqlite3.c"
 $27 = (($18) + 7)|0; //@line 62389 "c/sqlite3.c"
 $28 = (($3) + ($27)|0); //@line 62389 "c/sqlite3.c"
 HEAP8[$28>>0] = 0; //@line 62389 "c/sqlite3.c"
 $29 = ((($5)) + 36|0); //@line 62390 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 62390 "c/sqlite3.c"
 $31 = $30 >>> 8; //@line 62390 "c/sqlite3.c"
 $32 = $31&255; //@line 62390 "c/sqlite3.c"
 $33 = (($18) + 5)|0; //@line 62390 "c/sqlite3.c"
 $34 = (($3) + ($33)|0); //@line 62390 "c/sqlite3.c"
 HEAP8[$34>>0] = $32; //@line 62390 "c/sqlite3.c"
 $35 = HEAP32[$29>>2]|0; //@line 62390 "c/sqlite3.c"
 $36 = $35&255; //@line 62390 "c/sqlite3.c"
 $37 = ((($34)) + 1|0); //@line 62390 "c/sqlite3.c"
 HEAP8[$37>>0] = $36; //@line 62390 "c/sqlite3.c"
 $38 = HEAP32[$29>>2]|0; //@line 62391 "c/sqlite3.c"
 $39 = (($38) - ($23))|0; //@line 62391 "c/sqlite3.c"
 $40 = $39&65535; //@line 62391 "c/sqlite3.c"
 $41 = ((($0)) + 20|0); //@line 62391 "c/sqlite3.c"
 HEAP16[$41>>1] = $40; //@line 62391 "c/sqlite3.c"
 (_decodeFlags($0,$1)|0); //@line 62392 "c/sqlite3.c"
 $42 = ((($0)) + 18|0); //@line 62393 "c/sqlite3.c"
 HEAP16[$42>>1] = $24; //@line 62393 "c/sqlite3.c"
 $43 = HEAP32[$29>>2]|0; //@line 62394 "c/sqlite3.c"
 $44 = (($3) + ($43)|0); //@line 62394 "c/sqlite3.c"
 $45 = ((($0)) + 60|0); //@line 62394 "c/sqlite3.c"
 HEAP32[$45>>2] = $44; //@line 62394 "c/sqlite3.c"
 $46 = (($3) + ($23)|0); //@line 62395 "c/sqlite3.c"
 $47 = ((($0)) + 64|0); //@line 62395 "c/sqlite3.c"
 HEAP32[$47>>2] = $46; //@line 62395 "c/sqlite3.c"
 $48 = ((($0)) + 10|0); //@line 62396 "c/sqlite3.c"
 $49 = HEAP8[$48>>0]|0; //@line 62396 "c/sqlite3.c"
 $50 = $49&255; //@line 62396 "c/sqlite3.c"
 $51 = (($3) + ($50)|0); //@line 62396 "c/sqlite3.c"
 $52 = ((($0)) + 68|0); //@line 62396 "c/sqlite3.c"
 HEAP32[$52>>2] = $51; //@line 62396 "c/sqlite3.c"
 $53 = ((($0)) + 12|0); //@line 62397 "c/sqlite3.c"
 HEAP8[$53>>0] = 0; //@line 62397 "c/sqlite3.c"
 $54 = ((($5)) + 32|0); //@line 62399 "c/sqlite3.c"
 $55 = HEAP32[$54>>2]|0; //@line 62399 "c/sqlite3.c"
 $56 = (($55) + 65535)|0; //@line 62399 "c/sqlite3.c"
 $57 = $56&65535; //@line 62399 "c/sqlite3.c"
 $58 = ((($0)) + 24|0); //@line 62399 "c/sqlite3.c"
 HEAP16[$58>>1] = $57; //@line 62399 "c/sqlite3.c"
 $59 = ((($0)) + 22|0); //@line 62400 "c/sqlite3.c"
 HEAP16[$59>>1] = 0; //@line 62400 "c/sqlite3.c"
 HEAP8[$0>>0] = 1; //@line 62401 "c/sqlite3.c"
 return; //@line 62402 "c/sqlite3.c"
}
function _sqlite3Put4byte($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1 >>> 24; //@line 29676 "c/sqlite3.c"
 $3 = $2&255; //@line 29676 "c/sqlite3.c"
 HEAP8[$0>>0] = $3; //@line 29676 "c/sqlite3.c"
 $4 = $1 >>> 16; //@line 29677 "c/sqlite3.c"
 $5 = $4&255; //@line 29677 "c/sqlite3.c"
 $6 = ((($0)) + 1|0); //@line 29677 "c/sqlite3.c"
 HEAP8[$6>>0] = $5; //@line 29677 "c/sqlite3.c"
 $7 = $1 >>> 8; //@line 29678 "c/sqlite3.c"
 $8 = $7&255; //@line 29678 "c/sqlite3.c"
 $9 = ((($0)) + 2|0); //@line 29678 "c/sqlite3.c"
 HEAP8[$9>>0] = $8; //@line 29678 "c/sqlite3.c"
 $10 = $1&255; //@line 29679 "c/sqlite3.c"
 $11 = ((($0)) + 3|0); //@line 29679 "c/sqlite3.c"
 HEAP8[$11>>0] = $10; //@line 29679 "c/sqlite3.c"
 return; //@line 29681 "c/sqlite3.c"
}
function _decodeFlags($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$sink30 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $btreeParseCellPtrNoPayload$sink = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1 >>> 3; //@line 62181 "c/sqlite3.c"
 $3 = $2&255; //@line 62181 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 62181 "c/sqlite3.c"
 HEAP8[$4>>0] = $3; //@line 62181 "c/sqlite3.c"
 $5 = $1 & -9; //@line 62182 "c/sqlite3.c"
 $6 = $2 << 2; //@line 62183 "c/sqlite3.c"
 $7 = (4 - ($6))|0; //@line 62183 "c/sqlite3.c"
 $8 = $7&255; //@line 62183 "c/sqlite3.c"
 $9 = ((($0)) + 10|0); //@line 62183 "c/sqlite3.c"
 HEAP8[$9>>0] = $8; //@line 62183 "c/sqlite3.c"
 $10 = ((($0)) + 76|0); //@line 62184 "c/sqlite3.c"
 HEAP32[$10>>2] = 147; //@line 62184 "c/sqlite3.c"
 $11 = ((($0)) + 52|0); //@line 62185 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 62185 "c/sqlite3.c"
 switch ($5|0) {
 case 5:  {
  $13 = ((($0)) + 2|0); //@line 62193 "c/sqlite3.c"
  HEAP8[$13>>0] = 1; //@line 62193 "c/sqlite3.c"
  $14 = ($3<<24>>24)==(0); //@line 62194 "c/sqlite3.c"
  $15 = ((($0)) + 3|0);
  if ($14) {
   HEAP8[$15>>0] = 0; //@line 62198 "c/sqlite3.c"
   HEAP32[$10>>2] = 148; //@line 62199 "c/sqlite3.c"
   $btreeParseCellPtrNoPayload$sink = 165;
  } else {
   HEAP8[$15>>0] = 1; //@line 62195 "c/sqlite3.c"
   $btreeParseCellPtrNoPayload$sink = 164;
  }
  $16 = ((($0)) + 80|0);
  HEAP32[$16>>2] = $btreeParseCellPtrNoPayload$sink;
  $17 = ((($12)) + 28|0); //@line 62202 "c/sqlite3.c"
  $18 = HEAP16[$17>>1]|0; //@line 62202 "c/sqlite3.c"
  $19 = ((($0)) + 14|0); //@line 62202 "c/sqlite3.c"
  HEAP16[$19>>1] = $18; //@line 62202 "c/sqlite3.c"
  $20 = ((($12)) + 30|0); //@line 62203 "c/sqlite3.c"
  $$sink30 = $20;
  break;
 }
 case 2:  {
  $21 = ((($0)) + 2|0); //@line 62211 "c/sqlite3.c"
  HEAP8[$21>>0] = 0; //@line 62211 "c/sqlite3.c"
  $22 = ((($0)) + 3|0); //@line 62212 "c/sqlite3.c"
  HEAP8[$22>>0] = 0; //@line 62212 "c/sqlite3.c"
  $23 = ((($0)) + 80|0); //@line 62213 "c/sqlite3.c"
  HEAP32[$23>>2] = 163; //@line 62213 "c/sqlite3.c"
  $24 = ((($12)) + 24|0); //@line 62214 "c/sqlite3.c"
  $25 = HEAP16[$24>>1]|0; //@line 62214 "c/sqlite3.c"
  $26 = ((($0)) + 14|0); //@line 62214 "c/sqlite3.c"
  HEAP16[$26>>1] = $25; //@line 62214 "c/sqlite3.c"
  $27 = ((($12)) + 26|0); //@line 62215 "c/sqlite3.c"
  $$sink30 = $27;
  break;
 }
 default: {
  $28 = (_sqlite3CorruptError(62219)|0); //@line 62219 "c/sqlite3.c"
  $$0 = $28;
  return ($$0|0); //@line 62223 "c/sqlite3.c"
 }
 }
 $29 = HEAP16[$$sink30>>1]|0;
 $30 = ((($0)) + 16|0);
 HEAP16[$30>>1] = $29;
 $31 = ((($12)) + 21|0); //@line 62221 "c/sqlite3.c"
 $32 = HEAP8[$31>>0]|0; //@line 62221 "c/sqlite3.c"
 $33 = ((($0)) + 11|0); //@line 62221 "c/sqlite3.c"
 HEAP8[$33>>0] = $32; //@line 62221 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 62223 "c/sqlite3.c"
}
function _cellSizePtr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$add = 0, $$0$idx = 0, $$042 = 0, $$1 = 0, $$143 = 0, $$2$add = 0, $$2$idx = 0, $$2$ptr = 0, $$3 = 0, $$345 = 0, $$ptr$le = 0, $$ptr46 = 0, $$ptr47 = 0, $$ptr47$le = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond48 = 0, $spec$select = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 10|0); //@line 61669 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 61669 "c/sqlite3.c"
 $4 = $3&255; //@line 61669 "c/sqlite3.c"
 $5 = (($1) + ($4)|0); //@line 61669 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 61682 "c/sqlite3.c"
 $7 = $6&255; //@line 61682 "c/sqlite3.c"
 $8 = ($6<<24>>24)<(0); //@line 61683 "c/sqlite3.c"
 if ($8) {
  $9 = $7 & 127; //@line 61685 "c/sqlite3.c"
  $$0$idx = 0;$$042 = $9;
  while(1) {
   $10 = $$042 << 7; //@line 61687 "c/sqlite3.c"
   $$0$add = (($$0$idx) + 1)|0; //@line 61687 "c/sqlite3.c"
   $$ptr47 = (($5) + ($$0$add)|0); //@line 61669 "c/sqlite3.c"
   $11 = HEAP8[$$ptr47>>0]|0; //@line 61687 "c/sqlite3.c"
   $12 = $11 & 127; //@line 61687 "c/sqlite3.c"
   $13 = $12&255; //@line 61687 "c/sqlite3.c"
   $14 = $10 | $13; //@line 61687 "c/sqlite3.c"
   $15 = ($11<<24>>24)<(0); //@line 61688 "c/sqlite3.c"
   $16 = ($$0$add>>>0)<(8); //@line 61688 "c/sqlite3.c"
   $or$cond = $15 & $16; //@line 61688 "c/sqlite3.c"
   if ($or$cond) {
    $$0$idx = $$0$add;$$042 = $14;
   } else {
    break;
   }
  }
  $$ptr47$le = (($5) + ($$0$add)|0); //@line 61669 "c/sqlite3.c"
  $$1 = $$ptr47$le;$$143 = $14;
 } else {
  $$1 = $5;$$143 = $7;
 }
 $$ptr46 = ((($$1)) + 1|0); //@line 61669 "c/sqlite3.c"
 $17 = ((($0)) + 2|0); //@line 61691 "c/sqlite3.c"
 $18 = HEAP8[$17>>0]|0; //@line 61691 "c/sqlite3.c"
 $19 = ($18<<24>>24)==(0); //@line 61691 "c/sqlite3.c"
 if ($19) {
  $$3 = $$ptr46;
 } else {
  $$2$idx = 1;
  while(1) {
   $$2$ptr = (($$1) + ($$2$idx)|0); //@line 61669 "c/sqlite3.c"
   $$2$add = (($$2$idx) + 1)|0; //@line 61696 "c/sqlite3.c"
   $20 = HEAP8[$$2$ptr>>0]|0; //@line 61696 "c/sqlite3.c"
   $21 = ($20<<24>>24)<(0); //@line 61696 "c/sqlite3.c"
   $22 = ($$2$add>>>0)<(10); //@line 61696 "c/sqlite3.c"
   $or$cond48 = $21 & $22; //@line 61696 "c/sqlite3.c"
   if ($or$cond48) {
    $$2$idx = $$2$add;
   } else {
    break;
   }
  }
  $$ptr$le = (($$1) + ($$2$add)|0); //@line 61669 "c/sqlite3.c"
  $$3 = $$ptr$le;
 }
 $23 = ((($0)) + 14|0); //@line 61700 "c/sqlite3.c"
 $24 = HEAP16[$23>>1]|0; //@line 61700 "c/sqlite3.c"
 $25 = $24&65535; //@line 61700 "c/sqlite3.c"
 $26 = ($$143>>>0)>($25>>>0); //@line 61700 "c/sqlite3.c"
 if ($26) {
  $32 = ((($0)) + 16|0); //@line 61704 "c/sqlite3.c"
  $33 = HEAP16[$32>>1]|0; //@line 61704 "c/sqlite3.c"
  $34 = $33&65535; //@line 61704 "c/sqlite3.c"
  $35 = (($$143) - ($34))|0; //@line 61705 "c/sqlite3.c"
  $36 = ((($0)) + 52|0); //@line 61705 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 61705 "c/sqlite3.c"
  $38 = ((($37)) + 36|0); //@line 61705 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 61705 "c/sqlite3.c"
  $40 = (($39) + -4)|0; //@line 61705 "c/sqlite3.c"
  $41 = (($35>>>0) % ($40>>>0))&-1; //@line 61705 "c/sqlite3.c"
  $42 = (($41) + ($34))|0; //@line 61705 "c/sqlite3.c"
  $43 = ($42>>>0)>($25>>>0); //@line 61708 "c/sqlite3.c"
  $spec$select = $43 ? $34 : $42; //@line 61708 "c/sqlite3.c"
  $44 = $$3; //@line 61711 "c/sqlite3.c"
  $45 = $1; //@line 61711 "c/sqlite3.c"
  $46 = (($44) - ($45))|0; //@line 61711 "c/sqlite3.c"
  $47 = $46 & 65535; //@line 61711 "c/sqlite3.c"
  $48 = (($47) + 4)|0; //@line 61711 "c/sqlite3.c"
  $49 = (($48) + ($spec$select))|0; //@line 61711 "c/sqlite3.c"
  $$345 = $49;
  $50 = $$345&65535; //@line 61714 "c/sqlite3.c"
  return ($50|0); //@line 61714 "c/sqlite3.c"
 } else {
  $27 = $$3; //@line 61701 "c/sqlite3.c"
  $28 = $1; //@line 61701 "c/sqlite3.c"
  $29 = (($27) - ($28))|0; //@line 61701 "c/sqlite3.c"
  $30 = (($29) + ($$143))|0; //@line 61701 "c/sqlite3.c"
  $31 = ($30>>>0)>(4); //@line 61702 "c/sqlite3.c"
  $spec$store$select = $31 ? $30 : 4; //@line 61702 "c/sqlite3.c"
  $$345 = $spec$store$select;
  $50 = $$345&65535; //@line 61714 "c/sqlite3.c"
  return ($50|0); //@line 61714 "c/sqlite3.c"
 }
 return (0)|0;
}
function _cellSizePtrNoPayload($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$add = 0, $$0$idx = 0, $$0$ptr = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0$idx = 4;
 while(1) {
  $$0$ptr = (($1) + ($$0$idx)|0); //@line 61717 "c/sqlite3.c"
  $$0$add = (($$0$idx) + 1)|0; //@line 61733 "c/sqlite3.c"
  $2 = HEAP8[$$0$ptr>>0]|0; //@line 61733 "c/sqlite3.c"
  $3 = ($2<<24>>24)<(0); //@line 61733 "c/sqlite3.c"
  $4 = ($$0$add>>>0)<(13); //@line 61733 "c/sqlite3.c"
  $or$cond = $3 & $4; //@line 61733 "c/sqlite3.c"
  if ($or$cond) {
   $$0$idx = $$0$add;
  } else {
   break;
  }
 }
 $5 = $$0$add&65535; //@line 61735 "c/sqlite3.c"
 return ($5|0); //@line 61735 "c/sqlite3.c"
}
function _btreeParseCellPtrNoPayload($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 4|0); //@line 61537 "c/sqlite3.c"
 $4 = (_sqlite3GetVarint($3,$2)|0); //@line 61537 "c/sqlite3.c"
 $5 = $4&255; //@line 61537 "c/sqlite3.c"
 $6 = (($5) + 4)|0; //@line 61537 "c/sqlite3.c"
 $7 = $6&65535; //@line 61537 "c/sqlite3.c"
 $8 = ((($2)) + 18|0); //@line 61537 "c/sqlite3.c"
 HEAP16[$8>>1] = $7; //@line 61537 "c/sqlite3.c"
 $9 = ((($2)) + 12|0); //@line 61538 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 61538 "c/sqlite3.c"
 $10 = ((($2)) + 16|0); //@line 61539 "c/sqlite3.c"
 HEAP16[$10>>1] = 0; //@line 61539 "c/sqlite3.c"
 $11 = ((($2)) + 8|0); //@line 61540 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 61540 "c/sqlite3.c"
 return; //@line 61541 "c/sqlite3.c"
}
function _btreeParseCellPtr($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$add = 0, $$0$idx = 0, $$050 = 0, $$1 = 0, $$151 = 0, $$2$add = 0, $$2$add62 = 0, $$2$idx61 = 0, $$2$idx61$phi = 0, $$4 = 0, $$ptr = 0, $$ptr$le = 0, $$ptr55 = 0, $$ptr56 = 0, $$ptr56$le = 0, $$ptr60 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0;
 var $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP8[$1>>0]|0; //@line 61564 "c/sqlite3.c"
 $4 = $3&255; //@line 61564 "c/sqlite3.c"
 $5 = ($3<<24>>24)<(0); //@line 61565 "c/sqlite3.c"
 if ($5) {
  $6 = $4 & 127; //@line 61567 "c/sqlite3.c"
  $$0$idx = 0;$$050 = $6;
  while(1) {
   $7 = $$050 << 7; //@line 61569 "c/sqlite3.c"
   $$0$add = (($$0$idx) + 1)|0; //@line 61569 "c/sqlite3.c"
   $$ptr56 = (($1) + ($$0$add)|0); //@line 61548 "c/sqlite3.c"
   $8 = HEAP8[$$ptr56>>0]|0; //@line 61569 "c/sqlite3.c"
   $9 = $8 & 127; //@line 61569 "c/sqlite3.c"
   $10 = $9&255; //@line 61569 "c/sqlite3.c"
   $11 = $7 | $10; //@line 61569 "c/sqlite3.c"
   $12 = ($8<<24>>24)<(0); //@line 61570 "c/sqlite3.c"
   $13 = ($$0$add>>>0)<(8); //@line 61570 "c/sqlite3.c"
   $or$cond = $12 & $13; //@line 61570 "c/sqlite3.c"
   if ($or$cond) {
    $$0$idx = $$0$add;$$050 = $11;
   } else {
    break;
   }
  }
  $$ptr56$le = (($1) + ($$0$add)|0); //@line 61548 "c/sqlite3.c"
  $$1 = $$ptr56$le;$$151 = $11;
 } else {
  $$1 = $1;$$151 = $4;
 }
 $$ptr55 = ((($$1)) + 1|0); //@line 61548 "c/sqlite3.c"
 $14 = HEAP8[$$ptr55>>0]|0; //@line 61580 "c/sqlite3.c"
 $15 = $14&255; //@line 61580 "c/sqlite3.c"
 $16 = ($14<<24>>24)<(0); //@line 61581 "c/sqlite3.c"
 do {
  if ($16) {
   $17 = (_bitshift64Shl(($15|0),0,7)|0); //@line 61585 "c/sqlite3.c"
   $18 = tempRet0; //@line 61585 "c/sqlite3.c"
   $19 = $17 & 16256; //@line 61585 "c/sqlite3.c"
   $$ptr60 = ((($$1)) + 2|0); //@line 61548 "c/sqlite3.c"
   $20 = HEAP8[$$ptr60>>0]|0; //@line 61585 "c/sqlite3.c"
   $21 = $20 & 127; //@line 61585 "c/sqlite3.c"
   $22 = $21&255; //@line 61585 "c/sqlite3.c"
   $23 = $19 | $22; //@line 61585 "c/sqlite3.c"
   $24 = ($20<<24>>24)>(-1); //@line 61586 "c/sqlite3.c"
   if ($24) {
    $$4 = $$ptr60;$45 = $23;$48 = 0;
   } else {
    $$2$add62 = 2;$$2$idx61 = 1;$25 = $23;$26 = 0;
    while(1) {
     $34 = ($$2$idx61>>>0)>(6); //@line 61587 "c/sqlite3.c"
     if ($34) {
      label = 10;
      break;
     }
     $27 = (_bitshift64Shl(($25|0),($26|0),7)|0); //@line 61585 "c/sqlite3.c"
     $28 = tempRet0; //@line 61585 "c/sqlite3.c"
     $$2$add = (($$2$add62) + 1)|0; //@line 61585 "c/sqlite3.c"
     $$ptr = (($$1) + ($$2$add)|0); //@line 61548 "c/sqlite3.c"
     $29 = HEAP8[$$ptr>>0]|0; //@line 61585 "c/sqlite3.c"
     $30 = $29 & 127; //@line 61585 "c/sqlite3.c"
     $31 = $30&255; //@line 61585 "c/sqlite3.c"
     $32 = $27 | $31; //@line 61585 "c/sqlite3.c"
     $33 = ($29<<24>>24)>(-1); //@line 61586 "c/sqlite3.c"
     if ($33) {
      label = 11;
      break;
     } else {
      $$2$idx61$phi = $$2$add62;$$2$add62 = $$2$add;$25 = $32;$26 = $28;$$2$idx61 = $$2$idx61$phi;
     }
    }
    if ((label|0) == 10) {
     $35 = (($$1) + ($$2$add62)|0); //@line 61548 "c/sqlite3.c"
     $36 = (_bitshift64Shl(($25|0),($26|0),8)|0); //@line 61588 "c/sqlite3.c"
     $37 = tempRet0; //@line 61588 "c/sqlite3.c"
     $38 = ((($35)) + 1|0); //@line 61588 "c/sqlite3.c"
     $39 = HEAP8[$38>>0]|0; //@line 61588 "c/sqlite3.c"
     $40 = $39&255; //@line 61588 "c/sqlite3.c"
     $41 = $36 | $40; //@line 61588 "c/sqlite3.c"
     $$4 = $38;$45 = $41;$48 = $37;
     break;
    }
    else if ((label|0) == 11) {
     $$ptr$le = (($$1) + ($$2$add)|0); //@line 61548 "c/sqlite3.c"
     $$4 = $$ptr$le;$45 = $32;$48 = $28;
     break;
    }
   }
  } else {
   $$4 = $$ptr55;$45 = $15;$48 = 0;
  }
 } while(0);
 $42 = ((($$4)) + 1|0); //@line 61593 "c/sqlite3.c"
 $43 = $2; //@line 61595 "c/sqlite3.c"
 $44 = $43; //@line 61595 "c/sqlite3.c"
 HEAP32[$44>>2] = $45; //@line 61595 "c/sqlite3.c"
 $46 = (($43) + 4)|0; //@line 61595 "c/sqlite3.c"
 $47 = $46; //@line 61595 "c/sqlite3.c"
 HEAP32[$47>>2] = $48; //@line 61595 "c/sqlite3.c"
 $49 = ((($2)) + 12|0); //@line 61596 "c/sqlite3.c"
 HEAP32[$49>>2] = $$151; //@line 61596 "c/sqlite3.c"
 $50 = ((($2)) + 8|0); //@line 61597 "c/sqlite3.c"
 HEAP32[$50>>2] = $42; //@line 61597 "c/sqlite3.c"
 $51 = ((($0)) + 14|0); //@line 61600 "c/sqlite3.c"
 $52 = HEAP16[$51>>1]|0; //@line 61600 "c/sqlite3.c"
 $53 = $52&65535; //@line 61600 "c/sqlite3.c"
 $54 = ($$151>>>0)>($53>>>0); //@line 61600 "c/sqlite3.c"
 if ($54) {
  _btreeParseCellAdjustSizeForOverflow($0,$1,$2); //@line 61608 "c/sqlite3.c"
  return; //@line 61610 "c/sqlite3.c"
 } else {
  $55 = $42; //@line 61604 "c/sqlite3.c"
  $56 = $1; //@line 61604 "c/sqlite3.c"
  $57 = (($55) - ($56))|0; //@line 61604 "c/sqlite3.c"
  $58 = (($57) + ($$151))|0; //@line 61604 "c/sqlite3.c"
  $59 = $58&65535; //@line 61604 "c/sqlite3.c"
  $60 = ((($2)) + 18|0); //@line 61604 "c/sqlite3.c"
  $61 = $58 & 65532; //@line 61605 "c/sqlite3.c"
  $62 = ($61|0)==(0); //@line 61605 "c/sqlite3.c"
  $spec$select = $62 ? 4 : $59; //@line 61605 "c/sqlite3.c"
  HEAP16[$60>>1] = $spec$select;
  $63 = $$151&65535; //@line 61606 "c/sqlite3.c"
  $64 = ((($2)) + 16|0); //@line 61606 "c/sqlite3.c"
  HEAP16[$64>>1] = $63; //@line 61606 "c/sqlite3.c"
  return; //@line 61610 "c/sqlite3.c"
 }
}
function _btreeParseCellPtrIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$add = 0, $$0$idx = 0, $$035 = 0, $$1 = 0, $$136 = 0, $$ptr = 0, $$ptr$le = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 10|0); //@line 61622 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 61622 "c/sqlite3.c"
 $5 = $4&255; //@line 61622 "c/sqlite3.c"
 $6 = (($1) + ($5)|0); //@line 61622 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 61623 "c/sqlite3.c"
 $8 = $7&255; //@line 61623 "c/sqlite3.c"
 $9 = ($7<<24>>24)<(0); //@line 61624 "c/sqlite3.c"
 if ($9) {
  $10 = $8 & 127; //@line 61626 "c/sqlite3.c"
  $$0$idx = 0;$$035 = $10;
  while(1) {
   $11 = $$035 << 7; //@line 61628 "c/sqlite3.c"
   $$0$add = (($$0$idx) + 1)|0; //@line 61628 "c/sqlite3.c"
   $$ptr = (($6) + ($$0$add)|0); //@line 61616 "c/sqlite3.c"
   $12 = HEAP8[$$ptr>>0]|0; //@line 61628 "c/sqlite3.c"
   $13 = $12 & 127; //@line 61628 "c/sqlite3.c"
   $14 = $13&255; //@line 61628 "c/sqlite3.c"
   $15 = $11 | $14; //@line 61628 "c/sqlite3.c"
   $16 = ($12<<24>>24)<(0); //@line 61629 "c/sqlite3.c"
   $17 = ($$0$add>>>0)<(8); //@line 61629 "c/sqlite3.c"
   $or$cond = $16 & $17; //@line 61629 "c/sqlite3.c"
   if ($or$cond) {
    $$0$idx = $$0$add;$$035 = $15;
   } else {
    break;
   }
  }
  $$ptr$le = (($6) + ($$0$add)|0); //@line 61616 "c/sqlite3.c"
  $$1 = $$ptr$le;$$136 = $15;
 } else {
  $$1 = $6;$$136 = $8;
 }
 $18 = ((($$1)) + 1|0); //@line 61631 "c/sqlite3.c"
 $19 = $2; //@line 61632 "c/sqlite3.c"
 $20 = $19; //@line 61632 "c/sqlite3.c"
 HEAP32[$20>>2] = $$136; //@line 61632 "c/sqlite3.c"
 $21 = (($19) + 4)|0; //@line 61632 "c/sqlite3.c"
 $22 = $21; //@line 61632 "c/sqlite3.c"
 HEAP32[$22>>2] = 0; //@line 61632 "c/sqlite3.c"
 $23 = ((($2)) + 12|0); //@line 61633 "c/sqlite3.c"
 HEAP32[$23>>2] = $$136; //@line 61633 "c/sqlite3.c"
 $24 = ((($2)) + 8|0); //@line 61634 "c/sqlite3.c"
 HEAP32[$24>>2] = $18; //@line 61634 "c/sqlite3.c"
 $25 = ((($0)) + 14|0); //@line 61637 "c/sqlite3.c"
 $26 = HEAP16[$25>>1]|0; //@line 61637 "c/sqlite3.c"
 $27 = $26&65535; //@line 61637 "c/sqlite3.c"
 $28 = ($$136>>>0)>($27>>>0); //@line 61637 "c/sqlite3.c"
 if ($28) {
  _btreeParseCellAdjustSizeForOverflow($0,$1,$2); //@line 61645 "c/sqlite3.c"
  return; //@line 61647 "c/sqlite3.c"
 } else {
  $29 = $18; //@line 61641 "c/sqlite3.c"
  $30 = $1; //@line 61641 "c/sqlite3.c"
  $31 = (($29) - ($30))|0; //@line 61641 "c/sqlite3.c"
  $32 = (($31) + ($$136))|0; //@line 61641 "c/sqlite3.c"
  $33 = $32&65535; //@line 61641 "c/sqlite3.c"
  $34 = ((($2)) + 18|0); //@line 61641 "c/sqlite3.c"
  $35 = $32 & 65532; //@line 61642 "c/sqlite3.c"
  $36 = ($35|0)==(0); //@line 61642 "c/sqlite3.c"
  $spec$select = $36 ? 4 : $33; //@line 61642 "c/sqlite3.c"
  HEAP16[$34>>1] = $spec$select;
  $37 = $$136&65535; //@line 61643 "c/sqlite3.c"
  $38 = ((($2)) + 16|0); //@line 61643 "c/sqlite3.c"
  HEAP16[$38>>1] = $37; //@line 61643 "c/sqlite3.c"
  return; //@line 61647 "c/sqlite3.c"
 }
}
function _sqlite3CorruptError($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3ReportError(11,$0,18266)|0); //@line 146729 "c/sqlite3.c"
 return 11; //@line 146729 "c/sqlite3.c"
}
function _btreeParseCellAdjustSizeForOverflow($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 61499 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 61499 "c/sqlite3.c"
 $5 = $4&65535; //@line 61499 "c/sqlite3.c"
 $6 = ((($0)) + 14|0); //@line 61500 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 61500 "c/sqlite3.c"
 $8 = $7&65535; //@line 61500 "c/sqlite3.c"
 $9 = ((($2)) + 12|0); //@line 61501 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 61501 "c/sqlite3.c"
 $11 = (($10) - ($5))|0; //@line 61501 "c/sqlite3.c"
 $12 = ((($0)) + 52|0); //@line 61501 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 61501 "c/sqlite3.c"
 $14 = ((($13)) + 36|0); //@line 61501 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 61501 "c/sqlite3.c"
 $16 = (($15) + -4)|0; //@line 61501 "c/sqlite3.c"
 $17 = (($11>>>0) % ($16>>>0))&-1; //@line 61501 "c/sqlite3.c"
 $18 = (($17) + ($5))|0; //@line 61501 "c/sqlite3.c"
 $19 = ($18|0)>($8|0); //@line 61504 "c/sqlite3.c"
 $20 = $18&65535; //@line 61505 "c/sqlite3.c"
 $$sink = $19 ? $4 : $20; //@line 61504 "c/sqlite3.c"
 $21 = ((($2)) + 16|0);
 HEAP16[$21>>1] = $$sink;
 $22 = ((($2)) + 8|0); //@line 61509 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 61509 "c/sqlite3.c"
 $24 = $$sink&65535; //@line 61509 "c/sqlite3.c"
 $25 = (($23) + ($24)|0); //@line 61509 "c/sqlite3.c"
 $26 = $25; //@line 61509 "c/sqlite3.c"
 $27 = $1; //@line 61509 "c/sqlite3.c"
 $28 = (4 - ($27))|0; //@line 61509 "c/sqlite3.c"
 $29 = (($28) + ($26))|0; //@line 61509 "c/sqlite3.c"
 $30 = $29&65535; //@line 61509 "c/sqlite3.c"
 $31 = ((($2)) + 18|0); //@line 61509 "c/sqlite3.c"
 HEAP16[$31>>1] = $30; //@line 61509 "c/sqlite3.c"
 return; //@line 61510 "c/sqlite3.c"
}
function _sqlite3GetVarint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $100 = 0, $101 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0;
 var $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 29347 "c/sqlite3.c"
 $3 = $2&255; //@line 29347 "c/sqlite3.c"
 $4 = $3 & 128; //@line 29349 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 29349 "c/sqlite3.c"
 do {
  if ($5) {
   $6 = $2&255; //@line 29351 "c/sqlite3.c"
   $$0 = 1;$101 = 0;$98 = $6;
  } else {
   $7 = ((($0)) + 1|0); //@line 29355 "c/sqlite3.c"
   $8 = HEAP8[$7>>0]|0; //@line 29356 "c/sqlite3.c"
   $9 = $8&255; //@line 29356 "c/sqlite3.c"
   $10 = $9 & 128; //@line 29358 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 29358 "c/sqlite3.c"
   if ($11) {
    $12 = $3 << 7; //@line 29361 "c/sqlite3.c"
    $13 = $12 & 16256; //@line 29361 "c/sqlite3.c"
    $14 = $13 | $9; //@line 29362 "c/sqlite3.c"
    $$0 = 2;$101 = 0;$98 = $14;
    break;
   }
   $15 = ((($0)) + 2|0); //@line 29371 "c/sqlite3.c"
   $16 = $3 << 14; //@line 29372 "c/sqlite3.c"
   $17 = HEAP8[$15>>0]|0; //@line 29373 "c/sqlite3.c"
   $18 = $17&255; //@line 29373 "c/sqlite3.c"
   $19 = $16 | $18; //@line 29373 "c/sqlite3.c"
   $20 = $18 & 128; //@line 29375 "c/sqlite3.c"
   $21 = ($20|0)==(0); //@line 29375 "c/sqlite3.c"
   $22 = $19 & 2080895;
   if ($21) {
    $23 = $9 << 7; //@line 29379 "c/sqlite3.c"
    $24 = $23 & 16256; //@line 29379 "c/sqlite3.c"
    $25 = $22 | $24; //@line 29380 "c/sqlite3.c"
    $$0 = 3;$101 = 0;$98 = $25;
    break;
   }
   $26 = ((($0)) + 3|0); //@line 29387 "c/sqlite3.c"
   $27 = $9 << 14; //@line 29388 "c/sqlite3.c"
   $28 = HEAP8[$26>>0]|0; //@line 29389 "c/sqlite3.c"
   $29 = $28&255; //@line 29389 "c/sqlite3.c"
   $30 = $27 | $29; //@line 29389 "c/sqlite3.c"
   $31 = $29 & 128; //@line 29391 "c/sqlite3.c"
   $32 = ($31|0)==(0); //@line 29391 "c/sqlite3.c"
   $33 = $30 & 2080895;
   if ($32) {
    $34 = $22 << 7; //@line 29396 "c/sqlite3.c"
    $35 = $33 | $34; //@line 29397 "c/sqlite3.c"
    $$0 = 4;$101 = 0;$98 = $35;
    break;
   }
   $36 = ((($0)) + 4|0); //@line 29411 "c/sqlite3.c"
   $37 = $22 << 14; //@line 29412 "c/sqlite3.c"
   $38 = HEAP8[$36>>0]|0; //@line 29413 "c/sqlite3.c"
   $39 = $38&255; //@line 29413 "c/sqlite3.c"
   $40 = $37 | $39; //@line 29413 "c/sqlite3.c"
   $41 = $39 & 128; //@line 29415 "c/sqlite3.c"
   $42 = ($41|0)==(0); //@line 29415 "c/sqlite3.c"
   if ($42) {
    $43 = $33 << 7; //@line 29421 "c/sqlite3.c"
    $44 = $40 | $43; //@line 29422 "c/sqlite3.c"
    $45 = $22 >>> 18; //@line 29423 "c/sqlite3.c"
    $$0 = 5;$101 = $45;$98 = $44;
    break;
   }
   $46 = $22 << 7; //@line 29429 "c/sqlite3.c"
   $47 = $33 | $46; //@line 29430 "c/sqlite3.c"
   $48 = ((($0)) + 5|0); //@line 29433 "c/sqlite3.c"
   $49 = $33 << 14; //@line 29434 "c/sqlite3.c"
   $50 = HEAP8[$48>>0]|0; //@line 29435 "c/sqlite3.c"
   $51 = $50&255; //@line 29435 "c/sqlite3.c"
   $52 = $49 | $51; //@line 29435 "c/sqlite3.c"
   $53 = $51 & 128; //@line 29437 "c/sqlite3.c"
   $54 = ($53|0)==(0); //@line 29437 "c/sqlite3.c"
   if ($54) {
    $55 = $40 << 7; //@line 29442 "c/sqlite3.c"
    $56 = $55 & 266354560; //@line 29442 "c/sqlite3.c"
    $57 = $52 | $56; //@line 29443 "c/sqlite3.c"
    $58 = $47 >>> 18; //@line 29444 "c/sqlite3.c"
    $$0 = 6;$101 = $58;$98 = $57;
    break;
   }
   $59 = ((($0)) + 6|0); //@line 29449 "c/sqlite3.c"
   $60 = $40 << 14; //@line 29450 "c/sqlite3.c"
   $61 = HEAP8[$59>>0]|0; //@line 29451 "c/sqlite3.c"
   $62 = $61&255; //@line 29451 "c/sqlite3.c"
   $63 = $60 | $62; //@line 29451 "c/sqlite3.c"
   $64 = $62 & 128; //@line 29453 "c/sqlite3.c"
   $65 = ($64|0)==(0); //@line 29453 "c/sqlite3.c"
   if ($65) {
    $66 = $63 & -266354561; //@line 29455 "c/sqlite3.c"
    $67 = $52 << 7; //@line 29457 "c/sqlite3.c"
    $68 = $67 & 266354560; //@line 29457 "c/sqlite3.c"
    $69 = $66 | $68; //@line 29458 "c/sqlite3.c"
    $70 = $47 >>> 11; //@line 29459 "c/sqlite3.c"
    $$0 = 7;$101 = $70;$98 = $69;
    break;
   }
   $71 = $63 & 2080895; //@line 29465 "c/sqlite3.c"
   $72 = ((($0)) + 7|0); //@line 29466 "c/sqlite3.c"
   $73 = $52 << 14; //@line 29467 "c/sqlite3.c"
   $74 = HEAP8[$72>>0]|0; //@line 29468 "c/sqlite3.c"
   $75 = $74&255; //@line 29468 "c/sqlite3.c"
   $76 = $73 | $75; //@line 29468 "c/sqlite3.c"
   $77 = $75 & 128; //@line 29470 "c/sqlite3.c"
   $78 = ($77|0)==(0); //@line 29470 "c/sqlite3.c"
   if ($78) {
    $79 = $76 & -266354561; //@line 29472 "c/sqlite3.c"
    $80 = $71 << 7; //@line 29475 "c/sqlite3.c"
    $81 = $79 | $80; //@line 29476 "c/sqlite3.c"
    $82 = $47 >>> 4; //@line 29477 "c/sqlite3.c"
    $$0 = 8;$101 = $82;$98 = $81;
    break;
   } else {
    $83 = ((($0)) + 8|0); //@line 29482 "c/sqlite3.c"
    $84 = $71 << 15; //@line 29483 "c/sqlite3.c"
    $85 = HEAP8[$83>>0]|0; //@line 29484 "c/sqlite3.c"
    $86 = $85&255; //@line 29484 "c/sqlite3.c"
    $87 = $76 << 8; //@line 29490 "c/sqlite3.c"
    $88 = $87 & 532709120; //@line 29490 "c/sqlite3.c"
    $89 = $88 | $84; //@line 29484 "c/sqlite3.c"
    $90 = $89 | $86; //@line 29491 "c/sqlite3.c"
    $91 = $47 << 4; //@line 29493 "c/sqlite3.c"
    $92 = $38 & 120; //@line 29495 "c/sqlite3.c"
    $93 = $92&255; //@line 29495 "c/sqlite3.c"
    $94 = $93 >>> 3; //@line 29496 "c/sqlite3.c"
    $95 = $94 | $91; //@line 29497 "c/sqlite3.c"
    $$0 = 9;$101 = $95;$98 = $90;
    break;
   }
  }
 } while(0);
 $96 = $1;
 $97 = $96;
 HEAP32[$97>>2] = $98;
 $99 = (($96) + 4)|0;
 $100 = $99;
 HEAP32[$100>>2] = $101;
 return ($$0|0); //@line 29502 "c/sqlite3.c"
}
function _subjournalPageIfRequired($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_subjRequiresPage($0)|0); //@line 52498 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 52498 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
 } else {
  $3 = (_subjournalPage($0)|0); //@line 52499 "c/sqlite3.c"
  $$0 = $3;
 }
 return ($$0|0); //@line 52503 "c/sqlite3.c"
}
function _pagerWriteLargeSector($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $$0$lcssa85 = 0, $$066 = 0, $$06775 = 0, $$069$lcssa = 0, $$06974 = 0, $$1 = 0, $$16873 = 0, $$3 = 0, $$lcssa = 0, $$neg = 0, $$neg$demorgan = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $exitcond = 0, $or$cond = 0, $or$cond79 = 0, $spec$select = 0, $spec$select71 = 0, $spec$select72 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 20|0); //@line 53987 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 53987 "c/sqlite3.c"
 $4 = ((($3)) + 148|0); //@line 53988 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 53988 "c/sqlite3.c"
 $6 = ((($3)) + 152|0); //@line 53988 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 53988 "c/sqlite3.c"
 $8 = (($5>>>0) / ($7>>>0))&-1; //@line 53988 "c/sqlite3.c"
 $9 = ((($3)) + 20|0); //@line 53996 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 53996 "c/sqlite3.c"
 $11 = $10 | 4; //@line 53996 "c/sqlite3.c"
 HEAP8[$9>>0] = $11; //@line 53996 "c/sqlite3.c"
 $12 = ((($0)) + 24|0); //@line 54002 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 54002 "c/sqlite3.c"
 $14 = (($13) + -1)|0; //@line 54002 "c/sqlite3.c"
 $15 = (0 - ($8))|0; //@line 54002 "c/sqlite3.c"
 $16 = $14 & $15; //@line 54002 "c/sqlite3.c"
 $17 = (($16) + 1)|0; //@line 54002 "c/sqlite3.c"
 $$neg$demorgan = $14 & $15;
 $$neg = $$neg$demorgan ^ -1;
 $18 = ((($3)) + 24|0); //@line 54004 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 54004 "c/sqlite3.c"
 $20 = ($13>>>0)>($19>>>0); //@line 54005 "c/sqlite3.c"
 if ($20) {
  $21 = (($13) + 1)|0; //@line 54006 "c/sqlite3.c"
  $22 = (($21) + ($$neg))|0; //@line 54006 "c/sqlite3.c"
  $$066 = $22;
 } else {
  $23 = (($16) + ($8))|0; //@line 54007 "c/sqlite3.c"
  $24 = ($23>>>0)>($19>>>0); //@line 54007 "c/sqlite3.c"
  $25 = (($19) + 1)|0; //@line 54008 "c/sqlite3.c"
  $26 = (($25) + ($$neg))|0; //@line 54008 "c/sqlite3.c"
  $spec$select72 = $24 ? $26 : $8; //@line 54007 "c/sqlite3.c"
  $$066 = $spec$select72;
 }
 $27 = ($$066|0)>(0); //@line 54016 "c/sqlite3.c"
 if (!($27)) {
  $$0$lcssa85 = 0;
  $68 = HEAP8[$9>>0]|0; //@line 54056 "c/sqlite3.c"
  $69 = $68 & -5; //@line 54056 "c/sqlite3.c"
  HEAP8[$9>>0] = $69; //@line 54056 "c/sqlite3.c"
  STACKTOP = sp;return ($$0$lcssa85|0); //@line 54057 "c/sqlite3.c"
 }
 $28 = ((($3)) + 56|0);
 $$06775 = 0;$$06974 = 0;
 while(1) {
  $29 = (($$06775) + ($17))|0; //@line 54017 "c/sqlite3.c"
  $30 = HEAP32[$12>>2]|0; //@line 54019 "c/sqlite3.c"
  $31 = ($29|0)==($30|0); //@line 54019 "c/sqlite3.c"
  if ($31) {
   label = 8;
  } else {
   $32 = HEAP32[$28>>2]|0; //@line 54019 "c/sqlite3.c"
   $33 = (_sqlite3BitvecTest($32,$29)|0); //@line 54019 "c/sqlite3.c"
   $34 = ($33|0)==(0); //@line 54019 "c/sqlite3.c"
   if ($34) {
    label = 8;
   } else {
    $49 = (_sqlite3PagerLookup($3,$29)|0); //@line 54030 "c/sqlite3.c"
    HEAP32[$1>>2] = $49; //@line 54030 "c/sqlite3.c"
    $50 = ($49|0)==(0|0); //@line 54030 "c/sqlite3.c"
    if ($50) {
     $$1 = 0;$$3 = $$06974;
    } else {
     $51 = ((($49)) + 28|0); //@line 54031 "c/sqlite3.c"
     $52 = HEAP16[$51>>1]|0; //@line 54031 "c/sqlite3.c"
     $53 = $52 & 8; //@line 54031 "c/sqlite3.c"
     $54 = ($53<<16>>16)==(0); //@line 54031 "c/sqlite3.c"
     $spec$select71 = $54 ? $$06974 : 1; //@line 54031 "c/sqlite3.c"
     _sqlite3PagerUnrefNotNull($49); //@line 54034 "c/sqlite3.c"
     $$1 = 0;$$3 = $spec$select71;
    }
   }
  }
  if ((label|0) == 8) {
   label = 0;
   $35 = HEAP32[513]|0; //@line 54020 "c/sqlite3.c"
   $36 = HEAP32[$6>>2]|0; //@line 54020 "c/sqlite3.c"
   $37 = (($35|0) / ($36|0))&-1; //@line 54020 "c/sqlite3.c"
   $38 = (($37) + 1)|0; //@line 54020 "c/sqlite3.c"
   $39 = ($29|0)==($38|0); //@line 54020 "c/sqlite3.c"
   if ($39) {
    $$1 = 0;$$3 = $$06974;
   } else {
    $40 = (_sqlite3PagerGet($3,$29,$1,0)|0); //@line 54021 "c/sqlite3.c"
    $41 = ($40|0)==(0); //@line 54022 "c/sqlite3.c"
    if (!($41)) {
     label = 10;
     break;
    }
    $42 = HEAP32[$1>>2]|0; //@line 54023 "c/sqlite3.c"
    $43 = (_pager_write($42)|0); //@line 54023 "c/sqlite3.c"
    $44 = HEAP32[$1>>2]|0; //@line 54024 "c/sqlite3.c"
    $45 = ((($44)) + 28|0); //@line 54024 "c/sqlite3.c"
    $46 = HEAP16[$45>>1]|0; //@line 54024 "c/sqlite3.c"
    $47 = $46 & 8; //@line 54024 "c/sqlite3.c"
    $48 = ($47<<16>>16)==(0); //@line 54024 "c/sqlite3.c"
    $spec$select = $48 ? $$06974 : 1; //@line 54024 "c/sqlite3.c"
    _sqlite3PagerUnrefNotNull($44); //@line 54027 "c/sqlite3.c"
    $$1 = $43;$$3 = $spec$select;
   }
  }
  $55 = (($$06775) + 1)|0; //@line 54016 "c/sqlite3.c"
  $56 = ($55|0)<($$066|0); //@line 54016 "c/sqlite3.c"
  $57 = ($$1|0)==(0); //@line 54016 "c/sqlite3.c"
  $58 = $56 & $57; //@line 54016 "c/sqlite3.c"
  if ($58) {
   $$06775 = $55;$$06974 = $$3;
  } else {
   $$0$lcssa = $$1;$$069$lcssa = $$3;$$lcssa = $57;
   break;
  }
 }
 if ((label|0) == 10) {
  $$0$lcssa = $40;$$069$lcssa = $$06974;$$lcssa = 0;
 }
 $59 = ($$069$lcssa|0)!=(0); //@line 54044 "c/sqlite3.c"
 $or$cond = $59 & $$lcssa; //@line 54044 "c/sqlite3.c"
 $60 = ($$066|0)>(0); //@line 54046 "c/sqlite3.c"
 $or$cond79 = $or$cond & $60; //@line 54044 "c/sqlite3.c"
 if (!($or$cond79)) {
  $$0$lcssa85 = $$0$lcssa;
  $68 = HEAP8[$9>>0]|0; //@line 54056 "c/sqlite3.c"
  $69 = $68 & -5; //@line 54056 "c/sqlite3.c"
  HEAP8[$9>>0] = $69; //@line 54056 "c/sqlite3.c"
  STACKTOP = sp;return ($$0$lcssa85|0); //@line 54057 "c/sqlite3.c"
 }
 $$16873 = 0;
 while(1) {
  $61 = (($$16873) + ($17))|0; //@line 54047 "c/sqlite3.c"
  $62 = (_sqlite3PagerLookup($3,$61)|0); //@line 54047 "c/sqlite3.c"
  $63 = ($62|0)==(0|0); //@line 54048 "c/sqlite3.c"
  if (!($63)) {
   $64 = ((($62)) + 28|0); //@line 54049 "c/sqlite3.c"
   $65 = HEAP16[$64>>1]|0; //@line 54049 "c/sqlite3.c"
   $66 = $65 | 8; //@line 54049 "c/sqlite3.c"
   HEAP16[$64>>1] = $66; //@line 54049 "c/sqlite3.c"
   _sqlite3PagerUnrefNotNull($62); //@line 54050 "c/sqlite3.c"
  }
  $67 = (($$16873) + 1)|0; //@line 54046 "c/sqlite3.c"
  $exitcond = ($67|0)==($$066|0); //@line 54046 "c/sqlite3.c"
  if ($exitcond) {
   $$0$lcssa85 = $$0$lcssa;
   break;
  } else {
   $$16873 = $67;
  }
 }
 $68 = HEAP8[$9>>0]|0; //@line 54056 "c/sqlite3.c"
 $69 = $68 & -5; //@line 54056 "c/sqlite3.c"
 HEAP8[$9>>0] = $69; //@line 54056 "c/sqlite3.c"
 STACKTOP = sp;return ($$0$lcssa85|0); //@line 54057 "c/sqlite3.c"
}
function _pager_write($0) {
 $0 = $0|0;
 var $$027 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 53889 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 53889 "c/sqlite3.c"
 $3 = ((($2)) + 16|0); //@line 53914 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 53914 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(2); //@line 53914 "c/sqlite3.c"
 if ($5) {
  $6 = (_pager_open_journal($2)|0); //@line 53915 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 53916 "c/sqlite3.c"
  if (!($7)) {
   $$027 = $6;
   return ($$027|0); //@line 53967 "c/sqlite3.c"
  }
 }
 _sqlite3PcacheMakeDirty($0); //@line 53922 "c/sqlite3.c"
 $8 = ((($2)) + 56|0); //@line 53929 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 53929 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 53929 "c/sqlite3.c"
 do {
  if (!($10)) {
   $11 = ((($0)) + 24|0); //@line 53930 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 53930 "c/sqlite3.c"
   $13 = (_sqlite3BitvecTestNotNull($9,$12)|0); //@line 53930 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 53930 "c/sqlite3.c"
   if ($14) {
    $15 = ((($2)) + 28|0); //@line 53933 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 53933 "c/sqlite3.c"
    $17 = ($12>>>0)>($16>>>0); //@line 53933 "c/sqlite3.c"
    if ($17) {
     $20 = HEAP8[$3>>0]|0; //@line 53939 "c/sqlite3.c"
     $21 = ($20<<24>>24)==(4); //@line 53939 "c/sqlite3.c"
     if ($21) {
      break;
     }
     $22 = ((($0)) + 28|0); //@line 53940 "c/sqlite3.c"
     $23 = HEAP16[$22>>1]|0; //@line 53940 "c/sqlite3.c"
     $24 = $23 | 8; //@line 53940 "c/sqlite3.c"
     HEAP16[$22>>1] = $24; //@line 53940 "c/sqlite3.c"
     break;
    } else {
     $18 = (_pagerAddPageToRollbackJournal($0)|0); //@line 53934 "c/sqlite3.c"
     $19 = ($18|0)==(0); //@line 53935 "c/sqlite3.c"
     if ($19) {
      break;
     } else {
      $$027 = $18;
     }
     return ($$027|0); //@line 53967 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $25 = ((($0)) + 28|0); //@line 53953 "c/sqlite3.c"
 $26 = HEAP16[$25>>1]|0; //@line 53953 "c/sqlite3.c"
 $27 = $26 | 4; //@line 53953 "c/sqlite3.c"
 HEAP16[$25>>1] = $27; //@line 53953 "c/sqlite3.c"
 $28 = ((($2)) + 96|0); //@line 53958 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 53958 "c/sqlite3.c"
 $30 = ($29|0)>(0); //@line 53958 "c/sqlite3.c"
 if ($30) {
  $31 = (_subjournalPageIfRequired($0)|0); //@line 53959 "c/sqlite3.c"
  $$2 = $31;
 } else {
  $$2 = 0;
 }
 $32 = ((($2)) + 24|0); //@line 53963 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 53963 "c/sqlite3.c"
 $34 = ((($0)) + 24|0); //@line 53963 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 53963 "c/sqlite3.c"
 $36 = ($33>>>0)<($35>>>0); //@line 53963 "c/sqlite3.c"
 if (!($36)) {
  $$027 = $$2;
  return ($$027|0); //@line 53967 "c/sqlite3.c"
 }
 HEAP32[$32>>2] = $35; //@line 53964 "c/sqlite3.c"
 $$027 = $$2;
 return ($$027|0); //@line 53967 "c/sqlite3.c"
}
function _pager_open_journal($0) {
 $0 = $0|0;
 var $$038 = 0, $$246 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $spec$select = 0, $spec$select47 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 53675 "c/sqlite3.c"
 $2 = ((($0)) + 40|0); //@line 53684 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 53684 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 53684 "c/sqlite3.c"
 if (!($4)) {
  $$038 = $3;
  return ($$038|0); //@line 53743 "c/sqlite3.c"
 }
 $5 = ((($0)) + 212|0); //@line 53686 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 53686 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 53686 "c/sqlite3.c"
 do {
  if ($7) {
   $8 = ((($0)) + 5|0); //@line 53686 "c/sqlite3.c"
   $9 = HEAP8[$8>>0]|0; //@line 53686 "c/sqlite3.c"
   $10 = ($9<<24>>24)==(2); //@line 53686 "c/sqlite3.c"
   if (!($10)) {
    $11 = ((($0)) + 24|0); //@line 53687 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 53687 "c/sqlite3.c"
    $13 = (_sqlite3BitvecCreate($12)|0); //@line 53687 "c/sqlite3.c"
    $14 = ((($0)) + 56|0); //@line 53687 "c/sqlite3.c"
    HEAP32[$14>>2] = $13; //@line 53687 "c/sqlite3.c"
    $15 = ($13|0)==(0|0); //@line 53688 "c/sqlite3.c"
    if ($15) {
     $$038 = 7;
     return ($$038|0); //@line 53743 "c/sqlite3.c"
    }
    $16 = ((($0)) + 64|0); //@line 53693 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 53693 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 53693 "c/sqlite3.c"
    $19 = ($18|0)==(0|0); //@line 53693 "c/sqlite3.c"
    do {
     if ($19) {
      $20 = HEAP8[$8>>0]|0; //@line 53694 "c/sqlite3.c"
      $21 = ($20<<24>>24)==(4); //@line 53694 "c/sqlite3.c"
      if ($21) {
       _sqlite3MemJournalOpen($17); //@line 53695 "c/sqlite3.c"
       label = 10;
       break;
      }
      $22 = ((($0)) + 12|0); //@line 53700 "c/sqlite3.c"
      $23 = HEAP8[$22>>0]|0; //@line 53700 "c/sqlite3.c"
      $24 = ($23<<24>>24)==(0); //@line 53700 "c/sqlite3.c"
      $25 = HEAP32[(48)>>2]|0; //@line 53702 "c/sqlite3.c"
      $26 = (_databaseIsUnmoved($0)|0); //@line 53710 "c/sqlite3.c"
      $27 = ($26|0)==(0); //@line 53711 "c/sqlite3.c"
      if ($27) {
       $spec$select47 = $24 ? 0 : $25; //@line 53700 "c/sqlite3.c"
       $spec$select = $24 ? 2054 : 4110; //@line 53700 "c/sqlite3.c"
       $28 = ((($0)) + 172|0); //@line 53713 "c/sqlite3.c"
       $29 = HEAP32[$28>>2]|0; //@line 53713 "c/sqlite3.c"
       $30 = HEAP32[$16>>2]|0; //@line 53713 "c/sqlite3.c"
       $31 = (_sqlite3JournalOpen($1,$29,$30,$spec$select,$spec$select47)|0); //@line 53712 "c/sqlite3.c"
       $32 = ($31|0)==(0); //@line 53724 "c/sqlite3.c"
       if ($32) {
        label = 10;
       } else {
        $$246 = $31;
       }
      } else {
       $$246 = $26;
      }
     } else {
      label = 10;
     }
    } while(0);
    if ((label|0) == 10) {
     $33 = ((($0)) + 44|0); //@line 53726 "c/sqlite3.c"
     HEAP32[$33>>2] = 0; //@line 53726 "c/sqlite3.c"
     $34 = ((($0)) + 72|0); //@line 53727 "c/sqlite3.c"
     $35 = ((($0)) + 19|0); //@line 53728 "c/sqlite3.c"
     HEAP8[$35>>0] = 0; //@line 53728 "c/sqlite3.c"
     ;HEAP32[$34>>2]=0|0;HEAP32[$34+4>>2]=0|0;HEAP32[$34+8>>2]=0|0;HEAP32[$34+12>>2]=0|0; //@line 53727 "c/sqlite3.c"
     $36 = (_writeJournalHdr($0)|0); //@line 53730 "c/sqlite3.c"
     $37 = ($36|0)==(0); //@line 53734 "c/sqlite3.c"
     if ($37) {
      break;
     } else {
      $$246 = $36;
     }
    }
    $38 = ((($0)) + 56|0); //@line 53735 "c/sqlite3.c"
    $39 = HEAP32[$38>>2]|0; //@line 53735 "c/sqlite3.c"
    _sqlite3BitvecDestroy($39); //@line 53735 "c/sqlite3.c"
    HEAP32[$38>>2] = 0; //@line 53736 "c/sqlite3.c"
    $$038 = $$246;
    return ($$038|0); //@line 53743 "c/sqlite3.c"
   }
  }
 } while(0);
 $40 = ((($0)) + 16|0); //@line 53739 "c/sqlite3.c"
 HEAP8[$40>>0] = 3; //@line 53739 "c/sqlite3.c"
 $$038 = 0;
 return ($$038|0); //@line 53743 "c/sqlite3.c"
}
function _sqlite3PcacheMakeDirty($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 28|0); //@line 45729 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 45729 "c/sqlite3.c"
 $3 = $2&65535; //@line 45729 "c/sqlite3.c"
 $4 = $3 & 17; //@line 45729 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 45729 "c/sqlite3.c"
 if ($5) {
  return; //@line 45739 "c/sqlite3.c"
 }
 $6 = $3 & 65519; //@line 45730 "c/sqlite3.c"
 $7 = $6&65535; //@line 45730 "c/sqlite3.c"
 HEAP16[$1>>1] = $7; //@line 45730 "c/sqlite3.c"
 $8 = $3 & 1; //@line 45731 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 45731 "c/sqlite3.c"
 if ($9) {
  return; //@line 45739 "c/sqlite3.c"
 }
 $10 = $6 ^ 3; //@line 45732 "c/sqlite3.c"
 $11 = $10&65535; //@line 45732 "c/sqlite3.c"
 HEAP16[$1>>1] = $11; //@line 45732 "c/sqlite3.c"
 _pcacheManageDirtyList($0,2); //@line 45735 "c/sqlite3.c"
 return; //@line 45739 "c/sqlite3.c"
}
function _sqlite3BitvecTestNotNull($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$028$lcssa = 0, $$02838 = 0, $$029$lcssa = 0, $$02937 = 0, $$033 = 0, $$034 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (($1) + -1)|0; //@line 44896 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 44897 "c/sqlite3.c"
 $4 = ($2>>>0)<($3>>>0); //@line 44897 "c/sqlite3.c"
 if (!($4)) {
  $$3 = 0;
  return ($$3|0); //@line 44916 "c/sqlite3.c"
 }
 $5 = ((($0)) + 8|0); //@line 44898 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 44898 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 44898 "c/sqlite3.c"
 L4: do {
  if ($7) {
   $$028$lcssa = $2;$$029$lcssa = $0;
  } else {
   $$02838 = $2;$$02937 = $0;$9 = $6;
   while(1) {
    $8 = (($$02838>>>0) / ($9>>>0))&-1; //@line 44899 "c/sqlite3.c"
    $10 = ((($$02937)) + 12|0); //@line 44901 "c/sqlite3.c"
    $11 = (($10) + ($8<<2)|0); //@line 44901 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 44901 "c/sqlite3.c"
    $13 = ($12|0)==(0|0); //@line 44902 "c/sqlite3.c"
    if ($13) {
     $$3 = 0;
     break;
    }
    $14 = Math_imul($8, $9)|0;
    $15 = (($$02838) - ($14))|0;
    $16 = ((($12)) + 8|0); //@line 44898 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 44898 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 44898 "c/sqlite3.c"
    if ($18) {
     $$028$lcssa = $15;$$029$lcssa = $12;
     break L4;
    } else {
     $$02838 = $15;$$02937 = $12;$9 = $17;
    }
   }
   return ($$3|0); //@line 44916 "c/sqlite3.c"
  }
 } while(0);
 $19 = HEAP32[$$029$lcssa>>2]|0; //@line 44906 "c/sqlite3.c"
 $20 = ($19>>>0)<(4001); //@line 44906 "c/sqlite3.c"
 if ($20) {
  $21 = ((($$029$lcssa)) + 12|0); //@line 44907 "c/sqlite3.c"
  $22 = $$028$lcssa >>> 3; //@line 44907 "c/sqlite3.c"
  $23 = (($21) + ($22)|0); //@line 44907 "c/sqlite3.c"
  $24 = HEAP8[$23>>0]|0; //@line 44907 "c/sqlite3.c"
  $25 = $24&255; //@line 44907 "c/sqlite3.c"
  $26 = $$028$lcssa & 7; //@line 44907 "c/sqlite3.c"
  $27 = 1 << $26; //@line 44907 "c/sqlite3.c"
  $28 = $27 & $25; //@line 44907 "c/sqlite3.c"
  $29 = ($28|0)!=(0); //@line 44907 "c/sqlite3.c"
  $30 = $29&1; //@line 44907 "c/sqlite3.c"
  $$3 = $30;
  return ($$3|0); //@line 44916 "c/sqlite3.c"
 }
 $31 = (($$028$lcssa) + 1)|0; //@line 44909 "c/sqlite3.c"
 $$033 = (($$028$lcssa>>>0) % 125)&-1;
 $32 = (((($$029$lcssa)) + 12|0) + ($$033<<2)|0); //@line 44910 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 44910 "c/sqlite3.c"
 $34 = ($33|0)==(0); //@line 44910 "c/sqlite3.c"
 if ($34) {
  $$3 = 0;
  return ($$3|0); //@line 44916 "c/sqlite3.c"
 }
 $$034 = $$033;$40 = $33;
 while(1) {
  $39 = ($40|0)==($31|0); //@line 44911 "c/sqlite3.c"
  if ($39) {
   $$3 = 1;
   label = 12;
   break;
  }
  $35 = (($$034) + 1)|0; //@line 44912 "c/sqlite3.c"
  $$0 = (($35>>>0) % 125)&-1;
  $36 = (((($$029$lcssa)) + 12|0) + ($$0<<2)|0); //@line 44910 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 44910 "c/sqlite3.c"
  $38 = ($37|0)==(0); //@line 44910 "c/sqlite3.c"
  if ($38) {
   $$3 = 0;
   label = 12;
   break;
  } else {
   $$034 = $$0;$40 = $37;
  }
 }
 if ((label|0) == 12) {
  return ($$3|0); //@line 44916 "c/sqlite3.c"
 }
 return (0)|0;
}
function _pagerAddPageToRollbackJournal($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 53832 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 53832 "c/sqlite3.c"
 $3 = ((($2)) + 72|0); //@line 53836 "c/sqlite3.c"
 $4 = $3; //@line 53836 "c/sqlite3.c"
 $5 = $4; //@line 53836 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 53836 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 53836 "c/sqlite3.c"
 $8 = $7; //@line 53836 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 53836 "c/sqlite3.c"
 $10 = ((($0)) + 4|0); //@line 53844 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 53844 "c/sqlite3.c"
 $12 = (_pager_cksum($2,$11)|0); //@line 53845 "c/sqlite3.c"
 $13 = ((($0)) + 28|0); //@line 53854 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 53854 "c/sqlite3.c"
 $15 = $14 | 8; //@line 53854 "c/sqlite3.c"
 HEAP16[$13>>1] = $15; //@line 53854 "c/sqlite3.c"
 $16 = ((($2)) + 64|0); //@line 53856 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 53856 "c/sqlite3.c"
 $18 = ((($0)) + 24|0); //@line 53856 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 53856 "c/sqlite3.c"
 $20 = (_write32bits($17,$6,$9,$19)|0); //@line 53856 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 53857 "c/sqlite3.c"
 if (!($21)) {
  $$0 = $20;
  return ($$0|0); //@line 53879 "c/sqlite3.c"
 }
 $22 = HEAP32[$16>>2]|0; //@line 53858 "c/sqlite3.c"
 $23 = ((($2)) + 152|0); //@line 53858 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 53858 "c/sqlite3.c"
 $25 = (_i64Add(($6|0),($9|0),4,0)|0); //@line 53858 "c/sqlite3.c"
 $26 = tempRet0; //@line 53858 "c/sqlite3.c"
 $27 = (_sqlite3OsWrite($22,$11,$24,$25,$26)|0); //@line 53858 "c/sqlite3.c"
 $28 = ($27|0)==(0); //@line 53859 "c/sqlite3.c"
 if (!($28)) {
  $$0 = $27;
  return ($$0|0); //@line 53879 "c/sqlite3.c"
 }
 $29 = HEAP32[$16>>2]|0; //@line 53860 "c/sqlite3.c"
 $30 = HEAP32[$23>>2]|0; //@line 53860 "c/sqlite3.c"
 $31 = ($30|0)<(0); //@line 53860 "c/sqlite3.c"
 $32 = $31 << 31 >> 31; //@line 53860 "c/sqlite3.c"
 $33 = (_i64Add(($6|0),($9|0),4,0)|0); //@line 53860 "c/sqlite3.c"
 $34 = tempRet0; //@line 53860 "c/sqlite3.c"
 $35 = (_i64Add(($33|0),($34|0),($30|0),($32|0))|0); //@line 53860 "c/sqlite3.c"
 $36 = tempRet0; //@line 53860 "c/sqlite3.c"
 $37 = (_write32bits($29,$35,$36,$12)|0); //@line 53860 "c/sqlite3.c"
 $38 = ($37|0)==(0); //@line 53861 "c/sqlite3.c"
 if (!($38)) {
  $$0 = $37;
  return ($$0|0); //@line 53879 "c/sqlite3.c"
 }
 $39 = HEAP32[$23>>2]|0; //@line 53870 "c/sqlite3.c"
 $40 = (($39) + 8)|0; //@line 53870 "c/sqlite3.c"
 $41 = ($40|0)<(0); //@line 53870 "c/sqlite3.c"
 $42 = $41 << 31 >> 31; //@line 53870 "c/sqlite3.c"
 $43 = $3; //@line 53870 "c/sqlite3.c"
 $44 = $43; //@line 53870 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 53870 "c/sqlite3.c"
 $46 = (($43) + 4)|0; //@line 53870 "c/sqlite3.c"
 $47 = $46; //@line 53870 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 53870 "c/sqlite3.c"
 $49 = (_i64Add(($45|0),($48|0),($40|0),($42|0))|0); //@line 53870 "c/sqlite3.c"
 $50 = tempRet0; //@line 53870 "c/sqlite3.c"
 $51 = $3; //@line 53870 "c/sqlite3.c"
 $52 = $51; //@line 53870 "c/sqlite3.c"
 HEAP32[$52>>2] = $49; //@line 53870 "c/sqlite3.c"
 $53 = (($51) + 4)|0; //@line 53870 "c/sqlite3.c"
 $54 = $53; //@line 53870 "c/sqlite3.c"
 HEAP32[$54>>2] = $50; //@line 53870 "c/sqlite3.c"
 $55 = ((($2)) + 44|0); //@line 53871 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 53871 "c/sqlite3.c"
 $57 = (($56) + 1)|0; //@line 53871 "c/sqlite3.c"
 HEAP32[$55>>2] = $57; //@line 53871 "c/sqlite3.c"
 $58 = ((($2)) + 56|0); //@line 53873 "c/sqlite3.c"
 $59 = HEAP32[$58>>2]|0; //@line 53873 "c/sqlite3.c"
 $60 = HEAP32[$18>>2]|0; //@line 53873 "c/sqlite3.c"
 $61 = (_sqlite3BitvecSet($59,$60)|0); //@line 53873 "c/sqlite3.c"
 $62 = HEAP32[$18>>2]|0; //@line 53876 "c/sqlite3.c"
 $63 = (_addToSavepointBitvecs($2,$62)|0); //@line 53876 "c/sqlite3.c"
 $64 = $63 | $61; //@line 53876 "c/sqlite3.c"
 $$0 = $64;
 return ($$0|0); //@line 53879 "c/sqlite3.c"
}
function _pager_cksum($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$010$lcssa = 0, $$01012 = 0, $$013 = 0, $$013$in = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 48|0); //@line 50167 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 50167 "c/sqlite3.c"
 $4 = ((($0)) + 152|0); //@line 50168 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 50168 "c/sqlite3.c"
 $6 = ($5|0)>(200); //@line 50169 "c/sqlite3.c"
 if (!($6)) {
  $$010$lcssa = $3;
  return ($$010$lcssa|0); //@line 50173 "c/sqlite3.c"
 }
 $$01012 = $3;$$013$in = $5;
 while(1) {
  $$013 = (($$013$in) + -200)|0;
  $7 = (($1) + ($$013)|0); //@line 50170 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 50170 "c/sqlite3.c"
  $9 = $8&255; //@line 50170 "c/sqlite3.c"
  $10 = (($$01012) + ($9))|0; //@line 50170 "c/sqlite3.c"
  $11 = ($$013$in|0)>(400); //@line 50169 "c/sqlite3.c"
  if ($11) {
   $$01012 = $10;$$013$in = $$013;
  } else {
   $$010$lcssa = $10;
   break;
  }
 }
 return ($$010$lcssa|0); //@line 50173 "c/sqlite3.c"
}
function _write32bits($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 _sqlite3Put4byte($4,$3); //@line 49095 "c/sqlite3.c"
 $5 = (_sqlite3OsWrite($0,$4,4,$1,$2)|0); //@line 49096 "c/sqlite3.c"
 STACKTOP = sp;return ($5|0); //@line 49096 "c/sqlite3.c"
}
function _sqlite3OsWrite($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$0>>2]|0; //@line 20904 "c/sqlite3.c"
 $6 = ((($5)) + 12|0); //@line 20904 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 20904 "c/sqlite3.c"
 $8 = (FUNCTION_TABLE_iiiiii[$7 & 127]($0,$1,$2,$3,$4)|0); //@line 20904 "c/sqlite3.c"
 return ($8|0); //@line 20904 "c/sqlite3.c"
}
function _sqlite3BitvecSet($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$06385 = 0, $$06584 = 0, $$066$lcssa = 0, $$06687 = 0, $$069 = 0, $$072$lcssa = 0, $$07286 = 0, $$164 = 0, $$170 = 0, $$271 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $spec$store$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 44935 "c/sqlite3.c"
 if ($2) {
  $$3 = 0;
  return ($$3|0); //@line 44996 "c/sqlite3.c"
 }
 $3 = (($1) + -1)|0; //@line 44938 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 44939 "c/sqlite3.c"
 $5 = ($4>>>0)>(4000); //@line 44939 "c/sqlite3.c"
 L4: do {
  if ($5) {
   $$06687 = $0;$$07286 = $3;$53 = $0;
   while(1) {
    $6 = ((($$06687)) + 8|0); //@line 44939 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 44939 "c/sqlite3.c"
    $8 = ($7|0)==(0); //@line 44939 "c/sqlite3.c"
    if ($8) {
     break;
    }
    $9 = (($$07286>>>0) / ($7>>>0))&-1; //@line 44940 "c/sqlite3.c"
    $10 = Math_imul($9, $7)|0;
    $11 = (($$07286) - ($10))|0;
    $12 = ((($$06687)) + 12|0); //@line 44942 "c/sqlite3.c"
    $13 = (($12) + ($9<<2)|0); //@line 44942 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 44942 "c/sqlite3.c"
    $15 = ($14|0)==(0|0); //@line 44942 "c/sqlite3.c"
    if ($15) {
     $16 = (_sqlite3BitvecCreate($7)|0); //@line 44943 "c/sqlite3.c"
     HEAP32[$13>>2] = $16; //@line 44943 "c/sqlite3.c"
     $17 = ($16|0)==(0|0); //@line 44944 "c/sqlite3.c"
     if ($17) {
      $$3 = 7;
      label = 22;
      break;
     }
    }
    $18 = HEAP32[$13>>2]|0; //@line 44946 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 44939 "c/sqlite3.c"
    $20 = ($19>>>0)>(4000); //@line 44939 "c/sqlite3.c"
    if ($20) {
     $$06687 = $18;$$07286 = $11;$53 = $18;
    } else {
     $$066$lcssa = $18;$$072$lcssa = $11;
     break L4;
    }
   }
   if ((label|0) == 22) {
    return ($$3|0); //@line 44996 "c/sqlite3.c"
   }
   $30 = (($$07286) + 1)|0; //@line 44952 "c/sqlite3.c"
   $31 = (($$07286>>>0) % 125)&-1; //@line 44952 "c/sqlite3.c"
   $32 = ((($$06687)) + 12|0); //@line 44956 "c/sqlite3.c"
   $33 = (((($$06687)) + 12|0) + ($31<<2)|0); //@line 44956 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 44956 "c/sqlite3.c"
   $35 = ($34|0)==(0); //@line 44956 "c/sqlite3.c"
   L15: do {
    if ($35) {
     $36 = ((($$06687)) + 4|0); //@line 44957 "c/sqlite3.c"
     $37 = HEAP32[$36>>2]|0; //@line 44957 "c/sqlite3.c"
     $38 = ($37>>>0)<(124); //@line 44957 "c/sqlite3.c"
     if ($38) {
      $$271 = $31;
     } else {
      $$170 = $31;
      label = 14;
     }
    } else {
     $$069 = $31;
     while(1) {
      $39 = (((($$06687)) + 12|0) + ($$069<<2)|0); //@line 44966 "c/sqlite3.c"
      $40 = HEAP32[$39>>2]|0; //@line 44966 "c/sqlite3.c"
      $41 = ($40|0)==($30|0); //@line 44966 "c/sqlite3.c"
      if ($41) {
       $$3 = 0;
       break;
      }
      $42 = (($$069) + 1)|0; //@line 44967 "c/sqlite3.c"
      $43 = ($42>>>0)>(124); //@line 44968 "c/sqlite3.c"
      $spec$store$select = $43 ? 0 : $42; //@line 44968 "c/sqlite3.c"
      $44 = (((($$06687)) + 12|0) + ($spec$store$select<<2)|0); //@line 44969 "c/sqlite3.c"
      $45 = HEAP32[$44>>2]|0; //@line 44969 "c/sqlite3.c"
      $46 = ($45|0)==(0); //@line 44969 "c/sqlite3.c"
      if ($46) {
       $$170 = $spec$store$select;
       label = 14;
       break L15;
      } else {
       $$069 = $spec$store$select;
      }
     }
     return ($$3|0); //@line 44996 "c/sqlite3.c"
    }
   } while(0);
   if ((label|0) == 14) {
    $47 = ((($$06687)) + 4|0); //@line 44974 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 44974 "c/sqlite3.c"
    $49 = ($48>>>0)>(61); //@line 44974 "c/sqlite3.c"
    if ($49) {
     $50 = (_sqlite3DbMallocRaw(0,500,0)|0); //@line 44977 "c/sqlite3.c"
     $51 = ($50|0)==(0|0); //@line 44978 "c/sqlite3.c"
     if ($51) {
      $$3 = 7;
      return ($$3|0); //@line 44996 "c/sqlite3.c"
     }
     _memcpy(($50|0),($32|0),500)|0; //@line 44981 "c/sqlite3.c"
     _memset(($32|0),0,500)|0; //@line 44982 "c/sqlite3.c"
     $52 = HEAP32[$53>>2]|0; //@line 44983 "c/sqlite3.c"
     $54 = (($52) + 124)|0; //@line 44983 "c/sqlite3.c"
     $55 = (($54>>>0) / 125)&-1; //@line 44983 "c/sqlite3.c"
     $56 = ((($$06687)) + 8|0); //@line 44983 "c/sqlite3.c"
     HEAP32[$56>>2] = $55; //@line 44983 "c/sqlite3.c"
     $57 = (_sqlite3BitvecSet($$06687,$30)|0); //@line 44984 "c/sqlite3.c"
     $$06385 = $57;$$06584 = 0;
     while(1) {
      $58 = (($50) + ($$06584<<2)|0); //@line 44986 "c/sqlite3.c"
      $59 = HEAP32[$58>>2]|0; //@line 44986 "c/sqlite3.c"
      $60 = ($59|0)==(0); //@line 44986 "c/sqlite3.c"
      if ($60) {
       $$164 = $$06385;
      } else {
       $61 = (_sqlite3BitvecSet($$06687,$59)|0); //@line 44986 "c/sqlite3.c"
       $62 = $61 | $$06385; //@line 44986 "c/sqlite3.c"
       $$164 = $62;
      }
      $63 = (($$06584) + 1)|0; //@line 44985 "c/sqlite3.c"
      $exitcond = ($63|0)==(125); //@line 44985 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$06385 = $$164;$$06584 = $63;
      }
     }
     _sqlite3DbFree(0,$50); //@line 44988 "c/sqlite3.c"
     $$3 = $$164;
     return ($$3|0); //@line 44996 "c/sqlite3.c"
    } else {
     $$271 = $$170;
    }
   }
   $64 = ((($$06687)) + 4|0); //@line 44993 "c/sqlite3.c"
   $65 = HEAP32[$64>>2]|0; //@line 44993 "c/sqlite3.c"
   $66 = (($65) + 1)|0; //@line 44993 "c/sqlite3.c"
   HEAP32[$64>>2] = $66; //@line 44993 "c/sqlite3.c"
   $67 = (((($$06687)) + 12|0) + ($$271<<2)|0); //@line 44994 "c/sqlite3.c"
   HEAP32[$67>>2] = $30; //@line 44994 "c/sqlite3.c"
   $$3 = 0;
   return ($$3|0); //@line 44996 "c/sqlite3.c"
  } else {
   $$066$lcssa = $0;$$072$lcssa = $3;
  }
 } while(0);
 $21 = $$072$lcssa & 7; //@line 44949 "c/sqlite3.c"
 $22 = 1 << $21; //@line 44949 "c/sqlite3.c"
 $23 = ((($$066$lcssa)) + 12|0); //@line 44949 "c/sqlite3.c"
 $24 = $$072$lcssa >>> 3; //@line 44949 "c/sqlite3.c"
 $25 = (($23) + ($24)|0); //@line 44949 "c/sqlite3.c"
 $26 = HEAP8[$25>>0]|0; //@line 44949 "c/sqlite3.c"
 $27 = $26&255; //@line 44949 "c/sqlite3.c"
 $28 = $22 | $27; //@line 44949 "c/sqlite3.c"
 $29 = $28&255; //@line 44949 "c/sqlite3.c"
 HEAP8[$25>>0] = $29; //@line 44949 "c/sqlite3.c"
 $$3 = 0;
 return ($$3|0); //@line 44996 "c/sqlite3.c"
}
function _addToSavepointBitvecs($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$015$lcssa = 0, $$01516 = 0, $$017 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 96|0); //@line 49764 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 49764 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 49764 "c/sqlite3.c"
 if (!($4)) {
  $$015$lcssa = 0;
  return ($$015$lcssa|0); //@line 49772 "c/sqlite3.c"
 }
 $5 = ((($0)) + 92|0);
 $$01516 = 0;$$017 = 0;
 while(1) {
  $6 = HEAP32[$5>>2]|0; //@line 49765 "c/sqlite3.c"
  $7 = (((($6) + (($$017*48)|0)|0)) + 20|0); //@line 49766 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 49766 "c/sqlite3.c"
  $9 = ($8>>>0)<($1>>>0); //@line 49766 "c/sqlite3.c"
  if ($9) {
   $$1 = $$01516;
  } else {
   $10 = (((($6) + (($$017*48)|0)|0)) + 16|0); //@line 49767 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 49767 "c/sqlite3.c"
   $12 = (_sqlite3BitvecSet($11,$1)|0); //@line 49767 "c/sqlite3.c"
   $13 = $12 | $$01516; //@line 49767 "c/sqlite3.c"
   $$1 = $13;
  }
  $14 = (($$017) + 1)|0; //@line 49764 "c/sqlite3.c"
  $15 = HEAP32[$2>>2]|0; //@line 49764 "c/sqlite3.c"
  $16 = ($14|0)<($15|0); //@line 49764 "c/sqlite3.c"
  if ($16) {
   $$01516 = $$1;$$017 = $14;
  } else {
   $$015$lcssa = $$1;
   break;
  }
 }
 return ($$015$lcssa|0); //@line 49772 "c/sqlite3.c"
}
function _sqlite3BitvecCreate($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3MallocZero(512,0)|0); //@line 44882 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 44883 "c/sqlite3.c"
 if (!($2)) {
  HEAP32[$1>>2] = $0; //@line 44884 "c/sqlite3.c"
 }
 return ($1|0); //@line 44886 "c/sqlite3.c"
}
function _pcacheManageDirtyList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$sink32 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 45337 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45337 "c/sqlite3.c"
 $4 = $1&255; //@line 45342 "c/sqlite3.c"
 $5 = $4 & 1; //@line 45342 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 45342 "c/sqlite3.c"
 do {
  if (!($6)) {
   $7 = ((($3)) + 8|0); //@line 45347 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 45347 "c/sqlite3.c"
   $9 = ($8|0)==($0|0); //@line 45347 "c/sqlite3.c"
   if ($9) {
    $10 = ((($0)) + 36|0); //@line 45348 "c/sqlite3.c"
    $11 = HEAP32[$10>>2]|0; //@line 45348 "c/sqlite3.c"
    HEAP32[$7>>2] = $11; //@line 45348 "c/sqlite3.c"
   }
   $12 = ((($0)) + 32|0); //@line 45351 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 45351 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 45351 "c/sqlite3.c"
   $15 = ((($0)) + 36|0);
   $16 = HEAP32[$15>>2]|0;
   $17 = ((($3)) + 4|0); //@line 45355 "c/sqlite3.c"
   $18 = ((($13)) + 36|0); //@line 45352 "c/sqlite3.c"
   $$sink32 = $14 ? $17 : $18; //@line 45351 "c/sqlite3.c"
   HEAP32[$$sink32>>2] = $16;
   $19 = HEAP32[$15>>2]|0; //@line 45357 "c/sqlite3.c"
   $20 = ($19|0)==(0|0); //@line 45357 "c/sqlite3.c"
   if (!($20)) {
    $21 = ((($19)) + 32|0); //@line 45358 "c/sqlite3.c"
    HEAP32[$21>>2] = $13; //@line 45358 "c/sqlite3.c"
    break;
   }
   HEAP32[$3>>2] = $13; //@line 45365 "c/sqlite3.c"
   if ($14) {
    $22 = ((($3)) + 33|0); //@line 45369 "c/sqlite3.c"
    HEAP8[$22>>0] = 2; //@line 45369 "c/sqlite3.c"
   }
  }
 } while(0);
 $23 = $4 & 2; //@line 45373 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 45373 "c/sqlite3.c"
 if ($24) {
  return; //@line 45400 "c/sqlite3.c"
 }
 $25 = ((($0)) + 36|0); //@line 45374 "c/sqlite3.c"
 HEAP32[$25>>2] = 0; //@line 45374 "c/sqlite3.c"
 $26 = HEAP32[$3>>2]|0; //@line 45375 "c/sqlite3.c"
 $27 = ((($0)) + 32|0); //@line 45375 "c/sqlite3.c"
 HEAP32[$27>>2] = $26; //@line 45375 "c/sqlite3.c"
 $28 = ($26|0)==(0|0); //@line 45376 "c/sqlite3.c"
 if ($28) {
  $30 = ((($3)) + 4|0); //@line 45380 "c/sqlite3.c"
  HEAP32[$30>>2] = $0; //@line 45380 "c/sqlite3.c"
  $31 = ((($3)) + 32|0); //@line 45381 "c/sqlite3.c"
  $32 = HEAP8[$31>>0]|0; //@line 45381 "c/sqlite3.c"
  $33 = ($32<<24>>24)==(0); //@line 45381 "c/sqlite3.c"
  if (!($33)) {
   $34 = ((($3)) + 33|0); //@line 45383 "c/sqlite3.c"
   HEAP8[$34>>0] = 1; //@line 45383 "c/sqlite3.c"
  }
 } else {
  $29 = ((($26)) + 36|0); //@line 45378 "c/sqlite3.c"
  HEAP32[$29>>2] = $0; //@line 45378 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = $0; //@line 45386 "c/sqlite3.c"
 $35 = ((($3)) + 8|0); //@line 45393 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 45393 "c/sqlite3.c"
 $37 = ($36|0)==(0|0); //@line 45393 "c/sqlite3.c"
 if (!($37)) {
  return; //@line 45400 "c/sqlite3.c"
 }
 $38 = ((($0)) + 28|0); //@line 45394 "c/sqlite3.c"
 $39 = HEAP16[$38>>1]|0; //@line 45394 "c/sqlite3.c"
 $40 = $39 & 8; //@line 45394 "c/sqlite3.c"
 $41 = ($40<<16>>16)==(0); //@line 45394 "c/sqlite3.c"
 if (!($41)) {
  return; //@line 45400 "c/sqlite3.c"
 }
 HEAP32[$35>>2] = $0; //@line 45396 "c/sqlite3.c"
 return; //@line 45400 "c/sqlite3.c"
}
function _sqlite3MemJournalOpen($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3JournalOpen(0,0,$0,0,-1)|0); //@line 90940 "c/sqlite3.c"
 return; //@line 90941 "c/sqlite3.c"
}
function _databaseIsUnmoved($0) {
 $0 = $0|0;
 var $$08 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 52942 "c/sqlite3.c"
 $2 = ((($0)) + 12|0); //@line 52945 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 52945 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 52945 "c/sqlite3.c"
 if (!($4)) {
  $$08 = 0;
  STACKTOP = sp;return ($$08|0); //@line 52958 "c/sqlite3.c"
 }
 $5 = ((($0)) + 24|0); //@line 52946 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 52946 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 52946 "c/sqlite3.c"
 if ($7) {
  $$08 = 0;
  STACKTOP = sp;return ($$08|0); //@line 52958 "c/sqlite3.c"
 }
 $8 = ((($0)) + 60|0); //@line 52948 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 52948 "c/sqlite3.c"
 $10 = (_sqlite3OsFileControl($9,20,$1)|0); //@line 52948 "c/sqlite3.c"
 $11 = ($10|0)==(12); //@line 52949 "c/sqlite3.c"
 if ($11) {
  $$08 = 0;
  STACKTOP = sp;return ($$08|0); //@line 52958 "c/sqlite3.c"
 }
 $12 = ($10|0)==(0); //@line 52954 "c/sqlite3.c"
 $13 = HEAP32[$1>>2]|0; //@line 52954 "c/sqlite3.c"
 $14 = ($13|0)!=(0); //@line 52954 "c/sqlite3.c"
 $or$cond = $12 & $14; //@line 52954 "c/sqlite3.c"
 $spec$select = $or$cond ? 1032 : $10; //@line 52954 "c/sqlite3.c"
 $$08 = $spec$select;
 STACKTOP = sp;return ($$08|0); //@line 52958 "c/sqlite3.c"
}
function _sqlite3JournalOpen($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$2; stop=dest+72|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 90916 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 90917 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3OsOpen($0,$1,$2,$3,0)|0); //@line 90918 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 90934 "c/sqlite3.c"
 } else {
  $7 = ($4|0)>(0); //@line 90921 "c/sqlite3.c"
  $8 = ((($2)) + 4|0);
  $$ = $7 ? $4 : 1020; //@line 90923 "c/sqlite3.c"
  HEAP32[$8>>2] = $$;
  HEAP32[$2>>2] = 4880; //@line 90928 "c/sqlite3.c"
  $9 = ((($2)) + 8|0); //@line 90929 "c/sqlite3.c"
  HEAP32[$9>>2] = $4; //@line 90929 "c/sqlite3.c"
  $10 = ((($2)) + 56|0); //@line 90930 "c/sqlite3.c"
  HEAP32[$10>>2] = $3; //@line 90930 "c/sqlite3.c"
  $11 = ((($2)) + 64|0); //@line 90931 "c/sqlite3.c"
  HEAP32[$11>>2] = $1; //@line 90931 "c/sqlite3.c"
  $12 = ((($2)) + 60|0); //@line 90932 "c/sqlite3.c"
  HEAP32[$12>>2] = $0; //@line 90932 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 90934 "c/sqlite3.c"
 }
 return (0)|0;
}
function _writeJournalHdr($0) {
 $0 = $0|0;
 var $$05256 = 0, $$054$lcssa = 0, $$057 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $spec$select = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 204|0); //@line 49413 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49413 "c/sqlite3.c"
 $3 = ((($0)) + 152|0); //@line 49414 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 49414 "c/sqlite3.c"
 $5 = ((($0)) + 148|0); //@line 49420 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 49420 "c/sqlite3.c"
 $7 = ($4>>>0)>($6>>>0); //@line 49420 "c/sqlite3.c"
 $spec$select = $7 ? $6 : $4; //@line 49420 "c/sqlite3.c"
 $8 = ((($0)) + 96|0); //@line 49428 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 49428 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 49428 "c/sqlite3.c"
 if ($10) {
  $11 = ((($0)) + 92|0);
  $12 = HEAP32[$11>>2]|0;
  $13 = ((($0)) + 72|0);
  $14 = HEAP32[$8>>2]|0;
  $$057 = 0;
  while(1) {
   $15 = (((($12) + (($$057*48)|0)|0)) + 8|0); //@line 49429 "c/sqlite3.c"
   $16 = $15; //@line 49429 "c/sqlite3.c"
   $17 = $16; //@line 49429 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 49429 "c/sqlite3.c"
   $19 = (($16) + 4)|0; //@line 49429 "c/sqlite3.c"
   $20 = $19; //@line 49429 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 49429 "c/sqlite3.c"
   $22 = ($18|0)==(0); //@line 49429 "c/sqlite3.c"
   $23 = ($21|0)==(0); //@line 49429 "c/sqlite3.c"
   $24 = $22 & $23; //@line 49429 "c/sqlite3.c"
   if ($24) {
    $25 = $13; //@line 49430 "c/sqlite3.c"
    $26 = $25; //@line 49430 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 49430 "c/sqlite3.c"
    $28 = (($25) + 4)|0; //@line 49430 "c/sqlite3.c"
    $29 = $28; //@line 49430 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 49430 "c/sqlite3.c"
    $31 = $15; //@line 49430 "c/sqlite3.c"
    $32 = $31; //@line 49430 "c/sqlite3.c"
    HEAP32[$32>>2] = $27; //@line 49430 "c/sqlite3.c"
    $33 = (($31) + 4)|0; //@line 49430 "c/sqlite3.c"
    $34 = $33; //@line 49430 "c/sqlite3.c"
    HEAP32[$34>>2] = $30; //@line 49430 "c/sqlite3.c"
   }
   $35 = (($$057) + 1)|0; //@line 49428 "c/sqlite3.c"
   $36 = ($35|0)<($14|0); //@line 49428 "c/sqlite3.c"
   if ($36) {
    $$057 = $35;
   } else {
    break;
   }
  }
 }
 $37 = (_journalHdrOffset($0)|0); //@line 49434 "c/sqlite3.c"
 $38 = tempRet0; //@line 49434 "c/sqlite3.c"
 $39 = ((($0)) + 72|0); //@line 49434 "c/sqlite3.c"
 $40 = $39; //@line 49434 "c/sqlite3.c"
 $41 = $40; //@line 49434 "c/sqlite3.c"
 HEAP32[$41>>2] = $37; //@line 49434 "c/sqlite3.c"
 $42 = (($40) + 4)|0; //@line 49434 "c/sqlite3.c"
 $43 = $42; //@line 49434 "c/sqlite3.c"
 HEAP32[$43>>2] = $38; //@line 49434 "c/sqlite3.c"
 $44 = ((($0)) + 80|0); //@line 49434 "c/sqlite3.c"
 $45 = $44; //@line 49434 "c/sqlite3.c"
 $46 = $45; //@line 49434 "c/sqlite3.c"
 HEAP32[$46>>2] = $37; //@line 49434 "c/sqlite3.c"
 $47 = (($45) + 4)|0; //@line 49434 "c/sqlite3.c"
 $48 = $47; //@line 49434 "c/sqlite3.c"
 HEAP32[$48>>2] = $38; //@line 49434 "c/sqlite3.c"
 $49 = ((($0)) + 7|0); //@line 49457 "c/sqlite3.c"
 $50 = HEAP8[$49>>0]|0; //@line 49457 "c/sqlite3.c"
 $51 = ($50<<24>>24)==(0); //@line 49457 "c/sqlite3.c"
 if ($51) {
  $52 = ((($0)) + 5|0); //@line 49457 "c/sqlite3.c"
  $53 = HEAP8[$52>>0]|0; //@line 49457 "c/sqlite3.c"
  $54 = ($53<<24>>24)==(4); //@line 49457 "c/sqlite3.c"
  if ($54) {
   label = 9;
  } else {
   $55 = ((($0)) + 60|0); //@line 49458 "c/sqlite3.c"
   $56 = HEAP32[$55>>2]|0; //@line 49458 "c/sqlite3.c"
   $57 = (_sqlite3OsDeviceCharacteristics($56)|0); //@line 49458 "c/sqlite3.c"
   $58 = $57 & 512; //@line 49458 "c/sqlite3.c"
   $59 = ($58|0)==(0); //@line 49458 "c/sqlite3.c"
   if ($59) {
    dest=$2; stop=dest+12|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 49463 "c/sqlite3.c"
   } else {
    label = 9;
   }
  }
 } else {
  label = 9;
 }
 if ((label|0) == 9) {
  $60 = $2; //@line 49460 "c/sqlite3.c"
  $61 = $60; //@line 49460 "c/sqlite3.c"
  HEAP8[$61>>0]=-117058087&255;HEAP8[$61+1>>0]=(-117058087>>8)&255;HEAP8[$61+2>>0]=(-117058087>>16)&255;HEAP8[$61+3>>0]=-117058087>>24; //@line 49460 "c/sqlite3.c"
  $62 = (($60) + 4)|0; //@line 49460 "c/sqlite3.c"
  $63 = $62; //@line 49460 "c/sqlite3.c"
  HEAP8[$63>>0]=-681336544&255;HEAP8[$63+1>>0]=(-681336544>>8)&255;HEAP8[$63+2>>0]=(-681336544>>16)&255;HEAP8[$63+3>>0]=-681336544>>24; //@line 49460 "c/sqlite3.c"
  $64 = ((($2)) + 8|0); //@line 49461 "c/sqlite3.c"
  _sqlite3Put4byte($64,-1); //@line 49461 "c/sqlite3.c"
 }
 $65 = ((($0)) + 48|0); //@line 49467 "c/sqlite3.c"
 _sqlite3_randomness(4,$65); //@line 49467 "c/sqlite3.c"
 $66 = ((($2)) + 12|0); //@line 49468 "c/sqlite3.c"
 $67 = HEAP32[$65>>2]|0; //@line 49468 "c/sqlite3.c"
 _sqlite3Put4byte($66,$67); //@line 49468 "c/sqlite3.c"
 $68 = ((($2)) + 16|0); //@line 49470 "c/sqlite3.c"
 $69 = ((($0)) + 28|0); //@line 49470 "c/sqlite3.c"
 $70 = HEAP32[$69>>2]|0; //@line 49470 "c/sqlite3.c"
 _sqlite3Put4byte($68,$70); //@line 49470 "c/sqlite3.c"
 $71 = ((($2)) + 20|0); //@line 49472 "c/sqlite3.c"
 $72 = HEAP32[$5>>2]|0; //@line 49472 "c/sqlite3.c"
 _sqlite3Put4byte($71,$72); //@line 49472 "c/sqlite3.c"
 $73 = ((($2)) + 24|0); //@line 49475 "c/sqlite3.c"
 $74 = HEAP32[$3>>2]|0; //@line 49475 "c/sqlite3.c"
 _sqlite3Put4byte($73,$74); //@line 49475 "c/sqlite3.c"
 $75 = ((($2)) + 28|0); //@line 49482 "c/sqlite3.c"
 $76 = (($spec$select) + -28)|0; //@line 49483 "c/sqlite3.c"
 _memset(($75|0),0,($76|0))|0; //@line 49482 "c/sqlite3.c"
 $77 = ((($0)) + 64|0);
 $$05256 = 0;
 while(1) {
  $78 = HEAP32[$5>>2]|0; //@line 49502 "c/sqlite3.c"
  $79 = ($$05256>>>0)<($78>>>0); //@line 49502 "c/sqlite3.c"
  if (!($79)) {
   $$054$lcssa = 0;
   label = 14;
   break;
  }
  $80 = HEAP32[$77>>2]|0; //@line 49504 "c/sqlite3.c"
  $81 = $39; //@line 49504 "c/sqlite3.c"
  $82 = $81; //@line 49504 "c/sqlite3.c"
  $83 = HEAP32[$82>>2]|0; //@line 49504 "c/sqlite3.c"
  $84 = (($81) + 4)|0; //@line 49504 "c/sqlite3.c"
  $85 = $84; //@line 49504 "c/sqlite3.c"
  $86 = HEAP32[$85>>2]|0; //@line 49504 "c/sqlite3.c"
  $87 = (_sqlite3OsWrite($80,$2,$spec$select,$83,$86)|0); //@line 49504 "c/sqlite3.c"
  $88 = $39; //@line 49506 "c/sqlite3.c"
  $89 = $88; //@line 49506 "c/sqlite3.c"
  $90 = HEAP32[$89>>2]|0; //@line 49506 "c/sqlite3.c"
  $91 = (($88) + 4)|0; //@line 49506 "c/sqlite3.c"
  $92 = $91; //@line 49506 "c/sqlite3.c"
  $93 = HEAP32[$92>>2]|0; //@line 49506 "c/sqlite3.c"
  $94 = (_i64Add(($90|0),($93|0),($spec$select|0),0)|0); //@line 49506 "c/sqlite3.c"
  $95 = tempRet0; //@line 49506 "c/sqlite3.c"
  $96 = $39; //@line 49506 "c/sqlite3.c"
  $97 = $96; //@line 49506 "c/sqlite3.c"
  HEAP32[$97>>2] = $94; //@line 49506 "c/sqlite3.c"
  $98 = (($96) + 4)|0; //@line 49506 "c/sqlite3.c"
  $99 = $98; //@line 49506 "c/sqlite3.c"
  HEAP32[$99>>2] = $95; //@line 49506 "c/sqlite3.c"
  $100 = (($$05256) + ($spec$select))|0; //@line 49502 "c/sqlite3.c"
  $101 = ($87|0)==(0); //@line 49502 "c/sqlite3.c"
  if ($101) {
   $$05256 = $100;
  } else {
   $$054$lcssa = $87;
   label = 14;
   break;
  }
 }
 if ((label|0) == 14) {
  return ($$054$lcssa|0); //@line 49509 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BitvecDestroy($0) {
 $0 = $0|0;
 var $$07 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 45042 "c/sqlite3.c"
 if ($1) {
  return; //@line 45050 "c/sqlite3.c"
 }
 $2 = ((($0)) + 8|0); //@line 45043 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45043 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 45043 "c/sqlite3.c"
 if (!($4)) {
  $5 = ((($0)) + 12|0);
  $$07 = 0;
  while(1) {
   $6 = (($5) + ($$07<<2)|0); //@line 45046 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 45046 "c/sqlite3.c"
   _sqlite3BitvecDestroy($7); //@line 45046 "c/sqlite3.c"
   $8 = (($$07) + 1)|0; //@line 45045 "c/sqlite3.c"
   $exitcond = ($8|0)==(125); //@line 45045 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$07 = $8;
   }
  }
 }
 _sqlite3_free($0); //@line 45049 "c/sqlite3.c"
 return; //@line 45050 "c/sqlite3.c"
}
function _journalHdrOffset($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 72|0); //@line 49330 "c/sqlite3.c"
 $2 = $1; //@line 49330 "c/sqlite3.c"
 $3 = $2; //@line 49330 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 49330 "c/sqlite3.c"
 $5 = (($2) + 4)|0; //@line 49330 "c/sqlite3.c"
 $6 = $5; //@line 49330 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 49330 "c/sqlite3.c"
 $8 = ($4|0)==(0); //@line 49331 "c/sqlite3.c"
 $9 = ($7|0)==(0); //@line 49331 "c/sqlite3.c"
 $10 = $8 & $9; //@line 49331 "c/sqlite3.c"
 if ($10) {
  $21 = 0;$22 = 0;
  tempRet0 = ($21); //@line 49337 "c/sqlite3.c"
  return ($22|0); //@line 49337 "c/sqlite3.c"
 }
 $11 = (_i64Add(($4|0),($7|0),-1,-1)|0); //@line 49332 "c/sqlite3.c"
 $12 = tempRet0; //@line 49332 "c/sqlite3.c"
 $13 = ((($0)) + 148|0); //@line 49332 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 49332 "c/sqlite3.c"
 $15 = (___divdi3(($11|0),($12|0),($14|0),0)|0); //@line 49332 "c/sqlite3.c"
 $16 = tempRet0; //@line 49332 "c/sqlite3.c"
 $17 = (_i64Add(($15|0),($16|0),1,0)|0); //@line 49332 "c/sqlite3.c"
 $18 = tempRet0; //@line 49332 "c/sqlite3.c"
 $19 = (___muldi3(($17|0),($18|0),($14|0),0)|0); //@line 49332 "c/sqlite3.c"
 $20 = tempRet0; //@line 49332 "c/sqlite3.c"
 $21 = $20;$22 = $19;
 tempRet0 = ($21); //@line 49337 "c/sqlite3.c"
 return ($22|0); //@line 49337 "c/sqlite3.c"
}
function _sqlite3OsDeviceCharacteristics($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 20964 "c/sqlite3.c"
 $2 = ((($1)) + 48|0); //@line 20964 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 20964 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_ii[$3 & 255]($0)|0); //@line 20964 "c/sqlite3.c"
 return ($4|0); //@line 20964 "c/sqlite3.c"
}
function _sqlite3OsOpen($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 24|0); //@line 21025 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 21025 "c/sqlite3.c"
 $7 = $3 & 556927; //@line 21025 "c/sqlite3.c"
 $8 = (FUNCTION_TABLE_iiiiii[$6 & 127]($0,$1,$2,$7,$4)|0); //@line 21025 "c/sqlite3.c"
 return ($8|0); //@line 21027 "c/sqlite3.c"
}
function _memjrnlClose($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _memjrnlFreeChunks($0); //@line 90842 "c/sqlite3.c"
 return 0; //@line 90843 "c/sqlite3.c"
}
function _memjrnlRead($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$061 = 0, $$061$ = 0, $$063 = 0, $$06365 = 0, $$06367 = 0, $$064 = 0, $$1 = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 40|0); //@line 90662 "c/sqlite3.c"
 $6 = $5; //@line 90662 "c/sqlite3.c"
 $7 = $6; //@line 90662 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 90662 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 90662 "c/sqlite3.c"
 $10 = $9; //@line 90662 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 90662 "c/sqlite3.c"
 $12 = ($8|0)!=($3|0); //@line 90662 "c/sqlite3.c"
 $13 = ($11|0)!=($4|0); //@line 90662 "c/sqlite3.c"
 $14 = $12 | $13; //@line 90662 "c/sqlite3.c"
 $15 = ($3|0)==(0); //@line 90662 "c/sqlite3.c"
 $16 = ($4|0)==(0); //@line 90662 "c/sqlite3.c"
 $17 = $15 & $16; //@line 90662 "c/sqlite3.c"
 $or$cond = $17 | $14; //@line 90662 "c/sqlite3.c"
 L1: do {
  if ($or$cond) {
   $18 = ((($0)) + 16|0); //@line 90664 "c/sqlite3.c"
   $$06365 = HEAP32[$18>>2]|0;
   $19 = ($$06365|0)==(0|0); //@line 90665 "c/sqlite3.c"
   if ($19) {
    $$1 = 0;
   } else {
    $20 = ((($0)) + 4|0); //@line 90665 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0;
    $22 = ($21|0)<(0);
    $23 = $22 << 31 >> 31;
    $$06367 = $$06365;$24 = 0;$25 = 0;
    while(1) {
     $26 = (_i64Add(($24|0),($25|0),($21|0),($23|0))|0); //@line 90665 "c/sqlite3.c"
     $27 = tempRet0; //@line 90665 "c/sqlite3.c"
     $28 = ($27|0)>($4|0); //@line 90665 "c/sqlite3.c"
     $29 = ($26>>>0)>($3>>>0); //@line 90665 "c/sqlite3.c"
     $30 = ($27|0)==($4|0); //@line 90665 "c/sqlite3.c"
     $31 = $30 & $29; //@line 90665 "c/sqlite3.c"
     $32 = $28 | $31; //@line 90665 "c/sqlite3.c"
     if ($32) {
      $$1 = $$06367;
      break L1;
     }
     $$063 = HEAP32[$$06367>>2]|0;
     $33 = ($$063|0)==(0|0); //@line 90665 "c/sqlite3.c"
     if ($33) {
      $$1 = 0;
      break;
     } else {
      $$06367 = $$063;$24 = $26;$25 = $27;
     }
    }
   }
  } else {
   $34 = ((($0)) + 48|0); //@line 90671 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 90671 "c/sqlite3.c"
   $$1 = $35;
  }
 } while(0);
 $36 = ((($0)) + 4|0); //@line 90675 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 90675 "c/sqlite3.c"
 $38 = ($37|0)<(0); //@line 90675 "c/sqlite3.c"
 $39 = $38 << 31 >> 31; //@line 90675 "c/sqlite3.c"
 $40 = (___remdi3(($3|0),($4|0),($37|0),($39|0))|0); //@line 90675 "c/sqlite3.c"
 $41 = tempRet0; //@line 90675 "c/sqlite3.c"
 $$0 = $1;$$061 = $2;$$064 = $40;$$2 = $$1;
 while(1) {
  $42 = HEAP32[$36>>2]|0; //@line 90677 "c/sqlite3.c"
  $43 = (($42) - ($$064))|0; //@line 90677 "c/sqlite3.c"
  $44 = ($$061|0)<($43|0); //@line 90678 "c/sqlite3.c"
  $$061$ = $44 ? $$061 : $43; //@line 90678 "c/sqlite3.c"
  $45 = (((($$2)) + 4|0) + ($$064)|0); //@line 90679 "c/sqlite3.c"
  _memcpy(($$0|0),($45|0),($$061$|0))|0; //@line 90679 "c/sqlite3.c"
  $46 = (($$061) - ($43))|0; //@line 90681 "c/sqlite3.c"
  $47 = ($46|0)>(-1); //@line 90683 "c/sqlite3.c"
  if (!($47)) {
   $$3 = $$2;
   break;
  }
  $48 = (($$0) + ($$061$)|0); //@line 90680 "c/sqlite3.c"
  $49 = HEAP32[$$2>>2]|0; //@line 90683 "c/sqlite3.c"
  $50 = ($49|0)!=(0|0); //@line 90683 "c/sqlite3.c"
  $51 = ($46|0)!=(0); //@line 90683 "c/sqlite3.c"
  $or$cond5 = $51 & $50; //@line 90683 "c/sqlite3.c"
  if ($or$cond5) {
   $$0 = $48;$$061 = $46;$$064 = 0;$$2 = $49;
  } else {
   $$3 = $49;
   break;
  }
 }
 $52 = ($$3|0)==(0|0); //@line 90684 "c/sqlite3.c"
 $53 = ($2|0)<(0); //@line 90684 "c/sqlite3.c"
 $54 = $53 << 31 >> 31; //@line 90684 "c/sqlite3.c"
 $55 = (_i64Add(($2|0),($54|0),($3|0),($4|0))|0); //@line 90684 "c/sqlite3.c"
 $56 = tempRet0; //@line 90684 "c/sqlite3.c"
 $57 = $52 ? 0 : $55; //@line 90684 "c/sqlite3.c"
 $58 = $52 ? 0 : $56; //@line 90684 "c/sqlite3.c"
 $59 = $5; //@line 90684 "c/sqlite3.c"
 $60 = $59; //@line 90684 "c/sqlite3.c"
 HEAP32[$60>>2] = $57; //@line 90684 "c/sqlite3.c"
 $61 = (($59) + 4)|0; //@line 90684 "c/sqlite3.c"
 $62 = $61; //@line 90684 "c/sqlite3.c"
 HEAP32[$62>>2] = $58; //@line 90684 "c/sqlite3.c"
 $63 = ((($0)) + 48|0); //@line 90685 "c/sqlite3.c"
 HEAP32[$63>>2] = $$3; //@line 90685 "c/sqlite3.c"
 return 0; //@line 90687 "c/sqlite3.c"
}
function _memjrnlWrite($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$065$ = 0, $$06578 = 0, $$06777 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 8|0); //@line 90757 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 90757 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 90757 "c/sqlite3.c"
 if ($7) {
  $8 = ($2|0)<(0); //@line 90757 "c/sqlite3.c"
  $9 = $8 << 31 >> 31; //@line 90757 "c/sqlite3.c"
  $10 = (_i64Add(($2|0),($9|0),($3|0),($4|0))|0); //@line 90757 "c/sqlite3.c"
  $11 = tempRet0; //@line 90757 "c/sqlite3.c"
  $12 = ($6|0)<(0); //@line 90757 "c/sqlite3.c"
  $13 = $12 << 31 >> 31; //@line 90757 "c/sqlite3.c"
  $14 = ($11|0)>($13|0); //@line 90757 "c/sqlite3.c"
  $15 = ($10>>>0)>($6>>>0); //@line 90757 "c/sqlite3.c"
  $16 = ($11|0)==($13|0); //@line 90757 "c/sqlite3.c"
  $17 = $16 & $15; //@line 90757 "c/sqlite3.c"
  $18 = $14 | $17; //@line 90757 "c/sqlite3.c"
  if ($18) {
   $19 = (_memjrnlCreateFile($0)|0); //@line 90758 "c/sqlite3.c"
   $20 = ($19|0)==(0); //@line 90759 "c/sqlite3.c"
   if (!($20)) {
    $$4 = $19;
    return ($$4|0); //@line 90815 "c/sqlite3.c"
   }
   $21 = (_sqlite3OsWrite($0,$1,$2,$3,$4)|0); //@line 90760 "c/sqlite3.c"
   $$4 = $21;
   return ($$4|0); //@line 90815 "c/sqlite3.c"
  }
 }
 $22 = ($2|0)>(0); //@line 90783 "c/sqlite3.c"
 L9: do {
  if ($22) {
   $23 = ((($0)) + 24|0);
   $24 = ((($0)) + 32|0);
   $25 = ((($0)) + 4|0);
   $26 = ((($0)) + 16|0);
   $$06578 = $2;$$06777 = $1;
   while(1) {
    $27 = HEAP32[$24>>2]|0; //@line 90784 "c/sqlite3.c"
    $28 = $23; //@line 90785 "c/sqlite3.c"
    $29 = $28; //@line 90785 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 90785 "c/sqlite3.c"
    $31 = (($28) + 4)|0; //@line 90785 "c/sqlite3.c"
    $32 = $31; //@line 90785 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 90785 "c/sqlite3.c"
    $34 = HEAP32[$25>>2]|0; //@line 90785 "c/sqlite3.c"
    $35 = ($34|0)<(0); //@line 90785 "c/sqlite3.c"
    $36 = $35 << 31 >> 31; //@line 90785 "c/sqlite3.c"
    $37 = (___remdi3(($30|0),($33|0),($34|0),($36|0))|0); //@line 90785 "c/sqlite3.c"
    $38 = tempRet0; //@line 90785 "c/sqlite3.c"
    $39 = (($34) - ($37))|0; //@line 90786 "c/sqlite3.c"
    $40 = ($$06578|0)<($39|0); //@line 90786 "c/sqlite3.c"
    $$065$ = $40 ? $$06578 : $39; //@line 90786 "c/sqlite3.c"
    $41 = ($37|0)==(0); //@line 90788 "c/sqlite3.c"
    if ($41) {
     $42 = (($34) + 4)|0; //@line 90790 "c/sqlite3.c"
     $43 = (_sqlite3_malloc($42)|0); //@line 90790 "c/sqlite3.c"
     $44 = ($43|0)==(0|0); //@line 90791 "c/sqlite3.c"
     if ($44) {
      $$4 = 3082;
      break;
     }
     HEAP32[$43>>2] = 0; //@line 90794 "c/sqlite3.c"
     $45 = ($27|0)==(0|0); //@line 90795 "c/sqlite3.c"
     if ($45) {
      HEAP32[$26>>2] = $43; //@line 90800 "c/sqlite3.c"
     } else {
      HEAP32[$27>>2] = $43; //@line 90797 "c/sqlite3.c"
     }
     HEAP32[$24>>2] = $43; //@line 90802 "c/sqlite3.c"
    }
    $46 = HEAP32[$24>>2]|0; //@line 90805 "c/sqlite3.c"
    $47 = (((($46)) + 4|0) + ($37)|0); //@line 90805 "c/sqlite3.c"
    _memcpy(($47|0),($$06777|0),($$065$|0))|0; //@line 90805 "c/sqlite3.c"
    $48 = (($$06777) + ($$065$)|0); //@line 90806 "c/sqlite3.c"
    $49 = (($$06578) - ($$065$))|0; //@line 90807 "c/sqlite3.c"
    $50 = ($$065$|0)<(0); //@line 90808 "c/sqlite3.c"
    $51 = $50 << 31 >> 31; //@line 90808 "c/sqlite3.c"
    $52 = $23; //@line 90808 "c/sqlite3.c"
    $53 = $52; //@line 90808 "c/sqlite3.c"
    $54 = HEAP32[$53>>2]|0; //@line 90808 "c/sqlite3.c"
    $55 = (($52) + 4)|0; //@line 90808 "c/sqlite3.c"
    $56 = $55; //@line 90808 "c/sqlite3.c"
    $57 = HEAP32[$56>>2]|0; //@line 90808 "c/sqlite3.c"
    $58 = (_i64Add(($54|0),($57|0),($$065$|0),($51|0))|0); //@line 90808 "c/sqlite3.c"
    $59 = tempRet0; //@line 90808 "c/sqlite3.c"
    $60 = $23; //@line 90808 "c/sqlite3.c"
    $61 = $60; //@line 90808 "c/sqlite3.c"
    HEAP32[$61>>2] = $58; //@line 90808 "c/sqlite3.c"
    $62 = (($60) + 4)|0; //@line 90808 "c/sqlite3.c"
    $63 = $62; //@line 90808 "c/sqlite3.c"
    HEAP32[$63>>2] = $59; //@line 90808 "c/sqlite3.c"
    $64 = ($49|0)>(0); //@line 90783 "c/sqlite3.c"
    if ($64) {
     $$06578 = $49;$$06777 = $48;
    } else {
     break L9;
    }
   }
   return ($$4|0); //@line 90815 "c/sqlite3.c"
  }
 } while(0);
 $65 = (($3) + ($2))|0; //@line 90810 "c/sqlite3.c"
 $66 = ((($0)) + 12|0); //@line 90810 "c/sqlite3.c"
 HEAP32[$66>>2] = $65; //@line 90810 "c/sqlite3.c"
 $$4 = 0;
 return ($$4|0); //@line 90815 "c/sqlite3.c"
}
function _memjrnlTruncate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0); //@line 90826 "c/sqlite3.c"
 $4 = ($2|0)==(0); //@line 90826 "c/sqlite3.c"
 $5 = $3 & $4; //@line 90826 "c/sqlite3.c"
 if (!($5)) {
  return 0; //@line 90834 "c/sqlite3.c"
 }
 _memjrnlFreeChunks($0); //@line 90827 "c/sqlite3.c"
 $6 = ((($0)) + 12|0); //@line 90828 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 90828 "c/sqlite3.c"
 $7 = ((($0)) + 24|0); //@line 90829 "c/sqlite3.c"
 $8 = ((($0)) + 32|0); //@line 90829 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 90829 "c/sqlite3.c"
 $9 = $7; //@line 90830 "c/sqlite3.c"
 $10 = $9; //@line 90830 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 90830 "c/sqlite3.c"
 $11 = (($9) + 4)|0; //@line 90830 "c/sqlite3.c"
 $12 = $11; //@line 90830 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 90830 "c/sqlite3.c"
 $13 = ((($0)) + 40|0); //@line 90831 "c/sqlite3.c"
 $14 = ((($0)) + 48|0); //@line 90831 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 90831 "c/sqlite3.c"
 $15 = $13; //@line 90832 "c/sqlite3.c"
 $16 = $15; //@line 90832 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 90832 "c/sqlite3.c"
 $17 = (($15) + 4)|0; //@line 90832 "c/sqlite3.c"
 $18 = $17; //@line 90832 "c/sqlite3.c"
 HEAP32[$18>>2] = 0; //@line 90832 "c/sqlite3.c"
 return 0; //@line 90834 "c/sqlite3.c"
}
function _memjrnlSync($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 90854 "c/sqlite3.c"
}
function _memjrnlFileSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 90862 "c/sqlite3.c"
 $3 = $2; //@line 90862 "c/sqlite3.c"
 $4 = $3; //@line 90862 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 90862 "c/sqlite3.c"
 $6 = (($3) + 4)|0; //@line 90862 "c/sqlite3.c"
 $7 = $6; //@line 90862 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 90862 "c/sqlite3.c"
 $9 = $1; //@line 90862 "c/sqlite3.c"
 $10 = $9; //@line 90862 "c/sqlite3.c"
 HEAP32[$10>>2] = $5; //@line 90862 "c/sqlite3.c"
 $11 = (($9) + 4)|0; //@line 90862 "c/sqlite3.c"
 $12 = $11; //@line 90862 "c/sqlite3.c"
 HEAP32[$12>>2] = $8; //@line 90862 "c/sqlite3.c"
 return 0; //@line 90863 "c/sqlite3.c"
}
function _memjrnlFreeChunks($0) {
 $0 = $0|0;
 var $$in910 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 90696 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 90696 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 90696 "c/sqlite3.c"
 if (!($3)) {
  $$in910 = $2;
  while(1) {
   $4 = HEAP32[$$in910>>2]|0; //@line 90697 "c/sqlite3.c"
   _sqlite3_free($$in910); //@line 90698 "c/sqlite3.c"
   $5 = ($4|0)==(0|0); //@line 90696 "c/sqlite3.c"
   if ($5) {
    break;
   } else {
    $$in910 = $4;
   }
  }
 }
 HEAP32[$1>>2] = 0; //@line 90700 "c/sqlite3.c"
 return; //@line 90701 "c/sqlite3.c"
}
function _memjrnlCreateFile($0) {
 $0 = $0|0;
 var $$03137 = 0, $$039 = 0, $$1 = 0, $$2$ph = 0, $$236 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $1 = sp;
 dest=$1; src=$0; stop=dest+72|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 90709 "c/sqlite3.c"
 dest=$0; stop=dest+72|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 90711 "c/sqlite3.c"
 $2 = ((($1)) + 60|0); //@line 90712 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 90712 "c/sqlite3.c"
 $4 = ((($1)) + 64|0); //@line 90712 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 90712 "c/sqlite3.c"
 $6 = ((($1)) + 56|0); //@line 90712 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 90712 "c/sqlite3.c"
 $8 = (_sqlite3OsOpen($3,$5,$0,$7,0)|0); //@line 90712 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 90713 "c/sqlite3.c"
 L1: do {
  if ($9) {
   $10 = ((($1)) + 16|0); //@line 90717 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 90717 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 90717 "c/sqlite3.c"
   if (!($12)) {
    $13 = ((($1)) + 4|0); //@line 90714 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 90714 "c/sqlite3.c"
    $15 = ((($1)) + 24|0);
    $16 = $15;
    $17 = $16;
    $18 = HEAP32[$17>>2]|0;
    $19 = (($16) + 4)|0;
    $20 = $19;
    $21 = HEAP32[$20>>2]|0;
    $$03137 = $14;$$039 = $11;$24 = 0;$25 = 0;
    while(1) {
     $22 = ($$03137|0)<(0); //@line 90718 "c/sqlite3.c"
     $23 = $22 << 31 >> 31; //@line 90718 "c/sqlite3.c"
     $26 = (_i64Add(($24|0),($25|0),($$03137|0),($23|0))|0); //@line 90718 "c/sqlite3.c"
     $27 = tempRet0; //@line 90718 "c/sqlite3.c"
     $28 = ($27|0)>($21|0); //@line 90718 "c/sqlite3.c"
     $29 = ($26>>>0)>($18>>>0); //@line 90718 "c/sqlite3.c"
     $30 = ($27|0)==($21|0); //@line 90718 "c/sqlite3.c"
     $31 = $30 & $29; //@line 90718 "c/sqlite3.c"
     $32 = $28 | $31; //@line 90718 "c/sqlite3.c"
     $33 = (_i64Subtract(($18|0),($21|0),($24|0),($25|0))|0); //@line 90719 "c/sqlite3.c"
     $34 = tempRet0; //@line 90719 "c/sqlite3.c"
     $$1 = $32 ? $33 : $$03137; //@line 90718 "c/sqlite3.c"
     $35 = ((($$039)) + 4|0); //@line 90721 "c/sqlite3.c"
     $36 = (_sqlite3OsWrite($0,$35,$$1,$24,$25)|0); //@line 90721 "c/sqlite3.c"
     $37 = ($36|0)==(0); //@line 90722 "c/sqlite3.c"
     if (!($37)) {
      $$2$ph = $36;
      break L1;
     }
     $38 = ($$1|0)<(0); //@line 90723 "c/sqlite3.c"
     $39 = $38 << 31 >> 31; //@line 90723 "c/sqlite3.c"
     $40 = (_i64Add(($24|0),($25|0),($$1|0),($39|0))|0); //@line 90723 "c/sqlite3.c"
     $41 = tempRet0; //@line 90723 "c/sqlite3.c"
     $42 = HEAP32[$$039>>2]|0; //@line 90717 "c/sqlite3.c"
     $43 = ($42|0)==(0|0); //@line 90717 "c/sqlite3.c"
     if ($43) {
      break;
     } else {
      $$03137 = $$1;$$039 = $42;$24 = $40;$25 = $41;
     }
    }
   }
   _memjrnlFreeChunks($1); //@line 90727 "c/sqlite3.c"
   $$236 = 0;
   STACKTOP = sp;return ($$236|0); //@line 90738 "c/sqlite3.c"
  } else {
   $$2$ph = $8;
  }
 } while(0);
 _sqlite3OsClose($0); //@line 90735 "c/sqlite3.c"
 dest=$0; src=$1; stop=dest+72|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 90736 "c/sqlite3.c"
 $$236 = $$2$ph;
 STACKTOP = sp;return ($$236|0); //@line 90738 "c/sqlite3.c"
}
function _sqlite3OsClose($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 20893 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 20893 "c/sqlite3.c"
 if ($2) {
  return; //@line 20897 "c/sqlite3.c"
 }
 $3 = ((($1)) + 4|0); //@line 20894 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 20894 "c/sqlite3.c"
 (FUNCTION_TABLE_ii[$4 & 255]($0)|0); //@line 20894 "c/sqlite3.c"
 HEAP32[$0>>2] = 0; //@line 20895 "c/sqlite3.c"
 return; //@line 20897 "c/sqlite3.c"
}
function _sqlite3OsFileControl($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 20953 "c/sqlite3.c"
 $4 = ((($3)) + 40|0); //@line 20953 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 20953 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iiii[$5 & 127]($0,$1,$2)|0); //@line 20953 "c/sqlite3.c"
 return ($6|0); //@line 20953 "c/sqlite3.c"
}
function _sqlite3BitvecTest($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 44918 "c/sqlite3.c"
 if ($2) {
  $5 = 0;
  return ($5|0); //@line 44918 "c/sqlite3.c"
 }
 $3 = (_sqlite3BitvecTestNotNull($0,$1)|0); //@line 44918 "c/sqlite3.c"
 $4 = ($3|0)!=(0); //@line 44918 "c/sqlite3.c"
 $phitmp = $4&1;
 $5 = $phitmp;
 return ($5|0); //@line 44918 "c/sqlite3.c"
}
function _sqlite3PagerGet($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 200|0); //@line 53589 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 53589 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iiiii[$5 & 127]($0,$1,$2,$3)|0); //@line 53589 "c/sqlite3.c"
 return ($6|0); //@line 53589 "c/sqlite3.c"
}
function _sqlite3PagerUnrefNotNull($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 28|0); //@line 53629 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 53629 "c/sqlite3.c"
 $3 = $2 & 32; //@line 53629 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 53629 "c/sqlite3.c"
 if ($4) {
  _sqlite3PcacheRelease($0); //@line 53633 "c/sqlite3.c"
  return; //@line 53637 "c/sqlite3.c"
 } else {
  _pagerReleaseMapPage($0); //@line 53631 "c/sqlite3.c"
  return; //@line 53637 "c/sqlite3.c"
 }
}
function _sqlite3PagerLookup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 208|0); //@line 53608 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 53608 "c/sqlite3.c"
 $4 = (_sqlite3PcacheFetch($3,$1,0)|0); //@line 53608 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 53610 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 53612 "c/sqlite3.c"
 }
 $6 = HEAP32[$2>>2]|0; //@line 53611 "c/sqlite3.c"
 $7 = (_sqlite3PcacheFetchFinish($6,$1,$4)|0); //@line 53611 "c/sqlite3.c"
 $$0 = $7;
 return ($$0|0); //@line 53612 "c/sqlite3.c"
}
function _sqlite3PcacheFetch($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 33|0); //@line 45559 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 45559 "c/sqlite3.c"
 $5 = $4&255; //@line 45559 "c/sqlite3.c"
 $6 = $5 & $2; //@line 45559 "c/sqlite3.c"
 $7 = HEAP32[(148)>>2]|0; //@line 45563 "c/sqlite3.c"
 $8 = ((($0)) + 44|0); //@line 45563 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 45563 "c/sqlite3.c"
 $10 = (FUNCTION_TABLE_iiii[$7 & 127]($9,$1,$6)|0); //@line 45563 "c/sqlite3.c"
 return ($10|0); //@line 45566 "c/sqlite3.c"
}
function _sqlite3PcacheFetchFinish($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($2)) + 4|0); //@line 45670 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 45670 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 45672 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 45672 "c/sqlite3.c"
 if ($6) {
  $7 = (_pcacheFetchFinishWithInit($0,$1,$2)|0); //@line 45673 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 45679 "c/sqlite3.c"
 } else {
  $8 = ((($0)) + 12|0); //@line 45675 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 45675 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 45675 "c/sqlite3.c"
  HEAP32[$8>>2] = $10; //@line 45675 "c/sqlite3.c"
  $11 = ((($4)) + 30|0); //@line 45676 "c/sqlite3.c"
  $12 = HEAP16[$11>>1]|0; //@line 45676 "c/sqlite3.c"
  $13 = (($12) + 1)<<16>>16; //@line 45676 "c/sqlite3.c"
  HEAP16[$11>>1] = $13; //@line 45676 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 45679 "c/sqlite3.c"
 }
 return (0)|0;
}
function _pcacheFetchFinishWithInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($2)) + 4|0); //@line 45643 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 45643 "c/sqlite3.c"
 $5 = ((($4)) + 16|0); //@line 45645 "c/sqlite3.c"
 ;HEAP32[$5>>2]=0|0;HEAP32[$5+4>>2]=0|0;HEAP32[$5+8>>2]=0|0;HEAP32[$5+12>>2]=0|0;HEAP32[$5+16>>2]=0|0;HEAP32[$5+20>>2]=0|0; //@line 45645 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 45646 "c/sqlite3.c"
 $6 = HEAP32[$2>>2]|0; //@line 45647 "c/sqlite3.c"
 $7 = ((($4)) + 4|0); //@line 45647 "c/sqlite3.c"
 HEAP32[$7>>2] = $6; //@line 45647 "c/sqlite3.c"
 $8 = ((($4)) + 40|0); //@line 45648 "c/sqlite3.c"
 $9 = ((($4)) + 8|0); //@line 45648 "c/sqlite3.c"
 HEAP32[$9>>2] = $8; //@line 45648 "c/sqlite3.c"
 $10 = $8; //@line 45649 "c/sqlite3.c"
 $11 = $10; //@line 45649 "c/sqlite3.c"
 HEAP8[$11>>0]=0&255;HEAP8[$11+1>>0]=(0>>8)&255;HEAP8[$11+2>>0]=(0>>16)&255;HEAP8[$11+3>>0]=0>>24; //@line 45649 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 45649 "c/sqlite3.c"
 $13 = $12; //@line 45649 "c/sqlite3.c"
 HEAP8[$13>>0]=0&255;HEAP8[$13+1>>0]=(0>>8)&255;HEAP8[$13+2>>0]=(0>>16)&255;HEAP8[$13+3>>0]=0>>24; //@line 45649 "c/sqlite3.c"
 $14 = ((($4)) + 12|0); //@line 45650 "c/sqlite3.c"
 HEAP32[$14>>2] = $0; //@line 45650 "c/sqlite3.c"
 $15 = ((($4)) + 24|0); //@line 45651 "c/sqlite3.c"
 HEAP32[$15>>2] = $1; //@line 45651 "c/sqlite3.c"
 $16 = ((($4)) + 28|0); //@line 45652 "c/sqlite3.c"
 HEAP16[$16>>1] = 1; //@line 45652 "c/sqlite3.c"
 $17 = (_sqlite3PcacheFetchFinish($0,$1,$2)|0); //@line 45653 "c/sqlite3.c"
 return ($17|0); //@line 45653 "c/sqlite3.c"
}
function _pagerReleaseMapPage($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 52050 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 52050 "c/sqlite3.c"
 $3 = ((($2)) + 120|0); //@line 52051 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 52051 "c/sqlite3.c"
 $5 = (($4) + -1)|0; //@line 52051 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 52051 "c/sqlite3.c"
 $6 = ((($2)) + 136|0); //@line 52052 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 52052 "c/sqlite3.c"
 $8 = ((($0)) + 16|0); //@line 52052 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 52052 "c/sqlite3.c"
 HEAP32[$6>>2] = $0; //@line 52053 "c/sqlite3.c"
 return; //@line 52057 "c/sqlite3.c"
}
function _sqlite3PcacheRelease($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 45687 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 45687 "c/sqlite3.c"
 $3 = ((($2)) + 12|0); //@line 45687 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 45687 "c/sqlite3.c"
 $5 = (($4) + -1)|0; //@line 45687 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 45687 "c/sqlite3.c"
 $6 = ((($0)) + 30|0); //@line 45688 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 45688 "c/sqlite3.c"
 $8 = (($7) + -1)<<16>>16; //@line 45688 "c/sqlite3.c"
 HEAP16[$6>>1] = $8; //@line 45688 "c/sqlite3.c"
 $9 = ($8<<16>>16)==(0); //@line 45688 "c/sqlite3.c"
 if (!($9)) {
  return; //@line 45695 "c/sqlite3.c"
 }
 $10 = ((($0)) + 28|0); //@line 45689 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 45689 "c/sqlite3.c"
 $12 = $11 & 1; //@line 45689 "c/sqlite3.c"
 $13 = ($12<<16>>16)==(0); //@line 45689 "c/sqlite3.c"
 if ($13) {
  _pcacheManageDirtyList($0,3); //@line 45692 "c/sqlite3.c"
  return; //@line 45695 "c/sqlite3.c"
 } else {
  _pcacheUnpin($0); //@line 45690 "c/sqlite3.c"
  return; //@line 45695 "c/sqlite3.c"
 }
}
function _pcacheUnpin($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 45407 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 45407 "c/sqlite3.c"
 $3 = ((($2)) + 32|0); //@line 45407 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 45407 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 45407 "c/sqlite3.c"
 if ($5) {
  return; //@line 45412 "c/sqlite3.c"
 }
 $6 = HEAP32[(152)>>2]|0; //@line 45409 "c/sqlite3.c"
 $7 = ((($2)) + 44|0); //@line 45409 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 45409 "c/sqlite3.c"
 $9 = HEAP32[$0>>2]|0; //@line 45409 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$6 & 255]($8,$9,0); //@line 45409 "c/sqlite3.c"
 return; //@line 45412 "c/sqlite3.c"
}
function _subjRequiresPage($0) {
 $0 = $0|0;
 var $$018 = 0, $$019 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 49045 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49045 "c/sqlite3.c"
 $3 = ((($0)) + 24|0); //@line 49047 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 49047 "c/sqlite3.c"
 $5 = ((($2)) + 96|0); //@line 49049 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 49049 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 49049 "c/sqlite3.c"
 if (!($7)) {
  $$018 = 0;
  return ($$018|0); //@line 49056 "c/sqlite3.c"
 }
 $8 = ((($2)) + 92|0);
 $9 = HEAP32[$8>>2]|0;
 $$019 = 0;
 while(1) {
  $10 = (((($9) + (($$019*48)|0)|0)) + 20|0); //@line 49051 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 49051 "c/sqlite3.c"
  $12 = ($11>>>0)<($4>>>0); //@line 49051 "c/sqlite3.c"
  if (!($12)) {
   $13 = (((($9) + (($$019*48)|0)|0)) + 16|0); //@line 49051 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 49051 "c/sqlite3.c"
   $15 = (_sqlite3BitvecTestNotNull($14,$4)|0); //@line 49051 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 49051 "c/sqlite3.c"
   if ($16) {
    $$018 = 1;
    label = 6;
    break;
   }
  }
  $17 = (($$019) + 1)|0; //@line 49049 "c/sqlite3.c"
  $18 = HEAP32[$5>>2]|0; //@line 49049 "c/sqlite3.c"
  $19 = ($17|0)<($18|0); //@line 49049 "c/sqlite3.c"
  if ($19) {
   $$019 = $17;
  } else {
   $$018 = 0;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  return ($$018|0); //@line 49056 "c/sqlite3.c"
 }
 return (0)|0;
}
function _subjournalPage($0) {
 $0 = $0|0;
 var $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 52457 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 52457 "c/sqlite3.c"
 $3 = ((($2)) + 5|0); //@line 52458 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 52458 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(2); //@line 52458 "c/sqlite3.c"
 if (!($5)) {
  $6 = (_openSubJournal($2)|0); //@line 52468 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 52472 "c/sqlite3.c"
  if (!($7)) {
   $$2 = $6;
   return ($$2|0); //@line 52495 "c/sqlite3.c"
  }
  $8 = ((($0)) + 4|0); //@line 52473 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 52473 "c/sqlite3.c"
  $10 = ((($2)) + 52|0); //@line 52474 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 52474 "c/sqlite3.c"
  $12 = ((($2)) + 152|0); //@line 52474 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 52474 "c/sqlite3.c"
  $14 = (($13) + 4)|0; //@line 52474 "c/sqlite3.c"
  $15 = ($14|0)<(0); //@line 52474 "c/sqlite3.c"
  $16 = $15 << 31 >> 31; //@line 52474 "c/sqlite3.c"
  $17 = (___muldi3(($14|0),($16|0),($11|0),0)|0); //@line 52474 "c/sqlite3.c"
  $18 = tempRet0; //@line 52474 "c/sqlite3.c"
  $19 = ((($2)) + 68|0); //@line 52484 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 52484 "c/sqlite3.c"
  $21 = ((($0)) + 24|0); //@line 52484 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 52484 "c/sqlite3.c"
  $23 = (_write32bits($20,$17,$18,$22)|0); //@line 52484 "c/sqlite3.c"
  $24 = ($23|0)==(0); //@line 52485 "c/sqlite3.c"
  if (!($24)) {
   $$2 = $23;
   return ($$2|0); //@line 52495 "c/sqlite3.c"
  }
  $25 = (_i64Add(($17|0),($18|0),4,0)|0); //@line 52486 "c/sqlite3.c"
  $26 = tempRet0; //@line 52486 "c/sqlite3.c"
  $27 = HEAP32[$19>>2]|0; //@line 52486 "c/sqlite3.c"
  $28 = HEAP32[$12>>2]|0; //@line 52486 "c/sqlite3.c"
  $29 = (_sqlite3OsWrite($27,$9,$28,$25,$26)|0); //@line 52486 "c/sqlite3.c"
  $30 = ($29|0)==(0); //@line 52490 "c/sqlite3.c"
  if (!($30)) {
   $$2 = $29;
   return ($$2|0); //@line 52495 "c/sqlite3.c"
  }
 }
 $31 = ((($2)) + 52|0); //@line 52491 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 52491 "c/sqlite3.c"
 $33 = (($32) + 1)|0; //@line 52491 "c/sqlite3.c"
 HEAP32[$31>>2] = $33; //@line 52491 "c/sqlite3.c"
 $34 = ((($0)) + 24|0); //@line 52493 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 52493 "c/sqlite3.c"
 $36 = (_addToSavepointBitvecs($2,$35)|0); //@line 52493 "c/sqlite3.c"
 $$2 = $36;
 return ($$2|0); //@line 52495 "c/sqlite3.c"
}
function _openSubJournal($0) {
 $0 = $0|0;
 var $$0 = 0, $$011 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 68|0); //@line 52431 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 52431 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 52431 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 52431 "c/sqlite3.c"
 if (!($4)) {
  $$011 = 0;
  return ($$011|0); //@line 52441 "c/sqlite3.c"
 }
 $5 = ((($0)) + 5|0); //@line 52436 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 52436 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(4); //@line 52436 "c/sqlite3.c"
 if ($7) {
  label = 4;
 } else {
  $8 = HEAP32[(48)>>2]|0; //@line 52435 "c/sqlite3.c"
  $9 = ((($0)) + 21|0); //@line 52436 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 52436 "c/sqlite3.c"
  $11 = ($10<<24>>24)==(0); //@line 52436 "c/sqlite3.c"
  if ($11) {
   $$0 = $8;
  } else {
   label = 4;
  }
 }
 if ((label|0) == 4) {
  $$0 = -1;
 }
 $12 = HEAP32[$0>>2]|0; //@line 52439 "c/sqlite3.c"
 $13 = (_sqlite3JournalOpen($12,0,$2,8222,$$0)|0); //@line 52439 "c/sqlite3.c"
 $$011 = $13;
 return ($$011|0); //@line 52441 "c/sqlite3.c"
}
function _sqlite3JournalIsInMemory($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 90979 "c/sqlite3.c"
 $2 = ($1|0)==(4880|0); //@line 90979 "c/sqlite3.c"
 $3 = $2&1; //@line 90979 "c/sqlite3.c"
 return ($3|0); //@line 90979 "c/sqlite3.c"
}
function _sqlite3OsTruncate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 20907 "c/sqlite3.c"
 $4 = ((($3)) + 16|0); //@line 20907 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 20907 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iiii[$5 & 127]($0,$1,$2)|0); //@line 20907 "c/sqlite3.c"
 return ($6|0); //@line 20907 "c/sqlite3.c"
}
function _pagerPlaybackSavepoint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$07990 = 0, $$080 = 0, $$082 = 0, $$085 = 0, $$2$lcssa = 0, $$3$lcssa = 0, $$5$lcssa = 0, $$6 = 0, $$in = 0, $$ph100 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0;
 var $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0;
 var $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0;
 var $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0;
 var $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond88 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = sp + 8|0;
 $4 = ($1|0)!=(0|0); //@line 51376 "c/sqlite3.c"
 if ($4) {
  $5 = ((($1)) + 20|0); //@line 51377 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 51377 "c/sqlite3.c"
  $7 = (_sqlite3BitvecCreate($6)|0); //@line 51377 "c/sqlite3.c"
  $8 = ($7|0)==(0|0); //@line 51378 "c/sqlite3.c"
  if ($8) {
   $$082 = 7;
   STACKTOP = sp;return ($$082|0); //@line 51472 "c/sqlite3.c"
  } else {
   $$080 = $7;
  }
 } else {
  $$080 = 0;
 }
 $9 = ((($1)) + 20|0); //@line 51386 "c/sqlite3.c"
 $10 = ((($0)) + 28|0); //@line 51386 "c/sqlite3.c"
 $$in = $4 ? $9 : $10; //@line 51386 "c/sqlite3.c"
 $11 = HEAP32[$$in>>2]|0; //@line 51386 "c/sqlite3.c"
 $12 = ((($0)) + 24|0); //@line 51386 "c/sqlite3.c"
 HEAP32[$12>>2] = $11; //@line 51386 "c/sqlite3.c"
 $13 = ((($0)) + 12|0); //@line 51387 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 51387 "c/sqlite3.c"
 $15 = ((($0)) + 18|0); //@line 51387 "c/sqlite3.c"
 HEAP8[$15>>0] = $14; //@line 51387 "c/sqlite3.c"
 L5: do {
  if ($4) {
   $27 = ((($0)) + 72|0); //@line 51398 "c/sqlite3.c"
   $28 = $27; //@line 51398 "c/sqlite3.c"
   $29 = $28; //@line 51398 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 51398 "c/sqlite3.c"
   $31 = (($28) + 4)|0; //@line 51398 "c/sqlite3.c"
   $32 = $31; //@line 51398 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 51398 "c/sqlite3.c"
   $34 = ((($0)) + 212|0); //@line 51408 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 51408 "c/sqlite3.c"
   $36 = ($35|0)==(0|0); //@line 51408 "c/sqlite3.c"
   if ($36) {
    $37 = ((($1)) + 8|0); //@line 51409 "c/sqlite3.c"
    $38 = $37; //@line 51409 "c/sqlite3.c"
    $39 = $38; //@line 51409 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 51409 "c/sqlite3.c"
    $41 = (($38) + 4)|0; //@line 51409 "c/sqlite3.c"
    $42 = $41; //@line 51409 "c/sqlite3.c"
    $43 = HEAP32[$42>>2]|0; //@line 51409 "c/sqlite3.c"
    $44 = ($40|0)==(0); //@line 51409 "c/sqlite3.c"
    $45 = ($43|0)==(0); //@line 51409 "c/sqlite3.c"
    $46 = $44 & $45; //@line 51409 "c/sqlite3.c"
    $47 = $46 ? $30 : $40; //@line 51409 "c/sqlite3.c"
    $48 = $46 ? $33 : $43; //@line 51409 "c/sqlite3.c"
    $49 = $1; //@line 51410 "c/sqlite3.c"
    $50 = $49; //@line 51410 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 51410 "c/sqlite3.c"
    $52 = (($49) + 4)|0; //@line 51410 "c/sqlite3.c"
    $53 = $52; //@line 51410 "c/sqlite3.c"
    $54 = HEAP32[$53>>2]|0; //@line 51410 "c/sqlite3.c"
    $55 = $27; //@line 51410 "c/sqlite3.c"
    $56 = $55; //@line 51410 "c/sqlite3.c"
    HEAP32[$56>>2] = $51; //@line 51410 "c/sqlite3.c"
    $57 = (($55) + 4)|0; //@line 51410 "c/sqlite3.c"
    $58 = $57; //@line 51410 "c/sqlite3.c"
    HEAP32[$58>>2] = $54; //@line 51410 "c/sqlite3.c"
    while(1) {
     $59 = $27; //@line 51411 "c/sqlite3.c"
     $60 = $59; //@line 51411 "c/sqlite3.c"
     $61 = HEAP32[$60>>2]|0; //@line 51411 "c/sqlite3.c"
     $62 = (($59) + 4)|0; //@line 51411 "c/sqlite3.c"
     $63 = $62; //@line 51411 "c/sqlite3.c"
     $64 = HEAP32[$63>>2]|0; //@line 51411 "c/sqlite3.c"
     $65 = ($64|0)<($48|0); //@line 51411 "c/sqlite3.c"
     $66 = ($61>>>0)<($47>>>0); //@line 51411 "c/sqlite3.c"
     $67 = ($64|0)==($48|0); //@line 51411 "c/sqlite3.c"
     $68 = $67 & $66; //@line 51411 "c/sqlite3.c"
     $69 = $65 | $68; //@line 51411 "c/sqlite3.c"
     if (!($69)) {
      $$ph100 = $27;$87 = $33;$89 = $30;
      label = 12;
      break L5;
     }
     $70 = (_pager_playback_one_page($0,$27,$$080,1,1)|0); //@line 51412 "c/sqlite3.c"
     $71 = ($70|0)==(0); //@line 51411 "c/sqlite3.c"
     if (!($71)) {
      $$2$lcssa = $70;$168 = $27;$171 = $30;$174 = $33;
      break;
     }
    }
   } else {
    $175 = $30;$176 = $33;$72 = $27;
    label = 11;
   }
  } else {
   $16 = ((($0)) + 212|0); //@line 51389 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 51389 "c/sqlite3.c"
   $18 = ($17|0)==(0|0); //@line 51389 "c/sqlite3.c"
   if ($18) {
    $20 = ((($0)) + 72|0); //@line 51398 "c/sqlite3.c"
    $21 = $20; //@line 51398 "c/sqlite3.c"
    $22 = $21; //@line 51398 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 51398 "c/sqlite3.c"
    $24 = (($21) + 4)|0; //@line 51398 "c/sqlite3.c"
    $25 = $24; //@line 51398 "c/sqlite3.c"
    $26 = HEAP32[$25>>2]|0; //@line 51398 "c/sqlite3.c"
    $175 = $23;$176 = $26;$72 = $20;
    label = 11;
    break;
   }
   $19 = (_pagerRollbackWal($0)|0); //@line 51390 "c/sqlite3.c"
   $$082 = $19;
   STACKTOP = sp;return ($$082|0); //@line 51472 "c/sqlite3.c"
  }
 } while(0);
 if ((label|0) == 11) {
  $73 = $72; //@line 51416 "c/sqlite3.c"
  $74 = $73; //@line 51416 "c/sqlite3.c"
  HEAP32[$74>>2] = 0; //@line 51416 "c/sqlite3.c"
  $75 = (($73) + 4)|0; //@line 51416 "c/sqlite3.c"
  $76 = $75; //@line 51416 "c/sqlite3.c"
  HEAP32[$76>>2] = 0; //@line 51416 "c/sqlite3.c"
  $$ph100 = $72;$87 = $176;$89 = $175;
  label = 12;
 }
 L18: do {
  if ((label|0) == 12) {
   $77 = ((($0)) + 80|0);
   $78 = ((($0)) + 148|0);
   $79 = ((($0)) + 152|0);
   while(1) {
    $80 = $$ph100; //@line 51424 "c/sqlite3.c"
    $81 = $80; //@line 51424 "c/sqlite3.c"
    $82 = HEAP32[$81>>2]|0; //@line 51424 "c/sqlite3.c"
    $83 = (($80) + 4)|0; //@line 51424 "c/sqlite3.c"
    $84 = $83; //@line 51424 "c/sqlite3.c"
    $85 = HEAP32[$84>>2]|0; //@line 51424 "c/sqlite3.c"
    $86 = ($85|0)<($87|0); //@line 51424 "c/sqlite3.c"
    $88 = ($82>>>0)<($89>>>0); //@line 51424 "c/sqlite3.c"
    $90 = ($85|0)==($87|0); //@line 51424 "c/sqlite3.c"
    $91 = $90 & $88; //@line 51424 "c/sqlite3.c"
    $92 = $86 | $91; //@line 51424 "c/sqlite3.c"
    if (!($92)) {
     $$2$lcssa = 0;$168 = $$ph100;$171 = $89;$174 = $87;
     break L18;
    }
    HEAP32[$2>>2] = 0; //@line 51426 "c/sqlite3.c"
    $93 = (_readJournalHdr($0,0,$89,$87,$2,$3)|0); //@line 51428 "c/sqlite3.c"
    $94 = HEAP32[$2>>2]|0; //@line 51436 "c/sqlite3.c"
    $95 = ($94|0)==(0); //@line 51436 "c/sqlite3.c"
    if ($95) {
     $96 = $77; //@line 51437 "c/sqlite3.c"
     $97 = $96; //@line 51437 "c/sqlite3.c"
     $98 = HEAP32[$97>>2]|0; //@line 51437 "c/sqlite3.c"
     $99 = (($96) + 4)|0; //@line 51437 "c/sqlite3.c"
     $100 = $99; //@line 51437 "c/sqlite3.c"
     $101 = HEAP32[$100>>2]|0; //@line 51437 "c/sqlite3.c"
     $102 = HEAP32[$78>>2]|0; //@line 51437 "c/sqlite3.c"
     $103 = (_i64Add(($98|0),($101|0),($102|0),0)|0); //@line 51437 "c/sqlite3.c"
     $104 = tempRet0; //@line 51437 "c/sqlite3.c"
     $105 = $$ph100; //@line 51437 "c/sqlite3.c"
     $106 = $105; //@line 51437 "c/sqlite3.c"
     $107 = HEAP32[$106>>2]|0; //@line 51437 "c/sqlite3.c"
     $108 = (($105) + 4)|0; //@line 51437 "c/sqlite3.c"
     $109 = $108; //@line 51437 "c/sqlite3.c"
     $110 = HEAP32[$109>>2]|0; //@line 51437 "c/sqlite3.c"
     $111 = ($103|0)==($107|0); //@line 51437 "c/sqlite3.c"
     $112 = ($104|0)==($110|0); //@line 51437 "c/sqlite3.c"
     $113 = $111 & $112; //@line 51437 "c/sqlite3.c"
     if ($113) {
      $114 = (_i64Subtract(($89|0),($87|0),($107|0),($110|0))|0); //@line 51439 "c/sqlite3.c"
      $115 = tempRet0; //@line 51439 "c/sqlite3.c"
      $116 = HEAP32[$79>>2]|0; //@line 51439 "c/sqlite3.c"
      $117 = (($116) + 8)|0; //@line 51439 "c/sqlite3.c"
      $118 = ($117|0)<(0); //@line 51439 "c/sqlite3.c"
      $119 = $118 << 31 >> 31; //@line 51439 "c/sqlite3.c"
      $120 = (___divdi3(($114|0),($115|0),($117|0),($119|0))|0); //@line 51439 "c/sqlite3.c"
      $121 = tempRet0; //@line 51439 "c/sqlite3.c"
      HEAP32[$2>>2] = $120; //@line 51439 "c/sqlite3.c"
     }
    }
    $122 = ($93|0)==(0); //@line 51441 "c/sqlite3.c"
    $123 = HEAP32[$2>>2]|0; //@line 51441 "c/sqlite3.c"
    $124 = ($123|0)!=(0); //@line 51441 "c/sqlite3.c"
    $or$cond88 = $122 & $124; //@line 51441 "c/sqlite3.c"
    L27: do {
     if ($or$cond88) {
      $125 = HEAP32[$2>>2]|0;
      $$07990 = 0;
      while(1) {
       $126 = $$ph100; //@line 51441 "c/sqlite3.c"
       $127 = $126; //@line 51441 "c/sqlite3.c"
       $128 = HEAP32[$127>>2]|0; //@line 51441 "c/sqlite3.c"
       $129 = (($126) + 4)|0; //@line 51441 "c/sqlite3.c"
       $130 = $129; //@line 51441 "c/sqlite3.c"
       $131 = HEAP32[$130>>2]|0; //@line 51441 "c/sqlite3.c"
       $132 = ($131|0)<($87|0); //@line 51441 "c/sqlite3.c"
       $133 = ($128>>>0)<($89>>>0); //@line 51441 "c/sqlite3.c"
       $134 = ($131|0)==($87|0); //@line 51441 "c/sqlite3.c"
       $135 = $134 & $133; //@line 51441 "c/sqlite3.c"
       $136 = $132 | $135; //@line 51441 "c/sqlite3.c"
       if (!($136)) {
        $$3$lcssa = 0;
        break L27;
       }
       $137 = (_pager_playback_one_page($0,$$ph100,$$080,1,1)|0); //@line 51442 "c/sqlite3.c"
       $138 = (($$07990) + 1)|0; //@line 51441 "c/sqlite3.c"
       $139 = ($137|0)==(0); //@line 51441 "c/sqlite3.c"
       $140 = ($138>>>0)<($125>>>0); //@line 51441 "c/sqlite3.c"
       $or$cond = $139 & $140; //@line 51441 "c/sqlite3.c"
       if ($or$cond) {
        $$07990 = $138;
       } else {
        $$3$lcssa = $137;
        break;
       }
      }
     } else {
      $$3$lcssa = $93;
     }
    } while(0);
    $141 = ($$3$lcssa|0)==(0); //@line 51424 "c/sqlite3.c"
    if (!($141)) {
     $$2$lcssa = $$3$lcssa;$168 = $$ph100;$171 = $89;$174 = $87;
     break;
    }
   }
  }
 } while(0);
 if ($4) {
  $142 = ((($1)) + 24|0); //@line 51454 "c/sqlite3.c"
  $143 = HEAP32[$142>>2]|0; //@line 51454 "c/sqlite3.c"
  $144 = ((($0)) + 152|0); //@line 51454 "c/sqlite3.c"
  $145 = HEAP32[$144>>2]|0; //@line 51454 "c/sqlite3.c"
  $146 = (($145) + 4)|0; //@line 51454 "c/sqlite3.c"
  $147 = ($146|0)<(0); //@line 51454 "c/sqlite3.c"
  $148 = $147 << 31 >> 31; //@line 51454 "c/sqlite3.c"
  $149 = (___muldi3(($146|0),($148|0),($143|0),0)|0); //@line 51454 "c/sqlite3.c"
  $150 = tempRet0; //@line 51454 "c/sqlite3.c"
  $151 = $2; //@line 51454 "c/sqlite3.c"
  $152 = $151; //@line 51454 "c/sqlite3.c"
  HEAP32[$152>>2] = $149; //@line 51454 "c/sqlite3.c"
  $153 = (($151) + 4)|0; //@line 51454 "c/sqlite3.c"
  $154 = $153; //@line 51454 "c/sqlite3.c"
  HEAP32[$154>>2] = $150; //@line 51454 "c/sqlite3.c"
  $155 = ((($0)) + 212|0); //@line 51456 "c/sqlite3.c"
  $156 = HEAP32[$155>>2]|0; //@line 51456 "c/sqlite3.c"
  $157 = ($156|0)==(0|0); //@line 51456 "c/sqlite3.c"
  if ($157) {
   $159 = ($$2$lcssa|0)==(0); //@line 51459 "c/sqlite3.c"
   if ($159) {
    label = 26;
   } else {
    $$5$lcssa = $$2$lcssa;
   }
  } else {
   $158 = ((($1)) + 28|0); //@line 51457 "c/sqlite3.c"
   _sqlite3WalSavepointUndo($156,$158); //@line 51457 "c/sqlite3.c"
   label = 26;
  }
  L39: do {
   if ((label|0) == 26) {
    $160 = ((($0)) + 52|0); //@line 51459 "c/sqlite3.c"
    $161 = HEAP32[$142>>2]|0; //@line 51459 "c/sqlite3.c"
    $$085 = $161;
    while(1) {
     $162 = HEAP32[$160>>2]|0; //@line 51459 "c/sqlite3.c"
     $163 = ($$085>>>0)<($162>>>0); //@line 51459 "c/sqlite3.c"
     if (!($163)) {
      $$5$lcssa = 0;
      break L39;
     }
     $164 = (_pager_playback_one_page($0,$2,$$080,0,1)|0); //@line 51461 "c/sqlite3.c"
     $165 = (($$085) + 1)|0; //@line 51459 "c/sqlite3.c"
     $166 = ($164|0)==(0); //@line 51459 "c/sqlite3.c"
     if ($166) {
      $$085 = $165;
     } else {
      $$5$lcssa = $164;
      break;
     }
    }
   }
  } while(0);
  $$6 = $$5$lcssa;
 } else {
  $$6 = $$2$lcssa;
 }
 _sqlite3BitvecDestroy($$080); //@line 51466 "c/sqlite3.c"
 $167 = ($$6|0)==(0); //@line 51467 "c/sqlite3.c"
 if (!($167)) {
  $$082 = $$6;
  STACKTOP = sp;return ($$082|0); //@line 51472 "c/sqlite3.c"
 }
 $169 = $168; //@line 51468 "c/sqlite3.c"
 $170 = $169; //@line 51468 "c/sqlite3.c"
 HEAP32[$170>>2] = $171; //@line 51468 "c/sqlite3.c"
 $172 = (($169) + 4)|0; //@line 51468 "c/sqlite3.c"
 $173 = $172; //@line 51468 "c/sqlite3.c"
 HEAP32[$173>>2] = $174; //@line 51468 "c/sqlite3.c"
 $$082 = 0;
 STACKTOP = sp;return ($$082|0); //@line 51472 "c/sqlite3.c"
}
function _pagerRollbackWal($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $$01617 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 28|0); //@line 51118 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 51118 "c/sqlite3.c"
 $3 = ((($0)) + 24|0); //@line 51118 "c/sqlite3.c"
 HEAP32[$3>>2] = $2; //@line 51118 "c/sqlite3.c"
 $4 = ((($0)) + 212|0); //@line 51119 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 51119 "c/sqlite3.c"
 $6 = (_sqlite3WalUndo($5,$0)|0); //@line 51119 "c/sqlite3.c"
 $7 = ((($0)) + 208|0); //@line 51120 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 51120 "c/sqlite3.c"
 $9 = (_sqlite3PcacheDirtyList($8)|0); //@line 51120 "c/sqlite3.c"
 $10 = ($9|0)!=(0|0); //@line 51121 "c/sqlite3.c"
 $11 = ($6|0)==(0); //@line 51121 "c/sqlite3.c"
 $12 = $10 & $11; //@line 51121 "c/sqlite3.c"
 if (!($12)) {
  $$0$lcssa = $6;
  return ($$0$lcssa|0); //@line 51127 "c/sqlite3.c"
 }
 $$01617 = $9;
 while(1) {
  $13 = ((($$01617)) + 16|0); //@line 51122 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 51122 "c/sqlite3.c"
  $15 = ((($$01617)) + 24|0); //@line 51123 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 51123 "c/sqlite3.c"
  $17 = (_pagerUndoCallback($0,$16)|0); //@line 51123 "c/sqlite3.c"
  $18 = ($14|0)!=(0|0); //@line 51121 "c/sqlite3.c"
  $19 = ($17|0)==(0); //@line 51121 "c/sqlite3.c"
  $20 = $18 & $19; //@line 51121 "c/sqlite3.c"
  if ($20) {
   $$01617 = $14;
  } else {
   $$0$lcssa = $17;
   break;
  }
 }
 return ($$0$lcssa|0); //@line 51127 "c/sqlite3.c"
}
function _pager_playback_one_page($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$084 = 0, $$2 = 0, $$in = 0, $$lobit = 0, $$old1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond4 = 0;
 var $phitmp = 0, $storemerge = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp + 8|0;
 $6 = sp + 4|0;
 $7 = sp;
 $8 = ((($0)) + 204|0); //@line 50267 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 50267 "c/sqlite3.c"
 $10 = ($3|0)!=(0); //@line 50285 "c/sqlite3.c"
 $11 = ((($0)) + 64|0); //@line 50285 "c/sqlite3.c"
 $12 = ((($0)) + 68|0); //@line 50285 "c/sqlite3.c"
 $$in = $10 ? $11 : $12; //@line 50285 "c/sqlite3.c"
 $13 = HEAP32[$$in>>2]|0; //@line 50285 "c/sqlite3.c"
 $14 = $1; //@line 50286 "c/sqlite3.c"
 $15 = $14; //@line 50286 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 50286 "c/sqlite3.c"
 $17 = (($14) + 4)|0; //@line 50286 "c/sqlite3.c"
 $18 = $17; //@line 50286 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 50286 "c/sqlite3.c"
 $20 = (_read32bits($13,$16,$19,$6)|0); //@line 50286 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 50287 "c/sqlite3.c"
 if (!($21)) {
  $$0 = $20;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 $22 = ((($0)) + 152|0); //@line 50288 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 50288 "c/sqlite3.c"
 $24 = $1; //@line 50288 "c/sqlite3.c"
 $25 = $24; //@line 50288 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 50288 "c/sqlite3.c"
 $27 = (($24) + 4)|0; //@line 50288 "c/sqlite3.c"
 $28 = $27; //@line 50288 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 50288 "c/sqlite3.c"
 $30 = (_i64Add(($26|0),($29|0),4,0)|0); //@line 50288 "c/sqlite3.c"
 $31 = tempRet0; //@line 50288 "c/sqlite3.c"
 $32 = (_sqlite3OsRead($13,$9,$23,$30,$31)|0); //@line 50288 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 50289 "c/sqlite3.c"
 if (!($33)) {
  $$0 = $32;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 $34 = HEAP32[$22>>2]|0; //@line 50290 "c/sqlite3.c"
 $35 = $3 << 2; //@line 50290 "c/sqlite3.c"
 $36 = (($35) + 4)|0; //@line 50290 "c/sqlite3.c"
 $37 = (($36) + ($34))|0; //@line 50290 "c/sqlite3.c"
 $38 = ($37|0)<(0); //@line 50290 "c/sqlite3.c"
 $39 = $38 << 31 >> 31; //@line 50290 "c/sqlite3.c"
 $40 = $1; //@line 50290 "c/sqlite3.c"
 $41 = $40; //@line 50290 "c/sqlite3.c"
 $42 = HEAP32[$41>>2]|0; //@line 50290 "c/sqlite3.c"
 $43 = (($40) + 4)|0; //@line 50290 "c/sqlite3.c"
 $44 = $43; //@line 50290 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 50290 "c/sqlite3.c"
 $46 = (_i64Add(($42|0),($45|0),($37|0),($39|0))|0); //@line 50290 "c/sqlite3.c"
 $47 = tempRet0; //@line 50290 "c/sqlite3.c"
 $48 = $1; //@line 50290 "c/sqlite3.c"
 $49 = $48; //@line 50290 "c/sqlite3.c"
 HEAP32[$49>>2] = $46; //@line 50290 "c/sqlite3.c"
 $50 = (($48) + 4)|0; //@line 50290 "c/sqlite3.c"
 $51 = $50; //@line 50290 "c/sqlite3.c"
 HEAP32[$51>>2] = $47; //@line 50290 "c/sqlite3.c"
 $52 = HEAP32[$6>>2]|0; //@line 50297 "c/sqlite3.c"
 $53 = ($52|0)==(0); //@line 50297 "c/sqlite3.c"
 if ($53) {
  $$0 = 101;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 $54 = HEAP32[513]|0; //@line 50297 "c/sqlite3.c"
 $55 = (($54|0) / ($34|0))&-1; //@line 50297 "c/sqlite3.c"
 $56 = (($55) + 1)|0; //@line 50297 "c/sqlite3.c"
 $57 = ($52|0)==($56|0); //@line 50297 "c/sqlite3.c"
 if ($57) {
  $$0 = 101;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 $58 = ((($0)) + 24|0); //@line 50301 "c/sqlite3.c"
 $59 = HEAP32[$58>>2]|0; //@line 50301 "c/sqlite3.c"
 $60 = ($52>>>0)>($59>>>0); //@line 50301 "c/sqlite3.c"
 if ($60) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 $61 = (_sqlite3BitvecTest($2,$52)|0); //@line 50301 "c/sqlite3.c"
 $62 = ($61|0)==(0); //@line 50301 "c/sqlite3.c"
 if (!($62)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 if ($10) {
  $63 = (_i64Add(($46|0),($47|0),-4,-1)|0); //@line 50305 "c/sqlite3.c"
  $64 = tempRet0; //@line 50305 "c/sqlite3.c"
  $65 = (_read32bits($13,$63,$64,$7)|0); //@line 50305 "c/sqlite3.c"
  $66 = ($65|0)==(0); //@line 50306 "c/sqlite3.c"
  if (!($66)) {
   $$0 = $65;
   STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
  }
  $67 = ($4|0)==(0); //@line 50307 "c/sqlite3.c"
  if ($67) {
   $68 = (_pager_cksum($0,$9)|0); //@line 50307 "c/sqlite3.c"
   $69 = HEAP32[$7>>2]|0; //@line 50307 "c/sqlite3.c"
   $70 = ($68|0)==($69|0); //@line 50307 "c/sqlite3.c"
   if (!($70)) {
    $$0 = 101;
    STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
   }
  }
 }
 $71 = ($2|0)==(0|0); //@line 50315 "c/sqlite3.c"
 if (!($71)) {
  $72 = (_sqlite3BitvecSet($2,$52)|0); //@line 50315 "c/sqlite3.c"
  $73 = ($72|0)==(0); //@line 50315 "c/sqlite3.c"
  if (!($73)) {
   $$0 = $72;
   STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
  }
 }
 $74 = ($52|0)==(1); //@line 50321 "c/sqlite3.c"
 if ($74) {
  $75 = ((($0)) + 142|0); //@line 50321 "c/sqlite3.c"
  $76 = HEAP16[$75>>1]|0; //@line 50321 "c/sqlite3.c"
  $77 = $76 << 16 >> 16; //@line 50321 "c/sqlite3.c"
  $78 = ((($9)) + 20|0); //@line 50321 "c/sqlite3.c"
  $79 = HEAP8[$78>>0]|0; //@line 50321 "c/sqlite3.c"
  $80 = $79&255; //@line 50321 "c/sqlite3.c"
  $81 = ($77|0)==($80|0); //@line 50321 "c/sqlite3.c"
  if (!($81)) {
   $82 = $79&255; //@line 50322 "c/sqlite3.c"
   HEAP16[$75>>1] = $82; //@line 50322 "c/sqlite3.c"
  }
 }
 $83 = ((($0)) + 212|0); //@line 50361 "c/sqlite3.c"
 $84 = HEAP32[$83>>2]|0; //@line 50361 "c/sqlite3.c"
 $85 = ($84|0)==(0|0); //@line 50361 "c/sqlite3.c"
 if ($85) {
  $86 = (_sqlite3PagerLookup($0,$52)|0); //@line 50364 "c/sqlite3.c"
  $storemerge = $86;
 } else {
  $storemerge = 0;
 }
 HEAP32[$5>>2] = $storemerge;
 if ($10) {
  $87 = ((($0)) + 7|0); //@line 50373 "c/sqlite3.c"
  $88 = HEAP8[$87>>0]|0; //@line 50373 "c/sqlite3.c"
  $89 = ($88<<24>>24)==(0); //@line 50373 "c/sqlite3.c"
  if ($89) {
   $90 = $1; //@line 50373 "c/sqlite3.c"
   $91 = $90; //@line 50373 "c/sqlite3.c"
   $92 = HEAP32[$91>>2]|0; //@line 50373 "c/sqlite3.c"
   $93 = (($90) + 4)|0; //@line 50373 "c/sqlite3.c"
   $94 = $93; //@line 50373 "c/sqlite3.c"
   $95 = HEAP32[$94>>2]|0; //@line 50373 "c/sqlite3.c"
   $96 = ((($0)) + 80|0); //@line 50373 "c/sqlite3.c"
   $97 = $96; //@line 50373 "c/sqlite3.c"
   $98 = $97; //@line 50373 "c/sqlite3.c"
   $99 = HEAP32[$98>>2]|0; //@line 50373 "c/sqlite3.c"
   $100 = (($97) + 4)|0; //@line 50373 "c/sqlite3.c"
   $101 = $100; //@line 50373 "c/sqlite3.c"
   $102 = HEAP32[$101>>2]|0; //@line 50373 "c/sqlite3.c"
   $103 = ($95|0)<($102|0); //@line 50373 "c/sqlite3.c"
   $104 = ($92>>>0)<=($99>>>0); //@line 50373 "c/sqlite3.c"
   $105 = ($95|0)==($102|0); //@line 50373 "c/sqlite3.c"
   $106 = $105 & $104; //@line 50373 "c/sqlite3.c"
   $107 = $103 | $106; //@line 50373 "c/sqlite3.c"
   $phitmp = $107&1; //@line 50373 "c/sqlite3.c"
   $$084 = $phitmp;
  } else {
   $$084 = 1;
  }
 } else {
  $108 = ($storemerge|0)==(0|0); //@line 50375 "c/sqlite3.c"
  if ($108) {
   $$084 = 1;
  } else {
   $109 = ((($storemerge)) + 28|0); //@line 50375 "c/sqlite3.c"
   $110 = HEAP16[$109>>1]|0; //@line 50375 "c/sqlite3.c"
   $111 = ($110&65535) >>> 3; //@line 50375 "c/sqlite3.c"
   $$lobit = $111 & 1; //@line 50375 "c/sqlite3.c"
   $112 = $$lobit ^ 1; //@line 50375 "c/sqlite3.c"
   $113 = $112&65535; //@line 50375 "c/sqlite3.c"
   $$084 = $113;
  }
 }
 $114 = ((($0)) + 60|0); //@line 50377 "c/sqlite3.c"
 $115 = HEAP32[$114>>2]|0; //@line 50377 "c/sqlite3.c"
 $116 = HEAP32[$115>>2]|0; //@line 50377 "c/sqlite3.c"
 $117 = ($116|0)==(0|0); //@line 50377 "c/sqlite3.c"
 do {
  if ($117) {
   label = 31;
  } else {
   $118 = ((($0)) + 16|0); //@line 50378 "c/sqlite3.c"
   $119 = HEAP8[$118>>0]|0; //@line 50378 "c/sqlite3.c"
   $120 = ($119&255)>(3); //@line 50378 "c/sqlite3.c"
   if ($120) {
    $$old1 = ($$084|0)==(0); //@line 50379 "c/sqlite3.c"
    if ($$old1) {
     label = 31;
     break;
    }
   } else {
    $121 = ($119<<24>>24)==(0); //@line 50378 "c/sqlite3.c"
    $122 = ($$084|0)!=(0); //@line 50379 "c/sqlite3.c"
    $or$cond = $122 & $121; //@line 50379 "c/sqlite3.c"
    if (!($or$cond)) {
     label = 31;
     break;
    }
   }
   $123 = (($52) + -1)|0; //@line 50381 "c/sqlite3.c"
   $124 = HEAP32[$22>>2]|0; //@line 50381 "c/sqlite3.c"
   $125 = ($124|0)<(0); //@line 50381 "c/sqlite3.c"
   $126 = $125 << 31 >> 31; //@line 50381 "c/sqlite3.c"
   $127 = (___muldi3(($124|0),($126|0),($123|0),0)|0); //@line 50381 "c/sqlite3.c"
   $128 = tempRet0; //@line 50381 "c/sqlite3.c"
   $129 = (_sqlite3OsWrite($115,$9,$124,$127,$128)|0); //@line 50398 "c/sqlite3.c"
   $130 = ((($0)) + 32|0); //@line 50400 "c/sqlite3.c"
   $131 = HEAP32[$130>>2]|0; //@line 50400 "c/sqlite3.c"
   $132 = ($52>>>0)>($131>>>0); //@line 50400 "c/sqlite3.c"
   if ($132) {
    HEAP32[$130>>2] = $52; //@line 50401 "c/sqlite3.c"
   }
   $133 = ((($0)) + 88|0); //@line 50403 "c/sqlite3.c"
   $134 = HEAP32[$133>>2]|0; //@line 50403 "c/sqlite3.c"
   $135 = ($134|0)==(0|0); //@line 50403 "c/sqlite3.c"
   if ($135) {
    $$2 = $129;
   } else {
    _sqlite3BackupUpdate($134,$52,$9); //@line 50411 "c/sqlite3.c"
    $$2 = $129;
   }
  }
 } while(0);
 do {
  if ((label|0) == 31) {
   $136 = ($3|0)==(0); //@line 50413 "c/sqlite3.c"
   $137 = ($storemerge|0)==(0|0); //@line 50413 "c/sqlite3.c"
   $or$cond4 = $136 & $137; //@line 50413 "c/sqlite3.c"
   if ($or$cond4) {
    $138 = ((($0)) + 20|0); //@line 50432 "c/sqlite3.c"
    $139 = HEAP8[$138>>0]|0; //@line 50432 "c/sqlite3.c"
    $140 = $139 | 2; //@line 50432 "c/sqlite3.c"
    HEAP8[$138>>0] = $140; //@line 50432 "c/sqlite3.c"
    $141 = (_sqlite3PagerGet($0,$52,$5,1)|0); //@line 50433 "c/sqlite3.c"
    $142 = HEAP8[$138>>0]|0; //@line 50435 "c/sqlite3.c"
    $143 = $142 & -3; //@line 50435 "c/sqlite3.c"
    HEAP8[$138>>0] = $143; //@line 50435 "c/sqlite3.c"
    $144 = ($141|0)==(0); //@line 50436 "c/sqlite3.c"
    if ($144) {
     $145 = HEAP32[$5>>2]|0; //@line 50437 "c/sqlite3.c"
     _sqlite3PcacheMakeDirty($145); //@line 50437 "c/sqlite3.c"
     $$2 = 0;
     break;
    } else {
     $$0 = $141;
     STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
    }
   } else {
    $$2 = 0;
   }
  }
 } while(0);
 $146 = HEAP32[$5>>2]|0; //@line 50439 "c/sqlite3.c"
 $147 = ($146|0)==(0|0); //@line 50439 "c/sqlite3.c"
 if ($147) {
  $$0 = $$2;
  STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
 }
 $148 = ((($146)) + 4|0); //@line 50447 "c/sqlite3.c"
 $149 = HEAP32[$148>>2]|0; //@line 50447 "c/sqlite3.c"
 $150 = HEAP32[$22>>2]|0; //@line 50448 "c/sqlite3.c"
 _memcpy(($149|0),($9|0),($150|0))|0; //@line 50448 "c/sqlite3.c"
 $151 = ((($0)) + 196|0); //@line 50449 "c/sqlite3.c"
 $152 = HEAP32[$151>>2]|0; //@line 50449 "c/sqlite3.c"
 $153 = HEAP32[$5>>2]|0; //@line 50449 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$152 & 127]($153); //@line 50449 "c/sqlite3.c"
 if ($74) {
  $154 = ((($0)) + 104|0); //@line 50459 "c/sqlite3.c"
  $155 = ((($149)) + 24|0); //@line 50459 "c/sqlite3.c"
  dest=$154; src=$155; stop=dest+16|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 50459 "c/sqlite3.c"
 }
 $156 = HEAP32[$5>>2]|0; //@line 50466 "c/sqlite3.c"
 _sqlite3PcacheRelease($156); //@line 50466 "c/sqlite3.c"
 $$0 = $$2;
 STACKTOP = sp;return ($$0|0); //@line 50469 "c/sqlite3.c"
}
function _readJournalHdr($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$044$ph = 0, $$1 = 0, $$3 = 0, $$off = 0, $$off47 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0;
 var $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0;
 var $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp + 8|0;
 $7 = sp + 4|0;
 $8 = sp;
 $9 = (_journalHdrOffset($0)|0); //@line 49546 "c/sqlite3.c"
 $10 = tempRet0; //@line 49546 "c/sqlite3.c"
 $11 = ((($0)) + 72|0); //@line 49546 "c/sqlite3.c"
 $12 = $11; //@line 49546 "c/sqlite3.c"
 $13 = $12; //@line 49546 "c/sqlite3.c"
 HEAP32[$13>>2] = $9; //@line 49546 "c/sqlite3.c"
 $14 = (($12) + 4)|0; //@line 49546 "c/sqlite3.c"
 $15 = $14; //@line 49546 "c/sqlite3.c"
 HEAP32[$15>>2] = $10; //@line 49546 "c/sqlite3.c"
 $16 = ((($0)) + 148|0); //@line 49547 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 49547 "c/sqlite3.c"
 $18 = (_i64Add(($9|0),($10|0),($17|0),0)|0); //@line 49547 "c/sqlite3.c"
 $19 = tempRet0; //@line 49547 "c/sqlite3.c"
 $20 = ($19|0)>($3|0); //@line 49547 "c/sqlite3.c"
 $21 = ($18>>>0)>($2>>>0); //@line 49547 "c/sqlite3.c"
 $22 = ($19|0)==($3|0); //@line 49547 "c/sqlite3.c"
 $23 = $22 & $21; //@line 49547 "c/sqlite3.c"
 $24 = $20 | $23; //@line 49547 "c/sqlite3.c"
 if ($24) {
  $$1 = 101;
  STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
 }
 $25 = ($1|0)==(0); //@line 49557 "c/sqlite3.c"
 if ($25) {
  $26 = ((($0)) + 80|0); //@line 49557 "c/sqlite3.c"
  $27 = $26; //@line 49557 "c/sqlite3.c"
  $28 = $27; //@line 49557 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 49557 "c/sqlite3.c"
  $30 = (($27) + 4)|0; //@line 49557 "c/sqlite3.c"
  $31 = $30; //@line 49557 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 49557 "c/sqlite3.c"
  $33 = ($9|0)==($29|0); //@line 49557 "c/sqlite3.c"
  $34 = ($10|0)==($32|0); //@line 49557 "c/sqlite3.c"
  $35 = $33 & $34; //@line 49557 "c/sqlite3.c"
  if (!($35)) {
   label = 4;
  }
 } else {
  label = 4;
 }
 if ((label|0) == 4) {
  $36 = ((($0)) + 64|0); //@line 49558 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 49558 "c/sqlite3.c"
  $38 = (_sqlite3OsRead($37,$6,8,$9,$10)|0); //@line 49558 "c/sqlite3.c"
  $39 = ($38|0)==(0); //@line 49559 "c/sqlite3.c"
  if (!($39)) {
   $$1 = $38;
   STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
  }
  $40 = (_memcmp($6,18286,8)|0); //@line 49562 "c/sqlite3.c"
  $41 = ($40|0)==(0); //@line 49562 "c/sqlite3.c"
  if (!($41)) {
   $$1 = 101;
   STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
  }
 }
 $42 = ((($0)) + 64|0); //@line 49571 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 49571 "c/sqlite3.c"
 $44 = (_i64Add(($9|0),($10|0),8,0)|0); //@line 49571 "c/sqlite3.c"
 $45 = tempRet0; //@line 49571 "c/sqlite3.c"
 $46 = (_read32bits($43,$44,$45,$4)|0); //@line 49571 "c/sqlite3.c"
 $47 = ($46|0)==(0); //@line 49571 "c/sqlite3.c"
 if (!($47)) {
  $$1 = $46;
  STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
 }
 $48 = HEAP32[$42>>2]|0; //@line 49572 "c/sqlite3.c"
 $49 = (_i64Add(($9|0),($10|0),12,0)|0); //@line 49572 "c/sqlite3.c"
 $50 = tempRet0; //@line 49572 "c/sqlite3.c"
 $51 = ((($0)) + 48|0); //@line 49572 "c/sqlite3.c"
 $52 = (_read32bits($48,$49,$50,$51)|0); //@line 49572 "c/sqlite3.c"
 $53 = ($52|0)==(0); //@line 49572 "c/sqlite3.c"
 if (!($53)) {
  $$1 = $52;
  STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
 }
 $54 = HEAP32[$42>>2]|0; //@line 49573 "c/sqlite3.c"
 $55 = (_i64Add(($9|0),($10|0),16,0)|0); //@line 49573 "c/sqlite3.c"
 $56 = tempRet0; //@line 49573 "c/sqlite3.c"
 $57 = (_read32bits($54,$55,$56,$5)|0); //@line 49573 "c/sqlite3.c"
 $58 = ($57|0)==(0); //@line 49573 "c/sqlite3.c"
 if (!($58)) {
  $$1 = $57;
  STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
 }
 $59 = $11; //@line 49578 "c/sqlite3.c"
 $60 = $59; //@line 49578 "c/sqlite3.c"
 $61 = HEAP32[$60>>2]|0; //@line 49578 "c/sqlite3.c"
 $62 = (($59) + 4)|0; //@line 49578 "c/sqlite3.c"
 $63 = $62; //@line 49578 "c/sqlite3.c"
 $64 = HEAP32[$63>>2]|0; //@line 49578 "c/sqlite3.c"
 $65 = ($61|0)==(0); //@line 49578 "c/sqlite3.c"
 $66 = ($64|0)==(0); //@line 49578 "c/sqlite3.c"
 $67 = $65 & $66; //@line 49578 "c/sqlite3.c"
 do {
  if ($67) {
   $68 = HEAP32[$42>>2]|0; //@line 49583 "c/sqlite3.c"
   $69 = (_i64Add(($9|0),($10|0),20,0)|0); //@line 49583 "c/sqlite3.c"
   $70 = tempRet0; //@line 49583 "c/sqlite3.c"
   $71 = (_read32bits($68,$69,$70,$8)|0); //@line 49583 "c/sqlite3.c"
   $72 = ($71|0)==(0); //@line 49583 "c/sqlite3.c"
   if ($72) {
    $73 = HEAP32[$42>>2]|0; //@line 49584 "c/sqlite3.c"
    $74 = (_i64Add(($9|0),($10|0),24,0)|0); //@line 49584 "c/sqlite3.c"
    $75 = tempRet0; //@line 49584 "c/sqlite3.c"
    $76 = (_read32bits($73,$74,$75,$7)|0); //@line 49584 "c/sqlite3.c"
    $77 = ($76|0)==(0); //@line 49584 "c/sqlite3.c"
    if ($77) {
     $78 = HEAP32[$7>>2]|0; //@line 49593 "c/sqlite3.c"
     $79 = ($78|0)==(0); //@line 49593 "c/sqlite3.c"
     if ($79) {
      $80 = ((($0)) + 152|0); //@line 49594 "c/sqlite3.c"
      $81 = HEAP32[$80>>2]|0; //@line 49594 "c/sqlite3.c"
      HEAP32[$7>>2] = $81; //@line 49594 "c/sqlite3.c"
     }
     $82 = HEAP32[$7>>2]|0; //@line 49602 "c/sqlite3.c"
     $83 = HEAP32[$8>>2]|0; //@line 49602 "c/sqlite3.c"
     $$off = (($82) + -512)|0; //@line 49602 "c/sqlite3.c"
     $84 = ($$off>>>0)>(65024); //@line 49602 "c/sqlite3.c"
     $$off47 = (($83) + -32)|0; //@line 49602 "c/sqlite3.c"
     $85 = ($$off47>>>0)>(65504); //@line 49602 "c/sqlite3.c"
     $86 = $84 | $85; //@line 49602 "c/sqlite3.c"
     if ($86) {
      $$044$ph = 101;
     } else {
      $87 = (($82) + -1)|0; //@line 49604 "c/sqlite3.c"
      $88 = $87 & $82; //@line 49604 "c/sqlite3.c"
      $89 = ($88|0)==(0); //@line 49604 "c/sqlite3.c"
      if ($89) {
       $90 = (($83) + -1)|0; //@line 49604 "c/sqlite3.c"
       $91 = $90 & $83; //@line 49604 "c/sqlite3.c"
       $92 = ($91|0)==(0); //@line 49604 "c/sqlite3.c"
       if ($92) {
        $93 = (_sqlite3PagerSetPagesize($0,$7,-1)|0); //@line 49618 "c/sqlite3.c"
        HEAP32[$16>>2] = $83; //@line 49627 "c/sqlite3.c"
        $$3 = $93;
        break;
       } else {
        $$044$ph = 101;
       }
      } else {
       $$044$ph = 101;
      }
     }
    } else {
     $$044$ph = $76;
    }
   } else {
    $$044$ph = $71;
   }
   $$1 = $$044$ph;
   STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
  } else {
   $$3 = 0;
  }
 } while(0);
 $94 = HEAP32[$16>>2]|0; //@line 49630 "c/sqlite3.c"
 $95 = $11; //@line 49630 "c/sqlite3.c"
 $96 = $95; //@line 49630 "c/sqlite3.c"
 $97 = HEAP32[$96>>2]|0; //@line 49630 "c/sqlite3.c"
 $98 = (($95) + 4)|0; //@line 49630 "c/sqlite3.c"
 $99 = $98; //@line 49630 "c/sqlite3.c"
 $100 = HEAP32[$99>>2]|0; //@line 49630 "c/sqlite3.c"
 $101 = (_i64Add(($97|0),($100|0),($94|0),0)|0); //@line 49630 "c/sqlite3.c"
 $102 = tempRet0; //@line 49630 "c/sqlite3.c"
 $103 = $11; //@line 49630 "c/sqlite3.c"
 $104 = $103; //@line 49630 "c/sqlite3.c"
 HEAP32[$104>>2] = $101; //@line 49630 "c/sqlite3.c"
 $105 = (($103) + 4)|0; //@line 49630 "c/sqlite3.c"
 $106 = $105; //@line 49630 "c/sqlite3.c"
 HEAP32[$106>>2] = $102; //@line 49630 "c/sqlite3.c"
 $$1 = $$3;
 STACKTOP = sp;return ($$1|0); //@line 49632 "c/sqlite3.c"
}
function _sqlite3WalSavepointUndo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 12|0); //@line 58685 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 58685 "c/sqlite3.c"
 $4 = ((($0)) + 112|0); //@line 58685 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 58685 "c/sqlite3.c"
 $6 = ($3|0)==($5|0); //@line 58685 "c/sqlite3.c"
 if (!($6)) {
  HEAP32[$1>>2] = 0; //@line 58690 "c/sqlite3.c"
  $7 = HEAP32[$4>>2]|0; //@line 58691 "c/sqlite3.c"
  HEAP32[$2>>2] = $7; //@line 58691 "c/sqlite3.c"
 }
 $8 = HEAP32[$1>>2]|0; //@line 58694 "c/sqlite3.c"
 $9 = ((($0)) + 68|0); //@line 58694 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 58694 "c/sqlite3.c"
 $11 = ($8>>>0)<($10>>>0); //@line 58694 "c/sqlite3.c"
 if (!($11)) {
  return;
 }
 HEAP32[$9>>2] = $8; //@line 58695 "c/sqlite3.c"
 $12 = ((($1)) + 4|0); //@line 58696 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 58696 "c/sqlite3.c"
 $14 = ((($0)) + 76|0); //@line 58696 "c/sqlite3.c"
 HEAP32[$14>>2] = $13; //@line 58696 "c/sqlite3.c"
 $15 = ((($1)) + 8|0); //@line 58697 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 58697 "c/sqlite3.c"
 $17 = ((($0)) + 80|0); //@line 58697 "c/sqlite3.c"
 HEAP32[$17>>2] = $16; //@line 58697 "c/sqlite3.c"
 _walCleanupHash($0); //@line 58698 "c/sqlite3.c"
 return;
}
function _walCleanupHash($0) {
 $0 = $0|0;
 var $$016 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp + 8|0;
 $2 = sp + 4|0;
 $3 = sp;
 HEAP32[$1>>2] = 0; //@line 56558 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 56559 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 56560 "c/sqlite3.c"
 $4 = ((($0)) + 68|0); //@line 56570 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 56570 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 56570 "c/sqlite3.c"
 if ($6) {
  STACKTOP = sp;return; //@line 56612 "c/sqlite3.c"
 }
 $7 = (_walFramePage($5)|0); //@line 56578 "c/sqlite3.c"
 (_walHashGet($0,$7,$1,$2,$3)|0); //@line 56578 "c/sqlite3.c"
 $8 = HEAP32[$4>>2]|0; //@line 56583 "c/sqlite3.c"
 $9 = HEAP32[$3>>2]|0; //@line 56583 "c/sqlite3.c"
 $10 = (($8) - ($9))|0; //@line 56583 "c/sqlite3.c"
 $11 = HEAP32[$1>>2]|0;
 $$016 = 0;
 while(1) {
  $12 = (($11) + ($$016<<1)|0); //@line 56586 "c/sqlite3.c"
  $13 = HEAP16[$12>>1]|0; //@line 56586 "c/sqlite3.c"
  $14 = $13&65535; //@line 56586 "c/sqlite3.c"
  $15 = ($10|0)<($14|0); //@line 56586 "c/sqlite3.c"
  if ($15) {
   HEAP16[$12>>1] = 0; //@line 56587 "c/sqlite3.c"
  }
  $16 = (($$016) + 1)|0; //@line 56585 "c/sqlite3.c"
  $exitcond = ($16|0)==(8192); //@line 56585 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$016 = $16;
  }
 }
 $17 = HEAP32[$2>>2]|0; //@line 56594 "c/sqlite3.c"
 $18 = (($10) + 1)|0; //@line 56594 "c/sqlite3.c"
 $19 = (($17) + ($18<<2)|0); //@line 56594 "c/sqlite3.c"
 $20 = $11; //@line 56594 "c/sqlite3.c"
 $21 = $19; //@line 56594 "c/sqlite3.c"
 $22 = (($20) - ($21))|0; //@line 56594 "c/sqlite3.c"
 _memset(($19|0),0,($22|0))|0; //@line 56595 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 56612 "c/sqlite3.c"
}
function _walFramePage($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (($0) + 33)|0; //@line 56524 "c/sqlite3.c"
 $2 = $1 >>> 12; //@line 56524 "c/sqlite3.c"
 return ($2|0); //@line 56531 "c/sqlite3.c"
}
function _walHashGet($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = (_walIndexPage($0,$1,$5)|0); //@line 56495 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 56498 "c/sqlite3.c"
 if (!($7)) {
  STACKTOP = sp;return ($6|0); //@line 56514 "c/sqlite3.c"
 }
 $8 = HEAP32[$5>>2]|0; //@line 56502 "c/sqlite3.c"
 $9 = ((($8)) + 16384|0); //@line 56502 "c/sqlite3.c"
 $10 = ($1|0)==(0); //@line 56503 "c/sqlite3.c"
 if ($10) {
  $11 = ((($8)) + 136|0); //@line 56504 "c/sqlite3.c"
  HEAP32[$5>>2] = $11; //@line 56504 "c/sqlite3.c"
  $$0 = 0;
 } else {
  $12 = $1 << 12; //@line 56507 "c/sqlite3.c"
  $13 = (($12) + -34)|0; //@line 56507 "c/sqlite3.c"
  $$0 = $13;
 }
 $14 = HEAP32[$5>>2]|0; //@line 56510 "c/sqlite3.c"
 $15 = ((($14)) + -4|0); //@line 56510 "c/sqlite3.c"
 HEAP32[$3>>2] = $15; //@line 56510 "c/sqlite3.c"
 HEAP32[$2>>2] = $9; //@line 56511 "c/sqlite3.c"
 HEAP32[$4>>2] = $$0; //@line 56512 "c/sqlite3.c"
 STACKTOP = sp;return ($6|0); //@line 56514 "c/sqlite3.c"
}
function _walIndexPage($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$041 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$select42 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 24|0); //@line 56162 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 56162 "c/sqlite3.c"
 $5 = ($4|0)>($1|0); //@line 56162 "c/sqlite3.c"
 do {
  if (!($5)) {
   $6 = (($1) + 1)|0; //@line 56163 "c/sqlite3.c"
   $7 = $6 << 2; //@line 56163 "c/sqlite3.c"
   $8 = ((($0)) + 32|0); //@line 56165 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 56165 "c/sqlite3.c"
   $10 = ($7|0)<(0); //@line 56165 "c/sqlite3.c"
   $11 = $10 << 31 >> 31; //@line 56165 "c/sqlite3.c"
   $12 = (_sqlite3_realloc64($9,$7,$11)|0); //@line 56165 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 56166 "c/sqlite3.c"
   if (!($13)) {
    $14 = HEAP32[$3>>2]|0; //@line 56170 "c/sqlite3.c"
    $15 = (($12) + ($14<<2)|0); //@line 56170 "c/sqlite3.c"
    $16 = (($6) - ($14))|0; //@line 56171 "c/sqlite3.c"
    $17 = $16 << 2; //@line 56171 "c/sqlite3.c"
    _memset(($15|0),0,($17|0))|0; //@line 56170 "c/sqlite3.c"
    HEAP32[$8>>2] = $12; //@line 56172 "c/sqlite3.c"
    HEAP32[$3>>2] = $6; //@line 56173 "c/sqlite3.c"
    break;
   }
   HEAP32[$2>>2] = 0; //@line 56167 "c/sqlite3.c"
   $$1 = 7;
   return ($$1|0); //@line 56199 "c/sqlite3.c"
  }
 } while(0);
 $18 = ((($0)) + 32|0); //@line 56177 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 56177 "c/sqlite3.c"
 $20 = (($19) + ($1<<2)|0); //@line 56177 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 56177 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 56177 "c/sqlite3.c"
 do {
  if ($22) {
   $23 = ((($0)) + 43|0); //@line 56178 "c/sqlite3.c"
   $24 = HEAP8[$23>>0]|0; //@line 56178 "c/sqlite3.c"
   $25 = ($24<<24>>24)==(2); //@line 56178 "c/sqlite3.c"
   if ($25) {
    $26 = (_sqlite3MallocZero(32768,0)|0); //@line 56179 "c/sqlite3.c"
    $27 = HEAP32[$18>>2]|0; //@line 56179 "c/sqlite3.c"
    $28 = (($27) + ($1<<2)|0); //@line 56179 "c/sqlite3.c"
    HEAP32[$28>>2] = $26; //@line 56179 "c/sqlite3.c"
    $29 = HEAP32[$18>>2]|0; //@line 56180 "c/sqlite3.c"
    $30 = (($29) + ($1<<2)|0); //@line 56180 "c/sqlite3.c"
    $31 = HEAP32[$30>>2]|0; //@line 56180 "c/sqlite3.c"
    $32 = ($31|0)==(0|0); //@line 56180 "c/sqlite3.c"
    $spec$select = $32 ? 7 : 0; //@line 56180 "c/sqlite3.c"
    $$041 = $spec$select;
    break;
   }
   $33 = ((($0)) + 4|0); //@line 56182 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 56182 "c/sqlite3.c"
   $35 = ((($0)) + 44|0); //@line 56183 "c/sqlite3.c"
   $36 = HEAP8[$35>>0]|0; //@line 56183 "c/sqlite3.c"
   $37 = $36&255; //@line 56183 "c/sqlite3.c"
   $38 = (_sqlite3OsShmMap($34,$1,$37,$20)|0); //@line 56182 "c/sqlite3.c"
   $39 = $38 & 255; //@line 56187 "c/sqlite3.c"
   $40 = ($39|0)==(8); //@line 56187 "c/sqlite3.c"
   $41 = ((($0)) + 46|0); //@line 56188 "c/sqlite3.c"
   if ($40) {
    $42 = ($38|0)==(8); //@line 56189 "c/sqlite3.c"
    $spec$select42 = $42 ? 0 : $38; //@line 56189 "c/sqlite3.c"
    $43 = HEAP8[$41>>0]|0; //@line 56188 "c/sqlite3.c"
    $44 = $43 | 2; //@line 56188 "c/sqlite3.c"
    HEAP8[$41>>0] = $44; //@line 56188 "c/sqlite3.c"
    $$041 = $spec$select42;
   } else {
    $$041 = $38;
   }
  } else {
   $$041 = 0;
  }
 } while(0);
 $45 = HEAP32[$18>>2]|0; //@line 56196 "c/sqlite3.c"
 $46 = (($45) + ($1<<2)|0); //@line 56196 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 56196 "c/sqlite3.c"
 HEAP32[$2>>2] = $47; //@line 56196 "c/sqlite3.c"
 $$1 = $$041;
 return ($$1|0); //@line 56199 "c/sqlite3.c"
}
function _sqlite3OsShmMap($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 20984 "c/sqlite3.c"
 $5 = ((($4)) + 52|0); //@line 20984 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 20984 "c/sqlite3.c"
 $7 = (FUNCTION_TABLE_iiiiii[$6 & 127]($0,$1,32768,$2,$3)|0); //@line 20984 "c/sqlite3.c"
 return ($7|0); //@line 20984 "c/sqlite3.c"
}
function _sqlite3OsRead($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$0>>2]|0; //@line 20900 "c/sqlite3.c"
 $6 = ((($5)) + 8|0); //@line 20900 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 20900 "c/sqlite3.c"
 $8 = (FUNCTION_TABLE_iiiiii[$7 & 127]($0,$1,$2,$3,$4)|0); //@line 20900 "c/sqlite3.c"
 return ($8|0); //@line 20900 "c/sqlite3.c"
}
function _read32bits($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = (_sqlite3OsRead($0,$4,4,$1,$2)|0); //@line 49076 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 49077 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return ($5|0); //@line 49080 "c/sqlite3.c"
 }
 $7 = (_sqlite3Get4byte($4)|0); //@line 49078 "c/sqlite3.c"
 HEAP32[$3>>2] = $7; //@line 49078 "c/sqlite3.c"
 STACKTOP = sp;return ($5|0); //@line 49080 "c/sqlite3.c"
}
function _sqlite3PagerSetPagesize($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$041 = 0, $$04648 = 0, $$250 = 0, $$353 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, $storemerge = 0, $storemerge$in = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = HEAP32[$1>>2]|0; //@line 51731 "c/sqlite3.c"
 $5 = ((($0)) + 15|0); //@line 51733 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 51733 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 51733 "c/sqlite3.c"
 if ($7) {
  label = 3;
 } else {
  $8 = ((($0)) + 24|0); //@line 51733 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 51733 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 51733 "c/sqlite3.c"
  if ($10) {
   label = 3;
  }
 }
 do {
  if ((label|0) == 3) {
   $11 = ((($0)) + 208|0); //@line 51734 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 51734 "c/sqlite3.c"
   $13 = (_sqlite3PcacheRefCount($12)|0); //@line 51734 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 51734 "c/sqlite3.c"
   $15 = ($4|0)!=(0); //@line 51735 "c/sqlite3.c"
   $or$cond = $15 & $14; //@line 51735 "c/sqlite3.c"
   if ($or$cond) {
    $16 = ((($0)) + 152|0); //@line 51735 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 51735 "c/sqlite3.c"
    $18 = ($4|0)==($17|0); //@line 51735 "c/sqlite3.c"
    if (!($18)) {
     $19 = $3; //@line 51738 "c/sqlite3.c"
     $20 = $19; //@line 51738 "c/sqlite3.c"
     HEAP32[$20>>2] = 0; //@line 51738 "c/sqlite3.c"
     $21 = (($19) + 4)|0; //@line 51738 "c/sqlite3.c"
     $22 = $21; //@line 51738 "c/sqlite3.c"
     HEAP32[$22>>2] = 0; //@line 51738 "c/sqlite3.c"
     $23 = ((($0)) + 16|0); //@line 51740 "c/sqlite3.c"
     $24 = HEAP8[$23>>0]|0; //@line 51740 "c/sqlite3.c"
     $25 = ($24<<24>>24)==(0); //@line 51740 "c/sqlite3.c"
     if ($25) {
      label = 8;
     } else {
      $26 = ((($0)) + 60|0); //@line 51740 "c/sqlite3.c"
      $27 = HEAP32[$26>>2]|0; //@line 51740 "c/sqlite3.c"
      $28 = HEAP32[$27>>2]|0; //@line 51740 "c/sqlite3.c"
      $29 = ($28|0)==(0|0); //@line 51740 "c/sqlite3.c"
      if ($29) {
       label = 8;
      } else {
       $30 = (_sqlite3OsFileSize($27,$3)|0); //@line 51741 "c/sqlite3.c"
       $31 = ($30|0)==(0); //@line 51743 "c/sqlite3.c"
       if ($31) {
        label = 8;
       } else {
        $$04648 = 0;$$250 = $30;
       }
      }
     }
     if ((label|0) == 8) {
      $32 = (_sqlite3PageMalloc($4)|0); //@line 51744 "c/sqlite3.c"
      $33 = ($32|0)==(0|0); //@line 51745 "c/sqlite3.c"
      if ($33) {
       $$04648 = 0;$$250 = 7;
      } else {
       _pager_reset($0); //@line 51749 "c/sqlite3.c"
       $34 = HEAP32[$11>>2]|0; //@line 51750 "c/sqlite3.c"
       $35 = (_sqlite3PcacheSetPageSize($34,$4)|0); //@line 51750 "c/sqlite3.c"
       $36 = ($35|0)==(0); //@line 51752 "c/sqlite3.c"
       if ($36) {
        $37 = ((($0)) + 204|0); //@line 51753 "c/sqlite3.c"
        $38 = HEAP32[$37>>2]|0; //@line 51753 "c/sqlite3.c"
        _sqlite3PageFree($38); //@line 51753 "c/sqlite3.c"
        HEAP32[$37>>2] = $32; //@line 51754 "c/sqlite3.c"
        $39 = $3; //@line 51755 "c/sqlite3.c"
        $40 = $39; //@line 51755 "c/sqlite3.c"
        $41 = HEAP32[$40>>2]|0; //@line 51755 "c/sqlite3.c"
        $42 = (($39) + 4)|0; //@line 51755 "c/sqlite3.c"
        $43 = $42; //@line 51755 "c/sqlite3.c"
        $44 = HEAP32[$43>>2]|0; //@line 51755 "c/sqlite3.c"
        $45 = (_i64Add(($4|0),0,-1,-1)|0); //@line 51755 "c/sqlite3.c"
        $46 = tempRet0; //@line 51755 "c/sqlite3.c"
        $47 = (_i64Add(($45|0),($46|0),($41|0),($44|0))|0); //@line 51755 "c/sqlite3.c"
        $48 = tempRet0; //@line 51755 "c/sqlite3.c"
        $49 = (___divdi3(($47|0),($48|0),($4|0),0)|0); //@line 51755 "c/sqlite3.c"
        $50 = tempRet0; //@line 51755 "c/sqlite3.c"
        $51 = ((($0)) + 24|0); //@line 51755 "c/sqlite3.c"
        HEAP32[$51>>2] = $49; //@line 51755 "c/sqlite3.c"
        HEAP32[$16>>2] = $4; //@line 51756 "c/sqlite3.c"
        break;
       } else {
        $$04648 = $32;$$250 = $35;
       }
      }
     }
     _sqlite3PageFree($$04648); //@line 51758 "c/sqlite3.c"
     $52 = ((($0)) + 152|0); //@line 51762 "c/sqlite3.c"
     $53 = HEAP32[$52>>2]|0; //@line 51762 "c/sqlite3.c"
     HEAP32[$1>>2] = $53; //@line 51762 "c/sqlite3.c"
     $$353 = $$250;
     STACKTOP = sp;return ($$353|0); //@line 51770 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $storemerge$in = ((($0)) + 152|0); //@line 51762 "c/sqlite3.c"
 $storemerge = HEAP32[$storemerge$in>>2]|0; //@line 51762 "c/sqlite3.c"
 HEAP32[$1>>2] = $storemerge; //@line 51762 "c/sqlite3.c"
 $54 = ($2|0)<(0); //@line 51764 "c/sqlite3.c"
 if ($54) {
  $55 = ((($0)) + 142|0); //@line 51764 "c/sqlite3.c"
  $56 = HEAP16[$55>>1]|0; //@line 51764 "c/sqlite3.c"
  $57 = $56 << 16 >> 16; //@line 51764 "c/sqlite3.c"
  $$041 = $57;
 } else {
  $$041 = $2;
 }
 $58 = $$041&65535; //@line 51766 "c/sqlite3.c"
 $59 = ((($0)) + 142|0); //@line 51766 "c/sqlite3.c"
 HEAP16[$59>>1] = $58; //@line 51766 "c/sqlite3.c"
 $$353 = 0;
 STACKTOP = sp;return ($$353|0); //@line 51770 "c/sqlite3.c"
}
function _sqlite3PcacheRefCount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 45955 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 45955 "c/sqlite3.c"
 return ($2|0); //@line 45955 "c/sqlite3.c"
}
function _sqlite3OsFileSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 20915 "c/sqlite3.c"
 $3 = ((($2)) + 24|0); //@line 20915 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 20915 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iii[$4 & 255]($0,$1)|0); //@line 20915 "c/sqlite3.c"
 return ($5|0); //@line 20915 "c/sqlite3.c"
}
function _sqlite3PageMalloc($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_pcache1Alloc($0)|0); //@line 46530 "c/sqlite3.c"
 return ($1|0); //@line 46530 "c/sqlite3.c"
}
function _pager_reset($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 100|0); //@line 49723 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49723 "c/sqlite3.c"
 $3 = (($2) + 1)|0; //@line 49723 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 49723 "c/sqlite3.c"
 $4 = ((($0)) + 88|0); //@line 49724 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 49724 "c/sqlite3.c"
 _sqlite3BackupRestart($5); //@line 49724 "c/sqlite3.c"
 $6 = ((($0)) + 208|0); //@line 49725 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 49725 "c/sqlite3.c"
 _sqlite3PcacheClear($7); //@line 49725 "c/sqlite3.c"
 return; //@line 49726 "c/sqlite3.c"
}
function _sqlite3PcacheSetPageSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 45497 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45497 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 45497 "c/sqlite3.c"
 if ($4) {
  $$1 = 0;
  return ($$1|0); //@line 45513 "c/sqlite3.c"
 }
 $5 = HEAP32[(136)>>2]|0; //@line 45499 "c/sqlite3.c"
 $6 = ((($0)) + 28|0); //@line 45500 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 45500 "c/sqlite3.c"
 $8 = (($7) + 40)|0; //@line 45500 "c/sqlite3.c"
 $9 = ((($0)) + 32|0); //@line 45501 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 45501 "c/sqlite3.c"
 $11 = $10&255; //@line 45501 "c/sqlite3.c"
 $12 = (FUNCTION_TABLE_iiii[$5 & 127]($1,$8,$11)|0); //@line 45499 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 45503 "c/sqlite3.c"
 if ($13) {
  $$1 = 7;
  return ($$1|0); //@line 45513 "c/sqlite3.c"
 }
 $14 = HEAP32[(140)>>2]|0; //@line 45504 "c/sqlite3.c"
 $15 = (_numberOfCachePages($0)|0); //@line 45504 "c/sqlite3.c"
 FUNCTION_TABLE_vii[$14 & 127]($12,$15); //@line 45504 "c/sqlite3.c"
 $16 = ((($0)) + 44|0); //@line 45505 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 45505 "c/sqlite3.c"
 $18 = ($17|0)==(0|0); //@line 45505 "c/sqlite3.c"
 if (!($18)) {
  $19 = HEAP32[(164)>>2]|0; //@line 45506 "c/sqlite3.c"
  FUNCTION_TABLE_vi[$19 & 127]($17); //@line 45506 "c/sqlite3.c"
 }
 HEAP32[$16>>2] = $12; //@line 45508 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 45509 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 45513 "c/sqlite3.c"
}
function _sqlite3PageFree($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _pcache1Free($0); //@line 46537 "c/sqlite3.c"
 return; //@line 46538 "c/sqlite3.c"
}
function _numberOfCachePages($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 45419 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 45419 "c/sqlite3.c"
 $3 = ($2|0)>(-1); //@line 45419 "c/sqlite3.c"
 if ($3) {
  $$0 = $2;
  return ($$0|0); //@line 45429 "c/sqlite3.c"
 }
 $4 = ($2|0)<(0); //@line 45427 "c/sqlite3.c"
 $5 = $4 << 31 >> 31; //@line 45427 "c/sqlite3.c"
 $6 = (___muldi3(($2|0),($5|0),-1024,-1)|0); //@line 45427 "c/sqlite3.c"
 $7 = tempRet0; //@line 45427 "c/sqlite3.c"
 $8 = ((($0)) + 24|0); //@line 45427 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 45427 "c/sqlite3.c"
 $10 = ((($0)) + 28|0); //@line 45427 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 45427 "c/sqlite3.c"
 $12 = (($11) + ($9))|0; //@line 45427 "c/sqlite3.c"
 $13 = ($12|0)<(0); //@line 45427 "c/sqlite3.c"
 $14 = $13 << 31 >> 31; //@line 45427 "c/sqlite3.c"
 $15 = (___divdi3(($6|0),($7|0),($12|0),($14|0))|0); //@line 45427 "c/sqlite3.c"
 $16 = tempRet0; //@line 45427 "c/sqlite3.c"
 $$0 = $15;
 return ($$0|0); //@line 45429 "c/sqlite3.c"
}
function _sqlite3BackupRestart($0) {
 $0 = $0|0;
 var $$05 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 71119 "c/sqlite3.c"
 if ($1) {
  return; //@line 71123 "c/sqlite3.c"
 }
 $$05 = $0;
 while(1) {
  $2 = ((($$05)) + 16|0); //@line 71121 "c/sqlite3.c"
  HEAP32[$2>>2] = 1; //@line 71121 "c/sqlite3.c"
  $3 = ((($$05)) + 44|0); //@line 71119 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 71119 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 71119 "c/sqlite3.c"
  if ($5) {
   break;
  } else {
   $$05 = $4;
  }
 }
 return; //@line 71123 "c/sqlite3.c"
}
function _sqlite3PcacheClear($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3PcacheTruncate($0,0); //@line 45861 "c/sqlite3.c"
 return; //@line 45862 "c/sqlite3.c"
}
function _sqlite3PcacheTruncate($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02021 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 44|0); //@line 45819 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45819 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 45819 "c/sqlite3.c"
 if ($4) {
  return; //@line 45846 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 45823 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 45823 "c/sqlite3.c"
 if (!($6)) {
  $$02021 = $5;
  while(1) {
   $7 = ((($$02021)) + 32|0); //@line 45824 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 45824 "c/sqlite3.c"
   $9 = ((($$02021)) + 24|0); //@line 45830 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 45830 "c/sqlite3.c"
   $11 = ($10>>>0)>($1>>>0); //@line 45830 "c/sqlite3.c"
   if ($11) {
    _sqlite3PcacheMakeClean($$02021); //@line 45832 "c/sqlite3.c"
   }
   $12 = ($8|0)==(0|0); //@line 45823 "c/sqlite3.c"
   if ($12) {
    break;
   } else {
    $$02021 = $8;
   }
  }
 }
 $13 = ($1|0)==(0); //@line 45835 "c/sqlite3.c"
 if ($13) {
  $14 = ((($0)) + 12|0); //@line 45835 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 45835 "c/sqlite3.c"
  $16 = ($15|0)==(0); //@line 45835 "c/sqlite3.c"
  if ($16) {
   $$1 = 0;
  } else {
   $17 = HEAP32[(148)>>2]|0; //@line 45837 "c/sqlite3.c"
   $18 = HEAP32[$2>>2]|0; //@line 45837 "c/sqlite3.c"
   $19 = (FUNCTION_TABLE_iiii[$17 & 127]($18,1,0)|0); //@line 45837 "c/sqlite3.c"
   $20 = ($19|0)==(0|0); //@line 45838 "c/sqlite3.c"
   if ($20) {
    $$1 = 0;
   } else {
    $21 = HEAP32[$19>>2]|0; //@line 45840 "c/sqlite3.c"
    $22 = ((($0)) + 24|0); //@line 45840 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 45840 "c/sqlite3.c"
    _memset(($21|0),0,($23|0))|0; //@line 45840 "c/sqlite3.c"
    $$1 = 1;
   }
  }
 } else {
  $$1 = $1;
 }
 $24 = HEAP32[(160)>>2]|0; //@line 45844 "c/sqlite3.c"
 $25 = HEAP32[$2>>2]|0; //@line 45844 "c/sqlite3.c"
 $26 = (($$1) + 1)|0; //@line 45844 "c/sqlite3.c"
 FUNCTION_TABLE_vii[$24 & 127]($25,$26); //@line 45844 "c/sqlite3.c"
 return; //@line 45846 "c/sqlite3.c"
}
function _sqlite3PcacheMakeClean($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _pcacheManageDirtyList($0,1); //@line 45749 "c/sqlite3.c"
 $1 = ((($0)) + 28|0); //@line 45750 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 45750 "c/sqlite3.c"
 $3 = $2 & -16; //@line 45750 "c/sqlite3.c"
 $4 = $3 | 1; //@line 45751 "c/sqlite3.c"
 HEAP16[$1>>1] = $4; //@line 45751 "c/sqlite3.c"
 $5 = ((($0)) + 30|0); //@line 45754 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 45754 "c/sqlite3.c"
 $7 = ($6<<16>>16)==(0); //@line 45754 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 45757 "c/sqlite3.c"
 }
 _pcacheUnpin($0); //@line 45755 "c/sqlite3.c"
 return; //@line 45757 "c/sqlite3.c"
}
function _sqlite3BackupUpdate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 71103 "c/sqlite3.c"
 if (!($3)) {
  _backupUpdate($0,$1,$2); //@line 71103 "c/sqlite3.c"
 }
 return; //@line 71104 "c/sqlite3.c"
}
function _backupUpdate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $$0 = $0;
 while(1) {
  $3 = ((($$0)) + 28|0); //@line 71085 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 71085 "c/sqlite3.c"
  $5 = (_isFatalError($4)|0); //@line 71085 "c/sqlite3.c"
  $6 = ($5|0)==(0); //@line 71085 "c/sqlite3.c"
  if ($6) {
   $7 = ((($$0)) + 16|0); //@line 71085 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 71085 "c/sqlite3.c"
   $9 = ($8>>>0)>($1>>>0); //@line 71085 "c/sqlite3.c"
   if ($9) {
    $10 = HEAP32[$$0>>2]|0; //@line 71092 "c/sqlite3.c"
    $11 = ((($10)) + 12|0); //@line 71092 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 71092 "c/sqlite3.c"
    _sqlite3_mutex_enter($12); //@line 71092 "c/sqlite3.c"
    $13 = (_backupOnePage($$0,$1,$2,1)|0); //@line 71093 "c/sqlite3.c"
    $14 = HEAP32[$$0>>2]|0; //@line 71094 "c/sqlite3.c"
    $15 = ((($14)) + 12|0); //@line 71094 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 71094 "c/sqlite3.c"
    _sqlite3_mutex_leave($16); //@line 71094 "c/sqlite3.c"
    $17 = ($13|0)==(0); //@line 71096 "c/sqlite3.c"
    if (!($17)) {
     HEAP32[$3>>2] = $13; //@line 71097 "c/sqlite3.c"
    }
   }
  }
  $18 = ((($$0)) + 44|0); //@line 71100 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 71100 "c/sqlite3.c"
  $20 = ($19|0)==(0|0); //@line 71100 "c/sqlite3.c"
  if ($20) {
   break;
  } else {
   $$0 = $19;
  }
 }
 return; //@line 71101 "c/sqlite3.c"
}
function _isFatalError($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0|0) {
 case 0: case 5:  {
  $2 = 0;
  break;
 }
 default: {
  $1 = ($0|0)!=(6); //@line 70606 "c/sqlite3.c"
  $phitmp = $1&1;
  $2 = $phitmp;
 }
 }
 return ($2|0); //@line 70606 "c/sqlite3.c"
}
function _backupOnePage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$1$lcssa = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond63 = 0, $or$cond6364 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ((($0)) + 4|0); //@line 70620 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 70620 "c/sqlite3.c"
 $7 = (_sqlite3BtreePager($6)|0); //@line 70620 "c/sqlite3.c"
 $8 = ((($0)) + 24|0); //@line 70621 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 70621 "c/sqlite3.c"
 $10 = (_sqlite3BtreeGetPageSize($9)|0); //@line 70621 "c/sqlite3.c"
 $11 = (_sqlite3BtreeGetPageSize($6)|0); //@line 70622 "c/sqlite3.c"
 $12 = ($10|0)<($11|0); //@line 70623 "c/sqlite3.c"
 $13 = $12 ? $10 : $11; //@line 70623 "c/sqlite3.c"
 $14 = ($10|0)<(0); //@line 70624 "c/sqlite3.c"
 $15 = $14 << 31 >> 31; //@line 70624 "c/sqlite3.c"
 $16 = (___muldi3(($10|0),($15|0),($1|0),0)|0); //@line 70624 "c/sqlite3.c"
 $17 = tempRet0; //@line 70624 "c/sqlite3.c"
 $18 = ($10|0)==($11|0); //@line 70644 "c/sqlite3.c"
 if ($18) {
  $$0 = 0;
 } else {
  $19 = (_sqlite3PagerIsMemdb($7)|0); //@line 70644 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 70644 "c/sqlite3.c"
  $spec$select = $20 ? 0 : 8; //@line 70644 "c/sqlite3.c"
  $$0 = $spec$select;
 }
 $21 = ($$0|0)==(0); //@line 70672 "c/sqlite3.c"
 $22 = ($10|0)>(0); //@line 70672 "c/sqlite3.c"
 $or$cond6364 = $22 & $21; //@line 70672 "c/sqlite3.c"
 if (!($or$cond6364)) {
  $$1$lcssa = $$0;
  STACKTOP = sp;return ($$1$lcssa|0); //@line 70699 "c/sqlite3.c"
 }
 $23 = (_i64Subtract(($16|0),($17|0),($10|0),($15|0))|0); //@line 70672 "c/sqlite3.c"
 $24 = tempRet0; //@line 70672 "c/sqlite3.c"
 $25 = ($11|0)<(0);
 $26 = $25 << 31 >> 31;
 $27 = ($3|0)==(0);
 $28 = $23;$29 = $24;
 while(1) {
  HEAP32[$4>>2] = 0; //@line 70673 "c/sqlite3.c"
  $30 = (___divdi3(($28|0),($29|0),($11|0),($26|0))|0); //@line 70674 "c/sqlite3.c"
  $31 = tempRet0; //@line 70674 "c/sqlite3.c"
  $32 = HEAP32[513]|0; //@line 70675 "c/sqlite3.c"
  $33 = HEAP32[$5>>2]|0; //@line 70675 "c/sqlite3.c"
  $34 = ((($33)) + 4|0); //@line 70675 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 70675 "c/sqlite3.c"
  $36 = ((($35)) + 32|0); //@line 70675 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 70675 "c/sqlite3.c"
  $38 = (($32>>>0) / ($37>>>0))&-1; //@line 70675 "c/sqlite3.c"
  $39 = ($38|0)==($30|0); //@line 70675 "c/sqlite3.c"
  if ($39) {
   $$3 = 0;
  } else {
   $40 = (($30) + 1)|0; //@line 70674 "c/sqlite3.c"
   $41 = (_sqlite3PagerGet($7,$40,$4,0)|0); //@line 70676 "c/sqlite3.c"
   $42 = ($41|0)==(0); //@line 70676 "c/sqlite3.c"
   if ($42) {
    $43 = HEAP32[$4>>2]|0; //@line 70677 "c/sqlite3.c"
    $44 = (_sqlite3PagerWrite($43)|0); //@line 70677 "c/sqlite3.c"
    $45 = ($44|0)==(0); //@line 70677 "c/sqlite3.c"
    if ($45) {
     $46 = (___remdi3(($28|0),($29|0),($10|0),($15|0))|0); //@line 70679 "c/sqlite3.c"
     $47 = tempRet0; //@line 70679 "c/sqlite3.c"
     $48 = (($2) + ($46)|0); //@line 70679 "c/sqlite3.c"
     $49 = HEAP32[$4>>2]|0; //@line 70680 "c/sqlite3.c"
     $50 = (_sqlite3PagerGetData($49)|0); //@line 70680 "c/sqlite3.c"
     $51 = (___muldi3(($30|0),($31|0),($11|0),($26|0))|0);
     $52 = tempRet0;
     $53 = (_i64Subtract(($28|0),($29|0),($51|0),($52|0))|0);
     $54 = tempRet0;
     $55 = (($50) + ($53)|0); //@line 70681 "c/sqlite3.c"
     _memcpy(($55|0),($48|0),($13|0))|0; //@line 70690 "c/sqlite3.c"
     $56 = HEAP32[$4>>2]|0; //@line 70691 "c/sqlite3.c"
     $57 = (_sqlite3PagerGetExtra($56)|0); //@line 70691 "c/sqlite3.c"
     HEAP8[$57>>0] = 0; //@line 70691 "c/sqlite3.c"
     $58 = ($28|0)==(0); //@line 70692 "c/sqlite3.c"
     $59 = ($29|0)==(0); //@line 70692 "c/sqlite3.c"
     $60 = $58 & $59; //@line 70692 "c/sqlite3.c"
     $or$cond = $27 & $60; //@line 70692 "c/sqlite3.c"
     if ($or$cond) {
      $61 = ((($55)) + 28|0); //@line 70693 "c/sqlite3.c"
      $62 = HEAP32[$8>>2]|0; //@line 70693 "c/sqlite3.c"
      $63 = (_sqlite3BtreeLastPage($62)|0); //@line 70693 "c/sqlite3.c"
      _sqlite3Put4byte($61,$63); //@line 70693 "c/sqlite3.c"
      $$2 = 0;
     } else {
      $$2 = 0;
     }
    } else {
     $$2 = $44;
    }
   } else {
    $$2 = $41;
   }
   $64 = HEAP32[$4>>2]|0; //@line 70696 "c/sqlite3.c"
   _sqlite3PagerUnref($64); //@line 70696 "c/sqlite3.c"
   $$3 = $$2;
  }
  $65 = (_i64Add(($28|0),($29|0),($11|0),($26|0))|0); //@line 70672 "c/sqlite3.c"
  $66 = tempRet0; //@line 70672 "c/sqlite3.c"
  $67 = ($$3|0)==(0); //@line 70672 "c/sqlite3.c"
  $68 = ($66|0)<($17|0); //@line 70672 "c/sqlite3.c"
  $69 = ($65>>>0)<($16>>>0); //@line 70672 "c/sqlite3.c"
  $70 = ($66|0)==($17|0); //@line 70672 "c/sqlite3.c"
  $71 = $70 & $69; //@line 70672 "c/sqlite3.c"
  $72 = $68 | $71; //@line 70672 "c/sqlite3.c"
  $or$cond63 = $72 & $67; //@line 70672 "c/sqlite3.c"
  if ($or$cond63) {
   $28 = $65;$29 = $66;
  } else {
   $$1$lcssa = $$3;
   break;
  }
 }
 STACKTOP = sp;return ($$1$lcssa|0); //@line 70699 "c/sqlite3.c"
}
function _sqlite3BtreePager($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 69480 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 69480 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 69480 "c/sqlite3.c"
 return ($3|0); //@line 69480 "c/sqlite3.c"
}
function _sqlite3BtreeGetPageSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 63216 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63216 "c/sqlite3.c"
 $3 = ((($2)) + 32|0); //@line 63216 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63216 "c/sqlite3.c"
 return ($4|0); //@line 63216 "c/sqlite3.c"
}
function _sqlite3PagerIsMemdb($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 54720 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 54720 "c/sqlite3.c"
 $3 = $2&255; //@line 54720 "c/sqlite3.c"
 return ($3|0); //@line 54720 "c/sqlite3.c"
}
function _sqlite3PagerGetData($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 55150 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 55150 "c/sqlite3.c"
 return ($2|0); //@line 55150 "c/sqlite3.c"
}
function _sqlite3PagerGetExtra($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 55158 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 55158 "c/sqlite3.c"
 return ($2|0); //@line 55158 "c/sqlite3.c"
}
function _sqlite3BtreeLastPage($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 62475 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62475 "c/sqlite3.c"
 $3 = (_btreePagecount($2)|0); //@line 62475 "c/sqlite3.c"
 return ($3|0); //@line 62475 "c/sqlite3.c"
}
function _sqlite3PagerUnref($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 53639 "c/sqlite3.c"
 if (!($1)) {
  _sqlite3PagerUnrefNotNull($0); //@line 53639 "c/sqlite3.c"
 }
 return; //@line 53640 "c/sqlite3.c"
}
function _btreePagecount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 44|0); //@line 62470 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62470 "c/sqlite3.c"
 return ($2|0); //@line 62470 "c/sqlite3.c"
}
function _sqlite3WalUndo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$01 = 0, $$02 = 0, $$021$lcssa = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 44|0); //@line 58627 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 58627 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 58627 "c/sqlite3.c"
 if ($4) {
  $$1 = 0;
  return ($$1|0); //@line 58656 "c/sqlite3.c"
 }
 $5 = ((($0)) + 52|0); //@line 58628 "c/sqlite3.c"
 $6 = ((($0)) + 68|0); //@line 58628 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 58628 "c/sqlite3.c"
 $8 = (_walIndexHdr($0)|0); //@line 58634 "c/sqlite3.c"
 dest=$5; src=$8; stop=dest+48|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 58634 "c/sqlite3.c"
 $9 = HEAP32[$6>>2]|0; //@line 58636 "c/sqlite3.c"
 $$01 = (($9) + 1)|0;
 $10 = ($$01>>>0)>($7>>>0); //@line 58637 "c/sqlite3.c"
 if ($10) {
  $$021$lcssa = 0;
 } else {
  $$02 = $$01;
  while(1) {
   $11 = (_walFramePgno($0,$$02)|0); //@line 58652 "c/sqlite3.c"
   $12 = (_pagerUndoCallback($1,$11)|0); //@line 58652 "c/sqlite3.c"
   $$0 = (($$02) + 1)|0;
   $13 = ($12|0)!=(0); //@line 58637 "c/sqlite3.c"
   $14 = ($$0>>>0)>($7>>>0); //@line 58637 "c/sqlite3.c"
   $or$cond = $13 | $14; //@line 58637 "c/sqlite3.c"
   if ($or$cond) {
    $$021$lcssa = $12;
    break;
   } else {
    $$02 = $$0;
   }
  }
 }
 $15 = HEAP32[$6>>2]|0; //@line 58654 "c/sqlite3.c"
 $16 = ($7|0)==($15|0); //@line 58654 "c/sqlite3.c"
 if ($16) {
  $$1 = $$021$lcssa;
  return ($$1|0); //@line 58656 "c/sqlite3.c"
 }
 _walCleanupHash($0); //@line 58654 "c/sqlite3.c"
 $$1 = $$021$lcssa;
 return ($$1|0); //@line 58656 "c/sqlite3.c"
}
function _sqlite3PcacheDirtyList($0) {
 $0 = $0|0;
 var $$0$pr = 0, $$07 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0$pr = HEAP32[$0>>2]|0;
 $1 = ($$0$pr|0)==(0|0); //@line 45942 "c/sqlite3.c"
 if (!($1)) {
  $$07 = $$0$pr;
  while(1) {
   $2 = ((($$07)) + 32|0); //@line 45943 "c/sqlite3.c"
   $3 = HEAP32[$2>>2]|0; //@line 45943 "c/sqlite3.c"
   $4 = ((($$07)) + 16|0); //@line 45943 "c/sqlite3.c"
   HEAP32[$4>>2] = $3; //@line 45943 "c/sqlite3.c"
   $5 = $3;
   $6 = ($3|0)==(0); //@line 45942 "c/sqlite3.c"
   if ($6) {
    break;
   } else {
    $$07 = $5;
   }
  }
 }
 $7 = HEAP32[$0>>2]|0; //@line 45945 "c/sqlite3.c"
 $8 = (_pcacheSortDirtyList($7)|0); //@line 45945 "c/sqlite3.c"
 return ($8|0); //@line 45945 "c/sqlite3.c"
}
function _pagerUndoCallback($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3PagerLookup($0,$1)|0); //@line 51078 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 51079 "c/sqlite3.c"
 do {
  if ($3) {
   $$0 = 0;
  } else {
   $4 = (_sqlite3PcachePageRefcount($2)|0); //@line 51080 "c/sqlite3.c"
   $5 = ($4|0)==(1); //@line 51080 "c/sqlite3.c"
   if ($5) {
    _sqlite3PcacheDrop($2); //@line 51081 "c/sqlite3.c"
    $$0 = 0;
    break;
   }
   $6 = (_readDbPage($2)|0); //@line 51083 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 51084 "c/sqlite3.c"
   if ($7) {
    $8 = ((($0)) + 196|0); //@line 51085 "c/sqlite3.c"
    $9 = HEAP32[$8>>2]|0; //@line 51085 "c/sqlite3.c"
    FUNCTION_TABLE_vi[$9 & 127]($2); //@line 51085 "c/sqlite3.c"
   }
   _sqlite3PagerUnrefNotNull($2); //@line 51087 "c/sqlite3.c"
   $$0 = $6;
  }
 } while(0);
 $10 = ((($0)) + 88|0); //@line 51099 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 51099 "c/sqlite3.c"
 _sqlite3BackupRestart($11); //@line 51099 "c/sqlite3.c"
 return ($$0|0); //@line 51101 "c/sqlite3.c"
}
function _sqlite3PcachePageRefcount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 30|0); //@line 45962 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 45962 "c/sqlite3.c"
 $3 = $2 << 16 >> 16; //@line 45962 "c/sqlite3.c"
 return ($3|0); //@line 45962 "c/sqlite3.c"
}
function _sqlite3PcacheDrop($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 28|0); //@line 45715 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 45715 "c/sqlite3.c"
 $3 = $2 & 2; //@line 45715 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 45715 "c/sqlite3.c"
 if (!($4)) {
  _pcacheManageDirtyList($0,1); //@line 45716 "c/sqlite3.c"
 }
 $5 = ((($0)) + 12|0); //@line 45718 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 45718 "c/sqlite3.c"
 $7 = ((($6)) + 12|0); //@line 45718 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 45718 "c/sqlite3.c"
 $9 = (($8) + -1)|0; //@line 45718 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 45718 "c/sqlite3.c"
 $10 = HEAP32[(152)>>2]|0; //@line 45719 "c/sqlite3.c"
 $11 = ((($6)) + 44|0); //@line 45719 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 45719 "c/sqlite3.c"
 $13 = HEAP32[$0>>2]|0; //@line 45719 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$10 & 255]($12,$13,1); //@line 45719 "c/sqlite3.c"
 return; //@line 45720 "c/sqlite3.c"
}
function _readDbPage($0) {
 $0 = $0|0;
 var $$0 = 0, $$030 = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$store$select = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 20|0); //@line 50981 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 50981 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 50985 "c/sqlite3.c"
 $4 = ((($3)) + 212|0); //@line 50990 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 50990 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 50990 "c/sqlite3.c"
 if ($6) {
  label = 5;
 } else {
  $7 = ((($0)) + 24|0); //@line 50991 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 50991 "c/sqlite3.c"
  $9 = (_sqlite3WalFindFrame($5,$8,$1)|0); //@line 50991 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 50992 "c/sqlite3.c"
  if (!($10)) {
   $$0 = $9;
   STACKTOP = sp;return ($$0|0); //@line 51035 "c/sqlite3.c"
  }
  $$pr = HEAP32[$1>>2]|0; //@line 50994 "c/sqlite3.c"
  $11 = ($$pr|0)==(0); //@line 50994 "c/sqlite3.c"
  if ($11) {
   label = 5;
  } else {
   $12 = HEAP32[$4>>2]|0; //@line 50995 "c/sqlite3.c"
   $13 = ((($3)) + 152|0); //@line 50995 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 50995 "c/sqlite3.c"
   $15 = ((($0)) + 4|0); //@line 50995 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 50995 "c/sqlite3.c"
   $17 = (_sqlite3WalReadFrame($12,$$pr,$14,$16)|0); //@line 50995 "c/sqlite3.c"
   $$030 = $17;
  }
 }
 if ((label|0) == 5) {
  $18 = ((($0)) + 24|0); //@line 50999 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 50999 "c/sqlite3.c"
  $20 = (($19) + -1)|0; //@line 50999 "c/sqlite3.c"
  $21 = ((($3)) + 152|0); //@line 50999 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 50999 "c/sqlite3.c"
  $23 = ($22|0)<(0); //@line 50999 "c/sqlite3.c"
  $24 = $23 << 31 >> 31; //@line 50999 "c/sqlite3.c"
  $25 = (___muldi3(($20|0),0,($22|0),($24|0))|0); //@line 50999 "c/sqlite3.c"
  $26 = tempRet0; //@line 50999 "c/sqlite3.c"
  $27 = ((($3)) + 60|0); //@line 51000 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 51000 "c/sqlite3.c"
  $29 = ((($0)) + 4|0); //@line 51000 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 51000 "c/sqlite3.c"
  $31 = (_sqlite3OsRead($28,$30,$22,$25,$26)|0); //@line 51000 "c/sqlite3.c"
  $32 = ($31|0)==(522); //@line 51001 "c/sqlite3.c"
  $spec$store$select = $32 ? 0 : $31; //@line 51001 "c/sqlite3.c"
  $$030 = $spec$store$select;
 }
 $33 = ((($0)) + 24|0); //@line 51006 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 51006 "c/sqlite3.c"
 $35 = ($34|0)==(1); //@line 51006 "c/sqlite3.c"
 if (!($35)) {
  $$0 = $$030;
  STACKTOP = sp;return ($$0|0); //@line 51035 "c/sqlite3.c"
 }
 $36 = ($$030|0)==(0); //@line 51007 "c/sqlite3.c"
 if ($36) {
  $38 = ((($0)) + 4|0); //@line 51022 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 51022 "c/sqlite3.c"
  $40 = ((($39)) + 24|0); //@line 51022 "c/sqlite3.c"
  $41 = ((($3)) + 104|0); //@line 51023 "c/sqlite3.c"
  dest=$41; src=$40; stop=dest+16|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 51023 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 51035 "c/sqlite3.c"
 } else {
  $37 = ((($3)) + 104|0); //@line 51020 "c/sqlite3.c"
  ;HEAP32[$37>>2]=4294967295|0;HEAP32[$37+4>>2]=4294967295|0;HEAP32[$37+8>>2]=4294967295|0;HEAP32[$37+12>>2]=4294967295|0; //@line 51020 "c/sqlite3.c"
  $$0 = $$030;
  STACKTOP = sp;return ($$0|0); //@line 51035 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3WalFindFrame($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$047$lcssa = 0, $$05162 = 0, $$05261 = 0, $$05564 = 0, $$14863 = 0, $$249 = 0, $$3 = 0, $$350$ph = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 8|0;
 $4 = sp + 4|0;
 $5 = sp;
 $6 = ((($0)) + 68|0); //@line 58428 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 58428 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 58441 "c/sqlite3.c"
 do {
  if (!($8)) {
   $9 = ((($0)) + 40|0); //@line 58441 "c/sqlite3.c"
   $10 = HEAP16[$9>>1]|0; //@line 58441 "c/sqlite3.c"
   $11 = ($10<<16>>16)==(0); //@line 58441 "c/sqlite3.c"
   if ($11) {
    $12 = ((($0)) + 50|0); //@line 58441 "c/sqlite3.c"
    $13 = HEAP8[$12>>0]|0; //@line 58441 "c/sqlite3.c"
    $14 = ($13<<24>>24)==(0); //@line 58441 "c/sqlite3.c"
    if ($14) {
     break;
    }
   }
   $15 = ((($0)) + 100|0); //@line 58471 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 58471 "c/sqlite3.c"
   $17 = (_walFramePage($16)|0); //@line 58471 "c/sqlite3.c"
   $18 = (_walFramePage($7)|0); //@line 58472 "c/sqlite3.c"
   $19 = ($18|0)<($17|0); //@line 58472 "c/sqlite3.c"
   L6: do {
    if ($19) {
     $$047$lcssa = 0;
    } else {
     $$05564 = $18;
     L8: while(1) {
      $24 = (_walHashGet($0,$$05564,$3,$4,$5)|0); //@line 58480 "c/sqlite3.c"
      $25 = ($24|0)==(0); //@line 58481 "c/sqlite3.c"
      if (!($25)) {
       $$3 = $24;
       break;
      }
      $26 = (_walHash($1)|0); //@line 58485 "c/sqlite3.c"
      $27 = HEAP32[$3>>2]|0; //@line 58485 "c/sqlite3.c"
      $28 = (($27) + ($26<<1)|0); //@line 58485 "c/sqlite3.c"
      $29 = HEAP16[$28>>1]|0; //@line 58485 "c/sqlite3.c"
      $30 = ($29<<16>>16)==(0); //@line 58485 "c/sqlite3.c"
      if ($30) {
       $$350$ph = 0;
      } else {
       $31 = HEAP32[$5>>2]|0;
       $32 = HEAP32[$3>>2]|0;
       $33 = HEAP32[$4>>2]|0;
       $$05162 = 8192;$$05261 = $26;$$14863 = 0;$35 = $28;
       while(1) {
        $34 = HEAP16[$35>>1]|0; //@line 58486 "c/sqlite3.c"
        $36 = $34&65535; //@line 58486 "c/sqlite3.c"
        $37 = (($31) + ($36))|0; //@line 58486 "c/sqlite3.c"
        $38 = ($37>>>0)>($7>>>0); //@line 58487 "c/sqlite3.c"
        if ($38) {
         $$249 = $$14863;
        } else {
         $39 = HEAP32[$15>>2]|0; //@line 58487 "c/sqlite3.c"
         $40 = ($37>>>0)<($39>>>0); //@line 58487 "c/sqlite3.c"
         if ($40) {
          $$249 = $$14863;
         } else {
          $41 = HEAP16[$35>>1]|0; //@line 58487 "c/sqlite3.c"
          $42 = $41&65535; //@line 58487 "c/sqlite3.c"
          $43 = (($33) + ($42<<2)|0); //@line 58487 "c/sqlite3.c"
          $44 = HEAP32[$43>>2]|0; //@line 58487 "c/sqlite3.c"
          $45 = ($44|0)==($1|0); //@line 58487 "c/sqlite3.c"
          $spec$select = $45 ? $37 : $$14863; //@line 58487 "c/sqlite3.c"
          $$249 = $spec$select;
         }
        }
        $46 = ($$05162|0)==(0); //@line 58491 "c/sqlite3.c"
        if ($46) {
         label = 15;
         break L8;
        }
        $48 = (($$05162) + -1)|0; //@line 58491 "c/sqlite3.c"
        $49 = (_walNextHash($$05261)|0); //@line 58485 "c/sqlite3.c"
        $50 = (($32) + ($49<<1)|0); //@line 58485 "c/sqlite3.c"
        $51 = HEAP16[$50>>1]|0; //@line 58485 "c/sqlite3.c"
        $52 = ($51<<16>>16)==(0); //@line 58485 "c/sqlite3.c"
        if ($52) {
         $$350$ph = $$249;
         break;
        } else {
         $$05162 = $48;$$05261 = $49;$$14863 = $$249;$35 = $50;
        }
       }
      }
      $20 = (($$05564) + -1)|0; //@line 58472 "c/sqlite3.c"
      $21 = ($$05564|0)>($17|0); //@line 58472 "c/sqlite3.c"
      $22 = ($$350$ph|0)==(0); //@line 58472 "c/sqlite3.c"
      $23 = $21 & $22; //@line 58472 "c/sqlite3.c"
      if ($23) {
       $$05564 = $20;
      } else {
       $$047$lcssa = $$350$ph;
       break L6;
      }
     }
     if ((label|0) == 15) {
      $47 = (_sqlite3CorruptError(58492)|0); //@line 58492 "c/sqlite3.c"
      $$3 = $47;
     }
     $$4 = $$3;
     STACKTOP = sp;return ($$4|0); //@line 58517 "c/sqlite3.c"
    }
   } while(0);
   HEAP32[$2>>2] = $$047$lcssa; //@line 58515 "c/sqlite3.c"
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 58517 "c/sqlite3.c"
  }
 } while(0);
 HEAP32[$2>>2] = 0; //@line 58442 "c/sqlite3.c"
 $$4 = 0;
 STACKTOP = sp;return ($$4|0); //@line 58517 "c/sqlite3.c"
}
function _sqlite3WalReadFrame($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 66|0); //@line 58532 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 58532 "c/sqlite3.c"
 $6 = $5&65535; //@line 58532 "c/sqlite3.c"
 $7 = $6 & 65024; //@line 58533 "c/sqlite3.c"
 $8 = $6 << 16; //@line 58533 "c/sqlite3.c"
 $9 = $8 & 65536; //@line 58533 "c/sqlite3.c"
 $10 = $9 | $7; //@line 58533 "c/sqlite3.c"
 $11 = (($1) + -1)|0; //@line 58536 "c/sqlite3.c"
 $12 = $10 | 24; //@line 58536 "c/sqlite3.c"
 $13 = (___muldi3(($12|0),0,($11|0),0)|0); //@line 58536 "c/sqlite3.c"
 $14 = tempRet0; //@line 58536 "c/sqlite3.c"
 $15 = (_i64Add(($13|0),($14|0),56,0)|0); //@line 58536 "c/sqlite3.c"
 $16 = tempRet0; //@line 58536 "c/sqlite3.c"
 $17 = ((($0)) + 8|0); //@line 58538 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 58538 "c/sqlite3.c"
 $19 = ($10|0)<($2|0); //@line 58538 "c/sqlite3.c"
 $20 = $19 ? $10 : $2; //@line 58538 "c/sqlite3.c"
 $21 = (_sqlite3OsRead($18,$3,$20,$15,$16)|0); //@line 58538 "c/sqlite3.c"
 return ($21|0); //@line 58538 "c/sqlite3.c"
}
function _walHash($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0*383)|0; //@line 56465 "c/sqlite3.c"
 $2 = $1 & 8191; //@line 56465 "c/sqlite3.c"
 return ($2|0); //@line 56465 "c/sqlite3.c"
}
function _walNextHash($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (($0) + 1)|0; //@line 56468 "c/sqlite3.c"
 $2 = $1 & 8191; //@line 56468 "c/sqlite3.c"
 return ($2|0); //@line 56468 "c/sqlite3.c"
}
function _pcacheSortDirtyList($0) {
 $0 = $0|0;
 var $$02633 = 0, $$02835 = 0, $$034 = 0, $$12731 = 0, $$132 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 128|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(128|0);
 $1 = sp;
 dest=$1; stop=dest+128|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 45908 "c/sqlite3.c"
 $2 = ($0|0)==(0|0); //@line 45909 "c/sqlite3.c"
 if (!($2)) {
  $$02835 = $0;
  while(1) {
   $3 = ((($$02835)) + 16|0); //@line 45911 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 45911 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 45912 "c/sqlite3.c"
   $$02633 = $$02835;$$034 = 0;
   while(1) {
    $5 = (($1) + ($$034<<2)|0); //@line 45914 "c/sqlite3.c"
    $6 = HEAP32[$5>>2]|0; //@line 45914 "c/sqlite3.c"
    $7 = ($6|0)==(0|0); //@line 45914 "c/sqlite3.c"
    if ($7) {
     label = 5;
     break;
    }
    $8 = (_pcacheMergeDirtyList($6,$$02633)|0); //@line 45918 "c/sqlite3.c"
    HEAP32[$5>>2] = 0; //@line 45919 "c/sqlite3.c"
    $9 = (($$034) + 1)|0; //@line 45913 "c/sqlite3.c"
    $10 = ($9>>>0)<(31); //@line 45913 "c/sqlite3.c"
    if ($10) {
     $$02633 = $8;$$034 = $9;
    } else {
     label = 7;
     break;
    }
   }
   if ((label|0) == 5) {
    label = 0;
    HEAP32[$5>>2] = $$02633; //@line 45915 "c/sqlite3.c"
   }
   else if ((label|0) == 7) {
    label = 0;
    $11 = (($1) + ($9<<2)|0); //@line 45926 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 45926 "c/sqlite3.c"
    $13 = (_pcacheMergeDirtyList($12,$8)|0); //@line 45926 "c/sqlite3.c"
    HEAP32[$11>>2] = $13; //@line 45926 "c/sqlite3.c"
   }
   $14 = ($4|0)==(0|0); //@line 45909 "c/sqlite3.c"
   if ($14) {
    break;
   } else {
    $$02835 = $4;
   }
  }
 }
 $15 = HEAP32[$1>>2]|0; //@line 45929 "c/sqlite3.c"
 $$12731 = $15;$$132 = 1;
 while(1) {
  $16 = (($1) + ($$132<<2)|0); //@line 45931 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 45931 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 45931 "c/sqlite3.c"
  if ($18) {
   $$2 = $$12731;
  } else {
   $19 = ($$12731|0)==(0|0); //@line 45932 "c/sqlite3.c"
   if ($19) {
    $$2 = $17;
   } else {
    $20 = (_pcacheMergeDirtyList($$12731,$17)|0); //@line 45932 "c/sqlite3.c"
    $$2 = $20;
   }
  }
  $21 = (($$132) + 1)|0; //@line 45930 "c/sqlite3.c"
  $exitcond = ($21|0)==(32); //@line 45930 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$12731 = $$2;$$132 = $21;
  }
 }
 STACKTOP = sp;return ($$2|0); //@line 45934 "c/sqlite3.c"
}
function _pcacheMergeDirtyList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$ph = 0, $$0$ph$phi = 0, $$0$phi = 0, $$017 = 0, $$017$ph = 0, $$017$sink = 0, $$019$ph = 0, $$019$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $2 = sp;
 $$0$ph = $2;$$017$ph = $1;$$019$ph = $0;
 L1: while(1) {
  $3 = ((($$019$ph)) + 24|0);
  $4 = HEAP32[$3>>2]|0;
  $$0 = $$0$ph;$$017 = $$017$ph;
  while(1) {
   $5 = ((($$017)) + 24|0); //@line 45873 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 45873 "c/sqlite3.c"
   $7 = ($4>>>0)<($6>>>0); //@line 45873 "c/sqlite3.c"
   $8 = ((($$0)) + 16|0);
   if ($7) {
    break;
   }
   HEAP32[$8>>2] = $$017; //@line 45882 "c/sqlite3.c"
   $12 = ((($$017)) + 16|0); //@line 45884 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 45884 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 45885 "c/sqlite3.c"
   if ($14) {
    $$017$sink = $$017;$$019$sink = $$019$ph;
    break L1;
   } else {
    $$0$phi = $$017;$$017 = $13;$$0 = $$0$phi;
   }
  }
  HEAP32[$8>>2] = $$019$ph; //@line 45874 "c/sqlite3.c"
  $9 = ((($$019$ph)) + 16|0); //@line 45876 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 45876 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 45877 "c/sqlite3.c"
  if ($11) {
   $$017$sink = $$019$ph;$$019$sink = $$017;
   break;
  } else {
   $$0$ph$phi = $$019$ph;$$017$ph = $$017;$$019$ph = $10;$$0$ph = $$0$ph$phi;
  }
 }
 $15 = ((($$017$sink)) + 16|0);
 HEAP32[$15>>2] = $$019$sink;
 $16 = ((($2)) + 16|0); //@line 45891 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 45891 "c/sqlite3.c"
 STACKTOP = sp;return ($17|0); //@line 45891 "c/sqlite3.c"
}
function _walIndexHdr($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 32|0); //@line 56214 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 56214 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 56214 "c/sqlite3.c"
 return ($3|0); //@line 56214 "c/sqlite3.c"
}
function _walFramePgno($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_walFramePage($1)|0); //@line 56538 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 56539 "c/sqlite3.c"
 $4 = ((($0)) + 32|0);
 $5 = HEAP32[$4>>2]|0;
 if ($3) {
  $6 = HEAP32[$5>>2]|0; //@line 56540 "c/sqlite3.c"
  $7 = (($1) + 33)|0; //@line 56540 "c/sqlite3.c"
  $8 = (($6) + ($7<<2)|0); //@line 56540 "c/sqlite3.c"
  $$0$in = $8;
  $$0 = HEAP32[$$0$in>>2]|0;
  return ($$0|0); //@line 56543 "c/sqlite3.c"
 } else {
  $9 = (($5) + ($2<<2)|0); //@line 56542 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 56542 "c/sqlite3.c"
  $11 = (($1) + 33)|0; //@line 56542 "c/sqlite3.c"
  $12 = $11 & 4095; //@line 56542 "c/sqlite3.c"
  $13 = (($10) + ($12<<2)|0); //@line 56542 "c/sqlite3.c"
  $$0$in = $13;
  $$0 = HEAP32[$$0$in>>2]|0;
  return ($$0|0); //@line 56543 "c/sqlite3.c"
 }
 return (0)|0;
}
function _saveCursorsOnList($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$016 = 0, $$3 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $switch = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0);
 $$016 = $0;
 L1: while(1) {
  $4 = ($$016|0)==($2|0); //@line 61162 "c/sqlite3.c"
  do {
   if (!($4)) {
    if (!($3)) {
     $5 = ((($$016)) + 60|0); //@line 61162 "c/sqlite3.c"
     $6 = HEAP32[$5>>2]|0; //@line 61162 "c/sqlite3.c"
     $7 = ($6|0)==($1|0); //@line 61162 "c/sqlite3.c"
     if (!($7)) {
      break;
     }
    }
    $8 = HEAP8[$$016>>0]|0; //@line 61163 "c/sqlite3.c"
    $$off = (($8) + -1)<<24>>24; //@line 61163 "c/sqlite3.c"
    $switch = ($$off&255)<(2); //@line 61163 "c/sqlite3.c"
    if ($switch) {
     $9 = (_saveCursorPosition($$016)|0); //@line 61164 "c/sqlite3.c"
     $10 = ($9|0)==(0); //@line 61165 "c/sqlite3.c"
     if ($10) {
      break;
     } else {
      $$3 = $9;
      label = 9;
      break L1;
     }
    } else {
     _btreeReleaseAllCursorPages($$016); //@line 61170 "c/sqlite3.c"
     break;
    }
   }
  } while(0);
  $11 = ((($$016)) + 16|0); //@line 61173 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 61173 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 61174 "c/sqlite3.c"
  if ($13) {
   $$3 = 0;
   label = 9;
   break;
  } else {
   $$016 = $12;
  }
 }
 if ((label|0) == 9) {
  return ($$3|0); //@line 61176 "c/sqlite3.c"
 }
 return (0)|0;
}
function _saveCursorPosition($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 61099 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(2); //@line 61099 "c/sqlite3.c"
 if ($2) {
  HEAP8[$0>>0] = 1; //@line 61100 "c/sqlite3.c"
 } else {
  $3 = ((($0)) + 64|0); //@line 61102 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 61102 "c/sqlite3.c"
 }
 $4 = (_saveCursorKey($0)|0); //@line 61105 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 61106 "c/sqlite3.c"
 if ($5) {
  _btreeReleaseAllCursorPages($0); //@line 61107 "c/sqlite3.c"
  HEAP8[$0>>0] = 3; //@line 61108 "c/sqlite3.c"
 }
 $6 = ((($0)) + 1|0); //@line 61111 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 61111 "c/sqlite3.c"
 $8 = $7 & -15; //@line 61111 "c/sqlite3.c"
 HEAP8[$6>>0] = $8; //@line 61111 "c/sqlite3.c"
 return ($4|0); //@line 61112 "c/sqlite3.c"
}
function _btreeReleaseAllCursorPages($0) {
 $0 = $0|0;
 var $$07 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 68|0); //@line 61034 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 61034 "c/sqlite3.c"
 $3 = ($2<<24>>24)>(-1); //@line 61034 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 61041 "c/sqlite3.c"
 }
 $4 = HEAP8[$1>>0]|0; //@line 61035 "c/sqlite3.c"
 $5 = ($4<<24>>24)>(0); //@line 61035 "c/sqlite3.c"
 if ($5) {
  $$07 = 0;
  while(1) {
   $6 = (((($0)) + 120|0) + ($$07<<2)|0); //@line 61036 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 61036 "c/sqlite3.c"
   _releasePageNotNull($7); //@line 61036 "c/sqlite3.c"
   $8 = (($$07) + 1)|0; //@line 61035 "c/sqlite3.c"
   $9 = HEAP8[$1>>0]|0; //@line 61035 "c/sqlite3.c"
   $10 = $9 << 24 >> 24; //@line 61035 "c/sqlite3.c"
   $11 = ($8|0)<($10|0); //@line 61035 "c/sqlite3.c"
   if ($11) {
    $$07 = $8;
   } else {
    break;
   }
  }
 }
 $12 = ((($0)) + 116|0); //@line 61038 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 61038 "c/sqlite3.c"
 _releasePageNotNull($13); //@line 61038 "c/sqlite3.c"
 HEAP8[$1>>0] = -1; //@line 61039 "c/sqlite3.c"
 return; //@line 61041 "c/sqlite3.c"
}
function _releasePageNotNull($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 72|0); //@line 62557 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62557 "c/sqlite3.c"
 _sqlite3PagerUnrefNotNull($2); //@line 62557 "c/sqlite3.c"
 return; //@line 62558 "c/sqlite3.c"
}
function _saveCursorKey($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 69|0); //@line 61062 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 61062 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 61062 "c/sqlite3.c"
 if (!($3)) {
  $4 = (_sqlite3BtreeIntegerKey($0)|0); //@line 61064 "c/sqlite3.c"
  $5 = tempRet0; //@line 61064 "c/sqlite3.c"
  $6 = ((($0)) + 48|0); //@line 61064 "c/sqlite3.c"
  $7 = $6; //@line 61064 "c/sqlite3.c"
  $8 = $7; //@line 61064 "c/sqlite3.c"
  HEAP32[$8>>2] = $4; //@line 61064 "c/sqlite3.c"
  $9 = (($7) + 4)|0; //@line 61064 "c/sqlite3.c"
  $10 = $9; //@line 61064 "c/sqlite3.c"
  HEAP32[$10>>2] = $5; //@line 61064 "c/sqlite3.c"
  $$1 = 0;
  return ($$1|0); //@line 61082 "c/sqlite3.c"
 }
 $11 = (_sqlite3BtreePayloadSize($0)|0); //@line 61068 "c/sqlite3.c"
 $12 = ((($0)) + 48|0); //@line 61068 "c/sqlite3.c"
 $13 = $12; //@line 61068 "c/sqlite3.c"
 $14 = $13; //@line 61068 "c/sqlite3.c"
 HEAP32[$14>>2] = $11; //@line 61068 "c/sqlite3.c"
 $15 = (($13) + 4)|0; //@line 61068 "c/sqlite3.c"
 $16 = $15; //@line 61068 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 61068 "c/sqlite3.c"
 $17 = (_sqlite3Malloc($11,0)|0); //@line 61069 "c/sqlite3.c"
 $18 = ($17|0)==(0|0); //@line 61070 "c/sqlite3.c"
 if ($18) {
  $$1 = 7;
  return ($$1|0); //@line 61082 "c/sqlite3.c"
 }
 $19 = $12; //@line 61071 "c/sqlite3.c"
 $20 = $19; //@line 61071 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 61071 "c/sqlite3.c"
 $22 = (($19) + 4)|0; //@line 61071 "c/sqlite3.c"
 $23 = $22; //@line 61071 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 61071 "c/sqlite3.c"
 $25 = (_sqlite3BtreePayload($0,0,$21,$17)|0); //@line 61071 "c/sqlite3.c"
 $26 = ($25|0)==(0); //@line 61072 "c/sqlite3.c"
 if ($26) {
  $27 = ((($0)) + 56|0); //@line 61073 "c/sqlite3.c"
  HEAP32[$27>>2] = $17; //@line 61073 "c/sqlite3.c"
  $$1 = 0;
  return ($$1|0); //@line 61082 "c/sqlite3.c"
 } else {
  _sqlite3_free($17); //@line 61075 "c/sqlite3.c"
  $$1 = $25;
  return ($$1|0); //@line 61082 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeIntegerKey($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _getCellInfo($0); //@line 64837 "c/sqlite3.c"
 $1 = ((($0)) + 24|0); //@line 64838 "c/sqlite3.c"
 $2 = $1; //@line 64838 "c/sqlite3.c"
 $3 = $2; //@line 64838 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 64838 "c/sqlite3.c"
 $5 = (($2) + 4)|0; //@line 64838 "c/sqlite3.c"
 $6 = $5; //@line 64838 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 64838 "c/sqlite3.c"
 tempRet0 = ($7); //@line 64838 "c/sqlite3.c"
 return ($4|0); //@line 64838 "c/sqlite3.c"
}
function _sqlite3BtreePayloadSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _getCellInfo($0); //@line 64867 "c/sqlite3.c"
 $1 = ((($0)) + 36|0); //@line 64868 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 64868 "c/sqlite3.c"
 return ($2|0); //@line 64868 "c/sqlite3.c"
}
function _sqlite3BtreePayload($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_accessPayload($0,$1,$2,$3,0)|0); //@line 65216 "c/sqlite3.c"
 return ($4|0); //@line 65216 "c/sqlite3.c"
}
function _accessPayload($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0126 = 0, $$0131 = 0, $$0142 = 0, $$0146172 = 0, $$0148 = 0, $$1127173 = 0, $$1132164 = 0, $$1143163 = 0, $$1147162 = 0, $$2128165 = 0, $$2133 = 0, $$2150 = 0, $$3129 = 0, $$3145 = 0, $$3151 = 0, $$4130 = 0, $$4135$ph = 0, $$4152 = 0, $$5136 = 0, $$6154$ph = 0;
 var $$7155 = 0, $$8 = 0, $$9 = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0;
 var $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0;
 var $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond6 = 0, $spec$select = 0, $spec$select156 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp + 4|0;
 $6 = sp;
 $7 = ((($0)) + 116|0); //@line 65018 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 65018 "c/sqlite3.c"
 $9 = ((($0)) + 12|0); //@line 65019 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 65019 "c/sqlite3.c"
 _getCellInfo($0); //@line 65030 "c/sqlite3.c"
 $11 = ((($0)) + 32|0); //@line 65031 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 65031 "c/sqlite3.c"
 $13 = ((($8)) + 56|0); //@line 65035 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 65035 "c/sqlite3.c"
 $15 = $12; //@line 65035 "c/sqlite3.c"
 $16 = (($15) - ($14))|0; //@line 65035 "c/sqlite3.c"
 $17 = ((($10)) + 36|0); //@line 65035 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 65035 "c/sqlite3.c"
 $19 = ((($0)) + 40|0); //@line 65035 "c/sqlite3.c"
 $20 = HEAP16[$19>>1]|0; //@line 65035 "c/sqlite3.c"
 $21 = $20&65535; //@line 65035 "c/sqlite3.c"
 $22 = (($18) - ($21))|0; //@line 65035 "c/sqlite3.c"
 $23 = ($16>>>0)>($22>>>0); //@line 65035 "c/sqlite3.c"
 if ($23) {
  $24 = (_sqlite3CorruptError(65041)|0); //@line 65041 "c/sqlite3.c"
  $$9 = $24;
  STACKTOP = sp;return ($$9|0); //@line 65192 "c/sqlite3.c"
 }
 $25 = ($21>>>0)>($1>>>0); //@line 65045 "c/sqlite3.c"
 if ($25) {
  $26 = (($2) + ($1))|0; //@line 65047 "c/sqlite3.c"
  $27 = ($26>>>0)>($21>>>0); //@line 65047 "c/sqlite3.c"
  $28 = (($21) - ($1))|0; //@line 65048 "c/sqlite3.c"
  $spec$select = $27 ? $28 : $2; //@line 65047 "c/sqlite3.c"
  $29 = (($12) + ($1)|0); //@line 65050 "c/sqlite3.c"
  $30 = ((($8)) + 72|0); //@line 65050 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 65050 "c/sqlite3.c"
  $32 = (_copyPayload($29,$3,$spec$select,$4,$31)|0); //@line 65050 "c/sqlite3.c"
  $33 = (($3) + ($spec$select)|0); //@line 65052 "c/sqlite3.c"
  $34 = (($2) - ($spec$select))|0; //@line 65053 "c/sqlite3.c"
  $$0126 = 0;$$0131 = $34;$$0142 = $33;$$0148 = $32;
 } else {
  $35 = (($1) - ($21))|0; //@line 65055 "c/sqlite3.c"
  $$0126 = $35;$$0131 = $2;$$0142 = $3;$$0148 = 0;
 }
 $36 = ($$0148|0)==(0); //@line 65059 "c/sqlite3.c"
 $37 = ($$0131|0)!=(0); //@line 65059 "c/sqlite3.c"
 $or$cond = $36 & $37; //@line 65059 "c/sqlite3.c"
 do {
  if ($or$cond) {
   $38 = HEAP32[$17>>2]|0; //@line 65060 "c/sqlite3.c"
   $39 = (($38) + -4)|0; //@line 65060 "c/sqlite3.c"
   $40 = HEAP16[$19>>1]|0; //@line 65063 "c/sqlite3.c"
   $41 = $40&65535; //@line 65063 "c/sqlite3.c"
   $42 = (($12) + ($41)|0); //@line 65063 "c/sqlite3.c"
   $43 = (_sqlite3Get4byte($42)|0); //@line 65063 "c/sqlite3.c"
   HEAP32[$5>>2] = $43; //@line 65063 "c/sqlite3.c"
   $44 = ((($0)) + 1|0); //@line 65072 "c/sqlite3.c"
   $45 = HEAP8[$44>>0]|0; //@line 65072 "c/sqlite3.c"
   $46 = $45 & 4; //@line 65072 "c/sqlite3.c"
   $47 = ($46<<24>>24)==(0); //@line 65072 "c/sqlite3.c"
   do {
    if ($47) {
     $48 = ((($0)) + 36|0); //@line 65073 "c/sqlite3.c"
     $49 = HEAP32[$48>>2]|0; //@line 65073 "c/sqlite3.c"
     $50 = (($38) + -5)|0; //@line 65073 "c/sqlite3.c"
     $51 = (($50) - ($41))|0; //@line 65073 "c/sqlite3.c"
     $52 = (($51) + ($49))|0; //@line 65073 "c/sqlite3.c"
     $53 = (($52>>>0) / ($39>>>0))&-1; //@line 65073 "c/sqlite3.c"
     $54 = ((($0)) + 4|0); //@line 65074 "c/sqlite3.c"
     $55 = HEAP32[$54>>2]|0; //@line 65074 "c/sqlite3.c"
     $56 = ($53|0)>($55|0); //@line 65074 "c/sqlite3.c"
     if ($56) {
      $57 = ((($0)) + 20|0); //@line 65076 "c/sqlite3.c"
      $58 = HEAP32[$57>>2]|0; //@line 65076 "c/sqlite3.c"
      $59 = $53 << 3; //@line 65076 "c/sqlite3.c"
      $60 = (_sqlite3Realloc($58,$59,0)|0); //@line 65075 "c/sqlite3.c"
      $61 = ($60|0)==(0|0); //@line 65078 "c/sqlite3.c"
      if ($61) {
       $$8 = 7;
       break;
      }
      $62 = $53 << 1; //@line 65076 "c/sqlite3.c"
      HEAP32[$54>>2] = $62; //@line 65081 "c/sqlite3.c"
      HEAP32[$57>>2] = $60; //@line 65082 "c/sqlite3.c"
     }
     $63 = ((($0)) + 20|0); //@line 65085 "c/sqlite3.c"
     $64 = HEAP32[$63>>2]|0; //@line 65085 "c/sqlite3.c"
     $65 = $53 << 2; //@line 65085 "c/sqlite3.c"
     _memset(($64|0),0,($65|0))|0; //@line 65085 "c/sqlite3.c"
     $66 = HEAP8[$44>>0]|0; //@line 65086 "c/sqlite3.c"
     $67 = $66 | 4; //@line 65086 "c/sqlite3.c"
     HEAP8[$44>>0] = $67; //@line 65086 "c/sqlite3.c"
     label = 14;
    } else {
     $68 = ((($0)) + 20|0); //@line 65092 "c/sqlite3.c"
     $69 = HEAP32[$68>>2]|0; //@line 65092 "c/sqlite3.c"
     $70 = (($$0126>>>0) / ($39>>>0))&-1; //@line 65092 "c/sqlite3.c"
     $71 = (($69) + ($70<<2)|0); //@line 65092 "c/sqlite3.c"
     $72 = HEAP32[$71>>2]|0; //@line 65092 "c/sqlite3.c"
     $73 = ($72|0)==(0); //@line 65092 "c/sqlite3.c"
     if ($73) {
      label = 14;
     } else {
      HEAP32[$5>>2] = $72; //@line 65094 "c/sqlite3.c"
      $74 = Math_imul($70, $39)|0;
      $75 = (($$0126) - ($74))|0;
      $$0146172 = $70;$$1127173 = $75;$113 = $72;
      label = 15;
     }
    }
   } while(0);
   if ((label|0) == 14) {
    $$pr = HEAP32[$5>>2]|0; //@line 65100 "c/sqlite3.c"
    $76 = ($$pr|0)==(0); //@line 65100 "c/sqlite3.c"
    if ($76) {
     $$4135$ph = $$0131;$$6154$ph = 0;
     label = 26;
    } else {
     $$0146172 = 0;$$1127173 = $$0126;$113 = $$pr;
     label = 15;
    }
   }
   L21: do {
    if ((label|0) == 15) {
     $77 = ((($0)) + 20|0);
     $78 = ($4|0)==(0);
     $79 = $78 ? 2 : 0;
     $$1132164 = $$0131;$$1143163 = $$0142;$$1147162 = $$0146172;$$2128165 = $$1127173;$85 = $113;
     while(1) {
      $83 = HEAP32[$77>>2]|0; //@line 65105 "c/sqlite3.c"
      $84 = (($83) + ($$1147162<<2)|0); //@line 65105 "c/sqlite3.c"
      HEAP32[$84>>2] = $85; //@line 65105 "c/sqlite3.c"
      $86 = ($$2128165>>>0)<($39>>>0); //@line 65107 "c/sqlite3.c"
      if ($86) {
       $93 = (($$2128165) + ($$1132164))|0; //@line 65130 "c/sqlite3.c"
       $94 = ($93>>>0)>($39>>>0); //@line 65130 "c/sqlite3.c"
       $95 = (($39) - ($$2128165))|0; //@line 65131 "c/sqlite3.c"
       $spec$select156 = $94 ? $95 : $$1132164; //@line 65130 "c/sqlite3.c"
       $96 = HEAP32[$10>>2]|0; //@line 65167 "c/sqlite3.c"
       $97 = (_sqlite3PagerGet($96,$85,$6,$79)|0); //@line 65167 "c/sqlite3.c"
       $98 = ($97|0)==(0); //@line 65170 "c/sqlite3.c"
       if ($98) {
        $99 = HEAP32[$6>>2]|0; //@line 65171 "c/sqlite3.c"
        $100 = (_sqlite3PagerGetData($99)|0); //@line 65171 "c/sqlite3.c"
        $101 = (_sqlite3Get4byte($100)|0); //@line 65172 "c/sqlite3.c"
        HEAP32[$5>>2] = $101; //@line 65172 "c/sqlite3.c"
        $102 = (($$2128165) + 4)|0; //@line 65173 "c/sqlite3.c"
        $103 = (($100) + ($102)|0); //@line 65173 "c/sqlite3.c"
        $104 = (_copyPayload($103,$$1143163,$spec$select156,$4,$99)|0); //@line 65173 "c/sqlite3.c"
        $105 = HEAP32[$6>>2]|0; //@line 65174 "c/sqlite3.c"
        _sqlite3PagerUnref($105); //@line 65174 "c/sqlite3.c"
        $$3129 = 0;$$3151 = $104;
       } else {
        $$3129 = $$2128165;$$3151 = $97;
       }
       $106 = (($$1132164) - ($spec$select156))|0; //@line 65178 "c/sqlite3.c"
       $107 = ($106|0)==(0); //@line 65179 "c/sqlite3.c"
       $108 = (($$1143163) + ($spec$select156)|0); //@line 65180 "c/sqlite3.c"
       if ($107) {
        $$8 = $$3151;
        break L21;
       } else {
        $$2133 = $106;$$3145 = $108;$$4130 = $$3129;$$4152 = $$3151;
       }
      } else {
       $87 = (($$1147162) + 1)|0; //@line 65116 "c/sqlite3.c"
       $88 = (($83) + ($87<<2)|0); //@line 65116 "c/sqlite3.c"
       $89 = HEAP32[$88>>2]|0; //@line 65116 "c/sqlite3.c"
       $90 = ($89|0)==(0); //@line 65116 "c/sqlite3.c"
       if ($90) {
        $91 = (_getOverflowPage($10,$85,0,$5)|0); //@line 65119 "c/sqlite3.c"
        $$2150 = $91;
       } else {
        HEAP32[$5>>2] = $89; //@line 65117 "c/sqlite3.c"
        $$2150 = 0;
       }
       $92 = (($$2128165) - ($39))|0; //@line 65121 "c/sqlite3.c"
       $$2133 = $$1132164;$$3145 = $$1143163;$$4130 = $92;$$4152 = $$2150;
      }
      $109 = ($$4152|0)==(0); //@line 65182 "c/sqlite3.c"
      if (!($109)) {
       $$4135$ph = $$2133;$$6154$ph = $$4152;
       label = 26;
       break L21;
      }
      $80 = (($$1147162) + 1)|0; //@line 65183 "c/sqlite3.c"
      $81 = HEAP32[$5>>2]|0; //@line 65100 "c/sqlite3.c"
      $82 = ($81|0)==(0); //@line 65100 "c/sqlite3.c"
      if ($82) {
       $$4135$ph = $$2133;$$6154$ph = 0;
       label = 26;
       break;
      } else {
       $$1132164 = $$2133;$$1143163 = $$3145;$$1147162 = $80;$$2128165 = $$4130;$85 = $81;
      }
     }
    }
   } while(0);
   if ((label|0) == 26) {
    $$5136 = $$4135$ph;$$7155 = $$6154$ph;
    break;
   }
   $$9 = $$8;
   STACKTOP = sp;return ($$9|0); //@line 65192 "c/sqlite3.c"
  } else {
   $$5136 = $$0131;$$7155 = $$0148;
  }
 } while(0);
 $110 = ($$7155|0)==(0); //@line 65187 "c/sqlite3.c"
 $111 = ($$5136|0)!=(0); //@line 65187 "c/sqlite3.c"
 $or$cond6 = $110 & $111; //@line 65187 "c/sqlite3.c"
 if (!($or$cond6)) {
  $$9 = $$7155;
  STACKTOP = sp;return ($$9|0); //@line 65192 "c/sqlite3.c"
 }
 $112 = (_sqlite3CorruptError(65189)|0); //@line 65189 "c/sqlite3.c"
 $$9 = $112;
 STACKTOP = sp;return ($$9|0); //@line 65192 "c/sqlite3.c"
}
function _getCellInfo($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 42|0); //@line 64804 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 64804 "c/sqlite3.c"
 $3 = ($2<<16>>16)==(0); //@line 64804 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 64810 "c/sqlite3.c"
 }
 $4 = ((($0)) + 24|0); //@line 64804 "c/sqlite3.c"
 $5 = ((($0)) + 1|0); //@line 64805 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 64805 "c/sqlite3.c"
 $7 = $6 | 2; //@line 64805 "c/sqlite3.c"
 HEAP8[$5>>0] = $7; //@line 64805 "c/sqlite3.c"
 $8 = ((($0)) + 116|0); //@line 64806 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 64806 "c/sqlite3.c"
 $10 = ((($0)) + 70|0); //@line 64806 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 64806 "c/sqlite3.c"
 $12 = $11&65535; //@line 64806 "c/sqlite3.c"
 _btreeParseCell($9,$12,$4); //@line 64806 "c/sqlite3.c"
 return; //@line 64810 "c/sqlite3.c"
}
function _copyPayload($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$1 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($3|0)==(0); //@line 64965 "c/sqlite3.c"
 if ($5) {
  _memcpy(($1|0),($0|0),($2|0))|0; //@line 64974 "c/sqlite3.c"
  $$1 = 0;
 } else {
  $6 = (_sqlite3PagerWrite($4)|0); //@line 64967 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 64968 "c/sqlite3.c"
  if ($7) {
   _memcpy(($0|0),($1|0),($2|0))|0; //@line 64971 "c/sqlite3.c"
   $$1 = 0;
  } else {
   $$1 = $6;
  }
 }
 return ($$1|0); //@line 64977 "c/sqlite3.c"
}
function _getOverflowPage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$0$in = 0, $$2 = 0, $$232 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond35 = 0;
 var $or$cond40 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 $6 = sp + 8|0;
 HEAP32[$4>>2] = 0; //@line 64897 "c/sqlite3.c"
 $7 = ((($0)) + 17|0); //@line 64910 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 64910 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 64910 "c/sqlite3.c"
 do {
  if ($9) {
   label = 8;
  } else {
   $10 = HEAP32[513]|0;
   $11 = ((($0)) + 32|0);
   $12 = HEAP32[$11>>2]|0;
   $13 = (($10>>>0) / ($12>>>0))&-1;
   $$0$in = $1;
   while(1) {
    $$0 = (($$0$in) + 1)|0;
    $14 = (_ptrmapPageno($0,$$0)|0); //@line 64915 "c/sqlite3.c"
    $15 = ($14|0)==($$0|0); //@line 64915 "c/sqlite3.c"
    $16 = ($$0$in|0)==($13|0); //@line 64915 "c/sqlite3.c"
    $or$cond40 = $15 | $16; //@line 64915 "c/sqlite3.c"
    if ($or$cond40) {
     $$0$in = $$0;
    } else {
     break;
    }
   }
   $17 = (_btreePagecount($0)|0); //@line 64919 "c/sqlite3.c"
   $18 = ($$0>>>0)>($17>>>0); //@line 64919 "c/sqlite3.c"
   if ($18) {
    label = 8;
    break;
   }
   $19 = (_ptrmapGet($0,$$0,$6,$5)|0); //@line 64920 "c/sqlite3.c"
   $20 = ($19|0)==(0); //@line 64921 "c/sqlite3.c"
   $21 = HEAP8[$6>>0]|0; //@line 64921 "c/sqlite3.c"
   $22 = ($21<<24>>24)==(4); //@line 64921 "c/sqlite3.c"
   $or$cond = $20 & $22; //@line 64921 "c/sqlite3.c"
   $23 = HEAP32[$5>>2]|0; //@line 64921 "c/sqlite3.c"
   $24 = ($23|0)==($1|0); //@line 64921 "c/sqlite3.c"
   $or$cond35 = $or$cond & $24; //@line 64921 "c/sqlite3.c"
   if ($or$cond35) {
    $$2 = 101;$$232 = $$0;
   } else {
    $25 = ($19|0)==(0); //@line 64930 "c/sqlite3.c"
    if ($25) {
     label = 8;
    } else {
     $$2 = $19;$$232 = 0;
    }
   }
  }
 } while(0);
 if ((label|0) == 8) {
  $26 = ($2|0)==(0|0); //@line 64931 "c/sqlite3.c"
  $27 = $26 ? 2 : 0; //@line 64931 "c/sqlite3.c"
  $28 = (_btreeGetPage($0,$1,$4,$27)|0); //@line 64931 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 64933 "c/sqlite3.c"
  if ($29) {
   $30 = HEAP32[$4>>2]|0; //@line 64934 "c/sqlite3.c"
   $31 = ((($30)) + 56|0); //@line 64934 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 64934 "c/sqlite3.c"
   $33 = (_sqlite3Get4byte($32)|0); //@line 64934 "c/sqlite3.c"
   $$2 = 0;$$232 = $33;
  } else {
   $$2 = $28;$$232 = 0;
  }
 }
 HEAP32[$3>>2] = $$232; //@line 64938 "c/sqlite3.c"
 $34 = ($2|0)==(0|0); //@line 64939 "c/sqlite3.c"
 $35 = HEAP32[$4>>2]|0;
 if ($34) {
  _releasePage($35); //@line 64942 "c/sqlite3.c"
  $36 = ($$2|0)==(101); //@line 64944 "c/sqlite3.c"
  $37 = $36 ? 0 : $$2; //@line 64944 "c/sqlite3.c"
  STACKTOP = sp;return ($37|0); //@line 64944 "c/sqlite3.c"
 } else {
  HEAP32[$2>>2] = $35; //@line 64940 "c/sqlite3.c"
  $36 = ($$2|0)==(101); //@line 64944 "c/sqlite3.c"
  $37 = $36 ? 0 : $$2; //@line 64944 "c/sqlite3.c"
  STACKTOP = sp;return ($37|0); //@line 64944 "c/sqlite3.c"
 }
 return (0)|0;
}
function _ptrmapPageno($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$015 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$select$v = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1>>>0)<(2); //@line 61350 "c/sqlite3.c"
 if ($2) {
  $$015 = 0;
  return ($$015|0); //@line 61358 "c/sqlite3.c"
 }
 $3 = ((($0)) + 36|0); //@line 61351 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 61351 "c/sqlite3.c"
 $5 = (($4>>>0) / 5)&-1; //@line 61351 "c/sqlite3.c"
 $6 = (($5) + 1)|0; //@line 61351 "c/sqlite3.c"
 $7 = (($1) + -2)|0; //@line 61352 "c/sqlite3.c"
 $8 = (($7>>>0) % ($6>>>0))&-1; //@line 61353 "c/sqlite3.c"
 $9 = (($7) - ($8))|0; //@line 61353 "c/sqlite3.c"
 $10 = HEAP32[513]|0; //@line 61354 "c/sqlite3.c"
 $11 = ((($0)) + 32|0); //@line 61354 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 61354 "c/sqlite3.c"
 $13 = (($10>>>0) / ($12>>>0))&-1; //@line 61354 "c/sqlite3.c"
 $14 = (($9) + 1)|0; //@line 61354 "c/sqlite3.c"
 $15 = ($14|0)==($13|0); //@line 61354 "c/sqlite3.c"
 $spec$select$v = $15 ? 3 : 2; //@line 61354 "c/sqlite3.c"
 $spec$select = (($spec$select$v) + ($9))|0; //@line 61354 "c/sqlite3.c"
 $$015 = $spec$select;
 return ($$015|0); //@line 61358 "c/sqlite3.c"
}
function _ptrmapGet($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = (_ptrmapPageno($0,$1)|0); //@line 61431 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 61432 "c/sqlite3.c"
 $7 = (_sqlite3PagerGet($6,$5,$4,0)|0); //@line 61432 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 61433 "c/sqlite3.c"
 if (!($8)) {
  $$0 = $7;
  STACKTOP = sp;return ($$0|0); //@line 61451 "c/sqlite3.c"
 }
 $9 = HEAP32[$4>>2]|0; //@line 61436 "c/sqlite3.c"
 $10 = (_sqlite3PagerGetData($9)|0); //@line 61436 "c/sqlite3.c"
 $11 = (($1) - ($5))|0; //@line 61438 "c/sqlite3.c"
 $12 = ($11*5)|0; //@line 61438 "c/sqlite3.c"
 $13 = (($12) + -5)|0; //@line 61438 "c/sqlite3.c"
 $14 = ($13|0)<(0); //@line 61439 "c/sqlite3.c"
 if ($14) {
  _sqlite3PagerUnref($9); //@line 61440 "c/sqlite3.c"
  $15 = (_sqlite3CorruptError(61441)|0); //@line 61441 "c/sqlite3.c"
  $$0 = $15;
  STACKTOP = sp;return ($$0|0); //@line 61451 "c/sqlite3.c"
 }
 $16 = (($10) + ($13)|0); //@line 61445 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 61445 "c/sqlite3.c"
 HEAP8[$2>>0] = $17; //@line 61445 "c/sqlite3.c"
 $18 = ($3|0)==(0|0); //@line 61446 "c/sqlite3.c"
 if (!($18)) {
  $19 = (($12) + -4)|0; //@line 61446 "c/sqlite3.c"
  $20 = (($10) + ($19)|0); //@line 61446 "c/sqlite3.c"
  $21 = (_sqlite3Get4byte($20)|0); //@line 61446 "c/sqlite3.c"
  HEAP32[$3>>2] = $21; //@line 61446 "c/sqlite3.c"
 }
 _sqlite3PagerUnref($9); //@line 61448 "c/sqlite3.c"
 $22 = HEAP8[$2>>0]|0; //@line 61449 "c/sqlite3.c"
 $23 = (($22) + -1)<<24>>24; //@line 61449 "c/sqlite3.c"
 $24 = ($23&255)>(4); //@line 61449 "c/sqlite3.c"
 if (!($24)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 61451 "c/sqlite3.c"
 }
 $25 = (_sqlite3CorruptError(61449)|0); //@line 61449 "c/sqlite3.c"
 $$0 = $25;
 STACKTOP = sp;return ($$0|0); //@line 61451 "c/sqlite3.c"
}
function _btreeGetPage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = HEAP32[$0>>2]|0; //@line 62444 "c/sqlite3.c"
 $6 = (_sqlite3PagerGet($5,$1,$4,$3)|0); //@line 62444 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 62445 "c/sqlite3.c"
 if (!($7)) {
  $$0 = $6;
  STACKTOP = sp;return ($$0|0); //@line 62448 "c/sqlite3.c"
 }
 $8 = HEAP32[$4>>2]|0; //@line 62446 "c/sqlite3.c"
 $9 = (_btreePageFromDbPage($8,$1,$0)|0); //@line 62446 "c/sqlite3.c"
 HEAP32[$2>>2] = $9; //@line 62446 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 62448 "c/sqlite3.c"
}
function _releasePage($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 62560 "c/sqlite3.c"
 if (!($1)) {
  _releasePageNotNull($0); //@line 62560 "c/sqlite3.c"
 }
 return; //@line 62561 "c/sqlite3.c"
}
function _btreePageFromDbPage($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3PagerGetExtra($0)|0); //@line 62410 "c/sqlite3.c"
 $4 = ((($3)) + 4|0); //@line 62411 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 62411 "c/sqlite3.c"
 $6 = ($5|0)==($1|0); //@line 62411 "c/sqlite3.c"
 if ($6) {
  return ($3|0); //@line 62419 "c/sqlite3.c"
 }
 $7 = (_sqlite3PagerGetData($0)|0); //@line 62412 "c/sqlite3.c"
 $8 = ((($3)) + 56|0); //@line 62412 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 62412 "c/sqlite3.c"
 $9 = ((($3)) + 72|0); //@line 62413 "c/sqlite3.c"
 HEAP32[$9>>2] = $0; //@line 62413 "c/sqlite3.c"
 $10 = ((($3)) + 52|0); //@line 62414 "c/sqlite3.c"
 HEAP32[$10>>2] = $2; //@line 62414 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 62415 "c/sqlite3.c"
 $11 = ($1|0)==(1); //@line 62416 "c/sqlite3.c"
 $12 = $11 ? 100 : 0; //@line 62416 "c/sqlite3.c"
 $13 = ((($3)) + 9|0); //@line 62416 "c/sqlite3.c"
 HEAP8[$13>>0] = $12; //@line 62416 "c/sqlite3.c"
 return ($3|0); //@line 62419 "c/sqlite3.c"
}
function _btreeParseCell($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 80|0); //@line 61653 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 61653 "c/sqlite3.c"
 $5 = ((($0)) + 56|0); //@line 61653 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 61653 "c/sqlite3.c"
 $7 = ((($0)) + 24|0); //@line 61653 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 61653 "c/sqlite3.c"
 $9 = $8&65535; //@line 61653 "c/sqlite3.c"
 $10 = ((($0)) + 64|0); //@line 61653 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 61653 "c/sqlite3.c"
 $12 = $1 << 1; //@line 61653 "c/sqlite3.c"
 $13 = (($11) + ($12)|0); //@line 61653 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 61653 "c/sqlite3.c"
 $15 = $14&255; //@line 61653 "c/sqlite3.c"
 $16 = $15 << 8; //@line 61653 "c/sqlite3.c"
 $17 = ((($13)) + 1|0); //@line 61653 "c/sqlite3.c"
 $18 = HEAP8[$17>>0]|0; //@line 61653 "c/sqlite3.c"
 $19 = $18&255; //@line 61653 "c/sqlite3.c"
 $20 = $16 | $19; //@line 61653 "c/sqlite3.c"
 $21 = $20 & $9; //@line 61653 "c/sqlite3.c"
 $22 = (($6) + ($21)|0); //@line 61653 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$4 & 255]($0,$22,$2); //@line 61653 "c/sqlite3.c"
 return; //@line 61654 "c/sqlite3.c"
}
function _btreeLockCarefully($0) {
 $0 = $0|0;
 var $$0 = 0, $$017 = 0, $$018 = 0, $$1 = 0, $$115 = 0, $$116 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 60204 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60204 "c/sqlite3.c"
 $3 = ((($2)) + 56|0); //@line 60204 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60204 "c/sqlite3.c"
 $5 = (_sqlite3_mutex_try($4)|0); //@line 60204 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 60204 "c/sqlite3.c"
 if ($6) {
  $7 = HEAP32[$0>>2]|0; //@line 60205 "c/sqlite3.c"
  $8 = HEAP32[$1>>2]|0; //@line 60205 "c/sqlite3.c"
  $9 = ((($8)) + 4|0); //@line 60205 "c/sqlite3.c"
  HEAP32[$9>>2] = $7; //@line 60205 "c/sqlite3.c"
  $10 = ((($0)) + 10|0); //@line 60206 "c/sqlite3.c"
  HEAP8[$10>>0] = 1; //@line 60206 "c/sqlite3.c"
  return; //@line 60229 "c/sqlite3.c"
 }
 $11 = ((($0)) + 24|0); //@line 60215 "c/sqlite3.c"
 $$017 = HEAP32[$11>>2]|0;
 $12 = ($$017|0)==(0|0); //@line 60215 "c/sqlite3.c"
 if (!($12)) {
  $$018 = $$017;
  while(1) {
   $13 = ((($$018)) + 10|0); //@line 60219 "c/sqlite3.c"
   $14 = HEAP8[$13>>0]|0; //@line 60219 "c/sqlite3.c"
   $15 = ($14<<24>>24)==(0); //@line 60219 "c/sqlite3.c"
   if (!($15)) {
    _unlockBtreeMutex($$018); //@line 60220 "c/sqlite3.c"
   }
   $16 = ((($$018)) + 24|0); //@line 60215 "c/sqlite3.c"
   $$0 = HEAP32[$16>>2]|0;
   $17 = ($$0|0)==(0|0); //@line 60215 "c/sqlite3.c"
   if ($17) {
    break;
   } else {
    $$018 = $$0;
   }
  }
 }
 _lockBtreeMutex($0); //@line 60223 "c/sqlite3.c"
 $$115 = HEAP32[$11>>2]|0;
 $18 = ($$115|0)==(0|0); //@line 60224 "c/sqlite3.c"
 if ($18) {
  return; //@line 60229 "c/sqlite3.c"
 }
 $$116 = $$115;
 while(1) {
  $19 = ((($$116)) + 12|0); //@line 60225 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 60225 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 60225 "c/sqlite3.c"
  if (!($21)) {
   _lockBtreeMutex($$116); //@line 60226 "c/sqlite3.c"
  }
  $22 = ((($$116)) + 24|0); //@line 60224 "c/sqlite3.c"
  $$1 = HEAP32[$22>>2]|0;
  $23 = ($$1|0)==(0|0); //@line 60224 "c/sqlite3.c"
  if ($23) {
   break;
  } else {
   $$116 = $$1;
  }
 }
 return; //@line 60229 "c/sqlite3.c"
}
function _lockBtreeMutex($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 60124 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60124 "c/sqlite3.c"
 $3 = ((($2)) + 56|0); //@line 60124 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60124 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 60124 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 60125 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 60125 "c/sqlite3.c"
 $7 = ((($6)) + 4|0); //@line 60125 "c/sqlite3.c"
 HEAP32[$7>>2] = $5; //@line 60125 "c/sqlite3.c"
 $8 = ((($0)) + 10|0); //@line 60126 "c/sqlite3.c"
 HEAP8[$8>>0] = 1; //@line 60126 "c/sqlite3.c"
 return; //@line 60127 "c/sqlite3.c"
}
function _sqlite3VtabSync($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$025$lcssa = 0, $$027 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 348|0); //@line 128251 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 128251 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 128253 "c/sqlite3.c"
 $4 = ((($0)) + 324|0); //@line 128254 "c/sqlite3.c"
 $$027 = 0;
 while(1) {
  $5 = HEAP32[$4>>2]|0; //@line 128254 "c/sqlite3.c"
  $6 = ($$027|0)<($5|0); //@line 128254 "c/sqlite3.c"
  if (!($6)) {
   $$025$lcssa = 0;
   label = 7;
   break;
  }
  $7 = (($3) + ($$027<<2)|0); //@line 128256 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 128256 "c/sqlite3.c"
  $9 = ((($8)) + 8|0); //@line 128256 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 128256 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 128257 "c/sqlite3.c"
  if ($11) {
   $$1 = 0;
  } else {
   $12 = HEAP32[$10>>2]|0; //@line 128257 "c/sqlite3.c"
   $13 = ((($12)) + 60|0); //@line 128257 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 128257 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 128257 "c/sqlite3.c"
   if ($15) {
    $$1 = 0;
   } else {
    $16 = (FUNCTION_TABLE_ii[$14 & 255]($10)|0); //@line 128258 "c/sqlite3.c"
    _sqlite3VtabImportErrmsg($1,$10); //@line 128259 "c/sqlite3.c"
    $$1 = $16;
   }
  }
  $17 = (($$027) + 1)|0; //@line 128254 "c/sqlite3.c"
  $18 = ($$1|0)==(0); //@line 128254 "c/sqlite3.c"
  if ($18) {
   $$027 = $17;
  } else {
   $$025$lcssa = $$1;
   label = 7;
   break;
  }
 }
 if ((label|0) == 7) {
  HEAP32[$2>>2] = $3; //@line 128262 "c/sqlite3.c"
  return ($$025$lcssa|0); //@line 128263 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeIsInTrans($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 70131 "c/sqlite3.c"
 if ($1) {
  $5 = 0;
  return ($5|0); //@line 70131 "c/sqlite3.c"
 }
 $2 = ((($0)) + 8|0); //@line 70131 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 70131 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(2); //@line 70131 "c/sqlite3.c"
 $phitmp = $4&1;
 $5 = $phitmp;
 return ($5|0); //@line 70131 "c/sqlite3.c"
}
function _sqlite3PagerGetJournalMode($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 5|0); //@line 55303 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 55303 "c/sqlite3.c"
 $3 = $2&255; //@line 55303 "c/sqlite3.c"
 return ($3|0); //@line 55303 "c/sqlite3.c"
}
function _sqlite3PagerExclusiveLock($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 54267 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54267 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 54269 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 212|0); //@line 54275 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 54275 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 54275 "c/sqlite3.c"
  if ($6) {
   $7 = (_pager_wait_on_lock($0,4)|0); //@line 54276 "c/sqlite3.c"
   $$0 = $7;
  } else {
   $$0 = 0;
  }
 } else {
  $$0 = $2;
 }
 return ($$0|0); //@line 54279 "c/sqlite3.c"
}
function _sqlite3BtreeGetFilename($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 70110 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70110 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 70110 "c/sqlite3.c"
 $4 = (_sqlite3PagerFilename($3,1)|0); //@line 70110 "c/sqlite3.c"
 return ($4|0); //@line 70110 "c/sqlite3.c"
}
function _sqlite3BtreeCommitPhaseOne($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 64285 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 64285 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(2); //@line 64285 "c/sqlite3.c"
 if (!($4)) {
  $$1 = 0;
  return ($$1|0); //@line 64304 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 64286 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 64286 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 64287 "c/sqlite3.c"
 $7 = ((($6)) + 17|0); //@line 64289 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 64289 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 64289 "c/sqlite3.c"
 if (!($9)) {
  $10 = (_autoVacuumCommit($6)|0); //@line 64290 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 64291 "c/sqlite3.c"
  if (!($11)) {
   _sqlite3BtreeLeave($0); //@line 64292 "c/sqlite3.c"
   $$1 = $10;
   return ($$1|0); //@line 64304 "c/sqlite3.c"
  }
 }
 $12 = ((($6)) + 19|0); //@line 64296 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 64296 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 64296 "c/sqlite3.c"
 if (!($14)) {
  $15 = HEAP32[$6>>2]|0; //@line 64297 "c/sqlite3.c"
  $16 = ((($6)) + 44|0); //@line 64297 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 64297 "c/sqlite3.c"
  _sqlite3PagerTruncateImage($15,$17); //@line 64297 "c/sqlite3.c"
 }
 $18 = HEAP32[$6>>2]|0; //@line 64300 "c/sqlite3.c"
 $19 = (_sqlite3PagerCommitPhaseOne($18,$1,0)|0); //@line 64300 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 64301 "c/sqlite3.c"
 $$1 = $19;
 return ($$1|0); //@line 64304 "c/sqlite3.c"
}
function _sqlite3BtreeCommitPhaseTwo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 64374 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 64374 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 64374 "c/sqlite3.c"
 if ($4) {
  $$1 = 0;
  return ($$1|0); //@line 64399 "c/sqlite3.c"
 }
 _sqlite3BtreeEnter($0); //@line 64375 "c/sqlite3.c"
 $5 = HEAP8[$2>>0]|0; //@line 64381 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(2); //@line 64381 "c/sqlite3.c"
 do {
  if ($6) {
   $7 = ((($0)) + 4|0); //@line 64383 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 64383 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 64386 "c/sqlite3.c"
   $10 = (_sqlite3PagerCommitPhaseTwo($9)|0); //@line 64386 "c/sqlite3.c"
   $11 = ($10|0)!=(0); //@line 64387 "c/sqlite3.c"
   $12 = ($1|0)==(0); //@line 64387 "c/sqlite3.c"
   $or$cond = $12 & $11; //@line 64387 "c/sqlite3.c"
   if (!($or$cond)) {
    $13 = ((($0)) + 20|0); //@line 64391 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 64391 "c/sqlite3.c"
    $15 = (($14) + -1)|0; //@line 64391 "c/sqlite3.c"
    HEAP32[$13>>2] = $15; //@line 64391 "c/sqlite3.c"
    $16 = ((($8)) + 20|0); //@line 64392 "c/sqlite3.c"
    HEAP8[$16>>0] = 1; //@line 64392 "c/sqlite3.c"
    _btreeClearHasContent($8); //@line 64393 "c/sqlite3.c"
    break;
   }
   _sqlite3BtreeLeave($0); //@line 64388 "c/sqlite3.c"
   $$1 = $10;
   return ($$1|0); //@line 64399 "c/sqlite3.c"
  }
 } while(0);
 _btreeEndTransaction($0); //@line 64396 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 64397 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 64399 "c/sqlite3.c"
}
function _sqlite3VtabCommit($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _callFinaliser($0,64); //@line 128280 "c/sqlite3.c"
 return;
}
function _sqlite3MPrintf($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$2>>2] = $varargs; //@line 26819 "c/sqlite3.c"
 $3 = (_sqlite3VMPrintf($0,$1,$2)|0); //@line 26820 "c/sqlite3.c"
 STACKTOP = sp;return ($3|0); //@line 26822 "c/sqlite3.c"
}
function _sqlite3OsDelete($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 28|0); //@line 21032 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 21032 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iiii[$4 & 127]($0,$1,$2)|0); //@line 21032 "c/sqlite3.c"
 return ($5|0); //@line 21032 "c/sqlite3.c"
}
function _sqlite3OsOpenMalloc($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 4|0); //@line 21103 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 21103 "c/sqlite3.c"
 $7 = ($6|0)<(0); //@line 21103 "c/sqlite3.c"
 $8 = $7 << 31 >> 31; //@line 21103 "c/sqlite3.c"
 $9 = (_sqlite3MallocZero($6,$8)|0); //@line 21103 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 21104 "c/sqlite3.c"
 if ($10) {
  $$0 = 7;
  return ($$0|0); //@line 21114 "c/sqlite3.c"
 }
 $11 = (_sqlite3OsOpen($0,$1,$9,$3,$4)|0); //@line 21105 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 21106 "c/sqlite3.c"
 if ($12) {
  HEAP32[$2>>2] = $9; //@line 21109 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 21114 "c/sqlite3.c"
 } else {
  _sqlite3_free($9); //@line 21107 "c/sqlite3.c"
  $$0 = $11;
  return ($$0|0); //@line 21114 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeGetJournalname($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 70123 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70123 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 70123 "c/sqlite3.c"
 $4 = (_sqlite3PagerJournalname($3)|0); //@line 70123 "c/sqlite3.c"
 return ($4|0); //@line 70123 "c/sqlite3.c"
}
function _sqlite3OsCloseFree($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3OsClose($0); //@line 21118 "c/sqlite3.c"
 _sqlite3_free($0); //@line 21119 "c/sqlite3.c"
 return; //@line 21120 "c/sqlite3.c"
}
function _sqlite3OsSync($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 20911 "c/sqlite3.c"
 if ($2) {
  $7 = 0;
  return ($7|0); //@line 20911 "c/sqlite3.c"
 }
 $3 = HEAP32[$0>>2]|0; //@line 20911 "c/sqlite3.c"
 $4 = ((($3)) + 20|0); //@line 20911 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 20911 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iii[$5 & 255]($0,$1)|0); //@line 20911 "c/sqlite3.c"
 $7 = $6;
 return ($7|0); //@line 20911 "c/sqlite3.c"
}
function _sqlite3PagerJournalname($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 172|0); //@line 54932 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54932 "c/sqlite3.c"
 return ($2|0); //@line 54932 "c/sqlite3.c"
}
function _callFinaliser($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$028 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 348|0); //@line 128222 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 128222 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 128222 "c/sqlite3.c"
 if ($4) {
  return; //@line 128239 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = 0; //@line 128224 "c/sqlite3.c"
 $5 = ((($0)) + 324|0); //@line 128225 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 128225 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 128225 "c/sqlite3.c"
 if ($7) {
  $$028 = 0;
  while(1) {
   $8 = (($3) + ($$028<<2)|0); //@line 128226 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 128226 "c/sqlite3.c"
   $10 = ((($9)) + 8|0); //@line 128227 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 128227 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 128228 "c/sqlite3.c"
   if (!($12)) {
    $13 = HEAP32[$11>>2]|0; //@line 128230 "c/sqlite3.c"
    $14 = (($13) + ($1)|0); //@line 128230 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 128230 "c/sqlite3.c"
    $16 = ($15|0)==(0|0); //@line 128231 "c/sqlite3.c"
    if (!($16)) {
     (FUNCTION_TABLE_ii[$15 & 255]($11)|0); //@line 128231 "c/sqlite3.c"
    }
   }
   $17 = ((($9)) + 20|0); //@line 128233 "c/sqlite3.c"
   HEAP32[$17>>2] = 0; //@line 128233 "c/sqlite3.c"
   _sqlite3VtabUnlock($9); //@line 128234 "c/sqlite3.c"
   $18 = (($$028) + 1)|0; //@line 128225 "c/sqlite3.c"
   $19 = HEAP32[$5>>2]|0; //@line 128225 "c/sqlite3.c"
   $20 = ($18|0)<($19|0); //@line 128225 "c/sqlite3.c"
   if ($20) {
    $$028 = $18;
   } else {
    break;
   }
  }
 }
 _sqlite3DbFree($0,$3); //@line 128236 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 128237 "c/sqlite3.c"
 return; //@line 128239 "c/sqlite3.c"
}
function _sqlite3PagerCommitPhaseTwo($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 54529 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54529 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 54529 "c/sqlite3.c"
 if (!($3)) {
  $$0 = $2;
  return ($$0|0); //@line 54561 "c/sqlite3.c"
 }
 $4 = ((($0)) + 16|0); //@line 54548 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 54548 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(2); //@line 54548 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 4|0); //@line 54549 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 54549 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 54549 "c/sqlite3.c"
  if (!($9)) {
   $10 = ((($0)) + 5|0); //@line 54550 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 54550 "c/sqlite3.c"
   $12 = ($11<<24>>24)==(1); //@line 54550 "c/sqlite3.c"
   if ($12) {
    HEAP8[$4>>0] = 1; //@line 54553 "c/sqlite3.c"
    $$0 = 0;
    return ($$0|0); //@line 54561 "c/sqlite3.c"
   }
  }
 }
 $13 = ((($0)) + 100|0); //@line 54558 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 54558 "c/sqlite3.c"
 $15 = (($14) + 1)|0; //@line 54558 "c/sqlite3.c"
 HEAP32[$13>>2] = $15; //@line 54558 "c/sqlite3.c"
 $16 = ((($0)) + 19|0); //@line 54559 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 54559 "c/sqlite3.c"
 $18 = $17&255; //@line 54559 "c/sqlite3.c"
 $19 = (_pager_end_transaction($0,$18,1)|0); //@line 54559 "c/sqlite3.c"
 $20 = (_pager_error($0,$19)|0); //@line 54560 "c/sqlite3.c"
 $$0 = $20;
 return ($$0|0); //@line 54561 "c/sqlite3.c"
}
function _btreeClearHasContent($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 60|0); //@line 61025 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 61025 "c/sqlite3.c"
 _sqlite3BitvecDestroy($2); //@line 61025 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 61026 "c/sqlite3.c"
 return; //@line 61027 "c/sqlite3.c"
}
function _btreeEndTransaction($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 64311 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 64311 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 64312 "c/sqlite3.c"
 $4 = ((($2)) + 19|0); //@line 64316 "c/sqlite3.c"
 HEAP8[$4>>0] = 0; //@line 64316 "c/sqlite3.c"
 $5 = ((($0)) + 8|0); //@line 64318 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 64318 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 64318 "c/sqlite3.c"
 do {
  if (!($7)) {
   $8 = ((($3)) + 164|0); //@line 64318 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 64318 "c/sqlite3.c"
   $10 = ($9|0)>(1); //@line 64318 "c/sqlite3.c"
   if ($10) {
    _downgradeAllSharedCacheTableLocks($0); //@line 64322 "c/sqlite3.c"
    HEAP8[$5>>0] = 1; //@line 64323 "c/sqlite3.c"
    return; //@line 64344 "c/sqlite3.c"
   } else {
    _clearAllSharedCacheTableLocks($0); //@line 64330 "c/sqlite3.c"
    $11 = ((($2)) + 40|0); //@line 64331 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 64331 "c/sqlite3.c"
    $13 = (($12) + -1)|0; //@line 64331 "c/sqlite3.c"
    HEAP32[$11>>2] = $13; //@line 64331 "c/sqlite3.c"
    $14 = ($13|0)==(0); //@line 64332 "c/sqlite3.c"
    if (!($14)) {
     break;
    }
    $15 = ((($2)) + 20|0); //@line 64333 "c/sqlite3.c"
    HEAP8[$15>>0] = 0; //@line 64333 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 HEAP8[$5>>0] = 0; //@line 64339 "c/sqlite3.c"
 _unlockBtreeIfUnused($2); //@line 64340 "c/sqlite3.c"
 return; //@line 64344 "c/sqlite3.c"
}
function _downgradeAllSharedCacheTableLocks($0) {
 $0 = $0|0;
 var $$0 = 0, $$012 = 0, $$013 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 60859 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60859 "c/sqlite3.c"
 $3 = ((($2)) + 76|0); //@line 60860 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60860 "c/sqlite3.c"
 $5 = ($4|0)==($0|0); //@line 60860 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 60869 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = 0; //@line 60862 "c/sqlite3.c"
 $6 = ((($2)) + 22|0); //@line 60863 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 60863 "c/sqlite3.c"
 $8 = $7 & -193; //@line 60863 "c/sqlite3.c"
 HEAP16[$6>>1] = $8; //@line 60863 "c/sqlite3.c"
 $9 = ((($2)) + 72|0); //@line 60864 "c/sqlite3.c"
 $$012 = HEAP32[$9>>2]|0;
 $10 = ($$012|0)==(0|0); //@line 60864 "c/sqlite3.c"
 if ($10) {
  return; //@line 60869 "c/sqlite3.c"
 }
 $$013 = $$012;
 while(1) {
  $11 = ((($$013)) + 8|0); //@line 60866 "c/sqlite3.c"
  HEAP8[$11>>0] = 1; //@line 60866 "c/sqlite3.c"
  $12 = ((($$013)) + 12|0); //@line 60864 "c/sqlite3.c"
  $$0 = HEAP32[$12>>2]|0;
  $13 = ($$0|0)==(0|0); //@line 60864 "c/sqlite3.c"
  if ($13) {
   break;
  } else {
   $$013 = $$0;
  }
 }
 return; //@line 60869 "c/sqlite3.c"
}
function _clearAllSharedCacheTableLocks($0) {
 $0 = $0|0;
 var $$020 = 0, $$1 = 0, $$1$ph = 0, $$pr = 0, $$sink23 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 60815 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60815 "c/sqlite3.c"
 $3 = ((($2)) + 72|0); //@line 60816 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60822 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 60822 "c/sqlite3.c"
 if (!($5)) {
  $$020 = $3;$7 = $4;
  while(1) {
   $6 = HEAP32[$7>>2]|0; //@line 60826 "c/sqlite3.c"
   $8 = ($6|0)==($0|0); //@line 60826 "c/sqlite3.c"
   $9 = ((($7)) + 12|0);
   if ($8) {
    $10 = HEAP32[$9>>2]|0; //@line 60827 "c/sqlite3.c"
    HEAP32[$$020>>2] = $10; //@line 60827 "c/sqlite3.c"
    $11 = ((($7)) + 4|0); //@line 60829 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 60829 "c/sqlite3.c"
    $13 = ($12|0)==(1); //@line 60829 "c/sqlite3.c"
    $14 = $10;
    if ($13) {
     $$1 = $$020;$16 = $14;
    } else {
     _sqlite3_free($7); //@line 60830 "c/sqlite3.c"
     $$1$ph = $$020;
     label = 6;
    }
   } else {
    $$1$ph = $9;
    label = 6;
   }
   if ((label|0) == 6) {
    label = 0;
    $$pr = HEAP32[$$1$ph>>2]|0; //@line 60822 "c/sqlite3.c"
    $$1 = $$1$ph;$16 = $$pr;
   }
   $15 = ($16|0)==(0|0); //@line 60822 "c/sqlite3.c"
   if ($15) {
    break;
   } else {
    $$020 = $$1;$7 = $16;
   }
  }
 }
 $17 = ((($2)) + 76|0); //@line 60838 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 60838 "c/sqlite3.c"
 $19 = ($18|0)==($0|0); //@line 60838 "c/sqlite3.c"
 if ($19) {
  HEAP32[$17>>2] = 0; //@line 60839 "c/sqlite3.c"
  $$sink23 = -193;
 } else {
  $20 = ((($2)) + 40|0); //@line 60841 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 60841 "c/sqlite3.c"
  $22 = ($21|0)==(2); //@line 60841 "c/sqlite3.c"
  if ($22) {
   $$sink23 = -129;
  } else {
   return; //@line 60853 "c/sqlite3.c"
  }
 }
 $23 = ((($2)) + 22|0);
 $24 = HEAP16[$23>>1]|0;
 $25 = $24 & $$sink23;
 HEAP16[$23>>1] = $25;
 return; //@line 60853 "c/sqlite3.c"
}
function _unlockBtreeIfUnused($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 63592 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 63592 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 63592 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 63599 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0); //@line 63592 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 63592 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 63592 "c/sqlite3.c"
 if ($6) {
  return; //@line 63599 "c/sqlite3.c"
 }
 HEAP32[$4>>2] = 0; //@line 63596 "c/sqlite3.c"
 _releasePageOne($5); //@line 63597 "c/sqlite3.c"
 return; //@line 63599 "c/sqlite3.c"
}
function _releasePageOne($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 72|0); //@line 62570 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62570 "c/sqlite3.c"
 _sqlite3PagerUnrefPageOne($2); //@line 62570 "c/sqlite3.c"
 return; //@line 62571 "c/sqlite3.c"
}
function _sqlite3PagerUnrefPageOne($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 53646 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 53646 "c/sqlite3.c"
 _sqlite3PcacheRelease($0); //@line 53647 "c/sqlite3.c"
 _pagerUnlockIfUnused($2); //@line 53648 "c/sqlite3.c"
 return; //@line 53649 "c/sqlite3.c"
}
function _pagerUnlockIfUnused($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 208|0); //@line 53330 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 53330 "c/sqlite3.c"
 $3 = (_sqlite3PcacheRefCount($2)|0); //@line 53330 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 53330 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 53334 "c/sqlite3.c"
 }
 _pagerUnlockAndRollback($0); //@line 53332 "c/sqlite3.c"
 return; //@line 53334 "c/sqlite3.c"
}
function _pagerUnlockAndRollback($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 50133 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 50133 "c/sqlite3.c"
 switch ($2<<24>>24) {
 case 0: case 6:  {
  break;
 }
 case 1:  {
  $3 = ((($0)) + 4|0); //@line 50139 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 50139 "c/sqlite3.c"
  $5 = ($4<<24>>24)==(0); //@line 50139 "c/sqlite3.c"
  if ($5) {
   (_pager_end_transaction($0,0,0)|0); //@line 50141 "c/sqlite3.c"
  }
  break;
 }
 default: {
  _sqlite3BeginBenignMalloc(); //@line 50136 "c/sqlite3.c"
  (_sqlite3PagerRollback($0)|0); //@line 50137 "c/sqlite3.c"
  _sqlite3EndBenignMalloc(); //@line 50138 "c/sqlite3.c"
 }
 }
 _pager_unlock($0); //@line 50144 "c/sqlite3.c"
 return; //@line 50145 "c/sqlite3.c"
}
function _sqlite3PagerRollback($0) {
 $0 = $0|0;
 var $$1 = 0, $$129 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond31 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 54598 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 54598 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(6); //@line 54598 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 40|0); //@line 54598 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 54598 "c/sqlite3.c"
  $$1 = $5;
  return ($$1|0); //@line 54633 "c/sqlite3.c"
 }
 $6 = ($2&255)<(2); //@line 54599 "c/sqlite3.c"
 if ($6) {
  $$1 = 0;
  return ($$1|0); //@line 54633 "c/sqlite3.c"
 }
 $7 = ((($0)) + 212|0); //@line 54601 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 54601 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 54601 "c/sqlite3.c"
 do {
  if ($9) {
   $16 = ((($0)) + 64|0); //@line 54606 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 54606 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 54606 "c/sqlite3.c"
   $19 = ($18|0)==(0|0); //@line 54606 "c/sqlite3.c"
   $20 = ($2<<24>>24)==(2); //@line 54606 "c/sqlite3.c"
   $or$cond31 = $20 | $19; //@line 54606 "c/sqlite3.c"
   if (!($or$cond31)) {
    $27 = (_pager_playback($0,0)|0); //@line 54620 "c/sqlite3.c"
    $$129 = $27;
    break;
   }
   $21 = (_pager_end_transaction($0,0,0)|0); //@line 54608 "c/sqlite3.c"
   $22 = ((($0)) + 15|0); //@line 54609 "c/sqlite3.c"
   $23 = HEAP8[$22>>0]|0; //@line 54609 "c/sqlite3.c"
   $24 = ($23<<24>>24)==(0); //@line 54609 "c/sqlite3.c"
   $25 = ($2&255)>(2); //@line 54609 "c/sqlite3.c"
   $or$cond = $25 & $24; //@line 54609 "c/sqlite3.c"
   if ($or$cond) {
    $26 = ((($0)) + 40|0); //@line 54614 "c/sqlite3.c"
    HEAP32[$26>>2] = 4; //@line 54614 "c/sqlite3.c"
    HEAP8[$1>>0] = 6; //@line 54615 "c/sqlite3.c"
    _setGetterMethod($0); //@line 54616 "c/sqlite3.c"
    $$1 = $21;
    return ($$1|0); //@line 54633 "c/sqlite3.c"
   } else {
    $$129 = $21;
   }
  } else {
   $10 = (_sqlite3PagerSavepoint($0,2,-1)|0); //@line 54603 "c/sqlite3.c"
   $11 = ((($0)) + 19|0); //@line 54604 "c/sqlite3.c"
   $12 = HEAP8[$11>>0]|0; //@line 54604 "c/sqlite3.c"
   $13 = $12&255; //@line 54604 "c/sqlite3.c"
   $14 = (_pager_end_transaction($0,$13,0)|0); //@line 54604 "c/sqlite3.c"
   $15 = ($10|0)==(0); //@line 54605 "c/sqlite3.c"
   $spec$select = $15 ? $14 : $10; //@line 54605 "c/sqlite3.c"
   $$129 = $spec$select;
  }
 } while(0);
 $28 = (_pager_error($0,$$129)|0); //@line 54632 "c/sqlite3.c"
 $$1 = $28;
 return ($$1|0); //@line 54633 "c/sqlite3.c"
}
function _pager_end_transaction($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$068 = 0, $$1 = 0, $$2 = 0, $$3 = 0, $$4 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond3 = 0, $or$cond70 = 0, $phitmp = 0;
 var $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 50003 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 50003 "c/sqlite3.c"
 $5 = ($4&255)<(2); //@line 50003 "c/sqlite3.c"
 if ($5) {
  $6 = ((($0)) + 17|0); //@line 50003 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 50003 "c/sqlite3.c"
  $8 = ($7&255)<(2); //@line 50003 "c/sqlite3.c"
  if ($8) {
   $$0 = 0;
   return ($$0|0); //@line 50113 "c/sqlite3.c"
  }
 }
 _releaseAllSavepoints($0); //@line 50007 "c/sqlite3.c"
 $9 = ((($0)) + 64|0); //@line 50011 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 50011 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 50011 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 50011 "c/sqlite3.c"
 L5: do {
  if ($12) {
   $$2 = 0;
  } else {
   $13 = (_sqlite3JournalIsInMemory($10)|0); //@line 50015 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 50015 "c/sqlite3.c"
   if (!($14)) {
    _sqlite3OsClose($10); //@line 50017 "c/sqlite3.c"
    $$2 = 0;
    break;
   }
   $15 = ((($0)) + 5|0); //@line 50018 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 50018 "c/sqlite3.c"
   switch ($16<<24>>24) {
   case 3:  {
    $17 = ((($0)) + 72|0); //@line 50019 "c/sqlite3.c"
    $18 = $17; //@line 50019 "c/sqlite3.c"
    $19 = $18; //@line 50019 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 50019 "c/sqlite3.c"
    $21 = (($18) + 4)|0; //@line 50019 "c/sqlite3.c"
    $22 = $21; //@line 50019 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 50019 "c/sqlite3.c"
    $24 = ($20|0)==(0); //@line 50019 "c/sqlite3.c"
    $25 = ($23|0)==(0); //@line 50019 "c/sqlite3.c"
    $26 = $24 & $25; //@line 50019 "c/sqlite3.c"
    if ($26) {
     $$068 = 0;
    } else {
     $27 = (_sqlite3OsTruncate($10,0,0)|0); //@line 50022 "c/sqlite3.c"
     $28 = ($27|0)==(0); //@line 50023 "c/sqlite3.c"
     if ($28) {
      $29 = ((($0)) + 8|0); //@line 50023 "c/sqlite3.c"
      $30 = HEAP8[$29>>0]|0; //@line 50023 "c/sqlite3.c"
      $31 = ($30<<24>>24)==(0); //@line 50023 "c/sqlite3.c"
      if ($31) {
       $$068 = 0;
      } else {
       $32 = HEAP32[$9>>2]|0; //@line 50029 "c/sqlite3.c"
       $33 = ((($0)) + 10|0); //@line 50029 "c/sqlite3.c"
       $34 = HEAP8[$33>>0]|0; //@line 50029 "c/sqlite3.c"
       $35 = $34&255; //@line 50029 "c/sqlite3.c"
       $36 = (_sqlite3OsSync($32,$35)|0); //@line 50029 "c/sqlite3.c"
       $$068 = $36;
      }
     } else {
      $$068 = $27;
     }
    }
    $37 = $17; //@line 50032 "c/sqlite3.c"
    $38 = $37; //@line 50032 "c/sqlite3.c"
    HEAP32[$38>>2] = 0; //@line 50032 "c/sqlite3.c"
    $39 = (($37) + 4)|0; //@line 50032 "c/sqlite3.c"
    $40 = $39; //@line 50032 "c/sqlite3.c"
    HEAP32[$40>>2] = 0; //@line 50032 "c/sqlite3.c"
    $$2 = $$068;
    break L5;
    break;
   }
   case 1:  {
    break;
   }
   default: {
    $41 = ((($0)) + 4|0); //@line 50034 "c/sqlite3.c"
    $42 = HEAP8[$41>>0]|0; //@line 50034 "c/sqlite3.c"
    $43 = ($42<<24>>24)==(0); //@line 50034 "c/sqlite3.c"
    $44 = ($16<<24>>24)==(5); //@line 50034 "c/sqlite3.c"
    $or$cond70 = $44 | $43; //@line 50034 "c/sqlite3.c"
    if ($or$cond70) {
     $56 = ((($0)) + 12|0); //@line 50044 "c/sqlite3.c"
     $57 = HEAP8[$56>>0]|0; //@line 50044 "c/sqlite3.c"
     $58 = ($57<<24>>24)==(0); //@line 50044 "c/sqlite3.c"
     _sqlite3OsClose($10); //@line 50050 "c/sqlite3.c"
     if (!($58)) {
      $$2 = 0;
      break L5;
     }
     $59 = HEAP32[$0>>2]|0; //@line 50052 "c/sqlite3.c"
     $60 = ((($0)) + 172|0); //@line 50052 "c/sqlite3.c"
     $61 = HEAP32[$60>>2]|0; //@line 50052 "c/sqlite3.c"
     $62 = ((($0)) + 9|0); //@line 50052 "c/sqlite3.c"
     $63 = HEAP8[$62>>0]|0; //@line 50052 "c/sqlite3.c"
     $64 = $63&255; //@line 50052 "c/sqlite3.c"
     $65 = (_sqlite3OsDelete($59,$61,$64)|0); //@line 50052 "c/sqlite3.c"
     $$2 = $65;
     break L5;
    }
   }
   }
   $45 = ($1|0)==(0); //@line 50036 "c/sqlite3.c"
   if ($45) {
    $46 = ((($0)) + 12|0); //@line 50036 "c/sqlite3.c"
    $47 = HEAP8[$46>>0]|0; //@line 50036 "c/sqlite3.c"
    $48 = ($47<<24>>24)!=(0); //@line 50036 "c/sqlite3.c"
    $phitmp = $48&1; //@line 50036 "c/sqlite3.c"
    $49 = $phitmp;
   } else {
    $49 = 1;
   }
   $50 = (_zeroJournalHdr($0,$49)|0); //@line 50036 "c/sqlite3.c"
   $51 = ((($0)) + 72|0); //@line 50037 "c/sqlite3.c"
   $52 = $51; //@line 50037 "c/sqlite3.c"
   $53 = $52; //@line 50037 "c/sqlite3.c"
   HEAP32[$53>>2] = 0; //@line 50037 "c/sqlite3.c"
   $54 = (($52) + 4)|0; //@line 50037 "c/sqlite3.c"
   $55 = $54; //@line 50037 "c/sqlite3.c"
   HEAP32[$55>>2] = 0; //@line 50037 "c/sqlite3.c"
   $$2 = $50;
  }
 } while(0);
 $66 = ((($0)) + 56|0); //@line 50068 "c/sqlite3.c"
 $67 = HEAP32[$66>>2]|0; //@line 50068 "c/sqlite3.c"
 _sqlite3BitvecDestroy($67); //@line 50068 "c/sqlite3.c"
 HEAP32[$66>>2] = 0; //@line 50069 "c/sqlite3.c"
 $68 = ((($0)) + 44|0); //@line 50070 "c/sqlite3.c"
 HEAP32[$68>>2] = 0; //@line 50070 "c/sqlite3.c"
 $69 = ($$2|0)==(0); //@line 50071 "c/sqlite3.c"
 if ($69) {
  $70 = ((($0)) + 15|0); //@line 50072 "c/sqlite3.c"
  $71 = HEAP8[$70>>0]|0; //@line 50072 "c/sqlite3.c"
  $72 = ($71<<24>>24)==(0); //@line 50072 "c/sqlite3.c"
  if ($72) {
   $73 = (_pagerFlushOnCommit($0,$2)|0); //@line 50072 "c/sqlite3.c"
   $74 = ($73|0)==(0); //@line 50072 "c/sqlite3.c"
   if ($74) {
    $77 = ((($0)) + 208|0); //@line 50075 "c/sqlite3.c"
    $78 = HEAP32[$77>>2]|0; //@line 50075 "c/sqlite3.c"
    _sqlite3PcacheClearWritable($78); //@line 50075 "c/sqlite3.c"
   } else {
    label = 21;
   }
  } else {
   label = 21;
  }
  if ((label|0) == 21) {
   $75 = ((($0)) + 208|0); //@line 50073 "c/sqlite3.c"
   $76 = HEAP32[$75>>2]|0; //@line 50073 "c/sqlite3.c"
   _sqlite3PcacheCleanAll($76); //@line 50073 "c/sqlite3.c"
  }
  $79 = ((($0)) + 208|0); //@line 50077 "c/sqlite3.c"
  $80 = HEAP32[$79>>2]|0; //@line 50077 "c/sqlite3.c"
  $81 = ((($0)) + 24|0); //@line 50077 "c/sqlite3.c"
  $82 = HEAP32[$81>>2]|0; //@line 50077 "c/sqlite3.c"
  _sqlite3PcacheTruncate($80,$82); //@line 50077 "c/sqlite3.c"
 }
 $83 = ((($0)) + 212|0); //@line 50080 "c/sqlite3.c"
 $84 = HEAP32[$83>>2]|0; //@line 50080 "c/sqlite3.c"
 $85 = ($84|0)==(0|0); //@line 50080 "c/sqlite3.c"
 if ($85) {
  $86 = ($2|0)!=(0); //@line 50087 "c/sqlite3.c"
  $or$cond = $86 & $69; //@line 50087 "c/sqlite3.c"
  if ($or$cond) {
   $87 = ((($0)) + 32|0); //@line 50087 "c/sqlite3.c"
   $88 = HEAP32[$87>>2]|0; //@line 50087 "c/sqlite3.c"
   $89 = ((($0)) + 24|0); //@line 50087 "c/sqlite3.c"
   $90 = HEAP32[$89>>2]|0; //@line 50087 "c/sqlite3.c"
   $91 = ($88>>>0)>($90>>>0); //@line 50087 "c/sqlite3.c"
   if ($91) {
    $92 = (_pager_truncate($0,$90)|0); //@line 50095 "c/sqlite3.c"
    $$3 = $92;
   } else {
    $$3 = 0;
   }
  } else {
   $$3 = $$2;
  }
 } else {
  _sqlite3WalEndWriteTransaction($84); //@line 50085 "c/sqlite3.c"
  $$3 = $$2;
 }
 $93 = ($$3|0)==(0); //@line 50098 "c/sqlite3.c"
 $94 = ($2|0)!=(0); //@line 50098 "c/sqlite3.c"
 $or$cond3 = $94 & $93; //@line 50098 "c/sqlite3.c"
 if ($or$cond3) {
  $95 = ((($0)) + 60|0); //@line 50098 "c/sqlite3.c"
  $96 = HEAP32[$95>>2]|0; //@line 50098 "c/sqlite3.c"
  $97 = HEAP32[$96>>2]|0; //@line 50098 "c/sqlite3.c"
  $98 = ($97|0)==(0|0); //@line 50098 "c/sqlite3.c"
  if ($98) {
   $$4 = 0;
  } else {
   $99 = (_sqlite3OsFileControl($96,22,0)|0); //@line 50099 "c/sqlite3.c"
   $100 = ($99|0)==(12); //@line 50100 "c/sqlite3.c"
   $spec$store$select = $100 ? 0 : $99; //@line 50100 "c/sqlite3.c"
   $$4 = $spec$store$select;
  }
 } else {
  $$4 = $$3;
 }
 $101 = ((($0)) + 4|0); //@line 50103 "c/sqlite3.c"
 $102 = HEAP8[$101>>0]|0; //@line 50103 "c/sqlite3.c"
 $103 = ($102<<24>>24)==(0); //@line 50103 "c/sqlite3.c"
 do {
  if ($103) {
   $104 = HEAP32[$83>>2]|0; //@line 50104 "c/sqlite3.c"
   $105 = ($104|0)==(0|0); //@line 50104 "c/sqlite3.c"
   if (!($105)) {
    $106 = (_sqlite3WalExclusiveMode($104,0)|0); //@line 50104 "c/sqlite3.c"
    $107 = ($106|0)==(0); //@line 50104 "c/sqlite3.c"
    if ($107) {
     $$1 = 0;
     break;
    }
   }
   $108 = (_pagerUnlockDb($0,1)|0); //@line 50106 "c/sqlite3.c"
   $109 = ((($0)) + 18|0); //@line 50107 "c/sqlite3.c"
   HEAP8[$109>>0] = 0; //@line 50107 "c/sqlite3.c"
   $$1 = $108;
  } else {
   $$1 = 0;
  }
 } while(0);
 HEAP8[$3>>0] = 1; //@line 50109 "c/sqlite3.c"
 $110 = ((($0)) + 19|0); //@line 50110 "c/sqlite3.c"
 HEAP8[$110>>0] = 0; //@line 50110 "c/sqlite3.c"
 $111 = ($$4|0)==(0); //@line 50112 "c/sqlite3.c"
 $112 = $111 ? $$1 : $$4; //@line 50112 "c/sqlite3.c"
 $$0 = $112;
 return ($$0|0); //@line 50113 "c/sqlite3.c"
}
function _pager_unlock($0) {
 $0 = $0|0;
 var $$sink = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, $phitmp30 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 56|0); //@line 49799 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49799 "c/sqlite3.c"
 _sqlite3BitvecDestroy($2); //@line 49799 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 49800 "c/sqlite3.c"
 _releaseAllSavepoints($0); //@line 49801 "c/sqlite3.c"
 $3 = ((($0)) + 212|0); //@line 49803 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 49803 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 49803 "c/sqlite3.c"
 if ($5) {
  $6 = ((($0)) + 4|0); //@line 49807 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 49807 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(0); //@line 49807 "c/sqlite3.c"
  if ($8) {
   $9 = ((($0)) + 60|0); //@line 49809 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 49809 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 49809 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 49809 "c/sqlite3.c"
   if ($12) {
    label = 7;
   } else {
    $13 = (_sqlite3OsDeviceCharacteristics($10)|0); //@line 49809 "c/sqlite3.c"
    $phitmp = $13 & 2048; //@line 49809 "c/sqlite3.c"
    $phitmp30 = ($phitmp|0)==(0); //@line 49809 "c/sqlite3.c"
    if ($phitmp30) {
     label = 7;
    } else {
     $14 = ((($0)) + 5|0); //@line 49823 "c/sqlite3.c"
     $15 = HEAP8[$14>>0]|0; //@line 49823 "c/sqlite3.c"
     $16 = $15 & 5; //@line 49823 "c/sqlite3.c"
     $17 = ($16<<24>>24)==(1); //@line 49823 "c/sqlite3.c"
     if (!($17)) {
      label = 7;
     }
    }
   }
   if ((label|0) == 7) {
    $18 = ((($0)) + 64|0); //@line 49825 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 49825 "c/sqlite3.c"
    _sqlite3OsClose($19); //@line 49825 "c/sqlite3.c"
   }
   $20 = (_pagerUnlockDb($0,0)|0); //@line 49833 "c/sqlite3.c"
   $21 = ($20|0)==(0); //@line 49834 "c/sqlite3.c"
   if (!($21)) {
    $22 = ((($0)) + 16|0); //@line 49834 "c/sqlite3.c"
    $23 = HEAP8[$22>>0]|0; //@line 49834 "c/sqlite3.c"
    $24 = ($23<<24>>24)==(6); //@line 49834 "c/sqlite3.c"
    if ($24) {
     $25 = ((($0)) + 17|0); //@line 49835 "c/sqlite3.c"
     HEAP8[$25>>0] = 5; //@line 49835 "c/sqlite3.c"
    }
   }
   $26 = ((($0)) + 18|0); //@line 49843 "c/sqlite3.c"
   HEAP8[$26>>0] = 0; //@line 49843 "c/sqlite3.c"
   label = 12;
  }
 } else {
  _sqlite3WalEndReadTransaction($4); //@line 49805 "c/sqlite3.c"
  label = 12;
 }
 if ((label|0) == 12) {
  $27 = ((($0)) + 16|0);
  HEAP8[$27>>0] = 0;
 }
 $28 = ((($0)) + 40|0); //@line 49853 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 49853 "c/sqlite3.c"
 $30 = ($29|0)==(0); //@line 49853 "c/sqlite3.c"
 if ($30) {
  $41 = ((($0)) + 72|0); //@line 49866 "c/sqlite3.c"
  $42 = ((($0)) + 19|0); //@line 49868 "c/sqlite3.c"
  HEAP8[$42>>0] = 0; //@line 49868 "c/sqlite3.c"
  ;HEAP32[$41>>2]=0|0;HEAP32[$41+4>>2]=0|0;HEAP32[$41+8>>2]=0|0;HEAP32[$41+12>>2]=0|0; //@line 49867 "c/sqlite3.c"
  return; //@line 49869 "c/sqlite3.c"
 }
 $31 = ((($0)) + 12|0); //@line 49854 "c/sqlite3.c"
 $32 = HEAP8[$31>>0]|0; //@line 49854 "c/sqlite3.c"
 $33 = ($32<<24>>24)==(0); //@line 49854 "c/sqlite3.c"
 if ($33) {
  _pager_reset($0); //@line 49855 "c/sqlite3.c"
  $34 = ((($0)) + 18|0); //@line 49856 "c/sqlite3.c"
  HEAP8[$34>>0] = 0; //@line 49856 "c/sqlite3.c"
  $$sink = 0;
 } else {
  $35 = ((($0)) + 64|0); //@line 49859 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 49859 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 49859 "c/sqlite3.c"
  $38 = ($37|0)==(0|0); //@line 49859 "c/sqlite3.c"
  $39 = $38&1; //@line 49859 "c/sqlite3.c"
  $$sink = $39;
 }
 $40 = ((($0)) + 16|0);
 HEAP8[$40>>0] = $$sink;
 HEAP32[$28>>2] = 0; //@line 49862 "c/sqlite3.c"
 _setGetterMethod($0); //@line 49863 "c/sqlite3.c"
 $41 = ((($0)) + 72|0); //@line 49866 "c/sqlite3.c"
 $42 = ((($0)) + 19|0); //@line 49868 "c/sqlite3.c"
 HEAP8[$42>>0] = 0; //@line 49868 "c/sqlite3.c"
 ;HEAP32[$41>>2]=0|0;HEAP32[$41+4>>2]=0|0;HEAP32[$41+8>>2]=0|0;HEAP32[$41+12>>2]=0|0; //@line 49867 "c/sqlite3.c"
 return; //@line 49869 "c/sqlite3.c"
}
function _releaseAllSavepoints($0) {
 $0 = $0|0;
 var $$011 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 96|0); //@line 49743 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49743 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 49743 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 92|0);
  $$011 = 0;
  while(1) {
   $5 = HEAP32[$4>>2]|0; //@line 49744 "c/sqlite3.c"
   $6 = (((($5) + (($$011*48)|0)|0)) + 16|0); //@line 49744 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 49744 "c/sqlite3.c"
   _sqlite3BitvecDestroy($7); //@line 49744 "c/sqlite3.c"
   $8 = (($$011) + 1)|0; //@line 49743 "c/sqlite3.c"
   $9 = HEAP32[$1>>2]|0; //@line 49743 "c/sqlite3.c"
   $10 = ($8|0)<($9|0); //@line 49743 "c/sqlite3.c"
   if ($10) {
    $$011 = $8;
   } else {
    break;
   }
  }
 }
 $11 = ((($0)) + 4|0); //@line 49746 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 49746 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 49746 "c/sqlite3.c"
 if ($13) {
  label = 6;
 } else {
  $14 = ((($0)) + 68|0); //@line 49746 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 49746 "c/sqlite3.c"
  $16 = (_sqlite3JournalIsInMemory($15)|0); //@line 49746 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 49746 "c/sqlite3.c"
  if (!($17)) {
   label = 6;
  }
 }
 if ((label|0) == 6) {
  $18 = ((($0)) + 68|0); //@line 49747 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 49747 "c/sqlite3.c"
  _sqlite3OsClose($19); //@line 49747 "c/sqlite3.c"
 }
 $20 = ((($0)) + 92|0); //@line 49749 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 49749 "c/sqlite3.c"
 _sqlite3_free($21); //@line 49749 "c/sqlite3.c"
 HEAP32[$20>>2] = 0; //@line 49750 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 49751 "c/sqlite3.c"
 $22 = ((($0)) + 52|0); //@line 49752 "c/sqlite3.c"
 HEAP32[$22>>2] = 0; //@line 49752 "c/sqlite3.c"
 return; //@line 49753 "c/sqlite3.c"
}
function _sqlite3WalEndReadTransaction($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3WalEndWriteTransaction($0); //@line 58407 "c/sqlite3.c"
 $1 = ((($0)) + 40|0); //@line 58408 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 58408 "c/sqlite3.c"
 $3 = ($2<<16>>16)>(-1); //@line 58408 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 58412 "c/sqlite3.c"
 }
 $4 = $2 << 16 >> 16; //@line 58408 "c/sqlite3.c"
 $5 = (($4) + 3)|0; //@line 58409 "c/sqlite3.c"
 _walUnlockShared($0,$5); //@line 58409 "c/sqlite3.c"
 HEAP16[$1>>1] = -1; //@line 58410 "c/sqlite3.c"
 return; //@line 58412 "c/sqlite3.c"
}
function _pagerUnlockDb($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 60|0); //@line 49114 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 49114 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 49114 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 49114 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 49122 "c/sqlite3.c"
 }
 $6 = ((($0)) + 13|0); //@line 49116 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 49116 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 49116 "c/sqlite3.c"
 if ($8) {
  $9 = (_sqlite3OsUnlock($3,$1)|0); //@line 49116 "c/sqlite3.c"
  $14 = $9;
 } else {
  $14 = 0;
 }
 $10 = ((($0)) + 17|0); //@line 49117 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 49117 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(5); //@line 49117 "c/sqlite3.c"
 if ($12) {
  $$0 = $14;
  return ($$0|0); //@line 49122 "c/sqlite3.c"
 }
 $13 = $1&255; //@line 49118 "c/sqlite3.c"
 HEAP8[$10>>0] = $13; //@line 49118 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 49122 "c/sqlite3.c"
}
function _setGetterMethod($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $getPageNormal$getPageError = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 49020 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49020 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 49020 "c/sqlite3.c"
 $4 = ((($0)) + 200|0);
 $getPageNormal$getPageError = $3 ? 89 : 88;
 HEAP32[$4>>2] = $getPageNormal$getPageError;
 return; //@line 49033 "c/sqlite3.c"
}
function _getPageNormal($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$04648 = 0, $$04652 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0;
 var $or$cond47 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ($1|0)==(0); //@line 53409 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3CorruptError(53409)|0); //@line 53409 "c/sqlite3.c"
  $$0 = $6;
  STACKTOP = sp;return ($$0|0); //@line 53491 "c/sqlite3.c"
 }
 $7 = ((($0)) + 208|0); //@line 53410 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 53410 "c/sqlite3.c"
 $9 = (_sqlite3PcacheFetch($8,$1,3)|0); //@line 53410 "c/sqlite3.c"
 HEAP32[$4>>2] = $9; //@line 53410 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 53411 "c/sqlite3.c"
 if ($10) {
  $11 = HEAP32[$7>>2]|0; //@line 53413 "c/sqlite3.c"
  $12 = (_sqlite3PcacheFetchStress($11,$1,$4)|0); //@line 53413 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 53414 "c/sqlite3.c"
  if ($13) {
   $14 = HEAP32[$4>>2]|0; //@line 53415 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 53415 "c/sqlite3.c"
   if ($15) {
    $$04648 = 7;
   } else {
    label = 6;
   }
  } else {
   $$04648 = $12;
  }
 } else {
  label = 6;
 }
 do {
  if ((label|0) == 6) {
   $16 = HEAP32[$7>>2]|0; //@line 53420 "c/sqlite3.c"
   $17 = HEAP32[$4>>2]|0; //@line 53420 "c/sqlite3.c"
   $18 = (_sqlite3PcacheFetchFinish($16,$1,$17)|0); //@line 53420 "c/sqlite3.c"
   HEAP32[$2>>2] = $18; //@line 53420 "c/sqlite3.c"
   $19 = $3 & 1; //@line 53425 "c/sqlite3.c"
   $20 = ((($18)) + 20|0); //@line 53426 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 53426 "c/sqlite3.c"
   $22 = ($21|0)==(0|0); //@line 53426 "c/sqlite3.c"
   $23 = ($19|0)!=(0); //@line 53426 "c/sqlite3.c"
   $or$cond = $23 | $22; //@line 53426 "c/sqlite3.c"
   if (!($or$cond)) {
    $24 = ((($0)) + 184|0); //@line 53430 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 53430 "c/sqlite3.c"
    $26 = (($25) + 1)|0; //@line 53430 "c/sqlite3.c"
    HEAP32[$24>>2] = $26; //@line 53430 "c/sqlite3.c"
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 53491 "c/sqlite3.c"
   }
   $27 = ($1|0)<(0); //@line 53440 "c/sqlite3.c"
   do {
    if ($27) {
     label = 19;
    } else {
     $28 = HEAP32[513]|0; //@line 53440 "c/sqlite3.c"
     $29 = ((($0)) + 152|0); //@line 53440 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 53440 "c/sqlite3.c"
     $31 = (($28|0) / ($30|0))&-1; //@line 53440 "c/sqlite3.c"
     $32 = (($31) + 1)|0; //@line 53440 "c/sqlite3.c"
     $33 = ($32|0)==($1|0); //@line 53440 "c/sqlite3.c"
     if ($33) {
      label = 19;
     } else {
      HEAP32[$20>>2] = $0; //@line 53445 "c/sqlite3.c"
      $34 = ((($0)) + 60|0); //@line 53448 "c/sqlite3.c"
      $35 = HEAP32[$34>>2]|0; //@line 53448 "c/sqlite3.c"
      $36 = HEAP32[$35>>2]|0; //@line 53448 "c/sqlite3.c"
      $37 = ($36|0)==(0|0); //@line 53448 "c/sqlite3.c"
      if (!($37)) {
       $38 = ((($0)) + 24|0); //@line 53448 "c/sqlite3.c"
       $39 = HEAP32[$38>>2]|0; //@line 53448 "c/sqlite3.c"
       $40 = ($39>>>0)>=($1>>>0); //@line 53448 "c/sqlite3.c"
       $41 = ($19|0)==(0); //@line 53448 "c/sqlite3.c"
       $or$cond47 = $41 & $40; //@line 53448 "c/sqlite3.c"
       if ($or$cond47) {
        $53 = ((($0)) + 188|0); //@line 53473 "c/sqlite3.c"
        $54 = HEAP32[$53>>2]|0; //@line 53473 "c/sqlite3.c"
        $55 = (($54) + 1)|0; //@line 53473 "c/sqlite3.c"
        HEAP32[$53>>2] = $55; //@line 53473 "c/sqlite3.c"
        $56 = (_readDbPage($18)|0); //@line 53474 "c/sqlite3.c"
        $57 = ($56|0)==(0); //@line 53475 "c/sqlite3.c"
        if ($57) {
         $$0 = 0;
        } else {
         $$04652 = $56;
         break;
        }
        STACKTOP = sp;return ($$0|0); //@line 53491 "c/sqlite3.c"
       }
      }
      $42 = ((($0)) + 156|0); //@line 53449 "c/sqlite3.c"
      $43 = HEAP32[$42>>2]|0; //@line 53449 "c/sqlite3.c"
      $44 = ($43>>>0)<($1>>>0); //@line 53449 "c/sqlite3.c"
      if ($44) {
       $$04652 = 13;
      } else {
       if ($23) {
        _sqlite3BeginBenignMalloc(); //@line 53460 "c/sqlite3.c"
        $45 = ((($0)) + 28|0); //@line 53461 "c/sqlite3.c"
        $46 = HEAP32[$45>>2]|0; //@line 53461 "c/sqlite3.c"
        $47 = ($46>>>0)<($1>>>0); //@line 53461 "c/sqlite3.c"
        if (!($47)) {
         $48 = ((($0)) + 56|0); //@line 53462 "c/sqlite3.c"
         $49 = HEAP32[$48>>2]|0; //@line 53462 "c/sqlite3.c"
         (_sqlite3BitvecSet($49,$1)|0); //@line 53462 "c/sqlite3.c"
        }
        (_addToSavepointBitvecs($0,$1)|0); //@line 53465 "c/sqlite3.c"
        _sqlite3EndBenignMalloc(); //@line 53467 "c/sqlite3.c"
       }
       $50 = ((($18)) + 4|0); //@line 53469 "c/sqlite3.c"
       $51 = HEAP32[$50>>2]|0; //@line 53469 "c/sqlite3.c"
       $52 = HEAP32[$29>>2]|0; //@line 53469 "c/sqlite3.c"
       _memset(($51|0),0,($52|0))|0; //@line 53469 "c/sqlite3.c"
       $$0 = 0;
       STACKTOP = sp;return ($$0|0); //@line 53491 "c/sqlite3.c"
      }
     }
    }
   } while(0);
   if ((label|0) == 19) {
    $58 = (_sqlite3CorruptError(53441)|0); //@line 53441 "c/sqlite3.c"
    $59 = ($18|0)==(0|0); //@line 53485 "c/sqlite3.c"
    if ($59) {
     $$04648 = $58;
     break;
    } else {
     $$04652 = $58;
    }
   }
   _sqlite3PcacheDrop($18); //@line 53486 "c/sqlite3.c"
   $$04648 = $$04652;
  }
 } while(0);
 _pagerUnlockIfUnused($0); //@line 53488 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 53489 "c/sqlite3.c"
 $$0 = $$04648;
 STACKTOP = sp;return ($$0|0); //@line 53491 "c/sqlite3.c"
}
function _getPageError($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$2>>2] = 0; //@line 53576 "c/sqlite3.c"
 $4 = ((($0)) + 40|0); //@line 53577 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 53577 "c/sqlite3.c"
 return ($5|0); //@line 53577 "c/sqlite3.c"
}
function _sqlite3PcacheFetchStress($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$034 = 0, $$03443 = 0, $$03444 = 0, $$1 = 0, $$135 = 0, $$13541 = 0, $$13542 = 0, $$2$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 33|0); //@line 45586 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 45586 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(2); //@line 45586 "c/sqlite3.c"
 if ($5) {
  $$1 = 0;
  return ($$1|0); //@line 45625 "c/sqlite3.c"
 }
 $6 = (_sqlite3PcachePagecount($0)|0); //@line 45588 "c/sqlite3.c"
 $7 = ((($0)) + 20|0); //@line 45588 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 45588 "c/sqlite3.c"
 $9 = ($6|0)>($8|0); //@line 45588 "c/sqlite3.c"
 L4: do {
  if ($9) {
   $10 = ((($0)) + 8|0); //@line 45598 "c/sqlite3.c"
   $$03443 = HEAP32[$10>>2]|0;
   $11 = ($$03443|0)==(0|0); //@line 45599 "c/sqlite3.c"
   L6: do {
    if ($11) {
     label = 9;
    } else {
     $$03444 = $$03443;
     while(1) {
      $12 = ((($$03444)) + 30|0); //@line 45599 "c/sqlite3.c"
      $13 = HEAP16[$12>>1]|0; //@line 45599 "c/sqlite3.c"
      $14 = ($13<<16>>16)==(0); //@line 45599 "c/sqlite3.c"
      if ($14) {
       $15 = ((($$03444)) + 28|0); //@line 45599 "c/sqlite3.c"
       $16 = HEAP16[$15>>1]|0; //@line 45599 "c/sqlite3.c"
       $17 = $16 & 8; //@line 45599 "c/sqlite3.c"
       $18 = ($17<<16>>16)==(0); //@line 45599 "c/sqlite3.c"
       if ($18) {
        break;
       }
      }
      $19 = ((($$03444)) + 36|0); //@line 45600 "c/sqlite3.c"
      $$034 = HEAP32[$19>>2]|0;
      $20 = ($$034|0)==(0|0); //@line 45599 "c/sqlite3.c"
      if ($20) {
       label = 9;
       break L6;
      } else {
       $$03444 = $$034;
      }
     }
     HEAP32[$10>>2] = $$03444; //@line 45602 "c/sqlite3.c"
     $$2$ph = $$03444;
    }
   } while(0);
   L14: do {
    if ((label|0) == 9) {
     HEAP32[$10>>2] = 0; //@line 45602 "c/sqlite3.c"
     $21 = ((($0)) + 4|0); //@line 45604 "c/sqlite3.c"
     $$13541 = HEAP32[$21>>2]|0;
     $22 = ($$13541|0)==(0|0); //@line 45604 "c/sqlite3.c"
     if ($22) {
      break L4;
     }
     $$13542 = $$13541;
     while(1) {
      $23 = ((($$13542)) + 30|0); //@line 45604 "c/sqlite3.c"
      $24 = HEAP16[$23>>1]|0; //@line 45604 "c/sqlite3.c"
      $25 = ($24<<16>>16)==(0); //@line 45604 "c/sqlite3.c"
      if ($25) {
       $$2$ph = $$13542;
       break L14;
      }
      $26 = ((($$13542)) + 36|0); //@line 45604 "c/sqlite3.c"
      $$135 = HEAP32[$26>>2]|0;
      $27 = ($$135|0)==(0|0); //@line 45604 "c/sqlite3.c"
      if ($27) {
       break L4;
      } else {
       $$13542 = $$135;
      }
     }
    }
   } while(0);
   $28 = ((($0)) + 36|0); //@line 45616 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 45616 "c/sqlite3.c"
   $30 = ((($0)) + 40|0); //@line 45616 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 45616 "c/sqlite3.c"
   $32 = (FUNCTION_TABLE_iii[$29 & 255]($31,$$2$ph)|0); //@line 45616 "c/sqlite3.c"
   switch ($32|0) {
   case 0: case 5:  {
    break L4;
    break;
   }
   default: {
    $$1 = $32;
   }
   }
   return ($$1|0); //@line 45625 "c/sqlite3.c"
  }
 } while(0);
 $33 = HEAP32[(148)>>2]|0; //@line 45623 "c/sqlite3.c"
 $34 = ((($0)) + 44|0); //@line 45623 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 45623 "c/sqlite3.c"
 $36 = (FUNCTION_TABLE_iiii[$33 & 127]($35,$1,2)|0); //@line 45623 "c/sqlite3.c"
 HEAP32[$2>>2] = $36; //@line 45623 "c/sqlite3.c"
 $37 = ($36|0)==(0|0); //@line 45624 "c/sqlite3.c"
 $38 = $37 ? 7 : 0; //@line 45624 "c/sqlite3.c"
 $$1 = $38;
 return ($$1|0); //@line 45625 "c/sqlite3.c"
}
function _sqlite3PcachePagecount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(144)>>2]|0; //@line 45970 "c/sqlite3.c"
 $2 = ((($0)) + 44|0); //@line 45970 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45970 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_ii[$1 & 255]($3)|0); //@line 45970 "c/sqlite3.c"
 return ($4|0); //@line 45970 "c/sqlite3.c"
}
function _sqlite3OsUnlock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 20922 "c/sqlite3.c"
 $3 = ((($2)) + 32|0); //@line 20922 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 20922 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iii[$4 & 255]($0,$1)|0); //@line 20922 "c/sqlite3.c"
 return ($5|0); //@line 20922 "c/sqlite3.c"
}
function _sqlite3WalEndWriteTransaction($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 44|0); //@line 58604 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 58604 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 58604 "c/sqlite3.c"
 if ($3) {
  return;
 }
 _walUnlockExclusive($0,0,1); //@line 58605 "c/sqlite3.c"
 HEAP8[$1>>0] = 0; //@line 58606 "c/sqlite3.c"
 $4 = ((($0)) + 104|0); //@line 58607 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 58607 "c/sqlite3.c"
 $5 = ((($0)) + 47|0); //@line 58608 "c/sqlite3.c"
 HEAP8[$5>>0] = 0; //@line 58608 "c/sqlite3.c"
 return;
}
function _walUnlockShared($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 43|0); //@line 56434 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 56434 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 56434 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 56438 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 56435 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 56435 "c/sqlite3.c"
 (_sqlite3OsShmLock($6,$1,1,5)|0); //@line 56435 "c/sqlite3.c"
 return; //@line 56438 "c/sqlite3.c"
}
function _sqlite3OsShmLock($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 20968 "c/sqlite3.c"
 $5 = ((($4)) + 56|0); //@line 20968 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 20968 "c/sqlite3.c"
 $7 = (FUNCTION_TABLE_iiiii[$6 & 127]($0,$1,$2,$3)|0); //@line 20968 "c/sqlite3.c"
 return ($7|0); //@line 20968 "c/sqlite3.c"
}
function _walUnlockExclusive($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 43|0); //@line 56450 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 56450 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 56450 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 56455 "c/sqlite3.c"
 }
 $6 = ((($0)) + 4|0); //@line 56451 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 56451 "c/sqlite3.c"
 (_sqlite3OsShmLock($7,$1,$2,9)|0); //@line 56451 "c/sqlite3.c"
 return; //@line 56455 "c/sqlite3.c"
}
function _zeroJournalHdr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$1 = 0, $$2 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, $or$cond23 = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 72|0); //@line 49365 "c/sqlite3.c"
 $4 = $3; //@line 49365 "c/sqlite3.c"
 $5 = $4; //@line 49365 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 49365 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 49365 "c/sqlite3.c"
 $8 = $7; //@line 49365 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 49365 "c/sqlite3.c"
 $10 = ($6|0)==(0); //@line 49365 "c/sqlite3.c"
 $11 = ($9|0)==(0); //@line 49365 "c/sqlite3.c"
 $12 = $10 & $11; //@line 49365 "c/sqlite3.c"
 if ($12) {
  $$4 = 0;
  STACKTOP = sp;return ($$4|0); //@line 49393 "c/sqlite3.c"
 }
 $13 = ((($0)) + 160|0); //@line 49366 "c/sqlite3.c"
 $14 = $13; //@line 49366 "c/sqlite3.c"
 $15 = $14; //@line 49366 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 49366 "c/sqlite3.c"
 $17 = (($14) + 4)|0; //@line 49366 "c/sqlite3.c"
 $18 = $17; //@line 49366 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 49366 "c/sqlite3.c"
 $20 = ($1|0)!=(0); //@line 49369 "c/sqlite3.c"
 $21 = ($16|0)==(0); //@line 49369 "c/sqlite3.c"
 $22 = ($19|0)==(0); //@line 49369 "c/sqlite3.c"
 $23 = $21 & $22; //@line 49369 "c/sqlite3.c"
 $or$cond = $20 | $23; //@line 49369 "c/sqlite3.c"
 $24 = ((($0)) + 64|0);
 $25 = HEAP32[$24>>2]|0;
 if ($or$cond) {
  $26 = (_sqlite3OsTruncate($25,0,0)|0); //@line 49370 "c/sqlite3.c"
  $$0 = $26;
 } else {
  $27 = (_sqlite3OsWrite($25,41648,28,0,0)|0); //@line 49373 "c/sqlite3.c"
  $$0 = $27;
 }
 $28 = ($$0|0)==(0); //@line 49375 "c/sqlite3.c"
 if (!($28)) {
  $$4 = $$0;
  STACKTOP = sp;return ($$4|0); //@line 49393 "c/sqlite3.c"
 }
 $29 = ((($0)) + 7|0); //@line 49375 "c/sqlite3.c"
 $30 = HEAP8[$29>>0]|0; //@line 49375 "c/sqlite3.c"
 $31 = ($30<<24>>24)==(0); //@line 49375 "c/sqlite3.c"
 if ($31) {
  $32 = HEAP32[$24>>2]|0; //@line 49376 "c/sqlite3.c"
  $33 = ((($0)) + 10|0); //@line 49376 "c/sqlite3.c"
  $34 = HEAP8[$33>>0]|0; //@line 49376 "c/sqlite3.c"
  $35 = $34 | 16; //@line 49376 "c/sqlite3.c"
  $36 = $35&255; //@line 49376 "c/sqlite3.c"
  $37 = (_sqlite3OsSync($32,$36)|0); //@line 49376 "c/sqlite3.c"
  $$1 = $37;
 } else {
  $$1 = 0;
 }
 $38 = ($$1|0)==(0); //@line 49385 "c/sqlite3.c"
 $39 = ($19|0)>(0); //@line 49385 "c/sqlite3.c"
 $40 = ($16>>>0)>(0); //@line 49385 "c/sqlite3.c"
 $41 = ($19|0)==(0); //@line 49385 "c/sqlite3.c"
 $42 = $41 & $40; //@line 49385 "c/sqlite3.c"
 $43 = $39 | $42; //@line 49385 "c/sqlite3.c"
 $or$cond3 = $43 & $38; //@line 49385 "c/sqlite3.c"
 if (!($or$cond3)) {
  $$4 = $$1;
  STACKTOP = sp;return ($$4|0); //@line 49393 "c/sqlite3.c"
 }
 $44 = HEAP32[$24>>2]|0; //@line 49387 "c/sqlite3.c"
 $45 = (_sqlite3OsFileSize($44,$2)|0); //@line 49387 "c/sqlite3.c"
 $46 = ($45|0)==(0); //@line 49388 "c/sqlite3.c"
 $47 = $2; //@line 49388 "c/sqlite3.c"
 $48 = $47; //@line 49388 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 49388 "c/sqlite3.c"
 $50 = (($47) + 4)|0; //@line 49388 "c/sqlite3.c"
 $51 = $50; //@line 49388 "c/sqlite3.c"
 $52 = HEAP32[$51>>2]|0; //@line 49388 "c/sqlite3.c"
 $53 = ($52|0)>($19|0); //@line 49388 "c/sqlite3.c"
 $54 = ($49>>>0)>($16>>>0); //@line 49388 "c/sqlite3.c"
 $55 = ($52|0)==($19|0); //@line 49388 "c/sqlite3.c"
 $56 = $55 & $54; //@line 49388 "c/sqlite3.c"
 $57 = $53 | $56; //@line 49388 "c/sqlite3.c"
 $or$cond23 = $46 & $57; //@line 49388 "c/sqlite3.c"
 if ($or$cond23) {
  $58 = HEAP32[$24>>2]|0; //@line 49389 "c/sqlite3.c"
  $59 = (_sqlite3OsTruncate($58,$16,$19)|0); //@line 49389 "c/sqlite3.c"
  $$2 = $59;
 } else {
  $$2 = $45;
 }
 $$4 = $$2;
 STACKTOP = sp;return ($$4|0); //@line 49393 "c/sqlite3.c"
}
function _pagerFlushOnCommit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 49925 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 49925 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 49925 "c/sqlite3.c"
 if ($4) {
  $$0 = 1;
  return ($$0|0); //@line 49929 "c/sqlite3.c"
 }
 $5 = ($1|0)==(0); //@line 49926 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 49929 "c/sqlite3.c"
 }
 $6 = ((($0)) + 60|0); //@line 49927 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 49927 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 49927 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 49927 "c/sqlite3.c"
 if ($9) {
  $$0 = 0;
  return ($$0|0); //@line 49929 "c/sqlite3.c"
 }
 $10 = ((($0)) + 208|0); //@line 49928 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 49928 "c/sqlite3.c"
 $12 = (_sqlite3PCachePercentDirty($11)|0); //@line 49928 "c/sqlite3.c"
 $13 = ($12|0)>(24); //@line 49928 "c/sqlite3.c"
 $14 = $13&1; //@line 49928 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 49929 "c/sqlite3.c"
}
function _sqlite3PcacheCleanAll($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 45765 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 45765 "c/sqlite3.c"
 if ($2) {
  return; //@line 45768 "c/sqlite3.c"
 }
 $3 = $1;
 while(1) {
  _sqlite3PcacheMakeClean($3); //@line 45766 "c/sqlite3.c"
  $4 = HEAP32[$0>>2]|0; //@line 45765 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 45765 "c/sqlite3.c"
  if ($5) {
   break;
  } else {
   $3 = $4;
  }
 }
 return; //@line 45768 "c/sqlite3.c"
}
function _sqlite3PcacheClearWritable($0) {
 $0 = $0|0;
 var $$0 = 0, $$07 = 0, $$08 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$07 = HEAP32[$0>>2]|0;
 $1 = ($$07|0)==(0|0); //@line 45776 "c/sqlite3.c"
 if (!($1)) {
  $$08 = $$07;
  while(1) {
   $2 = ((($$08)) + 28|0); //@line 45777 "c/sqlite3.c"
   $3 = HEAP16[$2>>1]|0; //@line 45777 "c/sqlite3.c"
   $4 = $3 & -13; //@line 45777 "c/sqlite3.c"
   HEAP16[$2>>1] = $4; //@line 45777 "c/sqlite3.c"
   $5 = ((($$08)) + 32|0); //@line 45776 "c/sqlite3.c"
   $$0 = HEAP32[$5>>2]|0;
   $6 = ($$0|0)==(0|0); //@line 45776 "c/sqlite3.c"
   if ($6) {
    break;
   } else {
    $$08 = $$0;
   }
  }
 }
 $7 = ((($0)) + 4|0); //@line 45779 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 45779 "c/sqlite3.c"
 $9 = ((($0)) + 8|0); //@line 45779 "c/sqlite3.c"
 HEAP32[$9>>2] = $8; //@line 45779 "c/sqlite3.c"
 return; //@line 45780 "c/sqlite3.c"
}
function _pager_truncate($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 60|0); //@line 50629 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 50629 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 50629 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 50629 "c/sqlite3.c"
 if ($6) {
  $$2 = 0;
  STACKTOP = sp;return ($$2|0); //@line 50653 "c/sqlite3.c"
 }
 $7 = ((($0)) + 16|0); //@line 50630 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 50630 "c/sqlite3.c"
 $9 = (($8) + -1)<<24>>24; //@line 50630 "c/sqlite3.c"
 $10 = ($9&255)>(2); //@line 50630 "c/sqlite3.c"
 if (!($10)) {
  $$2 = 0;
  STACKTOP = sp;return ($$2|0); //@line 50653 "c/sqlite3.c"
 }
 $11 = ((($0)) + 152|0); //@line 50633 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 50633 "c/sqlite3.c"
 $13 = (_sqlite3OsFileSize($4,$2)|0); //@line 50636 "c/sqlite3.c"
 $14 = ($12|0)<(0); //@line 50637 "c/sqlite3.c"
 $15 = $14 << 31 >> 31; //@line 50637 "c/sqlite3.c"
 $16 = (___muldi3(($12|0),($15|0),($1|0),0)|0); //@line 50637 "c/sqlite3.c"
 $17 = tempRet0; //@line 50637 "c/sqlite3.c"
 $18 = ($13|0)==(0); //@line 50638 "c/sqlite3.c"
 do {
  if ($18) {
   $19 = $2; //@line 50638 "c/sqlite3.c"
   $20 = $19; //@line 50638 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 50638 "c/sqlite3.c"
   $22 = (($19) + 4)|0; //@line 50638 "c/sqlite3.c"
   $23 = $22; //@line 50638 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 50638 "c/sqlite3.c"
   $25 = ($21|0)==($16|0); //@line 50638 "c/sqlite3.c"
   $26 = ($24|0)==($17|0); //@line 50638 "c/sqlite3.c"
   $27 = $25 & $26; //@line 50638 "c/sqlite3.c"
   if ($27) {
    $$1 = 0;
   } else {
    $28 = ($24|0)>($17|0); //@line 50639 "c/sqlite3.c"
    $29 = ($21>>>0)>($16>>>0); //@line 50639 "c/sqlite3.c"
    $30 = ($24|0)==($17|0); //@line 50639 "c/sqlite3.c"
    $31 = $30 & $29; //@line 50639 "c/sqlite3.c"
    $32 = $28 | $31; //@line 50639 "c/sqlite3.c"
    if ($32) {
     $33 = HEAP32[$3>>2]|0; //@line 50640 "c/sqlite3.c"
     $34 = (_sqlite3OsTruncate($33,$16,$17)|0); //@line 50640 "c/sqlite3.c"
     $$0 = $34;
     label = 9;
    } else {
     $35 = (_i64Add(($21|0),($24|0),($12|0),($15|0))|0); //@line 50641 "c/sqlite3.c"
     $36 = tempRet0; //@line 50641 "c/sqlite3.c"
     $37 = ($36|0)>($17|0); //@line 50641 "c/sqlite3.c"
     $38 = ($35>>>0)>($16>>>0); //@line 50641 "c/sqlite3.c"
     $39 = ($36|0)==($17|0); //@line 50641 "c/sqlite3.c"
     $40 = $39 & $38; //@line 50641 "c/sqlite3.c"
     $41 = $37 | $40; //@line 50641 "c/sqlite3.c"
     if (!($41)) {
      $42 = (_i64Subtract(($16|0),($17|0),($12|0),($15|0))|0); //@line 50646 "c/sqlite3.c"
      $43 = tempRet0; //@line 50646 "c/sqlite3.c"
      $44 = ((($0)) + 204|0); //@line 50642 "c/sqlite3.c"
      $45 = HEAP32[$44>>2]|0; //@line 50642 "c/sqlite3.c"
      _memset(($45|0),0,($12|0))|0; //@line 50643 "c/sqlite3.c"
      $46 = HEAP32[$3>>2]|0; //@line 50646 "c/sqlite3.c"
      $47 = (_sqlite3OsWrite($46,$45,$12,$42,$43)|0); //@line 50646 "c/sqlite3.c"
      $$0 = $47;
      label = 9;
     }
    }
    if ((label|0) == 9) {
     $48 = ($$0|0)==(0); //@line 50648 "c/sqlite3.c"
     if (!($48)) {
      $$1 = $$0;
      break;
     }
    }
    $49 = ((($0)) + 32|0); //@line 50649 "c/sqlite3.c"
    HEAP32[$49>>2] = $1; //@line 50649 "c/sqlite3.c"
    $$1 = 0;
   }
  } else {
   $$1 = $13;
  }
 } while(0);
 $$2 = $$1;
 STACKTOP = sp;return ($$2|0); //@line 50653 "c/sqlite3.c"
}
function _sqlite3WalExclusiveMode($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$shrunk = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 59280 "c/sqlite3.c"
 if (!($2)) {
  $14 = ($1|0)>(0); //@line 59291 "c/sqlite3.c"
  if ($14) {
   $15 = ((($0)) + 40|0); //@line 59294 "c/sqlite3.c"
   $16 = HEAP16[$15>>1]|0; //@line 59294 "c/sqlite3.c"
   $17 = $16 << 16 >> 16; //@line 59294 "c/sqlite3.c"
   $18 = (($17) + 3)|0; //@line 59294 "c/sqlite3.c"
   _walUnlockShared($0,$18); //@line 59294 "c/sqlite3.c"
   $19 = ((($0)) + 43|0); //@line 59295 "c/sqlite3.c"
   HEAP8[$19>>0] = 1; //@line 59295 "c/sqlite3.c"
   $$0$shrunk = 1;
   $$0 = $$0$shrunk&1;
   return ($$0|0); //@line 59300 "c/sqlite3.c"
  } else {
   $20 = ((($0)) + 43|0); //@line 59298 "c/sqlite3.c"
   $21 = HEAP8[$20>>0]|0; //@line 59298 "c/sqlite3.c"
   $22 = ($21<<24>>24)==(0); //@line 59298 "c/sqlite3.c"
   $$0$shrunk = $22;
   $$0 = $$0$shrunk&1;
   return ($$0|0); //@line 59300 "c/sqlite3.c"
  }
 }
 $3 = ((($0)) + 43|0); //@line 59281 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 59281 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 59281 "c/sqlite3.c"
 if ($5) {
  $$0$shrunk = 0;
  $$0 = $$0$shrunk&1;
  return ($$0|0); //@line 59300 "c/sqlite3.c"
 }
 HEAP8[$3>>0] = 0; //@line 59282 "c/sqlite3.c"
 $6 = ((($0)) + 40|0); //@line 59283 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 59283 "c/sqlite3.c"
 $8 = $7 << 16 >> 16; //@line 59283 "c/sqlite3.c"
 $9 = (($8) + 3)|0; //@line 59283 "c/sqlite3.c"
 $10 = (_walLockShared($0,$9)|0); //@line 59283 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 59283 "c/sqlite3.c"
 if (!($11)) {
  HEAP8[$3>>0] = 1; //@line 59284 "c/sqlite3.c"
 }
 $12 = HEAP8[$3>>0]|0; //@line 59286 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 59286 "c/sqlite3.c"
 $$0$shrunk = $13;
 $$0 = $$0$shrunk&1;
 return ($$0|0); //@line 59300 "c/sqlite3.c"
}
function _walLockShared($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 43|0); //@line 56425 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 56425 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 56425 "c/sqlite3.c"
 if (!($4)) {
  $$0 = 0;
  return ($$0|0); //@line 56432 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 56426 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 56426 "c/sqlite3.c"
 $7 = (_sqlite3OsShmLock($6,$1,1,6)|0); //@line 56426 "c/sqlite3.c"
 $$0 = $7;
 return ($$0|0); //@line 56432 "c/sqlite3.c"
}
function _sqlite3PCachePercentDirty($0) {
 $0 = $0|0;
 var $$0 = 0, $$01214 = 0, $$013 = 0, $$015 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = (_numberOfCachePages($0)|0); //@line 46032 "c/sqlite3.c"
 $$013 = HEAP32[$0>>2]|0;
 $2 = ($$013|0)==(0|0); //@line 46033 "c/sqlite3.c"
 if ($2) {
  $11 = 0;$12 = 0;
 } else {
  $$01214 = 0;$$015 = $$013;
  while(1) {
   $3 = (($$01214) + 1)|0; //@line 46033 "c/sqlite3.c"
   $4 = ((($$015)) + 32|0); //@line 46033 "c/sqlite3.c"
   $$0 = HEAP32[$4>>2]|0;
   $5 = ($$0|0)==(0|0); //@line 46033 "c/sqlite3.c"
   if ($5) {
    break;
   } else {
    $$01214 = $3;$$015 = $$0;
   }
  }
  $6 = (___muldi3(($3|0),0,100,0)|0); //@line 46034 "c/sqlite3.c"
  $7 = tempRet0; //@line 46034 "c/sqlite3.c"
  $11 = $6;$12 = $7;
 }
 $8 = ($1|0)==(0); //@line 46034 "c/sqlite3.c"
 if ($8) {
  $15 = 0;
  return ($15|0); //@line 46034 "c/sqlite3.c"
 }
 $9 = ($1|0)<(0); //@line 46034 "c/sqlite3.c"
 $10 = $9 << 31 >> 31; //@line 46034 "c/sqlite3.c"
 $13 = (___divdi3(($11|0),($12|0),($1|0),($10|0))|0); //@line 46034 "c/sqlite3.c"
 $14 = tempRet0; //@line 46034 "c/sqlite3.c"
 $15 = $13;
 return ($15|0); //@line 46034 "c/sqlite3.c"
}
function _pager_playback($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$ph = 0, $$0$ph$be = 0, $$086$ph = 0, $$091 = 0, $$095143 = 0, $$1145 = 0, $$187144 = 0, $$192 = 0, $$2 = 0, $$2103 = 0, $$293$ph = 0, $$299$ph = 0, $$299106109114120 = 0, $$6 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0;
 var $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0;
 var $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0;
 var $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0;
 var $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0;
 var $or$cond5 = 0, $or$cond7 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp + 8|0;
 $2 = sp;
 $3 = sp + 28|0;
 $4 = sp + 24|0;
 $5 = sp + 20|0;
 $6 = sp + 16|0;
 $7 = HEAP32[$0>>2]|0; //@line 50768 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 50772 "c/sqlite3.c"
 HEAP32[$5>>2] = 1; //@line 50774 "c/sqlite3.c"
 $8 = ((($0)) + 152|0); //@line 50778 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 50778 "c/sqlite3.c"
 HEAP32[$6>>2] = $9; //@line 50778 "c/sqlite3.c"
 $10 = ((($0)) + 64|0); //@line 50784 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 50784 "c/sqlite3.c"
 $12 = (_sqlite3OsFileSize($11,$2)|0); //@line 50784 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 50785 "c/sqlite3.c"
 L1: do {
  if ($13) {
   $14 = ((($0)) + 204|0); //@line 50800 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 50800 "c/sqlite3.c"
   $16 = HEAP32[$10>>2]|0; //@line 50801 "c/sqlite3.c"
   $17 = HEAP32[$0>>2]|0; //@line 50801 "c/sqlite3.c"
   $18 = ((($17)) + 8|0); //@line 50801 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 50801 "c/sqlite3.c"
   $20 = (($19) + 1)|0; //@line 50801 "c/sqlite3.c"
   $21 = (_readMasterJournal($16,$15,$20)|0); //@line 50801 "c/sqlite3.c"
   $22 = ($21|0)==(0); //@line 50802 "c/sqlite3.c"
   if ($22) {
    $23 = HEAP8[$15>>0]|0; //@line 50802 "c/sqlite3.c"
    $24 = ($23<<24>>24)==(0); //@line 50802 "c/sqlite3.c"
    if ($24) {
     $$091 = 0;
    } else {
     $25 = (_sqlite3OsAccess($7,$15,0,$5)|0); //@line 50803 "c/sqlite3.c"
     $$091 = $25;
    }
    $26 = ($$091|0)==(0); //@line 50806 "c/sqlite3.c"
    $27 = HEAP32[$5>>2]|0; //@line 50806 "c/sqlite3.c"
    $28 = ($27|0)!=(0); //@line 50806 "c/sqlite3.c"
    $or$cond = $26 & $28; //@line 50806 "c/sqlite3.c"
    L7: do {
     if ($or$cond) {
      $29 = ((($0)) + 72|0); //@line 50809 "c/sqlite3.c"
      $30 = $29; //@line 50809 "c/sqlite3.c"
      $31 = $30; //@line 50809 "c/sqlite3.c"
      HEAP32[$31>>2] = 0; //@line 50809 "c/sqlite3.c"
      $32 = (($30) + 4)|0; //@line 50809 "c/sqlite3.c"
      $33 = $32; //@line 50809 "c/sqlite3.c"
      HEAP32[$33>>2] = 0; //@line 50809 "c/sqlite3.c"
      $34 = ((($0)) + 148|0);
      $35 = ((($0)) + 80|0);
      $36 = ((($0)) + 148|0);
      $37 = ((($0)) + 148|0);
      $38 = ((($0)) + 24|0);
      $$0$ph = 0;$$086$ph = $1;
      while(1) {
       while(1) {
        $39 = $2; //@line 50822 "c/sqlite3.c"
        $40 = $39; //@line 50822 "c/sqlite3.c"
        $41 = HEAP32[$40>>2]|0; //@line 50822 "c/sqlite3.c"
        $42 = (($39) + 4)|0; //@line 50822 "c/sqlite3.c"
        $43 = $42; //@line 50822 "c/sqlite3.c"
        $44 = HEAP32[$43>>2]|0; //@line 50822 "c/sqlite3.c"
        $45 = (_readJournalHdr($0,$1,$41,$44,$3,$4)|0); //@line 50822 "c/sqlite3.c"
        switch ($45|0) {
        case 101:  {
         $$2103 = $$0$ph;
         break L7;
         break;
        }
        case 0:  {
         break;
        }
        default: {
         $$192 = $45;$$2 = $$0$ph;
         label = 25;
         break L7;
        }
        }
        $46 = HEAP32[$3>>2]|0; //@line 50835 "c/sqlite3.c"
        $47 = ($46|0)==(-1); //@line 50835 "c/sqlite3.c"
        if ($47) {
         $48 = $2; //@line 50837 "c/sqlite3.c"
         $49 = $48; //@line 50837 "c/sqlite3.c"
         $50 = HEAP32[$49>>2]|0; //@line 50837 "c/sqlite3.c"
         $51 = (($48) + 4)|0; //@line 50837 "c/sqlite3.c"
         $52 = $51; //@line 50837 "c/sqlite3.c"
         $53 = HEAP32[$52>>2]|0; //@line 50837 "c/sqlite3.c"
         $54 = HEAP32[$34>>2]|0; //@line 50837 "c/sqlite3.c"
         $55 = (_i64Subtract(($50|0),($53|0),($54|0),0)|0); //@line 50837 "c/sqlite3.c"
         $56 = tempRet0; //@line 50837 "c/sqlite3.c"
         $57 = HEAP32[$8>>2]|0; //@line 50837 "c/sqlite3.c"
         $58 = (($57) + 8)|0; //@line 50837 "c/sqlite3.c"
         $59 = ($58|0)<(0); //@line 50837 "c/sqlite3.c"
         $60 = $59 << 31 >> 31; //@line 50837 "c/sqlite3.c"
         $61 = (___divdi3(($55|0),($56|0),($58|0),($60|0))|0); //@line 50837 "c/sqlite3.c"
         $62 = tempRet0; //@line 50837 "c/sqlite3.c"
         HEAP32[$3>>2] = $61; //@line 50837 "c/sqlite3.c"
        }
        $63 = HEAP32[$3>>2]|0; //@line 50854 "c/sqlite3.c"
        $64 = $63 | $1; //@line 50854 "c/sqlite3.c"
        $65 = ($64|0)==(0); //@line 50854 "c/sqlite3.c"
        if ($65) {
         $66 = $35; //@line 50855 "c/sqlite3.c"
         $67 = $66; //@line 50855 "c/sqlite3.c"
         $68 = HEAP32[$67>>2]|0; //@line 50855 "c/sqlite3.c"
         $69 = (($66) + 4)|0; //@line 50855 "c/sqlite3.c"
         $70 = $69; //@line 50855 "c/sqlite3.c"
         $71 = HEAP32[$70>>2]|0; //@line 50855 "c/sqlite3.c"
         $72 = HEAP32[$36>>2]|0; //@line 50855 "c/sqlite3.c"
         $73 = (_i64Add(($68|0),($71|0),($72|0),0)|0); //@line 50855 "c/sqlite3.c"
         $74 = tempRet0; //@line 50855 "c/sqlite3.c"
         $75 = $29; //@line 50855 "c/sqlite3.c"
         $76 = $75; //@line 50855 "c/sqlite3.c"
         $77 = HEAP32[$76>>2]|0; //@line 50855 "c/sqlite3.c"
         $78 = (($75) + 4)|0; //@line 50855 "c/sqlite3.c"
         $79 = $78; //@line 50855 "c/sqlite3.c"
         $80 = HEAP32[$79>>2]|0; //@line 50855 "c/sqlite3.c"
         $81 = ($73|0)==($77|0); //@line 50855 "c/sqlite3.c"
         $82 = ($74|0)==($80|0); //@line 50855 "c/sqlite3.c"
         $83 = $81 & $82; //@line 50855 "c/sqlite3.c"
         if ($83) {
          $84 = $2; //@line 50856 "c/sqlite3.c"
          $85 = $84; //@line 50856 "c/sqlite3.c"
          $86 = HEAP32[$85>>2]|0; //@line 50856 "c/sqlite3.c"
          $87 = (($84) + 4)|0; //@line 50856 "c/sqlite3.c"
          $88 = $87; //@line 50856 "c/sqlite3.c"
          $89 = HEAP32[$88>>2]|0; //@line 50856 "c/sqlite3.c"
          $90 = (_i64Subtract(($86|0),($89|0),($77|0),($80|0))|0); //@line 50856 "c/sqlite3.c"
          $91 = tempRet0; //@line 50856 "c/sqlite3.c"
          $92 = HEAP32[$8>>2]|0; //@line 50856 "c/sqlite3.c"
          $93 = (($92) + 8)|0; //@line 50856 "c/sqlite3.c"
          $94 = ($93|0)<(0); //@line 50856 "c/sqlite3.c"
          $95 = $94 << 31 >> 31; //@line 50856 "c/sqlite3.c"
          $96 = (___divdi3(($90|0),($91|0),($93|0),($95|0))|0); //@line 50856 "c/sqlite3.c"
          $97 = tempRet0; //@line 50856 "c/sqlite3.c"
          HEAP32[$3>>2] = $96; //@line 50856 "c/sqlite3.c"
         }
        }
        $98 = $29; //@line 50862 "c/sqlite3.c"
        $99 = $98; //@line 50862 "c/sqlite3.c"
        $100 = HEAP32[$99>>2]|0; //@line 50862 "c/sqlite3.c"
        $101 = (($98) + 4)|0; //@line 50862 "c/sqlite3.c"
        $102 = $101; //@line 50862 "c/sqlite3.c"
        $103 = HEAP32[$102>>2]|0; //@line 50862 "c/sqlite3.c"
        $104 = HEAP32[$37>>2]|0; //@line 50862 "c/sqlite3.c"
        $105 = ($100|0)==($104|0); //@line 50862 "c/sqlite3.c"
        $106 = ($103|0)==(0); //@line 50862 "c/sqlite3.c"
        $107 = $105 & $106; //@line 50862 "c/sqlite3.c"
        if ($107) {
         $108 = HEAP32[$4>>2]|0; //@line 50863 "c/sqlite3.c"
         $109 = (_pager_truncate($0,$108)|0); //@line 50863 "c/sqlite3.c"
         $110 = ($109|0)==(0); //@line 50864 "c/sqlite3.c"
         if (!($110)) {
          $$293$ph = $109;$$299$ph = $$0$ph;
          label = 26;
          break L1;
         }
         HEAP32[$38>>2] = $108; //@line 50867 "c/sqlite3.c"
        }
        $111 = HEAP32[$3>>2]|0; //@line 50873 "c/sqlite3.c"
        $112 = ($111|0)==(0); //@line 50873 "c/sqlite3.c"
        if (!($112)) {
         break;
        }
       }
       $113 = HEAP32[$3>>2]|0;
       $$095143 = 0;$$1145 = $$0$ph;$$187144 = $$086$ph;
       L26: while(1) {
        $114 = ($$187144|0)==(0); //@line 50874 "c/sqlite3.c"
        if (!($114)) {
         _pager_reset($0); //@line 50875 "c/sqlite3.c"
        }
        $115 = (_pager_playback_one_page($0,$29,0,1,0)|0); //@line 50878 "c/sqlite3.c"
        switch ($115|0) {
        case 522:  {
         $$2103 = $$1145;
         break L7;
         break;
        }
        case 101:  {
         label = 23;
         break L26;
         break;
        }
        case 0:  {
         break;
        }
        default: {
         $$192 = $115;$$2 = $$1145;
         label = 25;
         break L7;
        }
        }
        $116 = (($$1145) + 1)|0; //@line 50880 "c/sqlite3.c"
        $117 = (($$095143) + 1)|0; //@line 50873 "c/sqlite3.c"
        $118 = ($117>>>0)<($113>>>0); //@line 50873 "c/sqlite3.c"
        if ($118) {
         $$095143 = $117;$$1145 = $116;$$187144 = 0;
        } else {
         $$0$ph$be = $116;
         break;
        }
       }
       if ((label|0) == 23) {
        label = 0;
        $119 = $2; //@line 50883 "c/sqlite3.c"
        $120 = $119; //@line 50883 "c/sqlite3.c"
        $121 = HEAP32[$120>>2]|0; //@line 50883 "c/sqlite3.c"
        $122 = (($119) + 4)|0; //@line 50883 "c/sqlite3.c"
        $123 = $122; //@line 50883 "c/sqlite3.c"
        $124 = HEAP32[$123>>2]|0; //@line 50883 "c/sqlite3.c"
        $125 = $29; //@line 50883 "c/sqlite3.c"
        $126 = $125; //@line 50883 "c/sqlite3.c"
        HEAP32[$126>>2] = $121; //@line 50883 "c/sqlite3.c"
        $127 = (($125) + 4)|0; //@line 50883 "c/sqlite3.c"
        $128 = $127; //@line 50883 "c/sqlite3.c"
        HEAP32[$128>>2] = $124; //@line 50883 "c/sqlite3.c"
        $$0$ph$be = $$1145;
       }
       $$0$ph = $$0$ph$be;$$086$ph = 0;
      }
     } else {
      $$192 = $$091;$$2 = 0;
      label = 25;
     }
    } while(0);
    if ((label|0) == 25) {
     $129 = ($$192|0)==(0); //@line 50908 "c/sqlite3.c"
     if ($129) {
      $$2103 = $$2;
     } else {
      $$293$ph = $$192;$$299$ph = $$2;
      label = 26;
      break;
     }
    }
    $133 = (_sqlite3PagerSetPagesize($0,$6,-1)|0); //@line 50909 "c/sqlite3.c"
    $134 = ((($0)) + 12|0); //@line 50931 "c/sqlite3.c"
    $135 = HEAP8[$134>>0]|0; //@line 50931 "c/sqlite3.c"
    $136 = ((($0)) + 18|0); //@line 50931 "c/sqlite3.c"
    HEAP8[$136>>0] = $135; //@line 50931 "c/sqlite3.c"
    $137 = ($133|0)==(0); //@line 50933 "c/sqlite3.c"
    if ($137) {
     $138 = ((($0)) + 204|0); //@line 50934 "c/sqlite3.c"
     $139 = HEAP32[$138>>2]|0; //@line 50934 "c/sqlite3.c"
     $140 = HEAP32[$10>>2]|0; //@line 50935 "c/sqlite3.c"
     $141 = HEAP32[$0>>2]|0; //@line 50935 "c/sqlite3.c"
     $142 = ((($141)) + 8|0); //@line 50935 "c/sqlite3.c"
     $143 = HEAP32[$142>>2]|0; //@line 50935 "c/sqlite3.c"
     $144 = (($143) + 1)|0; //@line 50935 "c/sqlite3.c"
     $145 = (_readMasterJournal($140,$139,$144)|0); //@line 50935 "c/sqlite3.c"
     $146 = ($145|0)==(0); //@line 50938 "c/sqlite3.c"
     if ($146) {
      $147 = ((($0)) + 16|0); //@line 50939 "c/sqlite3.c"
      $148 = HEAP8[$147>>0]|0; //@line 50939 "c/sqlite3.c"
      $149 = (($148) + -1)<<24>>24; //@line 50939 "c/sqlite3.c"
      $150 = ($149&255)>(2); //@line 50939 "c/sqlite3.c"
      if ($150) {
       $151 = (_sqlite3PagerSync($0,0)|0); //@line 50941 "c/sqlite3.c"
       $152 = ($151|0)==(0); //@line 50943 "c/sqlite3.c"
       if (!($152)) {
        $$299106109114120 = $$2103;$$6 = $151;
        break;
       }
      }
      $153 = HEAP8[$139>>0]|0; //@line 50944 "c/sqlite3.c"
      $154 = ($153<<24>>24)!=(0); //@line 50944 "c/sqlite3.c"
      $155 = $154&1; //@line 50944 "c/sqlite3.c"
      $156 = (_pager_end_transaction($0,$155,0)|0); //@line 50944 "c/sqlite3.c"
      $157 = ($156|0)==(0); //@line 50947 "c/sqlite3.c"
      if ($157) {
       $158 = HEAP8[$139>>0]|0; //@line 50947 "c/sqlite3.c"
       $159 = ($158<<24>>24)!=(0); //@line 50947 "c/sqlite3.c"
       $160 = HEAP32[$5>>2]|0; //@line 50947 "c/sqlite3.c"
       $161 = ($160|0)!=(0); //@line 50947 "c/sqlite3.c"
       $or$cond5 = $159 & $161; //@line 50947 "c/sqlite3.c"
       if ($or$cond5) {
        $162 = (_pager_delmaster($0,$139)|0); //@line 50951 "c/sqlite3.c"
        $$299106109114120 = $$2103;$$6 = $162;
       } else {
        $$299106109114120 = $$2103;$$6 = 0;
       }
      } else {
       $$299106109114120 = $$2103;$$6 = $156;
      }
     } else {
      $$299106109114120 = $$2103;$$6 = $145;
     }
    } else {
     $$299106109114120 = $$2103;$$6 = $133;
    }
   } else {
    $$293$ph = $21;$$299$ph = 0;
    label = 26;
   }
  } else {
   $$293$ph = $12;$$299$ph = 0;
   label = 26;
  }
 } while(0);
 if ((label|0) == 26) {
  $130 = ((($0)) + 12|0); //@line 50931 "c/sqlite3.c"
  $131 = HEAP8[$130>>0]|0; //@line 50931 "c/sqlite3.c"
  $132 = ((($0)) + 18|0); //@line 50931 "c/sqlite3.c"
  HEAP8[$132>>0] = $131; //@line 50931 "c/sqlite3.c"
  $$299106109114120 = $$299$ph;$$6 = $$293$ph;
 }
 $163 = ($1|0)!=(0); //@line 50954 "c/sqlite3.c"
 $164 = ($$299106109114120|0)!=(0); //@line 50954 "c/sqlite3.c"
 $or$cond7 = $163 & $164; //@line 50954 "c/sqlite3.c"
 if (!($or$cond7)) {
  _setSectorSize($0); //@line 50963 "c/sqlite3.c"
  STACKTOP = sp;return ($$6|0); //@line 50964 "c/sqlite3.c"
 }
 $165 = ((($0)) + 172|0); //@line 50956 "c/sqlite3.c"
 $166 = HEAP32[$165>>2]|0; //@line 50956 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $$299106109114120; //@line 50955 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 50955 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $166; //@line 50955 "c/sqlite3.c"
 _sqlite3_log(539,18352,$vararg_buffer); //@line 50955 "c/sqlite3.c"
 _setSectorSize($0); //@line 50963 "c/sqlite3.c"
 STACKTOP = sp;return ($$6|0); //@line 50964 "c/sqlite3.c"
}
function _pager_error($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $trunc = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $trunc = $1&255; //@line 49898 "c/sqlite3.c"
 switch ($trunc<<24>>24) {
 case 10: case 13:  {
  break;
 }
 default: {
  return ($1|0); //@line 49903 "c/sqlite3.c"
 }
 }
 $2 = ((($0)) + 40|0); //@line 49899 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 49899 "c/sqlite3.c"
 $3 = ((($0)) + 16|0); //@line 49900 "c/sqlite3.c"
 HEAP8[$3>>0] = 6; //@line 49900 "c/sqlite3.c"
 _setGetterMethod($0); //@line 49901 "c/sqlite3.c"
 return ($1|0); //@line 49903 "c/sqlite3.c"
}
function _readMasterJournal($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$021 = 0, $$022 = 0, $$promoted = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, $or$cond3 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp + 12|0;
 $4 = sp;
 $5 = sp + 8|0;
 $6 = sp + 16|0;
 HEAP8[$1>>0] = 0; //@line 49280 "c/sqlite3.c"
 $7 = (_sqlite3OsFileSize($0,$4)|0); //@line 49282 "c/sqlite3.c"
 $8 = ($7|0)!=(0); //@line 49282 "c/sqlite3.c"
 $9 = $4; //@line 49283 "c/sqlite3.c"
 $10 = $9; //@line 49283 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 49283 "c/sqlite3.c"
 $12 = (($9) + 4)|0; //@line 49283 "c/sqlite3.c"
 $13 = $12; //@line 49283 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 49283 "c/sqlite3.c"
 $15 = ($14|0)<(0); //@line 49283 "c/sqlite3.c"
 $16 = ($11>>>0)<(16); //@line 49283 "c/sqlite3.c"
 $17 = ($14|0)==(0); //@line 49283 "c/sqlite3.c"
 $18 = $17 & $16; //@line 49283 "c/sqlite3.c"
 $19 = $15 | $18; //@line 49283 "c/sqlite3.c"
 $or$cond = $8 | $19; //@line 49283 "c/sqlite3.c"
 if ($or$cond) {
  $$021 = $7;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $20 = (_i64Add(($11|0),($14|0),-16,-1)|0); //@line 49284 "c/sqlite3.c"
 $21 = tempRet0; //@line 49284 "c/sqlite3.c"
 $22 = (_read32bits($0,$20,$21,$3)|0); //@line 49284 "c/sqlite3.c"
 $23 = ($22|0)==(0); //@line 49284 "c/sqlite3.c"
 if (!($23)) {
  $$021 = $22;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $24 = HEAP32[$3>>2]|0; //@line 49285 "c/sqlite3.c"
 $25 = ($24>>>0)<($2>>>0); //@line 49285 "c/sqlite3.c"
 if (!($25)) {
  $$021 = 0;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $26 = $4; //@line 49286 "c/sqlite3.c"
 $27 = $26; //@line 49286 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 49286 "c/sqlite3.c"
 $29 = (($26) + 4)|0; //@line 49286 "c/sqlite3.c"
 $30 = $29; //@line 49286 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 49286 "c/sqlite3.c"
 $32 = (_i64Add(($28|0),($31|0),-16,-1)|0); //@line 49286 "c/sqlite3.c"
 $33 = tempRet0; //@line 49286 "c/sqlite3.c"
 $34 = ($33|0)<(0); //@line 49286 "c/sqlite3.c"
 $35 = ($32>>>0)<($24>>>0); //@line 49286 "c/sqlite3.c"
 $36 = ($33|0)==(0); //@line 49286 "c/sqlite3.c"
 $37 = $36 & $35; //@line 49286 "c/sqlite3.c"
 $38 = $34 | $37; //@line 49286 "c/sqlite3.c"
 $39 = ($24|0)==(0); //@line 49287 "c/sqlite3.c"
 $or$cond3 = $39 | $38; //@line 49287 "c/sqlite3.c"
 if ($or$cond3) {
  $$021 = 0;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $40 = (_i64Add(($28|0),($31|0),-12,-1)|0); //@line 49288 "c/sqlite3.c"
 $41 = tempRet0; //@line 49288 "c/sqlite3.c"
 $42 = (_read32bits($0,$40,$41,$5)|0); //@line 49288 "c/sqlite3.c"
 $43 = ($42|0)==(0); //@line 49288 "c/sqlite3.c"
 if (!($43)) {
  $$021 = $42;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $44 = $4; //@line 49289 "c/sqlite3.c"
 $45 = $44; //@line 49289 "c/sqlite3.c"
 $46 = HEAP32[$45>>2]|0; //@line 49289 "c/sqlite3.c"
 $47 = (($44) + 4)|0; //@line 49289 "c/sqlite3.c"
 $48 = $47; //@line 49289 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 49289 "c/sqlite3.c"
 $50 = (_i64Add(($46|0),($49|0),-8,-1)|0); //@line 49289 "c/sqlite3.c"
 $51 = tempRet0; //@line 49289 "c/sqlite3.c"
 $52 = (_sqlite3OsRead($0,$6,8,$50,$51)|0); //@line 49289 "c/sqlite3.c"
 $53 = ($52|0)==(0); //@line 49289 "c/sqlite3.c"
 if (!($53)) {
  $$021 = $52;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $54 = (_memcmp($6,18286,8)|0); //@line 49290 "c/sqlite3.c"
 $55 = ($54|0)==(0); //@line 49290 "c/sqlite3.c"
 if (!($55)) {
  $$021 = 0;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $56 = $4; //@line 49291 "c/sqlite3.c"
 $57 = $56; //@line 49291 "c/sqlite3.c"
 $58 = HEAP32[$57>>2]|0; //@line 49291 "c/sqlite3.c"
 $59 = (($56) + 4)|0; //@line 49291 "c/sqlite3.c"
 $60 = $59; //@line 49291 "c/sqlite3.c"
 $61 = HEAP32[$60>>2]|0; //@line 49291 "c/sqlite3.c"
 $62 = (_i64Subtract(-16,-1,($24|0),0)|0); //@line 49291 "c/sqlite3.c"
 $63 = tempRet0; //@line 49291 "c/sqlite3.c"
 $64 = (_i64Add(($62|0),($63|0),($58|0),($61|0))|0); //@line 49291 "c/sqlite3.c"
 $65 = tempRet0; //@line 49291 "c/sqlite3.c"
 $66 = (_sqlite3OsRead($0,$1,$24,$64,$65)|0); //@line 49291 "c/sqlite3.c"
 $67 = ($66|0)==(0); //@line 49291 "c/sqlite3.c"
 if (!($67)) {
  $$021 = $66;
  STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
 }
 $$promoted = HEAP32[$5>>2]|0; //@line 49298 "c/sqlite3.c"
 $$022 = 0;$72 = $$promoted;
 while(1) {
  $68 = (($1) + ($$022)|0); //@line 49298 "c/sqlite3.c"
  $69 = HEAP8[$68>>0]|0; //@line 49298 "c/sqlite3.c"
  $70 = $69 << 24 >> 24; //@line 49298 "c/sqlite3.c"
  $71 = (($72) - ($70))|0; //@line 49298 "c/sqlite3.c"
  $73 = (($$022) + 1)|0; //@line 49297 "c/sqlite3.c"
  $exitcond = ($73|0)==($24|0); //@line 49297 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$022 = $73;$72 = $71;
  }
 }
 HEAP32[$5>>2] = $71; //@line 49298 "c/sqlite3.c"
 $74 = ($71|0)==(0); //@line 49300 "c/sqlite3.c"
 if (!($74)) {
  HEAP32[$3>>2] = 0; //@line 49306 "c/sqlite3.c"
 }
 $75 = HEAP32[$3>>2]|0; //@line 49308 "c/sqlite3.c"
 $76 = (($1) + ($75)|0); //@line 49308 "c/sqlite3.c"
 HEAP8[$76>>0] = 0; //@line 49308 "c/sqlite3.c"
 $$021 = 0;
 STACKTOP = sp;return ($$021|0); //@line 49311 "c/sqlite3.c"
}
function _sqlite3PagerSync($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 60|0); //@line 54243 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 54243 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 54243 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 54243 "c/sqlite3.c"
 L1: do {
  if (!($5)) {
   $6 = (_sqlite3OsFileControl($3,21,$1)|0); //@line 54245 "c/sqlite3.c"
   switch ($6|0) {
   case 0: case 12:  {
    break L1;
    break;
   }
   default: {
    $$1 = $6;
   }
   }
   return ($$1|0); //@line 54252 "c/sqlite3.c"
  }
 } while(0);
 $7 = ((($0)) + 7|0); //@line 54248 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 54248 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 54248 "c/sqlite3.c"
 if (!($9)) {
  $$1 = 0;
  return ($$1|0); //@line 54252 "c/sqlite3.c"
 }
 $10 = HEAP32[$2>>2]|0; //@line 54250 "c/sqlite3.c"
 $11 = ((($0)) + 10|0); //@line 54250 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 54250 "c/sqlite3.c"
 $13 = $12&255; //@line 54250 "c/sqlite3.c"
 $14 = (_sqlite3OsSync($10,$13)|0); //@line 54250 "c/sqlite3.c"
 $$1 = $14;
 return ($$1|0); //@line 54252 "c/sqlite3.c"
}
function _pager_delmaster($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$075$ph = 0, $$07688 = 0, $$3$ph = 0, $$4 = 0, $$4$ph = 0, $$485 = 0, $$486 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = sp + 8|0;
 $4 = HEAP32[$0>>2]|0; //@line 50515 "c/sqlite3.c"
 $5 = ((($4)) + 4|0); //@line 50528 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 50528 "c/sqlite3.c"
 $7 = $6 << 1; //@line 50528 "c/sqlite3.c"
 $8 = ($7|0)<(0); //@line 50528 "c/sqlite3.c"
 $9 = $8 << 31 >> 31; //@line 50528 "c/sqlite3.c"
 $10 = (_sqlite3MallocZero($7,$9)|0); //@line 50528 "c/sqlite3.c"
 $11 = HEAP32[$5>>2]|0; //@line 50529 "c/sqlite3.c"
 $12 = (($10) + ($11)|0); //@line 50529 "c/sqlite3.c"
 $13 = ($10|0)!=(0|0); //@line 50530 "c/sqlite3.c"
 if (!($13)) {
  _sqlite3_free(0); //@line 50594 "c/sqlite3.c"
  $$485 = 7;
  STACKTOP = sp;return ($$485|0); //@line 50601 "c/sqlite3.c"
 }
 $14 = (_sqlite3OsOpen($4,$1,$10,16385,0)|0); //@line 50534 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 50536 "c/sqlite3.c"
 if ($15) {
  $16 = (_sqlite3OsFileSize($10,$2)|0); //@line 50543 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 50544 "c/sqlite3.c"
  if ($17) {
   $18 = ((($4)) + 8|0); //@line 50545 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 50545 "c/sqlite3.c"
   $20 = (($19) + 1)|0; //@line 50545 "c/sqlite3.c"
   $21 = $2; //@line 50546 "c/sqlite3.c"
   $22 = $21; //@line 50546 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 50546 "c/sqlite3.c"
   $24 = (($21) + 4)|0; //@line 50546 "c/sqlite3.c"
   $25 = $24; //@line 50546 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 50546 "c/sqlite3.c"
   $27 = ($20|0)<(0); //@line 50546 "c/sqlite3.c"
   $28 = $27 << 31 >> 31; //@line 50546 "c/sqlite3.c"
   $29 = (_i64Add(($23|0),($26|0),1,0)|0); //@line 50546 "c/sqlite3.c"
   $30 = tempRet0; //@line 50546 "c/sqlite3.c"
   $31 = (_i64Add(($29|0),($30|0),($20|0),($28|0))|0); //@line 50546 "c/sqlite3.c"
   $32 = tempRet0; //@line 50546 "c/sqlite3.c"
   $33 = (_sqlite3Malloc($31,$32)|0); //@line 50546 "c/sqlite3.c"
   $34 = ($33|0)==(0|0); //@line 50547 "c/sqlite3.c"
   if ($34) {
    $$075$ph = 0;$$4$ph = 7;
    label = 18;
   } else {
    $35 = $2; //@line 50551 "c/sqlite3.c"
    $36 = $35; //@line 50551 "c/sqlite3.c"
    $37 = HEAP32[$36>>2]|0; //@line 50551 "c/sqlite3.c"
    $38 = (($35) + 4)|0; //@line 50551 "c/sqlite3.c"
    $39 = $38; //@line 50551 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 50551 "c/sqlite3.c"
    $41 = (($37) + 1)|0; //@line 50551 "c/sqlite3.c"
    $42 = (($33) + ($41)|0); //@line 50551 "c/sqlite3.c"
    $43 = (_sqlite3OsRead($10,$33,$37,0,0)|0); //@line 50552 "c/sqlite3.c"
    $44 = ($43|0)==(0); //@line 50553 "c/sqlite3.c"
    if ($44) {
     $45 = $2; //@line 50554 "c/sqlite3.c"
     $46 = $45; //@line 50554 "c/sqlite3.c"
     $47 = HEAP32[$46>>2]|0; //@line 50554 "c/sqlite3.c"
     $48 = (($45) + 4)|0; //@line 50554 "c/sqlite3.c"
     $49 = $48; //@line 50554 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 50554 "c/sqlite3.c"
     $51 = (($33) + ($47)|0); //@line 50554 "c/sqlite3.c"
     HEAP8[$51>>0] = 0; //@line 50554 "c/sqlite3.c"
     $52 = $33; //@line 50557 "c/sqlite3.c"
     $53 = $2; //@line 50557 "c/sqlite3.c"
     $54 = $53; //@line 50557 "c/sqlite3.c"
     $55 = HEAP32[$54>>2]|0; //@line 50557 "c/sqlite3.c"
     $56 = (($53) + 4)|0; //@line 50557 "c/sqlite3.c"
     $57 = $56; //@line 50557 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 50557 "c/sqlite3.c"
     $59 = ($58|0)>(0); //@line 50557 "c/sqlite3.c"
     $60 = ($55>>>0)>(0); //@line 50557 "c/sqlite3.c"
     $61 = ($58|0)==(0); //@line 50557 "c/sqlite3.c"
     $62 = $61 & $60; //@line 50557 "c/sqlite3.c"
     $63 = $59 | $62; //@line 50557 "c/sqlite3.c"
     L10: do {
      if ($63) {
       $$07688 = $33;
       while(1) {
        $64 = (_sqlite3OsAccess($4,$$07688,0,$3)|0); //@line 50559 "c/sqlite3.c"
        $65 = ($64|0)==(0); //@line 50560 "c/sqlite3.c"
        if (!($65)) {
         $$3$ph = $64;
         break;
        }
        $66 = HEAP32[$3>>2]|0; //@line 50563 "c/sqlite3.c"
        $67 = ($66|0)==(0); //@line 50563 "c/sqlite3.c"
        if (!($67)) {
         $68 = (_sqlite3OsOpen($4,$$07688,$12,2049,0)|0); //@line 50570 "c/sqlite3.c"
         $69 = ($68|0)==(0); //@line 50571 "c/sqlite3.c"
         if (!($69)) {
          $$3$ph = $68;
          break;
         }
         $70 = (_readMasterJournal($12,$42,$20)|0); //@line 50575 "c/sqlite3.c"
         _sqlite3OsClose($12); //@line 50576 "c/sqlite3.c"
         $71 = ($70|0)==(0); //@line 50577 "c/sqlite3.c"
         if (!($71)) {
          $$3$ph = $70;
          break;
         }
         $72 = HEAP8[$42>>0]|0; //@line 50581 "c/sqlite3.c"
         $73 = ($72<<24>>24)==(0); //@line 50581 "c/sqlite3.c"
         if (!($73)) {
          $74 = (_strcmp($42,$1)|0); //@line 50581 "c/sqlite3.c"
          $75 = ($74|0)==(0); //@line 50581 "c/sqlite3.c"
          if ($75) {
           $$3$ph = 0;
           break;
          }
         }
        }
        $76 = (_sqlite3Strlen30($$07688)|0); //@line 50587 "c/sqlite3.c"
        $77 = (($76) + 1)|0; //@line 50587 "c/sqlite3.c"
        $78 = (($$07688) + ($77)|0); //@line 50587 "c/sqlite3.c"
        $79 = $78; //@line 50557 "c/sqlite3.c"
        $80 = (($79) - ($52))|0; //@line 50557 "c/sqlite3.c"
        $81 = ($80|0)<(0); //@line 50557 "c/sqlite3.c"
        $82 = $81 << 31 >> 31; //@line 50557 "c/sqlite3.c"
        $83 = $2; //@line 50557 "c/sqlite3.c"
        $84 = $83; //@line 50557 "c/sqlite3.c"
        $85 = HEAP32[$84>>2]|0; //@line 50557 "c/sqlite3.c"
        $86 = (($83) + 4)|0; //@line 50557 "c/sqlite3.c"
        $87 = $86; //@line 50557 "c/sqlite3.c"
        $88 = HEAP32[$87>>2]|0; //@line 50557 "c/sqlite3.c"
        $89 = ($88|0)>($82|0); //@line 50557 "c/sqlite3.c"
        $90 = ($85>>>0)>($80>>>0); //@line 50557 "c/sqlite3.c"
        $91 = ($88|0)==($82|0); //@line 50557 "c/sqlite3.c"
        $92 = $91 & $90; //@line 50557 "c/sqlite3.c"
        $93 = $89 | $92; //@line 50557 "c/sqlite3.c"
        if ($93) {
         $$07688 = $78;
        } else {
         label = 17;
         break L10;
        }
       }
       $$4 = $$3$ph;
      } else {
       label = 17;
      }
     } while(0);
     if ((label|0) == 17) {
      _sqlite3OsClose($10); //@line 50590 "c/sqlite3.c"
      $94 = (_sqlite3OsDelete($4,$1,0)|0); //@line 50591 "c/sqlite3.c"
      $$4 = $94;
     }
     _sqlite3_free($33); //@line 50594 "c/sqlite3.c"
     if ($13) {
      $$486 = $$4;
     } else {
      $$485 = $$4;
      STACKTOP = sp;return ($$485|0); //@line 50601 "c/sqlite3.c"
     }
    } else {
     $$075$ph = $33;$$4$ph = $43;
     label = 18;
    }
   }
  } else {
   $$075$ph = 0;$$4$ph = $16;
   label = 18;
  }
 } else {
  $$075$ph = 0;$$4$ph = $14;
  label = 18;
 }
 if ((label|0) == 18) {
  _sqlite3_free($$075$ph); //@line 50594 "c/sqlite3.c"
  $$486 = $$4$ph;
 }
 _sqlite3OsClose($10); //@line 50596 "c/sqlite3.c"
 _sqlite3_free($10); //@line 50598 "c/sqlite3.c"
 $$485 = $$486;
 STACKTOP = sp;return ($$485|0); //@line 50601 "c/sqlite3.c"
}
function _setSectorSize($0) {
 $0 = $0|0;
 var $$sink = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 50697 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 50697 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 50697 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 60|0); //@line 50698 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 50698 "c/sqlite3.c"
  $6 = (_sqlite3OsDeviceCharacteristics($5)|0); //@line 50698 "c/sqlite3.c"
  $7 = $6 & 4096; //@line 50698 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 50699 "c/sqlite3.c"
  if ($8) {
   $9 = HEAP32[$4>>2]|0; //@line 50706 "c/sqlite3.c"
   $10 = (_sqlite3SectorSize($9)|0); //@line 50706 "c/sqlite3.c"
   $$sink = $10;
  } else {
   $$sink = 512;
  }
 } else {
  $$sink = 512;
 }
 $11 = ((($0)) + 148|0);
 HEAP32[$11>>2] = $$sink;
 return; //@line 50708 "c/sqlite3.c"
}
function _sqlite3SectorSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3OsSectorSize($0)|0); //@line 50661 "c/sqlite3.c"
 $2 = ($1|0)<(32); //@line 50662 "c/sqlite3.c"
 if ($2) {
  return 512; //@line 50668 "c/sqlite3.c"
 } else {
  $3 = ($1|0)<(65536); //@line 50664 "c/sqlite3.c"
  $spec$select = $3 ? $1 : 65536; //@line 50664 "c/sqlite3.c"
  return ($spec$select|0); //@line 50664 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3OsSectorSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 20960 "c/sqlite3.c"
 $2 = ((($1)) + 44|0); //@line 20960 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 20960 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 20961 "c/sqlite3.c"
 if ($4) {
  $6 = 4096;
  return ($6|0); //@line 20961 "c/sqlite3.c"
 }
 $5 = (FUNCTION_TABLE_ii[$3 & 255]($0)|0); //@line 20961 "c/sqlite3.c"
 $6 = $5;
 return ($6|0); //@line 20961 "c/sqlite3.c"
}
function _autoVacuumCommit($0) {
 $0 = $0|0;
 var $$05659 = 0, $$057 = 0, $$1 = 0, $$158$lcssa = 0, $$2 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 64206 "c/sqlite3.c"
 _invalidateAllOverflowCache($0); //@line 64210 "c/sqlite3.c"
 $2 = ((($0)) + 18|0); //@line 64212 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 64212 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 64212 "c/sqlite3.c"
 if (!($4)) {
  $$1 = 0;
  return ($$1|0); //@line 64251 "c/sqlite3.c"
 }
 $5 = (_btreePagecount($0)|0); //@line 64218 "c/sqlite3.c"
 $6 = (_ptrmapPageno($0,$5)|0); //@line 64219 "c/sqlite3.c"
 $7 = ($6|0)==($5|0); //@line 64219 "c/sqlite3.c"
 if (!($7)) {
  $8 = HEAP32[513]|0; //@line 64219 "c/sqlite3.c"
  $9 = ((($0)) + 32|0); //@line 64219 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 64219 "c/sqlite3.c"
  $11 = (($8>>>0) / ($10>>>0))&-1; //@line 64219 "c/sqlite3.c"
  $12 = (($11) + 1)|0; //@line 64219 "c/sqlite3.c"
  $13 = ($5|0)==($12|0); //@line 64219 "c/sqlite3.c"
  if (!($13)) {
   $15 = ((($0)) + 12|0); //@line 64227 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 64227 "c/sqlite3.c"
   $17 = ((($16)) + 56|0); //@line 64227 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 64227 "c/sqlite3.c"
   $19 = ((($18)) + 36|0); //@line 64227 "c/sqlite3.c"
   $20 = (_sqlite3Get4byte($19)|0); //@line 64227 "c/sqlite3.c"
   $21 = (_finalDbSize($0,$5,$20)|0); //@line 64228 "c/sqlite3.c"
   $22 = ($21>>>0)>($5>>>0); //@line 64229 "c/sqlite3.c"
   if ($22) {
    $23 = (_sqlite3CorruptError(64229)|0); //@line 64229 "c/sqlite3.c"
    $$1 = $23;
    return ($$1|0); //@line 64251 "c/sqlite3.c"
   }
   $24 = ($21>>>0)<($5>>>0); //@line 64230 "c/sqlite3.c"
   if ($24) {
    $25 = (_saveAllCursors($0,0,0)|0); //@line 64231 "c/sqlite3.c"
    $$057 = $25;
   } else {
    $$057 = 0;
   }
   $26 = ($5>>>0)>($21>>>0); //@line 64233 "c/sqlite3.c"
   $27 = ($$057|0)==(0); //@line 64233 "c/sqlite3.c"
   $28 = $27 & $26; //@line 64233 "c/sqlite3.c"
   if ($28) {
    $$05659 = $5;
    while(1) {
     $29 = (_incrVacuumStep($0,$21,$$05659,1)|0); //@line 64234 "c/sqlite3.c"
     $30 = (($$05659) + -1)|0; //@line 64233 "c/sqlite3.c"
     $31 = ($30>>>0)>($21>>>0); //@line 64233 "c/sqlite3.c"
     $32 = ($29|0)==(0); //@line 64233 "c/sqlite3.c"
     $33 = $32 & $31; //@line 64233 "c/sqlite3.c"
     if ($33) {
      $$05659 = $30;
     } else {
      $$158$lcssa = $29;$$lcssa = $32;
      break;
     }
    }
   } else {
    $$158$lcssa = $$057;$$lcssa = $27;
   }
   $34 = ($$158$lcssa|0)==(101); //@line 64236 "c/sqlite3.c"
   $or$cond = $34 | $$lcssa; //@line 64236 "c/sqlite3.c"
   $35 = ($20|0)!=(0); //@line 64236 "c/sqlite3.c"
   $or$cond3 = $35 & $or$cond; //@line 64236 "c/sqlite3.c"
   if ($or$cond3) {
    $36 = HEAP32[$15>>2]|0; //@line 64237 "c/sqlite3.c"
    $37 = ((($36)) + 72|0); //@line 64237 "c/sqlite3.c"
    $38 = HEAP32[$37>>2]|0; //@line 64237 "c/sqlite3.c"
    $39 = (_sqlite3PagerWrite($38)|0); //@line 64237 "c/sqlite3.c"
    $40 = HEAP32[$15>>2]|0; //@line 64238 "c/sqlite3.c"
    $41 = ((($40)) + 56|0); //@line 64238 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 64238 "c/sqlite3.c"
    $43 = ((($42)) + 32|0); //@line 64238 "c/sqlite3.c"
    _sqlite3Put4byte($43,0); //@line 64238 "c/sqlite3.c"
    $44 = HEAP32[$15>>2]|0; //@line 64239 "c/sqlite3.c"
    $45 = ((($44)) + 56|0); //@line 64239 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 64239 "c/sqlite3.c"
    $47 = ((($46)) + 36|0); //@line 64239 "c/sqlite3.c"
    _sqlite3Put4byte($47,0); //@line 64239 "c/sqlite3.c"
    $48 = HEAP32[$15>>2]|0; //@line 64240 "c/sqlite3.c"
    $49 = ((($48)) + 56|0); //@line 64240 "c/sqlite3.c"
    $50 = HEAP32[$49>>2]|0; //@line 64240 "c/sqlite3.c"
    $51 = ((($50)) + 28|0); //@line 64240 "c/sqlite3.c"
    _sqlite3Put4byte($51,$21); //@line 64240 "c/sqlite3.c"
    $52 = ((($0)) + 19|0); //@line 64241 "c/sqlite3.c"
    HEAP8[$52>>0] = 1; //@line 64241 "c/sqlite3.c"
    $53 = ((($0)) + 44|0); //@line 64242 "c/sqlite3.c"
    HEAP32[$53>>2] = $21; //@line 64242 "c/sqlite3.c"
    $$2 = $39;
   } else {
    $$2 = $$158$lcssa;
   }
   $54 = ($$2|0)==(0); //@line 64244 "c/sqlite3.c"
   if ($54) {
    $$1 = 0;
    return ($$1|0); //@line 64251 "c/sqlite3.c"
   }
   (_sqlite3PagerRollback($1)|0); //@line 64245 "c/sqlite3.c"
   $$1 = $$2;
   return ($$1|0); //@line 64251 "c/sqlite3.c"
  }
 }
 $14 = (_sqlite3CorruptError(64224)|0); //@line 64224 "c/sqlite3.c"
 $$1 = $14;
 return ($$1|0); //@line 64251 "c/sqlite3.c"
}
function _sqlite3PagerTruncateImage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 51955 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 51955 "c/sqlite3.c"
 return; //@line 51966 "c/sqlite3.c"
}
function _sqlite3PagerCommitPhaseOne($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$05255 = 0, $$1 = 0, $$5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($0)) + 40|0); //@line 54323 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 54323 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 54323 "c/sqlite3.c"
 if (!($6)) {
  $$0 = $5;
  STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
 }
 $7 = (_sqlite3FaultSim(400)|0); //@line 54326 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 54326 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 10;
  STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
 }
 $9 = ((($0)) + 16|0); //@line 54332 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 54332 "c/sqlite3.c"
 $11 = ($10&255)<(3); //@line 54332 "c/sqlite3.c"
 if ($11) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
 }
 $12 = (_pagerFlushOnCommit($0,1)|0); //@line 54336 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 54336 "c/sqlite3.c"
 do {
  if ($13) {
   $14 = ((($0)) + 88|0); //@line 54340 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 54340 "c/sqlite3.c"
   _sqlite3BackupRestart($15); //@line 54340 "c/sqlite3.c"
  } else {
   $16 = ((($0)) + 212|0); //@line 54342 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 54342 "c/sqlite3.c"
   $18 = ($17|0)==(0|0); //@line 54342 "c/sqlite3.c"
   if ($18) {
    $33 = (_pager_incr_changecounter($0)|0); //@line 54431 "c/sqlite3.c"
    $34 = ($33|0)==(0); //@line 54433 "c/sqlite3.c"
    if (!($34)) {
     $$0 = $33;
     STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
    }
    $35 = (_writeMasterJournal($0,$1)|0); //@line 54439 "c/sqlite3.c"
    $36 = ($35|0)==(0); //@line 54440 "c/sqlite3.c"
    if (!($36)) {
     $$0 = $35;
     STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
    }
    $37 = (_syncJournal($0,0)|0); //@line 54453 "c/sqlite3.c"
    $38 = ($37|0)==(0); //@line 54454 "c/sqlite3.c"
    if (!($38)) {
     $$0 = $37;
     STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
    }
    $39 = ((($0)) + 208|0); //@line 54464 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 54464 "c/sqlite3.c"
    $41 = (_sqlite3PcacheDirtyList($40)|0); //@line 54464 "c/sqlite3.c"
    $42 = (_pager_write_pagelist($0,$41)|0); //@line 54464 "c/sqlite3.c"
    $43 = ($42|0)==(0); //@line 54473 "c/sqlite3.c"
    if (!($43)) {
     $$0 = $42;
     STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
    }
    $44 = HEAP32[$39>>2]|0; //@line 54477 "c/sqlite3.c"
    _sqlite3PcacheCleanAll($44); //@line 54477 "c/sqlite3.c"
    $45 = ((($0)) + 24|0); //@line 54485 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 54485 "c/sqlite3.c"
    $47 = ((($0)) + 32|0); //@line 54485 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 54485 "c/sqlite3.c"
    $49 = ($46>>>0)>($48>>>0); //@line 54485 "c/sqlite3.c"
    if ($49) {
     $50 = HEAP32[513]|0; //@line 54486 "c/sqlite3.c"
     $51 = ((($0)) + 152|0); //@line 54486 "c/sqlite3.c"
     $52 = HEAP32[$51>>2]|0; //@line 54486 "c/sqlite3.c"
     $53 = (($50|0) / ($52|0))&-1; //@line 54486 "c/sqlite3.c"
     $54 = (($53) + 1)|0; //@line 54486 "c/sqlite3.c"
     $55 = ($46|0)==($54|0); //@line 54486 "c/sqlite3.c"
     $56 = $55&1; //@line 54486 "c/sqlite3.c"
     $57 = (($46) - ($56))|0; //@line 54486 "c/sqlite3.c"
     $58 = (_pager_truncate($0,$57)|0); //@line 54488 "c/sqlite3.c"
     $59 = ($58|0)==(0); //@line 54489 "c/sqlite3.c"
     if (!($59)) {
      $$0 = $58;
      STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
     }
    }
    $60 = ($2|0)==(0); //@line 54493 "c/sqlite3.c"
    if (!($60)) {
     break;
    }
    $61 = (_sqlite3PagerSync($0,$1)|0); //@line 54494 "c/sqlite3.c"
    $$5 = $61;
   } else {
    $19 = ((($0)) + 208|0); //@line 54343 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 54343 "c/sqlite3.c"
    $21 = (_sqlite3PcacheDirtyList($20)|0); //@line 54343 "c/sqlite3.c"
    HEAP32[$3>>2] = 0; //@line 54344 "c/sqlite3.c"
    $22 = ($21|0)==(0|0); //@line 54345 "c/sqlite3.c"
    if ($22) {
     $23 = (_sqlite3PagerGet($0,1,$3,0)|0); //@line 54348 "c/sqlite3.c"
     $24 = HEAP32[$3>>2]|0; //@line 54349 "c/sqlite3.c"
     $25 = ((($24)) + 16|0); //@line 54350 "c/sqlite3.c"
     HEAP32[$25>>2] = 0; //@line 54350 "c/sqlite3.c"
     $26 = ($24|0)==(0|0); //@line 54353 "c/sqlite3.c"
     if ($26) {
      $$1 = $23;
     } else {
      $$05255 = $24;
      label = 9;
     }
    } else {
     $$05255 = $21;
     label = 9;
    }
    if ((label|0) == 9) {
     $27 = ((($0)) + 24|0); //@line 54354 "c/sqlite3.c"
     $28 = HEAP32[$27>>2]|0; //@line 54354 "c/sqlite3.c"
     $29 = (_pagerWalFrames($0,$$05255,$28,1)|0); //@line 54354 "c/sqlite3.c"
     $$1 = $29;
    }
    $30 = HEAP32[$3>>2]|0; //@line 54356 "c/sqlite3.c"
    _sqlite3PagerUnref($30); //@line 54356 "c/sqlite3.c"
    $31 = ($$1|0)==(0); //@line 54357 "c/sqlite3.c"
    if ($31) {
     $32 = HEAP32[$19>>2]|0; //@line 54358 "c/sqlite3.c"
     _sqlite3PcacheCleanAll($32); //@line 54358 "c/sqlite3.c"
    }
    $$5 = $$1;
   }
   $62 = ($$5|0)==(0); //@line 54501 "c/sqlite3.c"
   if (!($62)) {
    $$0 = $$5;
    STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
   }
  }
 } while(0);
 $63 = ((($0)) + 212|0); //@line 54501 "c/sqlite3.c"
 $64 = HEAP32[$63>>2]|0; //@line 54501 "c/sqlite3.c"
 $65 = ($64|0)==(0|0); //@line 54501 "c/sqlite3.c"
 if (!($65)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
 }
 HEAP8[$9>>0] = 5; //@line 54502 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 54505 "c/sqlite3.c"
}
function _sqlite3FaultSim($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(268)>>2]|0; //@line 28515 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 28516 "c/sqlite3.c"
 if ($2) {
  $4 = 0;
  return ($4|0); //@line 28516 "c/sqlite3.c"
 }
 $3 = (FUNCTION_TABLE_ii[$1 & 255]($0)|0); //@line 28516 "c/sqlite3.c"
 $4 = $3;
 return ($4|0); //@line 28516 "c/sqlite3.c"
}
function _pagerWalFrames($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$$0$33 = 0, $$02941 = 0, $$03140 = 0, $$042 = 0, $$1 = 0, $$130 = 0, $$13038 = 0, $$13039 = 0, $$132 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $not$ = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 HEAP32[$4>>2] = $1;
 $5 = ($3|0)==(0); //@line 51159 "c/sqlite3.c"
 if ($5) {
  $$2 = 1;
 } else {
  HEAP32[$4>>2] = $1; //@line 51166 "c/sqlite3.c"
  $6 = ($1|0)==(0|0); //@line 51166 "c/sqlite3.c"
  if ($6) {
   $$2 = 0;
  } else {
   $$02941 = $1;$$03140 = 0;$$042 = $4;
   while(1) {
    $7 = ((($$02941)) + 24|0); //@line 51167 "c/sqlite3.c"
    $8 = HEAP32[$7>>2]|0; //@line 51167 "c/sqlite3.c"
    $9 = ($8>>>0)>($2>>>0); //@line 51167 "c/sqlite3.c"
    $10 = ((($$02941)) + 16|0); //@line 51168 "c/sqlite3.c"
    $not$ = $9 ^ 1; //@line 51167 "c/sqlite3.c"
    $11 = $not$&1; //@line 51167 "c/sqlite3.c"
    $$132 = (($$03140) + ($11))|0; //@line 51167 "c/sqlite3.c"
    $$1 = $9 ? $$042 : $10; //@line 51167 "c/sqlite3.c"
    $12 = HEAP32[$10>>2]|0; //@line 51166 "c/sqlite3.c"
    HEAP32[$$1>>2] = $12; //@line 51166 "c/sqlite3.c"
    $13 = ($12|0)==(0|0); //@line 51166 "c/sqlite3.c"
    if ($13) {
     $$2 = $$132;
     break;
    } else {
     $$02941 = $12;$$03140 = $$132;$$042 = $$1;
    }
   }
  }
 }
 $14 = ((($0)) + 192|0); //@line 51176 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 51176 "c/sqlite3.c"
 $16 = (($15) + ($$2))|0; //@line 51176 "c/sqlite3.c"
 HEAP32[$14>>2] = $16; //@line 51176 "c/sqlite3.c"
 $$0$$0$33 = HEAP32[$4>>2]|0; //@line 51178 "c/sqlite3.c"
 $17 = ((($$0$$0$33)) + 24|0); //@line 51178 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 51178 "c/sqlite3.c"
 $19 = ($18|0)==(1); //@line 51178 "c/sqlite3.c"
 if ($19) {
  _pager_write_changecounter($$0$$0$33); //@line 51178 "c/sqlite3.c"
 }
 $20 = ((($0)) + 212|0); //@line 51179 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 51179 "c/sqlite3.c"
 $22 = ((($0)) + 152|0); //@line 51180 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 51180 "c/sqlite3.c"
 $24 = ((($0)) + 11|0); //@line 51180 "c/sqlite3.c"
 $25 = HEAP8[$24>>0]|0; //@line 51180 "c/sqlite3.c"
 $26 = $25&255; //@line 51180 "c/sqlite3.c"
 $27 = (_sqlite3WalFrames($21,$23,$$0$$0$33,$2,$3,$26)|0); //@line 51179 "c/sqlite3.c"
 $28 = ($27|0)==(0); //@line 51182 "c/sqlite3.c"
 if (!($28)) {
  STACKTOP = sp;return ($27|0); //@line 51195 "c/sqlite3.c"
 }
 $29 = ((($0)) + 88|0); //@line 51182 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 51182 "c/sqlite3.c"
 $31 = ($30|0)==(0|0); //@line 51182 "c/sqlite3.c"
 if ($31) {
  STACKTOP = sp;return ($27|0); //@line 51195 "c/sqlite3.c"
 }
 $$13038 = HEAP32[$4>>2]|0;
 $32 = ($$13038|0)==(0|0); //@line 51183 "c/sqlite3.c"
 if ($32) {
  STACKTOP = sp;return ($27|0); //@line 51195 "c/sqlite3.c"
 }
 $$13039 = $$13038;
 while(1) {
  $33 = HEAP32[$29>>2]|0; //@line 51184 "c/sqlite3.c"
  $34 = ((($$13039)) + 24|0); //@line 51184 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 51184 "c/sqlite3.c"
  $36 = ((($$13039)) + 4|0); //@line 51184 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 51184 "c/sqlite3.c"
  _sqlite3BackupUpdate($33,$35,$37); //@line 51184 "c/sqlite3.c"
  $38 = ((($$13039)) + 16|0); //@line 51183 "c/sqlite3.c"
  $$130 = HEAP32[$38>>2]|0;
  $39 = ($$130|0)==(0|0); //@line 51183 "c/sqlite3.c"
  if ($39) {
   break;
  } else {
   $$13039 = $$130;
  }
 }
 STACKTOP = sp;return ($27|0); //@line 51195 "c/sqlite3.c"
}
function _pager_incr_changecounter($0) {
 $0 = $0|0;
 var $$01 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 18|0); //@line 54183 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 54183 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 54183 "c/sqlite3.c"
 if (!($4)) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 54230 "c/sqlite3.c"
 }
 $5 = ((($0)) + 24|0); //@line 54183 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 54183 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 54183 "c/sqlite3.c"
 if ($7) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 54230 "c/sqlite3.c"
 }
 $8 = (_sqlite3PagerGet($0,1,$1,0)|0); //@line 54189 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 54197 "c/sqlite3.c"
 if ($9) {
  $10 = HEAP32[$1>>2]|0; //@line 54198 "c/sqlite3.c"
  $11 = (_sqlite3PagerWrite($10)|0); //@line 54198 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 54201 "c/sqlite3.c"
  if ($12) {
   $13 = HEAP32[$1>>2]|0; //@line 54203 "c/sqlite3.c"
   _pager_write_changecounter($13); //@line 54203 "c/sqlite3.c"
   HEAP8[$2>>0] = 1; //@line 54223 "c/sqlite3.c"
   $$01 = 0;
  } else {
   $$01 = $11;
  }
 } else {
  $$01 = $8;
 }
 $14 = HEAP32[$1>>2]|0; //@line 54228 "c/sqlite3.c"
 _sqlite3PagerUnref($14); //@line 54228 "c/sqlite3.c"
 $$1 = $$01;
 STACKTOP = sp;return ($$1|0); //@line 54230 "c/sqlite3.c"
}
function _writeMasterJournal($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$047 = 0, $$048$lcssa = 0, $$04850 = 0, $$051 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0;
 var $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ($1|0)==(0|0); //@line 49664 "c/sqlite3.c"
 if ($3) {
  $$047 = 0;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $4 = ((($0)) + 5|0); //@line 49665 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 49665 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(4); //@line 49665 "c/sqlite3.c"
 if ($6) {
  $$047 = 0;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $7 = ((($0)) + 64|0); //@line 49666 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 49666 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 49666 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 49666 "c/sqlite3.c"
 if ($10) {
  $$047 = 0;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $11 = ((($0)) + 19|0); //@line 49670 "c/sqlite3.c"
 HEAP8[$11>>0] = 1; //@line 49670 "c/sqlite3.c"
 $12 = HEAP8[$1>>0]|0; //@line 49674 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 49674 "c/sqlite3.c"
 if ($13) {
  $$0$lcssa = 0;$$048$lcssa = 0;
 } else {
  $$04850 = 0;$$051 = 0;$15 = $12;
  while(1) {
   $14 = $15 << 24 >> 24; //@line 49675 "c/sqlite3.c"
   $16 = (($$051) + ($14))|0; //@line 49675 "c/sqlite3.c"
   $17 = (($$04850) + 1)|0; //@line 49674 "c/sqlite3.c"
   $18 = (($1) + ($17)|0); //@line 49674 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 49674 "c/sqlite3.c"
   $20 = ($19<<24>>24)==(0); //@line 49674 "c/sqlite3.c"
   if ($20) {
    $$0$lcssa = $16;$$048$lcssa = $17;
    break;
   } else {
    $$04850 = $17;$$051 = $16;$15 = $19;
   }
  }
 }
 $21 = ((($0)) + 8|0); //@line 49682 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 49682 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(0); //@line 49682 "c/sqlite3.c"
 if (!($23)) {
  $24 = (_journalHdrOffset($0)|0); //@line 49683 "c/sqlite3.c"
  $25 = tempRet0; //@line 49683 "c/sqlite3.c"
  $26 = ((($0)) + 72|0); //@line 49683 "c/sqlite3.c"
  $27 = $26; //@line 49683 "c/sqlite3.c"
  $28 = $27; //@line 49683 "c/sqlite3.c"
  HEAP32[$28>>2] = $24; //@line 49683 "c/sqlite3.c"
  $29 = (($27) + 4)|0; //@line 49683 "c/sqlite3.c"
  $30 = $29; //@line 49683 "c/sqlite3.c"
  HEAP32[$30>>2] = $25; //@line 49683 "c/sqlite3.c"
 }
 $31 = ((($0)) + 72|0); //@line 49685 "c/sqlite3.c"
 $32 = $31; //@line 49685 "c/sqlite3.c"
 $33 = $32; //@line 49685 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 49685 "c/sqlite3.c"
 $35 = (($32) + 4)|0; //@line 49685 "c/sqlite3.c"
 $36 = $35; //@line 49685 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 49685 "c/sqlite3.c"
 $38 = HEAP32[513]|0; //@line 49690 "c/sqlite3.c"
 $39 = ((($0)) + 152|0); //@line 49690 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 49690 "c/sqlite3.c"
 $41 = (($38|0) / ($40|0))&-1; //@line 49690 "c/sqlite3.c"
 $42 = (($41) + 1)|0; //@line 49690 "c/sqlite3.c"
 $43 = (_write32bits($8,$34,$37,$42)|0); //@line 49690 "c/sqlite3.c"
 $44 = ($43|0)==(0); //@line 49690 "c/sqlite3.c"
 if (!($44)) {
  $$047 = $43;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $45 = HEAP32[$7>>2]|0; //@line 49691 "c/sqlite3.c"
 $46 = (_i64Add(($34|0),($37|0),4,0)|0); //@line 49691 "c/sqlite3.c"
 $47 = tempRet0; //@line 49691 "c/sqlite3.c"
 $48 = (_sqlite3OsWrite($45,$1,$$048$lcssa,$46,$47)|0); //@line 49691 "c/sqlite3.c"
 $49 = ($48|0)==(0); //@line 49691 "c/sqlite3.c"
 if (!($49)) {
  $$047 = $48;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $50 = HEAP32[$7>>2]|0; //@line 49692 "c/sqlite3.c"
 $51 = (_i64Add(($46|0),($47|0),($$048$lcssa|0),0)|0); //@line 49692 "c/sqlite3.c"
 $52 = tempRet0; //@line 49692 "c/sqlite3.c"
 $53 = (_write32bits($50,$51,$52,$$048$lcssa)|0); //@line 49692 "c/sqlite3.c"
 $54 = ($53|0)==(0); //@line 49692 "c/sqlite3.c"
 if (!($54)) {
  $$047 = $53;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $55 = HEAP32[$7>>2]|0; //@line 49693 "c/sqlite3.c"
 $56 = (_i64Add(($51|0),($52|0),4,0)|0); //@line 49693 "c/sqlite3.c"
 $57 = tempRet0; //@line 49693 "c/sqlite3.c"
 $58 = (_write32bits($55,$56,$57,$$0$lcssa)|0); //@line 49693 "c/sqlite3.c"
 $59 = ($58|0)==(0); //@line 49693 "c/sqlite3.c"
 if (!($59)) {
  $$047 = $58;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $60 = HEAP32[$7>>2]|0; //@line 49694 "c/sqlite3.c"
 $61 = (_i64Add(($51|0),($52|0),8,0)|0); //@line 49695 "c/sqlite3.c"
 $62 = tempRet0; //@line 49695 "c/sqlite3.c"
 $63 = (_sqlite3OsWrite($60,18286,8,$61,$62)|0); //@line 49694 "c/sqlite3.c"
 $64 = ($63|0)==(0); //@line 49694 "c/sqlite3.c"
 if (!($64)) {
  $$047 = $63;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $65 = (($$048$lcssa) + 20)|0; //@line 49699 "c/sqlite3.c"
 $66 = $31; //@line 49699 "c/sqlite3.c"
 $67 = $66; //@line 49699 "c/sqlite3.c"
 $68 = HEAP32[$67>>2]|0; //@line 49699 "c/sqlite3.c"
 $69 = (($66) + 4)|0; //@line 49699 "c/sqlite3.c"
 $70 = $69; //@line 49699 "c/sqlite3.c"
 $71 = HEAP32[$70>>2]|0; //@line 49699 "c/sqlite3.c"
 $72 = (_i64Add(($68|0),($71|0),($65|0),0)|0); //@line 49699 "c/sqlite3.c"
 $73 = tempRet0; //@line 49699 "c/sqlite3.c"
 $74 = $31; //@line 49699 "c/sqlite3.c"
 $75 = $74; //@line 49699 "c/sqlite3.c"
 HEAP32[$75>>2] = $72; //@line 49699 "c/sqlite3.c"
 $76 = (($74) + 4)|0; //@line 49699 "c/sqlite3.c"
 $77 = $76; //@line 49699 "c/sqlite3.c"
 HEAP32[$77>>2] = $73; //@line 49699 "c/sqlite3.c"
 $78 = HEAP32[$7>>2]|0; //@line 49711 "c/sqlite3.c"
 $79 = (_sqlite3OsFileSize($78,$2)|0); //@line 49711 "c/sqlite3.c"
 $80 = ($79|0)==(0); //@line 49711 "c/sqlite3.c"
 if (!($80)) {
  $$047 = $79;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $81 = $2; //@line 49712 "c/sqlite3.c"
 $82 = $81; //@line 49712 "c/sqlite3.c"
 $83 = HEAP32[$82>>2]|0; //@line 49712 "c/sqlite3.c"
 $84 = (($81) + 4)|0; //@line 49712 "c/sqlite3.c"
 $85 = $84; //@line 49712 "c/sqlite3.c"
 $86 = HEAP32[$85>>2]|0; //@line 49712 "c/sqlite3.c"
 $87 = $31; //@line 49712 "c/sqlite3.c"
 $88 = $87; //@line 49712 "c/sqlite3.c"
 $89 = HEAP32[$88>>2]|0; //@line 49712 "c/sqlite3.c"
 $90 = (($87) + 4)|0; //@line 49712 "c/sqlite3.c"
 $91 = $90; //@line 49712 "c/sqlite3.c"
 $92 = HEAP32[$91>>2]|0; //@line 49712 "c/sqlite3.c"
 $93 = ($86|0)>($92|0); //@line 49712 "c/sqlite3.c"
 $94 = ($83>>>0)>($89>>>0); //@line 49712 "c/sqlite3.c"
 $95 = ($86|0)==($92|0); //@line 49712 "c/sqlite3.c"
 $96 = $95 & $94; //@line 49712 "c/sqlite3.c"
 $97 = $93 | $96; //@line 49712 "c/sqlite3.c"
 if (!($97)) {
  $$047 = 0;
  STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
 }
 $98 = HEAP32[$7>>2]|0; //@line 49714 "c/sqlite3.c"
 $99 = (_sqlite3OsTruncate($98,$89,$92)|0); //@line 49714 "c/sqlite3.c"
 $$047 = $99;
 STACKTOP = sp;return ($$047|0); //@line 49717 "c/sqlite3.c"
}
function _syncJournal($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$ph = 0, $$055 = 0, $$3 = 0, $$not = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $brmerge = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp + 16|0;
 $3 = sp;
 $4 = (_sqlite3PagerExclusiveLock($0)|0); //@line 52203 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 52204 "c/sqlite3.c"
 if (!($5)) {
  $$3 = $4;
  STACKTOP = sp;return ($$3|0); //@line 52303 "c/sqlite3.c"
 }
 $6 = ((($0)) + 7|0); //@line 52206 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 52206 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 52206 "c/sqlite3.c"
 do {
  if ($8) {
   $9 = ((($0)) + 64|0); //@line 52208 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 52208 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 52208 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 52208 "c/sqlite3.c"
   if (!($12)) {
    $13 = ((($0)) + 5|0); //@line 52208 "c/sqlite3.c"
    $14 = HEAP8[$13>>0]|0; //@line 52208 "c/sqlite3.c"
    $15 = ($14<<24>>24)==(4); //@line 52208 "c/sqlite3.c"
    if (!($15)) {
     $16 = ((($0)) + 60|0); //@line 52209 "c/sqlite3.c"
     $17 = HEAP32[$16>>2]|0; //@line 52209 "c/sqlite3.c"
     $18 = (_sqlite3OsDeviceCharacteristics($17)|0); //@line 52209 "c/sqlite3.c"
     $19 = $18 & 512; //@line 52212 "c/sqlite3.c"
     $20 = ($19|0)==(0); //@line 52212 "c/sqlite3.c"
     L9: do {
      if ($20) {
       $21 = $3; //@line 52239 "c/sqlite3.c"
       $22 = $21; //@line 52239 "c/sqlite3.c"
       HEAP32[$22>>2] = -117058087; //@line 52239 "c/sqlite3.c"
       $23 = (($21) + 4)|0; //@line 52239 "c/sqlite3.c"
       $24 = $23; //@line 52239 "c/sqlite3.c"
       HEAP32[$24>>2] = -681336544; //@line 52239 "c/sqlite3.c"
       $25 = ((($3)) + 8|0); //@line 52240 "c/sqlite3.c"
       $26 = ((($0)) + 44|0); //@line 52240 "c/sqlite3.c"
       $27 = HEAP32[$26>>2]|0; //@line 52240 "c/sqlite3.c"
       _sqlite3Put4byte($25,$27); //@line 52240 "c/sqlite3.c"
       $28 = (_journalHdrOffset($0)|0); //@line 52242 "c/sqlite3.c"
       $29 = tempRet0; //@line 52242 "c/sqlite3.c"
       $30 = HEAP32[$9>>2]|0; //@line 52243 "c/sqlite3.c"
       $31 = (_sqlite3OsRead($30,$2,8,$28,$29)|0); //@line 52243 "c/sqlite3.c"
       $32 = ($31|0)==(0); //@line 52244 "c/sqlite3.c"
       if ($32) {
        $33 = (_memcmp($2,18286,8)|0); //@line 52244 "c/sqlite3.c"
        $34 = ($33|0)==(0); //@line 52244 "c/sqlite3.c"
        if ($34) {
         $35 = HEAP32[$9>>2]|0; //@line 52246 "c/sqlite3.c"
         $36 = (_sqlite3OsWrite($35,41676,1,$28,$29)|0); //@line 52246 "c/sqlite3.c"
         $$055 = $36;
         label = 9;
        } else {
         label = 10;
        }
       } else {
        $$055 = $31;
        label = 9;
       }
       if ((label|0) == 9) {
        switch ($$055|0) {
        case 0: case 522:  {
         label = 10;
         break;
        }
        default: {
         $$0$ph = $$055;
        }
        }
       }
       do {
        if ((label|0) == 10) {
         $37 = ((($0)) + 8|0); //@line 52263 "c/sqlite3.c"
         $38 = HEAP8[$37>>0]|0; //@line 52263 "c/sqlite3.c"
         $39 = ($38<<24>>24)!=(0); //@line 52263 "c/sqlite3.c"
         $40 = $18 & 1024; //@line 52263 "c/sqlite3.c"
         $41 = ($40|0)==(0); //@line 52263 "c/sqlite3.c"
         $or$cond = $41 & $39; //@line 52263 "c/sqlite3.c"
         if ($or$cond) {
          $42 = HEAP32[$9>>2]|0; //@line 52266 "c/sqlite3.c"
          $43 = ((($0)) + 10|0); //@line 52266 "c/sqlite3.c"
          $44 = HEAP8[$43>>0]|0; //@line 52266 "c/sqlite3.c"
          $45 = $44&255; //@line 52266 "c/sqlite3.c"
          $46 = (_sqlite3OsSync($42,$45)|0); //@line 52266 "c/sqlite3.c"
          $47 = ($46|0)==(0); //@line 52267 "c/sqlite3.c"
          if (!($47)) {
           $$0$ph = $46;
           break;
          }
         }
         $48 = HEAP32[$9>>2]|0; //@line 52271 "c/sqlite3.c"
         $49 = ((($0)) + 80|0); //@line 52271 "c/sqlite3.c"
         $50 = $49; //@line 52271 "c/sqlite3.c"
         $51 = $50; //@line 52271 "c/sqlite3.c"
         $52 = HEAP32[$51>>2]|0; //@line 52271 "c/sqlite3.c"
         $53 = (($50) + 4)|0; //@line 52271 "c/sqlite3.c"
         $54 = $53; //@line 52271 "c/sqlite3.c"
         $55 = HEAP32[$54>>2]|0; //@line 52271 "c/sqlite3.c"
         $56 = (_sqlite3OsWrite($48,$3,12,$52,$55)|0); //@line 52270 "c/sqlite3.c"
         $57 = ($56|0)==(0); //@line 52273 "c/sqlite3.c"
         if ($57) {
          break L9;
         } else {
          $$0$ph = $56;
         }
        }
       } while(0);
       $$3 = $$0$ph;
       STACKTOP = sp;return ($$3|0); //@line 52303 "c/sqlite3.c"
      }
     } while(0);
     $58 = $18 & 1024; //@line 52275 "c/sqlite3.c"
     $59 = ($58|0)==(0); //@line 52275 "c/sqlite3.c"
     if ($59) {
      $60 = HEAP32[$9>>2]|0; //@line 52278 "c/sqlite3.c"
      $61 = ((($0)) + 10|0); //@line 52278 "c/sqlite3.c"
      $62 = HEAP8[$61>>0]|0; //@line 52278 "c/sqlite3.c"
      $63 = $62&255; //@line 52278 "c/sqlite3.c"
      $64 = ($62<<24>>24)==(3); //@line 52279 "c/sqlite3.c"
      $65 = $64 ? 16 : 0; //@line 52279 "c/sqlite3.c"
      $66 = $65 | $63; //@line 52278 "c/sqlite3.c"
      $67 = (_sqlite3OsSync($60,$66)|0); //@line 52278 "c/sqlite3.c"
      $68 = ($67|0)==(0); //@line 52281 "c/sqlite3.c"
      if (!($68)) {
       $$3 = $67;
       STACKTOP = sp;return ($$3|0); //@line 52303 "c/sqlite3.c"
      }
     }
     $69 = ((($0)) + 72|0); //@line 52284 "c/sqlite3.c"
     $70 = $69; //@line 52284 "c/sqlite3.c"
     $71 = $70; //@line 52284 "c/sqlite3.c"
     $72 = HEAP32[$71>>2]|0; //@line 52284 "c/sqlite3.c"
     $73 = (($70) + 4)|0; //@line 52284 "c/sqlite3.c"
     $74 = $73; //@line 52284 "c/sqlite3.c"
     $75 = HEAP32[$74>>2]|0; //@line 52284 "c/sqlite3.c"
     $76 = ((($0)) + 80|0); //@line 52284 "c/sqlite3.c"
     $77 = $76; //@line 52284 "c/sqlite3.c"
     $78 = $77; //@line 52284 "c/sqlite3.c"
     HEAP32[$78>>2] = $72; //@line 52284 "c/sqlite3.c"
     $79 = (($77) + 4)|0; //@line 52284 "c/sqlite3.c"
     $80 = $79; //@line 52284 "c/sqlite3.c"
     HEAP32[$80>>2] = $75; //@line 52284 "c/sqlite3.c"
     $81 = ($1|0)==(0); //@line 52285 "c/sqlite3.c"
     $$not = $20 ^ 1; //@line 52285 "c/sqlite3.c"
     $brmerge = $81 | $$not; //@line 52285 "c/sqlite3.c"
     if ($brmerge) {
      break;
     }
     $82 = ((($0)) + 44|0); //@line 52286 "c/sqlite3.c"
     HEAP32[$82>>2] = 0; //@line 52286 "c/sqlite3.c"
     $83 = (_writeJournalHdr($0)|0); //@line 52287 "c/sqlite3.c"
     $84 = ($83|0)==(0); //@line 52288 "c/sqlite3.c"
     if ($84) {
      break;
     } else {
      $$3 = $83;
     }
     STACKTOP = sp;return ($$3|0); //@line 52303 "c/sqlite3.c"
    }
   }
   $85 = ((($0)) + 72|0); //@line 52291 "c/sqlite3.c"
   $86 = $85; //@line 52291 "c/sqlite3.c"
   $87 = $86; //@line 52291 "c/sqlite3.c"
   $88 = HEAP32[$87>>2]|0; //@line 52291 "c/sqlite3.c"
   $89 = (($86) + 4)|0; //@line 52291 "c/sqlite3.c"
   $90 = $89; //@line 52291 "c/sqlite3.c"
   $91 = HEAP32[$90>>2]|0; //@line 52291 "c/sqlite3.c"
   $92 = ((($0)) + 80|0); //@line 52291 "c/sqlite3.c"
   $93 = $92; //@line 52291 "c/sqlite3.c"
   $94 = $93; //@line 52291 "c/sqlite3.c"
   HEAP32[$94>>2] = $88; //@line 52291 "c/sqlite3.c"
   $95 = (($93) + 4)|0; //@line 52291 "c/sqlite3.c"
   $96 = $95; //@line 52291 "c/sqlite3.c"
   HEAP32[$96>>2] = $91; //@line 52291 "c/sqlite3.c"
  }
 } while(0);
 $97 = ((($0)) + 208|0); //@line 52299 "c/sqlite3.c"
 $98 = HEAP32[$97>>2]|0; //@line 52299 "c/sqlite3.c"
 _sqlite3PcacheClearSyncFlags($98); //@line 52299 "c/sqlite3.c"
 $99 = ((($0)) + 16|0); //@line 52300 "c/sqlite3.c"
 HEAP8[$99>>0] = 4; //@line 52300 "c/sqlite3.c"
 $$3 = 0;
 STACKTOP = sp;return ($$3|0); //@line 52303 "c/sqlite3.c"
}
function _pager_write_pagelist($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$052 = 0, $$1$lcssa = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 60|0); //@line 52350 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 52350 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 52350 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 52350 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 144|0); //@line 52352 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 52352 "c/sqlite3.c"
  $9 = (_pagerOpentemp($0,$4,$8)|0); //@line 52352 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 52359 "c/sqlite3.c"
  if (!($10)) {
   $$1$lcssa = $9;
   STACKTOP = sp;return ($$1$lcssa|0); //@line 52418 "c/sqlite3.c"
  }
 }
 $11 = ((($0)) + 36|0); //@line 52360 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 52360 "c/sqlite3.c"
 $13 = ((($0)) + 24|0); //@line 52360 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 52360 "c/sqlite3.c"
 $15 = ($12>>>0)<($14>>>0); //@line 52360 "c/sqlite3.c"
 do {
  if ($15) {
   $16 = ((($1)) + 16|0); //@line 52361 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 52361 "c/sqlite3.c"
   $18 = ($17|0)==(0|0); //@line 52361 "c/sqlite3.c"
   if ($18) {
    $19 = ((($1)) + 24|0); //@line 52361 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 52361 "c/sqlite3.c"
    $21 = ($20>>>0)>($12>>>0); //@line 52361 "c/sqlite3.c"
    if (!($21)) {
     break;
    }
   }
   $22 = ((($0)) + 152|0); //@line 52363 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 52363 "c/sqlite3.c"
   $24 = ($23|0)<(0); //@line 52363 "c/sqlite3.c"
   $25 = $24 << 31 >> 31; //@line 52363 "c/sqlite3.c"
   $26 = (___muldi3(($23|0),($25|0),($14|0),0)|0); //@line 52363 "c/sqlite3.c"
   $27 = tempRet0; //@line 52363 "c/sqlite3.c"
   $28 = $2; //@line 52363 "c/sqlite3.c"
   $29 = $28; //@line 52363 "c/sqlite3.c"
   HEAP32[$29>>2] = $26; //@line 52363 "c/sqlite3.c"
   $30 = (($28) + 4)|0; //@line 52363 "c/sqlite3.c"
   $31 = $30; //@line 52363 "c/sqlite3.c"
   HEAP32[$31>>2] = $27; //@line 52363 "c/sqlite3.c"
   $32 = HEAP32[$3>>2]|0; //@line 52364 "c/sqlite3.c"
   _sqlite3OsFileControlHint($32,5,$2); //@line 52364 "c/sqlite3.c"
   $33 = HEAP32[$13>>2]|0; //@line 52365 "c/sqlite3.c"
   HEAP32[$11>>2] = $33; //@line 52365 "c/sqlite3.c"
  }
 } while(0);
 $34 = ($1|0)==(0|0); //@line 52368 "c/sqlite3.c"
 if ($34) {
  $$1$lcssa = 0;
  STACKTOP = sp;return ($$1$lcssa|0); //@line 52418 "c/sqlite3.c"
 }
 $35 = ((($0)) + 24|0);
 $36 = ((($0)) + 152|0);
 $37 = ((($0)) + 104|0);
 $38 = ((($0)) + 32|0);
 $39 = ((($0)) + 192|0);
 $40 = ((($0)) + 88|0);
 $$052 = $1;
 while(1) {
  $41 = ((($$052)) + 24|0); //@line 52369 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 52369 "c/sqlite3.c"
  $43 = HEAP32[$35>>2]|0; //@line 52379 "c/sqlite3.c"
  $44 = ($42>>>0)>($43>>>0); //@line 52379 "c/sqlite3.c"
  if ($44) {
   $$2 = 0;
  } else {
   $45 = ((($$052)) + 28|0); //@line 52379 "c/sqlite3.c"
   $46 = HEAP16[$45>>1]|0; //@line 52379 "c/sqlite3.c"
   $47 = $46 & 16; //@line 52379 "c/sqlite3.c"
   $48 = ($47<<16>>16)==(0); //@line 52379 "c/sqlite3.c"
   if ($48) {
    $49 = (($42) + -1)|0; //@line 52380 "c/sqlite3.c"
    $50 = HEAP32[$36>>2]|0; //@line 52380 "c/sqlite3.c"
    $51 = ($50|0)<(0); //@line 52380 "c/sqlite3.c"
    $52 = $51 << 31 >> 31; //@line 52380 "c/sqlite3.c"
    $53 = (___muldi3(($50|0),($52|0),($49|0),0)|0); //@line 52380 "c/sqlite3.c"
    $54 = tempRet0; //@line 52380 "c/sqlite3.c"
    $55 = ($42|0)==(1); //@line 52384 "c/sqlite3.c"
    if ($55) {
     _pager_write_changecounter($$052); //@line 52384 "c/sqlite3.c"
    }
    $56 = ((($$052)) + 4|0); //@line 52387 "c/sqlite3.c"
    $57 = HEAP32[$56>>2]|0; //@line 52387 "c/sqlite3.c"
    $58 = HEAP32[$3>>2]|0; //@line 52390 "c/sqlite3.c"
    $59 = HEAP32[$36>>2]|0; //@line 52390 "c/sqlite3.c"
    $60 = (_sqlite3OsWrite($58,$57,$59,$53,$54)|0); //@line 52390 "c/sqlite3.c"
    if ($55) {
     $61 = ((($57)) + 24|0); //@line 52397 "c/sqlite3.c"
     dest=$37; src=$61; stop=dest+16|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 52397 "c/sqlite3.c"
    }
    $62 = HEAP32[$38>>2]|0; //@line 52399 "c/sqlite3.c"
    $63 = ($42>>>0)>($62>>>0); //@line 52399 "c/sqlite3.c"
    if ($63) {
     HEAP32[$38>>2] = $42; //@line 52400 "c/sqlite3.c"
    }
    $64 = HEAP32[$39>>2]|0; //@line 52402 "c/sqlite3.c"
    $65 = (($64) + 1)|0; //@line 52402 "c/sqlite3.c"
    HEAP32[$39>>2] = $65; //@line 52402 "c/sqlite3.c"
    $66 = HEAP32[$40>>2]|0; //@line 52405 "c/sqlite3.c"
    $67 = HEAP32[$56>>2]|0; //@line 52405 "c/sqlite3.c"
    _sqlite3BackupUpdate($66,$42,$67); //@line 52405 "c/sqlite3.c"
    $$2 = $60;
   } else {
    $$2 = 0;
   }
  }
  $68 = ((($$052)) + 16|0); //@line 52415 "c/sqlite3.c"
  $69 = HEAP32[$68>>2]|0; //@line 52415 "c/sqlite3.c"
  $70 = ($$2|0)==(0); //@line 52368 "c/sqlite3.c"
  $71 = ($69|0)!=(0|0); //@line 52368 "c/sqlite3.c"
  $72 = $70 & $71; //@line 52368 "c/sqlite3.c"
  if ($72) {
   $$052 = $69;
  } else {
   $$1$lcssa = $$2;
   break;
  }
 }
 STACKTOP = sp;return ($$1$lcssa|0); //@line 52418 "c/sqlite3.c"
}
function _pagerOpentemp($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $2 | 30; //@line 51644 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 51646 "c/sqlite3.c"
 $5 = (_sqlite3OsOpen($4,0,$1,$3,0)|0); //@line 51646 "c/sqlite3.c"
 return ($5|0); //@line 51648 "c/sqlite3.c"
}
function _sqlite3OsFileControlHint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 20956 "c/sqlite3.c"
 $4 = ((($3)) + 40|0); //@line 20956 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 20956 "c/sqlite3.c"
 (FUNCTION_TABLE_iiii[$5 & 127]($0,$1,$2)|0); //@line 20956 "c/sqlite3.c"
 return; //@line 20957 "c/sqlite3.c"
}
function _pager_write_changecounter($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 51049 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 51049 "c/sqlite3.c"
 $3 = ((($2)) + 104|0); //@line 51049 "c/sqlite3.c"
 $4 = (_sqlite3Get4byte($3)|0); //@line 51049 "c/sqlite3.c"
 $5 = (($4) + 1)|0; //@line 51049 "c/sqlite3.c"
 $6 = ((($0)) + 4|0); //@line 51050 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 51050 "c/sqlite3.c"
 $8 = ((($7)) + 24|0); //@line 51050 "c/sqlite3.c"
 _sqlite3Put4byte($8,$5); //@line 51050 "c/sqlite3.c"
 $9 = HEAP32[$6>>2]|0; //@line 51055 "c/sqlite3.c"
 $10 = ((($9)) + 92|0); //@line 51055 "c/sqlite3.c"
 _sqlite3Put4byte($10,$5); //@line 51055 "c/sqlite3.c"
 $11 = HEAP32[$6>>2]|0; //@line 51056 "c/sqlite3.c"
 $12 = ((($11)) + 96|0); //@line 51056 "c/sqlite3.c"
 _sqlite3Put4byte($12,3022000); //@line 51056 "c/sqlite3.c"
 return; //@line 51057 "c/sqlite3.c"
}
function _sqlite3PcacheClearSyncFlags($0) {
 $0 = $0|0;
 var $$0 = 0, $$07 = 0, $$08 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$07 = HEAP32[$0>>2]|0;
 $1 = ($$07|0)==(0|0); //@line 45787 "c/sqlite3.c"
 if (!($1)) {
  $$08 = $$07;
  while(1) {
   $2 = ((($$08)) + 28|0); //@line 45788 "c/sqlite3.c"
   $3 = HEAP16[$2>>1]|0; //@line 45788 "c/sqlite3.c"
   $4 = $3 & -9; //@line 45788 "c/sqlite3.c"
   HEAP16[$2>>1] = $4; //@line 45788 "c/sqlite3.c"
   $5 = ((($$08)) + 32|0); //@line 45787 "c/sqlite3.c"
   $$0 = HEAP32[$5>>2]|0;
   $6 = ($$0|0)==(0|0); //@line 45787 "c/sqlite3.c"
   if ($6) {
    break;
   } else {
    $$08 = $$0;
   }
  }
 }
 $7 = ((($0)) + 4|0); //@line 45790 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 45790 "c/sqlite3.c"
 $9 = ((($0)) + 8|0); //@line 45790 "c/sqlite3.c"
 HEAP32[$9>>2] = $8; //@line 45790 "c/sqlite3.c"
 return; //@line 45791 "c/sqlite3.c"
}
function _sqlite3WalFrames($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0191$lcssa = 0, $$0191280 = 0, $$0196278 = 0, $$0204$lcssa = 0, $$0204277 = 0, $$0206 = 0, $$0210$lcssa = 0, $$0210270 = 0, $$10 = 0, $$11$ph = 0, $$1181$ph = 0, $$1192227 = 0, $$1197264 = 0, $$1205226 = 0, $$1211237 = 0, $$12245 = 0, $$12246 = 0, $$13$lcssa = 0, $$14 = 0, $$15$lcssa = 0;
 var $$2193$lcssa = 0, $$2193265 = 0, $$2212$ph = 0, $$3194 = 0, $$3213243 = 0, $$3213244 = 0, $$4195$lcssa = 0, $$4195261 = 0, $$4214260 = 0, $$lcssa = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0;
 var $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0;
 var $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0;
 var $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0;
 var $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0;
 var $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0;
 var $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0;
 var $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $6 = sp;
 $7 = sp + 32|0;
 $8 = sp + 24|0;
 $9 = (_walIndexHdr($0)|0); //@line 58916 "c/sqlite3.c"
 $10 = ((($0)) + 52|0); //@line 58917 "c/sqlite3.c"
 $11 = (_memcmp($10,$9,48)|0); //@line 58917 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 58917 "c/sqlite3.c"
 if ($12) {
  $$0206 = 0;
 } else {
  $13 = ((($9)) + 16|0); //@line 58918 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 58918 "c/sqlite3.c"
  $15 = (($14) + 1)|0; //@line 58918 "c/sqlite3.c"
  $$0206 = $15;
 }
 $16 = (_walRestartLog($0)|0); //@line 58924 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 58924 "c/sqlite3.c"
 if (!($17)) {
  $$10 = $16;
  STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
 }
 $18 = ((($0)) + 68|0); //@line 58932 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 58932 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 58933 "c/sqlite3.c"
 L7: do {
  if ($20) {
   _sqlite3Put4byte($7,931071618); //@line 58937 "c/sqlite3.c"
   $21 = ((($7)) + 4|0); //@line 58938 "c/sqlite3.c"
   _sqlite3Put4byte($21,3007000); //@line 58938 "c/sqlite3.c"
   $22 = ((($7)) + 8|0); //@line 58939 "c/sqlite3.c"
   _sqlite3Put4byte($22,$1); //@line 58939 "c/sqlite3.c"
   $23 = ((($7)) + 12|0); //@line 58940 "c/sqlite3.c"
   $24 = ((($0)) + 112|0); //@line 58940 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 58940 "c/sqlite3.c"
   _sqlite3Put4byte($23,$25); //@line 58940 "c/sqlite3.c"
   $26 = HEAP32[$24>>2]|0; //@line 58941 "c/sqlite3.c"
   $27 = ($26|0)==(0); //@line 58941 "c/sqlite3.c"
   if ($27) {
    $28 = ((($0)) + 84|0); //@line 58941 "c/sqlite3.c"
    _sqlite3_randomness(8,$28); //@line 58941 "c/sqlite3.c"
   }
   $29 = ((($7)) + 16|0); //@line 58942 "c/sqlite3.c"
   $30 = ((($0)) + 84|0); //@line 58942 "c/sqlite3.c"
   $31 = $30; //@line 58942 "c/sqlite3.c"
   $32 = $31; //@line 58942 "c/sqlite3.c"
   $33 = HEAPU8[$32>>0]|(HEAPU8[$32+1>>0]<<8)|(HEAPU8[$32+2>>0]<<16)|(HEAPU8[$32+3>>0]<<24); //@line 58942 "c/sqlite3.c"
   $34 = (($31) + 4)|0; //@line 58942 "c/sqlite3.c"
   $35 = $34; //@line 58942 "c/sqlite3.c"
   $36 = HEAPU8[$35>>0]|(HEAPU8[$35+1>>0]<<8)|(HEAPU8[$35+2>>0]<<16)|(HEAPU8[$35+3>>0]<<24); //@line 58942 "c/sqlite3.c"
   $37 = $29; //@line 58942 "c/sqlite3.c"
   $38 = $37; //@line 58942 "c/sqlite3.c"
   HEAP8[$38>>0]=$33&255;HEAP8[$38+1>>0]=($33>>8)&255;HEAP8[$38+2>>0]=($33>>16)&255;HEAP8[$38+3>>0]=$33>>24; //@line 58942 "c/sqlite3.c"
   $39 = (($37) + 4)|0; //@line 58942 "c/sqlite3.c"
   $40 = $39; //@line 58942 "c/sqlite3.c"
   HEAP8[$40>>0]=$36&255;HEAP8[$40+1>>0]=($36>>8)&255;HEAP8[$40+2>>0]=($36>>16)&255;HEAP8[$40+3>>0]=$36>>24; //@line 58942 "c/sqlite3.c"
   _walChecksumBytes(1,$7,24,0,$8); //@line 58943 "c/sqlite3.c"
   $41 = ((($7)) + 24|0); //@line 58944 "c/sqlite3.c"
   $42 = HEAP32[$8>>2]|0; //@line 58944 "c/sqlite3.c"
   _sqlite3Put4byte($41,$42); //@line 58944 "c/sqlite3.c"
   $43 = ((($7)) + 28|0); //@line 58945 "c/sqlite3.c"
   $44 = ((($8)) + 4|0); //@line 58945 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 58945 "c/sqlite3.c"
   _sqlite3Put4byte($43,$45); //@line 58945 "c/sqlite3.c"
   $46 = ((($0)) + 36|0); //@line 58947 "c/sqlite3.c"
   HEAP32[$46>>2] = $1; //@line 58947 "c/sqlite3.c"
   $47 = ((($0)) + 65|0); //@line 58948 "c/sqlite3.c"
   HEAP8[$47>>0] = 0; //@line 58948 "c/sqlite3.c"
   $48 = ((($0)) + 76|0); //@line 58949 "c/sqlite3.c"
   HEAP32[$48>>2] = $42; //@line 58949 "c/sqlite3.c"
   $49 = ((($0)) + 80|0); //@line 58950 "c/sqlite3.c"
   HEAP32[$49>>2] = $45; //@line 58950 "c/sqlite3.c"
   $50 = ((($0)) + 47|0); //@line 58951 "c/sqlite3.c"
   HEAP8[$50>>0] = 1; //@line 58951 "c/sqlite3.c"
   $51 = ((($0)) + 8|0); //@line 58953 "c/sqlite3.c"
   $52 = HEAP32[$51>>2]|0; //@line 58953 "c/sqlite3.c"
   $53 = (_sqlite3OsWrite($52,$7,32,0,0)|0); //@line 58953 "c/sqlite3.c"
   $54 = ($53|0)==(0); //@line 58955 "c/sqlite3.c"
   do {
    if ($54) {
     $55 = ((($0)) + 48|0); //@line 58966 "c/sqlite3.c"
     $56 = HEAP8[$55>>0]|0; //@line 58966 "c/sqlite3.c"
     $57 = ($56<<24>>24)==(0); //@line 58966 "c/sqlite3.c"
     if (!($57)) {
      $58 = HEAP32[$51>>2]|0; //@line 58967 "c/sqlite3.c"
      $59 = $5 >>> 2; //@line 58967 "c/sqlite3.c"
      $60 = $59 & 3; //@line 58967 "c/sqlite3.c"
      $61 = (_sqlite3OsSync($58,$60)|0); //@line 58967 "c/sqlite3.c"
      $62 = ($61|0)==(0); //@line 58968 "c/sqlite3.c"
      if (!($62)) {
       $$1181$ph = $61;
       break;
      }
     }
     break L7;
    } else {
     $$1181$ph = $53;
    }
   } while(0);
   $$10 = $$1181$ph;
   STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
  }
 } while(0);
 HEAP32[$6>>2] = $0; //@line 58974 "c/sqlite3.c"
 $63 = ((($0)) + 8|0); //@line 58975 "c/sqlite3.c"
 $64 = HEAP32[$63>>2]|0; //@line 58975 "c/sqlite3.c"
 $65 = ((($6)) + 4|0); //@line 58975 "c/sqlite3.c"
 HEAP32[$65>>2] = $64; //@line 58975 "c/sqlite3.c"
 $66 = ((($6)) + 8|0); //@line 58976 "c/sqlite3.c"
 $67 = $66; //@line 58976 "c/sqlite3.c"
 $68 = $67; //@line 58976 "c/sqlite3.c"
 HEAP32[$68>>2] = 0; //@line 58976 "c/sqlite3.c"
 $69 = (($67) + 4)|0; //@line 58976 "c/sqlite3.c"
 $70 = $69; //@line 58976 "c/sqlite3.c"
 HEAP32[$70>>2] = 0; //@line 58976 "c/sqlite3.c"
 $71 = ((($6)) + 16|0); //@line 58977 "c/sqlite3.c"
 HEAP32[$71>>2] = $5; //@line 58977 "c/sqlite3.c"
 $72 = ((($6)) + 20|0); //@line 58978 "c/sqlite3.c"
 HEAP32[$72>>2] = $1; //@line 58978 "c/sqlite3.c"
 $73 = (($1) + 24)|0; //@line 58979 "c/sqlite3.c"
 $74 = ($73|0)<(0); //@line 58979 "c/sqlite3.c"
 $75 = $74 << 31 >> 31; //@line 58979 "c/sqlite3.c"
 $76 = (___muldi3(($19|0),0,($73|0),($75|0))|0); //@line 58979 "c/sqlite3.c"
 $77 = tempRet0; //@line 58979 "c/sqlite3.c"
 $78 = (_i64Add(($76|0),($77|0),32,0)|0); //@line 58979 "c/sqlite3.c"
 $79 = tempRet0; //@line 58979 "c/sqlite3.c"
 $80 = ($2|0)==(0|0); //@line 58983 "c/sqlite3.c"
 L20: do {
  if ($80) {
   $$0191$lcssa = $19;$$0204$lcssa = 0;$141 = $78;$142 = $79;
  } else {
   $81 = ($$0206|0)==(0);
   $82 = ($4|0)==(0);
   $83 = ($4|0)==(0);
   $84 = ((($0)) + 104|0);
   $$0191280 = $19;$$0196278 = $2;$$0204277 = 0;$111 = $78;$112 = $79;
   L22: while(1) {
    do {
     if ($81) {
      label = 23;
     } else {
      $85 = ((($$0196278)) + 16|0); //@line 58990 "c/sqlite3.c"
      $86 = HEAP32[$85>>2]|0; //@line 58990 "c/sqlite3.c"
      $87 = ($86|0)!=(0|0); //@line 58990 "c/sqlite3.c"
      $or$cond = $83 | $87; //@line 58990 "c/sqlite3.c"
      if (!($or$cond)) {
       $88 = (($$0191280) + 1)|0; //@line 59012 "c/sqlite3.c"
       $242 = $88;
       label = 24;
       break;
      }
      HEAP32[$7>>2] = 0; //@line 58991 "c/sqlite3.c"
      $89 = ((($$0196278)) + 24|0); //@line 58992 "c/sqlite3.c"
      $90 = HEAP32[$89>>2]|0; //@line 58992 "c/sqlite3.c"
      (_sqlite3WalFindFrame($0,$90,$7)|0); //@line 58992 "c/sqlite3.c"
      $91 = HEAP32[$7>>2]|0; //@line 58994 "c/sqlite3.c"
      $92 = ($91>>>0)<($$0206>>>0); //@line 58994 "c/sqlite3.c"
      if ($92) {
       label = 23;
       break;
      }
      $93 = (($91) + -1)|0; //@line 58995 "c/sqlite3.c"
      $94 = (___muldi3(($93|0),0,($73|0),($75|0))|0); //@line 58995 "c/sqlite3.c"
      $95 = tempRet0; //@line 58995 "c/sqlite3.c"
      $96 = (_i64Add(($94|0),($95|0),56,0)|0); //@line 58995 "c/sqlite3.c"
      $97 = tempRet0; //@line 58995 "c/sqlite3.c"
      $98 = HEAP32[$84>>2]|0; //@line 58997 "c/sqlite3.c"
      $99 = (($98) + -1)|0; //@line 58997 "c/sqlite3.c"
      $100 = ($99>>>0)<($91>>>0); //@line 58997 "c/sqlite3.c"
      if (!($100)) {
       HEAP32[$84>>2] = $91; //@line 58998 "c/sqlite3.c"
      }
      $101 = ((($$0196278)) + 4|0); //@line 59003 "c/sqlite3.c"
      $102 = HEAP32[$101>>2]|0; //@line 59003 "c/sqlite3.c"
      $103 = HEAP32[$63>>2]|0; //@line 59005 "c/sqlite3.c"
      $104 = (_sqlite3OsWrite($103,$102,$1,$96,$97)|0); //@line 59005 "c/sqlite3.c"
      $105 = ($104|0)==(0); //@line 59006 "c/sqlite3.c"
      if (!($105)) {
       break L22;
      }
      $120 = ((($$0196278)) + 28|0); //@line 59007 "c/sqlite3.c"
      $121 = HEAP16[$120>>1]|0; //@line 59007 "c/sqlite3.c"
      $122 = $121 & -65; //@line 59007 "c/sqlite3.c"
      HEAP16[$120>>1] = $122; //@line 59007 "c/sqlite3.c"
      $$1192227 = $$0191280;$$1205226 = $$0204277;$244 = $111;$245 = $112;
     }
    } while(0);
    if ((label|0) == 23) {
     label = 0;
     $106 = (($$0191280) + 1)|0; //@line 59012 "c/sqlite3.c"
     if ($82) {
      $110 = 0;$243 = $106;
      label = 25;
     } else {
      $242 = $106;
      label = 24;
     }
    }
    if ((label|0) == 24) {
     label = 0;
     $107 = ((($$0196278)) + 16|0); //@line 59014 "c/sqlite3.c"
     $108 = HEAP32[$107>>2]|0; //@line 59014 "c/sqlite3.c"
     $109 = ($108|0)==(0|0); //@line 59014 "c/sqlite3.c"
     $spec$select = $109 ? $3 : 0; //@line 59014 "c/sqlite3.c"
     $110 = $spec$select;$243 = $242;
     label = 25;
    }
    if ((label|0) == 25) {
     label = 0;
     $113 = (_walWriteOneFrame($6,$$0196278,$110,$111,$112)|0); //@line 59015 "c/sqlite3.c"
     $114 = ($113|0)==(0); //@line 59016 "c/sqlite3.c"
     $115 = ((($$0196278)) + 28|0); //@line 59019 "c/sqlite3.c"
     if (!($114)) {
      $$10 = $113;
      label = 55;
      break;
     }
     $116 = (_i64Add(($111|0),($112|0),($73|0),($75|0))|0); //@line 59018 "c/sqlite3.c"
     $117 = tempRet0; //@line 59018 "c/sqlite3.c"
     $118 = HEAP16[$115>>1]|0; //@line 59019 "c/sqlite3.c"
     $119 = $118 | 64; //@line 59019 "c/sqlite3.c"
     HEAP16[$115>>1] = $119; //@line 59019 "c/sqlite3.c"
     $$1192227 = $243;$$1205226 = $$0196278;$244 = $116;$245 = $117;
    }
    $123 = ((($$0196278)) + 16|0); //@line 58983 "c/sqlite3.c"
    $124 = HEAP32[$123>>2]|0; //@line 58983 "c/sqlite3.c"
    $125 = ($124|0)==(0|0); //@line 58983 "c/sqlite3.c"
    if ($125) {
     $$0191$lcssa = $$1192227;$$0204$lcssa = $$1205226;$141 = $244;$142 = $245;
     break L20;
    } else {
     $$0191280 = $$1192227;$$0196278 = $124;$$0204277 = $$1205226;$111 = $244;$112 = $245;
    }
   }
   if ((label|0) == 55) {
    STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
   }
   $$10 = $104;
   STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
  }
 } while(0);
 $126 = ($4|0)!=(0); //@line 59023 "c/sqlite3.c"
 do {
  if ($126) {
   $127 = ((($0)) + 104|0); //@line 59023 "c/sqlite3.c"
   $128 = HEAP32[$127>>2]|0; //@line 59023 "c/sqlite3.c"
   $129 = ($128|0)==(0); //@line 59023 "c/sqlite3.c"
   if (!($129)) {
    $130 = (_walRewriteChecksums($0,$$0191$lcssa)|0); //@line 59024 "c/sqlite3.c"
    $131 = ($130|0)==(0); //@line 59025 "c/sqlite3.c"
    if (!($131)) {
     $$10 = $130;
     STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
    }
   }
   $132 = $5 & 3; //@line 59042 "c/sqlite3.c"
   $133 = ($132|0)==(0); //@line 59042 "c/sqlite3.c"
   if ($133) {
    $$12246 = 0;$$3213243 = 0;
   } else {
    $134 = ((($0)) + 49|0); //@line 59044 "c/sqlite3.c"
    $135 = HEAP8[$134>>0]|0; //@line 59044 "c/sqlite3.c"
    $136 = ($135<<24>>24)==(0); //@line 59044 "c/sqlite3.c"
    if ($136) {
     $$1211237 = 0;
     label = 39;
    } else {
     $137 = HEAP32[$63>>2]|0; //@line 59045 "c/sqlite3.c"
     $138 = (_sqlite3SectorSize($137)|0); //@line 59045 "c/sqlite3.c"
     $139 = ($138|0)<(0); //@line 59046 "c/sqlite3.c"
     $140 = $139 << 31 >> 31; //@line 59046 "c/sqlite3.c"
     $143 = (_i64Add(($141|0),($142|0),-1,-1)|0); //@line 59046 "c/sqlite3.c"
     $144 = tempRet0; //@line 59046 "c/sqlite3.c"
     $145 = (_i64Add(($143|0),($144|0),($138|0),($140|0))|0); //@line 59046 "c/sqlite3.c"
     $146 = tempRet0; //@line 59046 "c/sqlite3.c"
     $147 = (___remdi3(($145|0),($146|0),($138|0),($140|0))|0); //@line 59046 "c/sqlite3.c"
     $148 = tempRet0; //@line 59046 "c/sqlite3.c"
     $149 = (_i64Subtract(($145|0),($146|0),($147|0),($148|0))|0); //@line 59046 "c/sqlite3.c"
     $150 = tempRet0; //@line 59046 "c/sqlite3.c"
     $151 = $66; //@line 59046 "c/sqlite3.c"
     $152 = $151; //@line 59046 "c/sqlite3.c"
     HEAP32[$152>>2] = $149; //@line 59046 "c/sqlite3.c"
     $153 = (($151) + 4)|0; //@line 59046 "c/sqlite3.c"
     $154 = $153; //@line 59046 "c/sqlite3.c"
     HEAP32[$154>>2] = $150; //@line 59046 "c/sqlite3.c"
     $155 = ($149|0)==($141|0); //@line 59047 "c/sqlite3.c"
     $156 = ($150|0)==($142|0); //@line 59047 "c/sqlite3.c"
     $157 = $155 & $156; //@line 59047 "c/sqlite3.c"
     $158 = ($142|0)<($150|0); //@line 59049 "c/sqlite3.c"
     $159 = ($141>>>0)<($149>>>0); //@line 59049 "c/sqlite3.c"
     $160 = ($142|0)==($150|0); //@line 59049 "c/sqlite3.c"
     $161 = $160 & $159; //@line 59049 "c/sqlite3.c"
     $162 = $158 | $161; //@line 59049 "c/sqlite3.c"
     L59: do {
      if ($162) {
       $$0210270 = 0;$163 = $141;$164 = $142;
       while(1) {
        $165 = (_walWriteOneFrame($6,$$0204$lcssa,$3,$163,$164)|0); //@line 59050 "c/sqlite3.c"
        $166 = ($165|0)==(0); //@line 59051 "c/sqlite3.c"
        if (!($166)) {
         $$10 = $165;
         break;
        }
        $167 = (_i64Add(($163|0),($164|0),($73|0),($75|0))|0); //@line 59052 "c/sqlite3.c"
        $168 = tempRet0; //@line 59052 "c/sqlite3.c"
        $169 = (($$0210270) + 1)|0; //@line 59053 "c/sqlite3.c"
        $170 = ($168|0)<($150|0); //@line 59049 "c/sqlite3.c"
        $171 = ($167>>>0)<($149>>>0); //@line 59049 "c/sqlite3.c"
        $172 = ($168|0)==($150|0); //@line 59049 "c/sqlite3.c"
        $173 = $172 & $171; //@line 59049 "c/sqlite3.c"
        $174 = $170 | $173; //@line 59049 "c/sqlite3.c"
        if ($174) {
         $$0210270 = $169;$163 = $167;$164 = $168;
        } else {
         $$0210$lcssa = $169;
         break L59;
        }
       }
       STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
      } else {
       $$0210$lcssa = 0;
      }
     } while(0);
     if ($157) {
      $$1211237 = $$0210$lcssa;
      label = 39;
     } else {
      $$11$ph = 0;$$2212$ph = $$0210$lcssa;
     }
    }
    if ((label|0) == 39) {
     $175 = HEAP32[$65>>2]|0; //@line 59058 "c/sqlite3.c"
     $176 = (_sqlite3OsSync($175,$132)|0); //@line 59058 "c/sqlite3.c"
     $$11$ph = $176;$$2212$ph = $$1211237;
    }
    if ($126) {
     $$12246 = $$11$ph;$$3213243 = $$2212$ph;
    } else {
     $$12245 = $$11$ph;$$3213244 = $$2212$ph;
     break;
    }
   }
   $177 = ((($0)) + 47|0); //@line 59066 "c/sqlite3.c"
   $178 = HEAP8[$177>>0]|0; //@line 59066 "c/sqlite3.c"
   $179 = ($178<<24>>24)==(0); //@line 59066 "c/sqlite3.c"
   if ($179) {
    $$12245 = $$12246;$$3213244 = $$3213243;
   } else {
    $180 = ((($0)) + 16|0); //@line 59066 "c/sqlite3.c"
    $181 = $180; //@line 59066 "c/sqlite3.c"
    $182 = $181; //@line 59066 "c/sqlite3.c"
    $183 = HEAP32[$182>>2]|0; //@line 59066 "c/sqlite3.c"
    $184 = (($181) + 4)|0; //@line 59066 "c/sqlite3.c"
    $185 = $184; //@line 59066 "c/sqlite3.c"
    $186 = HEAP32[$185>>2]|0; //@line 59066 "c/sqlite3.c"
    $187 = ($186|0)>(-1); //@line 59066 "c/sqlite3.c"
    $188 = ($183>>>0)>(4294967295); //@line 59066 "c/sqlite3.c"
    $189 = ($186|0)==(-1); //@line 59066 "c/sqlite3.c"
    $190 = $189 & $188; //@line 59066 "c/sqlite3.c"
    $191 = $187 | $190; //@line 59066 "c/sqlite3.c"
    $192 = (($$3213243) + ($$0191$lcssa))|0; //@line 59068 "c/sqlite3.c"
    $193 = (___muldi3(($192|0),0,($73|0),($75|0))|0); //@line 59068 "c/sqlite3.c"
    $194 = tempRet0; //@line 59068 "c/sqlite3.c"
    $195 = (_i64Add(($193|0),($194|0),32,0)|0); //@line 59068 "c/sqlite3.c"
    $196 = tempRet0; //@line 59068 "c/sqlite3.c"
    if ($191) {
     $197 = ($196|0)>($186|0); //@line 59068 "c/sqlite3.c"
     $198 = ($195>>>0)>($183>>>0); //@line 59068 "c/sqlite3.c"
     $199 = ($196|0)==($186|0); //@line 59068 "c/sqlite3.c"
     $200 = $199 & $198; //@line 59068 "c/sqlite3.c"
     $201 = $197 | $200; //@line 59068 "c/sqlite3.c"
     $202 = $201 ? $195 : $183; //@line 59068 "c/sqlite3.c"
     $203 = $201 ? $196 : $186; //@line 59068 "c/sqlite3.c"
     _walLimitSize($0,$202,$203); //@line 59071 "c/sqlite3.c"
     HEAP8[$177>>0] = 0; //@line 59072 "c/sqlite3.c"
     $$12245 = $$12246;$$3213244 = $$3213243;
    } else {
     $$12245 = $$12246;$$3213244 = $$3213243;
    }
   }
  } else {
   $$12245 = 0;$$3213244 = 0;
  }
 } while(0);
 $204 = HEAP32[$18>>2]|0; //@line 59080 "c/sqlite3.c"
 $205 = ($2|0)!=(0|0); //@line 59081 "c/sqlite3.c"
 $206 = ($$12245|0)==(0); //@line 59081 "c/sqlite3.c"
 $207 = $205 & $206; //@line 59081 "c/sqlite3.c"
 if ($207) {
  $$1197264 = $2;$$2193265 = $204;
  while(1) {
   $208 = ((($$1197264)) + 28|0); //@line 59082 "c/sqlite3.c"
   $209 = HEAP16[$208>>1]|0; //@line 59082 "c/sqlite3.c"
   $210 = $209 & 64; //@line 59082 "c/sqlite3.c"
   $211 = ($210<<16>>16)==(0); //@line 59082 "c/sqlite3.c"
   $212 = (($$2193265) + 1)|0; //@line 59083 "c/sqlite3.c"
   if ($211) {
    $$14 = 0;$$3194 = $$2193265;
   } else {
    $213 = ((($$1197264)) + 24|0); //@line 59084 "c/sqlite3.c"
    $214 = HEAP32[$213>>2]|0; //@line 59084 "c/sqlite3.c"
    $215 = (_walIndexAppend($0,$212,$214)|0); //@line 59084 "c/sqlite3.c"
    $$14 = $215;$$3194 = $212;
   }
   $216 = ((($$1197264)) + 16|0); //@line 59081 "c/sqlite3.c"
   $217 = HEAP32[$216>>2]|0; //@line 59081 "c/sqlite3.c"
   $218 = ($217|0)!=(0|0); //@line 59081 "c/sqlite3.c"
   $219 = ($$14|0)==(0); //@line 59081 "c/sqlite3.c"
   $220 = $218 & $219; //@line 59081 "c/sqlite3.c"
   if ($220) {
    $$1197264 = $217;$$2193265 = $$3194;
   } else {
    $$13$lcssa = $$14;$$2193$lcssa = $$3194;
    break;
   }
  }
 } else {
  $$13$lcssa = $$12245;$$2193$lcssa = $204;
 }
 $221 = ($$13$lcssa|0)==(0); //@line 59086 "c/sqlite3.c"
 $222 = ($$3213244|0)>(0); //@line 59086 "c/sqlite3.c"
 $223 = $222 & $221; //@line 59086 "c/sqlite3.c"
 if ($223) {
  $224 = ((($$0204$lcssa)) + 24|0);
  $$4195261 = $$2193$lcssa;$$4214260 = $$3213244;
  while(1) {
   $225 = (($$4195261) + 1)|0; //@line 59087 "c/sqlite3.c"
   $226 = (($$4214260) + -1)|0; //@line 59088 "c/sqlite3.c"
   $227 = HEAP32[$224>>2]|0; //@line 59089 "c/sqlite3.c"
   $228 = (_walIndexAppend($0,$225,$227)|0); //@line 59089 "c/sqlite3.c"
   $229 = ($228|0)==(0); //@line 59086 "c/sqlite3.c"
   $230 = ($$4214260|0)>(1); //@line 59086 "c/sqlite3.c"
   $231 = $230 & $229; //@line 59086 "c/sqlite3.c"
   if ($231) {
    $$4195261 = $225;$$4214260 = $226;
   } else {
    $$15$lcssa = $228;$$4195$lcssa = $225;$$lcssa = $229;
    break;
   }
  }
 } else {
  $$15$lcssa = $$13$lcssa;$$4195$lcssa = $$2193$lcssa;$$lcssa = $221;
 }
 if (!($$lcssa)) {
  $$10 = $$15$lcssa;
  STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
 }
 $232 = $1 & 65280; //@line 59094 "c/sqlite3.c"
 $233 = $1 >>> 16; //@line 59094 "c/sqlite3.c"
 $234 = $232 | $233; //@line 59094 "c/sqlite3.c"
 $235 = $234&65535; //@line 59094 "c/sqlite3.c"
 $236 = ((($0)) + 66|0); //@line 59094 "c/sqlite3.c"
 HEAP16[$236>>1] = $235; //@line 59094 "c/sqlite3.c"
 HEAP32[$18>>2] = $$4195$lcssa; //@line 59097 "c/sqlite3.c"
 if (!($126)) {
  $$10 = 0;
  STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
 }
 $237 = ((($0)) + 60|0); //@line 59099 "c/sqlite3.c"
 $238 = HEAP32[$237>>2]|0; //@line 59099 "c/sqlite3.c"
 $239 = (($238) + 1)|0; //@line 59099 "c/sqlite3.c"
 HEAP32[$237>>2] = $239; //@line 59099 "c/sqlite3.c"
 $240 = ((($0)) + 72|0); //@line 59100 "c/sqlite3.c"
 HEAP32[$240>>2] = $3; //@line 59100 "c/sqlite3.c"
 _walIndexWriteHdr($0); //@line 59104 "c/sqlite3.c"
 $241 = ((($0)) + 12|0); //@line 59105 "c/sqlite3.c"
 HEAP32[$241>>2] = $$4195$lcssa; //@line 59105 "c/sqlite3.c"
 $$10 = 0;
 STACKTOP = sp;return ($$10|0); //@line 59111 "c/sqlite3.c"
}
function _walRestartLog($0) {
 $0 = $0|0;
 var $$025 = 0, $$3 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 40|0); //@line 58720 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 58720 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 58720 "c/sqlite3.c"
 if (!($4)) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 58756 "c/sqlite3.c"
 }
 $5 = (_walCkptInfo($0)|0); //@line 58721 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 58723 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 58723 "c/sqlite3.c"
 if (!($7)) {
  _sqlite3_randomness(4,$1); //@line 58725 "c/sqlite3.c"
  $8 = (_walLockExclusive($0,4,4)|0); //@line 58726 "c/sqlite3.c"
  switch ($8|0) {
  case 0:  {
   $9 = HEAP32[$1>>2]|0; //@line 58737 "c/sqlite3.c"
   _walRestartHdr($0,$9); //@line 58737 "c/sqlite3.c"
   _walUnlockExclusive($0,4,4); //@line 58738 "c/sqlite3.c"
   break;
  }
  case 5:  {
   break;
  }
  default: {
   $$3 = $8;
   STACKTOP = sp;return ($$3|0); //@line 58756 "c/sqlite3.c"
  }
  }
 }
 _walUnlockShared($0,3); //@line 58743 "c/sqlite3.c"
 HEAP16[$2>>1] = -1; //@line 58744 "c/sqlite3.c"
 $$025 = 0;
 while(1) {
  $10 = (($$025) + 1)|0; //@line 58748 "c/sqlite3.c"
  $11 = (_walTryBeginRead($0,$1,1,$10)|0); //@line 58748 "c/sqlite3.c"
  $12 = ($11|0)==(-1); //@line 58749 "c/sqlite3.c"
  if ($12) {
   $$025 = $10;
  } else {
   $$3 = $11;
   break;
  }
 }
 STACKTOP = sp;return ($$3|0); //@line 58756 "c/sqlite3.c"
}
function _walChecksumBytes($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$040 = 0, $$042 = 0, $$1 = 0, $$141 = 0, $$143 = 0, $$2 = 0, $$244 = 0, $$3 = 0, $$345 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (($1) + ($2)|0); //@line 56247 "c/sqlite3.c"
 $6 = ($3|0)==(0|0); //@line 56249 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;$$042 = 0;
 } else {
  $7 = HEAP32[$3>>2]|0; //@line 56250 "c/sqlite3.c"
  $8 = ((($3)) + 4|0); //@line 56251 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 56251 "c/sqlite3.c"
  $$0 = $7;$$042 = $9;
 }
 $10 = ($0|0)==(0); //@line 56259 "c/sqlite3.c"
 if ($10) {
  $$141 = $1;$$2 = $$0;$$244 = $$042;
  while(1) {
   $20 = HEAP32[$$141>>2]|0; //@line 56266 "c/sqlite3.c"
   $21 = (_llvm_bswap_i32(($20|0))|0); //@line 56266 "c/sqlite3.c"
   $22 = (($$2) + ($$244))|0; //@line 56266 "c/sqlite3.c"
   $23 = (($22) + ($21))|0; //@line 56266 "c/sqlite3.c"
   $24 = ((($$141)) + 4|0); //@line 56267 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 56267 "c/sqlite3.c"
   $26 = (_llvm_bswap_i32(($25|0))|0); //@line 56267 "c/sqlite3.c"
   $27 = (($26) + ($$244))|0; //@line 56267 "c/sqlite3.c"
   $28 = (($27) + ($23))|0; //@line 56267 "c/sqlite3.c"
   $29 = ((($$141)) + 8|0); //@line 56268 "c/sqlite3.c"
   $30 = ($29>>>0)<($5>>>0); //@line 56269 "c/sqlite3.c"
   if ($30) {
    $$141 = $29;$$2 = $23;$$244 = $28;
   } else {
    $$3 = $23;$$345 = $28;
    break;
   }
  }
  HEAP32[$4>>2] = $$3; //@line 56272 "c/sqlite3.c"
  $31 = ((($4)) + 4|0); //@line 56273 "c/sqlite3.c"
  HEAP32[$31>>2] = $$345; //@line 56273 "c/sqlite3.c"
  return; //@line 56274 "c/sqlite3.c"
 } else {
  $$040 = $1;$$1 = $$0;$$143 = $$042;
  while(1) {
   $11 = ((($$040)) + 4|0); //@line 56261 "c/sqlite3.c"
   $12 = HEAP32[$$040>>2]|0; //@line 56261 "c/sqlite3.c"
   $13 = (($$1) + ($$143))|0; //@line 56261 "c/sqlite3.c"
   $14 = (($13) + ($12))|0; //@line 56261 "c/sqlite3.c"
   $15 = ((($$040)) + 8|0); //@line 56262 "c/sqlite3.c"
   $16 = HEAP32[$11>>2]|0; //@line 56262 "c/sqlite3.c"
   $17 = (($16) + ($$143))|0; //@line 56262 "c/sqlite3.c"
   $18 = (($17) + ($14))|0; //@line 56262 "c/sqlite3.c"
   $19 = ($15>>>0)<($5>>>0); //@line 56263 "c/sqlite3.c"
   if ($19) {
    $$040 = $15;$$1 = $14;$$143 = $18;
   } else {
    $$3 = $14;$$345 = $18;
    break;
   }
  }
  HEAP32[$4>>2] = $$3; //@line 56272 "c/sqlite3.c"
  $31 = ((($4)) + 4|0); //@line 56273 "c/sqlite3.c"
  HEAP32[$31>>2] = $$345; //@line 56273 "c/sqlite3.c"
  return; //@line 56274 "c/sqlite3.c"
 }
}
function _walWriteOneFrame($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $5 = sp;
 $6 = ((($1)) + 4|0); //@line 58816 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 58816 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 58818 "c/sqlite3.c"
 $9 = ((($1)) + 24|0); //@line 58818 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 58818 "c/sqlite3.c"
 _walEncodeFrame($8,$10,$2,$7,$5); //@line 58818 "c/sqlite3.c"
 $11 = (_walWriteToLog($0,$5,24,$3,$4)|0); //@line 58819 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 58820 "c/sqlite3.c"
 if (!($12)) {
  $$0 = $11;
  STACKTOP = sp;return ($$0|0); //@line 58824 "c/sqlite3.c"
 }
 $13 = (_i64Add(($3|0),($4|0),24,0)|0); //@line 58822 "c/sqlite3.c"
 $14 = tempRet0; //@line 58822 "c/sqlite3.c"
 $15 = ((($0)) + 20|0); //@line 58822 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 58822 "c/sqlite3.c"
 $17 = (_walWriteToLog($0,$7,$16,$13,$14)|0); //@line 58822 "c/sqlite3.c"
 $$0 = $17;
 STACKTOP = sp;return ($$0|0); //@line 58824 "c/sqlite3.c"
}
function _walRewriteChecksums($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$051$lcssa = 0, $$05255 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond54 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = ((($0)) + 36|0); //@line 58835 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 58835 "c/sqlite3.c"
 $5 = (($4) + 24)|0; //@line 58842 "c/sqlite3.c"
 $6 = (_sqlite3_malloc($5)|0); //@line 58842 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 58843 "c/sqlite3.c"
 if ($7) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 58877 "c/sqlite3.c"
 }
 $8 = ((($0)) + 104|0); //@line 58851 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 58851 "c/sqlite3.c"
 $10 = ($9|0)==(1); //@line 58851 "c/sqlite3.c"
 $11 = (($9) + -2)|0; //@line 58854 "c/sqlite3.c"
 $12 = ($5|0)<(0); //@line 58854 "c/sqlite3.c"
 $13 = $12 << 31 >> 31; //@line 58854 "c/sqlite3.c"
 $14 = (___muldi3(($11|0),0,($5|0),($13|0))|0); //@line 58854 "c/sqlite3.c"
 $15 = tempRet0; //@line 58854 "c/sqlite3.c"
 $16 = (_i64Add(($14|0),($15|0),48,0)|0); //@line 58854 "c/sqlite3.c"
 $17 = tempRet0; //@line 58854 "c/sqlite3.c"
 $18 = $10 ? 24 : $16; //@line 58851 "c/sqlite3.c"
 $19 = $10 ? 0 : $17; //@line 58851 "c/sqlite3.c"
 $20 = ((($0)) + 8|0); //@line 58856 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 58856 "c/sqlite3.c"
 $22 = (_sqlite3OsRead($21,$6,8,$18,$19)|0); //@line 58856 "c/sqlite3.c"
 $23 = (_sqlite3Get4byte($6)|0); //@line 58857 "c/sqlite3.c"
 $24 = ((($0)) + 76|0); //@line 58857 "c/sqlite3.c"
 HEAP32[$24>>2] = $23; //@line 58857 "c/sqlite3.c"
 $25 = ((($6)) + 4|0); //@line 58858 "c/sqlite3.c"
 $26 = (_sqlite3Get4byte($25)|0); //@line 58858 "c/sqlite3.c"
 $27 = ((($0)) + 80|0); //@line 58858 "c/sqlite3.c"
 HEAP32[$27>>2] = $26; //@line 58858 "c/sqlite3.c"
 $28 = HEAP32[$8>>2]|0; //@line 58860 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 58861 "c/sqlite3.c"
 $29 = ($22|0)!=(0); //@line 58862 "c/sqlite3.c"
 $30 = ($28>>>0)>($1>>>0); //@line 58862 "c/sqlite3.c"
 $or$cond54 = $30 | $29; //@line 58862 "c/sqlite3.c"
 L4: do {
  if ($or$cond54) {
   $$051$lcssa = $22;
  } else {
   $31 = ($5|0)<(0);
   $32 = $31 << 31 >> 31;
   $33 = ((($6)) + 24|0);
   $$05255 = $28;
   while(1) {
    $34 = (($$05255) + -1)|0; //@line 58863 "c/sqlite3.c"
    $35 = (___muldi3(($34|0),0,($5|0),($32|0))|0); //@line 58863 "c/sqlite3.c"
    $36 = tempRet0; //@line 58863 "c/sqlite3.c"
    $37 = (_i64Add(($35|0),($36|0),32,0)|0); //@line 58863 "c/sqlite3.c"
    $38 = tempRet0; //@line 58863 "c/sqlite3.c"
    $39 = HEAP32[$20>>2]|0; //@line 58864 "c/sqlite3.c"
    $40 = (_sqlite3OsRead($39,$6,$5,$37,$38)|0); //@line 58864 "c/sqlite3.c"
    $41 = ($40|0)==(0); //@line 58865 "c/sqlite3.c"
    if (!($41)) {
     $$051$lcssa = $40;
     break L4;
    }
    $42 = (_sqlite3Get4byte($6)|0); //@line 58867 "c/sqlite3.c"
    $43 = (_sqlite3Get4byte($25)|0); //@line 58868 "c/sqlite3.c"
    _walEncodeFrame($0,$42,$43,$33,$2); //@line 58870 "c/sqlite3.c"
    $44 = HEAP32[$20>>2]|0; //@line 58871 "c/sqlite3.c"
    $45 = (_sqlite3OsWrite($44,$2,24,$37,$38)|0); //@line 58871 "c/sqlite3.c"
    $46 = (($$05255) + 1)|0; //@line 58862 "c/sqlite3.c"
    $47 = ($45|0)!=(0); //@line 58862 "c/sqlite3.c"
    $48 = ($46>>>0)>($1>>>0); //@line 58862 "c/sqlite3.c"
    $or$cond = $48 | $47; //@line 58862 "c/sqlite3.c"
    if ($or$cond) {
     $$051$lcssa = $45;
     break;
    } else {
     $$05255 = $46;
    }
   }
  }
 } while(0);
 _sqlite3_free($6); //@line 58875 "c/sqlite3.c"
 $$0 = $$051$lcssa;
 STACKTOP = sp;return ($$0|0); //@line 58877 "c/sqlite3.c"
}
function _walLimitSize($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp + 8|0;
 $3 = sp;
 _sqlite3BeginBenignMalloc(); //@line 57541 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 57542 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 57542 "c/sqlite3.c"
 $6 = (_sqlite3OsFileSize($5,$3)|0); //@line 57542 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 57543 "c/sqlite3.c"
 $8 = $3; //@line 57543 "c/sqlite3.c"
 $9 = $8; //@line 57543 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 57543 "c/sqlite3.c"
 $11 = (($8) + 4)|0; //@line 57543 "c/sqlite3.c"
 $12 = $11; //@line 57543 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 57543 "c/sqlite3.c"
 $14 = ($13|0)>($2|0); //@line 57543 "c/sqlite3.c"
 $15 = ($10>>>0)>($1>>>0); //@line 57543 "c/sqlite3.c"
 $16 = ($13|0)==($2|0); //@line 57543 "c/sqlite3.c"
 $17 = $16 & $15; //@line 57543 "c/sqlite3.c"
 $18 = $14 | $17; //@line 57543 "c/sqlite3.c"
 $or$cond = $7 & $18; //@line 57543 "c/sqlite3.c"
 if ($or$cond) {
  $19 = HEAP32[$4>>2]|0; //@line 57544 "c/sqlite3.c"
  $20 = (_sqlite3OsTruncate($19,$1,$2)|0); //@line 57544 "c/sqlite3.c"
  $$0 = $20;
 } else {
  $$0 = $6;
 }
 _sqlite3EndBenignMalloc(); //@line 57546 "c/sqlite3.c"
 $21 = ($$0|0)==(0); //@line 57547 "c/sqlite3.c"
 if ($21) {
  STACKTOP = sp;return; //@line 57550 "c/sqlite3.c"
 }
 $22 = ((($0)) + 108|0); //@line 57548 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 57548 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $23; //@line 57548 "c/sqlite3.c"
 _sqlite3_log($$0,18379,$vararg_buffer); //@line 57548 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 57550 "c/sqlite3.c"
}
function _walIndexAppend($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02933 = 0, $$03032 = 0, $$1 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 8|0;
 $4 = sp + 4|0;
 $5 = sp;
 HEAP32[$3>>2] = 0; //@line 56621 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 56622 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 56623 "c/sqlite3.c"
 $6 = (_walFramePage($1)|0); //@line 56625 "c/sqlite3.c"
 $7 = (_walHashGet($0,$6,$5,$4,$3)|0); //@line 56625 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 56630 "c/sqlite3.c"
 if (!($8)) {
  $$1 = $7;
  STACKTOP = sp;return ($$1|0); //@line 56695 "c/sqlite3.c"
 }
 $9 = HEAP32[$3>>2]|0; //@line 56635 "c/sqlite3.c"
 $10 = (($1) - ($9))|0; //@line 56635 "c/sqlite3.c"
 $11 = ($10|0)==(1); //@line 56641 "c/sqlite3.c"
 if ($11) {
  $12 = HEAP32[$5>>2]|0; //@line 56642 "c/sqlite3.c"
  $13 = ((($12)) + 16384|0); //@line 56642 "c/sqlite3.c"
  $14 = HEAP32[$4>>2]|0; //@line 56642 "c/sqlite3.c"
  $15 = ((($14)) + 4|0); //@line 56642 "c/sqlite3.c"
  $16 = $13; //@line 56642 "c/sqlite3.c"
  $17 = $15; //@line 56642 "c/sqlite3.c"
  $18 = (($16) - ($17))|0; //@line 56642 "c/sqlite3.c"
  _memset(($15|0),0,($18|0))|0; //@line 56643 "c/sqlite3.c"
 }
 $19 = HEAP32[$4>>2]|0; //@line 56652 "c/sqlite3.c"
 $20 = (($19) + ($10<<2)|0); //@line 56652 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 56652 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 56652 "c/sqlite3.c"
 if (!($22)) {
  _walCleanupHash($0); //@line 56653 "c/sqlite3.c"
 }
 $23 = (_walHash($2)|0); //@line 56659 "c/sqlite3.c"
 $24 = HEAP32[$5>>2]|0; //@line 56659 "c/sqlite3.c"
 $25 = (($24) + ($23<<1)|0); //@line 56659 "c/sqlite3.c"
 $26 = HEAP16[$25>>1]|0; //@line 56659 "c/sqlite3.c"
 $27 = ($26<<16>>16)==(0); //@line 56659 "c/sqlite3.c"
 L10: do {
  if ($27) {
   $$lcssa = $25;
  } else {
   $28 = HEAP32[$5>>2]|0;
   $$02933 = $10;$$03032 = $23;
   while(1) {
    $29 = ($$02933|0)==(0); //@line 56660 "c/sqlite3.c"
    if ($29) {
     break;
    }
    $30 = (($$02933) + -1)|0; //@line 56660 "c/sqlite3.c"
    $31 = (_walNextHash($$03032)|0); //@line 56659 "c/sqlite3.c"
    $32 = (($28) + ($31<<1)|0); //@line 56659 "c/sqlite3.c"
    $33 = HEAP16[$32>>1]|0; //@line 56659 "c/sqlite3.c"
    $34 = ($33<<16>>16)==(0); //@line 56659 "c/sqlite3.c"
    if ($34) {
     $$lcssa = $32;
     break L10;
    } else {
     $$02933 = $30;$$03032 = $31;
    }
   }
   $36 = (_sqlite3CorruptError(56660)|0); //@line 56660 "c/sqlite3.c"
   $$1 = $36;
   STACKTOP = sp;return ($$1|0); //@line 56695 "c/sqlite3.c"
  }
 } while(0);
 HEAP32[$20>>2] = $2; //@line 56662 "c/sqlite3.c"
 $35 = $10&65535; //@line 56663 "c/sqlite3.c"
 HEAP16[$$lcssa>>1] = $35; //@line 56663 "c/sqlite3.c"
 $$1 = $7;
 STACKTOP = sp;return ($$1|0); //@line 56695 "c/sqlite3.c"
}
function _walIndexWriteHdr($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 $1 = (_walIndexHdr($0)|0); //@line 56288 "c/sqlite3.c"
 $2 = ((($0)) + 52|0); //@line 56292 "c/sqlite3.c"
 $3 = ((($0)) + 64|0); //@line 56292 "c/sqlite3.c"
 HEAP8[$3>>0] = 1; //@line 56292 "c/sqlite3.c"
 HEAP32[$2>>2] = 3007000; //@line 56293 "c/sqlite3.c"
 $4 = ((($0)) + 92|0); //@line 56294 "c/sqlite3.c"
 _walChecksumBytes(1,$2,40,0,$4); //@line 56294 "c/sqlite3.c"
 $5 = ((($1)) + 48|0); //@line 56295 "c/sqlite3.c"
 dest=$5; src=$2; stop=dest+48|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 56295 "c/sqlite3.c"
 _walShmBarrier($0); //@line 56296 "c/sqlite3.c"
 dest=$1; src=$2; stop=dest+48|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 56297 "c/sqlite3.c"
 return; //@line 56298 "c/sqlite3.c"
}
function _walShmBarrier($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 43|0); //@line 56277 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 56277 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(2); //@line 56277 "c/sqlite3.c"
 if ($3) {
  return; //@line 56280 "c/sqlite3.c"
 }
 $4 = ((($0)) + 4|0); //@line 56278 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 56278 "c/sqlite3.c"
 _sqlite3OsShmBarrier($5); //@line 56278 "c/sqlite3.c"
 return; //@line 56280 "c/sqlite3.c"
}
function _sqlite3OsShmBarrier($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 20971 "c/sqlite3.c"
 $2 = ((($1)) + 60|0); //@line 20971 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 20971 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$3 & 127]($0); //@line 20971 "c/sqlite3.c"
 return; //@line 20972 "c/sqlite3.c"
}
function _walEncodeFrame($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 76|0); //@line 56321 "c/sqlite3.c"
 _sqlite3Put4byte($4,$1); //@line 56323 "c/sqlite3.c"
 $6 = ((($4)) + 4|0); //@line 56324 "c/sqlite3.c"
 _sqlite3Put4byte($6,$2); //@line 56324 "c/sqlite3.c"
 $7 = ((($0)) + 104|0); //@line 56325 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 56325 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 56325 "c/sqlite3.c"
 $10 = ((($4)) + 8|0);
 if ($9) {
  $11 = ((($0)) + 84|0); //@line 56326 "c/sqlite3.c"
  $12 = $11; //@line 56326 "c/sqlite3.c"
  $13 = $12; //@line 56326 "c/sqlite3.c"
  $14 = HEAPU8[$13>>0]|(HEAPU8[$13+1>>0]<<8)|(HEAPU8[$13+2>>0]<<16)|(HEAPU8[$13+3>>0]<<24); //@line 56326 "c/sqlite3.c"
  $15 = (($12) + 4)|0; //@line 56326 "c/sqlite3.c"
  $16 = $15; //@line 56326 "c/sqlite3.c"
  $17 = HEAPU8[$16>>0]|(HEAPU8[$16+1>>0]<<8)|(HEAPU8[$16+2>>0]<<16)|(HEAPU8[$16+3>>0]<<24); //@line 56326 "c/sqlite3.c"
  $18 = $10; //@line 56326 "c/sqlite3.c"
  $19 = $18; //@line 56326 "c/sqlite3.c"
  HEAP8[$19>>0]=$14&255;HEAP8[$19+1>>0]=($14>>8)&255;HEAP8[$19+2>>0]=($14>>16)&255;HEAP8[$19+3>>0]=$14>>24; //@line 56326 "c/sqlite3.c"
  $20 = (($18) + 4)|0; //@line 56326 "c/sqlite3.c"
  $21 = $20; //@line 56326 "c/sqlite3.c"
  HEAP8[$21>>0]=$17&255;HEAP8[$21+1>>0]=($17>>8)&255;HEAP8[$21+2>>0]=($17>>16)&255;HEAP8[$21+3>>0]=$17>>24; //@line 56326 "c/sqlite3.c"
  $22 = ((($0)) + 65|0); //@line 56328 "c/sqlite3.c"
  $23 = HEAP8[$22>>0]|0; //@line 56328 "c/sqlite3.c"
  $24 = ($23<<24>>24)==(0); //@line 56328 "c/sqlite3.c"
  $25 = $24&1; //@line 56328 "c/sqlite3.c"
  _walChecksumBytes($25,$4,8,$5,$5); //@line 56329 "c/sqlite3.c"
  $26 = ((($0)) + 36|0); //@line 56330 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 56330 "c/sqlite3.c"
  _walChecksumBytes($25,$3,$27,$5,$5); //@line 56330 "c/sqlite3.c"
  $28 = ((($4)) + 16|0); //@line 56332 "c/sqlite3.c"
  $29 = HEAP32[$5>>2]|0; //@line 56332 "c/sqlite3.c"
  _sqlite3Put4byte($28,$29); //@line 56332 "c/sqlite3.c"
  $30 = ((($4)) + 20|0); //@line 56333 "c/sqlite3.c"
  $31 = ((($0)) + 80|0); //@line 56333 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 56333 "c/sqlite3.c"
  _sqlite3Put4byte($30,$32); //@line 56333 "c/sqlite3.c"
  return; //@line 56337 "c/sqlite3.c"
 } else {
  dest=$10; stop=dest+16|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 56335 "c/sqlite3.c"
  return; //@line 56337 "c/sqlite3.c"
 }
}
function _walWriteToLog($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$1 = 0, $$138 = 0, $$140 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $not$or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 8|0); //@line 58786 "c/sqlite3.c"
 $6 = $5; //@line 58786 "c/sqlite3.c"
 $7 = $6; //@line 58786 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 58786 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 58786 "c/sqlite3.c"
 $10 = $9; //@line 58786 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 58786 "c/sqlite3.c"
 $12 = ($11|0)>($4|0); //@line 58786 "c/sqlite3.c"
 $13 = ($8>>>0)>($3>>>0); //@line 58786 "c/sqlite3.c"
 $14 = ($11|0)==($4|0); //@line 58786 "c/sqlite3.c"
 $15 = $14 & $13; //@line 58786 "c/sqlite3.c"
 $16 = $12 | $15; //@line 58786 "c/sqlite3.c"
 if ($16) {
  $17 = ($2|0)<(0); //@line 58786 "c/sqlite3.c"
  $18 = $17 << 31 >> 31; //@line 58786 "c/sqlite3.c"
  $19 = (_i64Add(($2|0),($18|0),($3|0),($4|0))|0); //@line 58786 "c/sqlite3.c"
  $20 = tempRet0; //@line 58786 "c/sqlite3.c"
  $21 = ($20|0)<($11|0); //@line 58786 "c/sqlite3.c"
  $22 = ($19>>>0)<($8>>>0); //@line 58786 "c/sqlite3.c"
  $23 = ($20|0)==($11|0); //@line 58786 "c/sqlite3.c"
  $24 = $23 & $22; //@line 58786 "c/sqlite3.c"
  $25 = $21 | $24; //@line 58786 "c/sqlite3.c"
  if ($25) {
   $$138 = $2;$$140 = $1;$47 = $3;$48 = $4;
  } else {
   $26 = (_i64Subtract(($8|0),($11|0),($3|0),($4|0))|0); //@line 58787 "c/sqlite3.c"
   $27 = tempRet0; //@line 58787 "c/sqlite3.c"
   $28 = ((($0)) + 4|0); //@line 58788 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 58788 "c/sqlite3.c"
   $30 = (_sqlite3OsWrite($29,$1,$26,$3,$4)|0); //@line 58788 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 58789 "c/sqlite3.c"
   if (!($31)) {
    $$1 = $30;
    return ($$1|0); //@line 58799 "c/sqlite3.c"
   }
   $32 = ($26|0)<(0); //@line 58790 "c/sqlite3.c"
   $33 = $32 << 31 >> 31; //@line 58790 "c/sqlite3.c"
   $34 = (_i64Add(($26|0),($33|0),($3|0),($4|0))|0); //@line 58790 "c/sqlite3.c"
   $35 = tempRet0; //@line 58790 "c/sqlite3.c"
   $36 = (($2) - ($26))|0; //@line 58791 "c/sqlite3.c"
   $37 = (($1) + ($26)|0); //@line 58792 "c/sqlite3.c"
   $38 = HEAP32[$28>>2]|0; //@line 58794 "c/sqlite3.c"
   $39 = ((($0)) + 16|0); //@line 58794 "c/sqlite3.c"
   $40 = HEAP32[$39>>2]|0; //@line 58794 "c/sqlite3.c"
   $41 = $40 & 3; //@line 58794 "c/sqlite3.c"
   $42 = (_sqlite3OsSync($38,$41)|0); //@line 58794 "c/sqlite3.c"
   $43 = ($36|0)!=(0); //@line 58795 "c/sqlite3.c"
   $44 = ($42|0)==(0); //@line 58795 "c/sqlite3.c"
   $not$or$cond = $43 & $44; //@line 58795 "c/sqlite3.c"
   if ($not$or$cond) {
    $$138 = $36;$$140 = $37;$47 = $34;$48 = $35;
   } else {
    $$1 = $42;
    return ($$1|0); //@line 58799 "c/sqlite3.c"
   }
  }
 } else {
  $$138 = $2;$$140 = $1;$47 = $3;$48 = $4;
 }
 $45 = ((($0)) + 4|0); //@line 58797 "c/sqlite3.c"
 $46 = HEAP32[$45>>2]|0; //@line 58797 "c/sqlite3.c"
 $49 = (_sqlite3OsWrite($46,$$140,$$138,$47,$48)|0); //@line 58797 "c/sqlite3.c"
 $$1 = $49;
 return ($$1|0); //@line 58799 "c/sqlite3.c"
}
function _walCkptInfo($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 32|0); //@line 56206 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 56206 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 56206 "c/sqlite3.c"
 $4 = ((($3)) + 96|0); //@line 56206 "c/sqlite3.c"
 return ($4|0); //@line 56206 "c/sqlite3.c"
}
function _walLockExclusive($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 43|0); //@line 56441 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 56441 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 56441 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  return ($$0|0); //@line 56448 "c/sqlite3.c"
 }
 $6 = ((($0)) + 4|0); //@line 56442 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 56442 "c/sqlite3.c"
 $8 = (_sqlite3OsShmLock($7,$1,$2,10)|0); //@line 56442 "c/sqlite3.c"
 $$0 = $8;
 return ($$0|0); //@line 56448 "c/sqlite3.c"
}
function _walRestartHdr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$$sroa_idx = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_walCkptInfo($0)|0); //@line 57308 "c/sqlite3.c"
 $3 = ((($0)) + 84|0); //@line 57310 "c/sqlite3.c"
 $4 = ((($0)) + 112|0); //@line 57311 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 57311 "c/sqlite3.c"
 $6 = (($5) + 1)|0; //@line 57311 "c/sqlite3.c"
 HEAP32[$4>>2] = $6; //@line 57311 "c/sqlite3.c"
 $7 = ((($0)) + 68|0); //@line 57312 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 57312 "c/sqlite3.c"
 $8 = (_sqlite3Get4byte($3)|0); //@line 57313 "c/sqlite3.c"
 $9 = (($8) + 1)|0; //@line 57313 "c/sqlite3.c"
 _sqlite3Put4byte($3,$9); //@line 57313 "c/sqlite3.c"
 $$0$$sroa_idx = ((($0)) + 88|0); //@line 57314 "c/sqlite3.c"
 HEAP32[$$0$$sroa_idx>>2] = $1; //@line 57314 "c/sqlite3.c"
 _walIndexWriteHdr($0); //@line 57315 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 57316 "c/sqlite3.c"
 $10 = ((($2)) + 32|0); //@line 57317 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 57317 "c/sqlite3.c"
 $11 = ((($2)) + 8|0); //@line 57318 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 57318 "c/sqlite3.c"
 $12 = ((($2)) + 12|0); //@line 57319 "c/sqlite3.c"
 HEAP32[$12>>2] = -1; //@line 57319 "c/sqlite3.c"
 $13 = ((($2)) + 16|0); //@line 57319 "c/sqlite3.c"
 HEAP32[$13>>2] = -1; //@line 57319 "c/sqlite3.c"
 $14 = ((($2)) + 20|0); //@line 57319 "c/sqlite3.c"
 HEAP32[$14>>2] = -1; //@line 57319 "c/sqlite3.c"
 return; //@line 57321 "c/sqlite3.c"
}
function _walTryBeginRead($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$1 = 0, $$1101 = 0, $$1101$1 = 0, $$1101$2 = 0, $$1101$3 = 0, $$1103 = 0, $$1106127$lcssa136 = 0, $$1108 = 0, $$1108$1 = 0, $$1108$2 = 0, $$1108$3 = 0, $$2109118 = 0, $$2119 = 0, $$3 = 0, $$5 = 0, $$lcssa134 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0;
 var $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0;
 var $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $9 = 0, $not$ = 0;
 var $or$cond = 0, $or$cond110$1 = 0, $or$cond110$2 = 0, $or$cond110$3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($3|0)>(5); //@line 58045 "c/sqlite3.c"
 do {
  if ($4) {
   $5 = ($3|0)>(100); //@line 58047 "c/sqlite3.c"
   if ($5) {
    $$1 = 15;
    return ($$1|0); //@line 58222 "c/sqlite3.c"
   } else {
    $6 = ($3|0)>(9); //@line 58051 "c/sqlite3.c"
    $7 = (($3) + -9)|0; //@line 58051 "c/sqlite3.c"
    $8 = ($7*39)|0; //@line 58051 "c/sqlite3.c"
    $9 = Math_imul($8, $7)|0; //@line 58051 "c/sqlite3.c"
    $spec$select = $6 ? $9 : 1; //@line 58051 "c/sqlite3.c"
    $10 = HEAP32[$0>>2]|0; //@line 58052 "c/sqlite3.c"
    (_sqlite3OsSleep($10,$spec$select)|0); //@line 58052 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $11 = ($2|0)==(0); //@line 58055 "c/sqlite3.c"
 L7: do {
  if ($11) {
   $13 = ((($0)) + 50|0); //@line 58057 "c/sqlite3.c"
   $14 = HEAP8[$13>>0]|0; //@line 58057 "c/sqlite3.c"
   $15 = ($14<<24>>24)==(0); //@line 58057 "c/sqlite3.c"
   if ($15) {
    $16 = (_walIndexReadHdr($0,$1)|0); //@line 58058 "c/sqlite3.c"
    $17 = ($16|0)==(5); //@line 58060 "c/sqlite3.c"
    L11: do {
     if ($17) {
      $18 = ((($0)) + 32|0); //@line 58069 "c/sqlite3.c"
      $19 = HEAP32[$18>>2]|0; //@line 58069 "c/sqlite3.c"
      $20 = HEAP32[$19>>2]|0; //@line 58069 "c/sqlite3.c"
      $21 = ($20|0)==(0|0); //@line 58069 "c/sqlite3.c"
      if ($21) {
       $$1 = -1;
       return ($$1|0); //@line 58222 "c/sqlite3.c"
      }
      $22 = (_walLockShared($0,2)|0); //@line 58078 "c/sqlite3.c"
      switch ($22|0) {
      case 0:  {
       break;
      }
      case 5:  {
       $$1 = 261;
       return ($$1|0); //@line 58222 "c/sqlite3.c"
       break;
      }
      default: {
       $$1103 = $22;
       break L11;
      }
      }
      _walUnlockShared($0,2); //@line 58079 "c/sqlite3.c"
      $$1 = -1;
      return ($$1|0); //@line 58222 "c/sqlite3.c"
     } else {
      $$1103 = $16;
     }
    } while(0);
    $23 = ($$1103|0)==(0); //@line 58085 "c/sqlite3.c"
    if (!($23)) {
     $$1 = $$1103;
     return ($$1|0); //@line 58222 "c/sqlite3.c"
    }
    $$pr = HEAP8[$13>>0]|0; //@line 58088 "c/sqlite3.c"
    $24 = ($$pr<<24>>24)==(0); //@line 58088 "c/sqlite3.c"
    if ($24) {
     $26 = (_walCkptInfo($0)|0); //@line 58095 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 58096 "c/sqlite3.c"
     $28 = ((($0)) + 52|0); //@line 58096 "c/sqlite3.c"
     $29 = ((($0)) + 68|0); //@line 58096 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 58096 "c/sqlite3.c"
     $31 = ($27|0)==($30|0); //@line 58096 "c/sqlite3.c"
     if (!($31)) {
      $$3 = 0;$40 = $26;
      break;
     }
     $32 = (_walLockShared($0,3)|0); //@line 58104 "c/sqlite3.c"
     _walShmBarrier($0); //@line 58105 "c/sqlite3.c"
     switch ($32|0) {
     case 5:  {
      $$3 = $32;$40 = $26;
      break L7;
      break;
     }
     case 0:  {
      break;
     }
     default: {
      $$1 = $32;
      return ($$1|0); //@line 58222 "c/sqlite3.c"
     }
     }
     $33 = (_walIndexHdr($0)|0); //@line 58107 "c/sqlite3.c"
     $34 = (_memcmp($33,$28,48)|0); //@line 58107 "c/sqlite3.c"
     $35 = ($34|0)==(0); //@line 58107 "c/sqlite3.c"
     if ($35) {
      $36 = ((($0)) + 40|0); //@line 58124 "c/sqlite3.c"
      HEAP16[$36>>1] = 0; //@line 58124 "c/sqlite3.c"
      $$1 = 0;
      return ($$1|0); //@line 58222 "c/sqlite3.c"
     } else {
      _walUnlockShared($0,3); //@line 58121 "c/sqlite3.c"
      $$1 = -1;
      return ($$1|0); //@line 58222 "c/sqlite3.c"
     }
    }
   }
   $25 = (_walBeginShmUnreliable($0,$1)|0); //@line 58089 "c/sqlite3.c"
   $$1 = $25;
   return ($$1|0); //@line 58222 "c/sqlite3.c"
  } else {
   $12 = (_walCkptInfo($0)|0); //@line 58095 "c/sqlite3.c"
   $$3 = 0;$40 = $12;
  }
 } while(0);
 $37 = ((($0)) + 68|0); //@line 58138 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 58138 "c/sqlite3.c"
 $39 = ((($40)) + 8|0); //@line 58145 "c/sqlite3.c"
 $41 = HEAP32[$39>>2]|0; //@line 58145 "c/sqlite3.c"
 $42 = ($41>>>0)>($38>>>0); //@line 58146 "c/sqlite3.c"
 $not$ = $42 ^ 1; //@line 58146 "c/sqlite3.c"
 $$1108 = $not$&1; //@line 58146 "c/sqlite3.c"
 $$1101 = $42 ? 0 : $41; //@line 58146 "c/sqlite3.c"
 $43 = ((($40)) + 12|0); //@line 58145 "c/sqlite3.c"
 $44 = HEAP32[$43>>2]|0; //@line 58145 "c/sqlite3.c"
 $45 = ($$1101>>>0)>($44>>>0); //@line 58146 "c/sqlite3.c"
 $46 = ($44>>>0)>($38>>>0); //@line 58146 "c/sqlite3.c"
 $or$cond110$1 = $45 | $46; //@line 58146 "c/sqlite3.c"
 $$1108$1 = $or$cond110$1 ? $$1108 : 2; //@line 58146 "c/sqlite3.c"
 $$1101$1 = $or$cond110$1 ? $$1101 : $44; //@line 58146 "c/sqlite3.c"
 $47 = ((($40)) + 16|0); //@line 58145 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 58145 "c/sqlite3.c"
 $49 = ($$1101$1>>>0)>($48>>>0); //@line 58146 "c/sqlite3.c"
 $50 = ($48>>>0)>($38>>>0); //@line 58146 "c/sqlite3.c"
 $or$cond110$2 = $49 | $50; //@line 58146 "c/sqlite3.c"
 $$1108$2 = $or$cond110$2 ? $$1108$1 : 3; //@line 58146 "c/sqlite3.c"
 $$1101$2 = $or$cond110$2 ? $$1101$1 : $48; //@line 58146 "c/sqlite3.c"
 $51 = ((($40)) + 20|0); //@line 58145 "c/sqlite3.c"
 $52 = HEAP32[$51>>2]|0; //@line 58145 "c/sqlite3.c"
 $53 = ($$1101$2>>>0)>($52>>>0); //@line 58146 "c/sqlite3.c"
 $54 = ($52>>>0)>($38>>>0); //@line 58146 "c/sqlite3.c"
 $or$cond110$3 = $53 | $54; //@line 58146 "c/sqlite3.c"
 $$1108$3 = $or$cond110$3 ? $$1108$2 : 4; //@line 58146 "c/sqlite3.c"
 $$1101$3 = $or$cond110$3 ? $$1101$2 : $52; //@line 58146 "c/sqlite3.c"
 $55 = ((($0)) + 52|0); //@line 58138 "c/sqlite3.c"
 $56 = ((($0)) + 46|0); //@line 58152 "c/sqlite3.c"
 $57 = HEAP8[$56>>0]|0; //@line 58152 "c/sqlite3.c"
 $58 = $57 & 2; //@line 58152 "c/sqlite3.c"
 $59 = ($58<<24>>24)==(0); //@line 58152 "c/sqlite3.c"
 L38: do {
  if ($59) {
   $60 = ($$1101$3>>>0)<($38>>>0); //@line 58153 "c/sqlite3.c"
   $61 = ($$1108$3|0)==(0); //@line 58153 "c/sqlite3.c"
   $or$cond = $61 | $60; //@line 58153 "c/sqlite3.c"
   if ($or$cond) {
    $62 = (_walLockExclusive($0,4,1)|0); //@line 58156 "c/sqlite3.c"
    switch ($62|0) {
    case 0:  {
     $$1106127$lcssa136 = 1;$$lcssa134 = 4;
     break;
    }
    case 5:  {
     label = 23;
     break;
    }
    default: {
     $$1 = $62;
     return ($$1|0); //@line 58222 "c/sqlite3.c"
    }
    }
    L43: do {
     if ((label|0) == 23) {
      $64 = (_walLockExclusive($0,5,1)|0); //@line 58156 "c/sqlite3.c"
      switch ($64|0) {
      case 0:  {
       $$1106127$lcssa136 = 2;$$lcssa134 = 5;
       break L43;
       break;
      }
      case 5:  {
       break;
      }
      default: {
       $$1 = $64;
       return ($$1|0); //@line 58222 "c/sqlite3.c"
      }
      }
      $84 = (_walLockExclusive($0,6,1)|0); //@line 58156 "c/sqlite3.c"
      switch ($84|0) {
      case 0:  {
       $$1106127$lcssa136 = 3;$$lcssa134 = 6;
       break L43;
       break;
      }
      case 5:  {
       break;
      }
      default: {
       $$1 = $84;
       return ($$1|0); //@line 58222 "c/sqlite3.c"
      }
      }
      $85 = (_walLockExclusive($0,7,1)|0); //@line 58156 "c/sqlite3.c"
      switch ($85|0) {
      case 5:  {
       $$5 = $85;
       label = 24;
       break L38;
       break;
      }
      case 0:  {
       $$1106127$lcssa136 = 4;$$lcssa134 = 7;
       break L43;
       break;
      }
      default: {
       $$1 = $85;
      }
      }
      return ($$1|0); //@line 58222 "c/sqlite3.c"
     }
    } while(0);
    $63 = (((($40)) + 4|0) + ($$1106127$lcssa136<<2)|0); //@line 58158 "c/sqlite3.c"
    HEAP32[$63>>2] = $38; //@line 58158 "c/sqlite3.c"
    _walUnlockExclusive($0,$$lcssa134,1); //@line 58160 "c/sqlite3.c"
    $$2109118 = $$1106127$lcssa136;$$2119 = $38;
   } else {
    $$2109118 = $$1108$3;$$2119 = $$1101$3;
   }
  } else {
   $$5 = $$3;
   label = 24;
  }
 } while(0);
 if ((label|0) == 24) {
  $65 = ($$1108$3|0)==(0); //@line 58167 "c/sqlite3.c"
  if ($65) {
   $66 = ($$5|0)==(5); //@line 58169 "c/sqlite3.c"
   $67 = $66 ? -1 : 1288; //@line 58169 "c/sqlite3.c"
   $$1 = $67;
   return ($$1|0); //@line 58222 "c/sqlite3.c"
  } else {
   $$2109118 = $$1108$3;$$2119 = $$1101$3;
  }
 }
 $68 = (($$2109118) + 3)|0; //@line 58172 "c/sqlite3.c"
 $69 = (_walLockShared($0,$68)|0); //@line 58172 "c/sqlite3.c"
 $70 = ($69|0)==(0); //@line 58173 "c/sqlite3.c"
 if (!($70)) {
  $71 = ($69|0)==(5); //@line 58174 "c/sqlite3.c"
  $72 = $71 ? -1 : $69; //@line 58174 "c/sqlite3.c"
  $$1 = $72;
  return ($$1|0); //@line 58222 "c/sqlite3.c"
 }
 $73 = HEAP32[$40>>2]|0; //@line 58210 "c/sqlite3.c"
 $74 = (($73) + 1)|0; //@line 58210 "c/sqlite3.c"
 $75 = ((($0)) + 100|0); //@line 58210 "c/sqlite3.c"
 HEAP32[$75>>2] = $74; //@line 58210 "c/sqlite3.c"
 _walShmBarrier($0); //@line 58211 "c/sqlite3.c"
 $76 = (((($40)) + 4|0) + ($$2109118<<2)|0); //@line 58212 "c/sqlite3.c"
 $77 = HEAP32[$76>>2]|0; //@line 58212 "c/sqlite3.c"
 $78 = ($77|0)==($$2119|0); //@line 58212 "c/sqlite3.c"
 if ($78) {
  $79 = (_walIndexHdr($0)|0); //@line 58213 "c/sqlite3.c"
  $80 = (_memcmp($79,$55,48)|0); //@line 58213 "c/sqlite3.c"
  $81 = ($80|0)==(0); //@line 58213 "c/sqlite3.c"
  if ($81) {
   $82 = $$2109118&65535; //@line 58219 "c/sqlite3.c"
   $83 = ((($0)) + 40|0); //@line 58219 "c/sqlite3.c"
   HEAP16[$83>>1] = $82; //@line 58219 "c/sqlite3.c"
   $$1 = 0;
   return ($$1|0); //@line 58222 "c/sqlite3.c"
  }
 }
 _walUnlockShared($0,$68); //@line 58215 "c/sqlite3.c"
 $$1 = -1;
 return ($$1|0); //@line 58222 "c/sqlite3.c"
}
function _sqlite3OsSleep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 60|0); //@line 21071 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 21071 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_iii[$3 & 255]($0,$1)|0); //@line 21071 "c/sqlite3.c"
 return ($4|0); //@line 21071 "c/sqlite3.c"
}
function _walIndexReadHdr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$036$ph = 0, $$038 = 0, $$13741 = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = (_walIndexPage($0,0,$2)|0); //@line 57709 "c/sqlite3.c"
 switch ($3|0) {
 case 0:  {
  break;
 }
 case 1288:  {
  $4 = ((($0)) + 50|0); //@line 57722 "c/sqlite3.c"
  HEAP8[$4>>0] = 1; //@line 57722 "c/sqlite3.c"
  $5 = ((($0)) + 43|0); //@line 57723 "c/sqlite3.c"
  HEAP8[$5>>0] = 2; //@line 57723 "c/sqlite3.c"
  HEAP32[$1>>2] = 1; //@line 57724 "c/sqlite3.c"
  break;
 }
 default: {
  $$038 = $3;
  STACKTOP = sp;return ($$038|0); //@line 57791 "c/sqlite3.c"
 }
 }
 $6 = HEAP32[$2>>2]|0; //@line 57740 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 57740 "c/sqlite3.c"
 if ($7) {
  label = 5;
 } else {
  $8 = (_walIndexTryHdr($0,$1)|0); //@line 57740 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 57746 "c/sqlite3.c"
  if ($9) {
   $$13741 = $3;
   label = 15;
  } else {
   label = 5;
  }
 }
 L7: do {
  if ((label|0) == 5) {
   $10 = ((($0)) + 50|0); //@line 57747 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 57747 "c/sqlite3.c"
   $12 = ($11<<24>>24)==(0); //@line 57747 "c/sqlite3.c"
   if ($12) {
    $13 = ((($0)) + 46|0); //@line 57747 "c/sqlite3.c"
    $14 = HEAP8[$13>>0]|0; //@line 57747 "c/sqlite3.c"
    $15 = $14 & 2; //@line 57747 "c/sqlite3.c"
    $16 = ($15<<24>>24)==(0); //@line 57747 "c/sqlite3.c"
    if (!($16)) {
     $17 = (_walLockShared($0,0)|0); //@line 57748 "c/sqlite3.c"
     $18 = ($17|0)==(0); //@line 57748 "c/sqlite3.c"
     if (!($18)) {
      $$2 = $17;
      break;
     }
     _walUnlockShared($0,0); //@line 57749 "c/sqlite3.c"
     $$2 = 264;
     break;
    }
   }
   $19 = (_walLockExclusive($0,0,1)|0); //@line 57752 "c/sqlite3.c"
   $20 = ($19|0)==(0); //@line 57752 "c/sqlite3.c"
   if ($20) {
    $21 = ((($0)) + 44|0); //@line 57753 "c/sqlite3.c"
    HEAP8[$21>>0] = 1; //@line 57753 "c/sqlite3.c"
    $22 = (_walIndexPage($0,0,$2)|0); //@line 57754 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 57754 "c/sqlite3.c"
    do {
     if ($23) {
      $24 = (_walIndexTryHdr($0,$1)|0); //@line 57755 "c/sqlite3.c"
      $25 = ($24|0)==(0); //@line 57756 "c/sqlite3.c"
      if ($25) {
       HEAP8[$21>>0] = 0; //@line 57765 "c/sqlite3.c"
       _walUnlockExclusive($0,0,1); //@line 57766 "c/sqlite3.c"
       $$13741 = 0;
       label = 15;
       break L7;
      } else {
       $26 = (_walIndexRecover($0)|0); //@line 57761 "c/sqlite3.c"
       HEAP32[$1>>2] = 1; //@line 57762 "c/sqlite3.c"
       $$036$ph = $26;
       break;
      }
     } else {
      $$036$ph = $22;
     }
    } while(0);
    HEAP8[$21>>0] = 0; //@line 57765 "c/sqlite3.c"
    _walUnlockExclusive($0,0,1); //@line 57766 "c/sqlite3.c"
    $$2 = $$036$ph;
   } else {
    $$2 = $19;
   }
  }
 } while(0);
 if ((label|0) == 15) {
  $27 = ((($0)) + 52|0); //@line 57774 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 57774 "c/sqlite3.c"
  $29 = ($28|0)==(3007000); //@line 57774 "c/sqlite3.c"
  if ($29) {
   $$2 = $$13741;
  } else {
   $30 = (_sqlite3CantopenError(57775)|0); //@line 57775 "c/sqlite3.c"
   $$2 = $30;
  }
 }
 $31 = ((($0)) + 50|0); //@line 57777 "c/sqlite3.c"
 $32 = HEAP8[$31>>0]|0; //@line 57777 "c/sqlite3.c"
 $33 = ($32<<24>>24)==(0); //@line 57777 "c/sqlite3.c"
 if ($33) {
  $$038 = $$2;
  STACKTOP = sp;return ($$038|0); //@line 57791 "c/sqlite3.c"
 }
 $34 = ($$2|0)==(0); //@line 57778 "c/sqlite3.c"
 if ($34) {
  $$3 = 0;
 } else {
  $35 = ($$2|0)==(522); //@line 57785 "c/sqlite3.c"
  $spec$select = $35 ? -1 : $$2; //@line 57785 "c/sqlite3.c"
  _walIndexClose($0,0); //@line 57779 "c/sqlite3.c"
  HEAP8[$31>>0] = 0; //@line 57780 "c/sqlite3.c"
  $$3 = $spec$select;
 }
 $36 = ((($0)) + 43|0); //@line 57787 "c/sqlite3.c"
 HEAP8[$36>>0] = 0; //@line 57787 "c/sqlite3.c"
 $$038 = $$3;
 STACKTOP = sp;return ($$038|0); //@line 57791 "c/sqlite3.c"
}
function _walBeginShmUnreliable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$066 = 0, $$075 = 0, $$2 = 0, $$3 = 0, $$3$ph = 0, $$371 = 0, $$372 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $89$phi = 0, $9 = 0, $90 = 0, $90$phi = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, dest = 0, label = 0;
 var sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $2 = sp;
 $3 = sp + 24|0;
 $4 = sp + 16|0;
 $5 = sp + 12|0;
 $6 = sp + 8|0;
 $7 = (_walLockShared($0,3)|0); //@line 57838 "c/sqlite3.c"
 L1: do {
  switch ($7|0) {
  case 0:  {
   $8 = ((($0)) + 40|0); //@line 57843 "c/sqlite3.c"
   HEAP16[$8>>1] = 0; //@line 57843 "c/sqlite3.c"
   $9 = ((($0)) + 4|0); //@line 57867 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 57867 "c/sqlite3.c"
   $11 = (_sqlite3OsShmMap($10,0,0,$4)|0); //@line 57867 "c/sqlite3.c"
   switch ($11|0) {
   case 8:  {
    $$3$ph = -1;
    label = 17;
    break L1;
    break;
   }
   case 1288:  {
    break;
   }
   default: {
    $$066 = 0;$$3 = $11;
    label = 18;
    break L1;
   }
   }
   $12 = ((($0)) + 52|0); //@line 57878 "c/sqlite3.c"
   $13 = (_walIndexHdr($0)|0); //@line 57878 "c/sqlite3.c"
   dest=$12; src=$13; stop=dest+48|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 57878 "c/sqlite3.c"
   $14 = ((($0)) + 8|0); //@line 57883 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 57883 "c/sqlite3.c"
   $16 = (_sqlite3OsFileSize($15,$2)|0); //@line 57883 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 57884 "c/sqlite3.c"
   if ($17) {
    $18 = $2; //@line 57887 "c/sqlite3.c"
    $19 = $18; //@line 57887 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 57887 "c/sqlite3.c"
    $21 = (($18) + 4)|0; //@line 57887 "c/sqlite3.c"
    $22 = $21; //@line 57887 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 57887 "c/sqlite3.c"
    $24 = ($23|0)<(0); //@line 57887 "c/sqlite3.c"
    $25 = ($20>>>0)<(32); //@line 57887 "c/sqlite3.c"
    $26 = ($23|0)==(0); //@line 57887 "c/sqlite3.c"
    $27 = $26 & $25; //@line 57887 "c/sqlite3.c"
    $28 = $24 | $27; //@line 57887 "c/sqlite3.c"
    if ($28) {
     HEAP32[$1>>2] = 1; //@line 57894 "c/sqlite3.c"
     $29 = ((($0)) + 68|0); //@line 57895 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 57895 "c/sqlite3.c"
     $31 = ($30|0)!=(0); //@line 57895 "c/sqlite3.c"
     $32 = $31 << 31 >> 31; //@line 57895 "c/sqlite3.c"
     $$066 = 0;$$3 = $32;
     label = 18;
     break L1;
    }
    $33 = HEAP32[$14>>2]|0; //@line 57900 "c/sqlite3.c"
    $34 = (_sqlite3OsRead($33,$3,32,0,0)|0); //@line 57900 "c/sqlite3.c"
    $35 = ($34|0)==(0); //@line 57901 "c/sqlite3.c"
    if ($35) {
     $36 = ((($0)) + 84|0); //@line 57904 "c/sqlite3.c"
     $37 = ((($3)) + 16|0); //@line 57904 "c/sqlite3.c"
     $38 = (_memcmp($36,$37,8)|0); //@line 57904 "c/sqlite3.c"
     $39 = ($38|0)==(0); //@line 57904 "c/sqlite3.c"
     if ($39) {
      $40 = ((($0)) + 66|0); //@line 57913 "c/sqlite3.c"
      $41 = HEAP16[$40>>1]|0; //@line 57913 "c/sqlite3.c"
      $42 = $41&65535; //@line 57913 "c/sqlite3.c"
      $43 = (($42) + 24)|0; //@line 57913 "c/sqlite3.c"
      $44 = (_sqlite3_malloc64($43,0)|0); //@line 57914 "c/sqlite3.c"
      $45 = ($44|0)==(0|0); //@line 57915 "c/sqlite3.c"
      if ($45) {
       $$3$ph = 7;
       label = 17;
      } else {
       $46 = ((($44)) + 24|0); //@line 57919 "c/sqlite3.c"
       $47 = ((($0)) + 76|0); //@line 57925 "c/sqlite3.c"
       $48 = HEAP32[$47>>2]|0; //@line 57925 "c/sqlite3.c"
       $49 = ((($0)) + 80|0); //@line 57926 "c/sqlite3.c"
       $50 = HEAP32[$49>>2]|0; //@line 57926 "c/sqlite3.c"
       $51 = ((($0)) + 68|0); //@line 57927 "c/sqlite3.c"
       $52 = HEAP32[$51>>2]|0; //@line 57927 "c/sqlite3.c"
       $53 = HEAP16[$40>>1]|0; //@line 57927 "c/sqlite3.c"
       $54 = $53&65535; //@line 57927 "c/sqlite3.c"
       $55 = (($54) + 24)|0; //@line 57927 "c/sqlite3.c"
       $56 = (___muldi3(($55|0),0,($52|0),0)|0); //@line 57927 "c/sqlite3.c"
       $57 = tempRet0; //@line 57927 "c/sqlite3.c"
       $58 = (_i64Add(($56|0),($57|0),32,0)|0); //@line 57927 "c/sqlite3.c"
       $59 = tempRet0; //@line 57927 "c/sqlite3.c"
       $60 = (_i64Add(($58|0),($59|0),($43|0),0)|0); //@line 57928 "c/sqlite3.c"
       $61 = tempRet0; //@line 57928 "c/sqlite3.c"
       $62 = $2; //@line 57928 "c/sqlite3.c"
       $63 = $62; //@line 57928 "c/sqlite3.c"
       $64 = HEAP32[$63>>2]|0; //@line 57928 "c/sqlite3.c"
       $65 = (($62) + 4)|0; //@line 57928 "c/sqlite3.c"
       $66 = $65; //@line 57928 "c/sqlite3.c"
       $67 = HEAP32[$66>>2]|0; //@line 57928 "c/sqlite3.c"
       $68 = ($61|0)>($67|0); //@line 57928 "c/sqlite3.c"
       $69 = ($60>>>0)>($64>>>0); //@line 57928 "c/sqlite3.c"
       $70 = ($61|0)==($67|0); //@line 57928 "c/sqlite3.c"
       $71 = $70 & $69; //@line 57928 "c/sqlite3.c"
       $72 = $68 | $71; //@line 57928 "c/sqlite3.c"
       L11: do {
        if ($72) {
         $$2 = 0;
        } else {
         $73 = $60;$74 = $61;$89 = $58;$90 = $59;
         while(1) {
          $88 = HEAP32[$14>>2]|0; //@line 57935 "c/sqlite3.c"
          $91 = (_sqlite3OsRead($88,$44,$43,$89,$90)|0); //@line 57935 "c/sqlite3.c"
          $92 = ($91|0)==(0); //@line 57936 "c/sqlite3.c"
          if (!($92)) {
           break;
          }
          $93 = (_walDecodeFrame($0,$5,$6,$46,$44)|0); //@line 57937 "c/sqlite3.c"
          $94 = ($93|0)==(0); //@line 57937 "c/sqlite3.c"
          if ($94) {
           break;
          }
          $95 = HEAP32[$6>>2]|0; //@line 57942 "c/sqlite3.c"
          $96 = ($95|0)==(0); //@line 57942 "c/sqlite3.c"
          if (!($96)) {
           $$2 = -1;
           break L11;
          }
          $75 = (_i64Add(($73|0),($74|0),($43|0),0)|0); //@line 57928 "c/sqlite3.c"
          $76 = tempRet0; //@line 57928 "c/sqlite3.c"
          $77 = $2; //@line 57928 "c/sqlite3.c"
          $78 = $77; //@line 57928 "c/sqlite3.c"
          $79 = HEAP32[$78>>2]|0; //@line 57928 "c/sqlite3.c"
          $80 = (($77) + 4)|0; //@line 57928 "c/sqlite3.c"
          $81 = $80; //@line 57928 "c/sqlite3.c"
          $82 = HEAP32[$81>>2]|0; //@line 57928 "c/sqlite3.c"
          $83 = ($76|0)>($82|0); //@line 57928 "c/sqlite3.c"
          $84 = ($75>>>0)>($79>>>0); //@line 57928 "c/sqlite3.c"
          $85 = ($76|0)==($82|0); //@line 57928 "c/sqlite3.c"
          $86 = $85 & $84; //@line 57928 "c/sqlite3.c"
          $87 = $83 | $86; //@line 57928 "c/sqlite3.c"
          if ($87) {
           $$2 = $91;
           break L11;
          } else {
           $90$phi = $74;$89$phi = $73;$73 = $75;$74 = $76;$90 = $90$phi;$89 = $89$phi;
          }
         }
         $$2 = $91;
        }
       } while(0);
       HEAP32[$47>>2] = $48; //@line 57947 "c/sqlite3.c"
       HEAP32[$49>>2] = $50; //@line 57948 "c/sqlite3.c"
       $$066 = $44;$$3 = $$2;
       label = 18;
      }
     } else {
      $$3$ph = -1;
      label = 17;
     }
    } else {
     $$3$ph = $34;
     label = 17;
    }
   } else {
    $$3$ph = $16;
    label = 17;
   }
   break;
  }
  case 5:  {
   $$3$ph = -1;
   label = 17;
   break;
  }
  default: {
   $$066 = 0;$$3 = $7;
   label = 18;
  }
  }
 } while(0);
 if ((label|0) == 17) {
  _sqlite3_free(0); //@line 57951 "c/sqlite3.c"
  $$371 = $$3$ph;
 }
 else if ((label|0) == 18) {
  _sqlite3_free($$066); //@line 57951 "c/sqlite3.c"
  $97 = ($$3|0)==(0); //@line 57952 "c/sqlite3.c"
  if ($97) {
   $$372 = 0;
   STACKTOP = sp;return ($$372|0); //@line 57962 "c/sqlite3.c"
  } else {
   $$371 = $$3;
  }
 }
 $98 = ((($0)) + 24|0); //@line 57954 "c/sqlite3.c"
 $99 = HEAP32[$98>>2]|0; //@line 57954 "c/sqlite3.c"
 $100 = ($99|0)>(0); //@line 57954 "c/sqlite3.c"
 if ($100) {
  $101 = ((($0)) + 32|0);
  $$075 = 0;
  while(1) {
   $102 = HEAP32[$101>>2]|0; //@line 57955 "c/sqlite3.c"
   $103 = (($102) + ($$075<<2)|0); //@line 57955 "c/sqlite3.c"
   $104 = HEAP32[$103>>2]|0; //@line 57955 "c/sqlite3.c"
   _sqlite3_free($104); //@line 57955 "c/sqlite3.c"
   $105 = HEAP32[$101>>2]|0; //@line 57956 "c/sqlite3.c"
   $106 = (($105) + ($$075<<2)|0); //@line 57956 "c/sqlite3.c"
   HEAP32[$106>>2] = 0; //@line 57956 "c/sqlite3.c"
   $107 = (($$075) + 1)|0; //@line 57954 "c/sqlite3.c"
   $108 = HEAP32[$98>>2]|0; //@line 57954 "c/sqlite3.c"
   $109 = ($107|0)<($108|0); //@line 57954 "c/sqlite3.c"
   if ($109) {
    $$075 = $107;
   } else {
    break;
   }
  }
 }
 $110 = ((($0)) + 50|0); //@line 57958 "c/sqlite3.c"
 HEAP8[$110>>0] = 0; //@line 57958 "c/sqlite3.c"
 _sqlite3WalEndReadTransaction($0); //@line 57959 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 57960 "c/sqlite3.c"
 $$372 = $$371;
 STACKTOP = sp;return ($$372|0); //@line 57962 "c/sqlite3.c"
}
function _walDecodeFrame($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 76|0); //@line 56352 "c/sqlite3.c"
 $6 = ((($0)) + 84|0); //@line 56359 "c/sqlite3.c"
 $7 = ((($4)) + 8|0); //@line 56359 "c/sqlite3.c"
 $8 = (_memcmp($6,$7,8)|0); //@line 56359 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 56359 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 0;
  return ($$0|0); //@line 56391 "c/sqlite3.c"
 }
 $10 = (_sqlite3Get4byte($4)|0); //@line 56365 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 56366 "c/sqlite3.c"
 if ($11) {
  $$0 = 0;
  return ($$0|0); //@line 56391 "c/sqlite3.c"
 }
 $12 = ((($0)) + 65|0); //@line 56375 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 56375 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 56375 "c/sqlite3.c"
 $15 = $14&1; //@line 56375 "c/sqlite3.c"
 _walChecksumBytes($15,$4,8,$5,$5); //@line 56376 "c/sqlite3.c"
 $16 = ((($0)) + 36|0); //@line 56377 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 56377 "c/sqlite3.c"
 _walChecksumBytes($15,$3,$17,$5,$5); //@line 56377 "c/sqlite3.c"
 $18 = HEAP32[$5>>2]|0; //@line 56378 "c/sqlite3.c"
 $19 = ((($4)) + 16|0); //@line 56378 "c/sqlite3.c"
 $20 = (_sqlite3Get4byte($19)|0); //@line 56378 "c/sqlite3.c"
 $21 = ($18|0)==($20|0); //@line 56378 "c/sqlite3.c"
 if (!($21)) {
  $$0 = 0;
  return ($$0|0); //@line 56391 "c/sqlite3.c"
 }
 $22 = ((($0)) + 80|0); //@line 56379 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 56379 "c/sqlite3.c"
 $24 = ((($4)) + 20|0); //@line 56379 "c/sqlite3.c"
 $25 = (_sqlite3Get4byte($24)|0); //@line 56379 "c/sqlite3.c"
 $26 = ($23|0)==($25|0); //@line 56379 "c/sqlite3.c"
 if (!($26)) {
  $$0 = 0;
  return ($$0|0); //@line 56391 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = $10; //@line 56388 "c/sqlite3.c"
 $27 = ((($4)) + 4|0); //@line 56389 "c/sqlite3.c"
 $28 = (_sqlite3Get4byte($27)|0); //@line 56389 "c/sqlite3.c"
 HEAP32[$2>>2] = $28; //@line 56389 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 56391 "c/sqlite3.c"
}
function _walIndexTryHdr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $2 = sp + 96|0;
 $3 = sp + 48|0;
 $4 = sp;
 $5 = (_walIndexHdr($0)|0); //@line 57654 "c/sqlite3.c"
 dest=$3; src=$5; stop=dest+48|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 57655 "c/sqlite3.c"
 _walShmBarrier($0); //@line 57656 "c/sqlite3.c"
 $6 = ((($5)) + 48|0); //@line 57657 "c/sqlite3.c"
 dest=$4; src=$6; stop=dest+48|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 57657 "c/sqlite3.c"
 $7 = (_memcmp($3,$4,48)|0); //@line 57659 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 57659 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 57680 "c/sqlite3.c"
 }
 $9 = ((($3)) + 12|0); //@line 57662 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 57662 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 57662 "c/sqlite3.c"
 if ($11) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 57680 "c/sqlite3.c"
 }
 _walChecksumBytes(1,$3,40,0,$2); //@line 57665 "c/sqlite3.c"
 $12 = HEAP32[$2>>2]|0; //@line 57666 "c/sqlite3.c"
 $13 = ((($3)) + 40|0); //@line 57666 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 57666 "c/sqlite3.c"
 $15 = ($12|0)==($14|0); //@line 57666 "c/sqlite3.c"
 if (!($15)) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 57680 "c/sqlite3.c"
 }
 $16 = ((($2)) + 4|0); //@line 57666 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 57666 "c/sqlite3.c"
 $18 = ((($3)) + 44|0); //@line 57666 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 57666 "c/sqlite3.c"
 $20 = ($17|0)==($19|0); //@line 57666 "c/sqlite3.c"
 if (!($20)) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 57680 "c/sqlite3.c"
 }
 $21 = ((($0)) + 52|0); //@line 57670 "c/sqlite3.c"
 $22 = (_memcmp($21,$3,48)|0); //@line 57670 "c/sqlite3.c"
 $23 = ($22|0)==(0); //@line 57670 "c/sqlite3.c"
 if ($23) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 57680 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = 1; //@line 57671 "c/sqlite3.c"
 dest=$21; src=$3; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 57672 "c/sqlite3.c"
 $24 = ((($0)) + 66|0); //@line 57673 "c/sqlite3.c"
 $25 = HEAP16[$24>>1]|0; //@line 57673 "c/sqlite3.c"
 $26 = $25&65535; //@line 57673 "c/sqlite3.c"
 $27 = $26 & 65024; //@line 57673 "c/sqlite3.c"
 $28 = $26 << 16; //@line 57673 "c/sqlite3.c"
 $29 = $28 & 65536; //@line 57673 "c/sqlite3.c"
 $30 = $29 | $27; //@line 57673 "c/sqlite3.c"
 $31 = ((($0)) + 36|0); //@line 57673 "c/sqlite3.c"
 HEAP32[$31>>2] = $30; //@line 57673 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 57680 "c/sqlite3.c"
}
function _walIndexRecover($0) {
 $0 = $0|0;
 var $$0119 = 0, $$0124141 = 0, $$2$ph = 0, $$3 = 0, $$4 = 0, $$4$ph = 0, $$6 = 0, $$off = 0, $$sroa$0$0138 = 0, $$sroa$0$0143 = 0, $$sroa$0$2 = 0, $$sroa$0$4$ph = 0, $$sroa$0$5130 = 0, $$sroa$5$0136 = 0, $$sroa$5$0144 = 0, $$sroa$5$2 = 0, $$sroa$5$4$ph = 0, $$sroa$5$5131 = 0, $1 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $105$phi = 0, $106 = 0, $106$phi = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0;
 var $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0;
 var $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0;
 var $153 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0;
 var $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0;
 var $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer = sp + 8|0;
 $1 = sp;
 $2 = sp + 24|0;
 $3 = sp + 20|0;
 $4 = sp + 16|0;
 $5 = ((($0)) + 45|0); //@line 56724 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 56724 "c/sqlite3.c"
 $7 = $6&255; //@line 56724 "c/sqlite3.c"
 $8 = (($7) + 1)|0; //@line 56724 "c/sqlite3.c"
 $9 = (2 - ($7))|0; //@line 56725 "c/sqlite3.c"
 $10 = (_walLockExclusive($0,$8,$9)|0); //@line 56725 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 56726 "c/sqlite3.c"
 if (!($11)) {
  $$0119 = $10;
  STACKTOP = sp;return ($$0119|0); //@line 56876 "c/sqlite3.c"
 }
 $12 = (_walLockExclusive($0,4,4)|0); //@line 56727 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 56728 "c/sqlite3.c"
 if (!($13)) {
  _walUnlockExclusive($0,$8,$9); //@line 56729 "c/sqlite3.c"
  $$0119 = $12;
  STACKTOP = sp;return ($$0119|0); //@line 56876 "c/sqlite3.c"
 }
 $14 = ((($0)) + 52|0); //@line 56738 "c/sqlite3.c"
 dest=$14; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 56738 "c/sqlite3.c"
 $15 = ((($0)) + 8|0); //@line 56740 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 56740 "c/sqlite3.c"
 $17 = (_sqlite3OsFileSize($16,$1)|0); //@line 56740 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 56741 "c/sqlite3.c"
 L8: do {
  if ($18) {
   $19 = $1; //@line 56745 "c/sqlite3.c"
   $20 = $19; //@line 56745 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 56745 "c/sqlite3.c"
   $22 = (($19) + 4)|0; //@line 56745 "c/sqlite3.c"
   $23 = $22; //@line 56745 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 56745 "c/sqlite3.c"
   $25 = ($24|0)>(0); //@line 56745 "c/sqlite3.c"
   $26 = ($21>>>0)>(32); //@line 56745 "c/sqlite3.c"
   $27 = ($24|0)==(0); //@line 56745 "c/sqlite3.c"
   $28 = $27 & $26; //@line 56745 "c/sqlite3.c"
   $29 = $25 | $28; //@line 56745 "c/sqlite3.c"
   L10: do {
    if ($29) {
     $30 = HEAP32[$15>>2]|0; //@line 56758 "c/sqlite3.c"
     $31 = (_sqlite3OsRead($30,$2,32,0,0)|0); //@line 56758 "c/sqlite3.c"
     $32 = ($31|0)==(0); //@line 56759 "c/sqlite3.c"
     do {
      if ($32) {
       $33 = (_sqlite3Get4byte($2)|0); //@line 56768 "c/sqlite3.c"
       $34 = ((($2)) + 8|0); //@line 56769 "c/sqlite3.c"
       $35 = (_sqlite3Get4byte($34)|0); //@line 56769 "c/sqlite3.c"
       $36 = $33 & -2; //@line 56770 "c/sqlite3.c"
       $37 = ($36|0)==(931071618); //@line 56770 "c/sqlite3.c"
       if ($37) {
        $38 = (($35) + -1)|0; //@line 56771 "c/sqlite3.c"
        $39 = $38 & $35; //@line 56771 "c/sqlite3.c"
        $40 = ($39|0)!=(0); //@line 56771 "c/sqlite3.c"
        $$off = (($35) + -512)|0; //@line 56772 "c/sqlite3.c"
        $41 = ($$off>>>0)>(65024); //@line 56772 "c/sqlite3.c"
        $42 = $41 | $40; //@line 56772 "c/sqlite3.c"
        if (!($42)) {
         $43 = $33 & 1; //@line 56777 "c/sqlite3.c"
         $44 = $43&255; //@line 56777 "c/sqlite3.c"
         $45 = ((($0)) + 65|0); //@line 56777 "c/sqlite3.c"
         HEAP8[$45>>0] = $44; //@line 56777 "c/sqlite3.c"
         $46 = ((($0)) + 36|0); //@line 56778 "c/sqlite3.c"
         HEAP32[$46>>2] = $35; //@line 56778 "c/sqlite3.c"
         $47 = ((($2)) + 12|0); //@line 56779 "c/sqlite3.c"
         $48 = (_sqlite3Get4byte($47)|0); //@line 56779 "c/sqlite3.c"
         $49 = ((($0)) + 112|0); //@line 56779 "c/sqlite3.c"
         HEAP32[$49>>2] = $48; //@line 56779 "c/sqlite3.c"
         $50 = ((($0)) + 84|0); //@line 56780 "c/sqlite3.c"
         $51 = ((($2)) + 16|0); //@line 56780 "c/sqlite3.c"
         $52 = $51; //@line 56780 "c/sqlite3.c"
         $53 = $52; //@line 56780 "c/sqlite3.c"
         $54 = HEAPU8[$53>>0]|(HEAPU8[$53+1>>0]<<8)|(HEAPU8[$53+2>>0]<<16)|(HEAPU8[$53+3>>0]<<24); //@line 56780 "c/sqlite3.c"
         $55 = (($52) + 4)|0; //@line 56780 "c/sqlite3.c"
         $56 = $55; //@line 56780 "c/sqlite3.c"
         $57 = HEAPU8[$56>>0]|(HEAPU8[$56+1>>0]<<8)|(HEAPU8[$56+2>>0]<<16)|(HEAPU8[$56+3>>0]<<24); //@line 56780 "c/sqlite3.c"
         $58 = $50; //@line 56780 "c/sqlite3.c"
         $59 = $58; //@line 56780 "c/sqlite3.c"
         HEAP8[$59>>0]=$54&255;HEAP8[$59+1>>0]=($54>>8)&255;HEAP8[$59+2>>0]=($54>>16)&255;HEAP8[$59+3>>0]=$54>>24; //@line 56780 "c/sqlite3.c"
         $60 = (($58) + 4)|0; //@line 56780 "c/sqlite3.c"
         $61 = $60; //@line 56780 "c/sqlite3.c"
         HEAP8[$61>>0]=$57&255;HEAP8[$61+1>>0]=($57>>8)&255;HEAP8[$61+2>>0]=($57>>16)&255;HEAP8[$61+3>>0]=$57>>24; //@line 56780 "c/sqlite3.c"
         $62 = $43 ^ 1; //@line 56783 "c/sqlite3.c"
         $63 = ((($0)) + 76|0); //@line 56784 "c/sqlite3.c"
         _walChecksumBytes($62,$2,24,0,$63); //@line 56783 "c/sqlite3.c"
         $64 = HEAP32[$63>>2]|0; //@line 56786 "c/sqlite3.c"
         $65 = ((($2)) + 24|0); //@line 56786 "c/sqlite3.c"
         $66 = (_sqlite3Get4byte($65)|0); //@line 56786 "c/sqlite3.c"
         $67 = ($64|0)==($66|0); //@line 56786 "c/sqlite3.c"
         if ($67) {
          $68 = ((($0)) + 80|0); //@line 56787 "c/sqlite3.c"
          $69 = HEAP32[$68>>2]|0; //@line 56787 "c/sqlite3.c"
          $70 = ((($2)) + 28|0); //@line 56787 "c/sqlite3.c"
          $71 = (_sqlite3Get4byte($70)|0); //@line 56787 "c/sqlite3.c"
          $72 = ($69|0)==($71|0); //@line 56787 "c/sqlite3.c"
          if ($72) {
           $73 = ((($2)) + 4|0); //@line 56794 "c/sqlite3.c"
           $74 = (_sqlite3Get4byte($73)|0); //@line 56794 "c/sqlite3.c"
           $75 = ($74|0)==(3007000); //@line 56795 "c/sqlite3.c"
           if ($75) {
            $77 = (($35) + 24)|0; //@line 56801 "c/sqlite3.c"
            $78 = ($77|0)<(0); //@line 56802 "c/sqlite3.c"
            $79 = $78 << 31 >> 31; //@line 56802 "c/sqlite3.c"
            $80 = (_sqlite3_malloc64($77,$79)|0); //@line 56802 "c/sqlite3.c"
            $81 = ($80|0)==(0|0); //@line 56803 "c/sqlite3.c"
            if ($81) {
             $$4 = 7;
             break;
            }
            $82 = ((($80)) + 24|0); //@line 56807 "c/sqlite3.c"
            $83 = (_i64Add(($77|0),($79|0),32,0)|0); //@line 56811 "c/sqlite3.c"
            $84 = tempRet0; //@line 56811 "c/sqlite3.c"
            $85 = $1; //@line 56811 "c/sqlite3.c"
            $86 = $85; //@line 56811 "c/sqlite3.c"
            $87 = HEAP32[$86>>2]|0; //@line 56811 "c/sqlite3.c"
            $88 = (($85) + 4)|0; //@line 56811 "c/sqlite3.c"
            $89 = $88; //@line 56811 "c/sqlite3.c"
            $90 = HEAP32[$89>>2]|0; //@line 56811 "c/sqlite3.c"
            $91 = ($84|0)>($90|0); //@line 56811 "c/sqlite3.c"
            $92 = ($83>>>0)>($87>>>0); //@line 56811 "c/sqlite3.c"
            $93 = ($84|0)==($90|0); //@line 56811 "c/sqlite3.c"
            $94 = $93 & $92; //@line 56811 "c/sqlite3.c"
            $95 = $91 | $94; //@line 56811 "c/sqlite3.c"
            L22: do {
             if ($95) {
              $$3 = 0;$$sroa$0$0138 = 0;$$sroa$5$0136 = 0;
             } else {
              $96 = ((($0)) + 68|0);
              $97 = ((($0)) + 72|0);
              $98 = $35 & 65280;
              $99 = $35 >>> 16;
              $100 = $98 | $99;
              $101 = $100&65535;
              $102 = ((($0)) + 66|0);
              $$0124141 = 0;$$sroa$0$0143 = 0;$$sroa$5$0144 = 0;$105 = 32;$106 = 0;$118 = $83;$119 = $84;
              while(1) {
               $103 = (($$0124141) + 1)|0; //@line 56816 "c/sqlite3.c"
               $104 = HEAP32[$15>>2]|0; //@line 56817 "c/sqlite3.c"
               $107 = (_sqlite3OsRead($104,$80,$77,$105,$106)|0); //@line 56817 "c/sqlite3.c"
               $108 = ($107|0)==(0); //@line 56818 "c/sqlite3.c"
               if (!($108)) {
                $$2$ph = $107;
                break;
               }
               $109 = (_walDecodeFrame($0,$3,$4,$82,$80)|0); //@line 56819 "c/sqlite3.c"
               $110 = ($109|0)==(0); //@line 56820 "c/sqlite3.c"
               if ($110) {
                $$2$ph = 0;
                break;
               }
               $111 = HEAP32[$3>>2]|0; //@line 56821 "c/sqlite3.c"
               $112 = (_walIndexAppend($0,$103,$111)|0); //@line 56821 "c/sqlite3.c"
               $113 = ($112|0)==(0); //@line 56822 "c/sqlite3.c"
               if (!($113)) {
                $$2$ph = $112;
                break;
               }
               $114 = HEAP32[$4>>2]|0; //@line 56825 "c/sqlite3.c"
               $115 = ($114|0)==(0); //@line 56825 "c/sqlite3.c"
               if ($115) {
                $$sroa$0$2 = $$sroa$0$0143;$$sroa$5$2 = $$sroa$5$0144;
               } else {
                HEAP32[$96>>2] = $103; //@line 56826 "c/sqlite3.c"
                HEAP32[$97>>2] = $114; //@line 56827 "c/sqlite3.c"
                HEAP16[$102>>1] = $101; //@line 56828 "c/sqlite3.c"
                $116 = HEAP32[$63>>2]|0; //@line 56831 "c/sqlite3.c"
                $117 = HEAP32[$68>>2]|0; //@line 56832 "c/sqlite3.c"
                $$sroa$0$2 = $116;$$sroa$5$2 = $117;
               }
               $120 = (_i64Add(($118|0),($119|0),($77|0),($79|0))|0); //@line 56811 "c/sqlite3.c"
               $121 = tempRet0; //@line 56811 "c/sqlite3.c"
               $122 = $1; //@line 56811 "c/sqlite3.c"
               $123 = $122; //@line 56811 "c/sqlite3.c"
               $124 = HEAP32[$123>>2]|0; //@line 56811 "c/sqlite3.c"
               $125 = (($122) + 4)|0; //@line 56811 "c/sqlite3.c"
               $126 = $125; //@line 56811 "c/sqlite3.c"
               $127 = HEAP32[$126>>2]|0; //@line 56811 "c/sqlite3.c"
               $128 = ($121|0)>($127|0); //@line 56811 "c/sqlite3.c"
               $129 = ($120>>>0)>($124>>>0); //@line 56811 "c/sqlite3.c"
               $130 = ($121|0)==($127|0); //@line 56811 "c/sqlite3.c"
               $131 = $130 & $129; //@line 56811 "c/sqlite3.c"
               $132 = $128 | $131; //@line 56811 "c/sqlite3.c"
               if ($132) {
                $$3 = 0;$$sroa$0$0138 = $$sroa$0$2;$$sroa$5$0136 = $$sroa$5$2;
                break L22;
               } else {
                $106$phi = $119;$105$phi = $118;$$0124141 = $103;$$sroa$0$0143 = $$sroa$0$2;$$sroa$5$0144 = $$sroa$5$2;$118 = $120;$119 = $121;$106 = $106$phi;$105 = $105$phi;
               }
              }
              $$3 = $$2$ph;$$sroa$0$0138 = $$sroa$0$0143;$$sroa$5$0136 = $$sroa$5$0144;
             }
            } while(0);
            _sqlite3_free($80); //@line 56836 "c/sqlite3.c"
            $$4$ph = $$3;$$sroa$0$4$ph = $$sroa$0$0138;$$sroa$5$4$ph = $$sroa$5$0136;
           } else {
            $76 = (_sqlite3CantopenError(56796)|0); //@line 56796 "c/sqlite3.c"
            $$4$ph = $76;$$sroa$0$4$ph = 0;$$sroa$5$4$ph = 0;
           }
           $133 = ($$4$ph|0)==(0); //@line 56840 "c/sqlite3.c"
           if ($133) {
            $$sroa$0$5130 = $$sroa$0$4$ph;$$sroa$5$5131 = $$sroa$5$4$ph;
            break L10;
           } else {
            $$6 = $$4$ph;
            break L8;
           }
          }
         }
        }
       }
       $$sroa$0$5130 = 0;$$sroa$5$5131 = 0;
       break L10;
      } else {
       $$4 = $31;
      }
     } while(0);
     $$6 = $$4;
     break L8;
    } else {
     $$sroa$0$5130 = 0;$$sroa$5$5131 = 0;
    }
   } while(0);
   $134 = ((($0)) + 76|0); //@line 56843 "c/sqlite3.c"
   HEAP32[$134>>2] = $$sroa$0$5130; //@line 56843 "c/sqlite3.c"
   $135 = ((($0)) + 80|0); //@line 56844 "c/sqlite3.c"
   HEAP32[$135>>2] = $$sroa$5$5131; //@line 56844 "c/sqlite3.c"
   _walIndexWriteHdr($0); //@line 56845 "c/sqlite3.c"
   $136 = (_walCkptInfo($0)|0); //@line 56851 "c/sqlite3.c"
   HEAP32[$136>>2] = 0; //@line 56852 "c/sqlite3.c"
   $137 = ((($0)) + 68|0); //@line 56853 "c/sqlite3.c"
   $138 = HEAP32[$137>>2]|0; //@line 56853 "c/sqlite3.c"
   $139 = ((($136)) + 32|0); //@line 56853 "c/sqlite3.c"
   HEAP32[$139>>2] = $138; //@line 56853 "c/sqlite3.c"
   $140 = ((($136)) + 4|0); //@line 56854 "c/sqlite3.c"
   HEAP32[$140>>2] = 0; //@line 56854 "c/sqlite3.c"
   $141 = ((($136)) + 8|0); //@line 56855 "c/sqlite3.c"
   HEAP32[$141>>2] = -1; //@line 56855 "c/sqlite3.c"
   $142 = ((($136)) + 12|0); //@line 56855 "c/sqlite3.c"
   HEAP32[$142>>2] = -1; //@line 56855 "c/sqlite3.c"
   $143 = ((($136)) + 16|0); //@line 56855 "c/sqlite3.c"
   HEAP32[$143>>2] = -1; //@line 56855 "c/sqlite3.c"
   $144 = ((($136)) + 20|0); //@line 56855 "c/sqlite3.c"
   HEAP32[$144>>2] = -1; //@line 56855 "c/sqlite3.c"
   $145 = HEAP32[$137>>2]|0; //@line 56856 "c/sqlite3.c"
   $146 = ($145|0)==(0); //@line 56856 "c/sqlite3.c"
   if (!($146)) {
    $147 = ((($136)) + 8|0); //@line 56856 "c/sqlite3.c"
    HEAP32[$147>>2] = $145; //@line 56856 "c/sqlite3.c"
   }
   $148 = ((($0)) + 72|0); //@line 56863 "c/sqlite3.c"
   $149 = HEAP32[$148>>2]|0; //@line 56863 "c/sqlite3.c"
   $150 = ($149|0)==(0); //@line 56863 "c/sqlite3.c"
   if ($150) {
    $$6 = 0;
   } else {
    $151 = HEAP32[$137>>2]|0; //@line 56866 "c/sqlite3.c"
    $152 = ((($0)) + 108|0); //@line 56866 "c/sqlite3.c"
    $153 = HEAP32[$152>>2]|0; //@line 56866 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $151; //@line 56864 "c/sqlite3.c"
    $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 56864 "c/sqlite3.c"
    HEAP32[$vararg_ptr1>>2] = $153; //@line 56864 "c/sqlite3.c"
    _sqlite3_log(283,18405,$vararg_buffer); //@line 56864 "c/sqlite3.c"
    $$6 = 0;
   }
  } else {
   $$6 = $17;
  }
 } while(0);
 _walUnlockExclusive($0,$8,$9); //@line 56873 "c/sqlite3.c"
 _walUnlockExclusive($0,4,4); //@line 56874 "c/sqlite3.c"
 $$0119 = $$6;
 STACKTOP = sp;return ($$0119|0); //@line 56876 "c/sqlite3.c"
}
function _walIndexClose($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 43|0); //@line 56882 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 56882 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(2); //@line 56882 "c/sqlite3.c"
 if ($4) {
  label = 3;
 } else {
  $5 = ((($0)) + 50|0); //@line 56882 "c/sqlite3.c"
  $6 = HEAP8[$5>>0]|0; //@line 56882 "c/sqlite3.c"
  $7 = ($6<<24>>24)==(0); //@line 56882 "c/sqlite3.c"
  if (!($7)) {
   label = 3;
  }
 }
 if ((label|0) == 3) {
  $8 = ((($0)) + 24|0); //@line 56884 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 56884 "c/sqlite3.c"
  $10 = ($9|0)>(0); //@line 56884 "c/sqlite3.c"
  if ($10) {
   $11 = ((($0)) + 32|0);
   $$012 = 0;
   while(1) {
    $12 = HEAP32[$11>>2]|0; //@line 56885 "c/sqlite3.c"
    $13 = (($12) + ($$012<<2)|0); //@line 56885 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 56885 "c/sqlite3.c"
    _sqlite3_free($14); //@line 56885 "c/sqlite3.c"
    $15 = HEAP32[$11>>2]|0; //@line 56886 "c/sqlite3.c"
    $16 = (($15) + ($$012<<2)|0); //@line 56886 "c/sqlite3.c"
    HEAP32[$16>>2] = 0; //@line 56886 "c/sqlite3.c"
    $17 = (($$012) + 1)|0; //@line 56884 "c/sqlite3.c"
    $18 = HEAP32[$8>>2]|0; //@line 56884 "c/sqlite3.c"
    $19 = ($17|0)<($18|0); //@line 56884 "c/sqlite3.c"
    if ($19) {
     $$012 = $17;
    } else {
     break;
    }
   }
  }
 }
 $20 = HEAP8[$2>>0]|0; //@line 56889 "c/sqlite3.c"
 $21 = ($20<<24>>24)==(2); //@line 56889 "c/sqlite3.c"
 if ($21) {
  return; //@line 56892 "c/sqlite3.c"
 }
 $22 = ((($0)) + 4|0); //@line 56890 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 56890 "c/sqlite3.c"
 _sqlite3OsShmUnmap($23,$1); //@line 56890 "c/sqlite3.c"
 return; //@line 56892 "c/sqlite3.c"
}
function _sqlite3OsShmUnmap($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 20974 "c/sqlite3.c"
 $3 = ((($2)) + 64|0); //@line 20974 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 20974 "c/sqlite3.c"
 (FUNCTION_TABLE_iii[$4 & 255]($0,$1)|0); //@line 20974 "c/sqlite3.c"
 return;
}
function _invalidateAllOverflowCache($0) {
 $0 = $0|0;
 var $$0 = 0, $$05 = 0, $$06 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 60914 "c/sqlite3.c"
 $$05 = HEAP32[$1>>2]|0;
 $2 = ($$05|0)==(0|0); //@line 60914 "c/sqlite3.c"
 if ($2) {
  return; //@line 60917 "c/sqlite3.c"
 }
 $$06 = $$05;
 while(1) {
  $3 = ((($$06)) + 1|0); //@line 60915 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 60915 "c/sqlite3.c"
  $5 = $4 & -5; //@line 60915 "c/sqlite3.c"
  HEAP8[$3>>0] = $5; //@line 60915 "c/sqlite3.c"
  $6 = ((($$06)) + 16|0); //@line 60914 "c/sqlite3.c"
  $$0 = HEAP32[$6>>2]|0;
  $7 = ($$0|0)==(0|0); //@line 60914 "c/sqlite3.c"
  if ($7) {
   break;
  } else {
   $$06 = $$0;
  }
 }
 return; //@line 60917 "c/sqlite3.c"
}
function _finalDbSize($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond25 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 36|0); //@line 64141 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 64141 "c/sqlite3.c"
 $5 = (($4>>>0) / 5)&-1; //@line 64141 "c/sqlite3.c"
 $6 = (($2) - ($1))|0; //@line 64142 "c/sqlite3.c"
 $7 = (_ptrmapPageno($0,$1)|0); //@line 64142 "c/sqlite3.c"
 $8 = (($6) + ($7))|0; //@line 64142 "c/sqlite3.c"
 $9 = (($8) + ($5))|0; //@line 64142 "c/sqlite3.c"
 $10 = (($9>>>0) / ($5>>>0))&-1; //@line 64142 "c/sqlite3.c"
 $11 = (($1) - ($2))|0; //@line 64143 "c/sqlite3.c"
 $12 = (($11) - ($10))|0; //@line 64143 "c/sqlite3.c"
 $13 = HEAP32[513]|0; //@line 64144 "c/sqlite3.c"
 $14 = ((($0)) + 32|0); //@line 64144 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 64144 "c/sqlite3.c"
 $16 = (($13>>>0) / ($15>>>0))&-1; //@line 64144 "c/sqlite3.c"
 $17 = (($16) + 1)|0; //@line 64144 "c/sqlite3.c"
 $18 = ($17>>>0)<($1>>>0); //@line 64144 "c/sqlite3.c"
 $19 = ($12>>>0)<($17>>>0); //@line 64144 "c/sqlite3.c"
 $or$cond = $18 & $19; //@line 64144 "c/sqlite3.c"
 $20 = $or$cond << 31 >> 31; //@line 64144 "c/sqlite3.c"
 $$0 = (($12) + ($20))|0; //@line 64144 "c/sqlite3.c"
 $$1 = $$0;
 while(1) {
  $21 = (_ptrmapPageno($0,$$1)|0); //@line 64147 "c/sqlite3.c"
  $22 = ($21|0)==($$1|0); //@line 64147 "c/sqlite3.c"
  $23 = ($$1|0)==($17|0); //@line 64147 "c/sqlite3.c"
  $or$cond25 = $23 | $22; //@line 64147 "c/sqlite3.c"
  $24 = (($$1) + -1)|0; //@line 64148 "c/sqlite3.c"
  if ($or$cond25) {
   $$1 = $24;
  } else {
   break;
  }
 }
 return ($$1|0); //@line 64151 "c/sqlite3.c"
}
function _incrVacuumStep($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$062 = 0, $$361$ph = 0, $$5$ph = 0, $$6 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0;
 var $spec$select63 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp + 16|0;
 $5 = sp + 12|0;
 $6 = sp + 8|0;
 $7 = sp + 4|0;
 $8 = sp;
 $9 = (_ptrmapPageno($0,$2)|0); //@line 64047 "c/sqlite3.c"
 $10 = ($9|0)==($2|0); //@line 64047 "c/sqlite3.c"
 L1: do {
  if (!($10)) {
   $11 = HEAP32[513]|0; //@line 64047 "c/sqlite3.c"
   $12 = ((($0)) + 32|0); //@line 64047 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 64047 "c/sqlite3.c"
   $14 = (($11>>>0) / ($13>>>0))&-1; //@line 64047 "c/sqlite3.c"
   $15 = (($14) + 1)|0; //@line 64047 "c/sqlite3.c"
   $16 = ($15|0)==($2|0); //@line 64047 "c/sqlite3.c"
   if (!($16)) {
    $17 = ((($0)) + 12|0); //@line 64051 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 64051 "c/sqlite3.c"
    $19 = ((($18)) + 56|0); //@line 64051 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 64051 "c/sqlite3.c"
    $21 = ((($20)) + 36|0); //@line 64051 "c/sqlite3.c"
    $22 = (_sqlite3Get4byte($21)|0); //@line 64051 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 64052 "c/sqlite3.c"
    L4: do {
     if ($23) {
      $$5$ph = 101;
     } else {
      $24 = (_ptrmapGet($0,$2,$4,$5)|0); //@line 64056 "c/sqlite3.c"
      $25 = ($24|0)==(0); //@line 64057 "c/sqlite3.c"
      if ($25) {
       $26 = HEAP8[$4>>0]|0; //@line 64060 "c/sqlite3.c"
       L7: do {
        switch ($26<<24>>24) {
        case 1:  {
         $27 = (_sqlite3CorruptError(64061)|0); //@line 64061 "c/sqlite3.c"
         $$5$ph = $27;
         break L4;
         break;
        }
        case 2:  {
         $28 = ($3|0)==(0); //@line 64065 "c/sqlite3.c"
         if ($28) {
          $29 = (_allocateBtreePage($0,$7,$6,$2,1)|0); //@line 64073 "c/sqlite3.c"
          $30 = ($29|0)==(0); //@line 64074 "c/sqlite3.c"
          if ($30) {
           $31 = HEAP32[$7>>2]|0; //@line 64078 "c/sqlite3.c"
           _releasePage($31); //@line 64078 "c/sqlite3.c"
           break L7;
          } else {
           $$5$ph = $29;
           break L4;
          }
         }
         break;
        }
        default: {
         $32 = (_btreeGetPage($0,$2,$7,0)|0); //@line 64086 "c/sqlite3.c"
         $33 = ($32|0)==(0); //@line 64087 "c/sqlite3.c"
         do {
          if ($33) {
           $34 = ($3|0)==(0); //@line 64098 "c/sqlite3.c"
           $spec$select = $34 ? 2 : 0; //@line 64098 "c/sqlite3.c"
           $spec$select63 = $34 ? $1 : 0; //@line 64098 "c/sqlite3.c"
           $35 = ($3|0)!=(0);
           while(1) {
            $36 = (_allocateBtreePage($0,$8,$6,$spec$select63,$spec$select)|0); //@line 64104 "c/sqlite3.c"
            $37 = ($36|0)==(0); //@line 64105 "c/sqlite3.c"
            if (!($37)) {
             label = 14;
             break;
            }
            $39 = HEAP32[$8>>2]|0; //@line 64109 "c/sqlite3.c"
            _releasePage($39); //@line 64109 "c/sqlite3.c"
            $40 = HEAP32[$6>>2]|0; //@line 64110 "c/sqlite3.c"
            $41 = ($40>>>0)>($1>>>0); //@line 64110 "c/sqlite3.c"
            $or$cond = $35 & $41; //@line 64110 "c/sqlite3.c"
            if (!($or$cond)) {
             break;
            }
           }
           if ((label|0) == 14) {
            $38 = HEAP32[$7>>2]|0; //@line 64106 "c/sqlite3.c"
            _releasePage($38); //@line 64106 "c/sqlite3.c"
            $$361$ph = $36;
            break;
           }
           $42 = HEAP32[$7>>2]|0; //@line 64113 "c/sqlite3.c"
           $43 = HEAP32[$5>>2]|0; //@line 64113 "c/sqlite3.c"
           $44 = (_relocatePage($0,$42,$26,$43,$40,$3)|0); //@line 64113 "c/sqlite3.c"
           _releasePage($42); //@line 64114 "c/sqlite3.c"
           $45 = ($44|0)==(0); //@line 64115 "c/sqlite3.c"
           if ($45) {
            break L7;
           } else {
            $$361$ph = $44;
           }
          } else {
           $$361$ph = $32;
          }
         } while(0);
         $$5$ph = $$361$ph;
         break L4;
        }
        }
       } while(0);
       break L1;
      } else {
       $$5$ph = $24;
      }
     }
    } while(0);
    $$6 = $$5$ph;
    STACKTOP = sp;return ($$6|0); //@line 64129 "c/sqlite3.c"
   }
  }
 } while(0);
 $46 = ($3|0)==(0); //@line 64121 "c/sqlite3.c"
 if (!($46)) {
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 64129 "c/sqlite3.c"
 }
 $47 = HEAP32[513]|0;
 $48 = ((($0)) + 32|0);
 $49 = HEAP32[$48>>2]|0;
 $50 = (($47>>>0) / ($49>>>0))&-1;
 $51 = (($50) + 1)|0;
 $$062 = $2;
 while(1) {
  $52 = (($$062) + -1)|0; //@line 64123 "c/sqlite3.c"
  $53 = ($52|0)==($51|0); //@line 64124 "c/sqlite3.c"
  if (!($53)) {
   $54 = (_ptrmapPageno($0,$52)|0); //@line 64124 "c/sqlite3.c"
   $55 = ($54|0)==($52|0); //@line 64124 "c/sqlite3.c"
   if (!($55)) {
    break;
   }
  }
  $$062 = $52;
 }
 $56 = ((($0)) + 19|0); //@line 64125 "c/sqlite3.c"
 HEAP8[$56>>0] = 1; //@line 64125 "c/sqlite3.c"
 $57 = ((($0)) + 44|0); //@line 64126 "c/sqlite3.c"
 HEAP32[$57>>2] = $52; //@line 64126 "c/sqlite3.c"
 $$6 = 0;
 STACKTOP = sp;return ($$6|0); //@line 64129 "c/sqlite3.c"
}
function _allocateBtreePage($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0209 = 0, $$0218335 = 0, $$0220336 = 0, $$0229333 = 0, $$0233 = 0, $$0234 = 0, $$10264 = 0, $$12 = 0, $$1217 = 0, $$1221334 = 0, $$1235 = 0, $$2211$ph = 0, $$2236 = 0, $$2239 = 0, $$3232 = 0, $$6 = 0, $$8 = 0, $$8$ph271 = 0, $$cast = 0, $$not = 0;
 var $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0;
 var $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0;
 var $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0;
 var $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0;
 var $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0;
 var $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0;
 var $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0;
 var $227 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0;
 var $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $or$cond245 = 0, $or$cond248 = 0, $or$cond249 = 0, $or$cond342 = 0, $or$cond343 = 0, $spec$select = 0, $spec$select246 = 0, $spec$select247 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp + 4|0;
 $6 = sp;
 HEAP32[$5>>2] = 0; //@line 66149 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 66155 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 66155 "c/sqlite3.c"
 $9 = (_btreePagecount($0)|0); //@line 66156 "c/sqlite3.c"
 $10 = ((($8)) + 56|0); //@line 66159 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 66159 "c/sqlite3.c"
 $12 = ((($11)) + 36|0); //@line 66159 "c/sqlite3.c"
 $13 = (_sqlite3Get4byte($12)|0); //@line 66159 "c/sqlite3.c"
 $14 = ($13>>>0)<($9>>>0); //@line 66161 "c/sqlite3.c"
 if (!($14)) {
  $15 = (_sqlite3CorruptError(66162)|0); //@line 66162 "c/sqlite3.c"
  $$6 = $15;
  STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
 }
 $16 = ($13|0)==(0); //@line 66164 "c/sqlite3.c"
 L5: do {
  if ($16) {
   $176 = ((($0)) + 19|0); //@line 66398 "c/sqlite3.c"
   $177 = HEAP8[$176>>0]|0; //@line 66398 "c/sqlite3.c"
   $178 = ($177<<24>>24)==(0); //@line 66398 "c/sqlite3.c"
   $179 = $178&1; //@line 66398 "c/sqlite3.c"
   $180 = ((($8)) + 72|0); //@line 66400 "c/sqlite3.c"
   $181 = HEAP32[$180>>2]|0; //@line 66400 "c/sqlite3.c"
   $182 = (_sqlite3PagerWrite($181)|0); //@line 66400 "c/sqlite3.c"
   $183 = ($182|0)==(0); //@line 66401 "c/sqlite3.c"
   if (!($183)) {
    $$6 = $182;
    STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
   }
   $184 = ((($0)) + 44|0); //@line 66402 "c/sqlite3.c"
   $185 = HEAP32[$184>>2]|0; //@line 66402 "c/sqlite3.c"
   $186 = (($185) + 1)|0; //@line 66402 "c/sqlite3.c"
   HEAP32[$184>>2] = $186; //@line 66402 "c/sqlite3.c"
   $187 = HEAP32[513]|0; //@line 66403 "c/sqlite3.c"
   $188 = ((($0)) + 32|0); //@line 66403 "c/sqlite3.c"
   $189 = HEAP32[$188>>2]|0; //@line 66403 "c/sqlite3.c"
   $190 = (($187>>>0) / ($189>>>0))&-1; //@line 66403 "c/sqlite3.c"
   $191 = ($185|0)==($190|0); //@line 66403 "c/sqlite3.c"
   if ($191) {
    $192 = (($185) + 2)|0; //@line 66403 "c/sqlite3.c"
    HEAP32[$184>>2] = $192; //@line 66403 "c/sqlite3.c"
   }
   $193 = ((($0)) + 17|0); //@line 66406 "c/sqlite3.c"
   $194 = HEAP8[$193>>0]|0; //@line 66406 "c/sqlite3.c"
   $195 = ($194<<24>>24)==(0); //@line 66406 "c/sqlite3.c"
   do {
    if (!($195)) {
     $196 = HEAP32[$184>>2]|0; //@line 66406 "c/sqlite3.c"
     $197 = (_ptrmapPageno($0,$196)|0); //@line 66406 "c/sqlite3.c"
     $198 = ($197|0)==($196|0); //@line 66406 "c/sqlite3.c"
     if ($198) {
      HEAP32[$6>>2] = 0; //@line 66411 "c/sqlite3.c"
      $199 = (_btreeGetUnusedPage($0,$196,$6,$179)|0); //@line 66414 "c/sqlite3.c"
      $200 = ($199|0)==(0); //@line 66415 "c/sqlite3.c"
      if ($200) {
       $201 = HEAP32[$6>>2]|0; //@line 66416 "c/sqlite3.c"
       $202 = ((($201)) + 72|0); //@line 66416 "c/sqlite3.c"
       $203 = HEAP32[$202>>2]|0; //@line 66416 "c/sqlite3.c"
       $204 = (_sqlite3PagerWrite($203)|0); //@line 66416 "c/sqlite3.c"
       _releasePage($201); //@line 66417 "c/sqlite3.c"
       $205 = ($204|0)==(0); //@line 66419 "c/sqlite3.c"
       if ($205) {
        $206 = HEAP32[$184>>2]|0; //@line 66420 "c/sqlite3.c"
        $207 = (($206) + 1)|0; //@line 66420 "c/sqlite3.c"
        HEAP32[$184>>2] = $207; //@line 66420 "c/sqlite3.c"
        $208 = HEAP32[513]|0; //@line 66421 "c/sqlite3.c"
        $209 = HEAP32[$188>>2]|0; //@line 66421 "c/sqlite3.c"
        $210 = (($208>>>0) / ($209>>>0))&-1; //@line 66421 "c/sqlite3.c"
        $211 = ($206|0)==($210|0); //@line 66421 "c/sqlite3.c"
        if ($211) {
         $212 = (($206) + 2)|0; //@line 66421 "c/sqlite3.c"
         HEAP32[$184>>2] = $212; //@line 66421 "c/sqlite3.c"
        }
        break;
       } else {
        $$10264 = $204;
       }
      } else {
       $$10264 = $199;
      }
      $$6 = $$10264;
      STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
     }
    }
   } while(0);
   $213 = HEAP32[$7>>2]|0; //@line 66424 "c/sqlite3.c"
   $214 = ((($213)) + 56|0); //@line 66424 "c/sqlite3.c"
   $215 = HEAP32[$214>>2]|0; //@line 66424 "c/sqlite3.c"
   $216 = ((($215)) + 28|0); //@line 66424 "c/sqlite3.c"
   $217 = HEAP32[$184>>2]|0; //@line 66424 "c/sqlite3.c"
   _sqlite3Put4byte($216,$217); //@line 66424 "c/sqlite3.c"
   $218 = HEAP32[$184>>2]|0; //@line 66425 "c/sqlite3.c"
   HEAP32[$2>>2] = $218; //@line 66425 "c/sqlite3.c"
   $219 = (_btreeGetUnusedPage($0,$218,$1,$179)|0); //@line 66428 "c/sqlite3.c"
   $220 = ($219|0)==(0); //@line 66429 "c/sqlite3.c"
   if (!($220)) {
    $$6 = $219;
    STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
   }
   $221 = HEAP32[$1>>2]|0; //@line 66430 "c/sqlite3.c"
   $222 = ((($221)) + 72|0); //@line 66430 "c/sqlite3.c"
   $223 = HEAP32[$222>>2]|0; //@line 66430 "c/sqlite3.c"
   $224 = (_sqlite3PagerWrite($223)|0); //@line 66430 "c/sqlite3.c"
   $225 = ($224|0)==(0); //@line 66431 "c/sqlite3.c"
   if ($225) {
    $$12 = 0;$$1217 = 0;
   } else {
    $226 = HEAP32[$1>>2]|0; //@line 66432 "c/sqlite3.c"
    _releasePage($226); //@line 66432 "c/sqlite3.c"
    HEAP32[$1>>2] = 0; //@line 66433 "c/sqlite3.c"
    $$12 = $224;$$1217 = 0;
   }
  } else {
   L30: do {
    switch ($4<<24>>24) {
    case 1:  {
     $17 = ($9>>>0)<($3>>>0); //@line 66176 "c/sqlite3.c"
     if ($17) {
      $$2239 = 0;
     } else {
      $18 = (_ptrmapGet($0,$3,$6,0)|0); //@line 66180 "c/sqlite3.c"
      $19 = ($18|0)==(0); //@line 66181 "c/sqlite3.c"
      if ($19) {
       $20 = HEAP8[$6>>0]|0; //@line 66182 "c/sqlite3.c"
       $21 = ($20<<24>>24)==(2); //@line 66182 "c/sqlite3.c"
       $spec$select = $21&1; //@line 66182 "c/sqlite3.c"
       $$2239 = $spec$select;
       break L30;
      }
      $$6 = $18;
      STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
     }
     break;
    }
    case 2:  {
     $$2239 = 1;
     break;
    }
    default: {
     $$2239 = 0;
    }
    }
   } while(0);
   $22 = ((($8)) + 72|0); //@line 66194 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 66194 "c/sqlite3.c"
   $24 = (_sqlite3PagerWrite($23)|0); //@line 66194 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 66195 "c/sqlite3.c"
   if (!($25)) {
    $$6 = $24;
    STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
   }
   $26 = HEAP32[$10>>2]|0; //@line 66196 "c/sqlite3.c"
   $27 = ((($26)) + 36|0); //@line 66196 "c/sqlite3.c"
   $28 = (($13) + -1)|0; //@line 66196 "c/sqlite3.c"
   _sqlite3Put4byte($27,$28); //@line 66196 "c/sqlite3.c"
   $29 = ($$2239<<24>>24)!=(0);
   $30 = ((($0)) + 36|0);
   $31 = ($$2239<<24>>24)==(0);
   $32 = ($$2239<<24>>24)==(0);
   $33 = ($3|0)==(0);
   $34 = ($4<<24>>24)==(2);
   $35 = ($4<<24>>24)==(2);
   $$not = $29 ^ 1;
   $36 = ($4<<24>>24)==(2);
   $$0234 = 0;
   while(1) {
    $37 = HEAP32[$5>>2]|0; //@line 66204 "c/sqlite3.c"
    $38 = ($37|0)!=(0|0); //@line 66205 "c/sqlite3.c"
    if ($38) {
     $39 = ((($37)) + 56|0); //@line 66209 "c/sqlite3.c"
     $40 = HEAP32[$39>>2]|0; //@line 66209 "c/sqlite3.c"
     $41 = (_sqlite3Get4byte($40)|0); //@line 66209 "c/sqlite3.c"
     $$0233 = $41;
    } else {
     $42 = HEAP32[$10>>2]|0; //@line 66214 "c/sqlite3.c"
     $43 = ((($42)) + 32|0); //@line 66214 "c/sqlite3.c"
     $44 = (_sqlite3Get4byte($43)|0); //@line 66214 "c/sqlite3.c"
     $$0233 = $44;
    }
    $45 = ($$0233>>>0)>($9>>>0); //@line 66217 "c/sqlite3.c"
    if ($45) {
     $$1235 = $$0234;
     label = 17;
    } else {
     $46 = (($$0234) + 1)|0; //@line 66217 "c/sqlite3.c"
     $47 = ($$0234>>>0)>($13>>>0); //@line 66217 "c/sqlite3.c"
     if ($47) {
      $$1235 = $46;
      label = 17;
     } else {
      $49 = (_btreeGetUnusedPage($0,$$0233,$5,0)|0); //@line 66220 "c/sqlite3.c"
      $$0209 = $49;$$2236 = $46;
     }
    }
    if ((label|0) == 17) {
     label = 0;
     $48 = (_sqlite3CorruptError(66218)|0); //@line 66218 "c/sqlite3.c"
     $$0209 = $48;$$2236 = $$1235;
    }
    $50 = ($$0209|0)==(0); //@line 66222 "c/sqlite3.c"
    if (!($50)) {
     label = 20;
     break;
    }
    $51 = HEAP32[$5>>2]|0; //@line 66230 "c/sqlite3.c"
    $52 = ((($51)) + 56|0); //@line 66230 "c/sqlite3.c"
    $53 = HEAP32[$52>>2]|0; //@line 66230 "c/sqlite3.c"
    $54 = ((($53)) + 4|0); //@line 66230 "c/sqlite3.c"
    $55 = (_sqlite3Get4byte($54)|0); //@line 66230 "c/sqlite3.c"
    $56 = ($55|0)!=(0); //@line 66231 "c/sqlite3.c"
    $or$cond = $29 | $56; //@line 66231 "c/sqlite3.c"
    if (!($or$cond)) {
     label = 22;
     break;
    }
    $67 = HEAP32[$30>>2]|0; //@line 66245 "c/sqlite3.c"
    $68 = $67 >>> 2; //@line 66245 "c/sqlite3.c"
    $69 = (($68) + -2)|0; //@line 66245 "c/sqlite3.c"
    $70 = ($55>>>0)>($69>>>0); //@line 66245 "c/sqlite3.c"
    if ($70) {
     label = 25;
     break;
    }
    if (!($31)) {
     $72 = ($$0233|0)==($3|0); //@line 66251 "c/sqlite3.c"
     $73 = ($$0233>>>0)<($3>>>0); //@line 66251 "c/sqlite3.c"
     $or$cond245 = $34 & $73; //@line 66251 "c/sqlite3.c"
     $or$cond342 = $72 | $or$cond245; //@line 66251 "c/sqlite3.c"
     if ($or$cond342) {
      label = 28;
      break;
     }
    }
    $125 = ($55|0)==(0); //@line 66312 "c/sqlite3.c"
    if ($125) {
     $$8 = 0;
    } else {
     L62: do {
      if ($33) {
       $$3232 = 0;
      } else {
       if ($35) {
        $$0220336 = 0;
        while(1) {
         $126 = $$0220336 << 2; //@line 66322 "c/sqlite3.c"
         $127 = (($126) + 8)|0; //@line 66322 "c/sqlite3.c"
         $128 = (($53) + ($127)|0); //@line 66322 "c/sqlite3.c"
         $129 = (_sqlite3Get4byte($128)|0); //@line 66322 "c/sqlite3.c"
         $130 = ($129>>>0)>($3>>>0); //@line 66323 "c/sqlite3.c"
         if (!($130)) {
          $$3232 = $$0220336;
          break L62;
         }
         $131 = (($$0220336) + 1)|0; //@line 66321 "c/sqlite3.c"
         $132 = ($131>>>0)<($55>>>0); //@line 66321 "c/sqlite3.c"
         if ($132) {
          $$0220336 = $131;
         } else {
          $$3232 = 0;
          break;
         }
        }
       } else {
        $133 = ($55>>>0)>(1); //@line 66331 "c/sqlite3.c"
        if (!($133)) {
         $$3232 = 0;
         break;
        }
        $134 = ((($53)) + 8|0); //@line 66330 "c/sqlite3.c"
        $135 = (_sqlite3Get4byte($134)|0); //@line 66330 "c/sqlite3.c"
        $136 = (($135) - ($3))|0; //@line 66330 "c/sqlite3.c"
        $137 = (_sqlite3AbsInt32($136)|0); //@line 66330 "c/sqlite3.c"
        $$0218335 = $137;$$0229333 = 0;$$1221334 = 1;
        while(1) {
         $138 = $$1221334 << 2; //@line 66332 "c/sqlite3.c"
         $139 = (($138) + 8)|0; //@line 66332 "c/sqlite3.c"
         $140 = (($53) + ($139)|0); //@line 66332 "c/sqlite3.c"
         $141 = (_sqlite3Get4byte($140)|0); //@line 66332 "c/sqlite3.c"
         $142 = (($141) - ($3))|0; //@line 66332 "c/sqlite3.c"
         $143 = (_sqlite3AbsInt32($142)|0); //@line 66332 "c/sqlite3.c"
         $144 = ($143|0)<($$0218335|0); //@line 66333 "c/sqlite3.c"
         $spec$select246 = $144 ? $$1221334 : $$0229333; //@line 66333 "c/sqlite3.c"
         $spec$select247 = $144 ? $143 : $$0218335; //@line 66333 "c/sqlite3.c"
         $145 = (($$1221334) + 1)|0; //@line 66331 "c/sqlite3.c"
         $exitcond = ($145|0)==($55|0); //@line 66331 "c/sqlite3.c"
         if ($exitcond) {
          $$3232 = $spec$select246;
          break;
         } else {
          $$0218335 = $spec$select247;$$0229333 = $spec$select246;$$1221334 = $145;
         }
        }
       }
      }
     } while(0);
     $146 = $$3232 << 2; //@line 66343 "c/sqlite3.c"
     $147 = (($146) + 8)|0; //@line 66343 "c/sqlite3.c"
     $148 = (($53) + ($147)|0); //@line 66343 "c/sqlite3.c"
     $149 = (_sqlite3Get4byte($148)|0); //@line 66343 "c/sqlite3.c"
     $150 = ($149>>>0)>($9>>>0); //@line 66345 "c/sqlite3.c"
     if ($150) {
      label = 55;
      break;
     }
     $152 = ($149|0)==($3|0); //@line 66351 "c/sqlite3.c"
     $or$cond248 = $152 | $$not; //@line 66351 "c/sqlite3.c"
     $153 = ($149>>>0)<($3>>>0); //@line 66351 "c/sqlite3.c"
     $or$cond249 = $36 & $153; //@line 66351 "c/sqlite3.c"
     $or$cond343 = $or$cond248 | $or$cond249; //@line 66351 "c/sqlite3.c"
     if ($or$cond343) {
      label = 57;
      break;
     } else {
      $$8 = $$0209;
     }
    }
    _releasePage($37); //@line 66376 "c/sqlite3.c"
    if ($32) {
     $$12 = $$8;$$1217 = 0;
     break L5;
    } else {
     $$0234 = $$2236;
    }
   }
   L76: do {
    if ((label|0) == 20) {
     HEAP32[$5>>2] = 0; //@line 66223 "c/sqlite3.c"
     $$12 = $$0209;$$1217 = $37;
     break L5;
    }
    else if ((label|0) == 22) {
     $57 = ((($51)) + 72|0); //@line 66236 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 66236 "c/sqlite3.c"
     $59 = (_sqlite3PagerWrite($58)|0); //@line 66236 "c/sqlite3.c"
     $60 = ($59|0)==(0); //@line 66237 "c/sqlite3.c"
     if (!($60)) {
      $$12 = $59;$$1217 = $37;
      break L5;
     }
     $61 = ((($51)) + 56|0); //@line 66230 "c/sqlite3.c"
     HEAP32[$2>>2] = $$0233; //@line 66240 "c/sqlite3.c"
     $62 = HEAP32[$10>>2]|0; //@line 66241 "c/sqlite3.c"
     $63 = ((($62)) + 32|0); //@line 66241 "c/sqlite3.c"
     $64 = HEAP32[$61>>2]|0; //@line 66241 "c/sqlite3.c"
     $65 = HEAPU8[$64>>0]|(HEAPU8[$64+1>>0]<<8)|(HEAPU8[$64+2>>0]<<16)|(HEAPU8[$64+3>>0]<<24); //@line 66241 "c/sqlite3.c"
     HEAP8[$63>>0]=$65&255;HEAP8[$63+1>>0]=($65>>8)&255;HEAP8[$63+2>>0]=($65>>16)&255;HEAP8[$63+3>>0]=$65>>24; //@line 66241 "c/sqlite3.c"
     $66 = HEAP32[$5>>2]|0; //@line 66242 "c/sqlite3.c"
     HEAP32[$1>>2] = $66; //@line 66242 "c/sqlite3.c"
    }
    else if ((label|0) == 25) {
     $71 = (_sqlite3CorruptError(66247)|0); //@line 66247 "c/sqlite3.c"
     $$12 = $71;$$1217 = $37;
     break L5;
    }
    else if ((label|0) == 28) {
     $74 = ((($51)) + 56|0); //@line 66230 "c/sqlite3.c"
     HEAP32[$2>>2] = $$0233; //@line 66256 "c/sqlite3.c"
     $75 = HEAP32[$5>>2]|0; //@line 66257 "c/sqlite3.c"
     HEAP32[$1>>2] = $75; //@line 66257 "c/sqlite3.c"
     $$cast = $75; //@line 66259 "c/sqlite3.c"
     $76 = ((($$cast)) + 72|0); //@line 66259 "c/sqlite3.c"
     $77 = HEAP32[$76>>2]|0; //@line 66259 "c/sqlite3.c"
     $78 = (_sqlite3PagerWrite($77)|0); //@line 66259 "c/sqlite3.c"
     $79 = ($78|0)==(0); //@line 66260 "c/sqlite3.c"
     if (!($79)) {
      $$12 = $78;$$1217 = $37;
      break L5;
     }
     $80 = ($55|0)==(0); //@line 66263 "c/sqlite3.c"
     if ($80) {
      if (!($38)) {
       $81 = HEAP32[$10>>2]|0; //@line 66265 "c/sqlite3.c"
       $82 = ((($81)) + 32|0); //@line 66265 "c/sqlite3.c"
       $83 = HEAP32[$74>>2]|0; //@line 66265 "c/sqlite3.c"
       $84 = HEAPU8[$83>>0]|(HEAPU8[$83+1>>0]<<8)|(HEAPU8[$83+2>>0]<<16)|(HEAPU8[$83+3>>0]<<24); //@line 66265 "c/sqlite3.c"
       HEAP8[$82>>0]=$84&255;HEAP8[$82+1>>0]=($84>>8)&255;HEAP8[$82+2>>0]=($84>>16)&255;HEAP8[$82+3>>0]=$84>>24; //@line 66265 "c/sqlite3.c"
       break;
      }
      $85 = ((($37)) + 72|0); //@line 66267 "c/sqlite3.c"
      $86 = HEAP32[$85>>2]|0; //@line 66267 "c/sqlite3.c"
      $87 = (_sqlite3PagerWrite($86)|0); //@line 66267 "c/sqlite3.c"
      $88 = ($87|0)==(0); //@line 66268 "c/sqlite3.c"
      if (!($88)) {
       $$12 = $87;$$1217 = $37;
       break L5;
      }
      $89 = ((($37)) + 56|0); //@line 66271 "c/sqlite3.c"
      $90 = HEAP32[$89>>2]|0; //@line 66271 "c/sqlite3.c"
      $91 = HEAP32[$74>>2]|0; //@line 66271 "c/sqlite3.c"
      $92 = HEAPU8[$91>>0]|(HEAPU8[$91+1>>0]<<8)|(HEAPU8[$91+2>>0]<<16)|(HEAPU8[$91+3>>0]<<24); //@line 66271 "c/sqlite3.c"
      HEAP8[$90>>0]=$92&255;HEAP8[$90+1>>0]=($92>>8)&255;HEAP8[$90+2>>0]=($92>>16)&255;HEAP8[$90+3>>0]=$92>>24; //@line 66271 "c/sqlite3.c"
      break;
     }
     $93 = HEAP32[$74>>2]|0; //@line 66279 "c/sqlite3.c"
     $94 = ((($93)) + 8|0); //@line 66279 "c/sqlite3.c"
     $95 = (_sqlite3Get4byte($94)|0); //@line 66279 "c/sqlite3.c"
     $96 = ($95>>>0)>($9>>>0); //@line 66280 "c/sqlite3.c"
     do {
      if ($96) {
       $97 = (_sqlite3CorruptError(66281)|0); //@line 66281 "c/sqlite3.c"
       $$2211$ph = $97;
      } else {
       $98 = (_btreeGetUnusedPage($0,$95,$6,0)|0); //@line 66285 "c/sqlite3.c"
       $99 = ($98|0)==(0); //@line 66286 "c/sqlite3.c"
       if ($99) {
        $100 = HEAP32[$6>>2]|0; //@line 66289 "c/sqlite3.c"
        $101 = ((($100)) + 72|0); //@line 66289 "c/sqlite3.c"
        $102 = HEAP32[$101>>2]|0; //@line 66289 "c/sqlite3.c"
        $103 = (_sqlite3PagerWrite($102)|0); //@line 66289 "c/sqlite3.c"
        $104 = ($103|0)==(0); //@line 66290 "c/sqlite3.c"
        if (!($104)) {
         _releasePage($100); //@line 66291 "c/sqlite3.c"
         $$2211$ph = $103;
         break;
        }
        $105 = ((($100)) + 56|0); //@line 66294 "c/sqlite3.c"
        $106 = HEAP32[$105>>2]|0; //@line 66294 "c/sqlite3.c"
        $107 = HEAP32[$74>>2]|0; //@line 66294 "c/sqlite3.c"
        $108 = HEAPU8[$107>>0]|(HEAPU8[$107+1>>0]<<8)|(HEAPU8[$107+2>>0]<<16)|(HEAPU8[$107+3>>0]<<24); //@line 66294 "c/sqlite3.c"
        HEAP8[$106>>0]=$108&255;HEAP8[$106+1>>0]=($108>>8)&255;HEAP8[$106+2>>0]=($108>>16)&255;HEAP8[$106+3>>0]=$108>>24; //@line 66294 "c/sqlite3.c"
        $109 = HEAP32[$105>>2]|0; //@line 66295 "c/sqlite3.c"
        $110 = ((($109)) + 4|0); //@line 66295 "c/sqlite3.c"
        $111 = (($55) + -1)|0; //@line 66295 "c/sqlite3.c"
        _sqlite3Put4byte($110,$111); //@line 66295 "c/sqlite3.c"
        $112 = HEAP32[$105>>2]|0; //@line 66296 "c/sqlite3.c"
        $113 = ((($112)) + 8|0); //@line 66296 "c/sqlite3.c"
        $114 = HEAP32[$74>>2]|0; //@line 66296 "c/sqlite3.c"
        $115 = ((($114)) + 12|0); //@line 66296 "c/sqlite3.c"
        $116 = $111 << 2; //@line 66296 "c/sqlite3.c"
        _memcpy(($113|0),($115|0),($116|0))|0; //@line 66296 "c/sqlite3.c"
        _releasePage($100); //@line 66297 "c/sqlite3.c"
        if ($38) {
         $119 = ((($37)) + 72|0); //@line 66302 "c/sqlite3.c"
         $120 = HEAP32[$119>>2]|0; //@line 66302 "c/sqlite3.c"
         $121 = (_sqlite3PagerWrite($120)|0); //@line 66302 "c/sqlite3.c"
         $122 = ($121|0)==(0); //@line 66303 "c/sqlite3.c"
         if (!($122)) {
          $$2211$ph = $121;
          break;
         }
         $123 = ((($37)) + 56|0); //@line 66306 "c/sqlite3.c"
         $124 = HEAP32[$123>>2]|0; //@line 66306 "c/sqlite3.c"
         _sqlite3Put4byte($124,$95); //@line 66306 "c/sqlite3.c"
        } else {
         $117 = HEAP32[$10>>2]|0; //@line 66300 "c/sqlite3.c"
         $118 = ((($117)) + 32|0); //@line 66300 "c/sqlite3.c"
         _sqlite3Put4byte($118,$95); //@line 66300 "c/sqlite3.c"
        }
        break L76;
       } else {
        $$2211$ph = $98;
       }
      }
     } while(0);
     $$12 = $$2211$ph;$$1217 = $37;
     break L5;
    }
    else if ((label|0) == 55) {
     $151 = (_sqlite3CorruptError(66346)|0); //@line 66346 "c/sqlite3.c"
     $$12 = $151;$$1217 = $37;
     break L5;
    }
    else if ((label|0) == 57) {
     HEAP32[$2>>2] = $149; //@line 66354 "c/sqlite3.c"
     $154 = ((($51)) + 72|0); //@line 66358 "c/sqlite3.c"
     $155 = HEAP32[$154>>2]|0; //@line 66358 "c/sqlite3.c"
     $156 = (_sqlite3PagerWrite($155)|0); //@line 66358 "c/sqlite3.c"
     $157 = ($156|0)==(0); //@line 66359 "c/sqlite3.c"
     if (!($157)) {
      $$12 = $156;$$1217 = $37;
      break L5;
     }
     $158 = (($55) + -1)|0; //@line 66360 "c/sqlite3.c"
     $159 = ($$3232>>>0)<($158>>>0); //@line 66360 "c/sqlite3.c"
     if ($159) {
      $160 = $55 << 2; //@line 66361 "c/sqlite3.c"
      $161 = (($160) + 4)|0; //@line 66361 "c/sqlite3.c"
      $162 = (($53) + ($161)|0); //@line 66361 "c/sqlite3.c"
      $163 = HEAPU8[$162>>0]|(HEAPU8[$162+1>>0]<<8)|(HEAPU8[$162+2>>0]<<16)|(HEAPU8[$162+3>>0]<<24); //@line 66361 "c/sqlite3.c"
      HEAP8[$148>>0]=$163&255;HEAP8[$148+1>>0]=($163>>8)&255;HEAP8[$148+2>>0]=($163>>16)&255;HEAP8[$148+3>>0]=$163>>24; //@line 66361 "c/sqlite3.c"
     }
     _sqlite3Put4byte($54,$158); //@line 66363 "c/sqlite3.c"
     $164 = HEAP32[$2>>2]|0; //@line 66364 "c/sqlite3.c"
     $165 = (_btreeGetHasContent($0,$164)|0); //@line 66364 "c/sqlite3.c"
     $166 = ($165|0)==(0); //@line 66364 "c/sqlite3.c"
     $167 = $166&1; //@line 66364 "c/sqlite3.c"
     $168 = (_btreeGetUnusedPage($0,$164,$1,$167)|0); //@line 66365 "c/sqlite3.c"
     $169 = ($168|0)==(0); //@line 66366 "c/sqlite3.c"
     if ($169) {
      $170 = HEAP32[$1>>2]|0; //@line 66367 "c/sqlite3.c"
      $171 = ((($170)) + 72|0); //@line 66367 "c/sqlite3.c"
      $172 = HEAP32[$171>>2]|0; //@line 66367 "c/sqlite3.c"
      $173 = (_sqlite3PagerWrite($172)|0); //@line 66367 "c/sqlite3.c"
      $174 = ($173|0)==(0); //@line 66368 "c/sqlite3.c"
      if ($174) {
       $$8$ph271 = 0;
      } else {
       $175 = HEAP32[$1>>2]|0; //@line 66369 "c/sqlite3.c"
       _releasePage($175); //@line 66369 "c/sqlite3.c"
       HEAP32[$1>>2] = 0; //@line 66370 "c/sqlite3.c"
       $$8$ph271 = $173;
      }
     } else {
      $$8$ph271 = $168;
     }
     _releasePage($37); //@line 66376 "c/sqlite3.c"
     $$12 = $$8$ph271;$$1217 = 0;
     break L5;
    }
   } while(0);
   HEAP32[$5>>2] = 0;
   _releasePage($37); //@line 66376 "c/sqlite3.c"
   $$12 = 0;$$1217 = 0;
  }
 } while(0);
 $227 = HEAP32[$5>>2]|0; //@line 66441 "c/sqlite3.c"
 _releasePage($227); //@line 66441 "c/sqlite3.c"
 _releasePage($$1217); //@line 66442 "c/sqlite3.c"
 $$6 = $$12;
 STACKTOP = sp;return ($$6|0); //@line 66446 "c/sqlite3.c"
}
function _relocatePage($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp + 4|0;
 $7 = sp;
 $8 = ((($1)) + 4|0); //@line 63956 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 63956 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 63957 "c/sqlite3.c"
 $11 = ((($1)) + 72|0); //@line 63968 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 63968 "c/sqlite3.c"
 $13 = (_sqlite3PagerMovepage($10,$12,$4,$5)|0); //@line 63968 "c/sqlite3.c"
 HEAP32[$7>>2] = $13; //@line 63968 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 63969 "c/sqlite3.c"
 if (!($14)) {
  $$1 = $13;
  STACKTOP = sp;return ($$1|0); //@line 64018 "c/sqlite3.c"
 }
 HEAP32[$8>>2] = $4; //@line 63972 "c/sqlite3.c"
 L4: do {
  switch ($2<<24>>24) {
  case 1: case 5:  {
   $15 = (_setChildPtrmaps($1)|0); //@line 63983 "c/sqlite3.c"
   HEAP32[$7>>2] = $15; //@line 63983 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 63984 "c/sqlite3.c"
   if ($16) {
    $23 = ($2<<24>>24)==(1); //@line 64001 "c/sqlite3.c"
    if ($23) {
     break L4;
    } else {
     label = 7;
     break L4;
    }
   } else {
    $$1 = $15;
    STACKTOP = sp;return ($$1|0); //@line 64018 "c/sqlite3.c"
   }
   break;
  }
  default: {
   $17 = ((($1)) + 56|0); //@line 63988 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 63988 "c/sqlite3.c"
   $19 = (_sqlite3Get4byte($18)|0); //@line 63988 "c/sqlite3.c"
   $20 = ($19|0)==(0); //@line 63989 "c/sqlite3.c"
   if ($20) {
    label = 7;
   } else {
    _ptrmapPut($0,$19,4,$4,$7); //@line 63990 "c/sqlite3.c"
    $21 = HEAP32[$7>>2]|0; //@line 63991 "c/sqlite3.c"
    $22 = ($21|0)==(0); //@line 63991 "c/sqlite3.c"
    if ($22) {
     label = 7;
    } else {
     $$1 = $21;
     STACKTOP = sp;return ($$1|0); //@line 64018 "c/sqlite3.c"
    }
   }
  }
  }
 } while(0);
 do {
  if ((label|0) == 7) {
   $24 = (_btreeGetPage($0,$3,$6,0)|0); //@line 64002 "c/sqlite3.c"
   HEAP32[$7>>2] = $24; //@line 64002 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 64003 "c/sqlite3.c"
   if (!($25)) {
    $$1 = $24;
    STACKTOP = sp;return ($$1|0); //@line 64018 "c/sqlite3.c"
   }
   $26 = HEAP32[$6>>2]|0; //@line 64006 "c/sqlite3.c"
   $27 = ((($26)) + 72|0); //@line 64006 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 64006 "c/sqlite3.c"
   $29 = (_sqlite3PagerWrite($28)|0); //@line 64006 "c/sqlite3.c"
   HEAP32[$7>>2] = $29; //@line 64006 "c/sqlite3.c"
   $30 = ($29|0)==(0); //@line 64007 "c/sqlite3.c"
   if ($30) {
    $31 = (_modifyPagePointer($26,$9,$4,$2)|0); //@line 64011 "c/sqlite3.c"
    HEAP32[$7>>2] = $31; //@line 64011 "c/sqlite3.c"
    _releasePage($26); //@line 64012 "c/sqlite3.c"
    $32 = ($31|0)==(0); //@line 64013 "c/sqlite3.c"
    if (!($32)) {
     break;
    }
    _ptrmapPut($0,$4,$2,$3,$7); //@line 64014 "c/sqlite3.c"
    break;
   } else {
    _releasePage($26); //@line 64008 "c/sqlite3.c"
    $$1 = $29;
    STACKTOP = sp;return ($$1|0); //@line 64018 "c/sqlite3.c"
   }
  }
 } while(0);
 $33 = HEAP32[$7>>2]|0; //@line 64017 "c/sqlite3.c"
 $$1 = $33;
 STACKTOP = sp;return ($$1|0); //@line 64018 "c/sqlite3.c"
}
function _sqlite3PagerMovepage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$050 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ((($0)) + 12|0); //@line 55021 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 55021 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 55021 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_sqlite3PagerWrite($1)|0); //@line 55022 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 55023 "c/sqlite3.c"
  if (!($9)) {
   $$1 = $8;
   STACKTOP = sp;return ($$1|0); //@line 55130 "c/sqlite3.c"
  }
 }
 $10 = ((($1)) + 28|0); //@line 55044 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 55044 "c/sqlite3.c"
 $12 = $11 & 2; //@line 55044 "c/sqlite3.c"
 $13 = ($12<<16>>16)==(0); //@line 55044 "c/sqlite3.c"
 if (!($13)) {
  $14 = (_subjournalPageIfRequired($1)|0); //@line 55045 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 55045 "c/sqlite3.c"
  if (!($15)) {
   $$1 = $14;
   STACKTOP = sp;return ($$1|0); //@line 55130 "c/sqlite3.c"
  }
 }
 $16 = HEAP16[$10>>1]|0; //@line 55061 "c/sqlite3.c"
 $17 = $16 & 8; //@line 55061 "c/sqlite3.c"
 $18 = ($17<<16>>16)==(0); //@line 55061 "c/sqlite3.c"
 $19 = ($3|0)!=(0); //@line 55061 "c/sqlite3.c"
 $or$cond = $19 | $18; //@line 55061 "c/sqlite3.c"
 if ($or$cond) {
  $$050 = 0;
 } else {
  $20 = ((($1)) + 24|0); //@line 55062 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 55062 "c/sqlite3.c"
  $$050 = $21;
 }
 $22 = $16 & -9; //@line 55073 "c/sqlite3.c"
 HEAP16[$10>>1] = $22; //@line 55073 "c/sqlite3.c"
 $23 = (_sqlite3PagerLookup($0,$2)|0); //@line 55074 "c/sqlite3.c"
 $24 = ($23|0)!=(0|0); //@line 55076 "c/sqlite3.c"
 do {
  if ($24) {
   $25 = ((($23)) + 28|0); //@line 55077 "c/sqlite3.c"
   $26 = HEAP16[$25>>1]|0; //@line 55077 "c/sqlite3.c"
   $27 = $26 & 8; //@line 55077 "c/sqlite3.c"
   $28 = HEAP16[$10>>1]|0; //@line 55077 "c/sqlite3.c"
   $29 = $28 | $27; //@line 55077 "c/sqlite3.c"
   HEAP16[$10>>1] = $29; //@line 55077 "c/sqlite3.c"
   $30 = HEAP8[$5>>0]|0; //@line 55078 "c/sqlite3.c"
   $31 = ($30<<24>>24)==(0); //@line 55078 "c/sqlite3.c"
   if ($31) {
    _sqlite3PcacheDrop($23); //@line 55083 "c/sqlite3.c"
    break;
   } else {
    $32 = ((($0)) + 24|0); //@line 55081 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 55081 "c/sqlite3.c"
    $34 = (($33) + 1)|0; //@line 55081 "c/sqlite3.c"
    _sqlite3PcacheMove($23,$34); //@line 55081 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $35 = ((($1)) + 24|0); //@line 55087 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 55087 "c/sqlite3.c"
 _sqlite3PcacheMove($1,$2); //@line 55088 "c/sqlite3.c"
 _sqlite3PcacheMakeDirty($1); //@line 55089 "c/sqlite3.c"
 $37 = HEAP8[$5>>0]|0; //@line 55095 "c/sqlite3.c"
 $38 = ($37<<24>>24)!=(0); //@line 55095 "c/sqlite3.c"
 $or$cond3 = $24 & $38; //@line 55095 "c/sqlite3.c"
 if ($or$cond3) {
  _sqlite3PcacheMove($23,$36); //@line 55096 "c/sqlite3.c"
  _sqlite3PagerUnrefNotNull($23); //@line 55097 "c/sqlite3.c"
 }
 $39 = ($$050|0)==(0); //@line 55100 "c/sqlite3.c"
 if ($39) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 55130 "c/sqlite3.c"
 }
 $40 = (_sqlite3PagerGet($0,$$050,$4,0)|0); //@line 55116 "c/sqlite3.c"
 $41 = ($40|0)==(0); //@line 55117 "c/sqlite3.c"
 if ($41) {
  $49 = HEAP32[$4>>2]|0; //@line 55124 "c/sqlite3.c"
  $50 = ((($49)) + 28|0); //@line 55124 "c/sqlite3.c"
  $51 = HEAP16[$50>>1]|0; //@line 55124 "c/sqlite3.c"
  $52 = $51 | 8; //@line 55124 "c/sqlite3.c"
  HEAP16[$50>>1] = $52; //@line 55124 "c/sqlite3.c"
  _sqlite3PcacheMakeDirty($49); //@line 55125 "c/sqlite3.c"
  $53 = HEAP32[$4>>2]|0; //@line 55126 "c/sqlite3.c"
  _sqlite3PagerUnrefNotNull($53); //@line 55126 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 55130 "c/sqlite3.c"
 }
 $42 = ((($0)) + 28|0); //@line 55118 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 55118 "c/sqlite3.c"
 $44 = ($$050>>>0)>($43>>>0); //@line 55118 "c/sqlite3.c"
 if (!($44)) {
  $45 = ((($0)) + 56|0); //@line 55120 "c/sqlite3.c"
  $46 = HEAP32[$45>>2]|0; //@line 55120 "c/sqlite3.c"
  $47 = ((($0)) + 204|0); //@line 55120 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 55120 "c/sqlite3.c"
  _sqlite3BitvecClear($46,$$050,$48); //@line 55120 "c/sqlite3.c"
 }
 $$1 = $40;
 STACKTOP = sp;return ($$1|0); //@line 55130 "c/sqlite3.c"
}
function _setChildPtrmaps($0) {
 $0 = $0|0;
 var $$0 = 0, $$04041 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 52|0); //@line 63845 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63845 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 63846 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 63846 "c/sqlite3.c"
 $6 = HEAP8[$0>>0]|0; //@line 63849 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 63849 "c/sqlite3.c"
 if ($7) {
  $8 = (_btreeInitPage($0)|0); //@line 63849 "c/sqlite3.c"
  HEAP32[$1>>2] = $8; //@line 63849 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 63850 "c/sqlite3.c"
  if (!($9)) {
   $$0 = $8;
   STACKTOP = sp;return ($$0|0); //@line 63870 "c/sqlite3.c"
  }
 } else {
  HEAP32[$1>>2] = 0; //@line 63849 "c/sqlite3.c"
 }
 $10 = ((($0)) + 22|0); //@line 63851 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 63851 "c/sqlite3.c"
 $12 = $11&65535; //@line 63851 "c/sqlite3.c"
 $13 = ($11<<16>>16)==(0); //@line 63853 "c/sqlite3.c"
 if (!($13)) {
  $14 = ((($0)) + 56|0);
  $15 = ((($0)) + 24|0);
  $16 = ((($0)) + 64|0);
  $17 = ((($0)) + 8|0);
  $$04041 = 0;
  while(1) {
   $18 = HEAP32[$14>>2]|0; //@line 63854 "c/sqlite3.c"
   $19 = HEAP16[$15>>1]|0; //@line 63854 "c/sqlite3.c"
   $20 = $19&65535; //@line 63854 "c/sqlite3.c"
   $21 = HEAP32[$16>>2]|0; //@line 63854 "c/sqlite3.c"
   $22 = $$04041 << 1; //@line 63854 "c/sqlite3.c"
   $23 = (($21) + ($22)|0); //@line 63854 "c/sqlite3.c"
   $24 = HEAP8[$23>>0]|0; //@line 63854 "c/sqlite3.c"
   $25 = $24&255; //@line 63854 "c/sqlite3.c"
   $26 = $25 << 8; //@line 63854 "c/sqlite3.c"
   $27 = ((($23)) + 1|0); //@line 63854 "c/sqlite3.c"
   $28 = HEAP8[$27>>0]|0; //@line 63854 "c/sqlite3.c"
   $29 = $28&255; //@line 63854 "c/sqlite3.c"
   $30 = $26 | $29; //@line 63854 "c/sqlite3.c"
   $31 = $30 & $20; //@line 63854 "c/sqlite3.c"
   $32 = (($18) + ($31)|0); //@line 63854 "c/sqlite3.c"
   _ptrmapPutOvflPtr($0,$32,$1); //@line 63856 "c/sqlite3.c"
   $33 = HEAP8[$17>>0]|0; //@line 63858 "c/sqlite3.c"
   $34 = ($33<<24>>24)==(0); //@line 63858 "c/sqlite3.c"
   if ($34) {
    $35 = (_sqlite3Get4byte($32)|0); //@line 63859 "c/sqlite3.c"
    _ptrmapPut($3,$35,5,$5,$1); //@line 63860 "c/sqlite3.c"
   }
   $36 = (($$04041) + 1)|0; //@line 63853 "c/sqlite3.c"
   $exitcond = ($36|0)==($12|0); //@line 63853 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$04041 = $36;
   }
  }
 }
 $37 = ((($0)) + 8|0); //@line 63864 "c/sqlite3.c"
 $38 = HEAP8[$37>>0]|0; //@line 63864 "c/sqlite3.c"
 $39 = ($38<<24>>24)==(0); //@line 63864 "c/sqlite3.c"
 if ($39) {
  $40 = ((($0)) + 56|0); //@line 63865 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 63865 "c/sqlite3.c"
  $42 = ((($0)) + 9|0); //@line 63865 "c/sqlite3.c"
  $43 = HEAP8[$42>>0]|0; //@line 63865 "c/sqlite3.c"
  $44 = $43&255; //@line 63865 "c/sqlite3.c"
  $45 = (($44) + 8)|0; //@line 63865 "c/sqlite3.c"
  $46 = (($41) + ($45)|0); //@line 63865 "c/sqlite3.c"
  $47 = (_sqlite3Get4byte($46)|0); //@line 63865 "c/sqlite3.c"
  _ptrmapPut($3,$47,5,$5,$1); //@line 63866 "c/sqlite3.c"
 }
 $48 = HEAP32[$1>>2]|0; //@line 63869 "c/sqlite3.c"
 $$0 = $48;
 STACKTOP = sp;return ($$0|0); //@line 63870 "c/sqlite3.c"
}
function _ptrmapPut($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = HEAP32[$4>>2]|0; //@line 61377 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 61377 "c/sqlite3.c"
 if (!($7)) {
  STACKTOP = sp;return; //@line 61413 "c/sqlite3.c"
 }
 $8 = ($1|0)==(0); //@line 61384 "c/sqlite3.c"
 if ($8) {
  $9 = (_sqlite3CorruptError(61385)|0); //@line 61385 "c/sqlite3.c"
  HEAP32[$4>>2] = $9; //@line 61385 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 61413 "c/sqlite3.c"
 }
 $10 = (_ptrmapPageno($0,$1)|0); //@line 61388 "c/sqlite3.c"
 $11 = HEAP32[$0>>2]|0; //@line 61389 "c/sqlite3.c"
 $12 = (_sqlite3PagerGet($11,$10,$5,0)|0); //@line 61389 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 61390 "c/sqlite3.c"
 if (!($13)) {
  HEAP32[$4>>2] = $12; //@line 61391 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 61413 "c/sqlite3.c"
 }
 $14 = (($1) - ($10))|0; //@line 61394 "c/sqlite3.c"
 $15 = ($14*5)|0; //@line 61394 "c/sqlite3.c"
 $16 = (($15) + -5)|0; //@line 61394 "c/sqlite3.c"
 $17 = ($16|0)<(0); //@line 61395 "c/sqlite3.c"
 do {
  if ($17) {
   $18 = (_sqlite3CorruptError(61396)|0); //@line 61396 "c/sqlite3.c"
   HEAP32[$4>>2] = $18; //@line 61396 "c/sqlite3.c"
  } else {
   $19 = HEAP32[$5>>2]|0; //@line 61400 "c/sqlite3.c"
   $20 = (_sqlite3PagerGetData($19)|0); //@line 61400 "c/sqlite3.c"
   $21 = (($20) + ($16)|0); //@line 61402 "c/sqlite3.c"
   $22 = HEAP8[$21>>0]|0; //@line 61402 "c/sqlite3.c"
   $23 = ($22<<24>>24)==($2<<24>>24); //@line 61402 "c/sqlite3.c"
   if ($23) {
    $24 = (($15) + -4)|0; //@line 61402 "c/sqlite3.c"
    $25 = (($20) + ($24)|0); //@line 61402 "c/sqlite3.c"
    $26 = (_sqlite3Get4byte($25)|0); //@line 61402 "c/sqlite3.c"
    $27 = ($26|0)==($3|0); //@line 61402 "c/sqlite3.c"
    if ($27) {
     break;
    }
   }
   $28 = (_sqlite3PagerWrite($19)|0); //@line 61404 "c/sqlite3.c"
   HEAP32[$4>>2] = $28; //@line 61404 "c/sqlite3.c"
   $29 = ($28|0)==(0); //@line 61405 "c/sqlite3.c"
   if ($29) {
    $30 = (($15) + -4)|0; //@line 61407 "c/sqlite3.c"
    $31 = (($20) + ($30)|0); //@line 61407 "c/sqlite3.c"
    HEAP8[$21>>0] = $2; //@line 61406 "c/sqlite3.c"
    _sqlite3Put4byte($31,$3); //@line 61407 "c/sqlite3.c"
   }
  }
 } while(0);
 $32 = HEAP32[$5>>2]|0; //@line 61412 "c/sqlite3.c"
 _sqlite3PagerUnref($32); //@line 61412 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 61413 "c/sqlite3.c"
}
function _modifyPagePointer($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$05670 = 0, $$05676 = 0, $$6 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp;
 $5 = ($3<<24>>24)==(4); //@line 63889 "c/sqlite3.c"
 if ($5) {
  $6 = ((($0)) + 56|0); //@line 63891 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 63891 "c/sqlite3.c"
  $8 = (_sqlite3Get4byte($7)|0); //@line 63891 "c/sqlite3.c"
  $9 = ($8|0)==($1|0); //@line 63891 "c/sqlite3.c"
  if ($9) {
   _sqlite3Put4byte($7,$2); //@line 63894 "c/sqlite3.c"
   $$6 = 0;
   STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
  } else {
   $10 = (_sqlite3CorruptError(63892)|0); //@line 63892 "c/sqlite3.c"
   $$6 = $10;
   STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
  }
 }
 $11 = HEAP8[$0>>0]|0; //@line 63900 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 63900 "c/sqlite3.c"
 if ($12) {
  $13 = (_btreeInitPage($0)|0); //@line 63900 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 63901 "c/sqlite3.c"
  if (!($14)) {
   $$6 = $13;
   STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
  }
 }
 $15 = ((($0)) + 22|0); //@line 63902 "c/sqlite3.c"
 $16 = HEAP16[$15>>1]|0; //@line 63902 "c/sqlite3.c"
 $17 = $16&65535; //@line 63902 "c/sqlite3.c"
 $18 = ($16<<16>>16)==(0); //@line 63904 "c/sqlite3.c"
 L13: do {
  if ($18) {
   $$05670 = 0;
  } else {
   $19 = ((($0)) + 56|0);
   $20 = ((($0)) + 24|0);
   $21 = ((($0)) + 64|0);
   $22 = ($3<<24>>24)==(3);
   $23 = ((($0)) + 80|0);
   $24 = ((($4)) + 16|0);
   $25 = ((($4)) + 12|0);
   $26 = ((($4)) + 18|0);
   $27 = ((($0)) + 52|0);
   $$05676 = 0;
   while(1) {
    $28 = HEAP32[$19>>2]|0; //@line 63905 "c/sqlite3.c"
    $29 = HEAP16[$20>>1]|0; //@line 63905 "c/sqlite3.c"
    $30 = $29&65535; //@line 63905 "c/sqlite3.c"
    $31 = HEAP32[$21>>2]|0; //@line 63905 "c/sqlite3.c"
    $32 = $$05676 << 1; //@line 63905 "c/sqlite3.c"
    $33 = (($31) + ($32)|0); //@line 63905 "c/sqlite3.c"
    $34 = HEAP8[$33>>0]|0; //@line 63905 "c/sqlite3.c"
    $35 = $34&255; //@line 63905 "c/sqlite3.c"
    $36 = $35 << 8; //@line 63905 "c/sqlite3.c"
    $37 = ((($33)) + 1|0); //@line 63905 "c/sqlite3.c"
    $38 = HEAP8[$37>>0]|0; //@line 63905 "c/sqlite3.c"
    $39 = $38&255; //@line 63905 "c/sqlite3.c"
    $40 = $36 | $39; //@line 63905 "c/sqlite3.c"
    $41 = $40 & $30; //@line 63905 "c/sqlite3.c"
    $42 = (($28) + ($41)|0); //@line 63905 "c/sqlite3.c"
    if ($22) {
     $43 = HEAP32[$23>>2]|0; //@line 63908 "c/sqlite3.c"
     FUNCTION_TABLE_viii[$43 & 255]($0,$42,$4); //@line 63908 "c/sqlite3.c"
     $44 = HEAP16[$24>>1]|0; //@line 63909 "c/sqlite3.c"
     $45 = $44&65535; //@line 63909 "c/sqlite3.c"
     $46 = HEAP32[$25>>2]|0; //@line 63909 "c/sqlite3.c"
     $47 = ($46>>>0)>($45>>>0); //@line 63909 "c/sqlite3.c"
     if ($47) {
      $48 = HEAP16[$26>>1]|0; //@line 63910 "c/sqlite3.c"
      $49 = $48&65535; //@line 63910 "c/sqlite3.c"
      $50 = (($42) + ($49)|0); //@line 63910 "c/sqlite3.c"
      $51 = HEAP32[$19>>2]|0; //@line 63910 "c/sqlite3.c"
      $52 = HEAP32[$27>>2]|0; //@line 63910 "c/sqlite3.c"
      $53 = ((($52)) + 36|0); //@line 63910 "c/sqlite3.c"
      $54 = HEAP32[$53>>2]|0; //@line 63910 "c/sqlite3.c"
      $55 = (($51) + ($54)|0); //@line 63910 "c/sqlite3.c"
      $56 = ($50>>>0)>($55>>>0); //@line 63910 "c/sqlite3.c"
      if ($56) {
       label = 12;
       break;
      }
      $58 = ((($50)) + -4|0); //@line 63913 "c/sqlite3.c"
      $59 = (_sqlite3Get4byte($58)|0); //@line 63913 "c/sqlite3.c"
      $60 = ($59|0)==($1|0); //@line 63913 "c/sqlite3.c"
      if ($60) {
       label = 17;
       break;
      }
     }
    } else {
     $61 = (_sqlite3Get4byte($42)|0); //@line 63919 "c/sqlite3.c"
     $62 = ($61|0)==($1|0); //@line 63919 "c/sqlite3.c"
     if ($62) {
      label = 16;
      break;
     }
    }
    $63 = (($$05676) + 1)|0; //@line 63904 "c/sqlite3.c"
    $64 = ($63>>>0)<($17>>>0); //@line 63904 "c/sqlite3.c"
    if ($64) {
     $$05676 = $63;
    } else {
     $$05670 = $63;
     break L13;
    }
   }
   if ((label|0) == 12) {
    $57 = (_sqlite3CorruptError(63911)|0); //@line 63911 "c/sqlite3.c"
    $$6 = $57;
    STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
   }
   else if ((label|0) == 16) {
    _sqlite3Put4byte($42,$2); //@line 63920 "c/sqlite3.c"
    $$05670 = $$05676;
    break;
   }
   else if ((label|0) == 17) {
    _sqlite3Put4byte($58,$2); //@line 63914 "c/sqlite3.c"
    $$05670 = $$05676;
    break;
   }
  }
 } while(0);
 $65 = ($$05670|0)==($17|0); //@line 63926 "c/sqlite3.c"
 if (!($65)) {
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
 }
 $66 = ($3<<24>>24)==(5); //@line 63927 "c/sqlite3.c"
 if ($66) {
  $67 = ((($0)) + 56|0); //@line 63928 "c/sqlite3.c"
  $68 = HEAP32[$67>>2]|0; //@line 63928 "c/sqlite3.c"
  $69 = ((($0)) + 9|0); //@line 63928 "c/sqlite3.c"
  $70 = HEAP8[$69>>0]|0; //@line 63928 "c/sqlite3.c"
  $71 = $70&255; //@line 63928 "c/sqlite3.c"
  $72 = (($71) + 8)|0; //@line 63928 "c/sqlite3.c"
  $73 = (($68) + ($72)|0); //@line 63928 "c/sqlite3.c"
  $74 = (_sqlite3Get4byte($73)|0); //@line 63928 "c/sqlite3.c"
  $75 = ($74|0)==($1|0); //@line 63928 "c/sqlite3.c"
  if ($75) {
   _sqlite3Put4byte($73,$2); //@line 63931 "c/sqlite3.c"
   $$6 = 0;
   STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
  }
 }
 $76 = (_sqlite3CorruptError(63929)|0); //@line 63929 "c/sqlite3.c"
 $$6 = $76;
 STACKTOP = sp;return ($$6|0); //@line 63935 "c/sqlite3.c"
}
function _btreeInitPage($0) {
 $0 = $0|0;
 var $$0124141 = 0, $$0125140 = 0, $$0128142 = 0, $$2127 = 0, $$3 = 0, $$3134 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0;
 var $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0;
 var $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0;
 var $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0;
 var $or$cond = 0, $spec$select = 0, $spec$select135 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 52|0); //@line 62254 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62254 "c/sqlite3.c"
 $3 = ((($0)) + 9|0); //@line 62255 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 62255 "c/sqlite3.c"
 $5 = ((($0)) + 56|0); //@line 62256 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 62256 "c/sqlite3.c"
 $7 = $4&255; //@line 62259 "c/sqlite3.c"
 $8 = (($6) + ($7)|0); //@line 62259 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 62259 "c/sqlite3.c"
 $10 = $9&255; //@line 62259 "c/sqlite3.c"
 $11 = (_decodeFlags($0,$10)|0); //@line 62259 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 62259 "c/sqlite3.c"
 if (!($12)) {
  $13 = (_sqlite3CorruptError(62260)|0); //@line 62260 "c/sqlite3.c"
  $$3 = $13;
  return ($$3|0); //@line 62366 "c/sqlite3.c"
 }
 $14 = ((($2)) + 32|0); //@line 62263 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 62263 "c/sqlite3.c"
 $16 = (($15) + 65535)|0; //@line 62263 "c/sqlite3.c"
 $17 = $16&65535; //@line 62263 "c/sqlite3.c"
 $18 = ((($0)) + 24|0); //@line 62263 "c/sqlite3.c"
 HEAP16[$18>>1] = $17; //@line 62263 "c/sqlite3.c"
 $19 = ((($0)) + 12|0); //@line 62264 "c/sqlite3.c"
 HEAP8[$19>>0] = 0; //@line 62264 "c/sqlite3.c"
 $20 = ((($2)) + 36|0); //@line 62265 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 62265 "c/sqlite3.c"
 $22 = (($7) + 8)|0; //@line 62266 "c/sqlite3.c"
 $23 = ((($0)) + 10|0); //@line 62266 "c/sqlite3.c"
 $24 = HEAP8[$23>>0]|0; //@line 62266 "c/sqlite3.c"
 $25 = $24&255; //@line 62266 "c/sqlite3.c"
 $26 = (($22) + ($25))|0; //@line 62266 "c/sqlite3.c"
 $27 = $26&65535; //@line 62266 "c/sqlite3.c"
 $28 = ((($0)) + 18|0); //@line 62266 "c/sqlite3.c"
 HEAP16[$28>>1] = $27; //@line 62266 "c/sqlite3.c"
 $29 = (($6) + ($21)|0); //@line 62267 "c/sqlite3.c"
 $30 = ((($0)) + 60|0); //@line 62267 "c/sqlite3.c"
 HEAP32[$30>>2] = $29; //@line 62267 "c/sqlite3.c"
 $31 = (($6) + ($26)|0); //@line 62268 "c/sqlite3.c"
 $32 = ((($0)) + 64|0); //@line 62268 "c/sqlite3.c"
 HEAP32[$32>>2] = $31; //@line 62268 "c/sqlite3.c"
 $33 = (($6) + ($25)|0); //@line 62269 "c/sqlite3.c"
 $34 = ((($0)) + 68|0); //@line 62269 "c/sqlite3.c"
 HEAP32[$34>>2] = $33; //@line 62269 "c/sqlite3.c"
 $35 = (($7) + 5)|0; //@line 62273 "c/sqlite3.c"
 $36 = (($6) + ($35)|0); //@line 62273 "c/sqlite3.c"
 $37 = HEAP8[$36>>0]|0; //@line 62273 "c/sqlite3.c"
 $38 = $37&255; //@line 62273 "c/sqlite3.c"
 $39 = $38 << 8; //@line 62273 "c/sqlite3.c"
 $40 = ((($36)) + 1|0); //@line 62273 "c/sqlite3.c"
 $41 = HEAP8[$40>>0]|0; //@line 62273 "c/sqlite3.c"
 $42 = $41&255; //@line 62273 "c/sqlite3.c"
 $43 = $39 | $42; //@line 62273 "c/sqlite3.c"
 $44 = (($43) + 65535)|0; //@line 62273 "c/sqlite3.c"
 $45 = $44 & 65535; //@line 62273 "c/sqlite3.c"
 $46 = (($45) + 1)|0; //@line 62273 "c/sqlite3.c"
 $47 = (($7) + 3)|0; //@line 62276 "c/sqlite3.c"
 $48 = (($6) + ($47)|0); //@line 62276 "c/sqlite3.c"
 $49 = HEAP8[$48>>0]|0; //@line 62276 "c/sqlite3.c"
 $50 = $49&255; //@line 62276 "c/sqlite3.c"
 $51 = $50 << 8; //@line 62276 "c/sqlite3.c"
 $52 = ((($48)) + 1|0); //@line 62276 "c/sqlite3.c"
 $53 = HEAP8[$52>>0]|0; //@line 62276 "c/sqlite3.c"
 $54 = $53&255; //@line 62276 "c/sqlite3.c"
 $55 = $51 | $54; //@line 62276 "c/sqlite3.c"
 $56 = $55&65535; //@line 62276 "c/sqlite3.c"
 $57 = ((($0)) + 22|0); //@line 62276 "c/sqlite3.c"
 HEAP16[$57>>1] = $56; //@line 62276 "c/sqlite3.c"
 $58 = (($15) + -8)|0; //@line 62277 "c/sqlite3.c"
 $59 = (($58>>>0) / 6)&-1; //@line 62277 "c/sqlite3.c"
 $60 = ($55>>>0)>($59>>>0); //@line 62277 "c/sqlite3.c"
 if ($60) {
  $61 = (_sqlite3CorruptError(62279)|0); //@line 62279 "c/sqlite3.c"
  $$3 = $61;
  return ($$3|0); //@line 62366 "c/sqlite3.c"
 }
 $62 = $55 << 1; //@line 62295 "c/sqlite3.c"
 $63 = (($62) + ($26))|0; //@line 62295 "c/sqlite3.c"
 $64 = (($21) + -4)|0; //@line 62296 "c/sqlite3.c"
 $65 = ((($2)) + 4|0); //@line 62297 "c/sqlite3.c"
 $66 = HEAP32[$65>>2]|0; //@line 62297 "c/sqlite3.c"
 $67 = ((($66)) + 28|0); //@line 62297 "c/sqlite3.c"
 $68 = HEAP32[$67>>2]|0; //@line 62297 "c/sqlite3.c"
 $69 = $68 & 2097152; //@line 62297 "c/sqlite3.c"
 $70 = ($69|0)==(0); //@line 62297 "c/sqlite3.c"
 if ($70) {
  $$3134 = $64;
 } else {
  $71 = ((($0)) + 8|0); //@line 62301 "c/sqlite3.c"
  $72 = HEAP8[$71>>0]|0; //@line 62301 "c/sqlite3.c"
  $73 = ($72<<24>>24)==(0); //@line 62301 "c/sqlite3.c"
  $74 = (($21) + -5)|0; //@line 62301 "c/sqlite3.c"
  $spec$select = $73 ? $74 : $64; //@line 62301 "c/sqlite3.c"
  $75 = HEAP16[$57>>1]|0; //@line 62302 "c/sqlite3.c"
  $76 = ($75<<16>>16)==(0); //@line 62302 "c/sqlite3.c"
  L11: do {
   if (!($76)) {
    $77 = ((($0)) + 76|0);
    $$0128142 = 0;
    while(1) {
     $82 = $$0128142 << 1; //@line 62303 "c/sqlite3.c"
     $83 = (($82) + ($26))|0; //@line 62303 "c/sqlite3.c"
     $84 = (($6) + ($83)|0); //@line 62303 "c/sqlite3.c"
     $85 = HEAP8[$84>>0]|0; //@line 62303 "c/sqlite3.c"
     $86 = $85&255; //@line 62303 "c/sqlite3.c"
     $87 = $86 << 8; //@line 62303 "c/sqlite3.c"
     $88 = ((($84)) + 1|0); //@line 62303 "c/sqlite3.c"
     $89 = HEAP8[$88>>0]|0; //@line 62303 "c/sqlite3.c"
     $90 = $89&255; //@line 62303 "c/sqlite3.c"
     $91 = $87 | $90; //@line 62303 "c/sqlite3.c"
     $92 = ($91>>>0)<($63>>>0); //@line 62306 "c/sqlite3.c"
     $93 = ($91|0)>($spec$select|0); //@line 62306 "c/sqlite3.c"
     $or$cond = $92 | $93; //@line 62306 "c/sqlite3.c"
     if ($or$cond) {
      label = 10;
      break;
     }
     $95 = HEAP32[$77>>2]|0; //@line 62309 "c/sqlite3.c"
     $96 = (($6) + ($91)|0); //@line 62309 "c/sqlite3.c"
     $97 = (FUNCTION_TABLE_iii[$95 & 255]($0,$96)|0); //@line 62309 "c/sqlite3.c"
     $98 = $97&65535; //@line 62309 "c/sqlite3.c"
     $99 = (($91) + ($98))|0; //@line 62311 "c/sqlite3.c"
     $100 = ($99|0)>($21|0); //@line 62311 "c/sqlite3.c"
     $81 = (($$0128142) + 1)|0; //@line 62302 "c/sqlite3.c"
     if ($100) {
      label = 12;
      break;
     }
     $78 = HEAP16[$57>>1]|0; //@line 62302 "c/sqlite3.c"
     $79 = $78&65535; //@line 62302 "c/sqlite3.c"
     $80 = ($81>>>0)<($79>>>0); //@line 62302 "c/sqlite3.c"
     if ($80) {
      $$0128142 = $81;
     } else {
      break L11;
     }
    }
    if ((label|0) == 10) {
     $94 = (_sqlite3CorruptError(62307)|0); //@line 62307 "c/sqlite3.c"
     $$3 = $94;
     return ($$3|0); //@line 62366 "c/sqlite3.c"
    }
    else if ((label|0) == 12) {
     $101 = (_sqlite3CorruptError(62312)|0); //@line 62312 "c/sqlite3.c"
     $$3 = $101;
     return ($$3|0); //@line 62366 "c/sqlite3.c"
    }
   }
  } while(0);
  $102 = HEAP8[$71>>0]|0; //@line 62315 "c/sqlite3.c"
  $103 = ($102<<24>>24)==(0); //@line 62315 "c/sqlite3.c"
  $104 = $103&1; //@line 62315 "c/sqlite3.c"
  $spec$select135 = (($spec$select) + ($104))|0; //@line 62315 "c/sqlite3.c"
  $$3134 = $spec$select135;
 }
 $105 = (($7) + 1)|0; //@line 62322 "c/sqlite3.c"
 $106 = (($6) + ($105)|0); //@line 62322 "c/sqlite3.c"
 $107 = HEAP8[$106>>0]|0; //@line 62322 "c/sqlite3.c"
 $108 = $107&255; //@line 62322 "c/sqlite3.c"
 $109 = $108 << 8; //@line 62322 "c/sqlite3.c"
 $110 = ((($106)) + 1|0); //@line 62322 "c/sqlite3.c"
 $111 = HEAP8[$110>>0]|0; //@line 62322 "c/sqlite3.c"
 $112 = $111&255; //@line 62322 "c/sqlite3.c"
 $113 = $109 | $112; //@line 62322 "c/sqlite3.c"
 $114 = (($7) + 7)|0; //@line 62323 "c/sqlite3.c"
 $115 = (($6) + ($114)|0); //@line 62323 "c/sqlite3.c"
 $116 = HEAP8[$115>>0]|0; //@line 62323 "c/sqlite3.c"
 $117 = $116&255; //@line 62323 "c/sqlite3.c"
 $118 = (($46) + ($117))|0; //@line 62323 "c/sqlite3.c"
 $119 = ($113|0)==(0); //@line 62324 "c/sqlite3.c"
 L24: do {
  if ($119) {
   $$2127 = $118;
  } else {
   $120 = ($113>>>0)<($63>>>0); //@line 62326 "c/sqlite3.c"
   if ($120) {
    $121 = (_sqlite3CorruptError(62330)|0); //@line 62330 "c/sqlite3.c"
    $$3 = $121;
    return ($$3|0); //@line 62366 "c/sqlite3.c"
   }
   $122 = ($113|0)>($$3134|0); //@line 62333 "c/sqlite3.c"
   L30: do {
    if (!($122)) {
     $$0124141 = $113;$$0125140 = $118;
     while(1) {
      $126 = (($6) + ($$0124141)|0); //@line 62337 "c/sqlite3.c"
      $127 = HEAP8[$126>>0]|0; //@line 62337 "c/sqlite3.c"
      $128 = $127&255; //@line 62337 "c/sqlite3.c"
      $129 = $128 << 8; //@line 62337 "c/sqlite3.c"
      $130 = ((($126)) + 1|0); //@line 62337 "c/sqlite3.c"
      $131 = HEAP8[$130>>0]|0; //@line 62337 "c/sqlite3.c"
      $132 = $131&255; //@line 62337 "c/sqlite3.c"
      $124 = $129 | $132; //@line 62337 "c/sqlite3.c"
      $133 = (($$0124141) + 2)|0; //@line 62338 "c/sqlite3.c"
      $134 = (($6) + ($133)|0); //@line 62338 "c/sqlite3.c"
      $135 = HEAP8[$134>>0]|0; //@line 62338 "c/sqlite3.c"
      $136 = $135&255; //@line 62338 "c/sqlite3.c"
      $137 = $136 << 8; //@line 62338 "c/sqlite3.c"
      $138 = ((($134)) + 1|0); //@line 62338 "c/sqlite3.c"
      $139 = HEAP8[$138>>0]|0; //@line 62338 "c/sqlite3.c"
      $140 = $139&255; //@line 62338 "c/sqlite3.c"
      $141 = $137 | $140; //@line 62338 "c/sqlite3.c"
      $142 = (($141) + ($$0125140))|0; //@line 62339 "c/sqlite3.c"
      $143 = (($141) + ($$0124141))|0; //@line 62340 "c/sqlite3.c"
      $144 = (($143) + 3)|0; //@line 62340 "c/sqlite3.c"
      $145 = ($124>>>0)>($144>>>0); //@line 62340 "c/sqlite3.c"
      if (!($145)) {
       break;
      }
      $123 = ($124|0)>($$3134|0); //@line 62333 "c/sqlite3.c"
      if ($123) {
       break L30;
      } else {
       $$0124141 = $124;$$0125140 = $142;
      }
     }
     $146 = ($124|0)==(0); //@line 62343 "c/sqlite3.c"
     if (!($146)) {
      $147 = (_sqlite3CorruptError(62345)|0); //@line 62345 "c/sqlite3.c"
      $$3 = $147;
      return ($$3|0); //@line 62366 "c/sqlite3.c"
     }
     $148 = ($143>>>0)>($21>>>0); //@line 62347 "c/sqlite3.c"
     if (!($148)) {
      $$2127 = $142;
      break L24;
     }
     $149 = (_sqlite3CorruptError(62349)|0); //@line 62349 "c/sqlite3.c"
     $$3 = $149;
     return ($$3|0); //@line 62366 "c/sqlite3.c"
    }
   } while(0);
   $125 = (_sqlite3CorruptError(62335)|0); //@line 62335 "c/sqlite3.c"
   $$3 = $125;
   return ($$3|0); //@line 62366 "c/sqlite3.c"
  }
 } while(0);
 $150 = ($$2127|0)>($21|0); //@line 62360 "c/sqlite3.c"
 if ($150) {
  $151 = (_sqlite3CorruptError(62361)|0); //@line 62361 "c/sqlite3.c"
  $$3 = $151;
  return ($$3|0); //@line 62366 "c/sqlite3.c"
 } else {
  $152 = (($$2127) - ($63))|0; //@line 62363 "c/sqlite3.c"
  $153 = $152&65535; //@line 62363 "c/sqlite3.c"
  $154 = ((($0)) + 20|0); //@line 62363 "c/sqlite3.c"
  HEAP16[$154>>1] = $153; //@line 62363 "c/sqlite3.c"
  HEAP8[$0>>0] = 1; //@line 62364 "c/sqlite3.c"
  $$3 = 0;
  return ($$3|0); //@line 62366 "c/sqlite3.c"
 }
 return (0)|0;
}
function _ptrmapPutOvflPtr($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = HEAP32[$2>>2]|0; //@line 61755 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 61755 "c/sqlite3.c"
 if (!($5)) {
  STACKTOP = sp;return; //@line 61762 "c/sqlite3.c"
 }
 $6 = ((($0)) + 80|0); //@line 61757 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 61757 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$7 & 255]($0,$1,$3); //@line 61757 "c/sqlite3.c"
 $8 = ((($3)) + 16|0); //@line 61758 "c/sqlite3.c"
 $9 = HEAP16[$8>>1]|0; //@line 61758 "c/sqlite3.c"
 $10 = $9&65535; //@line 61758 "c/sqlite3.c"
 $11 = ((($3)) + 12|0); //@line 61758 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 61758 "c/sqlite3.c"
 $13 = ($12>>>0)>($10>>>0); //@line 61758 "c/sqlite3.c"
 if (!($13)) {
  STACKTOP = sp;return; //@line 61762 "c/sqlite3.c"
 }
 $14 = ((($3)) + 18|0); //@line 61759 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 61759 "c/sqlite3.c"
 $16 = $15&65535; //@line 61759 "c/sqlite3.c"
 $17 = (($16) + -4)|0; //@line 61759 "c/sqlite3.c"
 $18 = (($1) + ($17)|0); //@line 61759 "c/sqlite3.c"
 $19 = (_sqlite3Get4byte($18)|0); //@line 61759 "c/sqlite3.c"
 $20 = ((($0)) + 52|0); //@line 61760 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 61760 "c/sqlite3.c"
 $22 = ((($0)) + 4|0); //@line 61760 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 61760 "c/sqlite3.c"
 _ptrmapPut($21,$19,3,$23,$2); //@line 61760 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 61762 "c/sqlite3.c"
}
function _sqlite3PcacheMove($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 45797 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45797 "c/sqlite3.c"
 $4 = HEAP32[(156)>>2]|0; //@line 45802 "c/sqlite3.c"
 $5 = ((($3)) + 44|0); //@line 45802 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 45802 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 45802 "c/sqlite3.c"
 $8 = ((($0)) + 24|0); //@line 45802 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 45802 "c/sqlite3.c"
 FUNCTION_TABLE_viiii[$4 & 127]($6,$7,$9,$1); //@line 45802 "c/sqlite3.c"
 HEAP32[$8>>2] = $1; //@line 45803 "c/sqlite3.c"
 $10 = ((($0)) + 28|0); //@line 45804 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 45804 "c/sqlite3.c"
 $12 = $11 & 10; //@line 45804 "c/sqlite3.c"
 $13 = ($12<<16>>16)==(10); //@line 45804 "c/sqlite3.c"
 if (!($13)) {
  return; //@line 45807 "c/sqlite3.c"
 }
 _pcacheManageDirtyList($0,3); //@line 45805 "c/sqlite3.c"
 return; //@line 45807 "c/sqlite3.c"
}
function _sqlite3BitvecClear($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$044$lcssa = 0, $$04455 = 0, $$04553 = 0, $$047$lcssa = 0, $$04754 = 0, $$052 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, $spec$store$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 45005 "c/sqlite3.c"
 if ($3) {
  return; //@line 45036 "c/sqlite3.c"
 }
 $4 = (($1) + -1)|0; //@line 45007 "c/sqlite3.c"
 $5 = ((($0)) + 8|0); //@line 45008 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 45008 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 45008 "c/sqlite3.c"
 L4: do {
  if ($7) {
   $$044$lcssa = $0;$$047$lcssa = $4;
  } else {
   $$04455 = $0;$$04754 = $4;$9 = $6;
   while(1) {
    $8 = (($$04754>>>0) / ($9>>>0))&-1; //@line 45009 "c/sqlite3.c"
    $10 = ((($$04455)) + 12|0); //@line 45011 "c/sqlite3.c"
    $11 = (($10) + ($8<<2)|0); //@line 45011 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 45011 "c/sqlite3.c"
    $13 = ($12|0)==(0|0); //@line 45012 "c/sqlite3.c"
    if ($13) {
     break;
    }
    $14 = Math_imul($8, $9)|0;
    $15 = (($$04754) - ($14))|0;
    $16 = ((($12)) + 8|0); //@line 45008 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 45008 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 45008 "c/sqlite3.c"
    if ($18) {
     $$044$lcssa = $12;$$047$lcssa = $15;
     break L4;
    } else {
     $$04455 = $12;$$04754 = $15;$9 = $17;
    }
   }
   return; //@line 45036 "c/sqlite3.c"
  }
 } while(0);
 $19 = HEAP32[$$044$lcssa>>2]|0; //@line 45016 "c/sqlite3.c"
 $20 = ($19>>>0)<(4001); //@line 45016 "c/sqlite3.c"
 if ($20) {
  $21 = $$047$lcssa & 7; //@line 45017 "c/sqlite3.c"
  $22 = 1 << $21; //@line 45017 "c/sqlite3.c"
  $23 = $22 ^ 255; //@line 45017 "c/sqlite3.c"
  $24 = ((($$044$lcssa)) + 12|0); //@line 45017 "c/sqlite3.c"
  $25 = $$047$lcssa >>> 3; //@line 45017 "c/sqlite3.c"
  $26 = (($24) + ($25)|0); //@line 45017 "c/sqlite3.c"
  $27 = HEAP8[$26>>0]|0; //@line 45017 "c/sqlite3.c"
  $28 = $27&255; //@line 45017 "c/sqlite3.c"
  $29 = $23 & $28; //@line 45017 "c/sqlite3.c"
  $30 = $29&255; //@line 45017 "c/sqlite3.c"
  HEAP8[$26>>0] = $30; //@line 45017 "c/sqlite3.c"
  return; //@line 45036 "c/sqlite3.c"
 }
 $31 = ((($$044$lcssa)) + 12|0); //@line 45021 "c/sqlite3.c"
 _memcpy(($2|0),($31|0),500)|0; //@line 45021 "c/sqlite3.c"
 _memset(($31|0),0,500)|0; //@line 45022 "c/sqlite3.c"
 $32 = ((($$044$lcssa)) + 4|0); //@line 45023 "c/sqlite3.c"
 HEAP32[$32>>2] = 0; //@line 45023 "c/sqlite3.c"
 $33 = (($$047$lcssa) + 1)|0;
 $$04553 = 0;
 while(1) {
  $34 = (($2) + ($$04553<<2)|0); //@line 45025 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 45025 "c/sqlite3.c"
  $36 = ($35|0)==(0); //@line 45025 "c/sqlite3.c"
  $37 = ($35|0)==($33|0); //@line 45025 "c/sqlite3.c"
  $or$cond = $36 | $37; //@line 45025 "c/sqlite3.c"
  if (!($or$cond)) {
   $38 = (($35) + -1)|0; //@line 45026 "c/sqlite3.c"
   $39 = (($38>>>0) % 125)&-1; //@line 45026 "c/sqlite3.c"
   $40 = HEAP32[$32>>2]|0; //@line 45027 "c/sqlite3.c"
   $41 = (($40) + 1)|0; //@line 45027 "c/sqlite3.c"
   HEAP32[$32>>2] = $41; //@line 45027 "c/sqlite3.c"
   $42 = (((($$044$lcssa)) + 12|0) + ($39<<2)|0); //@line 45028 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 45028 "c/sqlite3.c"
   $44 = ($43|0)==(0); //@line 45028 "c/sqlite3.c"
   if ($44) {
    $$lcssa = $42;
   } else {
    $$052 = $39;
    while(1) {
     $45 = (($$052) + 1)|0; //@line 45029 "c/sqlite3.c"
     $46 = ($45>>>0)>(124); //@line 45030 "c/sqlite3.c"
     $spec$store$select = $46 ? 0 : $45; //@line 45030 "c/sqlite3.c"
     $47 = (((($$044$lcssa)) + 12|0) + ($spec$store$select<<2)|0); //@line 45028 "c/sqlite3.c"
     $48 = HEAP32[$47>>2]|0; //@line 45028 "c/sqlite3.c"
     $49 = ($48|0)==(0); //@line 45028 "c/sqlite3.c"
     if ($49) {
      $$lcssa = $47;
      break;
     } else {
      $$052 = $spec$store$select;
     }
    }
   }
   $50 = HEAP32[$34>>2]|0; //@line 45032 "c/sqlite3.c"
   HEAP32[$$lcssa>>2] = $50; //@line 45032 "c/sqlite3.c"
  }
  $51 = (($$04553) + 1)|0; //@line 45024 "c/sqlite3.c"
  $exitcond = ($51|0)==(125); //@line 45024 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$04553 = $51;
  }
 }
 return; //@line 45036 "c/sqlite3.c"
}
function _btreeGetUnusedPage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_btreeGetPage($0,$1,$2,$3)|0); //@line 62588 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 62589 "c/sqlite3.c"
 if (!($5)) {
  HEAP32[$2>>2] = 0; //@line 62597 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 62600 "c/sqlite3.c"
 }
 $6 = HEAP32[$2>>2]|0; //@line 62590 "c/sqlite3.c"
 $7 = ((($6)) + 72|0); //@line 62590 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 62590 "c/sqlite3.c"
 $9 = (_sqlite3PagerPageRefcount($8)|0); //@line 62590 "c/sqlite3.c"
 $10 = ($9|0)>(1); //@line 62590 "c/sqlite3.c"
 if ($10) {
  _releasePage($6); //@line 62591 "c/sqlite3.c"
  HEAP32[$2>>2] = 0; //@line 62592 "c/sqlite3.c"
  $11 = (_sqlite3CorruptError(62593)|0); //@line 62593 "c/sqlite3.c"
  $$0 = $11;
  return ($$0|0); //@line 62600 "c/sqlite3.c"
 } else {
  HEAP8[$6>>0] = 0; //@line 62595 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 62600 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3AbsInt32($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)>(-1); //@line 29849 "c/sqlite3.c"
 if ($1) {
  return ($0|0); //@line 29852 "c/sqlite3.c"
 } else {
  $2 = ($0|0)==(-2147483648); //@line 29850 "c/sqlite3.c"
  $3 = (0 - ($0))|0; //@line 29851 "c/sqlite3.c"
  $spec$select = $2 ? 2147483647 : $3; //@line 29850 "c/sqlite3.c"
  return ($spec$select|0); //@line 29850 "c/sqlite3.c"
 }
 return (0)|0;
}
function _btreeGetHasContent($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 60|0); //@line 61016 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 61016 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 61017 "c/sqlite3.c"
 if ($4) {
  $9 = 0;
  return ($9|0); //@line 61017 "c/sqlite3.c"
 }
 $5 = (_sqlite3BitvecSize($3)|0); //@line 61017 "c/sqlite3.c"
 $6 = ($5>>>0)<($1>>>0); //@line 61017 "c/sqlite3.c"
 if ($6) {
  $9 = 1;
  return ($9|0); //@line 61017 "c/sqlite3.c"
 }
 $7 = (_sqlite3BitvecTest($3,$1)|0); //@line 61017 "c/sqlite3.c"
 $8 = ($7|0)!=(0); //@line 61017 "c/sqlite3.c"
 $phitmp = $8&1; //@line 61017 "c/sqlite3.c"
 $9 = $phitmp;
 return ($9|0); //@line 61017 "c/sqlite3.c"
}
function _sqlite3BitvecSize($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 45057 "c/sqlite3.c"
 return ($1|0); //@line 45057 "c/sqlite3.c"
}
function _sqlite3PagerPageRefcount($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3PcachePageRefcount($0)|0); //@line 54668 "c/sqlite3.c"
 return ($1|0); //@line 54668 "c/sqlite3.c"
}
function _sqlite3PagerFilename($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 54897 "c/sqlite3.c"
 if (!($2)) {
  $3 = ((($0)) + 15|0); //@line 54897 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 54897 "c/sqlite3.c"
  $5 = ($4<<24>>24)==(0); //@line 54897 "c/sqlite3.c"
  if (!($5)) {
   $8 = 41388;
   return ($8|0); //@line 54897 "c/sqlite3.c"
  }
 }
 $6 = ((($0)) + 168|0); //@line 54897 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 54897 "c/sqlite3.c"
 $8 = $7;
 return ($8|0); //@line 54897 "c/sqlite3.c"
}
function _pager_wait_on_lock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 176|0); //@line 51903 "c/sqlite3.c"
 $3 = ((($0)) + 180|0);
 while(1) {
  $4 = (_pagerLockDb($0,$1)|0); //@line 51902 "c/sqlite3.c"
  $5 = ($4|0)==(5); //@line 51903 "c/sqlite3.c"
  if (!($5)) {
   label = 4;
   break;
  }
  $6 = HEAP32[$2>>2]|0; //@line 51903 "c/sqlite3.c"
  $7 = HEAP32[$3>>2]|0; //@line 51903 "c/sqlite3.c"
  $8 = (FUNCTION_TABLE_ii[$6 & 255]($7)|0); //@line 51903 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 51903 "c/sqlite3.c"
  if ($9) {
   label = 4;
   break;
  }
 }
 if ((label|0) == 4) {
  return ($4|0); //@line 51904 "c/sqlite3.c"
 }
 return (0)|0;
}
function _pagerLockDb($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond13 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 17|0); //@line 49139 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 49139 "c/sqlite3.c"
 $4 = $3&255; //@line 49139 "c/sqlite3.c"
 $5 = ($4|0)<($1|0); //@line 49139 "c/sqlite3.c"
 $6 = ($3<<24>>24)==(5); //@line 49139 "c/sqlite3.c"
 $or$cond13 = $6 | $5; //@line 49139 "c/sqlite3.c"
 if (!($or$cond13)) {
  $$0 = 0;
  return ($$0|0); //@line 49146 "c/sqlite3.c"
 }
 $7 = ((($0)) + 13|0); //@line 49140 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 49140 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 49140 "c/sqlite3.c"
 if ($9) {
  $10 = ((($0)) + 60|0); //@line 49140 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 49140 "c/sqlite3.c"
  $12 = (_sqlite3OsLock($11,$1)|0); //@line 49140 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 49141 "c/sqlite3.c"
  if (!($13)) {
   $$0 = $12;
   return ($$0|0); //@line 49146 "c/sqlite3.c"
  }
 }
 $14 = HEAP8[$2>>0]|0; //@line 49141 "c/sqlite3.c"
 $15 = ($14<<24>>24)!=(5); //@line 49141 "c/sqlite3.c"
 $16 = ($1|0)==(4); //@line 49141 "c/sqlite3.c"
 $or$cond = $16 | $15; //@line 49141 "c/sqlite3.c"
 if (!($or$cond)) {
  $$0 = 0;
  return ($$0|0); //@line 49146 "c/sqlite3.c"
 }
 $17 = $1&255; //@line 49142 "c/sqlite3.c"
 HEAP8[$2>>0] = $17; //@line 49142 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 49146 "c/sqlite3.c"
}
function _sqlite3OsLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 20919 "c/sqlite3.c"
 $3 = ((($2)) + 28|0); //@line 20919 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 20919 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iii[$4 & 255]($0,$1)|0); //@line 20919 "c/sqlite3.c"
 return ($5|0); //@line 20919 "c/sqlite3.c"
}
function _sqlite3VtabImportErrmsg($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 8|0); //@line 77605 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 77605 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 77605 "c/sqlite3.c"
 if ($4) {
  return; //@line 77612 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 77606 "c/sqlite3.c"
 $6 = ((($0)) + 108|0); //@line 77607 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 77607 "c/sqlite3.c"
 _sqlite3DbFree($5,$7); //@line 77607 "c/sqlite3.c"
 $8 = HEAP32[$2>>2]|0; //@line 77608 "c/sqlite3.c"
 $9 = (_sqlite3DbStrDup($5,$8)|0); //@line 77608 "c/sqlite3.c"
 HEAP32[$6>>2] = $9; //@line 77608 "c/sqlite3.c"
 $10 = HEAP32[$2>>2]|0; //@line 77609 "c/sqlite3.c"
 _sqlite3_free($10); //@line 77609 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 77610 "c/sqlite3.c"
 return; //@line 77612 "c/sqlite3.c"
}
function _vdbeLeave($0) {
 $0 = $0|0;
 var $$019 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 74459 "c/sqlite3.c"
 $2 = ((($1)) + 16|0); //@line 74460 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 74460 "c/sqlite3.c"
 $4 = ((($1)) + 20|0); //@line 74461 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 74461 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 74462 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 74467 "c/sqlite3.c"
 }
 $7 = ((($0)) + 152|0);
 $$019 = 0;
 while(1) {
  $8 = ($$019|0)==(1); //@line 74463 "c/sqlite3.c"
  if (!($8)) {
   $9 = HEAP32[$7>>2]|0; //@line 74463 "c/sqlite3.c"
   $10 = 1 << $$019; //@line 74463 "c/sqlite3.c"
   $11 = $9 & $10; //@line 74463 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 74463 "c/sqlite3.c"
   if (!($12)) {
    $13 = (((($3) + ($$019<<4)|0)) + 4|0); //@line 74463 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 74463 "c/sqlite3.c"
    $15 = ($14|0)==(0|0); //@line 74463 "c/sqlite3.c"
    if (!($15)) {
     _sqlite3BtreeLeave($14); //@line 74464 "c/sqlite3.c"
    }
   }
  }
  $16 = (($$019) + 1)|0; //@line 74462 "c/sqlite3.c"
  $exitcond = ($16|0)==($5|0); //@line 74462 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$019 = $16;
  }
 }
 return; //@line 74467 "c/sqlite3.c"
}
function _sqlite3VdbeError($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 73010 "c/sqlite3.c"
 $4 = ((($0)) + 108|0); //@line 73010 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 73010 "c/sqlite3.c"
 _sqlite3DbFree($3,$5); //@line 73010 "c/sqlite3.c"
 HEAP32[$2>>2] = $varargs; //@line 73011 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 73012 "c/sqlite3.c"
 $7 = (_sqlite3VMPrintf($6,$1,$2)|0); //@line 73012 "c/sqlite3.c"
 HEAP32[$4>>2] = $7; //@line 73012 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 73014 "c/sqlite3.c"
}
function _sqlite3BtreeRollback($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02 = 0, $$0291 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 4|0;
 $4 = sp;
 $5 = ((($0)) + 4|0); //@line 64482 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 64482 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 64487 "c/sqlite3.c"
 $7 = ($1|0)==(0); //@line 64488 "c/sqlite3.c"
 if ($7) {
  $8 = (_saveAllCursors($6,0,0)|0); //@line 64489 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 64490 "c/sqlite3.c"
  $spec$select = $9 ? $2 : 0; //@line 64490 "c/sqlite3.c"
  $10 = ($8|0)==(0); //@line 64494 "c/sqlite3.c"
  if (!($10)) {
   $$02 = $8;$$0291 = $spec$select;
   label = 3;
  }
 } else {
  $$02 = $1;$$0291 = $2;
  label = 3;
 }
 if ((label|0) == 3) {
  (_sqlite3BtreeTripAllCursors($0,$$02,$$0291)|0); //@line 64495 "c/sqlite3.c"
 }
 $11 = ((($0)) + 8|0); //@line 64501 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 64501 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(2); //@line 64501 "c/sqlite3.c"
 if (!($13)) {
  _btreeEndTransaction($0); //@line 64526 "c/sqlite3.c"
  _sqlite3BtreeLeave($0); //@line 64527 "c/sqlite3.c"
  STACKTOP = sp;return;
 }
 $14 = HEAP32[$6>>2]|0; //@line 64505 "c/sqlite3.c"
 (_sqlite3PagerRollback($14)|0); //@line 64505 "c/sqlite3.c"
 $15 = (_btreeGetPage($6,1,$3,0)|0); //@line 64513 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 64513 "c/sqlite3.c"
 if ($16) {
  $17 = HEAP32[$3>>2]|0; //@line 64514 "c/sqlite3.c"
  $18 = ((($17)) + 56|0); //@line 64514 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 64514 "c/sqlite3.c"
  $20 = ((($19)) + 28|0); //@line 64514 "c/sqlite3.c"
  $21 = (_sqlite3Get4byte($20)|0); //@line 64514 "c/sqlite3.c"
  HEAP32[$4>>2] = $21; //@line 64514 "c/sqlite3.c"
  $22 = ($21|0)==(0); //@line 64516 "c/sqlite3.c"
  if ($22) {
   $23 = HEAP32[$6>>2]|0; //@line 64516 "c/sqlite3.c"
   _sqlite3PagerPagecount($23,$4); //@line 64516 "c/sqlite3.c"
  }
  $24 = HEAP32[$4>>2]|0; //@line 64518 "c/sqlite3.c"
  $25 = ((($6)) + 44|0); //@line 64518 "c/sqlite3.c"
  HEAP32[$25>>2] = $24; //@line 64518 "c/sqlite3.c"
  _releasePageOne($17); //@line 64519 "c/sqlite3.c"
 }
 $26 = ((($6)) + 20|0); //@line 64522 "c/sqlite3.c"
 HEAP8[$26>>0] = 1; //@line 64522 "c/sqlite3.c"
 _btreeClearHasContent($6); //@line 64523 "c/sqlite3.c"
 _btreeEndTransaction($0); //@line 64526 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 64527 "c/sqlite3.c"
 STACKTOP = sp;return;
}
function _sqlite3VtabRollback($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _callFinaliser($0,68); //@line 128271 "c/sqlite3.c"
 return;
}
function _sqlite3ExpirePreparedStatements($0) {
 $0 = $0|0;
 var $$0 = 0, $$05 = 0, $$06 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 77517 "c/sqlite3.c"
 $$05 = HEAP32[$1>>2]|0;
 $2 = ($$05|0)==(0|0); //@line 77517 "c/sqlite3.c"
 if ($2) {
  return; //@line 77520 "c/sqlite3.c"
 }
 $$06 = $$05;
 while(1) {
  $3 = ((($$06)) + 145|0); //@line 77518 "c/sqlite3.c"
  $4 = HEAPU8[$3>>0]|(HEAPU8[$3+1>>0]<<8); //@line 77518 "c/sqlite3.c"
  $5 = $4 | 1; //@line 77518 "c/sqlite3.c"
  HEAP8[$3>>0]=$5&255;HEAP8[$3+1>>0]=$5>>8; //@line 77518 "c/sqlite3.c"
  $6 = ((($$06)) + 8|0); //@line 77517 "c/sqlite3.c"
  $$0 = HEAP32[$6>>2]|0;
  $7 = ($$0|0)==(0|0); //@line 77517 "c/sqlite3.c"
  if ($7) {
   break;
  } else {
   $$06 = $$0;
  }
 }
 return; //@line 77520 "c/sqlite3.c"
}
function _sqlite3ResetAllSchemasOfConnection($0) {
 $0 = $0|0;
 var $$014 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnterAll($0); //@line 102163 "c/sqlite3.c"
 $1 = ((($0)) + 20|0); //@line 102165 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 102165 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 102165 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 16|0);
  $$014 = 0;
  while(1) {
   $5 = HEAP32[$4>>2]|0; //@line 102166 "c/sqlite3.c"
   $6 = (((($5) + ($$014<<4)|0)) + 12|0); //@line 102167 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 102167 "c/sqlite3.c"
   $8 = ($7|0)==(0|0); //@line 102167 "c/sqlite3.c"
   if (!($8)) {
    _sqlite3SchemaClear($7); //@line 102168 "c/sqlite3.c"
   }
   $9 = (($$014) + 1)|0; //@line 102165 "c/sqlite3.c"
   $10 = HEAP32[$1>>2]|0; //@line 102165 "c/sqlite3.c"
   $11 = ($9|0)<($10|0); //@line 102165 "c/sqlite3.c"
   if ($11) {
    $$014 = $9;
   } else {
    break;
   }
  }
 }
 $12 = ((($0)) + 24|0); //@line 102171 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 102171 "c/sqlite3.c"
 $14 = $13 & -2; //@line 102171 "c/sqlite3.c"
 HEAP32[$12>>2] = $14; //@line 102171 "c/sqlite3.c"
 _sqlite3VtabUnlockList($0); //@line 102172 "c/sqlite3.c"
 _sqlite3BtreeLeaveAll($0); //@line 102173 "c/sqlite3.c"
 _sqlite3CollapseDatabaseArray($0); //@line 102174 "c/sqlite3.c"
 return; //@line 102175 "c/sqlite3.c"
}
function _sqlite3CollapseDatabaseArray($0) {
 $0 = $0|0;
 var $$03235 = 0, $$03334 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 102113 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 102113 "c/sqlite3.c"
 $3 = ($2|0)>(2); //@line 102113 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 16|0);
  $$03235 = 2;$$03334 = 2;
  while(1) {
   $5 = HEAP32[$4>>2]|0; //@line 102114 "c/sqlite3.c"
   $6 = (($5) + ($$03235<<4)|0); //@line 102114 "c/sqlite3.c"
   $7 = (((($5) + ($$03235<<4)|0)) + 4|0); //@line 102115 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 102115 "c/sqlite3.c"
   $9 = ($8|0)==(0|0); //@line 102115 "c/sqlite3.c"
   if ($9) {
    $10 = HEAP32[$6>>2]|0; //@line 102116 "c/sqlite3.c"
    _sqlite3DbFree($0,$10); //@line 102116 "c/sqlite3.c"
    HEAP32[$6>>2] = 0; //@line 102117 "c/sqlite3.c"
    $$1 = $$03334;
   } else {
    $11 = ($$03334|0)<($$03235|0); //@line 102120 "c/sqlite3.c"
    if ($11) {
     $12 = (($5) + ($$03334<<4)|0); //@line 102121 "c/sqlite3.c"
     ;HEAP32[$12>>2]=HEAP32[$6>>2]|0;HEAP32[$12+4>>2]=HEAP32[$6+4>>2]|0;HEAP32[$12+8>>2]=HEAP32[$6+8>>2]|0;HEAP32[$12+12>>2]=HEAP32[$6+12>>2]|0; //@line 102121 "c/sqlite3.c"
    }
    $13 = (($$03334) + 1)|0; //@line 102123 "c/sqlite3.c"
    $$1 = $13;
   }
   $14 = (($$03235) + 1)|0; //@line 102113 "c/sqlite3.c"
   $15 = HEAP32[$1>>2]|0; //@line 102113 "c/sqlite3.c"
   $16 = ($14|0)<($15|0); //@line 102113 "c/sqlite3.c"
   if ($16) {
    $$03235 = $14;$$03334 = $$1;
   } else {
    break;
   }
  }
  HEAP32[$1>>2] = $$1; //@line 102125 "c/sqlite3.c"
  $17 = ($$1|0)<(3); //@line 102126 "c/sqlite3.c"
  if (!($17)) {
   return; //@line 102131 "c/sqlite3.c"
  }
 } else {
  HEAP32[$1>>2] = 2; //@line 102125 "c/sqlite3.c"
 }
 $18 = ((($0)) + 16|0); //@line 102126 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 102126 "c/sqlite3.c"
 $20 = ((($0)) + 400|0); //@line 102126 "c/sqlite3.c"
 $21 = ($19|0)==($20|0); //@line 102126 "c/sqlite3.c"
 if ($21) {
  return; //@line 102131 "c/sqlite3.c"
 }
 ;HEAP32[$20>>2]=HEAP32[$19>>2]|0;HEAP32[$20+4>>2]=HEAP32[$19+4>>2]|0;HEAP32[$20+8>>2]=HEAP32[$19+8>>2]|0;HEAP32[$20+12>>2]=HEAP32[$19+12>>2]|0;HEAP32[$20+16>>2]=HEAP32[$19+16>>2]|0;HEAP32[$20+20>>2]=HEAP32[$19+20>>2]|0;HEAP32[$20+24>>2]=HEAP32[$19+24>>2]|0;HEAP32[$20+28>>2]=HEAP32[$19+28>>2]|0; //@line 102127 "c/sqlite3.c"
 $22 = HEAP32[$18>>2]|0; //@line 102128 "c/sqlite3.c"
 _sqlite3DbFree($0,$22); //@line 102128 "c/sqlite3.c"
 HEAP32[$18>>2] = $20; //@line 102129 "c/sqlite3.c"
 return; //@line 102131 "c/sqlite3.c"
}
function _sqlite3BtreeTripAllCursors($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$022 = 0, $$02223 = 0, $$02224 = 0, $$2 = 0, $$3 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $switch = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 64446 "c/sqlite3.c"
 if ($3) {
  $$3 = 0;
  return ($$3|0); //@line 64466 "c/sqlite3.c"
 }
 _sqlite3BtreeEnter($0); //@line 64447 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 64448 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 64448 "c/sqlite3.c"
 $6 = ((($5)) + 8|0); //@line 64448 "c/sqlite3.c"
 $$02223 = HEAP32[$6>>2]|0;
 $7 = ($$02223|0)==(0|0); //@line 64448 "c/sqlite3.c"
 L4: do {
  if ($7) {
   $$2 = 0;
  } else {
   $8 = ($2|0)==(0);
   $$02224 = $$02223;
   while(1) {
    if ($8) {
     label = 9;
    } else {
     $9 = ((($$02224)) + 1|0); //@line 64449 "c/sqlite3.c"
     $10 = HEAP8[$9>>0]|0; //@line 64449 "c/sqlite3.c"
     $11 = $10 & 1; //@line 64449 "c/sqlite3.c"
     $12 = ($11<<24>>24)==(0); //@line 64449 "c/sqlite3.c"
     if ($12) {
      $13 = HEAP8[$$02224>>0]|0; //@line 64450 "c/sqlite3.c"
      $$off = (($13) + -1)<<24>>24; //@line 64450 "c/sqlite3.c"
      $switch = ($$off&255)<(2); //@line 64450 "c/sqlite3.c"
      if ($switch) {
       $14 = (_saveCursorPosition($$02224)|0); //@line 64451 "c/sqlite3.c"
       $15 = ($14|0)==(0); //@line 64452 "c/sqlite3.c"
       if (!($15)) {
        break;
       }
      }
     } else {
      label = 9;
     }
    }
    if ((label|0) == 9) {
     label = 0;
     _sqlite3BtreeClearCursor($$02224); //@line 64458 "c/sqlite3.c"
     HEAP8[$$02224>>0] = 4; //@line 64459 "c/sqlite3.c"
     $16 = ((($$02224)) + 64|0); //@line 64460 "c/sqlite3.c"
     HEAP32[$16>>2] = $1; //@line 64460 "c/sqlite3.c"
    }
    _btreeReleaseAllCursorPages($$02224); //@line 64462 "c/sqlite3.c"
    $17 = ((($$02224)) + 16|0); //@line 64448 "c/sqlite3.c"
    $$022 = HEAP32[$17>>2]|0;
    $18 = ($$022|0)==(0|0); //@line 64448 "c/sqlite3.c"
    if ($18) {
     $$2 = 0;
     break L4;
    } else {
     $$02224 = $$022;
    }
   }
   (_sqlite3BtreeTripAllCursors($0,$14,0)|0); //@line 64453 "c/sqlite3.c"
   $$2 = $14;
  }
 } while(0);
 _sqlite3BtreeLeave($0); //@line 64464 "c/sqlite3.c"
 $$3 = $$2;
 return ($$3|0); //@line 64466 "c/sqlite3.c"
}
function _sqlite3PagerPagecount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 51870 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 51870 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 51870 "c/sqlite3.c"
 return; //@line 51871 "c/sqlite3.c"
}
function _sqlite3BtreeClearCursor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 56|0); //@line 61183 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 61183 "c/sqlite3.c"
 _sqlite3_free($2); //@line 61183 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 61184 "c/sqlite3.c"
 HEAP8[$0>>0] = 0; //@line 61185 "c/sqlite3.c"
 return; //@line 61186 "c/sqlite3.c"
}
function _sqlite3VdbeFrameRestore($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 75085 "c/sqlite3.c"
 _closeCursorsInFrame($1); //@line 75086 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 75090 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 75090 "c/sqlite3.c"
 $4 = ((($1)) + 88|0); //@line 75090 "c/sqlite3.c"
 HEAP32[$4>>2] = $3; //@line 75090 "c/sqlite3.c"
 $5 = ((($0)) + 52|0); //@line 75091 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 75091 "c/sqlite3.c"
 $7 = ((($1)) + 136|0); //@line 75091 "c/sqlite3.c"
 HEAP32[$7>>2] = $6; //@line 75091 "c/sqlite3.c"
 $8 = ((($0)) + 16|0); //@line 75092 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 75092 "c/sqlite3.c"
 $10 = ((($1)) + 92|0); //@line 75092 "c/sqlite3.c"
 HEAP32[$10>>2] = $9; //@line 75092 "c/sqlite3.c"
 $11 = ((($0)) + 56|0); //@line 75093 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 75093 "c/sqlite3.c"
 $13 = ((($1)) + 24|0); //@line 75093 "c/sqlite3.c"
 HEAP32[$13>>2] = $12; //@line 75093 "c/sqlite3.c"
 $14 = ((($0)) + 20|0); //@line 75094 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 75094 "c/sqlite3.c"
 $16 = ((($1)) + 112|0); //@line 75094 "c/sqlite3.c"
 HEAP32[$16>>2] = $15; //@line 75094 "c/sqlite3.c"
 $17 = ((($0)) + 44|0); //@line 75095 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 75095 "c/sqlite3.c"
 $19 = ((($1)) + 28|0); //@line 75095 "c/sqlite3.c"
 HEAP32[$19>>2] = $18; //@line 75095 "c/sqlite3.c"
 $20 = ((($0)) + 32|0); //@line 75096 "c/sqlite3.c"
 $21 = $20; //@line 75096 "c/sqlite3.c"
 $22 = $21; //@line 75096 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 75096 "c/sqlite3.c"
 $24 = (($21) + 4)|0; //@line 75096 "c/sqlite3.c"
 $25 = $24; //@line 75096 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 75096 "c/sqlite3.c"
 $27 = HEAP32[$1>>2]|0; //@line 75096 "c/sqlite3.c"
 $28 = ((($27)) + 32|0); //@line 75096 "c/sqlite3.c"
 $29 = $28; //@line 75096 "c/sqlite3.c"
 $30 = $29; //@line 75096 "c/sqlite3.c"
 HEAP32[$30>>2] = $23; //@line 75096 "c/sqlite3.c"
 $31 = (($29) + 4)|0; //@line 75096 "c/sqlite3.c"
 $32 = $31; //@line 75096 "c/sqlite3.c"
 HEAP32[$32>>2] = $26; //@line 75096 "c/sqlite3.c"
 $33 = ((($0)) + 68|0); //@line 75097 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 75097 "c/sqlite3.c"
 $35 = ((($1)) + 44|0); //@line 75097 "c/sqlite3.c"
 HEAP32[$35>>2] = $34; //@line 75097 "c/sqlite3.c"
 $36 = ((($0)) + 72|0); //@line 75098 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 75098 "c/sqlite3.c"
 $38 = ((($27)) + 92|0); //@line 75098 "c/sqlite3.c"
 HEAP32[$38>>2] = $37; //@line 75098 "c/sqlite3.c"
 $39 = ((($1)) + 212|0); //@line 75099 "c/sqlite3.c"
 _sqlite3VdbeDeleteAuxData($27,$39,-1,0); //@line 75099 "c/sqlite3.c"
 $40 = ((($0)) + 40|0); //@line 75100 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 75100 "c/sqlite3.c"
 HEAP32[$39>>2] = $41; //@line 75100 "c/sqlite3.c"
 HEAP32[$40>>2] = 0; //@line 75101 "c/sqlite3.c"
 $42 = ((($0)) + 48|0); //@line 75102 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 75102 "c/sqlite3.c"
 return ($43|0); //@line 75102 "c/sqlite3.c"
}
function _closeCursorsInFrame($0) {
 $0 = $0|0;
 var $$013 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 112|0); //@line 75067 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 75067 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 75067 "c/sqlite3.c"
 if ($3) {
  return; //@line 75077 "c/sqlite3.c"
 }
 $4 = ((($0)) + 28|0); //@line 75069 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 75069 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 75069 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 75077 "c/sqlite3.c"
 }
 $$013 = 0;
 while(1) {
  $7 = HEAP32[$1>>2]|0; //@line 75070 "c/sqlite3.c"
  $8 = (($7) + ($$013<<2)|0); //@line 75070 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 75070 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 75071 "c/sqlite3.c"
  if (!($10)) {
   _sqlite3VdbeFreeCursor($0,$9); //@line 75072 "c/sqlite3.c"
   $11 = HEAP32[$1>>2]|0; //@line 75073 "c/sqlite3.c"
   $12 = (($11) + ($$013<<2)|0); //@line 75073 "c/sqlite3.c"
   HEAP32[$12>>2] = 0; //@line 75073 "c/sqlite3.c"
  }
  $13 = (($$013) + 1)|0; //@line 75069 "c/sqlite3.c"
  $14 = HEAP32[$4>>2]|0; //@line 75069 "c/sqlite3.c"
  $15 = ($13|0)<($14|0); //@line 75069 "c/sqlite3.c"
  if ($15) {
   $$013 = $13;
  } else {
   break;
  }
 }
 return; //@line 75077 "c/sqlite3.c"
}
function _sqlite3VdbeFrameDelete($0) {
 $0 = $0|0;
 var $$019 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 80|0); //@line 74567 "c/sqlite3.c"
 $2 = ((($0)) + 60|0); //@line 74568 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 74568 "c/sqlite3.c"
 $4 = (($1) + (($3*40)|0)|0); //@line 74568 "c/sqlite3.c"
 $5 = ((($0)) + 64|0); //@line 74569 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 74569 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 74569 "c/sqlite3.c"
 if ($7) {
  $$019 = 0;
  while(1) {
   $8 = HEAP32[$0>>2]|0; //@line 74570 "c/sqlite3.c"
   $9 = (($4) + ($$019<<2)|0); //@line 74570 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 74570 "c/sqlite3.c"
   _sqlite3VdbeFreeCursor($8,$10); //@line 74570 "c/sqlite3.c"
   $11 = (($$019) + 1)|0; //@line 74569 "c/sqlite3.c"
   $12 = HEAP32[$5>>2]|0; //@line 74569 "c/sqlite3.c"
   $13 = ($11|0)<($12|0); //@line 74569 "c/sqlite3.c"
   if ($13) {
    $$019 = $11;
   } else {
    break;
   }
  }
 }
 $14 = HEAP32[$2>>2]|0; //@line 74572 "c/sqlite3.c"
 _releaseMemArray($1,$14); //@line 74572 "c/sqlite3.c"
 $15 = HEAP32[$0>>2]|0; //@line 74573 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 74573 "c/sqlite3.c"
 $17 = ((($0)) + 40|0); //@line 74573 "c/sqlite3.c"
 _sqlite3VdbeDeleteAuxData($16,$17,-1,0); //@line 74573 "c/sqlite3.c"
 $18 = HEAP32[$0>>2]|0; //@line 74574 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 74574 "c/sqlite3.c"
 _sqlite3DbFree($19,$0); //@line 74574 "c/sqlite3.c"
 return; //@line 74575 "c/sqlite3.c"
}
function _sqlite3VdbeDeleteAuxData($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$017 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$1>>2]|0; //@line 75960 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 75960 "c/sqlite3.c"
 if ($5) {
  return; //@line 75977 "c/sqlite3.c"
 }
 $6 = ($2|0)<(0);
 $$017 = $1;$8 = $4;
 while(1) {
  do {
   if ($6) {
    label = 8;
   } else {
    $7 = HEAP32[$8>>2]|0; //@line 75963 "c/sqlite3.c"
    $9 = ($7|0)==($2|0); //@line 75963 "c/sqlite3.c"
    if ($9) {
     $10 = ((($8)) + 4|0); //@line 75964 "c/sqlite3.c"
     $11 = HEAP32[$10>>2]|0; //@line 75964 "c/sqlite3.c"
     $12 = ($11|0)>(-1); //@line 75964 "c/sqlite3.c"
     if ($12) {
      $13 = ($11|0)>(31); //@line 75965 "c/sqlite3.c"
      if ($13) {
       label = 8;
       break;
      }
      $14 = 1 << $11; //@line 75965 "c/sqlite3.c"
      $15 = $14 & $3; //@line 75965 "c/sqlite3.c"
      $16 = ($15|0)==(0); //@line 75965 "c/sqlite3.c"
      if ($16) {
       label = 8;
       break;
      }
     }
    }
    $24 = ((($8)) + 16|0); //@line 75974 "c/sqlite3.c"
    $$1 = $24;
   }
  } while(0);
  if ((label|0) == 8) {
   label = 0;
   $17 = ((($8)) + 12|0); //@line 75968 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 75968 "c/sqlite3.c"
   $19 = ($18|0)==(0|0); //@line 75968 "c/sqlite3.c"
   if (!($19)) {
    $20 = ((($8)) + 8|0); //@line 75969 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 75969 "c/sqlite3.c"
    FUNCTION_TABLE_vi[$18 & 127]($21); //@line 75969 "c/sqlite3.c"
   }
   $22 = ((($8)) + 16|0); //@line 75971 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 75971 "c/sqlite3.c"
   HEAP32[$$017>>2] = $23; //@line 75971 "c/sqlite3.c"
   _sqlite3DbFree($0,$8); //@line 75972 "c/sqlite3.c"
   $$1 = $$017;
  }
  $25 = HEAP32[$$1>>2]|0; //@line 75960 "c/sqlite3.c"
  $26 = ($25|0)==(0|0); //@line 75960 "c/sqlite3.c"
  if ($26) {
   break;
  } else {
   $$017 = $$1;$8 = $25;
  }
 }
 return; //@line 75977 "c/sqlite3.c"
}
function _sqlite3VdbeFreeCursor($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 75030 "c/sqlite3.c"
 if ($2) {
  return; //@line 75061 "c/sqlite3.c"
 }
 $3 = HEAP8[$1>>0]|0; //@line 75034 "c/sqlite3.c"
 switch ($3<<24>>24) {
 case 1:  {
  $4 = HEAP32[$0>>2]|0; //@line 75036 "c/sqlite3.c"
  _sqlite3VdbeSorterClose($4,$1); //@line 75036 "c/sqlite3.c"
  return; //@line 75061 "c/sqlite3.c"
  break;
 }
 case 0:  {
  $5 = ((($1)) + 5|0); //@line 75040 "c/sqlite3.c"
  $6 = HEAP8[$5>>0]|0; //@line 75040 "c/sqlite3.c"
  $7 = $6 & 1; //@line 75040 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(0); //@line 75040 "c/sqlite3.c"
  if ($8) {
   $12 = ((($1)) + 40|0); //@line 75046 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 75046 "c/sqlite3.c"
   _sqlite3BtreeCloseCursor($13); //@line 75046 "c/sqlite3.c"
   return; //@line 75061 "c/sqlite3.c"
  }
  $9 = ((($1)) + 8|0); //@line 75041 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 75041 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 75041 "c/sqlite3.c"
  if ($11) {
   return; //@line 75061 "c/sqlite3.c"
  }
  _sqlite3BtreeClose($10); //@line 75041 "c/sqlite3.c"
  return; //@line 75061 "c/sqlite3.c"
  break;
 }
 case 2:  {
  $14 = ((($1)) + 40|0); //@line 75052 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 75052 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 75053 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 75053 "c/sqlite3.c"
  $18 = ((($16)) + 4|0); //@line 75055 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 75055 "c/sqlite3.c"
  $20 = (($19) + -1)|0; //@line 75055 "c/sqlite3.c"
  HEAP32[$18>>2] = $20; //@line 75055 "c/sqlite3.c"
  $21 = ((($17)) + 28|0); //@line 75056 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 75056 "c/sqlite3.c"
  (FUNCTION_TABLE_ii[$22 & 255]($15)|0); //@line 75056 "c/sqlite3.c"
  return; //@line 75061 "c/sqlite3.c"
  break;
 }
 default: {
  return; //@line 75061 "c/sqlite3.c"
 }
 }
}
function _sqlite3VdbeSorterClose($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 40|0); //@line 89060 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 89060 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 89061 "c/sqlite3.c"
 if ($4) {
  return; //@line 89067 "c/sqlite3.c"
 }
 _sqlite3VdbeSorterReset($0,$3); //@line 89062 "c/sqlite3.c"
 $5 = ((($3)) + 40|0); //@line 89063 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89063 "c/sqlite3.c"
 _sqlite3_free($6); //@line 89063 "c/sqlite3.c"
 _sqlite3DbFree($0,$3); //@line 89064 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 89065 "c/sqlite3.c"
 return; //@line 89067 "c/sqlite3.c"
}
function _sqlite3BtreeClose($0) {
 $0 = $0|0;
 var $$01 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 63035 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63035 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63040 "c/sqlite3.c"
 $3 = ((($2)) + 8|0); //@line 63041 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63041 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 63042 "c/sqlite3.c"
 if (!($5)) {
  $$01 = $4;
  while(1) {
   $6 = ((($$01)) + 16|0); //@line 63044 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 63044 "c/sqlite3.c"
   $8 = ((($$01)) + 8|0); //@line 63045 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 63045 "c/sqlite3.c"
   $10 = ($9|0)==($0|0); //@line 63045 "c/sqlite3.c"
   if ($10) {
    _sqlite3BtreeCloseCursor($$01); //@line 63046 "c/sqlite3.c"
   }
   $11 = ($7|0)==(0|0); //@line 63042 "c/sqlite3.c"
   if ($11) {
    break;
   } else {
    $$01 = $7;
   }
  }
 }
 _sqlite3BtreeRollback($0,0,0); //@line 63054 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63055 "c/sqlite3.c"
 $12 = ((($0)) + 9|0); //@line 63062 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 63062 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 63062 "c/sqlite3.c"
 if ($14) {
  label = 8;
 } else {
  $15 = (_removeFromSharingList($2)|0); //@line 63062 "c/sqlite3.c"
  $16 = ($15|0)==(0); //@line 63062 "c/sqlite3.c"
  if (!($16)) {
   label = 8;
  }
 }
 if ((label|0) == 8) {
  $17 = HEAP32[$2>>2]|0; //@line 63069 "c/sqlite3.c"
  $18 = HEAP32[$0>>2]|0; //@line 63069 "c/sqlite3.c"
  _sqlite3PagerClose($17,$18); //@line 63069 "c/sqlite3.c"
  $19 = ((($2)) + 52|0); //@line 63070 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 63070 "c/sqlite3.c"
  $21 = ($20|0)==(0|0); //@line 63070 "c/sqlite3.c"
  if (!($21)) {
   $22 = ((($2)) + 48|0); //@line 63070 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 63070 "c/sqlite3.c"
   $24 = ($23|0)==(0|0); //@line 63070 "c/sqlite3.c"
   if (!($24)) {
    FUNCTION_TABLE_vi[$20 & 127]($23); //@line 63071 "c/sqlite3.c"
   }
  }
  $25 = ((($2)) + 48|0); //@line 63073 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 63073 "c/sqlite3.c"
  _sqlite3DbFree(0,$26); //@line 63073 "c/sqlite3.c"
  _freeTempSpace($2); //@line 63074 "c/sqlite3.c"
  _sqlite3_free($2); //@line 63075 "c/sqlite3.c"
 }
 $27 = ((($0)) + 28|0); //@line 63081 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 63081 "c/sqlite3.c"
 $29 = ($28|0)==(0|0); //@line 63081 "c/sqlite3.c"
 if (!($29)) {
  $30 = ((($0)) + 24|0); //@line 63081 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 63081 "c/sqlite3.c"
  $32 = ((($28)) + 24|0); //@line 63081 "c/sqlite3.c"
  HEAP32[$32>>2] = $31; //@line 63081 "c/sqlite3.c"
 }
 $33 = ((($0)) + 24|0); //@line 63082 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 63082 "c/sqlite3.c"
 $35 = ($34|0)==(0|0); //@line 63082 "c/sqlite3.c"
 if ($35) {
  _sqlite3_free($0); //@line 63085 "c/sqlite3.c"
  return;
 }
 $36 = HEAP32[$27>>2]|0; //@line 63082 "c/sqlite3.c"
 $37 = ((($34)) + 28|0); //@line 63082 "c/sqlite3.c"
 HEAP32[$37>>2] = $36; //@line 63082 "c/sqlite3.c"
 _sqlite3_free($0); //@line 63085 "c/sqlite3.c"
 return;
}
function _sqlite3BtreeCloseCursor($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 64759 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 64759 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 64760 "c/sqlite3.c"
 if ($3) {
  return;
 }
 $4 = ((($0)) + 12|0); //@line 64761 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 64761 "c/sqlite3.c"
 _sqlite3BtreeEnter($2); //@line 64762 "c/sqlite3.c"
 $6 = ((($5)) + 8|0); //@line 64764 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 64764 "c/sqlite3.c"
 $8 = ($7|0)==($0|0); //@line 64764 "c/sqlite3.c"
 L4: do {
  if ($8) {
   $9 = ((($0)) + 16|0); //@line 64765 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 64765 "c/sqlite3.c"
   HEAP32[$6>>2] = $10; //@line 64765 "c/sqlite3.c"
  } else {
   $$0 = $7;
   while(1) {
    $11 = ((($$0)) + 16|0); //@line 64769 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 64769 "c/sqlite3.c"
    $13 = ($12|0)==($0|0); //@line 64769 "c/sqlite3.c"
    if ($13) {
     break;
    }
    $17 = ($12|0)==(0|0); //@line 64774 "c/sqlite3.c"
    if ($17) {
     break L4;
    } else {
     $$0 = $12;
    }
   }
   $14 = ((($$0)) + 16|0); //@line 64769 "c/sqlite3.c"
   $15 = ((($0)) + 16|0); //@line 64770 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 64770 "c/sqlite3.c"
   HEAP32[$14>>2] = $16; //@line 64770 "c/sqlite3.c"
  }
 } while(0);
 _btreeReleaseAllCursorPages($0); //@line 64776 "c/sqlite3.c"
 _unlockBtreeIfUnused($5); //@line 64777 "c/sqlite3.c"
 $18 = ((($0)) + 20|0); //@line 64778 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 64778 "c/sqlite3.c"
 _sqlite3_free($19); //@line 64778 "c/sqlite3.c"
 $20 = ((($0)) + 56|0); //@line 64779 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 64779 "c/sqlite3.c"
 _sqlite3_free($21); //@line 64779 "c/sqlite3.c"
 _sqlite3BtreeLeave($2); //@line 64780 "c/sqlite3.c"
 return;
}
function _removeFromSharingList($0) {
 $0 = $0|0;
 var $$0 = 0, $$01820 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3MutexAlloc(2)|0); //@line 62962 "c/sqlite3.c"
 _sqlite3_mutex_enter($1); //@line 62963 "c/sqlite3.c"
 $2 = ((($0)) + 64|0); //@line 62964 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 62964 "c/sqlite3.c"
 $4 = (($3) + -1)|0; //@line 62964 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 62964 "c/sqlite3.c"
 $5 = ($3|0)<(2); //@line 62965 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  _sqlite3_mutex_leave($1); //@line 62982 "c/sqlite3.c"
  return ($$0|0); //@line 62983 "c/sqlite3.c"
 }
 $6 = HEAP32[10106]|0; //@line 62966 "c/sqlite3.c"
 $7 = ($6|0)==($0|0); //@line 62966 "c/sqlite3.c"
 L4: do {
  if ($7) {
   $8 = ((($0)) + 68|0); //@line 62967 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 62967 "c/sqlite3.c"
   HEAP32[10106] = $9; //@line 62967 "c/sqlite3.c"
  } else {
   $10 = ($6|0)==(0|0); //@line 62970 "c/sqlite3.c"
   if (!($10)) {
    $$01820 = $6;
    while(1) {
     $13 = ((($$01820)) + 68|0); //@line 62970 "c/sqlite3.c"
     $12 = HEAP32[$13>>2]|0; //@line 62970 "c/sqlite3.c"
     $14 = ($12|0)==($0|0); //@line 62970 "c/sqlite3.c"
     if ($14) {
      break;
     }
     $11 = ($12|0)==(0|0); //@line 62970 "c/sqlite3.c"
     if ($11) {
      break L4;
     } else {
      $$01820 = $12;
     }
    }
    $15 = ((($$01820)) + 68|0); //@line 62970 "c/sqlite3.c"
    $16 = ((($0)) + 68|0); //@line 62974 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 62974 "c/sqlite3.c"
    HEAP32[$15>>2] = $17; //@line 62974 "c/sqlite3.c"
   }
  }
 } while(0);
 $18 = ((($0)) + 56|0); //@line 62978 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 62978 "c/sqlite3.c"
 _sqlite3_mutex_free($19); //@line 62978 "c/sqlite3.c"
 $$0 = 1;
 _sqlite3_mutex_leave($1); //@line 62982 "c/sqlite3.c"
 return ($$0|0); //@line 62983 "c/sqlite3.c"
}
function _sqlite3PagerClose($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 204|0); //@line 52087 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 52087 "c/sqlite3.c"
 _sqlite3BeginBenignMalloc(); //@line 52092 "c/sqlite3.c"
 _pagerFreeMapHdrs($0); //@line 52093 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 52095 "c/sqlite3.c"
 HEAP8[$4>>0] = 0; //@line 52095 "c/sqlite3.c"
 $5 = ((($0)) + 212|0); //@line 52098 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 52098 "c/sqlite3.c"
 $7 = ((($0)) + 11|0); //@line 52098 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 52098 "c/sqlite3.c"
 $9 = $8&255; //@line 52098 "c/sqlite3.c"
 $10 = ((($0)) + 152|0); //@line 52098 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 52098 "c/sqlite3.c"
 $12 = ($1|0)==(0|0); //@line 52099 "c/sqlite3.c"
 if ($12) {
  label = 3;
 } else {
  $13 = ((($1)) + 28|0); //@line 52099 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 52099 "c/sqlite3.c"
  $15 = $14 & 2048; //@line 52099 "c/sqlite3.c"
  $16 = ($15|0)==(0); //@line 52099 "c/sqlite3.c"
  if ($16) {
   label = 3;
  } else {
   $17 = 0;
  }
 }
 if ((label|0) == 3) {
  $17 = $3;
 }
 (_sqlite3WalClose($6,$1,$9,$11,$17)|0); //@line 52098 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 52101 "c/sqlite3.c"
 _pager_reset($0); //@line 52103 "c/sqlite3.c"
 $18 = ((($0)) + 15|0); //@line 52104 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 52104 "c/sqlite3.c"
 $20 = ($19<<24>>24)==(0); //@line 52104 "c/sqlite3.c"
 if ($20) {
  $21 = ((($0)) + 64|0); //@line 52118 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 52118 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 52118 "c/sqlite3.c"
  $24 = ($23|0)==(0|0); //@line 52118 "c/sqlite3.c"
  if (!($24)) {
   $25 = (_pagerSyncHotJournal($0)|0); //@line 52119 "c/sqlite3.c"
   (_pager_error($0,$25)|0); //@line 52119 "c/sqlite3.c"
  }
  _pagerUnlockAndRollback($0); //@line 52121 "c/sqlite3.c"
 } else {
  _pager_unlock($0); //@line 52105 "c/sqlite3.c"
 }
 _sqlite3EndBenignMalloc(); //@line 52123 "c/sqlite3.c"
 $26 = ((($0)) + 64|0); //@line 52127 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 52127 "c/sqlite3.c"
 _sqlite3OsClose($27); //@line 52127 "c/sqlite3.c"
 $28 = ((($0)) + 60|0); //@line 52128 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 52128 "c/sqlite3.c"
 _sqlite3OsClose($29); //@line 52128 "c/sqlite3.c"
 _sqlite3PageFree($3); //@line 52129 "c/sqlite3.c"
 $30 = ((($0)) + 208|0); //@line 52130 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 52130 "c/sqlite3.c"
 _sqlite3PcacheClose($31); //@line 52130 "c/sqlite3.c"
 _sqlite3_free($0); //@line 52139 "c/sqlite3.c"
 return;
}
function _freeTempSpace($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 80|0); //@line 63024 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63024 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 63024 "c/sqlite3.c"
 if ($3) {
  return; //@line 63029 "c/sqlite3.c"
 }
 $4 = ((($2)) + -4|0); //@line 63025 "c/sqlite3.c"
 HEAP32[$1>>2] = $4; //@line 63025 "c/sqlite3.c"
 _sqlite3PageFree($4); //@line 63026 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 63027 "c/sqlite3.c"
 return; //@line 63029 "c/sqlite3.c"
}
function _pagerFreeMapHdrs($0) {
 $0 = $0|0;
 var $$in89 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 136|0); //@line 52065 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 52065 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 52065 "c/sqlite3.c"
 if ($3) {
  return; //@line 52069 "c/sqlite3.c"
 }
 $$in89 = $2;
 while(1) {
  $4 = ((($$in89)) + 16|0); //@line 52066 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 52066 "c/sqlite3.c"
  _sqlite3_free($$in89); //@line 52067 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 52065 "c/sqlite3.c"
  if ($6) {
   break;
  } else {
   $$in89 = $5;
  }
 }
 return; //@line 52069 "c/sqlite3.c"
}
function _sqlite3WalClose($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$025 = 0, $$1 = 0, $$126 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = ($0|0)==(0|0); //@line 57563 "c/sqlite3.c"
 if ($6) {
  $$126 = 0;
  STACKTOP = sp;return ($$126|0); //@line 57616 "c/sqlite3.c"
 }
 $7 = ($4|0)==(0|0); //@line 57574 "c/sqlite3.c"
 if ($7) {
  $$025 = 0;$$1 = 0;
 } else {
  $8 = ((($0)) + 4|0); //@line 57575 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 57575 "c/sqlite3.c"
  $10 = (_sqlite3OsLock($9,4)|0); //@line 57575 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 57575 "c/sqlite3.c"
  if ($11) {
   $12 = ((($0)) + 43|0); //@line 57577 "c/sqlite3.c"
   $13 = HEAP8[$12>>0]|0; //@line 57577 "c/sqlite3.c"
   $14 = ($13<<24>>24)==(0); //@line 57577 "c/sqlite3.c"
   if ($14) {
    HEAP8[$12>>0] = 1; //@line 57578 "c/sqlite3.c"
   }
   $15 = (_sqlite3WalCheckpoint($0,$1,0,0,0,$2,$3,$4,0,0)|0); //@line 57580 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 57583 "c/sqlite3.c"
   if ($16) {
    HEAP32[$5>>2] = -1; //@line 57584 "c/sqlite3.c"
    $17 = HEAP32[$8>>2]|0; //@line 57586 "c/sqlite3.c"
    _sqlite3OsFileControlHint($17,10,$5); //@line 57585 "c/sqlite3.c"
    $18 = HEAP32[$5>>2]|0; //@line 57588 "c/sqlite3.c"
    $19 = ($18|0)==(1); //@line 57588 "c/sqlite3.c"
    if ($19) {
     $20 = ((($0)) + 16|0); //@line 57593 "c/sqlite3.c"
     $21 = $20; //@line 57593 "c/sqlite3.c"
     $22 = $21; //@line 57593 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 57593 "c/sqlite3.c"
     $24 = (($21) + 4)|0; //@line 57593 "c/sqlite3.c"
     $25 = $24; //@line 57593 "c/sqlite3.c"
     $26 = HEAP32[$25>>2]|0; //@line 57593 "c/sqlite3.c"
     $27 = ($26|0)>(-1); //@line 57593 "c/sqlite3.c"
     $28 = ($23>>>0)>(4294967295); //@line 57593 "c/sqlite3.c"
     $29 = ($26|0)==(-1); //@line 57593 "c/sqlite3.c"
     $30 = $29 & $28; //@line 57593 "c/sqlite3.c"
     $31 = $27 | $30; //@line 57593 "c/sqlite3.c"
     if ($31) {
      _walLimitSize($0,0,0); //@line 57600 "c/sqlite3.c"
      $$0 = 0;
     } else {
      $$0 = 0;
     }
    } else {
     $$0 = 1;
    }
    $$025 = 0;$$1 = $$0;
   } else {
    $$025 = $15;$$1 = 0;
   }
  } else {
   $$025 = $10;$$1 = 0;
  }
 }
 _walIndexClose($0,$$1); //@line 57605 "c/sqlite3.c"
 $32 = ((($0)) + 8|0); //@line 57606 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 57606 "c/sqlite3.c"
 _sqlite3OsClose($33); //@line 57606 "c/sqlite3.c"
 $34 = ($$1|0)==(0); //@line 57607 "c/sqlite3.c"
 if (!($34)) {
  _sqlite3BeginBenignMalloc(); //@line 57608 "c/sqlite3.c"
  $35 = HEAP32[$0>>2]|0; //@line 57609 "c/sqlite3.c"
  $36 = ((($0)) + 108|0); //@line 57609 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 57609 "c/sqlite3.c"
  (_sqlite3OsDelete($35,$37,0)|0); //@line 57609 "c/sqlite3.c"
  _sqlite3EndBenignMalloc(); //@line 57610 "c/sqlite3.c"
 }
 $38 = ((($0)) + 32|0); //@line 57613 "c/sqlite3.c"
 $39 = HEAP32[$38>>2]|0; //@line 57613 "c/sqlite3.c"
 _sqlite3_free($39); //@line 57613 "c/sqlite3.c"
 _sqlite3_free($0); //@line 57614 "c/sqlite3.c"
 $$126 = $$025;
 STACKTOP = sp;return ($$126|0); //@line 57616 "c/sqlite3.c"
}
function _pagerSyncHotJournal($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 7|0); //@line 51985 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 51985 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 51985 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 64|0); //@line 51986 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 51986 "c/sqlite3.c"
  $6 = (_sqlite3OsSync($5,2)|0); //@line 51986 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 51988 "c/sqlite3.c"
  if (!($7)) {
   $$1 = $6;
   return ($$1|0); //@line 51991 "c/sqlite3.c"
  }
 }
 $8 = ((($0)) + 64|0); //@line 51989 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 51989 "c/sqlite3.c"
 $10 = ((($0)) + 80|0); //@line 51989 "c/sqlite3.c"
 $11 = (_sqlite3OsFileSize($9,$10)|0); //@line 51989 "c/sqlite3.c"
 $$1 = $11;
 return ($$1|0); //@line 51991 "c/sqlite3.c"
}
function _sqlite3PcacheClose($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(164)>>2]|0; //@line 45854 "c/sqlite3.c"
 $2 = ((($0)) + 44|0); //@line 45854 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 45854 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$1 & 127]($3); //@line 45854 "c/sqlite3.c"
 return; //@line 45855 "c/sqlite3.c"
}
function _sqlite3WalCheckpoint($0,$1,$2,$3,$4,$5,$6,$7,$8,$9) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 $9 = $9|0;
 var $$05154 = 0, $$05155 = 0, $$053 = 0, $$058 = 0, $$059 = 0, $$1 = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $or$cond = 0, dest = 0;
 var label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $10 = sp;
 HEAP32[$10>>2] = 0; //@line 59136 "c/sqlite3.c"
 $11 = ((($0)) + 46|0); //@line 59147 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 59147 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 59147 "c/sqlite3.c"
 if (!($13)) {
  $$053 = 8;
  STACKTOP = sp;return ($$053|0); //@line 59226 "c/sqlite3.c"
 }
 $14 = (_walLockExclusive($0,1,1)|0); //@line 59152 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 59153 "c/sqlite3.c"
 if (!($15)) {
  $$053 = $14;
  STACKTOP = sp;return ($$053|0); //@line 59226 "c/sqlite3.c"
 }
 $16 = ((($0)) + 45|0); //@line 59164 "c/sqlite3.c"
 HEAP8[$16>>0] = 1; //@line 59164 "c/sqlite3.c"
 $17 = ($2|0)==(0); //@line 59175 "c/sqlite3.c"
 L7: do {
  if ($17) {
   $$05155 = 0;$$059 = $3;
   label = 6;
  } else {
   $18 = (_walBusyLock($0,$3,$4,0,1)|0); //@line 59176 "c/sqlite3.c"
   switch ($18|0) {
   case 5:  {
    $$05155 = 0;$$059 = 0;
    label = 6;
    break L7;
    break;
   }
   case 0:  {
    break;
   }
   default: {
    $$05154 = $2;$$058 = $3;$$1 = $18;
    break L7;
   }
   }
   $19 = ((($0)) + 44|0); //@line 59178 "c/sqlite3.c"
   HEAP8[$19>>0] = 1; //@line 59178 "c/sqlite3.c"
   $$05155 = $2;$$059 = $3;
   label = 6;
  }
 } while(0);
 if ((label|0) == 6) {
  $20 = (_walIndexReadHdr($0,$10)|0); //@line 59188 "c/sqlite3.c"
  $$05154 = $$05155;$$058 = $$059;$$1 = $20;
 }
 $21 = ($$1|0)==(0); //@line 59195 "c/sqlite3.c"
 L13: do {
  if ($21) {
   $22 = ((($0)) + 68|0); //@line 59197 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 59197 "c/sqlite3.c"
   $24 = ($23|0)==(0); //@line 59197 "c/sqlite3.c"
   if ($24) {
    label = 11;
   } else {
    $25 = (_walPagesize($0)|0); //@line 59197 "c/sqlite3.c"
    $26 = ($25|0)==($6|0); //@line 59197 "c/sqlite3.c"
    if ($26) {
     label = 11;
    } else {
     $27 = (_sqlite3CorruptError(59198)|0); //@line 59198 "c/sqlite3.c"
     $$2 = $27;
    }
   }
   if ((label|0) == 11) {
    $28 = (_walCheckpoint($0,$1,$$05154,$$058,$4,$5,$7)|0); //@line 59200 "c/sqlite3.c"
    $$2 = $28;
   }
   switch ($$2|0) {
   case 0: case 5:  {
    break;
   }
   default: {
    $$3 = $$2;
    break L13;
   }
   }
   $29 = ($8|0)==(0|0); //@line 59205 "c/sqlite3.c"
   if (!($29)) {
    $30 = HEAP32[$22>>2]|0; //@line 59205 "c/sqlite3.c"
    HEAP32[$8>>2] = $30; //@line 59205 "c/sqlite3.c"
   }
   $31 = ($9|0)==(0|0); //@line 59206 "c/sqlite3.c"
   if ($31) {
    $$3 = $$2;
   } else {
    $32 = (_walCkptInfo($0)|0); //@line 59206 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 59206 "c/sqlite3.c"
    HEAP32[$9>>2] = $33; //@line 59206 "c/sqlite3.c"
    $$3 = $$2;
   }
  } else {
   $$3 = $$1;
  }
 } while(0);
 $34 = HEAP32[$10>>2]|0; //@line 59210 "c/sqlite3.c"
 $35 = ($34|0)==(0); //@line 59210 "c/sqlite3.c"
 if (!($35)) {
  $36 = ((($0)) + 52|0); //@line 59217 "c/sqlite3.c"
  dest=$36; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 59217 "c/sqlite3.c"
 }
 _sqlite3WalEndWriteTransaction($0); //@line 59221 "c/sqlite3.c"
 _walUnlockExclusive($0,1,1); //@line 59222 "c/sqlite3.c"
 HEAP8[$16>>0] = 0; //@line 59223 "c/sqlite3.c"
 $37 = ($$3|0)!=(0); //@line 59225 "c/sqlite3.c"
 $38 = ($$05154|0)==($2|0); //@line 59225 "c/sqlite3.c"
 $or$cond = $38 | $37; //@line 59225 "c/sqlite3.c"
 $39 = $or$cond ? $$3 : 5; //@line 59225 "c/sqlite3.c"
 $$053 = $39;
 STACKTOP = sp;return ($$053|0); //@line 59226 "c/sqlite3.c"
}
function _walBusyLock($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)!=(0|0);
 while(1) {
  $6 = (_walLockExclusive($0,$3,$4)|0); //@line 57277 "c/sqlite3.c"
  $7 = ($6|0)==(5); //@line 57278 "c/sqlite3.c"
  $or$cond = $5 & $7; //@line 57278 "c/sqlite3.c"
  if (!($or$cond)) {
   label = 4;
   break;
  }
  $8 = (FUNCTION_TABLE_ii[$1 & 255]($2)|0); //@line 57278 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 57278 "c/sqlite3.c"
  if ($9) {
   label = 4;
   break;
  }
 }
 if ((label|0) == 4) {
  return ($6|0); //@line 57279 "c/sqlite3.c"
 }
 return (0)|0;
}
function _walPagesize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 66|0); //@line 57287 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 57287 "c/sqlite3.c"
 $3 = $2&65535; //@line 57287 "c/sqlite3.c"
 $4 = $3 & 65024; //@line 57287 "c/sqlite3.c"
 $5 = $3 << 16; //@line 57287 "c/sqlite3.c"
 $6 = $5 & 65536; //@line 57287 "c/sqlite3.c"
 $7 = $6 | $4; //@line 57287 "c/sqlite3.c"
 return ($7|0); //@line 57287 "c/sqlite3.c"
}
function _walCheckpoint($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0 = 0, $$1 = 0, $$1$1 = 0, $$1$2 = 0, $$1$3 = 0, $$10 = 0, $$11 = 0, $$1115 = 0, $$1115$1 = 0, $$1115$2 = 0, $$1115$3 = 0, $$1121 = 0, $$1121$1 = 0, $$1121$2 = 0, $$1121$3 = 0, $$12 = 0, $$13 = 0, $$14 = 0, $$3 = 0, $$5149 = 0;
 var $$9 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0;
 var $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0;
 var $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $or$cond = 0, $or$cond124 = 0, $or$cond126 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $7 = sp + 24|0;
 $8 = sp + 20|0;
 $9 = sp + 16|0;
 $10 = sp + 8|0;
 $11 = sp;
 HEAP32[$7>>2] = 0; //@line 57365 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 57366 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 57367 "c/sqlite3.c"
 $12 = (_walPagesize($0)|0); //@line 57373 "c/sqlite3.c"
 $13 = (_walCkptInfo($0)|0); //@line 57376 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 57377 "c/sqlite3.c"
 $15 = ((($0)) + 68|0); //@line 57377 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 57377 "c/sqlite3.c"
 $17 = ($14>>>0)<($16>>>0); //@line 57377 "c/sqlite3.c"
 L1: do {
  if ($17) {
   $18 = (_walIteratorInit($0,$7)|0); //@line 57380 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 57381 "c/sqlite3.c"
   if (!($19)) {
    $$0 = $18;
    STACKTOP = sp;return ($$0|0); //@line 57532 "c/sqlite3.c"
   }
   $20 = HEAP32[$15>>2]|0; //@line 57395 "c/sqlite3.c"
   $21 = ((($0)) + 72|0); //@line 57396 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 57396 "c/sqlite3.c"
   $23 = ((($13)) + 8|0); //@line 57406 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 57406 "c/sqlite3.c"
   $25 = ($20>>>0)>($24>>>0); //@line 57407 "c/sqlite3.c"
   L6: do {
    if ($25) {
     $26 = (_walBusyLock($0,$3,$4,4,1)|0); //@line 57409 "c/sqlite3.c"
     switch ($26|0) {
     case 5:  {
      $$1 = 0;$$1115 = $26;$$1121 = $24;
      break L6;
      break;
     }
     case 0:  {
      break;
     }
     default: {
      $$14 = $26;
      break L1;
     }
     }
     HEAP32[$23>>2] = $20; //@line 57411 "c/sqlite3.c"
     _walUnlockExclusive($0,4,1); //@line 57412 "c/sqlite3.c"
     $$1 = $3;$$1115 = 0;$$1121 = $20;
    } else {
     $$1 = $3;$$1115 = 0;$$1121 = $20;
    }
   } while(0);
   $27 = ((($13)) + 12|0); //@line 57406 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 57406 "c/sqlite3.c"
   $29 = ($$1121>>>0)>($28>>>0); //@line 57407 "c/sqlite3.c"
   L10: do {
    if ($29) {
     $137 = (_walBusyLock($0,$$1,$4,5,1)|0); //@line 57409 "c/sqlite3.c"
     switch ($137|0) {
     case 5:  {
      $$1$1 = 0;$$1115$1 = $137;$$1121$1 = $28;
      break L10;
      break;
     }
     case 0:  {
      break;
     }
     default: {
      $$14 = $137;
      break L1;
     }
     }
     HEAP32[$27>>2] = -1; //@line 57411 "c/sqlite3.c"
     _walUnlockExclusive($0,5,1); //@line 57412 "c/sqlite3.c"
     $$1$1 = $$1;$$1115$1 = 0;$$1121$1 = $$1121;
    } else {
     $$1$1 = $$1;$$1115$1 = $$1115;$$1121$1 = $$1121;
    }
   } while(0);
   $138 = ((($13)) + 16|0); //@line 57406 "c/sqlite3.c"
   $139 = HEAP32[$138>>2]|0; //@line 57406 "c/sqlite3.c"
   $140 = ($$1121$1>>>0)>($139>>>0); //@line 57407 "c/sqlite3.c"
   L14: do {
    if ($140) {
     $141 = (_walBusyLock($0,$$1$1,$4,6,1)|0); //@line 57409 "c/sqlite3.c"
     switch ($141|0) {
     case 5:  {
      $$1$2 = 0;$$1115$2 = $141;$$1121$2 = $139;
      break L14;
      break;
     }
     case 0:  {
      break;
     }
     default: {
      $$14 = $141;
      break L1;
     }
     }
     HEAP32[$138>>2] = -1; //@line 57411 "c/sqlite3.c"
     _walUnlockExclusive($0,6,1); //@line 57412 "c/sqlite3.c"
     $$1$2 = $$1$1;$$1115$2 = 0;$$1121$2 = $$1121$1;
    } else {
     $$1$2 = $$1$1;$$1115$2 = $$1115$1;$$1121$2 = $$1121$1;
    }
   } while(0);
   $142 = ((($13)) + 20|0); //@line 57406 "c/sqlite3.c"
   $143 = HEAP32[$142>>2]|0; //@line 57406 "c/sqlite3.c"
   $144 = ($$1121$2>>>0)>($143>>>0); //@line 57407 "c/sqlite3.c"
   L18: do {
    if ($144) {
     $145 = (_walBusyLock($0,$$1$2,$4,7,1)|0); //@line 57409 "c/sqlite3.c"
     switch ($145|0) {
     case 5:  {
      $$1$3 = 0;$$1115$3 = $145;$$1121$3 = $143;
      break L18;
      break;
     }
     case 0:  {
      break;
     }
     default: {
      $$14 = $145;
      break L1;
     }
     }
     HEAP32[$142>>2] = -1; //@line 57411 "c/sqlite3.c"
     _walUnlockExclusive($0,7,1); //@line 57412 "c/sqlite3.c"
     $$1$3 = $$1$2;$$1115$3 = 0;$$1121$3 = $$1121$2;
    } else {
     $$1$3 = $$1$2;$$1115$3 = $$1115$2;$$1121$3 = $$1121$2;
    }
   } while(0);
   $146 = HEAP32[$13>>2]|0; //@line 57422 "c/sqlite3.c"
   $147 = ($146>>>0)<($$1121$3>>>0); //@line 57422 "c/sqlite3.c"
   if ($147) {
    $30 = (_walBusyLock($0,$$1$3,$4,3,1)|0); //@line 57423 "c/sqlite3.c"
    $31 = ($30|0)==(0); //@line 57423 "c/sqlite3.c"
    if ($31) {
     $32 = HEAP32[$13>>2]|0; //@line 57426 "c/sqlite3.c"
     $33 = ((($13)) + 32|0); //@line 57428 "c/sqlite3.c"
     HEAP32[$33>>2] = $$1121$3; //@line 57428 "c/sqlite3.c"
     $34 = ((($0)) + 8|0); //@line 57431 "c/sqlite3.c"
     $35 = HEAP32[$34>>2]|0; //@line 57431 "c/sqlite3.c"
     $36 = $5 >>> 2; //@line 57431 "c/sqlite3.c"
     $37 = $36 & 3; //@line 57431 "c/sqlite3.c"
     $38 = (_sqlite3OsSync($35,$37)|0); //@line 57431 "c/sqlite3.c"
     $39 = ($38|0)==(0); //@line 57436 "c/sqlite3.c"
     L25: do {
      if ($39) {
       $40 = ($12|0)<(0); //@line 57437 "c/sqlite3.c"
       $41 = $40 << 31 >> 31; //@line 57437 "c/sqlite3.c"
       $42 = (___muldi3(($22|0),0,($12|0),($41|0))|0); //@line 57437 "c/sqlite3.c"
       $43 = tempRet0; //@line 57437 "c/sqlite3.c"
       $44 = $11; //@line 57437 "c/sqlite3.c"
       $45 = $44; //@line 57437 "c/sqlite3.c"
       HEAP32[$45>>2] = $42; //@line 57437 "c/sqlite3.c"
       $46 = (($44) + 4)|0; //@line 57437 "c/sqlite3.c"
       $47 = $46; //@line 57437 "c/sqlite3.c"
       HEAP32[$47>>2] = $43; //@line 57437 "c/sqlite3.c"
       $48 = ((($0)) + 4|0); //@line 57438 "c/sqlite3.c"
       $49 = HEAP32[$48>>2]|0; //@line 57438 "c/sqlite3.c"
       $50 = (_sqlite3OsFileSize($49,$10)|0); //@line 57438 "c/sqlite3.c"
       $51 = ($50|0)==(0); //@line 57439 "c/sqlite3.c"
       if (!($51)) {
        $$9 = $50;
        break;
       }
       $52 = $10; //@line 57439 "c/sqlite3.c"
       $53 = $52; //@line 57439 "c/sqlite3.c"
       $54 = HEAP32[$53>>2]|0; //@line 57439 "c/sqlite3.c"
       $55 = (($52) + 4)|0; //@line 57439 "c/sqlite3.c"
       $56 = $55; //@line 57439 "c/sqlite3.c"
       $57 = HEAP32[$56>>2]|0; //@line 57439 "c/sqlite3.c"
       $58 = $11; //@line 57439 "c/sqlite3.c"
       $59 = $58; //@line 57439 "c/sqlite3.c"
       $60 = HEAP32[$59>>2]|0; //@line 57439 "c/sqlite3.c"
       $61 = (($58) + 4)|0; //@line 57439 "c/sqlite3.c"
       $62 = $61; //@line 57439 "c/sqlite3.c"
       $63 = HEAP32[$62>>2]|0; //@line 57439 "c/sqlite3.c"
       $64 = ($57|0)<($63|0); //@line 57439 "c/sqlite3.c"
       $65 = ($54>>>0)<($60>>>0); //@line 57439 "c/sqlite3.c"
       $66 = ($57|0)==($63|0); //@line 57439 "c/sqlite3.c"
       $67 = $66 & $65; //@line 57439 "c/sqlite3.c"
       $68 = $64 | $67; //@line 57439 "c/sqlite3.c"
       if ($68) {
        $69 = HEAP32[$48>>2]|0; //@line 57440 "c/sqlite3.c"
        _sqlite3OsFileControlHint($69,5,$11); //@line 57440 "c/sqlite3.c"
       }
       $70 = HEAP32[$7>>2]|0;
       $71 = ((($1)) + 256|0);
       $72 = (($12) + 24)|0;
       $73 = ($72|0)<(0);
       $74 = $73 << 31 >> 31;
       $75 = ((($0)) + 4|0);
       $76 = ($12|0)<(0);
       $77 = $76 << 31 >> 31;
       while(1) {
        $78 = (_walIteratorNext($70,$8,$9)|0); //@line 57446 "c/sqlite3.c"
        $79 = ($78|0)==(0); //@line 57446 "c/sqlite3.c"
        if (!($79)) {
         break;
        }
        $80 = HEAP32[$71>>2]|0; //@line 57449 "c/sqlite3.c"
        $81 = ($80|0)==(0); //@line 57449 "c/sqlite3.c"
        if (!($81)) {
         label = 16;
         break;
        }
        $86 = HEAP32[$9>>2]|0; //@line 57453 "c/sqlite3.c"
        $87 = ($86>>>0)<=($32>>>0); //@line 57453 "c/sqlite3.c"
        $88 = ($86>>>0)>($$1121$3>>>0); //@line 57453 "c/sqlite3.c"
        $or$cond124 = $87 | $88; //@line 57453 "c/sqlite3.c"
        $89 = HEAP32[$8>>2]|0; //@line 57453 "c/sqlite3.c"
        $90 = ($89>>>0)>($22>>>0); //@line 57453 "c/sqlite3.c"
        $or$cond126 = $or$cond124 | $90; //@line 57453 "c/sqlite3.c"
        if ($or$cond126) {
         $$5149 = 0;
        } else {
         $91 = (($86) + -1)|0; //@line 57456 "c/sqlite3.c"
         $92 = (___muldi3(($91|0),0,($72|0),($74|0))|0); //@line 57456 "c/sqlite3.c"
         $93 = tempRet0; //@line 57456 "c/sqlite3.c"
         $94 = (_i64Add(($92|0),($93|0),56,0)|0); //@line 57456 "c/sqlite3.c"
         $95 = tempRet0; //@line 57456 "c/sqlite3.c"
         $96 = HEAP32[$34>>2]|0; //@line 57458 "c/sqlite3.c"
         $97 = (_sqlite3OsRead($96,$6,$12,$94,$95)|0); //@line 57458 "c/sqlite3.c"
         $98 = ($97|0)==(0); //@line 57459 "c/sqlite3.c"
         if (!($98)) {
          $$9 = $97;
          break L25;
         }
         $99 = (($89) + -1)|0; //@line 57460 "c/sqlite3.c"
         $100 = (___muldi3(($99|0),0,($12|0),($77|0))|0); //@line 57460 "c/sqlite3.c"
         $101 = tempRet0; //@line 57460 "c/sqlite3.c"
         $102 = HEAP32[$75>>2]|0; //@line 57462 "c/sqlite3.c"
         $103 = (_sqlite3OsWrite($102,$6,$12,$100,$101)|0); //@line 57462 "c/sqlite3.c"
         $104 = ($103|0)==(0); //@line 57463 "c/sqlite3.c"
         if ($104) {
          $$5149 = $103;
         } else {
          $$9 = $103;
          break L25;
         }
        }
        $105 = ($$5149|0)==(0); //@line 57446 "c/sqlite3.c"
        if (!($105)) {
         $$9 = $$5149;
         break L25;
        }
       }
       if ((label|0) == 16) {
        $82 = ((($1)) + 73|0); //@line 57450 "c/sqlite3.c"
        $83 = HEAP8[$82>>0]|0; //@line 57450 "c/sqlite3.c"
        $84 = ($83<<24>>24)==(0); //@line 57450 "c/sqlite3.c"
        $85 = $84 ? 9 : 7; //@line 57450 "c/sqlite3.c"
        $$9 = $85;
        break;
       }
       $106 = (_walIndexHdr($0)|0); //@line 57468 "c/sqlite3.c"
       $107 = ((($106)) + 16|0); //@line 57468 "c/sqlite3.c"
       $108 = HEAP32[$107>>2]|0; //@line 57468 "c/sqlite3.c"
       $109 = ($$1121$3|0)==($108|0); //@line 57468 "c/sqlite3.c"
       if ($109) {
        $110 = HEAP32[$21>>2]|0; //@line 57469 "c/sqlite3.c"
        $111 = ($12|0)<(0); //@line 57469 "c/sqlite3.c"
        $112 = $111 << 31 >> 31; //@line 57469 "c/sqlite3.c"
        $113 = (___muldi3(($110|0),0,($12|0),($112|0))|0); //@line 57469 "c/sqlite3.c"
        $114 = tempRet0; //@line 57469 "c/sqlite3.c"
        $115 = ((($0)) + 4|0); //@line 57471 "c/sqlite3.c"
        $116 = HEAP32[$115>>2]|0; //@line 57471 "c/sqlite3.c"
        $117 = (_sqlite3OsTruncate($116,$113,$114)|0); //@line 57471 "c/sqlite3.c"
        $118 = ($117|0)==(0); //@line 57472 "c/sqlite3.c"
        if (!($118)) {
         $$9 = $117;
         break;
        }
        $119 = HEAP32[$115>>2]|0; //@line 57473 "c/sqlite3.c"
        $120 = (_sqlite3OsSync($119,$37)|0); //@line 57473 "c/sqlite3.c"
        $121 = ($120|0)==(0); //@line 57476 "c/sqlite3.c"
        if (!($121)) {
         $$9 = $120;
         break;
        }
       }
       HEAP32[$13>>2] = $$1121$3; //@line 57477 "c/sqlite3.c"
       $$9 = 0;
      } else {
       $$9 = $38;
      }
     } while(0);
     _walUnlockExclusive($0,3,1); //@line 57482 "c/sqlite3.c"
     $$10 = $$9;
    } else {
     $$10 = $30;
    }
   } else {
    $$10 = $$1115$3;
   }
   $122 = ($$10|0)==(5); //@line 57485 "c/sqlite3.c"
   $spec$select = $122 ? 0 : $$10; //@line 57485 "c/sqlite3.c"
   $$11 = $spec$select;$$3 = $$1$3;
   label = 27;
  } else {
   $$11 = 0;$$3 = $3;
   label = 27;
  }
 } while(0);
 if ((label|0) == 27) {
  $123 = ($$11|0)==(0); //@line 57497 "c/sqlite3.c"
  $124 = ($2|0)!=(0); //@line 57497 "c/sqlite3.c"
  $or$cond = $124 & $123; //@line 57497 "c/sqlite3.c"
  if ($or$cond) {
   $125 = HEAP32[$13>>2]|0; //@line 57499 "c/sqlite3.c"
   $126 = HEAP32[$15>>2]|0; //@line 57499 "c/sqlite3.c"
   $127 = ($125>>>0)<($126>>>0); //@line 57499 "c/sqlite3.c"
   if ($127) {
    $$14 = 5;
   } else {
    $128 = ($2|0)>(1); //@line 57501 "c/sqlite3.c"
    if ($128) {
     _sqlite3_randomness(4,$10); //@line 57503 "c/sqlite3.c"
     $129 = (_walBusyLock($0,$$3,$4,4,4)|0); //@line 57505 "c/sqlite3.c"
     $130 = ($129|0)==(0); //@line 57506 "c/sqlite3.c"
     if ($130) {
      $131 = ($2|0)==(3); //@line 57507 "c/sqlite3.c"
      if ($131) {
       $132 = HEAP32[$10>>2]|0; //@line 57521 "c/sqlite3.c"
       _walRestartHdr($0,$132); //@line 57521 "c/sqlite3.c"
       $133 = ((($0)) + 8|0); //@line 57522 "c/sqlite3.c"
       $134 = HEAP32[$133>>2]|0; //@line 57522 "c/sqlite3.c"
       $135 = (_sqlite3OsTruncate($134,0,0)|0); //@line 57522 "c/sqlite3.c"
       $$12 = $135;
      } else {
       $$12 = 0;
      }
      _walUnlockExclusive($0,4,4); //@line 57524 "c/sqlite3.c"
      $$13 = $$12;
     } else {
      $$13 = $129;
     }
     $$14 = $$13;
    } else {
     $$14 = 0;
    }
   }
  } else {
   $$14 = $$11;
  }
 }
 $136 = HEAP32[$7>>2]|0; //@line 57530 "c/sqlite3.c"
 _walIteratorFree($136); //@line 57530 "c/sqlite3.c"
 $$0 = $$14;
 STACKTOP = sp;return ($$0|0); //@line 57532 "c/sqlite3.c"
}
function _walIteratorInit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$06467 = 0, $$06669 = 0, $$1$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0;
 var $or$cond68 = 0, $spec$select = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 12|0;
 $3 = sp + 8|0;
 $4 = sp + 4|0;
 $5 = sp;
 $6 = ((($0)) + 68|0); //@line 57199 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 57199 "c/sqlite3.c"
 $8 = (_walFramePage($7)|0); //@line 57202 "c/sqlite3.c"
 $9 = ($8*20)|0; //@line 57204 "c/sqlite3.c"
 $10 = $7 << 1; //@line 57205 "c/sqlite3.c"
 $11 = (($10) + 28)|0; //@line 57204 "c/sqlite3.c"
 $12 = (($11) + ($9))|0; //@line 57205 "c/sqlite3.c"
 $13 = ($12|0)<(0); //@line 57206 "c/sqlite3.c"
 $14 = $13 << 31 >> 31; //@line 57206 "c/sqlite3.c"
 $15 = (_sqlite3_malloc64($12,$14)|0); //@line 57206 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 57207 "c/sqlite3.c"
 if ($16) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 57260 "c/sqlite3.c"
 }
 $17 = (($8) + 1)|0; //@line 57202 "c/sqlite3.c"
 _memset(($15|0),0,($12|0))|0; //@line 57210 "c/sqlite3.c"
 $18 = ((($15)) + 4|0); //@line 57211 "c/sqlite3.c"
 HEAP32[$18>>2] = $17; //@line 57211 "c/sqlite3.c"
 $19 = ($7>>>0)<(4096); //@line 57217 "c/sqlite3.c"
 $20 = $19 ? $7 : 4096; //@line 57217 "c/sqlite3.c"
 $21 = $20 << 1; //@line 57217 "c/sqlite3.c"
 $22 = (_sqlite3_malloc64($21,0)|0); //@line 57216 "c/sqlite3.c"
 $23 = ($22|0)==(0|0); //@line 57219 "c/sqlite3.c"
 $spec$select = $23 ? 7 : 0; //@line 57219 "c/sqlite3.c"
 $24 = ($8|0)<(0); //@line 57223 "c/sqlite3.c"
 $or$cond68 = $24 | $23; //@line 57223 "c/sqlite3.c"
 if ($or$cond68) {
  $$1$lcssa = $spec$select;
 } else {
  $25 = ((($15)) + 8|0);
  $$06669 = 0;
  while(1) {
   $26 = (_walHashGet($0,$$06669,$2,$4,$3)|0); //@line 57228 "c/sqlite3.c"
   $27 = ($26|0)==(0); //@line 57229 "c/sqlite3.c"
   if ($27) {
    $28 = HEAP32[$4>>2]|0; //@line 57234 "c/sqlite3.c"
    $29 = ((($28)) + 4|0); //@line 57234 "c/sqlite3.c"
    HEAP32[$4>>2] = $29; //@line 57234 "c/sqlite3.c"
    $30 = ($$06669|0)==($8|0); //@line 57235 "c/sqlite3.c"
    if ($30) {
     $31 = HEAP32[$3>>2]|0; //@line 57236 "c/sqlite3.c"
     $32 = (($7) - ($31))|0; //@line 57236 "c/sqlite3.c"
     $storemerge = $32;
    } else {
     $33 = HEAP32[$2>>2]|0; //@line 57238 "c/sqlite3.c"
     $34 = $29; //@line 57238 "c/sqlite3.c"
     $35 = (($33) - ($34))|0; //@line 57238 "c/sqlite3.c"
     $36 = $35 >> 2; //@line 57238 "c/sqlite3.c"
     $storemerge = $36;
    }
    HEAP32[$5>>2] = $storemerge;
    $37 = HEAP32[$18>>2]|0; //@line 57240 "c/sqlite3.c"
    $38 = (($25) + (($37*20)|0)|0); //@line 57240 "c/sqlite3.c"
    $39 = HEAP32[$3>>2]|0; //@line 57240 "c/sqlite3.c"
    $40 = (($38) + ($39<<1)|0); //@line 57240 "c/sqlite3.c"
    $41 = (($39) + 1)|0; //@line 57241 "c/sqlite3.c"
    HEAP32[$3>>2] = $41; //@line 57241 "c/sqlite3.c"
    $42 = ($storemerge|0)>(0); //@line 57243 "c/sqlite3.c"
    if ($42) {
     $$06467 = 0;
     while(1) {
      $43 = $$06467&65535; //@line 57244 "c/sqlite3.c"
      $44 = (($40) + ($$06467<<1)|0); //@line 57244 "c/sqlite3.c"
      HEAP16[$44>>1] = $43; //@line 57244 "c/sqlite3.c"
      $45 = (($$06467) + 1)|0; //@line 57243 "c/sqlite3.c"
      $exitcond = ($45|0)==($storemerge|0); //@line 57243 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$06467 = $45;
      }
     }
    }
    _walMergesort($29,$22,$40,$5); //@line 57246 "c/sqlite3.c"
    $46 = (((($25) + (($$06669*20)|0)|0)) + 16|0); //@line 57247 "c/sqlite3.c"
    HEAP32[$46>>2] = $41; //@line 57247 "c/sqlite3.c"
    $47 = HEAP32[$5>>2]|0; //@line 57248 "c/sqlite3.c"
    $48 = (((($25) + (($$06669*20)|0)|0)) + 12|0); //@line 57248 "c/sqlite3.c"
    HEAP32[$48>>2] = $47; //@line 57248 "c/sqlite3.c"
    $49 = (((($25) + (($$06669*20)|0)|0)) + 4|0); //@line 57249 "c/sqlite3.c"
    HEAP32[$49>>2] = $40; //@line 57249 "c/sqlite3.c"
    $50 = HEAP32[$4>>2]|0; //@line 57250 "c/sqlite3.c"
    $51 = (((($25) + (($$06669*20)|0)|0)) + 8|0); //@line 57250 "c/sqlite3.c"
    HEAP32[$51>>2] = $50; //@line 57250 "c/sqlite3.c"
   }
   $52 = (($$06669) + 1)|0; //@line 57223 "c/sqlite3.c"
   $53 = ($26|0)!=(0); //@line 57223 "c/sqlite3.c"
   $54 = ($$06669|0)>=($8|0); //@line 57223 "c/sqlite3.c"
   $or$cond = $54 | $53; //@line 57223 "c/sqlite3.c"
   if ($or$cond) {
    $$1$lcssa = $26;
    break;
   } else {
    $$06669 = $52;
   }
  }
 }
 _sqlite3_free($22); //@line 57253 "c/sqlite3.c"
 $55 = ($$1$lcssa|0)==(0); //@line 57255 "c/sqlite3.c"
 if (!($55)) {
  _walIteratorFree($15); //@line 57256 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = $15; //@line 57258 "c/sqlite3.c"
 $$0 = $$1$lcssa;
 STACKTOP = sp;return ($$0|0); //@line 57260 "c/sqlite3.c"
}
function _walIteratorNext($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$034$lcssa = 0, $$03439 = 0, $$03540 = 0, $$03540$in = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 57006 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 57008 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 57008 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 57008 "c/sqlite3.c"
 if (!($6)) {
  $$034$lcssa = -1;
  HEAP32[$0>>2] = $$034$lcssa; //@line 57023 "c/sqlite3.c"
  HEAP32[$1>>2] = $$034$lcssa; //@line 57023 "c/sqlite3.c"
  $32 = ($$034$lcssa|0)==(-1); //@line 57024 "c/sqlite3.c"
  $33 = $32&1; //@line 57024 "c/sqlite3.c"
  return ($33|0); //@line 57024 "c/sqlite3.c"
 }
 $$03439 = -1;$$03540$in = $5;
 while(1) {
  $$03540 = (($$03540$in) + -1)|0;
  $7 = (((($0)) + 8|0) + (($$03540*20)|0)|0); //@line 57010 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 57010 "c/sqlite3.c"
  $9 = (((((($0)) + 8|0) + (($$03540*20)|0)|0)) + 12|0); //@line 57010 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 57010 "c/sqlite3.c"
  $11 = ($8|0)<($10|0); //@line 57010 "c/sqlite3.c"
  L6: do {
   if ($11) {
    $12 = (((((($0)) + 8|0) + (($$03540*20)|0)|0)) + 8|0);
    $13 = HEAP32[$12>>2]|0;
    $14 = (((((($0)) + 8|0) + (($$03540*20)|0)|0)) + 4|0);
    $15 = HEAP32[$14>>2]|0;
    $17 = $8;
    while(1) {
     $16 = (($15) + ($17<<1)|0); //@line 57011 "c/sqlite3.c"
     $18 = HEAP16[$16>>1]|0; //@line 57011 "c/sqlite3.c"
     $19 = $18&65535; //@line 57011 "c/sqlite3.c"
     $20 = (($13) + ($19<<2)|0); //@line 57011 "c/sqlite3.c"
     $21 = HEAP32[$20>>2]|0; //@line 57011 "c/sqlite3.c"
     $22 = ($21>>>0)>($3>>>0); //@line 57012 "c/sqlite3.c"
     if ($22) {
      break;
     }
     $28 = (($17) + 1)|0; //@line 57019 "c/sqlite3.c"
     HEAP32[$7>>2] = $28; //@line 57019 "c/sqlite3.c"
     $29 = HEAP32[$9>>2]|0; //@line 57010 "c/sqlite3.c"
     $30 = ($28|0)<($29|0); //@line 57010 "c/sqlite3.c"
     if ($30) {
      $17 = $28;
     } else {
      $$4 = $$03439;
      break L6;
     }
    }
    $23 = ($21>>>0)<($$03439>>>0); //@line 57013 "c/sqlite3.c"
    if ($23) {
     $24 = $18&65535; //@line 57011 "c/sqlite3.c"
     $25 = (((((($0)) + 8|0) + (($$03540*20)|0)|0)) + 16|0); //@line 57015 "c/sqlite3.c"
     $26 = HEAP32[$25>>2]|0; //@line 57015 "c/sqlite3.c"
     $27 = (($26) + ($24))|0; //@line 57015 "c/sqlite3.c"
     HEAP32[$2>>2] = $27; //@line 57015 "c/sqlite3.c"
     $$4 = $21;
    } else {
     $$4 = $$03439;
    }
   } else {
    $$4 = $$03439;
   }
  } while(0);
  $31 = ($$03540$in|0)>(1); //@line 57008 "c/sqlite3.c"
  if ($31) {
   $$03439 = $$4;$$03540$in = $$03540;
  } else {
   $$034$lcssa = $$4;
   break;
  }
 }
 HEAP32[$0>>2] = $$034$lcssa; //@line 57023 "c/sqlite3.c"
 HEAP32[$1>>2] = $$034$lcssa; //@line 57023 "c/sqlite3.c"
 $32 = ($$034$lcssa|0)==(-1); //@line 57024 "c/sqlite3.c"
 $33 = $32&1; //@line 57024 "c/sqlite3.c"
 return ($33|0); //@line 57024 "c/sqlite3.c"
}
function _walIteratorFree($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3_free($0); //@line 57171 "c/sqlite3.c"
 return; //@line 57172 "c/sqlite3.c"
}
function _walMergesort($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$042 = 0, $$1$lcssa = 0, $$138 = 0, $$2 = 0, $$236 = 0, $$237 = 0, $$237$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $exitcond48 = 0, dest = 0;
 var label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $4 = sp + 108|0;
 $5 = sp + 104|0;
 $6 = sp;
 $7 = HEAP32[$3>>2]|0; //@line 57118 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 57119 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 57120 "c/sqlite3.c"
 dest=$6; stop=dest+104|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 57125 "c/sqlite3.c"
 $8 = ($7|0)>(0); //@line 57129 "c/sqlite3.c"
 if ($8) {
  $$042 = 0;
  while(1) {
   HEAP32[$4>>2] = 1; //@line 57130 "c/sqlite3.c"
   $9 = (($2) + ($$042<<1)|0); //@line 57131 "c/sqlite3.c"
   HEAP32[$5>>2] = $9; //@line 57131 "c/sqlite3.c"
   $10 = $$042 & 1; //@line 57132 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 57132 "c/sqlite3.c"
   if ($11) {
    $$1$lcssa = 0;
   } else {
    $$138 = 0;
    while(1) {
     $12 = (((($6) + ($$138<<3)|0)) + 4|0); //@line 57138 "c/sqlite3.c"
     $13 = HEAP32[$12>>2]|0; //@line 57138 "c/sqlite3.c"
     $14 = (($6) + ($$138<<3)|0); //@line 57138 "c/sqlite3.c"
     $15 = HEAP32[$14>>2]|0; //@line 57138 "c/sqlite3.c"
     _walMerge($0,$13,$15,$5,$4,$1); //@line 57138 "c/sqlite3.c"
     $16 = (($$138) + 1)|0; //@line 57132 "c/sqlite3.c"
     $17 = 1 << $16; //@line 57132 "c/sqlite3.c"
     $18 = $17 & $$042; //@line 57132 "c/sqlite3.c"
     $19 = ($18|0)==(0); //@line 57132 "c/sqlite3.c"
     if ($19) {
      $$1$lcssa = $16;
      break;
     } else {
      $$138 = $16;
     }
    }
   }
   $20 = HEAP32[$5>>2]|0; //@line 57140 "c/sqlite3.c"
   $21 = (((($6) + ($$1$lcssa<<3)|0)) + 4|0); //@line 57140 "c/sqlite3.c"
   HEAP32[$21>>2] = $20; //@line 57140 "c/sqlite3.c"
   $22 = HEAP32[$4>>2]|0; //@line 57141 "c/sqlite3.c"
   $23 = (($6) + ($$1$lcssa<<3)|0); //@line 57141 "c/sqlite3.c"
   HEAP32[$23>>2] = $22; //@line 57141 "c/sqlite3.c"
   $24 = (($$042) + 1)|0; //@line 57129 "c/sqlite3.c"
   $exitcond48 = ($24|0)==($7|0); //@line 57129 "c/sqlite3.c"
   if ($exitcond48) {
    break;
   } else {
    $$042 = $24;
   }
  }
  $$236 = (($$1$lcssa) + 1)|0;
  $25 = ($$236>>>0)<(13); //@line 57144 "c/sqlite3.c"
  if ($25) {
   $$237$ph = $$236;
  } else {
   $33 = HEAP32[$4>>2]|0; //@line 57155 "c/sqlite3.c"
   HEAP32[$3>>2] = $33; //@line 57155 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 57165 "c/sqlite3.c"
  }
 } else {
  $$237$ph = 1;
 }
 $$237 = $$237$ph;
 while(1) {
  $26 = 1 << $$237; //@line 57145 "c/sqlite3.c"
  $27 = $26 & $7; //@line 57145 "c/sqlite3.c"
  $28 = ($27|0)==(0); //@line 57145 "c/sqlite3.c"
  if (!($28)) {
   $29 = (($6) + ($$237<<3)|0); //@line 57151 "c/sqlite3.c"
   $30 = (((($6) + ($$237<<3)|0)) + 4|0); //@line 57151 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 57151 "c/sqlite3.c"
   $32 = HEAP32[$29>>2]|0; //@line 57151 "c/sqlite3.c"
   _walMerge($0,$31,$32,$5,$4,$1); //@line 57151 "c/sqlite3.c"
  }
  $$2 = (($$237) + 1)|0;
  $exitcond = ($$2|0)==(13); //@line 57144 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$237 = $$2;
  }
 }
 $33 = HEAP32[$4>>2]|0; //@line 57155 "c/sqlite3.c"
 HEAP32[$3>>2] = $33; //@line 57155 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 57165 "c/sqlite3.c"
}
function _walMerge($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$051 = 0, $$051$in = 0, $$05257 = 0, $$054$lcssa = 0, $$05456 = 0, $$058 = 0, $$1 = 0, $$153 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond55 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = HEAP32[$4>>2]|0; //@line 57061 "c/sqlite3.c"
 $7 = HEAP32[$3>>2]|0; //@line 57062 "c/sqlite3.c"
 $8 = ($6|0)>(0); //@line 57065 "c/sqlite3.c"
 $9 = ($2|0)>(0); //@line 57065 "c/sqlite3.c"
 $or$cond55 = $8 | $9; //@line 57065 "c/sqlite3.c"
 if (!($or$cond55)) {
  $$054$lcssa = 0;
  HEAP32[$3>>2] = $1; //@line 57085 "c/sqlite3.c"
  HEAP32[$4>>2] = $$054$lcssa; //@line 57086 "c/sqlite3.c"
  $40 = $$054$lcssa << 1; //@line 57087 "c/sqlite3.c"
  _memcpy(($1|0),($5|0),($40|0))|0; //@line 57087 "c/sqlite3.c"
  return; //@line 57088 "c/sqlite3.c"
 }
 $$05257 = 0;$$05456 = 0;$$058 = 0;$41 = $9;$42 = $8;
 while(1) {
  do {
   if ($41) {
    if ($42) {
     $10 = (($1) + ($$058<<1)|0); //@line 57070 "c/sqlite3.c"
     $11 = HEAP16[$10>>1]|0; //@line 57070 "c/sqlite3.c"
     $12 = $11&65535; //@line 57070 "c/sqlite3.c"
     $13 = (($0) + ($12<<2)|0); //@line 57070 "c/sqlite3.c"
     $14 = HEAP32[$13>>2]|0; //@line 57070 "c/sqlite3.c"
     $15 = (($7) + ($$05257<<1)|0); //@line 57070 "c/sqlite3.c"
     $16 = HEAP16[$15>>1]|0; //@line 57070 "c/sqlite3.c"
     $17 = $16&65535; //@line 57070 "c/sqlite3.c"
     $18 = (($0) + ($17<<2)|0); //@line 57070 "c/sqlite3.c"
     $19 = HEAP32[$18>>2]|0; //@line 57070 "c/sqlite3.c"
     $20 = ($14>>>0)<($19>>>0); //@line 57070 "c/sqlite3.c"
     if (!($20)) {
      label = 7;
      break;
     }
    }
    $21 = (($$058) + 1)|0; //@line 57072 "c/sqlite3.c"
    $22 = (($1) + ($$058<<1)|0); //@line 57072 "c/sqlite3.c"
    $$051$in = $22;$$1 = $21;$$153 = $$05257;
   } else {
    label = 7;
   }
  } while(0);
  if ((label|0) == 7) {
   label = 0;
   $23 = (($$05257) + 1)|0; //@line 57074 "c/sqlite3.c"
   $24 = (($7) + ($$05257<<1)|0); //@line 57074 "c/sqlite3.c"
   $$051$in = $24;$$1 = $$058;$$153 = $23;
  }
  $$051 = HEAP16[$$051$in>>1]|0;
  $25 = $$051&65535; //@line 57076 "c/sqlite3.c"
  $26 = (($0) + ($25<<2)|0); //@line 57076 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 57076 "c/sqlite3.c"
  $28 = (($$05456) + 1)|0; //@line 57078 "c/sqlite3.c"
  $29 = (($5) + ($$05456<<1)|0); //@line 57078 "c/sqlite3.c"
  HEAP16[$29>>1] = $$051; //@line 57078 "c/sqlite3.c"
  $30 = ($$1|0)<($2|0); //@line 57079 "c/sqlite3.c"
  if ($30) {
   $31 = (($1) + ($$1<<1)|0); //@line 57079 "c/sqlite3.c"
   $32 = HEAP16[$31>>1]|0; //@line 57079 "c/sqlite3.c"
   $33 = $32&65535; //@line 57079 "c/sqlite3.c"
   $34 = (($0) + ($33<<2)|0); //@line 57079 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 57079 "c/sqlite3.c"
   $36 = ($35|0)==($27|0); //@line 57079 "c/sqlite3.c"
   $37 = $36&1; //@line 57079 "c/sqlite3.c"
   $spec$select = (($$1) + ($37))|0; //@line 57079 "c/sqlite3.c"
   $$2 = $spec$select;
  } else {
   $$2 = $$1;
  }
  $38 = ($$153|0)<($6|0); //@line 57065 "c/sqlite3.c"
  $39 = ($$2|0)<($2|0); //@line 57065 "c/sqlite3.c"
  $or$cond = $38 | $39; //@line 57065 "c/sqlite3.c"
  if ($or$cond) {
   $$05257 = $$153;$$05456 = $28;$$058 = $$2;$41 = $39;$42 = $38;
  } else {
   $$054$lcssa = $28;
   break;
  }
 }
 HEAP32[$3>>2] = $1; //@line 57085 "c/sqlite3.c"
 HEAP32[$4>>2] = $$054$lcssa; //@line 57086 "c/sqlite3.c"
 $40 = $$054$lcssa << 1; //@line 57087 "c/sqlite3.c"
 _memcpy(($1|0),($5|0),($40|0))|0; //@line 57087 "c/sqlite3.c"
 return; //@line 57088 "c/sqlite3.c"
}
function _sqlite3VdbeSorterReset($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$029 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 (_vdbeSorterJoinAll($1,0)|0); //@line 89026 "c/sqlite3.c"
 $2 = ((($1)) + 16|0); //@line 89029 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 89029 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 89029 "c/sqlite3.c"
 if (!($4)) {
  _vdbePmaReaderClear($3); //@line 89030 "c/sqlite3.c"
  $5 = HEAP32[$2>>2]|0; //@line 89031 "c/sqlite3.c"
  _sqlite3DbFree($0,$5); //@line 89031 "c/sqlite3.c"
  HEAP32[$2>>2] = 0; //@line 89032 "c/sqlite3.c"
 }
 $6 = ((($1)) + 20|0); //@line 89035 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 89035 "c/sqlite3.c"
 _vdbeMergeEngineFree($7); //@line 89035 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 89036 "c/sqlite3.c"
 $8 = ((($1)) + 59|0); //@line 89037 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 89037 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 89037 "c/sqlite3.c"
 if (!($10)) {
  $$029 = 0;
  while(1) {
   $11 = (((($1)) + 64|0) + (($$029*72)|0)|0); //@line 89038 "c/sqlite3.c"
   _vdbeSortSubtaskCleanup($0,$11); //@line 89039 "c/sqlite3.c"
   $12 = (((((($1)) + 64|0) + (($$029*72)|0)|0)) + 8|0); //@line 89040 "c/sqlite3.c"
   HEAP32[$12>>2] = $1; //@line 89040 "c/sqlite3.c"
   $13 = (($$029) + 1)|0; //@line 89037 "c/sqlite3.c"
   $14 = HEAP8[$8>>0]|0; //@line 89037 "c/sqlite3.c"
   $15 = $14&255; //@line 89037 "c/sqlite3.c"
   $16 = ($13>>>0)<($15>>>0); //@line 89037 "c/sqlite3.c"
   if ($16) {
    $$029 = $13;
   } else {
    break;
   }
  }
 }
 $17 = ((($1)) + 36|0); //@line 89042 "c/sqlite3.c"
 $18 = ((($1)) + 40|0); //@line 89042 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 89042 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 89042 "c/sqlite3.c"
 if ($20) {
  $21 = HEAP32[$17>>2]|0; //@line 89043 "c/sqlite3.c"
  _vdbeSorterRecordFree(0,$21); //@line 89043 "c/sqlite3.c"
 }
 HEAP32[$17>>2] = 0; //@line 89045 "c/sqlite3.c"
 $22 = ((($1)) + 44|0); //@line 89046 "c/sqlite3.c"
 HEAP32[$22>>2] = 0; //@line 89046 "c/sqlite3.c"
 $23 = ((($1)) + 56|0); //@line 89047 "c/sqlite3.c"
 HEAP8[$23>>0] = 0; //@line 89047 "c/sqlite3.c"
 $24 = ((($1)) + 48|0); //@line 89048 "c/sqlite3.c"
 HEAP32[$24>>2] = 0; //@line 89048 "c/sqlite3.c"
 $25 = ((($1)) + 8|0); //@line 89049 "c/sqlite3.c"
 HEAP32[$25>>2] = 0; //@line 89049 "c/sqlite3.c"
 $26 = ((($1)) + 32|0); //@line 89050 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 89050 "c/sqlite3.c"
 _sqlite3DbFree($0,$27); //@line 89050 "c/sqlite3.c"
 HEAP32[$26>>2] = 0; //@line 89051 "c/sqlite3.c"
 return; //@line 89052 "c/sqlite3.c"
}
function _vdbeSorterJoinAll($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$01619 = 0, $$01619$in = 0, $$018 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 59|0); //@line 88951 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 88951 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 88951 "c/sqlite3.c"
 if ($4) {
  $$0$lcssa = $1;
  return ($$0$lcssa|0); //@line 88956 "c/sqlite3.c"
 }
 $5 = $3&255; //@line 88951 "c/sqlite3.c"
 $$01619$in = $5;$$018 = $1;
 while(1) {
  $$01619 = (($$01619$in) + -1)|0;
  $6 = (((($0)) + 64|0) + (($$01619*72)|0)|0); //@line 88952 "c/sqlite3.c"
  $7 = (_vdbeSorterJoinThread($6)|0); //@line 88953 "c/sqlite3.c"
  $8 = ($$018|0)==(0); //@line 88954 "c/sqlite3.c"
  $spec$select = $8 ? $7 : $$018; //@line 88954 "c/sqlite3.c"
  $9 = ($$01619$in|0)>(1); //@line 88951 "c/sqlite3.c"
  if ($9) {
   $$01619$in = $$01619;$$018 = $spec$select;
  } else {
   $$0$lcssa = $spec$select;
   break;
  }
 }
 return ($$0$lcssa|0); //@line 88956 "c/sqlite3.c"
}
function _vdbePmaReaderClear($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 28|0); //@line 88271 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 88271 "c/sqlite3.c"
 _sqlite3_free($2); //@line 88271 "c/sqlite3.c"
 $3 = ((($0)) + 36|0); //@line 88272 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 88272 "c/sqlite3.c"
 _sqlite3_free($4); //@line 88272 "c/sqlite3.c"
 $5 = ((($0)) + 48|0); //@line 88274 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 88274 "c/sqlite3.c"
 _vdbeIncrFree($6); //@line 88274 "c/sqlite3.c"
 dest=$0; stop=dest+56|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 88275 "c/sqlite3.c"
 return; //@line 88276 "c/sqlite3.c"
}
function _vdbeMergeEngineFree($0) {
 $0 = $0|0;
 var $$07 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 88995 "c/sqlite3.c"
 if (!($1)) {
  $2 = HEAP32[$0>>2]|0; //@line 88996 "c/sqlite3.c"
  $3 = ($2|0)>(0); //@line 88996 "c/sqlite3.c"
  if ($3) {
   $4 = ((($0)) + 12|0);
   $$07 = 0;
   while(1) {
    $5 = HEAP32[$4>>2]|0; //@line 88997 "c/sqlite3.c"
    $6 = (($5) + (($$07*56)|0)|0); //@line 88997 "c/sqlite3.c"
    _vdbePmaReaderClear($6); //@line 88997 "c/sqlite3.c"
    $7 = (($$07) + 1)|0; //@line 88996 "c/sqlite3.c"
    $8 = HEAP32[$0>>2]|0; //@line 88996 "c/sqlite3.c"
    $9 = ($7|0)<($8|0); //@line 88996 "c/sqlite3.c"
    if ($9) {
     $$07 = $7;
    } else {
     break;
    }
   }
  }
 }
 _sqlite3_free($0); //@line 89000 "c/sqlite3.c"
 return; //@line 89001 "c/sqlite3.c"
}
function _vdbeSortSubtaskCleanup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 12|0); //@line 88842 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 88842 "c/sqlite3.c"
 _sqlite3DbFree($0,$3); //@line 88842 "c/sqlite3.c"
 $4 = ((($1)) + 20|0); //@line 88846 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 88846 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 88846 "c/sqlite3.c"
 if ($6) {
  $7 = ((($1)) + 16|0); //@line 88852 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 88852 "c/sqlite3.c"
  _vdbeSorterRecordFree(0,$8); //@line 88852 "c/sqlite3.c"
 } else {
  _sqlite3_free($5); //@line 88847 "c/sqlite3.c"
 }
 $9 = ((($1)) + 40|0); //@line 88854 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 88854 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 88854 "c/sqlite3.c"
 if (!($11)) {
  _sqlite3OsCloseFree($10); //@line 88855 "c/sqlite3.c"
 }
 $12 = ((($1)) + 56|0); //@line 88857 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 88857 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 88857 "c/sqlite3.c"
 if ($14) {
  dest=$1; stop=dest+72|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 88860 "c/sqlite3.c"
  return; //@line 88861 "c/sqlite3.c"
 }
 _sqlite3OsCloseFree($13); //@line 88858 "c/sqlite3.c"
 dest=$1; stop=dest+72|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 88860 "c/sqlite3.c"
 return; //@line 88861 "c/sqlite3.c"
}
function _vdbeSorterRecordFree($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$09 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 88831 "c/sqlite3.c"
 if ($2) {
  return; //@line 88835 "c/sqlite3.c"
 }
 $$09 = $1;
 while(1) {
  $3 = ((($$09)) + 4|0); //@line 88832 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 88832 "c/sqlite3.c"
  _sqlite3DbFree($0,$$09); //@line 88833 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 88831 "c/sqlite3.c"
  if ($5) {
   break;
  } else {
   $$09 = $4;
  }
 }
 return; //@line 88835 "c/sqlite3.c"
}
function _vdbeIncrFree($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 89008 "c/sqlite3.c"
 if ($1) {
  return; //@line 89019 "c/sqlite3.c"
 }
 $2 = ((($0)) + 24|0); //@line 89010 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 89010 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 89010 "c/sqlite3.c"
 if (!($4)) {
  $5 = HEAP32[$0>>2]|0; //@line 89011 "c/sqlite3.c"
  (_vdbeSorterJoinThread($5)|0); //@line 89011 "c/sqlite3.c"
  $6 = ((($0)) + 32|0); //@line 89012 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 89012 "c/sqlite3.c"
  $8 = ($7|0)==(0|0); //@line 89012 "c/sqlite3.c"
  if (!($8)) {
   _sqlite3OsCloseFree($7); //@line 89012 "c/sqlite3.c"
  }
  $9 = ((($0)) + 48|0); //@line 89013 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 89013 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 89013 "c/sqlite3.c"
  if (!($11)) {
   _sqlite3OsCloseFree($10); //@line 89013 "c/sqlite3.c"
  }
 }
 $12 = ((($0)) + 4|0); //@line 89016 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 89016 "c/sqlite3.c"
 _vdbeMergeEngineFree($13); //@line 89016 "c/sqlite3.c"
 _sqlite3_free($0); //@line 89017 "c/sqlite3.c"
 return; //@line 89019 "c/sqlite3.c"
}
function _vdbeSorterJoinThread($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = HEAP32[$0>>2]|0; //@line 88908 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 88908 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 88921 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = (1); //@line 88912 "c/sqlite3.c"
 _sqlite3ThreadJoin($2,$1); //@line 88914 "c/sqlite3.c"
 $4 = HEAP32[$1>>2]|0; //@line 88916 "c/sqlite3.c"
 $5 = ((($0)) + 4|0); //@line 88918 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 88918 "c/sqlite3.c"
 HEAP32[$0>>2] = 0; //@line 88919 "c/sqlite3.c"
 $$0 = $4;
 STACKTOP = sp;return ($$0|0); //@line 88921 "c/sqlite3.c"
}
function _sqlite3ThreadJoin($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 27748 "c/sqlite3.c"
 if ($2) {
  return;
 }
 $3 = ((($0)) + 4|0); //@line 27749 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 27749 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 27749 "c/sqlite3.c"
 if ($5) {
  $8 = HEAP32[$0>>2]|0; //@line 27753 "c/sqlite3.c"
  (_pthread_join(($8|0),($1|0))|0); //@line 27753 "c/sqlite3.c"
 } else {
  $6 = ((($0)) + 8|0); //@line 27750 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 27750 "c/sqlite3.c"
  HEAP32[$1>>2] = $7; //@line 27750 "c/sqlite3.c"
 }
 _sqlite3_free($0); //@line 27755 "c/sqlite3.c"
 return;
}
function _initMemArray($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$067 = 0, $$08 = 0, $10 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)>(0); //@line 74505 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 74514 "c/sqlite3.c"
 }
 $$067 = $1;$$08 = $0;
 while(1) {
  $5 = (($$067) + -1)|0; //@line 74505 "c/sqlite3.c"
  $6 = ((($$08)) + 32|0); //@line 74506 "c/sqlite3.c"
  HEAP32[$6>>2] = $2; //@line 74506 "c/sqlite3.c"
  $7 = ((($$08)) + 8|0); //@line 74507 "c/sqlite3.c"
  HEAP16[$7>>1] = $3; //@line 74507 "c/sqlite3.c"
  $8 = ((($$08)) + 24|0); //@line 74508 "c/sqlite3.c"
  HEAP32[$8>>2] = 0; //@line 74508 "c/sqlite3.c"
  $9 = ((($$08)) + 40|0); //@line 74512 "c/sqlite3.c"
  $10 = ($$067|0)>(1); //@line 74505 "c/sqlite3.c"
  if ($10) {
   $$067 = $5;$$08 = $9;
  } else {
   break;
  }
 }
 return; //@line 74514 "c/sqlite3.c"
}
function _sqlite3BtreeIsInReadTrans($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 70165 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 70165 "c/sqlite3.c"
 $3 = ($2<<24>>24)!=(0); //@line 70165 "c/sqlite3.c"
 $4 = $3&1; //@line 70165 "c/sqlite3.c"
 return ($4|0); //@line 70165 "c/sqlite3.c"
}
function _sqlite3BtreeBeginTrans($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$092 = 0, $$092118 = 0, $$092119 = 0, $$1 = 0, $$195 = 0, $$2$lcssa = 0, $$4 = 0, $$4$ph = 0, $$4101 = 0, $$4102104105 = 0, $$6 = 0, $$7 = 0, $$old = 0, $$old109 = 0, $$pn = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0;
 var $104 = 0, $105 = 0, $106 = 0, $107 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0;
 var $99 = 0, $or$cond = 0, $or$cond110 = 0, $or$cond3 = 0, $or$cond5 = 0, $or$cond9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 63695 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63695 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63698 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 63705 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 63705 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(2); //@line 63705 "c/sqlite3.c"
 do {
  if ($6) {
   $$6 = 0;
  } else {
   $7 = ($5<<24>>24)!=(1); //@line 63705 "c/sqlite3.c"
   $8 = ($1|0)!=(0); //@line 63705 "c/sqlite3.c"
   $or$cond = $8 | $7; //@line 63705 "c/sqlite3.c"
   if (!($or$cond)) {
    $$7 = 0;
    _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
    return ($$7|0); //@line 63832 "c/sqlite3.c"
   }
   $9 = ((($3)) + 22|0); //@line 63711 "c/sqlite3.c"
   $10 = HEAP16[$9>>1]|0; //@line 63711 "c/sqlite3.c"
   $11 = $10 & 1; //@line 63711 "c/sqlite3.c"
   $12 = ($11<<16>>16)!=(0); //@line 63711 "c/sqlite3.c"
   $or$cond3 = $8 & $12; //@line 63711 "c/sqlite3.c"
   if ($or$cond3) {
    $$7 = 8;
    _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
    return ($$7|0); //@line 63832 "c/sqlite3.c"
   }
   L9: do {
    if ($8) {
     $13 = ((($3)) + 20|0); //@line 63723 "c/sqlite3.c"
     $14 = HEAP8[$13>>0]|0; //@line 63723 "c/sqlite3.c"
     $15 = ($14<<24>>24)!=(2); //@line 63723 "c/sqlite3.c"
     $16 = $10 & 128; //@line 63724 "c/sqlite3.c"
     $17 = ($16<<16>>16)==(0); //@line 63724 "c/sqlite3.c"
     $or$cond110 = $17 & $15; //@line 63724 "c/sqlite3.c"
     if ($or$cond110) {
      $20 = ($1|0)>(1); //@line 63727 "c/sqlite3.c"
      if ($20) {
       $21 = ((($3)) + 72|0); //@line 63729 "c/sqlite3.c"
       $$092118 = HEAP32[$21>>2]|0;
       $22 = ($$092118|0)==(0|0); //@line 63729 "c/sqlite3.c"
       if (!($22)) {
        $$092119 = $$092118;
        while(1) {
         $25 = HEAP32[$$092119>>2]|0; //@line 63730 "c/sqlite3.c"
         $26 = ($25|0)==($0|0); //@line 63730 "c/sqlite3.c"
         if (!($26)) {
          $$pn = $25;
          label = 13;
          break L9;
         }
         $23 = ((($$092119)) + 12|0); //@line 63729 "c/sqlite3.c"
         $$092 = HEAP32[$23>>2]|0;
         $24 = ($$092|0)==(0|0); //@line 63729 "c/sqlite3.c"
         if ($24) {
          break;
         } else {
          $$092119 = $$092;
         }
        }
       }
      }
     } else {
      label = 7;
     }
    } else {
     $$old = $10 & 128; //@line 63724 "c/sqlite3.c"
     $$old109 = ($$old<<16>>16)==(0); //@line 63724 "c/sqlite3.c"
     if (!($$old109)) {
      label = 7;
     }
    }
   } while(0);
   if ((label|0) == 7) {
    $18 = ((($3)) + 76|0); //@line 63726 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 63726 "c/sqlite3.c"
    $$pn = $19;
    label = 13;
   }
   if ((label|0) == 13) {
    $$1 = HEAP32[$$pn>>2]|0;
    $27 = ($$1|0)==(0|0); //@line 63736 "c/sqlite3.c"
    if (!($27)) {
     $$7 = 262;
     _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
     return ($$7|0); //@line 63832 "c/sqlite3.c"
    }
   }
   $28 = (_querySharedCacheTableLock($0,1,1)|0); //@line 63747 "c/sqlite3.c"
   $29 = ($28|0)==(0); //@line 63748 "c/sqlite3.c"
   if (!($29)) {
    $$7 = $28;
    _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
    return ($$7|0); //@line 63832 "c/sqlite3.c"
   }
   $30 = HEAP16[$9>>1]|0; //@line 63750 "c/sqlite3.c"
   $31 = $30 & -17; //@line 63750 "c/sqlite3.c"
   HEAP16[$9>>1] = $31; //@line 63750 "c/sqlite3.c"
   $32 = ((($3)) + 44|0); //@line 63751 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 63751 "c/sqlite3.c"
   $34 = ($33|0)==(0); //@line 63751 "c/sqlite3.c"
   if ($34) {
    $35 = $30 | 16; //@line 63751 "c/sqlite3.c"
    HEAP16[$9>>1] = $35; //@line 63751 "c/sqlite3.c"
   }
   $36 = ((($3)) + 12|0);
   $37 = ((($3)) + 20|0);
   $38 = ($1|0)>(1);
   $39 = $38&1;
   $$195 = 0;
   L30: while(1) {
    $40 = HEAP32[$36>>2]|0; //@line 63760 "c/sqlite3.c"
    $41 = ($40|0)==(0|0); //@line 63760 "c/sqlite3.c"
    L32: do {
     if ($41) {
      while(1) {
       $44 = (_lockBtree($3)|0); //@line 63760 "c/sqlite3.c"
       $45 = ($44|0)==(0); //@line 63760 "c/sqlite3.c"
       if (!($45)) {
        $$4$ph = $44;
        label = 26;
        break L32;
       }
       $42 = HEAP32[$36>>2]|0; //@line 63760 "c/sqlite3.c"
       $43 = ($42|0)==(0|0); //@line 63760 "c/sqlite3.c"
       if (!($43)) {
        $$2$lcssa = 0;
        label = 22;
        break;
       }
      }
     } else {
      $$2$lcssa = $$195;
      label = 22;
     }
    } while(0);
    do {
     if ((label|0) == 22) {
      label = 0;
      $46 = ($$2$lcssa|0)==(0); //@line 63762 "c/sqlite3.c"
      $or$cond5 = $8 & $46; //@line 63762 "c/sqlite3.c"
      if ($or$cond5) {
       $47 = HEAP16[$9>>1]|0; //@line 63763 "c/sqlite3.c"
       $48 = $47 & 1; //@line 63763 "c/sqlite3.c"
       $49 = ($48<<16>>16)==(0); //@line 63763 "c/sqlite3.c"
       if (!($49)) {
        $$4$ph = 8;
        label = 26;
        break;
       }
       $50 = HEAP32[$3>>2]|0; //@line 63766 "c/sqlite3.c"
       $51 = HEAP32[$0>>2]|0; //@line 63766 "c/sqlite3.c"
       $52 = (_sqlite3TempInMemory($51)|0); //@line 63766 "c/sqlite3.c"
       $53 = (_sqlite3PagerBegin($50,$39,$52)|0); //@line 63766 "c/sqlite3.c"
       $54 = ($53|0)==(0); //@line 63767 "c/sqlite3.c"
       if (!($54)) {
        $$4$ph = $53;
        label = 26;
        break;
       }
       $55 = (_newDatabase($3)|0); //@line 63768 "c/sqlite3.c"
       $$4 = $55;
      } else {
       $$4 = $$2$lcssa;
      }
      $57 = ($$4|0)==(0); //@line 63773 "c/sqlite3.c"
      if ($57) {
       $$4102104105 = 0;
       break L30;
      } else {
       $$4101 = $$4;$107 = 0;
      }
     }
    } while(0);
    if ((label|0) == 26) {
     label = 0;
     $56 = ($$4$ph|0)==(0); //@line 63773 "c/sqlite3.c"
     $$4101 = $$4$ph;$107 = $56;
    }
    _unlockBtreeIfUnused($3); //@line 63774 "c/sqlite3.c"
    $58 = $$4101 & 255; //@line 63776 "c/sqlite3.c"
    $59 = ($58|0)==(5); //@line 63776 "c/sqlite3.c"
    if (!($59)) {
     label = 31;
     break;
    }
    $60 = HEAP8[$37>>0]|0; //@line 63776 "c/sqlite3.c"
    $61 = ($60<<24>>24)==(0); //@line 63776 "c/sqlite3.c"
    if (!($61)) {
     label = 31;
     break;
    }
    $62 = (_btreeInvokeBusyHandler($3)|0); //@line 63777 "c/sqlite3.c"
    $63 = ($62|0)==(0); //@line 63776 "c/sqlite3.c"
    if ($63) {
     label = 31;
     break;
    } else {
     $$195 = $$4101;
    }
   }
   if ((label|0) == 31) {
    if ($107) {
     $$4102104105 = $$4101;
    } else {
     $$7 = $$4101;
     _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
     return ($$7|0); //@line 63832 "c/sqlite3.c"
    }
   }
   $64 = HEAP8[$4>>0]|0; //@line 63780 "c/sqlite3.c"
   $65 = ($64<<24>>24)==(0); //@line 63780 "c/sqlite3.c"
   if ($65) {
    $66 = ((($3)) + 40|0); //@line 63781 "c/sqlite3.c"
    $67 = HEAP32[$66>>2]|0; //@line 63781 "c/sqlite3.c"
    $68 = (($67) + 1)|0; //@line 63781 "c/sqlite3.c"
    HEAP32[$66>>2] = $68; //@line 63781 "c/sqlite3.c"
    $69 = ((($0)) + 9|0); //@line 63783 "c/sqlite3.c"
    $70 = HEAP8[$69>>0]|0; //@line 63783 "c/sqlite3.c"
    $71 = ($70<<24>>24)==(0); //@line 63783 "c/sqlite3.c"
    if (!($71)) {
     $72 = ((($0)) + 32|0); //@line 63785 "c/sqlite3.c"
     $73 = ((($0)) + 40|0); //@line 63785 "c/sqlite3.c"
     HEAP8[$73>>0] = 1; //@line 63785 "c/sqlite3.c"
     $74 = ((($3)) + 72|0); //@line 63786 "c/sqlite3.c"
     $75 = HEAP32[$74>>2]|0; //@line 63786 "c/sqlite3.c"
     $76 = ((($0)) + 44|0); //@line 63786 "c/sqlite3.c"
     HEAP32[$76>>2] = $75; //@line 63786 "c/sqlite3.c"
     HEAP32[$74>>2] = $72; //@line 63787 "c/sqlite3.c"
    }
   }
   $77 = $8 ? 2 : 1; //@line 63791 "c/sqlite3.c"
   HEAP8[$4>>0] = $77; //@line 63791 "c/sqlite3.c"
   $78 = ((($3)) + 20|0); //@line 63792 "c/sqlite3.c"
   $79 = HEAP8[$78>>0]|0; //@line 63792 "c/sqlite3.c"
   $80 = ($77&255)>($79&255); //@line 63792 "c/sqlite3.c"
   if ($80) {
    HEAP8[$78>>0] = $77; //@line 63793 "c/sqlite3.c"
   }
   if (!($8)) {
    $$7 = $$4102104105;
    _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
    return ($$7|0); //@line 63832 "c/sqlite3.c"
   }
   $81 = HEAP32[$36>>2]|0; //@line 63796 "c/sqlite3.c"
   $82 = ((($3)) + 76|0); //@line 63799 "c/sqlite3.c"
   HEAP32[$82>>2] = $0; //@line 63799 "c/sqlite3.c"
   $83 = HEAP16[$9>>1]|0; //@line 63800 "c/sqlite3.c"
   $84 = $83 & -65; //@line 63800 "c/sqlite3.c"
   $85 = ($1|0)>(1); //@line 63801 "c/sqlite3.c"
   $86 = $83 | 64; //@line 63801 "c/sqlite3.c"
   $spec$select = $85 ? $86 : $84; //@line 63801 "c/sqlite3.c"
   HEAP16[$9>>1] = $spec$select;
   $87 = HEAP32[$32>>2]|0; //@line 63810 "c/sqlite3.c"
   $88 = ((($81)) + 56|0); //@line 63810 "c/sqlite3.c"
   $89 = HEAP32[$88>>2]|0; //@line 63810 "c/sqlite3.c"
   $90 = ((($89)) + 28|0); //@line 63810 "c/sqlite3.c"
   $91 = (_sqlite3Get4byte($90)|0); //@line 63810 "c/sqlite3.c"
   $92 = ($87|0)==($91|0); //@line 63810 "c/sqlite3.c"
   if ($92) {
    $$6 = $$4102104105;
   } else {
    $93 = ((($81)) + 72|0); //@line 63811 "c/sqlite3.c"
    $94 = HEAP32[$93>>2]|0; //@line 63811 "c/sqlite3.c"
    $95 = (_sqlite3PagerWrite($94)|0); //@line 63811 "c/sqlite3.c"
    $96 = ($95|0)==(0); //@line 63812 "c/sqlite3.c"
    if ($96) {
     $97 = HEAP32[$88>>2]|0; //@line 63813 "c/sqlite3.c"
     $98 = ((($97)) + 28|0); //@line 63813 "c/sqlite3.c"
     $99 = HEAP32[$32>>2]|0; //@line 63813 "c/sqlite3.c"
     _sqlite3Put4byte($98,$99); //@line 63813 "c/sqlite3.c"
     $$6 = 0;
     break;
    } else {
     $$7 = $95;
     _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
     return ($$7|0); //@line 63832 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $100 = ($$6|0)==(0); //@line 63821 "c/sqlite3.c"
 $101 = ($1|0)!=(0); //@line 63821 "c/sqlite3.c"
 $or$cond9 = $101 & $100; //@line 63821 "c/sqlite3.c"
 if (!($or$cond9)) {
  $$7 = $$6;
  _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
  return ($$7|0); //@line 63832 "c/sqlite3.c"
 }
 $102 = HEAP32[$3>>2]|0; //@line 63826 "c/sqlite3.c"
 $103 = HEAP32[$0>>2]|0; //@line 63826 "c/sqlite3.c"
 $104 = ((($103)) + 440|0); //@line 63826 "c/sqlite3.c"
 $105 = HEAP32[$104>>2]|0; //@line 63826 "c/sqlite3.c"
 $106 = (_sqlite3PagerOpenSavepoint($102,$105)|0); //@line 63826 "c/sqlite3.c"
 $$7 = $106;
 _sqlite3BtreeLeave($0); //@line 63830 "c/sqlite3.c"
 return ($$7|0); //@line 63832 "c/sqlite3.c"
}
function _sqlite3BtreeGetMeta($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 69347 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 69347 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 69349 "c/sqlite3.c"
 $5 = ($1|0)==(15); //@line 69355 "c/sqlite3.c"
 if ($5) {
  $6 = HEAP32[$4>>2]|0; //@line 69356 "c/sqlite3.c"
  $7 = (_sqlite3PagerDataVersion($6)|0); //@line 69356 "c/sqlite3.c"
  $8 = ((($0)) + 20|0); //@line 69356 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 69356 "c/sqlite3.c"
  $10 = (($9) + ($7))|0; //@line 69356 "c/sqlite3.c"
  $storemerge = $10;
  HEAP32[$2>>2] = $storemerge;
  _sqlite3BtreeLeave($0); //@line 69369 "c/sqlite3.c"
  return; //@line 69370 "c/sqlite3.c"
 } else {
  $11 = ((($4)) + 12|0); //@line 69358 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 69358 "c/sqlite3.c"
  $13 = ((($12)) + 56|0); //@line 69358 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 69358 "c/sqlite3.c"
  $15 = $1 << 2; //@line 69358 "c/sqlite3.c"
  $16 = (($15) + 36)|0; //@line 69358 "c/sqlite3.c"
  $17 = (($14) + ($16)|0); //@line 69358 "c/sqlite3.c"
  $18 = (_sqlite3Get4byte($17)|0); //@line 69358 "c/sqlite3.c"
  $storemerge = $18;
  HEAP32[$2>>2] = $storemerge;
  _sqlite3BtreeLeave($0); //@line 69369 "c/sqlite3.c"
  return; //@line 69370 "c/sqlite3.c"
 }
}
function _sqlite3BtreeCommit($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 64406 "c/sqlite3.c"
 $1 = (_sqlite3BtreeCommitPhaseOne($0,0)|0); //@line 64407 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 64408 "c/sqlite3.c"
 if ($2) {
  $3 = (_sqlite3BtreeCommitPhaseTwo($0,0)|0); //@line 64409 "c/sqlite3.c"
  $$0 = $3;
 } else {
  $$0 = $1;
 }
 _sqlite3BtreeLeave($0); //@line 64411 "c/sqlite3.c"
 return ($$0|0); //@line 64412 "c/sqlite3.c"
}
function _sqlite3PagerDataVersion($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 100|0); //@line 49733 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 49733 "c/sqlite3.c"
 return ($2|0); //@line 49733 "c/sqlite3.c"
}
function _querySharedCacheTableLock($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$019 = 0, $$020 = 0, $$021 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 60679 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60679 "c/sqlite3.c"
 $5 = ((($0)) + 9|0); //@line 60695 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 60695 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 60695 "c/sqlite3.c"
 if ($7) {
  $$019 = 0;
  return ($$019|0); //@line 60729 "c/sqlite3.c"
 }
 $8 = ((($4)) + 76|0); //@line 60702 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 60702 "c/sqlite3.c"
 $10 = ($9|0)==($0|0); //@line 60702 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($4)) + 22|0); //@line 60702 "c/sqlite3.c"
  $12 = HEAP16[$11>>1]|0; //@line 60702 "c/sqlite3.c"
  $13 = $12 & 64; //@line 60702 "c/sqlite3.c"
  $14 = ($13<<16>>16)==(0); //@line 60702 "c/sqlite3.c"
  if (!($14)) {
   $$019 = 262;
   return ($$019|0); //@line 60729 "c/sqlite3.c"
  }
 }
 $15 = ((($4)) + 72|0); //@line 60707 "c/sqlite3.c"
 $$020 = HEAP32[$15>>2]|0;
 $16 = ($$020|0)==(0|0); //@line 60707 "c/sqlite3.c"
 if ($16) {
  $$019 = 0;
  return ($$019|0); //@line 60729 "c/sqlite3.c"
 }
 $$021 = $$020;
 while(1) {
  $17 = HEAP32[$$021>>2]|0; //@line 60719 "c/sqlite3.c"
  $18 = ($17|0)==($0|0); //@line 60719 "c/sqlite3.c"
  if (!($18)) {
   $19 = ((($$021)) + 4|0); //@line 60719 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 60719 "c/sqlite3.c"
   $21 = ($20|0)==($1|0); //@line 60719 "c/sqlite3.c"
   if ($21) {
    $22 = ((($$021)) + 8|0); //@line 60719 "c/sqlite3.c"
    $23 = HEAP8[$22>>0]|0; //@line 60719 "c/sqlite3.c"
    $24 = ($23<<24>>24)==($2<<24>>24); //@line 60719 "c/sqlite3.c"
    if (!($24)) {
     break;
    }
   }
  }
  $29 = ((($$021)) + 12|0); //@line 60707 "c/sqlite3.c"
  $$0 = HEAP32[$29>>2]|0;
  $30 = ($$0|0)==(0|0); //@line 60707 "c/sqlite3.c"
  if ($30) {
   $$019 = 0;
   label = 12;
   break;
  } else {
   $$021 = $$0;
  }
 }
 if ((label|0) == 12) {
  return ($$019|0); //@line 60729 "c/sqlite3.c"
 }
 $25 = ($2<<24>>24)==(2); //@line 60721 "c/sqlite3.c"
 if (!($25)) {
  $$019 = 262;
  return ($$019|0); //@line 60729 "c/sqlite3.c"
 }
 $26 = ((($4)) + 22|0); //@line 60723 "c/sqlite3.c"
 $27 = HEAP16[$26>>1]|0; //@line 60723 "c/sqlite3.c"
 $28 = $27 | 128; //@line 60723 "c/sqlite3.c"
 HEAP16[$26>>1] = $28; //@line 60723 "c/sqlite3.c"
 $$019 = 262;
 return ($$019|0); //@line 60729 "c/sqlite3.c"
}
function _lockBtree($0) {
 $0 = $0|0;
 var $$084 = 0, $$28391 = 0, $$3 = 0, $$off = 0, $$sink = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp + 8|0;
 $2 = sp + 4|0;
 $3 = sp;
 HEAP32[$2>>2] = 0; //@line 63390 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 63395 "c/sqlite3.c"
 $5 = (_sqlite3PagerSharedLock($4)|0); //@line 63395 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 63396 "c/sqlite3.c"
 if (!($6)) {
  $$3 = $5;
  STACKTOP = sp;return ($$3|0); //@line 63555 "c/sqlite3.c"
 }
 $7 = (_btreeGetPage($0,1,$1,0)|0); //@line 63397 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 63398 "c/sqlite3.c"
 if (!($8)) {
  $$3 = $7;
  STACKTOP = sp;return ($$3|0); //@line 63555 "c/sqlite3.c"
 }
 $9 = HEAP32[$1>>2]|0; //@line 63403 "c/sqlite3.c"
 $10 = ((($9)) + 56|0); //@line 63403 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 63403 "c/sqlite3.c"
 $12 = ((($11)) + 28|0); //@line 63403 "c/sqlite3.c"
 $13 = (_sqlite3Get4byte($12)|0); //@line 63403 "c/sqlite3.c"
 $14 = HEAP32[$0>>2]|0; //@line 63404 "c/sqlite3.c"
 _sqlite3PagerPagecount($14,$2); //@line 63404 "c/sqlite3.c"
 $15 = ($13|0)==(0); //@line 63405 "c/sqlite3.c"
 if ($15) {
  label = 5;
 } else {
  $16 = HEAP32[$10>>2]|0; //@line 63405 "c/sqlite3.c"
  $17 = ((($16)) + 24|0); //@line 63405 "c/sqlite3.c"
  $18 = ((($16)) + 92|0); //@line 63405 "c/sqlite3.c"
  $19 = (_memcmp($17,$18,4)|0); //@line 63405 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 63405 "c/sqlite3.c"
  if ($20) {
   $$084 = $13;
  } else {
   label = 5;
  }
 }
 if ((label|0) == 5) {
  $21 = HEAP32[$2>>2]|0; //@line 63406 "c/sqlite3.c"
  $$084 = $21;
 }
 $22 = ($$084|0)>(0); //@line 63408 "c/sqlite3.c"
 L12: do {
  if ($22) {
   $23 = HEAP32[$10>>2]|0; //@line 63411 "c/sqlite3.c"
   $24 = (_memcmp($23,18250,16)|0); //@line 63416 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 63416 "c/sqlite3.c"
   L14: do {
    if ($25) {
     $26 = ((($23)) + 18|0); //@line 63428 "c/sqlite3.c"
     $27 = HEAP8[$26>>0]|0; //@line 63428 "c/sqlite3.c"
     $28 = ($27&255)>(2); //@line 63428 "c/sqlite3.c"
     if ($28) {
      $29 = ((($0)) + 22|0); //@line 63429 "c/sqlite3.c"
      $30 = HEAP16[$29>>1]|0; //@line 63429 "c/sqlite3.c"
      $31 = $30 | 1; //@line 63429 "c/sqlite3.c"
      HEAP16[$29>>1] = $31; //@line 63429 "c/sqlite3.c"
     }
     $32 = ((($23)) + 19|0); //@line 63431 "c/sqlite3.c"
     $33 = HEAP8[$32>>0]|0; //@line 63431 "c/sqlite3.c"
     $34 = ($33&255)>(2); //@line 63431 "c/sqlite3.c"
     if ($34) {
      $$28391 = 26;
     } else {
      $35 = ($33<<24>>24)==(2); //@line 63443 "c/sqlite3.c"
      do {
       if ($35) {
        $36 = ((($0)) + 22|0); //@line 63443 "c/sqlite3.c"
        $37 = HEAP16[$36>>1]|0; //@line 63443 "c/sqlite3.c"
        $38 = $37 & 32; //@line 63443 "c/sqlite3.c"
        $39 = ($38<<16>>16)==(0); //@line 63443 "c/sqlite3.c"
        if ($39) {
         HEAP32[$3>>2] = 0; //@line 63444 "c/sqlite3.c"
         $40 = HEAP32[$0>>2]|0; //@line 63445 "c/sqlite3.c"
         $41 = (_sqlite3PagerOpenWal($40,$3)|0); //@line 63445 "c/sqlite3.c"
         $42 = ($41|0)==(0); //@line 63446 "c/sqlite3.c"
         if (!($42)) {
          $$28391 = $41;
          break L14;
         }
         $43 = HEAP32[$3>>2]|0; //@line 63450 "c/sqlite3.c"
         $44 = ($43|0)==(0); //@line 63450 "c/sqlite3.c"
         if (!($44)) {
          break;
         }
         _releasePageOne($9); //@line 63451 "c/sqlite3.c"
         $$3 = 0;
         STACKTOP = sp;return ($$3|0); //@line 63555 "c/sqlite3.c"
        }
       }
      } while(0);
      $45 = ((($23)) + 21|0); //@line 63467 "c/sqlite3.c"
      $46 = (_memcmp($45,18534,3)|0); //@line 63467 "c/sqlite3.c"
      $47 = ($46|0)==(0); //@line 63467 "c/sqlite3.c"
      if ($47) {
       $48 = ((($23)) + 16|0); //@line 63473 "c/sqlite3.c"
       $49 = HEAP8[$48>>0]|0; //@line 63473 "c/sqlite3.c"
       $50 = $49&255; //@line 63473 "c/sqlite3.c"
       $51 = $50 << 8; //@line 63473 "c/sqlite3.c"
       $52 = ((($23)) + 17|0); //@line 63473 "c/sqlite3.c"
       $53 = HEAP8[$52>>0]|0; //@line 63473 "c/sqlite3.c"
       $54 = $53&255; //@line 63473 "c/sqlite3.c"
       $55 = $54 << 16; //@line 63473 "c/sqlite3.c"
       $56 = $55 | $51; //@line 63473 "c/sqlite3.c"
       $57 = (($56) + 16777215)|0; //@line 63476 "c/sqlite3.c"
       $58 = $57 & $56; //@line 63476 "c/sqlite3.c"
       $59 = ($58|0)!=(0); //@line 63476 "c/sqlite3.c"
       $$off = (($56) + -257)|0; //@line 63477 "c/sqlite3.c"
       $60 = ($$off>>>0)>(65279); //@line 63477 "c/sqlite3.c"
       $61 = $60 | $59; //@line 63477 "c/sqlite3.c"
       if ($61) {
        $$28391 = 26;
       } else {
        $62 = ((($23)) + 20|0); //@line 63490 "c/sqlite3.c"
        $63 = HEAP8[$62>>0]|0; //@line 63490 "c/sqlite3.c"
        $64 = $63&255; //@line 63490 "c/sqlite3.c"
        $65 = (($56) - ($64))|0; //@line 63490 "c/sqlite3.c"
        $66 = ((($0)) + 32|0); //@line 63491 "c/sqlite3.c"
        $67 = HEAP32[$66>>2]|0; //@line 63491 "c/sqlite3.c"
        $68 = ($56|0)==($67|0); //@line 63491 "c/sqlite3.c"
        if (!($68)) {
         _releasePageOne($9); //@line 63498 "c/sqlite3.c"
         $69 = ((($0)) + 36|0); //@line 63499 "c/sqlite3.c"
         HEAP32[$69>>2] = $65; //@line 63499 "c/sqlite3.c"
         HEAP32[$66>>2] = $56; //@line 63500 "c/sqlite3.c"
         _freeTempSpace($0); //@line 63501 "c/sqlite3.c"
         $70 = HEAP32[$0>>2]|0; //@line 63502 "c/sqlite3.c"
         $71 = (_sqlite3PagerSetPagesize($70,$66,$64)|0); //@line 63502 "c/sqlite3.c"
         $$3 = $71;
         STACKTOP = sp;return ($$3|0); //@line 63555 "c/sqlite3.c"
        }
        $72 = ((($0)) + 4|0); //@line 63506 "c/sqlite3.c"
        $73 = HEAP32[$72>>2]|0; //@line 63506 "c/sqlite3.c"
        $74 = ((($73)) + 28|0); //@line 63506 "c/sqlite3.c"
        $75 = HEAP32[$74>>2]|0; //@line 63506 "c/sqlite3.c"
        $76 = $75 & 1; //@line 63506 "c/sqlite3.c"
        $77 = ($76|0)==(0); //@line 63506 "c/sqlite3.c"
        $78 = HEAP32[$2>>2]|0; //@line 63506 "c/sqlite3.c"
        $79 = ($$084|0)>($78|0); //@line 63506 "c/sqlite3.c"
        $or$cond = $77 & $79; //@line 63506 "c/sqlite3.c"
        if ($or$cond) {
         $80 = (_sqlite3CorruptError(63507)|0); //@line 63507 "c/sqlite3.c"
         $$28391 = $80;
         break;
        }
        $81 = ($65>>>0)<(480); //@line 63513 "c/sqlite3.c"
        if ($81) {
         $$28391 = 26;
        } else {
         HEAP32[$66>>2] = $56; //@line 63516 "c/sqlite3.c"
         $82 = ((($0)) + 36|0); //@line 63517 "c/sqlite3.c"
         HEAP32[$82>>2] = $65; //@line 63517 "c/sqlite3.c"
         $83 = ((($23)) + 52|0); //@line 63519 "c/sqlite3.c"
         $84 = (_sqlite3Get4byte($83)|0); //@line 63519 "c/sqlite3.c"
         $85 = ($84|0)!=(0); //@line 63519 "c/sqlite3.c"
         $86 = $85&1; //@line 63519 "c/sqlite3.c"
         $87 = ((($0)) + 17|0); //@line 63519 "c/sqlite3.c"
         HEAP8[$87>>0] = $86; //@line 63519 "c/sqlite3.c"
         $88 = ((($23)) + 64|0); //@line 63520 "c/sqlite3.c"
         $89 = (_sqlite3Get4byte($88)|0); //@line 63520 "c/sqlite3.c"
         $90 = ($89|0)!=(0); //@line 63520 "c/sqlite3.c"
         $91 = $90&1; //@line 63520 "c/sqlite3.c"
         $92 = ((($0)) + 18|0); //@line 63520 "c/sqlite3.c"
         HEAP8[$92>>0] = $91; //@line 63520 "c/sqlite3.c"
         break L12;
        }
       }
      } else {
       $$28391 = 26;
      }
     }
    } else {
     $$28391 = 26;
    }
   } while(0);
   _releasePageOne($9); //@line 63552 "c/sqlite3.c"
   $117 = ((($0)) + 12|0); //@line 63553 "c/sqlite3.c"
   HEAP32[$117>>2] = 0; //@line 63553 "c/sqlite3.c"
   $$3 = $$28391;
   STACKTOP = sp;return ($$3|0); //@line 63555 "c/sqlite3.c"
  }
 } while(0);
 $93 = ((($0)) + 36|0); //@line 63537 "c/sqlite3.c"
 $94 = HEAP32[$93>>2]|0; //@line 63537 "c/sqlite3.c"
 $95 = $94 << 6; //@line 63537 "c/sqlite3.c"
 $96 = (($95) + -768)|0; //@line 63537 "c/sqlite3.c"
 $97 = (($96>>>0) / 255)&-1; //@line 63537 "c/sqlite3.c"
 $98 = (($97) + 65513)|0; //@line 63537 "c/sqlite3.c"
 $99 = $98&65535; //@line 63537 "c/sqlite3.c"
 $100 = ((($0)) + 24|0); //@line 63537 "c/sqlite3.c"
 HEAP16[$100>>1] = $99; //@line 63537 "c/sqlite3.c"
 $101 = $94 << 5; //@line 63538 "c/sqlite3.c"
 $102 = (($101) + -384)|0; //@line 63538 "c/sqlite3.c"
 $103 = (($102>>>0) / 255)&-1; //@line 63538 "c/sqlite3.c"
 $104 = (($103) + 65513)|0; //@line 63538 "c/sqlite3.c"
 $105 = $104&65535; //@line 63538 "c/sqlite3.c"
 $106 = ((($0)) + 26|0); //@line 63538 "c/sqlite3.c"
 HEAP16[$106>>1] = $105; //@line 63538 "c/sqlite3.c"
 $107 = (($94) + 65501)|0; //@line 63539 "c/sqlite3.c"
 $108 = $107&65535; //@line 63539 "c/sqlite3.c"
 $109 = ((($0)) + 28|0); //@line 63539 "c/sqlite3.c"
 HEAP16[$109>>1] = $108; //@line 63539 "c/sqlite3.c"
 $110 = ((($0)) + 30|0); //@line 63540 "c/sqlite3.c"
 HEAP16[$110>>1] = $105; //@line 63540 "c/sqlite3.c"
 $111 = ($99&65535)>(127); //@line 63541 "c/sqlite3.c"
 $112 = $98&255; //@line 63544 "c/sqlite3.c"
 $$sink = $111 ? 127 : $112; //@line 63541 "c/sqlite3.c"
 $113 = ((($0)) + 21|0);
 HEAP8[$113>>0] = $$sink;
 $114 = HEAP32[$1>>2]|0; //@line 63547 "c/sqlite3.c"
 $115 = ((($0)) + 12|0); //@line 63547 "c/sqlite3.c"
 HEAP32[$115>>2] = $114; //@line 63547 "c/sqlite3.c"
 $116 = ((($0)) + 44|0); //@line 63548 "c/sqlite3.c"
 HEAP32[$116>>2] = $$084; //@line 63548 "c/sqlite3.c"
 $$3 = 0;
 STACKTOP = sp;return ($$3|0); //@line 63555 "c/sqlite3.c"
}
function _sqlite3TempInMemory($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 72|0); //@line 145594 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 145594 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(2); //@line 145594 "c/sqlite3.c"
 $4 = $3&1; //@line 145594 "c/sqlite3.c"
 return ($4|0); //@line 145594 "c/sqlite3.c"
}
function _sqlite3PagerBegin($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$028 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 40|0); //@line 53765 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 53765 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 53765 "c/sqlite3.c"
 if (!($5)) {
  $$028 = $4;
  return ($$028|0); //@line 53826 "c/sqlite3.c"
 }
 $6 = $2&255; //@line 53767 "c/sqlite3.c"
 $7 = ((($0)) + 21|0); //@line 53767 "c/sqlite3.c"
 HEAP8[$7>>0] = $6; //@line 53767 "c/sqlite3.c"
 $8 = ((($0)) + 16|0); //@line 53769 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 53769 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(1); //@line 53769 "c/sqlite3.c"
 if (!($10)) {
  $$028 = 0;
  return ($$028|0); //@line 53826 "c/sqlite3.c"
 }
 $11 = ((($0)) + 212|0); //@line 53772 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 53772 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 53772 "c/sqlite3.c"
 if ($13) {
  $24 = (_pagerLockDb($0,2)|0); //@line 53796 "c/sqlite3.c"
  $25 = ($24|0)==(0); //@line 53797 "c/sqlite3.c"
  $26 = ($1|0)!=(0); //@line 53797 "c/sqlite3.c"
  $or$cond = $26 & $25; //@line 53797 "c/sqlite3.c"
  if ($or$cond) {
   $27 = (_pager_wait_on_lock($0,4)|0); //@line 53798 "c/sqlite3.c"
   $$0 = $27;
  } else {
   $$0 = $24;
  }
 } else {
  $14 = ((($0)) + 4|0); //@line 53776 "c/sqlite3.c"
  $15 = HEAP8[$14>>0]|0; //@line 53776 "c/sqlite3.c"
  $16 = ($15<<24>>24)==(0); //@line 53776 "c/sqlite3.c"
  do {
   if (!($16)) {
    $17 = (_sqlite3WalExclusiveMode($12,-1)|0); //@line 53776 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 53776 "c/sqlite3.c"
    if (!($18)) {
     $19 = (_pagerLockDb($0,4)|0); //@line 53777 "c/sqlite3.c"
     $20 = ($19|0)==(0); //@line 53778 "c/sqlite3.c"
     if ($20) {
      $21 = HEAP32[$11>>2]|0; //@line 53781 "c/sqlite3.c"
      (_sqlite3WalExclusiveMode($21,1)|0); //@line 53781 "c/sqlite3.c"
      break;
     } else {
      $$028 = $19;
      return ($$028|0); //@line 53826 "c/sqlite3.c"
     }
    }
   }
  } while(0);
  $22 = HEAP32[$11>>2]|0; //@line 53789 "c/sqlite3.c"
  $23 = (_sqlite3WalBeginWriteTransaction($22)|0); //@line 53789 "c/sqlite3.c"
  $$0 = $23;
 }
 $28 = ($$0|0)==(0); //@line 53802 "c/sqlite3.c"
 if (!($28)) {
  $$028 = $$0;
  return ($$028|0); //@line 53826 "c/sqlite3.c"
 }
 HEAP8[$8>>0] = 2; //@line 53812 "c/sqlite3.c"
 $29 = ((($0)) + 24|0); //@line 53813 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 53813 "c/sqlite3.c"
 $31 = ((($0)) + 36|0); //@line 53813 "c/sqlite3.c"
 HEAP32[$31>>2] = $30; //@line 53813 "c/sqlite3.c"
 $32 = ((($0)) + 32|0); //@line 53814 "c/sqlite3.c"
 HEAP32[$32>>2] = $30; //@line 53814 "c/sqlite3.c"
 $33 = ((($0)) + 28|0); //@line 53815 "c/sqlite3.c"
 HEAP32[$33>>2] = $30; //@line 53815 "c/sqlite3.c"
 $34 = ((($0)) + 72|0); //@line 53816 "c/sqlite3.c"
 $35 = $34; //@line 53816 "c/sqlite3.c"
 $36 = $35; //@line 53816 "c/sqlite3.c"
 HEAP32[$36>>2] = 0; //@line 53816 "c/sqlite3.c"
 $37 = (($35) + 4)|0; //@line 53816 "c/sqlite3.c"
 $38 = $37; //@line 53816 "c/sqlite3.c"
 HEAP32[$38>>2] = 0; //@line 53816 "c/sqlite3.c"
 $$028 = 0;
 return ($$028|0); //@line 53826 "c/sqlite3.c"
}
function _btreeInvokeBusyHandler($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 62637 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62637 "c/sqlite3.c"
 $3 = ((($2)) + 388|0); //@line 62637 "c/sqlite3.c"
 $4 = (_sqlite3InvokeBusyHandler($3)|0); //@line 62637 "c/sqlite3.c"
 return ($4|0); //@line 62637 "c/sqlite3.c"
}
function _sqlite3PagerOpenSavepoint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 96|0); //@line 54782 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 54782 "c/sqlite3.c"
 $4 = ($3|0)<($1|0); //@line 54782 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 6|0); //@line 54782 "c/sqlite3.c"
  $6 = HEAP8[$5>>0]|0; //@line 54782 "c/sqlite3.c"
  $7 = ($6<<24>>24)==(0); //@line 54782 "c/sqlite3.c"
  if ($7) {
   $$0 = 0;
  } else {
   $8 = (_pagerOpenSavepoint($0,$1)|0); //@line 54783 "c/sqlite3.c"
   $$0 = $8;
  }
 } else {
  $$0 = 0;
 }
 return ($$0|0); //@line 54787 "c/sqlite3.c"
}
function _pagerOpenSavepoint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$04748 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 96|0); //@line 54735 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 54735 "c/sqlite3.c"
 $4 = ((($0)) + 92|0); //@line 54748 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 54748 "c/sqlite3.c"
 $6 = ($1*48)|0; //@line 54748 "c/sqlite3.c"
 $7 = (_sqlite3Realloc($5,$6,0)|0); //@line 54747 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 54750 "c/sqlite3.c"
 if ($8) {
  $$0 = 7;
  return ($$0|0); //@line 54777 "c/sqlite3.c"
 }
 $9 = (($7) + (($3*48)|0)|0); //@line 54753 "c/sqlite3.c"
 $10 = (($1) - ($3))|0; //@line 54753 "c/sqlite3.c"
 $11 = ($10*48)|0; //@line 54753 "c/sqlite3.c"
 _memset(($9|0),0,($11|0))|0; //@line 54753 "c/sqlite3.c"
 HEAP32[$4>>2] = $7; //@line 54754 "c/sqlite3.c"
 $12 = ($3|0)<($1|0); //@line 54757 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 0;
  return ($$0|0); //@line 54777 "c/sqlite3.c"
 }
 $13 = ((($0)) + 24|0);
 $14 = ((($0)) + 64|0);
 $15 = ((($0)) + 148|0);
 $16 = ((($0)) + 52|0);
 $17 = ((($0)) + 72|0);
 $18 = ((($0)) + 212|0);
 $$04748 = $3;
 while(1) {
  $19 = HEAP32[$13>>2]|0; //@line 54758 "c/sqlite3.c"
  $20 = (((($7) + (($$04748*48)|0)|0)) + 20|0); //@line 54758 "c/sqlite3.c"
  HEAP32[$20>>2] = $19; //@line 54758 "c/sqlite3.c"
  $21 = HEAP32[$14>>2]|0; //@line 54759 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 54759 "c/sqlite3.c"
  $23 = ($22|0)==(0|0); //@line 54759 "c/sqlite3.c"
  if ($23) {
   label = 6;
  } else {
   $24 = $17; //@line 54759 "c/sqlite3.c"
   $25 = $24; //@line 54759 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 54759 "c/sqlite3.c"
   $27 = (($24) + 4)|0; //@line 54759 "c/sqlite3.c"
   $28 = $27; //@line 54759 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 54759 "c/sqlite3.c"
   $30 = ($29|0)>(0); //@line 54759 "c/sqlite3.c"
   $31 = ($26>>>0)>(0); //@line 54759 "c/sqlite3.c"
   $32 = ($29|0)==(0); //@line 54759 "c/sqlite3.c"
   $33 = $32 & $31; //@line 54759 "c/sqlite3.c"
   $34 = $30 | $33; //@line 54759 "c/sqlite3.c"
   if ($34) {
    $39 = $26;$42 = $29;
   } else {
    label = 6;
   }
  }
  if ((label|0) == 6) {
   label = 0;
   $35 = HEAP32[$15>>2]|0; //@line 54762 "c/sqlite3.c"
   $39 = $35;$42 = 0;
  }
  $36 = (($7) + (($$04748*48)|0)|0);
  $37 = $36;
  $38 = $37;
  HEAP32[$38>>2] = $39;
  $40 = (($37) + 4)|0;
  $41 = $40;
  HEAP32[$41>>2] = $42;
  $43 = HEAP32[$16>>2]|0; //@line 54764 "c/sqlite3.c"
  $44 = (((($7) + (($$04748*48)|0)|0)) + 24|0); //@line 54764 "c/sqlite3.c"
  HEAP32[$44>>2] = $43; //@line 54764 "c/sqlite3.c"
  $45 = (_sqlite3BitvecCreate($19)|0); //@line 54765 "c/sqlite3.c"
  $46 = (((($7) + (($$04748*48)|0)|0)) + 16|0); //@line 54765 "c/sqlite3.c"
  HEAP32[$46>>2] = $45; //@line 54765 "c/sqlite3.c"
  $47 = ($45|0)==(0|0); //@line 54766 "c/sqlite3.c"
  if ($47) {
   $$0 = 7;
   label = 11;
   break;
  }
  $48 = HEAP32[$18>>2]|0; //@line 54769 "c/sqlite3.c"
  $49 = ($48|0)==(0|0); //@line 54769 "c/sqlite3.c"
  if (!($49)) {
   $50 = (((($7) + (($$04748*48)|0)|0)) + 28|0); //@line 54770 "c/sqlite3.c"
   _sqlite3WalSavepoint($48,$50); //@line 54770 "c/sqlite3.c"
  }
  $51 = (($$04748) + 1)|0; //@line 54772 "c/sqlite3.c"
  HEAP32[$2>>2] = $51; //@line 54772 "c/sqlite3.c"
  $52 = ($51|0)<($1|0); //@line 54757 "c/sqlite3.c"
  if ($52) {
   $$04748 = $51;
  } else {
   $$0 = 0;
   label = 11;
   break;
  }
 }
 if ((label|0) == 11) {
  return ($$0|0); //@line 54777 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3WalSavepoint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 68|0); //@line 58667 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 58667 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 58667 "c/sqlite3.c"
 $4 = ((($0)) + 76|0); //@line 58668 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 58668 "c/sqlite3.c"
 $6 = ((($1)) + 4|0); //@line 58668 "c/sqlite3.c"
 HEAP32[$6>>2] = $5; //@line 58668 "c/sqlite3.c"
 $7 = ((($0)) + 80|0); //@line 58669 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 58669 "c/sqlite3.c"
 $9 = ((($1)) + 8|0); //@line 58669 "c/sqlite3.c"
 HEAP32[$9>>2] = $8; //@line 58669 "c/sqlite3.c"
 $10 = ((($0)) + 112|0); //@line 58670 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 58670 "c/sqlite3.c"
 $12 = ((($1)) + 12|0); //@line 58670 "c/sqlite3.c"
 HEAP32[$12>>2] = $11; //@line 58670 "c/sqlite3.c"
 return; //@line 58671 "c/sqlite3.c"
}
function _sqlite3InvokeBusyHandler($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 144878 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
  return ($$0|0); //@line 144886 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 144878 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 144878 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  return ($$0|0); //@line 144886 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0); //@line 144878 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 144878 "c/sqlite3.c"
 $6 = ($5|0)<(0); //@line 144878 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;
  return ($$0|0); //@line 144886 "c/sqlite3.c"
 }
 $7 = ((($0)) + 4|0); //@line 144879 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 144879 "c/sqlite3.c"
 $9 = (FUNCTION_TABLE_iii[$2 & 255]($8,$5)|0); //@line 144879 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 144880 "c/sqlite3.c"
 if ($10) {
  $storemerge = -1;
 } else {
  $11 = HEAP32[$4>>2]|0; //@line 144883 "c/sqlite3.c"
  $12 = (($11) + 1)|0; //@line 144883 "c/sqlite3.c"
  $storemerge = $12;
 }
 HEAP32[$4>>2] = $storemerge;
 $$0 = $9;
 return ($$0|0); //@line 144886 "c/sqlite3.c"
}
function _sqlite3WalBeginWriteTransaction($0) {
 $0 = $0|0;
 var $$011 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 46|0); //@line 58573 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 58573 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 58573 "c/sqlite3.c"
 if (!($3)) {
  $$011 = 8;
  return ($$011|0); //@line 58597 "c/sqlite3.c"
 }
 $4 = (_walLockExclusive($0,0,1)|0); //@line 58580 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 58581 "c/sqlite3.c"
 if (!($5)) {
  $$011 = $4;
  return ($$011|0); //@line 58597 "c/sqlite3.c"
 }
 $6 = ((($0)) + 44|0); //@line 58584 "c/sqlite3.c"
 HEAP8[$6>>0] = 1; //@line 58584 "c/sqlite3.c"
 $7 = ((($0)) + 52|0); //@line 58590 "c/sqlite3.c"
 $8 = (_walIndexHdr($0)|0); //@line 58590 "c/sqlite3.c"
 $9 = (_memcmp($7,$8,48)|0); //@line 58590 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 58590 "c/sqlite3.c"
 if ($10) {
  $$011 = 0;
  return ($$011|0); //@line 58597 "c/sqlite3.c"
 }
 _walUnlockExclusive($0,0,1); //@line 58591 "c/sqlite3.c"
 HEAP8[$6>>0] = 0; //@line 58592 "c/sqlite3.c"
 $$011 = 517;
 return ($$011|0); //@line 58597 "c/sqlite3.c"
}
function _sqlite3PagerSharedLock($0) {
 $0 = $0|0;
 var $$162 = 0, $$2 = 0, $$3 = 0, $$4 = 0, $$464 = 0, $$5$ph = 0, $$6$ph = 0, $$7 = 0, $$8 = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $1 = sp + 24|0;
 $2 = sp + 8|0;
 $3 = sp;
 $4 = ((($0)) + 212|0); //@line 53124 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 53124 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 53124 "c/sqlite3.c"
 L1: do {
  if ($6) {
   $7 = ((($0)) + 16|0); //@line 53124 "c/sqlite3.c"
   $8 = HEAP8[$7>>0]|0; //@line 53124 "c/sqlite3.c"
   $9 = ($8<<24>>24)==(0); //@line 53124 "c/sqlite3.c"
   L3: do {
    if ($9) {
     HEAP32[$1>>2] = 1; //@line 53125 "c/sqlite3.c"
     $10 = (_pager_wait_on_lock($0,1)|0); //@line 53130 "c/sqlite3.c"
     $11 = ($10|0)==(0); //@line 53131 "c/sqlite3.c"
     L5: do {
      if ($11) {
       $12 = ((($0)) + 17|0); //@line 53139 "c/sqlite3.c"
       $13 = HEAP8[$12>>0]|0; //@line 53139 "c/sqlite3.c"
       $14 = ($13&255)<(2); //@line 53139 "c/sqlite3.c"
       if ($14) {
        $15 = (_hasHotJournal($0,$1)|0); //@line 53140 "c/sqlite3.c"
        $16 = ($15|0)==(0); //@line 53142 "c/sqlite3.c"
        if (!($16)) {
         $$5$ph = $15;
         break;
        }
       }
       $17 = HEAP32[$1>>2]|0; //@line 53145 "c/sqlite3.c"
       $18 = ($17|0)==(0); //@line 53145 "c/sqlite3.c"
       do {
        if (!($18)) {
         $19 = ((($0)) + 14|0); //@line 53146 "c/sqlite3.c"
         $20 = HEAP8[$19>>0]|0; //@line 53146 "c/sqlite3.c"
         $21 = ($20<<24>>24)==(0); //@line 53146 "c/sqlite3.c"
         if (!($21)) {
          $$5$ph = 776;
          break L5;
         }
         $22 = (_pagerLockDb($0,4)|0); //@line 53166 "c/sqlite3.c"
         $23 = ($22|0)==(0); //@line 53167 "c/sqlite3.c"
         if (!($23)) {
          $$5$ph = $22;
          break L5;
         }
         $24 = ((($0)) + 64|0); //@line 53184 "c/sqlite3.c"
         $25 = HEAP32[$24>>2]|0; //@line 53184 "c/sqlite3.c"
         $26 = HEAP32[$25>>2]|0; //@line 53184 "c/sqlite3.c"
         $27 = ($26|0)==(0|0); //@line 53184 "c/sqlite3.c"
         if ($27) {
          $28 = HEAP32[$0>>2]|0; //@line 53185 "c/sqlite3.c"
          $29 = ((($0)) + 172|0); //@line 53188 "c/sqlite3.c"
          $30 = HEAP32[$29>>2]|0; //@line 53188 "c/sqlite3.c"
          $31 = (_sqlite3OsAccess($28,$30,0,$2)|0); //@line 53187 "c/sqlite3.c"
          $32 = ($31|0)==(0); //@line 53189 "c/sqlite3.c"
          $33 = HEAP32[$2>>2]|0; //@line 53189 "c/sqlite3.c"
          $34 = ($33|0)!=(0); //@line 53189 "c/sqlite3.c"
          $or$cond = $32 & $34; //@line 53189 "c/sqlite3.c"
          if ($or$cond) {
           HEAP32[$3>>2] = 0; //@line 53190 "c/sqlite3.c"
           $35 = HEAP32[$29>>2]|0; //@line 53193 "c/sqlite3.c"
           $36 = HEAP32[$24>>2]|0; //@line 53193 "c/sqlite3.c"
           $37 = (_sqlite3OsOpen($28,$35,$36,2050,$3)|0); //@line 53193 "c/sqlite3.c"
           $38 = ($37|0)==(0); //@line 53195 "c/sqlite3.c"
           if ($38) {
            $39 = HEAP32[$3>>2]|0; //@line 53195 "c/sqlite3.c"
            $40 = $39 & 1; //@line 53195 "c/sqlite3.c"
            $41 = ($40|0)==(0); //@line 53195 "c/sqlite3.c"
            if ($41) {
             $$162 = 0;
            } else {
             $42 = (_sqlite3CantopenError(53196)|0); //@line 53196 "c/sqlite3.c"
             $43 = HEAP32[$24>>2]|0; //@line 53197 "c/sqlite3.c"
             _sqlite3OsClose($43); //@line 53197 "c/sqlite3.c"
             $$162 = $42;
            }
           } else {
            $$162 = $37;
           }
           $$2 = $$162;
          } else {
           $$2 = $31;
          }
          $$3 = $$2;
         } else {
          $$3 = 0;
         }
         $44 = HEAP32[$24>>2]|0; //@line 53210 "c/sqlite3.c"
         $45 = HEAP32[$44>>2]|0; //@line 53210 "c/sqlite3.c"
         $46 = ($45|0)==(0|0); //@line 53210 "c/sqlite3.c"
         if ($46) {
          $54 = ((($0)) + 4|0); //@line 53217 "c/sqlite3.c"
          $55 = HEAP8[$54>>0]|0; //@line 53217 "c/sqlite3.c"
          $56 = ($55<<24>>24)==(0); //@line 53217 "c/sqlite3.c"
          if ($56) {
           (_pagerUnlockDb($0,1)|0); //@line 53218 "c/sqlite3.c"
           $$4 = $$3;
           label = 21;
          } else {
           $$4 = $$3;
           label = 21;
          }
         } else {
          $47 = (_pagerSyncHotJournal($0)|0); //@line 53212 "c/sqlite3.c"
          $48 = ($47|0)==(0); //@line 53213 "c/sqlite3.c"
          if ($48) {
           $49 = ((($0)) + 12|0); //@line 53214 "c/sqlite3.c"
           $50 = HEAP8[$49>>0]|0; //@line 53214 "c/sqlite3.c"
           $51 = ($50<<24>>24)==(0); //@line 53214 "c/sqlite3.c"
           $52 = $51&1; //@line 53214 "c/sqlite3.c"
           $53 = (_pager_playback($0,$52)|0); //@line 53214 "c/sqlite3.c"
           HEAP8[$7>>0] = 0; //@line 53215 "c/sqlite3.c"
           $$4 = $53;
           label = 21;
          } else {
           $$464 = $47;
          }
         }
         if ((label|0) == 21) {
          $57 = ($$4|0)==(0); //@line 53221 "c/sqlite3.c"
          if ($57) {
           break;
          } else {
           $$464 = $$4;
          }
         }
         (_pager_error($0,$$464)|0); //@line 53238 "c/sqlite3.c"
         $$5$ph = $$464;
         break L5;
        }
       } while(0);
       $58 = ((($0)) + 12|0); //@line 53248 "c/sqlite3.c"
       $59 = HEAP8[$58>>0]|0; //@line 53248 "c/sqlite3.c"
       $60 = ($59<<24>>24)==(0); //@line 53248 "c/sqlite3.c"
       if ($60) {
        $61 = ((($0)) + 23|0); //@line 53248 "c/sqlite3.c"
        $62 = HEAP8[$61>>0]|0; //@line 53248 "c/sqlite3.c"
        $63 = ($62<<24>>24)==(0); //@line 53248 "c/sqlite3.c"
        if (!($63)) {
         $64 = ((($0)) + 60|0); //@line 53268 "c/sqlite3.c"
         $65 = HEAP32[$64>>2]|0; //@line 53268 "c/sqlite3.c"
         $66 = (_sqlite3OsRead($65,$2,16,24,0)|0); //@line 53268 "c/sqlite3.c"
         switch ($66|0) {
         case 0:  {
          break;
         }
         case 522:  {
          dest=$2; stop=dest+16|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 53273 "c/sqlite3.c"
          break;
         }
         default: {
          $$5$ph = $66;
          break L5;
         }
         }
         $67 = ((($0)) + 104|0); //@line 53276 "c/sqlite3.c"
         $68 = (_memcmp($67,$2,16)|0); //@line 53276 "c/sqlite3.c"
         $69 = ($68|0)==(0); //@line 53276 "c/sqlite3.c"
         if (!($69)) {
          _pager_reset($0); //@line 53277 "c/sqlite3.c"
         }
        }
       }
       $70 = (_pagerOpenWalIfPresent($0)|0); //@line 53294 "c/sqlite3.c"
       $$6$ph = $70;
       break L3;
      } else {
       $$5$ph = $10;
      }
     } while(0);
     $$8 = $$5$ph;
     break L1;
    } else {
     $$6$ph = 0;
    }
   } while(0);
   $$pr = HEAP32[$4>>2]|0; //@line 53300 "c/sqlite3.c"
   $71 = ($$pr|0)==(0|0); //@line 53300 "c/sqlite3.c"
   if ($71) {
    $$7 = $$6$ph;
    label = 35;
   } else {
    label = 34;
   }
  } else {
   label = 34;
  }
 } while(0);
 if ((label|0) == 34) {
  $72 = (_pagerBeginReadTransaction($0)|0); //@line 53302 "c/sqlite3.c"
  $$7 = $72;
  label = 35;
 }
 if ((label|0) == 35) {
  $73 = ((($0)) + 12|0); //@line 53305 "c/sqlite3.c"
  $74 = HEAP8[$73>>0]|0; //@line 53305 "c/sqlite3.c"
  $75 = ($74<<24>>24)==(0); //@line 53305 "c/sqlite3.c"
  if ($75) {
   $76 = ((($0)) + 16|0); //@line 53305 "c/sqlite3.c"
   $77 = HEAP8[$76>>0]|0; //@line 53305 "c/sqlite3.c"
   $78 = ($77<<24>>24)==(0); //@line 53305 "c/sqlite3.c"
   $79 = ($$7|0)==(0); //@line 53305 "c/sqlite3.c"
   $or$cond3 = $79 & $78; //@line 53305 "c/sqlite3.c"
   if ($or$cond3) {
    $80 = ((($0)) + 24|0); //@line 53306 "c/sqlite3.c"
    $81 = (_pagerPagecount($0,$80)|0); //@line 53306 "c/sqlite3.c"
    $$8 = $81;
   } else {
    $$8 = $$7;
   }
  } else {
   $$8 = $$7;
  }
 }
 $82 = ($$8|0)==(0); //@line 53310 "c/sqlite3.c"
 if ($82) {
  $83 = ((($0)) + 16|0); //@line 53315 "c/sqlite3.c"
  HEAP8[$83>>0] = 1; //@line 53315 "c/sqlite3.c"
  $84 = ((($0)) + 23|0); //@line 53316 "c/sqlite3.c"
  HEAP8[$84>>0] = 1; //@line 53316 "c/sqlite3.c"
  STACKTOP = sp;return ($$8|0); //@line 53319 "c/sqlite3.c"
 } else {
  _pager_unlock($0); //@line 53312 "c/sqlite3.c"
  STACKTOP = sp;return ($$8|0); //@line 53319 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3PagerOpenWal($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$011 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 55475 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 55475 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 55475 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 212|0); //@line 55475 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 55475 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 55475 "c/sqlite3.c"
  if ($7) {
   $8 = (_sqlite3PagerWalSupported($0)|0); //@line 55476 "c/sqlite3.c"
   $9 = ($8|0)==(0); //@line 55476 "c/sqlite3.c"
   if ($9) {
    $$011 = 14;
    return ($$011|0); //@line 55491 "c/sqlite3.c"
   }
   $10 = ((($0)) + 64|0); //@line 55479 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 55479 "c/sqlite3.c"
   _sqlite3OsClose($11); //@line 55479 "c/sqlite3.c"
   $12 = (_pagerOpenWal($0)|0); //@line 55481 "c/sqlite3.c"
   $13 = ($12|0)==(0); //@line 55482 "c/sqlite3.c"
   if (!($13)) {
    $$011 = $12;
    return ($$011|0); //@line 55491 "c/sqlite3.c"
   }
   $14 = ((($0)) + 5|0); //@line 55483 "c/sqlite3.c"
   HEAP8[$14>>0] = 5; //@line 55483 "c/sqlite3.c"
   $15 = ((($0)) + 16|0); //@line 55484 "c/sqlite3.c"
   HEAP8[$15>>0] = 0; //@line 55484 "c/sqlite3.c"
   $$011 = 0;
   return ($$011|0); //@line 55491 "c/sqlite3.c"
  }
 }
 HEAP32[$1>>2] = 1; //@line 55487 "c/sqlite3.c"
 $$011 = 0;
 return ($$011|0); //@line 55491 "c/sqlite3.c"
}
function _sqlite3PagerWalSupported($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 60|0); //@line 55389 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 55389 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 55389 "c/sqlite3.c"
 $4 = ((($0)) + 13|0); //@line 55390 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 55390 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 55390 "c/sqlite3.c"
 if (!($6)) {
  $$0 = 0;
  return ($$0|0); //@line 55392 "c/sqlite3.c"
 }
 $7 = ((($0)) + 4|0); //@line 55391 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 55391 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 55391 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 1;
  return ($$0|0); //@line 55392 "c/sqlite3.c"
 }
 $10 = HEAP32[$3>>2]|0; //@line 55391 "c/sqlite3.c"
 $11 = ($10|0)>(1); //@line 55391 "c/sqlite3.c"
 if (!($11)) {
  $$0 = 0;
  return ($$0|0); //@line 55392 "c/sqlite3.c"
 }
 $12 = ((($3)) + 52|0); //@line 55391 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 55391 "c/sqlite3.c"
 $14 = ($13|0)!=(0|0); //@line 55391 "c/sqlite3.c"
 $phitmp = $14&1;
 $$0 = $phitmp;
 return ($$0|0); //@line 55392 "c/sqlite3.c"
}
function _pagerOpenWal($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 55429 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 55429 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 55429 "c/sqlite3.c"
 if (!($3)) {
  $4 = (_pagerExclusiveLock($0)|0); //@line 55430 "c/sqlite3.c"
  $5 = ($4|0)==(0); //@line 55436 "c/sqlite3.c"
  if (!($5)) {
   $$1 = $4;
   return ($$1|0); //@line 55444 "c/sqlite3.c"
  }
 }
 $6 = HEAP32[$0>>2]|0; //@line 55437 "c/sqlite3.c"
 $7 = ((($0)) + 60|0); //@line 55438 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 55438 "c/sqlite3.c"
 $9 = ((($0)) + 216|0); //@line 55438 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 55438 "c/sqlite3.c"
 $11 = HEAP8[$1>>0]|0; //@line 55438 "c/sqlite3.c"
 $12 = $11&255; //@line 55438 "c/sqlite3.c"
 $13 = ((($0)) + 160|0); //@line 55439 "c/sqlite3.c"
 $14 = $13; //@line 55439 "c/sqlite3.c"
 $15 = $14; //@line 55439 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 55439 "c/sqlite3.c"
 $17 = (($14) + 4)|0; //@line 55439 "c/sqlite3.c"
 $18 = $17; //@line 55439 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 55439 "c/sqlite3.c"
 $20 = ((($0)) + 212|0); //@line 55439 "c/sqlite3.c"
 $21 = (_sqlite3WalOpen($6,$8,$10,$12,$16,$19,$20)|0); //@line 55437 "c/sqlite3.c"
 $$1 = $21;
 return ($$1|0); //@line 55444 "c/sqlite3.c"
}
function _pagerExclusiveLock($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_pagerLockDb($0,4)|0); //@line 55402 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 55403 "c/sqlite3.c"
 if (!($2)) {
  (_pagerUnlockDb($0,1)|0); //@line 55406 "c/sqlite3.c"
 }
 return ($1|0); //@line 55409 "c/sqlite3.c"
}
function _sqlite3WalOpen($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $7 = sp;
 HEAP32[$6>>2] = 0; //@line 56941 "c/sqlite3.c"
 $8 = ((($0)) + 4|0); //@line 56942 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 56942 "c/sqlite3.c"
 $10 = (($9) + 120)|0; //@line 56942 "c/sqlite3.c"
 $11 = (_sqlite3MallocZero($10,0)|0); //@line 56942 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 56943 "c/sqlite3.c"
 if ($12) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 56978 "c/sqlite3.c"
 }
 HEAP32[$11>>2] = $0; //@line 56947 "c/sqlite3.c"
 $13 = ((($11)) + 120|0); //@line 56948 "c/sqlite3.c"
 $14 = ((($11)) + 8|0); //@line 56948 "c/sqlite3.c"
 HEAP32[$14>>2] = $13; //@line 56948 "c/sqlite3.c"
 $15 = ((($11)) + 4|0); //@line 56949 "c/sqlite3.c"
 HEAP32[$15>>2] = $1; //@line 56949 "c/sqlite3.c"
 $16 = ((($11)) + 40|0); //@line 56950 "c/sqlite3.c"
 HEAP16[$16>>1] = -1; //@line 56950 "c/sqlite3.c"
 $17 = ((($11)) + 16|0); //@line 56951 "c/sqlite3.c"
 $18 = $17; //@line 56951 "c/sqlite3.c"
 $19 = $18; //@line 56951 "c/sqlite3.c"
 HEAP32[$19>>2] = $4; //@line 56951 "c/sqlite3.c"
 $20 = (($18) + 4)|0; //@line 56951 "c/sqlite3.c"
 $21 = $20; //@line 56951 "c/sqlite3.c"
 HEAP32[$21>>2] = $5; //@line 56951 "c/sqlite3.c"
 $22 = ((($11)) + 108|0); //@line 56952 "c/sqlite3.c"
 HEAP32[$22>>2] = $2; //@line 56952 "c/sqlite3.c"
 $23 = ((($11)) + 48|0); //@line 56953 "c/sqlite3.c"
 HEAP8[$23>>0] = 1; //@line 56953 "c/sqlite3.c"
 $24 = ((($11)) + 49|0); //@line 56954 "c/sqlite3.c"
 HEAP8[$24>>0] = 1; //@line 56954 "c/sqlite3.c"
 $25 = ($3|0)==(0); //@line 56955 "c/sqlite3.c"
 $26 = $25 ? 0 : 2; //@line 56955 "c/sqlite3.c"
 $27 = ((($11)) + 43|0); //@line 56955 "c/sqlite3.c"
 HEAP8[$27>>0] = $26; //@line 56955 "c/sqlite3.c"
 HEAP32[$7>>2] = 524294; //@line 56958 "c/sqlite3.c"
 $28 = HEAP32[$14>>2]|0; //@line 56959 "c/sqlite3.c"
 $29 = (_sqlite3OsOpen($0,$2,$28,524294,$7)|0); //@line 56959 "c/sqlite3.c"
 $cond = ($29|0)==(0); //@line 56960 "c/sqlite3.c"
 if (!($cond)) {
  _walIndexClose($11,0); //@line 56965 "c/sqlite3.c"
  $34 = HEAP32[$14>>2]|0; //@line 56966 "c/sqlite3.c"
  _sqlite3OsClose($34); //@line 56966 "c/sqlite3.c"
  _sqlite3_free($11); //@line 56967 "c/sqlite3.c"
  $$0 = $29;
  STACKTOP = sp;return ($$0|0); //@line 56978 "c/sqlite3.c"
 }
 $30 = HEAP32[$7>>2]|0; //@line 56960 "c/sqlite3.c"
 $31 = $30 & 1; //@line 56960 "c/sqlite3.c"
 $32 = ($31|0)==(0); //@line 56960 "c/sqlite3.c"
 if (!($32)) {
  $33 = ((($11)) + 46|0); //@line 56961 "c/sqlite3.c"
  HEAP8[$33>>0] = 1; //@line 56961 "c/sqlite3.c"
 }
 $35 = (_sqlite3OsDeviceCharacteristics($1)|0); //@line 56969 "c/sqlite3.c"
 $36 = $35 & 1024; //@line 56970 "c/sqlite3.c"
 $37 = ($36|0)==(0); //@line 56970 "c/sqlite3.c"
 if (!($37)) {
  HEAP8[$23>>0] = 0; //@line 56970 "c/sqlite3.c"
 }
 $38 = $35 & 4096; //@line 56971 "c/sqlite3.c"
 $39 = ($38|0)==(0); //@line 56971 "c/sqlite3.c"
 if (!($39)) {
  HEAP8[$24>>0] = 0; //@line 56972 "c/sqlite3.c"
 }
 HEAP32[$6>>2] = $11; //@line 56974 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 56978 "c/sqlite3.c"
}
function _hasHotJournal($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$2 = 0, $$3 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond5 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 12|0;
 $3 = sp + 8|0;
 $4 = sp + 4|0;
 $5 = sp;
 $6 = HEAP32[$0>>2]|0; //@line 52993 "c/sqlite3.c"
 HEAP32[$2>>2] = 1; //@line 52995 "c/sqlite3.c"
 $7 = ((($0)) + 64|0); //@line 52996 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 52996 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 52996 "c/sqlite3.c"
 $10 = ($9|0)!=(0|0); //@line 52996 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 53006 "c/sqlite3.c"
 if ($10) {
  $$0 = 0;
 } else {
  $11 = ((($0)) + 172|0); //@line 53008 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 53008 "c/sqlite3.c"
  $13 = (_sqlite3OsAccess($6,$12,0,$2)|0); //@line 53008 "c/sqlite3.c"
  $$0 = $13;
 }
 $14 = ($$0|0)==(0); //@line 53010 "c/sqlite3.c"
 $15 = HEAP32[$2>>2]|0; //@line 53010 "c/sqlite3.c"
 $16 = ($15|0)!=(0); //@line 53010 "c/sqlite3.c"
 $or$cond = $14 & $16; //@line 53010 "c/sqlite3.c"
 if (!($or$cond)) {
  $$4 = $$0;
  STACKTOP = sp;return ($$4|0); //@line 53082 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = 0; //@line 53011 "c/sqlite3.c"
 $17 = ((($0)) + 60|0); //@line 53021 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 53021 "c/sqlite3.c"
 $19 = (_sqlite3OsCheckReservedLock($18,$3)|0); //@line 53021 "c/sqlite3.c"
 $20 = HEAP32[$3>>2]|0; //@line 53022 "c/sqlite3.c"
 $21 = $20 | $19; //@line 53022 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 53022 "c/sqlite3.c"
 if ($22) {
  $23 = (_pagerPagecount($0,$4)|0); //@line 53026 "c/sqlite3.c"
  $24 = ($23|0)==(0); //@line 53027 "c/sqlite3.c"
  L9: do {
   if ($24) {
    $25 = HEAP32[$4>>2]|0; //@line 53036 "c/sqlite3.c"
    $26 = ($25|0)!=(0); //@line 53036 "c/sqlite3.c"
    $or$cond5 = $10 | $26; //@line 53036 "c/sqlite3.c"
    if (!($or$cond5)) {
     _sqlite3BeginBenignMalloc(); //@line 53037 "c/sqlite3.c"
     $27 = (_pagerLockDb($0,2)|0); //@line 53038 "c/sqlite3.c"
     $28 = ($27|0)==(0); //@line 53038 "c/sqlite3.c"
     if ($28) {
      $29 = ((($0)) + 172|0); //@line 53039 "c/sqlite3.c"
      $30 = HEAP32[$29>>2]|0; //@line 53039 "c/sqlite3.c"
      (_sqlite3OsDelete($6,$30,0)|0); //@line 53039 "c/sqlite3.c"
      $31 = ((($0)) + 4|0); //@line 53040 "c/sqlite3.c"
      $32 = HEAP8[$31>>0]|0; //@line 53040 "c/sqlite3.c"
      $33 = ($32<<24>>24)==(0); //@line 53040 "c/sqlite3.c"
      if ($33) {
       (_pagerUnlockDb($0,1)|0); //@line 53040 "c/sqlite3.c"
      }
     }
     _sqlite3EndBenignMalloc(); //@line 53042 "c/sqlite3.c"
     $$2 = 0;
     break;
    }
    L18: do {
     if (!($10)) {
      HEAP32[$5>>2] = 2049; //@line 53051 "c/sqlite3.c"
      $34 = ((($0)) + 172|0); //@line 53052 "c/sqlite3.c"
      $35 = HEAP32[$34>>2]|0; //@line 53052 "c/sqlite3.c"
      $36 = HEAP32[$7>>2]|0; //@line 53052 "c/sqlite3.c"
      $37 = (_sqlite3OsOpen($6,$35,$36,2049,$5)|0); //@line 53052 "c/sqlite3.c"
      switch ($37|0) {
      case 0:  {
       break L18;
       break;
      }
      case 14:  {
       break;
      }
      default: {
       $$2 = $37;
       break L9;
      }
      }
      HEAP32[$1>>2] = 1; //@line 53074 "c/sqlite3.c"
      $$2 = 0;
      break L9;
     }
    } while(0);
    HEAP8[$5>>0] = 0; //@line 53055 "c/sqlite3.c"
    $38 = HEAP32[$7>>2]|0; //@line 53056 "c/sqlite3.c"
    $39 = (_sqlite3OsRead($38,$5,1,0,0)|0); //@line 53056 "c/sqlite3.c"
    $40 = ($39|0)==(522); //@line 53057 "c/sqlite3.c"
    $spec$store$select = $40 ? 0 : $39; //@line 53057 "c/sqlite3.c"
    if (!($10)) {
     $41 = HEAP32[$7>>2]|0; //@line 53061 "c/sqlite3.c"
     _sqlite3OsClose($41); //@line 53061 "c/sqlite3.c"
    }
    $42 = HEAP8[$5>>0]|0; //@line 53063 "c/sqlite3.c"
    $43 = ($42<<24>>24)!=(0); //@line 53063 "c/sqlite3.c"
    $44 = $43&1; //@line 53063 "c/sqlite3.c"
    HEAP32[$1>>2] = $44; //@line 53063 "c/sqlite3.c"
    $$2 = $spec$store$select;
   } else {
    $$2 = $23;
   }
  } while(0);
  $$3 = $$2;
 } else {
  $$3 = $19;
 }
 $$4 = $$3;
 STACKTOP = sp;return ($$4|0); //@line 53082 "c/sqlite3.c"
}
function _pagerOpenWalIfPresent($0) {
 $0 = $0|0;
 var $$117$ph = 0, $$3$ph = 0, $$321 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp + 4|0;
 $2 = sp;
 $3 = ((($0)) + 12|0); //@line 51304 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 51304 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 51304 "c/sqlite3.c"
 if (!($5)) {
  $$321 = 0;
  STACKTOP = sp;return ($$321|0); //@line 51327 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0; //@line 51307 "c/sqlite3.c"
 $7 = ((($0)) + 216|0); //@line 51307 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 51307 "c/sqlite3.c"
 $9 = (_sqlite3OsAccess($6,$8,0,$1)|0); //@line 51306 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 51309 "c/sqlite3.c"
 do {
  if ($10) {
   $11 = HEAP32[$1>>2]|0; //@line 51310 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 51310 "c/sqlite3.c"
   if ($12) {
    $21 = ((($0)) + 5|0); //@line 51321 "c/sqlite3.c"
    $22 = HEAP8[$21>>0]|0; //@line 51321 "c/sqlite3.c"
    $23 = ($22<<24>>24)==(5); //@line 51321 "c/sqlite3.c"
    if (!($23)) {
     $$3$ph = 0;
     break;
    }
    HEAP8[$21>>0] = 0; //@line 51322 "c/sqlite3.c"
    $$3$ph = 0;
    break;
   }
   $13 = (_pagerPagecount($0,$2)|0); //@line 51313 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 51314 "c/sqlite3.c"
   if (!($14)) {
    $$321 = $13;
    STACKTOP = sp;return ($$321|0); //@line 51327 "c/sqlite3.c"
   }
   $15 = HEAP32[$2>>2]|0; //@line 51315 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 51315 "c/sqlite3.c"
   if ($16) {
    $17 = HEAP32[$0>>2]|0; //@line 51316 "c/sqlite3.c"
    $18 = HEAP32[$7>>2]|0; //@line 51316 "c/sqlite3.c"
    $19 = (_sqlite3OsDelete($17,$18,0)|0); //@line 51316 "c/sqlite3.c"
    $$117$ph = $19;
   } else {
    $20 = (_sqlite3PagerOpenWal($0,0)|0); //@line 51319 "c/sqlite3.c"
    $$117$ph = $20;
   }
   $$3$ph = $$117$ph;
  } else {
   $$3$ph = $9;
  }
 } while(0);
 $$321 = $$3$ph;
 STACKTOP = sp;return ($$321|0); //@line 51327 "c/sqlite3.c"
}
function _pagerBeginReadTransaction($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 51208 "c/sqlite3.c"
 $2 = ((($0)) + 212|0); //@line 51218 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 51218 "c/sqlite3.c"
 _sqlite3WalEndReadTransaction($3); //@line 51218 "c/sqlite3.c"
 $4 = HEAP32[$2>>2]|0; //@line 51220 "c/sqlite3.c"
 $5 = (_sqlite3WalBeginReadTransaction($4,$1)|0); //@line 51220 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 51221 "c/sqlite3.c"
 $7 = $6 | $5; //@line 51221 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 51221 "c/sqlite3.c"
 if ($8) {
  STACKTOP = sp;return ($5|0); //@line 51226 "c/sqlite3.c"
 }
 _pager_reset($0); //@line 51222 "c/sqlite3.c"
 STACKTOP = sp;return ($5|0); //@line 51226 "c/sqlite3.c"
}
function _pagerPagecount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $$120 = 0, $$12022 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 212|0); //@line 51252 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 51252 "c/sqlite3.c"
 $5 = (_sqlite3WalDbsize($4)|0); //@line 51252 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 51259 "c/sqlite3.c"
 do {
  if ($6) {
   $7 = ((($0)) + 60|0); //@line 51259 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 51259 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 51259 "c/sqlite3.c"
   $10 = ($9|0)==(0|0); //@line 51259 "c/sqlite3.c"
   if ($10) {
    $$12022 = 0;
   } else {
    $11 = $2; //@line 51260 "c/sqlite3.c"
    $12 = $11; //@line 51260 "c/sqlite3.c"
    HEAP32[$12>>2] = 0; //@line 51260 "c/sqlite3.c"
    $13 = (($11) + 4)|0; //@line 51260 "c/sqlite3.c"
    $14 = $13; //@line 51260 "c/sqlite3.c"
    HEAP32[$14>>2] = 0; //@line 51260 "c/sqlite3.c"
    $15 = (_sqlite3OsFileSize($8,$2)|0); //@line 51261 "c/sqlite3.c"
    $16 = ($15|0)==(0); //@line 51262 "c/sqlite3.c"
    if ($16) {
     $17 = $2; //@line 51265 "c/sqlite3.c"
     $18 = $17; //@line 51265 "c/sqlite3.c"
     $19 = HEAP32[$18>>2]|0; //@line 51265 "c/sqlite3.c"
     $20 = (($17) + 4)|0; //@line 51265 "c/sqlite3.c"
     $21 = $20; //@line 51265 "c/sqlite3.c"
     $22 = HEAP32[$21>>2]|0; //@line 51265 "c/sqlite3.c"
     $23 = ((($0)) + 152|0); //@line 51265 "c/sqlite3.c"
     $24 = HEAP32[$23>>2]|0; //@line 51265 "c/sqlite3.c"
     $25 = ($24|0)<(0); //@line 51265 "c/sqlite3.c"
     $26 = $25 << 31 >> 31; //@line 51265 "c/sqlite3.c"
     $27 = (_i64Add(($19|0),($22|0),-1,-1)|0); //@line 51265 "c/sqlite3.c"
     $28 = tempRet0; //@line 51265 "c/sqlite3.c"
     $29 = (_i64Add(($27|0),($28|0),($24|0),($26|0))|0); //@line 51265 "c/sqlite3.c"
     $30 = tempRet0; //@line 51265 "c/sqlite3.c"
     $31 = (___divdi3(($29|0),($30|0),($24|0),($26|0))|0); //@line 51265 "c/sqlite3.c"
     $32 = tempRet0; //@line 51265 "c/sqlite3.c"
     $$120 = $31;
     label = 6;
     break;
    }
    $$1 = $15;
    STACKTOP = sp;return ($$1|0); //@line 51278 "c/sqlite3.c"
   }
  } else {
   $$120 = $5;
   label = 6;
  }
 } while(0);
 if ((label|0) == 6) {
  $33 = ((($0)) + 156|0); //@line 51272 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 51272 "c/sqlite3.c"
  $35 = ($$120>>>0)>($34>>>0); //@line 51272 "c/sqlite3.c"
  if ($35) {
   HEAP32[$33>>2] = $$120; //@line 51273 "c/sqlite3.c"
   $$12022 = $$120;
  } else {
   $$12022 = $$120;
  }
 }
 HEAP32[$1>>2] = $$12022; //@line 51276 "c/sqlite3.c"
 $$1 = 0;
 STACKTOP = sp;return ($$1|0); //@line 51278 "c/sqlite3.c"
}
function _sqlite3WalDbsize($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 58545 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
 } else {
  $2 = ((($0)) + 40|0); //@line 58545 "c/sqlite3.c"
  $3 = HEAP16[$2>>1]|0; //@line 58545 "c/sqlite3.c"
  $4 = ($3<<16>>16)>(-1); //@line 58545 "c/sqlite3.c"
  if ($4) {
   $5 = ((($0)) + 72|0); //@line 58546 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 58546 "c/sqlite3.c"
   $$0 = $6;
  } else {
   $$0 = 0;
  }
 }
 return ($$0|0); //@line 58549 "c/sqlite3.c"
}
function _sqlite3WalBeginReadTransaction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0 = 0;
 while(1) {
  $2 = (($$0) + 1)|0; //@line 58329 "c/sqlite3.c"
  $3 = (_walTryBeginRead($0,$1,0,$2)|0); //@line 58329 "c/sqlite3.c"
  $4 = ($3|0)==(-1); //@line 58330 "c/sqlite3.c"
  if ($4) {
   $$0 = $2;
  } else {
   break;
  }
 }
 return ($3|0); //@line 58399 "c/sqlite3.c"
}
function _sqlite3OsCheckReservedLock($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 20926 "c/sqlite3.c"
 $3 = ((($2)) + 36|0); //@line 20926 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 20926 "c/sqlite3.c"
 $5 = (FUNCTION_TABLE_iii[$4 & 255]($0,$1)|0); //@line 20926 "c/sqlite3.c"
 return ($5|0); //@line 20926 "c/sqlite3.c"
}
function _sqlite3ParserInit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 139753 "c/sqlite3.c"
 HEAP32[$0>>2] = $1; //@line 139753 "c/sqlite3.c"
 HEAP16[$1>>1] = 0; //@line 139754 "c/sqlite3.c"
 $2 = ((($0)) + 10|0); //@line 139755 "c/sqlite3.c"
 HEAP8[$2>>0] = 0; //@line 139755 "c/sqlite3.c"
 $3 = ((($0)) + 1196|0); //@line 139757 "c/sqlite3.c"
 $4 = ((($0)) + 1208|0); //@line 139757 "c/sqlite3.c"
 HEAP32[$4>>2] = $3; //@line 139757 "c/sqlite3.c"
 return; //@line 139759 "c/sqlite3.c"
}
function _sqlite3GetToken($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0197 = 0, $$0199 = 0, $$0219 = 0, $$0237 = 0, $$1 = 0, $$10 = 0, $$11 = 0, $$1196 = 0, $$1198 = 0, $$1200 = 0, $$12224 = 0, $$13$lcssa = 0, $$13228 = 0, $$14 = 0, $$15236 = 0, $$16 = 0, $$17 = 0, $$18 = 0, $$18265 = 0, $$19 = 0;
 var $$20 = 0, $$21 = 0, $$22 = 0, $$2201 = 0, $$25 = 0, $$25$ph = 0, $$3 = 0, $$4$lcssa = 0, $$4223 = 0, $$5 = 0, $$6 = 0, $$7 = 0, $$8 = 0, $$8$in = 0, $$9 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0;
 var $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0;
 var $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0;
 var $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0;
 var $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0;
 var $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0;
 var $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0;
 var $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0;
 var $or$cond = 0, $or$cond204 = 0, $or$cond7 = 0, $spec$select = 0, $spec$select205 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 142556 "c/sqlite3.c"
 $3 = $2&255; //@line 142556 "c/sqlite3.c"
 $4 = (33161 + ($3)|0); //@line 142556 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 142556 "c/sqlite3.c"
 L1: do {
  switch ($5<<24>>24) {
  case 7:  {
   $$0199 = 1;
   while(1) {
    $6 = (($0) + ($$0199)|0); //@line 142565 "c/sqlite3.c"
    $7 = HEAP8[$6>>0]|0; //@line 142565 "c/sqlite3.c"
    $8 = $7&255; //@line 142565 "c/sqlite3.c"
    $9 = (16281 + ($8)|0); //@line 142565 "c/sqlite3.c"
    $10 = HEAP8[$9>>0]|0; //@line 142565 "c/sqlite3.c"
    $11 = $10 & 1; //@line 142565 "c/sqlite3.c"
    $12 = ($11<<24>>24)==(0); //@line 142565 "c/sqlite3.c"
    $13 = (($$0199) + 1)|0; //@line 142565 "c/sqlite3.c"
    if ($12) {
     break;
    } else {
     $$0199 = $13;
    }
   }
   HEAP32[$1>>2] = 158; //@line 142566 "c/sqlite3.c"
   $$1196 = $$0199;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 11:  {
   $14 = ((($0)) + 1|0); //@line 142570 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 142570 "c/sqlite3.c"
   $16 = ($15<<24>>24)==(45); //@line 142570 "c/sqlite3.c"
   if (!($16)) {
    HEAP32[$1>>2] = 89; //@line 142575 "c/sqlite3.c"
    $$1196 = 1;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
   $$1200 = 2;
   L14: while(1) {
    $17 = (($0) + ($$1200)|0); //@line 142571 "c/sqlite3.c"
    $18 = HEAP8[$17>>0]|0; //@line 142571 "c/sqlite3.c"
    switch ($18<<24>>24) {
    case 0: case 10:  {
     break L14;
     break;
    }
    default: {
    }
    }
    $19 = (($$1200) + 1)|0; //@line 142571 "c/sqlite3.c"
    $$1200 = $19;
   }
   HEAP32[$1>>2] = 158; //@line 142572 "c/sqlite3.c"
   $$1196 = $$1200;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 17:  {
   HEAP32[$1>>2] = 22; //@line 142579 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 18:  {
   HEAP32[$1>>2] = 23; //@line 142583 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 19:  {
   HEAP32[$1>>2] = 1; //@line 142587 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 20:  {
   HEAP32[$1>>2] = 88; //@line 142591 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 21:  {
   HEAP32[$1>>2] = 90; //@line 142595 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 16:  {
   $20 = ((($0)) + 1|0); //@line 142599 "c/sqlite3.c"
   $21 = HEAP8[$20>>0]|0; //@line 142599 "c/sqlite3.c"
   $22 = ($21<<24>>24)==(42); //@line 142599 "c/sqlite3.c"
   if ($22) {
    $23 = ((($0)) + 2|0); //@line 142599 "c/sqlite3.c"
    $24 = HEAP8[$23>>0]|0; //@line 142599 "c/sqlite3.c"
    $25 = ($24<<24>>24)==(0); //@line 142599 "c/sqlite3.c"
    if (!($25)) {
     $26 = $24&255; //@line 142599 "c/sqlite3.c"
     $$0197 = $26;$$2201 = 3;
     while(1) {
      $27 = ($$0197|0)==(42); //@line 142603 "c/sqlite3.c"
      if ($27) {
       $28 = (($0) + ($$2201)|0); //@line 142603 "c/sqlite3.c"
       $29 = HEAP8[$28>>0]|0; //@line 142603 "c/sqlite3.c"
       $30 = ($29<<24>>24)==(47); //@line 142603 "c/sqlite3.c"
       if ($30) {
        $$1198 = 1;
        break;
       }
      }
      $31 = (($0) + ($$2201)|0); //@line 142603 "c/sqlite3.c"
      $32 = HEAP8[$31>>0]|0; //@line 142603 "c/sqlite3.c"
      $33 = ($32<<24>>24)==(0); //@line 142603 "c/sqlite3.c"
      if ($33) {
       $$1198 = 0;
       break;
      }
      $34 = $32&255; //@line 142603 "c/sqlite3.c"
      $35 = (($$2201) + 1)|0; //@line 142603 "c/sqlite3.c"
      $$0197 = $34;$$2201 = $35;
     }
     $spec$select = (($$1198) + ($$2201))|0; //@line 142604 "c/sqlite3.c"
     HEAP32[$1>>2] = 158; //@line 142605 "c/sqlite3.c"
     $$1196 = $spec$select;
     return ($$1196|0); //@line 142825 "c/sqlite3.c"
    }
   }
   HEAP32[$1>>2] = 91; //@line 142600 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 22:  {
   HEAP32[$1>>2] = 92; //@line 142609 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 14:  {
   HEAP32[$1>>2] = 53; //@line 142613 "c/sqlite3.c"
   $36 = ((($0)) + 1|0); //@line 142614 "c/sqlite3.c"
   $37 = HEAP8[$36>>0]|0; //@line 142614 "c/sqlite3.c"
   $38 = ($37<<24>>24)==(61); //@line 142614 "c/sqlite3.c"
   $39 = $38 ? 2 : 1; //@line 142614 "c/sqlite3.c"
   $$1196 = $39;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 12:  {
   $40 = ((($0)) + 1|0); //@line 142617 "c/sqlite3.c"
   $41 = HEAP8[$40>>0]|0; //@line 142617 "c/sqlite3.c"
   switch ($41<<24>>24) {
   case 61:  {
    HEAP32[$1>>2] = 55; //@line 142618 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
    break;
   }
   case 62:  {
    HEAP32[$1>>2] = 52; //@line 142621 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
    break;
   }
   case 60:  {
    HEAP32[$1>>2] = 86; //@line 142624 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
    break;
   }
   default: {
    HEAP32[$1>>2] = 56; //@line 142627 "c/sqlite3.c"
    $$1196 = 1;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
   }
   break;
  }
  case 13:  {
   $42 = ((($0)) + 1|0); //@line 142632 "c/sqlite3.c"
   $43 = HEAP8[$42>>0]|0; //@line 142632 "c/sqlite3.c"
   switch ($43<<24>>24) {
   case 61:  {
    HEAP32[$1>>2] = 57; //@line 142633 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
    break;
   }
   case 62:  {
    HEAP32[$1>>2] = 87; //@line 142636 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
    break;
   }
   default: {
    HEAP32[$1>>2] = 54; //@line 142639 "c/sqlite3.c"
    $$1196 = 1;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
   }
   break;
  }
  case 15:  {
   $44 = ((($0)) + 1|0); //@line 142644 "c/sqlite3.c"
   $45 = HEAP8[$44>>0]|0; //@line 142644 "c/sqlite3.c"
   $46 = ($45<<24>>24)==(61); //@line 142644 "c/sqlite3.c"
   if ($46) {
    HEAP32[$1>>2] = 52; //@line 142648 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   } else {
    HEAP32[$1>>2] = 159; //@line 142645 "c/sqlite3.c"
    $$1196 = 1;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
   break;
  }
  case 10:  {
   $47 = ((($0)) + 1|0); //@line 142653 "c/sqlite3.c"
   $48 = HEAP8[$47>>0]|0; //@line 142653 "c/sqlite3.c"
   $49 = ($48<<24>>24)==(124); //@line 142653 "c/sqlite3.c"
   if ($49) {
    HEAP32[$1>>2] = 93; //@line 142657 "c/sqlite3.c"
    $$1196 = 2;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   } else {
    HEAP32[$1>>2] = 85; //@line 142654 "c/sqlite3.c"
    $$1196 = 1;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
   break;
  }
  case 23:  {
   HEAP32[$1>>2] = 26; //@line 142662 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 24:  {
   HEAP32[$1>>2] = 84; //@line 142666 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 25:  {
   HEAP32[$1>>2] = 95; //@line 142670 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 8:  {
   $50 = ((($0)) + 1|0); //@line 142678 "c/sqlite3.c"
   $51 = HEAP8[$50>>0]|0; //@line 142678 "c/sqlite3.c"
   $52 = ($51<<24>>24)==(0); //@line 142678 "c/sqlite3.c"
   L84: do {
    if ($52) {
     $$4$lcssa = 1;
    } else {
     $$4223 = 1;$54 = $51;
     while(1) {
      $53 = ($54<<24>>24)==($2<<24>>24); //@line 142679 "c/sqlite3.c"
      if ($53) {
       $55 = (($$4223) + 1)|0; //@line 142680 "c/sqlite3.c"
       $56 = (($0) + ($55)|0); //@line 142680 "c/sqlite3.c"
       $57 = HEAP8[$56>>0]|0; //@line 142680 "c/sqlite3.c"
       $58 = ($57<<24>>24)==($2<<24>>24); //@line 142680 "c/sqlite3.c"
       if ($58) {
        $$5 = $55;
       } else {
        break;
       }
      } else {
       $$5 = $$4223;
      }
      $59 = (($$5) + 1)|0; //@line 142678 "c/sqlite3.c"
      $60 = (($0) + ($59)|0); //@line 142678 "c/sqlite3.c"
      $61 = HEAP8[$60>>0]|0; //@line 142678 "c/sqlite3.c"
      $62 = ($61<<24>>24)==(0); //@line 142678 "c/sqlite3.c"
      if ($62) {
       $$4$lcssa = $59;
       break L84;
      } else {
       $$4223 = $59;$54 = $61;
      }
     }
     $63 = ($54<<24>>24)==(39); //@line 142687 "c/sqlite3.c"
     if ($63) {
      HEAP32[$1>>2] = 97; //@line 142688 "c/sqlite3.c"
      $64 = (($$4223) + 1)|0; //@line 142689 "c/sqlite3.c"
      $$1196 = $64;
      return ($$1196|0); //@line 142825 "c/sqlite3.c"
     } else {
      HEAP32[$1>>2] = 59; //@line 142691 "c/sqlite3.c"
      $65 = (($$4223) + 1)|0; //@line 142692 "c/sqlite3.c"
      $$1196 = $65;
      return ($$1196|0); //@line 142825 "c/sqlite3.c"
     }
    }
   } while(0);
   HEAP32[$1>>2] = 159; //@line 142694 "c/sqlite3.c"
   $$1196 = $$4$lcssa;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 26:  {
   $66 = ((($0)) + 1|0); //@line 142700 "c/sqlite3.c"
   $67 = HEAP8[$66>>0]|0; //@line 142700 "c/sqlite3.c"
   $68 = $67&255; //@line 142700 "c/sqlite3.c"
   $69 = (($68) + -48)|0; //@line 142700 "c/sqlite3.c"
   $70 = ($69>>>0)<(10); //@line 142700 "c/sqlite3.c"
   if (!($70)) {
    HEAP32[$1>>2] = 122; //@line 142703 "c/sqlite3.c"
    $$1196 = 1;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
   break;
  }
  case 3:  {
   break;
  }
  case 9:  {
   $138 = ($2<<24>>24)==(93); //@line 142745 "c/sqlite3.c"
   L103: do {
    if ($138) {
     $$13$lcssa = 1;$$3 = 59;
    } else {
     $$13228 = 1;
     while(1) {
      $139 = (($0) + ($$13228)|0); //@line 142745 "c/sqlite3.c"
      $140 = HEAP8[$139>>0]|0; //@line 142745 "c/sqlite3.c"
      $141 = ($140<<24>>24)==(0); //@line 142745 "c/sqlite3.c"
      if ($141) {
       $$13$lcssa = $$13228;$$3 = 159;
       break L103;
      }
      $142 = (($$13228) + 1)|0; //@line 142745 "c/sqlite3.c"
      $143 = ($140<<24>>24)==(93); //@line 142745 "c/sqlite3.c"
      if ($143) {
       $$13$lcssa = $142;$$3 = 59;
       break;
      } else {
       $$13228 = $142;
      }
     }
    }
   } while(0);
   HEAP32[$1>>2] = $$3; //@line 142746 "c/sqlite3.c"
   $$1196 = $$13$lcssa;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 6:  {
   HEAP32[$1>>2] = 135; //@line 142750 "c/sqlite3.c"
   $$14 = 1;
   while(1) {
    $144 = (($0) + ($$14)|0); //@line 142751 "c/sqlite3.c"
    $145 = HEAP8[$144>>0]|0; //@line 142751 "c/sqlite3.c"
    $146 = $145&255; //@line 142751 "c/sqlite3.c"
    $147 = (($146) + -48)|0; //@line 142751 "c/sqlite3.c"
    $148 = ($147>>>0)<(10); //@line 142751 "c/sqlite3.c"
    $149 = (($$14) + 1)|0; //@line 142751 "c/sqlite3.c"
    if ($148) {
     $$14 = $149;
    } else {
     $$1196 = $$14;
     break;
    }
   }
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 5: case 4:  {
   HEAP32[$1>>2] = 135; //@line 142759 "c/sqlite3.c"
   $150 = ((($0)) + 1|0); //@line 142760 "c/sqlite3.c"
   $151 = HEAP8[$150>>0]|0; //@line 142760 "c/sqlite3.c"
   $152 = ($151<<24>>24)==(0); //@line 142760 "c/sqlite3.c"
   if ($152) {
    $$18265 = 1;
   } else {
    $$0237 = 0;$$15236 = 1;$154 = $151;
    while(1) {
     $153 = $154&255; //@line 142760 "c/sqlite3.c"
     $155 = (16281 + ($153)|0); //@line 142761 "c/sqlite3.c"
     $156 = HEAP8[$155>>0]|0; //@line 142761 "c/sqlite3.c"
     $157 = $156 & 70; //@line 142761 "c/sqlite3.c"
     $158 = ($157<<24>>24)==(0); //@line 142761 "c/sqlite3.c"
     if ($158) {
      $160 = ($154<<24>>24)==(40); //@line 142764 "c/sqlite3.c"
      $161 = ($$0237|0)>(0); //@line 142764 "c/sqlite3.c"
      $or$cond = $161 & $160; //@line 142764 "c/sqlite3.c"
      if ($or$cond) {
       label = 90;
       break;
      }
      $173 = ($154<<24>>24)==(58); //@line 142774 "c/sqlite3.c"
      if (!($173)) {
       $$0219 = $$0237;$$18 = $$15236;
       break;
      }
      $174 = (($$15236) + 1)|0; //@line 142774 "c/sqlite3.c"
      $175 = (($0) + ($174)|0); //@line 142774 "c/sqlite3.c"
      $176 = HEAP8[$175>>0]|0; //@line 142774 "c/sqlite3.c"
      $177 = ($176<<24>>24)==(58); //@line 142774 "c/sqlite3.c"
      if ($177) {
       $$1 = $$0237;$$17 = $174;
      } else {
       $$0219 = $$0237;$$18 = $$15236;
       break;
      }
     } else {
      $159 = (($$0237) + 1)|0; //@line 142762 "c/sqlite3.c"
      $$1 = $159;$$17 = $$15236;
     }
     $178 = (($$17) + 1)|0; //@line 142760 "c/sqlite3.c"
     $179 = (($0) + ($178)|0); //@line 142760 "c/sqlite3.c"
     $180 = HEAP8[$179>>0]|0; //@line 142760 "c/sqlite3.c"
     $181 = ($180<<24>>24)==(0); //@line 142760 "c/sqlite3.c"
     if ($181) {
      $$0219 = $$1;$$18 = $178;
      break;
     } else {
      $$0237 = $$1;$$15236 = $178;$154 = $180;
     }
    }
    do {
     if ((label|0) == 90) {
      $$16 = $$15236;
      while(1) {
       $162 = (($$16) + 1)|0; //@line 142766 "c/sqlite3.c"
       $163 = (($0) + ($162)|0); //@line 142767 "c/sqlite3.c"
       $164 = HEAP8[$163>>0]|0; //@line 142767 "c/sqlite3.c"
       $cond = ($164<<24>>24)==(0); //@line 142767 "c/sqlite3.c"
       if ($cond) {
        break;
       }
       $165 = $164&255; //@line 142767 "c/sqlite3.c"
       $166 = (16281 + ($165)|0); //@line 142767 "c/sqlite3.c"
       $167 = HEAP8[$166>>0]|0; //@line 142767 "c/sqlite3.c"
       $168 = $167 & 1; //@line 142767 "c/sqlite3.c"
       $169 = ($168<<24>>24)==(0); //@line 142767 "c/sqlite3.c"
       $170 = ($164<<24>>24)!=(41); //@line 142767 "c/sqlite3.c"
       $or$cond7 = $170 & $169; //@line 142767 "c/sqlite3.c"
       if ($or$cond7) {
        $$16 = $162;
       } else {
        label = 93;
        break;
       }
      }
      if ((label|0) == 93) {
       $171 = ($164<<24>>24)==(41); //@line 142768 "c/sqlite3.c"
       if ($171) {
        $172 = (($$16) + 2)|0; //@line 142769 "c/sqlite3.c"
        $$0219 = $$0237;$$18 = $172;
        break;
       }
      }
      HEAP32[$1>>2] = 159; //@line 142771 "c/sqlite3.c"
      $$0219 = $$0237;$$18 = $162;
     }
    } while(0);
    $182 = ($$0219|0)==(0); //@line 142781 "c/sqlite3.c"
    if ($182) {
     $$18265 = $$18;
    } else {
     $$1196 = $$18;
     return ($$1196|0); //@line 142825 "c/sqlite3.c"
    }
   }
   HEAP32[$1>>2] = 159; //@line 142781 "c/sqlite3.c"
   $$1196 = $$18265;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 1:  {
   $$19 = 1;
   while(1) {
    $183 = (($0) + ($$19)|0); //@line 142785 "c/sqlite3.c"
    $184 = HEAP8[$183>>0]|0; //@line 142785 "c/sqlite3.c"
    $185 = $184&255; //@line 142785 "c/sqlite3.c"
    $186 = (33161 + ($185)|0); //@line 142785 "c/sqlite3.c"
    $187 = HEAP8[$186>>0]|0; //@line 142785 "c/sqlite3.c"
    $188 = ($187&255)<(2); //@line 142785 "c/sqlite3.c"
    $189 = (($$19) + 1)|0; //@line 142785 "c/sqlite3.c"
    if ($188) {
     $$19 = $189;
    } else {
     break;
    }
   }
   $190 = $184&255; //@line 142785 "c/sqlite3.c"
   $191 = (16281 + ($190)|0); //@line 142786 "c/sqlite3.c"
   $192 = HEAP8[$191>>0]|0; //@line 142786 "c/sqlite3.c"
   $193 = $192 & 70; //@line 142786 "c/sqlite3.c"
   $194 = ($193<<24>>24)==(0); //@line 142786 "c/sqlite3.c"
   if (!($194)) {
    $195 = (($$19) + 1)|0; //@line 142790 "c/sqlite3.c"
    $$25$ph = $195;
    label = 104;
    break L1;
   }
   HEAP32[$1>>2] = 59; //@line 142793 "c/sqlite3.c"
   $196 = (_keywordCode($0,$$19,$1)|0); //@line 142794 "c/sqlite3.c"
   $$1196 = $196;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
   break;
  }
  case 0:  {
   $197 = ((($0)) + 1|0); //@line 142799 "c/sqlite3.c"
   $198 = HEAP8[$197>>0]|0; //@line 142799 "c/sqlite3.c"
   $199 = ($198<<24>>24)==(39); //@line 142799 "c/sqlite3.c"
   if ($199) {
    HEAP32[$1>>2] = 133; //@line 142800 "c/sqlite3.c"
    $$20 = 2;
    while(1) {
     $200 = (($0) + ($$20)|0); //@line 142801 "c/sqlite3.c"
     $201 = HEAP8[$200>>0]|0; //@line 142801 "c/sqlite3.c"
     $202 = $201&255; //@line 142801 "c/sqlite3.c"
     $203 = (16281 + ($202)|0); //@line 142801 "c/sqlite3.c"
     $204 = HEAP8[$203>>0]|0; //@line 142801 "c/sqlite3.c"
     $205 = $204 & 8; //@line 142801 "c/sqlite3.c"
     $206 = ($205<<24>>24)==(0); //@line 142801 "c/sqlite3.c"
     $207 = (($$20) + 1)|0; //@line 142801 "c/sqlite3.c"
     if ($206) {
      break;
     } else {
      $$20 = $207;
     }
    }
    $208 = ($201<<24>>24)==(39); //@line 142802 "c/sqlite3.c"
    $209 = $$20 & 1; //@line 142802 "c/sqlite3.c"
    $210 = ($209|0)==(0); //@line 142802 "c/sqlite3.c"
    $or$cond204 = $208 & $210; //@line 142802 "c/sqlite3.c"
    L151: do {
     if ($or$cond204) {
      $$22 = $$20;
     } else {
      HEAP32[$1>>2] = 159; //@line 142803 "c/sqlite3.c"
      $$21 = $$20;
      while(1) {
       $211 = (($0) + ($$21)|0); //@line 142804 "c/sqlite3.c"
       $212 = HEAP8[$211>>0]|0; //@line 142804 "c/sqlite3.c"
       switch ($212<<24>>24) {
       case 39: case 0:  {
        $$22 = $$21;
        break L151;
        break;
       }
       default: {
       }
       }
       $213 = (($$21) + 1)|0; //@line 142804 "c/sqlite3.c"
       $$21 = $213;
      }
     }
    } while(0);
    $214 = (($0) + ($$22)|0); //@line 142806 "c/sqlite3.c"
    $215 = HEAP8[$214>>0]|0; //@line 142806 "c/sqlite3.c"
    $216 = ($215<<24>>24)!=(0); //@line 142806 "c/sqlite3.c"
    $217 = $216&1; //@line 142806 "c/sqlite3.c"
    $spec$select205 = (($$22) + ($217))|0; //@line 142806 "c/sqlite3.c"
    $$1196 = $spec$select205;
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   } else {
    $$25$ph = 1;
    label = 104;
   }
   break;
  }
  case 2:  {
   $$25$ph = 1;
   label = 104;
   break;
  }
  default: {
   HEAP32[$1>>2] = 159; //@line 142818 "c/sqlite3.c"
   $$1196 = 1;
   return ($$1196|0); //@line 142825 "c/sqlite3.c"
  }
  }
 } while(0);
 if ((label|0) == 104) {
  $$25 = $$25$ph;
  while(1) {
   $218 = (($0) + ($$25)|0); //@line 142822 "c/sqlite3.c"
   $219 = HEAP8[$218>>0]|0; //@line 142822 "c/sqlite3.c"
   $220 = $219&255; //@line 142822 "c/sqlite3.c"
   $221 = (16281 + ($220)|0); //@line 142822 "c/sqlite3.c"
   $222 = HEAP8[$221>>0]|0; //@line 142822 "c/sqlite3.c"
   $223 = $222 & 70; //@line 142822 "c/sqlite3.c"
   $224 = ($223<<24>>24)==(0); //@line 142822 "c/sqlite3.c"
   $225 = (($$25) + 1)|0; //@line 142822 "c/sqlite3.c"
   if ($224) {
    break;
   } else {
    $$25 = $225;
   }
  }
  HEAP32[$1>>2] = 59; //@line 142823 "c/sqlite3.c"
  $$1196 = $$25;
  return ($$1196|0); //@line 142825 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = 134; //@line 142714 "c/sqlite3.c"
 $71 = HEAP8[$0>>0]|0; //@line 142716 "c/sqlite3.c"
 $72 = ($71<<24>>24)==(48); //@line 142716 "c/sqlite3.c"
 L165: do {
  if ($72) {
   $73 = ((($0)) + 1|0); //@line 142716 "c/sqlite3.c"
   $74 = HEAP8[$73>>0]|0; //@line 142716 "c/sqlite3.c"
   switch ($74<<24>>24) {
   case 88: case 120:  {
    break;
   }
   default: {
    break L165;
   }
   }
   $75 = ((($0)) + 2|0); //@line 142716 "c/sqlite3.c"
   $76 = HEAP8[$75>>0]|0; //@line 142716 "c/sqlite3.c"
   $77 = $76&255; //@line 142716 "c/sqlite3.c"
   $78 = (16281 + ($77)|0); //@line 142716 "c/sqlite3.c"
   $79 = HEAP8[$78>>0]|0; //@line 142716 "c/sqlite3.c"
   $80 = $79 & 8; //@line 142716 "c/sqlite3.c"
   $81 = ($80<<24>>24)==(0); //@line 142716 "c/sqlite3.c"
   if (!($81)) {
    $$6 = 3;
    while(1) {
     $82 = (($0) + ($$6)|0); //@line 142717 "c/sqlite3.c"
     $83 = HEAP8[$82>>0]|0; //@line 142717 "c/sqlite3.c"
     $84 = $83&255; //@line 142717 "c/sqlite3.c"
     $85 = (16281 + ($84)|0); //@line 142717 "c/sqlite3.c"
     $86 = HEAP8[$85>>0]|0; //@line 142717 "c/sqlite3.c"
     $87 = $86 & 8; //@line 142717 "c/sqlite3.c"
     $88 = ($87<<24>>24)==(0); //@line 142717 "c/sqlite3.c"
     $89 = (($$6) + 1)|0; //@line 142717 "c/sqlite3.c"
     if ($88) {
      $$1196 = $$6;
      break;
     } else {
      $$6 = $89;
     }
    }
    return ($$1196|0); //@line 142825 "c/sqlite3.c"
   }
  }
 } while(0);
 $$7 = 0;
 while(1) {
  $90 = (($0) + ($$7)|0); //@line 142721 "c/sqlite3.c"
  $91 = HEAP8[$90>>0]|0; //@line 142721 "c/sqlite3.c"
  $92 = $91&255; //@line 142721 "c/sqlite3.c"
  $93 = (($92) + -48)|0; //@line 142721 "c/sqlite3.c"
  $94 = ($93>>>0)<(10); //@line 142721 "c/sqlite3.c"
  $95 = (($$7) + 1)|0; //@line 142721 "c/sqlite3.c"
  if ($94) {
   $$7 = $95;
  } else {
   break;
  }
 }
 $96 = ($91<<24>>24)==(46); //@line 142723 "c/sqlite3.c"
 if ($96) {
  $$8$in = $$7;
  while(1) {
   $$8 = (($$8$in) + 1)|0;
   $97 = (($0) + ($$8)|0); //@line 142725 "c/sqlite3.c"
   $98 = HEAP8[$97>>0]|0; //@line 142725 "c/sqlite3.c"
   $99 = $98&255; //@line 142725 "c/sqlite3.c"
   $100 = (($99) + -48)|0; //@line 142725 "c/sqlite3.c"
   $101 = ($100>>>0)<(10); //@line 142725 "c/sqlite3.c"
   if ($101) {
    $$8$in = $$8;
   } else {
    break;
   }
  }
  HEAP32[$1>>2] = 132; //@line 142726 "c/sqlite3.c"
  $$9 = $$8;
 } else {
  $$9 = $$7;
 }
 $102 = (($0) + ($$9)|0); //@line 142728 "c/sqlite3.c"
 $103 = HEAP8[$102>>0]|0; //@line 142728 "c/sqlite3.c"
 L182: do {
  switch ($103<<24>>24) {
  case 69: case 101:  {
   $104 = (($$9) + 1)|0; //@line 142729 "c/sqlite3.c"
   $105 = (($0) + ($104)|0); //@line 142729 "c/sqlite3.c"
   $106 = HEAP8[$105>>0]|0; //@line 142729 "c/sqlite3.c"
   $107 = $106&255; //@line 142729 "c/sqlite3.c"
   $108 = (($107) + -48)|0; //@line 142729 "c/sqlite3.c"
   $109 = ($108>>>0)<(10); //@line 142729 "c/sqlite3.c"
   if (!($109)) {
    switch ($106<<24>>24) {
    case 45: case 43:  {
     break;
    }
    default: {
     $$11 = $$9;
     break L182;
    }
    }
    $110 = (($$9) + 2)|0; //@line 142730 "c/sqlite3.c"
    $111 = (($0) + ($110)|0); //@line 142730 "c/sqlite3.c"
    $112 = HEAP8[$111>>0]|0; //@line 142730 "c/sqlite3.c"
    $113 = $112&255; //@line 142730 "c/sqlite3.c"
    $114 = (($113) + -48)|0; //@line 142730 "c/sqlite3.c"
    $115 = ($114>>>0)<(10); //@line 142730 "c/sqlite3.c"
    if (!($115)) {
     $$11 = $$9;
     break L182;
    }
   }
   $116 = (($$9) + 2)|0; //@line 142733 "c/sqlite3.c"
   $$10 = $116;
   while(1) {
    $117 = (($0) + ($$10)|0); //@line 142734 "c/sqlite3.c"
    $118 = HEAP8[$117>>0]|0; //@line 142734 "c/sqlite3.c"
    $119 = $118&255; //@line 142734 "c/sqlite3.c"
    $120 = (($119) + -48)|0; //@line 142734 "c/sqlite3.c"
    $121 = ($120>>>0)<(10); //@line 142734 "c/sqlite3.c"
    $122 = (($$10) + 1)|0; //@line 142734 "c/sqlite3.c"
    if ($121) {
     $$10 = $122;
    } else {
     break;
    }
   }
   HEAP32[$1>>2] = 132; //@line 142735 "c/sqlite3.c"
   $$11 = $$10;
   break;
  }
  default: {
   $$11 = $$9;
  }
  }
 } while(0);
 $123 = (($0) + ($$11)|0); //@line 142738 "c/sqlite3.c"
 $124 = HEAP8[$123>>0]|0; //@line 142738 "c/sqlite3.c"
 $125 = $124&255; //@line 142738 "c/sqlite3.c"
 $126 = (16281 + ($125)|0); //@line 142738 "c/sqlite3.c"
 $127 = HEAP8[$126>>0]|0; //@line 142738 "c/sqlite3.c"
 $128 = $127 & 70; //@line 142738 "c/sqlite3.c"
 $129 = ($128<<24>>24)==(0); //@line 142738 "c/sqlite3.c"
 if ($129) {
  $$1196 = $$11;
  return ($$1196|0); //@line 142825 "c/sqlite3.c"
 }
 $$12224 = $$11;
 while(1) {
  HEAP32[$1>>2] = 159; //@line 142739 "c/sqlite3.c"
  $130 = (($$12224) + 1)|0; //@line 142740 "c/sqlite3.c"
  $131 = (($0) + ($130)|0); //@line 142738 "c/sqlite3.c"
  $132 = HEAP8[$131>>0]|0; //@line 142738 "c/sqlite3.c"
  $133 = $132&255; //@line 142738 "c/sqlite3.c"
  $134 = (16281 + ($133)|0); //@line 142738 "c/sqlite3.c"
  $135 = HEAP8[$134>>0]|0; //@line 142738 "c/sqlite3.c"
  $136 = $135 & 70; //@line 142738 "c/sqlite3.c"
  $137 = ($136<<24>>24)==(0); //@line 142738 "c/sqlite3.c"
  if ($137) {
   $$1196 = $130;
   break;
  } else {
   $$12224 = $130;
  }
 }
 return ($$1196|0); //@line 142825 "c/sqlite3.c"
}
function _sqlite3Parser($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $$byval_copy2 = sp + 8|0;
 $4 = sp;
 $5 = ((($0)) + 4|0); //@line 141910 "c/sqlite3.c"
 HEAP32[$5>>2] = $3; //@line 141910 "c/sqlite3.c"
 $6 = $1&255;
 $7 = ($1|0)==(253);
 $8 = ((($0)) + 8|0);
 while(1) {
  $9 = (_yy_find_shift_action($0,$6)|0); //@line 141926 "c/sqlite3.c"
  $10 = ($9>>>0)>(1007); //@line 141927 "c/sqlite3.c"
  if (!($10)) {
   label = 3;
   break;
  }
  $25 = (($9) + -1008)|0; //@line 141928 "c/sqlite3.c"
  ;HEAP32[$$byval_copy2>>2]=HEAP32[$2>>2]|0;HEAP32[$$byval_copy2+4>>2]=HEAP32[$2+4>>2]|0; //@line 141928 "c/sqlite3.c"
  _yy_reduce($0,$25,$$byval_copy2); //@line 141928 "c/sqlite3.c"
  if ($7) {
   label = 10;
   break;
  }
  $26 = HEAP32[$0>>2]|0; //@line 142041 "c/sqlite3.c"
  $27 = ($26>>>0)>($8>>>0); //@line 142041 "c/sqlite3.c"
  if (!($27)) {
   label = 10;
   break;
  }
 }
 if ((label|0) == 3) {
  $11 = ($9>>>0)<(1005); //@line 141929 "c/sqlite3.c"
  if ($11) {
   ;HEAP32[$$byval_copy2>>2]=HEAP32[$2>>2]|0;HEAP32[$$byval_copy2+4>>2]=HEAP32[$2+4>>2]|0; //@line 141930 "c/sqlite3.c"
   _yy_shift($0,$9,$1,$$byval_copy2); //@line 141930 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 142055 "c/sqlite3.c"
  }
  $12 = ($9|0)==(1006); //@line 141935 "c/sqlite3.c"
  if ($12) {
   $13 = HEAP32[$0>>2]|0; //@line 141936 "c/sqlite3.c"
   $14 = ((($13)) + -12|0); //@line 141936 "c/sqlite3.c"
   HEAP32[$0>>2] = $14; //@line 141936 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 142055 "c/sqlite3.c"
  } else {
   $15 = $2; //@line 141941 "c/sqlite3.c"
   $16 = $15; //@line 141941 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 141941 "c/sqlite3.c"
   $18 = (($15) + 4)|0; //@line 141941 "c/sqlite3.c"
   $19 = $18; //@line 141941 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 141941 "c/sqlite3.c"
   $21 = $4; //@line 141941 "c/sqlite3.c"
   $22 = $21; //@line 141941 "c/sqlite3.c"
   HEAP32[$22>>2] = $17; //@line 141941 "c/sqlite3.c"
   $23 = (($21) + 4)|0; //@line 141941 "c/sqlite3.c"
   $24 = $23; //@line 141941 "c/sqlite3.c"
   HEAP32[$24>>2] = $20; //@line 141941 "c/sqlite3.c"
   ;HEAP32[$$byval_copy2>>2]=HEAP32[$2>>2]|0;HEAP32[$$byval_copy2+4>>2]=HEAP32[$2+4>>2]|0; //@line 142013 "c/sqlite3.c"
   _yy_syntax_error($0,$$byval_copy2); //@line 142013 "c/sqlite3.c"
   _yy_destructor($0,$6,$4); //@line 142014 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 142055 "c/sqlite3.c"
  }
 }
 else if ((label|0) == 10) {
  STACKTOP = sp;return; //@line 142055 "c/sqlite3.c"
 }
}
function _sqlite3ParserFinalize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 139908 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 139908 "c/sqlite3.c"
 $3 = ($1>>>0)>($2>>>0); //@line 139908 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 139912 "c/sqlite3.c"
 }
 while(1) {
  _yy_pop_parser_stack($0); //@line 139908 "c/sqlite3.c"
  $4 = HEAP32[$0>>2]|0; //@line 139908 "c/sqlite3.c"
  $5 = ($4>>>0)>($2>>>0); //@line 139908 "c/sqlite3.c"
  if (!($5)) {
   break;
  }
 }
 return; //@line 139912 "c/sqlite3.c"
}
function _yy_pop_parser_stack($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 139892 "c/sqlite3.c"
 $2 = ((($1)) + -12|0); //@line 139892 "c/sqlite3.c"
 HEAP32[$0>>2] = $2; //@line 139892 "c/sqlite3.c"
 $3 = ((($1)) + 2|0); //@line 139900 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 139900 "c/sqlite3.c"
 $5 = ((($1)) + 4|0); //@line 139900 "c/sqlite3.c"
 _yy_destructor($0,$4,$5); //@line 139900 "c/sqlite3.c"
 return; //@line 139901 "c/sqlite3.c"
}
function _yy_destructor($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 139795 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 139795 "c/sqlite3.c"
 switch ($1<<24>>24) {
 case -49: case -60: case -61: case -93:  {
  $5 = HEAP32[$4>>2]|0; //@line 139813 "c/sqlite3.c"
  $6 = HEAP32[$2>>2]|0; //@line 139813 "c/sqlite3.c"
  _sqlite3SelectDelete($5,$6); //@line 139813 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -14: case -19: case -28: case -30: case -40: case -52: case -54: case -82: case -83:  {
  $7 = HEAP32[$4>>2]|0; //@line 139826 "c/sqlite3.c"
  $8 = HEAP32[$2>>2]|0; //@line 139826 "c/sqlite3.c"
  _sqlite3ExprDelete($7,$8); //@line 139826 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -29: case -31: case -37: case -46: case -47: case -48: case -51: case -53: case -56: case -68: case -69: case -78:  {
  $9 = HEAP32[$4>>2]|0; //@line 139842 "c/sqlite3.c"
  $10 = HEAP32[$2>>2]|0; //@line 139842 "c/sqlite3.c"
  _sqlite3ExprListDelete($9,$10); //@line 139842 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -43: case -44: case -55: case -62:  {
  $11 = HEAP32[$4>>2]|0; //@line 139850 "c/sqlite3.c"
  $12 = HEAP32[$2>>2]|0; //@line 139850 "c/sqlite3.c"
  _sqlite3SrcListDelete($11,$12); //@line 139850 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -5: case -59:  {
  $13 = HEAP32[$4>>2]|0; //@line 139856 "c/sqlite3.c"
  $14 = HEAP32[$2>>2]|0; //@line 139856 "c/sqlite3.c"
  _sqlite3WithDelete($13,$14); //@line 139856 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -35: case -38: case -39:  {
  $15 = HEAP32[$4>>2]|0; //@line 139863 "c/sqlite3.c"
  $16 = HEAP32[$2>>2]|0; //@line 139863 "c/sqlite3.c"
  _sqlite3IdListDelete($15,$16); //@line 139863 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -18: case -23:  {
  $17 = HEAP32[$4>>2]|0; //@line 139869 "c/sqlite3.c"
  $18 = HEAP32[$2>>2]|0; //@line 139869 "c/sqlite3.c"
  _sqlite3DeleteTriggerStep($17,$18); //@line 139869 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 case -21:  {
  $19 = HEAP32[$4>>2]|0; //@line 139874 "c/sqlite3.c"
  $20 = ((($2)) + 4|0); //@line 139874 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 139874 "c/sqlite3.c"
  _sqlite3IdListDelete($19,$21); //@line 139874 "c/sqlite3.c"
  return; //@line 139880 "c/sqlite3.c"
  break;
 }
 default: {
  return; //@line 139880 "c/sqlite3.c"
 }
 }
}
function _yy_find_shift_action($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02737 = 0, $$3 = 0, $$lcssa = 0, $$sink50 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 139991 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 139991 "c/sqlite3.c"
 $4 = $3&65535; //@line 139991 "c/sqlite3.c"
 $5 = ($3&65535)>(465); //@line 139993 "c/sqlite3.c"
 if ($5) {
  $$3 = $4;
  return ($$3|0); //@line 140048 "c/sqlite3.c"
 }
 $6 = (11974 + ($4<<1)|0); //@line 139999 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 139999 "c/sqlite3.c"
 $8 = $7&65535; //@line 139999 "c/sqlite3.c"
 $9 = $1&255; //@line 140003 "c/sqlite3.c"
 $10 = (($8) + ($9))|0; //@line 140003 "c/sqlite3.c"
 $11 = (31394 + ($10)|0); //@line 140004 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 140004 "c/sqlite3.c"
 $13 = ($12<<24>>24)==($1<<24>>24); //@line 140004 "c/sqlite3.c"
 L4: do {
  if ($13) {
   $$lcssa = $10;
   label = 11;
  } else {
   $$02737 = $1;$24 = $9;$27 = $8;
   while(1) {
    $22 = ($$02737&255)<(83); //@line 140007 "c/sqlite3.c"
    if (!($22)) {
     break;
    }
    $23 = (33078 + ($24)|0); //@line 140008 "c/sqlite3.c"
    $17 = HEAP8[$23>>0]|0; //@line 140008 "c/sqlite3.c"
    $25 = ($17<<24>>24)==(0); //@line 140008 "c/sqlite3.c"
    if ($25) {
     break;
    }
    $14 = HEAP16[$6>>1]|0; //@line 139999 "c/sqlite3.c"
    $15 = $14&65535; //@line 139999 "c/sqlite3.c"
    $16 = $17&255; //@line 140003 "c/sqlite3.c"
    $18 = (($15) + ($16))|0; //@line 140003 "c/sqlite3.c"
    $19 = (31394 + ($18)|0); //@line 140004 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 140004 "c/sqlite3.c"
    $21 = ($20<<24>>24)==($17<<24>>24); //@line 140004 "c/sqlite3.c"
    if ($21) {
     $$lcssa = $18;
     label = 11;
     break L4;
    } else {
     $$02737 = $17;$24 = $16;$27 = $15;
    }
   }
   $26 = (($27) + 83)|0; //@line 140022 "c/sqlite3.c"
   $28 = ($26>>>0)<(1541); //@line 140028 "c/sqlite3.c"
   if ($28) {
    $29 = (31394 + ($26)|0); //@line 140030 "c/sqlite3.c"
    $30 = HEAP8[$29>>0]|0; //@line 140030 "c/sqlite3.c"
    $31 = ($30<<24>>24)!=(83); //@line 140030 "c/sqlite3.c"
    $32 = ($$02737<<24>>24)==(0); //@line 140030 "c/sqlite3.c"
    $or$cond = $32 | $31; //@line 140030 "c/sqlite3.c"
    if (!($or$cond)) {
     $33 = (8614 + ($26<<1)|0); //@line 140039 "c/sqlite3.c"
     $$sink50 = $33;
     break;
    }
   }
   $34 = (12906 + ($4<<1)|0); //@line 140043 "c/sqlite3.c"
   $$sink50 = $34;
  }
 } while(0);
 if ((label|0) == 11) {
  $35 = (8614 + ($$lcssa<<1)|0); //@line 140045 "c/sqlite3.c"
  $$sink50 = $35;
 }
 $36 = HEAP16[$$sink50>>1]|0;
 $37 = $36&65535;
 $$3 = $37;
 return ($$3|0); //@line 140048 "c/sqlite3.c"
}
function _yy_shift($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 140131 "c/sqlite3.c"
 $5 = ((($4)) + 12|0); //@line 140131 "c/sqlite3.c"
 HEAP32[$0>>2] = $5; //@line 140131 "c/sqlite3.c"
 $6 = ((($0)) + 1208|0); //@line 140139 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 140139 "c/sqlite3.c"
 $8 = ($5>>>0)>($7>>>0); //@line 140139 "c/sqlite3.c"
 if ($8) {
  HEAP32[$0>>2] = $4; //@line 140140 "c/sqlite3.c"
  _yyStackOverflow($0); //@line 140141 "c/sqlite3.c"
  return; //@line 140161 "c/sqlite3.c"
 } else {
  $9 = ($1|0)>(465); //@line 140153 "c/sqlite3.c"
  $10 = (($1) + 333)|0; //@line 140154 "c/sqlite3.c"
  $spec$select = $9 ? $10 : $1; //@line 140153 "c/sqlite3.c"
  $11 = $spec$select&65535; //@line 140157 "c/sqlite3.c"
  HEAP16[$5>>1] = $11; //@line 140157 "c/sqlite3.c"
  $12 = $2&255; //@line 140158 "c/sqlite3.c"
  $13 = ((($4)) + 14|0); //@line 140158 "c/sqlite3.c"
  HEAP8[$13>>0] = $12; //@line 140158 "c/sqlite3.c"
  $14 = ((($4)) + 16|0); //@line 140159 "c/sqlite3.c"
  $15 = $3; //@line 140159 "c/sqlite3.c"
  $16 = $15; //@line 140159 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 140159 "c/sqlite3.c"
  $18 = (($15) + 4)|0; //@line 140159 "c/sqlite3.c"
  $19 = $18; //@line 140159 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 140159 "c/sqlite3.c"
  $21 = $14; //@line 140159 "c/sqlite3.c"
  $22 = $21; //@line 140159 "c/sqlite3.c"
  HEAP32[$22>>2] = $17; //@line 140159 "c/sqlite3.c"
  $23 = (($21) + 4)|0; //@line 140159 "c/sqlite3.c"
  $24 = $23; //@line 140159 "c/sqlite3.c"
  HEAP32[$24>>2] = $20; //@line 140159 "c/sqlite3.c"
  return; //@line 140161 "c/sqlite3.c"
 }
}
function _yy_syntax_error($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 141830 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 141830 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 141833 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 141833 "c/sqlite3.c"
 $4 = HEAP32[$1>>2]|0; //@line 141838 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 141838 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 141838 "c/sqlite3.c"
 if ($6) {
  _sqlite3ErrorMsg($3,31377,$vararg_buffer1); //@line 141841 "c/sqlite3.c"
  HEAP32[$2>>2] = $3; //@line 141844 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 141845 "c/sqlite3.c"
 } else {
  HEAP32[$vararg_buffer>>2] = $1; //@line 141839 "c/sqlite3.c"
  _sqlite3ErrorMsg($3,19267,$vararg_buffer); //@line 141839 "c/sqlite3.c"
  HEAP32[$2>>2] = $3; //@line 141844 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 141845 "c/sqlite3.c"
 }
}
function _yy_reduce($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$01 = 0, $$04 = 0, $$byval_copy16 = 0, $10 = 0, $100 = 0, $1000 = 0, $1001 = 0, $1002 = 0, $1003 = 0, $1004 = 0, $1005 = 0, $1006 = 0, $1007 = 0, $1008 = 0, $1009 = 0, $101 = 0, $1010 = 0, $1011 = 0, $1012 = 0, $1013 = 0;
 var $1014 = 0, $1015 = 0, $1016 = 0, $1017 = 0, $1018 = 0, $1019 = 0, $102 = 0, $1020 = 0, $1021 = 0, $1022 = 0, $1023 = 0, $1024 = 0, $1025 = 0, $1026 = 0, $1027 = 0, $1028 = 0, $1029 = 0, $103 = 0, $1030 = 0, $1031 = 0;
 var $1032 = 0, $1033 = 0, $1034 = 0, $1035 = 0, $1036 = 0, $1037 = 0, $1038 = 0, $1039 = 0, $104 = 0, $1040 = 0, $1041 = 0, $1042 = 0, $1043 = 0, $1044 = 0, $1045 = 0, $1046 = 0, $1047 = 0, $1048 = 0, $1049 = 0, $105 = 0;
 var $1050 = 0, $1051 = 0, $1052 = 0, $1053 = 0, $1054 = 0, $1055 = 0, $1056 = 0, $1057 = 0, $1058 = 0, $1059 = 0, $106 = 0, $1060 = 0, $1061 = 0, $1062 = 0, $1063 = 0, $1064 = 0, $1065 = 0, $1066 = 0, $1067 = 0, $1068 = 0;
 var $1069 = 0, $107 = 0, $1070 = 0, $1071 = 0, $1072 = 0, $1073 = 0, $1074 = 0, $1075 = 0, $1076 = 0, $1077 = 0, $1078 = 0, $1079 = 0, $108 = 0, $1080 = 0, $1081 = 0, $1082 = 0, $1083 = 0, $1084 = 0, $1085 = 0, $1086 = 0;
 var $1087 = 0, $1088 = 0, $1089 = 0, $109 = 0, $1090 = 0, $1091 = 0, $1092 = 0, $1093 = 0, $1094 = 0, $1095 = 0, $1096 = 0, $1097 = 0, $1098 = 0, $1099 = 0, $11 = 0, $110 = 0, $1100 = 0, $1101 = 0, $1102 = 0, $1103 = 0;
 var $1104 = 0, $1105 = 0, $1106 = 0, $1107 = 0, $1108 = 0, $1109 = 0, $111 = 0, $1110 = 0, $1111 = 0, $1112 = 0, $1113 = 0, $1114 = 0, $1115 = 0, $1116 = 0, $1117 = 0, $1118 = 0, $1119 = 0, $112 = 0, $1120 = 0, $1121 = 0;
 var $1122 = 0, $1123 = 0, $1124 = 0, $1125 = 0, $1126 = 0, $1127 = 0, $1128 = 0, $1129 = 0, $113 = 0, $1130 = 0, $1131 = 0, $1132 = 0, $1133 = 0, $1134 = 0, $1135 = 0, $1136 = 0, $1137 = 0, $1138 = 0, $1139 = 0, $114 = 0;
 var $1140 = 0, $1141 = 0, $1142 = 0, $1143 = 0, $1144 = 0, $1145 = 0, $1146 = 0, $1147 = 0, $1148 = 0, $1149 = 0, $115 = 0, $1150 = 0, $1151 = 0, $1152 = 0, $1153 = 0, $1154 = 0, $1155 = 0, $1156 = 0, $1157 = 0, $1158 = 0;
 var $1159 = 0, $116 = 0, $1160 = 0, $1161 = 0, $1162 = 0, $1163 = 0, $1164 = 0, $1165 = 0, $1166 = 0, $1167 = 0, $1168 = 0, $1169 = 0, $117 = 0, $1170 = 0, $1171 = 0, $1172 = 0, $1173 = 0, $1174 = 0, $1175 = 0, $1176 = 0;
 var $1177 = 0, $1178 = 0, $1179 = 0, $118 = 0, $1180 = 0, $1181 = 0, $1182 = 0, $1183 = 0, $1184 = 0, $1185 = 0, $1186 = 0, $1187 = 0, $1188 = 0, $1189 = 0, $119 = 0, $1190 = 0, $1191 = 0, $1192 = 0, $1193 = 0, $1194 = 0;
 var $1195 = 0, $1196 = 0, $1197 = 0, $1198 = 0, $1199 = 0, $12 = 0, $120 = 0, $1200 = 0, $1201 = 0, $1202 = 0, $1203 = 0, $1204 = 0, $1205 = 0, $1206 = 0, $1207 = 0, $1208 = 0, $1209 = 0, $121 = 0, $1210 = 0, $1211 = 0;
 var $1212 = 0, $1213 = 0, $1214 = 0, $1215 = 0, $1216 = 0, $1217 = 0, $1218 = 0, $1219 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0;
 var $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0;
 var $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0;
 var $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0;
 var $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0;
 var $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0;
 var $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0;
 var $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0;
 var $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0;
 var $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0;
 var $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0;
 var $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0;
 var $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0;
 var $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0;
 var $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0;
 var $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0;
 var $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0;
 var $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0;
 var $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0;
 var $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0;
 var $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0;
 var $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0;
 var $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0, $584 = 0;
 var $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0, $60 = 0, $600 = 0, $601 = 0;
 var $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0, $618 = 0, $619 = 0, $62 = 0;
 var $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0, $636 = 0, $637 = 0, $638 = 0;
 var $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0, $654 = 0, $655 = 0, $656 = 0;
 var $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0, $672 = 0, $673 = 0, $674 = 0;
 var $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0, $690 = 0, $691 = 0, $692 = 0;
 var $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0, $708 = 0, $709 = 0, $71 = 0;
 var $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0, $726 = 0, $727 = 0, $728 = 0;
 var $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0, $744 = 0, $745 = 0, $746 = 0;
 var $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0, $762 = 0, $763 = 0, $764 = 0;
 var $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0, $780 = 0, $781 = 0, $782 = 0;
 var $783 = 0, $784 = 0, $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0, $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0, $799 = 0, $8 = 0, $80 = 0;
 var $800 = 0, $801 = 0, $802 = 0, $803 = 0, $804 = 0, $805 = 0, $806 = 0, $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0, $813 = 0, $814 = 0, $815 = 0, $816 = 0, $817 = 0, $818 = 0;
 var $819 = 0, $82 = 0, $820 = 0, $821 = 0, $822 = 0, $823 = 0, $824 = 0, $825 = 0, $826 = 0, $827 = 0, $828 = 0, $829 = 0, $83 = 0, $830 = 0, $831 = 0, $832 = 0, $833 = 0, $834 = 0, $835 = 0, $836 = 0;
 var $837 = 0, $838 = 0, $839 = 0, $84 = 0, $840 = 0, $841 = 0, $842 = 0, $843 = 0, $844 = 0, $845 = 0, $846 = 0, $847 = 0, $848 = 0, $849 = 0, $85 = 0, $850 = 0, $851 = 0, $852 = 0, $853 = 0, $854 = 0;
 var $855 = 0, $856 = 0, $857 = 0, $858 = 0, $859 = 0, $86 = 0, $860 = 0, $861 = 0, $862 = 0, $863 = 0, $864 = 0, $865 = 0, $866 = 0, $867 = 0, $868 = 0, $869 = 0, $87 = 0, $870 = 0, $871 = 0, $872 = 0;
 var $873 = 0, $874 = 0, $875 = 0, $876 = 0, $877 = 0, $878 = 0, $879 = 0, $88 = 0, $880 = 0, $881 = 0, $882 = 0, $883 = 0, $884 = 0, $885 = 0, $886 = 0, $887 = 0, $888 = 0, $889 = 0, $89 = 0, $890 = 0;
 var $891 = 0, $892 = 0, $893 = 0, $894 = 0, $895 = 0, $896 = 0, $897 = 0, $898 = 0, $899 = 0, $9 = 0, $90 = 0, $900 = 0, $901 = 0, $902 = 0, $903 = 0, $904 = 0, $905 = 0, $906 = 0, $907 = 0, $908 = 0;
 var $909 = 0, $91 = 0, $910 = 0, $911 = 0, $912 = 0, $913 = 0, $914 = 0, $915 = 0, $916 = 0, $917 = 0, $918 = 0, $919 = 0, $92 = 0, $920 = 0, $921 = 0, $922 = 0, $923 = 0, $924 = 0, $925 = 0, $926 = 0;
 var $927 = 0, $928 = 0, $929 = 0, $93 = 0, $930 = 0, $931 = 0, $932 = 0, $933 = 0, $934 = 0, $935 = 0, $936 = 0, $937 = 0, $938 = 0, $939 = 0, $94 = 0, $940 = 0, $941 = 0, $942 = 0, $943 = 0, $944 = 0;
 var $945 = 0, $946 = 0, $947 = 0, $948 = 0, $949 = 0, $95 = 0, $950 = 0, $951 = 0, $952 = 0, $953 = 0, $954 = 0, $955 = 0, $956 = 0, $957 = 0, $958 = 0, $959 = 0, $96 = 0, $960 = 0, $961 = 0, $962 = 0;
 var $963 = 0, $964 = 0, $965 = 0, $966 = 0, $967 = 0, $968 = 0, $969 = 0, $97 = 0, $970 = 0, $971 = 0, $972 = 0, $973 = 0, $974 = 0, $975 = 0, $976 = 0, $977 = 0, $978 = 0, $979 = 0, $98 = 0, $980 = 0;
 var $981 = 0, $982 = 0, $983 = 0, $984 = 0, $985 = 0, $986 = 0, $987 = 0, $988 = 0, $989 = 0, $99 = 0, $990 = 0, $991 = 0, $992 = 0, $993 = 0, $994 = 0, $995 = 0, $996 = 0, $997 = 0, $998 = 0, $999 = 0;
 var $or$cond = 0, $storemerge = 0, $vararg_buffer = 0, $vararg_buffer10 = 0, $vararg_buffer12 = 0, $vararg_buffer2 = 0, $vararg_buffer5 = 0, $vararg_buffer8 = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $$byval_copy16 = sp + 48|0;
 $vararg_buffer12 = sp + 40|0;
 $vararg_buffer10 = sp + 32|0;
 $vararg_buffer8 = sp + 24|0;
 $vararg_buffer5 = sp + 16|0;
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = ((($0)) + 4|0); //@line 140524 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 140524 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 140527 "c/sqlite3.c"
 $6 = (((18565 + ($1<<1)|0)) + 1|0); //@line 140545 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 140545 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 140545 "c/sqlite3.c"
 if ($8) {
  $9 = ((($0)) + 1208|0); //@line 140553 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 140553 "c/sqlite3.c"
  $11 = ($5>>>0)<($10>>>0); //@line 140553 "c/sqlite3.c"
  if (!($11)) {
   _yyStackOverflow($0); //@line 140554 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 141801 "c/sqlite3.c"
  }
 }
 L6: do {
  switch ($1|0) {
  case 0:  {
   $12 = ((($4)) + 399|0); //@line 140580 "c/sqlite3.c"
   HEAP8[$12>>0] = 1; //@line 140580 "c/sqlite3.c"
   break;
  }
  case 1:  {
   $13 = ((($4)) + 399|0); //@line 140583 "c/sqlite3.c"
   HEAP8[$13>>0] = 2; //@line 140583 "c/sqlite3.c"
   break;
  }
  case 2:  {
   _sqlite3FinishCoding($4); //@line 140586 "c/sqlite3.c"
   break;
  }
  case 3:  {
   $14 = ((($5)) + -8|0); //@line 140589 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 140589 "c/sqlite3.c"
   _sqlite3BeginTransaction($4,$15); //@line 140589 "c/sqlite3.c"
   break;
  }
  case 4:  {
   $16 = ((($5)) + 16|0); //@line 140592 "c/sqlite3.c"
   HEAP32[$16>>2] = 7; //@line 140592 "c/sqlite3.c"
   break;
  }
  case 7: case 6: case 5:  {
   $17 = ((($5)) + 2|0); //@line 140597 "c/sqlite3.c"
   $18 = HEAP8[$17>>0]|0; //@line 140597 "c/sqlite3.c"
   $19 = $18&255; //@line 140597 "c/sqlite3.c"
   $20 = ((($5)) + 4|0); //@line 140597 "c/sqlite3.c"
   HEAP32[$20>>2] = $19; //@line 140597 "c/sqlite3.c"
   break;
  }
  case 9: case 8:  {
   $21 = ((($5)) + -10|0); //@line 140601 "c/sqlite3.c"
   $22 = HEAP8[$21>>0]|0; //@line 140601 "c/sqlite3.c"
   $23 = $22&255; //@line 140601 "c/sqlite3.c"
   _sqlite3EndTransaction($4,$23); //@line 140601 "c/sqlite3.c"
   break;
  }
  case 10:  {
   $24 = ((($5)) + 4|0); //@line 140605 "c/sqlite3.c"
   _sqlite3Savepoint($4,0,$24); //@line 140605 "c/sqlite3.c"
   break;
  }
  case 11:  {
   $25 = ((($5)) + 4|0); //@line 140610 "c/sqlite3.c"
   _sqlite3Savepoint($4,1,$25); //@line 140610 "c/sqlite3.c"
   break;
  }
  case 12:  {
   $26 = ((($5)) + 4|0); //@line 140615 "c/sqlite3.c"
   _sqlite3Savepoint($4,2,$26); //@line 140615 "c/sqlite3.c"
   break;
  }
  case 13:  {
   $27 = ((($5)) + -8|0); //@line 140620 "c/sqlite3.c"
   $28 = ((($5)) + 4|0); //@line 140620 "c/sqlite3.c"
   $29 = ((($5)) + -44|0); //@line 140620 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 140620 "c/sqlite3.c"
   $31 = ((($5)) + -20|0); //@line 140620 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 140620 "c/sqlite3.c"
   _sqlite3StartTable($4,$27,$28,$30,0,0,$32); //@line 140620 "c/sqlite3.c"
   break;
  }
  case 14:  {
   _disableLookaside($4); //@line 140624 "c/sqlite3.c"
   break;
  }
  case 213: case 90: case 76: case 67: case 57: case 42: case 21: case 18: case 15:  {
   $33 = ((($5)) + 16|0); //@line 140635 "c/sqlite3.c"
   HEAP32[$33>>2] = 0; //@line 140635 "c/sqlite3.c"
   break;
  }
  case 16:  {
   $34 = ((($5)) + -20|0); //@line 140638 "c/sqlite3.c"
   HEAP32[$34>>2] = 1; //@line 140638 "c/sqlite3.c"
   break;
  }
  case 43: case 17:  {
   $35 = ((($5)) + 4|0); //@line 140642 "c/sqlite3.c"
   HEAP32[$35>>2] = 1; //@line 140642 "c/sqlite3.c"
   break;
  }
  case 19:  {
   $36 = ((($5)) + -20|0); //@line 140646 "c/sqlite3.c"
   $37 = ((($5)) + -8|0); //@line 140646 "c/sqlite3.c"
   $38 = ((($5)) + 4|0); //@line 140646 "c/sqlite3.c"
   $39 = HEAP32[$38>>2]|0; //@line 140646 "c/sqlite3.c"
   $40 = $39&255; //@line 140646 "c/sqlite3.c"
   _sqlite3EndTable($4,$36,$37,$40,0); //@line 140646 "c/sqlite3.c"
   break;
  }
  case 20:  {
   $41 = ((($5)) + 4|0); //@line 140651 "c/sqlite3.c"
   $42 = HEAP32[$41>>2]|0; //@line 140651 "c/sqlite3.c"
   _sqlite3EndTable($4,0,0,0,$42); //@line 140651 "c/sqlite3.c"
   $43 = HEAP32[$4>>2]|0; //@line 140652 "c/sqlite3.c"
   $44 = HEAP32[$41>>2]|0; //@line 140652 "c/sqlite3.c"
   _sqlite3SelectDelete($43,$44); //@line 140652 "c/sqlite3.c"
   break;
  }
  case 22:  {
   $45 = ((($5)) + 4|0); //@line 140657 "c/sqlite3.c"
   $46 = ((($5)) + 8|0); //@line 140657 "c/sqlite3.c"
   $47 = HEAP32[$46>>2]|0; //@line 140657 "c/sqlite3.c"
   $48 = ($47|0)==(5); //@line 140657 "c/sqlite3.c"
   if ($48) {
    $49 = HEAP32[$45>>2]|0; //@line 140657 "c/sqlite3.c"
    $50 = (_sqlite3_strnicmp($49,19225,5)|0); //@line 140657 "c/sqlite3.c"
    $51 = ($50|0)==(0); //@line 140657 "c/sqlite3.c"
    if ($51) {
     $52 = ((($5)) + -8|0); //@line 140658 "c/sqlite3.c"
     HEAP32[$52>>2] = 96; //@line 140658 "c/sqlite3.c"
     break L6;
    }
   }
   $53 = ((($5)) + -8|0); //@line 140660 "c/sqlite3.c"
   HEAP32[$53>>2] = 0; //@line 140660 "c/sqlite3.c"
   $54 = HEAP32[$45>>2]|0; //@line 140661 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $47; //@line 140661 "c/sqlite3.c"
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 140661 "c/sqlite3.c"
   HEAP32[$vararg_ptr1>>2] = $54; //@line 140661 "c/sqlite3.c"
   _sqlite3ErrorMsg($4,19231,$vararg_buffer); //@line 140661 "c/sqlite3.c"
   break;
  }
  case 23:  {
   $55 = ((($5)) + -8|0); //@line 140666 "c/sqlite3.c"
   $56 = ((($5)) + 4|0); //@line 140666 "c/sqlite3.c"
   _sqlite3AddColumn($4,$55,$56); //@line 140666 "c/sqlite3.c"
   break;
  }
  case 96: case 60: case 24:  {
   $57 = ((($5)) + 20|0); //@line 140671 "c/sqlite3.c"
   HEAP32[$57>>2] = 0; //@line 140671 "c/sqlite3.c"
   $58 = ((($5)) + 16|0); //@line 140671 "c/sqlite3.c"
   HEAP32[$58>>2] = 0; //@line 140671 "c/sqlite3.c"
   break;
  }
  case 25:  {
   $59 = ((($5)) + 4|0); //@line 140675 "c/sqlite3.c"
   $60 = HEAP32[$59>>2]|0; //@line 140675 "c/sqlite3.c"
   $61 = ((($5)) + 8|0); //@line 140675 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 140675 "c/sqlite3.c"
   $63 = (($60) + ($62)|0); //@line 140675 "c/sqlite3.c"
   $64 = ((($5)) + -32|0); //@line 140675 "c/sqlite3.c"
   $65 = HEAP32[$64>>2]|0; //@line 140675 "c/sqlite3.c"
   $66 = $63; //@line 140675 "c/sqlite3.c"
   $67 = (($66) - ($65))|0; //@line 140675 "c/sqlite3.c"
   $68 = ((($5)) + -28|0); //@line 140675 "c/sqlite3.c"
   HEAP32[$68>>2] = $67; //@line 140675 "c/sqlite3.c"
   break;
  }
  case 26:  {
   $69 = ((($5)) + 4|0); //@line 140680 "c/sqlite3.c"
   $70 = HEAP32[$69>>2]|0; //@line 140680 "c/sqlite3.c"
   $71 = ((($5)) + 8|0); //@line 140680 "c/sqlite3.c"
   $72 = HEAP32[$71>>2]|0; //@line 140680 "c/sqlite3.c"
   $73 = (($70) + ($72)|0); //@line 140680 "c/sqlite3.c"
   $74 = ((($5)) + -56|0); //@line 140680 "c/sqlite3.c"
   $75 = HEAP32[$74>>2]|0; //@line 140680 "c/sqlite3.c"
   $76 = $73; //@line 140680 "c/sqlite3.c"
   $77 = (($76) - ($75))|0; //@line 140680 "c/sqlite3.c"
   $78 = ((($5)) + -52|0); //@line 140680 "c/sqlite3.c"
   HEAP32[$78>>2] = $77; //@line 140680 "c/sqlite3.c"
   break;
  }
  case 27:  {
   $79 = ((($5)) + 8|0); //@line 140684 "c/sqlite3.c"
   $80 = HEAP32[$79>>2]|0; //@line 140684 "c/sqlite3.c"
   $81 = ((($5)) + 4|0); //@line 140684 "c/sqlite3.c"
   $82 = HEAP32[$81>>2]|0; //@line 140684 "c/sqlite3.c"
   $83 = ((($5)) + -8|0); //@line 140684 "c/sqlite3.c"
   $84 = HEAP32[$83>>2]|0; //@line 140684 "c/sqlite3.c"
   $85 = (($82) + ($80))|0; //@line 140684 "c/sqlite3.c"
   $86 = (($85) - ($84))|0; //@line 140684 "c/sqlite3.c"
   $87 = ((($5)) + -4|0); //@line 140684 "c/sqlite3.c"
   HEAP32[$87>>2] = $86; //@line 140684 "c/sqlite3.c"
   break;
  }
  case 28:  {
   $88 = HEAP32[$2>>2]|0; //@line 140689 "c/sqlite3.c"
   $89 = ((($5)) + 16|0); //@line 140689 "c/sqlite3.c"
   HEAP32[$89>>2] = $88; //@line 140689 "c/sqlite3.c"
   break;
  }
  case 62: case 29:  {
   $90 = ((($4)) + 80|0); //@line 140694 "c/sqlite3.c"
   $91 = ((($5)) + 4|0); //@line 140694 "c/sqlite3.c"
   $92 = $91; //@line 140694 "c/sqlite3.c"
   $93 = $92; //@line 140694 "c/sqlite3.c"
   $94 = HEAP32[$93>>2]|0; //@line 140694 "c/sqlite3.c"
   $95 = (($92) + 4)|0; //@line 140694 "c/sqlite3.c"
   $96 = $95; //@line 140694 "c/sqlite3.c"
   $97 = HEAP32[$96>>2]|0; //@line 140694 "c/sqlite3.c"
   $98 = $90; //@line 140694 "c/sqlite3.c"
   $99 = $98; //@line 140694 "c/sqlite3.c"
   HEAP32[$99>>2] = $94; //@line 140694 "c/sqlite3.c"
   $100 = (($98) + 4)|0; //@line 140694 "c/sqlite3.c"
   $101 = $100; //@line 140694 "c/sqlite3.c"
   HEAP32[$101>>2] = $97; //@line 140694 "c/sqlite3.c"
   break;
  }
  case 30:  {
   $102 = ((($5)) + -8|0); //@line 140697 "c/sqlite3.c"
   $103 = HEAP32[$102>>2]|0; //@line 140697 "c/sqlite3.c"
   $104 = ((($5)) + -20|0); //@line 140697 "c/sqlite3.c"
   $105 = HEAP32[$104>>2]|0; //@line 140697 "c/sqlite3.c"
   $106 = ((($5)) + 4|0); //@line 140697 "c/sqlite3.c"
   $107 = HEAP32[$106>>2]|0; //@line 140697 "c/sqlite3.c"
   _sqlite3AddDefaultValue($4,$103,$105,$107); //@line 140697 "c/sqlite3.c"
   break;
  }
  case 31:  {
   $108 = ((($5)) + -8|0); //@line 140700 "c/sqlite3.c"
   $109 = HEAP32[$108>>2]|0; //@line 140700 "c/sqlite3.c"
   $110 = ((($5)) + -20|0); //@line 140700 "c/sqlite3.c"
   $111 = HEAP32[$110>>2]|0; //@line 140700 "c/sqlite3.c"
   $112 = ((($111)) + 1|0); //@line 140700 "c/sqlite3.c"
   $113 = ((($5)) + 4|0); //@line 140700 "c/sqlite3.c"
   $114 = HEAP32[$113>>2]|0; //@line 140700 "c/sqlite3.c"
   _sqlite3AddDefaultValue($4,$109,$112,$114); //@line 140700 "c/sqlite3.c"
   break;
  }
  case 32:  {
   $115 = ((($5)) + -8|0); //@line 140703 "c/sqlite3.c"
   $116 = HEAP32[$115>>2]|0; //@line 140703 "c/sqlite3.c"
   $117 = ((($5)) + -20|0); //@line 140703 "c/sqlite3.c"
   $118 = HEAP32[$117>>2]|0; //@line 140703 "c/sqlite3.c"
   $119 = ((($5)) + 4|0); //@line 140703 "c/sqlite3.c"
   $120 = HEAP32[$119>>2]|0; //@line 140703 "c/sqlite3.c"
   _sqlite3AddDefaultValue($4,$116,$118,$120); //@line 140703 "c/sqlite3.c"
   break;
  }
  case 33:  {
   $121 = ((($5)) + -8|0); //@line 140707 "c/sqlite3.c"
   $122 = HEAP32[$121>>2]|0; //@line 140707 "c/sqlite3.c"
   $123 = (_sqlite3PExpr($4,148,$122,0)|0); //@line 140707 "c/sqlite3.c"
   $124 = ((($5)) + -20|0); //@line 140708 "c/sqlite3.c"
   $125 = HEAP32[$124>>2]|0; //@line 140708 "c/sqlite3.c"
   $126 = ((($5)) + 4|0); //@line 140708 "c/sqlite3.c"
   $127 = HEAP32[$126>>2]|0; //@line 140708 "c/sqlite3.c"
   _sqlite3AddDefaultValue($4,$123,$125,$127); //@line 140708 "c/sqlite3.c"
   break;
  }
  case 34:  {
   $128 = ((($5)) + 4|0); //@line 140713 "c/sqlite3.c"
   ;HEAP32[$$byval_copy16>>2]=HEAP32[$128>>2]|0;HEAP32[$$byval_copy16+4>>2]=HEAP32[$128+4>>2]|0; //@line 140713 "c/sqlite3.c"
   $129 = (_tokenExpr($4,97,$$byval_copy16)|0); //@line 140713 "c/sqlite3.c"
   $130 = HEAP32[$128>>2]|0; //@line 140714 "c/sqlite3.c"
   $131 = ((($5)) + 8|0); //@line 140714 "c/sqlite3.c"
   $132 = HEAP32[$131>>2]|0; //@line 140714 "c/sqlite3.c"
   $133 = (($130) + ($132)|0); //@line 140714 "c/sqlite3.c"
   _sqlite3AddDefaultValue($4,$129,$130,$133); //@line 140714 "c/sqlite3.c"
   break;
  }
  case 35:  {
   $134 = ((($5)) + 4|0); //@line 140718 "c/sqlite3.c"
   $135 = HEAP32[$134>>2]|0; //@line 140718 "c/sqlite3.c"
   _sqlite3AddNotNull($4,$135); //@line 140718 "c/sqlite3.c"
   break;
  }
  case 36:  {
   $136 = ((($5)) + -8|0); //@line 140721 "c/sqlite3.c"
   $137 = HEAP32[$136>>2]|0; //@line 140721 "c/sqlite3.c"
   $138 = ((($5)) + 4|0); //@line 140721 "c/sqlite3.c"
   $139 = HEAP32[$138>>2]|0; //@line 140721 "c/sqlite3.c"
   $140 = ((($5)) + -20|0); //@line 140721 "c/sqlite3.c"
   $141 = HEAP32[$140>>2]|0; //@line 140721 "c/sqlite3.c"
   _sqlite3AddPrimaryKey($4,0,$137,$139,$141); //@line 140721 "c/sqlite3.c"
   break;
  }
  case 37:  {
   $142 = ((($5)) + 4|0); //@line 140724 "c/sqlite3.c"
   $143 = HEAP32[$142>>2]|0; //@line 140724 "c/sqlite3.c"
   _sqlite3CreateIndex($4,0,0,0,0,$143,0,0,0,0,1); //@line 140724 "c/sqlite3.c"
   break;
  }
  case 38:  {
   $144 = ((($5)) + -8|0); //@line 140728 "c/sqlite3.c"
   $145 = HEAP32[$144>>2]|0; //@line 140728 "c/sqlite3.c"
   _sqlite3AddCheckConstraint($4,$145); //@line 140728 "c/sqlite3.c"
   break;
  }
  case 39:  {
   $146 = ((($5)) + -20|0); //@line 140731 "c/sqlite3.c"
   $147 = ((($5)) + -8|0); //@line 140731 "c/sqlite3.c"
   $148 = HEAP32[$147>>2]|0; //@line 140731 "c/sqlite3.c"
   $149 = ((($5)) + 4|0); //@line 140731 "c/sqlite3.c"
   $150 = HEAP32[$149>>2]|0; //@line 140731 "c/sqlite3.c"
   _sqlite3CreateForeignKey($4,0,$146,$148,$150); //@line 140731 "c/sqlite3.c"
   break;
  }
  case 40:  {
   $151 = ((($5)) + 4|0); //@line 140734 "c/sqlite3.c"
   $152 = HEAP32[$151>>2]|0; //@line 140734 "c/sqlite3.c"
   _sqlite3DeferForeignKey($4,$152); //@line 140734 "c/sqlite3.c"
   break;
  }
  case 41:  {
   $153 = ((($5)) + 4|0); //@line 140737 "c/sqlite3.c"
   _sqlite3AddCollateType($4,$153); //@line 140737 "c/sqlite3.c"
   break;
  }
  case 44:  {
   $154 = ((($5)) + 16|0); //@line 140740 "c/sqlite3.c"
   HEAP32[$154>>2] = 0; //@line 140740 "c/sqlite3.c"
   break;
  }
  case 45:  {
   $155 = ((($5)) + -8|0); //@line 140743 "c/sqlite3.c"
   $156 = HEAP32[$155>>2]|0; //@line 140743 "c/sqlite3.c"
   $157 = ((($5)) + 4|0); //@line 140743 "c/sqlite3.c"
   $158 = ((($5)) + 8|0); //@line 140743 "c/sqlite3.c"
   $159 = HEAP32[$158>>2]|0; //@line 140743 "c/sqlite3.c"
   $160 = $159 ^ -1; //@line 140743 "c/sqlite3.c"
   $161 = $156 & $160; //@line 140743 "c/sqlite3.c"
   $162 = HEAP32[$157>>2]|0; //@line 140743 "c/sqlite3.c"
   $163 = $161 | $162; //@line 140743 "c/sqlite3.c"
   HEAP32[$155>>2] = $163; //@line 140743 "c/sqlite3.c"
   break;
  }
  case 46:  {
   $164 = ((($5)) + -8|0); //@line 140746 "c/sqlite3.c"
   HEAP32[$164>>2] = 0; //@line 140746 "c/sqlite3.c"
   $165 = ((($5)) + -4|0); //@line 140746 "c/sqlite3.c"
   HEAP32[$165>>2] = 0; //@line 140746 "c/sqlite3.c"
   break;
  }
  case 47:  {
   $166 = ((($5)) + -20|0); //@line 140749 "c/sqlite3.c"
   HEAP32[$166>>2] = 0; //@line 140749 "c/sqlite3.c"
   $167 = ((($5)) + -16|0); //@line 140749 "c/sqlite3.c"
   HEAP32[$167>>2] = 0; //@line 140749 "c/sqlite3.c"
   break;
  }
  case 48:  {
   $168 = ((($5)) + 4|0); //@line 140752 "c/sqlite3.c"
   $169 = HEAP32[$168>>2]|0; //@line 140752 "c/sqlite3.c"
   $170 = ((($5)) + -20|0); //@line 140752 "c/sqlite3.c"
   HEAP32[$170>>2] = $169; //@line 140752 "c/sqlite3.c"
   $171 = ((($5)) + -16|0); //@line 140752 "c/sqlite3.c"
   HEAP32[$171>>2] = 255; //@line 140752 "c/sqlite3.c"
   break;
  }
  case 49:  {
   $172 = ((($5)) + 4|0); //@line 140755 "c/sqlite3.c"
   $173 = HEAP32[$172>>2]|0; //@line 140755 "c/sqlite3.c"
   $174 = $173 << 8; //@line 140755 "c/sqlite3.c"
   $175 = ((($5)) + -20|0); //@line 140755 "c/sqlite3.c"
   HEAP32[$175>>2] = $174; //@line 140755 "c/sqlite3.c"
   $176 = ((($5)) + -16|0); //@line 140755 "c/sqlite3.c"
   HEAP32[$176>>2] = 65280; //@line 140755 "c/sqlite3.c"
   break;
  }
  case 50:  {
   $177 = ((($5)) + -8|0); //@line 140758 "c/sqlite3.c"
   HEAP32[$177>>2] = 7; //@line 140758 "c/sqlite3.c"
   break;
  }
  case 51:  {
   $178 = ((($5)) + -8|0); //@line 140761 "c/sqlite3.c"
   HEAP32[$178>>2] = 8; //@line 140761 "c/sqlite3.c"
   break;
  }
  case 52:  {
   $179 = ((($5)) + 4|0); //@line 140764 "c/sqlite3.c"
   HEAP32[$179>>2] = 9; //@line 140764 "c/sqlite3.c"
   break;
  }
  case 53:  {
   $180 = ((($5)) + 4|0); //@line 140767 "c/sqlite3.c"
   HEAP32[$180>>2] = 6; //@line 140767 "c/sqlite3.c"
   break;
  }
  case 54:  {
   $181 = ((($5)) + -8|0); //@line 140770 "c/sqlite3.c"
   HEAP32[$181>>2] = 0; //@line 140770 "c/sqlite3.c"
   break;
  }
  case 55:  {
   $182 = ((($5)) + -20|0); //@line 140773 "c/sqlite3.c"
   HEAP32[$182>>2] = 0; //@line 140773 "c/sqlite3.c"
   break;
  }
  case 144: case 71: case 56:  {
   $183 = ((($5)) + 4|0); //@line 140778 "c/sqlite3.c"
   $184 = HEAP32[$183>>2]|0; //@line 140778 "c/sqlite3.c"
   $185 = ((($5)) + -8|0); //@line 140778 "c/sqlite3.c"
   HEAP32[$185>>2] = $184; //@line 140778 "c/sqlite3.c"
   break;
  }
  case 214: case 188: case 185: case 75: case 58:  {
   $186 = ((($5)) + -8|0); //@line 140785 "c/sqlite3.c"
   HEAP32[$186>>2] = 1; //@line 140785 "c/sqlite3.c"
   break;
  }
  case 59:  {
   $187 = ((($5)) + -8|0); //@line 140788 "c/sqlite3.c"
   HEAP32[$187>>2] = 0; //@line 140788 "c/sqlite3.c"
   break;
  }
  case 61:  {
   $188 = ((($4)) + 84|0); //@line 140791 "c/sqlite3.c"
   HEAP32[$188>>2] = 0; //@line 140791 "c/sqlite3.c"
   break;
  }
  case 63:  {
   $189 = ((($5)) + -32|0); //@line 140794 "c/sqlite3.c"
   $190 = HEAP32[$189>>2]|0; //@line 140794 "c/sqlite3.c"
   $191 = ((($5)) + 4|0); //@line 140794 "c/sqlite3.c"
   $192 = HEAP32[$191>>2]|0; //@line 140794 "c/sqlite3.c"
   $193 = ((($5)) + -20|0); //@line 140794 "c/sqlite3.c"
   $194 = HEAP32[$193>>2]|0; //@line 140794 "c/sqlite3.c"
   _sqlite3AddPrimaryKey($4,$190,$192,$194,0); //@line 140794 "c/sqlite3.c"
   break;
  }
  case 64:  {
   $195 = ((($5)) + -20|0); //@line 140797 "c/sqlite3.c"
   $196 = HEAP32[$195>>2]|0; //@line 140797 "c/sqlite3.c"
   $197 = ((($5)) + 4|0); //@line 140797 "c/sqlite3.c"
   $198 = HEAP32[$197>>2]|0; //@line 140797 "c/sqlite3.c"
   _sqlite3CreateIndex($4,0,0,0,$196,$198,0,0,0,0,1); //@line 140797 "c/sqlite3.c"
   break;
  }
  case 65:  {
   $199 = ((($5)) + -20|0); //@line 140801 "c/sqlite3.c"
   $200 = HEAP32[$199>>2]|0; //@line 140801 "c/sqlite3.c"
   _sqlite3AddCheckConstraint($4,$200); //@line 140801 "c/sqlite3.c"
   break;
  }
  case 66:  {
   $201 = ((($5)) + -68|0); //@line 140805 "c/sqlite3.c"
   $202 = HEAP32[$201>>2]|0; //@line 140805 "c/sqlite3.c"
   $203 = ((($5)) + -32|0); //@line 140805 "c/sqlite3.c"
   $204 = ((($5)) + -20|0); //@line 140805 "c/sqlite3.c"
   $205 = HEAP32[$204>>2]|0; //@line 140805 "c/sqlite3.c"
   $206 = ((($5)) + -8|0); //@line 140805 "c/sqlite3.c"
   $207 = HEAP32[$206>>2]|0; //@line 140805 "c/sqlite3.c"
   _sqlite3CreateForeignKey($4,$202,$203,$205,$207); //@line 140805 "c/sqlite3.c"
   $208 = ((($5)) + 4|0); //@line 140806 "c/sqlite3.c"
   $209 = HEAP32[$208>>2]|0; //@line 140806 "c/sqlite3.c"
   _sqlite3DeferForeignKey($4,$209); //@line 140806 "c/sqlite3.c"
   break;
  }
  case 70: case 68:  {
   $210 = ((($5)) + 16|0); //@line 140811 "c/sqlite3.c"
   HEAP32[$210>>2] = 10; //@line 140811 "c/sqlite3.c"
   break;
  }
  case 69:  {
   $211 = ((($5)) + 4|0); //@line 140814 "c/sqlite3.c"
   $212 = HEAP32[$211>>2]|0; //@line 140814 "c/sqlite3.c"
   $213 = ((($5)) + -20|0); //@line 140814 "c/sqlite3.c"
   HEAP32[$213>>2] = $212; //@line 140814 "c/sqlite3.c"
   break;
  }
  case 72:  {
   $214 = ((($5)) + 4|0); //@line 140817 "c/sqlite3.c"
   HEAP32[$214>>2] = 4; //@line 140817 "c/sqlite3.c"
   break;
  }
  case 145: case 73:  {
   $215 = ((($5)) + 4|0); //@line 140821 "c/sqlite3.c"
   HEAP32[$215>>2] = 5; //@line 140821 "c/sqlite3.c"
   break;
  }
  case 74:  {
   $216 = ((($5)) + 4|0); //@line 140825 "c/sqlite3.c"
   $217 = HEAP32[$216>>2]|0; //@line 140825 "c/sqlite3.c"
   $218 = ((($5)) + -8|0); //@line 140825 "c/sqlite3.c"
   $219 = HEAP32[$218>>2]|0; //@line 140825 "c/sqlite3.c"
   _sqlite3DropTable($4,$217,0,$219); //@line 140825 "c/sqlite3.c"
   break;
  }
  case 77:  {
   $220 = ((($5)) + -92|0); //@line 140830 "c/sqlite3.c"
   $221 = ((($5)) + -44|0); //@line 140830 "c/sqlite3.c"
   $222 = ((($5)) + -32|0); //@line 140830 "c/sqlite3.c"
   $223 = ((($5)) + -20|0); //@line 140830 "c/sqlite3.c"
   $224 = HEAP32[$223>>2]|0; //@line 140830 "c/sqlite3.c"
   $225 = ((($5)) + 4|0); //@line 140830 "c/sqlite3.c"
   $226 = HEAP32[$225>>2]|0; //@line 140830 "c/sqlite3.c"
   $227 = ((($5)) + -80|0); //@line 140830 "c/sqlite3.c"
   $228 = HEAP32[$227>>2]|0; //@line 140830 "c/sqlite3.c"
   $229 = ((($5)) + -56|0); //@line 140830 "c/sqlite3.c"
   $230 = HEAP32[$229>>2]|0; //@line 140830 "c/sqlite3.c"
   _sqlite3CreateView($4,$220,$221,$222,$224,$226,$228,$230); //@line 140830 "c/sqlite3.c"
   break;
  }
  case 78:  {
   $231 = ((($5)) + 4|0); //@line 140835 "c/sqlite3.c"
   $232 = HEAP32[$231>>2]|0; //@line 140835 "c/sqlite3.c"
   $233 = ((($5)) + -8|0); //@line 140835 "c/sqlite3.c"
   $234 = HEAP32[$233>>2]|0; //@line 140835 "c/sqlite3.c"
   _sqlite3DropTable($4,$232,1,$234); //@line 140835 "c/sqlite3.c"
   break;
  }
  case 79:  {
   ;HEAP32[$$byval_copy16>>2]=HEAP32[4956>>2]|0;HEAP32[$$byval_copy16+4>>2]=HEAP32[4956+4>>2]|0;HEAP32[$$byval_copy16+8>>2]=HEAP32[4956+8>>2]|0;HEAP32[$$byval_copy16+12>>2]=HEAP32[4956+12>>2]|0;HEAP32[$$byval_copy16+16>>2]=HEAP32[4956+16>>2]|0;HEAP32[$$byval_copy16+20>>2]=HEAP32[4956+20>>2]|0; //@line 140840 "c/sqlite3.c"
   $235 = ((($5)) + 4|0); //@line 140841 "c/sqlite3.c"
   $236 = HEAP32[$235>>2]|0; //@line 140841 "c/sqlite3.c"
   (_sqlite3Select($4,$236,$$byval_copy16)|0); //@line 140841 "c/sqlite3.c"
   $237 = HEAP32[$4>>2]|0; //@line 140842 "c/sqlite3.c"
   $238 = HEAP32[$235>>2]|0; //@line 140842 "c/sqlite3.c"
   _sqlite3SelectDelete($237,$238); //@line 140842 "c/sqlite3.c"
   break;
  }
  case 80:  {
   $239 = ((($5)) + 4|0); //@line 140847 "c/sqlite3.c"
   $240 = HEAP32[$239>>2]|0; //@line 140847 "c/sqlite3.c"
   $241 = ($240|0)==(0|0); //@line 140848 "c/sqlite3.c"
   if ($241) {
    $245 = HEAP32[$4>>2]|0; //@line 140852 "c/sqlite3.c"
    $246 = ((($5)) + -8|0); //@line 140852 "c/sqlite3.c"
    $247 = HEAP32[$246>>2]|0; //@line 140852 "c/sqlite3.c"
    _sqlite3WithDelete($245,$247); //@line 140852 "c/sqlite3.c"
   } else {
    $242 = ((($5)) + -8|0); //@line 140849 "c/sqlite3.c"
    $243 = HEAP32[$242>>2]|0; //@line 140849 "c/sqlite3.c"
    $244 = ((($240)) + 60|0); //@line 140849 "c/sqlite3.c"
    HEAP32[$244>>2] = $243; //@line 140849 "c/sqlite3.c"
    _parserDoubleLinkSelect($4,$240); //@line 140850 "c/sqlite3.c"
   }
   $248 = ((($5)) + -8|0); //@line 140854 "c/sqlite3.c"
   HEAP32[$248>>2] = $240; //@line 140854 "c/sqlite3.c"
   break;
  }
  case 81:  {
   $249 = ((($5)) + 4|0); //@line 140859 "c/sqlite3.c"
   $250 = HEAP32[$249>>2]|0; //@line 140859 "c/sqlite3.c"
   $251 = ((($5)) + -20|0); //@line 140860 "c/sqlite3.c"
   $252 = HEAP32[$251>>2]|0; //@line 140860 "c/sqlite3.c"
   $253 = ($250|0)==(0|0); //@line 140861 "c/sqlite3.c"
   do {
    if ($253) {
     label = 84;
    } else {
     $254 = ((($250)) + 48|0); //@line 140861 "c/sqlite3.c"
     $255 = HEAP32[$254>>2]|0; //@line 140861 "c/sqlite3.c"
     $256 = ($255|0)==(0|0); //@line 140861 "c/sqlite3.c"
     if ($256) {
      $$04 = $250;
     } else {
      $257 = ((($$byval_copy16)) + 4|0); //@line 140864 "c/sqlite3.c"
      HEAP32[$257>>2] = 0; //@line 140864 "c/sqlite3.c"
      _parserDoubleLinkSelect($4,$250); //@line 140865 "c/sqlite3.c"
      $258 = (_sqlite3SrcListAppendFromTerm($4,0,0,0,$$byval_copy16,$250,0,0)|0); //@line 140866 "c/sqlite3.c"
      $259 = (_sqlite3SelectNew($4,0,$258,0,0,0,0,0,0)|0); //@line 140867 "c/sqlite3.c"
      $260 = ($259|0)==(0|0); //@line 140869 "c/sqlite3.c"
      if ($260) {
       label = 84;
       break;
      } else {
       $$04 = $259;
      }
     }
     $261 = ((($5)) + -8|0); //@line 140870 "c/sqlite3.c"
     $262 = HEAP32[$261>>2]|0; //@line 140870 "c/sqlite3.c"
     $263 = $262&255; //@line 140870 "c/sqlite3.c"
     $264 = ((($$04)) + 4|0); //@line 140870 "c/sqlite3.c"
     HEAP8[$264>>0] = $263; //@line 140870 "c/sqlite3.c"
     $265 = ((($$04)) + 48|0); //@line 140871 "c/sqlite3.c"
     HEAP32[$265>>2] = $252; //@line 140871 "c/sqlite3.c"
     $266 = ($252|0)==(0|0); //@line 140872 "c/sqlite3.c"
     if (!($266)) {
      $267 = ((($252)) + 8|0); //@line 140872 "c/sqlite3.c"
      $268 = HEAP32[$267>>2]|0; //@line 140872 "c/sqlite3.c"
      $269 = $268 & -1025; //@line 140872 "c/sqlite3.c"
      HEAP32[$267>>2] = $269; //@line 140872 "c/sqlite3.c"
     }
     $270 = ((($$04)) + 8|0); //@line 140873 "c/sqlite3.c"
     $271 = HEAP32[$270>>2]|0; //@line 140873 "c/sqlite3.c"
     $272 = $271 & -1025; //@line 140873 "c/sqlite3.c"
     HEAP32[$270>>2] = $272; //@line 140873 "c/sqlite3.c"
     $273 = HEAP32[$261>>2]|0; //@line 140874 "c/sqlite3.c"
     $274 = ($273|0)==(116); //@line 140874 "c/sqlite3.c"
     if ($274) {
      $$01 = $$04;
     } else {
      $275 = ((($4)) + 22|0); //@line 140874 "c/sqlite3.c"
      HEAP8[$275>>0] = 1; //@line 140874 "c/sqlite3.c"
      $$01 = $$04;
     }
    }
   } while(0);
   if ((label|0) == 84) {
    $276 = HEAP32[$4>>2]|0; //@line 140876 "c/sqlite3.c"
    _sqlite3SelectDelete($276,$252); //@line 140876 "c/sqlite3.c"
    $$01 = 0;
   }
   HEAP32[$251>>2] = $$01; //@line 140878 "c/sqlite3.c"
   break;
  }
  case 84: case 82:  {
   $277 = ((($5)) + 2|0); //@line 140883 "c/sqlite3.c"
   $278 = HEAP8[$277>>0]|0; //@line 140883 "c/sqlite3.c"
   $279 = $278&255; //@line 140883 "c/sqlite3.c"
   $280 = ((($5)) + 4|0); //@line 140883 "c/sqlite3.c"
   HEAP32[$280>>2] = $279; //@line 140883 "c/sqlite3.c"
   break;
  }
  case 83:  {
   $281 = ((($5)) + -8|0); //@line 140886 "c/sqlite3.c"
   HEAP32[$281>>2] = 116; //@line 140886 "c/sqlite3.c"
   break;
  }
  case 85:  {
   $282 = ((($5)) + -68|0); //@line 140893 "c/sqlite3.c"
   $283 = HEAP32[$282>>2]|0; //@line 140893 "c/sqlite3.c"
   $284 = ((($5)) + -56|0); //@line 140893 "c/sqlite3.c"
   $285 = HEAP32[$284>>2]|0; //@line 140893 "c/sqlite3.c"
   $286 = ((($5)) + -44|0); //@line 140893 "c/sqlite3.c"
   $287 = HEAP32[$286>>2]|0; //@line 140893 "c/sqlite3.c"
   $288 = ((($5)) + -32|0); //@line 140893 "c/sqlite3.c"
   $289 = HEAP32[$288>>2]|0; //@line 140893 "c/sqlite3.c"
   $290 = ((($5)) + -20|0); //@line 140893 "c/sqlite3.c"
   $291 = HEAP32[$290>>2]|0; //@line 140893 "c/sqlite3.c"
   $292 = ((($5)) + -8|0); //@line 140893 "c/sqlite3.c"
   $293 = HEAP32[$292>>2]|0; //@line 140893 "c/sqlite3.c"
   $294 = ((($5)) + -80|0); //@line 140893 "c/sqlite3.c"
   $295 = HEAP32[$294>>2]|0; //@line 140893 "c/sqlite3.c"
   $296 = ((($5)) + 4|0); //@line 140893 "c/sqlite3.c"
   $297 = HEAP32[$296>>2]|0; //@line 140893 "c/sqlite3.c"
   $298 = (_sqlite3SelectNew($4,$283,$285,$287,$289,$291,$293,$295,$297)|0); //@line 140893 "c/sqlite3.c"
   $299 = ((($5)) + -92|0); //@line 140893 "c/sqlite3.c"
   HEAP32[$299>>2] = $298; //@line 140893 "c/sqlite3.c"
   break;
  }
  case 86:  {
   $300 = ((($5)) + -8|0); //@line 140922 "c/sqlite3.c"
   $301 = HEAP32[$300>>2]|0; //@line 140922 "c/sqlite3.c"
   $302 = (_sqlite3SelectNew($4,$301,0,0,0,0,0,512,0)|0); //@line 140922 "c/sqlite3.c"
   $303 = ((($5)) + -32|0); //@line 140922 "c/sqlite3.c"
   HEAP32[$303>>2] = $302; //@line 140922 "c/sqlite3.c"
   break;
  }
  case 87:  {
   $304 = ((($5)) + -44|0); //@line 140927 "c/sqlite3.c"
   $305 = HEAP32[$304>>2]|0; //@line 140927 "c/sqlite3.c"
   $306 = ((($5)) + -8|0); //@line 140928 "c/sqlite3.c"
   $307 = HEAP32[$306>>2]|0; //@line 140928 "c/sqlite3.c"
   $308 = (_sqlite3SelectNew($4,$307,0,0,0,0,0,1536,0)|0); //@line 140928 "c/sqlite3.c"
   $309 = ($305|0)==(0|0); //@line 140929 "c/sqlite3.c"
   if (!($309)) {
    $310 = ((($305)) + 8|0); //@line 140929 "c/sqlite3.c"
    $311 = HEAP32[$310>>2]|0; //@line 140929 "c/sqlite3.c"
    $312 = $311 & -1025; //@line 140929 "c/sqlite3.c"
    HEAP32[$310>>2] = $312; //@line 140929 "c/sqlite3.c"
   }
   $313 = ($308|0)==(0|0); //@line 140930 "c/sqlite3.c"
   if ($313) {
    $storemerge = $305;
   } else {
    $314 = ((($308)) + 4|0); //@line 140931 "c/sqlite3.c"
    HEAP8[$314>>0] = 116; //@line 140931 "c/sqlite3.c"
    $315 = ((($308)) + 48|0); //@line 140932 "c/sqlite3.c"
    HEAP32[$315>>2] = $305; //@line 140932 "c/sqlite3.c"
    $storemerge = $308;
   }
   HEAP32[$304>>2] = $storemerge;
   break;
  }
  case 88:  {
   $316 = ((($5)) + 4|0); //@line 140940 "c/sqlite3.c"
   HEAP32[$316>>2] = 1; //@line 140940 "c/sqlite3.c"
   break;
  }
  case 89:  {
   $317 = ((($5)) + 4|0); //@line 140943 "c/sqlite3.c"
   HEAP32[$317>>2] = 2; //@line 140943 "c/sqlite3.c"
   break;
  }
  case 209: case 204: case 201: case 126: case 119: case 91:  {
   $318 = ((($5)) + 16|0); //@line 140951 "c/sqlite3.c"
   HEAP32[$318>>2] = 0; //@line 140951 "c/sqlite3.c"
   break;
  }
  case 92:  {
   $319 = ((($5)) + -44|0); //@line 140955 "c/sqlite3.c"
   $320 = HEAP32[$319>>2]|0; //@line 140955 "c/sqlite3.c"
   $321 = ((($5)) + -20|0); //@line 140955 "c/sqlite3.c"
   $322 = HEAP32[$321>>2]|0; //@line 140955 "c/sqlite3.c"
   $323 = (_sqlite3ExprListAppend($4,$320,$322)|0); //@line 140955 "c/sqlite3.c"
   HEAP32[$319>>2] = $323; //@line 140955 "c/sqlite3.c"
   $324 = ((($5)) + 8|0); //@line 140956 "c/sqlite3.c"
   $325 = HEAP32[$324>>2]|0; //@line 140956 "c/sqlite3.c"
   $326 = ($325|0)==(0); //@line 140956 "c/sqlite3.c"
   if (!($326)) {
    $327 = ((($5)) + 4|0); //@line 140956 "c/sqlite3.c"
    _sqlite3ExprListSetName($4,$323,$327,1); //@line 140956 "c/sqlite3.c"
   }
   $328 = HEAP32[$319>>2]|0; //@line 140957 "c/sqlite3.c"
   $329 = ((($5)) + -32|0); //@line 140957 "c/sqlite3.c"
   $330 = HEAP32[$329>>2]|0; //@line 140957 "c/sqlite3.c"
   $331 = ((($5)) + -8|0); //@line 140957 "c/sqlite3.c"
   $332 = HEAP32[$331>>2]|0; //@line 140957 "c/sqlite3.c"
   _sqlite3ExprListSetSpan($4,$328,$330,$332); //@line 140957 "c/sqlite3.c"
   break;
  }
  case 93:  {
   $333 = HEAP32[$4>>2]|0; //@line 140962 "c/sqlite3.c"
   $334 = (_sqlite3Expr($333,154,0)|0); //@line 140962 "c/sqlite3.c"
   $335 = ((($5)) + -20|0); //@line 140963 "c/sqlite3.c"
   $336 = HEAP32[$335>>2]|0; //@line 140963 "c/sqlite3.c"
   $337 = (_sqlite3ExprListAppend($4,$336,$334)|0); //@line 140963 "c/sqlite3.c"
   HEAP32[$335>>2] = $337; //@line 140963 "c/sqlite3.c"
   break;
  }
  case 94:  {
   $338 = (_sqlite3PExpr($4,154,0,0)|0); //@line 140968 "c/sqlite3.c"
   $339 = HEAP32[$4>>2]|0; //@line 140969 "c/sqlite3.c"
   $340 = ((($5)) + -20|0); //@line 140969 "c/sqlite3.c"
   $341 = (_sqlite3ExprAlloc($339,59,$340,1)|0); //@line 140969 "c/sqlite3.c"
   $342 = (_sqlite3PExpr($4,122,$341,$338)|0); //@line 140970 "c/sqlite3.c"
   $343 = ((($5)) + -44|0); //@line 140971 "c/sqlite3.c"
   $344 = HEAP32[$343>>2]|0; //@line 140971 "c/sqlite3.c"
   $345 = (_sqlite3ExprListAppend($4,$344,$342)|0); //@line 140971 "c/sqlite3.c"
   HEAP32[$343>>2] = $345; //@line 140971 "c/sqlite3.c"
   break;
  }
  case 224: case 223: case 106: case 95:  {
   $346 = ((($5)) + -8|0); //@line 140978 "c/sqlite3.c"
   $347 = ((($5)) + 4|0); //@line 140978 "c/sqlite3.c"
   $348 = $347; //@line 140978 "c/sqlite3.c"
   $349 = $348; //@line 140978 "c/sqlite3.c"
   $350 = HEAP32[$349>>2]|0; //@line 140978 "c/sqlite3.c"
   $351 = (($348) + 4)|0; //@line 140978 "c/sqlite3.c"
   $352 = $351; //@line 140978 "c/sqlite3.c"
   $353 = HEAP32[$352>>2]|0; //@line 140978 "c/sqlite3.c"
   $354 = $346; //@line 140978 "c/sqlite3.c"
   $355 = $354; //@line 140978 "c/sqlite3.c"
   HEAP32[$355>>2] = $350; //@line 140978 "c/sqlite3.c"
   $356 = (($354) + 4)|0; //@line 140978 "c/sqlite3.c"
   $357 = $356; //@line 140978 "c/sqlite3.c"
   HEAP32[$357>>2] = $353; //@line 140978 "c/sqlite3.c"
   break;
  }
  case 97:  {
   $358 = HEAP32[$4>>2]|0; //@line 140981 "c/sqlite3.c"
   $359 = (_sqlite3DbMallocZero($358,80,0)|0); //@line 140981 "c/sqlite3.c"
   $360 = ((($5)) + 16|0); //@line 140981 "c/sqlite3.c"
   HEAP32[$360>>2] = $359; //@line 140981 "c/sqlite3.c"
   break;
  }
  case 98:  {
   $361 = ((($5)) + 4|0); //@line 140985 "c/sqlite3.c"
   $362 = HEAP32[$361>>2]|0; //@line 140985 "c/sqlite3.c"
   $363 = ((($5)) + -8|0); //@line 140985 "c/sqlite3.c"
   HEAP32[$363>>2] = $362; //@line 140985 "c/sqlite3.c"
   _sqlite3SrcListShiftJoinType($362); //@line 140986 "c/sqlite3.c"
   break;
  }
  case 99:  {
   $364 = ((($5)) + -8|0); //@line 140991 "c/sqlite3.c"
   $365 = HEAP32[$364>>2]|0; //@line 140991 "c/sqlite3.c"
   $366 = ($365|0)==(0|0); //@line 140991 "c/sqlite3.c"
   if (!($366)) {
    $367 = HEAP32[$365>>2]|0; //@line 140991 "c/sqlite3.c"
    $368 = ($367|0)>(0); //@line 140991 "c/sqlite3.c"
    if ($368) {
     $369 = (($367) + -1)|0; //@line 140991 "c/sqlite3.c"
     $370 = (((((($365)) + 8|0) + (($369*72)|0)|0)) + 36|0); //@line 140991 "c/sqlite3.c"
     $371 = ((($5)) + 4|0); //@line 140991 "c/sqlite3.c"
     $372 = HEAP32[$371>>2]|0; //@line 140991 "c/sqlite3.c"
     $373 = $372&255; //@line 140991 "c/sqlite3.c"
     HEAP8[$370>>0] = $373; //@line 140991 "c/sqlite3.c"
    }
   }
   break;
  }
  case 100:  {
   $374 = ((($5)) + 16|0); //@line 140995 "c/sqlite3.c"
   HEAP32[$374>>2] = 0; //@line 140995 "c/sqlite3.c"
   break;
  }
  case 101:  {
   $375 = ((($5)) + -68|0); //@line 140999 "c/sqlite3.c"
   $376 = HEAP32[$375>>2]|0; //@line 140999 "c/sqlite3.c"
   $377 = ((($5)) + -56|0); //@line 140999 "c/sqlite3.c"
   $378 = ((($5)) + -44|0); //@line 140999 "c/sqlite3.c"
   $379 = ((($5)) + -32|0); //@line 140999 "c/sqlite3.c"
   $380 = ((($5)) + -8|0); //@line 140999 "c/sqlite3.c"
   $381 = HEAP32[$380>>2]|0; //@line 140999 "c/sqlite3.c"
   $382 = ((($5)) + 4|0); //@line 140999 "c/sqlite3.c"
   $383 = HEAP32[$382>>2]|0; //@line 140999 "c/sqlite3.c"
   $384 = (_sqlite3SrcListAppendFromTerm($4,$376,$377,$378,$379,0,$381,$383)|0); //@line 140999 "c/sqlite3.c"
   HEAP32[$375>>2] = $384; //@line 140999 "c/sqlite3.c"
   $385 = ((($5)) + -20|0); //@line 141000 "c/sqlite3.c"
   _sqlite3SrcListIndexedBy($4,$384,$385); //@line 141000 "c/sqlite3.c"
   break;
  }
  case 102:  {
   $386 = ((($5)) + -92|0); //@line 141005 "c/sqlite3.c"
   $387 = HEAP32[$386>>2]|0; //@line 141005 "c/sqlite3.c"
   $388 = ((($5)) + -80|0); //@line 141005 "c/sqlite3.c"
   $389 = ((($5)) + -68|0); //@line 141005 "c/sqlite3.c"
   $390 = ((($5)) + -20|0); //@line 141005 "c/sqlite3.c"
   $391 = ((($5)) + -8|0); //@line 141005 "c/sqlite3.c"
   $392 = HEAP32[$391>>2]|0; //@line 141005 "c/sqlite3.c"
   $393 = ((($5)) + 4|0); //@line 141005 "c/sqlite3.c"
   $394 = HEAP32[$393>>2]|0; //@line 141005 "c/sqlite3.c"
   $395 = (_sqlite3SrcListAppendFromTerm($4,$387,$388,$389,$390,0,$392,$394)|0); //@line 141005 "c/sqlite3.c"
   HEAP32[$386>>2] = $395; //@line 141005 "c/sqlite3.c"
   $396 = ((($5)) + -44|0); //@line 141006 "c/sqlite3.c"
   $397 = HEAP32[$396>>2]|0; //@line 141006 "c/sqlite3.c"
   _sqlite3SrcListFuncArgs($4,$395,$397); //@line 141006 "c/sqlite3.c"
   break;
  }
  case 103:  {
   $398 = ((($5)) + -68|0); //@line 141011 "c/sqlite3.c"
   $399 = HEAP32[$398>>2]|0; //@line 141011 "c/sqlite3.c"
   $400 = ((($5)) + -20|0); //@line 141011 "c/sqlite3.c"
   $401 = ((($5)) + -44|0); //@line 141011 "c/sqlite3.c"
   $402 = HEAP32[$401>>2]|0; //@line 141011 "c/sqlite3.c"
   $403 = ((($5)) + -8|0); //@line 141011 "c/sqlite3.c"
   $404 = HEAP32[$403>>2]|0; //@line 141011 "c/sqlite3.c"
   $405 = ((($5)) + 4|0); //@line 141011 "c/sqlite3.c"
   $406 = HEAP32[$405>>2]|0; //@line 141011 "c/sqlite3.c"
   $407 = (_sqlite3SrcListAppendFromTerm($4,$399,0,0,$400,$402,$404,$406)|0); //@line 141011 "c/sqlite3.c"
   HEAP32[$398>>2] = $407; //@line 141011 "c/sqlite3.c"
   break;
  }
  case 104:  {
   $408 = ((($5)) + -68|0); //@line 141016 "c/sqlite3.c"
   $409 = HEAP32[$408>>2]|0; //@line 141016 "c/sqlite3.c"
   $410 = ($409|0)==(0|0); //@line 141016 "c/sqlite3.c"
   if ($410) {
    $411 = ((($5)) + -16|0); //@line 141016 "c/sqlite3.c"
    $412 = HEAP32[$411>>2]|0; //@line 141016 "c/sqlite3.c"
    $413 = ($412|0)==(0); //@line 141016 "c/sqlite3.c"
    if ($413) {
     $414 = ((($5)) + -8|0); //@line 141016 "c/sqlite3.c"
     $415 = HEAP32[$414>>2]|0; //@line 141016 "c/sqlite3.c"
     $416 = ($415|0)==(0|0); //@line 141016 "c/sqlite3.c"
     if ($416) {
      $417 = ((($5)) + 4|0); //@line 141016 "c/sqlite3.c"
      $418 = HEAP32[$417>>2]|0; //@line 141016 "c/sqlite3.c"
      $419 = ($418|0)==(0|0); //@line 141016 "c/sqlite3.c"
      if ($419) {
       $420 = ((($5)) + -44|0); //@line 141017 "c/sqlite3.c"
       $421 = HEAP32[$420>>2]|0; //@line 141017 "c/sqlite3.c"
       HEAP32[$408>>2] = $421; //@line 141017 "c/sqlite3.c"
       break L6;
      }
     }
    }
   }
   $422 = ((($5)) + -44|0); //@line 141018 "c/sqlite3.c"
   $423 = HEAP32[$422>>2]|0; //@line 141018 "c/sqlite3.c"
   $424 = HEAP32[$423>>2]|0; //@line 141018 "c/sqlite3.c"
   $425 = ($424|0)==(1); //@line 141018 "c/sqlite3.c"
   if (!($425)) {
    _sqlite3SrcListShiftJoinType($423); //@line 141032 "c/sqlite3.c"
    $447 = HEAP32[$422>>2]|0; //@line 141033 "c/sqlite3.c"
    $448 = (_sqlite3SelectNew($4,0,$447,0,0,0,0,2048,0)|0); //@line 141033 "c/sqlite3.c"
    $449 = HEAP32[$408>>2]|0; //@line 141034 "c/sqlite3.c"
    $450 = ((($5)) + -20|0); //@line 141034 "c/sqlite3.c"
    $451 = ((($5)) + -8|0); //@line 141034 "c/sqlite3.c"
    $452 = HEAP32[$451>>2]|0; //@line 141034 "c/sqlite3.c"
    $453 = ((($5)) + 4|0); //@line 141034 "c/sqlite3.c"
    $454 = HEAP32[$453>>2]|0; //@line 141034 "c/sqlite3.c"
    $455 = (_sqlite3SrcListAppendFromTerm($4,$449,0,0,$450,$448,$452,$454)|0); //@line 141034 "c/sqlite3.c"
    HEAP32[$408>>2] = $455; //@line 141034 "c/sqlite3.c"
    break L6;
   }
   $426 = ((($5)) + -20|0); //@line 141019 "c/sqlite3.c"
   $427 = ((($5)) + -8|0); //@line 141019 "c/sqlite3.c"
   $428 = HEAP32[$427>>2]|0; //@line 141019 "c/sqlite3.c"
   $429 = ((($5)) + 4|0); //@line 141019 "c/sqlite3.c"
   $430 = HEAP32[$429>>2]|0; //@line 141019 "c/sqlite3.c"
   $431 = (_sqlite3SrcListAppendFromTerm($4,$409,0,0,$426,0,$428,$430)|0); //@line 141019 "c/sqlite3.c"
   HEAP32[$408>>2] = $431; //@line 141019 "c/sqlite3.c"
   $432 = ($431|0)==(0|0); //@line 141020 "c/sqlite3.c"
   if (!($432)) {
    $433 = HEAP32[$431>>2]|0; //@line 141021 "c/sqlite3.c"
    $434 = (($433) + -1)|0; //@line 141021 "c/sqlite3.c"
    $435 = HEAP32[$422>>2]|0; //@line 141022 "c/sqlite3.c"
    $436 = ((($435)) + 16|0); //@line 141023 "c/sqlite3.c"
    $437 = HEAP32[$436>>2]|0; //@line 141023 "c/sqlite3.c"
    $438 = (((((($431)) + 8|0) + (($434*72)|0)|0)) + 8|0); //@line 141023 "c/sqlite3.c"
    HEAP32[$438>>2] = $437; //@line 141023 "c/sqlite3.c"
    $439 = ((($435)) + 12|0); //@line 141024 "c/sqlite3.c"
    $440 = HEAP32[$439>>2]|0; //@line 141024 "c/sqlite3.c"
    $441 = (((((($431)) + 8|0) + (($434*72)|0)|0)) + 4|0); //@line 141024 "c/sqlite3.c"
    HEAP32[$441>>2] = $440; //@line 141024 "c/sqlite3.c"
    $442 = ((($435)) + 28|0); //@line 141025 "c/sqlite3.c"
    $443 = HEAP32[$442>>2]|0; //@line 141025 "c/sqlite3.c"
    $444 = (((((($431)) + 8|0) + (($434*72)|0)|0)) + 20|0); //@line 141025 "c/sqlite3.c"
    HEAP32[$444>>2] = $443; //@line 141025 "c/sqlite3.c"
    HEAP32[$439>>2] = 0; //@line 141026 "c/sqlite3.c"
    HEAP32[$436>>2] = 0; //@line 141026 "c/sqlite3.c"
    HEAP32[$442>>2] = 0; //@line 141027 "c/sqlite3.c"
   }
   $445 = HEAP32[$4>>2]|0; //@line 141029 "c/sqlite3.c"
   $446 = HEAP32[$422>>2]|0; //@line 141029 "c/sqlite3.c"
   _sqlite3SrcListDelete($445,$446); //@line 141029 "c/sqlite3.c"
   break;
  }
  case 114: case 105:  {
   $456 = ((($5)) + 16|0); //@line 141040 "c/sqlite3.c"
   HEAP32[$456>>2] = 0; //@line 141040 "c/sqlite3.c"
   $457 = ((($5)) + 20|0); //@line 141040 "c/sqlite3.c"
   HEAP32[$457>>2] = 0; //@line 141040 "c/sqlite3.c"
   break;
  }
  case 107:  {
   $458 = HEAP32[$4>>2]|0; //@line 141043 "c/sqlite3.c"
   $459 = ((($5)) + -8|0); //@line 141043 "c/sqlite3.c"
   $460 = ((($5)) + 4|0); //@line 141043 "c/sqlite3.c"
   $461 = (_sqlite3SrcListAppend($458,0,$459,$460)|0); //@line 141043 "c/sqlite3.c"
   HEAP32[$459>>2] = $461; //@line 141043 "c/sqlite3.c"
   break;
  }
  case 108:  {
   $462 = ((($5)) + 4|0); //@line 141046 "c/sqlite3.c"
   HEAP32[$462>>2] = 1; //@line 141046 "c/sqlite3.c"
   break;
  }
  case 109:  {
   $463 = ((($5)) + -8|0); //@line 141049 "c/sqlite3.c"
   $464 = (_sqlite3JoinType($4,$463,0,0)|0); //@line 141049 "c/sqlite3.c"
   HEAP32[$463>>2] = $464; //@line 141049 "c/sqlite3.c"
   break;
  }
  case 110:  {
   $465 = ((($5)) + -20|0); //@line 141052 "c/sqlite3.c"
   $466 = ((($5)) + -8|0); //@line 141052 "c/sqlite3.c"
   $467 = (_sqlite3JoinType($4,$465,$466,0)|0); //@line 141052 "c/sqlite3.c"
   HEAP32[$465>>2] = $467; //@line 141052 "c/sqlite3.c"
   break;
  }
  case 111:  {
   $468 = ((($5)) + -32|0); //@line 141055 "c/sqlite3.c"
   $469 = ((($5)) + -20|0); //@line 141055 "c/sqlite3.c"
   $470 = ((($5)) + -8|0); //@line 141055 "c/sqlite3.c"
   $471 = (_sqlite3JoinType($4,$468,$469,$470)|0); //@line 141055 "c/sqlite3.c"
   HEAP32[$468>>2] = $471; //@line 141055 "c/sqlite3.c"
   break;
  }
  case 197: case 136: case 129: case 112:  {
   $472 = ((($5)) + 4|0); //@line 141061 "c/sqlite3.c"
   $473 = HEAP32[$472>>2]|0; //@line 141061 "c/sqlite3.c"
   $474 = ((($5)) + -8|0); //@line 141061 "c/sqlite3.c"
   HEAP32[$474>>2] = $473; //@line 141061 "c/sqlite3.c"
   break;
  }
  case 200: case 198: case 135: case 130: case 128: case 113:  {
   $475 = ((($5)) + 16|0); //@line 141069 "c/sqlite3.c"
   HEAP32[$475>>2] = 0; //@line 141069 "c/sqlite3.c"
   break;
  }
  case 115:  {
   $476 = ((($5)) + -20|0); //@line 141072 "c/sqlite3.c"
   $477 = ((($5)) + 4|0); //@line 141072 "c/sqlite3.c"
   $478 = $477; //@line 141072 "c/sqlite3.c"
   $479 = $478; //@line 141072 "c/sqlite3.c"
   $480 = HEAP32[$479>>2]|0; //@line 141072 "c/sqlite3.c"
   $481 = (($478) + 4)|0; //@line 141072 "c/sqlite3.c"
   $482 = $481; //@line 141072 "c/sqlite3.c"
   $483 = HEAP32[$482>>2]|0; //@line 141072 "c/sqlite3.c"
   $484 = $476; //@line 141072 "c/sqlite3.c"
   $485 = $484; //@line 141072 "c/sqlite3.c"
   HEAP32[$485>>2] = $480; //@line 141072 "c/sqlite3.c"
   $486 = (($484) + 4)|0; //@line 141072 "c/sqlite3.c"
   $487 = $486; //@line 141072 "c/sqlite3.c"
   HEAP32[$487>>2] = $483; //@line 141072 "c/sqlite3.c"
   break;
  }
  case 116:  {
   $488 = ((($5)) + -8|0); //@line 141075 "c/sqlite3.c"
   HEAP32[$488>>2] = 0; //@line 141075 "c/sqlite3.c"
   $489 = ((($5)) + -4|0); //@line 141075 "c/sqlite3.c"
   HEAP32[$489>>2] = 1; //@line 141075 "c/sqlite3.c"
   break;
  }
  case 117:  {
   $490 = ((($5)) + -8|0); //@line 141078 "c/sqlite3.c"
   $491 = HEAP32[$490>>2]|0; //@line 141078 "c/sqlite3.c"
   $492 = ((($5)) + -32|0); //@line 141078 "c/sqlite3.c"
   HEAP32[$492>>2] = $491; //@line 141078 "c/sqlite3.c"
   break;
  }
  case 146: case 118:  {
   $493 = ((($5)) + 16|0); //@line 141082 "c/sqlite3.c"
   HEAP32[$493>>2] = 0; //@line 141082 "c/sqlite3.c"
   break;
  }
  case 127: case 120:  {
   $494 = ((($5)) + 4|0); //@line 141086 "c/sqlite3.c"
   $495 = HEAP32[$494>>2]|0; //@line 141086 "c/sqlite3.c"
   $496 = ((($5)) + -20|0); //@line 141086 "c/sqlite3.c"
   HEAP32[$496>>2] = $495; //@line 141086 "c/sqlite3.c"
   break;
  }
  case 121:  {
   $497 = ((($5)) + -32|0); //@line 141090 "c/sqlite3.c"
   $498 = HEAP32[$497>>2]|0; //@line 141090 "c/sqlite3.c"
   $499 = ((($5)) + -8|0); //@line 141090 "c/sqlite3.c"
   $500 = HEAP32[$499>>2]|0; //@line 141090 "c/sqlite3.c"
   $501 = (_sqlite3ExprListAppend($4,$498,$500)|0); //@line 141090 "c/sqlite3.c"
   HEAP32[$497>>2] = $501; //@line 141090 "c/sqlite3.c"
   $502 = ((($5)) + 4|0); //@line 141091 "c/sqlite3.c"
   $503 = HEAP32[$502>>2]|0; //@line 141091 "c/sqlite3.c"
   _sqlite3ExprListSetSortOrder($501,$503); //@line 141091 "c/sqlite3.c"
   break;
  }
  case 122:  {
   $504 = ((($5)) + -8|0); //@line 141096 "c/sqlite3.c"
   $505 = HEAP32[$504>>2]|0; //@line 141096 "c/sqlite3.c"
   $506 = (_sqlite3ExprListAppend($4,0,$505)|0); //@line 141096 "c/sqlite3.c"
   HEAP32[$504>>2] = $506; //@line 141096 "c/sqlite3.c"
   $507 = ((($5)) + 4|0); //@line 141097 "c/sqlite3.c"
   $508 = HEAP32[$507>>2]|0; //@line 141097 "c/sqlite3.c"
   _sqlite3ExprListSetSortOrder($506,$508); //@line 141097 "c/sqlite3.c"
   break;
  }
  case 123:  {
   $509 = ((($5)) + 4|0); //@line 141101 "c/sqlite3.c"
   HEAP32[$509>>2] = 0; //@line 141101 "c/sqlite3.c"
   break;
  }
  case 124:  {
   $510 = ((($5)) + 4|0); //@line 141104 "c/sqlite3.c"
   HEAP32[$510>>2] = 1; //@line 141104 "c/sqlite3.c"
   break;
  }
  case 125:  {
   $511 = ((($5)) + 16|0); //@line 141107 "c/sqlite3.c"
   HEAP32[$511>>2] = -1; //@line 141107 "c/sqlite3.c"
   break;
  }
  case 131:  {
   $512 = ((($5)) + 4|0); //@line 141110 "c/sqlite3.c"
   $513 = HEAP32[$512>>2]|0; //@line 141110 "c/sqlite3.c"
   $514 = (_sqlite3PExpr($4,129,$513,0)|0); //@line 141110 "c/sqlite3.c"
   $515 = ((($5)) + -8|0); //@line 141110 "c/sqlite3.c"
   HEAP32[$515>>2] = $514; //@line 141110 "c/sqlite3.c"
   break;
  }
  case 132:  {
   $516 = ((($5)) + -20|0); //@line 141113 "c/sqlite3.c"
   $517 = HEAP32[$516>>2]|0; //@line 141113 "c/sqlite3.c"
   $518 = ((($5)) + 4|0); //@line 141113 "c/sqlite3.c"
   $519 = HEAP32[$518>>2]|0; //@line 141113 "c/sqlite3.c"
   $520 = (_sqlite3PExpr($4,129,$517,$519)|0); //@line 141113 "c/sqlite3.c"
   $521 = ((($5)) + -32|0); //@line 141113 "c/sqlite3.c"
   HEAP32[$521>>2] = $520; //@line 141113 "c/sqlite3.c"
   break;
  }
  case 133:  {
   $522 = ((($5)) + 4|0); //@line 141116 "c/sqlite3.c"
   $523 = HEAP32[$522>>2]|0; //@line 141116 "c/sqlite3.c"
   $524 = ((($5)) + -20|0); //@line 141116 "c/sqlite3.c"
   $525 = HEAP32[$524>>2]|0; //@line 141116 "c/sqlite3.c"
   $526 = (_sqlite3PExpr($4,129,$523,$525)|0); //@line 141116 "c/sqlite3.c"
   $527 = ((($5)) + -32|0); //@line 141116 "c/sqlite3.c"
   HEAP32[$527>>2] = $526; //@line 141116 "c/sqlite3.c"
   break;
  }
  case 134:  {
   $528 = ((($5)) + -56|0); //@line 141120 "c/sqlite3.c"
   $529 = HEAP32[$528>>2]|0; //@line 141120 "c/sqlite3.c"
   _sqlite3WithPush($4,$529,1); //@line 141120 "c/sqlite3.c"
   $530 = ((($5)) + -20|0); //@line 141121 "c/sqlite3.c"
   $531 = HEAP32[$530>>2]|0; //@line 141121 "c/sqlite3.c"
   $532 = ((($5)) + -8|0); //@line 141121 "c/sqlite3.c"
   _sqlite3SrcListIndexedBy($4,$531,$532); //@line 141121 "c/sqlite3.c"
   $533 = HEAP32[$530>>2]|0; //@line 141122 "c/sqlite3.c"
   $534 = ((($5)) + 4|0); //@line 141122 "c/sqlite3.c"
   $535 = HEAP32[$534>>2]|0; //@line 141122 "c/sqlite3.c"
   _sqlite3DeleteFrom($4,$533,$535); //@line 141122 "c/sqlite3.c"
   break;
  }
  case 137:  {
   $536 = ((($5)) + -80|0); //@line 141127 "c/sqlite3.c"
   $537 = HEAP32[$536>>2]|0; //@line 141127 "c/sqlite3.c"
   _sqlite3WithPush($4,$537,1); //@line 141127 "c/sqlite3.c"
   $538 = ((($5)) + -44|0); //@line 141128 "c/sqlite3.c"
   $539 = HEAP32[$538>>2]|0; //@line 141128 "c/sqlite3.c"
   $540 = ((($5)) + -32|0); //@line 141128 "c/sqlite3.c"
   _sqlite3SrcListIndexedBy($4,$539,$540); //@line 141128 "c/sqlite3.c"
   $541 = ((($5)) + -8|0); //@line 141129 "c/sqlite3.c"
   $542 = HEAP32[$541>>2]|0; //@line 141129 "c/sqlite3.c"
   _sqlite3ExprListCheckLength($4,$542,19258); //@line 141129 "c/sqlite3.c"
   $543 = HEAP32[$538>>2]|0; //@line 141130 "c/sqlite3.c"
   $544 = HEAP32[$541>>2]|0; //@line 141130 "c/sqlite3.c"
   $545 = ((($5)) + 4|0); //@line 141130 "c/sqlite3.c"
   $546 = HEAP32[$545>>2]|0; //@line 141130 "c/sqlite3.c"
   $547 = ((($5)) + -56|0); //@line 141130 "c/sqlite3.c"
   $548 = HEAP32[$547>>2]|0; //@line 141130 "c/sqlite3.c"
   _sqlite3Update($4,$543,$544,$546,$548); //@line 141130 "c/sqlite3.c"
   break;
  }
  case 138:  {
   $549 = ((($5)) + -44|0); //@line 141135 "c/sqlite3.c"
   $550 = HEAP32[$549>>2]|0; //@line 141135 "c/sqlite3.c"
   $551 = ((($5)) + 4|0); //@line 141135 "c/sqlite3.c"
   $552 = HEAP32[$551>>2]|0; //@line 141135 "c/sqlite3.c"
   $553 = (_sqlite3ExprListAppend($4,$550,$552)|0); //@line 141135 "c/sqlite3.c"
   HEAP32[$549>>2] = $553; //@line 141135 "c/sqlite3.c"
   $554 = ((($5)) + -20|0); //@line 141136 "c/sqlite3.c"
   _sqlite3ExprListSetName($4,$553,$554,1); //@line 141136 "c/sqlite3.c"
   break;
  }
  case 139:  {
   $555 = ((($5)) + -68|0); //@line 141141 "c/sqlite3.c"
   $556 = HEAP32[$555>>2]|0; //@line 141141 "c/sqlite3.c"
   $557 = ((($5)) + -32|0); //@line 141141 "c/sqlite3.c"
   $558 = HEAP32[$557>>2]|0; //@line 141141 "c/sqlite3.c"
   $559 = ((($5)) + 4|0); //@line 141141 "c/sqlite3.c"
   $560 = HEAP32[$559>>2]|0; //@line 141141 "c/sqlite3.c"
   $561 = (_sqlite3ExprListAppendVector($4,$556,$558,$560)|0); //@line 141141 "c/sqlite3.c"
   HEAP32[$555>>2] = $561; //@line 141141 "c/sqlite3.c"
   break;
  }
  case 140:  {
   $562 = ((($5)) + 4|0); //@line 141146 "c/sqlite3.c"
   $563 = HEAP32[$562>>2]|0; //@line 141146 "c/sqlite3.c"
   $564 = (_sqlite3ExprListAppend($4,0,$563)|0); //@line 141146 "c/sqlite3.c"
   $565 = ((($5)) + -20|0); //@line 141147 "c/sqlite3.c"
   _sqlite3ExprListSetName($4,$564,$565,1); //@line 141147 "c/sqlite3.c"
   HEAP32[$565>>2] = $564; //@line 141149 "c/sqlite3.c"
   break;
  }
  case 141:  {
   $566 = ((($5)) + -32|0); //@line 141153 "c/sqlite3.c"
   $567 = HEAP32[$566>>2]|0; //@line 141153 "c/sqlite3.c"
   $568 = ((($5)) + 4|0); //@line 141153 "c/sqlite3.c"
   $569 = HEAP32[$568>>2]|0; //@line 141153 "c/sqlite3.c"
   $570 = (_sqlite3ExprListAppendVector($4,0,$567,$569)|0); //@line 141153 "c/sqlite3.c"
   $571 = ((($5)) + -44|0); //@line 141153 "c/sqlite3.c"
   HEAP32[$571>>2] = $570; //@line 141153 "c/sqlite3.c"
   break;
  }
  case 142:  {
   $572 = ((($5)) + -56|0); //@line 141158 "c/sqlite3.c"
   $573 = HEAP32[$572>>2]|0; //@line 141158 "c/sqlite3.c"
   _sqlite3WithPush($4,$573,1); //@line 141158 "c/sqlite3.c"
   $574 = ((($5)) + -20|0); //@line 141159 "c/sqlite3.c"
   $575 = HEAP32[$574>>2]|0; //@line 141159 "c/sqlite3.c"
   $576 = ((($5)) + 4|0); //@line 141159 "c/sqlite3.c"
   $577 = HEAP32[$576>>2]|0; //@line 141159 "c/sqlite3.c"
   $578 = ((($5)) + -8|0); //@line 141159 "c/sqlite3.c"
   $579 = HEAP32[$578>>2]|0; //@line 141159 "c/sqlite3.c"
   $580 = ((($5)) + -44|0); //@line 141159 "c/sqlite3.c"
   $581 = HEAP32[$580>>2]|0; //@line 141159 "c/sqlite3.c"
   _sqlite3Insert($4,$575,$577,$579,$581); //@line 141159 "c/sqlite3.c"
   break;
  }
  case 143:  {
   $582 = ((($5)) + -68|0); //@line 141164 "c/sqlite3.c"
   $583 = HEAP32[$582>>2]|0; //@line 141164 "c/sqlite3.c"
   _sqlite3WithPush($4,$583,1); //@line 141164 "c/sqlite3.c"
   $584 = ((($5)) + -32|0); //@line 141165 "c/sqlite3.c"
   $585 = HEAP32[$584>>2]|0; //@line 141165 "c/sqlite3.c"
   $586 = ((($5)) + -20|0); //@line 141165 "c/sqlite3.c"
   $587 = HEAP32[$586>>2]|0; //@line 141165 "c/sqlite3.c"
   $588 = ((($5)) + -56|0); //@line 141165 "c/sqlite3.c"
   $589 = HEAP32[$588>>2]|0; //@line 141165 "c/sqlite3.c"
   _sqlite3Insert($4,$585,0,$587,$589); //@line 141165 "c/sqlite3.c"
   break;
  }
  case 147:  {
   $590 = ((($5)) + -8|0); //@line 141169 "c/sqlite3.c"
   $591 = HEAP32[$590>>2]|0; //@line 141169 "c/sqlite3.c"
   $592 = ((($5)) + -20|0); //@line 141169 "c/sqlite3.c"
   HEAP32[$592>>2] = $591; //@line 141169 "c/sqlite3.c"
   break;
  }
  case 148:  {
   $593 = HEAP32[$4>>2]|0; //@line 141172 "c/sqlite3.c"
   $594 = ((($5)) + -20|0); //@line 141172 "c/sqlite3.c"
   $595 = HEAP32[$594>>2]|0; //@line 141172 "c/sqlite3.c"
   $596 = ((($5)) + 4|0); //@line 141172 "c/sqlite3.c"
   $597 = (_sqlite3IdListAppend($593,$595,$596)|0); //@line 141172 "c/sqlite3.c"
   HEAP32[$594>>2] = $597; //@line 141172 "c/sqlite3.c"
   break;
  }
  case 149:  {
   $598 = HEAP32[$4>>2]|0; //@line 141175 "c/sqlite3.c"
   $599 = ((($5)) + 4|0); //@line 141175 "c/sqlite3.c"
   $600 = (_sqlite3IdListAppend($598,0,$599)|0); //@line 141175 "c/sqlite3.c"
   HEAP32[$599>>2] = $600; //@line 141175 "c/sqlite3.c"
   break;
  }
  case 150:  {
   $601 = ((($5)) + -8|0); //@line 141178 "c/sqlite3.c"
   $602 = HEAP32[$601>>2]|0; //@line 141178 "c/sqlite3.c"
   $603 = ((($5)) + -20|0); //@line 141178 "c/sqlite3.c"
   HEAP32[$603>>2] = $602; //@line 141178 "c/sqlite3.c"
   break;
  }
  case 152: case 151:  {
   $604 = ((($5)) + 4|0); //@line 141182 "c/sqlite3.c"
   ;HEAP32[$$byval_copy16>>2]=HEAP32[$604>>2]|0;HEAP32[$$byval_copy16+4>>2]=HEAP32[$604+4>>2]|0; //@line 141182 "c/sqlite3.c"
   $605 = (_tokenExpr($4,59,$$byval_copy16)|0); //@line 141182 "c/sqlite3.c"
   HEAP32[$604>>2] = $605; //@line 141182 "c/sqlite3.c"
   break;
  }
  case 153:  {
   $606 = HEAP32[$4>>2]|0; //@line 141186 "c/sqlite3.c"
   $607 = ((($5)) + -20|0); //@line 141186 "c/sqlite3.c"
   $608 = (_sqlite3ExprAlloc($606,59,$607,1)|0); //@line 141186 "c/sqlite3.c"
   $609 = HEAP32[$4>>2]|0; //@line 141187 "c/sqlite3.c"
   $610 = ((($5)) + 4|0); //@line 141187 "c/sqlite3.c"
   $611 = (_sqlite3ExprAlloc($609,59,$610,1)|0); //@line 141187 "c/sqlite3.c"
   $612 = (_sqlite3PExpr($4,122,$608,$611)|0); //@line 141188 "c/sqlite3.c"
   HEAP32[$607>>2] = $612; //@line 141190 "c/sqlite3.c"
   break;
  }
  case 154:  {
   $613 = HEAP32[$4>>2]|0; //@line 141194 "c/sqlite3.c"
   $614 = ((($5)) + -44|0); //@line 141194 "c/sqlite3.c"
   $615 = (_sqlite3ExprAlloc($613,59,$614,1)|0); //@line 141194 "c/sqlite3.c"
   $616 = HEAP32[$4>>2]|0; //@line 141195 "c/sqlite3.c"
   $617 = ((($5)) + -20|0); //@line 141195 "c/sqlite3.c"
   $618 = (_sqlite3ExprAlloc($616,59,$617,1)|0); //@line 141195 "c/sqlite3.c"
   $619 = HEAP32[$4>>2]|0; //@line 141196 "c/sqlite3.c"
   $620 = ((($5)) + 4|0); //@line 141196 "c/sqlite3.c"
   $621 = (_sqlite3ExprAlloc($619,59,$620,1)|0); //@line 141196 "c/sqlite3.c"
   $622 = (_sqlite3PExpr($4,122,$618,$621)|0); //@line 141197 "c/sqlite3.c"
   $623 = (_sqlite3PExpr($4,122,$615,$622)|0); //@line 141198 "c/sqlite3.c"
   HEAP32[$614>>2] = $623; //@line 141200 "c/sqlite3.c"
   break;
  }
  case 156: case 155:  {
   $624 = ((($5)) + 2|0); //@line 141204 "c/sqlite3.c"
   $625 = HEAP8[$624>>0]|0; //@line 141204 "c/sqlite3.c"
   $626 = $625&255; //@line 141204 "c/sqlite3.c"
   $627 = ((($5)) + 4|0); //@line 141204 "c/sqlite3.c"
   ;HEAP32[$$byval_copy16>>2]=HEAP32[$627>>2]|0;HEAP32[$$byval_copy16+4>>2]=HEAP32[$627+4>>2]|0; //@line 141204 "c/sqlite3.c"
   $628 = (_tokenExpr($4,$626,$$byval_copy16)|0); //@line 141204 "c/sqlite3.c"
   HEAP32[$627>>2] = $628; //@line 141204 "c/sqlite3.c"
   break;
  }
  case 157:  {
   $629 = HEAP32[$4>>2]|0; //@line 141208 "c/sqlite3.c"
   $630 = ((($5)) + 4|0); //@line 141208 "c/sqlite3.c"
   $631 = (_sqlite3ExprAlloc($629,134,$630,1)|0); //@line 141208 "c/sqlite3.c"
   HEAP32[$630>>2] = $631; //@line 141210 "c/sqlite3.c"
   break;
  }
  case 158:  {
   $632 = ((($5)) + 4|0); //@line 141214 "c/sqlite3.c"
   $633 = HEAP32[$632>>2]|0; //@line 141214 "c/sqlite3.c"
   $634 = HEAP8[$633>>0]|0; //@line 141214 "c/sqlite3.c"
   $635 = ($634<<24>>24)==(35); //@line 141214 "c/sqlite3.c"
   if ($635) {
    $636 = ((($633)) + 1|0); //@line 141214 "c/sqlite3.c"
    $637 = HEAP8[$636>>0]|0; //@line 141214 "c/sqlite3.c"
    $638 = $637&255; //@line 141214 "c/sqlite3.c"
    $639 = (($638) + -48)|0; //@line 141214 "c/sqlite3.c"
    $640 = ($639>>>0)<(10); //@line 141214 "c/sqlite3.c"
    if ($640) {
     $644 = $632; //@line 141222 "c/sqlite3.c"
     $645 = $644; //@line 141222 "c/sqlite3.c"
     $646 = HEAP32[$645>>2]|0; //@line 141222 "c/sqlite3.c"
     $647 = (($644) + 4)|0; //@line 141222 "c/sqlite3.c"
     $648 = $647; //@line 141222 "c/sqlite3.c"
     $649 = HEAP32[$648>>2]|0; //@line 141222 "c/sqlite3.c"
     $650 = $$byval_copy16; //@line 141222 "c/sqlite3.c"
     $651 = $650; //@line 141222 "c/sqlite3.c"
     HEAP32[$651>>2] = $646; //@line 141222 "c/sqlite3.c"
     $652 = (($650) + 4)|0; //@line 141222 "c/sqlite3.c"
     $653 = $652; //@line 141222 "c/sqlite3.c"
     HEAP32[$653>>2] = $649; //@line 141222 "c/sqlite3.c"
     $654 = ((($4)) + 18|0); //@line 141224 "c/sqlite3.c"
     $655 = HEAP8[$654>>0]|0; //@line 141224 "c/sqlite3.c"
     $656 = ($655<<24>>24)==(0); //@line 141224 "c/sqlite3.c"
     if ($656) {
      HEAP32[$vararg_buffer2>>2] = $$byval_copy16; //@line 141225 "c/sqlite3.c"
      _sqlite3ErrorMsg($4,19267,$vararg_buffer2); //@line 141225 "c/sqlite3.c"
      HEAP32[$632>>2] = 0; //@line 141226 "c/sqlite3.c"
     } else {
      $657 = (_sqlite3PExpr($4,150,0,0)|0); //@line 141228 "c/sqlite3.c"
      HEAP32[$632>>2] = $657; //@line 141228 "c/sqlite3.c"
      $658 = ($657|0)==(0|0); //@line 141229 "c/sqlite3.c"
      if (!($658)) {
       $659 = HEAP32[$$byval_copy16>>2]|0; //@line 141229 "c/sqlite3.c"
       $660 = ((($659)) + 1|0); //@line 141229 "c/sqlite3.c"
       $661 = ((($657)) + 28|0); //@line 141229 "c/sqlite3.c"
       (_sqlite3GetInt32($660,$661)|0); //@line 141229 "c/sqlite3.c"
      }
     }
     break L6;
    }
   }
   $641 = ((($5)) + 8|0); //@line 141215 "c/sqlite3.c"
   $642 = HEAP32[$641>>2]|0; //@line 141215 "c/sqlite3.c"
   ;HEAP32[$$byval_copy16>>2]=HEAP32[$632>>2]|0;HEAP32[$$byval_copy16+4>>2]=HEAP32[$632+4>>2]|0; //@line 141216 "c/sqlite3.c"
   $643 = (_tokenExpr($4,135,$$byval_copy16)|0); //@line 141216 "c/sqlite3.c"
   HEAP32[$632>>2] = $643; //@line 141216 "c/sqlite3.c"
   _sqlite3ExprAssignVarNumber($4,$643,$642); //@line 141217 "c/sqlite3.c"
   break;
  }
  case 159:  {
   $662 = ((($5)) + -20|0); //@line 141236 "c/sqlite3.c"
   $663 = HEAP32[$662>>2]|0; //@line 141236 "c/sqlite3.c"
   $664 = ((($5)) + 4|0); //@line 141236 "c/sqlite3.c"
   $665 = (_sqlite3ExprAddCollateToken($4,$663,$664,1)|0); //@line 141236 "c/sqlite3.c"
   HEAP32[$662>>2] = $665; //@line 141236 "c/sqlite3.c"
   break;
  }
  case 160:  {
   $666 = HEAP32[$4>>2]|0; //@line 141241 "c/sqlite3.c"
   $667 = ((($5)) + -8|0); //@line 141241 "c/sqlite3.c"
   $668 = (_sqlite3ExprAlloc($666,36,$667,1)|0); //@line 141241 "c/sqlite3.c"
   $669 = ((($5)) + -56|0); //@line 141241 "c/sqlite3.c"
   HEAP32[$669>>2] = $668; //@line 141241 "c/sqlite3.c"
   $670 = HEAP32[$4>>2]|0; //@line 141242 "c/sqlite3.c"
   $671 = ((($5)) + -32|0); //@line 141242 "c/sqlite3.c"
   $672 = HEAP32[$671>>2]|0; //@line 141242 "c/sqlite3.c"
   _sqlite3ExprAttachSubtrees($670,$668,$672,0); //@line 141242 "c/sqlite3.c"
   break;
  }
  case 161:  {
   $673 = ((($5)) + -8|0); //@line 141247 "c/sqlite3.c"
   $674 = HEAP32[$673>>2]|0; //@line 141247 "c/sqlite3.c"
   $675 = ($674|0)==(0|0); //@line 141247 "c/sqlite3.c"
   if (!($675)) {
    $676 = HEAP32[$674>>2]|0; //@line 141247 "c/sqlite3.c"
    $677 = HEAP32[$4>>2]|0; //@line 141247 "c/sqlite3.c"
    $678 = ((($677)) + 124|0); //@line 141247 "c/sqlite3.c"
    $679 = HEAP32[$678>>2]|0; //@line 141247 "c/sqlite3.c"
    $680 = ($676|0)>($679|0); //@line 141247 "c/sqlite3.c"
    if ($680) {
     $681 = ((($5)) + -44|0); //@line 141248 "c/sqlite3.c"
     HEAP32[$vararg_buffer5>>2] = $681; //@line 141248 "c/sqlite3.c"
     _sqlite3ErrorMsg($4,19291,$vararg_buffer5); //@line 141248 "c/sqlite3.c"
    }
   }
   $682 = HEAP32[$673>>2]|0; //@line 141250 "c/sqlite3.c"
   $683 = ((($5)) + -44|0); //@line 141250 "c/sqlite3.c"
   $684 = (_sqlite3ExprFunction($4,$682,$683)|0); //@line 141250 "c/sqlite3.c"
   $685 = ((($5)) + -20|0); //@line 141251 "c/sqlite3.c"
   $686 = HEAP32[$685>>2]|0; //@line 141251 "c/sqlite3.c"
   $687 = ($686|0)!=(1); //@line 141251 "c/sqlite3.c"
   $688 = ($684|0)==(0|0); //@line 141251 "c/sqlite3.c"
   $or$cond = $688 | $687; //@line 141251 "c/sqlite3.c"
   if (!($or$cond)) {
    $689 = ((($684)) + 4|0); //@line 141252 "c/sqlite3.c"
    $690 = HEAP32[$689>>2]|0; //@line 141252 "c/sqlite3.c"
    $691 = $690 | 16; //@line 141252 "c/sqlite3.c"
    HEAP32[$689>>2] = $691; //@line 141252 "c/sqlite3.c"
   }
   HEAP32[$683>>2] = $684; //@line 141255 "c/sqlite3.c"
   break;
  }
  case 162:  {
   $692 = ((($5)) + -32|0); //@line 141259 "c/sqlite3.c"
   $693 = (_sqlite3ExprFunction($4,0,$692)|0); //@line 141259 "c/sqlite3.c"
   HEAP32[$692>>2] = $693; //@line 141261 "c/sqlite3.c"
   break;
  }
  case 163:  {
   $694 = ((($5)) + 4|0); //@line 141265 "c/sqlite3.c"
   $695 = (_sqlite3ExprFunction($4,0,$694)|0); //@line 141265 "c/sqlite3.c"
   HEAP32[$694>>2] = $695; //@line 141267 "c/sqlite3.c"
   break;
  }
  case 164:  {
   $696 = ((($5)) + -32|0); //@line 141271 "c/sqlite3.c"
   $697 = HEAP32[$696>>2]|0; //@line 141271 "c/sqlite3.c"
   $698 = ((($5)) + -8|0); //@line 141271 "c/sqlite3.c"
   $699 = HEAP32[$698>>2]|0; //@line 141271 "c/sqlite3.c"
   $700 = (_sqlite3ExprListAppend($4,$697,$699)|0); //@line 141271 "c/sqlite3.c"
   $701 = (_sqlite3PExpr($4,151,0,0)|0); //@line 141272 "c/sqlite3.c"
   $702 = ((($5)) + -44|0); //@line 141272 "c/sqlite3.c"
   HEAP32[$702>>2] = $701; //@line 141272 "c/sqlite3.c"
   $703 = ($701|0)==(0|0); //@line 141273 "c/sqlite3.c"
   if ($703) {
    $705 = HEAP32[$4>>2]|0; //@line 141276 "c/sqlite3.c"
    _sqlite3ExprListDelete($705,$700); //@line 141276 "c/sqlite3.c"
    break L6;
   } else {
    $704 = ((($701)) + 20|0); //@line 141274 "c/sqlite3.c"
    HEAP32[$704>>2] = $700; //@line 141274 "c/sqlite3.c"
    break L6;
   }
   break;
  }
  case 172: case 171: case 170: case 169: case 168: case 167: case 166: case 165:  {
   $706 = ((($5)) + -10|0); //@line 141288 "c/sqlite3.c"
   $707 = HEAP8[$706>>0]|0; //@line 141288 "c/sqlite3.c"
   $708 = $707&255; //@line 141288 "c/sqlite3.c"
   $709 = ((($5)) + -20|0); //@line 141288 "c/sqlite3.c"
   $710 = HEAP32[$709>>2]|0; //@line 141288 "c/sqlite3.c"
   $711 = ((($5)) + 4|0); //@line 141288 "c/sqlite3.c"
   $712 = HEAP32[$711>>2]|0; //@line 141288 "c/sqlite3.c"
   $713 = (_sqlite3PExpr($4,$708,$710,$712)|0); //@line 141288 "c/sqlite3.c"
   HEAP32[$709>>2] = $713; //@line 141288 "c/sqlite3.c"
   break;
  }
  case 173:  {
   $714 = ((($5)) + -8|0); //@line 141291 "c/sqlite3.c"
   $715 = ((($5)) + 4|0); //@line 141291 "c/sqlite3.c"
   $716 = $715; //@line 141291 "c/sqlite3.c"
   $717 = $716; //@line 141291 "c/sqlite3.c"
   $718 = HEAP32[$717>>2]|0; //@line 141291 "c/sqlite3.c"
   $719 = (($716) + 4)|0; //@line 141291 "c/sqlite3.c"
   $720 = $719; //@line 141291 "c/sqlite3.c"
   $721 = HEAP32[$720>>2]|0; //@line 141291 "c/sqlite3.c"
   $722 = $714; //@line 141291 "c/sqlite3.c"
   $723 = $722; //@line 141291 "c/sqlite3.c"
   HEAP32[$723>>2] = $718; //@line 141291 "c/sqlite3.c"
   $724 = (($722) + 4)|0; //@line 141291 "c/sqlite3.c"
   $725 = $724; //@line 141291 "c/sqlite3.c"
   HEAP32[$725>>2] = $721; //@line 141291 "c/sqlite3.c"
   $726 = ((($5)) + -4|0); //@line 141291 "c/sqlite3.c"
   $727 = HEAP32[$726>>2]|0; //@line 141291 "c/sqlite3.c"
   $728 = $727 | -2147483648; //@line 141291 "c/sqlite3.c"
   HEAP32[$726>>2] = $728; //@line 141291 "c/sqlite3.c"
   break;
  }
  case 174:  {
   $729 = ((($5)) + -8|0); //@line 141296 "c/sqlite3.c"
   $730 = ((($5)) + -4|0); //@line 141296 "c/sqlite3.c"
   $731 = HEAP32[$730>>2]|0; //@line 141296 "c/sqlite3.c"
   $732 = $731 & 2147483647; //@line 141297 "c/sqlite3.c"
   HEAP32[$730>>2] = $732; //@line 141297 "c/sqlite3.c"
   $733 = ((($5)) + 4|0); //@line 141298 "c/sqlite3.c"
   $734 = HEAP32[$733>>2]|0; //@line 141298 "c/sqlite3.c"
   $735 = (_sqlite3ExprListAppend($4,0,$734)|0); //@line 141298 "c/sqlite3.c"
   $736 = ((($5)) + -20|0); //@line 141299 "c/sqlite3.c"
   $737 = HEAP32[$736>>2]|0; //@line 141299 "c/sqlite3.c"
   $738 = (_sqlite3ExprListAppend($4,$735,$737)|0); //@line 141299 "c/sqlite3.c"
   $739 = (_sqlite3ExprFunction($4,$738,$729)|0); //@line 141300 "c/sqlite3.c"
   HEAP32[$736>>2] = $739; //@line 141300 "c/sqlite3.c"
   $740 = ($731|0)<(0); //@line 141301 "c/sqlite3.c"
   if ($740) {
    $741 = (_sqlite3PExpr($4,19,$739,0)|0); //@line 141301 "c/sqlite3.c"
    HEAP32[$736>>2] = $741; //@line 141301 "c/sqlite3.c"
    $743 = $741;
   } else {
    $743 = $739;
   }
   $742 = ($743|0)==(0|0); //@line 141302 "c/sqlite3.c"
   if (!($742)) {
    $744 = ((($743)) + 4|0); //@line 141302 "c/sqlite3.c"
    $745 = HEAP32[$744>>2]|0; //@line 141302 "c/sqlite3.c"
    $746 = $745 | 128; //@line 141302 "c/sqlite3.c"
    HEAP32[$744>>2] = $746; //@line 141302 "c/sqlite3.c"
   }
   break;
  }
  case 175:  {
   $747 = ((($5)) + -32|0); //@line 141308 "c/sqlite3.c"
   $748 = ((($5)) + -28|0); //@line 141308 "c/sqlite3.c"
   $749 = HEAP32[$748>>2]|0; //@line 141308 "c/sqlite3.c"
   $750 = $749 & 2147483647; //@line 141309 "c/sqlite3.c"
   HEAP32[$748>>2] = $750; //@line 141309 "c/sqlite3.c"
   $751 = ((($5)) + -20|0); //@line 141310 "c/sqlite3.c"
   $752 = HEAP32[$751>>2]|0; //@line 141310 "c/sqlite3.c"
   $753 = (_sqlite3ExprListAppend($4,0,$752)|0); //@line 141310 "c/sqlite3.c"
   $754 = ((($5)) + -44|0); //@line 141311 "c/sqlite3.c"
   $755 = HEAP32[$754>>2]|0; //@line 141311 "c/sqlite3.c"
   $756 = (_sqlite3ExprListAppend($4,$753,$755)|0); //@line 141311 "c/sqlite3.c"
   $757 = ((($5)) + 4|0); //@line 141312 "c/sqlite3.c"
   $758 = HEAP32[$757>>2]|0; //@line 141312 "c/sqlite3.c"
   $759 = (_sqlite3ExprListAppend($4,$756,$758)|0); //@line 141312 "c/sqlite3.c"
   $760 = (_sqlite3ExprFunction($4,$759,$747)|0); //@line 141313 "c/sqlite3.c"
   HEAP32[$754>>2] = $760; //@line 141313 "c/sqlite3.c"
   $761 = ($749|0)<(0); //@line 141314 "c/sqlite3.c"
   if ($761) {
    $762 = (_sqlite3PExpr($4,19,$760,0)|0); //@line 141314 "c/sqlite3.c"
    HEAP32[$754>>2] = $762; //@line 141314 "c/sqlite3.c"
    $764 = $762;
   } else {
    $764 = $760;
   }
   $763 = ($764|0)==(0|0); //@line 141315 "c/sqlite3.c"
   if (!($763)) {
    $765 = ((($764)) + 4|0); //@line 141315 "c/sqlite3.c"
    $766 = HEAP32[$765>>2]|0; //@line 141315 "c/sqlite3.c"
    $767 = $766 | 128; //@line 141315 "c/sqlite3.c"
    HEAP32[$765>>2] = $767; //@line 141315 "c/sqlite3.c"
   }
   break;
  }
  case 176:  {
   $768 = ((($5)) + 2|0); //@line 141319 "c/sqlite3.c"
   $769 = HEAP8[$768>>0]|0; //@line 141319 "c/sqlite3.c"
   $770 = $769&255; //@line 141319 "c/sqlite3.c"
   $771 = ((($5)) + -8|0); //@line 141319 "c/sqlite3.c"
   $772 = HEAP32[$771>>2]|0; //@line 141319 "c/sqlite3.c"
   $773 = (_sqlite3PExpr($4,$770,$772,0)|0); //@line 141319 "c/sqlite3.c"
   HEAP32[$771>>2] = $773; //@line 141319 "c/sqlite3.c"
   break;
  }
  case 177:  {
   $774 = ((($5)) + -20|0); //@line 141322 "c/sqlite3.c"
   $775 = HEAP32[$774>>2]|0; //@line 141322 "c/sqlite3.c"
   $776 = (_sqlite3PExpr($4,51,$775,0)|0); //@line 141322 "c/sqlite3.c"
   HEAP32[$774>>2] = $776; //@line 141322 "c/sqlite3.c"
   break;
  }
  case 178:  {
   $777 = ((($5)) + -20|0); //@line 141326 "c/sqlite3.c"
   $778 = HEAP32[$777>>2]|0; //@line 141326 "c/sqlite3.c"
   $779 = ((($5)) + 4|0); //@line 141326 "c/sqlite3.c"
   $780 = HEAP32[$779>>2]|0; //@line 141326 "c/sqlite3.c"
   $781 = (_sqlite3PExpr($4,45,$778,$780)|0); //@line 141326 "c/sqlite3.c"
   HEAP32[$777>>2] = $781; //@line 141326 "c/sqlite3.c"
   $782 = HEAP32[$779>>2]|0; //@line 141327 "c/sqlite3.c"
   _binaryToUnaryIfNull($4,$782,$781,50); //@line 141327 "c/sqlite3.c"
   break;
  }
  case 179:  {
   $783 = ((($5)) + -32|0); //@line 141332 "c/sqlite3.c"
   $784 = HEAP32[$783>>2]|0; //@line 141332 "c/sqlite3.c"
   $785 = ((($5)) + 4|0); //@line 141332 "c/sqlite3.c"
   $786 = HEAP32[$785>>2]|0; //@line 141332 "c/sqlite3.c"
   $787 = (_sqlite3PExpr($4,143,$784,$786)|0); //@line 141332 "c/sqlite3.c"
   HEAP32[$783>>2] = $787; //@line 141332 "c/sqlite3.c"
   $788 = HEAP32[$785>>2]|0; //@line 141333 "c/sqlite3.c"
   _binaryToUnaryIfNull($4,$788,$787,51); //@line 141333 "c/sqlite3.c"
   break;
  }
  case 181: case 180:  {
   $789 = ((($5)) + -10|0); //@line 141338 "c/sqlite3.c"
   $790 = HEAP8[$789>>0]|0; //@line 141338 "c/sqlite3.c"
   $791 = $790&255; //@line 141338 "c/sqlite3.c"
   $792 = ((($5)) + 4|0); //@line 141338 "c/sqlite3.c"
   $793 = HEAP32[$792>>2]|0; //@line 141338 "c/sqlite3.c"
   $794 = (_sqlite3PExpr($4,$791,$793,0)|0); //@line 141338 "c/sqlite3.c"
   $795 = ((($5)) + -8|0); //@line 141338 "c/sqlite3.c"
   HEAP32[$795>>2] = $794; //@line 141338 "c/sqlite3.c"
   break;
  }
  case 182:  {
   $796 = ((($5)) + 4|0); //@line 141341 "c/sqlite3.c"
   $797 = HEAP32[$796>>2]|0; //@line 141341 "c/sqlite3.c"
   $798 = (_sqlite3PExpr($4,148,$797,0)|0); //@line 141341 "c/sqlite3.c"
   $799 = ((($5)) + -8|0); //@line 141341 "c/sqlite3.c"
   HEAP32[$799>>2] = $798; //@line 141341 "c/sqlite3.c"
   break;
  }
  case 183:  {
   $800 = ((($5)) + 4|0); //@line 141344 "c/sqlite3.c"
   $801 = HEAP32[$800>>2]|0; //@line 141344 "c/sqlite3.c"
   $802 = (_sqlite3PExpr($4,149,$801,0)|0); //@line 141344 "c/sqlite3.c"
   $803 = ((($5)) + -8|0); //@line 141344 "c/sqlite3.c"
   HEAP32[$803>>2] = $802; //@line 141344 "c/sqlite3.c"
   break;
  }
  case 187: case 184:  {
   $804 = ((($5)) + 4|0); //@line 141348 "c/sqlite3.c"
   HEAP32[$804>>2] = 0; //@line 141348 "c/sqlite3.c"
   break;
  }
  case 186:  {
   $805 = ((($5)) + -20|0); //@line 141352 "c/sqlite3.c"
   $806 = HEAP32[$805>>2]|0; //@line 141352 "c/sqlite3.c"
   $807 = (_sqlite3ExprListAppend($4,0,$806)|0); //@line 141352 "c/sqlite3.c"
   $808 = ((($5)) + 4|0); //@line 141353 "c/sqlite3.c"
   $809 = HEAP32[$808>>2]|0; //@line 141353 "c/sqlite3.c"
   $810 = (_sqlite3ExprListAppend($4,$807,$809)|0); //@line 141353 "c/sqlite3.c"
   $811 = ((($5)) + -44|0); //@line 141354 "c/sqlite3.c"
   $812 = HEAP32[$811>>2]|0; //@line 141354 "c/sqlite3.c"
   $813 = (_sqlite3PExpr($4,48,$812,0)|0); //@line 141354 "c/sqlite3.c"
   HEAP32[$811>>2] = $813; //@line 141354 "c/sqlite3.c"
   $814 = ($813|0)==(0|0); //@line 141355 "c/sqlite3.c"
   if ($814) {
    $816 = HEAP32[$4>>2]|0; //@line 141358 "c/sqlite3.c"
    _sqlite3ExprListDelete($816,$810); //@line 141358 "c/sqlite3.c"
   } else {
    $815 = ((($813)) + 20|0); //@line 141356 "c/sqlite3.c"
    HEAP32[$815>>2] = $810; //@line 141356 "c/sqlite3.c"
   }
   $817 = ((($5)) + -32|0); //@line 141360 "c/sqlite3.c"
   $818 = HEAP32[$817>>2]|0; //@line 141360 "c/sqlite3.c"
   $819 = ($818|0)==(0); //@line 141360 "c/sqlite3.c"
   if (!($819)) {
    $820 = HEAP32[$811>>2]|0; //@line 141360 "c/sqlite3.c"
    $821 = (_sqlite3PExpr($4,19,$820,0)|0); //@line 141360 "c/sqlite3.c"
    HEAP32[$811>>2] = $821; //@line 141360 "c/sqlite3.c"
   }
   break;
  }
  case 189:  {
   $822 = ((($5)) + -8|0); //@line 141365 "c/sqlite3.c"
   $823 = HEAP32[$822>>2]|0; //@line 141365 "c/sqlite3.c"
   $824 = ($823|0)==(0|0); //@line 141365 "c/sqlite3.c"
   if ($824) {
    $825 = HEAP32[$4>>2]|0; //@line 141374 "c/sqlite3.c"
    $826 = ((($5)) + -44|0); //@line 141374 "c/sqlite3.c"
    $827 = HEAP32[$826>>2]|0; //@line 141374 "c/sqlite3.c"
    _sqlite3ExprDelete($825,$827); //@line 141374 "c/sqlite3.c"
    $828 = HEAP32[$4>>2]|0; //@line 141375 "c/sqlite3.c"
    $829 = ((($5)) + -32|0); //@line 141375 "c/sqlite3.c"
    $830 = HEAP32[$829>>2]|0; //@line 141375 "c/sqlite3.c"
    $831 = (4980 + ($830<<3)|0); //@line 141375 "c/sqlite3.c"
    $832 = (_sqlite3ExprAlloc($828,134,$831,1)|0); //@line 141375 "c/sqlite3.c"
    HEAP32[$826>>2] = $832; //@line 141375 "c/sqlite3.c"
    break L6;
   }
   $833 = HEAP32[$823>>2]|0; //@line 141376 "c/sqlite3.c"
   $834 = ($833|0)==(1); //@line 141376 "c/sqlite3.c"
   if ($834) {
    $835 = ((($823)) + 4|0); //@line 141393 "c/sqlite3.c"
    $836 = HEAP32[$835>>2]|0; //@line 141393 "c/sqlite3.c"
    HEAP32[$835>>2] = 0; //@line 141394 "c/sqlite3.c"
    $837 = HEAP32[$4>>2]|0; //@line 141395 "c/sqlite3.c"
    $838 = HEAP32[$822>>2]|0; //@line 141395 "c/sqlite3.c"
    _sqlite3ExprListDelete($837,$838); //@line 141395 "c/sqlite3.c"
    $839 = ($836|0)==(0|0); //@line 141398 "c/sqlite3.c"
    if (!($839)) {
     $840 = ((($836)) + 4|0); //@line 141399 "c/sqlite3.c"
     $841 = HEAP32[$840>>2]|0; //@line 141399 "c/sqlite3.c"
     $842 = $841 & -769; //@line 141399 "c/sqlite3.c"
     $843 = $842 | 512; //@line 141400 "c/sqlite3.c"
     HEAP32[$840>>2] = $843; //@line 141400 "c/sqlite3.c"
    }
    $844 = ((($5)) + -32|0); //@line 141402 "c/sqlite3.c"
    $845 = HEAP32[$844>>2]|0; //@line 141402 "c/sqlite3.c"
    $846 = ($845|0)==(0); //@line 141402 "c/sqlite3.c"
    $847 = $846 ? 53 : 52; //@line 141402 "c/sqlite3.c"
    $848 = ((($5)) + -44|0); //@line 141402 "c/sqlite3.c"
    $849 = HEAP32[$848>>2]|0; //@line 141402 "c/sqlite3.c"
    $850 = (_sqlite3PExpr($4,$847,$849,$836)|0); //@line 141402 "c/sqlite3.c"
    HEAP32[$848>>2] = $850; //@line 141402 "c/sqlite3.c"
    break L6;
   }
   $851 = ((($5)) + -44|0); //@line 141404 "c/sqlite3.c"
   $852 = HEAP32[$851>>2]|0; //@line 141404 "c/sqlite3.c"
   $853 = (_sqlite3PExpr($4,49,$852,0)|0); //@line 141404 "c/sqlite3.c"
   HEAP32[$851>>2] = $853; //@line 141404 "c/sqlite3.c"
   $854 = ($853|0)==(0|0); //@line 141405 "c/sqlite3.c"
   if ($854) {
    $858 = HEAP32[$4>>2]|0; //@line 141409 "c/sqlite3.c"
    $859 = HEAP32[$822>>2]|0; //@line 141409 "c/sqlite3.c"
    _sqlite3ExprListDelete($858,$859); //@line 141409 "c/sqlite3.c"
   } else {
    $855 = HEAP32[$822>>2]|0; //@line 141406 "c/sqlite3.c"
    $856 = ((($853)) + 20|0); //@line 141406 "c/sqlite3.c"
    HEAP32[$856>>2] = $855; //@line 141406 "c/sqlite3.c"
    $857 = HEAP32[$851>>2]|0; //@line 141407 "c/sqlite3.c"
    _sqlite3ExprSetHeightAndFlags($4,$857); //@line 141407 "c/sqlite3.c"
   }
   $860 = ((($5)) + -32|0); //@line 141411 "c/sqlite3.c"
   $861 = HEAP32[$860>>2]|0; //@line 141411 "c/sqlite3.c"
   $862 = ($861|0)==(0); //@line 141411 "c/sqlite3.c"
   if (!($862)) {
    $863 = HEAP32[$851>>2]|0; //@line 141411 "c/sqlite3.c"
    $864 = (_sqlite3PExpr($4,19,$863,0)|0); //@line 141411 "c/sqlite3.c"
    HEAP32[$851>>2] = $864; //@line 141411 "c/sqlite3.c"
   }
   break;
  }
  case 190:  {
   $865 = (_sqlite3PExpr($4,119,0,0)|0); //@line 141417 "c/sqlite3.c"
   $866 = ((($5)) + -20|0); //@line 141417 "c/sqlite3.c"
   HEAP32[$866>>2] = $865; //@line 141417 "c/sqlite3.c"
   $867 = ((($5)) + -8|0); //@line 141418 "c/sqlite3.c"
   $868 = HEAP32[$867>>2]|0; //@line 141418 "c/sqlite3.c"
   _sqlite3PExprAddSelect($4,$865,$868); //@line 141418 "c/sqlite3.c"
   break;
  }
  case 191:  {
   $869 = ((($5)) + -44|0); //@line 141423 "c/sqlite3.c"
   $870 = HEAP32[$869>>2]|0; //@line 141423 "c/sqlite3.c"
   $871 = (_sqlite3PExpr($4,49,$870,0)|0); //@line 141423 "c/sqlite3.c"
   HEAP32[$869>>2] = $871; //@line 141423 "c/sqlite3.c"
   $872 = ((($5)) + -8|0); //@line 141424 "c/sqlite3.c"
   $873 = HEAP32[$872>>2]|0; //@line 141424 "c/sqlite3.c"
   _sqlite3PExprAddSelect($4,$871,$873); //@line 141424 "c/sqlite3.c"
   $874 = ((($5)) + -32|0); //@line 141425 "c/sqlite3.c"
   $875 = HEAP32[$874>>2]|0; //@line 141425 "c/sqlite3.c"
   $876 = ($875|0)==(0); //@line 141425 "c/sqlite3.c"
   if (!($876)) {
    $877 = HEAP32[$869>>2]|0; //@line 141425 "c/sqlite3.c"
    $878 = (_sqlite3PExpr($4,19,$877,0)|0); //@line 141425 "c/sqlite3.c"
    HEAP32[$869>>2] = $878; //@line 141425 "c/sqlite3.c"
   }
   break;
  }
  case 192:  {
   $879 = HEAP32[$4>>2]|0; //@line 141430 "c/sqlite3.c"
   $880 = ((($5)) + -20|0); //@line 141430 "c/sqlite3.c"
   $881 = ((($5)) + -8|0); //@line 141430 "c/sqlite3.c"
   $882 = (_sqlite3SrcListAppend($879,0,$880,$881)|0); //@line 141430 "c/sqlite3.c"
   $883 = (_sqlite3SelectNew($4,0,$882,0,0,0,0,0,0)|0); //@line 141431 "c/sqlite3.c"
   $884 = ((($5)) + 4|0); //@line 141432 "c/sqlite3.c"
   $885 = HEAP32[$884>>2]|0; //@line 141432 "c/sqlite3.c"
   $886 = ($885|0)==(0|0); //@line 141432 "c/sqlite3.c"
   if (!($886)) {
    $887 = ($883|0)==(0|0); //@line 141432 "c/sqlite3.c"
    $888 = $887 ? 0 : $882; //@line 141432 "c/sqlite3.c"
    _sqlite3SrcListFuncArgs($4,$888,$885); //@line 141432 "c/sqlite3.c"
   }
   $889 = ((($5)) + -44|0); //@line 141433 "c/sqlite3.c"
   $890 = HEAP32[$889>>2]|0; //@line 141433 "c/sqlite3.c"
   $891 = (_sqlite3PExpr($4,49,$890,0)|0); //@line 141433 "c/sqlite3.c"
   HEAP32[$889>>2] = $891; //@line 141433 "c/sqlite3.c"
   _sqlite3PExprAddSelect($4,$891,$883); //@line 141434 "c/sqlite3.c"
   $892 = ((($5)) + -32|0); //@line 141435 "c/sqlite3.c"
   $893 = HEAP32[$892>>2]|0; //@line 141435 "c/sqlite3.c"
   $894 = ($893|0)==(0); //@line 141435 "c/sqlite3.c"
   if (!($894)) {
    $895 = HEAP32[$889>>2]|0; //@line 141435 "c/sqlite3.c"
    $896 = (_sqlite3PExpr($4,19,$895,0)|0); //@line 141435 "c/sqlite3.c"
    HEAP32[$889>>2] = $896; //@line 141435 "c/sqlite3.c"
   }
   break;
  }
  case 193:  {
   $897 = (_sqlite3PExpr($4,20,0,0)|0); //@line 141441 "c/sqlite3.c"
   $898 = ((($5)) + -32|0); //@line 141441 "c/sqlite3.c"
   HEAP32[$898>>2] = $897; //@line 141441 "c/sqlite3.c"
   $899 = ((($5)) + -8|0); //@line 141442 "c/sqlite3.c"
   $900 = HEAP32[$899>>2]|0; //@line 141442 "c/sqlite3.c"
   _sqlite3PExprAddSelect($4,$897,$900); //@line 141442 "c/sqlite3.c"
   break;
  }
  case 194:  {
   $901 = ((($5)) + -32|0); //@line 141447 "c/sqlite3.c"
   $902 = HEAP32[$901>>2]|0; //@line 141447 "c/sqlite3.c"
   $903 = (_sqlite3PExpr($4,136,$902,0)|0); //@line 141447 "c/sqlite3.c"
   $904 = ((($5)) + -44|0); //@line 141447 "c/sqlite3.c"
   HEAP32[$904>>2] = $903; //@line 141447 "c/sqlite3.c"
   $905 = ($903|0)==(0|0); //@line 141448 "c/sqlite3.c"
   if ($905) {
    $916 = HEAP32[$4>>2]|0; //@line 141452 "c/sqlite3.c"
    $917 = ((($5)) + -20|0); //@line 141452 "c/sqlite3.c"
    $918 = HEAP32[$917>>2]|0; //@line 141452 "c/sqlite3.c"
    _sqlite3ExprListDelete($916,$918); //@line 141452 "c/sqlite3.c"
    $919 = HEAP32[$4>>2]|0; //@line 141453 "c/sqlite3.c"
    $920 = ((($5)) + -8|0); //@line 141453 "c/sqlite3.c"
    $921 = HEAP32[$920>>2]|0; //@line 141453 "c/sqlite3.c"
    _sqlite3ExprDelete($919,$921); //@line 141453 "c/sqlite3.c"
    break L6;
   }
   $906 = ((($5)) + -8|0); //@line 141449 "c/sqlite3.c"
   $907 = HEAP32[$906>>2]|0; //@line 141449 "c/sqlite3.c"
   $908 = ($907|0)==(0|0); //@line 141449 "c/sqlite3.c"
   $909 = ((($5)) + -20|0);
   $910 = HEAP32[$909>>2]|0;
   if ($908) {
    $914 = $910;
   } else {
    $911 = (_sqlite3ExprListAppend($4,$910,$907)|0); //@line 141449 "c/sqlite3.c"
    $914 = $911;
   }
   $912 = HEAP32[$904>>2]|0; //@line 141449 "c/sqlite3.c"
   $913 = ((($912)) + 20|0); //@line 141449 "c/sqlite3.c"
   HEAP32[$913>>2] = $914; //@line 141449 "c/sqlite3.c"
   $915 = HEAP32[$904>>2]|0; //@line 141450 "c/sqlite3.c"
   _sqlite3ExprSetHeightAndFlags($4,$915); //@line 141450 "c/sqlite3.c"
   break;
  }
  case 195:  {
   $922 = ((($5)) + -44|0); //@line 141459 "c/sqlite3.c"
   $923 = HEAP32[$922>>2]|0; //@line 141459 "c/sqlite3.c"
   $924 = ((($5)) + -20|0); //@line 141459 "c/sqlite3.c"
   $925 = HEAP32[$924>>2]|0; //@line 141459 "c/sqlite3.c"
   $926 = (_sqlite3ExprListAppend($4,$923,$925)|0); //@line 141459 "c/sqlite3.c"
   HEAP32[$922>>2] = $926; //@line 141459 "c/sqlite3.c"
   $927 = ((($5)) + 4|0); //@line 141460 "c/sqlite3.c"
   $928 = HEAP32[$927>>2]|0; //@line 141460 "c/sqlite3.c"
   $929 = (_sqlite3ExprListAppend($4,$926,$928)|0); //@line 141460 "c/sqlite3.c"
   HEAP32[$922>>2] = $929; //@line 141460 "c/sqlite3.c"
   break;
  }
  case 196:  {
   $930 = ((($5)) + -20|0); //@line 141465 "c/sqlite3.c"
   $931 = HEAP32[$930>>2]|0; //@line 141465 "c/sqlite3.c"
   $932 = (_sqlite3ExprListAppend($4,0,$931)|0); //@line 141465 "c/sqlite3.c"
   $933 = ((($5)) + -32|0); //@line 141465 "c/sqlite3.c"
   HEAP32[$933>>2] = $932; //@line 141465 "c/sqlite3.c"
   $934 = ((($5)) + 4|0); //@line 141466 "c/sqlite3.c"
   $935 = HEAP32[$934>>2]|0; //@line 141466 "c/sqlite3.c"
   $936 = (_sqlite3ExprListAppend($4,$932,$935)|0); //@line 141466 "c/sqlite3.c"
   HEAP32[$933>>2] = $936; //@line 141466 "c/sqlite3.c"
   break;
  }
  case 272:  {
   $1201 = ((($5)) + -80|0); //@line 141720 "c/sqlite3.c"
   $1202 = HEAP32[$1201>>2]|0; //@line 141720 "c/sqlite3.c"
   $1203 = ((($5)) + -56|0); //@line 141720 "c/sqlite3.c"
   $1204 = ((($5)) + -44|0); //@line 141720 "c/sqlite3.c"
   $1205 = HEAP32[$1204>>2]|0; //@line 141720 "c/sqlite3.c"
   $1206 = ((($5)) + -8|0); //@line 141720 "c/sqlite3.c"
   $1207 = HEAP32[$1206>>2]|0; //@line 141720 "c/sqlite3.c"
   $1208 = (_sqlite3WithAdd($4,$1202,$1203,$1205,$1207)|0); //@line 141720 "c/sqlite3.c"
   HEAP32[$1201>>2] = $1208; //@line 141720 "c/sqlite3.c"
   break;
  }
  case 202:  {
   $937 = ((($5)) + -20|0); //@line 141473 "c/sqlite3.c"
   $938 = HEAP32[$937>>2]|0; //@line 141473 "c/sqlite3.c"
   $939 = ((($5)) + 4|0); //@line 141473 "c/sqlite3.c"
   $940 = HEAP32[$939>>2]|0; //@line 141473 "c/sqlite3.c"
   $941 = (_sqlite3ExprListAppend($4,$938,$940)|0); //@line 141473 "c/sqlite3.c"
   HEAP32[$937>>2] = $941; //@line 141473 "c/sqlite3.c"
   break;
  }
  case 203:  {
   $942 = ((($5)) + 4|0); //@line 141476 "c/sqlite3.c"
   $943 = HEAP32[$942>>2]|0; //@line 141476 "c/sqlite3.c"
   $944 = (_sqlite3ExprListAppend($4,0,$943)|0); //@line 141476 "c/sqlite3.c"
   HEAP32[$942>>2] = $944; //@line 141476 "c/sqlite3.c"
   break;
  }
  case 210: case 205:  {
   $945 = ((($5)) + -8|0); //@line 141480 "c/sqlite3.c"
   $946 = HEAP32[$945>>2]|0; //@line 141480 "c/sqlite3.c"
   $947 = ((($5)) + -20|0); //@line 141480 "c/sqlite3.c"
   HEAP32[$947>>2] = $946; //@line 141480 "c/sqlite3.c"
   break;
  }
  case 206:  {
   $948 = ((($5)) + -80|0); //@line 141484 "c/sqlite3.c"
   $949 = ((($5)) + -68|0); //@line 141484 "c/sqlite3.c"
   $950 = HEAP32[$4>>2]|0; //@line 141485 "c/sqlite3.c"
   $951 = ((($5)) + -44|0); //@line 141485 "c/sqlite3.c"
   $952 = (_sqlite3SrcListAppend($950,0,$951,0)|0); //@line 141485 "c/sqlite3.c"
   $953 = ((($5)) + -20|0); //@line 141485 "c/sqlite3.c"
   $954 = HEAP32[$953>>2]|0; //@line 141485 "c/sqlite3.c"
   $955 = ((($5)) + -116|0); //@line 141485 "c/sqlite3.c"
   $956 = HEAP32[$955>>2]|0; //@line 141485 "c/sqlite3.c"
   $957 = ((($5)) + -128|0); //@line 141486 "c/sqlite3.c"
   $958 = ((($5)) + 4|0); //@line 141486 "c/sqlite3.c"
   $959 = HEAP32[$958>>2]|0; //@line 141486 "c/sqlite3.c"
   $960 = ((($5)) + -92|0); //@line 141486 "c/sqlite3.c"
   $961 = HEAP32[$960>>2]|0; //@line 141486 "c/sqlite3.c"
   _sqlite3CreateIndex($4,$948,$949,$952,$954,$956,$957,$959,0,$961,0); //@line 141484 "c/sqlite3.c"
   break;
  }
  case 247: case 207:  {
   $962 = ((($5)) + 4|0); //@line 141491 "c/sqlite3.c"
   HEAP32[$962>>2] = 2; //@line 141491 "c/sqlite3.c"
   break;
  }
  case 208:  {
   $963 = ((($5)) + 16|0); //@line 141494 "c/sqlite3.c"
   HEAP32[$963>>2] = 0; //@line 141494 "c/sqlite3.c"
   break;
  }
  case 211:  {
   $964 = ((($5)) + -44|0); //@line 141498 "c/sqlite3.c"
   $965 = HEAP32[$964>>2]|0; //@line 141498 "c/sqlite3.c"
   $966 = ((($5)) + -20|0); //@line 141498 "c/sqlite3.c"
   $967 = ((($5)) + -8|0); //@line 141498 "c/sqlite3.c"
   $968 = HEAP32[$967>>2]|0; //@line 141498 "c/sqlite3.c"
   $969 = ((($5)) + 4|0); //@line 141498 "c/sqlite3.c"
   $970 = HEAP32[$969>>2]|0; //@line 141498 "c/sqlite3.c"
   $971 = (_parserAddExprIdListTerm($4,$965,$966,$968,$970)|0); //@line 141498 "c/sqlite3.c"
   HEAP32[$964>>2] = $971; //@line 141498 "c/sqlite3.c"
   break;
  }
  case 212:  {
   $972 = ((($5)) + -20|0); //@line 141503 "c/sqlite3.c"
   $973 = ((($5)) + -8|0); //@line 141503 "c/sqlite3.c"
   $974 = HEAP32[$973>>2]|0; //@line 141503 "c/sqlite3.c"
   $975 = ((($5)) + 4|0); //@line 141503 "c/sqlite3.c"
   $976 = HEAP32[$975>>2]|0; //@line 141503 "c/sqlite3.c"
   $977 = (_parserAddExprIdListTerm($4,0,$972,$974,$976)|0); //@line 141503 "c/sqlite3.c"
   HEAP32[$972>>2] = $977; //@line 141503 "c/sqlite3.c"
   break;
  }
  case 215:  {
   $978 = ((($5)) + 4|0); //@line 141507 "c/sqlite3.c"
   $979 = HEAP32[$978>>2]|0; //@line 141507 "c/sqlite3.c"
   $980 = ((($5)) + -8|0); //@line 141507 "c/sqlite3.c"
   $981 = HEAP32[$980>>2]|0; //@line 141507 "c/sqlite3.c"
   _sqlite3DropIndex($4,$979,$981); //@line 141507 "c/sqlite3.c"
   break;
  }
  case 216:  {
   _sqlite3Vacuum($4,0); //@line 141510 "c/sqlite3.c"
   break;
  }
  case 217:  {
   $982 = ((($5)) + 4|0); //@line 141513 "c/sqlite3.c"
   _sqlite3Vacuum($4,$982); //@line 141513 "c/sqlite3.c"
   break;
  }
  case 218:  {
   $983 = ((($5)) + -8|0); //@line 141516 "c/sqlite3.c"
   $984 = ((($5)) + 4|0); //@line 141516 "c/sqlite3.c"
   _sqlite3Pragma($4,$983,$984,0,0); //@line 141516 "c/sqlite3.c"
   break;
  }
  case 219:  {
   $985 = ((($5)) + -32|0); //@line 141519 "c/sqlite3.c"
   $986 = ((($5)) + -20|0); //@line 141519 "c/sqlite3.c"
   $987 = ((($5)) + 4|0); //@line 141519 "c/sqlite3.c"
   _sqlite3Pragma($4,$985,$986,$987,0); //@line 141519 "c/sqlite3.c"
   break;
  }
  case 220:  {
   $988 = ((($5)) + -44|0); //@line 141522 "c/sqlite3.c"
   $989 = ((($5)) + -32|0); //@line 141522 "c/sqlite3.c"
   $990 = ((($5)) + -8|0); //@line 141522 "c/sqlite3.c"
   _sqlite3Pragma($4,$988,$989,$990,0); //@line 141522 "c/sqlite3.c"
   break;
  }
  case 221:  {
   $991 = ((($5)) + -32|0); //@line 141525 "c/sqlite3.c"
   $992 = ((($5)) + -20|0); //@line 141525 "c/sqlite3.c"
   $993 = ((($5)) + 4|0); //@line 141525 "c/sqlite3.c"
   _sqlite3Pragma($4,$991,$992,$993,1); //@line 141525 "c/sqlite3.c"
   break;
  }
  case 222:  {
   $994 = ((($5)) + -44|0); //@line 141528 "c/sqlite3.c"
   $995 = ((($5)) + -32|0); //@line 141528 "c/sqlite3.c"
   $996 = ((($5)) + -8|0); //@line 141528 "c/sqlite3.c"
   _sqlite3Pragma($4,$994,$995,$996,1); //@line 141528 "c/sqlite3.c"
   break;
  }
  case 225:  {
   $997 = ((($5)) + -32|0); //@line 141533 "c/sqlite3.c"
   $998 = HEAP32[$997>>2]|0; //@line 141533 "c/sqlite3.c"
   HEAP32[$$byval_copy16>>2] = $998; //@line 141533 "c/sqlite3.c"
   $999 = ((($5)) + 4|0); //@line 141534 "c/sqlite3.c"
   $1000 = HEAP32[$999>>2]|0; //@line 141534 "c/sqlite3.c"
   $1001 = (($1000) - ($998))|0; //@line 141534 "c/sqlite3.c"
   $1002 = ((($5)) + 8|0); //@line 141534 "c/sqlite3.c"
   $1003 = HEAP32[$1002>>2]|0; //@line 141534 "c/sqlite3.c"
   $1004 = (($1001) + ($1003))|0; //@line 141534 "c/sqlite3.c"
   $1005 = ((($$byval_copy16)) + 4|0); //@line 141534 "c/sqlite3.c"
   HEAP32[$1005>>2] = $1004; //@line 141534 "c/sqlite3.c"
   $1006 = ((($5)) + -8|0); //@line 141535 "c/sqlite3.c"
   $1007 = HEAP32[$1006>>2]|0; //@line 141535 "c/sqlite3.c"
   _sqlite3FinishTrigger($4,$1007,$$byval_copy16); //@line 141535 "c/sqlite3.c"
   break;
  }
  case 226:  {
   $1008 = ((($5)) + -80|0); //@line 141540 "c/sqlite3.c"
   $1009 = ((($5)) + -68|0); //@line 141540 "c/sqlite3.c"
   $1010 = ((($5)) + -56|0); //@line 141540 "c/sqlite3.c"
   $1011 = HEAP32[$1010>>2]|0; //@line 141540 "c/sqlite3.c"
   $1012 = ((($5)) + -44|0); //@line 141540 "c/sqlite3.c"
   $1013 = HEAP32[$1012>>2]|0; //@line 141540 "c/sqlite3.c"
   $1014 = ((($5)) + -40|0); //@line 141540 "c/sqlite3.c"
   $1015 = HEAP32[$1014>>2]|0; //@line 141540 "c/sqlite3.c"
   $1016 = ((($5)) + -20|0); //@line 141540 "c/sqlite3.c"
   $1017 = HEAP32[$1016>>2]|0; //@line 141540 "c/sqlite3.c"
   $1018 = ((($5)) + 4|0); //@line 141540 "c/sqlite3.c"
   $1019 = HEAP32[$1018>>2]|0; //@line 141540 "c/sqlite3.c"
   $1020 = ((($5)) + -116|0); //@line 141540 "c/sqlite3.c"
   $1021 = HEAP32[$1020>>2]|0; //@line 141540 "c/sqlite3.c"
   $1022 = ((($5)) + -92|0); //@line 141540 "c/sqlite3.c"
   $1023 = HEAP32[$1022>>2]|0; //@line 141540 "c/sqlite3.c"
   _sqlite3BeginTrigger($4,$1008,$1009,$1011,$1013,$1015,$1017,$1019,$1021,$1023); //@line 141540 "c/sqlite3.c"
   $1024 = ((($5)) + -64|0); //@line 141541 "c/sqlite3.c"
   $1025 = HEAP32[$1024>>2]|0; //@line 141541 "c/sqlite3.c"
   $1026 = ($1025|0)==(0); //@line 141541 "c/sqlite3.c"
   if ($1026) {
    $1027 = $1008; //@line 141541 "c/sqlite3.c"
    $1028 = $1027; //@line 141541 "c/sqlite3.c"
    $1029 = HEAP32[$1028>>2]|0; //@line 141541 "c/sqlite3.c"
    $1030 = (($1027) + 4)|0; //@line 141541 "c/sqlite3.c"
    $1031 = $1030; //@line 141541 "c/sqlite3.c"
    $1032 = HEAP32[$1031>>2]|0; //@line 141541 "c/sqlite3.c"
    $1033 = $1020; //@line 141541 "c/sqlite3.c"
    $1034 = $1033; //@line 141541 "c/sqlite3.c"
    HEAP32[$1034>>2] = $1029; //@line 141541 "c/sqlite3.c"
    $1035 = (($1033) + 4)|0; //@line 141541 "c/sqlite3.c"
    $1036 = $1035; //@line 141541 "c/sqlite3.c"
    HEAP32[$1036>>2] = $1032; //@line 141541 "c/sqlite3.c"
    break L6;
   } else {
    $1037 = $1009; //@line 141541 "c/sqlite3.c"
    $1038 = $1037; //@line 141541 "c/sqlite3.c"
    $1039 = HEAP32[$1038>>2]|0; //@line 141541 "c/sqlite3.c"
    $1040 = (($1037) + 4)|0; //@line 141541 "c/sqlite3.c"
    $1041 = $1040; //@line 141541 "c/sqlite3.c"
    $1042 = HEAP32[$1041>>2]|0; //@line 141541 "c/sqlite3.c"
    $1043 = $1020; //@line 141541 "c/sqlite3.c"
    $1044 = $1043; //@line 141541 "c/sqlite3.c"
    HEAP32[$1044>>2] = $1039; //@line 141541 "c/sqlite3.c"
    $1045 = (($1043) + 4)|0; //@line 141541 "c/sqlite3.c"
    $1046 = $1045; //@line 141541 "c/sqlite3.c"
    HEAP32[$1046>>2] = $1042; //@line 141541 "c/sqlite3.c"
    break L6;
   }
   break;
  }
  case 227:  {
   $1047 = ((($5)) + 2|0); //@line 141545 "c/sqlite3.c"
   $1048 = HEAP8[$1047>>0]|0; //@line 141545 "c/sqlite3.c"
   $1049 = $1048&255; //@line 141545 "c/sqlite3.c"
   $1050 = ((($5)) + 4|0); //@line 141545 "c/sqlite3.c"
   HEAP32[$1050>>2] = $1049; //@line 141545 "c/sqlite3.c"
   break;
  }
  case 228:  {
   $1051 = ((($5)) + -8|0); //@line 141548 "c/sqlite3.c"
   HEAP32[$1051>>2] = 64; //@line 141548 "c/sqlite3.c"
   break;
  }
  case 229:  {
   $1052 = ((($5)) + 16|0); //@line 141551 "c/sqlite3.c"
   HEAP32[$1052>>2] = 33; //@line 141551 "c/sqlite3.c"
   break;
  }
  case 231: case 230:  {
   $1053 = ((($5)) + 2|0); //@line 141555 "c/sqlite3.c"
   $1054 = HEAP8[$1053>>0]|0; //@line 141555 "c/sqlite3.c"
   $1055 = $1054&255; //@line 141555 "c/sqlite3.c"
   $1056 = ((($5)) + 4|0); //@line 141555 "c/sqlite3.c"
   HEAP32[$1056>>2] = $1055; //@line 141555 "c/sqlite3.c"
   $1057 = ((($5)) + 8|0); //@line 141555 "c/sqlite3.c"
   HEAP32[$1057>>2] = 0; //@line 141555 "c/sqlite3.c"
   break;
  }
  case 232:  {
   $1058 = ((($5)) + -20|0); //@line 141558 "c/sqlite3.c"
   HEAP32[$1058>>2] = 110; //@line 141558 "c/sqlite3.c"
   $1059 = ((($5)) + 4|0); //@line 141558 "c/sqlite3.c"
   $1060 = HEAP32[$1059>>2]|0; //@line 141558 "c/sqlite3.c"
   $1061 = ((($5)) + -16|0); //@line 141558 "c/sqlite3.c"
   HEAP32[$1061>>2] = $1060; //@line 141558 "c/sqlite3.c"
   break;
  }
  case 252: case 233:  {
   $1062 = ((($5)) + 16|0); //@line 141562 "c/sqlite3.c"
   HEAP32[$1062>>2] = 0; //@line 141562 "c/sqlite3.c"
   break;
  }
  case 253: case 234:  {
   $1063 = ((($5)) + 4|0); //@line 141566 "c/sqlite3.c"
   $1064 = HEAP32[$1063>>2]|0; //@line 141566 "c/sqlite3.c"
   $1065 = ((($5)) + -8|0); //@line 141566 "c/sqlite3.c"
   HEAP32[$1065>>2] = $1064; //@line 141566 "c/sqlite3.c"
   break;
  }
  case 235:  {
   $1066 = ((($5)) + -8|0); //@line 141571 "c/sqlite3.c"
   $1067 = HEAP32[$1066>>2]|0; //@line 141571 "c/sqlite3.c"
   $1068 = ((($5)) + -20|0); //@line 141571 "c/sqlite3.c"
   $1069 = HEAP32[$1068>>2]|0; //@line 141571 "c/sqlite3.c"
   $1070 = ((($1069)) + 36|0); //@line 141571 "c/sqlite3.c"
   $1071 = HEAP32[$1070>>2]|0; //@line 141571 "c/sqlite3.c"
   $1072 = ((($1071)) + 32|0); //@line 141571 "c/sqlite3.c"
   HEAP32[$1072>>2] = $1067; //@line 141571 "c/sqlite3.c"
   $1073 = HEAP32[$1066>>2]|0; //@line 141572 "c/sqlite3.c"
   $1074 = HEAP32[$1068>>2]|0; //@line 141572 "c/sqlite3.c"
   $1075 = ((($1074)) + 36|0); //@line 141572 "c/sqlite3.c"
   HEAP32[$1075>>2] = $1073; //@line 141572 "c/sqlite3.c"
   break;
  }
  case 236:  {
   $1076 = ((($5)) + -8|0); //@line 141578 "c/sqlite3.c"
   $1077 = HEAP32[$1076>>2]|0; //@line 141578 "c/sqlite3.c"
   $1078 = ((($1077)) + 36|0); //@line 141578 "c/sqlite3.c"
   HEAP32[$1078>>2] = $1077; //@line 141578 "c/sqlite3.c"
   break;
  }
  case 237:  {
   $1079 = ((($5)) + -20|0); //@line 141583 "c/sqlite3.c"
   $1080 = ((($5)) + 4|0); //@line 141583 "c/sqlite3.c"
   $1081 = $1080; //@line 141583 "c/sqlite3.c"
   $1082 = $1081; //@line 141583 "c/sqlite3.c"
   $1083 = HEAP32[$1082>>2]|0; //@line 141583 "c/sqlite3.c"
   $1084 = (($1081) + 4)|0; //@line 141583 "c/sqlite3.c"
   $1085 = $1084; //@line 141583 "c/sqlite3.c"
   $1086 = HEAP32[$1085>>2]|0; //@line 141583 "c/sqlite3.c"
   $1087 = $1079; //@line 141583 "c/sqlite3.c"
   $1088 = $1087; //@line 141583 "c/sqlite3.c"
   HEAP32[$1088>>2] = $1083; //@line 141583 "c/sqlite3.c"
   $1089 = (($1087) + 4)|0; //@line 141583 "c/sqlite3.c"
   $1090 = $1089; //@line 141583 "c/sqlite3.c"
   HEAP32[$1090>>2] = $1086; //@line 141583 "c/sqlite3.c"
   _sqlite3ErrorMsg($4,19325,$vararg_buffer8); //@line 141584 "c/sqlite3.c"
   break;
  }
  case 238:  {
   _sqlite3ErrorMsg($4,19420,$vararg_buffer10); //@line 141591 "c/sqlite3.c"
   break;
  }
  case 239:  {
   _sqlite3ErrorMsg($4,19504,$vararg_buffer12); //@line 141598 "c/sqlite3.c"
   break;
  }
  case 240:  {
   $1091 = HEAP32[$4>>2]|0; //@line 141604 "c/sqlite3.c"
   $1092 = ((($5)) + -56|0); //@line 141604 "c/sqlite3.c"
   $1093 = ((($5)) + -20|0); //@line 141604 "c/sqlite3.c"
   $1094 = HEAP32[$1093>>2]|0; //@line 141604 "c/sqlite3.c"
   $1095 = ((($5)) + -8|0); //@line 141604 "c/sqlite3.c"
   $1096 = HEAP32[$1095>>2]|0; //@line 141604 "c/sqlite3.c"
   $1097 = ((($5)) + -68|0); //@line 141604 "c/sqlite3.c"
   $1098 = HEAP32[$1097>>2]|0; //@line 141604 "c/sqlite3.c"
   $1099 = $1098&255; //@line 141604 "c/sqlite3.c"
   $1100 = ((($5)) + -80|0); //@line 141604 "c/sqlite3.c"
   $1101 = HEAP32[$1100>>2]|0; //@line 141604 "c/sqlite3.c"
   $1102 = ((($5)) + 4|0); //@line 141604 "c/sqlite3.c"
   $1103 = HEAP32[$1102>>2]|0; //@line 141604 "c/sqlite3.c"
   $1104 = (_sqlite3TriggerUpdateStep($1091,$1092,$1094,$1096,$1099,$1101,$1103)|0); //@line 141604 "c/sqlite3.c"
   HEAP32[$1100>>2] = $1104; //@line 141605 "c/sqlite3.c"
   break;
  }
  case 241:  {
   $1105 = HEAP32[$4>>2]|0; //@line 141608 "c/sqlite3.c"
   $1106 = ((($5)) + -32|0); //@line 141608 "c/sqlite3.c"
   $1107 = ((($5)) + -20|0); //@line 141608 "c/sqlite3.c"
   $1108 = HEAP32[$1107>>2]|0; //@line 141608 "c/sqlite3.c"
   $1109 = ((($5)) + -8|0); //@line 141608 "c/sqlite3.c"
   $1110 = HEAP32[$1109>>2]|0; //@line 141608 "c/sqlite3.c"
   $1111 = ((($5)) + -56|0); //@line 141608 "c/sqlite3.c"
   $1112 = HEAP32[$1111>>2]|0; //@line 141608 "c/sqlite3.c"
   $1113 = $1112&255; //@line 141608 "c/sqlite3.c"
   $1114 = ((($5)) + -68|0); //@line 141608 "c/sqlite3.c"
   $1115 = HEAP32[$1114>>2]|0; //@line 141608 "c/sqlite3.c"
   $1116 = ((($5)) + 4|0); //@line 141608 "c/sqlite3.c"
   $1117 = HEAP32[$1116>>2]|0; //@line 141608 "c/sqlite3.c"
   $1118 = (_sqlite3TriggerInsertStep($1105,$1106,$1108,$1110,$1113,$1115,$1117)|0); //@line 141608 "c/sqlite3.c"
   HEAP32[$1114>>2] = $1118; //@line 141609 "c/sqlite3.c"
   break;
  }
  case 242:  {
   $1119 = HEAP32[$4>>2]|0; //@line 141612 "c/sqlite3.c"
   $1120 = ((($5)) + -32|0); //@line 141612 "c/sqlite3.c"
   $1121 = ((($5)) + -8|0); //@line 141612 "c/sqlite3.c"
   $1122 = HEAP32[$1121>>2]|0; //@line 141612 "c/sqlite3.c"
   $1123 = ((($5)) + -56|0); //@line 141612 "c/sqlite3.c"
   $1124 = HEAP32[$1123>>2]|0; //@line 141612 "c/sqlite3.c"
   $1125 = ((($5)) + 4|0); //@line 141612 "c/sqlite3.c"
   $1126 = HEAP32[$1125>>2]|0; //@line 141612 "c/sqlite3.c"
   $1127 = (_sqlite3TriggerDeleteStep($1119,$1120,$1122,$1124,$1126)|0); //@line 141612 "c/sqlite3.c"
   HEAP32[$1123>>2] = $1127; //@line 141613 "c/sqlite3.c"
   break;
  }
  case 243:  {
   $1128 = HEAP32[$4>>2]|0; //@line 141616 "c/sqlite3.c"
   $1129 = ((($5)) + -8|0); //@line 141616 "c/sqlite3.c"
   $1130 = HEAP32[$1129>>2]|0; //@line 141616 "c/sqlite3.c"
   $1131 = ((($5)) + -20|0); //@line 141616 "c/sqlite3.c"
   $1132 = HEAP32[$1131>>2]|0; //@line 141616 "c/sqlite3.c"
   $1133 = ((($5)) + 4|0); //@line 141616 "c/sqlite3.c"
   $1134 = HEAP32[$1133>>2]|0; //@line 141616 "c/sqlite3.c"
   $1135 = (_sqlite3TriggerSelectStep($1128,$1130,$1132,$1134)|0); //@line 141616 "c/sqlite3.c"
   HEAP32[$1131>>2] = $1135; //@line 141617 "c/sqlite3.c"
   break;
  }
  case 244:  {
   $1136 = (_sqlite3PExpr($4,70,0,0)|0); //@line 141621 "c/sqlite3.c"
   $1137 = ((($5)) + -32|0); //@line 141621 "c/sqlite3.c"
   HEAP32[$1137>>2] = $1136; //@line 141621 "c/sqlite3.c"
   $1138 = ($1136|0)==(0|0); //@line 141622 "c/sqlite3.c"
   if (!($1138)) {
    $1139 = ((($1136)) + 1|0); //@line 141623 "c/sqlite3.c"
    HEAP8[$1139>>0] = 4; //@line 141623 "c/sqlite3.c"
   }
   break;
  }
  case 245:  {
   $1140 = HEAP32[$4>>2]|0; //@line 141629 "c/sqlite3.c"
   $1141 = ((($5)) + -8|0); //@line 141629 "c/sqlite3.c"
   $1142 = (_sqlite3ExprAlloc($1140,70,$1141,1)|0); //@line 141629 "c/sqlite3.c"
   $1143 = ((($5)) + -56|0); //@line 141629 "c/sqlite3.c"
   HEAP32[$1143>>2] = $1142; //@line 141629 "c/sqlite3.c"
   $1144 = ($1142|0)==(0|0); //@line 141630 "c/sqlite3.c"
   if (!($1144)) {
    $1145 = ((($5)) + -32|0); //@line 141631 "c/sqlite3.c"
    $1146 = HEAP32[$1145>>2]|0; //@line 141631 "c/sqlite3.c"
    $1147 = $1146&255; //@line 141631 "c/sqlite3.c"
    $1148 = ((($1142)) + 1|0); //@line 141631 "c/sqlite3.c"
    HEAP8[$1148>>0] = $1147; //@line 141631 "c/sqlite3.c"
   }
   break;
  }
  case 246:  {
   $1149 = ((($5)) + 4|0); //@line 141636 "c/sqlite3.c"
   HEAP32[$1149>>2] = 1; //@line 141636 "c/sqlite3.c"
   break;
  }
  case 248:  {
   $1150 = ((($5)) + 4|0); //@line 141639 "c/sqlite3.c"
   HEAP32[$1150>>2] = 3; //@line 141639 "c/sqlite3.c"
   break;
  }
  case 249:  {
   $1151 = ((($5)) + 4|0); //@line 141643 "c/sqlite3.c"
   $1152 = HEAP32[$1151>>2]|0; //@line 141643 "c/sqlite3.c"
   $1153 = ((($5)) + -8|0); //@line 141643 "c/sqlite3.c"
   $1154 = HEAP32[$1153>>2]|0; //@line 141643 "c/sqlite3.c"
   _sqlite3DropTrigger($4,$1152,$1154); //@line 141643 "c/sqlite3.c"
   break;
  }
  case 250:  {
   $1155 = ((($5)) + -32|0); //@line 141648 "c/sqlite3.c"
   $1156 = HEAP32[$1155>>2]|0; //@line 141648 "c/sqlite3.c"
   $1157 = ((($5)) + -8|0); //@line 141648 "c/sqlite3.c"
   $1158 = HEAP32[$1157>>2]|0; //@line 141648 "c/sqlite3.c"
   $1159 = ((($5)) + 4|0); //@line 141648 "c/sqlite3.c"
   $1160 = HEAP32[$1159>>2]|0; //@line 141648 "c/sqlite3.c"
   _sqlite3Attach($4,$1156,$1158,$1160); //@line 141648 "c/sqlite3.c"
   break;
  }
  case 251:  {
   $1161 = ((($5)) + 4|0); //@line 141653 "c/sqlite3.c"
   $1162 = HEAP32[$1161>>2]|0; //@line 141653 "c/sqlite3.c"
   _sqlite3Detach($4,$1162); //@line 141653 "c/sqlite3.c"
   break;
  }
  case 254:  {
   _sqlite3Reindex($4,0,0); //@line 141657 "c/sqlite3.c"
   break;
  }
  case 255:  {
   $1163 = ((($5)) + -8|0); //@line 141660 "c/sqlite3.c"
   $1164 = ((($5)) + 4|0); //@line 141660 "c/sqlite3.c"
   _sqlite3Reindex($4,$1163,$1164); //@line 141660 "c/sqlite3.c"
   break;
  }
  case 256:  {
   _sqlite3Analyze($4,0,0); //@line 141663 "c/sqlite3.c"
   break;
  }
  case 257:  {
   $1165 = ((($5)) + -8|0); //@line 141666 "c/sqlite3.c"
   $1166 = ((($5)) + 4|0); //@line 141666 "c/sqlite3.c"
   _sqlite3Analyze($4,$1165,$1166); //@line 141666 "c/sqlite3.c"
   break;
  }
  case 258:  {
   $1167 = ((($5)) + -32|0); //@line 141670 "c/sqlite3.c"
   $1168 = HEAP32[$1167>>2]|0; //@line 141670 "c/sqlite3.c"
   $1169 = ((($5)) + 4|0); //@line 141670 "c/sqlite3.c"
   _sqlite3AlterRenameTable($4,$1168,$1169); //@line 141670 "c/sqlite3.c"
   break;
  }
  case 259:  {
   $1170 = ((($4)) + 388|0); //@line 141675 "c/sqlite3.c"
   $1171 = HEAP32[$1170>>2]|0; //@line 141675 "c/sqlite3.c"
   $1172 = ((($5)) + -8|0); //@line 141675 "c/sqlite3.c"
   $1173 = HEAP32[$1172>>2]|0; //@line 141675 "c/sqlite3.c"
   $1174 = (($1171) - ($1173))|0; //@line 141675 "c/sqlite3.c"
   $1175 = ((($4)) + 392|0); //@line 141675 "c/sqlite3.c"
   $1176 = HEAP32[$1175>>2]|0; //@line 141675 "c/sqlite3.c"
   $1177 = (($1174) + ($1176))|0; //@line 141675 "c/sqlite3.c"
   $1178 = ((($5)) + -4|0); //@line 141675 "c/sqlite3.c"
   HEAP32[$1178>>2] = $1177; //@line 141675 "c/sqlite3.c"
   _sqlite3AlterFinishAddColumn($4,$1172); //@line 141676 "c/sqlite3.c"
   break;
  }
  case 260:  {
   _disableLookaside($4); //@line 141681 "c/sqlite3.c"
   $1179 = ((($5)) + 4|0); //@line 141682 "c/sqlite3.c"
   $1180 = HEAP32[$1179>>2]|0; //@line 141682 "c/sqlite3.c"
   _sqlite3AlterBeginAddColumn($4,$1180); //@line 141682 "c/sqlite3.c"
   break;
  }
  case 261:  {
   _sqlite3VtabFinishParse($4,0); //@line 141686 "c/sqlite3.c"
   break;
  }
  case 262:  {
   $1181 = ((($5)) + 4|0); //@line 141689 "c/sqlite3.c"
   _sqlite3VtabFinishParse($4,$1181); //@line 141689 "c/sqlite3.c"
   break;
  }
  case 263:  {
   $1182 = ((($5)) + -32|0); //@line 141693 "c/sqlite3.c"
   $1183 = ((($5)) + -20|0); //@line 141693 "c/sqlite3.c"
   $1184 = ((($5)) + 4|0); //@line 141693 "c/sqlite3.c"
   $1185 = ((($5)) + -44|0); //@line 141693 "c/sqlite3.c"
   $1186 = HEAP32[$1185>>2]|0; //@line 141693 "c/sqlite3.c"
   _sqlite3VtabBeginParse($4,$1182,$1183,$1184,$1186); //@line 141693 "c/sqlite3.c"
   break;
  }
  case 264:  {
   _sqlite3VtabArgInit($4); //@line 141697 "c/sqlite3.c"
   break;
  }
  case 267: case 266: case 265:  {
   $1187 = ((($5)) + 4|0); //@line 141702 "c/sqlite3.c"
   _sqlite3VtabArgExtend($4,$1187); //@line 141702 "c/sqlite3.c"
   break;
  }
  case 268:  {
   $1188 = ((($5)) + 16|0); //@line 141705 "c/sqlite3.c"
   HEAP32[$1188>>2] = 0; //@line 141705 "c/sqlite3.c"
   break;
  }
  case 269:  {
   $1189 = ((($5)) + 4|0); //@line 141708 "c/sqlite3.c"
   $1190 = HEAP32[$1189>>2]|0; //@line 141708 "c/sqlite3.c"
   $1191 = ((($5)) + -8|0); //@line 141708 "c/sqlite3.c"
   HEAP32[$1191>>2] = $1190; //@line 141708 "c/sqlite3.c"
   break;
  }
  case 270:  {
   $1192 = ((($5)) + 4|0); //@line 141711 "c/sqlite3.c"
   $1193 = HEAP32[$1192>>2]|0; //@line 141711 "c/sqlite3.c"
   $1194 = ((($5)) + -20|0); //@line 141711 "c/sqlite3.c"
   HEAP32[$1194>>2] = $1193; //@line 141711 "c/sqlite3.c"
   break;
  }
  case 271:  {
   $1195 = ((($5)) + -56|0); //@line 141715 "c/sqlite3.c"
   $1196 = ((($5)) + -44|0); //@line 141715 "c/sqlite3.c"
   $1197 = HEAP32[$1196>>2]|0; //@line 141715 "c/sqlite3.c"
   $1198 = ((($5)) + -8|0); //@line 141715 "c/sqlite3.c"
   $1199 = HEAP32[$1198>>2]|0; //@line 141715 "c/sqlite3.c"
   $1200 = (_sqlite3WithAdd($4,0,$1195,$1197,$1199)|0); //@line 141715 "c/sqlite3.c"
   HEAP32[$1195>>2] = $1200; //@line 141715 "c/sqlite3.c"
   break;
  }
  default: {
  }
  }
 } while(0);
 $1209 = (18565 + ($1<<1)|0); //@line 141785 "c/sqlite3.c"
 $1210 = HEAP8[$1209>>0]|0; //@line 141785 "c/sqlite3.c"
 $1211 = $7 << 24 >> 24; //@line 141786 "c/sqlite3.c"
 $1212 = (($5) + (($1211*12)|0)|0); //@line 141787 "c/sqlite3.c"
 $1213 = HEAP16[$1212>>1]|0; //@line 141787 "c/sqlite3.c"
 $1214 = $1213&65535; //@line 141787 "c/sqlite3.c"
 $1215 = (_yy_find_reduce_action($1214,$1210)|0); //@line 141787 "c/sqlite3.c"
 $1216 = (($1211) + 1)|0; //@line 141796 "c/sqlite3.c"
 $1217 = (($5) + (($1216*12)|0)|0); //@line 141796 "c/sqlite3.c"
 HEAP32[$0>>2] = $1217; //@line 141797 "c/sqlite3.c"
 $1218 = $1215&65535; //@line 141798 "c/sqlite3.c"
 HEAP16[$1217>>1] = $1218; //@line 141798 "c/sqlite3.c"
 $1219 = (((($5) + (($1216*12)|0)|0)) + 2|0); //@line 141799 "c/sqlite3.c"
 HEAP8[$1219>>0] = $1210; //@line 141799 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 141801 "c/sqlite3.c"
}
function _yyStackOverflow($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 140083 "c/sqlite3.c"
 $1 = ((($0)) + 4|0); //@line 140084 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 140084 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 140090 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 140090 "c/sqlite3.c"
 $5 = ($3>>>0)>($4>>>0); //@line 140090 "c/sqlite3.c"
 if ($5) {
  while(1) {
   _yy_pop_parser_stack($0); //@line 140090 "c/sqlite3.c"
   $6 = HEAP32[$0>>2]|0; //@line 140090 "c/sqlite3.c"
   $7 = ($6>>>0)>($4>>>0); //@line 140090 "c/sqlite3.c"
   if (!($7)) {
    break;
   }
  }
 }
 _sqlite3ErrorMsg($2,31355,$vararg_buffer); //@line 140095 "c/sqlite3.c"
 HEAP32[$1>>2] = $2; //@line 140097 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 140098 "c/sqlite3.c"
}
function _sqlite3FinishCoding($0) {
 $0 = $0|0;
 var $$07681 = 0, $$07779 = 0, $$178 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 101755 "c/sqlite3.c"
 $2 = ((($0)) + 18|0); //@line 101756 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 101756 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 101756 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 101855 "c/sqlite3.c"
 }
 $5 = ((($1)) + 73|0); //@line 101757 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 101757 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 101757 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 36|0); //@line 101757 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 101757 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 101757 "c/sqlite3.c"
  if ($10) {
   $14 = (_sqlite3GetVdbe($0)|0); //@line 101765 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 101768 "c/sqlite3.c"
   if (!($15)) {
    (_sqlite3VdbeAddOp0($14,66)|0); //@line 101769 "c/sqlite3.c"
    $16 = HEAP8[$5>>0]|0; //@line 101788 "c/sqlite3.c"
    $17 = ($16<<24>>24)==(0); //@line 101788 "c/sqlite3.c"
    do {
     if ($17) {
      $18 = ((($0)) + 92|0); //@line 101789 "c/sqlite3.c"
      $19 = HEAP32[$18>>2]|0; //@line 101789 "c/sqlite3.c"
      $20 = ($19|0)==(0); //@line 101789 "c/sqlite3.c"
      if ($20) {
       $21 = ((($0)) + 76|0); //@line 101789 "c/sqlite3.c"
       $22 = HEAP32[$21>>2]|0; //@line 101789 "c/sqlite3.c"
       $23 = ($22|0)==(0|0); //@line 101789 "c/sqlite3.c"
       if ($23) {
        break;
       }
      }
      _sqlite3VdbeJumpHere($14,0); //@line 101793 "c/sqlite3.c"
      $24 = ((($1)) + 20|0); //@line 101794 "c/sqlite3.c"
      $25 = HEAP32[$24>>2]|0; //@line 101794 "c/sqlite3.c"
      $26 = ($25|0)>(0); //@line 101794 "c/sqlite3.c"
      if ($26) {
       $27 = ((($1)) + 16|0);
       $28 = ((($0)) + 88|0);
       $29 = ((($1)) + 157|0);
       $$07681 = 0;
       while(1) {
        $30 = HEAP32[$18>>2]|0; //@line 101796 "c/sqlite3.c"
        $31 = 1 << $$07681; //@line 101796 "c/sqlite3.c"
        $32 = $30 & $31; //@line 101796 "c/sqlite3.c"
        $33 = ($32|0)==(0); //@line 101796 "c/sqlite3.c"
        if (!($33)) {
         _sqlite3VdbeUsesBtree($14,$$07681); //@line 101797 "c/sqlite3.c"
         $34 = HEAP32[$27>>2]|0; //@line 101798 "c/sqlite3.c"
         $35 = (((($34) + ($$07681<<4)|0)) + 12|0); //@line 101798 "c/sqlite3.c"
         $36 = HEAP32[$35>>2]|0; //@line 101798 "c/sqlite3.c"
         $37 = HEAP32[$28>>2]|0; //@line 101802 "c/sqlite3.c"
         $38 = $37 & $31; //@line 101802 "c/sqlite3.c"
         $39 = ($38|0)!=(0); //@line 101802 "c/sqlite3.c"
         $40 = $39&1; //@line 101802 "c/sqlite3.c"
         $41 = HEAP32[$36>>2]|0; //@line 101803 "c/sqlite3.c"
         $42 = ((($36)) + 4|0); //@line 101804 "c/sqlite3.c"
         $43 = HEAP32[$42>>2]|0; //@line 101804 "c/sqlite3.c"
         (_sqlite3VdbeAddOp4Int($14,2,$$07681,$40,$41,$43)|0); //@line 101799 "c/sqlite3.c"
         $44 = HEAP8[$29>>0]|0; //@line 101806 "c/sqlite3.c"
         $45 = ($44<<24>>24)==(0); //@line 101806 "c/sqlite3.c"
         if ($45) {
          _sqlite3VdbeChangeP5($14,1); //@line 101806 "c/sqlite3.c"
         }
        }
        $46 = (($$07681) + 1)|0; //@line 101794 "c/sqlite3.c"
        $47 = HEAP32[$24>>2]|0; //@line 101794 "c/sqlite3.c"
        $48 = ($46|0)<($47|0); //@line 101794 "c/sqlite3.c"
        if ($48) {
         $$07681 = $46;
        } else {
         break;
        }
       }
      }
      $49 = ((($0)) + 404|0); //@line 101811 "c/sqlite3.c"
      $50 = HEAP32[$49>>2]|0; //@line 101811 "c/sqlite3.c"
      $51 = ($50|0)>(0); //@line 101811 "c/sqlite3.c"
      if ($51) {
       $52 = ((($0)) + 452|0);
       $$07779 = 0;
       while(1) {
        $53 = HEAP32[$52>>2]|0; //@line 101812 "c/sqlite3.c"
        $54 = (($53) + ($$07779<<2)|0); //@line 101812 "c/sqlite3.c"
        $55 = HEAP32[$54>>2]|0; //@line 101812 "c/sqlite3.c"
        $56 = (_sqlite3GetVTable($1,$55)|0); //@line 101812 "c/sqlite3.c"
        (_sqlite3VdbeAddOp4($14,154,0,0,0,$56,-12)|0); //@line 101813 "c/sqlite3.c"
        $57 = (($$07779) + 1)|0; //@line 101811 "c/sqlite3.c"
        $58 = HEAP32[$49>>2]|0; //@line 101811 "c/sqlite3.c"
        $59 = ($57|0)<($58|0); //@line 101811 "c/sqlite3.c"
        if ($59) {
         $$07779 = $57;
        } else {
         break;
        }
       }
      }
      HEAP32[$49>>2] = 0; //@line 101815 "c/sqlite3.c"
      _codeTableLocks($0); //@line 101822 "c/sqlite3.c"
      _sqlite3AutoincrementBegin($0); //@line 101826 "c/sqlite3.c"
      $60 = ((($0)) + 76|0); //@line 101829 "c/sqlite3.c"
      $61 = HEAP32[$60>>2]|0; //@line 101829 "c/sqlite3.c"
      $62 = ($61|0)==(0|0); //@line 101829 "c/sqlite3.c"
      if (!($62)) {
       $63 = ((($0)) + 23|0); //@line 101831 "c/sqlite3.c"
       HEAP8[$63>>0] = 0; //@line 101831 "c/sqlite3.c"
       $64 = HEAP32[$61>>2]|0; //@line 101832 "c/sqlite3.c"
       $65 = ($64|0)>(0); //@line 101832 "c/sqlite3.c"
       if ($65) {
        $$178 = 0;
        while(1) {
         $66 = (((($61)) + 4|0) + (($$178*20)|0)|0); //@line 101833 "c/sqlite3.c"
         $67 = HEAP32[$66>>2]|0; //@line 101833 "c/sqlite3.c"
         $68 = (((((($61)) + 4|0) + (($$178*20)|0)|0)) + 16|0); //@line 101833 "c/sqlite3.c"
         $69 = HEAP32[$68>>2]|0; //@line 101833 "c/sqlite3.c"
         _sqlite3ExprCode($0,$67,$69); //@line 101833 "c/sqlite3.c"
         $70 = (($$178) + 1)|0; //@line 101832 "c/sqlite3.c"
         $71 = HEAP32[$61>>2]|0; //@line 101832 "c/sqlite3.c"
         $72 = ($70|0)<($71|0); //@line 101832 "c/sqlite3.c"
         if ($72) {
          $$178 = $70;
         } else {
          break;
         }
        }
       }
      }
      _sqlite3VdbeGoto($14,1); //@line 101838 "c/sqlite3.c"
     }
    } while(0);
    $73 = HEAP32[$8>>2]|0; //@line 101845 "c/sqlite3.c"
    $74 = ($73|0)==(0); //@line 101845 "c/sqlite3.c"
    if ($74) {
     $75 = HEAP8[$5>>0]|0; //@line 101845 "c/sqlite3.c"
     $76 = ($75<<24>>24)==(0); //@line 101845 "c/sqlite3.c"
     if ($76) {
      $77 = ((($0)) + 116|0); //@line 101849 "c/sqlite3.c"
      $78 = HEAP32[$77>>2]|0; //@line 101849 "c/sqlite3.c"
      $79 = ($78|0)==(0|0); //@line 101849 "c/sqlite3.c"
      if (!($79)) {
       $80 = ((($0)) + 40|0); //@line 101849 "c/sqlite3.c"
       $81 = HEAP32[$80>>2]|0; //@line 101849 "c/sqlite3.c"
       $82 = ($81|0)==(0); //@line 101849 "c/sqlite3.c"
       if ($82) {
        HEAP32[$80>>2] = 1; //@line 101849 "c/sqlite3.c"
       }
      }
      _sqlite3VdbeMakeReady($14,$0); //@line 101850 "c/sqlite3.c"
      $83 = ((($0)) + 12|0); //@line 101851 "c/sqlite3.c"
      HEAP32[$83>>2] = 101; //@line 101851 "c/sqlite3.c"
      return; //@line 101855 "c/sqlite3.c"
     }
    }
   }
   $84 = ((($0)) + 12|0); //@line 101853 "c/sqlite3.c"
   HEAP32[$84>>2] = 1; //@line 101853 "c/sqlite3.c"
   return; //@line 101855 "c/sqlite3.c"
  }
 }
 $11 = ((($0)) + 12|0); //@line 101758 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 101758 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 101758 "c/sqlite3.c"
 if (!($13)) {
  return; //@line 101855 "c/sqlite3.c"
 }
 HEAP32[$11>>2] = 1; //@line 101758 "c/sqlite3.c"
 return; //@line 101855 "c/sqlite3.c"
}
function _sqlite3BeginTransaction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 105574 "c/sqlite3.c"
 $3 = (_sqlite3AuthCheck($0,22,31285,0,0)|0); //@line 105576 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 105576 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 105588 "c/sqlite3.c"
 }
 $5 = (_sqlite3GetVdbe($0)|0); //@line 105579 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 105580 "c/sqlite3.c"
 if ($6) {
  return; //@line 105588 "c/sqlite3.c"
 }
 $7 = ($1|0)==(7); //@line 105581 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($2)) + 20|0); //@line 105582 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 105582 "c/sqlite3.c"
  $10 = ($9|0)>(0); //@line 105582 "c/sqlite3.c"
  if ($10) {
   $11 = ($1|0)==(9);
   $12 = $11 ? 2 : 1;
   $$018 = 0;
   while(1) {
    (_sqlite3VdbeAddOp2($5,2,$$018,$12)|0); //@line 105583 "c/sqlite3.c"
    _sqlite3VdbeUsesBtree($5,$$018); //@line 105584 "c/sqlite3.c"
    $13 = (($$018) + 1)|0; //@line 105582 "c/sqlite3.c"
    $14 = HEAP32[$8>>2]|0; //@line 105582 "c/sqlite3.c"
    $15 = ($13|0)<($14|0); //@line 105582 "c/sqlite3.c"
    if ($15) {
     $$018 = $13;
    } else {
     break;
    }
   }
  }
 }
 (_sqlite3VdbeAddOp0($5,1)|0); //@line 105587 "c/sqlite3.c"
 return; //@line 105588 "c/sqlite3.c"
}
function _sqlite3EndTransaction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(12); //@line 105602 "c/sqlite3.c"
 $3 = $2&1; //@line 105602 "c/sqlite3.c"
 $4 = $2 ? 31299 : 31308; //@line 105604 "c/sqlite3.c"
 $5 = (_sqlite3AuthCheck($0,22,$4,0,0)|0); //@line 105603 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 105603 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 105611 "c/sqlite3.c"
 }
 $7 = (_sqlite3GetVdbe($0)|0); //@line 105607 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 105608 "c/sqlite3.c"
 if ($8) {
  return; //@line 105611 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($7,1,1,$3)|0); //@line 105609 "c/sqlite3.c"
 return; //@line 105611 "c/sqlite3.c"
}
function _sqlite3Savepoint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 105618 "c/sqlite3.c"
 $4 = (_sqlite3NameFromToken($3,$2)|0); //@line 105618 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 105619 "c/sqlite3.c"
 if ($5) {
  return; //@line 105631 "c/sqlite3.c"
 }
 $6 = (_sqlite3GetVdbe($0)|0); //@line 105620 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 105625 "c/sqlite3.c"
 if (!($7)) {
  $8 = (6380 + ($1<<2)|0); //@line 105625 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 105625 "c/sqlite3.c"
  $10 = (_sqlite3AuthCheck($0,32,$9,$4,0)|0); //@line 105625 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 105625 "c/sqlite3.c"
  if ($11) {
   (_sqlite3VdbeAddOp4($6,0,$1,0,0,$4,-7)|0); //@line 105629 "c/sqlite3.c"
   return; //@line 105631 "c/sqlite3.c"
  }
 }
 $12 = HEAP32[$0>>2]|0; //@line 105626 "c/sqlite3.c"
 _sqlite3DbFree($12,$4); //@line 105626 "c/sqlite3.c"
 return; //@line 105631 "c/sqlite3.c"
}
function _sqlite3StartTable($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0141 = 0, $$1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0;
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0;
 var $spec$select = 0, $spec$select145 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $7 = sp + 20|0;
 $8 = HEAP32[$0>>2]|0; //@line 102474 "c/sqlite3.c"
 $9 = ((($8)) + 157|0); //@line 102479 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 102479 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 102479 "c/sqlite3.c"
 if ($11) {
  label = 4;
 } else {
  $12 = ((($8)) + 152|0); //@line 102479 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 102479 "c/sqlite3.c"
  $14 = ($13|0)==(1); //@line 102479 "c/sqlite3.c"
  if ($14) {
   $15 = ((($8)) + 156|0); //@line 102481 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 102481 "c/sqlite3.c"
   $17 = $16&255; //@line 102481 "c/sqlite3.c"
   $18 = ($16<<24>>24)==(1); //@line 102482 "c/sqlite3.c"
   $19 = $18 ? 21366 : 19754; //@line 102482 "c/sqlite3.c"
   $20 = (_sqlite3DbStrDup($8,$19)|0); //@line 102482 "c/sqlite3.c"
   HEAP32[$7>>2] = $1; //@line 102483 "c/sqlite3.c"
   $$0141 = $20;$$1 = $17;
  } else {
   label = 4;
  }
 }
 if ((label|0) == 4) {
  $21 = (_sqlite3TwoPartName($0,$1,$2,$7)|0); //@line 102486 "c/sqlite3.c"
  $22 = ($21|0)<(0); //@line 102487 "c/sqlite3.c"
  if ($22) {
   STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
  }
  $23 = ($3|0)!=(0); //@line 102488 "c/sqlite3.c"
  if ($23) {
   $24 = ((($2)) + 4|0); //@line 102488 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 102488 "c/sqlite3.c"
   $26 = ($25|0)!=(0); //@line 102488 "c/sqlite3.c"
   $27 = ($21|0)!=(1); //@line 102488 "c/sqlite3.c"
   $or$cond = $27 & $26; //@line 102488 "c/sqlite3.c"
   if ($or$cond) {
    _sqlite3ErrorMsg($0,31175,$vararg_buffer); //@line 102491 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
   }
  }
  $spec$select = $23 ? 1 : $21; //@line 102494 "c/sqlite3.c"
  $28 = HEAP32[$7>>2]|0; //@line 102495 "c/sqlite3.c"
  $29 = (_sqlite3NameFromToken($8,$28)|0); //@line 102495 "c/sqlite3.c"
  $$0141 = $29;$$1 = $spec$select;
 }
 $30 = ((($0)) + 380|0); //@line 102497 "c/sqlite3.c"
 $31 = HEAP32[$7>>2]|0; //@line 102497 "c/sqlite3.c"
 $32 = $31; //@line 102497 "c/sqlite3.c"
 $33 = $32; //@line 102497 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 102497 "c/sqlite3.c"
 $35 = (($32) + 4)|0; //@line 102497 "c/sqlite3.c"
 $36 = $35; //@line 102497 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 102497 "c/sqlite3.c"
 $38 = $30; //@line 102497 "c/sqlite3.c"
 $39 = $38; //@line 102497 "c/sqlite3.c"
 HEAP32[$39>>2] = $34; //@line 102497 "c/sqlite3.c"
 $40 = (($38) + 4)|0; //@line 102497 "c/sqlite3.c"
 $41 = $40; //@line 102497 "c/sqlite3.c"
 HEAP32[$41>>2] = $37; //@line 102497 "c/sqlite3.c"
 $42 = ($$0141|0)==(0|0); //@line 102498 "c/sqlite3.c"
 if ($42) {
  STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
 }
 $43 = (_sqlite3CheckObjectName($0,$$0141)|0); //@line 102499 "c/sqlite3.c"
 $44 = ($43|0)==(0); //@line 102499 "c/sqlite3.c"
 L18: do {
  if ($44) {
   $45 = ((($8)) + 156|0); //@line 102502 "c/sqlite3.c"
   $46 = HEAP8[$45>>0]|0; //@line 102502 "c/sqlite3.c"
   $47 = ($46<<24>>24)==(1); //@line 102502 "c/sqlite3.c"
   $spec$select145 = $47 ? 1 : $3; //@line 102502 "c/sqlite3.c"
   $48 = ((($8)) + 16|0); //@line 102513 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 102513 "c/sqlite3.c"
   $50 = (($49) + ($$1<<4)|0); //@line 102513 "c/sqlite3.c"
   $51 = HEAP32[$50>>2]|0; //@line 102513 "c/sqlite3.c"
   $52 = ($spec$select145|0)==(1); //@line 102514 "c/sqlite3.c"
   $53 = $52 ? 21366 : 19754; //@line 102514 "c/sqlite3.c"
   $54 = (_sqlite3AuthCheck($0,18,$53,0,$51)|0); //@line 102514 "c/sqlite3.c"
   $55 = ($54|0)==(0); //@line 102514 "c/sqlite3.c"
   if ($55) {
    $56 = ($5|0)==(0); //@line 102517 "c/sqlite3.c"
    if ($56) {
     $57 = $4 << 1; //@line 102517 "c/sqlite3.c"
     $58 = (($spec$select145) + ($57))|0; //@line 102517 "c/sqlite3.c"
     $59 = (31216 + ($58)|0); //@line 102517 "c/sqlite3.c"
     $60 = HEAP8[$59>>0]|0; //@line 102517 "c/sqlite3.c"
     $61 = $60&255; //@line 102517 "c/sqlite3.c"
     $62 = (_sqlite3AuthCheck($0,$61,$$0141,0,$51)|0); //@line 102517 "c/sqlite3.c"
     $63 = ($62|0)==(0); //@line 102517 "c/sqlite3.c"
     if (!($63)) {
      break;
     }
    }
    $64 = ((($0)) + 400|0); //@line 102531 "c/sqlite3.c"
    $65 = HEAP8[$64>>0]|0; //@line 102531 "c/sqlite3.c"
    $66 = ($65<<24>>24)==(0); //@line 102531 "c/sqlite3.c"
    do {
     if ($66) {
      $67 = HEAP32[$48>>2]|0; //@line 102532 "c/sqlite3.c"
      $68 = (($67) + ($$1<<4)|0); //@line 102532 "c/sqlite3.c"
      $69 = HEAP32[$68>>2]|0; //@line 102532 "c/sqlite3.c"
      $70 = (_sqlite3ReadSchema($0)|0); //@line 102533 "c/sqlite3.c"
      $71 = ($70|0)==(0); //@line 102533 "c/sqlite3.c"
      if (!($71)) {
       break L18;
      }
      $72 = (_sqlite3FindTable($8,$$0141,$69)|0); //@line 102536 "c/sqlite3.c"
      $73 = ($72|0)==(0|0); //@line 102537 "c/sqlite3.c"
      if ($73) {
       $76 = (_sqlite3FindIndex($8,$$0141,$69)|0); //@line 102546 "c/sqlite3.c"
       $77 = ($76|0)==(0|0); //@line 102546 "c/sqlite3.c"
       if ($77) {
        break;
       }
       HEAP32[$vararg_buffer3>>2] = $$0141; //@line 102547 "c/sqlite3.c"
       _sqlite3ErrorMsg($0,31244,$vararg_buffer3); //@line 102547 "c/sqlite3.c"
       break L18;
      }
      $74 = ($6|0)==(0); //@line 102538 "c/sqlite3.c"
      if ($74) {
       $75 = HEAP32[$7>>2]|0; //@line 102539 "c/sqlite3.c"
       HEAP32[$vararg_buffer1>>2] = $75; //@line 102539 "c/sqlite3.c"
       _sqlite3ErrorMsg($0,31220,$vararg_buffer1); //@line 102539 "c/sqlite3.c"
       break L18;
      } else {
       _sqlite3CodeVerifySchema($0,$$1); //@line 102542 "c/sqlite3.c"
       break L18;
      }
     }
    } while(0);
    $78 = (_sqlite3DbMallocZero($8,80,0)|0); //@line 102552 "c/sqlite3.c"
    $79 = ($78|0)==(0|0); //@line 102553 "c/sqlite3.c"
    if ($79) {
     $80 = ((($0)) + 12|0); //@line 102555 "c/sqlite3.c"
     HEAP32[$80>>2] = 7; //@line 102555 "c/sqlite3.c"
     $81 = ((($0)) + 36|0); //@line 102556 "c/sqlite3.c"
     $82 = HEAP32[$81>>2]|0; //@line 102556 "c/sqlite3.c"
     $83 = (($82) + 1)|0; //@line 102556 "c/sqlite3.c"
     HEAP32[$81>>2] = $83; //@line 102556 "c/sqlite3.c"
     break;
    }
    HEAP32[$78>>2] = $$0141; //@line 102559 "c/sqlite3.c"
    $84 = ((($78)) + 40|0); //@line 102560 "c/sqlite3.c"
    HEAP16[$84>>1] = -1; //@line 102560 "c/sqlite3.c"
    $85 = HEAP32[$48>>2]|0; //@line 102561 "c/sqlite3.c"
    $86 = (((($85) + ($$1<<4)|0)) + 12|0); //@line 102561 "c/sqlite3.c"
    $87 = HEAP32[$86>>2]|0; //@line 102561 "c/sqlite3.c"
    $88 = ((($78)) + 72|0); //@line 102561 "c/sqlite3.c"
    HEAP32[$88>>2] = $87; //@line 102561 "c/sqlite3.c"
    $89 = ((($78)) + 32|0); //@line 102562 "c/sqlite3.c"
    HEAP32[$89>>2] = 1; //@line 102562 "c/sqlite3.c"
    $90 = ((($78)) + 44|0); //@line 102566 "c/sqlite3.c"
    HEAP16[$90>>1] = 200; //@line 102566 "c/sqlite3.c"
    $91 = ((($0)) + 432|0); //@line 102569 "c/sqlite3.c"
    HEAP32[$91>>2] = $78; //@line 102569 "c/sqlite3.c"
    $92 = ((($0)) + 18|0); //@line 102576 "c/sqlite3.c"
    $93 = HEAP8[$92>>0]|0; //@line 102576 "c/sqlite3.c"
    $94 = ($93<<24>>24)==(0); //@line 102576 "c/sqlite3.c"
    if ($94) {
     $95 = (_strcmp($$0141,22689)|0); //@line 102576 "c/sqlite3.c"
     $96 = ($95|0)==(0); //@line 102576 "c/sqlite3.c"
     if ($96) {
      $97 = HEAP32[$88>>2]|0; //@line 102578 "c/sqlite3.c"
      $98 = ((($97)) + 72|0); //@line 102578 "c/sqlite3.c"
      HEAP32[$98>>2] = $78; //@line 102578 "c/sqlite3.c"
     }
    }
    $99 = HEAP8[$9>>0]|0; //@line 102590 "c/sqlite3.c"
    $100 = ($99<<24>>24)==(0); //@line 102590 "c/sqlite3.c"
    if (!($100)) {
     STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
    }
    $101 = (_sqlite3GetVdbe($0)|0); //@line 102590 "c/sqlite3.c"
    $102 = ($101|0)==(0|0); //@line 102590 "c/sqlite3.c"
    if ($102) {
     STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
    }
    _sqlite3BeginWriteOperation($0,1,$$1); //@line 102596 "c/sqlite3.c"
    $103 = ($5|0)==(0); //@line 102599 "c/sqlite3.c"
    if (!($103)) {
     (_sqlite3VdbeAddOp0($101,154)|0); //@line 102600 "c/sqlite3.c"
    }
    $104 = ((($0)) + 44|0); //@line 102607 "c/sqlite3.c"
    $105 = HEAP32[$104>>2]|0; //@line 102607 "c/sqlite3.c"
    $106 = (($105) + 1)|0; //@line 102607 "c/sqlite3.c"
    $107 = ((($0)) + 96|0); //@line 102607 "c/sqlite3.c"
    HEAP32[$107>>2] = $106; //@line 102607 "c/sqlite3.c"
    $108 = (($105) + 2)|0; //@line 102608 "c/sqlite3.c"
    $109 = ((($0)) + 100|0); //@line 102608 "c/sqlite3.c"
    HEAP32[$109>>2] = $108; //@line 102608 "c/sqlite3.c"
    $110 = (($105) + 3)|0; //@line 102609 "c/sqlite3.c"
    HEAP32[$104>>2] = $110; //@line 102609 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($101,102,$$1,$110,2)|0); //@line 102610 "c/sqlite3.c"
    _sqlite3VdbeUsesBtree($101,$$1); //@line 102611 "c/sqlite3.c"
    $111 = (_sqlite3VdbeAddOp1($101,21,$110)|0); //@line 102612 "c/sqlite3.c"
    $112 = ((($8)) + 28|0); //@line 102613 "c/sqlite3.c"
    $113 = HEAP32[$112>>2]|0; //@line 102613 "c/sqlite3.c"
    $114 = $113 & 2; //@line 102613 "c/sqlite3.c"
    $115 = ($114|0)==(0); //@line 102613 "c/sqlite3.c"
    $116 = $115 ? 4 : 1; //@line 102613 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($101,103,$$1,2,$116)|0); //@line 102615 "c/sqlite3.c"
    $117 = ((($8)) + 70|0); //@line 102616 "c/sqlite3.c"
    $118 = HEAP8[$117>>0]|0; //@line 102616 "c/sqlite3.c"
    $119 = $118&255; //@line 102616 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($101,103,$$1,5,$119)|0); //@line 102616 "c/sqlite3.c"
    _sqlite3VdbeJumpHere($101,$111); //@line 102617 "c/sqlite3.c"
    $120 = $5 | $4; //@line 102629 "c/sqlite3.c"
    $121 = ($120|0)==(0); //@line 102629 "c/sqlite3.c"
    if ($121) {
     $122 = (_sqlite3VdbeAddOp3($101,136,$$1,$108,1)|0); //@line 102635 "c/sqlite3.c"
     $123 = ((($0)) + 128|0); //@line 102634 "c/sqlite3.c"
     HEAP32[$123>>2] = $122; //@line 102634 "c/sqlite3.c"
    } else {
     (_sqlite3VdbeAddOp2($101,67,0,$108)|0); //@line 102630 "c/sqlite3.c"
    }
    _sqlite3OpenMasterTable($0,$$1); //@line 102637 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($101,116,0,$106)|0); //@line 102638 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4($101,72,6,$110,0,31279,-1)|0); //@line 102639 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($101,117,0,$110,$106)|0); //@line 102640 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($101,8); //@line 102641 "c/sqlite3.c"
    (_sqlite3VdbeAddOp0($101,113)|0); //@line 102642 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
   }
  }
 } while(0);
 _sqlite3DbFree($8,$$0141); //@line 102650 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 102652 "c/sqlite3.c"
}
function _disableLookaside($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 138193 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 138193 "c/sqlite3.c"
 $3 = (($2) + 1)<<24>>24; //@line 138193 "c/sqlite3.c"
 HEAP8[$1>>0] = $3; //@line 138193 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 138194 "c/sqlite3.c"
 $5 = ((($4)) + 264|0); //@line 138194 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 138194 "c/sqlite3.c"
 $7 = (($6) + 1)|0; //@line 138194 "c/sqlite3.c"
 HEAP32[$5>>2] = $7; //@line 138194 "c/sqlite3.c"
 return; //@line 138195 "c/sqlite3.c"
}
function _sqlite3EndTable($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$ = 0, $$0186 = 0, $$0186199 = 0, $$0186200 = 0, $$0188 = 0, $$0191 = 0, $$192 = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0;
 var $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0;
 var $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer18 = 0, $vararg_buffer21 = 0, $vararg_buffer3 = 0, $vararg_buffer8 = 0, $vararg_ptr11 = 0, $vararg_ptr12 = 0, $vararg_ptr13 = 0, $vararg_ptr14 = 0, $vararg_ptr15 = 0, $vararg_ptr16 = 0, $vararg_ptr17 = 0, $vararg_ptr6 = 0;
 var $vararg_ptr7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $vararg_buffer21 = sp + 72|0;
 $vararg_buffer18 = sp + 64|0;
 $vararg_buffer8 = sp + 32|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $5 = sp + 80|0;
 $6 = HEAP32[$0>>2]|0; //@line 103466 "c/sqlite3.c"
 $7 = ($2|0)==(0|0); //@line 103470 "c/sqlite3.c"
 $8 = ($4|0)==(0|0); //@line 103470 "c/sqlite3.c"
 $or$cond = $7 & $8; //@line 103470 "c/sqlite3.c"
 if ($or$cond) {
  STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
 }
 $9 = ((($0)) + 432|0); //@line 103474 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 103474 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 103475 "c/sqlite3.c"
 if ($11) {
  STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
 }
 $12 = ((($6)) + 157|0); //@line 103488 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 103488 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 103488 "c/sqlite3.c"
 if (!($14)) {
  $15 = ((($6)) + 152|0); //@line 103489 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 103489 "c/sqlite3.c"
  $17 = ((($10)) + 28|0); //@line 103489 "c/sqlite3.c"
  HEAP32[$17>>2] = $16; //@line 103489 "c/sqlite3.c"
  $18 = ($16|0)==(1); //@line 103490 "c/sqlite3.c"
  if ($18) {
   $19 = ((($10)) + 36|0); //@line 103490 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 103490 "c/sqlite3.c"
   $21 = $20 | 1; //@line 103490 "c/sqlite3.c"
   HEAP32[$19>>2] = $21; //@line 103490 "c/sqlite3.c"
  }
 }
 $22 = $3 & 32; //@line 103494 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(0); //@line 103494 "c/sqlite3.c"
 do {
  if (!($23)) {
   $24 = ((($10)) + 36|0); //@line 103495 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 103495 "c/sqlite3.c"
   $26 = $25 & 8; //@line 103495 "c/sqlite3.c"
   $27 = ($26|0)==(0); //@line 103495 "c/sqlite3.c"
   if (!($27)) {
    _sqlite3ErrorMsg($0,29804,$vararg_buffer); //@line 103496 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
   }
   $28 = $25 & 4; //@line 103500 "c/sqlite3.c"
   $29 = ($28|0)==(0); //@line 103500 "c/sqlite3.c"
   if ($29) {
    $30 = HEAP32[$10>>2]|0; //@line 103501 "c/sqlite3.c"
    HEAP32[$vararg_buffer1>>2] = $30; //@line 103501 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,29854,$vararg_buffer1); //@line 103501 "c/sqlite3.c"
    break;
   } else {
    $31 = $25 | 96; //@line 103503 "c/sqlite3.c"
    HEAP32[$24>>2] = $31; //@line 103503 "c/sqlite3.c"
    _convertToWithoutRowidTable($0,$10); //@line 103504 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $32 = ((($10)) + 72|0); //@line 103508 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 103508 "c/sqlite3.c"
 $34 = (_sqlite3SchemaToIndex($6,$33)|0); //@line 103508 "c/sqlite3.c"
 $35 = ((($10)) + 24|0); //@line 103513 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 103513 "c/sqlite3.c"
 $37 = ($36|0)==(0|0); //@line 103513 "c/sqlite3.c"
 if (!($37)) {
  _sqlite3ResolveSelfReference($0,$10,4,0,$36); //@line 103514 "c/sqlite3.c"
 }
 _estimateTableWidth($10); //@line 103519 "c/sqlite3.c"
 $38 = ((($10)) + 8|0); //@line 103520 "c/sqlite3.c"
 $$0186199 = HEAP32[$38>>2]|0;
 $39 = ($$0186199|0)==(0|0); //@line 103520 "c/sqlite3.c"
 if (!($39)) {
  $$0186200 = $$0186199;
  while(1) {
   _estimateIndexWidth($$0186200); //@line 103521 "c/sqlite3.c"
   $40 = ((($$0186200)) + 20|0); //@line 103520 "c/sqlite3.c"
   $$0186 = HEAP32[$40>>2]|0;
   $41 = ($$0186|0)==(0|0); //@line 103520 "c/sqlite3.c"
   if ($41) {
    break;
   } else {
    $$0186200 = $$0186;
   }
  }
 }
 $42 = HEAP8[$12>>0]|0; //@line 103530 "c/sqlite3.c"
 $43 = ($42<<24>>24)==(0); //@line 103530 "c/sqlite3.c"
 if ($43) {
  $44 = (_sqlite3GetVdbe($0)|0); //@line 103537 "c/sqlite3.c"
  $45 = ($44|0)==(0|0); //@line 103538 "c/sqlite3.c"
  if ($45) {
   STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
  }
  (_sqlite3VdbeAddOp1($44,113,0)|0); //@line 103540 "c/sqlite3.c"
  $46 = ((($10)) + 12|0); //@line 103545 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 103545 "c/sqlite3.c"
  $48 = ($47|0)==(0|0); //@line 103545 "c/sqlite3.c"
  $$ = $48 ? 29886 : 29892; //@line 103550 "c/sqlite3.c"
  $$192 = $48 ? 20408 : 28758; //@line 103550 "c/sqlite3.c"
  $49 = ($4|0)==(0|0); //@line 103570 "c/sqlite3.c"
  do {
   if ($49) {
    $81 = ($3<<24>>24)==(0); //@line 103618 "c/sqlite3.c"
    $82 = ((($0)) + 388|0); //@line 103618 "c/sqlite3.c"
    $83 = $81 ? $2 : $82; //@line 103618 "c/sqlite3.c"
    $84 = HEAP32[$83>>2]|0; //@line 103619 "c/sqlite3.c"
    $85 = ((($0)) + 380|0); //@line 103619 "c/sqlite3.c"
    $86 = HEAP32[$85>>2]|0; //@line 103619 "c/sqlite3.c"
    $87 = $84; //@line 103619 "c/sqlite3.c"
    $88 = (($87) - ($86))|0; //@line 103619 "c/sqlite3.c"
    $89 = HEAP8[$84>>0]|0; //@line 103620 "c/sqlite3.c"
    $90 = ($89<<24>>24)==(59); //@line 103620 "c/sqlite3.c"
    if ($90) {
     $$0188 = $88;
    } else {
     $91 = ((($83)) + 4|0); //@line 103620 "c/sqlite3.c"
     $92 = HEAP32[$91>>2]|0; //@line 103620 "c/sqlite3.c"
     $93 = (($92) + ($88))|0; //@line 103620 "c/sqlite3.c"
     $$0188 = $93;
    }
    $94 = HEAP32[$85>>2]|0; //@line 103622 "c/sqlite3.c"
    HEAP32[$vararg_buffer3>>2] = $$; //@line 103621 "c/sqlite3.c"
    $vararg_ptr6 = ((($vararg_buffer3)) + 4|0); //@line 103621 "c/sqlite3.c"
    HEAP32[$vararg_ptr6>>2] = $$0188; //@line 103621 "c/sqlite3.c"
    $vararg_ptr7 = ((($vararg_buffer3)) + 8|0); //@line 103621 "c/sqlite3.c"
    HEAP32[$vararg_ptr7>>2] = $94; //@line 103621 "c/sqlite3.c"
    $95 = (_sqlite3MPrintf($6,29897,$vararg_buffer3)|0); //@line 103621 "c/sqlite3.c"
    $$0191 = $95;
   } else {
    $50 = ((($0)) + 44|0); //@line 103579 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 103579 "c/sqlite3.c"
    $52 = (($51) + 1)|0; //@line 103579 "c/sqlite3.c"
    $53 = (($51) + 2)|0; //@line 103580 "c/sqlite3.c"
    $54 = (($51) + 3)|0; //@line 103581 "c/sqlite3.c"
    HEAP32[$50>>2] = $54; //@line 103581 "c/sqlite3.c"
    _sqlite3MayAbort($0); //@line 103583 "c/sqlite3.c"
    $55 = ((($0)) + 100|0); //@line 103584 "c/sqlite3.c"
    $56 = HEAP32[$55>>2]|0; //@line 103584 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($44,106,1,$56,$34)|0); //@line 103584 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($44,16); //@line 103585 "c/sqlite3.c"
    $57 = ((($0)) + 40|0); //@line 103586 "c/sqlite3.c"
    HEAP32[$57>>2] = 2; //@line 103586 "c/sqlite3.c"
    $58 = (_sqlite3VdbeCurrentAddr($44)|0); //@line 103587 "c/sqlite3.c"
    $59 = (($58) + 1)|0; //@line 103587 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($44,15,$52,0,$59)|0); //@line 103588 "c/sqlite3.c"
    $60 = ((($0)) + 36|0); //@line 103589 "c/sqlite3.c"
    $61 = HEAP32[$60>>2]|0; //@line 103589 "c/sqlite3.c"
    $62 = ($61|0)==(0); //@line 103589 "c/sqlite3.c"
    if ($62) {
     $63 = (_sqlite3ResultSetOfSelect($0,$4)|0); //@line 103590 "c/sqlite3.c"
     $64 = ($63|0)==(0|0); //@line 103591 "c/sqlite3.c"
     if (!($64)) {
      $65 = ((($63)) + 42|0); //@line 103593 "c/sqlite3.c"
      $66 = HEAP16[$65>>1]|0; //@line 103593 "c/sqlite3.c"
      $67 = ((($10)) + 42|0); //@line 103593 "c/sqlite3.c"
      HEAP16[$67>>1] = $66; //@line 103593 "c/sqlite3.c"
      $68 = ((($63)) + 4|0); //@line 103594 "c/sqlite3.c"
      $69 = HEAP32[$68>>2]|0; //@line 103594 "c/sqlite3.c"
      $70 = ((($10)) + 4|0); //@line 103594 "c/sqlite3.c"
      HEAP32[$70>>2] = $69; //@line 103594 "c/sqlite3.c"
      HEAP16[$65>>1] = 0; //@line 103595 "c/sqlite3.c"
      HEAP32[$68>>2] = 0; //@line 103596 "c/sqlite3.c"
      _sqlite3DeleteTable($6,$63); //@line 103597 "c/sqlite3.c"
      _sqlite3SelectDestInit($5,13,$52); //@line 103598 "c/sqlite3.c"
      (_sqlite3Select($0,$4,$5)|0); //@line 103599 "c/sqlite3.c"
      $71 = HEAP32[$60>>2]|0; //@line 103600 "c/sqlite3.c"
      $72 = ($71|0)==(0); //@line 103600 "c/sqlite3.c"
      if ($72) {
       _sqlite3VdbeEndCoroutine($44,$52); //@line 103601 "c/sqlite3.c"
       _sqlite3VdbeJumpHere($44,$58); //@line 103602 "c/sqlite3.c"
       $73 = ((($5)) + 4|0); //@line 103603 "c/sqlite3.c"
       $74 = HEAP32[$73>>2]|0; //@line 103603 "c/sqlite3.c"
       $75 = (_sqlite3VdbeAddOp1($44,16,$74)|0); //@line 103603 "c/sqlite3.c"
       $76 = ((($5)) + 8|0); //@line 103605 "c/sqlite3.c"
       $77 = HEAP32[$76>>2]|0; //@line 103605 "c/sqlite3.c"
       $78 = ((($5)) + 12|0); //@line 103605 "c/sqlite3.c"
       $79 = HEAP32[$78>>2]|0; //@line 103605 "c/sqlite3.c"
       (_sqlite3VdbeAddOp3($44,100,$77,$79,$53)|0); //@line 103605 "c/sqlite3.c"
       _sqlite3TableAffinity($44,$10,0); //@line 103606 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($44,116,1,$54)|0); //@line 103607 "c/sqlite3.c"
       (_sqlite3VdbeAddOp3($44,117,1,$53,$54)|0); //@line 103608 "c/sqlite3.c"
       _sqlite3VdbeGoto($44,$75); //@line 103609 "c/sqlite3.c"
       _sqlite3VdbeJumpHere($44,$75); //@line 103610 "c/sqlite3.c"
       (_sqlite3VdbeAddOp1($44,113,1)|0); //@line 103611 "c/sqlite3.c"
       $80 = (_createTableStmt($6,$10)|0); //@line 103616 "c/sqlite3.c"
       $$0191 = $80;
       break;
      }
     }
    }
    STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
   }
  } while(0);
  $96 = ((($6)) + 16|0); //@line 103634 "c/sqlite3.c"
  $97 = HEAP32[$96>>2]|0; //@line 103634 "c/sqlite3.c"
  $98 = (($97) + ($34<<4)|0); //@line 103634 "c/sqlite3.c"
  $99 = HEAP32[$98>>2]|0; //@line 103634 "c/sqlite3.c"
  $100 = HEAP32[$10>>2]|0; //@line 103636 "c/sqlite3.c"
  $101 = ((($0)) + 100|0); //@line 103638 "c/sqlite3.c"
  $102 = HEAP32[$101>>2]|0; //@line 103638 "c/sqlite3.c"
  $103 = ((($0)) + 96|0); //@line 103640 "c/sqlite3.c"
  $104 = HEAP32[$103>>2]|0; //@line 103640 "c/sqlite3.c"
  HEAP32[$vararg_buffer8>>2] = $99; //@line 103630 "c/sqlite3.c"
  $vararg_ptr11 = ((($vararg_buffer8)) + 4|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr11>>2] = 19754; //@line 103630 "c/sqlite3.c"
  $vararg_ptr12 = ((($vararg_buffer8)) + 8|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr12>>2] = $$192; //@line 103630 "c/sqlite3.c"
  $vararg_ptr13 = ((($vararg_buffer8)) + 12|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr13>>2] = $100; //@line 103630 "c/sqlite3.c"
  $vararg_ptr14 = ((($vararg_buffer8)) + 16|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr14>>2] = $100; //@line 103630 "c/sqlite3.c"
  $vararg_ptr15 = ((($vararg_buffer8)) + 20|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr15>>2] = $102; //@line 103630 "c/sqlite3.c"
  $vararg_ptr16 = ((($vararg_buffer8)) + 24|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr16>>2] = $$0191; //@line 103630 "c/sqlite3.c"
  $vararg_ptr17 = ((($vararg_buffer8)) + 28|0); //@line 103630 "c/sqlite3.c"
  HEAP32[$vararg_ptr17>>2] = $104; //@line 103630 "c/sqlite3.c"
  _sqlite3NestedParse($0,29912,$vararg_buffer8); //@line 103630 "c/sqlite3.c"
  _sqlite3DbFree($6,$$0191); //@line 103642 "c/sqlite3.c"
  _sqlite3ChangeCookie($0,$34); //@line 103643 "c/sqlite3.c"
  $105 = ((($10)) + 36|0); //@line 103649 "c/sqlite3.c"
  $106 = HEAP32[$105>>2]|0; //@line 103649 "c/sqlite3.c"
  $107 = $106 & 8; //@line 103649 "c/sqlite3.c"
  $108 = ($107|0)==(0); //@line 103649 "c/sqlite3.c"
  if (!($108)) {
   $109 = HEAP32[$96>>2]|0; //@line 103650 "c/sqlite3.c"
   $110 = (((($109) + ($34<<4)|0)) + 12|0); //@line 103652 "c/sqlite3.c"
   $111 = HEAP32[$110>>2]|0; //@line 103652 "c/sqlite3.c"
   $112 = ((($111)) + 72|0); //@line 103652 "c/sqlite3.c"
   $113 = HEAP32[$112>>2]|0; //@line 103652 "c/sqlite3.c"
   $114 = ($113|0)==(0|0); //@line 103652 "c/sqlite3.c"
   if ($114) {
    $115 = (($109) + ($34<<4)|0); //@line 103655 "c/sqlite3.c"
    $116 = HEAP32[$115>>2]|0; //@line 103655 "c/sqlite3.c"
    HEAP32[$vararg_buffer18>>2] = $116; //@line 103653 "c/sqlite3.c"
    _sqlite3NestedParse($0,29999,$vararg_buffer18); //@line 103653 "c/sqlite3.c"
   }
  }
  $117 = HEAP32[$10>>2]|0; //@line 103663 "c/sqlite3.c"
  HEAP32[$vararg_buffer21>>2] = $117; //@line 103663 "c/sqlite3.c"
  $118 = (_sqlite3MPrintf($6,30041,$vararg_buffer21)|0); //@line 103663 "c/sqlite3.c"
  _sqlite3VdbeAddParseSchemaOp($44,$34,$118); //@line 103662 "c/sqlite3.c"
  $$pr = HEAP8[$12>>0]|0; //@line 103669 "c/sqlite3.c"
  $119 = ($$pr<<24>>24)==(0); //@line 103669 "c/sqlite3.c"
  if ($119) {
   STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
  }
 }
 $120 = HEAP32[$32>>2]|0; //@line 103671 "c/sqlite3.c"
 $121 = ((($120)) + 8|0); //@line 103673 "c/sqlite3.c"
 $122 = HEAP32[$10>>2]|0; //@line 103673 "c/sqlite3.c"
 $123 = (_sqlite3HashInsert($121,$122,$10)|0); //@line 103673 "c/sqlite3.c"
 $124 = ($123|0)==(0|0); //@line 103674 "c/sqlite3.c"
 if (!($124)) {
  _sqlite3OomFault($6); //@line 103676 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
 }
 HEAP32[$9>>2] = 0; //@line 103679 "c/sqlite3.c"
 $125 = ((($6)) + 24|0); //@line 103680 "c/sqlite3.c"
 $126 = HEAP32[$125>>2]|0; //@line 103680 "c/sqlite3.c"
 $127 = $126 | 1; //@line 103680 "c/sqlite3.c"
 HEAP32[$125>>2] = $127; //@line 103680 "c/sqlite3.c"
 $128 = ((($10)) + 12|0); //@line 103683 "c/sqlite3.c"
 $129 = HEAP32[$128>>2]|0; //@line 103683 "c/sqlite3.c"
 $130 = ($129|0)==(0|0); //@line 103683 "c/sqlite3.c"
 if (!($130)) {
  STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
 }
 $131 = ((($0)) + 380|0); //@line 103684 "c/sqlite3.c"
 $132 = HEAP32[$131>>2]|0; //@line 103684 "c/sqlite3.c"
 $133 = HEAP32[$1>>2]|0; //@line 103687 "c/sqlite3.c"
 $134 = ($133|0)==(0|0); //@line 103687 "c/sqlite3.c"
 $spec$select = $134 ? $2 : $1; //@line 103687 "c/sqlite3.c"
 $135 = HEAP32[$spec$select>>2]|0; //@line 103690 "c/sqlite3.c"
 $136 = $132; //@line 103690 "c/sqlite3.c"
 $137 = (($135) - ($136))|0; //@line 103690 "c/sqlite3.c"
 $138 = (_sqlite3Utf8CharLen_70($132,$137)|0); //@line 103691 "c/sqlite3.c"
 $139 = (($138) + 13)|0; //@line 103691 "c/sqlite3.c"
 $140 = ((($10)) + 52|0); //@line 103691 "c/sqlite3.c"
 HEAP32[$140>>2] = $139; //@line 103691 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 103695 "c/sqlite3.c"
}
function _sqlite3AddColumn($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$072 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 102676 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 102676 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 102682 "c/sqlite3.c"
 $4 = ((($0)) + 432|0); //@line 102683 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 102683 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 102683 "c/sqlite3.c"
 if ($6) {
  STACKTOP = sp;return; //@line 102729 "c/sqlite3.c"
 }
 $7 = ((($5)) + 42|0); //@line 102684 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 102684 "c/sqlite3.c"
 $9 = $8 << 16 >> 16; //@line 102684 "c/sqlite3.c"
 $10 = ((($3)) + 108|0); //@line 102684 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 102684 "c/sqlite3.c"
 $12 = ($11|0)>($9|0); //@line 102684 "c/sqlite3.c"
 if (!($12)) {
  $13 = HEAP32[$5>>2]|0; //@line 102685 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $13; //@line 102685 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,29755,$vararg_buffer); //@line 102685 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102729 "c/sqlite3.c"
 }
 $14 = ((($1)) + 4|0); //@line 102688 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 102688 "c/sqlite3.c"
 $16 = ((($2)) + 4|0); //@line 102688 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 102688 "c/sqlite3.c"
 $18 = (($15) + 2)|0; //@line 102688 "c/sqlite3.c"
 $19 = (($18) + ($17))|0; //@line 102688 "c/sqlite3.c"
 $20 = (_sqlite3DbMallocRaw($3,$19,0)|0); //@line 102688 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 102689 "c/sqlite3.c"
 if ($21) {
  STACKTOP = sp;return; //@line 102729 "c/sqlite3.c"
 }
 $22 = HEAP32[$1>>2]|0; //@line 102690 "c/sqlite3.c"
 $23 = HEAP32[$14>>2]|0; //@line 102690 "c/sqlite3.c"
 _memcpy(($20|0),($22|0),($23|0))|0; //@line 102690 "c/sqlite3.c"
 $24 = HEAP32[$14>>2]|0; //@line 102691 "c/sqlite3.c"
 $25 = (($20) + ($24)|0); //@line 102691 "c/sqlite3.c"
 HEAP8[$25>>0] = 0; //@line 102691 "c/sqlite3.c"
 _sqlite3Dequote($20); //@line 102692 "c/sqlite3.c"
 $26 = HEAP16[$7>>1]|0; //@line 102693 "c/sqlite3.c"
 $27 = $26 << 16 >> 16; //@line 102693 "c/sqlite3.c"
 $28 = ($26<<16>>16)>(0); //@line 102693 "c/sqlite3.c"
 do {
  if ($28) {
   $29 = ((($5)) + 4|0);
   $30 = HEAP32[$29>>2]|0;
   $$072 = 0;
   while(1) {
    $35 = (($30) + ($$072<<4)|0); //@line 102694 "c/sqlite3.c"
    $36 = HEAP32[$35>>2]|0; //@line 102694 "c/sqlite3.c"
    $37 = (_sqlite3_stricmp($20,$36)|0); //@line 102694 "c/sqlite3.c"
    $38 = ($37|0)==(0); //@line 102694 "c/sqlite3.c"
    $34 = (($$072) + 1)|0; //@line 102693 "c/sqlite3.c"
    if ($38) {
     break;
    }
    $31 = HEAP16[$7>>1]|0; //@line 102693 "c/sqlite3.c"
    $32 = $31 << 16 >> 16; //@line 102693 "c/sqlite3.c"
    $33 = ($34|0)<($32|0); //@line 102693 "c/sqlite3.c"
    if ($33) {
     $$072 = $34;
    } else {
     label = 10;
     break;
    }
   }
   if ((label|0) == 10) {
    $39 = $31 << 16 >> 16; //@line 102693 "c/sqlite3.c"
    $$lcssa = $39;
    break;
   }
   HEAP32[$vararg_buffer1>>2] = $20; //@line 102695 "c/sqlite3.c"
   _sqlite3ErrorMsg($0,29778,$vararg_buffer1); //@line 102695 "c/sqlite3.c"
   _sqlite3DbFree($3,$20); //@line 102696 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 102729 "c/sqlite3.c"
  } else {
   $$lcssa = $27;
  }
 } while(0);
 $40 = $$lcssa & 7; //@line 102700 "c/sqlite3.c"
 $41 = ($40|0)==(0); //@line 102700 "c/sqlite3.c"
 do {
  if ($41) {
   $42 = ((($5)) + 4|0); //@line 102702 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 102702 "c/sqlite3.c"
   $44 = $$lcssa << 4; //@line 102702 "c/sqlite3.c"
   $45 = (($44) + 128)|0; //@line 102702 "c/sqlite3.c"
   $46 = (_sqlite3DbRealloc($3,$43,$45,0)|0); //@line 102702 "c/sqlite3.c"
   $47 = ($46|0)==(0|0); //@line 102703 "c/sqlite3.c"
   if (!($47)) {
    HEAP32[$42>>2] = $46; //@line 102707 "c/sqlite3.c"
    break;
   }
   _sqlite3DbFree($3,$20); //@line 102704 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 102729 "c/sqlite3.c"
  }
 } while(0);
 $48 = ((($5)) + 4|0); //@line 102709 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 102709 "c/sqlite3.c"
 $50 = HEAP16[$7>>1]|0; //@line 102709 "c/sqlite3.c"
 $51 = $50 << 16 >> 16; //@line 102709 "c/sqlite3.c"
 $52 = (((($49) + ($51<<4)|0)) + 4|0);
 ;HEAP32[$52>>2]=0|0;HEAP32[$52+4>>2]=0|0;HEAP32[$52+8>>2]=0|0; //@line 102710 "c/sqlite3.c"
 $53 = (($49) + ($51<<4)|0); //@line 102711 "c/sqlite3.c"
 HEAP32[$53>>2] = $20; //@line 102711 "c/sqlite3.c"
 $54 = HEAP32[$16>>2]|0; //@line 102714 "c/sqlite3.c"
 $55 = ($54|0)==(0); //@line 102714 "c/sqlite3.c"
 if ($55) {
  $56 = (((($49) + ($51<<4)|0)) + 13|0); //@line 102717 "c/sqlite3.c"
  HEAP8[$56>>0] = 65; //@line 102717 "c/sqlite3.c"
  $57 = (((($49) + ($51<<4)|0)) + 14|0); //@line 102718 "c/sqlite3.c"
  HEAP8[$57>>0] = 1; //@line 102718 "c/sqlite3.c"
 } else {
  $58 = (_sqlite3Strlen30($20)|0); //@line 102720 "c/sqlite3.c"
  $59 = (($20) + ($58)|0); //@line 102720 "c/sqlite3.c"
  $60 = ((($59)) + 1|0); //@line 102720 "c/sqlite3.c"
  $61 = HEAP32[$2>>2]|0; //@line 102721 "c/sqlite3.c"
  _memcpy(($60|0),($61|0),($54|0))|0; //@line 102721 "c/sqlite3.c"
  $62 = HEAP32[$16>>2]|0; //@line 102722 "c/sqlite3.c"
  $63 = (($60) + ($62)|0); //@line 102722 "c/sqlite3.c"
  HEAP8[$63>>0] = 0; //@line 102722 "c/sqlite3.c"
  _sqlite3Dequote($60); //@line 102723 "c/sqlite3.c"
  $64 = (((($49) + ($51<<4)|0)) + 14|0); //@line 102724 "c/sqlite3.c"
  $65 = (_sqlite3AffinityType($60,$64)|0); //@line 102724 "c/sqlite3.c"
  $66 = (((($49) + ($51<<4)|0)) + 13|0); //@line 102724 "c/sqlite3.c"
  HEAP8[$66>>0] = $65; //@line 102724 "c/sqlite3.c"
  $67 = (((($49) + ($51<<4)|0)) + 15|0); //@line 102725 "c/sqlite3.c"
  $68 = HEAP8[$67>>0]|0; //@line 102725 "c/sqlite3.c"
  $69 = $68 | 4; //@line 102725 "c/sqlite3.c"
  HEAP8[$67>>0] = $69; //@line 102725 "c/sqlite3.c"
 }
 $70 = HEAP16[$7>>1]|0; //@line 102727 "c/sqlite3.c"
 $71 = (($70) + 1)<<16>>16; //@line 102727 "c/sqlite3.c"
 HEAP16[$7>>1] = $71; //@line 102727 "c/sqlite3.c"
 $72 = ((($0)) + 84|0); //@line 102728 "c/sqlite3.c"
 HEAP32[$72>>2] = 0; //@line 102728 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 102729 "c/sqlite3.c"
}
function _sqlite3AddDefaultValue($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer = sp;
 $4 = sp + 8|0;
 $5 = HEAP32[$0>>2]|0; //@line 102850 "c/sqlite3.c"
 $6 = ((($0)) + 432|0); //@line 102851 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 102851 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 102852 "c/sqlite3.c"
 if ($8) {
  _sqlite3ExprDelete($5,$1); //@line 102872 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102873 "c/sqlite3.c"
 }
 $9 = ((($7)) + 4|0); //@line 102853 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 102853 "c/sqlite3.c"
 $11 = ((($7)) + 42|0); //@line 102853 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 102853 "c/sqlite3.c"
 $13 = $12 << 16 >> 16; //@line 102853 "c/sqlite3.c"
 $14 = (($13) + -1)|0; //@line 102853 "c/sqlite3.c"
 $15 = ((($5)) + 157|0); //@line 102854 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 102854 "c/sqlite3.c"
 $17 = (_sqlite3ExprIsConstantOrFunction($1,$16)|0); //@line 102854 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 102854 "c/sqlite3.c"
 if ($18) {
  $19 = (($10) + ($14<<4)|0); //@line 102856 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 102856 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $20; //@line 102855 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,29710,$vararg_buffer); //@line 102855 "c/sqlite3.c"
  _sqlite3ExprDelete($5,$1); //@line 102872 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102873 "c/sqlite3.c"
 } else {
  $21 = (((($10) + ($14<<4)|0)) + 4|0); //@line 102862 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 102862 "c/sqlite3.c"
  _sqlite3ExprDelete($5,$22); //@line 102862 "c/sqlite3.c"
  dest=$4; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 102863 "c/sqlite3.c"
  HEAP8[$4>>0] = -101; //@line 102864 "c/sqlite3.c"
  $23 = (_sqlite3DbSpanDup($5,$2,$3)|0); //@line 102865 "c/sqlite3.c"
  $24 = ((($4)) + 8|0); //@line 102865 "c/sqlite3.c"
  HEAP32[$24>>2] = $23; //@line 102865 "c/sqlite3.c"
  $25 = ((($4)) + 12|0); //@line 102866 "c/sqlite3.c"
  HEAP32[$25>>2] = $1; //@line 102866 "c/sqlite3.c"
  $26 = ((($4)) + 4|0); //@line 102867 "c/sqlite3.c"
  HEAP32[$26>>2] = 4096; //@line 102867 "c/sqlite3.c"
  $27 = (_sqlite3ExprDup($5,$4,1)|0); //@line 102868 "c/sqlite3.c"
  HEAP32[$21>>2] = $27; //@line 102868 "c/sqlite3.c"
  $28 = HEAP32[$24>>2]|0; //@line 102869 "c/sqlite3.c"
  _sqlite3DbFree($5,$28); //@line 102869 "c/sqlite3.c"
  _sqlite3ExprDelete($5,$1); //@line 102872 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102873 "c/sqlite3.c"
 }
}
function _sqlite3PExpr($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(44); //@line 93542 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 36|0); //@line 93542 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 93542 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 93542 "c/sqlite3.c"
  if ($7) {
   $8 = HEAP32[$0>>2]|0; //@line 93544 "c/sqlite3.c"
   $9 = (_sqlite3ExprAnd($8,$2,$3)|0); //@line 93544 "c/sqlite3.c"
   $$0 = $9;
  } else {
   label = 4;
  }
 } else {
  label = 4;
 }
 if ((label|0) == 4) {
  $10 = HEAP32[$0>>2]|0; //@line 93546 "c/sqlite3.c"
  $11 = (_sqlite3DbMallocRawNN($10,48,0)|0); //@line 93546 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 93547 "c/sqlite3.c"
  if (!($12)) {
   dest=$11; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 93548 "c/sqlite3.c"
   $13 = $1&255; //@line 93549 "c/sqlite3.c"
   HEAP8[$11>>0] = $13; //@line 93549 "c/sqlite3.c"
   $14 = ((($11)) + 34|0); //@line 93550 "c/sqlite3.c"
   HEAP16[$14>>1] = -1; //@line 93550 "c/sqlite3.c"
  }
  $15 = HEAP32[$0>>2]|0; //@line 93552 "c/sqlite3.c"
  _sqlite3ExprAttachSubtrees($15,$11,$2,$3); //@line 93552 "c/sqlite3.c"
  $$0 = $11;
 }
 $16 = ($$0|0)==(0|0); //@line 93554 "c/sqlite3.c"
 if ($16) {
  return ($$0|0); //@line 93557 "c/sqlite3.c"
 }
 $17 = ((($$0)) + 24|0); //@line 93555 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 93555 "c/sqlite3.c"
 (_sqlite3ExprCheckHeight($0,$18)|0); //@line 93555 "c/sqlite3.c"
 return ($$0|0); //@line 93557 "c/sqlite3.c"
}
function _tokenExpr($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 138226 "c/sqlite3.c"
 $4 = ((($2)) + 4|0); //@line 138226 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 138226 "c/sqlite3.c"
 $6 = (($5) + 49)|0; //@line 138226 "c/sqlite3.c"
 $7 = (_sqlite3DbMallocRawNN($3,$6,0)|0); //@line 138226 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 138227 "c/sqlite3.c"
 if ($8) {
  return ($7|0); //@line 138243 "c/sqlite3.c"
 }
 dest=$7; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 138228 "c/sqlite3.c"
 $9 = $1&255; //@line 138229 "c/sqlite3.c"
 HEAP8[$7>>0] = $9; //@line 138229 "c/sqlite3.c"
 $10 = ((($7)) + 4|0); //@line 138230 "c/sqlite3.c"
 HEAP32[$10>>2] = 8388608; //@line 138230 "c/sqlite3.c"
 $11 = ((($7)) + 34|0); //@line 138231 "c/sqlite3.c"
 HEAP16[$11>>1] = -1; //@line 138231 "c/sqlite3.c"
 $12 = ((($7)) + 48|0); //@line 138232 "c/sqlite3.c"
 $13 = ((($7)) + 8|0); //@line 138232 "c/sqlite3.c"
 HEAP32[$13>>2] = $12; //@line 138232 "c/sqlite3.c"
 $14 = HEAP32[$2>>2]|0; //@line 138233 "c/sqlite3.c"
 _memcpy(($12|0),($14|0),($5|0))|0; //@line 138233 "c/sqlite3.c"
 $15 = (($12) + ($5)|0); //@line 138234 "c/sqlite3.c"
 HEAP8[$15>>0] = 0; //@line 138234 "c/sqlite3.c"
 $16 = HEAP32[$13>>2]|0; //@line 138235 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 138235 "c/sqlite3.c"
 $18 = $17&255; //@line 138235 "c/sqlite3.c"
 $19 = (16281 + ($18)|0); //@line 138235 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 138235 "c/sqlite3.c"
 $21 = ($20<<24>>24)<(0); //@line 138235 "c/sqlite3.c"
 if ($21) {
  $22 = ($17<<24>>24)==(34); //@line 138236 "c/sqlite3.c"
  if ($22) {
   $23 = HEAP32[$10>>2]|0; //@line 138236 "c/sqlite3.c"
   $24 = $23 | 64; //@line 138236 "c/sqlite3.c"
   HEAP32[$10>>2] = $24; //@line 138236 "c/sqlite3.c"
  }
  _sqlite3Dequote($16); //@line 138237 "c/sqlite3.c"
 }
 $25 = ((($7)) + 24|0); //@line 138240 "c/sqlite3.c"
 HEAP32[$25>>2] = 1; //@line 138240 "c/sqlite3.c"
 return ($7|0); //@line 138243 "c/sqlite3.c"
}
function _sqlite3AddNotNull($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 432|0); //@line 102739 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 102739 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 102740 "c/sqlite3.c"
 if ($4) {
  return; //@line 102743 "c/sqlite3.c"
 }
 $5 = ((($3)) + 42|0); //@line 102740 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 102740 "c/sqlite3.c"
 $7 = ($6<<16>>16)<(1); //@line 102740 "c/sqlite3.c"
 if ($7) {
  return; //@line 102743 "c/sqlite3.c"
 }
 $8 = $6 << 16 >> 16; //@line 102740 "c/sqlite3.c"
 $9 = $1&255; //@line 102741 "c/sqlite3.c"
 $10 = ((($3)) + 4|0); //@line 102741 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 102741 "c/sqlite3.c"
 $12 = (($8) + -1)|0; //@line 102741 "c/sqlite3.c"
 $13 = (((($11) + ($12<<4)|0)) + 12|0); //@line 102741 "c/sqlite3.c"
 HEAP8[$13>>0] = $9; //@line 102741 "c/sqlite3.c"
 $14 = ((($3)) + 36|0); //@line 102742 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 102742 "c/sqlite3.c"
 $16 = $15 | 512; //@line 102742 "c/sqlite3.c"
 HEAP32[$14>>2] = $16; //@line 102742 "c/sqlite3.c"
 return; //@line 102743 "c/sqlite3.c"
}
function _sqlite3AddPrimaryKey($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$06476 = 0, $$065 = 0, $$06675 = 0, $$06774 = 0, $$16873 = 0, $$2 = 0, $$269 = 0, $$3 = 0, $$370 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, $or$cond3 = 0, $phitmp = 0, $vararg_buffer = 0, $vararg_buffer1 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 102918 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 102918 "c/sqlite3.c"
 $5 = ((($0)) + 432|0); //@line 102924 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 102924 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 102928 "c/sqlite3.c"
 if ($7) {
  $$0 = $1;
  $68 = HEAP32[$0>>2]|0; //@line 102980 "c/sqlite3.c"
  _sqlite3ExprListDelete($68,$$0); //@line 102980 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102982 "c/sqlite3.c"
 }
 $8 = ((($6)) + 36|0); //@line 102929 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 102929 "c/sqlite3.c"
 $10 = $9 & 4; //@line 102929 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 102929 "c/sqlite3.c"
 if (!($11)) {
  $12 = HEAP32[$6>>2]|0; //@line 102931 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $12; //@line 102930 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,29613,$vararg_buffer); //@line 102930 "c/sqlite3.c"
  $$0 = $1;
  $68 = HEAP32[$0>>2]|0; //@line 102980 "c/sqlite3.c"
  _sqlite3ExprListDelete($68,$$0); //@line 102980 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102982 "c/sqlite3.c"
 }
 $13 = $9 | 4; //@line 102934 "c/sqlite3.c"
 HEAP32[$8>>2] = $13; //@line 102934 "c/sqlite3.c"
 $14 = ($1|0)==(0|0); //@line 102935 "c/sqlite3.c"
 if ($14) {
  $15 = ((($6)) + 42|0); //@line 102936 "c/sqlite3.c"
  $16 = HEAP16[$15>>1]|0; //@line 102936 "c/sqlite3.c"
  $17 = $16 << 16 >> 16; //@line 102936 "c/sqlite3.c"
  $18 = (($17) + -1)|0; //@line 102936 "c/sqlite3.c"
  $19 = ((($6)) + 4|0); //@line 102937 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 102937 "c/sqlite3.c"
  $21 = (($20) + ($18<<4)|0); //@line 102937 "c/sqlite3.c"
  $22 = (((($20) + ($18<<4)|0)) + 15|0); //@line 102938 "c/sqlite3.c"
  $23 = HEAP8[$22>>0]|0; //@line 102938 "c/sqlite3.c"
  $24 = $23 | 1; //@line 102938 "c/sqlite3.c"
  HEAP8[$22>>0] = $24; //@line 102938 "c/sqlite3.c"
  $$065 = 1;$$3 = $21;$$370 = $18;
  label = 16;
 } else {
  $25 = HEAP32[$1>>2]|0; //@line 102941 "c/sqlite3.c"
  $26 = ($25|0)>(0); //@line 102942 "c/sqlite3.c"
  if ($26) {
   $27 = ((($6)) + 42|0);
   $28 = ((($6)) + 4|0);
   $$06476 = 0;$$06675 = 0;$$06774 = -1;
   while(1) {
    $29 = (((($1)) + 4|0) + (($$06675*20)|0)|0); //@line 102943 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 102943 "c/sqlite3.c"
    $31 = (_sqlite3ExprSkipCollate($30)|0); //@line 102943 "c/sqlite3.c"
    _sqlite3StringToId($31); //@line 102945 "c/sqlite3.c"
    $32 = HEAP8[$31>>0]|0; //@line 102946 "c/sqlite3.c"
    $33 = ($32<<24>>24)==(59); //@line 102946 "c/sqlite3.c"
    L14: do {
     if ($33) {
      $34 = ((($31)) + 8|0); //@line 102947 "c/sqlite3.c"
      $35 = HEAP32[$34>>2]|0; //@line 102947 "c/sqlite3.c"
      $36 = HEAP16[$27>>1]|0; //@line 102948 "c/sqlite3.c"
      $37 = ($36<<16>>16)>(0); //@line 102948 "c/sqlite3.c"
      if ($37) {
       $38 = HEAP32[$28>>2]|0;
       $$16873 = 0;
       while(1) {
        $39 = (($38) + ($$16873<<4)|0); //@line 102949 "c/sqlite3.c"
        $40 = HEAP32[$39>>2]|0; //@line 102949 "c/sqlite3.c"
        $41 = (_sqlite3StrICmp($35,$40)|0); //@line 102949 "c/sqlite3.c"
        $42 = ($41|0)==(0); //@line 102949 "c/sqlite3.c"
        if ($42) {
         break;
        }
        $47 = (($$16873) + 1)|0; //@line 102948 "c/sqlite3.c"
        $48 = HEAP16[$27>>1]|0; //@line 102948 "c/sqlite3.c"
        $49 = $48 << 16 >> 16; //@line 102948 "c/sqlite3.c"
        $50 = ($47|0)<($49|0); //@line 102948 "c/sqlite3.c"
        if ($50) {
         $$16873 = $47;
        } else {
         $$2 = $$06476;$$269 = $47;
         break L14;
        }
       }
       $43 = (($38) + ($$16873<<4)|0); //@line 102950 "c/sqlite3.c"
       $44 = (((($38) + ($$16873<<4)|0)) + 15|0); //@line 102951 "c/sqlite3.c"
       $45 = HEAP8[$44>>0]|0; //@line 102951 "c/sqlite3.c"
       $46 = $45 | 1; //@line 102951 "c/sqlite3.c"
       HEAP8[$44>>0] = $46; //@line 102951 "c/sqlite3.c"
       $$2 = $43;$$269 = $$16873;
      } else {
       $$2 = $$06476;$$269 = 0;
      }
     } else {
      $$2 = $$06476;$$269 = $$06774;
     }
    } while(0);
    $51 = (($$06675) + 1)|0; //@line 102942 "c/sqlite3.c"
    $exitcond = ($51|0)==($25|0); //@line 102942 "c/sqlite3.c"
    if ($exitcond) {
     break;
    } else {
     $$06476 = $$2;$$06675 = $51;$$06774 = $$269;
    }
   }
   $phitmp = ($25|0)==(1); //@line 102958 "c/sqlite3.c"
   $$065 = $phitmp;$$3 = $$2;$$370 = $$269;
   label = 16;
  }
 }
 if ((label|0) == 16) {
  $52 = ($$3|0)!=(0|0); //@line 102959 "c/sqlite3.c"
  $or$cond = $$065 & $52; //@line 102959 "c/sqlite3.c"
  if ($or$cond) {
   $53 = (_sqlite3ColumnType($$3,41388)|0); //@line 102960 "c/sqlite3.c"
   $54 = (_sqlite3StrICmp($53,22885)|0); //@line 102960 "c/sqlite3.c"
   $55 = ($54|0)==(0); //@line 102960 "c/sqlite3.c"
   $56 = ($4|0)!=(1); //@line 102961 "c/sqlite3.c"
   $or$cond3 = $56 & $55; //@line 102961 "c/sqlite3.c"
   if ($or$cond3) {
    $57 = $$370&65535; //@line 102963 "c/sqlite3.c"
    $58 = ((($6)) + 40|0); //@line 102963 "c/sqlite3.c"
    HEAP16[$58>>1] = $57; //@line 102963 "c/sqlite3.c"
    $59 = $2&255; //@line 102964 "c/sqlite3.c"
    $60 = ((($6)) + 48|0); //@line 102964 "c/sqlite3.c"
    HEAP8[$60>>0] = $59; //@line 102964 "c/sqlite3.c"
    $61 = $3 << 3; //@line 102966 "c/sqlite3.c"
    $62 = HEAP32[$8>>2]|0; //@line 102966 "c/sqlite3.c"
    $63 = $62 | $61; //@line 102966 "c/sqlite3.c"
    HEAP32[$8>>2] = $63; //@line 102966 "c/sqlite3.c"
    if ($14) {
     $$0 = 0;
     $68 = HEAP32[$0>>2]|0; //@line 102980 "c/sqlite3.c"
     _sqlite3ExprListDelete($68,$$0); //@line 102980 "c/sqlite3.c"
     STACKTOP = sp;return; //@line 102982 "c/sqlite3.c"
    }
    $64 = ((($1)) + 16|0); //@line 102967 "c/sqlite3.c"
    $65 = HEAP8[$64>>0]|0; //@line 102967 "c/sqlite3.c"
    $66 = ((($0)) + 398|0); //@line 102967 "c/sqlite3.c"
    HEAP8[$66>>0] = $65; //@line 102967 "c/sqlite3.c"
    $$0 = $1;
    $68 = HEAP32[$0>>2]|0; //@line 102980 "c/sqlite3.c"
    _sqlite3ExprListDelete($68,$$0); //@line 102980 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 102982 "c/sqlite3.c"
   }
  }
 }
 $67 = ($3|0)==(0); //@line 102968 "c/sqlite3.c"
 if ($67) {
  _sqlite3CreateIndex($0,0,0,0,$1,$2,0,0,$4,0,2); //@line 102974 "c/sqlite3.c"
  $$0 = 0;
  $68 = HEAP32[$0>>2]|0; //@line 102980 "c/sqlite3.c"
  _sqlite3ExprListDelete($68,$$0); //@line 102980 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102982 "c/sqlite3.c"
 } else {
  _sqlite3ErrorMsg($0,29654,$vararg_buffer1); //@line 102970 "c/sqlite3.c"
  $$0 = $1;
  $68 = HEAP32[$0>>2]|0; //@line 102980 "c/sqlite3.c"
  _sqlite3ExprListDelete($68,$$0); //@line 102980 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 102982 "c/sqlite3.c"
 }
}
function _sqlite3CreateIndex($0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$10) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 $9 = $9|0;
 $10 = $10|0;
 var $$0431 = 0, $$0432 = 0, $$0435 = 0, $$0437 = 0, $$0439$lcssa = 0, $$0439510 = 0, $$0440 = 0, $$0440520 = 0, $$0440521 = 0, $$0441535 = 0, $$0443 = 0, $$0448 = 0, $$0450 = 0, $$0452529 = 0, $$0456$lcssa = 0, $$0456534 = 0, $$0461 = 0, $$0467 = 0, $$0467542 = 0, $$0467544 = 0;
 var $$0468$lcssa = 0, $$0468543 = 0, $$1434 = 0, $$1434488 = 0, $$1434494 = 0, $$1438487 = 0, $$1442$lcssa = 0, $$1442530 = 0, $$1444 = 0, $$1451 = 0, $$1457 = 0, $$1489 = 0, $$2445525 = 0, $$2454 = 0, $$2526 = 0, $$3 = 0, $$3446523 = 0, $$3455 = 0, $$5 = 0, $$cast = 0;
 var $$cast497 = 0, $$lcssa = 0, $$lcssa499 = 0, $$lcssa504 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0;
 var $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0;
 var $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0;
 var $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0;
 var $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0;
 var $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0;
 var $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0;
 var $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0;
 var $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0;
 var $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0;
 var $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0;
 var $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0;
 var $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0;
 var $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0;
 var $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0;
 var $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond12 = 0, $or$cond469 = 0, $or$cond477 = 0, $or$cond9 = 0, $spec$select = 0, $spec$select473 = 0;
 var $spec$select474 = 0, $spec$select479 = 0, $spec$store$select = 0, $switch6 = 0, $trunc = 0, $trunc$clear = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer14 = 0, $vararg_buffer18 = 0, $vararg_buffer20 = 0, $vararg_buffer23 = 0, $vararg_buffer28 = 0, $vararg_buffer36 = 0, $vararg_buffer4 = 0, $vararg_buffer6 = 0, $vararg_buffer8 = 0, $vararg_ptr17 = 0, $vararg_ptr26 = 0;
 var $vararg_ptr27 = 0, $vararg_ptr31 = 0, $vararg_ptr32 = 0, $vararg_ptr33 = 0, $vararg_ptr34 = 0, $vararg_ptr35 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 160|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(160|0);
 $vararg_buffer36 = sp + 112|0;
 $vararg_buffer28 = sp + 88|0;
 $vararg_buffer23 = sp + 72|0;
 $vararg_buffer20 = sp + 64|0;
 $vararg_buffer18 = sp + 56|0;
 $vararg_buffer14 = sp + 48|0;
 $vararg_buffer11 = sp + 40|0;
 $vararg_buffer8 = sp + 32|0;
 $vararg_buffer6 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $11 = sp + 136|0;
 $12 = sp + 132|0;
 $13 = sp + 128|0;
 $14 = sp + 120|0;
 $15 = HEAP32[$0>>2]|0; //@line 104536 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 104539 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 104543 "c/sqlite3.c"
 $16 = ((($15)) + 73|0); //@line 104546 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 104546 "c/sqlite3.c"
 $18 = ($17<<24>>24)==(0); //@line 104546 "c/sqlite3.c"
 L1: do {
  if ($18) {
   $19 = ((($0)) + 36|0); //@line 104546 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 104546 "c/sqlite3.c"
   $21 = ($20|0)>(0); //@line 104546 "c/sqlite3.c"
   if ($21) {
    $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
   } else {
    $22 = ((($0)) + 400|0); //@line 104549 "c/sqlite3.c"
    $23 = HEAP8[$22>>0]|0; //@line 104549 "c/sqlite3.c"
    $24 = ($23<<24>>24)==(0); //@line 104549 "c/sqlite3.c"
    $25 = ($10<<24>>24)==(2); //@line 104549 "c/sqlite3.c"
    $or$cond469 = $25 | $24; //@line 104549 "c/sqlite3.c"
    if ($or$cond469) {
     $26 = (_sqlite3ReadSchema($0)|0); //@line 104552 "c/sqlite3.c"
     $27 = ($26|0)==(0); //@line 104552 "c/sqlite3.c"
     if ($27) {
      $28 = ($3|0)!=(0|0); //@line 104559 "c/sqlite3.c"
      if ($28) {
       $29 = (_sqlite3TwoPartName($0,$1,$2,$12)|0); //@line 104566 "c/sqlite3.c"
       $30 = ($29|0)<(0); //@line 104567 "c/sqlite3.c"
       if ($30) {
        $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
        break;
       }
       $31 = ((($15)) + 157|0); //@line 104575 "c/sqlite3.c"
       $32 = HEAP8[$31>>0]|0; //@line 104575 "c/sqlite3.c"
       $33 = ($32<<24>>24)==(0); //@line 104575 "c/sqlite3.c"
       if ($33) {
        $34 = (_sqlite3SrcListLookup($0,$3)|0); //@line 104576 "c/sqlite3.c"
        $35 = ((($2)) + 4|0); //@line 104577 "c/sqlite3.c"
        $36 = HEAP32[$35>>2]|0; //@line 104577 "c/sqlite3.c"
        $37 = ($36|0)==(0); //@line 104577 "c/sqlite3.c"
        $38 = ($34|0)!=(0|0); //@line 104577 "c/sqlite3.c"
        $or$cond = $38 & $37; //@line 104577 "c/sqlite3.c"
        if ($or$cond) {
         $39 = ((($34)) + 72|0); //@line 104577 "c/sqlite3.c"
         $40 = HEAP32[$39>>2]|0; //@line 104577 "c/sqlite3.c"
         $41 = ((($15)) + 16|0); //@line 104577 "c/sqlite3.c"
         $42 = HEAP32[$41>>2]|0; //@line 104577 "c/sqlite3.c"
         $43 = ((($42)) + 28|0); //@line 104577 "c/sqlite3.c"
         $44 = HEAP32[$43>>2]|0; //@line 104577 "c/sqlite3.c"
         $45 = ($40|0)==($44|0); //@line 104577 "c/sqlite3.c"
         $spec$select = $45 ? 1 : $29; //@line 104577 "c/sqlite3.c"
         $$0450 = $spec$select;
        } else {
         $$0450 = $29;
        }
       } else {
        $$0450 = $29;
       }
       $46 = HEAP32[$12>>2]|0; //@line 104583 "c/sqlite3.c"
       _sqlite3FixInit($11,$0,$$0450,29173,$46); //@line 104583 "c/sqlite3.c"
       (_sqlite3FixSrcList($11,$3)|0); //@line 104584 "c/sqlite3.c"
       $47 = ((($3)) + 8|0); //@line 104589 "c/sqlite3.c"
       $48 = (_sqlite3LocateTableItem($0,0,$47)|0); //@line 104589 "c/sqlite3.c"
       $49 = ($48|0)==(0|0); //@line 104591 "c/sqlite3.c"
       if ($49) {
        $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
        break;
       }
       $50 = ($$0450|0)==(1); //@line 104592 "c/sqlite3.c"
       if ($50) {
        $51 = ((($15)) + 16|0); //@line 104592 "c/sqlite3.c"
        $52 = HEAP32[$51>>2]|0; //@line 104592 "c/sqlite3.c"
        $53 = (((($52) + ($$0450<<4)|0)) + 12|0); //@line 104592 "c/sqlite3.c"
        $54 = HEAP32[$53>>2]|0; //@line 104592 "c/sqlite3.c"
        $55 = ((($48)) + 72|0); //@line 104592 "c/sqlite3.c"
        $56 = HEAP32[$55>>2]|0; //@line 104592 "c/sqlite3.c"
        $57 = ($54|0)==($56|0); //@line 104592 "c/sqlite3.c"
        if (!($57)) {
         $58 = HEAP32[$48>>2]|0; //@line 104595 "c/sqlite3.c"
         HEAP32[$vararg_buffer>>2] = $58; //@line 104593 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,29179,$vararg_buffer); //@line 104593 "c/sqlite3.c"
         $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
         break;
        }
       }
       $59 = ((($48)) + 36|0); //@line 104598 "c/sqlite3.c"
       $60 = HEAP32[$59>>2]|0; //@line 104598 "c/sqlite3.c"
       $61 = $60 & 32; //@line 104598 "c/sqlite3.c"
       $62 = ($61|0)==(0); //@line 104598 "c/sqlite3.c"
       if ($62) {
        $$0435 = $48;$$0461 = 0;$$1451 = $$0450;
       } else {
        $63 = (_sqlite3PrimaryKeyIndex($48)|0); //@line 104598 "c/sqlite3.c"
        $$0435 = $48;$$0461 = $63;$$1451 = $$0450;
       }
      } else {
       $64 = ((($0)) + 432|0); //@line 104602 "c/sqlite3.c"
       $65 = HEAP32[$64>>2]|0; //@line 104602 "c/sqlite3.c"
       $66 = ($65|0)==(0|0); //@line 104603 "c/sqlite3.c"
       if ($66) {
        $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
        break;
       }
       $67 = ((($65)) + 72|0); //@line 104604 "c/sqlite3.c"
       $68 = HEAP32[$67>>2]|0; //@line 104604 "c/sqlite3.c"
       $69 = (_sqlite3SchemaToIndex($15,$68)|0); //@line 104604 "c/sqlite3.c"
       $$0435 = $65;$$0461 = 0;$$1451 = $69;
      }
      $70 = ((($15)) + 16|0); //@line 104606 "c/sqlite3.c"
      $71 = HEAP32[$70>>2]|0; //@line 104606 "c/sqlite3.c"
      $72 = (($71) + ($$1451<<4)|0); //@line 104606 "c/sqlite3.c"
      $73 = HEAP32[$$0435>>2]|0; //@line 104610 "c/sqlite3.c"
      $74 = (_sqlite3_strnicmp($73,19990,7)|0); //@line 104610 "c/sqlite3.c"
      $75 = ($74|0)==(0); //@line 104610 "c/sqlite3.c"
      if ($75) {
       $76 = ((($15)) + 157|0); //@line 104611 "c/sqlite3.c"
       $77 = HEAP8[$76>>0]|0; //@line 104611 "c/sqlite3.c"
       $78 = ($77<<24>>24)==(0); //@line 104611 "c/sqlite3.c"
       if ($78) {
        $79 = ((($73)) + 7|0); //@line 104615 "c/sqlite3.c"
        $80 = (_sqlite3_strnicmp($79,29229,9)|0); //@line 104615 "c/sqlite3.c"
        $81 = ($80|0)==(0); //@line 104615 "c/sqlite3.c"
        if (!($81)) {
         HEAP32[$vararg_buffer1>>2] = $73; //@line 104616 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,29239,$vararg_buffer1); //@line 104616 "c/sqlite3.c"
         $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
         break;
        }
       }
      }
      $82 = ((($$0435)) + 12|0); //@line 104620 "c/sqlite3.c"
      $83 = HEAP32[$82>>2]|0; //@line 104620 "c/sqlite3.c"
      $84 = ($83|0)==(0|0); //@line 104620 "c/sqlite3.c"
      if (!($84)) {
       _sqlite3ErrorMsg($0,29267,$vararg_buffer4); //@line 104621 "c/sqlite3.c"
       $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
       break;
      }
      $85 = ((($$0435)) + 56|0); //@line 104626 "c/sqlite3.c"
      $86 = HEAP32[$85>>2]|0; //@line 104626 "c/sqlite3.c"
      $87 = ($86|0)==(0); //@line 104626 "c/sqlite3.c"
      if (!($87)) {
       _sqlite3ErrorMsg($0,29292,$vararg_buffer6); //@line 104627 "c/sqlite3.c"
       $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
       break;
      }
      $88 = HEAP32[$12>>2]|0; //@line 104645 "c/sqlite3.c"
      $89 = ($88|0)==(0|0); //@line 104645 "c/sqlite3.c"
      if ($89) {
       $103 = ((($$0435)) + 8|0); //@line 104670 "c/sqlite3.c"
       $$0467542 = HEAP32[$103>>2]|0;
       $104 = ($$0467542|0)==(0|0); //@line 104670 "c/sqlite3.c"
       if ($104) {
        $$0468$lcssa = 1;
       } else {
        $$0467544 = $$0467542;$$0468543 = 1;
        while(1) {
         $105 = ((($$0467544)) + 20|0); //@line 104670 "c/sqlite3.c"
         $106 = (($$0468543) + 1)|0; //@line 104670 "c/sqlite3.c"
         $$0467 = HEAP32[$105>>2]|0;
         $107 = ($$0467|0)==(0|0); //@line 104670 "c/sqlite3.c"
         if ($107) {
          $$0468$lcssa = $106;
          break;
         } else {
          $$0467544 = $$0467;$$0468543 = $106;
         }
        }
       }
       HEAP32[$vararg_buffer14>>2] = $73; //@line 104671 "c/sqlite3.c"
       $vararg_ptr17 = ((($vararg_buffer14)) + 4|0); //@line 104671 "c/sqlite3.c"
       HEAP32[$vararg_ptr17>>2] = $$0468$lcssa; //@line 104671 "c/sqlite3.c"
       $108 = (_sqlite3MPrintf($15,29384,$vararg_buffer14)|0); //@line 104671 "c/sqlite3.c"
       $109 = ($108|0)==(0|0); //@line 104672 "c/sqlite3.c"
       if ($109) {
        $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
        break;
       }
       $110 = HEAP8[$22>>0]|0; //@line 104681 "c/sqlite3.c"
       $111 = ($110<<24>>24)==(0); //@line 104681 "c/sqlite3.c"
       if ($111) {
        $$0437 = $108;
       } else {
        $112 = ((($108)) + 7|0); //@line 104681 "c/sqlite3.c"
        $113 = HEAP8[$112>>0]|0; //@line 104681 "c/sqlite3.c"
        $114 = (($113) + 1)<<24>>24; //@line 104681 "c/sqlite3.c"
        HEAP8[$112>>0] = $114; //@line 104681 "c/sqlite3.c"
        $$0437 = $108;
       }
      } else {
       $90 = (_sqlite3NameFromToken($15,$88)|0); //@line 104646 "c/sqlite3.c"
       $91 = ($90|0)==(0|0); //@line 104647 "c/sqlite3.c"
       if ($91) {
        $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
        break;
       }
       $92 = (_sqlite3CheckObjectName($0,$90)|0); //@line 104649 "c/sqlite3.c"
       $93 = ($92|0)==(0); //@line 104649 "c/sqlite3.c"
       if (!($93)) {
        $$1434488 = $7;$$1438487 = $90;$$1489 = $4;
        break;
       }
       $94 = ((($15)) + 157|0); //@line 104652 "c/sqlite3.c"
       $95 = HEAP8[$94>>0]|0; //@line 104652 "c/sqlite3.c"
       $96 = ($95<<24>>24)==(0); //@line 104652 "c/sqlite3.c"
       if ($96) {
        $97 = (_sqlite3FindTable($15,$90,0)|0); //@line 104653 "c/sqlite3.c"
        $98 = ($97|0)==(0|0); //@line 104653 "c/sqlite3.c"
        if (!($98)) {
         HEAP32[$vararg_buffer8>>2] = $90; //@line 104654 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,29326,$vararg_buffer8); //@line 104654 "c/sqlite3.c"
         $$1434488 = $7;$$1438487 = $90;$$1489 = $4;
         break;
        }
       }
       $99 = HEAP32[$72>>2]|0; //@line 104658 "c/sqlite3.c"
       $100 = (_sqlite3FindIndex($15,$90,$99)|0); //@line 104658 "c/sqlite3.c"
       $101 = ($100|0)==(0|0); //@line 104658 "c/sqlite3.c"
       if ($101) {
        $$0437 = $90;
       } else {
        $102 = ($9|0)==(0); //@line 104659 "c/sqlite3.c"
        if ($102) {
         HEAP32[$vararg_buffer11>>2] = $90; //@line 104660 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,29360,$vararg_buffer11); //@line 104660 "c/sqlite3.c"
         $$1434488 = $7;$$1438487 = $90;$$1489 = $4;
         break;
        } else {
         _sqlite3CodeVerifySchema($0,$$1451); //@line 104663 "c/sqlite3.c"
         $$1434488 = $7;$$1438487 = $90;$$1489 = $4;
         break;
        }
       }
      }
      $115 = HEAP32[$72>>2]|0; //@line 104688 "c/sqlite3.c"
      $116 = ($$1451|0)==(1); //@line 104689 "c/sqlite3.c"
      $117 = $116 ? 21366 : 19754; //@line 104689 "c/sqlite3.c"
      $118 = (_sqlite3AuthCheck($0,18,$117,0,$115)|0); //@line 104689 "c/sqlite3.c"
      $119 = ($118|0)==(0); //@line 104689 "c/sqlite3.c"
      if ($119) {
       $spec$store$select = $116 ? 3 : 1; //@line 104693 "c/sqlite3.c"
       $120 = HEAP32[$$0435>>2]|0; //@line 104694 "c/sqlite3.c"
       $121 = (_sqlite3AuthCheck($0,$spec$store$select,$$0437,$120,$115)|0); //@line 104694 "c/sqlite3.c"
       $122 = ($121|0)==(0); //@line 104694 "c/sqlite3.c"
       if ($122) {
        $123 = ($4|0)==(0|0); //@line 104704 "c/sqlite3.c"
        do {
         if ($123) {
          $124 = ((($$0435)) + 4|0); //@line 104706 "c/sqlite3.c"
          $125 = HEAP32[$124>>2]|0; //@line 104706 "c/sqlite3.c"
          $126 = ((($$0435)) + 42|0); //@line 104706 "c/sqlite3.c"
          $127 = HEAP16[$126>>1]|0; //@line 104706 "c/sqlite3.c"
          $128 = $127 << 16 >> 16; //@line 104706 "c/sqlite3.c"
          $129 = (($128) + -1)|0; //@line 104706 "c/sqlite3.c"
          $130 = (($125) + ($129<<4)|0); //@line 104706 "c/sqlite3.c"
          $131 = HEAP32[$130>>2]|0; //@line 104706 "c/sqlite3.c"
          _sqlite3TokenInit($14,$131); //@line 104706 "c/sqlite3.c"
          $132 = (_sqlite3ExprAlloc($15,59,$14,0)|0); //@line 104708 "c/sqlite3.c"
          $133 = (_sqlite3ExprListAppend($0,0,$132)|0); //@line 104707 "c/sqlite3.c"
          $134 = ($133|0)==(0|0); //@line 104709 "c/sqlite3.c"
          if ($134) {
           $$1434488 = $7;$$1438487 = $$0437;$$1489 = 0;
           break L1;
          } else {
           _sqlite3ExprListSetSortOrder($133,$8); //@line 104711 "c/sqlite3.c"
           $$0431 = $133;
           break;
          }
         } else {
          _sqlite3ExprListCheckLength($0,$4,29173); //@line 104713 "c/sqlite3.c"
          $$0431 = $4;
         }
        } while(0);
        $135 = HEAP32[$$0431>>2]|0; //@line 104719 "c/sqlite3.c"
        $136 = ($135|0)>(0); //@line 104719 "c/sqlite3.c"
        if ($136) {
         $137 = HEAP32[$$0431>>2]|0;
         $$0441535 = 0;$$0456534 = 0;
         while(1) {
          $138 = (((($$0431)) + 4|0) + (($$0441535*20)|0)|0); //@line 104720 "c/sqlite3.c"
          $139 = HEAP32[$138>>2]|0; //@line 104720 "c/sqlite3.c"
          $140 = HEAP8[$139>>0]|0; //@line 104722 "c/sqlite3.c"
          $141 = ($140<<24>>24)==(94); //@line 104722 "c/sqlite3.c"
          if ($141) {
           $142 = ((($139)) + 8|0); //@line 104723 "c/sqlite3.c"
           $143 = HEAP32[$142>>2]|0; //@line 104723 "c/sqlite3.c"
           $144 = (_sqlite3Strlen30($143)|0); //@line 104723 "c/sqlite3.c"
           $145 = (($$0456534) + 1)|0; //@line 104723 "c/sqlite3.c"
           $146 = (($145) + ($144))|0; //@line 104723 "c/sqlite3.c"
           $$1457 = $146;
          } else {
           $$1457 = $$0456534;
          }
          $147 = (($$0441535) + 1)|0; //@line 104719 "c/sqlite3.c"
          $148 = ($147|0)<($137|0); //@line 104719 "c/sqlite3.c"
          if ($148) {
           $$0441535 = $147;$$0456534 = $$1457;
          } else {
           $$0456$lcssa = $$1457;$$lcssa504 = $137;
           break;
          }
         }
        } else {
         $$0456$lcssa = 0;$$lcssa504 = $135;
        }
        $149 = (_sqlite3Strlen30($$0437)|0); //@line 104730 "c/sqlite3.c"
        $150 = ($$0461|0)!=(0|0); //@line 104731 "c/sqlite3.c"
        if ($150) {
         $151 = ((($$0461)) + 50|0); //@line 104731 "c/sqlite3.c"
         $152 = HEAP16[$151>>1]|0; //@line 104731 "c/sqlite3.c"
         $153 = $152&65535; //@line 104731 "c/sqlite3.c"
         $155 = $153;
        } else {
         $155 = 1;
        }
        $154 = (($155) + ($$lcssa504))|0; //@line 104732 "c/sqlite3.c"
        $156 = $154&65535; //@line 104732 "c/sqlite3.c"
        $157 = (($$0456$lcssa) + 1)|0; //@line 104733 "c/sqlite3.c"
        $158 = (($157) + ($149))|0; //@line 104733 "c/sqlite3.c"
        $159 = (_sqlite3AllocateIndexObject($15,$156,$158,$13)|0); //@line 104732 "c/sqlite3.c"
        $160 = HEAP8[$16>>0]|0; //@line 104734 "c/sqlite3.c"
        $161 = ($160<<24>>24)==(0); //@line 104734 "c/sqlite3.c"
        L74: do {
         if ($161) {
          $162 = HEAP32[$13>>2]|0; //@line 104739 "c/sqlite3.c"
          HEAP32[$159>>2] = $162; //@line 104739 "c/sqlite3.c"
          $163 = (($149) + 1)|0; //@line 104740 "c/sqlite3.c"
          $$cast = $162; //@line 104740 "c/sqlite3.c"
          $164 = (($$cast) + ($163)|0); //@line 104740 "c/sqlite3.c"
          HEAP32[$13>>2] = $164; //@line 104740 "c/sqlite3.c"
          $$cast497 = $162; //@line 104741 "c/sqlite3.c"
          _memcpy(($$cast497|0),($$0437|0),($163|0))|0; //@line 104741 "c/sqlite3.c"
          $165 = ((($159)) + 12|0); //@line 104742 "c/sqlite3.c"
          HEAP32[$165>>2] = $$0435; //@line 104742 "c/sqlite3.c"
          $166 = $5&255; //@line 104743 "c/sqlite3.c"
          $167 = ((($159)) + 54|0); //@line 104743 "c/sqlite3.c"
          HEAP8[$167>>0] = $166; //@line 104743 "c/sqlite3.c"
          $168 = ($5|0)!=(0); //@line 104744 "c/sqlite3.c"
          $169 = ((($159)) + 55|0); //@line 104744 "c/sqlite3.c"
          $170 = $168&1; //@line 104744 "c/sqlite3.c"
          $171 = HEAPU8[$169>>0]|(HEAPU8[$169+1>>0]<<8); //@line 104744 "c/sqlite3.c"
          $172 = ($170 << 3)&65535; //@line 104744 "c/sqlite3.c"
          $173 = $171 & -12; //@line 104744 "c/sqlite3.c"
          $174 = $10 & 3; //@line 104745 "c/sqlite3.c"
          $175 = $174&255; //@line 104745 "c/sqlite3.c"
          $176 = $172 | $175; //@line 104744 "c/sqlite3.c"
          $177 = $176 | $173; //@line 104745 "c/sqlite3.c"
          HEAP8[$169>>0]=$177&255;HEAP8[$169+1>>0]=$177>>8; //@line 104745 "c/sqlite3.c"
          $178 = HEAP32[$70>>2]|0; //@line 104746 "c/sqlite3.c"
          $179 = (((($178) + ($$1451<<4)|0)) + 12|0); //@line 104746 "c/sqlite3.c"
          $180 = HEAP32[$179>>2]|0; //@line 104746 "c/sqlite3.c"
          $181 = ((($159)) + 24|0); //@line 104746 "c/sqlite3.c"
          HEAP32[$181>>2] = $180; //@line 104746 "c/sqlite3.c"
          $182 = HEAP32[$$0431>>2]|0; //@line 104747 "c/sqlite3.c"
          $183 = $182&65535; //@line 104747 "c/sqlite3.c"
          $184 = ((($159)) + 50|0); //@line 104747 "c/sqlite3.c"
          HEAP16[$184>>1] = $183; //@line 104747 "c/sqlite3.c"
          $185 = ($7|0)==(0|0); //@line 104748 "c/sqlite3.c"
          if (!($185)) {
           _sqlite3ResolveSelfReference($0,$$0435,2,$7,0); //@line 104749 "c/sqlite3.c"
           $186 = ((($159)) + 36|0); //@line 104750 "c/sqlite3.c"
           HEAP32[$186>>2] = $7; //@line 104750 "c/sqlite3.c"
          }
          $187 = (((($71) + ($$1451<<4)|0)) + 12|0); //@line 104757 "c/sqlite3.c"
          $188 = HEAP32[$187>>2]|0; //@line 104757 "c/sqlite3.c"
          $189 = ((($188)) + 76|0); //@line 104757 "c/sqlite3.c"
          $190 = HEAP8[$189>>0]|0; //@line 104757 "c/sqlite3.c"
          $191 = ($190&255)>(3); //@line 104757 "c/sqlite3.c"
          $192 = HEAP32[$$0431>>2]|0; //@line 104772 "c/sqlite3.c"
          $193 = ($192|0)>(0); //@line 104772 "c/sqlite3.c"
          L79: do {
           if ($193) {
            $194 = ((($$0431)) + 4|0); //@line 104772 "c/sqlite3.c"
            $195 = ((($0)) + 432|0);
            $196 = ((($$0435)) + 40|0);
            $197 = ((($159)) + 4|0);
            $198 = ((($$0435)) + 4|0);
            $199 = ((($15)) + 157|0);
            $200 = ((($159)) + 40|0);
            $201 = ((($159)) + 32|0);
            $202 = ((($159)) + 28|0);
            $203 = ((($$0435)) + 4|0);
            $204 = ((($159)) + 4|0);
            $$0452529 = $194;$$1442530 = 0;
            while(1) {
             $205 = HEAP32[$$0452529>>2]|0; //@line 104777 "c/sqlite3.c"
             _sqlite3StringToId($205); //@line 104777 "c/sqlite3.c"
             $206 = HEAP32[$$0452529>>2]|0; //@line 104778 "c/sqlite3.c"
             _sqlite3ResolveSelfReference($0,$$0435,32,$206,0); //@line 104778 "c/sqlite3.c"
             $207 = HEAP32[$19>>2]|0; //@line 104779 "c/sqlite3.c"
             $208 = ($207|0)==(0); //@line 104779 "c/sqlite3.c"
             if (!($208)) {
              $$1434494 = 0;
              break L74;
             }
             $209 = HEAP32[$$0452529>>2]|0; //@line 104780 "c/sqlite3.c"
             $210 = (_sqlite3ExprSkipCollate($209)|0); //@line 104780 "c/sqlite3.c"
             $211 = HEAP8[$210>>0]|0; //@line 104781 "c/sqlite3.c"
             $212 = ($211<<24>>24)==(-111); //@line 104781 "c/sqlite3.c"
             if ($212) {
              $225 = ((($210)) + 32|0); //@line 104799 "c/sqlite3.c"
              $226 = HEAP16[$225>>1]|0; //@line 104799 "c/sqlite3.c"
              $227 = $226 << 16 >> 16; //@line 104799 "c/sqlite3.c"
              $228 = ($226<<16>>16)<(0); //@line 104801 "c/sqlite3.c"
              do {
               if ($228) {
                $229 = HEAP16[$196>>1]|0; //@line 104802 "c/sqlite3.c"
                $230 = $229 << 16 >> 16; //@line 104802 "c/sqlite3.c"
                $$0443 = $230;
               } else {
                $231 = HEAP32[$198>>2]|0; //@line 104803 "c/sqlite3.c"
                $232 = (((($231) + ($227<<4)|0)) + 12|0); //@line 104803 "c/sqlite3.c"
                $233 = HEAP8[$232>>0]|0; //@line 104803 "c/sqlite3.c"
                $234 = ($233<<24>>24)==(0); //@line 104803 "c/sqlite3.c"
                if (!($234)) {
                 $$0443 = $227;
                 break;
                }
                $235 = HEAPU8[$169>>0]|(HEAPU8[$169+1>>0]<<8); //@line 104804 "c/sqlite3.c"
                $236 = $235 & -9; //@line 104804 "c/sqlite3.c"
                HEAP8[$169>>0]=$236&255;HEAP8[$169+1>>0]=$236>>8; //@line 104804 "c/sqlite3.c"
                $$0443 = $227;
               }
              } while(0);
              $237 = $$0443&65535; //@line 104806 "c/sqlite3.c"
              $238 = HEAP32[$197>>2]|0; //@line 104806 "c/sqlite3.c"
              $239 = (($238) + ($$1442530<<1)|0); //@line 104806 "c/sqlite3.c"
              HEAP16[$239>>1] = $237; //@line 104806 "c/sqlite3.c"
              $$1444 = $$0443;$$3455 = $$0452529;
             } else {
              $213 = HEAP32[$195>>2]|0; //@line 104782 "c/sqlite3.c"
              $214 = ($$0435|0)==($213|0); //@line 104782 "c/sqlite3.c"
              if ($214) {
               break;
              }
              $215 = HEAP32[$200>>2]|0; //@line 104787 "c/sqlite3.c"
              $216 = ($215|0)==(0|0); //@line 104787 "c/sqlite3.c"
              if ($216) {
               $217 = (_sqlite3ExprListDup($15,$$0431,0)|0); //@line 104788 "c/sqlite3.c"
               HEAP32[$200>>2] = $217; //@line 104789 "c/sqlite3.c"
               $218 = HEAP8[$16>>0]|0; //@line 104790 "c/sqlite3.c"
               $219 = ($218<<24>>24)==(0); //@line 104790 "c/sqlite3.c"
               $220 = (((($217)) + 4|0) + (($$1442530*20)|0)|0); //@line 104792 "c/sqlite3.c"
               $spec$select473 = $219 ? $220 : $$0452529; //@line 104790 "c/sqlite3.c"
               $$2454 = $spec$select473;
              } else {
               $$2454 = $$0452529;
              }
              $221 = HEAP32[$204>>2]|0; //@line 104796 "c/sqlite3.c"
              $222 = (($221) + ($$1442530<<1)|0); //@line 104796 "c/sqlite3.c"
              HEAP16[$222>>1] = -2; //@line 104796 "c/sqlite3.c"
              $223 = HEAPU8[$169>>0]|(HEAPU8[$169+1>>0]<<8); //@line 104797 "c/sqlite3.c"
              $224 = $223 & -9; //@line 104797 "c/sqlite3.c"
              HEAP8[$169>>0]=$224&255;HEAP8[$169+1>>0]=$224>>8; //@line 104797 "c/sqlite3.c"
              $$1444 = -2;$$3455 = $$2454;
             }
             $240 = HEAP32[$$3455>>2]|0; //@line 104809 "c/sqlite3.c"
             $241 = HEAP8[$240>>0]|0; //@line 104809 "c/sqlite3.c"
             $242 = ($241<<24>>24)==(94); //@line 104809 "c/sqlite3.c"
             do {
              if ($242) {
               $243 = ((($240)) + 8|0); //@line 104811 "c/sqlite3.c"
               $244 = HEAP32[$243>>2]|0; //@line 104811 "c/sqlite3.c"
               $245 = (_sqlite3Strlen30($244)|0); //@line 104812 "c/sqlite3.c"
               $246 = (($245) + 1)|0; //@line 104812 "c/sqlite3.c"
               $247 = HEAP32[$13>>2]|0; //@line 104814 "c/sqlite3.c"
               _memcpy(($247|0),($244|0),($246|0))|0; //@line 104814 "c/sqlite3.c"
               $248 = (($247) + ($246)|0); //@line 104816 "c/sqlite3.c"
               HEAP32[$13>>2] = $248; //@line 104816 "c/sqlite3.c"
               $$0448 = $247;
              } else {
               $249 = ($$1444|0)>(-1); //@line 104818 "c/sqlite3.c"
               if (!($249)) {
                $$0448 = 0;
                break;
               }
               $250 = HEAP32[$203>>2]|0; //@line 104819 "c/sqlite3.c"
               $251 = (((($250) + ($$1444<<4)|0)) + 8|0); //@line 104819 "c/sqlite3.c"
               $252 = HEAP32[$251>>2]|0; //@line 104819 "c/sqlite3.c"
               $$0448 = $252;
              }
             } while(0);
             $253 = ($$0448|0)==(0|0); //@line 104821 "c/sqlite3.c"
             $spec$select474 = $253 ? 18038 : $$0448; //@line 104821 "c/sqlite3.c"
             $254 = HEAP8[$199>>0]|0; //@line 104822 "c/sqlite3.c"
             $255 = ($254<<24>>24)==(0); //@line 104822 "c/sqlite3.c"
             if ($255) {
              $256 = (_sqlite3LocateCollSeq($0,$spec$select474)|0); //@line 104822 "c/sqlite3.c"
              $257 = ($256|0)==(0|0); //@line 104822 "c/sqlite3.c"
              if ($257) {
               $$1434494 = 0;
               break L74;
              }
             }
             $258 = HEAP32[$201>>2]|0; //@line 104825 "c/sqlite3.c"
             $259 = (($258) + ($$1442530<<2)|0); //@line 104825 "c/sqlite3.c"
             HEAP32[$259>>2] = $spec$select474; //@line 104825 "c/sqlite3.c"
             $260 = ((($$3455)) + 12|0); //@line 104826 "c/sqlite3.c"
             $261 = HEAP8[$260>>0]|0; //@line 104826 "c/sqlite3.c"
             $262 = $191 ? $261 : 0; //@line 104827 "c/sqlite3.c"
             $263 = HEAP32[$202>>2]|0; //@line 104827 "c/sqlite3.c"
             $264 = (($263) + ($$1442530)|0); //@line 104827 "c/sqlite3.c"
             HEAP8[$264>>0] = $262; //@line 104827 "c/sqlite3.c"
             $265 = (($$1442530) + 1)|0; //@line 104772 "c/sqlite3.c"
             $266 = ((($$3455)) + 20|0); //@line 104772 "c/sqlite3.c"
             $267 = HEAP32[$$0431>>2]|0; //@line 104772 "c/sqlite3.c"
             $268 = ($265|0)<($267|0); //@line 104772 "c/sqlite3.c"
             if ($268) {
              $$0452529 = $266;$$1442530 = $265;
             } else {
              $$1442$lcssa = $265;
              break L79;
             }
            }
            _sqlite3ErrorMsg($0,29407,$vararg_buffer18); //@line 104783 "c/sqlite3.c"
            $$1434 = 0;
            label = 140;
            break L74;
           } else {
            $$1442$lcssa = 0;
           }
          } while(0);
          do {
           if ($150) {
            $269 = ((($$0461)) + 50|0); //@line 104835 "c/sqlite3.c"
            $270 = HEAP16[$269>>1]|0; //@line 104835 "c/sqlite3.c"
            $271 = ($270<<16>>16)==(0); //@line 104835 "c/sqlite3.c"
            if ($271) {
             break;
            }
            $272 = ((($$0461)) + 4|0);
            $273 = ((($159)) + 4|0);
            $274 = ((($$0461)) + 32|0);
            $275 = ((($159)) + 32|0);
            $276 = ((($$0461)) + 28|0);
            $277 = ((($159)) + 28|0);
            $278 = ((($159)) + 52|0);
            $$2445525 = 0;$$2526 = $$1442$lcssa;
            while(1) {
             $279 = HEAP32[$272>>2]|0; //@line 104836 "c/sqlite3.c"
             $280 = (($279) + ($$2445525<<1)|0); //@line 104836 "c/sqlite3.c"
             $281 = HEAP16[$280>>1]|0; //@line 104836 "c/sqlite3.c"
             $282 = $281 << 16 >> 16; //@line 104836 "c/sqlite3.c"
             $283 = HEAP32[$273>>2]|0; //@line 104838 "c/sqlite3.c"
             $284 = HEAP16[$184>>1]|0; //@line 104838 "c/sqlite3.c"
             $285 = $284&65535; //@line 104838 "c/sqlite3.c"
             $286 = (_hasColumn($283,$285,$282)|0); //@line 104838 "c/sqlite3.c"
             $287 = ($286|0)==(0); //@line 104838 "c/sqlite3.c"
             if ($287) {
              $290 = (($283) + ($$2526<<1)|0); //@line 104841 "c/sqlite3.c"
              HEAP16[$290>>1] = $281; //@line 104841 "c/sqlite3.c"
              $291 = HEAP32[$274>>2]|0; //@line 104842 "c/sqlite3.c"
              $292 = (($291) + ($$2445525<<2)|0); //@line 104842 "c/sqlite3.c"
              $293 = HEAP32[$292>>2]|0; //@line 104842 "c/sqlite3.c"
              $294 = HEAP32[$275>>2]|0; //@line 104842 "c/sqlite3.c"
              $295 = (($294) + ($$2526<<2)|0); //@line 104842 "c/sqlite3.c"
              HEAP32[$295>>2] = $293; //@line 104842 "c/sqlite3.c"
              $296 = HEAP32[$276>>2]|0; //@line 104843 "c/sqlite3.c"
              $297 = (($296) + ($$2445525)|0); //@line 104843 "c/sqlite3.c"
              $298 = HEAP8[$297>>0]|0; //@line 104843 "c/sqlite3.c"
              $299 = HEAP32[$277>>2]|0; //@line 104843 "c/sqlite3.c"
              $300 = (($299) + ($$2526)|0); //@line 104843 "c/sqlite3.c"
              HEAP8[$300>>0] = $298; //@line 104843 "c/sqlite3.c"
              $301 = (($$2526) + 1)|0; //@line 104844 "c/sqlite3.c"
              $$3 = $301;
             } else {
              $288 = HEAP16[$278>>1]|0; //@line 104839 "c/sqlite3.c"
              $289 = (($288) + -1)<<16>>16; //@line 104839 "c/sqlite3.c"
              HEAP16[$278>>1] = $289; //@line 104839 "c/sqlite3.c"
              $$3 = $$2526;
             }
             $302 = (($$2445525) + 1)|0; //@line 104835 "c/sqlite3.c"
             $303 = HEAP16[$269>>1]|0; //@line 104835 "c/sqlite3.c"
             $304 = $303&65535; //@line 104835 "c/sqlite3.c"
             $305 = ($302>>>0)<($304>>>0); //@line 104835 "c/sqlite3.c"
             if ($305) {
              $$2445525 = $302;$$2526 = $$3;
             } else {
              break;
             }
            }
           } else {
            $306 = ((($159)) + 4|0); //@line 104849 "c/sqlite3.c"
            $307 = HEAP32[$306>>2]|0; //@line 104849 "c/sqlite3.c"
            $308 = (($307) + ($$1442$lcssa<<1)|0); //@line 104849 "c/sqlite3.c"
            HEAP16[$308>>1] = -1; //@line 104849 "c/sqlite3.c"
            $309 = ((($159)) + 32|0); //@line 104850 "c/sqlite3.c"
            $310 = HEAP32[$309>>2]|0; //@line 104850 "c/sqlite3.c"
            $311 = (($310) + ($$1442$lcssa<<2)|0); //@line 104850 "c/sqlite3.c"
            HEAP32[$311>>2] = 18038; //@line 104850 "c/sqlite3.c"
           }
          } while(0);
          _sqlite3DefaultRowEst($159); //@line 104852 "c/sqlite3.c"
          $312 = ((($0)) + 432|0); //@line 104853 "c/sqlite3.c"
          $313 = HEAP32[$312>>2]|0; //@line 104853 "c/sqlite3.c"
          $314 = ($313|0)==(0|0); //@line 104853 "c/sqlite3.c"
          if ($314) {
           _estimateIndexWidth($159); //@line 104853 "c/sqlite3.c"
          }
          L121: do {
           if ($28) {
            $315 = ((($159)) + 52|0); //@line 104859 "c/sqlite3.c"
            $316 = HEAP16[$315>>1]|0; //@line 104859 "c/sqlite3.c"
            $317 = $316&65535; //@line 104859 "c/sqlite3.c"
            $318 = ((($$0435)) + 42|0); //@line 104859 "c/sqlite3.c"
            $319 = HEAP16[$318>>1]|0; //@line 104859 "c/sqlite3.c"
            $320 = $319 << 16 >> 16; //@line 104859 "c/sqlite3.c"
            $321 = ($317|0)<($320|0); //@line 104859 "c/sqlite3.c"
            if ($321) {
             break;
            }
            $322 = HEAPU8[$169>>0]|(HEAPU8[$169+1>>0]<<8); //@line 104860 "c/sqlite3.c"
            $323 = $322 | 32; //@line 104860 "c/sqlite3.c"
            HEAP8[$169>>0]=$323&255;HEAP8[$169+1>>0]=$323>>8; //@line 104860 "c/sqlite3.c"
            $324 = HEAP16[$318>>1]|0; //@line 104861 "c/sqlite3.c"
            $325 = ($324<<16>>16)>(0); //@line 104861 "c/sqlite3.c"
            if (!($325)) {
             break;
            }
            $326 = ((($$0435)) + 40|0);
            $327 = HEAP16[$326>>1]|0;
            $328 = $327 << 16 >> 16;
            $$3446523 = 0;
            while(1) {
             $329 = ($$3446523|0)==($328|0); //@line 104862 "c/sqlite3.c"
             if (!($329)) {
              $330 = $$3446523&65535; //@line 104863 "c/sqlite3.c"
              $331 = (_sqlite3ColumnOfIndex($159,$330)|0); //@line 104863 "c/sqlite3.c"
              $332 = ($331<<16>>16)>(-1); //@line 104863 "c/sqlite3.c"
              if (!($332)) {
               break;
              }
             }
             $334 = (($$3446523) + 1)|0; //@line 104861 "c/sqlite3.c"
             $335 = HEAP16[$318>>1]|0; //@line 104861 "c/sqlite3.c"
             $336 = $335 << 16 >> 16; //@line 104861 "c/sqlite3.c"
             $337 = ($334|0)<($336|0); //@line 104861 "c/sqlite3.c"
             if ($337) {
              $$3446523 = $334;
             } else {
              break L121;
             }
            }
            $333 = $322 & -33; //@line 104864 "c/sqlite3.c"
            HEAP8[$169>>0]=$333&255;HEAP8[$169+1>>0]=$333>>8; //@line 104864 "c/sqlite3.c"
           }
          } while(0);
          $338 = HEAP32[$312>>2]|0; //@line 104869 "c/sqlite3.c"
          $339 = ($$0435|0)==($338|0); //@line 104869 "c/sqlite3.c"
          L132: do {
           if ($339) {
            $340 = ((($$0435)) + 8|0); //@line 104892 "c/sqlite3.c"
            $$0440520 = HEAP32[$340>>2]|0;
            $341 = ($$0440520|0)==(0|0); //@line 104892 "c/sqlite3.c"
            if ($341) {
             break;
            }
            $342 = ((($159)) + 4|0);
            $343 = ((($159)) + 32|0);
            $$0440521 = $$0440520;
            L135: while(1) {
             $344 = ((($$0440521)) + 50|0); //@line 104898 "c/sqlite3.c"
             $345 = HEAP16[$344>>1]|0; //@line 104898 "c/sqlite3.c"
             $346 = HEAP16[$184>>1]|0; //@line 104898 "c/sqlite3.c"
             $347 = ($345<<16>>16)==($346<<16>>16); //@line 104898 "c/sqlite3.c"
             do {
              if ($347) {
               $348 = ((($$0440521)) + 32|0); //@line 104904 "c/sqlite3.c"
               $349 = $345&65535; //@line 104899 "c/sqlite3.c"
               $350 = ($345<<16>>16)==(0); //@line 104899 "c/sqlite3.c"
               L139: do {
                if ($350) {
                 $$0439$lcssa = 0;
                } else {
                 $351 = ((($$0440521)) + 4|0); //@line 104903 "c/sqlite3.c"
                 $352 = HEAP32[$351>>2]|0;
                 $353 = HEAP32[$342>>2]|0;
                 $$0439510 = 0;
                 while(1) {
                  $354 = (($352) + ($$0439510<<1)|0); //@line 104903 "c/sqlite3.c"
                  $355 = HEAP16[$354>>1]|0; //@line 104903 "c/sqlite3.c"
                  $356 = (($353) + ($$0439510<<1)|0); //@line 104903 "c/sqlite3.c"
                  $357 = HEAP16[$356>>1]|0; //@line 104903 "c/sqlite3.c"
                  $358 = ($355<<16>>16)==($357<<16>>16); //@line 104903 "c/sqlite3.c"
                  if (!($358)) {
                   $$0439$lcssa = $$0439510;
                   break L139;
                  }
                  $359 = HEAP32[$348>>2]|0; //@line 104904 "c/sqlite3.c"
                  $360 = (($359) + ($$0439510<<2)|0); //@line 104904 "c/sqlite3.c"
                  $361 = HEAP32[$360>>2]|0; //@line 104904 "c/sqlite3.c"
                  $362 = HEAP32[$343>>2]|0; //@line 104905 "c/sqlite3.c"
                  $363 = (($362) + ($$0439510<<2)|0); //@line 104905 "c/sqlite3.c"
                  $364 = HEAP32[$363>>2]|0; //@line 104905 "c/sqlite3.c"
                  $365 = (_sqlite3StrICmp($361,$364)|0); //@line 104906 "c/sqlite3.c"
                  $366 = ($365|0)==(0); //@line 104906 "c/sqlite3.c"
                  if (!($366)) {
                   $$0439$lcssa = $$0439510;
                   break L139;
                  }
                  $367 = (($$0439510) + 1)|0; //@line 104899 "c/sqlite3.c"
                  $368 = ($367>>>0)<($349>>>0); //@line 104899 "c/sqlite3.c"
                  if ($368) {
                   $$0439510 = $367;
                  } else {
                   $$0439$lcssa = $367;
                   break;
                  }
                 }
                }
               } while(0);
               $369 = ($$0439$lcssa|0)==($349|0); //@line 104908 "c/sqlite3.c"
               if (!($369)) {
                $$5 = 0;
                break;
               }
               $370 = ((($$0440521)) + 54|0); //@line 104909 "c/sqlite3.c"
               $371 = HEAP8[$370>>0]|0; //@line 104909 "c/sqlite3.c"
               $372 = HEAP8[$167>>0]|0; //@line 104909 "c/sqlite3.c"
               $373 = ($371<<24>>24)==($372<<24>>24); //@line 104909 "c/sqlite3.c"
               do {
                if (!($373)) {
                 $374 = ($371<<24>>24)==(10); //@line 104917 "c/sqlite3.c"
                 $375 = ($372<<24>>24)==(10); //@line 104917 "c/sqlite3.c"
                 $or$cond477 = $374 | $375; //@line 104917 "c/sqlite3.c"
                 if (!($or$cond477)) {
                  HEAP32[$vararg_buffer20>>2] = 0; //@line 104918 "c/sqlite3.c"
                  _sqlite3ErrorMsg($0,29468,$vararg_buffer20); //@line 104918 "c/sqlite3.c"
                 }
                 $376 = HEAP8[$370>>0]|0; //@line 104921 "c/sqlite3.c"
                 $377 = ($376<<24>>24)==(10); //@line 104921 "c/sqlite3.c"
                 if (!($377)) {
                  break;
                 }
                 $378 = HEAP8[$167>>0]|0; //@line 104922 "c/sqlite3.c"
                 HEAP8[$370>>0] = $378; //@line 104922 "c/sqlite3.c"
                }
               } while(0);
               if (!($25)) {
                $$5 = 2;
                break;
               }
               $379 = ((($$0440521)) + 55|0); //@line 104925 "c/sqlite3.c"
               $380 = HEAPU8[$379>>0]|(HEAPU8[$379+1>>0]<<8); //@line 104925 "c/sqlite3.c"
               $381 = $380 & -4; //@line 104925 "c/sqlite3.c"
               $382 = $381 | $175; //@line 104925 "c/sqlite3.c"
               HEAP8[$379>>0]=$382&255;HEAP8[$379+1>>0]=$382>>8; //@line 104925 "c/sqlite3.c"
               $$5 = 2;
              } else {
               $$5 = 20;
              }
             } while(0);
             $trunc = $$5&255;
             $trunc$clear = $trunc & 31;
             switch ($trunc$clear<<24>>24) {
             case 20: case 0:  {
              break;
             }
             default: {
              break L135;
             }
             }
             $383 = ((($$0440521)) + 20|0); //@line 104892 "c/sqlite3.c"
             $$0440 = HEAP32[$383>>2]|0;
             $384 = ($$0440|0)==(0|0); //@line 104892 "c/sqlite3.c"
             if ($384) {
              break L132;
             } else {
              $$0440521 = $$0440;
             }
            }
            $switch6 = ($$5|0)==(0);
            if (!($switch6)) {
             $$1434494 = 0;
             break L74;
            }
           }
          } while(0);
          $385 = ((($15)) + 157|0); //@line 104935 "c/sqlite3.c"
          $386 = HEAP8[$385>>0]|0; //@line 104935 "c/sqlite3.c"
          $387 = ($386<<24>>24)==(0); //@line 104935 "c/sqlite3.c"
          do {
           if ($387) {
            $399 = ((($$0435)) + 36|0); //@line 104965 "c/sqlite3.c"
            $400 = HEAP32[$399>>2]|0; //@line 104965 "c/sqlite3.c"
            $401 = $400 & 32; //@line 104965 "c/sqlite3.c"
            $402 = ($401|0)==(0); //@line 104965 "c/sqlite3.c"
            $or$cond9 = $28 | $402; //@line 104965 "c/sqlite3.c"
            if (!($or$cond9)) {
             break;
            }
            $403 = ((($0)) + 44|0); //@line 104968 "c/sqlite3.c"
            $404 = HEAP32[$403>>2]|0; //@line 104968 "c/sqlite3.c"
            $405 = (($404) + 1)|0; //@line 104968 "c/sqlite3.c"
            HEAP32[$403>>2] = $405; //@line 104968 "c/sqlite3.c"
            $406 = (_sqlite3GetVdbe($0)|0); //@line 104970 "c/sqlite3.c"
            $407 = ($406|0)==(0|0); //@line 104971 "c/sqlite3.c"
            if ($407) {
             $$1434 = 0;
             label = 140;
             break L74;
            }
            _sqlite3BeginWriteOperation($0,1,$$1451); //@line 104973 "c/sqlite3.c"
            $408 = (_sqlite3VdbeAddOp0($406,168)|0); //@line 104981 "c/sqlite3.c"
            $409 = ((($159)) + 44|0); //@line 104981 "c/sqlite3.c"
            HEAP32[$409>>2] = $408; //@line 104981 "c/sqlite3.c"
            (_sqlite3VdbeAddOp3($406,136,$$1451,$405,2)|0); //@line 104982 "c/sqlite3.c"
            $410 = ($6|0)==(0|0); //@line 104987 "c/sqlite3.c"
            if ($410) {
             $$0432 = 0;
            } else {
             $411 = ((($0)) + 388|0); //@line 104988 "c/sqlite3.c"
             $412 = HEAP32[$411>>2]|0; //@line 104988 "c/sqlite3.c"
             $413 = HEAP32[$88>>2]|0; //@line 104988 "c/sqlite3.c"
             $414 = $413; //@line 104988 "c/sqlite3.c"
             $415 = (($412) - ($414))|0; //@line 104988 "c/sqlite3.c"
             $416 = ((($0)) + 392|0); //@line 104988 "c/sqlite3.c"
             $417 = HEAP32[$416>>2]|0; //@line 104988 "c/sqlite3.c"
             $418 = (($415) + ($417))|0; //@line 104988 "c/sqlite3.c"
             $419 = (($418) + -1)|0; //@line 104989 "c/sqlite3.c"
             $420 = (($413) + ($419)|0); //@line 104989 "c/sqlite3.c"
             $421 = HEAP8[$420>>0]|0; //@line 104989 "c/sqlite3.c"
             $422 = ($421<<24>>24)==(59); //@line 104989 "c/sqlite3.c"
             $spec$select479 = $422 ? $419 : $418; //@line 104989 "c/sqlite3.c"
             $423 = ($5|0)==(0); //@line 104992 "c/sqlite3.c"
             $424 = $423 ? 41388 : 29510; //@line 104992 "c/sqlite3.c"
             HEAP32[$vararg_buffer23>>2] = $424; //@line 104991 "c/sqlite3.c"
             $vararg_ptr26 = ((($vararg_buffer23)) + 4|0); //@line 104991 "c/sqlite3.c"
             HEAP32[$vararg_ptr26>>2] = $spec$select479; //@line 104991 "c/sqlite3.c"
             $vararg_ptr27 = ((($vararg_buffer23)) + 8|0); //@line 104991 "c/sqlite3.c"
             HEAP32[$vararg_ptr27>>2] = $413; //@line 104991 "c/sqlite3.c"
             $425 = (_sqlite3MPrintf($15,29518,$vararg_buffer23)|0); //@line 104991 "c/sqlite3.c"
             $$0432 = $425;
            }
            $426 = HEAP32[$70>>2]|0; //@line 105003 "c/sqlite3.c"
            $427 = (($426) + ($$1451<<4)|0); //@line 105003 "c/sqlite3.c"
            $428 = HEAP32[$427>>2]|0; //@line 105003 "c/sqlite3.c"
            $429 = HEAP32[$159>>2]|0; //@line 105004 "c/sqlite3.c"
            $430 = HEAP32[$$0435>>2]|0; //@line 105005 "c/sqlite3.c"
            HEAP32[$vararg_buffer28>>2] = $428; //@line 105001 "c/sqlite3.c"
            $vararg_ptr31 = ((($vararg_buffer28)) + 4|0); //@line 105001 "c/sqlite3.c"
            HEAP32[$vararg_ptr31>>2] = 19754; //@line 105001 "c/sqlite3.c"
            $vararg_ptr32 = ((($vararg_buffer28)) + 8|0); //@line 105001 "c/sqlite3.c"
            HEAP32[$vararg_ptr32>>2] = $429; //@line 105001 "c/sqlite3.c"
            $vararg_ptr33 = ((($vararg_buffer28)) + 12|0); //@line 105001 "c/sqlite3.c"
            HEAP32[$vararg_ptr33>>2] = $430; //@line 105001 "c/sqlite3.c"
            $vararg_ptr34 = ((($vararg_buffer28)) + 16|0); //@line 105001 "c/sqlite3.c"
            HEAP32[$vararg_ptr34>>2] = $405; //@line 105001 "c/sqlite3.c"
            $vararg_ptr35 = ((($vararg_buffer28)) + 20|0); //@line 105001 "c/sqlite3.c"
            HEAP32[$vararg_ptr35>>2] = $$0432; //@line 105001 "c/sqlite3.c"
            _sqlite3NestedParse($0,29538,$vararg_buffer28); //@line 105001 "c/sqlite3.c"
            _sqlite3DbFree($15,$$0432); //@line 105009 "c/sqlite3.c"
            if ($28) {
             _sqlite3RefillIndex($0,$159,$405); //@line 105015 "c/sqlite3.c"
             _sqlite3ChangeCookie($0,$$1451); //@line 105016 "c/sqlite3.c"
             $431 = HEAP32[$159>>2]|0; //@line 105018 "c/sqlite3.c"
             HEAP32[$vararg_buffer36>>2] = $431; //@line 105018 "c/sqlite3.c"
             $432 = (_sqlite3MPrintf($15,29586,$vararg_buffer36)|0); //@line 105018 "c/sqlite3.c"
             _sqlite3VdbeAddParseSchemaOp($406,$$1451,$432); //@line 105017 "c/sqlite3.c"
             (_sqlite3VdbeAddOp0($406,152)|0); //@line 105019 "c/sqlite3.c"
            }
            $433 = HEAP32[$409>>2]|0; //@line 105022 "c/sqlite3.c"
            _sqlite3VdbeJumpHere($406,$433); //@line 105022 "c/sqlite3.c"
            label = 130;
           } else {
            $388 = HEAP32[$181>>2]|0; //@line 104939 "c/sqlite3.c"
            $389 = ((($388)) + 24|0); //@line 104939 "c/sqlite3.c"
            $390 = HEAP32[$159>>2]|0; //@line 104940 "c/sqlite3.c"
            $391 = (_sqlite3HashInsert($389,$390,$159)|0); //@line 104939 "c/sqlite3.c"
            $392 = ($391|0)==(0|0); //@line 104941 "c/sqlite3.c"
            if (!($392)) {
             _sqlite3OomFault($15); //@line 104943 "c/sqlite3.c"
             $$1434494 = 0;
             break L74;
            }
            $393 = ((($15)) + 24|0); //@line 104946 "c/sqlite3.c"
            $394 = HEAP32[$393>>2]|0; //@line 104946 "c/sqlite3.c"
            $395 = $394 | 1; //@line 104946 "c/sqlite3.c"
            HEAP32[$393>>2] = $395; //@line 104946 "c/sqlite3.c"
            if (!($28)) {
             break;
            }
            $396 = ((($15)) + 152|0); //@line 104948 "c/sqlite3.c"
            $397 = HEAP32[$396>>2]|0; //@line 104948 "c/sqlite3.c"
            $398 = ((($159)) + 44|0); //@line 104948 "c/sqlite3.c"
            HEAP32[$398>>2] = $397; //@line 104948 "c/sqlite3.c"
            label = 130;
           }
          } while(0);
          if ((label|0) == 130) {
           $434 = HEAP8[$385>>0]|0; //@line 105031 "c/sqlite3.c"
           $435 = ($434<<24>>24)!=(0); //@line 105031 "c/sqlite3.c"
           $436 = ($3|0)==(0|0); //@line 105031 "c/sqlite3.c"
           $or$cond12 = $436 | $435; //@line 105031 "c/sqlite3.c"
           if (!($or$cond12)) {
            $$1434494 = 0;
            break;
           }
          }
          $437 = ($5|0)==(5); //@line 105032 "c/sqlite3.c"
          do {
           if ($437) {
            $438 = ((($$0435)) + 8|0); //@line 105032 "c/sqlite3.c"
            $439 = HEAP32[$438>>2]|0; //@line 105032 "c/sqlite3.c"
            $440 = ($439|0)==(0|0); //@line 105032 "c/sqlite3.c"
            if ($440) {
             break;
            }
            $441 = ((($439)) + 54|0); //@line 105033 "c/sqlite3.c"
            $442 = HEAP8[$441>>0]|0; //@line 105033 "c/sqlite3.c"
            $443 = ($442<<24>>24)==(5); //@line 105033 "c/sqlite3.c"
            if ($443) {
             break;
            }
            $447 = ((($439)) + 20|0); //@line 105038 "c/sqlite3.c"
            $448 = HEAP32[$447>>2]|0; //@line 105038 "c/sqlite3.c"
            $449 = ($448|0)==(0|0); //@line 105038 "c/sqlite3.c"
            L181: do {
             if ($449) {
              $$lcssa = 0;$$lcssa499 = $447;
             } else {
              $451 = $448;$459 = $447;
              while(1) {
               $454 = ((($451)) + 54|0); //@line 105038 "c/sqlite3.c"
               $455 = HEAP8[$454>>0]|0; //@line 105038 "c/sqlite3.c"
               $456 = ($455<<24>>24)==(5); //@line 105038 "c/sqlite3.c"
               if ($456) {
                $$lcssa = $451;$$lcssa499 = $459;
                break L181;
               }
               $450 = ((($451)) + 20|0); //@line 105038 "c/sqlite3.c"
               $452 = HEAP32[$450>>2]|0; //@line 105038 "c/sqlite3.c"
               $453 = ($452|0)==(0|0); //@line 105038 "c/sqlite3.c"
               if ($453) {
                $$lcssa = 0;$$lcssa499 = $450;
                break;
               } else {
                $451 = $452;$459 = $450;
               }
              }
             }
            } while(0);
            $457 = ((($159)) + 20|0); //@line 105041 "c/sqlite3.c"
            HEAP32[$457>>2] = $$lcssa; //@line 105041 "c/sqlite3.c"
            HEAP32[$$lcssa499>>2] = $159; //@line 105042 "c/sqlite3.c"
            $$1434488 = 0;$$1438487 = $$0437;$$1489 = $$0431;
            break L1;
           }
          } while(0);
          $444 = ((($$0435)) + 8|0); //@line 105034 "c/sqlite3.c"
          $445 = HEAP32[$444>>2]|0; //@line 105034 "c/sqlite3.c"
          $446 = ((($159)) + 20|0); //@line 105034 "c/sqlite3.c"
          HEAP32[$446>>2] = $445; //@line 105034 "c/sqlite3.c"
          HEAP32[$444>>2] = $159; //@line 105035 "c/sqlite3.c"
          $$1434488 = 0;$$1438487 = $$0437;$$1489 = $$0431;
          break L1;
         } else {
          $$1434 = $7;
          label = 140;
         }
        } while(0);
        if ((label|0) == 140) {
         $458 = ($159|0)==(0|0); //@line 105049 "c/sqlite3.c"
         if ($458) {
          $$1434488 = $$1434;$$1438487 = $$0437;$$1489 = $$0431;
          break;
         } else {
          $$1434494 = $$1434;
         }
        }
        _freeIndex($15,$159); //@line 105049 "c/sqlite3.c"
        $$1434488 = $$1434494;$$1438487 = $$0437;$$1489 = $$0431;
       } else {
        $$1434488 = $7;$$1438487 = $$0437;$$1489 = $4;
       }
      } else {
       $$1434488 = $7;$$1438487 = $$0437;$$1489 = $4;
      }
     } else {
      $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
     }
    } else {
     $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
    }
   }
  } else {
   $$1434488 = $7;$$1438487 = 0;$$1489 = $4;
  }
 } while(0);
 _sqlite3ExprDelete($15,$$1434488); //@line 105050 "c/sqlite3.c"
 _sqlite3ExprListDelete($15,$$1489); //@line 105051 "c/sqlite3.c"
 _sqlite3SrcListDelete($15,$3); //@line 105052 "c/sqlite3.c"
 _sqlite3DbFree($15,$$1438487); //@line 105053 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 105054 "c/sqlite3.c"
}
function _sqlite3AddCheckConstraint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 432|0); //@line 102992 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 102992 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 102993 "c/sqlite3.c"
 $5 = ($3|0)==(0|0); //@line 102994 "c/sqlite3.c"
 if (!($5)) {
  $6 = ((($0)) + 400|0); //@line 102994 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 102994 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(0); //@line 102994 "c/sqlite3.c"
  if ($8) {
   $9 = ((($4)) + 16|0); //@line 102995 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 102995 "c/sqlite3.c"
   $11 = ((($4)) + 156|0); //@line 102995 "c/sqlite3.c"
   $12 = HEAP8[$11>>0]|0; //@line 102995 "c/sqlite3.c"
   $13 = $12&255; //@line 102995 "c/sqlite3.c"
   $14 = (((($10) + ($13<<4)|0)) + 4|0); //@line 102995 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 102995 "c/sqlite3.c"
   $16 = (_sqlite3BtreeIsReadonly($15)|0); //@line 102995 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 102995 "c/sqlite3.c"
   if ($17) {
    $18 = ((($3)) + 24|0); //@line 102997 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 102997 "c/sqlite3.c"
    $20 = (_sqlite3ExprListAppend($0,$19,$1)|0); //@line 102997 "c/sqlite3.c"
    HEAP32[$18>>2] = $20; //@line 102997 "c/sqlite3.c"
    $21 = ((($0)) + 84|0); //@line 102998 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 102998 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 102998 "c/sqlite3.c"
    if ($23) {
     return; //@line 103006 "c/sqlite3.c"
    }
    $24 = ((($0)) + 80|0); //@line 102998 "c/sqlite3.c"
    _sqlite3ExprListSetName($0,$20,$24,1); //@line 102999 "c/sqlite3.c"
    return; //@line 103006 "c/sqlite3.c"
   }
  }
 }
 _sqlite3ExprDelete($4,$1); //@line 103004 "c/sqlite3.c"
 return; //@line 103006 "c/sqlite3.c"
}
function _sqlite3CreateForeignKey($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0132149 = 0, $$0134156 = 0, $$0136148 = 0, $$0139155 = 0, $$1135 = 0, $$1138164 = 0, $$1138165 = 0, $$1140153 = 0, $$2147 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer4 = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer4 = sp + 16|0; //@line 104248 "c/sqlite3.c"
 $vararg_buffer2 = sp + 8|0; //@line 104248 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 104248 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 104254 "c/sqlite3.c"
 $6 = ((($0)) + 432|0); //@line 104258 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 104258 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 104265 "c/sqlite3.c"
 L1: do {
  if ($8) {
   $121 = 0;
  } else {
   $9 = ((($0)) + 400|0); //@line 104265 "c/sqlite3.c"
   $10 = HEAP8[$9>>0]|0; //@line 104265 "c/sqlite3.c"
   $11 = ($10<<24>>24)==(0); //@line 104265 "c/sqlite3.c"
   if ($11) {
    $12 = ($1|0)==(0|0); //@line 104266 "c/sqlite3.c"
    do {
     if ($12) {
      $13 = ((($7)) + 42|0); //@line 104267 "c/sqlite3.c"
      $14 = HEAP16[$13>>1]|0; //@line 104267 "c/sqlite3.c"
      $15 = $14 << 16 >> 16; //@line 104267 "c/sqlite3.c"
      $16 = (($15) + -1)|0; //@line 104267 "c/sqlite3.c"
      $17 = ($14<<16>>16)<(1); //@line 104268 "c/sqlite3.c"
      if ($17) {
       $121 = 0;
       break L1;
      }
      $18 = ($3|0)==(0|0); //@line 104269 "c/sqlite3.c"
      if ($18) {
       $19 = ((($2)) + 4|0); //@line 104284 "c/sqlite3.c"
       $20 = HEAP32[$19>>2]|0; //@line 104284 "c/sqlite3.c"
       $21 = (($20) + 45)|0; //@line 104284 "c/sqlite3.c"
       $$1135 = $21;$$1138164 = 1;$64 = $19;$97 = 0;
       break;
      }
      $22 = HEAP32[$3>>2]|0; //@line 104269 "c/sqlite3.c"
      $23 = ($22|0)==(1); //@line 104269 "c/sqlite3.c"
      if ($23) {
       $24 = ((($2)) + 4|0); //@line 104284 "c/sqlite3.c"
       $25 = HEAP32[$24>>2]|0; //@line 104284 "c/sqlite3.c"
       $26 = (($25) + 45)|0; //@line 104284 "c/sqlite3.c"
       $$1138165 = 1;$122 = $26;$123 = $24;
       label = 14;
       break;
      } else {
       $27 = ((($7)) + 4|0); //@line 104272 "c/sqlite3.c"
       $28 = HEAP32[$27>>2]|0; //@line 104272 "c/sqlite3.c"
       $29 = (($28) + ($16<<4)|0); //@line 104272 "c/sqlite3.c"
       $30 = HEAP32[$29>>2]|0; //@line 104272 "c/sqlite3.c"
       HEAP32[$vararg_buffer>>2] = $30; //@line 104270 "c/sqlite3.c"
       $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 104270 "c/sqlite3.c"
       HEAP32[$vararg_ptr1>>2] = $2; //@line 104270 "c/sqlite3.c"
       _sqlite3ErrorMsg($0,28970,$vararg_buffer); //@line 104270 "c/sqlite3.c"
       $121 = 0;
       break L1;
      }
     } else {
      $31 = ($3|0)==(0|0); //@line 104276 "c/sqlite3.c"
      if (!($31)) {
       $32 = HEAP32[$3>>2]|0; //@line 104276 "c/sqlite3.c"
       $33 = HEAP32[$1>>2]|0; //@line 104276 "c/sqlite3.c"
       $34 = ($32|0)==($33|0); //@line 104276 "c/sqlite3.c"
       if (!($34)) {
        _sqlite3ErrorMsg($0,29033,$vararg_buffer2); //@line 104277 "c/sqlite3.c"
        $121 = 0;
        break L1;
       }
      }
      $35 = HEAP32[$1>>2]|0; //@line 104282 "c/sqlite3.c"
      $36 = $35 << 3; //@line 104284 "c/sqlite3.c"
      $37 = ((($2)) + 4|0); //@line 104284 "c/sqlite3.c"
      $38 = HEAP32[$37>>2]|0; //@line 104284 "c/sqlite3.c"
      $39 = (($36) + 37)|0; //@line 104284 "c/sqlite3.c"
      $40 = (($39) + ($38))|0; //@line 104284 "c/sqlite3.c"
      $41 = ($3|0)==(0|0); //@line 104285 "c/sqlite3.c"
      if ($41) {
       $$1135 = $40;$$1138164 = $35;$64 = $37;$97 = 0;
      } else {
       $$1138165 = $35;$122 = $40;$123 = $37;
       label = 14;
      }
     }
    } while(0);
    if ((label|0) == 14) {
     $42 = HEAP32[$3>>2]|0; //@line 104286 "c/sqlite3.c"
     $43 = ($42|0)>(0); //@line 104286 "c/sqlite3.c"
     if ($43) {
      $44 = HEAP32[$3>>2]|0;
      $$0134156 = $122;$$0139155 = 0;
      while(1) {
       $45 = (((((($3)) + 4|0) + (($$0139155*20)|0)|0)) + 4|0); //@line 104287 "c/sqlite3.c"
       $46 = HEAP32[$45>>2]|0; //@line 104287 "c/sqlite3.c"
       $47 = (_sqlite3Strlen30($46)|0); //@line 104287 "c/sqlite3.c"
       $48 = (($$0134156) + 1)|0; //@line 104287 "c/sqlite3.c"
       $49 = (($48) + ($47))|0; //@line 104287 "c/sqlite3.c"
       $50 = (($$0139155) + 1)|0; //@line 104286 "c/sqlite3.c"
       $51 = ($50|0)<($44|0); //@line 104286 "c/sqlite3.c"
       if ($51) {
        $$0134156 = $49;$$0139155 = $50;
       } else {
        $$1135 = $49;$$1138164 = $$1138165;$64 = $123;$97 = 1;
        break;
       }
      }
     } else {
      $$1135 = $122;$$1138164 = $$1138165;$64 = $123;$97 = 1;
     }
    }
    $52 = ($$1135|0)<(0); //@line 104290 "c/sqlite3.c"
    $53 = $52 << 31 >> 31; //@line 104290 "c/sqlite3.c"
    $54 = (_sqlite3DbMallocZero($5,$$1135,$53)|0); //@line 104290 "c/sqlite3.c"
    $55 = ($54|0)==(0|0); //@line 104291 "c/sqlite3.c"
    if ($55) {
     $121 = 0;
    } else {
     HEAP32[$54>>2] = $7; //@line 104294 "c/sqlite3.c"
     $56 = ((($7)) + 16|0); //@line 104295 "c/sqlite3.c"
     $57 = HEAP32[$56>>2]|0; //@line 104295 "c/sqlite3.c"
     $58 = ((($54)) + 4|0); //@line 104295 "c/sqlite3.c"
     HEAP32[$58>>2] = $57; //@line 104295 "c/sqlite3.c"
     $59 = ((($54)) + 36|0); //@line 104296 "c/sqlite3.c"
     $60 = (($59) + ($$1138164<<3)|0); //@line 104296 "c/sqlite3.c"
     $61 = ((($54)) + 8|0); //@line 104297 "c/sqlite3.c"
     HEAP32[$61>>2] = $60; //@line 104297 "c/sqlite3.c"
     $62 = HEAP32[$2>>2]|0; //@line 104298 "c/sqlite3.c"
     $63 = HEAP32[$64>>2]|0; //@line 104298 "c/sqlite3.c"
     _memcpy(($60|0),($62|0),($63|0))|0; //@line 104298 "c/sqlite3.c"
     $65 = HEAP32[$64>>2]|0; //@line 104299 "c/sqlite3.c"
     $66 = (($60) + ($65)|0); //@line 104299 "c/sqlite3.c"
     HEAP8[$66>>0] = 0; //@line 104299 "c/sqlite3.c"
     _sqlite3Dequote($60); //@line 104300 "c/sqlite3.c"
     $67 = HEAP32[$64>>2]|0; //@line 104301 "c/sqlite3.c"
     $68 = (($67) + 1)|0; //@line 104301 "c/sqlite3.c"
     $69 = (($60) + ($68)|0); //@line 104301 "c/sqlite3.c"
     $70 = ((($54)) + 20|0); //@line 104302 "c/sqlite3.c"
     HEAP32[$70>>2] = $$1138164; //@line 104302 "c/sqlite3.c"
     L25: do {
      if ($12) {
       $71 = ((($7)) + 42|0); //@line 104304 "c/sqlite3.c"
       $72 = HEAP16[$71>>1]|0; //@line 104304 "c/sqlite3.c"
       $73 = $72 << 16 >> 16; //@line 104304 "c/sqlite3.c"
       $74 = (($73) + -1)|0; //@line 104304 "c/sqlite3.c"
       HEAP32[$59>>2] = $74; //@line 104304 "c/sqlite3.c"
       label = 28;
      } else {
       $75 = ($$1138164|0)>(0); //@line 104306 "c/sqlite3.c"
       if ($75) {
        $76 = ((($7)) + 42|0);
        $77 = ((($7)) + 4|0);
        $$1140153 = 0;
        L29: while(1) {
         $78 = HEAP16[$76>>1]|0; //@line 104308 "c/sqlite3.c"
         $79 = ($78<<16>>16)>(0); //@line 104308 "c/sqlite3.c"
         if (!($79)) {
          break;
         }
         $80 = HEAP32[$77>>2]|0;
         $81 = (((((($1)) + 4|0) + (($$1140153*20)|0)|0)) + 4|0);
         $82 = HEAP32[$81>>2]|0;
         $$0132149 = 0;
         while(1) {
          $83 = (($80) + ($$0132149<<4)|0); //@line 104309 "c/sqlite3.c"
          $84 = HEAP32[$83>>2]|0; //@line 104309 "c/sqlite3.c"
          $85 = (_sqlite3StrICmp($84,$82)|0); //@line 104309 "c/sqlite3.c"
          $86 = ($85|0)==(0); //@line 104309 "c/sqlite3.c"
          if ($86) {
           break;
          }
          $87 = (($$0132149) + 1)|0; //@line 104308 "c/sqlite3.c"
          $88 = HEAP16[$76>>1]|0; //@line 104308 "c/sqlite3.c"
          $89 = $88 << 16 >> 16; //@line 104308 "c/sqlite3.c"
          $90 = ($87|0)<($89|0); //@line 104308 "c/sqlite3.c"
          if ($90) {
           $$0132149 = $87;
          } else {
           break L29;
          }
         }
         $93 = (($59) + ($$1140153<<3)|0); //@line 104310 "c/sqlite3.c"
         HEAP32[$93>>2] = $$0132149; //@line 104310 "c/sqlite3.c"
         $94 = (($$1140153) + 1)|0; //@line 104306 "c/sqlite3.c"
         $95 = ($94|0)<($$1138164|0); //@line 104306 "c/sqlite3.c"
         if ($95) {
          $$1140153 = $94;
         } else {
          label = 28;
          break L25;
         }
        }
        $91 = (((((($1)) + 4|0) + (($$1140153*20)|0)|0)) + 4|0); //@line 104317 "c/sqlite3.c"
        $92 = HEAP32[$91>>2]|0; //@line 104317 "c/sqlite3.c"
        HEAP32[$vararg_buffer4>>2] = $92; //@line 104315 "c/sqlite3.c"
        _sqlite3ErrorMsg($0,29127,$vararg_buffer4); //@line 104315 "c/sqlite3.c"
        $121 = $54;
        break L1;
       }
      }
     } while(0);
     if ((label|0) == 28) {
      $96 = ($$1138164|0)>(0); //@line 104323 "c/sqlite3.c"
      $or$cond = $97 & $96; //@line 104322 "c/sqlite3.c"
      if ($or$cond) {
       $$0136148 = $69;$$2147 = 0;
       while(1) {
        $98 = (((((($3)) + 4|0) + (($$2147*20)|0)|0)) + 4|0); //@line 104324 "c/sqlite3.c"
        $99 = HEAP32[$98>>2]|0; //@line 104324 "c/sqlite3.c"
        $100 = (_sqlite3Strlen30($99)|0); //@line 104324 "c/sqlite3.c"
        $101 = (((($59) + ($$2147<<3)|0)) + 4|0); //@line 104325 "c/sqlite3.c"
        HEAP32[$101>>2] = $$0136148; //@line 104325 "c/sqlite3.c"
        _memcpy(($$0136148|0),($99|0),($100|0))|0; //@line 104326 "c/sqlite3.c"
        $102 = (($$0136148) + ($100)|0); //@line 104327 "c/sqlite3.c"
        HEAP8[$102>>0] = 0; //@line 104327 "c/sqlite3.c"
        $103 = (($100) + 1)|0; //@line 104328 "c/sqlite3.c"
        $104 = (($$0136148) + ($103)|0); //@line 104328 "c/sqlite3.c"
        $105 = (($$2147) + 1)|0; //@line 104323 "c/sqlite3.c"
        $exitcond = ($105|0)==($$1138164|0); //@line 104323 "c/sqlite3.c"
        if ($exitcond) {
         break;
        } else {
         $$0136148 = $104;$$2147 = $105;
        }
       }
      }
     }
     $106 = ((($54)) + 24|0); //@line 104331 "c/sqlite3.c"
     HEAP8[$106>>0] = 0; //@line 104331 "c/sqlite3.c"
     $107 = $4&255; //@line 104332 "c/sqlite3.c"
     $108 = ((($54)) + 25|0); //@line 104332 "c/sqlite3.c"
     HEAP8[$108>>0] = $107; //@line 104332 "c/sqlite3.c"
     $109 = $4 >>> 8; //@line 104333 "c/sqlite3.c"
     $110 = $109&255; //@line 104333 "c/sqlite3.c"
     $111 = ((($54)) + 26|0); //@line 104333 "c/sqlite3.c"
     HEAP8[$111>>0] = $110; //@line 104333 "c/sqlite3.c"
     $112 = ((($7)) + 72|0); //@line 104336 "c/sqlite3.c"
     $113 = HEAP32[$112>>2]|0; //@line 104336 "c/sqlite3.c"
     $114 = ((($113)) + 56|0); //@line 104336 "c/sqlite3.c"
     $115 = HEAP32[$61>>2]|0; //@line 104337 "c/sqlite3.c"
     $116 = (_sqlite3HashInsert($114,$115,$54)|0); //@line 104336 "c/sqlite3.c"
     $117 = ($116|0)==($54|0); //@line 104339 "c/sqlite3.c"
     if ($117) {
      _sqlite3OomFault($5); //@line 104340 "c/sqlite3.c"
      $121 = $54;
      break;
     }
     $118 = ($116|0)==(0|0); //@line 104343 "c/sqlite3.c"
     if (!($118)) {
      $119 = ((($54)) + 12|0); //@line 104345 "c/sqlite3.c"
      HEAP32[$119>>2] = $116; //@line 104345 "c/sqlite3.c"
      $120 = ((($116)) + 16|0); //@line 104346 "c/sqlite3.c"
      HEAP32[$120>>2] = $54; //@line 104346 "c/sqlite3.c"
     }
     HEAP32[$56>>2] = $54; //@line 104351 "c/sqlite3.c"
     $121 = 0;
    }
   } else {
    $121 = 0;
   }
  }
 } while(0);
 _sqlite3DbFree($5,$121); //@line 104355 "c/sqlite3.c"
 _sqlite3ExprListDelete($5,$1); //@line 104357 "c/sqlite3.c"
 _sqlite3ExprListDelete($5,$3); //@line 104358 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 104359 "c/sqlite3.c"
}
function _sqlite3DeferForeignKey($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 432|0); //@line 104372 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 104372 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 104372 "c/sqlite3.c"
 if ($4) {
  return; //@line 104376 "c/sqlite3.c"
 }
 $5 = ((($3)) + 16|0); //@line 104372 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 104372 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 104372 "c/sqlite3.c"
 if ($7) {
  return; //@line 104376 "c/sqlite3.c"
 }
 $8 = $1&255; //@line 104374 "c/sqlite3.c"
 $9 = ((($6)) + 24|0); //@line 104374 "c/sqlite3.c"
 HEAP8[$9>>0] = $8; //@line 104374 "c/sqlite3.c"
 return; //@line 104376 "c/sqlite3.c"
}
function _sqlite3AddCollateType($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$032 = 0, $$033 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 432|0); //@line 103018 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 103018 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 103018 "c/sqlite3.c"
 if ($4) {
  return; //@line 103042 "c/sqlite3.c"
 }
 $5 = ((($3)) + 42|0); //@line 103019 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 103019 "c/sqlite3.c"
 $7 = $6 << 16 >> 16; //@line 103019 "c/sqlite3.c"
 $8 = (($7) + -1)|0; //@line 103019 "c/sqlite3.c"
 $9 = HEAP32[$0>>2]|0; //@line 103020 "c/sqlite3.c"
 $10 = (_sqlite3NameFromToken($9,$1)|0); //@line 103021 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 103022 "c/sqlite3.c"
 if ($11) {
  return; //@line 103042 "c/sqlite3.c"
 }
 $12 = (_sqlite3LocateCollSeq($0,$10)|0); //@line 103024 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 103024 "c/sqlite3.c"
 if ($13) {
  _sqlite3DbFree($9,$10); //@line 103040 "c/sqlite3.c"
  return; //@line 103042 "c/sqlite3.c"
 }
 $14 = ((($3)) + 4|0); //@line 103026 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 103026 "c/sqlite3.c"
 $16 = (((($15) + ($8<<4)|0)) + 8|0); //@line 103026 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 103026 "c/sqlite3.c"
 _sqlite3DbFree($9,$17); //@line 103026 "c/sqlite3.c"
 $18 = HEAP32[$14>>2]|0; //@line 103027 "c/sqlite3.c"
 $19 = (((($18) + ($8<<4)|0)) + 8|0); //@line 103027 "c/sqlite3.c"
 HEAP32[$19>>2] = $10; //@line 103027 "c/sqlite3.c"
 $20 = ((($3)) + 8|0); //@line 103033 "c/sqlite3.c"
 $$032 = HEAP32[$20>>2]|0;
 $21 = ($$032|0)==(0|0); //@line 103033 "c/sqlite3.c"
 if ($21) {
  return; //@line 103042 "c/sqlite3.c"
 }
 $$033 = $$032;
 while(1) {
  $22 = ((($$033)) + 4|0); //@line 103035 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 103035 "c/sqlite3.c"
  $24 = HEAP16[$23>>1]|0; //@line 103035 "c/sqlite3.c"
  $25 = $24 << 16 >> 16; //@line 103035 "c/sqlite3.c"
  $26 = ($8|0)==($25|0); //@line 103035 "c/sqlite3.c"
  if ($26) {
   $27 = HEAP32[$14>>2]|0; //@line 103036 "c/sqlite3.c"
   $28 = (((($27) + ($8<<4)|0)) + 8|0); //@line 103036 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 103036 "c/sqlite3.c"
   $30 = ((($$033)) + 32|0); //@line 103036 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 103036 "c/sqlite3.c"
   HEAP32[$31>>2] = $29; //@line 103036 "c/sqlite3.c"
  }
  $32 = ((($$033)) + 20|0); //@line 103033 "c/sqlite3.c"
  $$0 = HEAP32[$32>>2]|0;
  $33 = ($$0|0)==(0|0); //@line 103033 "c/sqlite3.c"
  if ($33) {
   break;
  } else {
   $$033 = $$0;
  }
 }
 return; //@line 103042 "c/sqlite3.c"
}
function _sqlite3DropTable($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$ = 0, $$082 = 0, $$083 = 0, $$84 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer4 = sp + 16|0; //@line 104131 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 104131 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 104131 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 104134 "c/sqlite3.c"
 $5 = ((($4)) + 73|0); //@line 104137 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 104137 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 104137 "c/sqlite3.c"
 do {
  if ($7) {
   $8 = (_sqlite3ReadSchema($0)|0); //@line 104142 "c/sqlite3.c"
   $9 = ($8|0)==(0); //@line 104142 "c/sqlite3.c"
   if ($9) {
    $10 = ($3|0)!=(0); //@line 104143 "c/sqlite3.c"
    if ($10) {
     $13 = ((($4)) + 77|0); //@line 104143 "c/sqlite3.c"
     $14 = HEAP8[$13>>0]|0; //@line 104143 "c/sqlite3.c"
     $15 = (($14) + 1)<<24>>24; //@line 104143 "c/sqlite3.c"
     HEAP8[$13>>0] = $15; //@line 104143 "c/sqlite3.c"
     $16 = ((($1)) + 8|0); //@line 104145 "c/sqlite3.c"
     $17 = (_sqlite3LocateTableItem($0,$2,$16)|0); //@line 104145 "c/sqlite3.c"
     $18 = ((($4)) + 77|0); //@line 104146 "c/sqlite3.c"
     $19 = HEAP8[$18>>0]|0; //@line 104146 "c/sqlite3.c"
     $20 = (($19) + -1)<<24>>24; //@line 104146 "c/sqlite3.c"
     HEAP8[$18>>0] = $20; //@line 104146 "c/sqlite3.c"
     $22 = $17;
    } else {
     $11 = ((($1)) + 8|0); //@line 104145 "c/sqlite3.c"
     $12 = (_sqlite3LocateTableItem($0,$2,$11)|0); //@line 104145 "c/sqlite3.c"
     $22 = $12;
    }
    $21 = ($22|0)==(0|0); //@line 104148 "c/sqlite3.c"
    if ($21) {
     if (!($10)) {
      break;
     }
     $23 = ((($1)) + 12|0); //@line 104149 "c/sqlite3.c"
     $24 = HEAP32[$23>>2]|0; //@line 104149 "c/sqlite3.c"
     _sqlite3CodeVerifyNamedSchema($0,$24); //@line 104149 "c/sqlite3.c"
     break;
    }
    $25 = ((($22)) + 72|0); //@line 104152 "c/sqlite3.c"
    $26 = HEAP32[$25>>2]|0; //@line 104152 "c/sqlite3.c"
    $27 = (_sqlite3SchemaToIndex($4,$26)|0); //@line 104152 "c/sqlite3.c"
    $28 = ((($22)) + 56|0); //@line 104158 "c/sqlite3.c"
    $29 = HEAP32[$28>>2]|0; //@line 104158 "c/sqlite3.c"
    $30 = ($29|0)==(0); //@line 104158 "c/sqlite3.c"
    if (!($30)) {
     $31 = (_sqlite3ViewGetColumnNames($0,$22)|0); //@line 104158 "c/sqlite3.c"
     $32 = ($31|0)==(0); //@line 104158 "c/sqlite3.c"
     if (!($32)) {
      break;
     }
    }
    $33 = ($27|0)==(1); //@line 104164 "c/sqlite3.c"
    $34 = $33 ? 21366 : 19754; //@line 104164 "c/sqlite3.c"
    $35 = ((($4)) + 16|0); //@line 104165 "c/sqlite3.c"
    $36 = HEAP32[$35>>2]|0; //@line 104165 "c/sqlite3.c"
    $37 = (($36) + ($27<<4)|0); //@line 104165 "c/sqlite3.c"
    $38 = HEAP32[$37>>2]|0; //@line 104165 "c/sqlite3.c"
    $39 = (_sqlite3AuthCheck($0,9,$34,0,$38)|0); //@line 104167 "c/sqlite3.c"
    $40 = ($39|0)==(0); //@line 104167 "c/sqlite3.c"
    if ($40) {
     $41 = ($2|0)==(0); //@line 104170 "c/sqlite3.c"
     do {
      if ($41) {
       $42 = HEAP32[$28>>2]|0; //@line 104177 "c/sqlite3.c"
       $43 = ($42|0)==(0); //@line 104177 "c/sqlite3.c"
       if ($43) {
        $$84 = $33 ? 13 : 11; //@line 104184 "c/sqlite3.c"
        $$082 = 0;$$083 = $$84;
        break;
       } else {
        $44 = (_sqlite3GetVTable($4,$22)|0); //@line 104179 "c/sqlite3.c"
        $45 = ((($44)) + 4|0); //@line 104179 "c/sqlite3.c"
        $46 = HEAP32[$45>>2]|0; //@line 104179 "c/sqlite3.c"
        $47 = ((($46)) + 4|0); //@line 104179 "c/sqlite3.c"
        $48 = HEAP32[$47>>2]|0; //@line 104179 "c/sqlite3.c"
        $$082 = $48;$$083 = 30;
        break;
       }
      } else {
       $$ = $33 ? 15 : 17; //@line 104173 "c/sqlite3.c"
       $$082 = 0;$$083 = $$;
      }
     } while(0);
     $49 = HEAP32[$22>>2]|0; //@line 104188 "c/sqlite3.c"
     $50 = (_sqlite3AuthCheck($0,$$083,$49,$$082,$38)|0); //@line 104188 "c/sqlite3.c"
     $51 = ($50|0)==(0); //@line 104188 "c/sqlite3.c"
     if ($51) {
      $52 = HEAP32[$22>>2]|0; //@line 104191 "c/sqlite3.c"
      $53 = (_sqlite3AuthCheck($0,9,$52,0,$38)|0); //@line 104191 "c/sqlite3.c"
      $54 = ($53|0)==(0); //@line 104191 "c/sqlite3.c"
      if ($54) {
       $55 = HEAP32[$22>>2]|0; //@line 104196 "c/sqlite3.c"
       $56 = (_sqlite3_strnicmp($55,19990,7)|0); //@line 104196 "c/sqlite3.c"
       $57 = ($56|0)==(0); //@line 104196 "c/sqlite3.c"
       if ($57) {
        $58 = (_sqlite3_strnicmp($55,28763,11)|0); //@line 104197 "c/sqlite3.c"
        $59 = ($58|0)==(0); //@line 104197 "c/sqlite3.c"
        if (!($59)) {
         HEAP32[$vararg_buffer>>2] = $55; //@line 104198 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,28775,$vararg_buffer); //@line 104198 "c/sqlite3.c"
         break;
        }
       }
       $60 = ($2|0)==(0); //@line 104206 "c/sqlite3.c"
       $61 = ((($22)) + 12|0);
       $62 = HEAP32[$61>>2]|0;
       $63 = ($62|0)==(0|0);
       if ($60) {
        if (!($63)) {
         HEAP32[$vararg_buffer4>>2] = $55; //@line 104211 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,28837,$vararg_buffer4); //@line 104211 "c/sqlite3.c"
         break;
        }
       } else {
        if ($63) {
         HEAP32[$vararg_buffer1>>2] = $55; //@line 104207 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,28803,$vararg_buffer1); //@line 104207 "c/sqlite3.c"
         break;
        }
       }
       $64 = (_sqlite3GetVdbe($0)|0); //@line 104219 "c/sqlite3.c"
       $65 = ($64|0)==(0|0); //@line 104220 "c/sqlite3.c"
       if (!($65)) {
        _sqlite3BeginWriteOperation($0,1,$27); //@line 104221 "c/sqlite3.c"
        $66 = HEAP32[$22>>2]|0; //@line 104222 "c/sqlite3.c"
        _sqlite3ClearStatTables($0,$27,20323,$66); //@line 104222 "c/sqlite3.c"
        _sqlite3FkDropTable($0,$1,$22); //@line 104223 "c/sqlite3.c"
        _sqlite3CodeDropTable($0,$22,$27,$2); //@line 104224 "c/sqlite3.c"
       }
      }
     }
    }
   }
  }
 } while(0);
 _sqlite3SrcListDelete($4,$1); //@line 104228 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 104229 "c/sqlite3.c"
}
function _sqlite3CreateView($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer = sp + 8|0;
 $8 = sp;
 $9 = sp + 16|0;
 $10 = sp + 12|0;
 HEAP32[$10>>2] = 0; //@line 103716 "c/sqlite3.c"
 $11 = HEAP32[$0>>2]|0; //@line 103718 "c/sqlite3.c"
 $12 = ((($0)) + 396|0); //@line 103720 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 103720 "c/sqlite3.c"
 $14 = ($13<<16>>16)>(0); //@line 103720 "c/sqlite3.c"
 if ($14) {
  _sqlite3ErrorMsg($0,28722,$vararg_buffer); //@line 103721 "c/sqlite3.c"
 } else {
  _sqlite3StartTable($0,$2,$3,$6,1,0,$7); //@line 103724 "c/sqlite3.c"
  $15 = ((($0)) + 432|0); //@line 103725 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 103725 "c/sqlite3.c"
  $17 = ($16|0)==(0|0); //@line 103726 "c/sqlite3.c"
  if (!($17)) {
   $18 = ((($0)) + 36|0); //@line 103726 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 103726 "c/sqlite3.c"
   $20 = ($19|0)==(0); //@line 103726 "c/sqlite3.c"
   if ($20) {
    (_sqlite3TwoPartName($0,$2,$3,$10)|0); //@line 103727 "c/sqlite3.c"
    $21 = ((($16)) + 72|0); //@line 103728 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 103728 "c/sqlite3.c"
    $23 = (_sqlite3SchemaToIndex($11,$22)|0); //@line 103728 "c/sqlite3.c"
    $24 = HEAP32[$10>>2]|0; //@line 103729 "c/sqlite3.c"
    _sqlite3FixInit($9,$0,$23,28758,$24); //@line 103729 "c/sqlite3.c"
    $25 = (_sqlite3FixSelect($9,$5)|0); //@line 103730 "c/sqlite3.c"
    $26 = ($25|0)==(0); //@line 103730 "c/sqlite3.c"
    if ($26) {
     $27 = (_sqlite3SelectDup($11,$5,1)|0); //@line 103737 "c/sqlite3.c"
     $28 = ((($16)) + 12|0); //@line 103737 "c/sqlite3.c"
     HEAP32[$28>>2] = $27; //@line 103737 "c/sqlite3.c"
     $29 = (_sqlite3ExprListDup($11,$4,1)|0); //@line 103738 "c/sqlite3.c"
     $30 = ((($16)) + 24|0); //@line 103738 "c/sqlite3.c"
     HEAP32[$30>>2] = $29; //@line 103738 "c/sqlite3.c"
     $31 = ((($11)) + 73|0); //@line 103739 "c/sqlite3.c"
     $32 = HEAP8[$31>>0]|0; //@line 103739 "c/sqlite3.c"
     $33 = ($32<<24>>24)==(0); //@line 103739 "c/sqlite3.c"
     if ($33) {
      $34 = ((($0)) + 388|0); //@line 103744 "c/sqlite3.c"
      $35 = $34; //@line 103744 "c/sqlite3.c"
      $36 = $35; //@line 103744 "c/sqlite3.c"
      $37 = HEAP32[$36>>2]|0; //@line 103744 "c/sqlite3.c"
      $38 = (($35) + 4)|0; //@line 103744 "c/sqlite3.c"
      $39 = $38; //@line 103744 "c/sqlite3.c"
      $40 = HEAP32[$39>>2]|0; //@line 103744 "c/sqlite3.c"
      $41 = $8; //@line 103744 "c/sqlite3.c"
      $42 = $41; //@line 103744 "c/sqlite3.c"
      HEAP32[$42>>2] = $37; //@line 103744 "c/sqlite3.c"
      $43 = (($41) + 4)|0; //@line 103744 "c/sqlite3.c"
      $44 = $43; //@line 103744 "c/sqlite3.c"
      HEAP32[$44>>2] = $40; //@line 103744 "c/sqlite3.c"
      $45 = HEAP32[$8>>2]|0; //@line 103746 "c/sqlite3.c"
      $46 = HEAP8[$45>>0]|0; //@line 103746 "c/sqlite3.c"
      $47 = ($46<<24>>24)==(59); //@line 103746 "c/sqlite3.c"
      if (!($47)) {
       $48 = ((($8)) + 4|0); //@line 103747 "c/sqlite3.c"
       $49 = HEAP32[$48>>2]|0; //@line 103747 "c/sqlite3.c"
       $50 = (($45) + ($49)|0); //@line 103747 "c/sqlite3.c"
       HEAP32[$8>>2] = $50; //@line 103747 "c/sqlite3.c"
      }
      $51 = ((($8)) + 4|0); //@line 103749 "c/sqlite3.c"
      HEAP32[$51>>2] = 0; //@line 103749 "c/sqlite3.c"
      $52 = HEAP32[$8>>2]|0; //@line 103750 "c/sqlite3.c"
      $53 = HEAP32[$1>>2]|0; //@line 103750 "c/sqlite3.c"
      $54 = $53; //@line 103750 "c/sqlite3.c"
      $55 = (($52) - ($54))|0; //@line 103750 "c/sqlite3.c"
      $$0 = $55;
      while(1) {
       $56 = (($$0) + -1)|0; //@line 103753 "c/sqlite3.c"
       $57 = (($53) + ($56)|0); //@line 103753 "c/sqlite3.c"
       $58 = HEAP8[$57>>0]|0; //@line 103753 "c/sqlite3.c"
       $59 = $58&255; //@line 103753 "c/sqlite3.c"
       $60 = (16281 + ($59)|0); //@line 103753 "c/sqlite3.c"
       $61 = HEAP8[$60>>0]|0; //@line 103753 "c/sqlite3.c"
       $62 = $61 & 1; //@line 103753 "c/sqlite3.c"
       $63 = ($62<<24>>24)==(0); //@line 103753 "c/sqlite3.c"
       if ($63) {
        break;
       } else {
        $$0 = $56;
       }
      }
      $64 = (($53) + ($56)|0); //@line 103753 "c/sqlite3.c"
      HEAP32[$8>>2] = $64; //@line 103754 "c/sqlite3.c"
      HEAP32[$51>>2] = 1; //@line 103755 "c/sqlite3.c"
      _sqlite3EndTable($0,0,$8,0,0); //@line 103758 "c/sqlite3.c"
     }
    }
   }
  }
 }
 _sqlite3SelectDelete($11,$5); //@line 103761 "c/sqlite3.c"
 _sqlite3ExprListDelete($11,$4); //@line 103762 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 103764 "c/sqlite3.c"
}
function _sqlite3Select($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0643 = 0, $$0645 = 0, $$0645716 = 0, $$0645718 = 0, $$0646 = 0, $$0647745 = 0, $$0650710 = 0, $$0655744 = 0, $$0657$lcssa = 0, $$0657709 = 0, $$0659 = 0, $$0661 = 0, $$0661$ph = 0, $$0662 = 0, $$0663 = 0, $$0670 = 0, $$0671 = 0, $$0672 = 0, $$0673 = 0, $$0675734 = 0;
 var $$0677733 = 0, $$1$lcssa = 0, $$1651 = 0, $$1656$ph = 0, $$1658 = 0, $$1660 = 0, $$1676729 = 0, $$1678728 = 0, $$1717 = 0, $$2 = 0, $$2649$ph = 0, $$2652704 = 0, $$3653 = 0, $$3738 = 0, $$4654703 = 0, $$4724 = 0, $$5711 = 0, $$6705 = 0, $$lcssa = 0, $$lobit = 0;
 var $$pr = 0, $$sink = 0, $$sink784 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0;
 var $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0;
 var $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0;
 var $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0;
 var $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0;
 var $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0;
 var $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0;
 var $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0;
 var $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0;
 var $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0;
 var $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0;
 var $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0;
 var $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0;
 var $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0;
 var $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0;
 var $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0;
 var $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0;
 var $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0;
 var $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0;
 var $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0;
 var $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0;
 var $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0;
 var $567 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $not$ = 0, $not$692 = 0, $or$cond = 0, $or$cond4 = 0, $or$cond681 = 0, $phitmp = 0, $phitmp679 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, dest = 0;
 var label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 160|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(160|0);
 $vararg_buffer = sp;
 $3 = sp + 136|0;
 $4 = sp + 104|0;
 $5 = sp + 56|0;
 $6 = sp + 48|0;
 $7 = sp + 16|0;
 HEAP32[$6>>2] = 0; //@line 123813 "c/sqlite3.c"
 $8 = ((($0)) + 412|0); //@line 123817 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 123817 "c/sqlite3.c"
 $10 = ((($0)) + 416|0); //@line 123818 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 123818 "c/sqlite3.c"
 $12 = (($11) + 1)|0; //@line 123818 "c/sqlite3.c"
 HEAP32[$10>>2] = $12; //@line 123818 "c/sqlite3.c"
 HEAP32[$8>>2] = $11; //@line 123818 "c/sqlite3.c"
 $13 = HEAP32[$0>>2]|0; //@line 123821 "c/sqlite3.c"
 $14 = ($1|0)==(0|0); //@line 123822 "c/sqlite3.c"
 if ($14) {
  $$0646 = 1;
  STACKTOP = sp;return ($$0646|0); //@line 124734 "c/sqlite3.c"
 }
 $15 = ((($13)) + 73|0); //@line 123822 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 123822 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 123822 "c/sqlite3.c"
 if (!($17)) {
  $$0646 = 1;
  STACKTOP = sp;return ($$0646|0); //@line 124734 "c/sqlite3.c"
 }
 $18 = ((($0)) + 36|0); //@line 123822 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 123822 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 123822 "c/sqlite3.c"
 if (!($20)) {
  $$0646 = 1;
  STACKTOP = sp;return ($$0646|0); //@line 124734 "c/sqlite3.c"
 }
 $21 = (_sqlite3AuthCheck($0,21,0,0,0)|0); //@line 123825 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 123825 "c/sqlite3.c"
 if (!($22)) {
  $$0646 = 1;
  STACKTOP = sp;return ($$0646|0); //@line 124734 "c/sqlite3.c"
 }
 dest=$5; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 123826 "c/sqlite3.c"
 $23 = HEAP8[$2>>0]|0; //@line 123839 "c/sqlite3.c"
 $24 = ($23&255)<(9); //@line 123839 "c/sqlite3.c"
 if ($24) {
  $25 = ((($1)) + 44|0); //@line 123846 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 123846 "c/sqlite3.c"
  _sqlite3ExprListDelete($13,$26); //@line 123846 "c/sqlite3.c"
  HEAP32[$25>>2] = 0; //@line 123847 "c/sqlite3.c"
  $27 = ((($1)) + 8|0); //@line 123848 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 123848 "c/sqlite3.c"
  $29 = $28 & -2; //@line 123848 "c/sqlite3.c"
  HEAP32[$27>>2] = $29; //@line 123848 "c/sqlite3.c"
 }
 _sqlite3SelectPrep($0,$1,0); //@line 123850 "c/sqlite3.c"
 $30 = ((($4)) + 4|0);
 ;HEAP32[$30>>2]=0|0;HEAP32[$30+4>>2]=0|0;HEAP32[$30+8>>2]=0|0;HEAP32[$30+12>>2]=0|0;HEAP32[$30+16>>2]=0|0;HEAP32[$30+20>>2]=0|0;HEAP32[$30+24>>2]=0|0; //@line 123851 "c/sqlite3.c"
 $31 = ((($1)) + 44|0); //@line 123852 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 123852 "c/sqlite3.c"
 HEAP32[$4>>2] = $32; //@line 123852 "c/sqlite3.c"
 $33 = ((($1)) + 28|0); //@line 123853 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 123853 "c/sqlite3.c"
 $35 = HEAP32[$18>>2]|0; //@line 123854 "c/sqlite3.c"
 $36 = ($35|0)==(0); //@line 123854 "c/sqlite3.c"
 L16: do {
  if ($36) {
   $37 = HEAP8[$15>>0]|0; //@line 123854 "c/sqlite3.c"
   $38 = ($37<<24>>24)==(0); //@line 123854 "c/sqlite3.c"
   if ($38) {
    $39 = ((($1)) + 8|0); //@line 123858 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 123858 "c/sqlite3.c"
    $41 = $40 >>> 3; //@line 123858 "c/sqlite3.c"
    $$lobit = $41 & 1; //@line 123858 "c/sqlite3.c"
    $42 = (_sqlite3GetVdbe($0)|0); //@line 123868 "c/sqlite3.c"
    $43 = ($42|0)==(0|0); //@line 123869 "c/sqlite3.c"
    if ($43) {
     $$0662 = 1;
    } else {
     $44 = HEAP8[$2>>0]|0; //@line 123870 "c/sqlite3.c"
     $45 = ($44<<24>>24)==(9); //@line 123870 "c/sqlite3.c"
     if ($45) {
      _generateColumnNames($0,$1); //@line 123871 "c/sqlite3.c"
     }
     $46 = ((($1)) + 48|0); //@line 123877 "c/sqlite3.c"
     $47 = HEAP32[$46>>2]|0; //@line 123877 "c/sqlite3.c"
     $48 = ($47|0)==(0|0); //@line 123877 "c/sqlite3.c"
     L23: do {
      if ($48) {
       $$0647745 = 0;$$0655744 = $34;
       L25: while(1) {
        $49 = HEAP32[$$0655744>>2]|0; //@line 123877 "c/sqlite3.c"
        $50 = ($$0647745|0)<($49|0); //@line 123877 "c/sqlite3.c"
        if (!($50)) {
         break;
        }
        $51 = (((((($$0655744)) + 8|0) + (($$0647745*72)|0)|0)) + 20|0); //@line 123879 "c/sqlite3.c"
        $52 = HEAP32[$51>>2]|0; //@line 123879 "c/sqlite3.c"
        $53 = (((((($$0655744)) + 8|0) + (($$0647745*72)|0)|0)) + 16|0); //@line 123880 "c/sqlite3.c"
        $54 = HEAP32[$53>>2]|0; //@line 123880 "c/sqlite3.c"
        $55 = ($52|0)==(0|0); //@line 123881 "c/sqlite3.c"
        L28: do {
         if ($55) {
          $$1656$ph = $$0655744;$$2649$ph = $$0647745;
         } else {
          $56 = ((($54)) + 42|0); //@line 123885 "c/sqlite3.c"
          $57 = HEAP16[$56>>1]|0; //@line 123885 "c/sqlite3.c"
          $58 = $57 << 16 >> 16; //@line 123885 "c/sqlite3.c"
          $59 = HEAP32[$52>>2]|0; //@line 123885 "c/sqlite3.c"
          $60 = HEAP32[$59>>2]|0; //@line 123885 "c/sqlite3.c"
          $61 = ($60|0)==($58|0); //@line 123885 "c/sqlite3.c"
          if (!($61)) {
           label = 17;
           break L25;
          }
          $64 = ((($52)) + 8|0); //@line 123898 "c/sqlite3.c"
          $65 = HEAP32[$64>>2]|0; //@line 123898 "c/sqlite3.c"
          $66 = $65 & 8; //@line 123898 "c/sqlite3.c"
          $67 = ($66|0)==(0); //@line 123898 "c/sqlite3.c"
          if ($67) {
           $68 = ((($52)) + 44|0); //@line 123919 "c/sqlite3.c"
           $69 = HEAP32[$68>>2]|0; //@line 123919 "c/sqlite3.c"
           $70 = ($69|0)!=(0|0); //@line 123919 "c/sqlite3.c"
           $71 = ($$0647745|0)==(0); //@line 123920 "c/sqlite3.c"
           $or$cond = $71 & $70; //@line 123920 "c/sqlite3.c"
           do {
            if ($or$cond) {
             $72 = HEAP32[$39>>2]|0; //@line 123921 "c/sqlite3.c"
             $73 = $72 & 262144; //@line 123921 "c/sqlite3.c"
             $74 = ($73|0)==(0); //@line 123921 "c/sqlite3.c"
             if ($74) {
              break;
             }
             $75 = ($49|0)==(1); //@line 123922 "c/sqlite3.c"
             if ($75) {
              $$1656$ph = $$0655744;$$2649$ph = 0;
              break L28;
             }
             $76 = ((($$0655744)) + 116|0); //@line 123923 "c/sqlite3.c"
             $77 = HEAP8[$76>>0]|0; //@line 123923 "c/sqlite3.c"
             $78 = $77 & 10; //@line 123923 "c/sqlite3.c"
             $79 = ($78<<24>>24)==(0); //@line 123923 "c/sqlite3.c"
             if (!($79)) {
              $$1656$ph = $$0655744;$$2649$ph = 0;
              break L28;
             }
            }
           } while(0);
           $80 = (_flattenSubquery($0,$1,$$0647745,$$lobit)|0); //@line 123928 "c/sqlite3.c"
           $81 = ($80|0)==(0); //@line 123928 "c/sqlite3.c"
           $spec$select = $81 ? $$0647745 : -1; //@line 123928 "c/sqlite3.c"
           $82 = HEAP32[$33>>2]|0; //@line 123932 "c/sqlite3.c"
           $83 = HEAP8[$15>>0]|0; //@line 123933 "c/sqlite3.c"
           $84 = ($83<<24>>24)==(0); //@line 123933 "c/sqlite3.c"
           if (!($84)) {
            $$0662 = 1;
            break L16;
           }
           $85 = HEAP8[$2>>0]|0; //@line 123934 "c/sqlite3.c"
           $86 = ($85&255)<(9); //@line 123934 "c/sqlite3.c"
           if ($86) {
            $$1656$ph = $82;$$2649$ph = $spec$select;
            break;
           }
           $87 = HEAP32[$31>>2]|0; //@line 123935 "c/sqlite3.c"
           HEAP32[$4>>2] = $87; //@line 123935 "c/sqlite3.c"
           $$1656$ph = $82;$$2649$ph = $spec$select;
          } else {
           $$1656$ph = $$0655744;$$2649$ph = $$0647745;
          }
         }
        } while(0);
        $88 = (($$2649$ph) + 1)|0; //@line 123877 "c/sqlite3.c"
        $89 = HEAP32[$46>>2]|0; //@line 123877 "c/sqlite3.c"
        $90 = ($89|0)==(0|0); //@line 123877 "c/sqlite3.c"
        if ($90) {
         $$0647745 = $88;$$0655744 = $$1656$ph;
        } else {
         break L23;
        }
       }
       if ((label|0) == 17) {
        $62 = $57 << 16 >> 16; //@line 123885 "c/sqlite3.c"
        $63 = HEAP32[$54>>2]|0; //@line 123887 "c/sqlite3.c"
        HEAP32[$vararg_buffer>>2] = $62; //@line 123886 "c/sqlite3.c"
        $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 123886 "c/sqlite3.c"
        HEAP32[$vararg_ptr1>>2] = $63; //@line 123886 "c/sqlite3.c"
        $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 123886 "c/sqlite3.c"
        HEAP32[$vararg_ptr2>>2] = $60; //@line 123886 "c/sqlite3.c"
        _sqlite3ErrorMsg($0,28371,$vararg_buffer); //@line 123886 "c/sqlite3.c"
        $$0662 = 1;
        break L16;
       }
       $92 = HEAP32[$$0655744>>2]|0; //@line 123959 "c/sqlite3.c"
       $93 = ($92|0)>(0); //@line 123959 "c/sqlite3.c"
       L43: do {
        if ($93) {
         $94 = ((($0)) + 408|0);
         $95 = ((($1)) + 32|0);
         $96 = ((($0)) + 440|0);
         $97 = ((($0)) + 44|0);
         $98 = ((($0)) + 44|0);
         $99 = ((($7)) + 8|0);
         $100 = ((($$0655744)) + 116|0);
         $$3738 = 0;
         L45: while(1) {
          $101 = (((($$0655744)) + 8|0) + (($$3738*72)|0)|0); //@line 123960 "c/sqlite3.c"
          $102 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 56|0); //@line 123983 "c/sqlite3.c"
          $103 = $102; //@line 123983 "c/sqlite3.c"
          $104 = $103; //@line 123983 "c/sqlite3.c"
          $105 = HEAP32[$104>>2]|0; //@line 123983 "c/sqlite3.c"
          $106 = (($103) + 4)|0; //@line 123983 "c/sqlite3.c"
          $107 = $106; //@line 123983 "c/sqlite3.c"
          $108 = HEAP32[$107>>2]|0; //@line 123983 "c/sqlite3.c"
          $109 = ($105|0)==(0); //@line 123983 "c/sqlite3.c"
          $110 = ($108|0)==(0); //@line 123983 "c/sqlite3.c"
          $111 = $109 & $110; //@line 123983 "c/sqlite3.c"
          if ($111) {
           $112 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 4|0); //@line 123984 "c/sqlite3.c"
           $113 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 8|0); //@line 123984 "c/sqlite3.c"
           $114 = HEAP32[$113>>2]|0; //@line 123984 "c/sqlite3.c"
           $115 = HEAP32[$112>>2]|0; //@line 123984 "c/sqlite3.c"
           (_sqlite3AuthCheck($0,20,$114,41388,$115)|0); //@line 123984 "c/sqlite3.c"
          }
          $116 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 20|0); //@line 123990 "c/sqlite3.c"
          $117 = HEAP32[$116>>2]|0; //@line 123990 "c/sqlite3.c"
          $118 = ($117|0)==(0|0); //@line 123991 "c/sqlite3.c"
          do {
           if (!($118)) {
            $119 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 24|0); //@line 123999 "c/sqlite3.c"
            $120 = HEAP32[$119>>2]|0; //@line 123999 "c/sqlite3.c"
            $121 = ($120|0)==(0); //@line 123999 "c/sqlite3.c"
            if (!($121)) {
             $122 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 37|0); //@line 124000 "c/sqlite3.c"
             $123 = HEAP8[$122>>0]|0; //@line 124000 "c/sqlite3.c"
             $124 = $123 & 16; //@line 124000 "c/sqlite3.c"
             $125 = ($124<<24>>24)==(0); //@line 124000 "c/sqlite3.c"
             if (!($125)) {
              break;
             }
             $126 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 28|0); //@line 124005 "c/sqlite3.c"
             $127 = HEAP32[$126>>2]|0; //@line 124005 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($42,14,$127,$120)|0); //@line 124005 "c/sqlite3.c"
             break;
            }
            $128 = (_sqlite3SelectExprHeight($1)|0); //@line 124017 "c/sqlite3.c"
            $129 = HEAP32[$94>>2]|0; //@line 124017 "c/sqlite3.c"
            $130 = (($129) + ($128))|0; //@line 124017 "c/sqlite3.c"
            HEAP32[$94>>2] = $130; //@line 124017 "c/sqlite3.c"
            $131 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 36|0); //@line 124022 "c/sqlite3.c"
            $132 = HEAP8[$131>>0]|0; //@line 124022 "c/sqlite3.c"
            $133 = $132 & 32; //@line 124022 "c/sqlite3.c"
            $134 = ($133<<24>>24)==(0); //@line 124022 "c/sqlite3.c"
            if ($134) {
             $135 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 44|0); //@line 124023 "c/sqlite3.c"
             $136 = HEAP32[$95>>2]|0; //@line 124023 "c/sqlite3.c"
             $137 = HEAP32[$135>>2]|0; //@line 124023 "c/sqlite3.c"
             (_pushDownWhereTerms($0,$117,$136,$137)|0); //@line 124023 "c/sqlite3.c"
            }
            $138 = HEAP32[$96>>2]|0; //@line 124033 "c/sqlite3.c"
            $139 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 8|0); //@line 124034 "c/sqlite3.c"
            $140 = HEAP32[$139>>2]|0; //@line 124034 "c/sqlite3.c"
            HEAP32[$96>>2] = $140; //@line 124034 "c/sqlite3.c"
            $141 = ($$3738|0)==(0); //@line 124045 "c/sqlite3.c"
            do {
             if ($141) {
              $142 = HEAP32[$$0655744>>2]|0; //@line 124046 "c/sqlite3.c"
              $143 = ($142|0)==(1); //@line 124046 "c/sqlite3.c"
              if (!($143)) {
               $144 = HEAP8[$100>>0]|0; //@line 124047 "c/sqlite3.c"
               $145 = $144 & 10; //@line 124047 "c/sqlite3.c"
               $146 = ($145<<24>>24)==(0); //@line 124047 "c/sqlite3.c"
               if ($146) {
                label = 42;
                break;
               }
              }
              $147 = (_sqlite3VdbeCurrentAddr($42)|0); //@line 124052 "c/sqlite3.c"
              $148 = (($147) + 1)|0; //@line 124052 "c/sqlite3.c"
              $149 = HEAP32[$98>>2]|0; //@line 124054 "c/sqlite3.c"
              $150 = (($149) + 1)|0; //@line 124054 "c/sqlite3.c"
              HEAP32[$98>>2] = $150; //@line 124054 "c/sqlite3.c"
              $151 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 28|0); //@line 124054 "c/sqlite3.c"
              HEAP32[$151>>2] = $150; //@line 124054 "c/sqlite3.c"
              (_sqlite3VdbeAddOp3($42,15,$150,0,$148)|0); //@line 124055 "c/sqlite3.c"
              HEAP32[$119>>2] = $148; //@line 124057 "c/sqlite3.c"
              $152 = HEAP32[$151>>2]|0; //@line 124058 "c/sqlite3.c"
              _sqlite3SelectDestInit($7,13,$152); //@line 124058 "c/sqlite3.c"
              $153 = HEAP32[$10>>2]|0; //@line 124059 "c/sqlite3.c"
              $154 = $153&255; //@line 124059 "c/sqlite3.c"
              $155 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 40|0); //@line 124059 "c/sqlite3.c"
              HEAP8[$155>>0] = $154; //@line 124059 "c/sqlite3.c"
              (_sqlite3Select($0,$117,$7)|0); //@line 124060 "c/sqlite3.c"
              $156 = ((($117)) + 6|0); //@line 124061 "c/sqlite3.c"
              $157 = HEAP16[$156>>1]|0; //@line 124061 "c/sqlite3.c"
              $158 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 16|0); //@line 124061 "c/sqlite3.c"
              $159 = HEAP32[$158>>2]|0; //@line 124061 "c/sqlite3.c"
              $160 = ((($159)) + 44|0); //@line 124061 "c/sqlite3.c"
              HEAP16[$160>>1] = $157; //@line 124061 "c/sqlite3.c"
              $161 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 37|0); //@line 124062 "c/sqlite3.c"
              $162 = HEAP8[$161>>0]|0; //@line 124062 "c/sqlite3.c"
              $163 = $162 | 16; //@line 124062 "c/sqlite3.c"
              HEAP8[$161>>0] = $163; //@line 124062 "c/sqlite3.c"
              $164 = HEAP32[$99>>2]|0; //@line 124063 "c/sqlite3.c"
              $165 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 32|0); //@line 124063 "c/sqlite3.c"
              HEAP32[$165>>2] = $164; //@line 124063 "c/sqlite3.c"
              $166 = HEAP32[$151>>2]|0; //@line 124064 "c/sqlite3.c"
              _sqlite3VdbeEndCoroutine($42,$166); //@line 124064 "c/sqlite3.c"
              _sqlite3VdbeJumpHere($42,$147); //@line 124065 "c/sqlite3.c"
              _sqlite3ClearTempRegCache($0); //@line 124066 "c/sqlite3.c"
             } else {
              label = 42;
             }
            } while(0);
            if ((label|0) == 42) {
             label = 0;
             $167 = HEAP32[$97>>2]|0; //@line 124079 "c/sqlite3.c"
             $168 = (($167) + 1)|0; //@line 124079 "c/sqlite3.c"
             HEAP32[$97>>2] = $168; //@line 124079 "c/sqlite3.c"
             $169 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 28|0); //@line 124079 "c/sqlite3.c"
             HEAP32[$169>>2] = $168; //@line 124079 "c/sqlite3.c"
             $170 = (_sqlite3VdbeAddOp2($42,67,0,$168)|0); //@line 124080 "c/sqlite3.c"
             $171 = (($170) + 1)|0; //@line 124081 "c/sqlite3.c"
             HEAP32[$119>>2] = $171; //@line 124081 "c/sqlite3.c"
             $172 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 37|0); //@line 124082 "c/sqlite3.c"
             $173 = HEAP8[$172>>0]|0; //@line 124082 "c/sqlite3.c"
             $174 = $173 & 8; //@line 124082 "c/sqlite3.c"
             $175 = ($174<<24>>24)==(0); //@line 124082 "c/sqlite3.c"
             if ($175) {
              $176 = (_sqlite3VdbeAddOp0($42,20)|0); //@line 124086 "c/sqlite3.c"
              $$0670 = $176;
             } else {
              $$0670 = 0;
             }
             $177 = (_isSelfJoinView($$0655744,$101)|0); //@line 124091 "c/sqlite3.c"
             $178 = ($177|0)==(0|0); //@line 124092 "c/sqlite3.c"
             $179 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 44|0);
             $180 = HEAP32[$179>>2]|0;
             if ($178) {
              _sqlite3SelectDestInit($7,12,$180); //@line 124098 "c/sqlite3.c"
              $191 = HEAP32[$10>>2]|0; //@line 124099 "c/sqlite3.c"
              $192 = $191&255; //@line 124099 "c/sqlite3.c"
              $193 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 40|0); //@line 124099 "c/sqlite3.c"
              HEAP8[$193>>0] = $192; //@line 124099 "c/sqlite3.c"
              (_sqlite3Select($0,$117,$7)|0); //@line 124100 "c/sqlite3.c"
             } else {
              $181 = ((($177)) + 44|0); //@line 124093 "c/sqlite3.c"
              $182 = HEAP32[$181>>2]|0; //@line 124093 "c/sqlite3.c"
              (_sqlite3VdbeAddOp2($42,107,$180,$182)|0); //@line 124093 "c/sqlite3.c"
              $183 = ((($177)) + 40|0); //@line 124094 "c/sqlite3.c"
              $184 = HEAP8[$183>>0]|0; //@line 124094 "c/sqlite3.c"
              $185 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 40|0); //@line 124094 "c/sqlite3.c"
              HEAP8[$185>>0] = $184; //@line 124094 "c/sqlite3.c"
              $186 = ((($177)) + 20|0); //@line 124096 "c/sqlite3.c"
              $187 = HEAP32[$186>>2]|0; //@line 124096 "c/sqlite3.c"
              $188 = ((($187)) + 6|0); //@line 124096 "c/sqlite3.c"
              $189 = HEAP16[$188>>1]|0; //@line 124096 "c/sqlite3.c"
              $190 = ((($117)) + 6|0); //@line 124096 "c/sqlite3.c"
              HEAP16[$190>>1] = $189; //@line 124096 "c/sqlite3.c"
             }
             $194 = ((($117)) + 6|0); //@line 124102 "c/sqlite3.c"
             $195 = HEAP16[$194>>1]|0; //@line 124102 "c/sqlite3.c"
             $196 = (((((($$0655744)) + 8|0) + (($$3738*72)|0)|0)) + 16|0); //@line 124102 "c/sqlite3.c"
             $197 = HEAP32[$196>>2]|0; //@line 124102 "c/sqlite3.c"
             $198 = ((($197)) + 44|0); //@line 124102 "c/sqlite3.c"
             HEAP16[$198>>1] = $195; //@line 124102 "c/sqlite3.c"
             $199 = ($$0670|0)==(0); //@line 124103 "c/sqlite3.c"
             if (!($199)) {
              _sqlite3VdbeJumpHere($42,$$0670); //@line 124103 "c/sqlite3.c"
             }
             $200 = HEAP32[$169>>2]|0; //@line 124104 "c/sqlite3.c"
             $201 = (_sqlite3VdbeAddOp1($42,63,$200)|0); //@line 124104 "c/sqlite3.c"
             _sqlite3VdbeChangeP1($42,$170,$201); //@line 124106 "c/sqlite3.c"
             _sqlite3ClearTempRegCache($0); //@line 124107 "c/sqlite3.c"
            }
            $202 = HEAP8[$15>>0]|0; //@line 124109 "c/sqlite3.c"
            $203 = ($202<<24>>24)==(0); //@line 124109 "c/sqlite3.c"
            if (!($203)) {
             break L45;
            }
            $204 = (_sqlite3SelectExprHeight($1)|0); //@line 124110 "c/sqlite3.c"
            $205 = HEAP32[$94>>2]|0; //@line 124110 "c/sqlite3.c"
            $206 = (($205) - ($204))|0; //@line 124110 "c/sqlite3.c"
            HEAP32[$94>>2] = $206; //@line 124110 "c/sqlite3.c"
            HEAP32[$96>>2] = $138; //@line 124111 "c/sqlite3.c"
           }
          } while(0);
          $207 = (($$3738) + 1)|0; //@line 123959 "c/sqlite3.c"
          $208 = HEAP32[$$0655744>>2]|0; //@line 123959 "c/sqlite3.c"
          $209 = ($207|0)<($208|0); //@line 123959 "c/sqlite3.c"
          if ($209) {
           $$3738 = $207;
          } else {
           break L43;
          }
         }
         $$0662 = 1;
         break L16;
        }
       } while(0);
       $210 = HEAP32[$1>>2]|0; //@line 124117 "c/sqlite3.c"
       $211 = ((($1)) + 32|0); //@line 124118 "c/sqlite3.c"
       $212 = HEAP32[$211>>2]|0; //@line 124118 "c/sqlite3.c"
       $213 = ((($1)) + 36|0); //@line 124119 "c/sqlite3.c"
       $214 = HEAP32[$213>>2]|0; //@line 124119 "c/sqlite3.c"
       $215 = ((($1)) + 40|0); //@line 124120 "c/sqlite3.c"
       $216 = HEAP32[$215>>2]|0; //@line 124120 "c/sqlite3.c"
       $217 = HEAP32[$39>>2]|0; //@line 124121 "c/sqlite3.c"
       $218 = $217 & 1; //@line 124121 "c/sqlite3.c"
       $219 = $218&255; //@line 124121 "c/sqlite3.c"
       HEAP8[$3>>0] = $219; //@line 124121 "c/sqlite3.c"
       $220 = $217 & 9; //@line 124155 "c/sqlite3.c"
       $221 = ($220|0)==(1); //@line 124155 "c/sqlite3.c"
       if ($221) {
        $222 = HEAP32[$4>>2]|0; //@line 124156 "c/sqlite3.c"
        $223 = (_sqlite3ExprListCompare($222,$210,-1)|0); //@line 124156 "c/sqlite3.c"
        $224 = ($223|0)==(0); //@line 124156 "c/sqlite3.c"
        if ($224) {
         $225 = HEAP32[$39>>2]|0; //@line 124158 "c/sqlite3.c"
         $226 = $225 & -2; //@line 124158 "c/sqlite3.c"
         HEAP32[$39>>2] = $226; //@line 124158 "c/sqlite3.c"
         $227 = (_sqlite3ExprListDup($13,$210,0)|0); //@line 124159 "c/sqlite3.c"
         HEAP32[$213>>2] = $227; //@line 124159 "c/sqlite3.c"
         $$0661$ph = $227;
         label = 57;
        } else {
         $$0661 = $214;$229 = $222;
        }
       } else {
        $$0661$ph = $214;
        label = 57;
       }
       if ((label|0) == 57) {
        $$pr = HEAP32[$4>>2]|0; //@line 124181 "c/sqlite3.c"
        $$0661 = $$0661$ph;$229 = $$pr;
       }
       $228 = ($229|0)==(0|0); //@line 124181 "c/sqlite3.c"
       if ($228) {
        $$sink = -1;
       } else {
        $230 = HEAP32[$210>>2]|0; //@line 124183 "c/sqlite3.c"
        $231 = (_keyInfoFromExprList($0,$229,0,$230)|0); //@line 124183 "c/sqlite3.c"
        $232 = ((($0)) + 40|0); //@line 124184 "c/sqlite3.c"
        $233 = HEAP32[$232>>2]|0; //@line 124184 "c/sqlite3.c"
        $234 = (($233) + 1)|0; //@line 124184 "c/sqlite3.c"
        HEAP32[$232>>2] = $234; //@line 124184 "c/sqlite3.c"
        $235 = ((($4)) + 8|0); //@line 124184 "c/sqlite3.c"
        HEAP32[$235>>2] = $233; //@line 124184 "c/sqlite3.c"
        $236 = HEAP32[$4>>2]|0; //@line 124187 "c/sqlite3.c"
        $237 = HEAP32[$236>>2]|0; //@line 124187 "c/sqlite3.c"
        $238 = (($237) + 1)|0; //@line 124187 "c/sqlite3.c"
        $239 = HEAP32[$210>>2]|0; //@line 124187 "c/sqlite3.c"
        $240 = (($238) + ($239))|0; //@line 124187 "c/sqlite3.c"
        $241 = (_sqlite3VdbeAddOp4($42,109,$233,$240,0,$231,-9)|0); //@line 124186 "c/sqlite3.c"
        $$sink = $241;
       }
       $242 = ((($4)) + 20|0);
       HEAP32[$242>>2] = $$sink;
       $243 = HEAP8[$2>>0]|0; //@line 124196 "c/sqlite3.c"
       $244 = ($243<<24>>24)==(12); //@line 124196 "c/sqlite3.c"
       if ($244) {
        $245 = ((($2)) + 4|0); //@line 124197 "c/sqlite3.c"
        $246 = HEAP32[$245>>2]|0; //@line 124197 "c/sqlite3.c"
        $247 = HEAP32[$210>>2]|0; //@line 124197 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($42,109,$246,$247)|0); //@line 124197 "c/sqlite3.c"
       }
       $248 = (_sqlite3VdbeMakeLabel($42)|0); //@line 124202 "c/sqlite3.c"
       $249 = HEAP32[$39>>2]|0; //@line 124203 "c/sqlite3.c"
       $250 = $249 & 16384; //@line 124203 "c/sqlite3.c"
       $251 = ($250|0)==(0); //@line 124203 "c/sqlite3.c"
       if ($251) {
        $252 = ((($1)) + 6|0); //@line 124204 "c/sqlite3.c"
        HEAP16[$252>>1] = 320; //@line 124204 "c/sqlite3.c"
       }
       _computeLimitRegisters($0,$1,$248); //@line 124206 "c/sqlite3.c"
       $253 = ((($1)) + 12|0); //@line 124207 "c/sqlite3.c"
       $254 = HEAP32[$253>>2]|0; //@line 124207 "c/sqlite3.c"
       $255 = ($254|0)==(0); //@line 124207 "c/sqlite3.c"
       if ($255) {
        $256 = ((($4)) + 20|0); //@line 124207 "c/sqlite3.c"
        $257 = HEAP32[$256>>2]|0; //@line 124207 "c/sqlite3.c"
        $258 = ($257|0)>(-1); //@line 124207 "c/sqlite3.c"
        if ($258) {
         _sqlite3VdbeChangeOpcode($42,$257,110); //@line 124208 "c/sqlite3.c"
         $259 = ((($4)) + 28|0); //@line 124209 "c/sqlite3.c"
         $260 = HEAP8[$259>>0]|0; //@line 124209 "c/sqlite3.c"
         $261 = $260 | 1; //@line 124209 "c/sqlite3.c"
         HEAP8[$259>>0] = $261; //@line 124209 "c/sqlite3.c"
        }
       }
       $262 = HEAP32[$39>>2]|0; //@line 124214 "c/sqlite3.c"
       $263 = $262 & 1; //@line 124214 "c/sqlite3.c"
       $264 = ($263|0)==(0); //@line 124214 "c/sqlite3.c"
       if ($264) {
        $$sink784 = 0;
       } else {
        $265 = ((($0)) + 40|0); //@line 124215 "c/sqlite3.c"
        $266 = HEAP32[$265>>2]|0; //@line 124215 "c/sqlite3.c"
        $267 = (($266) + 1)|0; //@line 124215 "c/sqlite3.c"
        HEAP32[$265>>2] = $267; //@line 124215 "c/sqlite3.c"
        $268 = ((($3)) + 4|0); //@line 124215 "c/sqlite3.c"
        HEAP32[$268>>2] = $266; //@line 124215 "c/sqlite3.c"
        $269 = HEAP32[$1>>2]|0; //@line 124218 "c/sqlite3.c"
        $270 = (_keyInfoFromExprList($0,$269,0,0)|0); //@line 124218 "c/sqlite3.c"
        $271 = (_sqlite3VdbeAddOp4($42,109,$266,0,0,$270,-9)|0); //@line 124216 "c/sqlite3.c"
        $272 = ((($3)) + 8|0); //@line 124216 "c/sqlite3.c"
        HEAP32[$272>>2] = $271; //@line 124216 "c/sqlite3.c"
        _sqlite3VdbeChangeP5($42,8); //@line 124220 "c/sqlite3.c"
        $$sink784 = 3;
       }
       $273 = ((($3)) + 1|0);
       HEAP8[$273>>0] = $$sink784;
       $274 = ($$lobit|0)==(0); //@line 124226 "c/sqlite3.c"
       $275 = ($$0661|0)==(0|0); //@line 124226 "c/sqlite3.c"
       $or$cond4 = $274 & $275; //@line 124226 "c/sqlite3.c"
       L103: do {
        if ($or$cond4) {
         $276 = HEAP8[$3>>0]|0; //@line 124228 "c/sqlite3.c"
         $277 = ($276<<24>>24)==(0); //@line 124228 "c/sqlite3.c"
         $278 = HEAP32[$39>>2]|0; //@line 124230 "c/sqlite3.c"
         $279 = $278 & 16384; //@line 124230 "c/sqlite3.c"
         $280 = $277 ? 0 : 256; //@line 124230 "c/sqlite3.c"
         $281 = $280 | $279; //@line 124230 "c/sqlite3.c"
         $282 = $281&65535; //@line 124230 "c/sqlite3.c"
         $283 = HEAP32[$4>>2]|0; //@line 124233 "c/sqlite3.c"
         $284 = HEAP32[$1>>2]|0; //@line 124234 "c/sqlite3.c"
         $285 = ((($1)) + 6|0); //@line 124234 "c/sqlite3.c"
         $286 = HEAP16[$285>>1]|0; //@line 124234 "c/sqlite3.c"
         $287 = $286 << 16 >> 16; //@line 124234 "c/sqlite3.c"
         $288 = (_sqlite3WhereBegin($0,$$0655744,$212,$283,$284,$282,$287)|0); //@line 124233 "c/sqlite3.c"
         $289 = ($288|0)==(0|0); //@line 124235 "c/sqlite3.c"
         if ($289) {
          $$0662 = 1;
          break L16;
         }
         $290 = (_sqlite3WhereOutputRowCount($288)|0); //@line 124236 "c/sqlite3.c"
         $291 = HEAP16[$285>>1]|0; //@line 124236 "c/sqlite3.c"
         $292 = ($290<<16>>16)<($291<<16>>16); //@line 124236 "c/sqlite3.c"
         if ($292) {
          HEAP16[$285>>1] = $290; //@line 124237 "c/sqlite3.c"
         }
         $293 = HEAP8[$3>>0]|0; //@line 124239 "c/sqlite3.c"
         $294 = ($293<<24>>24)==(0); //@line 124239 "c/sqlite3.c"
         do {
          if (!($294)) {
           $295 = (_sqlite3WhereIsDistinct($288)|0); //@line 124239 "c/sqlite3.c"
           $296 = ($295|0)==(0); //@line 124239 "c/sqlite3.c"
           if ($296) {
            break;
           }
           $297 = $295&255; //@line 124240 "c/sqlite3.c"
           $298 = ((($3)) + 1|0); //@line 124240 "c/sqlite3.c"
           HEAP8[$298>>0] = $297; //@line 124240 "c/sqlite3.c"
          }
         } while(0);
         $299 = HEAP32[$4>>2]|0; //@line 124242 "c/sqlite3.c"
         $300 = ($299|0)==(0|0); //@line 124242 "c/sqlite3.c"
         do {
          if (!($300)) {
           $301 = (_sqlite3WhereIsOrdered($288)|0); //@line 124243 "c/sqlite3.c"
           $302 = ((($4)) + 4|0); //@line 124243 "c/sqlite3.c"
           HEAP32[$302>>2] = $301; //@line 124243 "c/sqlite3.c"
           $303 = (_sqlite3WhereOrderedInnerLoop($288)|0); //@line 124244 "c/sqlite3.c"
           $304 = $303&255; //@line 124244 "c/sqlite3.c"
           $305 = ((($4)) + 29|0); //@line 124244 "c/sqlite3.c"
           HEAP8[$305>>0] = $304; //@line 124244 "c/sqlite3.c"
           $306 = HEAP32[$299>>2]|0; //@line 124245 "c/sqlite3.c"
           $307 = ($301|0)==($306|0); //@line 124245 "c/sqlite3.c"
           if (!($307)) {
            break;
           }
           HEAP32[$4>>2] = 0; //@line 124246 "c/sqlite3.c"
          }
         } while(0);
         $308 = ((($4)) + 20|0); //@line 124254 "c/sqlite3.c"
         $309 = HEAP32[$308>>2]|0; //@line 124254 "c/sqlite3.c"
         $310 = ($309|0)>(-1); //@line 124254 "c/sqlite3.c"
         $311 = HEAP32[$4>>2]|0; //@line 124254 "c/sqlite3.c"
         $312 = ($311|0)==(0|0); //@line 124254 "c/sqlite3.c"
         $or$cond681 = $310 & $312; //@line 124254 "c/sqlite3.c"
         if ($or$cond681) {
          (_sqlite3VdbeChangeToNoop($42,$309)|0); //@line 124255 "c/sqlite3.c"
         }
         $313 = (_sqlite3WhereContinueLabel($288)|0); //@line 124261 "c/sqlite3.c"
         $314 = (_sqlite3WhereBreakLabel($288)|0); //@line 124262 "c/sqlite3.c"
         _selectInnerLoop($0,$1,-1,$4,$3,$2,$313,$314); //@line 124260 "c/sqlite3.c"
         _sqlite3WhereEnd($288); //@line 124266 "c/sqlite3.c"
        } else {
         $315 = ($$0661|0)!=(0|0); //@line 124286 "c/sqlite3.c"
         do {
          if ($315) {
           $316 = HEAP32[$1>>2]|0; //@line 124290 "c/sqlite3.c"
           $317 = HEAP32[$316>>2]|0; //@line 124290 "c/sqlite3.c"
           $318 = ($317|0)>(0); //@line 124290 "c/sqlite3.c"
           if ($318) {
            $319 = ((($316)) + 4|0); //@line 124290 "c/sqlite3.c"
            $$0675734 = $319;$$0677733 = $317;
            while(1) {
             $320 = ((($$0675734)) + 16|0); //@line 124291 "c/sqlite3.c"
             $321 = ((($320)) + 2|0); //@line 124291 "c/sqlite3.c"
             HEAP16[$321>>1] = 0; //@line 124291 "c/sqlite3.c"
             $322 = (($$0677733) + -1)|0; //@line 124290 "c/sqlite3.c"
             $323 = ((($$0675734)) + 20|0); //@line 124290 "c/sqlite3.c"
             $324 = ($$0677733|0)>(1); //@line 124290 "c/sqlite3.c"
             if ($324) {
              $$0675734 = $323;$$0677733 = $322;
             } else {
              break;
             }
            }
           }
           $325 = HEAP32[$$0661>>2]|0; //@line 124293 "c/sqlite3.c"
           $326 = ($325|0)>(0); //@line 124293 "c/sqlite3.c"
           if ($326) {
            $327 = ((($$0661)) + 4|0); //@line 124293 "c/sqlite3.c"
            $$1676729 = $327;$$1678728 = $325;
            while(1) {
             $328 = ((($$1676729)) + 16|0); //@line 124294 "c/sqlite3.c"
             $329 = ((($328)) + 2|0); //@line 124294 "c/sqlite3.c"
             HEAP16[$329>>1] = 0; //@line 124294 "c/sqlite3.c"
             $330 = (($$1678728) + -1)|0; //@line 124293 "c/sqlite3.c"
             $331 = ((($$1676729)) + 20|0); //@line 124293 "c/sqlite3.c"
             $332 = ($$1678728|0)>(1); //@line 124293 "c/sqlite3.c"
             if ($332) {
              $$1676729 = $331;$$1678728 = $330;
             } else {
              break;
             }
            }
           }
           $333 = ((($1)) + 6|0); //@line 124297 "c/sqlite3.c"
           $334 = HEAP16[$333>>1]|0; //@line 124297 "c/sqlite3.c"
           $335 = ($334<<16>>16)>(66); //@line 124297 "c/sqlite3.c"
           if (!($335)) {
            break;
           }
           HEAP16[$333>>1] = 66; //@line 124297 "c/sqlite3.c"
          } else {
           $336 = ((($1)) + 6|0); //@line 124300 "c/sqlite3.c"
           HEAP16[$336>>1] = 0; //@line 124300 "c/sqlite3.c"
          }
         } while(0);
         $337 = HEAP32[$4>>2]|0; //@line 124311 "c/sqlite3.c"
         $338 = (_sqlite3ExprListCompare($$0661,$337,-1)|0); //@line 124311 "c/sqlite3.c"
         $339 = ($338|0)==(0); //@line 124311 "c/sqlite3.c"
         $340 = (_sqlite3VdbeMakeLabel($42)|0); //@line 124316 "c/sqlite3.c"
         $341 = ((($7)) + 8|0);
         ;HEAP32[$341>>2]=0|0;HEAP32[$341+4>>2]=0|0;HEAP32[$341+8>>2]=0|0;HEAP32[$341+12>>2]=0|0;HEAP32[$341+16>>2]=0|0;HEAP32[$341+20>>2]=0|0; //@line 124322 "c/sqlite3.c"
         HEAP32[$7>>2] = $0; //@line 124323 "c/sqlite3.c"
         $342 = ((($7)) + 4|0); //@line 124324 "c/sqlite3.c"
         HEAP32[$342>>2] = $$0655744; //@line 124324 "c/sqlite3.c"
         $343 = ((($7)) + 12|0); //@line 124325 "c/sqlite3.c"
         HEAP32[$343>>2] = $5; //@line 124325 "c/sqlite3.c"
         $344 = ((($0)) + 44|0); //@line 124326 "c/sqlite3.c"
         $345 = HEAP32[$344>>2]|0; //@line 124326 "c/sqlite3.c"
         $346 = (($345) + 1)|0; //@line 124326 "c/sqlite3.c"
         $347 = ((($5)) + 16|0); //@line 124326 "c/sqlite3.c"
         HEAP32[$347>>2] = $346; //@line 124326 "c/sqlite3.c"
         if ($315) {
          $348 = HEAP32[$$0661>>2]|0; //@line 124327 "c/sqlite3.c"
          $350 = $348;
         } else {
          $350 = 0;
         }
         $349 = ((($5)) + 12|0); //@line 124327 "c/sqlite3.c"
         HEAP32[$349>>2] = $350; //@line 124327 "c/sqlite3.c"
         $351 = ((($5)) + 24|0); //@line 124328 "c/sqlite3.c"
         HEAP32[$351>>2] = $$0661; //@line 124328 "c/sqlite3.c"
         _sqlite3ExprAnalyzeAggList($7,$210); //@line 124329 "c/sqlite3.c"
         $352 = HEAP32[$4>>2]|0; //@line 124330 "c/sqlite3.c"
         _sqlite3ExprAnalyzeAggList($7,$352); //@line 124330 "c/sqlite3.c"
         $353 = ($216|0)==(0|0); //@line 124331 "c/sqlite3.c"
         if ($353) {
          $$1660 = $212;
         } else {
          if ($315) {
           _havingToWhere($0,$$0661,$216,$211); //@line 124334 "c/sqlite3.c"
           $354 = HEAP32[$211>>2]|0; //@line 124335 "c/sqlite3.c"
           $$0659 = $354;
          } else {
           $$0659 = $212;
          }
          _sqlite3ExprAnalyzeAggregates($7,$216); //@line 124337 "c/sqlite3.c"
          $$1660 = $$0659;
         }
         $355 = ((($5)) + 32|0); //@line 124339 "c/sqlite3.c"
         $356 = HEAP32[$355>>2]|0; //@line 124339 "c/sqlite3.c"
         $357 = ((($5)) + 36|0); //@line 124339 "c/sqlite3.c"
         HEAP32[$357>>2] = $356; //@line 124339 "c/sqlite3.c"
         $358 = HEAP32[$213>>2]|0; //@line 124340 "c/sqlite3.c"
         $359 = ($358|0)==(0|0); //@line 124340 "c/sqlite3.c"
         do {
          if ($359) {
           $360 = HEAP32[$215>>2]|0; //@line 124340 "c/sqlite3.c"
           $361 = ($360|0)==(0|0); //@line 124340 "c/sqlite3.c"
           if (!($361)) {
            $$0663 = 0;
            break;
           }
           $362 = ((($5)) + 44|0); //@line 124340 "c/sqlite3.c"
           $363 = HEAP32[$362>>2]|0; //@line 124340 "c/sqlite3.c"
           $364 = ($363|0)==(1); //@line 124340 "c/sqlite3.c"
           if (!($364)) {
            $$0663 = 0;
            break;
           }
           $365 = ((($5)) + 40|0); //@line 124341 "c/sqlite3.c"
           $366 = HEAP32[$365>>2]|0; //@line 124341 "c/sqlite3.c"
           $367 = HEAP32[$366>>2]|0; //@line 124341 "c/sqlite3.c"
           $368 = (_minMaxQuery($13,$367,$6)|0); //@line 124341 "c/sqlite3.c"
           $phitmp = $368&255; //@line 124342 "c/sqlite3.c"
           $$0663 = $phitmp;
          } else {
           $$0663 = 0;
          }
         } while(0);
         $369 = ((($5)) + 44|0); //@line 124345 "c/sqlite3.c"
         $370 = HEAP32[$369>>2]|0; //@line 124345 "c/sqlite3.c"
         $371 = ($370|0)>(0); //@line 124345 "c/sqlite3.c"
         if ($371) {
          $372 = ((($7)) + 28|0);
          $373 = ((($5)) + 40|0);
          $$4724 = 0;
          while(1) {
           $374 = HEAP16[$372>>1]|0; //@line 124347 "c/sqlite3.c"
           $375 = $374 | 8; //@line 124347 "c/sqlite3.c"
           HEAP16[$372>>1] = $375; //@line 124347 "c/sqlite3.c"
           $376 = HEAP32[$373>>2]|0; //@line 124348 "c/sqlite3.c"
           $377 = (($376) + ($$4724<<4)|0); //@line 124348 "c/sqlite3.c"
           $378 = HEAP32[$377>>2]|0; //@line 124348 "c/sqlite3.c"
           $379 = ((($378)) + 20|0); //@line 124348 "c/sqlite3.c"
           $380 = HEAP32[$379>>2]|0; //@line 124348 "c/sqlite3.c"
           _sqlite3ExprAnalyzeAggList($7,$380); //@line 124348 "c/sqlite3.c"
           $381 = HEAP16[$372>>1]|0; //@line 124349 "c/sqlite3.c"
           $382 = $381 & -9; //@line 124349 "c/sqlite3.c"
           HEAP16[$372>>1] = $382; //@line 124349 "c/sqlite3.c"
           $383 = (($$4724) + 1)|0; //@line 124345 "c/sqlite3.c"
           $384 = HEAP32[$369>>2]|0; //@line 124345 "c/sqlite3.c"
           $385 = ($383|0)<($384|0); //@line 124345 "c/sqlite3.c"
           if ($385) {
            $$4724 = $383;
           } else {
            break;
           }
          }
         }
         $386 = HEAP32[$344>>2]|0; //@line 124351 "c/sqlite3.c"
         $387 = ((($5)) + 20|0); //@line 124351 "c/sqlite3.c"
         HEAP32[$387>>2] = $386; //@line 124351 "c/sqlite3.c"
         $388 = HEAP8[$15>>0]|0; //@line 124352 "c/sqlite3.c"
         $389 = ($388<<24>>24)==(0); //@line 124352 "c/sqlite3.c"
         do {
          if ($389) {
           if ($315) {
            $390 = ((($0)) + 40|0); //@line 124391 "c/sqlite3.c"
            $391 = HEAP32[$390>>2]|0; //@line 124391 "c/sqlite3.c"
            $392 = (($391) + 1)|0; //@line 124391 "c/sqlite3.c"
            HEAP32[$390>>2] = $392; //@line 124391 "c/sqlite3.c"
            $393 = ((($5)) + 4|0); //@line 124391 "c/sqlite3.c"
            HEAP32[$393>>2] = $391; //@line 124391 "c/sqlite3.c"
            $394 = HEAP32[$355>>2]|0; //@line 124392 "c/sqlite3.c"
            $395 = (_keyInfoFromExprList($0,$$0661,0,$394)|0); //@line 124392 "c/sqlite3.c"
            $396 = HEAP32[$393>>2]|0; //@line 124394 "c/sqlite3.c"
            $397 = HEAP32[$349>>2]|0; //@line 124394 "c/sqlite3.c"
            $398 = (_sqlite3VdbeAddOp4($42,110,$396,$397,0,$395,-9)|0); //@line 124393 "c/sqlite3.c"
            $399 = HEAP32[$344>>2]|0; //@line 124399 "c/sqlite3.c"
            $400 = (($399) + 1)|0; //@line 124399 "c/sqlite3.c"
            $401 = (($399) + 2)|0; //@line 124400 "c/sqlite3.c"
            $402 = (($399) + 3)|0; //@line 124401 "c/sqlite3.c"
            HEAP32[$344>>2] = $402; //@line 124401 "c/sqlite3.c"
            $403 = (_sqlite3VdbeMakeLabel($42)|0); //@line 124402 "c/sqlite3.c"
            $404 = HEAP32[$344>>2]|0; //@line 124403 "c/sqlite3.c"
            $405 = (($404) + 1)|0; //@line 124403 "c/sqlite3.c"
            HEAP32[$344>>2] = $405; //@line 124403 "c/sqlite3.c"
            $406 = (_sqlite3VdbeMakeLabel($42)|0); //@line 124404 "c/sqlite3.c"
            $407 = HEAP32[$344>>2]|0; //@line 124405 "c/sqlite3.c"
            $408 = (($407) + 1)|0; //@line 124405 "c/sqlite3.c"
            $409 = HEAP32[$$0661>>2]|0; //@line 124406 "c/sqlite3.c"
            $410 = (($409) + ($407))|0; //@line 124406 "c/sqlite3.c"
            $411 = (($410) + 1)|0; //@line 124407 "c/sqlite3.c"
            $412 = (($410) + ($409))|0; //@line 124408 "c/sqlite3.c"
            HEAP32[$344>>2] = $412; //@line 124408 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,67,0,$401)|0); //@line 124409 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,67,0,$400)|0); //@line 124411 "c/sqlite3.c"
            $413 = HEAP32[$$0661>>2]|0; //@line 124413 "c/sqlite3.c"
            $414 = (($413) + ($407))|0; //@line 124413 "c/sqlite3.c"
            (_sqlite3VdbeAddOp3($42,70,0,$408,$414)|0); //@line 124413 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,14,$405,$406)|0); //@line 124420 "c/sqlite3.c"
            $415 = $339 ? 576 : 64; //@line 124422 "c/sqlite3.c"
            $416 = (_sqlite3WhereBegin($0,$$0655744,$$1660,$$0661,0,$415,0)|0); //@line 124421 "c/sqlite3.c"
            $417 = ($416|0)==(0|0); //@line 124424 "c/sqlite3.c"
            if ($417) {
             break;
            }
            $418 = (_sqlite3WhereIsOrdered($416)|0); //@line 124425 "c/sqlite3.c"
            $419 = HEAP32[$$0661>>2]|0; //@line 124425 "c/sqlite3.c"
            $420 = ($418|0)==($419|0); //@line 124425 "c/sqlite3.c"
            if ($420) {
             $$0671 = 0;$$0672 = 0;$$0673 = 0;
            } else {
             $421 = HEAP8[$3>>0]|0; //@line 124443 "c/sqlite3.c"
             $422 = ($421<<24>>24)==(0); //@line 124443 "c/sqlite3.c"
             if ($422) {
              $426 = 28420;
             } else {
              $423 = HEAP32[$39>>2]|0; //@line 124443 "c/sqlite3.c"
              $424 = $423 & 1; //@line 124443 "c/sqlite3.c"
              $425 = ($424|0)==(0); //@line 124443 "c/sqlite3.c"
              $phitmp679 = $425 ? 28411 : 28420;
              $426 = $phitmp679;
             }
             _explainTempTable($0,$426); //@line 124442 "c/sqlite3.c"
             $427 = HEAP32[$$0661>>2]|0; //@line 124447 "c/sqlite3.c"
             $428 = HEAP32[$355>>2]|0; //@line 124450 "c/sqlite3.c"
             $429 = ($428|0)>(0); //@line 124450 "c/sqlite3.c"
             if ($429) {
              $430 = ((($5)) + 28|0);
              $431 = HEAP32[$430>>2]|0;
              $432 = HEAP32[$355>>2]|0;
              $$0650710 = $427;$$0657709 = $427;$$5711 = 0;
              while(1) {
               $433 = (((($431) + (($$5711*24)|0)|0)) + 12|0); //@line 124451 "c/sqlite3.c"
               $434 = HEAP32[$433>>2]|0; //@line 124451 "c/sqlite3.c"
               $435 = ($434|0)<($$0650710|0); //@line 124451 "c/sqlite3.c"
               $not$ = $435 ^ 1; //@line 124451 "c/sqlite3.c"
               $436 = $not$&1; //@line 124451 "c/sqlite3.c"
               $$1658 = (($$0657709) + ($436))|0; //@line 124451 "c/sqlite3.c"
               $not$692 = $435 ^ 1; //@line 124451 "c/sqlite3.c"
               $437 = $not$692&1; //@line 124451 "c/sqlite3.c"
               $$1651 = (($$0650710) + ($437))|0; //@line 124451 "c/sqlite3.c"
               $438 = (($$5711) + 1)|0; //@line 124450 "c/sqlite3.c"
               $439 = ($438|0)<($432|0); //@line 124450 "c/sqlite3.c"
               if ($439) {
                $$0650710 = $$1651;$$0657709 = $$1658;$$5711 = $438;
               } else {
                $$0657$lcssa = $$1658;
                break;
               }
              }
             } else {
              $$0657$lcssa = $427;
             }
             $440 = (_sqlite3GetTempRange($0,$$0657$lcssa)|0); //@line 124456 "c/sqlite3.c"
             _sqlite3ExprCacheClear($0); //@line 124457 "c/sqlite3.c"
             (_sqlite3ExprCodeExprList($0,$$0661,$440,0,0)|0); //@line 124458 "c/sqlite3.c"
             $441 = HEAP32[$355>>2]|0; //@line 124460 "c/sqlite3.c"
             $442 = ($441|0)>(0); //@line 124460 "c/sqlite3.c"
             if ($442) {
              $443 = ((($5)) + 28|0);
              $$2652704 = $427;$$6705 = 0;
              while(1) {
               $444 = HEAP32[$443>>2]|0; //@line 124461 "c/sqlite3.c"
               $445 = (((($444) + (($$6705*24)|0)|0)) + 12|0); //@line 124462 "c/sqlite3.c"
               $446 = HEAP32[$445>>2]|0; //@line 124462 "c/sqlite3.c"
               $447 = ($446|0)<($$2652704|0); //@line 124462 "c/sqlite3.c"
               if ($447) {
                $$3653 = $$2652704;
               } else {
                $448 = (($$2652704) + 1)|0; //@line 124466 "c/sqlite3.c"
                $449 = (((($444) + (($$6705*24)|0)|0)) + 4|0); //@line 124465 "c/sqlite3.c"
                $450 = (((($444) + (($$6705*24)|0)|0)) + 8|0); //@line 124465 "c/sqlite3.c"
                $451 = (($444) + (($$6705*24)|0)|0); //@line 124465 "c/sqlite3.c"
                $452 = (($$2652704) + ($440))|0; //@line 124463 "c/sqlite3.c"
                $453 = HEAP32[$451>>2]|0; //@line 124465 "c/sqlite3.c"
                $454 = HEAP32[$450>>2]|0; //@line 124465 "c/sqlite3.c"
                $455 = HEAP32[$449>>2]|0; //@line 124465 "c/sqlite3.c"
                _sqlite3ExprCodeGetColumnToReg($0,$453,$454,$455,$452); //@line 124464 "c/sqlite3.c"
                $$3653 = $448;
               }
               $456 = (($$6705) + 1)|0; //@line 124460 "c/sqlite3.c"
               $457 = HEAP32[$355>>2]|0; //@line 124460 "c/sqlite3.c"
               $458 = ($456|0)<($457|0); //@line 124460 "c/sqlite3.c"
               if ($458) {
                $$2652704 = $$3653;$$6705 = $456;
               } else {
                break;
               }
              }
             }
             $459 = (_sqlite3GetTempReg($0)|0); //@line 124469 "c/sqlite3.c"
             (_sqlite3VdbeAddOp3($42,100,$440,$$0657$lcssa,$459)|0); //@line 124470 "c/sqlite3.c"
             $460 = HEAP32[$393>>2]|0; //@line 124471 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($42,127,$460,$459)|0); //@line 124471 "c/sqlite3.c"
             _sqlite3ReleaseTempReg($0,$459); //@line 124472 "c/sqlite3.c"
             _sqlite3ReleaseTempRange($0,$440,$$0657$lcssa); //@line 124473 "c/sqlite3.c"
             _sqlite3WhereEnd($416); //@line 124474 "c/sqlite3.c"
             $461 = HEAP32[$390>>2]|0; //@line 124475 "c/sqlite3.c"
             $462 = (($461) + 1)|0; //@line 124475 "c/sqlite3.c"
             HEAP32[$390>>2] = $462; //@line 124475 "c/sqlite3.c"
             $463 = ((($5)) + 8|0); //@line 124475 "c/sqlite3.c"
             HEAP32[$463>>2] = $461; //@line 124475 "c/sqlite3.c"
             $464 = (_sqlite3GetTempReg($0)|0); //@line 124476 "c/sqlite3.c"
             (_sqlite3VdbeAddOp3($42,112,$461,$464,$$0657$lcssa)|0); //@line 124477 "c/sqlite3.c"
             $465 = HEAP32[$393>>2]|0; //@line 124478 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($42,35,$465,$340)|0); //@line 124478 "c/sqlite3.c"
             $466 = ((($5)) + 1|0); //@line 124480 "c/sqlite3.c"
             HEAP8[$466>>0] = 1; //@line 124480 "c/sqlite3.c"
             _sqlite3ExprCacheClear($0); //@line 124481 "c/sqlite3.c"
             $$0671 = 1;$$0672 = $461;$$0673 = $464;
            }
            do {
             if ($339) {
              $467 = ((($13)) + 68|0); //@line 124492 "c/sqlite3.c"
              $468 = HEAP16[$467>>1]|0; //@line 124492 "c/sqlite3.c"
              $469 = $468 & 4; //@line 124492 "c/sqlite3.c"
              $470 = ($469<<16>>16)==(0); //@line 124492 "c/sqlite3.c"
              if (!($470)) {
               break;
              }
              $471 = ($$0671|0)==(0); //@line 124493 "c/sqlite3.c"
              if ($471) {
               $472 = (_sqlite3WhereIsSorted($416)|0); //@line 124493 "c/sqlite3.c"
               $473 = ($472|0)==(0); //@line 124493 "c/sqlite3.c"
               if ($473) {
                break;
               }
              }
              HEAP32[$4>>2] = 0; //@line 124495 "c/sqlite3.c"
              $474 = ((($4)) + 20|0); //@line 124496 "c/sqlite3.c"
              $475 = HEAP32[$474>>2]|0; //@line 124496 "c/sqlite3.c"
              (_sqlite3VdbeChangeToNoop($42,$475)|0); //@line 124496 "c/sqlite3.c"
             }
            } while(0);
            $476 = (_sqlite3VdbeCurrentAddr($42)|0); //@line 124504 "c/sqlite3.c"
            _sqlite3ExprCacheClear($0); //@line 124505 "c/sqlite3.c"
            $477 = ($$0671|0)!=(0); //@line 124506 "c/sqlite3.c"
            if ($477) {
             $478 = HEAP32[$393>>2]|0; //@line 124507 "c/sqlite3.c"
             (_sqlite3VdbeAddOp3($42,122,$478,$$0673,$$0672)|0); //@line 124507 "c/sqlite3.c"
            }
            $479 = HEAP32[$$0661>>2]|0; //@line 124510 "c/sqlite3.c"
            $480 = ($479|0)>(0); //@line 124510 "c/sqlite3.c"
            if ($480) {
             $$4654703 = 0;
             while(1) {
              if ($477) {
               $481 = (($$4654703) + ($411))|0; //@line 124512 "c/sqlite3.c"
               (_sqlite3VdbeAddOp3($42,98,$$0672,$$4654703,$481)|0); //@line 124512 "c/sqlite3.c"
              } else {
               HEAP8[$5>>0] = 1; //@line 124514 "c/sqlite3.c"
               $482 = (((($$0661)) + 4|0) + (($$4654703*20)|0)|0); //@line 124515 "c/sqlite3.c"
               $483 = HEAP32[$482>>2]|0; //@line 124515 "c/sqlite3.c"
               $484 = (($$4654703) + ($411))|0; //@line 124515 "c/sqlite3.c"
               _sqlite3ExprCode($0,$483,$484); //@line 124515 "c/sqlite3.c"
              }
              $485 = (($$4654703) + 1)|0; //@line 124510 "c/sqlite3.c"
              $486 = HEAP32[$$0661>>2]|0; //@line 124510 "c/sqlite3.c"
              $487 = ($485|0)<($486|0); //@line 124510 "c/sqlite3.c"
              if ($487) {
               $$4654703 = $485;
              } else {
               $$lcssa = $486;
               break;
              }
             }
            } else {
             $$lcssa = $479;
            }
            $488 = (_sqlite3KeyInfoRef($395)|0); //@line 124519 "c/sqlite3.c"
            (_sqlite3VdbeAddOp4($42,94,$408,$411,$$lcssa,$395,-9)|0); //@line 124518 "c/sqlite3.c"
            $489 = (_sqlite3VdbeCurrentAddr($42)|0); //@line 124520 "c/sqlite3.c"
            $490 = (($489) + 1)|0; //@line 124521 "c/sqlite3.c"
            (_sqlite3VdbeAddOp3($42,18,$490,0,$490)|0); //@line 124521 "c/sqlite3.c"
            $491 = HEAP32[$$0661>>2]|0; //@line 124532 "c/sqlite3.c"
            _sqlite3ExprCodeMove($0,$411,$408,$491); //@line 124532 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,14,$402,$403)|0); //@line 124533 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,48,$401,$340)|0); //@line 124535 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,14,$405,$406)|0); //@line 124537 "c/sqlite3.c"
            _sqlite3VdbeJumpHere($42,$489); //@line 124543 "c/sqlite3.c"
            _updateAccumulator($0,$5); //@line 124544 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,67,1,$400)|0); //@line 124545 "c/sqlite3.c"
            if ($477) {
             $492 = HEAP32[$393>>2]|0; //@line 124551 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($42,3,$492,$476)|0); //@line 124551 "c/sqlite3.c"
            } else {
             _sqlite3WhereEnd($416); //@line 124554 "c/sqlite3.c"
             (_sqlite3VdbeChangeToNoop($42,$398)|0); //@line 124555 "c/sqlite3.c"
            }
            (_sqlite3VdbeAddOp2($42,14,$402,$403)|0); //@line 124560 "c/sqlite3.c"
            _sqlite3VdbeGoto($42,$340); //@line 124565 "c/sqlite3.c"
            $493 = (_sqlite3VdbeCurrentAddr($42)|0); //@line 124574 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,67,1,$401)|0); //@line 124575 "c/sqlite3.c"
            (_sqlite3VdbeAddOp1($42,63,$402)|0); //@line 124577 "c/sqlite3.c"
            _sqlite3VdbeResolveLabel($42,$403); //@line 124578 "c/sqlite3.c"
            $494 = (_sqlite3VdbeCurrentAddr($42)|0); //@line 124579 "c/sqlite3.c"
            $495 = (($494) + 2)|0; //@line 124580 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($42,48,$400,$495)|0); //@line 124580 "c/sqlite3.c"
            (_sqlite3VdbeAddOp1($42,63,$402)|0); //@line 124583 "c/sqlite3.c"
            _finalizeAggFunctions($0,$5); //@line 124584 "c/sqlite3.c"
            $496 = (($494) + 1)|0; //@line 124585 "c/sqlite3.c"
            _sqlite3ExprIfFalse($0,$216,$496,16); //@line 124585 "c/sqlite3.c"
            _selectInnerLoop($0,$1,-1,$4,$3,$2,$496,$493); //@line 124586 "c/sqlite3.c"
            (_sqlite3VdbeAddOp1($42,63,$402)|0); //@line 124589 "c/sqlite3.c"
            _sqlite3VdbeResolveLabel($42,$406); //@line 124594 "c/sqlite3.c"
            _resetAccumulator($0,$5); //@line 124595 "c/sqlite3.c"
            (_sqlite3VdbeAddOp1($42,63,$405)|0); //@line 124596 "c/sqlite3.c"
           } else {
            $497 = (_isSimpleCount($1,$5)|0); //@line 124602 "c/sqlite3.c"
            $498 = ($497|0)==(0|0); //@line 124602 "c/sqlite3.c"
            if ($498) {
             _resetAccumulator($0,$5); //@line 124666 "c/sqlite3.c"
             $544 = HEAP32[$6>>2]|0; //@line 124676 "c/sqlite3.c"
             $545 = (_sqlite3WhereBegin($0,$$0655744,$$1660,$544,0,$$0663,0)|0); //@line 124676 "c/sqlite3.c"
             $546 = ($545|0)==(0|0); //@line 124678 "c/sqlite3.c"
             if ($546) {
              break;
             }
             _updateAccumulator($0,$5); //@line 124681 "c/sqlite3.c"
             $547 = (_sqlite3WhereIsOrdered($545)|0); //@line 124682 "c/sqlite3.c"
             $548 = ($547|0)>(0); //@line 124682 "c/sqlite3.c"
             if ($548) {
              $549 = (_sqlite3WhereBreakLabel($545)|0); //@line 124683 "c/sqlite3.c"
              _sqlite3VdbeGoto($42,$549); //@line 124683 "c/sqlite3.c"
             }
             _sqlite3WhereEnd($545); //@line 124687 "c/sqlite3.c"
             _finalizeAggFunctions($0,$5); //@line 124688 "c/sqlite3.c"
            } else {
             $499 = HEAP32[$0>>2]|0; //@line 124616 "c/sqlite3.c"
             $500 = ((($497)) + 72|0); //@line 124616 "c/sqlite3.c"
             $501 = HEAP32[$500>>2]|0; //@line 124616 "c/sqlite3.c"
             $502 = (_sqlite3SchemaToIndex($499,$501)|0); //@line 124616 "c/sqlite3.c"
             $503 = ((($0)) + 40|0); //@line 124617 "c/sqlite3.c"
             $504 = HEAP32[$503>>2]|0; //@line 124617 "c/sqlite3.c"
             $505 = (($504) + 1)|0; //@line 124617 "c/sqlite3.c"
             HEAP32[$503>>2] = $505; //@line 124617 "c/sqlite3.c"
             $506 = ((($497)) + 28|0); //@line 124621 "c/sqlite3.c"
             $507 = HEAP32[$506>>2]|0; //@line 124621 "c/sqlite3.c"
             _sqlite3CodeVerifySchema($0,$502); //@line 124623 "c/sqlite3.c"
             $508 = HEAP32[$506>>2]|0; //@line 124624 "c/sqlite3.c"
             $509 = HEAP32[$497>>2]|0; //@line 124624 "c/sqlite3.c"
             _sqlite3TableLock($0,$502,$508,0,$509); //@line 124624 "c/sqlite3.c"
             $510 = ((($497)) + 36|0); //@line 124635 "c/sqlite3.c"
             $511 = HEAP32[$510>>2]|0; //@line 124635 "c/sqlite3.c"
             $512 = $511 & 32; //@line 124635 "c/sqlite3.c"
             $513 = ($512|0)==(0); //@line 124635 "c/sqlite3.c"
             if ($513) {
              $$0643 = 0;
             } else {
              $514 = (_sqlite3PrimaryKeyIndex($497)|0); //@line 124635 "c/sqlite3.c"
              $$0643 = $514;
             }
             $515 = ((($497)) + 8|0); //@line 124636 "c/sqlite3.c"
             $$0645716 = HEAP32[$515>>2]|0;
             $516 = ($$0645716|0)==(0|0); //@line 124636 "c/sqlite3.c"
             if ($516) {
              $$1$lcssa = $$0643;
             } else {
              $517 = ((($497)) + 46|0);
              $$0645718 = $$0645716;$$1717 = $$0643;
              while(1) {
               $518 = ((($$0645718)) + 55|0); //@line 124637 "c/sqlite3.c"
               $519 = HEAPU8[$518>>0]|(HEAPU8[$518+1>>0]<<8); //@line 124637 "c/sqlite3.c"
               $520 = $519 & 4; //@line 124637 "c/sqlite3.c"
               $521 = ($520<<16>>16)==(0); //@line 124637 "c/sqlite3.c"
               do {
                if ($521) {
                 $522 = ((($$0645718)) + 48|0); //@line 124638 "c/sqlite3.c"
                 $523 = HEAP16[$522>>1]|0; //@line 124638 "c/sqlite3.c"
                 $524 = HEAP16[$517>>1]|0; //@line 124638 "c/sqlite3.c"
                 $525 = ($523<<16>>16)<($524<<16>>16); //@line 124638 "c/sqlite3.c"
                 if (!($525)) {
                  $$2 = $$1717;
                  break;
                 }
                 $526 = ((($$0645718)) + 36|0); //@line 124639 "c/sqlite3.c"
                 $527 = HEAP32[$526>>2]|0; //@line 124639 "c/sqlite3.c"
                 $528 = ($527|0)==(0|0); //@line 124639 "c/sqlite3.c"
                 if (!($528)) {
                  $$2 = $$1717;
                  break;
                 }
                 $529 = ($$1717|0)==(0|0); //@line 124640 "c/sqlite3.c"
                 if (!($529)) {
                  $530 = ((($$1717)) + 48|0); //@line 124640 "c/sqlite3.c"
                  $531 = HEAP16[$530>>1]|0; //@line 124640 "c/sqlite3.c"
                  $532 = ($523<<16>>16)<($531<<16>>16); //@line 124640 "c/sqlite3.c"
                  if (!($532)) {
                   $$2 = $$1717;
                   break;
                  }
                 }
                 $$2 = $$0645718;
                } else {
                 $$2 = $$1717;
                }
               } while(0);
               $533 = ((($$0645718)) + 20|0); //@line 124636 "c/sqlite3.c"
               $$0645 = HEAP32[$533>>2]|0;
               $534 = ($$0645|0)==(0|0); //@line 124636 "c/sqlite3.c"
               if ($534) {
                $$1$lcssa = $$2;
                break;
               } else {
                $$0645718 = $$0645;$$1717 = $$2;
               }
              }
             }
             $535 = ($$1$lcssa|0)==(0|0); //@line 124645 "c/sqlite3.c"
             do {
              if ($535) {
               (_sqlite3VdbeAddOp4Int($42,105,$504,$507,$502,1)|0); //@line 124651 "c/sqlite3.c"
              } else {
               $536 = ((($$1$lcssa)) + 44|0); //@line 124646 "c/sqlite3.c"
               $537 = HEAP32[$536>>2]|0; //@line 124646 "c/sqlite3.c"
               $538 = (_sqlite3KeyInfoOfIndex($0,$$1$lcssa)|0); //@line 124647 "c/sqlite3.c"
               (_sqlite3VdbeAddOp4Int($42,105,$504,$537,$502,1)|0); //@line 124651 "c/sqlite3.c"
               $539 = ($538|0)==(0|0); //@line 124652 "c/sqlite3.c"
               if ($539) {
                break;
               }
               _sqlite3VdbeChangeP4($42,-1,$538,-9); //@line 124653 "c/sqlite3.c"
              }
             } while(0);
             $540 = ((($5)) + 40|0); //@line 124655 "c/sqlite3.c"
             $541 = HEAP32[$540>>2]|0; //@line 124655 "c/sqlite3.c"
             $542 = ((($541)) + 8|0); //@line 124655 "c/sqlite3.c"
             $543 = HEAP32[$542>>2]|0; //@line 124655 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($42,101,$504,$543)|0); //@line 124655 "c/sqlite3.c"
             (_sqlite3VdbeAddOp1($42,113,$504)|0); //@line 124656 "c/sqlite3.c"
             _explainSimpleCount($0,$497,$$1$lcssa); //@line 124657 "c/sqlite3.c"
            }
            HEAP32[$4>>2] = 0; //@line 124691 "c/sqlite3.c"
            _sqlite3ExprIfFalse($0,$216,$340,16); //@line 124692 "c/sqlite3.c"
            _selectInnerLoop($0,$1,-1,0,0,$2,$340,$340); //@line 124693 "c/sqlite3.c"
           }
           _sqlite3VdbeResolveLabel($42,$340); //@line 124696 "c/sqlite3.c"
           break L103;
          }
         } while(0);
         $$0662 = 1;
         break L16;
        }
       } while(0);
       $550 = ((($3)) + 1|0); //@line 124700 "c/sqlite3.c"
       $551 = HEAP8[$550>>0]|0; //@line 124700 "c/sqlite3.c"
       $552 = ($551<<24>>24)==(3); //@line 124700 "c/sqlite3.c"
       if ($552) {
        _explainTempTable($0,28411); //@line 124701 "c/sqlite3.c"
       }
       $553 = HEAP32[$4>>2]|0; //@line 124707 "c/sqlite3.c"
       $554 = ($553|0)==(0|0); //@line 124707 "c/sqlite3.c"
       if (!($554)) {
        $555 = ((($4)) + 4|0); //@line 124709 "c/sqlite3.c"
        $556 = HEAP32[$555>>2]|0; //@line 124709 "c/sqlite3.c"
        $557 = ($556|0)>(0); //@line 124709 "c/sqlite3.c"
        $558 = $557 ? 28429 : 28452; //@line 124709 "c/sqlite3.c"
        _explainTempTable($0,$558); //@line 124708 "c/sqlite3.c"
        $559 = HEAP32[$210>>2]|0; //@line 124710 "c/sqlite3.c"
        _generateSortTail($0,$1,$4,$559,$2); //@line 124710 "c/sqlite3.c"
       }
       _sqlite3VdbeResolveLabel($42,$248); //@line 124715 "c/sqlite3.c"
       $560 = HEAP32[$18>>2]|0; //@line 124719 "c/sqlite3.c"
       $561 = ($560|0)>(0); //@line 124719 "c/sqlite3.c"
       $562 = $561&1; //@line 124719 "c/sqlite3.c"
       $$0662 = $562;
       break L16;
      }
     } while(0);
     $91 = (_multiSelect($0,$1,$2)|0); //@line 123945 "c/sqlite3.c"
     HEAP32[$8>>2] = $9; //@line 123946 "c/sqlite3.c"
     $$0646 = $91;
     STACKTOP = sp;return ($$0646|0); //@line 124734 "c/sqlite3.c"
    }
   } else {
    $$0662 = 1;
   }
  } else {
   $$0662 = 1;
  }
 } while(0);
 HEAP32[$8>>2] = $9; //@line 124725 "c/sqlite3.c"
 $563 = HEAP32[$6>>2]|0; //@line 124726 "c/sqlite3.c"
 _sqlite3ExprListDelete($13,$563); //@line 124726 "c/sqlite3.c"
 $564 = ((($5)) + 28|0); //@line 124727 "c/sqlite3.c"
 $565 = HEAP32[$564>>2]|0; //@line 124727 "c/sqlite3.c"
 _sqlite3DbFree($13,$565); //@line 124727 "c/sqlite3.c"
 $566 = ((($5)) + 40|0); //@line 124728 "c/sqlite3.c"
 $567 = HEAP32[$566>>2]|0; //@line 124728 "c/sqlite3.c"
 _sqlite3DbFree($13,$567); //@line 124728 "c/sqlite3.c"
 $$0646 = $$0662;
 STACKTOP = sp;return ($$0646|0); //@line 124734 "c/sqlite3.c"
}
function _parserDoubleLinkSelect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02023 = 0, $$02023$phi = 0, $$02122 = 0, $$024 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 138203 "c/sqlite3.c"
 $2 = ((($1)) + 48|0); //@line 138204 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 138204 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 138204 "c/sqlite3.c"
 if ($4) {
  STACKTOP = sp;return; //@line 138218 "c/sqlite3.c"
 }
 $$02023 = 0;$$02122 = $1;$$024 = 0;
 while(1) {
  $5 = ((($$02122)) + 52|0); //@line 138208 "c/sqlite3.c"
  HEAP32[$5>>2] = $$02023; //@line 138208 "c/sqlite3.c"
  $6 = ((($$02122)) + 8|0); //@line 138209 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 138209 "c/sqlite3.c"
  $8 = $7 | 256; //@line 138209 "c/sqlite3.c"
  HEAP32[$6>>2] = $8; //@line 138209 "c/sqlite3.c"
  $9 = ((($$02122)) + 48|0); //@line 138207 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 138207 "c/sqlite3.c"
  $11 = (($$024) + 1)|0; //@line 138207 "c/sqlite3.c"
  $12 = ($10|0)==(0|0); //@line 138207 "c/sqlite3.c"
  if ($12) {
   break;
  } else {
   $$02023$phi = $$02122;$$02122 = $10;$$024 = $11;$$02023 = $$02023$phi;
  }
 }
 $13 = ((($1)) + 8|0); //@line 138211 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 138211 "c/sqlite3.c"
 $15 = $14 & 1024; //@line 138211 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 138211 "c/sqlite3.c"
 if (!($16)) {
  STACKTOP = sp;return; //@line 138218 "c/sqlite3.c"
 }
 $17 = HEAP32[$0>>2]|0; //@line 138212 "c/sqlite3.c"
 $18 = ((($17)) + 116|0); //@line 138212 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 138212 "c/sqlite3.c"
 $20 = ($19|0)>(0); //@line 138212 "c/sqlite3.c"
 $21 = ($$024|0)>=($19|0); //@line 138213 "c/sqlite3.c"
 $or$cond = $20 & $21; //@line 138212 "c/sqlite3.c"
 if (!($or$cond)) {
  STACKTOP = sp;return; //@line 138218 "c/sqlite3.c"
 }
 _sqlite3ErrorMsg($0,28337,$vararg_buffer); //@line 138215 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 138218 "c/sqlite3.c"
}
function _sqlite3SrcListAppendFromTerm($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 105459 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 105469 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 105470 "c/sqlite3.c"
 if ($9) {
  $10 = ($6|0)!=(0|0); //@line 105470 "c/sqlite3.c"
  $11 = ($7|0)!=(0|0); //@line 105470 "c/sqlite3.c"
  $or$cond = $10 | $11; //@line 105470 "c/sqlite3.c"
  if ($or$cond) {
   $12 = $10 ? 28292 : 28295; //@line 105472 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $12; //@line 105471 "c/sqlite3.c"
   _sqlite3ErrorMsg($0,28301,$vararg_buffer); //@line 105471 "c/sqlite3.c"
  } else {
   label = 4;
  }
 } else {
  label = 4;
 }
 if ((label|0) == 4) {
  $13 = (_sqlite3SrcListAppend($8,$1,$2,$3)|0); //@line 105476 "c/sqlite3.c"
  $14 = ($13|0)==(0|0); //@line 105477 "c/sqlite3.c"
  if (!($14)) {
   $15 = HEAP32[$13>>2]|0; //@line 105481 "c/sqlite3.c"
   $16 = (($15) + -1)|0; //@line 105481 "c/sqlite3.c"
   $17 = ((($4)) + 4|0); //@line 105483 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 105483 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 105483 "c/sqlite3.c"
   if (!($19)) {
    $20 = (((((($13)) + 8|0) + (($16*72)|0)|0)) + 12|0); //@line 105484 "c/sqlite3.c"
    $21 = (_sqlite3NameFromToken($8,$4)|0); //@line 105484 "c/sqlite3.c"
    HEAP32[$20>>2] = $21; //@line 105484 "c/sqlite3.c"
   }
   $22 = (((((($13)) + 8|0) + (($16*72)|0)|0)) + 20|0); //@line 105486 "c/sqlite3.c"
   HEAP32[$22>>2] = $5; //@line 105486 "c/sqlite3.c"
   $23 = (((((($13)) + 8|0) + (($16*72)|0)|0)) + 48|0); //@line 105487 "c/sqlite3.c"
   HEAP32[$23>>2] = $6; //@line 105487 "c/sqlite3.c"
   $24 = (((((($13)) + 8|0) + (($16*72)|0)|0)) + 52|0); //@line 105488 "c/sqlite3.c"
   HEAP32[$24>>2] = $7; //@line 105488 "c/sqlite3.c"
   $$0 = $13;
   STACKTOP = sp;return ($$0|0); //@line 105497 "c/sqlite3.c"
  }
 }
 _sqlite3ExprDelete($8,$6); //@line 105493 "c/sqlite3.c"
 _sqlite3IdListDelete($8,$7); //@line 105494 "c/sqlite3.c"
 _sqlite3SelectDelete($8,$5); //@line 105495 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 105497 "c/sqlite3.c"
}
function _sqlite3SelectNew($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$0 = 0, $$037 = 0, $$038 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $9 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $9 = sp;
 $10 = HEAP32[$0>>2]|0; //@line 118799 "c/sqlite3.c"
 $11 = (_sqlite3DbMallocRawNN($10,64,0)|0); //@line 118799 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 118800 "c/sqlite3.c"
 $spec$store$select = $12 ? $9 : $11; //@line 118800 "c/sqlite3.c"
 $13 = ($1|0)==(0|0); //@line 118804 "c/sqlite3.c"
 if ($13) {
  $14 = HEAP32[$0>>2]|0; //@line 118806 "c/sqlite3.c"
  $15 = (_sqlite3Expr($14,154,0)|0); //@line 118806 "c/sqlite3.c"
  $16 = (_sqlite3ExprListAppend($0,0,$15)|0); //@line 118805 "c/sqlite3.c"
  $$037 = $16;
 } else {
  $$037 = $1;
 }
 HEAP32[$spec$store$select>>2] = $$037; //@line 118808 "c/sqlite3.c"
 $17 = ((($spec$store$select)) + 4|0); //@line 118809 "c/sqlite3.c"
 HEAP8[$17>>0] = 119; //@line 118809 "c/sqlite3.c"
 $18 = ((($spec$store$select)) + 8|0); //@line 118810 "c/sqlite3.c"
 HEAP32[$18>>2] = $7; //@line 118810 "c/sqlite3.c"
 $19 = ((($spec$store$select)) + 12|0); //@line 118811 "c/sqlite3.c"
 HEAP32[$19>>2] = 0; //@line 118811 "c/sqlite3.c"
 $20 = ((($spec$store$select)) + 16|0); //@line 118812 "c/sqlite3.c"
 HEAP32[$20>>2] = 0; //@line 118812 "c/sqlite3.c"
 $21 = ((($spec$store$select)) + 20|0); //@line 118816 "c/sqlite3.c"
 HEAP32[$21>>2] = -1; //@line 118816 "c/sqlite3.c"
 $22 = ((($spec$store$select)) + 24|0); //@line 118817 "c/sqlite3.c"
 HEAP32[$22>>2] = -1; //@line 118817 "c/sqlite3.c"
 $23 = ((($spec$store$select)) + 6|0); //@line 118818 "c/sqlite3.c"
 HEAP16[$23>>1] = 0; //@line 118818 "c/sqlite3.c"
 $24 = ($2|0)==(0|0); //@line 118819 "c/sqlite3.c"
 if ($24) {
  $25 = HEAP32[$0>>2]|0; //@line 118819 "c/sqlite3.c"
  $26 = (_sqlite3DbMallocZero($25,80,0)|0); //@line 118819 "c/sqlite3.c"
  $$038 = $26;
 } else {
  $$038 = $2;
 }
 $27 = ((($spec$store$select)) + 28|0); //@line 118820 "c/sqlite3.c"
 HEAP32[$27>>2] = $$038; //@line 118820 "c/sqlite3.c"
 $28 = ((($spec$store$select)) + 32|0); //@line 118821 "c/sqlite3.c"
 HEAP32[$28>>2] = $3; //@line 118821 "c/sqlite3.c"
 $29 = ((($spec$store$select)) + 36|0); //@line 118822 "c/sqlite3.c"
 HEAP32[$29>>2] = $4; //@line 118822 "c/sqlite3.c"
 $30 = ((($spec$store$select)) + 40|0); //@line 118823 "c/sqlite3.c"
 HEAP32[$30>>2] = $5; //@line 118823 "c/sqlite3.c"
 $31 = ((($spec$store$select)) + 44|0); //@line 118824 "c/sqlite3.c"
 HEAP32[$31>>2] = $6; //@line 118824 "c/sqlite3.c"
 $32 = ((($spec$store$select)) + 48|0); //@line 118825 "c/sqlite3.c"
 HEAP32[$32>>2] = 0; //@line 118825 "c/sqlite3.c"
 $33 = ((($spec$store$select)) + 52|0); //@line 118826 "c/sqlite3.c"
 HEAP32[$33>>2] = 0; //@line 118826 "c/sqlite3.c"
 $34 = ((($spec$store$select)) + 56|0); //@line 118827 "c/sqlite3.c"
 HEAP32[$34>>2] = $8; //@line 118827 "c/sqlite3.c"
 $35 = ((($spec$store$select)) + 60|0); //@line 118828 "c/sqlite3.c"
 HEAP32[$35>>2] = 0; //@line 118828 "c/sqlite3.c"
 $36 = HEAP32[$0>>2]|0; //@line 118829 "c/sqlite3.c"
 $37 = ((($36)) + 73|0); //@line 118829 "c/sqlite3.c"
 $38 = HEAP8[$37>>0]|0; //@line 118829 "c/sqlite3.c"
 $39 = ($38<<24>>24)==(0); //@line 118829 "c/sqlite3.c"
 if ($39) {
  $$0 = $spec$store$select;
  STACKTOP = sp;return ($$0|0); //@line 118836 "c/sqlite3.c"
 }
 $40 = ($spec$store$select|0)!=($9|0); //@line 118830 "c/sqlite3.c"
 $41 = $40&1; //@line 118830 "c/sqlite3.c"
 _clearSelect($36,$spec$store$select,$41); //@line 118830 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 118836 "c/sqlite3.c"
}
function _sqlite3ExprListAppend($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$028 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 94195 "c/sqlite3.c"
 $4 = ($1|0)==(0|0); //@line 94197 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3DbMallocRawNN($3,24,0)|0); //@line 94198 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 94199 "c/sqlite3.c"
  if ($6) {
   $$2 = $5;
   label = 7;
  } else {
   HEAP32[$5>>2] = 0; //@line 94202 "c/sqlite3.c"
   $$1 = $5;
   label = 6;
  }
 } else {
  $7 = HEAP32[$1>>2]|0; //@line 94203 "c/sqlite3.c"
  $8 = (($7) + -1)|0; //@line 94203 "c/sqlite3.c"
  $9 = $8 & $7; //@line 94203 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 94203 "c/sqlite3.c"
  if ($10) {
   $11 = ($7*40)|0; //@line 94206 "c/sqlite3.c"
   $12 = $11 | 4; //@line 94206 "c/sqlite3.c"
   $13 = (_sqlite3DbRealloc($3,$1,$12,0)|0); //@line 94205 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 94207 "c/sqlite3.c"
   if ($14) {
    $$2 = $1;
    label = 7;
   } else {
    $$1 = $13;
    label = 6;
   }
  } else {
   $$1 = $1;
   label = 6;
  }
 }
 if ((label|0) == 6) {
  $15 = HEAP32[$$1>>2]|0; //@line 94212 "c/sqlite3.c"
  $16 = (($15) + 1)|0; //@line 94212 "c/sqlite3.c"
  HEAP32[$$1>>2] = $16; //@line 94212 "c/sqlite3.c"
  $17 = (((((($$1)) + 4|0) + (($15*20)|0)|0)) + 4|0); //@line 94215 "c/sqlite3.c"
  ;HEAP32[$17>>2]=0|0;HEAP32[$17+4>>2]=0|0;HEAP32[$17+8>>2]=0|0;HEAP32[$17+12>>2]=0|0; //@line 94215 "c/sqlite3.c"
  $18 = (((($$1)) + 4|0) + (($15*20)|0)|0); //@line 94216 "c/sqlite3.c"
  HEAP32[$18>>2] = $2; //@line 94216 "c/sqlite3.c"
  $$028 = $$1;
  return ($$028|0); //@line 94224 "c/sqlite3.c"
 }
 else if ((label|0) == 7) {
  _sqlite3ExprDelete($3,$2); //@line 94221 "c/sqlite3.c"
  _sqlite3ExprListDelete($3,$$2); //@line 94222 "c/sqlite3.c"
  $$028 = 0;
  return ($$028|0); //@line 94224 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprListSetName($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 94323 "c/sqlite3.c"
 if ($4) {
  return; //@line 94331 "c/sqlite3.c"
 }
 $5 = HEAP32[$1>>2]|0; //@line 94326 "c/sqlite3.c"
 $6 = (($5) + -1)|0; //@line 94326 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 94328 "c/sqlite3.c"
 $8 = HEAP32[$2>>2]|0; //@line 94328 "c/sqlite3.c"
 $9 = ((($2)) + 4|0); //@line 94328 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 94328 "c/sqlite3.c"
 $11 = (_sqlite3DbStrNDup($7,$8,$10,0)|0); //@line 94328 "c/sqlite3.c"
 $12 = (((((($1)) + 4|0) + (($6*20)|0)|0)) + 4|0); //@line 94328 "c/sqlite3.c"
 HEAP32[$12>>2] = $11; //@line 94328 "c/sqlite3.c"
 $13 = ($3|0)==(0); //@line 94329 "c/sqlite3.c"
 if ($13) {
  return; //@line 94331 "c/sqlite3.c"
 }
 _sqlite3Dequote($11); //@line 94329 "c/sqlite3.c"
 return; //@line 94331 "c/sqlite3.c"
}
function _sqlite3ExprListSetSpan($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 94347 "c/sqlite3.c"
 $5 = ($1|0)==(0|0); //@line 94349 "c/sqlite3.c"
 if ($5) {
  return; //@line 94355 "c/sqlite3.c"
 }
 $6 = HEAP32[$1>>2]|0; //@line 94350 "c/sqlite3.c"
 $7 = (($6) + -1)|0; //@line 94350 "c/sqlite3.c"
 $8 = (((((($1)) + 4|0) + (($7*20)|0)|0)) + 8|0); //@line 94352 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 94352 "c/sqlite3.c"
 _sqlite3DbFree($4,$9); //@line 94352 "c/sqlite3.c"
 $10 = (_sqlite3DbSpanDup($4,$2,$3)|0); //@line 94353 "c/sqlite3.c"
 HEAP32[$8>>2] = $10; //@line 94353 "c/sqlite3.c"
 return; //@line 94355 "c/sqlite3.c"
}
function _sqlite3Expr($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 HEAP32[$3>>2] = $2; //@line 93494 "c/sqlite3.c"
 $4 = (_sqlite3Strlen30($2)|0); //@line 93495 "c/sqlite3.c"
 $5 = ((($3)) + 4|0); //@line 93495 "c/sqlite3.c"
 HEAP32[$5>>2] = $4; //@line 93495 "c/sqlite3.c"
 $6 = (_sqlite3ExprAlloc($0,$1,$3,0)|0); //@line 93496 "c/sqlite3.c"
 STACKTOP = sp;return ($6|0); //@line 93496 "c/sqlite3.c"
}
function _sqlite3ExprAlloc($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 HEAP32[$4>>2] = 0; //@line 93447 "c/sqlite3.c"
 $5 = ($2|0)!=(0|0); //@line 93450 "c/sqlite3.c"
 do {
  if ($5) {
   $6 = ($1|0)==(134); //@line 93451 "c/sqlite3.c"
   if ($6) {
    $7 = HEAP32[$2>>2]|0; //@line 93451 "c/sqlite3.c"
    $8 = ($7|0)==(0|0); //@line 93451 "c/sqlite3.c"
    if (!($8)) {
     $9 = (_sqlite3GetInt32($7,$4)|0); //@line 93452 "c/sqlite3.c"
     $10 = ($9|0)==(0); //@line 93452 "c/sqlite3.c"
     if (!($10)) {
      $$0 = 0;
      break;
     }
    }
   }
   $11 = ((($2)) + 4|0); //@line 93453 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 93453 "c/sqlite3.c"
   $13 = (($12) + 1)|0; //@line 93453 "c/sqlite3.c"
   $$0 = $13;
  } else {
   $$0 = 0;
  }
 } while(0);
 $14 = (($$0) + 48)|0; //@line 93457 "c/sqlite3.c"
 $15 = (_sqlite3DbMallocRawNN($0,$14,0)|0); //@line 93457 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 93458 "c/sqlite3.c"
 if ($16) {
  STACKTOP = sp;return ($15|0); //@line 93481 "c/sqlite3.c"
 }
 dest=$15; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 93459 "c/sqlite3.c"
 $17 = $1&255; //@line 93460 "c/sqlite3.c"
 HEAP8[$15>>0] = $17; //@line 93460 "c/sqlite3.c"
 $18 = ((($15)) + 34|0); //@line 93461 "c/sqlite3.c"
 HEAP16[$18>>1] = -1; //@line 93461 "c/sqlite3.c"
 do {
  if ($5) {
   $19 = ($$0|0)==(0); //@line 93463 "c/sqlite3.c"
   if ($19) {
    $20 = ((($15)) + 4|0); //@line 93464 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 93464 "c/sqlite3.c"
    $22 = $21 | 8389632; //@line 93464 "c/sqlite3.c"
    HEAP32[$20>>2] = $22; //@line 93464 "c/sqlite3.c"
    $23 = HEAP32[$4>>2]|0; //@line 93465 "c/sqlite3.c"
    $24 = ((($15)) + 8|0); //@line 93465 "c/sqlite3.c"
    HEAP32[$24>>2] = $23; //@line 93465 "c/sqlite3.c"
    break;
   }
   $25 = ((($15)) + 48|0); //@line 93467 "c/sqlite3.c"
   $26 = ((($15)) + 8|0); //@line 93467 "c/sqlite3.c"
   HEAP32[$26>>2] = $25; //@line 93467 "c/sqlite3.c"
   $27 = ((($2)) + 4|0); //@line 93469 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 93469 "c/sqlite3.c"
   $29 = ($28|0)==(0); //@line 93469 "c/sqlite3.c"
   if (!($29)) {
    $30 = HEAP32[$2>>2]|0; //@line 93469 "c/sqlite3.c"
    _memcpy(($25|0),($30|0),($28|0))|0; //@line 93469 "c/sqlite3.c"
   }
   $31 = HEAP32[$27>>2]|0; //@line 93470 "c/sqlite3.c"
   $32 = (($25) + ($31)|0); //@line 93470 "c/sqlite3.c"
   HEAP8[$32>>0] = 0; //@line 93470 "c/sqlite3.c"
   $33 = ($3|0)==(0); //@line 93471 "c/sqlite3.c"
   if (!($33)) {
    $34 = HEAP32[$26>>2]|0; //@line 93471 "c/sqlite3.c"
    $35 = HEAP8[$34>>0]|0; //@line 93471 "c/sqlite3.c"
    $36 = $35&255; //@line 93471 "c/sqlite3.c"
    $37 = (16281 + ($36)|0); //@line 93471 "c/sqlite3.c"
    $38 = HEAP8[$37>>0]|0; //@line 93471 "c/sqlite3.c"
    $39 = ($38<<24>>24)<(0); //@line 93471 "c/sqlite3.c"
    if ($39) {
     $40 = ($35<<24>>24)==(34); //@line 93472 "c/sqlite3.c"
     if ($40) {
      $41 = ((($15)) + 4|0); //@line 93472 "c/sqlite3.c"
      $42 = HEAP32[$41>>2]|0; //@line 93472 "c/sqlite3.c"
      $43 = $42 | 64; //@line 93472 "c/sqlite3.c"
      HEAP32[$41>>2] = $43; //@line 93472 "c/sqlite3.c"
     }
     _sqlite3Dequote($34); //@line 93473 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $44 = ((($15)) + 24|0); //@line 93478 "c/sqlite3.c"
 HEAP32[$44>>2] = 1; //@line 93478 "c/sqlite3.c"
 STACKTOP = sp;return ($15|0); //@line 93481 "c/sqlite3.c"
}
function _sqlite3SrcListShiftJoinType($0) {
 $0 = $0|0;
 var $$010 = 0, $$010$in = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 105556 "c/sqlite3.c"
 if ($1) {
  return; //@line 105563 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 105558 "c/sqlite3.c"
 $3 = ($2|0)>(1); //@line 105558 "c/sqlite3.c"
 if ($3) {
  $$010$in = $2;
  while(1) {
   $$010 = (($$010$in) + -1)|0;
   $4 = (($$010$in) + -2)|0; //@line 105559 "c/sqlite3.c"
   $5 = (((((($0)) + 8|0) + (($4*72)|0)|0)) + 36|0); //@line 105559 "c/sqlite3.c"
   $6 = HEAP8[$5>>0]|0; //@line 105559 "c/sqlite3.c"
   $7 = (((((($0)) + 8|0) + (($$010*72)|0)|0)) + 36|0); //@line 105559 "c/sqlite3.c"
   HEAP8[$7>>0] = $6; //@line 105559 "c/sqlite3.c"
   $8 = ($$010$in|0)>(2); //@line 105558 "c/sqlite3.c"
   if ($8) {
    $$010$in = $$010;
   } else {
    break;
   }
  }
 }
 $9 = ((($0)) + 44|0); //@line 105561 "c/sqlite3.c"
 HEAP8[$9>>0] = 0; //@line 105561 "c/sqlite3.c"
 return; //@line 105563 "c/sqlite3.c"
}
function _sqlite3SrcListIndexedBy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 105505 "c/sqlite3.c"
 if ($3) {
  return; //@line 105521 "c/sqlite3.c"
 }
 $4 = ((($2)) + 4|0); //@line 105505 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 105505 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 105505 "c/sqlite3.c"
 if ($6) {
  return; //@line 105521 "c/sqlite3.c"
 }
 $7 = HEAP32[$1>>2]|0; //@line 105508 "c/sqlite3.c"
 $8 = (($7) + -1)|0; //@line 105508 "c/sqlite3.c"
 $9 = ($5|0)==(1); //@line 105512 "c/sqlite3.c"
 if ($9) {
  $10 = HEAP32[$2>>2]|0; //@line 105512 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 105512 "c/sqlite3.c"
  if ($11) {
   $12 = (((((($1)) + 8|0) + (($8*72)|0)|0)) + 37|0); //@line 105515 "c/sqlite3.c"
   $13 = HEAP8[$12>>0]|0; //@line 105515 "c/sqlite3.c"
   $14 = $13 | 1; //@line 105515 "c/sqlite3.c"
   HEAP8[$12>>0] = $14; //@line 105515 "c/sqlite3.c"
   return; //@line 105521 "c/sqlite3.c"
  }
 }
 $15 = HEAP32[$0>>2]|0; //@line 105517 "c/sqlite3.c"
 $16 = (_sqlite3NameFromToken($15,$2)|0); //@line 105517 "c/sqlite3.c"
 $17 = (((((($1)) + 8|0) + (($8*72)|0)|0)) + 64|0); //@line 105517 "c/sqlite3.c"
 HEAP32[$17>>2] = $16; //@line 105517 "c/sqlite3.c"
 $18 = (((((($1)) + 8|0) + (($8*72)|0)|0)) + 37|0); //@line 105518 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 105518 "c/sqlite3.c"
 $20 = $19 | 2; //@line 105518 "c/sqlite3.c"
 HEAP8[$18>>0] = $20; //@line 105518 "c/sqlite3.c"
 return; //@line 105521 "c/sqlite3.c"
}
function _sqlite3SrcListFuncArgs($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 105528 "c/sqlite3.c"
 if ($3) {
  $10 = HEAP32[$0>>2]|0; //@line 105536 "c/sqlite3.c"
  _sqlite3ExprListDelete($10,$2); //@line 105536 "c/sqlite3.c"
  return; //@line 105538 "c/sqlite3.c"
 } else {
  $4 = HEAP32[$1>>2]|0; //@line 105529 "c/sqlite3.c"
  $5 = (($4) + -1)|0; //@line 105529 "c/sqlite3.c"
  $6 = (((((($1)) + 8|0) + (($5*72)|0)|0)) + 64|0); //@line 105533 "c/sqlite3.c"
  HEAP32[$6>>2] = $2; //@line 105533 "c/sqlite3.c"
  $7 = (((((($1)) + 8|0) + (($5*72)|0)|0)) + 37|0); //@line 105534 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 105534 "c/sqlite3.c"
  $9 = $8 | 4; //@line 105534 "c/sqlite3.c"
  HEAP8[$7>>0] = $9; //@line 105534 "c/sqlite3.c"
  return; //@line 105538 "c/sqlite3.c"
 }
}
function _sqlite3SrcListAppend($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$030 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 105375 "c/sqlite3.c"
 do {
  if ($4) {
   $5 = (_sqlite3DbMallocRawNN($0,80,0)|0); //@line 105376 "c/sqlite3.c"
   $6 = ($5|0)==(0|0); //@line 105377 "c/sqlite3.c"
   if ($6) {
    $$0 = 0;
    return ($$0|0); //@line 105401 "c/sqlite3.c"
   } else {
    $7 = ((($5)) + 4|0); //@line 105378 "c/sqlite3.c"
    HEAP32[$7>>2] = 1; //@line 105378 "c/sqlite3.c"
    HEAP32[$5>>2] = 1; //@line 105379 "c/sqlite3.c"
    $8 = ((($5)) + 8|0); //@line 105380 "c/sqlite3.c"
    dest=$8; stop=dest+72|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 105380 "c/sqlite3.c"
    $9 = ((($5)) + 52|0); //@line 105381 "c/sqlite3.c"
    HEAP32[$9>>2] = -1; //@line 105381 "c/sqlite3.c"
    $$030 = $5;
    break;
   }
  } else {
   $10 = HEAP32[$1>>2]|0; //@line 105383 "c/sqlite3.c"
   $11 = (_sqlite3SrcListEnlarge($0,$1,1,$10)|0); //@line 105383 "c/sqlite3.c"
   $$030 = $11;
  }
 } while(0);
 $12 = ((($0)) + 73|0); //@line 105385 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 105385 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 105385 "c/sqlite3.c"
 if (!($14)) {
  _sqlite3SrcListDelete($0,$$030); //@line 105386 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 105401 "c/sqlite3.c"
 }
 $15 = HEAP32[$$030>>2]|0; //@line 105389 "c/sqlite3.c"
 $16 = (($15) + -1)|0; //@line 105389 "c/sqlite3.c"
 $17 = ($3|0)==(0|0); //@line 105390 "c/sqlite3.c"
 if (!($17)) {
  $18 = HEAP32[$3>>2]|0; //@line 105390 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 105390 "c/sqlite3.c"
  if (!($19)) {
   $20 = (_sqlite3NameFromToken($0,$3)|0); //@line 105394 "c/sqlite3.c"
   $21 = (((((($$030)) + 8|0) + (($16*72)|0)|0)) + 8|0); //@line 105394 "c/sqlite3.c"
   HEAP32[$21>>2] = $20; //@line 105394 "c/sqlite3.c"
   $22 = (_sqlite3NameFromToken($0,$2)|0); //@line 105395 "c/sqlite3.c"
   $23 = (((((($$030)) + 8|0) + (($16*72)|0)|0)) + 4|0); //@line 105395 "c/sqlite3.c"
   HEAP32[$23>>2] = $22; //@line 105395 "c/sqlite3.c"
   $$0 = $$030;
   return ($$0|0); //@line 105401 "c/sqlite3.c"
  }
 }
 $24 = (_sqlite3NameFromToken($0,$2)|0); //@line 105397 "c/sqlite3.c"
 $25 = (((((($$030)) + 8|0) + (($16*72)|0)|0)) + 8|0); //@line 105397 "c/sqlite3.c"
 HEAP32[$25>>2] = $24; //@line 105397 "c/sqlite3.c"
 $26 = (((((($$030)) + 8|0) + (($16*72)|0)|0)) + 4|0); //@line 105398 "c/sqlite3.c"
 HEAP32[$26>>2] = 0; //@line 105398 "c/sqlite3.c"
 $$0 = $$030;
 return ($$0|0); //@line 105401 "c/sqlite3.c"
}
function _sqlite3JoinType($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$03948$lcssa = 0, $$04050 = 0, $$04149 = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond44 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer4 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer = sp;
 $4 = sp + 20|0;
 HEAP32[$4>>2] = $1; //@line 118903 "c/sqlite3.c"
 $5 = ((($4)) + 4|0); //@line 118904 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 118904 "c/sqlite3.c"
 $6 = ((($4)) + 8|0); //@line 118905 "c/sqlite3.c"
 HEAP32[$6>>2] = $3; //@line 118905 "c/sqlite3.c"
 $$04050 = 0;$$04149 = 0;
 L1: while(1) {
  $7 = (($4) + ($$04050<<2)|0); //@line 118906 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 118906 "c/sqlite3.c"
  $9 = ($8|0)==(0|0); //@line 118906 "c/sqlite3.c"
  if ($9) {
   $$2 = $$04149;
   break;
  }
  $10 = ((($8)) + 4|0);
  $11 = HEAP32[$10>>2]|0;
  switch ($11|0) {
  case 7:  {
   $12 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
   $13 = (_sqlite3_strnicmp($12,28138,$11)|0); //@line 118910 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 118910 "c/sqlite3.c"
   if ($14) {
    $$03948$lcssa = 0;
   } else {
    label = 17;
    break L1;
   }
   break;
  }
  case 4:  {
   $30 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
   $31 = (_sqlite3_strnicmp($30,(28144),$11)|0); //@line 118910 "c/sqlite3.c"
   $32 = ($31|0)==(0); //@line 118910 "c/sqlite3.c"
   if ($32) {
    $$03948$lcssa = 1;
   } else {
    $39 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
    $40 = (_sqlite3_strnicmp($39,(28157),$11)|0); //@line 118910 "c/sqlite3.c"
    $41 = ($40|0)==(0); //@line 118910 "c/sqlite3.c"
    if ($41) {
     $$03948$lcssa = 4;
    } else {
     label = 17;
     break L1;
    }
   }
   break;
  }
  case 5:  {
   $33 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
   $34 = (_sqlite3_strnicmp($33,(28148),$11)|0); //@line 118910 "c/sqlite3.c"
   $35 = ($34|0)==(0); //@line 118910 "c/sqlite3.c"
   if ($35) {
    $$03948$lcssa = 2;
   } else {
    $36 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
    $37 = (_sqlite3_strnicmp($36,(28152),$11)|0); //@line 118910 "c/sqlite3.c"
    $38 = ($37|0)==(0); //@line 118910 "c/sqlite3.c"
    if ($38) {
     $$03948$lcssa = 3;
    } else {
     $42 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
     $43 = (_sqlite3_strnicmp($42,(28161),$11)|0); //@line 118910 "c/sqlite3.c"
     $44 = ($43|0)==(0); //@line 118910 "c/sqlite3.c"
     if ($44) {
      $$03948$lcssa = 5;
     } else {
      $45 = HEAP32[$8>>2]|0; //@line 118910 "c/sqlite3.c"
      $46 = (_sqlite3_strnicmp($45,(28166),$11)|0); //@line 118910 "c/sqlite3.c"
      $47 = ($46|0)==(0); //@line 118910 "c/sqlite3.c"
      if ($47) {
       $$03948$lcssa = 6;
      } else {
       label = 17;
       break L1;
      }
     }
    }
   }
   break;
  }
  default: {
   label = 17;
   break L1;
  }
  }
  $15 = (((28172 + (($$03948$lcssa*3)|0)|0)) + 2|0); //@line 118911 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 118911 "c/sqlite3.c"
  $17 = $16&255; //@line 118911 "c/sqlite3.c"
  $18 = $$04149 | $17; //@line 118911 "c/sqlite3.c"
  $19 = (($$04050) + 1)|0; //@line 118906 "c/sqlite3.c"
  $20 = ($19>>>0)<(3); //@line 118906 "c/sqlite3.c"
  if ($20) {
   $$04050 = $19;$$04149 = $18;
  } else {
   $$2 = $18;
   break;
  }
 }
 if ((label|0) == 17) {
  $48 = $$04149 | 64; //@line 118917 "c/sqlite3.c"
  $$2 = $48;
 }
 $21 = $$2 & 33; //@line 118922 "c/sqlite3.c"
 $22 = ($21|0)!=(33); //@line 118922 "c/sqlite3.c"
 $23 = $$2 & 64; //@line 118923 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 118923 "c/sqlite3.c"
 $or$cond = $22 & $24; //@line 118922 "c/sqlite3.c"
 if (!($or$cond)) {
  $25 = ($3|0)==(0|0); //@line 118927 "c/sqlite3.c"
  $spec$select = $25 ? (17828) : 17827; //@line 118927 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $1; //@line 118928 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 118928 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $2; //@line 118928 "c/sqlite3.c"
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 118928 "c/sqlite3.c"
  HEAP32[$vararg_ptr2>>2] = $spec$select; //@line 118928 "c/sqlite3.c"
  $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 118928 "c/sqlite3.c"
  HEAP32[$vararg_ptr3>>2] = $3; //@line 118928 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,28193,$vararg_buffer); //@line 118928 "c/sqlite3.c"
  $$3 = 1;
  STACKTOP = sp;return ($$3|0); //@line 118937 "c/sqlite3.c"
 }
 $26 = $$2 & 32; //@line 118931 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 118931 "c/sqlite3.c"
 $28 = $$2 & 24; //@line 118932 "c/sqlite3.c"
 $29 = ($28|0)==(8); //@line 118932 "c/sqlite3.c"
 $or$cond44 = $27 | $29; //@line 118932 "c/sqlite3.c"
 if ($or$cond44) {
  $$3 = $$2;
  STACKTOP = sp;return ($$3|0); //@line 118937 "c/sqlite3.c"
 }
 _sqlite3ErrorMsg($0,28237,$vararg_buffer4); //@line 118933 "c/sqlite3.c"
 $$3 = 1;
 STACKTOP = sp;return ($$3|0); //@line 118937 "c/sqlite3.c"
}
function _sqlite3ExprListSetSortOrder($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 94298 "c/sqlite3.c"
 $3 = ($1|0)<(0); //@line 94301 "c/sqlite3.c"
 $or$cond = $2 | $3; //@line 94298 "c/sqlite3.c"
 if ($or$cond) {
  return; //@line 94306 "c/sqlite3.c"
 }
 $4 = $1&255; //@line 94305 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 94305 "c/sqlite3.c"
 $6 = (($5) + -1)|0; //@line 94305 "c/sqlite3.c"
 $7 = (((((($0)) + 4|0) + (($6*20)|0)|0)) + 12|0); //@line 94305 "c/sqlite3.c"
 HEAP8[$7>>0] = $4; //@line 94305 "c/sqlite3.c"
 return; //@line 94306 "c/sqlite3.c"
}
function _sqlite3WithPush($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 122815 "c/sqlite3.c"
 if ($3) {
  return; //@line 122821 "c/sqlite3.c"
 }
 $4 = ((($0)) + 464|0); //@line 122817 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 122817 "c/sqlite3.c"
 $6 = ((($1)) + 4|0); //@line 122817 "c/sqlite3.c"
 HEAP32[$6>>2] = $5; //@line 122817 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 122818 "c/sqlite3.c"
 $7 = ($2<<24>>24)==(0); //@line 122819 "c/sqlite3.c"
 if ($7) {
  return; //@line 122821 "c/sqlite3.c"
 }
 $8 = ((($0)) + 468|0); //@line 122819 "c/sqlite3.c"
 HEAP32[$8>>2] = $1; //@line 122819 "c/sqlite3.c"
 return; //@line 122821 "c/sqlite3.c"
}
function _sqlite3DeleteFrom($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03009 = 0, $$0301 = 0, $$030113 = 0, $$030115 = 0, $$0303 = 0, $$0304 = 0, $$0305 = 0, $$0306 = 0, $$0307 = 0, $$0308 = 0, $$03085 = 0, $$0309 = 0, $$0311 = 0, $$0312 = 0, $$0313 = 0, $$03141 = 0, $$0316$lcssa = 0, $$031614 = 0, $$0317 = 0, $$1 = 0;
 var $$110 = 0, $$111 = 0, $$1310 = 0, $$13103 = 0, $$2 = 0, $$3 = 0, $$promoted = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0;
 var $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0;
 var $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0;
 var $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0;
 var $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0;
 var $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0;
 var $202 = 0, $203 = 0, $204 = 0, $205 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $narrow = 0, $or$cond$not = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $3 = sp + 52|0;
 $4 = sp + 48|0;
 $5 = sp;
 $6 = sp + 16|0;
 $7 = sp + 8|0;
 HEAP32[$3>>2] = 0; //@line 106801 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 106802 "c/sqlite3.c"
 $8 = $5; //@line 106831 "c/sqlite3.c"
 $9 = $8; //@line 106831 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 106831 "c/sqlite3.c"
 $10 = (($8) + 4)|0; //@line 106831 "c/sqlite3.c"
 $11 = $10; //@line 106831 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 106831 "c/sqlite3.c"
 $12 = HEAP32[$0>>2]|0; //@line 106832 "c/sqlite3.c"
 $13 = ((($0)) + 36|0); //@line 106833 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 106833 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 106833 "c/sqlite3.c"
 L1: do {
  if ($15) {
   $16 = ((($12)) + 73|0); //@line 106833 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 106833 "c/sqlite3.c"
   $18 = ($17<<24>>24)==(0); //@line 106833 "c/sqlite3.c"
   if ($18) {
    $19 = (_sqlite3SrcListLookup($0,$1)|0); //@line 106844 "c/sqlite3.c"
    $20 = ($19|0)==(0|0); //@line 106845 "c/sqlite3.c"
    if ($20) {
     $$3 = 0;
    } else {
     $21 = (_sqlite3TriggersExist($0,$19,109,0,0)|0); //@line 106851 "c/sqlite3.c"
     $22 = ((($19)) + 12|0); //@line 106852 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 106852 "c/sqlite3.c"
     $24 = ($23|0)!=(0|0); //@line 106852 "c/sqlite3.c"
     $25 = ($21|0)!=(0|0); //@line 106857 "c/sqlite3.c"
     if ($25) {
      $73 = 1;
     } else {
      $26 = (_sqlite3FkRequired($0,$19,0,0)|0); //@line 106857 "c/sqlite3.c"
      $27 = ($26|0)!=(0); //@line 106857 "c/sqlite3.c"
      $73 = $27;
     }
     $28 = (_sqlite3ViewGetColumnNames($0,$19)|0); //@line 106875 "c/sqlite3.c"
     $29 = ($28|0)==(0); //@line 106875 "c/sqlite3.c"
     if ($29) {
      $30 = $25&1; //@line 106879 "c/sqlite3.c"
      $31 = (_sqlite3IsReadOnly($0,$19,$30)|0); //@line 106879 "c/sqlite3.c"
      $32 = ($31|0)==(0); //@line 106879 "c/sqlite3.c"
      if ($32) {
       $33 = ((($19)) + 72|0); //@line 106882 "c/sqlite3.c"
       $34 = HEAP32[$33>>2]|0; //@line 106882 "c/sqlite3.c"
       $35 = (_sqlite3SchemaToIndex($12,$34)|0); //@line 106882 "c/sqlite3.c"
       $36 = HEAP32[$19>>2]|0; //@line 106884 "c/sqlite3.c"
       $37 = ((($12)) + 16|0); //@line 106885 "c/sqlite3.c"
       $38 = HEAP32[$37>>2]|0; //@line 106885 "c/sqlite3.c"
       $39 = (($38) + ($35<<4)|0); //@line 106885 "c/sqlite3.c"
       $40 = HEAP32[$39>>2]|0; //@line 106885 "c/sqlite3.c"
       $41 = (_sqlite3AuthCheck($0,9,$36,0,$40)|0); //@line 106884 "c/sqlite3.c"
       $42 = ($41|0)==(1); //@line 106887 "c/sqlite3.c"
       if ($42) {
        $$3 = 0;
       } else {
        $43 = ((($0)) + 40|0); //@line 106895 "c/sqlite3.c"
        $44 = HEAP32[$43>>2]|0; //@line 106895 "c/sqlite3.c"
        $45 = (($44) + 1)|0; //@line 106895 "c/sqlite3.c"
        HEAP32[$43>>2] = $45; //@line 106895 "c/sqlite3.c"
        $46 = ((($1)) + 52|0); //@line 106895 "c/sqlite3.c"
        HEAP32[$46>>2] = $44; //@line 106895 "c/sqlite3.c"
        $47 = ((($19)) + 8|0); //@line 106896 "c/sqlite3.c"
        $$030113 = HEAP32[$47>>2]|0;
        $48 = ($$030113|0)==(0|0); //@line 106896 "c/sqlite3.c"
        if ($48) {
         $$0316$lcssa = 0;
        } else {
         $$promoted = HEAP32[$43>>2]|0; //@line 106897 "c/sqlite3.c"
         $$030115 = $$030113;$$031614 = 0;$50 = $$promoted;
         while(1) {
          $49 = (($50) + 1)|0; //@line 106897 "c/sqlite3.c"
          $51 = ((($$030115)) + 20|0); //@line 106896 "c/sqlite3.c"
          $52 = (($$031614) + 1)|0; //@line 106896 "c/sqlite3.c"
          $$0301 = HEAP32[$51>>2]|0;
          $53 = ($$0301|0)==(0|0); //@line 106896 "c/sqlite3.c"
          if ($53) {
           break;
          } else {
           $$030115 = $$0301;$$031614 = $52;$50 = $49;
          }
         }
         HEAP32[$43>>2] = $49; //@line 106897 "c/sqlite3.c"
         $$0316$lcssa = $52;
        }
        if ($24) {
         $54 = HEAP32[$19>>2]|0; //@line 106903 "c/sqlite3.c"
         _sqlite3AuthContextPush($0,$5,$54); //@line 106903 "c/sqlite3.c"
        }
        $55 = (_sqlite3GetVdbe($0)|0); //@line 106908 "c/sqlite3.c"
        $56 = ($55|0)==(0|0); //@line 106909 "c/sqlite3.c"
        if ($56) {
         $$3 = 0;
        } else {
         $57 = ((($0)) + 18|0); //@line 106912 "c/sqlite3.c"
         $58 = HEAP8[$57>>0]|0; //@line 106912 "c/sqlite3.c"
         $59 = ($58<<24>>24)==(0); //@line 106912 "c/sqlite3.c"
         if ($59) {
          _sqlite3VdbeCountChanges($55); //@line 106912 "c/sqlite3.c"
         }
         _sqlite3BeginWriteOperation($0,1,$35); //@line 106913 "c/sqlite3.c"
         if ($24) {
          _sqlite3MaterializeView($0,$19,$2,$44); //@line 106920 "c/sqlite3.c"
          HEAP32[$4>>2] = $44; //@line 106923 "c/sqlite3.c"
          HEAP32[$3>>2] = $44; //@line 106923 "c/sqlite3.c"
         }
         $60 = ((($6)) + 8|0);
         ;HEAP32[$60>>2]=0|0;HEAP32[$60+4>>2]=0|0;HEAP32[$60+8>>2]=0|0;HEAP32[$60+12>>2]=0|0;HEAP32[$60+16>>2]=0|0;HEAP32[$60+20>>2]=0|0; //@line 106931 "c/sqlite3.c"
         HEAP32[$6>>2] = $0; //@line 106932 "c/sqlite3.c"
         $61 = ((($6)) + 4|0); //@line 106933 "c/sqlite3.c"
         HEAP32[$61>>2] = $1; //@line 106933 "c/sqlite3.c"
         $62 = (_sqlite3ResolveExprNames($6,$2)|0); //@line 106934 "c/sqlite3.c"
         $63 = ($62|0)==(0); //@line 106934 "c/sqlite3.c"
         if ($63) {
          $64 = ((($12)) + 28|0); //@line 106941 "c/sqlite3.c"
          $65 = HEAP32[$64>>2]|0; //@line 106941 "c/sqlite3.c"
          $66 = $65 & 128; //@line 106941 "c/sqlite3.c"
          $67 = ($66|0)==(0); //@line 106941 "c/sqlite3.c"
          if ($67) {
           $$0317 = -1;
          } else {
           $68 = ((($0)) + 44|0); //@line 106942 "c/sqlite3.c"
           $69 = HEAP32[$68>>2]|0; //@line 106942 "c/sqlite3.c"
           $70 = (($69) + 1)|0; //@line 106942 "c/sqlite3.c"
           HEAP32[$68>>2] = $70; //@line 106942 "c/sqlite3.c"
           (_sqlite3VdbeAddOp2($55,67,0,$70)|0); //@line 106943 "c/sqlite3.c"
           $$0317 = $70;
          }
          $71 = ($41|0)!=(0); //@line 106958 "c/sqlite3.c"
          $72 = ($2|0)!=(0|0); //@line 106959 "c/sqlite3.c"
          $or$cond$not = $72 | $71; //@line 106959 "c/sqlite3.c"
          $or$cond3 = $73 | $or$cond$not; //@line 106959 "c/sqlite3.c"
          if ($or$cond3) {
           label = 30;
          } else {
           $74 = ((($19)) + 56|0); //@line 106961 "c/sqlite3.c"
           $75 = HEAP32[$74>>2]|0; //@line 106961 "c/sqlite3.c"
           $76 = ($75|0)==(0); //@line 106961 "c/sqlite3.c"
           if ($76) {
            $77 = ((($19)) + 28|0); //@line 106967 "c/sqlite3.c"
            $78 = HEAP32[$77>>2]|0; //@line 106967 "c/sqlite3.c"
            $79 = HEAP32[$19>>2]|0; //@line 106967 "c/sqlite3.c"
            _sqlite3TableLock($0,$35,$78,1,$79); //@line 106967 "c/sqlite3.c"
            $80 = ((($19)) + 36|0); //@line 106968 "c/sqlite3.c"
            $81 = HEAP32[$80>>2]|0; //@line 106968 "c/sqlite3.c"
            $82 = $81 & 32; //@line 106968 "c/sqlite3.c"
            $83 = ($82|0)==(0); //@line 106968 "c/sqlite3.c"
            if ($83) {
             $84 = HEAP32[$77>>2]|0; //@line 106969 "c/sqlite3.c"
             $85 = HEAP32[$19>>2]|0; //@line 106970 "c/sqlite3.c"
             (_sqlite3VdbeAddOp4($55,134,$84,$35,$$0317,$85,-1)|0); //@line 106969 "c/sqlite3.c"
            }
            $$110 = HEAP32[$47>>2]|0;
            $86 = ($$110|0)==(0|0); //@line 106972 "c/sqlite3.c"
            if ($86) {
             $$2 = 0;
            } else {
             $$111 = $$110;
             while(1) {
              $87 = ((($$111)) + 44|0); //@line 106974 "c/sqlite3.c"
              $88 = HEAP32[$87>>2]|0; //@line 106974 "c/sqlite3.c"
              (_sqlite3VdbeAddOp2($55,134,$88,$35)|0); //@line 106974 "c/sqlite3.c"
              $89 = ((($$111)) + 20|0); //@line 106972 "c/sqlite3.c"
              $$1 = HEAP32[$89>>2]|0;
              $90 = ($$1|0)==(0|0); //@line 106972 "c/sqlite3.c"
              if ($90) {
               $$2 = 0;
               break;
              } else {
               $$111 = $$1;
              }
             }
            }
           } else {
            label = 30;
           }
          }
          do {
           if ((label|0) == 30) {
            $91 = ((($6)) + 28|0); //@line 106980 "c/sqlite3.c"
            $92 = HEAP16[$91>>1]|0; //@line 106980 "c/sqlite3.c"
            $93 = $92 & 64; //@line 106980 "c/sqlite3.c"
            $94 = ($93<<16>>16)!=(0); //@line 106980 "c/sqlite3.c"
            $narrow = $73 | $94; //@line 106980 "c/sqlite3.c"
            $95 = $narrow ? 1044 : 1052; //@line 106981 "c/sqlite3.c"
            $96 = ((($19)) + 36|0); //@line 106982 "c/sqlite3.c"
            $97 = HEAP32[$96>>2]|0; //@line 106982 "c/sqlite3.c"
            $98 = $97 & 32; //@line 106982 "c/sqlite3.c"
            $99 = ($98|0)==(0); //@line 106982 "c/sqlite3.c"
            if ($99) {
             $100 = ((($0)) + 44|0); //@line 106986 "c/sqlite3.c"
             $101 = HEAP32[$100>>2]|0; //@line 106986 "c/sqlite3.c"
             $102 = (($101) + 1)|0; //@line 106986 "c/sqlite3.c"
             HEAP32[$100>>2] = $102; //@line 106986 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($55,70,0,$102)|0); //@line 106987 "c/sqlite3.c"
             $$0303 = 0;$$0306 = $102;$$0307 = 0;$$0311 = 1;$$0312 = 0;$$0313 = 0;
            } else {
             $103 = (_sqlite3PrimaryKeyIndex($19)|0); //@line 106991 "c/sqlite3.c"
             $104 = ((($103)) + 50|0); //@line 106993 "c/sqlite3.c"
             $105 = HEAP16[$104>>1]|0; //@line 106993 "c/sqlite3.c"
             $106 = ((($0)) + 44|0); //@line 106994 "c/sqlite3.c"
             $107 = HEAP32[$106>>2]|0; //@line 106994 "c/sqlite3.c"
             $108 = (($107) + 1)|0; //@line 106994 "c/sqlite3.c"
             $109 = $105 << 16 >> 16; //@line 106995 "c/sqlite3.c"
             $110 = (($107) + ($109))|0; //@line 106995 "c/sqlite3.c"
             HEAP32[$106>>2] = $110; //@line 106995 "c/sqlite3.c"
             $111 = HEAP32[$43>>2]|0; //@line 106996 "c/sqlite3.c"
             $112 = (($111) + 1)|0; //@line 106996 "c/sqlite3.c"
             HEAP32[$43>>2] = $112; //@line 106996 "c/sqlite3.c"
             $113 = (_sqlite3VdbeAddOp2($55,109,$111,$109)|0); //@line 106997 "c/sqlite3.c"
             _sqlite3VdbeSetP4KeyInfo($0,$103); //@line 106998 "c/sqlite3.c"
             $$0303 = $113;$$0306 = 0;$$0307 = $111;$$0311 = $105;$$0312 = $108;$$0313 = $103;
            }
            $114 = (_sqlite3WhereBegin($0,$1,$2,0,0,$95,$45)|0); //@line 107009 "c/sqlite3.c"
            $115 = ($114|0)==(0|0); //@line 107010 "c/sqlite3.c"
            if ($115) {
             $$3 = 0;
             break L1;
            }
            $116 = (_sqlite3WhereOkOnePass($114,$7)|0); //@line 107011 "c/sqlite3.c"
            $117 = HEAP32[$64>>2]|0; //@line 107016 "c/sqlite3.c"
            $118 = $117 & 128; //@line 107016 "c/sqlite3.c"
            $119 = ($118|0)==(0); //@line 107016 "c/sqlite3.c"
            if (!($119)) {
             (_sqlite3VdbeAddOp2($55,80,$$0317,1)|0); //@line 107017 "c/sqlite3.c"
            }
            $120 = ($$0313|0)!=(0|0); //@line 107021 "c/sqlite3.c"
            do {
             if ($120) {
              $121 = $$0311 << 16 >> 16; //@line 107022 "c/sqlite3.c"
              $122 = ($$0311<<16>>16)>(0); //@line 107022 "c/sqlite3.c"
              if (!($122)) {
               $$0309 = $$0312;
               break;
              }
              $123 = ((($$0313)) + 4|0);
              $$03009 = 0;
              while(1) {
               $124 = HEAP32[$123>>2]|0; //@line 107025 "c/sqlite3.c"
               $125 = (($124) + ($$03009<<1)|0); //@line 107025 "c/sqlite3.c"
               $126 = HEAP16[$125>>1]|0; //@line 107025 "c/sqlite3.c"
               $127 = $126 << 16 >> 16; //@line 107025 "c/sqlite3.c"
               $128 = (($$03009) + ($$0312))|0; //@line 107025 "c/sqlite3.c"
               _sqlite3ExprCodeGetColumnOfTable($55,$19,$44,$127,$128); //@line 107024 "c/sqlite3.c"
               $129 = (($$03009) + 1)|0; //@line 107022 "c/sqlite3.c"
               $exitcond = ($129|0)==($121|0); //@line 107022 "c/sqlite3.c"
               if ($exitcond) {
                $$0309 = $$0312;
                break;
               } else {
                $$03009 = $129;
               }
              }
             } else {
              $130 = ((($0)) + 44|0); //@line 107029 "c/sqlite3.c"
              $131 = HEAP32[$130>>2]|0; //@line 107029 "c/sqlite3.c"
              $132 = (($131) + 1)|0; //@line 107029 "c/sqlite3.c"
              $133 = (_sqlite3ExprCodeGetColumn($0,$19,-1,$44,$132,0)|0); //@line 107030 "c/sqlite3.c"
              $134 = HEAP32[$130>>2]|0; //@line 107031 "c/sqlite3.c"
              $135 = ($133|0)>($134|0); //@line 107031 "c/sqlite3.c"
              if (!($135)) {
               $$0309 = $133;
               break;
              }
              HEAP32[$130>>2] = $133; //@line 107031 "c/sqlite3.c"
              $$0309 = $133;
             }
            } while(0);
            $136 = ($116|0)!=(0); //@line 107034 "c/sqlite3.c"
            if ($136) {
             $137 = (($$0316$lcssa) + 2)|0; //@line 107039 "c/sqlite3.c"
             $138 = (_sqlite3DbMallocRawNN($12,$137,0)|0); //@line 107039 "c/sqlite3.c"
             $139 = ($138|0)==(0|0); //@line 107040 "c/sqlite3.c"
             if ($139) {
              _sqlite3WhereEnd($114); //@line 107041 "c/sqlite3.c"
              $$3 = 0;
              break L1;
             }
             $140 = (($$0316$lcssa) + 1)|0; //@line 107044 "c/sqlite3.c"
             _memset(($138|0),1,($140|0))|0; //@line 107044 "c/sqlite3.c"
             $141 = (($138) + ($140)|0); //@line 107045 "c/sqlite3.c"
             HEAP8[$141>>0] = 0; //@line 107045 "c/sqlite3.c"
             $142 = HEAP32[$7>>2]|0; //@line 107046 "c/sqlite3.c"
             $143 = ($142|0)>(-1); //@line 107046 "c/sqlite3.c"
             if ($143) {
              $144 = (($142) - ($44))|0; //@line 107046 "c/sqlite3.c"
              $145 = (($138) + ($144)|0); //@line 107046 "c/sqlite3.c"
              HEAP8[$145>>0] = 0; //@line 107046 "c/sqlite3.c"
             }
             $146 = ((($7)) + 4|0); //@line 107047 "c/sqlite3.c"
             $147 = HEAP32[$146>>2]|0; //@line 107047 "c/sqlite3.c"
             $148 = ($147|0)>(-1); //@line 107047 "c/sqlite3.c"
             if ($148) {
              $149 = (($147) - ($44))|0; //@line 107047 "c/sqlite3.c"
              $150 = (($138) + ($149)|0); //@line 107047 "c/sqlite3.c"
              HEAP8[$150>>0] = 0; //@line 107047 "c/sqlite3.c"
             }
             $151 = ($$0303|0)==(0); //@line 107048 "c/sqlite3.c"
             if (!($151)) {
              (_sqlite3VdbeChangeToNoop($55,$$0303)|0); //@line 107048 "c/sqlite3.c"
             }
             $158 = (_sqlite3VdbeMakeLabel($55)|0); //@line 107067 "c/sqlite3.c"
             $$0305 = $158;$$03085 = $$0311;$$03141 = $138;$$13103 = $$0309;
            } else {
             if ($120) {
              $152 = ((($0)) + 44|0); //@line 107052 "c/sqlite3.c"
              $153 = HEAP32[$152>>2]|0; //@line 107052 "c/sqlite3.c"
              $154 = (($153) + 1)|0; //@line 107052 "c/sqlite3.c"
              HEAP32[$152>>2] = $154; //@line 107052 "c/sqlite3.c"
              $155 = $$0311 << 16 >> 16; //@line 107054 "c/sqlite3.c"
              $156 = HEAP32[$0>>2]|0; //@line 107055 "c/sqlite3.c"
              $157 = (_sqlite3IndexAffinityStr($156,$$0313)|0); //@line 107055 "c/sqlite3.c"
              (_sqlite3VdbeAddOp4($55,100,$$0312,$155,$154,$157,$155)|0); //@line 107054 "c/sqlite3.c"
              (_sqlite3VdbeAddOp4Int($55,128,$$0307,$154,$$0312,$155)|0); //@line 107056 "c/sqlite3.c"
              $$0308 = 0;$$1310 = $154;
             } else {
              (_sqlite3VdbeAddOp2($55,144,$$0306,$$0309)|0); //@line 107060 "c/sqlite3.c"
              $$0308 = 1;$$1310 = $$0309;
             }
             _sqlite3WhereEnd($114); //@line 107069 "c/sqlite3.c"
             $$0305 = 0;$$03085 = $$0308;$$03141 = 0;$$13103 = $$1310;
            }
            do {
             if (!($24)) {
              $159 = ($116|0)==(2); //@line 107079 "c/sqlite3.c"
              if ($159) {
               $160 = (_sqlite3VdbeAddOp0($55,20)|0); //@line 107080 "c/sqlite3.c"
               (_sqlite3OpenTableAndIndices($0,$19,106,8,$44,$$03141,$3,$4)|0); //@line 107083 "c/sqlite3.c"
               _sqlite3VdbeJumpHere($55,$160); //@line 107087 "c/sqlite3.c"
               break;
              } else {
               (_sqlite3OpenTableAndIndices($0,$19,106,8,$44,$$03141,$3,$4)|0); //@line 107083 "c/sqlite3.c"
               break;
              }
             }
            } while(0);
            do {
             if ($136) {
              $161 = ((($19)) + 56|0); //@line 107095 "c/sqlite3.c"
              $162 = HEAP32[$161>>2]|0; //@line 107095 "c/sqlite3.c"
              $163 = ($162|0)==(0); //@line 107095 "c/sqlite3.c"
              if (!($163)) {
               $$0304 = 0;
               break;
              }
              $164 = HEAP32[$3>>2]|0; //@line 107095 "c/sqlite3.c"
              $165 = (($164) - ($44))|0; //@line 107095 "c/sqlite3.c"
              $166 = (($$03141) + ($165)|0); //@line 107095 "c/sqlite3.c"
              $167 = HEAP8[$166>>0]|0; //@line 107095 "c/sqlite3.c"
              $168 = ($167<<24>>24)==(0); //@line 107095 "c/sqlite3.c"
              if ($168) {
               $$0304 = 0;
               break;
              }
              $169 = $$03085 << 16 >> 16; //@line 107097 "c/sqlite3.c"
              (_sqlite3VdbeAddOp4Int($55,29,$164,$$0305,$$13103,$169)|0); //@line 107097 "c/sqlite3.c"
              $$0304 = 0;
             } else {
              if (!($120)) {
               $174 = (_sqlite3VdbeAddOp3($55,42,$$0306,0,$$13103)|0); //@line 107109 "c/sqlite3.c"
               $$0304 = $174;
               break;
              }
              $170 = (_sqlite3VdbeAddOp1($55,37,$$0307)|0); //@line 107101 "c/sqlite3.c"
              $171 = ((($19)) + 56|0); //@line 107102 "c/sqlite3.c"
              $172 = HEAP32[$171>>2]|0; //@line 107102 "c/sqlite3.c"
              $173 = ($172|0)==(0); //@line 107102 "c/sqlite3.c"
              if ($173) {
               (_sqlite3VdbeAddOp2($55,123,$$0307,$$13103)|0); //@line 107105 "c/sqlite3.c"
               $$0304 = $170;
               break;
              } else {
               (_sqlite3VdbeAddOp3($55,98,$$0307,0,$$13103)|0); //@line 107103 "c/sqlite3.c"
               $$0304 = $170;
               break;
              }
             }
            } while(0);
            $175 = ((($19)) + 56|0); //@line 107116 "c/sqlite3.c"
            $176 = HEAP32[$175>>2]|0; //@line 107116 "c/sqlite3.c"
            $177 = ($176|0)==(0); //@line 107116 "c/sqlite3.c"
            do {
             if ($177) {
              $184 = HEAP8[$57>>0]|0; //@line 107129 "c/sqlite3.c"
              $185 = ($184<<24>>24)==(0); //@line 107129 "c/sqlite3.c"
              $186 = HEAP32[$3>>2]|0; //@line 107130 "c/sqlite3.c"
              $187 = HEAP32[$4>>2]|0; //@line 107130 "c/sqlite3.c"
              $188 = $185&1; //@line 107131 "c/sqlite3.c"
              $189 = $116&255; //@line 107131 "c/sqlite3.c"
              $190 = ((($7)) + 4|0); //@line 107131 "c/sqlite3.c"
              $191 = HEAP32[$190>>2]|0; //@line 107131 "c/sqlite3.c"
              _sqlite3GenerateRowDelete($0,$19,$21,$186,$187,$$13103,$$03085,$188,10,$189,$191); //@line 107130 "c/sqlite3.c"
             } else {
              $178 = (_sqlite3GetVTable($12,$19)|0); //@line 107117 "c/sqlite3.c"
              _sqlite3VtabMakeWritable($0,$19); //@line 107118 "c/sqlite3.c"
              (_sqlite3VdbeAddOp4($55,12,0,1,$$13103,$178,-12)|0); //@line 107119 "c/sqlite3.c"
              _sqlite3VdbeChangeP5($55,2); //@line 107120 "c/sqlite3.c"
              _sqlite3MayAbort($0); //@line 107122 "c/sqlite3.c"
              $179 = ($116|0)==(1); //@line 107123 "c/sqlite3.c"
              if (!($179)) {
               break;
              }
              $180 = ((($0)) + 120|0); //@line 107123 "c/sqlite3.c"
              $181 = HEAP32[$180>>2]|0; //@line 107123 "c/sqlite3.c"
              $182 = ($181|0)==(0|0); //@line 107123 "c/sqlite3.c"
              if (!($182)) {
               break;
              }
              $183 = ((($0)) + 20|0); //@line 107124 "c/sqlite3.c"
              HEAP8[$183>>0] = 0; //@line 107124 "c/sqlite3.c"
             }
            } while(0);
            if ($136) {
             _sqlite3VdbeResolveLabel($55,$$0305); //@line 107136 "c/sqlite3.c"
             _sqlite3WhereEnd($114); //@line 107137 "c/sqlite3.c"
             $$2 = $$03141;
             break;
            }
            if ($120) {
             $192 = (($$0304) + 1)|0; //@line 107139 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($55,7,$$0307,$192)|0); //@line 107139 "c/sqlite3.c"
             _sqlite3VdbeJumpHere($55,$$0304); //@line 107140 "c/sqlite3.c"
             $$2 = $$03141;
             break;
            } else {
             _sqlite3VdbeGoto($55,$$0304); //@line 107142 "c/sqlite3.c"
             _sqlite3VdbeJumpHere($55,$$0304); //@line 107143 "c/sqlite3.c"
             $$2 = $$03141;
             break;
            }
           }
          } while(0);
          $193 = HEAP8[$57>>0]|0; //@line 107151 "c/sqlite3.c"
          $194 = ($193<<24>>24)==(0); //@line 107151 "c/sqlite3.c"
          if ($194) {
           $195 = ((($0)) + 124|0); //@line 107151 "c/sqlite3.c"
           $196 = HEAP32[$195>>2]|0; //@line 107151 "c/sqlite3.c"
           $197 = ($196|0)==(0|0); //@line 107151 "c/sqlite3.c"
           if ($197) {
            _sqlite3AutoincrementEnd($0); //@line 107152 "c/sqlite3.c"
           }
          }
          $198 = HEAP32[$64>>2]|0; //@line 107159 "c/sqlite3.c"
          $199 = $198 & 128; //@line 107159 "c/sqlite3.c"
          $200 = ($199|0)==(0); //@line 107159 "c/sqlite3.c"
          if ($200) {
           $$3 = $$2;
          } else {
           $201 = HEAP8[$57>>0]|0; //@line 107159 "c/sqlite3.c"
           $202 = ($201<<24>>24)==(0); //@line 107159 "c/sqlite3.c"
           if ($202) {
            $203 = ((($0)) + 124|0); //@line 107159 "c/sqlite3.c"
            $204 = HEAP32[$203>>2]|0; //@line 107159 "c/sqlite3.c"
            $205 = ($204|0)==(0|0); //@line 107159 "c/sqlite3.c"
            if ($205) {
             (_sqlite3VdbeAddOp2($55,78,$$0317,1)|0); //@line 107160 "c/sqlite3.c"
             _sqlite3VdbeSetNumCols($55,1); //@line 107161 "c/sqlite3.c"
             _sqlite3VdbeSetColName($55,0,0,28125,0); //@line 107162 "c/sqlite3.c"
             $$3 = $$2;
            } else {
             $$3 = $$2;
            }
           } else {
            $$3 = $$2;
           }
          }
         } else {
          $$3 = 0;
         }
        }
       }
      } else {
       $$3 = 0;
      }
     } else {
      $$3 = 0;
     }
    }
   } else {
    $$3 = 0;
   }
  } else {
   $$3 = 0;
  }
 } while(0);
 _sqlite3AuthContextPop($5); //@line 107166 "c/sqlite3.c"
 _sqlite3SrcListDelete($12,$1); //@line 107167 "c/sqlite3.c"
 _sqlite3ExprDelete($12,$2); //@line 107168 "c/sqlite3.c"
 _sqlite3DbFree($12,$$3); //@line 107173 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 107175 "c/sqlite3.c"
}
function _sqlite3ExprListCheckLength($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 94362 "c/sqlite3.c"
 $3 = ($1|0)==(0|0); //@line 94369 "c/sqlite3.c"
 if ($3) {
  STACKTOP = sp;return; //@line 94372 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 94366 "c/sqlite3.c"
 $5 = ((($4)) + 108|0); //@line 94366 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 94366 "c/sqlite3.c"
 $7 = HEAP32[$1>>2]|0; //@line 94369 "c/sqlite3.c"
 $8 = ($7|0)>($6|0); //@line 94369 "c/sqlite3.c"
 if (!($8)) {
  STACKTOP = sp;return; //@line 94372 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer>>2] = $2; //@line 94370 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,28102,$vararg_buffer); //@line 94370 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 94372 "c/sqlite3.c"
}
function _sqlite3Update($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0635 = 0, $$0637 = 0, $$0638 = 0, $$0640 = 0, $$0641 = 0, $$0643 = 0, $$0644 = 0, $$0645 = 0, $$0646 = 0, $$0647 = 0, $$0648 = 0, $$064822 = 0, $$064823 = 0, $$0649 = 0, $$065065 = 0, $$0653 = 0, $$0654 = 0, $$065484 = 0, $$065487 = 0;
 var $$0657 = 0, $$0659$lcssa = 0, $$065986 = 0, $$0660$lcssa = 0, $$066085 = 0, $$0664$lcssa = 0, $$066471 = 0, $$0669$lcssa = 0, $$066970 = 0, $$0673$lcssa = 0, $$067369 = 0, $$163372 = 0, $$1636 = 0, $$163624 = 0, $$163625 = 0, $$1639 = 0, $$1642 = 0, $$165118 = 0, $$1655 = 0, $$165557 = 0;
 var $$165559 = 0, $$1658 = 0, $$1661 = 0, $$1663 = 0, $$1665 = 0, $$1670 = 0, $$1674 = 0, $$2 = 0, $$263454 = 0, $$265258 = 0, $$26751315 = 0, $$297 = 0, $$350 = 0, $$366717 = 0, $$367216 = 0, $$445 = 0, $$542 = 0, $$641 = 0, $$lobit = 0, $$lobit$not = 0;
 var $$pr = 0, $$promoted = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0;
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0;
 var $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0;
 var $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0;
 var $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0;
 var $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0;
 var $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0;
 var $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0;
 var $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0;
 var $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0;
 var $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0;
 var $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0;
 var $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0;
 var $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0;
 var $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0;
 var $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0;
 var $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0;
 var $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0;
 var $425 = 0, $426 = 0, $427 = 0, $428 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0;
 var $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0, $exitcond = 0, $or$cond = 0, $or$cond1 = 0, $or$cond10 = 0, $or$cond13 = 0, $or$cond15 = 0, $or$cond17 = 0, $or$cond19 = 0, $or$cond21 = 0, $or$cond23 = 0, $or$cond25 = 0, $or$cond27 = 0, $or$cond3 = 0;
 var $or$cond4 = 0, $or$cond5 = 0, $or$cond7 = 0, $or$cond8 = 0, $smax = 0, $spec$select = 0, $spec$select2 = 0, $spec$select5 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer = sp + 8|0;
 $5 = sp;
 $6 = sp + 32|0;
 $7 = sp + 24|0;
 $8 = sp + 16|0;
 $9 = sp + 12|0;
 HEAP32[$9>>2] = 0; //@line 126218 "c/sqlite3.c"
 $10 = $5; //@line 126229 "c/sqlite3.c"
 $11 = $10; //@line 126229 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 126229 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 126229 "c/sqlite3.c"
 $13 = $12; //@line 126229 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 126229 "c/sqlite3.c"
 $14 = HEAP32[$0>>2]|0; //@line 126230 "c/sqlite3.c"
 $15 = ((($0)) + 36|0); //@line 126231 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 126231 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 126231 "c/sqlite3.c"
 if (!($17)) {
  $425 = 0;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $18 = ((($14)) + 73|0); //@line 126231 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 126231 "c/sqlite3.c"
 $20 = ($19<<24>>24)==(0); //@line 126231 "c/sqlite3.c"
 if (!($20)) {
  $425 = 0;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $21 = (_sqlite3SrcListLookup($0,$1)|0); //@line 126238 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 126239 "c/sqlite3.c"
 if ($22) {
  $425 = 0;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $23 = HEAP32[$0>>2]|0; //@line 126240 "c/sqlite3.c"
 $24 = ((($21)) + 72|0); //@line 126240 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 126240 "c/sqlite3.c"
 $26 = (_sqlite3SchemaToIndex($23,$25)|0); //@line 126240 "c/sqlite3.c"
 $27 = (_sqlite3TriggersExist($0,$21,110,$2,$7)|0); //@line 126246 "c/sqlite3.c"
 $28 = ((($21)) + 12|0); //@line 126247 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 126247 "c/sqlite3.c"
 $30 = ($29|0)!=(0|0); //@line 126247 "c/sqlite3.c"
 $31 = (_sqlite3ViewGetColumnNames($0,$21)|0); //@line 126269 "c/sqlite3.c"
 $32 = ($31|0)==(0); //@line 126269 "c/sqlite3.c"
 if (!($32)) {
  $425 = 0;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $33 = HEAP32[$7>>2]|0; //@line 126272 "c/sqlite3.c"
 $34 = (_sqlite3IsReadOnly($0,$21,$33)|0); //@line 126272 "c/sqlite3.c"
 $35 = ($34|0)==(0); //@line 126272 "c/sqlite3.c"
 if (!($35)) {
  $425 = 0;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $36 = ((($0)) + 40|0); //@line 126281 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 126281 "c/sqlite3.c"
 $38 = (($37) + 1)|0; //@line 126281 "c/sqlite3.c"
 HEAP32[$36>>2] = $38; //@line 126281 "c/sqlite3.c"
 $39 = ((($1)) + 52|0); //@line 126281 "c/sqlite3.c"
 HEAP32[$39>>2] = $37; //@line 126281 "c/sqlite3.c"
 $40 = ((($21)) + 36|0); //@line 126283 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 126283 "c/sqlite3.c"
 $42 = $41 & 32; //@line 126283 "c/sqlite3.c"
 $43 = ($42|0)==(0); //@line 126283 "c/sqlite3.c"
 if ($43) {
  $48 = 0;
 } else {
  $44 = (_sqlite3PrimaryKeyIndex($21)|0); //@line 126283 "c/sqlite3.c"
  $48 = $44;
 }
 $45 = ((($21)) + 8|0); //@line 126284 "c/sqlite3.c"
 $$065484 = HEAP32[$45>>2]|0;
 $46 = ($$065484|0)==(0|0); //@line 126284 "c/sqlite3.c"
 if ($46) {
  $$0659$lcssa = 0;$$0660$lcssa = $37;
 } else {
  $47 = ($48|0)!=(0|0);
  $$065487 = $$065484;$$065986 = 0;$$066085 = $37;
  while(1) {
   $49 = ((($$065487)) + 55|0); //@line 126285 "c/sqlite3.c"
   $50 = HEAPU8[$49>>0]|(HEAPU8[$49+1>>0]<<8); //@line 126285 "c/sqlite3.c"
   $51 = $50 & 3; //@line 126285 "c/sqlite3.c"
   $52 = ($51<<16>>16)==(2); //@line 126285 "c/sqlite3.c"
   $or$cond = $47 & $52; //@line 126285 "c/sqlite3.c"
   if ($or$cond) {
    $53 = HEAP32[$36>>2]|0; //@line 126286 "c/sqlite3.c"
    HEAP32[$39>>2] = $53; //@line 126287 "c/sqlite3.c"
    $$1661 = $53;
   } else {
    $$1661 = $$066085;
   }
   $54 = HEAP32[$36>>2]|0; //@line 126289 "c/sqlite3.c"
   $55 = (($54) + 1)|0; //@line 126289 "c/sqlite3.c"
   HEAP32[$36>>2] = $55; //@line 126289 "c/sqlite3.c"
   $56 = ((($$065487)) + 20|0); //@line 126284 "c/sqlite3.c"
   $57 = (($$065986) + 1)|0; //@line 126284 "c/sqlite3.c"
   $$0654 = HEAP32[$56>>2]|0;
   $58 = ($$0654|0)==(0|0); //@line 126284 "c/sqlite3.c"
   if ($58) {
    $$0659$lcssa = $57;$$0660$lcssa = $$1661;
    break;
   } else {
    $$065487 = $$0654;$$065986 = $57;$$066085 = $$1661;
   }
  }
 }
 $59 = ((($21)) + 42|0); //@line 126295 "c/sqlite3.c"
 $60 = HEAP16[$59>>1]|0; //@line 126295 "c/sqlite3.c"
 $61 = $60 << 16 >> 16; //@line 126295 "c/sqlite3.c"
 $62 = (($$0659$lcssa) + ($61))|0; //@line 126295 "c/sqlite3.c"
 $63 = $62 << 2; //@line 126295 "c/sqlite3.c"
 $64 = (($$0659$lcssa) + 2)|0; //@line 126295 "c/sqlite3.c"
 $65 = (($64) + ($63))|0; //@line 126295 "c/sqlite3.c"
 $66 = (_sqlite3DbMallocRawNN($14,$65,0)|0); //@line 126295 "c/sqlite3.c"
 $67 = ($66|0)==(0|0); //@line 126296 "c/sqlite3.c"
 if ($67) {
  $425 = 0;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $68 = HEAP16[$59>>1]|0; //@line 126297 "c/sqlite3.c"
 $69 = $68 << 16 >> 16; //@line 126297 "c/sqlite3.c"
 $70 = (($66) + ($69<<2)|0); //@line 126297 "c/sqlite3.c"
 $71 = (($70) + ($$0659$lcssa<<2)|0); //@line 126298 "c/sqlite3.c"
 $72 = (($$0659$lcssa) + 1)|0; //@line 126299 "c/sqlite3.c"
 _memset(($71|0),1,($72|0))|0; //@line 126299 "c/sqlite3.c"
 $73 = (($71) + ($72)|0); //@line 126300 "c/sqlite3.c"
 HEAP8[$73>>0] = 0; //@line 126300 "c/sqlite3.c"
 $74 = HEAP16[$59>>1]|0; //@line 126301 "c/sqlite3.c"
 $75 = ($74<<16>>16)>(0); //@line 126301 "c/sqlite3.c"
 if ($75) {
  $76 = HEAP16[$59>>1]|0;
  $77 = $76 << 16 >> 16;
  $78 = ($77|0)>(1); //@line 126301 "c/sqlite3.c"
  $smax = $78 ? $77 : 1; //@line 126301 "c/sqlite3.c"
  $79 = $smax << 2; //@line 126301 "c/sqlite3.c"
  _memset(($66|0),-1,($79|0))|0; //@line 126301 "c/sqlite3.c"
 }
 $80 = ((($6)) + 8|0);
 ;HEAP32[$80>>2]=0|0;HEAP32[$80+4>>2]=0|0;HEAP32[$80+8>>2]=0|0;HEAP32[$80+12>>2]=0|0;HEAP32[$80+16>>2]=0|0;HEAP32[$80+20>>2]=0|0; //@line 126304 "c/sqlite3.c"
 HEAP32[$6>>2] = $0; //@line 126305 "c/sqlite3.c"
 $81 = ((($6)) + 4|0); //@line 126306 "c/sqlite3.c"
 HEAP32[$81>>2] = $1; //@line 126306 "c/sqlite3.c"
 $82 = HEAP32[$2>>2]|0; //@line 126315 "c/sqlite3.c"
 $83 = ($82|0)>(0); //@line 126315 "c/sqlite3.c"
 L33: do {
  if ($83) {
   $84 = ($48|0)==(0|0);
   $85 = ((($14)) + 16|0);
   $86 = ((($21)) + 4|0);
   $87 = ((($21)) + 40|0);
   $88 = ((($21)) + 4|0);
   $89 = ($48|0)==(0|0);
   $$066471 = 0;$$066970 = 0;$$067369 = 0;$$163372 = 0;
   L35: while(1) {
    $90 = (((($2)) + 4|0) + (($$163372*20)|0)|0); //@line 126316 "c/sqlite3.c"
    $91 = HEAP32[$90>>2]|0; //@line 126316 "c/sqlite3.c"
    $92 = (_sqlite3ResolveExprNames($6,$91)|0); //@line 126316 "c/sqlite3.c"
    $93 = ($92|0)==(0); //@line 126316 "c/sqlite3.c"
    if (!($93)) {
     $425 = $66;
     label = 177;
     break;
    }
    $94 = HEAP16[$59>>1]|0; //@line 126319 "c/sqlite3.c"
    $95 = ($94<<16>>16)>(0); //@line 126319 "c/sqlite3.c"
    L38: do {
     if ($95) {
      $96 = HEAP32[$86>>2]|0;
      $97 = (((((($2)) + 4|0) + (($$163372*20)|0)|0)) + 4|0);
      $98 = HEAP32[$97>>2]|0;
      $$065065 = 0;
      while(1) {
       $99 = (($96) + ($$065065<<4)|0); //@line 126320 "c/sqlite3.c"
       $100 = HEAP32[$99>>2]|0; //@line 126320 "c/sqlite3.c"
       $101 = (_sqlite3StrICmp($100,$98)|0); //@line 126320 "c/sqlite3.c"
       $102 = ($101|0)==(0); //@line 126320 "c/sqlite3.c"
       if ($102) {
        break;
       }
       $111 = (($$065065) + 1)|0; //@line 126319 "c/sqlite3.c"
       $112 = HEAP16[$59>>1]|0; //@line 126319 "c/sqlite3.c"
       $113 = $112 << 16 >> 16; //@line 126319 "c/sqlite3.c"
       $114 = ($111|0)<($113|0); //@line 126319 "c/sqlite3.c"
       if ($114) {
        $$065065 = $111;
       } else {
        label = 27;
        break L38;
       }
      }
      $103 = HEAP16[$87>>1]|0; //@line 126321 "c/sqlite3.c"
      $104 = $103 << 16 >> 16; //@line 126321 "c/sqlite3.c"
      $105 = ($$065065|0)==($104|0); //@line 126321 "c/sqlite3.c"
      if ($105) {
       $106 = HEAP32[$90>>2]|0; //@line 126323 "c/sqlite3.c"
       $$1665 = $106;$$1670 = 1;$$1674 = $$067369;
      } else {
       if ($89) {
        $$1665 = $$066471;$$1670 = $$066970;$$1674 = $$067369;
       } else {
        $107 = (((($96) + ($$065065<<4)|0)) + 15|0); //@line 126324 "c/sqlite3.c"
        $108 = HEAP8[$107>>0]|0; //@line 126324 "c/sqlite3.c"
        $109 = $108 & 1; //@line 126324 "c/sqlite3.c"
        $110 = ($109<<24>>24)==(0); //@line 126324 "c/sqlite3.c"
        $spec$select = $110 ? $$067369 : 1; //@line 126324 "c/sqlite3.c"
        $$1665 = $$066471;$$1670 = $$066970;$$1674 = $spec$select;
       }
      }
      $123 = (($66) + ($$065065<<2)|0); //@line 126327 "c/sqlite3.c"
      HEAP32[$123>>2] = $$163372; //@line 126327 "c/sqlite3.c"
      $124 = HEAP32[$88>>2]|0; //@line 126346 "c/sqlite3.c"
      $125 = (($124) + ($$065065<<4)|0); //@line 126346 "c/sqlite3.c"
      $126 = HEAP32[$125>>2]|0; //@line 126346 "c/sqlite3.c"
      $$165118 = $$065065;$$26751315 = $$1674;$$366717 = $$1665;$$367216 = $$1670;$131 = $126;
     } else {
      label = 27;
     }
    } while(0);
    if ((label|0) == 27) {
     label = 0;
     if (!($84)) {
      label = 30;
      break;
     }
     $115 = (((((($2)) + 4|0) + (($$163372*20)|0)|0)) + 4|0); //@line 126332 "c/sqlite3.c"
     $116 = HEAP32[$115>>2]|0; //@line 126332 "c/sqlite3.c"
     $117 = (_sqlite3IsRowid($116)|0); //@line 126332 "c/sqlite3.c"
     $118 = ($117|0)==(0); //@line 126332 "c/sqlite3.c"
     if ($118) {
      label = 30;
      break;
     }
     $119 = HEAP32[$90>>2]|0; //@line 126335 "c/sqlite3.c"
     $$165118 = -1;$$26751315 = $$067369;$$366717 = $119;$$367216 = 1;$131 = 23800;
    }
    $127 = HEAP32[$21>>2]|0; //@line 126345 "c/sqlite3.c"
    $128 = HEAP32[$85>>2]|0; //@line 126347 "c/sqlite3.c"
    $129 = (($128) + ($26<<4)|0); //@line 126347 "c/sqlite3.c"
    $130 = HEAP32[$129>>2]|0; //@line 126347 "c/sqlite3.c"
    $132 = (_sqlite3AuthCheck($0,23,$127,$131,$130)|0); //@line 126345 "c/sqlite3.c"
    switch ($132|0) {
    case 1:  {
     $425 = $66;
     label = 177;
     break L35;
     break;
    }
    case 2:  {
     $133 = (($66) + ($$165118<<2)|0); //@line 126351 "c/sqlite3.c"
     HEAP32[$133>>2] = -1; //@line 126351 "c/sqlite3.c"
     break;
    }
    default: {
    }
    }
    $134 = (($$163372) + 1)|0; //@line 126315 "c/sqlite3.c"
    $135 = HEAP32[$2>>2]|0; //@line 126315 "c/sqlite3.c"
    $136 = ($134|0)<($135|0); //@line 126315 "c/sqlite3.c"
    if ($136) {
     $$066471 = $$366717;$$066970 = $$367216;$$067369 = $$26751315;$$163372 = $134;
    } else {
     $$0664$lcssa = $$366717;$$0669$lcssa = $$367216;$$0673$lcssa = $$26751315;
     break L33;
    }
   }
   if ((label|0) == 30) {
    $120 = (((((($2)) + 4|0) + (($$163372*20)|0)|0)) + 4|0); //@line 126337 "c/sqlite3.c"
    $121 = HEAP32[$120>>2]|0; //@line 126337 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $121; //@line 126337 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,28070,$vararg_buffer); //@line 126337 "c/sqlite3.c"
    $122 = ((($0)) + 17|0); //@line 126338 "c/sqlite3.c"
    HEAP8[$122>>0] = 1; //@line 126338 "c/sqlite3.c"
    $425 = $66;
    _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
    _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
    _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
    _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
    _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
   }
   else if ((label|0) == 177) {
    _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
    _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
    _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
    _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
    _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
   }
  } else {
   $$0664$lcssa = 0;$$0669$lcssa = 0;$$0673$lcssa = 0;
  }
 } while(0);
 $137 = $$0669$lcssa&255; //@line 126359 "c/sqlite3.c"
 $138 = $$0673$lcssa&255; //@line 126359 "c/sqlite3.c"
 $139 = (($137) + ($138))|0; //@line 126359 "c/sqlite3.c"
 $140 = $139&255; //@line 126359 "c/sqlite3.c"
 $141 = ((($21)) + 56|0); //@line 126366 "c/sqlite3.c"
 $142 = HEAP32[$141>>2]|0; //@line 126366 "c/sqlite3.c"
 $143 = ($142|0)!=(0); //@line 126366 "c/sqlite3.c"
 $144 = $143 << 31 >> 31; //@line 126366 "c/sqlite3.c"
 $145 = ($144|0)<(0); //@line 126366 "c/sqlite3.c"
 $146 = $145 << 31 >> 31; //@line 126366 "c/sqlite3.c"
 $147 = ((($1)) + 64|0); //@line 126366 "c/sqlite3.c"
 $148 = $147; //@line 126366 "c/sqlite3.c"
 $149 = $148; //@line 126366 "c/sqlite3.c"
 HEAP32[$149>>2] = $144; //@line 126366 "c/sqlite3.c"
 $150 = (($148) + 4)|0; //@line 126366 "c/sqlite3.c"
 $151 = $150; //@line 126366 "c/sqlite3.c"
 HEAP32[$151>>2] = $146; //@line 126366 "c/sqlite3.c"
 $152 = $139 & 255; //@line 126368 "c/sqlite3.c"
 $153 = (_sqlite3FkRequired($0,$21,$66,$152)|0); //@line 126368 "c/sqlite3.c"
 $$165557 = HEAP32[$45>>2]|0;
 $154 = ($$165557|0)==(0|0); //@line 126376 "c/sqlite3.c"
 if ($154) {
  $$pr = HEAP32[$9>>2]|0; //@line 126400 "c/sqlite3.c"
  $203 = $$pr;
 } else {
  $155 = ($152|0)!=(0);
  $156 = ($153|0)>(1);
  $or$cond3 = $155 | $156;
  $157 = ((($0)) + 44|0);
  $158 = ((($0)) + 44|0);
  $$promoted = HEAP32[$9>>2]|0; //@line 126391 "c/sqlite3.c"
  $$165559 = $$165557;$$265258 = 0;$426 = $$promoted;
  while(1) {
   L68: do {
    if ($or$cond3) {
     label = 39;
    } else {
     $159 = ((($$165559)) + 36|0); //@line 126378 "c/sqlite3.c"
     $160 = HEAP32[$159>>2]|0; //@line 126378 "c/sqlite3.c"
     $161 = ($160|0)!=(0|0); //@line 126378 "c/sqlite3.c"
     $162 = ($$165559|0)==($48|0); //@line 126378 "c/sqlite3.c"
     $or$cond1 = $162 | $161; //@line 126378 "c/sqlite3.c"
     if ($or$cond1) {
      label = 39;
     } else {
      $169 = ((($$165559)) + 50|0); //@line 126383 "c/sqlite3.c"
      $170 = HEAP16[$169>>1]|0; //@line 126383 "c/sqlite3.c"
      $171 = ($170<<16>>16)==(0); //@line 126383 "c/sqlite3.c"
      if ($171) {
       $428 = $426;
       label = 49;
      } else {
       $172 = ((($$165559)) + 4|0);
       $173 = HEAP32[$172>>2]|0;
       $$263454 = 0;
       while(1) {
        $178 = (($173) + ($$263454<<1)|0); //@line 126384 "c/sqlite3.c"
        $179 = HEAP16[$178>>1]|0; //@line 126384 "c/sqlite3.c"
        $180 = ($179<<16>>16)<(0); //@line 126385 "c/sqlite3.c"
        if ($180) {
         break;
        }
        $181 = $179 << 16 >> 16; //@line 126385 "c/sqlite3.c"
        $182 = (($66) + ($181<<2)|0); //@line 126385 "c/sqlite3.c"
        $183 = HEAP32[$182>>2]|0; //@line 126385 "c/sqlite3.c"
        $184 = ($183|0)>(-1); //@line 126385 "c/sqlite3.c"
        $177 = (($$263454) + 1)|0; //@line 126383 "c/sqlite3.c"
        if ($184) {
         break;
        }
        $174 = HEAP16[$169>>1]|0; //@line 126383 "c/sqlite3.c"
        $175 = $174&65535; //@line 126383 "c/sqlite3.c"
        $176 = ($177>>>0)<($175>>>0); //@line 126383 "c/sqlite3.c"
        if ($176) {
         $$263454 = $177;
        } else {
         $428 = $426;
         label = 49;
         break L68;
        }
       }
       $185 = HEAP32[$158>>2]|0; //@line 126386 "c/sqlite3.c"
       $186 = (($185) + 1)|0; //@line 126386 "c/sqlite3.c"
       $187 = ((($$165559)) + 52|0); //@line 126387 "c/sqlite3.c"
       $188 = HEAP16[$187>>1]|0; //@line 126387 "c/sqlite3.c"
       $189 = $188&65535; //@line 126387 "c/sqlite3.c"
       $190 = (($186) + ($189))|0; //@line 126387 "c/sqlite3.c"
       HEAP32[$158>>2] = $190; //@line 126387 "c/sqlite3.c"
       switch ($4|0) {
       case 5:  {
        break;
       }
       case 10:  {
        $191 = ((($$165559)) + 54|0); //@line 126389 "c/sqlite3.c"
        $192 = HEAP8[$191>>0]|0; //@line 126389 "c/sqlite3.c"
        $193 = ($192<<24>>24)==(5); //@line 126389 "c/sqlite3.c"
        if (!($193)) {
         $$2 = $186;$427 = $426;
         label = 48;
         break L68;
        }
        break;
       }
       default: {
        $$2 = $186;$427 = $426;
        label = 48;
        break L68;
       }
       }
       $$2 = $186;$427 = 1;
       label = 48;
      }
     }
    }
   } while(0);
   if ((label|0) == 39) {
    label = 0;
    $163 = HEAP32[$157>>2]|0; //@line 126379 "c/sqlite3.c"
    $164 = (($163) + 1)|0; //@line 126379 "c/sqlite3.c"
    $165 = ((($$165559)) + 52|0); //@line 126380 "c/sqlite3.c"
    $166 = HEAP16[$165>>1]|0; //@line 126380 "c/sqlite3.c"
    $167 = $166&65535; //@line 126380 "c/sqlite3.c"
    $168 = (($164) + ($167))|0; //@line 126380 "c/sqlite3.c"
    HEAP32[$157>>2] = $168; //@line 126380 "c/sqlite3.c"
    $$2 = $164;$427 = $426;
    label = 48;
   }
   if ((label|0) == 48) {
    label = 0;
    $194 = ($$2|0)==(0); //@line 126397 "c/sqlite3.c"
    if ($194) {
     $428 = $427;
     label = 49;
    } else {
     $$297 = $$2;$201 = $427;
    }
   }
   if ((label|0) == 49) {
    label = 0;
    $195 = (($$265258) + 1)|0; //@line 126397 "c/sqlite3.c"
    $196 = (($71) + ($195)|0); //@line 126397 "c/sqlite3.c"
    HEAP8[$196>>0] = 0; //@line 126397 "c/sqlite3.c"
    $$297 = 0;$201 = $428;
   }
   $197 = (($70) + ($$265258<<2)|0); //@line 126398 "c/sqlite3.c"
   HEAP32[$197>>2] = $$297; //@line 126398 "c/sqlite3.c"
   $198 = ((($$165559)) + 20|0); //@line 126376 "c/sqlite3.c"
   $199 = (($$265258) + 1)|0; //@line 126376 "c/sqlite3.c"
   $$1655 = HEAP32[$198>>2]|0;
   $200 = ($$1655|0)==(0|0); //@line 126376 "c/sqlite3.c"
   if ($200) {
    break;
   } else {
    $$165559 = $$1655;$$265258 = $199;$426 = $201;
   }
  }
  HEAP32[$9>>2] = $201; //@line 126391 "c/sqlite3.c"
  $203 = $201;
 }
 $202 = ($203|0)==(0); //@line 126400 "c/sqlite3.c"
 if (!($202)) {
  _memset(($71|0),1,($72|0))|0; //@line 126403 "c/sqlite3.c"
 }
 $204 = (_sqlite3GetVdbe($0)|0); //@line 126407 "c/sqlite3.c"
 $205 = ($204|0)==(0|0); //@line 126408 "c/sqlite3.c"
 if ($205) {
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $206 = ((($0)) + 18|0); //@line 126409 "c/sqlite3.c"
 $207 = HEAP8[$206>>0]|0; //@line 126409 "c/sqlite3.c"
 $208 = ($207<<24>>24)==(0); //@line 126409 "c/sqlite3.c"
 if ($208) {
  _sqlite3VdbeCountChanges($204); //@line 126409 "c/sqlite3.c"
 }
 _sqlite3BeginWriteOperation($0,1,$26); //@line 126410 "c/sqlite3.c"
 $209 = HEAP32[$141>>2]|0; //@line 126413 "c/sqlite3.c"
 $210 = ($209|0)==(0); //@line 126413 "c/sqlite3.c"
 if ($210) {
  $211 = ((($0)) + 44|0); //@line 126414 "c/sqlite3.c"
  $212 = HEAP32[$211>>2]|0; //@line 126414 "c/sqlite3.c"
  $213 = (($212) + 1)|0; //@line 126414 "c/sqlite3.c"
  $214 = (($212) + 2)|0; //@line 126415 "c/sqlite3.c"
  HEAP32[$211>>2] = $214; //@line 126415 "c/sqlite3.c"
  $215 = ($$0673$lcssa<<24>>24)!=(0); //@line 126416 "c/sqlite3.c"
  $216 = ($27|0)!=(0|0); //@line 126416 "c/sqlite3.c"
  $or$cond5 = $216 | $215; //@line 126416 "c/sqlite3.c"
  $217 = ($153|0)!=(0); //@line 126416 "c/sqlite3.c"
  $or$cond7 = $or$cond5 | $217; //@line 126416 "c/sqlite3.c"
  if ($or$cond7) {
   $218 = (($212) + 3)|0; //@line 126417 "c/sqlite3.c"
   $219 = HEAP16[$59>>1]|0; //@line 126418 "c/sqlite3.c"
   $220 = $219 << 16 >> 16; //@line 126418 "c/sqlite3.c"
   $221 = (($214) + ($220))|0; //@line 126418 "c/sqlite3.c"
   HEAP32[$211>>2] = $221; //@line 126418 "c/sqlite3.c"
   $$0638 = $218;
  } else {
   $$0638 = 0;
  }
  $222 = $153 | $152; //@line 126420 "c/sqlite3.c"
  $223 = ($222|0)!=(0); //@line 126420 "c/sqlite3.c"
  $224 = $216 | $223; //@line 126420 "c/sqlite3.c"
  if ($224) {
   $225 = HEAP32[$211>>2]|0; //@line 126421 "c/sqlite3.c"
   $226 = (($225) + 1)|0; //@line 126421 "c/sqlite3.c"
   HEAP32[$211>>2] = $226; //@line 126421 "c/sqlite3.c"
   $$0641 = $226;
  } else {
   $$0641 = $214;
  }
  $227 = HEAP32[$211>>2]|0; //@line 126423 "c/sqlite3.c"
  $228 = (($227) + 1)|0; //@line 126423 "c/sqlite3.c"
  $229 = HEAP16[$59>>1]|0; //@line 126424 "c/sqlite3.c"
  $230 = $229 << 16 >> 16; //@line 126424 "c/sqlite3.c"
  $231 = (($227) + ($230))|0; //@line 126424 "c/sqlite3.c"
  HEAP32[$211>>2] = $231; //@line 126424 "c/sqlite3.c"
  $$0637 = $213;$$0640 = $228;$$0643 = $214;$$1639 = $$0638;$$1642 = $$0641;
 } else {
  $$0637 = 0;$$0640 = 0;$$0643 = 0;$$1639 = 0;$$1642 = 0;
 }
 if ($30) {
  $232 = HEAP32[$21>>2]|0; //@line 126429 "c/sqlite3.c"
  _sqlite3AuthContextPush($0,$5,$232); //@line 126429 "c/sqlite3.c"
  _sqlite3MaterializeView($0,$21,$3,$$0660$lcssa); //@line 126437 "c/sqlite3.c"
 }
 $233 = (_sqlite3ResolveExprNames($6,$3)|0); //@line 126448 "c/sqlite3.c"
 $234 = ($233|0)==(0); //@line 126448 "c/sqlite3.c"
 if (!($234)) {
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $235 = HEAP32[$141>>2]|0; //@line 126454 "c/sqlite3.c"
 $236 = ($235|0)==(0); //@line 126454 "c/sqlite3.c"
 if (!($236)) {
  _updateVirtualTable($0,$1,$21,$2,$$0664$lcssa,$66,$3,$4); //@line 126455 "c/sqlite3.c"
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $237 = ((($14)) + 28|0); //@line 126462 "c/sqlite3.c"
 $238 = HEAP32[$237>>2]|0; //@line 126462 "c/sqlite3.c"
 $239 = $238 & 128; //@line 126462 "c/sqlite3.c"
 $240 = ($239|0)==(0); //@line 126462 "c/sqlite3.c"
 do {
  if ($240) {
   $$0644 = 0;
  } else {
   $241 = ((($0)) + 124|0); //@line 126462 "c/sqlite3.c"
   $242 = HEAP32[$241>>2]|0; //@line 126462 "c/sqlite3.c"
   $243 = ($242|0)==(0|0); //@line 126462 "c/sqlite3.c"
   if (!($243)) {
    $$0644 = 0;
    break;
   }
   $244 = ((($0)) + 44|0); //@line 126463 "c/sqlite3.c"
   $245 = HEAP32[$244>>2]|0; //@line 126463 "c/sqlite3.c"
   $246 = (($245) + 1)|0; //@line 126463 "c/sqlite3.c"
   HEAP32[$244>>2] = $246; //@line 126463 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($204,67,0,$246)|0); //@line 126464 "c/sqlite3.c"
   $$0644 = $246;
  }
 } while(0);
 $247 = HEAP32[$40>>2]|0; //@line 126467 "c/sqlite3.c"
 $248 = $247 & 32; //@line 126467 "c/sqlite3.c"
 $249 = ($248|0)==(0); //@line 126467 "c/sqlite3.c"
 if ($249) {
  (_sqlite3VdbeAddOp3($204,70,0,$$0637,$$0643)|0); //@line 126468 "c/sqlite3.c"
  $$0635 = 0;$$0645 = 0;$$0646 = 0;$$0647 = 0;$$0649 = 0;
 } else {
  $250 = ((($48)) + 50|0); //@line 126471 "c/sqlite3.c"
  $251 = HEAP16[$250>>1]|0; //@line 126471 "c/sqlite3.c"
  $252 = ((($0)) + 44|0); //@line 126472 "c/sqlite3.c"
  $253 = HEAP32[$252>>2]|0; //@line 126472 "c/sqlite3.c"
  $254 = (($253) + 1)|0; //@line 126472 "c/sqlite3.c"
  $255 = $251 << 16 >> 16; //@line 126473 "c/sqlite3.c"
  $256 = (($253) + 1)|0; //@line 126473 "c/sqlite3.c"
  $257 = (($256) + ($255))|0; //@line 126474 "c/sqlite3.c"
  HEAP32[$252>>2] = $257; //@line 126474 "c/sqlite3.c"
  $258 = HEAP32[$36>>2]|0; //@line 126475 "c/sqlite3.c"
  $259 = (($258) + 1)|0; //@line 126475 "c/sqlite3.c"
  HEAP32[$36>>2] = $259; //@line 126475 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($204,70,0,$254)|0); //@line 126477 "c/sqlite3.c"
  $260 = (_sqlite3VdbeAddOp2($204,109,$258,$255)|0); //@line 126478 "c/sqlite3.c"
  _sqlite3VdbeSetP4KeyInfo($0,$48); //@line 126479 "c/sqlite3.c"
  $$0635 = $257;$$0645 = $251;$$0646 = $254;$$0647 = $260;$$0649 = $258;
 }
 $261 = HEAP8[$206>>0]|0; //@line 126490 "c/sqlite3.c"
 $262 = ($261<<24>>24)!=(0); //@line 126490 "c/sqlite3.c"
 $263 = ($27|0)!=(0|0); //@line 126490 "c/sqlite3.c"
 $or$cond13 = $263 | $262; //@line 126490 "c/sqlite3.c"
 $264 = ($153|0)!=(0); //@line 126490 "c/sqlite3.c"
 $or$cond15 = $264 | $or$cond13; //@line 126490 "c/sqlite3.c"
 $265 = ($140<<24>>24)!=(0); //@line 126490 "c/sqlite3.c"
 $or$cond17 = $265 | $or$cond15; //@line 126490 "c/sqlite3.c"
 $266 = ($203|0)!=(0); //@line 126490 "c/sqlite3.c"
 $or$cond19 = $266 | $or$cond17; //@line 126490 "c/sqlite3.c"
 $spec$select2 = $or$cond19 ? 4100 : 4108; //@line 126490 "c/sqlite3.c"
 $267 = (_sqlite3WhereBegin($0,$1,$3,0,0,$spec$select2,$38)|0); //@line 126493 "c/sqlite3.c"
 $268 = ($267|0)==(0|0); //@line 126494 "c/sqlite3.c"
 if ($268) {
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $269 = (_sqlite3WhereOkOnePass($267,$8)|0); //@line 126506 "c/sqlite3.c"
 $270 = ($269|0)==(2); //@line 126507 "c/sqlite3.c"
 do {
  if ($270) {
   $271 = ((($8)) + 4|0); //@line 126508 "c/sqlite3.c"
   $272 = HEAP32[$271>>2]|0; //@line 126508 "c/sqlite3.c"
   $273 = ($272|0)<(0); //@line 126509 "c/sqlite3.c"
   $274 = ($272|0)==($$0660$lcssa|0); //@line 126509 "c/sqlite3.c"
   $or$cond4 = $273 | $274; //@line 126509 "c/sqlite3.c"
   if ($or$cond4) {
    $$1663 = 2;
    break;
   }
   $275 = (($272) - ($37))|0; //@line 126509 "c/sqlite3.c"
   $276 = (($71) + ($275)|0); //@line 126509 "c/sqlite3.c"
   $277 = HEAP8[$276>>0]|0; //@line 126509 "c/sqlite3.c"
   $278 = ($277<<24>>24)==(0); //@line 126509 "c/sqlite3.c"
   $spec$select5 = $278 ? $269 : 0; //@line 126509 "c/sqlite3.c"
   $$1663 = $spec$select5;
  } else {
   $$1663 = $269;
  }
 } while(0);
 $279 = HEAP32[$40>>2]|0; //@line 126515 "c/sqlite3.c"
 $280 = $279 & 32; //@line 126515 "c/sqlite3.c"
 $281 = ($280|0)==(0); //@line 126515 "c/sqlite3.c"
 do {
  if ($281) {
   (_sqlite3VdbeAddOp2($204,124,$$0660$lcssa,$$0643)|0); //@line 126519 "c/sqlite3.c"
   $282 = ($$1663|0)==(0); //@line 126520 "c/sqlite3.c"
   if (!($282)) {
    $$0648 = 0;$$1636 = $$0635;
    label = 88;
    break;
   }
   (_sqlite3VdbeAddOp2($204,144,$$0637,$$0643)|0); //@line 126521 "c/sqlite3.c"
   $$064822 = 0;$$163624 = $$0635;
   label = 89;
  } else {
   $283 = $$0645 << 16 >> 16; //@line 126529 "c/sqlite3.c"
   $284 = ($$0645<<16>>16)>(0); //@line 126529 "c/sqlite3.c"
   if ($284) {
    $285 = ((($48)) + 4|0);
    $$350 = 0;
    while(1) {
     $286 = HEAP32[$285>>2]|0; //@line 126531 "c/sqlite3.c"
     $287 = (($286) + ($$350<<1)|0); //@line 126531 "c/sqlite3.c"
     $288 = HEAP16[$287>>1]|0; //@line 126531 "c/sqlite3.c"
     $289 = $288 << 16 >> 16; //@line 126531 "c/sqlite3.c"
     $290 = (($$350) + ($$0646))|0; //@line 126531 "c/sqlite3.c"
     _sqlite3ExprCodeGetColumnOfTable($204,$21,$$0660$lcssa,$289,$290); //@line 126531 "c/sqlite3.c"
     $291 = (($$350) + 1)|0; //@line 126529 "c/sqlite3.c"
     $exitcond = ($291|0)==($283|0); //@line 126529 "c/sqlite3.c"
     if ($exitcond) {
      break;
     } else {
      $$350 = $291;
     }
    }
   }
   $292 = ($$1663|0)==(0); //@line 126533 "c/sqlite3.c"
   if ($292) {
    $293 = (_sqlite3IndexAffinityStr($14,$48)|0); //@line 126539 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4($204,100,$$0646,$283,$$0635,$293,$283)|0); //@line 126538 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4Int($204,128,$$0649,$$0635,$$0646,$283)|0); //@line 126540 "c/sqlite3.c"
    $$064822 = 0;$$163624 = $$0635;
    label = 89;
    break;
   } else {
    (_sqlite3VdbeChangeToNoop($204,$$0647)|0); //@line 126534 "c/sqlite3.c"
    $$0648 = $283;$$1636 = $$0646;
    label = 88;
    break;
   }
  }
 } while(0);
 if ((label|0) == 88) {
  $294 = ($$1663|0)==(2); //@line 126544 "c/sqlite3.c"
  if ($294) {
   $$064823 = $$0648;$$163625 = $$1636;$402 = 1;
  } else {
   $$064822 = $$0648;$$163624 = $$1636;
   label = 89;
  }
 }
 if ((label|0) == 89) {
  _sqlite3WhereEnd($267); //@line 126545 "c/sqlite3.c"
  $$064823 = $$064822;$$163625 = $$163624;$402 = 0;
 }
 $295 = (_sqlite3VdbeMakeLabel($204)|0); //@line 126548 "c/sqlite3.c"
 L149: do {
  if ($30) {
   label = 101;
  } else {
   $cond = ($$1663|0)==(0); //@line 126553 "c/sqlite3.c"
   do {
    if (!($cond)) {
     $296 = HEAP32[$8>>2]|0; //@line 126554 "c/sqlite3.c"
     $297 = ($296|0)>(-1); //@line 126554 "c/sqlite3.c"
     if ($297) {
      $298 = (($296) - ($37))|0; //@line 126554 "c/sqlite3.c"
      $299 = (($71) + ($298)|0); //@line 126554 "c/sqlite3.c"
      HEAP8[$299>>0] = 0; //@line 126554 "c/sqlite3.c"
     }
     $300 = ((($8)) + 4|0); //@line 126555 "c/sqlite3.c"
     $301 = HEAP32[$300>>2]|0; //@line 126555 "c/sqlite3.c"
     $302 = ($301|0)>(-1); //@line 126555 "c/sqlite3.c"
     if ($302) {
      $303 = (($301) - ($37))|0; //@line 126555 "c/sqlite3.c"
      $304 = (($71) + ($303)|0); //@line 126555 "c/sqlite3.c"
      HEAP8[$304>>0] = 0; //@line 126555 "c/sqlite3.c"
     }
     if (!($402)) {
      break;
     }
     $$lobit = $301 >>> 31; //@line 126558 "c/sqlite3.c"
     $$lobit$not = $$lobit ^ 1; //@line 126558 "c/sqlite3.c"
     $305 = ($$0659$lcssa>>>0)>($$lobit$not>>>0); //@line 126558 "c/sqlite3.c"
     if (!($305)) {
      break;
     }
     $306 = (_sqlite3VdbeAddOp0($204,20)|0); //@line 126559 "c/sqlite3.c"
     (_sqlite3OpenTableAndIndices($0,$21,106,0,$37,$71,0,0)|0); //@line 126561 "c/sqlite3.c"
     $307 = ($306|0)==(0); //@line 126563 "c/sqlite3.c"
     if ($307) {
      label = 102;
      break L149;
     }
     _sqlite3VdbeJumpHere($204,$306); //@line 126563 "c/sqlite3.c"
     label = 102;
     break L149;
    }
   } while(0);
   (_sqlite3OpenTableAndIndices($0,$21,106,0,$37,$71,0,0)|0); //@line 126561 "c/sqlite3.c"
   label = 101;
  }
 } while(0);
 do {
  if ((label|0) == 101) {
   $308 = ($$1663|0)==(0); //@line 126567 "c/sqlite3.c"
   if (!($308)) {
    label = 102;
    break;
   }
   $318 = ($48|0)==(0|0); //@line 126581 "c/sqlite3.c"
   if ($318) {
    $321 = (_sqlite3VdbeAddOp3($204,42,$$0637,$295,$$0643)|0); //@line 126588 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($204,32,$$0660$lcssa,$321,$$0643)|0); //@line 126591 "c/sqlite3.c"
    $$0653 = 0;$$1658 = $321;
    break;
   } else {
    $319 = (_sqlite3VdbeMakeLabel($204)|0); //@line 126582 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($204,37,$$0649,$295)|0); //@line 126583 "c/sqlite3.c"
    $320 = (_sqlite3VdbeAddOp2($204,123,$$0649,$$163625)|0); //@line 126584 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4Int($204,29,$$0660$lcssa,$319,$$163625,0)|0); //@line 126585 "c/sqlite3.c"
    $$0653 = $320;$$1658 = $319;
    break;
   }
  }
 } while(0);
 if ((label|0) == 102) {
  $309 = HEAP32[$8>>2]|0; //@line 126568 "c/sqlite3.c"
  $310 = ($309|0)==($$0660$lcssa|0); //@line 126568 "c/sqlite3.c"
  $or$cond8 = $30 | $310; //@line 126568 "c/sqlite3.c"
  do {
   if (!($or$cond8)) {
    $311 = ((($8)) + 4|0); //@line 126568 "c/sqlite3.c"
    $312 = HEAP32[$311>>2]|0; //@line 126568 "c/sqlite3.c"
    $313 = ($312|0)==($$0660$lcssa|0); //@line 126568 "c/sqlite3.c"
    if ($313) {
     break;
    }
    (_sqlite3VdbeAddOp4Int($204,29,$$0660$lcssa,$295,$$163625,$$064823)|0); //@line 126570 "c/sqlite3.c"
   }
  } while(0);
  $314 = ($$1663|0)==(1); //@line 126573 "c/sqlite3.c"
  if ($314) {
   $$0657 = $295;
  } else {
   $315 = (_sqlite3VdbeMakeLabel($204)|0); //@line 126576 "c/sqlite3.c"
   $$0657 = $315;
  }
  $316 = ($48|0)==(0|0); //@line 126578 "c/sqlite3.c"
  $317 = $316 ? $$0643 : $$163625; //@line 126578 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($204,50,$317,$295)|0); //@line 126578 "c/sqlite3.c"
  $$0653 = 0;$$1658 = $$0657;
 }
 $322 = ($$0669$lcssa<<24>>24)==(0); //@line 126600 "c/sqlite3.c"
 if (!($322)) {
  _sqlite3ExprCode($0,$$0664$lcssa,$$1642); //@line 126601 "c/sqlite3.c"
  (_sqlite3VdbeAddOp1($204,17,$$1642)|0); //@line 126602 "c/sqlite3.c"
 }
 $323 = ($$0673$lcssa<<24>>24)!=(0); //@line 126607 "c/sqlite3.c"
 $or$cond21 = $323 | $264; //@line 126607 "c/sqlite3.c"
 $or$cond23 = $263 | $or$cond21; //@line 126607 "c/sqlite3.c"
 do {
  if ($or$cond23) {
   if ($264) {
    $324 = (_sqlite3FkOldmask($0,$21)|0); //@line 126608 "c/sqlite3.c"
    $327 = $324;
   } else {
    $327 = 0;
   }
   $325 = (_sqlite3TriggerColmask($0,$27,$2,0,3,$21,$4)|0); //@line 126609 "c/sqlite3.c"
   $326 = $325 | $327; //@line 126609 "c/sqlite3.c"
   $328 = HEAP16[$59>>1]|0; //@line 126612 "c/sqlite3.c"
   $329 = ($328<<16>>16)>(0); //@line 126612 "c/sqlite3.c"
   if ($329) {
    $330 = ($326|0)==(-1);
    $331 = ((($21)) + 4|0);
    $$445 = 0;
    while(1) {
     do {
      if ($330) {
       label = 122;
      } else {
       $332 = ($$445>>>0)<(32); //@line 126614 "c/sqlite3.c"
       if ($332) {
        $333 = 1 << $$445; //@line 126614 "c/sqlite3.c"
        $334 = $333 & $326; //@line 126614 "c/sqlite3.c"
        $335 = ($334|0)==(0); //@line 126614 "c/sqlite3.c"
        if (!($335)) {
         label = 122;
         break;
        }
       }
       $336 = HEAP32[$331>>2]|0; //@line 126615 "c/sqlite3.c"
       $337 = (((($336) + ($$445<<4)|0)) + 15|0); //@line 126615 "c/sqlite3.c"
       $338 = HEAP8[$337>>0]|0; //@line 126615 "c/sqlite3.c"
       $339 = $338 & 1; //@line 126615 "c/sqlite3.c"
       $340 = ($339<<24>>24)==(0); //@line 126615 "c/sqlite3.c"
       if (!($340)) {
        label = 122;
        break;
       }
       $342 = (($$445) + ($$1639))|0; //@line 126620 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($204,70,0,$342)|0); //@line 126620 "c/sqlite3.c"
      }
     } while(0);
     if ((label|0) == 122) {
      label = 0;
      $341 = (($$445) + ($$1639))|0; //@line 126618 "c/sqlite3.c"
      _sqlite3ExprCodeGetColumnOfTable($204,$21,$$0660$lcssa,$$445,$341); //@line 126618 "c/sqlite3.c"
     }
     $343 = (($$445) + 1)|0; //@line 126612 "c/sqlite3.c"
     $344 = HEAP16[$59>>1]|0; //@line 126612 "c/sqlite3.c"
     $345 = $344 << 16 >> 16; //@line 126612 "c/sqlite3.c"
     $346 = ($343|0)<($345|0); //@line 126612 "c/sqlite3.c"
     if ($346) {
      $$445 = $343;
     } else {
      break;
     }
    }
   }
   $347 = ($48|0)==(0|0); //@line 126623 "c/sqlite3.c"
   $or$cond25 = $347 & $322; //@line 126623 "c/sqlite3.c"
   if (!($or$cond25)) {
    break;
   }
   (_sqlite3VdbeAddOp2($204,75,$$0643,$$1642)|0); //@line 126624 "c/sqlite3.c"
  }
 } while(0);
 $348 = (_sqlite3TriggerColmask($0,$27,$2,1,1,$21,$4)|0); //@line 126641 "c/sqlite3.c"
 $349 = HEAP16[$59>>1]|0; //@line 126644 "c/sqlite3.c"
 $350 = ($349<<16>>16)>(0); //@line 126644 "c/sqlite3.c"
 if ($350) {
  $351 = ((($21)) + 40|0);
  $$542 = 0;
  while(1) {
   $352 = HEAP16[$351>>1]|0; //@line 126645 "c/sqlite3.c"
   $353 = $352 << 16 >> 16; //@line 126645 "c/sqlite3.c"
   $354 = ($$542|0)==($353|0); //@line 126645 "c/sqlite3.c"
   L207: do {
    if ($354) {
     $355 = (($$542) + ($$0640))|0; //@line 126646 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($204,70,0,$355)|0); //@line 126646 "c/sqlite3.c"
    } else {
     $356 = (($66) + ($$542<<2)|0); //@line 126648 "c/sqlite3.c"
     $357 = HEAP32[$356>>2]|0; //@line 126648 "c/sqlite3.c"
     $358 = ($357|0)>(-1); //@line 126649 "c/sqlite3.c"
     if ($358) {
      $359 = (((($2)) + 4|0) + (($357*20)|0)|0); //@line 126650 "c/sqlite3.c"
      $360 = HEAP32[$359>>2]|0; //@line 126650 "c/sqlite3.c"
      $361 = (($$542) + ($$0640))|0; //@line 126650 "c/sqlite3.c"
      _sqlite3ExprCode($0,$360,$361); //@line 126650 "c/sqlite3.c"
      break;
     }
     $362 = HEAP32[$7>>2]|0; //@line 126651 "c/sqlite3.c"
     $363 = $362 & 1; //@line 126651 "c/sqlite3.c"
     $364 = ($363|0)==(0); //@line 126651 "c/sqlite3.c"
     $365 = ($$542>>>0)>(31); //@line 126651 "c/sqlite3.c"
     $or$cond27 = $365 | $364; //@line 126651 "c/sqlite3.c"
     do {
      if (!($or$cond27)) {
       $366 = 1 << $$542; //@line 126651 "c/sqlite3.c"
       $367 = $366 & $348; //@line 126651 "c/sqlite3.c"
       $368 = ($367|0)==(0); //@line 126651 "c/sqlite3.c"
       if (!($368)) {
        break;
       }
       $370 = (($$542) + ($$0640))|0; //@line 126661 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($204,70,0,$370)|0); //@line 126661 "c/sqlite3.c"
       break L207;
      }
     } while(0);
     $369 = (($$542) + ($$0640))|0; //@line 126659 "c/sqlite3.c"
     _sqlite3ExprCodeGetColumnToReg($0,$21,$$542,$$0660$lcssa,$369); //@line 126659 "c/sqlite3.c"
    }
   } while(0);
   $371 = (($$542) + 1)|0; //@line 126644 "c/sqlite3.c"
   $372 = HEAP16[$59>>1]|0; //@line 126644 "c/sqlite3.c"
   $373 = $372 << 16 >> 16; //@line 126644 "c/sqlite3.c"
   $374 = ($371|0)<($373|0); //@line 126644 "c/sqlite3.c"
   if ($374) {
    $$542 = $371;
   } else {
    break;
   }
  }
 }
 $375 = HEAP32[$7>>2]|0; //@line 126669 "c/sqlite3.c"
 $376 = $375 & 1; //@line 126669 "c/sqlite3.c"
 $377 = ($376|0)==(0); //@line 126669 "c/sqlite3.c"
 do {
  if (!($377)) {
   _sqlite3TableAffinity($204,$21,$$0640); //@line 126670 "c/sqlite3.c"
   _sqlite3CodeRowTrigger($0,$27,110,$2,1,$21,$$0643,$4,$$1658); //@line 126671 "c/sqlite3.c"
   $378 = ($48|0)==(0|0); //@line 126680 "c/sqlite3.c"
   if ($378) {
    (_sqlite3VdbeAddOp3($204,32,$$0660$lcssa,$$1658,$$0643)|0); //@line 126684 "c/sqlite3.c"
   } else {
    (_sqlite3VdbeAddOp4Int($204,29,$$0660$lcssa,$$1658,$$163625,$$064823)|0); //@line 126681 "c/sqlite3.c"
   }
   $379 = HEAP16[$59>>1]|0; //@line 126693 "c/sqlite3.c"
   $380 = ($379<<16>>16)>(0); //@line 126693 "c/sqlite3.c"
   if (!($380)) {
    break;
   }
   $381 = ((($21)) + 40|0);
   $$641 = 0;
   while(1) {
    $382 = (($66) + ($$641<<2)|0); //@line 126694 "c/sqlite3.c"
    $383 = HEAP32[$382>>2]|0; //@line 126694 "c/sqlite3.c"
    $384 = ($383|0)<(0); //@line 126694 "c/sqlite3.c"
    do {
     if ($384) {
      $385 = HEAP16[$381>>1]|0; //@line 126694 "c/sqlite3.c"
      $386 = $385 << 16 >> 16; //@line 126694 "c/sqlite3.c"
      $387 = ($$641|0)==($386|0); //@line 126694 "c/sqlite3.c"
      if ($387) {
       break;
      }
      $388 = (($$641) + ($$0640))|0; //@line 126695 "c/sqlite3.c"
      _sqlite3ExprCodeGetColumnOfTable($204,$21,$$0660$lcssa,$$641,$388); //@line 126695 "c/sqlite3.c"
     }
    } while(0);
    $389 = (($$641) + 1)|0; //@line 126693 "c/sqlite3.c"
    $390 = HEAP16[$59>>1]|0; //@line 126693 "c/sqlite3.c"
    $391 = $390 << 16 >> 16; //@line 126693 "c/sqlite3.c"
    $392 = ($389|0)<($391|0); //@line 126693 "c/sqlite3.c"
    if ($392) {
     $$641 = $389;
    } else {
     break;
    }
   }
  }
 } while(0);
 do {
  if (!($30)) {
   $393 = $4&255; //@line 126706 "c/sqlite3.c"
   _sqlite3GenerateConstraintChecks($0,$21,$70,$$0660$lcssa,$38,$$1642,$$0643,$140,$393,$$1658,$9,$66); //@line 126705 "c/sqlite3.c"
   if ($264) {
    _sqlite3FkCheck($0,$21,$$0643,0,$66,$152); //@line 126711 "c/sqlite3.c"
   }
   $394 = HEAP32[$9>>2]|0; //@line 126715 "c/sqlite3.c"
   $395 = ($152|0)==(0); //@line 126715 "c/sqlite3.c"
   $396 = $394 | $152; //@line 126715 "c/sqlite3.c"
   $397 = ($396|0)==(0); //@line 126715 "c/sqlite3.c"
   do {
    if ($397) {
     $$0 = 0;
    } else {
     $398 = ($48|0)==(0|0); //@line 126716 "c/sqlite3.c"
     if ($398) {
      $400 = (_sqlite3VdbeAddOp3($204,32,$$0660$lcssa,0,$$0643)|0); //@line 126719 "c/sqlite3.c"
      $$0 = $400;
      break;
     } else {
      $399 = (_sqlite3VdbeAddOp4Int($204,29,$$0660$lcssa,0,$$163625,$$064823)|0); //@line 126717 "c/sqlite3.c"
      $$0 = $399;
      break;
     }
    }
   } while(0);
   _sqlite3GenerateRowIndexDelete($0,$21,$$0660$lcssa,$38,$70,-1); //@line 126723 "c/sqlite3.c"
   $401 = ($153|0)<(2); //@line 126748 "c/sqlite3.c"
   $or$cond10 = $395 & $401; //@line 126748 "c/sqlite3.c"
   if (!($or$cond10)) {
    (_sqlite3VdbeAddOp2($204,119,$$0660$lcssa,0)|0); //@line 126749 "c/sqlite3.c"
   }
   if (!($397)) {
    _sqlite3VdbeJumpHere($204,$$0); //@line 126753 "c/sqlite3.c"
   }
   if ($264) {
    _sqlite3FkCheck($0,$21,0,$$1642,$66,$152); //@line 126757 "c/sqlite3.c"
    $403 = $402 ? 6 : 4; //@line 126763 "c/sqlite3.c"
    _sqlite3CompleteInsertion($0,$21,$$0660$lcssa,$38,$$1642,$70,$403,0,0); //@line 126761 "c/sqlite3.c"
    _sqlite3FkActions($0,$21,$2,$$0643,$66,$152); //@line 126771 "c/sqlite3.c"
    break;
   } else {
    $404 = $402 ? 6 : 4; //@line 126763 "c/sqlite3.c"
    _sqlite3CompleteInsertion($0,$21,$$0660$lcssa,$38,$$1642,$70,$404,0,0); //@line 126761 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $405 = HEAP32[$237>>2]|0; //@line 126777 "c/sqlite3.c"
 $406 = $405 & 128; //@line 126777 "c/sqlite3.c"
 $407 = ($406|0)==(0); //@line 126777 "c/sqlite3.c"
 do {
  if (!($407)) {
   $408 = ((($0)) + 124|0); //@line 126777 "c/sqlite3.c"
   $409 = HEAP32[$408>>2]|0; //@line 126777 "c/sqlite3.c"
   $410 = ($409|0)==(0|0); //@line 126777 "c/sqlite3.c"
   if (!($410)) {
    break;
   }
   (_sqlite3VdbeAddOp2($204,80,$$0644,1)|0); //@line 126778 "c/sqlite3.c"
  }
 } while(0);
 _sqlite3CodeRowTrigger($0,$27,110,$2,2,$21,$$0643,$4,$$1658); //@line 126781 "c/sqlite3.c"
 L258: do {
  switch ($$1663|0) {
  case 1:  {
   break;
  }
  case 2:  {
   _sqlite3VdbeResolveLabel($204,$$1658); //@line 126790 "c/sqlite3.c"
   _sqlite3WhereEnd($267); //@line 126791 "c/sqlite3.c"
   break;
  }
  default: {
   $411 = ($48|0)==(0|0); //@line 126792 "c/sqlite3.c"
   if ($411) {
    _sqlite3VdbeGoto($204,$$1658); //@line 126796 "c/sqlite3.c"
    break L258;
   } else {
    _sqlite3VdbeResolveLabel($204,$$1658); //@line 126793 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($204,7,$$0649,$$0653)|0); //@line 126794 "c/sqlite3.c"
    break L258;
   }
  }
  }
 } while(0);
 _sqlite3VdbeResolveLabel($204,$295); //@line 126798 "c/sqlite3.c"
 $412 = HEAP8[$206>>0]|0; //@line 126804 "c/sqlite3.c"
 $413 = ($412<<24>>24)==(0); //@line 126804 "c/sqlite3.c"
 do {
  if ($413) {
   $414 = ((($0)) + 124|0); //@line 126804 "c/sqlite3.c"
   $415 = HEAP32[$414>>2]|0; //@line 126804 "c/sqlite3.c"
   $416 = ($415|0)==(0|0); //@line 126804 "c/sqlite3.c"
   if (!($416)) {
    break;
   }
   _sqlite3AutoincrementEnd($0); //@line 126805 "c/sqlite3.c"
  }
 } while(0);
 $417 = HEAP32[$237>>2]|0; //@line 126813 "c/sqlite3.c"
 $418 = $417 & 128; //@line 126813 "c/sqlite3.c"
 $419 = ($418|0)==(0); //@line 126813 "c/sqlite3.c"
 if ($419) {
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $420 = ((($0)) + 124|0); //@line 126813 "c/sqlite3.c"
 $421 = HEAP32[$420>>2]|0; //@line 126813 "c/sqlite3.c"
 $422 = ($421|0)==(0|0); //@line 126813 "c/sqlite3.c"
 if (!($422)) {
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 $423 = HEAP8[$206>>0]|0; //@line 126813 "c/sqlite3.c"
 $424 = ($423<<24>>24)==(0); //@line 126813 "c/sqlite3.c"
 if (!($424)) {
  $425 = $66;
  _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
  _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
  _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
  _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
  _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($204,78,$$0644,1)|0); //@line 126814 "c/sqlite3.c"
 _sqlite3VdbeSetNumCols($204,1); //@line 126815 "c/sqlite3.c"
 _sqlite3VdbeSetColName($204,0,0,28089,0); //@line 126816 "c/sqlite3.c"
 $425 = $66;
 _sqlite3AuthContextPop($5); //@line 126820 "c/sqlite3.c"
 _sqlite3DbFree($14,$425); //@line 126821 "c/sqlite3.c"
 _sqlite3SrcListDelete($14,$1); //@line 126822 "c/sqlite3.c"
 _sqlite3ExprListDelete($14,$2); //@line 126823 "c/sqlite3.c"
 _sqlite3ExprDelete($14,$3); //@line 126824 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 126830 "c/sqlite3.c"
}
function _sqlite3ExprListAppendVector($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$lcssa = 0, $$054 = 0, $$05556 = 0, $$057 = 0, $$1 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 94238 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 94243 "c/sqlite3.c"
 $5 = ($1|0)==(0|0); //@line 94246 "c/sqlite3.c"
 if ($5) {
  $37 = 0;
 } else {
  $6 = HEAP32[$1>>2]|0; //@line 94246 "c/sqlite3.c"
  $37 = $6;
 }
 $7 = ($2|0)==(0|0); //@line 94249 "c/sqlite3.c"
 $8 = ($3|0)==(0|0); //@line 94250 "c/sqlite3.c"
 $or$cond3 = $7 | $8; //@line 94249 "c/sqlite3.c"
 do {
  if ($or$cond3) {
   $$054 = $3;$$1 = $1;
  } else {
   $9 = HEAP8[$3>>0]|0; //@line 94257 "c/sqlite3.c"
   $10 = ($9<<24>>24)==(119); //@line 94257 "c/sqlite3.c"
   if (!($10)) {
    $11 = ((($2)) + 4|0); //@line 94257 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 94257 "c/sqlite3.c"
    $13 = (_sqlite3ExprVectorSize($3)|0); //@line 94257 "c/sqlite3.c"
    $14 = ($12|0)==($13|0); //@line 94257 "c/sqlite3.c"
    if (!($14)) {
     HEAP32[$vararg_buffer>>2] = $12; //@line 94258 "c/sqlite3.c"
     $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 94258 "c/sqlite3.c"
     HEAP32[$vararg_ptr1>>2] = $13; //@line 94258 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,24804,$vararg_buffer); //@line 94258 "c/sqlite3.c"
     $$054 = $3;$$1 = $1;
     break;
    }
   }
   $15 = ((($2)) + 4|0); //@line 94263 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 94263 "c/sqlite3.c"
   $17 = ($16|0)>(0); //@line 94263 "c/sqlite3.c"
   if ($17) {
    $$05556 = 0;$$057 = $1;
    while(1) {
     $18 = (_sqlite3ExprForVectorField($0,$3,$$05556)|0); //@line 94264 "c/sqlite3.c"
     $19 = (_sqlite3ExprListAppend($0,$$057,$18)|0); //@line 94265 "c/sqlite3.c"
     $20 = ($19|0)==(0|0); //@line 94266 "c/sqlite3.c"
     if (!($20)) {
      $21 = HEAP32[$2>>2]|0; //@line 94268 "c/sqlite3.c"
      $22 = (($21) + ($$05556<<3)|0); //@line 94268 "c/sqlite3.c"
      $23 = HEAP32[$22>>2]|0; //@line 94268 "c/sqlite3.c"
      $24 = HEAP32[$19>>2]|0; //@line 94268 "c/sqlite3.c"
      $25 = (($24) + -1)|0; //@line 94268 "c/sqlite3.c"
      $26 = (((((($19)) + 4|0) + (($25*20)|0)|0)) + 4|0); //@line 94268 "c/sqlite3.c"
      HEAP32[$26>>2] = $23; //@line 94268 "c/sqlite3.c"
      HEAP32[$22>>2] = 0; //@line 94269 "c/sqlite3.c"
     }
     $27 = (($$05556) + 1)|0; //@line 94263 "c/sqlite3.c"
     $28 = HEAP32[$15>>2]|0; //@line 94263 "c/sqlite3.c"
     $29 = ($27|0)<($28|0); //@line 94263 "c/sqlite3.c"
     if ($29) {
      $$05556 = $27;$$057 = $19;
     } else {
      $$0$lcssa = $19;$$lcssa = $28;
      break;
     }
    }
   } else {
    $$0$lcssa = $1;$$lcssa = $16;
   }
   $30 = ((($4)) + 73|0); //@line 94273 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 94273 "c/sqlite3.c"
   $32 = ($31<<24>>24)==(0); //@line 94273 "c/sqlite3.c"
   if ($32) {
    $33 = HEAP8[$3>>0]|0; //@line 94273 "c/sqlite3.c"
    $34 = ($33<<24>>24)==(119); //@line 94273 "c/sqlite3.c"
    $35 = ($$0$lcssa|0)!=(0|0); //@line 94273 "c/sqlite3.c"
    $or$cond = $35 & $34; //@line 94273 "c/sqlite3.c"
    if ($or$cond) {
     $36 = (((($$0$lcssa)) + 4|0) + (($37*20)|0)|0); //@line 94274 "c/sqlite3.c"
     $38 = HEAP32[$36>>2]|0; //@line 94274 "c/sqlite3.c"
     $39 = ((($38)) + 16|0); //@line 94280 "c/sqlite3.c"
     HEAP32[$39>>2] = $3; //@line 94280 "c/sqlite3.c"
     $40 = ((($38)) + 28|0); //@line 94285 "c/sqlite3.c"
     HEAP32[$40>>2] = $$lcssa; //@line 94285 "c/sqlite3.c"
     $$054 = 0;$$1 = $$0$lcssa;
    } else {
     $$054 = $3;$$1 = $$0$lcssa;
    }
   } else {
    $$054 = $3;$$1 = $$0$lcssa;
   }
  }
 } while(0);
 _sqlite3ExprDelete($4,$$054); //@line 94289 "c/sqlite3.c"
 _sqlite3IdListDelete($4,$2); //@line 94290 "c/sqlite3.c"
 STACKTOP = sp;return ($$1|0); //@line 94291 "c/sqlite3.c"
}
function _sqlite3Insert($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0529652 = 0, $$0531639 = 0, $$0537628 = 0, $$0537628$in = 0, $$0542$lcssa = 0, $$0542631 = 0, $$0546645 = 0, $$0558 = 0, $$0559 = 0, $$0566644 = 0, $$0571 = 0, $$0573 = 0, $$0574 = 0, $$0577 = 0, $$0578 = 0, $$1 = 0, $$1530646 = 0, $$1532620 = 0, $$1539 = 0;
 var $$1543610 = 0, $$1572 = 0, $$1579 = 0, $$2533614 = 0, $$2544594 = 0, $$2548 = 0, $$2557 = 0, $$2562 = 0, $$2565 = 0, $$2632 = 0, $$3534 = 0, $$3541 = 0, $$3545 = 0, $$3549 = 0, $$3569 = 0, $$3627 = 0, $$4550 = 0, $$4550$lobit = 0, $$4570 = 0, $$4621 = 0;
 var $$5536607 = 0, $$5611 = 0, $$6 = 0, $$lcssa = 0, $$lcssa599 = 0, $$lobit = 0, $$lobit580 = 0, $$lobit581 = 0, $$not = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0;
 var $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0;
 var $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0;
 var $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0;
 var $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0;
 var $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0;
 var $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0;
 var $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0;
 var $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0;
 var $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0;
 var $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0;
 var $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0;
 var $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0;
 var $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0;
 var $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0;
 var $or$cond = 0, $or$cond11 = 0, $or$cond4 = 0, $or$cond6 = 0, $or$cond9 = 0, $phitmp = 0, $spec$select = 0, $spec$select582 = 0, $spec$select584 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_buffer9 = 0, $vararg_ptr1 = 0, $vararg_ptr12 = 0, $vararg_ptr2 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $vararg_buffer9 = sp + 32|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $5 = sp + 108|0;
 $6 = sp + 104|0;
 $7 = sp + 80|0;
 $8 = sp + 72|0;
 $9 = sp + 40|0;
 HEAP32[$5>>2] = 0; //@line 111329 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 111330 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 111359 "c/sqlite3.c"
 $11 = ((($0)) + 36|0); //@line 111360 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 111360 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 111360 "c/sqlite3.c"
 L1: do {
  if ($13) {
   $14 = ((($10)) + 73|0); //@line 111360 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 111360 "c/sqlite3.c"
   $16 = ($15<<24>>24)==(0); //@line 111360 "c/sqlite3.c"
   if ($16) {
    $17 = ((($7)) + 4|0); //@line 111363 "c/sqlite3.c"
    HEAP32[$17>>2] = 0; //@line 111363 "c/sqlite3.c"
    $18 = ($2|0)==(0|0); //@line 111369 "c/sqlite3.c"
    if ($18) {
     $$0 = 0;$$0571 = 0;
    } else {
     $19 = ((($2)) + 8|0); //@line 111369 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 111369 "c/sqlite3.c"
     $21 = $20 & 512; //@line 111369 "c/sqlite3.c"
     $22 = ($21|0)==(0); //@line 111369 "c/sqlite3.c"
     if ($22) {
      $$0 = $2;$$0571 = 0;
     } else {
      $23 = ((($2)) + 48|0); //@line 111369 "c/sqlite3.c"
      $24 = HEAP32[$23>>2]|0; //@line 111369 "c/sqlite3.c"
      $25 = ($24|0)==(0|0); //@line 111369 "c/sqlite3.c"
      if ($25) {
       $26 = HEAP32[$2>>2]|0; //@line 111370 "c/sqlite3.c"
       HEAP32[$2>>2] = 0; //@line 111371 "c/sqlite3.c"
       _sqlite3SelectDelete($10,$2); //@line 111372 "c/sqlite3.c"
       $$0 = 0;$$0571 = $26;
      } else {
       $$0 = $2;$$0571 = 0;
      }
     }
    }
    $27 = (_sqlite3SrcListLookup($0,$1)|0); //@line 111379 "c/sqlite3.c"
    $28 = ($27|0)==(0|0); //@line 111380 "c/sqlite3.c"
    if ($28) {
     $$1 = $$0;$$1572 = $$0571;$371 = 0;
    } else {
     $29 = ((($27)) + 72|0); //@line 111383 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 111383 "c/sqlite3.c"
     $31 = (_sqlite3SchemaToIndex($10,$30)|0); //@line 111383 "c/sqlite3.c"
     $32 = HEAP32[$27>>2]|0; //@line 111385 "c/sqlite3.c"
     $33 = ((($10)) + 16|0); //@line 111386 "c/sqlite3.c"
     $34 = HEAP32[$33>>2]|0; //@line 111386 "c/sqlite3.c"
     $35 = (($34) + ($31<<4)|0); //@line 111386 "c/sqlite3.c"
     $36 = HEAP32[$35>>2]|0; //@line 111386 "c/sqlite3.c"
     $37 = (_sqlite3AuthCheck($0,18,$32,0,$36)|0); //@line 111385 "c/sqlite3.c"
     $38 = ($37|0)==(0); //@line 111385 "c/sqlite3.c"
     if ($38) {
      $39 = ((($27)) + 36|0); //@line 111389 "c/sqlite3.c"
      $40 = HEAP32[$39>>2]|0; //@line 111389 "c/sqlite3.c"
      $41 = $40 >>> 5; //@line 111389 "c/sqlite3.c"
      $$lobit = $41 & 1; //@line 111389 "c/sqlite3.c"
      $42 = (_sqlite3TriggersExist($0,$27,108,0,$8)|0); //@line 111395 "c/sqlite3.c"
      $43 = ((($27)) + 12|0); //@line 111396 "c/sqlite3.c"
      $44 = HEAP32[$43>>2]|0; //@line 111396 "c/sqlite3.c"
      $45 = ($44|0)!=(0|0); //@line 111396 "c/sqlite3.c"
      $46 = (_sqlite3ViewGetColumnNames($0,$27)|0); //@line 111411 "c/sqlite3.c"
      $47 = ($46|0)==(0); //@line 111411 "c/sqlite3.c"
      if ($47) {
       $48 = HEAP32[$8>>2]|0; //@line 111417 "c/sqlite3.c"
       $49 = (_sqlite3IsReadOnly($0,$27,$48)|0); //@line 111417 "c/sqlite3.c"
       $50 = ($49|0)==(0); //@line 111417 "c/sqlite3.c"
       if ($50) {
        $51 = (_sqlite3GetVdbe($0)|0); //@line 111423 "c/sqlite3.c"
        $52 = ($51|0)==(0|0); //@line 111424 "c/sqlite3.c"
        if ($52) {
         $$1 = $$0;$$1572 = $$0571;$371 = 0;
        } else {
         $53 = ((($0)) + 18|0); //@line 111425 "c/sqlite3.c"
         $54 = HEAP8[$53>>0]|0; //@line 111425 "c/sqlite3.c"
         $55 = ($54<<24>>24)==(0); //@line 111425 "c/sqlite3.c"
         if ($55) {
          _sqlite3VdbeCountChanges($51); //@line 111425 "c/sqlite3.c"
         }
         $56 = ($$0|0)!=(0|0); //@line 111426 "c/sqlite3.c"
         $57 = ($42|0)!=(0|0); //@line 111426 "c/sqlite3.c"
         $58 = $56 | $57; //@line 111426 "c/sqlite3.c"
         $59 = $58&1; //@line 111426 "c/sqlite3.c"
         _sqlite3BeginWriteOperation($0,$59,$31); //@line 111426 "c/sqlite3.c"
         $60 = ($3|0)==(0|0); //@line 111438 "c/sqlite3.c"
         if ($60) {
          $61 = (_xferOptimization($0,$27,$$0,$4,$31)|0); //@line 111438 "c/sqlite3.c"
          $62 = ($61|0)==(0); //@line 111438 "c/sqlite3.c"
          if ($62) {
           label = 16;
          } else {
           $$1579 = 0;$372 = 0;
          }
         } else {
          label = 16;
         }
         do {
          if ((label|0) == 16) {
           $63 = (_autoIncBegin($0,$31,$27)|0); //@line 111448 "c/sqlite3.c"
           $64 = ((($0)) + 44|0); //@line 111453 "c/sqlite3.c"
           $65 = HEAP32[$64>>2]|0; //@line 111453 "c/sqlite3.c"
           $66 = (($65) + 1)|0; //@line 111453 "c/sqlite3.c"
           $67 = ((($27)) + 42|0); //@line 111454 "c/sqlite3.c"
           $68 = HEAP16[$67>>1]|0; //@line 111454 "c/sqlite3.c"
           $69 = $68 << 16 >> 16; //@line 111454 "c/sqlite3.c"
           $70 = (($65) + 1)|0; //@line 111454 "c/sqlite3.c"
           $71 = (($70) + ($69))|0; //@line 111454 "c/sqlite3.c"
           HEAP32[$64>>2] = $71; //@line 111454 "c/sqlite3.c"
           $72 = ((($27)) + 56|0); //@line 111455 "c/sqlite3.c"
           $73 = HEAP32[$72>>2]|0; //@line 111455 "c/sqlite3.c"
           $74 = ($73|0)==(0); //@line 111455 "c/sqlite3.c"
           if ($74) {
            $$0577 = $66;
           } else {
            $75 = (($71) + 1)|0; //@line 111457 "c/sqlite3.c"
            $76 = (($65) + 2)|0; //@line 111456 "c/sqlite3.c"
            HEAP32[$64>>2] = $75; //@line 111457 "c/sqlite3.c"
            $$0577 = $76;
           }
           $77 = (($$0577) + 1)|0; //@line 111459 "c/sqlite3.c"
           $78 = HEAP32[$39>>2]|0; //@line 111472 "c/sqlite3.c"
           $79 = $78 >>> 7; //@line 111472 "c/sqlite3.c"
           $$lobit580 = $79 & 1; //@line 111472 "c/sqlite3.c"
           $80 = $$lobit580 ^ 1; //@line 111472 "c/sqlite3.c"
           $81 = $80&255; //@line 111472 "c/sqlite3.c"
           $82 = ($3|0)!=(0|0); //@line 111473 "c/sqlite3.c"
           L24: do {
            if ($82) {
             $83 = ((($3)) + 4|0); //@line 111474 "c/sqlite3.c"
             $84 = HEAP32[$83>>2]|0; //@line 111474 "c/sqlite3.c"
             $85 = ($84|0)>(0); //@line 111474 "c/sqlite3.c"
             if ($85) {
              $86 = HEAP32[$3>>2]|0;
              $87 = HEAP32[$83>>2]|0;
              $$0529652 = 0;
              while(1) {
               $88 = (((($86) + ($$0529652<<3)|0)) + 4|0); //@line 111475 "c/sqlite3.c"
               HEAP32[$88>>2] = -1; //@line 111475 "c/sqlite3.c"
               $89 = (($$0529652) + 1)|0; //@line 111474 "c/sqlite3.c"
               $90 = ($89|0)<($87|0); //@line 111474 "c/sqlite3.c"
               if ($90) {
                $$0529652 = $89;
               } else {
                break;
               }
              }
              $91 = ($87|0)>(0); //@line 111477 "c/sqlite3.c"
              if ($91) {
               $92 = ($68<<16>>16)>(0);
               $93 = ($$lobit|0)!=(0);
               $94 = ((($27)) + 4|0);
               $95 = ((($27)) + 40|0);
               $$0546645 = -1;$$0566644 = $81;$$1530646 = 0;
               while(1) {
                $96 = HEAP32[$3>>2]|0;
                $97 = (($96) + ($$1530646<<3)|0);
                $98 = HEAP32[$97>>2]|0;
                L33: do {
                 if ($92) {
                  $99 = HEAP32[$94>>2]|0;
                  $$0531639 = 0;$102 = $98;$106 = $96;
                  while(1) {
                   $100 = (($99) + ($$0531639<<4)|0); //@line 111479 "c/sqlite3.c"
                   $101 = HEAP32[$100>>2]|0; //@line 111479 "c/sqlite3.c"
                   $103 = (_sqlite3StrICmp($102,$101)|0); //@line 111479 "c/sqlite3.c"
                   $104 = ($103|0)==(0); //@line 111479 "c/sqlite3.c"
                   if ($104) {
                    break;
                   }
                   $111 = (($$0531639) + 1)|0; //@line 111478 "c/sqlite3.c"
                   $112 = ($111|0)<($69|0); //@line 111478 "c/sqlite3.c"
                   $113 = HEAP32[$3>>2]|0;
                   $114 = (($113) + ($$1530646<<3)|0);
                   $115 = HEAP32[$114>>2]|0;
                   if ($112) {
                    $$0531639 = $111;$102 = $115;$106 = $113;
                   } else {
                    $$lcssa599 = $115;
                    label = 29;
                    break L33;
                   }
                  }
                  $105 = (((($106) + ($$1530646<<3)|0)) + 4|0); //@line 111480 "c/sqlite3.c"
                  HEAP32[$105>>2] = $$0531639; //@line 111480 "c/sqlite3.c"
                  $107 = ($$1530646|0)==($$0531639|0); //@line 111481 "c/sqlite3.c"
                  $spec$select = $107 ? $$0566644 : 0; //@line 111481 "c/sqlite3.c"
                  $108 = HEAP16[$95>>1]|0; //@line 111482 "c/sqlite3.c"
                  $109 = $108 << 16 >> 16; //@line 111482 "c/sqlite3.c"
                  $110 = ($$0531639|0)==($109|0); //@line 111482 "c/sqlite3.c"
                  $spec$select584 = $110 ? $$1530646 : $$0546645; //@line 111482 "c/sqlite3.c"
                  $$2548 = $spec$select584;$$3569 = $spec$select;
                 } else {
                  $$lcssa599 = $98;
                  label = 29;
                 }
                } while(0);
                if ((label|0) == 29) {
                 label = 0;
                 $116 = (_sqlite3IsRowid($$lcssa599)|0); //@line 111489 "c/sqlite3.c"
                 $117 = ($116|0)==(0); //@line 111489 "c/sqlite3.c"
                 $or$cond = $93 | $117; //@line 111489 "c/sqlite3.c"
                 if ($or$cond) {
                  break;
                 } else {
                  $$2548 = $$1530646;$$3569 = 0;
                 }
                }
                $119 = (($$1530646) + 1)|0; //@line 111477 "c/sqlite3.c"
                $120 = ($119|0)<($87|0); //@line 111477 "c/sqlite3.c"
                if ($120) {
                 $$0546645 = $$2548;$$0566644 = $$3569;$$1530646 = $119;
                } else {
                 $$3549 = $$2548;$$4570 = $$3569;
                 break L24;
                }
               }
               HEAP32[$vararg_buffer>>2] = $1; //@line 111493 "c/sqlite3.c"
               $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 111493 "c/sqlite3.c"
               HEAP32[$vararg_ptr1>>2] = 0; //@line 111493 "c/sqlite3.c"
               $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 111493 "c/sqlite3.c"
               HEAP32[$vararg_ptr2>>2] = $$lcssa599; //@line 111493 "c/sqlite3.c"
               _sqlite3ErrorMsg($0,27188,$vararg_buffer); //@line 111493 "c/sqlite3.c"
               $118 = ((($0)) + 17|0); //@line 111495 "c/sqlite3.c"
               HEAP8[$118>>0] = 1; //@line 111495 "c/sqlite3.c"
               $$1 = $$0;$$1572 = $$0571;$371 = 0;
               break L1;
              } else {
               $$3549 = -1;$$4570 = $81;
              }
             } else {
              $$3549 = -1;$$4570 = $81;
             }
            } else {
             $$3549 = -1;$$4570 = $81;
            }
           } while(0);
           do {
            if ($56) {
             $121 = HEAP32[$64>>2]|0; //@line 111514 "c/sqlite3.c"
             $122 = (($121) + 1)|0; //@line 111514 "c/sqlite3.c"
             HEAP32[$64>>2] = $122; //@line 111514 "c/sqlite3.c"
             $123 = (_sqlite3VdbeCurrentAddr($51)|0); //@line 111515 "c/sqlite3.c"
             $124 = (($123) + 1)|0; //@line 111515 "c/sqlite3.c"
             (_sqlite3VdbeAddOp3($51,15,$122,0,$124)|0); //@line 111516 "c/sqlite3.c"
             _sqlite3SelectDestInit($7,13,$122); //@line 111517 "c/sqlite3.c"
             $125 = ($$4570<<24>>24)==(0); //@line 111518 "c/sqlite3.c"
             $126 = $125 ? 0 : $77; //@line 111518 "c/sqlite3.c"
             $127 = ((($7)) + 8|0); //@line 111518 "c/sqlite3.c"
             HEAP32[$127>>2] = $126; //@line 111518 "c/sqlite3.c"
             $128 = HEAP16[$67>>1]|0; //@line 111519 "c/sqlite3.c"
             $129 = $128 << 16 >> 16; //@line 111519 "c/sqlite3.c"
             $130 = ((($7)) + 12|0); //@line 111519 "c/sqlite3.c"
             HEAP32[$130>>2] = $129; //@line 111519 "c/sqlite3.c"
             $131 = (_sqlite3Select($0,$$0,$7)|0); //@line 111520 "c/sqlite3.c"
             $132 = HEAP32[$127>>2]|0; //@line 111521 "c/sqlite3.c"
             $133 = ($131|0)==(0); //@line 111522 "c/sqlite3.c"
             if (!($133)) {
              $$1 = $$0;$$1572 = $$0571;$371 = 0;
              break L1;
             }
             $134 = HEAP8[$14>>0]|0; //@line 111522 "c/sqlite3.c"
             $135 = ($134<<24>>24)==(0); //@line 111522 "c/sqlite3.c"
             if (!($135)) {
              $$1 = $$0;$$1572 = $$0571;$371 = 0;
              break L1;
             }
             $136 = HEAP32[$11>>2]|0; //@line 111522 "c/sqlite3.c"
             $137 = ($136|0)==(0); //@line 111522 "c/sqlite3.c"
             if (!($137)) {
              $$1 = $$0;$$1572 = $$0571;$371 = 0;
              break L1;
             }
             _sqlite3VdbeEndCoroutine($51,$122); //@line 111523 "c/sqlite3.c"
             _sqlite3VdbeJumpHere($51,$123); //@line 111524 "c/sqlite3.c"
             $138 = HEAP32[$$0>>2]|0; //@line 111526 "c/sqlite3.c"
             $139 = HEAP32[$138>>2]|0; //@line 111526 "c/sqlite3.c"
             if (!($57)) {
              $140 = (_readsTable($0,$31,$27)|0); //@line 111537 "c/sqlite3.c"
              $141 = ($140|0)==(0); //@line 111537 "c/sqlite3.c"
              if ($141) {
               $$0573 = $132;$$2557 = 0;$$2562 = 0;$$3541 = $139;
               break;
              }
             }
             $142 = ((($0)) + 40|0); //@line 111556 "c/sqlite3.c"
             $143 = HEAP32[$142>>2]|0; //@line 111556 "c/sqlite3.c"
             $144 = (($143) + 1)|0; //@line 111556 "c/sqlite3.c"
             HEAP32[$142>>2] = $144; //@line 111556 "c/sqlite3.c"
             $145 = (_sqlite3GetTempReg($0)|0); //@line 111557 "c/sqlite3.c"
             $146 = (_sqlite3GetTempReg($0)|0); //@line 111558 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($51,109,$143,$139)|0); //@line 111559 "c/sqlite3.c"
             $147 = HEAP32[$17>>2]|0; //@line 111560 "c/sqlite3.c"
             $148 = (_sqlite3VdbeAddOp1($51,16,$147)|0); //@line 111560 "c/sqlite3.c"
             (_sqlite3VdbeAddOp3($51,100,$132,$139,$145)|0); //@line 111561 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($51,116,$143,$146)|0); //@line 111562 "c/sqlite3.c"
             (_sqlite3VdbeAddOp3($51,117,$143,$145,$146)|0); //@line 111563 "c/sqlite3.c"
             _sqlite3VdbeGoto($51,$148); //@line 111564 "c/sqlite3.c"
             _sqlite3VdbeJumpHere($51,$148); //@line 111565 "c/sqlite3.c"
             _sqlite3ReleaseTempReg($0,$145); //@line 111566 "c/sqlite3.c"
             _sqlite3ReleaseTempReg($0,$146); //@line 111567 "c/sqlite3.c"
             $$0573 = $132;$$2557 = $143;$$2562 = 1;$$3541 = $139;
            } else {
             $149 = ((($9)) + 4|0);
             ;HEAP32[$149>>2]=0|0;HEAP32[$149+4>>2]=0|0;HEAP32[$149+8>>2]=0|0;HEAP32[$149+12>>2]=0|0;HEAP32[$149+16>>2]=0|0;HEAP32[$149+20>>2]=0|0;HEAP32[$149+24>>2]=0|0; //@line 111574 "c/sqlite3.c"
             HEAP32[$9>>2] = $0; //@line 111575 "c/sqlite3.c"
             $150 = ($$0571|0)==(0|0); //@line 111578 "c/sqlite3.c"
             if ($150) {
              $$1539 = 0;
             } else {
              $151 = HEAP32[$$0571>>2]|0; //@line 111579 "c/sqlite3.c"
              $152 = (_sqlite3ResolveExprListNames($9,$$0571)|0); //@line 111580 "c/sqlite3.c"
              $153 = ($152|0)==(0); //@line 111580 "c/sqlite3.c"
              if ($153) {
               $$1539 = $151;
              } else {
               $$1 = 0;$$1572 = $$0571;$371 = 0;
               break L1;
              }
             }
             $$0573 = 0;$$2557 = -1;$$2562 = 0;$$3541 = $$1539;
            }
           } while(0);
           $154 = ($$3541|0)>(0); //@line 111592 "c/sqlite3.c"
           $or$cond4 = $60 & $154; //@line 111592 "c/sqlite3.c"
           if ($or$cond4) {
            $155 = ((($27)) + 40|0); //@line 111593 "c/sqlite3.c"
            $156 = HEAP16[$155>>1]|0; //@line 111593 "c/sqlite3.c"
            $157 = $156 << 16 >> 16; //@line 111593 "c/sqlite3.c"
            $$4550 = $157;
           } else {
            $$4550 = $$3549;
           }
           $158 = HEAP16[$67>>1]|0; //@line 111599 "c/sqlite3.c"
           $159 = $158 << 16 >> 16; //@line 111599 "c/sqlite3.c"
           $160 = ($158<<16>>16)>(0); //@line 111599 "c/sqlite3.c"
           if ($160) {
            $161 = ((($27)) + 4|0);
            $162 = HEAP32[$161>>2]|0;
            $163 = HEAP16[$67>>1]|0;
            $164 = $163 << 16 >> 16;
            $$0542631 = 0;$$2632 = 0;
            while(1) {
             $165 = (((($162) + ($$2632<<4)|0)) + 15|0); //@line 111600 "c/sqlite3.c"
             $166 = HEAP8[$165>>0]|0; //@line 111600 "c/sqlite3.c"
             $167 = ($166&255) >>> 1; //@line 111600 "c/sqlite3.c"
             $$lobit581 = $167 & 1; //@line 111600 "c/sqlite3.c"
             $168 = $$lobit581&255; //@line 111600 "c/sqlite3.c"
             $169 = (($$0542631) + ($168))|0; //@line 111600 "c/sqlite3.c"
             $170 = (($$2632) + 1)|0; //@line 111599 "c/sqlite3.c"
             $171 = ($170|0)<($164|0); //@line 111599 "c/sqlite3.c"
             if ($171) {
              $$0542631 = $169;$$2632 = $170;
             } else {
              break;
             }
            }
            $172 = $163 << 16 >> 16; //@line 111599 "c/sqlite3.c"
            $$0542$lcssa = $169;$$lcssa = $172;
           } else {
            $$0542$lcssa = 0;$$lcssa = $159;
           }
           $173 = ($$3541|0)!=(0); //@line 111602 "c/sqlite3.c"
           $or$cond6 = $60 & $173; //@line 111602 "c/sqlite3.c"
           if ($or$cond6) {
            $174 = (($$lcssa) - ($$0542$lcssa))|0; //@line 111602 "c/sqlite3.c"
            $175 = ($$3541|0)==($174|0); //@line 111602 "c/sqlite3.c"
            if (!($175)) {
             HEAP32[$vararg_buffer3>>2] = $1; //@line 111603 "c/sqlite3.c"
             $vararg_ptr6 = ((($vararg_buffer3)) + 4|0); //@line 111603 "c/sqlite3.c"
             HEAP32[$vararg_ptr6>>2] = 0; //@line 111603 "c/sqlite3.c"
             $vararg_ptr7 = ((($vararg_buffer3)) + 8|0); //@line 111603 "c/sqlite3.c"
             HEAP32[$vararg_ptr7>>2] = $174; //@line 111603 "c/sqlite3.c"
             $vararg_ptr8 = ((($vararg_buffer3)) + 12|0); //@line 111603 "c/sqlite3.c"
             HEAP32[$vararg_ptr8>>2] = $$3541; //@line 111603 "c/sqlite3.c"
             _sqlite3ErrorMsg($0,27220,$vararg_buffer3); //@line 111603 "c/sqlite3.c"
             $$1 = $$0;$$1572 = $$0571;$371 = 0;
             break L1;
            }
           }
           do {
            if ($82) {
             $176 = ((($3)) + 4|0); //@line 111608 "c/sqlite3.c"
             $177 = HEAP32[$176>>2]|0; //@line 111608 "c/sqlite3.c"
             $178 = ($$3541|0)==($177|0); //@line 111608 "c/sqlite3.c"
             if ($178) {
              break;
             }
             HEAP32[$vararg_buffer9>>2] = $$3541; //@line 111609 "c/sqlite3.c"
             $vararg_ptr12 = ((($vararg_buffer9)) + 4|0); //@line 111609 "c/sqlite3.c"
             HEAP32[$vararg_ptr12>>2] = $177; //@line 111609 "c/sqlite3.c"
             _sqlite3ErrorMsg($0,27272,$vararg_buffer9); //@line 111609 "c/sqlite3.c"
             $$1 = $$0;$$1572 = $$0571;$371 = 0;
             break L1;
            }
           } while(0);
           $179 = ((($10)) + 28|0); //@line 111615 "c/sqlite3.c"
           $180 = HEAP32[$179>>2]|0; //@line 111615 "c/sqlite3.c"
           $181 = $180 & 128; //@line 111615 "c/sqlite3.c"
           $182 = ($181|0)==(0); //@line 111615 "c/sqlite3.c"
           if ($182) {
            $$0578 = 0;
           } else {
            $183 = HEAP32[$64>>2]|0; //@line 111616 "c/sqlite3.c"
            $184 = (($183) + 1)|0; //@line 111616 "c/sqlite3.c"
            HEAP32[$64>>2] = $184; //@line 111616 "c/sqlite3.c"
            (_sqlite3VdbeAddOp2($51,67,0,$184)|0); //@line 111617 "c/sqlite3.c"
            $$0578 = $184;
           }
           do {
            if ($45) {
             $$0574 = 0;$373 = 0;
            } else {
             $185 = (_sqlite3OpenTableAndIndices($0,$27,106,0,-1,0,$5,$6)|0); //@line 111623 "c/sqlite3.c"
             $186 = $185 << 2; //@line 111625 "c/sqlite3.c"
             $187 = (($186) + 4)|0; //@line 111625 "c/sqlite3.c"
             $188 = (_sqlite3DbMallocRawNN($10,$187,0)|0); //@line 111625 "c/sqlite3.c"
             $189 = ($188|0)==(0|0); //@line 111626 "c/sqlite3.c"
             if ($189) {
              $$1 = $$0;$$1572 = $$0571;$371 = 0;
              break L1;
             }
             $190 = ($185|0)>(0); //@line 111629 "c/sqlite3.c"
             if (!($190)) {
              $$0574 = $188;$373 = $188;
              break;
             }
             $191 = ((($27)) + 8|0); //@line 111629 "c/sqlite3.c"
             $$0537628$in = $191;$$3627 = 0;
             while(1) {
              $$0537628 = HEAP32[$$0537628$in>>2]|0;
              $192 = HEAP32[$64>>2]|0; //@line 111631 "c/sqlite3.c"
              $193 = (($192) + 1)|0; //@line 111631 "c/sqlite3.c"
              HEAP32[$64>>2] = $193; //@line 111631 "c/sqlite3.c"
              $194 = (($188) + ($$3627<<2)|0); //@line 111631 "c/sqlite3.c"
              HEAP32[$194>>2] = $193; //@line 111631 "c/sqlite3.c"
              $195 = ((($$0537628)) + 52|0); //@line 111632 "c/sqlite3.c"
              $196 = HEAP16[$195>>1]|0; //@line 111632 "c/sqlite3.c"
              $197 = $196&65535; //@line 111632 "c/sqlite3.c"
              $198 = HEAP32[$64>>2]|0; //@line 111632 "c/sqlite3.c"
              $199 = (($198) + ($197))|0; //@line 111632 "c/sqlite3.c"
              HEAP32[$64>>2] = $199; //@line 111632 "c/sqlite3.c"
              $200 = ((($$0537628)) + 20|0); //@line 111629 "c/sqlite3.c"
              $201 = (($$3627) + 1)|0; //@line 111629 "c/sqlite3.c"
              $exitcond = ($201|0)==($185|0); //@line 111629 "c/sqlite3.c"
              if ($exitcond) {
               $$0574 = $188;$373 = $188;
               break;
              } else {
               $$0537628$in = $200;$$3627 = $201;
              }
             }
            }
           } while(0);
           $202 = ($$2562<<24>>24)!=(0); //@line 111637 "c/sqlite3.c"
           do {
            if ($202) {
             $203 = (_sqlite3VdbeAddOp1($51,37,$$2557)|0); //@line 111647 "c/sqlite3.c"
             $204 = (_sqlite3VdbeCurrentAddr($51)|0); //@line 111648 "c/sqlite3.c"
             $$0558 = $203;$$0559 = $204;
            } else {
             if (!($56)) {
              $$0558 = 0;$$0559 = 0;
              break;
             }
             $205 = HEAP32[$17>>2]|0; //@line 111658 "c/sqlite3.c"
             $206 = (_sqlite3VdbeAddOp1($51,16,$205)|0); //@line 111658 "c/sqlite3.c"
             $$0558 = $206;$$0559 = $206;
            }
           } while(0);
           $207 = (_sqlite3VdbeMakeLabel($51)|0); //@line 111664 "c/sqlite3.c"
           $208 = HEAP32[$8>>2]|0; //@line 111665 "c/sqlite3.c"
           $209 = $208 & 1; //@line 111665 "c/sqlite3.c"
           $210 = ($209|0)==(0); //@line 111665 "c/sqlite3.c"
           if (!($210)) {
            $211 = HEAP16[$67>>1]|0; //@line 111666 "c/sqlite3.c"
            $212 = $211 << 16 >> 16; //@line 111666 "c/sqlite3.c"
            $213 = (($212) + 1)|0; //@line 111666 "c/sqlite3.c"
            $214 = (_sqlite3GetTempRange($0,$213)|0); //@line 111666 "c/sqlite3.c"
            $215 = ($$4550|0)<(0); //@line 111674 "c/sqlite3.c"
            if ($215) {
             (_sqlite3VdbeAddOp2($51,67,-1,$214)|0); //@line 111675 "c/sqlite3.c"
            } else {
             if ($202) {
              (_sqlite3VdbeAddOp3($51,98,$$2557,$$4550,$214)|0); //@line 111680 "c/sqlite3.c"
             } else {
              $216 = (((($$0571)) + 4|0) + (($$4550*20)|0)|0); //@line 111683 "c/sqlite3.c"
              $217 = HEAP32[$216>>2]|0; //@line 111683 "c/sqlite3.c"
              _sqlite3ExprCode($0,$217,$214); //@line 111683 "c/sqlite3.c"
             }
             $218 = (_sqlite3VdbeAddOp1($51,51,$214)|0); //@line 111685 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($51,67,-1,$214)|0); //@line 111686 "c/sqlite3.c"
             _sqlite3VdbeJumpHere($51,$218); //@line 111687 "c/sqlite3.c"
             (_sqlite3VdbeAddOp1($51,17,$214)|0); //@line 111688 "c/sqlite3.c"
            }
            $219 = HEAP16[$67>>1]|0; //@line 111698 "c/sqlite3.c"
            $220 = ($219<<16>>16)>(0); //@line 111698 "c/sqlite3.c"
            if ($220) {
             $221 = ((($3)) + 4|0);
             $222 = ($$0571|0)!=(0|0);
             $or$cond9 = $222 | $202;
             $223 = $60&1;
             $224 = ((($27)) + 4|0);
             $225 = (($214) + 1)|0;
             $226 = ((($3)) + 4|0);
             $227 = (($214) + 1)|0;
             $228 = (($214) + 1)|0;
             $$1532620 = 0;$$4621 = 0;
             while(1) {
              L104: do {
               if ($82) {
                $229 = HEAP32[$221>>2]|0; //@line 111700 "c/sqlite3.c"
                $230 = ($229|0)>(0); //@line 111700 "c/sqlite3.c"
                if (!($230)) {
                 $$3534 = 0;
                 break;
                }
                $231 = HEAP32[$3>>2]|0;
                $$2533614 = 0;
                while(1) {
                 $232 = (((($231) + ($$2533614<<3)|0)) + 4|0); //@line 111701 "c/sqlite3.c"
                 $233 = HEAP32[$232>>2]|0; //@line 111701 "c/sqlite3.c"
                 $234 = ($233|0)==($$4621|0); //@line 111701 "c/sqlite3.c"
                 if ($234) {
                  $$3534 = $$2533614;
                  break L104;
                 }
                 $235 = (($$2533614) + 1)|0; //@line 111700 "c/sqlite3.c"
                 $236 = HEAP32[$221>>2]|0; //@line 111700 "c/sqlite3.c"
                 $237 = ($235|0)<($236|0); //@line 111700 "c/sqlite3.c"
                 if ($237) {
                  $$2533614 = $235;
                 } else {
                  $$3534 = $235;
                  break;
                 }
                }
               } else {
                $$3534 = $$1532620;
               }
              } while(0);
              do {
               if ($or$cond9) {
                if ($82) {
                 $238 = HEAP32[$226>>2]|0; //@line 111704 "c/sqlite3.c"
                 $239 = ($$3534|0)<($238|0); //@line 111704 "c/sqlite3.c"
                 if (!($239)) {
                  label = 84;
                  break;
                 }
                }
                if ($202) {
                 $244 = (($227) + ($$4621))|0; //@line 111708 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp3($51,98,$$2557,$$3534,$244)|0); //@line 111708 "c/sqlite3.c"
                 break;
                } else {
                 $245 = (((($$0571)) + 4|0) + (($$3534*20)|0)|0); //@line 111711 "c/sqlite3.c"
                 $246 = HEAP32[$245>>2]|0; //@line 111711 "c/sqlite3.c"
                 $247 = (($228) + ($$4621))|0; //@line 111711 "c/sqlite3.c"
                 _sqlite3ExprCodeAndCache($0,$246,$247); //@line 111711 "c/sqlite3.c"
                 break;
                }
               } else {
                label = 84;
               }
              } while(0);
              if ((label|0) == 84) {
               label = 0;
               $240 = HEAP32[$224>>2]|0; //@line 111706 "c/sqlite3.c"
               $241 = (((($240) + ($$4621<<4)|0)) + 4|0); //@line 111706 "c/sqlite3.c"
               $242 = HEAP32[$241>>2]|0; //@line 111706 "c/sqlite3.c"
               $243 = (($225) + ($$4621))|0; //@line 111706 "c/sqlite3.c"
               _sqlite3ExprCode($0,$242,$243); //@line 111706 "c/sqlite3.c"
              }
              $spec$select582 = (($$3534) + ($223))|0; //@line 111713 "c/sqlite3.c"
              $248 = (($$4621) + 1)|0; //@line 111698 "c/sqlite3.c"
              $249 = HEAP16[$67>>1]|0; //@line 111698 "c/sqlite3.c"
              $250 = $249 << 16 >> 16; //@line 111698 "c/sqlite3.c"
              $251 = ($248|0)<($250|0); //@line 111698 "c/sqlite3.c"
              if ($251) {
               $$1532620 = $spec$select582;$$4621 = $248;
              } else {
               break;
              }
             }
            }
            if (!($45)) {
             $252 = (($214) + 1)|0; //@line 111722 "c/sqlite3.c"
             _sqlite3TableAffinity($51,$27,$252); //@line 111722 "c/sqlite3.c"
            }
            $253 = HEAP16[$67>>1]|0; //@line 111727 "c/sqlite3.c"
            $254 = $253 << 16 >> 16; //@line 111727 "c/sqlite3.c"
            $255 = (($214) + -1)|0; //@line 111727 "c/sqlite3.c"
            $256 = (($255) - ($254))|0; //@line 111727 "c/sqlite3.c"
            _sqlite3CodeRowTrigger($0,$42,108,0,1,$27,$256,$4,$207); //@line 111726 "c/sqlite3.c"
            $257 = HEAP16[$67>>1]|0; //@line 111729 "c/sqlite3.c"
            $258 = $257 << 16 >> 16; //@line 111729 "c/sqlite3.c"
            $259 = (($258) + 1)|0; //@line 111729 "c/sqlite3.c"
            _sqlite3ReleaseTempRange($0,$214,$259); //@line 111729 "c/sqlite3.c"
           }
           do {
            if (!($45)) {
             $260 = HEAP32[$72>>2]|0; //@line 111736 "c/sqlite3.c"
             $261 = ($260|0)==(0); //@line 111736 "c/sqlite3.c"
             if (!($261)) {
              (_sqlite3VdbeAddOp2($51,70,0,$66)|0); //@line 111738 "c/sqlite3.c"
             }
             $262 = ($$4550|0)>(-1); //@line 111740 "c/sqlite3.c"
             L132: do {
              if ($262) {
               do {
                if ($202) {
                 (_sqlite3VdbeAddOp3($51,98,$$2557,$$4550,$$0577)|0); //@line 111742 "c/sqlite3.c"
                 label = 102;
                } else {
                 if ($56) {
                  $263 = (($$4550) + ($$0573))|0; //@line 111744 "c/sqlite3.c"
                  (_sqlite3VdbeAddOp2($51,75,$263,$$0577)|0); //@line 111744 "c/sqlite3.c"
                  label = 102;
                  break;
                 }
                 $264 = (((($$0571)) + 4|0) + (($$4550*20)|0)|0); //@line 111747 "c/sqlite3.c"
                 $265 = HEAP32[$264>>2]|0; //@line 111747 "c/sqlite3.c"
                 _sqlite3ExprCode($0,$265,$$0577); //@line 111747 "c/sqlite3.c"
                 $266 = (_sqlite3VdbeGetOp($51,-1)|0); //@line 111748 "c/sqlite3.c"
                 $267 = HEAP8[$266>>0]|0; //@line 111750 "c/sqlite3.c"
                 $268 = ($267<<24>>24)==(70); //@line 111750 "c/sqlite3.c"
                 if (!($268)) {
                  label = 102;
                  break;
                 }
                 $269 = HEAP32[$72>>2]|0; //@line 111750 "c/sqlite3.c"
                 $270 = ($269|0)==(0); //@line 111750 "c/sqlite3.c"
                 if (!($270)) {
                  label = 104;
                  break;
                 }
                 HEAP8[$266>>0] = 116; //@line 111752 "c/sqlite3.c"
                 $271 = HEAP32[$5>>2]|0; //@line 111753 "c/sqlite3.c"
                 $272 = ((($266)) + 4|0); //@line 111753 "c/sqlite3.c"
                 HEAP32[$272>>2] = $271; //@line 111753 "c/sqlite3.c"
                 $273 = ((($266)) + 8|0); //@line 111754 "c/sqlite3.c"
                 HEAP32[$273>>2] = $$0577; //@line 111754 "c/sqlite3.c"
                 $274 = ((($266)) + 12|0); //@line 111755 "c/sqlite3.c"
                 HEAP32[$274>>2] = $63; //@line 111755 "c/sqlite3.c"
                 $$2565 = 1;
                 break L132;
                }
               } while(0);
               do {
                if ((label|0) == 102) {
                 $$pr = HEAP32[$72>>2]|0; //@line 111763 "c/sqlite3.c"
                 $275 = ($$pr|0)==(0); //@line 111763 "c/sqlite3.c"
                 if (!($275)) {
                  label = 104;
                  break;
                 }
                 $276 = (_sqlite3VdbeAddOp1($51,51,$$0577)|0); //@line 111764 "c/sqlite3.c"
                 $277 = HEAP32[$5>>2]|0; //@line 111765 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp3($51,116,$277,$$0577,$63)|0); //@line 111765 "c/sqlite3.c"
                 _sqlite3VdbeJumpHere($51,$276); //@line 111766 "c/sqlite3.c"
                }
               } while(0);
               if ((label|0) == 104) {
                $278 = (_sqlite3VdbeCurrentAddr($51)|0); //@line 111768 "c/sqlite3.c"
                $279 = (($278) + 2)|0; //@line 111769 "c/sqlite3.c"
                (_sqlite3VdbeAddOp2($51,50,$$0577,$279)|0); //@line 111769 "c/sqlite3.c"
               }
               (_sqlite3VdbeAddOp1($51,17,$$0577)|0); //@line 111771 "c/sqlite3.c"
               $$2565 = 0;
              } else {
               $280 = HEAP32[$72>>2]|0; //@line 111773 "c/sqlite3.c"
               $281 = $280 | $$lobit; //@line 111773 "c/sqlite3.c"
               $282 = ($281|0)==(0); //@line 111773 "c/sqlite3.c"
               if ($282) {
                $283 = HEAP32[$5>>2]|0; //@line 111776 "c/sqlite3.c"
                (_sqlite3VdbeAddOp3($51,116,$283,$$0577,$63)|0); //@line 111776 "c/sqlite3.c"
                $$2565 = 1;
                break;
               } else {
                (_sqlite3VdbeAddOp2($51,70,0,$$0577)|0); //@line 111774 "c/sqlite3.c"
                $$2565 = 0;
                break;
               }
              }
             } while(0);
             _autoIncStep($0,$63,$$0577); //@line 111779 "c/sqlite3.c"
             $284 = HEAP16[$67>>1]|0; //@line 111785 "c/sqlite3.c"
             $285 = ($284<<16>>16)>(0); //@line 111785 "c/sqlite3.c"
             if ($285) {
              $286 = ((($27)) + 40|0);
              $287 = ((($27)) + 4|0);
              $288 = ($$3541|0)==(0);
              $289 = ((($27)) + 4|0);
              $290 = ((($3)) + 4|0);
              $291 = ((($3)) + 4|0);
              $292 = ($$0573|0)==($77|0);
              $$1543610 = 0;$$5611 = 0;
              while(1) {
               $293 = (($$5611) + ($77))|0; //@line 111786 "c/sqlite3.c"
               $294 = HEAP16[$286>>1]|0; //@line 111787 "c/sqlite3.c"
               $295 = $294 << 16 >> 16; //@line 111787 "c/sqlite3.c"
               $296 = ($$5611|0)==($295|0); //@line 111787 "c/sqlite3.c"
               L157: do {
                if ($296) {
                 (_sqlite3VdbeAddOp1($51,71,$293)|0); //@line 111793 "c/sqlite3.c"
                 $$3545 = $$1543610;
                } else {
                 L160: do {
                  if ($60) {
                   $297 = HEAP32[$287>>2]|0; //@line 111797 "c/sqlite3.c"
                   $298 = (((($297) + ($$5611<<4)|0)) + 15|0); //@line 111797 "c/sqlite3.c"
                   $299 = HEAP8[$298>>0]|0; //@line 111797 "c/sqlite3.c"
                   $300 = $299 & 2; //@line 111797 "c/sqlite3.c"
                   $301 = ($300<<24>>24)==(0); //@line 111797 "c/sqlite3.c"
                   if ($301) {
                    $303 = (($$5611) - ($$1543610))|0; //@line 111801 "c/sqlite3.c"
                    $$6 = $303;
                    label = 121;
                    break;
                   } else {
                    $302 = (($$1543610) + 1)|0; //@line 111799 "c/sqlite3.c"
                    $$2544594 = $302;
                    break;
                   }
                  } else {
                   $304 = HEAP32[$290>>2]|0; //@line 111804 "c/sqlite3.c"
                   $305 = ($304|0)>(0); //@line 111804 "c/sqlite3.c"
                   if (!($305)) {
                    $$6 = 0;
                    label = 121;
                    break;
                   }
                   $306 = HEAP32[$3>>2]|0;
                   $$5536607 = 0;
                   while(1) {
                    $307 = (((($306) + ($$5536607<<3)|0)) + 4|0); //@line 111805 "c/sqlite3.c"
                    $308 = HEAP32[$307>>2]|0; //@line 111805 "c/sqlite3.c"
                    $309 = ($308|0)==($$5611|0); //@line 111805 "c/sqlite3.c"
                    if ($309) {
                     $$6 = $$5536607;
                     label = 121;
                     break L160;
                    }
                    $310 = (($$5536607) + 1)|0; //@line 111804 "c/sqlite3.c"
                    $311 = HEAP32[$290>>2]|0; //@line 111804 "c/sqlite3.c"
                    $312 = ($310|0)<($311|0); //@line 111804 "c/sqlite3.c"
                    if ($312) {
                     $$5536607 = $310;
                    } else {
                     $$6 = $310;
                     label = 121;
                     break;
                    }
                   }
                  }
                 } while(0);
                 do {
                  if ((label|0) == 121) {
                   label = 0;
                   $313 = ($$6|0)<(0); //@line 111808 "c/sqlite3.c"
                   $or$cond11 = $288 | $313; //@line 111808 "c/sqlite3.c"
                   if ($or$cond11) {
                    $$2544594 = $$1543610;
                    break;
                   }
                   if ($82) {
                    $314 = HEAP32[$291>>2]|0; //@line 111808 "c/sqlite3.c"
                    $315 = ($$6|0)<($314|0); //@line 111808 "c/sqlite3.c"
                    if (!($315)) {
                     $$2544594 = $$1543610;
                     break;
                    }
                   }
                   if ($202) {
                    (_sqlite3VdbeAddOp3($51,98,$$2557,$$6,$293)|0); //@line 111811 "c/sqlite3.c"
                    $$3545 = $$1543610;
                    break L157;
                   }
                   if (!($56)) {
                    $320 = (((($$0571)) + 4|0) + (($$6*20)|0)|0); //@line 111817 "c/sqlite3.c"
                    $321 = HEAP32[$320>>2]|0; //@line 111817 "c/sqlite3.c"
                    _sqlite3ExprCode($0,$321,$293); //@line 111817 "c/sqlite3.c"
                    $$3545 = $$1543610;
                    break L157;
                   }
                   if ($292) {
                    $$3545 = $$1543610;
                    break L157;
                   }
                   $319 = (($$6) + ($$0573))|0; //@line 111814 "c/sqlite3.c"
                   (_sqlite3VdbeAddOp2($51,76,$319,$293)|0); //@line 111814 "c/sqlite3.c"
                   $$3545 = $$1543610;
                   break L157;
                  }
                 } while(0);
                 $316 = HEAP32[$289>>2]|0; //@line 111809 "c/sqlite3.c"
                 $317 = (((($316) + ($$5611<<4)|0)) + 4|0); //@line 111809 "c/sqlite3.c"
                 $318 = HEAP32[$317>>2]|0; //@line 111809 "c/sqlite3.c"
                 _sqlite3ExprCodeFactorable($0,$318,$293); //@line 111809 "c/sqlite3.c"
                 $$3545 = $$2544594;
                }
               } while(0);
               $322 = (($$5611) + 1)|0; //@line 111785 "c/sqlite3.c"
               $323 = HEAP16[$67>>1]|0; //@line 111785 "c/sqlite3.c"
               $324 = $323 << 16 >> 16; //@line 111785 "c/sqlite3.c"
               $325 = ($322|0)<($324|0); //@line 111785 "c/sqlite3.c"
               if ($325) {
                $$1543610 = $$3545;$$5611 = $322;
               } else {
                break;
               }
              }
             }
             $326 = HEAP32[$72>>2]|0; //@line 111825 "c/sqlite3.c"
             $327 = ($326|0)==(0); //@line 111825 "c/sqlite3.c"
             if (!($327)) {
              $328 = (_sqlite3GetVTable($10,$27)|0); //@line 111826 "c/sqlite3.c"
              _sqlite3VtabMakeWritable($0,$27); //@line 111827 "c/sqlite3.c"
              $329 = HEAP16[$67>>1]|0; //@line 111828 "c/sqlite3.c"
              $330 = $329 << 16 >> 16; //@line 111828 "c/sqlite3.c"
              $331 = (($330) + 2)|0; //@line 111828 "c/sqlite3.c"
              (_sqlite3VdbeAddOp4($51,12,1,$331,$66,$328,-12)|0); //@line 111828 "c/sqlite3.c"
              $332 = ($4|0)==(10); //@line 111829 "c/sqlite3.c"
              $333 = $4&65535; //@line 111829 "c/sqlite3.c"
              $334 = $332 ? 2 : $333; //@line 111829 "c/sqlite3.c"
              _sqlite3VdbeChangeP5($51,$334); //@line 111829 "c/sqlite3.c"
              _sqlite3MayAbort($0); //@line 111830 "c/sqlite3.c"
              break;
             }
             $335 = HEAP32[$5>>2]|0; //@line 111836 "c/sqlite3.c"
             $336 = HEAP32[$6>>2]|0; //@line 111836 "c/sqlite3.c"
             $$4550$lobit = $$4550 >>> 31; //@line 111837 "c/sqlite3.c"
             $337 = $$4550$lobit&255; //@line 111837 "c/sqlite3.c"
             $$not = $337 ^ 1; //@line 111837 "c/sqlite3.c"
             $338 = $4&255; //@line 111837 "c/sqlite3.c"
             _sqlite3GenerateConstraintChecks($0,$27,$$0574,$335,$336,$66,0,$$not,$338,$207,$9,0); //@line 111836 "c/sqlite3.c"
             _sqlite3FkCheck($0,$27,0,$66,0,0); //@line 111839 "c/sqlite3.c"
             $339 = HEAP32[$9>>2]|0; //@line 111849 "c/sqlite3.c"
             $340 = ($339|0)==(0); //@line 111849 "c/sqlite3.c"
             do {
              if ($340) {
               $349 = 1;
              } else {
               $341 = ($42|0)==(0|0); //@line 111849 "c/sqlite3.c"
               if (!($341)) {
                $349 = 0;
                break;
               }
               $342 = HEAP32[$179>>2]|0; //@line 111850 "c/sqlite3.c"
               $343 = $342 & 16384; //@line 111850 "c/sqlite3.c"
               $344 = ($343|0)==(0); //@line 111850 "c/sqlite3.c"
               if ($344) {
                $349 = 1;
                break;
               }
               $345 = (_sqlite3FkReferences($27)|0); //@line 111850 "c/sqlite3.c"
               $346 = ($345|0)==(0|0); //@line 111850 "c/sqlite3.c"
               $phitmp = $346&1; //@line 111850 "c/sqlite3.c"
               $349 = $phitmp;
              }
             } while(0);
             $347 = HEAP32[$5>>2]|0; //@line 111852 "c/sqlite3.c"
             $348 = HEAP32[$6>>2]|0; //@line 111852 "c/sqlite3.c"
             _sqlite3CompleteInsertion($0,$27,$347,$348,$66,$$0574,0,$$2565,$349); //@line 111852 "c/sqlite3.c"
            }
           } while(0);
           $350 = HEAP32[$179>>2]|0; //@line 111860 "c/sqlite3.c"
           $351 = $350 & 128; //@line 111860 "c/sqlite3.c"
           $352 = ($351|0)==(0); //@line 111860 "c/sqlite3.c"
           if (!($352)) {
            (_sqlite3VdbeAddOp2($51,80,$$0578,1)|0); //@line 111861 "c/sqlite3.c"
           }
           if ($57) {
            $353 = (($$0577) + -1)|0; //@line 111867 "c/sqlite3.c"
            $354 = HEAP16[$67>>1]|0; //@line 111867 "c/sqlite3.c"
            $355 = $354 << 16 >> 16; //@line 111867 "c/sqlite3.c"
            $356 = (($353) - ($355))|0; //@line 111867 "c/sqlite3.c"
            _sqlite3CodeRowTrigger($0,$42,108,0,2,$27,$356,$4,$207); //@line 111866 "c/sqlite3.c"
           }
           _sqlite3VdbeResolveLabel($51,$207); //@line 111873 "c/sqlite3.c"
           if ($202) {
            (_sqlite3VdbeAddOp2($51,7,$$2557,$$0559)|0); //@line 111875 "c/sqlite3.c"
            _sqlite3VdbeJumpHere($51,$$0558); //@line 111876 "c/sqlite3.c"
            (_sqlite3VdbeAddOp1($51,113,$$2557)|0); //@line 111877 "c/sqlite3.c"
            $$1579 = $$0578;$372 = $373;
            break;
           }
           if (!($56)) {
            $$1579 = $$0578;$372 = $373;
            break;
           }
           _sqlite3VdbeGoto($51,$$0559); //@line 111879 "c/sqlite3.c"
           _sqlite3VdbeJumpHere($51,$$0558); //@line 111880 "c/sqlite3.c"
           $$1579 = $$0578;$372 = $373;
          }
         } while(0);
         $357 = HEAP8[$53>>0]|0; //@line 111888 "c/sqlite3.c"
         $358 = ($357<<24>>24)==(0); //@line 111888 "c/sqlite3.c"
         if ($358) {
          $359 = ((($0)) + 124|0); //@line 111888 "c/sqlite3.c"
          $360 = HEAP32[$359>>2]|0; //@line 111888 "c/sqlite3.c"
          $361 = ($360|0)==(0|0); //@line 111888 "c/sqlite3.c"
          if ($361) {
           _sqlite3AutoincrementEnd($0); //@line 111889 "c/sqlite3.c"
          }
         }
         $362 = ((($10)) + 28|0); //@line 111897 "c/sqlite3.c"
         $363 = HEAP32[$362>>2]|0; //@line 111897 "c/sqlite3.c"
         $364 = $363 & 128; //@line 111897 "c/sqlite3.c"
         $365 = ($364|0)==(0); //@line 111897 "c/sqlite3.c"
         if ($365) {
          $$1 = $$0;$$1572 = $$0571;$371 = $372;
         } else {
          $366 = HEAP8[$53>>0]|0; //@line 111897 "c/sqlite3.c"
          $367 = ($366<<24>>24)==(0); //@line 111897 "c/sqlite3.c"
          if ($367) {
           $368 = ((($0)) + 124|0); //@line 111897 "c/sqlite3.c"
           $369 = HEAP32[$368>>2]|0; //@line 111897 "c/sqlite3.c"
           $370 = ($369|0)==(0|0); //@line 111897 "c/sqlite3.c"
           if ($370) {
            (_sqlite3VdbeAddOp2($51,78,$$1579,1)|0); //@line 111898 "c/sqlite3.c"
            _sqlite3VdbeSetNumCols($51,1); //@line 111899 "c/sqlite3.c"
            _sqlite3VdbeSetColName($51,0,0,27297,0); //@line 111900 "c/sqlite3.c"
            $$1 = $$0;$$1572 = $$0571;$371 = $372;
           } else {
            $$1 = $$0;$$1572 = $$0571;$371 = $372;
           }
          } else {
           $$1 = $$0;$$1572 = $$0571;$371 = $372;
          }
         }
        }
       } else {
        $$1 = $$0;$$1572 = $$0571;$371 = 0;
       }
      } else {
       $$1 = $$0;$$1572 = $$0571;$371 = 0;
      }
     } else {
      $$1 = $$0;$$1572 = $$0571;$371 = 0;
     }
    }
   } else {
    $$1 = $2;$$1572 = 0;$371 = 0;
   }
  } else {
   $$1 = $2;$$1572 = 0;$371 = 0;
  }
 } while(0);
 _sqlite3SrcListDelete($10,$1); //@line 111904 "c/sqlite3.c"
 _sqlite3ExprListDelete($10,$$1572); //@line 111905 "c/sqlite3.c"
 _sqlite3SelectDelete($10,$$1); //@line 111906 "c/sqlite3.c"
 _sqlite3IdListDelete($10,$3); //@line 111907 "c/sqlite3.c"
 _sqlite3DbFree($10,$371); //@line 111908 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 111909 "c/sqlite3.c"
}
function _sqlite3IdListAppend($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$013 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ($1|0)==(0|0); //@line 105220 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3DbMallocZero($0,8,0)|0); //@line 105221 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 105222 "c/sqlite3.c"
  if ($6) {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 105237 "c/sqlite3.c"
  } else {
   $$013 = $5;
  }
 } else {
  $$013 = $1;
 }
 $7 = HEAP32[$$013>>2]|0; //@line 105226 "c/sqlite3.c"
 $8 = ((($$013)) + 4|0); //@line 105228 "c/sqlite3.c"
 $9 = (_sqlite3ArrayAllocate($0,$7,8,$8,$3)|0); //@line 105224 "c/sqlite3.c"
 HEAP32[$$013>>2] = $9; //@line 105224 "c/sqlite3.c"
 $10 = HEAP32[$3>>2]|0; //@line 105231 "c/sqlite3.c"
 $11 = ($10|0)<(0); //@line 105231 "c/sqlite3.c"
 if ($11) {
  _sqlite3IdListDelete($0,$$013); //@line 105232 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 105237 "c/sqlite3.c"
 } else {
  $12 = (_sqlite3NameFromToken($0,$2)|0); //@line 105235 "c/sqlite3.c"
  $13 = HEAP32[$$013>>2]|0; //@line 105235 "c/sqlite3.c"
  $14 = (($13) + ($10<<3)|0); //@line 105235 "c/sqlite3.c"
  HEAP32[$14>>2] = $12; //@line 105235 "c/sqlite3.c"
  $$0 = $$013;
  STACKTOP = sp;return ($$0|0); //@line 105237 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprAssignVarNumber($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$3 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $8 = 0, $9 = 0, $or$cond = 0, $sext$mask = 0, $vararg_buffer = 0, $vararg_buffer1 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer1 = sp + 16|0;
 $vararg_buffer = sp + 8|0;
 $3 = sp;
 $4 = HEAP32[$0>>2]|0; //@line 93664 "c/sqlite3.c"
 $5 = ($1|0)==(0|0); //@line 93668 "c/sqlite3.c"
 if ($5) {
  STACKTOP = sp;return; //@line 93726 "c/sqlite3.c"
 }
 $6 = ((($1)) + 8|0); //@line 93670 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 93670 "c/sqlite3.c"
 $8 = ((($7)) + 1|0); //@line 93674 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 93674 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 93674 "c/sqlite3.c"
 L4: do {
  if ($10) {
   $11 = ((($0)) + 396|0); //@line 93677 "c/sqlite3.c"
   $12 = HEAP16[$11>>1]|0; //@line 93677 "c/sqlite3.c"
   $13 = (($12) + 1)<<16>>16; //@line 93677 "c/sqlite3.c"
   HEAP16[$11>>1] = $13; //@line 93677 "c/sqlite3.c"
   $$3 = $13;
  } else {
   $14 = HEAP8[$7>>0]|0; //@line 93680 "c/sqlite3.c"
   $15 = ($14<<24>>24)==(63); //@line 93680 "c/sqlite3.c"
   do {
    if ($15) {
     $16 = ($2|0)==(2); //@line 93685 "c/sqlite3.c"
     if ($16) {
      $17 = $9 << 24 >> 24; //@line 93686 "c/sqlite3.c"
      $18 = (($17) + -48)|0; //@line 93686 "c/sqlite3.c"
      $19 = ($18|0)<(0); //@line 93686 "c/sqlite3.c"
      $20 = $19 << 31 >> 31; //@line 93686 "c/sqlite3.c"
      $21 = $3; //@line 93686 "c/sqlite3.c"
      $22 = $21; //@line 93686 "c/sqlite3.c"
      HEAP32[$22>>2] = $18; //@line 93686 "c/sqlite3.c"
      $23 = (($21) + 4)|0; //@line 93686 "c/sqlite3.c"
      $24 = $23; //@line 93686 "c/sqlite3.c"
      HEAP32[$24>>2] = $20; //@line 93686 "c/sqlite3.c"
      $$0 = 0;
     } else {
      $25 = (($2) + -1)|0; //@line 93689 "c/sqlite3.c"
      $26 = (_sqlite3Atoi64($8,$3,$25,1)|0); //@line 93689 "c/sqlite3.c"
      $27 = ($26|0)!=(0); //@line 93689 "c/sqlite3.c"
      $$0 = $27;
     }
     $28 = $3; //@line 93695 "c/sqlite3.c"
     $29 = $28; //@line 93695 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 93695 "c/sqlite3.c"
     $31 = (($28) + 4)|0; //@line 93695 "c/sqlite3.c"
     $32 = $31; //@line 93695 "c/sqlite3.c"
     $33 = HEAP32[$32>>2]|0; //@line 93695 "c/sqlite3.c"
     $34 = ($33|0)<(0); //@line 93695 "c/sqlite3.c"
     $35 = ($30>>>0)<(1); //@line 93695 "c/sqlite3.c"
     $36 = ($33|0)==(0); //@line 93695 "c/sqlite3.c"
     $37 = $36 & $35; //@line 93695 "c/sqlite3.c"
     $38 = $34 | $37; //@line 93695 "c/sqlite3.c"
     $or$cond = $$0 | $38; //@line 93695 "c/sqlite3.c"
     if (!($or$cond)) {
      $39 = ((($4)) + 136|0); //@line 93695 "c/sqlite3.c"
      $40 = HEAP32[$39>>2]|0; //@line 93695 "c/sqlite3.c"
      $41 = ($40|0)<(0); //@line 93695 "c/sqlite3.c"
      $42 = $41 << 31 >> 31; //@line 93695 "c/sqlite3.c"
      $43 = ($33|0)>($42|0); //@line 93695 "c/sqlite3.c"
      $44 = ($30>>>0)>($40>>>0); //@line 93695 "c/sqlite3.c"
      $45 = ($33|0)==($42|0); //@line 93695 "c/sqlite3.c"
      $46 = $45 & $44; //@line 93695 "c/sqlite3.c"
      $47 = $43 | $46; //@line 93695 "c/sqlite3.c"
      if (!($47)) {
       $48 = $30&65535; //@line 93700 "c/sqlite3.c"
       $49 = ((($0)) + 396|0); //@line 93701 "c/sqlite3.c"
       $50 = HEAP16[$49>>1]|0; //@line 93701 "c/sqlite3.c"
       $51 = ($50<<16>>16)<($48<<16>>16); //@line 93701 "c/sqlite3.c"
       if ($51) {
        HEAP16[$49>>1] = $48; //@line 93702 "c/sqlite3.c"
       } else {
        $52 = $48 << 16 >> 16; //@line 93701 "c/sqlite3.c"
        $53 = ((($0)) + 420|0); //@line 93704 "c/sqlite3.c"
        $54 = HEAP32[$53>>2]|0; //@line 93704 "c/sqlite3.c"
        $55 = (_sqlite3VListNumToName($54,$52)|0); //@line 93704 "c/sqlite3.c"
        $56 = ($55|0)==(0|0); //@line 93704 "c/sqlite3.c"
        if (!($56)) {
         $$3 = $48;
         break L4;
        }
       }
       $$sink = $48;
       break;
      }
     }
     $69 = ((($4)) + 136|0); //@line 93697 "c/sqlite3.c"
     $70 = HEAP32[$69>>2]|0; //@line 93697 "c/sqlite3.c"
     HEAP32[$vararg_buffer>>2] = $70; //@line 93696 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,27122,$vararg_buffer); //@line 93696 "c/sqlite3.c"
     STACKTOP = sp;return; //@line 93726 "c/sqlite3.c"
    } else {
     $57 = ((($0)) + 420|0); //@line 93712 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 93712 "c/sqlite3.c"
     $59 = (_sqlite3VListNameToNum($58,$7,$2)|0); //@line 93712 "c/sqlite3.c"
     $60 = $59&65535; //@line 93712 "c/sqlite3.c"
     $sext$mask = $59 & 65535; //@line 93713 "c/sqlite3.c"
     $61 = ($sext$mask|0)==(0); //@line 93713 "c/sqlite3.c"
     if (!($61)) {
      $$3 = $60;
      break L4;
     }
     $62 = ((($0)) + 396|0); //@line 93714 "c/sqlite3.c"
     $63 = HEAP16[$62>>1]|0; //@line 93714 "c/sqlite3.c"
     $64 = (($63) + 1)<<16>>16; //@line 93714 "c/sqlite3.c"
     HEAP16[$62>>1] = $64; //@line 93714 "c/sqlite3.c"
     $$sink = $64;
    }
   } while(0);
   $65 = $$sink << 16 >> 16; //@line 93719 "c/sqlite3.c"
   $66 = ((($0)) + 420|0); //@line 93719 "c/sqlite3.c"
   $67 = HEAP32[$66>>2]|0; //@line 93719 "c/sqlite3.c"
   $68 = (_sqlite3VListAdd($4,$67,$7,$2,$65)|0); //@line 93719 "c/sqlite3.c"
   HEAP32[$66>>2] = $68; //@line 93719 "c/sqlite3.c"
   $$3 = $$sink;
  }
 } while(0);
 $71 = ((($1)) + 32|0); //@line 93722 "c/sqlite3.c"
 HEAP16[$71>>1] = $$3; //@line 93722 "c/sqlite3.c"
 $72 = $$3 << 16 >> 16; //@line 93723 "c/sqlite3.c"
 $73 = ((($4)) + 136|0); //@line 93723 "c/sqlite3.c"
 $74 = HEAP32[$73>>2]|0; //@line 93723 "c/sqlite3.c"
 $75 = ($74|0)<($72|0); //@line 93723 "c/sqlite3.c"
 if (!($75)) {
  STACKTOP = sp;return; //@line 93726 "c/sqlite3.c"
 }
 _sqlite3ErrorMsg($0,27165,$vararg_buffer1); //@line 93724 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 93726 "c/sqlite3.c"
}
function _sqlite3ExprAddCollateToken($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($2)) + 4|0); //@line 92774 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 92774 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 92774 "c/sqlite3.c"
 if ($6) {
  $$1 = $1;
  return ($$1|0); //@line 92782 "c/sqlite3.c"
 }
 $7 = HEAP32[$0>>2]|0; //@line 92775 "c/sqlite3.c"
 $8 = (_sqlite3ExprAlloc($7,94,$2,$3)|0); //@line 92775 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 92776 "c/sqlite3.c"
 if ($9) {
  $$1 = $1;
  return ($$1|0); //@line 92782 "c/sqlite3.c"
 }
 $10 = ((($8)) + 12|0); //@line 92777 "c/sqlite3.c"
 HEAP32[$10>>2] = $1; //@line 92777 "c/sqlite3.c"
 $11 = ((($8)) + 4|0); //@line 92778 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 92778 "c/sqlite3.c"
 $13 = $12 | 4352; //@line 92778 "c/sqlite3.c"
 HEAP32[$11>>2] = $13; //@line 92778 "c/sqlite3.c"
 $$1 = $8;
 return ($$1|0); //@line 92782 "c/sqlite3.c"
}
function _sqlite3ExprAttachSubtrees($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 93511 "c/sqlite3.c"
 if ($4) {
  _sqlite3ExprDelete($0,$2); //@line 93513 "c/sqlite3.c"
  _sqlite3ExprDelete($0,$3); //@line 93514 "c/sqlite3.c"
  return; //@line 93526 "c/sqlite3.c"
 }
 $5 = ($3|0)==(0|0); //@line 93516 "c/sqlite3.c"
 if (!($5)) {
  $6 = ((($1)) + 16|0); //@line 93517 "c/sqlite3.c"
  HEAP32[$6>>2] = $3; //@line 93517 "c/sqlite3.c"
  $7 = ((($3)) + 4|0); //@line 93518 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 93518 "c/sqlite3.c"
  $9 = $8 & 2097412; //@line 93518 "c/sqlite3.c"
  $10 = ((($1)) + 4|0); //@line 93518 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 93518 "c/sqlite3.c"
  $12 = $11 | $9; //@line 93518 "c/sqlite3.c"
  HEAP32[$10>>2] = $12; //@line 93518 "c/sqlite3.c"
 }
 $13 = ($2|0)==(0|0); //@line 93520 "c/sqlite3.c"
 if (!($13)) {
  $14 = ((($1)) + 12|0); //@line 93521 "c/sqlite3.c"
  HEAP32[$14>>2] = $2; //@line 93521 "c/sqlite3.c"
  $15 = ((($2)) + 4|0); //@line 93522 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 93522 "c/sqlite3.c"
  $17 = $16 & 2097412; //@line 93522 "c/sqlite3.c"
  $18 = ((($1)) + 4|0); //@line 93522 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 93522 "c/sqlite3.c"
  $20 = $19 | $17; //@line 93522 "c/sqlite3.c"
  HEAP32[$18>>2] = $20; //@line 93522 "c/sqlite3.c"
 }
 _exprSetHeight($1); //@line 93524 "c/sqlite3.c"
 return; //@line 93526 "c/sqlite3.c"
}
function _sqlite3ExprFunction($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 93633 "c/sqlite3.c"
 $4 = (_sqlite3ExprAlloc($3,144,$2,1)|0); //@line 93635 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 93636 "c/sqlite3.c"
 if ($5) {
  _sqlite3ExprListDelete($3,$1); //@line 93637 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 93645 "c/sqlite3.c"
 } else {
  $6 = ((($4)) + 20|0); //@line 93640 "c/sqlite3.c"
  HEAP32[$6>>2] = $1; //@line 93640 "c/sqlite3.c"
  $7 = ((($4)) + 4|0); //@line 93641 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 93641 "c/sqlite3.c"
  $9 = $8 | 4; //@line 93641 "c/sqlite3.c"
  HEAP32[$7>>2] = $9; //@line 93641 "c/sqlite3.c"
  _sqlite3ExprSetHeightAndFlags($0,$4); //@line 93643 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 93645 "c/sqlite3.c"
 }
 return (0)|0;
}
function _binaryToUnaryIfNull($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 138249 "c/sqlite3.c"
 $5 = ($2|0)!=(0|0); //@line 138250 "c/sqlite3.c"
 $6 = ($1|0)!=(0|0); //@line 138250 "c/sqlite3.c"
 $or$cond = $6 & $5; //@line 138250 "c/sqlite3.c"
 if (!($or$cond)) {
  return; //@line 138255 "c/sqlite3.c"
 }
 $7 = HEAP8[$1>>0]|0; //@line 138250 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(101); //@line 138250 "c/sqlite3.c"
 if (!($8)) {
  return; //@line 138255 "c/sqlite3.c"
 }
 $9 = $3&255; //@line 138251 "c/sqlite3.c"
 HEAP8[$2>>0] = $9; //@line 138251 "c/sqlite3.c"
 $10 = ((($2)) + 16|0); //@line 138252 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 138252 "c/sqlite3.c"
 _sqlite3ExprDelete($4,$11); //@line 138252 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 138253 "c/sqlite3.c"
 return; //@line 138255 "c/sqlite3.c"
}
function _sqlite3ExprSetHeightAndFlags($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 36|0); //@line 93392 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 93392 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 93392 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 93395 "c/sqlite3.c"
 }
 _exprSetHeight($1); //@line 93393 "c/sqlite3.c"
 $5 = ((($1)) + 24|0); //@line 93394 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 93394 "c/sqlite3.c"
 (_sqlite3ExprCheckHeight($0,$6)|0); //@line 93394 "c/sqlite3.c"
 return; //@line 93395 "c/sqlite3.c"
}
function _sqlite3PExprAddSelect($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 93565 "c/sqlite3.c"
 if ($3) {
  $8 = HEAP32[$0>>2]|0; //@line 93571 "c/sqlite3.c"
  _sqlite3SelectDelete($8,$2); //@line 93571 "c/sqlite3.c"
  return; //@line 93573 "c/sqlite3.c"
 } else {
  $4 = ((($1)) + 20|0); //@line 93566 "c/sqlite3.c"
  HEAP32[$4>>2] = $2; //@line 93566 "c/sqlite3.c"
  $5 = ((($1)) + 4|0); //@line 93567 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 93567 "c/sqlite3.c"
  $7 = $6 | 2099200; //@line 93567 "c/sqlite3.c"
  HEAP32[$5>>2] = $7; //@line 93567 "c/sqlite3.c"
  _sqlite3ExprSetHeightAndFlags($0,$1); //@line 93568 "c/sqlite3.c"
  return; //@line 93573 "c/sqlite3.c"
 }
}
function _parserAddExprIdListTerm($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 138263 "c/sqlite3.c"
 $5 = (_sqlite3ExprListAppend($0,$1,0)|0); //@line 138269 "c/sqlite3.c"
 $6 = ($3|0)!=(0); //@line 138270 "c/sqlite3.c"
 $7 = ($4|0)!=(-1); //@line 138270 "c/sqlite3.c"
 $or$cond = $6 | $7; //@line 138270 "c/sqlite3.c"
 if ($or$cond) {
  $8 = HEAP32[$0>>2]|0; //@line 138271 "c/sqlite3.c"
  $9 = ((($8)) + 157|0); //@line 138271 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 138271 "c/sqlite3.c"
  $11 = ($10<<24>>24)==(0); //@line 138271 "c/sqlite3.c"
  if ($11) {
   $12 = ((($2)) + 4|0); //@line 138274 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 138274 "c/sqlite3.c"
   $14 = HEAP32[$2>>2]|0; //@line 138274 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $13; //@line 138273 "c/sqlite3.c"
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 138273 "c/sqlite3.c"
   HEAP32[$vararg_ptr1>>2] = $14; //@line 138273 "c/sqlite3.c"
   _sqlite3ErrorMsg($0,27082,$vararg_buffer); //@line 138273 "c/sqlite3.c"
  }
 }
 _sqlite3ExprListSetName($0,$5,$2,1); //@line 138276 "c/sqlite3.c"
 STACKTOP = sp;return ($5|0); //@line 138277 "c/sqlite3.c"
}
function _sqlite3DropIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer5 = 0, $vararg_ptr1 = 0, $vararg_ptr8 = 0, $vararg_ptr9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer5 = sp + 16|0; //@line 105106 "c/sqlite3.c"
 $vararg_buffer2 = sp + 8|0; //@line 105106 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 105106 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 105109 "c/sqlite3.c"
 $4 = ((($3)) + 73|0); //@line 105113 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 105113 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 105113 "c/sqlite3.c"
 if (!($6)) {
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 $7 = (_sqlite3ReadSchema($0)|0); //@line 105117 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 105117 "c/sqlite3.c"
 if (!($8)) {
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 $9 = ((($1)) + 16|0); //@line 105120 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 105120 "c/sqlite3.c"
 $11 = ((($1)) + 12|0); //@line 105120 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 105120 "c/sqlite3.c"
 $13 = (_sqlite3FindIndex($3,$10,$12)|0); //@line 105120 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 105121 "c/sqlite3.c"
 if ($14) {
  $15 = ($2|0)==(0); //@line 105122 "c/sqlite3.c"
  if ($15) {
   HEAP32[$vararg_buffer>>2] = $1; //@line 105123 "c/sqlite3.c"
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 105123 "c/sqlite3.c"
   HEAP32[$vararg_ptr1>>2] = 0; //@line 105123 "c/sqlite3.c"
   _sqlite3ErrorMsg($0,26872,$vararg_buffer); //@line 105123 "c/sqlite3.c"
  } else {
   $16 = HEAP32[$11>>2]|0; //@line 105125 "c/sqlite3.c"
   _sqlite3CodeVerifyNamedSchema($0,$16); //@line 105125 "c/sqlite3.c"
  }
  $17 = ((($0)) + 17|0); //@line 105127 "c/sqlite3.c"
  HEAP8[$17>>0] = 1; //@line 105127 "c/sqlite3.c"
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 $18 = ((($13)) + 55|0); //@line 105130 "c/sqlite3.c"
 $19 = HEAPU8[$18>>0]|(HEAPU8[$18+1>>0]<<8); //@line 105130 "c/sqlite3.c"
 $20 = $19 & 3; //@line 105130 "c/sqlite3.c"
 $21 = ($20<<16>>16)==(0); //@line 105130 "c/sqlite3.c"
 if (!($21)) {
  HEAP32[$vararg_buffer2>>2] = 0; //@line 105131 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,26890,$vararg_buffer2); //@line 105131 "c/sqlite3.c"
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 $22 = ((($13)) + 24|0); //@line 105135 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 105135 "c/sqlite3.c"
 $24 = (_sqlite3SchemaToIndex($3,$23)|0); //@line 105135 "c/sqlite3.c"
 $25 = ((($13)) + 12|0); //@line 105139 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 105139 "c/sqlite3.c"
 $27 = ((($3)) + 16|0); //@line 105140 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 105140 "c/sqlite3.c"
 $29 = (($28) + ($24<<4)|0); //@line 105140 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 105140 "c/sqlite3.c"
 $31 = ($24|0)==(1); //@line 105141 "c/sqlite3.c"
 $32 = $31 ? 21366 : 19754; //@line 105141 "c/sqlite3.c"
 $33 = (_sqlite3AuthCheck($0,9,$32,0,$30)|0); //@line 105142 "c/sqlite3.c"
 $34 = ($33|0)==(0); //@line 105142 "c/sqlite3.c"
 if (!($34)) {
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 $35 = ($24|0)==(0); //@line 105145 "c/sqlite3.c"
 $spec$select = $35 ? 10 : 12; //@line 105145 "c/sqlite3.c"
 $36 = HEAP32[$13>>2]|0; //@line 105146 "c/sqlite3.c"
 $37 = HEAP32[$26>>2]|0; //@line 105146 "c/sqlite3.c"
 $38 = (_sqlite3AuthCheck($0,$spec$select,$36,$37,$30)|0); //@line 105146 "c/sqlite3.c"
 $39 = ($38|0)==(0); //@line 105146 "c/sqlite3.c"
 if (!($39)) {
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 $40 = (_sqlite3GetVdbe($0)|0); //@line 105153 "c/sqlite3.c"
 $41 = ($40|0)==(0|0); //@line 105154 "c/sqlite3.c"
 if ($41) {
  _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
 }
 _sqlite3BeginWriteOperation($0,1,$24); //@line 105155 "c/sqlite3.c"
 $42 = HEAP32[$27>>2]|0; //@line 105158 "c/sqlite3.c"
 $43 = (($42) + ($24<<4)|0); //@line 105158 "c/sqlite3.c"
 $44 = HEAP32[$43>>2]|0; //@line 105158 "c/sqlite3.c"
 $45 = HEAP32[$13>>2]|0; //@line 105158 "c/sqlite3.c"
 HEAP32[$vararg_buffer5>>2] = $44; //@line 105156 "c/sqlite3.c"
 $vararg_ptr8 = ((($vararg_buffer5)) + 4|0); //@line 105156 "c/sqlite3.c"
 HEAP32[$vararg_ptr8>>2] = 19754; //@line 105156 "c/sqlite3.c"
 $vararg_ptr9 = ((($vararg_buffer5)) + 8|0); //@line 105156 "c/sqlite3.c"
 HEAP32[$vararg_ptr9>>2] = $45; //@line 105156 "c/sqlite3.c"
 _sqlite3NestedParse($0,26963,$vararg_buffer5); //@line 105156 "c/sqlite3.c"
 $46 = HEAP32[$13>>2]|0; //@line 105160 "c/sqlite3.c"
 _sqlite3ClearStatTables($0,$24,20327,$46); //@line 105160 "c/sqlite3.c"
 _sqlite3ChangeCookie($0,$24); //@line 105161 "c/sqlite3.c"
 $47 = ((($13)) + 44|0); //@line 105162 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 105162 "c/sqlite3.c"
 _destroyRootPage($0,$48,$24); //@line 105162 "c/sqlite3.c"
 $49 = HEAP32[$13>>2]|0; //@line 105163 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($40,141,$24,0,0,$49,0)|0); //@line 105163 "c/sqlite3.c"
 _sqlite3SrcListDelete($3,$1); //@line 105167 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 105168 "c/sqlite3.c"
}
function _sqlite3Vacuum($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$011 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$2>>2] = $1;
 $3 = (_sqlite3GetVdbe($0)|0); //@line 127085 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 127087 "c/sqlite3.c"
 if ($4) {
  STACKTOP = sp;return; //@line 127109 "c/sqlite3.c"
 }
 $5 = ($1|0)==(0|0); //@line 127088 "c/sqlite3.c"
 if ($5) {
  $$011 = 0;
 } else {
  $6 = (_sqlite3TwoPartName($0,$1,$1,$2)|0); //@line 127092 "c/sqlite3.c"
  $7 = ($6|0)<(0); //@line 127093 "c/sqlite3.c"
  $8 = ($6|0)==(1); //@line 127104 "c/sqlite3.c"
  $or$cond = $7 | $8; //@line 127093 "c/sqlite3.c"
  if ($or$cond) {
   STACKTOP = sp;return; //@line 127109 "c/sqlite3.c"
  } else {
   $$011 = $6;
  }
 }
 (_sqlite3VdbeAddOp1($3,10,$$011)|0); //@line 127105 "c/sqlite3.c"
 _sqlite3VdbeUsesBtree($3,$$011); //@line 127106 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 127109 "c/sqlite3.c"
}
function _sqlite3Pragma($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$ = 0, $$0 = 0, $$01162 = 0, $$01164 = 0, $$011641440 = 0, $$011641441 = 0, $$01165 = 0, $$01166 = 0, $$011661445 = 0, $$011661446 = 0, $$01170 = 0, $$01171 = 0, $$011711258 = 0, $$011721283 = 0, $$011731436 = 0, $$01175 = 0, $$011761435$lcssa = 0, $$011771284 = 0, $$011781291 = 0, $$011811404 = 0;
 var $$011821287 = 0, $$011821287$in = 0, $$011841302 = 0, $$011851294 = 0, $$011871301 = 0, $$011891299 = 0, $$011901400 = 0, $$011901400$in = 0, $$011911308 = 0, $$01193 = 0, $$011931311 = 0, $$011931313 = 0, $$011941312 = 0, $$011951316 = 0, $$011961320 = 0, $$011971415 = 0, $$01199 = 0, $$011991319 = 0, $$011991321 = 0, $$012001414 = 0;
 var $$012021329 = 0, $$01203 = 0, $$012031388 = 0, $$012031390 = 0, $$012061328 = 0, $$01207 = 0, $$012071374 = 0, $$012071376 = 0, $$012081324 = 0, $$01209$lcssa = 0, $$012091358 = 0, $$01210 = 0, $$012101356 = 0, $$012101359 = 0, $$01211 = 0, $$012111333 = 0, $$012111335 = 0, $$01213$lcssa = 0, $$012131367 = 0, $$01215$lcssa = 0;
 var $$012151366 = 0, $$01221 = 0, $$01222 = 0, $$012221365 = 0, $$012221368 = 0, $$01225$lcssa = 0, $$012251334 = 0, $$012271389 = 0, $$012311430 = 0, $$012321340 = 0, $$012331353 = 0, $$11186 = 0, $$11188 = 0, $$11198 = 0, $$11201 = 0, $$11204 = 0, $$112041410 = 0, $$112041416 = 0, $$11212 = 0, $$112121346 = 0;
 var $$112121348 = 0, $$11223 = 0, $$112231381 = 0, $$112231383 = 0, $$112261347 = 0, $$112281394 = 0, $$11234 = 0, $$1253 = 0, $$211801260 = 0, $$21205 = 0, $$212051421 = 0, $$212051423 = 0, $$21217$lcssa = 0, $$212171357 = 0, $$21224 = 0, $$212241426 = 0, $$212241427 = 0, $$212291411 = 0, $$21449 = 0, $$31218$lcssa = 0;
 var $$312181382 = 0, $$312301422 = 0, $$41219 = 0, $$51220$lcssa = 0, $$512201375 = 0, $$in = 0, $$lcssa = 0, $$lobit = 0, $$mux = 0, $$sink = 0, $$sink$in = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0;
 var $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0;
 var $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0;
 var $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0;
 var $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0;
 var $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0;
 var $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0;
 var $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0;
 var $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0;
 var $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0;
 var $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0;
 var $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0;
 var $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0;
 var $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0;
 var $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0;
 var $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0;
 var $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0;
 var $399 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0;
 var $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0;
 var $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0;
 var $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0;
 var $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0;
 var $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0;
 var $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0;
 var $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0;
 var $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0;
 var $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0;
 var $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0;
 var $598 = 0, $599 = 0, $6 = 0, $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0;
 var $615 = 0, $616 = 0, $617 = 0, $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0;
 var $633 = 0, $634 = 0, $635 = 0, $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0;
 var $651 = 0, $652 = 0, $653 = 0, $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0;
 var $67 = 0, $670 = 0, $671 = 0, $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0;
 var $688 = 0, $689 = 0, $69 = 0, $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0;
 var $705 = 0, $706 = 0, $707 = 0, $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0;
 var $723 = 0, $724 = 0, $725 = 0, $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0;
 var $741 = 0, $742 = 0, $743 = 0, $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0;
 var $76 = 0, $760 = 0, $761 = 0, $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0;
 var $778 = 0, $779 = 0, $78 = 0, $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0, $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0, $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0;
 var $796 = 0, $797 = 0, $798 = 0, $799 = 0, $8 = 0, $80 = 0, $800 = 0, $801 = 0, $802 = 0, $803 = 0, $804 = 0, $805 = 0, $806 = 0, $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0;
 var $813 = 0, $814 = 0, $815 = 0, $816 = 0, $817 = 0, $818 = 0, $819 = 0, $82 = 0, $820 = 0, $821 = 0, $822 = 0, $823 = 0, $824 = 0, $825 = 0, $826 = 0, $827 = 0, $828 = 0, $829 = 0, $83 = 0, $830 = 0;
 var $831 = 0, $832 = 0, $833 = 0, $834 = 0, $835 = 0, $836 = 0, $837 = 0, $838 = 0, $839 = 0, $84 = 0, $840 = 0, $841 = 0, $842 = 0, $843 = 0, $844 = 0, $845 = 0, $846 = 0, $847 = 0, $848 = 0, $849 = 0;
 var $85 = 0, $850 = 0, $851 = 0, $852 = 0, $853 = 0, $854 = 0, $855 = 0, $856 = 0, $857 = 0, $858 = 0, $859 = 0, $86 = 0, $860 = 0, $861 = 0, $862 = 0, $863 = 0, $864 = 0, $865 = 0, $866 = 0, $867 = 0;
 var $868 = 0, $869 = 0, $87 = 0, $870 = 0, $871 = 0, $872 = 0, $873 = 0, $874 = 0, $875 = 0, $876 = 0, $877 = 0, $878 = 0, $879 = 0, $88 = 0, $880 = 0, $881 = 0, $882 = 0, $883 = 0, $884 = 0, $885 = 0;
 var $886 = 0, $887 = 0, $888 = 0, $889 = 0, $89 = 0, $890 = 0, $891 = 0, $892 = 0, $893 = 0, $894 = 0, $895 = 0, $896 = 0, $897 = 0, $898 = 0, $899 = 0, $9 = 0, $90 = 0, $900 = 0, $901 = 0, $902 = 0;
 var $903 = 0, $904 = 0, $905 = 0, $906 = 0, $907 = 0, $908 = 0, $909 = 0, $91 = 0, $910 = 0, $911 = 0, $912 = 0, $913 = 0, $914 = 0, $915 = 0, $916 = 0, $917 = 0, $918 = 0, $919 = 0, $92 = 0, $920 = 0;
 var $921 = 0, $922 = 0, $923 = 0, $924 = 0, $925 = 0, $926 = 0, $927 = 0, $928 = 0, $929 = 0, $93 = 0, $930 = 0, $931 = 0, $932 = 0, $933 = 0, $934 = 0, $935 = 0, $936 = 0, $937 = 0, $938 = 0, $939 = 0;
 var $94 = 0, $940 = 0, $941 = 0, $942 = 0, $943 = 0, $944 = 0, $945 = 0, $946 = 0, $947 = 0, $948 = 0, $949 = 0, $95 = 0, $950 = 0, $951 = 0, $952 = 0, $953 = 0, $954 = 0, $955 = 0, $956 = 0, $957 = 0;
 var $958 = 0, $959 = 0, $96 = 0, $960 = 0, $961 = 0, $962 = 0, $963 = 0, $964 = 0, $965 = 0, $966 = 0, $967 = 0, $968 = 0, $969 = 0, $97 = 0, $970 = 0, $971 = 0, $972 = 0, $973 = 0, $974 = 0, $975 = 0;
 var $976 = 0, $98 = 0, $99 = 0, $brmerge = 0, $exitcond = 0, $not$ = 0, $or$cond = 0, $or$cond11 = 0, $or$cond1242 = 0, $or$cond1245 = 0, $or$cond16 = 0, $or$cond5 = 0, $or$cond9 = 0, $sext = 0, $spec$select = 0, $spec$select1243 = 0, $spec$select1244 = 0, $spec$select1246 = 0, $spec$select1247 = 0, $spec$select1256 = 0;
 var $storemerge = 0, $storemerge1238 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer19 = 0, $vararg_buffer24 = 0, $vararg_buffer29 = 0, $vararg_buffer36 = 0, $vararg_buffer4 = 0, $vararg_buffer41 = 0, $vararg_buffer45 = 0, $vararg_buffer55 = 0, $vararg_buffer59 = 0, $vararg_buffer6 = 0, $vararg_buffer62 = 0, $vararg_buffer66 = 0, $vararg_buffer69 = 0, $vararg_buffer73 = 0, $vararg_buffer9 = 0;
 var $vararg_ptr14 = 0, $vararg_ptr15 = 0, $vararg_ptr16 = 0, $vararg_ptr17 = 0, $vararg_ptr18 = 0, $vararg_ptr22 = 0, $vararg_ptr23 = 0, $vararg_ptr27 = 0, $vararg_ptr28 = 0, $vararg_ptr32 = 0, $vararg_ptr33 = 0, $vararg_ptr34 = 0, $vararg_ptr35 = 0, $vararg_ptr39 = 0, $vararg_ptr40 = 0, $vararg_ptr44 = 0, $vararg_ptr48 = 0, $vararg_ptr49 = 0, $vararg_ptr50 = 0, $vararg_ptr51 = 0;
 var $vararg_ptr52 = 0, $vararg_ptr53 = 0, $vararg_ptr54 = 0, $vararg_ptr58 = 0, $vararg_ptr65 = 0, $vararg_ptr72 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 272|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(272|0);
 $vararg_buffer73 = sp + 224|0;
 $vararg_buffer69 = sp + 216|0;
 $vararg_buffer66 = sp + 208|0;
 $vararg_buffer62 = sp + 200|0;
 $vararg_buffer59 = sp + 192|0;
 $vararg_buffer55 = sp + 184|0;
 $vararg_buffer45 = sp + 152|0;
 $vararg_buffer41 = sp + 144|0;
 $vararg_buffer36 = sp + 128|0;
 $vararg_buffer29 = sp + 104|0;
 $vararg_buffer24 = sp + 88|0;
 $vararg_buffer19 = sp + 72|0;
 $vararg_buffer11 = sp + 48|0;
 $vararg_buffer9 = sp + 40|0;
 $vararg_buffer6 = sp + 32|0;
 $vararg_buffer4 = sp + 24|0;
 $vararg_buffer1 = sp + 16|0;
 $vararg_buffer = sp + 8|0;
 $5 = sp + 256|0;
 $6 = sp + 240|0;
 $7 = sp;
 $8 = sp + 236|0;
 $9 = sp + 232|0;
 $10 = sp + 228|0;
 $11 = HEAP32[$0>>2]|0; //@line 115636 "c/sqlite3.c"
 $12 = (_sqlite3GetVdbe($0)|0); //@line 115638 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 115641 "c/sqlite3.c"
 if ($13) {
  STACKTOP = sp;return; //@line 117469 "c/sqlite3.c"
 }
 _sqlite3VdbeRunOnlyOnce($12); //@line 115642 "c/sqlite3.c"
 $14 = ((($0)) + 44|0); //@line 115643 "c/sqlite3.c"
 HEAP32[$14>>2] = 2; //@line 115643 "c/sqlite3.c"
 $15 = (_sqlite3TwoPartName($0,$1,$2,$5)|0); //@line 115647 "c/sqlite3.c"
 $16 = ($15|0)<(0); //@line 115648 "c/sqlite3.c"
 if ($16) {
  STACKTOP = sp;return; //@line 117469 "c/sqlite3.c"
 }
 $17 = ((($11)) + 16|0); //@line 115649 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 115649 "c/sqlite3.c"
 $19 = ($15|0)==(1); //@line 115654 "c/sqlite3.c"
 if ($19) {
  $20 = (_sqlite3OpenTempDatabase($0)|0); //@line 115654 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 115654 "c/sqlite3.c"
  if (!($21)) {
   STACKTOP = sp;return; //@line 117469 "c/sqlite3.c"
  }
 }
 $22 = HEAP32[$5>>2]|0; //@line 115658 "c/sqlite3.c"
 $23 = (_sqlite3NameFromToken($11,$22)|0); //@line 115658 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 115659 "c/sqlite3.c"
 if ($24) {
  STACKTOP = sp;return; //@line 117469 "c/sqlite3.c"
 }
 $25 = ($4|0)==(0); //@line 115660 "c/sqlite3.c"
 if ($25) {
  $27 = (_sqlite3NameFromToken($11,$3)|0); //@line 115663 "c/sqlite3.c"
  $$01162 = $27;
 } else {
  HEAP32[$vararg_buffer>>2] = $3; //@line 115661 "c/sqlite3.c"
  $26 = (_sqlite3MPrintf($11,25898,$vararg_buffer)|0); //@line 115661 "c/sqlite3.c"
  $$01162 = $26;
 }
 $28 = ((($2)) + 4|0); //@line 115667 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 115667 "c/sqlite3.c"
 $30 = ($29|0)==(0); //@line 115667 "c/sqlite3.c"
 if ($30) {
  $33 = 0;
 } else {
  $31 = (($18) + ($15<<4)|0); //@line 115667 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 115667 "c/sqlite3.c"
  $33 = $32;
 }
 $34 = (_sqlite3AuthCheck($0,19,$23,$$01162,$33)|0); //@line 115668 "c/sqlite3.c"
 $35 = ($34|0)==(0); //@line 115668 "c/sqlite3.c"
 L21: do {
  if ($35) {
   HEAP32[$6>>2] = 0; //@line 115687 "c/sqlite3.c"
   $36 = ((($6)) + 4|0); //@line 115688 "c/sqlite3.c"
   HEAP32[$36>>2] = $23; //@line 115688 "c/sqlite3.c"
   $37 = ((($6)) + 8|0); //@line 115689 "c/sqlite3.c"
   HEAP32[$37>>2] = $$01162; //@line 115689 "c/sqlite3.c"
   $38 = ((($6)) + 12|0); //@line 115690 "c/sqlite3.c"
   HEAP32[$38>>2] = 0; //@line 115690 "c/sqlite3.c"
   $39 = ((($11)) + 396|0); //@line 115691 "c/sqlite3.c"
   HEAP32[$39>>2] = 0; //@line 115691 "c/sqlite3.c"
   $40 = (_sqlite3_file_control($11,$33,14,$6)|0); //@line 115692 "c/sqlite3.c"
   switch ($40|0) {
   case 0:  {
    _sqlite3VdbeSetNumCols($12,1); //@line 115694 "c/sqlite3.c"
    $41 = HEAP32[$6>>2]|0; //@line 115695 "c/sqlite3.c"
    _sqlite3VdbeSetColName($12,0,0,$41,(-1)); //@line 115695 "c/sqlite3.c"
    $42 = HEAP32[$6>>2]|0; //@line 115696 "c/sqlite3.c"
    _returnSingleText($12,$42); //@line 115696 "c/sqlite3.c"
    $43 = HEAP32[$6>>2]|0; //@line 115697 "c/sqlite3.c"
    _sqlite3_free($43); //@line 115697 "c/sqlite3.c"
    break L21;
    break;
   }
   case 12:  {
    $51 = (_pragmaLocate($23)|0); //@line 115711 "c/sqlite3.c"
    $52 = ($51|0)==(0|0); //@line 115712 "c/sqlite3.c"
    if ($52) {
     break L21;
    }
    $53 = ((($51)) + 5|0); //@line 115715 "c/sqlite3.c"
    $54 = HEAP8[$53>>0]|0; //@line 115715 "c/sqlite3.c"
    $55 = $54 & 1; //@line 115715 "c/sqlite3.c"
    $56 = ($55<<24>>24)==(0); //@line 115715 "c/sqlite3.c"
    if (!($56)) {
     $57 = (_sqlite3ReadSchema($0)|0); //@line 115716 "c/sqlite3.c"
     $58 = ($57|0)==(0); //@line 115716 "c/sqlite3.c"
     if (!($58)) {
      break L21;
     }
    }
    $59 = HEAP8[$53>>0]|0; //@line 115720 "c/sqlite3.c"
    $60 = $59&255; //@line 115720 "c/sqlite3.c"
    $61 = $60 & 2; //@line 115720 "c/sqlite3.c"
    $62 = ($61|0)==(0); //@line 115720 "c/sqlite3.c"
    if ($62) {
     $63 = $60 & 4; //@line 115721 "c/sqlite3.c"
     $64 = ($63|0)==(0); //@line 115721 "c/sqlite3.c"
     $65 = ($$01162|0)==(0|0); //@line 115721 "c/sqlite3.c"
     $or$cond = $65 | $64; //@line 115721 "c/sqlite3.c"
     if ($or$cond) {
      _setPragmaResultColumnNames($12,$51); //@line 115723 "c/sqlite3.c"
     }
    }
    $66 = ((($51)) + 4|0); //@line 115727 "c/sqlite3.c"
    $67 = HEAP8[$66>>0]|0; //@line 115727 "c/sqlite3.c"
    do {
     switch ($67<<24>>24) {
     case 11:  {
      _sqlite3VdbeUsesBtree($12,$15); //@line 115760 "c/sqlite3.c"
      $68 = ($$01162|0)==(0|0); //@line 115761 "c/sqlite3.c"
      if ($68) {
       $69 = HEAP32[$14>>2]|0; //@line 115762 "c/sqlite3.c"
       $70 = (($69) + 2)|0; //@line 115762 "c/sqlite3.c"
       HEAP32[$14>>2] = $70; //@line 115762 "c/sqlite3.c"
       $71 = (_sqlite3VdbeAddOpList($12,9,25902)|0); //@line 115764 "c/sqlite3.c"
       $72 = ((($71)) + 4|0); //@line 115766 "c/sqlite3.c"
       HEAP32[$72>>2] = $15; //@line 115766 "c/sqlite3.c"
       $73 = ((($71)) + 24|0); //@line 115767 "c/sqlite3.c"
       HEAP32[$73>>2] = $15; //@line 115767 "c/sqlite3.c"
       $74 = ((($71)) + 124|0); //@line 115768 "c/sqlite3.c"
       HEAP32[$74>>2] = -2000; //@line 115768 "c/sqlite3.c"
       break L21;
      } else {
       $75 = (_sqlite3Atoi($$01162)|0); //@line 115770 "c/sqlite3.c"
       $76 = (_sqlite3AbsInt32($75)|0); //@line 115770 "c/sqlite3.c"
       _sqlite3BeginWriteOperation($0,0,$15); //@line 115771 "c/sqlite3.c"
       (_sqlite3VdbeAddOp3($12,103,$15,3,$76)|0); //@line 115772 "c/sqlite3.c"
       $77 = (((($18) + ($15<<4)|0)) + 12|0); //@line 115774 "c/sqlite3.c"
       $78 = HEAP32[$77>>2]|0; //@line 115774 "c/sqlite3.c"
       $79 = ((($78)) + 80|0); //@line 115774 "c/sqlite3.c"
       HEAP32[$79>>2] = $76; //@line 115774 "c/sqlite3.c"
       $80 = (((($18) + ($15<<4)|0)) + 4|0); //@line 115775 "c/sqlite3.c"
       $81 = HEAP32[$80>>2]|0; //@line 115775 "c/sqlite3.c"
       _sqlite3BtreeSetCacheSize($81,$76); //@line 115775 "c/sqlite3.c"
       break L21;
      }
      break;
     }
     case 28:  {
      $82 = (((($18) + ($15<<4)|0)) + 4|0); //@line 115792 "c/sqlite3.c"
      $83 = HEAP32[$82>>2]|0; //@line 115792 "c/sqlite3.c"
      $84 = ($$01162|0)==(0|0); //@line 115794 "c/sqlite3.c"
      if (!($84)) {
       $91 = (_sqlite3Atoi($$01162)|0); //@line 115801 "c/sqlite3.c"
       $92 = ((($11)) + 84|0); //@line 115801 "c/sqlite3.c"
       HEAP32[$92>>2] = $91; //@line 115801 "c/sqlite3.c"
       $93 = (_sqlite3BtreeSetPageSize($83,$91,-1,0)|0); //@line 115802 "c/sqlite3.c"
       $94 = ($93|0)==(7); //@line 115802 "c/sqlite3.c"
       if (!($94)) {
        break L21;
       }
       _sqlite3OomFault($11); //@line 115803 "c/sqlite3.c"
       break L21;
      }
      $85 = ($83|0)==(0|0); //@line 115795 "c/sqlite3.c"
      if ($85) {
       $89 = 0;$90 = 0;
      } else {
       $86 = (_sqlite3BtreeGetPageSize($83)|0); //@line 115795 "c/sqlite3.c"
       $87 = ($86|0)<(0); //@line 115795 "c/sqlite3.c"
       $88 = $87 << 31 >> 31; //@line 115795 "c/sqlite3.c"
       $89 = $86;$90 = $88;
      }
      _returnSingleInt($12,$89,$90); //@line 115796 "c/sqlite3.c"
      break L21;
      break;
     }
     case 30:  {
      $95 = (((($18) + ($15<<4)|0)) + 4|0); //@line 115818 "c/sqlite3.c"
      $96 = HEAP32[$95>>2]|0; //@line 115818 "c/sqlite3.c"
      $97 = ($$01162|0)==(0|0); //@line 115821 "c/sqlite3.c"
      if ($97) {
       $$011711258 = -1;
      } else {
       $98 = (_sqlite3_stricmp($$01162,25938)|0); //@line 115822 "c/sqlite3.c"
       $99 = ($98|0)==(0); //@line 115822 "c/sqlite3.c"
       if ($99) {
        $$01171 = 2;
       } else {
        $100 = (_sqlite3GetBoolean($$01162,0)|0); //@line 115825 "c/sqlite3.c"
        $101 = $100&255; //@line 115825 "c/sqlite3.c"
        $$01171 = $101;
       }
       $102 = HEAP32[$28>>2]|0; //@line 115828 "c/sqlite3.c"
       $103 = ($102|0)==(0); //@line 115828 "c/sqlite3.c"
       if ($103) {
        $104 = ((($11)) + 20|0); //@line 115830 "c/sqlite3.c"
        $105 = HEAP32[$104>>2]|0; //@line 115830 "c/sqlite3.c"
        $106 = ($105|0)>(0); //@line 115830 "c/sqlite3.c"
        if ($106) {
         $$011721283 = 0;
         while(1) {
          $107 = HEAP32[$17>>2]|0; //@line 115831 "c/sqlite3.c"
          $108 = (((($107) + ($$011721283<<4)|0)) + 4|0); //@line 115831 "c/sqlite3.c"
          $109 = HEAP32[$108>>2]|0; //@line 115831 "c/sqlite3.c"
          (_sqlite3BtreeSecureDelete($109,$$01171)|0); //@line 115831 "c/sqlite3.c"
          $110 = (($$011721283) + 1)|0; //@line 115830 "c/sqlite3.c"
          $111 = HEAP32[$104>>2]|0; //@line 115830 "c/sqlite3.c"
          $112 = ($110|0)<($111|0); //@line 115830 "c/sqlite3.c"
          if ($112) {
           $$011721283 = $110;
          } else {
           $$011711258 = $$01171;
           break;
          }
         }
        } else {
         $$011711258 = $$01171;
        }
       } else {
        $$011711258 = $$01171;
       }
      }
      $113 = (_sqlite3BtreeSecureDelete($96,$$011711258)|0); //@line 115834 "c/sqlite3.c"
      $114 = ($113|0)<(0); //@line 115835 "c/sqlite3.c"
      $115 = $114 << 31 >> 31; //@line 115835 "c/sqlite3.c"
      _returnSingleInt($12,$113,$115); //@line 115835 "c/sqlite3.c"
      break L21;
      break;
     }
     case 24:  {
      _sqlite3CodeVerifySchema($0,$15); //@line 115858 "c/sqlite3.c"
      $116 = HEAP32[$14>>2]|0; //@line 115859 "c/sqlite3.c"
      $117 = (($116) + 1)|0; //@line 115859 "c/sqlite3.c"
      HEAP32[$14>>2] = $117; //@line 115859 "c/sqlite3.c"
      $118 = HEAP8[$23>>0]|0; //@line 115860 "c/sqlite3.c"
      $119 = $118 | 32; //@line 115860 "c/sqlite3.c"
      $120 = ($119<<24>>24)==(112); //@line 115860 "c/sqlite3.c"
      if ($120) {
       (_sqlite3VdbeAddOp2($12,160,$15,$117)|0); //@line 115861 "c/sqlite3.c"
      } else {
       $121 = (_sqlite3Atoi($$01162)|0); //@line 115864 "c/sqlite3.c"
       $122 = (_sqlite3AbsInt32($121)|0); //@line 115864 "c/sqlite3.c"
       (_sqlite3VdbeAddOp3($12,161,$15,$117,$122)|0); //@line 115863 "c/sqlite3.c"
      }
      (_sqlite3VdbeAddOp2($12,78,$117,1)|0); //@line 115866 "c/sqlite3.c"
      break L21;
      break;
     }
     case 23:  {
      $123 = (_getLockingMode($$01162)|0); //@line 115876 "c/sqlite3.c"
      $124 = HEAP32[$28>>2]|0; //@line 115878 "c/sqlite3.c"
      $125 = ($124|0)==(0); //@line 115878 "c/sqlite3.c"
      $126 = ($123|0)==(-1); //@line 115878 "c/sqlite3.c"
      $or$cond5 = $126 & $125; //@line 115878 "c/sqlite3.c"
      if ($or$cond5) {
       $127 = ((($11)) + 75|0); //@line 115883 "c/sqlite3.c"
       $128 = HEAP8[$127>>0]|0; //@line 115883 "c/sqlite3.c"
       $129 = $128&255; //@line 115883 "c/sqlite3.c"
       $$01175 = $129;
      } else {
       if ($125) {
        $130 = ((($11)) + 20|0); //@line 115897 "c/sqlite3.c"
        $131 = HEAP32[$130>>2]|0; //@line 115897 "c/sqlite3.c"
        $132 = ($131|0)>(2); //@line 115897 "c/sqlite3.c"
        if ($132) {
         $$011771284 = 2;
         while(1) {
          $133 = HEAP32[$17>>2]|0; //@line 115898 "c/sqlite3.c"
          $134 = (((($133) + ($$011771284<<4)|0)) + 4|0); //@line 115898 "c/sqlite3.c"
          $135 = HEAP32[$134>>2]|0; //@line 115898 "c/sqlite3.c"
          $136 = (_sqlite3BtreePager($135)|0); //@line 115898 "c/sqlite3.c"
          (_sqlite3PagerLockingMode($136,$123)|0); //@line 115899 "c/sqlite3.c"
          $137 = (($$011771284) + 1)|0; //@line 115897 "c/sqlite3.c"
          $138 = HEAP32[$130>>2]|0; //@line 115897 "c/sqlite3.c"
          $139 = ($137|0)<($138|0); //@line 115897 "c/sqlite3.c"
          if ($139) {
           $$011771284 = $137;
          } else {
           break;
          }
         }
        }
        $140 = $123&255; //@line 115901 "c/sqlite3.c"
        $141 = ((($11)) + 75|0); //@line 115901 "c/sqlite3.c"
        HEAP8[$141>>0] = $140; //@line 115901 "c/sqlite3.c"
       }
       $142 = (((($18) + ($15<<4)|0)) + 4|0); //@line 115903 "c/sqlite3.c"
       $143 = HEAP32[$142>>2]|0; //@line 115903 "c/sqlite3.c"
       $144 = (_sqlite3BtreePager($143)|0); //@line 115903 "c/sqlite3.c"
       $145 = (_sqlite3PagerLockingMode($144,$123)|0); //@line 115904 "c/sqlite3.c"
       $$01175 = $145;
      }
      $146 = ($$01175|0)==(1); //@line 115909 "c/sqlite3.c"
      $spec$select = $146 ? 25950 : 25943; //@line 115909 "c/sqlite3.c"
      _returnSingleText($12,$spec$select); //@line 115912 "c/sqlite3.c"
      break L21;
      break;
     }
     case 20:  {
      $147 = ($$01162|0)==(0|0); //@line 115925 "c/sqlite3.c"
      L85: do {
       if ($147) {
        label = 59;
       } else {
        $148 = (_sqlite3Strlen30($$01162)|0); //@line 115931 "c/sqlite3.c"
        $149 = (_sqlite3JournalModename(0)|0); //@line 115932 "c/sqlite3.c"
        $150 = ($149|0)==(0|0); //@line 115932 "c/sqlite3.c"
        if ($150) {
         label = 59;
        } else {
         $$011781291 = 0;$151 = $149;
         while(1) {
          $152 = (_sqlite3_strnicmp($$01162,$151,$148)|0); //@line 115933 "c/sqlite3.c"
          $153 = ($152|0)==(0); //@line 115933 "c/sqlite3.c"
          if ($153) {
           $$01165 = $15;$$211801260 = $$011781291;
           break L85;
          }
          $154 = (($$011781291) + 1)|0; //@line 115932 "c/sqlite3.c"
          $155 = (_sqlite3JournalModename($154)|0); //@line 115932 "c/sqlite3.c"
          $156 = ($155|0)==(0|0); //@line 115932 "c/sqlite3.c"
          if ($156) {
           label = 59;
           break;
          } else {
           $$011781291 = $154;$151 = $155;
          }
         }
        }
       }
      } while(0);
      if ((label|0) == 59) {
       $157 = HEAP32[$28>>2]|0; //@line 115941 "c/sqlite3.c"
       $158 = ($157|0)==(0); //@line 115941 "c/sqlite3.c"
       if ($158) {
        HEAP32[$28>>2] = 1; //@line 115944 "c/sqlite3.c"
        $$01165 = 0;$$211801260 = -1;
       } else {
        $$01165 = $15;$$211801260 = -1;
       }
      }
      $159 = ((($11)) + 20|0); //@line 115946 "c/sqlite3.c"
      $160 = HEAP32[$159>>2]|0; //@line 115946 "c/sqlite3.c"
      $161 = ($160|0)>(0); //@line 115946 "c/sqlite3.c"
      if ($161) {
       $$011821287$in = $160;
       while(1) {
        $$011821287 = (($$011821287$in) + -1)|0;
        $162 = HEAP32[$17>>2]|0; //@line 115947 "c/sqlite3.c"
        $163 = (((($162) + ($$011821287<<4)|0)) + 4|0); //@line 115947 "c/sqlite3.c"
        $164 = HEAP32[$163>>2]|0; //@line 115947 "c/sqlite3.c"
        $165 = ($164|0)==(0|0); //@line 115947 "c/sqlite3.c"
        do {
         if (!($165)) {
          $166 = ($$011821287|0)==($$01165|0); //@line 115947 "c/sqlite3.c"
          if (!($166)) {
           $167 = HEAP32[$28>>2]|0; //@line 115947 "c/sqlite3.c"
           $168 = ($167|0)==(0); //@line 115947 "c/sqlite3.c"
           if (!($168)) {
            break;
           }
          }
          _sqlite3VdbeUsesBtree($12,$$011821287); //@line 115948 "c/sqlite3.c"
          (_sqlite3VdbeAddOp3($12,9,$$011821287,1,$$211801260)|0); //@line 115949 "c/sqlite3.c"
         }
        } while(0);
        $169 = ($$011821287$in|0)>(1); //@line 115946 "c/sqlite3.c"
        if ($169) {
         $$011821287$in = $$011821287;
        } else {
         break;
        }
       }
      }
      (_sqlite3VdbeAddOp2($12,78,1,1)|0); //@line 115952 "c/sqlite3.c"
      break L21;
      break;
     }
     case 21:  {
      $170 = (((($18) + ($15<<4)|0)) + 4|0); //@line 115963 "c/sqlite3.c"
      $171 = HEAP32[$170>>2]|0; //@line 115963 "c/sqlite3.c"
      $172 = (_sqlite3BtreePager($171)|0); //@line 115963 "c/sqlite3.c"
      $173 = $7; //@line 115964 "c/sqlite3.c"
      $174 = $173; //@line 115964 "c/sqlite3.c"
      HEAP32[$174>>2] = -2; //@line 115964 "c/sqlite3.c"
      $175 = (($173) + 4)|0; //@line 115964 "c/sqlite3.c"
      $176 = $175; //@line 115964 "c/sqlite3.c"
      HEAP32[$176>>2] = -1; //@line 115964 "c/sqlite3.c"
      $177 = ($$01162|0)==(0|0); //@line 115965 "c/sqlite3.c"
      if (!($177)) {
       (_sqlite3DecOrHexToI64($$01162,$7)|0); //@line 115966 "c/sqlite3.c"
       $178 = $7; //@line 115967 "c/sqlite3.c"
       $179 = $178; //@line 115967 "c/sqlite3.c"
       $180 = HEAP32[$179>>2]|0; //@line 115967 "c/sqlite3.c"
       $181 = (($178) + 4)|0; //@line 115967 "c/sqlite3.c"
       $182 = $181; //@line 115967 "c/sqlite3.c"
       $183 = HEAP32[$182>>2]|0; //@line 115967 "c/sqlite3.c"
       $184 = ($183|0)<(-1); //@line 115967 "c/sqlite3.c"
       $185 = ($180>>>0)<(4294967295); //@line 115967 "c/sqlite3.c"
       $186 = ($183|0)==(-1); //@line 115967 "c/sqlite3.c"
       $187 = $186 & $185; //@line 115967 "c/sqlite3.c"
       $188 = $184 | $187; //@line 115967 "c/sqlite3.c"
       if ($188) {
        $189 = $7; //@line 115967 "c/sqlite3.c"
        $190 = $189; //@line 115967 "c/sqlite3.c"
        HEAP32[$190>>2] = -1; //@line 115967 "c/sqlite3.c"
        $191 = (($189) + 4)|0; //@line 115967 "c/sqlite3.c"
        $192 = $191; //@line 115967 "c/sqlite3.c"
        HEAP32[$192>>2] = -1; //@line 115967 "c/sqlite3.c"
       }
      }
      $193 = $7; //@line 115969 "c/sqlite3.c"
      $194 = $193; //@line 115969 "c/sqlite3.c"
      $195 = HEAP32[$194>>2]|0; //@line 115969 "c/sqlite3.c"
      $196 = (($193) + 4)|0; //@line 115969 "c/sqlite3.c"
      $197 = $196; //@line 115969 "c/sqlite3.c"
      $198 = HEAP32[$197>>2]|0; //@line 115969 "c/sqlite3.c"
      $199 = (_sqlite3PagerJournalSizeLimit($172,$195,$198)|0); //@line 115969 "c/sqlite3.c"
      $200 = tempRet0; //@line 115969 "c/sqlite3.c"
      _returnSingleInt($12,$199,$200); //@line 115970 "c/sqlite3.c"
      break L21;
      break;
     }
     case 1:  {
      $201 = (((($18) + ($15<<4)|0)) + 4|0); //@line 115985 "c/sqlite3.c"
      $202 = HEAP32[$201>>2]|0; //@line 115985 "c/sqlite3.c"
      $203 = ($$01162|0)==(0|0); //@line 115987 "c/sqlite3.c"
      if ($203) {
       $204 = (_sqlite3BtreeGetAutoVacuum($202)|0); //@line 115988 "c/sqlite3.c"
       $205 = ($204|0)<(0); //@line 115988 "c/sqlite3.c"
       $206 = $205 << 31 >> 31; //@line 115988 "c/sqlite3.c"
       _returnSingleInt($12,$204,$206); //@line 115988 "c/sqlite3.c"
       break L21;
      }
      $207 = (_getAutoVacuum($$01162)|0); //@line 115990 "c/sqlite3.c"
      $208 = $207&255; //@line 115992 "c/sqlite3.c"
      $209 = ((($11)) + 76|0); //@line 115992 "c/sqlite3.c"
      HEAP8[$209>>0] = $208; //@line 115992 "c/sqlite3.c"
      $210 = (_sqlite3BtreeSetAutoVacuum($202,$207)|0); //@line 115998 "c/sqlite3.c"
      $211 = ($210|0)==(0); //@line 115999 "c/sqlite3.c"
      $212 = (($207) + -1)|0; //@line 115999 "c/sqlite3.c"
      $213 = ($212>>>0)<(2); //@line 115999 "c/sqlite3.c"
      $or$cond1242 = $213 & $211; //@line 115999 "c/sqlite3.c"
      if (!($or$cond1242)) {
       break L21;
      }
      $214 = (_sqlite3VdbeCurrentAddr($12)|0); //@line 116014 "c/sqlite3.c"
      $215 = (_sqlite3VdbeAddOpList($12,5,25960)|0); //@line 116016 "c/sqlite3.c"
      $216 = ((($215)) + 4|0); //@line 116018 "c/sqlite3.c"
      HEAP32[$216>>2] = $15; //@line 116018 "c/sqlite3.c"
      $217 = ((($215)) + 24|0); //@line 116019 "c/sqlite3.c"
      HEAP32[$217>>2] = $15; //@line 116019 "c/sqlite3.c"
      $218 = (($214) + 4)|0; //@line 116020 "c/sqlite3.c"
      $219 = ((($215)) + 48|0); //@line 116020 "c/sqlite3.c"
      HEAP32[$219>>2] = $218; //@line 116020 "c/sqlite3.c"
      $220 = ((($215)) + 84|0); //@line 116021 "c/sqlite3.c"
      HEAP32[$220>>2] = $15; //@line 116021 "c/sqlite3.c"
      $221 = ((($215)) + 92|0); //@line 116022 "c/sqlite3.c"
      HEAP32[$221>>2] = $212; //@line 116022 "c/sqlite3.c"
      _sqlite3VdbeUsesBtree($12,$15); //@line 116023 "c/sqlite3.c"
      break L21;
      break;
     }
     case 16:  {
      $222 = ($$01162|0)==(0|0); //@line 116038 "c/sqlite3.c"
      if ($222) {
       label = 79;
      } else {
       $223 = (_sqlite3GetInt32($$01162,$7)|0); //@line 116038 "c/sqlite3.c"
       $224 = ($223|0)==(0); //@line 116038 "c/sqlite3.c"
       $225 = HEAP32[$7>>2]|0; //@line 116038 "c/sqlite3.c"
       $226 = ($225|0)<(1); //@line 116038 "c/sqlite3.c"
       $or$cond9 = $224 | $226; //@line 116038 "c/sqlite3.c"
       if ($or$cond9) {
        label = 79;
       }
      }
      if ((label|0) == 79) {
       HEAP32[$7>>2] = 2147483647; //@line 116039 "c/sqlite3.c"
      }
      _sqlite3BeginWriteOperation($0,0,$15); //@line 116041 "c/sqlite3.c"
      $227 = HEAP32[$7>>2]|0; //@line 116042 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($12,67,$227,1)|0); //@line 116042 "c/sqlite3.c"
      $228 = (_sqlite3VdbeAddOp1($12,60,$15)|0); //@line 116043 "c/sqlite3.c"
      (_sqlite3VdbeAddOp1($12,78,1)|0); //@line 116044 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($12,80,1,-1)|0); //@line 116045 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($12,48,1,$228)|0); //@line 116046 "c/sqlite3.c"
      _sqlite3VdbeJumpHere($12,$228); //@line 116047 "c/sqlite3.c"
      break L21;
      break;
     }
     case 4:  {
      $229 = ($$01162|0)==(0|0); //@line 116066 "c/sqlite3.c"
      if ($229) {
       $230 = (((($18) + ($15<<4)|0)) + 12|0); //@line 116067 "c/sqlite3.c"
       $231 = HEAP32[$230>>2]|0; //@line 116067 "c/sqlite3.c"
       $232 = ((($231)) + 80|0); //@line 116067 "c/sqlite3.c"
       $233 = HEAP32[$232>>2]|0; //@line 116067 "c/sqlite3.c"
       $234 = ($233|0)<(0); //@line 116067 "c/sqlite3.c"
       $235 = $234 << 31 >> 31; //@line 116067 "c/sqlite3.c"
       _returnSingleInt($12,$233,$235); //@line 116067 "c/sqlite3.c"
       break L21;
      } else {
       $236 = (_sqlite3Atoi($$01162)|0); //@line 116069 "c/sqlite3.c"
       $237 = (((($18) + ($15<<4)|0)) + 12|0); //@line 116070 "c/sqlite3.c"
       $238 = HEAP32[$237>>2]|0; //@line 116070 "c/sqlite3.c"
       $239 = ((($238)) + 80|0); //@line 116070 "c/sqlite3.c"
       HEAP32[$239>>2] = $236; //@line 116070 "c/sqlite3.c"
       $240 = (((($18) + ($15<<4)|0)) + 4|0); //@line 116071 "c/sqlite3.c"
       $241 = HEAP32[$240>>2]|0; //@line 116071 "c/sqlite3.c"
       _sqlite3BtreeSetCacheSize($241,$236); //@line 116071 "c/sqlite3.c"
       break L21;
      }
      break;
     }
     case 5:  {
      $242 = ($$01162|0)==(0|0); //@line 116100 "c/sqlite3.c"
      if ($242) {
       $243 = ((($11)) + 28|0); //@line 116102 "c/sqlite3.c"
       $244 = HEAP32[$243>>2]|0; //@line 116102 "c/sqlite3.c"
       $245 = $244 & 32; //@line 116102 "c/sqlite3.c"
       $246 = ($245|0)==(0); //@line 116102 "c/sqlite3.c"
       if ($246) {
        $252 = 0;$253 = 0;
       } else {
        $247 = (((($18) + ($15<<4)|0)) + 4|0); //@line 116103 "c/sqlite3.c"
        $248 = HEAP32[$247>>2]|0; //@line 116103 "c/sqlite3.c"
        $249 = (_sqlite3BtreeSetSpillSize($248,0)|0); //@line 116103 "c/sqlite3.c"
        $250 = ($249|0)<(0); //@line 116102 "c/sqlite3.c"
        $251 = $250 << 31 >> 31; //@line 116102 "c/sqlite3.c"
        $252 = $249;$253 = $251;
       }
       _returnSingleInt($12,$252,$253); //@line 116101 "c/sqlite3.c"
       break L21;
      } else {
       HEAP32[$7>>2] = 1; //@line 116105 "c/sqlite3.c"
       $254 = (_sqlite3GetInt32($$01162,$7)|0); //@line 116106 "c/sqlite3.c"
       $255 = ($254|0)==(0); //@line 116106 "c/sqlite3.c"
       if (!($255)) {
        $256 = (((($18) + ($15<<4)|0)) + 4|0); //@line 116107 "c/sqlite3.c"
        $257 = HEAP32[$256>>2]|0; //@line 116107 "c/sqlite3.c"
        $258 = HEAP32[$7>>2]|0; //@line 116107 "c/sqlite3.c"
        (_sqlite3BtreeSetSpillSize($257,$258)|0); //@line 116107 "c/sqlite3.c"
       }
       $259 = HEAP32[$7>>2]|0; //@line 116109 "c/sqlite3.c"
       $260 = ($259|0)!=(0); //@line 116109 "c/sqlite3.c"
       $261 = $260&1; //@line 116109 "c/sqlite3.c"
       $262 = (_sqlite3GetBoolean($$01162,$261)|0); //@line 116109 "c/sqlite3.c"
       $263 = ($262<<24>>24)==(0); //@line 116109 "c/sqlite3.c"
       $264 = ((($11)) + 28|0);
       $265 = HEAP32[$264>>2]|0;
       $266 = $265 & -33; //@line 116112 "c/sqlite3.c"
       $267 = $265 | 32; //@line 116110 "c/sqlite3.c"
       $storemerge1238 = $263 ? $266 : $267; //@line 116109 "c/sqlite3.c"
       HEAP32[$264>>2] = $storemerge1238;
       _setAllPagerFlags($11); //@line 116114 "c/sqlite3.c"
       break L21;
      }
      break;
     }
     case 25:  {
      _returnSingleInt($12,0,0); //@line 116155 "c/sqlite3.c"
      break L21;
      break;
     }
     case 35:  {
      $268 = ($$01162|0)==(0|0); //@line 116175 "c/sqlite3.c"
      if ($268) {
       $269 = ((($11)) + 72|0); //@line 116176 "c/sqlite3.c"
       $270 = HEAP8[$269>>0]|0; //@line 116176 "c/sqlite3.c"
       $271 = $270&255; //@line 116176 "c/sqlite3.c"
       _returnSingleInt($12,$271,0); //@line 116176 "c/sqlite3.c"
       break L21;
      } else {
       _changeTempStorage($0,$$01162); //@line 116178 "c/sqlite3.c"
       break L21;
      }
      break;
     }
     case 36:  {
      $272 = ($$01162|0)==(0|0); //@line 116194 "c/sqlite3.c"
      if ($272) {
       $273 = HEAP32[10026]|0; //@line 116195 "c/sqlite3.c"
       _returnSingleText($12,$273); //@line 116195 "c/sqlite3.c"
       break L21;
      }
      $274 = HEAP8[$$01162>>0]|0; //@line 116198 "c/sqlite3.c"
      $275 = ($274<<24>>24)==(0); //@line 116198 "c/sqlite3.c"
      do {
       if (!($275)) {
        $276 = HEAP32[$11>>2]|0; //@line 116200 "c/sqlite3.c"
        $277 = (_sqlite3OsAccess($276,$$01162,1,$7)|0); //@line 116200 "c/sqlite3.c"
        $278 = ($277|0)!=(0); //@line 116201 "c/sqlite3.c"
        $279 = HEAP32[$7>>2]|0; //@line 116201 "c/sqlite3.c"
        $280 = ($279|0)==(0); //@line 116201 "c/sqlite3.c"
        $or$cond11 = $278 | $280; //@line 116201 "c/sqlite3.c"
        if ($or$cond11) {
         _sqlite3ErrorMsg($0,25980,$vararg_buffer4); //@line 116202 "c/sqlite3.c"
         break L21;
        } else {
         break;
        }
       }
      } while(0);
      $281 = ((($11)) + 72|0); //@line 116207 "c/sqlite3.c"
      $282 = HEAP8[$281>>0]|0; //@line 116207 "c/sqlite3.c"
      $283 = ($282&255)<(2); //@line 116207 "c/sqlite3.c"
      if ($283) {
       (_invalidateTempStorage($0)|0); //@line 116210 "c/sqlite3.c"
      }
      $284 = HEAP32[10026]|0; //@line 116212 "c/sqlite3.c"
      _sqlite3_free($284); //@line 116212 "c/sqlite3.c"
      $285 = HEAP8[$$01162>>0]|0; //@line 116213 "c/sqlite3.c"
      $286 = ($285<<24>>24)==(0); //@line 116213 "c/sqlite3.c"
      if ($286) {
       HEAP32[10026] = 0; //@line 116216 "c/sqlite3.c"
       break L21;
      } else {
       HEAP32[$vararg_buffer6>>2] = $$01162; //@line 116214 "c/sqlite3.c"
       $287 = (_sqlite3_mprintf(15687,$vararg_buffer6)|0); //@line 116214 "c/sqlite3.c"
       HEAP32[10026] = $287; //@line 116214 "c/sqlite3.c"
       break L21;
      }
      break;
     }
     case 33:  {
      $288 = ($$01162|0)==(0|0); //@line 116309 "c/sqlite3.c"
      if ($288) {
       $289 = (((($18) + ($15<<4)|0)) + 8|0); //@line 116310 "c/sqlite3.c"
       $290 = HEAP8[$289>>0]|0; //@line 116310 "c/sqlite3.c"
       $291 = $290&255; //@line 116310 "c/sqlite3.c"
       $292 = (($291) + -1)|0; //@line 116310 "c/sqlite3.c"
       $293 = ($292|0)<(0); //@line 116310 "c/sqlite3.c"
       $294 = $293 << 31 >> 31; //@line 116310 "c/sqlite3.c"
       _returnSingleInt($12,$292,$294); //@line 116310 "c/sqlite3.c"
       break L21;
      }
      $295 = ((($11)) + 71|0); //@line 116312 "c/sqlite3.c"
      $296 = HEAP8[$295>>0]|0; //@line 116312 "c/sqlite3.c"
      $297 = ($296<<24>>24)==(0); //@line 116312 "c/sqlite3.c"
      if ($297) {
       _sqlite3ErrorMsg($0,26005,$vararg_buffer9); //@line 116313 "c/sqlite3.c"
       break L21;
      }
      if ($19) {
       break L21;
      }
      $298 = (_getSafetyLevel($$01162,0,1)|0); //@line 116316 "c/sqlite3.c"
      $299 = (($298) + 1)<<24>>24; //@line 116316 "c/sqlite3.c"
      $300 = $299 & 7; //@line 116316 "c/sqlite3.c"
      $301 = ($300<<24>>24)==(0); //@line 116317 "c/sqlite3.c"
      $302 = $301 ? 1 : $300; //@line 116318 "c/sqlite3.c"
      $303 = (((($18) + ($15<<4)|0)) + 8|0); //@line 116318 "c/sqlite3.c"
      HEAP8[$303>>0] = $302; //@line 116318 "c/sqlite3.c"
      $304 = (((($18) + ($15<<4)|0)) + 9|0); //@line 116319 "c/sqlite3.c"
      HEAP8[$304>>0] = 1; //@line 116319 "c/sqlite3.c"
      _setAllPagerFlags($11); //@line 116320 "c/sqlite3.c"
      break L21;
      break;
     }
     case 2:  {
      $305 = ($$01162|0)==(0|0); //@line 116329 "c/sqlite3.c"
      if ($305) {
       _setPragmaResultColumnNames($12,$51); //@line 116330 "c/sqlite3.c"
       $306 = ((($11)) + 28|0); //@line 116331 "c/sqlite3.c"
       $307 = HEAP32[$306>>2]|0; //@line 116331 "c/sqlite3.c"
       $308 = ((($51)) + 8|0); //@line 116331 "c/sqlite3.c"
       $309 = HEAP32[$308>>2]|0; //@line 116331 "c/sqlite3.c"
       $310 = $309 & $307; //@line 116331 "c/sqlite3.c"
       $311 = ($310|0)!=(0); //@line 116331 "c/sqlite3.c"
       $312 = $311&1; //@line 116331 "c/sqlite3.c"
       _returnSingleInt($12,$312,0); //@line 116331 "c/sqlite3.c"
       break L21;
      }
      $313 = ((($51)) + 8|0); //@line 116333 "c/sqlite3.c"
      $314 = HEAP32[$313>>2]|0; //@line 116333 "c/sqlite3.c"
      $315 = ((($11)) + 71|0); //@line 116334 "c/sqlite3.c"
      $316 = HEAP8[$315>>0]|0; //@line 116334 "c/sqlite3.c"
      $317 = ($316<<24>>24)==(0); //@line 116334 "c/sqlite3.c"
      $318 = $314 & -16385; //@line 116337 "c/sqlite3.c"
      $spec$select1243 = $317 ? $318 : $314; //@line 116334 "c/sqlite3.c"
      $319 = (_sqlite3GetBoolean($$01162,0)|0); //@line 116346 "c/sqlite3.c"
      $320 = ($319<<24>>24)==(0); //@line 116346 "c/sqlite3.c"
      if ($320) {
       $324 = $spec$select1243 ^ -1; //@line 116349 "c/sqlite3.c"
       $325 = ((($11)) + 28|0); //@line 116349 "c/sqlite3.c"
       $326 = HEAP32[$325>>2]|0; //@line 116349 "c/sqlite3.c"
       $327 = $326 & $324; //@line 116349 "c/sqlite3.c"
       HEAP32[$325>>2] = $327; //@line 116349 "c/sqlite3.c"
       $328 = ($spec$select1243|0)==(524288); //@line 116350 "c/sqlite3.c"
       if ($328) {
        $329 = ((($11)) + 456|0); //@line 116350 "c/sqlite3.c"
        $330 = $329; //@line 116350 "c/sqlite3.c"
        $331 = $330; //@line 116350 "c/sqlite3.c"
        HEAP32[$331>>2] = 0; //@line 116350 "c/sqlite3.c"
        $332 = (($330) + 4)|0; //@line 116350 "c/sqlite3.c"
        $333 = $332; //@line 116350 "c/sqlite3.c"
        HEAP32[$333>>2] = 0; //@line 116350 "c/sqlite3.c"
       }
      } else {
       $321 = ((($11)) + 28|0); //@line 116347 "c/sqlite3.c"
       $322 = HEAP32[$321>>2]|0; //@line 116347 "c/sqlite3.c"
       $323 = $322 | $spec$select1243; //@line 116347 "c/sqlite3.c"
       HEAP32[$321>>2] = $323; //@line 116347 "c/sqlite3.c"
      }
      (_sqlite3VdbeAddOp0($12,152)|0); //@line 116357 "c/sqlite3.c"
      _setAllPagerFlags($11); //@line 116358 "c/sqlite3.c"
      break L21;
      break;
     }
     case 34:  {
      $334 = ($$01162|0)==(0|0); //@line 116378 "c/sqlite3.c"
      if ($334) {
       break L21;
      }
      $335 = (_sqlite3LocateTable($0,2,$$01162,$33)|0); //@line 116380 "c/sqlite3.c"
      $336 = ($335|0)==(0|0); //@line 116381 "c/sqlite3.c"
      if ($336) {
       break L21;
      }
      $337 = (_sqlite3PrimaryKeyIndex($335)|0); //@line 116385 "c/sqlite3.c"
      HEAP32[$14>>2] = 6; //@line 116386 "c/sqlite3.c"
      _sqlite3CodeVerifySchema($0,$15); //@line 116387 "c/sqlite3.c"
      (_sqlite3ViewGetColumnNames($0,$335)|0); //@line 116388 "c/sqlite3.c"
      $338 = ((($335)) + 42|0); //@line 116389 "c/sqlite3.c"
      $339 = HEAP16[$338>>1]|0; //@line 116389 "c/sqlite3.c"
      $340 = ($339<<16>>16)>(0); //@line 116389 "c/sqlite3.c"
      if (!($340)) {
       break L21;
      }
      $341 = $339 << 16 >> 16; //@line 116389 "c/sqlite3.c"
      $342 = ((($335)) + 4|0); //@line 116389 "c/sqlite3.c"
      $343 = HEAP32[$342>>2]|0; //@line 116389 "c/sqlite3.c"
      $344 = ($337|0)==(0|0);
      $345 = ((($337)) + 4|0);
      $$011841302 = 0;$$011871301 = 0;$$011891299 = $343;$355 = $341;
      while(1) {
       $346 = ((($$011891299)) + 15|0); //@line 116390 "c/sqlite3.c"
       $347 = HEAP8[$346>>0]|0; //@line 116390 "c/sqlite3.c"
       $348 = $347&255; //@line 116390 "c/sqlite3.c"
       $349 = $348 & 2; //@line 116390 "c/sqlite3.c"
       $350 = ($349|0)==(0); //@line 116390 "c/sqlite3.c"
       if ($350) {
        $352 = $348 & 1; //@line 116394 "c/sqlite3.c"
        $353 = ($352|0)==(0); //@line 116394 "c/sqlite3.c"
        $brmerge = $353 | $344; //@line 116394 "c/sqlite3.c"
        $not$ = $353 ^ 1; //@line 116394 "c/sqlite3.c"
        $$mux = $not$&1; //@line 116394 "c/sqlite3.c"
        L182: do {
         if ($brmerge) {
          $$11186 = $$mux;
         } else {
          $354 = ($355|0)<(1); //@line 116399 "c/sqlite3.c"
          if ($354) {
           $$11186 = 1;
           break;
          }
          $356 = HEAP32[$345>>2]|0;
          $$011851294 = 1;
          while(1) {
           $357 = (($$011851294) + -1)|0; //@line 116399 "c/sqlite3.c"
           $358 = (($356) + ($357<<1)|0); //@line 116399 "c/sqlite3.c"
           $359 = HEAP16[$358>>1]|0; //@line 116399 "c/sqlite3.c"
           $360 = $359 << 16 >> 16; //@line 116399 "c/sqlite3.c"
           $361 = ($$011841302|0)==($360|0); //@line 116399 "c/sqlite3.c"
           if ($361) {
            $$11186 = $$011851294;
            break L182;
           }
           $362 = (($$011851294) + 1)|0; //@line 116399 "c/sqlite3.c"
           $363 = ($$011851294|0)<($355|0); //@line 116399 "c/sqlite3.c"
           if ($363) {
            $$011851294 = $362;
           } else {
            $$11186 = $362;
            break;
           }
          }
         }
        } while(0);
        $364 = (($$011841302) - ($$011871301))|0; //@line 116403 "c/sqlite3.c"
        $365 = HEAP32[$$011891299>>2]|0; //@line 116404 "c/sqlite3.c"
        $366 = (_sqlite3ColumnType($$011891299,41388)|0); //@line 116405 "c/sqlite3.c"
        $367 = ((($$011891299)) + 12|0); //@line 116406 "c/sqlite3.c"
        $368 = HEAP8[$367>>0]|0; //@line 116406 "c/sqlite3.c"
        $369 = ($368<<24>>24)!=(0); //@line 116406 "c/sqlite3.c"
        $370 = $369&1; //@line 116406 "c/sqlite3.c"
        $371 = ((($$011891299)) + 4|0); //@line 116407 "c/sqlite3.c"
        $372 = HEAP32[$371>>2]|0; //@line 116407 "c/sqlite3.c"
        $373 = ($372|0)==(0|0); //@line 116407 "c/sqlite3.c"
        if ($373) {
         $376 = 0;
        } else {
         $374 = ((($372)) + 8|0); //@line 116407 "c/sqlite3.c"
         $375 = HEAP32[$374>>2]|0; //@line 116407 "c/sqlite3.c"
         $376 = $375;
        }
        HEAP32[$vararg_buffer11>>2] = $364; //@line 116402 "c/sqlite3.c"
        $vararg_ptr14 = ((($vararg_buffer11)) + 4|0); //@line 116402 "c/sqlite3.c"
        HEAP32[$vararg_ptr14>>2] = $365; //@line 116402 "c/sqlite3.c"
        $vararg_ptr15 = ((($vararg_buffer11)) + 8|0); //@line 116402 "c/sqlite3.c"
        HEAP32[$vararg_ptr15>>2] = $366; //@line 116402 "c/sqlite3.c"
        $vararg_ptr16 = ((($vararg_buffer11)) + 12|0); //@line 116402 "c/sqlite3.c"
        HEAP32[$vararg_ptr16>>2] = $370; //@line 116402 "c/sqlite3.c"
        $vararg_ptr17 = ((($vararg_buffer11)) + 16|0); //@line 116402 "c/sqlite3.c"
        HEAP32[$vararg_ptr17>>2] = $376; //@line 116402 "c/sqlite3.c"
        $vararg_ptr18 = ((($vararg_buffer11)) + 20|0); //@line 116402 "c/sqlite3.c"
        HEAP32[$vararg_ptr18>>2] = $$11186; //@line 116402 "c/sqlite3.c"
        _sqlite3VdbeMultiLoad($12,1,26058,$vararg_buffer11); //@line 116402 "c/sqlite3.c"
        $$11188 = $$011871301;
       } else {
        $351 = (($$011871301) + 1)|0; //@line 116391 "c/sqlite3.c"
        $$11188 = $351;
       }
       $377 = (($$011841302) + 1)|0; //@line 116389 "c/sqlite3.c"
       $378 = ((($$011891299)) + 16|0); //@line 116389 "c/sqlite3.c"
       $379 = HEAP16[$338>>1]|0; //@line 116389 "c/sqlite3.c"
       $380 = $379 << 16 >> 16; //@line 116389 "c/sqlite3.c"
       $381 = ($377|0)<($380|0); //@line 116389 "c/sqlite3.c"
       if ($381) {
        $$011841302 = $377;$$011871301 = $$11188;$$011891299 = $378;$355 = $380;
       } else {
        break;
       }
      }
      break;
     }
     case 17:  {
      $382 = ($$01162|0)==(0|0); //@line 116441 "c/sqlite3.c"
      if ($382) {
       break L21;
      }
      $383 = (_sqlite3FindIndex($11,$$01162,$33)|0); //@line 116444 "c/sqlite3.c"
      $384 = ($383|0)==(0|0); //@line 116445 "c/sqlite3.c"
      if ($384) {
       break L21;
      }
      $385 = ((($51)) + 8|0); //@line 116448 "c/sqlite3.c"
      $386 = HEAP32[$385>>2]|0; //@line 116448 "c/sqlite3.c"
      $387 = ($386|0)==(0); //@line 116448 "c/sqlite3.c"
      $388 = ((($383)) + 50|0); //@line 116454 "c/sqlite3.c"
      $389 = ((($383)) + 52|0); //@line 116450 "c/sqlite3.c"
      $$sink$in = $387 ? $388 : $389; //@line 116448 "c/sqlite3.c"
      $storemerge = $387 ? 3 : 6; //@line 116448 "c/sqlite3.c"
      $$sink = HEAP16[$$sink$in>>1]|0;
      $390 = $$sink&65535;
      HEAP32[$14>>2] = $storemerge;
      $391 = ((($383)) + 12|0); //@line 116457 "c/sqlite3.c"
      $392 = HEAP32[$391>>2]|0; //@line 116457 "c/sqlite3.c"
      _sqlite3CodeVerifySchema($0,$15); //@line 116458 "c/sqlite3.c"
      $393 = ($$sink<<16>>16)==(0); //@line 116460 "c/sqlite3.c"
      if ($393) {
       break L21;
      }
      $394 = ((($383)) + 4|0);
      $395 = ((($392)) + 4|0);
      $396 = ((($383)) + 28|0);
      $397 = ((($383)) + 32|0);
      $398 = ((($383)) + 50|0);
      $$011911308 = 0;
      while(1) {
       $399 = HEAP32[$394>>2]|0; //@line 116461 "c/sqlite3.c"
       $400 = (($399) + ($$011911308<<1)|0); //@line 116461 "c/sqlite3.c"
       $401 = HEAP16[$400>>1]|0; //@line 116461 "c/sqlite3.c"
       $402 = $401 << 16 >> 16; //@line 116462 "c/sqlite3.c"
       $403 = ($401<<16>>16)<(0); //@line 116463 "c/sqlite3.c"
       if ($403) {
        $407 = 0;
       } else {
        $404 = HEAP32[$395>>2]|0; //@line 116463 "c/sqlite3.c"
        $405 = (($404) + ($402<<4)|0); //@line 116463 "c/sqlite3.c"
        $406 = HEAP32[$405>>2]|0; //@line 116463 "c/sqlite3.c"
        $407 = $406;
       }
       HEAP32[$vararg_buffer19>>2] = $$011911308; //@line 116462 "c/sqlite3.c"
       $vararg_ptr22 = ((($vararg_buffer19)) + 4|0); //@line 116462 "c/sqlite3.c"
       HEAP32[$vararg_ptr22>>2] = $402; //@line 116462 "c/sqlite3.c"
       $vararg_ptr23 = ((($vararg_buffer19)) + 8|0); //@line 116462 "c/sqlite3.c"
       HEAP32[$vararg_ptr23>>2] = $407; //@line 116462 "c/sqlite3.c"
       _sqlite3VdbeMultiLoad($12,1,26065,$vararg_buffer19); //@line 116462 "c/sqlite3.c"
       $408 = HEAP32[$385>>2]|0; //@line 116464 "c/sqlite3.c"
       $409 = ($408|0)==(0); //@line 116464 "c/sqlite3.c"
       if (!($409)) {
        $410 = HEAP32[$396>>2]|0; //@line 116466 "c/sqlite3.c"
        $411 = (($410) + ($$011911308)|0); //@line 116466 "c/sqlite3.c"
        $412 = HEAP8[$411>>0]|0; //@line 116466 "c/sqlite3.c"
        $413 = $412&255; //@line 116466 "c/sqlite3.c"
        $414 = HEAP32[$397>>2]|0; //@line 116467 "c/sqlite3.c"
        $415 = (($414) + ($$011911308<<2)|0); //@line 116467 "c/sqlite3.c"
        $416 = HEAP32[$415>>2]|0; //@line 116467 "c/sqlite3.c"
        $417 = HEAP16[$398>>1]|0; //@line 116468 "c/sqlite3.c"
        $418 = $417&65535; //@line 116468 "c/sqlite3.c"
        $419 = ($$011911308>>>0)<($418>>>0); //@line 116468 "c/sqlite3.c"
        $420 = $419&1; //@line 116468 "c/sqlite3.c"
        HEAP32[$vararg_buffer24>>2] = $413; //@line 116465 "c/sqlite3.c"
        $vararg_ptr27 = ((($vararg_buffer24)) + 4|0); //@line 116465 "c/sqlite3.c"
        HEAP32[$vararg_ptr27>>2] = $416; //@line 116465 "c/sqlite3.c"
        $vararg_ptr28 = ((($vararg_buffer24)) + 8|0); //@line 116465 "c/sqlite3.c"
        HEAP32[$vararg_ptr28>>2] = $420; //@line 116465 "c/sqlite3.c"
        _sqlite3VdbeMultiLoad($12,4,26070,$vararg_buffer24); //@line 116465 "c/sqlite3.c"
       }
       $421 = HEAP32[$14>>2]|0; //@line 116470 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($12,78,1,$421)|0); //@line 116470 "c/sqlite3.c"
       $422 = (($$011911308) + 1)|0; //@line 116460 "c/sqlite3.c"
       $exitcond = ($422|0)==($390|0); //@line 116460 "c/sqlite3.c"
       if ($exitcond) {
        break;
       } else {
        $$011911308 = $422;
       }
      }
      break;
     }
     case 18:  {
      $423 = ($$01162|0)==(0|0); //@line 116476 "c/sqlite3.c"
      if ($423) {
       break L21;
      }
      $424 = (_sqlite3FindTable($11,$$01162,$33)|0); //@line 116480 "c/sqlite3.c"
      $425 = ($424|0)==(0|0); //@line 116481 "c/sqlite3.c"
      if ($425) {
       break L21;
      }
      HEAP32[$14>>2] = 5; //@line 116482 "c/sqlite3.c"
      _sqlite3CodeVerifySchema($0,$15); //@line 116483 "c/sqlite3.c"
      $426 = ((($424)) + 8|0); //@line 116484 "c/sqlite3.c"
      $$011931311 = HEAP32[$426>>2]|0;
      $427 = ($$011931311|0)==(0|0); //@line 116484 "c/sqlite3.c"
      if ($427) {
       break L21;
      }
      $$011931313 = $$011931311;$$011941312 = 0;
      while(1) {
       $428 = HEAP32[$$011931313>>2]|0; //@line 116488 "c/sqlite3.c"
       $429 = ((($$011931313)) + 54|0); //@line 116489 "c/sqlite3.c"
       $430 = HEAP8[$429>>0]|0; //@line 116489 "c/sqlite3.c"
       $431 = ($430<<24>>24)!=(0); //@line 116489 "c/sqlite3.c"
       $432 = $431&1; //@line 116489 "c/sqlite3.c"
       $433 = ((($$011931313)) + 55|0); //@line 116490 "c/sqlite3.c"
       $434 = HEAPU8[$433>>0]|(HEAPU8[$433+1>>0]<<8); //@line 116490 "c/sqlite3.c"
       $435 = $434 & 3; //@line 116490 "c/sqlite3.c"
       $436 = $435&65535; //@line 116490 "c/sqlite3.c"
       $437 = (6220 + ($436<<2)|0); //@line 116490 "c/sqlite3.c"
       $438 = HEAP32[$437>>2]|0; //@line 116490 "c/sqlite3.c"
       $439 = ((($$011931313)) + 36|0); //@line 116491 "c/sqlite3.c"
       $440 = HEAP32[$439>>2]|0; //@line 116491 "c/sqlite3.c"
       $441 = ($440|0)!=(0|0); //@line 116491 "c/sqlite3.c"
       $442 = $441&1; //@line 116491 "c/sqlite3.c"
       HEAP32[$vararg_buffer29>>2] = $$011941312; //@line 116486 "c/sqlite3.c"
       $vararg_ptr32 = ((($vararg_buffer29)) + 4|0); //@line 116486 "c/sqlite3.c"
       HEAP32[$vararg_ptr32>>2] = $428; //@line 116486 "c/sqlite3.c"
       $vararg_ptr33 = ((($vararg_buffer29)) + 8|0); //@line 116486 "c/sqlite3.c"
       HEAP32[$vararg_ptr33>>2] = $432; //@line 116486 "c/sqlite3.c"
       $vararg_ptr34 = ((($vararg_buffer29)) + 12|0); //@line 116486 "c/sqlite3.c"
       HEAP32[$vararg_ptr34>>2] = $438; //@line 116486 "c/sqlite3.c"
       $vararg_ptr35 = ((($vararg_buffer29)) + 16|0); //@line 116486 "c/sqlite3.c"
       HEAP32[$vararg_ptr35>>2] = $442; //@line 116486 "c/sqlite3.c"
       _sqlite3VdbeMultiLoad($12,1,26075,$vararg_buffer29); //@line 116486 "c/sqlite3.c"
       $443 = ((($$011931313)) + 20|0); //@line 116484 "c/sqlite3.c"
       $444 = (($$011941312) + 1)|0; //@line 116484 "c/sqlite3.c"
       $$01193 = HEAP32[$443>>2]|0;
       $445 = ($$01193|0)==(0|0); //@line 116484 "c/sqlite3.c"
       if ($445) {
        break;
       } else {
        $$011931313 = $$01193;$$011941312 = $444;
       }
      }
      break;
     }
     case 10:  {
      HEAP32[$14>>2] = 3; //@line 116499 "c/sqlite3.c"
      $446 = ((($11)) + 20|0); //@line 116500 "c/sqlite3.c"
      $447 = HEAP32[$446>>2]|0; //@line 116500 "c/sqlite3.c"
      $448 = ($447|0)>(0); //@line 116500 "c/sqlite3.c"
      if (!($448)) {
       break L21;
      }
      $$011951316 = 0;
      while(1) {
       $449 = HEAP32[$17>>2]|0; //@line 116501 "c/sqlite3.c"
       $450 = (((($449) + ($$011951316<<4)|0)) + 4|0); //@line 116501 "c/sqlite3.c"
       $451 = HEAP32[$450>>2]|0; //@line 116501 "c/sqlite3.c"
       $452 = ($451|0)==(0|0); //@line 116501 "c/sqlite3.c"
       if (!($452)) {
        $453 = (($449) + ($$011951316<<4)|0); //@line 116505 "c/sqlite3.c"
        $454 = HEAP32[$453>>2]|0; //@line 116505 "c/sqlite3.c"
        $455 = (_sqlite3BtreeGetFilename($451)|0); //@line 116506 "c/sqlite3.c"
        HEAP32[$vararg_buffer36>>2] = $$011951316; //@line 116503 "c/sqlite3.c"
        $vararg_ptr39 = ((($vararg_buffer36)) + 4|0); //@line 116503 "c/sqlite3.c"
        HEAP32[$vararg_ptr39>>2] = $454; //@line 116503 "c/sqlite3.c"
        $vararg_ptr40 = ((($vararg_buffer36)) + 8|0); //@line 116503 "c/sqlite3.c"
        HEAP32[$vararg_ptr40>>2] = $455; //@line 116503 "c/sqlite3.c"
        _sqlite3VdbeMultiLoad($12,1,26081,$vararg_buffer36); //@line 116503 "c/sqlite3.c"
       }
       $456 = (($$011951316) + 1)|0; //@line 116500 "c/sqlite3.c"
       $457 = HEAP32[$446>>2]|0; //@line 116500 "c/sqlite3.c"
       $458 = ($456|0)<($457|0); //@line 116500 "c/sqlite3.c"
       if ($458) {
        $$011951316 = $456;
       } else {
        break;
       }
      }
      break;
     }
     case 7:  {
      HEAP32[$14>>2] = 2; //@line 116514 "c/sqlite3.c"
      $459 = ((($11)) + 380|0); //@line 116515 "c/sqlite3.c"
      $$011991319 = HEAP32[$459>>2]|0;
      $460 = ($$011991319|0)==(0|0); //@line 116515 "c/sqlite3.c"
      if ($460) {
       break L21;
      }
      $$011961320 = 0;$$011991321 = $$011991319;
      while(1) {
       $461 = ((($$011991321)) + 8|0); //@line 116516 "c/sqlite3.c"
       $462 = HEAP32[$461>>2]|0; //@line 116516 "c/sqlite3.c"
       $463 = (($$011961320) + 1)|0; //@line 116517 "c/sqlite3.c"
       $464 = HEAP32[$462>>2]|0; //@line 116517 "c/sqlite3.c"
       HEAP32[$vararg_buffer41>>2] = $$011961320; //@line 116517 "c/sqlite3.c"
       $vararg_ptr44 = ((($vararg_buffer41)) + 4|0); //@line 116517 "c/sqlite3.c"
       HEAP32[$vararg_ptr44>>2] = $464; //@line 116517 "c/sqlite3.c"
       _sqlite3VdbeMultiLoad($12,1,26085,$vararg_buffer41); //@line 116517 "c/sqlite3.c"
       $$01199 = HEAP32[$$011991321>>2]|0;
       $465 = ($$01199|0)==(0|0); //@line 116515 "c/sqlite3.c"
       if ($465) {
        break;
       } else {
        $$011961320 = $463;$$011991321 = $$01199;
       }
      }
      break;
     }
     case 14:  {
      $466 = ($$01162|0)==(0|0); //@line 116564 "c/sqlite3.c"
      if ($466) {
       break L21;
      }
      $467 = (_sqlite3FindTable($11,$$01162,$33)|0); //@line 116567 "c/sqlite3.c"
      $468 = ($467|0)==(0|0); //@line 116568 "c/sqlite3.c"
      if ($468) {
       break L21;
      }
      $469 = ((($467)) + 16|0); //@line 116569 "c/sqlite3.c"
      $470 = HEAP32[$469>>2]|0; //@line 116569 "c/sqlite3.c"
      $471 = ($470|0)==(0|0); //@line 116570 "c/sqlite3.c"
      if ($471) {
       break L21;
      }
      HEAP32[$14>>2] = 8; //@line 116572 "c/sqlite3.c"
      _sqlite3CodeVerifySchema($0,$15); //@line 116573 "c/sqlite3.c"
      $472 = ((($467)) + 4|0);
      $$012021329 = $470;$$012061328 = 0;
      while(1) {
       $473 = ((($$012021329)) + 20|0); //@line 116576 "c/sqlite3.c"
       $474 = HEAP32[$473>>2]|0; //@line 116576 "c/sqlite3.c"
       $475 = ($474|0)>(0); //@line 116576 "c/sqlite3.c"
       if ($475) {
        $476 = ((($$012021329)) + 8|0);
        $477 = ((($$012021329)) + 26|0);
        $478 = ((($$012021329)) + 25|0);
        $$012081324 = 0;
        while(1) {
         $479 = HEAP32[$476>>2]|0; //@line 116580 "c/sqlite3.c"
         $480 = HEAP32[$472>>2]|0; //@line 116581 "c/sqlite3.c"
         $481 = (((($$012021329)) + 36|0) + ($$012081324<<3)|0); //@line 116581 "c/sqlite3.c"
         $482 = HEAP32[$481>>2]|0; //@line 116581 "c/sqlite3.c"
         $483 = (($480) + ($482<<4)|0); //@line 116581 "c/sqlite3.c"
         $484 = HEAP32[$483>>2]|0; //@line 116581 "c/sqlite3.c"
         $485 = (((((($$012021329)) + 36|0) + ($$012081324<<3)|0)) + 4|0); //@line 116582 "c/sqlite3.c"
         $486 = HEAP32[$485>>2]|0; //@line 116582 "c/sqlite3.c"
         $487 = HEAP8[$477>>0]|0; //@line 116583 "c/sqlite3.c"
         $488 = (_actionName($487)|0); //@line 116583 "c/sqlite3.c"
         $489 = HEAP8[$478>>0]|0; //@line 116584 "c/sqlite3.c"
         $490 = (_actionName($489)|0); //@line 116584 "c/sqlite3.c"
         HEAP32[$vararg_buffer45>>2] = $$012061328; //@line 116577 "c/sqlite3.c"
         $vararg_ptr48 = ((($vararg_buffer45)) + 4|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr48>>2] = $$012081324; //@line 116577 "c/sqlite3.c"
         $vararg_ptr49 = ((($vararg_buffer45)) + 8|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr49>>2] = $479; //@line 116577 "c/sqlite3.c"
         $vararg_ptr50 = ((($vararg_buffer45)) + 12|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr50>>2] = $484; //@line 116577 "c/sqlite3.c"
         $vararg_ptr51 = ((($vararg_buffer45)) + 16|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr51>>2] = $486; //@line 116577 "c/sqlite3.c"
         $vararg_ptr52 = ((($vararg_buffer45)) + 20|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr52>>2] = $488; //@line 116577 "c/sqlite3.c"
         $vararg_ptr53 = ((($vararg_buffer45)) + 24|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr53>>2] = $490; //@line 116577 "c/sqlite3.c"
         $vararg_ptr54 = ((($vararg_buffer45)) + 28|0); //@line 116577 "c/sqlite3.c"
         HEAP32[$vararg_ptr54>>2] = 26097; //@line 116577 "c/sqlite3.c"
         _sqlite3VdbeMultiLoad($12,1,26088,$vararg_buffer45); //@line 116577 "c/sqlite3.c"
         $491 = (($$012081324) + 1)|0; //@line 116576 "c/sqlite3.c"
         $492 = HEAP32[$473>>2]|0; //@line 116576 "c/sqlite3.c"
         $493 = ($491|0)<($492|0); //@line 116576 "c/sqlite3.c"
         if ($493) {
          $$012081324 = $491;
         } else {
          break;
         }
        }
       }
       $494 = (($$012061328) + 1)|0; //@line 116587 "c/sqlite3.c"
       $495 = ((($$012021329)) + 4|0); //@line 116588 "c/sqlite3.c"
       $496 = HEAP32[$495>>2]|0; //@line 116588 "c/sqlite3.c"
       $497 = ($496|0)==(0|0); //@line 116574 "c/sqlite3.c"
       if ($497) {
        break;
       } else {
        $$012021329 = $496;$$012061328 = $494;
       }
      }
      break;
     }
     case 13:  {
      $498 = HEAP32[$14>>2]|0; //@line 116614 "c/sqlite3.c"
      $499 = (($498) + 1)|0; //@line 116614 "c/sqlite3.c"
      $500 = (($498) + 5)|0; //@line 116616 "c/sqlite3.c"
      $501 = (($498) + 6)|0; //@line 116617 "c/sqlite3.c"
      HEAP32[$14>>2] = $501; //@line 116617 "c/sqlite3.c"
      _sqlite3CodeVerifySchema($0,$15); //@line 116618 "c/sqlite3.c"
      $502 = HEAP32[$17>>2]|0; //@line 116619 "c/sqlite3.c"
      $503 = (((($502) + ($15<<4)|0)) + 12|0); //@line 116619 "c/sqlite3.c"
      $504 = HEAP32[$503>>2]|0; //@line 116619 "c/sqlite3.c"
      $505 = ((($504)) + 16|0); //@line 116619 "c/sqlite3.c"
      $506 = HEAP32[$505>>2]|0; //@line 116619 "c/sqlite3.c"
      $507 = ($506|0)==(0|0); //@line 116620 "c/sqlite3.c"
      L235: do {
       if (!($507)) {
        $508 = ($$01162|0)==(0|0);
        $509 = ((($0)) + 40|0);
        $510 = (($498) + 2)|0;
        $511 = (($498) + 3)|0;
        $$012331353 = $506;
        while(1) {
         if ($508) {
          $513 = ((($$012331353)) + 8|0); //@line 116625 "c/sqlite3.c"
          $514 = HEAP32[$513>>2]|0; //@line 116625 "c/sqlite3.c"
          $515 = HEAP32[$$012331353>>2]|0; //@line 116626 "c/sqlite3.c"
          $$01221 = $514;$$11234 = $515;
         } else {
          $512 = (_sqlite3LocateTable($0,0,$$01162,$33)|0); //@line 116622 "c/sqlite3.c"
          $$01221 = $512;$$11234 = 0;
         }
         $516 = ($$01221|0)==(0|0); //@line 116628 "c/sqlite3.c"
         if (!($516)) {
          $517 = ((($$01221)) + 16|0); //@line 116628 "c/sqlite3.c"
          $518 = HEAP32[$517>>2]|0; //@line 116628 "c/sqlite3.c"
          $519 = ($518|0)==(0|0); //@line 116628 "c/sqlite3.c"
          if (!($519)) {
           $521 = ((($$01221)) + 28|0); //@line 116629 "c/sqlite3.c"
           $522 = HEAP32[$521>>2]|0; //@line 116629 "c/sqlite3.c"
           $523 = HEAP32[$$01221>>2]|0; //@line 116629 "c/sqlite3.c"
           _sqlite3TableLock($0,$15,$522,0,$523); //@line 116629 "c/sqlite3.c"
           $524 = ((($$01221)) + 42|0); //@line 116630 "c/sqlite3.c"
           $525 = HEAP16[$524>>1]|0; //@line 116630 "c/sqlite3.c"
           $526 = $525 << 16 >> 16; //@line 116630 "c/sqlite3.c"
           $527 = (($501) + ($526))|0; //@line 116630 "c/sqlite3.c"
           $528 = HEAP32[$14>>2]|0; //@line 116630 "c/sqlite3.c"
           $529 = ($527|0)>($528|0); //@line 116630 "c/sqlite3.c"
           if ($529) {
            HEAP32[$14>>2] = $527; //@line 116630 "c/sqlite3.c"
           }
           _sqlite3OpenTable($0,0,$15,$$01221,105); //@line 116631 "c/sqlite3.c"
           $530 = HEAP32[$$01221>>2]|0; //@line 116632 "c/sqlite3.c"
           (_sqlite3VdbeLoadString($12,$499,$530)|0); //@line 116632 "c/sqlite3.c"
           $$012111333 = HEAP32[$517>>2]|0;
           $531 = ($$012111333|0)==(0|0); //@line 116633 "c/sqlite3.c"
           if ($531) {
            $$01225$lcssa = 1;
           } else {
            $$012111335 = $$012111333;$$012251334 = 1;
            while(1) {
             $532 = ((($$012111335)) + 8|0); //@line 116634 "c/sqlite3.c"
             $533 = HEAP32[$532>>2]|0; //@line 116634 "c/sqlite3.c"
             $534 = (_sqlite3FindTable($11,$533,$33)|0); //@line 116634 "c/sqlite3.c"
             $535 = ($534|0)==(0|0); //@line 116635 "c/sqlite3.c"
             do {
              if (!($535)) {
               HEAP32[$7>>2] = 0; //@line 116636 "c/sqlite3.c"
               $536 = ((($534)) + 28|0); //@line 116637 "c/sqlite3.c"
               $537 = HEAP32[$536>>2]|0; //@line 116637 "c/sqlite3.c"
               $538 = HEAP32[$534>>2]|0; //@line 116637 "c/sqlite3.c"
               _sqlite3TableLock($0,$15,$537,0,$538); //@line 116637 "c/sqlite3.c"
               $539 = (_sqlite3FkLocateIndex($0,$534,$$012111335,$7,0)|0); //@line 116638 "c/sqlite3.c"
               $540 = ($539|0)==(0); //@line 116639 "c/sqlite3.c"
               if (!($540)) {
                break L235;
               }
               $541 = HEAP32[$7>>2]|0; //@line 116640 "c/sqlite3.c"
               $542 = ($541|0)==(0|0); //@line 116640 "c/sqlite3.c"
               if ($542) {
                _sqlite3OpenTable($0,$$012251334,$15,$534,105); //@line 116641 "c/sqlite3.c"
                break;
               } else {
                $543 = ((($541)) + 44|0); //@line 116643 "c/sqlite3.c"
                $544 = HEAP32[$543>>2]|0; //@line 116643 "c/sqlite3.c"
                (_sqlite3VdbeAddOp3($12,105,$$012251334,$544,$15)|0); //@line 116643 "c/sqlite3.c"
                _sqlite3VdbeSetP4KeyInfo($0,$541); //@line 116644 "c/sqlite3.c"
                break;
               }
              }
             } while(0);
             $545 = (($$012251334) + 1)|0; //@line 116633 "c/sqlite3.c"
             $546 = ((($$012111335)) + 4|0); //@line 116633 "c/sqlite3.c"
             $$01211 = HEAP32[$546>>2]|0;
             $547 = ($$01211|0)==(0|0); //@line 116633 "c/sqlite3.c"
             if ($547) {
              $$01225$lcssa = $545;
              break;
             } else {
              $$012111335 = $$01211;$$012251334 = $545;
             }
            }
           }
           $548 = HEAP32[$509>>2]|0; //@line 116653 "c/sqlite3.c"
           $549 = ($548|0)<($$01225$lcssa|0); //@line 116653 "c/sqlite3.c"
           if ($549) {
            HEAP32[$509>>2] = $$01225$lcssa; //@line 116653 "c/sqlite3.c"
           }
           $550 = (_sqlite3VdbeAddOp1($12,37,0)|0); //@line 116654 "c/sqlite3.c"
           $$112121346 = HEAP32[$517>>2]|0;
           $551 = ($$112121346|0)==(0|0); //@line 116655 "c/sqlite3.c"
           if (!($551)) {
            $552 = ((($$01221)) + 36|0);
            $$112121348 = $$112121346;$$112261347 = 1;
            while(1) {
             $553 = ((($$112121348)) + 8|0); //@line 116656 "c/sqlite3.c"
             $554 = HEAP32[$553>>2]|0; //@line 116656 "c/sqlite3.c"
             $555 = (_sqlite3FindTable($11,$554,$33)|0); //@line 116656 "c/sqlite3.c"
             HEAP32[$7>>2] = 0; //@line 116657 "c/sqlite3.c"
             HEAP32[$8>>2] = 0; //@line 116658 "c/sqlite3.c"
             $556 = ($555|0)!=(0|0); //@line 116659 "c/sqlite3.c"
             if ($556) {
              (_sqlite3FkLocateIndex($0,$555,$$112121348,$7,$8)|0); //@line 116660 "c/sqlite3.c"
             }
             $557 = (_sqlite3VdbeMakeLabel($12)|0); //@line 116663 "c/sqlite3.c"
             $558 = ((($$112121348)) + 20|0); //@line 116669 "c/sqlite3.c"
             $559 = HEAP32[$558>>2]|0; //@line 116669 "c/sqlite3.c"
             $560 = ($559|0)>(0); //@line 116669 "c/sqlite3.c"
             if ($560) {
              $$012321340 = 0;
              while(1) {
               $561 = HEAP32[$8>>2]|0; //@line 116670 "c/sqlite3.c"
               $562 = ($561|0)==(0|0); //@line 116670 "c/sqlite3.c"
               $563 = (($561) + ($$012321340<<2)|0); //@line 116670 "c/sqlite3.c"
               $564 = (((($$112121348)) + 36|0) + ($$012321340<<3)|0); //@line 116670 "c/sqlite3.c"
               $$in = $562 ? $564 : $563; //@line 116670 "c/sqlite3.c"
               $565 = HEAP32[$$in>>2]|0; //@line 116670 "c/sqlite3.c"
               $566 = (($$012321340) + ($501))|0; //@line 116671 "c/sqlite3.c"
               _sqlite3ExprCodeGetColumnOfTable($12,$$01221,0,$565,$566); //@line 116671 "c/sqlite3.c"
               (_sqlite3VdbeAddOp2($12,50,$566,$557)|0); //@line 116672 "c/sqlite3.c"
               $567 = (($$012321340) + 1)|0; //@line 116669 "c/sqlite3.c"
               $568 = HEAP32[$558>>2]|0; //@line 116669 "c/sqlite3.c"
               $569 = ($567|0)<($568|0); //@line 116669 "c/sqlite3.c"
               if ($569) {
                $$012321340 = $567;
               } else {
                $$lcssa = $568;
                break;
               }
              }
             } else {
              $$lcssa = $559;
             }
             $570 = HEAP32[$7>>2]|0; //@line 116677 "c/sqlite3.c"
             $571 = ($570|0)==(0|0); //@line 116677 "c/sqlite3.c"
             do {
              if ($571) {
               if (!($556)) {
                break;
               }
               $574 = (_sqlite3VdbeCurrentAddr($12)|0); //@line 116683 "c/sqlite3.c"
               $575 = (($574) + 2)|0; //@line 116683 "c/sqlite3.c"
               (_sqlite3VdbeAddOp3($12,31,$$112261347,$575,$501)|0); //@line 116684 "c/sqlite3.c"
               _sqlite3VdbeGoto($12,$557); //@line 116685 "c/sqlite3.c"
              } else {
               $572 = (_sqlite3IndexAffinityStr($11,$570)|0); //@line 116679 "c/sqlite3.c"
               $573 = HEAP32[$558>>2]|0; //@line 116679 "c/sqlite3.c"
               (_sqlite3VdbeAddOp4($12,100,$501,$$lcssa,$500,$572,$573)|0); //@line 116678 "c/sqlite3.c"
               (_sqlite3VdbeAddOp4Int($12,30,$$112261347,$557,$500,0)|0); //@line 116680 "c/sqlite3.c"
              }
             } while(0);
             $576 = HEAP32[$552>>2]|0; //@line 116690 "c/sqlite3.c"
             $577 = $576 & 32; //@line 116690 "c/sqlite3.c"
             $578 = ($577|0)==(0); //@line 116690 "c/sqlite3.c"
             if ($578) {
              (_sqlite3VdbeAddOp2($12,124,0,$510)|0); //@line 116691 "c/sqlite3.c"
             } else {
              (_sqlite3VdbeAddOp2($12,70,0,$510)|0); //@line 116693 "c/sqlite3.c"
             }
             $579 = HEAP32[$553>>2]|0; //@line 116695 "c/sqlite3.c"
             $580 = (($$112261347) + -1)|0; //@line 116695 "c/sqlite3.c"
             HEAP32[$vararg_buffer55>>2] = $579; //@line 116695 "c/sqlite3.c"
             $vararg_ptr58 = ((($vararg_buffer55)) + 4|0); //@line 116695 "c/sqlite3.c"
             HEAP32[$vararg_ptr58>>2] = $580; //@line 116695 "c/sqlite3.c"
             _sqlite3VdbeMultiLoad($12,$511,26102,$vararg_buffer55); //@line 116695 "c/sqlite3.c"
             (_sqlite3VdbeAddOp2($12,78,$499,4)|0); //@line 116696 "c/sqlite3.c"
             _sqlite3VdbeResolveLabel($12,$557); //@line 116697 "c/sqlite3.c"
             $581 = HEAP32[$8>>2]|0; //@line 116698 "c/sqlite3.c"
             _sqlite3DbFree($11,$581); //@line 116698 "c/sqlite3.c"
             $582 = (($$112261347) + 1)|0; //@line 116655 "c/sqlite3.c"
             $583 = ((($$112121348)) + 4|0); //@line 116655 "c/sqlite3.c"
             $$11212 = HEAP32[$583>>2]|0;
             $584 = ($$11212|0)==(0|0); //@line 116655 "c/sqlite3.c"
             if ($584) {
              break;
             } else {
              $$112121348 = $$11212;$$112261347 = $582;
             }
            }
           }
           $585 = (($550) + 1)|0; //@line 116700 "c/sqlite3.c"
           (_sqlite3VdbeAddOp2($12,7,0,$585)|0); //@line 116700 "c/sqlite3.c"
           _sqlite3VdbeJumpHere($12,$550); //@line 116701 "c/sqlite3.c"
          }
         }
         $520 = ($$11234|0)==(0|0); //@line 116620 "c/sqlite3.c"
         if ($520) {
          break;
         } else {
          $$012331353 = $$11234;
         }
        }
       }
      } while(0);
      break L21;
      break;
     }
     case 6:  {
      $586 = ($$01162|0)==(0|0); //@line 116725 "c/sqlite3.c"
      if ($586) {
       break L21;
      }
      $587 = (_sqlite3GetBoolean($$01162,0)|0); //@line 116726 "c/sqlite3.c"
      $588 = $587&255; //@line 116726 "c/sqlite3.c"
      _sqlite3RegisterLikeFunctions($11,$588); //@line 116726 "c/sqlite3.c"
      break L21;
      break;
     }
     case 19:  {
      $589 = HEAP8[$23>>0]|0; //@line 116751 "c/sqlite3.c"
      $590 = $589 | 32; //@line 116751 "c/sqlite3.c"
      $591 = ($590<<24>>24)==(113); //@line 116751 "c/sqlite3.c"
      $592 = HEAP32[$2>>2]|0; //@line 116764 "c/sqlite3.c"
      $593 = ($592|0)==(0|0); //@line 116764 "c/sqlite3.c"
      $spec$select1244 = $593 ? -1 : $15; //@line 116764 "c/sqlite3.c"
      HEAP32[$14>>2] = 6; //@line 116767 "c/sqlite3.c"
      HEAP32[$7>>2] = 100; //@line 116770 "c/sqlite3.c"
      $594 = ($$01162|0)==(0|0); //@line 116771 "c/sqlite3.c"
      if (!($594)) {
       (_sqlite3GetInt32($$01162,$7)|0); //@line 116772 "c/sqlite3.c"
       $595 = HEAP32[$7>>2]|0; //@line 116773 "c/sqlite3.c"
       $596 = ($595|0)<(1); //@line 116773 "c/sqlite3.c"
       if ($596) {
        HEAP32[$7>>2] = 100; //@line 116774 "c/sqlite3.c"
       }
      }
      $597 = HEAP32[$7>>2]|0; //@line 116777 "c/sqlite3.c"
      $598 = (($597) + -1)|0; //@line 116777 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($12,67,$598,1)|0); //@line 116777 "c/sqlite3.c"
      $599 = ((($11)) + 20|0); //@line 116780 "c/sqlite3.c"
      $600 = HEAP32[$599>>2]|0; //@line 116780 "c/sqlite3.c"
      $601 = ($600|0)>(0); //@line 116780 "c/sqlite3.c"
      L295: do {
       if ($601) {
        $602 = ($spec$select1244|0)<(0);
        $603 = ((($11)) + 28|0);
        $604 = ((($11)) + 73|0);
        $605 = ((($0)) + 56|0);
        $$012311430 = 0;
        while(1) {
         $606 = ($$012311430|0)==($spec$select1244|0); //@line 116788 "c/sqlite3.c"
         $or$cond1245 = $602 | $606; //@line 116788 "c/sqlite3.c"
         do {
          if ($or$cond1245) {
           _sqlite3CodeVerifySchema($0,$$012311430); //@line 116790 "c/sqlite3.c"
           $607 = HEAP32[$17>>2]|0; //@line 116798 "c/sqlite3.c"
           $608 = (((($607) + ($$012311430<<4)|0)) + 12|0); //@line 116798 "c/sqlite3.c"
           $609 = HEAP32[$608>>2]|0; //@line 116798 "c/sqlite3.c"
           $610 = ((($609)) + 16|0); //@line 116799 "c/sqlite3.c"
           $$012221365 = HEAP32[$610>>2]|0;
           $611 = ($$012221365|0)==(0|0); //@line 116799 "c/sqlite3.c"
           if ($611) {
            $$01213$lcssa = 0;$$01215$lcssa = 0;
           } else {
            $$012131367 = 0;$$012151366 = 0;$$012221368 = $$012221365;
            while(1) {
             $612 = ((($$012221368)) + 8|0); //@line 116800 "c/sqlite3.c"
             $613 = HEAP32[$612>>2]|0; //@line 116800 "c/sqlite3.c"
             $614 = ((($613)) + 36|0); //@line 116803 "c/sqlite3.c"
             $615 = HEAP32[$614>>2]|0; //@line 116803 "c/sqlite3.c"
             $616 = $615 >>> 5; //@line 116803 "c/sqlite3.c"
             $$lobit = $616 & 1; //@line 116803 "c/sqlite3.c"
             $617 = $$lobit ^ 1; //@line 116803 "c/sqlite3.c"
             $spec$select1246 = (($617) + ($$012151366))|0; //@line 116803 "c/sqlite3.c"
             $618 = ((($613)) + 8|0); //@line 116804 "c/sqlite3.c"
             $$012101356 = HEAP32[$618>>2]|0;
             $619 = ($$012101356|0)==(0|0); //@line 116804 "c/sqlite3.c"
             if ($619) {
              $$01209$lcssa = 0;$$21217$lcssa = $spec$select1246;
             } else {
              $$012091358 = 0;$$012101359 = $$012101356;$$212171357 = $spec$select1246;
              while(1) {
               $620 = (($$212171357) + 1)|0; //@line 116804 "c/sqlite3.c"
               $621 = ((($$012101359)) + 20|0); //@line 116804 "c/sqlite3.c"
               $622 = (($$012091358) + 1)|0; //@line 116804 "c/sqlite3.c"
               $$01210 = HEAP32[$621>>2]|0;
               $623 = ($$01210|0)==(0|0); //@line 116804 "c/sqlite3.c"
               if ($623) {
                $$01209$lcssa = $622;$$21217$lcssa = $620;
                break;
               } else {
                $$012091358 = $622;$$012101359 = $$01210;$$212171357 = $620;
               }
              }
             }
             $624 = ($$01209$lcssa|0)>($$012131367|0); //@line 116805 "c/sqlite3.c"
             $spec$select1247 = $624 ? $$01209$lcssa : $$012131367; //@line 116805 "c/sqlite3.c"
             $$01222 = HEAP32[$$012221368>>2]|0;
             $625 = ($$01222|0)==(0|0); //@line 116799 "c/sqlite3.c"
             if ($625) {
              $$01213$lcssa = $spec$select1247;$$01215$lcssa = $$21217$lcssa;
              break;
             } else {
              $$012131367 = $spec$select1247;$$012151366 = $$21217$lcssa;$$012221368 = $$01222;
             }
            }
           }
           $626 = $$01215$lcssa << 2; //@line 116807 "c/sqlite3.c"
           $627 = (($626) + 4)|0; //@line 116807 "c/sqlite3.c"
           $628 = (_sqlite3DbMallocRawNN($11,$627,0)|0); //@line 116807 "c/sqlite3.c"
           $629 = ($628|0)==(0|0); //@line 116808 "c/sqlite3.c"
           if ($629) {
            break L295;
           }
           $$112231381 = HEAP32[$610>>2]|0;
           $630 = ($$112231381|0)==(0|0); //@line 116809 "c/sqlite3.c"
           if ($630) {
            $$31218$lcssa = 0;
           } else {
            $$112231383 = $$112231381;$$312181382 = 0;
            while(1) {
             $631 = ((($$112231383)) + 8|0); //@line 116810 "c/sqlite3.c"
             $632 = HEAP32[$631>>2]|0; //@line 116810 "c/sqlite3.c"
             $633 = ((($632)) + 36|0); //@line 116812 "c/sqlite3.c"
             $634 = HEAP32[$633>>2]|0; //@line 116812 "c/sqlite3.c"
             $635 = $634 & 32; //@line 116812 "c/sqlite3.c"
             $636 = ($635|0)==(0); //@line 116812 "c/sqlite3.c"
             $637 = (($$312181382) + 1)|0; //@line 116812 "c/sqlite3.c"
             if ($636) {
              $638 = (($628) + ($637<<2)|0); //@line 116812 "c/sqlite3.c"
              $639 = ((($632)) + 28|0); //@line 116812 "c/sqlite3.c"
              $640 = HEAP32[$639>>2]|0; //@line 116812 "c/sqlite3.c"
              HEAP32[$638>>2] = $640; //@line 116812 "c/sqlite3.c"
              $$41219 = $637;
             } else {
              $$41219 = $$312181382;
             }
             $641 = ((($632)) + 8|0); //@line 116813 "c/sqlite3.c"
             $$012071374 = HEAP32[$641>>2]|0;
             $642 = ($$012071374|0)==(0|0); //@line 116813 "c/sqlite3.c"
             if ($642) {
              $$51220$lcssa = $$41219;
             } else {
              $$012071376 = $$012071374;$$512201375 = $$41219;
              while(1) {
               $643 = ((($$012071376)) + 44|0); //@line 116814 "c/sqlite3.c"
               $644 = HEAP32[$643>>2]|0; //@line 116814 "c/sqlite3.c"
               $645 = (($$512201375) + 1)|0; //@line 116814 "c/sqlite3.c"
               $646 = (($628) + ($645<<2)|0); //@line 116814 "c/sqlite3.c"
               HEAP32[$646>>2] = $644; //@line 116814 "c/sqlite3.c"
               $647 = ((($$012071376)) + 20|0); //@line 116813 "c/sqlite3.c"
               $$01207 = HEAP32[$647>>2]|0;
               $648 = ($$01207|0)==(0|0); //@line 116813 "c/sqlite3.c"
               if ($648) {
                $$51220$lcssa = $645;
                break;
               } else {
                $$012071376 = $$01207;$$512201375 = $645;
               }
              }
             }
             $$11223 = HEAP32[$$112231383>>2]|0;
             $649 = ($$11223|0)==(0|0); //@line 116809 "c/sqlite3.c"
             if ($649) {
              $$31218$lcssa = $$51220$lcssa;
              break;
             } else {
              $$112231383 = $$11223;$$312181382 = $$51220$lcssa;
             }
            }
           }
           HEAP32[$628>>2] = $$31218$lcssa; //@line 116817 "c/sqlite3.c"
           $650 = HEAP32[$14>>2]|0; //@line 116820 "c/sqlite3.c"
           $651 = (($$01213$lcssa) + 8)|0; //@line 116820 "c/sqlite3.c"
           $652 = ($650|0)>($651|0); //@line 116820 "c/sqlite3.c"
           $$ = $652 ? $650 : $651; //@line 116820 "c/sqlite3.c"
           HEAP32[$14>>2] = $$; //@line 116820 "c/sqlite3.c"
           _sqlite3ClearTempRegCache($0); //@line 116821 "c/sqlite3.c"
           (_sqlite3VdbeAddOp4($12,143,2,$$31218$lcssa,1,$628,-15)|0); //@line 116824 "c/sqlite3.c"
           $653 = $$012311430&65535; //@line 116825 "c/sqlite3.c"
           $654 = $653 & 255; //@line 116825 "c/sqlite3.c"
           _sqlite3VdbeChangeP5($12,$654); //@line 116825 "c/sqlite3.c"
           $655 = (_sqlite3VdbeAddOp1($12,50,2)|0); //@line 116826 "c/sqlite3.c"
           $656 = HEAP32[$17>>2]|0; //@line 116828 "c/sqlite3.c"
           $657 = (($656) + ($$012311430<<4)|0); //@line 116828 "c/sqlite3.c"
           $658 = HEAP32[$657>>2]|0; //@line 116828 "c/sqlite3.c"
           HEAP32[$vararg_buffer59>>2] = $658; //@line 116828 "c/sqlite3.c"
           $659 = (_sqlite3MPrintf($11,26106,$vararg_buffer59)|0); //@line 116828 "c/sqlite3.c"
           (_sqlite3VdbeAddOp4($12,97,0,3,0,$659,-7)|0); //@line 116827 "c/sqlite3.c"
           (_sqlite3VdbeAddOp3($12,93,2,3,3)|0); //@line 116830 "c/sqlite3.c"
           (_integrityCheckResultRow($12)|0); //@line 116831 "c/sqlite3.c"
           _sqlite3VdbeJumpHere($12,$655); //@line 116832 "c/sqlite3.c"
           $$212241426 = HEAP32[$610>>2]|0;
           $660 = ($$212241426|0)==(0|0); //@line 116836 "c/sqlite3.c"
           if ($660) {
            break;
           }
           $$212241427 = $$212241426;
           while(1) {
            $661 = ((($$212241427)) + 8|0); //@line 116837 "c/sqlite3.c"
            $662 = HEAP32[$661>>2]|0; //@line 116837 "c/sqlite3.c"
            $663 = ((($662)) + 28|0); //@line 116844 "c/sqlite3.c"
            $664 = HEAP32[$663>>2]|0; //@line 116844 "c/sqlite3.c"
            $665 = ($664|0)<(1); //@line 116844 "c/sqlite3.c"
            do {
             if (!($665)) {
              $666 = ((($662)) + 36|0); //@line 116845 "c/sqlite3.c"
              $667 = HEAP32[$666>>2]|0; //@line 116845 "c/sqlite3.c"
              $668 = $667 & 32; //@line 116845 "c/sqlite3.c"
              $669 = ($668|0)==(0); //@line 116845 "c/sqlite3.c"
              if ($669) {
               $732 = 0;
              } else {
               $670 = (_sqlite3PrimaryKeyIndex($662)|0); //@line 116845 "c/sqlite3.c"
               $732 = $670;
              }
              _sqlite3ExprCacheClear($0); //@line 116846 "c/sqlite3.c"
              (_sqlite3OpenTableAndIndices($0,$662,105,0,1,0,$8,$9)|0); //@line 116847 "c/sqlite3.c"
              (_sqlite3VdbeAddOp2($12,67,0,7)|0); //@line 116852 "c/sqlite3.c"
              $671 = ((($662)) + 8|0); //@line 116853 "c/sqlite3.c"
              $$012031388 = HEAP32[$671>>2]|0;
              $672 = ($$012031388|0)==(0|0); //@line 116853 "c/sqlite3.c"
              if (!($672)) {
               $$012031390 = $$012031388;$$012271389 = 0;
               while(1) {
                $673 = (($$012271389) + 8)|0; //@line 116854 "c/sqlite3.c"
                (_sqlite3VdbeAddOp2($12,67,0,$673)|0); //@line 116854 "c/sqlite3.c"
                $674 = ((($$012031390)) + 20|0); //@line 116853 "c/sqlite3.c"
                $675 = (($$012271389) + 1)|0; //@line 116853 "c/sqlite3.c"
                $$01203 = HEAP32[$674>>2]|0;
                $676 = ($$01203|0)==(0|0); //@line 116853 "c/sqlite3.c"
                if ($676) {
                 break;
                } else {
                 $$012031390 = $$01203;$$012271389 = $675;
                }
               }
              }
              $677 = HEAP32[$8>>2]|0; //@line 116858 "c/sqlite3.c"
              (_sqlite3VdbeAddOp2($12,37,$677,0)|0); //@line 116858 "c/sqlite3.c"
              $678 = (_sqlite3VdbeAddOp2($12,80,7,1)|0); //@line 116859 "c/sqlite3.c"
              $679 = ((($662)) + 42|0); //@line 116861 "c/sqlite3.c"
              $680 = HEAP16[$679>>1]|0; //@line 116861 "c/sqlite3.c"
              $681 = ($680<<16>>16)>(0); //@line 116861 "c/sqlite3.c"
              if ($681) {
               $682 = ((($662)) + 40|0);
               $683 = ((($662)) + 4|0);
               $$112281394 = 0;
               while(1) {
                $684 = HEAP16[$682>>1]|0; //@line 116864 "c/sqlite3.c"
                $685 = $684 << 16 >> 16; //@line 116864 "c/sqlite3.c"
                $686 = ($$112281394|0)==($685|0); //@line 116864 "c/sqlite3.c"
                do {
                 if (!($686)) {
                  $687 = HEAP32[$683>>2]|0; //@line 116865 "c/sqlite3.c"
                  $688 = (((($687) + ($$112281394<<4)|0)) + 12|0); //@line 116865 "c/sqlite3.c"
                  $689 = HEAP8[$688>>0]|0; //@line 116865 "c/sqlite3.c"
                  $690 = ($689<<24>>24)==(0); //@line 116865 "c/sqlite3.c"
                  if ($690) {
                   break;
                  }
                  $691 = HEAP32[$8>>2]|0; //@line 116866 "c/sqlite3.c"
                  _sqlite3ExprCodeGetColumnOfTable($12,$662,$691,$$112281394,3); //@line 116866 "c/sqlite3.c"
                  _sqlite3VdbeChangeP5($12,128); //@line 116867 "c/sqlite3.c"
                  $692 = (_sqlite3VdbeAddOp1($12,51,3)|0); //@line 116868 "c/sqlite3.c"
                  $693 = HEAP32[$662>>2]|0; //@line 116869 "c/sqlite3.c"
                  $694 = HEAP32[$683>>2]|0; //@line 116870 "c/sqlite3.c"
                  $695 = (($694) + ($$112281394<<4)|0); //@line 116870 "c/sqlite3.c"
                  $696 = HEAP32[$695>>2]|0; //@line 116870 "c/sqlite3.c"
                  HEAP32[$vararg_buffer62>>2] = $693; //@line 116869 "c/sqlite3.c"
                  $vararg_ptr65 = ((($vararg_buffer62)) + 4|0); //@line 116869 "c/sqlite3.c"
                  HEAP32[$vararg_ptr65>>2] = $696; //@line 116869 "c/sqlite3.c"
                  $697 = (_sqlite3MPrintf($11,26130,$vararg_buffer62)|0); //@line 116869 "c/sqlite3.c"
                  (_sqlite3VdbeAddOp4($12,97,0,3,0,$697,-7)|0); //@line 116871 "c/sqlite3.c"
                  (_integrityCheckResultRow($12)|0); //@line 116872 "c/sqlite3.c"
                  _sqlite3VdbeJumpHere($12,$692); //@line 116873 "c/sqlite3.c"
                 }
                } while(0);
                $698 = (($$112281394) + 1)|0; //@line 116861 "c/sqlite3.c"
                $699 = HEAP16[$679>>1]|0; //@line 116861 "c/sqlite3.c"
                $700 = $699 << 16 >> 16; //@line 116861 "c/sqlite3.c"
                $701 = ($698|0)<($700|0); //@line 116861 "c/sqlite3.c"
                if ($701) {
                 $$112281394 = $698;
                } else {
                 break;
                }
               }
              }
              $702 = ((($662)) + 24|0); //@line 116876 "c/sqlite3.c"
              $703 = HEAP32[$702>>2]|0; //@line 116876 "c/sqlite3.c"
              $704 = ($703|0)==(0|0); //@line 116876 "c/sqlite3.c"
              do {
               if (!($704)) {
                $705 = HEAP32[$603>>2]|0; //@line 116876 "c/sqlite3.c"
                $706 = $705 & 512; //@line 116876 "c/sqlite3.c"
                $707 = ($706|0)==(0); //@line 116876 "c/sqlite3.c"
                if (!($707)) {
                 break;
                }
                $708 = (_sqlite3ExprListDup($11,$703,0)|0); //@line 116877 "c/sqlite3.c"
                $709 = HEAP8[$604>>0]|0; //@line 116878 "c/sqlite3.c"
                $710 = ($709<<24>>24)==(0); //@line 116878 "c/sqlite3.c"
                if ($710) {
                 $711 = (_sqlite3VdbeMakeLabel($12)|0); //@line 116879 "c/sqlite3.c"
                 $712 = (_sqlite3VdbeMakeLabel($12)|0); //@line 116880 "c/sqlite3.c"
                 $713 = HEAP32[$8>>2]|0; //@line 116883 "c/sqlite3.c"
                 $714 = (($713) + 1)|0; //@line 116883 "c/sqlite3.c"
                 HEAP32[$605>>2] = $714; //@line 116883 "c/sqlite3.c"
                 _sqlite3ExprCachePush($0); //@line 116884 "c/sqlite3.c"
                 $715 = HEAP32[$708>>2]|0; //@line 116885 "c/sqlite3.c"
                 $716 = ($715|0)>(1); //@line 116885 "c/sqlite3.c"
                 if ($716) {
                  $$011901400$in = $715;
                  while(1) {
                   $$011901400 = (($$011901400$in) + -1)|0;
                   $717 = (((($708)) + 4|0) + (($$011901400*20)|0)|0); //@line 116886 "c/sqlite3.c"
                   $718 = HEAP32[$717>>2]|0; //@line 116886 "c/sqlite3.c"
                   _sqlite3ExprIfFalse($0,$718,$711,0); //@line 116886 "c/sqlite3.c"
                   $719 = ($$011901400$in|0)>(2); //@line 116885 "c/sqlite3.c"
                   if ($719) {
                    $$011901400$in = $$011901400;
                   } else {
                    break;
                   }
                  }
                 }
                 $720 = ((($708)) + 4|0); //@line 116888 "c/sqlite3.c"
                 $721 = HEAP32[$720>>2]|0; //@line 116888 "c/sqlite3.c"
                 _sqlite3ExprIfTrue($0,$721,$712,16); //@line 116888 "c/sqlite3.c"
                 _sqlite3VdbeResolveLabel($12,$711); //@line 116890 "c/sqlite3.c"
                 HEAP32[$605>>2] = 0; //@line 116891 "c/sqlite3.c"
                 $722 = HEAP32[$662>>2]|0; //@line 116893 "c/sqlite3.c"
                 HEAP32[$vararg_buffer66>>2] = $722; //@line 116892 "c/sqlite3.c"
                 $723 = (_sqlite3MPrintf($11,26150,$vararg_buffer66)|0); //@line 116892 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp4($12,97,0,3,0,$723,-7)|0); //@line 116894 "c/sqlite3.c"
                 (_integrityCheckResultRow($12)|0); //@line 116895 "c/sqlite3.c"
                 _sqlite3VdbeResolveLabel($12,$712); //@line 116896 "c/sqlite3.c"
                 _sqlite3ExprCachePop($0); //@line 116897 "c/sqlite3.c"
                }
                _sqlite3ExprListDelete($11,$708); //@line 116899 "c/sqlite3.c"
               }
              } while(0);
              $724 = HEAP32[$8>>2]|0;
              if ($591) {
               (_sqlite3VdbeAddOp2($12,7,$724,$678)|0); //@line 116952 "c/sqlite3.c"
               $790 = (($678) + -1)|0; //@line 116953 "c/sqlite3.c"
               _sqlite3VdbeJumpHere($12,$790); //@line 116953 "c/sqlite3.c"
               break;
              }
              $725 = HEAP16[$679>>1]|0; //@line 116903 "c/sqlite3.c"
              $726 = $725 << 16 >> 16; //@line 116903 "c/sqlite3.c"
              $727 = (($726) + -1)|0; //@line 116903 "c/sqlite3.c"
              (_sqlite3VdbeAddOp3($12,98,$724,$727,3)|0); //@line 116903 "c/sqlite3.c"
              _sqlite3VdbeChangeP5($12,128); //@line 116904 "c/sqlite3.c"
              $$112041410 = HEAP32[$671>>2]|0;
              $728 = ($$112041410|0)==(0|0); //@line 116906 "c/sqlite3.c"
              if (!($728)) {
               $729 = ((($662)) + 4|0);
               $$011971415 = -1;$$012001414 = 0;$$112041416 = $$112041410;$$212291411 = 0;
               while(1) {
                $730 = (_sqlite3VdbeMakeLabel($12)|0); //@line 116908 "c/sqlite3.c"
                $731 = ($732|0)==($$112041416|0); //@line 116909 "c/sqlite3.c"
                if ($731) {
                 $$11198 = $$011971415;$$11201 = $$012001414;
                } else {
                 $733 = HEAP32[$8>>2]|0; //@line 116910 "c/sqlite3.c"
                 $734 = (_sqlite3GenerateIndexKey($0,$$112041416,$733,0,0,$10,$$012001414,$$011971415)|0); //@line 116910 "c/sqlite3.c"
                 $735 = (($$212291411) + 8)|0; //@line 116913 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp2($12,80,$735,1)|0); //@line 116913 "c/sqlite3.c"
                 $736 = HEAP32[$9>>2]|0; //@line 116915 "c/sqlite3.c"
                 $737 = (($736) + ($$212291411))|0; //@line 116915 "c/sqlite3.c"
                 $738 = ((($$112041416)) + 52|0); //@line 116916 "c/sqlite3.c"
                 $739 = HEAP16[$738>>1]|0; //@line 116916 "c/sqlite3.c"
                 $740 = $739&65535; //@line 116916 "c/sqlite3.c"
                 $741 = (_sqlite3VdbeAddOp4Int($12,30,$737,$730,$734,$740)|0); //@line 116915 "c/sqlite3.c"
                 (_sqlite3VdbeLoadString($12,3,26180)|0); //@line 116917 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp3($12,93,7,3,3)|0); //@line 116918 "c/sqlite3.c"
                 (_sqlite3VdbeLoadString($12,4,26185)|0); //@line 116919 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp3($12,93,4,3,3)|0); //@line 116920 "c/sqlite3.c"
                 $742 = HEAP32[$$112041416>>2]|0; //@line 116921 "c/sqlite3.c"
                 $743 = (_sqlite3VdbeLoadString($12,4,$742)|0); //@line 116921 "c/sqlite3.c"
                 (_sqlite3VdbeAddOp3($12,93,4,3,3)|0); //@line 116922 "c/sqlite3.c"
                 $744 = (_integrityCheckResultRow($12)|0); //@line 116923 "c/sqlite3.c"
                 _sqlite3VdbeJumpHere($12,$741); //@line 116924 "c/sqlite3.c"
                 $745 = ((($$112041416)) + 54|0); //@line 116928 "c/sqlite3.c"
                 $746 = HEAP8[$745>>0]|0; //@line 116928 "c/sqlite3.c"
                 $747 = ($746<<24>>24)==(0); //@line 116928 "c/sqlite3.c"
                 if (!($747)) {
                  $748 = (_sqlite3VdbeMakeLabel($12)|0); //@line 116929 "c/sqlite3.c"
                  $749 = ((($$112041416)) + 50|0); //@line 116932 "c/sqlite3.c"
                  $750 = HEAP16[$749>>1]|0; //@line 116932 "c/sqlite3.c"
                  $751 = ($750<<16>>16)==(0); //@line 116932 "c/sqlite3.c"
                  if (!($751)) {
                   $752 = ((($$112041416)) + 4|0);
                   $$011811404 = 0;
                   while(1) {
                    $753 = HEAP32[$752>>2]|0; //@line 116933 "c/sqlite3.c"
                    $754 = (($753) + ($$011811404<<1)|0); //@line 116933 "c/sqlite3.c"
                    $755 = HEAP16[$754>>1]|0; //@line 116933 "c/sqlite3.c"
                    $756 = ($755<<16>>16)>(-1); //@line 116935 "c/sqlite3.c"
                    if ($756) {
                     $757 = $755 << 16 >> 16; //@line 116933 "c/sqlite3.c"
                     $758 = HEAP32[$729>>2]|0; //@line 116935 "c/sqlite3.c"
                     $759 = (((($758) + ($757<<4)|0)) + 12|0); //@line 116935 "c/sqlite3.c"
                     $760 = HEAP8[$759>>0]|0; //@line 116935 "c/sqlite3.c"
                     $761 = ($760<<24>>24)==(0); //@line 116935 "c/sqlite3.c"
                     if ($761) {
                      label = 255;
                     }
                    } else {
                     label = 255;
                    }
                    if ((label|0) == 255) {
                     label = 0;
                     $762 = (($$011811404) + ($734))|0; //@line 116936 "c/sqlite3.c"
                     (_sqlite3VdbeAddOp2($12,50,$762,$748)|0); //@line 116936 "c/sqlite3.c"
                    }
                    $763 = (($$011811404) + 1)|0; //@line 116932 "c/sqlite3.c"
                    $764 = HEAP16[$749>>1]|0; //@line 116932 "c/sqlite3.c"
                    $765 = $764&65535; //@line 116932 "c/sqlite3.c"
                    $766 = ($763>>>0)<($765>>>0); //@line 116932 "c/sqlite3.c"
                    if ($766) {
                     $$011811404 = $763;
                    } else {
                     break;
                    }
                   }
                  }
                  $767 = HEAP32[$9>>2]|0; //@line 116939 "c/sqlite3.c"
                  $768 = (($767) + ($$212291411))|0; //@line 116939 "c/sqlite3.c"
                  $769 = (_sqlite3VdbeAddOp1($12,7,$768)|0); //@line 116939 "c/sqlite3.c"
                  _sqlite3VdbeGoto($12,$748); //@line 116940 "c/sqlite3.c"
                  _sqlite3VdbeJumpHere($12,$769); //@line 116941 "c/sqlite3.c"
                  $770 = HEAP32[$9>>2]|0; //@line 116942 "c/sqlite3.c"
                  $771 = (($770) + ($$212291411))|0; //@line 116942 "c/sqlite3.c"
                  $772 = HEAP16[$749>>1]|0; //@line 116943 "c/sqlite3.c"
                  $773 = $772&65535; //@line 116943 "c/sqlite3.c"
                  (_sqlite3VdbeAddOp4Int($12,39,$771,$748,$734,$773)|0); //@line 116942 "c/sqlite3.c"
                  (_sqlite3VdbeLoadString($12,3,26206)|0); //@line 116944 "c/sqlite3.c"
                  _sqlite3VdbeGoto($12,$743); //@line 116945 "c/sqlite3.c"
                  _sqlite3VdbeResolveLabel($12,$748); //@line 116946 "c/sqlite3.c"
                 }
                 _sqlite3VdbeJumpHere($12,$744); //@line 116948 "c/sqlite3.c"
                 $774 = HEAP32[$10>>2]|0; //@line 116949 "c/sqlite3.c"
                 _sqlite3ResolvePartIdxLabel($0,$774); //@line 116949 "c/sqlite3.c"
                 $$11198 = $734;$$11201 = $$112041416;
                }
                $775 = ((($$112041416)) + 20|0); //@line 116906 "c/sqlite3.c"
                $776 = (($$212291411) + 1)|0; //@line 116906 "c/sqlite3.c"
                $$11204 = HEAP32[$775>>2]|0;
                $777 = ($$11204|0)==(0|0); //@line 116906 "c/sqlite3.c"
                if ($777) {
                 break;
                } else {
                 $$011971415 = $$11198;$$012001414 = $$11201;$$112041416 = $$11204;$$212291411 = $776;
                }
               }
              }
              $778 = HEAP32[$8>>2]|0; //@line 116952 "c/sqlite3.c"
              (_sqlite3VdbeAddOp2($12,7,$778,$678)|0); //@line 116952 "c/sqlite3.c"
              $779 = (($678) + -1)|0; //@line 116953 "c/sqlite3.c"
              _sqlite3VdbeJumpHere($12,$779); //@line 116953 "c/sqlite3.c"
              (_sqlite3VdbeLoadString($12,2,26233)|0); //@line 116956 "c/sqlite3.c"
              $$212051421 = HEAP32[$671>>2]|0;
              $780 = ($$212051421|0)==(0|0); //@line 116957 "c/sqlite3.c"
              if ($780) {
               break;
              }
              $$212051423 = $$212051421;$$312301422 = 0;
              while(1) {
               $781 = ($732|0)==($$212051423|0); //@line 116958 "c/sqlite3.c"
               if (!($781)) {
                $782 = HEAP32[$9>>2]|0; //@line 116959 "c/sqlite3.c"
                $783 = (($782) + ($$312301422))|0; //@line 116959 "c/sqlite3.c"
                (_sqlite3VdbeAddOp2($12,101,$783,3)|0); //@line 116959 "c/sqlite3.c"
                $784 = (($$312301422) + 8)|0; //@line 116960 "c/sqlite3.c"
                $785 = (_sqlite3VdbeAddOp3($12,53,$784,0,3)|0); //@line 116960 "c/sqlite3.c"
                _sqlite3VdbeChangeP5($12,144); //@line 116961 "c/sqlite3.c"
                $786 = HEAP32[$$212051423>>2]|0; //@line 116962 "c/sqlite3.c"
                (_sqlite3VdbeLoadString($12,4,$786)|0); //@line 116962 "c/sqlite3.c"
                (_sqlite3VdbeAddOp3($12,93,4,2,3)|0); //@line 116963 "c/sqlite3.c"
                (_integrityCheckResultRow($12)|0); //@line 116964 "c/sqlite3.c"
                _sqlite3VdbeJumpHere($12,$785); //@line 116965 "c/sqlite3.c"
               }
               $787 = ((($$212051423)) + 20|0); //@line 116957 "c/sqlite3.c"
               $788 = (($$312301422) + 1)|0; //@line 116957 "c/sqlite3.c"
               $$21205 = HEAP32[$787>>2]|0;
               $789 = ($$21205|0)==(0|0); //@line 116957 "c/sqlite3.c"
               if ($789) {
                break;
               } else {
                $$212051423 = $$21205;$$312301422 = $788;
               }
              }
             }
            } while(0);
            $$21224 = HEAP32[$$212241427>>2]|0;
            $791 = ($$21224|0)==(0|0); //@line 116836 "c/sqlite3.c"
            if ($791) {
             break;
            } else {
             $$212241427 = $$21224;
            }
           }
          }
         } while(0);
         $792 = (($$012311430) + 1)|0; //@line 116780 "c/sqlite3.c"
         $793 = HEAP32[$599>>2]|0; //@line 116780 "c/sqlite3.c"
         $794 = ($792|0)<($793|0); //@line 116780 "c/sqlite3.c"
         if ($794) {
          $$012311430 = $792;
         } else {
          break;
         }
        }
       }
      } while(0);
      $795 = (_sqlite3VdbeAddOpList($12,7,26262)|0); //@line 116984 "c/sqlite3.c"
      $796 = ($795|0)==(0|0); //@line 116985 "c/sqlite3.c"
      if (!($796)) {
       $797 = (1 - ($597))|0; //@line 116986 "c/sqlite3.c"
       $798 = ((($795)) + 8|0); //@line 116986 "c/sqlite3.c"
       HEAP32[$798>>2] = $797; //@line 116986 "c/sqlite3.c"
       $799 = ((($795)) + 41|0); //@line 116987 "c/sqlite3.c"
       HEAP8[$799>>0] = -1; //@line 116987 "c/sqlite3.c"
       $800 = ((($795)) + 56|0); //@line 116988 "c/sqlite3.c"
       HEAP32[$800>>2] = 26290; //@line 116988 "c/sqlite3.c"
       $801 = ((($795)) + 101|0); //@line 116989 "c/sqlite3.c"
       HEAP8[$801>>0] = -1; //@line 116989 "c/sqlite3.c"
       $802 = (_sqlite3ErrStr(11)|0); //@line 116990 "c/sqlite3.c"
       $803 = ((($795)) + 116|0); //@line 116990 "c/sqlite3.c"
       HEAP32[$803>>2] = $802; //@line 116990 "c/sqlite3.c"
      }
      $804 = (_sqlite3VdbeCurrentAddr($12)|0); //@line 116992 "c/sqlite3.c"
      $805 = (($804) + -2)|0; //@line 116992 "c/sqlite3.c"
      _sqlite3VdbeChangeP3($12,0,$805); //@line 116992 "c/sqlite3.c"
      break L21;
      break;
     }
     case 12:  {
      $806 = ($$01162|0)==(0|0); //@line 117037 "c/sqlite3.c"
      if ($806) {
       $807 = (_sqlite3ReadSchema($0)|0); //@line 117038 "c/sqlite3.c"
       $808 = ($807|0)==(0); //@line 117038 "c/sqlite3.c"
       if (!($808)) {
        break L21;
       }
       $809 = HEAP32[$0>>2]|0; //@line 117042 "c/sqlite3.c"
       $810 = ((($809)) + 70|0); //@line 117042 "c/sqlite3.c"
       $811 = HEAP8[$810>>0]|0; //@line 117042 "c/sqlite3.c"
       $812 = $811&255; //@line 117042 "c/sqlite3.c"
       $813 = (6232 + ($812<<3)|0); //@line 117042 "c/sqlite3.c"
       $814 = HEAP32[$813>>2]|0; //@line 117042 "c/sqlite3.c"
       _returnSingleText($12,$814); //@line 117042 "c/sqlite3.c"
       break L21;
      }
      $815 = HEAP32[$17>>2]|0; //@line 117050 "c/sqlite3.c"
      $816 = ((($815)) + 12|0); //@line 117050 "c/sqlite3.c"
      $817 = HEAP32[$816>>2]|0; //@line 117050 "c/sqlite3.c"
      $818 = ((($817)) + 78|0); //@line 117050 "c/sqlite3.c"
      $819 = HEAP16[$818>>1]|0; //@line 117050 "c/sqlite3.c"
      $820 = $819 & 5; //@line 117050 "c/sqlite3.c"
      $821 = ($820<<16>>16)==(1); //@line 117050 "c/sqlite3.c"
      if ($821) {
       break L21;
      }
      $822 = (_sqlite3StrICmp($$01162,26293)|0); //@line 117054 "c/sqlite3.c"
      $823 = ($822|0)==(0); //@line 117054 "c/sqlite3.c"
      do {
       if ($823) {
        $$011761435$lcssa = 6232;
       } else {
        $824 = (_sqlite3StrICmp($$01162,26298)|0); //@line 117054 "c/sqlite3.c"
        $825 = ($824|0)==(0); //@line 117054 "c/sqlite3.c"
        if ($825) {
         $$011761435$lcssa = (6240);
        } else {
         $965 = (_sqlite3StrICmp($$01162,26364)|0); //@line 117054 "c/sqlite3.c"
         $966 = ($965|0)==(0); //@line 117054 "c/sqlite3.c"
         if ($966) {
          $$011761435$lcssa = (6248);
         } else {
          $967 = (_sqlite3StrICmp($$01162,26373)|0); //@line 117054 "c/sqlite3.c"
          $968 = ($967|0)==(0); //@line 117054 "c/sqlite3.c"
          if ($968) {
           $$011761435$lcssa = (6256);
          } else {
           $969 = (_sqlite3StrICmp($$01162,26382)|0); //@line 117054 "c/sqlite3.c"
           $970 = ($969|0)==(0); //@line 117054 "c/sqlite3.c"
           if ($970) {
            $$011761435$lcssa = (6264);
            break;
           }
           $971 = (_sqlite3StrICmp($$01162,26390)|0); //@line 117054 "c/sqlite3.c"
           $972 = ($971|0)==(0); //@line 117054 "c/sqlite3.c"
           if ($972) {
            $$011761435$lcssa = (6272);
            break;
           }
           $973 = (_sqlite3StrICmp($$01162,26398)|0); //@line 117054 "c/sqlite3.c"
           $974 = ($973|0)==(0); //@line 117054 "c/sqlite3.c"
           if ($974) {
            $$011761435$lcssa = (6280);
            break;
           }
           $975 = (_sqlite3StrICmp($$01162,26405)|0); //@line 117054 "c/sqlite3.c"
           $976 = ($975|0)==(0); //@line 117054 "c/sqlite3.c"
           if ($976) {
            $$011761435$lcssa = (6288);
            break;
           }
           HEAP32[$vararg_buffer73>>2] = $$01162; //@line 117061 "c/sqlite3.c"
           _sqlite3ErrorMsg($0,26411,$vararg_buffer73); //@line 117061 "c/sqlite3.c"
           break L21;
          }
         }
        }
       }
      } while(0);
      $826 = ((($$011761435$lcssa)) + 4|0); //@line 117056 "c/sqlite3.c"
      $827 = HEAP8[$826>>0]|0; //@line 117056 "c/sqlite3.c"
      $828 = ($827<<24>>24)==(0); //@line 117056 "c/sqlite3.c"
      $$1253 = $828 ? 2 : $827; //@line 117056 "c/sqlite3.c"
      $829 = ((($11)) + 70|0); //@line 117055 "c/sqlite3.c"
      HEAP8[$829>>0] = $$1253; //@line 117055 "c/sqlite3.c"
      $830 = ((($817)) + 77|0); //@line 117055 "c/sqlite3.c"
      HEAP8[$830>>0] = $$1253; //@line 117055 "c/sqlite3.c"
      break L21;
      break;
     }
     case 0:  {
      $831 = ((($51)) + 8|0); //@line 117103 "c/sqlite3.c"
      $832 = HEAP32[$831>>2]|0; //@line 117103 "c/sqlite3.c"
      _sqlite3VdbeUsesBtree($12,$15); //@line 117104 "c/sqlite3.c"
      $833 = ($$01162|0)==(0|0); //@line 117105 "c/sqlite3.c"
      if (!($833)) {
       $834 = HEAP8[$53>>0]|0; //@line 117105 "c/sqlite3.c"
       $835 = $834 & 8; //@line 117105 "c/sqlite3.c"
       $836 = ($835<<24>>24)==(0); //@line 117105 "c/sqlite3.c"
       if ($836) {
        $837 = (_sqlite3VdbeAddOpList($12,2,26304)|0); //@line 117113 "c/sqlite3.c"
        $838 = ((($837)) + 4|0); //@line 117115 "c/sqlite3.c"
        HEAP32[$838>>2] = $15; //@line 117115 "c/sqlite3.c"
        $839 = ((($837)) + 24|0); //@line 117116 "c/sqlite3.c"
        HEAP32[$839>>2] = $15; //@line 117116 "c/sqlite3.c"
        $840 = ((($837)) + 28|0); //@line 117117 "c/sqlite3.c"
        HEAP32[$840>>2] = $832; //@line 117117 "c/sqlite3.c"
        $841 = (_sqlite3Atoi($$01162)|0); //@line 117118 "c/sqlite3.c"
        $842 = ((($837)) + 32|0); //@line 117118 "c/sqlite3.c"
        HEAP32[$842>>2] = $841; //@line 117118 "c/sqlite3.c"
        break L21;
       }
      }
      $843 = (_sqlite3VdbeAddOpList($12,3,26312)|0); //@line 117128 "c/sqlite3.c"
      $844 = ((($843)) + 4|0); //@line 117130 "c/sqlite3.c"
      HEAP32[$844>>2] = $15; //@line 117130 "c/sqlite3.c"
      $845 = ((($843)) + 24|0); //@line 117131 "c/sqlite3.c"
      HEAP32[$845>>2] = $15; //@line 117131 "c/sqlite3.c"
      $846 = ((($843)) + 32|0); //@line 117132 "c/sqlite3.c"
      HEAP32[$846>>2] = $832; //@line 117132 "c/sqlite3.c"
      _sqlite3VdbeReusable($12); //@line 117133 "c/sqlite3.c"
      break L21;
      break;
     }
     case 8:  {
      HEAP32[$14>>2] = 1; //@line 117149 "c/sqlite3.c"
      $847 = (_sqlite3_compileoption_get(0)|0); //@line 117150 "c/sqlite3.c"
      $848 = ($847|0)==(0|0); //@line 117150 "c/sqlite3.c"
      if (!($848)) {
       $$011731436 = 0;$850 = $847;
       while(1) {
        $849 = (($$011731436) + 1)|0; //@line 117150 "c/sqlite3.c"
        (_sqlite3VdbeLoadString($12,1,$850)|0); //@line 117151 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($12,78,1,1)|0); //@line 117152 "c/sqlite3.c"
        $851 = (_sqlite3_compileoption_get($849)|0); //@line 117150 "c/sqlite3.c"
        $852 = ($851|0)==(0|0); //@line 117150 "c/sqlite3.c"
        if ($852) {
         break;
        } else {
         $$011731436 = $849;$850 = $851;
        }
       }
      }
      _sqlite3VdbeReusable($12); //@line 117154 "c/sqlite3.c"
      break L21;
      break;
     }
     case 39:  {
      $853 = HEAP32[$2>>2]|0; //@line 117166 "c/sqlite3.c"
      $854 = ($853|0)==(0|0); //@line 117166 "c/sqlite3.c"
      $855 = $854 ? 10 : $15; //@line 117166 "c/sqlite3.c"
      $856 = ($$01162|0)==(0|0); //@line 117168 "c/sqlite3.c"
      if ($856) {
       $$01170 = 0;
      } else {
       $857 = (_sqlite3StrICmp($$01162,26324)|0); //@line 117169 "c/sqlite3.c"
       $858 = ($857|0)==(0); //@line 117169 "c/sqlite3.c"
       if ($858) {
        $$01170 = 1;
       } else {
        $859 = (_sqlite3StrICmp($$01162,26329)|0); //@line 117171 "c/sqlite3.c"
        $860 = ($859|0)==(0); //@line 117171 "c/sqlite3.c"
        if ($860) {
         $$01170 = 2;
        } else {
         $861 = (_sqlite3StrICmp($$01162,26337)|0); //@line 117173 "c/sqlite3.c"
         $862 = ($861|0)==(0); //@line 117173 "c/sqlite3.c"
         $spec$select1256 = $862 ? 3 : 0; //@line 117173 "c/sqlite3.c"
         $$01170 = $spec$select1256;
        }
       }
      }
      HEAP32[$14>>2] = 3; //@line 117177 "c/sqlite3.c"
      (_sqlite3VdbeAddOp3($12,8,$855,$$01170,1)|0); //@line 117178 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($12,78,1,3)|0); //@line 117179 "c/sqlite3.c"
      break L21;
      break;
     }
     case 38:  {
      $863 = ($$01162|0)==(0|0); //@line 117192 "c/sqlite3.c"
      if (!($863)) {
       $864 = (_sqlite3Atoi($$01162)|0); //@line 117193 "c/sqlite3.c"
       (_sqlite3_wal_autocheckpoint($11,$864)|0); //@line 117193 "c/sqlite3.c"
      }
      $865 = ((($11)) + 228|0); //@line 117196 "c/sqlite3.c"
      $866 = HEAP32[$865>>2]|0; //@line 117196 "c/sqlite3.c"
      $867 = ($866|0)==(87|0); //@line 117196 "c/sqlite3.c"
      if ($867) {
       $868 = ((($11)) + 232|0); //@line 117197 "c/sqlite3.c"
       $869 = HEAP32[$868>>2]|0; //@line 117197 "c/sqlite3.c"
       $870 = ($869|0)<(0); //@line 117196 "c/sqlite3.c"
       $871 = $870 << 31 >> 31; //@line 117196 "c/sqlite3.c"
       $872 = $869;$873 = $871;
      } else {
       $872 = 0;$873 = 0;
      }
      _returnSingleInt($12,$872,$873); //@line 117195 "c/sqlite3.c"
      break L21;
      break;
     }
     case 31:  {
      (_sqlite3_db_release_memory($11)|0); //@line 117210 "c/sqlite3.c"
      break L21;
      break;
     }
     case 27:  {
      $874 = ($$01162|0)==(0|0); //@line 117279 "c/sqlite3.c"
      if ($874) {
       $$0 = 65534;
      } else {
       $875 = (_sqlite3Atoi($$01162)|0); //@line 117280 "c/sqlite3.c"
       $876 = $875 & 2; //@line 117281 "c/sqlite3.c"
       $877 = ($876|0)==(0); //@line 117281 "c/sqlite3.c"
       if ($877) {
        break L21;
       } else {
        $$0 = $875;
       }
      }
      $878 = ((($0)) + 40|0); //@line 117285 "c/sqlite3.c"
      $879 = HEAP32[$878>>2]|0; //@line 117285 "c/sqlite3.c"
      $880 = (($879) + 1)|0; //@line 117285 "c/sqlite3.c"
      HEAP32[$878>>2] = $880; //@line 117285 "c/sqlite3.c"
      $881 = ($33|0)==(0|0); //@line 117286 "c/sqlite3.c"
      if ($881) {
       $882 = ((($11)) + 20|0); //@line 117286 "c/sqlite3.c"
       $883 = HEAP32[$882>>2]|0; //@line 117286 "c/sqlite3.c"
       $884 = (($883) + -1)|0; //@line 117286 "c/sqlite3.c"
       $886 = $884;
      } else {
       $886 = $15;
      }
      $885 = ($15|0)>($886|0); //@line 117286 "c/sqlite3.c"
      if (!($885)) {
       $887 = $$0 & 1;
       $888 = ($887|0)==(0);
       $889 = $$0 & 1;
       $890 = $889 | 2;
       $$21449 = $15;
       while(1) {
        $891 = ($$21449|0)==(1); //@line 117287 "c/sqlite3.c"
        do {
         if (!($891)) {
          _sqlite3CodeVerifySchema($0,$$21449); //@line 117288 "c/sqlite3.c"
          $892 = HEAP32[$17>>2]|0; //@line 117289 "c/sqlite3.c"
          $893 = (((($892) + ($$21449<<4)|0)) + 12|0); //@line 117289 "c/sqlite3.c"
          $894 = HEAP32[$893>>2]|0; //@line 117289 "c/sqlite3.c"
          $895 = ((($894)) + 16|0); //@line 117290 "c/sqlite3.c"
          $$011661445 = HEAP32[$895>>2]|0;
          $896 = ($$011661445|0)==(0|0); //@line 117290 "c/sqlite3.c"
          if ($896) {
           break;
          }
          $$011661446 = $$011661445;
          while(1) {
           $897 = ((($$011661446)) + 8|0); //@line 117291 "c/sqlite3.c"
           $898 = HEAP32[$897>>2]|0; //@line 117291 "c/sqlite3.c"
           $899 = ((($898)) + 36|0); //@line 117296 "c/sqlite3.c"
           $900 = HEAP32[$899>>2]|0; //@line 117296 "c/sqlite3.c"
           $901 = $900 & 256; //@line 117296 "c/sqlite3.c"
           $902 = ($901|0)==(0); //@line 117296 "c/sqlite3.c"
           do {
            if (!($902)) {
             $903 = ((($898)) + 44|0); //@line 117299 "c/sqlite3.c"
             $904 = HEAP16[$903>>1]|0; //@line 117299 "c/sqlite3.c"
             $905 = $904&65535; //@line 117299 "c/sqlite3.c"
             $906 = (($905) + 46)|0; //@line 117299 "c/sqlite3.c"
             $907 = $906&65535; //@line 117299 "c/sqlite3.c"
             $908 = ((($898)) + 8|0); //@line 117300 "c/sqlite3.c"
             $$011641440 = HEAP32[$908>>2]|0;
             $909 = ($$011641440|0)==(0|0); //@line 117300 "c/sqlite3.c"
             L454: do {
              if ($909) {
               label = 311;
              } else {
               $$011641441 = $$011641440;
               while(1) {
                $912 = ((($$011641441)) + 55|0); //@line 117301 "c/sqlite3.c"
                $913 = HEAPU8[$912>>0]|(HEAPU8[$912+1>>0]<<8); //@line 117301 "c/sqlite3.c"
                $914 = $913 & 128; //@line 117301 "c/sqlite3.c"
                $915 = ($914<<16>>16)==(0); //@line 117301 "c/sqlite3.c"
                if ($915) {
                 break L454;
                }
                $910 = ((($$011641441)) + 20|0); //@line 117300 "c/sqlite3.c"
                $$01164 = HEAP32[$910>>2]|0;
                $911 = ($$01164|0)==(0|0); //@line 117300 "c/sqlite3.c"
                if ($911) {
                 label = 311;
                 break;
                } else {
                 $$011641441 = $$01164;
                }
               }
              }
             } while(0);
             do {
              if ((label|0) == 311) {
               label = 0;
               $916 = ($907<<16>>16)==(0); //@line 117306 "c/sqlite3.c"
               if ($916) {
                break;
               }
               _sqlite3OpenTable($0,$879,$$21449,$898,105); //@line 117307 "c/sqlite3.c"
               $917 = (_sqlite3VdbeCurrentAddr($12)|0); //@line 117309 "c/sqlite3.c"
               $918 = (($890) + ($917))|0; //@line 117309 "c/sqlite3.c"
               $sext = $906 << 16; //@line 117309 "c/sqlite3.c"
               $919 = $sext >> 16; //@line 117309 "c/sqlite3.c"
               (_sqlite3VdbeAddOp3($12,34,$879,$918,$919)|0); //@line 117308 "c/sqlite3.c"
              }
             } while(0);
             $920 = HEAP32[$17>>2]|0; //@line 117313 "c/sqlite3.c"
             $921 = (($920) + ($$21449<<4)|0); //@line 117313 "c/sqlite3.c"
             $922 = HEAP32[$921>>2]|0; //@line 117313 "c/sqlite3.c"
             $923 = HEAP32[$898>>2]|0; //@line 117313 "c/sqlite3.c"
             HEAP32[$vararg_buffer69>>2] = $922; //@line 117312 "c/sqlite3.c"
             $vararg_ptr72 = ((($vararg_buffer69)) + 4|0); //@line 117312 "c/sqlite3.c"
             HEAP32[$vararg_ptr72>>2] = $923; //@line 117312 "c/sqlite3.c"
             $924 = (_sqlite3MPrintf($11,26346,$vararg_buffer69)|0); //@line 117312 "c/sqlite3.c"
             if ($888) {
              (_sqlite3VdbeAddOp4($12,137,0,0,0,$924,-7)|0); //@line 117319 "c/sqlite3.c"
              break;
             } else {
              $925 = (_sqlite3GetTempReg($0)|0); //@line 117315 "c/sqlite3.c"
              (_sqlite3VdbeAddOp4($12,97,0,$925,0,$924,-7)|0); //@line 117316 "c/sqlite3.c"
              (_sqlite3VdbeAddOp2($12,78,$925,1)|0); //@line 117317 "c/sqlite3.c"
              break;
             }
            }
           } while(0);
           $$01166 = HEAP32[$$011661446>>2]|0;
           $926 = ($$01166|0)==(0|0); //@line 117290 "c/sqlite3.c"
           if ($926) {
            break;
           } else {
            $$011661446 = $$01166;
           }
          }
         }
        } while(0);
        $927 = (($$21449) + 1)|0; //@line 117286 "c/sqlite3.c"
        $928 = ($$21449|0)<($886|0); //@line 117286 "c/sqlite3.c"
        if ($928) {
         $$21449 = $927;
        } else {
         break;
        }
       }
      }
      (_sqlite3VdbeAddOp0($12,152)|0); //@line 117323 "c/sqlite3.c"
      break L21;
      break;
     }
     case 32:  {
      $935 = ($$01162|0)==(0|0); //@line 117358 "c/sqlite3.c"
      if (!($935)) {
       $936 = (_sqlite3DecOrHexToI64($$01162,$7)|0); //@line 117358 "c/sqlite3.c"
       $937 = ($936|0)==(0); //@line 117358 "c/sqlite3.c"
       if ($937) {
        $938 = $7; //@line 117359 "c/sqlite3.c"
        $939 = $938; //@line 117359 "c/sqlite3.c"
        $940 = HEAP32[$939>>2]|0; //@line 117359 "c/sqlite3.c"
        $941 = (($938) + 4)|0; //@line 117359 "c/sqlite3.c"
        $942 = $941; //@line 117359 "c/sqlite3.c"
        $943 = HEAP32[$942>>2]|0; //@line 117359 "c/sqlite3.c"
        (_sqlite3_soft_heap_limit64($940,$943)|0); //@line 117359 "c/sqlite3.c"
        $944 = tempRet0; //@line 117359 "c/sqlite3.c"
       }
      }
      $945 = (_sqlite3_soft_heap_limit64(-1,-1)|0); //@line 117361 "c/sqlite3.c"
      $946 = tempRet0; //@line 117361 "c/sqlite3.c"
      _returnSingleInt($12,$945,$946); //@line 117361 "c/sqlite3.c"
      break L21;
      break;
     }
     case 37:  {
      $947 = ($$01162|0)==(0|0); //@line 117374 "c/sqlite3.c"
      if (!($947)) {
       $948 = (_sqlite3DecOrHexToI64($$01162,$7)|0); //@line 117375 "c/sqlite3.c"
       $949 = ($948|0)==(0); //@line 117375 "c/sqlite3.c"
       $950 = $7; //@line 117376 "c/sqlite3.c"
       $951 = $950; //@line 117376 "c/sqlite3.c"
       $952 = HEAP32[$951>>2]|0; //@line 117376 "c/sqlite3.c"
       $953 = (($950) + 4)|0; //@line 117376 "c/sqlite3.c"
       $954 = $953; //@line 117376 "c/sqlite3.c"
       $955 = HEAP32[$954>>2]|0; //@line 117376 "c/sqlite3.c"
       $956 = ($955|0)>(-1); //@line 117376 "c/sqlite3.c"
       $957 = ($952>>>0)>(4294967295); //@line 117376 "c/sqlite3.c"
       $958 = ($955|0)==(-1); //@line 117376 "c/sqlite3.c"
       $959 = $958 & $957; //@line 117376 "c/sqlite3.c"
       $960 = $956 | $959; //@line 117376 "c/sqlite3.c"
       $or$cond16 = $949 & $960; //@line 117376 "c/sqlite3.c"
       if ($or$cond16) {
        $961 = $952 & 2147483647; //@line 117378 "c/sqlite3.c"
        (_sqlite3_limit($11,11,$961)|0); //@line 117378 "c/sqlite3.c"
       }
      }
      $962 = (_sqlite3_limit($11,11,-1)|0); //@line 117380 "c/sqlite3.c"
      $963 = ($962|0)<(0); //@line 117380 "c/sqlite3.c"
      $964 = $963 << 31 >> 31; //@line 117380 "c/sqlite3.c"
      _returnSingleInt($12,$962,$964); //@line 117380 "c/sqlite3.c"
      break L21;
      break;
     }
     default: {
      $929 = ($$01162|0)==(0|0); //@line 117338 "c/sqlite3.c"
      if (!($929)) {
       $930 = (_sqlite3Atoi($$01162)|0); //@line 117339 "c/sqlite3.c"
       (_sqlite3_busy_timeout($11,$930)|0); //@line 117339 "c/sqlite3.c"
      }
      $931 = ((($11)) + 436|0); //@line 117341 "c/sqlite3.c"
      $932 = HEAP32[$931>>2]|0; //@line 117341 "c/sqlite3.c"
      $933 = ($932|0)<(0); //@line 117341 "c/sqlite3.c"
      $934 = $933 << 31 >> 31; //@line 117341 "c/sqlite3.c"
      _returnSingleInt($12,$932,$934); //@line 117341 "c/sqlite3.c"
      break L21;
     }
     }
    } while(0);
    break;
   }
   default: {
    $44 = HEAP32[$6>>2]|0; //@line 115701 "c/sqlite3.c"
    $45 = ($44|0)==(0|0); //@line 115701 "c/sqlite3.c"
    if (!($45)) {
     HEAP32[$vararg_buffer1>>2] = $44; //@line 115702 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,15687,$vararg_buffer1); //@line 115702 "c/sqlite3.c"
     $46 = HEAP32[$6>>2]|0; //@line 115703 "c/sqlite3.c"
     _sqlite3_free($46); //@line 115703 "c/sqlite3.c"
    }
    $47 = ((($0)) + 36|0); //@line 115705 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 115705 "c/sqlite3.c"
    $49 = (($48) + 1)|0; //@line 115705 "c/sqlite3.c"
    HEAP32[$47>>2] = $49; //@line 115705 "c/sqlite3.c"
    $50 = ((($0)) + 12|0); //@line 115706 "c/sqlite3.c"
    HEAP32[$50>>2] = $40; //@line 115706 "c/sqlite3.c"
    break L21;
   }
   }
  }
 } while(0);
 _sqlite3DbFree($11,$23); //@line 117467 "c/sqlite3.c"
 _sqlite3DbFree($11,$$01162); //@line 117468 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 117469 "c/sqlite3.c"
}
function _sqlite3FinishTrigger($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$079 = 0, $$081 = 0, $$1 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer5 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer5 = sp + 24|0;
 $vararg_buffer = sp;
 $3 = sp + 40|0;
 $4 = sp + 32|0;
 $5 = ((($0)) + 436|0); //@line 125212 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 125212 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 125214 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 125219 "c/sqlite3.c"
 $8 = ((($0)) + 36|0); //@line 125220 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 125220 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 125220 "c/sqlite3.c"
 $11 = ($6|0)!=(0|0); //@line 125220 "c/sqlite3.c"
 $or$cond = $11 & $10; //@line 125220 "c/sqlite3.c"
 do {
  if ($or$cond) {
   $12 = HEAP32[$6>>2]|0; //@line 125221 "c/sqlite3.c"
   $13 = ((($6)) + 20|0); //@line 125222 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 125222 "c/sqlite3.c"
   $15 = (_sqlite3SchemaToIndex($7,$14)|0); //@line 125222 "c/sqlite3.c"
   $16 = ((($6)) + 28|0); //@line 125223 "c/sqlite3.c"
   HEAP32[$16>>2] = $1; //@line 125223 "c/sqlite3.c"
   $17 = ($1|0)==(0|0); //@line 125224 "c/sqlite3.c"
   if (!($17)) {
    $$081 = $1;
    while(1) {
     $18 = ((($$081)) + 4|0); //@line 125225 "c/sqlite3.c"
     HEAP32[$18>>2] = $6; //@line 125225 "c/sqlite3.c"
     $19 = ((($$081)) + 32|0); //@line 125226 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 125226 "c/sqlite3.c"
     $21 = ($20|0)==(0|0); //@line 125224 "c/sqlite3.c"
     if ($21) {
      break;
     } else {
      $$081 = $20;
     }
    }
   }
   _sqlite3TokenInit($4,$12); //@line 125228 "c/sqlite3.c"
   _sqlite3FixInit($3,$0,$15,25526,$4); //@line 125229 "c/sqlite3.c"
   $22 = HEAP32[$16>>2]|0; //@line 125230 "c/sqlite3.c"
   $23 = (_sqlite3FixTriggerStep($3,$22)|0); //@line 125230 "c/sqlite3.c"
   $24 = ($23|0)==(0); //@line 125230 "c/sqlite3.c"
   if ($24) {
    $25 = ((($6)) + 12|0); //@line 125231 "c/sqlite3.c"
    $26 = HEAP32[$25>>2]|0; //@line 125231 "c/sqlite3.c"
    $27 = (_sqlite3FixExpr($3,$26)|0); //@line 125231 "c/sqlite3.c"
    $28 = ($27|0)==(0); //@line 125231 "c/sqlite3.c"
    if ($28) {
     $29 = ((($7)) + 157|0); //@line 125239 "c/sqlite3.c"
     $30 = HEAP8[$29>>0]|0; //@line 125239 "c/sqlite3.c"
     $31 = ($30<<24>>24)==(0); //@line 125239 "c/sqlite3.c"
     if ($31) {
      $32 = (_sqlite3GetVdbe($0)|0); //@line 125244 "c/sqlite3.c"
      $33 = ($32|0)==(0|0); //@line 125245 "c/sqlite3.c"
      if ($33) {
       $$079 = $6;$$1 = 0;
       break;
      }
      _sqlite3BeginWriteOperation($0,0,$15); //@line 125246 "c/sqlite3.c"
      $34 = HEAP32[$2>>2]|0; //@line 125247 "c/sqlite3.c"
      $35 = ((($2)) + 4|0); //@line 125247 "c/sqlite3.c"
      $36 = HEAP32[$35>>2]|0; //@line 125247 "c/sqlite3.c"
      $37 = (_sqlite3DbStrNDup($7,$34,$36,0)|0); //@line 125247 "c/sqlite3.c"
      $38 = ((($7)) + 16|0); //@line 125251 "c/sqlite3.c"
      $39 = HEAP32[$38>>2]|0; //@line 125251 "c/sqlite3.c"
      $40 = (($39) + ($15<<4)|0); //@line 125251 "c/sqlite3.c"
      $41 = HEAP32[$40>>2]|0; //@line 125251 "c/sqlite3.c"
      $42 = ((($6)) + 4|0); //@line 125252 "c/sqlite3.c"
      $43 = HEAP32[$42>>2]|0; //@line 125252 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $41; //@line 125249 "c/sqlite3.c"
      $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 125249 "c/sqlite3.c"
      HEAP32[$vararg_ptr1>>2] = 19754; //@line 125249 "c/sqlite3.c"
      $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 125249 "c/sqlite3.c"
      HEAP32[$vararg_ptr2>>2] = $12; //@line 125249 "c/sqlite3.c"
      $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 125249 "c/sqlite3.c"
      HEAP32[$vararg_ptr3>>2] = $43; //@line 125249 "c/sqlite3.c"
      $vararg_ptr4 = ((($vararg_buffer)) + 16|0); //@line 125249 "c/sqlite3.c"
      HEAP32[$vararg_ptr4>>2] = $37; //@line 125249 "c/sqlite3.c"
      _sqlite3NestedParse($0,25805,$vararg_buffer); //@line 125249 "c/sqlite3.c"
      _sqlite3DbFree($7,$37); //@line 125253 "c/sqlite3.c"
      _sqlite3ChangeCookie($0,$15); //@line 125254 "c/sqlite3.c"
      HEAP32[$vararg_buffer5>>2] = $12; //@line 125256 "c/sqlite3.c"
      $44 = (_sqlite3MPrintf($7,25869,$vararg_buffer5)|0); //@line 125256 "c/sqlite3.c"
      _sqlite3VdbeAddParseSchemaOp($32,$15,$44); //@line 125255 "c/sqlite3.c"
      $$pr = HEAP8[$29>>0]|0; //@line 125259 "c/sqlite3.c"
      $45 = ($$pr<<24>>24)==(0); //@line 125259 "c/sqlite3.c"
      if ($45) {
       $$079 = $6;$$1 = 0;
       break;
      }
     }
     $46 = ((($7)) + 16|0); //@line 125261 "c/sqlite3.c"
     $47 = HEAP32[$46>>2]|0; //@line 125261 "c/sqlite3.c"
     $48 = (((($47) + ($15<<4)|0)) + 12|0); //@line 125261 "c/sqlite3.c"
     $49 = HEAP32[$48>>2]|0; //@line 125261 "c/sqlite3.c"
     $50 = ((($49)) + 40|0); //@line 125261 "c/sqlite3.c"
     $51 = (_sqlite3HashInsert($50,$12,$6)|0); //@line 125263 "c/sqlite3.c"
     $52 = ($51|0)==(0|0); //@line 125264 "c/sqlite3.c"
     if (!($52)) {
      _sqlite3OomFault($7); //@line 125265 "c/sqlite3.c"
      $$079 = $51;$$1 = 0;
      break;
     }
     $53 = HEAP32[$13>>2]|0; //@line 125266 "c/sqlite3.c"
     $54 = ((($6)) + 24|0); //@line 125266 "c/sqlite3.c"
     $55 = HEAP32[$54>>2]|0; //@line 125266 "c/sqlite3.c"
     $56 = ($53|0)==($55|0); //@line 125266 "c/sqlite3.c"
     if ($56) {
      $57 = ((($55)) + 8|0); //@line 125268 "c/sqlite3.c"
      $58 = ((($6)) + 4|0); //@line 125268 "c/sqlite3.c"
      $59 = HEAP32[$58>>2]|0; //@line 125268 "c/sqlite3.c"
      $60 = (_sqlite3HashFind($57,$59)|0); //@line 125268 "c/sqlite3.c"
      $61 = ((($60)) + 68|0); //@line 125270 "c/sqlite3.c"
      $62 = HEAP32[$61>>2]|0; //@line 125270 "c/sqlite3.c"
      $63 = ((($6)) + 32|0); //@line 125270 "c/sqlite3.c"
      HEAP32[$63>>2] = $62; //@line 125270 "c/sqlite3.c"
      HEAP32[$61>>2] = $6; //@line 125271 "c/sqlite3.c"
      $$079 = $51;$$1 = 0;
     } else {
      $$079 = $51;$$1 = 0;
     }
    } else {
     $$079 = $6;$$1 = 0;
    }
   } else {
    $$079 = $6;$$1 = 0;
   }
  } else {
   $$079 = $6;$$1 = $1;
  }
 } while(0);
 _sqlite3DeleteTrigger($7,$$079); //@line 125276 "c/sqlite3.c"
 _sqlite3DeleteTriggerStep($7,$$1); //@line 125278 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 125279 "c/sqlite3.c"
}
function _sqlite3BeginTrigger($0,$1,$2,$3,$4,$5,$6,$7,$8,$9) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 $9 = $9|0;
 var $$0137 = 0, $$0139 = 0, $$0140 = 0, $$1 = 0, $$old10 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0;
 var $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond11 = 0, $or$cond3 = 0, $or$cond5 = 0;
 var $or$cond7 = 0, $or$cond9 = 0, $spec$select = 0, $spec$select141 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer12 = 0, $vararg_buffer3 = 0, $vararg_buffer5 = 0, $vararg_buffer7 = 0, $vararg_ptr10 = 0, $vararg_ptr11 = 0, $vararg_ptr15 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $vararg_buffer12 = sp + 48|0;
 $vararg_buffer7 = sp + 32|0;
 $vararg_buffer5 = sp + 24|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $10 = sp + 80|0;
 $11 = sp + 56|0;
 $12 = HEAP32[$0>>2]|0; //@line 125034 "c/sqlite3.c"
 $13 = ($8|0)!=(0); //@line 125043 "c/sqlite3.c"
 do {
  if ($13) {
   $14 = ((($2)) + 4|0); //@line 125045 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 125045 "c/sqlite3.c"
   $16 = ($15|0)==(0); //@line 125045 "c/sqlite3.c"
   if ($16) {
    HEAP32[$10>>2] = $1; //@line 125050 "c/sqlite3.c"
    $$old10 = ($6|0)==(0|0); //@line 125058 "c/sqlite3.c"
    if ($$old10) {
     $$0137 = 0;$$0140 = 0;
     break;
    } else {
     $$0139 = 1;
     label = 6;
     break;
    }
   } else {
    _sqlite3ErrorMsg($0,25480,$vararg_buffer); //@line 125046 "c/sqlite3.c"
    $$0137 = 0;$$0140 = 0;
    break;
   }
  } else {
   $17 = (_sqlite3TwoPartName($0,$1,$2,$10)|0); //@line 125053 "c/sqlite3.c"
   $18 = ($17|0)>(-1); //@line 125054 "c/sqlite3.c"
   $19 = ($6|0)!=(0|0); //@line 125058 "c/sqlite3.c"
   $or$cond11 = $19 & $18; //@line 125054 "c/sqlite3.c"
   if ($or$cond11) {
    $$0139 = $17;
    label = 6;
   } else {
    $$0137 = 0;$$0140 = 0;
   }
  }
 } while(0);
 do {
  if ((label|0) == 6) {
   $20 = ((($12)) + 73|0); //@line 125058 "c/sqlite3.c"
   $21 = HEAP8[$20>>0]|0; //@line 125058 "c/sqlite3.c"
   $22 = ($21<<24>>24)==(0); //@line 125058 "c/sqlite3.c"
   if ($22) {
    $23 = ((($12)) + 157|0); //@line 125070 "c/sqlite3.c"
    $24 = HEAP8[$23>>0]|0; //@line 125070 "c/sqlite3.c"
    $25 = ($24<<24>>24)!=(0); //@line 125070 "c/sqlite3.c"
    $26 = ($$0139|0)!=(1); //@line 125070 "c/sqlite3.c"
    $or$cond = $26 & $25; //@line 125070 "c/sqlite3.c"
    if ($or$cond) {
     $27 = ((($6)) + 12|0); //@line 125071 "c/sqlite3.c"
     $28 = HEAP32[$27>>2]|0; //@line 125071 "c/sqlite3.c"
     _sqlite3DbFree($12,$28); //@line 125071 "c/sqlite3.c"
     HEAP32[$27>>2] = 0; //@line 125072 "c/sqlite3.c"
    }
    $29 = (_sqlite3SrcListLookup($0,$6)|0); //@line 125080 "c/sqlite3.c"
    $30 = HEAP8[$23>>0]|0; //@line 125081 "c/sqlite3.c"
    $31 = ($30<<24>>24)==(0); //@line 125081 "c/sqlite3.c"
    if ($31) {
     $32 = ((($2)) + 4|0); //@line 125081 "c/sqlite3.c"
     $33 = HEAP32[$32>>2]|0; //@line 125081 "c/sqlite3.c"
     $34 = ($33|0)==(0); //@line 125081 "c/sqlite3.c"
     $35 = ($29|0)!=(0|0); //@line 125081 "c/sqlite3.c"
     $or$cond3 = $35 & $34; //@line 125081 "c/sqlite3.c"
     if ($or$cond3) {
      $36 = ((($29)) + 72|0); //@line 125082 "c/sqlite3.c"
      $37 = HEAP32[$36>>2]|0; //@line 125082 "c/sqlite3.c"
      $38 = ((($12)) + 16|0); //@line 125082 "c/sqlite3.c"
      $39 = HEAP32[$38>>2]|0; //@line 125082 "c/sqlite3.c"
      $40 = ((($39)) + 28|0); //@line 125082 "c/sqlite3.c"
      $41 = HEAP32[$40>>2]|0; //@line 125082 "c/sqlite3.c"
      $42 = ($37|0)==($41|0); //@line 125082 "c/sqlite3.c"
      $spec$select = $42 ? 1 : $$0139; //@line 125081 "c/sqlite3.c"
      $$1 = $spec$select;
     } else {
      $$1 = $$0139;
     }
    } else {
     $$1 = $$0139;
    }
    $43 = HEAP8[$20>>0]|0; //@line 125087 "c/sqlite3.c"
    $44 = ($43<<24>>24)==(0); //@line 125087 "c/sqlite3.c"
    if ($44) {
     $45 = HEAP32[$10>>2]|0; //@line 125089 "c/sqlite3.c"
     _sqlite3FixInit($11,$0,$$1,25526,$45); //@line 125089 "c/sqlite3.c"
     $46 = (_sqlite3FixSrcList($11,$6)|0); //@line 125090 "c/sqlite3.c"
     $47 = ($46|0)==(0); //@line 125090 "c/sqlite3.c"
     if ($47) {
      $48 = (_sqlite3SrcListLookup($0,$6)|0); //@line 125093 "c/sqlite3.c"
      $49 = ($48|0)==(0|0); //@line 125094 "c/sqlite3.c"
      if ($49) {
       $50 = ((($12)) + 156|0); //@line 125096 "c/sqlite3.c"
       $51 = HEAP8[$50>>0]|0; //@line 125096 "c/sqlite3.c"
       $52 = ($51<<24>>24)==(1); //@line 125096 "c/sqlite3.c"
       if (!($52)) {
        $$0137 = 0;$$0140 = 0;
        break;
       }
       $53 = ((($12)) + 158|0); //@line 125105 "c/sqlite3.c"
       HEAP8[$53>>0] = 1; //@line 125105 "c/sqlite3.c"
       $$0137 = 0;$$0140 = 0;
       break;
      }
      $54 = ((($48)) + 56|0); //@line 125109 "c/sqlite3.c"
      $55 = HEAP32[$54>>2]|0; //@line 125109 "c/sqlite3.c"
      $56 = ($55|0)==(0); //@line 125109 "c/sqlite3.c"
      if (!($56)) {
       _sqlite3ErrorMsg($0,25534,$vararg_buffer1); //@line 125110 "c/sqlite3.c"
       $$0137 = 0;$$0140 = 0;
       break;
      }
      $57 = (_sqlite3NameFromToken($12,$45)|0); //@line 125116 "c/sqlite3.c"
      $58 = ($57|0)==(0|0); //@line 125117 "c/sqlite3.c"
      if ($58) {
       $$0137 = 0;$$0140 = 0;
      } else {
       $59 = (_sqlite3CheckObjectName($0,$57)|0); //@line 125117 "c/sqlite3.c"
       $60 = ($59|0)==(0); //@line 125117 "c/sqlite3.c"
       if ($60) {
        $61 = ((($12)) + 16|0); //@line 125121 "c/sqlite3.c"
        $62 = HEAP32[$61>>2]|0; //@line 125121 "c/sqlite3.c"
        $63 = (((($62) + ($$1<<4)|0)) + 12|0); //@line 125121 "c/sqlite3.c"
        $64 = HEAP32[$63>>2]|0; //@line 125121 "c/sqlite3.c"
        $65 = ((($64)) + 40|0); //@line 125121 "c/sqlite3.c"
        $66 = (_sqlite3HashFind($65,$57)|0); //@line 125121 "c/sqlite3.c"
        $67 = ($66|0)==(0|0); //@line 125121 "c/sqlite3.c"
        if (!($67)) {
         $68 = ($9|0)==(0); //@line 125122 "c/sqlite3.c"
         if ($68) {
          HEAP32[$vararg_buffer3>>2] = $45; //@line 125123 "c/sqlite3.c"
          _sqlite3ErrorMsg($0,25575,$vararg_buffer3); //@line 125123 "c/sqlite3.c"
          $$0137 = 0;$$0140 = $57;
          break;
         } else {
          _sqlite3CodeVerifySchema($0,$$1); //@line 125126 "c/sqlite3.c"
          $$0137 = 0;$$0140 = $57;
          break;
         }
        }
        $69 = HEAP32[$48>>2]|0; //@line 125132 "c/sqlite3.c"
        $70 = (_sqlite3_strnicmp($69,19990,7)|0); //@line 125132 "c/sqlite3.c"
        $71 = ($70|0)==(0); //@line 125132 "c/sqlite3.c"
        if ($71) {
         _sqlite3ErrorMsg($0,25601,$vararg_buffer5); //@line 125133 "c/sqlite3.c"
         $$0137 = 0;$$0140 = $57;
         break;
        }
        $72 = ((($48)) + 12|0); //@line 125140 "c/sqlite3.c"
        $73 = HEAP32[$72>>2]|0; //@line 125140 "c/sqlite3.c"
        $74 = ($73|0)!=(0|0); //@line 125140 "c/sqlite3.c"
        $75 = ($3|0)!=(64); //@line 125140 "c/sqlite3.c"
        $or$cond5 = $75 & $74; //@line 125140 "c/sqlite3.c"
        if ($or$cond5) {
         $76 = ($3|0)==(33); //@line 125142 "c/sqlite3.c"
         $77 = $76 ? 25639 : 25646; //@line 125142 "c/sqlite3.c"
         HEAP32[$vararg_buffer7>>2] = $77; //@line 125141 "c/sqlite3.c"
         $vararg_ptr10 = ((($vararg_buffer7)) + 4|0); //@line 125141 "c/sqlite3.c"
         HEAP32[$vararg_ptr10>>2] = $6; //@line 125141 "c/sqlite3.c"
         $vararg_ptr11 = ((($vararg_buffer7)) + 8|0); //@line 125141 "c/sqlite3.c"
         HEAP32[$vararg_ptr11>>2] = 0; //@line 125141 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,25652,$vararg_buffer7); //@line 125141 "c/sqlite3.c"
         $$0137 = 0;$$0140 = $57;
         break;
        }
        $78 = ($73|0)==(0|0); //@line 125145 "c/sqlite3.c"
        $79 = ($3|0)==(64); //@line 125145 "c/sqlite3.c"
        $or$cond7 = $79 & $78; //@line 125145 "c/sqlite3.c"
        if ($or$cond7) {
         HEAP32[$vararg_buffer12>>2] = $6; //@line 125146 "c/sqlite3.c"
         $vararg_ptr15 = ((($vararg_buffer12)) + 4|0); //@line 125146 "c/sqlite3.c"
         HEAP32[$vararg_ptr15>>2] = 0; //@line 125146 "c/sqlite3.c"
         _sqlite3ErrorMsg($0,25689,$vararg_buffer12); //@line 125146 "c/sqlite3.c"
         $$0137 = 0;$$0140 = $57;
         break;
        }
        $80 = ((($48)) + 72|0); //@line 125153 "c/sqlite3.c"
        $81 = HEAP32[$80>>2]|0; //@line 125153 "c/sqlite3.c"
        $82 = (_sqlite3SchemaToIndex($12,$81)|0); //@line 125153 "c/sqlite3.c"
        $83 = HEAP32[$61>>2]|0; //@line 125155 "c/sqlite3.c"
        $84 = (($83) + ($82<<4)|0); //@line 125155 "c/sqlite3.c"
        $85 = HEAP32[$84>>2]|0; //@line 125155 "c/sqlite3.c"
        if ($13) {
         $86 = ((($83)) + 16|0); //@line 125156 "c/sqlite3.c"
         $87 = HEAP32[$86>>2]|0; //@line 125156 "c/sqlite3.c"
         $89 = $87;
        } else {
         $89 = $85;
        }
        $88 = ($82|0)==(1); //@line 125157 "c/sqlite3.c"
        $or$cond9 = $13 | $88; //@line 125157 "c/sqlite3.c"
        $spec$select141 = $or$cond9 ? 5 : 7; //@line 125157 "c/sqlite3.c"
        $90 = (_sqlite3AuthCheck($0,$spec$select141,$57,$69,$89)|0); //@line 125158 "c/sqlite3.c"
        $91 = ($90|0)==(0); //@line 125158 "c/sqlite3.c"
        if ($91) {
         $92 = $88 ? 21366 : 19754; //@line 125161 "c/sqlite3.c"
         $93 = (_sqlite3AuthCheck($0,18,$92,0,$85)|0); //@line 125161 "c/sqlite3.c"
         $94 = ($93|0)==(0); //@line 125161 "c/sqlite3.c"
         if ($94) {
          $95 = (_sqlite3DbMallocZero($12,36,0)|0); //@line 125177 "c/sqlite3.c"
          $96 = ($95|0)==(0|0); //@line 125178 "c/sqlite3.c"
          if ($96) {
           $$0137 = $95;$$0140 = $57;
          } else {
           HEAP32[$95>>2] = $57; //@line 125179 "c/sqlite3.c"
           $97 = ((($6)) + 16|0); //@line 125181 "c/sqlite3.c"
           $98 = HEAP32[$97>>2]|0; //@line 125181 "c/sqlite3.c"
           $99 = (_sqlite3DbStrDup($12,$98)|0); //@line 125181 "c/sqlite3.c"
           $100 = ((($95)) + 4|0); //@line 125181 "c/sqlite3.c"
           HEAP32[$100>>2] = $99; //@line 125181 "c/sqlite3.c"
           $101 = HEAP32[$61>>2]|0; //@line 125182 "c/sqlite3.c"
           $102 = (((($101) + ($$1<<4)|0)) + 12|0); //@line 125182 "c/sqlite3.c"
           $103 = HEAP32[$102>>2]|0; //@line 125182 "c/sqlite3.c"
           $104 = ((($95)) + 20|0); //@line 125182 "c/sqlite3.c"
           HEAP32[$104>>2] = $103; //@line 125182 "c/sqlite3.c"
           $105 = HEAP32[$80>>2]|0; //@line 125183 "c/sqlite3.c"
           $106 = ((($95)) + 24|0); //@line 125183 "c/sqlite3.c"
           HEAP32[$106>>2] = $105; //@line 125183 "c/sqlite3.c"
           $107 = $4&255; //@line 125184 "c/sqlite3.c"
           $108 = ((($95)) + 8|0); //@line 125184 "c/sqlite3.c"
           HEAP8[$108>>0] = $107; //@line 125184 "c/sqlite3.c"
           $109 = ($3|0)==(33); //@line 125185 "c/sqlite3.c"
           $110 = $79 | $109; //@line 125185 "c/sqlite3.c"
           $111 = $110 ? 1 : 2; //@line 125185 "c/sqlite3.c"
           $112 = ((($95)) + 9|0); //@line 125185 "c/sqlite3.c"
           HEAP8[$112>>0] = $111; //@line 125185 "c/sqlite3.c"
           $113 = (_sqlite3ExprDup($12,$7,1)|0); //@line 125186 "c/sqlite3.c"
           $114 = ((($95)) + 12|0); //@line 125186 "c/sqlite3.c"
           HEAP32[$114>>2] = $113; //@line 125186 "c/sqlite3.c"
           $115 = (_sqlite3IdListDup($12,$5)|0); //@line 125187 "c/sqlite3.c"
           $116 = ((($95)) + 16|0); //@line 125187 "c/sqlite3.c"
           HEAP32[$116>>2] = $115; //@line 125187 "c/sqlite3.c"
           $117 = ((($0)) + 436|0); //@line 125189 "c/sqlite3.c"
           HEAP32[$117>>2] = $95; //@line 125189 "c/sqlite3.c"
           $$0137 = $95;$$0140 = 0;
          }
         } else {
          $$0137 = 0;$$0140 = $57;
         }
        } else {
         $$0137 = 0;$$0140 = $57;
        }
       } else {
        $$0137 = 0;$$0140 = $57;
       }
      }
     } else {
      $$0137 = 0;$$0140 = 0;
     }
    } else {
     $$0137 = 0;$$0140 = 0;
    }
   } else {
    $$0137 = 0;$$0140 = 0;
   }
  }
 } while(0);
 _sqlite3DbFree($12,$$0140); //@line 125192 "c/sqlite3.c"
 _sqlite3SrcListDelete($12,$6); //@line 125193 "c/sqlite3.c"
 _sqlite3IdListDelete($12,$5); //@line 125194 "c/sqlite3.c"
 _sqlite3ExprDelete($12,$7); //@line 125195 "c/sqlite3.c"
 $118 = ((($0)) + 436|0); //@line 125196 "c/sqlite3.c"
 $119 = HEAP32[$118>>2]|0; //@line 125196 "c/sqlite3.c"
 $120 = ($119|0)==(0|0); //@line 125196 "c/sqlite3.c"
 if (!($120)) {
  STACKTOP = sp;return; //@line 125201 "c/sqlite3.c"
 }
 _sqlite3DeleteTrigger($12,$$0137); //@line 125197 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 125201 "c/sqlite3.c"
}
function _sqlite3TriggerUpdateStep($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $7 = (_triggerStepAllocate($0,110,$1,$5,$6)|0); //@line 125393 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 125394 "c/sqlite3.c"
 if (!($8)) {
  $9 = (_sqlite3ExprListDup($0,$2,1)|0); //@line 125395 "c/sqlite3.c"
  $10 = ((($7)) + 20|0); //@line 125395 "c/sqlite3.c"
  HEAP32[$10>>2] = $9; //@line 125395 "c/sqlite3.c"
  $11 = (_sqlite3ExprDup($0,$3,1)|0); //@line 125396 "c/sqlite3.c"
  $12 = ((($7)) + 16|0); //@line 125396 "c/sqlite3.c"
  HEAP32[$12>>2] = $11; //@line 125396 "c/sqlite3.c"
  $13 = ((($7)) + 1|0); //@line 125397 "c/sqlite3.c"
  HEAP8[$13>>0] = $4; //@line 125397 "c/sqlite3.c"
 }
 _sqlite3ExprListDelete($0,$2); //@line 125399 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$3); //@line 125400 "c/sqlite3.c"
 return ($7|0); //@line 125401 "c/sqlite3.c"
}
function _sqlite3TriggerInsertStep($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $10 = 0, $11 = 0, $12 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $7 = (_triggerStepAllocate($0,108,$1,$5,$6)|0); //@line 125364 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 125365 "c/sqlite3.c"
 if ($8) {
  _sqlite3IdListDelete($0,$2); //@line 125370 "c/sqlite3.c"
  _sqlite3SelectDelete($0,$3); //@line 125372 "c/sqlite3.c"
  return ($7|0); //@line 125374 "c/sqlite3.c"
 } else {
  $9 = (_sqlite3SelectDup($0,$3,1)|0); //@line 125366 "c/sqlite3.c"
  $10 = ((($7)) + 8|0); //@line 125366 "c/sqlite3.c"
  HEAP32[$10>>2] = $9; //@line 125366 "c/sqlite3.c"
  $11 = ((($7)) + 24|0); //@line 125367 "c/sqlite3.c"
  HEAP32[$11>>2] = $2; //@line 125367 "c/sqlite3.c"
  $12 = ((($7)) + 1|0); //@line 125368 "c/sqlite3.c"
  HEAP8[$12>>0] = $4; //@line 125368 "c/sqlite3.c"
  _sqlite3SelectDelete($0,$3); //@line 125372 "c/sqlite3.c"
  return ($7|0); //@line 125374 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3TriggerDeleteStep($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_triggerStepAllocate($0,109,$1,$3,$4)|0); //@line 125418 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 125419 "c/sqlite3.c"
 if (!($6)) {
  $7 = (_sqlite3ExprDup($0,$2,1)|0); //@line 125420 "c/sqlite3.c"
  $8 = ((($5)) + 16|0); //@line 125420 "c/sqlite3.c"
  HEAP32[$8>>2] = $7; //@line 125420 "c/sqlite3.c"
  $9 = ((($5)) + 1|0); //@line 125421 "c/sqlite3.c"
  HEAP8[$9>>0] = 10; //@line 125421 "c/sqlite3.c"
 }
 _sqlite3ExprDelete($0,$2); //@line 125423 "c/sqlite3.c"
 return ($5|0); //@line 125424 "c/sqlite3.c"
}
function _sqlite3TriggerSelectStep($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3DbMallocZero($0,40,0)|0); //@line 125305 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 125306 "c/sqlite3.c"
 if ($5) {
  _sqlite3SelectDelete($0,$1); //@line 125307 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 125315 "c/sqlite3.c"
 } else {
  HEAP8[$4>>0] = 119; //@line 125310 "c/sqlite3.c"
  $6 = ((($4)) + 8|0); //@line 125311 "c/sqlite3.c"
  HEAP32[$6>>2] = $1; //@line 125311 "c/sqlite3.c"
  $7 = ((($4)) + 1|0); //@line 125312 "c/sqlite3.c"
  HEAP8[$7>>0] = 10; //@line 125312 "c/sqlite3.c"
  $8 = (_triggerSpanDup($0,$2,$3)|0); //@line 125313 "c/sqlite3.c"
  $9 = ((($4)) + 28|0); //@line 125313 "c/sqlite3.c"
  HEAP32[$9>>2] = $8; //@line 125313 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 125315 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3DropTrigger($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03943 = 0, $$04042 = 0, $$141 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 125448 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 125453 "c/sqlite3.c"
 $4 = ((($3)) + 73|0); //@line 125455 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 125455 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 125455 "c/sqlite3.c"
 if (!($6)) {
  _sqlite3SrcListDelete($3,$1); //@line 125483 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 125484 "c/sqlite3.c"
 }
 $7 = (_sqlite3ReadSchema($0)|0); //@line 125456 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 125456 "c/sqlite3.c"
 if (!($8)) {
  _sqlite3SrcListDelete($3,$1); //@line 125483 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 125484 "c/sqlite3.c"
 }
 $9 = ((($1)) + 12|0); //@line 125461 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 125461 "c/sqlite3.c"
 $11 = ((($1)) + 16|0); //@line 125462 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 125462 "c/sqlite3.c"
 $13 = ((($3)) + 20|0); //@line 125464 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 125464 "c/sqlite3.c"
 $15 = ($14|0)>(0); //@line 125464 "c/sqlite3.c"
 if ($15) {
  $16 = ($10|0)==(0|0);
  $17 = ((($3)) + 16|0);
  $18 = ((($3)) + 16|0);
  $$03943 = 0;$$04042 = 0;
  while(1) {
   $19 = ($$04042>>>0)<(2); //@line 125465 "c/sqlite3.c"
   $20 = $19&1; //@line 125465 "c/sqlite3.c"
   $21 = $$04042 ^ $20; //@line 125465 "c/sqlite3.c"
   if ($16) {
    label = 7;
   } else {
    $22 = HEAP32[$18>>2]|0; //@line 125466 "c/sqlite3.c"
    $23 = (($22) + ($21<<4)|0); //@line 125466 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 125466 "c/sqlite3.c"
    $25 = (_sqlite3StrICmp($24,$10)|0); //@line 125466 "c/sqlite3.c"
    $26 = ($25|0)==(0); //@line 125466 "c/sqlite3.c"
    if ($26) {
     label = 7;
    } else {
     $$141 = $$03943;
    }
   }
   if ((label|0) == 7) {
    label = 0;
    $27 = HEAP32[$17>>2]|0; //@line 125468 "c/sqlite3.c"
    $28 = (((($27) + ($21<<4)|0)) + 12|0); //@line 125468 "c/sqlite3.c"
    $29 = HEAP32[$28>>2]|0; //@line 125468 "c/sqlite3.c"
    $30 = ((($29)) + 40|0); //@line 125468 "c/sqlite3.c"
    $31 = (_sqlite3HashFind($30,$12)|0); //@line 125468 "c/sqlite3.c"
    $32 = ($31|0)==(0|0); //@line 125469 "c/sqlite3.c"
    if ($32) {
     $$141 = $31;
    } else {
     label = 9;
     break;
    }
   }
   $33 = (($$04042) + 1)|0; //@line 125464 "c/sqlite3.c"
   $34 = HEAP32[$13>>2]|0; //@line 125464 "c/sqlite3.c"
   $35 = ($33|0)<($34|0); //@line 125464 "c/sqlite3.c"
   if ($35) {
    $$03943 = $$141;$$04042 = $33;
   } else {
    $$2 = $$141;
    break;
   }
  }
  if ((label|0) == 9) {
   $$2 = $31;
  }
  $36 = ($$2|0)==(0|0); //@line 125471 "c/sqlite3.c"
  if (!($36)) {
   _sqlite3DropTriggerPtr($0,$$2); //@line 125480 "c/sqlite3.c"
   _sqlite3SrcListDelete($3,$1); //@line 125483 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 125484 "c/sqlite3.c"
  }
 }
 $37 = ($2|0)==(0); //@line 125472 "c/sqlite3.c"
 if ($37) {
  HEAP32[$vararg_buffer>>2] = $1; //@line 125473 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 125473 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = 0; //@line 125473 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,25409,$vararg_buffer); //@line 125473 "c/sqlite3.c"
 } else {
  _sqlite3CodeVerifyNamedSchema($0,$10); //@line 125475 "c/sqlite3.c"
 }
 $38 = ((($0)) + 17|0); //@line 125477 "c/sqlite3.c"
 HEAP8[$38>>0] = 1; //@line 125477 "c/sqlite3.c"
 _sqlite3SrcListDelete($3,$1); //@line 125483 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 125484 "c/sqlite3.c"
}
function _sqlite3Attach($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _codeAttach($0,24,6128,$1,$1,$2,$3); //@line 101179 "c/sqlite3.c"
 return; //@line 101180 "c/sqlite3.c"
}
function _sqlite3Detach($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _codeAttach($0,25,6100,$1,0,0,$1); //@line 101160 "c/sqlite3.c"
 return; //@line 101161 "c/sqlite3.c"
}
function _sqlite3Reindex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $3 = sp + 4|0;
 $4 = HEAP32[$0>>2]|0; //@line 105916 "c/sqlite3.c"
 $5 = (_sqlite3ReadSchema($0)|0); //@line 105921 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 105921 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 }
 $7 = ($1|0)==(0|0); //@line 105925 "c/sqlite3.c"
 if ($7) {
  _reindexDatabases($0,0); //@line 105926 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 }
 $8 = ($2|0)==(0|0); //@line 105928 "c/sqlite3.c"
 if ($8) {
  label = 6;
 } else {
  $9 = HEAP32[$2>>2]|0; //@line 105928 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 105928 "c/sqlite3.c"
  if ($10) {
   label = 6;
  }
 }
 do {
  if ((label|0) == 6) {
   $11 = HEAP32[$0>>2]|0; //@line 105931 "c/sqlite3.c"
   $12 = (_sqlite3NameFromToken($11,$1)|0); //@line 105931 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 105932 "c/sqlite3.c"
   if ($13) {
    STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
   }
   $14 = ((($4)) + 70|0); //@line 105933 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 105933 "c/sqlite3.c"
   $16 = (_sqlite3FindCollSeq($4,$15,$12,0)|0); //@line 105933 "c/sqlite3.c"
   $17 = ($16|0)==(0|0); //@line 105934 "c/sqlite3.c"
   if ($17) {
    _sqlite3DbFree($4,$12); //@line 105939 "c/sqlite3.c"
    break;
   }
   _reindexDatabases($0,$12); //@line 105935 "c/sqlite3.c"
   _sqlite3DbFree($4,$12); //@line 105936 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
  }
 } while(0);
 $18 = (_sqlite3TwoPartName($0,$1,$2,$3)|0); //@line 105941 "c/sqlite3.c"
 $19 = ($18|0)<(0); //@line 105942 "c/sqlite3.c"
 if ($19) {
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 }
 $20 = HEAP32[$3>>2]|0; //@line 105943 "c/sqlite3.c"
 $21 = (_sqlite3NameFromToken($4,$20)|0); //@line 105943 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 105944 "c/sqlite3.c"
 if ($22) {
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 }
 $23 = ((($4)) + 16|0); //@line 105945 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 105945 "c/sqlite3.c"
 $25 = (($24) + ($18<<4)|0); //@line 105945 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 105945 "c/sqlite3.c"
 $27 = (_sqlite3FindTable($4,$21,$26)|0); //@line 105946 "c/sqlite3.c"
 $28 = ($27|0)==(0|0); //@line 105947 "c/sqlite3.c"
 if (!($28)) {
  _reindexTable($0,$27,0); //@line 105948 "c/sqlite3.c"
  _sqlite3DbFree($4,$21); //@line 105949 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 }
 $29 = (_sqlite3FindIndex($4,$21,$26)|0); //@line 105952 "c/sqlite3.c"
 _sqlite3DbFree($4,$21); //@line 105953 "c/sqlite3.c"
 $30 = ($29|0)==(0|0); //@line 105954 "c/sqlite3.c"
 if ($30) {
  _sqlite3ErrorMsg($0,24695,$vararg_buffer); //@line 105959 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 } else {
  _sqlite3BeginWriteOperation($0,0,$18); //@line 105955 "c/sqlite3.c"
  _sqlite3RefillIndex($0,$29,-1); //@line 105956 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105960 "c/sqlite3.c"
 }
}
function _sqlite3Analyze($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$052 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = HEAP32[$0>>2]|0; //@line 100223 "c/sqlite3.c"
 $5 = (_sqlite3ReadSchema($0)|0); //@line 100235 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 100235 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return; //@line 100268 "c/sqlite3.c"
 }
 $7 = ($1|0)==(0|0); //@line 100240 "c/sqlite3.c"
 do {
  if ($7) {
   $8 = ((($4)) + 20|0); //@line 100242 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 100242 "c/sqlite3.c"
   $10 = ($9|0)>(0); //@line 100242 "c/sqlite3.c"
   if ($10) {
    $$052 = 0;
    while(1) {
     $11 = ($$052|0)==(1); //@line 100243 "c/sqlite3.c"
     if (!($11)) {
      _analyzeDatabase($0,$$052); //@line 100244 "c/sqlite3.c"
     }
     $12 = (($$052) + 1)|0; //@line 100242 "c/sqlite3.c"
     $13 = HEAP32[$8>>2]|0; //@line 100242 "c/sqlite3.c"
     $14 = ($12|0)<($13|0); //@line 100242 "c/sqlite3.c"
     if ($14) {
      $$052 = $12;
     } else {
      break;
     }
    }
   }
  } else {
   $15 = ((($2)) + 4|0); //@line 100246 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 100246 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 100246 "c/sqlite3.c"
   if ($17) {
    $18 = (_sqlite3FindDb($4,$1)|0); //@line 100246 "c/sqlite3.c"
    $19 = ($18|0)>(-1); //@line 100246 "c/sqlite3.c"
    if ($19) {
     _analyzeDatabase($0,$18); //@line 100248 "c/sqlite3.c"
     break;
    }
   }
   $20 = (_sqlite3TwoPartName($0,$1,$2,$3)|0); //@line 100251 "c/sqlite3.c"
   $21 = ($20|0)>(-1); //@line 100252 "c/sqlite3.c"
   if ($21) {
    $22 = HEAP32[$15>>2]|0; //@line 100253 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 100253 "c/sqlite3.c"
    if ($23) {
     $31 = 0;
    } else {
     $24 = ((($4)) + 16|0); //@line 100253 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 100253 "c/sqlite3.c"
     $26 = (($25) + ($20<<4)|0); //@line 100253 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 100253 "c/sqlite3.c"
     $31 = $27;
    }
    $28 = HEAP32[$3>>2]|0; //@line 100254 "c/sqlite3.c"
    $29 = (_sqlite3NameFromToken($4,$28)|0); //@line 100254 "c/sqlite3.c"
    $30 = ($29|0)==(0|0); //@line 100255 "c/sqlite3.c"
    if (!($30)) {
     $32 = (_sqlite3FindIndex($4,$29,$31)|0); //@line 100256 "c/sqlite3.c"
     $33 = ($32|0)==(0|0); //@line 100256 "c/sqlite3.c"
     if ($33) {
      $36 = (_sqlite3LocateTable($0,0,$29,$31)|0); //@line 100258 "c/sqlite3.c"
      $37 = ($36|0)==(0|0); //@line 100258 "c/sqlite3.c"
      if (!($37)) {
       _analyzeTable($0,$36,0); //@line 100259 "c/sqlite3.c"
      }
     } else {
      $34 = ((($32)) + 12|0); //@line 100257 "c/sqlite3.c"
      $35 = HEAP32[$34>>2]|0; //@line 100257 "c/sqlite3.c"
      _analyzeTable($0,$35,$32); //@line 100257 "c/sqlite3.c"
     }
     _sqlite3DbFree($4,$29); //@line 100261 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $38 = ((($4)) + 82|0); //@line 100265 "c/sqlite3.c"
 $39 = HEAP8[$38>>0]|0; //@line 100265 "c/sqlite3.c"
 $40 = ($39<<24>>24)==(0); //@line 100265 "c/sqlite3.c"
 if (!($40)) {
  STACKTOP = sp;return; //@line 100268 "c/sqlite3.c"
 }
 $41 = (_sqlite3GetVdbe($0)|0); //@line 100265 "c/sqlite3.c"
 $42 = ($41|0)==(0|0); //@line 100265 "c/sqlite3.c"
 if ($42) {
  STACKTOP = sp;return; //@line 100268 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp0($41,152)|0); //@line 100266 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 100268 "c/sqlite3.c"
}
function _sqlite3AlterRenameTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0133135 = 0, $$0134 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer22 = 0, $vararg_buffer27 = 0, $vararg_buffer4 = 0, $vararg_ptr10 = 0, $vararg_ptr14 = 0, $vararg_ptr15 = 0, $vararg_ptr16 = 0, $vararg_ptr17 = 0, $vararg_ptr18 = 0, $vararg_ptr19 = 0, $vararg_ptr20 = 0, $vararg_ptr21 = 0, $vararg_ptr25 = 0, $vararg_ptr26 = 0;
 var $vararg_ptr30 = 0, $vararg_ptr31 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0, $vararg_ptr9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $vararg_buffer27 = sp + 96|0; //@line 98409 "c/sqlite3.c"
 $vararg_buffer22 = sp + 80|0; //@line 98409 "c/sqlite3.c"
 $vararg_buffer11 = sp + 40|0; //@line 98409 "c/sqlite3.c"
 $vararg_buffer4 = sp + 16|0; //@line 98409 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 98409 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 98409 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 98417 "c/sqlite3.c"
 $4 = ((($3)) + 24|0); //@line 98427 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 98427 "c/sqlite3.c"
 $6 = ((($3)) + 73|0); //@line 98428 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 98428 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 98428 "c/sqlite3.c"
 do {
  if ($8) {
   $9 = ((($1)) + 8|0); //@line 98432 "c/sqlite3.c"
   $10 = (_sqlite3LocateTableItem($0,0,$9)|0); //@line 98432 "c/sqlite3.c"
   $11 = ($10|0)==(0|0); //@line 98433 "c/sqlite3.c"
   if ($11) {
    $$0 = 0;
   } else {
    $12 = HEAP32[$0>>2]|0; //@line 98434 "c/sqlite3.c"
    $13 = ((($10)) + 72|0); //@line 98434 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 98434 "c/sqlite3.c"
    $15 = (_sqlite3SchemaToIndex($12,$14)|0); //@line 98434 "c/sqlite3.c"
    $16 = ((($3)) + 16|0); //@line 98435 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 98435 "c/sqlite3.c"
    $18 = (($17) + ($15<<4)|0); //@line 98435 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 98435 "c/sqlite3.c"
    $20 = HEAP32[$4>>2]|0; //@line 98436 "c/sqlite3.c"
    $21 = $20 | 2; //@line 98436 "c/sqlite3.c"
    HEAP32[$4>>2] = $21; //@line 98436 "c/sqlite3.c"
    $22 = (_sqlite3NameFromToken($3,$2)|0); //@line 98439 "c/sqlite3.c"
    $23 = ($22|0)==(0|0); //@line 98440 "c/sqlite3.c"
    if ($23) {
     $$0 = 0;
    } else {
     $24 = (_sqlite3FindTable($3,$22,$19)|0); //@line 98445 "c/sqlite3.c"
     $25 = ($24|0)==(0|0); //@line 98445 "c/sqlite3.c"
     if ($25) {
      $26 = (_sqlite3FindIndex($3,$22,$19)|0); //@line 98445 "c/sqlite3.c"
      $27 = ($26|0)==(0|0); //@line 98445 "c/sqlite3.c"
      if ($27) {
       $28 = HEAP32[$10>>2]|0; //@line 98454 "c/sqlite3.c"
       $29 = (_isSystemTable($0,$28)|0); //@line 98454 "c/sqlite3.c"
       $30 = ($29|0)==(0); //@line 98454 "c/sqlite3.c"
       if (!($30)) {
        $$0 = $22;
        break;
       }
       $31 = (_sqlite3CheckObjectName($0,$22)|0); //@line 98457 "c/sqlite3.c"
       $32 = ($31|0)==(0); //@line 98457 "c/sqlite3.c"
       if (!($32)) {
        $$0 = $22;
        break;
       }
       $33 = ((($10)) + 12|0); //@line 98462 "c/sqlite3.c"
       $34 = HEAP32[$33>>2]|0; //@line 98462 "c/sqlite3.c"
       $35 = ($34|0)==(0|0); //@line 98462 "c/sqlite3.c"
       $36 = HEAP32[$10>>2]|0;
       if (!($35)) {
        HEAP32[$vararg_buffer1>>2] = $36; //@line 98463 "c/sqlite3.c"
        _sqlite3ErrorMsg($0,22209,$vararg_buffer1); //@line 98463 "c/sqlite3.c"
        $$0 = $22;
        break;
       }
       $37 = (_sqlite3AuthCheck($0,26,$19,$36,0)|0); //@line 98470 "c/sqlite3.c"
       $38 = ($37|0)==(0); //@line 98470 "c/sqlite3.c"
       if (!($38)) {
        $$0 = $22;
        break;
       }
       $39 = (_sqlite3ViewGetColumnNames($0,$10)|0); //@line 98476 "c/sqlite3.c"
       $40 = ($39|0)==(0); //@line 98476 "c/sqlite3.c"
       if (!($40)) {
        $$0 = $22;
        break;
       }
       $41 = ((($10)) + 56|0); //@line 98479 "c/sqlite3.c"
       $42 = HEAP32[$41>>2]|0; //@line 98479 "c/sqlite3.c"
       $43 = ($42|0)==(0); //@line 98479 "c/sqlite3.c"
       if ($43) {
        $$0134 = 0;
       } else {
        $44 = (_sqlite3GetVTable($3,$10)|0); //@line 98480 "c/sqlite3.c"
        $45 = ((($44)) + 8|0); //@line 98481 "c/sqlite3.c"
        $46 = HEAP32[$45>>2]|0; //@line 98481 "c/sqlite3.c"
        $47 = HEAP32[$46>>2]|0; //@line 98481 "c/sqlite3.c"
        $48 = ((($47)) + 76|0); //@line 98481 "c/sqlite3.c"
        $49 = HEAP32[$48>>2]|0; //@line 98481 "c/sqlite3.c"
        $50 = ($49|0)==(0|0); //@line 98481 "c/sqlite3.c"
        $spec$select = $50 ? 0 : $44; //@line 98481 "c/sqlite3.c"
        $$0134 = $spec$select;
       }
       $51 = (_sqlite3GetVdbe($0)|0); //@line 98492 "c/sqlite3.c"
       $52 = ($51|0)==(0|0); //@line 98493 "c/sqlite3.c"
       if ($52) {
        $$0 = $22;
        break;
       }
       $53 = ($$0134|0)!=(0|0); //@line 98496 "c/sqlite3.c"
       $54 = $53&1; //@line 98496 "c/sqlite3.c"
       _sqlite3BeginWriteOperation($0,$54,$15); //@line 98496 "c/sqlite3.c"
       _sqlite3ChangeCookie($0,$15); //@line 98497 "c/sqlite3.c"
       if ($53) {
        $55 = ((($0)) + 44|0); //@line 98506 "c/sqlite3.c"
        $56 = HEAP32[$55>>2]|0; //@line 98506 "c/sqlite3.c"
        $57 = (($56) + 1)|0; //@line 98506 "c/sqlite3.c"
        HEAP32[$55>>2] = $57; //@line 98506 "c/sqlite3.c"
        (_sqlite3VdbeLoadString($51,$57,$22)|0); //@line 98507 "c/sqlite3.c"
        (_sqlite3VdbeAddOp4($51,159,$57,0,0,$$0134,-12)|0); //@line 98508 "c/sqlite3.c"
        _sqlite3MayAbort($0); //@line 98509 "c/sqlite3.c"
       }
       $58 = HEAP32[$10>>2]|0; //@line 98514 "c/sqlite3.c"
       $59 = (_sqlite3Utf8CharLen_70($58,-1)|0); //@line 98515 "c/sqlite3.c"
       $60 = ((($3)) + 28|0); //@line 98518 "c/sqlite3.c"
       $61 = HEAP32[$60>>2]|0; //@line 98518 "c/sqlite3.c"
       $62 = $61 & 16384; //@line 98518 "c/sqlite3.c"
       $63 = ($62|0)==(0); //@line 98518 "c/sqlite3.c"
       if (!($63)) {
        $64 = (_whereForeignKeys($0,$10)|0); //@line 98522 "c/sqlite3.c"
        $65 = ($64|0)==(0|0); //@line 98522 "c/sqlite3.c"
        if (!($65)) {
         HEAP32[$vararg_buffer4>>2] = $19; //@line 98523 "c/sqlite3.c"
         $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 98523 "c/sqlite3.c"
         HEAP32[$vararg_ptr7>>2] = 19754; //@line 98523 "c/sqlite3.c"
         $vararg_ptr8 = ((($vararg_buffer4)) + 8|0); //@line 98523 "c/sqlite3.c"
         HEAP32[$vararg_ptr8>>2] = $58; //@line 98523 "c/sqlite3.c"
         $vararg_ptr9 = ((($vararg_buffer4)) + 12|0); //@line 98523 "c/sqlite3.c"
         HEAP32[$vararg_ptr9>>2] = $22; //@line 98523 "c/sqlite3.c"
         $vararg_ptr10 = ((($vararg_buffer4)) + 16|0); //@line 98523 "c/sqlite3.c"
         HEAP32[$vararg_ptr10>>2] = $64; //@line 98523 "c/sqlite3.c"
         _sqlite3NestedParse($0,22236,$vararg_buffer4); //@line 98523 "c/sqlite3.c"
         _sqlite3DbFree($3,$64); //@line 98527 "c/sqlite3.c"
        }
       }
       HEAP32[$vararg_buffer11>>2] = $19; //@line 98533 "c/sqlite3.c"
       $vararg_ptr14 = ((($vararg_buffer11)) + 4|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr14>>2] = 19754; //@line 98533 "c/sqlite3.c"
       $vararg_ptr15 = ((($vararg_buffer11)) + 8|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr15>>2] = $22; //@line 98533 "c/sqlite3.c"
       $vararg_ptr16 = ((($vararg_buffer11)) + 12|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr16>>2] = $22; //@line 98533 "c/sqlite3.c"
       $vararg_ptr17 = ((($vararg_buffer11)) + 16|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr17>>2] = $22; //@line 98533 "c/sqlite3.c"
       $vararg_ptr18 = ((($vararg_buffer11)) + 20|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr18>>2] = $22; //@line 98533 "c/sqlite3.c"
       $vararg_ptr19 = ((($vararg_buffer11)) + 24|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr19>>2] = $22; //@line 98533 "c/sqlite3.c"
       $vararg_ptr20 = ((($vararg_buffer11)) + 28|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr20>>2] = $59; //@line 98533 "c/sqlite3.c"
       $vararg_ptr21 = ((($vararg_buffer11)) + 32|0); //@line 98533 "c/sqlite3.c"
       HEAP32[$vararg_ptr21>>2] = $58; //@line 98533 "c/sqlite3.c"
       _sqlite3NestedParse($0,22305,$vararg_buffer11); //@line 98533 "c/sqlite3.c"
       $66 = (_sqlite3FindTable($3,22689,$19)|0); //@line 98561 "c/sqlite3.c"
       $67 = ($66|0)==(0|0); //@line 98561 "c/sqlite3.c"
       if (!($67)) {
        $68 = HEAP32[$10>>2]|0; //@line 98564 "c/sqlite3.c"
        HEAP32[$vararg_buffer22>>2] = $19; //@line 98562 "c/sqlite3.c"
        $vararg_ptr25 = ((($vararg_buffer22)) + 4|0); //@line 98562 "c/sqlite3.c"
        HEAP32[$vararg_ptr25>>2] = $22; //@line 98562 "c/sqlite3.c"
        $vararg_ptr26 = ((($vararg_buffer22)) + 8|0); //@line 98562 "c/sqlite3.c"
        HEAP32[$vararg_ptr26>>2] = $68; //@line 98562 "c/sqlite3.c"
        _sqlite3NestedParse($0,22705,$vararg_buffer22); //@line 98562 "c/sqlite3.c"
       }
       $69 = (_whereTempTriggers($0,$10)|0); //@line 98573 "c/sqlite3.c"
       $70 = ($69|0)==(0|0); //@line 98573 "c/sqlite3.c"
       if (!($70)) {
        HEAP32[$vararg_buffer27>>2] = $22; //@line 98574 "c/sqlite3.c"
        $vararg_ptr30 = ((($vararg_buffer27)) + 4|0); //@line 98574 "c/sqlite3.c"
        HEAP32[$vararg_ptr30>>2] = $22; //@line 98574 "c/sqlite3.c"
        $vararg_ptr31 = ((($vararg_buffer27)) + 8|0); //@line 98574 "c/sqlite3.c"
        HEAP32[$vararg_ptr31>>2] = $69; //@line 98574 "c/sqlite3.c"
        _sqlite3NestedParse($0,22763,$vararg_buffer27); //@line 98574 "c/sqlite3.c"
        _sqlite3DbFree($3,$69); //@line 98579 "c/sqlite3.c"
       }
       $71 = HEAP32[$60>>2]|0; //@line 98584 "c/sqlite3.c"
       $72 = $71 & 16384; //@line 98584 "c/sqlite3.c"
       $73 = ($72|0)==(0); //@line 98584 "c/sqlite3.c"
       do {
        if (!($73)) {
         $74 = (_sqlite3FkReferences($10)|0); //@line 98586 "c/sqlite3.c"
         $75 = ($74|0)==(0|0); //@line 98586 "c/sqlite3.c"
         if ($75) {
          break;
         }
         $$0133135 = $74;
         while(1) {
          $76 = HEAP32[$$0133135>>2]|0; //@line 98587 "c/sqlite3.c"
          $77 = ($76|0)==($10|0); //@line 98588 "c/sqlite3.c"
          if (!($77)) {
           $78 = HEAP32[$76>>2]|0; //@line 98589 "c/sqlite3.c"
           _reloadTableSchema($0,$76,$78); //@line 98589 "c/sqlite3.c"
          }
          $79 = ((($$0133135)) + 12|0); //@line 98586 "c/sqlite3.c"
          $80 = HEAP32[$79>>2]|0; //@line 98586 "c/sqlite3.c"
          $81 = ($80|0)==(0|0); //@line 98586 "c/sqlite3.c"
          if ($81) {
           break;
          } else {
           $$0133135 = $80;
          }
         }
        }
       } while(0);
       _reloadTableSchema($0,$10,$22); //@line 98596 "c/sqlite3.c"
       $$0 = $22;
       break;
      }
     }
     HEAP32[$vararg_buffer>>2] = $22; //@line 98446 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,22150,$vararg_buffer); //@line 98446 "c/sqlite3.c"
     $$0 = $22;
    }
   }
  } else {
   $$0 = 0;
  }
 } while(0);
 _sqlite3SrcListDelete($3,$1); //@line 98599 "c/sqlite3.c"
 _sqlite3DbFree($3,$$0); //@line 98600 "c/sqlite3.c"
 HEAP32[$4>>2] = $5; //@line 98601 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98602 "c/sqlite3.c"
}
function _sqlite3AlterFinishAddColumn($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0109112 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $or$cond = 0, $or$cond3 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, $vararg_buffer5 = 0, $vararg_buffer7 = 0;
 var $vararg_buffer9 = 0, $vararg_ptr11 = 0, $vararg_ptr12 = 0, $vararg_ptr13 = 0, $vararg_ptr14 = 0, $vararg_ptr15 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $vararg_buffer9 = sp + 40|0;
 $vararg_buffer7 = sp + 32|0;
 $vararg_buffer5 = sp + 24|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 64|0;
 $3 = ((($0)) + 8|0); //@line 98622 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 98622 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 98625 "c/sqlite3.c"
 $6 = ((($0)) + 36|0); //@line 98626 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 98626 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 98626 "c/sqlite3.c"
 if (!($8)) {
  STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
 }
 $9 = ((($5)) + 73|0); //@line 98626 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 98626 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 98626 "c/sqlite3.c"
 if (!($11)) {
  STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
 }
 $12 = ((($0)) + 432|0); //@line 98628 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 98628 "c/sqlite3.c"
 $14 = ((($13)) + 72|0); //@line 98632 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 98632 "c/sqlite3.c"
 $16 = (_sqlite3SchemaToIndex($5,$15)|0); //@line 98632 "c/sqlite3.c"
 $17 = ((($5)) + 16|0); //@line 98633 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 98633 "c/sqlite3.c"
 $19 = (($18) + ($16<<4)|0); //@line 98633 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 98633 "c/sqlite3.c"
 $21 = HEAP32[$13>>2]|0; //@line 98634 "c/sqlite3.c"
 $22 = ((($21)) + 16|0); //@line 98634 "c/sqlite3.c"
 $23 = ((($13)) + 4|0); //@line 98635 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 98635 "c/sqlite3.c"
 $25 = ((($13)) + 42|0); //@line 98635 "c/sqlite3.c"
 $26 = HEAP16[$25>>1]|0; //@line 98635 "c/sqlite3.c"
 $27 = $26 << 16 >> 16; //@line 98635 "c/sqlite3.c"
 $28 = (($27) + -1)|0; //@line 98635 "c/sqlite3.c"
 $29 = (((($24) + ($28<<4)|0)) + 4|0); //@line 98636 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 98636 "c/sqlite3.c"
 $31 = (_sqlite3FindTable($5,$22,$20)|0); //@line 98637 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 98642 "c/sqlite3.c"
 $33 = (_sqlite3AuthCheck($0,26,$20,$32,0)|0); //@line 98642 "c/sqlite3.c"
 $34 = ($33|0)==(0); //@line 98642 "c/sqlite3.c"
 if (!($34)) {
  STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
 }
 $35 = ($30|0)==(0|0); //@line 98652 "c/sqlite3.c"
 if ($35) {
  $$0 = 0;
 } else {
  $36 = ((($30)) + 12|0); //@line 98652 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 98652 "c/sqlite3.c"
  $38 = HEAP8[$37>>0]|0; //@line 98652 "c/sqlite3.c"
  $39 = ($38<<24>>24)==(101); //@line 98652 "c/sqlite3.c"
  $spec$select = $39 ? 0 : $30; //@line 98652 "c/sqlite3.c"
  $$0 = $spec$select;
 }
 $40 = (((($24) + ($28<<4)|0)) + 15|0); //@line 98660 "c/sqlite3.c"
 $41 = HEAP8[$40>>0]|0; //@line 98660 "c/sqlite3.c"
 $42 = $41 & 1; //@line 98660 "c/sqlite3.c"
 $43 = ($42<<24>>24)==(0); //@line 98660 "c/sqlite3.c"
 if (!($43)) {
  _sqlite3ErrorMsg($0,21759,$vararg_buffer); //@line 98661 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
 }
 $44 = ((($13)) + 8|0); //@line 98664 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 98664 "c/sqlite3.c"
 $46 = ($45|0)==(0|0); //@line 98664 "c/sqlite3.c"
 if (!($46)) {
  _sqlite3ErrorMsg($0,21791,$vararg_buffer1); //@line 98665 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
 }
 $47 = ((($5)) + 28|0); //@line 98668 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 98668 "c/sqlite3.c"
 $49 = $48 & 16384; //@line 98668 "c/sqlite3.c"
 $50 = ($49|0)==(0); //@line 98668 "c/sqlite3.c"
 if (!($50)) {
  $51 = ((($13)) + 16|0); //@line 98668 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 98668 "c/sqlite3.c"
  $53 = ($52|0)!=(0|0); //@line 98668 "c/sqlite3.c"
  $54 = ($$0|0)!=(0|0); //@line 98668 "c/sqlite3.c"
  $or$cond = $54 & $53; //@line 98668 "c/sqlite3.c"
  if ($or$cond) {
   _sqlite3ErrorMsg($0,21818,$vararg_buffer3); //@line 98669 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
  }
 }
 $55 = (((($24) + ($28<<4)|0)) + 12|0); //@line 98673 "c/sqlite3.c"
 $56 = HEAP8[$55>>0]|0; //@line 98673 "c/sqlite3.c"
 $57 = ($56<<24>>24)==(0); //@line 98673 "c/sqlite3.c"
 $58 = ($$0|0)!=(0|0); //@line 98673 "c/sqlite3.c"
 $or$cond3 = $58 | $57; //@line 98673 "c/sqlite3.c"
 if (!($or$cond3)) {
  _sqlite3ErrorMsg($0,21877,$vararg_buffer5); //@line 98674 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
 }
 L30: do {
  if ($58) {
   HEAP32[$2>>2] = 0; //@line 98683 "c/sqlite3.c"
   $59 = (_sqlite3ValueFromExpr($5,$$0,1,65,$2)|0); //@line 98685 "c/sqlite3.c"
   $60 = ($59|0)==(0); //@line 98687 "c/sqlite3.c"
   do {
    if ($60) {
     $61 = HEAP32[$2>>2]|0; //@line 98691 "c/sqlite3.c"
     $62 = ($61|0)==(0|0); //@line 98691 "c/sqlite3.c"
     if ($62) {
      _sqlite3ErrorMsg($0,21930,$vararg_buffer7); //@line 98692 "c/sqlite3.c"
      break;
     } else {
      _sqlite3ValueFree($61); //@line 98695 "c/sqlite3.c"
      break L30;
     }
    }
   } while(0);
   STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
  }
 } while(0);
 $63 = HEAP32[$1>>2]|0; //@line 98699 "c/sqlite3.c"
 $64 = ((($1)) + 4|0); //@line 98699 "c/sqlite3.c"
 $65 = HEAP32[$64>>2]|0; //@line 98699 "c/sqlite3.c"
 $66 = (_sqlite3DbStrNDup($5,$63,$65,0)|0); //@line 98699 "c/sqlite3.c"
 $67 = ($66|0)==(0|0); //@line 98700 "c/sqlite3.c"
 if (!($67)) {
  $68 = HEAP32[$64>>2]|0; //@line 98701 "c/sqlite3.c"
  $69 = (($68) + -1)|0; //@line 98701 "c/sqlite3.c"
  $70 = ((($5)) + 24|0); //@line 98702 "c/sqlite3.c"
  $71 = HEAP32[$70>>2]|0; //@line 98702 "c/sqlite3.c"
  $72 = ($69|0)>(0); //@line 98703 "c/sqlite3.c"
  L42: do {
   if ($72) {
    $73 = (($66) + ($69)|0); //@line 98701 "c/sqlite3.c"
    $$0109112 = $73;
    while(1) {
     $74 = HEAP8[$$0109112>>0]|0; //@line 98703 "c/sqlite3.c"
     $75 = ($74<<24>>24)==(59); //@line 98703 "c/sqlite3.c"
     if (!($75)) {
      $76 = $74&255; //@line 98703 "c/sqlite3.c"
      $77 = (16281 + ($76)|0); //@line 98703 "c/sqlite3.c"
      $78 = HEAP8[$77>>0]|0; //@line 98703 "c/sqlite3.c"
      $79 = $78 & 1; //@line 98703 "c/sqlite3.c"
      $80 = ($79<<24>>24)==(0); //@line 98703 "c/sqlite3.c"
      if ($80) {
       break L42;
      }
     }
     $81 = ((($$0109112)) + -1|0); //@line 98704 "c/sqlite3.c"
     HEAP8[$$0109112>>0] = 0; //@line 98704 "c/sqlite3.c"
     $82 = ($81>>>0)>($66>>>0); //@line 98703 "c/sqlite3.c"
     if ($82) {
      $$0109112 = $81;
     } else {
      break;
     }
    }
   }
  } while(0);
  $83 = HEAP32[$70>>2]|0; //@line 98706 "c/sqlite3.c"
  $84 = $83 | 2; //@line 98706 "c/sqlite3.c"
  HEAP32[$70>>2] = $84; //@line 98706 "c/sqlite3.c"
  $85 = ((($13)) + 52|0); //@line 98711 "c/sqlite3.c"
  $86 = HEAP32[$85>>2]|0; //@line 98711 "c/sqlite3.c"
  $87 = (($86) + 1)|0; //@line 98711 "c/sqlite3.c"
  HEAP32[$vararg_buffer9>>2] = $20; //@line 98707 "c/sqlite3.c"
  $vararg_ptr11 = ((($vararg_buffer9)) + 4|0); //@line 98707 "c/sqlite3.c"
  HEAP32[$vararg_ptr11>>2] = 19754; //@line 98707 "c/sqlite3.c"
  $vararg_ptr12 = ((($vararg_buffer9)) + 8|0); //@line 98707 "c/sqlite3.c"
  HEAP32[$vararg_ptr12>>2] = $86; //@line 98707 "c/sqlite3.c"
  $vararg_ptr13 = ((($vararg_buffer9)) + 12|0); //@line 98707 "c/sqlite3.c"
  HEAP32[$vararg_ptr13>>2] = $66; //@line 98707 "c/sqlite3.c"
  $vararg_ptr14 = ((($vararg_buffer9)) + 16|0); //@line 98707 "c/sqlite3.c"
  HEAP32[$vararg_ptr14>>2] = $87; //@line 98707 "c/sqlite3.c"
  $vararg_ptr15 = ((($vararg_buffer9)) + 20|0); //@line 98707 "c/sqlite3.c"
  HEAP32[$vararg_ptr15>>2] = $22; //@line 98707 "c/sqlite3.c"
  _sqlite3NestedParse($0,21976,$vararg_buffer9); //@line 98707 "c/sqlite3.c"
  _sqlite3DbFree($5,$66); //@line 98714 "c/sqlite3.c"
  HEAP32[$70>>2] = $71; //@line 98715 "c/sqlite3.c"
 }
 $88 = (_sqlite3GetTempReg($0)|0); //@line 98722 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($4,102,$16,$88,2)|0); //@line 98723 "c/sqlite3.c"
 _sqlite3VdbeUsesBtree($4,$16); //@line 98724 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($4,80,$88,-2)|0); //@line 98725 "c/sqlite3.c"
 $89 = (_sqlite3VdbeCurrentAddr($4)|0); //@line 98726 "c/sqlite3.c"
 $90 = (($89) + 2)|0; //@line 98726 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($4,48,$88,$90)|0); //@line 98726 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($4,103,$16,2,3)|0); //@line 98728 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$88); //@line 98729 "c/sqlite3.c"
 $91 = HEAP32[$31>>2]|0; //@line 98732 "c/sqlite3.c"
 _reloadTableSchema($0,$31,$91); //@line 98732 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98733 "c/sqlite3.c"
}
function _sqlite3AlterBeginAddColumn($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$069 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer3 = sp + 16|0; //@line 98750 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 98750 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 98750 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 98757 "c/sqlite3.c"
 $3 = ((($2)) + 73|0); //@line 98762 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 98762 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 98762 "c/sqlite3.c"
 if (!($5)) {
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $6 = ((($1)) + 8|0); //@line 98763 "c/sqlite3.c"
 $7 = (_sqlite3LocateTableItem($0,0,$6)|0); //@line 98763 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 98764 "c/sqlite3.c"
 if ($8) {
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $9 = ((($7)) + 56|0); //@line 98767 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 98767 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 98767 "c/sqlite3.c"
 if (!($11)) {
  _sqlite3ErrorMsg($0,19795,$vararg_buffer); //@line 98768 "c/sqlite3.c"
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $12 = ((($7)) + 12|0); //@line 98774 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 98774 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 98774 "c/sqlite3.c"
 if (!($14)) {
  _sqlite3ErrorMsg($0,19829,$vararg_buffer1); //@line 98775 "c/sqlite3.c"
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $15 = HEAP32[$7>>2]|0; //@line 98778 "c/sqlite3.c"
 $16 = (_isSystemTable($0,$15)|0); //@line 98778 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 98778 "c/sqlite3.c"
 if (!($17)) {
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $18 = ((($7)) + 72|0); //@line 98783 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 98783 "c/sqlite3.c"
 $20 = (_sqlite3SchemaToIndex($2,$19)|0); //@line 98783 "c/sqlite3.c"
 $21 = (_sqlite3DbMallocZero($2,80,0)|0); //@line 98792 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 98793 "c/sqlite3.c"
 if ($22) {
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $23 = ((($0)) + 432|0); //@line 98794 "c/sqlite3.c"
 HEAP32[$23>>2] = $21; //@line 98794 "c/sqlite3.c"
 $24 = ((($21)) + 32|0); //@line 98795 "c/sqlite3.c"
 HEAP32[$24>>2] = 1; //@line 98795 "c/sqlite3.c"
 $25 = ((($7)) + 42|0); //@line 98796 "c/sqlite3.c"
 $26 = HEAP16[$25>>1]|0; //@line 98796 "c/sqlite3.c"
 $27 = ((($21)) + 42|0); //@line 98796 "c/sqlite3.c"
 HEAP16[$27>>1] = $26; //@line 98796 "c/sqlite3.c"
 $28 = $26 << 16 >> 16; //@line 98798 "c/sqlite3.c"
 $29 = (($28) + -1)|0; //@line 98798 "c/sqlite3.c"
 $30 = (($29|0) / 8)&-1; //@line 98798 "c/sqlite3.c"
 $31 = $30 << 7; //@line 98798 "c/sqlite3.c"
 $32 = (($31) + 128)|0; //@line 98800 "c/sqlite3.c"
 $33 = (_sqlite3DbMallocZero($2,$32,0)|0); //@line 98800 "c/sqlite3.c"
 $34 = ((($21)) + 4|0); //@line 98800 "c/sqlite3.c"
 HEAP32[$34>>2] = $33; //@line 98800 "c/sqlite3.c"
 $35 = HEAP32[$7>>2]|0; //@line 98801 "c/sqlite3.c"
 HEAP32[$vararg_buffer3>>2] = $35; //@line 98801 "c/sqlite3.c"
 $36 = (_sqlite3MPrintf($2,19859,$vararg_buffer3)|0); //@line 98801 "c/sqlite3.c"
 HEAP32[$21>>2] = $36; //@line 98801 "c/sqlite3.c"
 $37 = HEAP32[$34>>2]|0; //@line 98802 "c/sqlite3.c"
 $38 = ($37|0)==(0|0); //@line 98802 "c/sqlite3.c"
 $39 = ($36|0)==(0|0); //@line 98802 "c/sqlite3.c"
 $or$cond = $39 | $38; //@line 98802 "c/sqlite3.c"
 if ($or$cond) {
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 $40 = ((($7)) + 4|0); //@line 98806 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 98806 "c/sqlite3.c"
 $42 = HEAP16[$27>>1]|0; //@line 98806 "c/sqlite3.c"
 $43 = $42 << 16 >> 16; //@line 98806 "c/sqlite3.c"
 $44 = $43 << 4; //@line 98806 "c/sqlite3.c"
 _memcpy(($37|0),($41|0),($44|0))|0; //@line 98806 "c/sqlite3.c"
 $45 = HEAP16[$27>>1]|0; //@line 98807 "c/sqlite3.c"
 $46 = ($45<<16>>16)>(0); //@line 98807 "c/sqlite3.c"
 if ($46) {
  $$069 = 0;
  while(1) {
   $47 = HEAP32[$34>>2]|0; //@line 98808 "c/sqlite3.c"
   $48 = (($47) + ($$069<<4)|0); //@line 98809 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 98809 "c/sqlite3.c"
   $50 = (_sqlite3DbStrDup($2,$49)|0); //@line 98809 "c/sqlite3.c"
   HEAP32[$48>>2] = $50; //@line 98809 "c/sqlite3.c"
   $51 = (((($47) + ($$069<<4)|0)) + 8|0); //@line 98810 "c/sqlite3.c"
   HEAP32[$51>>2] = 0; //@line 98810 "c/sqlite3.c"
   $52 = (((($47) + ($$069<<4)|0)) + 4|0); //@line 98811 "c/sqlite3.c"
   HEAP32[$52>>2] = 0; //@line 98811 "c/sqlite3.c"
   $53 = (($$069) + 1)|0; //@line 98807 "c/sqlite3.c"
   $54 = HEAP16[$27>>1]|0; //@line 98807 "c/sqlite3.c"
   $55 = $54 << 16 >> 16; //@line 98807 "c/sqlite3.c"
   $56 = ($53|0)<($55|0); //@line 98807 "c/sqlite3.c"
   if ($56) {
    $$069 = $53;
   } else {
    break;
   }
  }
 }
 $57 = ((($2)) + 16|0); //@line 98813 "c/sqlite3.c"
 $58 = HEAP32[$57>>2]|0; //@line 98813 "c/sqlite3.c"
 $59 = (((($58) + ($20<<4)|0)) + 12|0); //@line 98813 "c/sqlite3.c"
 $60 = HEAP32[$59>>2]|0; //@line 98813 "c/sqlite3.c"
 $61 = ((($21)) + 72|0); //@line 98813 "c/sqlite3.c"
 HEAP32[$61>>2] = $60; //@line 98813 "c/sqlite3.c"
 $62 = ((($7)) + 52|0); //@line 98814 "c/sqlite3.c"
 $63 = HEAP32[$62>>2]|0; //@line 98814 "c/sqlite3.c"
 $64 = ((($21)) + 52|0); //@line 98814 "c/sqlite3.c"
 HEAP32[$64>>2] = $63; //@line 98814 "c/sqlite3.c"
 HEAP32[$24>>2] = 1; //@line 98815 "c/sqlite3.c"
 _sqlite3BeginWriteOperation($0,0,$20); //@line 98818 "c/sqlite3.c"
 $65 = (_sqlite3GetVdbe($0)|0); //@line 98819 "c/sqlite3.c"
 $66 = ($65|0)==(0|0); //@line 98820 "c/sqlite3.c"
 if ($66) {
  _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
 }
 _sqlite3ChangeCookie($0,$20); //@line 98821 "c/sqlite3.c"
 _sqlite3SrcListDelete($2,$1); //@line 98824 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98826 "c/sqlite3.c"
}
function _sqlite3VtabFinishParse($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer9 = 0, $vararg_ptr4 = 0, $vararg_ptr5 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer9 = sp + 32|0; //@line 127745 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 127745 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 127745 "c/sqlite3.c"
 $2 = ((($0)) + 432|0); //@line 127746 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 127746 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 127747 "c/sqlite3.c"
 $5 = ($3|0)==(0|0); //@line 127749 "c/sqlite3.c"
 if ($5) {
  STACKTOP = sp;return; //@line 127823 "c/sqlite3.c"
 }
 _addArgumentToVtab($0); //@line 127750 "c/sqlite3.c"
 $6 = ((($0)) + 444|0); //@line 127751 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 127751 "c/sqlite3.c"
 $7 = ((($3)) + 56|0); //@line 127752 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 127752 "c/sqlite3.c"
 $9 = ($8|0)<(1); //@line 127752 "c/sqlite3.c"
 if ($9) {
  STACKTOP = sp;return; //@line 127823 "c/sqlite3.c"
 }
 $10 = ((($4)) + 157|0); //@line 127760 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 127760 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 127760 "c/sqlite3.c"
 if ($12) {
  $13 = ($1|0)==(0|0); //@line 127768 "c/sqlite3.c"
  if (!($13)) {
   $14 = HEAP32[$1>>2]|0; //@line 127769 "c/sqlite3.c"
   $15 = ((($0)) + 380|0); //@line 127769 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 127769 "c/sqlite3.c"
   $17 = (($14) - ($16))|0; //@line 127769 "c/sqlite3.c"
   $18 = ((($1)) + 4|0); //@line 127769 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 127769 "c/sqlite3.c"
   $20 = (($17) + ($19))|0; //@line 127769 "c/sqlite3.c"
   $21 = ((($0)) + 384|0); //@line 127769 "c/sqlite3.c"
   HEAP32[$21>>2] = $20; //@line 127769 "c/sqlite3.c"
  }
  $22 = ((($0)) + 380|0); //@line 127771 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $22; //@line 127771 "c/sqlite3.c"
  $23 = (_sqlite3MPrintf($4,19642,$vararg_buffer)|0); //@line 127771 "c/sqlite3.c"
  $24 = ((($3)) + 72|0); //@line 127781 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 127781 "c/sqlite3.c"
  $26 = (_sqlite3SchemaToIndex($4,$25)|0); //@line 127781 "c/sqlite3.c"
  $27 = ((($4)) + 16|0); //@line 127786 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 127786 "c/sqlite3.c"
  $29 = (($28) + ($26<<4)|0); //@line 127786 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 127786 "c/sqlite3.c"
  $31 = HEAP32[$3>>2]|0; //@line 127787 "c/sqlite3.c"
  $32 = ((($0)) + 96|0); //@line 127790 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 127790 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = $30; //@line 127782 "c/sqlite3.c"
  $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 127782 "c/sqlite3.c"
  HEAP32[$vararg_ptr4>>2] = 19754; //@line 127782 "c/sqlite3.c"
  $vararg_ptr5 = ((($vararg_buffer1)) + 8|0); //@line 127782 "c/sqlite3.c"
  HEAP32[$vararg_ptr5>>2] = $31; //@line 127782 "c/sqlite3.c"
  $vararg_ptr6 = ((($vararg_buffer1)) + 12|0); //@line 127782 "c/sqlite3.c"
  HEAP32[$vararg_ptr6>>2] = $31; //@line 127782 "c/sqlite3.c"
  $vararg_ptr7 = ((($vararg_buffer1)) + 16|0); //@line 127782 "c/sqlite3.c"
  HEAP32[$vararg_ptr7>>2] = $23; //@line 127782 "c/sqlite3.c"
  $vararg_ptr8 = ((($vararg_buffer1)) + 20|0); //@line 127782 "c/sqlite3.c"
  HEAP32[$vararg_ptr8>>2] = $33; //@line 127782 "c/sqlite3.c"
  _sqlite3NestedParse($0,19666,$vararg_buffer1); //@line 127782 "c/sqlite3.c"
  _sqlite3DbFree($4,$23); //@line 127792 "c/sqlite3.c"
  $34 = (_sqlite3GetVdbe($0)|0); //@line 127793 "c/sqlite3.c"
  _sqlite3ChangeCookie($0,$26); //@line 127794 "c/sqlite3.c"
  (_sqlite3VdbeAddOp0($34,152)|0); //@line 127796 "c/sqlite3.c"
  $35 = HEAP32[$3>>2]|0; //@line 127797 "c/sqlite3.c"
  HEAP32[$vararg_buffer9>>2] = $35; //@line 127797 "c/sqlite3.c"
  $36 = (_sqlite3MPrintf($4,19768,$vararg_buffer9)|0); //@line 127797 "c/sqlite3.c"
  _sqlite3VdbeAddParseSchemaOp($34,$26,$36); //@line 127798 "c/sqlite3.c"
  $37 = ((($0)) + 44|0); //@line 127800 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 127800 "c/sqlite3.c"
  $39 = (($38) + 1)|0; //@line 127800 "c/sqlite3.c"
  HEAP32[$37>>2] = $39; //@line 127800 "c/sqlite3.c"
  $40 = HEAP32[$3>>2]|0; //@line 127801 "c/sqlite3.c"
  (_sqlite3VdbeLoadString($34,$39,$40)|0); //@line 127801 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($34,155,$26,$39)|0); //@line 127802 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 127823 "c/sqlite3.c"
 }
 $41 = ((($3)) + 72|0); //@line 127812 "c/sqlite3.c"
 $42 = HEAP32[$41>>2]|0; //@line 127812 "c/sqlite3.c"
 $43 = HEAP32[$3>>2]|0; //@line 127813 "c/sqlite3.c"
 $44 = ((($42)) + 8|0); //@line 127815 "c/sqlite3.c"
 $45 = (_sqlite3HashInsert($44,$43,$3)|0); //@line 127815 "c/sqlite3.c"
 $46 = ($45|0)==(0|0); //@line 127816 "c/sqlite3.c"
 if ($46) {
  HEAP32[$2>>2] = 0; //@line 127821 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 127823 "c/sqlite3.c"
 } else {
  _sqlite3OomFault($4); //@line 127817 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 127823 "c/sqlite3.c"
 }
}
function _sqlite3VtabBeginParse($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3StartTable($0,$1,$2,0,0,1,$4); //@line 127694 "c/sqlite3.c"
 $5 = ((($0)) + 432|0); //@line 127695 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 127695 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 127696 "c/sqlite3.c"
 if ($7) {
  return; //@line 127725 "c/sqlite3.c"
 }
 $8 = HEAP32[$0>>2]|0; //@line 127699 "c/sqlite3.c"
 $9 = ((($6)) + 72|0); //@line 127700 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 127700 "c/sqlite3.c"
 $11 = (_sqlite3SchemaToIndex($8,$10)|0); //@line 127700 "c/sqlite3.c"
 $12 = (_sqlite3NameFromToken($8,$3)|0); //@line 127704 "c/sqlite3.c"
 _addModuleArgument($8,$6,$12); //@line 127704 "c/sqlite3.c"
 _addModuleArgument($8,$6,0); //@line 127705 "c/sqlite3.c"
 $13 = HEAP32[$6>>2]|0; //@line 127706 "c/sqlite3.c"
 $14 = (_sqlite3DbStrDup($8,$13)|0); //@line 127706 "c/sqlite3.c"
 _addModuleArgument($8,$6,$14); //@line 127706 "c/sqlite3.c"
 $15 = HEAP32[$3>>2]|0; //@line 127711 "c/sqlite3.c"
 $16 = ((($3)) + 4|0); //@line 127711 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 127711 "c/sqlite3.c"
 $18 = (($15) + ($17)|0); //@line 127711 "c/sqlite3.c"
 $19 = ((($0)) + 380|0); //@line 127711 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 127711 "c/sqlite3.c"
 $21 = $18; //@line 127711 "c/sqlite3.c"
 $22 = (($21) - ($20))|0; //@line 127711 "c/sqlite3.c"
 $23 = ((($0)) + 384|0); //@line 127710 "c/sqlite3.c"
 HEAP32[$23>>2] = $22; //@line 127710 "c/sqlite3.c"
 $24 = ((($6)) + 60|0); //@line 127720 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 127720 "c/sqlite3.c"
 $26 = ($25|0)==(0|0); //@line 127720 "c/sqlite3.c"
 if ($26) {
  return; //@line 127725 "c/sqlite3.c"
 }
 $27 = HEAP32[$6>>2]|0; //@line 127721 "c/sqlite3.c"
 $28 = HEAP32[$25>>2]|0; //@line 127722 "c/sqlite3.c"
 $29 = HEAP32[$0>>2]|0; //@line 127722 "c/sqlite3.c"
 $30 = ((($29)) + 16|0); //@line 127722 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 127722 "c/sqlite3.c"
 $32 = (($31) + ($11<<4)|0); //@line 127722 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 127722 "c/sqlite3.c"
 (_sqlite3AuthCheck($0,29,$27,$28,$33)|0); //@line 127721 "c/sqlite3.c"
 return; //@line 127725 "c/sqlite3.c"
}
function _sqlite3VtabArgInit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _addArgumentToVtab($0); //@line 127830 "c/sqlite3.c"
 $1 = ((($0)) + 444|0); //@line 127831 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 127831 "c/sqlite3.c"
 $2 = ((($0)) + 448|0); //@line 127832 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 127832 "c/sqlite3.c"
 return; //@line 127833 "c/sqlite3.c"
}
function _sqlite3VtabArgExtend($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 444|0); //@line 127841 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 127841 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 127841 "c/sqlite3.c"
 $5 = HEAP32[$1>>2]|0;
 if ($4) {
  HEAP32[$2>>2] = $5; //@line 127842 "c/sqlite3.c"
  $6 = ((($1)) + 4|0); //@line 127843 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 127843 "c/sqlite3.c"
  $$sink = $7;
  $14 = ((($0)) + 448|0);
  HEAP32[$14>>2] = $$sink;
  return; //@line 127848 "c/sqlite3.c"
 } else {
  $8 = ((($1)) + 4|0); //@line 127846 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 127846 "c/sqlite3.c"
  $10 = (($5) + ($9)|0); //@line 127846 "c/sqlite3.c"
  $11 = $10; //@line 127846 "c/sqlite3.c"
  $12 = $3; //@line 127846 "c/sqlite3.c"
  $13 = (($11) - ($12))|0; //@line 127846 "c/sqlite3.c"
  $$sink = $13;
  $14 = ((($0)) + 448|0);
  HEAP32[$14>>2] = $$sink;
  return; //@line 127848 "c/sqlite3.c"
 }
}
function _sqlite3WithAdd($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0$in = 0, $$04950 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 106014 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 106020 "c/sqlite3.c"
 $6 = (_sqlite3NameFromToken($5,$2)|0); //@line 106026 "c/sqlite3.c"
 $7 = ($6|0)!=(0|0); //@line 106027 "c/sqlite3.c"
 $8 = ($1|0)!=(0|0); //@line 106027 "c/sqlite3.c"
 $or$cond = $8 & $7; //@line 106027 "c/sqlite3.c"
 if ($or$cond) {
  $9 = HEAP32[$1>>2]|0; //@line 106029 "c/sqlite3.c"
  $10 = ($9|0)>(0); //@line 106029 "c/sqlite3.c"
  if ($10) {
   $$04950 = 0;
   while(1) {
    $11 = (((($1)) + 8|0) + ($$04950<<4)|0); //@line 106030 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 106030 "c/sqlite3.c"
    $13 = (_sqlite3StrICmp($6,$12)|0); //@line 106030 "c/sqlite3.c"
    $14 = ($13|0)==(0); //@line 106030 "c/sqlite3.c"
    if ($14) {
     HEAP32[$vararg_buffer>>2] = $6; //@line 106031 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,19589,$vararg_buffer); //@line 106031 "c/sqlite3.c"
    }
    $15 = (($$04950) + 1)|0; //@line 106029 "c/sqlite3.c"
    $16 = HEAP32[$1>>2]|0; //@line 106029 "c/sqlite3.c"
    $17 = ($15|0)<($16|0); //@line 106029 "c/sqlite3.c"
    if ($17) {
     $$04950 = $15;
    } else {
     break;
    }
   }
  }
 }
 if ($8) {
  $18 = HEAP32[$1>>2]|0; //@line 106037 "c/sqlite3.c"
  $19 = $18 << 4; //@line 106037 "c/sqlite3.c"
  $20 = (($19) + 24)|0; //@line 106037 "c/sqlite3.c"
  $21 = ($20|0)<(0); //@line 106038 "c/sqlite3.c"
  $22 = $21 << 31 >> 31; //@line 106038 "c/sqlite3.c"
  $23 = (_sqlite3DbRealloc($5,$1,$20,$22)|0); //@line 106038 "c/sqlite3.c"
  $$0$in = $23;
 } else {
  $24 = (_sqlite3DbMallocZero($5,24,0)|0); //@line 106040 "c/sqlite3.c"
  $$0$in = $24;
 }
 $25 = ((($5)) + 73|0); //@line 106044 "c/sqlite3.c"
 $26 = HEAP8[$25>>0]|0; //@line 106044 "c/sqlite3.c"
 $27 = ($26<<24>>24)==(0); //@line 106044 "c/sqlite3.c"
 if ($27) {
  $28 = ((($$0$in)) + 8|0); //@line 106050 "c/sqlite3.c"
  $29 = HEAP32[$$0$in>>2]|0; //@line 106050 "c/sqlite3.c"
  $30 = (((($28) + ($29<<4)|0)) + 8|0); //@line 106050 "c/sqlite3.c"
  HEAP32[$30>>2] = $4; //@line 106050 "c/sqlite3.c"
  $31 = (((($28) + ($29<<4)|0)) + 4|0); //@line 106051 "c/sqlite3.c"
  HEAP32[$31>>2] = $3; //@line 106051 "c/sqlite3.c"
  $32 = (($28) + ($29<<4)|0); //@line 106052 "c/sqlite3.c"
  HEAP32[$32>>2] = $6; //@line 106052 "c/sqlite3.c"
  $33 = (((($28) + ($29<<4)|0)) + 12|0); //@line 106053 "c/sqlite3.c"
  HEAP32[$33>>2] = 0; //@line 106053 "c/sqlite3.c"
  $34 = (($29) + 1)|0; //@line 106054 "c/sqlite3.c"
  HEAP32[$$0$in>>2] = $34; //@line 106054 "c/sqlite3.c"
  $$1 = $$0$in;
  STACKTOP = sp;return ($$1|0); //@line 106057 "c/sqlite3.c"
 } else {
  _sqlite3ExprListDelete($5,$3); //@line 106045 "c/sqlite3.c"
  _sqlite3SelectDelete($5,$4); //@line 106046 "c/sqlite3.c"
  _sqlite3DbFree($5,$6); //@line 106047 "c/sqlite3.c"
  $$1 = $1;
  STACKTOP = sp;return ($$1|0); //@line 106057 "c/sqlite3.c"
 }
 return (0)|0;
}
function _yy_find_reduce_action($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (7944 + ($0<<1)|0); //@line 140066 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 140066 "c/sqlite3.c"
 $4 = $3 << 16 >> 16; //@line 140066 "c/sqlite3.c"
 $5 = $1&255; //@line 140068 "c/sqlite3.c"
 $6 = (($4) + ($5))|0; //@line 140068 "c/sqlite3.c"
 $7 = (8614 + ($6<<1)|0); //@line 140077 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 140077 "c/sqlite3.c"
 $9 = $8&65535; //@line 140077 "c/sqlite3.c"
 return ($9|0); //@line 140077 "c/sqlite3.c"
}
function _sqlite3NameFromToken($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 102306 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 102312 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 102307 "c/sqlite3.c"
 $4 = ((($1)) + 4|0); //@line 102307 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 102307 "c/sqlite3.c"
 $6 = (_sqlite3DbStrNDup($0,$3,$5,0)|0); //@line 102307 "c/sqlite3.c"
 _sqlite3Dequote($6); //@line 102308 "c/sqlite3.c"
 $$0 = $6;
 return ($$0|0); //@line 102312 "c/sqlite3.c"
}
function _sqlite3Dequote($0) {
 $0 = $0|0;
 var $$0 = 0, $$021 = 0, $$1 = 0, $$122 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 28716 "c/sqlite3.c"
 if ($1) {
  return; //@line 28734 "c/sqlite3.c"
 }
 $2 = HEAP8[$0>>0]|0; //@line 28717 "c/sqlite3.c"
 $3 = $2&255; //@line 28718 "c/sqlite3.c"
 $4 = (16281 + ($3)|0); //@line 28718 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 28718 "c/sqlite3.c"
 $6 = ($5<<24>>24)<(0); //@line 28718 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 28734 "c/sqlite3.c"
 }
 $7 = ($2<<24>>24)==(91); //@line 28719 "c/sqlite3.c"
 $spec$select = $7 ? 93 : $2; //@line 28719 "c/sqlite3.c"
 $$0 = 0;$$021 = 1;
 while(1) {
  $8 = (($0) + ($$021)|0); //@line 28722 "c/sqlite3.c"
  $9 = HEAP8[$8>>0]|0; //@line 28722 "c/sqlite3.c"
  $10 = ($9<<24>>24)==($spec$select<<24>>24); //@line 28722 "c/sqlite3.c"
  if ($10) {
   $11 = (($$021) + 1)|0; //@line 28723 "c/sqlite3.c"
   $12 = (($0) + ($11)|0); //@line 28723 "c/sqlite3.c"
   $13 = HEAP8[$12>>0]|0; //@line 28723 "c/sqlite3.c"
   $14 = ($13<<24>>24)==($spec$select<<24>>24); //@line 28723 "c/sqlite3.c"
   $15 = (($0) + ($$0)|0);
   if (!($14)) {
    break;
   }
   HEAP8[$15>>0] = $spec$select; //@line 28724 "c/sqlite3.c"
   $$122 = $11;
  } else {
   $16 = (($0) + ($$0)|0); //@line 28730 "c/sqlite3.c"
   HEAP8[$16>>0] = $9; //@line 28730 "c/sqlite3.c"
   $$122 = $$021;
  }
  $$1 = (($$0) + 1)|0;
  $17 = (($$122) + 1)|0; //@line 28720 "c/sqlite3.c"
  $$0 = $$1;$$021 = $17;
 }
 HEAP8[$15>>0] = 0; //@line 28733 "c/sqlite3.c"
 return; //@line 28734 "c/sqlite3.c"
}
function _addArgumentToVtab($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 444|0); //@line 127733 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 127733 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 127733 "c/sqlite3.c"
 if ($3) {
  return; //@line 127739 "c/sqlite3.c"
 }
 $4 = ((($0)) + 432|0); //@line 127733 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 127733 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 127733 "c/sqlite3.c"
 if ($6) {
  return; //@line 127739 "c/sqlite3.c"
 }
 $7 = ((($0)) + 448|0); //@line 127735 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 127735 "c/sqlite3.c"
 $9 = HEAP32[$0>>2]|0; //@line 127736 "c/sqlite3.c"
 $10 = ($8|0)<(0); //@line 127737 "c/sqlite3.c"
 $11 = $10 << 31 >> 31; //@line 127737 "c/sqlite3.c"
 $12 = (_sqlite3DbStrNDup($9,$2,$8,$11)|0); //@line 127737 "c/sqlite3.c"
 _addModuleArgument($9,$5,$12); //@line 127737 "c/sqlite3.c"
 return; //@line 127739 "c/sqlite3.c"
}
function _addModuleArgument($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 56|0); //@line 127665 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 127665 "c/sqlite3.c"
 $5 = $4 << 2; //@line 127665 "c/sqlite3.c"
 $6 = (($5) + 8)|0; //@line 127665 "c/sqlite3.c"
 $7 = ((($1)) + 60|0); //@line 127667 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 127667 "c/sqlite3.c"
 $9 = ($6|0)<(0); //@line 127667 "c/sqlite3.c"
 $10 = $9 << 31 >> 31; //@line 127667 "c/sqlite3.c"
 $11 = (_sqlite3DbRealloc($0,$8,$6,$10)|0); //@line 127667 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 127668 "c/sqlite3.c"
 if ($12) {
  _sqlite3DbFree($0,$2); //@line 127669 "c/sqlite3.c"
  return; //@line 127676 "c/sqlite3.c"
 } else {
  $13 = HEAP32[$3>>2]|0; //@line 127671 "c/sqlite3.c"
  $14 = (($13) + 1)|0; //@line 127671 "c/sqlite3.c"
  HEAP32[$3>>2] = $14; //@line 127671 "c/sqlite3.c"
  $15 = (($11) + ($13<<2)|0); //@line 127672 "c/sqlite3.c"
  HEAP32[$15>>2] = $2; //@line 127672 "c/sqlite3.c"
  $16 = (($11) + ($14<<2)|0); //@line 127673 "c/sqlite3.c"
  HEAP32[$16>>2] = 0; //@line 127673 "c/sqlite3.c"
  HEAP32[$7>>2] = $11; //@line 127674 "c/sqlite3.c"
  return; //@line 127676 "c/sqlite3.c"
 }
}
function _sqlite3SchemaToIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 118259 "c/sqlite3.c"
 if ($2) {
  $$1 = -1000000;
  return ($$1|0); //@line 118268 "c/sqlite3.c"
 }
 $3 = ((($0)) + 16|0);
 $4 = HEAP32[$3>>2]|0;
 $$0 = 0;
 while(1) {
  $5 = (((($4) + ($$0<<4)|0)) + 12|0); //@line 118262 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 118262 "c/sqlite3.c"
  $7 = ($6|0)==($1|0); //@line 118262 "c/sqlite3.c"
  $8 = (($$0) + 1)|0; //@line 118260 "c/sqlite3.c"
  if ($7) {
   $$1 = $$0;
   break;
  } else {
   $$0 = $8;
  }
 }
 return ($$1|0); //@line 118268 "c/sqlite3.c"
}
function _sqlite3AuthCheck($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$022 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 101542 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 101548 "c/sqlite3.c"
 $6 = ((($5)) + 157|0); //@line 101554 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 101554 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 101554 "c/sqlite3.c"
 do {
  if ($8) {
   $9 = ((($0)) + 400|0); //@line 101554 "c/sqlite3.c"
   $10 = HEAP8[$9>>0]|0; //@line 101554 "c/sqlite3.c"
   $11 = ($10<<24>>24)==(0); //@line 101554 "c/sqlite3.c"
   if ($11) {
    $12 = ((($5)) + 304|0); //@line 101558 "c/sqlite3.c"
    $13 = HEAP32[$12>>2]|0; //@line 101558 "c/sqlite3.c"
    $14 = ($13|0)==(0|0); //@line 101558 "c/sqlite3.c"
    if ($14) {
     $$022 = 0;
    } else {
     $15 = ((($5)) + 308|0); //@line 101573 "c/sqlite3.c"
     $16 = HEAP32[$15>>2]|0; //@line 101573 "c/sqlite3.c"
     $17 = ((($0)) + 440|0); //@line 101573 "c/sqlite3.c"
     $18 = HEAP32[$17>>2]|0; //@line 101573 "c/sqlite3.c"
     $19 = (FUNCTION_TABLE_iiiiiii[$13 & 127]($16,$1,$2,$3,$4,$18)|0); //@line 101573 "c/sqlite3.c"
     $20 = ($19|0)==(1); //@line 101578 "c/sqlite3.c"
     if ($20) {
      _sqlite3ErrorMsg($0,17871,$vararg_buffer); //@line 101579 "c/sqlite3.c"
      $21 = ((($0)) + 12|0); //@line 101580 "c/sqlite3.c"
      HEAP32[$21>>2] = 23; //@line 101580 "c/sqlite3.c"
      $$022 = 1;
      break;
     }
     $22 = $19 | 2; //@line 101581 "c/sqlite3.c"
     $23 = ($22|0)==(2); //@line 101581 "c/sqlite3.c"
     if ($23) {
      $$022 = $19;
     } else {
      _sqliteAuthBadReturnCode($0); //@line 101583 "c/sqlite3.c"
      $$022 = 1;
     }
    }
   } else {
    $$022 = 0;
   }
  } else {
   $$022 = 0;
  }
 } while(0);
 STACKTOP = sp;return ($$022|0); //@line 101586 "c/sqlite3.c"
}
function _sqliteAuthBadReturnCode($0) {
 $0 = $0|0;
 var $1 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 101434 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,19619,$vararg_buffer); //@line 101435 "c/sqlite3.c"
 $1 = ((($0)) + 12|0); //@line 101436 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 101436 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 101437 "c/sqlite3.c"
}
function _sqlite3NestedParse($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0;
 var stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $2 = sp + 8|0;
 $3 = sp;
 $4 = sp + 24|0;
 HEAP32[$3>>2] = 0; //@line 101872 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 101873 "c/sqlite3.c"
 $6 = ((($0)) + 36|0); //@line 101876 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 101876 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 101876 "c/sqlite3.c"
 if (!($8)) {
  STACKTOP = sp;return; //@line 101892 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = $varargs; //@line 101878 "c/sqlite3.c"
 $9 = (_sqlite3VMPrintf($5,$1,$2)|0); //@line 101879 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 101881 "c/sqlite3.c"
 if ($10) {
  STACKTOP = sp;return; //@line 101892 "c/sqlite3.c"
 }
 $11 = ((($0)) + 18|0); //@line 101884 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 101884 "c/sqlite3.c"
 $13 = (($12) + 1)<<24>>24; //@line 101884 "c/sqlite3.c"
 HEAP8[$11>>0] = $13; //@line 101884 "c/sqlite3.c"
 $14 = ((($0)) + 388|0); //@line 101885 "c/sqlite3.c"
 dest=$4; src=$14; stop=dest+84|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 101885 "c/sqlite3.c"
 dest=$14; stop=dest+84|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 101886 "c/sqlite3.c"
 (_sqlite3RunParser($0,$9,$3)|0); //@line 101887 "c/sqlite3.c"
 $15 = HEAP32[$3>>2]|0; //@line 101888 "c/sqlite3.c"
 _sqlite3DbFree($5,$15); //@line 101888 "c/sqlite3.c"
 _sqlite3DbFree($5,$9); //@line 101889 "c/sqlite3.c"
 dest=$14; src=$4; stop=dest+84|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 101890 "c/sqlite3.c"
 $16 = HEAP8[$11>>0]|0; //@line 101891 "c/sqlite3.c"
 $17 = (($16) + -1)<<24>>24; //@line 101891 "c/sqlite3.c"
 HEAP8[$11>>0] = $17; //@line 101891 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 101892 "c/sqlite3.c"
}
function _sqlite3GetVdbe($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 120544 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 120544 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 120544 "c/sqlite3.c"
 if (!($3)) {
  $$0 = $2;
  return ($$0|0); //@line 120553 "c/sqlite3.c"
 }
 $4 = ((($0)) + 120|0); //@line 120547 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 120547 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 120547 "c/sqlite3.c"
 if ($6) {
  $7 = HEAP32[$0>>2]|0; //@line 120548 "c/sqlite3.c"
  $8 = ((($7)) + 68|0); //@line 120548 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 120548 "c/sqlite3.c"
  $10 = $9 & 8; //@line 120548 "c/sqlite3.c"
  $11 = ($10<<16>>16)==(0); //@line 120548 "c/sqlite3.c"
  if ($11) {
   $12 = ((($0)) + 23|0); //@line 120550 "c/sqlite3.c"
   HEAP8[$12>>0] = 1; //@line 120550 "c/sqlite3.c"
  }
 }
 $13 = (_sqlite3VdbeCreate($0)|0); //@line 120552 "c/sqlite3.c"
 $$0 = $13;
 return ($$0|0); //@line 120553 "c/sqlite3.c"
}
function _sqlite3ChangeCookie($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 103099 "c/sqlite3.c"
 $3 = ((($0)) + 8|0); //@line 103100 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 103100 "c/sqlite3.c"
 $5 = ((($2)) + 16|0); //@line 103103 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 103103 "c/sqlite3.c"
 $7 = (((($6) + ($1<<4)|0)) + 12|0); //@line 103103 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 103103 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 103103 "c/sqlite3.c"
 $10 = (($9) + 1)|0; //@line 103103 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($4,103,$1,1,$10)|0); //@line 103102 "c/sqlite3.c"
 return; //@line 103104 "c/sqlite3.c"
}
function _sqlite3VdbeAddOp0($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3VdbeAddOp3($0,$1,0,0,0)|0); //@line 73178 "c/sqlite3.c"
 return ($2|0); //@line 73178 "c/sqlite3.c"
}
function _sqlite3VdbeAddParseSchemaOp($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$08 = 0, $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3VdbeAddOp4($0,138,$1,0,0,$2,-7)|0); //@line 73276 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 73277 "c/sqlite3.c"
 $4 = ((($3)) + 20|0); //@line 73277 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 73277 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 73277 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 73278 "c/sqlite3.c"
 }
 $$08 = 0;
 while(1) {
  _sqlite3VdbeUsesBtree($0,$$08); //@line 73277 "c/sqlite3.c"
  $7 = (($$08) + 1)|0; //@line 73277 "c/sqlite3.c"
  $8 = HEAP32[$0>>2]|0; //@line 73277 "c/sqlite3.c"
  $9 = ((($8)) + 20|0); //@line 73277 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 73277 "c/sqlite3.c"
  $11 = ($7|0)<($10|0); //@line 73277 "c/sqlite3.c"
  if ($11) {
   $$08 = $7;
  } else {
   break;
  }
 }
 return; //@line 73278 "c/sqlite3.c"
}
function _sqlite3VdbeLoadString($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeAddOp4($0,97,0,$1,0,$2,0)|0); //@line 73197 "c/sqlite3.c"
 return ($3|0); //@line 73197 "c/sqlite3.c"
}
function _sqlite3VdbeAddOp2($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3VdbeAddOp3($0,$1,$2,$3,0)|0); //@line 73184 "c/sqlite3.c"
 return ($4|0); //@line 73184 "c/sqlite3.c"
}
function _sqlite3VdbeAddOp3($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 136|0); //@line 73136 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 73136 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 73139 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 73139 "c/sqlite3.c"
 $9 = ((($8)) + 48|0); //@line 73139 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 73139 "c/sqlite3.c"
 $11 = ($10|0)>($6|0); //@line 73139 "c/sqlite3.c"
 if ($11) {
  $13 = (($6) + 1)|0; //@line 73142 "c/sqlite3.c"
  HEAP32[$5>>2] = $13; //@line 73142 "c/sqlite3.c"
  $14 = ((($0)) + 88|0); //@line 73143 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 73143 "c/sqlite3.c"
  $16 = $1&255; //@line 73144 "c/sqlite3.c"
  $17 = (($15) + (($6*20)|0)|0); //@line 73144 "c/sqlite3.c"
  HEAP8[$17>>0] = $16; //@line 73144 "c/sqlite3.c"
  $18 = (((($15) + (($6*20)|0)|0)) + 2|0); //@line 73145 "c/sqlite3.c"
  HEAP16[$18>>1] = 0; //@line 73145 "c/sqlite3.c"
  $19 = (((($15) + (($6*20)|0)|0)) + 4|0); //@line 73146 "c/sqlite3.c"
  HEAP32[$19>>2] = $2; //@line 73146 "c/sqlite3.c"
  $20 = (((($15) + (($6*20)|0)|0)) + 8|0); //@line 73147 "c/sqlite3.c"
  HEAP32[$20>>2] = $3; //@line 73147 "c/sqlite3.c"
  $21 = (((($15) + (($6*20)|0)|0)) + 12|0); //@line 73148 "c/sqlite3.c"
  HEAP32[$21>>2] = $4; //@line 73148 "c/sqlite3.c"
  $22 = (((($15) + (($6*20)|0)|0)) + 16|0); //@line 73149 "c/sqlite3.c"
  HEAP32[$22>>2] = 0; //@line 73149 "c/sqlite3.c"
  $23 = (((($15) + (($6*20)|0)|0)) + 1|0); //@line 73150 "c/sqlite3.c"
  HEAP8[$23>>0] = 0; //@line 73150 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 73176 "c/sqlite3.c"
 } else {
  $12 = (_growOp3($0,$1,$2,$3,$4)|0); //@line 73140 "c/sqlite3.c"
  $$0 = $12;
  return ($$0|0); //@line 73176 "c/sqlite3.c"
 }
 return (0)|0;
}
function _growOp3($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_growOpArray($0)|0); //@line 73128 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 73128 "c/sqlite3.c"
 if ($6) {
  $7 = (_sqlite3VdbeAddOp3($0,$1,$2,$3,$4)|0); //@line 73130 "c/sqlite3.c"
  $$0 = $7;
 } else {
  $$0 = 1;
 }
 return ($$0|0); //@line 73131 "c/sqlite3.c"
}
function _growOpArray($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 73066 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 73066 "c/sqlite3.c"
 $3 = ((($2)) + 48|0); //@line 73078 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 73078 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 73078 "c/sqlite3.c"
 $6 = $4 << 1; //@line 73078 "c/sqlite3.c"
 $spec$select = $5 ? 51 : $6; //@line 73078 "c/sqlite3.c"
 $7 = HEAP32[$2>>2]|0; //@line 73083 "c/sqlite3.c"
 $8 = ((($7)) + 120|0); //@line 73083 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 73083 "c/sqlite3.c"
 $10 = ($spec$select|0)>($9|0); //@line 73083 "c/sqlite3.c"
 if ($10) {
  _sqlite3OomFault($7); //@line 73084 "c/sqlite3.c"
  $$0 = 7;
  return ($$0|0); //@line 73097 "c/sqlite3.c"
 }
 $11 = ((($0)) + 88|0); //@line 73090 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 73090 "c/sqlite3.c"
 $13 = ($spec$select*20)|0; //@line 73090 "c/sqlite3.c"
 $14 = (_sqlite3DbRealloc($7,$12,$13,0)|0); //@line 73090 "c/sqlite3.c"
 $15 = ($14|0)!=(0|0); //@line 73091 "c/sqlite3.c"
 if ($15) {
  $16 = HEAP32[$2>>2]|0; //@line 73092 "c/sqlite3.c"
  $17 = (_sqlite3DbMallocSize($16,$14)|0); //@line 73092 "c/sqlite3.c"
  $18 = ((($2)) + 52|0); //@line 73092 "c/sqlite3.c"
  HEAP32[$18>>2] = $17; //@line 73092 "c/sqlite3.c"
  $19 = (($17>>>0) / 20)&-1; //@line 73093 "c/sqlite3.c"
  HEAP32[$3>>2] = $19; //@line 73093 "c/sqlite3.c"
  HEAP32[$11>>2] = $14; //@line 73094 "c/sqlite3.c"
 }
 $20 = $15 ? 0 : 7; //@line 73096 "c/sqlite3.c"
 $$0 = $20;
 return ($$0|0); //@line 73097 "c/sqlite3.c"
}
function _sqlite3VdbeAddOp4($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $7 = (_sqlite3VdbeAddOp3($0,$1,$2,$3,$4)|0); //@line 73243 "c/sqlite3.c"
 _sqlite3VdbeChangeP4($0,$7,$5,$6); //@line 73244 "c/sqlite3.c"
 return ($7|0); //@line 73245 "c/sqlite3.c"
}
function _sqlite3VdbeChangeP4($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 73958 "c/sqlite3.c"
 $5 = ((($4)) + 73|0); //@line 73961 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 73961 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 73961 "c/sqlite3.c"
 if (!($7)) {
  $8 = ($3|0)==(-12); //@line 73962 "c/sqlite3.c"
  if ($8) {
   return; //@line 73986 "c/sqlite3.c"
  }
  _freeP4($4,$3,$2); //@line 73962 "c/sqlite3.c"
  return; //@line 73986 "c/sqlite3.c"
 }
 $9 = ($1|0)<(0); //@line 73967 "c/sqlite3.c"
 if ($9) {
  $10 = ((($0)) + 136|0); //@line 73968 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 73968 "c/sqlite3.c"
  $12 = (($11) + -1)|0; //@line 73968 "c/sqlite3.c"
  $$0 = $12;
 } else {
  $$0 = $1;
 }
 $13 = ((($0)) + 88|0); //@line 73970 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 73970 "c/sqlite3.c"
 $15 = (($14) + (($$0*20)|0)|0); //@line 73970 "c/sqlite3.c"
 $16 = ($3|0)>(-1); //@line 73971 "c/sqlite3.c"
 if (!($16)) {
  $17 = (((($14) + (($$0*20)|0)|0)) + 1|0); //@line 73971 "c/sqlite3.c"
  $18 = HEAP8[$17>>0]|0; //@line 73971 "c/sqlite3.c"
  $19 = ($18<<24>>24)==(0); //@line 73971 "c/sqlite3.c"
  if ($19) {
   $20 = ($3|0)==(-3); //@line 73975 "c/sqlite3.c"
   if ($20) {
    $21 = $2; //@line 73978 "c/sqlite3.c"
    $22 = (((($14) + (($$0*20)|0)|0)) + 16|0); //@line 73978 "c/sqlite3.c"
    HEAP32[$22>>2] = $21; //@line 73978 "c/sqlite3.c"
    HEAP8[$17>>0] = -3; //@line 73979 "c/sqlite3.c"
    return; //@line 73986 "c/sqlite3.c"
   }
   $23 = ($2|0)==(0|0); //@line 73980 "c/sqlite3.c"
   if ($23) {
    return; //@line 73986 "c/sqlite3.c"
   }
   $24 = (((($14) + (($$0*20)|0)|0)) + 16|0); //@line 73982 "c/sqlite3.c"
   HEAP32[$24>>2] = $2; //@line 73982 "c/sqlite3.c"
   $25 = $3&255; //@line 73983 "c/sqlite3.c"
   HEAP8[$17>>0] = $25; //@line 73983 "c/sqlite3.c"
   $26 = ($3|0)==(-12); //@line 73984 "c/sqlite3.c"
   if (!($26)) {
    return; //@line 73986 "c/sqlite3.c"
   }
   _sqlite3VtabLock($2); //@line 73984 "c/sqlite3.c"
   return; //@line 73986 "c/sqlite3.c"
  }
 }
 _vdbeChangeP4Full($0,$15,$2,$3); //@line 73972 "c/sqlite3.c"
 return; //@line 73986 "c/sqlite3.c"
}
function _vdbeChangeP4Full($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($1)) + 1|0); //@line 73941 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 73941 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 73941 "c/sqlite3.c"
 if (!($6)) {
  $7 = HEAP32[$0>>2]|0; //@line 73942 "c/sqlite3.c"
  $8 = $5 << 24 >> 24; //@line 73942 "c/sqlite3.c"
  $9 = ((($1)) + 16|0); //@line 73942 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 73942 "c/sqlite3.c"
  _freeP4($7,$8,$10); //@line 73942 "c/sqlite3.c"
  HEAP8[$4>>0] = 0; //@line 73943 "c/sqlite3.c"
  HEAP32[$9>>2] = 0; //@line 73944 "c/sqlite3.c"
 }
 $11 = ($3|0)<(0); //@line 73946 "c/sqlite3.c"
 if ($11) {
  $12 = ((($0)) + 88|0); //@line 73947 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 73947 "c/sqlite3.c"
  $14 = $1; //@line 73947 "c/sqlite3.c"
  $15 = (($14) - ($13))|0; //@line 73947 "c/sqlite3.c"
  $16 = (($15|0) / 20)&-1; //@line 73947 "c/sqlite3.c"
  _sqlite3VdbeChangeP4($0,$16,$2,$3); //@line 73947 "c/sqlite3.c"
  return; //@line 73953 "c/sqlite3.c"
 }
 $17 = ($3|0)==(0); //@line 73949 "c/sqlite3.c"
 if ($17) {
  $18 = (_sqlite3Strlen30($2)|0); //@line 73949 "c/sqlite3.c"
  $$0 = $18;
 } else {
  $$0 = $3;
 }
 $19 = HEAP32[$0>>2]|0; //@line 73950 "c/sqlite3.c"
 $20 = ($$0|0)<(0); //@line 73950 "c/sqlite3.c"
 $21 = $20 << 31 >> 31; //@line 73950 "c/sqlite3.c"
 $22 = (_sqlite3DbStrNDup($19,$2,$$0,$21)|0); //@line 73950 "c/sqlite3.c"
 $23 = ((($1)) + 16|0); //@line 73950 "c/sqlite3.c"
 HEAP32[$23>>2] = $22; //@line 73950 "c/sqlite3.c"
 HEAP8[$4>>0] = -7; //@line 73951 "c/sqlite3.c"
 return; //@line 73953 "c/sqlite3.c"
}
function _sqlite3VtabLock($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 127494 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 127494 "c/sqlite3.c"
 $3 = (($2) + 1)|0; //@line 127494 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 127494 "c/sqlite3.c"
 return; //@line 127495 "c/sqlite3.c"
}
function _sqlite3VdbeUsesBtree($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = 1 << $1; //@line 74405 "c/sqlite3.c"
 $3 = ((($0)) + 148|0); //@line 74405 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 74405 "c/sqlite3.c"
 $5 = $4 | $2; //@line 74405 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 74405 "c/sqlite3.c"
 $6 = ($1|0)==(1); //@line 74406 "c/sqlite3.c"
 if ($6) {
  return; //@line 74409 "c/sqlite3.c"
 }
 $7 = HEAP32[$0>>2]|0; //@line 74406 "c/sqlite3.c"
 $8 = ((($7)) + 16|0); //@line 74406 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 74406 "c/sqlite3.c"
 $10 = (((($9) + ($1<<4)|0)) + 4|0); //@line 74406 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 74406 "c/sqlite3.c"
 $12 = (_sqlite3BtreeSharable($11)|0); //@line 74406 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 74406 "c/sqlite3.c"
 if ($13) {
  return; //@line 74409 "c/sqlite3.c"
 }
 $14 = ((($0)) + 152|0); //@line 74407 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 74407 "c/sqlite3.c"
 $16 = $15 | $2; //@line 74407 "c/sqlite3.c"
 HEAP32[$14>>2] = $16; //@line 74407 "c/sqlite3.c"
 return; //@line 74409 "c/sqlite3.c"
}
function _sqlite3BtreeSharable($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 9|0); //@line 70372 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 70372 "c/sqlite3.c"
 $3 = $2&255; //@line 70372 "c/sqlite3.c"
 return ($3|0); //@line 70372 "c/sqlite3.c"
}
function _sqlite3VdbeCreate($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 72982 "c/sqlite3.c"
 $2 = (_sqlite3DbMallocRawNN($1,216,0)|0); //@line 72984 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 72985 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  return ($$0|0); //@line 73003 "c/sqlite3.c"
 }
 $4 = ((($2)) + 88|0); //@line 72986 "c/sqlite3.c"
 dest=$4; stop=dest+128|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 72986 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 72987 "c/sqlite3.c"
 $5 = ((($1)) + 4|0); //@line 72988 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 72988 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 72988 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($6)) + 4|0); //@line 72989 "c/sqlite3.c"
  HEAP32[$8>>2] = $2; //@line 72989 "c/sqlite3.c"
 }
 $9 = HEAP32[$5>>2]|0; //@line 72991 "c/sqlite3.c"
 $10 = ((($2)) + 8|0); //@line 72991 "c/sqlite3.c"
 HEAP32[$10>>2] = $9; //@line 72991 "c/sqlite3.c"
 $11 = ((($2)) + 4|0); //@line 72992 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 72992 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 72993 "c/sqlite3.c"
 $12 = ((($2)) + 20|0); //@line 72994 "c/sqlite3.c"
 HEAP32[$12>>2] = 381479589; //@line 72994 "c/sqlite3.c"
 $13 = ((($2)) + 12|0); //@line 72995 "c/sqlite3.c"
 HEAP32[$13>>2] = $0; //@line 72995 "c/sqlite3.c"
 $14 = ((($0)) + 8|0); //@line 72996 "c/sqlite3.c"
 HEAP32[$14>>2] = $2; //@line 72996 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($2,62,0,1)|0); //@line 73001 "c/sqlite3.c"
 $$0 = $2;
 return ($$0|0); //@line 73003 "c/sqlite3.c"
}
function _sqlite3LocateTableItem($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 102017 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 102017 "c/sqlite3.c"
 if ($4) {
  $10 = ((($2)) + 4|0); //@line 102021 "c/sqlite3.c"
  $$0$in = $10;
 } else {
  $5 = HEAP32[$0>>2]|0; //@line 102018 "c/sqlite3.c"
  $6 = (_sqlite3SchemaToIndex($5,$3)|0); //@line 102018 "c/sqlite3.c"
  $7 = ((($5)) + 16|0); //@line 102019 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 102019 "c/sqlite3.c"
  $9 = (($8) + ($6<<4)|0); //@line 102019 "c/sqlite3.c"
  $$0$in = $9;
 }
 $$0 = HEAP32[$$0$in>>2]|0;
 $11 = ((($2)) + 8|0); //@line 102023 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 102023 "c/sqlite3.c"
 $13 = (_sqlite3LocateTable($0,$1,$12,$$0)|0); //@line 102023 "c/sqlite3.c"
 return ($13|0); //@line 102023 "c/sqlite3.c"
}
function _isSystemTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 98396 "c/sqlite3.c"
 $2 = (_sqlite3_strnicmp($1,19990,7)|0); //@line 98397 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 98397 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 98402 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer>>2] = $1; //@line 98398 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,19998,$vararg_buffer); //@line 98398 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 98402 "c/sqlite3.c"
}
function _sqlite3BeginWriteOperation($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 120|0); //@line 105716 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 105716 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 105716 "c/sqlite3.c"
 $spec$select = $5 ? $0 : $4; //@line 105716 "c/sqlite3.c"
 _sqlite3CodeVerifySchema($0,$2); //@line 105717 "c/sqlite3.c"
 $6 = 1 << $2; //@line 105718 "c/sqlite3.c"
 $7 = ((($spec$select)) + 88|0); //@line 105718 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 105718 "c/sqlite3.c"
 $9 = $8 | $6; //@line 105718 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 105718 "c/sqlite3.c"
 $10 = ((($spec$select)) + 20|0); //@line 105719 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 105719 "c/sqlite3.c"
 $12 = $11&255; //@line 105719 "c/sqlite3.c"
 $13 = $12 | $1; //@line 105719 "c/sqlite3.c"
 $14 = $13&255; //@line 105719 "c/sqlite3.c"
 HEAP8[$10>>0] = $14; //@line 105719 "c/sqlite3.c"
 return; //@line 105720 "c/sqlite3.c"
}
function _sqlite3CodeVerifySchema($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 120|0); //@line 105673 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 105673 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 105673 "c/sqlite3.c"
 $spec$select = $4 ? $0 : $3; //@line 105673 "c/sqlite3.c"
 $5 = ((($spec$select)) + 92|0); //@line 105679 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 105679 "c/sqlite3.c"
 $7 = 1 << $1; //@line 105679 "c/sqlite3.c"
 $8 = $6 & $7; //@line 105679 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 105679 "c/sqlite3.c"
 if (!($9)) {
  return; //@line 105685 "c/sqlite3.c"
 }
 $10 = $6 | $7; //@line 105680 "c/sqlite3.c"
 HEAP32[$5>>2] = $10; //@line 105680 "c/sqlite3.c"
 $11 = ($1|0)==(1); //@line 105681 "c/sqlite3.c"
 if (!($11)) {
  return; //@line 105685 "c/sqlite3.c"
 }
 (_sqlite3OpenTempDatabase($spec$select)|0); //@line 105682 "c/sqlite3.c"
 return; //@line 105685 "c/sqlite3.c"
}
function _sqlite3OpenTempDatabase($0) {
 $0 = $0|0;
 var $$1 = 0, $$cast = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $1 = sp + 4|0;
 $2 = HEAP32[$0>>2]|0; //@line 105638 "c/sqlite3.c"
 $3 = ((($2)) + 16|0); //@line 105639 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 105639 "c/sqlite3.c"
 $5 = ((($4)) + 20|0); //@line 105639 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 105639 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 105639 "c/sqlite3.c"
 if (!($7)) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 105664 "c/sqlite3.c"
 }
 $8 = ((($0)) + 399|0); //@line 105639 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 105639 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 105639 "c/sqlite3.c"
 if (!($10)) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 105664 "c/sqlite3.c"
 }
 $11 = HEAP32[$2>>2]|0; //@line 105649 "c/sqlite3.c"
 $12 = (_sqlite3BtreeOpen($11,0,$2,$1,0,542)|0); //@line 105649 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 105650 "c/sqlite3.c"
 if (!($13)) {
  _sqlite3ErrorMsg($0,19878,$vararg_buffer); //@line 105651 "c/sqlite3.c"
  $14 = ((($0)) + 12|0); //@line 105653 "c/sqlite3.c"
  HEAP32[$14>>2] = $12; //@line 105653 "c/sqlite3.c"
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 105664 "c/sqlite3.c"
 }
 $15 = HEAP32[$1>>2]|0; //@line 105656 "c/sqlite3.c"
 $16 = HEAP32[$3>>2]|0; //@line 105656 "c/sqlite3.c"
 $17 = ((($16)) + 20|0); //@line 105656 "c/sqlite3.c"
 HEAP32[$17>>2] = $15; //@line 105656 "c/sqlite3.c"
 $$cast = $15; //@line 105658 "c/sqlite3.c"
 $18 = ((($2)) + 84|0); //@line 105658 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 105658 "c/sqlite3.c"
 $20 = (_sqlite3BtreeSetPageSize($$cast,$19,-1,0)|0); //@line 105658 "c/sqlite3.c"
 $21 = ($20|0)==(7); //@line 105658 "c/sqlite3.c"
 if ($21) {
  _sqlite3OomFault($2); //@line 105659 "c/sqlite3.c"
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 105664 "c/sqlite3.c"
 } else {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 105664 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeOpen($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0208 = 0, $$0210285 = 0, $$0212 = 0, $$0213288 = 0, $$0213288$in = 0, $$0228 = 0, $$0228$ph = 0, $$1209$lcssa = 0, $$1209281 = 0, $$1209281$phi = 0, $$1220252 = 0, $$1220253262 = 0, $$1220254 = 0, $$3217 = 0, $$6 = 0, $$6227264 = 0, $$6227265268 = 0, $$6227265269 = 0, $$in = 0, $$in280 = 0;
 var $$in290 = 0, $$in291 = 0, $$lcssa274 = 0, $$off = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0;
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0;
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0;
 var $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0;
 var $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0;
 var $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0;
 var $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond233 = 0, $or$cond235 = 0, $or$cond237 = 0, $or$cond5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $6 = sp;
 $7 = ($1|0)==(0|0); //@line 62677 "c/sqlite3.c"
 if ($7) {
  label = 4;
 } else {
  $8 = HEAP8[$1>>0]|0; //@line 62677 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 62677 "c/sqlite3.c"
  $10 = (_strcmp($1,19948)|0); //@line 62685 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 62685 "c/sqlite3.c"
  if ($11) {
   $209 = $9;
   label = 6;
  } else {
   if ($9) {
    label = 4;
   } else {
    $210 = 0;
    label = 5;
   }
  }
 }
 if ((label|0) == 4) {
  $12 = (_sqlite3TempInMemory($2)|0); //@line 62686 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 62686 "c/sqlite3.c"
  if ($13) {
   $210 = 1;
   label = 5;
  } else {
   $209 = 1;
   label = 6;
  }
 }
 if ((label|0) == 5) {
  $14 = $5 & 128; //@line 62687 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 62687 "c/sqlite3.c"
  if ($15) {
   $19 = 0;$20 = $210;$76 = $4;
  } else {
   $209 = $210;
   label = 6;
  }
 }
 if ((label|0) == 6) {
  $16 = $4 | 2; //@line 62702 "c/sqlite3.c"
  $19 = 1;$20 = $209;$76 = $16;
 }
 $17 = $5 & 256; //@line 62704 "c/sqlite3.c"
 $18 = ($17|0)!=(0); //@line 62704 "c/sqlite3.c"
 $or$cond = $19 | $20; //@line 62704 "c/sqlite3.c"
 $or$cond233 = $18 & $or$cond; //@line 62704 "c/sqlite3.c"
 $21 = $5 & -769; //@line 62705 "c/sqlite3.c"
 $22 = $21 | 512; //@line 62705 "c/sqlite3.c"
 $$0212 = $or$cond233 ? $22 : $5; //@line 62704 "c/sqlite3.c"
 $23 = (_sqlite3MallocZero(48,0)|0); //@line 62707 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 62708 "c/sqlite3.c"
 if ($24) {
  $$6 = 7;
  STACKTOP = sp;return ($$6|0); //@line 62947 "c/sqlite3.c"
 }
 $25 = ((($23)) + 8|0); //@line 62711 "c/sqlite3.c"
 HEAP8[$25>>0] = 0; //@line 62711 "c/sqlite3.c"
 HEAP32[$23>>2] = $2; //@line 62712 "c/sqlite3.c"
 $26 = ((($23)) + 32|0); //@line 62714 "c/sqlite3.c"
 HEAP32[$26>>2] = $23; //@line 62714 "c/sqlite3.c"
 $27 = ((($23)) + 36|0); //@line 62715 "c/sqlite3.c"
 HEAP32[$27>>2] = 1; //@line 62715 "c/sqlite3.c"
 if ($20) {
  $$1220254 = 0;
  label = 29;
 } else {
  $28 = $$0212 & 64; //@line 62723 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 62723 "c/sqlite3.c"
  $or$cond235 = $19 & $29; //@line 62723 "c/sqlite3.c"
  $30 = $$0212 & 131072; //@line 62724 "c/sqlite3.c"
  $31 = ($30|0)==(0); //@line 62724 "c/sqlite3.c"
  $or$cond237 = $31 | $or$cond235; //@line 62723 "c/sqlite3.c"
  if ($or$cond237) {
   $$1220254 = 0;
   label = 29;
  } else {
   $32 = (_sqlite3Strlen30($1)|0); //@line 62725 "c/sqlite3.c"
   $33 = (($32) + 1)|0; //@line 62725 "c/sqlite3.c"
   $34 = ((($0)) + 8|0); //@line 62726 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 62726 "c/sqlite3.c"
   $36 = (($35) + 1)|0; //@line 62726 "c/sqlite3.c"
   $37 = ($36|0)>($33|0); //@line 62727 "c/sqlite3.c"
   $38 = $37 ? $36 : $33; //@line 62727 "c/sqlite3.c"
   $39 = ($38|0)<(0); //@line 62727 "c/sqlite3.c"
   $40 = $39 << 31 >> 31; //@line 62727 "c/sqlite3.c"
   $41 = (_sqlite3Malloc($38,$40)|0); //@line 62727 "c/sqlite3.c"
   $42 = ((($23)) + 9|0); //@line 62730 "c/sqlite3.c"
   HEAP8[$42>>0] = 1; //@line 62730 "c/sqlite3.c"
   $43 = ($41|0)==(0|0); //@line 62731 "c/sqlite3.c"
   if ($43) {
    _sqlite3_free($23); //@line 62732 "c/sqlite3.c"
    $$6 = 7;
    STACKTOP = sp;return ($$6|0); //@line 62947 "c/sqlite3.c"
   }
   if ($19) {
    _memcpy(($41|0),($1|0),($33|0))|0; //@line 62736 "c/sqlite3.c"
   } else {
    $44 = (_sqlite3OsFullPathname($0,$1,$36,$41)|0); //@line 62738 "c/sqlite3.c"
    $45 = ($44|0)==(0); //@line 62740 "c/sqlite3.c"
    if (!($45)) {
     _sqlite3_free($41); //@line 62741 "c/sqlite3.c"
     _sqlite3_free($23); //@line 62742 "c/sqlite3.c"
     $$6 = $44;
     STACKTOP = sp;return ($$6|0); //@line 62947 "c/sqlite3.c"
    }
   }
   $46 = (_sqlite3MutexAlloc(4)|0); //@line 62747 "c/sqlite3.c"
   _sqlite3_mutex_enter($46); //@line 62748 "c/sqlite3.c"
   $47 = (_sqlite3MutexAlloc(2)|0); //@line 62749 "c/sqlite3.c"
   _sqlite3_mutex_enter($47); //@line 62750 "c/sqlite3.c"
   $$in290 = HEAP32[10106]|0;
   $48 = ($$in290|0)==(0|0); //@line 62752 "c/sqlite3.c"
   L27: do {
    if ($48) {
     $$in280 = 0;
    } else {
     $$in291 = $$in290;
     while(1) {
      $49 = HEAP32[$$in291>>2]|0; //@line 62754 "c/sqlite3.c"
      $50 = (_sqlite3PagerFilename($49,0)|0); //@line 62754 "c/sqlite3.c"
      $51 = (_strcmp($41,$50)|0); //@line 62754 "c/sqlite3.c"
      $52 = ($51|0)==(0); //@line 62754 "c/sqlite3.c"
      if ($52) {
       $53 = (_sqlite3PagerVfs($49)|0); //@line 62755 "c/sqlite3.c"
       $54 = ($53|0)==($0|0); //@line 62755 "c/sqlite3.c"
       if ($54) {
        break;
       }
      }
      $71 = ((($$in291)) + 68|0); //@line 62752 "c/sqlite3.c"
      $$in = HEAP32[$71>>2]|0;
      $72 = ($$in|0)==(0|0); //@line 62752 "c/sqlite3.c"
      if ($72) {
       $$in280 = 0;
       break L27;
      } else {
       $$in291 = $$in;
      }
     }
     $55 = ((($2)) + 20|0); //@line 62757 "c/sqlite3.c"
     $56 = HEAP32[$55>>2]|0; //@line 62757 "c/sqlite3.c"
     $57 = ($56|0)>(0); //@line 62757 "c/sqlite3.c"
     L35: do {
      if ($57) {
       $58 = ((($2)) + 16|0);
       $59 = HEAP32[$58>>2]|0;
       $$0213288$in = $56;
       while(1) {
        $$0213288 = (($$0213288$in) + -1)|0;
        $60 = (((($59) + ($$0213288<<4)|0)) + 4|0); //@line 62758 "c/sqlite3.c"
        $61 = HEAP32[$60>>2]|0; //@line 62758 "c/sqlite3.c"
        $62 = ($61|0)==(0|0); //@line 62759 "c/sqlite3.c"
        if (!($62)) {
         $63 = ((($61)) + 4|0); //@line 62759 "c/sqlite3.c"
         $64 = HEAP32[$63>>2]|0; //@line 62759 "c/sqlite3.c"
         $65 = ($64|0)==($$in291|0); //@line 62759 "c/sqlite3.c"
         if ($65) {
          break;
         }
        }
        $66 = ($$0213288$in|0)>(1); //@line 62757 "c/sqlite3.c"
        if ($66) {
         $$0213288$in = $$0213288;
        } else {
         break L35;
        }
       }
       _sqlite3_mutex_leave($47); //@line 62760 "c/sqlite3.c"
       _sqlite3_mutex_leave($46); //@line 62761 "c/sqlite3.c"
       _sqlite3_free($41); //@line 62762 "c/sqlite3.c"
       _sqlite3_free($23); //@line 62763 "c/sqlite3.c"
       $$6 = 19;
       STACKTOP = sp;return ($$6|0); //@line 62947 "c/sqlite3.c"
      }
     } while(0);
     $67 = ((($23)) + 4|0); //@line 62767 "c/sqlite3.c"
     HEAP32[$67>>2] = $$in291; //@line 62767 "c/sqlite3.c"
     $68 = ((($$in291)) + 64|0); //@line 62768 "c/sqlite3.c"
     $69 = HEAP32[$68>>2]|0; //@line 62768 "c/sqlite3.c"
     $70 = (($69) + 1)|0; //@line 62768 "c/sqlite3.c"
     HEAP32[$68>>2] = $70; //@line 62768 "c/sqlite3.c"
     $$in280 = $$in291;
    }
   } while(0);
   _sqlite3_mutex_leave($47); //@line 62772 "c/sqlite3.c"
   _sqlite3_free($41); //@line 62773 "c/sqlite3.c"
   $73 = ($$in280|0)==(0|0); //@line 62787 "c/sqlite3.c"
   if ($73) {
    $$1220254 = $46;
    label = 29;
   } else {
    $$1220252 = $46;$$3217 = $$in280;
    label = 45;
   }
  }
 }
 L46: do {
  if ((label|0) == 29) {
   $74 = (_sqlite3MallocZero(84,0)|0); //@line 62799 "c/sqlite3.c"
   $75 = ($74|0)==(0|0); //@line 62800 "c/sqlite3.c"
   if ($75) {
    $$6227265269 = 7;$199 = 0;
   } else {
    $77 = (_sqlite3PagerOpen($0,$74,$1,$76,$$0212)|0); //@line 62804 "c/sqlite3.c"
    $78 = ($77|0)==(0); //@line 62806 "c/sqlite3.c"
    do {
     if ($78) {
      $79 = HEAP32[$74>>2]|0; //@line 62807 "c/sqlite3.c"
      $80 = ((($2)) + 40|0); //@line 62807 "c/sqlite3.c"
      $81 = $80; //@line 62807 "c/sqlite3.c"
      $82 = $81; //@line 62807 "c/sqlite3.c"
      $83 = HEAP32[$82>>2]|0; //@line 62807 "c/sqlite3.c"
      $84 = (($81) + 4)|0; //@line 62807 "c/sqlite3.c"
      $85 = $84; //@line 62807 "c/sqlite3.c"
      $86 = HEAP32[$85>>2]|0; //@line 62807 "c/sqlite3.c"
      _sqlite3PagerSetMmapLimit($79,$83,$86); //@line 62807 "c/sqlite3.c"
      $87 = HEAP32[$74>>2]|0; //@line 62808 "c/sqlite3.c"
      $88 = (_sqlite3PagerReadFileheader($87,$6)|0); //@line 62808 "c/sqlite3.c"
      $89 = ($88|0)==(0); //@line 62810 "c/sqlite3.c"
      if ($89) {
       $90 = $76&255; //@line 62813 "c/sqlite3.c"
       $91 = ((($74)) + 16|0); //@line 62813 "c/sqlite3.c"
       HEAP8[$91>>0] = $90; //@line 62813 "c/sqlite3.c"
       $92 = ((($74)) + 4|0); //@line 62814 "c/sqlite3.c"
       HEAP32[$92>>2] = $2; //@line 62814 "c/sqlite3.c"
       $93 = HEAP32[$74>>2]|0; //@line 62815 "c/sqlite3.c"
       _sqlite3PagerSetBusyhandler($93,$74); //@line 62815 "c/sqlite3.c"
       $94 = ((($23)) + 4|0); //@line 62816 "c/sqlite3.c"
       HEAP32[$94>>2] = $74; //@line 62816 "c/sqlite3.c"
       $95 = ((($74)) + 8|0); //@line 62818 "c/sqlite3.c"
       HEAP32[$95>>2] = 0; //@line 62818 "c/sqlite3.c"
       $96 = ((($74)) + 12|0); //@line 62819 "c/sqlite3.c"
       HEAP32[$96>>2] = 0; //@line 62819 "c/sqlite3.c"
       $97 = HEAP32[$74>>2]|0; //@line 62820 "c/sqlite3.c"
       $98 = (_sqlite3PagerIsreadonly($97)|0); //@line 62820 "c/sqlite3.c"
       $99 = ($98<<24>>24)==(0); //@line 62820 "c/sqlite3.c"
       if (!($99)) {
        $100 = ((($74)) + 22|0); //@line 62820 "c/sqlite3.c"
        $101 = HEAP16[$100>>1]|0; //@line 62820 "c/sqlite3.c"
        $102 = $101 | 1; //@line 62820 "c/sqlite3.c"
        HEAP16[$100>>1] = $102; //@line 62820 "c/sqlite3.c"
       }
       $103 = ((($6)) + 16|0); //@line 62829 "c/sqlite3.c"
       $104 = HEAP8[$103>>0]|0; //@line 62829 "c/sqlite3.c"
       $105 = $104&255; //@line 62829 "c/sqlite3.c"
       $106 = $105 << 8; //@line 62829 "c/sqlite3.c"
       $107 = ((($6)) + 17|0); //@line 62829 "c/sqlite3.c"
       $108 = HEAP8[$107>>0]|0; //@line 62829 "c/sqlite3.c"
       $109 = $108&255; //@line 62829 "c/sqlite3.c"
       $110 = $109 << 16; //@line 62829 "c/sqlite3.c"
       $111 = $110 | $106; //@line 62829 "c/sqlite3.c"
       $112 = ((($74)) + 32|0); //@line 62829 "c/sqlite3.c"
       HEAP32[$112>>2] = $111; //@line 62829 "c/sqlite3.c"
       $$off = (($111) + -512)|0; //@line 62830 "c/sqlite3.c"
       $113 = ($$off>>>0)>(65024); //@line 62830 "c/sqlite3.c"
       if ($113) {
        label = 36;
       } else {
        $114 = (($111) + 16777215)|0; //@line 62831 "c/sqlite3.c"
        $115 = $114 & $111; //@line 62831 "c/sqlite3.c"
        $116 = ($115|0)==(0); //@line 62831 "c/sqlite3.c"
        if ($116) {
         $118 = ((($6)) + 20|0); //@line 62850 "c/sqlite3.c"
         $119 = HEAP8[$118>>0]|0; //@line 62850 "c/sqlite3.c"
         $120 = ((($74)) + 22|0); //@line 62851 "c/sqlite3.c"
         $121 = HEAP16[$120>>1]|0; //@line 62851 "c/sqlite3.c"
         $122 = $121 | 2; //@line 62851 "c/sqlite3.c"
         HEAP16[$120>>1] = $122; //@line 62851 "c/sqlite3.c"
         $123 = ((($6)) + 52|0); //@line 62853 "c/sqlite3.c"
         $124 = (_sqlite3Get4byte($123)|0); //@line 62853 "c/sqlite3.c"
         $125 = ($124|0)!=(0); //@line 62853 "c/sqlite3.c"
         $126 = $125&1; //@line 62853 "c/sqlite3.c"
         $127 = ((($74)) + 17|0); //@line 62853 "c/sqlite3.c"
         HEAP8[$127>>0] = $126; //@line 62853 "c/sqlite3.c"
         $128 = ((($6)) + 64|0); //@line 62854 "c/sqlite3.c"
         $129 = (_sqlite3Get4byte($128)|0); //@line 62854 "c/sqlite3.c"
         $130 = ($129|0)!=(0); //@line 62854 "c/sqlite3.c"
         $131 = $130&1; //@line 62854 "c/sqlite3.c"
         $$0228$ph = $119;$$sink = $131;
         label = 39;
        } else {
         label = 36;
        }
       }
       if ((label|0) == 36) {
        HEAP32[$112>>2] = 0; //@line 62832 "c/sqlite3.c"
        $or$cond5 = $7 | $19; //@line 62840 "c/sqlite3.c"
        if ($or$cond5) {
         $$0228 = 0;
        } else {
         $117 = ((($74)) + 17|0); //@line 62841 "c/sqlite3.c"
         HEAP8[$117>>0] = 0; //@line 62841 "c/sqlite3.c"
         $$0228$ph = 0;$$sink = 0;
         label = 39;
        }
       }
       if ((label|0) == 39) {
        $132 = ((($74)) + 18|0);
        HEAP8[$132>>0] = $$sink;
        $$0228 = $$0228$ph;
       }
       $133 = $$0228&255; //@line 62857 "c/sqlite3.c"
       $134 = (_sqlite3PagerSetPagesize($97,$112,$133)|0); //@line 62857 "c/sqlite3.c"
       $135 = ($134|0)==(0); //@line 62858 "c/sqlite3.c"
       if ($135) {
        $136 = HEAP32[$112>>2]|0; //@line 62859 "c/sqlite3.c"
        $137 = (($136) - ($133))|0; //@line 62859 "c/sqlite3.c"
        $138 = ((($74)) + 36|0); //@line 62859 "c/sqlite3.c"
        HEAP32[$138>>2] = $137; //@line 62859 "c/sqlite3.c"
        $139 = ((($74)) + 64|0); //@line 62865 "c/sqlite3.c"
        HEAP32[$139>>2] = 1; //@line 62865 "c/sqlite3.c"
        $140 = ((($23)) + 9|0); //@line 62866 "c/sqlite3.c"
        $141 = HEAP8[$140>>0]|0; //@line 62866 "c/sqlite3.c"
        $142 = ($141<<24>>24)==(0); //@line 62866 "c/sqlite3.c"
        if ($142) {
         $$1220252 = $$1220254;$$3217 = $74;
         label = 45;
         break L46;
        }
        $143 = (_sqlite3MutexAlloc(2)|0); //@line 62868 "c/sqlite3.c"
        $144 = HEAP32[(12)>>2]|0; //@line 62869 "c/sqlite3.c"
        $145 = ($144|0)==(0); //@line 62869 "c/sqlite3.c"
        if (!($145)) {
         $146 = (_sqlite3MutexAlloc(0)|0); //@line 62870 "c/sqlite3.c"
         $147 = ((($74)) + 56|0); //@line 62870 "c/sqlite3.c"
         HEAP32[$147>>2] = $146; //@line 62870 "c/sqlite3.c"
         $148 = ($146|0)==(0|0); //@line 62871 "c/sqlite3.c"
         if ($148) {
          $$6227265268 = 7;
          break;
         }
        }
        _sqlite3_mutex_enter($143); //@line 62876 "c/sqlite3.c"
        $149 = HEAP32[10106]|0; //@line 62877 "c/sqlite3.c"
        $150 = ((($74)) + 68|0); //@line 62877 "c/sqlite3.c"
        HEAP32[$150>>2] = $149; //@line 62877 "c/sqlite3.c"
        HEAP32[10106] = $74; //@line 62878 "c/sqlite3.c"
        _sqlite3_mutex_leave($143); //@line 62879 "c/sqlite3.c"
        $$1220252 = $$1220254;$$3217 = $74;
        label = 45;
        break L46;
       } else {
        $$6227265268 = $134;
       }
      } else {
       $$6227265268 = $88;
      }
     } else {
      $$6227265268 = $77;
     }
    } while(0);
    $197 = HEAP32[$74>>2]|0; //@line 62919 "c/sqlite3.c"
    $198 = ($197|0)==(0|0); //@line 62919 "c/sqlite3.c"
    if ($198) {
     $$6227265269 = $$6227265268;$199 = $74;
    } else {
     _sqlite3PagerClose($197,0); //@line 62920 "c/sqlite3.c"
     $$6227265269 = $$6227265268;$199 = $74;
    }
   }
   _sqlite3_free($199); //@line 62922 "c/sqlite3.c"
   _sqlite3_free($23); //@line 62923 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 62924 "c/sqlite3.c"
   $$1220253262 = $$1220254;$$6227264 = $$6227265269;
  }
 } while(0);
 if ((label|0) == 45) {
  $151 = ((($23)) + 9|0); //@line 62889 "c/sqlite3.c"
  $152 = HEAP8[$151>>0]|0; //@line 62889 "c/sqlite3.c"
  $153 = ($152<<24>>24)==(0); //@line 62889 "c/sqlite3.c"
  L75: do {
   if (!($153)) {
    $154 = ((($2)) + 20|0); //@line 62892 "c/sqlite3.c"
    $155 = HEAP32[$154>>2]|0; //@line 62892 "c/sqlite3.c"
    $156 = ($155|0)>(0); //@line 62892 "c/sqlite3.c"
    if ($156) {
     $157 = ((($2)) + 16|0);
     $158 = HEAP32[$157>>2]|0;
     $$0210285 = 0;
     while(1) {
      $159 = (((($158) + ($$0210285<<4)|0)) + 4|0); //@line 62893 "c/sqlite3.c"
      $160 = HEAP32[$159>>2]|0; //@line 62893 "c/sqlite3.c"
      $161 = ($160|0)==(0|0); //@line 62893 "c/sqlite3.c"
      if (!($161)) {
       $162 = ((($160)) + 9|0); //@line 62893 "c/sqlite3.c"
       $163 = HEAP8[$162>>0]|0; //@line 62893 "c/sqlite3.c"
       $164 = ($163<<24>>24)==(0); //@line 62893 "c/sqlite3.c"
       if (!($164)) {
        break;
       }
      }
      $192 = (($$0210285) + 1)|0; //@line 62892 "c/sqlite3.c"
      $193 = HEAP32[$154>>2]|0; //@line 62892 "c/sqlite3.c"
      $194 = ($192|0)<($193|0); //@line 62892 "c/sqlite3.c"
      if ($194) {
       $$0210285 = $192;
      } else {
       break L75;
      }
     }
     $$0208 = $160;
     while(1) {
      $165 = ((($$0208)) + 28|0); //@line 62894 "c/sqlite3.c"
      $166 = HEAP32[$165>>2]|0; //@line 62894 "c/sqlite3.c"
      $167 = ($166|0)==(0|0); //@line 62894 "c/sqlite3.c"
      if ($167) {
       break;
      } else {
       $$0208 = $166;
      }
     }
     $168 = ((($23)) + 4|0); //@line 62895 "c/sqlite3.c"
     $169 = HEAP32[$168>>2]|0; //@line 62895 "c/sqlite3.c"
     $170 = ((($$0208)) + 4|0); //@line 62895 "c/sqlite3.c"
     $171 = HEAP32[$170>>2]|0; //@line 62895 "c/sqlite3.c"
     $172 = ($169>>>0)<($171>>>0); //@line 62895 "c/sqlite3.c"
     if ($172) {
      $173 = ((($$0208)) + 28|0); //@line 62894 "c/sqlite3.c"
      $174 = ((($23)) + 24|0); //@line 62896 "c/sqlite3.c"
      HEAP32[$174>>2] = $$0208; //@line 62896 "c/sqlite3.c"
      $175 = ((($23)) + 28|0); //@line 62897 "c/sqlite3.c"
      HEAP32[$175>>2] = 0; //@line 62897 "c/sqlite3.c"
      HEAP32[$173>>2] = $23; //@line 62898 "c/sqlite3.c"
      break;
     }
     $176 = ((($$0208)) + 24|0); //@line 62900 "c/sqlite3.c"
     $177 = HEAP32[$176>>2]|0; //@line 62900 "c/sqlite3.c"
     $178 = ($177|0)==(0|0); //@line 62900 "c/sqlite3.c"
     L90: do {
      if ($178) {
       $$1209$lcssa = $$0208;$$lcssa274 = $176;
       label = 57;
      } else {
       $$1209281 = $$0208;$180 = $177;$211 = $176;
       while(1) {
        $185 = ((($180)) + 4|0); //@line 62900 "c/sqlite3.c"
        $186 = HEAP32[$185>>2]|0; //@line 62900 "c/sqlite3.c"
        $187 = ($186>>>0)<($169>>>0); //@line 62900 "c/sqlite3.c"
        if (!($187)) {
         break;
        }
        $179 = ((($180)) + 24|0); //@line 62900 "c/sqlite3.c"
        $181 = HEAP32[$179>>2]|0; //@line 62900 "c/sqlite3.c"
        $182 = ($181|0)==(0|0); //@line 62900 "c/sqlite3.c"
        if ($182) {
         $$1209$lcssa = $180;$$lcssa274 = $179;
         label = 57;
         break L90;
        } else {
         $$1209281$phi = $180;$180 = $181;$211 = $179;$$1209281 = $$1209281$phi;
        }
       }
       $188 = ((($23)) + 24|0); //@line 62903 "c/sqlite3.c"
       HEAP32[$188>>2] = $180; //@line 62903 "c/sqlite3.c"
       $189 = ((($23)) + 28|0); //@line 62904 "c/sqlite3.c"
       HEAP32[$189>>2] = $$1209281; //@line 62904 "c/sqlite3.c"
       $190 = ((($180)) + 28|0); //@line 62906 "c/sqlite3.c"
       HEAP32[$190>>2] = $23; //@line 62906 "c/sqlite3.c"
       $191 = $211;
      }
     } while(0);
     if ((label|0) == 57) {
      $183 = ((($23)) + 24|0); //@line 62903 "c/sqlite3.c"
      HEAP32[$183>>2] = 0; //@line 62903 "c/sqlite3.c"
      $184 = ((($23)) + 28|0); //@line 62904 "c/sqlite3.c"
      HEAP32[$184>>2] = $$1209$lcssa; //@line 62904 "c/sqlite3.c"
      $191 = $$lcssa274;
     }
     HEAP32[$191>>2] = $23; //@line 62908 "c/sqlite3.c"
    }
   }
  } while(0);
  HEAP32[$3>>2] = $23; //@line 62915 "c/sqlite3.c"
  $195 = (_sqlite3BtreeSchema($23,0,0)|0); //@line 62932 "c/sqlite3.c"
  $196 = ($195|0)==(0|0); //@line 62932 "c/sqlite3.c"
  if ($196) {
   $200 = ((($23)) + 4|0); //@line 62933 "c/sqlite3.c"
   $201 = HEAP32[$200>>2]|0; //@line 62933 "c/sqlite3.c"
   $202 = HEAP32[$201>>2]|0; //@line 62933 "c/sqlite3.c"
   _sqlite3PagerSetCachesize($202,-2000); //@line 62933 "c/sqlite3.c"
  }
  $203 = HEAP32[$$3217>>2]|0; //@line 62936 "c/sqlite3.c"
  $204 = (_sqlite3PagerFile($203)|0); //@line 62936 "c/sqlite3.c"
  $205 = HEAP32[$204>>2]|0; //@line 62937 "c/sqlite3.c"
  $206 = ($205|0)==(0|0); //@line 62937 "c/sqlite3.c"
  if ($206) {
   $$1220253262 = $$1220252;$$6227264 = 0;
  } else {
   $207 = ((($$3217)) + 4|0); //@line 62938 "c/sqlite3.c"
   _sqlite3OsFileControlHint($204,30,$207); //@line 62938 "c/sqlite3.c"
   $$1220253262 = $$1220252;$$6227264 = 0;
  }
 }
 $208 = ($$1220253262|0)==(0|0); //@line 62941 "c/sqlite3.c"
 if ($208) {
  $$6 = $$6227264;
  STACKTOP = sp;return ($$6|0); //@line 62947 "c/sqlite3.c"
 }
 _sqlite3_mutex_leave($$1220253262); //@line 62943 "c/sqlite3.c"
 $$6 = $$6227264;
 STACKTOP = sp;return ($$6|0); //@line 62947 "c/sqlite3.c"
}
function _sqlite3BtreeSetPageSize($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$028 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 4|0); //@line 63184 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 63184 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63186 "c/sqlite3.c"
 $6 = ((($5)) + 22|0); //@line 63190 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 63190 "c/sqlite3.c"
 $8 = $7 & 2; //@line 63190 "c/sqlite3.c"
 $9 = ($8<<16>>16)==(0); //@line 63190 "c/sqlite3.c"
 if (!($9)) {
  _sqlite3BtreeLeave($0); //@line 63191 "c/sqlite3.c"
  $$0 = 8;
  return ($$0|0); //@line 63210 "c/sqlite3.c"
 }
 $10 = ($2|0)<(0); //@line 63194 "c/sqlite3.c"
 if ($10) {
  $11 = ((($5)) + 32|0); //@line 63195 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 63195 "c/sqlite3.c"
  $13 = ((($5)) + 36|0); //@line 63195 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 63195 "c/sqlite3.c"
  $15 = (($12) - ($14))|0; //@line 63195 "c/sqlite3.c"
  $$028 = $15;
 } else {
  $$028 = $2;
 }
 $$off = (($1) + -512)|0; //@line 63198 "c/sqlite3.c"
 $16 = ($$off>>>0)<(65025); //@line 63198 "c/sqlite3.c"
 if ($16) {
  $17 = (($1) + -1)|0; //@line 63199 "c/sqlite3.c"
  $18 = $17 & $1; //@line 63199 "c/sqlite3.c"
  $19 = ($18|0)==(0); //@line 63199 "c/sqlite3.c"
  if ($19) {
   $20 = ((($5)) + 32|0); //@line 63202 "c/sqlite3.c"
   HEAP32[$20>>2] = $1; //@line 63202 "c/sqlite3.c"
   _freeTempSpace($5); //@line 63203 "c/sqlite3.c"
  }
 }
 $21 = HEAP32[$5>>2]|0; //@line 63205 "c/sqlite3.c"
 $22 = ((($5)) + 32|0); //@line 63205 "c/sqlite3.c"
 $23 = (_sqlite3PagerSetPagesize($21,$22,$$028)|0); //@line 63205 "c/sqlite3.c"
 $24 = HEAP32[$22>>2]|0; //@line 63206 "c/sqlite3.c"
 $25 = $$028 & 65535; //@line 63206 "c/sqlite3.c"
 $26 = (($24) - ($25))|0; //@line 63206 "c/sqlite3.c"
 $27 = ((($5)) + 36|0); //@line 63206 "c/sqlite3.c"
 HEAP32[$27>>2] = $26; //@line 63206 "c/sqlite3.c"
 $28 = ($3|0)==(0); //@line 63207 "c/sqlite3.c"
 if (!($28)) {
  $29 = HEAP16[$6>>1]|0; //@line 63207 "c/sqlite3.c"
  $30 = $29 | 2; //@line 63207 "c/sqlite3.c"
  HEAP16[$6>>1] = $30; //@line 63207 "c/sqlite3.c"
 }
 _sqlite3BtreeLeave($0); //@line 63208 "c/sqlite3.c"
 $$0 = $23;
 return ($$0|0); //@line 63210 "c/sqlite3.c"
}
function _sqlite3OsFullPathname($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP8[$3>>0] = 0; //@line 21050 "c/sqlite3.c"
 $4 = ((($0)) + 36|0); //@line 21051 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 21051 "c/sqlite3.c"
 $6 = (FUNCTION_TABLE_iiiii[$5 & 127]($0,$1,$2,$3)|0); //@line 21051 "c/sqlite3.c"
 return ($6|0); //@line 21051 "c/sqlite3.c"
}
function _sqlite3PagerVfs($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 54904 "c/sqlite3.c"
 return ($1|0); //@line 54904 "c/sqlite3.c"
}
function _sqlite3PagerOpen($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0191$lcssa = 0, $$019130 = 0, $$01992 = 0, $$020922 = 0, $$02101 = 0, $$021120 = 0, $$021211 = 0, $$1196 = 0, $$1198 = 0, $$1205 = 0, $$2 = 0, $$2203 = 0, $$3 = 0, $$629 = 0, $$pr = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0;
 var $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0;
 var $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0;
 var $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0;
 var $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $factor = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp + 4|0;
 $6 = sp;
 $7 = $3 & 1; //@line 52667 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 52667 "c/sqlite3.c"
 HEAP32[$5>>2] = 4096; //@line 52669 "c/sqlite3.c"
 $9 = (_sqlite3JournalSize($0)|0); //@line 52675 "c/sqlite3.c"
 $10 = (($9) + 7)|0; //@line 52675 "c/sqlite3.c"
 $11 = $10 & -8; //@line 52675 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 52678 "c/sqlite3.c"
 $12 = $3 & 2; //@line 52681 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 52681 "c/sqlite3.c"
 do {
  if ($13) {
   $20 = ($2|0)!=(0|0); //@line 52696 "c/sqlite3.c"
   if ($20) {
    $$pr = HEAP8[$2>>0]|0; //@line 52696 "c/sqlite3.c"
    $21 = ($$pr<<24>>24)==(0); //@line 52696 "c/sqlite3.c"
    if ($21) {
     $$01992 = $2;$$02101 = 0;$$1196 = 0;$$1198 = 0;$$1205 = 0;$$2203 = 0;$162 = 1;
    } else {
     $22 = ((($0)) + 8|0); //@line 52698 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 52698 "c/sqlite3.c"
     $24 = (($23) + 1)|0; //@line 52698 "c/sqlite3.c"
     $25 = $24 << 1; //@line 52699 "c/sqlite3.c"
     $26 = ($25|0)<(0); //@line 52699 "c/sqlite3.c"
     $27 = $26 << 31 >> 31; //@line 52699 "c/sqlite3.c"
     $28 = (_sqlite3DbMallocRaw(0,$25,$27)|0); //@line 52699 "c/sqlite3.c"
     $29 = ($28|0)==(0|0); //@line 52700 "c/sqlite3.c"
     if ($29) {
      $$2 = 7;
      STACKTOP = sp;return ($$2|0); //@line 52933 "c/sqlite3.c"
     }
     HEAP8[$28>>0] = 0; //@line 52703 "c/sqlite3.c"
     $30 = (_sqlite3OsFullPathname($0,$2,$24,$28)|0); //@line 52704 "c/sqlite3.c"
     $31 = (_sqlite3Strlen30($28)|0); //@line 52705 "c/sqlite3.c"
     $32 = (_sqlite3Strlen30($2)|0); //@line 52706 "c/sqlite3.c"
     $33 = (($32) + 1)|0; //@line 52706 "c/sqlite3.c"
     $34 = (($2) + ($33)|0); //@line 52706 "c/sqlite3.c"
     $35 = HEAP8[$34>>0]|0; //@line 52707 "c/sqlite3.c"
     $36 = ($35<<24>>24)==(0); //@line 52707 "c/sqlite3.c"
     if ($36) {
      $$0191$lcssa = $34;
     } else {
      $$019130 = $34;
      while(1) {
       $37 = (_sqlite3Strlen30($$019130)|0); //@line 52708 "c/sqlite3.c"
       $38 = (($37) + 1)|0; //@line 52708 "c/sqlite3.c"
       $39 = (($$019130) + ($38)|0); //@line 52708 "c/sqlite3.c"
       $40 = (_sqlite3Strlen30($39)|0); //@line 52709 "c/sqlite3.c"
       $41 = (($40) + 1)|0; //@line 52709 "c/sqlite3.c"
       $42 = (($39) + ($41)|0); //@line 52709 "c/sqlite3.c"
       $43 = HEAP8[$42>>0]|0; //@line 52707 "c/sqlite3.c"
       $44 = ($43<<24>>24)==(0); //@line 52707 "c/sqlite3.c"
       if ($44) {
        $$0191$lcssa = $42;
        break;
       } else {
        $$019130 = $42;
       }
      }
     }
     $45 = ((($$0191$lcssa)) + 1|0); //@line 52711 "c/sqlite3.c"
     $46 = $45; //@line 52711 "c/sqlite3.c"
     $47 = $34; //@line 52711 "c/sqlite3.c"
     $48 = (($46) - ($47))|0; //@line 52711 "c/sqlite3.c"
     $49 = ($30|0)==(0); //@line 52713 "c/sqlite3.c"
     if ($49) {
      $50 = (($31) + 8)|0; //@line 52713 "c/sqlite3.c"
      $51 = HEAP32[$22>>2]|0; //@line 52713 "c/sqlite3.c"
      $52 = ($50|0)>($51|0); //@line 52713 "c/sqlite3.c"
      if (!($52)) {
       $$01992 = $2;$$02101 = 0;$$1196 = $48;$$1198 = $34;$$1205 = $28;$$2203 = $31;$162 = $20;
       break;
      }
      $53 = (_sqlite3CantopenError(52720)|0); //@line 52720 "c/sqlite3.c"
      $54 = ($53|0)==(0); //@line 52722 "c/sqlite3.c"
      if ($54) {
       $$01992 = $2;$$02101 = 0;$$1196 = $48;$$1198 = $34;$$1205 = $28;$$2203 = $31;$162 = $20;
       break;
      } else {
       $$021211 = $53;
      }
     } else {
      $$021211 = $30;
     }
     _sqlite3DbFree(0,$28); //@line 52723 "c/sqlite3.c"
     $$2 = $$021211;
     STACKTOP = sp;return ($$2|0); //@line 52933 "c/sqlite3.c"
    }
   } else {
    $$01992 = 0;$$02101 = 0;$$1196 = 0;$$1198 = 0;$$1205 = 0;$$2203 = 0;$162 = 0;
   }
  } else {
   $14 = ($2|0)==(0|0); //@line 52683 "c/sqlite3.c"
   if ($14) {
    $$01992 = 0;$$02101 = 1;$$1196 = 0;$$1198 = 0;$$1205 = 0;$$2203 = 0;$162 = 0;
   } else {
    $15 = HEAP8[$2>>0]|0; //@line 52683 "c/sqlite3.c"
    $16 = ($15<<24>>24)==(0); //@line 52683 "c/sqlite3.c"
    if ($16) {
     $$01992 = $2;$$02101 = 1;$$1196 = 0;$$1198 = 0;$$1205 = 0;$$2203 = 0;$162 = 1;
    } else {
     $17 = (_sqlite3DbStrDup(0,$2)|0); //@line 52684 "c/sqlite3.c"
     $18 = ($17|0)==(0|0); //@line 52685 "c/sqlite3.c"
     if ($18) {
      $$2 = 7;
      STACKTOP = sp;return ($$2|0); //@line 52933 "c/sqlite3.c"
     } else {
      $19 = (_sqlite3Strlen30($17)|0); //@line 52686 "c/sqlite3.c"
      $$01992 = 0;$$02101 = 1;$$1196 = 0;$$1198 = 0;$$1205 = $17;$$2203 = $19;$162 = 0;
      break;
     }
    }
   }
  }
 } while(0);
 $55 = ((($0)) + 4|0); //@line 52743 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 52743 "c/sqlite3.c"
 $57 = (($56) + 279)|0; //@line 52742 "c/sqlite3.c"
 $58 = $57 & -8; //@line 52742 "c/sqlite3.c"
 $59 = $11 << 1; //@line 52744 "c/sqlite3.c"
 $factor = ($$2203*3)|0;
 $60 = (($59) + 17)|0; //@line 52745 "c/sqlite3.c"
 $61 = (($60) + ($factor))|0; //@line 52746 "c/sqlite3.c"
 $62 = (($61) + ($$1196))|0; //@line 52748 "c/sqlite3.c"
 $63 = (($62) + ($58))|0; //@line 52748 "c/sqlite3.c"
 $64 = (_sqlite3MallocZero($63,0)|0); //@line 52740 "c/sqlite3.c"
 $65 = ($64|0)==(0|0); //@line 52752 "c/sqlite3.c"
 if ($65) {
  _sqlite3DbFree(0,$$1205); //@line 52753 "c/sqlite3.c"
  $$2 = 7;
  STACKTOP = sp;return ($$2|0); //@line 52933 "c/sqlite3.c"
 }
 $66 = ((($64)) + 224|0); //@line 52757 "c/sqlite3.c"
 $67 = ((($64)) + 208|0); //@line 52757 "c/sqlite3.c"
 HEAP32[$67>>2] = $66; //@line 52757 "c/sqlite3.c"
 $68 = ((($64)) + 272|0); //@line 52758 "c/sqlite3.c"
 $69 = ((($64)) + 60|0); //@line 52758 "c/sqlite3.c"
 HEAP32[$69>>2] = $68; //@line 52758 "c/sqlite3.c"
 $70 = HEAP32[$55>>2]|0; //@line 52759 "c/sqlite3.c"
 $71 = (($70) + 7)|0; //@line 52759 "c/sqlite3.c"
 $72 = $71 & -8; //@line 52759 "c/sqlite3.c"
 $73 = (($68) + ($72)|0); //@line 52759 "c/sqlite3.c"
 $74 = ((($64)) + 68|0); //@line 52759 "c/sqlite3.c"
 HEAP32[$74>>2] = $73; //@line 52759 "c/sqlite3.c"
 $75 = (($73) + ($11)|0); //@line 52760 "c/sqlite3.c"
 $76 = ((($64)) + 64|0); //@line 52760 "c/sqlite3.c"
 HEAP32[$76>>2] = $75; //@line 52760 "c/sqlite3.c"
 $77 = (($75) + ($11)|0); //@line 52761 "c/sqlite3.c"
 $78 = ((($64)) + 168|0); //@line 52761 "c/sqlite3.c"
 HEAP32[$78>>2] = $77; //@line 52761 "c/sqlite3.c"
 $79 = ($$1205|0)==(0|0); //@line 52765 "c/sqlite3.c"
 if (!($79)) {
  $80 = (($$2203) + 1)|0; //@line 52767 "c/sqlite3.c"
  $81 = (($$1196) + ($80))|0; //@line 52767 "c/sqlite3.c"
  $82 = (($77) + ($81)|0); //@line 52767 "c/sqlite3.c"
  $83 = ((($64)) + 172|0); //@line 52767 "c/sqlite3.c"
  HEAP32[$83>>2] = $82; //@line 52767 "c/sqlite3.c"
  _memcpy(($77|0),($$1205|0),($$2203|0))|0; //@line 52768 "c/sqlite3.c"
  $84 = ($$1196|0)==(0); //@line 52769 "c/sqlite3.c"
  if (!($84)) {
   $85 = HEAP32[$78>>2]|0; //@line 52769 "c/sqlite3.c"
   $86 = (($85) + ($80)|0); //@line 52769 "c/sqlite3.c"
   _memcpy(($86|0),($$1198|0),($$1196|0))|0; //@line 52769 "c/sqlite3.c"
  }
  $87 = HEAP32[$83>>2]|0; //@line 52770 "c/sqlite3.c"
  _memcpy(($87|0),($$1205|0),($$2203|0))|0; //@line 52770 "c/sqlite3.c"
  $88 = HEAP32[$83>>2]|0; //@line 52771 "c/sqlite3.c"
  $89 = (($88) + ($$2203)|0); //@line 52771 "c/sqlite3.c"
  dest=$89; src=19957; stop=dest+10|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0)); //@line 52771 "c/sqlite3.c"
  $90 = HEAP32[$83>>2]|0; //@line 52774 "c/sqlite3.c"
  $91 = (($$2203) + 9)|0; //@line 52774 "c/sqlite3.c"
  $92 = (($90) + ($91)|0); //@line 52774 "c/sqlite3.c"
  $93 = ((($64)) + 216|0); //@line 52774 "c/sqlite3.c"
  HEAP32[$93>>2] = $92; //@line 52774 "c/sqlite3.c"
  _memcpy(($92|0),($$1205|0),($$2203|0))|0; //@line 52775 "c/sqlite3.c"
  $94 = HEAP32[$93>>2]|0; //@line 52776 "c/sqlite3.c"
  $95 = (($94) + ($$2203)|0); //@line 52776 "c/sqlite3.c"
  ;HEAP8[$95>>0]=HEAP8[19967>>0]|0;HEAP8[$95+1>>0]=HEAP8[19967+1>>0]|0;HEAP8[$95+2>>0]=HEAP8[19967+2>>0]|0;HEAP8[$95+3>>0]=HEAP8[19967+3>>0]|0;HEAP8[$95+4>>0]=HEAP8[19967+4>>0]|0; //@line 52776 "c/sqlite3.c"
  _sqlite3DbFree(0,$$1205); //@line 52779 "c/sqlite3.c"
 }
 HEAP32[$64>>2] = $0; //@line 52781 "c/sqlite3.c"
 $96 = ((($64)) + 144|0); //@line 52782 "c/sqlite3.c"
 HEAP32[$96>>2] = $4; //@line 52782 "c/sqlite3.c"
 do {
  if ($162) {
   $97 = HEAP8[$$01992>>0]|0; //@line 52786 "c/sqlite3.c"
   $98 = ($97<<24>>24)==(0); //@line 52786 "c/sqlite3.c"
   if ($98) {
    $$3 = $4;
    label = 34;
   } else {
    HEAP32[$6>>2] = 0; //@line 52787 "c/sqlite3.c"
    $99 = HEAP32[$78>>2]|0; //@line 52788 "c/sqlite3.c"
    $100 = HEAP32[$69>>2]|0; //@line 52788 "c/sqlite3.c"
    $101 = (_sqlite3OsOpen($0,$99,$100,$4,$6)|0); //@line 52788 "c/sqlite3.c"
    $102 = HEAP32[$6>>2]|0; //@line 52790 "c/sqlite3.c"
    $103 = $102 & 1; //@line 52790 "c/sqlite3.c"
    $104 = ($101|0)==(0); //@line 52800 "c/sqlite3.c"
    if (!($104)) {
     $$629 = $101;
     break;
    }
    $105 = HEAP32[$69>>2]|0; //@line 52801 "c/sqlite3.c"
    $106 = (_sqlite3OsDeviceCharacteristics($105)|0); //@line 52801 "c/sqlite3.c"
    $107 = ($103|0)==(0); //@line 52802 "c/sqlite3.c"
    do {
     if ($107) {
      _setSectorSize($64); //@line 52803 "c/sqlite3.c"
      $108 = ((($64)) + 148|0); //@line 52805 "c/sqlite3.c"
      $109 = HEAP32[$108>>2]|0; //@line 52805 "c/sqlite3.c"
      $110 = ($109>>>0)>(4096); //@line 52805 "c/sqlite3.c"
      if ($110) {
       $111 = ($109>>>0)>(8192); //@line 52806 "c/sqlite3.c"
       if ($111) {
        HEAP32[$5>>2] = 8192; //@line 52807 "c/sqlite3.c"
        break;
       } else {
        HEAP32[$5>>2] = $109; //@line 52809 "c/sqlite3.c"
        break;
       }
      }
     }
    } while(0);
    $112 = (_sqlite3_uri_boolean($$01992,19973,0)|0); //@line 52826 "c/sqlite3.c"
    $113 = $112&255; //@line 52826 "c/sqlite3.c"
    $114 = ((($64)) + 13|0); //@line 52826 "c/sqlite3.c"
    HEAP8[$114>>0] = $113; //@line 52826 "c/sqlite3.c"
    $115 = $106 & 8192; //@line 52827 "c/sqlite3.c"
    $116 = ($115|0)==(0); //@line 52827 "c/sqlite3.c"
    if ($116) {
     $117 = (_sqlite3_uri_boolean($$01992,19980,0)|0); //@line 52828 "c/sqlite3.c"
     $118 = ($117|0)==(0); //@line 52828 "c/sqlite3.c"
     if ($118) {
      $$020922 = $103;$$021120 = 0;
      label = 36;
      break;
     }
    }
    $119 = $4 | 1; //@line 52829 "c/sqlite3.c"
    $$3 = $119;
    label = 34;
   }
  } else {
   $$3 = $4;
   label = 34;
  }
 } while(0);
 if ((label|0) == 34) {
  $120 = ((($64)) + 16|0); //@line 52846 "c/sqlite3.c"
  HEAP8[$120>>0] = 1; //@line 52846 "c/sqlite3.c"
  $121 = ((($64)) + 17|0); //@line 52847 "c/sqlite3.c"
  HEAP8[$121>>0] = 4; //@line 52847 "c/sqlite3.c"
  $122 = ((($64)) + 13|0); //@line 52848 "c/sqlite3.c"
  HEAP8[$122>>0] = 1; //@line 52848 "c/sqlite3.c"
  $123 = $$3 & 1; //@line 52849 "c/sqlite3.c"
  $$020922 = $123;$$021120 = 1;
  label = 36;
 }
 if ((label|0) == 36) {
  $124 = (_sqlite3PagerSetPagesize($64,$5,-1)|0); //@line 52857 "c/sqlite3.c"
  $125 = ($124|0)==(0); //@line 52862 "c/sqlite3.c"
  if ($125) {
   $126 = ($$02101|0)==(0); //@line 52865 "c/sqlite3.c"
   $127 = $126 ? 149 : 0; //@line 52866 "c/sqlite3.c"
   $128 = $$02101 ^ 1; //@line 52865 "c/sqlite3.c"
   $129 = HEAP32[$5>>2]|0; //@line 52865 "c/sqlite3.c"
   $130 = HEAP32[$67>>2]|0; //@line 52866 "c/sqlite3.c"
   $131 = (_sqlite3PcacheOpen($129,$128,$127,$64,$130)|0); //@line 52865 "c/sqlite3.c"
   $132 = ($131|0)==(0); //@line 52871 "c/sqlite3.c"
   if ($132) {
    $136 = $7 ^ 1; //@line 52881 "c/sqlite3.c"
    $137 = $136&255; //@line 52881 "c/sqlite3.c"
    $138 = ((($64)) + 6|0); //@line 52881 "c/sqlite3.c"
    HEAP8[$138>>0] = $137; //@line 52881 "c/sqlite3.c"
    $139 = ((($64)) + 156|0); //@line 52888 "c/sqlite3.c"
    HEAP32[$139>>2] = 1073741823; //@line 52888 "c/sqlite3.c"
    $140 = ((($64)) + 12|0); //@line 52891 "c/sqlite3.c"
    HEAP8[$140>>0] = $$021120; //@line 52891 "c/sqlite3.c"
    $141 = ((($64)) + 4|0); //@line 52895 "c/sqlite3.c"
    HEAP8[$141>>0] = $$021120; //@line 52895 "c/sqlite3.c"
    $142 = ((($64)) + 18|0); //@line 52896 "c/sqlite3.c"
    HEAP8[$142>>0] = $$021120; //@line 52896 "c/sqlite3.c"
    $143 = $$02101&255; //@line 52897 "c/sqlite3.c"
    $144 = ((($64)) + 15|0); //@line 52897 "c/sqlite3.c"
    HEAP8[$144>>0] = $143; //@line 52897 "c/sqlite3.c"
    $145 = $$020922&255; //@line 52898 "c/sqlite3.c"
    $146 = ((($64)) + 14|0); //@line 52898 "c/sqlite3.c"
    HEAP8[$146>>0] = $145; //@line 52898 "c/sqlite3.c"
    $147 = ((($64)) + 7|0); //@line 52900 "c/sqlite3.c"
    HEAP8[$147>>0] = $$021120; //@line 52900 "c/sqlite3.c"
    $148 = ($$021120<<24>>24)==(0); //@line 52901 "c/sqlite3.c"
    if ($148) {
     $149 = ((($64)) + 8|0); //@line 52907 "c/sqlite3.c"
     HEAP8[$149>>0] = 1; //@line 52907 "c/sqlite3.c"
     $150 = ((($64)) + 9|0); //@line 52908 "c/sqlite3.c"
     HEAP8[$150>>0] = 0; //@line 52908 "c/sqlite3.c"
     $151 = ((($64)) + 10|0); //@line 52909 "c/sqlite3.c"
     HEAP8[$151>>0] = 2; //@line 52909 "c/sqlite3.c"
     $152 = ((($64)) + 11|0); //@line 52910 "c/sqlite3.c"
     HEAP8[$152>>0] = 10; //@line 52910 "c/sqlite3.c"
    }
    $153 = ((($64)) + 140|0); //@line 52915 "c/sqlite3.c"
    HEAP16[$153>>1] = 88; //@line 52915 "c/sqlite3.c"
    $154 = ((($64)) + 160|0); //@line 52916 "c/sqlite3.c"
    $155 = $154; //@line 52916 "c/sqlite3.c"
    $156 = $155; //@line 52916 "c/sqlite3.c"
    HEAP32[$156>>2] = -1; //@line 52916 "c/sqlite3.c"
    $157 = (($155) + 4)|0; //@line 52916 "c/sqlite3.c"
    $158 = $157; //@line 52916 "c/sqlite3.c"
    HEAP32[$158>>2] = -1; //@line 52916 "c/sqlite3.c"
    _setSectorSize($64); //@line 52918 "c/sqlite3.c"
    if ($8) {
     $159 = ($$02101|0)==(0); //@line 52921 "c/sqlite3.c"
     if (!($159)) {
      $$sink = 4;
      label = 43;
     }
    } else {
     $$sink = 2;
     label = 43;
    }
    if ((label|0) == 43) {
     $160 = ((($64)) + 5|0);
     HEAP8[$160>>0] = $$sink;
    }
    $161 = ((($64)) + 196|0); //@line 52926 "c/sqlite3.c"
    HEAP32[$161>>2] = 101; //@line 52926 "c/sqlite3.c"
    _setGetterMethod($64); //@line 52927 "c/sqlite3.c"
    HEAP32[$1>>2] = $64; //@line 52931 "c/sqlite3.c"
    $$2 = 0;
    STACKTOP = sp;return ($$2|0); //@line 52933 "c/sqlite3.c"
   } else {
    $$629 = $131;
   }
  } else {
   $$629 = $124;
  }
 }
 $133 = HEAP32[$69>>2]|0; //@line 52872 "c/sqlite3.c"
 _sqlite3OsClose($133); //@line 52872 "c/sqlite3.c"
 $134 = ((($64)) + 204|0); //@line 52873 "c/sqlite3.c"
 $135 = HEAP32[$134>>2]|0; //@line 52873 "c/sqlite3.c"
 _sqlite3PageFree($135); //@line 52873 "c/sqlite3.c"
 _sqlite3_free($64); //@line 52874 "c/sqlite3.c"
 $$2 = $$629;
 STACKTOP = sp;return ($$2|0); //@line 52933 "c/sqlite3.c"
}
function _sqlite3PagerSetMmapLimit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 128|0); //@line 51510 "c/sqlite3.c"
 $4 = $3; //@line 51510 "c/sqlite3.c"
 $5 = $4; //@line 51510 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 51510 "c/sqlite3.c"
 $6 = (($4) + 4)|0; //@line 51510 "c/sqlite3.c"
 $7 = $6; //@line 51510 "c/sqlite3.c"
 HEAP32[$7>>2] = $2; //@line 51510 "c/sqlite3.c"
 return; //@line 51512 "c/sqlite3.c"
}
function _sqlite3PagerReadFileheader($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $spec$store$select = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$1; stop=dest+100|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 51841 "c/sqlite3.c"
 $2 = ((($0)) + 60|0); //@line 51850 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 51850 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 51850 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 51850 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  return ($$0|0); //@line 51857 "c/sqlite3.c"
 }
 $6 = (_sqlite3OsRead($3,$1,100,0,0)|0); //@line 51852 "c/sqlite3.c"
 $7 = ($6|0)==(522); //@line 51853 "c/sqlite3.c"
 $spec$store$select = $7 ? 0 : $6; //@line 51853 "c/sqlite3.c"
 $$0 = $spec$store$select;
 return ($$0|0); //@line 51857 "c/sqlite3.c"
}
function _sqlite3PagerSetBusyhandler($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 176|0); //@line 51677 "c/sqlite3.c"
 HEAP32[$2>>2] = 158; //@line 51677 "c/sqlite3.c"
 $3 = ((($0)) + 180|0); //@line 51678 "c/sqlite3.c"
 HEAP32[$3>>2] = $1; //@line 51678 "c/sqlite3.c"
 $4 = ((($0)) + 60|0); //@line 51680 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 51680 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 51680 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 51680 "c/sqlite3.c"
 if ($7) {
  return; //@line 51686 "c/sqlite3.c"
 }
 _sqlite3OsFileControlHint($5,15,$2); //@line 51684 "c/sqlite3.c"
 return; //@line 51686 "c/sqlite3.c"
}
function _sqlite3PagerIsreadonly($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 14|0); //@line 54640 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 54640 "c/sqlite3.c"
 return ($2|0); //@line 54640 "c/sqlite3.c"
}
function _sqlite3BtreeSchema($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 70195 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 70195 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 70196 "c/sqlite3.c"
 $5 = ((($4)) + 48|0); //@line 70197 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 70197 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 70197 "c/sqlite3.c"
 $8 = ($1|0)!=(0); //@line 70197 "c/sqlite3.c"
 $or$cond = $8 & $7; //@line 70197 "c/sqlite3.c"
 if (!($or$cond)) {
  _sqlite3BtreeLeave($0); //@line 70201 "c/sqlite3.c"
  $13 = HEAP32[$5>>2]|0; //@line 70202 "c/sqlite3.c"
  return ($13|0); //@line 70202 "c/sqlite3.c"
 }
 $9 = ((($4)) + 52|0); //@line 70199 "c/sqlite3.c"
 $10 = ($1|0)<(0); //@line 70198 "c/sqlite3.c"
 $11 = $10 << 31 >> 31; //@line 70198 "c/sqlite3.c"
 $12 = (_sqlite3DbMallocZero(0,$1,$11)|0); //@line 70198 "c/sqlite3.c"
 HEAP32[$5>>2] = $12; //@line 70198 "c/sqlite3.c"
 HEAP32[$9>>2] = $2; //@line 70199 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 70201 "c/sqlite3.c"
 $13 = HEAP32[$5>>2]|0; //@line 70202 "c/sqlite3.c"
 return ($13|0); //@line 70202 "c/sqlite3.c"
}
function _sqlite3PagerSetCachesize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 208|0); //@line 51479 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 51479 "c/sqlite3.c"
 _sqlite3PcacheSetCachesize($3,$1); //@line 51479 "c/sqlite3.c"
 return; //@line 51480 "c/sqlite3.c"
}
function _sqlite3PagerFile($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 60|0); //@line 54913 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54913 "c/sqlite3.c"
 return ($2|0); //@line 54913 "c/sqlite3.c"
}
function _sqlite3PcacheSetCachesize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 16|0); //@line 45987 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 45987 "c/sqlite3.c"
 $3 = HEAP32[(140)>>2]|0; //@line 45988 "c/sqlite3.c"
 $4 = ((($0)) + 44|0); //@line 45988 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 45988 "c/sqlite3.c"
 $6 = (_numberOfCachePages($0)|0); //@line 45989 "c/sqlite3.c"
 FUNCTION_TABLE_vii[$3 & 127]($5,$6); //@line 45988 "c/sqlite3.c"
 return; //@line 45990 "c/sqlite3.c"
}
function _pageReinit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3PagerGetExtra($0)|0); //@line 62613 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 62615 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 62615 "c/sqlite3.c"
 if ($3) {
  return; //@line 62628 "c/sqlite3.c"
 }
 HEAP8[$1>>0] = 0; //@line 62617 "c/sqlite3.c"
 $4 = (_sqlite3PagerPageRefcount($0)|0); //@line 62618 "c/sqlite3.c"
 $5 = ($4|0)>(1); //@line 62618 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 62628 "c/sqlite3.c"
 }
 (_btreeInitPage($1)|0); //@line 62625 "c/sqlite3.c"
 return; //@line 62628 "c/sqlite3.c"
}
function _sqlite3JournalSize($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 90987 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 90987 "c/sqlite3.c"
 $3 = ($2|0)>(72); //@line 90987 "c/sqlite3.c"
 $spec$select = $3 ? $2 : 72; //@line 90987 "c/sqlite3.c"
 return ($spec$select|0); //@line 90987 "c/sqlite3.c"
}
function _pagerStress($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$023 = 0, $$1 = 0, $$125 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 40|0); //@line 52547 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 52547 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 52547 "c/sqlite3.c"
 if (!($4)) {
  $$023 = 0;
  return ($$023|0); //@line 52595 "c/sqlite3.c"
 }
 $5 = ((($0)) + 20|0); //@line 52551 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 52551 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 52551 "c/sqlite3.c"
 if (!($7)) {
  $8 = $6 & 3; //@line 52552 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 52552 "c/sqlite3.c"
  if (!($9)) {
   $$023 = 0;
   return ($$023|0); //@line 52595 "c/sqlite3.c"
  }
  $10 = ((($1)) + 28|0); //@line 52553 "c/sqlite3.c"
  $11 = HEAP16[$10>>1]|0; //@line 52553 "c/sqlite3.c"
  $12 = $11 & 8; //@line 52553 "c/sqlite3.c"
  $13 = ($12<<16>>16)==(0); //@line 52553 "c/sqlite3.c"
  if (!($13)) {
   $$023 = 0;
   return ($$023|0); //@line 52595 "c/sqlite3.c"
  }
 }
 $14 = ((($1)) + 16|0); //@line 52558 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 52558 "c/sqlite3.c"
 $15 = ((($0)) + 212|0); //@line 52559 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 52559 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 52559 "c/sqlite3.c"
 do {
  if ($17) {
   $21 = ((($1)) + 28|0); //@line 52575 "c/sqlite3.c"
   $22 = HEAP16[$21>>1]|0; //@line 52575 "c/sqlite3.c"
   $23 = $22 & 8; //@line 52575 "c/sqlite3.c"
   $24 = ($23<<16>>16)==(0); //@line 52575 "c/sqlite3.c"
   if ($24) {
    $25 = ((($0)) + 16|0); //@line 52576 "c/sqlite3.c"
    $26 = HEAP8[$25>>0]|0; //@line 52576 "c/sqlite3.c"
    $27 = ($26<<24>>24)==(3); //@line 52576 "c/sqlite3.c"
    if ($27) {
     label = 10;
    }
   } else {
    label = 10;
   }
   if ((label|0) == 10) {
    $28 = (_syncJournal($0,1)|0); //@line 52578 "c/sqlite3.c"
    $29 = ($28|0)==(0); //@line 52582 "c/sqlite3.c"
    if (!($29)) {
     $$125 = $28;
     break;
    }
   }
   $30 = (_pager_write_pagelist($0,$1)|0); //@line 52584 "c/sqlite3.c"
   $$1 = $30;
   label = 12;
  } else {
   $18 = (_subjournalPageIfRequired($1)|0); //@line 52561 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 52562 "c/sqlite3.c"
   if ($19) {
    $20 = (_pagerWalFrames($0,$1,0,0)|0); //@line 52563 "c/sqlite3.c"
    $$1 = $20;
    label = 12;
   } else {
    $$125 = $18;
   }
  }
 } while(0);
 if ((label|0) == 12) {
  $31 = ($$1|0)==(0); //@line 52589 "c/sqlite3.c"
  if ($31) {
   _sqlite3PcacheMakeClean($1); //@line 52591 "c/sqlite3.c"
   $$125 = 0;
  } else {
   $$125 = $$1;
  }
 }
 $32 = (_pager_error($0,$$125)|0); //@line 52594 "c/sqlite3.c"
 $$023 = $32;
 return ($$023|0); //@line 52595 "c/sqlite3.c"
}
function _sqlite3PcacheOpen($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$4; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 45477 "c/sqlite3.c"
 $5 = ((($4)) + 24|0); //@line 45478 "c/sqlite3.c"
 HEAP32[$5>>2] = 1; //@line 45478 "c/sqlite3.c"
 $6 = ((($4)) + 28|0); //@line 45479 "c/sqlite3.c"
 HEAP32[$6>>2] = 88; //@line 45479 "c/sqlite3.c"
 $7 = $1&255; //@line 45481 "c/sqlite3.c"
 $8 = ((($4)) + 32|0); //@line 45481 "c/sqlite3.c"
 HEAP8[$8>>0] = $7; //@line 45481 "c/sqlite3.c"
 $9 = ((($4)) + 33|0); //@line 45482 "c/sqlite3.c"
 HEAP8[$9>>0] = 2; //@line 45482 "c/sqlite3.c"
 $10 = ((($4)) + 36|0); //@line 45483 "c/sqlite3.c"
 HEAP32[$10>>2] = $2; //@line 45483 "c/sqlite3.c"
 $11 = ((($4)) + 40|0); //@line 45484 "c/sqlite3.c"
 HEAP32[$11>>2] = $3; //@line 45484 "c/sqlite3.c"
 $12 = ((($4)) + 16|0); //@line 45485 "c/sqlite3.c"
 HEAP32[$12>>2] = 100; //@line 45485 "c/sqlite3.c"
 $13 = ((($4)) + 20|0); //@line 45486 "c/sqlite3.c"
 HEAP32[$13>>2] = 1; //@line 45486 "c/sqlite3.c"
 $14 = (_sqlite3PcacheSetPageSize($4,$0)|0); //@line 45488 "c/sqlite3.c"
 return ($14|0); //@line 45488 "c/sqlite3.c"
}
function _sqlite3LocateTable($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer3 = sp + 16|0; //@line 101958 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 101958 "c/sqlite3.c"
 $4 = (_sqlite3ReadSchema($0)|0); //@line 101967 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 101967 "c/sqlite3.c"
 if (!($5)) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 101999 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0; //@line 101971 "c/sqlite3.c"
 $7 = (_sqlite3FindTable($6,$2,$3)|0); //@line 101971 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 101972 "c/sqlite3.c"
 if (!($8)) {
  $$3 = $7;
  STACKTOP = sp;return ($$3|0); //@line 101999 "c/sqlite3.c"
 }
 $9 = $1 & 1; //@line 101973 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 101973 "c/sqlite3.c"
 $11 = $10 ? 20026 : 20040; //@line 101973 "c/sqlite3.c"
 $12 = HEAP32[$0>>2]|0; //@line 101975 "c/sqlite3.c"
 $13 = (_sqlite3FindDbName($12,$3)|0); //@line 101975 "c/sqlite3.c"
 $14 = ($13|0)<(1); //@line 101975 "c/sqlite3.c"
 if ($14) {
  $15 = ((($12)) + 328|0); //@line 101979 "c/sqlite3.c"
  $16 = (_sqlite3HashFind($15,$2)|0); //@line 101979 "c/sqlite3.c"
  $17 = ($16|0)==(0|0); //@line 101980 "c/sqlite3.c"
  if ($17) {
   $18 = (_sqlite3_strnicmp($2,20053,7)|0); //@line 101980 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 101980 "c/sqlite3.c"
   if ($19) {
    $20 = HEAP32[$0>>2]|0; //@line 101981 "c/sqlite3.c"
    $21 = (_sqlite3PragmaVtabRegister($20,$2)|0); //@line 101981 "c/sqlite3.c"
    $$0 = $21;
   } else {
    $$0 = $16;
   }
  } else {
   $$0 = $16;
  }
  $22 = ($$0|0)==(0|0); //@line 101983 "c/sqlite3.c"
  if (!($22)) {
   $23 = (_sqlite3VtabEponymousTableInit($0,$$0)|0); //@line 101983 "c/sqlite3.c"
   $24 = ($23|0)==(0); //@line 101983 "c/sqlite3.c"
   if (!($24)) {
    $29 = ((($$0)) + 16|0); //@line 101984 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 101984 "c/sqlite3.c"
    $$3 = $30;
    STACKTOP = sp;return ($$3|0); //@line 101999 "c/sqlite3.c"
   }
  }
 }
 $25 = $1 & 2; //@line 101988 "c/sqlite3.c"
 $26 = ($25|0)==(0); //@line 101988 "c/sqlite3.c"
 if (!($26)) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 101999 "c/sqlite3.c"
 }
 $27 = ($3|0)==(0|0); //@line 101989 "c/sqlite3.c"
 if ($27) {
  HEAP32[$vararg_buffer3>>2] = $11; //@line 101992 "c/sqlite3.c"
  $vararg_ptr6 = ((($vararg_buffer3)) + 4|0); //@line 101992 "c/sqlite3.c"
  HEAP32[$vararg_ptr6>>2] = $2; //@line 101992 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,20071,$vararg_buffer3); //@line 101992 "c/sqlite3.c"
 } else {
  HEAP32[$vararg_buffer>>2] = $11; //@line 101990 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 101990 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $3; //@line 101990 "c/sqlite3.c"
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 101990 "c/sqlite3.c"
  HEAP32[$vararg_ptr2>>2] = $2; //@line 101990 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,20061,$vararg_buffer); //@line 101990 "c/sqlite3.c"
 }
 $28 = ((($0)) + 17|0); //@line 101994 "c/sqlite3.c"
 HEAP8[$28>>0] = 1; //@line 101994 "c/sqlite3.c"
 $$3 = 0;
 STACKTOP = sp;return ($$3|0); //@line 101999 "c/sqlite3.c"
}
function _sqlite3ReadSchema($0) {
 $0 = $0|0;
 var $$011 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 118178 "c/sqlite3.c"
 $2 = ((($1)) + 157|0); //@line 118180 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 118180 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 118180 "c/sqlite3.c"
 if (!($4)) {
  $$011 = 0;
  return ($$011|0); //@line 118187 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 118181 "c/sqlite3.c"
 $6 = (_sqlite3Init($1,$5)|0); //@line 118181 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 118183 "c/sqlite3.c"
 if ($7) {
  $$011 = 0;
  return ($$011|0); //@line 118187 "c/sqlite3.c"
 }
 $8 = ((($0)) + 12|0); //@line 118184 "c/sqlite3.c"
 HEAP32[$8>>2] = $6; //@line 118184 "c/sqlite3.c"
 $9 = ((($0)) + 36|0); //@line 118185 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 118185 "c/sqlite3.c"
 $11 = (($10) + 1)|0; //@line 118185 "c/sqlite3.c"
 HEAP32[$9>>2] = $11; //@line 118185 "c/sqlite3.c"
 $$011 = $6;
 return ($$011|0); //@line 118187 "c/sqlite3.c"
}
function _sqlite3FindTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02430 = 0, $$025 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 20|0);
 $4 = ($2|0)==(0|0);
 $5 = ((($0)) + 16|0);
 $6 = ((($0)) + 16|0);
 $7 = ((($0)) + 16|0);
 $$025 = $1;
 L1: while(1) {
  $8 = HEAP32[$3>>2]|0; //@line 101930 "c/sqlite3.c"
  $9 = ($8|0)>(0); //@line 101930 "c/sqlite3.c"
  if ($9) {
   $$02430 = 0;
   while(1) {
    $10 = ($$02430>>>0)<(2); //@line 101931 "c/sqlite3.c"
    $11 = $10&1; //@line 101931 "c/sqlite3.c"
    $12 = $$02430 ^ $11; //@line 101931 "c/sqlite3.c"
    if ($4) {
     label = 6;
    } else {
     $13 = HEAP32[$6>>2]|0; //@line 101932 "c/sqlite3.c"
     $14 = (($13) + ($12<<4)|0); //@line 101932 "c/sqlite3.c"
     $15 = HEAP32[$14>>2]|0; //@line 101932 "c/sqlite3.c"
     $16 = (_sqlite3StrICmp($2,$15)|0); //@line 101932 "c/sqlite3.c"
     $17 = ($16|0)==(0); //@line 101932 "c/sqlite3.c"
     if ($17) {
      label = 6;
     }
    }
    if ((label|0) == 6) {
     label = 0;
     $18 = HEAP32[$5>>2]|0; //@line 101934 "c/sqlite3.c"
     $19 = (((($18) + ($12<<4)|0)) + 12|0); //@line 101934 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 101934 "c/sqlite3.c"
     $21 = ((($20)) + 8|0); //@line 101934 "c/sqlite3.c"
     $22 = (_sqlite3HashFind($21,$$025)|0); //@line 101934 "c/sqlite3.c"
     $23 = ($22|0)==(0|0); //@line 101935 "c/sqlite3.c"
     if (!($23)) {
      label = 10;
      break L1;
     }
    }
    $24 = (($$02430) + 1)|0; //@line 101930 "c/sqlite3.c"
    $25 = HEAP32[$3>>2]|0; //@line 101930 "c/sqlite3.c"
    $26 = ($24|0)<($25|0); //@line 101930 "c/sqlite3.c"
    if ($26) {
     $$02430 = $24;
    } else {
     break;
    }
   }
  }
  $27 = (_sqlite3StrICmp($$025,19754)|0); //@line 101940 "c/sqlite3.c"
  $28 = ($27|0)==(0); //@line 101940 "c/sqlite3.c"
  if (!($28)) {
   $$3 = 0;
   label = 11;
   break;
  }
  $29 = HEAP32[$7>>2]|0; //@line 101941 "c/sqlite3.c"
  $30 = ((($29)) + 16|0); //@line 101941 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 101941 "c/sqlite3.c"
  $32 = (_sqlite3_stricmp($2,$31)|0); //@line 101941 "c/sqlite3.c"
  $33 = ($32|0)==(0); //@line 101941 "c/sqlite3.c"
  if ($33) {
   $$025 = 21366;
  } else {
   $$3 = 0;
   label = 11;
   break;
  }
 }
 if ((label|0) == 10) {
  $$3 = $22;
  return ($$3|0); //@line 101945 "c/sqlite3.c"
 }
 else if ((label|0) == 11) {
  return ($$3|0); //@line 101945 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3FindDbName($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01415 = 0, $$016 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 102336 "c/sqlite3.c"
 if ($2) {
  $$1 = -1;
  return ($$1|0); //@line 102345 "c/sqlite3.c"
 }
 $3 = ((($0)) + 20|0); //@line 102338 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 102338 "c/sqlite3.c"
 $5 = (($4) + -1)|0; //@line 102338 "c/sqlite3.c"
 $6 = ($4|0)>(0); //@line 102338 "c/sqlite3.c"
 if (!($6)) {
  $$1 = $5;
  return ($$1|0); //@line 102345 "c/sqlite3.c"
 }
 $7 = ((($0)) + 16|0); //@line 102338 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 102338 "c/sqlite3.c"
 $9 = (($8) + ($5<<4)|0); //@line 102338 "c/sqlite3.c"
 $$01415 = $5;$$016 = $9;
 while(1) {
  $10 = HEAP32[$$016>>2]|0; //@line 102339 "c/sqlite3.c"
  $11 = (_sqlite3_stricmp($10,$1)|0); //@line 102339 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 102339 "c/sqlite3.c"
  if ($12) {
   $$1 = $$01415;
   label = 8;
   break;
  }
  $13 = ($$01415|0)==(0); //@line 102342 "c/sqlite3.c"
  if ($13) {
   label = 6;
   break;
  }
  $16 = (($$01415) + -1)|0; //@line 102338 "c/sqlite3.c"
  $17 = ((($$016)) + -16|0); //@line 102338 "c/sqlite3.c"
  $18 = ($$01415|0)>(0); //@line 102338 "c/sqlite3.c"
  if ($18) {
   $$01415 = $16;$$016 = $17;
  } else {
   $$1 = $16;
   label = 8;
   break;
  }
 }
 if ((label|0) == 6) {
  $14 = (_sqlite3_stricmp(21361,$1)|0); //@line 102342 "c/sqlite3.c"
  $15 = ($14|0)!=(0); //@line 102342 "c/sqlite3.c"
  $spec$select = $15 << 31 >> 31; //@line 102342 "c/sqlite3.c"
  return ($spec$select|0); //@line 102342 "c/sqlite3.c"
 }
 else if ((label|0) == 8) {
  return ($$1|0); //@line 102345 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3PragmaVtabRegister($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 7|0); //@line 117772 "c/sqlite3.c"
 $3 = (_pragmaLocate($2)|0); //@line 117772 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 117773 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  return ($$0|0); //@line 117777 "c/sqlite3.c"
 }
 $5 = ((($3)) + 5|0); //@line 117774 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 117774 "c/sqlite3.c"
 $7 = $6 & 48; //@line 117774 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 117774 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 117777 "c/sqlite3.c"
 }
 $9 = (_sqlite3VtabCreateModule($0,$1,4996,$3,0)|0); //@line 117776 "c/sqlite3.c"
 $$0 = $9;
 return ($$0|0); //@line 117777 "c/sqlite3.c"
}
function _sqlite3VtabEponymousTableInit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = sp + 4|0;
 $3 = HEAP32[$1>>2]|0; //@line 128498 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 128500 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 128502 "c/sqlite3.c"
 $5 = ((($1)) + 16|0); //@line 128503 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 128503 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 128503 "c/sqlite3.c"
 if (!($7)) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 128528 "c/sqlite3.c"
 }
 $8 = ((($3)) + 4|0); //@line 128504 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 128504 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 128504 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($3)) + 8|0); //@line 128504 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 128504 "c/sqlite3.c"
  $13 = ($9|0)==($12|0); //@line 128504 "c/sqlite3.c"
  if (!($13)) {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 128528 "c/sqlite3.c"
  }
 }
 $14 = (_sqlite3DbMallocZero($4,80,0)|0); //@line 128505 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 128506 "c/sqlite3.c"
 if ($15) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 128528 "c/sqlite3.c"
 }
 $16 = ((($1)) + 4|0); //@line 128507 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 128507 "c/sqlite3.c"
 $18 = (_sqlite3DbStrDup($4,$17)|0); //@line 128507 "c/sqlite3.c"
 HEAP32[$14>>2] = $18; //@line 128507 "c/sqlite3.c"
 $19 = ($18|0)==(0|0); //@line 128508 "c/sqlite3.c"
 if ($19) {
  _sqlite3DbFree($4,$14); //@line 128509 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 128528 "c/sqlite3.c"
 }
 HEAP32[$5>>2] = $14; //@line 128512 "c/sqlite3.c"
 $20 = ((($14)) + 32|0); //@line 128513 "c/sqlite3.c"
 HEAP32[$20>>2] = 1; //@line 128513 "c/sqlite3.c"
 $21 = ((($4)) + 16|0); //@line 128514 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 128514 "c/sqlite3.c"
 $23 = ((($22)) + 12|0); //@line 128514 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 128514 "c/sqlite3.c"
 $25 = ((($14)) + 72|0); //@line 128514 "c/sqlite3.c"
 HEAP32[$25>>2] = $24; //@line 128514 "c/sqlite3.c"
 $26 = ((($14)) + 40|0); //@line 128516 "c/sqlite3.c"
 HEAP16[$26>>1] = -1; //@line 128516 "c/sqlite3.c"
 $27 = (_sqlite3DbStrDup($4,$18)|0); //@line 128517 "c/sqlite3.c"
 _addModuleArgument($4,$14,$27); //@line 128517 "c/sqlite3.c"
 _addModuleArgument($4,$14,0); //@line 128518 "c/sqlite3.c"
 $28 = HEAP32[$14>>2]|0; //@line 128519 "c/sqlite3.c"
 $29 = (_sqlite3DbStrDup($4,$28)|0); //@line 128519 "c/sqlite3.c"
 _addModuleArgument($4,$14,$29); //@line 128519 "c/sqlite3.c"
 $30 = ((($3)) + 8|0); //@line 128520 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 128520 "c/sqlite3.c"
 $32 = (_vtabCallConstructor($4,$14,$1,$31,$2)|0); //@line 128520 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 128521 "c/sqlite3.c"
 if ($33) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 128528 "c/sqlite3.c"
 }
 $34 = HEAP32[$2>>2]|0; //@line 128522 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $34; //@line 128522 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,15687,$vararg_buffer); //@line 128522 "c/sqlite3.c"
 _sqlite3DbFree($4,$34); //@line 128523 "c/sqlite3.c"
 _sqlite3VtabEponymousTableClear($4,$1); //@line 128524 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 128528 "c/sqlite3.c"
}
function _vtabCallConstructor($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0130140 = 0, $$0131138 = 0, $$0132 = 0, $$0133 = 0, $$0133148 = 0, $$0133149 = 0, $$0134145 = 0, $$0135142 = 0, $$1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0;
 var $vararg_buffer7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $5 = sp + 32|0;
 $6 = sp + 28|0;
 $7 = ((($1)) + 60|0); //@line 127865 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 127865 "c/sqlite3.c"
 $9 = ((($1)) + 56|0); //@line 127866 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 127866 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 127867 "c/sqlite3.c"
 $11 = ((($0)) + 344|0); //@line 127873 "c/sqlite3.c"
 $$0133148 = HEAP32[$11>>2]|0;
 $12 = ($$0133148|0)==(0|0); //@line 127873 "c/sqlite3.c"
 L1: do {
  if (!($12)) {
   $$0133149 = $$0133148;
   while(1) {
    $15 = ((($$0133149)) + 4|0); //@line 127874 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 127874 "c/sqlite3.c"
    $17 = ($16|0)==($1|0); //@line 127874 "c/sqlite3.c"
    if ($17) {
     break;
    }
    $13 = ((($$0133149)) + 8|0); //@line 127873 "c/sqlite3.c"
    $$0133 = HEAP32[$13>>2]|0;
    $14 = ($$0133|0)==(0|0); //@line 127873 "c/sqlite3.c"
    if ($14) {
     break L1;
    } else {
     $$0133149 = $$0133;
    }
   }
   $18 = HEAP32[$1>>2]|0; //@line 127876 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $18; //@line 127875 "c/sqlite3.c"
   $19 = (_sqlite3MPrintf($0,20078,$vararg_buffer)|0); //@line 127875 "c/sqlite3.c"
   HEAP32[$4>>2] = $19; //@line 127875 "c/sqlite3.c"
   $$0 = 6;
   STACKTOP = sp;return ($$0|0); //@line 127976 "c/sqlite3.c"
  }
 } while(0);
 $20 = HEAP32[$1>>2]|0; //@line 127882 "c/sqlite3.c"
 $21 = (_sqlite3DbStrDup($0,$20)|0); //@line 127882 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 127883 "c/sqlite3.c"
 if ($22) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 127976 "c/sqlite3.c"
 }
 $23 = (_sqlite3MallocZero(28,0)|0); //@line 127887 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 127888 "c/sqlite3.c"
 if ($24) {
  _sqlite3OomFault($0); //@line 127889 "c/sqlite3.c"
  _sqlite3DbFree($0,$21); //@line 127890 "c/sqlite3.c"
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 127976 "c/sqlite3.c"
 }
 HEAP32[$23>>2] = $0; //@line 127893 "c/sqlite3.c"
 $25 = ((($23)) + 4|0); //@line 127894 "c/sqlite3.c"
 HEAP32[$25>>2] = $2; //@line 127894 "c/sqlite3.c"
 $26 = ((($1)) + 72|0); //@line 127896 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 127896 "c/sqlite3.c"
 $28 = (_sqlite3SchemaToIndex($0,$27)|0); //@line 127896 "c/sqlite3.c"
 $29 = ((($0)) + 16|0); //@line 127897 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 127897 "c/sqlite3.c"
 $31 = (($30) + ($28<<4)|0); //@line 127897 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 127897 "c/sqlite3.c"
 $33 = HEAP32[$7>>2]|0; //@line 127897 "c/sqlite3.c"
 $34 = ((($33)) + 4|0); //@line 127897 "c/sqlite3.c"
 HEAP32[$34>>2] = $32; //@line 127897 "c/sqlite3.c"
 $35 = ((($5)) + 4|0); //@line 127902 "c/sqlite3.c"
 HEAP32[$35>>2] = $1; //@line 127902 "c/sqlite3.c"
 HEAP32[$5>>2] = $23; //@line 127903 "c/sqlite3.c"
 $36 = HEAP32[$11>>2]|0; //@line 127904 "c/sqlite3.c"
 $37 = ((($5)) + 8|0); //@line 127904 "c/sqlite3.c"
 HEAP32[$37>>2] = $36; //@line 127904 "c/sqlite3.c"
 $38 = ((($5)) + 12|0); //@line 127905 "c/sqlite3.c"
 HEAP32[$38>>2] = 0; //@line 127905 "c/sqlite3.c"
 HEAP32[$11>>2] = $5; //@line 127906 "c/sqlite3.c"
 $39 = ((($2)) + 8|0); //@line 127907 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 127907 "c/sqlite3.c"
 $41 = ((($23)) + 8|0); //@line 127907 "c/sqlite3.c"
 $42 = (FUNCTION_TABLE_iiiiiii[$3 & 127]($0,$40,$10,$8,$41,$6)|0); //@line 127907 "c/sqlite3.c"
 $43 = HEAP32[$37>>2]|0; //@line 127908 "c/sqlite3.c"
 HEAP32[$11>>2] = $43; //@line 127908 "c/sqlite3.c"
 L16: do {
  switch ($42|0) {
  case 7:  {
   _sqlite3OomFault($0); //@line 127909 "c/sqlite3.c"
   label = 11;
   break;
  }
  case 0:  {
   $49 = HEAP32[$41>>2]|0; //@line 127920 "c/sqlite3.c"
   $50 = ($49|0)==(0|0); //@line 127920 "c/sqlite3.c"
   if ($50) {
    $$0132 = 0;
   } else {
    ;HEAP32[$49>>2]=0|0;HEAP32[$49+4>>2]=0|0;HEAP32[$49+8>>2]=0|0; //@line 127923 "c/sqlite3.c"
    $51 = HEAP32[$2>>2]|0; //@line 127924 "c/sqlite3.c"
    $52 = HEAP32[$41>>2]|0; //@line 127924 "c/sqlite3.c"
    HEAP32[$52>>2] = $51; //@line 127924 "c/sqlite3.c"
    $53 = ((($23)) + 12|0); //@line 127925 "c/sqlite3.c"
    HEAP32[$53>>2] = 1; //@line 127925 "c/sqlite3.c"
    $54 = HEAP32[$38>>2]|0; //@line 127926 "c/sqlite3.c"
    $55 = ($54|0)==(0); //@line 127926 "c/sqlite3.c"
    if ($55) {
     $56 = HEAP32[$1>>2]|0; //@line 127928 "c/sqlite3.c"
     HEAP32[$vararg_buffer7>>2] = $56; //@line 127928 "c/sqlite3.c"
     $57 = (_sqlite3MPrintf($0,20150,$vararg_buffer7)|0); //@line 127928 "c/sqlite3.c"
     HEAP32[$4>>2] = $57; //@line 127928 "c/sqlite3.c"
     _sqlite3VtabUnlock($23); //@line 127929 "c/sqlite3.c"
     $$0132 = 1;
     break L16;
    }
    $58 = ((($1)) + 64|0); //@line 127939 "c/sqlite3.c"
    $59 = HEAP32[$58>>2]|0; //@line 127939 "c/sqlite3.c"
    $60 = ((($23)) + 24|0); //@line 127939 "c/sqlite3.c"
    HEAP32[$60>>2] = $59; //@line 127939 "c/sqlite3.c"
    HEAP32[$58>>2] = $23; //@line 127940 "c/sqlite3.c"
    $61 = ((($1)) + 42|0); //@line 127942 "c/sqlite3.c"
    $62 = HEAP16[$61>>1]|0; //@line 127942 "c/sqlite3.c"
    $63 = ($62<<16>>16)>(0); //@line 127942 "c/sqlite3.c"
    if ($63) {
     $64 = ((($1)) + 4|0);
     $65 = ((($1)) + 36|0);
     $$0134145 = 0;$$0135142 = 0;
     while(1) {
      $66 = HEAP32[$64>>2]|0; //@line 127943 "c/sqlite3.c"
      $67 = (($66) + ($$0135142<<4)|0); //@line 127943 "c/sqlite3.c"
      $68 = (_sqlite3ColumnType($67,41388)|0); //@line 127943 "c/sqlite3.c"
      $69 = (_sqlite3Strlen30($68)|0); //@line 127946 "c/sqlite3.c"
      $70 = ($69|0)>(0); //@line 127947 "c/sqlite3.c"
      L26: do {
       if ($70) {
        $$0131138 = 0;
        L28: while(1) {
         $71 = (($68) + ($$0131138)|0); //@line 127948 "c/sqlite3.c"
         $72 = (_sqlite3_strnicmp(20196,$71,6)|0); //@line 127948 "c/sqlite3.c"
         $73 = ($72|0)==(0); //@line 127948 "c/sqlite3.c"
         do {
          if ($73) {
           $74 = ($$0131138|0)==(0); //@line 127949 "c/sqlite3.c"
           if (!($74)) {
            $75 = (($$0131138) + -1)|0; //@line 127949 "c/sqlite3.c"
            $76 = (($68) + ($75)|0); //@line 127949 "c/sqlite3.c"
            $77 = HEAP8[$76>>0]|0; //@line 127949 "c/sqlite3.c"
            $78 = ($77<<24>>24)==(32); //@line 127949 "c/sqlite3.c"
            if (!($78)) {
             break;
            }
           }
           $79 = (($$0131138) + 6)|0; //@line 127950 "c/sqlite3.c"
           $80 = (($68) + ($79)|0); //@line 127950 "c/sqlite3.c"
           $81 = HEAP8[$80>>0]|0; //@line 127950 "c/sqlite3.c"
           switch ($81<<24>>24) {
           case 32: case 0:  {
            break L28;
            break;
           }
           default: {
           }
           }
          }
         } while(0);
         $82 = (($$0131138) + 1)|0; //@line 127947 "c/sqlite3.c"
         $83 = ($82|0)<($69|0); //@line 127947 "c/sqlite3.c"
         if ($83) {
          $$0131138 = $82;
         } else {
          label = 33;
          break L26;
         }
        }
        $84 = ($81<<24>>24)==(0); //@line 127957 "c/sqlite3.c"
        $85 = $84 ? 6 : 7; //@line 127957 "c/sqlite3.c"
        $86 = (($$0131138) + ($85))|0; //@line 127958 "c/sqlite3.c"
        $87 = ($86|0)>($69|0); //@line 127958 "c/sqlite3.c"
        if (!($87)) {
         $$0130140 = $$0131138;$89 = $86;
         while(1) {
          $88 = (($68) + ($89)|0); //@line 127959 "c/sqlite3.c"
          $90 = HEAP8[$88>>0]|0; //@line 127959 "c/sqlite3.c"
          $91 = (($68) + ($$0130140)|0); //@line 127959 "c/sqlite3.c"
          HEAP8[$91>>0] = $90; //@line 127959 "c/sqlite3.c"
          $92 = (($$0130140) + 1)|0; //@line 127958 "c/sqlite3.c"
          $93 = (($92) + ($85))|0; //@line 127958 "c/sqlite3.c"
          $94 = ($93|0)>($69|0); //@line 127958 "c/sqlite3.c"
          if ($94) {
           break;
          } else {
           $$0130140 = $92;$89 = $93;
          }
         }
        }
        $95 = HEAP8[$71>>0]|0; //@line 127961 "c/sqlite3.c"
        $96 = ($95<<24>>24)==(0); //@line 127961 "c/sqlite3.c"
        $97 = ($$0131138|0)!=(0); //@line 127961 "c/sqlite3.c"
        $or$cond = $97 & $96; //@line 127961 "c/sqlite3.c"
        if ($or$cond) {
         $98 = (($$0131138) + -1)|0; //@line 127963 "c/sqlite3.c"
         $99 = (($68) + ($98)|0); //@line 127963 "c/sqlite3.c"
         HEAP8[$99>>0] = 0; //@line 127963 "c/sqlite3.c"
        }
        $100 = HEAP32[$64>>2]|0; //@line 127965 "c/sqlite3.c"
        $101 = (((($100) + ($$0135142<<4)|0)) + 15|0); //@line 127965 "c/sqlite3.c"
        $102 = HEAP8[$101>>0]|0; //@line 127965 "c/sqlite3.c"
        $103 = $102 | 2; //@line 127965 "c/sqlite3.c"
        HEAP8[$101>>0] = $103; //@line 127965 "c/sqlite3.c"
        $$1 = -128;
       } else {
        label = 33;
       }
      } while(0);
      if ((label|0) == 33) {
       label = 0;
       $104 = $$0134145&255; //@line 127968 "c/sqlite3.c"
       $105 = HEAP32[$65>>2]|0; //@line 127968 "c/sqlite3.c"
       $106 = $105 | $104; //@line 127968 "c/sqlite3.c"
       HEAP32[$65>>2] = $106; //@line 127968 "c/sqlite3.c"
       $$1 = $$0134145;
      }
      $107 = (($$0135142) + 1)|0; //@line 127942 "c/sqlite3.c"
      $108 = HEAP16[$61>>1]|0; //@line 127942 "c/sqlite3.c"
      $109 = $108 << 16 >> 16; //@line 127942 "c/sqlite3.c"
      $110 = ($107|0)<($109|0); //@line 127942 "c/sqlite3.c"
      if ($110) {
       $$0134145 = $$1;$$0135142 = $107;
      } else {
       $$0132 = $42;
       break;
      }
     }
    } else {
     $$0132 = 0;
    }
   }
   break;
  }
  default: {
   label = 11;
  }
  }
 } while(0);
 if ((label|0) == 11) {
  $44 = HEAP32[$6>>2]|0; //@line 127913 "c/sqlite3.c"
  $45 = ($44|0)==(0|0); //@line 127913 "c/sqlite3.c"
  if ($45) {
   HEAP32[$vararg_buffer1>>2] = $21; //@line 127914 "c/sqlite3.c"
   $46 = (_sqlite3MPrintf($0,20120,$vararg_buffer1)|0); //@line 127914 "c/sqlite3.c"
   HEAP32[$4>>2] = $46; //@line 127914 "c/sqlite3.c"
  } else {
   HEAP32[$vararg_buffer4>>2] = $44; //@line 127916 "c/sqlite3.c"
   $47 = (_sqlite3MPrintf($0,15687,$vararg_buffer4)|0); //@line 127916 "c/sqlite3.c"
   HEAP32[$4>>2] = $47; //@line 127916 "c/sqlite3.c"
   $48 = HEAP32[$6>>2]|0; //@line 127917 "c/sqlite3.c"
   _sqlite3_free($48); //@line 127917 "c/sqlite3.c"
  }
  _sqlite3DbFree($0,$23); //@line 127919 "c/sqlite3.c"
  $$0132 = $42;
 }
 _sqlite3DbFree($0,$21); //@line 127974 "c/sqlite3.c"
 $$0 = $$0132;
 STACKTOP = sp;return ($$0|0); //@line 127976 "c/sqlite3.c"
}
function _sqlite3VtabEponymousTableClear($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 16|0); //@line 128535 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 128535 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 128536 "c/sqlite3.c"
 if ($4) {
  return; //@line 128544 "c/sqlite3.c"
 }
 $5 = ((($3)) + 36|0); //@line 128540 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 128540 "c/sqlite3.c"
 $7 = $6 | 2; //@line 128540 "c/sqlite3.c"
 HEAP32[$5>>2] = $7; //@line 128540 "c/sqlite3.c"
 _sqlite3DeleteTable($0,$3); //@line 128541 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 128542 "c/sqlite3.c"
 return; //@line 128544 "c/sqlite3.c"
}
function _sqlite3ColumnType($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 15|0); //@line 28588 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 28588 "c/sqlite3.c"
 $4 = $3 & 4; //@line 28588 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 28588 "c/sqlite3.c"
 if ($5) {
  $$0 = $1;
  return ($$0|0); //@line 28590 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0; //@line 28589 "c/sqlite3.c"
 $7 = (_strlen($6)|0); //@line 28589 "c/sqlite3.c"
 $8 = (($6) + ($7)|0); //@line 28589 "c/sqlite3.c"
 $9 = ((($8)) + 1|0); //@line 28589 "c/sqlite3.c"
 $$0 = $9;
 return ($$0|0); //@line 28590 "c/sqlite3.c"
}
function _pragmaLocate($0) {
 $0 = $0|0;
 var $$02022 = 0, $$023 = 0, $$1 = 0, $$121 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$02022 = 0;$$023 = 57;
 while(1) {
  $1 = (($$023) + ($$02022))|0; //@line 115579 "c/sqlite3.c"
  $2 = (($1|0) / 2)&-1; //@line 115579 "c/sqlite3.c"
  $3 = (5296 + (($2*12)|0)|0); //@line 115580 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 115580 "c/sqlite3.c"
  $5 = (_sqlite3_stricmp($0,$4)|0); //@line 115580 "c/sqlite3.c"
  $6 = ($5|0)==(0); //@line 115581 "c/sqlite3.c"
  if ($6) {
   $$lcssa = 0;
   label = 4;
   break;
  }
  $7 = ($5|0)<(0); //@line 115582 "c/sqlite3.c"
  $8 = (($2) + -1)|0; //@line 115583 "c/sqlite3.c"
  $9 = (($2) + 1)|0; //@line 115585 "c/sqlite3.c"
  $$121 = $7 ? $$02022 : $9; //@line 115582 "c/sqlite3.c"
  $$1 = $7 ? $8 : $$023; //@line 115582 "c/sqlite3.c"
  $10 = ($$121|0)>($$1|0); //@line 115578 "c/sqlite3.c"
  if ($10) {
   $$lcssa = 1;
   label = 4;
   break;
  } else {
   $$02022 = $$121;$$023 = $$1;
  }
 }
 if ((label|0) == 4) {
  $11 = (5296 + (($2*12)|0)|0); //@line 115588 "c/sqlite3.c"
  $12 = $$lcssa ? 0 : $11; //@line 115588 "c/sqlite3.c"
  return ($12|0); //@line 115588 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VtabCreateModule($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3Strlen30($1)|0); //@line 127403 "c/sqlite3.c"
 $6 = (($5) + 21)|0; //@line 127404 "c/sqlite3.c"
 $7 = (_sqlite3Malloc($6,0)|0); //@line 127404 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 127405 "c/sqlite3.c"
 if ($8) {
  _sqlite3OomFault($0); //@line 127406 "c/sqlite3.c"
  $$1 = $7;
  return ($$1|0); //@line 127424 "c/sqlite3.c"
 }
 $9 = ((($7)) + 20|0); //@line 127409 "c/sqlite3.c"
 $10 = (($5) + 1)|0; //@line 127410 "c/sqlite3.c"
 _memcpy(($9|0),($1|0),($10|0))|0; //@line 127410 "c/sqlite3.c"
 $11 = ((($7)) + 4|0); //@line 127411 "c/sqlite3.c"
 HEAP32[$11>>2] = $9; //@line 127411 "c/sqlite3.c"
 HEAP32[$7>>2] = $2; //@line 127412 "c/sqlite3.c"
 $12 = ((($7)) + 8|0); //@line 127413 "c/sqlite3.c"
 HEAP32[$12>>2] = $3; //@line 127413 "c/sqlite3.c"
 $13 = ((($7)) + 12|0); //@line 127414 "c/sqlite3.c"
 HEAP32[$13>>2] = $4; //@line 127414 "c/sqlite3.c"
 $14 = ((($7)) + 16|0); //@line 127415 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 127415 "c/sqlite3.c"
 $15 = ((($0)) + 328|0); //@line 127416 "c/sqlite3.c"
 $16 = (_sqlite3HashInsert($15,$9,$7)|0); //@line 127416 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 127418 "c/sqlite3.c"
 if ($17) {
  $$1 = $7;
  return ($$1|0); //@line 127424 "c/sqlite3.c"
 }
 _sqlite3OomFault($0); //@line 127419 "c/sqlite3.c"
 _sqlite3DbFree($0,$16); //@line 127420 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 127424 "c/sqlite3.c"
}
function _pragmaVtabConnect($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$04248 = 0, $$04248$in = 0, $$04347 = 0, $$045 = 0, $$046 = 0, $$1 = 0, $$144 = 0, $$2 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer6 = 0, $vararg_buffer9 = 0, $vararg_ptr1 = 0, $vararg_ptr5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 256|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(256|0);
 $vararg_buffer9 = sp + 24|0;
 $vararg_buffer6 = sp + 16|0;
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 $6 = sp + 32|0;
 $7 = sp + 56|0;
 _sqlite3StrAccumInit($6,0,$7,200,0); //@line 117511 "c/sqlite3.c"
 _sqlite3StrAccumAppendAll($6,20219); //@line 117512 "c/sqlite3.c"
 $8 = ((($1)) + 7|0); //@line 117513 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 117513 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 117513 "c/sqlite3.c"
 if ($10) {
  $24 = HEAP32[$1>>2]|0; //@line 117518 "c/sqlite3.c"
  HEAP32[$vararg_buffer6>>2] = $24; //@line 117518 "c/sqlite3.c"
  _sqlite3XPrintf($6,20241,$vararg_buffer6); //@line 117518 "c/sqlite3.c"
  $$144 = 1;
 } else {
  $11 = ((($1)) + 6|0); //@line 117513 "c/sqlite3.c"
  $12 = HEAP8[$11>>0]|0; //@line 117513 "c/sqlite3.c"
  $13 = $12&255; //@line 117513 "c/sqlite3.c"
  $14 = (5088 + ($13<<2)|0); //@line 117514 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 117514 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = 40; //@line 117514 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 117514 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $15; //@line 117514 "c/sqlite3.c"
  _sqlite3XPrintf($6,20234,$vararg_buffer); //@line 117514 "c/sqlite3.c"
  $16 = HEAP8[$8>>0]|0; //@line 117513 "c/sqlite3.c"
  $17 = ($16&255)>(1); //@line 117513 "c/sqlite3.c"
  if ($17) {
   $$04248$in = $13;$$04347 = 1;
   while(1) {
    $$04248 = (($$04248$in) + 1)|0; //@line 117513 "c/sqlite3.c"
    $18 = (5088 + ($$04248<<2)|0); //@line 117514 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 117514 "c/sqlite3.c"
    HEAP32[$vararg_buffer2>>2] = 44; //@line 117514 "c/sqlite3.c"
    $vararg_ptr5 = ((($vararg_buffer2)) + 4|0); //@line 117514 "c/sqlite3.c"
    HEAP32[$vararg_ptr5>>2] = $19; //@line 117514 "c/sqlite3.c"
    _sqlite3XPrintf($6,20234,$vararg_buffer2); //@line 117514 "c/sqlite3.c"
    $20 = (($$04347) + 1)|0; //@line 117513 "c/sqlite3.c"
    $21 = HEAP8[$8>>0]|0; //@line 117513 "c/sqlite3.c"
    $22 = $21&255; //@line 117513 "c/sqlite3.c"
    $23 = ($20>>>0)<($22>>>0); //@line 117513 "c/sqlite3.c"
    if ($23) {
     $$04248$in = $$04248;$$04347 = $20;
    } else {
     break;
    }
   }
   $phitmp = $20&255; //@line 117523 "c/sqlite3.c"
   $$144 = $phitmp;
  } else {
   $$144 = 1;
  }
 }
 $25 = ((($1)) + 5|0); //@line 117523 "c/sqlite3.c"
 $26 = HEAP8[$25>>0]|0; //@line 117523 "c/sqlite3.c"
 $27 = $26 & 32; //@line 117523 "c/sqlite3.c"
 $28 = ($27<<24>>24)==(0); //@line 117523 "c/sqlite3.c"
 if ($28) {
  $$1 = 0;$30 = $26;
 } else {
  _sqlite3StrAccumAppendAll($6,20247); //@line 117524 "c/sqlite3.c"
  $$pr = HEAP8[$25>>0]|0; //@line 117527 "c/sqlite3.c"
  $$1 = 1;$30 = $$pr;
 }
 $29 = ($30&255)>(63); //@line 117527 "c/sqlite3.c"
 if ($29) {
  $31 = (($$1) + 1)|0; //@line 117529 "c/sqlite3.c"
  _sqlite3StrAccumAppendAll($6,20259); //@line 117528 "c/sqlite3.c"
  $$2 = $31;
 } else {
  $$2 = $$1;
 }
 _sqlite3StrAccumAppend($6,20274,1); //@line 117531 "c/sqlite3.c"
 (_sqlite3StrAccumFinish($6)|0); //@line 117532 "c/sqlite3.c"
 $32 = (_sqlite3_declare_vtab($0,$7)|0); //@line 117534 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 117535 "c/sqlite3.c"
 if (!($33)) {
  $41 = (_sqlite3_errmsg($0)|0); //@line 117547 "c/sqlite3.c"
  HEAP32[$vararg_buffer9>>2] = $41; //@line 117547 "c/sqlite3.c"
  $42 = (_sqlite3_mprintf(15687,$vararg_buffer9)|0); //@line 117547 "c/sqlite3.c"
  HEAP32[$5>>2] = $42; //@line 117547 "c/sqlite3.c"
  $$045 = $32;$$046 = 0;
  HEAP32[$4>>2] = $$046; //@line 117550 "c/sqlite3.c"
  STACKTOP = sp;return ($$045|0); //@line 117551 "c/sqlite3.c"
 }
 $34 = (_sqlite3_malloc(24)|0); //@line 117536 "c/sqlite3.c"
 $35 = ($34|0)==(0|0); //@line 117537 "c/sqlite3.c"
 if ($35) {
  $$045 = 7;$$046 = $34;
  HEAP32[$4>>2] = $$046; //@line 117550 "c/sqlite3.c"
  STACKTOP = sp;return ($$045|0); //@line 117551 "c/sqlite3.c"
 }
 ;HEAP32[$34>>2]=0|0;HEAP32[$34+4>>2]=0|0;HEAP32[$34+8>>2]=0|0;HEAP32[$34+12>>2]=0|0;HEAP32[$34+16>>2]=0|0;HEAP32[$34+20>>2]=0|0; //@line 117540 "c/sqlite3.c"
 $36 = ((($34)) + 16|0); //@line 117541 "c/sqlite3.c"
 HEAP32[$36>>2] = $1; //@line 117541 "c/sqlite3.c"
 $37 = ((($34)) + 12|0); //@line 117542 "c/sqlite3.c"
 HEAP32[$37>>2] = $0; //@line 117542 "c/sqlite3.c"
 $38 = ((($34)) + 21|0); //@line 117543 "c/sqlite3.c"
 HEAP8[$38>>0] = $$144; //@line 117543 "c/sqlite3.c"
 $39 = $$2&255; //@line 117544 "c/sqlite3.c"
 $40 = ((($34)) + 20|0); //@line 117544 "c/sqlite3.c"
 HEAP8[$40>>0] = $39; //@line 117544 "c/sqlite3.c"
 $$045 = 0;$$046 = $34;
 HEAP32[$4>>2] = $$046; //@line 117550 "c/sqlite3.c"
 STACKTOP = sp;return ($$045|0); //@line 117551 "c/sqlite3.c"
}
function _pragmaVtabBestIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$03537 = 0, $$038 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($1)) + 40|0); //@line 117576 "c/sqlite3.c"
 HEAPF64[$3>>3] = 1.0; //@line 117576 "c/sqlite3.c"
 $4 = ((($0)) + 20|0); //@line 117577 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 117577 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 117577 "c/sqlite3.c"
 if ($6) {
  STACKTOP = sp;return 0; //@line 117604 "c/sqlite3.c"
 }
 $7 = ((($1)) + 4|0); //@line 117578 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 117578 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 117579 "c/sqlite3.c"
 $9 = ((($2)) + 4|0); //@line 117580 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 117580 "c/sqlite3.c"
 $10 = HEAP32[$1>>2]|0; //@line 117581 "c/sqlite3.c"
 $11 = ($10|0)>(0); //@line 117581 "c/sqlite3.c"
 if ($11) {
  $12 = HEAP32[$1>>2]|0;
  $13 = ((($0)) + 21|0);
  $$03537 = $8;$$038 = 0;
  while(1) {
   $14 = ((($$03537)) + 5|0); //@line 117582 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 117582 "c/sqlite3.c"
   $16 = ($15<<24>>24)==(0); //@line 117582 "c/sqlite3.c"
   if (!($16)) {
    $17 = ((($$03537)) + 4|0); //@line 117583 "c/sqlite3.c"
    $18 = HEAP8[$17>>0]|0; //@line 117583 "c/sqlite3.c"
    $19 = ($18<<24>>24)==(2); //@line 117583 "c/sqlite3.c"
    if ($19) {
     $20 = HEAP32[$$03537>>2]|0; //@line 117584 "c/sqlite3.c"
     $21 = HEAP8[$13>>0]|0; //@line 117584 "c/sqlite3.c"
     $22 = $21&255; //@line 117584 "c/sqlite3.c"
     $23 = ($20|0)<($22|0); //@line 117584 "c/sqlite3.c"
     if (!($23)) {
      $24 = (($20) - ($22))|0; //@line 117585 "c/sqlite3.c"
      $25 = (($2) + ($24<<2)|0); //@line 117587 "c/sqlite3.c"
      $26 = (($$038) + 1)|0; //@line 117587 "c/sqlite3.c"
      HEAP32[$25>>2] = $26; //@line 117587 "c/sqlite3.c"
     }
    }
   }
   $27 = (($$038) + 1)|0; //@line 117581 "c/sqlite3.c"
   $28 = ((($$03537)) + 12|0); //@line 117581 "c/sqlite3.c"
   $29 = ($27|0)<($12|0); //@line 117581 "c/sqlite3.c"
   if ($29) {
    $$03537 = $28;$$038 = $27;
   } else {
    break;
   }
  }
 }
 $30 = HEAP32[$2>>2]|0; //@line 117589 "c/sqlite3.c"
 $31 = ($30|0)==(0); //@line 117589 "c/sqlite3.c"
 if ($31) {
  HEAPF64[$3>>3] = 2147483647.0; //@line 117590 "c/sqlite3.c"
  $32 = ((($1)) + 48|0); //@line 117591 "c/sqlite3.c"
  $33 = $32; //@line 117591 "c/sqlite3.c"
  $34 = $33; //@line 117591 "c/sqlite3.c"
  HEAP32[$34>>2] = 2147483647; //@line 117591 "c/sqlite3.c"
  $35 = (($33) + 4)|0; //@line 117591 "c/sqlite3.c"
  $36 = $35; //@line 117591 "c/sqlite3.c"
  HEAP32[$36>>2] = 0; //@line 117591 "c/sqlite3.c"
  STACKTOP = sp;return 0; //@line 117604 "c/sqlite3.c"
 }
 $37 = (($30) + -1)|0; //@line 117594 "c/sqlite3.c"
 $38 = ((($1)) + 16|0); //@line 117595 "c/sqlite3.c"
 $39 = HEAP32[$38>>2]|0; //@line 117595 "c/sqlite3.c"
 $40 = (($39) + ($37<<3)|0); //@line 117595 "c/sqlite3.c"
 HEAP32[$40>>2] = 1; //@line 117595 "c/sqlite3.c"
 $41 = (((($39) + ($37<<3)|0)) + 4|0); //@line 117596 "c/sqlite3.c"
 HEAP8[$41>>0] = 1; //@line 117596 "c/sqlite3.c"
 $42 = HEAP32[$9>>2]|0; //@line 117597 "c/sqlite3.c"
 $43 = ($42|0)==(0); //@line 117597 "c/sqlite3.c"
 $44 = (($42) + -1)|0; //@line 117600 "c/sqlite3.c"
 if ($43) {
  STACKTOP = sp;return 0; //@line 117604 "c/sqlite3.c"
 }
 $45 = (((($39) + ($44<<3)|0)) + 4|0); //@line 117602 "c/sqlite3.c"
 $46 = (($39) + ($44<<3)|0); //@line 117601 "c/sqlite3.c"
 $47 = ((($1)) + 48|0); //@line 117599 "c/sqlite3.c"
 HEAPF64[$3>>3] = 20.0; //@line 117598 "c/sqlite3.c"
 $48 = $47; //@line 117599 "c/sqlite3.c"
 $49 = $48; //@line 117599 "c/sqlite3.c"
 HEAP32[$49>>2] = 20; //@line 117599 "c/sqlite3.c"
 $50 = (($48) + 4)|0; //@line 117599 "c/sqlite3.c"
 $51 = $50; //@line 117599 "c/sqlite3.c"
 HEAP32[$51>>2] = 0; //@line 117599 "c/sqlite3.c"
 HEAP32[$46>>2] = 2; //@line 117601 "c/sqlite3.c"
 HEAP8[$45>>0] = 1; //@line 117602 "c/sqlite3.c"
 STACKTOP = sp;return 0; //@line 117604 "c/sqlite3.c"
}
function _pragmaVtabDisconnect($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3_free($0); //@line 117559 "c/sqlite3.c"
 return 0; //@line 117560 "c/sqlite3.c"
}
function _pragmaVtabOpen($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3_malloc(24)|0); //@line 117609 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 117610 "c/sqlite3.c"
 if ($3) {
  $$0 = 7;
  return ($$0|0); //@line 117615 "c/sqlite3.c"
 }
 ;HEAP32[$2>>2]=0|0;HEAP32[$2+4>>2]=0|0;HEAP32[$2+8>>2]=0|0;HEAP32[$2+12>>2]=0|0;HEAP32[$2+16>>2]=0|0;HEAP32[$2+20>>2]=0|0; //@line 117611 "c/sqlite3.c"
 HEAP32[$2>>2] = $0; //@line 117612 "c/sqlite3.c"
 HEAP32[$1>>2] = $2; //@line 117613 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 117615 "c/sqlite3.c"
}
function _pragmaVtabClose($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _pragmaVtabCursorClear($0); //@line 117631 "c/sqlite3.c"
 _sqlite3_free($0); //@line 117632 "c/sqlite3.c"
 return 0; //@line 117633 "c/sqlite3.c"
}
function _pragmaVtabFilter($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$04952 = 0, $$05051 = 0, $$2 = 0, $$lobit = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $5 = sp + 32|0;
 $6 = HEAP32[$0>>2]|0; //@line 117661 "c/sqlite3.c"
 _pragmaVtabCursorClear($0); //@line 117669 "c/sqlite3.c"
 $7 = ((($6)) + 16|0); //@line 117670 "c/sqlite3.c"
 $8 = ($3|0)>(0); //@line 117671 "c/sqlite3.c"
 L1: do {
  if ($8) {
   $9 = HEAP32[$7>>2]|0; //@line 117670 "c/sqlite3.c"
   $10 = ((($9)) + 5|0); //@line 117670 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 117670 "c/sqlite3.c"
   $12 = ($11&255) >>> 5; //@line 117670 "c/sqlite3.c"
   $$lobit = $12 & 1; //@line 117670 "c/sqlite3.c"
   $13 = $$lobit ^ 1; //@line 117670 "c/sqlite3.c"
   $14 = $13&255; //@line 117670 "c/sqlite3.c"
   $15 = ((($0)) + 16|0);
   $$04952 = 0;$$05051 = $14;
   while(1) {
    $16 = (($4) + ($$04952<<2)|0); //@line 117672 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 117672 "c/sqlite3.c"
    $18 = (_sqlite3_value_text($17)|0); //@line 117672 "c/sqlite3.c"
    $19 = ($18|0)==(0|0); //@line 117675 "c/sqlite3.c"
    if (!($19)) {
     HEAP32[$vararg_buffer>>2] = $18; //@line 117676 "c/sqlite3.c"
     $20 = (_sqlite3_mprintf(15687,$vararg_buffer)|0); //@line 117676 "c/sqlite3.c"
     $21 = (($15) + ($$05051<<2)|0); //@line 117676 "c/sqlite3.c"
     HEAP32[$21>>2] = $20; //@line 117676 "c/sqlite3.c"
     $22 = ($20|0)==(0|0); //@line 117677 "c/sqlite3.c"
     if ($22) {
      $$2 = 7;
      break;
     }
    }
    $23 = (($$04952) + 1)|0; //@line 117671 "c/sqlite3.c"
    $24 = (($$05051) + 1)|0; //@line 117671 "c/sqlite3.c"
    $25 = ($23|0)<($3|0); //@line 117671 "c/sqlite3.c"
    if ($25) {
     $$04952 = $23;$$05051 = $24;
    } else {
     break L1;
    }
   }
   STACKTOP = sp;return ($$2|0); //@line 117700 "c/sqlite3.c"
  }
 } while(0);
 $26 = ((($6)) + 12|0); //@line 117682 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 117682 "c/sqlite3.c"
 $28 = ((($27)) + 104|0); //@line 117682 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 117682 "c/sqlite3.c"
 _sqlite3StrAccumInit($5,0,0,0,$29); //@line 117682 "c/sqlite3.c"
 _sqlite3StrAccumAppendAll($5,20203); //@line 117683 "c/sqlite3.c"
 $30 = ((($0)) + 16|0); //@line 117684 "c/sqlite3.c"
 $31 = ((($0)) + 20|0); //@line 117684 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 117684 "c/sqlite3.c"
 $33 = ($32|0)==(0|0); //@line 117684 "c/sqlite3.c"
 if (!($33)) {
  HEAP32[$vararg_buffer1>>2] = $32; //@line 117685 "c/sqlite3.c"
  _sqlite3XPrintf($5,20211,$vararg_buffer1); //@line 117685 "c/sqlite3.c"
 }
 $34 = HEAP32[$7>>2]|0; //@line 117687 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 117687 "c/sqlite3.c"
 _sqlite3StrAccumAppendAll($5,$35); //@line 117687 "c/sqlite3.c"
 $36 = HEAP32[$30>>2]|0; //@line 117688 "c/sqlite3.c"
 $37 = ($36|0)==(0|0); //@line 117688 "c/sqlite3.c"
 if (!($37)) {
  HEAP32[$vararg_buffer4>>2] = $36; //@line 117689 "c/sqlite3.c"
  _sqlite3XPrintf($5,20215,$vararg_buffer4); //@line 117689 "c/sqlite3.c"
 }
 $38 = (_sqlite3StrAccumFinish($5)|0); //@line 117691 "c/sqlite3.c"
 $39 = ($38|0)==(0|0); //@line 117692 "c/sqlite3.c"
 if ($39) {
  $$2 = 7;
  STACKTOP = sp;return ($$2|0); //@line 117700 "c/sqlite3.c"
 }
 $40 = HEAP32[$26>>2]|0; //@line 117693 "c/sqlite3.c"
 $41 = ((($0)) + 4|0); //@line 117693 "c/sqlite3.c"
 $42 = (_sqlite3_prepare_v2($40,$38,-1,$41,0)|0); //@line 117693 "c/sqlite3.c"
 _sqlite3_free($38); //@line 117694 "c/sqlite3.c"
 $43 = ($42|0)==(0); //@line 117695 "c/sqlite3.c"
 if ($43) {
  $48 = (_pragmaVtabNext($0)|0); //@line 117699 "c/sqlite3.c"
  $$2 = $48;
  STACKTOP = sp;return ($$2|0); //@line 117700 "c/sqlite3.c"
 } else {
  $44 = HEAP32[$26>>2]|0; //@line 117696 "c/sqlite3.c"
  $45 = (_sqlite3_errmsg($44)|0); //@line 117696 "c/sqlite3.c"
  HEAP32[$vararg_buffer7>>2] = $45; //@line 117696 "c/sqlite3.c"
  $46 = (_sqlite3_mprintf(15687,$vararg_buffer7)|0); //@line 117696 "c/sqlite3.c"
  $47 = ((($6)) + 8|0); //@line 117696 "c/sqlite3.c"
  HEAP32[$47>>2] = $46; //@line 117696 "c/sqlite3.c"
  $$2 = $42;
  STACKTOP = sp;return ($$2|0); //@line 117700 "c/sqlite3.c"
 }
 return (0)|0;
}
function _pragmaVtabNext($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 117642 "c/sqlite3.c"
 $2 = $1; //@line 117642 "c/sqlite3.c"
 $3 = $2; //@line 117642 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 117642 "c/sqlite3.c"
 $5 = (($2) + 4)|0; //@line 117642 "c/sqlite3.c"
 $6 = $5; //@line 117642 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 117642 "c/sqlite3.c"
 $8 = (_i64Add(($4|0),($7|0),1,0)|0); //@line 117642 "c/sqlite3.c"
 $9 = tempRet0; //@line 117642 "c/sqlite3.c"
 $10 = $1; //@line 117642 "c/sqlite3.c"
 $11 = $10; //@line 117642 "c/sqlite3.c"
 HEAP32[$11>>2] = $8; //@line 117642 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 117642 "c/sqlite3.c"
 $13 = $12; //@line 117642 "c/sqlite3.c"
 HEAP32[$13>>2] = $9; //@line 117642 "c/sqlite3.c"
 $14 = ((($0)) + 4|0); //@line 117644 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 117644 "c/sqlite3.c"
 $16 = (_sqlite3_step($15)|0); //@line 117644 "c/sqlite3.c"
 $17 = ($16|0)==(100); //@line 117644 "c/sqlite3.c"
 if ($17) {
  $$0 = 0;
  return ($$0|0); //@line 117649 "c/sqlite3.c"
 }
 $18 = HEAP32[$14>>2]|0; //@line 117645 "c/sqlite3.c"
 $19 = (_sqlite3_finalize($18)|0); //@line 117645 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 117646 "c/sqlite3.c"
 _pragmaVtabCursorClear($0); //@line 117647 "c/sqlite3.c"
 $$0 = $19;
 return ($$0|0); //@line 117649 "c/sqlite3.c"
}
function _pragmaVtabEof($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 117707 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 117707 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 117707 "c/sqlite3.c"
 $4 = $3&1; //@line 117707 "c/sqlite3.c"
 return ($4|0); //@line 117707 "c/sqlite3.c"
}
function _pragmaVtabColumn($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 117719 "c/sqlite3.c"
 $4 = ((($3)) + 21|0); //@line 117720 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 117720 "c/sqlite3.c"
 $6 = $5&255; //@line 117720 "c/sqlite3.c"
 $7 = ($6|0)>($2|0); //@line 117720 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 4|0); //@line 117721 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 117721 "c/sqlite3.c"
  $10 = (_sqlite3_column_value($9,$2)|0); //@line 117721 "c/sqlite3.c"
  _sqlite3_result_value($1,$10); //@line 117721 "c/sqlite3.c"
  return 0; //@line 117725 "c/sqlite3.c"
 } else {
  $11 = ((($0)) + 16|0); //@line 117723 "c/sqlite3.c"
  $12 = (($2) - ($6))|0; //@line 117723 "c/sqlite3.c"
  $13 = (($11) + ($12<<2)|0); //@line 117723 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 117723 "c/sqlite3.c"
  _sqlite3_result_text($1,$14,-1,(-1)); //@line 117723 "c/sqlite3.c"
  return 0; //@line 117725 "c/sqlite3.c"
 }
 return (0)|0;
}
function _pragmaVtabRowid($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 117733 "c/sqlite3.c"
 $3 = $2; //@line 117733 "c/sqlite3.c"
 $4 = $3; //@line 117733 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 117733 "c/sqlite3.c"
 $6 = (($3) + 4)|0; //@line 117733 "c/sqlite3.c"
 $7 = $6; //@line 117733 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 117733 "c/sqlite3.c"
 $9 = $1; //@line 117733 "c/sqlite3.c"
 $10 = $9; //@line 117733 "c/sqlite3.c"
 HEAP32[$10>>2] = $5; //@line 117733 "c/sqlite3.c"
 $11 = (($9) + 4)|0; //@line 117733 "c/sqlite3.c"
 $12 = $11; //@line 117733 "c/sqlite3.c"
 HEAP32[$12>>2] = $8; //@line 117733 "c/sqlite3.c"
 return 0; //@line 117734 "c/sqlite3.c"
}
function _pragmaVtabCursorClear($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 117620 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 117620 "c/sqlite3.c"
 (_sqlite3_finalize($2)|0); //@line 117620 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 117621 "c/sqlite3.c"
 $3 = ((($0)) + 16|0); //@line 117623 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 117623 "c/sqlite3.c"
 _sqlite3_free($4); //@line 117623 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 117624 "c/sqlite3.c"
 $5 = ((($0)) + 20|0); //@line 117623 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 117623 "c/sqlite3.c"
 _sqlite3_free($6); //@line 117623 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 117624 "c/sqlite3.c"
 return; //@line 117626 "c/sqlite3.c"
}
function _sqlite3Init($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$02527 = 0, $$02527$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 118147 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 118147 "c/sqlite3.c"
 $4 = $3 & 1; //@line 118147 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 118147 "c/sqlite3.c"
 $6 = ((($0)) + 16|0); //@line 118152 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 118152 "c/sqlite3.c"
 $8 = ((($7)) + 12|0); //@line 118152 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 118152 "c/sqlite3.c"
 $10 = ((($9)) + 77|0); //@line 118152 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 118152 "c/sqlite3.c"
 $12 = ((($0)) + 70|0); //@line 118152 "c/sqlite3.c"
 HEAP8[$12>>0] = $11; //@line 118152 "c/sqlite3.c"
 $13 = ((($9)) + 78|0); //@line 118155 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 118155 "c/sqlite3.c"
 $15 = $14 & 1; //@line 118155 "c/sqlite3.c"
 $16 = ($15<<16>>16)==(0); //@line 118155 "c/sqlite3.c"
 if ($16) {
  $17 = (_sqlite3InitOne($0,0,$1)|0); //@line 118156 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 118157 "c/sqlite3.c"
  if (!($18)) {
   $$0 = $17;
   return ($$0|0); //@line 118170 "c/sqlite3.c"
  }
 }
 $19 = ((($0)) + 20|0); //@line 118160 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 118160 "c/sqlite3.c"
 $21 = ($20|0)>(1); //@line 118160 "c/sqlite3.c"
 L5: do {
  if ($21) {
   $$02527$in = $20;
   while(1) {
    $$02527 = (($$02527$in) + -1)|0;
    $22 = HEAP32[$6>>2]|0; //@line 118161 "c/sqlite3.c"
    $23 = (((($22) + ($$02527<<4)|0)) + 12|0); //@line 118161 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 118161 "c/sqlite3.c"
    $25 = ((($24)) + 78|0); //@line 118161 "c/sqlite3.c"
    $26 = HEAP16[$25>>1]|0; //@line 118161 "c/sqlite3.c"
    $27 = $26 & 1; //@line 118161 "c/sqlite3.c"
    $28 = ($27<<16>>16)==(0); //@line 118161 "c/sqlite3.c"
    if ($28) {
     $29 = (_sqlite3InitOne($0,$$02527,$1)|0); //@line 118162 "c/sqlite3.c"
     $30 = ($29|0)==(0); //@line 118163 "c/sqlite3.c"
     if (!($30)) {
      $$0 = $29;
      break;
     }
    }
    $31 = ($$02527$in|0)>(2); //@line 118160 "c/sqlite3.c"
    if ($31) {
     $$02527$in = $$02527;
    } else {
     break L5;
    }
   }
   return ($$0|0); //@line 118170 "c/sqlite3.c"
  }
 } while(0);
 if (!($5)) {
  $$0 = 0;
  return ($$0|0); //@line 118170 "c/sqlite3.c"
 }
 _sqlite3CommitInternalChanges($0); //@line 118167 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 118170 "c/sqlite3.c"
}
function _sqlite3InitOne($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$097 = 0, $$1102 = 0, $$2 = 0, $$2104 = 0, $$3 = 0, $$3106 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond100 = 0, $spec$select = 0, $spec$store$select = 0, $spec$store$select1 = 0;
 var $switch$split2D = 0, $switch$split42D = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer = sp;
 $3 = sp + 48|0;
 $4 = sp + 24|0;
 $5 = sp + 8|0;
 $6 = ((($0)) + 157|0); //@line 117937 "c/sqlite3.c"
 HEAP8[$6>>0] = 1; //@line 117937 "c/sqlite3.c"
 $7 = ($1|0)==(1); //@line 117944 "c/sqlite3.c"
 $8 = $7 ? 21366 : 19754; //@line 117944 "c/sqlite3.c"
 HEAP32[$3>>2] = $8; //@line 117944 "c/sqlite3.c"
 $9 = ((($3)) + 4|0); //@line 117945 "c/sqlite3.c"
 HEAP32[$9>>2] = 21385; //@line 117945 "c/sqlite3.c"
 $10 = ((($3)) + 8|0); //@line 117946 "c/sqlite3.c"
 HEAP32[$10>>2] = 21387; //@line 117946 "c/sqlite3.c"
 $11 = ((($3)) + 12|0); //@line 117948 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 117948 "c/sqlite3.c"
 HEAP32[$5>>2] = $0; //@line 117949 "c/sqlite3.c"
 $12 = ((($5)) + 8|0); //@line 117950 "c/sqlite3.c"
 HEAP32[$12>>2] = $1; //@line 117950 "c/sqlite3.c"
 $13 = ((($5)) + 12|0); //@line 117951 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 117951 "c/sqlite3.c"
 $14 = ((($5)) + 4|0); //@line 117952 "c/sqlite3.c"
 HEAP32[$14>>2] = $2; //@line 117952 "c/sqlite3.c"
 (_sqlite3InitCallback($5,3,$3,0)|0); //@line 117953 "c/sqlite3.c"
 $15 = HEAP32[$13>>2]|0; //@line 117954 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 117954 "c/sqlite3.c"
 if ($16) {
  $17 = ((($0)) + 16|0); //@line 117961 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 117961 "c/sqlite3.c"
  $19 = (((($18) + ($1<<4)|0)) + 4|0); //@line 117962 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 117962 "c/sqlite3.c"
  $21 = ($20|0)==(0|0); //@line 117962 "c/sqlite3.c"
  if ($21) {
   $22 = ((($18)) + 28|0); //@line 117964 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 117964 "c/sqlite3.c"
   $24 = ((($23)) + 78|0); //@line 117964 "c/sqlite3.c"
   $25 = HEAP16[$24>>1]|0; //@line 117964 "c/sqlite3.c"
   $26 = $25 | 1; //@line 117964 "c/sqlite3.c"
   HEAP16[$24>>1] = $26; //@line 117964 "c/sqlite3.c"
   $$3106 = 0;
   HEAP8[$6>>0] = 0; //@line 118131 "c/sqlite3.c"
   STACKTOP = sp;return ($$3106|0); //@line 118132 "c/sqlite3.c"
  }
  _sqlite3BtreeEnter($20); //@line 117972 "c/sqlite3.c"
  $27 = HEAP32[$19>>2]|0; //@line 117973 "c/sqlite3.c"
  $28 = (_sqlite3BtreeIsInReadTrans($27)|0); //@line 117973 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 117973 "c/sqlite3.c"
  if ($29) {
   $30 = (_sqlite3BtreeBeginTrans($27,0)|0); //@line 117974 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 117975 "c/sqlite3.c"
   if ($31) {
    $$097 = 1;
    label = 7;
   } else {
    $32 = (_sqlite3ErrStr($30)|0); //@line 117976 "c/sqlite3.c"
    _sqlite3SetString($2,$0,$32); //@line 117976 "c/sqlite3.c"
    $$2104 = $30;
   }
  } else {
   $$097 = 0;
   label = 7;
  }
  if ((label|0) == 7) {
   $33 = HEAP32[$19>>2]|0; //@line 118000 "c/sqlite3.c"
   _sqlite3BtreeGetMeta($33,1,$4); //@line 118000 "c/sqlite3.c"
   $34 = HEAP32[$19>>2]|0; //@line 118000 "c/sqlite3.c"
   $35 = ((($4)) + 4|0); //@line 118000 "c/sqlite3.c"
   _sqlite3BtreeGetMeta($34,2,$35); //@line 118000 "c/sqlite3.c"
   $36 = HEAP32[$19>>2]|0; //@line 118000 "c/sqlite3.c"
   $37 = ((($4)) + 8|0); //@line 118000 "c/sqlite3.c"
   _sqlite3BtreeGetMeta($36,3,$37); //@line 118000 "c/sqlite3.c"
   $38 = HEAP32[$19>>2]|0; //@line 118000 "c/sqlite3.c"
   $39 = ((($4)) + 12|0); //@line 118000 "c/sqlite3.c"
   _sqlite3BtreeGetMeta($38,4,$39); //@line 118000 "c/sqlite3.c"
   $40 = HEAP32[$19>>2]|0; //@line 118000 "c/sqlite3.c"
   $41 = ((($4)) + 16|0); //@line 118000 "c/sqlite3.c"
   _sqlite3BtreeGetMeta($40,5,$41); //@line 118000 "c/sqlite3.c"
   $42 = HEAP32[$4>>2]|0; //@line 118002 "c/sqlite3.c"
   $43 = (((($18) + ($1<<4)|0)) + 12|0); //@line 118002 "c/sqlite3.c"
   $44 = HEAP32[$43>>2]|0; //@line 118002 "c/sqlite3.c"
   HEAP32[$44>>2] = $42; //@line 118002 "c/sqlite3.c"
   $45 = ((($4)) + 16|0); //@line 118009 "c/sqlite3.c"
   $46 = HEAP32[$45>>2]|0; //@line 118009 "c/sqlite3.c"
   $47 = ($46|0)==(0); //@line 118009 "c/sqlite3.c"
   do {
    if ($47) {
     $57 = HEAP32[$17>>2]|0; //@line 118030 "c/sqlite3.c"
     $58 = (((($57) + ($1<<4)|0)) + 12|0); //@line 118030 "c/sqlite3.c"
     $59 = HEAP32[$58>>2]|0; //@line 118030 "c/sqlite3.c"
     $60 = ((($59)) + 78|0); //@line 118030 "c/sqlite3.c"
     $61 = HEAP16[$60>>1]|0; //@line 118030 "c/sqlite3.c"
     $62 = $61 | 4; //@line 118030 "c/sqlite3.c"
     HEAP16[$60>>1] = $62; //@line 118030 "c/sqlite3.c"
     label = 13;
    } else {
     $48 = ($1|0)==(0); //@line 118010 "c/sqlite3.c"
     if ($48) {
      $49 = $46 & 3; //@line 118014 "c/sqlite3.c"
      $50 = $49&255; //@line 118014 "c/sqlite3.c"
      $51 = ($49|0)==(0); //@line 118015 "c/sqlite3.c"
      $spec$store$select = $51 ? 1 : $50; //@line 118015 "c/sqlite3.c"
      $52 = ((($0)) + 70|0); //@line 118016 "c/sqlite3.c"
      HEAP8[$52>>0] = $spec$store$select; //@line 118016 "c/sqlite3.c"
      label = 13;
      break;
     }
     $53 = ((($0)) + 70|0); //@line 118022 "c/sqlite3.c"
     $54 = HEAP8[$53>>0]|0; //@line 118022 "c/sqlite3.c"
     $55 = $54&255; //@line 118022 "c/sqlite3.c"
     $56 = ($46|0)==($55|0); //@line 118022 "c/sqlite3.c"
     if ($56) {
      label = 13;
     } else {
      _sqlite3SetString($2,$0,21459); //@line 118023 "c/sqlite3.c"
      $$2 = 1;
     }
    }
   } while(0);
   do {
    if ((label|0) == 13) {
     $63 = ((($0)) + 70|0); //@line 118032 "c/sqlite3.c"
     $64 = HEAP8[$63>>0]|0; //@line 118032 "c/sqlite3.c"
     $65 = ((($44)) + 77|0); //@line 118032 "c/sqlite3.c"
     HEAP8[$65>>0] = $64; //@line 118032 "c/sqlite3.c"
     $66 = ((($44)) + 80|0); //@line 118034 "c/sqlite3.c"
     $67 = HEAP32[$66>>2]|0; //@line 118034 "c/sqlite3.c"
     $68 = ($67|0)==(0); //@line 118034 "c/sqlite3.c"
     if ($68) {
      $69 = ((($4)) + 8|0); //@line 118036 "c/sqlite3.c"
      $70 = HEAP32[$69>>2]|0; //@line 118036 "c/sqlite3.c"
      $71 = (_sqlite3AbsInt32($70)|0); //@line 118036 "c/sqlite3.c"
      $72 = ($71|0)==(0); //@line 118037 "c/sqlite3.c"
      $spec$store$select1 = $72 ? -2000 : $71; //@line 118037 "c/sqlite3.c"
      HEAP32[$66>>2] = $spec$store$select1; //@line 118038 "c/sqlite3.c"
      $73 = HEAP32[$19>>2]|0; //@line 118042 "c/sqlite3.c"
      _sqlite3BtreeSetCacheSize($73,$spec$store$select1); //@line 118042 "c/sqlite3.c"
     }
     $74 = ((($4)) + 4|0); //@line 118051 "c/sqlite3.c"
     $75 = HEAP32[$74>>2]|0; //@line 118051 "c/sqlite3.c"
     $76 = $75&255; //@line 118051 "c/sqlite3.c"
     $77 = HEAP32[$43>>2]|0; //@line 118051 "c/sqlite3.c"
     $78 = ((($77)) + 76|0); //@line 118051 "c/sqlite3.c"
     HEAP8[$78>>0] = $76; //@line 118051 "c/sqlite3.c"
     $79 = ($76<<24>>24)==(0); //@line 118052 "c/sqlite3.c"
     if ($79) {
      HEAP8[$78>>0] = 1; //@line 118053 "c/sqlite3.c"
     } else {
      $80 = ($76&255)>(4); //@line 118055 "c/sqlite3.c"
      if ($80) {
       _sqlite3SetString($2,$0,21527); //@line 118056 "c/sqlite3.c"
       $$2 = 1;
       break;
      }
     }
     $81 = ($1|0)==(0); //@line 118066 "c/sqlite3.c"
     $82 = ($75|0)>(3); //@line 118066 "c/sqlite3.c"
     $or$cond100 = $81 & $82; //@line 118066 "c/sqlite3.c"
     if ($or$cond100) {
      $83 = ((($0)) + 28|0); //@line 118067 "c/sqlite3.c"
      $84 = HEAP32[$83>>2]|0; //@line 118067 "c/sqlite3.c"
      $85 = $84 & -3; //@line 118067 "c/sqlite3.c"
      HEAP32[$83>>2] = $85; //@line 118067 "c/sqlite3.c"
     }
     $86 = HEAP32[$17>>2]|0; //@line 118077 "c/sqlite3.c"
     $87 = (($86) + ($1<<4)|0); //@line 118077 "c/sqlite3.c"
     $88 = HEAP32[$87>>2]|0; //@line 118077 "c/sqlite3.c"
     HEAP32[$vararg_buffer>>2] = $88; //@line 118075 "c/sqlite3.c"
     $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 118075 "c/sqlite3.c"
     HEAP32[$vararg_ptr1>>2] = $8; //@line 118075 "c/sqlite3.c"
     $89 = (_sqlite3MPrintf($0,21551,$vararg_buffer)|0); //@line 118075 "c/sqlite3.c"
     $90 = ((($0)) + 304|0); //@line 118081 "c/sqlite3.c"
     $91 = HEAP32[$90>>2]|0; //@line 118081 "c/sqlite3.c"
     HEAP32[$90>>2] = 0; //@line 118082 "c/sqlite3.c"
     $92 = (_sqlite3_exec($0,$89,90,$5,0)|0); //@line 118084 "c/sqlite3.c"
     HEAP32[$90>>2] = $91; //@line 118086 "c/sqlite3.c"
     $93 = ($92|0)==(0); //@line 118089 "c/sqlite3.c"
     $94 = HEAP32[$13>>2]|0; //@line 118089 "c/sqlite3.c"
     $spec$select = $93 ? $94 : $92; //@line 118089 "c/sqlite3.c"
     _sqlite3DbFree($0,$89); //@line 118090 "c/sqlite3.c"
     $95 = ($spec$select|0)==(0); //@line 118092 "c/sqlite3.c"
     if ($95) {
      (_sqlite3AnalysisLoad($0,$1)|0); //@line 118093 "c/sqlite3.c"
     }
     $96 = ((($0)) + 73|0); //@line 118097 "c/sqlite3.c"
     $97 = HEAP8[$96>>0]|0; //@line 118097 "c/sqlite3.c"
     $98 = ($97<<24>>24)==(0); //@line 118097 "c/sqlite3.c"
     if ($98) {
      $99 = ($spec$select|0)==(0); //@line 118101 "c/sqlite3.c"
      if (!($99)) {
       $$1102 = $spec$select;
       label = 26;
      }
     } else {
      _sqlite3ResetAllSchemasOfConnection($0); //@line 118099 "c/sqlite3.c"
      $$1102 = 7;
      label = 26;
     }
     if ((label|0) == 26) {
      $100 = ((($0)) + 28|0); //@line 118101 "c/sqlite3.c"
      $101 = HEAP32[$100>>2]|0; //@line 118101 "c/sqlite3.c"
      $102 = $101 & 1; //@line 118101 "c/sqlite3.c"
      $103 = ($102|0)==(0); //@line 118101 "c/sqlite3.c"
      if ($103) {
       $$2 = $$1102;
       break;
      }
     }
     $104 = HEAP32[$17>>2]|0; //@line 118110 "c/sqlite3.c"
     $105 = (((($104) + ($1<<4)|0)) + 12|0); //@line 118110 "c/sqlite3.c"
     $106 = HEAP32[$105>>2]|0; //@line 118110 "c/sqlite3.c"
     $107 = ((($106)) + 78|0); //@line 118110 "c/sqlite3.c"
     $108 = HEAP16[$107>>1]|0; //@line 118110 "c/sqlite3.c"
     $109 = $108 | 1; //@line 118110 "c/sqlite3.c"
     HEAP16[$107>>1] = $109; //@line 118110 "c/sqlite3.c"
     $$2 = 0;
    }
   } while(0);
   $110 = ($$097|0)==(0); //@line 118119 "c/sqlite3.c"
   if ($110) {
    $$2104 = $$2;
   } else {
    $111 = HEAP32[$19>>2]|0; //@line 118120 "c/sqlite3.c"
    (_sqlite3BtreeCommit($111)|0); //@line 118120 "c/sqlite3.c"
    $$2104 = $$2;
   }
  }
  $112 = HEAP32[$19>>2]|0; //@line 118122 "c/sqlite3.c"
  _sqlite3BtreeLeave($112); //@line 118122 "c/sqlite3.c"
  $$3 = $$2104;
 } else {
  $$3 = $15;
 }
 $switch$split2D = ($$3|0)<(7);
 L45: do {
  if ($switch$split2D) {
   switch ($$3|0) {
   case 0:  {
    $$3106 = $$3;
    break;
   }
   default: {
    break L45;
   }
   }
   HEAP8[$6>>0] = 0; //@line 118131 "c/sqlite3.c"
   STACKTOP = sp;return ($$3106|0); //@line 118132 "c/sqlite3.c"
  } else {
   $switch$split42D = ($$3|0)<(3082);
   if ($switch$split42D) {
    switch ($$3|0) {
    case 7:  {
     break;
    }
    default: {
     break L45;
    }
    }
   } else {
    switch ($$3|0) {
    case 3082:  {
     break;
    }
    default: {
     break L45;
    }
    }
   }
   _sqlite3OomFault($0); //@line 118127 "c/sqlite3.c"
  }
 } while(0);
 _sqlite3ResetOneSchema($0,$1); //@line 118129 "c/sqlite3.c"
 $$3106 = $$3;
 HEAP8[$6>>0] = 0; //@line 118131 "c/sqlite3.c"
 STACKTOP = sp;return ($$3106|0); //@line 118132 "c/sqlite3.c"
}
function _sqlite3InitCallback($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = HEAP32[$0>>2]|0; //@line 117837 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 117838 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 117838 "c/sqlite3.c"
 $8 = ((($5)) + 16|0); //@line 117843 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 117843 "c/sqlite3.c"
 $10 = (((($9) + ($7<<4)|0)) + 12|0); //@line 117843 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 117843 "c/sqlite3.c"
 $12 = ((($11)) + 78|0); //@line 117843 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 117843 "c/sqlite3.c"
 $14 = $13 & -5; //@line 117843 "c/sqlite3.c"
 HEAP16[$12>>1] = $14; //@line 117843 "c/sqlite3.c"
 $15 = ((($5)) + 73|0); //@line 117844 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 117844 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 117844 "c/sqlite3.c"
 if (!($17)) {
  $18 = HEAP32[$2>>2]|0; //@line 117845 "c/sqlite3.c"
  _corruptSchema($0,$18,0); //@line 117845 "c/sqlite3.c"
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
 }
 $19 = ($2|0)==(0|0); //@line 117850 "c/sqlite3.c"
 if ($19) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
 }
 $20 = ((($2)) + 4|0); //@line 117851 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 117851 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 117851 "c/sqlite3.c"
 if ($22) {
  $23 = HEAP32[$2>>2]|0; //@line 117852 "c/sqlite3.c"
  _corruptSchema($0,$23,0); //@line 117852 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
 }
 $24 = ((($2)) + 8|0); //@line 117853 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 117853 "c/sqlite3.c"
 $26 = (_sqlite3_strnicmp($25,21693,7)|0); //@line 117853 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 117853 "c/sqlite3.c"
 if ($27) {
  $28 = ((($5)) + 156|0); //@line 117860 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 117860 "c/sqlite3.c"
  $30 = $7&255; //@line 117865 "c/sqlite3.c"
  HEAP8[$28>>0] = $30; //@line 117865 "c/sqlite3.c"
  $31 = (_sqlite3Atoi($21)|0); //@line 117866 "c/sqlite3.c"
  $32 = ((($5)) + 152|0); //@line 117866 "c/sqlite3.c"
  HEAP32[$32>>2] = $31; //@line 117866 "c/sqlite3.c"
  $33 = ((($5)) + 158|0); //@line 117867 "c/sqlite3.c"
  HEAP8[$33>>0] = 0; //@line 117867 "c/sqlite3.c"
  $34 = HEAP32[$24>>2]|0; //@line 117868 "c/sqlite3.c"
  (_sqlite3_prepare($5,$34,-1,$4,0)|0); //@line 117868 "c/sqlite3.c"
  $35 = ((($5)) + 56|0); //@line 117869 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 117869 "c/sqlite3.c"
  HEAP8[$28>>0] = $29; //@line 117871 "c/sqlite3.c"
  $37 = ($36|0)==(0); //@line 117873 "c/sqlite3.c"
  L14: do {
   if (!($37)) {
    $38 = HEAP8[$33>>0]|0; //@line 117874 "c/sqlite3.c"
    $39 = ($38<<24>>24)==(0); //@line 117874 "c/sqlite3.c"
    if ($39) {
     $40 = ((($0)) + 12|0); //@line 117877 "c/sqlite3.c"
     HEAP32[$40>>2] = $36; //@line 117877 "c/sqlite3.c"
     switch ($36|0) {
     case 9:  {
      break L14;
      break;
     }
     case 7:  {
      _sqlite3OomFault($5); //@line 117879 "c/sqlite3.c"
      break L14;
      break;
     }
     default: {
     }
     }
     $41 = $36 & 255; //@line 117880 "c/sqlite3.c"
     $42 = ($41|0)==(6); //@line 117880 "c/sqlite3.c"
     if (!($42)) {
      $43 = HEAP32[$2>>2]|0; //@line 117881 "c/sqlite3.c"
      $44 = (_sqlite3_errmsg($5)|0); //@line 117881 "c/sqlite3.c"
      _corruptSchema($0,$43,$44); //@line 117881 "c/sqlite3.c"
     }
    }
   }
  } while(0);
  $45 = HEAP32[$4>>2]|0; //@line 117885 "c/sqlite3.c"
  (_sqlite3_finalize($45)|0); //@line 117885 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
 }
 $46 = HEAP32[$2>>2]|0; //@line 117886 "c/sqlite3.c"
 $47 = ($46|0)==(0|0); //@line 117886 "c/sqlite3.c"
 do {
  if (!($47)) {
   $48 = ($25|0)==(0|0); //@line 117886 "c/sqlite3.c"
   if (!($48)) {
    $49 = HEAP8[$25>>0]|0; //@line 117886 "c/sqlite3.c"
    $50 = ($49<<24>>24)==(0); //@line 117886 "c/sqlite3.c"
    if (!($50)) {
     break;
    }
   }
   $51 = (($9) + ($7<<4)|0); //@line 117896 "c/sqlite3.c"
   $52 = HEAP32[$51>>2]|0; //@line 117896 "c/sqlite3.c"
   $53 = (_sqlite3FindIndex($5,$46,$52)|0); //@line 117896 "c/sqlite3.c"
   $54 = ($53|0)==(0|0); //@line 117897 "c/sqlite3.c"
   if ($54) {
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
   }
   $55 = HEAP32[$20>>2]|0; //@line 117904 "c/sqlite3.c"
   $56 = ((($53)) + 44|0); //@line 117904 "c/sqlite3.c"
   $57 = (_sqlite3GetInt32($55,$56)|0); //@line 117904 "c/sqlite3.c"
   $58 = ($57|0)==(0); //@line 117904 "c/sqlite3.c"
   if (!($58)) {
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
   }
   $59 = HEAP32[$2>>2]|0; //@line 117905 "c/sqlite3.c"
   _corruptSchema($0,$59,21701); //@line 117905 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
  }
 } while(0);
 _corruptSchema($0,$46,0); //@line 117887 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 117909 "c/sqlite3.c"
}
function _sqlite3SetString($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 25787 "c/sqlite3.c"
 _sqlite3DbFree($1,$3); //@line 25787 "c/sqlite3.c"
 $4 = (_sqlite3DbStrDup($1,$2)|0); //@line 25788 "c/sqlite3.c"
 HEAP32[$0>>2] = $4; //@line 25788 "c/sqlite3.c"
 return; //@line 25789 "c/sqlite3.c"
}
function _sqlite3BtreeSetCacheSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 63097 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63097 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63099 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63100 "c/sqlite3.c"
 _sqlite3PagerSetCachesize($4,$1); //@line 63100 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63101 "c/sqlite3.c"
 return;
}
function _sqlite3AnalysisLoad($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$043 = 0, $$051 = 0, $$052 = 0, $$1 = 0, $$146 = 0, $$147 = 0, $$2 = 0, $$244 = 0, $$245 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = sp + 8|0;
 $3 = ((($0)) + 16|0); //@line 100704 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 100704 "c/sqlite3.c"
 $5 = (((($4) + ($1<<4)|0)) + 12|0); //@line 100704 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 100704 "c/sqlite3.c"
 $7 = ((($6)) + 16|0); //@line 100711 "c/sqlite3.c"
 $$051 = HEAP32[$7>>2]|0;
 $8 = ($$051|0)==(0|0); //@line 100711 "c/sqlite3.c"
 if (!($8)) {
  $$052 = $$051;
  while(1) {
   $9 = ((($$052)) + 8|0); //@line 100712 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 100712 "c/sqlite3.c"
   $11 = ((($10)) + 36|0); //@line 100713 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 100713 "c/sqlite3.c"
   $13 = $12 & -17; //@line 100713 "c/sqlite3.c"
   HEAP32[$11>>2] = $13; //@line 100713 "c/sqlite3.c"
   $$0 = HEAP32[$$052>>2]|0;
   $14 = ($$0|0)==(0|0); //@line 100711 "c/sqlite3.c"
   if ($14) {
    break;
   } else {
    $$052 = $$0;
   }
  }
 }
 $15 = ((($6)) + 32|0); //@line 100715 "c/sqlite3.c"
 $$146 = HEAP32[$15>>2]|0;
 $16 = ($$146|0)==(0|0); //@line 100715 "c/sqlite3.c"
 if (!($16)) {
  $$147 = $$146;
  while(1) {
   $17 = ((($$147)) + 8|0); //@line 100716 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 100716 "c/sqlite3.c"
   $19 = ((($18)) + 55|0); //@line 100717 "c/sqlite3.c"
   $20 = HEAPU8[$19>>0]|(HEAPU8[$19+1>>0]<<8); //@line 100717 "c/sqlite3.c"
   $21 = $20 & -129; //@line 100717 "c/sqlite3.c"
   HEAP8[$19>>0]=$21&255;HEAP8[$19+1>>0]=$21>>8; //@line 100717 "c/sqlite3.c"
   $$1 = HEAP32[$$147>>2]|0;
   $22 = ($$1|0)==(0|0); //@line 100715 "c/sqlite3.c"
   if ($22) {
    break;
   } else {
    $$147 = $$1;
   }
  }
 }
 HEAP32[$2>>2] = $0; //@line 100725 "c/sqlite3.c"
 $23 = HEAP32[$3>>2]|0; //@line 100726 "c/sqlite3.c"
 $24 = (($23) + ($1<<4)|0); //@line 100726 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 100726 "c/sqlite3.c"
 $26 = ((($2)) + 4|0); //@line 100726 "c/sqlite3.c"
 HEAP32[$26>>2] = $25; //@line 100726 "c/sqlite3.c"
 $27 = (_sqlite3FindTable($0,21606,$25)|0); //@line 100727 "c/sqlite3.c"
 $28 = ($27|0)==(0|0); //@line 100727 "c/sqlite3.c"
 if ($28) {
  $$043 = 0;
 } else {
  $29 = HEAP32[$26>>2]|0; //@line 100729 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $29; //@line 100728 "c/sqlite3.c"
  $30 = (_sqlite3MPrintf($0,21619,$vararg_buffer)|0); //@line 100728 "c/sqlite3.c"
  $31 = ($30|0)==(0|0); //@line 100730 "c/sqlite3.c"
  if ($31) {
   $$043 = 7;
  } else {
   $32 = (_sqlite3_exec($0,$30,91,$2,0)|0); //@line 100733 "c/sqlite3.c"
   _sqlite3DbFree($0,$30); //@line 100734 "c/sqlite3.c"
   $$043 = $32;
  }
 }
 $$244 = HEAP32[$15>>2]|0;
 $33 = ($$244|0)==(0|0); //@line 100740 "c/sqlite3.c"
 if (!($33)) {
  $$245 = $$244;
  while(1) {
   $34 = ((($$245)) + 8|0); //@line 100741 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 100741 "c/sqlite3.c"
   $36 = ((($35)) + 55|0); //@line 100742 "c/sqlite3.c"
   $37 = HEAPU8[$36>>0]|(HEAPU8[$36+1>>0]<<8); //@line 100742 "c/sqlite3.c"
   $38 = $37 & 128; //@line 100742 "c/sqlite3.c"
   $39 = ($38<<16>>16)==(0); //@line 100742 "c/sqlite3.c"
   if ($39) {
    _sqlite3DefaultRowEst($35); //@line 100742 "c/sqlite3.c"
   }
   $$2 = HEAP32[$$245>>2]|0;
   $40 = ($$2|0)==(0|0); //@line 100740 "c/sqlite3.c"
   if ($40) {
    break;
   } else {
    $$245 = $$2;
   }
  }
 }
 $41 = ($$043|0)==(7); //@line 100759 "c/sqlite3.c"
 if (!($41)) {
  STACKTOP = sp;return ($$043|0); //@line 100762 "c/sqlite3.c"
 }
 _sqlite3OomFault($0); //@line 100760 "c/sqlite3.c"
 STACKTOP = sp;return ($$043|0); //@line 100762 "c/sqlite3.c"
}
function _analysisLoader($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$047 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $4 = sp;
 $5 = ($2|0)==(0|0); //@line 100365 "c/sqlite3.c"
 if ($5) {
  STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
 }
 $6 = HEAP32[$2>>2]|0; //@line 100365 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 100365 "c/sqlite3.c"
 if ($7) {
  STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
 }
 $8 = ((($2)) + 8|0); //@line 100365 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 100365 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 100365 "c/sqlite3.c"
 if ($10) {
  STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
 }
 $11 = HEAP32[$0>>2]|0; //@line 100368 "c/sqlite3.c"
 $12 = ((($0)) + 4|0); //@line 100368 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 100368 "c/sqlite3.c"
 $14 = (_sqlite3FindTable($11,$6,$13)|0); //@line 100368 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 100369 "c/sqlite3.c"
 if ($15) {
  STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
 }
 $16 = ((($2)) + 4|0); //@line 100372 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 100372 "c/sqlite3.c"
 $18 = ($17|0)==(0|0); //@line 100372 "c/sqlite3.c"
 if ($18) {
  $19 = HEAP32[$8>>2]|0; //@line 100379 "c/sqlite3.c"
  $53 = $19;
 } else {
  $20 = HEAP32[$2>>2]|0; //@line 100374 "c/sqlite3.c"
  $21 = (_sqlite3_stricmp($20,$17)|0); //@line 100374 "c/sqlite3.c"
  $22 = ($21|0)==(0); //@line 100374 "c/sqlite3.c"
  if ($22) {
   $23 = (_sqlite3PrimaryKeyIndex($14)|0); //@line 100375 "c/sqlite3.c"
   $$047 = $23;
  } else {
   $24 = HEAP32[$0>>2]|0; //@line 100377 "c/sqlite3.c"
   $25 = HEAP32[$12>>2]|0; //@line 100377 "c/sqlite3.c"
   $26 = (_sqlite3FindIndex($24,$17,$25)|0); //@line 100377 "c/sqlite3.c"
   $$047 = $26;
  }
  $27 = HEAP32[$8>>2]|0; //@line 100379 "c/sqlite3.c"
  $28 = ($$047|0)==(0|0); //@line 100381 "c/sqlite3.c"
  if ($28) {
   $53 = $27;
  } else {
   $29 = ((($$047)) + 50|0); //@line 100383 "c/sqlite3.c"
   $30 = HEAP16[$29>>1]|0; //@line 100383 "c/sqlite3.c"
   $31 = $30&65535; //@line 100383 "c/sqlite3.c"
   $32 = (($31) + 1)|0; //@line 100383 "c/sqlite3.c"
   $33 = ((($$047)) + 55|0); //@line 100394 "c/sqlite3.c"
   $34 = HEAPU8[$33>>0]|(HEAPU8[$33+1>>0]<<8); //@line 100394 "c/sqlite3.c"
   $35 = $34 & -5; //@line 100394 "c/sqlite3.c"
   HEAP8[$33>>0]=$35&255;HEAP8[$33+1>>0]=$35>>8; //@line 100394 "c/sqlite3.c"
   $36 = ((($$047)) + 8|0); //@line 100395 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 100395 "c/sqlite3.c"
   _decodeIntArray($27,$32,$37,$$047); //@line 100395 "c/sqlite3.c"
   $38 = HEAPU8[$33>>0]|(HEAPU8[$33+1>>0]<<8); //@line 100396 "c/sqlite3.c"
   $39 = $38 | 128; //@line 100396 "c/sqlite3.c"
   HEAP8[$33>>0]=$39&255;HEAP8[$33+1>>0]=$39>>8; //@line 100396 "c/sqlite3.c"
   $40 = ((($$047)) + 36|0); //@line 100397 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 100397 "c/sqlite3.c"
   $42 = ($41|0)==(0|0); //@line 100397 "c/sqlite3.c"
   if (!($42)) {
    STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
   }
   $43 = HEAP32[$36>>2]|0; //@line 100398 "c/sqlite3.c"
   $44 = HEAP16[$43>>1]|0; //@line 100398 "c/sqlite3.c"
   $45 = ((($14)) + 44|0); //@line 100398 "c/sqlite3.c"
   HEAP16[$45>>1] = $44; //@line 100398 "c/sqlite3.c"
   $46 = ((($14)) + 36|0); //@line 100399 "c/sqlite3.c"
   $47 = HEAP32[$46>>2]|0; //@line 100399 "c/sqlite3.c"
   $48 = $47 | 16; //@line 100399 "c/sqlite3.c"
   HEAP32[$46>>2] = $48; //@line 100399 "c/sqlite3.c"
   STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
  }
 }
 $49 = ((($14)) + 46|0); //@line 100403 "c/sqlite3.c"
 $50 = HEAP16[$49>>1]|0; //@line 100403 "c/sqlite3.c"
 $51 = ((($4)) + 48|0); //@line 100403 "c/sqlite3.c"
 HEAP16[$51>>1] = $50; //@line 100403 "c/sqlite3.c"
 $52 = ((($14)) + 44|0); //@line 100407 "c/sqlite3.c"
 _decodeIntArray($53,1,$52,$4); //@line 100407 "c/sqlite3.c"
 $54 = HEAP16[$51>>1]|0; //@line 100408 "c/sqlite3.c"
 HEAP16[$49>>1] = $54; //@line 100408 "c/sqlite3.c"
 $55 = ((($14)) + 36|0); //@line 100409 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 100409 "c/sqlite3.c"
 $57 = $56 | 16; //@line 100409 "c/sqlite3.c"
 HEAP32[$55>>2] = $57; //@line 100409 "c/sqlite3.c"
 STACKTOP = sp;return 0; //@line 100413 "c/sqlite3.c"
}
function _sqlite3DefaultRowEst($0) {
 $0 = $0|0;
 var $$029 = 0, $$029$in = 0, $$lcssa = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select27 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 105077 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 105077 "c/sqlite3.c"
 $3 = ((($0)) + 50|0); //@line 105078 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 105078 "c/sqlite3.c"
 $5 = ($4&65535)<(5); //@line 105078 "c/sqlite3.c"
 $spec$select27 = $5 ? $4 : 5; //@line 105078 "c/sqlite3.c"
 $6 = $spec$select27&65535; //@line 105078 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 105087 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 105087 "c/sqlite3.c"
 $9 = ((($8)) + 44|0); //@line 105087 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 105087 "c/sqlite3.c"
 HEAP16[$2>>1] = $10; //@line 105087 "c/sqlite3.c"
 $11 = ((($0)) + 36|0); //@line 105088 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 105088 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 105088 "c/sqlite3.c"
 if ($13) {
  $$pr = HEAP16[$2>>1]|0; //@line 105089 "c/sqlite3.c"
  $18 = $$pr;
 } else {
  $14 = $10&65535; //@line 105088 "c/sqlite3.c"
  $15 = (($14) + 65526)|0; //@line 105088 "c/sqlite3.c"
  $16 = $15&65535; //@line 105088 "c/sqlite3.c"
  HEAP16[$2>>1] = $16; //@line 105088 "c/sqlite3.c"
  $18 = $16;
 }
 $17 = ($18<<16>>16)<(33); //@line 105089 "c/sqlite3.c"
 if ($17) {
  HEAP16[$2>>1] = 33; //@line 105089 "c/sqlite3.c"
 }
 $19 = ((($2)) + 2|0); //@line 105093 "c/sqlite3.c"
 $20 = ($spec$select27 << 1)&65535; //@line 105093 "c/sqlite3.c"
 $21 = $20&65535; //@line 105093 "c/sqlite3.c"
 _memcpy(($19|0),(11696|0),($21|0))|0; //@line 105093 "c/sqlite3.c"
 $22 = HEAP16[$3>>1]|0; //@line 105094 "c/sqlite3.c"
 $23 = $22&65535; //@line 105094 "c/sqlite3.c"
 $24 = ($spec$select27&65535)<($22&65535); //@line 105094 "c/sqlite3.c"
 if ($24) {
  $$029$in = $6;
  while(1) {
   $$029 = (($$029$in) + 1)|0;
   $25 = (($2) + ($$029<<1)|0); //@line 105095 "c/sqlite3.c"
   HEAP16[$25>>1] = 23; //@line 105095 "c/sqlite3.c"
   $26 = HEAP16[$3>>1]|0; //@line 105094 "c/sqlite3.c"
   $27 = $26&65535; //@line 105094 "c/sqlite3.c"
   $28 = ($$029>>>0)<($27>>>0); //@line 105094 "c/sqlite3.c"
   if ($28) {
    $$029$in = $$029;
   } else {
    break;
   }
  }
  $29 = $26&65535; //@line 105094 "c/sqlite3.c"
  $$lcssa = $29;
 } else {
  $$lcssa = $23;
 }
 $30 = ((($0)) + 54|0); //@line 105099 "c/sqlite3.c"
 $31 = HEAP8[$30>>0]|0; //@line 105099 "c/sqlite3.c"
 $32 = ($31<<24>>24)==(0); //@line 105099 "c/sqlite3.c"
 if ($32) {
  return; //@line 105100 "c/sqlite3.c"
 }
 $33 = (($2) + ($$lcssa<<1)|0); //@line 105099 "c/sqlite3.c"
 HEAP16[$33>>1] = 0; //@line 105099 "c/sqlite3.c"
 return; //@line 105100 "c/sqlite3.c"
}
function _sqlite3PrimaryKeyIndex($0) {
 $0 = $0|0;
 var $$0 = 0, $$0$lcssa = 0, $$06 = 0, $$07 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 102431 "c/sqlite3.c"
 $$06 = HEAP32[$1>>2]|0;
 $2 = ($$06|0)==(0|0); //@line 102431 "c/sqlite3.c"
 if ($2) {
  $$0$lcssa = 0;
  return ($$0$lcssa|0); //@line 102432 "c/sqlite3.c"
 }
 $$07 = $$06;
 while(1) {
  $3 = ((($$07)) + 55|0); //@line 102431 "c/sqlite3.c"
  $4 = HEAPU8[$3>>0]|(HEAPU8[$3+1>>0]<<8); //@line 102431 "c/sqlite3.c"
  $5 = $4 & 3; //@line 102431 "c/sqlite3.c"
  $6 = ($5<<16>>16)==(2); //@line 102431 "c/sqlite3.c"
  if ($6) {
   $$0$lcssa = $$07;
   label = 5;
   break;
  }
  $7 = ((($$07)) + 20|0); //@line 102431 "c/sqlite3.c"
  $$0 = HEAP32[$7>>2]|0;
  $8 = ($$0|0)==(0|0); //@line 102431 "c/sqlite3.c"
  if ($8) {
   $$0$lcssa = 0;
   label = 5;
   break;
  } else {
   $$07 = $$0;
  }
 }
 if ((label|0) == 5) {
  return ($$0$lcssa|0); //@line 102432 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3FindIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02226 = 0, $$02325 = 0, $$124 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 20|0); //@line 102043 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 102043 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 102043 "c/sqlite3.c"
 if (!($5)) {
  $$2 = 0;
  return ($$2|0); //@line 102052 "c/sqlite3.c"
 }
 $6 = ((($0)) + 16|0);
 $7 = ($2|0)==(0|0);
 $$02226 = 0;$$02325 = 0;
 while(1) {
  $8 = ($$02325>>>0)<(2); //@line 102044 "c/sqlite3.c"
  $9 = $8&1; //@line 102044 "c/sqlite3.c"
  $10 = $$02325 ^ $9; //@line 102044 "c/sqlite3.c"
  $11 = HEAP32[$6>>2]|0; //@line 102045 "c/sqlite3.c"
  $12 = (((($11) + ($10<<4)|0)) + 12|0); //@line 102045 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 102045 "c/sqlite3.c"
  if ($7) {
   label = 5;
  } else {
   $14 = (($11) + ($10<<4)|0); //@line 102047 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 102047 "c/sqlite3.c"
   $16 = (_sqlite3StrICmp($2,$15)|0); //@line 102047 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 102047 "c/sqlite3.c"
   if ($17) {
    label = 5;
   } else {
    $$124 = $$02226;
   }
  }
  if ((label|0) == 5) {
   label = 0;
   $18 = ((($13)) + 24|0); //@line 102049 "c/sqlite3.c"
   $19 = (_sqlite3HashFind($18,$1)|0); //@line 102049 "c/sqlite3.c"
   $20 = ($19|0)==(0|0); //@line 102050 "c/sqlite3.c"
   if ($20) {
    $$124 = $19;
   } else {
    break;
   }
  }
  $21 = (($$02325) + 1)|0; //@line 102043 "c/sqlite3.c"
  $22 = HEAP32[$3>>2]|0; //@line 102043 "c/sqlite3.c"
  $23 = ($21|0)<($22|0); //@line 102043 "c/sqlite3.c"
  if ($23) {
   $$02226 = $$124;$$02325 = $21;
  } else {
   $$2 = $$124;
   label = 8;
   break;
  }
 }
 if ((label|0) == 8) {
  return ($$2|0); //@line 102052 "c/sqlite3.c"
 }
 $$2 = $19;
 return ($$2|0); //@line 102052 "c/sqlite3.c"
}
function _decodeIntArray($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$lcssa = 0, $$03711 = 0, $$038$lcssa = 0, $$03810 = 0, $$04 = 0, $$1$lcssa = 0, $$13 = 0, $$31 = 0, $$4 = 0, $$5 = 0, $$off = 0, $$off2 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0;
 var $or$cond9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP8[$0>>0]|0; //@line 100302 "c/sqlite3.c"
 $5 = ($4<<24>>24)!=(0); //@line 100302 "c/sqlite3.c"
 $6 = ($1|0)>(0); //@line 100302 "c/sqlite3.c"
 $or$cond9 = $6 & $5; //@line 100302 "c/sqlite3.c"
 if ($or$cond9) {
  $$03711 = 0;$$03810 = $0;
  while(1) {
   $7 = HEAP8[$$03810>>0]|0; //@line 100304 "c/sqlite3.c"
   $$off2 = (($7) + -48)<<24>>24; //@line 100304 "c/sqlite3.c"
   $8 = ($$off2&255)<(10); //@line 100304 "c/sqlite3.c"
   if ($8) {
    $$04 = 0;$$13 = $$03810;$10 = $7;
    while(1) {
     $9 = $10 << 24 >> 24; //@line 100304 "c/sqlite3.c"
     $11 = ($$04*10)|0; //@line 100305 "c/sqlite3.c"
     $12 = (($11) + -48)|0; //@line 100305 "c/sqlite3.c"
     $13 = (($12) + ($9))|0; //@line 100305 "c/sqlite3.c"
     $14 = ((($$13)) + 1|0); //@line 100306 "c/sqlite3.c"
     $15 = HEAP8[$14>>0]|0; //@line 100304 "c/sqlite3.c"
     $$off = (($15) + -48)<<24>>24; //@line 100304 "c/sqlite3.c"
     $16 = ($$off&255)<(10); //@line 100304 "c/sqlite3.c"
     if ($16) {
      $$04 = $13;$$13 = $14;$10 = $15;
     } else {
      $$0$lcssa = $13;$$1$lcssa = $14;
      break;
     }
    }
   } else {
    $$0$lcssa = 0;$$1$lcssa = $$03810;
   }
   $17 = (_sqlite3LogEst($$0$lcssa,0)|0); //@line 100315 "c/sqlite3.c"
   $18 = (($2) + ($$03711<<1)|0); //@line 100315 "c/sqlite3.c"
   HEAP16[$18>>1] = $17; //@line 100315 "c/sqlite3.c"
   $19 = HEAP8[$$1$lcssa>>0]|0; //@line 100317 "c/sqlite3.c"
   $20 = ($19<<24>>24)==(32); //@line 100317 "c/sqlite3.c"
   $21 = ((($$1$lcssa)) + 1|0); //@line 100317 "c/sqlite3.c"
   $spec$select = $20 ? $21 : $$1$lcssa; //@line 100317 "c/sqlite3.c"
   $22 = (($$03711) + 1)|0; //@line 100302 "c/sqlite3.c"
   $23 = HEAP8[$spec$select>>0]|0; //@line 100302 "c/sqlite3.c"
   $24 = ($23<<24>>24)!=(0); //@line 100302 "c/sqlite3.c"
   $25 = ($22|0)<($1|0); //@line 100302 "c/sqlite3.c"
   $or$cond = $25 & $24; //@line 100302 "c/sqlite3.c"
   if ($or$cond) {
    $$03711 = $22;$$03810 = $spec$select;
   } else {
    $$038$lcssa = $spec$select;
    break;
   }
  }
 } else {
  $$038$lcssa = $0;
 }
 $26 = ((($3)) + 55|0); //@line 100324 "c/sqlite3.c"
 $27 = HEAPU8[$26>>0]|(HEAPU8[$26+1>>0]<<8); //@line 100324 "c/sqlite3.c"
 $28 = $27 & -69; //@line 100325 "c/sqlite3.c"
 HEAP8[$26>>0]=$28&255;HEAP8[$26+1>>0]=$28>>8; //@line 100325 "c/sqlite3.c"
 $$pr = HEAP8[$$038$lcssa>>0]|0; //@line 100326 "c/sqlite3.c"
 $29 = ($$pr<<24>>24)==(0); //@line 100326 "c/sqlite3.c"
 if ($29) {
  return; //@line 100343 "c/sqlite3.c"
 }
 $30 = ((($3)) + 48|0);
 $$31 = $$038$lcssa;
 L14: while(1) {
  $31 = (_sqlite3_strglob(21660,$$31)|0); //@line 100327 "c/sqlite3.c"
  $32 = ($31|0)==(0); //@line 100327 "c/sqlite3.c"
  do {
   if ($32) {
    $33 = HEAPU8[$26>>0]|(HEAPU8[$26+1>>0]<<8); //@line 100328 "c/sqlite3.c"
    $34 = $33 | 4; //@line 100328 "c/sqlite3.c"
    HEAP8[$26>>0]=$34&255;HEAP8[$26+1>>0]=$34>>8; //@line 100328 "c/sqlite3.c"
   } else {
    $35 = (_sqlite3_strglob(21671,$$31)|0); //@line 100329 "c/sqlite3.c"
    $36 = ($35|0)==(0); //@line 100329 "c/sqlite3.c"
    if ($36) {
     $37 = ((($$31)) + 3|0); //@line 100330 "c/sqlite3.c"
     $38 = (_sqlite3Atoi($37)|0); //@line 100330 "c/sqlite3.c"
     $39 = ($38|0)<(0); //@line 100330 "c/sqlite3.c"
     $40 = $39 << 31 >> 31; //@line 100330 "c/sqlite3.c"
     $41 = (_sqlite3LogEst($38,$40)|0); //@line 100330 "c/sqlite3.c"
     HEAP16[$30>>1] = $41; //@line 100330 "c/sqlite3.c"
     break;
    }
    $42 = (_sqlite3_strglob(21681,$$31)|0); //@line 100331 "c/sqlite3.c"
    $43 = ($42|0)==(0); //@line 100331 "c/sqlite3.c"
    if ($43) {
     $44 = HEAPU8[$26>>0]|(HEAPU8[$26+1>>0]<<8); //@line 100332 "c/sqlite3.c"
     $45 = $44 | 64; //@line 100332 "c/sqlite3.c"
     HEAP8[$26>>0]=$45&255;HEAP8[$26+1>>0]=$45>>8; //@line 100332 "c/sqlite3.c"
    }
   }
  } while(0);
  $$4 = $$31;
  L24: while(1) {
   $46 = HEAP8[$$4>>0]|0; //@line 100339 "c/sqlite3.c"
   switch ($46<<24>>24) {
   case 32: case 0:  {
    break L24;
    break;
   }
   default: {
   }
   }
   $47 = ((($$4)) + 1|0); //@line 100339 "c/sqlite3.c"
   $$4 = $47;
  }
  $$5 = $$4;
  L28: while(1) {
   $48 = HEAP8[$$5>>0]|0; //@line 100340 "c/sqlite3.c"
   $49 = ((($$5)) + 1|0); //@line 100340 "c/sqlite3.c"
   switch ($48<<24>>24) {
   case 0:  {
    break L14;
    break;
   }
   case 32:  {
    $$5 = $49;
    break;
   }
   default: {
    break L28;
   }
   }
  }
  $$31 = $$5;
 }
 return; //@line 100343 "c/sqlite3.c"
}
function _sqlite3LogEst($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$019 = 0, $$024 = 0, $$1$lcssa = 0, $$134 = 0, $$228 = 0, $$3 = 0, $$318$off0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1>>>0)<(0); //@line 29921 "c/sqlite3.c"
 $3 = ($0>>>0)<(8); //@line 29921 "c/sqlite3.c"
 $4 = ($1|0)==(0); //@line 29921 "c/sqlite3.c"
 $5 = $4 & $3; //@line 29921 "c/sqlite3.c"
 $6 = $2 | $5; //@line 29921 "c/sqlite3.c"
 if ($6) {
  $7 = ($1>>>0)<(0); //@line 29922 "c/sqlite3.c"
  $8 = ($0>>>0)<(2); //@line 29922 "c/sqlite3.c"
  $9 = ($1|0)==(0); //@line 29922 "c/sqlite3.c"
  $10 = $9 & $8; //@line 29922 "c/sqlite3.c"
  $11 = $7 | $10; //@line 29922 "c/sqlite3.c"
  if ($11) {
   $$019 = 0;
   return ($$019|0); //@line 29935 "c/sqlite3.c"
  }
  $$024 = 40;$14 = $0;$15 = $1;
  while(1) {
   $12 = $$024 & 65535; //@line 29923 "c/sqlite3.c"
   $13 = (($12) + 65526)|0; //@line 29923 "c/sqlite3.c"
   $16 = (_bitshift64Shl(($14|0),($15|0),1)|0); //@line 29923 "c/sqlite3.c"
   $17 = tempRet0; //@line 29923 "c/sqlite3.c"
   $18 = ($17>>>0)<(0); //@line 29923 "c/sqlite3.c"
   $19 = ($16>>>0)<(8); //@line 29923 "c/sqlite3.c"
   $20 = ($17|0)==(0); //@line 29923 "c/sqlite3.c"
   $21 = $20 & $19; //@line 29923 "c/sqlite3.c"
   $22 = $18 | $21; //@line 29923 "c/sqlite3.c"
   if ($22) {
    $$024 = $13;$14 = $16;$15 = $17;
   } else {
    break;
   }
  }
  $59 = $13&65535; //@line 29923 "c/sqlite3.c"
  $$3 = $59;$$318$off0 = $16;
 } else {
  $23 = ($1>>>0)>(0); //@line 29930 "c/sqlite3.c"
  $24 = ($0>>>0)>(255); //@line 29930 "c/sqlite3.c"
  $25 = ($1|0)==(0); //@line 29930 "c/sqlite3.c"
  $26 = $25 & $24; //@line 29930 "c/sqlite3.c"
  $27 = $23 | $26; //@line 29930 "c/sqlite3.c"
  if ($27) {
   $$134 = 40;$30 = $0;$31 = $1;
   while(1) {
    $28 = $$134 & 65535; //@line 29930 "c/sqlite3.c"
    $29 = (($28) + 40)|0; //@line 29930 "c/sqlite3.c"
    $32 = (_bitshift64Lshr(($30|0),($31|0),4)|0); //@line 29930 "c/sqlite3.c"
    $33 = tempRet0; //@line 29930 "c/sqlite3.c"
    $34 = ($31>>>0)>(0); //@line 29930 "c/sqlite3.c"
    $35 = ($30>>>0)>(4095); //@line 29930 "c/sqlite3.c"
    $36 = ($31|0)==(0); //@line 29930 "c/sqlite3.c"
    $37 = $36 & $35; //@line 29930 "c/sqlite3.c"
    $38 = $34 | $37; //@line 29930 "c/sqlite3.c"
    if ($38) {
     $$134 = $29;$30 = $32;$31 = $33;
    } else {
     break;
    }
   }
   $39 = $29&65535; //@line 29930 "c/sqlite3.c"
   $$1$lcssa = $39;$41 = $33;$43 = $32;
  } else {
   $$1$lcssa = 40;$41 = $1;$43 = $0;
  }
  $40 = ($41>>>0)>(0); //@line 29931 "c/sqlite3.c"
  $42 = ($43>>>0)>(15); //@line 29931 "c/sqlite3.c"
  $44 = ($41|0)==(0); //@line 29931 "c/sqlite3.c"
  $45 = $44 & $42; //@line 29931 "c/sqlite3.c"
  $46 = $40 | $45; //@line 29931 "c/sqlite3.c"
  if ($46) {
   $$228 = $$1$lcssa;$50 = $43;$51 = $41;
   while(1) {
    $47 = $$228&65535; //@line 29931 "c/sqlite3.c"
    $48 = (($47) + 10)|0; //@line 29931 "c/sqlite3.c"
    $49 = $48&65535; //@line 29931 "c/sqlite3.c"
    $52 = (_bitshift64Lshr(($50|0),($51|0),1)|0); //@line 29931 "c/sqlite3.c"
    $53 = tempRet0; //@line 29931 "c/sqlite3.c"
    $54 = ($51>>>0)>(0); //@line 29931 "c/sqlite3.c"
    $55 = ($50>>>0)>(31); //@line 29931 "c/sqlite3.c"
    $56 = ($51|0)==(0); //@line 29931 "c/sqlite3.c"
    $57 = $56 & $55; //@line 29931 "c/sqlite3.c"
    $58 = $54 | $57; //@line 29931 "c/sqlite3.c"
    if ($58) {
     $$228 = $49;$50 = $52;$51 = $53;
    } else {
     break;
    }
   }
   $$3 = $49;$$318$off0 = $52;
  } else {
   $$3 = $$1$lcssa;$$318$off0 = $43;
  }
 }
 $60 = $$318$off0 & 7; //@line 29934 "c/sqlite3.c"
 $61 = (11706 + ($60<<1)|0); //@line 29934 "c/sqlite3.c"
 $62 = HEAP16[$61>>1]|0; //@line 29934 "c/sqlite3.c"
 $63 = $62&65535; //@line 29934 "c/sqlite3.c"
 $64 = $$3&65535; //@line 29934 "c/sqlite3.c"
 $65 = (($64) + 65526)|0; //@line 29934 "c/sqlite3.c"
 $66 = (($65) + ($63))|0; //@line 29934 "c/sqlite3.c"
 $67 = $66&65535; //@line 29934 "c/sqlite3.c"
 $$019 = $67;
 return ($$019|0); //@line 29935 "c/sqlite3.c"
}
function _corruptSchema($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 117807 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 117807 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 117811 "c/sqlite3.c"
 $4 = ((($3)) + 73|0); //@line 117812 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 117812 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 117812 "c/sqlite3.c"
 if (!($6)) {
  $22 = 7;
  $21 = ((($0)) + 12|0); //@line 117820 "c/sqlite3.c"
  HEAP32[$21>>2] = $22; //@line 117820 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 117821 "c/sqlite3.c"
 }
 $7 = ((($3)) + 28|0); //@line 117812 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 117812 "c/sqlite3.c"
 $9 = $8 & 1; //@line 117812 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 117812 "c/sqlite3.c"
 if ($10) {
  $11 = ($1|0)==(0|0); //@line 117814 "c/sqlite3.c"
  $spec$select = $11 ? 21718 : $1; //@line 117814 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $spec$select; //@line 117815 "c/sqlite3.c"
  $12 = (_sqlite3MPrintf($3,21720,$vararg_buffer)|0); //@line 117815 "c/sqlite3.c"
  $13 = ($2|0)==(0|0); //@line 117816 "c/sqlite3.c"
  if ($13) {
   $$0 = $12;
  } else {
   HEAP32[$vararg_buffer1>>2] = $12; //@line 117816 "c/sqlite3.c"
   $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 117816 "c/sqlite3.c"
   HEAP32[$vararg_ptr4>>2] = $2; //@line 117816 "c/sqlite3.c"
   $14 = (_sqlite3MPrintf($3,21751,$vararg_buffer1)|0); //@line 117816 "c/sqlite3.c"
   $$0 = $14;
  }
  $15 = ((($0)) + 4|0); //@line 117817 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 117817 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 117817 "c/sqlite3.c"
  _sqlite3DbFree($3,$17); //@line 117817 "c/sqlite3.c"
  $18 = HEAP32[$15>>2]|0; //@line 117818 "c/sqlite3.c"
  HEAP32[$18>>2] = $$0; //@line 117818 "c/sqlite3.c"
 }
 $$pr = HEAP8[$4>>0]|0; //@line 117820 "c/sqlite3.c"
 $19 = ($$pr<<24>>24)==(0); //@line 117820 "c/sqlite3.c"
 if (!($19)) {
  $22 = 7;
  $21 = ((($0)) + 12|0); //@line 117820 "c/sqlite3.c"
  HEAP32[$21>>2] = $22; //@line 117820 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 117821 "c/sqlite3.c"
 }
 $20 = (_sqlite3CorruptError(117820)|0); //@line 117820 "c/sqlite3.c"
 $22 = $20;
 $21 = ((($0)) + 12|0); //@line 117820 "c/sqlite3.c"
 HEAP32[$21>>2] = $22; //@line 117820 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 117821 "c/sqlite3.c"
}
function _sqlite3ValueFromExpr($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)==(0|0); //@line 72644 "c/sqlite3.c"
 if ($5) {
  $7 = 0;
 } else {
  $6 = (_valueFromExpr($0,$1,$2,$3,$4)|0); //@line 72644 "c/sqlite3.c"
  $7 = $6;
 }
 return ($7|0); //@line 72644 "c/sqlite3.c"
}
function _sqlite3GetTempReg($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 19|0); //@line 97929 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 97929 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 97929 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 44|0); //@line 97930 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 97930 "c/sqlite3.c"
  $6 = (($5) + 1)|0; //@line 97930 "c/sqlite3.c"
  HEAP32[$4>>2] = $6; //@line 97930 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 97933 "c/sqlite3.c"
 } else {
  $7 = (($2) + -1)<<24>>24; //@line 97932 "c/sqlite3.c"
  HEAP8[$1>>0] = $7; //@line 97932 "c/sqlite3.c"
  $8 = $7&255; //@line 97932 "c/sqlite3.c"
  $9 = (((($0)) + 348|0) + ($8<<2)|0); //@line 97932 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 97932 "c/sqlite3.c"
  $$0 = $10;
  return ($$0|0); //@line 97933 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeCurrentAddr($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 136|0); //@line 73630 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 73630 "c/sqlite3.c"
 return ($2|0); //@line 73630 "c/sqlite3.c"
}
function _sqlite3ReleaseTempReg($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01517 = 0, $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 97944 "c/sqlite3.c"
 if ($2) {
  return;
 }
 $3 = ((($0)) + 19|0); //@line 97944 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 97944 "c/sqlite3.c"
 $5 = ($4&255)<(8); //@line 97944 "c/sqlite3.c"
 if (!($5)) {
  return;
 }
 $6 = ((($0)) + 25|0); //@line 97947 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 97947 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 97947 "c/sqlite3.c"
 L7: do {
  if (!($8)) {
   $9 = ((($0)) + 148|0); //@line 97947 "c/sqlite3.c"
   $$01517 = 0;$$018 = $9;
   while(1) {
    $10 = ((($$018)) + 12|0); //@line 97948 "c/sqlite3.c"
    $11 = HEAP32[$10>>2]|0; //@line 97948 "c/sqlite3.c"
    $12 = ($11|0)==($1|0); //@line 97948 "c/sqlite3.c"
    if ($12) {
     break;
    }
    $14 = (($$01517) + 1)|0; //@line 97947 "c/sqlite3.c"
    $15 = ((($$018)) + 20|0); //@line 97947 "c/sqlite3.c"
    $16 = HEAP8[$6>>0]|0; //@line 97947 "c/sqlite3.c"
    $17 = $16&255; //@line 97947 "c/sqlite3.c"
    $18 = ($14>>>0)<($17>>>0); //@line 97947 "c/sqlite3.c"
    if ($18) {
     $$01517 = $14;$$018 = $15;
    } else {
     break L7;
    }
   }
   $13 = ((($$018)) + 6|0); //@line 97949 "c/sqlite3.c"
   HEAP8[$13>>0] = 1; //@line 97949 "c/sqlite3.c"
   return;
  }
 } while(0);
 $19 = (($4) + 1)<<24>>24; //@line 97953 "c/sqlite3.c"
 HEAP8[$3>>0] = $19; //@line 97953 "c/sqlite3.c"
 $20 = $4&255; //@line 97953 "c/sqlite3.c"
 $21 = (((($0)) + 348|0) + ($20<<2)|0); //@line 97953 "c/sqlite3.c"
 HEAP32[$21>>2] = $1; //@line 97953 "c/sqlite3.c"
 return;
}
function _reloadTableSchema($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$034 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 98347 "c/sqlite3.c"
 $3 = (_sqlite3GetVdbe($0)|0); //@line 98355 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 98356 "c/sqlite3.c"
 if ($4) {
  STACKTOP = sp;return; //@line 98386 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 98358 "c/sqlite3.c"
 $6 = ((($1)) + 72|0); //@line 98358 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 98358 "c/sqlite3.c"
 $8 = (_sqlite3SchemaToIndex($5,$7)|0); //@line 98358 "c/sqlite3.c"
 $9 = (_sqlite3TriggerList($0,$1)|0); //@line 98363 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 98363 "c/sqlite3.c"
 if (!($10)) {
  $$034 = $9;
  while(1) {
   $11 = HEAP32[$0>>2]|0; //@line 98364 "c/sqlite3.c"
   $12 = ((($$034)) + 20|0); //@line 98364 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 98364 "c/sqlite3.c"
   $14 = (_sqlite3SchemaToIndex($11,$13)|0); //@line 98364 "c/sqlite3.c"
   $15 = HEAP32[$$034>>2]|0; //@line 98366 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($3,142,$14,0,0,$15,0)|0); //@line 98366 "c/sqlite3.c"
   $16 = ((($$034)) + 32|0); //@line 98363 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 98363 "c/sqlite3.c"
   $18 = ($17|0)==(0|0); //@line 98363 "c/sqlite3.c"
   if ($18) {
    break;
   } else {
    $$034 = $17;
   }
  }
 }
 $19 = HEAP32[$1>>2]|0; //@line 98371 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($3,140,$8,0,0,$19,0)|0); //@line 98371 "c/sqlite3.c"
 $20 = HEAP32[$0>>2]|0; //@line 98374 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 98374 "c/sqlite3.c"
 $21 = (_sqlite3MPrintf($20,22085,$vararg_buffer)|0); //@line 98374 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 98375 "c/sqlite3.c"
 if ($22) {
  STACKTOP = sp;return; //@line 98386 "c/sqlite3.c"
 }
 _sqlite3VdbeAddParseSchemaOp($3,$8,$21); //@line 98376 "c/sqlite3.c"
 $23 = (_whereTempTriggers($0,$1)|0); //@line 98382 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 98382 "c/sqlite3.c"
 if ($24) {
  STACKTOP = sp;return; //@line 98386 "c/sqlite3.c"
 }
 _sqlite3VdbeAddParseSchemaOp($3,1,$23); //@line 98383 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98386 "c/sqlite3.c"
}
function _sqlite3TriggerList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$028 = 0, $$02830 = 0, $$02832 = 0, $$02931 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 124987 "c/sqlite3.c"
 $3 = ((($2)) + 16|0); //@line 124987 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 124987 "c/sqlite3.c"
 $5 = ((($4)) + 28|0); //@line 124987 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 124987 "c/sqlite3.c"
 $7 = ((($0)) + 146|0); //@line 124990 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 124990 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 124990 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 0;
  return ($$0|0); //@line 125009 "c/sqlite3.c"
 }
 $10 = ((($1)) + 72|0); //@line 124994 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 124994 "c/sqlite3.c"
 $12 = ($6|0)==($11|0); //@line 124994 "c/sqlite3.c"
 if (!($12)) {
  $13 = ((($6)) + 48|0); //@line 124997 "c/sqlite3.c"
  $$02830 = HEAP32[$13>>2]|0;
  $14 = ($$02830|0)==(0|0); //@line 124997 "c/sqlite3.c"
  if (!($14)) {
   $15 = ((($1)) + 68|0);
   $$02832 = $$02830;$$02931 = 0;
   while(1) {
    $16 = ((($$02832)) + 8|0); //@line 124998 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 124998 "c/sqlite3.c"
    $18 = ((($17)) + 24|0); //@line 124999 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 124999 "c/sqlite3.c"
    $20 = ($19|0)==($11|0); //@line 124999 "c/sqlite3.c"
    if ($20) {
     $21 = ((($17)) + 4|0); //@line 125000 "c/sqlite3.c"
     $22 = HEAP32[$21>>2]|0; //@line 125000 "c/sqlite3.c"
     $23 = HEAP32[$1>>2]|0; //@line 125000 "c/sqlite3.c"
     $24 = (_sqlite3StrICmp($22,$23)|0); //@line 125000 "c/sqlite3.c"
     $25 = ($24|0)==(0); //@line 125000 "c/sqlite3.c"
     if ($25) {
      $26 = ($$02931|0)==(0|0); //@line 125002 "c/sqlite3.c"
      if ($26) {
       $27 = HEAP32[$15>>2]|0; //@line 125002 "c/sqlite3.c"
       $29 = $27;
      } else {
       $29 = $$02931;
      }
      $28 = ((($17)) + 32|0); //@line 125002 "c/sqlite3.c"
      HEAP32[$28>>2] = $29; //@line 125002 "c/sqlite3.c"
      $$1 = $17;
     } else {
      $$1 = $$02931;
     }
    } else {
     $$1 = $$02931;
    }
    $$028 = HEAP32[$$02832>>2]|0;
    $30 = ($$028|0)==(0|0); //@line 124997 "c/sqlite3.c"
    if ($30) {
     break;
    } else {
     $$02832 = $$028;$$02931 = $$1;
    }
   }
   $31 = ($$1|0)==(0|0); //@line 125008 "c/sqlite3.c"
   if (!($31)) {
    $$0 = $$1;
    return ($$0|0); //@line 125009 "c/sqlite3.c"
   }
  }
 }
 $32 = ((($1)) + 68|0); //@line 125008 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 125008 "c/sqlite3.c"
 $$0 = $33;
 return ($$0|0); //@line 125009 "c/sqlite3.c"
}
function _whereTempTriggers($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02930 = 0, $$031 = 0, $$1 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 98313 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 98316 "c/sqlite3.c"
 $3 = ((($2)) + 16|0); //@line 98316 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 98316 "c/sqlite3.c"
 $5 = ((($4)) + 28|0); //@line 98316 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 98316 "c/sqlite3.c"
 $7 = ((($1)) + 72|0); //@line 98323 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 98323 "c/sqlite3.c"
 $9 = ($8|0)==($6|0); //@line 98323 "c/sqlite3.c"
 if ($9) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 98336 "c/sqlite3.c"
 }
 $10 = (_sqlite3TriggerList($0,$1)|0); //@line 98325 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 98325 "c/sqlite3.c"
 if ($11) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 98336 "c/sqlite3.c"
 }
 $$02930 = 0;$$031 = $10;
 while(1) {
  $12 = ((($$031)) + 20|0); //@line 98326 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 98326 "c/sqlite3.c"
  $14 = ($13|0)==($6|0); //@line 98326 "c/sqlite3.c"
  if ($14) {
   $15 = HEAP32[$$031>>2]|0; //@line 98327 "c/sqlite3.c"
   $16 = (_whereOrName($2,$$02930,$15)|0); //@line 98327 "c/sqlite3.c"
   $$1 = $16;
  } else {
   $$1 = $$02930;
  }
  $17 = ((($$031)) + 32|0); //@line 98325 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 98325 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 98325 "c/sqlite3.c"
  if ($19) {
   break;
  } else {
   $$02930 = $$1;$$031 = $18;
  }
 }
 $20 = ($$1|0)==(0|0); //@line 98331 "c/sqlite3.c"
 if ($20) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 98336 "c/sqlite3.c"
 }
 $21 = HEAP32[$0>>2]|0; //@line 98332 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $$1; //@line 98332 "c/sqlite3.c"
 $22 = (_sqlite3MPrintf($21,22097,$vararg_buffer)|0); //@line 98332 "c/sqlite3.c"
 $23 = HEAP32[$0>>2]|0; //@line 98333 "c/sqlite3.c"
 _sqlite3DbFree($23,$$1); //@line 98333 "c/sqlite3.c"
 $$3 = $22;
 STACKTOP = sp;return ($$3|0); //@line 98336 "c/sqlite3.c"
}
function _whereOrName($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 98279 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 98279 "c/sqlite3.c"
 $3 = ($1|0)==(0|0); //@line 98281 "c/sqlite3.c"
 if ($3) {
  HEAP32[$vararg_buffer>>2] = $2; //@line 98282 "c/sqlite3.c"
  $4 = (_sqlite3MPrintf($0,22121,$vararg_buffer)|0); //@line 98282 "c/sqlite3.c"
  $$0 = $4;
  STACKTOP = sp;return ($$0|0); //@line 98287 "c/sqlite3.c"
 } else {
  HEAP32[$vararg_buffer1>>2] = $1; //@line 98284 "c/sqlite3.c"
  $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 98284 "c/sqlite3.c"
  HEAP32[$vararg_ptr4>>2] = $2; //@line 98284 "c/sqlite3.c"
  $5 = (_sqlite3MPrintf($0,22129,$vararg_buffer1)|0); //@line 98284 "c/sqlite3.c"
  _sqlite3DbFree($0,$1); //@line 98285 "c/sqlite3.c"
  $$0 = $5;
  STACKTOP = sp;return ($$0|0); //@line 98287 "c/sqlite3.c"
 }
 return (0)|0;
}
function _valueFromExpr($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$088 = 0, $$089 = 0, $$090 = 0, $$094 = 0, $$1 = 0, $$11 = 0, $$195 = 0, $10 = 0, $100 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0.0, $69 = 0.0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond7 = 0, $trunc = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $5 = sp + 8|0;
 HEAP32[$5>>2] = 0; //@line 72507 "c/sqlite3.c"
 $$088 = $1;
 L1: while(1) {
  $6 = HEAP8[$$088>>0]|0; //@line 72513 "c/sqlite3.c"
  switch ($6<<24>>24) {
  case -107: case -101:  {
   break;
  }
  default: {
   break L1;
  }
  }
  $7 = ((($$088)) + 12|0); //@line 72513 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 72513 "c/sqlite3.c"
  $$088 = $8;
 }
 $9 = $6&255; //@line 72513 "c/sqlite3.c"
 $10 = ($6<<24>>24)==(-106); //@line 72517 "c/sqlite3.c"
 if ($10) {
  $11 = ((($$088)) + 38|0); //@line 72517 "c/sqlite3.c"
  $12 = HEAP8[$11>>0]|0; //@line 72517 "c/sqlite3.c"
  $13 = $12&255; //@line 72517 "c/sqlite3.c"
  $$094 = $13;
 } else {
  $$094 = $9;
 }
 $trunc = $$094&255; //@line 72526 "c/sqlite3.c"
 L8: do {
  switch ($trunc<<24>>24) {
  case 36:  {
   $14 = ((($$088)) + 8|0); //@line 72527 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 72527 "c/sqlite3.c"
   $16 = (_sqlite3AffinityType($15,0)|0); //@line 72527 "c/sqlite3.c"
   $17 = ((($$088)) + 12|0); //@line 72528 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 72528 "c/sqlite3.c"
   $19 = (_valueFromExpr($0,$18,$2,$16,$4)|0); //@line 72528 "c/sqlite3.c"
   $20 = HEAP32[$4>>2]|0; //@line 72530 "c/sqlite3.c"
   $21 = ($20|0)==(0|0); //@line 72530 "c/sqlite3.c"
   if ($21) {
    $$0 = $19;
    STACKTOP = sp;return ($$0|0); //@line 72625 "c/sqlite3.c"
   }
   _sqlite3VdbeMemCast($20,$16,1); //@line 72531 "c/sqlite3.c"
   $22 = HEAP32[$4>>2]|0; //@line 72532 "c/sqlite3.c"
   _sqlite3ValueApplyAffinity($22,$3,1); //@line 72532 "c/sqlite3.c"
   $$0 = $19;
   STACKTOP = sp;return ($$0|0); //@line 72625 "c/sqlite3.c"
   break;
  }
  case -108:  {
   $23 = ((($$088)) + 12|0); //@line 72541 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 72541 "c/sqlite3.c"
   $25 = HEAP8[$24>>0]|0; //@line 72541 "c/sqlite3.c"
   switch ($25<<24>>24) {
   case -124: case -122:  {
    break;
   }
   default: {
    $$11 = $$088;
    label = 24;
    break L8;
   }
   }
   $26 = $25&255; //@line 72543 "c/sqlite3.c"
   $$090 = 22143;$$1 = $24;$$195 = $26;$37 = -1;$38 = -1;
   label = 11;
   break;
  }
  default: {
   $$090 = 41388;$$1 = $$088;$$195 = $$094;$37 = 1;$38 = 0;
   label = 11;
  }
  }
 } while(0);
 L16: do {
  if ((label|0) == 11) {
   L18: do {
    switch ($$195|0) {
    case 148:  {
     $$11 = $$1;
     label = 24;
     break L16;
     break;
    }
    case 97: case 132: case 134:  {
     $27 = (_valueNew($0)|0); //@line 72549 "c/sqlite3.c"
     HEAP32[$5>>2] = $27; //@line 72549 "c/sqlite3.c"
     $28 = ($27|0)==(0|0); //@line 72550 "c/sqlite3.c"
     if (!($28)) {
      $29 = ((($$1)) + 4|0); //@line 72551 "c/sqlite3.c"
      $30 = HEAP32[$29>>2]|0; //@line 72551 "c/sqlite3.c"
      $31 = $30 & 1024; //@line 72551 "c/sqlite3.c"
      $32 = ($31|0)==(0); //@line 72551 "c/sqlite3.c"
      if ($32) {
       $41 = ((($$1)) + 8|0); //@line 72554 "c/sqlite3.c"
       $42 = HEAP32[$41>>2]|0; //@line 72554 "c/sqlite3.c"
       HEAP32[$vararg_buffer>>2] = $$090; //@line 72554 "c/sqlite3.c"
       $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 72554 "c/sqlite3.c"
       HEAP32[$vararg_ptr1>>2] = $42; //@line 72554 "c/sqlite3.c"
       $43 = (_sqlite3MPrintf($0,22145,$vararg_buffer)|0); //@line 72554 "c/sqlite3.c"
       $44 = ($43|0)==(0|0); //@line 72555 "c/sqlite3.c"
       if ($44) {
        break L18;
       }
       _sqlite3ValueSetStr($27,$43,1,157); //@line 72556 "c/sqlite3.c"
      } else {
       $33 = ((($$1)) + 8|0); //@line 72552 "c/sqlite3.c"
       $34 = HEAP32[$33>>2]|0; //@line 72552 "c/sqlite3.c"
       $35 = ($34|0)<(0); //@line 72552 "c/sqlite3.c"
       $36 = $35 << 31 >> 31; //@line 72552 "c/sqlite3.c"
       $39 = (___muldi3(($37|0),($38|0),($34|0),($36|0))|0); //@line 72552 "c/sqlite3.c"
       $40 = tempRet0; //@line 72552 "c/sqlite3.c"
       _sqlite3VdbeMemSetInt64($27,$39,$40); //@line 72552 "c/sqlite3.c"
      }
      $45 = $$195 | 2; //@line 72558 "c/sqlite3.c"
      $46 = ($45|0)==(134); //@line 72558 "c/sqlite3.c"
      $47 = ($3<<24>>24)==(65); //@line 72558 "c/sqlite3.c"
      $or$cond = $47 & $46; //@line 72558 "c/sqlite3.c"
      if ($or$cond) {
       _sqlite3ValueApplyAffinity($27,67,1); //@line 72559 "c/sqlite3.c"
      } else {
       _sqlite3ValueApplyAffinity($27,$3,1); //@line 72561 "c/sqlite3.c"
      }
      $48 = ((($27)) + 8|0); //@line 72563 "c/sqlite3.c"
      $49 = HEAP16[$48>>1]|0; //@line 72563 "c/sqlite3.c"
      $50 = $49&65535; //@line 72563 "c/sqlite3.c"
      $51 = $50 & 12; //@line 72563 "c/sqlite3.c"
      $52 = ($51|0)==(0); //@line 72563 "c/sqlite3.c"
      if (!($52)) {
       $53 = $50 & 65533; //@line 72563 "c/sqlite3.c"
       $54 = $53&65535; //@line 72563 "c/sqlite3.c"
       HEAP16[$48>>1] = $54; //@line 72563 "c/sqlite3.c"
      }
      $55 = ($2<<24>>24)==(1); //@line 72564 "c/sqlite3.c"
      if ($55) {
       $$089 = 0;
       break L16;
      }
      $56 = $2&255; //@line 72564 "c/sqlite3.c"
      $57 = (_sqlite3VdbeChangeEncoding($27,$56)|0); //@line 72565 "c/sqlite3.c"
      $$089 = $57;
      break L16;
     }
     break;
    }
    case 101:  {
     $88 = (_valueNew($0)|0); //@line 72584 "c/sqlite3.c"
     HEAP32[$5>>2] = $88; //@line 72584 "c/sqlite3.c"
     $89 = ($88|0)==(0|0); //@line 72585 "c/sqlite3.c"
     if (!($89)) {
      _sqlite3VdbeMemNumerify($88); //@line 72586 "c/sqlite3.c"
      $$089 = 0;
      break L16;
     }
     break;
    }
    case 133:  {
     $90 = (_valueNew($0)|0); //@line 72593 "c/sqlite3.c"
     HEAP32[$5>>2] = $90; //@line 72593 "c/sqlite3.c"
     $91 = ($90|0)==(0|0); //@line 72594 "c/sqlite3.c"
     if (!($91)) {
      $92 = ((($$1)) + 8|0); //@line 72595 "c/sqlite3.c"
      $93 = HEAP32[$92>>2]|0; //@line 72595 "c/sqlite3.c"
      $94 = ((($93)) + 2|0); //@line 72595 "c/sqlite3.c"
      $95 = (_sqlite3Strlen30($94)|0); //@line 72596 "c/sqlite3.c"
      $96 = (($95) + -1)|0; //@line 72596 "c/sqlite3.c"
      $97 = (_sqlite3HexToBlob($0,$94,$96)|0); //@line 72598 "c/sqlite3.c"
      $98 = (($96|0) / 2)&-1; //@line 72598 "c/sqlite3.c"
      (_sqlite3VdbeMemSetStr($90,$97,$98,0,157)|0); //@line 72598 "c/sqlite3.c"
      $$089 = 0;
      break L16;
     }
     break;
    }
    default: {
     $$089 = 0;
     break L16;
    }
    }
   } while(0);
   _sqlite3OomFault($0); //@line 72616 "c/sqlite3.c"
   _sqlite3DbFree($0,0); //@line 72617 "c/sqlite3.c"
   $100 = HEAP32[$5>>2]|0; //@line 72622 "c/sqlite3.c"
   _sqlite3ValueFree($100); //@line 72622 "c/sqlite3.c"
   $$0 = 7;
   STACKTOP = sp;return ($$0|0); //@line 72625 "c/sqlite3.c"
  }
 } while(0);
 if ((label|0) == 24) {
  $58 = ((($$11)) + 12|0); //@line 72569 "c/sqlite3.c"
  $59 = HEAP32[$58>>2]|0; //@line 72569 "c/sqlite3.c"
  $60 = (_valueFromExpr($0,$59,$2,$3,$5)|0); //@line 72569 "c/sqlite3.c"
  $61 = ($60|0)==(0); //@line 72569 "c/sqlite3.c"
  $62 = HEAP32[$5>>2]|0; //@line 72570 "c/sqlite3.c"
  $63 = ($62|0)!=(0|0); //@line 72570 "c/sqlite3.c"
  $or$cond7 = $61 & $63; //@line 72570 "c/sqlite3.c"
  if ($or$cond7) {
   _sqlite3VdbeMemNumerify($62); //@line 72572 "c/sqlite3.c"
   $64 = ((($62)) + 8|0); //@line 72573 "c/sqlite3.c"
   $65 = HEAP16[$64>>1]|0; //@line 72573 "c/sqlite3.c"
   $66 = $65 & 8; //@line 72573 "c/sqlite3.c"
   $67 = ($66<<16>>16)==(0); //@line 72573 "c/sqlite3.c"
   do {
    if ($67) {
     $70 = $62; //@line 72575 "c/sqlite3.c"
     $71 = $70; //@line 72575 "c/sqlite3.c"
     $72 = HEAP32[$71>>2]|0; //@line 72575 "c/sqlite3.c"
     $73 = (($70) + 4)|0; //@line 72575 "c/sqlite3.c"
     $74 = $73; //@line 72575 "c/sqlite3.c"
     $75 = HEAP32[$74>>2]|0; //@line 72575 "c/sqlite3.c"
     $76 = ($72|0)==(0); //@line 72575 "c/sqlite3.c"
     $77 = ($75|0)==(-2147483648); //@line 72575 "c/sqlite3.c"
     $78 = $76 & $77; //@line 72575 "c/sqlite3.c"
     if ($78) {
      HEAPF64[$62>>3] = 9.2233720368547758E+18; //@line 72576 "c/sqlite3.c"
      $79 = HEAP16[$64>>1]|0; //@line 72577 "c/sqlite3.c"
      $80 = $79 & 15872; //@line 72577 "c/sqlite3.c"
      $81 = $80 | 8; //@line 72577 "c/sqlite3.c"
      HEAP16[$64>>1] = $81; //@line 72577 "c/sqlite3.c"
      break;
     } else {
      $82 = (_i64Subtract(0,0,($72|0),($75|0))|0); //@line 72579 "c/sqlite3.c"
      $83 = tempRet0; //@line 72579 "c/sqlite3.c"
      $84 = $62; //@line 72579 "c/sqlite3.c"
      $85 = $84; //@line 72579 "c/sqlite3.c"
      HEAP32[$85>>2] = $82; //@line 72579 "c/sqlite3.c"
      $86 = (($84) + 4)|0; //@line 72579 "c/sqlite3.c"
      $87 = $86; //@line 72579 "c/sqlite3.c"
      HEAP32[$87>>2] = $83; //@line 72579 "c/sqlite3.c"
      break;
     }
    } else {
     $68 = +HEAPF64[$62>>3]; //@line 72574 "c/sqlite3.c"
     $69 = - $68; //@line 72574 "c/sqlite3.c"
     HEAPF64[$62>>3] = $69; //@line 72574 "c/sqlite3.c"
    }
   } while(0);
   _sqlite3ValueApplyAffinity($62,$3,$2); //@line 72581 "c/sqlite3.c"
   $$089 = 0;
  } else {
   $$089 = 0;
  }
 }
 $99 = HEAP32[$5>>2]|0; //@line 72609 "c/sqlite3.c"
 HEAP32[$4>>2] = $99; //@line 72609 "c/sqlite3.c"
 $$0 = $$089;
 STACKTOP = sp;return ($$0|0); //@line 72625 "c/sqlite3.c"
}
function _sqlite3AffinityType($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$03348 = 0, $$03647 = 0, $$03746 = 0, $$049 = 0, $$1 = 0, $$1$ph = 0, $$134 = 0, $$134$ph = 0, $$235 = 0, $$245 = 0, $$old = 0, $$old38 = 0, $$old40 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$store$select = 0, $switch$split102D = 0, $switch$split12D = 0, $switch$split132D = 0, $switch$split2D = 0, $switch$split42D = 0, $switch$split72D = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP8[$0>>0]|0; //@line 102776 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 102776 "c/sqlite3.c"
 L1: do {
  if ($4) {
   $$0$lcssa = 0;$$235 = 67;
  } else {
   $$03348 = 67;$$03647 = 0;$$03746 = $0;$$049 = 0;$7 = $3;
   while(1) {
    $5 = $$03647 << 8; //@line 102777 "c/sqlite3.c"
    $6 = $7&255; //@line 102777 "c/sqlite3.c"
    $8 = (16025 + ($6)|0); //@line 102777 "c/sqlite3.c"
    $9 = HEAP8[$8>>0]|0; //@line 102777 "c/sqlite3.c"
    $10 = $9&255; //@line 102777 "c/sqlite3.c"
    $11 = $5 | $10; //@line 102777 "c/sqlite3.c"
    $12 = ((($$03746)) + 1|0); //@line 102778 "c/sqlite3.c"
    $switch$split2D = ($11|0)<(1685026146);
    L5: do {
     if ($switch$split2D) {
      $switch$split12D = ($11|0)<(1667785074);
      if ($switch$split12D) {
       switch ($11|0) {
       case 1651273570:  {
        break;
       }
       default: {
        label = 13;
        break L5;
       }
       }
       switch ($$03348<<24>>24) {
       case 69: case 67:  {
        break;
       }
       default: {
        label = 12;
        break L5;
       }
       }
       $13 = HEAP8[$12>>0]|0; //@line 102789 "c/sqlite3.c"
       $14 = ($13<<24>>24)==(40); //@line 102789 "c/sqlite3.c"
       $spec$select = $14 ? $12 : $$049; //@line 102789 "c/sqlite3.c"
       $$1 = $spec$select;$$134 = 65;$18 = $13;
       break;
      }
      $switch$split72D = ($11|0)<(1668050786);
      if ($switch$split72D) {
       switch ($11|0) {
       case 1667785074:  {
        $$1$ph = $12;$$134$ph = 66;
        label = 14;
        break L5;
        break;
       }
       default: {
        label = 13;
        break L5;
       }
       }
      }
      switch ($11|0) {
      case 1668050786:  {
       break;
      }
      default: {
       label = 13;
       break L5;
      }
      }
      $$1$ph = $$049;$$134$ph = 66;
      label = 14;
     } else {
      $switch$split42D = ($11|0)<(1919246700);
      if (!($switch$split42D)) {
       $switch$split132D = ($11|0)<(1952807028);
       if ($switch$split132D) {
        switch ($11|0) {
        case 1919246700:  {
         break;
        }
        default: {
         label = 13;
         break L5;
        }
        }
        $$old = ($$03348<<24>>24)==(67); //@line 102792 "c/sqlite3.c"
        if ($$old) {
         $$1$ph = $$049;$$134$ph = 69;
         label = 14;
         break;
        } else {
         label = 12;
         break;
        }
       } else {
        switch ($11|0) {
        case 1952807028:  {
         break;
        }
        default: {
         label = 13;
         break L5;
        }
        }
        $$1$ph = $$049;$$134$ph = 66;
        label = 14;
        break;
       }
      }
      $switch$split102D = ($11|0)<(1718382433);
      if ($switch$split102D) {
       switch ($11|0) {
       case 1685026146:  {
        break;
       }
       default: {
        label = 13;
        break L5;
       }
       }
       $$old40 = ($$03348<<24>>24)==(67); //@line 102798 "c/sqlite3.c"
       if ($$old40) {
        $$1$ph = $$049;$$134$ph = 69;
        label = 14;
        break;
       }
      } else {
       switch ($11|0) {
       case 1718382433:  {
        break;
       }
       default: {
        label = 13;
        break L5;
       }
       }
       $$old38 = ($$03348<<24>>24)==(67); //@line 102795 "c/sqlite3.c"
       if ($$old38) {
        $$1$ph = $$049;$$134$ph = 69;
        label = 14;
        break;
       }
      }
      $$1$ph = $$049;$$134$ph = $$03348;
      label = 14;
     }
    } while(0);
    if ((label|0) == 12) {
     label = 0;
     $$1$ph = $$049;$$134$ph = $$03348;
     label = 14;
    }
    else if ((label|0) == 13) {
     label = 0;
     $15 = $11 & 16777215; //@line 102801 "c/sqlite3.c"
     $16 = ($15|0)==(6909556); //@line 102801 "c/sqlite3.c"
     if ($16) {
      $$0$lcssa = $$049;$$235 = 68;
      break L1;
     } else {
      $$1$ph = $$049;$$134$ph = $$03348;
      label = 14;
     }
    }
    if ((label|0) == 14) {
     label = 0;
     $$pr = HEAP8[$12>>0]|0; //@line 102776 "c/sqlite3.c"
     $$1 = $$1$ph;$$134 = $$134$ph;$18 = $$pr;
    }
    $17 = ($18<<24>>24)==(0); //@line 102776 "c/sqlite3.c"
    if ($17) {
     $$0$lcssa = $$1;$$235 = $$134;
     break;
    } else {
     $$03348 = $$134;$$03647 = $11;$$03746 = $12;$$049 = $$1;$7 = $18;
    }
   }
  }
 } while(0);
 $19 = ($1|0)==(0|0); //@line 102809 "c/sqlite3.c"
 if ($19) {
  STACKTOP = sp;return ($$235|0); //@line 102829 "c/sqlite3.c"
 }
 HEAP8[$1>>0] = 1; //@line 102810 "c/sqlite3.c"
 $20 = ($$235<<24>>24)<(67); //@line 102811 "c/sqlite3.c"
 if (!($20)) {
  STACKTOP = sp;return ($$235|0); //@line 102829 "c/sqlite3.c"
 }
 $21 = ($$0$lcssa|0)==(0|0); //@line 102812 "c/sqlite3.c"
 if ($21) {
  HEAP8[$1>>0] = 5; //@line 102825 "c/sqlite3.c"
  STACKTOP = sp;return ($$235|0); //@line 102829 "c/sqlite3.c"
 }
 $22 = HEAP8[$$0$lcssa>>0]|0; //@line 102813 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(0); //@line 102813 "c/sqlite3.c"
 if ($23) {
  STACKTOP = sp;return ($$235|0); //@line 102829 "c/sqlite3.c"
 }
 $$245 = $$0$lcssa;$25 = $22;
 while(1) {
  $24 = $25&255; //@line 102814 "c/sqlite3.c"
  $26 = (($24) + -48)|0; //@line 102814 "c/sqlite3.c"
  $27 = ($26>>>0)<(10); //@line 102814 "c/sqlite3.c"
  if ($27) {
   break;
  }
  $33 = ((($$245)) + 1|0); //@line 102822 "c/sqlite3.c"
  $34 = HEAP8[$33>>0]|0; //@line 102813 "c/sqlite3.c"
  $35 = ($34<<24>>24)==(0); //@line 102813 "c/sqlite3.c"
  if ($35) {
   label = 25;
   break;
  } else {
   $$245 = $33;$25 = $34;
  }
 }
 if ((label|0) == 25) {
  STACKTOP = sp;return ($$235|0); //@line 102829 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = 0; //@line 102815 "c/sqlite3.c"
 (_sqlite3GetInt32($$245,$2)|0); //@line 102816 "c/sqlite3.c"
 $28 = HEAP32[$2>>2]|0; //@line 102817 "c/sqlite3.c"
 $29 = (($28|0) / 4)&-1; //@line 102817 "c/sqlite3.c"
 $30 = (($29) + 1)|0; //@line 102817 "c/sqlite3.c"
 $31 = ($30|0)<(255); //@line 102818 "c/sqlite3.c"
 $spec$store$select = $31 ? $30 : 255; //@line 102818 "c/sqlite3.c"
 $32 = $spec$store$select&255; //@line 102819 "c/sqlite3.c"
 HEAP8[$1>>0] = $32; //@line 102819 "c/sqlite3.c"
 STACKTOP = sp;return ($$235|0); //@line 102829 "c/sqlite3.c"
}
function _sqlite3VdbeMemCast($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 71815 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 71815 "c/sqlite3.c"
 $5 = $4&65535; //@line 71815 "c/sqlite3.c"
 $6 = $5 & 1; //@line 71815 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 71815 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 71849 "c/sqlite3.c"
 }
 switch ($1<<24>>24) {
 case 65:  {
  $8 = $5 & 16; //@line 71818 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 71818 "c/sqlite3.c"
  if (!($9)) {
   $17 = $5 & 15888; //@line 71823 "c/sqlite3.c"
   $18 = $17&65535; //@line 71823 "c/sqlite3.c"
   HEAP16[$3>>1] = $18; //@line 71823 "c/sqlite3.c"
   return; //@line 71849 "c/sqlite3.c"
  }
  _sqlite3ValueApplyAffinity($0,66,$2); //@line 71819 "c/sqlite3.c"
  $10 = HEAP16[$3>>1]|0; //@line 71821 "c/sqlite3.c"
  $11 = $10&65535; //@line 71821 "c/sqlite3.c"
  $12 = $11 & 2; //@line 71821 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 71821 "c/sqlite3.c"
  if ($13) {
   return; //@line 71849 "c/sqlite3.c"
  }
  $14 = $11 & 15872; //@line 71821 "c/sqlite3.c"
  $15 = $14 | 16; //@line 71821 "c/sqlite3.c"
  $16 = $15&65535; //@line 71821 "c/sqlite3.c"
  HEAP16[$3>>1] = $16; //@line 71821 "c/sqlite3.c"
  return; //@line 71849 "c/sqlite3.c"
  break;
 }
 case 67:  {
  _sqlite3VdbeMemNumerify($0); //@line 71828 "c/sqlite3.c"
  return; //@line 71849 "c/sqlite3.c"
  break;
 }
 case 68:  {
  _sqlite3VdbeMemIntegerify($0); //@line 71832 "c/sqlite3.c"
  return; //@line 71849 "c/sqlite3.c"
  break;
 }
 case 69:  {
  _sqlite3VdbeMemRealify($0); //@line 71836 "c/sqlite3.c"
  return; //@line 71849 "c/sqlite3.c"
  break;
 }
 default: {
  $19 = $5 >>> 3; //@line 71842 "c/sqlite3.c"
  $20 = $19 & 2; //@line 71842 "c/sqlite3.c"
  $21 = $20 | $5; //@line 71842 "c/sqlite3.c"
  $22 = $21&65535; //@line 71842 "c/sqlite3.c"
  HEAP16[$3>>1] = $22; //@line 71842 "c/sqlite3.c"
  _sqlite3ValueApplyAffinity($0,66,$2); //@line 71843 "c/sqlite3.c"
  $23 = HEAP16[$3>>1]|0; //@line 71845 "c/sqlite3.c"
  $24 = $23 & -16413; //@line 71845 "c/sqlite3.c"
  HEAP16[$3>>1] = $24; //@line 71845 "c/sqlite3.c"
  return; //@line 71849 "c/sqlite3.c"
 }
 }
}
function _sqlite3ValueApplyAffinity($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _applyAffinity($0,$1,$2); //@line 80233 "c/sqlite3.c"
 return; //@line 80234 "c/sqlite3.c"
}
function _valueNew($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ValueNew($0)|0); //@line 72379 "c/sqlite3.c"
 return ($1|0); //@line 72379 "c/sqlite3.c"
}
function _sqlite3VdbeMemNumerify($0) {
 $0 = $0|0;
 var $$sink2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71784 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71784 "c/sqlite3.c"
 $3 = $2 & 13; //@line 71784 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 71784 "c/sqlite3.c"
 if (!($4)) {
  $33 = HEAP16[$1>>1]|0; //@line 71803 "c/sqlite3.c"
  $34 = $33 & -16403; //@line 71803 "c/sqlite3.c"
  HEAP16[$1>>1] = $34; //@line 71803 "c/sqlite3.c"
  return;
 }
 $5 = ((($0)) + 16|0); //@line 71788 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 71788 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 71788 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 71788 "c/sqlite3.c"
 $9 = ((($0)) + 10|0); //@line 71788 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 71788 "c/sqlite3.c"
 $11 = (_sqlite3Atoi64($6,$0,$8,$10)|0); //@line 71788 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 71789 "c/sqlite3.c"
 if ($12) {
  $$sink2 = 4;
 } else {
  $13 = $0; //@line 71792 "c/sqlite3.c"
  $14 = $13; //@line 71792 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 71792 "c/sqlite3.c"
  $16 = (($13) + 4)|0; //@line 71792 "c/sqlite3.c"
  $17 = $16; //@line 71792 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 71792 "c/sqlite3.c"
  $19 = HEAP32[$5>>2]|0; //@line 71793 "c/sqlite3.c"
  $20 = HEAP32[$7>>2]|0; //@line 71793 "c/sqlite3.c"
  $21 = HEAP8[$9>>0]|0; //@line 71793 "c/sqlite3.c"
  (_sqlite3AtoF($19,$0,$20,$21)|0); //@line 71793 "c/sqlite3.c"
  $22 = ($11|0)==(1); //@line 71794 "c/sqlite3.c"
  if ($22) {
   $23 = +HEAPF64[$0>>3]; //@line 71794 "c/sqlite3.c"
   $24 = (+($15>>>0)) + (4294967296.0*(+($18|0))); //@line 71794 "c/sqlite3.c"
   $25 = $23 == $24; //@line 71794 "c/sqlite3.c"
   if ($25) {
    $26 = $0; //@line 71795 "c/sqlite3.c"
    $27 = $26; //@line 71795 "c/sqlite3.c"
    HEAP32[$27>>2] = $15; //@line 71795 "c/sqlite3.c"
    $28 = (($26) + 4)|0; //@line 71795 "c/sqlite3.c"
    $29 = $28; //@line 71795 "c/sqlite3.c"
    HEAP32[$29>>2] = $18; //@line 71795 "c/sqlite3.c"
    $$sink2 = 4;
   } else {
    $$sink2 = 8;
   }
  } else {
   $$sink2 = 8;
  }
 }
 $30 = HEAP16[$1>>1]|0;
 $31 = $30 & 15872;
 $32 = $31 | $$sink2;
 HEAP16[$1>>1] = $32;
 $33 = HEAP16[$1>>1]|0; //@line 71803 "c/sqlite3.c"
 $34 = $33 & -16403; //@line 71803 "c/sqlite3.c"
 HEAP16[$1>>1] = $34; //@line 71803 "c/sqlite3.c"
 return;
}
function _sqlite3HexToBlob($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (($2|0) / 2)&-1; //@line 29712 "c/sqlite3.c"
 $4 = (($3) + 1)|0; //@line 29712 "c/sqlite3.c"
 $5 = ($4|0)<(0); //@line 29712 "c/sqlite3.c"
 $6 = $5 << 31 >> 31; //@line 29712 "c/sqlite3.c"
 $7 = (_sqlite3DbMallocRawNN($0,$4,$6)|0); //@line 29712 "c/sqlite3.c"
 $8 = (($2) + -1)|0; //@line 29713 "c/sqlite3.c"
 $9 = ($7|0)==(0|0); //@line 29714 "c/sqlite3.c"
 if ($9) {
  return ($7|0); //@line 29720 "c/sqlite3.c"
 }
 $10 = ($2|0)>(1); //@line 29715 "c/sqlite3.c"
 if ($10) {
  $$018 = 0;
  while(1) {
   $11 = (($1) + ($$018)|0); //@line 29716 "c/sqlite3.c"
   $12 = HEAP8[$11>>0]|0; //@line 29716 "c/sqlite3.c"
   $13 = $12 << 24 >> 24; //@line 29716 "c/sqlite3.c"
   $14 = (_sqlite3HexToInt($13)|0); //@line 29716 "c/sqlite3.c"
   $15 = $14&255; //@line 29716 "c/sqlite3.c"
   $16 = $15 << 4; //@line 29716 "c/sqlite3.c"
   $17 = $$018 | 1; //@line 29716 "c/sqlite3.c"
   $18 = (($1) + ($17)|0); //@line 29716 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 29716 "c/sqlite3.c"
   $20 = $19 << 24 >> 24; //@line 29716 "c/sqlite3.c"
   $21 = (_sqlite3HexToInt($20)|0); //@line 29716 "c/sqlite3.c"
   $22 = $21&255; //@line 29716 "c/sqlite3.c"
   $23 = $16 | $22; //@line 29716 "c/sqlite3.c"
   $24 = $23&255; //@line 29716 "c/sqlite3.c"
   $25 = $$018 >>> 1; //@line 29716 "c/sqlite3.c"
   $26 = (($7) + ($25)|0); //@line 29716 "c/sqlite3.c"
   HEAP8[$26>>0] = $24; //@line 29716 "c/sqlite3.c"
   $27 = (($$018) + 2)|0; //@line 29715 "c/sqlite3.c"
   $28 = ($27|0)<($8|0); //@line 29715 "c/sqlite3.c"
   if ($28) {
    $$018 = $27;
   } else {
    break;
   }
  }
  $29 = $2 >>> 1; //@line 29718 "c/sqlite3.c"
  $$0$lcssa = $29;
 } else {
  $$0$lcssa = 0;
 }
 $30 = (($7) + ($$0$lcssa)|0); //@line 29718 "c/sqlite3.c"
 HEAP8[$30>>0] = 0; //@line 29718 "c/sqlite3.c"
 return ($7|0); //@line 29720 "c/sqlite3.c"
}
function _applyAffinity($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1<<24>>24)>(66); //@line 80183 "c/sqlite3.c"
 if (!($3)) {
  $13 = ($1<<24>>24)==(66); //@line 80193 "c/sqlite3.c"
  if (!($13)) {
   return; //@line 80206 "c/sqlite3.c"
  }
  $14 = ((($0)) + 8|0); //@line 80199 "c/sqlite3.c"
  $15 = HEAP16[$14>>1]|0; //@line 80199 "c/sqlite3.c"
  $16 = $15&65535; //@line 80199 "c/sqlite3.c"
  $17 = $16 & 2; //@line 80199 "c/sqlite3.c"
  $18 = ($17|0)!=(0); //@line 80199 "c/sqlite3.c"
  $19 = $16 & 12; //@line 80200 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 80200 "c/sqlite3.c"
  $or$cond = $18 | $20; //@line 80199 "c/sqlite3.c"
  if (!($or$cond)) {
   (_sqlite3VdbeMemStringify($0,$2,1)|0); //@line 80201 "c/sqlite3.c"
  }
  $21 = HEAP16[$14>>1]|0; //@line 80204 "c/sqlite3.c"
  $22 = $21 & -13; //@line 80204 "c/sqlite3.c"
  HEAP16[$14>>1] = $22; //@line 80204 "c/sqlite3.c"
  return; //@line 80206 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0); //@line 80186 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 80186 "c/sqlite3.c"
 $6 = $5&65535; //@line 80186 "c/sqlite3.c"
 $7 = $6 & 4; //@line 80186 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 80186 "c/sqlite3.c"
 if (!($8)) {
  return; //@line 80206 "c/sqlite3.c"
 }
 $9 = $6 & 8; //@line 80187 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 80187 "c/sqlite3.c"
 if (!($10)) {
  _sqlite3VdbeIntegerAffinity($0); //@line 80190 "c/sqlite3.c"
  return; //@line 80206 "c/sqlite3.c"
 }
 $11 = $6 & 2; //@line 80188 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 80188 "c/sqlite3.c"
 if ($12) {
  return; //@line 80206 "c/sqlite3.c"
 }
 _applyNumericAffinity($0,1); //@line 80188 "c/sqlite3.c"
 return; //@line 80206 "c/sqlite3.c"
}
function _sqlite3VdbeMemIntegerify($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3VdbeIntValue($0)|0); //@line 71757 "c/sqlite3.c"
 $2 = tempRet0; //@line 71757 "c/sqlite3.c"
 $3 = $0; //@line 71757 "c/sqlite3.c"
 $4 = $3; //@line 71757 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 71757 "c/sqlite3.c"
 $5 = (($3) + 4)|0; //@line 71757 "c/sqlite3.c"
 $6 = $5; //@line 71757 "c/sqlite3.c"
 HEAP32[$6>>2] = $2; //@line 71757 "c/sqlite3.c"
 $7 = ((($0)) + 8|0); //@line 71758 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 71758 "c/sqlite3.c"
 $9 = $8 & 15872; //@line 71758 "c/sqlite3.c"
 $10 = $9 | 4; //@line 71758 "c/sqlite3.c"
 HEAP16[$7>>1] = $10; //@line 71758 "c/sqlite3.c"
 return;
}
function _sqlite3VdbeMemRealify($0) {
 $0 = $0|0;
 var $1 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (+_sqlite3VdbeRealValue($0)); //@line 71770 "c/sqlite3.c"
 HEAPF64[$0>>3] = $1; //@line 71770 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 71771 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 71771 "c/sqlite3.c"
 $4 = $3 & 15872; //@line 71771 "c/sqlite3.c"
 $5 = $4 | 8; //@line 71771 "c/sqlite3.c"
 HEAP16[$2>>1] = $5; //@line 71771 "c/sqlite3.c"
 return;
}
function _sqlite3CheckObjectName($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 102416 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 102417 "c/sqlite3.c"
 $3 = ((($2)) + 157|0); //@line 102417 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 102417 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 102417 "c/sqlite3.c"
 if ($5) {
  $6 = ((($0)) + 18|0); //@line 102417 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 102417 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(0); //@line 102417 "c/sqlite3.c"
  if ($8) {
   $9 = ((($2)) + 28|0); //@line 102418 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 102418 "c/sqlite3.c"
   $11 = $10 & 1; //@line 102418 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 102418 "c/sqlite3.c"
   if ($12) {
    $13 = (_sqlite3_strnicmp($1,19990,7)|0); //@line 102419 "c/sqlite3.c"
    $14 = ($13|0)==(0); //@line 102419 "c/sqlite3.c"
    if ($14) {
     HEAP32[$vararg_buffer>>2] = $1; //@line 102420 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,24471,$vararg_buffer); //@line 102420 "c/sqlite3.c"
     $$0 = 1;
    } else {
     $$0 = 0;
    }
   } else {
    $$0 = 0;
   }
  } else {
   $$0 = 0;
  }
 } else {
  $$0 = 0;
 }
 STACKTOP = sp;return ($$0|0); //@line 102424 "c/sqlite3.c"
}
function _sqlite3ViewGetColumnNames($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$069 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 103773 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 103778 "c/sqlite3.c"
 $3 = ((($2)) + 48|0); //@line 103789 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 103789 "c/sqlite3.c"
 $5 = (($4) + 1)|0; //@line 103789 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 103789 "c/sqlite3.c"
 $6 = (_sqlite3VtabCallConnect($0,$1)|0); //@line 103790 "c/sqlite3.c"
 $7 = HEAP32[$3>>2]|0; //@line 103791 "c/sqlite3.c"
 $8 = (($7) + -1)|0; //@line 103791 "c/sqlite3.c"
 HEAP32[$3>>2] = $8; //@line 103791 "c/sqlite3.c"
 $9 = ($6|0)==(0); //@line 103792 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 103886 "c/sqlite3.c"
 }
 $10 = ((($1)) + 56|0); //@line 103795 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 103795 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 103795 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 103886 "c/sqlite3.c"
 }
 $13 = ((($1)) + 42|0); //@line 103802 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 103802 "c/sqlite3.c"
 $15 = ($14<<16>>16)>(0); //@line 103802 "c/sqlite3.c"
 if ($15) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 103886 "c/sqlite3.c"
 }
 $16 = ($14<<16>>16)<(0); //@line 103819 "c/sqlite3.c"
 if ($16) {
  $17 = HEAP32[$1>>2]|0; //@line 103820 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $17; //@line 103820 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,22855,$vararg_buffer); //@line 103820 "c/sqlite3.c"
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 103886 "c/sqlite3.c"
 }
 $18 = ((($1)) + 12|0); //@line 103833 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 103833 "c/sqlite3.c"
 $20 = (_sqlite3SelectDup($2,$19,0)|0); //@line 103833 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 103834 "c/sqlite3.c"
 if ($21) {
  $$1 = 1;
 } else {
  $22 = ((($0)) + 40|0); //@line 103835 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 103835 "c/sqlite3.c"
  $24 = ((($20)) + 28|0); //@line 103836 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 103836 "c/sqlite3.c"
  _sqlite3SrcListAssignCursors($0,$25); //@line 103836 "c/sqlite3.c"
  HEAP16[$13>>1] = -1; //@line 103837 "c/sqlite3.c"
  $26 = ((($2)) + 264|0); //@line 103838 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 103838 "c/sqlite3.c"
  $28 = (($27) + 1)|0; //@line 103838 "c/sqlite3.c"
  HEAP32[$26>>2] = $28; //@line 103838 "c/sqlite3.c"
  $29 = ((($2)) + 304|0); //@line 103840 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 103840 "c/sqlite3.c"
  HEAP32[$29>>2] = 0; //@line 103841 "c/sqlite3.c"
  $31 = (_sqlite3ResultSetOfSelect($0,$20)|0); //@line 103842 "c/sqlite3.c"
  HEAP32[$29>>2] = $30; //@line 103843 "c/sqlite3.c"
  HEAP32[$22>>2] = $23; //@line 103847 "c/sqlite3.c"
  $32 = ((($1)) + 24|0); //@line 103848 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 103848 "c/sqlite3.c"
  $34 = ($33|0)==(0|0); //@line 103848 "c/sqlite3.c"
  do {
   if ($34) {
    $47 = ($31|0)==(0|0); //@line 103863 "c/sqlite3.c"
    if ($47) {
     HEAP16[$13>>1] = 0; //@line 103874 "c/sqlite3.c"
     $$069 = 1;
     break;
    } else {
     $48 = ((($31)) + 42|0); //@line 103868 "c/sqlite3.c"
     $49 = HEAP16[$48>>1]|0; //@line 103868 "c/sqlite3.c"
     HEAP16[$13>>1] = $49; //@line 103868 "c/sqlite3.c"
     $50 = ((($31)) + 4|0); //@line 103869 "c/sqlite3.c"
     $51 = HEAP32[$50>>2]|0; //@line 103869 "c/sqlite3.c"
     $52 = ((($1)) + 4|0); //@line 103869 "c/sqlite3.c"
     HEAP32[$52>>2] = $51; //@line 103869 "c/sqlite3.c"
     HEAP16[$48>>1] = 0; //@line 103870 "c/sqlite3.c"
     HEAP32[$50>>2] = 0; //@line 103871 "c/sqlite3.c"
     $$069 = 0;
     break;
    }
   } else {
    $35 = ((($1)) + 4|0); //@line 103856 "c/sqlite3.c"
    _sqlite3ColumnsFromExprList($0,$33,$13,$35); //@line 103855 "c/sqlite3.c"
    $36 = ((($2)) + 73|0); //@line 103857 "c/sqlite3.c"
    $37 = HEAP8[$36>>0]|0; //@line 103857 "c/sqlite3.c"
    $38 = ($37<<24>>24)==(0); //@line 103857 "c/sqlite3.c"
    if ($38) {
     $39 = ((($0)) + 36|0); //@line 103858 "c/sqlite3.c"
     $40 = HEAP32[$39>>2]|0; //@line 103858 "c/sqlite3.c"
     $41 = ($40|0)==(0); //@line 103858 "c/sqlite3.c"
     if ($41) {
      $42 = HEAP16[$13>>1]|0; //@line 103859 "c/sqlite3.c"
      $43 = $42 << 16 >> 16; //@line 103859 "c/sqlite3.c"
      $44 = HEAP32[$20>>2]|0; //@line 103859 "c/sqlite3.c"
      $45 = HEAP32[$44>>2]|0; //@line 103859 "c/sqlite3.c"
      $46 = ($45|0)==($43|0); //@line 103859 "c/sqlite3.c"
      if ($46) {
       _sqlite3SelectAddColumnTypeAndCollation($0,$1,$20); //@line 103861 "c/sqlite3.c"
       $$069 = 0;
      } else {
       $$069 = 0;
      }
     } else {
      $$069 = 0;
     }
    } else {
     $$069 = 0;
    }
   }
  } while(0);
  _sqlite3DeleteTable($2,$31); //@line 103877 "c/sqlite3.c"
  _sqlite3SelectDelete($2,$20); //@line 103878 "c/sqlite3.c"
  $53 = HEAP32[$26>>2]|0; //@line 103879 "c/sqlite3.c"
  $54 = (($53) + -1)|0; //@line 103879 "c/sqlite3.c"
  HEAP32[$26>>2] = $54; //@line 103879 "c/sqlite3.c"
  $$1 = $$069;
 }
 $55 = ((($1)) + 72|0); //@line 103883 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 103883 "c/sqlite3.c"
 $57 = ((($56)) + 78|0); //@line 103883 "c/sqlite3.c"
 $58 = HEAP16[$57>>1]|0; //@line 103883 "c/sqlite3.c"
 $59 = $58 | 2; //@line 103883 "c/sqlite3.c"
 HEAP16[$57>>1] = $59; //@line 103883 "c/sqlite3.c"
 $$0 = $$1;
 STACKTOP = sp;return ($$0|0); //@line 103886 "c/sqlite3.c"
}
function _sqlite3GetVTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$lcssa = 0, $$07 = 0, $$08 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 64|0); //@line 127506 "c/sqlite3.c"
 $$07 = HEAP32[$2>>2]|0;
 $3 = ($$07|0)==(0|0); //@line 127506 "c/sqlite3.c"
 L1: do {
  if ($3) {
   $$0$lcssa = 0;
  } else {
   $$08 = $$07;
   while(1) {
    $4 = HEAP32[$$08>>2]|0; //@line 127506 "c/sqlite3.c"
    $5 = ($4|0)==($0|0); //@line 127506 "c/sqlite3.c"
    if ($5) {
     $$0$lcssa = $$08;
     break L1;
    }
    $6 = ((($$08)) + 24|0); //@line 127506 "c/sqlite3.c"
    $$0 = HEAP32[$6>>2]|0;
    $7 = ($$0|0)==(0|0); //@line 127506 "c/sqlite3.c"
    if ($7) {
     $$0$lcssa = 0;
     break;
    } else {
     $$08 = $$0;
    }
   }
  }
 } while(0);
 return ($$0$lcssa|0); //@line 127507 "c/sqlite3.c"
}
function _sqlite3MayAbort($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 120|0); //@line 105751 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 105751 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 105751 "c/sqlite3.c"
 $spec$select = $3 ? $0 : $2; //@line 105751 "c/sqlite3.c"
 $4 = ((($spec$select)) + 21|0); //@line 105752 "c/sqlite3.c"
 HEAP8[$4>>0] = 1; //@line 105752 "c/sqlite3.c"
 return; //@line 105753 "c/sqlite3.c"
}
function _whereForeignKeys($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$01011 = 0, $$012 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3FkReferences($1)|0); //@line 98300 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 98300 "c/sqlite3.c"
 if ($3) {
  $$0$lcssa = 0;
  return ($$0$lcssa|0); //@line 98303 "c/sqlite3.c"
 }
 $$01011 = $2;$$012 = 0;
 while(1) {
  $4 = HEAP32[$0>>2]|0; //@line 98301 "c/sqlite3.c"
  $5 = HEAP32[$$01011>>2]|0; //@line 98301 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 98301 "c/sqlite3.c"
  $7 = (_whereOrName($4,$$012,$6)|0); //@line 98301 "c/sqlite3.c"
  $8 = ((($$01011)) + 12|0); //@line 98300 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 98300 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 98300 "c/sqlite3.c"
  if ($10) {
   $$0$lcssa = $7;
   break;
  } else {
   $$01011 = $9;$$012 = $7;
  }
 }
 return ($$0$lcssa|0); //@line 98303 "c/sqlite3.c"
}
function _sqlite3FkReferences($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 72|0); //@line 110079 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 110079 "c/sqlite3.c"
 $3 = ((($2)) + 56|0); //@line 110079 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 110079 "c/sqlite3.c"
 $5 = (_sqlite3HashFind($3,$4)|0); //@line 110079 "c/sqlite3.c"
 return ($5|0); //@line 110079 "c/sqlite3.c"
}
function _sqlite3VtabCallConnect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 12|0;
 $3 = HEAP32[$0>>2]|0; //@line 127986 "c/sqlite3.c"
 $4 = ((($1)) + 56|0); //@line 127992 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 127992 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 127992 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 128015 "c/sqlite3.c"
 }
 $7 = (_sqlite3GetVTable($3,$1)|0); //@line 127992 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 127992 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 128015 "c/sqlite3.c"
 }
 $9 = ((($1)) + 60|0); //@line 127997 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 127997 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 127997 "c/sqlite3.c"
 $12 = ((($3)) + 328|0); //@line 127998 "c/sqlite3.c"
 $13 = (_sqlite3HashFind($12,$11)|0); //@line 127998 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 128000 "c/sqlite3.c"
 if ($14) {
  $15 = HEAP32[$9>>2]|0; //@line 128001 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 128001 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $16; //@line 128002 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,24452,$vararg_buffer); //@line 128002 "c/sqlite3.c"
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 128015 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = 0; //@line 128005 "c/sqlite3.c"
 $17 = HEAP32[$13>>2]|0; //@line 128006 "c/sqlite3.c"
 $18 = ((($17)) + 8|0); //@line 128006 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 128006 "c/sqlite3.c"
 $20 = (_vtabCallConstructor($3,$1,$13,$19,$2)|0); //@line 128006 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 128007 "c/sqlite3.c"
 if (!($21)) {
  $22 = HEAP32[$2>>2]|0; //@line 128008 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = $22; //@line 128008 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,15687,$vararg_buffer1); //@line 128008 "c/sqlite3.c"
  $23 = ((($0)) + 12|0); //@line 128009 "c/sqlite3.c"
  HEAP32[$23>>2] = $20; //@line 128009 "c/sqlite3.c"
 }
 $24 = HEAP32[$2>>2]|0; //@line 128011 "c/sqlite3.c"
 _sqlite3DbFree($3,$24); //@line 128011 "c/sqlite3.c"
 $$0 = $20;
 STACKTOP = sp;return ($$0|0); //@line 128015 "c/sqlite3.c"
}
function _sqlite3SelectDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$$0$ = 0, $$06071 = 0, $$06170 = 0, $$06269 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 HEAP32[$3>>2] = 0; //@line 94132 "c/sqlite3.c"
 $4 = ($1|0)==(0|0); //@line 94138 "c/sqlite3.c"
 if ($4) {
  $$0$$0$ = HEAP32[$3>>2]|0; //@line 94164 "c/sqlite3.c"
  STACKTOP = sp;return ($$0$$0$|0); //@line 94164 "c/sqlite3.c"
 }
 $$06071 = 0;$$06170 = $1;$$06269 = $3;
 while(1) {
  $5 = (_sqlite3DbMallocRawNN($0,64,0)|0); //@line 94139 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 94140 "c/sqlite3.c"
  if ($6) {
   label = 5;
   break;
  }
  $7 = HEAP32[$$06170>>2]|0; //@line 94141 "c/sqlite3.c"
  $8 = (_sqlite3ExprListDup($0,$7,$2)|0); //@line 94141 "c/sqlite3.c"
  HEAP32[$5>>2] = $8; //@line 94141 "c/sqlite3.c"
  $9 = ((($$06170)) + 28|0); //@line 94142 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 94142 "c/sqlite3.c"
  $11 = (_sqlite3SrcListDup($0,$10,$2)|0); //@line 94142 "c/sqlite3.c"
  $12 = ((($5)) + 28|0); //@line 94142 "c/sqlite3.c"
  HEAP32[$12>>2] = $11; //@line 94142 "c/sqlite3.c"
  $13 = ((($$06170)) + 32|0); //@line 94143 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 94143 "c/sqlite3.c"
  $15 = (_sqlite3ExprDup($0,$14,$2)|0); //@line 94143 "c/sqlite3.c"
  $16 = ((($5)) + 32|0); //@line 94143 "c/sqlite3.c"
  HEAP32[$16>>2] = $15; //@line 94143 "c/sqlite3.c"
  $17 = ((($$06170)) + 36|0); //@line 94144 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 94144 "c/sqlite3.c"
  $19 = (_sqlite3ExprListDup($0,$18,$2)|0); //@line 94144 "c/sqlite3.c"
  $20 = ((($5)) + 36|0); //@line 94144 "c/sqlite3.c"
  HEAP32[$20>>2] = $19; //@line 94144 "c/sqlite3.c"
  $21 = ((($$06170)) + 40|0); //@line 94145 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 94145 "c/sqlite3.c"
  $23 = (_sqlite3ExprDup($0,$22,$2)|0); //@line 94145 "c/sqlite3.c"
  $24 = ((($5)) + 40|0); //@line 94145 "c/sqlite3.c"
  HEAP32[$24>>2] = $23; //@line 94145 "c/sqlite3.c"
  $25 = ((($$06170)) + 44|0); //@line 94146 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 94146 "c/sqlite3.c"
  $27 = (_sqlite3ExprListDup($0,$26,$2)|0); //@line 94146 "c/sqlite3.c"
  $28 = ((($5)) + 44|0); //@line 94146 "c/sqlite3.c"
  HEAP32[$28>>2] = $27; //@line 94146 "c/sqlite3.c"
  $29 = ((($$06170)) + 4|0); //@line 94147 "c/sqlite3.c"
  $30 = HEAP8[$29>>0]|0; //@line 94147 "c/sqlite3.c"
  $31 = ((($5)) + 4|0); //@line 94147 "c/sqlite3.c"
  HEAP8[$31>>0] = $30; //@line 94147 "c/sqlite3.c"
  $32 = ((($5)) + 52|0); //@line 94148 "c/sqlite3.c"
  HEAP32[$32>>2] = $$06071; //@line 94148 "c/sqlite3.c"
  $33 = ((($5)) + 48|0); //@line 94149 "c/sqlite3.c"
  HEAP32[$33>>2] = 0; //@line 94149 "c/sqlite3.c"
  $34 = ((($$06170)) + 56|0); //@line 94150 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 94150 "c/sqlite3.c"
  $36 = (_sqlite3ExprDup($0,$35,$2)|0); //@line 94150 "c/sqlite3.c"
  $37 = ((($5)) + 56|0); //@line 94150 "c/sqlite3.c"
  HEAP32[$37>>2] = $36; //@line 94150 "c/sqlite3.c"
  $38 = ((($5)) + 12|0); //@line 94151 "c/sqlite3.c"
  HEAP32[$38>>2] = 0; //@line 94151 "c/sqlite3.c"
  $39 = ((($5)) + 16|0); //@line 94152 "c/sqlite3.c"
  HEAP32[$39>>2] = 0; //@line 94152 "c/sqlite3.c"
  $40 = ((($$06170)) + 8|0); //@line 94153 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 94153 "c/sqlite3.c"
  $42 = $41 & -33; //@line 94153 "c/sqlite3.c"
  $43 = ((($5)) + 8|0); //@line 94153 "c/sqlite3.c"
  HEAP32[$43>>2] = $42; //@line 94153 "c/sqlite3.c"
  $44 = ((($5)) + 20|0); //@line 94154 "c/sqlite3.c"
  HEAP32[$44>>2] = -1; //@line 94154 "c/sqlite3.c"
  $45 = ((($5)) + 24|0); //@line 94155 "c/sqlite3.c"
  HEAP32[$45>>2] = -1; //@line 94155 "c/sqlite3.c"
  $46 = ((($$06170)) + 6|0); //@line 94156 "c/sqlite3.c"
  $47 = HEAP16[$46>>1]|0; //@line 94156 "c/sqlite3.c"
  $48 = ((($5)) + 6|0); //@line 94156 "c/sqlite3.c"
  HEAP16[$48>>1] = $47; //@line 94156 "c/sqlite3.c"
  $49 = ((($$06170)) + 60|0); //@line 94157 "c/sqlite3.c"
  $50 = HEAP32[$49>>2]|0; //@line 94157 "c/sqlite3.c"
  $51 = (_withDup($0,$50)|0); //@line 94157 "c/sqlite3.c"
  $52 = ((($5)) + 60|0); //@line 94157 "c/sqlite3.c"
  HEAP32[$52>>2] = $51; //@line 94157 "c/sqlite3.c"
  HEAP32[$$06269>>2] = $5; //@line 94159 "c/sqlite3.c"
  $53 = ((($$06170)) + 48|0); //@line 94138 "c/sqlite3.c"
  $54 = HEAP32[$53>>2]|0; //@line 94138 "c/sqlite3.c"
  $55 = ($54|0)==(0|0); //@line 94138 "c/sqlite3.c"
  if ($55) {
   label = 5;
   break;
  } else {
   $$06071 = $5;$$06170 = $54;$$06269 = $33;
  }
 }
 if ((label|0) == 5) {
  $$0$$0$ = HEAP32[$3>>2]|0; //@line 94164 "c/sqlite3.c"
  STACKTOP = sp;return ($$0$$0$|0); //@line 94164 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3SrcListAssignCursors($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01415 = 0, $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 105410 "c/sqlite3.c"
 if ($2) {
  return; //@line 105419 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 105411 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 105411 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 105419 "c/sqlite3.c"
 }
 $5 = ((($1)) + 8|0); //@line 105411 "c/sqlite3.c"
 $6 = ((($0)) + 40|0);
 $$01415 = 0;$$016 = $5;
 while(1) {
  $7 = ((($$016)) + 44|0); //@line 105412 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 105412 "c/sqlite3.c"
  $9 = ($8|0)>(-1); //@line 105412 "c/sqlite3.c"
  if ($9) {
   label = 8;
   break;
  }
  $10 = HEAP32[$6>>2]|0; //@line 105413 "c/sqlite3.c"
  $11 = (($10) + 1)|0; //@line 105413 "c/sqlite3.c"
  HEAP32[$6>>2] = $11; //@line 105413 "c/sqlite3.c"
  HEAP32[$7>>2] = $10; //@line 105413 "c/sqlite3.c"
  $12 = ((($$016)) + 20|0); //@line 105414 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 105414 "c/sqlite3.c"
  $14 = ($13|0)==(0|0); //@line 105414 "c/sqlite3.c"
  if (!($14)) {
   $15 = ((($13)) + 28|0); //@line 105415 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 105415 "c/sqlite3.c"
   _sqlite3SrcListAssignCursors($0,$16); //@line 105415 "c/sqlite3.c"
  }
  $17 = (($$01415) + 1)|0; //@line 105411 "c/sqlite3.c"
  $18 = ((($$016)) + 72|0); //@line 105411 "c/sqlite3.c"
  $19 = HEAP32[$1>>2]|0; //@line 105411 "c/sqlite3.c"
  $20 = ($17|0)<($19|0); //@line 105411 "c/sqlite3.c"
  if ($20) {
   $$01415 = $17;$$016 = $18;
  } else {
   label = 8;
   break;
  }
 }
 if ((label|0) == 8) {
  return; //@line 105419 "c/sqlite3.c"
 }
}
function _sqlite3ResultSetOfSelect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$033 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 120509 "c/sqlite3.c"
 $3 = ((($2)) + 28|0); //@line 120512 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 120512 "c/sqlite3.c"
 $5 = $4 & -69; //@line 120513 "c/sqlite3.c"
 $6 = $5 | 64; //@line 120514 "c/sqlite3.c"
 HEAP32[$3>>2] = $6; //@line 120514 "c/sqlite3.c"
 _sqlite3SelectPrep($0,$1,0); //@line 120515 "c/sqlite3.c"
 $7 = ((($0)) + 36|0); //@line 120516 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 120516 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 120516 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 0;
  return ($$0|0); //@line 120537 "c/sqlite3.c"
 }
 $$033 = $1;
 while(1) {
  $10 = ((($$033)) + 48|0); //@line 120517 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 120517 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 120517 "c/sqlite3.c"
  if ($12) {
   break;
  } else {
   $$033 = $11;
  }
 }
 HEAP32[$3>>2] = $4; //@line 120518 "c/sqlite3.c"
 $13 = (_sqlite3DbMallocZero($2,80,0)|0); //@line 120519 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 120520 "c/sqlite3.c"
 if ($14) {
  $$0 = 0;
  return ($$0|0); //@line 120537 "c/sqlite3.c"
 }
 $15 = ((($13)) + 32|0); //@line 120526 "c/sqlite3.c"
 HEAP32[$15>>2] = 1; //@line 120526 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 120527 "c/sqlite3.c"
 $16 = ((($13)) + 44|0); //@line 120528 "c/sqlite3.c"
 HEAP16[$16>>1] = 200; //@line 120528 "c/sqlite3.c"
 $17 = HEAP32[$$033>>2]|0; //@line 120529 "c/sqlite3.c"
 $18 = ((($13)) + 42|0); //@line 120529 "c/sqlite3.c"
 $19 = ((($13)) + 4|0); //@line 120529 "c/sqlite3.c"
 _sqlite3ColumnsFromExprList($0,$17,$18,$19); //@line 120529 "c/sqlite3.c"
 _sqlite3SelectAddColumnTypeAndCollation($0,$13,$$033); //@line 120530 "c/sqlite3.c"
 $20 = ((($13)) + 40|0); //@line 120531 "c/sqlite3.c"
 HEAP16[$20>>1] = -1; //@line 120531 "c/sqlite3.c"
 $21 = ((($2)) + 73|0); //@line 120532 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 120532 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(0); //@line 120532 "c/sqlite3.c"
 if ($23) {
  $$0 = $13;
  return ($$0|0); //@line 120537 "c/sqlite3.c"
 }
 _sqlite3DeleteTable($2,$13); //@line 120533 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 120537 "c/sqlite3.c"
}
function _sqlite3ColumnsFromExprList($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$089 = 0, $$090 = 0, $$091 = 0, $$09336 = 0, $$09423 = 0, $$09534 = 0, $$096 = 0, $$096$lcssa = 0, $$09610 = 0, $$09611 = 0, $$098$lcssa = 0, $$09820 = 0, $$1 = 0, $$1$in = 0, $$15 = 0, $$1979 = 0, $$2 = 0, $$316 = 0, $10 = 0, $11 = 0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $8 = 0, $9 = 0, $exitcond = 0, $spec$select3 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_ptr4 = 0, $vararg_ptr5 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $4 = sp + 40|0;
 $5 = sp + 24|0;
 $6 = HEAP32[$0>>2]|0; //@line 120359 "c/sqlite3.c"
 _sqlite3HashInit($5); //@line 120368 "c/sqlite3.c"
 $7 = ($1|0)==(0|0); //@line 120369 "c/sqlite3.c"
 L1: do {
  if ($7) {
   HEAP16[$2>>1] = 0; //@line 120379 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 120380 "c/sqlite3.c"
   $$09534 = 0;$$098$lcssa = 0;$78 = 0;
  } else {
   $8 = HEAP32[$1>>2]|0; //@line 120370 "c/sqlite3.c"
   $9 = $8 << 4; //@line 120371 "c/sqlite3.c"
   $10 = (_sqlite3DbMallocZero($6,$9,0)|0); //@line 120371 "c/sqlite3.c"
   $11 = ($8|0)<(32767); //@line 120373 "c/sqlite3.c"
   if ($11) {
    $12 = $8&65535; //@line 120379 "c/sqlite3.c"
    HEAP16[$2>>1] = $12; //@line 120379 "c/sqlite3.c"
    HEAP32[$3>>2] = $10; //@line 120380 "c/sqlite3.c"
    $13 = ($8|0)>(0); //@line 120382 "c/sqlite3.c"
    if ($13) {
     $$09336 = $8;
    } else {
     $$09534 = $10;$$098$lcssa = 0;$78 = $10;
     break;
    }
   } else {
    HEAP16[$2>>1] = 32767; //@line 120379 "c/sqlite3.c"
    HEAP32[$3>>2] = $10; //@line 120380 "c/sqlite3.c"
    $$09336 = 32767;
   }
   $14 = ((($6)) + 73|0); //@line 120382 "c/sqlite3.c"
   $$09423 = $10;$$09820 = 0;
   while(1) {
    $15 = HEAP8[$14>>0]|0; //@line 120382 "c/sqlite3.c"
    $16 = ($15<<24>>24)==(0); //@line 120382 "c/sqlite3.c"
    if (!($16)) {
     $$09534 = $10;$$098$lcssa = $$09820;$78 = $10;
     break L1;
    }
    $17 = (((((($1)) + 4|0) + (($$09820*20)|0)|0)) + 4|0); //@line 120385 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 120385 "c/sqlite3.c"
    $19 = ($18|0)==(0|0); //@line 120385 "c/sqlite3.c"
    do {
     if ($19) {
      $20 = (((($1)) + 4|0) + (($$09820*20)|0)|0); //@line 120388 "c/sqlite3.c"
      $21 = HEAP32[$20>>2]|0; //@line 120388 "c/sqlite3.c"
      $22 = (_sqlite3ExprSkipCollate($21)|0); //@line 120388 "c/sqlite3.c"
      $$090 = $22;
      L13: while(1) {
       $23 = HEAP8[$$090>>0]|0; //@line 120389 "c/sqlite3.c"
       switch ($23<<24>>24) {
       case -111:  {
        label = 12;
        break L13;
        break;
       }
       case 59:  {
        label = 16;
        break L13;
        break;
       }
       case 122:  {
        break;
       }
       default: {
        label = 17;
        break L13;
       }
       }
       $24 = ((($$090)) + 16|0); //@line 120390 "c/sqlite3.c"
       $25 = HEAP32[$24>>2]|0; //@line 120390 "c/sqlite3.c"
       $$090 = $25;
      }
      if ((label|0) == 12) {
       label = 0;
       $26 = ((($$090)) + 32|0); //@line 120396 "c/sqlite3.c"
       $27 = HEAP16[$26>>1]|0; //@line 120396 "c/sqlite3.c"
       $28 = $27 << 16 >> 16; //@line 120396 "c/sqlite3.c"
       $29 = ((($$090)) + 44|0); //@line 120397 "c/sqlite3.c"
       $30 = HEAP32[$29>>2]|0; //@line 120397 "c/sqlite3.c"
       $31 = ($27<<16>>16)<(0); //@line 120399 "c/sqlite3.c"
       if ($31) {
        $32 = ((($30)) + 40|0); //@line 120399 "c/sqlite3.c"
        $33 = HEAP16[$32>>1]|0; //@line 120399 "c/sqlite3.c"
        $34 = $33 << 16 >> 16; //@line 120399 "c/sqlite3.c"
        $$089 = $34;
       } else {
        $$089 = $28;
       }
       $35 = ($$089|0)>(-1); //@line 120400 "c/sqlite3.c"
       if (!($35)) {
        $$15 = 19225;
        label = 19;
        break;
       }
       $36 = ((($30)) + 4|0); //@line 120400 "c/sqlite3.c"
       $37 = HEAP32[$36>>2]|0; //@line 120400 "c/sqlite3.c"
       $38 = (($37) + ($$089<<4)|0); //@line 120400 "c/sqlite3.c"
       $$1$in = $38;
      }
      else if ((label|0) == 16) {
       label = 0;
       $39 = ((($$090)) + 8|0); //@line 120403 "c/sqlite3.c"
       $$1$in = $39;
      }
      else if ((label|0) == 17) {
       label = 0;
       $40 = (((((($1)) + 4|0) + (($$09820*20)|0)|0)) + 8|0); //@line 120406 "c/sqlite3.c"
       $$1$in = $40;
      }
      $$1 = HEAP32[$$1$in>>2]|0;
      $41 = ($$1|0)==(0|0); //@line 120409 "c/sqlite3.c"
      if ($41) {
       $43 = (($$09820) + 1)|0; //@line 120412 "c/sqlite3.c"
       HEAP32[$vararg_buffer>>2] = $43; //@line 120412 "c/sqlite3.c"
       $44 = (_sqlite3MPrintf($6,22893,$vararg_buffer)|0); //@line 120412 "c/sqlite3.c"
       $$2 = $44;
      } else {
       $$15 = $$1;
       label = 19;
      }
     } else {
      $$15 = $18;
      label = 19;
     }
    } while(0);
    if ((label|0) == 19) {
     label = 0;
     $42 = (_sqlite3DbStrDup($6,$$15)|0); //@line 120410 "c/sqlite3.c"
     $$2 = $42;
    }
    HEAP32[$4>>2] = 0; //@line 120418 "c/sqlite3.c"
    $45 = ($$2|0)==(0|0); //@line 120419 "c/sqlite3.c"
    L29: do {
     if ($45) {
      label = 35;
     } else {
      $$316 = $$2;
      while(1) {
       $46 = (_sqlite3HashFind($5,$$316)|0); //@line 120419 "c/sqlite3.c"
       $47 = ($46|0)==(0|0); //@line 120419 "c/sqlite3.c"
       if ($47) {
        break;
       }
       $48 = (_sqlite3Strlen30($$316)|0); //@line 120420 "c/sqlite3.c"
       $49 = ($48|0)>(0); //@line 120421 "c/sqlite3.c"
       if ($49) {
        $50 = ($48|0)==(1); //@line 120422 "c/sqlite3.c"
        L36: do {
         if ($50) {
          $$096$lcssa = 0;
         } else {
          $$09610 = (($48) + -1)|0;
          $$09611 = $$09610;
          while(1) {
           $52 = (($$316) + ($$09611)|0); //@line 120422 "c/sqlite3.c"
           $53 = HEAP8[$52>>0]|0; //@line 120422 "c/sqlite3.c"
           $54 = $53&255; //@line 120422 "c/sqlite3.c"
           $55 = (($54) + -48)|0; //@line 120422 "c/sqlite3.c"
           $56 = ($55>>>0)<(10); //@line 120422 "c/sqlite3.c"
           if (!($56)) {
            $$096$lcssa = $$09611;
            break L36;
           }
           $$096 = (($$09611) + -1)|0;
           $51 = ($$09611|0)>(1); //@line 120422 "c/sqlite3.c"
           if ($51) {
            $$09611 = $$096;
           } else {
            $$096$lcssa = $$096;
            break;
           }
          }
         }
        } while(0);
        $57 = (($$316) + ($$096$lcssa)|0); //@line 120423 "c/sqlite3.c"
        $58 = HEAP8[$57>>0]|0; //@line 120423 "c/sqlite3.c"
        $59 = ($58<<24>>24)==(58); //@line 120423 "c/sqlite3.c"
        $spec$select3 = $59 ? $$096$lcssa : $48; //@line 120423 "c/sqlite3.c"
        $$091 = $spec$select3;
       } else {
        $$091 = $48;
       }
       $60 = HEAP32[$4>>2]|0; //@line 120425 "c/sqlite3.c"
       $61 = (($60) + 1)|0; //@line 120425 "c/sqlite3.c"
       HEAP32[$4>>2] = $61; //@line 120425 "c/sqlite3.c"
       HEAP32[$vararg_buffer1>>2] = $$091; //@line 120425 "c/sqlite3.c"
       $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 120425 "c/sqlite3.c"
       HEAP32[$vararg_ptr4>>2] = $$316; //@line 120425 "c/sqlite3.c"
       $vararg_ptr5 = ((($vararg_buffer1)) + 8|0); //@line 120425 "c/sqlite3.c"
       HEAP32[$vararg_ptr5>>2] = $61; //@line 120425 "c/sqlite3.c"
       $62 = (_sqlite3MPrintf($6,22902,$vararg_buffer1)|0); //@line 120425 "c/sqlite3.c"
       $63 = HEAP32[$4>>2]|0; //@line 120426 "c/sqlite3.c"
       $64 = ($63>>>0)>(3); //@line 120426 "c/sqlite3.c"
       if ($64) {
        _sqlite3_randomness(4,$4); //@line 120426 "c/sqlite3.c"
       }
       $65 = ($62|0)==(0|0); //@line 120419 "c/sqlite3.c"
       if ($65) {
        label = 35;
        break L29;
       } else {
        $$316 = $62;
       }
      }
      HEAP32[$$09423>>2] = $$316; //@line 120428 "c/sqlite3.c"
      $66 = (_sqlite3HashInsert($5,$$316,$$09423)|0); //@line 120430 "c/sqlite3.c"
      $67 = ($66|0)==($$09423|0); //@line 120430 "c/sqlite3.c"
      if ($67) {
       _sqlite3OomFault($6); //@line 120431 "c/sqlite3.c"
      }
     }
    } while(0);
    if ((label|0) == 35) {
     label = 0;
     HEAP32[$$09423>>2] = 0; //@line 120428 "c/sqlite3.c"
    }
    $68 = (($$09820) + 1)|0; //@line 120382 "c/sqlite3.c"
    $69 = ((($$09423)) + 16|0); //@line 120382 "c/sqlite3.c"
    $70 = ($68|0)<($$09336|0); //@line 120382 "c/sqlite3.c"
    if ($70) {
     $$09423 = $69;$$09820 = $68;
    } else {
     $$09534 = $10;$$098$lcssa = $68;$78 = $10;
     break;
    }
   }
  }
 } while(0);
 _sqlite3HashClear($5); //@line 120434 "c/sqlite3.c"
 $71 = ((($6)) + 73|0); //@line 120435 "c/sqlite3.c"
 $72 = HEAP8[$71>>0]|0; //@line 120435 "c/sqlite3.c"
 $73 = ($72<<24>>24)==(0); //@line 120435 "c/sqlite3.c"
 if ($73) {
  STACKTOP = sp;return;
 }
 $74 = ($$098$lcssa|0)==(0); //@line 120436 "c/sqlite3.c"
 if (!($74)) {
  $$1979 = 0;
  while(1) {
   $75 = (($$09534) + ($$1979<<4)|0); //@line 120437 "c/sqlite3.c"
   $76 = HEAP32[$75>>2]|0; //@line 120437 "c/sqlite3.c"
   _sqlite3DbFree($6,$76); //@line 120437 "c/sqlite3.c"
   $77 = (($$1979) + 1)|0; //@line 120436 "c/sqlite3.c"
   $exitcond = ($77|0)==($$098$lcssa|0); //@line 120436 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$1979 = $77;
   }
  }
 }
 _sqlite3DbFree($6,$78); //@line 120439 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 120440 "c/sqlite3.c"
 HEAP16[$2>>1] = 0; //@line 120441 "c/sqlite3.c"
 STACKTOP = sp;return;
}
function _sqlite3SelectAddColumnTypeAndCollation($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$05455 = 0, $$056 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = HEAP32[$0>>2]|0; //@line 120463 "c/sqlite3.c"
 $5 = ((($4)) + 73|0); //@line 120474 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 120474 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 120474 "c/sqlite3.c"
 if (!($7)) {
  STACKTOP = sp;return; //@line 120501 "c/sqlite3.c"
 }
 ;HEAP32[$3>>2]=0|0;HEAP32[$3+4>>2]=0|0;HEAP32[$3+8>>2]=0|0;HEAP32[$3+12>>2]=0|0;HEAP32[$3+16>>2]=0|0;HEAP32[$3+20>>2]=0|0;HEAP32[$3+24>>2]=0|0;HEAP32[$3+28>>2]=0|0; //@line 120475 "c/sqlite3.c"
 $8 = ((($2)) + 28|0); //@line 120476 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 120476 "c/sqlite3.c"
 $10 = ((($3)) + 4|0); //@line 120476 "c/sqlite3.c"
 HEAP32[$10>>2] = $9; //@line 120476 "c/sqlite3.c"
 $11 = HEAP32[$2>>2]|0; //@line 120477 "c/sqlite3.c"
 $12 = ((($1)) + 42|0); //@line 120478 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 120478 "c/sqlite3.c"
 $14 = ($13<<16>>16)>(0); //@line 120478 "c/sqlite3.c"
 if ($14) {
  $15 = ((($1)) + 4|0); //@line 120478 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 120478 "c/sqlite3.c"
  $$05455 = 0;$$056 = $16;
  while(1) {
   $17 = (((($11)) + 4|0) + (($$05455*20)|0)|0); //@line 120481 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 120481 "c/sqlite3.c"
   $19 = (_columnTypeImpl($3,$18)|0); //@line 120482 "c/sqlite3.c"
   $20 = (_sqlite3ExprAffinity($18)|0); //@line 120484 "c/sqlite3.c"
   $21 = ((($$056)) + 13|0); //@line 120484 "c/sqlite3.c"
   HEAP8[$21>>0] = $20; //@line 120484 "c/sqlite3.c"
   $22 = ($19|0)==(0|0); //@line 120485 "c/sqlite3.c"
   if ($22) {
    $39 = $20;
   } else {
    $23 = (_sqlite3Strlen30($19)|0); //@line 120486 "c/sqlite3.c"
    $24 = HEAP32[$$056>>2]|0; //@line 120487 "c/sqlite3.c"
    $25 = (_sqlite3Strlen30($24)|0); //@line 120487 "c/sqlite3.c"
    $26 = (($23) + 2)|0; //@line 120488 "c/sqlite3.c"
    $27 = (($26) + ($25))|0; //@line 120488 "c/sqlite3.c"
    $28 = ($27|0)<(0); //@line 120488 "c/sqlite3.c"
    $29 = $28 << 31 >> 31; //@line 120488 "c/sqlite3.c"
    $30 = (_sqlite3DbReallocOrFree($4,$24,$27,$29)|0); //@line 120488 "c/sqlite3.c"
    HEAP32[$$056>>2] = $30; //@line 120488 "c/sqlite3.c"
    $31 = ($30|0)==(0|0); //@line 120489 "c/sqlite3.c"
    $32 = ((($$056)) + 15|0); //@line 120491 "c/sqlite3.c"
    if (!($31)) {
     $33 = (($23) + 1)|0; //@line 120490 "c/sqlite3.c"
     $34 = (($25) + 1)|0; //@line 120490 "c/sqlite3.c"
     $35 = (($30) + ($34)|0); //@line 120490 "c/sqlite3.c"
     _memcpy(($35|0),($19|0),($33|0))|0; //@line 120490 "c/sqlite3.c"
     $36 = HEAP8[$32>>0]|0; //@line 120491 "c/sqlite3.c"
     $37 = $36 | 4; //@line 120491 "c/sqlite3.c"
     HEAP8[$32>>0] = $37; //@line 120491 "c/sqlite3.c"
    }
    $$pr = HEAP8[$21>>0]|0; //@line 120494 "c/sqlite3.c"
    $39 = $$pr;
   }
   $38 = ($39<<24>>24)==(0); //@line 120494 "c/sqlite3.c"
   if ($38) {
    HEAP8[$21>>0] = 65; //@line 120494 "c/sqlite3.c"
   }
   $40 = (_sqlite3ExprCollSeq($0,$18)|0); //@line 120495 "c/sqlite3.c"
   $41 = ($40|0)==(0|0); //@line 120496 "c/sqlite3.c"
   if (!($41)) {
    $42 = ((($$056)) + 8|0); //@line 120496 "c/sqlite3.c"
    $43 = HEAP32[$42>>2]|0; //@line 120496 "c/sqlite3.c"
    $44 = ($43|0)==(0|0); //@line 120496 "c/sqlite3.c"
    if ($44) {
     $45 = HEAP32[$40>>2]|0; //@line 120497 "c/sqlite3.c"
     $46 = (_sqlite3DbStrDup($4,$45)|0); //@line 120497 "c/sqlite3.c"
     HEAP32[$42>>2] = $46; //@line 120497 "c/sqlite3.c"
    }
   }
   $47 = (($$05455) + 1)|0; //@line 120478 "c/sqlite3.c"
   $48 = ((($$056)) + 16|0); //@line 120478 "c/sqlite3.c"
   $49 = HEAP16[$12>>1]|0; //@line 120478 "c/sqlite3.c"
   $50 = $49 << 16 >> 16; //@line 120478 "c/sqlite3.c"
   $51 = ($47|0)<($50|0); //@line 120478 "c/sqlite3.c"
   if ($51) {
    $$05455 = $47;$$056 = $48;
   } else {
    break;
   }
  }
 }
 $52 = ((($1)) + 46|0); //@line 120500 "c/sqlite3.c"
 HEAP16[$52>>1] = 1; //@line 120500 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 120501 "c/sqlite3.c"
}
function _columnTypeImpl($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$05763 = 0, $$06064 = 0, $$066 = 0, $$1 = 0, $$159 = 0, $$161 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = HEAP8[$1>>0]|0; //@line 120072 "c/sqlite3.c"
 switch ($3<<24>>24) {
 case -111:  {
  $4 = ((($1)) + 32|0); //@line 120080 "c/sqlite3.c"
  $5 = HEAP16[$4>>1]|0; //@line 120080 "c/sqlite3.c"
  $6 = $5 << 16 >> 16; //@line 120080 "c/sqlite3.c"
  $7 = ($0|0)==(0|0); //@line 120081 "c/sqlite3.c"
  if ($7) {
   $$2 = 0;
   STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  }
  $8 = ((($1)) + 28|0);
  $$06064 = 0;$$066 = $0;
  while(1) {
   $9 = ((($$066)) + 4|0); //@line 120082 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 120082 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 120083 "c/sqlite3.c"
   $12 = ($11|0)>(0); //@line 120083 "c/sqlite3.c"
   L8: do {
    if ($12) {
     $13 = HEAP32[$8>>2]|0;
     $$05763 = 0;
     while(1) {
      $14 = (((((($10)) + 8|0) + (($$05763*72)|0)|0)) + 44|0); //@line 120083 "c/sqlite3.c"
      $15 = HEAP32[$14>>2]|0; //@line 120083 "c/sqlite3.c"
      $16 = ($15|0)==($13|0); //@line 120083 "c/sqlite3.c"
      if ($16) {
       break;
      }
      $17 = (($$05763) + 1)|0; //@line 120083 "c/sqlite3.c"
      $18 = HEAP32[$10>>2]|0; //@line 120083 "c/sqlite3.c"
      $19 = ($17|0)<($18|0); //@line 120083 "c/sqlite3.c"
      if ($19) {
       $$05763 = $17;
      } else {
       label = 9;
       break L8;
      }
     }
     $20 = (((((($10)) + 8|0) + (($$05763*72)|0)|0)) + 16|0); //@line 120085 "c/sqlite3.c"
     $21 = HEAP32[$20>>2]|0; //@line 120085 "c/sqlite3.c"
     $22 = (((((($10)) + 8|0) + (($$05763*72)|0)|0)) + 20|0); //@line 120086 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 120086 "c/sqlite3.c"
     $$1 = $$066;$$159 = $21;$$161 = $23;
    } else {
     label = 9;
    }
   } while(0);
   if ((label|0) == 9) {
    label = 0;
    $24 = ((($$066)) + 16|0); //@line 120088 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 120088 "c/sqlite3.c"
    $$1 = $25;$$159 = 0;$$161 = $$06064;
   }
   $26 = ($$1|0)!=(0|0); //@line 120081 "c/sqlite3.c"
   $27 = ($$159|0)==(0|0); //@line 120081 "c/sqlite3.c"
   $or$cond = $27 & $26; //@line 120081 "c/sqlite3.c"
   if ($or$cond) {
    $$06064 = $$161;$$066 = $$1;
   } else {
    break;
   }
  }
  if ($27) {
   $$2 = 0;
   STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  }
  $28 = ($$161|0)==(0|0); //@line 120114 "c/sqlite3.c"
  if ($28) {
   $41 = ($5<<16>>16)<(0); //@line 120151 "c/sqlite3.c"
   if ($41) {
    $$2 = 22885;
    STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
   }
   $42 = ((($$159)) + 4|0); //@line 120154 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 120154 "c/sqlite3.c"
   $44 = (($43) + ($6<<4)|0); //@line 120154 "c/sqlite3.c"
   $45 = (_sqlite3ColumnType($44,0)|0); //@line 120154 "c/sqlite3.c"
   $$2 = $45;
   STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  }
  $29 = ($5<<16>>16)>(-1); //@line 120119 "c/sqlite3.c"
  if (!($29)) {
   $$2 = 0;
   STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  }
  $30 = HEAP32[$$161>>2]|0; //@line 120119 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 120119 "c/sqlite3.c"
  $32 = ($31|0)>($6|0); //@line 120119 "c/sqlite3.c"
  if (!($32)) {
   $$2 = 0;
   STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  }
  $33 = (((($30)) + 4|0) + (($6*20)|0)|0); //@line 120125 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 120125 "c/sqlite3.c"
  $35 = ((($$161)) + 28|0); //@line 120126 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 120126 "c/sqlite3.c"
  $37 = ((($2)) + 4|0); //@line 120126 "c/sqlite3.c"
  HEAP32[$37>>2] = $36; //@line 120126 "c/sqlite3.c"
  $38 = ((($2)) + 16|0); //@line 120127 "c/sqlite3.c"
  HEAP32[$38>>2] = $$1; //@line 120127 "c/sqlite3.c"
  $39 = HEAP32[$$1>>2]|0; //@line 120128 "c/sqlite3.c"
  HEAP32[$2>>2] = $39; //@line 120128 "c/sqlite3.c"
  $40 = (_columnTypeImpl($2,$34)|0); //@line 120129 "c/sqlite3.c"
  $$2 = $40;
  STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  break;
 }
 case 119:  {
  $46 = ((($1)) + 20|0); //@line 120167 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 120167 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 120168 "c/sqlite3.c"
  $49 = ((($48)) + 4|0); //@line 120168 "c/sqlite3.c"
  $50 = HEAP32[$49>>2]|0; //@line 120168 "c/sqlite3.c"
  $51 = ((($47)) + 28|0); //@line 120170 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 120170 "c/sqlite3.c"
  $53 = ((($2)) + 4|0); //@line 120170 "c/sqlite3.c"
  HEAP32[$53>>2] = $52; //@line 120170 "c/sqlite3.c"
  $54 = ((($2)) + 16|0); //@line 120171 "c/sqlite3.c"
  HEAP32[$54>>2] = $0; //@line 120171 "c/sqlite3.c"
  $55 = HEAP32[$0>>2]|0; //@line 120172 "c/sqlite3.c"
  HEAP32[$2>>2] = $55; //@line 120172 "c/sqlite3.c"
  $56 = (_columnTypeImpl($2,$50)|0); //@line 120173 "c/sqlite3.c"
  $$2 = $56;
  STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
  break;
 }
 default: {
  $$2 = 0;
  STACKTOP = sp;return ($$2|0); //@line 120187 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3ExprAffinity($0) {
 $0 = $0|0;
 var $$0 = 0, $$019 = 0, $$tr$be = 0, $$tr$be$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ExprSkipCollate($0)|0); //@line 92734 "c/sqlite3.c"
 $2 = ((($1)) + 4|0); //@line 92735 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 92735 "c/sqlite3.c"
 $4 = $3 & 512; //@line 92735 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 92735 "c/sqlite3.c"
 if (!($5)) {
  $$019 = 0;
  return ($$019|0); //@line 92758 "c/sqlite3.c"
 }
 $7 = $1;
 while(1) {
  $6 = HEAP8[$7>>0]|0; //@line 92736 "c/sqlite3.c"
  $8 = ($6<<24>>24)==(119); //@line 92737 "c/sqlite3.c"
  if ($8) {
   $9 = ((($7)) + 20|0); //@line 92739 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 92739 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 92739 "c/sqlite3.c"
   $12 = ((($11)) + 4|0); //@line 92739 "c/sqlite3.c"
   $$tr$be$in = $12;
  } else {
   $18 = $6&255; //@line 92736 "c/sqlite3.c"
   $19 = ($6<<24>>24)==(-106); //@line 92741 "c/sqlite3.c"
   if ($19) {
    $20 = ((($7)) + 38|0); //@line 92741 "c/sqlite3.c"
    $21 = HEAP8[$20>>0]|0; //@line 92741 "c/sqlite3.c"
    $22 = $21&255; //@line 92741 "c/sqlite3.c"
    $$0 = $22;
   } else {
    $$0 = $18;
   }
   $23 = ($$0|0)==(36); //@line 92743 "c/sqlite3.c"
   if ($23) {
    label = 9;
    break;
   }
   $27 = $$0 | 2; //@line 92748 "c/sqlite3.c"
   $28 = ($27|0)==(147); //@line 92748 "c/sqlite3.c"
   if ($28) {
    $29 = ((($7)) + 44|0); //@line 92748 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 92748 "c/sqlite3.c"
    $31 = ($30|0)==(0|0); //@line 92748 "c/sqlite3.c"
    if (!($31)) {
     label = 12;
     break;
    }
   }
   $36 = ($$0|0)==(152); //@line 92751 "c/sqlite3.c"
   if (!($36)) {
    label = 15;
    break;
   }
   $37 = ((($7)) + 12|0); //@line 92754 "c/sqlite3.c"
   $38 = HEAP32[$37>>2]|0; //@line 92754 "c/sqlite3.c"
   $39 = ((($38)) + 20|0); //@line 92754 "c/sqlite3.c"
   $40 = HEAP32[$39>>2]|0; //@line 92754 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 92754 "c/sqlite3.c"
   $42 = ((($7)) + 32|0); //@line 92754 "c/sqlite3.c"
   $43 = HEAP16[$42>>1]|0; //@line 92754 "c/sqlite3.c"
   $44 = $43 << 16 >> 16; //@line 92754 "c/sqlite3.c"
   $45 = (((($41)) + 4|0) + (($44*20)|0)|0); //@line 92754 "c/sqlite3.c"
   $$tr$be$in = $45;
  }
  $$tr$be = HEAP32[$$tr$be$in>>2]|0;
  $13 = (_sqlite3ExprSkipCollate($$tr$be)|0); //@line 92734 "c/sqlite3.c"
  $14 = ((($13)) + 4|0); //@line 92735 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 92735 "c/sqlite3.c"
  $16 = $15 & 512; //@line 92735 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 92735 "c/sqlite3.c"
  if ($17) {
   $7 = $13;
  } else {
   $$019 = 0;
   label = 16;
   break;
  }
 }
 if ((label|0) == 9) {
  $24 = ((($7)) + 8|0); //@line 92745 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 92745 "c/sqlite3.c"
  $26 = (_sqlite3AffinityType($25,0)|0); //@line 92745 "c/sqlite3.c"
  $$019 = $26;
  return ($$019|0); //@line 92758 "c/sqlite3.c"
 }
 else if ((label|0) == 12) {
  $32 = ((($7)) + 32|0); //@line 92749 "c/sqlite3.c"
  $33 = HEAP16[$32>>1]|0; //@line 92749 "c/sqlite3.c"
  $34 = $33 << 16 >> 16; //@line 92749 "c/sqlite3.c"
  $35 = (_sqlite3TableColumnAffinity($30,$34)|0); //@line 92749 "c/sqlite3.c"
  $$019 = $35;
  return ($$019|0); //@line 92758 "c/sqlite3.c"
 }
 else if ((label|0) == 15) {
  $46 = ((($7)) + 1|0); //@line 92757 "c/sqlite3.c"
  $47 = HEAP8[$46>>0]|0; //@line 92757 "c/sqlite3.c"
  $$019 = $47;
  return ($$019|0); //@line 92758 "c/sqlite3.c"
 }
 else if ((label|0) == 16) {
  return ($$019|0); //@line 92758 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprSkipCollate($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $$04 = 0, $$1 = 0, $$1$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 92796 "c/sqlite3.c"
 if ($1) {
  $$0$lcssa = 0;
  return ($$0$lcssa|0); //@line 92807 "c/sqlite3.c"
 }
 $$04 = $0;
 while(1) {
  $2 = ((($$04)) + 4|0); //@line 92796 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 92796 "c/sqlite3.c"
  $4 = $3 & 4096; //@line 92796 "c/sqlite3.c"
  $5 = ($4|0)==(0); //@line 92796 "c/sqlite3.c"
  if ($5) {
   $$0$lcssa = $$04;
   label = 8;
   break;
  }
  $6 = $3 & 262144; //@line 92797 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 92797 "c/sqlite3.c"
  if ($7) {
   $11 = ((($$04)) + 12|0); //@line 92804 "c/sqlite3.c"
   $$1$in = $11;
  } else {
   $8 = ((($$04)) + 20|0); //@line 92801 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 92801 "c/sqlite3.c"
   $10 = ((($9)) + 4|0); //@line 92801 "c/sqlite3.c"
   $$1$in = $10;
  }
  $$1 = HEAP32[$$1$in>>2]|0;
  $12 = ($$1|0)==(0|0); //@line 92796 "c/sqlite3.c"
  if ($12) {
   $$0$lcssa = 0;
   label = 8;
   break;
  } else {
   $$04 = $$1;
  }
 }
 if ((label|0) == 8) {
  return ($$0$lcssa|0); //@line 92807 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3TableColumnAffinity($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(-1); //@line 92713 "c/sqlite3.c"
 if (!($2)) {
  $7 = 68;
  return ($7|0); //@line 92713 "c/sqlite3.c"
 }
 $3 = ((($0)) + 4|0); //@line 92713 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 92713 "c/sqlite3.c"
 $5 = (((($4) + ($1<<4)|0)) + 13|0); //@line 92713 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 92713 "c/sqlite3.c"
 $7 = $6;
 return ($7|0); //@line 92713 "c/sqlite3.c"
}
function _sqlite3SelectPrep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 123421 "c/sqlite3.c"
 $4 = ((($3)) + 73|0); //@line 123421 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 123421 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 123421 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 123428 "c/sqlite3.c"
 }
 $7 = ((($1)) + 8|0); //@line 123422 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 123422 "c/sqlite3.c"
 $9 = $8 & 128; //@line 123422 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 123422 "c/sqlite3.c"
 if (!($10)) {
  return; //@line 123428 "c/sqlite3.c"
 }
 _sqlite3SelectExpand($0,$1); //@line 123423 "c/sqlite3.c"
 $11 = ((($0)) + 36|0); //@line 123424 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 123424 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 123424 "c/sqlite3.c"
 if (!($13)) {
  return; //@line 123428 "c/sqlite3.c"
 }
 $14 = HEAP32[$0>>2]|0; //@line 123424 "c/sqlite3.c"
 $15 = ((($14)) + 73|0); //@line 123424 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 123424 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 123424 "c/sqlite3.c"
 if (!($17)) {
  return; //@line 123428 "c/sqlite3.c"
 }
 _sqlite3ResolveSelectNames($0,$1,$2); //@line 123425 "c/sqlite3.c"
 $18 = HEAP32[$11>>2]|0; //@line 123426 "c/sqlite3.c"
 $19 = ($18|0)==(0); //@line 123426 "c/sqlite3.c"
 if (!($19)) {
  return; //@line 123428 "c/sqlite3.c"
 }
 $20 = HEAP32[$0>>2]|0; //@line 123426 "c/sqlite3.c"
 $21 = ((($20)) + 73|0); //@line 123426 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 123426 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(0); //@line 123426 "c/sqlite3.c"
 if (!($23)) {
  return; //@line 123428 "c/sqlite3.c"
 }
 _sqlite3SelectAddTypeInfo($0,$1); //@line 123427 "c/sqlite3.c"
 return; //@line 123428 "c/sqlite3.c"
}
function _sqlite3SelectExpand($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = ((($2)) + 4|0); //@line 123330 "c/sqlite3.c"
 HEAP32[$3>>2] = 150; //@line 123330 "c/sqlite3.c"
 HEAP32[$2>>2] = $0; //@line 123331 "c/sqlite3.c"
 $4 = ((($0)) + 22|0); //@line 123332 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 123332 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 123332 "c/sqlite3.c"
 if (!($6)) {
  $7 = ((($2)) + 8|0); //@line 123333 "c/sqlite3.c"
  HEAP32[$7>>2] = 151; //@line 123333 "c/sqlite3.c"
  $8 = ((($2)) + 12|0); //@line 123334 "c/sqlite3.c"
  HEAP32[$8>>2] = 0; //@line 123334 "c/sqlite3.c"
  (_sqlite3WalkSelect($2,$1)|0); //@line 123335 "c/sqlite3.c"
 }
 $9 = ((($2)) + 8|0); //@line 123337 "c/sqlite3.c"
 HEAP32[$9>>2] = 152; //@line 123337 "c/sqlite3.c"
 $10 = ((($2)) + 12|0); //@line 123338 "c/sqlite3.c"
 HEAP32[$10>>2] = 74; //@line 123338 "c/sqlite3.c"
 (_sqlite3WalkSelect($2,$1)|0); //@line 123339 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 123340 "c/sqlite3.c"
}
function _sqlite3ResolveSelectNames($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = ((($3)) + 4|0); //@line 92643 "c/sqlite3.c"
 HEAP32[$4>>2] = 153; //@line 92643 "c/sqlite3.c"
 $5 = ((($3)) + 8|0); //@line 92644 "c/sqlite3.c"
 HEAP32[$5>>2] = 154; //@line 92644 "c/sqlite3.c"
 $6 = ((($3)) + 12|0); //@line 92645 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 92645 "c/sqlite3.c"
 HEAP32[$3>>2] = $0; //@line 92646 "c/sqlite3.c"
 $7 = ((($3)) + 24|0); //@line 92647 "c/sqlite3.c"
 HEAP32[$7>>2] = $2; //@line 92647 "c/sqlite3.c"
 (_sqlite3WalkSelect($3,$1)|0); //@line 92648 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 92649 "c/sqlite3.c"
}
function _sqlite3SelectAddTypeInfo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = ((($2)) + 8|0); //@line 123394 "c/sqlite3.c"
 HEAP32[$3>>2] = 155; //@line 123394 "c/sqlite3.c"
 $4 = ((($2)) + 12|0); //@line 123395 "c/sqlite3.c"
 HEAP32[$4>>2] = 75; //@line 123395 "c/sqlite3.c"
 $5 = ((($2)) + 4|0); //@line 123396 "c/sqlite3.c"
 HEAP32[$5>>2] = 150; //@line 123396 "c/sqlite3.c"
 HEAP32[$2>>2] = $0; //@line 123397 "c/sqlite3.c"
 (_sqlite3WalkSelect($2,$1)|0); //@line 123398 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 123400 "c/sqlite3.c"
}
function _sqlite3SelectWalkNoop($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 123302 "c/sqlite3.c"
}
function _selectAddSubqueryTypeInfo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$02730 = 0, $$02829 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 8|0); //@line 123365 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 123365 "c/sqlite3.c"
 $4 = $3 | 128; //@line 123365 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 123365 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 123366 "c/sqlite3.c"
 $6 = ((($1)) + 28|0); //@line 123367 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 123367 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 123368 "c/sqlite3.c"
 $9 = ($8|0)>(0); //@line 123368 "c/sqlite3.c"
 if (!($9)) {
  return; //@line 123380 "c/sqlite3.c"
 }
 $10 = ((($7)) + 8|0); //@line 123368 "c/sqlite3.c"
 $$02730 = 0;$$02829 = $10;
 while(1) {
  $11 = ((($$02829)) + 16|0); //@line 123369 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 123369 "c/sqlite3.c"
  $13 = ((($12)) + 36|0); //@line 123371 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 123371 "c/sqlite3.c"
  $15 = $14 & 2; //@line 123371 "c/sqlite3.c"
  $16 = ($15|0)==(0); //@line 123371 "c/sqlite3.c"
  if (!($16)) {
   $17 = ((($$02829)) + 20|0); //@line 123373 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 123373 "c/sqlite3.c"
   $19 = ($18|0)==(0|0); //@line 123374 "c/sqlite3.c"
   if (!($19)) {
    $$0 = $18;
    while(1) {
     $20 = ((($$0)) + 48|0); //@line 123375 "c/sqlite3.c"
     $21 = HEAP32[$20>>2]|0; //@line 123375 "c/sqlite3.c"
     $22 = ($21|0)==(0|0); //@line 123375 "c/sqlite3.c"
     if ($22) {
      break;
     } else {
      $$0 = $21;
     }
    }
    _sqlite3SelectAddColumnTypeAndCollation($5,$12,$$0); //@line 123376 "c/sqlite3.c"
   }
  }
  $23 = (($$02730) + 1)|0; //@line 123368 "c/sqlite3.c"
  $24 = ((($$02829)) + 72|0); //@line 123368 "c/sqlite3.c"
  $25 = HEAP32[$7>>2]|0; //@line 123368 "c/sqlite3.c"
  $26 = ($23|0)<($25|0); //@line 123368 "c/sqlite3.c"
  if ($26) {
   $$02730 = $23;$$02829 = $24;
  } else {
   break;
  }
 }
 return; //@line 123380 "c/sqlite3.c"
}
function _sqlite3ExprWalkNoop($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 123293 "c/sqlite3.c"
}
function _sqlite3WalkSelect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 91134 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$0 = 0;
  } else {
   $3 = ((($0)) + 8|0); //@line 91135 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 91135 "c/sqlite3.c"
   $5 = ($4|0)==(0|0); //@line 91135 "c/sqlite3.c"
   if ($5) {
    $$0 = 0;
   } else {
    $6 = ((($0)) + 12|0);
    $$018 = $1;
    while(1) {
     $7 = HEAP32[$3>>2]|0; //@line 91137 "c/sqlite3.c"
     $8 = (FUNCTION_TABLE_iii[$7 & 255]($0,$$018)|0); //@line 91137 "c/sqlite3.c"
     $9 = ($8|0)==(0); //@line 91138 "c/sqlite3.c"
     if (!($9)) {
      break;
     }
     $11 = (_sqlite3WalkSelectExpr($0,$$018)|0); //@line 91139 "c/sqlite3.c"
     $12 = ($11|0)==(0); //@line 91139 "c/sqlite3.c"
     if (!($12)) {
      $$0 = 2;
      break L1;
     }
     $13 = (_sqlite3WalkSelectFrom($0,$$018)|0); //@line 91140 "c/sqlite3.c"
     $14 = ($13|0)==(0); //@line 91140 "c/sqlite3.c"
     if (!($14)) {
      $$0 = 2;
      break L1;
     }
     $15 = HEAP32[$6>>2]|0; //@line 91144 "c/sqlite3.c"
     $16 = ($15|0)==(0|0); //@line 91144 "c/sqlite3.c"
     if (!($16)) {
      FUNCTION_TABLE_vii[$15 & 127]($0,$$018); //@line 91145 "c/sqlite3.c"
     }
     $17 = ((($$018)) + 48|0); //@line 91147 "c/sqlite3.c"
     $18 = HEAP32[$17>>2]|0; //@line 91147 "c/sqlite3.c"
     $19 = ($18|0)==(0|0); //@line 91148 "c/sqlite3.c"
     if ($19) {
      $$0 = 0;
      break L1;
     } else {
      $$018 = $18;
     }
    }
    $10 = $8 & 2; //@line 91138 "c/sqlite3.c"
    $$0 = $10;
   }
  }
 } while(0);
 return ($$0|0); //@line 91150 "c/sqlite3.c"
}
function _sqlite3WalkSelectExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 91079 "c/sqlite3.c"
 $3 = (_sqlite3WalkExprList($0,$2)|0); //@line 91079 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 91079 "c/sqlite3.c"
 if (!($4)) {
  $$0 = 2;
  return ($$0|0); //@line 91086 "c/sqlite3.c"
 }
 $5 = ((($1)) + 32|0); //@line 91080 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 91080 "c/sqlite3.c"
 $7 = (_sqlite3WalkExpr($0,$6)|0); //@line 91080 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 91080 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 2;
  return ($$0|0); //@line 91086 "c/sqlite3.c"
 }
 $9 = ((($1)) + 36|0); //@line 91081 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 91081 "c/sqlite3.c"
 $11 = (_sqlite3WalkExprList($0,$10)|0); //@line 91081 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 91081 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 2;
  return ($$0|0); //@line 91086 "c/sqlite3.c"
 }
 $13 = ((($1)) + 40|0); //@line 91082 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 91082 "c/sqlite3.c"
 $15 = (_sqlite3WalkExpr($0,$14)|0); //@line 91082 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 91082 "c/sqlite3.c"
 if (!($16)) {
  $$0 = 2;
  return ($$0|0); //@line 91086 "c/sqlite3.c"
 }
 $17 = ((($1)) + 44|0); //@line 91083 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 91083 "c/sqlite3.c"
 $19 = (_sqlite3WalkExprList($0,$18)|0); //@line 91083 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 91083 "c/sqlite3.c"
 if (!($20)) {
  $$0 = 2;
  return ($$0|0); //@line 91086 "c/sqlite3.c"
 }
 $21 = ((($1)) + 56|0); //@line 91084 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 91084 "c/sqlite3.c"
 $23 = (_sqlite3WalkExpr($0,$22)|0); //@line 91084 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 91084 "c/sqlite3.c"
 $$ = $24 ? 0 : 2; //@line 91085 "c/sqlite3.c"
 $$0 = $$;
 return ($$0|0); //@line 91086 "c/sqlite3.c"
}
function _sqlite3WalkSelectFrom($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01719 = 0, $$018 = 0, $$020 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 28|0); //@line 91100 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 91100 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 91102 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 91102 "c/sqlite3.c"
 if (!($5)) {
  $$018 = 0;
  return ($$018|0); //@line 91113 "c/sqlite3.c"
 }
 $6 = ((($3)) + 8|0); //@line 91102 "c/sqlite3.c"
 $$01719 = $4;$$020 = $6;
 while(1) {
  $7 = ((($$020)) + 20|0); //@line 91103 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 91103 "c/sqlite3.c"
  $9 = ($8|0)==(0|0); //@line 91103 "c/sqlite3.c"
  if (!($9)) {
   $10 = (_sqlite3WalkSelect($0,$8)|0); //@line 91103 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 91103 "c/sqlite3.c"
   if (!($11)) {
    $$018 = 2;
    label = 8;
    break;
   }
  }
  $12 = ((($$020)) + 37|0); //@line 91106 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 91106 "c/sqlite3.c"
  $14 = $13 & 4; //@line 91106 "c/sqlite3.c"
  $15 = ($14<<24>>24)==(0); //@line 91106 "c/sqlite3.c"
  if (!($15)) {
   $16 = ((($$020)) + 64|0); //@line 91107 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 91107 "c/sqlite3.c"
   $18 = (_sqlite3WalkExprList($0,$17)|0); //@line 91107 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 91107 "c/sqlite3.c"
   if (!($19)) {
    $$018 = 2;
    label = 8;
    break;
   }
  }
  $20 = (($$01719) + -1)|0; //@line 91102 "c/sqlite3.c"
  $21 = ((($$020)) + 72|0); //@line 91102 "c/sqlite3.c"
  $22 = ($$01719|0)>(1); //@line 91102 "c/sqlite3.c"
  if ($22) {
   $$01719 = $20;$$020 = $21;
  } else {
   $$018 = 0;
   label = 8;
   break;
  }
 }
 if ((label|0) == 8) {
  return ($$018|0); //@line 91113 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3WalkExprList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01113 = 0, $$012 = 0, $$014 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 91064 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$012 = 0;
  } else {
   $3 = HEAP32[$1>>2]|0; //@line 91065 "c/sqlite3.c"
   $4 = ($3|0)>(0); //@line 91065 "c/sqlite3.c"
   if ($4) {
    $5 = ((($1)) + 4|0); //@line 91065 "c/sqlite3.c"
    $$01113 = $3;$$014 = $5;
    while(1) {
     $6 = HEAP32[$$014>>2]|0; //@line 91066 "c/sqlite3.c"
     $7 = (_sqlite3WalkExpr($0,$6)|0); //@line 91066 "c/sqlite3.c"
     $8 = ($7|0)==(0); //@line 91066 "c/sqlite3.c"
     if (!($8)) {
      $$012 = 2;
      break L1;
     }
     $9 = (($$01113) + -1)|0; //@line 91065 "c/sqlite3.c"
     $10 = ((($$014)) + 20|0); //@line 91065 "c/sqlite3.c"
     $11 = ($$01113|0)>(1); //@line 91065 "c/sqlite3.c"
     if ($11) {
      $$01113 = $9;$$014 = $10;
     } else {
      $$012 = 0;
      break;
     }
    }
   } else {
    $$012 = 0;
   }
  }
 } while(0);
 return ($$012|0); //@line 91070 "c/sqlite3.c"
}
function _sqlite3WalkExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 91054 "c/sqlite3.c"
 if ($2) {
  $4 = 0;
 } else {
  $3 = (_walkExpr($0,$1)|0); //@line 91054 "c/sqlite3.c"
  $4 = $3;
 }
 return ($4|0); //@line 91054 "c/sqlite3.c"
}
function _walkExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$01728 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 91035 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 91035 "c/sqlite3.c"
 $4 = (FUNCTION_TABLE_iii[$3 & 255]($0,$1)|0); //@line 91035 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 91036 "c/sqlite3.c"
 L1: do {
  if ($5) {
   $$01728 = $1;
   while(1) {
    $11 = ((($$01728)) + 4|0); //@line 91037 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 91037 "c/sqlite3.c"
    $13 = $12 & 8404992; //@line 91037 "c/sqlite3.c"
    $14 = ($13|0)==(0); //@line 91037 "c/sqlite3.c"
    if (!($14)) {
     break;
    }
    $15 = ((($$01728)) + 12|0); //@line 91038 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 91038 "c/sqlite3.c"
    $17 = ($16|0)==(0|0); //@line 91038 "c/sqlite3.c"
    if (!($17)) {
     $18 = (_walkExpr($0,$16)|0); //@line 91038 "c/sqlite3.c"
     $19 = ($18|0)==(0); //@line 91038 "c/sqlite3.c"
     if (!($19)) {
      $$0 = 2;
      label = 14;
      break;
     }
    }
    $20 = ((($$01728)) + 16|0); //@line 91040 "c/sqlite3.c"
    $7 = HEAP32[$20>>2]|0; //@line 91040 "c/sqlite3.c"
    $21 = ($7|0)==(0|0); //@line 91040 "c/sqlite3.c"
    if ($21) {
     label = 9;
     break;
    }
    $6 = HEAP32[$2>>2]|0; //@line 91035 "c/sqlite3.c"
    $8 = (FUNCTION_TABLE_iii[$6 & 255]($0,$7)|0); //@line 91035 "c/sqlite3.c"
    $9 = ($8|0)==(0); //@line 91036 "c/sqlite3.c"
    if ($9) {
     $$01728 = $7;
    } else {
     $$lcssa = $8;
     break L1;
    }
   }
   if ((label|0) == 14) {
    return ($$0|0); //@line 91052 "c/sqlite3.c"
   }
   do {
    if ((label|0) == 9) {
     $22 = ((($$01728)) + 4|0); //@line 91037 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 91043 "c/sqlite3.c"
     $24 = $23 & 2048; //@line 91043 "c/sqlite3.c"
     $25 = ($24|0)==(0); //@line 91043 "c/sqlite3.c"
     if (!($25)) {
      $26 = ((($$01728)) + 20|0); //@line 91044 "c/sqlite3.c"
      $27 = HEAP32[$26>>2]|0; //@line 91044 "c/sqlite3.c"
      $28 = (_sqlite3WalkSelect($0,$27)|0); //@line 91044 "c/sqlite3.c"
      $29 = ($28|0)==(0); //@line 91044 "c/sqlite3.c"
      if ($29) {
       break;
      } else {
       $$0 = 2;
      }
      return ($$0|0); //@line 91052 "c/sqlite3.c"
     }
     $30 = ((($$01728)) + 20|0); //@line 91045 "c/sqlite3.c"
     $31 = HEAP32[$30>>2]|0; //@line 91045 "c/sqlite3.c"
     $32 = ($31|0)==(0|0); //@line 91045 "c/sqlite3.c"
     if (!($32)) {
      $33 = (_sqlite3WalkExprList($0,$31)|0); //@line 91046 "c/sqlite3.c"
      $34 = ($33|0)==(0); //@line 91046 "c/sqlite3.c"
      if (!($34)) {
       $$0 = 2;
       return ($$0|0); //@line 91052 "c/sqlite3.c"
      }
     }
    }
   } while(0);
   $$0 = 0;
   return ($$0|0); //@line 91052 "c/sqlite3.c"
  } else {
   $$lcssa = $4;
  }
 } while(0);
 $10 = $$lcssa & 2; //@line 91036 "c/sqlite3.c"
 $$0 = $10;
 return ($$0|0); //@line 91052 "c/sqlite3.c"
}
function _resolveExprStep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0156 = 0, $$0157183 = 0, $$0158 = 0, $$0159 = 0, $$2 = 0, $$sink = 0, $$sink188 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0;
 var $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0;
 var $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0;
 var $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $phitmp = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer15 = 0, $vararg_buffer3 = 0, $vararg_buffer7 = 0, $vararg_ptr10 = 0, $vararg_ptr14 = 0, $vararg_ptr6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer15 = sp + 40|0; //@line 91723 "c/sqlite3.c"
 $vararg_buffer11 = sp + 32|0; //@line 91723 "c/sqlite3.c"
 $vararg_buffer7 = sp + 24|0; //@line 91723 "c/sqlite3.c"
 $vararg_buffer3 = sp + 16|0; //@line 91723 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 91723 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 91723 "c/sqlite3.c"
 $2 = ((($0)) + 24|0); //@line 91727 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 91727 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 91729 "c/sqlite3.c"
 $5 = HEAP8[$1>>0]|0; //@line 91741 "c/sqlite3.c"
 switch ($5<<24>>24) {
 case 57: case 54: case 55: case 56: case 52: case 53: case 48: case 45: case -113:  {
  $132 = HEAP32[$4>>2]|0; //@line 91949 "c/sqlite3.c"
  $133 = ((($132)) + 73|0); //@line 91949 "c/sqlite3.c"
  $134 = HEAP8[$133>>0]|0; //@line 91949 "c/sqlite3.c"
  $135 = ($134<<24>>24)==(0); //@line 91949 "c/sqlite3.c"
  if ($135) {
   $136 = ((($1)) + 12|0); //@line 91951 "c/sqlite3.c"
   $137 = HEAP32[$136>>2]|0; //@line 91951 "c/sqlite3.c"
   $138 = (_sqlite3ExprVectorSize($137)|0); //@line 91951 "c/sqlite3.c"
   $139 = ($5<<24>>24)==(48); //@line 91952 "c/sqlite3.c"
   if ($139) {
    $140 = ((($1)) + 20|0); //@line 91953 "c/sqlite3.c"
    $141 = HEAP32[$140>>2]|0; //@line 91953 "c/sqlite3.c"
    $142 = ((($141)) + 4|0); //@line 91953 "c/sqlite3.c"
    $143 = HEAP32[$142>>2]|0; //@line 91953 "c/sqlite3.c"
    $144 = (_sqlite3ExprVectorSize($143)|0); //@line 91953 "c/sqlite3.c"
    $145 = ($144|0)==($138|0); //@line 91954 "c/sqlite3.c"
    if ($145) {
     $146 = ((($141)) + 24|0); //@line 91955 "c/sqlite3.c"
     $$sink188 = $146;
     label = 42;
    } else {
     $$0 = $144;
    }
   } else {
    $147 = ((($1)) + 16|0); //@line 91959 "c/sqlite3.c"
    $$sink188 = $147;
    label = 42;
   }
   if ((label|0) == 42) {
    $148 = HEAP32[$$sink188>>2]|0;
    $149 = (_sqlite3ExprVectorSize($148)|0);
    $$0 = $149;
   }
   $150 = ($138|0)==($$0|0); //@line 91961 "c/sqlite3.c"
   if (!($150)) {
    _sqlite3ErrorMsg($4,23693,$vararg_buffer15); //@line 91971 "c/sqlite3.c"
   }
  }
  break;
 }
 case -112:  {
  $22 = ((($1)) + 20|0); //@line 91803 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 91803 "c/sqlite3.c"
  $24 = ($23|0)==(0|0); //@line 91804 "c/sqlite3.c"
  if ($24) {
   $32 = 0;
  } else {
   $25 = HEAP32[$23>>2]|0; //@line 91804 "c/sqlite3.c"
   $32 = $25;
  }
  $26 = HEAP32[$4>>2]|0; //@line 91811 "c/sqlite3.c"
  $27 = ((($26)) + 70|0); //@line 91811 "c/sqlite3.c"
  $28 = HEAP8[$27>>0]|0; //@line 91811 "c/sqlite3.c"
  $29 = ((($1)) + 8|0); //@line 91814 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 91814 "c/sqlite3.c"
  $31 = (_sqlite3Strlen30($30)|0); //@line 91815 "c/sqlite3.c"
  $33 = (_sqlite3FindFunction($26,$30,$32,$28,0)|0); //@line 91816 "c/sqlite3.c"
  $34 = ($33|0)==(0|0); //@line 91817 "c/sqlite3.c"
  L16: do {
   if ($34) {
    $82 = HEAP32[$4>>2]|0; //@line 91818 "c/sqlite3.c"
    $83 = (_sqlite3FindFunction($82,$30,-2,$28,0)|0); //@line 91818 "c/sqlite3.c"
    $84 = ($83|0)==(0|0); //@line 91819 "c/sqlite3.c"
    if (!($84)) {
     HEAP32[$vararg_buffer11>>2] = $31; //@line 91889 "c/sqlite3.c"
     $vararg_ptr14 = ((($vararg_buffer11)) + 4|0); //@line 91889 "c/sqlite3.c"
     HEAP32[$vararg_ptr14>>2] = $30; //@line 91889 "c/sqlite3.c"
     _sqlite3ErrorMsg($4,23626,$vararg_buffer11); //@line 91889 "c/sqlite3.c"
     $92 = ((($3)) + 24|0); //@line 91891 "c/sqlite3.c"
     $93 = HEAP32[$92>>2]|0; //@line 91891 "c/sqlite3.c"
     $94 = (($93) + 1)|0; //@line 91891 "c/sqlite3.c"
     HEAP32[$92>>2] = $94; //@line 91891 "c/sqlite3.c"
     break;
    }
    $85 = HEAP32[$4>>2]|0; //@line 91881 "c/sqlite3.c"
    $86 = ((($85)) + 157|0); //@line 91881 "c/sqlite3.c"
    $87 = HEAP8[$86>>0]|0; //@line 91881 "c/sqlite3.c"
    $88 = ($87<<24>>24)==(0); //@line 91881 "c/sqlite3.c"
    if ($88) {
     HEAP32[$vararg_buffer7>>2] = $31; //@line 91886 "c/sqlite3.c"
     $vararg_ptr10 = ((($vararg_buffer7)) + 4|0); //@line 91886 "c/sqlite3.c"
     HEAP32[$vararg_ptr10>>2] = $30; //@line 91886 "c/sqlite3.c"
     _sqlite3ErrorMsg($4,23603,$vararg_buffer7); //@line 91886 "c/sqlite3.c"
     $89 = ((($3)) + 24|0); //@line 91887 "c/sqlite3.c"
     $90 = HEAP32[$89>>2]|0; //@line 91887 "c/sqlite3.c"
     $91 = (($90) + 1)|0; //@line 91887 "c/sqlite3.c"
     HEAP32[$89>>2] = $91; //@line 91887 "c/sqlite3.c"
    }
   } else {
    $35 = ((($33)) + 16|0); //@line 91825 "c/sqlite3.c"
    $36 = HEAP32[$35>>2]|0; //@line 91825 "c/sqlite3.c"
    $37 = ($36|0)==(0|0); //@line 91825 "c/sqlite3.c"
    $38 = ((($33)) + 2|0); //@line 91826 "c/sqlite3.c"
    $39 = HEAP16[$38>>1]|0; //@line 91826 "c/sqlite3.c"
    $40 = $39 & 1024; //@line 91826 "c/sqlite3.c"
    $41 = ($40<<16>>16)==(0); //@line 91826 "c/sqlite3.c"
    do {
     if (!($41)) {
      $42 = ((($1)) + 4|0); //@line 91827 "c/sqlite3.c"
      $43 = HEAP32[$42>>2]|0; //@line 91827 "c/sqlite3.c"
      $44 = $43 | 266240; //@line 91827 "c/sqlite3.c"
      HEAP32[$42>>2] = $44; //@line 91827 "c/sqlite3.c"
      $45 = ($32|0)==(2); //@line 91828 "c/sqlite3.c"
      if (!($45)) {
       $54 = ((($33)) + 20|0); //@line 91846 "c/sqlite3.c"
       $55 = HEAP32[$54>>2]|0; //@line 91846 "c/sqlite3.c"
       $56 = HEAP8[$55>>0]|0; //@line 91846 "c/sqlite3.c"
       $57 = ($56<<24>>24)==(117); //@line 91846 "c/sqlite3.c"
       $58 = $57 ? 8388608 : 125829120; //@line 91846 "c/sqlite3.c"
       $59 = ((($1)) + 28|0); //@line 91846 "c/sqlite3.c"
       HEAP32[$59>>2] = $58; //@line 91846 "c/sqlite3.c"
       break;
      }
      $46 = ((($23)) + 24|0); //@line 91829 "c/sqlite3.c"
      $47 = HEAP32[$46>>2]|0; //@line 91829 "c/sqlite3.c"
      $48 = (_exprProbability($47)|0); //@line 91829 "c/sqlite3.c"
      $49 = ((($1)) + 28|0); //@line 91829 "c/sqlite3.c"
      HEAP32[$49>>2] = $48; //@line 91829 "c/sqlite3.c"
      $50 = ($48|0)<(0); //@line 91830 "c/sqlite3.c"
      if ($50) {
       _sqlite3ErrorMsg($4,23433,$vararg_buffer); //@line 91831 "c/sqlite3.c"
       $51 = ((($3)) + 24|0); //@line 91834 "c/sqlite3.c"
       $52 = HEAP32[$51>>2]|0; //@line 91834 "c/sqlite3.c"
       $53 = (($52) + 1)|0; //@line 91834 "c/sqlite3.c"
       HEAP32[$51>>2] = $53; //@line 91834 "c/sqlite3.c"
      }
     }
    } while(0);
    $60 = ((($33)) + 20|0); //@line 91851 "c/sqlite3.c"
    $61 = HEAP32[$60>>2]|0; //@line 91851 "c/sqlite3.c"
    $62 = (_sqlite3AuthCheck($4,31,0,$61,0)|0); //@line 91851 "c/sqlite3.c"
    switch ($62|0) {
    case 0:  {
     $67 = HEAP16[$38>>1]|0; //@line 91863 "c/sqlite3.c"
     $68 = $67 & 10240; //@line 91863 "c/sqlite3.c"
     $69 = ($68<<16>>16)==(0); //@line 91863 "c/sqlite3.c"
     if (!($69)) {
      $70 = ((($1)) + 4|0); //@line 91867 "c/sqlite3.c"
      $71 = HEAP32[$70>>2]|0; //@line 91867 "c/sqlite3.c"
      $72 = $71 | 524288; //@line 91867 "c/sqlite3.c"
      HEAP32[$70>>2] = $72; //@line 91867 "c/sqlite3.c"
     }
     $73 = $67 & 2048; //@line 91869 "c/sqlite3.c"
     $74 = ($73<<16>>16)==(0); //@line 91869 "c/sqlite3.c"
     if ($74) {
      _notValid($4,$3,23539,34); //@line 91873 "c/sqlite3.c"
     }
     if ($37) {
      break L16;
     }
     $75 = ((($3)) + 28|0); //@line 91877 "c/sqlite3.c"
     $76 = HEAP16[$75>>1]|0; //@line 91877 "c/sqlite3.c"
     $77 = $76 & 1; //@line 91877 "c/sqlite3.c"
     $78 = ($77<<16>>16)==(0); //@line 91877 "c/sqlite3.c"
     if ($78) {
      HEAP32[$vararg_buffer3>>2] = $31; //@line 91878 "c/sqlite3.c"
      $vararg_ptr6 = ((($vararg_buffer3)) + 4|0); //@line 91878 "c/sqlite3.c"
      HEAP32[$vararg_ptr6>>2] = $30; //@line 91878 "c/sqlite3.c"
      _sqlite3ErrorMsg($4,23567,$vararg_buffer3); //@line 91878 "c/sqlite3.c"
      $79 = ((($3)) + 24|0); //@line 91879 "c/sqlite3.c"
      $80 = HEAP32[$79>>2]|0; //@line 91879 "c/sqlite3.c"
      $81 = (($80) + 1)|0; //@line 91879 "c/sqlite3.c"
      HEAP32[$79>>2] = $81; //@line 91879 "c/sqlite3.c"
      break L16;
     }
     $95 = ((($3)) + 28|0); //@line 91893 "c/sqlite3.c"
     $96 = HEAP16[$95>>1]|0; //@line 91893 "c/sqlite3.c"
     $97 = $96 & -2; //@line 91893 "c/sqlite3.c"
     HEAP16[$95>>1] = $97; //@line 91893 "c/sqlite3.c"
     (_sqlite3WalkExprList($0,$23)|0); //@line 91894 "c/sqlite3.c"
     HEAP8[$1>>0] = -110; //@line 91897 "c/sqlite3.c"
     $98 = ((($1)) + 38|0); //@line 91898 "c/sqlite3.c"
     HEAP8[$98>>0] = 0; //@line 91898 "c/sqlite3.c"
     $$0157183 = $3;
     while(1) {
      $99 = ((($$0157183)) + 4|0); //@line 91899 "c/sqlite3.c"
      $100 = HEAP32[$99>>2]|0; //@line 91899 "c/sqlite3.c"
      $101 = (_sqlite3FunctionUsesThisSrc($1,$100)|0); //@line 91899 "c/sqlite3.c"
      $102 = ($101|0)==(0); //@line 91899 "c/sqlite3.c"
      if (!($102)) {
       label = 30;
       break;
      }
      $103 = HEAP8[$98>>0]|0; //@line 91900 "c/sqlite3.c"
      $104 = (($103) + 1)<<24>>24; //@line 91900 "c/sqlite3.c"
      HEAP8[$98>>0] = $104; //@line 91900 "c/sqlite3.c"
      $105 = ((($$0157183)) + 16|0); //@line 91901 "c/sqlite3.c"
      $106 = HEAP32[$105>>2]|0; //@line 91901 "c/sqlite3.c"
      $107 = ($106|0)==(0|0); //@line 91899 "c/sqlite3.c"
      if ($107) {
       break;
      } else {
       $$0157183 = $106;
      }
     }
     if ((label|0) == 30) {
      $108 = ((($33)) + 2|0); //@line 91907 "c/sqlite3.c"
      $109 = HEAP16[$108>>1]|0; //@line 91907 "c/sqlite3.c"
      $110 = $109 & 4096; //@line 91907 "c/sqlite3.c"
      $111 = ((($$0157183)) + 28|0); //@line 91907 "c/sqlite3.c"
      $112 = HEAP16[$111>>1]|0; //@line 91907 "c/sqlite3.c"
      $113 = $110 | $112; //@line 91907 "c/sqlite3.c"
      $114 = $113 | 16; //@line 91907 "c/sqlite3.c"
      HEAP16[$111>>1] = $114; //@line 91907 "c/sqlite3.c"
     }
     $115 = HEAP16[$95>>1]|0; //@line 91910 "c/sqlite3.c"
     $116 = $115 | 1; //@line 91910 "c/sqlite3.c"
     HEAP16[$95>>1] = $116; //@line 91910 "c/sqlite3.c"
     $$2 = 1;
     STACKTOP = sp;return ($$2|0); //@line 91977 "c/sqlite3.c"
     break;
    }
    case 1:  {
     $63 = HEAP32[$60>>2]|0; //@line 91855 "c/sqlite3.c"
     HEAP32[$vararg_buffer1>>2] = $63; //@line 91854 "c/sqlite3.c"
     _sqlite3ErrorMsg($4,23504,$vararg_buffer1); //@line 91854 "c/sqlite3.c"
     $64 = ((($3)) + 24|0); //@line 91856 "c/sqlite3.c"
     $65 = HEAP32[$64>>2]|0; //@line 91856 "c/sqlite3.c"
     $66 = (($65) + 1)|0; //@line 91856 "c/sqlite3.c"
     HEAP32[$64>>2] = $66; //@line 91856 "c/sqlite3.c"
     break;
    }
    default: {
    }
    }
    HEAP8[$1>>0] = 101; //@line 91858 "c/sqlite3.c"
    $$2 = 1;
    STACKTOP = sp;return ($$2|0); //@line 91977 "c/sqlite3.c"
   }
  } while(0);
  (_sqlite3WalkExprList($0,$23)|0); //@line 91894 "c/sqlite3.c"
  $$2 = 1;
  STACKTOP = sp;return ($$2|0); //@line 91977 "c/sqlite3.c"
  break;
 }
 case 49: case 20: case 119:  {
  $117 = ((($1)) + 4|0); //@line 91923 "c/sqlite3.c"
  $118 = HEAP32[$117>>2]|0; //@line 91923 "c/sqlite3.c"
  $119 = $118 & 2048; //@line 91923 "c/sqlite3.c"
  $120 = ($119|0)==(0); //@line 91923 "c/sqlite3.c"
  if (!($120)) {
   $121 = ((($3)) + 20|0); //@line 91924 "c/sqlite3.c"
   $122 = HEAP32[$121>>2]|0; //@line 91924 "c/sqlite3.c"
   _notValid($4,$3,23671,38); //@line 91925 "c/sqlite3.c"
   $123 = ((($1)) + 20|0); //@line 91926 "c/sqlite3.c"
   $124 = HEAP32[$123>>2]|0; //@line 91926 "c/sqlite3.c"
   (_sqlite3WalkSelect($0,$124)|0); //@line 91926 "c/sqlite3.c"
   $125 = HEAP32[$121>>2]|0; //@line 91928 "c/sqlite3.c"
   $126 = ($122|0)==($125|0); //@line 91928 "c/sqlite3.c"
   if (!($126)) {
    $127 = HEAP32[$117>>2]|0; //@line 91929 "c/sqlite3.c"
    $128 = $127 | 32; //@line 91929 "c/sqlite3.c"
    HEAP32[$117>>2] = $128; //@line 91929 "c/sqlite3.c"
    $129 = ((($3)) + 28|0); //@line 91930 "c/sqlite3.c"
    $130 = HEAP16[$129>>1]|0; //@line 91930 "c/sqlite3.c"
    $131 = $130 | 64; //@line 91930 "c/sqlite3.c"
    HEAP16[$129>>1] = $131; //@line 91930 "c/sqlite3.c"
   }
  }
  break;
 }
 case -121:  {
  _notValid($4,$3,23682,38); //@line 91936 "c/sqlite3.c"
  break;
 }
 case 59:  {
  $$0158 = 0;$$0159 = 0;$$sink = $1;
  label = 4;
  break;
 }
 case 122:  {
  _notValid($4,$3,23416,32); //@line 91784 "c/sqlite3.c"
  $6 = ((($1)) + 16|0); //@line 91785 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 91785 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 91786 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(59); //@line 91786 "c/sqlite3.c"
  $10 = ((($1)) + 12|0);
  $11 = HEAP32[$10>>2]|0;
  $12 = ((($11)) + 8|0);
  $13 = HEAP32[$12>>2]|0;
  if ($9) {
   $$0158 = $13;$$0159 = 0;$$sink = $7;
   label = 4;
  } else {
   $14 = ((($7)) + 12|0); //@line 91793 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 91793 "c/sqlite3.c"
   $16 = ((($15)) + 8|0); //@line 91793 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 91793 "c/sqlite3.c"
   $18 = ((($7)) + 16|0); //@line 91794 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 91794 "c/sqlite3.c"
   $$0158 = $17;$$0159 = $13;$$sink = $19;
   label = 4;
  }
  break;
 }
 default: {
 }
 }
 if ((label|0) == 4) {
  $20 = ((($$sink)) + 8|0);
  $$0156 = HEAP32[$20>>2]|0;
  $21 = (_lookupName($4,$$0159,$$0158,$$0156,$3,$1)|0); //@line 91797 "c/sqlite3.c"
  $$2 = $21;
  STACKTOP = sp;return ($$2|0); //@line 91977 "c/sqlite3.c"
 }
 $151 = ((($4)) + 36|0); //@line 91976 "c/sqlite3.c"
 $152 = HEAP32[$151>>2]|0; //@line 91976 "c/sqlite3.c"
 $153 = ($152|0)==(0); //@line 91976 "c/sqlite3.c"
 if (!($153)) {
  $$2 = 2;
  STACKTOP = sp;return ($$2|0); //@line 91977 "c/sqlite3.c"
 }
 $154 = HEAP32[$4>>2]|0; //@line 91976 "c/sqlite3.c"
 $155 = ((($154)) + 73|0); //@line 91976 "c/sqlite3.c"
 $156 = HEAP8[$155>>0]|0; //@line 91976 "c/sqlite3.c"
 $157 = ($156<<24>>24)==(0); //@line 91976 "c/sqlite3.c"
 $phitmp = $157 ? 0 : 2; //@line 91976 "c/sqlite3.c"
 $$2 = $phitmp;
 STACKTOP = sp;return ($$2|0); //@line 91977 "c/sqlite3.c"
}
function _resolveSelectStep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0140190 = 0, $$0141189 = 0, $$0142$lcssa = 0, $$0142167 = 0, $$0144166 = 0, $$0146174 = 0, $$0186 = 0, $$1143$lcssa = 0, $$1143169 = 0, $$1145168 = 0, $$1147180 = 0, $$2148185 = 0, $$9 = 0, $$lcssa163 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0;
 var $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0;
 var $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0;
 var $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0;
 var $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0;
 var $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $phitmp = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 16|0;
 $3 = ((($1)) + 8|0); //@line 92319 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 92319 "c/sqlite3.c"
 $5 = $4 & 4; //@line 92319 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 92319 "c/sqlite3.c"
 if (!($6)) {
  $$9 = 1;
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 $7 = ((($0)) + 24|0); //@line 92322 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 92322 "c/sqlite3.c"
 $9 = HEAP32[$0>>2]|0; //@line 92323 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 92324 "c/sqlite3.c"
 $11 = $4 & 64; //@line 92334 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 92334 "c/sqlite3.c"
 if ($12) {
  _sqlite3SelectPrep($9,$1,$8); //@line 92335 "c/sqlite3.c"
  $13 = ((($9)) + 36|0); //@line 92336 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 92336 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 92336 "c/sqlite3.c"
  if (!($15)) {
   $$9 = 2;
   STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
  }
  $16 = ((($10)) + 73|0); //@line 92336 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 92336 "c/sqlite3.c"
  $18 = ($17<<24>>24)==(0); //@line 92336 "c/sqlite3.c"
  $phitmp = $18 ? 1 : 2; //@line 92336 "c/sqlite3.c"
  $$9 = $phitmp;
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 $19 = ((($1)) + 48|0); //@line 92339 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 92339 "c/sqlite3.c"
 $21 = ($20|0)!=(0|0); //@line 92339 "c/sqlite3.c"
 $22 = $21&1; //@line 92339 "c/sqlite3.c"
 $23 = ((($2)) + 28|0);
 $24 = ((($2)) + 4|0);
 $25 = ((($2)) + 16|0);
 $26 = ((($9)) + 440|0);
 $27 = ($8|0)==(0|0);
 $28 = ((($9)) + 36|0);
 $29 = ((($10)) + 73|0);
 $30 = ($8|0)==(0|0);
 $31 = ((($2)) + 8|0);
 $32 = ((($10)) + 73|0);
 $33 = ((($2)) + 4|0);
 $$0140190 = $1;$$0141189 = 0;
 L11: while(1) {
  $34 = ((($$0140190)) + 8|0); //@line 92345 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 92345 "c/sqlite3.c"
  $36 = $35 | 4; //@line 92345 "c/sqlite3.c"
  HEAP32[$34>>2] = $36; //@line 92345 "c/sqlite3.c"
  ;HEAP32[$33>>2]=0|0;HEAP32[$33+4>>2]=0|0;HEAP32[$33+8>>2]=0|0;HEAP32[$33+12>>2]=0|0;HEAP32[$33+16>>2]=0|0;HEAP32[$33+20>>2]=0|0;HEAP32[$33+24>>2]=0|0; //@line 92350 "c/sqlite3.c"
  HEAP32[$2>>2] = $9; //@line 92351 "c/sqlite3.c"
  $37 = ((($$0140190)) + 56|0); //@line 92352 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 92352 "c/sqlite3.c"
  $39 = (_sqlite3ResolveExprNames($2,$38)|0); //@line 92352 "c/sqlite3.c"
  $40 = ($39|0)==(0); //@line 92352 "c/sqlite3.c"
  if (!($40)) {
   $$9 = 2;
   label = 58;
   break;
  }
  $41 = HEAP32[$34>>2]|0; //@line 92362 "c/sqlite3.c"
  $42 = $41 & 65536; //@line 92362 "c/sqlite3.c"
  $43 = ($42|0)==(0); //@line 92362 "c/sqlite3.c"
  if (!($43)) {
   $44 = ((($$0140190)) + 28|0); //@line 92363 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 92363 "c/sqlite3.c"
   $46 = ((($45)) + 28|0); //@line 92363 "c/sqlite3.c"
   $47 = HEAP32[$46>>2]|0; //@line 92363 "c/sqlite3.c"
   $48 = ((($$0140190)) + 44|0); //@line 92366 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 92366 "c/sqlite3.c"
   $50 = ((($47)) + 44|0); //@line 92366 "c/sqlite3.c"
   HEAP32[$50>>2] = $49; //@line 92366 "c/sqlite3.c"
   HEAP32[$48>>2] = 0; //@line 92367 "c/sqlite3.c"
  }
  $51 = ((($$0140190)) + 28|0); //@line 92372 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 92372 "c/sqlite3.c"
  $53 = HEAP32[$52>>2]|0; //@line 92372 "c/sqlite3.c"
  $54 = ($53|0)>(0); //@line 92372 "c/sqlite3.c"
  if ($54) {
   $$0146174 = 0;$56 = $52;
   while(1) {
    $55 = (((((($56)) + 8|0) + (($$0146174*72)|0)|0)) + 20|0); //@line 92374 "c/sqlite3.c"
    $57 = HEAP32[$55>>2]|0; //@line 92374 "c/sqlite3.c"
    $58 = ($57|0)==(0|0); //@line 92374 "c/sqlite3.c"
    if (!($58)) {
     $59 = HEAP32[$26>>2]|0; //@line 92377 "c/sqlite3.c"
     if ($27) {
      $$0142$lcssa = 0;
     } else {
      $$0142167 = 0;$$0144166 = $8;
      while(1) {
       $60 = ((($$0144166)) + 20|0); //@line 92384 "c/sqlite3.c"
       $61 = HEAP32[$60>>2]|0; //@line 92384 "c/sqlite3.c"
       $62 = (($61) + ($$0142167))|0; //@line 92384 "c/sqlite3.c"
       $63 = ((($$0144166)) + 16|0); //@line 92384 "c/sqlite3.c"
       $64 = HEAP32[$63>>2]|0; //@line 92384 "c/sqlite3.c"
       $65 = ($64|0)==(0|0); //@line 92384 "c/sqlite3.c"
       if ($65) {
        $$0142$lcssa = $62;
        break;
       } else {
        $$0142167 = $62;$$0144166 = $64;
       }
      }
     }
     $66 = (((((($56)) + 8|0) + (($$0146174*72)|0)|0)) + 8|0); //@line 92386 "c/sqlite3.c"
     $67 = HEAP32[$66>>2]|0; //@line 92386 "c/sqlite3.c"
     $68 = ($67|0)==(0|0); //@line 92386 "c/sqlite3.c"
     if (!($68)) {
      HEAP32[$26>>2] = $67; //@line 92386 "c/sqlite3.c"
     }
     _sqlite3ResolveSelectNames($9,$57,$8); //@line 92387 "c/sqlite3.c"
     HEAP32[$26>>2] = $59; //@line 92388 "c/sqlite3.c"
     $69 = HEAP32[$28>>2]|0; //@line 92389 "c/sqlite3.c"
     $70 = ($69|0)==(0); //@line 92389 "c/sqlite3.c"
     if (!($70)) {
      $$9 = 2;
      label = 58;
      break L11;
     }
     $71 = HEAP8[$29>>0]|0; //@line 92389 "c/sqlite3.c"
     $72 = ($71<<24>>24)==(0); //@line 92389 "c/sqlite3.c"
     if (!($72)) {
      $$9 = 2;
      label = 58;
      break L11;
     }
     if ($30) {
      $$1143$lcssa = $$0142$lcssa;
     } else {
      $$1143169 = $$0142$lcssa;$$1145168 = $8;
      while(1) {
       $73 = ((($$1145168)) + 20|0); //@line 92391 "c/sqlite3.c"
       $74 = HEAP32[$73>>2]|0; //@line 92391 "c/sqlite3.c"
       $75 = (($$1143169) - ($74))|0; //@line 92391 "c/sqlite3.c"
       $76 = ((($$1145168)) + 16|0); //@line 92391 "c/sqlite3.c"
       $77 = HEAP32[$76>>2]|0; //@line 92391 "c/sqlite3.c"
       $78 = ($77|0)==(0|0); //@line 92391 "c/sqlite3.c"
       if ($78) {
        $$1143$lcssa = $75;
        break;
       } else {
        $$1143169 = $75;$$1145168 = $77;
       }
      }
     }
     $79 = ($$1143$lcssa|0)!=(0); //@line 92393 "c/sqlite3.c"
     $80 = (((((($56)) + 8|0) + (($$0146174*72)|0)|0)) + 37|0); //@line 92393 "c/sqlite3.c"
     $81 = $79&1; //@line 92393 "c/sqlite3.c"
     $82 = HEAP8[$80>>0]|0; //@line 92393 "c/sqlite3.c"
     $83 = ($81 << 3)&255; //@line 92393 "c/sqlite3.c"
     $84 = $82 & -9; //@line 92393 "c/sqlite3.c"
     $85 = $84 | $83; //@line 92393 "c/sqlite3.c"
     HEAP8[$80>>0] = $85; //@line 92393 "c/sqlite3.c"
    }
    $86 = (($$0146174) + 1)|0; //@line 92372 "c/sqlite3.c"
    $87 = HEAP32[$51>>2]|0; //@line 92372 "c/sqlite3.c"
    $88 = HEAP32[$87>>2]|0; //@line 92372 "c/sqlite3.c"
    $89 = ($86|0)<($88|0); //@line 92372 "c/sqlite3.c"
    if ($89) {
     $$0146174 = $86;$56 = $87;
    } else {
     break;
    }
   }
  }
  HEAP16[$23>>1] = 1; //@line 92400 "c/sqlite3.c"
  $90 = HEAP32[$51>>2]|0; //@line 92401 "c/sqlite3.c"
  HEAP32[$24>>2] = $90; //@line 92401 "c/sqlite3.c"
  HEAP32[$25>>2] = $8; //@line 92402 "c/sqlite3.c"
  $91 = HEAP32[$$0140190>>2]|0; //@line 92405 "c/sqlite3.c"
  $92 = (_sqlite3ResolveExprListNames($2,$91)|0); //@line 92405 "c/sqlite3.c"
  $93 = ($92|0)==(0); //@line 92405 "c/sqlite3.c"
  if (!($93)) {
   $$9 = 2;
   label = 58;
   break;
  }
  $94 = ((($$0140190)) + 36|0); //@line 92411 "c/sqlite3.c"
  $95 = HEAP32[$94>>2]|0; //@line 92411 "c/sqlite3.c"
  $96 = ($95|0)!=(0|0); //@line 92412 "c/sqlite3.c"
  if ($96) {
   label = 27;
  } else {
   $97 = HEAP16[$23>>1]|0; //@line 92412 "c/sqlite3.c"
   $98 = $97&65535; //@line 92412 "c/sqlite3.c"
   $99 = $98 & 16; //@line 92412 "c/sqlite3.c"
   $100 = ($99|0)==(0); //@line 92412 "c/sqlite3.c"
   if ($100) {
    $107 = $98 & 65534; //@line 92416 "c/sqlite3.c"
    $108 = $107&65535; //@line 92416 "c/sqlite3.c"
    HEAP16[$23>>1] = $108; //@line 92416 "c/sqlite3.c"
   } else {
    label = 27;
   }
  }
  if ((label|0) == 27) {
   label = 0;
   $101 = HEAP16[$23>>1]|0; //@line 92414 "c/sqlite3.c"
   $102 = $101 & 4096; //@line 92414 "c/sqlite3.c"
   $103 = $102 | 8; //@line 92414 "c/sqlite3.c"
   $104 = $103&65535; //@line 92414 "c/sqlite3.c"
   $105 = HEAP32[$34>>2]|0; //@line 92414 "c/sqlite3.c"
   $106 = $105 | $104; //@line 92414 "c/sqlite3.c"
   HEAP32[$34>>2] = $106; //@line 92414 "c/sqlite3.c"
  }
  $109 = ((($$0140190)) + 40|0); //@line 92421 "c/sqlite3.c"
  $110 = HEAP32[$109>>2]|0; //@line 92421 "c/sqlite3.c"
  $111 = ($110|0)==(0|0); //@line 92421 "c/sqlite3.c"
  $or$cond = $96 | $111; //@line 92421 "c/sqlite3.c"
  if (!($or$cond)) {
   label = 30;
   break;
  }
  $112 = HEAP32[$$0140190>>2]|0; //@line 92434 "c/sqlite3.c"
  HEAP32[$31>>2] = $112; //@line 92434 "c/sqlite3.c"
  $113 = (_sqlite3ResolveExprNames($2,$110)|0); //@line 92435 "c/sqlite3.c"
  $114 = ($113|0)==(0); //@line 92435 "c/sqlite3.c"
  if (!($114)) {
   $$9 = 2;
   label = 58;
   break;
  }
  $115 = ((($$0140190)) + 32|0); //@line 92436 "c/sqlite3.c"
  $116 = HEAP32[$115>>2]|0; //@line 92436 "c/sqlite3.c"
  $117 = (_sqlite3ResolveExprNames($2,$116)|0); //@line 92436 "c/sqlite3.c"
  $118 = ($117|0)==(0); //@line 92436 "c/sqlite3.c"
  if (!($118)) {
   $$9 = 2;
   label = 58;
   break;
  }
  $119 = HEAP32[$51>>2]|0; //@line 92439 "c/sqlite3.c"
  $120 = HEAP32[$119>>2]|0; //@line 92439 "c/sqlite3.c"
  $121 = ($120|0)>(0); //@line 92439 "c/sqlite3.c"
  if ($121) {
   $$1147180 = 0;$123 = $119;
   while(1) {
    $122 = (((((($123)) + 8|0) + (($$1147180*72)|0)|0)) + 37|0); //@line 92441 "c/sqlite3.c"
    $124 = HEAP8[$122>>0]|0; //@line 92441 "c/sqlite3.c"
    $125 = $124 & 4; //@line 92441 "c/sqlite3.c"
    $126 = ($125<<24>>24)==(0); //@line 92441 "c/sqlite3.c"
    if (!($126)) {
     $127 = (((((($123)) + 8|0) + (($$1147180*72)|0)|0)) + 64|0); //@line 92442 "c/sqlite3.c"
     $128 = HEAP32[$127>>2]|0; //@line 92442 "c/sqlite3.c"
     $129 = (_sqlite3ResolveExprListNames($2,$128)|0); //@line 92442 "c/sqlite3.c"
     $130 = ($129|0)==(0); //@line 92442 "c/sqlite3.c"
     if (!($130)) {
      $$9 = 2;
      label = 58;
      break L11;
     }
    }
    $131 = (($$1147180) + 1)|0; //@line 92439 "c/sqlite3.c"
    $132 = HEAP32[$51>>2]|0; //@line 92439 "c/sqlite3.c"
    $133 = HEAP32[$132>>2]|0; //@line 92439 "c/sqlite3.c"
    $134 = ($131|0)<($133|0); //@line 92439 "c/sqlite3.c"
    if ($134) {
     $$1147180 = $131;$123 = $132;
    } else {
     $$lcssa163 = $132;
     break;
    }
   }
  } else {
   $$lcssa163 = $119;
  }
  HEAP32[$25>>2] = 0; //@line 92451 "c/sqlite3.c"
  $135 = HEAP16[$23>>1]|0; //@line 92452 "c/sqlite3.c"
  $136 = $135 | 1; //@line 92452 "c/sqlite3.c"
  HEAP16[$23>>1] = $136; //@line 92452 "c/sqlite3.c"
  $137 = HEAP32[$34>>2]|0; //@line 92459 "c/sqlite3.c"
  $138 = $137 & 65536; //@line 92459 "c/sqlite3.c"
  $139 = ($138|0)==(0); //@line 92459 "c/sqlite3.c"
  if (!($139)) {
   $140 = ((($$lcssa163)) + 28|0); //@line 92460 "c/sqlite3.c"
   $141 = HEAP32[$140>>2]|0; //@line 92460 "c/sqlite3.c"
   $142 = ((($141)) + 44|0); //@line 92461 "c/sqlite3.c"
   $143 = HEAP32[$142>>2]|0; //@line 92461 "c/sqlite3.c"
   $144 = ((($$0140190)) + 44|0); //@line 92461 "c/sqlite3.c"
   HEAP32[$144>>2] = $143; //@line 92461 "c/sqlite3.c"
   HEAP32[$142>>2] = 0; //@line 92462 "c/sqlite3.c"
  }
  $145 = ($$0141189>>>0)<($22>>>0); //@line 92475 "c/sqlite3.c"
  if (!($145)) {
   $146 = ((($$0140190)) + 44|0); //@line 92476 "c/sqlite3.c"
   $147 = HEAP32[$146>>2]|0; //@line 92476 "c/sqlite3.c"
   $148 = (_resolveOrderGroupBy($2,$$0140190,$147,22954)|0); //@line 92476 "c/sqlite3.c"
   $149 = ($148|0)==(0); //@line 92476 "c/sqlite3.c"
   if (!($149)) {
    $$9 = 2;
    label = 58;
    break;
   }
  }
  $150 = HEAP8[$32>>0]|0; //@line 92480 "c/sqlite3.c"
  $151 = ($150<<24>>24)==(0); //@line 92480 "c/sqlite3.c"
  if (!($151)) {
   $$9 = 2;
   label = 58;
   break;
  }
  if ($96) {
   $152 = (_resolveOrderGroupBy($2,$$0140190,$95,22960)|0); //@line 92490 "c/sqlite3.c"
   $153 = ($152|0)==(0); //@line 92490 "c/sqlite3.c"
   if (!($153)) {
    $$9 = 2;
    label = 58;
    break;
   }
   $154 = HEAP8[$32>>0]|0; //@line 92490 "c/sqlite3.c"
   $155 = ($154<<24>>24)==(0); //@line 92490 "c/sqlite3.c"
   if (!($155)) {
    $$9 = 2;
    label = 58;
    break;
   }
   $156 = HEAP32[$95>>2]|0; //@line 92493 "c/sqlite3.c"
   $157 = ($156|0)>(0); //@line 92493 "c/sqlite3.c"
   if ($157) {
    $158 = ((($95)) + 4|0); //@line 92493 "c/sqlite3.c"
    $$0186 = $158;$$2148185 = 0;
    while(1) {
     $159 = HEAP32[$$0186>>2]|0; //@line 92494 "c/sqlite3.c"
     $160 = ((($159)) + 4|0); //@line 92494 "c/sqlite3.c"
     $161 = HEAP32[$160>>2]|0; //@line 92494 "c/sqlite3.c"
     $162 = $161 & 2; //@line 92494 "c/sqlite3.c"
     $163 = ($162|0)==(0); //@line 92494 "c/sqlite3.c"
     if (!($163)) {
      label = 49;
      break L11;
     }
     $164 = (($$2148185) + 1)|0; //@line 92493 "c/sqlite3.c"
     $165 = ((($$0186)) + 20|0); //@line 92493 "c/sqlite3.c"
     $166 = HEAP32[$95>>2]|0; //@line 92493 "c/sqlite3.c"
     $167 = ($164|0)<($166|0); //@line 92493 "c/sqlite3.c"
     if ($167) {
      $$0186 = $165;$$2148185 = $164;
     } else {
      break;
     }
    }
   }
  }
  $168 = ((($$0140190)) + 52|0); //@line 92504 "c/sqlite3.c"
  $169 = HEAP32[$168>>2]|0; //@line 92504 "c/sqlite3.c"
  $170 = ($169|0)==(0|0); //@line 92504 "c/sqlite3.c"
  if (!($170)) {
   $171 = HEAP32[$$0140190>>2]|0; //@line 92504 "c/sqlite3.c"
   $172 = HEAP32[$171>>2]|0; //@line 92504 "c/sqlite3.c"
   $173 = HEAP32[$169>>2]|0; //@line 92504 "c/sqlite3.c"
   $174 = HEAP32[$173>>2]|0; //@line 92504 "c/sqlite3.c"
   $175 = ($172|0)==($174|0); //@line 92504 "c/sqlite3.c"
   if (!($175)) {
    label = 53;
    break;
   }
  }
  $176 = ((($$0140190)) + 48|0); //@line 92511 "c/sqlite3.c"
  $177 = HEAP32[$176>>2]|0; //@line 92511 "c/sqlite3.c"
  $178 = (($$0141189) + 1)|0; //@line 92512 "c/sqlite3.c"
  $179 = ($177|0)==(0|0); //@line 92342 "c/sqlite3.c"
  if ($179) {
   label = 55;
   break;
  } else {
   $$0140190 = $177;$$0141189 = $178;
  }
 }
 if ((label|0) == 30) {
  _sqlite3ErrorMsg($9,22910,$vararg_buffer); //@line 92422 "c/sqlite3.c"
  $$9 = 2;
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 else if ((label|0) == 49) {
  _sqlite3ErrorMsg($9,22966,$vararg_buffer1); //@line 92495 "c/sqlite3.c"
  $$9 = 2;
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 else if ((label|0) == 53) {
  _sqlite3SelectWrongNumTermsError($9,$169); //@line 92505 "c/sqlite3.c"
  $$9 = 2;
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 else if ((label|0) == 55) {
  if ($21) {
   $180 = (_resolveCompoundOrderBy($9,$1)|0); //@line 92518 "c/sqlite3.c"
   $181 = ($180|0)==(0); //@line 92518 "c/sqlite3.c"
   if (!($181)) {
    $$9 = 2;
    STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
   }
  }
  $$9 = 1;
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 else if ((label|0) == 58) {
  STACKTOP = sp;return ($$9|0); //@line 92523 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ResolveExprNames($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = ($1|0)==(0|0); //@line 92580 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 92603 "c/sqlite3.c"
 }
 $4 = ((($0)) + 28|0); //@line 92581 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 92581 "c/sqlite3.c"
 $6 = $5&65535; //@line 92581 "c/sqlite3.c"
 $7 = $6 & 4112; //@line 92581 "c/sqlite3.c"
 $8 = $6 & 61423; //@line 92582 "c/sqlite3.c"
 $9 = $8&65535; //@line 92582 "c/sqlite3.c"
 HEAP16[$4>>1] = $9; //@line 92582 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 92583 "c/sqlite3.c"
 HEAP32[$2>>2] = $10; //@line 92583 "c/sqlite3.c"
 $11 = ((($2)) + 4|0); //@line 92584 "c/sqlite3.c"
 HEAP32[$11>>2] = 153; //@line 92584 "c/sqlite3.c"
 $12 = ((($2)) + 8|0); //@line 92585 "c/sqlite3.c"
 HEAP32[$12>>2] = 154; //@line 92585 "c/sqlite3.c"
 $13 = ((($2)) + 12|0); //@line 92586 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 92586 "c/sqlite3.c"
 $14 = ((($2)) + 24|0); //@line 92587 "c/sqlite3.c"
 HEAP32[$14>>2] = $0; //@line 92587 "c/sqlite3.c"
 $15 = ((($1)) + 24|0); //@line 92589 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 92589 "c/sqlite3.c"
 $17 = HEAP32[$2>>2]|0; //@line 92589 "c/sqlite3.c"
 $18 = ((($17)) + 408|0); //@line 92589 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 92589 "c/sqlite3.c"
 $20 = (($19) + ($16))|0; //@line 92589 "c/sqlite3.c"
 HEAP32[$18>>2] = $20; //@line 92589 "c/sqlite3.c"
 $21 = (_sqlite3ExprCheckHeight($17,$20)|0); //@line 92590 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 92590 "c/sqlite3.c"
 if (!($22)) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 92603 "c/sqlite3.c"
 }
 (_sqlite3WalkExpr($2,$1)|0); //@line 92594 "c/sqlite3.c"
 $23 = HEAP32[$15>>2]|0; //@line 92596 "c/sqlite3.c"
 $24 = HEAP32[$2>>2]|0; //@line 92596 "c/sqlite3.c"
 $25 = ((($24)) + 408|0); //@line 92596 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 92596 "c/sqlite3.c"
 $27 = (($26) - ($23))|0; //@line 92596 "c/sqlite3.c"
 HEAP32[$25>>2] = $27; //@line 92596 "c/sqlite3.c"
 $28 = HEAP16[$4>>1]|0; //@line 92598 "c/sqlite3.c"
 $29 = $28 & 16; //@line 92598 "c/sqlite3.c"
 $30 = ($29<<16>>16)==(0); //@line 92598 "c/sqlite3.c"
 if (!($30)) {
  $31 = ((($1)) + 4|0); //@line 92599 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 92599 "c/sqlite3.c"
  $33 = $32 | 2; //@line 92599 "c/sqlite3.c"
  HEAP32[$31>>2] = $33; //@line 92599 "c/sqlite3.c"
 }
 $34 = $28&65535; //@line 92601 "c/sqlite3.c"
 $35 = $7 | $34; //@line 92601 "c/sqlite3.c"
 $36 = $35&65535; //@line 92601 "c/sqlite3.c"
 HEAP16[$4>>1] = $36; //@line 92601 "c/sqlite3.c"
 $37 = ((($0)) + 24|0); //@line 92602 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 92602 "c/sqlite3.c"
 $39 = ($38|0)>(0); //@line 92602 "c/sqlite3.c"
 if ($39) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 92603 "c/sqlite3.c"
 }
 $40 = ((($24)) + 36|0); //@line 92602 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 92602 "c/sqlite3.c"
 $42 = ($41|0)>(0); //@line 92602 "c/sqlite3.c"
 $phitmp = $42&1; //@line 92602 "c/sqlite3.c"
 $$0 = $phitmp;
 STACKTOP = sp;return ($$0|0); //@line 92603 "c/sqlite3.c"
}
function _sqlite3ResolveExprListNames($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$08 = 0, $$09 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 92615 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$08 = 0;
  } else {
   $3 = HEAP32[$1>>2]|0; //@line 92616 "c/sqlite3.c"
   $4 = ($3|0)>(0); //@line 92616 "c/sqlite3.c"
   if ($4) {
    $$09 = 0;
    while(1) {
     $8 = (((($1)) + 4|0) + (($$09*20)|0)|0); //@line 92617 "c/sqlite3.c"
     $9 = HEAP32[$8>>2]|0; //@line 92617 "c/sqlite3.c"
     $10 = (_sqlite3ResolveExprNames($0,$9)|0); //@line 92617 "c/sqlite3.c"
     $11 = ($10|0)==(0); //@line 92617 "c/sqlite3.c"
     $7 = (($$09) + 1)|0; //@line 92616 "c/sqlite3.c"
     if (!($11)) {
      $$08 = 2;
      break L1;
     }
     $5 = HEAP32[$1>>2]|0; //@line 92616 "c/sqlite3.c"
     $6 = ($7|0)<($5|0); //@line 92616 "c/sqlite3.c"
     if ($6) {
      $$09 = $7;
     } else {
      $$08 = 0;
      break;
     }
    }
   } else {
    $$08 = 0;
   }
  }
 } while(0);
 return ($$08|0); //@line 92621 "c/sqlite3.c"
}
function _resolveOrderGroupBy($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$05161 = 0, $$05358 = 0, $$05459 = 0, $$2 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ($2|0)==(0|0); //@line 92260 "c/sqlite3.c"
 if ($5) {
  $$2 = 0;
  STACKTOP = sp;return ($$2|0); //@line 92301 "c/sqlite3.c"
 }
 $6 = HEAP32[$1>>2]|0; //@line 92261 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 92261 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 92262 "c/sqlite3.c"
 $9 = HEAP32[$2>>2]|0; //@line 92263 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 92263 "c/sqlite3.c"
 L4: do {
  if ($10) {
   $11 = ((($2)) + 4|0); //@line 92263 "c/sqlite3.c"
   $$05161 = 0;$$05459 = $11;
   L6: while(1) {
    $12 = HEAP32[$$05459>>2]|0; //@line 92264 "c/sqlite3.c"
    $13 = (_sqlite3ExprSkipCollate($12)|0); //@line 92265 "c/sqlite3.c"
    $14 = HEAP8[$3>>0]|0; //@line 92266 "c/sqlite3.c"
    $15 = ($14<<24>>24)==(71); //@line 92266 "c/sqlite3.c"
    if ($15) {
     label = 7;
    } else {
     $16 = HEAP32[$1>>2]|0; //@line 92267 "c/sqlite3.c"
     $17 = (_resolveAsName($16,$13)|0); //@line 92267 "c/sqlite3.c"
     HEAP32[$4>>2] = $17; //@line 92267 "c/sqlite3.c"
     $18 = ($17|0)>(0); //@line 92268 "c/sqlite3.c"
     if ($18) {
      $19 = $17&65535; //@line 92273 "c/sqlite3.c"
      $20 = ((($$05459)) + 16|0); //@line 92273 "c/sqlite3.c"
      HEAP16[$20>>1] = $19; //@line 92273 "c/sqlite3.c"
     } else {
      label = 7;
     }
    }
    do {
     if ((label|0) == 7) {
      label = 0;
      $21 = (_sqlite3ExprIsInteger($13,$4)|0); //@line 92277 "c/sqlite3.c"
      $22 = ($21|0)==(0); //@line 92277 "c/sqlite3.c"
      if (!($22)) {
       $23 = HEAP32[$4>>2]|0; //@line 92281 "c/sqlite3.c"
       $$off = (($23) + -1)|0; //@line 92281 "c/sqlite3.c"
       $24 = ($$off>>>0)>(65534); //@line 92281 "c/sqlite3.c"
       if ($24) {
        break L6;
       }
       $26 = $23&65535; //@line 92285 "c/sqlite3.c"
       $27 = ((($$05459)) + 16|0); //@line 92285 "c/sqlite3.c"
       HEAP16[$27>>1] = $26; //@line 92285 "c/sqlite3.c"
       break;
      }
      $28 = ((($$05459)) + 16|0); //@line 92290 "c/sqlite3.c"
      HEAP16[$28>>1] = 0; //@line 92290 "c/sqlite3.c"
      $29 = (_sqlite3ResolveExprNames($0,$12)|0); //@line 92291 "c/sqlite3.c"
      $30 = ($29|0)==(0); //@line 92291 "c/sqlite3.c"
      if (!($30)) {
       $$2 = 1;
       label = 19;
       break L6;
      }
      $31 = HEAP32[$1>>2]|0; //@line 92294 "c/sqlite3.c"
      $32 = HEAP32[$31>>2]|0; //@line 92294 "c/sqlite3.c"
      $33 = ($32|0)>(0); //@line 92294 "c/sqlite3.c"
      if ($33) {
       $$05358 = 0;$35 = $31;
       while(1) {
        $34 = (((($35)) + 4|0) + (($$05358*20)|0)|0); //@line 92295 "c/sqlite3.c"
        $36 = HEAP32[$34>>2]|0; //@line 92295 "c/sqlite3.c"
        $37 = (_sqlite3ExprCompare(0,$12,$36,-1)|0); //@line 92295 "c/sqlite3.c"
        $38 = ($37|0)==(0); //@line 92295 "c/sqlite3.c"
        if ($38) {
         $39 = (($$05358) + 1)|0; //@line 92296 "c/sqlite3.c"
         $40 = $39&65535; //@line 92296 "c/sqlite3.c"
         HEAP16[$28>>1] = $40; //@line 92296 "c/sqlite3.c"
        }
        $41 = (($$05358) + 1)|0; //@line 92294 "c/sqlite3.c"
        $42 = HEAP32[$1>>2]|0; //@line 92294 "c/sqlite3.c"
        $43 = HEAP32[$42>>2]|0; //@line 92294 "c/sqlite3.c"
        $44 = ($41|0)<($43|0); //@line 92294 "c/sqlite3.c"
        if ($44) {
         $$05358 = $41;$35 = $42;
        } else {
         break;
        }
       }
      }
     }
    } while(0);
    $45 = (($$05161) + 1)|0; //@line 92263 "c/sqlite3.c"
    $46 = ((($$05459)) + 20|0); //@line 92263 "c/sqlite3.c"
    $47 = HEAP32[$2>>2]|0; //@line 92263 "c/sqlite3.c"
    $48 = ($45|0)<($47|0); //@line 92263 "c/sqlite3.c"
    if ($48) {
     $$05161 = $45;$$05459 = $46;
    } else {
     break L4;
    }
   }
   if ((label|0) == 19) {
    STACKTOP = sp;return ($$2|0); //@line 92301 "c/sqlite3.c"
   }
   $25 = (($$05161) + 1)|0; //@line 92282 "c/sqlite3.c"
   _resolveOutOfRangeError($8,$3,$25,$7); //@line 92282 "c/sqlite3.c"
   $$2 = 1;
   STACKTOP = sp;return ($$2|0); //@line 92301 "c/sqlite3.c"
  }
 } while(0);
 $49 = (_sqlite3ResolveOrderGroupBy($8,$1,$2,$3)|0); //@line 92300 "c/sqlite3.c"
 $$2 = $49;
 STACKTOP = sp;return ($$2|0); //@line 92301 "c/sqlite3.c"
}
function _sqlite3SelectWrongNumTermsError($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 121280 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 121280 "c/sqlite3.c"
 $2 = ((($1)) + 8|0); //@line 121281 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 121281 "c/sqlite3.c"
 $4 = $3 & 512; //@line 121281 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 121281 "c/sqlite3.c"
 if ($5) {
  $6 = ((($1)) + 4|0); //@line 121285 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 121285 "c/sqlite3.c"
  $8 = $7&255; //@line 121285 "c/sqlite3.c"
  $9 = (_selectOpName($8)|0); //@line 121285 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = $9; //@line 121284 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,23222,$vararg_buffer1); //@line 121284 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 121287 "c/sqlite3.c"
 } else {
  _sqlite3ErrorMsg($0,23176,$vararg_buffer); //@line 121282 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 121287 "c/sqlite3.c"
 }
}
function _resolveCompoundOrderBy($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$091$lcssa = 0, $$091133 = 0, $$091133$phi = 0, $$094138 = 0, $$097125 = 0, $$1102124 = 0, $$192129 = 0, $$195127 = 0, $$296123 = 0, $$3104$ph = 0, $$6 = 0, $$pr = 0, $$pr149 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0;
 var $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $9 = 0, $exitcond = 0;
 var $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 12|0;
 $3 = ((($1)) + 44|0); //@line 92113 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 92113 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 92114 "c/sqlite3.c"
 if ($5) {
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0; //@line 92115 "c/sqlite3.c"
 $7 = HEAP32[$4>>2]|0; //@line 92116 "c/sqlite3.c"
 $8 = ((($6)) + 108|0); //@line 92116 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 92116 "c/sqlite3.c"
 $10 = ($7|0)>($9|0); //@line 92116 "c/sqlite3.c"
 if ($10) {
  _sqlite3ErrorMsg($0,23025,$vararg_buffer); //@line 92117 "c/sqlite3.c"
  $$6 = 1;
  STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
 }
 $11 = ($7|0)>(0); //@line 92120 "c/sqlite3.c"
 if ($11) {
  $$094138 = 0;
  while(1) {
   $12 = (((((($4)) + 4|0) + (($$094138*20)|0)|0)) + 13|0); //@line 92121 "c/sqlite3.c"
   $13 = HEAP8[$12>>0]|0; //@line 92121 "c/sqlite3.c"
   $14 = $13 & -2; //@line 92121 "c/sqlite3.c"
   HEAP8[$12>>0] = $14; //@line 92121 "c/sqlite3.c"
   $15 = (($$094138) + 1)|0; //@line 92120 "c/sqlite3.c"
   $exitcond = ($15|0)==($7|0); //@line 92120 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$094138 = $15;
   }
  }
 }
 $16 = ((($1)) + 52|0); //@line 92123 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 92123 "c/sqlite3.c"
 $17 = ((($1)) + 48|0); //@line 92124 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 92124 "c/sqlite3.c"
 $19 = ($18|0)==(0|0); //@line 92124 "c/sqlite3.c"
 if ($19) {
  $$091$lcssa = $1;
 } else {
  $$091133 = $1;$21 = $18;
  while(1) {
   $20 = ((($21)) + 52|0); //@line 92125 "c/sqlite3.c"
   HEAP32[$20>>2] = $$091133; //@line 92125 "c/sqlite3.c"
   $22 = ((($21)) + 48|0); //@line 92124 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 92124 "c/sqlite3.c"
   $24 = ($23|0)==(0|0); //@line 92124 "c/sqlite3.c"
   if ($24) {
    $$091$lcssa = $21;
    break;
   } else {
    $$091133$phi = $21;$21 = $23;$$091133 = $$091133$phi;
   }
  }
 }
 $25 = ((($4)) + 4|0);
 $26 = ((($6)) + 73|0);
 $$192129 = $$091$lcssa;
 L18: while(1) {
  $27 = HEAP32[$$192129>>2]|0; //@line 92131 "c/sqlite3.c"
  $28 = HEAP32[$4>>2]|0; //@line 92133 "c/sqlite3.c"
  $29 = ($28|0)>(0); //@line 92133 "c/sqlite3.c"
  if (!($29)) {
   $$6 = 0;
   label = 38;
   break;
  }
  $$097125 = $25;$$1102124 = 0;$$195127 = 0;
  while(1) {
   HEAP32[$2>>2] = -1; //@line 92134 "c/sqlite3.c"
   $30 = ((($$097125)) + 13|0); //@line 92136 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 92136 "c/sqlite3.c"
   $32 = $31 & 1; //@line 92136 "c/sqlite3.c"
   $33 = ($32<<24>>24)==(0); //@line 92136 "c/sqlite3.c"
   if ($33) {
    $34 = HEAP32[$$097125>>2]|0; //@line 92137 "c/sqlite3.c"
    $35 = (_sqlite3ExprSkipCollate($34)|0); //@line 92137 "c/sqlite3.c"
    $36 = (_sqlite3ExprIsInteger($35,$2)|0); //@line 92138 "c/sqlite3.c"
    $37 = ($36|0)==(0); //@line 92138 "c/sqlite3.c"
    if ($37) {
     $44 = (_resolveAsName($27,$35)|0); //@line 92144 "c/sqlite3.c"
     HEAP32[$2>>2] = $44; //@line 92144 "c/sqlite3.c"
     $45 = ($44|0)==(0); //@line 92145 "c/sqlite3.c"
     if ($45) {
      $46 = (_sqlite3ExprDup($6,$35,0)|0); //@line 92146 "c/sqlite3.c"
      $47 = HEAP8[$26>>0]|0; //@line 92147 "c/sqlite3.c"
      $48 = ($47<<24>>24)==(0); //@line 92147 "c/sqlite3.c"
      if ($48) {
       $49 = (_resolveOrderByTermToExprList($0,$$192129,$46)|0); //@line 92149 "c/sqlite3.c"
       HEAP32[$2>>2] = $49; //@line 92149 "c/sqlite3.c"
      }
      _sqlite3ExprDelete($6,$46); //@line 92151 "c/sqlite3.c"
      label = 22;
     } else {
      $51 = $44;
     }
    } else {
     $38 = HEAP32[$2>>2]|0; //@line 92139 "c/sqlite3.c"
     $39 = ($38|0)<(1); //@line 92139 "c/sqlite3.c"
     if ($39) {
      label = 17;
      break L18;
     }
     $40 = HEAP32[$27>>2]|0; //@line 92139 "c/sqlite3.c"
     $41 = ($38|0)>($40|0); //@line 92139 "c/sqlite3.c"
     if ($41) {
      label = 17;
      break L18;
     } else {
      label = 22;
     }
    }
    if ((label|0) == 22) {
     label = 0;
     $$pr = HEAP32[$2>>2]|0; //@line 92154 "c/sqlite3.c"
     $51 = $$pr;
    }
    $50 = ($51|0)>(0); //@line 92154 "c/sqlite3.c"
    if ($50) {
     $52 = (_sqlite3Expr($6,134,0)|0); //@line 92157 "c/sqlite3.c"
     $53 = ($52|0)==(0|0); //@line 92158 "c/sqlite3.c"
     if ($53) {
      break L18;
     }
     $54 = ((($52)) + 4|0); //@line 92159 "c/sqlite3.c"
     $55 = HEAP32[$54>>2]|0; //@line 92159 "c/sqlite3.c"
     $56 = $55 | 1024; //@line 92159 "c/sqlite3.c"
     HEAP32[$54>>2] = $56; //@line 92159 "c/sqlite3.c"
     $57 = ((($52)) + 8|0); //@line 92160 "c/sqlite3.c"
     HEAP32[$57>>2] = $51; //@line 92160 "c/sqlite3.c"
     $58 = HEAP32[$$097125>>2]|0; //@line 92161 "c/sqlite3.c"
     $59 = ($58|0)==($35|0); //@line 92161 "c/sqlite3.c"
     if ($59) {
      $$sink = $$097125;
     } else {
      $$0 = $58;
      while(1) {
       $60 = ((($$0)) + 12|0); //@line 92166 "c/sqlite3.c"
       $61 = HEAP32[$60>>2]|0; //@line 92166 "c/sqlite3.c"
       $62 = HEAP8[$61>>0]|0; //@line 92166 "c/sqlite3.c"
       $63 = ($62<<24>>24)==(94); //@line 92166 "c/sqlite3.c"
       if ($63) {
        $$0 = $61;
       } else {
        break;
       }
      }
      $64 = ((($$0)) + 12|0); //@line 92166 "c/sqlite3.c"
      $$sink = $64;
     }
     HEAP32[$$sink>>2] = $52;
     _sqlite3ExprDelete($6,$35); //@line 92170 "c/sqlite3.c"
     $65 = $51&65535; //@line 92171 "c/sqlite3.c"
     $66 = ((($$097125)) + 16|0); //@line 92171 "c/sqlite3.c"
     HEAP16[$66>>1] = $65; //@line 92171 "c/sqlite3.c"
     $67 = HEAP8[$30>>0]|0; //@line 92172 "c/sqlite3.c"
     $68 = $67 | 1; //@line 92172 "c/sqlite3.c"
     HEAP8[$30>>0] = $68; //@line 92172 "c/sqlite3.c"
     $$3104$ph = $$1102124;
    } else {
     $$3104$ph = 1;
    }
   } else {
    $$3104$ph = $$1102124;
   }
   $69 = (($$195127) + 1)|0; //@line 92133 "c/sqlite3.c"
   $70 = ((($$097125)) + 20|0); //@line 92133 "c/sqlite3.c"
   $71 = HEAP32[$4>>2]|0; //@line 92133 "c/sqlite3.c"
   $72 = ($69|0)<($71|0); //@line 92133 "c/sqlite3.c"
   if ($72) {
    $$097125 = $70;$$1102124 = $$3104$ph;$$195127 = $69;
   } else {
    break;
   }
  }
  $73 = ((($$192129)) + 52|0); //@line 92177 "c/sqlite3.c"
  $74 = HEAP32[$73>>2]|0; //@line 92177 "c/sqlite3.c"
  $75 = ($74|0)!=(0|0); //@line 92128 "c/sqlite3.c"
  $76 = ($$3104$ph|0)!=(0); //@line 92128 "c/sqlite3.c"
  $77 = $76 & $75; //@line 92128 "c/sqlite3.c"
  if ($77) {
   $$192129 = $74;
  } else {
   label = 33;
   break;
  }
 }
 if ((label|0) == 17) {
  $42 = (($$195127) + 1)|0; //@line 92140 "c/sqlite3.c"
  $43 = HEAP32[$27>>2]|0; //@line 92140 "c/sqlite3.c"
  _resolveOutOfRangeError($0,22954,$42,$43); //@line 92140 "c/sqlite3.c"
 }
 else if ((label|0) == 33) {
  $$pr149 = HEAP32[$4>>2]|0; //@line 92179 "c/sqlite3.c"
  $78 = ($$pr149|0)>(0); //@line 92179 "c/sqlite3.c"
  if (!($78)) {
   $$6 = 0;
   STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
  }
  $$296123 = 0;
  while(1) {
   $82 = (((((($4)) + 4|0) + (($$296123*20)|0)|0)) + 13|0); //@line 92180 "c/sqlite3.c"
   $83 = HEAP8[$82>>0]|0; //@line 92180 "c/sqlite3.c"
   $84 = $83 & 1; //@line 92180 "c/sqlite3.c"
   $85 = ($84<<24>>24)==(0); //@line 92180 "c/sqlite3.c"
   $81 = (($$296123) + 1)|0;
   if ($85) {
    break;
   }
   $79 = HEAP32[$4>>2]|0; //@line 92179 "c/sqlite3.c"
   $80 = ($81|0)<($79|0); //@line 92179 "c/sqlite3.c"
   if ($80) {
    $$296123 = $81;
   } else {
    $$6 = 0;
    label = 38;
    break;
   }
  }
  if ((label|0) == 38) {
   STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
  }
  HEAP32[$vararg_buffer1>>2] = $81; //@line 92181 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,23059,$vararg_buffer1); //@line 92181 "c/sqlite3.c"
  $$6 = 1;
  STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
 }
 else if ((label|0) == 38) {
  STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
 }
 $$6 = 1;
 STACKTOP = sp;return ($$6|0); //@line 92187 "c/sqlite3.c"
}
function _sqlite3ExprIsInteger($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$010 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ($0|0)==(0|0); //@line 94647 "c/sqlite3.c"
 L1: do {
  if ($3) {
   $$010 = 0;
  } else {
   $4 = ((($0)) + 4|0); //@line 94654 "c/sqlite3.c"
   $5 = HEAP32[$4>>2]|0; //@line 94654 "c/sqlite3.c"
   $6 = $5 & 1024; //@line 94654 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 94654 "c/sqlite3.c"
   if (!($7)) {
    $8 = ((($0)) + 8|0); //@line 94655 "c/sqlite3.c"
    $9 = HEAP32[$8>>2]|0; //@line 94655 "c/sqlite3.c"
    HEAP32[$1>>2] = $9; //@line 94655 "c/sqlite3.c"
    $$010 = 1;
    break;
   }
   $10 = HEAP8[$0>>0]|0; //@line 94658 "c/sqlite3.c"
   switch ($10<<24>>24) {
   case -107:  {
    $11 = ((($0)) + 12|0); //@line 94660 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 94660 "c/sqlite3.c"
    $13 = (_sqlite3ExprIsInteger($12,$1)|0); //@line 94660 "c/sqlite3.c"
    $$010 = $13;
    break L1;
    break;
   }
   case -108:  {
    break;
   }
   default: {
    $$010 = 0;
    break L1;
   }
   }
   $14 = ((($0)) + 12|0); //@line 94665 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 94665 "c/sqlite3.c"
   $16 = (_sqlite3ExprIsInteger($15,$2)|0); //@line 94665 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 94665 "c/sqlite3.c"
   if ($17) {
    $$0 = 0;
   } else {
    $18 = HEAP32[$2>>2]|0; //@line 94667 "c/sqlite3.c"
    $19 = (0 - ($18))|0; //@line 94667 "c/sqlite3.c"
    HEAP32[$1>>2] = $19; //@line 94667 "c/sqlite3.c"
    $$0 = 1;
   }
   $$010 = $$0;
  }
 } while(0);
 STACKTOP = sp;return ($$010|0); //@line 94675 "c/sqlite3.c"
}
function _resolveOutOfRangeError($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 92078 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 92083 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 92083 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $1; //@line 92083 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 92083 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $3; //@line 92083 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,23120,$vararg_buffer); //@line 92083 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 92086 "c/sqlite3.c"
}
function _resolveAsName($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0225 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 92000 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(59); //@line 92000 "c/sqlite3.c"
 if (!($3)) {
  $$3 = 0;
  return ($$3|0); //@line 92010 "c/sqlite3.c"
 }
 $4 = ((($1)) + 8|0); //@line 92001 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 92001 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 92002 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 92002 "c/sqlite3.c"
 if (!($7)) {
  $$3 = 0;
  return ($$3|0); //@line 92010 "c/sqlite3.c"
 }
 $$0225 = 0;
 while(1) {
  $8 = (((((($0)) + 4|0) + (($$0225*20)|0)|0)) + 4|0); //@line 92003 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 92003 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 92004 "c/sqlite3.c"
  if (!($10)) {
   $11 = (_sqlite3StrICmp($9,$5)|0); //@line 92004 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 92004 "c/sqlite3.c"
   if ($12) {
    break;
   }
  }
  $13 = (($$0225) + 1)|0; //@line 92002 "c/sqlite3.c"
  $14 = HEAP32[$0>>2]|0; //@line 92002 "c/sqlite3.c"
  $15 = ($13|0)<($14|0); //@line 92002 "c/sqlite3.c"
  if ($15) {
   $$0225 = $13;
  } else {
   $$3 = 0;
   label = 8;
   break;
  }
 }
 if ((label|0) == 8) {
  return ($$3|0); //@line 92010 "c/sqlite3.c"
 }
 $16 = (($$0225) + 1)|0; //@line 92005 "c/sqlite3.c"
 $$3 = $16;
 return ($$3|0); //@line 92010 "c/sqlite3.c"
}
function _sqlite3ExprDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 94014 "c/sqlite3.c"
 if ($3) {
  $5 = 0;
 } else {
  $4 = (_exprDup($0,$1,$2,0)|0); //@line 94014 "c/sqlite3.c"
  $5 = $4;
 }
 return ($5|0); //@line 94014 "c/sqlite3.c"
}
function _resolveOrderByTermToExprList($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$02425 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = HEAP32[$1>>2]|0; //@line 92043 "c/sqlite3.c"
 $5 = ((($3)) + 12|0);
 ;HEAP32[$5>>2]=0|0;HEAP32[$5+4>>2]=0|0;HEAP32[$5+8>>2]=0|0;HEAP32[$5+12>>2]=0|0;HEAP32[$5+16>>2]=0|0; //@line 92047 "c/sqlite3.c"
 HEAP32[$3>>2] = $0; //@line 92048 "c/sqlite3.c"
 $6 = ((($1)) + 28|0); //@line 92049 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 92049 "c/sqlite3.c"
 $8 = ((($3)) + 4|0); //@line 92049 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 92049 "c/sqlite3.c"
 $9 = ((($3)) + 8|0); //@line 92050 "c/sqlite3.c"
 HEAP32[$9>>2] = $4; //@line 92050 "c/sqlite3.c"
 $10 = ((($3)) + 28|0); //@line 92051 "c/sqlite3.c"
 HEAP16[$10>>1] = 1; //@line 92051 "c/sqlite3.c"
 $11 = ((($3)) + 24|0); //@line 92052 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 92052 "c/sqlite3.c"
 $12 = HEAP32[$0>>2]|0; //@line 92053 "c/sqlite3.c"
 $13 = ((($12)) + 77|0); //@line 92054 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 92054 "c/sqlite3.c"
 HEAP8[$13>>0] = 1; //@line 92055 "c/sqlite3.c"
 $15 = (_sqlite3ResolveExprNames($3,$2)|0); //@line 92056 "c/sqlite3.c"
 HEAP8[$13>>0] = $14; //@line 92057 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 92058 "c/sqlite3.c"
 if (!($16)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 92072 "c/sqlite3.c"
 }
 $17 = HEAP32[$4>>2]|0; //@line 92064 "c/sqlite3.c"
 $18 = ($17|0)>(0); //@line 92064 "c/sqlite3.c"
 if (!($18)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 92072 "c/sqlite3.c"
 }
 $$02425 = 0;
 while(1) {
  $22 = (((($4)) + 4|0) + (($$02425*20)|0)|0); //@line 92065 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 92065 "c/sqlite3.c"
  $24 = (_sqlite3ExprCompare(0,$23,$2,-1)|0); //@line 92065 "c/sqlite3.c"
  $25 = ($24|0)<(2); //@line 92065 "c/sqlite3.c"
  $21 = (($$02425) + 1)|0;
  if ($25) {
   $$0 = $21;
   label = 6;
   break;
  }
  $19 = HEAP32[$4>>2]|0; //@line 92064 "c/sqlite3.c"
  $20 = ($21|0)<($19|0); //@line 92064 "c/sqlite3.c"
  if ($20) {
   $$02425 = $21;
  } else {
   $$0 = 0;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  STACKTOP = sp;return ($$0|0); //@line 92072 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprCompare($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $or$cond = 0, $or$cond59 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 97477 "c/sqlite3.c"
 $5 = ($2|0)==(0|0); //@line 97477 "c/sqlite3.c"
 $or$cond = $4 | $5; //@line 97477 "c/sqlite3.c"
 if ($or$cond) {
  $6 = ($2|0)==($1|0); //@line 97478 "c/sqlite3.c"
  $7 = $6 ? 0 : 2; //@line 97478 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 97519 "c/sqlite3.c"
 }
 $8 = ($0|0)==(0|0); //@line 97480 "c/sqlite3.c"
 if (!($8)) {
  $9 = HEAP8[$1>>0]|0; //@line 97480 "c/sqlite3.c"
  $10 = ($9<<24>>24)==(-121); //@line 97480 "c/sqlite3.c"
  if ($10) {
   $11 = (_exprCompareVariable($0,$1,$2)|0); //@line 97480 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 97480 "c/sqlite3.c"
   if (!($12)) {
    $$0 = 0;
    return ($$0|0); //@line 97519 "c/sqlite3.c"
   }
  }
 }
 $13 = ((($1)) + 4|0); //@line 97483 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 97483 "c/sqlite3.c"
 $15 = ((($2)) + 4|0); //@line 97483 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 97483 "c/sqlite3.c"
 $17 = $16 | $14; //@line 97483 "c/sqlite3.c"
 $18 = $17 & 1024; //@line 97484 "c/sqlite3.c"
 $19 = ($18|0)==(0); //@line 97484 "c/sqlite3.c"
 if (!($19)) {
  $20 = $14 & 1024; //@line 97485 "c/sqlite3.c"
  $21 = $20 & $16; //@line 97485 "c/sqlite3.c"
  $22 = ($21|0)==(0); //@line 97485 "c/sqlite3.c"
  if (!($22)) {
   $23 = ((($1)) + 8|0); //@line 97485 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 97485 "c/sqlite3.c"
   $25 = ((($2)) + 8|0); //@line 97485 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 97485 "c/sqlite3.c"
   $27 = ($24|0)==($26|0); //@line 97485 "c/sqlite3.c"
   if ($27) {
    $$0 = 0;
    return ($$0|0); //@line 97519 "c/sqlite3.c"
   }
  }
  $$0 = 2;
  return ($$0|0); //@line 97519 "c/sqlite3.c"
 }
 $28 = HEAP8[$1>>0]|0; //@line 97490 "c/sqlite3.c"
 $29 = HEAP8[$2>>0]|0; //@line 97490 "c/sqlite3.c"
 $30 = ($28<<24>>24)==($29<<24>>24); //@line 97490 "c/sqlite3.c"
 if (!($30)) {
  $31 = ($28<<24>>24)==(94); //@line 97491 "c/sqlite3.c"
  do {
   if ($31) {
    $32 = ((($1)) + 12|0); //@line 97491 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 97491 "c/sqlite3.c"
    $34 = (_sqlite3ExprCompare($0,$33,$2,$3)|0); //@line 97491 "c/sqlite3.c"
    $35 = ($34|0)<(2); //@line 97491 "c/sqlite3.c"
    if ($35) {
     $$0 = 1;
     return ($$0|0); //@line 97519 "c/sqlite3.c"
    } else {
     $$pr = HEAP8[$2>>0]|0; //@line 97494 "c/sqlite3.c"
     $37 = $$pr;
     break;
    }
   } else {
    $37 = $29;
   }
  } while(0);
  $36 = ($37<<24>>24)==(94); //@line 97494 "c/sqlite3.c"
  if ($36) {
   $38 = ((($2)) + 12|0); //@line 97494 "c/sqlite3.c"
   $39 = HEAP32[$38>>2]|0; //@line 97494 "c/sqlite3.c"
   $40 = (_sqlite3ExprCompare($0,$1,$39,$3)|0); //@line 97494 "c/sqlite3.c"
   $41 = ($40|0)<(2); //@line 97494 "c/sqlite3.c"
   if ($41) {
    $$0 = 1;
    return ($$0|0); //@line 97519 "c/sqlite3.c"
   }
  }
  $$0 = 2;
  return ($$0|0); //@line 97519 "c/sqlite3.c"
 }
 L32: do {
  switch ($28<<24>>24) {
  case -109: case -111:  {
   break;
  }
  default: {
   $42 = ((($1)) + 8|0); //@line 97499 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 97499 "c/sqlite3.c"
   $44 = ($43|0)==(0|0); //@line 97499 "c/sqlite3.c"
   if (!($44)) {
    $45 = ($28<<24>>24)==(-112); //@line 97500 "c/sqlite3.c"
    $46 = ((($2)) + 8|0);
    $47 = HEAP32[$46>>2]|0;
    if ($45) {
     $48 = (_sqlite3StrICmp($43,$47)|0); //@line 97501 "c/sqlite3.c"
     $49 = ($48|0)==(0); //@line 97501 "c/sqlite3.c"
     if ($49) {
      break L32;
     } else {
      $$0 = 2;
     }
     return ($$0|0); //@line 97519 "c/sqlite3.c"
    }
    $50 = (_strcmp($43,$47)|0); //@line 97502 "c/sqlite3.c"
    $51 = ($50|0)==(0); //@line 97502 "c/sqlite3.c"
    if (!($51)) {
     $52 = ($28<<24>>24)==(94); //@line 97503 "c/sqlite3.c"
     $53 = $52 ? 1 : 2; //@line 97503 "c/sqlite3.c"
     $$0 = $53;
     return ($$0|0); //@line 97519 "c/sqlite3.c"
    }
   }
  }
  }
 } while(0);
 $54 = $16 ^ $14; //@line 97506 "c/sqlite3.c"
 $55 = $54 & 16; //@line 97506 "c/sqlite3.c"
 $56 = ($55|0)==(0); //@line 97506 "c/sqlite3.c"
 if (!($56)) {
  $$0 = 2;
  return ($$0|0); //@line 97519 "c/sqlite3.c"
 }
 $57 = $17 & 16384; //@line 97507 "c/sqlite3.c"
 $58 = ($57|0)==(0); //@line 97507 "c/sqlite3.c"
 if ($58) {
  $59 = $17 & 2048; //@line 97508 "c/sqlite3.c"
  $60 = ($59|0)==(0); //@line 97508 "c/sqlite3.c"
  if (!($60)) {
   $$0 = 2;
   return ($$0|0); //@line 97519 "c/sqlite3.c"
  }
  $61 = ((($1)) + 12|0); //@line 97509 "c/sqlite3.c"
  $62 = HEAP32[$61>>2]|0; //@line 97509 "c/sqlite3.c"
  $63 = ((($2)) + 12|0); //@line 97509 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 97509 "c/sqlite3.c"
  $65 = (_sqlite3ExprCompare($0,$62,$64,$3)|0); //@line 97509 "c/sqlite3.c"
  $66 = ($65|0)==(0); //@line 97509 "c/sqlite3.c"
  if (!($66)) {
   $$0 = 2;
   return ($$0|0); //@line 97519 "c/sqlite3.c"
  }
  $67 = ((($1)) + 16|0); //@line 97510 "c/sqlite3.c"
  $68 = HEAP32[$67>>2]|0; //@line 97510 "c/sqlite3.c"
  $69 = ((($2)) + 16|0); //@line 97510 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 97510 "c/sqlite3.c"
  $71 = (_sqlite3ExprCompare($0,$68,$70,$3)|0); //@line 97510 "c/sqlite3.c"
  $72 = ($71|0)==(0); //@line 97510 "c/sqlite3.c"
  if (!($72)) {
   $$0 = 2;
   return ($$0|0); //@line 97519 "c/sqlite3.c"
  }
  $73 = ((($1)) + 20|0); //@line 97511 "c/sqlite3.c"
  $74 = HEAP32[$73>>2]|0; //@line 97511 "c/sqlite3.c"
  $75 = ((($2)) + 20|0); //@line 97511 "c/sqlite3.c"
  $76 = HEAP32[$75>>2]|0; //@line 97511 "c/sqlite3.c"
  $77 = (_sqlite3ExprListCompare($74,$76,$3)|0); //@line 97511 "c/sqlite3.c"
  $78 = ($77|0)==(0); //@line 97511 "c/sqlite3.c"
  if (!($78)) {
   $$0 = 2;
   return ($$0|0); //@line 97519 "c/sqlite3.c"
  }
  $79 = $17 & 8192; //@line 97512 "c/sqlite3.c"
  $80 = ($79|0)==(0); //@line 97512 "c/sqlite3.c"
  if ($80) {
   $81 = HEAP8[$1>>0]|0; //@line 97512 "c/sqlite3.c"
   $82 = ($81<<24>>24)==(97); //@line 97512 "c/sqlite3.c"
   if (!($82)) {
    $83 = ((($1)) + 32|0); //@line 97513 "c/sqlite3.c"
    $84 = HEAP16[$83>>1]|0; //@line 97513 "c/sqlite3.c"
    $85 = ((($2)) + 32|0); //@line 97513 "c/sqlite3.c"
    $86 = HEAP16[$85>>1]|0; //@line 97513 "c/sqlite3.c"
    $87 = ($84<<16>>16)==($86<<16>>16); //@line 97513 "c/sqlite3.c"
    if (!($87)) {
     $$0 = 2;
     return ($$0|0); //@line 97519 "c/sqlite3.c"
    }
    $88 = ((($1)) + 28|0); //@line 97514 "c/sqlite3.c"
    $89 = HEAP32[$88>>2]|0; //@line 97514 "c/sqlite3.c"
    $90 = ((($2)) + 28|0); //@line 97514 "c/sqlite3.c"
    $91 = HEAP32[$90>>2]|0; //@line 97514 "c/sqlite3.c"
    $92 = ($89|0)==($91|0); //@line 97514 "c/sqlite3.c"
    if (!($92)) {
     $93 = ($89|0)!=($3|0); //@line 97515 "c/sqlite3.c"
     $94 = ($91|0)>(-1); //@line 97515 "c/sqlite3.c"
     $or$cond59 = $93 | $94; //@line 97515 "c/sqlite3.c"
     if ($or$cond59) {
      $$0 = 2;
      return ($$0|0); //@line 97519 "c/sqlite3.c"
     }
    }
   }
  }
 }
 $$0 = 0;
 return ($$0|0); //@line 97519 "c/sqlite3.c"
}
function _exprCompareVariable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 HEAP32[$3>>2] = 0; //@line 97426 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 97428 "c/sqlite3.c"
 (_sqlite3ValueFromExpr($4,$2,1,65,$3)|0); //@line 97428 "c/sqlite3.c"
 $5 = HEAP32[$3>>2]|0; //@line 97429 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 97429 "c/sqlite3.c"
 if ($6) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 97443 "c/sqlite3.c"
 }
 $7 = ((($1)) + 32|0); //@line 97430 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 97430 "c/sqlite3.c"
 $9 = $8 << 16 >> 16; //@line 97430 "c/sqlite3.c"
 $10 = ((($0)) + 8|0); //@line 97431 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 97431 "c/sqlite3.c"
 _sqlite3VdbeSetVarmask($11,$9); //@line 97431 "c/sqlite3.c"
 $12 = ((($0)) + 424|0); //@line 97432 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 97432 "c/sqlite3.c"
 $14 = (_sqlite3VdbeGetBoundValue($13,$9)|0); //@line 97432 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 97433 "c/sqlite3.c"
 if ($15) {
  $$0 = 0;
 } else {
  $16 = (_sqlite3_value_type($14)|0); //@line 97434 "c/sqlite3.c"
  $17 = ($16|0)==(3); //@line 97434 "c/sqlite3.c"
  if ($17) {
   (_sqlite3_value_text($14)|0); //@line 97435 "c/sqlite3.c"
  }
  $18 = (_sqlite3MemCompare($14,$5,0)|0); //@line 97437 "c/sqlite3.c"
  $19 = ($18|0)==(0); //@line 97437 "c/sqlite3.c"
  $20 = $19&1; //@line 97437 "c/sqlite3.c"
  $$0 = $20;
 }
 _sqlite3ValueFree($5); //@line 97439 "c/sqlite3.c"
 _sqlite3ValueFree($14); //@line 97440 "c/sqlite3.c"
 $$1 = $$0;
 STACKTOP = sp;return ($$1|0); //@line 97443 "c/sqlite3.c"
}
function _sqlite3ExprListCompare($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02931 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 97538 "c/sqlite3.c"
 $4 = ($1|0)==(0|0); //@line 97538 "c/sqlite3.c"
 $or$cond = $3 & $4; //@line 97538 "c/sqlite3.c"
 if ($or$cond) {
  $$2 = 0;
  return ($$2|0); //@line 97548 "c/sqlite3.c"
 }
 $or$cond3 = $3 | $4; //@line 97539 "c/sqlite3.c"
 if ($or$cond3) {
  $$2 = 1;
  return ($$2|0); //@line 97548 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 97540 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 97540 "c/sqlite3.c"
 $7 = ($5|0)==($6|0); //@line 97540 "c/sqlite3.c"
 if (!($7)) {
  $$2 = 1;
  return ($$2|0); //@line 97548 "c/sqlite3.c"
 }
 $8 = HEAP32[$0>>2]|0; //@line 97541 "c/sqlite3.c"
 $9 = ($8|0)>(0); //@line 97541 "c/sqlite3.c"
 if (!($9)) {
  $$2 = 0;
  return ($$2|0); //@line 97548 "c/sqlite3.c"
 }
 $$02931 = 0;
 while(1) {
  $13 = (((((($0)) + 4|0) + (($$02931*20)|0)|0)) + 12|0); //@line 97544 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 97544 "c/sqlite3.c"
  $15 = (((((($1)) + 4|0) + (($$02931*20)|0)|0)) + 12|0); //@line 97544 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 97544 "c/sqlite3.c"
  $17 = ($14<<24>>24)==($16<<24>>24); //@line 97544 "c/sqlite3.c"
  if (!($17)) {
   $$2 = 1;
   label = 9;
   break;
  }
  $18 = (((($1)) + 4|0) + (($$02931*20)|0)|0); //@line 97543 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 97543 "c/sqlite3.c"
  $20 = (((($0)) + 4|0) + (($$02931*20)|0)|0); //@line 97542 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 97542 "c/sqlite3.c"
  $22 = (_sqlite3ExprCompare(0,$21,$19,$2)|0); //@line 97545 "c/sqlite3.c"
  $23 = ($22|0)==(0); //@line 97545 "c/sqlite3.c"
  $12 = (($$02931) + 1)|0; //@line 97541 "c/sqlite3.c"
  if (!($23)) {
   $$2 = 1;
   label = 9;
   break;
  }
  $10 = HEAP32[$0>>2]|0; //@line 97541 "c/sqlite3.c"
  $11 = ($12|0)<($10|0); //@line 97541 "c/sqlite3.c"
  if ($11) {
   $$02931 = $12;
  } else {
   $$2 = 0;
   label = 9;
   break;
  }
 }
 if ((label|0) == 9) {
  return ($$2|0); //@line 97548 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeSetVarmask($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$sink = 0, $$sink3 = 0, $$sink5 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(31); //@line 77569 "c/sqlite3.c"
 $3 = (($1) + -1)|0; //@line 77572 "c/sqlite3.c"
 $4 = 1 << $3; //@line 77572 "c/sqlite3.c"
 $5 = ((($0)) + 204|0); //@line 77572 "c/sqlite3.c"
 $6 = ((($0)) + 204|0); //@line 77570 "c/sqlite3.c"
 $$sink = $2 ? $6 : $5; //@line 77569 "c/sqlite3.c"
 $$sink5 = $2 ? -2147483648 : $4; //@line 77569 "c/sqlite3.c"
 $$sink3 = $2 ? $6 : $5; //@line 77569 "c/sqlite3.c"
 $7 = HEAP32[$$sink>>2]|0;
 $8 = $7 | $$sink5;
 HEAP32[$$sink3>>2] = $8;
 return; //@line 77574 "c/sqlite3.c"
}
function _sqlite3VdbeGetBoundValue($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 77546 "c/sqlite3.c"
 if ($2) {
  $$1 = 0;
  return ($$1|0); //@line 77559 "c/sqlite3.c"
 }
 $3 = ((($0)) + 116|0); //@line 77547 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 77547 "c/sqlite3.c"
 $5 = (($1) + -1)|0; //@line 77547 "c/sqlite3.c"
 $6 = (($4) + (($5*40)|0)|0); //@line 77547 "c/sqlite3.c"
 $7 = (((($4) + (($5*40)|0)|0)) + 8|0); //@line 77549 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 77549 "c/sqlite3.c"
 $9 = $8 & 1; //@line 77549 "c/sqlite3.c"
 $10 = ($9<<16>>16)==(0); //@line 77549 "c/sqlite3.c"
 if (!($10)) {
  $$1 = 0;
  return ($$1|0); //@line 77559 "c/sqlite3.c"
 }
 $11 = HEAP32[$0>>2]|0; //@line 77550 "c/sqlite3.c"
 $12 = (_sqlite3ValueNew($11)|0); //@line 77550 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 77551 "c/sqlite3.c"
 if ($13) {
  $$1 = 0;
  return ($$1|0); //@line 77559 "c/sqlite3.c"
 }
 (_sqlite3VdbeMemCopy($12,$6)|0); //@line 77552 "c/sqlite3.c"
 _sqlite3ValueApplyAffinity($12,65,1); //@line 77553 "c/sqlite3.c"
 $$1 = $12;
 return ($$1|0); //@line 77559 "c/sqlite3.c"
}
function _exprDup($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$077 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ($3|0)!=(0|0); //@line 93886 "c/sqlite3.c"
 if ($5) {
  $6 = HEAP32[$3>>2]|0; //@line 93887 "c/sqlite3.c"
  $$0 = 32768;$storemerge = $6;
 } else {
  $7 = (_dupedExprSize($1,$2)|0); //@line 93890 "c/sqlite3.c"
  $8 = ($7|0)<(0); //@line 93890 "c/sqlite3.c"
  $9 = $8 << 31 >> 31; //@line 93890 "c/sqlite3.c"
  $10 = (_sqlite3DbMallocRawNN($0,$7,$9)|0); //@line 93890 "c/sqlite3.c"
  $$0 = 0;$storemerge = $10;
 }
 HEAP32[$4>>2] = $storemerge;
 $11 = ($storemerge|0)==(0|0); //@line 93895 "c/sqlite3.c"
 if ($11) {
  STACKTOP = sp;return ($storemerge|0); //@line 93965 "c/sqlite3.c"
 }
 $12 = (_dupedExprStructSize($1,$2)|0); //@line 93901 "c/sqlite3.c"
 $13 = $12 & 4095; //@line 93902 "c/sqlite3.c"
 $14 = ((($1)) + 4|0); //@line 93904 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 93904 "c/sqlite3.c"
 $16 = $15 & 1024; //@line 93904 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 93904 "c/sqlite3.c"
 if ($17) {
  $18 = ((($1)) + 8|0); //@line 93904 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 93904 "c/sqlite3.c"
  $20 = ($19|0)==(0|0); //@line 93904 "c/sqlite3.c"
  if ($20) {
   $$077 = 0;
  } else {
   $21 = (_sqlite3Strlen30($19)|0); //@line 93905 "c/sqlite3.c"
   $22 = (($21) + 1)|0; //@line 93905 "c/sqlite3.c"
   $$077 = $22;
  }
 } else {
  $$077 = 0;
 }
 $23 = ($2|0)==(0); //@line 93909 "c/sqlite3.c"
 if ($23) {
  $24 = (_exprStructSize($1)|0); //@line 93913 "c/sqlite3.c"
  _memcpy(($storemerge|0),($1|0),($24|0))|0; //@line 93914 "c/sqlite3.c"
  $25 = ($24>>>0)<(48); //@line 93915 "c/sqlite3.c"
  if ($25) {
   $26 = (48 - ($24))|0; //@line 93916 "c/sqlite3.c"
   $27 = HEAP32[$4>>2]|0; //@line 93916 "c/sqlite3.c"
   $28 = (($27) + ($24)|0); //@line 93916 "c/sqlite3.c"
   _memset(($28|0),0,($26|0))|0; //@line 93916 "c/sqlite3.c"
  }
 } else {
  _memcpy(($storemerge|0),($1|0),($13|0))|0; //@line 93911 "c/sqlite3.c"
 }
 $29 = ((($storemerge)) + 4|0); //@line 93921 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 93921 "c/sqlite3.c"
 $31 = $30 & -122881; //@line 93921 "c/sqlite3.c"
 $32 = $12 & 24576; //@line 93922 "c/sqlite3.c"
 $33 = $32 | $$0; //@line 93922 "c/sqlite3.c"
 $34 = $33 | $31; //@line 93923 "c/sqlite3.c"
 HEAP32[$29>>2] = $34; //@line 93923 "c/sqlite3.c"
 $35 = ($$077|0)==(0); //@line 93926 "c/sqlite3.c"
 if (!($35)) {
  $36 = HEAP32[$4>>2]|0; //@line 93927 "c/sqlite3.c"
  $37 = (($36) + ($13)|0); //@line 93927 "c/sqlite3.c"
  $38 = ((($storemerge)) + 8|0); //@line 93927 "c/sqlite3.c"
  HEAP32[$38>>2] = $37; //@line 93927 "c/sqlite3.c"
  $39 = ((($1)) + 8|0); //@line 93928 "c/sqlite3.c"
  $40 = HEAP32[$39>>2]|0; //@line 93928 "c/sqlite3.c"
  _memcpy(($37|0),($40|0),($$077|0))|0; //@line 93928 "c/sqlite3.c"
 }
 $41 = HEAP32[$14>>2]|0; //@line 93931 "c/sqlite3.c"
 $42 = HEAP32[$29>>2]|0; //@line 93931 "c/sqlite3.c"
 $43 = $42 | $41; //@line 93931 "c/sqlite3.c"
 $44 = $43 & 8404992; //@line 93931 "c/sqlite3.c"
 $45 = ($44|0)==(0); //@line 93931 "c/sqlite3.c"
 do {
  if ($45) {
   $46 = $41 & 2048; //@line 93933 "c/sqlite3.c"
   $47 = ($46|0)==(0); //@line 93933 "c/sqlite3.c"
   $48 = ((($1)) + 20|0);
   if ($47) {
    $52 = HEAP32[$48>>2]|0; //@line 93936 "c/sqlite3.c"
    $53 = (_sqlite3ExprListDup($0,$52,$2)|0); //@line 93936 "c/sqlite3.c"
    $54 = ((($storemerge)) + 20|0); //@line 93936 "c/sqlite3.c"
    HEAP32[$54>>2] = $53; //@line 93936 "c/sqlite3.c"
    break;
   } else {
    $49 = HEAP32[$48>>2]|0; //@line 93934 "c/sqlite3.c"
    $50 = (_sqlite3SelectDup($0,$49,$2)|0); //@line 93934 "c/sqlite3.c"
    $51 = ((($storemerge)) + 20|0); //@line 93934 "c/sqlite3.c"
    HEAP32[$51>>2] = $50; //@line 93934 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $55 = HEAP32[$29>>2]|0; //@line 93941 "c/sqlite3.c"
 $56 = $55 & 24576; //@line 93941 "c/sqlite3.c"
 $57 = ($56|0)==(0); //@line 93941 "c/sqlite3.c"
 if ($57) {
  $76 = HEAP32[$14>>2]|0; //@line 93953 "c/sqlite3.c"
  $77 = $76 & 8404992; //@line 93953 "c/sqlite3.c"
  $78 = ($77|0)==(0); //@line 93953 "c/sqlite3.c"
  if (!($78)) {
   STACKTOP = sp;return ($storemerge|0); //@line 93965 "c/sqlite3.c"
  }
  $79 = HEAP8[$storemerge>>0]|0; //@line 93954 "c/sqlite3.c"
  $80 = ($79<<24>>24)==(-104); //@line 93954 "c/sqlite3.c"
  $81 = ((($1)) + 12|0);
  if ($80) {
   $82 = HEAP32[$81>>2]|0; //@line 93955 "c/sqlite3.c"
   $83 = ((($storemerge)) + 12|0); //@line 93955 "c/sqlite3.c"
   HEAP32[$83>>2] = $82; //@line 93955 "c/sqlite3.c"
  } else {
   $84 = HEAP32[$81>>2]|0; //@line 93959 "c/sqlite3.c"
   $85 = (_sqlite3ExprDup($0,$84,0)|0); //@line 93959 "c/sqlite3.c"
   $86 = ((($storemerge)) + 12|0); //@line 93959 "c/sqlite3.c"
   HEAP32[$86>>2] = $85; //@line 93959 "c/sqlite3.c"
  }
  $87 = ((($1)) + 16|0); //@line 93961 "c/sqlite3.c"
  $88 = HEAP32[$87>>2]|0; //@line 93961 "c/sqlite3.c"
  $89 = (_sqlite3ExprDup($0,$88,0)|0); //@line 93961 "c/sqlite3.c"
  $90 = ((($storemerge)) + 16|0); //@line 93961 "c/sqlite3.c"
  HEAP32[$90>>2] = $89; //@line 93961 "c/sqlite3.c"
  STACKTOP = sp;return ($storemerge|0); //@line 93965 "c/sqlite3.c"
 }
 $58 = (_dupedExprNodeSize($1,$2)|0); //@line 93942 "c/sqlite3.c"
 $59 = HEAP32[$4>>2]|0; //@line 93942 "c/sqlite3.c"
 $60 = (($59) + ($58)|0); //@line 93942 "c/sqlite3.c"
 HEAP32[$4>>2] = $60; //@line 93942 "c/sqlite3.c"
 $61 = $55 & 8404992; //@line 93943 "c/sqlite3.c"
 $62 = ($61|0)==(0); //@line 93943 "c/sqlite3.c"
 if ($62) {
  $63 = ((($1)) + 12|0); //@line 93944 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 93944 "c/sqlite3.c"
  $65 = ($64|0)==(0|0); //@line 93944 "c/sqlite3.c"
  if ($65) {
   $68 = 0;
  } else {
   $66 = (_exprDup($0,$64,1,$4)|0); //@line 93945 "c/sqlite3.c"
   $68 = $66;
  }
  $67 = ((($storemerge)) + 12|0); //@line 93944 "c/sqlite3.c"
  HEAP32[$67>>2] = $68; //@line 93944 "c/sqlite3.c"
  $69 = ((($1)) + 16|0); //@line 93946 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 93946 "c/sqlite3.c"
  $71 = ($70|0)==(0|0); //@line 93946 "c/sqlite3.c"
  if ($71) {
   $74 = 0;
  } else {
   $72 = (_exprDup($0,$70,1,$4)|0); //@line 93947 "c/sqlite3.c"
   $74 = $72;
  }
  $73 = ((($storemerge)) + 16|0); //@line 93946 "c/sqlite3.c"
  HEAP32[$73>>2] = $74; //@line 93946 "c/sqlite3.c"
 }
 if (!($5)) {
  STACKTOP = sp;return ($storemerge|0); //@line 93965 "c/sqlite3.c"
 }
 $75 = HEAP32[$4>>2]|0; //@line 93950 "c/sqlite3.c"
 HEAP32[$3>>2] = $75; //@line 93950 "c/sqlite3.c"
 STACKTOP = sp;return ($storemerge|0); //@line 93965 "c/sqlite3.c"
}
function _dupedExprSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 93858 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 93864 "c/sqlite3.c"
 }
 $3 = (_dupedExprNodeSize($0,$1)|0); //@line 93859 "c/sqlite3.c"
 $4 = $1 & 1; //@line 93860 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 93860 "c/sqlite3.c"
 if ($5) {
  $$0 = $3;
  return ($$0|0); //@line 93864 "c/sqlite3.c"
 } else {
  $6 = ((($0)) + 12|0); //@line 93861 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 93861 "c/sqlite3.c"
  $8 = (_dupedExprSize($7,$1)|0); //@line 93861 "c/sqlite3.c"
  $9 = ((($0)) + 16|0); //@line 93861 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 93861 "c/sqlite3.c"
  $11 = (_dupedExprSize($10,$1)|0); //@line 93861 "c/sqlite3.c"
  $12 = (($8) + ($3))|0; //@line 93861 "c/sqlite3.c"
  $13 = (($12) + ($11))|0; //@line 93861 "c/sqlite3.c"
  return ($13|0); //@line 93864 "c/sqlite3.c"
 }
 return (0)|0;
}
function _dupedExprStructSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 93813 "c/sqlite3.c"
 if ($2) {
  $$0 = 48;
  return ($$0|0); //@line 93827 "c/sqlite3.c"
 }
 $3 = HEAP8[$0>>0]|0; //@line 93813 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(-104); //@line 93813 "c/sqlite3.c"
 if ($4) {
  $$0 = 48;
  return ($$0|0); //@line 93827 "c/sqlite3.c"
 }
 $5 = ((($0)) + 12|0); //@line 93820 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 93820 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 93820 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 20|0); //@line 93820 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 93820 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 93820 "c/sqlite3.c"
  $spec$select = $10 ? 16396 : 8220; //@line 93820 "c/sqlite3.c"
  return ($spec$select|0); //@line 93820 "c/sqlite3.c"
 } else {
  $$0 = 8220;
  return ($$0|0); //@line 93827 "c/sqlite3.c"
 }
 return (0)|0;
}
function _exprStructSize($0) {
 $0 = $0|0;
 var $$ = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 93769 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 93769 "c/sqlite3.c"
 $3 = $2 & 16384; //@line 93769 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 93769 "c/sqlite3.c"
 $5 = $2 & 8192; //@line 93770 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 93770 "c/sqlite3.c"
 $$ = $6 ? 48 : 28; //@line 93771 "c/sqlite3.c"
 $spec$select = $4 ? $$ : 12; //@line 93769 "c/sqlite3.c"
 return ($spec$select|0); //@line 93772 "c/sqlite3.c"
}
function _sqlite3ExprListDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$05461 = 0, $$05560 = 0, $$05659 = 0, $$05758 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 94022 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  return ($$0|0); //@line 94056 "c/sqlite3.c"
 }
 $4 = (_sqlite3DbMallocSize($0,$1)|0); //@line 94023 "c/sqlite3.c"
 $5 = ($4|0)<(0); //@line 94023 "c/sqlite3.c"
 $6 = $5 << 31 >> 31; //@line 94023 "c/sqlite3.c"
 $7 = (_sqlite3DbMallocRawNN($0,$4,$6)|0); //@line 94023 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 94024 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 94056 "c/sqlite3.c"
 }
 $9 = HEAP32[$1>>2]|0; //@line 94025 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 94025 "c/sqlite3.c"
 $10 = HEAP32[$1>>2]|0; //@line 94028 "c/sqlite3.c"
 $11 = ($10|0)>(0); //@line 94028 "c/sqlite3.c"
 if (!($11)) {
  $$0 = $7;
  return ($$0|0); //@line 94056 "c/sqlite3.c"
 }
 $12 = ((($1)) + 4|0); //@line 94027 "c/sqlite3.c"
 $13 = ((($7)) + 4|0); //@line 94026 "c/sqlite3.c"
 $$05461 = $13;$$05560 = 0;$$05659 = 0;$$05758 = $12;
 while(1) {
  $14 = HEAP32[$$05758>>2]|0; //@line 94029 "c/sqlite3.c"
  $15 = (_sqlite3ExprDup($0,$14,$2)|0); //@line 94031 "c/sqlite3.c"
  HEAP32[$$05461>>2] = $15; //@line 94031 "c/sqlite3.c"
  $16 = ($14|0)==(0|0); //@line 94032 "c/sqlite3.c"
  do {
   if ($16) {
    $$1 = $$05560;
   } else {
    $17 = HEAP8[$14>>0]|0; //@line 94033 "c/sqlite3.c"
    $18 = ($17<<24>>24)!=(-104); //@line 94033 "c/sqlite3.c"
    $19 = ($15|0)==(0|0); //@line 94034 "c/sqlite3.c"
    $or$cond = $19 | $18; //@line 94034 "c/sqlite3.c"
    if ($or$cond) {
     $$1 = $$05560;
    } else {
     $20 = ((($15)) + 32|0); //@line 94037 "c/sqlite3.c"
     $21 = HEAP16[$20>>1]|0; //@line 94037 "c/sqlite3.c"
     $22 = ($21<<16>>16)==(0); //@line 94037 "c/sqlite3.c"
     if ($22) {
      $23 = ((($15)) + 16|0); //@line 94039 "c/sqlite3.c"
      $24 = HEAP32[$23>>2]|0; //@line 94039 "c/sqlite3.c"
      $25 = ((($15)) + 12|0); //@line 94039 "c/sqlite3.c"
      HEAP32[$25>>2] = $24; //@line 94039 "c/sqlite3.c"
      $$1 = $24;
      break;
     } else {
      $26 = ((($15)) + 12|0); //@line 94045 "c/sqlite3.c"
      HEAP32[$26>>2] = $$05560; //@line 94045 "c/sqlite3.c"
      $$1 = $$05560;
      break;
     }
    }
   }
  } while(0);
  $27 = ((($$05758)) + 4|0); //@line 94048 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 94048 "c/sqlite3.c"
  $29 = (_sqlite3DbStrDup($0,$28)|0); //@line 94048 "c/sqlite3.c"
  $30 = ((($$05461)) + 4|0); //@line 94048 "c/sqlite3.c"
  HEAP32[$30>>2] = $29; //@line 94048 "c/sqlite3.c"
  $31 = ((($$05758)) + 8|0); //@line 94049 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 94049 "c/sqlite3.c"
  $33 = (_sqlite3DbStrDup($0,$32)|0); //@line 94049 "c/sqlite3.c"
  $34 = ((($$05461)) + 8|0); //@line 94049 "c/sqlite3.c"
  HEAP32[$34>>2] = $33; //@line 94049 "c/sqlite3.c"
  $35 = ((($$05758)) + 12|0); //@line 94050 "c/sqlite3.c"
  $36 = HEAP8[$35>>0]|0; //@line 94050 "c/sqlite3.c"
  $37 = ((($$05461)) + 12|0); //@line 94050 "c/sqlite3.c"
  HEAP8[$37>>0] = $36; //@line 94050 "c/sqlite3.c"
  $38 = ((($$05461)) + 13|0); //@line 94051 "c/sqlite3.c"
  $39 = HEAP8[$38>>0]|0; //@line 94051 "c/sqlite3.c"
  $40 = $39 & -2; //@line 94051 "c/sqlite3.c"
  HEAP8[$38>>0] = $40; //@line 94051 "c/sqlite3.c"
  $41 = ((($$05758)) + 13|0); //@line 94052 "c/sqlite3.c"
  $42 = HEAP8[$41>>0]|0; //@line 94052 "c/sqlite3.c"
  $43 = $42 & 2; //@line 94052 "c/sqlite3.c"
  $44 = $39 & -4; //@line 94052 "c/sqlite3.c"
  $45 = $43 | $44; //@line 94052 "c/sqlite3.c"
  HEAP8[$38>>0] = $45; //@line 94052 "c/sqlite3.c"
  $46 = ((($$05758)) + 16|0); //@line 94053 "c/sqlite3.c"
  $47 = ((($$05461)) + 16|0); //@line 94053 "c/sqlite3.c"
  $48 = HEAP32[$46>>2]|0; //@line 94053 "c/sqlite3.c"
  HEAP32[$47>>2] = $48; //@line 94053 "c/sqlite3.c"
  $49 = (($$05659) + 1)|0; //@line 94028 "c/sqlite3.c"
  $50 = ((($$05461)) + 20|0); //@line 94028 "c/sqlite3.c"
  $51 = ((($$05758)) + 20|0); //@line 94028 "c/sqlite3.c"
  $52 = HEAP32[$1>>2]|0; //@line 94028 "c/sqlite3.c"
  $53 = ($49|0)<($52|0); //@line 94028 "c/sqlite3.c"
  if ($53) {
   $$05461 = $50;$$05560 = $$1;$$05659 = $49;$$05758 = $51;
  } else {
   $$0 = $7;
   break;
  }
 }
 return ($$0|0); //@line 94056 "c/sqlite3.c"
}
function _dupedExprNodeSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_dupedExprStructSize($0,$1)|0); //@line 93836 "c/sqlite3.c"
 $3 = $2 & 4095; //@line 93836 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 93837 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 93837 "c/sqlite3.c"
 $6 = $5 & 1024; //@line 93837 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 93837 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 8|0); //@line 93837 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 93837 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 93837 "c/sqlite3.c"
  if ($10) {
   $$0 = $3;
  } else {
   $11 = (_sqlite3Strlen30($9)|0); //@line 93838 "c/sqlite3.c"
   $12 = (($3) + 1)|0; //@line 93838 "c/sqlite3.c"
   $13 = (($12) + ($11))|0; //@line 93838 "c/sqlite3.c"
   $$0 = $13;
  }
 } else {
  $$0 = $3;
 }
 $14 = (($$0) + 7)|0; //@line 93840 "c/sqlite3.c"
 $15 = $14 & -8; //@line 93840 "c/sqlite3.c"
 return ($15|0); //@line 93840 "c/sqlite3.c"
}
function _selectOpName($0) {
 $0 = $0|0;
 var $$0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0|0) {
 case 116:  {
  $$0 = 23327;
  break;
 }
 case 118:  {
  $$0 = 23304;
  break;
 }
 case 117:  {
  $$0 = 23314;
  break;
 }
 default: {
  $$0 = 23321;
 }
 }
 return ($$0|0); //@line 119813 "c/sqlite3.c"
}
function _sqlite3ResolveOrderGroupBy($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$031 = 0, $$03234 = 0, $$035 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 92200 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 92206 "c/sqlite3.c"
 $5 = ($2|0)==(0|0); //@line 92210 "c/sqlite3.c"
 if ($5) {
  $$031 = 0;
  STACKTOP = sp;return ($$031|0); //@line 92228 "c/sqlite3.c"
 }
 $6 = ((($4)) + 73|0); //@line 92210 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 92210 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 92210 "c/sqlite3.c"
 if (!($8)) {
  $$031 = 0;
  STACKTOP = sp;return ($$031|0); //@line 92228 "c/sqlite3.c"
 }
 $9 = HEAP32[$2>>2]|0; //@line 92211 "c/sqlite3.c"
 $10 = ((($4)) + 108|0); //@line 92211 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 92211 "c/sqlite3.c"
 $12 = ($9|0)>($11|0); //@line 92211 "c/sqlite3.c"
 if ($12) {
  HEAP32[$vararg_buffer>>2] = $3; //@line 92212 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,23337,$vararg_buffer); //@line 92212 "c/sqlite3.c"
  $$031 = 1;
  STACKTOP = sp;return ($$031|0); //@line 92228 "c/sqlite3.c"
 }
 $13 = HEAP32[$1>>2]|0; //@line 92215 "c/sqlite3.c"
 $14 = HEAP32[$2>>2]|0; //@line 92217 "c/sqlite3.c"
 $15 = ($14|0)>(0); //@line 92217 "c/sqlite3.c"
 if (!($15)) {
  $$031 = 0;
  STACKTOP = sp;return ($$031|0); //@line 92228 "c/sqlite3.c"
 }
 $16 = ((($2)) + 4|0); //@line 92217 "c/sqlite3.c"
 $$03234 = 0;$$035 = $16;
 while(1) {
  $17 = ((($$035)) + 16|0); //@line 92218 "c/sqlite3.c"
  $18 = HEAP16[$17>>1]|0; //@line 92218 "c/sqlite3.c"
  $19 = ($18<<16>>16)==(0); //@line 92218 "c/sqlite3.c"
  if (!($19)) {
   $20 = $18&65535; //@line 92219 "c/sqlite3.c"
   $21 = HEAP32[$13>>2]|0; //@line 92219 "c/sqlite3.c"
   $22 = ($21|0)<($20|0); //@line 92219 "c/sqlite3.c"
   if ($22) {
    break;
   }
   $24 = (($20) + -1)|0; //@line 92223 "c/sqlite3.c"
   $25 = HEAP32[$$035>>2]|0; //@line 92223 "c/sqlite3.c"
   _resolveAlias($0,$13,$24,$25,$3,0); //@line 92223 "c/sqlite3.c"
  }
  $26 = (($$03234) + 1)|0; //@line 92217 "c/sqlite3.c"
  $27 = ((($$035)) + 20|0); //@line 92217 "c/sqlite3.c"
  $28 = HEAP32[$2>>2]|0; //@line 92217 "c/sqlite3.c"
  $29 = ($26|0)<($28|0); //@line 92217 "c/sqlite3.c"
  if ($29) {
   $$03234 = $26;$$035 = $27;
  } else {
   $$031 = 0;
   label = 12;
   break;
  }
 }
 if ((label|0) == 12) {
  STACKTOP = sp;return ($$031|0); //@line 92228 "c/sqlite3.c"
 }
 $23 = (($$03234) + 1)|0; //@line 92220 "c/sqlite3.c"
 _resolveOutOfRangeError($0,$3,$23,$21); //@line 92220 "c/sqlite3.c"
 $$031 = 1;
 STACKTOP = sp;return ($$031|0); //@line 92228 "c/sqlite3.c"
}
function _resolveAlias($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 $6 = (((($1)) + 4|0) + (($2*20)|0)|0); //@line 91227 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 91227 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 91229 "c/sqlite3.c"
 $9 = (_sqlite3ExprDup($8,$7,0)|0); //@line 91230 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 91231 "c/sqlite3.c"
 if ($10) {
  return; //@line 91254 "c/sqlite3.c"
 }
 $11 = HEAP8[$4>>0]|0; //@line 91232 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(71); //@line 91232 "c/sqlite3.c"
 if (!($12)) {
  _incrAggFunctionDepth($9,$5); //@line 91232 "c/sqlite3.c"
 }
 $13 = HEAP8[$3>>0]|0; //@line 91233 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(94); //@line 91233 "c/sqlite3.c"
 if ($14) {
  $15 = ((($3)) + 8|0); //@line 91234 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 91234 "c/sqlite3.c"
  $17 = (_sqlite3ExprAddCollateString($0,$9,$16)|0); //@line 91234 "c/sqlite3.c"
  $$0 = $17;
 } else {
  $$0 = $9;
 }
 $18 = ((($$0)) + 4|0); //@line 91236 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 91236 "c/sqlite3.c"
 $20 = $19 | 4194304; //@line 91236 "c/sqlite3.c"
 HEAP32[$18>>2] = $20; //@line 91236 "c/sqlite3.c"
 $21 = ((($3)) + 4|0); //@line 91245 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 91245 "c/sqlite3.c"
 $23 = $22 | 32768; //@line 91245 "c/sqlite3.c"
 HEAP32[$21>>2] = $23; //@line 91245 "c/sqlite3.c"
 _sqlite3ExprDelete($8,$3); //@line 91246 "c/sqlite3.c"
 dest=$3; src=$$0; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 91247 "c/sqlite3.c"
 $24 = HEAP32[$21>>2]|0; //@line 91248 "c/sqlite3.c"
 $25 = $24 & 1024; //@line 91248 "c/sqlite3.c"
 $26 = ($25|0)==(0); //@line 91248 "c/sqlite3.c"
 if ($26) {
  $27 = ((($3)) + 8|0); //@line 91248 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 91248 "c/sqlite3.c"
  $29 = ($28|0)==(0|0); //@line 91248 "c/sqlite3.c"
  if (!($29)) {
   $30 = (_sqlite3DbStrDup($8,$28)|0); //@line 91250 "c/sqlite3.c"
   HEAP32[$27>>2] = $30; //@line 91250 "c/sqlite3.c"
   $31 = HEAP32[$21>>2]|0; //@line 91251 "c/sqlite3.c"
   $32 = $31 | 65536; //@line 91251 "c/sqlite3.c"
   HEAP32[$21>>2] = $32; //@line 91251 "c/sqlite3.c"
  }
 }
 _sqlite3DbFree($8,$$0); //@line 91253 "c/sqlite3.c"
 return; //@line 91254 "c/sqlite3.c"
}
function _incrAggFunctionDepth($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = ($1|0)>(0); //@line 91186 "c/sqlite3.c"
 if (!($3)) {
  STACKTOP = sp;return; //@line 91193 "c/sqlite3.c"
 }
 ;HEAP32[$2>>2]=0|0;HEAP32[$2+4>>2]=0|0;HEAP32[$2+8>>2]=0|0;HEAP32[$2+12>>2]=0|0;HEAP32[$2+16>>2]=0|0;HEAP32[$2+20>>2]=0|0; //@line 91188 "c/sqlite3.c"
 $4 = ((($2)) + 4|0); //@line 91189 "c/sqlite3.c"
 HEAP32[$4>>2] = 156; //@line 91189 "c/sqlite3.c"
 $5 = ((($2)) + 24|0); //@line 91190 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 91190 "c/sqlite3.c"
 (_sqlite3WalkExpr($2,$0)|0); //@line 91191 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 91193 "c/sqlite3.c"
}
function _sqlite3ExprAddCollateString($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 _sqlite3TokenInit($3,$2); //@line 92787 "c/sqlite3.c"
 $4 = (_sqlite3ExprAddCollateToken($0,$1,$3,0)|0); //@line 92788 "c/sqlite3.c"
 STACKTOP = sp;return ($4|0); //@line 92788 "c/sqlite3.c"
}
function _sqlite3TokenInit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = $1; //@line 28740 "c/sqlite3.c"
 $2 = (_sqlite3Strlen30($1)|0); //@line 28741 "c/sqlite3.c"
 $3 = ((($0)) + 4|0); //@line 28741 "c/sqlite3.c"
 HEAP32[$3>>2] = $2; //@line 28741 "c/sqlite3.c"
 return; //@line 28742 "c/sqlite3.c"
}
function _incrAggDepth($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 91182 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(-110); //@line 91182 "c/sqlite3.c"
 if (!($3)) {
  return 0; //@line 91183 "c/sqlite3.c"
 }
 $4 = ((($0)) + 24|0); //@line 91182 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 91182 "c/sqlite3.c"
 $6 = ((($1)) + 38|0); //@line 91182 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 91182 "c/sqlite3.c"
 $8 = $7&255; //@line 91182 "c/sqlite3.c"
 $9 = (($5) + ($8))|0; //@line 91182 "c/sqlite3.c"
 $10 = $9&255; //@line 91182 "c/sqlite3.c"
 HEAP8[$6>>0] = $10; //@line 91182 "c/sqlite3.c"
 return 0; //@line 91183 "c/sqlite3.c"
}
function _sqlite3ExprCheckHeight($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 93312 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 93314 "c/sqlite3.c"
 $3 = ((($2)) + 112|0); //@line 93314 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 93314 "c/sqlite3.c"
 $5 = ($4|0)<($1|0); //@line 93315 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 93321 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer>>2] = $4; //@line 93316 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,23368,$vararg_buffer); //@line 93316 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 93321 "c/sqlite3.c"
}
function _notValid($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$select7 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 91682 "c/sqlite3.c"
 $4 = ((($1)) + 28|0); //@line 91688 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 91688 "c/sqlite3.c"
 $6 = $5&65535; //@line 91688 "c/sqlite3.c"
 $7 = $6 & $3; //@line 91688 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 91688 "c/sqlite3.c"
 if ($8) {
  STACKTOP = sp;return; //@line 91696 "c/sqlite3.c"
 }
 $9 = $6 & 32; //@line 91690 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 91690 "c/sqlite3.c"
 $11 = $6 & 4; //@line 91692 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 91692 "c/sqlite3.c"
 $spec$select = $12 ? 23851 : 23879; //@line 91692 "c/sqlite3.c"
 $spec$select7 = $10 ? $spec$select : 23897; //@line 91690 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 91694 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 91694 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $spec$select7; //@line 91694 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,23915,$vararg_buffer); //@line 91694 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 91696 "c/sqlite3.c"
}
function _lookupName($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0263 = 0, $$0264 = 0, $$0266452 = 0, $$0268443 = 0, $$0271420 = 0, $$0286$lcssa = 0, $$0286418 = 0, $$0288 = 0, $$0297425 = 0, $$0300 = 0, $$0304 = 0, $$0309415 = 0, $$0310 = 0, $$0323429 = 0, $$0324 = 0, $$10 = 0, $$1265347361 = 0, $$1265348355358 = 0, $$1265348355359 = 0, $$1267435 = 0;
 var $$1269 = 0, $$1272426 = 0, $$1275$lcssa = 0, $$1275434 = 0, $$1287 = 0, $$1289$lcssa = 0, $$1289433 = 0, $$1298442 = 0, $$1305 = 0, $$1311$lcssa = 0, $$1311432 = 0, $$14507 = 0, $$14508 = 0, $$2270 = 0, $$2273449 = 0, $$2276$lcssa = 0, $$2276419 = 0, $$2290$lcssa = 0, $$2290417 = 0, $$2306 = 0;
 var $$2312$lcssa = 0, $$2312416 = 0, $$3277 = 0, $$3291 = 0, $$3303 = 0, $$3303335 = 0, $$3303335497504 = 0, $$3313 = 0, $$4278 = 0, $$4292 = 0, $$4308 = 0, $$4308334 = 0, $$4308334498501 = 0, $$4308334499 = 0, $$4314 = 0, $$5279 = 0, $$5293 = 0, $$6 = 0, $$6280 = 0, $$6294 = 0;
 var $$6316 = 0, $$7317 = 0, $$8296 = 0, $$8296336 = 0, $$9 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0;
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0;
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0;
 var $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0;
 var $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0;
 var $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0;
 var $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0;
 var $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0;
 var $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0;
 var $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0;
 var $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond329 = 0, $not$or$cond = 0, $or$cond10 = 0, $or$cond12 = 0, $or$cond14 = 0, $or$cond18 = 0, $or$cond4 = 0, $or$cond6 = 0, $or$cond8 = 0, $spec$select = 0, $spec$select327 = 0, $spec$select328 = 0, $spec$store$select = 0, $storemerge = 0, $vararg_buffer = 0;
 var $vararg_buffer1 = 0, $vararg_buffer14 = 0, $vararg_buffer3 = 0, $vararg_buffer9 = 0, $vararg_ptr12 = 0, $vararg_ptr13 = 0, $vararg_ptr17 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer14 = sp + 48|0; //@line 91331 "c/sqlite3.c"
 $vararg_buffer9 = sp + 32|0; //@line 91331 "c/sqlite3.c"
 $vararg_buffer3 = sp + 16|0; //@line 91331 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 91331 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 91331 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 91342 "c/sqlite3.c"
 $7 = ((($5)) + 28|0); //@line 91356 "c/sqlite3.c"
 HEAP32[$7>>2] = -1; //@line 91356 "c/sqlite3.c"
 $8 = ((($5)) + 44|0); //@line 91357 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 91357 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 91364 "c/sqlite3.c"
 L1: do {
  if ($9) {
   $$0263 = 0;$$0304 = 0;
  } else {
   $10 = ((($4)) + 28|0); //@line 91367 "c/sqlite3.c"
   $11 = HEAP16[$10>>1]|0; //@line 91367 "c/sqlite3.c"
   $12 = $11 & 6; //@line 91367 "c/sqlite3.c"
   $13 = ($12<<16>>16)==(0); //@line 91367 "c/sqlite3.c"
   if ($13) {
    $14 = ((($6)) + 20|0); //@line 91374 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 91374 "c/sqlite3.c"
    $16 = ($15|0)>(0); //@line 91374 "c/sqlite3.c"
    if ($16) {
     $17 = ((($6)) + 16|0);
     $18 = HEAP32[$17>>2]|0;
     $$0266452 = 0;
     while(1) {
      $19 = (($18) + ($$0266452<<4)|0); //@line 91376 "c/sqlite3.c"
      $20 = HEAP32[$19>>2]|0; //@line 91376 "c/sqlite3.c"
      $21 = (_sqlite3StrICmp($20,$1)|0); //@line 91376 "c/sqlite3.c"
      $22 = ($21|0)==(0); //@line 91376 "c/sqlite3.c"
      if ($22) {
       break;
      }
      $25 = (($$0266452) + 1)|0; //@line 91374 "c/sqlite3.c"
      $26 = HEAP32[$14>>2]|0; //@line 91374 "c/sqlite3.c"
      $27 = ($25|0)<($26|0); //@line 91374 "c/sqlite3.c"
      if ($27) {
       $$0266452 = $25;
      } else {
       $$0263 = $1;$$0304 = 0;
       break L1;
      }
     }
     $23 = (((($18) + ($$0266452<<4)|0)) + 12|0); //@line 91377 "c/sqlite3.c"
     $24 = HEAP32[$23>>2]|0; //@line 91377 "c/sqlite3.c"
     $$0263 = $1;$$0304 = $24;
    } else {
     $$0263 = $1;$$0304 = 0;
    }
   } else {
    $$0263 = 0;$$0304 = 0;
   }
  }
 } while(0);
 $28 = ($$0263|0)==(0|0);
 $29 = ($2|0)!=(0|0);
 $or$cond4 = $29 & $28;
 $30 = ((($0)) + 124|0);
 $31 = ($2|0)==(0|0);
 $32 = ($$0263|0)==(0|0);
 $33 = ($2|0)==(0|0);
 $34 = ($2|0)!=(0|0);
 $35 = ((($5)) + 32|0);
 $36 = ((($5)) + 32|0);
 $37 = ((($0)) + 144|0);
 $38 = ((($5)) + 4|0);
 $39 = ((($5)) + 32|0);
 $40 = ((($5)) + 1|0);
 $41 = ((($5)) + 1|0);
 $42 = ((($5)) + 32|0);
 $43 = ((($0)) + 136|0);
 $44 = ((($0)) + 140|0);
 $$0264 = $4;$$0288 = 0;$$0300 = 0;$$0310 = 0;$$0324 = 0;$$1305 = $$0304;
 L10: while(1) {
  $45 = ((($$0264)) + 4|0); //@line 91388 "c/sqlite3.c"
  $46 = HEAP32[$45>>2]|0; //@line 91388 "c/sqlite3.c"
  $47 = ($46|0)==(0|0); //@line 91390 "c/sqlite3.c"
  if ($47) {
   $$2306 = $$1305;$$6280 = 0;$$6294 = $$0288;$$7317 = $$0310;
  } else {
   $48 = HEAP32[$46>>2]|0; //@line 91391 "c/sqlite3.c"
   $49 = ($48|0)>(0); //@line 91391 "c/sqlite3.c"
   if ($49) {
    $50 = ((($46)) + 8|0); //@line 91391 "c/sqlite3.c"
    $$0323429 = $50;$$1267435 = 0;$$1275434 = 0;$$1289433 = $$0288;$$1311432 = $$0310;
    while(1) {
     $51 = ((($$0323429)) + 16|0); //@line 91392 "c/sqlite3.c"
     $52 = HEAP32[$51>>2]|0; //@line 91392 "c/sqlite3.c"
     $53 = ((($$0323429)) + 20|0); //@line 91395 "c/sqlite3.c"
     $54 = HEAP32[$53>>2]|0; //@line 91395 "c/sqlite3.c"
     $55 = ($54|0)==(0|0); //@line 91395 "c/sqlite3.c"
     if ($55) {
      $$4278 = $$1275434;$$4292 = $$1289433;$$4314 = $$1311432;
      label = 20;
     } else {
      $56 = ((($54)) + 8|0); //@line 91395 "c/sqlite3.c"
      $57 = HEAP32[$56>>2]|0; //@line 91395 "c/sqlite3.c"
      $58 = $57 & 2048; //@line 91395 "c/sqlite3.c"
      $59 = ($58|0)==(0); //@line 91395 "c/sqlite3.c"
      if ($59) {
       $$4278 = $$1275434;$$4292 = $$1289433;$$4314 = $$1311432;
       label = 20;
      } else {
       $60 = HEAP32[$54>>2]|0; //@line 91397 "c/sqlite3.c"
       $61 = HEAP32[$60>>2]|0; //@line 91398 "c/sqlite3.c"
       $62 = ($61|0)>(0); //@line 91398 "c/sqlite3.c"
       if ($62) {
        $$0271420 = 0;$$0286418 = 0;$$2276419 = $$1275434;$$2290417 = $$1289433;$$2312416 = $$1311432;
        while(1) {
         $63 = (((((($60)) + 4|0) + (($$0271420*20)|0)|0)) + 8|0); //@line 91399 "c/sqlite3.c"
         $64 = HEAP32[$63>>2]|0; //@line 91399 "c/sqlite3.c"
         $65 = (_sqlite3MatchSpanName($64,$3,$2,$$0263)|0); //@line 91399 "c/sqlite3.c"
         $66 = ($65|0)==(0); //@line 91399 "c/sqlite3.c"
         if ($66) {
          $$1287 = $$0286418;$$3277 = $$2276419;$$3291 = $$2290417;$$3313 = $$2312416;
         } else {
          $67 = (($$2276419) + 1)|0; //@line 91400 "c/sqlite3.c"
          $68 = $$0271420&65535; //@line 91403 "c/sqlite3.c"
          HEAP16[$35>>1] = $68; //@line 91403 "c/sqlite3.c"
          $$1287 = 1;$$3277 = $67;$$3291 = 2;$$3313 = $$0323429;
         }
         $69 = (($$0271420) + 1)|0; //@line 91398 "c/sqlite3.c"
         $70 = HEAP32[$60>>2]|0; //@line 91398 "c/sqlite3.c"
         $71 = ($69|0)<($70|0); //@line 91398 "c/sqlite3.c"
         if ($71) {
          $$0271420 = $69;$$0286418 = $$1287;$$2276419 = $$3277;$$2290417 = $$3291;$$2312416 = $$3313;
         } else {
          $$0286$lcssa = $$1287;$$2276$lcssa = $$3277;$$2290$lcssa = $$3291;$$2312$lcssa = $$3313;
          break;
         }
        }
       } else {
        $$0286$lcssa = 0;$$2276$lcssa = $$1275434;$$2290$lcssa = $$1289433;$$2312$lcssa = $$1311432;
       }
       $72 = ($$0286$lcssa|0)==(0); //@line 91407 "c/sqlite3.c"
       $not$or$cond = $34 & $72; //@line 91407 "c/sqlite3.c"
       if ($not$or$cond) {
        $$4278 = $$2276$lcssa;$$4292 = $$2290$lcssa;$$4314 = $$2312$lcssa;
        label = 20;
       } else {
        $$5279 = $$2276$lcssa;$$5293 = $$2290$lcssa;$$6316 = $$2312$lcssa;
       }
      }
     }
     L29: do {
      if ((label|0) == 20) {
       label = 0;
       if (!($32)) {
        $73 = ((($52)) + 72|0); //@line 91409 "c/sqlite3.c"
        $74 = HEAP32[$73>>2]|0; //@line 91409 "c/sqlite3.c"
        $75 = ($74|0)==($$1305|0); //@line 91409 "c/sqlite3.c"
        if (!($75)) {
         $$5279 = $$4278;$$5293 = $$4292;$$6316 = $$4314;
         break;
        }
       }
       if (!($33)) {
        $76 = ((($$0323429)) + 12|0); //@line 91413 "c/sqlite3.c"
        $77 = HEAP32[$76>>2]|0; //@line 91413 "c/sqlite3.c"
        $78 = ($77|0)==(0|0); //@line 91413 "c/sqlite3.c"
        if ($78) {
         $79 = HEAP32[$52>>2]|0; //@line 91413 "c/sqlite3.c"
         $80 = $79;
        } else {
         $80 = $77;
        }
        $81 = (_sqlite3StrICmp($80,$2)|0); //@line 91415 "c/sqlite3.c"
        $82 = ($81|0)==(0); //@line 91415 "c/sqlite3.c"
        if (!($82)) {
         $$5279 = $$4278;$$5293 = $$4292;$$6316 = $$4314;
         break;
        }
       }
       $83 = (($$4292) + 1)|0; //@line 91419 "c/sqlite3.c"
       $84 = ($$4292|0)==(0); //@line 91419 "c/sqlite3.c"
       $spec$select = $84 ? $$0323429 : $$4314; //@line 91419 "c/sqlite3.c"
       $85 = ((($52)) + 42|0); //@line 91422 "c/sqlite3.c"
       $86 = HEAP16[$85>>1]|0; //@line 91422 "c/sqlite3.c"
       $87 = ($86<<16>>16)>(0); //@line 91422 "c/sqlite3.c"
       if ($87) {
        $88 = ((($52)) + 4|0); //@line 91422 "c/sqlite3.c"
        $89 = HEAP32[$88>>2]|0; //@line 91422 "c/sqlite3.c"
        $90 = ($$4278|0)==(1);
        $91 = ((($$0323429)) + 36|0);
        $92 = ((($$0323429)) + 52|0);
        $$0297425 = $89;$$1272426 = 0;
        while(1) {
         $93 = HEAP32[$$0297425>>2]|0; //@line 91423 "c/sqlite3.c"
         $94 = (_sqlite3StrICmp($93,$3)|0); //@line 91423 "c/sqlite3.c"
         $95 = ($94|0)==(0); //@line 91423 "c/sqlite3.c"
         if ($95) {
          if (!($90)) {
           break;
          }
          $96 = HEAP8[$91>>0]|0; //@line 91429 "c/sqlite3.c"
          $97 = $96 & 4; //@line 91429 "c/sqlite3.c"
          $98 = ($97<<24>>24)==(0); //@line 91429 "c/sqlite3.c"
          if ($98) {
           $99 = HEAP32[$92>>2]|0; //@line 91430 "c/sqlite3.c"
           $100 = (_nameInUsingClause($99,$3)|0); //@line 91430 "c/sqlite3.c"
           $101 = ($100|0)==(0); //@line 91430 "c/sqlite3.c"
           if ($101) {
            break;
           }
          }
         }
         $109 = (($$1272426) + 1)|0; //@line 91422 "c/sqlite3.c"
         $110 = ((($$0297425)) + 16|0); //@line 91422 "c/sqlite3.c"
         $111 = HEAP16[$85>>1]|0; //@line 91422 "c/sqlite3.c"
         $112 = $111 << 16 >> 16; //@line 91422 "c/sqlite3.c"
         $113 = ($109|0)<($112|0); //@line 91422 "c/sqlite3.c"
         if ($113) {
          $$0297425 = $110;$$1272426 = $109;
         } else {
          $$5279 = $$4278;$$5293 = $83;$$6316 = $spec$select;
          break L29;
         }
        }
        $102 = (($$4278) + 1)|0; //@line 91432 "c/sqlite3.c"
        $103 = ((($52)) + 40|0); //@line 91435 "c/sqlite3.c"
        $104 = HEAP16[$103>>1]|0; //@line 91435 "c/sqlite3.c"
        $105 = $104 << 16 >> 16; //@line 91435 "c/sqlite3.c"
        $106 = ($$1272426|0)==($105|0); //@line 91435 "c/sqlite3.c"
        $107 = $$1272426&65535; //@line 91435 "c/sqlite3.c"
        $108 = $106 ? -1 : $107; //@line 91435 "c/sqlite3.c"
        HEAP16[$36>>1] = $108; //@line 91435 "c/sqlite3.c"
        $$5279 = $102;$$5293 = $83;$$6316 = $$0323429;
       } else {
        $$5279 = $$4278;$$5293 = $83;$$6316 = $spec$select;
       }
      }
     } while(0);
     $114 = (($$1267435) + 1)|0; //@line 91391 "c/sqlite3.c"
     $115 = ((($$0323429)) + 72|0); //@line 91391 "c/sqlite3.c"
     $116 = HEAP32[$46>>2]|0; //@line 91391 "c/sqlite3.c"
     $117 = ($114|0)<($116|0); //@line 91391 "c/sqlite3.c"
     if ($117) {
      $$0323429 = $115;$$1267435 = $114;$$1275434 = $$5279;$$1289433 = $$5293;$$1311432 = $$6316;
     } else {
      $$1275$lcssa = $$5279;$$1289$lcssa = $$5293;$$1311$lcssa = $$6316;
      break;
     }
    }
   } else {
    $$1275$lcssa = 0;$$1289$lcssa = $$0288;$$1311$lcssa = $$0310;
   }
   $118 = ($$1311$lcssa|0)==(0|0); //@line 91440 "c/sqlite3.c"
   if ($118) {
    $$2306 = $$1305;$$6280 = $$1275$lcssa;$$6294 = $$1289$lcssa;$$7317 = 0;
   } else {
    $119 = ((($$1311$lcssa)) + 44|0); //@line 91441 "c/sqlite3.c"
    $120 = HEAP32[$119>>2]|0; //@line 91441 "c/sqlite3.c"
    HEAP32[$7>>2] = $120; //@line 91441 "c/sqlite3.c"
    $121 = ((($$1311$lcssa)) + 16|0); //@line 91442 "c/sqlite3.c"
    $122 = HEAP32[$121>>2]|0; //@line 91442 "c/sqlite3.c"
    HEAP32[$8>>2] = $122; //@line 91442 "c/sqlite3.c"
    $123 = ((($$1311$lcssa)) + 36|0); //@line 91445 "c/sqlite3.c"
    $124 = HEAP8[$123>>0]|0; //@line 91445 "c/sqlite3.c"
    $125 = $124 & 8; //@line 91445 "c/sqlite3.c"
    $126 = ($125<<24>>24)==(0); //@line 91445 "c/sqlite3.c"
    if (!($126)) {
     $127 = HEAP32[$38>>2]|0; //@line 91446 "c/sqlite3.c"
     $128 = $127 | 1048576; //@line 91446 "c/sqlite3.c"
     HEAP32[$38>>2] = $128; //@line 91446 "c/sqlite3.c"
    }
    $129 = HEAP32[$8>>2]|0; //@line 91448 "c/sqlite3.c"
    $130 = ((($129)) + 72|0); //@line 91448 "c/sqlite3.c"
    $131 = HEAP32[$130>>2]|0; //@line 91448 "c/sqlite3.c"
    $$2306 = $131;$$6280 = $$1275$lcssa;$$6294 = $$1289$lcssa;$$7317 = $$1311$lcssa;
   }
  }
  $132 = ($$6294|0)==(0); //@line 91456 "c/sqlite3.c"
  $or$cond6 = $or$cond4 & $132; //@line 91456 "c/sqlite3.c"
  do {
   if ($or$cond6) {
    $133 = HEAP32[$30>>2]|0; //@line 91456 "c/sqlite3.c"
    $134 = ($133|0)==(0|0); //@line 91456 "c/sqlite3.c"
    if ($134) {
     $$10 = $$6280;$$3303335 = $$0300;$$4308334 = $$2306;$$8296336 = 0;
    } else {
     $135 = HEAP8[$37>>0]|0; //@line 91457 "c/sqlite3.c"
     $cond329 = ($135<<24>>24)==(109); //@line 91459 "c/sqlite3.c"
     if ($cond329) {
      label = 44;
     } else {
      $136 = (_sqlite3StrICmp(23711,$2)|0); //@line 91459 "c/sqlite3.c"
      $137 = ($136|0)==(0); //@line 91459 "c/sqlite3.c"
      if ($137) {
       $storemerge = 1;
      } else {
       $138 = ($135<<24>>24)==(108); //@line 91462 "c/sqlite3.c"
       if ($138) {
        $$10 = $$6280;$$3303335 = $$0300;$$4308334 = $$2306;$$8296336 = 0;
        break;
       } else {
        label = 44;
       }
      }
     }
     if ((label|0) == 44) {
      label = 0;
      $139 = (_sqlite3StrICmp(23715,$2)|0); //@line 91462 "c/sqlite3.c"
      $140 = ($139|0)==(0); //@line 91462 "c/sqlite3.c"
      if ($140) {
       $storemerge = 0;
      } else {
       $$10 = $$6280;$$3303335 = $$0300;$$4308334 = $$2306;$$8296336 = 0;
       break;
      }
     }
     HEAP32[$7>>2] = $storemerge;
     $141 = ((($133)) + 72|0); //@line 91471 "c/sqlite3.c"
     $142 = HEAP32[$141>>2]|0; //@line 91471 "c/sqlite3.c"
     $143 = (($$6294) + 1)|0; //@line 91472 "c/sqlite3.c"
     $144 = ((($133)) + 42|0); //@line 91473 "c/sqlite3.c"
     $145 = HEAP16[$144>>1]|0; //@line 91473 "c/sqlite3.c"
     $146 = $145 << 16 >> 16; //@line 91473 "c/sqlite3.c"
     $147 = ($145<<16>>16)>(0); //@line 91473 "c/sqlite3.c"
     do {
      if ($147) {
       $148 = ((($133)) + 4|0); //@line 91473 "c/sqlite3.c"
       $149 = HEAP32[$148>>2]|0; //@line 91473 "c/sqlite3.c"
       $$0268443 = 0;$$1298442 = $149;$285 = $146;
       while(1) {
        $150 = HEAP32[$$1298442>>2]|0; //@line 91474 "c/sqlite3.c"
        $151 = (_sqlite3StrICmp($150,$3)|0); //@line 91474 "c/sqlite3.c"
        $152 = ($151|0)==(0); //@line 91474 "c/sqlite3.c"
        if ($152) {
         label = 48;
         break;
        }
        $157 = (($$0268443) + 1)|0; //@line 91473 "c/sqlite3.c"
        $158 = ((($$1298442)) + 16|0); //@line 91473 "c/sqlite3.c"
        $159 = HEAP16[$144>>1]|0; //@line 91473 "c/sqlite3.c"
        $160 = $159 << 16 >> 16; //@line 91473 "c/sqlite3.c"
        $161 = ($157|0)<($160|0); //@line 91473 "c/sqlite3.c"
        if ($161) {
         $$0268443 = $157;$$1298442 = $158;$285 = $160;
        } else {
         label = 50;
         break;
        }
       }
       if ((label|0) == 48) {
        label = 0;
        $153 = ((($133)) + 40|0); //@line 91475 "c/sqlite3.c"
        $154 = HEAP16[$153>>1]|0; //@line 91475 "c/sqlite3.c"
        $155 = $154 << 16 >> 16; //@line 91475 "c/sqlite3.c"
        $156 = ($$0268443|0)==($155|0); //@line 91475 "c/sqlite3.c"
        $spec$select327 = $156 ? -1 : $$0268443; //@line 91475 "c/sqlite3.c"
        $$1269 = $spec$select327;$164 = $285;
        break;
       }
       else if ((label|0) == 50) {
        label = 0;
        $162 = $159 << 16 >> 16; //@line 91473 "c/sqlite3.c"
        $$1269 = $157;$164 = $162;
        break;
       }
      } else {
       $$1269 = 0;$164 = $146;
      }
     } while(0);
     $163 = ($$1269|0)<($164|0); //@line 91481 "c/sqlite3.c"
     if ($163) {
      $$2270 = $$1269;
     } else {
      $165 = (_sqlite3IsRowid($3)|0); //@line 91481 "c/sqlite3.c"
      $166 = ($165|0)==(0); //@line 91481 "c/sqlite3.c"
      if ($166) {
       $$2270 = $$1269;
      } else {
       $167 = ((($133)) + 36|0); //@line 91481 "c/sqlite3.c"
       $168 = HEAP32[$167>>2]|0; //@line 91481 "c/sqlite3.c"
       $169 = $168 & 64; //@line 91481 "c/sqlite3.c"
       $170 = ($169|0)==(0); //@line 91481 "c/sqlite3.c"
       $spec$select328 = $170 ? -1 : $$1269; //@line 91481 "c/sqlite3.c"
       $$2270 = $spec$select328;
      }
     }
     $171 = ($$2270|0)<($164|0); //@line 91485 "c/sqlite3.c"
     if ($171) {
      $172 = (($$6280) + 1)|0; //@line 91486 "c/sqlite3.c"
      $173 = ($$2270|0)<(0); //@line 91487 "c/sqlite3.c"
      do {
       if ($173) {
        HEAP8[$41>>0] = 68; //@line 91488 "c/sqlite3.c"
       } else {
        $174 = HEAP32[$7>>2]|0; //@line 91489 "c/sqlite3.c"
        $175 = ($174|0)==(0); //@line 91489 "c/sqlite3.c"
        $176 = ($$2270|0)>(31);
        $177 = 1 << $$2270;
        $178 = $176 ? -1 : $177;
        if ($175) {
         $179 = HEAP32[$43>>2]|0; //@line 91492 "c/sqlite3.c"
         $180 = $179 | $178; //@line 91492 "c/sqlite3.c"
         HEAP32[$43>>2] = $180; //@line 91492 "c/sqlite3.c"
         break;
        } else {
         $181 = HEAP32[$44>>2]|0; //@line 91496 "c/sqlite3.c"
         $182 = $181 | $178; //@line 91496 "c/sqlite3.c"
         HEAP32[$44>>2] = $182; //@line 91496 "c/sqlite3.c"
         break;
        }
       }
      } while(0);
      $183 = $$2270&65535; //@line 91498 "c/sqlite3.c"
      HEAP16[$42>>1] = $183; //@line 91498 "c/sqlite3.c"
      HEAP32[$8>>2] = $133; //@line 91499 "c/sqlite3.c"
      $$3303 = 1;$$4308 = $142;$$8296 = $143;$$9 = $172;
      label = 61;
     } else {
      $$3303 = $$0300;$$4308 = $142;$$8296 = $143;$$9 = $$6280;
      label = 61;
     }
    }
   } else {
    $$3303 = $$0300;$$4308 = $$2306;$$8296 = $$6294;$$9 = $$6280;
    label = 61;
   }
  } while(0);
  if ((label|0) == 61) {
   label = 0;
   $184 = ($$9|0)==(0); //@line 91509 "c/sqlite3.c"
   $185 = ($$8296|0)==(1); //@line 91510 "c/sqlite3.c"
   $or$cond8 = $185 & $184; //@line 91510 "c/sqlite3.c"
   $186 = ($$7317|0)!=(0|0); //@line 91511 "c/sqlite3.c"
   $or$cond10 = $186 & $or$cond8; //@line 91510 "c/sqlite3.c"
   if ($or$cond10) {
    $187 = ((($$0264)) + 28|0); //@line 91512 "c/sqlite3.c"
    $188 = HEAP16[$187>>1]|0; //@line 91512 "c/sqlite3.c"
    $189 = $188 & 32; //@line 91512 "c/sqlite3.c"
    $190 = ($189<<16>>16)==(0); //@line 91512 "c/sqlite3.c"
    if ($190) {
     $191 = (_sqlite3IsRowid($3)|0); //@line 91513 "c/sqlite3.c"
     $192 = ($191|0)==(0); //@line 91513 "c/sqlite3.c"
     if ($192) {
      $$10 = 0;$$3303335 = $$3303;$$4308334 = $$4308;$$8296336 = 1;
     } else {
      $193 = ((($$7317)) + 16|0); //@line 91514 "c/sqlite3.c"
      $194 = HEAP32[$193>>2]|0; //@line 91514 "c/sqlite3.c"
      $195 = ((($194)) + 36|0); //@line 91514 "c/sqlite3.c"
      $196 = HEAP32[$195>>2]|0; //@line 91514 "c/sqlite3.c"
      $197 = $196 & 64; //@line 91514 "c/sqlite3.c"
      $198 = ($197|0)==(0); //@line 91514 "c/sqlite3.c"
      if ($198) {
       label = 65;
       break;
      } else {
       $$10 = 0;$$3303335 = $$3303;$$4308334 = $$4308;$$8296336 = 1;
      }
     }
    } else {
     $$10 = 0;$$3303335 = $$3303;$$4308334 = $$4308;$$8296336 = 1;
    }
   } else {
    $$10 = $$9;$$3303335 = $$3303;$$4308334 = $$4308;$$8296336 = $$8296;
   }
  }
  $199 = ((($$0264)) + 8|0); //@line 91539 "c/sqlite3.c"
  $200 = HEAP32[$199>>2]|0; //@line 91539 "c/sqlite3.c"
  $201 = ($200|0)!=(0|0); //@line 91539 "c/sqlite3.c"
  $or$cond12 = $31 & $201; //@line 91540 "c/sqlite3.c"
  $202 = ($$10|0)==(0); //@line 91541 "c/sqlite3.c"
  $or$cond14 = $202 & $or$cond12; //@line 91540 "c/sqlite3.c"
  if ($or$cond14) {
   $203 = HEAP32[$200>>2]|0; //@line 91543 "c/sqlite3.c"
   $204 = ($203|0)>(0); //@line 91543 "c/sqlite3.c"
   if ($204) {
    $$2273449 = 0;
    while(1) {
     $205 = (((((($200)) + 4|0) + (($$2273449*20)|0)|0)) + 4|0); //@line 91544 "c/sqlite3.c"
     $206 = HEAP32[$205>>2]|0; //@line 91544 "c/sqlite3.c"
     $207 = ($206|0)==(0|0); //@line 91545 "c/sqlite3.c"
     if (!($207)) {
      $208 = (_sqlite3StrICmp($206,$3)|0); //@line 91545 "c/sqlite3.c"
      $209 = ($208|0)==(0); //@line 91545 "c/sqlite3.c"
      if ($209) {
       label = 71;
       break L10;
      }
     }
     $222 = (($$2273449) + 1)|0; //@line 91543 "c/sqlite3.c"
     $223 = HEAP32[$200>>2]|0; //@line 91543 "c/sqlite3.c"
     $224 = ($222|0)<($223|0); //@line 91543 "c/sqlite3.c"
     if ($224) {
      $$2273449 = $222;
     } else {
      break;
     }
    }
   }
  } else {
   switch ($$10|0) {
   case 1:  {
    $$1265348355359 = $$0264;$$14507 = $$10;$$3303335497504 = $$3303335;$$4308334498501 = $$4308334;
    label = 89;
    break L10;
    break;
   }
   case 0:  {
    break;
   }
   default: {
    $$1265348355358 = $$0264;$$14508 = $$10;$233 = 23765;
    label = 83;
    break L10;
   }
   }
  }
  $225 = (($$0324) + 1)|0; //@line 91573 "c/sqlite3.c"
  $226 = ((($$0264)) + 16|0); //@line 91572 "c/sqlite3.c"
  $227 = HEAP32[$226>>2]|0; //@line 91572 "c/sqlite3.c"
  $228 = ($227|0)==(0|0); //@line 91574 "c/sqlite3.c"
  if ($228) {
   label = 80;
   break;
  } else {
   $$0264 = $227;$$0288 = $$8296336;$$0300 = $$3303335;$$0310 = $$7317;$$0324 = $225;$$1305 = $$4308334;
  }
 }
 do {
  if ((label|0) == 65) {
   HEAP16[$39>>1] = -1; //@line 91517 "c/sqlite3.c"
   HEAP8[$40>>0] = 68; //@line 91518 "c/sqlite3.c"
   $$1265348355359 = $$0264;$$14507 = 1;$$3303335497504 = $$3303;$$4308334498501 = $$4308;
   label = 89;
  }
  else if ((label|0) == 71) {
   $210 = (((($200)) + 4|0) + (($$2273449*20)|0)|0); //@line 91550 "c/sqlite3.c"
   $211 = HEAP32[$210>>2]|0; //@line 91550 "c/sqlite3.c"
   $212 = ((($$0264)) + 28|0); //@line 91551 "c/sqlite3.c"
   $213 = HEAP16[$212>>1]|0; //@line 91551 "c/sqlite3.c"
   $214 = $213 & 1; //@line 91551 "c/sqlite3.c"
   $215 = ($214<<16>>16)==(0); //@line 91551 "c/sqlite3.c"
   if ($215) {
    $216 = ((($211)) + 4|0); //@line 91551 "c/sqlite3.c"
    $217 = HEAP32[$216>>2]|0; //@line 91551 "c/sqlite3.c"
    $218 = $217 & 2; //@line 91551 "c/sqlite3.c"
    $219 = ($218|0)==(0); //@line 91551 "c/sqlite3.c"
    if (!($219)) {
     HEAP32[$vararg_buffer>>2] = $206; //@line 91552 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,23719,$vararg_buffer); //@line 91552 "c/sqlite3.c"
     $$6 = 2;
     STACKTOP = sp;return ($$6|0); //@line 91653 "c/sqlite3.c"
    }
   }
   $220 = (_sqlite3ExprVectorSize($211)|0); //@line 91555 "c/sqlite3.c"
   $221 = ($220|0)==(1); //@line 91555 "c/sqlite3.c"
   if ($221) {
    _resolveAlias($0,$200,$$2273449,$5,41388,$$0324); //@line 91559 "c/sqlite3.c"
    $$1265347361 = $$0264;$$4308334499 = $$4308334;
    break;
   }
   _sqlite3ErrorMsg($0,23693,$vararg_buffer1); //@line 91556 "c/sqlite3.c"
   $$6 = 2;
   STACKTOP = sp;return ($$6|0); //@line 91653 "c/sqlite3.c"
  }
  else if ((label|0) == 80) {
   if ($31) {
    $229 = ((($5)) + 4|0); //@line 91587 "c/sqlite3.c"
    $230 = HEAP32[$229>>2]|0; //@line 91587 "c/sqlite3.c"
    $231 = $230 & 64; //@line 91587 "c/sqlite3.c"
    $232 = ($231|0)==(0); //@line 91587 "c/sqlite3.c"
    if ($232) {
     $$1265348355358 = 0;$$14508 = 0;$233 = 23750;
     label = 83;
    } else {
     HEAP8[$5>>0] = 97; //@line 91588 "c/sqlite3.c"
     HEAP32[$8>>2] = 0; //@line 91589 "c/sqlite3.c"
     $$6 = 1;
     STACKTOP = sp;return ($$6|0); //@line 91653 "c/sqlite3.c"
    }
   } else {
    $$1265348355358 = 0;$$14508 = 0;$233 = 23750;
    label = 83;
   }
  }
 } while(0);
 if ((label|0) == 83) {
  do {
   if ($28) {
    if ($29) {
     HEAP32[$vararg_buffer9>>2] = $233; //@line 91603 "c/sqlite3.c"
     $vararg_ptr12 = ((($vararg_buffer9)) + 4|0); //@line 91603 "c/sqlite3.c"
     HEAP32[$vararg_ptr12>>2] = $2; //@line 91603 "c/sqlite3.c"
     $vararg_ptr13 = ((($vararg_buffer9)) + 8|0); //@line 91603 "c/sqlite3.c"
     HEAP32[$vararg_ptr13>>2] = $3; //@line 91603 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,20061,$vararg_buffer9); //@line 91603 "c/sqlite3.c"
     break;
    } else {
     HEAP32[$vararg_buffer14>>2] = $233; //@line 91605 "c/sqlite3.c"
     $vararg_ptr17 = ((($vararg_buffer14)) + 4|0); //@line 91605 "c/sqlite3.c"
     HEAP32[$vararg_ptr17>>2] = $3; //@line 91605 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,20071,$vararg_buffer14); //@line 91605 "c/sqlite3.c"
     break;
    }
   } else {
    HEAP32[$vararg_buffer3>>2] = $233; //@line 91601 "c/sqlite3.c"
    $vararg_ptr6 = ((($vararg_buffer3)) + 4|0); //@line 91601 "c/sqlite3.c"
    HEAP32[$vararg_ptr6>>2] = $$0263; //@line 91601 "c/sqlite3.c"
    $vararg_ptr7 = ((($vararg_buffer3)) + 8|0); //@line 91601 "c/sqlite3.c"
    HEAP32[$vararg_ptr7>>2] = $2; //@line 91601 "c/sqlite3.c"
    $vararg_ptr8 = ((($vararg_buffer3)) + 12|0); //@line 91601 "c/sqlite3.c"
    HEAP32[$vararg_ptr8>>2] = $3; //@line 91601 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,23787,$vararg_buffer3); //@line 91601 "c/sqlite3.c"
   }
  } while(0);
  $234 = ((($0)) + 17|0); //@line 91607 "c/sqlite3.c"
  HEAP8[$234>>0] = 1; //@line 91607 "c/sqlite3.c"
  $235 = ((($4)) + 24|0); //@line 91608 "c/sqlite3.c"
  $236 = HEAP32[$235>>2]|0; //@line 91608 "c/sqlite3.c"
  $237 = (($236) + 1)|0; //@line 91608 "c/sqlite3.c"
  HEAP32[$235>>2] = $237; //@line 91608 "c/sqlite3.c"
  $$1265348355359 = $$1265348355358;$$14507 = $$14508;$$3303335497504 = $$3303335;$$4308334498501 = $$4308334;
  label = 89;
 }
 if ((label|0) == 89) {
  $238 = ((($5)) + 32|0); //@line 91617 "c/sqlite3.c"
  $239 = HEAP16[$238>>1]|0; //@line 91617 "c/sqlite3.c"
  $240 = $239 << 16 >> 16; //@line 91617 "c/sqlite3.c"
  $241 = ($239<<16>>16)>(-1); //@line 91617 "c/sqlite3.c"
  $242 = ($$7317|0)!=(0|0); //@line 91617 "c/sqlite3.c"
  $or$cond18 = $242 & $241; //@line 91617 "c/sqlite3.c"
  $243 = ((($$7317)) + 56|0); //@line 91624 "c/sqlite3.c"
  if ($or$cond18) {
   $244 = ($240|0)<(63); //@line 91620 "c/sqlite3.c"
   $spec$store$select = $244 ? $240 : 63; //@line 91620 "c/sqlite3.c"
   $245 = (_bitshift64Shl(1,0,($spec$store$select|0))|0); //@line 91624 "c/sqlite3.c"
   $246 = tempRet0; //@line 91624 "c/sqlite3.c"
   $247 = $243; //@line 91624 "c/sqlite3.c"
   $248 = $247; //@line 91624 "c/sqlite3.c"
   $249 = HEAP32[$248>>2]|0; //@line 91624 "c/sqlite3.c"
   $250 = (($247) + 4)|0; //@line 91624 "c/sqlite3.c"
   $251 = $250; //@line 91624 "c/sqlite3.c"
   $252 = HEAP32[$251>>2]|0; //@line 91624 "c/sqlite3.c"
   $253 = $249 | $245; //@line 91624 "c/sqlite3.c"
   $254 = $252 | $246; //@line 91624 "c/sqlite3.c"
   $255 = $243; //@line 91624 "c/sqlite3.c"
   $256 = $255; //@line 91624 "c/sqlite3.c"
   HEAP32[$256>>2] = $253; //@line 91624 "c/sqlite3.c"
   $257 = (($255) + 4)|0; //@line 91624 "c/sqlite3.c"
   $258 = $257; //@line 91624 "c/sqlite3.c"
   HEAP32[$258>>2] = $254; //@line 91624 "c/sqlite3.c"
  }
  $259 = ((($5)) + 12|0); //@line 91629 "c/sqlite3.c"
  $260 = HEAP32[$259>>2]|0; //@line 91629 "c/sqlite3.c"
  _sqlite3ExprDelete($6,$260); //@line 91629 "c/sqlite3.c"
  HEAP32[$259>>2] = 0; //@line 91630 "c/sqlite3.c"
  $261 = ((($5)) + 16|0); //@line 91631 "c/sqlite3.c"
  $262 = HEAP32[$261>>2]|0; //@line 91631 "c/sqlite3.c"
  _sqlite3ExprDelete($6,$262); //@line 91631 "c/sqlite3.c"
  HEAP32[$261>>2] = 0; //@line 91632 "c/sqlite3.c"
  $263 = ($$3303335497504|0)==(0); //@line 91633 "c/sqlite3.c"
  $264 = $263 ? -111 : 75; //@line 91633 "c/sqlite3.c"
  HEAP8[$5>>0] = $264; //@line 91633 "c/sqlite3.c"
  $265 = ((($5)) + 4|0); //@line 91634 "c/sqlite3.c"
  $266 = HEAP32[$265>>2]|0; //@line 91634 "c/sqlite3.c"
  $267 = $266 | 8388608; //@line 91634 "c/sqlite3.c"
  HEAP32[$265>>2] = $267; //@line 91634 "c/sqlite3.c"
  $268 = ($$14507|0)==(1); //@line 91636 "c/sqlite3.c"
  if ($268) {
   $$1265347361 = $$1265348355359;$$4308334499 = $$4308334498501;
  } else {
   $$6 = 2;
   STACKTOP = sp;return ($$6|0); //@line 91653 "c/sqlite3.c"
  }
 }
 $269 = ((($5)) + 4|0); //@line 91638 "c/sqlite3.c"
 $270 = HEAP32[$269>>2]|0; //@line 91638 "c/sqlite3.c"
 $271 = $270 & 4194304; //@line 91638 "c/sqlite3.c"
 $272 = ($271|0)==(0); //@line 91638 "c/sqlite3.c"
 if ($272) {
  $273 = ((($$1265347361)) + 4|0); //@line 91639 "c/sqlite3.c"
  $274 = HEAP32[$273>>2]|0; //@line 91639 "c/sqlite3.c"
  _sqlite3AuthRead($0,$5,$$4308334499,$274); //@line 91639 "c/sqlite3.c"
 }
 $275 = ((($4)) + 20|0); //@line 91645 "c/sqlite3.c"
 $276 = HEAP32[$275>>2]|0; //@line 91645 "c/sqlite3.c"
 $277 = (($276) + 1)|0; //@line 91645 "c/sqlite3.c"
 HEAP32[$275>>2] = $277; //@line 91645 "c/sqlite3.c"
 $278 = ($$1265347361|0)==($4|0); //@line 91646 "c/sqlite3.c"
 if ($278) {
  $$6 = 1;
  STACKTOP = sp;return ($$6|0); //@line 91653 "c/sqlite3.c"
 }
 $$0309415 = $4;
 while(1) {
  $279 = ((($$0309415)) + 16|0); //@line 91647 "c/sqlite3.c"
  $280 = HEAP32[$279>>2]|0; //@line 91647 "c/sqlite3.c"
  $281 = ((($280)) + 20|0); //@line 91645 "c/sqlite3.c"
  $282 = HEAP32[$281>>2]|0; //@line 91645 "c/sqlite3.c"
  $283 = (($282) + 1)|0; //@line 91645 "c/sqlite3.c"
  HEAP32[$281>>2] = $283; //@line 91645 "c/sqlite3.c"
  $284 = ($280|0)==($$1265347361|0); //@line 91646 "c/sqlite3.c"
  if ($284) {
   $$6 = 1;
   break;
  } else {
   $$0309415 = $280;
  }
 }
 STACKTOP = sp;return ($$6|0); //@line 91653 "c/sqlite3.c"
}
function _sqlite3FindFunction($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$07394 = 0, $$075$lcssa = 0, $$07593 = 0, $$077$lcssa = 0, $$07792 = 0, $$1 = 0, $$17490 = 0, $$27988 = 0, $$289 = 0, $$4 = 0, $$481 = 0, $$5 = 0, $$587 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $brmerge = 0, $or$cond = 0, $spec$select = 0, $spec$select82 = 0, $spec$select83 = 0, $spec$select84 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3Strlen30($1)|0); //@line 106440 "c/sqlite3.c"
 $6 = ((($0)) + 356|0); //@line 106444 "c/sqlite3.c"
 $7 = (_sqlite3HashFind($6,$1)|0); //@line 106444 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 106445 "c/sqlite3.c"
 if ($8) {
  $$075$lcssa = 0;$$077$lcssa = 0;
 } else {
  $$07394 = $7;$$07593 = 0;$$07792 = 0;
  while(1) {
   $9 = (_matchQuality($$07394,$2,$3)|0); //@line 106446 "c/sqlite3.c"
   $10 = ($9|0)>($$07792|0); //@line 106447 "c/sqlite3.c"
   $spec$select = $10 ? $9 : $$07792; //@line 106447 "c/sqlite3.c"
   $spec$select82 = $10 ? $$07394 : $$07593; //@line 106447 "c/sqlite3.c"
   $11 = ((($$07394)) + 8|0); //@line 106451 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 106451 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 106445 "c/sqlite3.c"
   if ($13) {
    $$075$lcssa = $spec$select82;$$077$lcssa = $spec$select;
    break;
   } else {
    $$07394 = $12;$$07593 = $spec$select82;$$07792 = $spec$select;
   }
  }
 }
 $14 = ($4<<24>>24)==(0); //@line 106466 "c/sqlite3.c"
 do {
  if ($14) {
   $15 = ($$075$lcssa|0)==(0|0); //@line 106466 "c/sqlite3.c"
   if (!($15)) {
    $16 = ((($0)) + 24|0); //@line 106466 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 106466 "c/sqlite3.c"
    $18 = $17 & 2; //@line 106466 "c/sqlite3.c"
    $19 = ($18|0)==(0); //@line 106466 "c/sqlite3.c"
    if ($19) {
     $$587 = $$075$lcssa;$52 = 0;
     label = 16;
     break;
    }
   }
   $20 = HEAP8[$1>>0]|0; //@line 106468 "c/sqlite3.c"
   $21 = $20&255; //@line 106468 "c/sqlite3.c"
   $22 = (16025 + ($21)|0); //@line 106468 "c/sqlite3.c"
   $23 = HEAP8[$22>>0]|0; //@line 106468 "c/sqlite3.c"
   $24 = $23&255; //@line 106468 "c/sqlite3.c"
   $25 = (($5) + ($24))|0; //@line 106468 "c/sqlite3.c"
   $26 = (($25|0) % 23)&-1; //@line 106468 "c/sqlite3.c"
   $27 = (_functionSearch($26,$1)|0); //@line 106469 "c/sqlite3.c"
   $28 = ($27|0)==(0|0); //@line 106470 "c/sqlite3.c"
   if ($28) {
    $$5 = $$075$lcssa;$53 = 0;
    label = 15;
   } else {
    $$17490 = $27;$$27988 = 0;$$289 = $$075$lcssa;
    while(1) {
     $29 = (_matchQuality($$17490,$2,$3)|0); //@line 106471 "c/sqlite3.c"
     $30 = ($29|0)>($$27988|0); //@line 106472 "c/sqlite3.c"
     $spec$select83 = $30 ? $29 : $$27988; //@line 106472 "c/sqlite3.c"
     $spec$select84 = $30 ? $$17490 : $$289; //@line 106472 "c/sqlite3.c"
     $31 = ((($$17490)) + 8|0); //@line 106476 "c/sqlite3.c"
     $32 = HEAP32[$31>>2]|0; //@line 106476 "c/sqlite3.c"
     $33 = ($32|0)==(0|0); //@line 106470 "c/sqlite3.c"
     if ($33) {
      $$4 = $spec$select84;$$481 = $spec$select83;
      label = 10;
      break;
     } else {
      $$17490 = $32;$$27988 = $spec$select83;$$289 = $spec$select84;
     }
    }
   }
  } else {
   $$4 = $$075$lcssa;$$481 = $$077$lcssa;
   label = 10;
  }
 } while(0);
 do {
  if ((label|0) == 10) {
   $34 = ($4<<24>>24)!=(0); //@line 106484 "c/sqlite3.c"
   $35 = ($$481|0)<(6); //@line 106484 "c/sqlite3.c"
   $or$cond = $34 & $35; //@line 106484 "c/sqlite3.c"
   if ($or$cond) {
    $36 = (($5) + 29)|0; //@line 106485 "c/sqlite3.c"
    $37 = (_sqlite3DbMallocZero($0,$36,0)|0); //@line 106485 "c/sqlite3.c"
    $38 = ($37|0)==(0|0); //@line 106485 "c/sqlite3.c"
    if ($38) {
     $$5 = $37;$53 = $34;
     label = 15;
    } else {
     $39 = ((($37)) + 28|0); //@line 106487 "c/sqlite3.c"
     $40 = ((($37)) + 20|0); //@line 106487 "c/sqlite3.c"
     HEAP32[$40>>2] = $39; //@line 106487 "c/sqlite3.c"
     $41 = $2&255; //@line 106488 "c/sqlite3.c"
     HEAP8[$37>>0] = $41; //@line 106488 "c/sqlite3.c"
     $42 = $3&255; //@line 106489 "c/sqlite3.c"
     $43 = ((($37)) + 2|0); //@line 106489 "c/sqlite3.c"
     HEAP16[$43>>1] = $42; //@line 106489 "c/sqlite3.c"
     $44 = (($5) + 1)|0; //@line 106490 "c/sqlite3.c"
     _memcpy(($39|0),($1|0),($44|0))|0; //@line 106490 "c/sqlite3.c"
     $45 = (_sqlite3HashInsert($6,$39,$37)|0); //@line 106491 "c/sqlite3.c"
     $46 = ($45|0)==($37|0); //@line 106492 "c/sqlite3.c"
     if (!($46)) {
      $47 = ((($37)) + 8|0); //@line 106497 "c/sqlite3.c"
      HEAP32[$47>>2] = $45; //@line 106497 "c/sqlite3.c"
      $$587 = $37;$52 = $34;
      label = 16;
      break;
     }
     _sqlite3DbFree($0,$37); //@line 106493 "c/sqlite3.c"
     _sqlite3OomFault($0); //@line 106494 "c/sqlite3.c"
     $$1 = 0;
     return ($$1|0); //@line 106505 "c/sqlite3.c"
    }
   } else {
    $$5 = $$4;$53 = $34;
    label = 15;
   }
  }
 } while(0);
 if ((label|0) == 15) {
  $48 = ($$5|0)==(0|0); //@line 106501 "c/sqlite3.c"
  if (!($48)) {
   $$587 = $$5;$52 = $53;
   label = 16;
  }
 }
 if ((label|0) == 16) {
  $49 = ((($$587)) + 12|0); //@line 106501 "c/sqlite3.c"
  $50 = HEAP32[$49>>2]|0; //@line 106501 "c/sqlite3.c"
  $51 = ($50|0)!=(0|0); //@line 106501 "c/sqlite3.c"
  $brmerge = $52 | $51; //@line 106501 "c/sqlite3.c"
  if ($brmerge) {
   $$1 = $$587;
   return ($$1|0); //@line 106505 "c/sqlite3.c"
  }
 }
 $$1 = 0;
 return ($$1|0); //@line 106505 "c/sqlite3.c"
}
function _exprProbability($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAPF64[$1>>3] = -1.0; //@line 91704 "c/sqlite3.c"
 $2 = HEAP8[$0>>0]|0; //@line 91705 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(-124); //@line 91705 "c/sqlite3.c"
 if (!($3)) {
  $$0 = -1;
  STACKTOP = sp;return ($$0|0); //@line 91710 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0); //@line 91706 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 91706 "c/sqlite3.c"
 $6 = (_sqlite3Strlen30($5)|0); //@line 91706 "c/sqlite3.c"
 (_sqlite3AtoF($5,$1,$6,1)|0); //@line 91706 "c/sqlite3.c"
 $7 = +HEAPF64[$1>>3]; //@line 91708 "c/sqlite3.c"
 $8 = $7 > 1.0; //@line 91708 "c/sqlite3.c"
 if ($8) {
  $$0 = -1;
  STACKTOP = sp;return ($$0|0); //@line 91710 "c/sqlite3.c"
 }
 $9 = $7 * 134217728.0; //@line 91709 "c/sqlite3.c"
 $10 = (~~(($9))); //@line 91709 "c/sqlite3.c"
 $$0 = $10;
 STACKTOP = sp;return ($$0|0); //@line 91710 "c/sqlite3.c"
}
function _sqlite3FunctionUsesThisSrc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $2 = sp + 12|0;
 $3 = sp;
 $4 = ((($2)) + 4|0); //@line 97707 "c/sqlite3.c"
 HEAP32[$4>>2] = 157; //@line 97707 "c/sqlite3.c"
 $5 = ((($2)) + 8|0); //@line 97708 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 97708 "c/sqlite3.c"
 $6 = ((($2)) + 24|0); //@line 97709 "c/sqlite3.c"
 HEAP32[$6>>2] = $3; //@line 97709 "c/sqlite3.c"
 HEAP32[$3>>2] = $1; //@line 97710 "c/sqlite3.c"
 $7 = ((($3)) + 4|0); //@line 97711 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 97711 "c/sqlite3.c"
 $8 = ((($3)) + 8|0); //@line 97712 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 97712 "c/sqlite3.c"
 $9 = ((($0)) + 20|0); //@line 97713 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 97713 "c/sqlite3.c"
 (_sqlite3WalkExprList($2,$10)|0); //@line 97713 "c/sqlite3.c"
 $11 = HEAP32[$7>>2]|0; //@line 97714 "c/sqlite3.c"
 $12 = ($11|0)>(0); //@line 97714 "c/sqlite3.c"
 $13 = HEAP32[$8>>2]|0; //@line 97714 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 97714 "c/sqlite3.c"
 $15 = $12 | $14; //@line 97714 "c/sqlite3.c"
 $16 = $15&1; //@line 97714 "c/sqlite3.c"
 STACKTOP = sp;return ($16|0); //@line 97714 "c/sqlite3.c"
}
function _sqlite3ExprVectorSize($0) {
 $0 = $0|0;
 var $$0 = 0, $$07 = 0, $$sink = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 93062 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(-106); //@line 93063 "c/sqlite3.c"
 if ($2) {
  $3 = ((($0)) + 38|0); //@line 93063 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 93063 "c/sqlite3.c"
  $$0 = $4;
 } else {
  $$0 = $1;
 }
 switch ($$0<<24>>24) {
 case -105:  {
  $5 = ((($0)) + 20|0); //@line 93065 "c/sqlite3.c"
  $$sink = $5;
  break;
 }
 case 119:  {
  $6 = ((($0)) + 20|0); //@line 93067 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 93067 "c/sqlite3.c"
  $$sink = $7;
  break;
 }
 default: {
  $$07 = 1;
  return ($$07|0); //@line 93071 "c/sqlite3.c"
 }
 }
 $8 = HEAP32[$$sink>>2]|0;
 $9 = HEAP32[$8>>2]|0;
 $$07 = $9;
 return ($$07|0); //@line 93071 "c/sqlite3.c"
}
function _exprSrcCount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$021 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 97680 "c/sqlite3.c"
 switch ($2<<24>>24) {
 case -109: case -111:  {
  break;
 }
 default: {
  return 0; //@line 97694 "c/sqlite3.c"
 }
 }
 $3 = ((($0)) + 24|0); //@line 97682 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 97682 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 97683 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 97684 "c/sqlite3.c"
 L4: do {
  if ($6) {
   label = 8;
  } else {
   $7 = HEAP32[$5>>2]|0; //@line 97684 "c/sqlite3.c"
   $8 = ($7|0)>(0); //@line 97685 "c/sqlite3.c"
   if ($8) {
    $9 = ((($1)) + 28|0);
    $10 = HEAP32[$9>>2]|0;
    $$021 = 0;
    while(1) {
     $13 = (((((($5)) + 8|0) + (($$021*72)|0)|0)) + 44|0); //@line 97686 "c/sqlite3.c"
     $14 = HEAP32[$13>>2]|0; //@line 97686 "c/sqlite3.c"
     $15 = ($10|0)==($14|0); //@line 97686 "c/sqlite3.c"
     $12 = (($$021) + 1)|0; //@line 97685 "c/sqlite3.c"
     if ($15) {
      break;
     }
     $11 = ($12|0)<($7|0); //@line 97685 "c/sqlite3.c"
     if ($11) {
      $$021 = $12;
     } else {
      label = 8;
      break L4;
     }
    }
    $16 = ((($4)) + 4|0); //@line 97689 "c/sqlite3.c"
    $$sink = $16;
   } else {
    label = 8;
   }
  }
 } while(0);
 if ((label|0) == 8) {
  $17 = ((($4)) + 8|0); //@line 97691 "c/sqlite3.c"
  $$sink = $17;
 }
 $18 = HEAP32[$$sink>>2]|0;
 $19 = (($18) + 1)|0;
 HEAP32[$$sink>>2] = $19;
 return 0; //@line 97694 "c/sqlite3.c"
}
function _matchQuality($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$014 = 0, $$lobit = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(-2); //@line 106337 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 12|0); //@line 106337 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 106337 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 106337 "c/sqlite3.c"
  $7 = $6 ? 0 : 6; //@line 106337 "c/sqlite3.c"
  $$014 = $7;
  return ($$014|0); //@line 106358 "c/sqlite3.c"
 }
 $8 = HEAP8[$0>>0]|0; //@line 106340 "c/sqlite3.c"
 $9 = $8 << 24 >> 24; //@line 106340 "c/sqlite3.c"
 $10 = ($9|0)!=($1|0); //@line 106340 "c/sqlite3.c"
 $11 = ($8<<24>>24)>(-1); //@line 106340 "c/sqlite3.c"
 $or$cond = $11 & $10; //@line 106340 "c/sqlite3.c"
 if ($or$cond) {
  $$014 = 0;
  return ($$014|0); //@line 106358 "c/sqlite3.c"
 }
 $12 = ($9|0)==($1|0); //@line 106344 "c/sqlite3.c"
 $$ = $12 ? 4 : 1; //@line 106346 "c/sqlite3.c"
 $13 = $2&255; //@line 106351 "c/sqlite3.c"
 $14 = ((($0)) + 2|0); //@line 106351 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 106351 "c/sqlite3.c"
 $16 = $15&65535; //@line 106351 "c/sqlite3.c"
 $17 = $16 & 3; //@line 106351 "c/sqlite3.c"
 $18 = ($17|0)==($13|0); //@line 106351 "c/sqlite3.c"
 if (!($18)) {
  $20 = $16 & $13; //@line 106353 "c/sqlite3.c"
  $21 = $20 >>> 1; //@line 106353 "c/sqlite3.c"
  $$lobit = $21 & 1; //@line 106353 "c/sqlite3.c"
  $spec$select = (($$lobit) + ($$))|0; //@line 106353 "c/sqlite3.c"
  return ($spec$select|0); //@line 106353 "c/sqlite3.c"
 }
 $19 = $$ | 2; //@line 106352 "c/sqlite3.c"
 $$014 = $19;
 return ($$014|0); //@line 106358 "c/sqlite3.c"
}
function _sqlite3MatchSpanName($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$031 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0 = 0;
 L1: while(1) {
  $4 = (($0) + ($$0)|0); //@line 91287 "c/sqlite3.c"
  $5 = HEAP8[$4>>0]|0; //@line 91287 "c/sqlite3.c"
  switch ($5<<24>>24) {
  case 46: case 0:  {
   break L1;
   break;
  }
  default: {
  }
  }
  $6 = (($$0) + 1)|0; //@line 91287 "c/sqlite3.c"
  $$0 = $6;
 }
 $7 = ($3|0)==(0|0); //@line 91288 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_sqlite3_strnicmp($0,$3,$$0)|0); //@line 91288 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 91288 "c/sqlite3.c"
  if (!($9)) {
   $$031 = 0;
   return ($$031|0); //@line 91301 "c/sqlite3.c"
  }
  $10 = (($3) + ($$0)|0); //@line 91288 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 91288 "c/sqlite3.c"
  $12 = ($11<<24>>24)==(0); //@line 91288 "c/sqlite3.c"
  if (!($12)) {
   $$031 = 0;
   return ($$031|0); //@line 91301 "c/sqlite3.c"
  }
 }
 $13 = (($$0) + 1)|0; //@line 91291 "c/sqlite3.c"
 $14 = (($0) + ($13)|0); //@line 91291 "c/sqlite3.c"
 $$1 = 0;
 L12: while(1) {
  $15 = (($14) + ($$1)|0); //@line 91292 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 91292 "c/sqlite3.c"
  switch ($16<<24>>24) {
  case 46: case 0:  {
   break L12;
   break;
  }
  default: {
  }
  }
  $17 = (($$1) + 1)|0; //@line 91292 "c/sqlite3.c"
  $$1 = $17;
 }
 $18 = ($2|0)==(0|0); //@line 91293 "c/sqlite3.c"
 if (!($18)) {
  $19 = (_sqlite3_strnicmp($14,$2,$$1)|0); //@line 91293 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 91293 "c/sqlite3.c"
  if (!($20)) {
   $$031 = 0;
   return ($$031|0); //@line 91301 "c/sqlite3.c"
  }
  $21 = (($2) + ($$1)|0); //@line 91293 "c/sqlite3.c"
  $22 = HEAP8[$21>>0]|0; //@line 91293 "c/sqlite3.c"
  $23 = ($22<<24>>24)==(0); //@line 91293 "c/sqlite3.c"
  if (!($23)) {
   $$031 = 0;
   return ($$031|0); //@line 91301 "c/sqlite3.c"
  }
 }
 $24 = ($1|0)==(0|0); //@line 91297 "c/sqlite3.c"
 if (!($24)) {
  $25 = (($$1) + 1)|0; //@line 91296 "c/sqlite3.c"
  $26 = (($14) + ($25)|0); //@line 91296 "c/sqlite3.c"
  $27 = (_sqlite3StrICmp($26,$1)|0); //@line 91297 "c/sqlite3.c"
  $28 = ($27|0)==(0); //@line 91297 "c/sqlite3.c"
  if (!($28)) {
   $$031 = 0;
   return ($$031|0); //@line 91301 "c/sqlite3.c"
  }
 }
 $$031 = 1;
 return ($$031|0); //@line 91301 "c/sqlite3.c"
}
function _nameInUsingClause($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0911 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 91264 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$1 = 0;
  } else {
   $3 = ((($0)) + 4|0); //@line 91266 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 91266 "c/sqlite3.c"
   $5 = ($4|0)>(0); //@line 91266 "c/sqlite3.c"
   if ($5) {
    $6 = HEAP32[$0>>2]|0;
    $$0911 = 0;
    while(1) {
     $10 = (($6) + ($$0911<<3)|0); //@line 91267 "c/sqlite3.c"
     $11 = HEAP32[$10>>2]|0; //@line 91267 "c/sqlite3.c"
     $12 = (_sqlite3StrICmp($11,$1)|0); //@line 91267 "c/sqlite3.c"
     $13 = ($12|0)==(0); //@line 91267 "c/sqlite3.c"
     $9 = (($$0911) + 1)|0; //@line 91266 "c/sqlite3.c"
     if ($13) {
      $$1 = 1;
      break L1;
     }
     $7 = HEAP32[$3>>2]|0; //@line 91266 "c/sqlite3.c"
     $8 = ($9|0)<($7|0); //@line 91266 "c/sqlite3.c"
     if ($8) {
      $$0911 = $9;
     } else {
      $$1 = 0;
      break;
     }
    }
   } else {
    $$1 = 0;
   }
  }
 } while(0);
 return ($$1|0); //@line 91271 "c/sqlite3.c"
}
function _sqlite3IsRowid($0) {
 $0 = $0|0;
 var $$ = 0, $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3StrICmp($0,23839)|0); //@line 94755 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 94755 "c/sqlite3.c"
 if ($2) {
  $$0 = 1;
 } else {
  $3 = (_sqlite3StrICmp($0,23800)|0); //@line 94756 "c/sqlite3.c"
  $4 = ($3|0)==(0); //@line 94756 "c/sqlite3.c"
  if ($4) {
   $$0 = 1;
  } else {
   $5 = (_sqlite3StrICmp($0,23847)|0); //@line 94757 "c/sqlite3.c"
   $6 = ($5|0)==(0); //@line 94757 "c/sqlite3.c"
   $$ = $6&1; //@line 94757 "c/sqlite3.c"
   $$0 = $$;
  }
 }
 return ($$0|0); //@line 94759 "c/sqlite3.c"
}
function _sqlite3AuthRead($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$0$in = 0, $$037 = 0, $$03840 = 0, $$sink = 0, $$sink45 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 101490 "c/sqlite3.c"
 $5 = ((($4)) + 304|0); //@line 101497 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 101497 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 101497 "c/sqlite3.c"
 if ($7) {
  return; //@line 101533 "c/sqlite3.c"
 }
 $8 = (_sqlite3SchemaToIndex($4,$2)|0); //@line 101498 "c/sqlite3.c"
 $9 = ($8|0)<(0); //@line 101499 "c/sqlite3.c"
 if ($9) {
  return; //@line 101533 "c/sqlite3.c"
 }
 $10 = HEAP8[$1>>0]|0; //@line 101506 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(75); //@line 101506 "c/sqlite3.c"
 do {
  if ($11) {
   $12 = ((($0)) + 124|0); //@line 101507 "c/sqlite3.c"
   $$0$in = $12;
  } else {
   $13 = HEAP32[$3>>2]|0; //@line 101510 "c/sqlite3.c"
   $14 = ($13|0)>(0); //@line 101510 "c/sqlite3.c"
   if (!($14)) {
    return; //@line 101533 "c/sqlite3.c"
   }
   $15 = ((($1)) + 28|0);
   $16 = HEAP32[$15>>2]|0;
   $$03840 = 0;
   while(1) {
    $17 = (((((($3)) + 8|0) + (($$03840*72)|0)|0)) + 44|0); //@line 101511 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 101511 "c/sqlite3.c"
    $19 = ($16|0)==($18|0); //@line 101511 "c/sqlite3.c"
    if ($19) {
     label = 8;
     break;
    }
    $21 = (($$03840) + 1)|0; //@line 101510 "c/sqlite3.c"
    $22 = HEAP32[$3>>2]|0; //@line 101510 "c/sqlite3.c"
    $23 = ($21|0)<($22|0); //@line 101510 "c/sqlite3.c"
    if ($23) {
     $$03840 = $21;
    } else {
     label = 17;
     break;
    }
   }
   if ((label|0) == 8) {
    $20 = (((((($3)) + 8|0) + (($$03840*72)|0)|0)) + 16|0); //@line 101512 "c/sqlite3.c"
    $$0$in = $20;
    break;
   }
   else if ((label|0) == 17) {
    return; //@line 101533 "c/sqlite3.c"
   }
  }
 } while(0);
 $$0 = HEAP32[$$0$in>>2]|0;
 $24 = ((($1)) + 32|0); //@line 101517 "c/sqlite3.c"
 $25 = HEAP16[$24>>1]|0; //@line 101517 "c/sqlite3.c"
 $26 = $25 << 16 >> 16; //@line 101517 "c/sqlite3.c"
 $27 = ($$0|0)==(0|0); //@line 101518 "c/sqlite3.c"
 if ($27) {
  return; //@line 101533 "c/sqlite3.c"
 }
 $28 = ($25<<16>>16)>(-1); //@line 101520 "c/sqlite3.c"
 if ($28) {
  $$sink45 = $26;
  label = 14;
 } else {
  $29 = ((($$0)) + 40|0); //@line 101523 "c/sqlite3.c"
  $30 = HEAP16[$29>>1]|0; //@line 101523 "c/sqlite3.c"
  $31 = ($30<<16>>16)>(-1); //@line 101523 "c/sqlite3.c"
  if ($31) {
   $32 = $30 << 16 >> 16; //@line 101523 "c/sqlite3.c"
   $$sink45 = $32;
   label = 14;
  } else {
   $$037 = 23800;
  }
 }
 if ((label|0) == 14) {
  $$sink = ((($$0)) + 4|0);
  $33 = HEAP32[$$sink>>2]|0;
  $34 = (($33) + ($$sink45<<4)|0);
  $35 = HEAP32[$34>>2]|0;
  $$037 = $35;
 }
 $36 = HEAP32[$$0>>2]|0; //@line 101530 "c/sqlite3.c"
 $37 = (_sqlite3AuthReadCol($0,$36,$$037,$8)|0); //@line 101530 "c/sqlite3.c"
 $38 = ($37|0)==(2); //@line 101530 "c/sqlite3.c"
 if (!($38)) {
  return; //@line 101533 "c/sqlite3.c"
 }
 HEAP8[$1>>0] = 101; //@line 101531 "c/sqlite3.c"
 return; //@line 101533 "c/sqlite3.c"
}
function _sqlite3AuthReadCol($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$034 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer6 = 0, $vararg_ptr1 = 0, $vararg_ptr5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer6 = sp + 16|0; //@line 101449 "c/sqlite3.c"
 $vararg_buffer2 = sp + 8|0; //@line 101449 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 101449 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 101454 "c/sqlite3.c"
 $5 = ((($4)) + 16|0); //@line 101455 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 101455 "c/sqlite3.c"
 $7 = (($6) + ($3<<4)|0); //@line 101455 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 101455 "c/sqlite3.c"
 $9 = ((($4)) + 157|0); //@line 101458 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 101458 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 101458 "c/sqlite3.c"
 if (!($11)) {
  $$034 = 0;
  STACKTOP = sp;return ($$034|0); //@line 101473 "c/sqlite3.c"
 }
 $12 = ((($4)) + 304|0); //@line 101459 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 101459 "c/sqlite3.c"
 $14 = ((($4)) + 308|0); //@line 101459 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 101459 "c/sqlite3.c"
 $16 = ((($0)) + 440|0); //@line 101459 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 101459 "c/sqlite3.c"
 $18 = (FUNCTION_TABLE_iiiiiii[$13 & 127]($15,20,$1,$2,$8,$17)|0); //@line 101459 "c/sqlite3.c"
 $19 = ($18|0)==(1); //@line 101464 "c/sqlite3.c"
 if ($19) {
  HEAP32[$vararg_buffer>>2] = $1; //@line 101465 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 101465 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $2; //@line 101465 "c/sqlite3.c"
  $20 = (_sqlite3_mprintf(17909,$vararg_buffer)|0); //@line 101465 "c/sqlite3.c"
  $21 = ((($4)) + 20|0); //@line 101466 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 101466 "c/sqlite3.c"
  $23 = ($22|0)>(2); //@line 101466 "c/sqlite3.c"
  $24 = ($3|0)!=(0); //@line 101466 "c/sqlite3.c"
  $or$cond = $24 | $23; //@line 101466 "c/sqlite3.c"
  if ($or$cond) {
   HEAP32[$vararg_buffer2>>2] = $8; //@line 101466 "c/sqlite3.c"
   $vararg_ptr5 = ((($vararg_buffer2)) + 4|0); //@line 101466 "c/sqlite3.c"
   HEAP32[$vararg_ptr5>>2] = $20; //@line 101466 "c/sqlite3.c"
   $25 = (_sqlite3_mprintf(23806,$vararg_buffer2)|0); //@line 101466 "c/sqlite3.c"
   $$0 = $25;
  } else {
   $$0 = $20;
  }
  HEAP32[$vararg_buffer6>>2] = $$0; //@line 101467 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,23812,$vararg_buffer6); //@line 101467 "c/sqlite3.c"
  $26 = ((($0)) + 12|0); //@line 101468 "c/sqlite3.c"
  HEAP32[$26>>2] = 23; //@line 101468 "c/sqlite3.c"
  $$034 = 1;
  STACKTOP = sp;return ($$034|0); //@line 101473 "c/sqlite3.c"
 } else {
  $27 = $18 | 2; //@line 101469 "c/sqlite3.c"
  $28 = ($27|0)==(2); //@line 101469 "c/sqlite3.c"
  if ($28) {
   $$034 = $18;
   STACKTOP = sp;return ($$034|0); //@line 101473 "c/sqlite3.c"
  }
  _sqliteAuthBadReturnCode($0); //@line 101470 "c/sqlite3.c"
  $$034 = $18;
  STACKTOP = sp;return ($$034|0); //@line 101473 "c/sqlite3.c"
 }
 return (0)|0;
}
function _convertCompoundSelectToSubquery($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$05660 = 0, $$05660$in = 0, $$05762 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($1)) + 48|0); //@line 122719 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 122719 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 122719 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 $6 = ((($1)) + 44|0); //@line 122720 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 122720 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 122720 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 $$05762 = $1;
 L7: while(1) {
  $9 = ((($$05762)) + 4|0); //@line 122721 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 122721 "c/sqlite3.c"
  switch ($10<<24>>24) {
  case 119: case 116:  {
   break;
  }
  default: {
   break L7;
  }
  }
  $11 = ((($$05762)) + 48|0); //@line 122721 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 122721 "c/sqlite3.c"
  $cond = ($12|0)==(0|0); //@line 122721 "c/sqlite3.c"
  if ($cond) {
   $$0 = 0;
   label = 13;
   break;
  } else {
   $$05762 = $12;
  }
 }
 if ((label|0) == 13) {
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 $13 = HEAP32[$7>>2]|0; //@line 122724 "c/sqlite3.c"
 $14 = ($13|0)>(0); //@line 122724 "c/sqlite3.c"
 if (!($14)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 $$05660$in = $13;
 while(1) {
  $$05660 = (($$05660$in) + -1)|0;
  $16 = (((($7)) + 4|0) + (($$05660*20)|0)|0); //@line 122725 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 122725 "c/sqlite3.c"
  $18 = ((($17)) + 4|0); //@line 122725 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 122725 "c/sqlite3.c"
  $20 = $19 & 256; //@line 122725 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 122725 "c/sqlite3.c"
  if (!($21)) {
   break;
  }
  $15 = ($$05660$in|0)>(1); //@line 122724 "c/sqlite3.c"
  if ($15) {
   $$05660$in = $$05660;
  } else {
   $$0 = 0;
   label = 13;
   break;
  }
 }
 if ((label|0) == 13) {
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 $22 = HEAP32[$0>>2]|0; //@line 122731 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 122732 "c/sqlite3.c"
 $24 = (_sqlite3DbMallocZero($23,64,0)|0); //@line 122733 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 122734 "c/sqlite3.c"
 if ($25) {
  $$0 = 2;
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 $26 = $2; //@line 122735 "c/sqlite3.c"
 $27 = $26; //@line 122735 "c/sqlite3.c"
 HEAP32[$27>>2] = 0; //@line 122735 "c/sqlite3.c"
 $28 = (($26) + 4)|0; //@line 122735 "c/sqlite3.c"
 $29 = $28; //@line 122735 "c/sqlite3.c"
 HEAP32[$29>>2] = 0; //@line 122735 "c/sqlite3.c"
 $30 = (_sqlite3SrcListAppendFromTerm($22,0,0,0,$2,$24,0,0)|0); //@line 122736 "c/sqlite3.c"
 $31 = ($30|0)==(0|0); //@line 122737 "c/sqlite3.c"
 if ($31) {
  $$0 = 2;
  STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
 }
 dest=$24; src=$1; stop=dest+64|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 122738 "c/sqlite3.c"
 $32 = ((($1)) + 28|0); //@line 122739 "c/sqlite3.c"
 HEAP32[$32>>2] = $30; //@line 122739 "c/sqlite3.c"
 $33 = (_sqlite3Expr($23,154,0)|0); //@line 122740 "c/sqlite3.c"
 $34 = (_sqlite3ExprListAppend($22,0,$33)|0); //@line 122740 "c/sqlite3.c"
 HEAP32[$1>>2] = $34; //@line 122740 "c/sqlite3.c"
 $35 = ((($1)) + 4|0); //@line 122741 "c/sqlite3.c"
 HEAP8[$35>>0] = 119; //@line 122741 "c/sqlite3.c"
 $36 = ((($1)) + 32|0); //@line 122742 "c/sqlite3.c"
 HEAP32[$36>>2] = 0; //@line 122742 "c/sqlite3.c"
 $37 = ((($24)) + 36|0); //@line 122743 "c/sqlite3.c"
 HEAP32[$37>>2] = 0; //@line 122743 "c/sqlite3.c"
 $38 = ((($24)) + 40|0); //@line 122744 "c/sqlite3.c"
 HEAP32[$38>>2] = 0; //@line 122744 "c/sqlite3.c"
 $39 = ((($24)) + 44|0); //@line 122745 "c/sqlite3.c"
 HEAP32[$39>>2] = 0; //@line 122745 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 122746 "c/sqlite3.c"
 $40 = ((($1)) + 52|0); //@line 122747 "c/sqlite3.c"
 HEAP32[$40>>2] = 0; //@line 122747 "c/sqlite3.c"
 $41 = ((($1)) + 60|0); //@line 122748 "c/sqlite3.c"
 HEAP32[$41>>2] = 0; //@line 122748 "c/sqlite3.c"
 $42 = ((($1)) + 8|0); //@line 122749 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 122749 "c/sqlite3.c"
 $44 = $43 & -65793; //@line 122749 "c/sqlite3.c"
 $45 = $44 | 65536; //@line 122751 "c/sqlite3.c"
 HEAP32[$42>>2] = $45; //@line 122751 "c/sqlite3.c"
 $46 = ((($24)) + 48|0); //@line 122753 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 122753 "c/sqlite3.c"
 $48 = ((($47)) + 52|0); //@line 122753 "c/sqlite3.c"
 HEAP32[$48>>2] = $24; //@line 122753 "c/sqlite3.c"
 $49 = ((($24)) + 56|0); //@line 122754 "c/sqlite3.c"
 HEAP32[$49>>2] = 0; //@line 122754 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 122756 "c/sqlite3.c"
}
function _selectExpander($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0300390 = 0, $$0302357 = 0, $$0303 = 0, $$0304 = 0, $$0305 = 0, $$0306383 = 0, $$0308 = 0, $$0309$lcssa = 0, $$0309363 = 0, $$0314387 = 0, $$0316$lcssa = 0, $$0316374 = 0, $$0322 = 0, $$0324 = 0, $$0330$lcssa = 0, $$0330382 = 0, $$1297 = 0, $$1299 = 0, $$1301364 = 0, $$1307375 = 0;
 var $$1310356 = 0, $$1315361 = 0, $$1317$lcssa = 0, $$1317$lcssa399 = 0, $$1317360 = 0, $$1323 = 0, $$1331$lcssa = 0, $$1331373 = 0, $$2311 = 0, $$2318354 = 0, $$2332 = 0, $$3312$ph = 0, $$3319 = 0, $$4320$ph = 0, $$5 = 0, $$6 = 0, $$pr = 0, $$pr347 = 0, $$sink = 0, $$sink409 = 0;
 var $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0;
 var $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0;
 var $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0;
 var $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0;
 var $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0;
 var $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0;
 var $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0;
 var $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0;
 var $244 = 0, $245 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond4 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer13 = 0, $vararg_buffer16 = 0, $vararg_buffer18 = 0, $vararg_buffer4 = 0, $vararg_buffer8 = 0, $vararg_ptr11 = 0, $vararg_ptr12 = 0, $vararg_ptr7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $vararg_buffer18 = sp + 56|0;
 $vararg_buffer16 = sp + 48|0;
 $vararg_buffer13 = sp + 40|0;
 $vararg_buffer8 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 64|0;
 $3 = HEAP32[$0>>2]|0; //@line 123002 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 123007 "c/sqlite3.c"
 $5 = ((($1)) + 8|0); //@line 123009 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 123009 "c/sqlite3.c"
 $7 = $6 | 64; //@line 123012 "c/sqlite3.c"
 HEAP32[$5>>2] = $7; //@line 123012 "c/sqlite3.c"
 $8 = ((($4)) + 73|0); //@line 123013 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 123013 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 123013 "c/sqlite3.c"
 if (!($10)) {
  $$5 = 2;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $11 = $6 & 64; //@line 123017 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 123017 "c/sqlite3.c"
 if (!($12)) {
  $$5 = 1;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $13 = ((($1)) + 28|0); //@line 123020 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 123020 "c/sqlite3.c"
 $15 = HEAP32[$1>>2]|0; //@line 123021 "c/sqlite3.c"
 $16 = ((($1)) + 60|0); //@line 123022 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 123022 "c/sqlite3.c"
 $18 = ($17|0)==(0|0); //@line 123022 "c/sqlite3.c"
 if (!($18)) {
  _sqlite3WithPush($3,$17,0); //@line 123023 "c/sqlite3.c"
 }
 _sqlite3SrcListAssignCursors($3,$14); //@line 123029 "c/sqlite3.c"
 $19 = ((($14)) + 8|0); //@line 123035 "c/sqlite3.c"
 $20 = HEAP32[$14>>2]|0; //@line 123035 "c/sqlite3.c"
 $21 = ($20|0)>(0); //@line 123035 "c/sqlite3.c"
 L10: do {
  if ($21) {
   $$0300390 = 0;$$0314387 = $19;
   L12: while(1) {
    $22 = ((($$0314387)) + 37|0); //@line 123038 "c/sqlite3.c"
    $23 = HEAP8[$22>>0]|0; //@line 123038 "c/sqlite3.c"
    $24 = $23 & 32; //@line 123038 "c/sqlite3.c"
    $25 = ($24<<24>>24)==(0); //@line 123038 "c/sqlite3.c"
    if ($25) {
     $26 = (_withExpand($0,$$0314387)|0); //@line 123041 "c/sqlite3.c"
     $27 = ($26|0)==(0); //@line 123041 "c/sqlite3.c"
     if (!($27)) {
      $$5 = 2;
      label = 93;
      break;
     }
     $28 = ((($$0314387)) + 16|0); //@line 123042 "c/sqlite3.c"
     $29 = HEAP32[$28>>2]|0; //@line 123042 "c/sqlite3.c"
     $30 = ($29|0)==(0|0); //@line 123042 "c/sqlite3.c"
     do {
      if ($30) {
       $31 = ((($$0314387)) + 8|0); //@line 123044 "c/sqlite3.c"
       $32 = HEAP32[$31>>2]|0; //@line 123044 "c/sqlite3.c"
       $33 = ($32|0)==(0|0); //@line 123044 "c/sqlite3.c"
       if ($33) {
        $34 = ((($$0314387)) + 20|0); //@line 123046 "c/sqlite3.c"
        $35 = HEAP32[$34>>2]|0; //@line 123046 "c/sqlite3.c"
        $36 = (_sqlite3WalkSelect($0,$35)|0); //@line 123050 "c/sqlite3.c"
        $37 = ($36|0)==(0); //@line 123050 "c/sqlite3.c"
        if (!($37)) {
         $$5 = 2;
         label = 93;
         break L12;
        }
        $38 = (_sqlite3DbMallocZero($4,80,0)|0); //@line 123051 "c/sqlite3.c"
        HEAP32[$28>>2] = $38; //@line 123051 "c/sqlite3.c"
        $39 = ($38|0)==(0|0); //@line 123052 "c/sqlite3.c"
        if ($39) {
         $$5 = 2;
         label = 93;
         break L12;
        }
        $40 = ((($38)) + 32|0); //@line 123053 "c/sqlite3.c"
        HEAP32[$40>>2] = 1; //@line 123053 "c/sqlite3.c"
        $41 = ((($$0314387)) + 12|0); //@line 123054 "c/sqlite3.c"
        $42 = HEAP32[$41>>2]|0; //@line 123054 "c/sqlite3.c"
        $43 = ($42|0)==(0|0); //@line 123054 "c/sqlite3.c"
        if ($43) {
         HEAP32[$vararg_buffer>>2] = $38; //@line 123057 "c/sqlite3.c"
         $45 = (_sqlite3MPrintf($4,23935,$vararg_buffer)|0); //@line 123057 "c/sqlite3.c"
         $$sink = $45;
        } else {
         $44 = (_sqlite3DbStrDup($4,$42)|0); //@line 123055 "c/sqlite3.c"
         $$sink = $44;
        }
        HEAP32[$38>>2] = $$sink;
        $$0324 = $35;
        while(1) {
         $46 = ((($$0324)) + 48|0); //@line 123059 "c/sqlite3.c"
         $47 = HEAP32[$46>>2]|0; //@line 123059 "c/sqlite3.c"
         $48 = ($47|0)==(0|0); //@line 123059 "c/sqlite3.c"
         if ($48) {
          break;
         } else {
          $$0324 = $47;
         }
        }
        $49 = HEAP32[$$0324>>2]|0; //@line 123060 "c/sqlite3.c"
        $50 = ((($38)) + 42|0); //@line 123060 "c/sqlite3.c"
        $51 = ((($38)) + 4|0); //@line 123060 "c/sqlite3.c"
        _sqlite3ColumnsFromExprList($3,$49,$50,$51); //@line 123060 "c/sqlite3.c"
        $52 = ((($38)) + 40|0); //@line 123061 "c/sqlite3.c"
        HEAP16[$52>>1] = -1; //@line 123061 "c/sqlite3.c"
        $53 = ((($38)) + 44|0); //@line 123062 "c/sqlite3.c"
        HEAP16[$53>>1] = 200; //@line 123062 "c/sqlite3.c"
        $54 = ((($38)) + 36|0); //@line 123063 "c/sqlite3.c"
        $55 = HEAP32[$54>>2]|0; //@line 123063 "c/sqlite3.c"
        $56 = $55 | 2; //@line 123063 "c/sqlite3.c"
        HEAP32[$54>>2] = $56; //@line 123063 "c/sqlite3.c"
        break;
       } else {
        $57 = (_sqlite3LocateTableItem($3,0,$$0314387)|0); //@line 123068 "c/sqlite3.c"
        HEAP32[$28>>2] = $57; //@line 123068 "c/sqlite3.c"
        $58 = ($57|0)==(0|0); //@line 123069 "c/sqlite3.c"
        if ($58) {
         $$5 = 2;
         label = 93;
         break L12;
        }
        $59 = ((($57)) + 32|0); //@line 123070 "c/sqlite3.c"
        $60 = HEAP32[$59>>2]|0; //@line 123070 "c/sqlite3.c"
        $61 = ($60>>>0)>(65534); //@line 123070 "c/sqlite3.c"
        if ($61) {
         label = 21;
         break L12;
        }
        $63 = (($60) + 1)|0; //@line 123076 "c/sqlite3.c"
        HEAP32[$59>>2] = $63; //@line 123076 "c/sqlite3.c"
        $64 = ((($57)) + 56|0); //@line 123077 "c/sqlite3.c"
        $65 = HEAP32[$64>>2]|0; //@line 123077 "c/sqlite3.c"
        $66 = ($65|0)==(0); //@line 123077 "c/sqlite3.c"
        if ($66) {
         $67 = (_cannotBeFunction($3,$$0314387)|0); //@line 123077 "c/sqlite3.c"
         $68 = ($67|0)==(0); //@line 123077 "c/sqlite3.c"
         if (!($68)) {
          $$5 = 2;
          label = 93;
          break L12;
         }
         $$pr = HEAP32[$64>>2]|0; //@line 123081 "c/sqlite3.c"
         $69 = ($$pr|0)==(0); //@line 123081 "c/sqlite3.c"
         if ($69) {
          $70 = ((($57)) + 12|0); //@line 123081 "c/sqlite3.c"
          $71 = HEAP32[$70>>2]|0; //@line 123081 "c/sqlite3.c"
          $72 = ($71|0)==(0|0); //@line 123081 "c/sqlite3.c"
          if ($72) {
           break;
          }
         }
        }
        $73 = (_sqlite3ViewGetColumnNames($3,$57)|0); //@line 123083 "c/sqlite3.c"
        $74 = ($73|0)==(0); //@line 123083 "c/sqlite3.c"
        if (!($74)) {
         $$5 = 2;
         label = 93;
         break L12;
        }
        $75 = ((($57)) + 12|0); //@line 123085 "c/sqlite3.c"
        $76 = HEAP32[$75>>2]|0; //@line 123085 "c/sqlite3.c"
        $77 = (_sqlite3SelectDup($4,$76,0)|0); //@line 123085 "c/sqlite3.c"
        $78 = ((($$0314387)) + 20|0); //@line 123085 "c/sqlite3.c"
        HEAP32[$78>>2] = $77; //@line 123085 "c/sqlite3.c"
        $79 = ((($57)) + 42|0); //@line 123087 "c/sqlite3.c"
        $80 = HEAP16[$79>>1]|0; //@line 123087 "c/sqlite3.c"
        HEAP16[$79>>1] = -1; //@line 123088 "c/sqlite3.c"
        (_sqlite3WalkSelect($0,$77)|0); //@line 123089 "c/sqlite3.c"
        HEAP16[$79>>1] = $80; //@line 123090 "c/sqlite3.c"
        break;
       }
      }
     } while(0);
     $81 = (_sqlite3IndexedByLookup($3,$$0314387)|0); //@line 123096 "c/sqlite3.c"
     $82 = ($81|0)==(0); //@line 123096 "c/sqlite3.c"
     if (!($82)) {
      $$5 = 2;
      label = 93;
      break;
     }
    }
    $83 = (($$0300390) + 1)|0; //@line 123035 "c/sqlite3.c"
    $84 = ((($$0314387)) + 72|0); //@line 123035 "c/sqlite3.c"
    $85 = HEAP32[$14>>2]|0; //@line 123035 "c/sqlite3.c"
    $86 = ($83|0)<($85|0); //@line 123035 "c/sqlite3.c"
    if ($86) {
     $$0300390 = $83;$$0314387 = $84;
    } else {
     break L10;
    }
   }
   if ((label|0) == 21) {
    $62 = HEAP32[$57>>2]|0; //@line 123072 "c/sqlite3.c"
    HEAP32[$vararg_buffer1>>2] = $62; //@line 123071 "c/sqlite3.c"
    _sqlite3ErrorMsg($3,23947,$vararg_buffer1); //@line 123071 "c/sqlite3.c"
    HEAP32[$28>>2] = 0; //@line 123073 "c/sqlite3.c"
    $$5 = 2;
    STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
   }
   else if ((label|0) == 93) {
    STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
   }
  }
 } while(0);
 $87 = HEAP8[$8>>0]|0; //@line 123103 "c/sqlite3.c"
 $88 = ($87<<24>>24)==(0); //@line 123103 "c/sqlite3.c"
 if (!($88)) {
  $$5 = 2;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $89 = (_sqliteProcessJoin($3,$1)|0); //@line 123103 "c/sqlite3.c"
 $90 = ($89|0)==(0); //@line 123103 "c/sqlite3.c"
 if (!($90)) {
  $$5 = 2;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $91 = HEAP32[$15>>2]|0; //@line 123118 "c/sqlite3.c"
 $92 = ($91|0)>(0); //@line 123118 "c/sqlite3.c"
 L58: do {
  if ($92) {
   $$0306383 = 0;$$0330382 = 0;
   L60: while(1) {
    $93 = (((($15)) + 4|0) + (($$0306383*20)|0)|0); //@line 123119 "c/sqlite3.c"
    $94 = HEAP32[$93>>2]|0; //@line 123119 "c/sqlite3.c"
    $95 = HEAP8[$94>>0]|0; //@line 123120 "c/sqlite3.c"
    switch ($95<<24>>24) {
    case -102:  {
     break L60;
     break;
    }
    case 122:  {
     $96 = ((($94)) + 16|0); //@line 123123 "c/sqlite3.c"
     $97 = HEAP32[$96>>2]|0; //@line 123123 "c/sqlite3.c"
     $98 = HEAP8[$97>>0]|0; //@line 123123 "c/sqlite3.c"
     $99 = ($98<<24>>24)==(-102); //@line 123123 "c/sqlite3.c"
     if ($99) {
      break L60;
     }
     break;
    }
    default: {
    }
    }
    $100 = ((($94)) + 4|0); //@line 123124 "c/sqlite3.c"
    $101 = HEAP32[$100>>2]|0; //@line 123124 "c/sqlite3.c"
    $102 = $101 | $$0330382; //@line 123124 "c/sqlite3.c"
    $103 = (($$0306383) + 1)|0; //@line 123118 "c/sqlite3.c"
    $104 = HEAP32[$15>>2]|0; //@line 123118 "c/sqlite3.c"
    $105 = ($103|0)<($104|0); //@line 123118 "c/sqlite3.c"
    if ($105) {
     $$0306383 = $103;$$0330382 = $102;
    } else {
     $$0330$lcssa = $102;
     label = 87;
     break L58;
    }
   }
   $106 = HEAP32[$3>>2]|0; //@line 123134 "c/sqlite3.c"
   $107 = ((($106)) + 28|0); //@line 123134 "c/sqlite3.c"
   $108 = HEAP32[$107>>2]|0; //@line 123134 "c/sqlite3.c"
   $109 = $108 & 68; //@line 123136 "c/sqlite3.c"
   $110 = ($109|0)==(4); //@line 123136 "c/sqlite3.c"
   $111 = HEAP32[$15>>2]|0; //@line 123138 "c/sqlite3.c"
   $112 = ($111|0)>(0); //@line 123138 "c/sqlite3.c"
   L66: do {
    if ($112) {
     $113 = ((($4)) + 16|0);
     $$0316374 = 0;$$1307375 = 0;$$1331373 = $$0330382;
     while(1) {
      $114 = (((($15)) + 4|0) + (($$1307375*20)|0)|0); //@line 123139 "c/sqlite3.c"
      $115 = HEAP32[$114>>2]|0; //@line 123139 "c/sqlite3.c"
      $116 = ((($115)) + 4|0); //@line 123140 "c/sqlite3.c"
      $117 = HEAP32[$116>>2]|0; //@line 123140 "c/sqlite3.c"
      $118 = $117 | $$1331373; //@line 123140 "c/sqlite3.c"
      $119 = HEAP8[$115>>0]|0; //@line 123143 "c/sqlite3.c"
      switch ($119<<24>>24) {
      case -102:  {
       $$0308 = 0;
       label = 45;
       break;
      }
      case 122:  {
       $120 = ((($115)) + 16|0); //@line 123141 "c/sqlite3.c"
       $121 = HEAP32[$120>>2]|0; //@line 123141 "c/sqlite3.c"
       $122 = HEAP8[$121>>0]|0; //@line 123144 "c/sqlite3.c"
       $123 = ($122<<24>>24)==(-102); //@line 123144 "c/sqlite3.c"
       if ($123) {
        $134 = ((($115)) + 12|0); //@line 123164 "c/sqlite3.c"
        $135 = HEAP32[$134>>2]|0; //@line 123164 "c/sqlite3.c"
        $136 = ((($135)) + 8|0); //@line 123164 "c/sqlite3.c"
        $137 = HEAP32[$136>>2]|0; //@line 123164 "c/sqlite3.c"
        $$0308 = $137;
        label = 45;
       } else {
        label = 41;
       }
       break;
      }
      default: {
       label = 41;
      }
      }
      do {
       if ((label|0) == 41) {
        label = 0;
        $124 = (_sqlite3ExprListAppend($3,$$0316374,$115)|0); //@line 123148 "c/sqlite3.c"
        $125 = ($124|0)==(0|0); //@line 123149 "c/sqlite3.c"
        if (!($125)) {
         $126 = (((((($15)) + 4|0) + (($$1307375*20)|0)|0)) + 4|0); //@line 123150 "c/sqlite3.c"
         $127 = HEAP32[$126>>2]|0; //@line 123150 "c/sqlite3.c"
         $128 = HEAP32[$124>>2]|0; //@line 123150 "c/sqlite3.c"
         $129 = (($128) + -1)|0; //@line 123150 "c/sqlite3.c"
         $130 = (((((($124)) + 4|0) + (($129*20)|0)|0)) + 4|0); //@line 123150 "c/sqlite3.c"
         HEAP32[$130>>2] = $127; //@line 123150 "c/sqlite3.c"
         $131 = (((((($15)) + 4|0) + (($$1307375*20)|0)|0)) + 8|0); //@line 123151 "c/sqlite3.c"
         $132 = HEAP32[$131>>2]|0; //@line 123151 "c/sqlite3.c"
         $133 = (((((($124)) + 4|0) + (($129*20)|0)|0)) + 8|0); //@line 123151 "c/sqlite3.c"
         HEAP32[$133>>2] = $132; //@line 123151 "c/sqlite3.c"
         HEAP32[$126>>2] = 0; //@line 123152 "c/sqlite3.c"
         HEAP32[$131>>2] = 0; //@line 123153 "c/sqlite3.c"
        }
        HEAP32[$114>>2] = 0; //@line 123155 "c/sqlite3.c"
        $$6 = $124;
       }
       else if ((label|0) == 45) {
        label = 0;
        $138 = HEAP32[$14>>2]|0; //@line 123166 "c/sqlite3.c"
        $139 = ($138|0)>(0); //@line 123166 "c/sqlite3.c"
        if ($139) {
         $140 = ($$0308|0)==(0|0);
         $141 = ($$0308|0)!=(0|0);
         $142 = ($$0308|0)==(0|0);
         $$0309363 = 0;$$1301364 = 0;$$1315361 = $19;$$1317360 = $$0316374;
         while(1) {
          $143 = ((($$1315361)) + 16|0); //@line 123167 "c/sqlite3.c"
          $144 = HEAP32[$143>>2]|0; //@line 123167 "c/sqlite3.c"
          $145 = ((($$1315361)) + 20|0); //@line 123168 "c/sqlite3.c"
          $146 = HEAP32[$145>>2]|0; //@line 123168 "c/sqlite3.c"
          $147 = ((($$1315361)) + 12|0); //@line 123169 "c/sqlite3.c"
          $148 = HEAP32[$147>>2]|0; //@line 123169 "c/sqlite3.c"
          $149 = ($148|0)==(0|0); //@line 123172 "c/sqlite3.c"
          if ($149) {
           $150 = HEAP32[$144>>2]|0; //@line 123173 "c/sqlite3.c"
           $$0304 = $150;
          } else {
           $$0304 = $148;
          }
          $151 = HEAP8[$8>>0]|0; //@line 123175 "c/sqlite3.c"
          $152 = ($151<<24>>24)==(0); //@line 123175 "c/sqlite3.c"
          if (!($152)) {
           $$0309$lcssa = $$0309363;$$1317$lcssa = $$1317360;
           break;
          }
          $153 = ($146|0)==(0|0); //@line 123176 "c/sqlite3.c"
          if ($153) {
           label = 52;
          } else {
           $154 = ((($146)) + 8|0); //@line 123176 "c/sqlite3.c"
           $155 = HEAP32[$154>>2]|0; //@line 123176 "c/sqlite3.c"
           $156 = $155 & 2048; //@line 123176 "c/sqlite3.c"
           $157 = ($156|0)==(0); //@line 123176 "c/sqlite3.c"
           if ($157) {
            label = 52;
           } else {
            $$0303 = 0;$$0305 = $146;
            label = 56;
           }
          }
          do {
           if ((label|0) == 52) {
            label = 0;
            if (!($140)) {
             $158 = (_sqlite3StrICmp($$0308,$$0304)|0); //@line 123178 "c/sqlite3.c"
             $159 = ($158|0)==(0); //@line 123178 "c/sqlite3.c"
             if (!($159)) {
              $$3312$ph = $$0309363;$$4320$ph = $$1317360;
              break;
             }
            }
            $160 = ((($144)) + 72|0); //@line 123181 "c/sqlite3.c"
            $161 = HEAP32[$160>>2]|0; //@line 123181 "c/sqlite3.c"
            $162 = (_sqlite3SchemaToIndex($4,$161)|0); //@line 123181 "c/sqlite3.c"
            $163 = ($162|0)>(-1); //@line 123182 "c/sqlite3.c"
            if (!($163)) {
             $$0303 = 23986;$$0305 = 0;
             label = 56;
             break;
            }
            $164 = HEAP32[$113>>2]|0; //@line 123182 "c/sqlite3.c"
            $165 = (($164) + ($162<<4)|0); //@line 123182 "c/sqlite3.c"
            $166 = HEAP32[$165>>2]|0; //@line 123182 "c/sqlite3.c"
            $$0303 = $166;$$0305 = 0;
            label = 56;
           }
          } while(0);
          if ((label|0) == 56) {
           label = 0;
           $167 = ((($144)) + 42|0); //@line 123184 "c/sqlite3.c"
           $168 = HEAP16[$167>>1]|0; //@line 123184 "c/sqlite3.c"
           $169 = ($168<<16>>16)>(0); //@line 123184 "c/sqlite3.c"
           if ($169) {
            $170 = ((($144)) + 4|0);
            $171 = ($$0305|0)!=(0|0);
            $or$cond = $141 & $171;
            $172 = ($$1301364|0)!=(0);
            $or$cond4 = $142 & $172;
            $173 = ((($$1315361)) + 36|0);
            $174 = ((($$1315361)) + 52|0);
            $175 = ($$0303|0)==(0|0);
            $$0302357 = 0;$$1310356 = $$0309363;$$2318354 = $$1317360;
            while(1) {
             $176 = HEAP32[$170>>2]|0; //@line 123185 "c/sqlite3.c"
             $177 = (($176) + ($$0302357<<4)|0); //@line 123185 "c/sqlite3.c"
             $178 = HEAP32[$177>>2]|0; //@line 123185 "c/sqlite3.c"
             if ($or$cond) {
              $179 = HEAP32[$$0305>>2]|0; //@line 123192 "c/sqlite3.c"
              $180 = (((((($179)) + 4|0) + (($$0302357*20)|0)|0)) + 8|0); //@line 123192 "c/sqlite3.c"
              $181 = HEAP32[$180>>2]|0; //@line 123192 "c/sqlite3.c"
              $182 = (_sqlite3MatchSpanName($181,0,$$0308,0)|0); //@line 123192 "c/sqlite3.c"
              $183 = ($182|0)==(0); //@line 123192 "c/sqlite3.c"
              if ($183) {
               $$2311 = $$1310356;$$3319 = $$2318354;
              } else {
               label = 60;
              }
             } else {
              label = 60;
             }
             do {
              if ((label|0) == 60) {
               label = 0;
               $184 = HEAP32[$5>>2]|0; //@line 123201 "c/sqlite3.c"
               $185 = $184 & 131072; //@line 123201 "c/sqlite3.c"
               $186 = ($185|0)==(0); //@line 123201 "c/sqlite3.c"
               if ($186) {
                $187 = (((($176) + ($$0302357<<4)|0)) + 15|0); //@line 123202 "c/sqlite3.c"
                $188 = HEAP8[$187>>0]|0; //@line 123202 "c/sqlite3.c"
                $189 = $188 & 2; //@line 123202 "c/sqlite3.c"
                $190 = ($189<<24>>24)==(0); //@line 123202 "c/sqlite3.c"
                if (!($190)) {
                 $$2311 = $$1310356;$$3319 = $$2318354;
                 break;
                }
               }
               if ($or$cond4) {
                $191 = HEAP8[$173>>0]|0; //@line 123209 "c/sqlite3.c"
                $192 = $191 & 4; //@line 123209 "c/sqlite3.c"
                $193 = ($192<<24>>24)==(0); //@line 123209 "c/sqlite3.c"
                if (!($193)) {
                 $194 = (_tableAndColumnIndex($14,$$1301364,$178,0,0)|0); //@line 123210 "c/sqlite3.c"
                 $195 = ($194|0)==(0); //@line 123210 "c/sqlite3.c"
                 if (!($195)) {
                  $$2311 = 1;$$3319 = $$2318354;
                  break;
                 }
                }
                $196 = HEAP32[$174>>2]|0; //@line 123216 "c/sqlite3.c"
                $197 = (_sqlite3IdListIndex($196,$178)|0); //@line 123216 "c/sqlite3.c"
                $198 = ($197|0)>(-1); //@line 123216 "c/sqlite3.c"
                if ($198) {
                 $$2311 = 1;$$3319 = $$2318354;
                 break;
                }
               }
               $199 = (_sqlite3Expr($4,59,$178)|0); //@line 123222 "c/sqlite3.c"
               if ($110) {
                label = 68;
               } else {
                $200 = HEAP32[$14>>2]|0; //@line 123225 "c/sqlite3.c"
                $201 = ($200|0)>(1); //@line 123225 "c/sqlite3.c"
                if ($201) {
                 label = 68;
                } else {
                 $$1297 = 0;$$1299 = $178;$$1323 = $199;
                }
               }
               do {
                if ((label|0) == 68) {
                 label = 0;
                 $202 = (_sqlite3Expr($4,59,$$0304)|0); //@line 123227 "c/sqlite3.c"
                 $203 = (_sqlite3PExpr($3,122,$202,$199)|0); //@line 123228 "c/sqlite3.c"
                 if ($175) {
                  $$0322 = $203;
                 } else {
                  $204 = (_sqlite3Expr($4,59,$$0303)|0); //@line 123230 "c/sqlite3.c"
                  $205 = (_sqlite3PExpr($3,122,$204,$203)|0); //@line 123231 "c/sqlite3.c"
                  $$0322 = $205;
                 }
                 if (!($110)) {
                  $$1297 = 0;$$1299 = $178;$$1323 = $$0322;
                  break;
                 }
                 HEAP32[$vararg_buffer4>>2] = $$0304; //@line 123234 "c/sqlite3.c"
                 $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 123234 "c/sqlite3.c"
                 HEAP32[$vararg_ptr7>>2] = $178; //@line 123234 "c/sqlite3.c"
                 $206 = (_sqlite3MPrintf($4,17909,$vararg_buffer4)|0); //@line 123234 "c/sqlite3.c"
                 $$1297 = $206;$$1299 = $206;$$1323 = $$0322;
                }
               } while(0);
               $207 = (_sqlite3ExprListAppend($3,$$2318354,$$1323)|0); //@line 123240 "c/sqlite3.c"
               _sqlite3TokenInit($2,$$1299); //@line 123241 "c/sqlite3.c"
               _sqlite3ExprListSetName($3,$207,$2,0); //@line 123242 "c/sqlite3.c"
               $208 = ($207|0)==(0|0); //@line 123243 "c/sqlite3.c"
               do {
                if (!($208)) {
                 $209 = HEAP32[$5>>2]|0; //@line 123243 "c/sqlite3.c"
                 $210 = $209 & 2048; //@line 123243 "c/sqlite3.c"
                 $211 = ($210|0)==(0); //@line 123243 "c/sqlite3.c"
                 if ($211) {
                  break;
                 }
                 $212 = HEAP32[$207>>2]|0; //@line 123244 "c/sqlite3.c"
                 $213 = (($212) + -1)|0; //@line 123244 "c/sqlite3.c"
                 if ($171) {
                  $214 = HEAP32[$$0305>>2]|0; //@line 123246 "c/sqlite3.c"
                  $215 = (((((($214)) + 4|0) + (($$0302357*20)|0)|0)) + 8|0); //@line 123246 "c/sqlite3.c"
                  $216 = HEAP32[$215>>2]|0; //@line 123246 "c/sqlite3.c"
                  $217 = (_sqlite3DbStrDup($4,$216)|0); //@line 123246 "c/sqlite3.c"
                  $$sink409 = $217;
                 } else {
                  HEAP32[$vararg_buffer8>>2] = $$0303; //@line 123249 "c/sqlite3.c"
                  $vararg_ptr11 = ((($vararg_buffer8)) + 4|0); //@line 123249 "c/sqlite3.c"
                  HEAP32[$vararg_ptr11>>2] = $$0304; //@line 123249 "c/sqlite3.c"
                  $vararg_ptr12 = ((($vararg_buffer8)) + 8|0); //@line 123249 "c/sqlite3.c"
                  HEAP32[$vararg_ptr12>>2] = $$1299; //@line 123249 "c/sqlite3.c"
                  $218 = (_sqlite3MPrintf($4,23988,$vararg_buffer8)|0); //@line 123249 "c/sqlite3.c"
                  $$sink409 = $218;
                 }
                 $219 = (((((($207)) + 4|0) + (($213*20)|0)|0)) + 8|0);
                 HEAP32[$219>>2] = $$sink409;
                 $220 = (((((($207)) + 4|0) + (($213*20)|0)|0)) + 13|0); //@line 123253 "c/sqlite3.c"
                 $221 = HEAP8[$220>>0]|0; //@line 123253 "c/sqlite3.c"
                 $222 = $221 | 2; //@line 123253 "c/sqlite3.c"
                 HEAP8[$220>>0] = $222; //@line 123253 "c/sqlite3.c"
                }
               } while(0);
               _sqlite3DbFree($4,$$1297); //@line 123255 "c/sqlite3.c"
               $$2311 = 1;$$3319 = $207;
              }
             } while(0);
             $223 = (($$0302357) + 1)|0; //@line 123184 "c/sqlite3.c"
             $224 = HEAP16[$167>>1]|0; //@line 123184 "c/sqlite3.c"
             $225 = $224 << 16 >> 16; //@line 123184 "c/sqlite3.c"
             $226 = ($223|0)<($225|0); //@line 123184 "c/sqlite3.c"
             if ($226) {
              $$0302357 = $223;$$1310356 = $$2311;$$2318354 = $$3319;
             } else {
              $$3312$ph = $$2311;$$4320$ph = $$3319;
              break;
             }
            }
           } else {
            $$3312$ph = $$0309363;$$4320$ph = $$1317360;
           }
          }
          $227 = (($$1301364) + 1)|0; //@line 123166 "c/sqlite3.c"
          $228 = ((($$1315361)) + 72|0); //@line 123166 "c/sqlite3.c"
          $229 = HEAP32[$14>>2]|0; //@line 123166 "c/sqlite3.c"
          $230 = ($227|0)<($229|0); //@line 123166 "c/sqlite3.c"
          if ($230) {
           $$0309363 = $$3312$ph;$$1301364 = $227;$$1315361 = $228;$$1317360 = $$4320$ph;
          } else {
           $$0309$lcssa = $$3312$ph;$$1317$lcssa = $$4320$ph;
           break;
          }
         }
         $231 = ($$0309$lcssa|0)==(0); //@line 123258 "c/sqlite3.c"
         if ($231) {
          $$1317$lcssa399 = $$1317$lcssa;
         } else {
          $$6 = $$1317$lcssa;
          break;
         }
        } else {
         $$1317$lcssa399 = $$0316374;
        }
        $232 = ($$0308|0)==(0|0); //@line 123259 "c/sqlite3.c"
        if ($232) {
         _sqlite3ErrorMsg($3,24015,$vararg_buffer16); //@line 123262 "c/sqlite3.c"
         $$6 = $$1317$lcssa399;
         break;
        } else {
         HEAP32[$vararg_buffer13>>2] = $$0308; //@line 123260 "c/sqlite3.c"
         _sqlite3ErrorMsg($3,23997,$vararg_buffer13); //@line 123260 "c/sqlite3.c"
         $$6 = $$1317$lcssa399;
         break;
        }
       }
      } while(0);
      $233 = (($$1307375) + 1)|0; //@line 123138 "c/sqlite3.c"
      $234 = HEAP32[$15>>2]|0; //@line 123138 "c/sqlite3.c"
      $235 = ($233|0)<($234|0); //@line 123138 "c/sqlite3.c"
      if ($235) {
       $$0316374 = $$6;$$1307375 = $233;$$1331373 = $118;
      } else {
       $$0316$lcssa = $$6;$$1331$lcssa = $118;
       break L66;
      }
     }
    } else {
     $$0316$lcssa = 0;$$1331$lcssa = $$0330382;
    }
   } while(0);
   _sqlite3ExprListDelete($4,$15); //@line 123267 "c/sqlite3.c"
   HEAP32[$1>>2] = $$0316$lcssa; //@line 123268 "c/sqlite3.c"
   $$2332 = $$1331$lcssa;$237 = $$0316$lcssa;
  } else {
   $$0330$lcssa = 0;
   label = 87;
  }
 } while(0);
 if ((label|0) == 87) {
  $$pr347 = HEAP32[$1>>2]|0; //@line 123270 "c/sqlite3.c"
  $$2332 = $$0330$lcssa;$237 = $$pr347;
 }
 $236 = ($237|0)==(0|0); //@line 123270 "c/sqlite3.c"
 if ($236) {
  $$5 = 0;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $238 = HEAP32[$237>>2]|0; //@line 123271 "c/sqlite3.c"
 $239 = ((($4)) + 108|0); //@line 123271 "c/sqlite3.c"
 $240 = HEAP32[$239>>2]|0; //@line 123271 "c/sqlite3.c"
 $241 = ($238|0)>($240|0); //@line 123271 "c/sqlite3.c"
 if ($241) {
  _sqlite3ErrorMsg($3,24035,$vararg_buffer18); //@line 123272 "c/sqlite3.c"
  $$5 = 2;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $242 = $$2332 & 2097156; //@line 123275 "c/sqlite3.c"
 $243 = ($242|0)==(0); //@line 123275 "c/sqlite3.c"
 if ($243) {
  $$5 = 0;
  STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
 }
 $244 = HEAP32[$5>>2]|0; //@line 123276 "c/sqlite3.c"
 $245 = $244 | 262144; //@line 123276 "c/sqlite3.c"
 HEAP32[$5>>2] = $245; //@line 123276 "c/sqlite3.c"
 $$5 = 0;
 STACKTOP = sp;return ($$5|0); //@line 123280 "c/sqlite3.c"
}
function _selectPopWith($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 122964 "c/sqlite3.c"
 $3 = ((($2)) + 464|0); //@line 122965 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 122965 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 122965 "c/sqlite3.c"
 if ($5) {
  return; //@line 122972 "c/sqlite3.c"
 }
 $6 = ((($1)) + 48|0); //@line 122965 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 122965 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 122965 "c/sqlite3.c"
 if (!($8)) {
  return; //@line 122972 "c/sqlite3.c"
 }
 $9 = (_findRightmost($1)|0); //@line 122966 "c/sqlite3.c"
 $10 = ((($9)) + 60|0); //@line 122966 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 122966 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 122967 "c/sqlite3.c"
 if ($12) {
  return; //@line 122972 "c/sqlite3.c"
 }
 $13 = ((($11)) + 4|0); //@line 122969 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 122969 "c/sqlite3.c"
 HEAP32[$3>>2] = $14; //@line 122969 "c/sqlite3.c"
 return; //@line 122972 "c/sqlite3.c"
}
function _findRightmost($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0 = $0;
 while(1) {
  $1 = ((($$0)) + 52|0); //@line 118862 "c/sqlite3.c"
  $2 = HEAP32[$1>>2]|0; //@line 118862 "c/sqlite3.c"
  $3 = ($2|0)==(0|0); //@line 118862 "c/sqlite3.c"
  if ($3) {
   break;
  } else {
   $$0 = $2;
  }
 }
 return ($$0|0); //@line 118863 "c/sqlite3.c"
}
function _withExpand($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0111 = 0, $$0112 = 0, $$0113115 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 28|0;
 $3 = HEAP32[$0>>2]|0; //@line 122842 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 122843 "c/sqlite3.c"
 $5 = ((($3)) + 464|0); //@line 122849 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 122849 "c/sqlite3.c"
 $7 = (_searchWith($6,$1,$2)|0); //@line 122849 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 122850 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
 }
 $9 = ((($7)) + 12|0); //@line 122862 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 122862 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 122862 "c/sqlite3.c"
 if (!($11)) {
  $12 = HEAP32[$7>>2]|0; //@line 122863 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $12; //@line 122863 "c/sqlite3.c"
  _sqlite3ErrorMsg($3,$10,$vararg_buffer); //@line 122863 "c/sqlite3.c"
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
 }
 $13 = (_cannotBeFunction($3,$1)|0); //@line 122866 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 122866 "c/sqlite3.c"
 if (!($14)) {
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
 }
 $15 = (_sqlite3DbMallocZero($4,80,0)|0); //@line 122869 "c/sqlite3.c"
 $16 = ((($1)) + 16|0); //@line 122869 "c/sqlite3.c"
 HEAP32[$16>>2] = $15; //@line 122869 "c/sqlite3.c"
 $17 = ($15|0)==(0|0); //@line 122870 "c/sqlite3.c"
 if ($17) {
  $$1 = 2;
  STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
 }
 $18 = ((($15)) + 32|0); //@line 122871 "c/sqlite3.c"
 HEAP32[$18>>2] = 1; //@line 122871 "c/sqlite3.c"
 $19 = HEAP32[$7>>2]|0; //@line 122872 "c/sqlite3.c"
 $20 = (_sqlite3DbStrDup($4,$19)|0); //@line 122872 "c/sqlite3.c"
 HEAP32[$15>>2] = $20; //@line 122872 "c/sqlite3.c"
 $21 = ((($15)) + 40|0); //@line 122873 "c/sqlite3.c"
 HEAP16[$21>>1] = -1; //@line 122873 "c/sqlite3.c"
 $22 = ((($15)) + 44|0); //@line 122874 "c/sqlite3.c"
 HEAP16[$22>>1] = 200; //@line 122874 "c/sqlite3.c"
 $23 = ((($15)) + 36|0); //@line 122875 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 122875 "c/sqlite3.c"
 $25 = $24 | 66; //@line 122875 "c/sqlite3.c"
 HEAP32[$23>>2] = $25; //@line 122875 "c/sqlite3.c"
 $26 = ((($7)) + 8|0); //@line 122876 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 122876 "c/sqlite3.c"
 $28 = (_sqlite3SelectDup($4,$27,0)|0); //@line 122876 "c/sqlite3.c"
 $29 = ((($1)) + 20|0); //@line 122876 "c/sqlite3.c"
 HEAP32[$29>>2] = $28; //@line 122876 "c/sqlite3.c"
 $30 = ((($4)) + 73|0); //@line 122877 "c/sqlite3.c"
 $31 = HEAP8[$30>>0]|0; //@line 122877 "c/sqlite3.c"
 $32 = ($31<<24>>24)==(0); //@line 122877 "c/sqlite3.c"
 if (!($32)) {
  $$1 = 7;
  STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
 }
 $33 = ((($28)) + 4|0); //@line 122882 "c/sqlite3.c"
 $34 = HEAP8[$33>>0]|0; //@line 122882 "c/sqlite3.c"
 $35 = (($34) + -115)<<24>>24; //@line 122882 "c/sqlite3.c"
 $36 = ($35&255)<(2); //@line 122882 "c/sqlite3.c"
 if ($36) {
  $37 = ((($28)) + 28|0); //@line 122885 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 122885 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 122886 "c/sqlite3.c"
  $40 = ($39|0)>(0); //@line 122886 "c/sqlite3.c"
  if ($40) {
   $41 = ((($28)) + 8|0);
   $$0113115 = 0;
   while(1) {
    $42 = (((((($38)) + 8|0) + (($$0113115*72)|0)|0)) + 4|0); //@line 122888 "c/sqlite3.c"
    $43 = HEAP32[$42>>2]|0; //@line 122888 "c/sqlite3.c"
    $44 = ($43|0)==(0|0); //@line 122888 "c/sqlite3.c"
    if ($44) {
     $45 = (((((($38)) + 8|0) + (($$0113115*72)|0)|0)) + 8|0); //@line 122889 "c/sqlite3.c"
     $46 = HEAP32[$45>>2]|0; //@line 122889 "c/sqlite3.c"
     $47 = ($46|0)==(0|0); //@line 122889 "c/sqlite3.c"
     if (!($47)) {
      $48 = HEAP32[$7>>2]|0; //@line 122890 "c/sqlite3.c"
      $49 = (_sqlite3StrICmp($46,$48)|0); //@line 122890 "c/sqlite3.c"
      $50 = ($49|0)==(0); //@line 122890 "c/sqlite3.c"
      if ($50) {
       $51 = (((((($38)) + 8|0) + (($$0113115*72)|0)|0)) + 16|0); //@line 122892 "c/sqlite3.c"
       HEAP32[$51>>2] = $15; //@line 122892 "c/sqlite3.c"
       $52 = (((((($38)) + 8|0) + (($$0113115*72)|0)|0)) + 37|0); //@line 122893 "c/sqlite3.c"
       $53 = HEAP8[$52>>0]|0; //@line 122893 "c/sqlite3.c"
       $54 = $53 | 32; //@line 122893 "c/sqlite3.c"
       HEAP8[$52>>0] = $54; //@line 122893 "c/sqlite3.c"
       $55 = HEAP32[$18>>2]|0; //@line 122894 "c/sqlite3.c"
       $56 = (($55) + 1)|0; //@line 122894 "c/sqlite3.c"
       HEAP32[$18>>2] = $56; //@line 122894 "c/sqlite3.c"
       $57 = HEAP32[$41>>2]|0; //@line 122895 "c/sqlite3.c"
       $58 = $57 | 8192; //@line 122895 "c/sqlite3.c"
       HEAP32[$41>>2] = $58; //@line 122895 "c/sqlite3.c"
      }
     }
    }
    $59 = (($$0113115) + 1)|0; //@line 122886 "c/sqlite3.c"
    $60 = HEAP32[$38>>2]|0; //@line 122886 "c/sqlite3.c"
    $61 = ($59|0)<($60|0); //@line 122886 "c/sqlite3.c"
    if ($61) {
     $$0113115 = $59;
    } else {
     break;
    }
   }
  }
 }
 $62 = HEAP32[$18>>2]|0; //@line 122901 "c/sqlite3.c"
 $63 = ($62>>>0)>(2); //@line 122901 "c/sqlite3.c"
 if ($63) {
  $64 = HEAP32[$7>>2]|0; //@line 122903 "c/sqlite3.c"
  HEAP32[$vararg_buffer1>>2] = $64; //@line 122902 "c/sqlite3.c"
  _sqlite3ErrorMsg($3,24276,$vararg_buffer1); //@line 122902 "c/sqlite3.c"
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
 }
 HEAP32[$9>>2] = 24319; //@line 122910 "c/sqlite3.c"
 $65 = HEAP32[$5>>2]|0; //@line 122911 "c/sqlite3.c"
 $66 = HEAP32[$2>>2]|0; //@line 122912 "c/sqlite3.c"
 HEAP32[$5>>2] = $66; //@line 122912 "c/sqlite3.c"
 if ($36) {
  $67 = ((($28)) + 48|0); //@line 122914 "c/sqlite3.c"
  $68 = HEAP32[$67>>2]|0; //@line 122914 "c/sqlite3.c"
  $69 = ((($28)) + 60|0); //@line 122916 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 122916 "c/sqlite3.c"
  $71 = ((($68)) + 60|0); //@line 122916 "c/sqlite3.c"
  HEAP32[$71>>2] = $70; //@line 122916 "c/sqlite3.c"
  (_sqlite3WalkSelect($0,$68)|0); //@line 122917 "c/sqlite3.c"
  HEAP32[$71>>2] = 0; //@line 122918 "c/sqlite3.c"
 } else {
  (_sqlite3WalkSelect($0,$28)|0); //@line 122920 "c/sqlite3.c"
 }
 HEAP32[$5>>2] = $66; //@line 122922 "c/sqlite3.c"
 $$0112 = $28;
 while(1) {
  $72 = ((($$0112)) + 48|0); //@line 122924 "c/sqlite3.c"
  $73 = HEAP32[$72>>2]|0; //@line 122924 "c/sqlite3.c"
  $74 = ($73|0)==(0|0); //@line 122924 "c/sqlite3.c"
  if ($74) {
   break;
  } else {
   $$0112 = $73;
  }
 }
 $75 = HEAP32[$$0112>>2]|0; //@line 122925 "c/sqlite3.c"
 $76 = ((($7)) + 4|0); //@line 122926 "c/sqlite3.c"
 $77 = HEAP32[$76>>2]|0; //@line 122926 "c/sqlite3.c"
 $78 = ($77|0)==(0|0); //@line 122926 "c/sqlite3.c"
 if ($78) {
  $$0111 = $75;
 } else {
  $79 = ($75|0)==(0|0); //@line 122927 "c/sqlite3.c"
  if ($79) {
   $$0111 = $77;
  } else {
   $80 = HEAP32[$75>>2]|0; //@line 122927 "c/sqlite3.c"
   $81 = HEAP32[$77>>2]|0; //@line 122927 "c/sqlite3.c"
   $82 = ($80|0)==($81|0); //@line 122927 "c/sqlite3.c"
   if ($82) {
    $$0111 = $77;
   } else {
    $83 = HEAP32[$7>>2]|0; //@line 122929 "c/sqlite3.c"
    HEAP32[$vararg_buffer4>>2] = $83; //@line 122928 "c/sqlite3.c"
    $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 122928 "c/sqlite3.c"
    HEAP32[$vararg_ptr7>>2] = $80; //@line 122928 "c/sqlite3.c"
    $vararg_ptr8 = ((($vararg_buffer4)) + 8|0); //@line 122928 "c/sqlite3.c"
    HEAP32[$vararg_ptr8>>2] = $81; //@line 122928 "c/sqlite3.c"
    _sqlite3ErrorMsg($3,24342,$vararg_buffer4); //@line 122928 "c/sqlite3.c"
    HEAP32[$5>>2] = $65; //@line 122931 "c/sqlite3.c"
    $$1 = 1;
    STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
   }
  }
 }
 $84 = ((($15)) + 42|0); //@line 122937 "c/sqlite3.c"
 $85 = ((($15)) + 4|0); //@line 122937 "c/sqlite3.c"
 _sqlite3ColumnsFromExprList($3,$$0111,$84,$85); //@line 122937 "c/sqlite3.c"
 if ($36) {
  $86 = ((($28)) + 8|0); //@line 122939 "c/sqlite3.c"
  $87 = HEAP32[$86>>2]|0; //@line 122939 "c/sqlite3.c"
  $88 = $87 & 8192; //@line 122939 "c/sqlite3.c"
  $89 = ($88|0)==(0); //@line 122939 "c/sqlite3.c"
  $$ = $89 ? 24380 : 24418;
  HEAP32[$9>>2] = $$;
  (_sqlite3WalkSelect($0,$28)|0); //@line 122944 "c/sqlite3.c"
 }
 HEAP32[$9>>2] = 0; //@line 122946 "c/sqlite3.c"
 HEAP32[$5>>2] = $65; //@line 122947 "c/sqlite3.c"
 $$1 = 0;
 STACKTOP = sp;return ($$1|0); //@line 122951 "c/sqlite3.c"
}
function _cannotBeFunction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 122763 "c/sqlite3.c"
 $2 = ((($1)) + 37|0); //@line 122764 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 122764 "c/sqlite3.c"
 $4 = $3 & 4; //@line 122764 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 122764 "c/sqlite3.c"
 if ($5) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 122769 "c/sqlite3.c"
 }
 $6 = ((($1)) + 8|0); //@line 122765 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 122765 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $7; //@line 122765 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,24253,$vararg_buffer); //@line 122765 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 122769 "c/sqlite3.c"
}
function _sqlite3IndexedByLookup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$021 = 0, $$02126 = 0, $$02127 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 122670 "c/sqlite3.c"
 $2 = ((($1)) + 16|0); //@line 122671 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 122671 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 122671 "c/sqlite3.c"
 if ($4) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 122687 "c/sqlite3.c"
 }
 $5 = ((($1)) + 37|0); //@line 122671 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 122671 "c/sqlite3.c"
 $7 = $6 & 2; //@line 122671 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 122671 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 122687 "c/sqlite3.c"
 }
 $9 = ((($1)) + 64|0); //@line 122673 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 122673 "c/sqlite3.c"
 $11 = ((($3)) + 8|0); //@line 122675 "c/sqlite3.c"
 $$02126 = HEAP32[$11>>2]|0;
 $12 = ($$02126|0)==(0|0); //@line 122676 "c/sqlite3.c"
 L7: do {
  if (!($12)) {
   $$02127 = $$02126;
   while(1) {
    $13 = HEAP32[$$02127>>2]|0; //@line 122676 "c/sqlite3.c"
    $14 = (_sqlite3StrICmp($13,$10)|0); //@line 122676 "c/sqlite3.c"
    $15 = ($14|0)==(0); //@line 122676 "c/sqlite3.c"
    if ($15) {
     break;
    }
    $16 = ((($$02127)) + 20|0); //@line 122677 "c/sqlite3.c"
    $$021 = HEAP32[$16>>2]|0;
    $17 = ($$021|0)==(0|0); //@line 122676 "c/sqlite3.c"
    if ($17) {
     break L7;
    } else {
     $$02127 = $$021;
    }
   }
   $19 = ((($1)) + 68|0); //@line 122684 "c/sqlite3.c"
   HEAP32[$19>>2] = $$02127; //@line 122684 "c/sqlite3.c"
   $$1 = 0;
   STACKTOP = sp;return ($$1|0); //@line 122687 "c/sqlite3.c"
  }
 } while(0);
 HEAP32[$vararg_buffer>>2] = $10; //@line 122680 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 122680 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = 0; //@line 122680 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,24235,$vararg_buffer); //@line 122680 "c/sqlite3.c"
 $18 = ((($0)) + 17|0); //@line 122681 "c/sqlite3.c"
 HEAP8[$18>>0] = 1; //@line 122681 "c/sqlite3.c"
 $$1 = 1;
 STACKTOP = sp;return ($$1|0); //@line 122687 "c/sqlite3.c"
}
function _sqliteProcessJoin($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$089110 = 0, $$090104 = 0, $$092109 = 0, $$096107 = 0, $$191105 = 0, $$6 = 0, $$lobit = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 24|0;
 $3 = sp + 20|0;
 $4 = ((($1)) + 28|0); //@line 119092 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 119092 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 119095 "c/sqlite3.c"
 $7 = ($6|0)>(1); //@line 119095 "c/sqlite3.c"
 if (!($7)) {
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 119171 "c/sqlite3.c"
 }
 $8 = ((($5)) + 80|0); //@line 119094 "c/sqlite3.c"
 $9 = ((($5)) + 8|0); //@line 119093 "c/sqlite3.c"
 $10 = ((($1)) + 32|0);
 $11 = ((($1)) + 32|0);
 $12 = ((($1)) + 32|0);
 $$089110 = 0;$$092109 = $9;$$096107 = $8;
 L4: while(1) {
  $13 = ((($$096107)) + 16|0); //@line 119096 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 119096 "c/sqlite3.c"
  $15 = ((($$092109)) + 16|0); //@line 119099 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 119099 "c/sqlite3.c"
  $17 = ($16|0)==(0|0); //@line 119099 "c/sqlite3.c"
  $18 = ($14|0)==(0|0); //@line 119099 "c/sqlite3.c"
  $or$cond = $18 | $17; //@line 119099 "c/sqlite3.c"
  if (!($or$cond)) {
   $19 = ((($$096107)) + 36|0); //@line 119100 "c/sqlite3.c"
   $20 = HEAP8[$19>>0]|0; //@line 119100 "c/sqlite3.c"
   $21 = $20&255; //@line 119100 "c/sqlite3.c"
   $22 = $21 & 32; //@line 119100 "c/sqlite3.c"
   $23 = ($22|0)==(0); //@line 119100 "c/sqlite3.c"
   $$lobit = $22 >>> 5; //@line 119100 "c/sqlite3.c"
   $24 = $21 & 4; //@line 119105 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 119105 "c/sqlite3.c"
   if (!($25)) {
    $26 = ((($$096107)) + 48|0); //@line 119106 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 119106 "c/sqlite3.c"
    $28 = ($27|0)==(0|0); //@line 119106 "c/sqlite3.c"
    if (!($28)) {
     label = 7;
     break;
    }
    $29 = ((($$096107)) + 52|0); //@line 119106 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 119106 "c/sqlite3.c"
    $31 = ($30|0)==(0|0); //@line 119106 "c/sqlite3.c"
    if (!($31)) {
     label = 7;
     break;
    }
    $32 = ((($14)) + 42|0); //@line 119111 "c/sqlite3.c"
    $33 = HEAP16[$32>>1]|0; //@line 119111 "c/sqlite3.c"
    $34 = ($33<<16>>16)>(0); //@line 119111 "c/sqlite3.c"
    if ($34) {
     $35 = ((($14)) + 4|0);
     $36 = (($$089110) + 1)|0;
     $$090104 = 0;
     while(1) {
      $37 = HEAP32[$35>>2]|0; //@line 119116 "c/sqlite3.c"
      $38 = (($37) + ($$090104<<4)|0); //@line 119116 "c/sqlite3.c"
      $39 = HEAP32[$38>>2]|0; //@line 119116 "c/sqlite3.c"
      $40 = (_tableAndColumnIndex($5,$36,$39,$2,$3)|0); //@line 119117 "c/sqlite3.c"
      $41 = ($40|0)==(0); //@line 119117 "c/sqlite3.c"
      if (!($41)) {
       $42 = HEAP32[$2>>2]|0; //@line 119118 "c/sqlite3.c"
       $43 = HEAP32[$3>>2]|0; //@line 119118 "c/sqlite3.c"
       _addWhereTerm($0,$5,$42,$43,$36,$$090104,$$lobit,$12); //@line 119118 "c/sqlite3.c"
      }
      $44 = (($$090104) + 1)|0; //@line 119111 "c/sqlite3.c"
      $45 = HEAP16[$32>>1]|0; //@line 119111 "c/sqlite3.c"
      $46 = $45 << 16 >> 16; //@line 119111 "c/sqlite3.c"
      $47 = ($44|0)<($46|0); //@line 119111 "c/sqlite3.c"
      if ($47) {
       $$090104 = $44;
      } else {
       break;
      }
     }
    }
   }
   $48 = ((($$096107)) + 48|0); //@line 119126 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 119126 "c/sqlite3.c"
   $50 = ($49|0)==(0|0); //@line 119126 "c/sqlite3.c"
   if (!($50)) {
    $51 = ((($$096107)) + 52|0); //@line 119126 "c/sqlite3.c"
    $52 = HEAP32[$51>>2]|0; //@line 119126 "c/sqlite3.c"
    $53 = ($52|0)==(0|0); //@line 119126 "c/sqlite3.c"
    if (!($53)) {
     label = 15;
     break;
    }
    if (!($23)) {
     $54 = ((($$096107)) + 44|0); //@line 119136 "c/sqlite3.c"
     $55 = HEAP32[$54>>2]|0; //@line 119136 "c/sqlite3.c"
     _setJoinExpr($49,$55); //@line 119136 "c/sqlite3.c"
    }
    $56 = HEAP32[$0>>2]|0; //@line 119137 "c/sqlite3.c"
    $57 = HEAP32[$11>>2]|0; //@line 119137 "c/sqlite3.c"
    $58 = HEAP32[$48>>2]|0; //@line 119137 "c/sqlite3.c"
    $59 = (_sqlite3ExprAnd($56,$57,$58)|0); //@line 119137 "c/sqlite3.c"
    HEAP32[$11>>2] = $59; //@line 119137 "c/sqlite3.c"
    HEAP32[$48>>2] = 0; //@line 119138 "c/sqlite3.c"
   }
   $60 = ((($$096107)) + 52|0); //@line 119148 "c/sqlite3.c"
   $61 = HEAP32[$60>>2]|0; //@line 119148 "c/sqlite3.c"
   $62 = ($61|0)==(0|0); //@line 119148 "c/sqlite3.c"
   if (!($62)) {
    $63 = ((($61)) + 4|0); //@line 119150 "c/sqlite3.c"
    $64 = HEAP32[$63>>2]|0; //@line 119150 "c/sqlite3.c"
    $65 = ($64|0)>(0); //@line 119150 "c/sqlite3.c"
    if ($65) {
     $66 = (($$089110) + 1)|0;
     $$191105 = 0;
     while(1) {
      $67 = HEAP32[$61>>2]|0; //@line 119156 "c/sqlite3.c"
      $68 = (($67) + ($$191105<<3)|0); //@line 119156 "c/sqlite3.c"
      $69 = HEAP32[$68>>2]|0; //@line 119156 "c/sqlite3.c"
      $70 = (_columnIndex($14,$69)|0); //@line 119157 "c/sqlite3.c"
      $71 = ($70|0)<(0); //@line 119158 "c/sqlite3.c"
      if ($71) {
       label = 25;
       break L4;
      }
      $72 = (_tableAndColumnIndex($5,$66,$69,$2,$3)|0); //@line 119159 "c/sqlite3.c"
      $73 = ($72|0)==(0); //@line 119159 "c/sqlite3.c"
      if ($73) {
       label = 25;
       break L4;
      }
      $74 = HEAP32[$2>>2]|0; //@line 119165 "c/sqlite3.c"
      $75 = HEAP32[$3>>2]|0; //@line 119165 "c/sqlite3.c"
      _addWhereTerm($0,$5,$74,$75,$66,$70,$$lobit,$10); //@line 119165 "c/sqlite3.c"
      $76 = (($$191105) + 1)|0; //@line 119150 "c/sqlite3.c"
      $77 = HEAP32[$63>>2]|0; //@line 119150 "c/sqlite3.c"
      $78 = ($76|0)<($77|0); //@line 119150 "c/sqlite3.c"
      if ($78) {
       $$191105 = $76;
      } else {
       break;
      }
     }
    }
   }
  }
  $79 = (($$089110) + 1)|0; //@line 119095 "c/sqlite3.c"
  $80 = ((($$096107)) + 72|0); //@line 119095 "c/sqlite3.c"
  $81 = ((($$092109)) + 72|0); //@line 119095 "c/sqlite3.c"
  $82 = HEAP32[$5>>2]|0; //@line 119095 "c/sqlite3.c"
  $83 = (($82) + -1)|0; //@line 119095 "c/sqlite3.c"
  $84 = ($79|0)<($83|0); //@line 119095 "c/sqlite3.c"
  if ($84) {
   $$089110 = $79;$$092109 = $81;$$096107 = $80;
  } else {
   $$6 = 0;
   label = 27;
   break;
  }
 }
 if ((label|0) == 7) {
  HEAP32[$vararg_buffer>>2] = 0; //@line 119107 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,24066,$vararg_buffer); //@line 119107 "c/sqlite3.c"
  $$6 = 1;
  STACKTOP = sp;return ($$6|0); //@line 119171 "c/sqlite3.c"
 }
 else if ((label|0) == 15) {
  _sqlite3ErrorMsg($0,24116,$vararg_buffer1); //@line 119127 "c/sqlite3.c"
  $$6 = 1;
  STACKTOP = sp;return ($$6|0); //@line 119171 "c/sqlite3.c"
 }
 else if ((label|0) == 25) {
  HEAP32[$vararg_buffer3>>2] = $69; //@line 119161 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,24171,$vararg_buffer3); //@line 119161 "c/sqlite3.c"
  $$6 = 1;
  STACKTOP = sp;return ($$6|0); //@line 119171 "c/sqlite3.c"
 }
 else if ((label|0) == 27) {
  STACKTOP = sp;return ($$6|0); //@line 119171 "c/sqlite3.c"
 }
 return (0)|0;
}
function _tableAndColumnIndex($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$01517 = 0, $10 = 0, $11 = 0, $12 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)>(0); //@line 118972 "c/sqlite3.c"
 L1: do {
  if ($5) {
   $$01517 = 0;
   while(1) {
    $6 = (((((($0)) + 8|0) + (($$01517*72)|0)|0)) + 16|0); //@line 118973 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 118973 "c/sqlite3.c"
    $8 = (_columnIndex($7,$2)|0); //@line 118973 "c/sqlite3.c"
    $9 = ($8|0)>(-1); //@line 118974 "c/sqlite3.c"
    if ($9) {
     break;
    }
    $11 = (($$01517) + 1)|0; //@line 118972 "c/sqlite3.c"
    $12 = ($11|0)<($1|0); //@line 118972 "c/sqlite3.c"
    if ($12) {
     $$01517 = $11;
    } else {
     $$0 = 0;
     break L1;
    }
   }
   $10 = ($3|0)==(0|0); //@line 118975 "c/sqlite3.c"
   if ($10) {
    $$0 = 1;
   } else {
    HEAP32[$3>>2] = $$01517; //@line 118976 "c/sqlite3.c"
    HEAP32[$4>>2] = $8; //@line 118977 "c/sqlite3.c"
    $$0 = 1;
   }
  } else {
   $$0 = 0;
  }
 } while(0);
 return ($$0|0); //@line 118983 "c/sqlite3.c"
}
function _sqlite3IdListIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$08 = 0, $$09 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 105258 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$08 = -1;
  } else {
   $3 = ((($0)) + 4|0); //@line 105259 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 105259 "c/sqlite3.c"
   $5 = ($4|0)>(0); //@line 105259 "c/sqlite3.c"
   if ($5) {
    $6 = HEAP32[$0>>2]|0;
    $$09 = 0;
    while(1) {
     $7 = (($6) + ($$09<<3)|0); //@line 105260 "c/sqlite3.c"
     $8 = HEAP32[$7>>2]|0; //@line 105260 "c/sqlite3.c"
     $9 = (_sqlite3StrICmp($8,$1)|0); //@line 105260 "c/sqlite3.c"
     $10 = ($9|0)==(0); //@line 105260 "c/sqlite3.c"
     if ($10) {
      $$08 = $$09;
      break L1;
     }
     $11 = (($$09) + 1)|0; //@line 105259 "c/sqlite3.c"
     $12 = HEAP32[$3>>2]|0; //@line 105259 "c/sqlite3.c"
     $13 = ($11|0)<($12|0); //@line 105259 "c/sqlite3.c"
     if ($13) {
      $$09 = $11;
     } else {
      $$08 = -1;
      break;
     }
    }
   } else {
    $$08 = -1;
   }
  }
 } while(0);
 return ($$08|0); //@line 105263 "c/sqlite3.c"
}
function _columnIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$07 = 0, $$08 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 42|0); //@line 118946 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 118946 "c/sqlite3.c"
 $4 = ($3<<16>>16)>(0); //@line 118946 "c/sqlite3.c"
 if (!($4)) {
  $$07 = -1;
  return ($$07|0); //@line 118950 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 118947 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0;
 $$08 = 0;
 while(1) {
  $7 = (($6) + ($$08<<4)|0); //@line 118947 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 118947 "c/sqlite3.c"
  $9 = (_sqlite3StrICmp($8,$1)|0); //@line 118947 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 118947 "c/sqlite3.c"
  if ($10) {
   $$07 = $$08;
   label = 5;
   break;
  }
  $11 = (($$08) + 1)|0; //@line 118946 "c/sqlite3.c"
  $12 = HEAP16[$2>>1]|0; //@line 118946 "c/sqlite3.c"
  $13 = $12 << 16 >> 16; //@line 118946 "c/sqlite3.c"
  $14 = ($11|0)<($13|0); //@line 118946 "c/sqlite3.c"
  if ($14) {
   $$08 = $11;
  } else {
   $$07 = -1;
   label = 5;
   break;
  }
 }
 if ((label|0) == 5) {
  return ($$07|0); //@line 118950 "c/sqlite3.c"
 }
 return (0)|0;
}
function _addWhereTerm($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = HEAP32[$0>>2]|0; //@line 119006 "c/sqlite3.c"
 $9 = (_sqlite3CreateColumnExpr($8,$1,$2,$3)|0); //@line 119016 "c/sqlite3.c"
 $10 = (_sqlite3CreateColumnExpr($8,$1,$4,$5)|0); //@line 119017 "c/sqlite3.c"
 $11 = (_sqlite3PExpr($0,53,$9,$10)|0); //@line 119019 "c/sqlite3.c"
 $12 = ($11|0)!=(0|0); //@line 119020 "c/sqlite3.c"
 $13 = ($6|0)!=(0); //@line 119020 "c/sqlite3.c"
 $or$cond = $13 & $12; //@line 119020 "c/sqlite3.c"
 if (!($or$cond)) {
  $21 = HEAP32[$7>>2]|0; //@line 119026 "c/sqlite3.c"
  $22 = (_sqlite3ExprAnd($8,$21,$11)|0); //@line 119026 "c/sqlite3.c"
  HEAP32[$7>>2] = $22; //@line 119026 "c/sqlite3.c"
  return; //@line 119027 "c/sqlite3.c"
 }
 $14 = ((($11)) + 4|0); //@line 119021 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 119021 "c/sqlite3.c"
 $16 = $15 | 1; //@line 119021 "c/sqlite3.c"
 HEAP32[$14>>2] = $16; //@line 119021 "c/sqlite3.c"
 $17 = ((($10)) + 28|0); //@line 119024 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 119024 "c/sqlite3.c"
 $19 = $18&65535; //@line 119024 "c/sqlite3.c"
 $20 = ((($11)) + 36|0); //@line 119024 "c/sqlite3.c"
 HEAP16[$20>>1] = $19; //@line 119024 "c/sqlite3.c"
 $21 = HEAP32[$7>>2]|0; //@line 119026 "c/sqlite3.c"
 $22 = (_sqlite3ExprAnd($8,$21,$11)|0); //@line 119026 "c/sqlite3.c"
 HEAP32[$7>>2] = $22; //@line 119026 "c/sqlite3.c"
 return; //@line 119027 "c/sqlite3.c"
}
function _setJoinExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01517 = 0, $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 119056 "c/sqlite3.c"
 if ($2) {
  return; //@line 119070 "c/sqlite3.c"
 }
 $3 = $1&65535;
 $$01517 = $0;
 while(1) {
  $4 = ((($$01517)) + 4|0); //@line 119057 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 119057 "c/sqlite3.c"
  $6 = $5 | 1; //@line 119057 "c/sqlite3.c"
  HEAP32[$4>>2] = $6; //@line 119057 "c/sqlite3.c"
  $7 = ((($$01517)) + 36|0); //@line 119060 "c/sqlite3.c"
  HEAP16[$7>>1] = $3; //@line 119060 "c/sqlite3.c"
  $8 = HEAP8[$$01517>>0]|0; //@line 119061 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(-112); //@line 119061 "c/sqlite3.c"
  if ($9) {
   $10 = ((($$01517)) + 20|0); //@line 119061 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 119061 "c/sqlite3.c"
   $12 = ($11|0)==(0|0); //@line 119061 "c/sqlite3.c"
   if (!($12)) {
    $13 = HEAP32[$10>>2]|0; //@line 119063 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 119063 "c/sqlite3.c"
    $15 = ($14|0)>(0); //@line 119063 "c/sqlite3.c"
    if ($15) {
     $$016 = 0;$17 = $13;
     while(1) {
      $16 = (((($17)) + 4|0) + (($$016*20)|0)|0); //@line 119064 "c/sqlite3.c"
      $18 = HEAP32[$16>>2]|0; //@line 119064 "c/sqlite3.c"
      _setJoinExpr($18,$1); //@line 119064 "c/sqlite3.c"
      $19 = (($$016) + 1)|0; //@line 119063 "c/sqlite3.c"
      $20 = HEAP32[$10>>2]|0; //@line 119063 "c/sqlite3.c"
      $21 = HEAP32[$20>>2]|0; //@line 119063 "c/sqlite3.c"
      $22 = ($19|0)<($21|0); //@line 119063 "c/sqlite3.c"
      if ($22) {
       $$016 = $19;$17 = $20;
      } else {
       break;
      }
     }
    }
   }
  }
  $23 = ((($$01517)) + 12|0); //@line 119067 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 119067 "c/sqlite3.c"
  _setJoinExpr($24,$1); //@line 119067 "c/sqlite3.c"
  $25 = ((($$01517)) + 16|0); //@line 119068 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 119068 "c/sqlite3.c"
  $27 = ($26|0)==(0|0); //@line 119056 "c/sqlite3.c"
  if ($27) {
   break;
  } else {
   $$01517 = $26;
  }
 }
 return; //@line 119070 "c/sqlite3.c"
}
function _sqlite3ExprAnd($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 93612 "c/sqlite3.c"
 if ($3) {
  $$0 = $2;
  return ($$0|0); //@line 93625 "c/sqlite3.c"
 }
 $4 = ($2|0)==(0|0); //@line 93614 "c/sqlite3.c"
 if ($4) {
  $$0 = $1;
  return ($$0|0); //@line 93625 "c/sqlite3.c"
 }
 $5 = (_exprAlwaysFalse($1)|0); //@line 93616 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 93616 "c/sqlite3.c"
 if ($6) {
  $7 = (_exprAlwaysFalse($2)|0); //@line 93616 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 93616 "c/sqlite3.c"
  if ($8) {
   $10 = (_sqlite3ExprAlloc($0,44,0,0)|0); //@line 93621 "c/sqlite3.c"
   _sqlite3ExprAttachSubtrees($0,$10,$1,$2); //@line 93622 "c/sqlite3.c"
   $$0 = $10;
   return ($$0|0); //@line 93625 "c/sqlite3.c"
  }
 }
 _sqlite3ExprDelete($0,$1); //@line 93617 "c/sqlite3.c"
 _sqlite3ExprDelete($0,$2); //@line 93618 "c/sqlite3.c"
 $9 = (_sqlite3ExprAlloc($0,134,4980,0)|0); //@line 93619 "c/sqlite3.c"
 $$0 = $9;
 return ($$0|0); //@line 93625 "c/sqlite3.c"
}
function _exprAlwaysFalse($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 93597 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 93598 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 93598 "c/sqlite3.c"
 $4 = $3 & 1; //@line 93598 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 93598 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3ExprIsInteger($0,$1)|0); //@line 93599 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 93599 "c/sqlite3.c"
  if ($7) {
   $$0 = 0;
  } else {
   $8 = HEAP32[$1>>2]|0; //@line 93600 "c/sqlite3.c"
   $9 = ($8|0)==(0); //@line 93600 "c/sqlite3.c"
   $10 = $9&1; //@line 93600 "c/sqlite3.c"
   $$0 = $10;
  }
 } else {
  $$0 = 0;
 }
 STACKTOP = sp;return ($$0|0); //@line 93601 "c/sqlite3.c"
}
function _sqlite3CreateColumnExpr($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$cast = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3ExprAlloc($0,145,0,0)|0); //@line 91660 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 91661 "c/sqlite3.c"
 if ($5) {
  return ($4|0); //@line 91674 "c/sqlite3.c"
 }
 $6 = (((((($1)) + 8|0) + (($2*72)|0)|0)) + 16|0); //@line 91663 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 91663 "c/sqlite3.c"
 $8 = ((($4)) + 44|0); //@line 91663 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 91663 "c/sqlite3.c"
 $9 = (((((($1)) + 8|0) + (($2*72)|0)|0)) + 44|0); //@line 91664 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 91664 "c/sqlite3.c"
 $11 = ((($4)) + 28|0); //@line 91664 "c/sqlite3.c"
 HEAP32[$11>>2] = $10; //@line 91664 "c/sqlite3.c"
 $$cast = $7; //@line 91665 "c/sqlite3.c"
 $12 = ((($$cast)) + 40|0); //@line 91665 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 91665 "c/sqlite3.c"
 $14 = $13 << 16 >> 16; //@line 91665 "c/sqlite3.c"
 $15 = ($14|0)==($3|0); //@line 91665 "c/sqlite3.c"
 if ($15) {
  $16 = ((($4)) + 32|0); //@line 91666 "c/sqlite3.c"
  HEAP16[$16>>1] = -1; //@line 91666 "c/sqlite3.c"
  return ($4|0); //@line 91674 "c/sqlite3.c"
 } else {
  $17 = $3&65535; //@line 91668 "c/sqlite3.c"
  $18 = ((($4)) + 32|0); //@line 91668 "c/sqlite3.c"
  HEAP16[$18>>1] = $17; //@line 91668 "c/sqlite3.c"
  $19 = ($3|0)<(63); //@line 91671 "c/sqlite3.c"
  $20 = $19 ? $3 : 63; //@line 91671 "c/sqlite3.c"
  $21 = (_bitshift64Shl(1,0,($20|0))|0); //@line 91671 "c/sqlite3.c"
  $22 = tempRet0; //@line 91671 "c/sqlite3.c"
  $23 = (((((($1)) + 8|0) + (($2*72)|0)|0)) + 56|0); //@line 91671 "c/sqlite3.c"
  $24 = $23; //@line 91671 "c/sqlite3.c"
  $25 = $24; //@line 91671 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 91671 "c/sqlite3.c"
  $27 = (($24) + 4)|0; //@line 91671 "c/sqlite3.c"
  $28 = $27; //@line 91671 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 91671 "c/sqlite3.c"
  $30 = $26 | $21; //@line 91671 "c/sqlite3.c"
  $31 = $29 | $22; //@line 91671 "c/sqlite3.c"
  $32 = $23; //@line 91671 "c/sqlite3.c"
  $33 = $32; //@line 91671 "c/sqlite3.c"
  HEAP32[$33>>2] = $30; //@line 91671 "c/sqlite3.c"
  $34 = (($32) + 4)|0; //@line 91671 "c/sqlite3.c"
  $35 = $34; //@line 91671 "c/sqlite3.c"
  HEAP32[$35>>2] = $31; //@line 91671 "c/sqlite3.c"
  return ($4|0); //@line 91674 "c/sqlite3.c"
 }
 return (0)|0;
}
function _searchWith($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02331 = 0, $$02432 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 4|0); //@line 122788 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 122788 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 122788 "c/sqlite3.c"
 if (!($5)) {
  $$3 = 0;
  return ($$3|0); //@line 122801 "c/sqlite3.c"
 }
 $6 = ((($1)) + 8|0); //@line 122788 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 122788 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 122788 "c/sqlite3.c"
 $9 = ($0|0)==(0|0); //@line 122790 "c/sqlite3.c"
 $or$cond = $8 | $9; //@line 122788 "c/sqlite3.c"
 if ($or$cond) {
  $$3 = 0;
  return ($$3|0); //@line 122801 "c/sqlite3.c"
 }
 $$02432 = $0;
 L7: while(1) {
  $10 = HEAP32[$$02432>>2]|0; //@line 122792 "c/sqlite3.c"
  $11 = ($10|0)>(0); //@line 122792 "c/sqlite3.c"
  if ($11) {
   $$02331 = 0;
   while(1) {
    $15 = (((($$02432)) + 8|0) + ($$02331<<4)|0); //@line 122793 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 122793 "c/sqlite3.c"
    $17 = (_sqlite3StrICmp($7,$16)|0); //@line 122793 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 122793 "c/sqlite3.c"
    $14 = (($$02331) + 1)|0; //@line 122792 "c/sqlite3.c"
    if ($18) {
     break L7;
    }
    $12 = HEAP32[$$02432>>2]|0; //@line 122792 "c/sqlite3.c"
    $13 = ($14|0)<($12|0); //@line 122792 "c/sqlite3.c"
    if ($13) {
     $$02331 = $14;
    } else {
     break;
    }
   }
  }
  $19 = ((($$02432)) + 4|0); //@line 122790 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 122790 "c/sqlite3.c"
  $21 = ($20|0)==(0|0); //@line 122790 "c/sqlite3.c"
  if ($21) {
   $$3 = 0;
   label = 10;
   break;
  } else {
   $$02432 = $20;
  }
 }
 if ((label|0) == 10) {
  return ($$3|0); //@line 122801 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = $$02432; //@line 122794 "c/sqlite3.c"
 $$3 = $15;
 return ($$3|0); //@line 122801 "c/sqlite3.c"
}
function _sqlite3SrcListDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$07577 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 94071 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  return ($$0|0); //@line 94106 "c/sqlite3.c"
 }
 $4 = HEAP32[$1>>2]|0; //@line 94072 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 94072 "c/sqlite3.c"
 $6 = ($4*72)|0; //@line 94072 "c/sqlite3.c"
 $phitmp = (($6) + 8)|0; //@line 94072 "c/sqlite3.c"
 $7 = ($phitmp|0)<(0); //@line 94072 "c/sqlite3.c"
 $8 = $7 << 31 >> 31; //@line 94072 "c/sqlite3.c"
 $9 = $5 ? $phitmp : 80; //@line 94072 "c/sqlite3.c"
 $10 = $5 ? $8 : 0; //@line 94072 "c/sqlite3.c"
 $11 = (_sqlite3DbMallocRawNN($0,$9,$10)|0); //@line 94073 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 94074 "c/sqlite3.c"
 if ($12) {
  $$0 = 0;
  return ($$0|0); //@line 94106 "c/sqlite3.c"
 }
 $13 = HEAP32[$1>>2]|0; //@line 94075 "c/sqlite3.c"
 $14 = ((($11)) + 4|0); //@line 94075 "c/sqlite3.c"
 HEAP32[$14>>2] = $13; //@line 94075 "c/sqlite3.c"
 HEAP32[$11>>2] = $13; //@line 94075 "c/sqlite3.c"
 $15 = HEAP32[$1>>2]|0; //@line 94076 "c/sqlite3.c"
 $16 = ($15|0)>(0); //@line 94076 "c/sqlite3.c"
 if (!($16)) {
  $$0 = $11;
  return ($$0|0); //@line 94106 "c/sqlite3.c"
 }
 $17 = ((($11)) + 8|0);
 $$07577 = 0;
 while(1) {
  $18 = (($17) + (($$07577*72)|0)|0); //@line 94077 "c/sqlite3.c"
  $19 = (((($1)) + 8|0) + (($$07577*72)|0)|0); //@line 94078 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 94080 "c/sqlite3.c"
  HEAP32[$18>>2] = $20; //@line 94080 "c/sqlite3.c"
  $21 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 4|0); //@line 94081 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 94081 "c/sqlite3.c"
  $23 = (_sqlite3DbStrDup($0,$22)|0); //@line 94081 "c/sqlite3.c"
  $24 = (((($17) + (($$07577*72)|0)|0)) + 4|0); //@line 94081 "c/sqlite3.c"
  HEAP32[$24>>2] = $23; //@line 94081 "c/sqlite3.c"
  $25 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 8|0); //@line 94082 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 94082 "c/sqlite3.c"
  $27 = (_sqlite3DbStrDup($0,$26)|0); //@line 94082 "c/sqlite3.c"
  $28 = (((($17) + (($$07577*72)|0)|0)) + 8|0); //@line 94082 "c/sqlite3.c"
  HEAP32[$28>>2] = $27; //@line 94082 "c/sqlite3.c"
  $29 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 12|0); //@line 94083 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 94083 "c/sqlite3.c"
  $31 = (_sqlite3DbStrDup($0,$30)|0); //@line 94083 "c/sqlite3.c"
  $32 = (((($17) + (($$07577*72)|0)|0)) + 12|0); //@line 94083 "c/sqlite3.c"
  HEAP32[$32>>2] = $31; //@line 94083 "c/sqlite3.c"
  $33 = (((($17) + (($$07577*72)|0)|0)) + 36|0); //@line 94084 "c/sqlite3.c"
  $34 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 36|0); //@line 94084 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 94084 "c/sqlite3.c"
  HEAP32[$33>>2] = $35; //@line 94084 "c/sqlite3.c"
  $36 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 44|0); //@line 94085 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 94085 "c/sqlite3.c"
  $38 = (((($17) + (($$07577*72)|0)|0)) + 44|0); //@line 94085 "c/sqlite3.c"
  HEAP32[$38>>2] = $37; //@line 94085 "c/sqlite3.c"
  $39 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 24|0); //@line 94086 "c/sqlite3.c"
  $40 = HEAP32[$39>>2]|0; //@line 94086 "c/sqlite3.c"
  $41 = (((($17) + (($$07577*72)|0)|0)) + 24|0); //@line 94086 "c/sqlite3.c"
  HEAP32[$41>>2] = $40; //@line 94086 "c/sqlite3.c"
  $42 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 28|0); //@line 94087 "c/sqlite3.c"
  $43 = HEAP32[$42>>2]|0; //@line 94087 "c/sqlite3.c"
  $44 = (((($17) + (($$07577*72)|0)|0)) + 28|0); //@line 94087 "c/sqlite3.c"
  HEAP32[$44>>2] = $43; //@line 94087 "c/sqlite3.c"
  $45 = (((($17) + (($$07577*72)|0)|0)) + 37|0); //@line 94088 "c/sqlite3.c"
  $46 = HEAP8[$45>>0]|0; //@line 94088 "c/sqlite3.c"
  $47 = $46 & 2; //@line 94088 "c/sqlite3.c"
  $48 = ($47<<24>>24)==(0); //@line 94088 "c/sqlite3.c"
  if (!($48)) {
   $49 = (((($17) + (($$07577*72)|0)|0)) + 64|0); //@line 94089 "c/sqlite3.c"
   $50 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 64|0); //@line 94089 "c/sqlite3.c"
   $51 = HEAP32[$50>>2]|0; //@line 94089 "c/sqlite3.c"
   $52 = (_sqlite3DbStrDup($0,$51)|0); //@line 94089 "c/sqlite3.c"
   HEAP32[$49>>2] = $52; //@line 94089 "c/sqlite3.c"
  }
  $53 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 68|0); //@line 94091 "c/sqlite3.c"
  $54 = HEAP32[$53>>2]|0; //@line 94091 "c/sqlite3.c"
  $55 = (((($17) + (($$07577*72)|0)|0)) + 68|0); //@line 94091 "c/sqlite3.c"
  HEAP32[$55>>2] = $54; //@line 94091 "c/sqlite3.c"
  $56 = HEAP8[$45>>0]|0; //@line 94092 "c/sqlite3.c"
  $57 = $56 & 4; //@line 94092 "c/sqlite3.c"
  $58 = ($57<<24>>24)==(0); //@line 94092 "c/sqlite3.c"
  if (!($58)) {
   $59 = (((($17) + (($$07577*72)|0)|0)) + 64|0); //@line 94093 "c/sqlite3.c"
   $60 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 64|0); //@line 94094 "c/sqlite3.c"
   $61 = HEAP32[$60>>2]|0; //@line 94094 "c/sqlite3.c"
   $62 = (_sqlite3ExprListDup($0,$61,$2)|0); //@line 94094 "c/sqlite3.c"
   HEAP32[$59>>2] = $62; //@line 94093 "c/sqlite3.c"
  }
  $63 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 16|0); //@line 94096 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 94096 "c/sqlite3.c"
  $65 = (((($17) + (($$07577*72)|0)|0)) + 16|0); //@line 94096 "c/sqlite3.c"
  HEAP32[$65>>2] = $64; //@line 94096 "c/sqlite3.c"
  $66 = ($64|0)==(0|0); //@line 94097 "c/sqlite3.c"
  if (!($66)) {
   $67 = ((($64)) + 32|0); //@line 94098 "c/sqlite3.c"
   $68 = HEAP32[$67>>2]|0; //@line 94098 "c/sqlite3.c"
   $69 = (($68) + 1)|0; //@line 94098 "c/sqlite3.c"
   HEAP32[$67>>2] = $69; //@line 94098 "c/sqlite3.c"
  }
  $70 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 20|0); //@line 94100 "c/sqlite3.c"
  $71 = HEAP32[$70>>2]|0; //@line 94100 "c/sqlite3.c"
  $72 = (_sqlite3SelectDup($0,$71,$2)|0); //@line 94100 "c/sqlite3.c"
  $73 = (((($17) + (($$07577*72)|0)|0)) + 20|0); //@line 94100 "c/sqlite3.c"
  HEAP32[$73>>2] = $72; //@line 94100 "c/sqlite3.c"
  $74 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 48|0); //@line 94101 "c/sqlite3.c"
  $75 = HEAP32[$74>>2]|0; //@line 94101 "c/sqlite3.c"
  $76 = (_sqlite3ExprDup($0,$75,$2)|0); //@line 94101 "c/sqlite3.c"
  $77 = (((($17) + (($$07577*72)|0)|0)) + 48|0); //@line 94101 "c/sqlite3.c"
  HEAP32[$77>>2] = $76; //@line 94101 "c/sqlite3.c"
  $78 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 52|0); //@line 94102 "c/sqlite3.c"
  $79 = HEAP32[$78>>2]|0; //@line 94102 "c/sqlite3.c"
  $80 = (_sqlite3IdListDup($0,$79)|0); //@line 94102 "c/sqlite3.c"
  $81 = (((($17) + (($$07577*72)|0)|0)) + 52|0); //@line 94102 "c/sqlite3.c"
  HEAP32[$81>>2] = $80; //@line 94102 "c/sqlite3.c"
  $82 = (((((($1)) + 8|0) + (($$07577*72)|0)|0)) + 56|0); //@line 94103 "c/sqlite3.c"
  $83 = $82; //@line 94103 "c/sqlite3.c"
  $84 = $83; //@line 94103 "c/sqlite3.c"
  $85 = HEAP32[$84>>2]|0; //@line 94103 "c/sqlite3.c"
  $86 = (($83) + 4)|0; //@line 94103 "c/sqlite3.c"
  $87 = $86; //@line 94103 "c/sqlite3.c"
  $88 = HEAP32[$87>>2]|0; //@line 94103 "c/sqlite3.c"
  $89 = (((($17) + (($$07577*72)|0)|0)) + 56|0); //@line 94103 "c/sqlite3.c"
  $90 = $89; //@line 94103 "c/sqlite3.c"
  $91 = $90; //@line 94103 "c/sqlite3.c"
  HEAP32[$91>>2] = $85; //@line 94103 "c/sqlite3.c"
  $92 = (($90) + 4)|0; //@line 94103 "c/sqlite3.c"
  $93 = $92; //@line 94103 "c/sqlite3.c"
  HEAP32[$93>>2] = $88; //@line 94103 "c/sqlite3.c"
  $94 = (($$07577) + 1)|0; //@line 94076 "c/sqlite3.c"
  $95 = HEAP32[$1>>2]|0; //@line 94076 "c/sqlite3.c"
  $96 = ($94|0)<($95|0); //@line 94076 "c/sqlite3.c"
  if ($96) {
   $$07577 = $94;
  } else {
   $$0 = $11;
   break;
  }
 }
 return ($$0|0); //@line 94106 "c/sqlite3.c"
}
function _withDup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$030 = 0, $$031 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 93976 "c/sqlite3.c"
 if ($2) {
  $$030 = 0;
  return ($$030|0); //@line 93989 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 93977 "c/sqlite3.c"
 $4 = $3 << 4; //@line 93977 "c/sqlite3.c"
 $5 = $4 | 8; //@line 93977 "c/sqlite3.c"
 $6 = ($5|0)<(0); //@line 93978 "c/sqlite3.c"
 $7 = $6 << 31 >> 31; //@line 93978 "c/sqlite3.c"
 $8 = (_sqlite3DbMallocZero($0,$5,$7)|0); //@line 93978 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 93979 "c/sqlite3.c"
 if ($9) {
  $$030 = $8;
  return ($$030|0); //@line 93989 "c/sqlite3.c"
 }
 $10 = HEAP32[$1>>2]|0; //@line 93981 "c/sqlite3.c"
 HEAP32[$8>>2] = $10; //@line 93981 "c/sqlite3.c"
 $11 = HEAP32[$1>>2]|0; //@line 93982 "c/sqlite3.c"
 $12 = ($11|0)>(0); //@line 93982 "c/sqlite3.c"
 if (!($12)) {
  $$030 = $8;
  return ($$030|0); //@line 93989 "c/sqlite3.c"
 }
 $13 = ((($8)) + 8|0);
 $$031 = 0;
 while(1) {
  $14 = (((((($1)) + 8|0) + ($$031<<4)|0)) + 8|0); //@line 93983 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 93983 "c/sqlite3.c"
  $16 = (_sqlite3SelectDup($0,$15,0)|0); //@line 93983 "c/sqlite3.c"
  $17 = (((($13) + ($$031<<4)|0)) + 8|0); //@line 93983 "c/sqlite3.c"
  HEAP32[$17>>2] = $16; //@line 93983 "c/sqlite3.c"
  $18 = (((((($1)) + 8|0) + ($$031<<4)|0)) + 4|0); //@line 93984 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 93984 "c/sqlite3.c"
  $20 = (_sqlite3ExprListDup($0,$19,0)|0); //@line 93984 "c/sqlite3.c"
  $21 = (((($13) + ($$031<<4)|0)) + 4|0); //@line 93984 "c/sqlite3.c"
  HEAP32[$21>>2] = $20; //@line 93984 "c/sqlite3.c"
  $22 = (((($1)) + 8|0) + ($$031<<4)|0); //@line 93985 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 93985 "c/sqlite3.c"
  $24 = (_sqlite3DbStrDup($0,$23)|0); //@line 93985 "c/sqlite3.c"
  $25 = (($13) + ($$031<<4)|0); //@line 93985 "c/sqlite3.c"
  HEAP32[$25>>2] = $24; //@line 93985 "c/sqlite3.c"
  $26 = (($$031) + 1)|0; //@line 93982 "c/sqlite3.c"
  $27 = HEAP32[$1>>2]|0; //@line 93982 "c/sqlite3.c"
  $28 = ($26|0)<($27|0); //@line 93982 "c/sqlite3.c"
  if ($28) {
   $$031 = $26;
  } else {
   $$030 = $8;
   break;
  }
 }
 return ($$030|0); //@line 93989 "c/sqlite3.c"
}
function _sqlite3IdListDup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$03132 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 94111 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 94130 "c/sqlite3.c"
 }
 $3 = (_sqlite3DbMallocRawNN($0,8,0)|0); //@line 94112 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 94113 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  return ($$0|0); //@line 94130 "c/sqlite3.c"
 }
 $5 = ((($1)) + 4|0); //@line 94114 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 94114 "c/sqlite3.c"
 $7 = ((($3)) + 4|0); //@line 94114 "c/sqlite3.c"
 HEAP32[$7>>2] = $6; //@line 94114 "c/sqlite3.c"
 $8 = HEAP32[$5>>2]|0; //@line 94115 "c/sqlite3.c"
 $9 = $8 << 3; //@line 94115 "c/sqlite3.c"
 $10 = (_sqlite3DbMallocRawNN($0,$9,0)|0); //@line 94115 "c/sqlite3.c"
 HEAP32[$3>>2] = $10; //@line 94115 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 94116 "c/sqlite3.c"
 if ($11) {
  _sqlite3DbFreeNN($0,$3); //@line 94117 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 94130 "c/sqlite3.c"
 }
 $12 = HEAP32[$5>>2]|0; //@line 94123 "c/sqlite3.c"
 $13 = ($12|0)>(0); //@line 94123 "c/sqlite3.c"
 if (!($13)) {
  $$0 = $3;
  return ($$0|0); //@line 94130 "c/sqlite3.c"
 }
 $$03132 = 0;
 while(1) {
  $14 = HEAP32[$3>>2]|0; //@line 94124 "c/sqlite3.c"
  $15 = HEAP32[$1>>2]|0; //@line 94125 "c/sqlite3.c"
  $16 = (($15) + ($$03132<<3)|0); //@line 94126 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 94126 "c/sqlite3.c"
  $18 = (_sqlite3DbStrDup($0,$17)|0); //@line 94126 "c/sqlite3.c"
  $19 = (($14) + ($$03132<<3)|0); //@line 94126 "c/sqlite3.c"
  HEAP32[$19>>2] = $18; //@line 94126 "c/sqlite3.c"
  $20 = (((($15) + ($$03132<<3)|0)) + 4|0); //@line 94127 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 94127 "c/sqlite3.c"
  $22 = (((($14) + ($$03132<<3)|0)) + 4|0); //@line 94127 "c/sqlite3.c"
  HEAP32[$22>>2] = $21; //@line 94127 "c/sqlite3.c"
  $23 = (($$03132) + 1)|0; //@line 94123 "c/sqlite3.c"
  $24 = HEAP32[$5>>2]|0; //@line 94123 "c/sqlite3.c"
  $25 = ($23|0)<($24|0); //@line 94123 "c/sqlite3.c"
  if ($25) {
   $$03132 = $23;
  } else {
   $$0 = $3;
   break;
  }
 }
 return ($$0|0); //@line 94130 "c/sqlite3.c"
}
function _analyzeDatabase($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$035 = 0, $$036 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 100165 "c/sqlite3.c"
 $3 = ((($2)) + 16|0); //@line 100166 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 100166 "c/sqlite3.c"
 $5 = (((($4) + ($1<<4)|0)) + 12|0); //@line 100166 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 100166 "c/sqlite3.c"
 _sqlite3BeginWriteOperation($0,0,$1); //@line 100172 "c/sqlite3.c"
 $7 = ((($0)) + 40|0); //@line 100173 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 100173 "c/sqlite3.c"
 $9 = (($8) + 3)|0; //@line 100174 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 100174 "c/sqlite3.c"
 _openStatTable($0,$1,$8,0,0); //@line 100175 "c/sqlite3.c"
 $10 = ((($0)) + 44|0); //@line 100176 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 100176 "c/sqlite3.c"
 $12 = (($11) + 1)|0; //@line 100176 "c/sqlite3.c"
 $13 = HEAP32[$7>>2]|0; //@line 100177 "c/sqlite3.c"
 $14 = ((($6)) + 16|0); //@line 100179 "c/sqlite3.c"
 $$035 = HEAP32[$14>>2]|0;
 $15 = ($$035|0)==(0|0); //@line 100179 "c/sqlite3.c"
 if ($15) {
  _loadAnalysis($0,$1); //@line 100183 "c/sqlite3.c"
  return; //@line 100184 "c/sqlite3.c"
 }
 $$036 = $$035;
 while(1) {
  $16 = ((($$036)) + 8|0); //@line 100180 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 100180 "c/sqlite3.c"
  _analyzeOneTable($0,$17,0,$8,$12,$13); //@line 100181 "c/sqlite3.c"
  $$0 = HEAP32[$$036>>2]|0;
  $18 = ($$0|0)==(0|0); //@line 100179 "c/sqlite3.c"
  if ($18) {
   break;
  } else {
   $$036 = $$0;
  }
 }
 _loadAnalysis($0,$1); //@line 100183 "c/sqlite3.c"
 return; //@line 100184 "c/sqlite3.c"
}
function _sqlite3FindDb($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3NameFromToken($0,$1)|0); //@line 102357 "c/sqlite3.c"
 $3 = (_sqlite3FindDbName($0,$2)|0); //@line 102358 "c/sqlite3.c"
 _sqlite3DbFree($0,$2); //@line 102359 "c/sqlite3.c"
 return ($3|0); //@line 102360 "c/sqlite3.c"
}
function _sqlite3TwoPartName($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 102380 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 102380 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 102386 "c/sqlite3.c"
 $5 = ((($2)) + 4|0); //@line 102389 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 102389 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 102389 "c/sqlite3.c"
 if ($7) {
  $13 = ((($4)) + 156|0); //@line 102403 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 102403 "c/sqlite3.c"
  $15 = $14&255; //@line 102403 "c/sqlite3.c"
  HEAP32[$3>>2] = $1; //@line 102404 "c/sqlite3.c"
  $$0 = $15;
  STACKTOP = sp;return ($$0|0); //@line 102407 "c/sqlite3.c"
 }
 $8 = ((($4)) + 157|0); //@line 102390 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 102390 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 102390 "c/sqlite3.c"
 if (!($10)) {
  _sqlite3ErrorMsg($0,24658,$vararg_buffer); //@line 102391 "c/sqlite3.c"
  $$0 = -1;
  STACKTOP = sp;return ($$0|0); //@line 102407 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = $2; //@line 102394 "c/sqlite3.c"
 $11 = (_sqlite3FindDb($4,$1)|0); //@line 102395 "c/sqlite3.c"
 $12 = ($11|0)<(0); //@line 102396 "c/sqlite3.c"
 if (!($12)) {
  $$0 = $11;
  STACKTOP = sp;return ($$0|0); //@line 102407 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer1>>2] = $1; //@line 102397 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,24675,$vararg_buffer1); //@line 102397 "c/sqlite3.c"
 $$0 = -1;
 STACKTOP = sp;return ($$0|0); //@line 102407 "c/sqlite3.c"
}
function _analyzeTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 100197 "c/sqlite3.c"
 $4 = ((($1)) + 72|0); //@line 100197 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 100197 "c/sqlite3.c"
 $6 = (_sqlite3SchemaToIndex($3,$5)|0); //@line 100197 "c/sqlite3.c"
 _sqlite3BeginWriteOperation($0,0,$6); //@line 100198 "c/sqlite3.c"
 $7 = ((($0)) + 40|0); //@line 100199 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 100199 "c/sqlite3.c"
 $9 = (($8) + 3)|0; //@line 100200 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 100200 "c/sqlite3.c"
 $10 = ($2|0)==(0|0); //@line 100201 "c/sqlite3.c"
 if ($10) {
  $12 = HEAP32[$1>>2]|0; //@line 100204 "c/sqlite3.c"
  _openStatTable($0,$6,$8,$12,20323); //@line 100204 "c/sqlite3.c"
 } else {
  $11 = HEAP32[$2>>2]|0; //@line 100202 "c/sqlite3.c"
  _openStatTable($0,$6,$8,$11,20327); //@line 100202 "c/sqlite3.c"
 }
 $13 = ((($0)) + 44|0); //@line 100206 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 100206 "c/sqlite3.c"
 $15 = (($14) + 1)|0; //@line 100206 "c/sqlite3.c"
 $16 = HEAP32[$7>>2]|0; //@line 100206 "c/sqlite3.c"
 _analyzeOneTable($0,$1,$2,$8,$15,$16); //@line 100206 "c/sqlite3.c"
 _loadAnalysis($0,$6); //@line 100207 "c/sqlite3.c"
 return; //@line 100208 "c/sqlite3.c"
}
function _openStatTable($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$055 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $5 = sp + 32|0;
 $6 = sp + 44|0;
 $7 = HEAP32[$0>>2]|0; //@line 99026 "c/sqlite3.c"
 $8 = (_sqlite3GetVdbe($0)|0); //@line 99028 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 99032 "c/sqlite3.c"
 if ($9) {
  STACKTOP = sp;return; //@line 99085 "c/sqlite3.c"
 }
 $10 = ((($7)) + 16|0); //@line 99035 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 99035 "c/sqlite3.c"
 $12 = (($11) + ($1<<4)|0);
 $13 = ($3|0)==(0|0);
 $14 = ((($0)) + 100|0);
 $$055 = 0;
 while(1) {
  $15 = (6076 + ($$055<<3)|0); //@line 99041 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 99041 "c/sqlite3.c"
  $17 = HEAP32[$12>>2]|0; //@line 99043 "c/sqlite3.c"
  $18 = (_sqlite3FindTable($7,$16,$17)|0); //@line 99043 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 99043 "c/sqlite3.c"
  do {
   if ($19) {
    $20 = ($$055|0)==(0); //@line 99044 "c/sqlite3.c"
    if ($20) {
     $21 = (((6076 + ($$055<<3)|0)) + 4|0); //@line 99044 "c/sqlite3.c"
     $22 = HEAP32[$21>>2]|0; //@line 99044 "c/sqlite3.c"
     $23 = HEAP32[$12>>2]|0; //@line 99050 "c/sqlite3.c"
     HEAP32[$vararg_buffer>>2] = $23; //@line 99049 "c/sqlite3.c"
     $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 99049 "c/sqlite3.c"
     HEAP32[$vararg_ptr1>>2] = $16; //@line 99049 "c/sqlite3.c"
     $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 99049 "c/sqlite3.c"
     HEAP32[$vararg_ptr2>>2] = $22; //@line 99049 "c/sqlite3.c"
     _sqlite3NestedParse($0,24566,$vararg_buffer); //@line 99049 "c/sqlite3.c"
     $24 = HEAP32[$14>>2]|0; //@line 99052 "c/sqlite3.c"
     $25 = (($5) + ($$055<<2)|0); //@line 99052 "c/sqlite3.c"
     HEAP32[$25>>2] = $24; //@line 99052 "c/sqlite3.c"
     $26 = (($6) + ($$055)|0); //@line 99053 "c/sqlite3.c"
     HEAP8[$26>>0] = 16; //@line 99053 "c/sqlite3.c"
    }
   } else {
    $27 = ((($18)) + 28|0); //@line 99059 "c/sqlite3.c"
    $28 = HEAP32[$27>>2]|0; //@line 99059 "c/sqlite3.c"
    $29 = (($5) + ($$055<<2)|0); //@line 99059 "c/sqlite3.c"
    HEAP32[$29>>2] = $28; //@line 99059 "c/sqlite3.c"
    $30 = (($6) + ($$055)|0); //@line 99060 "c/sqlite3.c"
    HEAP8[$30>>0] = 0; //@line 99060 "c/sqlite3.c"
    _sqlite3TableLock($0,$1,$28,1,$16); //@line 99061 "c/sqlite3.c"
    if ($13) {
     (_sqlite3VdbeAddOp2($8,134,$28,$1)|0); //@line 99073 "c/sqlite3.c"
     break;
    } else {
     $31 = HEAP32[$12>>2]|0; //@line 99065 "c/sqlite3.c"
     HEAP32[$vararg_buffer3>>2] = $31; //@line 99063 "c/sqlite3.c"
     $vararg_ptr6 = ((($vararg_buffer3)) + 4|0); //@line 99063 "c/sqlite3.c"
     HEAP32[$vararg_ptr6>>2] = $16; //@line 99063 "c/sqlite3.c"
     $vararg_ptr7 = ((($vararg_buffer3)) + 8|0); //@line 99063 "c/sqlite3.c"
     HEAP32[$vararg_ptr7>>2] = $4; //@line 99063 "c/sqlite3.c"
     $vararg_ptr8 = ((($vararg_buffer3)) + 12|0); //@line 99063 "c/sqlite3.c"
     HEAP32[$vararg_ptr8>>2] = $3; //@line 99063 "c/sqlite3.c"
     _sqlite3NestedParse($0,24589,$vararg_buffer3); //@line 99063 "c/sqlite3.c"
     break;
    }
   }
  } while(0);
  $32 = (($$055) + 1)|0; //@line 99040 "c/sqlite3.c"
  $exitcond = ($32|0)==(3); //@line 99040 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$055 = $32;
  }
 }
 $33 = HEAP32[$5>>2]|0; //@line 99081 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4Int($8,106,$2,$33,$1,3)|0); //@line 99081 "c/sqlite3.c"
 $34 = HEAP8[$6>>0]|0; //@line 99082 "c/sqlite3.c"
 $35 = $34&255; //@line 99082 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($8,$35); //@line 99082 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 99085 "c/sqlite3.c"
}
function _analyzeOneTable($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$ = 0, $$0 = 0, $$0240 = 0, $$0240$in = 0, $$0241 = 0, $$0243254 = 0, $$0245 = 0, $$0248$lcssa = 0, $$0248259 = 0, $$0258 = 0, $$0260 = 0, $$1 = 0, $$1244255 = 0, $$2 = 0, $$250 = 0, $$252 = 0, $$not = 0, $10 = 0, $100 = 0, $101 = 0;
 var $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond251 = 0, $or$cond253 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = HEAP32[$0>>2]|0; //@line 99815 "c/sqlite3.c"
 $7 = (($4) + 1)|0; //@line 99824 "c/sqlite3.c"
 $8 = (($4) + 2)|0; //@line 99825 "c/sqlite3.c"
 $9 = (($4) + 3)|0; //@line 99826 "c/sqlite3.c"
 $10 = (($4) + 4)|0; //@line 99830 "c/sqlite3.c"
 $11 = (($4) + 5)|0; //@line 99831 "c/sqlite3.c"
 $12 = (($4) + 6)|0; //@line 99832 "c/sqlite3.c"
 $13 = (($4) + 7)|0; //@line 99833 "c/sqlite3.c"
 $14 = ((($0)) + 44|0); //@line 99839 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 99839 "c/sqlite3.c"
 $16 = ($15|0)>($13|0); //@line 99839 "c/sqlite3.c"
 $$ = $16 ? $15 : $13; //@line 99839 "c/sqlite3.c"
 HEAP32[$14>>2] = $$; //@line 99839 "c/sqlite3.c"
 $17 = (_sqlite3GetVdbe($0)|0); //@line 99840 "c/sqlite3.c"
 $18 = ($17|0)==(0|0); //@line 99841 "c/sqlite3.c"
 $19 = ($1|0)==(0|0); //@line 99841 "c/sqlite3.c"
 $or$cond = $19 | $18; //@line 99841 "c/sqlite3.c"
 if ($or$cond) {
  return; //@line 100147 "c/sqlite3.c"
 }
 $20 = ((($1)) + 28|0); //@line 99844 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 99844 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 99844 "c/sqlite3.c"
 if ($22) {
  return; //@line 100147 "c/sqlite3.c"
 }
 $23 = HEAP32[$1>>2]|0; //@line 99848 "c/sqlite3.c"
 $24 = (_sqlite3_strlike(24513,$23,0)|0); //@line 99848 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 99848 "c/sqlite3.c"
 if ($25) {
  return; //@line 100147 "c/sqlite3.c"
 }
 $26 = ((($1)) + 72|0); //@line 99853 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 99853 "c/sqlite3.c"
 $28 = (_sqlite3SchemaToIndex($6,$27)|0); //@line 99853 "c/sqlite3.c"
 $29 = HEAP32[$1>>2]|0; //@line 99857 "c/sqlite3.c"
 $30 = ((($6)) + 16|0); //@line 99858 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 99858 "c/sqlite3.c"
 $32 = (($31) + ($28<<4)|0); //@line 99858 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 99858 "c/sqlite3.c"
 $34 = (_sqlite3AuthCheck($0,28,$29,0,$33)|0); //@line 99857 "c/sqlite3.c"
 $35 = ($34|0)==(0); //@line 99857 "c/sqlite3.c"
 if (!($35)) {
  return; //@line 100147 "c/sqlite3.c"
 }
 $36 = HEAP32[$20>>2]|0; //@line 99879 "c/sqlite3.c"
 $37 = HEAP32[$1>>2]|0; //@line 99879 "c/sqlite3.c"
 _sqlite3TableLock($0,$28,$36,0,$37); //@line 99879 "c/sqlite3.c"
 $38 = (($5) + 1)|0; //@line 99880 "c/sqlite3.c"
 $39 = (($5) + 2)|0; //@line 99881 "c/sqlite3.c"
 $40 = ((($0)) + 40|0); //@line 99882 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 99882 "c/sqlite3.c"
 $42 = ($41|0)>($39|0); //@line 99882 "c/sqlite3.c"
 $$250 = $42 ? $41 : $39; //@line 99882 "c/sqlite3.c"
 HEAP32[$40>>2] = $$250; //@line 99882 "c/sqlite3.c"
 _sqlite3OpenTable($0,$5,$28,$1,105); //@line 99883 "c/sqlite3.c"
 $43 = HEAP32[$1>>2]|0; //@line 99884 "c/sqlite3.c"
 (_sqlite3VdbeLoadString($17,$10,$43)|0); //@line 99884 "c/sqlite3.c"
 $44 = ((($1)) + 8|0); //@line 99886 "c/sqlite3.c"
 $$0258 = HEAP32[$44>>2]|0;
 $45 = ($$0258|0)==(0|0); //@line 99886 "c/sqlite3.c"
 $46 = ($2|0)==(0|0);
 if ($45) {
  $$0248$lcssa = 1;
 } else {
  $47 = ((($1)) + 36|0);
  $$0248259 = 1;$$0260 = $$0258;
  while(1) {
   $48 = ($$0260|0)==($2|0); //@line 99893 "c/sqlite3.c"
   $or$cond251 = $46 | $48; //@line 99893 "c/sqlite3.c"
   do {
    if ($or$cond251) {
     $49 = ((($$0260)) + 36|0); //@line 99894 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 99894 "c/sqlite3.c"
     $51 = ($50|0)==(0|0); //@line 99894 "c/sqlite3.c"
     $spec$select = $51 ? 0 : $$0248259; //@line 99894 "c/sqlite3.c"
     $52 = HEAP32[$47>>2]|0; //@line 99895 "c/sqlite3.c"
     $53 = $52 & 32; //@line 99895 "c/sqlite3.c"
     $54 = ($53|0)==(0); //@line 99895 "c/sqlite3.c"
     if ($54) {
      label = 11;
     } else {
      $55 = ((($$0260)) + 55|0); //@line 99895 "c/sqlite3.c"
      $56 = HEAPU8[$55>>0]|(HEAPU8[$55+1>>0]<<8); //@line 99895 "c/sqlite3.c"
      $57 = $56 & 3; //@line 99895 "c/sqlite3.c"
      $58 = ($57<<16>>16)==(2); //@line 99895 "c/sqlite3.c"
      if ($58) {
       $59 = ((($$0260)) + 50|0); //@line 99896 "c/sqlite3.c"
       $60 = HEAP16[$59>>1]|0; //@line 99896 "c/sqlite3.c"
       $61 = $60&65535; //@line 99896 "c/sqlite3.c"
       $62 = HEAP32[$1>>2]|0; //@line 99897 "c/sqlite3.c"
       $$0240$in = $61;$$0241 = $62;$$0245 = $61;
      } else {
       label = 11;
      }
     }
     if ((label|0) == 11) {
      label = 0;
      $63 = ((($$0260)) + 52|0); //@line 99900 "c/sqlite3.c"
      $64 = HEAP16[$63>>1]|0; //@line 99900 "c/sqlite3.c"
      $65 = $64&65535; //@line 99900 "c/sqlite3.c"
      $66 = HEAP32[$$0260>>2]|0; //@line 99901 "c/sqlite3.c"
      $67 = ((($$0260)) + 55|0); //@line 99902 "c/sqlite3.c"
      $68 = HEAPU8[$67>>0]|(HEAPU8[$67+1>>0]<<8); //@line 99902 "c/sqlite3.c"
      $69 = $68 & 8; //@line 99902 "c/sqlite3.c"
      $70 = ($69<<16>>16)==(0); //@line 99902 "c/sqlite3.c"
      if ($70) {
       $$0240$in = $65;$$0241 = $66;$$0245 = $65;
      } else {
       $71 = ((($$0260)) + 50|0); //@line 99902 "c/sqlite3.c"
       $72 = HEAP16[$71>>1]|0; //@line 99902 "c/sqlite3.c"
       $73 = $72&65535; //@line 99902 "c/sqlite3.c"
       $$0240$in = $73;$$0241 = $66;$$0245 = $65;
      }
     }
     $$0240 = (($$0240$in) + -1)|0;
     (_sqlite3VdbeLoadString($17,$11,$$0241)|0); //@line 99906 "c/sqlite3.c"
     $74 = HEAP32[$14>>2]|0; //@line 99945 "c/sqlite3.c"
     $75 = (($$0240) + ($13))|0; //@line 99945 "c/sqlite3.c"
     $76 = ($74|0)>($75|0); //@line 99945 "c/sqlite3.c"
     $$252 = $76 ? $74 : $75; //@line 99945 "c/sqlite3.c"
     HEAP32[$14>>2] = $$252; //@line 99945 "c/sqlite3.c"
     $77 = ((($$0260)) + 44|0); //@line 99949 "c/sqlite3.c"
     $78 = HEAP32[$77>>2]|0; //@line 99949 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($17,105,$38,$78,$28)|0); //@line 99949 "c/sqlite3.c"
     _sqlite3VdbeSetP4KeyInfo($0,$$0260); //@line 99950 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($17,67,$$0245,$8)|0); //@line 99966 "c/sqlite3.c"
     $79 = ((($$0260)) + 50|0); //@line 99967 "c/sqlite3.c"
     $80 = HEAP16[$79>>1]|0; //@line 99967 "c/sqlite3.c"
     $81 = $80&65535; //@line 99967 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($17,67,$81,$9)|0); //@line 99967 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4($17,163,0,$8,$7,5992,-8)|0); //@line 99968 "c/sqlite3.c"
     _sqlite3VdbeChangeP5($17,2); //@line 99970 "c/sqlite3.c"
     $82 = (_sqlite3VdbeAddOp1($17,37,$38)|0); //@line 99980 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($17,67,0,$8)|0); //@line 99982 "c/sqlite3.c"
     $83 = (_sqlite3VdbeCurrentAddr($17)|0); //@line 99983 "c/sqlite3.c"
     $84 = ($$0240$in>>>0)>(1); //@line 99985 "c/sqlite3.c"
     if ($84) {
      $85 = (_sqlite3VdbeMakeLabel($17)|0); //@line 99986 "c/sqlite3.c"
      $86 = $$0240 << 2; //@line 99988 "c/sqlite3.c"
      $87 = (_sqlite3DbMallocRawNN($6,$86,0)|0); //@line 99988 "c/sqlite3.c"
      $88 = ($87|0)==(0|0); //@line 99989 "c/sqlite3.c"
      if ($88) {
       $$2 = $spec$select;
       break;
      }
      (_sqlite3VdbeAddOp0($17,13)|0); //@line 100001 "c/sqlite3.c"
      $89 = (_sqlite3VdbeCurrentAddr($17)|0); //@line 100002 "c/sqlite3.c"
      $90 = ($$0240|0)==(1); //@line 100003 "c/sqlite3.c"
      if ($90) {
       $91 = HEAP16[$79>>1]|0; //@line 100003 "c/sqlite3.c"
       $92 = ($91<<16>>16)==(1); //@line 100003 "c/sqlite3.c"
       if ($92) {
        $93 = ((($$0260)) + 54|0); //@line 100003 "c/sqlite3.c"
        $94 = HEAP8[$93>>0]|0; //@line 100003 "c/sqlite3.c"
        $95 = ($94<<24>>24)==(0); //@line 100003 "c/sqlite3.c"
        if (!($95)) {
         (_sqlite3VdbeAddOp2($17,51,$13,$85)|0); //@line 100007 "c/sqlite3.c"
        }
       }
      }
      $96 = ((($$0260)) + 32|0);
      $$0243254 = 0;
      while(1) {
       $97 = HEAP32[$96>>2]|0; //@line 100011 "c/sqlite3.c"
       $98 = (($97) + ($$0243254<<2)|0); //@line 100011 "c/sqlite3.c"
       $99 = HEAP32[$98>>2]|0; //@line 100011 "c/sqlite3.c"
       $100 = (_sqlite3LocateCollSeq($0,$99)|0); //@line 100011 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($17,67,$$0243254,$8)|0); //@line 100012 "c/sqlite3.c"
       (_sqlite3VdbeAddOp3($17,98,$38,$$0243254,$9)|0); //@line 100013 "c/sqlite3.c"
       $101 = (($$0243254) + ($13))|0; //@line 100015 "c/sqlite3.c"
       $102 = (_sqlite3VdbeAddOp4($17,52,$9,0,$101,$100,-2)|0); //@line 100015 "c/sqlite3.c"
       $103 = (($87) + ($$0243254<<2)|0); //@line 100014 "c/sqlite3.c"
       HEAP32[$103>>2] = $102; //@line 100014 "c/sqlite3.c"
       _sqlite3VdbeChangeP5($17,128); //@line 100016 "c/sqlite3.c"
       $104 = (($$0243254) + 1)|0; //@line 100010 "c/sqlite3.c"
       $105 = ($104|0)<($$0240|0); //@line 100010 "c/sqlite3.c"
       if ($105) {
        $$0243254 = $104;
       } else {
        break;
       }
      }
      (_sqlite3VdbeAddOp2($17,67,$$0240,$8)|0); //@line 100019 "c/sqlite3.c"
      _sqlite3VdbeGoto($17,$85); //@line 100020 "c/sqlite3.c"
      $106 = (($89) + -1)|0; //@line 100030 "c/sqlite3.c"
      _sqlite3VdbeJumpHere($17,$106); //@line 100030 "c/sqlite3.c"
      $107 = ($$0240$in>>>0)>(1); //@line 100031 "c/sqlite3.c"
      if ($107) {
       $$1244255 = 0;
       while(1) {
        $108 = (($87) + ($$1244255<<2)|0); //@line 100032 "c/sqlite3.c"
        $109 = HEAP32[$108>>2]|0; //@line 100032 "c/sqlite3.c"
        _sqlite3VdbeJumpHere($17,$109); //@line 100032 "c/sqlite3.c"
        $110 = (($$1244255) + ($13))|0; //@line 100033 "c/sqlite3.c"
        (_sqlite3VdbeAddOp3($17,98,$38,$$1244255,$110)|0); //@line 100033 "c/sqlite3.c"
        $111 = (($$1244255) + 1)|0; //@line 100031 "c/sqlite3.c"
        $112 = ($111|0)<($$0240|0); //@line 100031 "c/sqlite3.c"
        if ($112) {
         $$1244255 = $111;
        } else {
         break;
        }
       }
      }
      _sqlite3VdbeResolveLabel($17,$85); //@line 100035 "c/sqlite3.c"
      _sqlite3DbFree($6,$87); //@line 100036 "c/sqlite3.c"
      $$1 = $89;
     } else {
      $$1 = $83;
     }
     (_sqlite3VdbeAddOp4($17,163,1,$7,$9,6020,-8)|0); //@line 100065 "c/sqlite3.c"
     _sqlite3VdbeChangeP5($17,2); //@line 100067 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($17,7,$38,$$1)|0); //@line 100068 "c/sqlite3.c"
     _callStatGet($17,$7,$12); //@line 100071 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4($17,100,$10,3,$9,24522,0)|0); //@line 100073 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($17,116,$3,$4)|0); //@line 100074 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($17,117,$3,$9,$4)|0); //@line 100075 "c/sqlite3.c"
     _sqlite3VdbeChangeP5($17,8); //@line 100079 "c/sqlite3.c"
     _sqlite3VdbeJumpHere($17,$82); //@line 100125 "c/sqlite3.c"
     $$2 = $spec$select;
    } else {
     $$2 = $$0248259;
    }
   } while(0);
   $113 = ((($$0260)) + 20|0); //@line 99886 "c/sqlite3.c"
   $$0 = HEAP32[$113>>2]|0;
   $114 = ($$0|0)==(0|0); //@line 99886 "c/sqlite3.c"
   if ($114) {
    $$0248$lcssa = $$2;
    break;
   } else {
    $$0248259 = $$2;$$0260 = $$0;
   }
  }
 }
 $$not = $46 ^ 1; //@line 100132 "c/sqlite3.c"
 $115 = ($$0248$lcssa<<24>>24)==(0); //@line 100132 "c/sqlite3.c"
 $or$cond253 = $115 | $$not; //@line 100132 "c/sqlite3.c"
 if ($or$cond253) {
  return; //@line 100147 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($17,101,$5,$12)|0); //@line 100134 "c/sqlite3.c"
 $116 = (_sqlite3VdbeAddOp1($17,22,$12)|0); //@line 100135 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($17,70,0,$11)|0); //@line 100136 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($17,100,$10,3,$9,24522,0)|0); //@line 100138 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($17,116,$3,$4)|0); //@line 100139 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($17,117,$3,$9,$4)|0); //@line 100140 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($17,8); //@line 100141 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($17,$116); //@line 100145 "c/sqlite3.c"
 return; //@line 100147 "c/sqlite3.c"
}
function _loadAnalysis($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3GetVdbe($0)|0); //@line 100155 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 100156 "c/sqlite3.c"
 if ($3) {
  return; //@line 100159 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp1($2,139,$1)|0); //@line 100157 "c/sqlite3.c"
 return; //@line 100159 "c/sqlite3.c"
}
function _sqlite3VdbeAddOp1($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeAddOp3($0,$1,$2,0,0)|0); //@line 73181 "c/sqlite3.c"
 return ($3|0); //@line 73181 "c/sqlite3.c"
}
function _sqlite3TableLock($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$044 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 120|0); //@line 101674 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 101674 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 101674 "c/sqlite3.c"
 $spec$select = $7 ? $0 : $6; //@line 101674 "c/sqlite3.c"
 $8 = ($1|0)==(1); //@line 101680 "c/sqlite3.c"
 if ($8) {
  return; //@line 101703 "c/sqlite3.c"
 }
 $9 = HEAP32[$0>>2]|0; //@line 101681 "c/sqlite3.c"
 $10 = ((($9)) + 16|0); //@line 101681 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 101681 "c/sqlite3.c"
 $12 = (((($11) + ($1<<4)|0)) + 4|0); //@line 101681 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 101681 "c/sqlite3.c"
 $14 = (_sqlite3BtreeSharable($13)|0); //@line 101681 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 101681 "c/sqlite3.c"
 if ($15) {
  return; //@line 101703 "c/sqlite3.c"
 }
 $16 = ((($spec$select)) + 108|0); //@line 101682 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 101682 "c/sqlite3.c"
 $18 = ($17|0)>(0); //@line 101682 "c/sqlite3.c"
 L7: do {
  if ($18) {
   $19 = ((($spec$select)) + 112|0);
   $20 = HEAP32[$19>>2]|0;
   $$044 = 0;
   while(1) {
    $21 = (($20) + ($$044<<4)|0); //@line 101684 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 101684 "c/sqlite3.c"
    $23 = ($22|0)==($1|0); //@line 101684 "c/sqlite3.c"
    if ($23) {
     $24 = (((($20) + ($$044<<4)|0)) + 4|0); //@line 101684 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 101684 "c/sqlite3.c"
     $26 = ($25|0)==($2|0); //@line 101684 "c/sqlite3.c"
     if ($26) {
      break;
     }
    }
    $32 = (($$044) + 1)|0; //@line 101682 "c/sqlite3.c"
    $33 = HEAP32[$16>>2]|0; //@line 101682 "c/sqlite3.c"
    $34 = ($32|0)<($33|0); //@line 101682 "c/sqlite3.c"
    if ($34) {
     $$044 = $32;
    } else {
     $$lcssa = $33;
     break L7;
    }
   }
   $27 = (((($20) + ($$044<<4)|0)) + 8|0); //@line 101685 "c/sqlite3.c"
   $28 = HEAP8[$27>>0]|0; //@line 101685 "c/sqlite3.c"
   $29 = $28 | $3; //@line 101685 "c/sqlite3.c"
   $30 = ($29<<24>>24)!=(0); //@line 101685 "c/sqlite3.c"
   $31 = $30&1; //@line 101685 "c/sqlite3.c"
   HEAP8[$27>>0] = $31; //@line 101685 "c/sqlite3.c"
   return; //@line 101703 "c/sqlite3.c"
  } else {
   $$lcssa = $17;
  }
 } while(0);
 $35 = $$lcssa << 4; //@line 101690 "c/sqlite3.c"
 $36 = (($35) + 16)|0; //@line 101690 "c/sqlite3.c"
 $37 = HEAP32[$spec$select>>2]|0; //@line 101692 "c/sqlite3.c"
 $38 = ((($spec$select)) + 112|0); //@line 101692 "c/sqlite3.c"
 $39 = HEAP32[$38>>2]|0; //@line 101692 "c/sqlite3.c"
 $40 = ($36|0)<(0); //@line 101692 "c/sqlite3.c"
 $41 = $40 << 31 >> 31; //@line 101692 "c/sqlite3.c"
 $42 = (_sqlite3DbReallocOrFree($37,$39,$36,$41)|0); //@line 101692 "c/sqlite3.c"
 HEAP32[$38>>2] = $42; //@line 101691 "c/sqlite3.c"
 $43 = ($42|0)==(0|0); //@line 101693 "c/sqlite3.c"
 if ($43) {
  HEAP32[$16>>2] = 0; //@line 101700 "c/sqlite3.c"
  $50 = HEAP32[$spec$select>>2]|0; //@line 101701 "c/sqlite3.c"
  _sqlite3OomFault($50); //@line 101701 "c/sqlite3.c"
  return; //@line 101703 "c/sqlite3.c"
 } else {
  $44 = HEAP32[$16>>2]|0; //@line 101694 "c/sqlite3.c"
  $45 = (($44) + 1)|0; //@line 101694 "c/sqlite3.c"
  HEAP32[$16>>2] = $45; //@line 101694 "c/sqlite3.c"
  $46 = (($42) + ($44<<4)|0); //@line 101695 "c/sqlite3.c"
  HEAP32[$46>>2] = $1; //@line 101695 "c/sqlite3.c"
  $47 = (((($42) + ($44<<4)|0)) + 4|0); //@line 101696 "c/sqlite3.c"
  HEAP32[$47>>2] = $2; //@line 101696 "c/sqlite3.c"
  $48 = (((($42) + ($44<<4)|0)) + 8|0); //@line 101697 "c/sqlite3.c"
  HEAP8[$48>>0] = $3; //@line 101697 "c/sqlite3.c"
  $49 = (((($42) + ($44<<4)|0)) + 12|0); //@line 101698 "c/sqlite3.c"
  HEAP32[$49>>2] = $4; //@line 101698 "c/sqlite3.c"
  return; //@line 101703 "c/sqlite3.c"
 }
}
function _sqlite3OpenTable($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3GetVdbe($0)|0); //@line 110872 "c/sqlite3.c"
 $6 = ((($3)) + 28|0); //@line 110874 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 110874 "c/sqlite3.c"
 $8 = ($4|0)==(106); //@line 110875 "c/sqlite3.c"
 $9 = $8&1; //@line 110875 "c/sqlite3.c"
 $10 = HEAP32[$3>>2]|0; //@line 110875 "c/sqlite3.c"
 _sqlite3TableLock($0,$2,$7,$9,$10); //@line 110874 "c/sqlite3.c"
 $11 = ((($3)) + 36|0); //@line 110876 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 110876 "c/sqlite3.c"
 $13 = $12 & 32; //@line 110876 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 110876 "c/sqlite3.c"
 if ($14) {
  $15 = HEAP32[$6>>2]|0; //@line 110877 "c/sqlite3.c"
  $16 = ((($3)) + 42|0); //@line 110877 "c/sqlite3.c"
  $17 = HEAP16[$16>>1]|0; //@line 110877 "c/sqlite3.c"
  $18 = $17 << 16 >> 16; //@line 110877 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4Int($5,$4,$1,$15,$2,$18)|0); //@line 110877 "c/sqlite3.c"
  return; //@line 110887 "c/sqlite3.c"
 } else {
  $19 = (_sqlite3PrimaryKeyIndex($3)|0); //@line 110880 "c/sqlite3.c"
  $20 = ((($19)) + 44|0); //@line 110883 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 110883 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($5,$4,$1,$21,$2)|0); //@line 110883 "c/sqlite3.c"
  _sqlite3VdbeSetP4KeyInfo($0,$19); //@line 110884 "c/sqlite3.c"
  return; //@line 110887 "c/sqlite3.c"
 }
}
function _sqlite3VdbeSetP4KeyInfo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 74018 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 74018 "c/sqlite3.c"
 $4 = (_sqlite3KeyInfoOfIndex($0,$1)|0); //@line 74022 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 74023 "c/sqlite3.c"
 if ($5) {
  return; //@line 74024 "c/sqlite3.c"
 }
 _sqlite3VdbeAppendP4($3,$4,-9); //@line 74023 "c/sqlite3.c"
 return; //@line 74024 "c/sqlite3.c"
}
function _sqlite3VdbeChangeP5($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 136|0); //@line 73784 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73784 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 73784 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 73785 "c/sqlite3.c"
 }
 $5 = (($3) + -1)|0; //@line 73784 "c/sqlite3.c"
 $6 = ((($0)) + 88|0); //@line 73784 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 73784 "c/sqlite3.c"
 $8 = (((($7) + (($5*20)|0)|0)) + 2|0); //@line 73784 "c/sqlite3.c"
 HEAP16[$8>>1] = $1; //@line 73784 "c/sqlite3.c"
 return; //@line 73785 "c/sqlite3.c"
}
function _sqlite3VdbeMakeLabel($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 73330 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 73330 "c/sqlite3.c"
 $3 = ((($2)) + 68|0); //@line 73331 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 73331 "c/sqlite3.c"
 $5 = (($4) + 1)|0; //@line 73331 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 73331 "c/sqlite3.c"
 $6 = (($4) + -1)|0; //@line 73333 "c/sqlite3.c"
 $7 = $6 & $4; //@line 73333 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 73333 "c/sqlite3.c"
 $9 = ((($2)) + 72|0); //@line 73334 "c/sqlite3.c"
 if ($8) {
  $10 = $4 << 3; //@line 73335 "c/sqlite3.c"
  $11 = $10 | 4; //@line 73335 "c/sqlite3.c"
  $12 = HEAP32[$2>>2]|0; //@line 73334 "c/sqlite3.c"
  $13 = HEAP32[$9>>2]|0; //@line 73334 "c/sqlite3.c"
  $14 = (_sqlite3DbReallocOrFree($12,$13,$11,0)|0); //@line 73334 "c/sqlite3.c"
  HEAP32[$9>>2] = $14; //@line 73334 "c/sqlite3.c"
 }
 $15 = ((($2)) + 72|0); //@line 73337 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 73337 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 73337 "c/sqlite3.c"
 if ($17) {
  $19 = $4 ^ -1; //@line 73340 "c/sqlite3.c"
  return ($19|0); //@line 73340 "c/sqlite3.c"
 }
 $18 = (($16) + ($4<<2)|0); //@line 73338 "c/sqlite3.c"
 HEAP32[$18>>2] = -1; //@line 73338 "c/sqlite3.c"
 $19 = $4 ^ -1; //@line 73340 "c/sqlite3.c"
 return ($19|0); //@line 73340 "c/sqlite3.c"
}
function _sqlite3LocateCollSeq($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 103065 "c/sqlite3.c"
 $3 = ((($2)) + 70|0); //@line 103066 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 103066 "c/sqlite3.c"
 $5 = ((($2)) + 157|0); //@line 103067 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 103067 "c/sqlite3.c"
 $7 = $6&255; //@line 103070 "c/sqlite3.c"
 $8 = (_sqlite3FindCollSeq($2,$4,$1,$7)|0); //@line 103070 "c/sqlite3.c"
 $9 = ($6<<24>>24)==(0); //@line 103071 "c/sqlite3.c"
 if (!($9)) {
  $$0 = $8;
  return ($$0|0); //@line 103075 "c/sqlite3.c"
 }
 $10 = ($8|0)==(0|0); //@line 103071 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($8)) + 12|0); //@line 103071 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 103071 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 103071 "c/sqlite3.c"
  if (!($13)) {
   $$0 = $8;
   return ($$0|0); //@line 103075 "c/sqlite3.c"
  }
 }
 $14 = (_sqlite3GetCollSeq($0,$4,$8,$1)|0); //@line 103072 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 103075 "c/sqlite3.c"
}
function _sqlite3VdbeGoto($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3VdbeAddOp3($0,13,0,$1,0)|0); //@line 73190 "c/sqlite3.c"
 return;
}
function _sqlite3VdbeJumpHere($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 136|0); //@line 73792 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73792 "c/sqlite3.c"
 _sqlite3VdbeChangeP2($0,$1,$3); //@line 73792 "c/sqlite3.c"
 return; //@line 73793 "c/sqlite3.c"
}
function _sqlite3VdbeResolveLabel($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 73349 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73349 "c/sqlite3.c"
 $4 = ((($3)) + 72|0); //@line 73354 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 73354 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 73354 "c/sqlite3.c"
 if ($6) {
  return; //@line 73357 "c/sqlite3.c"
 }
 $7 = $1 ^ -1; //@line 73350 "c/sqlite3.c"
 $8 = (($5) + ($7<<2)|0); //@line 73355 "c/sqlite3.c"
 $9 = ((($0)) + 136|0); //@line 73355 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 73355 "c/sqlite3.c"
 HEAP32[$8>>2] = $10; //@line 73355 "c/sqlite3.c"
 return; //@line 73357 "c/sqlite3.c"
}
function _callStatGet($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3VdbeAddOp4($0,163,0,$1,$2,6048,-8)|0); //@line 99798 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($0,1); //@line 99800 "c/sqlite3.c"
 return; //@line 99801 "c/sqlite3.c"
}
function _statGet($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03436 = 0, $$037 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 99664 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 99664 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 99668 "c/sqlite3.c"
 $4 = (_sqlite3_value_blob($3)|0); //@line 99668 "c/sqlite3.c"
 $5 = ((($4)) + 12|0); //@line 99706 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 99706 "c/sqlite3.c"
 $7 = ($6*25)|0; //@line 99706 "c/sqlite3.c"
 $8 = (($7) + 25)|0; //@line 99706 "c/sqlite3.c"
 $9 = ($8|0)<(0); //@line 99706 "c/sqlite3.c"
 $10 = $9 << 31 >> 31; //@line 99706 "c/sqlite3.c"
 $11 = (_sqlite3MallocZero($8,$10)|0); //@line 99706 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 99707 "c/sqlite3.c"
 if ($12) {
  _sqlite3_result_error_nomem($0); //@line 99708 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 99777 "c/sqlite3.c"
 }
 $13 = HEAP32[$4>>2]|0; //@line 99712 "c/sqlite3.c"
 $14 = $vararg_buffer; //@line 99712 "c/sqlite3.c"
 $15 = $14; //@line 99712 "c/sqlite3.c"
 HEAP32[$15>>2] = $13; //@line 99712 "c/sqlite3.c"
 $16 = (($14) + 4)|0; //@line 99712 "c/sqlite3.c"
 $17 = $16; //@line 99712 "c/sqlite3.c"
 HEAP32[$17>>2] = 0; //@line 99712 "c/sqlite3.c"
 (_sqlite3_snprintf(24,$11,24535,$vararg_buffer)|0); //@line 99712 "c/sqlite3.c"
 $18 = HEAP32[$5>>2]|0; //@line 99714 "c/sqlite3.c"
 $19 = ($18|0)>(0); //@line 99714 "c/sqlite3.c"
 if ($19) {
  $20 = (_sqlite3Strlen30($11)|0); //@line 99713 "c/sqlite3.c"
  $21 = (($11) + ($20)|0); //@line 99713 "c/sqlite3.c"
  $22 = ((($4)) + 24|0);
  $$03436 = 0;$$037 = $21;
  while(1) {
   $23 = HEAP32[$22>>2]|0; //@line 99715 "c/sqlite3.c"
   $24 = (($23) + ($$03436<<2)|0); //@line 99715 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 99715 "c/sqlite3.c"
   $26 = (($25) + 1)|0; //@line 99715 "c/sqlite3.c"
   $27 = HEAP32[$4>>2]|0; //@line 99716 "c/sqlite3.c"
   $28 = (_i64Add(($26|0),0,-1,-1)|0); //@line 99716 "c/sqlite3.c"
   $29 = tempRet0; //@line 99716 "c/sqlite3.c"
   $30 = (_i64Add(($28|0),($29|0),($27|0),0)|0); //@line 99716 "c/sqlite3.c"
   $31 = tempRet0; //@line 99716 "c/sqlite3.c"
   $32 = (___udivdi3(($30|0),($31|0),($26|0),0)|0); //@line 99716 "c/sqlite3.c"
   $33 = tempRet0; //@line 99716 "c/sqlite3.c"
   $34 = $vararg_buffer1; //@line 99717 "c/sqlite3.c"
   $35 = $34; //@line 99717 "c/sqlite3.c"
   HEAP32[$35>>2] = $32; //@line 99717 "c/sqlite3.c"
   $36 = (($34) + 4)|0; //@line 99717 "c/sqlite3.c"
   $37 = $36; //@line 99717 "c/sqlite3.c"
   HEAP32[$37>>2] = $33; //@line 99717 "c/sqlite3.c"
   (_sqlite3_snprintf(24,$$037,24540,$vararg_buffer1)|0); //@line 99717 "c/sqlite3.c"
   $38 = (_sqlite3Strlen30($$037)|0); //@line 99718 "c/sqlite3.c"
   $39 = (($$037) + ($38)|0); //@line 99718 "c/sqlite3.c"
   $40 = (($$03436) + 1)|0; //@line 99714 "c/sqlite3.c"
   $41 = HEAP32[$5>>2]|0; //@line 99714 "c/sqlite3.c"
   $42 = ($40|0)<($41|0); //@line 99714 "c/sqlite3.c"
   if ($42) {
    $$03436 = $40;$$037 = $39;
   } else {
    break;
   }
  }
 }
 _sqlite3_result_text($0,$11,-1,83); //@line 99723 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 99777 "c/sqlite3.c"
}
function _statPush($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$031 = 0, $$134 = 0, $$232 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 99566 "c/sqlite3.c"
 $4 = (_sqlite3_value_blob($3)|0); //@line 99566 "c/sqlite3.c"
 $5 = ((($2)) + 4|0); //@line 99567 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 99567 "c/sqlite3.c"
 $7 = (_sqlite3_value_int($6)|0); //@line 99567 "c/sqlite3.c"
 $8 = HEAP32[$4>>2]|0; //@line 99574 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 99574 "c/sqlite3.c"
 if ($9) {
  $10 = ((($4)) + 8|0); //@line 99576 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 99576 "c/sqlite3.c"
  $12 = ($11|0)>(0); //@line 99576 "c/sqlite3.c"
  if ($12) {
   $13 = ((($4)) + 20|0);
   $14 = HEAP32[$13>>2]|0;
   $$031 = 0;
   while(1) {
    $15 = (($14) + ($$031<<2)|0); //@line 99576 "c/sqlite3.c"
    HEAP32[$15>>2] = 1; //@line 99576 "c/sqlite3.c"
    $16 = (($$031) + 1)|0; //@line 99576 "c/sqlite3.c"
    $17 = HEAP32[$10>>2]|0; //@line 99576 "c/sqlite3.c"
    $18 = ($16|0)<($17|0); //@line 99576 "c/sqlite3.c"
    if ($18) {
     $$031 = $16;
    } else {
     break;
    }
   }
  }
 } else {
  $19 = ($7|0)>(0); //@line 99583 "c/sqlite3.c"
  if ($19) {
   $20 = ((($4)) + 20|0);
   $21 = HEAP32[$20>>2]|0;
   $$134 = 0;
   while(1) {
    $22 = (($21) + ($$134<<2)|0); //@line 99584 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 99584 "c/sqlite3.c"
    $24 = (($23) + 1)|0; //@line 99584 "c/sqlite3.c"
    HEAP32[$22>>2] = $24; //@line 99584 "c/sqlite3.c"
    $25 = (($$134) + 1)|0; //@line 99583 "c/sqlite3.c"
    $exitcond = ($25|0)==($7|0); //@line 99583 "c/sqlite3.c"
    if ($exitcond) {
     break;
    } else {
     $$134 = $25;
    }
   }
  }
  $26 = ((($4)) + 8|0); //@line 99586 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 99586 "c/sqlite3.c"
  $28 = ($7|0)<($27|0); //@line 99586 "c/sqlite3.c"
  if ($28) {
   $29 = ((($4)) + 20|0);
   $30 = ((($4)) + 24|0);
   $31 = HEAP32[$30>>2]|0;
   $32 = HEAP32[$29>>2]|0;
   $$232 = $7;
   while(1) {
    $33 = (($31) + ($$232<<2)|0); //@line 99587 "c/sqlite3.c"
    $34 = HEAP32[$33>>2]|0; //@line 99587 "c/sqlite3.c"
    $35 = (($34) + 1)|0; //@line 99587 "c/sqlite3.c"
    HEAP32[$33>>2] = $35; //@line 99587 "c/sqlite3.c"
    $36 = (($32) + ($$232<<2)|0); //@line 99591 "c/sqlite3.c"
    HEAP32[$36>>2] = 1; //@line 99591 "c/sqlite3.c"
    $37 = (($$232) + 1)|0; //@line 99586 "c/sqlite3.c"
    $38 = HEAP32[$26>>2]|0; //@line 99586 "c/sqlite3.c"
    $39 = ($37|0)<($38|0); //@line 99586 "c/sqlite3.c"
    if ($39) {
     $$232 = $37;
    } else {
     break;
    }
   }
  }
 }
 $40 = HEAP32[$4>>2]|0; //@line 99594 "c/sqlite3.c"
 $41 = (($40) + 1)|0; //@line 99594 "c/sqlite3.c"
 HEAP32[$4>>2] = $41; //@line 99594 "c/sqlite3.c"
 return; //@line 99626 "c/sqlite3.c"
}
function _sqlite3VdbeChangeP2($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeGetOp($0,$1)|0); //@line 73777 "c/sqlite3.c"
 $4 = ((($3)) + 8|0); //@line 73777 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 73777 "c/sqlite3.c"
 return; //@line 73778 "c/sqlite3.c"
}
function _sqlite3VdbeGetOp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$05 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)<(0); //@line 74088 "c/sqlite3.c"
 if ($2) {
  $3 = ((($0)) + 136|0); //@line 74089 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 74089 "c/sqlite3.c"
  $5 = (($4) + -1)|0; //@line 74089 "c/sqlite3.c"
  $$0 = $5;
 } else {
  $$0 = $1;
 }
 $6 = HEAP32[$0>>2]|0; //@line 74092 "c/sqlite3.c"
 $7 = ((($6)) + 73|0); //@line 74092 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 74092 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 74092 "c/sqlite3.c"
 if (!($9)) {
  $$05 = 40428;
  return ($$05|0); //@line 74097 "c/sqlite3.c"
 }
 $10 = ((($0)) + 88|0); //@line 74095 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 74095 "c/sqlite3.c"
 $12 = (($11) + (($$0*20)|0)|0); //@line 74095 "c/sqlite3.c"
 $$05 = $12;
 return ($$05|0); //@line 74097 "c/sqlite3.c"
}
function _statInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $factor = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 99246 "c/sqlite3.c"
 $4 = (_sqlite3_value_int($3)|0); //@line 99246 "c/sqlite3.c"
 $5 = (($4) + 1)|0; //@line 99248 "c/sqlite3.c"
 $6 = $5 & -2; //@line 99248 "c/sqlite3.c"
 $7 = ((($2)) + 4|0); //@line 99249 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 99249 "c/sqlite3.c"
 $9 = (_sqlite3_value_int($8)|0); //@line 99249 "c/sqlite3.c"
 $factor = $6 << 3;
 $10 = (($factor) + 60)|0; //@line 99256 "c/sqlite3.c"
 $11 = (_sqlite3_context_db_handle($0)|0); //@line 99263 "c/sqlite3.c"
 $12 = ($10|0)<(0); //@line 99264 "c/sqlite3.c"
 $13 = $12 << 31 >> 31; //@line 99264 "c/sqlite3.c"
 $14 = (_sqlite3DbMallocZero($11,$10,$13)|0); //@line 99264 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 99265 "c/sqlite3.c"
 if ($15) {
  _sqlite3_result_error_nomem($0); //@line 99266 "c/sqlite3.c"
  return; //@line 99310 "c/sqlite3.c"
 } else {
  $16 = ((($14)) + 56|0); //@line 99270 "c/sqlite3.c"
  HEAP32[$16>>2] = $11; //@line 99270 "c/sqlite3.c"
  HEAP32[$14>>2] = 0; //@line 99271 "c/sqlite3.c"
  $17 = ((($14)) + 8|0); //@line 99272 "c/sqlite3.c"
  HEAP32[$17>>2] = $4; //@line 99272 "c/sqlite3.c"
  $18 = ((($14)) + 12|0); //@line 99273 "c/sqlite3.c"
  HEAP32[$18>>2] = $9; //@line 99273 "c/sqlite3.c"
  $19 = ((($14)) + 60|0); //@line 99274 "c/sqlite3.c"
  $20 = ((($14)) + 20|0); //@line 99274 "c/sqlite3.c"
  $21 = ((($14)) + 24|0); //@line 99274 "c/sqlite3.c"
  HEAP32[$21>>2] = $19; //@line 99274 "c/sqlite3.c"
  $22 = (($19) + ($6<<2)|0); //@line 99275 "c/sqlite3.c"
  HEAP32[$20>>2] = $22; //@line 99275 "c/sqlite3.c"
  _sqlite3_result_blob($0,$14,60,102); //@line 99309 "c/sqlite3.c"
  return; //@line 99310 "c/sqlite3.c"
 }
}
function _stat4Destructor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 56|0); //@line 99203 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 99203 "c/sqlite3.c"
 _sqlite3DbFree($2,$0); //@line 99203 "c/sqlite3.c"
 return; //@line 99204 "c/sqlite3.c"
}
function _sqlite3KeyInfoOfIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$039 = 0, $$04041 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 52|0); //@line 105971 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 105971 "c/sqlite3.c"
 $4 = $3&65535; //@line 105971 "c/sqlite3.c"
 $5 = ((($1)) + 50|0); //@line 105972 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 105972 "c/sqlite3.c"
 $7 = $6&65535; //@line 105972 "c/sqlite3.c"
 $8 = ((($0)) + 36|0); //@line 105974 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 105974 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 105974 "c/sqlite3.c"
 if (!($10)) {
  $$0 = 0;
  return ($$0|0); //@line 106006 "c/sqlite3.c"
 }
 $11 = ((($1)) + 55|0); //@line 105975 "c/sqlite3.c"
 $12 = HEAPU8[$11>>0]|(HEAPU8[$11+1>>0]<<8); //@line 105975 "c/sqlite3.c"
 $13 = $12 & 8; //@line 105975 "c/sqlite3.c"
 $14 = ($13<<16>>16)==(0); //@line 105975 "c/sqlite3.c"
 $15 = HEAP32[$0>>2]|0;
 if ($14) {
  $18 = (_sqlite3KeyInfoAlloc($15,$4,0)|0); //@line 105978 "c/sqlite3.c"
  $$039 = $18;
 } else {
  $16 = (($4) - ($7))|0; //@line 105976 "c/sqlite3.c"
  $17 = (_sqlite3KeyInfoAlloc($15,$7,$16)|0); //@line 105976 "c/sqlite3.c"
  $$039 = $17;
 }
 $19 = ($$039|0)==(0|0); //@line 105980 "c/sqlite3.c"
 if ($19) {
  $$0 = 0;
  return ($$0|0); //@line 106006 "c/sqlite3.c"
 }
 $20 = ($3<<16>>16)==(0); //@line 105982 "c/sqlite3.c"
 if (!($20)) {
  $21 = ((($1)) + 32|0);
  $22 = ((($1)) + 28|0);
  $23 = ((($$039)) + 16|0);
  $$04041 = 0;
  while(1) {
   $24 = HEAP32[$21>>2]|0; //@line 105983 "c/sqlite3.c"
   $25 = (($24) + ($$04041<<2)|0); //@line 105983 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 105983 "c/sqlite3.c"
   $27 = ($26|0)==(18038|0); //@line 105984 "c/sqlite3.c"
   if ($27) {
    $30 = 0;
   } else {
    $28 = (_sqlite3LocateCollSeq($0,$26)|0); //@line 105985 "c/sqlite3.c"
    $30 = $28;
   }
   $29 = (((($$039)) + 20|0) + ($$04041<<2)|0); //@line 105984 "c/sqlite3.c"
   HEAP32[$29>>2] = $30; //@line 105984 "c/sqlite3.c"
   $31 = HEAP32[$22>>2]|0; //@line 105986 "c/sqlite3.c"
   $32 = (($31) + ($$04041)|0); //@line 105986 "c/sqlite3.c"
   $33 = HEAP8[$32>>0]|0; //@line 105986 "c/sqlite3.c"
   $34 = HEAP32[$23>>2]|0; //@line 105986 "c/sqlite3.c"
   $35 = (($34) + ($$04041)|0); //@line 105986 "c/sqlite3.c"
   HEAP8[$35>>0] = $33; //@line 105986 "c/sqlite3.c"
   $36 = (($$04041) + 1)|0; //@line 105982 "c/sqlite3.c"
   $exitcond = ($36|0)==($4|0); //@line 105982 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$04041 = $36;
   }
  }
 }
 $37 = HEAP32[$8>>2]|0; //@line 105988 "c/sqlite3.c"
 $38 = ($37|0)==(0); //@line 105988 "c/sqlite3.c"
 if ($38) {
  $$0 = $$039;
  return ($$0|0); //@line 106006 "c/sqlite3.c"
 }
 $39 = HEAPU8[$11>>0]|(HEAPU8[$11+1>>0]<<8); //@line 105990 "c/sqlite3.c"
 $40 = $39 & 256; //@line 105990 "c/sqlite3.c"
 $41 = ($40<<16>>16)==(0); //@line 105990 "c/sqlite3.c"
 if ($41) {
  $42 = ((($0)) + 12|0); //@line 105999 "c/sqlite3.c"
  $43 = $39 | 256; //@line 105998 "c/sqlite3.c"
  HEAP8[$11>>0]=$43&255;HEAP8[$11+1>>0]=$43>>8; //@line 105998 "c/sqlite3.c"
  HEAP32[$42>>2] = 513; //@line 105999 "c/sqlite3.c"
 }
 _sqlite3KeyInfoUnref($$039); //@line 106001 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 106006 "c/sqlite3.c"
}
function _sqlite3VdbeAppendP4($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 74001 "c/sqlite3.c"
 $4 = ((($3)) + 73|0); //@line 74001 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 74001 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 74001 "c/sqlite3.c"
 if ($6) {
  $7 = ((($0)) + 88|0); //@line 74006 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 74006 "c/sqlite3.c"
  $9 = ((($0)) + 136|0); //@line 74006 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 74006 "c/sqlite3.c"
  $11 = (($10) + -1)|0; //@line 74006 "c/sqlite3.c"
  $12 = $2&255; //@line 74008 "c/sqlite3.c"
  $13 = (((($8) + (($11*20)|0)|0)) + 1|0); //@line 74008 "c/sqlite3.c"
  HEAP8[$13>>0] = $12; //@line 74008 "c/sqlite3.c"
  $14 = (((($8) + (($11*20)|0)|0)) + 16|0); //@line 74009 "c/sqlite3.c"
  HEAP32[$14>>2] = $1; //@line 74009 "c/sqlite3.c"
  return; //@line 74011 "c/sqlite3.c"
 } else {
  _freeP4($3,$2,$1); //@line 74002 "c/sqlite3.c"
  return; //@line 74011 "c/sqlite3.c"
 }
}
function _sqlite3KeyInfoAlloc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (($2) + ($1))|0; //@line 119716 "c/sqlite3.c"
 $4 = ($3*5)|0; //@line 119716 "c/sqlite3.c"
 $5 = (($4) + 20)|0; //@line 119717 "c/sqlite3.c"
 $6 = (_sqlite3DbMallocRawNN($0,$5,0)|0); //@line 119717 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 119718 "c/sqlite3.c"
 if ($7) {
  _sqlite3OomFault($0); //@line 119727 "c/sqlite3.c"
  return ($6|0); //@line 119729 "c/sqlite3.c"
 } else {
  $8 = (($4) + -4)|0; //@line 119716 "c/sqlite3.c"
  $9 = ((($6)) + 20|0); //@line 119719 "c/sqlite3.c"
  $10 = (($9) + ($3<<2)|0); //@line 119719 "c/sqlite3.c"
  $11 = ((($6)) + 16|0); //@line 119719 "c/sqlite3.c"
  HEAP32[$11>>2] = $10; //@line 119719 "c/sqlite3.c"
  $12 = $1&65535; //@line 119720 "c/sqlite3.c"
  $13 = ((($6)) + 6|0); //@line 119720 "c/sqlite3.c"
  HEAP16[$13>>1] = $12; //@line 119720 "c/sqlite3.c"
  $14 = $3&65535; //@line 119721 "c/sqlite3.c"
  $15 = ((($6)) + 8|0); //@line 119721 "c/sqlite3.c"
  HEAP16[$15>>1] = $14; //@line 119721 "c/sqlite3.c"
  $16 = ((($0)) + 70|0); //@line 119722 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 119722 "c/sqlite3.c"
  $18 = ((($6)) + 4|0); //@line 119722 "c/sqlite3.c"
  HEAP8[$18>>0] = $17; //@line 119722 "c/sqlite3.c"
  $19 = ((($6)) + 12|0); //@line 119723 "c/sqlite3.c"
  HEAP32[$19>>2] = $0; //@line 119723 "c/sqlite3.c"
  HEAP32[$6>>2] = 1; //@line 119724 "c/sqlite3.c"
  $20 = ((($6)) + 24|0); //@line 119725 "c/sqlite3.c"
  _memset(($20|0),0,($8|0))|0; //@line 119725 "c/sqlite3.c"
  return ($6|0); //@line 119729 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeAddOp4Int($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = (_sqlite3VdbeAddOp3($0,$1,$2,$3,$4)|0); //@line 73291 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 73292 "c/sqlite3.c"
 $8 = ((($7)) + 73|0); //@line 73292 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 73292 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 73292 "c/sqlite3.c"
 if (!($10)) {
  return ($6|0); //@line 73297 "c/sqlite3.c"
 }
 $11 = ((($0)) + 88|0); //@line 73293 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 73293 "c/sqlite3.c"
 $13 = (((($12) + (($6*20)|0)|0)) + 1|0); //@line 73294 "c/sqlite3.c"
 HEAP8[$13>>0] = -3; //@line 73294 "c/sqlite3.c"
 $14 = (((($12) + (($6*20)|0)|0)) + 16|0); //@line 73295 "c/sqlite3.c"
 HEAP32[$14>>2] = $5; //@line 73295 "c/sqlite3.c"
 return ($6|0); //@line 73297 "c/sqlite3.c"
}
function _reindexDatabases($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$021 = 0, $$02123 = 0, $$02124 = 0, $$02225 = 0, $$026 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 105880 "c/sqlite3.c"
 $3 = ((($2)) + 20|0); //@line 105885 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 105885 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 105885 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 105892 "c/sqlite3.c"
 }
 $6 = ((($2)) + 16|0); //@line 105885 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 105885 "c/sqlite3.c"
 $$02225 = 0;$$026 = $7;
 while(1) {
  $8 = ((($$026)) + 12|0); //@line 105887 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 105887 "c/sqlite3.c"
  $10 = ((($9)) + 16|0); //@line 105887 "c/sqlite3.c"
  $$02123 = HEAP32[$10>>2]|0;
  $11 = ($$02123|0)==(0|0); //@line 105887 "c/sqlite3.c"
  if (!($11)) {
   $$02124 = $$02123;
   while(1) {
    $12 = ((($$02124)) + 8|0); //@line 105888 "c/sqlite3.c"
    $13 = HEAP32[$12>>2]|0; //@line 105888 "c/sqlite3.c"
    _reindexTable($0,$13,$1); //@line 105889 "c/sqlite3.c"
    $$021 = HEAP32[$$02124>>2]|0;
    $14 = ($$021|0)==(0|0); //@line 105887 "c/sqlite3.c"
    if ($14) {
     break;
    } else {
     $$02124 = $$021;
    }
   }
  }
  $15 = (($$02225) + 1)|0; //@line 105885 "c/sqlite3.c"
  $16 = ((($$026)) + 16|0); //@line 105885 "c/sqlite3.c"
  $17 = HEAP32[$3>>2]|0; //@line 105885 "c/sqlite3.c"
  $18 = ($15|0)<($17|0); //@line 105885 "c/sqlite3.c"
  if ($18) {
   $$02225 = $15;$$026 = $16;
  } else {
   break;
  }
 }
 return; //@line 105892 "c/sqlite3.c"
}
function _reindexTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$014 = 0, $$015 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 8|0); //@line 105861 "c/sqlite3.c"
 $$014 = HEAP32[$3>>2]|0;
 $4 = ($$014|0)==(0|0); //@line 105861 "c/sqlite3.c"
 if ($4) {
  return; //@line 105868 "c/sqlite3.c"
 }
 $5 = ($2|0)==(0|0);
 $6 = ((($1)) + 72|0);
 $$015 = $$014;
 while(1) {
  if ($5) {
   label = 5;
  } else {
   $7 = (_collationMatch($2,$$015)|0); //@line 105862 "c/sqlite3.c"
   $8 = ($7|0)==(0); //@line 105862 "c/sqlite3.c"
   if (!($8)) {
    label = 5;
   }
  }
  if ((label|0) == 5) {
   label = 0;
   $9 = HEAP32[$0>>2]|0; //@line 105863 "c/sqlite3.c"
   $10 = HEAP32[$6>>2]|0; //@line 105863 "c/sqlite3.c"
   $11 = (_sqlite3SchemaToIndex($9,$10)|0); //@line 105863 "c/sqlite3.c"
   _sqlite3BeginWriteOperation($0,0,$11); //@line 105864 "c/sqlite3.c"
   _sqlite3RefillIndex($0,$$015,-1); //@line 105865 "c/sqlite3.c"
  }
  $12 = ((($$015)) + 20|0); //@line 105861 "c/sqlite3.c"
  $$0 = HEAP32[$12>>2]|0;
  $13 = ($$0|0)==(0|0); //@line 105861 "c/sqlite3.c"
  if ($13) {
   break;
  } else {
   $$015 = $$0;
  }
 }
 return; //@line 105868 "c/sqlite3.c"
}
function _sqlite3RefillIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0119 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($1)) + 12|0); //@line 104390 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 104390 "c/sqlite3.c"
 $6 = ((($0)) + 40|0); //@line 104391 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 104391 "c/sqlite3.c"
 $8 = (($7) + 1)|0; //@line 104391 "c/sqlite3.c"
 $9 = (($7) + 2)|0; //@line 104392 "c/sqlite3.c"
 HEAP32[$6>>2] = $9; //@line 104392 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 104401 "c/sqlite3.c"
 $11 = ((($1)) + 24|0); //@line 104402 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 104402 "c/sqlite3.c"
 $13 = (_sqlite3SchemaToIndex($10,$12)|0); //@line 104402 "c/sqlite3.c"
 $14 = HEAP32[$1>>2]|0; //@line 104405 "c/sqlite3.c"
 $15 = ((($10)) + 16|0); //@line 104406 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 104406 "c/sqlite3.c"
 $17 = (($16) + ($13<<4)|0); //@line 104406 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 104406 "c/sqlite3.c"
 $19 = (_sqlite3AuthCheck($0,27,$14,0,$18)|0); //@line 104405 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 104405 "c/sqlite3.c"
 if (!($20)) {
  STACKTOP = sp;return; //@line 104467 "c/sqlite3.c"
 }
 $21 = ((($5)) + 28|0); //@line 104412 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 104412 "c/sqlite3.c"
 $23 = HEAP32[$5>>2]|0; //@line 104412 "c/sqlite3.c"
 _sqlite3TableLock($0,$13,$22,1,$23); //@line 104412 "c/sqlite3.c"
 $24 = (_sqlite3GetVdbe($0)|0); //@line 104414 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 104415 "c/sqlite3.c"
 if ($25) {
  STACKTOP = sp;return; //@line 104467 "c/sqlite3.c"
 }
 $26 = ($2|0)>(-1); //@line 104416 "c/sqlite3.c"
 if ($26) {
  $$0119 = $2;
 } else {
  $27 = ((($1)) + 44|0); //@line 104419 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 104419 "c/sqlite3.c"
  $$0119 = $28;
 }
 $29 = (_sqlite3KeyInfoOfIndex($0,$1)|0); //@line 104421 "c/sqlite3.c"
 $30 = HEAP32[$6>>2]|0; //@line 104425 "c/sqlite3.c"
 $31 = (($30) + 1)|0; //@line 104425 "c/sqlite3.c"
 HEAP32[$6>>2] = $31; //@line 104425 "c/sqlite3.c"
 $32 = ((($1)) + 50|0); //@line 104426 "c/sqlite3.c"
 $33 = HEAP16[$32>>1]|0; //@line 104426 "c/sqlite3.c"
 $34 = $33&65535; //@line 104426 "c/sqlite3.c"
 $35 = (_sqlite3KeyInfoRef($29)|0); //@line 104427 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($24,110,$30,0,$34,$29,-9)|0); //@line 104426 "c/sqlite3.c"
 _sqlite3OpenTable($0,$7,$13,$5,105); //@line 104431 "c/sqlite3.c"
 $36 = (_sqlite3VdbeAddOp2($24,37,$7,0)|0); //@line 104432 "c/sqlite3.c"
 $37 = (_sqlite3GetTempReg($0)|0); //@line 104433 "c/sqlite3.c"
 (_sqlite3GenerateIndexKey($0,$1,$7,$37,0,$3,0,0)|0); //@line 104435 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($24,127,$30,$37)|0); //@line 104436 "c/sqlite3.c"
 $38 = HEAP32[$3>>2]|0; //@line 104437 "c/sqlite3.c"
 _sqlite3ResolvePartIdxLabel($0,$38); //@line 104437 "c/sqlite3.c"
 $39 = (($36) + 1)|0; //@line 104438 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($24,7,$7,$39)|0); //@line 104438 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($24,$36); //@line 104439 "c/sqlite3.c"
 $40 = ($2|0)<(0); //@line 104440 "c/sqlite3.c"
 if ($40) {
  (_sqlite3VdbeAddOp2($24,134,$$0119,$13)|0); //@line 104440 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp4($24,106,$8,$$0119,$13,$29,-9)|0); //@line 104441 "c/sqlite3.c"
 $41 = $2 >> 31; //@line 104443 "c/sqlite3.c"
 $42 = (($41) + 16)|0; //@line 104443 "c/sqlite3.c"
 $43 = $42 & 65520; //@line 104443 "c/sqlite3.c"
 $44 = $43 | 1; //@line 104443 "c/sqlite3.c"
 $45 = $44&65535; //@line 104443 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($24,$45); //@line 104443 "c/sqlite3.c"
 $46 = (_sqlite3VdbeAddOp2($24,35,$30,0)|0); //@line 104445 "c/sqlite3.c"
 $47 = ((($1)) + 54|0); //@line 104446 "c/sqlite3.c"
 $48 = HEAP8[$47>>0]|0; //@line 104446 "c/sqlite3.c"
 $49 = ($48<<24>>24)==(0); //@line 104446 "c/sqlite3.c"
 $50 = (_sqlite3VdbeCurrentAddr($24)|0);
 if ($49) {
  $$0 = $50;
 } else {
  $51 = (($50) + 3)|0; //@line 104447 "c/sqlite3.c"
  _sqlite3VdbeGoto($24,$51); //@line 104448 "c/sqlite3.c"
  $52 = (_sqlite3VdbeCurrentAddr($24)|0); //@line 104449 "c/sqlite3.c"
  $53 = HEAP16[$32>>1]|0; //@line 104451 "c/sqlite3.c"
  $54 = $53&65535; //@line 104451 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4Int($24,121,$30,$51,$37,$54)|0); //@line 104450 "c/sqlite3.c"
  _sqlite3UniqueConstraint($0,2,$1); //@line 104452 "c/sqlite3.c"
  $$0 = $52;
 }
 (_sqlite3VdbeAddOp3($24,122,$30,$37,$8)|0); //@line 104456 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($24,126,$8)|0); //@line 104457 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($24,128,$8,$37)|0); //@line 104458 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($24,16); //@line 104459 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$37); //@line 104460 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($24,3,$30,$$0)|0); //@line 104461 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($24,$46); //@line 104462 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($24,113,$7)|0); //@line 104464 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($24,113,$8)|0); //@line 104465 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($24,113,$30)|0); //@line 104466 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 104467 "c/sqlite3.c"
}
function _sqlite3KeyInfoRef($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 119747 "c/sqlite3.c"
 if ($1) {
  return ($0|0); //@line 119751 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 119749 "c/sqlite3.c"
 $3 = (($2) + 1)|0; //@line 119749 "c/sqlite3.c"
 HEAP32[$0>>2] = $3; //@line 119749 "c/sqlite3.c"
 return ($0|0); //@line 119751 "c/sqlite3.c"
}
function _sqlite3GenerateIndexKey($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0 = 0, $$06263 = 0, $$sink = 0, $$sink65 = 0, $$sink65$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = ((($0)) + 8|0); //@line 107452 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 107452 "c/sqlite3.c"
 $10 = ($5|0)==(0|0); //@line 107457 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($1)) + 36|0); //@line 107458 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 107458 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 107458 "c/sqlite3.c"
  if ($13) {
   $$sink = $5;
  } else {
   $14 = (_sqlite3VdbeMakeLabel($9)|0); //@line 107459 "c/sqlite3.c"
   HEAP32[$5>>2] = $14; //@line 107459 "c/sqlite3.c"
   $15 = (($2) + 1)|0; //@line 107460 "c/sqlite3.c"
   $16 = ((($0)) + 56|0); //@line 107460 "c/sqlite3.c"
   HEAP32[$16>>2] = $15; //@line 107460 "c/sqlite3.c"
   _sqlite3ExprCachePush($0); //@line 107461 "c/sqlite3.c"
   $17 = HEAP32[$11>>2]|0; //@line 107462 "c/sqlite3.c"
   $18 = HEAP32[$5>>2]|0; //@line 107462 "c/sqlite3.c"
   _sqlite3ExprIfFalseDup($0,$17,$18); //@line 107462 "c/sqlite3.c"
   $$sink = $16;
  }
  HEAP32[$$sink>>2] = 0;
 }
 $19 = ($4|0)==(0); //@line 107469 "c/sqlite3.c"
 if ($19) {
  label = 8;
 } else {
  $20 = ((($1)) + 55|0); //@line 107469 "c/sqlite3.c"
  $21 = HEAPU8[$20>>0]|(HEAPU8[$20+1>>0]<<8); //@line 107469 "c/sqlite3.c"
  $22 = $21 & 8; //@line 107469 "c/sqlite3.c"
  $23 = ($22<<16>>16)==(0); //@line 107469 "c/sqlite3.c"
  if ($23) {
   label = 8;
  } else {
   $24 = ((($1)) + 50|0); //@line 107469 "c/sqlite3.c"
   $$sink65$in = $24;
  }
 }
 if ((label|0) == 8) {
  $25 = ((($1)) + 52|0); //@line 107469 "c/sqlite3.c"
  $$sink65$in = $25;
 }
 $$sink65 = HEAP16[$$sink65$in>>1]|0;
 $26 = $$sink65&65535;
 $27 = (_sqlite3GetTempRange($0,$26)|0); //@line 107470 "c/sqlite3.c"
 $28 = ($6|0)==(0|0); //@line 107471 "c/sqlite3.c"
 do {
  if ($28) {
   $$0 = 0;
  } else {
   $29 = ($27|0)==($7|0); //@line 107471 "c/sqlite3.c"
   if ($29) {
    $30 = ((($6)) + 36|0); //@line 107471 "c/sqlite3.c"
    $31 = HEAP32[$30>>2]|0; //@line 107471 "c/sqlite3.c"
    $32 = ($31|0)==(0|0); //@line 107471 "c/sqlite3.c"
    if ($32) {
     $$0 = $6;
     break;
    }
   }
   $$0 = 0;
  }
 } while(0);
 $33 = ($$sink65<<16>>16)==(0); //@line 107472 "c/sqlite3.c"
 if (!($33)) {
  $34 = ($$0|0)==(0|0);
  $35 = ((($$0)) + 4|0);
  $36 = ((($1)) + 4|0);
  $$06263 = 0;
  while(1) {
   if ($34) {
    label = 17;
   } else {
    $37 = HEAP32[$35>>2]|0; //@line 107474 "c/sqlite3.c"
    $38 = (($37) + ($$06263<<1)|0); //@line 107474 "c/sqlite3.c"
    $39 = HEAP16[$38>>1]|0; //@line 107474 "c/sqlite3.c"
    $40 = HEAP32[$36>>2]|0; //@line 107474 "c/sqlite3.c"
    $41 = (($40) + ($$06263<<1)|0); //@line 107474 "c/sqlite3.c"
    $42 = HEAP16[$41>>1]|0; //@line 107474 "c/sqlite3.c"
    $43 = ($39<<16>>16)!=($42<<16>>16); //@line 107474 "c/sqlite3.c"
    $44 = ($39<<16>>16)==(-2); //@line 107475 "c/sqlite3.c"
    $or$cond = $44 | $43; //@line 107475 "c/sqlite3.c"
    if ($or$cond) {
     label = 17;
    }
   }
   if ((label|0) == 17) {
    label = 0;
    $45 = (($$06263) + ($27))|0; //@line 107480 "c/sqlite3.c"
    _sqlite3ExprCodeLoadIndexColumn($0,$1,$2,$$06263,$45); //@line 107480 "c/sqlite3.c"
    _sqlite3VdbeDeletePriorOpcode($9); //@line 107487 "c/sqlite3.c"
   }
   $46 = (($$06263) + 1)|0; //@line 107472 "c/sqlite3.c"
   $exitcond = ($46|0)==($26|0); //@line 107472 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$06263 = $46;
   }
  }
 }
 $47 = ($3|0)==(0); //@line 107489 "c/sqlite3.c"
 if ($47) {
  _sqlite3ReleaseTempRange($0,$27,$26); //@line 107496 "c/sqlite3.c"
  return ($27|0); //@line 107497 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp3($9,100,$27,$26,$3)|0); //@line 107490 "c/sqlite3.c"
 $48 = ((($1)) + 12|0); //@line 107491 "c/sqlite3.c"
 $49 = HEAP32[$48>>2]|0; //@line 107491 "c/sqlite3.c"
 $50 = ((($49)) + 12|0); //@line 107491 "c/sqlite3.c"
 $51 = HEAP32[$50>>2]|0; //@line 107491 "c/sqlite3.c"
 $52 = ($51|0)==(0|0); //@line 107491 "c/sqlite3.c"
 if ($52) {
  _sqlite3ReleaseTempRange($0,$27,$26); //@line 107496 "c/sqlite3.c"
  return ($27|0); //@line 107497 "c/sqlite3.c"
 }
 $53 = HEAP32[$0>>2]|0; //@line 107492 "c/sqlite3.c"
 $54 = (_sqlite3IndexAffinityStr($53,$1)|0); //@line 107492 "c/sqlite3.c"
 _sqlite3VdbeChangeP4($9,-1,$54,0); //@line 107493 "c/sqlite3.c"
 _sqlite3ReleaseTempRange($0,$27,$26); //@line 107496 "c/sqlite3.c"
 return ($27|0); //@line 107497 "c/sqlite3.c"
}
function _sqlite3ResolvePartIdxLabel($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 107506 "c/sqlite3.c"
 if ($2) {
  return; //@line 107510 "c/sqlite3.c"
 }
 $3 = ((($0)) + 8|0); //@line 107507 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 107507 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($4,$1); //@line 107507 "c/sqlite3.c"
 _sqlite3ExprCachePop($0); //@line 107508 "c/sqlite3.c"
 return; //@line 107510 "c/sqlite3.c"
}
function _sqlite3UniqueConstraint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$023 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 8|0;
 $4 = ((($2)) + 12|0); //@line 105788 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 105788 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 105790 "c/sqlite3.c"
 _sqlite3StrAccumInit($3,$6,0,0,200); //@line 105790 "c/sqlite3.c"
 $7 = ((($2)) + 40|0); //@line 105791 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 105791 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 105791 "c/sqlite3.c"
 if ($9) {
  $11 = ((($2)) + 50|0); //@line 105794 "c/sqlite3.c"
  $12 = HEAP16[$11>>1]|0; //@line 105794 "c/sqlite3.c"
  $13 = ($12<<16>>16)==(0); //@line 105794 "c/sqlite3.c"
  if (!($13)) {
   $14 = ((($5)) + 4|0);
   $15 = ((($2)) + 4|0);
   $$023 = 0;
   while(1) {
    $16 = HEAP32[$14>>2]|0; //@line 105797 "c/sqlite3.c"
    $17 = HEAP32[$15>>2]|0; //@line 105797 "c/sqlite3.c"
    $18 = (($17) + ($$023<<1)|0); //@line 105797 "c/sqlite3.c"
    $19 = HEAP16[$18>>1]|0; //@line 105797 "c/sqlite3.c"
    $20 = $19 << 16 >> 16; //@line 105797 "c/sqlite3.c"
    $21 = (($16) + ($20<<4)|0); //@line 105797 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 105797 "c/sqlite3.c"
    $23 = ($$023|0)==(0); //@line 105798 "c/sqlite3.c"
    if (!($23)) {
     _sqlite3StrAccumAppend($3,24752,2); //@line 105798 "c/sqlite3.c"
    }
    $24 = HEAP32[$5>>2]|0; //@line 105799 "c/sqlite3.c"
    _sqlite3StrAccumAppendAll($3,$24); //@line 105799 "c/sqlite3.c"
    _sqlite3StrAccumAppend($3,15402,1); //@line 105800 "c/sqlite3.c"
    _sqlite3StrAccumAppendAll($3,$22); //@line 105801 "c/sqlite3.c"
    $25 = (($$023) + 1)|0; //@line 105794 "c/sqlite3.c"
    $26 = HEAP16[$11>>1]|0; //@line 105794 "c/sqlite3.c"
    $27 = $26&65535; //@line 105794 "c/sqlite3.c"
    $28 = ($25>>>0)<($27>>>0); //@line 105794 "c/sqlite3.c"
    if ($28) {
     $$023 = $25;
    } else {
     break;
    }
   }
  }
 } else {
  $10 = HEAP32[$2>>2]|0; //@line 105792 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $10; //@line 105792 "c/sqlite3.c"
  _sqlite3XPrintf($3,24741,$vararg_buffer); //@line 105792 "c/sqlite3.c"
 }
 $29 = (_sqlite3StrAccumFinish($3)|0); //@line 105804 "c/sqlite3.c"
 $30 = ((($2)) + 55|0); //@line 105806 "c/sqlite3.c"
 $31 = HEAPU8[$30>>0]|(HEAPU8[$30+1>>0]<<8); //@line 105806 "c/sqlite3.c"
 $32 = $31 & 3; //@line 105806 "c/sqlite3.c"
 $33 = ($32<<16>>16)==(2); //@line 105806 "c/sqlite3.c"
 $34 = $33 ? 1555 : 2067; //@line 105806 "c/sqlite3.c"
 _sqlite3HaltConstraint($0,$34,$1,$29,-7,2); //@line 105805 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 105809 "c/sqlite3.c"
}
function _sqlite3HaltConstraint($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = (_sqlite3GetVdbe($0)|0); //@line 105768 "c/sqlite3.c"
 $7 = ($2|0)==(2); //@line 105770 "c/sqlite3.c"
 if ($7) {
  _sqlite3MayAbort($0); //@line 105771 "c/sqlite3.c"
 }
 $8 = $4 << 24 >> 24; //@line 105773 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($6,66,$1,$2,0,$3,$8)|0); //@line 105773 "c/sqlite3.c"
 $9 = $5&255; //@line 105774 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($6,$9); //@line 105774 "c/sqlite3.c"
 return; //@line 105775 "c/sqlite3.c"
}
function _sqlite3ExprCachePop($0) {
 $0 = $0|0;
 var $$09 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 60|0); //@line 95925 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 95925 "c/sqlite3.c"
 $3 = (($2) + -1)|0; //@line 95925 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 95925 "c/sqlite3.c"
 $4 = ((($0)) + 25|0); //@line 95931 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 95931 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 95931 "c/sqlite3.c"
 if ($6) {
  return; //@line 95938 "c/sqlite3.c"
 }
 $$09 = 0;
 while(1) {
  $7 = (((((($0)) + 148|0) + (($$09*20)|0)|0)) + 8|0); //@line 95932 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 95932 "c/sqlite3.c"
  $9 = HEAP32[$1>>2]|0; //@line 95932 "c/sqlite3.c"
  $10 = ($8|0)>($9|0); //@line 95932 "c/sqlite3.c"
  if ($10) {
   _cacheEntryClear($0,$$09); //@line 95933 "c/sqlite3.c"
   $$1 = $$09;
  } else {
   $11 = (($$09) + 1)|0; //@line 95935 "c/sqlite3.c"
   $$1 = $11;
  }
  $12 = HEAP8[$4>>0]|0; //@line 95931 "c/sqlite3.c"
  $13 = $12&255; //@line 95931 "c/sqlite3.c"
  $14 = ($$1|0)<($13|0); //@line 95931 "c/sqlite3.c"
  if ($14) {
   $$09 = $$1;
  } else {
   break;
  }
 }
 return; //@line 95938 "c/sqlite3.c"
}
function _cacheEntryClear($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (((($0)) + 148|0) + (($1*20)|0)|0); //@line 95820 "c/sqlite3.c"
 $3 = (((((($0)) + 148|0) + (($1*20)|0)|0)) + 6|0); //@line 95820 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 95820 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 95820 "c/sqlite3.c"
 if (!($5)) {
  $6 = ((($0)) + 19|0); //@line 95821 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 95821 "c/sqlite3.c"
  $8 = ($7&255)<(8); //@line 95821 "c/sqlite3.c"
  if ($8) {
   $9 = $7&255; //@line 95821 "c/sqlite3.c"
   $10 = (((($0)) + 348|0) + ($9<<2)|0); //@line 95822 "c/sqlite3.c"
   $11 = (($7) + 1)<<24>>24; //@line 95822 "c/sqlite3.c"
   $12 = (((((($0)) + 148|0) + (($1*20)|0)|0)) + 12|0); //@line 95822 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 95822 "c/sqlite3.c"
   HEAP8[$6>>0] = $11; //@line 95822 "c/sqlite3.c"
   HEAP32[$10>>2] = $13; //@line 95822 "c/sqlite3.c"
  }
 }
 $14 = ((($0)) + 25|0); //@line 95825 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 95825 "c/sqlite3.c"
 $16 = (($15) + -1)<<24>>24; //@line 95825 "c/sqlite3.c"
 HEAP8[$14>>0] = $16; //@line 95825 "c/sqlite3.c"
 $17 = $16&255; //@line 95826 "c/sqlite3.c"
 $18 = ($17|0)>($1|0); //@line 95826 "c/sqlite3.c"
 if (!($18)) {
  return; //@line 95829 "c/sqlite3.c"
 }
 $19 = (((($0)) + 148|0) + (($17*20)|0)|0); //@line 95827 "c/sqlite3.c"
 ;HEAP32[$2>>2]=HEAP32[$19>>2]|0;HEAP32[$2+4>>2]=HEAP32[$19+4>>2]|0;HEAP32[$2+8>>2]=HEAP32[$19+8>>2]|0;HEAP32[$2+12>>2]=HEAP32[$19+12>>2]|0;HEAP32[$2+16>>2]=HEAP32[$19+16>>2]|0; //@line 95827 "c/sqlite3.c"
 return; //@line 95829 "c/sqlite3.c"
}
function _sqlite3ExprCachePush($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 60|0); //@line 95909 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 95909 "c/sqlite3.c"
 $3 = (($2) + 1)|0; //@line 95909 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 95909 "c/sqlite3.c"
 return; //@line 95915 "c/sqlite3.c"
}
function _sqlite3ExprIfFalseDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 97402 "c/sqlite3.c"
 $4 = (_sqlite3ExprDup($3,$1,0)|0); //@line 97403 "c/sqlite3.c"
 $5 = ((($3)) + 73|0); //@line 97404 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 97404 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 97404 "c/sqlite3.c"
 if ($7) {
  _sqlite3ExprIfFalse($0,$4,$2,16); //@line 97405 "c/sqlite3.c"
 }
 _sqlite3ExprDelete($3,$4); //@line 97407 "c/sqlite3.c"
 return; //@line 97408 "c/sqlite3.c"
}
function _sqlite3GetTempRange($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(1); //@line 97962 "c/sqlite3.c"
 if ($2) {
  $3 = (_sqlite3GetTempReg($0)|0); //@line 97962 "c/sqlite3.c"
  $$0 = $3;
  return ($$0|0); //@line 97974 "c/sqlite3.c"
 }
 $4 = ((($0)) + 32|0); //@line 97963 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 97963 "c/sqlite3.c"
 $6 = ((($0)) + 28|0); //@line 97964 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 97964 "c/sqlite3.c"
 $8 = ($7|0)<($1|0); //@line 97965 "c/sqlite3.c"
 if ($8) {
  $11 = ((($0)) + 44|0); //@line 97970 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 97970 "c/sqlite3.c"
  $13 = (($12) + 1)|0; //@line 97970 "c/sqlite3.c"
  $14 = (($12) + ($1))|0; //@line 97971 "c/sqlite3.c"
  HEAP32[$11>>2] = $14; //@line 97971 "c/sqlite3.c"
  $$0 = $13;
  return ($$0|0); //@line 97974 "c/sqlite3.c"
 } else {
  $9 = (($5) + ($1))|0; //@line 97967 "c/sqlite3.c"
  HEAP32[$4>>2] = $9; //@line 97967 "c/sqlite3.c"
  $10 = (($7) - ($1))|0; //@line 97968 "c/sqlite3.c"
  HEAP32[$6>>2] = $10; //@line 97968 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 97974 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprCodeLoadIndexColumn($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($1)) + 4|0); //@line 95966 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 95966 "c/sqlite3.c"
 $7 = (($6) + ($3<<1)|0); //@line 95966 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 95966 "c/sqlite3.c"
 $9 = ($8<<16>>16)==(-2); //@line 95967 "c/sqlite3.c"
 if ($9) {
  $10 = (($2) + 1)|0; //@line 95970 "c/sqlite3.c"
  $11 = ((($0)) + 56|0); //@line 95970 "c/sqlite3.c"
  HEAP32[$11>>2] = $10; //@line 95970 "c/sqlite3.c"
  $12 = ((($1)) + 40|0); //@line 95971 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 95971 "c/sqlite3.c"
  $14 = (((($13)) + 4|0) + (($3*20)|0)|0); //@line 95971 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 95971 "c/sqlite3.c"
  _sqlite3ExprCodeCopy($0,$15,$4); //@line 95971 "c/sqlite3.c"
  HEAP32[$11>>2] = 0; //@line 95972 "c/sqlite3.c"
  return; //@line 95977 "c/sqlite3.c"
 } else {
  $16 = $8 << 16 >> 16; //@line 95967 "c/sqlite3.c"
  $17 = ((($0)) + 8|0); //@line 95974 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 95974 "c/sqlite3.c"
  $19 = ((($1)) + 12|0); //@line 95974 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 95974 "c/sqlite3.c"
  _sqlite3ExprCodeGetColumnOfTable($18,$20,$2,$16,$4); //@line 95974 "c/sqlite3.c"
  return; //@line 95977 "c/sqlite3.c"
 }
}
function _sqlite3VdbeDeletePriorOpcode($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 136|0); //@line 73911 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 73911 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 73911 "c/sqlite3.c"
 if (!($3)) {
  return;
 }
 $4 = ((($0)) + 88|0); //@line 73911 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 73911 "c/sqlite3.c"
 $6 = (($2) + -1)|0; //@line 73911 "c/sqlite3.c"
 $7 = (($5) + (($6*20)|0)|0); //@line 73911 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 73911 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(81); //@line 73911 "c/sqlite3.c"
 if (!($9)) {
  return;
 }
 (_sqlite3VdbeChangeToNoop($0,$6)|0); //@line 73912 "c/sqlite3.c"
 return;
}
function _sqlite3IndexAffinityStr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$034$lcssa = 0, $$03436 = 0, $$1 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 16|0); //@line 110910 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 110910 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 110910 "c/sqlite3.c"
 if ($4) {
  $5 = ((($1)) + 12|0); //@line 110920 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 110920 "c/sqlite3.c"
  $7 = ((($1)) + 52|0); //@line 110921 "c/sqlite3.c"
  $8 = HEAP16[$7>>1]|0; //@line 110921 "c/sqlite3.c"
  $9 = $8&65535; //@line 110921 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 110921 "c/sqlite3.c"
  $11 = (_sqlite3DbMallocRaw(0,$10,0)|0); //@line 110921 "c/sqlite3.c"
  HEAP32[$2>>2] = $11; //@line 110921 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 110922 "c/sqlite3.c"
  if ($12) {
   _sqlite3OomFault($0); //@line 110923 "c/sqlite3.c"
   $$1 = 0;
   return ($$1|0); //@line 110945 "c/sqlite3.c"
  }
  $13 = HEAP16[$7>>1]|0; //@line 110926 "c/sqlite3.c"
  $14 = ($13<<16>>16)==(0); //@line 110926 "c/sqlite3.c"
  if ($14) {
   $$034$lcssa = 0;
  } else {
   $15 = ((($1)) + 4|0);
   $16 = ((($6)) + 4|0);
   $17 = ((($1)) + 40|0);
   $$03436 = 0;
   while(1) {
    $18 = HEAP32[$15>>2]|0; //@line 110927 "c/sqlite3.c"
    $19 = (($18) + ($$03436<<1)|0); //@line 110927 "c/sqlite3.c"
    $20 = HEAP16[$19>>1]|0; //@line 110927 "c/sqlite3.c"
    $21 = ($20<<16>>16)>(-1); //@line 110928 "c/sqlite3.c"
    if ($21) {
     $22 = $20 << 16 >> 16; //@line 110928 "c/sqlite3.c"
     $23 = HEAP32[$16>>2]|0; //@line 110929 "c/sqlite3.c"
     $24 = (((($23) + ($22<<4)|0)) + 13|0); //@line 110929 "c/sqlite3.c"
     $25 = HEAP8[$24>>0]|0; //@line 110929 "c/sqlite3.c"
     $$sink = $25;
    } else {
     $26 = ($20<<16>>16)==(-1); //@line 110930 "c/sqlite3.c"
     if ($26) {
      $$sink = 68;
     } else {
      $27 = HEAP32[$17>>2]|0; //@line 110936 "c/sqlite3.c"
      $28 = (((($27)) + 4|0) + (($$03436*20)|0)|0); //@line 110936 "c/sqlite3.c"
      $29 = HEAP32[$28>>2]|0; //@line 110936 "c/sqlite3.c"
      $30 = (_sqlite3ExprAffinity($29)|0); //@line 110936 "c/sqlite3.c"
      $31 = ($30<<24>>24)==(0); //@line 110937 "c/sqlite3.c"
      $spec$store$select = $31 ? 65 : $30; //@line 110937 "c/sqlite3.c"
      $$sink = $spec$store$select;
     }
    }
    $32 = HEAP32[$2>>2]|0;
    $33 = (($32) + ($$03436)|0);
    HEAP8[$33>>0] = $$sink;
    $34 = (($$03436) + 1)|0; //@line 110926 "c/sqlite3.c"
    $35 = HEAP16[$7>>1]|0; //@line 110926 "c/sqlite3.c"
    $36 = $35&65535; //@line 110926 "c/sqlite3.c"
    $37 = ($34>>>0)<($36>>>0); //@line 110926 "c/sqlite3.c"
    if ($37) {
     $$03436 = $34;
    } else {
     $$034$lcssa = $34;
     break;
    }
   }
  }
  $38 = HEAP32[$2>>2]|0; //@line 110941 "c/sqlite3.c"
  $39 = (($38) + ($$034$lcssa)|0); //@line 110941 "c/sqlite3.c"
  HEAP8[$39>>0] = 0; //@line 110941 "c/sqlite3.c"
 }
 $40 = HEAP32[$2>>2]|0; //@line 110944 "c/sqlite3.c"
 $$1 = $40;
 return ($$1|0); //@line 110945 "c/sqlite3.c"
}
function _sqlite3ReleaseTempRange($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)==(1); //@line 97976 "c/sqlite3.c"
 if ($3) {
  _sqlite3ReleaseTempReg($0,$1); //@line 97977 "c/sqlite3.c"
  return; //@line 97985 "c/sqlite3.c"
 }
 _sqlite3ExprCacheRemove($0,$1,$2); //@line 97980 "c/sqlite3.c"
 $4 = ((($0)) + 28|0); //@line 97981 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 97981 "c/sqlite3.c"
 $6 = ($5|0)<($2|0); //@line 97981 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 97985 "c/sqlite3.c"
 }
 HEAP32[$4>>2] = $2; //@line 97982 "c/sqlite3.c"
 $7 = ((($0)) + 32|0); //@line 97983 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 97983 "c/sqlite3.c"
 return; //@line 97985 "c/sqlite3.c"
}
function _sqlite3ExprCacheRemove($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$015 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 25|0); //@line 95893 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 95893 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 95893 "c/sqlite3.c"
 if ($5) {
  return; //@line 95901 "c/sqlite3.c"
 }
 $6 = (($2) + ($1))|0;
 $$015 = 0;
 while(1) {
  $7 = (((((($0)) + 148|0) + (($$015*20)|0)|0)) + 12|0); //@line 95895 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 95895 "c/sqlite3.c"
  $9 = ($8|0)>=($1|0); //@line 95895 "c/sqlite3.c"
  $10 = ($8|0)<($6|0); //@line 95895 "c/sqlite3.c"
  $or$cond = $9 & $10; //@line 95895 "c/sqlite3.c"
  if ($or$cond) {
   _cacheEntryClear($0,$$015); //@line 95896 "c/sqlite3.c"
   $$1 = $$015;
  } else {
   $11 = (($$015) + 1)|0; //@line 95898 "c/sqlite3.c"
   $$1 = $11;
  }
  $12 = HEAP8[$3>>0]|0; //@line 95893 "c/sqlite3.c"
  $13 = $12&255; //@line 95893 "c/sqlite3.c"
  $14 = ($$1|0)<($13|0); //@line 95893 "c/sqlite3.c"
  if ($14) {
   $$015 = $$1;
  } else {
   break;
  }
 }
 return; //@line 95901 "c/sqlite3.c"
}
function _sqlite3VdbeChangeToNoop($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 73896 "c/sqlite3.c"
 $3 = ((($2)) + 73|0); //@line 73896 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 73896 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 73896 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  return ($$0|0); //@line 73904 "c/sqlite3.c"
 }
 $6 = ((($0)) + 88|0); //@line 73898 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 73898 "c/sqlite3.c"
 $8 = (((($7) + (($1*20)|0)|0)) + 1|0); //@line 73899 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 73899 "c/sqlite3.c"
 $10 = $9 << 24 >> 24; //@line 73899 "c/sqlite3.c"
 $11 = (((($7) + (($1*20)|0)|0)) + 16|0); //@line 73899 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 73899 "c/sqlite3.c"
 _freeP4($2,$10,$12); //@line 73899 "c/sqlite3.c"
 HEAP8[$8>>0] = 0; //@line 73900 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 73901 "c/sqlite3.c"
 $13 = (($7) + (($1*20)|0)|0); //@line 73902 "c/sqlite3.c"
 HEAP8[$13>>0] = -88; //@line 73902 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 73904 "c/sqlite3.c"
}
function _sqlite3ExprCodeCopy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 96929 "c/sqlite3.c"
 $4 = (_sqlite3ExprDup($3,$1,0)|0); //@line 96930 "c/sqlite3.c"
 $5 = ((($3)) + 73|0); //@line 96931 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 96931 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 96931 "c/sqlite3.c"
 if ($7) {
  _sqlite3ExprCode($0,$4,$2); //@line 96931 "c/sqlite3.c"
 }
 _sqlite3ExprDelete($3,$4); //@line 96932 "c/sqlite3.c"
 return; //@line 96933 "c/sqlite3.c"
}
function _sqlite3ExprCodeGetColumnOfTable($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $brmerge = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)==(0|0); //@line 95989 "c/sqlite3.c"
 if ($5) {
  (_sqlite3VdbeAddOp3($0,98,$2,$3,$4)|0); //@line 95990 "c/sqlite3.c"
  return; //@line 96006 "c/sqlite3.c"
 }
 $6 = ($3|0)<(0); //@line 95993 "c/sqlite3.c"
 if ($6) {
  (_sqlite3VdbeAddOp2($0,124,$2,$4)|0); //@line 95994 "c/sqlite3.c"
  return; //@line 96006 "c/sqlite3.c"
 }
 $7 = ((($1)) + 40|0); //@line 95993 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 95993 "c/sqlite3.c"
 $9 = $8 << 16 >> 16; //@line 95993 "c/sqlite3.c"
 $10 = ($9|0)==($3|0); //@line 95993 "c/sqlite3.c"
 if ($10) {
  (_sqlite3VdbeAddOp2($0,124,$2,$4)|0); //@line 95994 "c/sqlite3.c"
 } else {
  $11 = ((($1)) + 56|0); //@line 95996 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 95996 "c/sqlite3.c"
  $13 = ($12|0)!=(0); //@line 95996 "c/sqlite3.c"
  $14 = $13 ? 158 : 98; //@line 95996 "c/sqlite3.c"
  $15 = ((($1)) + 36|0); //@line 95998 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 95998 "c/sqlite3.c"
  $17 = $16 & 32; //@line 95998 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 95998 "c/sqlite3.c"
  $brmerge = $13 | $18; //@line 95998 "c/sqlite3.c"
  if ($brmerge) {
   $$0 = $3;
  } else {
   $19 = (_sqlite3PrimaryKeyIndex($1)|0); //@line 95999 "c/sqlite3.c"
   $20 = $3&65535; //@line 95999 "c/sqlite3.c"
   $21 = (_sqlite3ColumnOfIndex($19,$20)|0); //@line 95999 "c/sqlite3.c"
   $22 = $21 << 16 >> 16; //@line 95999 "c/sqlite3.c"
   $$0 = $22;
  }
  (_sqlite3VdbeAddOp3($0,$14,$2,$$0,$4)|0); //@line 96001 "c/sqlite3.c"
 }
 _sqlite3ColumnDefault($0,$1,$3,$4); //@line 96004 "c/sqlite3.c"
 return; //@line 96006 "c/sqlite3.c"
}
function _sqlite3ColumnOfIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$07 = 0, $$09 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 52|0); //@line 102441 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 102441 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(0); //@line 102441 "c/sqlite3.c"
 if ($4) {
  $$07 = -1;
  return ($$07|0); //@line 102445 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0);
 $6 = HEAP32[$5>>2]|0;
 $$09 = 0;
 while(1) {
  $7 = (($6) + ($$09<<1)|0); //@line 102442 "c/sqlite3.c"
  $8 = HEAP16[$7>>1]|0; //@line 102442 "c/sqlite3.c"
  $9 = ($8<<16>>16)==($1<<16>>16); //@line 102442 "c/sqlite3.c"
  if ($9) {
   break;
  }
  $11 = (($$09) + 1)|0; //@line 102441 "c/sqlite3.c"
  $12 = HEAP16[$2>>1]|0; //@line 102441 "c/sqlite3.c"
  $13 = $12&65535; //@line 102441 "c/sqlite3.c"
  $14 = ($11>>>0)<($13>>>0); //@line 102441 "c/sqlite3.c"
  if ($14) {
   $$09 = $11;
  } else {
   $$07 = -1;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  return ($$07|0); //@line 102445 "c/sqlite3.c"
 }
 $10 = $$09&65535; //@line 102442 "c/sqlite3.c"
 $$07 = $10;
 return ($$07|0); //@line 102445 "c/sqlite3.c"
}
function _sqlite3ColumnDefault($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ((($1)) + 12|0); //@line 126141 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 126141 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 126141 "c/sqlite3.c"
 if ($7) {
  HEAP32[$4>>2] = 0; //@line 126142 "c/sqlite3.c"
  $8 = (_sqlite3VdbeDb($0)|0); //@line 126143 "c/sqlite3.c"
  $9 = ((($8)) + 70|0); //@line 126143 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 126143 "c/sqlite3.c"
  $11 = ((($1)) + 4|0); //@line 126144 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 126144 "c/sqlite3.c"
  $13 = (((($12) + ($2<<4)|0)) + 4|0); //@line 126147 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 126147 "c/sqlite3.c"
  $15 = (((($12) + ($2<<4)|0)) + 13|0); //@line 126148 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 126148 "c/sqlite3.c"
  (_sqlite3ValueFromExpr($8,$14,$10,$16,$4)|0); //@line 126147 "c/sqlite3.c"
  $17 = HEAP32[$4>>2]|0; //@line 126149 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 126149 "c/sqlite3.c"
  if (!($18)) {
   _sqlite3VdbeAppendP4($0,$17,-11); //@line 126150 "c/sqlite3.c"
  }
 }
 $19 = ((($1)) + 4|0); //@line 126154 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 126154 "c/sqlite3.c"
 $21 = (((($20) + ($2<<4)|0)) + 13|0); //@line 126154 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 126154 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(69); //@line 126154 "c/sqlite3.c"
 if (!($23)) {
  STACKTOP = sp;return; //@line 126158 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp1($0,81,$3)|0); //@line 126155 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 126158 "c/sqlite3.c"
}
function _sqlite3VdbeDb($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 77526 "c/sqlite3.c"
 return ($1|0); //@line 77526 "c/sqlite3.c"
}
function _sqlite3ExprCode($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 96912 "c/sqlite3.c"
 if (!($3)) {
  $4 = HEAP8[$1>>0]|0; //@line 96912 "c/sqlite3.c"
  $5 = ($4<<24>>24)==(-106); //@line 96912 "c/sqlite3.c"
  if ($5) {
   $6 = ((($0)) + 8|0); //@line 96913 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 96913 "c/sqlite3.c"
   $8 = ((($1)) + 28|0); //@line 96913 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 96913 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($7,75,$9,$2)|0); //@line 96913 "c/sqlite3.c"
   return; //@line 96921 "c/sqlite3.c"
  }
 }
 $10 = (_sqlite3ExprCodeTarget($0,$1,$2)|0); //@line 96915 "c/sqlite3.c"
 $11 = ($10|0)==($2|0); //@line 96917 "c/sqlite3.c"
 if ($11) {
  return; //@line 96921 "c/sqlite3.c"
 }
 $12 = ((($0)) + 8|0); //@line 96917 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 96917 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 96917 "c/sqlite3.c"
 if ($14) {
  return; //@line 96921 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($13,76,$10,$2)|0); //@line 96918 "c/sqlite3.c"
 return; //@line 96921 "c/sqlite3.c"
}
function _sqlite3ExprCodeTarget($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0466 = 0, $$0468 = 0, $$0470498 = 0, $$0471 = 0, $$0473 = 0, $$0479 = 0, $$0480492 = 0, $$0481 = 0, $$0482$lcssa = 0, $$0482502 = 0, $$0484508 = 0, $$0486$lcssa = 0, $$0486500 = 0, $$1467 = 0, $$1469 = 0, $$1472 = 0, $$1483 = 0, $$1485501 = 0, $$1487 = 0;
 var $$1499 = 0, $$2 = 0, $$2488 = 0, $$6 = 0, $$pr = 0, $$sink513 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0;
 var $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0;
 var $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0;
 var $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0;
 var $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0;
 var $33 = 0, $330 = 0, $331 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond512 = 0, $or$cond = 0, $or$cond7 = 0, $spec$select = 0;
 var $trunc = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer10 = 0, $vararg_buffer4 = 0, $vararg_buffer8 = 0, $vararg_ptr7 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 144|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(144|0);
 $vararg_buffer10 = sp + 32|0;
 $vararg_buffer8 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = sp + 140|0;
 $4 = sp + 136|0;
 $5 = sp + 88|0;
 $6 = sp + 40|0;
 $7 = ((($0)) + 8|0); //@line 96179 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 96179 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 96182 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 96183 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 96189 "c/sqlite3.c"
 if ($9) {
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
 }
 $10 = ($1|0)==(0|0); //@line 96194 "c/sqlite3.c"
 if ($10) {
  $$0466 = 101;
 } else {
  $11 = HEAP8[$1>>0]|0; //@line 96197 "c/sqlite3.c"
  $12 = $11&255; //@line 96197 "c/sqlite3.c"
  $$0466 = $12;
 }
 $trunc = $$0466&255; //@line 96199 "c/sqlite3.c"
 L7: do {
  switch ($trunc<<24>>24) {
  case -109:  {
   $13 = ((($1)) + 40|0); //@line 96201 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 96201 "c/sqlite3.c"
   $15 = ((($14)) + 28|0); //@line 96202 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 96202 "c/sqlite3.c"
   $17 = ((($1)) + 34|0); //@line 96202 "c/sqlite3.c"
   $18 = HEAP16[$17>>1]|0; //@line 96202 "c/sqlite3.c"
   $19 = $18 << 16 >> 16; //@line 96202 "c/sqlite3.c"
   $20 = HEAP8[$14>>0]|0; //@line 96203 "c/sqlite3.c"
   $21 = ($20<<24>>24)==(0); //@line 96203 "c/sqlite3.c"
   if ($21) {
    $22 = (((($16) + (($19*24)|0)|0)) + 16|0); //@line 96205 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 96205 "c/sqlite3.c"
    $$6 = $23;
    STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   }
   $24 = ((($14)) + 1|0); //@line 96206 "c/sqlite3.c"
   $25 = HEAP8[$24>>0]|0; //@line 96206 "c/sqlite3.c"
   $26 = ($25<<24>>24)==(0); //@line 96206 "c/sqlite3.c"
   if ($26) {
    label = 9;
   } else {
    $27 = (((($16) + (($19*24)|0)|0)) + 12|0); //@line 96208 "c/sqlite3.c"
    $28 = ((($14)) + 8|0); //@line 96207 "c/sqlite3.c"
    $29 = HEAP32[$28>>2]|0; //@line 96207 "c/sqlite3.c"
    $30 = HEAP32[$27>>2]|0; //@line 96208 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($8,98,$29,$30,$2)|0); //@line 96207 "c/sqlite3.c"
    $$6 = $2;
    STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   }
   break;
  }
  case -111:  {
   label = 9;
   break;
  }
  case -122:  {
   _codeInteger($0,$1,0,$2); //@line 96230 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -124:  {
   $50 = ((($1)) + 8|0); //@line 96236 "c/sqlite3.c"
   $51 = HEAP32[$50>>2]|0; //@line 96236 "c/sqlite3.c"
   _codeReal($8,$51,0,$2); //@line 96236 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case 97:  {
   $52 = ((($1)) + 8|0); //@line 96242 "c/sqlite3.c"
   $53 = HEAP32[$52>>2]|0; //@line 96242 "c/sqlite3.c"
   (_sqlite3VdbeLoadString($8,$2,$53)|0); //@line 96242 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case 101:  {
   (_sqlite3VdbeAddOp2($8,70,0,$2)|0); //@line 96246 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -123:  {
   $54 = ((($1)) + 8|0); //@line 96257 "c/sqlite3.c"
   $55 = HEAP32[$54>>2]|0; //@line 96257 "c/sqlite3.c"
   $56 = ((($55)) + 2|0); //@line 96257 "c/sqlite3.c"
   $57 = (_sqlite3Strlen30($56)|0); //@line 96258 "c/sqlite3.c"
   $58 = (($57) + -1)|0; //@line 96258 "c/sqlite3.c"
   $59 = (_sqlite3VdbeDb($8)|0); //@line 96260 "c/sqlite3.c"
   $60 = (_sqlite3HexToBlob($59,$56,$58)|0); //@line 96260 "c/sqlite3.c"
   $61 = (($58|0) / 2)&-1; //@line 96261 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($8,72,$61,$2,0,$60,-7)|0); //@line 96261 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -121:  {
   $62 = ((($1)) + 32|0); //@line 96269 "c/sqlite3.c"
   $63 = HEAP16[$62>>1]|0; //@line 96269 "c/sqlite3.c"
   $64 = $63 << 16 >> 16; //@line 96269 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,73,$64,$2)|0); //@line 96269 "c/sqlite3.c"
   $65 = ((($1)) + 8|0); //@line 96270 "c/sqlite3.c"
   $66 = HEAP32[$65>>2]|0; //@line 96270 "c/sqlite3.c"
   $67 = ((($66)) + 1|0); //@line 96270 "c/sqlite3.c"
   $68 = HEAP8[$67>>0]|0; //@line 96270 "c/sqlite3.c"
   $69 = ($68<<24>>24)==(0); //@line 96270 "c/sqlite3.c"
   if ($69) {
    $$6 = $2;
    STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   }
   $70 = ((($0)) + 420|0); //@line 96271 "c/sqlite3.c"
   $71 = HEAP32[$70>>2]|0; //@line 96271 "c/sqlite3.c"
   $72 = HEAP16[$62>>1]|0; //@line 96271 "c/sqlite3.c"
   $73 = $72 << 16 >> 16; //@line 96271 "c/sqlite3.c"
   $74 = (_sqlite3VListNumToName($71,$73)|0); //@line 96271 "c/sqlite3.c"
   HEAP32[$71>>2] = 0; //@line 96273 "c/sqlite3.c"
   _sqlite3VdbeAppendP4($8,$74,-1); //@line 96274 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -106:  {
   $75 = ((($1)) + 28|0); //@line 96279 "c/sqlite3.c"
   $76 = HEAP32[$75>>2]|0; //@line 96279 "c/sqlite3.c"
   $$6 = $76;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case 36:  {
   $77 = ((($1)) + 12|0); //@line 96284 "c/sqlite3.c"
   $78 = HEAP32[$77>>2]|0; //@line 96284 "c/sqlite3.c"
   $79 = (_sqlite3ExprCodeTarget($0,$78,$2)|0); //@line 96284 "c/sqlite3.c"
   $80 = ($79|0)==($2|0); //@line 96285 "c/sqlite3.c"
   if ($80) {
    $$0468 = $79;
   } else {
    (_sqlite3VdbeAddOp2($8,76,$79,$2)|0); //@line 96286 "c/sqlite3.c"
    $$0468 = $2;
   }
   $81 = ((($1)) + 8|0); //@line 96290 "c/sqlite3.c"
   $82 = HEAP32[$81>>2]|0; //@line 96290 "c/sqlite3.c"
   $83 = (_sqlite3AffinityType($82,0)|0); //@line 96290 "c/sqlite3.c"
   $84 = $83 << 24 >> 24; //@line 96290 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,82,$2,$84)|0); //@line 96289 "c/sqlite3.c"
   _sqlite3ExprCacheAffinityChange($0,$$0468,1); //@line 96292 "c/sqlite3.c"
   $$6 = $$0468;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -113: case 45:  {
   $85 = ($$0466|0)==(45); //@line 96298 "c/sqlite3.c"
   $86 = $85 ? 53 : 52; //@line 96298 "c/sqlite3.c"
   $$0473 = 128;$$1467 = $86;
   label = 26;
   break;
  }
  case 53: case 52: case 57: case 54: case 55: case 56:  {
   $$0473 = 0;$$1467 = $$0466;
   label = 26;
   break;
  }
  case 93: case 87: case 86: case 91: case 85: case 84: case 92: case 89: case 90: case 88: case 43: case 44:  {
   $99 = ((($1)) + 12|0); //@line 96349 "c/sqlite3.c"
   $100 = HEAP32[$99>>2]|0; //@line 96349 "c/sqlite3.c"
   $101 = (_sqlite3ExprCodeTemp($0,$100,$3)|0); //@line 96349 "c/sqlite3.c"
   $102 = ((($1)) + 16|0); //@line 96350 "c/sqlite3.c"
   $103 = HEAP32[$102>>2]|0; //@line 96350 "c/sqlite3.c"
   $104 = (_sqlite3ExprCodeTemp($0,$103,$4)|0); //@line 96350 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($8,$$0466,$104,$101,$2)|0); //@line 96351 "c/sqlite3.c"
   $$1469 = $2;
   break;
  }
  case -108:  {
   $105 = ((($1)) + 12|0); //@line 96357 "c/sqlite3.c"
   $106 = HEAP32[$105>>2]|0; //@line 96357 "c/sqlite3.c"
   $107 = HEAP8[$106>>0]|0; //@line 96359 "c/sqlite3.c"
   switch ($107<<24>>24) {
   case -122:  {
    _codeInteger($0,$106,1,$2); //@line 96360 "c/sqlite3.c"
    $$6 = $2;
    STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
    break;
   }
   case -124:  {
    $108 = ((($106)) + 8|0); //@line 96365 "c/sqlite3.c"
    $109 = HEAP32[$108>>2]|0; //@line 96365 "c/sqlite3.c"
    _codeReal($8,$109,1,$2); //@line 96365 "c/sqlite3.c"
    $$6 = $2;
    STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
    break;
   }
   default: {
    HEAP8[$5>>0] = -122; //@line 96369 "c/sqlite3.c"
    $110 = ((($5)) + 4|0); //@line 96370 "c/sqlite3.c"
    HEAP32[$110>>2] = 17408; //@line 96370 "c/sqlite3.c"
    $111 = ((($5)) + 8|0); //@line 96371 "c/sqlite3.c"
    HEAP32[$111>>2] = 0; //@line 96371 "c/sqlite3.c"
    $112 = (_sqlite3ExprCodeTemp($0,$5,$3)|0); //@line 96372 "c/sqlite3.c"
    $113 = HEAP32[$105>>2]|0; //@line 96373 "c/sqlite3.c"
    $114 = (_sqlite3ExprCodeTemp($0,$113,$4)|0); //@line 96373 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($8,89,$114,$112,$2)|0); //@line 96374 "c/sqlite3.c"
    $$1469 = $2;
    break L7;
   }
   }
   break;
  }
  case 19: case 95:  {
   $115 = ((($1)) + 12|0); //@line 96383 "c/sqlite3.c"
   $116 = HEAP32[$115>>2]|0; //@line 96383 "c/sqlite3.c"
   $117 = (_sqlite3ExprCodeTemp($0,$116,$3)|0); //@line 96383 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,$$0466,$117,$2)|0); //@line 96385 "c/sqlite3.c"
   $$1469 = $2;
   break;
  }
  case 51: case 50:  {
   (_sqlite3VdbeAddOp2($8,67,1,$2)|0); //@line 96393 "c/sqlite3.c"
   $118 = ((($1)) + 12|0); //@line 96394 "c/sqlite3.c"
   $119 = HEAP32[$118>>2]|0; //@line 96394 "c/sqlite3.c"
   $120 = (_sqlite3ExprCodeTemp($0,$119,$3)|0); //@line 96394 "c/sqlite3.c"
   $121 = (_sqlite3VdbeAddOp1($8,$$0466,$120)|0); //@line 96396 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,67,0,$2)|0); //@line 96399 "c/sqlite3.c"
   _sqlite3VdbeJumpHere($8,$121); //@line 96400 "c/sqlite3.c"
   $$1469 = $2;
   break;
  }
  case -110:  {
   $122 = ((($1)) + 40|0); //@line 96404 "c/sqlite3.c"
   $123 = HEAP32[$122>>2]|0; //@line 96404 "c/sqlite3.c"
   $124 = ($123|0)==(0|0); //@line 96405 "c/sqlite3.c"
   if ($124) {
    $125 = ((($1)) + 8|0); //@line 96407 "c/sqlite3.c"
    $126 = HEAP32[$125>>2]|0; //@line 96407 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $126; //@line 96407 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,24755,$vararg_buffer); //@line 96407 "c/sqlite3.c"
    $$1469 = $2;
    break L7;
   }
   $127 = ((($123)) + 40|0); //@line 96409 "c/sqlite3.c"
   $128 = HEAP32[$127>>2]|0; //@line 96409 "c/sqlite3.c"
   $129 = ((($1)) + 34|0); //@line 96409 "c/sqlite3.c"
   $130 = HEAP16[$129>>1]|0; //@line 96409 "c/sqlite3.c"
   $131 = $130 << 16 >> 16; //@line 96409 "c/sqlite3.c"
   $132 = (((($128) + ($131<<4)|0)) + 8|0); //@line 96409 "c/sqlite3.c"
   $133 = HEAP32[$132>>2]|0; //@line 96409 "c/sqlite3.c"
   $$6 = $133;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -112:  {
   $134 = HEAP32[$0>>2]|0; //@line 96420 "c/sqlite3.c"
   $135 = ((($134)) + 70|0); //@line 96421 "c/sqlite3.c"
   $136 = HEAP8[$135>>0]|0; //@line 96421 "c/sqlite3.c"
   $137 = ((($0)) + 23|0); //@line 96424 "c/sqlite3.c"
   $138 = HEAP8[$137>>0]|0; //@line 96424 "c/sqlite3.c"
   $139 = ($138<<24>>24)==(0); //@line 96424 "c/sqlite3.c"
   if (!($139)) {
    $140 = (_sqlite3ExprIsConstantNotJoin($1)|0); //@line 96424 "c/sqlite3.c"
    $141 = ($140|0)==(0); //@line 96424 "c/sqlite3.c"
    if (!($141)) {
     $142 = (_sqlite3ExprCodeAtInit($0,$1,-1)|0); //@line 96427 "c/sqlite3.c"
     $$6 = $142;
     STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
    }
   }
   $143 = ((($1)) + 4|0); //@line 96430 "c/sqlite3.c"
   $144 = HEAP32[$143>>2]|0; //@line 96430 "c/sqlite3.c"
   $145 = $144 & 16384; //@line 96430 "c/sqlite3.c"
   $146 = ($145|0)==(0); //@line 96430 "c/sqlite3.c"
   if ($146) {
    $147 = ((($1)) + 20|0); //@line 96433 "c/sqlite3.c"
    $148 = HEAP32[$147>>2]|0; //@line 96433 "c/sqlite3.c"
    $149 = ($148|0)==(0|0); //@line 96435 "c/sqlite3.c"
    if ($149) {
     $$0480492 = 0;$153 = 0;$331 = 0;
    } else {
     $150 = HEAP32[$148>>2]|0; //@line 96435 "c/sqlite3.c"
     $$0480492 = $148;$153 = $150;$331 = 1;
    }
   } else {
    $$0480492 = 0;$153 = 0;$331 = 0;
   }
   $151 = ((($1)) + 8|0); //@line 96437 "c/sqlite3.c"
   $152 = HEAP32[$151>>2]|0; //@line 96437 "c/sqlite3.c"
   $154 = (_sqlite3FindFunction($134,$152,$153,$136,0)|0); //@line 96438 "c/sqlite3.c"
   $155 = ($154|0)==(0|0); //@line 96444 "c/sqlite3.c"
   if (!($155)) {
    $156 = ((($154)) + 16|0); //@line 96444 "c/sqlite3.c"
    $157 = HEAP32[$156>>2]|0; //@line 96444 "c/sqlite3.c"
    $158 = ($157|0)==(0|0); //@line 96444 "c/sqlite3.c"
    if ($158) {
     $159 = ((($154)) + 2|0); //@line 96453 "c/sqlite3.c"
     $160 = HEAP16[$159>>1]|0; //@line 96453 "c/sqlite3.c"
     $161 = $160&65535; //@line 96453 "c/sqlite3.c"
     $162 = $161 & 512; //@line 96453 "c/sqlite3.c"
     $163 = ($162|0)==(0); //@line 96453 "c/sqlite3.c"
     if (!($163)) {
      $164 = (_sqlite3VdbeMakeLabel($8)|0); //@line 96454 "c/sqlite3.c"
      $165 = ((($$0480492)) + 4|0); //@line 96456 "c/sqlite3.c"
      $166 = HEAP32[$165>>2]|0; //@line 96456 "c/sqlite3.c"
      _sqlite3ExprCode($0,$166,$2); //@line 96456 "c/sqlite3.c"
      $167 = ($153|0)>(1); //@line 96457 "c/sqlite3.c"
      if ($167) {
       $$0484508 = 1;
       while(1) {
        (_sqlite3VdbeAddOp2($8,51,$2,$164)|0); //@line 96458 "c/sqlite3.c"
        _sqlite3ExprCacheRemove($0,$2,1); //@line 96460 "c/sqlite3.c"
        _sqlite3ExprCachePush($0); //@line 96461 "c/sqlite3.c"
        $168 = (((($$0480492)) + 4|0) + (($$0484508*20)|0)|0); //@line 96462 "c/sqlite3.c"
        $169 = HEAP32[$168>>2]|0; //@line 96462 "c/sqlite3.c"
        _sqlite3ExprCode($0,$169,$2); //@line 96462 "c/sqlite3.c"
        _sqlite3ExprCachePop($0); //@line 96463 "c/sqlite3.c"
        $170 = (($$0484508) + 1)|0; //@line 96457 "c/sqlite3.c"
        $exitcond512 = ($170|0)==($153|0); //@line 96457 "c/sqlite3.c"
        if ($exitcond512) {
         break;
        } else {
         $$0484508 = $170;
        }
       }
      }
      _sqlite3VdbeResolveLabel($8,$164); //@line 96465 "c/sqlite3.c"
      $$1469 = $2;
      break L7;
     }
     $171 = $161 & 1024; //@line 96472 "c/sqlite3.c"
     $172 = ($171|0)==(0); //@line 96472 "c/sqlite3.c"
     if (!($172)) {
      $173 = ((($$0480492)) + 4|0); //@line 96474 "c/sqlite3.c"
      $174 = HEAP32[$173>>2]|0; //@line 96474 "c/sqlite3.c"
      $175 = (_sqlite3ExprCodeTarget($0,$174,$2)|0); //@line 96474 "c/sqlite3.c"
      $$6 = $175;
      STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
     }
     $176 = ($153|0)>(0); //@line 96493 "c/sqlite3.c"
     if ($176) {
      $$0482502 = 0;$$0486500 = 0;$$1485501 = 0;
      while(1) {
       $177 = ($$1485501>>>0)<(32); //@line 96494 "c/sqlite3.c"
       if ($177) {
        $178 = (((($$0480492)) + 4|0) + (($$1485501*20)|0)|0); //@line 96494 "c/sqlite3.c"
        $179 = HEAP32[$178>>2]|0; //@line 96494 "c/sqlite3.c"
        $180 = (_sqlite3ExprIsConstant($179)|0); //@line 96494 "c/sqlite3.c"
        $181 = ($180|0)==(0); //@line 96494 "c/sqlite3.c"
        $182 = 1 << $$1485501; //@line 96496 "c/sqlite3.c"
        $183 = $181 ? 0 : $182; //@line 96494 "c/sqlite3.c"
        $spec$select = $183 | $$0482502; //@line 96494 "c/sqlite3.c"
        $$1483 = $spec$select;
       } else {
        $$1483 = $$0482502;
       }
       $184 = HEAP16[$159>>1]|0; //@line 96498 "c/sqlite3.c"
       $185 = $184 & 32; //@line 96498 "c/sqlite3.c"
       $186 = ($185<<16>>16)==(0); //@line 96498 "c/sqlite3.c"
       $187 = ($$0486500|0)!=(0|0); //@line 96498 "c/sqlite3.c"
       $or$cond = $187 | $186; //@line 96498 "c/sqlite3.c"
       if ($or$cond) {
        $$1487 = $$0486500;
       } else {
        $188 = (((($$0480492)) + 4|0) + (($$1485501*20)|0)|0); //@line 96499 "c/sqlite3.c"
        $189 = HEAP32[$188>>2]|0; //@line 96499 "c/sqlite3.c"
        $190 = (_sqlite3ExprCollSeq($0,$189)|0); //@line 96499 "c/sqlite3.c"
        $$1487 = $190;
       }
       $191 = (($$1485501) + 1)|0; //@line 96493 "c/sqlite3.c"
       $exitcond = ($191|0)==($153|0); //@line 96493 "c/sqlite3.c"
       if ($exitcond) {
        $$0482$lcssa = $$1483;$$0486$lcssa = $$1487;
        break;
       } else {
        $$0482502 = $$1483;$$0486500 = $$1487;$$1485501 = $191;
       }
      }
     } else {
      $$0482$lcssa = 0;$$0486$lcssa = 0;
     }
     if ($331) {
      $192 = ($$0482$lcssa|0)==(0); //@line 96503 "c/sqlite3.c"
      if ($192) {
       $197 = (_sqlite3GetTempRange($0,$153)|0); //@line 96507 "c/sqlite3.c"
       $$0471 = $197;
      } else {
       $193 = ((($0)) + 44|0); //@line 96504 "c/sqlite3.c"
       $194 = HEAP32[$193>>2]|0; //@line 96504 "c/sqlite3.c"
       $195 = (($194) + 1)|0; //@line 96504 "c/sqlite3.c"
       $196 = (($194) + ($153))|0; //@line 96505 "c/sqlite3.c"
       HEAP32[$193>>2] = $196; //@line 96505 "c/sqlite3.c"
       $$0471 = $195;
      }
      $198 = HEAP16[$159>>1]|0; //@line 96515 "c/sqlite3.c"
      $199 = $198 & 192; //@line 96515 "c/sqlite3.c"
      $200 = ($199<<16>>16)==(0); //@line 96515 "c/sqlite3.c"
      L111: do {
       if (!($200)) {
        $201 = ((($$0480492)) + 4|0); //@line 96519 "c/sqlite3.c"
        $202 = HEAP32[$201>>2]|0; //@line 96519 "c/sqlite3.c"
        $203 = HEAP8[$202>>0]|0; //@line 96519 "c/sqlite3.c"
        switch ($203<<24>>24) {
        case -109: case -111:  {
         break;
        }
        default: {
         break L111;
        }
        }
        $204 = $198&255; //@line 96525 "c/sqlite3.c"
        $205 = $204 & -64; //@line 96525 "c/sqlite3.c"
        $206 = ((($202)) + 38|0); //@line 96524 "c/sqlite3.c"
        HEAP8[$206>>0] = $205; //@line 96524 "c/sqlite3.c"
       }
      } while(0);
      _sqlite3ExprCachePush($0); //@line 96529 "c/sqlite3.c"
      (_sqlite3ExprCodeExprList($0,$$0480492,$$0471,0,3)|0); //@line 96530 "c/sqlite3.c"
      _sqlite3ExprCachePop($0); //@line 96532 "c/sqlite3.c"
      $$1472 = $$0471;
     } else {
      $$1472 = 0;
     }
     $207 = ($153|0)>(1); //@line 96549 "c/sqlite3.c"
     if ($207) {
      $208 = HEAP32[$143>>2]|0; //@line 96549 "c/sqlite3.c"
      $209 = $208 & 128; //@line 96549 "c/sqlite3.c"
      $210 = ($209|0)==(0); //@line 96549 "c/sqlite3.c"
      if ($210) {
       label = 74;
      } else {
       $211 = ((($$0480492)) + 24|0); //@line 96550 "c/sqlite3.c"
       $$sink513 = $211;
       label = 75;
      }
     } else {
      $212 = ($153|0)==(1); //@line 96551 "c/sqlite3.c"
      if ($212) {
       label = 74;
      } else {
       $$0481 = $154;
      }
     }
     if ((label|0) == 74) {
      $213 = ((($$0480492)) + 4|0); //@line 96552 "c/sqlite3.c"
      $$sink513 = $213;
      label = 75;
     }
     if ((label|0) == 75) {
      $214 = HEAP32[$$sink513>>2]|0;
      $215 = (_sqlite3VtabOverloadFunction($134,$154,$153,$214)|0);
      $$0481 = $215;
     }
     $216 = ((($$0481)) + 2|0); //@line 96555 "c/sqlite3.c"
     $217 = HEAP16[$216>>1]|0; //@line 96555 "c/sqlite3.c"
     $218 = $217 & 32; //@line 96555 "c/sqlite3.c"
     $219 = ($218<<16>>16)==(0); //@line 96555 "c/sqlite3.c"
     if (!($219)) {
      $220 = ($$0486$lcssa|0)==(0|0); //@line 96556 "c/sqlite3.c"
      if ($220) {
       $221 = ((($134)) + 8|0); //@line 96556 "c/sqlite3.c"
       $222 = HEAP32[$221>>2]|0; //@line 96556 "c/sqlite3.c"
       $$2488 = $222;
      } else {
       $$2488 = $$0486$lcssa;
      }
      (_sqlite3VdbeAddOp4($8,79,0,0,0,$$2488,-2)|0); //@line 96557 "c/sqlite3.c"
     }
     $223 = ((($0)) + 56|0); //@line 96570 "c/sqlite3.c"
     $224 = HEAP32[$223>>2]|0; //@line 96570 "c/sqlite3.c"
     $225 = ($224|0)==(0); //@line 96570 "c/sqlite3.c"
     $226 = $225 ? 163 : 162; //@line 96570 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4($8,$226,$$0482$lcssa,$$1472,$2,$$0481,-8)|0); //@line 96570 "c/sqlite3.c"
     $227 = $153&65535; //@line 96572 "c/sqlite3.c"
     $228 = $227 & 255; //@line 96572 "c/sqlite3.c"
     _sqlite3VdbeChangeP5($8,$228); //@line 96572 "c/sqlite3.c"
     $229 = ($153|0)!=(0); //@line 96574 "c/sqlite3.c"
     $230 = ($$0482$lcssa|0)==(0); //@line 96574 "c/sqlite3.c"
     $or$cond7 = $229 & $230; //@line 96574 "c/sqlite3.c"
     if (!($or$cond7)) {
      $$6 = $2;
      STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
     }
     _sqlite3ReleaseTempRange($0,$$1472,$153); //@line 96575 "c/sqlite3.c"
     $$6 = $2;
     STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
    }
   }
   HEAP32[$vararg_buffer1>>2] = $152; //@line 96445 "c/sqlite3.c"
   _sqlite3ErrorMsg($0,24781,$vararg_buffer1); //@line 96445 "c/sqlite3.c"
   $$1469 = $2;
   break;
  }
  case 119: case 20:  {
   $231 = ($$0466|0)==(119); //@line 96585 "c/sqlite3.c"
   if ($231) {
    $232 = ((($1)) + 20|0); //@line 96585 "c/sqlite3.c"
    $233 = HEAP32[$232>>2]|0; //@line 96585 "c/sqlite3.c"
    $234 = HEAP32[$233>>2]|0; //@line 96585 "c/sqlite3.c"
    $235 = HEAP32[$234>>2]|0; //@line 96585 "c/sqlite3.c"
    $236 = ($235|0)==(1); //@line 96585 "c/sqlite3.c"
    if (!($236)) {
     _sqlite3SubselectError($0,$235,1); //@line 96586 "c/sqlite3.c"
     $$1469 = $2;
     break L7;
    }
   }
   $237 = (_sqlite3CodeSubselect($0,$1,0,0)|0); //@line 96588 "c/sqlite3.c"
   $$6 = $237;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -104:  {
   $238 = ((($1)) + 12|0); //@line 96594 "c/sqlite3.c"
   $239 = HEAP32[$238>>2]|0; //@line 96594 "c/sqlite3.c"
   $240 = ((($239)) + 28|0); //@line 96594 "c/sqlite3.c"
   $241 = HEAP32[$240>>2]|0; //@line 96594 "c/sqlite3.c"
   $242 = ($241|0)==(0); //@line 96594 "c/sqlite3.c"
   if ($242) {
    $243 = (_sqlite3CodeSubselect($0,$239,0,0)|0); //@line 96595 "c/sqlite3.c"
    $244 = HEAP32[$238>>2]|0; //@line 96595 "c/sqlite3.c"
    $245 = ((($244)) + 28|0); //@line 96595 "c/sqlite3.c"
    HEAP32[$245>>2] = $243; //@line 96595 "c/sqlite3.c"
   }
   $246 = ((($1)) + 28|0); //@line 96598 "c/sqlite3.c"
   $247 = HEAP32[$246>>2]|0; //@line 96598 "c/sqlite3.c"
   $248 = ($247|0)==(0); //@line 96598 "c/sqlite3.c"
   if (!($248)) {
    $249 = HEAP32[$238>>2]|0; //@line 96599 "c/sqlite3.c"
    $250 = (_sqlite3ExprVectorSize($249)|0); //@line 96599 "c/sqlite3.c"
    $251 = ($247|0)==($250|0); //@line 96599 "c/sqlite3.c"
    if (!($251)) {
     HEAP32[$vararg_buffer4>>2] = $247; //@line 96601 "c/sqlite3.c"
     $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 96601 "c/sqlite3.c"
     HEAP32[$vararg_ptr7>>2] = $250; //@line 96601 "c/sqlite3.c"
     _sqlite3ErrorMsg($0,24804,$vararg_buffer4); //@line 96601 "c/sqlite3.c"
    }
   }
   $252 = HEAP32[$238>>2]|0; //@line 96604 "c/sqlite3.c"
   $253 = ((($252)) + 28|0); //@line 96604 "c/sqlite3.c"
   $254 = HEAP32[$253>>2]|0; //@line 96604 "c/sqlite3.c"
   $255 = ((($1)) + 32|0); //@line 96604 "c/sqlite3.c"
   $256 = HEAP16[$255>>1]|0; //@line 96604 "c/sqlite3.c"
   $257 = $256 << 16 >> 16; //@line 96604 "c/sqlite3.c"
   $258 = (($254) + ($257))|0; //@line 96604 "c/sqlite3.c"
   $$6 = $258;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case 49:  {
   $259 = (_sqlite3VdbeMakeLabel($8)|0); //@line 96607 "c/sqlite3.c"
   $260 = (_sqlite3VdbeMakeLabel($8)|0); //@line 96608 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,70,0,$2)|0); //@line 96609 "c/sqlite3.c"
   _sqlite3ExprCodeIN($0,$1,$259,$260); //@line 96610 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,67,1,$2)|0); //@line 96611 "c/sqlite3.c"
   _sqlite3VdbeResolveLabel($8,$259); //@line 96612 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,80,$2,0)|0); //@line 96613 "c/sqlite3.c"
   _sqlite3VdbeResolveLabel($8,$260); //@line 96614 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case 48:  {
   _exprCodeBetween($0,$1,$2,0,0); //@line 96632 "c/sqlite3.c"
   $$6 = $2;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case -107: case 94: case -101:  {
   $261 = ((($1)) + 12|0); //@line 96638 "c/sqlite3.c"
   $262 = HEAP32[$261>>2]|0; //@line 96638 "c/sqlite3.c"
   $263 = (_sqlite3ExprCodeTarget($0,$262,$2)|0); //@line 96638 "c/sqlite3.c"
   $$6 = $263;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   break;
  }
  case 75:  {
   $264 = ((($1)) + 44|0); //@line 96667 "c/sqlite3.c"
   $265 = HEAP32[$264>>2]|0; //@line 96667 "c/sqlite3.c"
   $266 = ((($1)) + 28|0); //@line 96668 "c/sqlite3.c"
   $267 = HEAP32[$266>>2]|0; //@line 96668 "c/sqlite3.c"
   $268 = ((($265)) + 42|0); //@line 96668 "c/sqlite3.c"
   $269 = HEAP16[$268>>1]|0; //@line 96668 "c/sqlite3.c"
   $270 = $269 << 16 >> 16; //@line 96668 "c/sqlite3.c"
   $271 = (($270) + 1)|0; //@line 96668 "c/sqlite3.c"
   $272 = Math_imul($271, $267)|0; //@line 96668 "c/sqlite3.c"
   $273 = ((($1)) + 32|0); //@line 96668 "c/sqlite3.c"
   $274 = HEAP16[$273>>1]|0; //@line 96668 "c/sqlite3.c"
   $275 = $274 << 16 >> 16; //@line 96668 "c/sqlite3.c"
   $276 = (($275) + 1)|0; //@line 96668 "c/sqlite3.c"
   $277 = (($276) + ($272))|0; //@line 96668 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,145,$277,$2)|0); //@line 96675 "c/sqlite3.c"
   $278 = HEAP16[$273>>1]|0; //@line 96688 "c/sqlite3.c"
   $279 = ($278<<16>>16)>(-1); //@line 96688 "c/sqlite3.c"
   if ($279) {
    $280 = $278 << 16 >> 16; //@line 96688 "c/sqlite3.c"
    $281 = ((($265)) + 4|0); //@line 96689 "c/sqlite3.c"
    $282 = HEAP32[$281>>2]|0; //@line 96689 "c/sqlite3.c"
    $283 = (((($282) + ($280<<4)|0)) + 13|0); //@line 96689 "c/sqlite3.c"
    $284 = HEAP8[$283>>0]|0; //@line 96689 "c/sqlite3.c"
    $285 = ($284<<24>>24)==(69); //@line 96689 "c/sqlite3.c"
    if ($285) {
     (_sqlite3VdbeAddOp1($8,81,$2)|0); //@line 96691 "c/sqlite3.c"
     $$1469 = $2;
    } else {
     $$1469 = $2;
    }
   } else {
    $$1469 = $2;
   }
   break;
  }
  case -105:  {
   _sqlite3ErrorMsg($0,23693,$vararg_buffer8); //@line 96698 "c/sqlite3.c"
   $$1469 = $2;
   break;
  }
  case -103:  {
   $286 = ((($1)) + 28|0); //@line 96704 "c/sqlite3.c"
   $287 = HEAP32[$286>>2]|0; //@line 96704 "c/sqlite3.c"
   $288 = (_sqlite3VdbeAddOp1($8,23,$287)|0); //@line 96704 "c/sqlite3.c"
   _sqlite3ExprCachePush($0); //@line 96705 "c/sqlite3.c"
   $289 = ((($1)) + 12|0); //@line 96706 "c/sqlite3.c"
   $290 = HEAP32[$289>>2]|0; //@line 96706 "c/sqlite3.c"
   $291 = (_sqlite3ExprCodeTarget($0,$290,$2)|0); //@line 96706 "c/sqlite3.c"
   _sqlite3ExprCachePop($0); //@line 96707 "c/sqlite3.c"
   _sqlite3VdbeJumpHere($8,$288); //@line 96708 "c/sqlite3.c"
   _sqlite3VdbeChangeP3($8,$288,$291); //@line 96709 "c/sqlite3.c"
   $$1469 = $291;
   break;
  }
  case 70:  {
   $316 = ((($0)) + 124|0); //@line 96803 "c/sqlite3.c"
   $317 = HEAP32[$316>>2]|0; //@line 96803 "c/sqlite3.c"
   $318 = ($317|0)==(0|0); //@line 96803 "c/sqlite3.c"
   if ($318) {
    _sqlite3ErrorMsg($0,24834,$vararg_buffer10); //@line 96804 "c/sqlite3.c"
    $$6 = 0;
    STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
   }
   $319 = ((($1)) + 1|0); //@line 96808 "c/sqlite3.c"
   $320 = HEAP8[$319>>0]|0; //@line 96808 "c/sqlite3.c"
   $321 = ($320<<24>>24)==(2); //@line 96808 "c/sqlite3.c"
   if ($321) {
    _sqlite3MayAbort($0); //@line 96809 "c/sqlite3.c"
    $$pr = HEAP8[$319>>0]|0; //@line 96812 "c/sqlite3.c"
    $323 = $$pr;
   } else {
    $323 = $320;
   }
   $322 = ($323<<24>>24)==(4); //@line 96812 "c/sqlite3.c"
   if ($322) {
    $324 = ((($1)) + 8|0); //@line 96814 "c/sqlite3.c"
    $325 = HEAP32[$324>>2]|0; //@line 96814 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4($8,66,0,4,0,$325,0)|0); //@line 96813 "c/sqlite3.c"
    $$1469 = $2;
    break L7;
   } else {
    $326 = $323 << 24 >> 24; //@line 96812 "c/sqlite3.c"
    $327 = ((($1)) + 8|0); //@line 96818 "c/sqlite3.c"
    $328 = HEAP32[$327>>2]|0; //@line 96818 "c/sqlite3.c"
    _sqlite3HaltConstraint($0,1811,$326,$328,0,0); //@line 96817 "c/sqlite3.c"
    $$1469 = $2;
    break L7;
   }
   break;
  }
  default: {
   $292 = ((($1)) + 20|0); //@line 96748 "c/sqlite3.c"
   $293 = HEAP32[$292>>2]|0; //@line 96748 "c/sqlite3.c"
   $294 = HEAP32[$293>>2]|0; //@line 96750 "c/sqlite3.c"
   $295 = (_sqlite3VdbeMakeLabel($8)|0); //@line 96751 "c/sqlite3.c"
   $296 = ((($1)) + 12|0); //@line 96752 "c/sqlite3.c"
   $297 = HEAP32[$296>>2]|0; //@line 96752 "c/sqlite3.c"
   $298 = ($297|0)!=(0|0); //@line 96752 "c/sqlite3.c"
   if ($298) {
    dest=$5; src=$297; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 96753 "c/sqlite3.c"
    $299 = (_exprCodeVector($0,$5,$3)|0); //@line 96755 "c/sqlite3.c"
    _exprToRegister($5,$299); //@line 96755 "c/sqlite3.c"
    dest=$6; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 96757 "c/sqlite3.c"
    HEAP8[$6>>0] = 53; //@line 96758 "c/sqlite3.c"
    $300 = ((($6)) + 12|0); //@line 96759 "c/sqlite3.c"
    HEAP32[$300>>2] = $5; //@line 96759 "c/sqlite3.c"
    HEAP32[$3>>2] = 0; //@line 96765 "c/sqlite3.c"
    $$0 = $6;
   } else {
    $$0 = 0;
   }
   $301 = (($294) + -1)|0; //@line 96767 "c/sqlite3.c"
   $302 = ($294|0)>(1); //@line 96767 "c/sqlite3.c"
   if ($302) {
    $303 = ((($6)) + 16|0);
    $$0470498 = 0;$$1499 = $$0;
    while(1) {
     _sqlite3ExprCachePush($0); //@line 96768 "c/sqlite3.c"
     $304 = (((($293)) + 4|0) + (($$0470498*20)|0)|0);
     $305 = HEAP32[$304>>2]|0;
     if ($298) {
      HEAP32[$303>>2] = $305; //@line 96771 "c/sqlite3.c"
      $$2 = $$1499;
     } else {
      $$2 = $305;
     }
     $306 = (_sqlite3VdbeMakeLabel($8)|0); //@line 96775 "c/sqlite3.c"
     _sqlite3ExprIfFalse($0,$$2,$306,16); //@line 96777 "c/sqlite3.c"
     $307 = $$0470498 | 1; //@line 96779 "c/sqlite3.c"
     $308 = (((($293)) + 4|0) + (($307*20)|0)|0); //@line 96779 "c/sqlite3.c"
     $309 = HEAP32[$308>>2]|0; //@line 96779 "c/sqlite3.c"
     _sqlite3ExprCode($0,$309,$2); //@line 96779 "c/sqlite3.c"
     _sqlite3VdbeGoto($8,$295); //@line 96780 "c/sqlite3.c"
     _sqlite3ExprCachePop($0); //@line 96781 "c/sqlite3.c"
     _sqlite3VdbeResolveLabel($8,$306); //@line 96782 "c/sqlite3.c"
     $310 = (($$0470498) + 2)|0; //@line 96767 "c/sqlite3.c"
     $311 = ($310|0)<($301|0); //@line 96767 "c/sqlite3.c"
     if ($311) {
      $$0470498 = $310;$$1499 = $$2;
     } else {
      break;
     }
    }
   }
   $312 = $294 & 1; //@line 96784 "c/sqlite3.c"
   $313 = ($312|0)==(0); //@line 96784 "c/sqlite3.c"
   if ($313) {
    (_sqlite3VdbeAddOp2($8,70,0,$2)|0); //@line 96789 "c/sqlite3.c"
   } else {
    _sqlite3ExprCachePush($0); //@line 96785 "c/sqlite3.c"
    $314 = (((($293)) + 4|0) + (($301*20)|0)|0); //@line 96786 "c/sqlite3.c"
    $315 = HEAP32[$314>>2]|0; //@line 96786 "c/sqlite3.c"
    _sqlite3ExprCode($0,$315,$2); //@line 96786 "c/sqlite3.c"
    _sqlite3ExprCachePop($0); //@line 96787 "c/sqlite3.c"
   }
   _sqlite3VdbeResolveLabel($8,$295); //@line 96793 "c/sqlite3.c"
   $$1469 = $2;
  }
  }
 } while(0);
 do {
  if ((label|0) == 9) {
   $31 = ((($1)) + 28|0); //@line 96214 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 96214 "c/sqlite3.c"
   $33 = ($32|0)<(0); //@line 96215 "c/sqlite3.c"
   do {
    if ($33) {
     $34 = ((($0)) + 56|0); //@line 96216 "c/sqlite3.c"
     $35 = HEAP32[$34>>2]|0; //@line 96216 "c/sqlite3.c"
     $36 = ($35|0)<(0); //@line 96216 "c/sqlite3.c"
     if (!($36)) {
      $41 = (($35) + -1)|0; //@line 96222 "c/sqlite3.c"
      $$0479 = $41;
      break;
     }
     $37 = ((($1)) + 32|0); //@line 96218 "c/sqlite3.c"
     $38 = HEAP16[$37>>1]|0; //@line 96218 "c/sqlite3.c"
     $39 = $38 << 16 >> 16; //@line 96218 "c/sqlite3.c"
     $40 = (($39) - ($35))|0; //@line 96218 "c/sqlite3.c"
     $$6 = $40;
     STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
    } else {
     $$0479 = $32;
    }
   } while(0);
   $42 = ((($1)) + 44|0); //@line 96225 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 96225 "c/sqlite3.c"
   $44 = ((($1)) + 32|0); //@line 96226 "c/sqlite3.c"
   $45 = HEAP16[$44>>1]|0; //@line 96226 "c/sqlite3.c"
   $46 = $45 << 16 >> 16; //@line 96226 "c/sqlite3.c"
   $47 = ((($1)) + 38|0); //@line 96227 "c/sqlite3.c"
   $48 = HEAP8[$47>>0]|0; //@line 96227 "c/sqlite3.c"
   $49 = (_sqlite3ExprCodeGetColumn($0,$43,$46,$$0479,$2,$48)|0); //@line 96225 "c/sqlite3.c"
   $$6 = $49;
   STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
  }
  else if ((label|0) == 26) {
   $87 = ((($1)) + 12|0); //@line 96307 "c/sqlite3.c"
   $88 = HEAP32[$87>>2]|0; //@line 96307 "c/sqlite3.c"
   $89 = (_sqlite3ExprIsVector($88)|0); //@line 96308 "c/sqlite3.c"
   $90 = ($89|0)==(0); //@line 96308 "c/sqlite3.c"
   if ($90) {
    $93 = (_sqlite3ExprCodeTemp($0,$88,$3)|0); //@line 96311 "c/sqlite3.c"
    $94 = ((($1)) + 16|0); //@line 96312 "c/sqlite3.c"
    $95 = HEAP32[$94>>2]|0; //@line 96312 "c/sqlite3.c"
    $96 = (_sqlite3ExprCodeTemp($0,$95,$4)|0); //@line 96312 "c/sqlite3.c"
    $97 = HEAP32[$94>>2]|0; //@line 96313 "c/sqlite3.c"
    $98 = $$0473 | 32; //@line 96314 "c/sqlite3.c"
    _codeCompare($0,$88,$97,$$1467,$93,$96,$2,$98); //@line 96313 "c/sqlite3.c"
    $$1469 = $2;
    break;
   } else {
    $91 = $$1467&255; //@line 96309 "c/sqlite3.c"
    $92 = $$0473&255; //@line 96309 "c/sqlite3.c"
    _codeVectorCompare($0,$1,$2,$91,$92); //@line 96309 "c/sqlite3.c"
    $$1469 = $2;
    break;
   }
  }
 } while(0);
 $329 = HEAP32[$3>>2]|0; //@line 96825 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$329); //@line 96825 "c/sqlite3.c"
 $330 = HEAP32[$4>>2]|0; //@line 96826 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$330); //@line 96826 "c/sqlite3.c"
 $$6 = $$1469;
 STACKTOP = sp;return ($$6|0); //@line 96828 "c/sqlite3.c"
}
function _sqlite3ExprCodeGetColumn($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$03336 = 0, $$034 = 0, $$037 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ((($0)) + 8|0); //@line 96028 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 96028 "c/sqlite3.c"
 $8 = ((($0)) + 25|0); //@line 96032 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 96032 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 96032 "c/sqlite3.c"
 L1: do {
  if (!($10)) {
   $11 = ((($0)) + 148|0); //@line 96032 "c/sqlite3.c"
   $$03336 = 0;$$037 = $11;
   while(1) {
    $12 = HEAP32[$$037>>2]|0; //@line 96033 "c/sqlite3.c"
    $13 = ($12|0)==($3|0); //@line 96033 "c/sqlite3.c"
    if ($13) {
     $14 = ((($$037)) + 4|0); //@line 96033 "c/sqlite3.c"
     $15 = HEAP16[$14>>1]|0; //@line 96033 "c/sqlite3.c"
     $16 = $15 << 16 >> 16; //@line 96033 "c/sqlite3.c"
     $17 = ($16|0)==($2|0); //@line 96033 "c/sqlite3.c"
     if ($17) {
      break;
     }
    }
    $25 = (($$03336) + 1)|0; //@line 96032 "c/sqlite3.c"
    $26 = ((($$037)) + 20|0); //@line 96032 "c/sqlite3.c"
    $27 = HEAP8[$8>>0]|0; //@line 96032 "c/sqlite3.c"
    $28 = $27&255; //@line 96032 "c/sqlite3.c"
    $29 = ($25>>>0)<($28>>>0); //@line 96032 "c/sqlite3.c"
    if ($29) {
     $$03336 = $25;$$037 = $26;
    } else {
     break L1;
    }
   }
   $18 = ((($0)) + 64|0); //@line 96034 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 96034 "c/sqlite3.c"
   $20 = (($19) + 1)|0; //@line 96034 "c/sqlite3.c"
   HEAP32[$18>>2] = $20; //@line 96034 "c/sqlite3.c"
   $21 = ((($$037)) + 16|0); //@line 96034 "c/sqlite3.c"
   HEAP32[$21>>2] = $19; //@line 96034 "c/sqlite3.c"
   $22 = ((($$037)) + 12|0); //@line 96035 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 96035 "c/sqlite3.c"
   _sqlite3ExprCachePinRegister($0,$23); //@line 96035 "c/sqlite3.c"
   $24 = HEAP32[$22>>2]|0; //@line 96036 "c/sqlite3.c"
   $$034 = $24;
   return ($$034|0); //@line 96047 "c/sqlite3.c"
  }
 } while(0);
 _sqlite3ExprCodeGetColumnOfTable($7,$1,$3,$2,$4); //@line 96040 "c/sqlite3.c"
 $30 = ($5<<24>>24)==(0); //@line 96041 "c/sqlite3.c"
 if ($30) {
  _sqlite3ExprCacheStore($0,$3,$2,$4); //@line 96044 "c/sqlite3.c"
  $$034 = $4;
  return ($$034|0); //@line 96047 "c/sqlite3.c"
 } else {
  $31 = $5&255; //@line 96042 "c/sqlite3.c"
  _sqlite3VdbeChangeP5($7,$31); //@line 96042 "c/sqlite3.c"
  $$034 = $4;
  return ($$034|0); //@line 96047 "c/sqlite3.c"
 }
 return (0)|0;
}
function _codeInteger($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond$not = 0;
 var $or$cond3 = 0, $or$cond5 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp + 8|0;
 $4 = sp;
 $5 = ((($0)) + 8|0); //@line 95784 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 95784 "c/sqlite3.c"
 $7 = ((($1)) + 4|0); //@line 95785 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 95785 "c/sqlite3.c"
 $9 = $8 & 1024; //@line 95785 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 95785 "c/sqlite3.c"
 if (!($10)) {
  $11 = ((($1)) + 8|0); //@line 95786 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 95786 "c/sqlite3.c"
  $13 = ($2|0)==(0); //@line 95788 "c/sqlite3.c"
  $14 = (0 - ($12))|0; //@line 95788 "c/sqlite3.c"
  $spec$select = $13 ? $12 : $14; //@line 95788 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($6,67,$spec$select,$3)|0); //@line 95789 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 95814 "c/sqlite3.c"
 }
 $15 = ((($1)) + 8|0); //@line 95793 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 95793 "c/sqlite3.c"
 $17 = (_sqlite3DecOrHexToI64($16,$4)|0); //@line 95795 "c/sqlite3.c"
 $18 = ($17|0)!=(3); //@line 95796 "c/sqlite3.c"
 $19 = ($2|0)!=(0); //@line 95796 "c/sqlite3.c"
 $or$cond = $19 | $18; //@line 95796 "c/sqlite3.c"
 $or$cond$not = $or$cond ^ 1; //@line 95796 "c/sqlite3.c"
 $20 = ($17|0)==(2); //@line 95796 "c/sqlite3.c"
 $or$cond3 = $20 | $or$cond$not; //@line 95796 "c/sqlite3.c"
 if ($or$cond3) {
  label = 5;
 } else {
  $21 = $4; //@line 95796 "c/sqlite3.c"
  $22 = $21; //@line 95796 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 95796 "c/sqlite3.c"
  $24 = (($21) + 4)|0; //@line 95796 "c/sqlite3.c"
  $25 = $24; //@line 95796 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 95796 "c/sqlite3.c"
  $27 = ($23|0)==(0); //@line 95796 "c/sqlite3.c"
  $28 = ($26|0)==(-2147483648); //@line 95796 "c/sqlite3.c"
  $29 = $27 & $28; //@line 95796 "c/sqlite3.c"
  $or$cond5 = $19 & $29; //@line 95796 "c/sqlite3.c"
  if ($or$cond5) {
   label = 5;
  } else {
   if ($19) {
    $33 = ($17|0)==(3); //@line 95810 "c/sqlite3.c"
    $34 = (_i64Subtract(0,0,($23|0),($26|0))|0); //@line 95810 "c/sqlite3.c"
    $35 = tempRet0; //@line 95810 "c/sqlite3.c"
    $36 = $33 ? 0 : $34; //@line 95810 "c/sqlite3.c"
    $37 = $33 ? -2147483648 : $35; //@line 95810 "c/sqlite3.c"
    $38 = $4; //@line 95810 "c/sqlite3.c"
    $39 = $38; //@line 95810 "c/sqlite3.c"
    HEAP32[$39>>2] = $36; //@line 95810 "c/sqlite3.c"
    $40 = (($38) + 4)|0; //@line 95810 "c/sqlite3.c"
    $41 = $40; //@line 95810 "c/sqlite3.c"
    HEAP32[$41>>2] = $37; //@line 95810 "c/sqlite3.c"
   }
   _sqlite3VdbeAddOp4Dup8($6,68,$3,$4,-14); //@line 95811 "c/sqlite3.c"
  }
 }
 do {
  if ((label|0) == 5) {
   $30 = (_sqlite3_strnicmp($16,25008,2)|0); //@line 95801 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 95801 "c/sqlite3.c"
   if ($31) {
    $32 = $19 ? 22143 : 41388; //@line 95802 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $32; //@line 95802 "c/sqlite3.c"
    $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 95802 "c/sqlite3.c"
    HEAP32[$vararg_ptr1>>2] = $16; //@line 95802 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,25011,$vararg_buffer); //@line 95802 "c/sqlite3.c"
    break;
   } else {
    _codeReal($6,$16,$2,$3); //@line 95806 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 STACKTOP = sp;return; //@line 95814 "c/sqlite3.c"
}
function _codeReal($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ($1|0)==(0|0); //@line 95766 "c/sqlite3.c"
 if ($5) {
  STACKTOP = sp;return; //@line 95773 "c/sqlite3.c"
 }
 $6 = (_sqlite3Strlen30($1)|0); //@line 95768 "c/sqlite3.c"
 (_sqlite3AtoF($1,$4,$6,1)|0); //@line 95768 "c/sqlite3.c"
 $7 = ($2|0)==(0); //@line 95770 "c/sqlite3.c"
 if (!($7)) {
  $8 = +HEAPF64[$4>>3]; //@line 95770 "c/sqlite3.c"
  $9 = - $8; //@line 95770 "c/sqlite3.c"
  HEAPF64[$4>>3] = $9; //@line 95770 "c/sqlite3.c"
 }
 _sqlite3VdbeAddOp4Dup8($0,132,$3,$4,-13); //@line 95771 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 95773 "c/sqlite3.c"
}
function _sqlite3VListNumToName($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$013 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 30057 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 30065 "c/sqlite3.c"
 }
 $3 = ((($0)) + 4|0); //@line 30058 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 30058 "c/sqlite3.c"
 $$013 = 2;
 while(1) {
  $5 = (($0) + ($$013<<2)|0); //@line 30061 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 30061 "c/sqlite3.c"
  $7 = ($6|0)==($1|0); //@line 30061 "c/sqlite3.c"
  if ($7) {
   break;
  }
  $10 = (($$013) + 1)|0; //@line 30062 "c/sqlite3.c"
  $11 = (($0) + ($10<<2)|0); //@line 30062 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 30062 "c/sqlite3.c"
  $13 = (($12) + ($$013))|0; //@line 30062 "c/sqlite3.c"
  $14 = ($13|0)<($4|0); //@line 30063 "c/sqlite3.c"
  if ($14) {
   $$013 = $13;
  } else {
   $$0 = 0;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  return ($$0|0); //@line 30065 "c/sqlite3.c"
 }
 $8 = (($$013) + 2)|0; //@line 30061 "c/sqlite3.c"
 $9 = (($0) + ($8<<2)|0); //@line 30061 "c/sqlite3.c"
 $$0 = $9;
 return ($$0|0); //@line 30065 "c/sqlite3.c"
}
function _sqlite3ExprCacheAffinityChange($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3ExprCacheRemove($0,$1,$2); //@line 96086 "c/sqlite3.c"
 return; //@line 96087 "c/sqlite3.c"
}
function _sqlite3ExprIsVector($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3ExprVectorSize($0)|0); //@line 93052 "c/sqlite3.c"
 $2 = ($1|0)>(1); //@line 93052 "c/sqlite3.c"
 $3 = $2&1; //@line 93052 "c/sqlite3.c"
 return ($3|0); //@line 93052 "c/sqlite3.c"
}
function _codeVectorCompare($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$074 = 0, $$075 = 0, $$177 = 0, $$2 = 0, $$278 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$select79 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $5 = sp + 16|0;
 $6 = sp + 12|0;
 $7 = sp + 8|0;
 $8 = sp + 4|0;
 $9 = ((($0)) + 8|0); //@line 93235 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 93235 "c/sqlite3.c"
 $11 = ((($1)) + 12|0); //@line 93236 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 93236 "c/sqlite3.c"
 $13 = ((($1)) + 16|0); //@line 93237 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 93237 "c/sqlite3.c"
 $15 = (_sqlite3ExprVectorSize($12)|0); //@line 93238 "c/sqlite3.c"
 $16 = (_sqlite3VdbeMakeLabel($10)|0); //@line 93243 "c/sqlite3.c"
 $17 = (_sqlite3ExprVectorSize($14)|0); //@line 93245 "c/sqlite3.c"
 $18 = ($15|0)==($17|0); //@line 93245 "c/sqlite3.c"
 if (!($18)) {
  _sqlite3ErrorMsg($0,23693,$vararg_buffer); //@line 93246 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 93304 "c/sqlite3.c"
 }
 $19 = $4 | 32; //@line 93259 "c/sqlite3.c"
 $20 = ($3<<24>>24)==(55); //@line 93260 "c/sqlite3.c"
 $spec$select = $20 ? 56 : $3; //@line 93260 "c/sqlite3.c"
 $21 = ($spec$select<<24>>24)==(57); //@line 93261 "c/sqlite3.c"
 $$177 = $21 ? 54 : $spec$select; //@line 93261 "c/sqlite3.c"
 $22 = (_exprCodeSubselect($0,$12)|0); //@line 93263 "c/sqlite3.c"
 $23 = (_exprCodeSubselect($0,$14)|0); //@line 93264 "c/sqlite3.c"
 $24 = (($15) + -1)|0;
 $25 = (($15) + -2)|0;
 $$0 = $19;$$074 = 0;$$278 = $$177;
 while(1) {
  HEAP32[$5>>2] = 0; //@line 93267 "c/sqlite3.c"
  HEAP32[$6>>2] = 0; //@line 93267 "c/sqlite3.c"
  $26 = ($$074|0)!=(0); //@line 93271 "c/sqlite3.c"
  if ($26) {
   _sqlite3ExprCachePush($0); //@line 93271 "c/sqlite3.c"
  }
  $27 = (_exprVectorRegister($0,$12,$$074,$22,$7,$5)|0); //@line 93272 "c/sqlite3.c"
  $28 = (_exprVectorRegister($0,$14,$$074,$23,$8,$6)|0); //@line 93273 "c/sqlite3.c"
  $29 = HEAP32[$7>>2]|0; //@line 93274 "c/sqlite3.c"
  $30 = HEAP32[$8>>2]|0; //@line 93274 "c/sqlite3.c"
  $31 = $$278&255; //@line 93274 "c/sqlite3.c"
  $32 = $$0&255; //@line 93274 "c/sqlite3.c"
  _codeCompare($0,$29,$30,$31,$27,$28,$2,$32); //@line 93274 "c/sqlite3.c"
  $33 = HEAP32[$5>>2]|0; //@line 93281 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$33); //@line 93281 "c/sqlite3.c"
  $34 = HEAP32[$6>>2]|0; //@line 93282 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$34); //@line 93282 "c/sqlite3.c"
  if ($26) {
   _sqlite3ExprCachePop($0); //@line 93283 "c/sqlite3.c"
  }
  $35 = ($$074|0)==($24|0); //@line 93284 "c/sqlite3.c"
  L13: do {
   if ($35) {
    $$075 = 0;$$2 = $$0;$$4 = $$278;
   } else {
    switch ($$278<<24>>24) {
    case 53:  {
     (_sqlite3VdbeAddOp2($10,22,$2,$16)|0); //@line 93288 "c/sqlite3.c"
     $36 = $32 | 8; //@line 93289 "c/sqlite3.c"
     $37 = $36&255; //@line 93289 "c/sqlite3.c"
     $$075 = 1;$$2 = $37;$$4 = 53;
     break L13;
     break;
    }
    case 52:  {
     (_sqlite3VdbeAddOp2($10,21,$2,$16)|0); //@line 93291 "c/sqlite3.c"
     $38 = $32 | 8; //@line 93292 "c/sqlite3.c"
     $39 = $38&255; //@line 93292 "c/sqlite3.c"
     $$075 = 1;$$2 = $39;$$4 = 52;
     break L13;
     break;
    }
    default: {
     (_sqlite3VdbeAddOp2($10,58,0,$16)|0); //@line 93295 "c/sqlite3.c"
     $40 = ($$074|0)==($25|0); //@line 93300 "c/sqlite3.c"
     $spec$select79 = $40 ? $3 : $$278; //@line 93300 "c/sqlite3.c"
     $$075 = 1;$$2 = $$0;$$4 = $spec$select79;
     break L13;
    }
    }
   }
  } while(0);
  $41 = (($$074) + 1)|0; //@line 93266 "c/sqlite3.c"
  if ($$075) {
   $$0 = $$2;$$074 = $41;$$278 = $$4;
  } else {
   break;
  }
 }
 _sqlite3VdbeResolveLabel($10,$16); //@line 93303 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 93304 "c/sqlite3.c"
}
function _sqlite3ExprCodeTemp($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ExprSkipCollate($1)|0); //@line 96883 "c/sqlite3.c"
 $4 = ((($0)) + 23|0); //@line 96884 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 96884 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 96884 "c/sqlite3.c"
 if (!($6)) {
  $7 = HEAP8[$3>>0]|0; //@line 96885 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(-106); //@line 96885 "c/sqlite3.c"
  if (!($8)) {
   $9 = (_sqlite3ExprIsConstantNotJoin($3)|0); //@line 96886 "c/sqlite3.c"
   $10 = ($9|0)==(0); //@line 96886 "c/sqlite3.c"
   if (!($10)) {
    HEAP32[$2>>2] = 0; //@line 96888 "c/sqlite3.c"
    $11 = (_sqlite3ExprCodeAtInit($0,$3,-1)|0); //@line 96889 "c/sqlite3.c"
    $$0 = $11;
    return ($$0|0); //@line 96900 "c/sqlite3.c"
   }
  }
 }
 $12 = (_sqlite3GetTempReg($0)|0); //@line 96891 "c/sqlite3.c"
 $13 = (_sqlite3ExprCodeTarget($0,$3,$12)|0); //@line 96892 "c/sqlite3.c"
 $14 = ($13|0)==($12|0); //@line 96893 "c/sqlite3.c"
 if ($14) {
  $storemerge = $12;
 } else {
  _sqlite3ReleaseTempReg($0,$12); //@line 96896 "c/sqlite3.c"
  $storemerge = 0;
 }
 HEAP32[$2>>2] = $storemerge;
 $$0 = $13;
 return ($$0|0); //@line 96900 "c/sqlite3.c"
}
function _codeCompare($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = (_sqlite3BinaryCompareCollSeq($0,$1,$2)|0); //@line 93034 "c/sqlite3.c"
 $9 = (_binaryCompareP5($1,$2,$7)|0); //@line 93035 "c/sqlite3.c"
 $10 = ((($0)) + 8|0); //@line 93036 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 93036 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($11,$3,$5,$6,$4,$8,-2)|0); //@line 93036 "c/sqlite3.c"
 $12 = HEAP32[$10>>2]|0; //@line 93038 "c/sqlite3.c"
 $13 = $9&255; //@line 93038 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($12,$13); //@line 93038 "c/sqlite3.c"
 return;
}
function _sqlite3ExprIsConstantNotJoin($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_exprIsConst($0,2,0)|0); //@line 94535 "c/sqlite3.c"
 return ($1|0); //@line 94535 "c/sqlite3.c"
}
function _sqlite3ExprCodeAtInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03945 = 0, $$04044 = 0, $$041 = 0, $$1 = 0, $$142 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 76|0); //@line 96846 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 96846 "c/sqlite3.c"
 $5 = ($2|0)<(0); //@line 96847 "c/sqlite3.c"
 $6 = ($4|0)!=(0|0); //@line 96847 "c/sqlite3.c"
 $or$cond = $5 & $6; //@line 96847 "c/sqlite3.c"
 L1: do {
  if ($or$cond) {
   $7 = HEAP32[$4>>2]|0; //@line 96850 "c/sqlite3.c"
   $8 = ($7|0)>(0); //@line 96850 "c/sqlite3.c"
   if ($8) {
    $9 = ((($4)) + 4|0); //@line 96850 "c/sqlite3.c"
    $$03945 = $7;$$04044 = $9;
    while(1) {
     $10 = ((($$04044)) + 13|0); //@line 96851 "c/sqlite3.c"
     $11 = HEAP8[$10>>0]|0; //@line 96851 "c/sqlite3.c"
     $12 = $11 & 4; //@line 96851 "c/sqlite3.c"
     $13 = ($12<<24>>24)==(0); //@line 96851 "c/sqlite3.c"
     if (!($13)) {
      $14 = HEAP32[$$04044>>2]|0; //@line 96851 "c/sqlite3.c"
      $15 = (_sqlite3ExprCompare(0,$14,$1,-1)|0); //@line 96851 "c/sqlite3.c"
      $16 = ($15|0)==(0); //@line 96851 "c/sqlite3.c"
      if ($16) {
       break;
      }
     }
     $17 = ((($$04044)) + 20|0); //@line 96850 "c/sqlite3.c"
     $18 = (($$03945) + -1)|0; //@line 96850 "c/sqlite3.c"
     $19 = ($$03945|0)>(1); //@line 96850 "c/sqlite3.c"
     if ($19) {
      $$03945 = $18;$$04044 = $17;
     } else {
      break L1;
     }
    }
    $20 = ((($$04044)) + 16|0); //@line 96852 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 96852 "c/sqlite3.c"
    $$1 = $21;
    return ($$1|0); //@line 96866 "c/sqlite3.c"
   }
  }
 } while(0);
 $22 = HEAP32[$0>>2]|0; //@line 96856 "c/sqlite3.c"
 $23 = (_sqlite3ExprDup($22,$1,0)|0); //@line 96856 "c/sqlite3.c"
 $24 = (_sqlite3ExprListAppend($0,$4,$23)|0); //@line 96857 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 96858 "c/sqlite3.c"
 if ($25) {
  $$142 = $2;
 } else {
  $26 = HEAP32[$24>>2]|0; //@line 96859 "c/sqlite3.c"
  $27 = (($26) + -1)|0; //@line 96859 "c/sqlite3.c"
  $28 = (((((($24)) + 4|0) + (($27*20)|0)|0)) + 13|0); //@line 96860 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 96860 "c/sqlite3.c"
  $30 = $2 >>> 29; //@line 96860 "c/sqlite3.c"
  $31 = $30&255; //@line 96860 "c/sqlite3.c"
  $32 = $31 & 4; //@line 96860 "c/sqlite3.c"
  $33 = $29 & -5; //@line 96860 "c/sqlite3.c"
  $34 = $33 | $32; //@line 96860 "c/sqlite3.c"
  HEAP8[$28>>0] = $34; //@line 96860 "c/sqlite3.c"
  if ($5) {
   $35 = ((($0)) + 44|0); //@line 96861 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 96861 "c/sqlite3.c"
   $37 = (($36) + 1)|0; //@line 96861 "c/sqlite3.c"
   HEAP32[$35>>2] = $37; //@line 96861 "c/sqlite3.c"
   $$041 = $37;
  } else {
   $$041 = $2;
  }
  $38 = (((((($24)) + 4|0) + (($27*20)|0)|0)) + 16|0); //@line 96862 "c/sqlite3.c"
  HEAP32[$38>>2] = $$041; //@line 96862 "c/sqlite3.c"
  $$142 = $$041;
 }
 HEAP32[$3>>2] = $24; //@line 96864 "c/sqlite3.c"
 $$1 = $$142;
 return ($$1|0); //@line 96866 "c/sqlite3.c"
}
function _sqlite3ExprIsConstant($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_exprIsConst($0,1,0)|0); //@line 94525 "c/sqlite3.c"
 return ($1|0); //@line 94525 "c/sqlite3.c"
}
function _sqlite3ExprCodeExprList($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$06571 = 0, $$06670 = 0, $$067$lcssa = 0, $$06769 = 0, $$1 = 0, $$168 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = $4&255; //@line 97002 "c/sqlite3.c"
 $6 = $5 & 1; //@line 97002 "c/sqlite3.c"
 $7 = (76 - ($6))|0; //@line 97002 "c/sqlite3.c"
 $8 = ((($0)) + 8|0); //@line 97003 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 97003 "c/sqlite3.c"
 $10 = HEAP32[$1>>2]|0; //@line 97007 "c/sqlite3.c"
 $11 = ($10|0)>(0); //@line 97009 "c/sqlite3.c"
 if (!($11)) {
  $$067$lcssa = $10;
  return ($$067$lcssa|0); //@line 97036 "c/sqlite3.c"
 }
 $12 = ((($1)) + 4|0); //@line 97009 "c/sqlite3.c"
 $13 = ((($0)) + 23|0); //@line 97008 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 97008 "c/sqlite3.c"
 $15 = ($14<<24>>24)==(0); //@line 97008 "c/sqlite3.c"
 $16 = $5 & 253; //@line 97008 "c/sqlite3.c"
 $17 = $16&255; //@line 97008 "c/sqlite3.c"
 $$0 = $15 ? $17 : $4; //@line 97008 "c/sqlite3.c"
 $18 = $$0&255;
 $19 = $18 & 4;
 $20 = ($19|0)==(0);
 $21 = $18 & 2;
 $22 = ($21|0)==(0);
 $23 = $18 & 8;
 $24 = ($23|0)==(0);
 $25 = ($7|0)==(75);
 $26 = (($3) + -1)|0;
 $$06571 = $12;$$06670 = 0;$$06769 = $10;
 while(1) {
  $27 = HEAP32[$$06571>>2]|0; //@line 97010 "c/sqlite3.c"
  do {
   if ($20) {
    label = 8;
   } else {
    $28 = ((($$06571)) + 16|0); //@line 97011 "c/sqlite3.c"
    $29 = HEAP16[$28>>1]|0; //@line 97011 "c/sqlite3.c"
    $30 = $29&65535; //@line 97011 "c/sqlite3.c"
    $31 = ($29<<16>>16)==(0); //@line 97011 "c/sqlite3.c"
    if ($31) {
     label = 8;
    } else {
     if ($24) {
      $34 = (($26) + ($30))|0; //@line 97016 "c/sqlite3.c"
      $35 = (($$06670) + ($2))|0; //@line 97016 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($9,$7,$34,$35)|0); //@line 97016 "c/sqlite3.c"
      $$1 = $$06670;$$168 = $$06769;
      break;
     } else {
      $32 = (($$06670) + -1)|0; //@line 97013 "c/sqlite3.c"
      $33 = (($$06769) + -1)|0; //@line 97014 "c/sqlite3.c"
      $$1 = $32;$$168 = $33;
      break;
     }
    }
   }
  } while(0);
  do {
   if ((label|0) == 8) {
    label = 0;
    if (!($22)) {
     $36 = (_sqlite3ExprIsConstant($27)|0); //@line 97018 "c/sqlite3.c"
     $37 = ($36|0)==(0); //@line 97018 "c/sqlite3.c"
     if (!($37)) {
      $38 = (($$06670) + ($2))|0; //@line 97019 "c/sqlite3.c"
      (_sqlite3ExprCodeAtInit($0,$27,$38)|0); //@line 97019 "c/sqlite3.c"
      $$1 = $$06670;$$168 = $$06769;
      break;
     }
    }
    $39 = (($$06670) + ($2))|0; //@line 97021 "c/sqlite3.c"
    $40 = (_sqlite3ExprCodeTarget($0,$27,$39)|0); //@line 97021 "c/sqlite3.c"
    $41 = ($40|0)==($39|0); //@line 97022 "c/sqlite3.c"
    if ($41) {
     $$1 = $$06670;$$168 = $$06769;
    } else {
     if ($25) {
      $42 = (_sqlite3VdbeGetOp($9,-1)|0); //@line 97025 "c/sqlite3.c"
      $43 = HEAP8[$42>>0]|0; //@line 97025 "c/sqlite3.c"
      $44 = ($43<<24>>24)==(75); //@line 97025 "c/sqlite3.c"
      if ($44) {
       $45 = ((($42)) + 4|0); //@line 97026 "c/sqlite3.c"
       $46 = HEAP32[$45>>2]|0; //@line 97026 "c/sqlite3.c"
       $47 = ((($42)) + 12|0); //@line 97026 "c/sqlite3.c"
       $48 = HEAP32[$47>>2]|0; //@line 97026 "c/sqlite3.c"
       $49 = (($48) + 1)|0; //@line 97026 "c/sqlite3.c"
       $50 = (($49) + ($46))|0; //@line 97026 "c/sqlite3.c"
       $51 = ($50|0)==($40|0); //@line 97026 "c/sqlite3.c"
       if ($51) {
        $52 = ((($42)) + 8|0); //@line 97027 "c/sqlite3.c"
        $53 = HEAP32[$52>>2]|0; //@line 97027 "c/sqlite3.c"
        $54 = (($48) + 1)|0; //@line 97027 "c/sqlite3.c"
        $55 = (($54) + ($53))|0; //@line 97027 "c/sqlite3.c"
        $56 = ($55|0)==($39|0); //@line 97027 "c/sqlite3.c"
        if ($56) {
         $57 = (($48) + 1)|0; //@line 97029 "c/sqlite3.c"
         HEAP32[$47>>2] = $57; //@line 97029 "c/sqlite3.c"
         $$1 = $$06670;$$168 = $$06769;
         break;
        }
       }
      }
     }
     (_sqlite3VdbeAddOp2($9,$7,$40,$39)|0); //@line 97031 "c/sqlite3.c"
     $$1 = $$06670;$$168 = $$06769;
    }
   }
  } while(0);
  $58 = (($$1) + 1)|0; //@line 97009 "c/sqlite3.c"
  $59 = ((($$06571)) + 20|0); //@line 97009 "c/sqlite3.c"
  $60 = ($58|0)<($$168|0); //@line 97009 "c/sqlite3.c"
  if ($60) {
   $$06571 = $59;$$06670 = $58;$$06769 = $$168;
  } else {
   $$067$lcssa = $$168;
   break;
  }
 }
 return ($$067$lcssa|0); //@line 97036 "c/sqlite3.c"
}
function _sqlite3VtabOverloadFunction($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$058 = 0, $$060 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 HEAP32[$4>>2] = 0; //@line 128407 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 128408 "c/sqlite3.c"
 $6 = ($3|0)==(0|0); //@line 128416 "c/sqlite3.c"
 if ($6) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $7 = HEAP8[$3>>0]|0; //@line 128417 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(-111); //@line 128417 "c/sqlite3.c"
 if (!($8)) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $9 = ((($3)) + 44|0); //@line 128418 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 128418 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 128419 "c/sqlite3.c"
 if ($11) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $12 = ((($10)) + 56|0); //@line 128420 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 128420 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 128420 "c/sqlite3.c"
 if ($14) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $15 = (_sqlite3GetVTable($0,$10)|0); //@line 128421 "c/sqlite3.c"
 $16 = ((($15)) + 8|0); //@line 128421 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 128421 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 128424 "c/sqlite3.c"
 $19 = ((($18)) + 72|0); //@line 128425 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 128425 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 128425 "c/sqlite3.c"
 if ($21) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $22 = ((($1)) + 20|0); //@line 128430 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 128430 "c/sqlite3.c"
 $24 = (_sqlite3DbStrDup($0,$23)|0); //@line 128430 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 128431 "c/sqlite3.c"
 if ($25) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $26 = HEAP8[$24>>0]|0; //@line 128432 "c/sqlite3.c"
 $27 = ($26<<24>>24)==(0); //@line 128432 "c/sqlite3.c"
 if (!($27)) {
  $$060 = $24;$29 = $26;
  while(1) {
   $28 = $29&255; //@line 128433 "c/sqlite3.c"
   $30 = (16025 + ($28)|0); //@line 128433 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 128433 "c/sqlite3.c"
   HEAP8[$$060>>0] = $31; //@line 128433 "c/sqlite3.c"
   $32 = ((($$060)) + 1|0); //@line 128432 "c/sqlite3.c"
   $33 = HEAP8[$32>>0]|0; //@line 128432 "c/sqlite3.c"
   $34 = ($33<<24>>24)==(0); //@line 128432 "c/sqlite3.c"
   if ($34) {
    break;
   } else {
    $$060 = $32;$29 = $33;
   }
  }
 }
 $35 = HEAP32[$19>>2]|0; //@line 128435 "c/sqlite3.c"
 $36 = (FUNCTION_TABLE_iiiiii[$35 & 127]($17,$2,$24,$4,$5)|0); //@line 128435 "c/sqlite3.c"
 _sqlite3DbFree($0,$24); //@line 128436 "c/sqlite3.c"
 $phitmp = ($36|0)==(0); //@line 128437 "c/sqlite3.c"
 if ($phitmp) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 $37 = HEAP32[$22>>2]|0; //@line 128445 "c/sqlite3.c"
 $38 = (_sqlite3Strlen30($37)|0); //@line 128445 "c/sqlite3.c"
 $39 = (($38) + 29)|0; //@line 128445 "c/sqlite3.c"
 $40 = (_sqlite3DbMallocZero($0,$39,0)|0); //@line 128444 "c/sqlite3.c"
 $41 = ($40|0)==(0|0); //@line 128446 "c/sqlite3.c"
 if ($41) {
  $$058 = $1;
  STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
 }
 ;HEAP32[$40>>2]=HEAP32[$1>>2]|0;HEAP32[$40+4>>2]=HEAP32[$1+4>>2]|0;HEAP32[$40+8>>2]=HEAP32[$1+8>>2]|0;HEAP32[$40+12>>2]=HEAP32[$1+12>>2]|0;HEAP32[$40+16>>2]=HEAP32[$1+16>>2]|0;HEAP32[$40+20>>2]=HEAP32[$1+20>>2]|0;HEAP32[$40+24>>2]=HEAP32[$1+24>>2]|0; //@line 128449 "c/sqlite3.c"
 $42 = ((($40)) + 28|0); //@line 128450 "c/sqlite3.c"
 $43 = ((($40)) + 20|0); //@line 128450 "c/sqlite3.c"
 HEAP32[$43>>2] = $42; //@line 128450 "c/sqlite3.c"
 $44 = HEAP32[$22>>2]|0; //@line 128451 "c/sqlite3.c"
 $45 = (_sqlite3Strlen30($44)|0); //@line 128451 "c/sqlite3.c"
 $46 = (($45) + 1)|0; //@line 128451 "c/sqlite3.c"
 _memcpy(($42|0),($44|0),($46|0))|0; //@line 128451 "c/sqlite3.c"
 $47 = HEAP32[$4>>2]|0; //@line 128452 "c/sqlite3.c"
 $48 = ((($40)) + 12|0); //@line 128452 "c/sqlite3.c"
 HEAP32[$48>>2] = $47; //@line 128452 "c/sqlite3.c"
 $49 = HEAP32[$5>>2]|0; //@line 128453 "c/sqlite3.c"
 $50 = ((($40)) + 4|0); //@line 128453 "c/sqlite3.c"
 HEAP32[$50>>2] = $49; //@line 128453 "c/sqlite3.c"
 $51 = ((($40)) + 2|0); //@line 128454 "c/sqlite3.c"
 $52 = HEAP16[$51>>1]|0; //@line 128454 "c/sqlite3.c"
 $53 = $52 | 16; //@line 128454 "c/sqlite3.c"
 HEAP16[$51>>1] = $53; //@line 128454 "c/sqlite3.c"
 $$058 = $40;
 STACKTOP = sp;return ($$058|0); //@line 128456 "c/sqlite3.c"
}
function _sqlite3SubselectError($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 95178 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $1; //@line 95180 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 95180 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $2; //@line 95180 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,24964,$vararg_buffer); //@line 95180 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 95181 "c/sqlite3.c"
}
function _sqlite3CodeSubselect($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0184 = 0, $$0196209 = 0, $$0197207 = 0, $$0198206 = 0, $$1185$lcssa = 0, $$1185208 = 0, $$1191 = 0, $$2186 = 0, $$3187 = 0, $$5189 = 0, $$6 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0;
 var $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0;
 var $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond4 = 0, $exitcond = 0, $spec$store$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer = sp;
 $4 = sp + 16|0;
 $5 = sp + 12|0;
 $6 = (_sqlite3GetVdbe($0)|0); //@line 95244 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 95245 "c/sqlite3.c"
 if ($7) {
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 95473 "c/sqlite3.c"
 }
 _sqlite3ExprCachePush($0); //@line 95246 "c/sqlite3.c"
 $8 = ((($1)) + 4|0); //@line 95258 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 95258 "c/sqlite3.c"
 $10 = $9 & 32; //@line 95258 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 95258 "c/sqlite3.c"
 if ($11) {
  $12 = (_sqlite3VdbeAddOp0($6,20)|0); //@line 95259 "c/sqlite3.c"
  $$0184 = $12;
 } else {
  $$0184 = -1;
 }
 $13 = ((($0)) + 399|0); //@line 95263 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 95263 "c/sqlite3.c"
 $15 = ($14<<24>>24)==(2); //@line 95263 "c/sqlite3.c"
 if ($15) {
  $16 = HEAP32[$0>>2]|0; //@line 95264 "c/sqlite3.c"
  $17 = ($$0184|0)>(-1); //@line 95265 "c/sqlite3.c"
  $18 = $17 ? 41388 : 24915; //@line 95265 "c/sqlite3.c"
  $19 = HEAP8[$1>>0]|0; //@line 95266 "c/sqlite3.c"
  $20 = ($19<<24>>24)==(49); //@line 95266 "c/sqlite3.c"
  $21 = $20 ? 24927 : 24932; //@line 95266 "c/sqlite3.c"
  $22 = ((($0)) + 416|0); //@line 95267 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 95267 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $18; //@line 95264 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 95264 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $21; //@line 95264 "c/sqlite3.c"
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 95264 "c/sqlite3.c"
  HEAP32[$vararg_ptr2>>2] = $23; //@line 95264 "c/sqlite3.c"
  $24 = (_sqlite3MPrintf($16,24939,$vararg_buffer)|0); //@line 95264 "c/sqlite3.c"
  $25 = ((($0)) + 412|0); //@line 95269 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 95269 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4($6,169,$26,0,0,$24,-7)|0); //@line 95269 "c/sqlite3.c"
 }
 $27 = HEAP8[$1>>0]|0; //@line 95273 "c/sqlite3.c"
 $cond4 = ($27<<24>>24)==(49); //@line 95273 "c/sqlite3.c"
 if ($cond4) {
  $28 = ((($1)) + 12|0); //@line 95276 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 95276 "c/sqlite3.c"
  $30 = (_sqlite3ExprVectorSize($29)|0); //@line 95280 "c/sqlite3.c"
  $31 = ((($0)) + 40|0); //@line 95296 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 95296 "c/sqlite3.c"
  $33 = (($32) + 1)|0; //@line 95296 "c/sqlite3.c"
  HEAP32[$31>>2] = $33; //@line 95296 "c/sqlite3.c"
  $34 = ((($1)) + 28|0); //@line 95296 "c/sqlite3.c"
  HEAP32[$34>>2] = $32; //@line 95296 "c/sqlite3.c"
  $35 = ($3|0)!=(0); //@line 95298 "c/sqlite3.c"
  $36 = $35 ? 0 : $30; //@line 95298 "c/sqlite3.c"
  $37 = (_sqlite3VdbeAddOp2($6,109,$32,$36)|0); //@line 95297 "c/sqlite3.c"
  if ($35) {
   $62 = 0;
  } else {
   $38 = HEAP32[$0>>2]|0; //@line 95299 "c/sqlite3.c"
   $39 = (_sqlite3KeyInfoAlloc($38,$30,1)|0); //@line 95299 "c/sqlite3.c"
   $62 = $39;
  }
  $40 = HEAP32[$8>>2]|0; //@line 95301 "c/sqlite3.c"
  $41 = $40 & 2048; //@line 95301 "c/sqlite3.c"
  $42 = ($41|0)==(0); //@line 95301 "c/sqlite3.c"
  if ($42) {
   $64 = ((($1)) + 20|0); //@line 95338 "c/sqlite3.c"
   $65 = HEAP32[$64>>2]|0; //@line 95338 "c/sqlite3.c"
   $66 = ($65|0)==(0|0); //@line 95338 "c/sqlite3.c"
   if ($66) {
    $$3187 = $$0184;
   } else {
    $67 = (_sqlite3ExprAffinity($29)|0); //@line 95352 "c/sqlite3.c"
    $68 = ($67<<24>>24)==(0); //@line 95353 "c/sqlite3.c"
    $spec$store$select = $68 ? 65 : $67; //@line 95353 "c/sqlite3.c"
    HEAP8[$4>>0] = $spec$store$select;
    $69 = ($62|0)==(0|0); //@line 95356 "c/sqlite3.c"
    if (!($69)) {
     $70 = HEAP32[$28>>2]|0; //@line 95358 "c/sqlite3.c"
     $71 = (_sqlite3ExprCollSeq($0,$70)|0); //@line 95358 "c/sqlite3.c"
     $72 = ((($62)) + 20|0); //@line 95358 "c/sqlite3.c"
     HEAP32[$72>>2] = $71; //@line 95358 "c/sqlite3.c"
    }
    $73 = (_sqlite3GetTempReg($0)|0); //@line 95362 "c/sqlite3.c"
    $74 = (_sqlite3GetTempReg($0)|0); //@line 95363 "c/sqlite3.c"
    if ($35) {
     (_sqlite3VdbeAddOp4($6,72,0,$74,0,41388,-1)|0); //@line 95364 "c/sqlite3.c"
    }
    $75 = HEAP32[$65>>2]|0; //@line 95365 "c/sqlite3.c"
    $76 = ($75|0)>(0); //@line 95365 "c/sqlite3.c"
    if ($76) {
     $77 = ((($65)) + 4|0); //@line 95365 "c/sqlite3.c"
     $$0197207 = $75;$$0198206 = $77;$$1185208 = $$0184;
     while(1) {
      $78 = HEAP32[$$0198206>>2]|0; //@line 95366 "c/sqlite3.c"
      $79 = ($$1185208|0)>(-1); //@line 95374 "c/sqlite3.c"
      if ($79) {
       $80 = (_sqlite3ExprIsConstant($78)|0); //@line 95374 "c/sqlite3.c"
       $81 = ($80|0)==(0); //@line 95374 "c/sqlite3.c"
       if ($81) {
        (_sqlite3VdbeChangeToNoop($6,$$1185208)|0); //@line 95375 "c/sqlite3.c"
        $$2186 = -1;
       } else {
        $$2186 = $$1185208;
       }
      } else {
       $$2186 = $$1185208;
      }
      do {
       if ($35) {
        $82 = (_sqlite3ExprIsInteger($78,$5)|0); //@line 95380 "c/sqlite3.c"
        $83 = ($82|0)==(0); //@line 95380 "c/sqlite3.c"
        if ($83) {
         $86 = (_sqlite3ExprCodeTarget($0,$78,$73)|0); //@line 95383 "c/sqlite3.c"
         $87 = (_sqlite3VdbeCurrentAddr($6)|0); //@line 95386 "c/sqlite3.c"
         $88 = (($87) + 2)|0; //@line 95386 "c/sqlite3.c"
         (_sqlite3VdbeAddOp2($6,17,$86,$88)|0); //@line 95385 "c/sqlite3.c"
         $89 = HEAP32[$34>>2]|0; //@line 95388 "c/sqlite3.c"
         (_sqlite3VdbeAddOp3($6,117,$89,$74,$86)|0); //@line 95388 "c/sqlite3.c"
         break;
        } else {
         $84 = HEAP32[$34>>2]|0; //@line 95381 "c/sqlite3.c"
         $85 = HEAP32[$5>>2]|0; //@line 95381 "c/sqlite3.c"
         (_sqlite3VdbeAddOp3($6,118,$84,$74,$85)|0); //@line 95381 "c/sqlite3.c"
         break;
        }
       } else {
        $90 = (_sqlite3ExprCodeTarget($0,$78,$73)|0); //@line 95383 "c/sqlite3.c"
        (_sqlite3VdbeAddOp4($6,100,$90,1,$74,$4,1)|0); //@line 95390 "c/sqlite3.c"
        _sqlite3ExprCacheAffinityChange($0,$90,1); //@line 95391 "c/sqlite3.c"
        $91 = HEAP32[$34>>2]|0; //@line 95392 "c/sqlite3.c"
        (_sqlite3VdbeAddOp4Int($6,128,$91,$74,$90,1)|0); //@line 95392 "c/sqlite3.c"
       }
      } while(0);
      $92 = (($$0197207) + -1)|0; //@line 95365 "c/sqlite3.c"
      $93 = ((($$0198206)) + 20|0); //@line 95365 "c/sqlite3.c"
      $94 = ($$0197207|0)>(1); //@line 95365 "c/sqlite3.c"
      if ($94) {
       $$0197207 = $92;$$0198206 = $93;$$1185208 = $$2186;
      } else {
       $$1185$lcssa = $$2186;
       break;
      }
     }
    } else {
     $$1185$lcssa = $$0184;
    }
    _sqlite3ReleaseTempReg($0,$73); //@line 95396 "c/sqlite3.c"
    _sqlite3ReleaseTempReg($0,$74); //@line 95397 "c/sqlite3.c"
    $$3187 = $$1185$lcssa;
   }
  } else {
   $43 = ((($1)) + 20|0); //@line 95307 "c/sqlite3.c"
   $44 = HEAP32[$43>>2]|0; //@line 95307 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 95308 "c/sqlite3.c"
   $46 = HEAP32[$45>>2]|0; //@line 95313 "c/sqlite3.c"
   $47 = ($46|0)==($30|0); //@line 95313 "c/sqlite3.c"
   if ($47) {
    $48 = HEAP32[$34>>2]|0; //@line 95316 "c/sqlite3.c"
    _sqlite3SelectDestInit($4,11,$48); //@line 95316 "c/sqlite3.c"
    $49 = (_exprINAffinity($0,$1)|0); //@line 95317 "c/sqlite3.c"
    $50 = ((($4)) + 16|0); //@line 95317 "c/sqlite3.c"
    HEAP32[$50>>2] = $49; //@line 95317 "c/sqlite3.c"
    $51 = ((($44)) + 12|0); //@line 95318 "c/sqlite3.c"
    HEAP32[$51>>2] = 0; //@line 95318 "c/sqlite3.c"
    $52 = (_sqlite3Select($0,$44,$4)|0); //@line 95321 "c/sqlite3.c"
    $53 = ($52|0)==(0); //@line 95321 "c/sqlite3.c"
    $54 = HEAP32[$0>>2]|0;
    $55 = HEAP32[$50>>2]|0;
    _sqlite3DbFree($54,$55);
    if (!($53)) {
     _sqlite3KeyInfoUnref($62); //@line 95323 "c/sqlite3.c"
     $$6 = 0;
     STACKTOP = sp;return ($$6|0); //@line 95473 "c/sqlite3.c"
    }
    $56 = ($30|0)>(0); //@line 95331 "c/sqlite3.c"
    if ($56) {
     $$0196209 = 0;
     while(1) {
      $57 = (_sqlite3VectorFieldSubexpr($29,$$0196209)|0); //@line 95332 "c/sqlite3.c"
      $58 = (((($45)) + 4|0) + (($$0196209*20)|0)|0); //@line 95334 "c/sqlite3.c"
      $59 = HEAP32[$58>>2]|0; //@line 95334 "c/sqlite3.c"
      $60 = (_sqlite3BinaryCompareCollSeq($0,$57,$59)|0); //@line 95333 "c/sqlite3.c"
      $61 = (((($62)) + 20|0) + ($$0196209<<2)|0); //@line 95333 "c/sqlite3.c"
      HEAP32[$61>>2] = $60; //@line 95333 "c/sqlite3.c"
      $63 = (($$0196209) + 1)|0; //@line 95331 "c/sqlite3.c"
      $exitcond = ($63|0)==($30|0); //@line 95331 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$0196209 = $63;
      }
     }
    }
    $$3187 = $$0184;
   } else {
    $$3187 = $$0184;
   }
  }
  $95 = ($62|0)==(0|0); //@line 95399 "c/sqlite3.c"
  if ($95) {
   $$1191 = 0;$$5189 = $$3187;
  } else {
   _sqlite3VdbeChangeP4($6,$37,$62,-9); //@line 95400 "c/sqlite3.c"
   $$1191 = 0;$$5189 = $$3187;
  }
 } else {
  $96 = ((($1)) + 20|0); //@line 95431 "c/sqlite3.c"
  $97 = HEAP32[$96>>2]|0; //@line 95431 "c/sqlite3.c"
  $98 = ($27<<24>>24)==(119); //@line 95432 "c/sqlite3.c"
  if ($98) {
   $99 = HEAP32[$97>>2]|0; //@line 95432 "c/sqlite3.c"
   $100 = HEAP32[$99>>2]|0; //@line 95432 "c/sqlite3.c"
   $106 = $100;
  } else {
   $106 = 1;
  }
  $101 = ((($0)) + 44|0); //@line 95433 "c/sqlite3.c"
  $102 = HEAP32[$101>>2]|0; //@line 95433 "c/sqlite3.c"
  $103 = (($102) + 1)|0; //@line 95433 "c/sqlite3.c"
  _sqlite3SelectDestInit($4,0,$103); //@line 95433 "c/sqlite3.c"
  $104 = HEAP32[$101>>2]|0; //@line 95434 "c/sqlite3.c"
  $105 = (($104) + ($106))|0; //@line 95434 "c/sqlite3.c"
  HEAP32[$101>>2] = $105; //@line 95434 "c/sqlite3.c"
  $107 = HEAP8[$1>>0]|0; //@line 95435 "c/sqlite3.c"
  $108 = ($107<<24>>24)==(119); //@line 95435 "c/sqlite3.c"
  if ($108) {
   HEAP8[$4>>0] = 10; //@line 95436 "c/sqlite3.c"
   $109 = ((($4)) + 4|0); //@line 95437 "c/sqlite3.c"
   $110 = HEAP32[$109>>2]|0; //@line 95437 "c/sqlite3.c"
   $111 = ((($4)) + 8|0); //@line 95437 "c/sqlite3.c"
   HEAP32[$111>>2] = $110; //@line 95437 "c/sqlite3.c"
   $112 = ((($4)) + 12|0); //@line 95438 "c/sqlite3.c"
   HEAP32[$112>>2] = $106; //@line 95438 "c/sqlite3.c"
   $113 = (($106) + -1)|0; //@line 95439 "c/sqlite3.c"
   $114 = (($113) + ($110))|0; //@line 95439 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($6,70,0,$110,$114)|0); //@line 95439 "c/sqlite3.c"
  } else {
   HEAP8[$4>>0] = 3; //@line 95442 "c/sqlite3.c"
   $115 = ((($4)) + 4|0); //@line 95443 "c/sqlite3.c"
   $116 = HEAP32[$115>>2]|0; //@line 95443 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($6,67,0,$116)|0); //@line 95443 "c/sqlite3.c"
  }
  $117 = HEAP32[$0>>2]|0; //@line 95446 "c/sqlite3.c"
  $118 = (_sqlite3ExprAlloc($117,134,(4988),0)|0); //@line 95446 "c/sqlite3.c"
  $119 = ((($97)) + 56|0); //@line 95447 "c/sqlite3.c"
  $120 = HEAP32[$119>>2]|0; //@line 95447 "c/sqlite3.c"
  $121 = ($120|0)==(0|0); //@line 95447 "c/sqlite3.c"
  if ($121) {
   $127 = (_sqlite3PExpr($0,129,$118,0)|0); //@line 95451 "c/sqlite3.c"
   HEAP32[$119>>2] = $127; //@line 95451 "c/sqlite3.c"
  } else {
   $122 = HEAP32[$0>>2]|0; //@line 95448 "c/sqlite3.c"
   $123 = ((($120)) + 12|0); //@line 95448 "c/sqlite3.c"
   $124 = HEAP32[$123>>2]|0; //@line 95448 "c/sqlite3.c"
   _sqlite3ExprDelete($122,$124); //@line 95448 "c/sqlite3.c"
   $125 = HEAP32[$119>>2]|0; //@line 95449 "c/sqlite3.c"
   $126 = ((($125)) + 12|0); //@line 95449 "c/sqlite3.c"
   HEAP32[$126>>2] = $118; //@line 95449 "c/sqlite3.c"
  }
  $128 = ((($97)) + 12|0); //@line 95453 "c/sqlite3.c"
  HEAP32[$128>>2] = 0; //@line 95453 "c/sqlite3.c"
  $129 = (_sqlite3Select($0,$97,$4)|0); //@line 95454 "c/sqlite3.c"
  $130 = ($129|0)==(0); //@line 95454 "c/sqlite3.c"
  $131 = ((($4)) + 4|0); //@line 95457 "c/sqlite3.c"
  $132 = HEAP32[$131>>2]|0; //@line 95457 "c/sqlite3.c"
  if ($130) {
   $$1191 = $132;$$5189 = $$0184;
  } else {
   $$6 = 0;
   STACKTOP = sp;return ($$6|0); //@line 95473 "c/sqlite3.c"
  }
 }
 $133 = ($2|0)==(0); //@line 95463 "c/sqlite3.c"
 if (!($133)) {
  $134 = ((($1)) + 28|0); //@line 95464 "c/sqlite3.c"
  $135 = HEAP32[$134>>2]|0; //@line 95464 "c/sqlite3.c"
  _sqlite3SetHasNullFlag($6,$135,$2); //@line 95464 "c/sqlite3.c"
 }
 $136 = ($$5189|0)>(-1); //@line 95467 "c/sqlite3.c"
 if ($136) {
  _sqlite3VdbeJumpHere($6,$$5189); //@line 95468 "c/sqlite3.c"
 }
 _sqlite3ExprCachePop($0); //@line 95470 "c/sqlite3.c"
 $$6 = $$1191;
 STACKTOP = sp;return ($$6|0); //@line 95473 "c/sqlite3.c"
}
function _sqlite3ExprCodeIN($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$ = 0, $$0 = 0, $$0230$lcssa = 0, $$0230249 = 0, $$0231237 = 0, $$0232 = 0, $$0233 = 0, $$0234 = 0, $$0235 = 0, $$0236256 = 0, $$1246 = 0, $$2242 = 0, $$3238 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $brmerge = 0, $exitcond = 0, $exitcond254 = 0, $exitcond255 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 8|0;
 $5 = sp + 4|0;
 $6 = sp;
 HEAP32[$4>>2] = 0; //@line 95530 "c/sqlite3.c"
 $7 = ((($1)) + 12|0); //@line 95547 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 95547 "c/sqlite3.c"
 $9 = (_sqlite3ExprCheckIN($0,$1)|0); //@line 95548 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 95548 "c/sqlite3.c"
 if (!($10)) {
  STACKTOP = sp;return; //@line 95753 "c/sqlite3.c"
 }
 $11 = (_exprINAffinity($0,$1)|0); //@line 95549 "c/sqlite3.c"
 $12 = HEAP32[$7>>2]|0; //@line 95550 "c/sqlite3.c"
 $13 = (_sqlite3ExprVectorSize($12)|0); //@line 95550 "c/sqlite3.c"
 $14 = HEAP32[$0>>2]|0; //@line 95552 "c/sqlite3.c"
 $15 = ($13*5)|0; //@line 95552 "c/sqlite3.c"
 $16 = (($15) + 1)|0; //@line 95552 "c/sqlite3.c"
 $17 = (_sqlite3DbMallocZero($14,$16,0)|0); //@line 95551 "c/sqlite3.c"
 $18 = HEAP32[$0>>2]|0; //@line 95554 "c/sqlite3.c"
 $19 = ((($18)) + 73|0); //@line 95554 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 95554 "c/sqlite3.c"
 $21 = ($20<<24>>24)==(0); //@line 95554 "c/sqlite3.c"
 if ($21) {
  $22 = ((($0)) + 8|0); //@line 95560 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 95560 "c/sqlite3.c"
  $24 = ($2|0)==($3|0); //@line 95565 "c/sqlite3.c"
  $$ = $24 ? 0 : $4; //@line 95565 "c/sqlite3.c"
  $25 = (_sqlite3FindInIndex($0,$1,3,$$,$17)|0); //@line 95563 "c/sqlite3.c"
  _sqlite3ExprCachePush($0); //@line 95589 "c/sqlite3.c"
  $26 = (_exprCodeVector($0,$8,$5)|0); //@line 95590 "c/sqlite3.c"
  $27 = ($13|0)>(0); //@line 95591 "c/sqlite3.c"
  L6: do {
   if ($27) {
    $$0230249 = 0;
    while(1) {
     $28 = (($17) + ($$0230249<<2)|0); //@line 95591 "c/sqlite3.c"
     $29 = HEAP32[$28>>2]|0; //@line 95591 "c/sqlite3.c"
     $30 = ($29|0)==($$0230249|0); //@line 95591 "c/sqlite3.c"
     if (!($30)) {
      $$0230$lcssa = $$0230249;
      break L6;
     }
     $31 = (($$0230249) + 1)|0; //@line 95591 "c/sqlite3.c"
     $32 = ($31|0)<($13|0); //@line 95591 "c/sqlite3.c"
     if ($32) {
      $$0230249 = $31;
     } else {
      $$0230$lcssa = $31;
      break;
     }
    }
   } else {
    $$0230$lcssa = 0;
   }
  } while(0);
  $33 = ($$0230$lcssa|0)==($13|0); //@line 95592 "c/sqlite3.c"
  if ($33) {
   $$0 = $26;
  } else {
   $34 = (_sqlite3GetTempRange($0,$13)|0); //@line 95597 "c/sqlite3.c"
   $35 = ($13|0)>(0); //@line 95598 "c/sqlite3.c"
   if ($35) {
    $$1246 = 0;
    while(1) {
     $36 = (($$1246) + ($26))|0; //@line 95599 "c/sqlite3.c"
     $37 = (($17) + ($$1246<<2)|0); //@line 95599 "c/sqlite3.c"
     $38 = HEAP32[$37>>2]|0; //@line 95599 "c/sqlite3.c"
     $39 = (($38) + ($34))|0; //@line 95599 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($23,75,$36,$39,0)|0); //@line 95599 "c/sqlite3.c"
     $40 = (($$1246) + 1)|0; //@line 95598 "c/sqlite3.c"
     $exitcond255 = ($40|0)==($13|0); //@line 95598 "c/sqlite3.c"
     if ($exitcond255) {
      $$0 = $34;
      break;
     } else {
      $$1246 = $40;
     }
    }
   } else {
    $$0 = $34;
   }
  }
  $41 = ($25|0)==(5); //@line 95609 "c/sqlite3.c"
  L18: do {
   if ($41) {
    $42 = ((($1)) + 20|0); //@line 95610 "c/sqlite3.c"
    $43 = HEAP32[$42>>2]|0; //@line 95610 "c/sqlite3.c"
    $44 = HEAP32[$7>>2]|0; //@line 95611 "c/sqlite3.c"
    $45 = (_sqlite3ExprCollSeq($0,$44)|0); //@line 95611 "c/sqlite3.c"
    $46 = (_sqlite3VdbeMakeLabel($23)|0); //@line 95612 "c/sqlite3.c"
    $47 = ($3|0)!=($2|0); //@line 95617 "c/sqlite3.c"
    if ($47) {
     $48 = (_sqlite3GetTempReg($0)|0); //@line 95618 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($23,84,$$0,$$0,$48)|0); //@line 95619 "c/sqlite3.c"
     $$0232 = $48;
    } else {
     $$0232 = 0;
    }
    $49 = HEAP32[$43>>2]|0; //@line 95621 "c/sqlite3.c"
    $50 = ($49|0)>(0); //@line 95621 "c/sqlite3.c"
    if ($50) {
     $51 = ($$0232|0)==(0);
     $$0231237 = 0;
     while(1) {
      $52 = (((($43)) + 4|0) + (($$0231237*20)|0)|0); //@line 95622 "c/sqlite3.c"
      $53 = HEAP32[$52>>2]|0; //@line 95622 "c/sqlite3.c"
      $54 = (_sqlite3ExprCodeTemp($0,$53,$6)|0); //@line 95622 "c/sqlite3.c"
      if (!($51)) {
       $55 = HEAP32[$52>>2]|0; //@line 95623 "c/sqlite3.c"
       $56 = (_sqlite3ExprCanBeNull($55)|0); //@line 95623 "c/sqlite3.c"
       $57 = ($56|0)==(0); //@line 95623 "c/sqlite3.c"
       if (!($57)) {
        (_sqlite3VdbeAddOp3($23,84,$$0232,$54,$$0232)|0); //@line 95624 "c/sqlite3.c"
       }
      }
      $58 = HEAP32[$43>>2]|0; //@line 95626 "c/sqlite3.c"
      $59 = (($58) + -1)|0; //@line 95626 "c/sqlite3.c"
      $60 = ($$0231237|0)<($59|0); //@line 95626 "c/sqlite3.c"
      $brmerge = $47 | $60; //@line 95626 "c/sqlite3.c"
      if ($brmerge) {
       (_sqlite3VdbeAddOp4($23,53,$$0,$46,$54,$45,-2)|0); //@line 95627 "c/sqlite3.c"
       $61 = HEAP8[$11>>0]|0; //@line 95631 "c/sqlite3.c"
       $62 = $61 << 24 >> 24; //@line 95631 "c/sqlite3.c"
       _sqlite3VdbeChangeP5($23,$62); //@line 95631 "c/sqlite3.c"
      } else {
       (_sqlite3VdbeAddOp4($23,52,$$0,$2,$54,$45,-2)|0); //@line 95634 "c/sqlite3.c"
       $63 = HEAP8[$11>>0]|0; //@line 95636 "c/sqlite3.c"
       $64 = $63 | 16; //@line 95636 "c/sqlite3.c"
       $65 = $64 << 24 >> 24; //@line 95636 "c/sqlite3.c"
       _sqlite3VdbeChangeP5($23,$65); //@line 95636 "c/sqlite3.c"
      }
      $66 = HEAP32[$6>>2]|0; //@line 95638 "c/sqlite3.c"
      _sqlite3ReleaseTempReg($0,$66); //@line 95638 "c/sqlite3.c"
      $67 = (($$0231237) + 1)|0; //@line 95621 "c/sqlite3.c"
      $68 = HEAP32[$43>>2]|0; //@line 95621 "c/sqlite3.c"
      $69 = ($67|0)<($68|0); //@line 95621 "c/sqlite3.c"
      if ($69) {
       $$0231237 = $67;
      } else {
       break;
      }
     }
    }
    $70 = ($$0232|0)==(0); //@line 95640 "c/sqlite3.c"
    if (!($70)) {
     (_sqlite3VdbeAddOp2($23,50,$$0232,$3)|0); //@line 95641 "c/sqlite3.c"
     _sqlite3VdbeGoto($23,$2); //@line 95642 "c/sqlite3.c"
    }
    _sqlite3VdbeResolveLabel($23,$46); //@line 95644 "c/sqlite3.c"
    _sqlite3ReleaseTempReg($0,$$0232); //@line 95645 "c/sqlite3.c"
   } else {
    if ($24) {
     $$0233 = $2;$$0234 = 0;
    } else {
     $71 = (_sqlite3VdbeMakeLabel($23)|0); //@line 95656 "c/sqlite3.c"
     $$0233 = $71;$$0234 = $71;
    }
    $72 = ($13|0)>(0); //@line 95658 "c/sqlite3.c"
    if ($72) {
     $$2242 = 0;
     while(1) {
      $73 = HEAP32[$7>>2]|0; //@line 95659 "c/sqlite3.c"
      $74 = (_sqlite3VectorFieldSubexpr($73,$$2242)|0); //@line 95659 "c/sqlite3.c"
      $75 = (_sqlite3ExprCanBeNull($74)|0); //@line 95660 "c/sqlite3.c"
      $76 = ($75|0)==(0); //@line 95660 "c/sqlite3.c"
      if (!($76)) {
       $77 = (($$2242) + ($$0))|0; //@line 95661 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($23,50,$77,$$0233)|0); //@line 95661 "c/sqlite3.c"
      }
      $78 = (($$2242) + 1)|0; //@line 95658 "c/sqlite3.c"
      $exitcond254 = ($78|0)==($13|0); //@line 95658 "c/sqlite3.c"
      if ($exitcond254) {
       break;
      } else {
       $$2242 = $78;
      }
     }
    }
    $79 = ($25|0)==(1); //@line 95670 "c/sqlite3.c"
    do {
     if ($79) {
      $80 = ((($1)) + 28|0); //@line 95674 "c/sqlite3.c"
      $81 = HEAP32[$80>>2]|0; //@line 95674 "c/sqlite3.c"
      (_sqlite3VdbeAddOp3($23,31,$81,$2,$$0)|0); //@line 95674 "c/sqlite3.c"
      $82 = (_sqlite3VdbeAddOp0($23,13)|0); //@line 95676 "c/sqlite3.c"
      $$0235 = $82;
     } else {
      (_sqlite3VdbeAddOp4($23,99,$$0,$13,0,$11,$13)|0); //@line 95678 "c/sqlite3.c"
      $83 = ((($1)) + 28|0);
      $84 = HEAP32[$83>>2]|0;
      if ($24) {
       (_sqlite3VdbeAddOp4Int($23,29,$84,$2,$$0,$13)|0); //@line 95681 "c/sqlite3.c"
       break L18;
      } else {
       $85 = (_sqlite3VdbeAddOp4Int($23,30,$84,0,$$0,$13)|0); //@line 95686 "c/sqlite3.c"
       $$0235 = $85;
       break;
      }
     }
    } while(0);
    $86 = HEAP32[$4>>2]|0; //@line 95693 "c/sqlite3.c"
    $87 = ($86|0)!=(0); //@line 95693 "c/sqlite3.c"
    $88 = ($13|0)==(1); //@line 95693 "c/sqlite3.c"
    $or$cond = $88 & $87; //@line 95693 "c/sqlite3.c"
    if ($or$cond) {
     (_sqlite3VdbeAddOp2($23,51,$86,$2)|0); //@line 95694 "c/sqlite3.c"
    }
    if ($24) {
     _sqlite3VdbeGoto($23,$2); //@line 95701 "c/sqlite3.c"
    }
    $89 = ($$0234|0)==(0); //@line 95710 "c/sqlite3.c"
    if (!($89)) {
     _sqlite3VdbeResolveLabel($23,$$0234); //@line 95710 "c/sqlite3.c"
    }
    $90 = ((($1)) + 28|0); //@line 95711 "c/sqlite3.c"
    $91 = HEAP32[$90>>2]|0; //@line 95711 "c/sqlite3.c"
    $92 = (_sqlite3VdbeAddOp2($23,37,$91,$2)|0); //@line 95711 "c/sqlite3.c"
    $93 = ($13|0)>(1); //@line 95713 "c/sqlite3.c"
    if ($93) {
     $94 = (_sqlite3VdbeMakeLabel($23)|0); //@line 95714 "c/sqlite3.c"
     $$0236256 = $94;
     label = 48;
    } else {
     $95 = ($13|0)==(1); //@line 95720 "c/sqlite3.c"
     if ($95) {
      $$0236256 = $2;
      label = 48;
     } else {
      (_sqlite3VdbeAddOp2($23,13,0,$3)|0); //@line 95732 "c/sqlite3.c"
     }
    }
    if ((label|0) == 48) {
     $$3238 = 0;
     while(1) {
      $96 = (_sqlite3GetTempReg($0)|0); //@line 95723 "c/sqlite3.c"
      $97 = (_sqlite3VectorFieldSubexpr($8,$$3238)|0); //@line 95724 "c/sqlite3.c"
      $98 = (_sqlite3ExprCollSeq($0,$97)|0); //@line 95725 "c/sqlite3.c"
      $99 = HEAP32[$90>>2]|0; //@line 95726 "c/sqlite3.c"
      (_sqlite3VdbeAddOp3($23,98,$99,$$3238,$96)|0); //@line 95726 "c/sqlite3.c"
      $100 = (($$3238) + ($$0))|0; //@line 95727 "c/sqlite3.c"
      (_sqlite3VdbeAddOp4($23,52,$100,$$0236256,$96,$98,-2)|0); //@line 95727 "c/sqlite3.c"
      _sqlite3ReleaseTempReg($0,$96); //@line 95730 "c/sqlite3.c"
      $101 = (($$3238) + 1)|0; //@line 95720 "c/sqlite3.c"
      $exitcond = ($101|0)==($13|0); //@line 95720 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$3238 = $101;
      }
     }
     (_sqlite3VdbeAddOp2($23,13,0,$3)|0); //@line 95732 "c/sqlite3.c"
     if ($93) {
      $102 = (($92) + 1)|0; //@line 95735 "c/sqlite3.c"
      _sqlite3VdbeResolveLabel($23,$$0236256); //@line 95734 "c/sqlite3.c"
      $103 = HEAP32[$90>>2]|0; //@line 95735 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($23,7,$103,$102)|0); //@line 95735 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($23,13,0,$2)|0); //@line 95740 "c/sqlite3.c"
     }
    }
    _sqlite3VdbeJumpHere($23,$$0235); //@line 95744 "c/sqlite3.c"
   }
  } while(0);
  $104 = ($$0|0)==($26|0); //@line 95747 "c/sqlite3.c"
  if (!($104)) {
   _sqlite3ReleaseTempReg($0,$$0); //@line 95747 "c/sqlite3.c"
  }
  _sqlite3ExprCachePop($0); //@line 95748 "c/sqlite3.c"
 }
 $105 = HEAP32[$0>>2]|0; //@line 95751 "c/sqlite3.c"
 _sqlite3DbFree($105,$17); //@line 95751 "c/sqlite3.c"
 $106 = HEAP32[$0>>2]|0; //@line 95752 "c/sqlite3.c"
 _sqlite3DbFree($106,$11); //@line 95752 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 95753 "c/sqlite3.c"
}
function _exprCodeBetween($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 208|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(208|0);
 $5 = sp + 152|0;
 $6 = sp + 104|0;
 $7 = sp + 56|0;
 $8 = sp + 8|0;
 $9 = sp;
 HEAP32[$9>>2] = 0; //@line 97070 "c/sqlite3.c"
 dest=$6; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 97073 "c/sqlite3.c"
 dest=$7; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 97074 "c/sqlite3.c"
 dest=$5; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 97075 "c/sqlite3.c"
 $10 = ((($1)) + 12|0); //@line 97078 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 97078 "c/sqlite3.c"
 dest=$8; src=$11; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 97078 "c/sqlite3.c"
 HEAP8[$5>>0] = 44; //@line 97079 "c/sqlite3.c"
 $12 = ((($5)) + 12|0); //@line 97080 "c/sqlite3.c"
 HEAP32[$12>>2] = $6; //@line 97080 "c/sqlite3.c"
 $13 = ((($5)) + 16|0); //@line 97081 "c/sqlite3.c"
 HEAP32[$13>>2] = $7; //@line 97081 "c/sqlite3.c"
 HEAP8[$6>>0] = 57; //@line 97082 "c/sqlite3.c"
 $14 = ((($6)) + 12|0); //@line 97083 "c/sqlite3.c"
 HEAP32[$14>>2] = $8; //@line 97083 "c/sqlite3.c"
 $15 = ((($1)) + 20|0); //@line 97084 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 97084 "c/sqlite3.c"
 $17 = ((($16)) + 4|0); //@line 97084 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 97084 "c/sqlite3.c"
 $19 = ((($6)) + 16|0); //@line 97084 "c/sqlite3.c"
 HEAP32[$19>>2] = $18; //@line 97084 "c/sqlite3.c"
 HEAP8[$7>>0] = 55; //@line 97085 "c/sqlite3.c"
 $20 = ((($7)) + 12|0); //@line 97086 "c/sqlite3.c"
 HEAP32[$20>>2] = $8; //@line 97086 "c/sqlite3.c"
 $21 = ((($16)) + 24|0); //@line 97087 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 97087 "c/sqlite3.c"
 $23 = ((($7)) + 16|0); //@line 97087 "c/sqlite3.c"
 HEAP32[$23>>2] = $22; //@line 97087 "c/sqlite3.c"
 $24 = (_exprCodeVector($0,$8,$9)|0); //@line 97088 "c/sqlite3.c"
 _exprToRegister($8,$24); //@line 97088 "c/sqlite3.c"
 $25 = ($3|0)==(0|0); //@line 97089 "c/sqlite3.c"
 if ($25) {
  $26 = ((($8)) + 4|0); //@line 97097 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 97097 "c/sqlite3.c"
  $28 = $27 | 1; //@line 97097 "c/sqlite3.c"
  HEAP32[$26>>2] = $28; //@line 97097 "c/sqlite3.c"
  (_sqlite3ExprCodeTarget($0,$5,$2)|0); //@line 97098 "c/sqlite3.c"
  $29 = HEAP32[$9>>2]|0; //@line 97100 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$29); //@line 97100 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 97112 "c/sqlite3.c"
 } else {
  FUNCTION_TABLE_viiii[$3 & 127]($0,$5,$2,$4); //@line 97090 "c/sqlite3.c"
  $29 = HEAP32[$9>>2]|0; //@line 97100 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$29); //@line 97100 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 97112 "c/sqlite3.c"
 }
}
function _sqlite3VdbeChangeP3($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeGetOp($0,$1)|0); //@line 73780 "c/sqlite3.c"
 $4 = ((($3)) + 12|0); //@line 73780 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 73780 "c/sqlite3.c"
 return; //@line 73781 "c/sqlite3.c"
}
function _exprCodeVector($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$025 = 0, $$026 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ExprVectorSize($1)|0); //@line 96143 "c/sqlite3.c"
 $4 = ($3|0)==(1); //@line 96144 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3ExprCodeTemp($0,$1,$2)|0); //@line 96145 "c/sqlite3.c"
  $$025 = $5;
  return ($$025|0); //@line 96163 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = 0; //@line 96147 "c/sqlite3.c"
 $6 = HEAP8[$1>>0]|0; //@line 96148 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(119); //@line 96148 "c/sqlite3.c"
 if ($7) {
  $8 = (_sqlite3CodeSubselect($0,$1,0,0)|0); //@line 96152 "c/sqlite3.c"
  $$025 = $8;
  return ($$025|0); //@line 96163 "c/sqlite3.c"
 }
 $9 = ((($0)) + 44|0); //@line 96156 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 96156 "c/sqlite3.c"
 $11 = (($10) + 1)|0; //@line 96156 "c/sqlite3.c"
 $12 = (($10) + ($3))|0; //@line 96157 "c/sqlite3.c"
 HEAP32[$9>>2] = $12; //@line 96157 "c/sqlite3.c"
 $13 = ($3|0)>(0); //@line 96158 "c/sqlite3.c"
 if (!($13)) {
  $$025 = $11;
  return ($$025|0); //@line 96163 "c/sqlite3.c"
 }
 $14 = ((($1)) + 20|0);
 $$026 = 0;
 while(1) {
  $15 = HEAP32[$14>>2]|0; //@line 96159 "c/sqlite3.c"
  $16 = (((($15)) + 4|0) + (($$026*20)|0)|0); //@line 96159 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 96159 "c/sqlite3.c"
  $18 = (($$026) + ($11))|0; //@line 96159 "c/sqlite3.c"
  _sqlite3ExprCodeFactorable($0,$17,$18); //@line 96159 "c/sqlite3.c"
  $19 = (($$026) + 1)|0; //@line 96158 "c/sqlite3.c"
  $exitcond = ($19|0)==($3|0); //@line 96158 "c/sqlite3.c"
  if ($exitcond) {
   $$025 = $11;
   break;
  } else {
   $$026 = $19;
  }
 }
 return ($$025|0); //@line 96163 "c/sqlite3.c"
}
function _exprToRegister($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 96125 "c/sqlite3.c"
 $3 = ((($0)) + 38|0); //@line 96125 "c/sqlite3.c"
 HEAP8[$3>>0] = $2; //@line 96125 "c/sqlite3.c"
 HEAP8[$0>>0] = -106; //@line 96126 "c/sqlite3.c"
 $4 = ((($0)) + 28|0); //@line 96127 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 96127 "c/sqlite3.c"
 $5 = ((($0)) + 4|0); //@line 96128 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 96128 "c/sqlite3.c"
 $7 = $6 & -4097; //@line 96128 "c/sqlite3.c"
 HEAP32[$5>>2] = $7; //@line 96128 "c/sqlite3.c"
 return; //@line 96129 "c/sqlite3.c"
}
function _sqlite3ExprIfFalse($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$090 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 $6 = ((($0)) + 8|0); //@line 97252 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 97252 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 97254 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 97255 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 97259 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 97260 "c/sqlite3.c"
 $or$cond = $9 | $8; //@line 97259 "c/sqlite3.c"
 if ($or$cond) {
  STACKTOP = sp;return; //@line 97394 "c/sqlite3.c"
 }
 $10 = HEAP8[$1>>0]|0; //@line 97280 "c/sqlite3.c"
 $11 = $10 ^ 1; //@line 97280 "c/sqlite3.c"
 $12 = $11&255; //@line 97280 "c/sqlite3.c"
 L4: do {
  switch ($10<<24>>24) {
  case 44:  {
   $13 = ((($1)) + 12|0); //@line 97296 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 97296 "c/sqlite3.c"
   _sqlite3ExprIfFalse($0,$14,$2,$3); //@line 97296 "c/sqlite3.c"
   _sqlite3ExprCachePush($0); //@line 97297 "c/sqlite3.c"
   $15 = ((($1)) + 16|0); //@line 97298 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 97298 "c/sqlite3.c"
   _sqlite3ExprIfFalse($0,$16,$2,$3); //@line 97298 "c/sqlite3.c"
   _sqlite3ExprCachePop($0); //@line 97299 "c/sqlite3.c"
   break;
  }
  case 43:  {
   $17 = (_sqlite3VdbeMakeLabel($7)|0); //@line 97303 "c/sqlite3.c"
   $18 = ((($1)) + 12|0); //@line 97305 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 97305 "c/sqlite3.c"
   $20 = $3 ^ 16; //@line 97305 "c/sqlite3.c"
   _sqlite3ExprIfTrue($0,$19,$17,$20); //@line 97305 "c/sqlite3.c"
   _sqlite3ExprCachePush($0); //@line 97306 "c/sqlite3.c"
   $21 = ((($1)) + 16|0); //@line 97307 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 97307 "c/sqlite3.c"
   _sqlite3ExprIfFalse($0,$22,$2,$3); //@line 97307 "c/sqlite3.c"
   _sqlite3VdbeResolveLabel($7,$17); //@line 97308 "c/sqlite3.c"
   _sqlite3ExprCachePop($0); //@line 97309 "c/sqlite3.c"
   break;
  }
  case 19:  {
   $23 = ((($1)) + 12|0); //@line 97314 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 97314 "c/sqlite3.c"
   _sqlite3ExprIfTrue($0,$24,$2,$3); //@line 97314 "c/sqlite3.c"
   break;
  }
  case -113: case 45:  {
   $25 = ($10<<24>>24)==(45); //@line 97321 "c/sqlite3.c"
   $26 = $25 ? 52 : 53; //@line 97321 "c/sqlite3.c"
   $$0 = 128;$$090 = $26;
   label = 7;
   break;
  }
  case 53: case 52: case 57: case 54: case 55: case 56:  {
   $$0 = $3;$$090 = $12;
   label = 7;
   break;
  }
  case 51: case 50:  {
   $37 = ((($1)) + 12|0); //@line 97352 "c/sqlite3.c"
   $38 = HEAP32[$37>>2]|0; //@line 97352 "c/sqlite3.c"
   $39 = (_sqlite3ExprCodeTemp($0,$38,$4)|0); //@line 97352 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($7,$12,$39,$2)|0); //@line 97353 "c/sqlite3.c"
   break;
  }
  case 48:  {
   _exprCodeBetween($0,$1,$2,76,$3); //@line 97361 "c/sqlite3.c"
   break;
  }
  case 49:  {
   $40 = ($3|0)==(0); //@line 97366 "c/sqlite3.c"
   if ($40) {
    $41 = (_sqlite3VdbeMakeLabel($7)|0); //@line 97369 "c/sqlite3.c"
    _sqlite3ExprCodeIN($0,$1,$2,$41); //@line 97370 "c/sqlite3.c"
    _sqlite3VdbeResolveLabel($7,$41); //@line 97371 "c/sqlite3.c"
    break L4;
   } else {
    _sqlite3ExprCodeIN($0,$1,$2,$2); //@line 97367 "c/sqlite3.c"
    break L4;
   }
   break;
  }
  default: {
   $$1 = $3;
   label = 14;
  }
  }
 } while(0);
 if ((label|0) == 7) {
  $27 = ((($1)) + 12|0); //@line 97330 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 97330 "c/sqlite3.c"
  $29 = (_sqlite3ExprIsVector($28)|0); //@line 97330 "c/sqlite3.c"
  $30 = ($29|0)==(0); //@line 97330 "c/sqlite3.c"
  if ($30) {
   $31 = (_sqlite3ExprCodeTemp($0,$28,$4)|0); //@line 97332 "c/sqlite3.c"
   $32 = ((($1)) + 16|0); //@line 97333 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 97333 "c/sqlite3.c"
   $34 = (_sqlite3ExprCodeTemp($0,$33,$5)|0); //@line 97333 "c/sqlite3.c"
   $35 = HEAP32[$27>>2]|0; //@line 97334 "c/sqlite3.c"
   $36 = HEAP32[$32>>2]|0; //@line 97334 "c/sqlite3.c"
   _codeCompare($0,$35,$36,$$090,$31,$34,$2,$$0); //@line 97334 "c/sqlite3.c"
  } else {
   $$1 = $$0;
   label = 14;
  }
 }
 do {
  if ((label|0) == 14) {
   $42 = (_exprAlwaysFalse($1)|0); //@line 97378 "c/sqlite3.c"
   $43 = ($42|0)==(0); //@line 97378 "c/sqlite3.c"
   if (!($43)) {
    _sqlite3VdbeGoto($7,$2); //@line 97379 "c/sqlite3.c"
    break;
   }
   $44 = (_exprAlwaysTrue($1)|0); //@line 97380 "c/sqlite3.c"
   $45 = ($44|0)==(0); //@line 97380 "c/sqlite3.c"
   if ($45) {
    $46 = ($$1|0)!=(0); //@line 97384 "c/sqlite3.c"
    $47 = $46&1; //@line 97384 "c/sqlite3.c"
    $48 = (_sqlite3ExprCodeTemp($0,$1,$4)|0); //@line 97383 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($7,22,$48,$2,$47)|0); //@line 97384 "c/sqlite3.c"
   }
  }
 } while(0);
 $49 = HEAP32[$4>>2]|0; //@line 97392 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$49); //@line 97392 "c/sqlite3.c"
 $50 = HEAP32[$5>>2]|0; //@line 97393 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$50); //@line 97393 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 97394 "c/sqlite3.c"
}
function _sqlite3ExprIfTrue($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$092 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 $6 = ((($0)) + 8|0); //@line 97129 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 97129 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 97131 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 97132 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 97136 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 97137 "c/sqlite3.c"
 $or$cond = $9 | $8; //@line 97136 "c/sqlite3.c"
 if ($or$cond) {
  STACKTOP = sp;return; //@line 97240 "c/sqlite3.c"
 }
 $10 = HEAP8[$1>>0]|0; //@line 97138 "c/sqlite3.c"
 $11 = $10&255; //@line 97138 "c/sqlite3.c"
 switch ($10<<24>>24) {
 case 44:  {
  $12 = (_sqlite3VdbeMakeLabel($7)|0); //@line 97141 "c/sqlite3.c"
  $13 = ((($1)) + 12|0); //@line 97143 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 97143 "c/sqlite3.c"
  $15 = $3 ^ 16; //@line 97143 "c/sqlite3.c"
  _sqlite3ExprIfFalse($0,$14,$12,$15); //@line 97143 "c/sqlite3.c"
  _sqlite3ExprCachePush($0); //@line 97144 "c/sqlite3.c"
  $16 = ((($1)) + 16|0); //@line 97145 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 97145 "c/sqlite3.c"
  _sqlite3ExprIfTrue($0,$17,$2,$3); //@line 97145 "c/sqlite3.c"
  _sqlite3VdbeResolveLabel($7,$12); //@line 97146 "c/sqlite3.c"
  _sqlite3ExprCachePop($0); //@line 97147 "c/sqlite3.c"
  break;
 }
 case 43:  {
  $18 = ((($1)) + 12|0); //@line 97152 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 97152 "c/sqlite3.c"
  _sqlite3ExprIfTrue($0,$19,$2,$3); //@line 97152 "c/sqlite3.c"
  _sqlite3ExprCachePush($0); //@line 97153 "c/sqlite3.c"
  $20 = ((($1)) + 16|0); //@line 97154 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 97154 "c/sqlite3.c"
  _sqlite3ExprIfTrue($0,$21,$2,$3); //@line 97154 "c/sqlite3.c"
  _sqlite3ExprCachePop($0); //@line 97155 "c/sqlite3.c"
  break;
 }
 case 19:  {
  $22 = ((($1)) + 12|0); //@line 97160 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 97160 "c/sqlite3.c"
  _sqlite3ExprIfFalse($0,$23,$2,$3); //@line 97160 "c/sqlite3.c"
  break;
 }
 case -113: case 45:  {
  $24 = ($10<<24>>24)==(45); //@line 97167 "c/sqlite3.c"
  $25 = $24 ? 53 : 52; //@line 97167 "c/sqlite3.c"
  $$0 = 128;$$092 = $25;
  label = 7;
  break;
 }
 case 53: case 52: case 57: case 54: case 55: case 56:  {
  $$0 = $3;$$092 = $11;
  label = 7;
  break;
 }
 case 51: case 50:  {
  $36 = ((($1)) + 12|0); //@line 97200 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 97200 "c/sqlite3.c"
  $38 = (_sqlite3ExprCodeTemp($0,$37,$4)|0); //@line 97200 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($7,$11,$38,$2)|0); //@line 97201 "c/sqlite3.c"
  break;
 }
 case 48:  {
  _exprCodeBetween($0,$1,$2,77,$3); //@line 97209 "c/sqlite3.c"
  break;
 }
 case 49:  {
  $39 = (_sqlite3VdbeMakeLabel($7)|0); //@line 97214 "c/sqlite3.c"
  $40 = ($3|0)==(0); //@line 97215 "c/sqlite3.c"
  $41 = $40 ? $39 : $2; //@line 97215 "c/sqlite3.c"
  _sqlite3ExprCodeIN($0,$1,$39,$41); //@line 97216 "c/sqlite3.c"
  _sqlite3VdbeGoto($7,$2); //@line 97217 "c/sqlite3.c"
  _sqlite3VdbeResolveLabel($7,$39); //@line 97218 "c/sqlite3.c"
  break;
 }
 default: {
  $$1 = $3;
  label = 12;
 }
 }
 if ((label|0) == 7) {
  $26 = ((($1)) + 12|0); //@line 97176 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 97176 "c/sqlite3.c"
  $28 = (_sqlite3ExprIsVector($27)|0); //@line 97176 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 97176 "c/sqlite3.c"
  if ($29) {
   $30 = (_sqlite3ExprCodeTemp($0,$27,$4)|0); //@line 97178 "c/sqlite3.c"
   $31 = ((($1)) + 16|0); //@line 97179 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 97179 "c/sqlite3.c"
   $33 = (_sqlite3ExprCodeTemp($0,$32,$5)|0); //@line 97179 "c/sqlite3.c"
   $34 = HEAP32[$26>>2]|0; //@line 97180 "c/sqlite3.c"
   $35 = HEAP32[$31>>2]|0; //@line 97180 "c/sqlite3.c"
   _codeCompare($0,$34,$35,$$092,$30,$33,$2,$$0); //@line 97180 "c/sqlite3.c"
  } else {
   $$1 = $$0;
   label = 12;
  }
 }
 do {
  if ((label|0) == 12) {
   $42 = (_exprAlwaysTrue($1)|0); //@line 97224 "c/sqlite3.c"
   $43 = ($42|0)==(0); //@line 97224 "c/sqlite3.c"
   if (!($43)) {
    _sqlite3VdbeGoto($7,$2); //@line 97225 "c/sqlite3.c"
    break;
   }
   $44 = (_exprAlwaysFalse($1)|0); //@line 97226 "c/sqlite3.c"
   $45 = ($44|0)==(0); //@line 97226 "c/sqlite3.c"
   if ($45) {
    $46 = ($$1|0)!=(0); //@line 97230 "c/sqlite3.c"
    $47 = $46&1; //@line 97230 "c/sqlite3.c"
    $48 = (_sqlite3ExprCodeTemp($0,$1,$4)|0); //@line 97229 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($7,21,$48,$2,$47)|0); //@line 97230 "c/sqlite3.c"
   }
  }
 } while(0);
 $49 = HEAP32[$4>>2]|0; //@line 97238 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$49); //@line 97238 "c/sqlite3.c"
 $50 = HEAP32[$5>>2]|0; //@line 97239 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$50); //@line 97239 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 97240 "c/sqlite3.c"
}
function _exprAlwaysTrue($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 93591 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 93592 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 93592 "c/sqlite3.c"
 $4 = $3 & 1; //@line 93592 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 93592 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3ExprIsInteger($0,$1)|0); //@line 93593 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 93593 "c/sqlite3.c"
  if ($7) {
   $$0 = 0;
  } else {
   $8 = HEAP32[$1>>2]|0; //@line 93594 "c/sqlite3.c"
   $9 = ($8|0)!=(0); //@line 93594 "c/sqlite3.c"
   $10 = $9&1; //@line 93594 "c/sqlite3.c"
   $$0 = $10;
  }
 } else {
  $$0 = 0;
 }
 STACKTOP = sp;return ($$0|0); //@line 93595 "c/sqlite3.c"
}
function _sqlite3ExprCodeFactorable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 23|0); //@line 96942 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 96942 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 96942 "c/sqlite3.c"
 if (!($5)) {
  $6 = (_sqlite3ExprIsConstant($1)|0); //@line 96942 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 96942 "c/sqlite3.c"
  if (!($7)) {
   (_sqlite3ExprCodeAtInit($0,$1,$2)|0); //@line 96943 "c/sqlite3.c"
   return; //@line 96947 "c/sqlite3.c"
  }
 }
 _sqlite3ExprCode($0,$1,$2); //@line 96945 "c/sqlite3.c"
 return; //@line 96947 "c/sqlite3.c"
}
function _sqlite3ExprCheckIN($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 12|0); //@line 95484 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 95484 "c/sqlite3.c"
 $4 = (_sqlite3ExprVectorSize($3)|0); //@line 95484 "c/sqlite3.c"
 $5 = ((($1)) + 4|0); //@line 95485 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 95485 "c/sqlite3.c"
 $7 = $6 & 2048; //@line 95485 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 95485 "c/sqlite3.c"
 if ($8) {
  $14 = ($4|0)==(1); //@line 95490 "c/sqlite3.c"
  if ($14) {
   $$0 = 0;
   return ($$0|0); //@line 95495 "c/sqlite3.c"
  }
  _sqlite3VectorErrorMsg($0,$3); //@line 95491 "c/sqlite3.c"
  $$0 = 1;
  return ($$0|0); //@line 95495 "c/sqlite3.c"
 } else {
  $9 = ((($1)) + 20|0); //@line 95486 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 95486 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 95486 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 95486 "c/sqlite3.c"
  $13 = ($4|0)==($12|0); //@line 95486 "c/sqlite3.c"
  if ($13) {
   $$0 = 0;
   return ($$0|0); //@line 95495 "c/sqlite3.c"
  }
  _sqlite3SubselectError($0,$12,$4); //@line 95487 "c/sqlite3.c"
  $$0 = 1;
  return ($$0|0); //@line 95495 "c/sqlite3.c"
 }
 return (0)|0;
}
function _exprINAffinity($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$035 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 12|0); //@line 95147 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 95147 "c/sqlite3.c"
 $4 = (_sqlite3ExprVectorSize($3)|0); //@line 95148 "c/sqlite3.c"
 $5 = ((($1)) + 4|0); //@line 95149 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 95149 "c/sqlite3.c"
 $7 = $6 & 2048; //@line 95149 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 95149 "c/sqlite3.c"
 if ($8) {
  $19 = 0;
 } else {
  $9 = ((($1)) + 20|0); //@line 95149 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 95149 "c/sqlite3.c"
  $19 = $10;
 }
 $11 = HEAP32[$0>>2]|0; //@line 95153 "c/sqlite3.c"
 $12 = (($4) + 1)|0; //@line 95153 "c/sqlite3.c"
 $13 = ($12|0)<(0); //@line 95153 "c/sqlite3.c"
 $14 = $13 << 31 >> 31; //@line 95153 "c/sqlite3.c"
 $15 = (_sqlite3DbMallocRaw($11,$12,$14)|0); //@line 95153 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 95154 "c/sqlite3.c"
 if ($16) {
  return ($15|0); //@line 95167 "c/sqlite3.c"
 }
 $17 = ($4|0)>(0); //@line 95156 "c/sqlite3.c"
 if ($17) {
  $18 = ($19|0)==(0|0);
  $$035 = 0;
  while(1) {
   $20 = (_sqlite3VectorFieldSubexpr($3,$$035)|0); //@line 95157 "c/sqlite3.c"
   $21 = (_sqlite3ExprAffinity($20)|0); //@line 95158 "c/sqlite3.c"
   if ($18) {
    $$sink = $21;
   } else {
    $22 = HEAP32[$19>>2]|0; //@line 95160 "c/sqlite3.c"
    $23 = (((($22)) + 4|0) + (($$035*20)|0)|0); //@line 95160 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 95160 "c/sqlite3.c"
    $25 = (_sqlite3CompareAffinity($24,$21)|0); //@line 95160 "c/sqlite3.c"
    $$sink = $25;
   }
   $26 = (($15) + ($$035)|0);
   HEAP8[$26>>0] = $$sink;
   $27 = (($$035) + 1)|0; //@line 95156 "c/sqlite3.c"
   $exitcond = ($27|0)==($4|0); //@line 95156 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$035 = $27;
   }
  }
 }
 $28 = (($15) + ($4)|0); //@line 95165 "c/sqlite3.c"
 HEAP8[$28>>0] = 0; //@line 95165 "c/sqlite3.c"
 return ($15|0); //@line 95167 "c/sqlite3.c"
}
function _sqlite3FindInIndex($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0213240 = 0, $$0214 = 0, $$0217$lcssa = 0, $$0217269 = 0, $$0218$lcssa = 0, $$0218241 = 0, $$0219 = 0, $$0219257 = 0, $$0219259 = 0, $$0220264 = 0, $$0222263 = 0, $$1 = 0, $$1221 = 0, $$1223248 = 0, $$6237 = 0, $$7 = 0, $$8 = 0, $$lcssa239 = 0, $$off = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0;
 var $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0;
 var $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0;
 var $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond231 = 0, $sext = 0, $spec$select = 0, $switch5 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 94925 "c/sqlite3.c"
 $5 = ((($0)) + 40|0); //@line 94933 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 94933 "c/sqlite3.c"
 $7 = (($6) + 1)|0; //@line 94933 "c/sqlite3.c"
 HEAP32[$5>>2] = $7; //@line 94933 "c/sqlite3.c"
 $8 = (_sqlite3GetVdbe($0)|0); //@line 94935 "c/sqlite3.c"
 $9 = $2 & 4; //@line 94938 "c/sqlite3.c"
 $10 = ($9|0)!=(0); //@line 94938 "c/sqlite3.c"
 $11 = ($3|0)==(0|0); //@line 94945 "c/sqlite3.c"
 if ($11) {
  $$1 = 0;
 } else {
  $12 = ((($1)) + 4|0); //@line 94945 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 94945 "c/sqlite3.c"
  $14 = $13 & 2048; //@line 94945 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 94945 "c/sqlite3.c"
  if ($15) {
   $$1 = $3;
  } else {
   $16 = ((($1)) + 20|0); //@line 94947 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 94947 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 94947 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 94948 "c/sqlite3.c"
   $20 = ($19|0)>(0); //@line 94948 "c/sqlite3.c"
   L4: do {
    if ($20) {
     $$0217269 = 0;$195 = $19;
     while(1) {
      $21 = (((($18)) + 4|0) + (($$0217269*20)|0)|0); //@line 94949 "c/sqlite3.c"
      $22 = HEAP32[$21>>2]|0; //@line 94949 "c/sqlite3.c"
      $23 = (_sqlite3ExprCanBeNull($22)|0); //@line 94949 "c/sqlite3.c"
      $24 = ($23|0)==(0); //@line 94949 "c/sqlite3.c"
      if (!($24)) {
       $$0217$lcssa = $$0217269;$$lcssa239 = $195;
       break L4;
      }
      $25 = (($$0217269) + 1)|0; //@line 94948 "c/sqlite3.c"
      $26 = HEAP32[$18>>2]|0; //@line 94948 "c/sqlite3.c"
      $27 = ($25|0)<($26|0); //@line 94948 "c/sqlite3.c"
      if ($27) {
       $$0217269 = $25;$195 = $26;
      } else {
       $$0217$lcssa = $25;$$lcssa239 = $26;
       break;
      }
     }
    } else {
     $$0217$lcssa = 0;$$lcssa239 = $19;
    }
   } while(0);
   $28 = ($$0217$lcssa|0)==($$lcssa239|0); //@line 94951 "c/sqlite3.c"
   $spec$select = $28 ? 0 : $3; //@line 94951 "c/sqlite3.c"
   $$1 = $spec$select;
  }
 }
 $29 = ((($0)) + 36|0); //@line 94959 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 94959 "c/sqlite3.c"
 $31 = ($30|0)==(0); //@line 94959 "c/sqlite3.c"
 L11: do {
  if ($31) {
   $32 = (_isCandidateForInOpt($1)|0); //@line 94959 "c/sqlite3.c"
   $33 = ($32|0)==(0|0); //@line 94959 "c/sqlite3.c"
   if ($33) {
    label = 43;
   } else {
    $34 = HEAP32[$0>>2]|0; //@line 94960 "c/sqlite3.c"
    $35 = HEAP32[$32>>2]|0; //@line 94963 "c/sqlite3.c"
    $36 = HEAP32[$35>>2]|0; //@line 94964 "c/sqlite3.c"
    $37 = ((($32)) + 28|0); //@line 94969 "c/sqlite3.c"
    $38 = HEAP32[$37>>2]|0; //@line 94969 "c/sqlite3.c"
    $39 = ((($38)) + 24|0); //@line 94969 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 94969 "c/sqlite3.c"
    $41 = ((($40)) + 72|0); //@line 94972 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 94972 "c/sqlite3.c"
    $43 = (_sqlite3SchemaToIndex($34,$42)|0); //@line 94972 "c/sqlite3.c"
    $sext = $43 << 16; //@line 94973 "c/sqlite3.c"
    $44 = $sext >> 16; //@line 94973 "c/sqlite3.c"
    _sqlite3CodeVerifySchema($0,$44); //@line 94973 "c/sqlite3.c"
    $45 = ((($40)) + 28|0); //@line 94974 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 94974 "c/sqlite3.c"
    $47 = HEAP32[$40>>2]|0; //@line 94974 "c/sqlite3.c"
    _sqlite3TableLock($0,$44,$46,0,$47); //@line 94974 "c/sqlite3.c"
    $48 = ($36|0)==(1); //@line 94977 "c/sqlite3.c"
    if ($48) {
     $49 = ((($35)) + 4|0); //@line 94977 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 94977 "c/sqlite3.c"
     $51 = ((($50)) + 32|0); //@line 94977 "c/sqlite3.c"
     $52 = HEAP16[$51>>1]|0; //@line 94977 "c/sqlite3.c"
     $53 = ($52<<16>>16)<(0); //@line 94977 "c/sqlite3.c"
     if ($53) {
      $54 = (_sqlite3VdbeAddOp0($8,20)|0); //@line 94979 "c/sqlite3.c"
      _sqlite3OpenTable($0,$6,$44,$40,105); //@line 94982 "c/sqlite3.c"
      _sqlite3VdbeJumpHere($8,$54); //@line 94985 "c/sqlite3.c"
      $$6237 = 1;
      label = 53;
      break;
     } else {
      label = 14;
     }
    } else {
     $55 = ($36|0)>(0); //@line 94995 "c/sqlite3.c"
     if ($55) {
      label = 14;
     }
    }
    if ((label|0) == 14) {
     $56 = ((($1)) + 12|0);
     $$0220264 = 1;$$0222263 = 0;
     while(1) {
      $57 = HEAP32[$56>>2]|0; //@line 94996 "c/sqlite3.c"
      $58 = (_sqlite3VectorFieldSubexpr($57,$$0222263)|0); //@line 94996 "c/sqlite3.c"
      $59 = (((($35)) + 4|0) + (($$0222263*20)|0)|0); //@line 94997 "c/sqlite3.c"
      $60 = HEAP32[$59>>2]|0; //@line 94997 "c/sqlite3.c"
      $61 = ((($60)) + 32|0); //@line 94997 "c/sqlite3.c"
      $62 = HEAP16[$61>>1]|0; //@line 94997 "c/sqlite3.c"
      $63 = $62 << 16 >> 16; //@line 94997 "c/sqlite3.c"
      $64 = (_sqlite3TableColumnAffinity($40,$63)|0); //@line 94998 "c/sqlite3.c"
      $65 = (_sqlite3CompareAffinity($58,$64)|0); //@line 94999 "c/sqlite3.c"
      $66 = $65 << 24 >> 24; //@line 95002 "c/sqlite3.c"
      $$off = (($66) + -65)|0; //@line 95002 "c/sqlite3.c"
      $switch5 = ($$off>>>0)<(2); //@line 95002 "c/sqlite3.c"
      $67 = ($64<<24>>24)>(66); //@line 95013 "c/sqlite3.c"
      $68 = $67&1; //@line 95013 "c/sqlite3.c"
      $$1221 = $switch5 ? $$0220264 : $68; //@line 95002 "c/sqlite3.c"
      $69 = (($$0222263) + 1)|0; //@line 94995 "c/sqlite3.c"
      $70 = ($69|0)<($36|0); //@line 94995 "c/sqlite3.c"
      $71 = ($$1221|0)!=(0); //@line 94995 "c/sqlite3.c"
      $72 = $70 & $71; //@line 94995 "c/sqlite3.c"
      if ($72) {
       $$0220264 = $$1221;$$0222263 = $69;
      } else {
       break;
      }
     }
     if (!($71)) {
      label = 43;
      break;
     }
    }
    $73 = ((($40)) + 8|0); //@line 95019 "c/sqlite3.c"
    $$0219257 = HEAP32[$73>>2]|0;
    $74 = ($$0219257|0)==(0|0); //@line 95019 "c/sqlite3.c"
    if ($74) {
     label = 43;
    } else {
     $75 = ($36|0)>(0);
     $76 = (_bitshift64Shl(1,0,($36|0))|0);
     $77 = tempRet0;
     $78 = (_i64Add(($76|0),($77|0),-1,-1)|0);
     $79 = tempRet0;
     $80 = ((($1)) + 12|0);
     $81 = ($36|0)>(0);
     $82 = ($4|0)==(0|0);
     $83 = ($$1|0)==(0|0);
     $84 = ((($0)) + 44|0);
     $$0219259 = $$0219257;
     L25: while(1) {
      $85 = ((($$0219259)) + 52|0); //@line 95022 "c/sqlite3.c"
      $86 = HEAP16[$85>>1]|0; //@line 95022 "c/sqlite3.c"
      $87 = $86&65535; //@line 95022 "c/sqlite3.c"
      $88 = ($36|0)>($87|0); //@line 95022 "c/sqlite3.c"
      $89 = ($86&65535)>(62); //@line 95027 "c/sqlite3.c"
      $or$cond231 = $89 | $88; //@line 95022 "c/sqlite3.c"
      do {
       if (!($or$cond231)) {
        if ($10) {
         $90 = ((($$0219259)) + 50|0); //@line 95029 "c/sqlite3.c"
         $91 = HEAP16[$90>>1]|0; //@line 95029 "c/sqlite3.c"
         $92 = $91&65535; //@line 95029 "c/sqlite3.c"
         $93 = ($36|0)<($92|0); //@line 95029 "c/sqlite3.c"
         if ($93) {
          break;
         }
         $94 = ($36|0)<($87|0); //@line 95030 "c/sqlite3.c"
         if ($94) {
          $95 = ((($$0219259)) + 54|0); //@line 95030 "c/sqlite3.c"
          $96 = HEAP8[$95>>0]|0; //@line 95030 "c/sqlite3.c"
          $97 = ($96<<24>>24)==(0); //@line 95030 "c/sqlite3.c"
          if ($97) {
           break;
          }
         }
        }
        L34: do {
         if ($75) {
          $98 = ((($$0219259)) + 4|0);
          $99 = ((($$0219259)) + 32|0);
          $$1223248 = 0;$124 = 0;$126 = 0;
          while(1) {
           $100 = HEAP32[$80>>2]|0; //@line 95038 "c/sqlite3.c"
           $101 = (_sqlite3VectorFieldSubexpr($100,$$1223248)|0); //@line 95038 "c/sqlite3.c"
           $102 = (((($35)) + 4|0) + (($$1223248*20)|0)|0); //@line 95039 "c/sqlite3.c"
           $103 = HEAP32[$102>>2]|0; //@line 95039 "c/sqlite3.c"
           $104 = (_sqlite3BinaryCompareCollSeq($0,$101,$103)|0); //@line 95040 "c/sqlite3.c"
           L38: do {
            if ($81) {
             $105 = HEAP32[$98>>2]|0;
             $106 = ((($103)) + 32|0);
             $107 = HEAP16[$106>>1]|0;
             $108 = ($104|0)==(0|0);
             $$0218241 = 0;
             while(1) {
              $109 = (($105) + ($$0218241<<1)|0); //@line 95045 "c/sqlite3.c"
              $110 = HEAP16[$109>>1]|0; //@line 95045 "c/sqlite3.c"
              $111 = ($110<<16>>16)==($107<<16>>16); //@line 95045 "c/sqlite3.c"
              if ($111) {
               if ($108) {
                $$0218$lcssa = $$0218241;
                break L38;
               }
               $112 = HEAP32[$104>>2]|0; //@line 95047 "c/sqlite3.c"
               $113 = HEAP32[$99>>2]|0; //@line 95047 "c/sqlite3.c"
               $114 = (($113) + ($$0218241<<2)|0); //@line 95047 "c/sqlite3.c"
               $115 = HEAP32[$114>>2]|0; //@line 95047 "c/sqlite3.c"
               $116 = (_sqlite3StrICmp($112,$115)|0); //@line 95047 "c/sqlite3.c"
               $117 = ($116|0)==(0); //@line 95047 "c/sqlite3.c"
               if ($117) {
                $$0218$lcssa = $$0218241;
                break L38;
               }
              }
              $118 = (($$0218241) + 1)|0; //@line 95044 "c/sqlite3.c"
              $119 = ($118|0)<($36|0); //@line 95044 "c/sqlite3.c"
              if ($119) {
               $$0218241 = $118;
              } else {
               $$0218$lcssa = $118;
               break;
              }
             }
            } else {
             $$0218$lcssa = 0;
            }
           } while(0);
           $120 = ($$0218$lcssa|0)==($36|0); //@line 95052 "c/sqlite3.c"
           if ($120) {
            $136 = $124;$138 = $126;
            break L34;
           }
           $121 = (_bitshift64Shl(1,0,($$0218$lcssa|0))|0); //@line 95053 "c/sqlite3.c"
           $122 = tempRet0; //@line 95053 "c/sqlite3.c"
           $123 = $121 & $124; //@line 95054 "c/sqlite3.c"
           $125 = $122 & $126; //@line 95054 "c/sqlite3.c"
           $127 = ($123|0)==(0); //@line 95054 "c/sqlite3.c"
           $128 = ($125|0)==(0); //@line 95054 "c/sqlite3.c"
           $129 = $127 & $128; //@line 95054 "c/sqlite3.c"
           if (!($129)) {
            $136 = $124;$138 = $126;
            break L34;
           }
           $130 = $121 | $124; //@line 95055 "c/sqlite3.c"
           $131 = $122 | $126; //@line 95055 "c/sqlite3.c"
           if (!($82)) {
            $132 = (($4) + ($$1223248<<2)|0); //@line 95056 "c/sqlite3.c"
            HEAP32[$132>>2] = $$0218$lcssa; //@line 95056 "c/sqlite3.c"
           }
           $133 = (($$1223248) + 1)|0; //@line 95037 "c/sqlite3.c"
           $134 = ($133|0)<($36|0); //@line 95037 "c/sqlite3.c"
           if ($134) {
            $$1223248 = $133;$124 = $130;$126 = $131;
           } else {
            $136 = $130;$138 = $131;
            break;
           }
          }
         } else {
          $136 = 0;$138 = 0;
         }
        } while(0);
        $135 = ($136|0)==($78|0); //@line 95060 "c/sqlite3.c"
        $137 = ($138|0)==($79|0); //@line 95060 "c/sqlite3.c"
        $139 = $135 & $137; //@line 95060 "c/sqlite3.c"
        if ($139) {
         break L25;
        }
       }
      } while(0);
      $152 = ((($$0219259)) + 20|0); //@line 95019 "c/sqlite3.c"
      $$0219 = HEAP32[$152>>2]|0;
      $153 = ($$0219|0)==(0|0); //@line 95019 "c/sqlite3.c"
      if ($153) {
       label = 43;
       break L11;
      } else {
       $$0219259 = $$0219;
      }
     }
     $140 = (_sqlite3VdbeAddOp0($8,20)|0); //@line 95062 "c/sqlite3.c"
     $141 = HEAP32[$$0219259>>2]|0; //@line 95065 "c/sqlite3.c"
     HEAP32[$vararg_buffer>>2] = $141; //@line 95065 "c/sqlite3.c"
     $142 = (_sqlite3MPrintf($34,24884,$vararg_buffer)|0); //@line 95065 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4($8,169,0,0,0,$142,-7)|0); //@line 95064 "c/sqlite3.c"
     $143 = ((($$0219259)) + 44|0); //@line 95068 "c/sqlite3.c"
     $144 = HEAP32[$143>>2]|0; //@line 95068 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($8,105,$6,$144,$44)|0); //@line 95068 "c/sqlite3.c"
     _sqlite3VdbeSetP4KeyInfo($0,$$0219259); //@line 95069 "c/sqlite3.c"
     $145 = ((($$0219259)) + 28|0); //@line 95072 "c/sqlite3.c"
     $146 = HEAP32[$145>>2]|0; //@line 95072 "c/sqlite3.c"
     $147 = HEAP8[$146>>0]|0; //@line 95072 "c/sqlite3.c"
     $148 = $147&255; //@line 95072 "c/sqlite3.c"
     $149 = (($148) + 3)|0; //@line 95072 "c/sqlite3.c"
     if (!($83)) {
      $150 = HEAP32[$84>>2]|0; //@line 95080 "c/sqlite3.c"
      $151 = (($150) + 1)|0; //@line 95080 "c/sqlite3.c"
      HEAP32[$84>>2] = $151; //@line 95080 "c/sqlite3.c"
      HEAP32[$$1>>2] = $151; //@line 95080 "c/sqlite3.c"
      if ($48) {
       _sqlite3SetHasNullFlag($8,$6,$151); //@line 95082 "c/sqlite3.c"
      }
     }
     _sqlite3VdbeJumpHere($8,$140); //@line 95085 "c/sqlite3.c"
     $$6237 = $149;
     label = 53;
    }
   }
  } else {
   label = 43;
  }
 } while(0);
 do {
  if ((label|0) == 43) {
   $154 = $2 & 1; //@line 95100 "c/sqlite3.c"
   $155 = ($154|0)==(0); //@line 95100 "c/sqlite3.c"
   if (!($155)) {
    $156 = ((($1)) + 4|0); //@line 95101 "c/sqlite3.c"
    $157 = HEAP32[$156>>2]|0; //@line 95101 "c/sqlite3.c"
    $158 = $157 & 2048; //@line 95101 "c/sqlite3.c"
    $159 = ($158|0)==(0); //@line 95101 "c/sqlite3.c"
    if ($159) {
     $160 = (_sqlite3InRhsIsConstant($1)|0); //@line 95102 "c/sqlite3.c"
     $161 = ($160|0)==(0); //@line 95102 "c/sqlite3.c"
     if ($161) {
      $$6237 = 5;
      label = 53;
      break;
     }
     $162 = ((($1)) + 20|0); //@line 95102 "c/sqlite3.c"
     $163 = HEAP32[$162>>2]|0; //@line 95102 "c/sqlite3.c"
     $164 = HEAP32[$163>>2]|0; //@line 95102 "c/sqlite3.c"
     $165 = ($164|0)<(3); //@line 95102 "c/sqlite3.c"
     if ($165) {
      $$6237 = 5;
      label = 53;
      break;
     }
    }
   }
   $166 = ((($0)) + 132|0); //@line 95111 "c/sqlite3.c"
   $167 = HEAP32[$166>>2]|0; //@line 95111 "c/sqlite3.c"
   if ($10) {
    HEAP32[$166>>2] = 0; //@line 95115 "c/sqlite3.c"
    $168 = ((($1)) + 12|0); //@line 95116 "c/sqlite3.c"
    $169 = HEAP32[$168>>2]|0; //@line 95116 "c/sqlite3.c"
    $170 = ((($169)) + 32|0); //@line 95116 "c/sqlite3.c"
    $171 = HEAP16[$170>>1]|0; //@line 95116 "c/sqlite3.c"
    $172 = ($171<<16>>16)<(0); //@line 95116 "c/sqlite3.c"
    if ($172) {
     $173 = ((($1)) + 4|0); //@line 95116 "c/sqlite3.c"
     $174 = HEAP32[$173>>2]|0; //@line 95116 "c/sqlite3.c"
     $175 = $174 >>> 11; //@line 95116 "c/sqlite3.c"
     $176 = $175 & 1; //@line 95116 "c/sqlite3.c"
     $177 = (($176) + 1)|0; //@line 95116 "c/sqlite3.c"
     $$0214 = 0;$$7 = $177;
    } else {
     $$0214 = 0;$$7 = 2;
    }
   } else {
    $178 = ($$1|0)==(0|0); //@line 95119 "c/sqlite3.c"
    if ($178) {
     $$0214 = 0;$$7 = 2;
    } else {
     $179 = ((($0)) + 44|0); //@line 95120 "c/sqlite3.c"
     $180 = HEAP32[$179>>2]|0; //@line 95120 "c/sqlite3.c"
     $181 = (($180) + 1)|0; //@line 95120 "c/sqlite3.c"
     HEAP32[$179>>2] = $181; //@line 95120 "c/sqlite3.c"
     HEAP32[$$1>>2] = $181; //@line 95120 "c/sqlite3.c"
     $$0214 = $181;$$7 = 2;
    }
   }
   $182 = ($$7|0)==(1); //@line 95122 "c/sqlite3.c"
   $183 = $182&1; //@line 95122 "c/sqlite3.c"
   (_sqlite3CodeSubselect($0,$1,$$0214,$183)|0); //@line 95122 "c/sqlite3.c"
   HEAP32[$166>>2] = $167; //@line 95123 "c/sqlite3.c"
   $$8 = $$7;
  }
 } while(0);
 if ((label|0) == 53) {
  $184 = ((($1)) + 28|0); //@line 95125 "c/sqlite3.c"
  HEAP32[$184>>2] = $6; //@line 95125 "c/sqlite3.c"
  $$8 = $$6237;
 }
 $185 = ($4|0)!=(0|0); //@line 95128 "c/sqlite3.c"
 $186 = (($$8) + -3)|0; //@line 95128 "c/sqlite3.c"
 $187 = ($186>>>0)>(1); //@line 95128 "c/sqlite3.c"
 $188 = $185 & $187; //@line 95128 "c/sqlite3.c"
 if (!($188)) {
  STACKTOP = sp;return ($$8|0); //@line 95133 "c/sqlite3.c"
 }
 $189 = ((($1)) + 12|0); //@line 95130 "c/sqlite3.c"
 $190 = HEAP32[$189>>2]|0; //@line 95130 "c/sqlite3.c"
 $191 = (_sqlite3ExprVectorSize($190)|0); //@line 95130 "c/sqlite3.c"
 $192 = ($191|0)>(0); //@line 95131 "c/sqlite3.c"
 if (!($192)) {
  STACKTOP = sp;return ($$8|0); //@line 95133 "c/sqlite3.c"
 }
 $$0213240 = 0;
 while(1) {
  $193 = (($4) + ($$0213240<<2)|0); //@line 95131 "c/sqlite3.c"
  HEAP32[$193>>2] = $$0213240; //@line 95131 "c/sqlite3.c"
  $194 = (($$0213240) + 1)|0; //@line 95131 "c/sqlite3.c"
  $exitcond = ($194|0)==($191|0); //@line 95131 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$0213240 = $194;
  }
 }
 STACKTOP = sp;return ($$8|0); //@line 95133 "c/sqlite3.c"
}
function _sqlite3ExprCanBeNull($0) {
 $0 = $0|0;
 var $$0 = 0, $$011$lcssa = 0, $$01113 = 0, $$012 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 94693 "c/sqlite3.c"
 $2 = $1 | 1; //@line 94693 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(-107); //@line 94693 "c/sqlite3.c"
 if ($3) {
  $$01113 = $0;
  while(1) {
   $4 = ((($$01113)) + 12|0); //@line 94693 "c/sqlite3.c"
   $5 = HEAP32[$4>>2]|0; //@line 94693 "c/sqlite3.c"
   $6 = HEAP8[$5>>0]|0; //@line 94693 "c/sqlite3.c"
   $7 = $6 | 1; //@line 94693 "c/sqlite3.c"
   $8 = ($7<<24>>24)==(-107); //@line 94693 "c/sqlite3.c"
   if ($8) {
    $$01113 = $5;
   } else {
    $$011$lcssa = $5;$$lcssa = $6;
    break;
   }
  }
 } else {
  $$011$lcssa = $0;$$lcssa = $1;
 }
 $9 = ($$lcssa<<24>>24)==(-106); //@line 94695 "c/sqlite3.c"
 if ($9) {
  $10 = ((($$011$lcssa)) + 38|0); //@line 94695 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 94695 "c/sqlite3.c"
  $$0 = $11;
 } else {
  $$0 = $$lcssa;
 }
 switch ($$0<<24>>24) {
 case -111:  {
  $12 = ((($$011$lcssa)) + 4|0); //@line 94703 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 94703 "c/sqlite3.c"
  $14 = $13 & 1048576; //@line 94703 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 94703 "c/sqlite3.c"
  if (!($15)) {
   $$012 = 1;
   return ($$012|0); //@line 94709 "c/sqlite3.c"
  }
  $16 = ((($$011$lcssa)) + 44|0); //@line 94704 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 94704 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 94704 "c/sqlite3.c"
  if ($18) {
   $$012 = 1;
   return ($$012|0); //@line 94709 "c/sqlite3.c"
  }
  $19 = ((($$011$lcssa)) + 32|0); //@line 94705 "c/sqlite3.c"
  $20 = HEAP16[$19>>1]|0; //@line 94705 "c/sqlite3.c"
  $21 = ($20<<16>>16)>(-1); //@line 94705 "c/sqlite3.c"
  if (!($21)) {
   $$012 = 0;
   return ($$012|0); //@line 94709 "c/sqlite3.c"
  }
  $22 = $20 << 16 >> 16; //@line 94705 "c/sqlite3.c"
  $23 = ((($17)) + 4|0); //@line 94705 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 94705 "c/sqlite3.c"
  $25 = (((($24) + ($22<<4)|0)) + 12|0); //@line 94705 "c/sqlite3.c"
  $26 = HEAP8[$25>>0]|0; //@line 94705 "c/sqlite3.c"
  $27 = ($26<<24>>24)==(0); //@line 94705 "c/sqlite3.c"
  $phitmp = $27&1;
  $$012 = $phitmp;
  return ($$012|0); //@line 94709 "c/sqlite3.c"
  break;
 }
 case -123: case -124: case 97: case -122:  {
  $$012 = 0;
  return ($$012|0); //@line 94709 "c/sqlite3.c"
  break;
 }
 default: {
  $$012 = 1;
  return ($$012|0); //@line 94709 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3VectorFieldSubexpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3ExprIsVector($0)|0); //@line 93090 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 93090 "c/sqlite3.c"
 if ($3) {
  $$0 = $0;
  return ($$0|0); //@line 93099 "c/sqlite3.c"
 }
 $4 = HEAP8[$0>>0]|0; //@line 93092 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(119); //@line 93092 "c/sqlite3.c"
 if ($5) {
  label = 4;
 } else {
  $6 = ((($0)) + 38|0); //@line 93092 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 93092 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(119); //@line 93092 "c/sqlite3.c"
  if ($8) {
   label = 4;
  } else {
   $11 = ((($0)) + 20|0); //@line 93095 "c/sqlite3.c"
   $$sink = $11;
  }
 }
 if ((label|0) == 4) {
  $9 = ((($0)) + 20|0); //@line 93093 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 93093 "c/sqlite3.c"
  $$sink = $10;
 }
 $12 = HEAP32[$$sink>>2]|0;
 $13 = (((($12)) + 4|0) + (($1*20)|0)|0);
 $14 = HEAP32[$13>>2]|0;
 $$0 = $14;
 return ($$0|0); //@line 93099 "c/sqlite3.c"
}
function _isCandidateForInOpt($0) {
 $0 = $0|0;
 var $$03335 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 94775 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 94775 "c/sqlite3.c"
 $3 = $2 & 2080; //@line 94775 "c/sqlite3.c"
 $4 = ($3|0)==(2048); //@line 94775 "c/sqlite3.c"
 L1: do {
  if ($4) {
   $5 = ((($0)) + 20|0); //@line 94777 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 94777 "c/sqlite3.c"
   $7 = ((($6)) + 48|0); //@line 94778 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 94778 "c/sqlite3.c"
   $9 = ($8|0)==(0|0); //@line 94778 "c/sqlite3.c"
   if ($9) {
    $10 = ((($6)) + 8|0); //@line 94779 "c/sqlite3.c"
    $11 = HEAP32[$10>>2]|0; //@line 94779 "c/sqlite3.c"
    $12 = $11 & 9; //@line 94779 "c/sqlite3.c"
    $13 = ($12|0)==(0); //@line 94779 "c/sqlite3.c"
    if ($13) {
     $14 = ((($6)) + 56|0); //@line 94785 "c/sqlite3.c"
     $15 = HEAP32[$14>>2]|0; //@line 94785 "c/sqlite3.c"
     $16 = ($15|0)==(0|0); //@line 94785 "c/sqlite3.c"
     if ($16) {
      $17 = ((($6)) + 32|0); //@line 94786 "c/sqlite3.c"
      $18 = HEAP32[$17>>2]|0; //@line 94786 "c/sqlite3.c"
      $19 = ($18|0)==(0|0); //@line 94786 "c/sqlite3.c"
      if ($19) {
       $20 = ((($6)) + 28|0); //@line 94787 "c/sqlite3.c"
       $21 = HEAP32[$20>>2]|0; //@line 94787 "c/sqlite3.c"
       $22 = HEAP32[$21>>2]|0; //@line 94789 "c/sqlite3.c"
       $23 = ($22|0)==(1); //@line 94789 "c/sqlite3.c"
       if ($23) {
        $24 = ((($21)) + 28|0); //@line 94790 "c/sqlite3.c"
        $25 = HEAP32[$24>>2]|0; //@line 94790 "c/sqlite3.c"
        $26 = ($25|0)==(0|0); //@line 94790 "c/sqlite3.c"
        if ($26) {
         $27 = ((($21)) + 24|0); //@line 94791 "c/sqlite3.c"
         $28 = HEAP32[$27>>2]|0; //@line 94791 "c/sqlite3.c"
         $29 = ((($28)) + 56|0); //@line 94794 "c/sqlite3.c"
         $30 = HEAP32[$29>>2]|0; //@line 94794 "c/sqlite3.c"
         $31 = ($30|0)==(0); //@line 94794 "c/sqlite3.c"
         if ($31) {
          $32 = HEAP32[$6>>2]|0; //@line 94795 "c/sqlite3.c"
          $33 = HEAP32[$32>>2]|0; //@line 94798 "c/sqlite3.c"
          $34 = ($33|0)>(0); //@line 94798 "c/sqlite3.c"
          if ($34) {
           $$03335 = 0;
           while(1) {
            $38 = (((($32)) + 4|0) + (($$03335*20)|0)|0); //@line 94799 "c/sqlite3.c"
            $39 = HEAP32[$38>>2]|0; //@line 94799 "c/sqlite3.c"
            $40 = HEAP8[$39>>0]|0; //@line 94800 "c/sqlite3.c"
            $41 = ($40<<24>>24)==(-111); //@line 94800 "c/sqlite3.c"
            $37 = (($$03335) + 1)|0; //@line 94798 "c/sqlite3.c"
            if (!($41)) {
             $$2 = 0;
             break L1;
            }
            $35 = HEAP32[$32>>2]|0; //@line 94798 "c/sqlite3.c"
            $36 = ($37|0)<($35|0); //@line 94798 "c/sqlite3.c"
            if ($36) {
             $$03335 = $37;
            } else {
             $$2 = $6;
             break;
            }
           }
          } else {
           $$2 = $6;
          }
         } else {
          $$2 = 0;
         }
        } else {
         $$2 = 0;
        }
       } else {
        $$2 = 0;
       }
      } else {
       $$2 = 0;
      }
     } else {
      $$2 = 0;
     }
    } else {
     $$2 = 0;
    }
   } else {
    $$2 = 0;
   }
  } else {
   $$2 = 0;
  }
 } while(0);
 return ($$2|0); //@line 94804 "c/sqlite3.c"
}
function _sqlite3CompareAffinity($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond10 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3ExprAffinity($0)|0); //@line 92915 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 92916 "c/sqlite3.c"
 $4 = ($1<<24>>24)==(0); //@line 92916 "c/sqlite3.c"
 $or$cond = $4 | $3; //@line 92916 "c/sqlite3.c"
 if ($or$cond) {
  $7 = $2&255; //@line 92916 "c/sqlite3.c"
  $8 = $2 | $1; //@line 92925 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 92925 "c/sqlite3.c"
  $10 = $1&255; //@line 92933 "c/sqlite3.c"
  $11 = (($7) + ($10))|0; //@line 92933 "c/sqlite3.c"
  $12 = $11&255; //@line 92933 "c/sqlite3.c"
  $$0 = $9 ? 65 : $12; //@line 92925 "c/sqlite3.c"
  return ($$0|0); //@line 92935 "c/sqlite3.c"
 } else {
  $5 = ($2<<24>>24)>(66); //@line 92920 "c/sqlite3.c"
  $6 = ($1<<24>>24)>(66); //@line 92920 "c/sqlite3.c"
  $or$cond10 = $6 | $5; //@line 92920 "c/sqlite3.c"
  $spec$select = $or$cond10 ? 67 : 65; //@line 92920 "c/sqlite3.c"
  return ($spec$select|0); //@line 92920 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3SetHasNullFlag($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3VdbeAddOp2($0,67,0,$2)|0); //@line 94816 "c/sqlite3.c"
 $3 = (_sqlite3VdbeAddOp1($0,37,$1)|0); //@line 94817 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($0,98,$1,0,$2)|0); //@line 94818 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($0,128); //@line 94819 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($0,$3); //@line 94821 "c/sqlite3.c"
 return; //@line 94822 "c/sqlite3.c"
}
function _sqlite3InRhsIsConstant($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 94835 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 94835 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 94836 "c/sqlite3.c"
 $3 = (_sqlite3ExprIsConstant($0)|0); //@line 94837 "c/sqlite3.c"
 HEAP32[$1>>2] = $2; //@line 94838 "c/sqlite3.c"
 return ($3|0); //@line 94839 "c/sqlite3.c"
}
function _sqlite3VectorErrorMsg($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 95195 "c/sqlite3.c"
 $2 = ((($1)) + 4|0); //@line 95197 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 95197 "c/sqlite3.c"
 $4 = $3 & 2048; //@line 95197 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 95197 "c/sqlite3.c"
 if ($5) {
  _sqlite3ErrorMsg($0,23693,$vararg_buffer); //@line 95202 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 95204 "c/sqlite3.c"
 } else {
  $6 = ((($1)) + 20|0); //@line 95198 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 95198 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 95198 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 95198 "c/sqlite3.c"
  _sqlite3SubselectError($0,$9,1); //@line 95198 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 95204 "c/sqlite3.c"
 }
}
function _sqlite3SelectDestInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $1&255; //@line 118774 "c/sqlite3.c"
 HEAP8[$0>>0] = $3; //@line 118774 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 118775 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 118775 "c/sqlite3.c"
 $5 = ((($0)) + 16|0); //@line 118776 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 118776 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 118777 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 118777 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 118778 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 118778 "c/sqlite3.c"
 return; //@line 118779 "c/sqlite3.c"
}
function _exprIsConst($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = $1&255; //@line 94505 "c/sqlite3.c"
 $5 = ((($3)) + 20|0); //@line 94505 "c/sqlite3.c"
 HEAP8[$5>>0] = $4; //@line 94505 "c/sqlite3.c"
 $6 = ((($3)) + 4|0); //@line 94506 "c/sqlite3.c"
 HEAP32[$6>>2] = 158; //@line 94506 "c/sqlite3.c"
 $7 = ((($3)) + 8|0); //@line 94507 "c/sqlite3.c"
 HEAP32[$7>>2] = 159; //@line 94507 "c/sqlite3.c"
 $8 = ((($3)) + 24|0); //@line 94511 "c/sqlite3.c"
 HEAP32[$8>>2] = $2; //@line 94511 "c/sqlite3.c"
 (_sqlite3WalkExpr($3,$0)|0); //@line 94512 "c/sqlite3.c"
 $9 = HEAP8[$5>>0]|0; //@line 94513 "c/sqlite3.c"
 $10 = $9&255; //@line 94513 "c/sqlite3.c"
 STACKTOP = sp;return ($10|0); //@line 94513 "c/sqlite3.c"
}
function _exprNodeIsConstant($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 94452 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 94452 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(2); //@line 94452 "c/sqlite3.c"
 if ($4) {
  $5 = ((($1)) + 4|0); //@line 94452 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 94452 "c/sqlite3.c"
  $7 = $6 & 1; //@line 94452 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 94452 "c/sqlite3.c"
  if ($8) {
   label = 4;
  } else {
   HEAP8[$2>>0] = 0; //@line 94453 "c/sqlite3.c"
   $$0 = 2;
  }
 } else {
  label = 4;
 }
 L4: do {
  if ((label|0) == 4) {
   $9 = HEAP8[$1>>0]|0; //@line 94457 "c/sqlite3.c"
   switch ($9<<24>>24) {
   case -112:  {
    $10 = ($3&255)>(3); //@line 94462 "c/sqlite3.c"
    if ($10) {
     $$0 = 0;
     break L4;
    }
    $11 = ((($1)) + 4|0); //@line 94462 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 94462 "c/sqlite3.c"
    $13 = $12 & 524288; //@line 94462 "c/sqlite3.c"
    $14 = ($13|0)==(0); //@line 94462 "c/sqlite3.c"
    if (!($14)) {
     $$0 = 0;
     break L4;
    }
    HEAP8[$2>>0] = 0; //@line 94465 "c/sqlite3.c"
    $$0 = 2;
    break L4;
    break;
   }
   case -109: case -110: case -111: case 59:  {
    $15 = ($3<<24>>24)==(3); //@line 94476 "c/sqlite3.c"
    if ($15) {
     $16 = ((($1)) + 28|0); //@line 94476 "c/sqlite3.c"
     $17 = HEAP32[$16>>2]|0; //@line 94476 "c/sqlite3.c"
     $18 = ((($0)) + 24|0); //@line 94476 "c/sqlite3.c"
     $19 = HEAP32[$18>>2]|0; //@line 94476 "c/sqlite3.c"
     $20 = ($17|0)==($19|0); //@line 94476 "c/sqlite3.c"
     if ($20) {
      $$0 = 0;
      break L4;
     }
    }
    break;
   }
   case -103:  {
    break;
   }
   case -121:  {
    switch ($3<<24>>24) {
    case 5:  {
     HEAP8[$1>>0] = 101; //@line 94489 "c/sqlite3.c"
     $$0 = 0;
     break L4;
     break;
    }
    case 4:  {
     HEAP8[$2>>0] = 0; //@line 94493 "c/sqlite3.c"
     $$0 = 2;
     break L4;
     break;
    }
    default: {
     $$0 = 0;
     break L4;
    }
    }
    break;
   }
   default: {
    $$0 = 0;
    break L4;
   }
   }
   HEAP8[$2>>0] = 0; //@line 94482 "c/sqlite3.c"
   $$0 = 2;
  }
 } while(0);
 return ($$0|0); //@line 94502 "c/sqlite3.c"
}
function _sqlite3SelectWalkFail($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 20|0); //@line 94418 "c/sqlite3.c"
 HEAP8[$2>>0] = 0; //@line 94418 "c/sqlite3.c"
 return 2; //@line 94419 "c/sqlite3.c"
}
function _binaryCompareP5($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ExprAffinity($1)|0); //@line 92981 "c/sqlite3.c"
 $4 = (_sqlite3CompareAffinity($0,$3)|0); //@line 92982 "c/sqlite3.c"
 $5 = $4&255; //@line 92982 "c/sqlite3.c"
 $6 = $5 | $2; //@line 92982 "c/sqlite3.c"
 $7 = $6&255; //@line 92982 "c/sqlite3.c"
 return ($7|0); //@line 92983 "c/sqlite3.c"
}
function _exprCodeSubselect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 93170 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(119); //@line 93170 "c/sqlite3.c"
 if ($3) {
  $4 = (_sqlite3CodeSubselect($0,$1,0,0)|0); //@line 93171 "c/sqlite3.c"
  $$0 = $4;
 } else {
  $$0 = 0;
 }
 return ($$0|0); //@line 93174 "c/sqlite3.c"
}
function _exprVectorRegister($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = HEAP8[$1>>0]|0; //@line 93203 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(-106); //@line 93205 "c/sqlite3.c"
 if ($7) {
  $8 = (_sqlite3VectorFieldSubexpr($1,$2)|0); //@line 93206 "c/sqlite3.c"
  HEAP32[$4>>2] = $8; //@line 93206 "c/sqlite3.c"
  $9 = ((($1)) + 28|0); //@line 93207 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 93207 "c/sqlite3.c"
  $11 = (($10) + ($2))|0; //@line 93207 "c/sqlite3.c"
  $$0 = $11;
  return ($$0|0); //@line 93215 "c/sqlite3.c"
 }
 $12 = ($6<<24>>24)==(119); //@line 93209 "c/sqlite3.c"
 $13 = ((($1)) + 20|0);
 if ($12) {
  $14 = HEAP32[$13>>2]|0; //@line 93210 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 93210 "c/sqlite3.c"
  $16 = (((($15)) + 4|0) + (($2*20)|0)|0); //@line 93210 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 93210 "c/sqlite3.c"
  HEAP32[$4>>2] = $17; //@line 93210 "c/sqlite3.c"
  $18 = (($3) + ($2))|0; //@line 93211 "c/sqlite3.c"
  $$0 = $18;
  return ($$0|0); //@line 93215 "c/sqlite3.c"
 } else {
  $19 = HEAP32[$13>>2]|0; //@line 93213 "c/sqlite3.c"
  $20 = (((($19)) + 4|0) + (($2*20)|0)|0); //@line 93213 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 93213 "c/sqlite3.c"
  HEAP32[$4>>2] = $21; //@line 93213 "c/sqlite3.c"
  $22 = (_sqlite3ExprCodeTemp($0,$21,$5)|0); //@line 93214 "c/sqlite3.c"
  $$0 = $22;
  return ($$0|0); //@line 93215 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeAddOp4Dup8($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3VdbeDb($0)|0); //@line 73261 "c/sqlite3.c"
 $6 = (_sqlite3DbMallocRawNN($5,8,0)|0); //@line 73261 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 73262 "c/sqlite3.c"
 if ($7) {
  (_sqlite3VdbeAddOp4($0,$1,0,$2,0,$6,$4)|0); //@line 73263 "c/sqlite3.c"
  return;
 }
 $8 = $3; //@line 73262 "c/sqlite3.c"
 $9 = $8; //@line 73262 "c/sqlite3.c"
 $10 = HEAPU8[$9>>0]|(HEAPU8[$9+1>>0]<<8)|(HEAPU8[$9+2>>0]<<16)|(HEAPU8[$9+3>>0]<<24); //@line 73262 "c/sqlite3.c"
 $11 = (($8) + 4)|0; //@line 73262 "c/sqlite3.c"
 $12 = $11; //@line 73262 "c/sqlite3.c"
 $13 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8)|(HEAPU8[$12+2>>0]<<16)|(HEAPU8[$12+3>>0]<<24); //@line 73262 "c/sqlite3.c"
 $14 = $6; //@line 73262 "c/sqlite3.c"
 $15 = $14; //@line 73262 "c/sqlite3.c"
 HEAP8[$15>>0]=$10&255;HEAP8[$15+1>>0]=($10>>8)&255;HEAP8[$15+2>>0]=($10>>16)&255;HEAP8[$15+3>>0]=$10>>24; //@line 73262 "c/sqlite3.c"
 $16 = (($14) + 4)|0; //@line 73262 "c/sqlite3.c"
 $17 = $16; //@line 73262 "c/sqlite3.c"
 HEAP8[$17>>0]=$13&255;HEAP8[$17+1>>0]=($13>>8)&255;HEAP8[$17+2>>0]=($13>>16)&255;HEAP8[$17+3>>0]=$13>>24; //@line 73262 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($0,$1,0,$2,0,$6,$4)|0); //@line 73263 "c/sqlite3.c"
 return;
}
function _sqlite3DecOrHexToI64($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$025 = 0, $$029 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 29168 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(48); //@line 29168 "c/sqlite3.c"
 if (!($3)) {
  $46 = (_sqlite3Strlen30($0)|0); //@line 29182 "c/sqlite3.c"
  $47 = (_sqlite3Atoi64($0,$1,$46,1)|0); //@line 29182 "c/sqlite3.c"
  return ($47|0); //@line 29184 "c/sqlite3.c"
 }
 $4 = ((($0)) + 1|0); //@line 29169 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 29169 "c/sqlite3.c"
 switch ($5<<24>>24) {
 case 88: case 120:  {
  break;
 }
 default: {
  $46 = (_sqlite3Strlen30($0)|0); //@line 29182 "c/sqlite3.c"
  $47 = (_sqlite3Atoi64($0,$1,$46,1)|0); //@line 29182 "c/sqlite3.c"
  return ($47|0); //@line 29184 "c/sqlite3.c"
 }
 }
 $$025 = 2;
 while(1) {
  $6 = (($0) + ($$025)|0); //@line 29173 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 29173 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(48); //@line 29173 "c/sqlite3.c"
  $9 = (($$025) + 1)|0; //@line 29173 "c/sqlite3.c"
  if ($8) {
   $$025 = $9;
  } else {
   break;
  }
 }
 $10 = (($0) + ($$025)|0); //@line 29174 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 29174 "c/sqlite3.c"
 $12 = $11&255; //@line 29174 "c/sqlite3.c"
 $13 = (16281 + ($12)|0); //@line 29174 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 29174 "c/sqlite3.c"
 $15 = $14 & 8; //@line 29174 "c/sqlite3.c"
 $16 = ($15<<24>>24)==(0); //@line 29174 "c/sqlite3.c"
 if ($16) {
  $$0$lcssa = $$025;$$lcssa = $10;$38 = 0;$41 = 0;
 } else {
  $$029 = $$025;$17 = 0;$18 = 0;$22 = $11;
  while(1) {
   $19 = (_bitshift64Shl(($17|0),($18|0),4)|0); //@line 29175 "c/sqlite3.c"
   $20 = tempRet0; //@line 29175 "c/sqlite3.c"
   $21 = $22 << 24 >> 24; //@line 29175 "c/sqlite3.c"
   $23 = (_sqlite3HexToInt($21)|0); //@line 29175 "c/sqlite3.c"
   $24 = $23&255; //@line 29175 "c/sqlite3.c"
   $25 = (_i64Add(($19|0),($20|0),($24|0),0)|0); //@line 29175 "c/sqlite3.c"
   $26 = tempRet0; //@line 29175 "c/sqlite3.c"
   $27 = (($$029) + 1)|0; //@line 29174 "c/sqlite3.c"
   $28 = (($0) + ($27)|0); //@line 29174 "c/sqlite3.c"
   $29 = HEAP8[$28>>0]|0; //@line 29174 "c/sqlite3.c"
   $30 = $29&255; //@line 29174 "c/sqlite3.c"
   $31 = (16281 + ($30)|0); //@line 29174 "c/sqlite3.c"
   $32 = HEAP8[$31>>0]|0; //@line 29174 "c/sqlite3.c"
   $33 = $32 & 8; //@line 29174 "c/sqlite3.c"
   $34 = ($33<<24>>24)==(0); //@line 29174 "c/sqlite3.c"
   if ($34) {
    break;
   } else {
    $$029 = $27;$17 = $25;$18 = $26;$22 = $29;
   }
  }
  $35 = (($0) + ($27)|0); //@line 29174 "c/sqlite3.c"
  $$0$lcssa = $27;$$lcssa = $35;$38 = $25;$41 = $26;
 }
 $36 = $1; //@line 29177 "c/sqlite3.c"
 $37 = $36; //@line 29177 "c/sqlite3.c"
 HEAP32[$37>>2] = $38; //@line 29177 "c/sqlite3.c"
 $39 = (($36) + 4)|0; //@line 29177 "c/sqlite3.c"
 $40 = $39; //@line 29177 "c/sqlite3.c"
 HEAP32[$40>>2] = $41; //@line 29177 "c/sqlite3.c"
 $42 = HEAP8[$$lcssa>>0]|0; //@line 29178 "c/sqlite3.c"
 $43 = ($42<<24>>24)==(0); //@line 29178 "c/sqlite3.c"
 $44 = (($$0$lcssa) - ($$025))|0; //@line 29178 "c/sqlite3.c"
 $45 = ($44|0)>(16); //@line 29178 "c/sqlite3.c"
 $phitmp = $45 ? 2 : 0;
 $spec$select = $43 ? $phitmp : 2; //@line 29178 "c/sqlite3.c"
 return ($spec$select|0); //@line 29178 "c/sqlite3.c"
}
function _sqlite3ExprCachePinRegister($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01011 = 0, $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 25|0); //@line 95949 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 95949 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 95949 "c/sqlite3.c"
 if ($4) {
  return; //@line 95954 "c/sqlite3.c"
 }
 $5 = ((($0)) + 148|0); //@line 95949 "c/sqlite3.c"
 $6 = HEAP8[$2>>0]|0;
 $7 = $6&255;
 $$01011 = 0;$$012 = $5;
 while(1) {
  $8 = ((($$012)) + 12|0); //@line 95950 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 95950 "c/sqlite3.c"
  $10 = ($9|0)==($1|0); //@line 95950 "c/sqlite3.c"
  if ($10) {
   $11 = ((($$012)) + 6|0); //@line 95951 "c/sqlite3.c"
   HEAP8[$11>>0] = 0; //@line 95951 "c/sqlite3.c"
  }
  $12 = (($$01011) + 1)|0; //@line 95949 "c/sqlite3.c"
  $13 = ((($$012)) + 20|0); //@line 95949 "c/sqlite3.c"
  $14 = ($12>>>0)<($7>>>0); //@line 95949 "c/sqlite3.c"
  if ($14) {
   $$01011 = $12;$$012 = $13;
  } else {
   break;
  }
 }
 return; //@line 95954 "c/sqlite3.c"
}
function _sqlite3ExprCacheStore($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$031$pn = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select$1 = 0, $spec$select$2 = 0, $spec$select$3 = 0, $spec$select$4 = 0, $spec$select$5 = 0, $spec$select$6 = 0, $spec$select$7 = 0;
 var $spec$select$8 = 0, $spec$select36 = 0, $spec$select36$1 = 0, $spec$select36$2 = 0, $spec$select36$3 = 0, $spec$select36$4 = 0, $spec$select36$5 = 0, $spec$select36$6 = 0, $spec$select36$7 = 0, $spec$select36$8 = 0, $spec$select36$9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 95850 "c/sqlite3.c"
 $5 = ((($4)) + 68|0); //@line 95850 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 95850 "c/sqlite3.c"
 $7 = $6 & 2; //@line 95850 "c/sqlite3.c"
 $8 = ($7<<16>>16)==(0); //@line 95850 "c/sqlite3.c"
 if (!($8)) {
  return; //@line 95885 "c/sqlite3.c"
 }
 $9 = ((($0)) + 25|0); //@line 95864 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 95864 "c/sqlite3.c"
 $11 = ($10&255)>(9); //@line 95864 "c/sqlite3.c"
 if ($11) {
  $12 = ((($0)) + 164|0); //@line 95868 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 95868 "c/sqlite3.c"
  $14 = ($13|0)==(2147483647); //@line 95868 "c/sqlite3.c"
  $spec$select36 = $14 << 31 >> 31; //@line 95868 "c/sqlite3.c"
  $15 = ((($0)) + 184|0); //@line 95868 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 95868 "c/sqlite3.c"
  $17 = ($16|0)<($13|0); //@line 95868 "c/sqlite3.c"
  $spec$select$1 = $17 ? $16 : $13; //@line 95868 "c/sqlite3.c"
  $spec$select36$1 = $17 ? 1 : $spec$select36; //@line 95868 "c/sqlite3.c"
  $18 = ((($0)) + 204|0); //@line 95868 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 95868 "c/sqlite3.c"
  $20 = ($19|0)<($spec$select$1|0); //@line 95868 "c/sqlite3.c"
  $spec$select$2 = $20 ? $19 : $spec$select$1; //@line 95868 "c/sqlite3.c"
  $spec$select36$2 = $20 ? 2 : $spec$select36$1; //@line 95868 "c/sqlite3.c"
  $21 = ((($0)) + 224|0); //@line 95868 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 95868 "c/sqlite3.c"
  $23 = ($22|0)<($spec$select$2|0); //@line 95868 "c/sqlite3.c"
  $spec$select$3 = $23 ? $22 : $spec$select$2; //@line 95868 "c/sqlite3.c"
  $spec$select36$3 = $23 ? 3 : $spec$select36$2; //@line 95868 "c/sqlite3.c"
  $24 = ((($0)) + 244|0); //@line 95868 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 95868 "c/sqlite3.c"
  $26 = ($25|0)<($spec$select$3|0); //@line 95868 "c/sqlite3.c"
  $spec$select$4 = $26 ? $25 : $spec$select$3; //@line 95868 "c/sqlite3.c"
  $spec$select36$4 = $26 ? 4 : $spec$select36$3; //@line 95868 "c/sqlite3.c"
  $27 = ((($0)) + 264|0); //@line 95868 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 95868 "c/sqlite3.c"
  $29 = ($28|0)<($spec$select$4|0); //@line 95868 "c/sqlite3.c"
  $spec$select$5 = $29 ? $28 : $spec$select$4; //@line 95868 "c/sqlite3.c"
  $spec$select36$5 = $29 ? 5 : $spec$select36$4; //@line 95868 "c/sqlite3.c"
  $30 = ((($0)) + 284|0); //@line 95868 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 95868 "c/sqlite3.c"
  $32 = ($31|0)<($spec$select$5|0); //@line 95868 "c/sqlite3.c"
  $spec$select$6 = $32 ? $31 : $spec$select$5; //@line 95868 "c/sqlite3.c"
  $spec$select36$6 = $32 ? 6 : $spec$select36$5; //@line 95868 "c/sqlite3.c"
  $33 = ((($0)) + 304|0); //@line 95868 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 95868 "c/sqlite3.c"
  $35 = ($34|0)<($spec$select$6|0); //@line 95868 "c/sqlite3.c"
  $spec$select$7 = $35 ? $34 : $spec$select$6; //@line 95868 "c/sqlite3.c"
  $spec$select36$7 = $35 ? 7 : $spec$select36$6; //@line 95868 "c/sqlite3.c"
  $36 = ((($0)) + 324|0); //@line 95868 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 95868 "c/sqlite3.c"
  $38 = ($37|0)<($spec$select$7|0); //@line 95868 "c/sqlite3.c"
  $spec$select$8 = $38 ? $37 : $spec$select$7; //@line 95868 "c/sqlite3.c"
  $spec$select36$8 = $38 ? 8 : $spec$select36$7; //@line 95868 "c/sqlite3.c"
  $39 = ((($0)) + 344|0); //@line 95868 "c/sqlite3.c"
  $40 = HEAP32[$39>>2]|0; //@line 95868 "c/sqlite3.c"
  $41 = ($40|0)<($spec$select$8|0); //@line 95868 "c/sqlite3.c"
  $spec$select36$9 = $41 ? 9 : $spec$select36$8; //@line 95868 "c/sqlite3.c"
  $$031$pn = $spec$select36$9;
 } else {
  $42 = $10&255; //@line 95864 "c/sqlite3.c"
  $43 = (($10) + 1)<<24>>24; //@line 95875 "c/sqlite3.c"
  HEAP8[$9>>0] = $43; //@line 95875 "c/sqlite3.c"
  $$031$pn = $42;
 }
 $44 = ((($0)) + 60|0); //@line 95879 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 95879 "c/sqlite3.c"
 $46 = (((((($0)) + 148|0) + (($$031$pn*20)|0)|0)) + 8|0); //@line 95879 "c/sqlite3.c"
 HEAP32[$46>>2] = $45; //@line 95879 "c/sqlite3.c"
 $47 = (((($0)) + 148|0) + (($$031$pn*20)|0)|0); //@line 95880 "c/sqlite3.c"
 HEAP32[$47>>2] = $1; //@line 95880 "c/sqlite3.c"
 $48 = $2&65535; //@line 95881 "c/sqlite3.c"
 $49 = (((((($0)) + 148|0) + (($$031$pn*20)|0)|0)) + 4|0); //@line 95881 "c/sqlite3.c"
 HEAP16[$49>>1] = $48; //@line 95881 "c/sqlite3.c"
 $50 = (((((($0)) + 148|0) + (($$031$pn*20)|0)|0)) + 12|0); //@line 95882 "c/sqlite3.c"
 HEAP32[$50>>2] = $3; //@line 95882 "c/sqlite3.c"
 $51 = (((((($0)) + 148|0) + (($$031$pn*20)|0)|0)) + 6|0); //@line 95883 "c/sqlite3.c"
 HEAP8[$51>>0] = 0; //@line 95883 "c/sqlite3.c"
 $52 = ((($0)) + 64|0); //@line 95884 "c/sqlite3.c"
 $53 = HEAP32[$52>>2]|0; //@line 95884 "c/sqlite3.c"
 $54 = (($53) + 1)|0; //@line 95884 "c/sqlite3.c"
 HEAP32[$52>>2] = $54; //@line 95884 "c/sqlite3.c"
 $55 = (((((($0)) + 148|0) + (($$031$pn*20)|0)|0)) + 16|0); //@line 95884 "c/sqlite3.c"
 HEAP32[$55>>2] = $53; //@line 95884 "c/sqlite3.c"
 return; //@line 95885 "c/sqlite3.c"
}
function _collationMatch($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01415 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 32|0); //@line 105843 "c/sqlite3.c"
 $3 = ((($1)) + 52|0); //@line 105842 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 105842 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 105842 "c/sqlite3.c"
 if ($5) {
  $$2 = 0;
  return ($$2|0); //@line 105850 "c/sqlite3.c"
 }
 $6 = ((($1)) + 4|0);
 $7 = HEAP32[$6>>2]|0;
 $$01415 = 0;
 while(1) {
  $8 = (($7) + ($$01415<<1)|0); //@line 105845 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 105845 "c/sqlite3.c"
  $10 = ($9<<16>>16)>(-1); //@line 105845 "c/sqlite3.c"
  if ($10) {
   $11 = HEAP32[$2>>2]|0; //@line 105843 "c/sqlite3.c"
   $12 = (($11) + ($$01415<<2)|0); //@line 105843 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 105843 "c/sqlite3.c"
   $14 = (_sqlite3StrICmp($13,$0)|0); //@line 105845 "c/sqlite3.c"
   $15 = ($14|0)==(0); //@line 105845 "c/sqlite3.c"
   if ($15) {
    $$2 = 1;
    label = 6;
    break;
   }
  }
  $16 = (($$01415) + 1)|0; //@line 105842 "c/sqlite3.c"
  $17 = HEAP16[$3>>1]|0; //@line 105842 "c/sqlite3.c"
  $18 = $17&65535; //@line 105842 "c/sqlite3.c"
  $19 = ($16>>>0)<($18>>>0); //@line 105842 "c/sqlite3.c"
  if ($19) {
   $$01415 = $16;
  } else {
   $$2 = 0;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  return ($$2|0); //@line 105850 "c/sqlite3.c"
 }
 return (0)|0;
}
function _codeAttach($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$049 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $7 = sp;
 $8 = HEAP32[$0>>2]|0; //@line 101087 "c/sqlite3.c"
 $9 = ((($0)) + 36|0); //@line 101090 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 101090 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 101090 "c/sqlite3.c"
 do {
  if ($11) {
   $12 = ((($7)) + 4|0);
   ;HEAP32[$12>>2]=0|0;HEAP32[$12+4>>2]=0|0;HEAP32[$12+8>>2]=0|0;HEAP32[$12+12>>2]=0|0;HEAP32[$12+16>>2]=0|0;HEAP32[$12+20>>2]=0|0;HEAP32[$12+24>>2]=0|0; //@line 101091 "c/sqlite3.c"
   HEAP32[$7>>2] = $0; //@line 101092 "c/sqlite3.c"
   $13 = (_resolveAttachExpr($7,$4)|0); //@line 101095 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 101095 "c/sqlite3.c"
   if ($14) {
    $15 = (_resolveAttachExpr($7,$5)|0); //@line 101096 "c/sqlite3.c"
    $16 = ($15|0)==(0); //@line 101096 "c/sqlite3.c"
    if ($16) {
     $17 = (_resolveAttachExpr($7,$6)|0); //@line 101097 "c/sqlite3.c"
     $18 = ($17|0)==(0); //@line 101097 "c/sqlite3.c"
     if ($18) {
      $19 = ($3|0)==(0|0); //@line 101103 "c/sqlite3.c"
      if (!($19)) {
       $20 = HEAP8[$3>>0]|0; //@line 101105 "c/sqlite3.c"
       $21 = ($20<<24>>24)==(97); //@line 101105 "c/sqlite3.c"
       if ($21) {
        $22 = ((($3)) + 8|0); //@line 101106 "c/sqlite3.c"
        $23 = HEAP32[$22>>2]|0; //@line 101106 "c/sqlite3.c"
        $$049 = $23;
       } else {
        $$049 = 0;
       }
       $24 = (_sqlite3AuthCheck($0,$1,$$049,0,0)|0); //@line 101110 "c/sqlite3.c"
       $25 = ($24|0)==(0); //@line 101111 "c/sqlite3.c"
       if (!($25)) {
        break;
       }
      }
      $26 = (_sqlite3GetVdbe($0)|0); //@line 101118 "c/sqlite3.c"
      $27 = (_sqlite3GetTempRange($0,4)|0); //@line 101119 "c/sqlite3.c"
      _sqlite3ExprCode($0,$4,$27); //@line 101120 "c/sqlite3.c"
      $28 = (($27) + 1)|0; //@line 101121 "c/sqlite3.c"
      _sqlite3ExprCode($0,$5,$28); //@line 101121 "c/sqlite3.c"
      $29 = (($27) + 2)|0; //@line 101122 "c/sqlite3.c"
      _sqlite3ExprCode($0,$6,$29); //@line 101122 "c/sqlite3.c"
      $30 = ($26|0)==(0|0); //@line 101125 "c/sqlite3.c"
      if (!($30)) {
       $31 = (($27) + 3)|0; //@line 101126 "c/sqlite3.c"
       $32 = HEAP8[$2>>0]|0; //@line 101126 "c/sqlite3.c"
       $33 = $32 << 24 >> 24; //@line 101126 "c/sqlite3.c"
       $34 = (($31) - ($33))|0; //@line 101126 "c/sqlite3.c"
       (_sqlite3VdbeAddOp4($26,163,0,$34,$31,$2,-8)|0); //@line 101126 "c/sqlite3.c"
       $35 = HEAP8[$2>>0]|0; //@line 101129 "c/sqlite3.c"
       $36 = $35&255; //@line 101129 "c/sqlite3.c"
       _sqlite3VdbeChangeP5($26,$36); //@line 101129 "c/sqlite3.c"
       $37 = ($1|0)==(24); //@line 101135 "c/sqlite3.c"
       $38 = $37&1; //@line 101135 "c/sqlite3.c"
       (_sqlite3VdbeAddOp1($26,152,$38)|0); //@line 101135 "c/sqlite3.c"
      }
     }
    }
   }
  }
 } while(0);
 _sqlite3ExprDelete($8,$4); //@line 101139 "c/sqlite3.c"
 _sqlite3ExprDelete($8,$5); //@line 101140 "c/sqlite3.c"
 _sqlite3ExprDelete($8,$6); //@line 101141 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 101142 "c/sqlite3.c"
}
function _resolveAttachExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 100807 "c/sqlite3.c"
 do {
  if ($2) {
   $$0 = 0;
  } else {
   $3 = HEAP8[$1>>0]|0; //@line 100808 "c/sqlite3.c"
   $4 = ($3<<24>>24)==(59); //@line 100808 "c/sqlite3.c"
   if ($4) {
    HEAP8[$1>>0] = 97; //@line 100811 "c/sqlite3.c"
    $$0 = 0;
    break;
   } else {
    $5 = (_sqlite3ResolveExprNames($0,$1)|0); //@line 100809 "c/sqlite3.c"
    $$0 = $5;
    break;
   }
  }
 } while(0);
 return ($$0|0); //@line 100814 "c/sqlite3.c"
}
function _detachFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03135 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 160|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(160|0);
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = sp + 24|0;
 $4 = HEAP32[$2>>2]|0; //@line 101033 "c/sqlite3.c"
 $5 = (_sqlite3_value_text($4)|0); //@line 101033 "c/sqlite3.c"
 $6 = (_sqlite3_context_db_handle($0)|0); //@line 101034 "c/sqlite3.c"
 $7 = ($5|0)==(0|0); //@line 101041 "c/sqlite3.c"
 $spec$select = $7 ? 41388 : $5; //@line 101041 "c/sqlite3.c"
 $8 = ((($6)) + 20|0); //@line 101042 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 101042 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 101042 "c/sqlite3.c"
 L1: do {
  if ($10) {
   $11 = ((($6)) + 16|0);
   $12 = HEAP32[$11>>2]|0;
   $$03135 = 0;
   while(1) {
    $13 = (((($12) + ($$03135<<4)|0)) + 4|0); //@line 101044 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 101044 "c/sqlite3.c"
    $15 = ($14|0)==(0|0); //@line 101044 "c/sqlite3.c"
    if (!($15)) {
     $16 = (($12) + ($$03135<<4)|0); //@line 101045 "c/sqlite3.c"
     $17 = HEAP32[$16>>2]|0; //@line 101045 "c/sqlite3.c"
     $18 = (_sqlite3StrICmp($17,$spec$select)|0); //@line 101045 "c/sqlite3.c"
     $19 = ($18|0)==(0); //@line 101045 "c/sqlite3.c"
     if ($19) {
      break;
     }
    }
    $20 = (($$03135) + 1)|0; //@line 101042 "c/sqlite3.c"
    $21 = HEAP32[$8>>2]|0; //@line 101042 "c/sqlite3.c"
    $22 = ($20|0)<($21|0); //@line 101042 "c/sqlite3.c"
    if ($22) {
     $$03135 = $20;
    } else {
     label = 6;
     break L1;
    }
   }
   $23 = ($$03135>>>0)<(2); //@line 101052 "c/sqlite3.c"
   if ($23) {
    HEAP32[$vararg_buffer1>>2] = $spec$select; //@line 101053 "c/sqlite3.c"
    (_sqlite3_snprintf(128,$3,25072,$vararg_buffer1)|0); //@line 101053 "c/sqlite3.c"
    break;
   }
   $24 = (((($12) + ($$03135<<4)|0)) + 4|0); //@line 101056 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 101056 "c/sqlite3.c"
   $26 = (_sqlite3BtreeIsInReadTrans($25)|0); //@line 101056 "c/sqlite3.c"
   $27 = ($26|0)==(0); //@line 101056 "c/sqlite3.c"
   if ($27) {
    $28 = (_sqlite3BtreeIsInBackup($25)|0); //@line 101056 "c/sqlite3.c"
    $29 = ($28|0)==(0); //@line 101056 "c/sqlite3.c"
    if ($29) {
     _sqlite3BtreeClose($25); //@line 101061 "c/sqlite3.c"
     HEAP32[$24>>2] = 0; //@line 101062 "c/sqlite3.c"
     $30 = (((($12) + ($$03135<<4)|0)) + 12|0); //@line 101063 "c/sqlite3.c"
     HEAP32[$30>>2] = 0; //@line 101063 "c/sqlite3.c"
     _sqlite3CollapseDatabaseArray($6); //@line 101064 "c/sqlite3.c"
     STACKTOP = sp;return; //@line 101069 "c/sqlite3.c"
    }
   }
   HEAP32[$vararg_buffer4>>2] = $spec$select; //@line 101057 "c/sqlite3.c"
   (_sqlite3_snprintf(128,$3,25098,$vararg_buffer4)|0); //@line 101057 "c/sqlite3.c"
  } else {
   label = 6;
  }
 } while(0);
 if ((label|0) == 6) {
  HEAP32[$vararg_buffer>>2] = $spec$select; //@line 101049 "c/sqlite3.c"
  (_sqlite3_snprintf(128,$3,25051,$vararg_buffer)|0); //@line 101049 "c/sqlite3.c"
 }
 _sqlite3_result_error($0,$3,-1); //@line 101068 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 101069 "c/sqlite3.c"
}
function _sqlite3BtreeIsInBackup($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 70171 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70171 "c/sqlite3.c"
 $3 = ($2|0)!=(0); //@line 70171 "c/sqlite3.c"
 $4 = $3&1; //@line 70171 "c/sqlite3.c"
 return ($4|0); //@line 70171 "c/sqlite3.c"
}
function _attachFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0120 = 0, $$0122 = 0, $$0124$in = 0, $$0136 = 0, $$1 = 0, $$2 = 0, $$3127 = 0, $$4 = 0, $$4129 = 0, $$4130 = 0, $$lcssa = 0, $$lcssa134 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0;
 var $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond125 = 0, $spec$select = 0, $switch$split2D = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer10 = 0, $vararg_buffer4 = 0, $vararg_buffer6 = 0, $vararg_buffer8 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer10 = sp + 40|0;
 $vararg_buffer8 = sp + 32|0;
 $vararg_buffer6 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = sp + 60|0;
 $4 = sp + 56|0;
 $5 = sp + 52|0;
 $6 = sp + 48|0;
 $7 = sp + 44|0;
 $8 = (_sqlite3_context_db_handle($0)|0); //@line 100835 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 100838 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 100839 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 100843 "c/sqlite3.c"
 $9 = HEAP32[$2>>2]|0; //@line 100848 "c/sqlite3.c"
 $10 = (_sqlite3_value_text($9)|0); //@line 100848 "c/sqlite3.c"
 $11 = ((($2)) + 4|0); //@line 100849 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 100849 "c/sqlite3.c"
 $13 = (_sqlite3_value_text($12)|0); //@line 100849 "c/sqlite3.c"
 $14 = ($10|0)==(0|0); //@line 100850 "c/sqlite3.c"
 $spec$select = $14 ? 41388 : $10; //@line 100850 "c/sqlite3.c"
 $15 = ($13|0)==(0|0); //@line 100851 "c/sqlite3.c"
 $$0122 = $15 ? 41388 : $13; //@line 100851 "c/sqlite3.c"
 $16 = ((($8)) + 20|0); //@line 100859 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 100859 "c/sqlite3.c"
 $18 = ((($8)) + 128|0); //@line 100859 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 100859 "c/sqlite3.c"
 $20 = (($19) + 2)|0; //@line 100859 "c/sqlite3.c"
 $21 = ($17|0)<($20|0); //@line 100859 "c/sqlite3.c"
 L1: do {
  if ($21) {
   $23 = HEAP32[$16>>2]|0; //@line 100865 "c/sqlite3.c"
   $24 = ($23|0)>(0); //@line 100865 "c/sqlite3.c"
   $25 = ((($8)) + 16|0);
   $26 = HEAP32[$25>>2]|0;
   L3: do {
    if ($24) {
     $$0136 = 0;$32 = $26;
     while(1) {
      $31 = (($32) + ($$0136<<4)|0); //@line 100866 "c/sqlite3.c"
      $33 = HEAP32[$31>>2]|0; //@line 100866 "c/sqlite3.c"
      $34 = (_sqlite3StrICmp($33,$$0122)|0); //@line 100868 "c/sqlite3.c"
      $35 = ($34|0)==(0); //@line 100868 "c/sqlite3.c"
      $29 = (($$0136) + 1)|0; //@line 100865 "c/sqlite3.c"
      if ($35) {
       break;
      }
      $27 = HEAP32[$16>>2]|0; //@line 100865 "c/sqlite3.c"
      $28 = ($29|0)<($27|0); //@line 100865 "c/sqlite3.c"
      $30 = HEAP32[$25>>2]|0;
      if ($28) {
       $$0136 = $29;$32 = $30;
      } else {
       $$lcssa = $30;$$lcssa134 = $27;
       break L3;
      }
     }
     HEAP32[$vararg_buffer1>>2] = $$0122; //@line 100869 "c/sqlite3.c"
     $36 = (_sqlite3MPrintf($8,25171,$vararg_buffer1)|0); //@line 100869 "c/sqlite3.c"
     HEAP32[$6>>2] = $36; //@line 100869 "c/sqlite3.c"
     $$4 = 0;$117 = $36;
     label = 30;
     break L1;
    } else {
     $$lcssa = $26;$$lcssa134 = $23;
    }
   } while(0);
   $37 = ((($8)) + 400|0); //@line 100877 "c/sqlite3.c"
   $38 = ($$lcssa|0)==($37|0); //@line 100877 "c/sqlite3.c"
   do {
    if ($38) {
     $39 = (_sqlite3DbMallocRawNN($8,48,0)|0); //@line 100878 "c/sqlite3.c"
     $40 = ($39|0)==(0|0); //@line 100879 "c/sqlite3.c"
     if ($40) {
      STACKTOP = sp;return; //@line 101018 "c/sqlite3.c"
     } else {
      $41 = HEAP32[$25>>2]|0; //@line 100880 "c/sqlite3.c"
      ;HEAP32[$39>>2]=HEAP32[$41>>2]|0;HEAP32[$39+4>>2]=HEAP32[$41+4>>2]|0;HEAP32[$39+8>>2]=HEAP32[$41+8>>2]|0;HEAP32[$39+12>>2]=HEAP32[$41+12>>2]|0;HEAP32[$39+16>>2]=HEAP32[$41+16>>2]|0;HEAP32[$39+20>>2]=HEAP32[$41+20>>2]|0;HEAP32[$39+24>>2]=HEAP32[$41+24>>2]|0;HEAP32[$39+28>>2]=HEAP32[$41+28>>2]|0; //@line 100880 "c/sqlite3.c"
      $$0124$in = $39;
      break;
     }
    } else {
     $42 = $$lcssa134 << 4; //@line 100882 "c/sqlite3.c"
     $43 = (($42) + 16)|0; //@line 100882 "c/sqlite3.c"
     $44 = (_sqlite3DbRealloc($8,$$lcssa,$43,0)|0); //@line 100882 "c/sqlite3.c"
     $45 = ($44|0)==(0|0); //@line 100883 "c/sqlite3.c"
     if ($45) {
      STACKTOP = sp;return; //@line 101018 "c/sqlite3.c"
     } else {
      $$0124$in = $44;
     }
    }
   } while(0);
   HEAP32[$25>>2] = $$0124$in; //@line 100885 "c/sqlite3.c"
   $46 = HEAP32[$16>>2]|0; //@line 100886 "c/sqlite3.c"
   $47 = (($$0124$in) + ($46<<4)|0); //@line 100886 "c/sqlite3.c"
   ;HEAP32[$47>>2]=0|0;HEAP32[$47+4>>2]=0|0;HEAP32[$47+8>>2]=0|0;HEAP32[$47+12>>2]=0|0; //@line 100887 "c/sqlite3.c"
   $48 = ((($8)) + 52|0); //@line 100893 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 100893 "c/sqlite3.c"
   HEAP32[$5>>2] = $49; //@line 100893 "c/sqlite3.c"
   $50 = HEAP32[$8>>2]|0; //@line 100894 "c/sqlite3.c"
   $51 = ((($50)) + 16|0); //@line 100894 "c/sqlite3.c"
   $52 = HEAP32[$51>>2]|0; //@line 100894 "c/sqlite3.c"
   $53 = (_sqlite3ParseUri($52,$spec$select,$5,$7,$3,$4)|0); //@line 100894 "c/sqlite3.c"
   switch ($53|0) {
   case 0:  {
    $55 = HEAP32[$5>>2]|0; //@line 100902 "c/sqlite3.c"
    $56 = $55 | 256; //@line 100902 "c/sqlite3.c"
    HEAP32[$5>>2] = $56; //@line 100902 "c/sqlite3.c"
    $57 = HEAP32[$7>>2]|0; //@line 100903 "c/sqlite3.c"
    $58 = HEAP32[$3>>2]|0; //@line 100903 "c/sqlite3.c"
    $59 = (((($$0124$in) + ($46<<4)|0)) + 4|0); //@line 100903 "c/sqlite3.c"
    $60 = (_sqlite3BtreeOpen($57,$58,$8,$59,0,$56)|0); //@line 100903 "c/sqlite3.c"
    _sqlite3_free($58); //@line 100904 "c/sqlite3.c"
    $61 = HEAP32[$16>>2]|0; //@line 100905 "c/sqlite3.c"
    $62 = (($61) + 1)|0; //@line 100905 "c/sqlite3.c"
    HEAP32[$16>>2] = $62; //@line 100905 "c/sqlite3.c"
    $63 = ((($8)) + 81|0); //@line 100906 "c/sqlite3.c"
    HEAP8[$63>>0] = 0; //@line 100906 "c/sqlite3.c"
    switch ($60|0) {
    case 19:  {
     $64 = (_sqlite3MPrintf($8,25201,$vararg_buffer4)|0); //@line 100909 "c/sqlite3.c"
     HEAP32[$6>>2] = $64; //@line 100909 "c/sqlite3.c"
     $$1 = 1;
     break;
    }
    case 0:  {
     $65 = HEAP32[$59>>2]|0; //@line 100912 "c/sqlite3.c"
     $66 = (_sqlite3SchemaGet($8,$65)|0); //@line 100912 "c/sqlite3.c"
     $67 = (((($$0124$in) + ($46<<4)|0)) + 12|0); //@line 100912 "c/sqlite3.c"
     HEAP32[$67>>2] = $66; //@line 100912 "c/sqlite3.c"
     $68 = ($66|0)==(0|0); //@line 100913 "c/sqlite3.c"
     if ($68) {
      $$0120 = 7;
     } else {
      $69 = ((($66)) + 76|0); //@line 100915 "c/sqlite3.c"
      $70 = HEAP8[$69>>0]|0; //@line 100915 "c/sqlite3.c"
      $71 = ($70<<24>>24)==(0); //@line 100915 "c/sqlite3.c"
      if ($71) {
       $$0120 = 0;
      } else {
       $72 = ((($66)) + 77|0); //@line 100915 "c/sqlite3.c"
       $73 = HEAP8[$72>>0]|0; //@line 100915 "c/sqlite3.c"
       $74 = ((($8)) + 70|0); //@line 100915 "c/sqlite3.c"
       $75 = HEAP8[$74>>0]|0; //@line 100915 "c/sqlite3.c"
       $76 = ($73<<24>>24)==($75<<24>>24); //@line 100915 "c/sqlite3.c"
       if ($76) {
        $$0120 = 0;
       } else {
        $77 = (_sqlite3MPrintf($8,21459,$vararg_buffer6)|0); //@line 100916 "c/sqlite3.c"
        HEAP32[$6>>2] = $77; //@line 100916 "c/sqlite3.c"
        $$0120 = 1;
       }
      }
     }
     $78 = HEAP32[$59>>2]|0; //@line 100920 "c/sqlite3.c"
     _sqlite3BtreeEnter($78); //@line 100920 "c/sqlite3.c"
     $79 = HEAP32[$59>>2]|0; //@line 100921 "c/sqlite3.c"
     $80 = (_sqlite3BtreePager($79)|0); //@line 100921 "c/sqlite3.c"
     $81 = ((($8)) + 75|0); //@line 100922 "c/sqlite3.c"
     $82 = HEAP8[$81>>0]|0; //@line 100922 "c/sqlite3.c"
     $83 = $82&255; //@line 100922 "c/sqlite3.c"
     (_sqlite3PagerLockingMode($80,$83)|0); //@line 100922 "c/sqlite3.c"
     $84 = HEAP32[$59>>2]|0; //@line 100923 "c/sqlite3.c"
     $85 = HEAP32[$25>>2]|0; //@line 100924 "c/sqlite3.c"
     $86 = ((($85)) + 4|0); //@line 100924 "c/sqlite3.c"
     $87 = HEAP32[$86>>2]|0; //@line 100924 "c/sqlite3.c"
     $88 = (_sqlite3BtreeSecureDelete($87,-1)|0); //@line 100924 "c/sqlite3.c"
     (_sqlite3BtreeSecureDelete($84,$88)|0); //@line 100923 "c/sqlite3.c"
     $89 = HEAP32[$59>>2]|0; //@line 100926 "c/sqlite3.c"
     $90 = ((($8)) + 28|0); //@line 100927 "c/sqlite3.c"
     $91 = HEAP32[$90>>2]|0; //@line 100927 "c/sqlite3.c"
     $92 = $91 & 56; //@line 100927 "c/sqlite3.c"
     $93 = $92 | 3; //@line 100927 "c/sqlite3.c"
     _sqlite3BtreeSetPagerFlags($89,$93); //@line 100926 "c/sqlite3.c"
     $94 = HEAP32[$59>>2]|0; //@line 100929 "c/sqlite3.c"
     _sqlite3BtreeLeave($94); //@line 100929 "c/sqlite3.c"
     $$1 = $$0120;
     break;
    }
    default: {
     $$1 = $60;
    }
    }
    $95 = (((($$0124$in) + ($46<<4)|0)) + 8|0); //@line 100931 "c/sqlite3.c"
    HEAP8[$95>>0] = 3; //@line 100931 "c/sqlite3.c"
    $96 = (_sqlite3DbStrDup($8,$$0122)|0); //@line 100932 "c/sqlite3.c"
    HEAP32[$47>>2] = $96; //@line 100932 "c/sqlite3.c"
    $97 = ($$1|0)==(0); //@line 100933 "c/sqlite3.c"
    $98 = ($96|0)==(0|0); //@line 100933 "c/sqlite3.c"
    $or$cond125 = $97 & $98; //@line 100933 "c/sqlite3.c"
    $$2 = $or$cond125 ? 7 : $$1; //@line 100933 "c/sqlite3.c"
    $99 = ($$2|0)==(0); //@line 100975 "c/sqlite3.c"
    if ($99) {
     _sqlite3BtreeEnterAll($8); //@line 100976 "c/sqlite3.c"
     $100 = (_sqlite3Init($8,$6)|0); //@line 100977 "c/sqlite3.c"
     _sqlite3BtreeLeaveAll($8); //@line 100978 "c/sqlite3.c"
     $101 = ($100|0)==(0); //@line 100989 "c/sqlite3.c"
     if ($101) {
      STACKTOP = sp;return; //@line 101018 "c/sqlite3.c"
     } else {
      $$3127 = $100;
     }
    } else {
     $$3127 = $$2;
    }
    $102 = HEAP32[$16>>2]|0; //@line 100990 "c/sqlite3.c"
    $103 = (($102) + -1)|0; //@line 100990 "c/sqlite3.c"
    $104 = HEAP32[$25>>2]|0; //@line 100992 "c/sqlite3.c"
    $105 = (((($104) + ($103<<4)|0)) + 4|0); //@line 100992 "c/sqlite3.c"
    $106 = HEAP32[$105>>2]|0; //@line 100992 "c/sqlite3.c"
    $107 = ($106|0)==(0|0); //@line 100992 "c/sqlite3.c"
    if (!($107)) {
     _sqlite3BtreeClose($106); //@line 100993 "c/sqlite3.c"
     $108 = HEAP32[$25>>2]|0; //@line 100994 "c/sqlite3.c"
     $109 = (((($108) + ($103<<4)|0)) + 4|0); //@line 100994 "c/sqlite3.c"
     HEAP32[$109>>2] = 0; //@line 100994 "c/sqlite3.c"
     $110 = (((($108) + ($103<<4)|0)) + 12|0); //@line 100995 "c/sqlite3.c"
     HEAP32[$110>>2] = 0; //@line 100995 "c/sqlite3.c"
    }
    _sqlite3ResetAllSchemasOfConnection($8); //@line 100997 "c/sqlite3.c"
    HEAP32[$16>>2] = $103; //@line 100998 "c/sqlite3.c"
    $switch$split2D = ($$3127|0)<(3082);
    if ($switch$split2D) {
     switch ($$3127|0) {
     case 7:  {
      label = 27;
      break;
     }
     default: {
     }
     }
    } else {
     switch ($$3127|0) {
     case 3082:  {
      label = 27;
      break;
     }
     default: {
     }
     }
    }
    if ((label|0) == 27) {
     _sqlite3OomFault($8); //@line 101000 "c/sqlite3.c"
     $111 = HEAP32[$6>>2]|0; //@line 101001 "c/sqlite3.c"
     _sqlite3DbFree($8,$111); //@line 101001 "c/sqlite3.c"
     $112 = (_sqlite3MPrintf($8,17402,$vararg_buffer8)|0); //@line 101002 "c/sqlite3.c"
     HEAP32[$6>>2] = $112; //@line 101002 "c/sqlite3.c"
     $$4 = $$3127;$117 = $112;
     label = 30;
     break L1;
    }
    $113 = HEAP32[$6>>2]|0; //@line 101003 "c/sqlite3.c"
    $114 = ($113|0)==(0|0); //@line 101003 "c/sqlite3.c"
    if (!($114)) {
     $$4129 = $$3127;$118 = $113;
     label = 31;
     break L1;
    }
    HEAP32[$vararg_buffer10>>2] = $spec$select; //@line 101004 "c/sqlite3.c"
    $115 = (_sqlite3MPrintf($8,25230,$vararg_buffer10)|0); //@line 101004 "c/sqlite3.c"
    HEAP32[$6>>2] = $115; //@line 101004 "c/sqlite3.c"
    $$4 = $$3127;$117 = $115;
    label = 30;
    break L1;
    break;
   }
   case 7:  {
    _sqlite3OomFault($8); //@line 100896 "c/sqlite3.c"
    break;
   }
   default: {
   }
   }
   $54 = HEAP32[$4>>2]|0; //@line 100897 "c/sqlite3.c"
   _sqlite3_result_error($0,$54,-1); //@line 100897 "c/sqlite3.c"
   _sqlite3_free($54); //@line 100898 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 101018 "c/sqlite3.c"
  } else {
   HEAP32[$vararg_buffer>>2] = $19; //@line 100860 "c/sqlite3.c"
   $22 = (_sqlite3MPrintf($8,25134,$vararg_buffer)|0); //@line 100860 "c/sqlite3.c"
   HEAP32[$6>>2] = $22; //@line 100860 "c/sqlite3.c"
   $$4 = 0;$117 = $22;
   label = 30;
  }
 } while(0);
 if ((label|0) == 30) {
  $116 = ($117|0)==(0|0); //@line 101013 "c/sqlite3.c"
  if ($116) {
   $$4130 = $$4;
  } else {
   $$4129 = $$4;$118 = $117;
   label = 31;
  }
 }
 if ((label|0) == 31) {
  _sqlite3_result_error($0,$118,-1); //@line 101014 "c/sqlite3.c"
  $119 = HEAP32[$6>>2]|0; //@line 101015 "c/sqlite3.c"
  _sqlite3DbFree($8,$119); //@line 101015 "c/sqlite3.c"
  $$4130 = $$4129;
 }
 $120 = ($$4130|0)==(0); //@line 101017 "c/sqlite3.c"
 if ($120) {
  STACKTOP = sp;return; //@line 101018 "c/sqlite3.c"
 }
 _sqlite3_result_error_code($0,$$4130); //@line 101017 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 101018 "c/sqlite3.c"
}
function _sqlite3ParseUri($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0212332 = 0, $$0224340 = 0, $$0233339 = 0, $$0245$ph = 0, $$0249345 = 0, $$0257$ph = 0, $$0260338 = 0, $$0262 = 0, $$1 = 0, $$1214278 = 0, $$1216277 = 0, $$1218276 = 0, $$1220275 = 0, $$1234 = 0, $$1263$ph = 0, $$1266 = 0, $$2247 = 0, $$2259 = 0, $$2264 = 0, $$3227$ph = 0;
 var $$3248 = 0, $$3252 = 0, $$3252$be = 0, $$3252$ph = 0, $$3252$ph$ph = 0, $$4228 = 0, $$4237 = 0, $$4253 = 0, $$6255 = 0, $$7231 = 0, $$7256 = 0, $$8$ph = 0, $$8232$ph = 0, $$8232300 = 0, $$8302 = 0, $$old = 0, $$old269 = 0, $$sink = 0, $10 = 0, $100 = 0;
 var $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0;
 var $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0;
 var $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0;
 var $156 = 0, $157 = 0, $158 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0;
 var $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $or$cond5 = 0, $trunc = 0, $trunc$clear = 0, $vararg_buffer = 0, $vararg_buffer10 = 0, $vararg_buffer2 = 0, $vararg_buffer6 = 0;
 var $vararg_ptr1 = 0, $vararg_ptr5 = 0, $vararg_ptr9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer10 = sp + 24|0; //@line 145927 "c/sqlite3.c"
 $vararg_buffer6 = sp + 16|0; //@line 145927 "c/sqlite3.c"
 $vararg_buffer2 = sp + 8|0; //@line 145927 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 145927 "c/sqlite3.c"
 $6 = HEAP32[$2>>2]|0; //@line 145935 "c/sqlite3.c"
 $7 = (_sqlite3Strlen30($1)|0); //@line 145939 "c/sqlite3.c"
 $8 = $6 & 64; //@line 145943 "c/sqlite3.c"
 $9 = HEAP32[(20)>>2]|0; //@line 145944 "c/sqlite3.c"
 $10 = $9 | $8; //@line 145944 "c/sqlite3.c"
 $11 = ($10|0)!=(0); //@line 145944 "c/sqlite3.c"
 $12 = ($7|0)>(4); //@line 145945 "c/sqlite3.c"
 $or$cond5 = $12 & $11; //@line 145944 "c/sqlite3.c"
 L1: do {
  if ($or$cond5) {
   $13 = (_memcmp($1,25258,5)|0); //@line 145945 "c/sqlite3.c"
   $14 = ($13|0)==(0); //@line 145945 "c/sqlite3.c"
   if ($14) {
    $15 = (($7) + 2)|0; //@line 145951 "c/sqlite3.c"
    $16 = ($15|0)<(0); //@line 145951 "c/sqlite3.c"
    $17 = $16 << 31 >> 31; //@line 145951 "c/sqlite3.c"
    $18 = $6 | 64; //@line 145955 "c/sqlite3.c"
    $$0249345 = 0;$23 = $15;$24 = $17;
    while(1) {
     $19 = (($1) + ($$0249345)|0); //@line 145957 "c/sqlite3.c"
     $20 = HEAP8[$19>>0]|0; //@line 145957 "c/sqlite3.c"
     $21 = ($20<<24>>24)==(38); //@line 145957 "c/sqlite3.c"
     $22 = $21&1; //@line 145957 "c/sqlite3.c"
     $25 = (_i64Add(($23|0),($24|0),($22|0),0)|0); //@line 145957 "c/sqlite3.c"
     $26 = tempRet0; //@line 145957 "c/sqlite3.c"
     $27 = (($$0249345) + 1)|0; //@line 145957 "c/sqlite3.c"
     $exitcond = ($27|0)==($7|0); //@line 145957 "c/sqlite3.c"
     if ($exitcond) {
      break;
     } else {
      $$0249345 = $27;$23 = $25;$24 = $26;
     }
    }
    $28 = (_sqlite3_malloc64($25,$26)|0); //@line 145958 "c/sqlite3.c"
    $29 = ($28|0)==(0|0); //@line 145959 "c/sqlite3.c"
    if ($29) {
     $$1 = 7;
     STACKTOP = sp;return ($$1|0); //@line 146154 "c/sqlite3.c"
    }
    $30 = ((($1)) + 5|0); //@line 145976 "c/sqlite3.c"
    $31 = HEAP8[$30>>0]|0; //@line 145976 "c/sqlite3.c"
    $32 = ($31<<24>>24)==(47); //@line 145976 "c/sqlite3.c"
    L10: do {
     if ($32) {
      $33 = ((($1)) + 6|0); //@line 145976 "c/sqlite3.c"
      $34 = HEAP8[$33>>0]|0; //@line 145976 "c/sqlite3.c"
      $35 = ($34<<24>>24)==(47); //@line 145976 "c/sqlite3.c"
      if ($35) {
       $trunc = 7;
       L13: while(1) {
        $36 = (($1) + ($trunc)|0); //@line 145978 "c/sqlite3.c"
        $37 = HEAP8[$36>>0]|0; //@line 145978 "c/sqlite3.c"
        switch ($37<<24>>24) {
        case 0: case 47:  {
         break L13;
         break;
        }
        default: {
        }
        }
        $38 = (($trunc) + 1)|0; //@line 145978 "c/sqlite3.c"
        $trunc = $38;
       }
       $trunc$clear = $trunc & 2147483647; //@line 145979 "c/sqlite3.c"
       switch ($trunc$clear|0) {
       case 7:  {
        $$3252$ph$ph = 7;
        break L10;
        break;
       }
       case 16:  {
        $39 = ((($1)) + 7|0); //@line 145979 "c/sqlite3.c"
        $40 = (_memcmp(25264,$39,9)|0); //@line 145979 "c/sqlite3.c"
        $41 = ($40|0)==(0); //@line 145979 "c/sqlite3.c"
        if ($41) {
         $$3252$ph$ph = 16;
         break L10;
        }
        break;
       }
       default: {
       }
       }
       $42 = (($trunc) + -7)|0; //@line 145981 "c/sqlite3.c"
       $43 = ((($1)) + 7|0); //@line 145981 "c/sqlite3.c"
       HEAP32[$vararg_buffer>>2] = $42; //@line 145980 "c/sqlite3.c"
       $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 145980 "c/sqlite3.c"
       HEAP32[$vararg_ptr1>>2] = $43; //@line 145980 "c/sqlite3.c"
       $44 = (_sqlite3_mprintf(25274,$vararg_buffer)|0); //@line 145980 "c/sqlite3.c"
       $$1263$ph = $28;$$8$ph = 1;$$8232$ph = $18;$$sink = $44;
       label = 69;
       break L1;
      } else {
       $$3252$ph$ph = 5;
      }
     } else {
      $$3252$ph$ph = 5;
     }
    } while(0);
    $$0245$ph = 0;$$0257$ph = 0;$$3252$ph = $$3252$ph$ph;
    L21: while(1) {
     $45 = (($$0245$ph) + -1)|0;
     $46 = (($28) + ($45)|0);
     $47 = ($$0257$ph|0)==(0);
     $48 = ($$0257$ph|0)==(1);
     $49 = ($$0257$ph|0)!=(2);
     $$3252 = $$3252$ph;
     L23: while(1) {
      $50 = (($1) + ($$3252)|0); //@line 145999 "c/sqlite3.c"
      $51 = HEAP8[$50>>0]|0; //@line 145999 "c/sqlite3.c"
      switch ($51<<24>>24) {
      case 0: case 35:  {
       break L21;
       break;
      }
      default: {
      }
      }
      $52 = (($$3252) + 1)|0; //@line 146000 "c/sqlite3.c"
      $53 = ($51<<24>>24)==(37); //@line 146001 "c/sqlite3.c"
      L26: do {
       if ($53) {
        $54 = (($1) + ($52)|0); //@line 146002 "c/sqlite3.c"
        $55 = HEAP8[$54>>0]|0; //@line 146002 "c/sqlite3.c"
        $56 = $55&255; //@line 146002 "c/sqlite3.c"
        $57 = (16281 + ($56)|0); //@line 146002 "c/sqlite3.c"
        $58 = HEAP8[$57>>0]|0; //@line 146002 "c/sqlite3.c"
        $59 = $58 & 8; //@line 146002 "c/sqlite3.c"
        $60 = ($59<<24>>24)==(0); //@line 146002 "c/sqlite3.c"
        if ($60) {
         label = 30;
        } else {
         $61 = (($$3252) + 2)|0; //@line 146003 "c/sqlite3.c"
         $62 = (($1) + ($61)|0); //@line 146003 "c/sqlite3.c"
         $63 = HEAP8[$62>>0]|0; //@line 146003 "c/sqlite3.c"
         $64 = $63&255; //@line 146003 "c/sqlite3.c"
         $65 = (16281 + ($64)|0); //@line 146003 "c/sqlite3.c"
         $66 = HEAP8[$65>>0]|0; //@line 146003 "c/sqlite3.c"
         $67 = $66 & 8; //@line 146003 "c/sqlite3.c"
         $68 = ($67<<24>>24)==(0); //@line 146003 "c/sqlite3.c"
         if ($68) {
          label = 30;
         } else {
          $69 = $55 << 24 >> 24; //@line 146005 "c/sqlite3.c"
          $70 = (_sqlite3HexToInt($69)|0); //@line 146005 "c/sqlite3.c"
          $71 = $70&255; //@line 146005 "c/sqlite3.c"
          $72 = $71 << 4; //@line 146005 "c/sqlite3.c"
          $73 = (($$3252) + 3)|0; //@line 146006 "c/sqlite3.c"
          $74 = $63 << 24 >> 24; //@line 146006 "c/sqlite3.c"
          $75 = (_sqlite3HexToInt($74)|0); //@line 146006 "c/sqlite3.c"
          $76 = $75&255; //@line 146006 "c/sqlite3.c"
          $77 = (($72) + ($76))|0; //@line 146006 "c/sqlite3.c"
          $78 = ($77|0)==(0); //@line 146009 "c/sqlite3.c"
          if (!($78)) {
           label = 29;
           break L23;
          }
          $$4253 = $73;
          while(1) {
           $79 = (($1) + ($$4253)|0); //@line 146015 "c/sqlite3.c"
           $80 = HEAP8[$79>>0]|0; //@line 146015 "c/sqlite3.c"
           switch ($80<<24>>24) {
           case 35: case 0:  {
            $$3252$be = $$4253;
            break L26;
            break;
           }
           default: {
           }
           }
           $81 = ($80<<24>>24)==(63); //@line 146016 "c/sqlite3.c"
           $or$cond = $47 & $81; //@line 146016 "c/sqlite3.c"
           if ($or$cond) {
            $$3252$be = $$4253;
            break L26;
           }
           if ($48) {
            switch ($80<<24>>24) {
            case 38: case 61:  {
             $$3252$be = $$4253;
             break L26;
             break;
            }
            default: {
            }
            }
           } else {
            $82 = ($80<<24>>24)!=(38); //@line 146018 "c/sqlite3.c"
            $83 = $49 | $82; //@line 146018 "c/sqlite3.c"
            if (!($83)) {
             $$3252$be = $$4253;
             break L26;
            }
           }
           $84 = (($$4253) + 1)|0; //@line 146020 "c/sqlite3.c"
           $$4253 = $84;
          }
         }
        }
       } else {
        label = 30;
       }
      } while(0);
      L39: do {
       if ((label|0) == 30) {
        label = 0;
        switch ($$0257$ph|0) {
        case 0:  {
         label = 39;
         break L23;
         break;
        }
        case 2:  {
         label = 40;
         break L23;
         break;
        }
        case 1:  {
         break;
        }
        default: {
         $$1266 = $51;$$2247 = $$0245$ph;$$2259 = $$0257$ph;$$7256 = $52;
         break L23;
        }
        }
        switch ($51<<24>>24) {
        case 38: case 61:  {
         break;
        }
        default: {
         $$1266 = $51;$$2247 = $$0245$ph;$$2259 = 1;$$7256 = $52;
         break L23;
        }
        }
        $86 = HEAP8[$46>>0]|0; //@line 146032 "c/sqlite3.c"
        $87 = ($86<<24>>24)==(0); //@line 146032 "c/sqlite3.c"
        if (!($87)) {
         label = 37;
         break L23;
        }
        $$6255 = $52;
        while(1) {
         $88 = (($1) + ($$6255)|0); //@line 146034 "c/sqlite3.c"
         $89 = HEAP8[$88>>0]|0; //@line 146034 "c/sqlite3.c"
         switch ($89<<24>>24) {
         case 35: case 0:  {
          $$3252$be = $$6255;
          break L39;
          break;
         }
         default: {
         }
         }
         $90 = (($$6255) + -1)|0; //@line 146034 "c/sqlite3.c"
         $91 = (($1) + ($90)|0); //@line 146034 "c/sqlite3.c"
         $92 = HEAP8[$91>>0]|0; //@line 146034 "c/sqlite3.c"
         $93 = ($92<<24>>24)==(38); //@line 146034 "c/sqlite3.c"
         if ($93) {
          $$3252$be = $$6255;
          break L39;
         }
         $94 = (($$6255) + 1)|0; //@line 146034 "c/sqlite3.c"
         $$6255 = $94;
        }
       }
      } while(0);
      $$3252 = $$3252$be;
     }
     if ((label|0) == 29) {
      label = 0;
      $85 = $77&255; //@line 146030 "c/sqlite3.c"
      $$1266 = $85;$$2247 = $$0245$ph;$$2259 = $$0257$ph;$$7256 = $73;
     }
     else if ((label|0) == 37) {
      label = 0;
      $95 = ($51<<24>>24)==(38); //@line 146031 "c/sqlite3.c"
      if ($95) {
       $96 = (($28) + ($$0245$ph)|0); //@line 146038 "c/sqlite3.c"
       $97 = (($$0245$ph) + 1)|0; //@line 146038 "c/sqlite3.c"
       HEAP8[$96>>0] = 0; //@line 146038 "c/sqlite3.c"
       $$1266 = 0;$$2247 = $97;$$2259 = 1;$$7256 = $52;
      } else {
       $$1266 = 0;$$2247 = $$0245$ph;$$2259 = 2;$$7256 = $52;
      }
     }
     else if ((label|0) == 39) {
      label = 0;
      $$old = ($51<<24>>24)==(63); //@line 146043 "c/sqlite3.c"
      if ($$old) {
       label = 41;
      } else {
       $$1266 = $51;$$2247 = $$0245$ph;$$2259 = 0;$$7256 = $52;
      }
     }
     else if ((label|0) == 40) {
      label = 0;
      $$old269 = ($51<<24>>24)==(38); //@line 146043 "c/sqlite3.c"
      if ($$old269) {
       label = 41;
      } else {
       $$1266 = $51;$$2247 = $$0245$ph;$$2259 = 2;$$7256 = $52;
      }
     }
     if ((label|0) == 41) {
      label = 0;
      $$1266 = 0;$$2247 = $$0245$ph;$$2259 = 1;$$7256 = $52;
     }
     $98 = (($$2247) + 1)|0; //@line 146047 "c/sqlite3.c"
     $99 = (($28) + ($$2247)|0); //@line 146047 "c/sqlite3.c"
     HEAP8[$99>>0] = $$1266; //@line 146047 "c/sqlite3.c"
     $$0245$ph = $98;$$0257$ph = $$2259;$$3252$ph = $$7256;
    }
    $100 = ($$0257$ph|0)==(1); //@line 146049 "c/sqlite3.c"
    if ($100) {
     $101 = (($28) + ($$0245$ph)|0); //@line 146049 "c/sqlite3.c"
     $102 = (($$0245$ph) + 1)|0; //@line 146049 "c/sqlite3.c"
     HEAP8[$101>>0] = 0; //@line 146049 "c/sqlite3.c"
     $$3248 = $102;
    } else {
     $$3248 = $$0245$ph;
    }
    $103 = (($$3248) + 1)|0; //@line 146050 "c/sqlite3.c"
    $104 = (($28) + ($$3248)|0); //@line 146050 "c/sqlite3.c"
    HEAP8[$104>>0] = 0; //@line 146050 "c/sqlite3.c"
    $105 = (($28) + ($103)|0); //@line 146051 "c/sqlite3.c"
    HEAP8[$105>>0] = 0; //@line 146051 "c/sqlite3.c"
    $106 = (_sqlite3Strlen30($28)|0); //@line 146057 "c/sqlite3.c"
    $107 = (($106) + 1)|0; //@line 146057 "c/sqlite3.c"
    $108 = (($28) + ($107)|0); //@line 146057 "c/sqlite3.c"
    $109 = HEAP8[$108>>0]|0; //@line 146058 "c/sqlite3.c"
    $110 = ($109<<24>>24)==(0); //@line 146058 "c/sqlite3.c"
    if ($110) {
     $$0262 = $28;$$4237 = $0;$$7231 = $18;
     label = 67;
    } else {
     $$0224340 = $18;$$0233339 = $0;$$0260338 = $108;
     L63: while(1) {
      $111 = (_sqlite3Strlen30($$0260338)|0); //@line 146059 "c/sqlite3.c"
      $112 = (($111) + 1)|0; //@line 146060 "c/sqlite3.c"
      $113 = (($$0260338) + ($112)|0); //@line 146060 "c/sqlite3.c"
      $114 = (_sqlite3Strlen30($113)|0); //@line 146061 "c/sqlite3.c"
      switch ($111|0) {
      case 3:  {
       $115 = (_memcmp(25302,$$0260338,3)|0); //@line 146063 "c/sqlite3.c"
       $116 = ($115|0)==(0); //@line 146063 "c/sqlite3.c"
       if ($116) {
        $$1234 = $113;$$4228 = $$0224340;
       } else {
        $$3227$ph = $$0224340;
        label = 61;
       }
       break;
      }
      case 5:  {
       $117 = (_memcmp(25306,$$0260338,5)|0); //@line 146074 "c/sqlite3.c"
       $118 = ($117|0)==(0); //@line 146074 "c/sqlite3.c"
       if ($118) {
        $$1214278 = 393216;$$1216277 = -393217;$$1218276 = 25306;$$1220275 = 6196;
        label = 51;
       } else {
        $$3227$ph = $$0224340;
        label = 61;
       }
       break;
      }
      case 4:  {
       $119 = (_memcmp(25312,$$0260338,4)|0); //@line 146086 "c/sqlite3.c"
       $120 = ($119|0)==(0); //@line 146086 "c/sqlite3.c"
       $121 = $$0224340 & 135; //@line 146098 "c/sqlite3.c"
       if ($120) {
        $$1214278 = $121;$$1216277 = -136;$$1218276 = 15488;$$1220275 = 6156;
        label = 51;
       } else {
        $$3227$ph = $$0224340;
        label = 61;
       }
       break;
      }
      default: {
       $$3227$ph = $$0224340;
       label = 61;
      }
      }
      if ((label|0) == 51) {
       label = 0;
       $122 = HEAP32[$$1220275>>2]|0; //@line 146105 "c/sqlite3.c"
       $123 = ($122|0)==(0|0); //@line 146105 "c/sqlite3.c"
       if ($123) {
        label = 57;
        break;
       }
       $$0212332 = 0;$124 = $122;
       while(1) {
        $125 = (_sqlite3Strlen30($124)|0); //@line 146107 "c/sqlite3.c"
        $126 = ($114|0)==($125|0); //@line 146107 "c/sqlite3.c"
        if ($126) {
         $127 = (_memcmp($113,$124,$114)|0); //@line 146107 "c/sqlite3.c"
         $128 = ($127|0)==(0); //@line 146107 "c/sqlite3.c"
         if ($128) {
          break;
         }
        }
        $129 = (($$0212332) + 1)|0; //@line 146105 "c/sqlite3.c"
        $130 = (($$1220275) + ($129<<3)|0); //@line 146105 "c/sqlite3.c"
        $131 = HEAP32[$130>>2]|0; //@line 146105 "c/sqlite3.c"
        $132 = ($131|0)==(0|0); //@line 146105 "c/sqlite3.c"
        if ($132) {
         label = 57;
         break L63;
        } else {
         $$0212332 = $129;$124 = $131;
        }
       }
       $133 = (((($$1220275) + ($$0212332<<3)|0)) + 4|0); //@line 146108 "c/sqlite3.c"
       $134 = HEAP32[$133>>2]|0; //@line 146108 "c/sqlite3.c"
       $135 = ($134|0)==(0); //@line 146112 "c/sqlite3.c"
       if ($135) {
        label = 57;
        break;
       }
       $137 = $134 & -129; //@line 146117 "c/sqlite3.c"
       $138 = ($137|0)>($$1214278|0); //@line 146117 "c/sqlite3.c"
       if ($138) {
        label = 59;
        break;
       }
       $140 = $$1216277 & $$0224340; //@line 146123 "c/sqlite3.c"
       $141 = $134 | $140; //@line 146123 "c/sqlite3.c"
       $$3227$ph = $141;
       label = 61;
      }
      if ((label|0) == 61) {
       label = 0;
       $$1234 = $$0233339;$$4228 = $$3227$ph;
      }
      $142 = (($114) + 1)|0; //@line 146127 "c/sqlite3.c"
      $143 = (($113) + ($142)|0); //@line 146127 "c/sqlite3.c"
      $144 = HEAP8[$143>>0]|0; //@line 146058 "c/sqlite3.c"
      $145 = ($144<<24>>24)==(0); //@line 146058 "c/sqlite3.c"
      if ($145) {
       $$0262 = $28;$$4237 = $$1234;$$7231 = $$4228;
       label = 67;
       break L1;
      } else {
       $$0224340 = $$4228;$$0233339 = $$1234;$$0260338 = $143;
      }
     }
     if ((label|0) == 57) {
      HEAP32[$vararg_buffer2>>2] = $$1218276; //@line 146113 "c/sqlite3.c"
      $vararg_ptr5 = ((($vararg_buffer2)) + 4|0); //@line 146113 "c/sqlite3.c"
      HEAP32[$vararg_ptr5>>2] = $113; //@line 146113 "c/sqlite3.c"
      $136 = (_sqlite3_mprintf(25317,$vararg_buffer2)|0); //@line 146113 "c/sqlite3.c"
      $$1263$ph = $28;$$8$ph = 1;$$8232$ph = $$0224340;$$sink = $136;
      label = 69;
      break;
     }
     else if ((label|0) == 59) {
      HEAP32[$vararg_buffer6>>2] = $$1218276; //@line 146118 "c/sqlite3.c"
      $vararg_ptr9 = ((($vararg_buffer6)) + 4|0); //@line 146118 "c/sqlite3.c"
      HEAP32[$vararg_ptr9>>2] = $113; //@line 146118 "c/sqlite3.c"
      $139 = (_sqlite3_mprintf(25337,$vararg_buffer6)|0); //@line 146118 "c/sqlite3.c"
      $$1263$ph = $28;$$8$ph = 3;$$8232$ph = $$0224340;$$sink = $139;
      label = 69;
      break;
     }
    }
   } else {
    label = 63;
   }
  } else {
   label = 63;
  }
 } while(0);
 if ((label|0) == 63) {
  $146 = (($7) + 2)|0; //@line 146131 "c/sqlite3.c"
  $147 = ($146|0)<(0); //@line 146131 "c/sqlite3.c"
  $148 = $147 << 31 >> 31; //@line 146131 "c/sqlite3.c"
  $149 = (_sqlite3_malloc64($146,$148)|0); //@line 146131 "c/sqlite3.c"
  $150 = ($149|0)==(0|0); //@line 146132 "c/sqlite3.c"
  if ($150) {
   $$1 = 7;
   STACKTOP = sp;return ($$1|0); //@line 146154 "c/sqlite3.c"
  }
  $151 = ($7|0)==(0); //@line 146133 "c/sqlite3.c"
  if (!($151)) {
   _memcpy(($149|0),($1|0),($7|0))|0; //@line 146134 "c/sqlite3.c"
  }
  $152 = (($149) + ($7)|0); //@line 146136 "c/sqlite3.c"
  HEAP8[$152>>0] = 0; //@line 146136 "c/sqlite3.c"
  $153 = (($7) + 1)|0; //@line 146137 "c/sqlite3.c"
  $154 = (($149) + ($153)|0); //@line 146137 "c/sqlite3.c"
  HEAP8[$154>>0] = 0; //@line 146137 "c/sqlite3.c"
  $155 = $6 & -65; //@line 146138 "c/sqlite3.c"
  $$0262 = $149;$$4237 = $0;$$7231 = $155;
  label = 67;
 }
 if ((label|0) == 67) {
  $156 = (_sqlite3_vfs_find($$4237)|0); //@line 146141 "c/sqlite3.c"
  HEAP32[$3>>2] = $156; //@line 146141 "c/sqlite3.c"
  $157 = ($156|0)==(0|0); //@line 146142 "c/sqlite3.c"
  if ($157) {
   HEAP32[$vararg_buffer10>>2] = $$4237; //@line 146143 "c/sqlite3.c"
   $158 = (_sqlite3_mprintf(25361,$vararg_buffer10)|0); //@line 146143 "c/sqlite3.c"
   $$1263$ph = $$0262;$$8$ph = 1;$$8232$ph = $$7231;$$sink = $158;
   label = 69;
  } else {
   $$2264 = $$0262;$$8232300 = $$7231;$$8302 = 0;
  }
 }
 if ((label|0) == 69) {
  HEAP32[$5>>2] = $$sink;
  _sqlite3_free($$1263$ph); //@line 146148 "c/sqlite3.c"
  $$2264 = 0;$$8232300 = $$8232$ph;$$8302 = $$8$ph;
 }
 HEAP32[$2>>2] = $$8232300; //@line 146151 "c/sqlite3.c"
 HEAP32[$4>>2] = $$2264; //@line 146152 "c/sqlite3.c"
 $$1 = $$8302;
 STACKTOP = sp;return ($$1|0); //@line 146154 "c/sqlite3.c"
}
function _sqlite3SchemaGet($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 106549 "c/sqlite3.c"
 if ($2) {
  $4 = (_sqlite3DbMallocZero(0,84,0)|0); //@line 106552 "c/sqlite3.c"
  $$0$in = $4;
 } else {
  $3 = (_sqlite3BtreeSchema($1,84,103)|0); //@line 106550 "c/sqlite3.c"
  $$0$in = $3;
 }
 $5 = ($$0$in|0)==(0|0); //@line 106554 "c/sqlite3.c"
 if ($5) {
  _sqlite3OomFault($0); //@line 106555 "c/sqlite3.c"
  return ($$0$in|0); //@line 106563 "c/sqlite3.c"
 }
 $6 = ((($$0$in)) + 76|0); //@line 106556 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 106556 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 106556 "c/sqlite3.c"
 if (!($8)) {
  return ($$0$in|0); //@line 106563 "c/sqlite3.c"
 }
 $9 = ((($$0$in)) + 8|0); //@line 106557 "c/sqlite3.c"
 _sqlite3HashInit($9); //@line 106557 "c/sqlite3.c"
 $10 = ((($$0$in)) + 24|0); //@line 106558 "c/sqlite3.c"
 _sqlite3HashInit($10); //@line 106558 "c/sqlite3.c"
 $11 = ((($$0$in)) + 40|0); //@line 106559 "c/sqlite3.c"
 _sqlite3HashInit($11); //@line 106559 "c/sqlite3.c"
 $12 = ((($$0$in)) + 56|0); //@line 106560 "c/sqlite3.c"
 _sqlite3HashInit($12); //@line 106560 "c/sqlite3.c"
 $13 = ((($$0$in)) + 77|0); //@line 106561 "c/sqlite3.c"
 HEAP8[$13>>0] = 1; //@line 106561 "c/sqlite3.c"
 return ($$0$in|0); //@line 106563 "c/sqlite3.c"
}
function _sqlite3PagerLockingMode($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(-1); //@line 55178 "c/sqlite3.c"
 if ($2) {
  $3 = ((($0)) + 12|0); //@line 55178 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 55178 "c/sqlite3.c"
  $5 = ($4<<24>>24)==(0); //@line 55178 "c/sqlite3.c"
  if ($5) {
   $6 = ((($0)) + 212|0); //@line 55178 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 55178 "c/sqlite3.c"
   $8 = (_sqlite3WalHeapMemory($7)|0); //@line 55178 "c/sqlite3.c"
   $9 = ($8|0)==(0); //@line 55178 "c/sqlite3.c"
   if ($9) {
    $10 = $1&255; //@line 55179 "c/sqlite3.c"
    $11 = ((($0)) + 4|0); //@line 55179 "c/sqlite3.c"
    HEAP8[$11>>0] = $10; //@line 55179 "c/sqlite3.c"
   }
  }
 }
 $12 = ((($0)) + 4|0); //@line 55181 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 55181 "c/sqlite3.c"
 $14 = $13&255; //@line 55181 "c/sqlite3.c"
 return ($14|0); //@line 55181 "c/sqlite3.c"
}
function _sqlite3BtreeSecureDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 63291 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  return ($$0|0); //@line 63302 "c/sqlite3.c"
 }
 _sqlite3BtreeEnter($0); //@line 63292 "c/sqlite3.c"
 $3 = ($1|0)>(-1); //@line 63295 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 4|0); //@line 63296 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 63296 "c/sqlite3.c"
  $6 = ((($5)) + 22|0); //@line 63296 "c/sqlite3.c"
  $7 = HEAP16[$6>>1]|0; //@line 63296 "c/sqlite3.c"
  $8 = $7 & -13; //@line 63296 "c/sqlite3.c"
  $9 = $1 << 2; //@line 63297 "c/sqlite3.c"
  $10 = $8&65535; //@line 63297 "c/sqlite3.c"
  $11 = $9 | $10; //@line 63297 "c/sqlite3.c"
  $12 = $11&65535; //@line 63297 "c/sqlite3.c"
  HEAP16[$6>>1] = $12; //@line 63297 "c/sqlite3.c"
 }
 $13 = ((($0)) + 4|0); //@line 63299 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 63299 "c/sqlite3.c"
 $15 = ((($14)) + 22|0); //@line 63299 "c/sqlite3.c"
 $16 = HEAP16[$15>>1]|0; //@line 63299 "c/sqlite3.c"
 $17 = ($16&65535) >>> 2; //@line 63299 "c/sqlite3.c"
 $18 = $17 & 3; //@line 63299 "c/sqlite3.c"
 $19 = $18&65535; //@line 63299 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63300 "c/sqlite3.c"
 $$0 = $19;
 return ($$0|0); //@line 63302 "c/sqlite3.c"
}
function _sqlite3BtreeSetPagerFlags($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 63153 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63153 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63155 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63156 "c/sqlite3.c"
 _sqlite3PagerSetFlags($4,$1); //@line 63156 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63157 "c/sqlite3.c"
 return;
}
function _sqlite3PagerSetFlags($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$not = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $brmerge = 0, $storemerge = 0, $storemerge$in = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1 & 7; //@line 51577 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 51578 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 51578 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 51578 "c/sqlite3.c"
 if ($5) {
  $8 = ($2|0)==(1); //@line 51583 "c/sqlite3.c"
  $9 = $8&1; //@line 51583 "c/sqlite3.c"
  $10 = ((($0)) + 7|0); //@line 51583 "c/sqlite3.c"
  HEAP8[$10>>0] = $9; //@line 51583 "c/sqlite3.c"
  $11 = ($2>>>0)>(2); //@line 51584 "c/sqlite3.c"
  $12 = $11&1; //@line 51584 "c/sqlite3.c"
  $13 = ((($0)) + 8|0); //@line 51584 "c/sqlite3.c"
  HEAP8[$13>>0] = $12; //@line 51584 "c/sqlite3.c"
  $14 = ($2|0)==(4); //@line 51585 "c/sqlite3.c"
  $15 = $14&1; //@line 51585 "c/sqlite3.c"
  $$sink = $15;
 } else {
  $6 = ((($0)) + 7|0); //@line 51579 "c/sqlite3.c"
  HEAP8[$6>>0] = 1; //@line 51579 "c/sqlite3.c"
  $7 = ((($0)) + 8|0); //@line 51580 "c/sqlite3.c"
  HEAP8[$7>>0] = 0; //@line 51580 "c/sqlite3.c"
  $$sink = 0;
 }
 $16 = ((($0)) + 9|0);
 HEAP8[$16>>0] = $$sink;
 $17 = ((($0)) + 7|0); //@line 51587 "c/sqlite3.c"
 $18 = HEAP8[$17>>0]|0; //@line 51587 "c/sqlite3.c"
 $19 = ($18<<24>>24)==(0); //@line 51587 "c/sqlite3.c"
 do {
  if ($19) {
   $21 = $1 & 8; //@line 51589 "c/sqlite3.c"
   $22 = ($21|0)==(0); //@line 51589 "c/sqlite3.c"
   $23 = ((($0)) + 10|0);
   if ($22) {
    HEAP8[$23>>0] = 2; //@line 51592 "c/sqlite3.c"
    break;
   } else {
    HEAP8[$23>>0] = 3; //@line 51590 "c/sqlite3.c"
    break;
   }
  } else {
   $20 = ((($0)) + 10|0); //@line 51588 "c/sqlite3.c"
   HEAP8[$20>>0] = 0; //@line 51588 "c/sqlite3.c"
  }
 } while(0);
 $24 = ((($0)) + 10|0); //@line 51594 "c/sqlite3.c"
 $25 = HEAP8[$24>>0]|0; //@line 51594 "c/sqlite3.c"
 $26 = $25&255; //@line 51594 "c/sqlite3.c"
 $27 = $26 << 2; //@line 51594 "c/sqlite3.c"
 $28 = $27&255; //@line 51594 "c/sqlite3.c"
 $29 = ((($0)) + 11|0); //@line 51594 "c/sqlite3.c"
 HEAP8[$29>>0] = $28; //@line 51594 "c/sqlite3.c"
 $30 = ((($0)) + 8|0); //@line 51595 "c/sqlite3.c"
 $31 = HEAP8[$30>>0]|0; //@line 51595 "c/sqlite3.c"
 $32 = ($31<<24>>24)==(0); //@line 51595 "c/sqlite3.c"
 if (!($32)) {
  $33 = $27 | $26; //@line 51596 "c/sqlite3.c"
  $34 = $33&255; //@line 51596 "c/sqlite3.c"
  HEAP8[$29>>0] = $34; //@line 51596 "c/sqlite3.c"
 }
 $35 = $1 & 16; //@line 51598 "c/sqlite3.c"
 $36 = ($35|0)==(0); //@line 51598 "c/sqlite3.c"
 $$not = $19 ^ 1; //@line 51598 "c/sqlite3.c"
 $brmerge = $36 | $$not; //@line 51598 "c/sqlite3.c"
 if ($brmerge) {
  $39 = $1 & 32; //@line 51601 "c/sqlite3.c"
  $40 = ($39|0)==(0); //@line 51601 "c/sqlite3.c"
  $41 = ((($0)) + 20|0);
  $42 = HEAP8[$41>>0]|0;
  $43 = $42&255;
  $44 = $43 | 1; //@line 51604 "c/sqlite3.c"
  $45 = $43 & 254; //@line 51602 "c/sqlite3.c"
  $storemerge$in = $40 ? $44 : $45; //@line 51601 "c/sqlite3.c"
  $storemerge = $storemerge$in&255;
  HEAP8[$41>>0] = $storemerge;
  return; //@line 51606 "c/sqlite3.c"
 }
 $37 = HEAP8[$29>>0]|0; //@line 51599 "c/sqlite3.c"
 $38 = $37 | 12; //@line 51599 "c/sqlite3.c"
 HEAP8[$29>>0] = $38; //@line 51599 "c/sqlite3.c"
 $39 = $1 & 32; //@line 51601 "c/sqlite3.c"
 $40 = ($39|0)==(0); //@line 51601 "c/sqlite3.c"
 $41 = ((($0)) + 20|0);
 $42 = HEAP8[$41>>0]|0;
 $43 = $42&255;
 $44 = $43 | 1; //@line 51604 "c/sqlite3.c"
 $45 = $43 & 254; //@line 51602 "c/sqlite3.c"
 $storemerge$in = $40 ? $44 : $45; //@line 51601 "c/sqlite3.c"
 $storemerge = $storemerge$in&255;
 HEAP8[$41>>0] = $storemerge;
 return; //@line 51606 "c/sqlite3.c"
}
function _sqlite3WalHeapMemory($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 59309 "c/sqlite3.c"
 if ($1) {
  $5 = 0;
  return ($5|0); //@line 59309 "c/sqlite3.c"
 }
 $2 = ((($0)) + 43|0); //@line 59309 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 59309 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(2); //@line 59309 "c/sqlite3.c"
 $phitmp = $4&1;
 $5 = $phitmp;
 return ($5|0); //@line 59309 "c/sqlite3.c"
}
function _sqlite3CodeVerifyNamedSchema($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 105692 "c/sqlite3.c"
 $3 = ((($2)) + 20|0); //@line 105694 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 105694 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 105694 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 105700 "c/sqlite3.c"
 }
 $6 = ((($2)) + 16|0);
 $7 = ($1|0)==(0|0);
 $$016 = 0;
 while(1) {
  $8 = HEAP32[$6>>2]|0; //@line 105695 "c/sqlite3.c"
  $9 = (((($8) + ($$016<<4)|0)) + 4|0); //@line 105696 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 105696 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 105696 "c/sqlite3.c"
  do {
   if (!($11)) {
    if (!($7)) {
     $12 = (($8) + ($$016<<4)|0); //@line 105696 "c/sqlite3.c"
     $13 = HEAP32[$12>>2]|0; //@line 105696 "c/sqlite3.c"
     $14 = (_sqlite3StrICmp($1,$13)|0); //@line 105696 "c/sqlite3.c"
     $15 = ($14|0)==(0); //@line 105696 "c/sqlite3.c"
     if (!($15)) {
      break;
     }
    }
    _sqlite3CodeVerifySchema($0,$$016); //@line 105697 "c/sqlite3.c"
   }
  } while(0);
  $16 = (($$016) + 1)|0; //@line 105694 "c/sqlite3.c"
  $17 = HEAP32[$3>>2]|0; //@line 105694 "c/sqlite3.c"
  $18 = ($16|0)<($17|0); //@line 105694 "c/sqlite3.c"
  if ($18) {
   $$016 = $16;
  } else {
   break;
  }
 }
 return; //@line 105700 "c/sqlite3.c"
}
function _sqlite3DropTriggerPtr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 125498 "c/sqlite3.c"
 $2 = HEAP32[$0>>2]|0; //@line 125501 "c/sqlite3.c"
 $3 = ((($1)) + 20|0); //@line 125504 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 125504 "c/sqlite3.c"
 $5 = (_sqlite3SchemaToIndex($2,$4)|0); //@line 125504 "c/sqlite3.c"
 $6 = (_tableOfTrigger($1)|0); //@line 125506 "c/sqlite3.c"
 $7 = ((($2)) + 16|0); //@line 125512 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 125512 "c/sqlite3.c"
 $9 = (($8) + ($5<<4)|0); //@line 125512 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 125512 "c/sqlite3.c"
 $11 = ($5|0)==(1); //@line 125513 "c/sqlite3.c"
 $spec$select = $11 ? 14 : 16; //@line 125514 "c/sqlite3.c"
 $12 = HEAP32[$1>>2]|0; //@line 125515 "c/sqlite3.c"
 $13 = HEAP32[$6>>2]|0; //@line 125515 "c/sqlite3.c"
 $14 = (_sqlite3AuthCheck($0,$spec$select,$12,$13,$10)|0); //@line 125515 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 125515 "c/sqlite3.c"
 if (!($15)) {
  STACKTOP = sp;return; //@line 125533 "c/sqlite3.c"
 }
 $16 = $11 ? 21366 : 19754; //@line 125513 "c/sqlite3.c"
 $17 = (_sqlite3AuthCheck($0,9,$16,0,$10)|0); //@line 125516 "c/sqlite3.c"
 $18 = ($17|0)==(0); //@line 125516 "c/sqlite3.c"
 if (!($18)) {
  STACKTOP = sp;return; //@line 125533 "c/sqlite3.c"
 }
 $19 = (_sqlite3GetVdbe($0)|0); //@line 125525 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 125525 "c/sqlite3.c"
 if ($20) {
  STACKTOP = sp;return; //@line 125533 "c/sqlite3.c"
 }
 $21 = HEAP32[$7>>2]|0; //@line 125528 "c/sqlite3.c"
 $22 = (($21) + ($5<<4)|0); //@line 125528 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 125528 "c/sqlite3.c"
 $24 = HEAP32[$1>>2]|0; //@line 125528 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $23; //@line 125526 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 125526 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = 19754; //@line 125526 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 125526 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $24; //@line 125526 "c/sqlite3.c"
 _sqlite3NestedParse($0,25429,$vararg_buffer); //@line 125526 "c/sqlite3.c"
 _sqlite3ChangeCookie($0,$5); //@line 125530 "c/sqlite3.c"
 $25 = HEAP32[$1>>2]|0; //@line 125531 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($19,142,$5,0,0,$25,0)|0); //@line 125531 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 125533 "c/sqlite3.c"
}
function _tableOfTrigger($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 125491 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 125491 "c/sqlite3.c"
 $3 = ((($2)) + 8|0); //@line 125491 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 125491 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 125491 "c/sqlite3.c"
 $6 = (_sqlite3HashFind($3,$5)|0); //@line 125491 "c/sqlite3.c"
 return ($6|0); //@line 125491 "c/sqlite3.c"
}
function _triggerSpanDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$014 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3DbSpanDup($0,$1,$2)|0); //@line 125286 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 125288 "c/sqlite3.c"
 if ($4) {
  return ($3|0); //@line 125289 "c/sqlite3.c"
 }
 $5 = HEAP8[$3>>0]|0; //@line 125288 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 125288 "c/sqlite3.c"
 if ($6) {
  return ($3|0); //@line 125289 "c/sqlite3.c"
 }
 $$014 = 0;$13 = $3;$8 = $5;
 while(1) {
  $7 = $8&255; //@line 125288 "c/sqlite3.c"
  $9 = (16281 + ($7)|0); //@line 125288 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 125288 "c/sqlite3.c"
  $11 = $10 & 1; //@line 125288 "c/sqlite3.c"
  $12 = ($11<<24>>24)==(0); //@line 125288 "c/sqlite3.c"
  if (!($12)) {
   HEAP8[$13>>0] = 32; //@line 125288 "c/sqlite3.c"
  }
  $14 = (($$014) + 1)|0; //@line 125288 "c/sqlite3.c"
  $15 = (($3) + ($14)|0); //@line 125288 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 125288 "c/sqlite3.c"
  $17 = ($16<<24>>24)==(0); //@line 125288 "c/sqlite3.c"
  if ($17) {
   break;
  } else {
   $$014 = $14;$13 = $15;$8 = $16;
  }
 }
 return ($3|0); //@line 125289 "c/sqlite3.c"
}
function _sqlite3DbSpanDup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$011 = 0, $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$011 = $1;
 while(1) {
  $3 = HEAP8[$$011>>0]|0; //@line 25777 "c/sqlite3.c"
  $4 = $3&255; //@line 25777 "c/sqlite3.c"
  $5 = (16281 + ($4)|0); //@line 25777 "c/sqlite3.c"
  $6 = HEAP8[$5>>0]|0; //@line 25777 "c/sqlite3.c"
  $7 = $6 & 1; //@line 25777 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(0); //@line 25777 "c/sqlite3.c"
  $9 = ((($$011)) + 1|0); //@line 25777 "c/sqlite3.c"
  if ($8) {
   break;
  } else {
   $$011 = $9;
  }
 }
 $10 = $2; //@line 25778 "c/sqlite3.c"
 $11 = $$011; //@line 25778 "c/sqlite3.c"
 $12 = (($10) - ($11))|0; //@line 25778 "c/sqlite3.c"
 $13 = ($12|0)>(0); //@line 25779 "c/sqlite3.c"
 L4: do {
  if ($13) {
   $$012 = $12;
   while(1) {
    $15 = (($$012) + -1)|0; //@line 25779 "c/sqlite3.c"
    $16 = (($$011) + ($15)|0); //@line 25779 "c/sqlite3.c"
    $17 = HEAP8[$16>>0]|0; //@line 25779 "c/sqlite3.c"
    $18 = $17&255; //@line 25779 "c/sqlite3.c"
    $19 = (16281 + ($18)|0); //@line 25779 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 25779 "c/sqlite3.c"
    $21 = $20 & 1; //@line 25779 "c/sqlite3.c"
    $22 = ($21<<24>>24)==(0); //@line 25779 "c/sqlite3.c"
    if ($22) {
     $$0$lcssa = $$012;
     break L4;
    }
    $14 = ($$012|0)>(1); //@line 25779 "c/sqlite3.c"
    if ($14) {
     $$012 = $15;
    } else {
     $$0$lcssa = $15;
     break;
    }
   }
  } else {
   $$0$lcssa = $12;
  }
 } while(0);
 $23 = ($$0$lcssa|0)<(0); //@line 25780 "c/sqlite3.c"
 $24 = $23 << 31 >> 31; //@line 25780 "c/sqlite3.c"
 $25 = (_sqlite3DbStrNDup($0,$$011,$$0$lcssa,$24)|0); //@line 25780 "c/sqlite3.c"
 return ($25|0); //@line 25780 "c/sqlite3.c"
}
function _triggerStepAllocate($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($2)) + 4|0); //@line 125332 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 125332 "c/sqlite3.c"
 $7 = (($6) + 41)|0; //@line 125332 "c/sqlite3.c"
 $8 = (_sqlite3DbMallocZero($0,$7,0)|0); //@line 125332 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 125333 "c/sqlite3.c"
 if ($9) {
  return ($8|0); //@line 125341 "c/sqlite3.c"
 }
 $10 = ((($8)) + 40|0); //@line 125334 "c/sqlite3.c"
 $11 = HEAP32[$2>>2]|0; //@line 125335 "c/sqlite3.c"
 $12 = HEAP32[$5>>2]|0; //@line 125335 "c/sqlite3.c"
 _memcpy(($10|0),($11|0),($12|0))|0; //@line 125335 "c/sqlite3.c"
 _sqlite3Dequote($10); //@line 125336 "c/sqlite3.c"
 $13 = ((($8)) + 12|0); //@line 125337 "c/sqlite3.c"
 HEAP32[$13>>2] = $10; //@line 125337 "c/sqlite3.c"
 HEAP8[$8>>0] = $1; //@line 125338 "c/sqlite3.c"
 $14 = (_triggerSpanDup($0,$3,$4)|0); //@line 125339 "c/sqlite3.c"
 $15 = ((($8)) + 28|0); //@line 125339 "c/sqlite3.c"
 HEAP32[$15>>2] = $14; //@line 125339 "c/sqlite3.c"
 return ($8|0); //@line 125341 "c/sqlite3.c"
}
function _sqlite3SrcListLookup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 8|0); //@line 106599 "c/sqlite3.c"
 $3 = (_sqlite3LocateTableItem($0,0,$2)|0); //@line 106602 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 106603 "c/sqlite3.c"
 $5 = ((($1)) + 24|0); //@line 106603 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 106603 "c/sqlite3.c"
 _sqlite3DeleteTable($4,$6); //@line 106603 "c/sqlite3.c"
 HEAP32[$5>>2] = $3; //@line 106604 "c/sqlite3.c"
 $7 = ($3|0)==(0|0); //@line 106605 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($3)) + 32|0); //@line 106606 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 106606 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 106606 "c/sqlite3.c"
  HEAP32[$8>>2] = $10; //@line 106606 "c/sqlite3.c"
 }
 $11 = (_sqlite3IndexedByLookup($0,$2)|0); //@line 106608 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 106608 "c/sqlite3.c"
 $spec$select = $12 ? $3 : 0; //@line 106608 "c/sqlite3.c"
 return ($spec$select|0); //@line 106611 "c/sqlite3.c"
}
function _sqlite3FixInit($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$1>>2]|0; //@line 101196 "c/sqlite3.c"
 HEAP32[$0>>2] = $1; //@line 101198 "c/sqlite3.c"
 $6 = ((($5)) + 16|0); //@line 101199 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 101199 "c/sqlite3.c"
 $8 = (($7) + ($2<<4)|0); //@line 101199 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 101199 "c/sqlite3.c"
 $10 = ((($0)) + 12|0); //@line 101199 "c/sqlite3.c"
 HEAP32[$10>>2] = $9; //@line 101199 "c/sqlite3.c"
 $11 = (((($7) + ($2<<4)|0)) + 12|0); //@line 101200 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 101200 "c/sqlite3.c"
 $13 = ((($0)) + 4|0); //@line 101200 "c/sqlite3.c"
 HEAP32[$13>>2] = $12; //@line 101200 "c/sqlite3.c"
 $14 = ((($0)) + 16|0); //@line 101201 "c/sqlite3.c"
 HEAP32[$14>>2] = $3; //@line 101201 "c/sqlite3.c"
 $15 = ((($0)) + 20|0); //@line 101202 "c/sqlite3.c"
 HEAP32[$15>>2] = $4; //@line 101202 "c/sqlite3.c"
 $16 = ($2|0)==(1); //@line 101203 "c/sqlite3.c"
 $17 = $16&1; //@line 101203 "c/sqlite3.c"
 $18 = ((($0)) + 8|0); //@line 101203 "c/sqlite3.c"
 HEAP32[$18>>2] = $17; //@line 101203 "c/sqlite3.c"
 return; //@line 101204 "c/sqlite3.c"
}
function _sqlite3FixSrcList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$029 = 0, $$03031 = 0, $$032 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0;
 var $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 101221 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 101228 "c/sqlite3.c"
 if ($2) {
  $$029 = 0;
  STACKTOP = sp;return ($$029|0); //@line 101248 "c/sqlite3.c"
 }
 $3 = ((($0)) + 12|0); //@line 101229 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 101229 "c/sqlite3.c"
 $5 = HEAP32[$1>>2]|0; //@line 101230 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 101230 "c/sqlite3.c"
 if (!($6)) {
  $$029 = 0;
  STACKTOP = sp;return ($$029|0); //@line 101248 "c/sqlite3.c"
 }
 $7 = ((($1)) + 8|0); //@line 101230 "c/sqlite3.c"
 $8 = ((($0)) + 8|0);
 $9 = ((($0)) + 4|0);
 $$03031 = 0;$$032 = $7;
 while(1) {
  $10 = HEAP32[$8>>2]|0; //@line 101231 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 101231 "c/sqlite3.c"
  if ($11) {
   $12 = ((($$032)) + 4|0); //@line 101232 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 101232 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 101232 "c/sqlite3.c"
   if (!($14)) {
    $15 = (_sqlite3StrICmp($13,$4)|0); //@line 101232 "c/sqlite3.c"
    $16 = ($15|0)==(0); //@line 101232 "c/sqlite3.c"
    if (!($16)) {
     label = 7;
     break;
    }
   }
   $22 = HEAP32[$0>>2]|0; //@line 101238 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 101238 "c/sqlite3.c"
   _sqlite3DbFree($23,$13); //@line 101238 "c/sqlite3.c"
   HEAP32[$12>>2] = 0; //@line 101239 "c/sqlite3.c"
   $24 = HEAP32[$9>>2]|0; //@line 101240 "c/sqlite3.c"
   HEAP32[$$032>>2] = $24; //@line 101240 "c/sqlite3.c"
  }
  $25 = ((($$032)) + 20|0); //@line 101243 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 101243 "c/sqlite3.c"
  $27 = (_sqlite3FixSelect($0,$26)|0); //@line 101243 "c/sqlite3.c"
  $28 = ($27|0)==(0); //@line 101243 "c/sqlite3.c"
  if (!($28)) {
   $$029 = 1;
   label = 12;
   break;
  }
  $29 = ((($$032)) + 48|0); //@line 101244 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 101244 "c/sqlite3.c"
  $31 = (_sqlite3FixExpr($0,$30)|0); //@line 101244 "c/sqlite3.c"
  $32 = ($31|0)==(0); //@line 101244 "c/sqlite3.c"
  if (!($32)) {
   $$029 = 1;
   label = 12;
   break;
  }
  $33 = (($$03031) + 1)|0; //@line 101230 "c/sqlite3.c"
  $34 = ((($$032)) + 72|0); //@line 101230 "c/sqlite3.c"
  $35 = HEAP32[$1>>2]|0; //@line 101230 "c/sqlite3.c"
  $36 = ($33|0)<($35|0); //@line 101230 "c/sqlite3.c"
  if ($36) {
   $$03031 = $33;$$032 = $34;
  } else {
   $$029 = 0;
   label = 12;
   break;
  }
 }
 if ((label|0) == 7) {
  $17 = HEAP32[$0>>2]|0; //@line 101233 "c/sqlite3.c"
  $18 = ((($0)) + 16|0); //@line 101235 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 101235 "c/sqlite3.c"
  $20 = ((($0)) + 20|0); //@line 101235 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 101235 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $19; //@line 101233 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 101233 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $21; //@line 101233 "c/sqlite3.c"
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 101233 "c/sqlite3.c"
  HEAP32[$vararg_ptr2>>2] = $13; //@line 101233 "c/sqlite3.c"
  _sqlite3ErrorMsg($17,25735,$vararg_buffer); //@line 101233 "c/sqlite3.c"
  $$029 = 1;
  STACKTOP = sp;return ($$029|0); //@line 101248 "c/sqlite3.c"
 }
 else if ((label|0) == 12) {
  STACKTOP = sp;return ($$029|0); //@line 101248 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3FixSelect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $$017 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 101254 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$016 = 0;
  } else {
   $$017 = $1;
   while(1) {
    $3 = HEAP32[$$017>>2]|0; //@line 101255 "c/sqlite3.c"
    $4 = (_sqlite3FixExprList($0,$3)|0); //@line 101255 "c/sqlite3.c"
    $5 = ($4|0)==(0); //@line 101255 "c/sqlite3.c"
    if (!($5)) {
     $$016 = 1;
     break L1;
    }
    $6 = ((($$017)) + 28|0); //@line 101258 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 101258 "c/sqlite3.c"
    $8 = (_sqlite3FixSrcList($0,$7)|0); //@line 101258 "c/sqlite3.c"
    $9 = ($8|0)==(0); //@line 101258 "c/sqlite3.c"
    if (!($9)) {
     $$016 = 1;
     break L1;
    }
    $10 = ((($$017)) + 32|0); //@line 101261 "c/sqlite3.c"
    $11 = HEAP32[$10>>2]|0; //@line 101261 "c/sqlite3.c"
    $12 = (_sqlite3FixExpr($0,$11)|0); //@line 101261 "c/sqlite3.c"
    $13 = ($12|0)==(0); //@line 101261 "c/sqlite3.c"
    if (!($13)) {
     $$016 = 1;
     break L1;
    }
    $14 = ((($$017)) + 36|0); //@line 101264 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 101264 "c/sqlite3.c"
    $16 = (_sqlite3FixExprList($0,$15)|0); //@line 101264 "c/sqlite3.c"
    $17 = ($16|0)==(0); //@line 101264 "c/sqlite3.c"
    if (!($17)) {
     $$016 = 1;
     break L1;
    }
    $18 = ((($$017)) + 40|0); //@line 101267 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 101267 "c/sqlite3.c"
    $20 = (_sqlite3FixExpr($0,$19)|0); //@line 101267 "c/sqlite3.c"
    $21 = ($20|0)==(0); //@line 101267 "c/sqlite3.c"
    if (!($21)) {
     $$016 = 1;
     break L1;
    }
    $22 = ((($$017)) + 44|0); //@line 101270 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 101270 "c/sqlite3.c"
    $24 = (_sqlite3FixExprList($0,$23)|0); //@line 101270 "c/sqlite3.c"
    $25 = ($24|0)==(0); //@line 101270 "c/sqlite3.c"
    if (!($25)) {
     $$016 = 1;
     break L1;
    }
    $26 = ((($$017)) + 56|0); //@line 101273 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 101273 "c/sqlite3.c"
    $28 = (_sqlite3FixExpr($0,$27)|0); //@line 101273 "c/sqlite3.c"
    $29 = ($28|0)==(0); //@line 101273 "c/sqlite3.c"
    if (!($29)) {
     $$016 = 1;
     break L1;
    }
    $30 = ((($$017)) + 48|0); //@line 101276 "c/sqlite3.c"
    $31 = HEAP32[$30>>2]|0; //@line 101276 "c/sqlite3.c"
    $32 = ($31|0)==(0|0); //@line 101254 "c/sqlite3.c"
    if ($32) {
     $$016 = 0;
     break;
    } else {
     $$017 = $31;
    }
   }
  }
 } while(0);
 return ($$016|0); //@line 101279 "c/sqlite3.c"
}
function _sqlite3FixExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$013 = 0, $$014 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 101281 "c/sqlite3.c"
 $2 = ($1|0)==(0|0); //@line 101284 "c/sqlite3.c"
 if ($2) {
  $$013 = 0;
  STACKTOP = sp;return ($$013|0); //@line 101305 "c/sqlite3.c"
 }
 $$014 = $1;
 while(1) {
  $3 = HEAP8[$$014>>0]|0; //@line 101285 "c/sqlite3.c"
  $4 = ($3<<24>>24)==(-121); //@line 101285 "c/sqlite3.c"
  if ($4) {
   $5 = HEAP32[$0>>2]|0; //@line 101286 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 101286 "c/sqlite3.c"
   $7 = ((($6)) + 157|0); //@line 101286 "c/sqlite3.c"
   $8 = HEAP8[$7>>0]|0; //@line 101286 "c/sqlite3.c"
   $9 = ($8<<24>>24)==(0); //@line 101286 "c/sqlite3.c"
   if ($9) {
    label = 6;
    break;
   }
   HEAP8[$$014>>0] = 101; //@line 101287 "c/sqlite3.c"
  }
  $12 = ((($$014)) + 4|0); //@line 101293 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 101293 "c/sqlite3.c"
  $14 = $13 & 8404992; //@line 101293 "c/sqlite3.c"
  $15 = ($14|0)==(0); //@line 101293 "c/sqlite3.c"
  if (!($15)) {
   $$013 = 0;
   label = 13;
   break;
  }
  $16 = $13 & 2048; //@line 101294 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 101294 "c/sqlite3.c"
  $18 = ((($$014)) + 20|0);
  if ($17) {
   $22 = HEAP32[$18>>2]|0; //@line 101297 "c/sqlite3.c"
   $23 = (_sqlite3FixExprList($0,$22)|0); //@line 101297 "c/sqlite3.c"
   $24 = ($23|0)==(0); //@line 101297 "c/sqlite3.c"
   if (!($24)) {
    $$013 = 1;
    label = 13;
    break;
   }
  } else {
   $19 = HEAP32[$18>>2]|0; //@line 101295 "c/sqlite3.c"
   $20 = (_sqlite3FixSelect($0,$19)|0); //@line 101295 "c/sqlite3.c"
   $21 = ($20|0)==(0); //@line 101295 "c/sqlite3.c"
   if (!($21)) {
    $$013 = 1;
    label = 13;
    break;
   }
  }
  $25 = ((($$014)) + 16|0); //@line 101299 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 101299 "c/sqlite3.c"
  $27 = (_sqlite3FixExpr($0,$26)|0); //@line 101299 "c/sqlite3.c"
  $28 = ($27|0)==(0); //@line 101299 "c/sqlite3.c"
  if (!($28)) {
   $$013 = 1;
   label = 13;
   break;
  }
  $29 = ((($$014)) + 12|0); //@line 101302 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 101302 "c/sqlite3.c"
  $31 = ($30|0)==(0|0); //@line 101284 "c/sqlite3.c"
  if ($31) {
   $$013 = 0;
   label = 13;
   break;
  } else {
   $$014 = $30;
  }
 }
 if ((label|0) == 6) {
  $10 = ((($0)) + 16|0); //@line 101289 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 101289 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $11; //@line 101289 "c/sqlite3.c"
  _sqlite3ErrorMsg($5,25781,$vararg_buffer); //@line 101289 "c/sqlite3.c"
  $$013 = 1;
  STACKTOP = sp;return ($$013|0); //@line 101305 "c/sqlite3.c"
 }
 else if ((label|0) == 13) {
  STACKTOP = sp;return ($$013|0); //@line 101305 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3FixExprList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01113 = 0, $$012 = 0, $$014 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 101312 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$012 = 0;
  } else {
   $3 = HEAP32[$1>>2]|0; //@line 101313 "c/sqlite3.c"
   $4 = ($3|0)>(0); //@line 101313 "c/sqlite3.c"
   if ($4) {
    $5 = ((($1)) + 4|0); //@line 101313 "c/sqlite3.c"
    $$01113 = 0;$$014 = $5;
    while(1) {
     $6 = HEAP32[$$014>>2]|0; //@line 101314 "c/sqlite3.c"
     $7 = (_sqlite3FixExpr($0,$6)|0); //@line 101314 "c/sqlite3.c"
     $8 = ($7|0)==(0); //@line 101314 "c/sqlite3.c"
     if (!($8)) {
      $$012 = 1;
      break L1;
     }
     $9 = (($$01113) + 1)|0; //@line 101313 "c/sqlite3.c"
     $10 = ((($$014)) + 20|0); //@line 101313 "c/sqlite3.c"
     $11 = HEAP32[$1>>2]|0; //@line 101313 "c/sqlite3.c"
     $12 = ($9|0)<($11|0); //@line 101313 "c/sqlite3.c"
     if ($12) {
      $$01113 = $9;$$014 = $10;
     } else {
      $$012 = 0;
      break;
     }
    }
   } else {
    $$012 = 0;
   }
  }
 } while(0);
 return ($$012|0); //@line 101319 "c/sqlite3.c"
}
function _sqlite3FixTriggerStep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$08 = 0, $$09 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 101327 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$08 = 0;
  } else {
   $$09 = $1;
   while(1) {
    $3 = ((($$09)) + 8|0); //@line 101328 "c/sqlite3.c"
    $4 = HEAP32[$3>>2]|0; //@line 101328 "c/sqlite3.c"
    $5 = (_sqlite3FixSelect($0,$4)|0); //@line 101328 "c/sqlite3.c"
    $6 = ($5|0)==(0); //@line 101328 "c/sqlite3.c"
    if (!($6)) {
     $$08 = 1;
     break L1;
    }
    $7 = ((($$09)) + 16|0); //@line 101331 "c/sqlite3.c"
    $8 = HEAP32[$7>>2]|0; //@line 101331 "c/sqlite3.c"
    $9 = (_sqlite3FixExpr($0,$8)|0); //@line 101331 "c/sqlite3.c"
    $10 = ($9|0)==(0); //@line 101331 "c/sqlite3.c"
    if (!($10)) {
     $$08 = 1;
     break L1;
    }
    $11 = ((($$09)) + 20|0); //@line 101334 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 101334 "c/sqlite3.c"
    $13 = (_sqlite3FixExprList($0,$12)|0); //@line 101334 "c/sqlite3.c"
    $14 = ($13|0)==(0); //@line 101334 "c/sqlite3.c"
    if (!($14)) {
     $$08 = 1;
     break L1;
    }
    $15 = ((($$09)) + 32|0); //@line 101337 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 101337 "c/sqlite3.c"
    $17 = ($16|0)==(0|0); //@line 101327 "c/sqlite3.c"
    if ($17) {
     $$08 = 0;
     break;
    } else {
     $$09 = $16;
    }
   }
  }
 } while(0);
 return ($$08|0); //@line 101340 "c/sqlite3.c"
}
function _sqlite3VdbeRunOnlyOnce($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 145|0); //@line 73363 "c/sqlite3.c"
 $2 = HEAPU8[$1>>0]|(HEAPU8[$1+1>>0]<<8); //@line 73363 "c/sqlite3.c"
 $3 = $2 | 32; //@line 73363 "c/sqlite3.c"
 HEAP8[$1>>0]=$3&255;HEAP8[$1+1>>0]=$3>>8; //@line 73363 "c/sqlite3.c"
 return; //@line 73364 "c/sqlite3.c"
}
function _returnSingleText($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 115492 "c/sqlite3.c"
 if ($2) {
  return; //@line 115496 "c/sqlite3.c"
 }
 (_sqlite3VdbeLoadString($0,1,$1)|0); //@line 115493 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($0,78,1,1)|0); //@line 115494 "c/sqlite3.c"
 return; //@line 115496 "c/sqlite3.c"
}
function _setPragmaResultColumnNames($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01718 = 0, $$019 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 7|0); //@line 115465 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 115465 "c/sqlite3.c"
 $4 = $3&255; //@line 115466 "c/sqlite3.c"
 $5 = ($3<<24>>24)==(0); //@line 115466 "c/sqlite3.c"
 $6 = $5 ? 1 : $4; //@line 115466 "c/sqlite3.c"
 _sqlite3VdbeSetNumCols($0,$6); //@line 115466 "c/sqlite3.c"
 if ($5) {
  $7 = HEAP32[$1>>2]|0; //@line 115468 "c/sqlite3.c"
  _sqlite3VdbeSetColName($0,0,0,$7,0); //@line 115468 "c/sqlite3.c"
  return; //@line 115475 "c/sqlite3.c"
 }
 $8 = ((($1)) + 6|0); //@line 115471 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 115471 "c/sqlite3.c"
 $10 = $9&255; //@line 115471 "c/sqlite3.c"
 $$01718 = 0;$$019 = $10;
 while(1) {
  $11 = (5088 + ($$019<<2)|0); //@line 115472 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 115472 "c/sqlite3.c"
  _sqlite3VdbeSetColName($0,$$01718,0,$12,0); //@line 115472 "c/sqlite3.c"
  $13 = (($$01718) + 1)|0; //@line 115471 "c/sqlite3.c"
  $14 = (($$019) + 1)|0; //@line 115471 "c/sqlite3.c"
  $exitcond = ($13|0)==($4|0); //@line 115471 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$01718 = $13;$$019 = $14;
  }
 }
 return; //@line 115475 "c/sqlite3.c"
}
function _sqlite3VdbeAddOpList($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0363 = 0, $$0372 = 0, $$0381 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 136|0); //@line 73704 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 73704 "c/sqlite3.c"
 $5 = (($4) + ($1))|0; //@line 73704 "c/sqlite3.c"
 $6 = ((($0)) + 12|0); //@line 73704 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 73704 "c/sqlite3.c"
 $8 = ((($7)) + 48|0); //@line 73704 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 73704 "c/sqlite3.c"
 $10 = ($5|0)>($9|0); //@line 73704 "c/sqlite3.c"
 if ($10) {
  $11 = (_growOpArray($0)|0); //@line 73704 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 73704 "c/sqlite3.c"
  if (!($12)) {
   $$0 = 0;
   return ($$0|0); //@line 73736 "c/sqlite3.c"
  }
 }
 $13 = ((($0)) + 88|0); //@line 73707 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 73707 "c/sqlite3.c"
 $15 = HEAP32[$3>>2]|0; //@line 73707 "c/sqlite3.c"
 $16 = (($14) + (($15*20)|0)|0); //@line 73707 "c/sqlite3.c"
 $17 = ($1|0)>(0); //@line 73708 "c/sqlite3.c"
 if ($17) {
  $$0363 = $16;$$0372 = 0;$$0381 = $2;
  while(1) {
   $18 = HEAP8[$$0381>>0]|0; //@line 73709 "c/sqlite3.c"
   HEAP8[$$0363>>0] = $18; //@line 73709 "c/sqlite3.c"
   $19 = ((($$0381)) + 1|0); //@line 73710 "c/sqlite3.c"
   $20 = HEAP8[$19>>0]|0; //@line 73710 "c/sqlite3.c"
   $21 = $20 << 24 >> 24; //@line 73710 "c/sqlite3.c"
   $22 = ((($$0363)) + 4|0); //@line 73710 "c/sqlite3.c"
   HEAP32[$22>>2] = $21; //@line 73710 "c/sqlite3.c"
   $23 = ((($$0381)) + 2|0); //@line 73711 "c/sqlite3.c"
   $24 = HEAP8[$23>>0]|0; //@line 73711 "c/sqlite3.c"
   $25 = $24 << 24 >> 24; //@line 73711 "c/sqlite3.c"
   $26 = ((($$0363)) + 8|0); //@line 73711 "c/sqlite3.c"
   HEAP32[$26>>2] = $25; //@line 73711 "c/sqlite3.c"
   $27 = $18&255; //@line 73713 "c/sqlite3.c"
   $28 = (26702 + ($27)|0); //@line 73713 "c/sqlite3.c"
   $29 = HEAP8[$28>>0]|0; //@line 73713 "c/sqlite3.c"
   $30 = $29 & 1; //@line 73713 "c/sqlite3.c"
   $31 = ($30<<24>>24)!=(0); //@line 73713 "c/sqlite3.c"
   $32 = ($24<<24>>24)>(0); //@line 73713 "c/sqlite3.c"
   $or$cond = $32 & $31; //@line 73713 "c/sqlite3.c"
   if ($or$cond) {
    $33 = HEAP32[$3>>2]|0; //@line 73714 "c/sqlite3.c"
    $34 = (($33) + ($25))|0; //@line 73714 "c/sqlite3.c"
    HEAP32[$26>>2] = $34; //@line 73714 "c/sqlite3.c"
   }
   $35 = ((($$0381)) + 3|0); //@line 73716 "c/sqlite3.c"
   $36 = HEAP8[$35>>0]|0; //@line 73716 "c/sqlite3.c"
   $37 = $36 << 24 >> 24; //@line 73716 "c/sqlite3.c"
   $38 = ((($$0363)) + 12|0); //@line 73716 "c/sqlite3.c"
   HEAP32[$38>>2] = $37; //@line 73716 "c/sqlite3.c"
   $39 = ((($$0363)) + 1|0); //@line 73717 "c/sqlite3.c"
   HEAP8[$39>>0] = 0; //@line 73717 "c/sqlite3.c"
   $40 = ((($$0363)) + 16|0); //@line 73718 "c/sqlite3.c"
   HEAP32[$40>>2] = 0; //@line 73718 "c/sqlite3.c"
   $41 = ((($$0363)) + 2|0); //@line 73719 "c/sqlite3.c"
   HEAP16[$41>>1] = 0; //@line 73719 "c/sqlite3.c"
   $42 = (($$0372) + 1)|0; //@line 73708 "c/sqlite3.c"
   $43 = ((($$0381)) + 4|0); //@line 73708 "c/sqlite3.c"
   $44 = ((($$0363)) + 20|0); //@line 73708 "c/sqlite3.c"
   $exitcond = ($42|0)==($1|0); //@line 73708 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$0363 = $44;$$0372 = $42;$$0381 = $43;
   }
  }
 }
 $45 = HEAP32[$3>>2]|0; //@line 73734 "c/sqlite3.c"
 $46 = (($45) + ($1))|0; //@line 73734 "c/sqlite3.c"
 HEAP32[$3>>2] = $46; //@line 73734 "c/sqlite3.c"
 $$0 = $16;
 return ($$0|0); //@line 73736 "c/sqlite3.c"
}
function _returnSingleInt($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = $3;
 $5 = $4;
 HEAP32[$5>>2] = $1;
 $6 = (($4) + 4)|0;
 $7 = $6;
 HEAP32[$7>>2] = $2;
 _sqlite3VdbeAddOp4Dup8($0,68,1,$3,-14); //@line 115481 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($0,78,1,1)|0); //@line 115482 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 115483 "c/sqlite3.c"
}
function _getLockingMode($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 115376 "c/sqlite3.c"
 if ($1) {
  label = 4;
 } else {
  $2 = (_sqlite3StrICmp($0,25950)|0); //@line 115377 "c/sqlite3.c"
  $3 = ($2|0)==(0); //@line 115377 "c/sqlite3.c"
  if ($3) {
   $$0 = 1;
  } else {
   $4 = (_sqlite3StrICmp($0,25943)|0); //@line 115378 "c/sqlite3.c"
   $5 = ($4|0)==(0); //@line 115378 "c/sqlite3.c"
   if ($5) {
    $$0 = 0;
   } else {
    label = 4;
   }
  }
 }
 if ((label|0) == 4) {
  $$0 = -1;
 }
 return ($$0|0); //@line 115381 "c/sqlite3.c"
}
function _sqlite3JournalModename($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(6); //@line 115567 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
 } else {
  $2 = (6304 + ($0<<2)|0); //@line 115568 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 115568 "c/sqlite3.c"
  $$0 = $3;
 }
 return ($$0|0); //@line 115569 "c/sqlite3.c"
}
function _sqlite3PagerJournalSizeLimit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)>(-1); //@line 55325 "c/sqlite3.c"
 $4 = ($1>>>0)>(4294967294); //@line 55325 "c/sqlite3.c"
 $5 = ($2|0)==(-1); //@line 55325 "c/sqlite3.c"
 $6 = $5 & $4; //@line 55325 "c/sqlite3.c"
 $7 = $3 | $6; //@line 55325 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 160|0); //@line 55326 "c/sqlite3.c"
  $9 = $8; //@line 55326 "c/sqlite3.c"
  $10 = $9; //@line 55326 "c/sqlite3.c"
  HEAP32[$10>>2] = $1; //@line 55326 "c/sqlite3.c"
  $11 = (($9) + 4)|0; //@line 55326 "c/sqlite3.c"
  $12 = $11; //@line 55326 "c/sqlite3.c"
  HEAP32[$12>>2] = $2; //@line 55326 "c/sqlite3.c"
  $13 = ((($0)) + 212|0); //@line 55327 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 55327 "c/sqlite3.c"
  _sqlite3WalLimit($14,$1,$2); //@line 55327 "c/sqlite3.c"
 }
 $15 = ((($0)) + 160|0); //@line 55329 "c/sqlite3.c"
 $16 = $15; //@line 55329 "c/sqlite3.c"
 $17 = $16; //@line 55329 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 55329 "c/sqlite3.c"
 $19 = (($16) + 4)|0; //@line 55329 "c/sqlite3.c"
 $20 = $19; //@line 55329 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 55329 "c/sqlite3.c"
 tempRet0 = ($21); //@line 55329 "c/sqlite3.c"
 return ($18|0); //@line 55329 "c/sqlite3.c"
}
function _sqlite3BtreeGetAutoVacuum($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 63339 "c/sqlite3.c"
 $1 = ((($0)) + 4|0); //@line 63341 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63341 "c/sqlite3.c"
 $3 = ((($2)) + 17|0); //@line 63341 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 63341 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 63341 "c/sqlite3.c"
 if ($5) {
  $10 = 0;
  _sqlite3BtreeLeave($0); //@line 63345 "c/sqlite3.c"
  return ($10|0); //@line 63346 "c/sqlite3.c"
 }
 $6 = ((($2)) + 18|0); //@line 63342 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 63342 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 63342 "c/sqlite3.c"
 $9 = $8 ? 1 : 2; //@line 63342 "c/sqlite3.c"
 $10 = $9;
 _sqlite3BtreeLeave($0); //@line 63345 "c/sqlite3.c"
 return ($10|0); //@line 63346 "c/sqlite3.c"
}
function _getAutoVacuum($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3StrICmp($0,26662)|0); //@line 115392 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 115392 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
 } else {
  $3 = (_sqlite3StrICmp($0,26324)|0); //@line 115393 "c/sqlite3.c"
  $4 = ($3|0)==(0); //@line 115393 "c/sqlite3.c"
  if ($4) {
   $$0 = 1;
  } else {
   $5 = (_sqlite3StrICmp($0,26667)|0); //@line 115394 "c/sqlite3.c"
   $6 = ($5|0)==(0); //@line 115394 "c/sqlite3.c"
   if ($6) {
    $$0 = 2;
   } else {
    $7 = (_sqlite3Atoi($0)|0); //@line 115395 "c/sqlite3.c"
    $8 = ($7>>>0)<(3); //@line 115396 "c/sqlite3.c"
    $9 = $7 & 255; //@line 115396 "c/sqlite3.c"
    $10 = $8 ? $9 : 0; //@line 115396 "c/sqlite3.c"
    $$0 = $10;
   }
  }
 }
 return ($$0|0); //@line 115397 "c/sqlite3.c"
}
function _sqlite3BtreeSetAutoVacuum($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 63314 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63314 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63318 "c/sqlite3.c"
 $4 = ((($3)) + 22|0); //@line 63319 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 63319 "c/sqlite3.c"
 $6 = $5 & 2; //@line 63319 "c/sqlite3.c"
 $7 = ($6<<16>>16)==(0); //@line 63319 "c/sqlite3.c"
 if (!($7)) {
  $8 = $1 & 255; //@line 63319 "c/sqlite3.c"
  $9 = ($8|0)!=(0); //@line 63319 "c/sqlite3.c"
  $10 = $9&1; //@line 63319 "c/sqlite3.c"
  $11 = ((($3)) + 17|0); //@line 63319 "c/sqlite3.c"
  $12 = HEAP8[$11>>0]|0; //@line 63319 "c/sqlite3.c"
  $13 = $12&255; //@line 63319 "c/sqlite3.c"
  $14 = ($10|0)==($13|0); //@line 63319 "c/sqlite3.c"
  if (!($14)) {
   $$0 = 8;
   _sqlite3BtreeLeave($0); //@line 63325 "c/sqlite3.c"
   return ($$0|0); //@line 63326 "c/sqlite3.c"
  }
 }
 $15 = $1 & 255; //@line 63322 "c/sqlite3.c"
 $16 = ($15|0)!=(0); //@line 63322 "c/sqlite3.c"
 $17 = $16&1; //@line 63322 "c/sqlite3.c"
 $18 = ((($3)) + 17|0); //@line 63322 "c/sqlite3.c"
 HEAP8[$18>>0] = $17; //@line 63322 "c/sqlite3.c"
 $19 = ($15|0)==(2); //@line 63323 "c/sqlite3.c"
 $20 = $19&1; //@line 63323 "c/sqlite3.c"
 $21 = ((($3)) + 18|0); //@line 63323 "c/sqlite3.c"
 HEAP8[$21>>0] = $20; //@line 63323 "c/sqlite3.c"
 $$0 = 0;
 _sqlite3BtreeLeave($0); //@line 63325 "c/sqlite3.c"
 return ($$0|0); //@line 63326 "c/sqlite3.c"
}
function _sqlite3BtreeSetSpillSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 63116 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63116 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 63119 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63120 "c/sqlite3.c"
 $5 = (_sqlite3PagerSetSpillsize($4,$1)|0); //@line 63120 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63121 "c/sqlite3.c"
 return ($5|0); //@line 63122 "c/sqlite3.c"
}
function _setAllPagerFlags($0) {
 $0 = $0|0;
 var $$01112 = 0, $$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 71|0); //@line 115505 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 115505 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 115505 "c/sqlite3.c"
 if ($3) {
  return; //@line 115522 "c/sqlite3.c"
 }
 $4 = ((($0)) + 20|0); //@line 115507 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 115507 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 115514 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 115522 "c/sqlite3.c"
 }
 $7 = ((($0)) + 16|0); //@line 115506 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 115506 "c/sqlite3.c"
 $9 = ((($0)) + 28|0);
 $$01112 = $8;$$in = $5;
 while(1) {
  $10 = (($$in) + -1)|0; //@line 115514 "c/sqlite3.c"
  $11 = ((($$01112)) + 4|0); //@line 115515 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 115515 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 115515 "c/sqlite3.c"
  if (!($13)) {
   $14 = ((($$01112)) + 8|0); //@line 115517 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 115517 "c/sqlite3.c"
   $16 = $15&255; //@line 115517 "c/sqlite3.c"
   $17 = HEAP32[$9>>2]|0; //@line 115517 "c/sqlite3.c"
   $18 = $17 & 56; //@line 115517 "c/sqlite3.c"
   $19 = $18 | $16; //@line 115517 "c/sqlite3.c"
   _sqlite3BtreeSetPagerFlags($12,$19); //@line 115516 "c/sqlite3.c"
  }
  $20 = ((($$01112)) + 16|0); //@line 115519 "c/sqlite3.c"
  $21 = ($$in|0)>(1); //@line 115514 "c/sqlite3.c"
  if ($21) {
   $$01112 = $20;$$in = $10;
  } else {
   break;
  }
 }
 return; //@line 115522 "c/sqlite3.c"
}
function _changeTempStorage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_getTempStore($1)|0); //@line 115447 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 115448 "c/sqlite3.c"
 $4 = ((($3)) + 72|0); //@line 115449 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 115449 "c/sqlite3.c"
 $6 = $5&255; //@line 115449 "c/sqlite3.c"
 $7 = ($2|0)==($6|0); //@line 115449 "c/sqlite3.c"
 if ($7) {
  return;
 }
 $8 = (_invalidateTempStorage($0)|0); //@line 115450 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 115450 "c/sqlite3.c"
 if (!($9)) {
  return;
 }
 $10 = $2&255; //@line 115453 "c/sqlite3.c"
 HEAP8[$4>>0] = $10; //@line 115453 "c/sqlite3.c"
 return;
}
function _invalidateTempStorage($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 115424 "c/sqlite3.c"
 $1 = HEAP32[$0>>2]|0; //@line 115425 "c/sqlite3.c"
 $2 = ((($1)) + 16|0); //@line 115426 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 115426 "c/sqlite3.c"
 $4 = ((($3)) + 20|0); //@line 115426 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 115426 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 115426 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 115437 "c/sqlite3.c"
 }
 $7 = ((($1)) + 71|0); //@line 115427 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 115427 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 115427 "c/sqlite3.c"
 if (!($9)) {
  $10 = (_sqlite3BtreeIsInReadTrans($5)|0); //@line 115427 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 115427 "c/sqlite3.c"
  if ($11) {
   _sqlite3BtreeClose($5); //@line 115432 "c/sqlite3.c"
   $12 = HEAP32[$2>>2]|0; //@line 115433 "c/sqlite3.c"
   $13 = ((($12)) + 20|0); //@line 115433 "c/sqlite3.c"
   HEAP32[$13>>2] = 0; //@line 115433 "c/sqlite3.c"
   _sqlite3ResetAllSchemasOfConnection($1); //@line 115434 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 115437 "c/sqlite3.c"
  }
 }
 _sqlite3ErrorMsg($0,26600,$vararg_buffer); //@line 115428 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 115437 "c/sqlite3.c"
}
function _sqlite3VdbeMultiLoad($0,$1,$2,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $varargs = $varargs|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $arglist_current = 0, $arglist_current2 = 0, $arglist_next = 0, $arglist_next3 = 0, $expanded = 0, $expanded10 = 0, $expanded12 = 0, $expanded13 = 0, $expanded14 = 0, $expanded3 = 0, $expanded5 = 0, $expanded6 = 0, $expanded7 = 0, $expanded9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 HEAP32[$3>>2] = $varargs; //@line 73215 "c/sqlite3.c"
 $$0 = 0;
 L1: while(1) {
  $4 = (($2) + ($$0)|0); //@line 73216 "c/sqlite3.c"
  $5 = HEAP8[$4>>0]|0; //@line 73216 "c/sqlite3.c"
  switch ($5<<24>>24) {
  case 0:  {
   break L1;
   break;
  }
  case 115:  {
   $arglist_current = HEAP32[$3>>2]|0; //@line 73218 "c/sqlite3.c"
   $6 = $arglist_current; //@line 73218 "c/sqlite3.c"
   $7 = ((0) + 4|0);
   $expanded3 = $7;
   $expanded = (($expanded3) - 1)|0;
   $8 = (($6) + ($expanded))|0; //@line 73218 "c/sqlite3.c"
   $9 = ((0) + 4|0);
   $expanded7 = $9;
   $expanded6 = (($expanded7) - 1)|0;
   $expanded5 = $expanded6 ^ -1;
   $10 = $8 & $expanded5; //@line 73218 "c/sqlite3.c"
   $11 = $10; //@line 73218 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 73218 "c/sqlite3.c"
   $arglist_next = ((($11)) + 4|0); //@line 73218 "c/sqlite3.c"
   HEAP32[$3>>2] = $arglist_next; //@line 73218 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 73219 "c/sqlite3.c"
   $14 = $13 ? 70 : 97; //@line 73219 "c/sqlite3.c"
   $15 = (($$0) + ($1))|0; //@line 73219 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($0,$14,0,$15,0,$12,0)|0); //@line 73219 "c/sqlite3.c"
   break;
  }
  case 105:  {
   $arglist_current2 = HEAP32[$3>>2]|0; //@line 73221 "c/sqlite3.c"
   $16 = $arglist_current2; //@line 73221 "c/sqlite3.c"
   $17 = ((0) + 4|0);
   $expanded10 = $17;
   $expanded9 = (($expanded10) - 1)|0;
   $18 = (($16) + ($expanded9))|0; //@line 73221 "c/sqlite3.c"
   $19 = ((0) + 4|0);
   $expanded14 = $19;
   $expanded13 = (($expanded14) - 1)|0;
   $expanded12 = $expanded13 ^ -1;
   $20 = $18 & $expanded12; //@line 73221 "c/sqlite3.c"
   $21 = $20; //@line 73221 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 73221 "c/sqlite3.c"
   $arglist_next3 = ((($21)) + 4|0); //@line 73221 "c/sqlite3.c"
   HEAP32[$3>>2] = $arglist_next3; //@line 73221 "c/sqlite3.c"
   $23 = (($$0) + ($1))|0; //@line 73221 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($0,67,$22,$23)|0); //@line 73221 "c/sqlite3.c"
   break;
  }
  default: {
   label = 7;
   break L1;
  }
  }
  $24 = (($$0) + 1)|0; //@line 73216 "c/sqlite3.c"
  $$0 = $24;
 }
 if ((label|0) == 7) {
  STACKTOP = sp;return; //@line 73229 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($0,78,$1,$$0)|0); //@line 73226 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 73229 "c/sqlite3.c"
}
function _actionName($0) {
 $0 = $0|0;
 var $$0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0<<24>>24) {
 case 7:  {
  $$0 = 26587;
  break;
 }
 case 8:  {
  $$0 = 26548;
  break;
 }
 case 9:  {
  $$0 = 26560;
  break;
 }
 case 6:  {
  $$0 = 26568;
  break;
 }
 default: {
  $$0 = 26577;
 }
 }
 return ($$0|0); //@line 115542 "c/sqlite3.c"
}
function _sqlite3FkLocateIndex($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$091 = 0, $$091119 = 0, $$091120 = 0, $$092 = 0, $$093103 = 0, $$093108 = 0, $$094$lcssa = 0, $$094110 = 0, $$095107 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0;
 var $exitcond = 0, $or$cond = 0, $spec$store$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 109597 "c/sqlite3.c"
 $5 = ((($2)) + 20|0); //@line 109605 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 109605 "c/sqlite3.c"
 $7 = ((($2)) + 40|0); //@line 109606 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 109606 "c/sqlite3.c"
 $9 = ($6|0)==(1); //@line 109621 "c/sqlite3.c"
 do {
  if ($9) {
   $10 = ((($1)) + 40|0); //@line 109629 "c/sqlite3.c"
   $11 = HEAP16[$10>>1]|0; //@line 109629 "c/sqlite3.c"
   $12 = $11 << 16 >> 16; //@line 109629 "c/sqlite3.c"
   $13 = ($11<<16>>16)>(-1); //@line 109629 "c/sqlite3.c"
   if ($13) {
    $14 = ($8|0)==(0|0); //@line 109630 "c/sqlite3.c"
    if ($14) {
     $$0 = 0;
     STACKTOP = sp;return ($$0|0); //@line 109703 "c/sqlite3.c"
    }
    $15 = ((($1)) + 4|0); //@line 109631 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 109631 "c/sqlite3.c"
    $17 = (($16) + ($12<<4)|0); //@line 109631 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 109631 "c/sqlite3.c"
    $19 = (_sqlite3StrICmp($18,$8)|0); //@line 109631 "c/sqlite3.c"
    $20 = ($19|0)==(0); //@line 109631 "c/sqlite3.c"
    if ($20) {
     $$0 = 0;
     STACKTOP = sp;return ($$0|0); //@line 109703 "c/sqlite3.c"
    } else {
     $$092 = 0;$94 = 0;
    }
   } else {
    $$092 = 0;$94 = 0;
   }
  } else {
   $21 = ($4|0)==(0|0); //@line 109633 "c/sqlite3.c"
   if ($21) {
    $$092 = 0;$94 = 0;
   } else {
    $22 = HEAP32[$0>>2]|0; //@line 109635 "c/sqlite3.c"
    $23 = $6 << 2; //@line 109635 "c/sqlite3.c"
    $24 = (_sqlite3DbMallocRawNN($22,$23,0)|0); //@line 109635 "c/sqlite3.c"
    $25 = ($24|0)==(0|0); //@line 109636 "c/sqlite3.c"
    if ($25) {
     $$0 = 1;
     STACKTOP = sp;return ($$0|0); //@line 109703 "c/sqlite3.c"
    } else {
     HEAP32[$4>>2] = $24; //@line 109637 "c/sqlite3.c"
     $$092 = $24;$94 = $24;
     break;
    }
   }
  }
 } while(0);
 $26 = ((($1)) + 8|0); //@line 109640 "c/sqlite3.c"
 $$091119 = HEAP32[$26>>2]|0;
 $27 = ($$091119|0)==(0|0); //@line 109640 "c/sqlite3.c"
 L14: do {
  if (!($27)) {
   $28 = ($8|0)==(0|0);
   $29 = ((($1)) + 4|0);
   $30 = ($6|0)>(0);
   $31 = ($6|0)>(0);
   $32 = ($$092|0)==(0|0);
   $$091120 = $$091119;
   L16: while(1) {
    $33 = ((($$091120)) + 50|0); //@line 109641 "c/sqlite3.c"
    $34 = HEAP16[$33>>1]|0; //@line 109641 "c/sqlite3.c"
    $35 = $34&65535; //@line 109641 "c/sqlite3.c"
    $36 = ($6|0)==($35|0); //@line 109641 "c/sqlite3.c"
    do {
     if ($36) {
      $37 = ((($$091120)) + 54|0); //@line 109641 "c/sqlite3.c"
      $38 = HEAP8[$37>>0]|0; //@line 109641 "c/sqlite3.c"
      $39 = ($38<<24>>24)==(0); //@line 109641 "c/sqlite3.c"
      if (!($39)) {
       $40 = ((($$091120)) + 36|0); //@line 109641 "c/sqlite3.c"
       $41 = HEAP32[$40>>2]|0; //@line 109641 "c/sqlite3.c"
       $42 = ($41|0)==(0|0); //@line 109641 "c/sqlite3.c"
       if ($42) {
        if ($28) {
         $43 = ((($$091120)) + 55|0); //@line 109650 "c/sqlite3.c"
         $44 = HEAPU8[$43>>0]|(HEAPU8[$43+1>>0]<<8); //@line 109650 "c/sqlite3.c"
         $45 = $44 & 3; //@line 109650 "c/sqlite3.c"
         $46 = ($45<<16>>16)==(2); //@line 109650 "c/sqlite3.c"
         if ($46) {
          label = 15;
          break L16;
         } else {
          break;
         }
        }
        $53 = ((($$091120)) + 4|0); //@line 109664 "c/sqlite3.c"
        L25: do {
         if ($30) {
          $54 = ((($$091120)) + 32|0);
          $$094110 = 0;
          while(1) {
           $55 = HEAP32[$53>>2]|0; //@line 109664 "c/sqlite3.c"
           $56 = (($55) + ($$094110<<1)|0); //@line 109664 "c/sqlite3.c"
           $57 = HEAP16[$56>>1]|0; //@line 109664 "c/sqlite3.c"
           $58 = $57 << 16 >> 16; //@line 109668 "c/sqlite3.c"
           $59 = ($57<<16>>16)<(0); //@line 109668 "c/sqlite3.c"
           if ($59) {
            $$094$lcssa = $$094110;
            break L25;
           }
           $60 = HEAP32[$29>>2]|0; //@line 109673 "c/sqlite3.c"
           $61 = (((($60) + ($58<<4)|0)) + 8|0); //@line 109673 "c/sqlite3.c"
           $62 = HEAP32[$61>>2]|0; //@line 109673 "c/sqlite3.c"
           $63 = ($62|0)==(0|0); //@line 109674 "c/sqlite3.c"
           $spec$store$select = $63 ? 18038 : $62; //@line 109674 "c/sqlite3.c"
           $64 = HEAP32[$54>>2]|0; //@line 109675 "c/sqlite3.c"
           $65 = (($64) + ($$094110<<2)|0); //@line 109675 "c/sqlite3.c"
           $66 = HEAP32[$65>>2]|0; //@line 109675 "c/sqlite3.c"
           $67 = (_sqlite3StrICmp($66,$spec$store$select)|0); //@line 109675 "c/sqlite3.c"
           $68 = ($67|0)==(0); //@line 109675 "c/sqlite3.c"
           if (!($68)) {
            $$094$lcssa = $$094110;
            break L25;
           }
           $69 = (($60) + ($58<<4)|0); //@line 109677 "c/sqlite3.c"
           $70 = HEAP32[$69>>2]|0; //@line 109677 "c/sqlite3.c"
           L31: do {
            if ($31) {
             $$093108 = 0;
             while(1) {
              $71 = (((((($2)) + 36|0) + ($$093108<<3)|0)) + 4|0); //@line 109679 "c/sqlite3.c"
              $72 = HEAP32[$71>>2]|0; //@line 109679 "c/sqlite3.c"
              $73 = (_sqlite3StrICmp($72,$70)|0); //@line 109679 "c/sqlite3.c"
              $74 = ($73|0)==(0); //@line 109679 "c/sqlite3.c"
              if ($74) {
               break;
              }
              $78 = (($$093108) + 1)|0; //@line 109678 "c/sqlite3.c"
              $79 = ($78|0)<($6|0); //@line 109678 "c/sqlite3.c"
              if ($79) {
               $$093108 = $78;
              } else {
               $$093103 = $78;
               break L31;
              }
             }
             if ($32) {
              $$093103 = $$093108;
             } else {
              $75 = (($$092) + ($$094110<<2)|0); //@line 109680 "c/sqlite3.c"
              $76 = (((($2)) + 36|0) + ($$093108<<3)|0); //@line 109680 "c/sqlite3.c"
              $77 = HEAP32[$76>>2]|0; //@line 109680 "c/sqlite3.c"
              HEAP32[$75>>2] = $77; //@line 109680 "c/sqlite3.c"
              $$093103 = $$093108;
             }
            } else {
             $$093103 = 0;
            }
           } while(0);
           $80 = ($$093103|0)==($6|0); //@line 109684 "c/sqlite3.c"
           if ($80) {
            $$094$lcssa = $$094110;
            break L25;
           }
           $81 = (($$094110) + 1)|0; //@line 109663 "c/sqlite3.c"
           $82 = ($81|0)<($6|0); //@line 109663 "c/sqlite3.c"
           if ($82) {
            $$094110 = $81;
           } else {
            $$094$lcssa = $81;
            break;
           }
          }
         } else {
          $$094$lcssa = 0;
         }
        } while(0);
        $83 = ($$094$lcssa|0)==($6|0); //@line 109686 "c/sqlite3.c"
        if ($83) {
         break L16;
        }
       }
      }
     }
    } while(0);
    $84 = ((($$091120)) + 20|0); //@line 109640 "c/sqlite3.c"
    $$091 = HEAP32[$84>>2]|0;
    $85 = ($$091|0)==(0|0); //@line 109640 "c/sqlite3.c"
    if ($85) {
     break L14;
    } else {
     $$091120 = $$091;
    }
   }
   if ((label|0) == 15) {
    $47 = ($$092|0)!=(0|0); //@line 109651 "c/sqlite3.c"
    $48 = ($6|0)>(0); //@line 109653 "c/sqlite3.c"
    $or$cond = $47 & $48; //@line 109651 "c/sqlite3.c"
    if ($or$cond) {
     $$095107 = 0;
     while(1) {
      $49 = (((($2)) + 36|0) + ($$095107<<3)|0); //@line 109653 "c/sqlite3.c"
      $50 = HEAP32[$49>>2]|0; //@line 109653 "c/sqlite3.c"
      $51 = (($$092) + ($$095107<<2)|0); //@line 109653 "c/sqlite3.c"
      HEAP32[$51>>2] = $50; //@line 109653 "c/sqlite3.c"
      $52 = (($$095107) + 1)|0; //@line 109653 "c/sqlite3.c"
      $exitcond = ($52|0)==($6|0); //@line 109653 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$095107 = $52;
      }
     }
    }
   }
   HEAP32[$3>>2] = $$091120; //@line 109701 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 109703 "c/sqlite3.c"
  }
 } while(0);
 $86 = ((($0)) + 146|0); //@line 109692 "c/sqlite3.c"
 $87 = HEAP8[$86>>0]|0; //@line 109692 "c/sqlite3.c"
 $88 = ($87<<24>>24)==(0); //@line 109692 "c/sqlite3.c"
 if ($88) {
  $89 = HEAP32[$2>>2]|0; //@line 109695 "c/sqlite3.c"
  $90 = HEAP32[$89>>2]|0; //@line 109695 "c/sqlite3.c"
  $91 = ((($2)) + 8|0); //@line 109695 "c/sqlite3.c"
  $92 = HEAP32[$91>>2]|0; //@line 109695 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $90; //@line 109693 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 109693 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $92; //@line 109693 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,26503,$vararg_buffer); //@line 109693 "c/sqlite3.c"
 }
 $93 = HEAP32[$0>>2]|0; //@line 109697 "c/sqlite3.c"
 _sqlite3DbFree($93,$94); //@line 109697 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 109703 "c/sqlite3.c"
}
function _sqlite3RegisterLikeFunctions($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $likeInfoAlt$likeInfoNorm = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)!=(0); //@line 109210 "c/sqlite3.c"
 $likeInfoAlt$likeInfoNorm = $2 ? 26436 : 16989; //@line 109212 "c/sqlite3.c"
 (_sqlite3CreateFunc($0,16993,2,1,$likeInfoAlt$likeInfoNorm,140,0,0,0)|0); //@line 109215 "c/sqlite3.c"
 (_sqlite3CreateFunc($0,16993,3,1,$likeInfoAlt$likeInfoNorm,140,0,0,0)|0); //@line 109216 "c/sqlite3.c"
 (_sqlite3CreateFunc($0,16984,2,1,16980,140,0,0,0)|0); //@line 109217 "c/sqlite3.c"
 _setLikeOptFlag($0,16984,12); //@line 109219 "c/sqlite3.c"
 $3 = $2 ? 12 : 4; //@line 109221 "c/sqlite3.c"
 _setLikeOptFlag($0,16993,$3); //@line 109220 "c/sqlite3.c"
 return; //@line 109222 "c/sqlite3.c"
}
function _sqlite3ClearTempRegCache($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 19|0); //@line 97991 "c/sqlite3.c"
 HEAP8[$1>>0] = 0; //@line 97991 "c/sqlite3.c"
 $2 = ((($0)) + 28|0); //@line 97992 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 97992 "c/sqlite3.c"
 return; //@line 97993 "c/sqlite3.c"
}
function _integrityCheckResultRow($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3VdbeAddOp2($0,78,3,1)|0); //@line 115600 "c/sqlite3.c"
 $1 = (_sqlite3VdbeCurrentAddr($0)|0); //@line 115601 "c/sqlite3.c"
 $2 = (($1) + 2)|0; //@line 115601 "c/sqlite3.c"
 $3 = (_sqlite3VdbeAddOp3($0,48,1,$2,1)|0); //@line 115601 "c/sqlite3.c"
 (_sqlite3VdbeAddOp0($0,66)|0); //@line 115603 "c/sqlite3.c"
 return ($3|0); //@line 115604 "c/sqlite3.c"
}
function _sqlite3ExprCacheClear($0) {
 $0 = $0|0;
 var $$010 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 25|0); //@line 96071 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 96071 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 96071 "c/sqlite3.c"
 if ($3) {
  HEAP8[$1>>0] = 0; //@line 96078 "c/sqlite3.c"
  return; //@line 96079 "c/sqlite3.c"
 }
 $4 = HEAP8[$1>>0]|0;
 $5 = $4&255;
 $6 = ((($0)) + 19|0);
 $$010 = 0;
 while(1) {
  $7 = (((((($0)) + 148|0) + (($$010*20)|0)|0)) + 6|0); //@line 96072 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 96072 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 96072 "c/sqlite3.c"
  if (!($9)) {
   $10 = HEAP8[$6>>0]|0; //@line 96073 "c/sqlite3.c"
   $11 = ($10&255)<(8); //@line 96073 "c/sqlite3.c"
   if ($11) {
    $12 = $10&255; //@line 96073 "c/sqlite3.c"
    $13 = (((($0)) + 348|0) + ($12<<2)|0); //@line 96075 "c/sqlite3.c"
    $14 = (($10) + 1)<<24>>24; //@line 96075 "c/sqlite3.c"
    $15 = (((((($0)) + 148|0) + (($$010*20)|0)|0)) + 12|0); //@line 96075 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 96075 "c/sqlite3.c"
    HEAP8[$6>>0] = $14; //@line 96075 "c/sqlite3.c"
    HEAP32[$13>>2] = $16; //@line 96075 "c/sqlite3.c"
   }
  }
  $17 = (($$010) + 1)|0; //@line 96071 "c/sqlite3.c"
  $18 = ($17>>>0)<($5>>>0); //@line 96071 "c/sqlite3.c"
  if ($18) {
   $$010 = $17;
  } else {
   break;
  }
 }
 HEAP8[$1>>0] = 0; //@line 96078 "c/sqlite3.c"
 return; //@line 96079 "c/sqlite3.c"
}
function _sqlite3OpenTableAndIndices($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0 = 0, $$064$mux = 0, $$06472 = 0, $$065 = 0, $$06569 = 0, $$06573 = 0, $$066 = 0, $$068$lcssa = 0, $$06870 = 0, $$1 = 0, $$167$lcssa = 0, $$16771 = 0, $$not = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $8 = 0, $9 = 0, $brmerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = ((($1)) + 56|0); //@line 112663 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 112663 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 112663 "c/sqlite3.c"
 if (!($10)) {
  $$0 = 0;
  return ($$0|0); //@line 112697 "c/sqlite3.c"
 }
 $11 = HEAP32[$0>>2]|0; //@line 112669 "c/sqlite3.c"
 $12 = ((($1)) + 72|0); //@line 112669 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 112669 "c/sqlite3.c"
 $14 = (_sqlite3SchemaToIndex($11,$13)|0); //@line 112669 "c/sqlite3.c"
 $15 = (_sqlite3GetVdbe($0)|0); //@line 112670 "c/sqlite3.c"
 $16 = ($4|0)<(0); //@line 112672 "c/sqlite3.c"
 if ($16) {
  $17 = ((($0)) + 40|0); //@line 112672 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 112672 "c/sqlite3.c"
  $$066 = $18;
 } else {
  $$066 = $4;
 }
 $19 = (($$066) + 1)|0; //@line 112673 "c/sqlite3.c"
 $20 = ($6|0)!=(0|0); //@line 112674 "c/sqlite3.c"
 if ($20) {
  HEAP32[$6>>2] = $$066; //@line 112674 "c/sqlite3.c"
 }
 $21 = ((($1)) + 36|0); //@line 112675 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 112675 "c/sqlite3.c"
 $23 = $22 & 32; //@line 112675 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 112675 "c/sqlite3.c"
 do {
  if ($24) {
   $25 = ($5|0)==(0|0); //@line 112675 "c/sqlite3.c"
   if (!($25)) {
    $26 = HEAP8[$5>>0]|0; //@line 112675 "c/sqlite3.c"
    $27 = ($26<<24>>24)==(0); //@line 112675 "c/sqlite3.c"
    if ($27) {
     label = 10;
     break;
    }
   }
   _sqlite3OpenTable($0,$$066,$14,$1,$2); //@line 112676 "c/sqlite3.c"
  } else {
   label = 10;
  }
 } while(0);
 if ((label|0) == 10) {
  $28 = ((($1)) + 28|0); //@line 112678 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 112678 "c/sqlite3.c"
  $30 = ($2|0)==(106); //@line 112678 "c/sqlite3.c"
  $31 = $30&1; //@line 112678 "c/sqlite3.c"
  $32 = HEAP32[$1>>2]|0; //@line 112678 "c/sqlite3.c"
  _sqlite3TableLock($0,$14,$29,$31,$32); //@line 112678 "c/sqlite3.c"
 }
 $33 = ($7|0)==(0|0); //@line 112680 "c/sqlite3.c"
 if (!($33)) {
  HEAP32[$7>>2] = $19; //@line 112680 "c/sqlite3.c"
 }
 $34 = ((($1)) + 8|0); //@line 112681 "c/sqlite3.c"
 $$06569 = HEAP32[$34>>2]|0;
 $35 = ($$06569|0)==(0|0); //@line 112681 "c/sqlite3.c"
 if ($35) {
  $$068$lcssa = 0;$$167$lcssa = $19;
 } else {
  $$not = $20 ^ 1;
  $36 = ($5|0)==(0|0);
  $$06472 = $3;$$06573 = $$06569;$$06870 = 0;$$16771 = $19;
  while(1) {
   $37 = (($$16771) + 1)|0; //@line 112682 "c/sqlite3.c"
   $38 = ((($$06573)) + 55|0); //@line 112684 "c/sqlite3.c"
   $39 = HEAPU8[$38>>0]|(HEAPU8[$38+1>>0]<<8); //@line 112684 "c/sqlite3.c"
   $40 = $39 & 3; //@line 112684 "c/sqlite3.c"
   $41 = ($40<<16>>16)==(2); //@line 112684 "c/sqlite3.c"
   if ($41) {
    $42 = HEAP32[$21>>2]|0; //@line 112684 "c/sqlite3.c"
    $43 = $42 & 32; //@line 112684 "c/sqlite3.c"
    $44 = ($43|0)==(0); //@line 112684 "c/sqlite3.c"
    $brmerge = $44 | $$not; //@line 112684 "c/sqlite3.c"
    $$064$mux = $44 ? $$06472 : 0; //@line 112684 "c/sqlite3.c"
    if ($brmerge) {
     $$1 = $$064$mux;
    } else {
     HEAP32[$6>>2] = $$16771; //@line 112685 "c/sqlite3.c"
     $$1 = 0;
    }
   } else {
    $$1 = $$06472;
   }
   if ($36) {
    label = 20;
   } else {
    $45 = (($$06870) + 1)|0; //@line 112688 "c/sqlite3.c"
    $46 = (($5) + ($45)|0); //@line 112688 "c/sqlite3.c"
    $47 = HEAP8[$46>>0]|0; //@line 112688 "c/sqlite3.c"
    $48 = ($47<<24>>24)==(0); //@line 112688 "c/sqlite3.c"
    if (!($48)) {
     label = 20;
    }
   }
   if ((label|0) == 20) {
    label = 0;
    $49 = ((($$06573)) + 44|0); //@line 112689 "c/sqlite3.c"
    $50 = HEAP32[$49>>2]|0; //@line 112689 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($15,$2,$$16771,$50,$14)|0); //@line 112689 "c/sqlite3.c"
    _sqlite3VdbeSetP4KeyInfo($0,$$06573); //@line 112690 "c/sqlite3.c"
    $51 = $$1&255; //@line 112691 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($15,$51); //@line 112691 "c/sqlite3.c"
   }
   $52 = ((($$06573)) + 20|0); //@line 112681 "c/sqlite3.c"
   $53 = (($$06870) + 1)|0; //@line 112681 "c/sqlite3.c"
   $$065 = HEAP32[$52>>2]|0;
   $54 = ($$065|0)==(0|0); //@line 112681 "c/sqlite3.c"
   if ($54) {
    $$068$lcssa = $53;$$167$lcssa = $37;
    break;
   } else {
    $$06472 = $$1;$$06573 = $$065;$$06870 = $53;$$16771 = $37;
   }
  }
 }
 $55 = ((($0)) + 40|0); //@line 112695 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 112695 "c/sqlite3.c"
 $57 = ($$167$lcssa|0)>($56|0); //@line 112695 "c/sqlite3.c"
 if (!($57)) {
  $$0 = $$068$lcssa;
  return ($$0|0); //@line 112697 "c/sqlite3.c"
 }
 HEAP32[$55>>2] = $$167$lcssa; //@line 112695 "c/sqlite3.c"
 $$0 = $$068$lcssa;
 return ($$0|0); //@line 112697 "c/sqlite3.c"
}
function _sqlite3VdbeReusable($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 145|0); //@line 73370 "c/sqlite3.c"
 $2 = HEAPU8[$1>>0]|(HEAPU8[$1+1>>0]<<8); //@line 73370 "c/sqlite3.c"
 $3 = $2 & -33; //@line 73370 "c/sqlite3.c"
 HEAP8[$1>>0]=$3&255;HEAP8[$1+1>>0]=$3>>8; //@line 73370 "c/sqlite3.c"
 return; //@line 73371 "c/sqlite3.c"
}
function _sqlite3WalDefaultHook($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = $0; //@line 145391 "c/sqlite3.c"
 $5 = ($4|0)>($3|0); //@line 145391 "c/sqlite3.c"
 if ($5) {
  return 0; //@line 145396 "c/sqlite3.c"
 }
 _sqlite3BeginBenignMalloc(); //@line 145392 "c/sqlite3.c"
 (_sqlite3_wal_checkpoint($1,$2)|0); //@line 145393 "c/sqlite3.c"
 _sqlite3EndBenignMalloc(); //@line 145394 "c/sqlite3.c"
 return 0; //@line 145396 "c/sqlite3.c"
}
function _sqlite3CreateFunc($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$1 = 0, $$197 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $9 = 0, $or$cond = 0, $or$cond3$not = 0, $or$cond5 = 0, $or$cond7 = 0, $or$cond7$not = 0, $or$cond9 = 0;
 var $trunc = 0, $trunc$clear = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 144980 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 144995 "c/sqlite3.c"
 do {
  if (!($9)) {
   $10 = ($5|0)!=(0|0); //@line 144996 "c/sqlite3.c"
   $11 = ($7|0)!=(0|0);
   if ($10) {
    $12 = ($6|0)!=(0|0); //@line 144996 "c/sqlite3.c"
    $or$cond = $12 | $11; //@line 144996 "c/sqlite3.c"
    if ($or$cond) {
     break;
    } else {
     $14 = 0;$15 = 0;
    }
   } else {
    $or$cond3$not = $11 ^ 1; //@line 144997 "c/sqlite3.c"
    $13 = ($6|0)!=(0|0); //@line 144997 "c/sqlite3.c"
    $or$cond5 = $13 | $or$cond3$not; //@line 144997 "c/sqlite3.c"
    if ($or$cond5) {
     $14 = $11;$15 = $13;
    } else {
     break;
    }
   }
   $or$cond7 = $10 | $14; //@line 144998 "c/sqlite3.c"
   $or$cond7$not = $or$cond7 ^ 1; //@line 144998 "c/sqlite3.c"
   $or$cond9 = $15 & $or$cond7$not; //@line 144998 "c/sqlite3.c"
   $$off = (($2) + 1)|0; //@line 144998 "c/sqlite3.c"
   $16 = ($$off>>>0)>(128); //@line 144998 "c/sqlite3.c"
   $17 = $16 | $or$cond9; //@line 144998 "c/sqlite3.c"
   if (!($17)) {
    $18 = (_sqlite3Strlen30($1)|0); //@line 145000 "c/sqlite3.c"
    $19 = ($18|0)>(255); //@line 145000 "c/sqlite3.c"
    if (!($19)) {
     $21 = $3 & 2048; //@line 145005 "c/sqlite3.c"
     $trunc = $3&255; //@line 145016 "c/sqlite3.c"
     $trunc$clear = $trunc & 7; //@line 145016 "c/sqlite3.c"
     switch ($trunc$clear<<24>>24) {
     case 4:  {
      $$197 = 2;
      break;
     }
     case 5:  {
      $22 = $21 | 1; //@line 145020 "c/sqlite3.c"
      $23 = (_sqlite3CreateFunc($0,$1,$2,$22,$4,$5,$6,$7,$8)|0); //@line 145020 "c/sqlite3.c"
      $24 = ($23|0)==(0); //@line 145022 "c/sqlite3.c"
      if (!($24)) {
       $$1 = $23;
       STACKTOP = sp;return ($$1|0); //@line 145073 "c/sqlite3.c"
      }
      $25 = $21 | 2; //@line 145023 "c/sqlite3.c"
      $26 = (_sqlite3CreateFunc($0,$1,$2,$25,$4,$5,$6,$7,$8)|0); //@line 145023 "c/sqlite3.c"
      $27 = ($26|0)==(0); //@line 145026 "c/sqlite3.c"
      if ($27) {
       $$197 = 3;
      } else {
       $$1 = $26;
       STACKTOP = sp;return ($$1|0); //@line 145073 "c/sqlite3.c"
      }
      break;
     }
     default: {
      $28 = $3 & 7; //@line 145006 "c/sqlite3.c"
      $$197 = $28;
     }
     }
     $29 = $$197&255; //@line 145040 "c/sqlite3.c"
     $30 = (_sqlite3FindFunction($0,$1,$2,$29,0)|0); //@line 145040 "c/sqlite3.c"
     $31 = ($30|0)==(0|0); //@line 145041 "c/sqlite3.c"
     do {
      if (!($31)) {
       $32 = ((($30)) + 2|0); //@line 145041 "c/sqlite3.c"
       $33 = HEAP16[$32>>1]|0; //@line 145041 "c/sqlite3.c"
       $34 = $33 & 3; //@line 145041 "c/sqlite3.c"
       $35 = $34&65535; //@line 145041 "c/sqlite3.c"
       $36 = ($$197|0)==($35|0); //@line 145041 "c/sqlite3.c"
       if ($36) {
        $37 = HEAP8[$30>>0]|0; //@line 145041 "c/sqlite3.c"
        $38 = $37 << 24 >> 24; //@line 145041 "c/sqlite3.c"
        $39 = ($38|0)==($2|0); //@line 145041 "c/sqlite3.c"
        if ($39) {
         $40 = ((($0)) + 160|0); //@line 145042 "c/sqlite3.c"
         $41 = HEAP32[$40>>2]|0; //@line 145042 "c/sqlite3.c"
         $42 = ($41|0)==(0); //@line 145042 "c/sqlite3.c"
         if ($42) {
          _sqlite3ExpirePreparedStatements($0); //@line 145048 "c/sqlite3.c"
          break;
         }
         _sqlite3ErrorWithMsg($0,5,26440,$vararg_buffer); //@line 145043 "c/sqlite3.c"
         $$1 = 5;
         STACKTOP = sp;return ($$1|0); //@line 145073 "c/sqlite3.c"
        }
       }
      }
     } while(0);
     $43 = (_sqlite3FindFunction($0,$1,$2,$29,1)|0); //@line 145052 "c/sqlite3.c"
     $44 = ($43|0)==(0|0); //@line 145054 "c/sqlite3.c"
     if ($44) {
      $$1 = 7;
      STACKTOP = sp;return ($$1|0); //@line 145073 "c/sqlite3.c"
     }
     _functionDestroy($0,$43); //@line 145060 "c/sqlite3.c"
     $45 = ($8|0)==(0|0); //@line 145062 "c/sqlite3.c"
     if (!($45)) {
      $46 = HEAP32[$8>>2]|0; //@line 145063 "c/sqlite3.c"
      $47 = (($46) + 1)|0; //@line 145063 "c/sqlite3.c"
      HEAP32[$8>>2] = $47; //@line 145063 "c/sqlite3.c"
     }
     $48 = ((($43)) + 24|0); //@line 145065 "c/sqlite3.c"
     HEAP32[$48>>2] = $8; //@line 145065 "c/sqlite3.c"
     $49 = ((($43)) + 2|0); //@line 145066 "c/sqlite3.c"
     $50 = HEAP16[$49>>1]|0; //@line 145066 "c/sqlite3.c"
     $51 = $50 & 3; //@line 145066 "c/sqlite3.c"
     $52 = $51&65535; //@line 145066 "c/sqlite3.c"
     $53 = $21 | $52; //@line 145066 "c/sqlite3.c"
     $54 = $53&65535; //@line 145066 "c/sqlite3.c"
     HEAP16[$49>>1] = $54; //@line 145066 "c/sqlite3.c"
     $55 = $10 ? $5 : $6; //@line 145068 "c/sqlite3.c"
     $56 = ((($43)) + 12|0); //@line 145068 "c/sqlite3.c"
     HEAP32[$56>>2] = $55; //@line 145068 "c/sqlite3.c"
     $57 = ((($43)) + 16|0); //@line 145069 "c/sqlite3.c"
     HEAP32[$57>>2] = $7; //@line 145069 "c/sqlite3.c"
     $58 = ((($43)) + 4|0); //@line 145070 "c/sqlite3.c"
     HEAP32[$58>>2] = $4; //@line 145070 "c/sqlite3.c"
     $59 = $2&255; //@line 145071 "c/sqlite3.c"
     HEAP8[$43>>0] = $59; //@line 145071 "c/sqlite3.c"
     $$1 = 0;
     STACKTOP = sp;return ($$1|0); //@line 145073 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $20 = (_sqlite3MisuseError(145001)|0); //@line 145001 "c/sqlite3.c"
 $$1 = $20;
 STACKTOP = sp;return ($$1|0); //@line 145073 "c/sqlite3.c"
}
function _setLikeOptFlag($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3FindFunction($0,$1,2,1,0)|0); //@line 109197 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 109198 "c/sqlite3.c"
 if ($4) {
  return; //@line 109201 "c/sqlite3.c"
 }
 $5 = $2&255; //@line 109199 "c/sqlite3.c"
 $6 = ((($3)) + 2|0); //@line 109199 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 109199 "c/sqlite3.c"
 $8 = $7&65535; //@line 109199 "c/sqlite3.c"
 $9 = $8 | $5; //@line 109199 "c/sqlite3.c"
 $10 = $9&65535; //@line 109199 "c/sqlite3.c"
 HEAP16[$6>>1] = $10; //@line 109199 "c/sqlite3.c"
 return; //@line 109201 "c/sqlite3.c"
}
function _functionDestroy($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 24|0); //@line 144361 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 144361 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 144362 "c/sqlite3.c"
 if ($4) {
  return; //@line 144369 "c/sqlite3.c"
 }
 $5 = HEAP32[$3>>2]|0; //@line 144363 "c/sqlite3.c"
 $6 = (($5) + -1)|0; //@line 144363 "c/sqlite3.c"
 HEAP32[$3>>2] = $6; //@line 144363 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 144364 "c/sqlite3.c"
 if (!($7)) {
  return; //@line 144369 "c/sqlite3.c"
 }
 $8 = ((($3)) + 4|0); //@line 144365 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 144365 "c/sqlite3.c"
 $10 = ((($3)) + 8|0); //@line 144365 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 144365 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$9 & 127]($11); //@line 144365 "c/sqlite3.c"
 _sqlite3DbFree($0,$3); //@line 144366 "c/sqlite3.c"
 return; //@line 144369 "c/sqlite3.c"
}
function _getTempStore($0) {
 $0 = $0|0;
 var $$ = 0, $$0 = 0, $$off = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 115407 "c/sqlite3.c"
 $$off = (($1) + -48)<<24>>24; //@line 115407 "c/sqlite3.c"
 $2 = ($$off&255)<(3); //@line 115407 "c/sqlite3.c"
 if ($2) {
  $3 = $1 << 24 >> 24; //@line 115407 "c/sqlite3.c"
  $4 = (($3) + -48)|0; //@line 115408 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 115416 "c/sqlite3.c"
 }
 $5 = (_sqlite3StrICmp($0,20392)|0); //@line 115409 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 115409 "c/sqlite3.c"
 if ($6) {
  $$0 = 1;
  return ($$0|0); //@line 115416 "c/sqlite3.c"
 }
 $7 = (_sqlite3StrICmp($0,25402)|0); //@line 115411 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 115411 "c/sqlite3.c"
 $$ = $8 ? 2 : 0; //@line 115412 "c/sqlite3.c"
 $$0 = $$;
 return ($$0|0); //@line 115416 "c/sqlite3.c"
}
function _sqlite3PagerSetSpillsize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 208|0); //@line 51487 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 51487 "c/sqlite3.c"
 $4 = (_sqlite3PcacheSetSpillsize($3,$1)|0); //@line 51487 "c/sqlite3.c"
 return ($4|0); //@line 51487 "c/sqlite3.c"
}
function _sqlite3PcacheSetSpillsize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0); //@line 46000 "c/sqlite3.c"
 if (!($2)) {
  $3 = ($1|0)<(0); //@line 46001 "c/sqlite3.c"
  if ($3) {
   $4 = ($1|0)<(0); //@line 46002 "c/sqlite3.c"
   $5 = $4 << 31 >> 31; //@line 46002 "c/sqlite3.c"
   $6 = (___muldi3(($1|0),($5|0),-1024,-1)|0); //@line 46002 "c/sqlite3.c"
   $7 = tempRet0; //@line 46002 "c/sqlite3.c"
   $8 = ((($0)) + 24|0); //@line 46002 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 46002 "c/sqlite3.c"
   $10 = ((($0)) + 28|0); //@line 46002 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 46002 "c/sqlite3.c"
   $12 = (($11) + ($9))|0; //@line 46002 "c/sqlite3.c"
   $13 = ($12|0)<(0); //@line 46002 "c/sqlite3.c"
   $14 = $13 << 31 >> 31; //@line 46002 "c/sqlite3.c"
   $15 = (___divdi3(($6|0),($7|0),($12|0),($14|0))|0); //@line 46002 "c/sqlite3.c"
   $16 = tempRet0; //@line 46002 "c/sqlite3.c"
   $$012 = $15;
  } else {
   $$012 = $1;
  }
  $17 = ((($0)) + 20|0); //@line 46004 "c/sqlite3.c"
  HEAP32[$17>>2] = $$012; //@line 46004 "c/sqlite3.c"
 }
 $18 = (_numberOfCachePages($0)|0); //@line 46006 "c/sqlite3.c"
 $19 = ((($0)) + 20|0); //@line 46007 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 46007 "c/sqlite3.c"
 $21 = ($18|0)<($20|0); //@line 46007 "c/sqlite3.c"
 $spec$select = $21 ? $20 : $18; //@line 46007 "c/sqlite3.c"
 return ($spec$select|0); //@line 46008 "c/sqlite3.c"
}
function _sqlite3WalLimit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 56984 "c/sqlite3.c"
 if ($3) {
  return; //@line 56985 "c/sqlite3.c"
 }
 $4 = ((($0)) + 16|0); //@line 56984 "c/sqlite3.c"
 $5 = $4; //@line 56984 "c/sqlite3.c"
 $6 = $5; //@line 56984 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 56984 "c/sqlite3.c"
 $7 = (($5) + 4)|0; //@line 56984 "c/sqlite3.c"
 $8 = $7; //@line 56984 "c/sqlite3.c"
 HEAP32[$8>>2] = $2; //@line 56984 "c/sqlite3.c"
 return; //@line 56985 "c/sqlite3.c"
}
function _sqlite3ClearStatTables($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0;
 var $vararg_buffer10 = 0, $vararg_buffer16 = 0, $vararg_buffer19 = 0, $vararg_buffer25 = 0, $vararg_buffer28 = 0, $vararg_buffer7 = 0, $vararg_ptr13 = 0, $vararg_ptr14 = 0, $vararg_ptr15 = 0, $vararg_ptr22 = 0, $vararg_ptr23 = 0, $vararg_ptr24 = 0, $vararg_ptr31 = 0, $vararg_ptr32 = 0, $vararg_ptr33 = 0, $vararg_ptr4 = 0, $vararg_ptr5 = 0, $vararg_ptr6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 128|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(128|0);
 $vararg_buffer28 = sp + 80|0;
 $vararg_buffer25 = sp + 72|0;
 $vararg_buffer19 = sp + 56|0;
 $vararg_buffer16 = sp + 48|0;
 $vararg_buffer10 = sp + 32|0;
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $4 = sp + 96|0;
 $5 = HEAP32[$0>>2]|0; //@line 104044 "c/sqlite3.c"
 $6 = ((($5)) + 16|0); //@line 104044 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 104044 "c/sqlite3.c"
 $8 = (($7) + ($1<<4)|0); //@line 104044 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 104044 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = 1; //@line 104047 "c/sqlite3.c"
 (_sqlite3_snprintf(24,$4,27068,$vararg_buffer)|0); //@line 104047 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 104048 "c/sqlite3.c"
 $11 = (_sqlite3FindTable($10,$4,$9)|0); //@line 104048 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 104048 "c/sqlite3.c"
 if (!($12)) {
  HEAP32[$vararg_buffer1>>2] = $9; //@line 104049 "c/sqlite3.c"
  $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr4>>2] = $4; //@line 104049 "c/sqlite3.c"
  $vararg_ptr5 = ((($vararg_buffer1)) + 8|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr5>>2] = $2; //@line 104049 "c/sqlite3.c"
  $vararg_ptr6 = ((($vararg_buffer1)) + 12|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr6>>2] = $3; //@line 104049 "c/sqlite3.c"
  _sqlite3NestedParse($0,24589,$vararg_buffer1); //@line 104049 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer7>>2] = 2; //@line 104047 "c/sqlite3.c"
 (_sqlite3_snprintf(24,$4,27068,$vararg_buffer7)|0); //@line 104047 "c/sqlite3.c"
 $13 = HEAP32[$0>>2]|0; //@line 104048 "c/sqlite3.c"
 $14 = (_sqlite3FindTable($13,$4,$9)|0); //@line 104048 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 104048 "c/sqlite3.c"
 if (!($15)) {
  HEAP32[$vararg_buffer10>>2] = $9; //@line 104049 "c/sqlite3.c"
  $vararg_ptr13 = ((($vararg_buffer10)) + 4|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr13>>2] = $4; //@line 104049 "c/sqlite3.c"
  $vararg_ptr14 = ((($vararg_buffer10)) + 8|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr14>>2] = $2; //@line 104049 "c/sqlite3.c"
  $vararg_ptr15 = ((($vararg_buffer10)) + 12|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr15>>2] = $3; //@line 104049 "c/sqlite3.c"
  _sqlite3NestedParse($0,24589,$vararg_buffer10); //@line 104049 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer16>>2] = 3; //@line 104047 "c/sqlite3.c"
 (_sqlite3_snprintf(24,$4,27068,$vararg_buffer16)|0); //@line 104047 "c/sqlite3.c"
 $16 = HEAP32[$0>>2]|0; //@line 104048 "c/sqlite3.c"
 $17 = (_sqlite3FindTable($16,$4,$9)|0); //@line 104048 "c/sqlite3.c"
 $18 = ($17|0)==(0|0); //@line 104048 "c/sqlite3.c"
 if (!($18)) {
  HEAP32[$vararg_buffer19>>2] = $9; //@line 104049 "c/sqlite3.c"
  $vararg_ptr22 = ((($vararg_buffer19)) + 4|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr22>>2] = $4; //@line 104049 "c/sqlite3.c"
  $vararg_ptr23 = ((($vararg_buffer19)) + 8|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr23>>2] = $2; //@line 104049 "c/sqlite3.c"
  $vararg_ptr24 = ((($vararg_buffer19)) + 12|0); //@line 104049 "c/sqlite3.c"
  HEAP32[$vararg_ptr24>>2] = $3; //@line 104049 "c/sqlite3.c"
  _sqlite3NestedParse($0,24589,$vararg_buffer19); //@line 104049 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer25>>2] = 4; //@line 104047 "c/sqlite3.c"
 (_sqlite3_snprintf(24,$4,27068,$vararg_buffer25)|0); //@line 104047 "c/sqlite3.c"
 $19 = HEAP32[$0>>2]|0; //@line 104048 "c/sqlite3.c"
 $20 = (_sqlite3FindTable($19,$4,$9)|0); //@line 104048 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 104048 "c/sqlite3.c"
 if ($21) {
  STACKTOP = sp;return; //@line 104055 "c/sqlite3.c"
 }
 HEAP32[$vararg_buffer28>>2] = $9; //@line 104049 "c/sqlite3.c"
 $vararg_ptr31 = ((($vararg_buffer28)) + 4|0); //@line 104049 "c/sqlite3.c"
 HEAP32[$vararg_ptr31>>2] = $4; //@line 104049 "c/sqlite3.c"
 $vararg_ptr32 = ((($vararg_buffer28)) + 8|0); //@line 104049 "c/sqlite3.c"
 HEAP32[$vararg_ptr32>>2] = $2; //@line 104049 "c/sqlite3.c"
 $vararg_ptr33 = ((($vararg_buffer28)) + 12|0); //@line 104049 "c/sqlite3.c"
 HEAP32[$vararg_ptr33>>2] = $3; //@line 104049 "c/sqlite3.c"
 _sqlite3NestedParse($0,24589,$vararg_buffer28); //@line 104049 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 104055 "c/sqlite3.c"
}
function _destroyRootPage($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp; //@line 103959 "c/sqlite3.c"
 $3 = (_sqlite3GetVdbe($0)|0); //@line 103960 "c/sqlite3.c"
 $4 = (_sqlite3GetTempReg($0)|0); //@line 103961 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($3,133,$1,$4,$2)|0); //@line 103963 "c/sqlite3.c"
 _sqlite3MayAbort($0); //@line 103964 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 103977 "c/sqlite3.c"
 $6 = ((($5)) + 16|0); //@line 103977 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 103977 "c/sqlite3.c"
 $8 = (($7) + ($2<<4)|0); //@line 103977 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 103977 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $9; //@line 103975 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 103975 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = 19754; //@line 103975 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 103975 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $1; //@line 103975 "c/sqlite3.c"
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 103975 "c/sqlite3.c"
 HEAP32[$vararg_ptr3>>2] = $4; //@line 103975 "c/sqlite3.c"
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0); //@line 103975 "c/sqlite3.c"
 HEAP32[$vararg_ptr4>>2] = $4; //@line 103975 "c/sqlite3.c"
 _sqlite3NestedParse($0,27012,$vararg_buffer); //@line 103975 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$4); //@line 103979 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 103980 "c/sqlite3.c"
}
function _exprSetHeight($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 93371 "c/sqlite3.c"
 $2 = ((($0)) + 12|0); //@line 93372 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 93372 "c/sqlite3.c"
 _heightOfExpr($3,$1); //@line 93372 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 93373 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 93373 "c/sqlite3.c"
 _heightOfExpr($5,$1); //@line 93373 "c/sqlite3.c"
 $6 = ((($0)) + 4|0); //@line 93374 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 93374 "c/sqlite3.c"
 $8 = $7 & 2048; //@line 93374 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 93374 "c/sqlite3.c"
 $10 = ((($0)) + 20|0);
 if ($9) {
  $12 = HEAP32[$10>>2]|0; //@line 93376 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 93376 "c/sqlite3.c"
  if (!($13)) {
   _heightOfExprList($12,$1); //@line 93377 "c/sqlite3.c"
   $14 = HEAP32[$10>>2]|0; //@line 93378 "c/sqlite3.c"
   $15 = (_sqlite3ExprListFlags($14)|0); //@line 93378 "c/sqlite3.c"
   $16 = $15 & 2097412; //@line 93378 "c/sqlite3.c"
   $17 = HEAP32[$6>>2]|0; //@line 93378 "c/sqlite3.c"
   $18 = $17 | $16; //@line 93378 "c/sqlite3.c"
   HEAP32[$6>>2] = $18; //@line 93378 "c/sqlite3.c"
  }
 } else {
  $11 = HEAP32[$10>>2]|0; //@line 93375 "c/sqlite3.c"
  _heightOfSelect($11,$1); //@line 93375 "c/sqlite3.c"
 }
 $19 = HEAP32[$1>>2]|0; //@line 93380 "c/sqlite3.c"
 $20 = (($19) + 1)|0; //@line 93380 "c/sqlite3.c"
 $21 = ((($0)) + 24|0); //@line 93380 "c/sqlite3.c"
 HEAP32[$21>>2] = $20; //@line 93380 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 93381 "c/sqlite3.c"
}
function _heightOfExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 93334 "c/sqlite3.c"
 if (!($2)) {
  $3 = ((($0)) + 24|0); //@line 93335 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 93335 "c/sqlite3.c"
  $5 = HEAP32[$1>>2]|0; //@line 93335 "c/sqlite3.c"
  $6 = ($4|0)>($5|0); //@line 93335 "c/sqlite3.c"
  if ($6) {
   HEAP32[$1>>2] = $4; //@line 93336 "c/sqlite3.c"
  }
 }
 return; //@line 93339 "c/sqlite3.c"
}
function _heightOfSelect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 93350 "c/sqlite3.c"
 if ($2) {
  return; //@line 93358 "c/sqlite3.c"
 }
 $$016 = $0;
 while(1) {
  $3 = ((($$016)) + 32|0); //@line 93351 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 93351 "c/sqlite3.c"
  _heightOfExpr($4,$1); //@line 93351 "c/sqlite3.c"
  $5 = ((($$016)) + 40|0); //@line 93352 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 93352 "c/sqlite3.c"
  _heightOfExpr($6,$1); //@line 93352 "c/sqlite3.c"
  $7 = ((($$016)) + 56|0); //@line 93353 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 93353 "c/sqlite3.c"
  _heightOfExpr($8,$1); //@line 93353 "c/sqlite3.c"
  $9 = HEAP32[$$016>>2]|0; //@line 93354 "c/sqlite3.c"
  _heightOfExprList($9,$1); //@line 93354 "c/sqlite3.c"
  $10 = ((($$016)) + 36|0); //@line 93355 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 93355 "c/sqlite3.c"
  _heightOfExprList($11,$1); //@line 93355 "c/sqlite3.c"
  $12 = ((($$016)) + 44|0); //@line 93356 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 93356 "c/sqlite3.c"
  _heightOfExprList($13,$1); //@line 93356 "c/sqlite3.c"
  $14 = ((($$016)) + 48|0); //@line 93350 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 93350 "c/sqlite3.c"
  $16 = ($15|0)==(0|0); //@line 93350 "c/sqlite3.c"
  if ($16) {
   break;
  } else {
   $$016 = $15;
  }
 }
 return; //@line 93358 "c/sqlite3.c"
}
function _heightOfExprList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$07 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 93341 "c/sqlite3.c"
 if ($2) {
  return; //@line 93347 "c/sqlite3.c"
 }
 $3 = HEAP32[$0>>2]|0; //@line 93343 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 93343 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 93347 "c/sqlite3.c"
 }
 $$07 = 0;
 while(1) {
  $5 = (((($0)) + 4|0) + (($$07*20)|0)|0); //@line 93344 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 93344 "c/sqlite3.c"
  _heightOfExpr($6,$1); //@line 93344 "c/sqlite3.c"
  $7 = (($$07) + 1)|0; //@line 93343 "c/sqlite3.c"
  $8 = HEAP32[$0>>2]|0; //@line 93343 "c/sqlite3.c"
  $9 = ($7|0)<($8|0); //@line 93343 "c/sqlite3.c"
  if ($9) {
   $$07 = $7;
  } else {
   break;
  }
 }
 return; //@line 93347 "c/sqlite3.c"
}
function _sqlite3ExprListFlags($0) {
 $0 = $0|0;
 var $$012$lcssa = 0, $$01213 = 0, $$014 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 94401 "c/sqlite3.c"
 $2 = ($1|0)>(0); //@line 94401 "c/sqlite3.c"
 if (!($2)) {
  $$012$lcssa = 0;
  return ($$012$lcssa|0); //@line 94406 "c/sqlite3.c"
 }
 $3 = HEAP32[$0>>2]|0;
 $$01213 = 0;$$014 = 0;
 while(1) {
  $4 = (((($0)) + 4|0) + (($$014*20)|0)|0); //@line 94402 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 94402 "c/sqlite3.c"
  $6 = ((($5)) + 4|0); //@line 94404 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 94404 "c/sqlite3.c"
  $8 = $7 | $$01213; //@line 94404 "c/sqlite3.c"
  $9 = (($$014) + 1)|0; //@line 94401 "c/sqlite3.c"
  $10 = ($9|0)<($3|0); //@line 94401 "c/sqlite3.c"
  if ($10) {
   $$01213 = $8;$$014 = $9;
  } else {
   $$012$lcssa = $8;
   break;
  }
 }
 return ($$012$lcssa|0); //@line 94406 "c/sqlite3.c"
}
function _sqlite3VListNameToNum($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$023 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 30073 "c/sqlite3.c"
 if ($3) {
  $$2 = 0;
  return ($$2|0); //@line 30082 "c/sqlite3.c"
 }
 $4 = ((($0)) + 4|0); //@line 30074 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 30074 "c/sqlite3.c"
 $$023 = 2;
 while(1) {
  $6 = (($$023) + 2)|0; //@line 30077 "c/sqlite3.c"
  $7 = (($0) + ($6<<2)|0); //@line 30077 "c/sqlite3.c"
  $8 = (_strncmp($7,$1,$2)|0); //@line 30078 "c/sqlite3.c"
  $9 = ($8|0)==(0); //@line 30078 "c/sqlite3.c"
  if ($9) {
   $10 = (($7) + ($2)|0); //@line 30078 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 30078 "c/sqlite3.c"
   $12 = ($11<<24>>24)==(0); //@line 30078 "c/sqlite3.c"
   if ($12) {
    break;
   }
  }
  $15 = (($$023) + 1)|0; //@line 30079 "c/sqlite3.c"
  $16 = (($0) + ($15<<2)|0); //@line 30079 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 30079 "c/sqlite3.c"
  $18 = (($17) + ($$023))|0; //@line 30079 "c/sqlite3.c"
  $19 = ($18|0)<($5|0); //@line 30080 "c/sqlite3.c"
  if ($19) {
   $$023 = $18;
  } else {
   $$2 = 0;
   label = 7;
   break;
  }
 }
 if ((label|0) == 7) {
  return ($$2|0); //@line 30082 "c/sqlite3.c"
 }
 $13 = (($0) + ($$023<<2)|0); //@line 30078 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 30078 "c/sqlite3.c"
 $$2 = $14;
 return ($$2|0); //@line 30082 "c/sqlite3.c"
}
function _sqlite3VListAdd($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$1 = 0, $$147 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (($3|0) / 4)&-1; //@line 30028 "c/sqlite3.c"
 $6 = (($5) + 3)|0; //@line 30028 "c/sqlite3.c"
 $7 = ($1|0)==(0|0); //@line 30030 "c/sqlite3.c"
 if ($7) {
  $16 = 10;
  label = 4;
 } else {
  $8 = ((($1)) + 4|0); //@line 30030 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 30030 "c/sqlite3.c"
  $10 = (($9) + ($6))|0; //@line 30030 "c/sqlite3.c"
  $11 = HEAP32[$1>>2]|0; //@line 30030 "c/sqlite3.c"
  $12 = ($10|0)>($11|0); //@line 30030 "c/sqlite3.c"
  if ($12) {
   $13 = HEAP32[$1>>2]|0; //@line 30032 "c/sqlite3.c"
   $14 = $13 << 1; //@line 30032 "c/sqlite3.c"
   $16 = $14;
   label = 4;
  } else {
   $$147 = $1;
  }
 }
 if ((label|0) == 4) {
  $15 = (($16) + ($6))|0; //@line 30032 "c/sqlite3.c"
  $17 = $15 << 2; //@line 30033 "c/sqlite3.c"
  $18 = (_sqlite3DbRealloc($0,$1,$17,0)|0); //@line 30033 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 30034 "c/sqlite3.c"
  if ($19) {
   $$1 = $1;
   return ($$1|0); //@line 30048 "c/sqlite3.c"
  }
  if ($7) {
   $20 = ((($18)) + 4|0); //@line 30035 "c/sqlite3.c"
   HEAP32[$20>>2] = 2; //@line 30035 "c/sqlite3.c"
  }
  HEAP32[$18>>2] = $15; //@line 30037 "c/sqlite3.c"
  $$147 = $18;
 }
 $21 = ((($$147)) + 4|0); //@line 30039 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 30039 "c/sqlite3.c"
 $23 = (($$147) + ($22<<2)|0); //@line 30040 "c/sqlite3.c"
 HEAP32[$23>>2] = $4; //@line 30040 "c/sqlite3.c"
 $24 = (($22) + 1)|0; //@line 30041 "c/sqlite3.c"
 $25 = (($$147) + ($24<<2)|0); //@line 30041 "c/sqlite3.c"
 HEAP32[$25>>2] = $6; //@line 30041 "c/sqlite3.c"
 $26 = (($22) + 2)|0; //@line 30042 "c/sqlite3.c"
 $27 = (($$147) + ($26<<2)|0); //@line 30042 "c/sqlite3.c"
 $28 = (($22) + ($6))|0; //@line 30043 "c/sqlite3.c"
 HEAP32[$21>>2] = $28; //@line 30043 "c/sqlite3.c"
 _memcpy(($27|0),($2|0),($3|0))|0; //@line 30045 "c/sqlite3.c"
 $29 = (($27) + ($3)|0); //@line 30046 "c/sqlite3.c"
 HEAP8[$29>>0] = 0; //@line 30046 "c/sqlite3.c"
 $$1 = $$147;
 return ($$1|0); //@line 30048 "c/sqlite3.c"
}
function _sqlite3ArrayAllocate($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$1 = 0, $$132 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$3>>2]|0; //@line 105195 "c/sqlite3.c"
 $6 = (($5) + -1)|0; //@line 105196 "c/sqlite3.c"
 $7 = $6 & $5; //@line 105196 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 105196 "c/sqlite3.c"
 if ($8) {
  $9 = ($5|0)==(0); //@line 105197 "c/sqlite3.c"
  $10 = $5 << 1; //@line 105197 "c/sqlite3.c"
  $11 = $9 ? 1 : $10; //@line 105197 "c/sqlite3.c"
  $12 = Math_imul($11, $2)|0; //@line 105198 "c/sqlite3.c"
  $13 = ($12|0)<(0); //@line 105198 "c/sqlite3.c"
  $14 = $13 << 31 >> 31; //@line 105198 "c/sqlite3.c"
  $15 = (_sqlite3DbRealloc($0,$1,$12,$14)|0); //@line 105198 "c/sqlite3.c"
  $16 = ($15|0)==(0|0); //@line 105199 "c/sqlite3.c"
  if ($16) {
   HEAP32[$4>>2] = -1; //@line 105200 "c/sqlite3.c"
   $$1 = $1;
   return ($$1|0); //@line 105210 "c/sqlite3.c"
  } else {
   $$132 = $15;
  }
 } else {
  $$132 = $1;
 }
 $17 = Math_imul($5, $2)|0; //@line 105206 "c/sqlite3.c"
 $18 = (($$132) + ($17)|0); //@line 105206 "c/sqlite3.c"
 _memset(($18|0),0,($2|0))|0; //@line 105206 "c/sqlite3.c"
 HEAP32[$4>>2] = $5; //@line 105207 "c/sqlite3.c"
 $19 = HEAP32[$3>>2]|0; //@line 105208 "c/sqlite3.c"
 $20 = (($19) + 1)|0; //@line 105208 "c/sqlite3.c"
 HEAP32[$3>>2] = $20; //@line 105208 "c/sqlite3.c"
 $$1 = $$132;
 return ($$1|0); //@line 105210 "c/sqlite3.c"
}
function _sqlite3TriggersExist($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$02125 = 0, $$022$lcssa = 0, $$02223 = 0, $$024 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$0>>2]|0; //@line 125592 "c/sqlite3.c"
 $6 = ((($5)) + 28|0); //@line 125592 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 125592 "c/sqlite3.c"
 $8 = $7 & 262144; //@line 125592 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 125592 "c/sqlite3.c"
 if ($9) {
  $$02125 = 0;$$022$lcssa = 0;
 } else {
  $10 = (_sqlite3TriggerList($0,$1)|0); //@line 125593 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 125596 "c/sqlite3.c"
  if ($11) {
   $$02125 = 0;$$022$lcssa = 0;
  } else {
   $$02223 = 0;$$024 = $10;
   while(1) {
    $12 = ((($$024)) + 8|0); //@line 125597 "c/sqlite3.c"
    $13 = HEAP8[$12>>0]|0; //@line 125597 "c/sqlite3.c"
    $14 = $13&255; //@line 125597 "c/sqlite3.c"
    $15 = ($14|0)==($2|0); //@line 125597 "c/sqlite3.c"
    if ($15) {
     $16 = ((($$024)) + 16|0); //@line 125597 "c/sqlite3.c"
     $17 = HEAP32[$16>>2]|0; //@line 125597 "c/sqlite3.c"
     $18 = (_checkColumnOverlap($17,$3)|0); //@line 125597 "c/sqlite3.c"
     $19 = ($18|0)==(0); //@line 125597 "c/sqlite3.c"
     if ($19) {
      $$1 = $$02223;
     } else {
      $20 = ((($$024)) + 9|0); //@line 125598 "c/sqlite3.c"
      $21 = HEAP8[$20>>0]|0; //@line 125598 "c/sqlite3.c"
      $22 = $21&255; //@line 125598 "c/sqlite3.c"
      $23 = $$02223 | $22; //@line 125598 "c/sqlite3.c"
      $$1 = $23;
     }
    } else {
     $$1 = $$02223;
    }
    $24 = ((($$024)) + 32|0); //@line 125596 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 125596 "c/sqlite3.c"
    $26 = ($25|0)==(0|0); //@line 125596 "c/sqlite3.c"
    if ($26) {
     $$02125 = $10;$$022$lcssa = $$1;
     break;
    } else {
     $$02223 = $$1;$$024 = $25;
    }
   }
  }
 }
 $27 = ($4|0)==(0|0); //@line 125601 "c/sqlite3.c"
 if ($27) {
  $28 = ($$022$lcssa|0)==(0); //@line 125604 "c/sqlite3.c"
  $29 = $28 ? 0 : $$02125; //@line 125604 "c/sqlite3.c"
  return ($29|0); //@line 125604 "c/sqlite3.c"
 }
 HEAP32[$4>>2] = $$022$lcssa; //@line 125602 "c/sqlite3.c"
 $28 = ($$022$lcssa|0)==(0); //@line 125604 "c/sqlite3.c"
 $29 = $28 ? 0 : $$02125; //@line 125604 "c/sqlite3.c"
 return ($29|0); //@line 125604 "c/sqlite3.c"
}
function _sqlite3IsReadOnly($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 106619 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 106619 "c/sqlite3.c"
 $3 = ((($1)) + 56|0); //@line 106630 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 106630 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 106630 "c/sqlite3.c"
 if ($5) {
  label = 3;
 } else {
  $6 = HEAP32[$0>>2]|0; //@line 106631 "c/sqlite3.c"
  $7 = (_sqlite3GetVTable($6,$1)|0); //@line 106631 "c/sqlite3.c"
  $8 = ((($7)) + 4|0); //@line 106631 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 106631 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 106631 "c/sqlite3.c"
  $11 = ((($10)) + 52|0); //@line 106631 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 106631 "c/sqlite3.c"
  $13 = ($12|0)==(0|0); //@line 106631 "c/sqlite3.c"
  if (!($13)) {
   label = 3;
  }
 }
 do {
  if ((label|0) == 3) {
   $14 = ((($1)) + 36|0); //@line 106632 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 106632 "c/sqlite3.c"
   $16 = $15 & 1; //@line 106632 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 106632 "c/sqlite3.c"
   if (!($17)) {
    $18 = HEAP32[$0>>2]|0; //@line 106633 "c/sqlite3.c"
    $19 = ((($18)) + 28|0); //@line 106633 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 106633 "c/sqlite3.c"
    $21 = $20 & 1; //@line 106633 "c/sqlite3.c"
    $22 = ($21|0)==(0); //@line 106633 "c/sqlite3.c"
    if ($22) {
     $23 = ((($0)) + 18|0); //@line 106634 "c/sqlite3.c"
     $24 = HEAP8[$23>>0]|0; //@line 106634 "c/sqlite3.c"
     $25 = ($24<<24>>24)==(0); //@line 106634 "c/sqlite3.c"
     if ($25) {
      break;
     }
    }
   }
   $27 = ($2|0)==(0); //@line 106641 "c/sqlite3.c"
   if (!($27)) {
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 106647 "c/sqlite3.c"
   }
   $28 = ((($1)) + 12|0); //@line 106641 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 106641 "c/sqlite3.c"
   $30 = ($29|0)==(0|0); //@line 106641 "c/sqlite3.c"
   if ($30) {
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 106647 "c/sqlite3.c"
   }
   $31 = HEAP32[$1>>2]|0; //@line 106642 "c/sqlite3.c"
   HEAP32[$vararg_buffer1>>2] = $31; //@line 106642 "c/sqlite3.c"
   _sqlite3ErrorMsg($0,28032,$vararg_buffer1); //@line 106642 "c/sqlite3.c"
   $$0 = 1;
   STACKTOP = sp;return ($$0|0); //@line 106647 "c/sqlite3.c"
  }
 } while(0);
 $26 = HEAP32[$1>>2]|0; //@line 106636 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $26; //@line 106636 "c/sqlite3.c"
 _sqlite3ErrorMsg($0,28003,$vararg_buffer); //@line 106636 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 106647 "c/sqlite3.c"
}
function _sqlite3VdbeCountChanges($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 145|0); //@line 77502 "c/sqlite3.c"
 $2 = HEAPU8[$1>>0]|(HEAPU8[$1+1>>0]<<8); //@line 77502 "c/sqlite3.c"
 $3 = $2 | 16; //@line 77502 "c/sqlite3.c"
 HEAP8[$1>>0]=$3&255;HEAP8[$1+1>>0]=$3>>8; //@line 77502 "c/sqlite3.c"
 return; //@line 77503 "c/sqlite3.c"
}
function _xferOptimization($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0272 = 0, $$0274 = 0, $$0277 = 0, $$0277324 = 0, $$0277326 = 0, $$0281 = 0, $$0281330 = 0, $$0281332 = 0, $$0283337 = 0, $$0285$lcssa = 0, $$0285331 = 0, $$0287 = 0, $$0288 = 0, $$0289 = 0, $$1273 = 0, $$1276 = 0, $$1278 = 0, $$1278$lcssa = 0, $$1278304 = 0, $$1278305 = 0;
 var $$1282 = 0, $$1282318 = 0, $$1282319 = 0, $$1284$lcssa = 0, $$1284308 = 0, $$2 = 0, $$lcssa = 0, $$old = 0, $$old1 = 0, $$old292 = 0, $$old299 = 0, $$old300 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0;
 var $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0;
 var $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0;
 var $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0;
 var $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0;
 var $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0;
 var $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0;
 var $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0;
 var $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0;
 var $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0, $cond325 = 0, $or$cond = 0, $or$cond293 = 0, $or$cond295 = 0, $or$cond298 = 0, $or$cond301 = 0, $spec$select291 = 0, $spec$select296 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$0>>2]|0; //@line 112791 "c/sqlite3.c"
 $6 = ($2|0)==(0|0); //@line 112807 "c/sqlite3.c"
 if ($6) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $7 = ((($0)) + 464|0); //@line 112810 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 112810 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 112810 "c/sqlite3.c"
 if (!($9)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $10 = ((($2)) + 60|0); //@line 112810 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 112810 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 112810 "c/sqlite3.c"
 if (!($12)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $13 = (_sqlite3TriggerList($0,$1)|0); //@line 112816 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 112816 "c/sqlite3.c"
 if (!($14)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $15 = ((($1)) + 56|0); //@line 112820 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 112820 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 112820 "c/sqlite3.c"
 if (!($17)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $18 = ($3|0)==(10); //@line 112824 "c/sqlite3.c"
 do {
  if ($18) {
   $19 = ((($1)) + 40|0); //@line 112825 "c/sqlite3.c"
   $20 = HEAP16[$19>>1]|0; //@line 112825 "c/sqlite3.c"
   $21 = ($20<<16>>16)>(-1); //@line 112825 "c/sqlite3.c"
   if ($21) {
    $22 = ((($1)) + 48|0); //@line 112825 "c/sqlite3.c"
    $23 = HEAP8[$22>>0]|0; //@line 112825 "c/sqlite3.c"
    $24 = $23&255; //@line 112825 "c/sqlite3.c"
    $25 = ($23<<24>>24)==(10); //@line 112826 "c/sqlite3.c"
    if (!($25)) {
     $$1276 = $24;
     break;
    }
   }
   $$1276 = 2;
  } else {
   $$1276 = $3;
  }
 } while(0);
 $26 = ((($2)) + 28|0); //@line 112829 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 112829 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 112829 "c/sqlite3.c"
 $29 = ($28|0)==(1); //@line 112829 "c/sqlite3.c"
 if (!($29)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $30 = ((($27)) + 8|0); //@line 112832 "c/sqlite3.c"
 $31 = ((($27)) + 28|0); //@line 112832 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 112832 "c/sqlite3.c"
 $33 = ($32|0)==(0|0); //@line 112832 "c/sqlite3.c"
 if (!($33)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $34 = ((($2)) + 32|0); //@line 112835 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 112835 "c/sqlite3.c"
 $36 = ($35|0)==(0|0); //@line 112835 "c/sqlite3.c"
 if (!($36)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $37 = ((($2)) + 44|0); //@line 112838 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 112838 "c/sqlite3.c"
 $39 = ($38|0)==(0|0); //@line 112838 "c/sqlite3.c"
 if (!($39)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $40 = ((($2)) + 36|0); //@line 112843 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 112843 "c/sqlite3.c"
 $42 = ($41|0)==(0|0); //@line 112843 "c/sqlite3.c"
 if (!($42)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $43 = ((($2)) + 56|0); //@line 112846 "c/sqlite3.c"
 $44 = HEAP32[$43>>2]|0; //@line 112846 "c/sqlite3.c"
 $45 = ($44|0)==(0|0); //@line 112846 "c/sqlite3.c"
 if (!($45)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $46 = ((($2)) + 48|0); //@line 112849 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 112849 "c/sqlite3.c"
 $48 = ($47|0)==(0|0); //@line 112849 "c/sqlite3.c"
 if (!($48)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $49 = ((($2)) + 8|0); //@line 112852 "c/sqlite3.c"
 $50 = HEAP32[$49>>2]|0; //@line 112852 "c/sqlite3.c"
 $51 = $50 & 1; //@line 112852 "c/sqlite3.c"
 $52 = ($51|0)==(0); //@line 112852 "c/sqlite3.c"
 if (!($52)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $53 = HEAP32[$2>>2]|0; //@line 112855 "c/sqlite3.c"
 $54 = HEAP32[$53>>2]|0; //@line 112857 "c/sqlite3.c"
 $55 = ($54|0)==(1); //@line 112857 "c/sqlite3.c"
 if (!($55)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $56 = ((($53)) + 4|0); //@line 112861 "c/sqlite3.c"
 $57 = HEAP32[$56>>2]|0; //@line 112861 "c/sqlite3.c"
 $58 = HEAP8[$57>>0]|0; //@line 112861 "c/sqlite3.c"
 $59 = ($58<<24>>24)==(-102); //@line 112861 "c/sqlite3.c"
 if (!($59)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $60 = (_sqlite3LocateTableItem($0,0,$30)|0); //@line 112870 "c/sqlite3.c"
 $61 = ($60|0)==(0|0); //@line 112871 "c/sqlite3.c"
 $62 = ($60|0)==($1|0); //@line 112874 "c/sqlite3.c"
 $or$cond298 = $61 | $62; //@line 112871 "c/sqlite3.c"
 if ($or$cond298) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $63 = ((($1)) + 36|0); //@line 112877 "c/sqlite3.c"
 $64 = HEAP32[$63>>2]|0; //@line 112877 "c/sqlite3.c"
 $65 = ((($60)) + 36|0); //@line 112877 "c/sqlite3.c"
 $66 = HEAP32[$65>>2]|0; //@line 112877 "c/sqlite3.c"
 $67 = $66 ^ $64; //@line 112877 "c/sqlite3.c"
 $68 = $67 & 32; //@line 112877 "c/sqlite3.c"
 $69 = ($68|0)==(0); //@line 112877 "c/sqlite3.c"
 if (!($69)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $70 = ((($60)) + 56|0); //@line 112881 "c/sqlite3.c"
 $71 = HEAP32[$70>>2]|0; //@line 112881 "c/sqlite3.c"
 $72 = ($71|0)==(0); //@line 112881 "c/sqlite3.c"
 if (!($72)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $73 = ((($60)) + 12|0); //@line 112885 "c/sqlite3.c"
 $74 = HEAP32[$73>>2]|0; //@line 112885 "c/sqlite3.c"
 $75 = ($74|0)==(0|0); //@line 112885 "c/sqlite3.c"
 if (!($75)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $76 = ((($1)) + 42|0); //@line 112888 "c/sqlite3.c"
 $77 = HEAP16[$76>>1]|0; //@line 112888 "c/sqlite3.c"
 $78 = ((($60)) + 42|0); //@line 112888 "c/sqlite3.c"
 $79 = HEAP16[$78>>1]|0; //@line 112888 "c/sqlite3.c"
 $80 = ($77<<16>>16)==($79<<16>>16); //@line 112888 "c/sqlite3.c"
 if (!($80)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $81 = ((($1)) + 40|0); //@line 112891 "c/sqlite3.c"
 $82 = HEAP16[$81>>1]|0; //@line 112891 "c/sqlite3.c"
 $83 = ((($60)) + 40|0); //@line 112891 "c/sqlite3.c"
 $84 = HEAP16[$83>>1]|0; //@line 112891 "c/sqlite3.c"
 $85 = ($82<<16>>16)==($84<<16>>16); //@line 112891 "c/sqlite3.c"
 if (!($85)) {
  $$2 = 0;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 $86 = $77 << 16 >> 16; //@line 112894 "c/sqlite3.c"
 $87 = ($77<<16>>16)>(0); //@line 112894 "c/sqlite3.c"
 L70: do {
  if ($87) {
   $88 = ((($1)) + 4|0);
   $89 = HEAP32[$88>>2]|0;
   $90 = ((($60)) + 4|0);
   $91 = HEAP32[$90>>2]|0;
   $$0283337 = 0;
   L72: while(1) {
    $92 = (((($89) + ($$0283337<<4)|0)) + 13|0); //@line 112904 "c/sqlite3.c"
    $93 = HEAP8[$92>>0]|0; //@line 112904 "c/sqlite3.c"
    $94 = (((($91) + ($$0283337<<4)|0)) + 13|0); //@line 112904 "c/sqlite3.c"
    $95 = HEAP8[$94>>0]|0; //@line 112904 "c/sqlite3.c"
    $96 = ($93<<24>>24)==($95<<24>>24); //@line 112904 "c/sqlite3.c"
    if (!($96)) {
     $$2 = 0;
     label = 85;
     break;
    }
    $97 = (((($89) + ($$0283337<<4)|0)) + 8|0); //@line 112907 "c/sqlite3.c"
    $98 = HEAP32[$97>>2]|0; //@line 112907 "c/sqlite3.c"
    $99 = (((($91) + ($$0283337<<4)|0)) + 8|0); //@line 112907 "c/sqlite3.c"
    $100 = HEAP32[$99>>2]|0; //@line 112907 "c/sqlite3.c"
    $101 = (_sqlite3_stricmp($98,$100)|0); //@line 112907 "c/sqlite3.c"
    $102 = ($101|0)==(0); //@line 112907 "c/sqlite3.c"
    if (!($102)) {
     $$2 = 0;
     label = 85;
     break;
    }
    $103 = (((($89) + ($$0283337<<4)|0)) + 12|0); //@line 112910 "c/sqlite3.c"
    $104 = HEAP8[$103>>0]|0; //@line 112910 "c/sqlite3.c"
    $105 = ($104<<24>>24)==(0); //@line 112910 "c/sqlite3.c"
    if (!($105)) {
     $106 = (((($91) + ($$0283337<<4)|0)) + 12|0); //@line 112910 "c/sqlite3.c"
     $107 = HEAP8[$106>>0]|0; //@line 112910 "c/sqlite3.c"
     $108 = ($107<<24>>24)==(0); //@line 112910 "c/sqlite3.c"
     if ($108) {
      $$2 = 0;
      label = 85;
      break;
     }
    }
    $109 = ($$0283337|0)==(0); //@line 112914 "c/sqlite3.c"
    do {
     if (!($109)) {
      $110 = (((($89) + ($$0283337<<4)|0)) + 4|0); //@line 112917 "c/sqlite3.c"
      $111 = HEAP32[$110>>2]|0; //@line 112917 "c/sqlite3.c"
      $112 = ($111|0)==(0|0); //@line 112917 "c/sqlite3.c"
      $113 = (((($91) + ($$0283337<<4)|0)) + 4|0); //@line 112917 "c/sqlite3.c"
      $114 = HEAP32[$113>>2]|0; //@line 112917 "c/sqlite3.c"
      $115 = ($114|0)==(0|0); //@line 112917 "c/sqlite3.c"
      $116 = $112 ^ $115; //@line 112917 "c/sqlite3.c"
      if ($116) {
       $$2 = 0;
       label = 85;
       break L72;
      }
      if ($112) {
       break;
      }
      $117 = ((($111)) + 8|0); //@line 112918 "c/sqlite3.c"
      $118 = HEAP32[$117>>2]|0; //@line 112918 "c/sqlite3.c"
      $119 = ((($114)) + 8|0); //@line 112919 "c/sqlite3.c"
      $120 = HEAP32[$119>>2]|0; //@line 112919 "c/sqlite3.c"
      $121 = (_strcmp($118,$120)|0); //@line 112918 "c/sqlite3.c"
      $122 = ($121|0)==(0); //@line 112919 "c/sqlite3.c"
      if (!($122)) {
       $$2 = 0;
       label = 85;
       break L72;
      }
     }
    } while(0);
    $123 = (($$0283337) + 1)|0; //@line 112894 "c/sqlite3.c"
    $124 = ($123|0)<($86|0); //@line 112894 "c/sqlite3.c"
    if ($124) {
     $$0283337 = $123;
    } else {
     break L70;
    }
   }
   if ((label|0) == 85) {
    return ($$2|0); //@line 113096 "c/sqlite3.c"
   }
  }
 } while(0);
 $125 = ((($1)) + 8|0); //@line 112925 "c/sqlite3.c"
 $$0281330 = HEAP32[$125>>2]|0;
 $126 = ($$0281330|0)==(0|0); //@line 112925 "c/sqlite3.c"
 L91: do {
  if ($126) {
   $$0285$lcssa = 0;
  } else {
   $127 = ((($60)) + 8|0);
   $$0281332 = $$0281330;$$0285331 = 0;
   L93: while(1) {
    $128 = ((($$0281332)) + 54|0); //@line 112926 "c/sqlite3.c"
    $129 = HEAP8[$128>>0]|0; //@line 112926 "c/sqlite3.c"
    $130 = ($129<<24>>24)==(0); //@line 112926 "c/sqlite3.c"
    $spec$select291 = $130 ? $$0285331 : 1; //@line 112926 "c/sqlite3.c"
    $$0277324 = HEAP32[$127>>2]|0;
    $cond325 = ($$0277324|0)==(0|0); //@line 112929 "c/sqlite3.c"
    if ($cond325) {
     $$2 = 0;
     label = 85;
     break;
    }
    $$0277326 = $$0277324;
    while(1) {
     $132 = (_xferCompatibleIndex($$0281332,$$0277326)|0); //@line 112930 "c/sqlite3.c"
     $133 = ($132|0)==(0); //@line 112930 "c/sqlite3.c"
     if (!($133)) {
      break;
     }
     $131 = ((($$0277326)) + 20|0); //@line 112929 "c/sqlite3.c"
     $$0277 = HEAP32[$131>>2]|0;
     $cond = ($$0277|0)==(0|0); //@line 112929 "c/sqlite3.c"
     if ($cond) {
      $$2 = 0;
      label = 85;
      break L93;
     } else {
      $$0277326 = $$0277;
     }
    }
    $134 = ((($$0281332)) + 20|0); //@line 112925 "c/sqlite3.c"
    $$0281 = HEAP32[$134>>2]|0;
    $135 = ($$0281|0)==(0|0); //@line 112925 "c/sqlite3.c"
    if ($135) {
     $$0285$lcssa = $spec$select291;
     break L91;
    } else {
     $$0281332 = $$0281;$$0285331 = $spec$select291;
    }
   }
   if ((label|0) == 85) {
    return ($$2|0); //@line 113096 "c/sqlite3.c"
   }
  }
 } while(0);
 $136 = ((($1)) + 24|0); //@line 112937 "c/sqlite3.c"
 $137 = HEAP32[$136>>2]|0; //@line 112937 "c/sqlite3.c"
 $138 = ($137|0)==(0|0); //@line 112937 "c/sqlite3.c"
 do {
  if (!($138)) {
   $139 = ((($60)) + 24|0); //@line 112937 "c/sqlite3.c"
   $140 = HEAP32[$139>>2]|0; //@line 112937 "c/sqlite3.c"
   $141 = (_sqlite3ExprListCompare($140,$137,-1)|0); //@line 112937 "c/sqlite3.c"
   $142 = ($141|0)==(0); //@line 112937 "c/sqlite3.c"
   if ($142) {
    break;
   } else {
    $$2 = 0;
   }
   return ($$2|0); //@line 113096 "c/sqlite3.c"
  }
 } while(0);
 $143 = ((($5)) + 28|0); //@line 112949 "c/sqlite3.c"
 $144 = HEAP32[$143>>2]|0; //@line 112949 "c/sqlite3.c"
 $145 = $144 & 16384; //@line 112949 "c/sqlite3.c"
 $146 = ($145|0)==(0); //@line 112949 "c/sqlite3.c"
 do {
  if ($146) {
   $$old299 = $144 & 128; //@line 112953 "c/sqlite3.c"
   $$old300 = ($$old299|0)==(0); //@line 112953 "c/sqlite3.c"
   if ($$old300) {
    break;
   } else {
    $$2 = 0;
   }
   return ($$2|0); //@line 113096 "c/sqlite3.c"
  } else {
   $147 = ((($1)) + 16|0); //@line 112949 "c/sqlite3.c"
   $148 = HEAP32[$147>>2]|0; //@line 112949 "c/sqlite3.c"
   $149 = ($148|0)==(0|0); //@line 112949 "c/sqlite3.c"
   $150 = $144 & 128; //@line 112953 "c/sqlite3.c"
   $151 = ($150|0)==(0); //@line 112953 "c/sqlite3.c"
   $or$cond301 = $151 & $149; //@line 112949 "c/sqlite3.c"
   if ($or$cond301) {
    break;
   } else {
    $$2 = 0;
   }
   return ($$2|0); //@line 113096 "c/sqlite3.c"
  }
 } while(0);
 $152 = ((($60)) + 72|0); //@line 112964 "c/sqlite3.c"
 $153 = HEAP32[$152>>2]|0; //@line 112964 "c/sqlite3.c"
 $154 = (_sqlite3SchemaToIndex($5,$153)|0); //@line 112964 "c/sqlite3.c"
 $155 = (_sqlite3GetVdbe($0)|0); //@line 112965 "c/sqlite3.c"
 _sqlite3CodeVerifySchema($0,$154); //@line 112966 "c/sqlite3.c"
 $156 = ((($0)) + 40|0); //@line 112967 "c/sqlite3.c"
 $157 = HEAP32[$156>>2]|0; //@line 112967 "c/sqlite3.c"
 $158 = (($157) + 1)|0; //@line 112967 "c/sqlite3.c"
 $159 = (($157) + 2)|0; //@line 112968 "c/sqlite3.c"
 HEAP32[$156>>2] = $159; //@line 112968 "c/sqlite3.c"
 $160 = (_autoIncBegin($0,$4,$1)|0); //@line 112969 "c/sqlite3.c"
 $161 = (_sqlite3GetTempReg($0)|0); //@line 112970 "c/sqlite3.c"
 $162 = (_sqlite3GetTempReg($0)|0); //@line 112971 "c/sqlite3.c"
 _sqlite3OpenTable($0,$158,$4,$1,106); //@line 112972 "c/sqlite3.c"
 $163 = ((($5)) + 24|0); //@line 112974 "c/sqlite3.c"
 $164 = HEAP32[$163>>2]|0; //@line 112974 "c/sqlite3.c"
 $165 = $164 & 4; //@line 112974 "c/sqlite3.c"
 $166 = ($165|0)==(0); //@line 112974 "c/sqlite3.c"
 do {
  if ($166) {
   $167 = HEAP16[$81>>1]|0; //@line 112975 "c/sqlite3.c"
   $168 = ($167<<16>>16)<(0); //@line 112975 "c/sqlite3.c"
   if ($168) {
    $169 = HEAP32[$125>>2]|0; //@line 112975 "c/sqlite3.c"
    $170 = ($169|0)!=(0|0); //@line 112975 "c/sqlite3.c"
    $171 = ($$0285$lcssa|0)!=(0); //@line 112976 "c/sqlite3.c"
    $or$cond = $171 | $170; //@line 112976 "c/sqlite3.c"
    $$old = (($$1276) + -1)|0; //@line 112977 "c/sqlite3.c"
    $$old292 = ($$old>>>0)>(1); //@line 112977 "c/sqlite3.c"
    $or$cond295 = $$old292 | $or$cond; //@line 112976 "c/sqlite3.c"
    if (!($or$cond295)) {
     $$0288 = 0;
     break;
    }
   } else {
    $$old1 = ($$0285$lcssa|0)!=(0); //@line 112976 "c/sqlite3.c"
    $172 = (($$1276) + -1)|0; //@line 112977 "c/sqlite3.c"
    $173 = ($172>>>0)>(1); //@line 112977 "c/sqlite3.c"
    $or$cond293 = $173 | $$old1; //@line 112977 "c/sqlite3.c"
    if (!($or$cond293)) {
     $$0288 = 0;
     break;
    }
   }
   $174 = (_sqlite3VdbeAddOp2($155,37,$158,0)|0); //@line 112996 "c/sqlite3.c"
   $175 = (_sqlite3VdbeAddOp0($155,13)|0); //@line 112997 "c/sqlite3.c"
   _sqlite3VdbeJumpHere($155,$174); //@line 112998 "c/sqlite3.c"
   $$0288 = $175;
  } else {
   $$0288 = 0;
  }
 } while(0);
 $176 = HEAP32[$65>>2]|0; //@line 113000 "c/sqlite3.c"
 $177 = $176 & 32; //@line 113000 "c/sqlite3.c"
 $178 = ($177|0)==(0); //@line 113000 "c/sqlite3.c"
 if ($178) {
  _sqlite3OpenTable($0,$157,$154,$60,105); //@line 113002 "c/sqlite3.c"
  $179 = (_sqlite3VdbeAddOp2($155,37,$157,0)|0); //@line 113003 "c/sqlite3.c"
  $180 = HEAP16[$81>>1]|0; //@line 113004 "c/sqlite3.c"
  $181 = ($180<<16>>16)>(-1); //@line 113004 "c/sqlite3.c"
  do {
   if ($181) {
    $182 = (_sqlite3VdbeAddOp2($155,124,$157,$162)|0); //@line 113005 "c/sqlite3.c"
    $183 = (_sqlite3VdbeAddOp3($155,32,$158,0,$162)|0); //@line 113006 "c/sqlite3.c"
    _sqlite3RowidConstraint($0,$$1276,$1); //@line 113008 "c/sqlite3.c"
    _sqlite3VdbeJumpHere($155,$183); //@line 113009 "c/sqlite3.c"
    _autoIncStep($0,$160,$162); //@line 113010 "c/sqlite3.c"
    $$0287 = $182;
   } else {
    $184 = HEAP32[$125>>2]|0; //@line 113011 "c/sqlite3.c"
    $185 = ($184|0)==(0|0); //@line 113011 "c/sqlite3.c"
    if ($185) {
     $186 = (_sqlite3VdbeAddOp2($155,116,$158,$162)|0); //@line 113012 "c/sqlite3.c"
     $$0287 = $186;
     break;
    } else {
     $187 = (_sqlite3VdbeAddOp2($155,124,$157,$162)|0); //@line 113014 "c/sqlite3.c"
     $$0287 = $187;
     break;
    }
   }
  } while(0);
  (_sqlite3VdbeAddOp3($155,123,$157,$161,1)|0); //@line 113017 "c/sqlite3.c"
  $188 = HEAP32[$163>>2]|0; //@line 113018 "c/sqlite3.c"
  $189 = $188 & 4; //@line 113018 "c/sqlite3.c"
  $190 = ($189|0)==(0); //@line 113018 "c/sqlite3.c"
  if ($190) {
   $$0274 = 41;
  } else {
   (_sqlite3VdbeAddOp1($155,126,$158)|0); //@line 113019 "c/sqlite3.c"
   $$0274 = 57;
  }
  (_sqlite3VdbeAddOp4($155,117,$158,$161,$162,$1,-6)|0); //@line 113025 "c/sqlite3.c"
  _sqlite3VdbeChangeP5($155,$$0274); //@line 113027 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($155,7,$157,$$0287)|0); //@line 113028 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($155,113,$157,0)|0); //@line 113029 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($155,113,$158,0)|0); //@line 113030 "c/sqlite3.c"
  $$0289 = $179;
 } else {
  $191 = ((($1)) + 28|0); //@line 113032 "c/sqlite3.c"
  $192 = HEAP32[$191>>2]|0; //@line 113032 "c/sqlite3.c"
  $193 = HEAP32[$1>>2]|0; //@line 113032 "c/sqlite3.c"
  _sqlite3TableLock($0,$4,$192,1,$193); //@line 113032 "c/sqlite3.c"
  $194 = ((($60)) + 28|0); //@line 113033 "c/sqlite3.c"
  $195 = HEAP32[$194>>2]|0; //@line 113033 "c/sqlite3.c"
  $196 = HEAP32[$60>>2]|0; //@line 113033 "c/sqlite3.c"
  _sqlite3TableLock($0,$154,$195,0,$196); //@line 113033 "c/sqlite3.c"
  $$0289 = 0;
 }
 $$1282318 = HEAP32[$125>>2]|0;
 $197 = ($$1282318|0)==(0|0); //@line 113035 "c/sqlite3.c"
 if (!($197)) {
  $198 = ((($60)) + 8|0);
  $$1282319 = $$1282318;
  while(1) {
   $$1278304 = HEAP32[$198>>2]|0;
   $199 = ($$1278304|0)==(0|0); //@line 113037 "c/sqlite3.c"
   L139: do {
    if ($199) {
     $$1278$lcssa = 0;
    } else {
     $$1278305 = $$1278304;
     while(1) {
      $200 = (_xferCompatibleIndex($$1282319,$$1278305)|0); //@line 113038 "c/sqlite3.c"
      $201 = ($200|0)==(0); //@line 113038 "c/sqlite3.c"
      if (!($201)) {
       $$1278$lcssa = $$1278305;
       break L139;
      }
      $202 = ((($$1278305)) + 20|0); //@line 113037 "c/sqlite3.c"
      $$1278 = HEAP32[$202>>2]|0;
      $203 = ($$1278|0)==(0|0); //@line 113037 "c/sqlite3.c"
      if ($203) {
       $$1278$lcssa = 0;
       break;
      } else {
       $$1278305 = $$1278;
      }
     }
    }
   } while(0);
   $204 = ((($$1278$lcssa)) + 44|0); //@line 113041 "c/sqlite3.c"
   $205 = HEAP32[$204>>2]|0; //@line 113041 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($155,105,$157,$205,$154)|0); //@line 113041 "c/sqlite3.c"
   _sqlite3VdbeSetP4KeyInfo($0,$$1278$lcssa); //@line 113042 "c/sqlite3.c"
   $206 = ((($$1282319)) + 44|0); //@line 113044 "c/sqlite3.c"
   $207 = HEAP32[$206>>2]|0; //@line 113044 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($155,106,$158,$207,$4)|0); //@line 113044 "c/sqlite3.c"
   _sqlite3VdbeSetP4KeyInfo($0,$$1282319); //@line 113045 "c/sqlite3.c"
   _sqlite3VdbeChangeP5($155,1); //@line 113046 "c/sqlite3.c"
   $208 = (_sqlite3VdbeAddOp2($155,37,$157,0)|0); //@line 113048 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($155,123,$157,$161,1)|0); //@line 113049 "c/sqlite3.c"
   $209 = HEAP32[$163>>2]|0; //@line 113050 "c/sqlite3.c"
   $210 = $209 & 4; //@line 113050 "c/sqlite3.c"
   $211 = ($210|0)==(0); //@line 113050 "c/sqlite3.c"
   do {
    if ($211) {
     $$0272 = 0;
    } else {
     $212 = ((($$1278$lcssa)) + 52|0); //@line 113065 "c/sqlite3.c"
     $213 = HEAP16[$212>>1]|0; //@line 113065 "c/sqlite3.c"
     $214 = ($213<<16>>16)==(0); //@line 113065 "c/sqlite3.c"
     L147: do {
      if ($214) {
       $$1284$lcssa = 0;$$lcssa = 0;
      } else {
       $215 = $213&65535; //@line 113065 "c/sqlite3.c"
       $216 = ((($$1278$lcssa)) + 32|0); //@line 113066 "c/sqlite3.c"
       $217 = HEAP32[$216>>2]|0;
       $$1284308 = 0;$243 = $215;
       while(1) {
        $218 = (($217) + ($$1284308<<2)|0); //@line 113066 "c/sqlite3.c"
        $219 = HEAP32[$218>>2]|0; //@line 113066 "c/sqlite3.c"
        $220 = (_sqlite3_stricmp(18038,$219)|0); //@line 113067 "c/sqlite3.c"
        $221 = ($220|0)==(0); //@line 113067 "c/sqlite3.c"
        if (!($221)) {
         $$1284$lcssa = $$1284308;$$lcssa = $243;
         break L147;
        }
        $222 = (($$1284308) + 1)|0; //@line 113065 "c/sqlite3.c"
        $223 = HEAP16[$212>>1]|0; //@line 113065 "c/sqlite3.c"
        $224 = $223&65535; //@line 113065 "c/sqlite3.c"
        $225 = ($222>>>0)<($224>>>0); //@line 113065 "c/sqlite3.c"
        if ($225) {
         $$1284308 = $222;$243 = $224;
        } else {
         break;
        }
       }
       $226 = $223&65535; //@line 113065 "c/sqlite3.c"
       $$1284$lcssa = $222;$$lcssa = $226;
      }
     } while(0);
     $227 = ($$1284$lcssa|0)==($$lcssa|0); //@line 113069 "c/sqlite3.c"
     if (!($227)) {
      $$0272 = 0;
      break;
     }
     (_sqlite3VdbeAddOp1($155,126,$158)|0); //@line 113071 "c/sqlite3.c"
     $$0272 = 16;
    }
   } while(0);
   $228 = HEAP32[$65>>2]|0; //@line 113074 "c/sqlite3.c"
   $229 = $228 & 32; //@line 113074 "c/sqlite3.c"
   $230 = ($229|0)==(0); //@line 113074 "c/sqlite3.c"
   if ($230) {
    $$1273 = $$0272;
   } else {
    $231 = ((($$1282319)) + 55|0); //@line 113074 "c/sqlite3.c"
    $232 = HEAPU8[$231>>0]|(HEAPU8[$231+1>>0]<<8); //@line 113074 "c/sqlite3.c"
    $233 = $232 & 3; //@line 113074 "c/sqlite3.c"
    $234 = ($233<<16>>16)==(2); //@line 113074 "c/sqlite3.c"
    $235 = $234&1; //@line 113074 "c/sqlite3.c"
    $spec$select296 = $$0272 | $235; //@line 113074 "c/sqlite3.c"
    $$1273 = $spec$select296;
   }
   (_sqlite3VdbeAddOp2($155,128,$158,$161)|0); //@line 113077 "c/sqlite3.c"
   $236 = $$1273 | 8; //@line 113078 "c/sqlite3.c"
   $237 = $236&255; //@line 113078 "c/sqlite3.c"
   _sqlite3VdbeChangeP5($155,$237); //@line 113078 "c/sqlite3.c"
   $238 = (($208) + 1)|0; //@line 113079 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($155,7,$157,$238)|0); //@line 113079 "c/sqlite3.c"
   _sqlite3VdbeJumpHere($155,$208); //@line 113080 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($155,113,$157,0)|0); //@line 113081 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($155,113,$158,0)|0); //@line 113082 "c/sqlite3.c"
   $239 = ((($$1282319)) + 20|0); //@line 113035 "c/sqlite3.c"
   $$1282 = HEAP32[$239>>2]|0;
   $240 = ($$1282|0)==(0|0); //@line 113035 "c/sqlite3.c"
   if ($240) {
    break;
   } else {
    $$1282319 = $$1282;
   }
  }
 }
 $241 = ($$0289|0)==(0); //@line 113084 "c/sqlite3.c"
 if (!($241)) {
  _sqlite3VdbeJumpHere($155,$$0289); //@line 113084 "c/sqlite3.c"
 }
 _sqlite3ReleaseTempReg($0,$162); //@line 113085 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$161); //@line 113086 "c/sqlite3.c"
 $242 = ($$0288|0)==(0); //@line 113087 "c/sqlite3.c"
 if ($242) {
  $$2 = 1;
  return ($$2|0); //@line 113096 "c/sqlite3.c"
 }
 _sqlite3AutoincrementEnd($0); //@line 113088 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($155,66,0,0)|0); //@line 113089 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($155,$$0288); //@line 113090 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($155,113,$158,0)|0); //@line 113091 "c/sqlite3.c"
 $$2 = 0;
 return ($$2|0); //@line 113096 "c/sqlite3.c"
}
function _autoIncBegin($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$031 = 0, $$03137 = 0, $$03139 = 0, $$1 = 0, $$133 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, $cond38 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($2)) + 36|0); //@line 111065 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 111065 "c/sqlite3.c"
 $5 = $4 & 8; //@line 111065 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 111065 "c/sqlite3.c"
 if ($6) {
  $$133 = 0;
  return ($$133|0); //@line 111087 "c/sqlite3.c"
 }
 $7 = HEAP32[$0>>2]|0; //@line 111066 "c/sqlite3.c"
 $8 = ((($7)) + 24|0); //@line 111066 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 111066 "c/sqlite3.c"
 $10 = $9 & 4; //@line 111066 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 111066 "c/sqlite3.c"
 if (!($11)) {
  $$133 = 0;
  return ($$133|0); //@line 111087 "c/sqlite3.c"
 }
 $12 = ((($0)) + 120|0); //@line 111068 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 111068 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 111068 "c/sqlite3.c"
 $spec$select = $14 ? $0 : $13; //@line 111068 "c/sqlite3.c"
 $15 = ((($spec$select)) + 116|0); //@line 111071 "c/sqlite3.c"
 $$03137 = HEAP32[$15>>2]|0;
 $cond38 = ($$03137|0)==(0|0); //@line 111072 "c/sqlite3.c"
 L7: do {
  if ($cond38) {
   label = 7;
  } else {
   $$03139 = $$03137;
   while(1) {
    $16 = ((($$03139)) + 4|0); //@line 111072 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 111072 "c/sqlite3.c"
    $18 = ($17|0)==($2|0); //@line 111072 "c/sqlite3.c"
    if ($18) {
     $$1 = $$03139;
     break L7;
    }
    $$031 = HEAP32[$$03139>>2]|0;
    $cond = ($$031|0)==(0|0); //@line 111072 "c/sqlite3.c"
    if ($cond) {
     label = 7;
     break;
    } else {
     $$03139 = $$031;
    }
   }
  }
 } while(0);
 do {
  if ((label|0) == 7) {
   $19 = (_sqlite3DbMallocRawNN($7,16,0)|0); //@line 111074 "c/sqlite3.c"
   $20 = ($19|0)==(0|0); //@line 111075 "c/sqlite3.c"
   if ($20) {
    $$133 = 0;
    return ($$133|0); //@line 111087 "c/sqlite3.c"
   } else {
    $21 = HEAP32[$15>>2]|0; //@line 111076 "c/sqlite3.c"
    HEAP32[$19>>2] = $21; //@line 111076 "c/sqlite3.c"
    HEAP32[$15>>2] = $19; //@line 111077 "c/sqlite3.c"
    $22 = ((($19)) + 4|0); //@line 111078 "c/sqlite3.c"
    HEAP32[$22>>2] = $2; //@line 111078 "c/sqlite3.c"
    $23 = ((($19)) + 8|0); //@line 111079 "c/sqlite3.c"
    HEAP32[$23>>2] = $1; //@line 111079 "c/sqlite3.c"
    $24 = ((($spec$select)) + 44|0); //@line 111080 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 111080 "c/sqlite3.c"
    $26 = (($25) + 2)|0; //@line 111081 "c/sqlite3.c"
    $27 = ((($19)) + 12|0); //@line 111081 "c/sqlite3.c"
    HEAP32[$27>>2] = $26; //@line 111081 "c/sqlite3.c"
    $28 = (($25) + 3)|0; //@line 111082 "c/sqlite3.c"
    HEAP32[$24>>2] = $28; //@line 111082 "c/sqlite3.c"
    $$1 = $19;
    break;
   }
  }
 } while(0);
 $29 = ((($$1)) + 12|0); //@line 111084 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 111084 "c/sqlite3.c"
 $$133 = $30;
 return ($$133|0); //@line 111087 "c/sqlite3.c"
}
function _sqlite3VdbeEndCoroutine($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 (_sqlite3VdbeAddOp1($0,64,$1)|0); //@line 73303 "c/sqlite3.c"
 $2 = ((($0)) + 12|0); //@line 73311 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73311 "c/sqlite3.c"
 $4 = ((($3)) + 19|0); //@line 73311 "c/sqlite3.c"
 HEAP8[$4>>0] = 0; //@line 73311 "c/sqlite3.c"
 $5 = ((($3)) + 28|0); //@line 73312 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 73312 "c/sqlite3.c"
 return; //@line 73313 "c/sqlite3.c"
}
function _readsTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$042 = 0, $$04250 = 0, $$04251 = 0, $$04352 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3GetVdbe($0)|0); //@line 111003 "c/sqlite3.c"
 $4 = (_sqlite3VdbeCurrentAddr($3)|0); //@line 111005 "c/sqlite3.c"
 $5 = ((($2)) + 56|0); //@line 111007 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 111007 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 111007 "c/sqlite3.c"
 if ($7) {
  $32 = 0;
 } else {
  $8 = HEAP32[$0>>2]|0; //@line 111007 "c/sqlite3.c"
  $9 = (_sqlite3GetVTable($8,$2)|0); //@line 111007 "c/sqlite3.c"
  $32 = $9;
 }
 $10 = ($4|0)>(1); //@line 111010 "c/sqlite3.c"
 if (!($10)) {
  $$4 = 0;
  return ($$4|0); //@line 111034 "c/sqlite3.c"
 }
 $11 = ((($2)) + 28|0);
 $12 = ((($2)) + 8|0);
 $$04352 = 1;
 L7: while(1) {
  $13 = (_sqlite3VdbeGetOp($3,$$04352)|0); //@line 111011 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 111013 "c/sqlite3.c"
  switch ($14<<24>>24) {
  case 105:  {
   $15 = ((($13)) + 12|0); //@line 111013 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 111013 "c/sqlite3.c"
   $17 = ($16|0)==($1|0); //@line 111013 "c/sqlite3.c"
   if ($17) {
    $18 = ((($13)) + 8|0); //@line 111015 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 111015 "c/sqlite3.c"
    $20 = HEAP32[$11>>2]|0; //@line 111016 "c/sqlite3.c"
    $21 = ($19|0)==($20|0); //@line 111016 "c/sqlite3.c"
    if ($21) {
     $$4 = 1;
     label = 15;
     break L7;
    }
    $$04250 = HEAP32[$12>>2]|0;
    $22 = ($$04250|0)==(0|0); //@line 111019 "c/sqlite3.c"
    if (!($22)) {
     $$04251 = $$04250;
     while(1) {
      $25 = ((($$04251)) + 44|0); //@line 111020 "c/sqlite3.c"
      $26 = HEAP32[$25>>2]|0; //@line 111020 "c/sqlite3.c"
      $27 = ($19|0)==($26|0); //@line 111020 "c/sqlite3.c"
      if ($27) {
       $$4 = 1;
       label = 15;
       break L7;
      }
      $23 = ((($$04251)) + 20|0); //@line 111019 "c/sqlite3.c"
      $$042 = HEAP32[$23>>2]|0;
      $24 = ($$042|0)==(0|0); //@line 111019 "c/sqlite3.c"
      if ($24) {
       break;
      } else {
       $$04251 = $$042;
      }
     }
     $28 = ($14<<24>>24)==(-99); //@line 111026 "c/sqlite3.c"
     if ($28) {
      label = 13;
     }
    }
   }
   break;
  }
  case -99:  {
   label = 13;
   break;
  }
  default: {
  }
  }
  if ((label|0) == 13) {
   label = 0;
   $29 = ((($13)) + 16|0); //@line 111026 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 111026 "c/sqlite3.c"
   $31 = ($30|0)==($32|0); //@line 111026 "c/sqlite3.c"
   if ($31) {
    $$4 = 1;
    label = 15;
    break;
   }
  }
  $33 = (($$04352) + 1)|0; //@line 111010 "c/sqlite3.c"
  $34 = ($33|0)<($4|0); //@line 111010 "c/sqlite3.c"
  if ($34) {
   $$04352 = $33;
  } else {
   $$4 = 0;
   label = 15;
   break;
  }
 }
 if ((label|0) == 15) {
  return ($$4|0); //@line 111034 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprCodeAndCache($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 96962 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 96962 "c/sqlite3.c"
 _sqlite3ExprCode($0,$1,$2); //@line 96967 "c/sqlite3.c"
 $5 = ((($0)) + 44|0); //@line 96968 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 96968 "c/sqlite3.c"
 $7 = (($6) + 1)|0; //@line 96968 "c/sqlite3.c"
 HEAP32[$5>>2] = $7; //@line 96968 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($4,75,$2,$7)|0); //@line 96969 "c/sqlite3.c"
 _exprToRegister($1,$7); //@line 96970 "c/sqlite3.c"
 return; //@line 96971 "c/sqlite3.c"
}
function _sqlite3TableAffinity($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03538 = 0, $$036 = 0, $$1 = 0, $$1$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 20|0); //@line 110969 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 110969 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 110970 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3VdbeDb($0)|0); //@line 110971 "c/sqlite3.c"
  $7 = ((($1)) + 42|0); //@line 110972 "c/sqlite3.c"
  $8 = HEAP16[$7>>1]|0; //@line 110972 "c/sqlite3.c"
  $9 = $8 << 16 >> 16; //@line 110972 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 110972 "c/sqlite3.c"
  $11 = ($10|0)<(0); //@line 110972 "c/sqlite3.c"
  $12 = $11 << 31 >> 31; //@line 110972 "c/sqlite3.c"
  $13 = (_sqlite3DbMallocRaw(0,$10,$12)|0); //@line 110972 "c/sqlite3.c"
  $14 = ($13|0)==(0|0); //@line 110973 "c/sqlite3.c"
  if ($14) {
   _sqlite3OomFault($6); //@line 110974 "c/sqlite3.c"
   return; //@line 110994 "c/sqlite3.c"
  }
  $15 = HEAP16[$7>>1]|0; //@line 110978 "c/sqlite3.c"
  $16 = ($15<<16>>16)>(0); //@line 110978 "c/sqlite3.c"
  if ($16) {
   $17 = ((($1)) + 4|0);
   $$03538 = 0;
   while(1) {
    $18 = HEAP32[$17>>2]|0; //@line 110979 "c/sqlite3.c"
    $19 = (((($18) + ($$03538<<4)|0)) + 13|0); //@line 110979 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 110979 "c/sqlite3.c"
    $21 = (($13) + ($$03538)|0); //@line 110979 "c/sqlite3.c"
    HEAP8[$21>>0] = $20; //@line 110979 "c/sqlite3.c"
    $22 = (($$03538) + 1)|0; //@line 110978 "c/sqlite3.c"
    $23 = HEAP16[$7>>1]|0; //@line 110978 "c/sqlite3.c"
    $24 = $23 << 16 >> 16; //@line 110978 "c/sqlite3.c"
    $25 = ($22|0)<($24|0); //@line 110978 "c/sqlite3.c"
    if ($25) {
     $$03538 = $22;
    } else {
     $$1$ph = $22;
     break;
    }
   }
  } else {
   $$1$ph = 0;
  }
  $$1 = $$1$ph;
  while(1) {
   $26 = (($$1) + -1)|0; //@line 110982 "c/sqlite3.c"
   $27 = (($13) + ($$1)|0); //@line 110982 "c/sqlite3.c"
   HEAP8[$27>>0] = 0; //@line 110982 "c/sqlite3.c"
   $28 = ($$1|0)>(0); //@line 110983 "c/sqlite3.c"
   if (!($28)) {
    break;
   }
   $29 = (($13) + ($26)|0); //@line 110983 "c/sqlite3.c"
   $30 = HEAP8[$29>>0]|0; //@line 110983 "c/sqlite3.c"
   $31 = ($30<<24>>24)==(65); //@line 110983 "c/sqlite3.c"
   if ($31) {
    $$1 = $26;
   } else {
    break;
   }
  }
  HEAP32[$3>>2] = $13; //@line 110984 "c/sqlite3.c"
  $$036 = $13;
 } else {
  $$036 = $4;
 }
 $32 = (_sqlite3Strlen30($$036)|0); //@line 110986 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 110987 "c/sqlite3.c"
 if ($33) {
  return; //@line 110994 "c/sqlite3.c"
 }
 $34 = ($2|0)==(0); //@line 110988 "c/sqlite3.c"
 if ($34) {
  _sqlite3VdbeChangeP4($0,-1,$$036,$32); //@line 110991 "c/sqlite3.c"
  return; //@line 110994 "c/sqlite3.c"
 } else {
  (_sqlite3VdbeAddOp4($0,99,$2,$32,0,$$036,$32)|0); //@line 110989 "c/sqlite3.c"
  return; //@line 110994 "c/sqlite3.c"
 }
}
function _sqlite3CodeRowTrigger($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$015 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $9 = ($1|0)==(0|0); //@line 126001 "c/sqlite3.c"
 if ($9) {
  return; //@line 126019 "c/sqlite3.c"
 }
 $$015 = $1;
 while(1) {
  $10 = ((($$015)) + 8|0); //@line 126012 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 126012 "c/sqlite3.c"
  $12 = $11&255; //@line 126012 "c/sqlite3.c"
  $13 = ($12|0)==($2|0); //@line 126012 "c/sqlite3.c"
  if ($13) {
   $14 = ((($$015)) + 9|0); //@line 126013 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 126013 "c/sqlite3.c"
   $16 = $15&255; //@line 126013 "c/sqlite3.c"
   $17 = ($16|0)==($4|0); //@line 126013 "c/sqlite3.c"
   if ($17) {
    $18 = ((($$015)) + 16|0); //@line 126014 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 126014 "c/sqlite3.c"
    $20 = (_checkColumnOverlap($19,$3)|0); //@line 126014 "c/sqlite3.c"
    $21 = ($20|0)==(0); //@line 126014 "c/sqlite3.c"
    if (!($21)) {
     _sqlite3CodeRowTriggerDirect($0,$$015,$5,$6,$7,$8); //@line 126016 "c/sqlite3.c"
    }
   }
  }
  $22 = ((($$015)) + 32|0); //@line 126001 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 126001 "c/sqlite3.c"
  $24 = ($23|0)==(0|0); //@line 126001 "c/sqlite3.c"
  if ($24) {
   break;
  } else {
   $$015 = $23;
  }
 }
 return; //@line 126019 "c/sqlite3.c"
}
function _autoIncStep($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)>(0); //@line 111149 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 111152 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0); //@line 111150 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 111150 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($5,147,$1,$2)|0); //@line 111150 "c/sqlite3.c"
 return; //@line 111152 "c/sqlite3.c"
}
function _sqlite3VtabMakeWritable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$027 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 120|0); //@line 128465 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 128465 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 128465 "c/sqlite3.c"
 $spec$select = $4 ? $0 : $3; //@line 128465 "c/sqlite3.c"
 $5 = ((($spec$select)) + 404|0); //@line 128470 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 128470 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 128470 "c/sqlite3.c"
 L1: do {
  if ($7) {
   $8 = ((($spec$select)) + 452|0);
   $9 = HEAP32[$8>>2]|0;
   $$027 = 0;
   while(1) {
    $13 = (($9) + ($$027<<2)|0); //@line 128471 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 128471 "c/sqlite3.c"
    $15 = ($14|0)==($1|0); //@line 128471 "c/sqlite3.c"
    $12 = (($$027) + 1)|0; //@line 128470 "c/sqlite3.c"
    if ($15) {
     break;
    }
    $10 = HEAP32[$5>>2]|0; //@line 128470 "c/sqlite3.c"
    $11 = ($12|0)<($10|0); //@line 128470 "c/sqlite3.c"
    if ($11) {
     $$027 = $12;
    } else {
     $$lcssa = $10;
     break L1;
    }
   }
   return; //@line 128481 "c/sqlite3.c"
  } else {
   $$lcssa = $6;
  }
 } while(0);
 $16 = $$lcssa << 2; //@line 128473 "c/sqlite3.c"
 $17 = (($16) + 4)|0; //@line 128473 "c/sqlite3.c"
 $18 = ((($spec$select)) + 452|0); //@line 128474 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 128474 "c/sqlite3.c"
 $20 = ($17|0)<(0); //@line 128474 "c/sqlite3.c"
 $21 = $20 << 31 >> 31; //@line 128474 "c/sqlite3.c"
 $22 = (_sqlite3_realloc64($19,$17,$21)|0); //@line 128474 "c/sqlite3.c"
 $23 = ($22|0)==(0|0); //@line 128475 "c/sqlite3.c"
 if ($23) {
  $27 = HEAP32[$spec$select>>2]|0; //@line 128479 "c/sqlite3.c"
  _sqlite3OomFault($27); //@line 128479 "c/sqlite3.c"
  return; //@line 128481 "c/sqlite3.c"
 } else {
  HEAP32[$18>>2] = $22; //@line 128476 "c/sqlite3.c"
  $24 = HEAP32[$5>>2]|0; //@line 128477 "c/sqlite3.c"
  $25 = (($24) + 1)|0; //@line 128477 "c/sqlite3.c"
  HEAP32[$5>>2] = $25; //@line 128477 "c/sqlite3.c"
  $26 = (($22) + ($24<<2)|0); //@line 128477 "c/sqlite3.c"
  HEAP32[$26>>2] = $1; //@line 128477 "c/sqlite3.c"
  return; //@line 128481 "c/sqlite3.c"
 }
}
function _sqlite3GenerateConstraintChecks($0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 $9 = $9|0;
 $10 = $10|0;
 $11 = $11|0;
 var $$0 = 0, $$0389 = 0, $$0389459 = 0, $$0389460 = 0, $$0390 = 0, $$0391445 = 0, $$0393444 = 0, $$0395 = 0, $$0396469 = 0, $$0398452 = 0, $$0399 = 0, $$0399$shrunk = 0, $$0404 = 0, $$0409 = 0, $$0410431 = 0, $$0411 = 0, $$0411475 = 0, $$0411476 = 0, $$0413 = 0, $$0418449 = 0;
 var $$1 = 0, $$1397464 = 0, $$1400 = 0, $$1405 = 0, $$1412 = 0, $$1417 = 0, $$1419 = 0, $$1448 = 0, $$1454 = 0, $$2401463 = 0, $$2406$lcssa = 0, $$2406450 = 0, $$2420 = 0, $$2437 = 0, $$3407 = 0, $$3440 = 0, $$4403 = 0, $$4408 = 0, $$4443 = 0, $$5 = 0;
 var $$6 = 0, $$6$shrunk = 0, $$7 = 0, $$8 = 0, $$8$shrunk = 0, $$lcssa = 0, $$off = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0;
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0;
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0;
 var $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0;
 var $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0;
 var $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0;
 var $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0;
 var $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0;
 var $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $80 = 0;
 var $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0;
 var $or$cond = 0, $or$cond3 = 0, $or$cond425 = 0, $or$cond426 = 0, $or$cond427 = 0, $or$cond434 = 0, $or$cond5 = 0, $spec$select = 0, $spec$select422 = 0, $spec$select423 = 0, $spec$select424 = 0, $spec$select428 = 0, $spec$select429 = 0, $spec$select430 = 0, $spec$select433 = 0, $switch = 0, $trunc421 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 112061 "c/sqlite3.c"
 $12 = ($6|0)!=(0); //@line 112090 "c/sqlite3.c"
 $13 = HEAP32[$0>>2]|0; //@line 112091 "c/sqlite3.c"
 $14 = (_sqlite3GetVdbe($0)|0); //@line 112092 "c/sqlite3.c"
 $15 = ((($1)) + 42|0); //@line 112095 "c/sqlite3.c"
 $16 = HEAP16[$15>>1]|0; //@line 112095 "c/sqlite3.c"
 $17 = $16 << 16 >> 16; //@line 112095 "c/sqlite3.c"
 $18 = ((($1)) + 36|0); //@line 112101 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 112101 "c/sqlite3.c"
 $20 = $19 & 32; //@line 112101 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 112101 "c/sqlite3.c"
 if ($21) {
  $$0390 = 0;$$0409 = 1;
 } else {
  $22 = (_sqlite3PrimaryKeyIndex($1)|0); //@line 112105 "c/sqlite3.c"
  $23 = ((($22)) + 50|0); //@line 112106 "c/sqlite3.c"
  $24 = HEAP16[$23>>1]|0; //@line 112106 "c/sqlite3.c"
  $25 = $24&65535; //@line 112106 "c/sqlite3.c"
  $$0390 = $22;$$0409 = $25;
 }
 $26 = ($16<<16>>16)>(0); //@line 112115 "c/sqlite3.c"
 if ($26) {
  $27 = ((($1)) + 40|0);
  $28 = ($11|0)==(0|0);
  $29 = ((($1)) + 4|0);
  $30 = ($8<<24>>24)==(10);
  $31 = (($5) + 1)|0;
  $32 = (($5) + 1)|0;
  $33 = (($5) + 1)|0;
  $$0396469 = 0;
  while(1) {
   $34 = HEAP16[$27>>1]|0; //@line 112116 "c/sqlite3.c"
   $35 = $34 << 16 >> 16; //@line 112116 "c/sqlite3.c"
   $36 = ($$0396469|0)==($35|0); //@line 112116 "c/sqlite3.c"
   L8: do {
    if (!($36)) {
     if (!($28)) {
      $37 = (($11) + ($$0396469<<2)|0); //@line 112119 "c/sqlite3.c"
      $38 = HEAP32[$37>>2]|0; //@line 112119 "c/sqlite3.c"
      $39 = ($38|0)<(0); //@line 112119 "c/sqlite3.c"
      if ($39) {
       break;
      }
     }
     $40 = HEAP32[$29>>2]|0; //@line 112123 "c/sqlite3.c"
     $41 = (((($40) + ($$0396469<<4)|0)) + 12|0); //@line 112123 "c/sqlite3.c"
     $42 = HEAP8[$41>>0]|0; //@line 112123 "c/sqlite3.c"
     $43 = ($42<<24>>24)==(0); //@line 112124 "c/sqlite3.c"
     if (!($43)) {
      $44 = ($42<<24>>24)==(10); //@line 112127 "c/sqlite3.c"
      $spec$select = $44 ? 2 : $42; //@line 112127 "c/sqlite3.c"
      $$0399$shrunk = $30 ? $spec$select : $8; //@line 112125 "c/sqlite3.c"
      $$0399 = $$0399$shrunk&255;
      $45 = ($$0399$shrunk<<24>>24)==(5); //@line 112130 "c/sqlite3.c"
      if ($45) {
       $46 = (((($40) + ($$0396469<<4)|0)) + 4|0); //@line 112130 "c/sqlite3.c"
       $47 = HEAP32[$46>>2]|0; //@line 112130 "c/sqlite3.c"
       $48 = ($47|0)==(0|0); //@line 112130 "c/sqlite3.c"
       $spec$select422 = $48 ? 2 : $$0399; //@line 112130 "c/sqlite3.c"
       $$1400 = $spec$select422;
      } else {
       $$1400 = $$0399;
      }
      $trunc421 = $$1400&255; //@line 112135 "c/sqlite3.c"
      switch ($trunc421<<24>>24) {
      case 2:  {
       _sqlite3MayAbort($0); //@line 112137 "c/sqlite3.c"
       break;
      }
      case 3: case 1:  {
       break;
      }
      case 4:  {
       $55 = (($33) + ($$0396469))|0; //@line 112151 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($14,50,$55,$9)|0); //@line 112151 "c/sqlite3.c"
       break L8;
       break;
      }
      default: {
       $56 = (($31) + ($$0396469))|0; //@line 112157 "c/sqlite3.c"
       $57 = (_sqlite3VdbeAddOp1($14,51,$56)|0); //@line 112157 "c/sqlite3.c"
       $58 = HEAP32[$29>>2]|0; //@line 112159 "c/sqlite3.c"
       $59 = (((($58) + ($$0396469<<4)|0)) + 4|0); //@line 112159 "c/sqlite3.c"
       $60 = HEAP32[$59>>2]|0; //@line 112159 "c/sqlite3.c"
       _sqlite3ExprCode($0,$60,$56); //@line 112159 "c/sqlite3.c"
       _sqlite3VdbeJumpHere($14,$57); //@line 112160 "c/sqlite3.c"
       break L8;
      }
      }
      $49 = HEAP32[$1>>2]|0; //@line 112141 "c/sqlite3.c"
      $50 = HEAP32[$29>>2]|0; //@line 112142 "c/sqlite3.c"
      $51 = (($50) + ($$0396469<<4)|0); //@line 112142 "c/sqlite3.c"
      $52 = HEAP32[$51>>2]|0; //@line 112142 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $49; //@line 112141 "c/sqlite3.c"
      $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 112141 "c/sqlite3.c"
      HEAP32[$vararg_ptr1>>2] = $52; //@line 112141 "c/sqlite3.c"
      $53 = (_sqlite3MPrintf($13,17909,$vararg_buffer)|0); //@line 112141 "c/sqlite3.c"
      $54 = (($32) + ($$0396469))|0; //@line 112144 "c/sqlite3.c"
      (_sqlite3VdbeAddOp3($14,65,1299,$$1400,$54)|0); //@line 112143 "c/sqlite3.c"
      _sqlite3VdbeAppendP4($14,$53,-7); //@line 112145 "c/sqlite3.c"
      _sqlite3VdbeChangeP5($14,1); //@line 112146 "c/sqlite3.c"
     }
    }
   } while(0);
   $61 = (($$0396469) + 1)|0; //@line 112115 "c/sqlite3.c"
   $exitcond = ($61|0)==($17|0); //@line 112115 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$0396469 = $61;
   }
  }
 }
 $62 = ((($1)) + 24|0); //@line 112169 "c/sqlite3.c"
 $63 = HEAP32[$62>>2]|0; //@line 112169 "c/sqlite3.c"
 $64 = ($63|0)==(0|0); //@line 112169 "c/sqlite3.c"
 if (!($64)) {
  $65 = ((($13)) + 28|0); //@line 112169 "c/sqlite3.c"
  $66 = HEAP32[$65>>2]|0; //@line 112169 "c/sqlite3.c"
  $67 = $66 & 512; //@line 112169 "c/sqlite3.c"
  $68 = ($67|0)==(0); //@line 112169 "c/sqlite3.c"
  if ($68) {
   $69 = $5 ^ -1; //@line 112171 "c/sqlite3.c"
   $70 = ((($0)) + 56|0); //@line 112171 "c/sqlite3.c"
   HEAP32[$70>>2] = $69; //@line 112171 "c/sqlite3.c"
   $71 = HEAP32[$63>>2]|0; //@line 112173 "c/sqlite3.c"
   $72 = ($71|0)>(0); //@line 112173 "c/sqlite3.c"
   if ($72) {
    $73 = ($8<<24>>24)==(10); //@line 112172 "c/sqlite3.c"
    $74 = $8&255; //@line 112172 "c/sqlite3.c"
    $75 = $73 ? 2 : $74; //@line 112172 "c/sqlite3.c"
    $76 = ($11|0)==(0|0);
    $77 = $7&255;
    $$1397464 = 0;$$2401463 = $75;
    while(1) {
     $78 = (((($63)) + 4|0) + (($$1397464*20)|0)|0); //@line 112175 "c/sqlite3.c"
     $79 = HEAP32[$78>>2]|0; //@line 112175 "c/sqlite3.c"
     if ($76) {
      label = 23;
     } else {
      $80 = (_checkConstraintUnchanged($79,$11,$77)|0); //@line 112176 "c/sqlite3.c"
      $81 = ($80|0)==(0); //@line 112176 "c/sqlite3.c"
      if ($81) {
       label = 23;
      } else {
       $$5 = $$2401463;
      }
     }
     if ((label|0) == 23) {
      label = 0;
      $82 = (_sqlite3VdbeMakeLabel($14)|0); //@line 112177 "c/sqlite3.c"
      _sqlite3ExprIfTrue($0,$79,$82,16); //@line 112178 "c/sqlite3.c"
      $83 = ($$2401463|0)==(4); //@line 112179 "c/sqlite3.c"
      if ($83) {
       _sqlite3VdbeGoto($14,$9); //@line 112180 "c/sqlite3.c"
       $$4403 = 4;
      } else {
       $84 = (((((($63)) + 4|0) + (($$1397464*20)|0)|0)) + 4|0); //@line 112182 "c/sqlite3.c"
       $85 = HEAP32[$84>>2]|0; //@line 112182 "c/sqlite3.c"
       $86 = ($85|0)==(0|0); //@line 112183 "c/sqlite3.c"
       if ($86) {
        $87 = HEAP32[$1>>2]|0; //@line 112183 "c/sqlite3.c"
        $$0413 = $87;
       } else {
        $$0413 = $85;
       }
       $88 = ($$2401463|0)==(5); //@line 112184 "c/sqlite3.c"
       $spec$select423 = $88 ? 2 : $$2401463; //@line 112184 "c/sqlite3.c"
       _sqlite3HaltConstraint($0,275,$spec$select423,$$0413,0,3); //@line 112185 "c/sqlite3.c"
       $$4403 = $spec$select423;
      }
      _sqlite3VdbeResolveLabel($14,$82); //@line 112189 "c/sqlite3.c"
      $$5 = $$4403;
     }
     $89 = (($$1397464) + 1)|0; //@line 112173 "c/sqlite3.c"
     $90 = HEAP32[$63>>2]|0; //@line 112173 "c/sqlite3.c"
     $91 = ($89|0)<($90|0); //@line 112173 "c/sqlite3.c"
     if ($91) {
      $$1397464 = $89;$$2401463 = $$5;
     } else {
      break;
     }
    }
   }
   HEAP32[$70>>2] = 0; //@line 112191 "c/sqlite3.c"
  }
 }
 $92 = ($7<<24>>24)!=(0); //@line 112198 "c/sqlite3.c"
 $93 = ($$0390|0)==(0|0); //@line 112198 "c/sqlite3.c"
 $or$cond = $92 & $93; //@line 112198 "c/sqlite3.c"
 if ($or$cond) {
  $94 = (_sqlite3VdbeMakeLabel($14)|0); //@line 112199 "c/sqlite3.c"
  $95 = ((($1)) + 48|0); //@line 112202 "c/sqlite3.c"
  $96 = HEAP8[$95>>0]|0; //@line 112202 "c/sqlite3.c"
  $97 = ($8<<24>>24)==(10); //@line 112203 "c/sqlite3.c"
  $98 = ($96<<24>>24)==(10); //@line 112205 "c/sqlite3.c"
  $spec$select424 = $98 ? 2 : $96; //@line 112205 "c/sqlite3.c"
  $$6$shrunk = $97 ? $spec$select424 : $8; //@line 112203 "c/sqlite3.c"
  $$6 = $$6$shrunk&255;
  if ($12) {
   (_sqlite3VdbeAddOp3($14,53,$5,$94,$6)|0); //@line 112213 "c/sqlite3.c"
   _sqlite3VdbeChangeP5($14,144); //@line 112214 "c/sqlite3.c"
  }
  $99 = ($$6$shrunk<<24>>24)!=(5); //@line 112223 "c/sqlite3.c"
  $100 = ($8<<24>>24)==(5); //@line 112223 "c/sqlite3.c"
  $or$cond425 = $100 | $99; //@line 112223 "c/sqlite3.c"
  L50: do {
   if ($or$cond425) {
    $$0411 = 0;
    label = 41;
   } else {
    $101 = ((($1)) + 8|0); //@line 112224 "c/sqlite3.c"
    $$0389459 = HEAP32[$101>>2]|0;
    $102 = ($$0389459|0)==(0|0); //@line 112224 "c/sqlite3.c"
    if ($102) {
     (_sqlite3VdbeAddOp3($14,32,$3,$94,$5)|0); //@line 112234 "c/sqlite3.c"
     $$0411476 = 0;
     label = 44;
     break;
    }
    $$0389460 = $$0389459;
    while(1) {
     $105 = ((($$0389460)) + 54|0); //@line 112225 "c/sqlite3.c"
     $106 = HEAP8[$105>>0]|0; //@line 112225 "c/sqlite3.c"
     $$off = (($106) + -3)<<24>>24; //@line 112225 "c/sqlite3.c"
     $switch = ($$off&255)<(2); //@line 112225 "c/sqlite3.c"
     if ($switch) {
      break;
     }
     $103 = ((($$0389460)) + 20|0); //@line 112224 "c/sqlite3.c"
     $$0389 = HEAP32[$103>>2]|0;
     $104 = ($$0389|0)==(0|0); //@line 112224 "c/sqlite3.c"
     if ($104) {
      $$0411 = 0;
      label = 41;
      break L50;
     } else {
      $$0389460 = $$0389;
     }
    }
    $107 = (_sqlite3VdbeAddOp0($14,13)|0); //@line 112226 "c/sqlite3.c"
    $$0411 = $107;
    label = 41;
   }
  } while(0);
  L59: do {
   if ((label|0) == 41) {
    (_sqlite3VdbeAddOp3($14,32,$3,$94,$5)|0); //@line 112234 "c/sqlite3.c"
    switch ($$6$shrunk<<24>>24) {
    case 5:  {
     $$0411476 = $$0411;
     label = 44;
     break L59;
     break;
    }
    case 3: case 2: case 1:  {
     $$7 = $$6;
     break;
    }
    case 4:  {
     _sqlite3VdbeGoto($14,$9); //@line 112301 "c/sqlite3.c"
     $$0404 = 0;$$0411475 = $$0411;
     break L59;
     break;
    }
    default: {
     $$7 = 2;
    }
    }
    _sqlite3RowidConstraint($0,$$7,$1); //@line 112246 "c/sqlite3.c"
    $$0404 = 0;$$0411475 = $$0411;
   }
  } while(0);
  do {
   if ((label|0) == 44) {
    $108 = ((($13)) + 28|0); //@line 112273 "c/sqlite3.c"
    $109 = HEAP32[$108>>2]|0; //@line 112273 "c/sqlite3.c"
    $110 = $109 & 8192; //@line 112273 "c/sqlite3.c"
    $111 = ($110|0)==(0); //@line 112273 "c/sqlite3.c"
    if ($111) {
     label = 46;
    } else {
     $112 = (_sqlite3TriggersExist($0,$1,109,0,0)|0); //@line 112274 "c/sqlite3.c"
     $113 = ($112|0)==(0|0); //@line 112276 "c/sqlite3.c"
     if ($113) {
      label = 46;
     } else {
      $$0410431 = $112;
     }
    }
    if ((label|0) == 46) {
     $114 = (_sqlite3FkRequired($0,$1,0,0)|0); //@line 112276 "c/sqlite3.c"
     $115 = ($114|0)==(0); //@line 112276 "c/sqlite3.c"
     if ($115) {
      $116 = ((($1)) + 8|0); //@line 112291 "c/sqlite3.c"
      $117 = HEAP32[$116>>2]|0; //@line 112291 "c/sqlite3.c"
      $118 = ($117|0)==(0|0); //@line 112291 "c/sqlite3.c"
      if ($118) {
       $$0404 = 1;$$0411475 = $$0411476;
       break;
      }
      _sqlite3MultiWrite($0); //@line 112292 "c/sqlite3.c"
      _sqlite3GenerateRowIndexDelete($0,$1,$3,$4,0,-1); //@line 112293 "c/sqlite3.c"
      $$0404 = 1;$$0411475 = $$0411476;
      break;
     } else {
      $$0410431 = 0;
     }
    }
    _sqlite3MultiWrite($0); //@line 112277 "c/sqlite3.c"
    _sqlite3GenerateRowDelete($0,$1,$$0410431,$3,$4,$5,1,0,5,1,-1); //@line 112278 "c/sqlite3.c"
    $$0404 = 1;$$0411475 = $$0411476;
   }
  } while(0);
  _sqlite3VdbeResolveLabel($14,$94); //@line 112305 "c/sqlite3.c"
  $119 = ($$0411475|0)==(0); //@line 112306 "c/sqlite3.c"
  if ($119) {
   $$1405 = $$0404;$$1412 = 0;$$1417 = 0;
  } else {
   $120 = (_sqlite3VdbeAddOp0($14,13)|0); //@line 112307 "c/sqlite3.c"
   _sqlite3VdbeJumpHere($14,$$0411475); //@line 112308 "c/sqlite3.c"
   $$1405 = $$0404;$$1412 = $$0411475;$$1417 = $120;
  }
 } else {
  $$1405 = 0;$$1412 = 0;$$1417 = 0;
 }
 $121 = ((($1)) + 8|0); //@line 112319 "c/sqlite3.c"
 $$1448 = HEAP32[$121>>2]|0;
 $122 = ($$1448|0)==(0|0); //@line 112319 "c/sqlite3.c"
 if ($122) {
  $$2406$lcssa = $$1405;
 } else {
  $123 = (($5) + 1)|0;
  $124 = $5 ^ -1;
  $125 = ((($0)) + 56|0);
  $126 = ($7<<24>>24)==(0);
  $127 = ((($1)) + 40|0);
  $128 = (($5) + 1)|0;
  $129 = $5 ^ -1;
  $130 = ((($0)) + 56|0);
  $131 = ($8<<24>>24)==(10);
  $132 = ((($13)) + 28|0);
  $133 = ((($1)) + 16|0);
  $134 = ((($13)) + 28|0);
  $135 = ((($$0390)) + 50|0);
  $136 = $$0409&65535;
  $137 = ((($$0390)) + 50|0);
  $138 = ((($$0390)) + 4|0);
  $139 = ((($$0390)) + 32|0);
  $140 = ((($$0390)) + 4|0);
  $141 = (($6) + 1)|0;
  $$0398452 = 0;$$0418449 = 0;$$1454 = $$1448;$$2406450 = $$1405;
  while(1) {
   $142 = (($2) + ($$0398452<<2)|0); //@line 112325 "c/sqlite3.c"
   $143 = HEAP32[$142>>2]|0; //@line 112325 "c/sqlite3.c"
   $144 = ($143|0)==(0); //@line 112325 "c/sqlite3.c"
   L81: do {
    if ($144) {
     $$2420 = $$0418449;$$4408 = $$2406450;
    } else {
     $145 = ($$0418449<<24>>24)==(0); //@line 112326 "c/sqlite3.c"
     if ($145) {
      _sqlite3TableAffinity($14,$1,$123); //@line 112327 "c/sqlite3.c"
      $$1419 = 1;
     } else {
      $$1419 = $$0418449;
     }
     $146 = (($$0398452) + ($4))|0; //@line 112330 "c/sqlite3.c"
     $147 = (_sqlite3VdbeMakeLabel($14)|0); //@line 112331 "c/sqlite3.c"
     $148 = ((($$1454)) + 36|0); //@line 112334 "c/sqlite3.c"
     $149 = HEAP32[$148>>2]|0; //@line 112334 "c/sqlite3.c"
     $150 = ($149|0)==(0|0); //@line 112334 "c/sqlite3.c"
     if (!($150)) {
      $151 = HEAP32[$142>>2]|0; //@line 112335 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($14,70,0,$151)|0); //@line 112335 "c/sqlite3.c"
      HEAP32[$125>>2] = $124; //@line 112336 "c/sqlite3.c"
      $152 = HEAP32[$148>>2]|0; //@line 112337 "c/sqlite3.c"
      _sqlite3ExprIfFalseDup($0,$152,$147); //@line 112337 "c/sqlite3.c"
      HEAP32[$125>>2] = 0; //@line 112339 "c/sqlite3.c"
     }
     $153 = HEAP32[$142>>2]|0; //@line 112345 "c/sqlite3.c"
     $154 = (($153) + 1)|0; //@line 112345 "c/sqlite3.c"
     $155 = ((($$1454)) + 52|0); //@line 112346 "c/sqlite3.c"
     $156 = HEAP16[$155>>1]|0; //@line 112346 "c/sqlite3.c"
     $157 = ($156<<16>>16)==(0); //@line 112346 "c/sqlite3.c"
     if ($157) {
      $$lcssa = 0;
     } else {
      $158 = ((($$1454)) + 4|0);
      $159 = ((($$1454)) + 40|0);
      $$2437 = 0;
      while(1) {
       $160 = HEAP32[$158>>2]|0; //@line 112347 "c/sqlite3.c"
       $161 = (($160) + ($$2437<<1)|0); //@line 112347 "c/sqlite3.c"
       $162 = HEAP16[$161>>1]|0; //@line 112347 "c/sqlite3.c"
       switch ($162<<16>>16) {
       case -2:  {
        HEAP32[$130>>2] = $129; //@line 112350 "c/sqlite3.c"
        $163 = HEAP32[$159>>2]|0; //@line 112351 "c/sqlite3.c"
        $164 = (((($163)) + 4|0) + (($$2437*20)|0)|0); //@line 112351 "c/sqlite3.c"
        $165 = HEAP32[$164>>2]|0; //@line 112351 "c/sqlite3.c"
        $166 = (($$2437) + ($154))|0; //@line 112351 "c/sqlite3.c"
        _sqlite3ExprCodeCopy($0,$165,$166); //@line 112351 "c/sqlite3.c"
        HEAP32[$130>>2] = 0; //@line 112352 "c/sqlite3.c"
        break;
       }
       case -1:  {
        $$0395 = $5;
        label = 65;
        break;
       }
       default: {
        $167 = $162 << 16 >> 16; //@line 112347 "c/sqlite3.c"
        $168 = HEAP16[$127>>1]|0; //@line 112355 "c/sqlite3.c"
        $169 = ($162<<16>>16)==($168<<16>>16); //@line 112355 "c/sqlite3.c"
        $170 = (($128) + ($167))|0; //@line 112358 "c/sqlite3.c"
        $spec$select433 = $169 ? $5 : $170; //@line 112355 "c/sqlite3.c"
        $$0395 = $spec$select433;
        label = 65;
       }
       }
       if ((label|0) == 65) {
        label = 0;
        $171 = ($162&65535) >>> 15; //@line 112360 "c/sqlite3.c"
        $172 = $171 | 76; //@line 112360 "c/sqlite3.c"
        $173 = $172&65535; //@line 112360 "c/sqlite3.c"
        $174 = (($$2437) + ($154))|0; //@line 112360 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($14,$173,$$0395,$174)|0); //@line 112360 "c/sqlite3.c"
       }
       $175 = (($$2437) + 1)|0; //@line 112346 "c/sqlite3.c"
       $176 = HEAP16[$155>>1]|0; //@line 112346 "c/sqlite3.c"
       $177 = $176&65535; //@line 112346 "c/sqlite3.c"
       $178 = ($175>>>0)<($177>>>0); //@line 112346 "c/sqlite3.c"
       if ($178) {
        $$2437 = $175;
       } else {
        break;
       }
      }
      $179 = $176&65535; //@line 112346 "c/sqlite3.c"
      $$lcssa = $179;
     }
     $180 = HEAP32[$142>>2]|0; //@line 112364 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($14,100,$154,$$lcssa,$180)|0); //@line 112364 "c/sqlite3.c"
     $181 = ($$0390|0)==($$1454|0); //@line 112374 "c/sqlite3.c"
     $or$cond426 = $12 & $181; //@line 112374 "c/sqlite3.c"
     $or$cond427 = $126 & $or$cond426; //@line 112374 "c/sqlite3.c"
     if ($or$cond427) {
      _sqlite3VdbeResolveLabel($14,$147); //@line 112375 "c/sqlite3.c"
      $$2420 = $$1419;$$4408 = $$2406450;
      break;
     }
     $182 = ((($$1454)) + 54|0); //@line 112380 "c/sqlite3.c"
     $183 = HEAP8[$182>>0]|0; //@line 112380 "c/sqlite3.c"
     $184 = ($183<<24>>24)==(0); //@line 112381 "c/sqlite3.c"
     if ($184) {
      _sqlite3VdbeResolveLabel($14,$147); //@line 112382 "c/sqlite3.c"
      $$2420 = $$1419;$$4408 = $$2406450;
      break;
     }
     $185 = ($183<<24>>24)==(10); //@line 112387 "c/sqlite3.c"
     $spec$select428 = $185 ? 2 : $183; //@line 112387 "c/sqlite3.c"
     $$8$shrunk = $131 ? $spec$select428 : $8; //@line 112385 "c/sqlite3.c"
     $$8 = $$8$shrunk&255;
     $186 = ($$0398452|0)==(0); //@line 112398 "c/sqlite3.c"
     do {
      if ($186) {
       $187 = ((($$1454)) + 20|0); //@line 112398 "c/sqlite3.c"
       $188 = HEAP32[$187>>2]|0; //@line 112398 "c/sqlite3.c"
       $189 = ($188|0)==(0|0); //@line 112398 "c/sqlite3.c"
       $190 = ($$8$shrunk<<24>>24)==(5); //@line 112400 "c/sqlite3.c"
       $or$cond3 = $181 & $190; //@line 112400 "c/sqlite3.c"
       $or$cond434 = $or$cond3 & $189; //@line 112399 "c/sqlite3.c"
       if ($or$cond434) {
        $191 = HEAP32[$132>>2]|0; //@line 112401 "c/sqlite3.c"
        $192 = $191 & 8192; //@line 112401 "c/sqlite3.c"
        $193 = ($192|0)==(0); //@line 112401 "c/sqlite3.c"
        if (!($193)) {
         $194 = (_sqlite3TriggersExist($0,$1,109,0,0)|0); //@line 112402 "c/sqlite3.c"
         $195 = ($194|0)==(0|0); //@line 112402 "c/sqlite3.c"
         if (!($195)) {
          break;
         }
        }
        $196 = HEAP32[$132>>2]|0; //@line 112403 "c/sqlite3.c"
        $197 = $196 & 16384; //@line 112403 "c/sqlite3.c"
        $198 = ($197|0)==(0); //@line 112403 "c/sqlite3.c"
        if (!($198)) {
         $199 = HEAP32[$133>>2]|0; //@line 112404 "c/sqlite3.c"
         $200 = ($199|0)==(0|0); //@line 112404 "c/sqlite3.c"
         if (!($200)) {
          break;
         }
         $201 = (_sqlite3FkReferences($1)|0); //@line 112404 "c/sqlite3.c"
         $202 = ($201|0)==(0|0); //@line 112404 "c/sqlite3.c"
         if (!($202)) {
          break;
         }
        }
        _sqlite3VdbeResolveLabel($14,$147); //@line 112406 "c/sqlite3.c"
        $$2420 = $$1419;$$4408 = $$2406450;
        break L81;
       }
      }
     } while(0);
     _sqlite3ExprCachePush($0); //@line 112411 "c/sqlite3.c"
     $203 = ((($$1454)) + 50|0); //@line 112413 "c/sqlite3.c"
     $204 = HEAP16[$203>>1]|0; //@line 112413 "c/sqlite3.c"
     $205 = $204&65535; //@line 112413 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4Int($14,28,$146,$147,$154,$205)|0); //@line 112412 "c/sqlite3.c"
     if ($181) {
      $211 = $154;
     } else {
      $206 = (_sqlite3GetTempRange($0,$$0409)|0); //@line 112416 "c/sqlite3.c"
      $211 = $206;
     }
     $207 = ($$8$shrunk<<24>>24)==(5); //@line 112417 "c/sqlite3.c"
     $or$cond5 = $12 | $207; //@line 112417 "c/sqlite3.c"
     do {
      if ($or$cond5) {
       $208 = HEAP32[$18>>2]|0; //@line 112418 "c/sqlite3.c"
       $209 = $208 & 32; //@line 112418 "c/sqlite3.c"
       $210 = ($209|0)==(0); //@line 112418 "c/sqlite3.c"
       if ($210) {
        (_sqlite3VdbeAddOp2($14,131,$146,$211)|0); //@line 112419 "c/sqlite3.c"
        if (!($12)) {
         break;
        }
        (_sqlite3VdbeAddOp3($14,53,$211,$147,$6)|0); //@line 112423 "c/sqlite3.c"
        _sqlite3VdbeChangeP5($14,144); //@line 112424 "c/sqlite3.c"
        break;
       }
       do {
        if (!($181)) {
         $212 = HEAP16[$135>>1]|0; //@line 112432 "c/sqlite3.c"
         $213 = ($212<<16>>16)==(0); //@line 112432 "c/sqlite3.c"
         if ($213) {
          break;
         }
         $$3440 = 0;
         while(1) {
          $214 = HEAP32[$138>>2]|0; //@line 112434 "c/sqlite3.c"
          $215 = (($214) + ($$3440<<1)|0); //@line 112434 "c/sqlite3.c"
          $216 = HEAP16[$215>>1]|0; //@line 112434 "c/sqlite3.c"
          $217 = (_sqlite3ColumnOfIndex($$1454,$216)|0); //@line 112434 "c/sqlite3.c"
          $218 = $217 << 16 >> 16; //@line 112434 "c/sqlite3.c"
          $219 = (($$3440) + ($211))|0; //@line 112435 "c/sqlite3.c"
          (_sqlite3VdbeAddOp3($14,98,$146,$218,$219)|0); //@line 112435 "c/sqlite3.c"
          $220 = (($$3440) + 1)|0; //@line 112432 "c/sqlite3.c"
          $221 = HEAP16[$135>>1]|0; //@line 112432 "c/sqlite3.c"
          $222 = $221&65535; //@line 112432 "c/sqlite3.c"
          $223 = ($220>>>0)<($222>>>0); //@line 112432 "c/sqlite3.c"
          if ($223) {
           $$3440 = $220;
          } else {
           break;
          }
         }
        }
       } while(0);
       if (!($12)) {
        break;
       }
       $224 = ((($$1454)) + 55|0); //@line 112450 "c/sqlite3.c"
       $225 = HEAPU8[$224>>0]|(HEAPU8[$224+1>>0]<<8); //@line 112450 "c/sqlite3.c"
       $226 = $225 & 3; //@line 112450 "c/sqlite3.c"
       $227 = ($226<<16>>16)==(2); //@line 112450 "c/sqlite3.c"
       $228 = $227 ? $154 : $211; //@line 112450 "c/sqlite3.c"
       $229 = HEAP16[$137>>1]|0; //@line 112452 "c/sqlite3.c"
       $230 = ($229<<16>>16)==(0); //@line 112452 "c/sqlite3.c"
       if ($230) {
        break;
       }
       $231 = HEAP16[$137>>1]|0; //@line 112448 "c/sqlite3.c"
       $232 = $231&65535; //@line 112448 "c/sqlite3.c"
       $233 = (_sqlite3VdbeCurrentAddr($14)|0); //@line 112448 "c/sqlite3.c"
       $234 = (($233) + ($232))|0; //@line 112448 "c/sqlite3.c"
       $$0391445 = 52;$$0393444 = $234;$$4443 = 0;
       while(1) {
        $235 = HEAP32[$139>>2]|0; //@line 112453 "c/sqlite3.c"
        $236 = (($235) + ($$4443<<2)|0); //@line 112453 "c/sqlite3.c"
        $237 = HEAP32[$236>>2]|0; //@line 112453 "c/sqlite3.c"
        $238 = (_sqlite3LocateCollSeq($0,$237)|0); //@line 112453 "c/sqlite3.c"
        $239 = HEAP32[$140>>2]|0; //@line 112454 "c/sqlite3.c"
        $240 = (($239) + ($$4443<<1)|0); //@line 112454 "c/sqlite3.c"
        $241 = HEAP16[$240>>1]|0; //@line 112454 "c/sqlite3.c"
        $242 = $241 << 16 >> 16; //@line 112454 "c/sqlite3.c"
        $243 = HEAP16[$137>>1]|0; //@line 112456 "c/sqlite3.c"
        $244 = $243&65535; //@line 112456 "c/sqlite3.c"
        $245 = (($244) + -1)|0; //@line 112456 "c/sqlite3.c"
        $246 = ($$4443|0)==($245|0); //@line 112456 "c/sqlite3.c"
        $spec$select429 = $246 ? $147 : $$0393444; //@line 112456 "c/sqlite3.c"
        $spec$select430 = $246 ? 53 : $$0391445; //@line 112456 "c/sqlite3.c"
        $247 = (($141) + ($242))|0; //@line 112461 "c/sqlite3.c"
        $248 = (($$4443) + ($228))|0; //@line 112461 "c/sqlite3.c"
        (_sqlite3VdbeAddOp4($14,$spec$select430,$247,$spec$select429,$248,$238,-2)|0); //@line 112460 "c/sqlite3.c"
        _sqlite3VdbeChangeP5($14,144); //@line 112463 "c/sqlite3.c"
        $249 = (($$4443) + 1)|0; //@line 112452 "c/sqlite3.c"
        $250 = HEAP16[$137>>1]|0; //@line 112452 "c/sqlite3.c"
        $251 = $250&65535; //@line 112452 "c/sqlite3.c"
        $252 = ($249>>>0)<($251>>>0); //@line 112452 "c/sqlite3.c"
        if ($252) {
         $$0391445 = $spec$select430;$$0393444 = $spec$select429;$$4443 = $249;
        } else {
         break;
        }
       }
      }
     } while(0);
     switch ($$8$shrunk<<24>>24) {
     case 3: case 2: case 1:  {
      _sqlite3UniqueConstraint($0,$$8,$$1454); //@line 112478 "c/sqlite3.c"
      $$3407 = $$2406450;
      break;
     }
     case 4:  {
      _sqlite3VdbeGoto($14,$9); //@line 112482 "c/sqlite3.c"
      $$3407 = $$2406450;
      break;
     }
     default: {
      _sqlite3MultiWrite($0); //@line 112488 "c/sqlite3.c"
      $253 = HEAP32[$134>>2]|0; //@line 112489 "c/sqlite3.c"
      $254 = $253 & 8192; //@line 112489 "c/sqlite3.c"
      $255 = ($254|0)==(0); //@line 112489 "c/sqlite3.c"
      if ($255) {
       $$0 = 0;
      } else {
       $256 = (_sqlite3TriggersExist($0,$1,109,0,0)|0); //@line 112490 "c/sqlite3.c"
       $$0 = $256;
      }
      $257 = $181&1; //@line 112494 "c/sqlite3.c"
      _sqlite3GenerateRowDelete($0,$1,$$0,$3,$4,$211,$136,0,5,$257,$146); //@line 112492 "c/sqlite3.c"
      $$3407 = 1;
     }
     }
     _sqlite3VdbeResolveLabel($14,$147); //@line 112499 "c/sqlite3.c"
     _sqlite3ExprCachePop($0); //@line 112500 "c/sqlite3.c"
     $258 = ($211|0)==($154|0); //@line 112501 "c/sqlite3.c"
     if ($258) {
      $$2420 = $$1419;$$4408 = $$3407;
     } else {
      _sqlite3ReleaseTempRange($0,$211,$$0409); //@line 112501 "c/sqlite3.c"
      $$2420 = $$1419;$$4408 = $$3407;
     }
    }
   } while(0);
   $259 = ((($$1454)) + 20|0); //@line 112319 "c/sqlite3.c"
   $260 = (($$0398452) + 1)|0; //@line 112319 "c/sqlite3.c"
   $$1 = HEAP32[$259>>2]|0;
   $261 = ($$1|0)==(0|0); //@line 112319 "c/sqlite3.c"
   if ($261) {
    $$2406$lcssa = $$4408;
    break;
   } else {
    $$0398452 = $260;$$0418449 = $$2420;$$1454 = $$1;$$2406450 = $$4408;
   }
  }
 }
 $262 = ($$1412|0)==(0); //@line 112503 "c/sqlite3.c"
 if ($262) {
  HEAP32[$10>>2] = $$2406$lcssa; //@line 112508 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 112510 "c/sqlite3.c"
 }
 $263 = (($$1412) + 1)|0; //@line 112504 "c/sqlite3.c"
 _sqlite3VdbeGoto($14,$263); //@line 112504 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($14,$$1417); //@line 112505 "c/sqlite3.c"
 HEAP32[$10>>2] = $$2406$lcssa; //@line 112508 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 112510 "c/sqlite3.c"
}
function _sqlite3FkCheck($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $$0175 = 0, $$0176 = 0, $$0177194 = 0, $$0179$lcssa = 0, $$0179191 = 0, $$0198 = 0, $$0199 = 0, $$1178192 = 0, $$1180 = 0, $$1186 = 0, $$sink = 0, $$sink$in = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0;
 var $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0;
 var $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0;
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0;
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0;
 var $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp + 8|0;
 $7 = sp + 4|0;
 $8 = sp;
 $9 = HEAP32[$0>>2]|0; //@line 110276 "c/sqlite3.c"
 $10 = ((($0)) + 146|0); //@line 110280 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 110280 "c/sqlite3.c"
 $12 = ((($9)) + 28|0); //@line 110286 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 110286 "c/sqlite3.c"
 $14 = $13 & 16384; //@line 110286 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 110286 "c/sqlite3.c"
 if ($15) {
  STACKTOP = sp;return; //@line 110460 "c/sqlite3.c"
 }
 $16 = ((($1)) + 72|0); //@line 110288 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 110288 "c/sqlite3.c"
 $18 = (_sqlite3SchemaToIndex($9,$17)|0); //@line 110288 "c/sqlite3.c"
 $19 = ((($9)) + 16|0); //@line 110289 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 110289 "c/sqlite3.c"
 $21 = (($20) + ($18<<4)|0); //@line 110289 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 110289 "c/sqlite3.c"
 $23 = ((($1)) + 16|0); //@line 110293 "c/sqlite3.c"
 $$0198 = HEAP32[$23>>2]|0;
 $24 = ($$0198|0)==(0|0); //@line 110293 "c/sqlite3.c"
 L4: do {
  if (!($24)) {
   $25 = ($4|0)==(0|0);
   $26 = ($11<<24>>24)==(0);
   $27 = ((($9)) + 73|0);
   $28 = ((($0)) + 40|0);
   $29 = ($2|0)==(0);
   $30 = ((($1)) + 40|0);
   $31 = ((($9)) + 304|0);
   $32 = (($2) + 1)|0;
   $33 = ($3|0)==(0);
   $$0199 = $$0198;
   L6: while(1) {
    HEAP32[$6>>2] = 0; //@line 110295 "c/sqlite3.c"
    HEAP32[$7>>2] = 0; //@line 110296 "c/sqlite3.c"
    if ($25) {
     label = 7;
    } else {
     $34 = HEAP32[$1>>2]|0; //@line 110303 "c/sqlite3.c"
     $35 = ((($$0199)) + 8|0); //@line 110303 "c/sqlite3.c"
     $36 = HEAP32[$35>>2]|0; //@line 110303 "c/sqlite3.c"
     $37 = (_sqlite3_stricmp($34,$36)|0); //@line 110303 "c/sqlite3.c"
     $38 = ($37|0)==(0); //@line 110303 "c/sqlite3.c"
     if ($38) {
      label = 7;
     } else {
      $39 = (_fkChildIsModified($1,$$0199,$4,$5)|0); //@line 110304 "c/sqlite3.c"
      $40 = ($39|0)==(0); //@line 110304 "c/sqlite3.c"
      if (!($40)) {
       label = 7;
      }
     }
    }
    do {
     if ((label|0) == 7) {
      label = 0;
      $41 = HEAP8[$10>>0]|0; //@line 110313 "c/sqlite3.c"
      $42 = ($41<<24>>24)==(0); //@line 110313 "c/sqlite3.c"
      $43 = ((($$0199)) + 8|0);
      $44 = HEAP32[$43>>2]|0;
      if ($42) {
       $46 = (_sqlite3LocateTable($0,0,$44,$22)|0); //@line 110316 "c/sqlite3.c"
       $$0175 = $46;
      } else {
       $45 = (_sqlite3FindTable($9,$44,$22)|0); //@line 110314 "c/sqlite3.c"
       $$0175 = $45;
      }
      $47 = ($$0175|0)==(0|0); //@line 110318 "c/sqlite3.c"
      if (!($47)) {
       $48 = (_sqlite3FkLocateIndex($0,$$0175,$$0199,$6,$7)|0); //@line 110318 "c/sqlite3.c"
       $49 = ($48|0)==(0); //@line 110318 "c/sqlite3.c"
       if ($49) {
        $68 = HEAP32[$7>>2]|0; //@line 110341 "c/sqlite3.c"
        $69 = ($68|0)==(0|0); //@line 110341 "c/sqlite3.c"
        if ($69) {
         $70 = ((($$0199)) + 36|0); //@line 110344 "c/sqlite3.c"
         $71 = HEAP32[$70>>2]|0; //@line 110344 "c/sqlite3.c"
         HEAP32[$8>>2] = $71; //@line 110344 "c/sqlite3.c"
         $$0176 = $8;
        } else {
         $$0176 = $68;
        }
        $72 = ((($$0199)) + 20|0); //@line 110347 "c/sqlite3.c"
        $73 = HEAP32[$72>>2]|0; //@line 110347 "c/sqlite3.c"
        $74 = ($73|0)>(0); //@line 110347 "c/sqlite3.c"
        if ($74) {
         $75 = ((($$0175)) + 4|0);
         $76 = HEAP32[$6>>2]|0;
         $77 = ($76|0)==(0|0);
         $78 = ((($$0175)) + 40|0);
         $79 = ((($76)) + 4|0);
         $$0179191 = 0;$$1178192 = 0;
         while(1) {
          $80 = (($$0176) + ($$1178192<<2)|0); //@line 110348 "c/sqlite3.c"
          $81 = HEAP32[$80>>2]|0; //@line 110348 "c/sqlite3.c"
          $82 = HEAP16[$30>>1]|0; //@line 110348 "c/sqlite3.c"
          $83 = $82 << 16 >> 16; //@line 110348 "c/sqlite3.c"
          $84 = ($81|0)==($83|0); //@line 110348 "c/sqlite3.c"
          if ($84) {
           HEAP32[$80>>2] = -1; //@line 110349 "c/sqlite3.c"
          }
          $85 = HEAP32[$31>>2]|0; //@line 110356 "c/sqlite3.c"
          $86 = ($85|0)==(0|0); //@line 110356 "c/sqlite3.c"
          if ($86) {
           $$1180 = $$0179191;
          } else {
           $87 = HEAP32[$75>>2]|0; //@line 110358 "c/sqlite3.c"
           if ($77) {
            $$sink$in = $78;
           } else {
            $88 = HEAP32[$79>>2]|0; //@line 110358 "c/sqlite3.c"
            $89 = (($88) + ($$1178192<<1)|0); //@line 110358 "c/sqlite3.c"
            $$sink$in = $89;
           }
           $$sink = HEAP16[$$sink$in>>1]|0;
           $90 = $$sink << 16 >> 16;
           $91 = (($87) + ($90<<4)|0); //@line 110358 "c/sqlite3.c"
           $92 = HEAP32[$91>>2]|0; //@line 110358 "c/sqlite3.c"
           $93 = HEAP32[$$0175>>2]|0; //@line 110359 "c/sqlite3.c"
           $94 = (_sqlite3AuthReadCol($0,$93,$92,$18)|0); //@line 110359 "c/sqlite3.c"
           $95 = ($94|0)==(2); //@line 110360 "c/sqlite3.c"
           $96 = $95&1; //@line 110360 "c/sqlite3.c"
           $$1180 = $96;
          }
          $97 = (($$1178192) + 1)|0; //@line 110347 "c/sqlite3.c"
          $98 = HEAP32[$72>>2]|0; //@line 110347 "c/sqlite3.c"
          $99 = ($97|0)<($98|0); //@line 110347 "c/sqlite3.c"
          if ($99) {
           $$0179191 = $$1180;$$1178192 = $97;
          } else {
           $$0179$lcssa = $$1180;
           break;
          }
         }
        } else {
         $$0179$lcssa = 0;
        }
        $100 = ((($$0175)) + 28|0); //@line 110368 "c/sqlite3.c"
        $101 = HEAP32[$100>>2]|0; //@line 110368 "c/sqlite3.c"
        $102 = HEAP32[$$0175>>2]|0; //@line 110368 "c/sqlite3.c"
        _sqlite3TableLock($0,$18,$101,0,$102); //@line 110368 "c/sqlite3.c"
        $103 = HEAP32[$28>>2]|0; //@line 110369 "c/sqlite3.c"
        $104 = (($103) + 1)|0; //@line 110369 "c/sqlite3.c"
        HEAP32[$28>>2] = $104; //@line 110369 "c/sqlite3.c"
        if (!($29)) {
         $105 = HEAP32[$6>>2]|0; //@line 110375 "c/sqlite3.c"
         _fkLookupParent($0,$18,$$0175,$105,$$0199,$$0176,$2,-1,$$0179$lcssa); //@line 110375 "c/sqlite3.c"
        }
        if (!($33)) {
         $106 = (_isSetNullAction($0,$$0199)|0); //@line 110377 "c/sqlite3.c"
         $107 = ($106|0)==(0); //@line 110377 "c/sqlite3.c"
         if ($107) {
          $108 = HEAP32[$6>>2]|0; //@line 110386 "c/sqlite3.c"
          _fkLookupParent($0,$18,$$0175,$108,$$0199,$$0176,$3,1,$$0179$lcssa); //@line 110386 "c/sqlite3.c"
         }
        }
        $109 = HEAP32[$7>>2]|0; //@line 110389 "c/sqlite3.c"
        _sqlite3DbFree($9,$109); //@line 110389 "c/sqlite3.c"
        break;
       }
      }
      if ($26) {
       break L6;
      }
      $50 = HEAP8[$27>>0]|0; //@line 110320 "c/sqlite3.c"
      $51 = ($50<<24>>24)==(0); //@line 110320 "c/sqlite3.c"
      if (!($51)) {
       break L6;
      }
      if ($47) {
       $52 = (_sqlite3GetVdbe($0)|0); //@line 110329 "c/sqlite3.c"
       $53 = (_sqlite3VdbeCurrentAddr($52)|0); //@line 110330 "c/sqlite3.c"
       $54 = ((($$0199)) + 20|0); //@line 110330 "c/sqlite3.c"
       $55 = HEAP32[$54>>2]|0; //@line 110330 "c/sqlite3.c"
       $56 = (($53) + 1)|0; //@line 110330 "c/sqlite3.c"
       $57 = (($56) + ($55))|0; //@line 110330 "c/sqlite3.c"
       $58 = ($55|0)>(0); //@line 110331 "c/sqlite3.c"
       if ($58) {
        $$0177194 = 0;
        while(1) {
         $59 = (((($$0199)) + 36|0) + ($$0177194<<3)|0); //@line 110332 "c/sqlite3.c"
         $60 = HEAP32[$59>>2]|0; //@line 110332 "c/sqlite3.c"
         $61 = (($32) + ($60))|0; //@line 110332 "c/sqlite3.c"
         (_sqlite3VdbeAddOp2($52,50,$61,$57)|0); //@line 110333 "c/sqlite3.c"
         $62 = (($$0177194) + 1)|0; //@line 110331 "c/sqlite3.c"
         $63 = HEAP32[$54>>2]|0; //@line 110331 "c/sqlite3.c"
         $64 = ($62|0)<($63|0); //@line 110331 "c/sqlite3.c"
         if ($64) {
          $$0177194 = $62;
         } else {
          break;
         }
        }
       }
       $65 = ((($$0199)) + 24|0); //@line 110335 "c/sqlite3.c"
       $66 = HEAP8[$65>>0]|0; //@line 110335 "c/sqlite3.c"
       $67 = $66&255; //@line 110335 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($52,146,$67,-1)|0); //@line 110335 "c/sqlite3.c"
      }
     }
    } while(0);
    $110 = ((($$0199)) + 4|0); //@line 110293 "c/sqlite3.c"
    $$0 = HEAP32[$110>>2]|0;
    $111 = ($$0|0)==(0|0); //@line 110293 "c/sqlite3.c"
    if ($111) {
     break L4;
    } else {
     $$0199 = $$0;
    }
   }
   STACKTOP = sp;return; //@line 110460 "c/sqlite3.c"
  }
 } while(0);
 $112 = (_sqlite3FkReferences($1)|0); //@line 110394 "c/sqlite3.c"
 $113 = ($112|0)==(0|0); //@line 110394 "c/sqlite3.c"
 if ($113) {
  STACKTOP = sp;return; //@line 110460 "c/sqlite3.c"
 }
 $114 = ($4|0)!=(0|0);
 $115 = ((($0)) + 120|0);
 $116 = ($11<<24>>24)==(0);
 $117 = ((($0)) + 20|0);
 $118 = ((($0)) + 40|0);
 $119 = ($3|0)==(0);
 $120 = ((($9)) + 73|0);
 $121 = ($2|0)==(0);
 $122 = $114&1;
 $$1186 = $112;
 L60: while(1) {
  HEAP32[$6>>2] = 0; //@line 110395 "c/sqlite3.c"
  HEAP32[$7>>2] = 0; //@line 110397 "c/sqlite3.c"
  if ($114) {
   $123 = (_fkParentIsModified($1,$$1186,$4,$5)|0); //@line 110399 "c/sqlite3.c"
   $124 = ($123|0)==(0); //@line 110399 "c/sqlite3.c"
   if ($124) {
    label = 58;
   } else {
    label = 42;
   }
  } else {
   label = 42;
  }
  do {
   if ((label|0) == 42) {
    label = 0;
    $125 = ((($$1186)) + 24|0); //@line 110403 "c/sqlite3.c"
    $126 = HEAP8[$125>>0]|0; //@line 110403 "c/sqlite3.c"
    $127 = ($126<<24>>24)==(0); //@line 110403 "c/sqlite3.c"
    if ($127) {
     $128 = HEAP32[$12>>2]|0; //@line 110403 "c/sqlite3.c"
     $129 = $128 & 524288; //@line 110403 "c/sqlite3.c"
     $130 = ($129|0)==(0); //@line 110403 "c/sqlite3.c"
     if ($130) {
      $131 = HEAP32[$115>>2]|0; //@line 110404 "c/sqlite3.c"
      $132 = ($131|0)==(0|0); //@line 110404 "c/sqlite3.c"
      if ($132) {
       $133 = HEAP8[$117>>0]|0; //@line 110404 "c/sqlite3.c"
       $134 = ($133<<24>>24)==(0); //@line 110404 "c/sqlite3.c"
       if ($134) {
        label = 58;
        break;
       }
      }
     }
    }
    $135 = (_sqlite3FkLocateIndex($0,$1,$$1186,$6,$7)|0); //@line 110412 "c/sqlite3.c"
    $136 = ($135|0)==(0); //@line 110412 "c/sqlite3.c"
    if (!($136)) {
     if ($116) {
      label = 48;
      break L60;
     }
     $160 = HEAP8[$120>>0]|0; //@line 110413 "c/sqlite3.c"
     $161 = ($160<<24>>24)==(0); //@line 110413 "c/sqlite3.c"
     if ($161) {
      break;
     } else {
      label = 61;
      break L60;
     }
    }
    $137 = (_sqlite3SrcListAppend($9,0,0,0)|0); //@line 110420 "c/sqlite3.c"
    $138 = ($137|0)==(0|0); //@line 110421 "c/sqlite3.c"
    if (!($138)) {
     $139 = HEAP32[$$1186>>2]|0; //@line 110423 "c/sqlite3.c"
     $140 = ((($137)) + 24|0); //@line 110423 "c/sqlite3.c"
     HEAP32[$140>>2] = $139; //@line 110423 "c/sqlite3.c"
     $141 = HEAP32[$$1186>>2]|0; //@line 110424 "c/sqlite3.c"
     $142 = HEAP32[$141>>2]|0; //@line 110424 "c/sqlite3.c"
     $143 = ((($137)) + 16|0); //@line 110424 "c/sqlite3.c"
     HEAP32[$143>>2] = $142; //@line 110424 "c/sqlite3.c"
     $144 = HEAP32[$140>>2]|0; //@line 110425 "c/sqlite3.c"
     $145 = ((($144)) + 32|0); //@line 110425 "c/sqlite3.c"
     $146 = HEAP32[$145>>2]|0; //@line 110425 "c/sqlite3.c"
     $147 = (($146) + 1)|0; //@line 110425 "c/sqlite3.c"
     HEAP32[$145>>2] = $147; //@line 110425 "c/sqlite3.c"
     $148 = HEAP32[$118>>2]|0; //@line 110426 "c/sqlite3.c"
     $149 = (($148) + 1)|0; //@line 110426 "c/sqlite3.c"
     HEAP32[$118>>2] = $149; //@line 110426 "c/sqlite3.c"
     $150 = ((($137)) + 52|0); //@line 110426 "c/sqlite3.c"
     HEAP32[$150>>2] = $148; //@line 110426 "c/sqlite3.c"
     if (!($119)) {
      $151 = HEAP32[$6>>2]|0; //@line 110429 "c/sqlite3.c"
      $152 = HEAP32[$7>>2]|0; //@line 110429 "c/sqlite3.c"
      _fkScanChildren($0,$137,$1,$151,$$1186,$152,$3,-1); //@line 110429 "c/sqlite3.c"
     }
     L80: do {
      if (!($121)) {
       $153 = (((($$1186)) + 25|0) + ($122)|0); //@line 110432 "c/sqlite3.c"
       $154 = HEAP8[$153>>0]|0; //@line 110432 "c/sqlite3.c"
       $155 = HEAP32[$6>>2]|0; //@line 110433 "c/sqlite3.c"
       $156 = HEAP32[$7>>2]|0; //@line 110433 "c/sqlite3.c"
       _fkScanChildren($0,$137,$1,$155,$$1186,$156,$2,1); //@line 110433 "c/sqlite3.c"
       $157 = HEAP8[$125>>0]|0; //@line 110451 "c/sqlite3.c"
       $158 = ($157<<24>>24)==(0); //@line 110451 "c/sqlite3.c"
       if ($158) {
        switch ($154<<24>>24) {
        case 7: case 9:  {
         break L80;
         break;
        }
        default: {
        }
        }
        _sqlite3MayAbort($0); //@line 110452 "c/sqlite3.c"
       }
      }
     } while(0);
     HEAP32[$143>>2] = 0; //@line 110455 "c/sqlite3.c"
     _sqlite3SrcListDelete($9,$137); //@line 110456 "c/sqlite3.c"
    }
    $159 = HEAP32[$7>>2]|0; //@line 110458 "c/sqlite3.c"
    _sqlite3DbFree($9,$159); //@line 110458 "c/sqlite3.c"
    label = 58;
   }
  } while(0);
  if ((label|0) == 58) {
   label = 0;
  }
  $162 = ((($$1186)) + 12|0); //@line 110394 "c/sqlite3.c"
  $163 = HEAP32[$162>>2]|0; //@line 110394 "c/sqlite3.c"
  $164 = ($163|0)==(0|0); //@line 110394 "c/sqlite3.c"
  if ($164) {
   label = 61;
   break;
  } else {
   $$1186 = $163;
  }
 }
 if ((label|0) == 48) {
  STACKTOP = sp;return; //@line 110460 "c/sqlite3.c"
 }
 else if ((label|0) == 61) {
  STACKTOP = sp;return; //@line 110460 "c/sqlite3.c"
 }
}
function _sqlite3CompleteInsertion($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$0$lcssa = 0, $$06772 = 0, $$068 = 0, $$06871 = 0, $$06875 = 0, $$069 = 0, $$074 = 0, $$1 = 0, $$170 = 0, $$3 = 0, $$op = 0, $$sink = 0, $$sink$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $9 = 0, $spec$select = 0, $spec$select76 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $9 = (_sqlite3GetVdbe($0)|0); //@line 112567 "c/sqlite3.c"
 $10 = ((($1)) + 8|0); //@line 112570 "c/sqlite3.c"
 $$06871 = HEAP32[$10>>2]|0;
 $11 = ($$06871|0)==(0|0); //@line 112570 "c/sqlite3.c"
 if ($11) {
  $$0$lcssa = 0;
 } else {
  $12 = ($8|0)==(0);
  $13 = $12 ? 0 : 16;
  $14 = ((($1)) + 36|0);
  $15 = $6 & 2;
  $16 = $13 | 1;
  $17 = $16&255;
  $18 = $15 | $17;
  $19 = $18&255;
  $$06772 = 0;$$06875 = $$06871;$$074 = 0;
  while(1) {
   $20 = (($5) + ($$06772<<2)|0); //@line 112571 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 112571 "c/sqlite3.c"
   $22 = ($21|0)==(0); //@line 112571 "c/sqlite3.c"
   if ($22) {
    $$1 = $$074;
   } else {
    $23 = ((($$06875)) + 36|0); //@line 112573 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 112573 "c/sqlite3.c"
    $25 = ($24|0)==(0|0); //@line 112573 "c/sqlite3.c"
    if (!($25)) {
     $26 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 112574 "c/sqlite3.c"
     $27 = (($26) + 2)|0; //@line 112574 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($9,50,$21,$27)|0); //@line 112574 "c/sqlite3.c"
    }
    $28 = ((($$06875)) + 55|0); //@line 112578 "c/sqlite3.c"
    $29 = HEAPU8[$28>>0]|(HEAPU8[$28+1>>0]<<8); //@line 112578 "c/sqlite3.c"
    $30 = $29 & 3; //@line 112578 "c/sqlite3.c"
    $31 = ($30<<16>>16)==(2); //@line 112578 "c/sqlite3.c"
    if ($31) {
     $32 = HEAP32[$14>>2]|0; //@line 112578 "c/sqlite3.c"
     $33 = $32 & 32; //@line 112578 "c/sqlite3.c"
     $34 = ($33|0)==(0); //@line 112578 "c/sqlite3.c"
     $spec$select76 = $34 ? $13 : $19; //@line 112578 "c/sqlite3.c"
     $$069 = $spec$select76;
    } else {
     $$069 = $13;
    }
    $35 = (($$06772) + ($3))|0; //@line 112591 "c/sqlite3.c"
    $36 = HEAP32[$20>>2]|0; //@line 112591 "c/sqlite3.c"
    $37 = (($36) + 1)|0; //@line 112592 "c/sqlite3.c"
    $38 = $29 & 8; //@line 112593 "c/sqlite3.c"
    $39 = ($38<<16>>16)==(0); //@line 112593 "c/sqlite3.c"
    $40 = ((($$06875)) + 52|0); //@line 112593 "c/sqlite3.c"
    $41 = ((($$06875)) + 50|0); //@line 112593 "c/sqlite3.c"
    $$sink$in = $39 ? $40 : $41; //@line 112593 "c/sqlite3.c"
    $$sink = HEAP16[$$sink$in>>1]|0;
    $42 = $$sink&65535;
    (_sqlite3VdbeAddOp4Int($9,128,$35,$36,$37,$42)|0); //@line 112591 "c/sqlite3.c"
    $43 = $$069&255; //@line 112594 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($9,$43); //@line 112594 "c/sqlite3.c"
    $$1 = 1;
   }
   $44 = ((($$06875)) + 20|0); //@line 112570 "c/sqlite3.c"
   $45 = (($$06772) + 1)|0; //@line 112570 "c/sqlite3.c"
   $$068 = HEAP32[$44>>2]|0;
   $46 = ($$068|0)==(0|0); //@line 112570 "c/sqlite3.c"
   if ($46) {
    $$0$lcssa = $$1;
    break;
   } else {
    $$06772 = $45;$$06875 = $$068;$$074 = $$1;
   }
  }
 }
 $47 = ((($1)) + 36|0); //@line 112596 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 112596 "c/sqlite3.c"
 $49 = $48 & 32; //@line 112596 "c/sqlite3.c"
 $50 = ($49|0)==(0); //@line 112596 "c/sqlite3.c"
 if (!($50)) {
  return; //@line 112622 "c/sqlite3.c"
 }
 $51 = (($4) + 1)|0; //@line 112597 "c/sqlite3.c"
 $52 = (_sqlite3GetTempReg($0)|0); //@line 112598 "c/sqlite3.c"
 $53 = ((($1)) + 42|0); //@line 112599 "c/sqlite3.c"
 $54 = HEAP16[$53>>1]|0; //@line 112599 "c/sqlite3.c"
 $55 = $54 << 16 >> 16; //@line 112599 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($9,100,$51,$55,$52)|0); //@line 112599 "c/sqlite3.c"
 $56 = ($$0$lcssa<<24>>24)==(0); //@line 112601 "c/sqlite3.c"
 if ($56) {
  _sqlite3TableAffinity($9,$1,0); //@line 112602 "c/sqlite3.c"
  $57 = HEAP16[$53>>1]|0; //@line 112603 "c/sqlite3.c"
  $58 = $57 << 16 >> 16; //@line 112603 "c/sqlite3.c"
  _sqlite3ExprCacheAffinityChange($0,$51,$58); //@line 112603 "c/sqlite3.c"
 }
 $59 = ((($0)) + 18|0); //@line 112605 "c/sqlite3.c"
 $60 = HEAP8[$59>>0]|0; //@line 112605 "c/sqlite3.c"
 $61 = ($60<<24>>24)==(0); //@line 112605 "c/sqlite3.c"
 $62 = ($6|0)==(0); //@line 112609 "c/sqlite3.c"
 $$op = $6 | 1; //@line 112609 "c/sqlite3.c"
 $63 = $$op&255; //@line 112609 "c/sqlite3.c"
 $64 = $62 ? 33 : $63; //@line 112609 "c/sqlite3.c"
 $$170 = $61 ? $64 : 0; //@line 112605 "c/sqlite3.c"
 $65 = ($7|0)==(0); //@line 112611 "c/sqlite3.c"
 $66 = $$170 | 8; //@line 112612 "c/sqlite3.c"
 $spec$select = $65 ? $$170 : $66; //@line 112611 "c/sqlite3.c"
 $67 = ($8|0)==(0); //@line 112614 "c/sqlite3.c"
 $68 = $spec$select | 16; //@line 112615 "c/sqlite3.c"
 $$3 = $67 ? $spec$select : $68; //@line 112614 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($9,117,$2,$52,$4)|0); //@line 112617 "c/sqlite3.c"
 $69 = HEAP8[$59>>0]|0; //@line 112618 "c/sqlite3.c"
 $70 = ($69<<24>>24)==(0); //@line 112618 "c/sqlite3.c"
 if ($70) {
  _sqlite3VdbeAppendP4($9,$1,-6); //@line 112619 "c/sqlite3.c"
 }
 $71 = $$3&255; //@line 112621 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($9,$71); //@line 112621 "c/sqlite3.c"
 return; //@line 112622 "c/sqlite3.c"
}
function _sqlite3AutoincrementEnd($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 116|0); //@line 111197 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 111197 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 111197 "c/sqlite3.c"
 if ($3) {
  return; //@line 111198 "c/sqlite3.c"
 }
 _autoIncrementEnd($0); //@line 111197 "c/sqlite3.c"
 return; //@line 111198 "c/sqlite3.c"
}
function _autoIncrementEnd($0) {
 $0 = $0|0;
 var $$042 = 0, $$04243 = 0, $$04244 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 111163 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 111163 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 111164 "c/sqlite3.c"
 $4 = ((($0)) + 116|0); //@line 111167 "c/sqlite3.c"
 $5 = ((($3)) + 16|0); //@line 111177 "c/sqlite3.c"
 $$04243 = HEAP32[$4>>2]|0;
 $6 = ($$04243|0)==(0|0); //@line 111167 "c/sqlite3.c"
 if ($6) {
  return; //@line 111195 "c/sqlite3.c"
 }
 $$04244 = $$04243;
 while(1) {
  $7 = HEAP32[$5>>2]|0; //@line 111177 "c/sqlite3.c"
  $8 = ((($$04244)) + 8|0); //@line 111177 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 111177 "c/sqlite3.c"
  $10 = ((($$04244)) + 12|0); //@line 111179 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 111179 "c/sqlite3.c"
  $12 = (_sqlite3GetTempReg($0)|0); //@line 111181 "c/sqlite3.c"
  $13 = HEAP32[$8>>2]|0; //@line 111183 "c/sqlite3.c"
  $14 = (((($7) + ($9<<4)|0)) + 12|0); //@line 111183 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 111183 "c/sqlite3.c"
  $16 = ((($15)) + 72|0); //@line 111183 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 111183 "c/sqlite3.c"
  _sqlite3OpenTable($0,0,$13,$17,106); //@line 111183 "c/sqlite3.c"
  $18 = (_sqlite3VdbeAddOpList($2,5,27311)|0); //@line 111184 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 111185 "c/sqlite3.c"
  if ($19) {
   label = 5;
   break;
  }
  $20 = (($11) + 1)|0; //@line 111186 "c/sqlite3.c"
  $21 = ((($18)) + 4|0); //@line 111186 "c/sqlite3.c"
  HEAP32[$21>>2] = $20; //@line 111186 "c/sqlite3.c"
  $22 = ((($18)) + 28|0); //@line 111187 "c/sqlite3.c"
  HEAP32[$22>>2] = $20; //@line 111187 "c/sqlite3.c"
  $23 = (($11) + -1)|0; //@line 111188 "c/sqlite3.c"
  $24 = ((($18)) + 44|0); //@line 111188 "c/sqlite3.c"
  HEAP32[$24>>2] = $23; //@line 111188 "c/sqlite3.c"
  $25 = ((($18)) + 52|0); //@line 111189 "c/sqlite3.c"
  HEAP32[$25>>2] = $12; //@line 111189 "c/sqlite3.c"
  $26 = ((($18)) + 68|0); //@line 111190 "c/sqlite3.c"
  HEAP32[$26>>2] = $12; //@line 111190 "c/sqlite3.c"
  $27 = ((($18)) + 72|0); //@line 111191 "c/sqlite3.c"
  HEAP32[$27>>2] = $20; //@line 111191 "c/sqlite3.c"
  $28 = ((($18)) + 62|0); //@line 111192 "c/sqlite3.c"
  HEAP16[$28>>1] = 8; //@line 111192 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$12); //@line 111193 "c/sqlite3.c"
  $$042 = HEAP32[$$04244>>2]|0;
  $29 = ($$042|0)==(0|0); //@line 111167 "c/sqlite3.c"
  if ($29) {
   label = 5;
   break;
  } else {
   $$04244 = $$042;
  }
 }
 if ((label|0) == 5) {
  return; //@line 111195 "c/sqlite3.c"
 }
}
function _fkChildIsModified($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$01617 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $not$or$cond = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $4 = ((($1)) + 20|0); //@line 110186 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 110186 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 110186 "c/sqlite3.c"
 if (!($6)) {
  $$2 = 0;
  return ($$2|0); //@line 110192 "c/sqlite3.c"
 }
 $7 = ((($0)) + 40|0);
 $8 = ($3|0)==(0);
 $$01617 = 0;
 while(1) {
  $12 = (((($1)) + 36|0) + ($$01617<<3)|0); //@line 110187 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 110187 "c/sqlite3.c"
  $14 = (($2) + ($13<<2)|0); //@line 110188 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 110188 "c/sqlite3.c"
  $16 = ($15|0)>(-1); //@line 110188 "c/sqlite3.c"
  if ($16) {
   $$2 = 1;
   label = 6;
   break;
  }
  $17 = HEAP16[$7>>1]|0; //@line 110189 "c/sqlite3.c"
  $18 = $17 << 16 >> 16; //@line 110189 "c/sqlite3.c"
  $19 = ($13|0)!=($18|0); //@line 110189 "c/sqlite3.c"
  $not$or$cond = $8 | $19; //@line 110189 "c/sqlite3.c"
  $11 = (($$01617) + 1)|0; //@line 110186 "c/sqlite3.c"
  if (!($not$or$cond)) {
   $$2 = 1;
   label = 6;
   break;
  }
  $9 = HEAP32[$4>>2]|0; //@line 110186 "c/sqlite3.c"
  $10 = ($11|0)<($9|0); //@line 110186 "c/sqlite3.c"
  if ($10) {
   $$01617 = $11;
  } else {
   $$2 = 0;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  return ($$2|0); //@line 110192 "c/sqlite3.c"
 }
 return (0)|0;
}
function _fkLookupParent($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$0150157 = 0, $$1153 = 0, $$2152 = 0, $$lcssa = 0, $$not151 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $brmerge = 0, $exitcond = 0, $exitcond162 = 0, $or$cond = 0, $or$cond3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $9 = (_sqlite3GetVdbe($0)|0); //@line 109743 "c/sqlite3.c"
 $10 = ((($0)) + 40|0); //@line 109744 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 109744 "c/sqlite3.c"
 $12 = (($11) + -1)|0; //@line 109744 "c/sqlite3.c"
 $13 = (_sqlite3VdbeMakeLabel($9)|0); //@line 109745 "c/sqlite3.c"
 $14 = ($7|0)<(0); //@line 109754 "c/sqlite3.c"
 if ($14) {
  $15 = ((($4)) + 24|0); //@line 109755 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 109755 "c/sqlite3.c"
  $17 = $16&255; //@line 109755 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($9,47,$17,$13)|0); //@line 109755 "c/sqlite3.c"
 }
 $18 = ((($4)) + 20|0); //@line 109758 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 109758 "c/sqlite3.c"
 $20 = ($19|0)>(0); //@line 109758 "c/sqlite3.c"
 if ($20) {
  $21 = (($6) + 1)|0;
  $$0150157 = 0;
  while(1) {
   $22 = (($5) + ($$0150157<<2)|0); //@line 109759 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 109759 "c/sqlite3.c"
   $24 = (($21) + ($23))|0; //@line 109759 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($9,50,$24,$13)|0); //@line 109760 "c/sqlite3.c"
   $25 = (($$0150157) + 1)|0; //@line 109758 "c/sqlite3.c"
   $26 = HEAP32[$18>>2]|0; //@line 109758 "c/sqlite3.c"
   $27 = ($25|0)<($26|0); //@line 109758 "c/sqlite3.c"
   if ($27) {
    $$0150157 = $25;
   } else {
    $$lcssa = $26;
    break;
   }
  }
 } else {
  $$lcssa = $19;
 }
 $28 = ($8|0)==(0); //@line 109763 "c/sqlite3.c"
 do {
  if ($28) {
   $29 = ($3|0)==(0|0); //@line 109764 "c/sqlite3.c"
   if ($29) {
    $30 = (_sqlite3GetTempReg($0)|0); //@line 109768 "c/sqlite3.c"
    $31 = HEAP32[$5>>2]|0; //@line 109775 "c/sqlite3.c"
    $32 = (($6) + 1)|0; //@line 109775 "c/sqlite3.c"
    $33 = (($32) + ($31))|0; //@line 109775 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($9,76,$33,$30)|0); //@line 109775 "c/sqlite3.c"
    $34 = (_sqlite3VdbeAddOp2($9,17,$30,0)|0); //@line 109776 "c/sqlite3.c"
    $35 = HEAP32[$4>>2]|0; //@line 109783 "c/sqlite3.c"
    $36 = ($35|0)==($2|0); //@line 109783 "c/sqlite3.c"
    $37 = ($7|0)==(1); //@line 109783 "c/sqlite3.c"
    $or$cond = $37 & $36; //@line 109783 "c/sqlite3.c"
    if ($or$cond) {
     (_sqlite3VdbeAddOp3($9,53,$6,$13,$30)|0); //@line 109784 "c/sqlite3.c"
     _sqlite3VdbeChangeP5($9,144); //@line 109785 "c/sqlite3.c"
    }
    _sqlite3OpenTable($0,$12,$1,$2,105); //@line 109788 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($9,32,$12,0,$30)|0); //@line 109789 "c/sqlite3.c"
    _sqlite3VdbeGoto($9,$13); //@line 109790 "c/sqlite3.c"
    $38 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 109791 "c/sqlite3.c"
    $39 = (($38) + -2)|0; //@line 109791 "c/sqlite3.c"
    _sqlite3VdbeJumpHere($9,$39); //@line 109791 "c/sqlite3.c"
    _sqlite3VdbeJumpHere($9,$34); //@line 109792 "c/sqlite3.c"
    _sqlite3ReleaseTempReg($0,$30); //@line 109793 "c/sqlite3.c"
    break;
   }
   $40 = (_sqlite3GetTempRange($0,$$lcssa)|0); //@line 109796 "c/sqlite3.c"
   $41 = (_sqlite3GetTempReg($0)|0); //@line 109797 "c/sqlite3.c"
   $42 = ((($3)) + 44|0); //@line 109799 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 109799 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($9,105,$12,$43,$1)|0); //@line 109799 "c/sqlite3.c"
   _sqlite3VdbeSetP4KeyInfo($0,$3); //@line 109800 "c/sqlite3.c"
   $44 = ($$lcssa|0)>(0); //@line 109801 "c/sqlite3.c"
   if ($44) {
    $45 = (($6) + 1)|0;
    $$1153 = 0;
    while(1) {
     $46 = (($5) + ($$1153<<2)|0); //@line 109802 "c/sqlite3.c"
     $47 = HEAP32[$46>>2]|0; //@line 109802 "c/sqlite3.c"
     $48 = (($45) + ($47))|0; //@line 109802 "c/sqlite3.c"
     $49 = (($$1153) + ($40))|0; //@line 109802 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($9,75,$48,$49)|0); //@line 109802 "c/sqlite3.c"
     $50 = (($$1153) + 1)|0; //@line 109801 "c/sqlite3.c"
     $exitcond162 = ($50|0)==($$lcssa|0); //@line 109801 "c/sqlite3.c"
     if ($exitcond162) {
      break;
     } else {
      $$1153 = $50;
     }
    }
   }
   $51 = HEAP32[$4>>2]|0; //@line 109815 "c/sqlite3.c"
   $52 = ($51|0)==($2|0); //@line 109815 "c/sqlite3.c"
   $53 = ($7|0)==(1); //@line 109815 "c/sqlite3.c"
   $or$cond3 = $53 & $52; //@line 109815 "c/sqlite3.c"
   if ($or$cond3) {
    $54 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 109816 "c/sqlite3.c"
    $55 = (($$lcssa) + 1)|0; //@line 109816 "c/sqlite3.c"
    $56 = (($55) + ($54))|0; //@line 109816 "c/sqlite3.c"
    $57 = ($$lcssa|0)>(0); //@line 109817 "c/sqlite3.c"
    if ($57) {
     $58 = (($6) + 1)|0;
     $59 = ((($3)) + 4|0);
     $60 = ((($2)) + 40|0);
     $$2152 = 0;
     while(1) {
      $61 = (($5) + ($$2152<<2)|0); //@line 109818 "c/sqlite3.c"
      $62 = HEAP32[$61>>2]|0; //@line 109818 "c/sqlite3.c"
      $63 = (($58) + ($62))|0; //@line 109818 "c/sqlite3.c"
      $64 = HEAP32[$59>>2]|0; //@line 109819 "c/sqlite3.c"
      $65 = (($64) + ($$2152<<1)|0); //@line 109819 "c/sqlite3.c"
      $66 = HEAP16[$65>>1]|0; //@line 109819 "c/sqlite3.c"
      $67 = $66 << 16 >> 16; //@line 109819 "c/sqlite3.c"
      $68 = (($67) + 1)|0; //@line 109819 "c/sqlite3.c"
      $69 = HEAP16[$60>>1]|0; //@line 109822 "c/sqlite3.c"
      $70 = ($66<<16>>16)==($69<<16>>16); //@line 109822 "c/sqlite3.c"
      $71 = $70 ? 0 : $68; //@line 109822 "c/sqlite3.c"
      $spec$select = (($71) + ($6))|0; //@line 109822 "c/sqlite3.c"
      (_sqlite3VdbeAddOp3($9,52,$63,$56,$spec$select)|0); //@line 109826 "c/sqlite3.c"
      _sqlite3VdbeChangeP5($9,16); //@line 109827 "c/sqlite3.c"
      $72 = (($$2152) + 1)|0; //@line 109817 "c/sqlite3.c"
      $exitcond = ($72|0)==($$lcssa|0); //@line 109817 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$2152 = $72;
      }
     }
    }
    _sqlite3VdbeGoto($9,$13); //@line 109829 "c/sqlite3.c"
   }
   $73 = HEAP32[$0>>2]|0; //@line 109833 "c/sqlite3.c"
   $74 = (_sqlite3IndexAffinityStr($73,$3)|0); //@line 109833 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($9,100,$40,$$lcssa,$41,$74,$$lcssa)|0); //@line 109832 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4Int($9,30,$12,$13,$41,0)|0); //@line 109834 "c/sqlite3.c"
   _sqlite3ReleaseTempReg($0,$41); //@line 109836 "c/sqlite3.c"
   _sqlite3ReleaseTempRange($0,$40,$$lcssa); //@line 109837 "c/sqlite3.c"
  }
 } while(0);
 $75 = ((($4)) + 24|0); //@line 109841 "c/sqlite3.c"
 $76 = HEAP8[$75>>0]|0; //@line 109841 "c/sqlite3.c"
 $77 = ($76<<24>>24)==(0); //@line 109841 "c/sqlite3.c"
 if ($77) {
  $78 = HEAP32[$0>>2]|0; //@line 109841 "c/sqlite3.c"
  $79 = ((($78)) + 28|0); //@line 109841 "c/sqlite3.c"
  $80 = HEAP32[$79>>2]|0; //@line 109841 "c/sqlite3.c"
  $81 = $80 & 524288; //@line 109841 "c/sqlite3.c"
  $82 = ($81|0)==(0); //@line 109841 "c/sqlite3.c"
  if ($82) {
   $83 = ((($0)) + 120|0); //@line 109842 "c/sqlite3.c"
   $84 = HEAP32[$83>>2]|0; //@line 109842 "c/sqlite3.c"
   $85 = ($84|0)==(0|0); //@line 109842 "c/sqlite3.c"
   if ($85) {
    $86 = ((($0)) + 20|0); //@line 109843 "c/sqlite3.c"
    $87 = HEAP8[$86>>0]|0; //@line 109843 "c/sqlite3.c"
    $88 = ($87<<24>>24)==(0); //@line 109843 "c/sqlite3.c"
    if ($88) {
     _sqlite3HaltConstraint($0,787,2,0,-1,4); //@line 109850 "c/sqlite3.c"
     _sqlite3VdbeResolveLabel($9,$13); //@line 109859 "c/sqlite3.c"
     (_sqlite3VdbeAddOp1($9,113,$12)|0); //@line 109860 "c/sqlite3.c"
     return; //@line 109861 "c/sqlite3.c"
    }
   }
  }
  $89 = ($7|0)<(1); //@line 109853 "c/sqlite3.c"
  $$not151 = $77 ^ 1; //@line 109853 "c/sqlite3.c"
  $brmerge = $89 | $$not151; //@line 109853 "c/sqlite3.c"
  if (!($brmerge)) {
   _sqlite3MayAbort($0); //@line 109854 "c/sqlite3.c"
  }
 }
 $90 = HEAP8[$75>>0]|0; //@line 109856 "c/sqlite3.c"
 $91 = $90&255; //@line 109856 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($9,146,$91,$7)|0); //@line 109856 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($9,$13); //@line 109859 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($9,113,$12)|0); //@line 109860 "c/sqlite3.c"
 return; //@line 109861 "c/sqlite3.c"
}
function _isSetNullAction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 120|0); //@line 110236 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 110236 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 110236 "c/sqlite3.c"
 $spec$select = $4 ? $0 : $3; //@line 110236 "c/sqlite3.c"
 $5 = ((($spec$select)) + 460|0); //@line 110237 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 110237 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 110237 "c/sqlite3.c"
 if ($7) {
  $$1 = 0;
  return ($$1|0); //@line 110246 "c/sqlite3.c"
 }
 $8 = HEAP32[$6>>2]|0; //@line 110238 "c/sqlite3.c"
 $9 = ((($1)) + 28|0); //@line 110239 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 110239 "c/sqlite3.c"
 $11 = ($8|0)==($10|0); //@line 110239 "c/sqlite3.c"
 if ($11) {
  $12 = ((($1)) + 25|0); //@line 110239 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 110239 "c/sqlite3.c"
  $14 = ($13<<24>>24)==(7); //@line 110239 "c/sqlite3.c"
  if ($14) {
   $$1 = 1;
   return ($$1|0); //@line 110246 "c/sqlite3.c"
  }
 }
 $15 = ((($1)) + 32|0); //@line 110240 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 110240 "c/sqlite3.c"
 $17 = ($8|0)==($16|0); //@line 110240 "c/sqlite3.c"
 if ($17) {
  $18 = ((($1)) + 26|0); //@line 110240 "c/sqlite3.c"
  $19 = HEAP8[$18>>0]|0; //@line 110240 "c/sqlite3.c"
  $20 = ($19<<24>>24)==(7); //@line 110240 "c/sqlite3.c"
  if ($20) {
   $$1 = 1;
   return ($$1|0); //@line 110246 "c/sqlite3.c"
  }
 }
 $$1 = 0;
 return ($$1|0); //@line 110246 "c/sqlite3.c"
}
function _fkParentIsModified($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$03137 = 0, $$03239 = 0, $$5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($1)) + 20|0); //@line 110213 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 110213 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 110213 "c/sqlite3.c"
 if (!($6)) {
  $$5 = 0;
  return ($$5|0); //@line 110228 "c/sqlite3.c"
 }
 $7 = ((($0)) + 42|0);
 $8 = HEAP16[$7>>1]|0;
 $9 = ($8<<16>>16)>(0);
 $10 = ((($0)) + 4|0);
 $11 = ((($0)) + 40|0);
 $12 = ($3|0)!=(0);
 $$03239 = 0;
 L4: while(1) {
  $13 = (((((($1)) + 36|0) + ($$03239<<3)|0)) + 4|0); //@line 110214 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 110214 "c/sqlite3.c"
  if ($9) {
   $15 = ($14|0)==(0|0);
   $$03137 = 0;
   while(1) {
    $16 = (($2) + ($$03137<<2)|0); //@line 110217 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 110217 "c/sqlite3.c"
    $18 = ($17|0)>(-1); //@line 110217 "c/sqlite3.c"
    if ($18) {
     label = 7;
    } else {
     $19 = HEAP16[$11>>1]|0; //@line 110217 "c/sqlite3.c"
     $20 = $19 << 16 >> 16; //@line 110217 "c/sqlite3.c"
     $21 = ($$03137|0)==($20|0); //@line 110217 "c/sqlite3.c"
     $or$cond = $12 & $21; //@line 110217 "c/sqlite3.c"
     if ($or$cond) {
      label = 7;
     }
    }
    do {
     if ((label|0) == 7) {
      label = 0;
      $22 = HEAP32[$10>>2]|0; //@line 110218 "c/sqlite3.c"
      if ($15) {
       $27 = (((($22) + ($$03137<<4)|0)) + 15|0); //@line 110221 "c/sqlite3.c"
       $28 = HEAP8[$27>>0]|0; //@line 110221 "c/sqlite3.c"
       $29 = $28 & 1; //@line 110221 "c/sqlite3.c"
       $30 = ($29<<24>>24)==(0); //@line 110221 "c/sqlite3.c"
       if ($30) {
        break;
       } else {
        $$5 = 1;
        label = 12;
        break L4;
       }
      } else {
       $23 = (($22) + ($$03137<<4)|0); //@line 110220 "c/sqlite3.c"
       $24 = HEAP32[$23>>2]|0; //@line 110220 "c/sqlite3.c"
       $25 = (_sqlite3StrICmp($24,$14)|0); //@line 110220 "c/sqlite3.c"
       $26 = ($25|0)==(0); //@line 110220 "c/sqlite3.c"
       if ($26) {
        $$5 = 1;
        label = 12;
        break L4;
       } else {
        break;
       }
      }
     }
    } while(0);
    $31 = (($$03137) + 1)|0; //@line 110216 "c/sqlite3.c"
    $32 = HEAP16[$7>>1]|0; //@line 110216 "c/sqlite3.c"
    $33 = $32 << 16 >> 16; //@line 110216 "c/sqlite3.c"
    $34 = ($31|0)<($33|0); //@line 110216 "c/sqlite3.c"
    if ($34) {
     $$03137 = $31;
    } else {
     break;
    }
   }
  }
  $35 = (($$03239) + 1)|0; //@line 110213 "c/sqlite3.c"
  $36 = HEAP32[$4>>2]|0; //@line 110213 "c/sqlite3.c"
  $37 = ($35|0)<($36|0); //@line 110213 "c/sqlite3.c"
  if ($37) {
   $$03239 = $35;
  } else {
   $$5 = 0;
   label = 12;
   break;
  }
 }
 if ((label|0) == 12) {
  return ($$5|0); //@line 110228 "c/sqlite3.c"
 }
 return (0)|0;
}
function _fkScanChildren($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0119$lcssa = 0, $$0119126 = 0, $$0121$lcssa = 0, $$0121124 = 0, $$0122 = 0, $$0123 = 0, $$0127 = 0, $$1120 = 0, $$1125 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $9 = 0, $or$cond = 0, $sext = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $8 = sp;
 $9 = HEAP32[$0>>2]|0; //@line 109961 "c/sqlite3.c"
 $10 = (_sqlite3GetVdbe($0)|0); //@line 109967 "c/sqlite3.c"
 $11 = ($7|0)<(0); //@line 109974 "c/sqlite3.c"
 if ($11) {
  $12 = ((($4)) + 24|0); //@line 109975 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 109975 "c/sqlite3.c"
  $14 = $13&255; //@line 109975 "c/sqlite3.c"
  $15 = (_sqlite3VdbeAddOp2($10,47,$14,0)|0); //@line 109975 "c/sqlite3.c"
  $$0122 = $15;
 } else {
  $$0122 = 0;
 }
 $16 = ((($4)) + 20|0); //@line 109987 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 109987 "c/sqlite3.c"
 $18 = ($17|0)>(0); //@line 109987 "c/sqlite3.c"
 if ($18) {
  $19 = ($3|0)==(0|0);
  $20 = ($5|0)==(0|0);
  $21 = ((($4)) + 36|0);
  $22 = ((($3)) + 4|0);
  $$0119126 = 0;$$0127 = 0;
  while(1) {
   if ($19) {
    $28 = -1;
   } else {
    $23 = HEAP32[$22>>2]|0; //@line 109994 "c/sqlite3.c"
    $24 = (($23) + ($$0127<<1)|0); //@line 109994 "c/sqlite3.c"
    $25 = HEAP16[$24>>1]|0; //@line 109994 "c/sqlite3.c"
    $26 = $25 << 16 >> 16; //@line 109994 "c/sqlite3.c"
    $28 = $26;
   }
   $27 = $28&65535; //@line 109994 "c/sqlite3.c"
   $29 = (_exprTableRegister($0,$2,$6,$27)|0); //@line 109995 "c/sqlite3.c"
   $30 = (($5) + ($$0127<<2)|0); //@line 109996 "c/sqlite3.c"
   $$in = $20 ? $21 : $30; //@line 109996 "c/sqlite3.c"
   $31 = HEAP32[$$in>>2]|0; //@line 109996 "c/sqlite3.c"
   $32 = HEAP32[$4>>2]|0; //@line 109998 "c/sqlite3.c"
   $33 = ((($32)) + 4|0); //@line 109998 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 109998 "c/sqlite3.c"
   $sext = $31 << 16; //@line 109998 "c/sqlite3.c"
   $35 = $sext >> 16; //@line 109998 "c/sqlite3.c"
   $36 = (($34) + ($35<<4)|0); //@line 109998 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 109998 "c/sqlite3.c"
   $38 = (_sqlite3Expr($9,59,$37)|0); //@line 109999 "c/sqlite3.c"
   $39 = (_sqlite3PExpr($0,53,$29,$38)|0); //@line 110000 "c/sqlite3.c"
   $40 = (_sqlite3ExprAnd($9,$$0119126,$39)|0); //@line 110001 "c/sqlite3.c"
   $41 = (($$0127) + 1)|0; //@line 109987 "c/sqlite3.c"
   $42 = HEAP32[$16>>2]|0; //@line 109987 "c/sqlite3.c"
   $43 = ($41|0)<($42|0); //@line 109987 "c/sqlite3.c"
   if ($43) {
    $$0119126 = $40;$$0127 = $41;
   } else {
    $$0119$lcssa = $40;
    break;
   }
  }
 } else {
  $$0119$lcssa = 0;
 }
 $44 = HEAP32[$4>>2]|0; //@line 110015 "c/sqlite3.c"
 $45 = ($44|0)==($2|0); //@line 110015 "c/sqlite3.c"
 $46 = ($7|0)>(0); //@line 110015 "c/sqlite3.c"
 $or$cond = $46 & $45; //@line 110015 "c/sqlite3.c"
 if ($or$cond) {
  $47 = ((($2)) + 36|0); //@line 110019 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 110019 "c/sqlite3.c"
  $49 = $48 & 32; //@line 110019 "c/sqlite3.c"
  $50 = ($49|0)==(0); //@line 110019 "c/sqlite3.c"
  if ($50) {
   $51 = (_exprTableRegister($0,$2,$6,-1)|0); //@line 110020 "c/sqlite3.c"
   $52 = ((($1)) + 52|0); //@line 110021 "c/sqlite3.c"
   $53 = HEAP32[$52>>2]|0; //@line 110021 "c/sqlite3.c"
   $54 = (_exprTableColumn($9,$2,$53,-1)|0); //@line 110021 "c/sqlite3.c"
   $55 = (_sqlite3PExpr($0,52,$51,$54)|0); //@line 110022 "c/sqlite3.c"
   $$0123 = $55;
  } else {
   $56 = (_sqlite3PrimaryKeyIndex($2)|0); //@line 110025 "c/sqlite3.c"
   $57 = ((($56)) + 50|0); //@line 110027 "c/sqlite3.c"
   $58 = HEAP16[$57>>1]|0; //@line 110027 "c/sqlite3.c"
   $59 = ($58<<16>>16)==(0); //@line 110027 "c/sqlite3.c"
   if ($59) {
    $$0121$lcssa = 0;
   } else {
    $60 = ((($3)) + 4|0);
    $61 = ((($1)) + 52|0);
    $$0121124 = 0;$$1125 = 0;
    while(1) {
     $62 = HEAP32[$60>>2]|0; //@line 110028 "c/sqlite3.c"
     $63 = (($62) + ($$1125<<1)|0); //@line 110028 "c/sqlite3.c"
     $64 = HEAP16[$63>>1]|0; //@line 110028 "c/sqlite3.c"
     $65 = (_exprTableRegister($0,$2,$6,$64)|0); //@line 110030 "c/sqlite3.c"
     $66 = HEAP32[$61>>2]|0; //@line 110031 "c/sqlite3.c"
     $67 = (_exprTableColumn($9,$2,$66,$64)|0); //@line 110031 "c/sqlite3.c"
     $68 = (_sqlite3PExpr($0,53,$65,$67)|0); //@line 110032 "c/sqlite3.c"
     $69 = (_sqlite3ExprAnd($9,$$0121124,$68)|0); //@line 110033 "c/sqlite3.c"
     $70 = (($$1125) + 1)|0; //@line 110027 "c/sqlite3.c"
     $71 = HEAP16[$57>>1]|0; //@line 110027 "c/sqlite3.c"
     $72 = $71&65535; //@line 110027 "c/sqlite3.c"
     $73 = ($70>>>0)<($72>>>0); //@line 110027 "c/sqlite3.c"
     if ($73) {
      $$0121124 = $69;$$1125 = $70;
     } else {
      $$0121$lcssa = $69;
      break;
     }
    }
   }
   $74 = (_sqlite3PExpr($0,19,$$0121$lcssa,0)|0); //@line 110035 "c/sqlite3.c"
   $$0123 = $74;
  }
  $75 = (_sqlite3ExprAnd($9,$$0119$lcssa,$$0123)|0); //@line 110037 "c/sqlite3.c"
  $$1120 = $75;
 } else {
  $$1120 = $$0119$lcssa;
 }
 $76 = ((($8)) + 8|0);
 ;HEAP32[$76>>2]=0|0;HEAP32[$76+4>>2]=0|0;HEAP32[$76+8>>2]=0|0;HEAP32[$76+12>>2]=0|0;HEAP32[$76+16>>2]=0|0;HEAP32[$76+20>>2]=0|0; //@line 110041 "c/sqlite3.c"
 $77 = ((($8)) + 4|0); //@line 110042 "c/sqlite3.c"
 HEAP32[$77>>2] = $1; //@line 110042 "c/sqlite3.c"
 HEAP32[$8>>2] = $0; //@line 110043 "c/sqlite3.c"
 (_sqlite3ResolveExprNames($8,$$1120)|0); //@line 110044 "c/sqlite3.c"
 $78 = ((($0)) + 36|0); //@line 110049 "c/sqlite3.c"
 $79 = HEAP32[$78>>2]|0; //@line 110049 "c/sqlite3.c"
 $80 = ($79|0)==(0); //@line 110049 "c/sqlite3.c"
 if ($80) {
  $81 = (_sqlite3WhereBegin($0,$1,$$1120,0,0,0,0)|0); //@line 110050 "c/sqlite3.c"
  $82 = ((($4)) + 24|0); //@line 110051 "c/sqlite3.c"
  $83 = HEAP8[$82>>0]|0; //@line 110051 "c/sqlite3.c"
  $84 = $83&255; //@line 110051 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($10,146,$84,$7)|0); //@line 110051 "c/sqlite3.c"
  $85 = ($81|0)==(0|0); //@line 110052 "c/sqlite3.c"
  if (!($85)) {
   _sqlite3WhereEnd($81); //@line 110053 "c/sqlite3.c"
  }
 }
 _sqlite3ExprDelete($9,$$1120); //@line 110058 "c/sqlite3.c"
 $86 = ($$0122|0)==(0); //@line 110059 "c/sqlite3.c"
 if ($86) {
  STACKTOP = sp;return; //@line 110062 "c/sqlite3.c"
 }
 _sqlite3VdbeJumpHere($10,$$0122); //@line 110060 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 110062 "c/sqlite3.c"
}
function _exprTableRegister($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$029 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 109881 "c/sqlite3.c"
 $5 = (_sqlite3Expr($4,150,0)|0); //@line 109883 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 109884 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;
  return ($$0|0); //@line 109897 "c/sqlite3.c"
 }
 $7 = $3 << 16 >> 16; //@line 109885 "c/sqlite3.c"
 $8 = ($3<<16>>16)>(-1); //@line 109885 "c/sqlite3.c"
 if ($8) {
  $9 = ((($1)) + 40|0); //@line 109885 "c/sqlite3.c"
  $10 = HEAP16[$9>>1]|0; //@line 109885 "c/sqlite3.c"
  $11 = ($10<<16>>16)==($3<<16>>16); //@line 109885 "c/sqlite3.c"
  if (!($11)) {
   $12 = ((($1)) + 4|0); //@line 109886 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 109886 "c/sqlite3.c"
   $14 = (($2) + 1)|0; //@line 109887 "c/sqlite3.c"
   $15 = (($14) + ($7))|0; //@line 109887 "c/sqlite3.c"
   $16 = ((($5)) + 28|0); //@line 109887 "c/sqlite3.c"
   HEAP32[$16>>2] = $15; //@line 109887 "c/sqlite3.c"
   $17 = (((($13) + ($7<<4)|0)) + 13|0); //@line 109888 "c/sqlite3.c"
   $18 = HEAP8[$17>>0]|0; //@line 109888 "c/sqlite3.c"
   $19 = ((($5)) + 1|0); //@line 109888 "c/sqlite3.c"
   HEAP8[$19>>0] = $18; //@line 109888 "c/sqlite3.c"
   $20 = (((($13) + ($7<<4)|0)) + 8|0); //@line 109889 "c/sqlite3.c"
   $21 = HEAP32[$20>>2]|0; //@line 109889 "c/sqlite3.c"
   $22 = ($21|0)==(0|0); //@line 109890 "c/sqlite3.c"
   if ($22) {
    $23 = ((($4)) + 8|0); //@line 109890 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 109890 "c/sqlite3.c"
    $25 = HEAP32[$24>>2]|0; //@line 109890 "c/sqlite3.c"
    $$029 = $25;
   } else {
    $$029 = $21;
   }
   $26 = (_sqlite3ExprAddCollateString($0,$5,$$029)|0); //@line 109891 "c/sqlite3.c"
   $$0 = $26;
   return ($$0|0); //@line 109897 "c/sqlite3.c"
  }
 }
 $27 = ((($5)) + 28|0); //@line 109893 "c/sqlite3.c"
 HEAP32[$27>>2] = $2; //@line 109893 "c/sqlite3.c"
 $28 = ((($5)) + 1|0); //@line 109894 "c/sqlite3.c"
 HEAP8[$28>>0] = 68; //@line 109894 "c/sqlite3.c"
 $$0 = $5;
 return ($$0|0); //@line 109897 "c/sqlite3.c"
}
function _exprTableColumn($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3Expr($0,145,0)|0); //@line 109910 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 109911 "c/sqlite3.c"
 if ($5) {
  return ($4|0); //@line 109916 "c/sqlite3.c"
 }
 $6 = ((($4)) + 44|0); //@line 109912 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 109912 "c/sqlite3.c"
 $7 = ((($4)) + 28|0); //@line 109913 "c/sqlite3.c"
 HEAP32[$7>>2] = $2; //@line 109913 "c/sqlite3.c"
 $8 = ((($4)) + 32|0); //@line 109914 "c/sqlite3.c"
 HEAP16[$8>>1] = $3; //@line 109914 "c/sqlite3.c"
 return ($4|0); //@line 109916 "c/sqlite3.c"
}
function _sqlite3WhereBegin($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0 = 0, $$0362 = 0, $$0363 = 0, $$0363425 = 0, $$0363428 = 0, $$0364$ph = 0, $$0365$lcssa = 0, $$0365427 = 0, $$0367$lcssa = 0, $$0367423 = 0, $$0369 = 0, $$0370448 = 0, $$0376433 = 0, $$0377 = 0, $$0386450 = 0, $$0386450$in = 0, $$0388438 = 0, $$1$ph = 0, $$1371 = 0, $$1378455 = 0;
 var $$1389441 = 0, $$2 = 0, $$2379432 = 0, $$2383 = 0, $$3380420 = 0, $$not401 = 0, $$not403 = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0;
 var $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0;
 var $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0;
 var $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0;
 var $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0;
 var $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0;
 var $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0;
 var $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0;
 var $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0;
 var $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0;
 var $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0;
 var $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0;
 var $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0;
 var $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0;
 var $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0;
 var $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0;
 var $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $40 = 0, $400 = 0;
 var $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0;
 var $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0;
 var $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0;
 var $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0;
 var $474 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $brmerge = 0, $brmerge404 = 0, $exitcond = 0, $or$cond = 0;
 var $or$cond394 = 0, $or$cond396 = 0, $or$cond398 = 0, $or$cond402 = 0, $or$cond402426 = 0, $or$cond406 = 0, $phitmp = 0, $spec$select = 0, $spec$select390 = 0, $spec$select391 = 0, $vararg_buffer = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $7 = sp + 8|0;
 $8 = ((($0)) + 8|0); //@line 137389 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 137389 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 137410 "c/sqlite3.c"
 ;HEAP32[$7>>2]=0|0;HEAP32[$7+4>>2]=0|0;HEAP32[$7+8>>2]=0|0;HEAP32[$7+12>>2]=0|0;HEAP32[$7+16>>2]=0|0;HEAP32[$7+20>>2]=0|0; //@line 137411 "c/sqlite3.c"
 $11 = ($3|0)==(0|0); //@line 137415 "c/sqlite3.c"
 if ($11) {
  $$0362 = 0;
 } else {
  $12 = HEAP32[$3>>2]|0; //@line 137415 "c/sqlite3.c"
  $13 = ($12|0)>(63); //@line 137415 "c/sqlite3.c"
  $spec$select = $13 ? 0 : $3; //@line 137415 "c/sqlite3.c"
  $$0362 = $spec$select;
 }
 $14 = ((($7)) + 8|0); //@line 137416 "c/sqlite3.c"
 HEAP32[$14>>2] = $$0362; //@line 137416 "c/sqlite3.c"
 $15 = ((($10)) + 68|0); //@line 137420 "c/sqlite3.c"
 $16 = HEAP16[$15>>1]|0; //@line 137420 "c/sqlite3.c"
 $17 = $16 & 16; //@line 137420 "c/sqlite3.c"
 $18 = ($17<<16>>16)==(0); //@line 137420 "c/sqlite3.c"
 $19 = $5 & -257; //@line 137421 "c/sqlite3.c"
 $spec$select390 = $18 ? $5 : $19; //@line 137420 "c/sqlite3.c"
 $20 = HEAP32[$1>>2]|0; //@line 137428 "c/sqlite3.c"
 $21 = ($20|0)>(64); //@line 137428 "c/sqlite3.c"
 if ($21) {
  HEAP32[$vararg_buffer>>2] = 64; //@line 137429 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,27331,$vararg_buffer); //@line 137429 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 137908 "c/sqlite3.c"
 }
 $22 = $spec$select390&65535; //@line 137438 "c/sqlite3.c"
 $23 = $22 & 32; //@line 137438 "c/sqlite3.c"
 $24 = ($23|0)!=(0); //@line 137438 "c/sqlite3.c"
 $spec$select391 = $24 ? 1 : $20; //@line 137438 "c/sqlite3.c"
 $25 = ($spec$select391*80)|0; //@line 137447 "c/sqlite3.c"
 $26 = (($25) + 759)|0; //@line 137447 "c/sqlite3.c"
 $27 = $26 & -16; //@line 137447 "c/sqlite3.c"
 $28 = (($27) + 72)|0; //@line 137448 "c/sqlite3.c"
 $29 = (_sqlite3DbMallocRawNN($10,$28,0)|0); //@line 137448 "c/sqlite3.c"
 $30 = ((($10)) + 73|0); //@line 137449 "c/sqlite3.c"
 $31 = HEAP8[$30>>0]|0; //@line 137449 "c/sqlite3.c"
 $32 = ($31<<24>>24)==(0); //@line 137449 "c/sqlite3.c"
 if (!($32)) {
  _sqlite3DbFree($10,$29); //@line 137450 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 137908 "c/sqlite3.c"
 }
 HEAP32[$29>>2] = $0; //@line 137454 "c/sqlite3.c"
 $33 = ((($29)) + 4|0); //@line 137455 "c/sqlite3.c"
 HEAP32[$33>>2] = $1; //@line 137455 "c/sqlite3.c"
 $34 = ((($29)) + 8|0); //@line 137456 "c/sqlite3.c"
 HEAP32[$34>>2] = $$0362; //@line 137456 "c/sqlite3.c"
 $35 = ((($29)) + 16|0); //@line 137457 "c/sqlite3.c"
 HEAP32[$35>>2] = $2; //@line 137457 "c/sqlite3.c"
 $36 = ((($29)) + 12|0); //@line 137458 "c/sqlite3.c"
 HEAP32[$36>>2] = $4; //@line 137458 "c/sqlite3.c"
 $37 = ((($29)) + 24|0); //@line 137459 "c/sqlite3.c"
 $38 = ((($29)) + 28|0); //@line 137459 "c/sqlite3.c"
 HEAP32[$38>>2] = -1; //@line 137459 "c/sqlite3.c"
 HEAP32[$37>>2] = -1; //@line 137459 "c/sqlite3.c"
 $39 = $spec$select391&255; //@line 137460 "c/sqlite3.c"
 $40 = ((($29)) + 46|0); //@line 137460 "c/sqlite3.c"
 HEAP8[$40>>0] = $39; //@line 137460 "c/sqlite3.c"
 $41 = (_sqlite3VdbeMakeLabel($9)|0); //@line 137461 "c/sqlite3.c"
 $42 = ((($29)) + 32|0); //@line 137461 "c/sqlite3.c"
 HEAP32[$42>>2] = $41; //@line 137461 "c/sqlite3.c"
 $43 = ((($29)) + 36|0); //@line 137461 "c/sqlite3.c"
 HEAP32[$43>>2] = $41; //@line 137461 "c/sqlite3.c"
 $44 = ((($29)) + 44|0); //@line 137462 "c/sqlite3.c"
 HEAP16[$44>>1] = $spec$select390; //@line 137462 "c/sqlite3.c"
 $45 = $6&65535; //@line 137463 "c/sqlite3.c"
 $46 = ((($29)) + 20|0); //@line 137463 "c/sqlite3.c"
 HEAP16[$46>>1] = $45; //@line 137463 "c/sqlite3.c"
 $47 = ((($0)) + 132|0); //@line 137464 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 137464 "c/sqlite3.c"
 $49 = ((($29)) + 40|0); //@line 137464 "c/sqlite3.c"
 HEAP32[$49>>2] = $48; //@line 137464 "c/sqlite3.c"
 $50 = ((($29)) + 47|0); //@line 137465 "c/sqlite3.c"
 dest=$50; stop=dest+33|0; do { HEAP8[dest>>0]=0|0; dest=dest+1|0; } while ((dest|0) < (stop|0)); //@line 137465 "c/sqlite3.c"
 $51 = ((($29)) + 752|0); //@line 137467 "c/sqlite3.c"
 $52 = (($25) + 72)|0; //@line 137467 "c/sqlite3.c"
 _memset(($51|0),0,($52|0))|0; //@line 137467 "c/sqlite3.c"
 $53 = ((($29)) + 488|0); //@line 137469 "c/sqlite3.c"
 HEAP32[$7>>2] = $29; //@line 137470 "c/sqlite3.c"
 $54 = ((($29)) + 80|0); //@line 137471 "c/sqlite3.c"
 $55 = ((($7)) + 4|0); //@line 137471 "c/sqlite3.c"
 HEAP32[$55>>2] = $54; //@line 137471 "c/sqlite3.c"
 $56 = (($29) + ($27)|0); //@line 137472 "c/sqlite3.c"
 $57 = ((($7)) + 12|0); //@line 137472 "c/sqlite3.c"
 HEAP32[$57>>2] = $56; //@line 137472 "c/sqlite3.c"
 _whereLoopInit($56); //@line 137474 "c/sqlite3.c"
 $58 = ((($29)) + 492|0); //@line 137482 "c/sqlite3.c"
 HEAP32[$58>>2] = 0; //@line 137482 "c/sqlite3.c"
 _sqlite3WhereClauseInit($54,$29); //@line 137483 "c/sqlite3.c"
 _sqlite3WhereSplit($54,$2,44); //@line 137484 "c/sqlite3.c"
 $59 = ($spec$select391|0)==(0); //@line 137488 "c/sqlite3.c"
 if ($59) {
  $60 = ($$0362|0)==(0|0); //@line 137489 "c/sqlite3.c"
  if (!($60)) {
   $61 = HEAP32[$$0362>>2]|0; //@line 137489 "c/sqlite3.c"
   $62 = $61&255; //@line 137489 "c/sqlite3.c"
   HEAP8[$50>>0] = $62; //@line 137489 "c/sqlite3.c"
  }
  $63 = $22 & 256; //@line 137490 "c/sqlite3.c"
  $64 = ($63|0)==(0); //@line 137490 "c/sqlite3.c"
  if (!($64)) {
   $65 = ((($29)) + 51|0); //@line 137491 "c/sqlite3.c"
   HEAP8[$65>>0] = 1; //@line 137491 "c/sqlite3.c"
  }
 } else {
  $$0377 = 0;
  while(1) {
   $66 = (((($1)) + 8|0) + (($$0377*72)|0)|0); //@line 137510 "c/sqlite3.c"
   $67 = (((((($1)) + 8|0) + (($$0377*72)|0)|0)) + 44|0); //@line 137510 "c/sqlite3.c"
   $68 = HEAP32[$67>>2]|0; //@line 137510 "c/sqlite3.c"
   _createMask($53,$68); //@line 137510 "c/sqlite3.c"
   _sqlite3WhereTabFuncArgs($0,$66,$54); //@line 137511 "c/sqlite3.c"
   $69 = (($$0377) + 1)|0; //@line 137512 "c/sqlite3.c"
   $70 = HEAP32[$1>>2]|0; //@line 137512 "c/sqlite3.c"
   $71 = ($69|0)<($70|0); //@line 137512 "c/sqlite3.c"
   if ($71) {
    $$0377 = $69;
   } else {
    break;
   }
  }
 }
 _sqlite3WhereExprAnalyze($1,$54); //@line 137526 "c/sqlite3.c"
 $72 = HEAP8[$30>>0]|0; //@line 137527 "c/sqlite3.c"
 $73 = ($72<<24>>24)==(0); //@line 137527 "c/sqlite3.c"
 L22: do {
  if ($73) {
   $74 = HEAP32[$55>>2]|0; //@line 137540 "c/sqlite3.c"
   $75 = ((($74)) + 12|0); //@line 137540 "c/sqlite3.c"
   $76 = HEAP32[$75>>2]|0; //@line 137540 "c/sqlite3.c"
   $77 = ($76|0)>(0); //@line 137540 "c/sqlite3.c"
   if ($77) {
    $78 = HEAP32[$55>>2]|0;
    $79 = ((($78)) + 12|0);
    $80 = ((($74)) + 20|0); //@line 137541 "c/sqlite3.c"
    $81 = HEAP32[$80>>2]|0; //@line 137541 "c/sqlite3.c"
    $82 = ((($81)) + 40|0); //@line 137542 "c/sqlite3.c"
    $83 = $82; //@line 137542 "c/sqlite3.c"
    $84 = $83; //@line 137542 "c/sqlite3.c"
    $85 = HEAP32[$84>>2]|0; //@line 137542 "c/sqlite3.c"
    $86 = (($83) + 4)|0; //@line 137542 "c/sqlite3.c"
    $87 = $86; //@line 137542 "c/sqlite3.c"
    $88 = HEAP32[$87>>2]|0; //@line 137542 "c/sqlite3.c"
    $89 = ($85|0)==(0); //@line 137542 "c/sqlite3.c"
    $90 = ($88|0)==(0); //@line 137542 "c/sqlite3.c"
    $91 = $89 & $90; //@line 137542 "c/sqlite3.c"
    do {
     if ($91) {
      if (!($59)) {
       $92 = HEAP32[$81>>2]|0; //@line 137542 "c/sqlite3.c"
       $93 = (_exprIsDeterministic($92)|0); //@line 137542 "c/sqlite3.c"
       $94 = ($93|0)==(0); //@line 137542 "c/sqlite3.c"
       if ($94) {
        break;
       }
      }
      $95 = HEAP32[$81>>2]|0; //@line 137543 "c/sqlite3.c"
      $96 = HEAP32[$43>>2]|0; //@line 137543 "c/sqlite3.c"
      _sqlite3ExprIfFalse($0,$95,$96,16); //@line 137543 "c/sqlite3.c"
      $97 = ((($81)) + 10|0); //@line 137544 "c/sqlite3.c"
      $98 = HEAP16[$97>>1]|0; //@line 137544 "c/sqlite3.c"
      $99 = $98 | 4; //@line 137544 "c/sqlite3.c"
      HEAP16[$97>>1] = $99; //@line 137544 "c/sqlite3.c"
     }
    } while(0);
    $100 = HEAP32[$79>>2]|0; //@line 137540 "c/sqlite3.c"
    $101 = ($100|0)>(1); //@line 137540 "c/sqlite3.c"
    if ($101) {
     $102 = ((($78)) + 20|0);
     $$1378455 = 1;
     while(1) {
      $103 = HEAP32[$102>>2]|0; //@line 137541 "c/sqlite3.c"
      $104 = (($103) + (($$1378455*48)|0)|0); //@line 137541 "c/sqlite3.c"
      $105 = (((($103) + (($$1378455*48)|0)|0)) + 40|0); //@line 137542 "c/sqlite3.c"
      $106 = $105; //@line 137542 "c/sqlite3.c"
      $107 = $106; //@line 137542 "c/sqlite3.c"
      $108 = HEAP32[$107>>2]|0; //@line 137542 "c/sqlite3.c"
      $109 = (($106) + 4)|0; //@line 137542 "c/sqlite3.c"
      $110 = $109; //@line 137542 "c/sqlite3.c"
      $111 = HEAP32[$110>>2]|0; //@line 137542 "c/sqlite3.c"
      $112 = ($108|0)==(0); //@line 137542 "c/sqlite3.c"
      $113 = ($111|0)==(0); //@line 137542 "c/sqlite3.c"
      $114 = $112 & $113; //@line 137542 "c/sqlite3.c"
      do {
       if ($114) {
        if (!($59)) {
         $115 = HEAP32[$104>>2]|0; //@line 137542 "c/sqlite3.c"
         $116 = (_exprIsDeterministic($115)|0); //@line 137542 "c/sqlite3.c"
         $117 = ($116|0)==(0); //@line 137542 "c/sqlite3.c"
         if ($117) {
          break;
         }
        }
        $118 = HEAP32[$104>>2]|0; //@line 137543 "c/sqlite3.c"
        $119 = HEAP32[$43>>2]|0; //@line 137543 "c/sqlite3.c"
        _sqlite3ExprIfFalse($0,$118,$119,16); //@line 137543 "c/sqlite3.c"
        $120 = (((($103) + (($$1378455*48)|0)|0)) + 10|0); //@line 137544 "c/sqlite3.c"
        $121 = HEAP16[$120>>1]|0; //@line 137544 "c/sqlite3.c"
        $122 = $121 | 4; //@line 137544 "c/sqlite3.c"
        HEAP16[$120>>1] = $122; //@line 137544 "c/sqlite3.c"
       }
      } while(0);
      $123 = (($$1378455) + 1)|0; //@line 137540 "c/sqlite3.c"
      $124 = HEAP32[$79>>2]|0; //@line 137540 "c/sqlite3.c"
      $125 = ($123|0)<($124|0); //@line 137540 "c/sqlite3.c"
      if ($125) {
       $$1378455 = $123;
      } else {
       break;
      }
     }
    }
   }
   $126 = $22 & 256; //@line 137548 "c/sqlite3.c"
   $127 = ($126|0)==(0); //@line 137548 "c/sqlite3.c"
   do {
    if (!($127)) {
     $128 = (_isDistinctRedundant($0,$1,$54,$4)|0); //@line 137549 "c/sqlite3.c"
     $129 = ($128|0)==(0); //@line 137549 "c/sqlite3.c"
     if (!($129)) {
      $130 = ((($29)) + 51|0); //@line 137551 "c/sqlite3.c"
      HEAP8[$130>>0] = 1; //@line 137551 "c/sqlite3.c"
      break;
     }
     $131 = ($$0362|0)==(0|0); //@line 137552 "c/sqlite3.c"
     if ($131) {
      $132 = HEAP16[$44>>1]|0; //@line 137554 "c/sqlite3.c"
      $133 = $132 | 128; //@line 137554 "c/sqlite3.c"
      HEAP16[$44>>1] = $133; //@line 137554 "c/sqlite3.c"
      HEAP32[$34>>2] = $4; //@line 137555 "c/sqlite3.c"
     }
    }
   } while(0);
   $134 = ($spec$select391|0)==(1); //@line 137573 "c/sqlite3.c"
   if ($134) {
    $135 = (_whereShortCut($7)|0); //@line 137573 "c/sqlite3.c"
    $136 = ($135|0)==(0); //@line 137573 "c/sqlite3.c"
    if ($136) {
     label = 34;
    } else {
     label = 38;
    }
   } else {
    label = 34;
   }
   if ((label|0) == 34) {
    $137 = (_whereLoopAddAll($7)|0); //@line 137574 "c/sqlite3.c"
    $138 = ($137|0)==(0); //@line 137575 "c/sqlite3.c"
    if (!($138)) {
     label = 118;
     break;
    }
    _wherePathSolver($29,0); //@line 137590 "c/sqlite3.c"
    $139 = HEAP8[$30>>0]|0; //@line 137591 "c/sqlite3.c"
    $140 = ($139<<24>>24)==(0); //@line 137591 "c/sqlite3.c"
    if (!($140)) {
     label = 118;
     break;
    }
    $141 = HEAP32[$34>>2]|0; //@line 137592 "c/sqlite3.c"
    $142 = ($141|0)==(0|0); //@line 137592 "c/sqlite3.c"
    if ($142) {
     label = 39;
    } else {
     $143 = ((($29)) + 72|0); //@line 137593 "c/sqlite3.c"
     $144 = HEAP16[$143>>1]|0; //@line 137593 "c/sqlite3.c"
     $145 = $144&65535; //@line 137593 "c/sqlite3.c"
     $146 = (($145) + 1)|0; //@line 137593 "c/sqlite3.c"
     $147 = $146&65535; //@line 137593 "c/sqlite3.c"
     _wherePathSolver($29,$147); //@line 137593 "c/sqlite3.c"
     $148 = HEAP8[$30>>0]|0; //@line 137594 "c/sqlite3.c"
     $149 = ($148<<24>>24)==(0); //@line 137594 "c/sqlite3.c"
     if ($149) {
      label = 38;
     } else {
      break;
     }
    }
   }
   if ((label|0) == 38) {
    $$pr = HEAP32[$34>>2]|0; //@line 137597 "c/sqlite3.c"
    $150 = ($$pr|0)==(0|0); //@line 137597 "c/sqlite3.c"
    if ($150) {
     label = 39;
    }
   }
   if ((label|0) == 39) {
    $151 = ((($10)) + 28|0); //@line 137597 "c/sqlite3.c"
    $152 = HEAP32[$151>>2]|0; //@line 137597 "c/sqlite3.c"
    $153 = $152 & 4096; //@line 137597 "c/sqlite3.c"
    $154 = ($153|0)==(0); //@line 137597 "c/sqlite3.c"
    if (!($154)) {
     $155 = ((($29)) + 64|0); //@line 137598 "c/sqlite3.c"
     $156 = $155; //@line 137598 "c/sqlite3.c"
     $157 = $156; //@line 137598 "c/sqlite3.c"
     HEAP32[$157>>2] = -1; //@line 137598 "c/sqlite3.c"
     $158 = (($156) + 4)|0; //@line 137598 "c/sqlite3.c"
     $159 = $158; //@line 137598 "c/sqlite3.c"
     HEAP32[$159>>2] = -1; //@line 137598 "c/sqlite3.c"
    }
   }
   $160 = ((($0)) + 36|0); //@line 137600 "c/sqlite3.c"
   $161 = HEAP32[$160>>2]|0; //@line 137600 "c/sqlite3.c"
   $162 = ($161|0)==(0); //@line 137600 "c/sqlite3.c"
   if ($162) {
    $163 = HEAP8[$30>>0]|0; //@line 137600 "c/sqlite3.c"
    $164 = ($163<<24>>24)==(0); //@line 137600 "c/sqlite3.c"
    if ($164) {
     $165 = HEAP8[$40>>0]|0; //@line 137660 "c/sqlite3.c"
     $166 = ($165&255)>(1); //@line 137660 "c/sqlite3.c"
     $167 = ($4|0)!=(0|0); //@line 137661 "c/sqlite3.c"
     $or$cond = $167 & $166; //@line 137661 "c/sqlite3.c"
     if ($or$cond) {
      $168 = HEAP16[$15>>1]|0; //@line 137662 "c/sqlite3.c"
      $169 = $168 & 256; //@line 137662 "c/sqlite3.c"
      $170 = ($169<<16>>16)==(0); //@line 137662 "c/sqlite3.c"
      if ($170) {
       $171 = (_sqlite3WhereExprListUsage($53,$4)|0); //@line 137665 "c/sqlite3.c"
       $172 = tempRet0; //@line 137665 "c/sqlite3.c"
       $173 = HEAP32[$14>>2]|0; //@line 137666 "c/sqlite3.c"
       $174 = ($173|0)==(0|0); //@line 137666 "c/sqlite3.c"
       if ($174) {
        $205 = $171;$207 = $172;
       } else {
        $175 = (_sqlite3WhereExprListUsage($53,$173)|0); //@line 137667 "c/sqlite3.c"
        $176 = tempRet0; //@line 137667 "c/sqlite3.c"
        $177 = $175 | $171; //@line 137667 "c/sqlite3.c"
        $178 = $176 | $172; //@line 137667 "c/sqlite3.c"
        $205 = $177;$207 = $178;
       }
       $179 = HEAP8[$40>>0]|0; //@line 137669 "c/sqlite3.c"
       $180 = ($179&255)>(1); //@line 137669 "c/sqlite3.c"
       if ($180) {
        $181 = $179&255; //@line 137669 "c/sqlite3.c"
        $$0370448 = $spec$select391;$$0386450$in = $181;$221 = -1;$223 = -1;
        while(1) {
         $$0386450 = (($$0386450$in) + -1)|0;
         $182 = (($51) + (($$0386450*80)|0)|0); //@line 137672 "c/sqlite3.c"
         $183 = (((($51) + (($$0386450*80)|0)|0)) + 64|0); //@line 137672 "c/sqlite3.c"
         $184 = HEAP32[$183>>2]|0; //@line 137672 "c/sqlite3.c"
         $185 = HEAP32[$33>>2]|0; //@line 137673 "c/sqlite3.c"
         $186 = ((($184)) + 16|0); //@line 137673 "c/sqlite3.c"
         $187 = HEAP8[$186>>0]|0; //@line 137673 "c/sqlite3.c"
         $188 = $187&255; //@line 137673 "c/sqlite3.c"
         $189 = (((((($185)) + 8|0) + (($188*72)|0)|0)) + 36|0); //@line 137674 "c/sqlite3.c"
         $190 = HEAP8[$189>>0]|0; //@line 137674 "c/sqlite3.c"
         $191 = $190 & 8; //@line 137674 "c/sqlite3.c"
         $192 = ($191<<24>>24)==(0); //@line 137674 "c/sqlite3.c"
         L73: do {
          if ($192) {
           $$1371 = $$0370448;$471 = $221;$472 = $223;
          } else {
           if ($127) {
            $193 = ((($184)) + 36|0); //@line 137676 "c/sqlite3.c"
            $194 = HEAP32[$193>>2]|0; //@line 137676 "c/sqlite3.c"
            $195 = $194 & 4096; //@line 137676 "c/sqlite3.c"
            $196 = ($195|0)==(0); //@line 137676 "c/sqlite3.c"
            if ($196) {
             $$1371 = $$0370448;$471 = $221;$472 = $223;
             break;
            }
           }
           $197 = ((($184)) + 8|0); //@line 137680 "c/sqlite3.c"
           $198 = $197; //@line 137680 "c/sqlite3.c"
           $199 = $198; //@line 137680 "c/sqlite3.c"
           $200 = HEAP32[$199>>2]|0; //@line 137680 "c/sqlite3.c"
           $201 = (($198) + 4)|0; //@line 137680 "c/sqlite3.c"
           $202 = $201; //@line 137680 "c/sqlite3.c"
           $203 = HEAP32[$202>>2]|0; //@line 137680 "c/sqlite3.c"
           $204 = $200 & $205; //@line 137680 "c/sqlite3.c"
           $206 = $203 & $207; //@line 137680 "c/sqlite3.c"
           $208 = ($204|0)==(0); //@line 137680 "c/sqlite3.c"
           $209 = ($206|0)==(0); //@line 137680 "c/sqlite3.c"
           $210 = $208 & $209; //@line 137680 "c/sqlite3.c"
           if (!($210)) {
            $$1371 = $$0370448;$471 = $221;$472 = $223;
            break;
           }
           $211 = HEAP32[$55>>2]|0; //@line 137681 "c/sqlite3.c"
           $212 = ((($211)) + 20|0); //@line 137681 "c/sqlite3.c"
           $213 = HEAP32[$212>>2]|0; //@line 137681 "c/sqlite3.c"
           $214 = ((($211)) + 12|0); //@line 137681 "c/sqlite3.c"
           $215 = HEAP32[$214>>2]|0; //@line 137681 "c/sqlite3.c"
           $216 = (($213) + (($215*48)|0)|0); //@line 137681 "c/sqlite3.c"
           $217 = ($215|0)>(0); //@line 137682 "c/sqlite3.c"
           do {
            if ($217) {
             $224 = (((((($185)) + 8|0) + (($188*72)|0)|0)) + 44|0);
             $$0388438 = $213;
             while(1) {
              $225 = ((($$0388438)) + 40|0); //@line 137683 "c/sqlite3.c"
              $226 = $225; //@line 137683 "c/sqlite3.c"
              $227 = $226; //@line 137683 "c/sqlite3.c"
              $228 = HEAP32[$227>>2]|0; //@line 137683 "c/sqlite3.c"
              $229 = (($226) + 4)|0; //@line 137683 "c/sqlite3.c"
              $230 = $229; //@line 137683 "c/sqlite3.c"
              $231 = HEAP32[$230>>2]|0; //@line 137683 "c/sqlite3.c"
              $232 = $228 & $200; //@line 137683 "c/sqlite3.c"
              $233 = $231 & $203; //@line 137683 "c/sqlite3.c"
              $234 = ($232|0)==(0); //@line 137683 "c/sqlite3.c"
              $235 = ($233|0)==(0); //@line 137683 "c/sqlite3.c"
              $236 = $234 & $235; //@line 137683 "c/sqlite3.c"
              if (!($236)) {
               $237 = HEAP32[$$0388438>>2]|0; //@line 137684 "c/sqlite3.c"
               $238 = ((($237)) + 4|0); //@line 137684 "c/sqlite3.c"
               $239 = HEAP32[$238>>2]|0; //@line 137684 "c/sqlite3.c"
               $240 = $239 & 1; //@line 137684 "c/sqlite3.c"
               $241 = ($240|0)==(0); //@line 137684 "c/sqlite3.c"
               if ($241) {
                $$1371 = $$0370448;$471 = $221;$472 = $223;
                break L73;
               }
               $242 = ((($237)) + 36|0); //@line 137685 "c/sqlite3.c"
               $243 = HEAP16[$242>>1]|0; //@line 137685 "c/sqlite3.c"
               $244 = $243 << 16 >> 16; //@line 137685 "c/sqlite3.c"
               $245 = HEAP32[$224>>2]|0; //@line 137685 "c/sqlite3.c"
               $246 = ($245|0)==($244|0); //@line 137685 "c/sqlite3.c"
               if (!($246)) {
                $$1371 = $$0370448;$471 = $221;$472 = $223;
                break L73;
               }
              }
              $247 = ((($$0388438)) + 48|0); //@line 137682 "c/sqlite3.c"
              $248 = ($247>>>0)<($216>>>0); //@line 137682 "c/sqlite3.c"
              if ($248) {
               $$0388438 = $247;
              } else {
               break;
              }
             }
             $249 = $200 ^ -1; //@line 137693 "c/sqlite3.c"
             $250 = $203 ^ -1; //@line 137693 "c/sqlite3.c"
             $251 = $221 & $249; //@line 137693 "c/sqlite3.c"
             $252 = $223 & $250; //@line 137693 "c/sqlite3.c"
             $253 = ($215|0)>(0); //@line 137694 "c/sqlite3.c"
             if (!($253)) {
              $473 = $251;$474 = $252;
              break;
             }
             $$1389441 = $213;
             while(1) {
              $254 = ((($$1389441)) + 40|0); //@line 137695 "c/sqlite3.c"
              $255 = $254; //@line 137695 "c/sqlite3.c"
              $256 = $255; //@line 137695 "c/sqlite3.c"
              $257 = HEAP32[$256>>2]|0; //@line 137695 "c/sqlite3.c"
              $258 = (($255) + 4)|0; //@line 137695 "c/sqlite3.c"
              $259 = $258; //@line 137695 "c/sqlite3.c"
              $260 = HEAP32[$259>>2]|0; //@line 137695 "c/sqlite3.c"
              $261 = $257 & $200; //@line 137695 "c/sqlite3.c"
              $262 = $260 & $203; //@line 137695 "c/sqlite3.c"
              $263 = ($261|0)==(0); //@line 137695 "c/sqlite3.c"
              $264 = ($262|0)==(0); //@line 137695 "c/sqlite3.c"
              $265 = $263 & $264; //@line 137695 "c/sqlite3.c"
              if (!($265)) {
               $266 = ((($$1389441)) + 10|0); //@line 137696 "c/sqlite3.c"
               $267 = HEAP16[$266>>1]|0; //@line 137696 "c/sqlite3.c"
               $268 = $267 | 4; //@line 137696 "c/sqlite3.c"
               HEAP16[$266>>1] = $268; //@line 137696 "c/sqlite3.c"
              }
              $269 = ((($$1389441)) + 48|0); //@line 137694 "c/sqlite3.c"
              $270 = ($269>>>0)<($216>>>0); //@line 137694 "c/sqlite3.c"
              if ($270) {
               $$1389441 = $269;
              } else {
               $473 = $251;$474 = $252;
               break;
              }
             }
            } else {
             $218 = $200 ^ -1; //@line 137693 "c/sqlite3.c"
             $219 = $203 ^ -1; //@line 137693 "c/sqlite3.c"
             $220 = $221 & $218; //@line 137693 "c/sqlite3.c"
             $222 = $223 & $219; //@line 137693 "c/sqlite3.c"
             $473 = $220;$474 = $222;
            }
           } while(0);
           $271 = HEAP8[$40>>0]|0; //@line 137699 "c/sqlite3.c"
           $272 = $271&255; //@line 137699 "c/sqlite3.c"
           $273 = (($272) + -1)|0; //@line 137699 "c/sqlite3.c"
           $274 = ($273|0)==($$0386450|0); //@line 137699 "c/sqlite3.c"
           if (!($274)) {
            $275 = (($51) + (($$0386450$in*80)|0)|0); //@line 137701 "c/sqlite3.c"
            $276 = (($273) - ($$0386450))|0; //@line 137700 "c/sqlite3.c"
            $277 = ($276*80)|0; //@line 137700 "c/sqlite3.c"
            _memmove(($182|0),($275|0),($277|0))|0; //@line 137701 "c/sqlite3.c"
           }
           $278 = HEAP8[$40>>0]|0; //@line 137703 "c/sqlite3.c"
           $279 = (($278) + -1)<<24>>24; //@line 137703 "c/sqlite3.c"
           HEAP8[$40>>0] = $279; //@line 137703 "c/sqlite3.c"
           $280 = (($$0370448) + -1)|0; //@line 137704 "c/sqlite3.c"
           $$1371 = $280;$471 = $473;$472 = $474;
          }
         } while(0);
         $281 = ($$0386450$in|0)>(2); //@line 137669 "c/sqlite3.c"
         if ($281) {
          $$0370448 = $$1371;$$0386450$in = $$0386450;$221 = $471;$223 = $472;
         } else {
          $$2 = $$1371;$469 = $471;$470 = $472;
          break;
         }
        }
       } else {
        $$2 = $spec$select391;$469 = -1;$470 = -1;
       }
      } else {
       $$2 = $spec$select391;$469 = -1;$470 = -1;
      }
     } else {
      $$2 = $spec$select391;$469 = -1;$470 = -1;
     }
     $282 = ((($29)) + 72|0); //@line 137708 "c/sqlite3.c"
     $283 = HEAP16[$282>>1]|0; //@line 137708 "c/sqlite3.c"
     $284 = $283 << 16 >> 16; //@line 137708 "c/sqlite3.c"
     $285 = HEAP32[$29>>2]|0; //@line 137708 "c/sqlite3.c"
     $286 = ((($285)) + 132|0); //@line 137708 "c/sqlite3.c"
     $287 = HEAP32[$286>>2]|0; //@line 137708 "c/sqlite3.c"
     $288 = (($287) + ($284))|0; //@line 137708 "c/sqlite3.c"
     HEAP32[$286>>2] = $288; //@line 137708 "c/sqlite3.c"
     $289 = $22 & 4; //@line 137730 "c/sqlite3.c"
     $290 = ($289|0)==(0); //@line 137730 "c/sqlite3.c"
     do {
      if ($290) {
       $$2383 = 0;
      } else {
       $291 = ((($29)) + 816|0); //@line 137731 "c/sqlite3.c"
       $292 = HEAP32[$291>>2]|0; //@line 137731 "c/sqlite3.c"
       $293 = ((($292)) + 36|0); //@line 137731 "c/sqlite3.c"
       $294 = HEAP32[$293>>2]|0; //@line 137731 "c/sqlite3.c"
       $295 = $294 & 4096; //@line 137732 "c/sqlite3.c"
       $296 = ($295|0)==(0); //@line 137732 "c/sqlite3.c"
       if ($296) {
        $297 = $22 & 8; //@line 137734 "c/sqlite3.c"
        $298 = ($297|0)!=(0); //@line 137734 "c/sqlite3.c"
        $299 = $294 & 1024; //@line 137735 "c/sqlite3.c"
        $300 = ($299|0)==(0); //@line 137735 "c/sqlite3.c"
        $or$cond394 = $298 & $300; //@line 137735 "c/sqlite3.c"
        if (!($or$cond394)) {
         $$2383 = 0;
         break;
        }
        $301 = $294 & 8192; //@line 137736 "c/sqlite3.c"
        $302 = ($301|0)!=(0); //@line 137736 "c/sqlite3.c"
        $303 = $22 & 16; //@line 137736 "c/sqlite3.c"
        $304 = ($303|0)==(0); //@line 137736 "c/sqlite3.c"
        $or$cond396 = $304 & $302; //@line 137736 "c/sqlite3.c"
        if ($or$cond396) {
         $$2383 = 0;
         break;
        }
       }
       $305 = $295 >>> 12; //@line 137738 "c/sqlite3.c"
       $306 = (2 - ($305))|0; //@line 137738 "c/sqlite3.c"
       $307 = $306&255; //@line 137738 "c/sqlite3.c"
       $308 = ((($29)) + 49|0); //@line 137738 "c/sqlite3.c"
       HEAP8[$308>>0] = $307; //@line 137738 "c/sqlite3.c"
       $309 = ((($1)) + 24|0); //@line 137739 "c/sqlite3.c"
       $310 = HEAP32[$309>>2]|0; //@line 137739 "c/sqlite3.c"
       $311 = ((($310)) + 36|0); //@line 137739 "c/sqlite3.c"
       $312 = HEAP32[$311>>2]|0; //@line 137739 "c/sqlite3.c"
       $313 = $312 & 32; //@line 137739 "c/sqlite3.c"
       $314 = ($313|0)!=(0); //@line 137739 "c/sqlite3.c"
       $315 = $294 & 64; //@line 137739 "c/sqlite3.c"
       $316 = ($315|0)==(0); //@line 137739 "c/sqlite3.c"
       $or$cond398 = $316 | $314; //@line 137739 "c/sqlite3.c"
       if ($or$cond398) {
        $$2383 = 0;
       } else {
        $317 = $294 & -65; //@line 137743 "c/sqlite3.c"
        HEAP32[$293>>2] = $317; //@line 137743 "c/sqlite3.c"
        $phitmp = $spec$select390 & 8; //@line 137744 "c/sqlite3.c"
        $$2383 = $phitmp;
       }
      }
     } while(0);
     $318 = ($$2|0)>(0); //@line 137751 "c/sqlite3.c"
     if ($318) {
      $319 = ((($29)) + 49|0);
      $$not401 = $24 ^ 1;
      $320 = ($6|0)==(0);
      $$not403 = $24 ^ 1;
      $brmerge404 = $320 | $$not403;
      $321 = ((($29)) + 49|0);
      $322 = ((($0)) + 40|0);
      $323 = ((($29)) + 51|0);
      $$0376433 = $51;$$2379432 = 0;
      while(1) {
       $324 = ((($$0376433)) + 44|0); //@line 137756 "c/sqlite3.c"
       $325 = HEAP8[$324>>0]|0; //@line 137756 "c/sqlite3.c"
       $326 = $325&255; //@line 137756 "c/sqlite3.c"
       $327 = (((((($1)) + 8|0) + (($326*72)|0)|0)) + 16|0); //@line 137757 "c/sqlite3.c"
       $328 = HEAP32[$327>>2]|0; //@line 137757 "c/sqlite3.c"
       $329 = ((($328)) + 72|0); //@line 137758 "c/sqlite3.c"
       $330 = HEAP32[$329>>2]|0; //@line 137758 "c/sqlite3.c"
       $331 = (_sqlite3SchemaToIndex($10,$330)|0); //@line 137758 "c/sqlite3.c"
       $332 = ((($$0376433)) + 64|0); //@line 137759 "c/sqlite3.c"
       $333 = HEAP32[$332>>2]|0; //@line 137759 "c/sqlite3.c"
       $334 = ((($328)) + 36|0); //@line 137760 "c/sqlite3.c"
       $335 = HEAP32[$334>>2]|0; //@line 137760 "c/sqlite3.c"
       $336 = $335 & 2; //@line 137760 "c/sqlite3.c"
       $337 = ($336|0)==(0); //@line 137760 "c/sqlite3.c"
       do {
        if ($337) {
         $338 = ((($328)) + 12|0); //@line 137760 "c/sqlite3.c"
         $339 = HEAP32[$338>>2]|0; //@line 137760 "c/sqlite3.c"
         $340 = ($339|0)==(0|0); //@line 137760 "c/sqlite3.c"
         if ($340) {
          $341 = ((($333)) + 36|0); //@line 137764 "c/sqlite3.c"
          $342 = HEAP32[$341>>2]|0; //@line 137764 "c/sqlite3.c"
          $343 = $342 & 1024; //@line 137764 "c/sqlite3.c"
          $344 = ($343|0)==(0); //@line 137764 "c/sqlite3.c"
          if (!($344)) {
           $345 = (_sqlite3GetVTable($10,$328)|0); //@line 137765 "c/sqlite3.c"
           $346 = (((((($1)) + 8|0) + (($326*72)|0)|0)) + 44|0); //@line 137766 "c/sqlite3.c"
           $347 = HEAP32[$346>>2]|0; //@line 137766 "c/sqlite3.c"
           (_sqlite3VdbeAddOp4($9,157,$347,0,0,$345,-12)|0); //@line 137767 "c/sqlite3.c"
           break;
          }
          $348 = ((($328)) + 56|0); //@line 137768 "c/sqlite3.c"
          $349 = HEAP32[$348>>2]|0; //@line 137768 "c/sqlite3.c"
          $350 = ($349|0)==(0); //@line 137768 "c/sqlite3.c"
          if (!($350)) {
           break;
          }
          $351 = $342 & 64; //@line 137772 "c/sqlite3.c"
          $352 = $351 | $23; //@line 137773 "c/sqlite3.c"
          $353 = ($352|0)==(0); //@line 137773 "c/sqlite3.c"
          if (!($353)) {
           $387 = ((($328)) + 28|0); //@line 137803 "c/sqlite3.c"
           $388 = HEAP32[$387>>2]|0; //@line 137803 "c/sqlite3.c"
           $389 = HEAP32[$328>>2]|0; //@line 137803 "c/sqlite3.c"
           _sqlite3TableLock($0,$331,$388,0,$389); //@line 137803 "c/sqlite3.c"
           break;
          }
          $354 = HEAP8[$321>>0]|0; //@line 137775 "c/sqlite3.c"
          $355 = ($354<<24>>24)==(0); //@line 137775 "c/sqlite3.c"
          if ($355) {
           $$0369 = 105;
          } else {
           $356 = (((((($1)) + 8|0) + (($326*72)|0)|0)) + 44|0); //@line 137777 "c/sqlite3.c"
           $357 = HEAP32[$356>>2]|0; //@line 137777 "c/sqlite3.c"
           HEAP32[$37>>2] = $357; //@line 137777 "c/sqlite3.c"
           $$0369 = 106;
          }
          $358 = (((((($1)) + 8|0) + (($326*72)|0)|0)) + 44|0); //@line 137779 "c/sqlite3.c"
          $359 = HEAP32[$358>>2]|0; //@line 137779 "c/sqlite3.c"
          _sqlite3OpenTable($0,$359,$331,$328,$$0369); //@line 137779 "c/sqlite3.c"
          $360 = HEAP8[$321>>0]|0; //@line 137783 "c/sqlite3.c"
          $361 = ($360<<24>>24)==(0); //@line 137783 "c/sqlite3.c"
          do {
           if ($361) {
            $362 = ((($328)) + 42|0); //@line 137783 "c/sqlite3.c"
            $363 = HEAP16[$362>>1]|0; //@line 137783 "c/sqlite3.c"
            $364 = ($363<<16>>16)<(64); //@line 137783 "c/sqlite3.c"
            if (!($364)) {
             break;
            }
            $365 = HEAP32[$334>>2]|0; //@line 137783 "c/sqlite3.c"
            $366 = $365 & 32; //@line 137783 "c/sqlite3.c"
            $367 = ($366|0)==(0); //@line 137783 "c/sqlite3.c"
            if (!($367)) {
             break;
            }
            $368 = (((((($1)) + 8|0) + (($326*72)|0)|0)) + 56|0); //@line 137784 "c/sqlite3.c"
            $369 = $368; //@line 137784 "c/sqlite3.c"
            $370 = $369; //@line 137784 "c/sqlite3.c"
            $371 = HEAP32[$370>>2]|0; //@line 137784 "c/sqlite3.c"
            $372 = (($369) + 4)|0; //@line 137784 "c/sqlite3.c"
            $373 = $372; //@line 137784 "c/sqlite3.c"
            $374 = HEAP32[$373>>2]|0; //@line 137784 "c/sqlite3.c"
            $375 = ($371|0)==(0); //@line 137786 "c/sqlite3.c"
            $376 = ($374|0)==(0); //@line 137786 "c/sqlite3.c"
            $377 = $375 & $376; //@line 137786 "c/sqlite3.c"
            if ($377) {
             $$0367$lcssa = 0;
            } else {
             $$0367423 = 0;$378 = $371;$379 = $374;
             while(1) {
              $380 = (_bitshift64Lshr(($378|0),($379|0),1)|0); //@line 137786 "c/sqlite3.c"
              $381 = tempRet0; //@line 137786 "c/sqlite3.c"
              $382 = (($$0367423) + 1)|0; //@line 137786 "c/sqlite3.c"
              $383 = ($380|0)==(0); //@line 137786 "c/sqlite3.c"
              $384 = ($381|0)==(0); //@line 137786 "c/sqlite3.c"
              $385 = $383 & $384; //@line 137786 "c/sqlite3.c"
              if ($385) {
               $$0367$lcssa = $382;
               break;
              } else {
               $$0367423 = $382;$378 = $380;$379 = $381;
              }
             }
            }
            $386 = $$0367$lcssa; //@line 137787 "c/sqlite3.c"
            _sqlite3VdbeChangeP4($9,-1,$386,-3); //@line 137787 "c/sqlite3.c"
           }
          } while(0);
          _sqlite3VdbeChangeP5($9,$$2383); //@line 137796 "c/sqlite3.c"
         }
        }
       } while(0);
       $390 = ((($333)) + 36|0); //@line 137805 "c/sqlite3.c"
       $391 = HEAP32[$390>>2]|0; //@line 137805 "c/sqlite3.c"
       $392 = $391 & 512; //@line 137805 "c/sqlite3.c"
       $393 = ($392|0)==(0); //@line 137805 "c/sqlite3.c"
       L137: do {
        if (!($393)) {
         $394 = ((($333)) + 32|0); //@line 137806 "c/sqlite3.c"
         $395 = HEAP32[$394>>2]|0; //@line 137806 "c/sqlite3.c"
         $396 = HEAP32[$334>>2]|0; //@line 137811 "c/sqlite3.c"
         $397 = $396 & 32; //@line 137811 "c/sqlite3.c"
         $398 = ($397|0)==(0); //@line 137811 "c/sqlite3.c"
         do {
          if (!($398)) {
           $399 = ((($395)) + 55|0); //@line 137811 "c/sqlite3.c"
           $400 = HEAPU8[$399>>0]|(HEAPU8[$399+1>>0]<<8); //@line 137811 "c/sqlite3.c"
           $401 = $400 & 3; //@line 137811 "c/sqlite3.c"
           $402 = ($401<<16>>16)!=(2); //@line 137811 "c/sqlite3.c"
           $brmerge = $402 | $$not401; //@line 137812 "c/sqlite3.c"
           if ($brmerge) {
            break;
           }
           $415 = ((($$0376433)) + 4|0); //@line 137816 "c/sqlite3.c"
           $416 = HEAP32[$415>>2]|0; //@line 137816 "c/sqlite3.c"
           $417 = ((($$0376433)) + 8|0); //@line 137834 "c/sqlite3.c"
           HEAP32[$417>>2] = $416; //@line 137834 "c/sqlite3.c"
           break L137;
          }
         } while(0);
         $403 = HEAP8[$319>>0]|0; //@line 137818 "c/sqlite3.c"
         $404 = ($403<<24>>24)==(0); //@line 137818 "c/sqlite3.c"
         do {
          if ($404) {
           if (!($brmerge404)) {
            $$0364$ph = 104;$$1$ph = $6;
            break;
           }
           $413 = HEAP32[$322>>2]|0; //@line 137832 "c/sqlite3.c"
           $414 = (($413) + 1)|0; //@line 137832 "c/sqlite3.c"
           HEAP32[$322>>2] = $414; //@line 137832 "c/sqlite3.c"
           $$0364$ph = 105;$$1$ph = $413;
          } else {
           $405 = HEAP32[$327>>2]|0; //@line 137819 "c/sqlite3.c"
           $406 = ((($405)) + 8|0); //@line 137819 "c/sqlite3.c"
           $$0363425 = HEAP32[$406>>2]|0;
           $407 = ($$0363425|0)==(0|0); //@line 137822 "c/sqlite3.c"
           $408 = ($$0363425|0)==($395|0); //@line 137822 "c/sqlite3.c"
           $or$cond402426 = $407 | $408; //@line 137822 "c/sqlite3.c"
           if ($or$cond402426) {
            $$0365$lcssa = $6;
           } else {
            $$0363428 = $$0363425;$$0365427 = $6;
            while(1) {
             $409 = (($$0365427) + 1)|0; //@line 137823 "c/sqlite3.c"
             $410 = ((($$0363428)) + 20|0); //@line 137824 "c/sqlite3.c"
             $$0363 = HEAP32[$410>>2]|0;
             $411 = ($$0363|0)==(0|0); //@line 137822 "c/sqlite3.c"
             $412 = ($$0363|0)==($395|0); //@line 137822 "c/sqlite3.c"
             $or$cond402 = $411 | $412; //@line 137822 "c/sqlite3.c"
             if ($or$cond402) {
              $$0365$lcssa = $409;
              break;
             } else {
              $$0363428 = $$0363;$$0365427 = $409;
             }
            }
           }
           HEAP32[$38>>2] = $$0365$lcssa; //@line 137827 "c/sqlite3.c"
           $$0364$ph = 106;$$1$ph = $$0365$lcssa;
          }
         } while(0);
         $418 = ((($$0376433)) + 8|0); //@line 137834 "c/sqlite3.c"
         HEAP32[$418>>2] = $$1$ph; //@line 137834 "c/sqlite3.c"
         $419 = ((($395)) + 44|0); //@line 137838 "c/sqlite3.c"
         $420 = HEAP32[$419>>2]|0; //@line 137838 "c/sqlite3.c"
         (_sqlite3VdbeAddOp3($9,$$0364$ph,$$1$ph,$420,$331)|0); //@line 137838 "c/sqlite3.c"
         _sqlite3VdbeSetP4KeyInfo($0,$395); //@line 137839 "c/sqlite3.c"
         $421 = HEAP32[$390>>2]|0; //@line 137840 "c/sqlite3.c"
         $422 = $421 & 15; //@line 137840 "c/sqlite3.c"
         $423 = ($422|0)!=(0); //@line 137840 "c/sqlite3.c"
         $424 = $421 & 32770; //@line 137841 "c/sqlite3.c"
         $425 = ($424|0)==(0); //@line 137841 "c/sqlite3.c"
         $or$cond406 = $423 & $425; //@line 137841 "c/sqlite3.c"
         if (!($or$cond406)) {
          break;
         }
         $426 = HEAP16[$44>>1]|0; //@line 137842 "c/sqlite3.c"
         $427 = $426 & 1; //@line 137842 "c/sqlite3.c"
         $428 = ($427<<16>>16)==(0); //@line 137842 "c/sqlite3.c"
         if (!($428)) {
          break;
         }
         $429 = HEAP8[$323>>0]|0; //@line 137843 "c/sqlite3.c"
         $430 = ($429<<24>>24)==(2); //@line 137843 "c/sqlite3.c"
         if ($430) {
          break;
         }
         _sqlite3VdbeChangeP5($9,2); //@line 137845 "c/sqlite3.c"
        }
       } while(0);
       $431 = ($331|0)>(-1); //@line 137865 "c/sqlite3.c"
       if ($431) {
        _sqlite3CodeVerifySchema($0,$331); //@line 137865 "c/sqlite3.c"
       }
       $432 = (($$2379432) + 1)|0; //@line 137751 "c/sqlite3.c"
       $433 = ((($$0376433)) + 80|0); //@line 137751 "c/sqlite3.c"
       $exitcond = ($432|0)==($$2|0); //@line 137751 "c/sqlite3.c"
       if ($exitcond) {
        break;
       } else {
        $$0376433 = $433;$$2379432 = $432;
       }
      }
     }
     $434 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 137867 "c/sqlite3.c"
     $435 = ((($29)) + 56|0); //@line 137867 "c/sqlite3.c"
     HEAP32[$435>>2] = $434; //@line 137867 "c/sqlite3.c"
     $436 = HEAP8[$30>>0]|0; //@line 137868 "c/sqlite3.c"
     $437 = ($436<<24>>24)==(0); //@line 137868 "c/sqlite3.c"
     if ($437) {
      $438 = ($$2|0)>(0); //@line 137874 "c/sqlite3.c"
      if (!($438)) {
       $$0 = $29;
       STACKTOP = sp;return ($$0|0); //@line 137908 "c/sqlite3.c"
      }
      $$3380420 = 0;$450 = $469;$451 = $470;
      while(1) {
       $439 = (($51) + (($$3380420*80)|0)|0); //@line 137877 "c/sqlite3.c"
       $440 = (((($51) + (($$3380420*80)|0)|0)) + 64|0); //@line 137878 "c/sqlite3.c"
       $441 = HEAP32[$440>>2]|0; //@line 137878 "c/sqlite3.c"
       $442 = ((($441)) + 36|0); //@line 137878 "c/sqlite3.c"
       $443 = HEAP32[$442>>2]|0; //@line 137878 "c/sqlite3.c"
       $444 = $443 & 16384; //@line 137880 "c/sqlite3.c"
       $445 = ($444|0)==(0); //@line 137880 "c/sqlite3.c"
       if (!($445)) {
        $446 = (((($51) + (($$3380420*80)|0)|0)) + 44|0); //@line 137882 "c/sqlite3.c"
        $447 = HEAP8[$446>>0]|0; //@line 137882 "c/sqlite3.c"
        $448 = $447&255; //@line 137882 "c/sqlite3.c"
        $449 = (((($1)) + 8|0) + (($448*72)|0)|0); //@line 137882 "c/sqlite3.c"
        _constructAutomaticIndex($0,$54,$449,$450,$451,$439); //@line 137881 "c/sqlite3.c"
        $452 = HEAP8[$30>>0]|0; //@line 137883 "c/sqlite3.c"
        $453 = ($452<<24>>24)==(0); //@line 137883 "c/sqlite3.c"
        if (!($453)) {
         break L22;
        }
       }
       $454 = (((($51) + (($$3380420*80)|0)|0)) + 44|0); //@line 137887 "c/sqlite3.c"
       $455 = HEAP8[$454>>0]|0; //@line 137887 "c/sqlite3.c"
       $456 = $455&255; //@line 137887 "c/sqlite3.c"
       _sqlite3WhereExplainOneScan($0,$1,$439,$$3380420,$456,$spec$select390); //@line 137886 "c/sqlite3.c"
       $457 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 137889 "c/sqlite3.c"
       $458 = (((($51) + (($$3380420*80)|0)|0)) + 32|0); //@line 137889 "c/sqlite3.c"
       HEAP32[$458>>2] = $457; //@line 137889 "c/sqlite3.c"
       $459 = (_sqlite3WhereCodeOneLoopStart($29,$$3380420,$450,$451)|0); //@line 137890 "c/sqlite3.c"
       $460 = tempRet0; //@line 137890 "c/sqlite3.c"
       $461 = (((($51) + (($$3380420*80)|0)|0)) + 24|0); //@line 137891 "c/sqlite3.c"
       $462 = HEAP32[$461>>2]|0; //@line 137891 "c/sqlite3.c"
       HEAP32[$42>>2] = $462; //@line 137891 "c/sqlite3.c"
       $463 = (($$3380420) + 1)|0; //@line 137874 "c/sqlite3.c"
       $464 = ($463|0)<($$2|0); //@line 137874 "c/sqlite3.c"
       if ($464) {
        $$3380420 = $463;$450 = $459;$451 = $460;
       } else {
        $$0 = $29;
        break;
       }
      }
      STACKTOP = sp;return ($$0|0); //@line 137908 "c/sqlite3.c"
     }
    }
   }
  } else {
   label = 118;
  }
 } while(0);
 if ((label|0) == 118) {
  $465 = ($29|0)==(0|0); //@line 137903 "c/sqlite3.c"
  if ($465) {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 137908 "c/sqlite3.c"
  }
 }
 $466 = ((($29)) + 40|0); //@line 137904 "c/sqlite3.c"
 $467 = HEAP32[$466>>2]|0; //@line 137904 "c/sqlite3.c"
 $468 = ((($0)) + 132|0); //@line 137904 "c/sqlite3.c"
 HEAP32[$468>>2] = $467; //@line 137904 "c/sqlite3.c"
 _whereInfoFree($10,$29); //@line 137905 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 137908 "c/sqlite3.c"
}
function _sqlite3WhereEnd($0) {
 $0 = $0|0;
 var $$0209 = 0, $$0211221 = 0, $$0212 = 0, $$0212$in = 0, $$0213220 = 0, $$0214 = 0, $$0215219 = 0, $$0216225 = 0, $$0217230 = 0, $$0218229 = 0, $$0235 = 0, $$0235$in = 0, $$1223 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0;
 var $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0;
 var $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0;
 var $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0;
 var $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0;
 var $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0;
 var $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0;
 var $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0;
 var $231 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond239 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 137915 "c/sqlite3.c"
 $2 = ((($1)) + 8|0); //@line 137916 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 137916 "c/sqlite3.c"
 $4 = ((($0)) + 4|0); //@line 137920 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 137920 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 137921 "c/sqlite3.c"
 _sqlite3ExprCacheClear($1); //@line 137926 "c/sqlite3.c"
 $7 = ((($0)) + 46|0); //@line 137927 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 137927 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 137927 "c/sqlite3.c"
 if (!($9)) {
  $10 = $8&255; //@line 137927 "c/sqlite3.c"
  $11 = ((($0)) + 51|0);
  $12 = ((($1)) + 44|0);
  $$0235$in = $10;
  while(1) {
   $$0235 = (($$0235$in) + -1)|0;
   $13 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 64|0); //@line 137930 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 137930 "c/sqlite3.c"
   $15 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 45|0); //@line 137931 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 137931 "c/sqlite3.c"
   $17 = ($16<<24>>24)==(-88); //@line 137931 "c/sqlite3.c"
   if ($17) {
    $74 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 24|0); //@line 137968 "c/sqlite3.c"
    $75 = HEAP32[$74>>2]|0; //@line 137968 "c/sqlite3.c"
    _sqlite3VdbeResolveLabel($3,$75); //@line 137968 "c/sqlite3.c"
   } else {
    $18 = HEAP8[$11>>0]|0; //@line 137936 "c/sqlite3.c"
    $19 = ($18<<24>>24)==(2); //@line 137936 "c/sqlite3.c"
    if ($19) {
     $20 = HEAP8[$7>>0]|0; //@line 137937 "c/sqlite3.c"
     $21 = $20&255; //@line 137937 "c/sqlite3.c"
     $22 = ($$0235$in|0)==($21|0); //@line 137937 "c/sqlite3.c"
     if ($22) {
      $23 = ((($14)) + 36|0); //@line 137938 "c/sqlite3.c"
      $24 = HEAP32[$23>>2]|0; //@line 137938 "c/sqlite3.c"
      $25 = $24 & 512; //@line 137938 "c/sqlite3.c"
      $26 = ($25|0)==(0); //@line 137938 "c/sqlite3.c"
      if ($26) {
       $$0214 = 0;
      } else {
       $27 = ((($14)) + 32|0); //@line 137939 "c/sqlite3.c"
       $28 = HEAP32[$27>>2]|0; //@line 137939 "c/sqlite3.c"
       $29 = ((($28)) + 55|0); //@line 137939 "c/sqlite3.c"
       $30 = HEAPU8[$29>>0]|(HEAPU8[$29+1>>0]<<8); //@line 137939 "c/sqlite3.c"
       $31 = $30 & 128; //@line 137939 "c/sqlite3.c"
       $32 = ($31<<16>>16)==(0); //@line 137939 "c/sqlite3.c"
       if ($32) {
        $$0214 = 0;
       } else {
        $33 = ((($14)) + 30|0); //@line 137940 "c/sqlite3.c"
        $34 = HEAP16[$33>>1]|0; //@line 137940 "c/sqlite3.c"
        $35 = $34&65535; //@line 137940 "c/sqlite3.c"
        $36 = ($34<<16>>16)==(0); //@line 137940 "c/sqlite3.c"
        if ($36) {
         $$0214 = 0;
        } else {
         $37 = ((($28)) + 8|0); //@line 137941 "c/sqlite3.c"
         $38 = HEAP32[$37>>2]|0; //@line 137941 "c/sqlite3.c"
         $39 = (($38) + ($35<<1)|0); //@line 137941 "c/sqlite3.c"
         $40 = HEAP16[$39>>1]|0; //@line 137941 "c/sqlite3.c"
         $41 = ($40<<16>>16)>(35); //@line 137941 "c/sqlite3.c"
         if ($41) {
          $42 = HEAP32[$12>>2]|0; //@line 137943 "c/sqlite3.c"
          $43 = (($42) + 1)|0; //@line 137943 "c/sqlite3.c"
          $44 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 8|0);
          $$0216225 = 0;
          while(1) {
           $45 = HEAP32[$44>>2]|0; //@line 137946 "c/sqlite3.c"
           $46 = (($$0216225) + ($43))|0; //@line 137946 "c/sqlite3.c"
           (_sqlite3VdbeAddOp3($3,98,$45,$$0216225,$46)|0); //@line 137946 "c/sqlite3.c"
           $47 = (($$0216225) + 1)|0; //@line 137945 "c/sqlite3.c"
           $exitcond239 = ($47|0)==($35|0); //@line 137945 "c/sqlite3.c"
           if ($exitcond239) {
            break;
           } else {
            $$0216225 = $47;
           }
          }
          $48 = (($35) + 1)|0; //@line 137948 "c/sqlite3.c"
          $49 = HEAP32[$12>>2]|0; //@line 137948 "c/sqlite3.c"
          $50 = (($48) + ($49))|0; //@line 137948 "c/sqlite3.c"
          HEAP32[$12>>2] = $50; //@line 137948 "c/sqlite3.c"
          $51 = HEAP8[$15>>0]|0; //@line 137949 "c/sqlite3.c"
          $52 = ($51<<24>>24)==(6); //@line 137949 "c/sqlite3.c"
          $53 = $52 ? 24 : 27; //@line 137949 "c/sqlite3.c"
          $54 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 8|0); //@line 137950 "c/sqlite3.c"
          $55 = HEAP32[$54>>2]|0; //@line 137950 "c/sqlite3.c"
          $56 = (_sqlite3VdbeAddOp4Int($3,$53,$55,0,$43,$35)|0); //@line 137950 "c/sqlite3.c"
          $57 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 52|0); //@line 137953 "c/sqlite3.c"
          $58 = HEAP32[$57>>2]|0; //@line 137953 "c/sqlite3.c"
          (_sqlite3VdbeAddOp2($3,13,1,$58)|0); //@line 137953 "c/sqlite3.c"
          $$0214 = $56;
         } else {
          $$0214 = 0;
         }
        }
       }
      }
     } else {
      $$0214 = 0;
     }
    } else {
     $$0214 = 0;
    }
    $59 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 24|0); //@line 137957 "c/sqlite3.c"
    $60 = HEAP32[$59>>2]|0; //@line 137957 "c/sqlite3.c"
    _sqlite3VdbeResolveLabel($3,$60); //@line 137957 "c/sqlite3.c"
    $61 = HEAP8[$15>>0]|0; //@line 137958 "c/sqlite3.c"
    $62 = $61&255; //@line 137958 "c/sqlite3.c"
    $63 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 48|0); //@line 137958 "c/sqlite3.c"
    $64 = HEAP32[$63>>2]|0; //@line 137958 "c/sqlite3.c"
    $65 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 52|0); //@line 137958 "c/sqlite3.c"
    $66 = HEAP32[$65>>2]|0; //@line 137958 "c/sqlite3.c"
    $67 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 46|0); //@line 137958 "c/sqlite3.c"
    $68 = HEAP8[$67>>0]|0; //@line 137958 "c/sqlite3.c"
    $69 = $68&255; //@line 137958 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($3,$62,$64,$66,$69)|0); //@line 137958 "c/sqlite3.c"
    $70 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 47|0); //@line 137959 "c/sqlite3.c"
    $71 = HEAP8[$70>>0]|0; //@line 137959 "c/sqlite3.c"
    $72 = $71&255; //@line 137959 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($3,$72); //@line 137959 "c/sqlite3.c"
    $73 = ($$0214|0)==(0); //@line 137965 "c/sqlite3.c"
    if (!($73)) {
     _sqlite3VdbeJumpHere($3,$$0214); //@line 137965 "c/sqlite3.c"
    }
   }
   $76 = ((($14)) + 36|0); //@line 137970 "c/sqlite3.c"
   $77 = HEAP32[$76>>2]|0; //@line 137970 "c/sqlite3.c"
   $78 = $77 & 2048; //@line 137970 "c/sqlite3.c"
   $79 = ($78|0)==(0); //@line 137970 "c/sqlite3.c"
   if (!($79)) {
    $80 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 56|0); //@line 137970 "c/sqlite3.c"
    $81 = HEAP32[$80>>2]|0; //@line 137970 "c/sqlite3.c"
    $82 = ($81|0)>(0); //@line 137970 "c/sqlite3.c"
    if ($82) {
     $83 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 16|0); //@line 137973 "c/sqlite3.c"
     $84 = HEAP32[$83>>2]|0; //@line 137973 "c/sqlite3.c"
     _sqlite3VdbeResolveLabel($3,$84); //@line 137973 "c/sqlite3.c"
     $85 = HEAP32[$80>>2]|0; //@line 137974 "c/sqlite3.c"
     $86 = ($85|0)>(0); //@line 137974 "c/sqlite3.c"
     if ($86) {
      $87 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 60|0); //@line 137974 "c/sqlite3.c"
      $88 = HEAP32[$87>>2]|0; //@line 137974 "c/sqlite3.c"
      $89 = (($85) + -1)|0; //@line 137974 "c/sqlite3.c"
      $90 = (($88) + (($89*12)|0)|0); //@line 137974 "c/sqlite3.c"
      $$0217230 = $85;$$0218229 = $90;
      while(1) {
       $91 = ((($$0218229)) + 4|0); //@line 137975 "c/sqlite3.c"
       $92 = HEAP32[$91>>2]|0; //@line 137975 "c/sqlite3.c"
       $93 = (($92) + 1)|0; //@line 137975 "c/sqlite3.c"
       _sqlite3VdbeJumpHere($3,$93); //@line 137975 "c/sqlite3.c"
       $94 = ((($$0218229)) + 8|0); //@line 137976 "c/sqlite3.c"
       $95 = HEAP8[$94>>0]|0; //@line 137976 "c/sqlite3.c"
       $96 = ($95<<24>>24)==(-88); //@line 137976 "c/sqlite3.c"
       if (!($96)) {
        $97 = $95&255; //@line 137976 "c/sqlite3.c"
        $98 = HEAP32[$$0218229>>2]|0; //@line 137977 "c/sqlite3.c"
        $99 = HEAP32[$91>>2]|0; //@line 137977 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($3,$97,$98,$99)|0); //@line 137977 "c/sqlite3.c"
       }
       $100 = HEAP32[$91>>2]|0; //@line 137982 "c/sqlite3.c"
       $101 = (($100) + -1)|0; //@line 137982 "c/sqlite3.c"
       _sqlite3VdbeJumpHere($3,$101); //@line 137982 "c/sqlite3.c"
       $102 = (($$0217230) + -1)|0; //@line 137974 "c/sqlite3.c"
       $103 = ((($$0218229)) + -12|0); //@line 137974 "c/sqlite3.c"
       $104 = ($$0217230|0)>(1); //@line 137974 "c/sqlite3.c"
       if ($104) {
        $$0217230 = $102;$$0218229 = $103;
       } else {
        break;
       }
      }
     }
    }
   }
   $105 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 12|0); //@line 137985 "c/sqlite3.c"
   $106 = HEAP32[$105>>2]|0; //@line 137985 "c/sqlite3.c"
   _sqlite3VdbeResolveLabel($3,$106); //@line 137985 "c/sqlite3.c"
   $107 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 20|0); //@line 137986 "c/sqlite3.c"
   $108 = HEAP32[$107>>2]|0; //@line 137986 "c/sqlite3.c"
   $109 = ($108|0)==(0); //@line 137986 "c/sqlite3.c"
   if (!($109)) {
    _sqlite3VdbeGoto($3,$108); //@line 137987 "c/sqlite3.c"
    $110 = HEAP32[$107>>2]|0; //@line 137989 "c/sqlite3.c"
    _sqlite3VdbeJumpHere($3,$110); //@line 137989 "c/sqlite3.c"
    $111 = HEAP32[$107>>2]|0; //@line 137990 "c/sqlite3.c"
    $112 = (($111) + -2)|0; //@line 137990 "c/sqlite3.c"
    _sqlite3VdbeJumpHere($3,$112); //@line 137990 "c/sqlite3.c"
   }
   $113 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 40|0); //@line 137993 "c/sqlite3.c"
   $114 = HEAP32[$113>>2]|0; //@line 137993 "c/sqlite3.c"
   $115 = ($114|0)==(0); //@line 137993 "c/sqlite3.c"
   if (!($115)) {
    $116 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 36|0); //@line 137994 "c/sqlite3.c"
    $117 = HEAP32[$116>>2]|0; //@line 137994 "c/sqlite3.c"
    $118 = $117 >>> 1; //@line 137994 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($3,59,$118,$114)|0); //@line 137994 "c/sqlite3.c"
   }
   $119 = (((($0)) + 752|0) + (($$0235*80)|0)|0); //@line 137999 "c/sqlite3.c"
   $120 = HEAP32[$119>>2]|0; //@line 137999 "c/sqlite3.c"
   $121 = ($120|0)==(0); //@line 137999 "c/sqlite3.c"
   if (!($121)) {
    $122 = HEAP32[$76>>2]|0; //@line 138000 "c/sqlite3.c"
    $123 = (_sqlite3VdbeAddOp1($3,48,$120)|0); //@line 138001 "c/sqlite3.c"
    $124 = $122 & 64; //@line 138003 "c/sqlite3.c"
    $125 = ($124|0)==(0); //@line 138003 "c/sqlite3.c"
    if ($125) {
     $126 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 4|0); //@line 138005 "c/sqlite3.c"
     $127 = HEAP32[$126>>2]|0; //@line 138005 "c/sqlite3.c"
     (_sqlite3VdbeAddOp1($3,125,$127)|0); //@line 138005 "c/sqlite3.c"
    }
    $128 = $122 & 512; //@line 138007 "c/sqlite3.c"
    $129 = ($128|0)==(0); //@line 138007 "c/sqlite3.c"
    if ($129) {
     $130 = $122 & 8192; //@line 138008 "c/sqlite3.c"
     $131 = ($130|0)==(0); //@line 138008 "c/sqlite3.c"
     if (!($131)) {
      $132 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 56|0); //@line 138008 "c/sqlite3.c"
      $133 = HEAP32[$132>>2]|0; //@line 138008 "c/sqlite3.c"
      $134 = ($133|0)==(0|0); //@line 138008 "c/sqlite3.c"
      if (!($134)) {
       label = 33;
      }
     }
    } else {
     label = 33;
    }
    if ((label|0) == 33) {
     label = 0;
     $135 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 8|0); //@line 138010 "c/sqlite3.c"
     $136 = HEAP32[$135>>2]|0; //@line 138010 "c/sqlite3.c"
     (_sqlite3VdbeAddOp1($3,125,$136)|0); //@line 138010 "c/sqlite3.c"
    }
    $137 = HEAP8[$15>>0]|0; //@line 138012 "c/sqlite3.c"
    $138 = ($137<<24>>24)==(63); //@line 138012 "c/sqlite3.c"
    if ($138) {
     $139 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 48|0); //@line 138013 "c/sqlite3.c"
     $140 = HEAP32[$139>>2]|0; //@line 138013 "c/sqlite3.c"
     $141 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 28|0); //@line 138013 "c/sqlite3.c"
     $142 = HEAP32[$141>>2]|0; //@line 138013 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($3,14,$140,$142)|0); //@line 138013 "c/sqlite3.c"
    } else {
     $143 = (((((($0)) + 752|0) + (($$0235*80)|0)|0)) + 28|0); //@line 138015 "c/sqlite3.c"
     $144 = HEAP32[$143>>2]|0; //@line 138015 "c/sqlite3.c"
     _sqlite3VdbeGoto($3,$144); //@line 138015 "c/sqlite3.c"
    }
    _sqlite3VdbeJumpHere($3,$123); //@line 138017 "c/sqlite3.c"
   }
   $145 = ($$0235$in|0)>(1); //@line 137927 "c/sqlite3.c"
   if ($145) {
    $$0235$in = $$0235;
   } else {
    break;
   }
  }
 }
 $146 = ((($0)) + 36|0); //@line 138026 "c/sqlite3.c"
 $147 = HEAP32[$146>>2]|0; //@line 138026 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($3,$147); //@line 138026 "c/sqlite3.c"
 $148 = HEAP8[$7>>0]|0; //@line 138029 "c/sqlite3.c"
 $149 = ($148<<24>>24)==(0); //@line 138029 "c/sqlite3.c"
 if ($149) {
  $229 = ((($0)) + 40|0); //@line 138105 "c/sqlite3.c"
  $230 = HEAP32[$229>>2]|0; //@line 138105 "c/sqlite3.c"
  $231 = ((($1)) + 132|0); //@line 138105 "c/sqlite3.c"
  HEAP32[$231>>2] = $230; //@line 138105 "c/sqlite3.c"
  _whereInfoFree($6,$0); //@line 138106 "c/sqlite3.c"
  return; //@line 138108 "c/sqlite3.c"
 }
 $150 = ((($0)) + 752|0); //@line 138029 "c/sqlite3.c"
 $151 = ((($0)) + 49|0);
 $152 = ((($6)) + 73|0);
 $$0211221 = $150;$$1223 = 0;
 while(1) {
  $153 = ((($$0211221)) + 44|0); //@line 138033 "c/sqlite3.c"
  $154 = HEAP8[$153>>0]|0; //@line 138033 "c/sqlite3.c"
  $155 = $154&255; //@line 138033 "c/sqlite3.c"
  $156 = (((((($5)) + 8|0) + (($155*72)|0)|0)) + 16|0); //@line 138034 "c/sqlite3.c"
  $157 = HEAP32[$156>>2]|0; //@line 138034 "c/sqlite3.c"
  $158 = ((($$0211221)) + 64|0); //@line 138036 "c/sqlite3.c"
  $159 = HEAP32[$158>>2]|0; //@line 138036 "c/sqlite3.c"
  $160 = (((((($5)) + 8|0) + (($155*72)|0)|0)) + 37|0); //@line 138042 "c/sqlite3.c"
  $161 = HEAP8[$160>>0]|0; //@line 138042 "c/sqlite3.c"
  $162 = $161 & 16; //@line 138042 "c/sqlite3.c"
  $163 = ($162<<24>>24)==(0); //@line 138042 "c/sqlite3.c"
  do {
   if ($163) {
    $170 = ((($159)) + 36|0); //@line 138060 "c/sqlite3.c"
    $171 = HEAP32[$170>>2]|0; //@line 138060 "c/sqlite3.c"
    $172 = $171 & 576; //@line 138060 "c/sqlite3.c"
    $173 = ($172|0)==(0); //@line 138060 "c/sqlite3.c"
    if ($173) {
     $175 = $171 & 8192; //@line 138062 "c/sqlite3.c"
     $176 = ($175|0)==(0); //@line 138062 "c/sqlite3.c"
     if ($176) {
      break;
     }
     $177 = ((($$0211221)) + 56|0); //@line 138063 "c/sqlite3.c"
     $$0212$in = $177;
    } else {
     $174 = ((($159)) + 32|0); //@line 138061 "c/sqlite3.c"
     $$0212$in = $174;
    }
    $$0212 = HEAP32[$$0212$in>>2]|0;
    $178 = ($$0212|0)==(0|0); //@line 138065 "c/sqlite3.c"
    if (!($178)) {
     $179 = HEAP8[$151>>0]|0; //@line 138066 "c/sqlite3.c"
     $180 = ($179<<24>>24)==(0); //@line 138066 "c/sqlite3.c"
     if (!($180)) {
      $181 = ((($$0212)) + 12|0); //@line 138066 "c/sqlite3.c"
      $182 = HEAP32[$181>>2]|0; //@line 138066 "c/sqlite3.c"
      $183 = ((($182)) + 36|0); //@line 138066 "c/sqlite3.c"
      $184 = HEAP32[$183>>2]|0; //@line 138066 "c/sqlite3.c"
      $185 = $184 & 32; //@line 138066 "c/sqlite3.c"
      $186 = ($185|0)==(0); //@line 138066 "c/sqlite3.c"
      if ($186) {
       break;
      }
     }
     $187 = HEAP8[$152>>0]|0; //@line 138067 "c/sqlite3.c"
     $188 = ($187<<24>>24)==(0); //@line 138067 "c/sqlite3.c"
     if ($188) {
      $189 = (_sqlite3VdbeCurrentAddr($3)|0); //@line 138069 "c/sqlite3.c"
      $190 = ((($$0211221)) + 32|0); //@line 138070 "c/sqlite3.c"
      $191 = HEAP32[$190>>2]|0; //@line 138070 "c/sqlite3.c"
      $192 = ($191|0)<($189|0); //@line 138072 "c/sqlite3.c"
      if ($192) {
       $193 = (_sqlite3VdbeGetOp($3,$191)|0); //@line 138071 "c/sqlite3.c"
       $194 = ((($$0211221)) + 4|0);
       $195 = ((($157)) + 36|0);
       $196 = ((($$0211221)) + 8|0);
       $197 = ((($$0211221)) + 8|0);
       $198 = ((($$0211221)) + 8|0);
       $$0213220 = $193;$$0215219 = $191;
       while(1) {
        $199 = ((($$0213220)) + 4|0); //@line 138073 "c/sqlite3.c"
        $200 = HEAP32[$199>>2]|0; //@line 138073 "c/sqlite3.c"
        $201 = HEAP32[$194>>2]|0; //@line 138073 "c/sqlite3.c"
        $202 = ($200|0)==($201|0); //@line 138073 "c/sqlite3.c"
        L74: do {
         if ($202) {
          $203 = HEAP8[$$0213220>>0]|0; //@line 138074 "c/sqlite3.c"
          switch ($203<<24>>24) {
          case 98:  {
           $204 = ((($$0213220)) + 8|0); //@line 138079 "c/sqlite3.c"
           $205 = HEAP32[$204>>2]|0; //@line 138079 "c/sqlite3.c"
           $206 = HEAP32[$195>>2]|0; //@line 138081 "c/sqlite3.c"
           $207 = $206 & 32; //@line 138081 "c/sqlite3.c"
           $208 = ($207|0)==(0); //@line 138081 "c/sqlite3.c"
           if ($208) {
            $$0209 = $205;
           } else {
            $209 = (_sqlite3PrimaryKeyIndex($157)|0); //@line 138082 "c/sqlite3.c"
            $210 = ((($209)) + 4|0); //@line 138083 "c/sqlite3.c"
            $211 = HEAP32[$210>>2]|0; //@line 138083 "c/sqlite3.c"
            $212 = (($211) + ($205<<1)|0); //@line 138083 "c/sqlite3.c"
            $213 = HEAP16[$212>>1]|0; //@line 138083 "c/sqlite3.c"
            $214 = $213 << 16 >> 16; //@line 138083 "c/sqlite3.c"
            $$0209 = $214;
           }
           $215 = $$0209&65535; //@line 138086 "c/sqlite3.c"
           $216 = (_sqlite3ColumnOfIndex($$0212,$215)|0); //@line 138086 "c/sqlite3.c"
           $217 = ($216<<16>>16)>(-1); //@line 138087 "c/sqlite3.c"
           if (!($217)) {
            break L74;
           }
           $218 = $216 << 16 >> 16; //@line 138086 "c/sqlite3.c"
           HEAP32[$204>>2] = $218; //@line 138088 "c/sqlite3.c"
           $219 = HEAP32[$198>>2]|0; //@line 138089 "c/sqlite3.c"
           HEAP32[$199>>2] = $219; //@line 138089 "c/sqlite3.c"
           break L74;
           break;
          }
          case 124:  {
           $220 = HEAP32[$196>>2]|0; //@line 138094 "c/sqlite3.c"
           HEAP32[$199>>2] = $220; //@line 138094 "c/sqlite3.c"
           HEAP8[$$0213220>>0] = -125; //@line 138095 "c/sqlite3.c"
           break L74;
           break;
          }
          case 23:  {
           $221 = HEAP32[$197>>2]|0; //@line 138097 "c/sqlite3.c"
           HEAP32[$199>>2] = $221; //@line 138097 "c/sqlite3.c"
           break L74;
           break;
          }
          default: {
           break L74;
          }
          }
         }
        } while(0);
        $222 = (($$0215219) + 1)|0; //@line 138072 "c/sqlite3.c"
        $223 = ((($$0213220)) + 20|0); //@line 138072 "c/sqlite3.c"
        $exitcond = ($222|0)==($189|0); //@line 138072 "c/sqlite3.c"
        if ($exitcond) {
         break;
        } else {
         $$0213220 = $223;$$0215219 = $222;
        }
       }
      }
     }
    }
   } else {
    $164 = ((($$0211221)) + 32|0); //@line 138044 "c/sqlite3.c"
    $165 = HEAP32[$164>>2]|0; //@line 138044 "c/sqlite3.c"
    $166 = ((($$0211221)) + 4|0); //@line 138044 "c/sqlite3.c"
    $167 = HEAP32[$166>>2]|0; //@line 138044 "c/sqlite3.c"
    $168 = (((((($5)) + 8|0) + (($155*72)|0)|0)) + 32|0); //@line 138045 "c/sqlite3.c"
    $169 = HEAP32[$168>>2]|0; //@line 138045 "c/sqlite3.c"
    _translateColumnToCopy($1,$165,$167,$169,0); //@line 138044 "c/sqlite3.c"
   }
  } while(0);
  $224 = (($$1223) + 1)|0; //@line 138029 "c/sqlite3.c"
  $225 = ((($$0211221)) + 80|0); //@line 138029 "c/sqlite3.c"
  $226 = HEAP8[$7>>0]|0; //@line 138029 "c/sqlite3.c"
  $227 = $226&255; //@line 138029 "c/sqlite3.c"
  $228 = ($224>>>0)<($227>>>0); //@line 138029 "c/sqlite3.c"
  if ($228) {
   $$0211221 = $225;$$1223 = $224;
  } else {
   break;
  }
 }
 $229 = ((($0)) + 40|0); //@line 138105 "c/sqlite3.c"
 $230 = HEAP32[$229>>2]|0; //@line 138105 "c/sqlite3.c"
 $231 = ((($1)) + 132|0); //@line 138105 "c/sqlite3.c"
 HEAP32[$231>>2] = $230; //@line 138105 "c/sqlite3.c"
 _whereInfoFree($6,$0); //@line 138106 "c/sqlite3.c"
 return; //@line 138108 "c/sqlite3.c"
}
function _translateColumnToCopy($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$03031 = 0, $$032 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 8|0); //@line 133449 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 133449 "c/sqlite3.c"
 $7 = (_sqlite3VdbeCurrentAddr($6)|0); //@line 133451 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 133452 "c/sqlite3.c"
 $9 = ((($8)) + 73|0); //@line 133452 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 133452 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 133452 "c/sqlite3.c"
 $12 = ($7|0)>($1|0); //@line 133453 "c/sqlite3.c"
 $or$cond = $11 & $12; //@line 133452 "c/sqlite3.c"
 if (!($or$cond)) {
  return; //@line 133473 "c/sqlite3.c"
 }
 $13 = (_sqlite3VdbeGetOp($6,$1)|0); //@line 133450 "c/sqlite3.c"
 $14 = ($4|0)==(0);
 $$03031 = $13;$$032 = $1;
 while(1) {
  $15 = ((($$03031)) + 4|0); //@line 133454 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 133454 "c/sqlite3.c"
  $17 = ($16|0)==($2|0); //@line 133454 "c/sqlite3.c"
  L6: do {
   if ($17) {
    $18 = HEAP8[$$03031>>0]|0; //@line 133455 "c/sqlite3.c"
    switch ($18<<24>>24) {
    case 98:  {
     HEAP8[$$03031>>0] = 75; //@line 133456 "c/sqlite3.c"
     $19 = ((($$03031)) + 8|0); //@line 133457 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 133457 "c/sqlite3.c"
     $21 = (($20) + ($3))|0; //@line 133457 "c/sqlite3.c"
     HEAP32[$15>>2] = $21; //@line 133457 "c/sqlite3.c"
     $22 = ((($$03031)) + 12|0); //@line 133458 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 133458 "c/sqlite3.c"
     HEAP32[$19>>2] = $23; //@line 133458 "c/sqlite3.c"
     HEAP32[$22>>2] = 0; //@line 133459 "c/sqlite3.c"
     break L6;
     break;
    }
    case 124:  {
     break;
    }
    default: {
     break L6;
    }
    }
    if ($14) {
     HEAP8[$$03031>>0] = 70; //@line 133467 "c/sqlite3.c"
     HEAP32[$15>>2] = 0; //@line 133468 "c/sqlite3.c"
     $26 = ((($$03031)) + 12|0); //@line 133469 "c/sqlite3.c"
     HEAP32[$26>>2] = 0; //@line 133469 "c/sqlite3.c"
     break;
    } else {
     HEAP8[$$03031>>0] = 80; //@line 133463 "c/sqlite3.c"
     $24 = ((($$03031)) + 8|0); //@line 133464 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 133464 "c/sqlite3.c"
     HEAP32[$15>>2] = $25; //@line 133464 "c/sqlite3.c"
     HEAP32[$24>>2] = 1; //@line 133465 "c/sqlite3.c"
     break;
    }
   }
  } while(0);
  $27 = (($$032) + 1)|0; //@line 133453 "c/sqlite3.c"
  $28 = ((($$03031)) + 20|0); //@line 133453 "c/sqlite3.c"
  $exitcond = ($27|0)==($7|0); //@line 133453 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$03031 = $28;$$032 = $27;
  }
 }
 return; //@line 133473 "c/sqlite3.c"
}
function _whereInfoFree($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$022 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 46|0); //@line 134795 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 134795 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 134795 "c/sqlite3.c"
 if (!($4)) {
  $$022 = 0;
  while(1) {
   $5 = (((((($1)) + 752|0) + (($$022*80)|0)|0)) + 64|0); //@line 134797 "c/sqlite3.c"
   $6 = HEAP32[$5>>2]|0; //@line 134797 "c/sqlite3.c"
   $7 = ($6|0)==(0|0); //@line 134797 "c/sqlite3.c"
   if (!($7)) {
    $8 = ((($6)) + 36|0); //@line 134797 "c/sqlite3.c"
    $9 = HEAP32[$8>>2]|0; //@line 134797 "c/sqlite3.c"
    $10 = $9 & 2048; //@line 134797 "c/sqlite3.c"
    $11 = ($10|0)==(0); //@line 134797 "c/sqlite3.c"
    if (!($11)) {
     $12 = (((((($1)) + 752|0) + (($$022*80)|0)|0)) + 60|0); //@line 134798 "c/sqlite3.c"
     $13 = HEAP32[$12>>2]|0; //@line 134798 "c/sqlite3.c"
     _sqlite3DbFree($0,$13); //@line 134798 "c/sqlite3.c"
    }
   }
   $14 = (($$022) + 1)|0; //@line 134795 "c/sqlite3.c"
   $15 = HEAP8[$2>>0]|0; //@line 134795 "c/sqlite3.c"
   $16 = $15&255; //@line 134795 "c/sqlite3.c"
   $17 = ($14>>>0)<($16>>>0); //@line 134795 "c/sqlite3.c"
   if ($17) {
    $$022 = $14;
   } else {
    break;
   }
  }
 }
 $18 = ((($1)) + 80|0); //@line 134801 "c/sqlite3.c"
 _sqlite3WhereClauseClear($18); //@line 134801 "c/sqlite3.c"
 $19 = ((($1)) + 60|0); //@line 134802 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 134802 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 134802 "c/sqlite3.c"
 if ($21) {
  _sqlite3DbFreeNN($0,$1); //@line 134807 "c/sqlite3.c"
  return; //@line 134808 "c/sqlite3.c"
 }
 $23 = $20;
 while(1) {
  $22 = ((($23)) + 52|0); //@line 134804 "c/sqlite3.c"
  $24 = HEAP32[$22>>2]|0; //@line 134804 "c/sqlite3.c"
  HEAP32[$19>>2] = $24; //@line 134804 "c/sqlite3.c"
  _whereLoopDelete($0,$23); //@line 134805 "c/sqlite3.c"
  $25 = HEAP32[$19>>2]|0; //@line 134802 "c/sqlite3.c"
  $26 = ($25|0)==(0|0); //@line 134802 "c/sqlite3.c"
  if ($26) {
   break;
  } else {
   $23 = $25;
  }
 }
 _sqlite3DbFreeNN($0,$1); //@line 134807 "c/sqlite3.c"
 return; //@line 134808 "c/sqlite3.c"
}
function _sqlite3WhereClauseClear($0) {
 $0 = $0|0;
 var $$02325 = 0, $$026 = 0, $$026$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 132795 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 132795 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 132795 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 132796 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 132796 "c/sqlite3.c"
 $6 = ((($0)) + 20|0); //@line 132796 "c/sqlite3.c"
 $7 = ($5|0)>(0); //@line 132796 "c/sqlite3.c"
 if ($7) {
  $8 = HEAP32[$6>>2]|0; //@line 132796 "c/sqlite3.c"
  $$02325 = $8;$$026$in = $5;
  while(1) {
   $$026 = (($$026$in) + -1)|0;
   $9 = ((($$02325)) + 10|0); //@line 132797 "c/sqlite3.c"
   $10 = HEAP16[$9>>1]|0; //@line 132797 "c/sqlite3.c"
   $11 = $10 & 1; //@line 132797 "c/sqlite3.c"
   $12 = ($11<<16>>16)==(0); //@line 132797 "c/sqlite3.c"
   if (!($12)) {
    $13 = HEAP32[$$02325>>2]|0; //@line 132798 "c/sqlite3.c"
    _sqlite3ExprDelete($3,$13); //@line 132798 "c/sqlite3.c"
   }
   $14 = HEAP16[$9>>1]|0; //@line 132800 "c/sqlite3.c"
   $15 = $14&65535; //@line 132800 "c/sqlite3.c"
   $16 = $15 & 16; //@line 132800 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 132800 "c/sqlite3.c"
   if ($17) {
    $20 = $15 & 32; //@line 132802 "c/sqlite3.c"
    $21 = ($20|0)==(0); //@line 132802 "c/sqlite3.c"
    if (!($21)) {
     $22 = ((($$02325)) + 28|0); //@line 132803 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 132803 "c/sqlite3.c"
     _whereAndInfoDelete($3,$23); //@line 132803 "c/sqlite3.c"
    }
   } else {
    $18 = ((($$02325)) + 28|0); //@line 132801 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 132801 "c/sqlite3.c"
    _whereOrInfoDelete($3,$19); //@line 132801 "c/sqlite3.c"
   }
   $24 = ((($$02325)) + 48|0); //@line 132796 "c/sqlite3.c"
   $25 = ($$026$in|0)>(1); //@line 132796 "c/sqlite3.c"
   if ($25) {
    $$02325 = $24;$$026$in = $$026;
   } else {
    break;
   }
  }
 }
 $26 = HEAP32[$6>>2]|0; //@line 132806 "c/sqlite3.c"
 $27 = ((($0)) + 24|0); //@line 132806 "c/sqlite3.c"
 $28 = ($26|0)==($27|0); //@line 132806 "c/sqlite3.c"
 if ($28) {
  return; //@line 132809 "c/sqlite3.c"
 }
 _sqlite3DbFree($3,$26); //@line 132807 "c/sqlite3.c"
 return; //@line 132809 "c/sqlite3.c"
}
function _whereLoopDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _whereLoopClear($0,$1); //@line 134785 "c/sqlite3.c"
 _sqlite3DbFreeNN($0,$1); //@line 134786 "c/sqlite3.c"
 return; //@line 134787 "c/sqlite3.c"
}
function _whereLoopClear($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 48|0); //@line 134741 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 134741 "c/sqlite3.c"
 $4 = ((($1)) + 56|0); //@line 134741 "c/sqlite3.c"
 $5 = ($3|0)==($4|0); //@line 134741 "c/sqlite3.c"
 if (!($5)) {
  _sqlite3DbFreeNN($0,$3); //@line 134741 "c/sqlite3.c"
 }
 _whereLoopClearUnion($0,$1); //@line 134742 "c/sqlite3.c"
 _whereLoopInit($1); //@line 134743 "c/sqlite3.c"
 return; //@line 134744 "c/sqlite3.c"
}
function _whereLoopClearUnion($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 36|0); //@line 134724 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 134724 "c/sqlite3.c"
 $4 = $3 & 17408; //@line 134724 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 134724 "c/sqlite3.c"
 if ($5) {
  return; //@line 134735 "c/sqlite3.c"
 }
 $6 = $3 & 1024; //@line 134725 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 134725 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($1)) + 28|0); //@line 134725 "c/sqlite3.c"
  $9 = HEAP8[$8>>0]|0; //@line 134725 "c/sqlite3.c"
  $10 = ($9<<24>>24)==(0); //@line 134725 "c/sqlite3.c"
  if (!($10)) {
   $11 = ((($1)) + 32|0); //@line 134726 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 134726 "c/sqlite3.c"
   _sqlite3_free($12); //@line 134726 "c/sqlite3.c"
   HEAP8[$8>>0] = 0; //@line 134727 "c/sqlite3.c"
   HEAP32[$11>>2] = 0; //@line 134728 "c/sqlite3.c"
   return; //@line 134735 "c/sqlite3.c"
  }
 }
 $13 = $3 & 16384; //@line 134729 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 134729 "c/sqlite3.c"
 if ($14) {
  return; //@line 134735 "c/sqlite3.c"
 }
 $15 = ((($1)) + 32|0); //@line 134729 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 134729 "c/sqlite3.c"
 $17 = ($16|0)==(0|0); //@line 134729 "c/sqlite3.c"
 if ($17) {
  return; //@line 134735 "c/sqlite3.c"
 }
 $18 = ((($16)) + 16|0); //@line 134730 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 134730 "c/sqlite3.c"
 _sqlite3DbFree($0,$19); //@line 134730 "c/sqlite3.c"
 $20 = HEAP32[$15>>2]|0; //@line 134731 "c/sqlite3.c"
 _sqlite3DbFreeNN($0,$20); //@line 134731 "c/sqlite3.c"
 HEAP32[$15>>2] = 0; //@line 134732 "c/sqlite3.c"
 return; //@line 134735 "c/sqlite3.c"
}
function _whereLoopInit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 56|0); //@line 134714 "c/sqlite3.c"
 $2 = ((($0)) + 48|0); //@line 134714 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 134714 "c/sqlite3.c"
 $3 = ((($0)) + 40|0); //@line 134715 "c/sqlite3.c"
 HEAP16[$3>>1] = 0; //@line 134715 "c/sqlite3.c"
 $4 = ((($0)) + 44|0); //@line 134716 "c/sqlite3.c"
 HEAP16[$4>>1] = 3; //@line 134716 "c/sqlite3.c"
 $5 = ((($0)) + 36|0); //@line 134717 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 134717 "c/sqlite3.c"
 return; //@line 134718 "c/sqlite3.c"
}
function _whereOrInfoDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3WhereClauseClear($1); //@line 131405 "c/sqlite3.c"
 _sqlite3DbFree($0,$1); //@line 131406 "c/sqlite3.c"
 return; //@line 131407 "c/sqlite3.c"
}
function _whereAndInfoDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3WhereClauseClear($1); //@line 131413 "c/sqlite3.c"
 _sqlite3DbFree($0,$1); //@line 131414 "c/sqlite3.c"
 return; //@line 131415 "c/sqlite3.c"
}
function _sqlite3WhereClauseInit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = $1; //@line 132780 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 132781 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 132781 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 132782 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 132782 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 132783 "c/sqlite3.c"
 HEAP32[$4>>2] = 8; //@line 132783 "c/sqlite3.c"
 $5 = ((($0)) + 24|0); //@line 132784 "c/sqlite3.c"
 $6 = ((($0)) + 20|0); //@line 132784 "c/sqlite3.c"
 HEAP32[$6>>2] = $5; //@line 132784 "c/sqlite3.c"
 return; //@line 132785 "c/sqlite3.c"
}
function _sqlite3WhereSplit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$tr1316 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ExprSkipCollate($1)|0); //@line 132762 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 132763 "c/sqlite3.c"
 HEAP8[$4>>0] = $2; //@line 132763 "c/sqlite3.c"
 $5 = ($3|0)==(0|0); //@line 132764 "c/sqlite3.c"
 if ($5) {
  return; //@line 132771 "c/sqlite3.c"
 }
 $$tr1316 = $1;$7 = $3;
 while(1) {
  $6 = HEAP8[$7>>0]|0; //@line 132765 "c/sqlite3.c"
  $8 = ($6<<24>>24)==($2<<24>>24); //@line 132765 "c/sqlite3.c"
  if (!($8)) {
   break;
  }
  $9 = ((($7)) + 12|0); //@line 132768 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 132768 "c/sqlite3.c"
  _sqlite3WhereSplit($0,$10,$2); //@line 132768 "c/sqlite3.c"
  $11 = ((($7)) + 16|0); //@line 132769 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 132769 "c/sqlite3.c"
  $13 = (_sqlite3ExprSkipCollate($12)|0); //@line 132762 "c/sqlite3.c"
  HEAP8[$4>>0] = $2; //@line 132763 "c/sqlite3.c"
  $14 = ($13|0)==(0|0); //@line 132764 "c/sqlite3.c"
  if ($14) {
   label = 6;
   break;
  } else {
   $$tr1316 = $12;$7 = $13;
  }
 }
 if ((label|0) == 6) {
  return; //@line 132771 "c/sqlite3.c"
 }
 (_whereClauseInsert($0,$$tr1316,0)|0); //@line 132766 "c/sqlite3.c"
 return; //@line 132771 "c/sqlite3.c"
}
function _createMask($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 133108 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 133108 "c/sqlite3.c"
 $4 = (($3) + 1)|0; //@line 133108 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 133108 "c/sqlite3.c"
 $5 = (((($0)) + 8|0) + ($3<<2)|0); //@line 133108 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 133108 "c/sqlite3.c"
 return; //@line 133109 "c/sqlite3.c"
}
function _sqlite3WhereTabFuncArgs($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$04046 = 0, $$047 = 0, $$143 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 132875 "c/sqlite3.c"
 $3 = ((($1)) + 37|0); //@line 132884 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 132884 "c/sqlite3.c"
 $5 = $4 & 4; //@line 132884 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 132884 "c/sqlite3.c"
 if ($6) {
  STACKTOP = sp;return; //@line 132905 "c/sqlite3.c"
 }
 $7 = ((($1)) + 16|0); //@line 132885 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 132885 "c/sqlite3.c"
 $9 = ((($1)) + 64|0); //@line 132887 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 132887 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 132888 "c/sqlite3.c"
 if ($11) {
  STACKTOP = sp;return; //@line 132905 "c/sqlite3.c"
 }
 $12 = HEAP32[$10>>2]|0; //@line 132889 "c/sqlite3.c"
 $13 = ($12|0)>(0); //@line 132889 "c/sqlite3.c"
 if (!($13)) {
  STACKTOP = sp;return; //@line 132905 "c/sqlite3.c"
 }
 $14 = ((($8)) + 42|0);
 $15 = ((($8)) + 4|0);
 $16 = ((($1)) + 44|0);
 $$04046 = 0;$$047 = 0;
 L10: while(1) {
  $17 = HEAP16[$14>>1]|0; //@line 132890 "c/sqlite3.c"
  $18 = $17 << 16 >> 16; //@line 132890 "c/sqlite3.c"
  $19 = ($$04046|0)<($18|0); //@line 132890 "c/sqlite3.c"
  if (!($19)) {
   label = 9;
   break;
  }
  $20 = HEAP32[$15>>2]|0;
  $$143 = $$04046;
  while(1) {
   $21 = (((($20) + ($$143<<4)|0)) + 15|0); //@line 132890 "c/sqlite3.c"
   $22 = HEAP8[$21>>0]|0; //@line 132890 "c/sqlite3.c"
   $23 = $22 & 2; //@line 132890 "c/sqlite3.c"
   $24 = ($23<<24>>24)==(0); //@line 132890 "c/sqlite3.c"
   if (!($24)) {
    break;
   }
   $25 = (($$143) + 1)|0; //@line 132890 "c/sqlite3.c"
   $26 = HEAP16[$14>>1]|0; //@line 132890 "c/sqlite3.c"
   $27 = $26 << 16 >> 16; //@line 132890 "c/sqlite3.c"
   $28 = ($25|0)<($27|0); //@line 132890 "c/sqlite3.c"
   if ($28) {
    $$143 = $25;
   } else {
    label = 9;
    break L10;
   }
  }
  $30 = HEAP32[$0>>2]|0; //@line 132896 "c/sqlite3.c"
  $31 = (_sqlite3ExprAlloc($30,145,0,0)|0); //@line 132896 "c/sqlite3.c"
  $32 = ($31|0)==(0|0); //@line 132897 "c/sqlite3.c"
  if ($32) {
   label = 12;
   break;
  }
  $33 = HEAP32[$16>>2]|0; //@line 132898 "c/sqlite3.c"
  $34 = ((($31)) + 28|0); //@line 132898 "c/sqlite3.c"
  HEAP32[$34>>2] = $33; //@line 132898 "c/sqlite3.c"
  $35 = (($$143) + 1)|0; //@line 132899 "c/sqlite3.c"
  $36 = $$143&65535; //@line 132899 "c/sqlite3.c"
  $37 = ((($31)) + 32|0); //@line 132899 "c/sqlite3.c"
  HEAP16[$37>>1] = $36; //@line 132899 "c/sqlite3.c"
  $38 = ((($31)) + 44|0); //@line 132900 "c/sqlite3.c"
  HEAP32[$38>>2] = $8; //@line 132900 "c/sqlite3.c"
  $39 = HEAP32[$0>>2]|0; //@line 132902 "c/sqlite3.c"
  $40 = (((($10)) + 4|0) + (($$047*20)|0)|0); //@line 132902 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 132902 "c/sqlite3.c"
  $42 = (_sqlite3ExprDup($39,$41,0)|0); //@line 132902 "c/sqlite3.c"
  $43 = (_sqlite3PExpr($0,53,$31,$42)|0); //@line 132901 "c/sqlite3.c"
  (_whereClauseInsert($2,$43,1)|0); //@line 132903 "c/sqlite3.c"
  $44 = (($$047) + 1)|0; //@line 132889 "c/sqlite3.c"
  $45 = HEAP32[$10>>2]|0; //@line 132889 "c/sqlite3.c"
  $46 = ($44|0)<($45|0); //@line 132889 "c/sqlite3.c"
  if ($46) {
   $$04046 = $35;$$047 = $44;
  } else {
   label = 12;
   break;
  }
 }
 if ((label|0) == 9) {
  $29 = HEAP32[$8>>2]|0; //@line 132893 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $29; //@line 132892 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 132892 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $$047; //@line 132892 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,27810,$vararg_buffer); //@line 132892 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 132905 "c/sqlite3.c"
 }
 else if ((label|0) == 12) {
  STACKTOP = sp;return; //@line 132905 "c/sqlite3.c"
 }
}
function _sqlite3WhereExprAnalyze($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$07 = 0, $$07$in = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 12|0); //@line 132862 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 132862 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 132862 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 132865 "c/sqlite3.c"
 }
 $$07$in = $3;
 while(1) {
  $$07 = (($$07$in) + -1)|0;
  _exprAnalyze($0,$1,$$07); //@line 132863 "c/sqlite3.c"
  $5 = ($$07$in|0)>(1); //@line 132862 "c/sqlite3.c"
  if ($5) {
   $$07$in = $$07;
  } else {
   break;
  }
 }
 return; //@line 132865 "c/sqlite3.c"
}
function _exprIsDeterministic($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $1 = sp;
 ;HEAP32[$1>>2]=0|0;HEAP32[$1+4>>2]=0|0;HEAP32[$1+8>>2]=0|0;HEAP32[$1+12>>2]=0|0;HEAP32[$1+16>>2]=0|0;HEAP32[$1+20>>2]=0|0;HEAP32[$1+24>>2]=0|0; //@line 137280 "c/sqlite3.c"
 $2 = ((($1)) + 20|0); //@line 137281 "c/sqlite3.c"
 HEAP8[$2>>0] = 1; //@line 137281 "c/sqlite3.c"
 $3 = ((($1)) + 4|0); //@line 137282 "c/sqlite3.c"
 HEAP32[$3>>2] = 160; //@line 137282 "c/sqlite3.c"
 $4 = ((($1)) + 8|0); //@line 137283 "c/sqlite3.c"
 HEAP32[$4>>2] = 159; //@line 137283 "c/sqlite3.c"
 (_sqlite3WalkExpr($1,$0)|0); //@line 137284 "c/sqlite3.c"
 $5 = HEAP8[$2>>0]|0; //@line 137285 "c/sqlite3.c"
 $6 = $5&255; //@line 137285 "c/sqlite3.c"
 STACKTOP = sp;return ($6|0); //@line 137285 "c/sqlite3.c"
}
function _isDistinctRedundant($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$043 = 0, $$04355 = 0, $$04356 = 0, $$04464 = 0, $$145$lcssa = 0, $$14547 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$1>>2]|0; //@line 133379 "c/sqlite3.c"
 $5 = ($4|0)==(1); //@line 133379 "c/sqlite3.c"
 if (!($5)) {
  $$2 = 0;
  return ($$2|0); //@line 133420 "c/sqlite3.c"
 }
 $6 = ((($1)) + 52|0); //@line 133380 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 133380 "c/sqlite3.c"
 $8 = ((($1)) + 24|0); //@line 133381 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 133381 "c/sqlite3.c"
 $10 = HEAP32[$3>>2]|0; //@line 133387 "c/sqlite3.c"
 $11 = ($10|0)>(0); //@line 133387 "c/sqlite3.c"
 L4: do {
  if ($11) {
   $$04464 = 0;
   while(1) {
    $12 = (((($3)) + 4|0) + (($$04464*20)|0)|0); //@line 133388 "c/sqlite3.c"
    $13 = HEAP32[$12>>2]|0; //@line 133388 "c/sqlite3.c"
    $14 = (_sqlite3ExprSkipCollate($13)|0); //@line 133388 "c/sqlite3.c"
    $15 = HEAP8[$14>>0]|0; //@line 133389 "c/sqlite3.c"
    $16 = ($15<<24>>24)==(-111); //@line 133389 "c/sqlite3.c"
    if ($16) {
     $17 = ((($14)) + 28|0); //@line 133389 "c/sqlite3.c"
     $18 = HEAP32[$17>>2]|0; //@line 133389 "c/sqlite3.c"
     $19 = ($18|0)==($7|0); //@line 133389 "c/sqlite3.c"
     if ($19) {
      $20 = ((($14)) + 32|0); //@line 133389 "c/sqlite3.c"
      $21 = HEAP16[$20>>1]|0; //@line 133389 "c/sqlite3.c"
      $22 = ($21<<16>>16)<(0); //@line 133389 "c/sqlite3.c"
      if ($22) {
       $$2 = 1;
       break;
      }
     }
    }
    $23 = (($$04464) + 1)|0; //@line 133387 "c/sqlite3.c"
    $24 = HEAP32[$3>>2]|0; //@line 133387 "c/sqlite3.c"
    $25 = ($23|0)<($24|0); //@line 133387 "c/sqlite3.c"
    if ($25) {
     $$04464 = $23;
    } else {
     break L4;
    }
   }
   return ($$2|0); //@line 133420 "c/sqlite3.c"
  }
 } while(0);
 $26 = ((($9)) + 8|0); //@line 133405 "c/sqlite3.c"
 $$04355 = HEAP32[$26>>2]|0;
 $27 = ($$04355|0)==(0|0); //@line 133405 "c/sqlite3.c"
 if ($27) {
  $$2 = 0;
  return ($$2|0); //@line 133420 "c/sqlite3.c"
 }
 $$04356 = $$04355;
 while(1) {
  $28 = ((($$04356)) + 54|0); //@line 133406 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 133406 "c/sqlite3.c"
  $30 = ($29<<24>>24)==(0); //@line 133406 "c/sqlite3.c"
  if (!($30)) {
   $31 = ((($$04356)) + 50|0); //@line 133407 "c/sqlite3.c"
   $32 = HEAP16[$31>>1]|0; //@line 133407 "c/sqlite3.c"
   $33 = ($32<<16>>16)==(0); //@line 133407 "c/sqlite3.c"
   L21: do {
    if ($33) {
     $$145$lcssa = 0;
    } else {
     $$14547 = 0;
     while(1) {
      $34 = (_sqlite3WhereFindTerm($2,$7,$$14547,-1,-1,2,$$04356)|0); //@line 133408 "c/sqlite3.c"
      $35 = ($34|0)==(0|0); //@line 133408 "c/sqlite3.c"
      if ($35) {
       $36 = (_findIndexCol($0,$3,$7,$$04356,$$14547)|0); //@line 133409 "c/sqlite3.c"
       $37 = ($36|0)<(0); //@line 133409 "c/sqlite3.c"
       if ($37) {
        $$145$lcssa = $$14547;
        break L21;
       }
       $38 = (_indexColumnNotNull($$04356,$$14547)|0); //@line 133410 "c/sqlite3.c"
       $39 = ($38|0)==(0); //@line 133410 "c/sqlite3.c"
       if ($39) {
        $$145$lcssa = $$14547;
        break L21;
       }
      }
      $40 = (($$14547) + 1)|0; //@line 133407 "c/sqlite3.c"
      $41 = HEAP16[$31>>1]|0; //@line 133407 "c/sqlite3.c"
      $42 = $41&65535; //@line 133407 "c/sqlite3.c"
      $43 = ($40>>>0)<($42>>>0); //@line 133407 "c/sqlite3.c"
      if ($43) {
       $$14547 = $40;
      } else {
       $$145$lcssa = $40;
       break;
      }
     }
    }
   } while(0);
   $44 = HEAP16[$31>>1]|0; //@line 133413 "c/sqlite3.c"
   $45 = $44&65535; //@line 133413 "c/sqlite3.c"
   $46 = ($$145$lcssa|0)==($45|0); //@line 133413 "c/sqlite3.c"
   if ($46) {
    $$2 = 1;
    label = 19;
    break;
   }
  }
  $47 = ((($$04356)) + 20|0); //@line 133405 "c/sqlite3.c"
  $$043 = HEAP32[$47>>2]|0;
  $48 = ($$043|0)==(0|0); //@line 133405 "c/sqlite3.c"
  if ($48) {
   $$2 = 0;
   label = 19;
   break;
  } else {
   $$04356 = $$043;
  }
 }
 if ((label|0) == 19) {
  return ($$2|0); //@line 133420 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereShortCut($0) {
 $0 = $0|0;
 var $$0 = 0, $$087 = 0, $$08793 = 0, $$08794 = 0, $$088$lcssa = 0, $$08890 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $12 = 0;
 var $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 137194 "c/sqlite3.c"
 $2 = ((($1)) + 44|0); //@line 137195 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 137195 "c/sqlite3.c"
 $4 = $3 & 32; //@line 137195 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 137195 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 0;
  return ($$0|0); //@line 137260 "c/sqlite3.c"
 }
 $6 = ((($1)) + 4|0); //@line 137197 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 137197 "c/sqlite3.c"
 $8 = ((($7)) + 24|0); //@line 137198 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 137198 "c/sqlite3.c"
 $10 = ((($9)) + 56|0); //@line 137199 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 137199 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 137199 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 0;
  return ($$0|0); //@line 137260 "c/sqlite3.c"
 }
 $13 = ((($7)) + 45|0); //@line 137200 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 137200 "c/sqlite3.c"
 $15 = $14 & 2; //@line 137200 "c/sqlite3.c"
 $16 = ($15<<24>>24)==(0); //@line 137200 "c/sqlite3.c"
 if (!($16)) {
  $$0 = 0;
  return ($$0|0); //@line 137260 "c/sqlite3.c"
 }
 $17 = ((($7)) + 52|0); //@line 137201 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 137201 "c/sqlite3.c"
 $19 = ((($1)) + 80|0); //@line 137202 "c/sqlite3.c"
 $20 = ((($0)) + 12|0); //@line 137203 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 137203 "c/sqlite3.c"
 $22 = ((($21)) + 36|0); //@line 137204 "c/sqlite3.c"
 HEAP32[$22>>2] = 0; //@line 137204 "c/sqlite3.c"
 $23 = ((($21)) + 42|0); //@line 137205 "c/sqlite3.c"
 HEAP16[$23>>1] = 0; //@line 137205 "c/sqlite3.c"
 $24 = (_sqlite3WhereFindTerm($19,$18,-1,0,0,130,0)|0); //@line 137206 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 137207 "c/sqlite3.c"
 L10: do {
  if ($25) {
   $31 = ((($9)) + 8|0); //@line 137216 "c/sqlite3.c"
   $$08793 = HEAP32[$31>>2]|0;
   $32 = ($$08793|0)==(0|0); //@line 137216 "c/sqlite3.c"
   if (!($32)) {
    $33 = ((($21)) + 48|0);
    $$08794 = $$08793;
    while(1) {
     $34 = ((($$08794)) + 54|0); //@line 137219 "c/sqlite3.c"
     $35 = HEAP8[$34>>0]|0; //@line 137219 "c/sqlite3.c"
     $36 = ($35<<24>>24)==(0); //@line 137219 "c/sqlite3.c"
     if (!($36)) {
      $37 = ((($$08794)) + 36|0); //@line 137220 "c/sqlite3.c"
      $38 = HEAP32[$37>>2]|0; //@line 137220 "c/sqlite3.c"
      $39 = ($38|0)==(0|0); //@line 137220 "c/sqlite3.c"
      if ($39) {
       $40 = ((($$08794)) + 50|0); //@line 137221 "c/sqlite3.c"
       $41 = HEAP16[$40>>1]|0; //@line 137221 "c/sqlite3.c"
       $42 = ($41&65535)>(3); //@line 137221 "c/sqlite3.c"
       if (!($42)) {
        $43 = ((($$08794)) + 55|0); //@line 137223 "c/sqlite3.c"
        $44 = HEAPU8[$43>>0]|(HEAPU8[$43+1>>0]<<8); //@line 137223 "c/sqlite3.c"
        $45 = ($44 << 4)&65535; //@line 137223 "c/sqlite3.c"
        $46 = $45 & 128; //@line 137223 "c/sqlite3.c"
        $47 = $46 | 2; //@line 137223 "c/sqlite3.c"
        $48 = $47&65535; //@line 137223 "c/sqlite3.c"
        $49 = HEAP16[$40>>1]|0; //@line 137224 "c/sqlite3.c"
        $50 = ($49<<16>>16)==(0); //@line 137224 "c/sqlite3.c"
        L19: do {
         if ($50) {
          $$088$lcssa = 0;
         } else {
          $$08890 = 0;
          while(1) {
           $51 = (_sqlite3WhereFindTerm($19,$18,$$08890,0,0,$48,$$08794)|0); //@line 137225 "c/sqlite3.c"
           $52 = ($51|0)==(0|0); //@line 137226 "c/sqlite3.c"
           if ($52) {
            $$088$lcssa = $$08890;
            break L19;
           }
           $53 = HEAP32[$33>>2]|0; //@line 137228 "c/sqlite3.c"
           $54 = (($53) + ($$08890<<2)|0); //@line 137228 "c/sqlite3.c"
           HEAP32[$54>>2] = $51; //@line 137228 "c/sqlite3.c"
           $55 = (($$08890) + 1)|0; //@line 137224 "c/sqlite3.c"
           $56 = HEAP16[$40>>1]|0; //@line 137224 "c/sqlite3.c"
           $57 = $56&65535; //@line 137224 "c/sqlite3.c"
           $58 = ($55>>>0)<($57>>>0); //@line 137224 "c/sqlite3.c"
           if ($58) {
            $$08890 = $55;
           } else {
            $$088$lcssa = $55;
            break;
           }
          }
         }
        } while(0);
        $59 = HEAP16[$40>>1]|0; //@line 137230 "c/sqlite3.c"
        $60 = $59&65535; //@line 137230 "c/sqlite3.c"
        $61 = ($$088$lcssa|0)==($60|0); //@line 137230 "c/sqlite3.c"
        if ($61) {
         break;
        }
       }
      }
     }
     $87 = ((($$08794)) + 20|0); //@line 137216 "c/sqlite3.c"
     $$087 = HEAP32[$87>>2]|0;
     $88 = ($$087|0)==(0|0); //@line 137216 "c/sqlite3.c"
     if ($88) {
      break L10;
     } else {
      $$08794 = $$087;
     }
    }
    $62 = ((($$08794)) + 55|0); //@line 137223 "c/sqlite3.c"
    HEAP32[$22>>2] = 4609; //@line 137231 "c/sqlite3.c"
    $63 = HEAPU8[$62>>0]|(HEAPU8[$62+1>>0]<<8); //@line 137232 "c/sqlite3.c"
    $64 = $63 & 32; //@line 137232 "c/sqlite3.c"
    $65 = ($64<<16>>16)==(0); //@line 137232 "c/sqlite3.c"
    if ($65) {
     $66 = ((($7)) + 64|0); //@line 137232 "c/sqlite3.c"
     $67 = $66; //@line 137232 "c/sqlite3.c"
     $68 = $67; //@line 137232 "c/sqlite3.c"
     $69 = HEAP32[$68>>2]|0; //@line 137232 "c/sqlite3.c"
     $70 = (($67) + 4)|0; //@line 137232 "c/sqlite3.c"
     $71 = $70; //@line 137232 "c/sqlite3.c"
     $72 = HEAP32[$71>>2]|0; //@line 137232 "c/sqlite3.c"
     $73 = (_columnsInIndex($$08794)|0); //@line 137232 "c/sqlite3.c"
     $74 = tempRet0; //@line 137232 "c/sqlite3.c"
     $75 = $73 ^ -1; //@line 137232 "c/sqlite3.c"
     $76 = $74 ^ -1; //@line 137232 "c/sqlite3.c"
     $77 = $69 & $75; //@line 137232 "c/sqlite3.c"
     $78 = $72 & $76; //@line 137232 "c/sqlite3.c"
     $79 = ($77|0)==(0); //@line 137232 "c/sqlite3.c"
     $80 = ($78|0)==(0); //@line 137232 "c/sqlite3.c"
     $81 = $79 & $80; //@line 137232 "c/sqlite3.c"
     if ($81) {
      label = 18;
     }
    } else {
     label = 18;
    }
    if ((label|0) == 18) {
     HEAP32[$22>>2] = 4673; //@line 137233 "c/sqlite3.c"
    }
    $82 = $$088$lcssa&65535; //@line 137235 "c/sqlite3.c"
    $83 = ((($21)) + 40|0); //@line 137235 "c/sqlite3.c"
    HEAP16[$83>>1] = $82; //@line 137235 "c/sqlite3.c"
    $84 = ((($21)) + 24|0); //@line 137236 "c/sqlite3.c"
    HEAP16[$84>>1] = $82; //@line 137236 "c/sqlite3.c"
    $85 = ((($21)) + 32|0); //@line 137237 "c/sqlite3.c"
    HEAP32[$85>>2] = $$08794; //@line 137237 "c/sqlite3.c"
    $86 = ((($21)) + 20|0); //@line 137239 "c/sqlite3.c"
    HEAP16[$86>>1] = 39; //@line 137239 "c/sqlite3.c"
   }
  } else {
   HEAP32[$22>>2] = 4353; //@line 137209 "c/sqlite3.c"
   $26 = ((($21)) + 48|0); //@line 137210 "c/sqlite3.c"
   $27 = HEAP32[$26>>2]|0; //@line 137210 "c/sqlite3.c"
   HEAP32[$27>>2] = $24; //@line 137210 "c/sqlite3.c"
   $28 = ((($21)) + 40|0); //@line 137211 "c/sqlite3.c"
   HEAP16[$28>>1] = 1; //@line 137211 "c/sqlite3.c"
   $29 = ((($21)) + 24|0); //@line 137212 "c/sqlite3.c"
   HEAP16[$29>>1] = 1; //@line 137212 "c/sqlite3.c"
   $30 = ((($21)) + 20|0); //@line 137214 "c/sqlite3.c"
   HEAP16[$30>>1] = 33; //@line 137214 "c/sqlite3.c"
  }
 } while(0);
 $89 = HEAP32[$22>>2]|0; //@line 137243 "c/sqlite3.c"
 $90 = ($89|0)==(0); //@line 137243 "c/sqlite3.c"
 if ($90) {
  $$0 = 0;
  return ($$0|0); //@line 137260 "c/sqlite3.c"
 }
 $91 = ((($21)) + 22|0); //@line 137244 "c/sqlite3.c"
 HEAP16[$91>>1] = 1; //@line 137244 "c/sqlite3.c"
 $92 = ((($1)) + 816|0); //@line 137245 "c/sqlite3.c"
 HEAP32[$92>>2] = $21; //@line 137245 "c/sqlite3.c"
 $93 = ((($21)) + 8|0); //@line 137247 "c/sqlite3.c"
 $94 = $93; //@line 137247 "c/sqlite3.c"
 $95 = $94; //@line 137247 "c/sqlite3.c"
 HEAP32[$95>>2] = 1; //@line 137247 "c/sqlite3.c"
 $96 = (($94) + 4)|0; //@line 137247 "c/sqlite3.c"
 $97 = $96; //@line 137247 "c/sqlite3.c"
 HEAP32[$97>>2] = 0; //@line 137247 "c/sqlite3.c"
 $98 = ((($1)) + 756|0); //@line 137248 "c/sqlite3.c"
 HEAP32[$98>>2] = $18; //@line 137248 "c/sqlite3.c"
 $99 = ((($1)) + 72|0); //@line 137249 "c/sqlite3.c"
 HEAP16[$99>>1] = 1; //@line 137249 "c/sqlite3.c"
 $100 = ((($1)) + 8|0); //@line 137250 "c/sqlite3.c"
 $101 = HEAP32[$100>>2]|0; //@line 137250 "c/sqlite3.c"
 $102 = ($101|0)==(0|0); //@line 137250 "c/sqlite3.c"
 if (!($102)) {
  $103 = HEAP32[$101>>2]|0; //@line 137250 "c/sqlite3.c"
  $104 = $103&255; //@line 137250 "c/sqlite3.c"
  $105 = ((($1)) + 47|0); //@line 137250 "c/sqlite3.c"
  HEAP8[$105>>0] = $104; //@line 137250 "c/sqlite3.c"
 }
 $106 = HEAP16[$2>>1]|0; //@line 137251 "c/sqlite3.c"
 $107 = $106 & 256; //@line 137251 "c/sqlite3.c"
 $108 = ($107<<16>>16)==(0); //@line 137251 "c/sqlite3.c"
 if ($108) {
  $$0 = 1;
  return ($$0|0); //@line 137260 "c/sqlite3.c"
 }
 $109 = ((($1)) + 51|0); //@line 137252 "c/sqlite3.c"
 HEAP8[$109>>0] = 1; //@line 137252 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 137260 "c/sqlite3.c"
}
function _whereLoopAddAll($0) {
 $0 = $0|0;
 var $$070 = 0, $$07081 = 0, $$07084 = 0, $$07289 = 0, $$07986 = 0, $$080$pn83 = 0, $$080$pn83$phi = 0, $$08085 = 0, $$176 = 0, $$3 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 136360 "c/sqlite3.c"
 $2 = ((($1)) + 4|0); //@line 136364 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 136364 "c/sqlite3.c"
 $4 = ((($1)) + 46|0); //@line 136366 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 136366 "c/sqlite3.c"
 $6 = $5&255; //@line 136366 "c/sqlite3.c"
 $7 = (((($3)) + 8|0) + (($6*72)|0)|0); //@line 136366 "c/sqlite3.c"
 $8 = HEAP32[$1>>2]|0; //@line 136367 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 136367 "c/sqlite3.c"
 $10 = ((($0)) + 12|0); //@line 136373 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 136373 "c/sqlite3.c"
 _whereLoopInit($11); //@line 136374 "c/sqlite3.c"
 $12 = ((($9)) + 73|0); //@line 136403 "c/sqlite3.c"
 $13 = ($5<<24>>24)==(0); //@line 136375 "c/sqlite3.c"
 if ($13) {
  $$3 = 0;
  _whereLoopClear($9,$11); //@line 136406 "c/sqlite3.c"
  return ($$3|0); //@line 136407 "c/sqlite3.c"
 }
 $14 = ((($3)) + 8|0); //@line 136375 "c/sqlite3.c"
 $15 = ((($11)) + 16|0);
 $16 = ((($1)) + 488|0);
 $17 = ((($11)) + 8|0);
 $$07289 = 0;$$07986 = 0;$$08085 = $14;$32 = 0;$33 = 0;$35 = 0;$36 = 0;
 while(1) {
  $18 = $$07986&255; //@line 136377 "c/sqlite3.c"
  HEAP8[$15>>0] = $18; //@line 136377 "c/sqlite3.c"
  $19 = ((($$08085)) + 44|0); //@line 136378 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 136378 "c/sqlite3.c"
  $21 = (_sqlite3WhereGetMask($16,$20)|0); //@line 136378 "c/sqlite3.c"
  $22 = tempRet0; //@line 136378 "c/sqlite3.c"
  $23 = $17; //@line 136378 "c/sqlite3.c"
  $24 = $23; //@line 136378 "c/sqlite3.c"
  HEAP32[$24>>2] = $21; //@line 136378 "c/sqlite3.c"
  $25 = (($23) + 4)|0; //@line 136378 "c/sqlite3.c"
  $26 = $25; //@line 136378 "c/sqlite3.c"
  HEAP32[$26>>2] = $22; //@line 136378 "c/sqlite3.c"
  $27 = ((($$08085)) + 36|0); //@line 136379 "c/sqlite3.c"
  $28 = HEAP8[$27>>0]|0; //@line 136379 "c/sqlite3.c"
  $29 = $28 | $$07289; //@line 136379 "c/sqlite3.c"
  $30 = $29 & 10; //@line 136379 "c/sqlite3.c"
  $31 = ($30<<24>>24)==(0); //@line 136379 "c/sqlite3.c"
  $34 = $31 ? $33 : $32; //@line 136379 "c/sqlite3.c"
  $37 = $31 ? $36 : $35; //@line 136379 "c/sqlite3.c"
  $38 = ((($$08085)) + 16|0); //@line 136386 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 136386 "c/sqlite3.c"
  $40 = ((($39)) + 56|0); //@line 136386 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 136386 "c/sqlite3.c"
  $42 = ($41|0)==(0); //@line 136386 "c/sqlite3.c"
  if ($42) {
   $63 = (_whereLoopAddBtree($0,$34,$37)|0); //@line 136397 "c/sqlite3.c"
   $$176 = $63;$65 = 0;$66 = 0;
  } else {
   $$07081 = ((($$08085)) + 72|0);
   $43 = ($$07081>>>0)<($7>>>0); //@line 136388 "c/sqlite3.c"
   if ($43) {
    $$07084 = $$07081;$$080$pn83 = $$08085;$45 = 0;$47 = 0;
    while(1) {
     $44 = ($45|0)==(0); //@line 136389 "c/sqlite3.c"
     $46 = ($47|0)==(0); //@line 136389 "c/sqlite3.c"
     $48 = $44 & $46; //@line 136389 "c/sqlite3.c"
     if ($48) {
      $49 = ((($$080$pn83)) + 108|0); //@line 136389 "c/sqlite3.c"
      $50 = HEAP8[$49>>0]|0; //@line 136389 "c/sqlite3.c"
      $51 = $50 & 10; //@line 136389 "c/sqlite3.c"
      $52 = ($51<<24>>24)==(0); //@line 136389 "c/sqlite3.c"
      if ($52) {
       $82 = 0;$83 = 0;
      } else {
       label = 8;
      }
     } else {
      label = 8;
     }
     if ((label|0) == 8) {
      label = 0;
      $53 = ((($$080$pn83)) + 116|0); //@line 136390 "c/sqlite3.c"
      $54 = HEAP32[$53>>2]|0; //@line 136390 "c/sqlite3.c"
      $55 = (_sqlite3WhereGetMask($16,$54)|0); //@line 136390 "c/sqlite3.c"
      $56 = tempRet0; //@line 136390 "c/sqlite3.c"
      $57 = $55 | $45; //@line 136390 "c/sqlite3.c"
      $58 = $56 | $47; //@line 136390 "c/sqlite3.c"
      $82 = $57;$83 = $58;
     }
     $$070 = ((($$07084)) + 72|0);
     $59 = ($$070>>>0)<($7>>>0); //@line 136388 "c/sqlite3.c"
     if ($59) {
      $$080$pn83$phi = $$07084;$$07084 = $$070;$45 = $82;$47 = $83;$$080$pn83 = $$080$pn83$phi;
     } else {
      $60 = $82;$61 = $83;
      break;
     }
    }
   } else {
    $60 = 0;$61 = 0;
   }
   $62 = (_whereLoopAddVirtual($0,$34,$37,$60,$61)|0); //@line 136393 "c/sqlite3.c"
   $$176 = $62;$65 = $60;$66 = $61;
  }
  $64 = ($$176|0)==(0); //@line 136399 "c/sqlite3.c"
  if (!($64)) {
   $$3 = $$176;
   label = 16;
   break;
  }
  $67 = (_whereLoopAddOr($0,$34,$37,$65,$66)|0); //@line 136400 "c/sqlite3.c"
  $68 = $17; //@line 136402 "c/sqlite3.c"
  $69 = $68; //@line 136402 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 136402 "c/sqlite3.c"
  $71 = (($68) + 4)|0; //@line 136402 "c/sqlite3.c"
  $72 = $71; //@line 136402 "c/sqlite3.c"
  $73 = HEAP32[$72>>2]|0; //@line 136402 "c/sqlite3.c"
  $74 = $70 | $32; //@line 136402 "c/sqlite3.c"
  $75 = $73 | $35; //@line 136402 "c/sqlite3.c"
  $76 = ($67|0)==(0); //@line 136403 "c/sqlite3.c"
  if (!($76)) {
   $$3 = $67;
   label = 16;
   break;
  }
  $77 = HEAP8[$12>>0]|0; //@line 136403 "c/sqlite3.c"
  $78 = ($77<<24>>24)==(0); //@line 136403 "c/sqlite3.c"
  if (!($78)) {
   $$3 = 0;
   label = 16;
   break;
  }
  $79 = (($$07986) + 1)|0; //@line 136375 "c/sqlite3.c"
  $80 = ((($$08085)) + 72|0); //@line 136375 "c/sqlite3.c"
  $81 = ($80>>>0)<($7>>>0); //@line 136375 "c/sqlite3.c"
  if ($81) {
   $$07289 = $28;$$07986 = $79;$$08085 = $80;$32 = $74;$33 = $34;$35 = $75;$36 = $37;
  } else {
   $$3 = 0;
   label = 16;
   break;
  }
 }
 if ((label|0) == 16) {
  _whereLoopClear($9,$11); //@line 136406 "c/sqlite3.c"
  return ($$3|0); //@line 136407 "c/sqlite3.c"
 }
 return (0)|0;
}
function _wherePathSolver($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$031266 = 0, $$031374 = 0, $$031518 = 0, $$031865 = 0, $$0321 = 0, $$0322 = 0, $$0323 = 0, $$0324 = 0, $$032564 = 0, $$033363 = 0, $$0340$lcssa = 0, $$034048 = 0, $$0345 = 0, $$034673 = 0, $$0347 = 0, $$034734 = 0, $$034739 = 0, $$034817 = 0, $$035172 = 0, $$035562 = 0;
 var $$035562$phi = 0, $$035562$pn = 0, $$035661 = 0, $$035661$phi = 0, $$035760 = 0, $$111 = 0, $$131452 = 0, $$1316 = 0, $$1319$lcssa = 0, $$131951 = 0, $$1326$lcssa = 0, $$132650 = 0, $$1334$lcssa = 0, $$133449 = 0, $$1341$lcssa = 0, $$134135 = 0, $$1349 = 0, $$135247 = 0, $$213 = 0, $$231727 = 0;
 var $$2320$lcssa = 0, $$232038 = 0, $$2327$lcssa = 0, $$232737 = 0, $$2335$lcssa = 0, $$233536 = 0, $$2342 = 0, $$235028 = 0, $$2353$lcssa = 0, $$2353$lcssa83 = 0, $$235312 = 0, $$326 = 0, $$332825 = 0, $$333624 = 0, $$3343 = 0, $$4 = 0, $$4329 = 0, $$4337 = 0, $$4344 = 0, $$6 = 0;
 var $$6331 = 0, $$6339 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0;
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0;
 var $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0;
 var $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0;
 var $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0;
 var $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0;
 var $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0;
 var $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0;
 var $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0;
 var $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0;
 var $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0;
 var $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0;
 var $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0;
 var $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0;
 var $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0;
 var $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0;
 var $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond76 = 0, $exitcond77 = 0, $exitcond78 = 0, $exitcond79 = 0, $or$cond = 0, $or$cond1 = 0, $or$cond2 = 0, $or$cond3 = 0, $or$cond7 = 0, $or$cond9 = 0, $sext = 0, $spec$select = 0, $spec$select4 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp + 8|0;
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 136826 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 136827 "c/sqlite3.c"
 $5 = ((($0)) + 46|0); //@line 136828 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 136828 "c/sqlite3.c"
 $7 = $6&255; //@line 136828 "c/sqlite3.c"
 $8 = ($6&255)<(2); //@line 136832 "c/sqlite3.c"
 $9 = ($6<<24>>24)==(2); //@line 136832 "c/sqlite3.c"
 $10 = $9 ? 5 : 10; //@line 136832 "c/sqlite3.c"
 $11 = $8 ? 1 : $10; //@line 136832 "c/sqlite3.c"
 $12 = ((($0)) + 8|0); //@line 136841 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 136841 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 136841 "c/sqlite3.c"
 $15 = ($1<<16>>16)==(0); //@line 136841 "c/sqlite3.c"
 $or$cond1 = $15 | $14; //@line 136841 "c/sqlite3.c"
 if ($or$cond1) {
  $$0321 = 0;
 } else {
  $16 = HEAP32[$13>>2]|0; //@line 136844 "c/sqlite3.c"
  $$0321 = $16;
 }
 $17 = $7 << 2; //@line 136848 "c/sqlite3.c"
 $18 = (($17) + 32)|0; //@line 136848 "c/sqlite3.c"
 $19 = $11 << 1; //@line 136848 "c/sqlite3.c"
 $20 = Math_imul($19, $18)|0; //@line 136848 "c/sqlite3.c"
 $21 = $$0321 << 1; //@line 136849 "c/sqlite3.c"
 $22 = (($21) + ($20))|0; //@line 136849 "c/sqlite3.c"
 $23 = ($22|0)<(0); //@line 136850 "c/sqlite3.c"
 $24 = $23 << 31 >> 31; //@line 136850 "c/sqlite3.c"
 $25 = (_sqlite3DbMallocRawNN($4,$22,$24)|0); //@line 136850 "c/sqlite3.c"
 $26 = ($25|0)==(0|0); //@line 136851 "c/sqlite3.c"
 if ($26) {
  STACKTOP = sp;return;
 }
 $27 = (($25) + ($11<<5)|0); //@line 136853 "c/sqlite3.c"
 ;HEAP32[$27>>2]=0|0;HEAP32[$27+4>>2]=0|0;HEAP32[$27+8>>2]=0|0;HEAP32[$27+12>>2]=0|0;HEAP32[$27+16>>2]=0|0;HEAP32[$27+20>>2]=0|0;HEAP32[$27+24>>2]=0|0;HEAP32[$27+28>>2]=0|0; //@line 136854 "c/sqlite3.c"
 $28 = (($27) + ($11<<5)|0); //@line 136855 "c/sqlite3.c"
 $29 = $11 << 1; //@line 136856 "c/sqlite3.c"
 $$031374 = $29;$$034673 = $28;$$035172 = $25;
 while(1) {
  $30 = ((($$035172)) + 24|0); //@line 136857 "c/sqlite3.c"
  HEAP32[$30>>2] = $$034673; //@line 136857 "c/sqlite3.c"
  $31 = (($$031374) + -1)|0; //@line 136856 "c/sqlite3.c"
  $32 = ((($$035172)) + 32|0); //@line 136856 "c/sqlite3.c"
  $33 = (($$034673) + ($7<<2)|0); //@line 136856 "c/sqlite3.c"
  $34 = ($$031374|0)>(1); //@line 136856 "c/sqlite3.c"
  if ($34) {
   $$031374 = $31;$$034673 = $33;$$035172 = $32;
  } else {
   break;
  }
 }
 $35 = ($$0321|0)!=(0); //@line 136859 "c/sqlite3.c"
 if ($35) {
  _memset(($33|0),0,($21|0))|0; //@line 136867 "c/sqlite3.c"
  $$0345 = $33;
 } else {
  $$0345 = 0;
 }
 $36 = ((($3)) + 132|0); //@line 136877 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 136877 "c/sqlite3.c"
 $38 = ($37>>>0)<(48); //@line 136877 "c/sqlite3.c"
 $spec$select = $38 ? $37 : 48; //@line 136877 "c/sqlite3.c"
 $39 = $spec$select&65535; //@line 136877 "c/sqlite3.c"
 $40 = (((($25) + ($11<<5)|0)) + 16|0); //@line 136877 "c/sqlite3.c"
 HEAP16[$40>>1] = $39; //@line 136877 "c/sqlite3.c"
 if ($35) {
  $41 = (((($25) + ($11<<5)|0)) + 22|0); //@line 136887 "c/sqlite3.c"
  $42 = ($6<<24>>24)==(0); //@line 136887 "c/sqlite3.c"
  $43 = $$0321&255; //@line 136887 "c/sqlite3.c"
  $44 = $42 ? $43 : -1; //@line 136887 "c/sqlite3.c"
  HEAP8[$41>>0] = $44; //@line 136887 "c/sqlite3.c"
 }
 $45 = ($6<<24>>24)==(0); //@line 136893 "c/sqlite3.c"
 if ($45) {
  $$2353$lcssa83 = $27;
 } else {
  $46 = ((($0)) + 60|0);
  $47 = ((($0)) + 44|0);
  $48 = ($11>>>0)>(1);
  $$031266 = 0;$$031865 = 0;$$032564 = 0;$$033363 = 0;$$035562 = $25;$$035661 = $27;$$035760 = 1;
  while(1) {
   $49 = ($$035760|0)>(0); //@line 136895 "c/sqlite3.c"
   if ($49) {
    $50 = $$031266&65535;
    $51 = $$031266 << 2;
    $52 = ((($$035562)) + 18|0);
    $53 = ((($$035562)) + 16|0);
    $$034048 = 0;$$131452 = 0;$$131951 = $$031865;$$132650 = $$032564;$$133449 = $$033363;$$135247 = $$035661;
    while(1) {
     $$034734 = HEAP32[$46>>2]|0;
     $54 = ($$034734|0)==(0|0); //@line 136896 "c/sqlite3.c"
     if ($54) {
      $$1341$lcssa = $$034048;$$2320$lcssa = $$131951;$$2327$lcssa = $$132650;$$2335$lcssa = $$133449;
     } else {
      $55 = ((($$135247)) + 22|0);
      $56 = ((($$135247)) + 16|0);
      $57 = ((($$135247)) + 20|0);
      $58 = ((($$135247)) + 16|0);
      $59 = ((($$135247)) + 8|0);
      $60 = ((($$135247)) + 24|0);
      $$034739 = $$034734;$$134135 = $$034048;$$232038 = $$131951;$$232737 = $$132650;$$233536 = $$133449;
      while(1) {
       $61 = HEAP8[$55>>0]|0; //@line 136900 "c/sqlite3.c"
       $62 = $2; //@line 136902 "c/sqlite3.c"
       $63 = $62; //@line 136902 "c/sqlite3.c"
       HEAP32[$63>>2] = 0; //@line 136902 "c/sqlite3.c"
       $64 = (($62) + 4)|0; //@line 136902 "c/sqlite3.c"
       $65 = $64; //@line 136902 "c/sqlite3.c"
       HEAP32[$65>>2] = 0; //@line 136902 "c/sqlite3.c"
       $66 = $$034739; //@line 136904 "c/sqlite3.c"
       $67 = $66; //@line 136904 "c/sqlite3.c"
       $68 = HEAP32[$67>>2]|0; //@line 136904 "c/sqlite3.c"
       $69 = (($66) + 4)|0; //@line 136904 "c/sqlite3.c"
       $70 = $69; //@line 136904 "c/sqlite3.c"
       $71 = HEAP32[$70>>2]|0; //@line 136904 "c/sqlite3.c"
       $72 = $$135247; //@line 136904 "c/sqlite3.c"
       $73 = $72; //@line 136904 "c/sqlite3.c"
       $74 = HEAP32[$73>>2]|0; //@line 136904 "c/sqlite3.c"
       $75 = (($72) + 4)|0; //@line 136904 "c/sqlite3.c"
       $76 = $75; //@line 136904 "c/sqlite3.c"
       $77 = HEAP32[$76>>2]|0; //@line 136904 "c/sqlite3.c"
       $78 = $74 ^ -1; //@line 136904 "c/sqlite3.c"
       $79 = $77 ^ -1; //@line 136904 "c/sqlite3.c"
       $80 = $68 & $78; //@line 136904 "c/sqlite3.c"
       $81 = $71 & $79; //@line 136904 "c/sqlite3.c"
       $82 = ($80|0)==(0); //@line 136904 "c/sqlite3.c"
       $83 = ($81|0)==(0); //@line 136904 "c/sqlite3.c"
       $84 = $82 & $83; //@line 136904 "c/sqlite3.c"
       L28: do {
        if ($84) {
         $85 = ((($$034739)) + 8|0); //@line 136905 "c/sqlite3.c"
         $86 = $85; //@line 136905 "c/sqlite3.c"
         $87 = $86; //@line 136905 "c/sqlite3.c"
         $88 = HEAP32[$87>>2]|0; //@line 136905 "c/sqlite3.c"
         $89 = (($86) + 4)|0; //@line 136905 "c/sqlite3.c"
         $90 = $89; //@line 136905 "c/sqlite3.c"
         $91 = HEAP32[$90>>2]|0; //@line 136905 "c/sqlite3.c"
         $92 = $88 & $74; //@line 136905 "c/sqlite3.c"
         $93 = $91 & $77; //@line 136905 "c/sqlite3.c"
         $94 = ($92|0)==(0); //@line 136905 "c/sqlite3.c"
         $95 = ($93|0)==(0); //@line 136905 "c/sqlite3.c"
         $96 = $94 & $95; //@line 136905 "c/sqlite3.c"
         if ($96) {
          $97 = ((($$034739)) + 36|0); //@line 136906 "c/sqlite3.c"
          $98 = HEAP32[$97>>2]|0; //@line 136906 "c/sqlite3.c"
          $99 = $98 & 16384; //@line 136906 "c/sqlite3.c"
          $100 = ($99|0)==(0); //@line 136906 "c/sqlite3.c"
          if (!($100)) {
           $101 = HEAP16[$58>>1]|0; //@line 136906 "c/sqlite3.c"
           $102 = ($101<<16>>16)<(10); //@line 136906 "c/sqlite3.c"
           if ($102) {
            $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
            break;
           }
          }
          $103 = ((($$034739)) + 18|0); //@line 136914 "c/sqlite3.c"
          $104 = HEAP16[$103>>1]|0; //@line 136914 "c/sqlite3.c"
          $105 = ((($$034739)) + 20|0); //@line 136914 "c/sqlite3.c"
          $106 = HEAP16[$105>>1]|0; //@line 136914 "c/sqlite3.c"
          $107 = $106&65535; //@line 136914 "c/sqlite3.c"
          $108 = HEAP16[$56>>1]|0; //@line 136914 "c/sqlite3.c"
          $109 = $108&65535; //@line 136914 "c/sqlite3.c"
          $110 = (($109) + ($107))|0; //@line 136914 "c/sqlite3.c"
          $111 = $110&65535; //@line 136914 "c/sqlite3.c"
          $112 = (_sqlite3LogEstAdd($104,$111)|0); //@line 136914 "c/sqlite3.c"
          $113 = HEAP16[$57>>1]|0; //@line 136915 "c/sqlite3.c"
          $114 = (_sqlite3LogEstAdd($112,$113)|0); //@line 136915 "c/sqlite3.c"
          $115 = ((($$034739)) + 22|0); //@line 136916 "c/sqlite3.c"
          $116 = HEAP16[$115>>1]|0; //@line 136916 "c/sqlite3.c"
          $117 = $116&65535; //@line 136916 "c/sqlite3.c"
          $118 = (($117) + ($109))|0; //@line 136916 "c/sqlite3.c"
          $119 = $118&65535; //@line 136916 "c/sqlite3.c"
          $120 = $88 | $74; //@line 136917 "c/sqlite3.c"
          $121 = $91 | $77; //@line 136917 "c/sqlite3.c"
          $122 = ($61<<24>>24)<(0); //@line 136918 "c/sqlite3.c"
          if ($122) {
           $123 = HEAP32[$12>>2]|0; //@line 136920 "c/sqlite3.c"
           $124 = HEAP16[$47>>1]|0; //@line 136920 "c/sqlite3.c"
           $125 = (_wherePathSatisfiesOrderBy($0,$123,$$135247,$124,$50,$$034739,$2)|0); //@line 136919 "c/sqlite3.c"
           $$0322 = $125;
          } else {
           $126 = $59; //@line 136923 "c/sqlite3.c"
           $127 = $126; //@line 136923 "c/sqlite3.c"
           $128 = HEAP32[$127>>2]|0; //@line 136923 "c/sqlite3.c"
           $129 = (($126) + 4)|0; //@line 136923 "c/sqlite3.c"
           $130 = $129; //@line 136923 "c/sqlite3.c"
           $131 = HEAP32[$130>>2]|0; //@line 136923 "c/sqlite3.c"
           $132 = $2; //@line 136923 "c/sqlite3.c"
           $133 = $132; //@line 136923 "c/sqlite3.c"
           HEAP32[$133>>2] = $128; //@line 136923 "c/sqlite3.c"
           $134 = (($132) + 4)|0; //@line 136923 "c/sqlite3.c"
           $135 = $134; //@line 136923 "c/sqlite3.c"
           HEAP32[$135>>2] = $131; //@line 136923 "c/sqlite3.c"
           $$0322 = $61;
          }
          $136 = $$0322 << 24 >> 24; //@line 136925 "c/sqlite3.c"
          $137 = ($$0322<<24>>24)>(-1); //@line 136925 "c/sqlite3.c"
          $138 = ($$0321|0)>($136|0); //@line 136925 "c/sqlite3.c"
          $or$cond2 = $137 & $138; //@line 136925 "c/sqlite3.c"
          if ($or$cond2) {
           $139 = (($$0345) + ($136<<1)|0); //@line 136926 "c/sqlite3.c"
           $140 = HEAP16[$139>>1]|0; //@line 136926 "c/sqlite3.c"
           $141 = ($140<<16>>16)==(0); //@line 136926 "c/sqlite3.c"
           if ($141) {
            $142 = (_whereSortingCost($0,$1,$$0321,$136)|0); //@line 136927 "c/sqlite3.c"
            HEAP16[$139>>1] = $142; //@line 136927 "c/sqlite3.c"
           }
           $143 = HEAP16[$139>>1]|0; //@line 136931 "c/sqlite3.c"
           $144 = (_sqlite3LogEstAdd($114,$143)|0); //@line 136931 "c/sqlite3.c"
           $$0323 = $114;$$0324 = $144;
          } else {
           $145 = $114&65535; //@line 136939 "c/sqlite3.c"
           $146 = (($145) + 65534)|0; //@line 136939 "c/sqlite3.c"
           $147 = $146&65535; //@line 136939 "c/sqlite3.c"
           $$0323 = $147;$$0324 = $114;
          }
          $148 = ($$134135|0)>(0); //@line 136953 "c/sqlite3.c"
          L45: do {
           if ($148) {
            $$031518 = 0;$$034817 = $$035562;
            while(1) {
             $149 = $$034817; //@line 136954 "c/sqlite3.c"
             $150 = $149; //@line 136954 "c/sqlite3.c"
             $151 = HEAP32[$150>>2]|0; //@line 136954 "c/sqlite3.c"
             $152 = (($149) + 4)|0; //@line 136954 "c/sqlite3.c"
             $153 = $152; //@line 136954 "c/sqlite3.c"
             $154 = HEAP32[$153>>2]|0; //@line 136954 "c/sqlite3.c"
             $155 = ($151|0)==($120|0); //@line 136954 "c/sqlite3.c"
             $156 = ($154|0)==($121|0); //@line 136954 "c/sqlite3.c"
             $157 = $155 & $156; //@line 136954 "c/sqlite3.c"
             if ($157) {
              $158 = ((($$034817)) + 22|0); //@line 136955 "c/sqlite3.c"
              $159 = HEAP8[$158>>0]|0; //@line 136955 "c/sqlite3.c"
              $160 = $159 ^ $$0322; //@line 136955 "c/sqlite3.c"
              $161 = ($160<<24>>24)>(-1); //@line 136955 "c/sqlite3.c"
              if ($161) {
               break;
              }
             }
             $162 = (($$031518) + 1)|0; //@line 136953 "c/sqlite3.c"
             $163 = ((($$034817)) + 32|0); //@line 136953 "c/sqlite3.c"
             $164 = ($162|0)<($$134135|0); //@line 136953 "c/sqlite3.c"
             if ($164) {
              $$031518 = $162;$$034817 = $163;
             } else {
              label = 33;
              break L45;
             }
            }
            $171 = ((($$034817)) + 18|0); //@line 137004 "c/sqlite3.c"
            $172 = HEAP16[$171>>1]|0; //@line 137004 "c/sqlite3.c"
            $173 = ($172<<16>>16)<($$0324<<16>>16); //@line 137004 "c/sqlite3.c"
            if ($173) {
             $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
             break L28;
            }
            $174 = ($172<<16>>16)==($$0324<<16>>16); //@line 137005 "c/sqlite3.c"
            if (!($174)) {
             $$1349 = $$034817;$$3343 = $$134135;
             break;
            }
            $175 = ((($$034817)) + 16|0); //@line 137006 "c/sqlite3.c"
            $176 = HEAP16[$175>>1]|0; //@line 137006 "c/sqlite3.c"
            $177 = $176 << 16 >> 16; //@line 137006 "c/sqlite3.c"
            $sext = $118 << 16; //@line 137006 "c/sqlite3.c"
            $178 = $sext >> 16; //@line 137006 "c/sqlite3.c"
            $179 = ($178|0)>($177|0); //@line 137006 "c/sqlite3.c"
            if ($179) {
             $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
             break L28;
            }
            $180 = ($178|0)==($177|0); //@line 137007 "c/sqlite3.c"
            if (!($180)) {
             $$1349 = $$034817;$$3343 = $$134135;
             break;
            }
            $181 = ((($$034817)) + 20|0); //@line 137007 "c/sqlite3.c"
            $182 = HEAP16[$181>>1]|0; //@line 137007 "c/sqlite3.c"
            $183 = ($182<<16>>16)>($$0323<<16>>16); //@line 137007 "c/sqlite3.c"
            if ($183) {
             $$1349 = $$034817;$$3343 = $$134135;
            } else {
             $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
             break L28;
            }
           } else {
            label = 33;
           }
          } while(0);
          if ((label|0) == 33) {
           label = 0;
           $165 = ($$134135|0)<($11|0); //@line 136963 "c/sqlite3.c"
           if (!($165)) {
            $166 = ($$0324<<16>>16)>($$232737<<16>>16); //@line 136964 "c/sqlite3.c"
            if ($166) {
             $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
             break;
            }
            $167 = ($$0324<<16>>16)!=($$232737<<16>>16); //@line 136964 "c/sqlite3.c"
            $168 = ($$0323<<16>>16)<($$233536<<16>>16); //@line 136964 "c/sqlite3.c"
            $or$cond3 = $167 | $168; //@line 136964 "c/sqlite3.c"
            if (!($or$cond3)) {
             $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
             break;
            }
           }
           $169 = $165&1; //@line 136980 "c/sqlite3.c"
           $$2342 = (($$134135) + ($169))|0; //@line 136980 "c/sqlite3.c"
           $$1316 = $165 ? $$134135 : $$232038; //@line 136980 "c/sqlite3.c"
           $170 = (($$035562) + ($$1316<<5)|0); //@line 136987 "c/sqlite3.c"
           $$1349 = $170;$$3343 = $$2342;
          }
          $184 = $$135247; //@line 137042 "c/sqlite3.c"
          $185 = $184; //@line 137042 "c/sqlite3.c"
          $186 = HEAP32[$185>>2]|0; //@line 137042 "c/sqlite3.c"
          $187 = (($184) + 4)|0; //@line 137042 "c/sqlite3.c"
          $188 = $187; //@line 137042 "c/sqlite3.c"
          $189 = HEAP32[$188>>2]|0; //@line 137042 "c/sqlite3.c"
          $190 = $85; //@line 137042 "c/sqlite3.c"
          $191 = $190; //@line 137042 "c/sqlite3.c"
          $192 = HEAP32[$191>>2]|0; //@line 137042 "c/sqlite3.c"
          $193 = (($190) + 4)|0; //@line 137042 "c/sqlite3.c"
          $194 = $193; //@line 137042 "c/sqlite3.c"
          $195 = HEAP32[$194>>2]|0; //@line 137042 "c/sqlite3.c"
          $196 = $192 | $186; //@line 137042 "c/sqlite3.c"
          $197 = $195 | $189; //@line 137042 "c/sqlite3.c"
          $198 = $$1349; //@line 137042 "c/sqlite3.c"
          $199 = $198; //@line 137042 "c/sqlite3.c"
          HEAP32[$199>>2] = $196; //@line 137042 "c/sqlite3.c"
          $200 = (($198) + 4)|0; //@line 137042 "c/sqlite3.c"
          $201 = $200; //@line 137042 "c/sqlite3.c"
          HEAP32[$201>>2] = $197; //@line 137042 "c/sqlite3.c"
          $202 = $2; //@line 137043 "c/sqlite3.c"
          $203 = $202; //@line 137043 "c/sqlite3.c"
          $204 = HEAP32[$203>>2]|0; //@line 137043 "c/sqlite3.c"
          $205 = (($202) + 4)|0; //@line 137043 "c/sqlite3.c"
          $206 = $205; //@line 137043 "c/sqlite3.c"
          $207 = HEAP32[$206>>2]|0; //@line 137043 "c/sqlite3.c"
          $208 = ((($$1349)) + 8|0); //@line 137043 "c/sqlite3.c"
          $209 = $208; //@line 137043 "c/sqlite3.c"
          $210 = $209; //@line 137043 "c/sqlite3.c"
          HEAP32[$210>>2] = $204; //@line 137043 "c/sqlite3.c"
          $211 = (($209) + 4)|0; //@line 137043 "c/sqlite3.c"
          $212 = $211; //@line 137043 "c/sqlite3.c"
          HEAP32[$212>>2] = $207; //@line 137043 "c/sqlite3.c"
          $213 = ((($$1349)) + 16|0); //@line 137044 "c/sqlite3.c"
          HEAP16[$213>>1] = $119; //@line 137044 "c/sqlite3.c"
          $214 = ((($$1349)) + 18|0); //@line 137045 "c/sqlite3.c"
          HEAP16[$214>>1] = $$0324; //@line 137045 "c/sqlite3.c"
          $215 = ((($$1349)) + 20|0); //@line 137046 "c/sqlite3.c"
          HEAP16[$215>>1] = $$0323; //@line 137046 "c/sqlite3.c"
          $216 = ((($$1349)) + 22|0); //@line 137047 "c/sqlite3.c"
          HEAP8[$216>>0] = $$0322; //@line 137047 "c/sqlite3.c"
          $217 = ((($$1349)) + 24|0); //@line 137048 "c/sqlite3.c"
          $218 = HEAP32[$217>>2]|0; //@line 137048 "c/sqlite3.c"
          $219 = HEAP32[$60>>2]|0; //@line 137048 "c/sqlite3.c"
          _memcpy(($218|0),($219|0),($51|0))|0; //@line 137048 "c/sqlite3.c"
          $220 = HEAP32[$217>>2]|0; //@line 137049 "c/sqlite3.c"
          $221 = (($220) + ($$031266<<2)|0); //@line 137049 "c/sqlite3.c"
          HEAP32[$221>>2] = $$034739; //@line 137049 "c/sqlite3.c"
          $222 = ($$3343|0)<($11|0); //@line 137050 "c/sqlite3.c"
          if ($222) {
           $$4344 = $$3343;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
           break;
          }
          $223 = HEAP16[$52>>1]|0; //@line 137052 "c/sqlite3.c"
          $224 = HEAP16[$53>>1]|0; //@line 137053 "c/sqlite3.c"
          if (!($48)) {
           $$4344 = $$3343;$$6 = 0;$$6331 = $223;$$6339 = $224;
           break;
          }
          $$035562$pn = $$035562;$$231727 = 1;$$326 = 0;$$332825 = $223;$$333624 = $224;
          while(1) {
           $$235028 = ((($$035562$pn)) + 32|0);
           $225 = ((($$035562$pn)) + 50|0); //@line 137055 "c/sqlite3.c"
           $226 = HEAP16[$225>>1]|0; //@line 137055 "c/sqlite3.c"
           $227 = ($226<<16>>16)>($$332825<<16>>16); //@line 137055 "c/sqlite3.c"
           do {
            if ($227) {
             label = 48;
            } else {
             $228 = ($226<<16>>16)==($$332825<<16>>16); //@line 137056 "c/sqlite3.c"
             if (!($228)) {
              $$4 = $$326;$$4329 = $$332825;$$4337 = $$333624;
              break;
             }
             $229 = ((($$035562$pn)) + 52|0); //@line 137056 "c/sqlite3.c"
             $230 = HEAP16[$229>>1]|0; //@line 137056 "c/sqlite3.c"
             $231 = ($230<<16>>16)>($$333624<<16>>16); //@line 137056 "c/sqlite3.c"
             if ($231) {
              label = 48;
             } else {
              $$4 = $$326;$$4329 = $$332825;$$4337 = $$333624;
             }
            }
           } while(0);
           if ((label|0) == 48) {
            label = 0;
            $232 = ((($$035562$pn)) + 52|0); //@line 137059 "c/sqlite3.c"
            $233 = HEAP16[$232>>1]|0; //@line 137059 "c/sqlite3.c"
            $$4 = $$231727;$$4329 = $226;$$4337 = $233;
           }
           $234 = (($$231727) + 1)|0; //@line 137054 "c/sqlite3.c"
           $exitcond77 = ($234|0)==($11|0); //@line 137054 "c/sqlite3.c"
           if ($exitcond77) {
            $$4344 = $$3343;$$6 = $$4;$$6331 = $$4329;$$6339 = $$4337;
            break;
           } else {
            $$035562$pn = $$235028;$$231727 = $234;$$326 = $$4;$$332825 = $$4329;$$333624 = $$4337;
           }
          }
         } else {
          $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
         }
        } else {
         $$4344 = $$134135;$$6 = $$232038;$$6331 = $$232737;$$6339 = $$233536;
        }
       } while(0);
       $235 = ((($$034739)) + 52|0); //@line 136896 "c/sqlite3.c"
       $$0347 = HEAP32[$235>>2]|0;
       $236 = ($$0347|0)==(0|0); //@line 136896 "c/sqlite3.c"
       if ($236) {
        $$1341$lcssa = $$4344;$$2320$lcssa = $$6;$$2327$lcssa = $$6331;$$2335$lcssa = $$6339;
        break;
       } else {
        $$034739 = $$0347;$$134135 = $$4344;$$232038 = $$6;$$232737 = $$6331;$$233536 = $$6339;
       }
      }
     }
     $237 = (($$131452) + 1)|0; //@line 136895 "c/sqlite3.c"
     $238 = ((($$135247)) + 32|0); //@line 136895 "c/sqlite3.c"
     $exitcond78 = ($237|0)==($$035760|0); //@line 136895 "c/sqlite3.c"
     if ($exitcond78) {
      $$0340$lcssa = $$1341$lcssa;$$1319$lcssa = $$2320$lcssa;$$1326$lcssa = $$2327$lcssa;$$1334$lcssa = $$2335$lcssa;
      break;
     } else {
      $$034048 = $$1341$lcssa;$$131452 = $237;$$131951 = $$2320$lcssa;$$132650 = $$2327$lcssa;$$133449 = $$2335$lcssa;$$135247 = $238;
     }
    }
   } else {
    $$0340$lcssa = 0;$$1319$lcssa = $$031865;$$1326$lcssa = $$032564;$$1334$lcssa = $$033363;
   }
   $239 = (($$031266) + 1)|0; //@line 136893 "c/sqlite3.c"
   $exitcond79 = ($239|0)==($7|0); //@line 136893 "c/sqlite3.c"
   if ($exitcond79) {
    break;
   } else {
    $$035661$phi = $$035562;$$035562$phi = $$035661;$$031266 = $239;$$031865 = $$1319$lcssa;$$032564 = $$1326$lcssa;$$033363 = $$1334$lcssa;$$035760 = $$0340$lcssa;$$035661 = $$035661$phi;$$035562 = $$035562$phi;
   }
  }
  $240 = ($$0340$lcssa|0)==(0); //@line 137090 "c/sqlite3.c"
  if ($240) {
   _sqlite3ErrorMsg($3,27679,$vararg_buffer); //@line 137091 "c/sqlite3.c"
   _sqlite3DbFreeNN($4,$25); //@line 137092 "c/sqlite3.c"
   STACKTOP = sp;return;
  }
  $241 = ($$0340$lcssa|0)>(1); //@line 137098 "c/sqlite3.c"
  if ($241) {
   $$213 = 1;$$235312 = $$035562;
   while(1) {
    $242 = ((($$235312)) + 18|0); //@line 137099 "c/sqlite3.c"
    $243 = HEAP16[$242>>1]|0; //@line 137099 "c/sqlite3.c"
    $244 = (((($$035562) + ($$213<<5)|0)) + 18|0); //@line 137099 "c/sqlite3.c"
    $245 = HEAP16[$244>>1]|0; //@line 137099 "c/sqlite3.c"
    $246 = ($243<<16>>16)>($245<<16>>16); //@line 137099 "c/sqlite3.c"
    $247 = (($$035562) + ($$213<<5)|0); //@line 137099 "c/sqlite3.c"
    $spec$select4 = $246 ? $247 : $$235312; //@line 137099 "c/sqlite3.c"
    $248 = (($$213) + 1)|0; //@line 137098 "c/sqlite3.c"
    $exitcond76 = ($248|0)==($$0340$lcssa|0); //@line 137098 "c/sqlite3.c"
    if ($exitcond76) {
     $$2353$lcssa = $spec$select4;
     break;
    } else {
     $$213 = $248;$$235312 = $spec$select4;
    }
   }
  } else {
   $$2353$lcssa = $$035562;
  }
  $249 = ($6<<24>>24)==(0); //@line 137103 "c/sqlite3.c"
  if ($249) {
   $$2353$lcssa83 = $$2353$lcssa;
  } else {
   $250 = ((($$2353$lcssa)) + 24|0);
   $251 = ((($0)) + 4|0);
   $$111 = 0;
   while(1) {
    $252 = HEAP32[$250>>2]|0; //@line 137105 "c/sqlite3.c"
    $253 = (($252) + ($$111<<2)|0); //@line 137105 "c/sqlite3.c"
    $254 = HEAP32[$253>>2]|0; //@line 137105 "c/sqlite3.c"
    $255 = (((((($0)) + 752|0) + (($$111*80)|0)|0)) + 64|0); //@line 137105 "c/sqlite3.c"
    HEAP32[$255>>2] = $254; //@line 137105 "c/sqlite3.c"
    $256 = ((($254)) + 16|0); //@line 137106 "c/sqlite3.c"
    $257 = HEAP8[$256>>0]|0; //@line 137106 "c/sqlite3.c"
    $258 = (((((($0)) + 752|0) + (($$111*80)|0)|0)) + 44|0); //@line 137106 "c/sqlite3.c"
    HEAP8[$258>>0] = $257; //@line 137106 "c/sqlite3.c"
    $259 = HEAP32[$251>>2]|0; //@line 137107 "c/sqlite3.c"
    $260 = $257&255; //@line 137107 "c/sqlite3.c"
    $261 = (((((($259)) + 8|0) + (($260*72)|0)|0)) + 44|0); //@line 137107 "c/sqlite3.c"
    $262 = HEAP32[$261>>2]|0; //@line 137107 "c/sqlite3.c"
    $263 = (((((($0)) + 752|0) + (($$111*80)|0)|0)) + 4|0); //@line 137107 "c/sqlite3.c"
    HEAP32[$263>>2] = $262; //@line 137107 "c/sqlite3.c"
    $264 = (($$111) + 1)|0; //@line 137103 "c/sqlite3.c"
    $exitcond = ($264|0)==($7|0); //@line 137103 "c/sqlite3.c"
    if ($exitcond) {
     $$2353$lcssa83 = $$2353$lcssa;
     break;
    } else {
     $$111 = $264;
    }
   }
  }
 }
 $265 = ((($0)) + 44|0); //@line 137109 "c/sqlite3.c"
 $266 = HEAP16[$265>>1]|0; //@line 137109 "c/sqlite3.c"
 $267 = $266 & 384; //@line 137110 "c/sqlite3.c"
 $268 = ($267<<16>>16)==(256); //@line 137110 "c/sqlite3.c"
 if ($268) {
  $269 = ((($0)) + 51|0); //@line 137111 "c/sqlite3.c"
  $270 = HEAP8[$269>>0]|0; //@line 137111 "c/sqlite3.c"
  $271 = ($270<<24>>24)!=(0); //@line 137111 "c/sqlite3.c"
  $or$cond7 = $15 | $271; //@line 137112 "c/sqlite3.c"
  if (!($or$cond7)) {
   $272 = ((($0)) + 12|0); //@line 137115 "c/sqlite3.c"
   $273 = HEAP32[$272>>2]|0; //@line 137115 "c/sqlite3.c"
   $274 = (($7) + -1)|0; //@line 137116 "c/sqlite3.c"
   $275 = $274&65535; //@line 137116 "c/sqlite3.c"
   $276 = ((($$2353$lcssa83)) + 24|0); //@line 137116 "c/sqlite3.c"
   $277 = HEAP32[$276>>2]|0; //@line 137116 "c/sqlite3.c"
   $278 = (($277) + ($274<<2)|0); //@line 137116 "c/sqlite3.c"
   $279 = HEAP32[$278>>2]|0; //@line 137116 "c/sqlite3.c"
   $280 = (_wherePathSatisfiesOrderBy($0,$273,$$2353$lcssa83,128,$275,$279,$2)|0); //@line 137115 "c/sqlite3.c"
   $281 = $280 << 24 >> 24; //@line 137115 "c/sqlite3.c"
   $282 = HEAP32[$272>>2]|0; //@line 137117 "c/sqlite3.c"
   $283 = HEAP32[$282>>2]|0; //@line 137117 "c/sqlite3.c"
   $284 = ($283|0)==($281|0); //@line 137117 "c/sqlite3.c"
   if ($284) {
    HEAP8[$269>>0] = 2; //@line 137118 "c/sqlite3.c"
   }
  }
 }
 $285 = HEAP32[$12>>2]|0; //@line 137121 "c/sqlite3.c"
 $286 = ($285|0)==(0|0); //@line 137121 "c/sqlite3.c"
 if (!($286)) {
  $287 = HEAP16[$265>>1]|0; //@line 137122 "c/sqlite3.c"
  $288 = $287 & 128; //@line 137122 "c/sqlite3.c"
  $289 = ($288<<16>>16)==(0); //@line 137122 "c/sqlite3.c"
  $290 = ((($$2353$lcssa83)) + 22|0);
  $291 = HEAP8[$290>>0]|0;
  if ($289) {
   $296 = ((($0)) + 47|0); //@line 137127 "c/sqlite3.c"
   HEAP8[$296>>0] = $291; //@line 137127 "c/sqlite3.c"
   $297 = ((($$2353$lcssa83)) + 8|0); //@line 137128 "c/sqlite3.c"
   $298 = $297; //@line 137128 "c/sqlite3.c"
   $299 = $298; //@line 137128 "c/sqlite3.c"
   $300 = HEAP32[$299>>2]|0; //@line 137128 "c/sqlite3.c"
   $301 = (($298) + 4)|0; //@line 137128 "c/sqlite3.c"
   $302 = $301; //@line 137128 "c/sqlite3.c"
   $303 = HEAP32[$302>>2]|0; //@line 137128 "c/sqlite3.c"
   $304 = ((($0)) + 64|0); //@line 137128 "c/sqlite3.c"
   $305 = $304; //@line 137128 "c/sqlite3.c"
   $306 = $305; //@line 137128 "c/sqlite3.c"
   HEAP32[$306>>2] = $300; //@line 137128 "c/sqlite3.c"
   $307 = (($305) + 4)|0; //@line 137128 "c/sqlite3.c"
   $308 = $307; //@line 137128 "c/sqlite3.c"
   HEAP32[$308>>2] = $303; //@line 137128 "c/sqlite3.c"
   $309 = ($291<<24>>24)<(1); //@line 137129 "c/sqlite3.c"
   if ($309) {
    HEAP8[$296>>0] = 0; //@line 137130 "c/sqlite3.c"
    $310 = ($6<<24>>24)==(0); //@line 137131 "c/sqlite3.c"
    if (!($310)) {
     $311 = ((($$2353$lcssa83)) + 24|0); //@line 137132 "c/sqlite3.c"
     $312 = HEAP32[$311>>2]|0; //@line 137132 "c/sqlite3.c"
     $313 = (($7) + -1)|0; //@line 137132 "c/sqlite3.c"
     $314 = (($312) + ($313<<2)|0); //@line 137132 "c/sqlite3.c"
     $315 = HEAP32[$314>>2]|0; //@line 137132 "c/sqlite3.c"
     $316 = ((($315)) + 36|0); //@line 137132 "c/sqlite3.c"
     $317 = HEAP32[$316>>2]|0; //@line 137132 "c/sqlite3.c"
     $318 = $317 & 4096; //@line 137133 "c/sqlite3.c"
     $319 = ($318|0)!=(0); //@line 137133 "c/sqlite3.c"
     $320 = $317 & 260; //@line 137134 "c/sqlite3.c"
     $321 = ($320|0)==(260); //@line 137134 "c/sqlite3.c"
     $or$cond9 = $319 | $321; //@line 137134 "c/sqlite3.c"
     if (!($or$cond9)) {
      $322 = $2; //@line 137136 "c/sqlite3.c"
      $323 = $322; //@line 137136 "c/sqlite3.c"
      HEAP32[$323>>2] = 0; //@line 137136 "c/sqlite3.c"
      $324 = (($322) + 4)|0; //@line 137136 "c/sqlite3.c"
      $325 = $324; //@line 137136 "c/sqlite3.c"
      HEAP32[$325>>2] = 0; //@line 137136 "c/sqlite3.c"
      $326 = $313&65535; //@line 137138 "c/sqlite3.c"
      $327 = (_wherePathSatisfiesOrderBy($0,$285,$$2353$lcssa83,2048,$326,$315,$2)|0); //@line 137137 "c/sqlite3.c"
      $328 = $327 << 24 >> 24; //@line 137137 "c/sqlite3.c"
      $329 = HEAP32[$12>>2]|0; //@line 137141 "c/sqlite3.c"
      $330 = HEAP32[$329>>2]|0; //@line 137141 "c/sqlite3.c"
      $331 = ($330|0)==($328|0); //@line 137141 "c/sqlite3.c"
      if ($331) {
       $332 = ((($0)) + 52|0); //@line 137142 "c/sqlite3.c"
       HEAP8[$332>>0] = 1; //@line 137142 "c/sqlite3.c"
       $333 = $2; //@line 137143 "c/sqlite3.c"
       $334 = $333; //@line 137143 "c/sqlite3.c"
       $335 = HEAP32[$334>>2]|0; //@line 137143 "c/sqlite3.c"
       $336 = (($333) + 4)|0; //@line 137143 "c/sqlite3.c"
       $337 = $336; //@line 137143 "c/sqlite3.c"
       $338 = HEAP32[$337>>2]|0; //@line 137143 "c/sqlite3.c"
       $339 = $304; //@line 137143 "c/sqlite3.c"
       $340 = $339; //@line 137143 "c/sqlite3.c"
       HEAP32[$340>>2] = $335; //@line 137143 "c/sqlite3.c"
       $341 = (($339) + 4)|0; //@line 137143 "c/sqlite3.c"
       $342 = $341; //@line 137143 "c/sqlite3.c"
       HEAP32[$342>>2] = $338; //@line 137143 "c/sqlite3.c"
      }
     }
    }
   }
  } else {
   $292 = $291 << 24 >> 24; //@line 137123 "c/sqlite3.c"
   $293 = HEAP32[$285>>2]|0; //@line 137123 "c/sqlite3.c"
   $294 = ($293|0)==($292|0); //@line 137123 "c/sqlite3.c"
   if ($294) {
    $295 = ((($0)) + 51|0); //@line 137124 "c/sqlite3.c"
    HEAP8[$295>>0] = 2; //@line 137124 "c/sqlite3.c"
   }
  }
  $343 = HEAP16[$265>>1]|0; //@line 137149 "c/sqlite3.c"
  $344 = $343 & 512; //@line 137149 "c/sqlite3.c"
  $345 = ($344<<16>>16)==(0); //@line 137149 "c/sqlite3.c"
  if (!($345)) {
   $346 = ((($0)) + 47|0); //@line 137150 "c/sqlite3.c"
   $347 = HEAP8[$346>>0]|0; //@line 137150 "c/sqlite3.c"
   $348 = $347 << 24 >> 24; //@line 137150 "c/sqlite3.c"
   $349 = HEAP32[$12>>2]|0; //@line 137150 "c/sqlite3.c"
   $350 = HEAP32[$349>>2]|0; //@line 137150 "c/sqlite3.c"
   $351 = ($350|0)==($348|0); //@line 137150 "c/sqlite3.c"
   $352 = ($6<<24>>24)!=(0); //@line 137150 "c/sqlite3.c"
   $or$cond = $352 & $351; //@line 137150 "c/sqlite3.c"
   if ($or$cond) {
    $353 = $2; //@line 137152 "c/sqlite3.c"
    $354 = $353; //@line 137152 "c/sqlite3.c"
    HEAP32[$354>>2] = 0; //@line 137152 "c/sqlite3.c"
    $355 = (($353) + 4)|0; //@line 137152 "c/sqlite3.c"
    $356 = $355; //@line 137152 "c/sqlite3.c"
    HEAP32[$356>>2] = 0; //@line 137152 "c/sqlite3.c"
    $357 = (($7) + -1)|0; //@line 137154 "c/sqlite3.c"
    $358 = $357&65535; //@line 137154 "c/sqlite3.c"
    $359 = ((($$2353$lcssa83)) + 24|0); //@line 137154 "c/sqlite3.c"
    $360 = HEAP32[$359>>2]|0; //@line 137154 "c/sqlite3.c"
    $361 = (($360) + ($357<<2)|0); //@line 137154 "c/sqlite3.c"
    $362 = HEAP32[$361>>2]|0; //@line 137154 "c/sqlite3.c"
    $363 = (_wherePathSatisfiesOrderBy($0,$349,$$2353$lcssa83,0,$358,$362,$2)|0); //@line 137153 "c/sqlite3.c"
    $364 = $363 << 24 >> 24; //@line 137153 "c/sqlite3.c"
    $365 = HEAP32[$12>>2]|0; //@line 137157 "c/sqlite3.c"
    $366 = HEAP32[$365>>2]|0; //@line 137157 "c/sqlite3.c"
    $367 = ($366|0)==($364|0); //@line 137157 "c/sqlite3.c"
    if ($367) {
     $368 = ((($0)) + 48|0); //@line 137158 "c/sqlite3.c"
     HEAP8[$368>>0] = 1; //@line 137158 "c/sqlite3.c"
     $369 = $2; //@line 137159 "c/sqlite3.c"
     $370 = $369; //@line 137159 "c/sqlite3.c"
     $371 = HEAP32[$370>>2]|0; //@line 137159 "c/sqlite3.c"
     $372 = (($369) + 4)|0; //@line 137159 "c/sqlite3.c"
     $373 = $372; //@line 137159 "c/sqlite3.c"
     $374 = HEAP32[$373>>2]|0; //@line 137159 "c/sqlite3.c"
     $375 = ((($0)) + 64|0); //@line 137159 "c/sqlite3.c"
     $376 = $375; //@line 137159 "c/sqlite3.c"
     $377 = $376; //@line 137159 "c/sqlite3.c"
     HEAP32[$377>>2] = $371; //@line 137159 "c/sqlite3.c"
     $378 = (($376) + 4)|0; //@line 137159 "c/sqlite3.c"
     $379 = $378; //@line 137159 "c/sqlite3.c"
     HEAP32[$379>>2] = $374; //@line 137159 "c/sqlite3.c"
    }
   }
  }
 }
 $380 = ((($$2353$lcssa83)) + 16|0); //@line 137165 "c/sqlite3.c"
 $381 = HEAP16[$380>>1]|0; //@line 137165 "c/sqlite3.c"
 $382 = ((($0)) + 72|0); //@line 137165 "c/sqlite3.c"
 HEAP16[$382>>1] = $381; //@line 137165 "c/sqlite3.c"
 _sqlite3DbFreeNN($4,$25); //@line 137168 "c/sqlite3.c"
 STACKTOP = sp;return;
}
function _sqlite3WhereExprListUsage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01112 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 132840 "c/sqlite3.c"
 if ($2) {
  $16 = 0;$17 = 0;
 } else {
  $3 = HEAP32[$1>>2]|0; //@line 132841 "c/sqlite3.c"
  $4 = ($3|0)>(0); //@line 132841 "c/sqlite3.c"
  if ($4) {
   $$01112 = 0;$10 = 0;$12 = 0;
   while(1) {
    $5 = (((($1)) + 4|0) + (($$01112*20)|0)|0); //@line 132842 "c/sqlite3.c"
    $6 = HEAP32[$5>>2]|0; //@line 132842 "c/sqlite3.c"
    $7 = (_sqlite3WhereExprUsage($0,$6)|0); //@line 132842 "c/sqlite3.c"
    $8 = tempRet0; //@line 132842 "c/sqlite3.c"
    $9 = $7 | $10; //@line 132842 "c/sqlite3.c"
    $11 = $8 | $12; //@line 132842 "c/sqlite3.c"
    $13 = (($$01112) + 1)|0; //@line 132841 "c/sqlite3.c"
    $14 = HEAP32[$1>>2]|0; //@line 132841 "c/sqlite3.c"
    $15 = ($13|0)<($14|0); //@line 132841 "c/sqlite3.c"
    if ($15) {
     $$01112 = $13;$10 = $9;$12 = $11;
    } else {
     $16 = $11;$17 = $9;
     break;
    }
   }
  } else {
   $16 = 0;$17 = 0;
  }
 }
 tempRet0 = ($16); //@line 132845 "c/sqlite3.c"
 return ($17|0); //@line 132845 "c/sqlite3.c"
}
function _constructAutomaticIndex($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0$lcssa = 0, $$0234302 = 0, $$0236 = 0, $$0237$lcssa = 0, $$0237287 = 0, $$0246293 = 0, $$0257300 = 0, $$0261$lcssa = 0, $$0261299 = 0, $$0264 = 0, $$0265 = 0, $$0304 = 0, $$1235288 = 0, $$1247282 = 0, $$1258 = 0, $$1262 = 0, $$2239 = 0, $$2248280 = 0, $$2263 = 0, $$3240$lcssa = 0;
 var $$3240283 = 0, $$3260$ph = 0, $$4$ph = 0, $$4241 = 0, $$5$lcssa = 0, $$5242281 = 0, $$5294 = 0, $$6243 = 0, $$op = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0;
 var $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0;
 var $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0;
 var $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0;
 var $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0;
 var $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0;
 var $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0;
 var $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $spec$select266 = 0, $spec$select274 = 0, $spec$select275 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $6 = sp + 8|0;
 $7 = ((($0)) + 8|0); //@line 133592 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 133592 "c/sqlite3.c"
 $9 = (_sqlite3VdbeAddOp0($8,20)|0); //@line 133594 "c/sqlite3.c"
 $10 = ((($2)) + 16|0); //@line 133599 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 133599 "c/sqlite3.c"
 $12 = ((($1)) + 20|0); //@line 133600 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 133600 "c/sqlite3.c"
 $14 = ((($1)) + 12|0); //@line 133600 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 133600 "c/sqlite3.c"
 $16 = (($13) + (($15*48)|0)|0); //@line 133600 "c/sqlite3.c"
 $17 = ((($5)) + 64|0); //@line 133601 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 133601 "c/sqlite3.c"
 $19 = ($15|0)>(0); //@line 133603 "c/sqlite3.c"
 L1: do {
  if ($19) {
   $20 = ((($2)) + 44|0);
   $21 = ((($11)) + 4|0);
   $22 = ((($18)) + 48|0);
   $$0234302 = $13;$$0257300 = 0;$$0261299 = 0;$$0304 = 0;$62 = 0;$64 = 0;
   while(1) {
    $23 = HEAP32[$$0234302>>2]|0; //@line 133604 "c/sqlite3.c"
    $24 = $18; //@line 133608 "c/sqlite3.c"
    $25 = $24; //@line 133608 "c/sqlite3.c"
    $26 = HEAP32[$25>>2]|0; //@line 133608 "c/sqlite3.c"
    $27 = (($24) + 4)|0; //@line 133608 "c/sqlite3.c"
    $28 = $27; //@line 133608 "c/sqlite3.c"
    $29 = HEAP32[$28>>2]|0; //@line 133608 "c/sqlite3.c"
    $30 = ($26|0)==(0); //@line 133608 "c/sqlite3.c"
    $31 = ($29|0)==(0); //@line 133608 "c/sqlite3.c"
    $32 = $30 & $31; //@line 133608 "c/sqlite3.c"
    if ($32) {
     $33 = ((($$0234302)) + 10|0); //@line 133609 "c/sqlite3.c"
     $34 = HEAP16[$33>>1]|0; //@line 133609 "c/sqlite3.c"
     $35 = $34 & 2; //@line 133609 "c/sqlite3.c"
     $36 = ($35<<16>>16)==(0); //@line 133609 "c/sqlite3.c"
     if ($36) {
      $37 = ((($23)) + 4|0); //@line 133610 "c/sqlite3.c"
      $38 = HEAP32[$37>>2]|0; //@line 133610 "c/sqlite3.c"
      $39 = $38 & 1; //@line 133610 "c/sqlite3.c"
      $40 = ($39|0)==(0); //@line 133610 "c/sqlite3.c"
      if ($40) {
       $41 = HEAP32[$20>>2]|0; //@line 133611 "c/sqlite3.c"
       $42 = (_sqlite3ExprIsTableConstant($23,$41)|0); //@line 133611 "c/sqlite3.c"
       $43 = ($42|0)==(0); //@line 133611 "c/sqlite3.c"
       if ($43) {
        $$1262 = $$0261299;
       } else {
        $44 = HEAP32[$0>>2]|0; //@line 133612 "c/sqlite3.c"
        $45 = (_sqlite3ExprDup($44,$23,0)|0); //@line 133613 "c/sqlite3.c"
        $46 = (_sqlite3ExprAnd($44,$$0261299,$45)|0); //@line 133612 "c/sqlite3.c"
        $$1262 = $46;
       }
      } else {
       $$1262 = $$0261299;
      }
     } else {
      $$1262 = $$0261299;
     }
    } else {
     $$1262 = $$0261299;
    }
    $47 = (_termCanDriveIndex($$0234302,$2,$3,$4)|0); //@line 133615 "c/sqlite3.c"
    $48 = ($47|0)==(0); //@line 133615 "c/sqlite3.c"
    if ($48) {
     $$3260$ph = $$0257300;$$4$ph = $$0304;$248 = $62;$249 = $64;
    } else {
     $49 = ((($$0234302)) + 28|0); //@line 133616 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 133616 "c/sqlite3.c"
     $51 = ($50|0)>(63); //@line 133617 "c/sqlite3.c"
     $52 = (_bitshift64Shl(1,0,($50|0))|0); //@line 133617 "c/sqlite3.c"
     $53 = tempRet0; //@line 133617 "c/sqlite3.c"
     $54 = $51 ? 0 : $52; //@line 133617 "c/sqlite3.c"
     $55 = $51 ? -2147483648 : $53; //@line 133617 "c/sqlite3.c"
     $56 = ($$0257300<<24>>24)==(0); //@line 133620 "c/sqlite3.c"
     if ($56) {
      $57 = HEAP32[$11>>2]|0; //@line 133622 "c/sqlite3.c"
      $58 = HEAP32[$21>>2]|0; //@line 133623 "c/sqlite3.c"
      $59 = (($58) + ($50<<4)|0); //@line 133623 "c/sqlite3.c"
      $60 = HEAP32[$59>>2]|0; //@line 133623 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $57; //@line 133621 "c/sqlite3.c"
      $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 133621 "c/sqlite3.c"
      HEAP32[$vararg_ptr1>>2] = $60; //@line 133621 "c/sqlite3.c"
      _sqlite3_log(284,27642,$vararg_buffer); //@line 133621 "c/sqlite3.c"
      $$1258 = 1;
     } else {
      $$1258 = $$0257300;
     }
     $61 = $54 & $62; //@line 133626 "c/sqlite3.c"
     $63 = $55 & $64; //@line 133626 "c/sqlite3.c"
     $65 = ($61|0)==(0); //@line 133626 "c/sqlite3.c"
     $66 = ($63|0)==(0); //@line 133626 "c/sqlite3.c"
     $67 = $65 & $66; //@line 133626 "c/sqlite3.c"
     if ($67) {
      $68 = HEAP32[$0>>2]|0; //@line 133627 "c/sqlite3.c"
      $69 = (($$0304) + 1)|0; //@line 133627 "c/sqlite3.c"
      $70 = (_whereLoopResize($68,$18,$69)|0); //@line 133627 "c/sqlite3.c"
      $71 = ($70|0)==(0); //@line 133627 "c/sqlite3.c"
      if (!($71)) {
       $$2263 = $$1262;
       break;
      }
      $72 = $54 | $62; //@line 133631 "c/sqlite3.c"
      $73 = $55 | $64; //@line 133631 "c/sqlite3.c"
      $74 = HEAP32[$22>>2]|0; //@line 133630 "c/sqlite3.c"
      $75 = (($74) + ($$0304<<2)|0); //@line 133630 "c/sqlite3.c"
      HEAP32[$75>>2] = $$0234302; //@line 133630 "c/sqlite3.c"
      $$3260$ph = $$1258;$$4$ph = $69;$248 = $72;$249 = $73;
     } else {
      $$3260$ph = $$1258;$$4$ph = $$0304;$248 = $62;$249 = $64;
     }
    }
    $76 = ((($$0234302)) + 48|0); //@line 133603 "c/sqlite3.c"
    $77 = ($76>>>0)<($16>>>0); //@line 133603 "c/sqlite3.c"
    if ($77) {
     $$0234302 = $76;$$0257300 = $$3260$ph;$$0261299 = $$1262;$$0304 = $$4$ph;$62 = $248;$64 = $249;
    } else {
     $$0$lcssa = $$4$ph;$$0261$lcssa = $$1262;$90 = $249;$92 = $248;
     break L1;
    }
   }
   $247 = HEAP32[$0>>2]|0; //@line 133756 "c/sqlite3.c"
   _sqlite3ExprDelete($247,$$2263); //@line 133756 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 133757 "c/sqlite3.c"
  } else {
   $$0$lcssa = 0;$$0261$lcssa = 0;$90 = 0;$92 = 0;
  }
 } while(0);
 $78 = $$0$lcssa&65535; //@line 133636 "c/sqlite3.c"
 $79 = ((($18)) + 40|0); //@line 133636 "c/sqlite3.c"
 HEAP16[$79>>1] = $78; //@line 133636 "c/sqlite3.c"
 $80 = ((($18)) + 24|0); //@line 133636 "c/sqlite3.c"
 HEAP16[$80>>1] = $78; //@line 133636 "c/sqlite3.c"
 $81 = ((($18)) + 36|0); //@line 133637 "c/sqlite3.c"
 HEAP32[$81>>2] = 16961; //@line 133637 "c/sqlite3.c"
 $82 = ((($2)) + 56|0); //@line 133648 "c/sqlite3.c"
 $83 = $82; //@line 133648 "c/sqlite3.c"
 $84 = $83; //@line 133648 "c/sqlite3.c"
 $85 = HEAP32[$84>>2]|0; //@line 133648 "c/sqlite3.c"
 $86 = (($83) + 4)|0; //@line 133648 "c/sqlite3.c"
 $87 = $86; //@line 133648 "c/sqlite3.c"
 $88 = HEAP32[$87>>2]|0; //@line 133648 "c/sqlite3.c"
 $89 = $90 | -2147483648; //@line 133648 "c/sqlite3.c"
 $91 = $92 ^ -1; //@line 133648 "c/sqlite3.c"
 $93 = $89 ^ 2147483647; //@line 133648 "c/sqlite3.c"
 $94 = $85 & $91; //@line 133648 "c/sqlite3.c"
 $95 = $88 & $93; //@line 133648 "c/sqlite3.c"
 $96 = ((($11)) + 42|0); //@line 133649 "c/sqlite3.c"
 $97 = HEAP16[$96>>1]|0; //@line 133649 "c/sqlite3.c"
 $98 = $97 << 16 >> 16; //@line 133649 "c/sqlite3.c"
 $99 = ($97<<16>>16)<(63); //@line 133649 "c/sqlite3.c"
 $spec$select275 = $99 ? $97 : 63; //@line 133649 "c/sqlite3.c"
 $100 = $spec$select275 << 16 >> 16; //@line 133649 "c/sqlite3.c"
 $101 = ($97<<16>>16)>(0); //@line 133652 "c/sqlite3.c"
 if ($101) {
  $$0246293 = 0;$$5294 = $$0$lcssa;
  while(1) {
   $102 = (_bitshift64Shl(1,0,($$0246293|0))|0); //@line 133653 "c/sqlite3.c"
   $103 = tempRet0; //@line 133653 "c/sqlite3.c"
   $104 = $102 & $94; //@line 133653 "c/sqlite3.c"
   $105 = $103 & $95; //@line 133653 "c/sqlite3.c"
   $106 = ($104|0)!=(0); //@line 133653 "c/sqlite3.c"
   $107 = ($105|0)!=(0); //@line 133653 "c/sqlite3.c"
   $108 = $106 | $107; //@line 133653 "c/sqlite3.c"
   $109 = $108&1; //@line 133653 "c/sqlite3.c"
   $spec$select266 = (($$5294) + ($109))|0; //@line 133653 "c/sqlite3.c"
   $110 = (($$0246293) + 1)|0; //@line 133652 "c/sqlite3.c"
   $111 = ($110|0)<($100|0); //@line 133652 "c/sqlite3.c"
   if ($111) {
    $$0246293 = $110;$$5294 = $spec$select266;
   } else {
    $$5$lcssa = $spec$select266;
    break;
   }
  }
 } else {
  $$5$lcssa = $$0$lcssa;
 }
 $112 = ($88|0)<(0); //@line 133655 "c/sqlite3.c"
 $113 = HEAP32[$0>>2]|0; //@line 133660 "c/sqlite3.c"
 $$op = (($98) + -62)|0; //@line 133655 "c/sqlite3.c"
 $spec$select274 = $112 ? $$op : 1; //@line 133655 "c/sqlite3.c"
 $114 = (($spec$select274) + ($$5$lcssa))|0; //@line 133660 "c/sqlite3.c"
 $115 = $114&65535; //@line 133660 "c/sqlite3.c"
 $116 = (_sqlite3AllocateIndexObject($113,$115,0,$6)|0); //@line 133660 "c/sqlite3.c"
 $117 = ($116|0)==(0|0); //@line 133661 "c/sqlite3.c"
 if ($117) {
  $$2263 = $$0261$lcssa;
  $247 = HEAP32[$0>>2]|0; //@line 133756 "c/sqlite3.c"
  _sqlite3ExprDelete($247,$$2263); //@line 133756 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 133757 "c/sqlite3.c"
 }
 $118 = ((($18)) + 32|0); //@line 133662 "c/sqlite3.c"
 HEAP32[$118>>2] = $116; //@line 133662 "c/sqlite3.c"
 HEAP32[$116>>2] = 27668; //@line 133663 "c/sqlite3.c"
 $119 = ((($116)) + 12|0); //@line 133664 "c/sqlite3.c"
 HEAP32[$119>>2] = $11; //@line 133664 "c/sqlite3.c"
 $120 = HEAP32[$12>>2]|0; //@line 133667 "c/sqlite3.c"
 $121 = ($120>>>0)<($16>>>0); //@line 133667 "c/sqlite3.c"
 if ($121) {
  $122 = ((($116)) + 4|0);
  $123 = ((($116)) + 32|0);
  $$0237287 = 0;$$1235288 = $120;$134 = 0;$136 = 0;
  while(1) {
   $124 = (_termCanDriveIndex($$1235288,$2,$3,$4)|0); //@line 133668 "c/sqlite3.c"
   $125 = ($124|0)==(0); //@line 133668 "c/sqlite3.c"
   if ($125) {
    $$2239 = $$0237287;$250 = $134;$251 = $136;
   } else {
    $126 = ((($$1235288)) + 28|0); //@line 133669 "c/sqlite3.c"
    $127 = HEAP32[$126>>2]|0; //@line 133669 "c/sqlite3.c"
    $128 = ($127|0)>(63); //@line 133670 "c/sqlite3.c"
    $129 = (_bitshift64Shl(1,0,($127|0))|0); //@line 133670 "c/sqlite3.c"
    $130 = tempRet0; //@line 133670 "c/sqlite3.c"
    $131 = $128 ? 0 : $129; //@line 133670 "c/sqlite3.c"
    $132 = $128 ? -2147483648 : $130; //@line 133670 "c/sqlite3.c"
    $133 = $131 & $134; //@line 133673 "c/sqlite3.c"
    $135 = $132 & $136; //@line 133673 "c/sqlite3.c"
    $137 = ($133|0)==(0); //@line 133673 "c/sqlite3.c"
    $138 = ($135|0)==(0); //@line 133673 "c/sqlite3.c"
    $139 = $137 & $138; //@line 133673 "c/sqlite3.c"
    if ($139) {
     $140 = HEAP32[$$1235288>>2]|0; //@line 133674 "c/sqlite3.c"
     $141 = $131 | $134; //@line 133675 "c/sqlite3.c"
     $142 = $132 | $136; //@line 133675 "c/sqlite3.c"
     $143 = $127&65535; //@line 133676 "c/sqlite3.c"
     $144 = HEAP32[$122>>2]|0; //@line 133676 "c/sqlite3.c"
     $145 = (($144) + ($$0237287<<1)|0); //@line 133676 "c/sqlite3.c"
     HEAP16[$145>>1] = $143; //@line 133676 "c/sqlite3.c"
     $146 = ((($140)) + 12|0); //@line 133677 "c/sqlite3.c"
     $147 = HEAP32[$146>>2]|0; //@line 133677 "c/sqlite3.c"
     $148 = ((($140)) + 16|0); //@line 133677 "c/sqlite3.c"
     $149 = HEAP32[$148>>2]|0; //@line 133677 "c/sqlite3.c"
     $150 = (_sqlite3BinaryCompareCollSeq($0,$147,$149)|0); //@line 133677 "c/sqlite3.c"
     $151 = ($150|0)==(0|0); //@line 133678 "c/sqlite3.c"
     if ($151) {
      $155 = 18038;
     } else {
      $152 = HEAP32[$150>>2]|0; //@line 133678 "c/sqlite3.c"
      $155 = $152;
     }
     $153 = HEAP32[$123>>2]|0; //@line 133678 "c/sqlite3.c"
     $154 = (($153) + ($$0237287<<2)|0); //@line 133678 "c/sqlite3.c"
     HEAP32[$154>>2] = $155; //@line 133678 "c/sqlite3.c"
     $156 = (($$0237287) + 1)|0; //@line 133679 "c/sqlite3.c"
     $$2239 = $156;$250 = $141;$251 = $142;
    } else {
     $$2239 = $$0237287;$250 = $134;$251 = $136;
    }
   }
   $157 = ((($$1235288)) + 48|0); //@line 133667 "c/sqlite3.c"
   $158 = ($157>>>0)<($16>>>0); //@line 133667 "c/sqlite3.c"
   if ($158) {
    $$0237287 = $$2239;$$1235288 = $157;$134 = $250;$136 = $251;
   } else {
    $$0237$lcssa = $$2239;
    break;
   }
  }
 } else {
  $$0237$lcssa = 0;
 }
 $159 = ($97<<16>>16)>(0); //@line 133687 "c/sqlite3.c"
 if ($159) {
  $160 = ((($116)) + 4|0);
  $161 = ((($116)) + 32|0);
  $$1247282 = 0;$$3240283 = $$0237$lcssa;
  while(1) {
   $162 = (_bitshift64Shl(1,0,($$1247282|0))|0); //@line 133688 "c/sqlite3.c"
   $163 = tempRet0; //@line 133688 "c/sqlite3.c"
   $164 = $162 & $94; //@line 133688 "c/sqlite3.c"
   $165 = $163 & $95; //@line 133688 "c/sqlite3.c"
   $166 = ($164|0)==(0); //@line 133688 "c/sqlite3.c"
   $167 = ($165|0)==(0); //@line 133688 "c/sqlite3.c"
   $168 = $166 & $167; //@line 133688 "c/sqlite3.c"
   if ($168) {
    $$4241 = $$3240283;
   } else {
    $169 = $$1247282&65535; //@line 133689 "c/sqlite3.c"
    $170 = HEAP32[$160>>2]|0; //@line 133689 "c/sqlite3.c"
    $171 = (($170) + ($$3240283<<1)|0); //@line 133689 "c/sqlite3.c"
    HEAP16[$171>>1] = $169; //@line 133689 "c/sqlite3.c"
    $172 = HEAP32[$161>>2]|0; //@line 133690 "c/sqlite3.c"
    $173 = (($172) + ($$3240283<<2)|0); //@line 133690 "c/sqlite3.c"
    HEAP32[$173>>2] = 18038; //@line 133690 "c/sqlite3.c"
    $174 = (($$3240283) + 1)|0; //@line 133691 "c/sqlite3.c"
    $$4241 = $174;
   }
   $175 = (($$1247282) + 1)|0; //@line 133687 "c/sqlite3.c"
   $176 = ($175|0)<($100|0); //@line 133687 "c/sqlite3.c"
   if ($176) {
    $$1247282 = $175;$$3240283 = $$4241;
   } else {
    $$3240$lcssa = $$4241;
    break;
   }
  }
 } else {
  $$3240$lcssa = $$0237$lcssa;
 }
 $177 = $82; //@line 133694 "c/sqlite3.c"
 $178 = $177; //@line 133694 "c/sqlite3.c"
 $179 = HEAP32[$178>>2]|0; //@line 133694 "c/sqlite3.c"
 $180 = (($177) + 4)|0; //@line 133694 "c/sqlite3.c"
 $181 = $180; //@line 133694 "c/sqlite3.c"
 $182 = HEAP32[$181>>2]|0; //@line 133694 "c/sqlite3.c"
 $183 = ($182|0)<(0); //@line 133694 "c/sqlite3.c"
 if ($183) {
  $184 = HEAP16[$96>>1]|0; //@line 133695 "c/sqlite3.c"
  $185 = ($184<<16>>16)>(63); //@line 133695 "c/sqlite3.c"
  if ($185) {
   $186 = ((($116)) + 4|0);
   $187 = ((($116)) + 32|0);
   $$2248280 = 63;$$5242281 = $$3240$lcssa;
   while(1) {
    $188 = $$2248280&65535; //@line 133696 "c/sqlite3.c"
    $189 = HEAP32[$186>>2]|0; //@line 133696 "c/sqlite3.c"
    $190 = (($189) + ($$5242281<<1)|0); //@line 133696 "c/sqlite3.c"
    HEAP16[$190>>1] = $188; //@line 133696 "c/sqlite3.c"
    $191 = HEAP32[$187>>2]|0; //@line 133697 "c/sqlite3.c"
    $192 = (($191) + ($$5242281<<2)|0); //@line 133697 "c/sqlite3.c"
    HEAP32[$192>>2] = 18038; //@line 133697 "c/sqlite3.c"
    $193 = (($$5242281) + 1)|0; //@line 133698 "c/sqlite3.c"
    $194 = (($$2248280) + 1)|0; //@line 133695 "c/sqlite3.c"
    $195 = HEAP16[$96>>1]|0; //@line 133695 "c/sqlite3.c"
    $196 = $195 << 16 >> 16; //@line 133695 "c/sqlite3.c"
    $197 = ($194|0)<($196|0); //@line 133695 "c/sqlite3.c"
    if ($197) {
     $$2248280 = $194;$$5242281 = $193;
    } else {
     $$6243 = $193;
     break;
    }
   }
  } else {
   $$6243 = $$3240$lcssa;
  }
 } else {
  $$6243 = $$3240$lcssa;
 }
 $198 = ((($116)) + 4|0); //@line 133702 "c/sqlite3.c"
 $199 = HEAP32[$198>>2]|0; //@line 133702 "c/sqlite3.c"
 $200 = (($199) + ($$6243<<1)|0); //@line 133702 "c/sqlite3.c"
 HEAP16[$200>>1] = -1; //@line 133702 "c/sqlite3.c"
 $201 = ((($116)) + 32|0); //@line 133703 "c/sqlite3.c"
 $202 = HEAP32[$201>>2]|0; //@line 133703 "c/sqlite3.c"
 $203 = (($202) + ($$6243<<2)|0); //@line 133703 "c/sqlite3.c"
 HEAP32[$203>>2] = 18038; //@line 133703 "c/sqlite3.c"
 $204 = ((($0)) + 40|0); //@line 133707 "c/sqlite3.c"
 $205 = HEAP32[$204>>2]|0; //@line 133707 "c/sqlite3.c"
 $206 = (($205) + 1)|0; //@line 133707 "c/sqlite3.c"
 HEAP32[$204>>2] = $206; //@line 133707 "c/sqlite3.c"
 $207 = ((($5)) + 8|0); //@line 133707 "c/sqlite3.c"
 HEAP32[$207>>2] = $205; //@line 133707 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($8,108,$205,$114)|0); //@line 133708 "c/sqlite3.c"
 _sqlite3VdbeSetP4KeyInfo($0,$116); //@line 133709 "c/sqlite3.c"
 _sqlite3ExprCachePush($0); //@line 133713 "c/sqlite3.c"
 $208 = HEAP32[$1>>2]|0; //@line 133714 "c/sqlite3.c"
 $209 = ((($208)) + 4|0); //@line 133714 "c/sqlite3.c"
 $210 = HEAP32[$209>>2]|0; //@line 133714 "c/sqlite3.c"
 $211 = ((($5)) + 44|0); //@line 133714 "c/sqlite3.c"
 $212 = HEAP8[$211>>0]|0; //@line 133714 "c/sqlite3.c"
 $213 = $212&255; //@line 133714 "c/sqlite3.c"
 $214 = (((((($210)) + 8|0) + (($213*72)|0)|0)) + 37|0); //@line 133715 "c/sqlite3.c"
 $215 = HEAP8[$214>>0]|0; //@line 133715 "c/sqlite3.c"
 $216 = $215 & 16; //@line 133715 "c/sqlite3.c"
 $217 = ($216<<24>>24)==(0); //@line 133715 "c/sqlite3.c"
 if ($217) {
  $224 = ((($5)) + 4|0); //@line 133723 "c/sqlite3.c"
  $225 = HEAP32[$224>>2]|0; //@line 133723 "c/sqlite3.c"
  $226 = (_sqlite3VdbeAddOp1($8,37,$225)|0); //@line 133723 "c/sqlite3.c"
  $$0236 = $226;$$0264 = 0;
 } else {
  $218 = (((((($210)) + 8|0) + (($213*72)|0)|0)) + 28|0); //@line 133716 "c/sqlite3.c"
  $219 = HEAP32[$218>>2]|0; //@line 133716 "c/sqlite3.c"
  $220 = (_sqlite3VdbeAddOp2($8,67,0,0)|0); //@line 133717 "c/sqlite3.c"
  $221 = (((((($210)) + 8|0) + (($213*72)|0)|0)) + 24|0); //@line 133718 "c/sqlite3.c"
  $222 = HEAP32[$221>>2]|0; //@line 133718 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($8,15,$219,0,$222)|0); //@line 133718 "c/sqlite3.c"
  $223 = (_sqlite3VdbeAddOp1($8,16,$219)|0); //@line 133719 "c/sqlite3.c"
  $$0236 = $223;$$0264 = $220;
 }
 $227 = ($$0261$lcssa|0)!=(0|0); //@line 133725 "c/sqlite3.c"
 if ($227) {
  $228 = (_sqlite3VdbeMakeLabel($8)|0); //@line 133726 "c/sqlite3.c"
  _sqlite3ExprIfFalse($0,$$0261$lcssa,$228,16); //@line 133727 "c/sqlite3.c"
  $229 = HEAP32[$81>>2]|0; //@line 133728 "c/sqlite3.c"
  $230 = $229 | 131072; //@line 133728 "c/sqlite3.c"
  HEAP32[$81>>2] = $230; //@line 133728 "c/sqlite3.c"
  $$0265 = $228;
 } else {
  $$0265 = 0;
 }
 $231 = (_sqlite3GetTempReg($0)|0); //@line 133730 "c/sqlite3.c"
 $232 = ((($5)) + 4|0); //@line 133732 "c/sqlite3.c"
 $233 = HEAP32[$232>>2]|0; //@line 133732 "c/sqlite3.c"
 $234 = (_sqlite3GenerateIndexKey($0,$116,$233,$231,0,0,0,0)|0); //@line 133731 "c/sqlite3.c"
 $235 = HEAP32[$207>>2]|0; //@line 133734 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($8,128,$235,$231)|0); //@line 133734 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($8,16); //@line 133735 "c/sqlite3.c"
 if ($227) {
  _sqlite3VdbeResolveLabel($8,$$0265); //@line 133736 "c/sqlite3.c"
 }
 $236 = HEAP8[$214>>0]|0; //@line 133737 "c/sqlite3.c"
 $237 = $236 & 16; //@line 133737 "c/sqlite3.c"
 $238 = ($237<<24>>24)==(0); //@line 133737 "c/sqlite3.c"
 if ($238) {
  $245 = HEAP32[$232>>2]|0; //@line 133745 "c/sqlite3.c"
  $246 = (($$0236) + 1)|0; //@line 133745 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($8,7,$245,$246)|0); //@line 133745 "c/sqlite3.c"
 } else {
  $239 = (($234) + ($$6243))|0; //@line 133738 "c/sqlite3.c"
  _sqlite3VdbeChangeP2($8,$$0264,$239); //@line 133738 "c/sqlite3.c"
  $240 = HEAP32[$232>>2]|0; //@line 133740 "c/sqlite3.c"
  $241 = (((((($210)) + 8|0) + (($213*72)|0)|0)) + 32|0); //@line 133741 "c/sqlite3.c"
  $242 = HEAP32[$241>>2]|0; //@line 133741 "c/sqlite3.c"
  _translateColumnToCopy($0,$$0236,$240,$242,1); //@line 133740 "c/sqlite3.c"
  _sqlite3VdbeGoto($8,$$0236); //@line 133742 "c/sqlite3.c"
  $243 = HEAP8[$214>>0]|0; //@line 133743 "c/sqlite3.c"
  $244 = $243 & -17; //@line 133743 "c/sqlite3.c"
  HEAP8[$214>>0] = $244; //@line 133743 "c/sqlite3.c"
 }
 _sqlite3VdbeChangeP5($8,3); //@line 133747 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($8,$$0236); //@line 133748 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$231); //@line 133749 "c/sqlite3.c"
 _sqlite3ExprCachePop($0); //@line 133750 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($8,$9); //@line 133753 "c/sqlite3.c"
 $$2263 = $$0261$lcssa;
 $247 = HEAP32[$0>>2]|0; //@line 133756 "c/sqlite3.c"
 _sqlite3ExprDelete($247,$$2263); //@line 133756 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 133757 "c/sqlite3.c"
}
function _sqlite3WhereExplainOneScan($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$ = 0, $$0 = 0, $$073$ph = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, $spec$select7 = 0, $spec$select8 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer10 = 0, $vararg_buffer13 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, $vararg_ptr16 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 176|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(176|0);
 $vararg_buffer13 = sp + 40|0;
 $vararg_buffer10 = sp + 32|0;
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $6 = sp + 48|0;
 $7 = sp + 72|0;
 $8 = ((($0)) + 120|0); //@line 129299 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 129299 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 129299 "c/sqlite3.c"
 $spec$select = $10 ? $0 : $9; //@line 129299 "c/sqlite3.c"
 $11 = ((($spec$select)) + 399|0); //@line 129299 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 129299 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(2); //@line 129299 "c/sqlite3.c"
 if (!($13)) {
  STACKTOP = sp;return;
 }
 $14 = ((($2)) + 44|0); //@line 129302 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 129302 "c/sqlite3.c"
 $16 = $15&255; //@line 129302 "c/sqlite3.c"
 $17 = ((($0)) + 8|0); //@line 129303 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 129303 "c/sqlite3.c"
 $19 = HEAP32[$0>>2]|0; //@line 129304 "c/sqlite3.c"
 $20 = ((($0)) + 412|0); //@line 129305 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 129305 "c/sqlite3.c"
 $22 = ((($2)) + 64|0); //@line 129313 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 129313 "c/sqlite3.c"
 $24 = ((($23)) + 36|0); //@line 129314 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 129314 "c/sqlite3.c"
 $26 = $25 & 8192; //@line 129315 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 129315 "c/sqlite3.c"
 if ($27) {
  $28 = $5&65535; //@line 129315 "c/sqlite3.c"
  $29 = $28 & 32; //@line 129315 "c/sqlite3.c"
  $30 = ($29|0)==(0); //@line 129315 "c/sqlite3.c"
  if ($30) {
   $31 = $25 & 48; //@line 129317 "c/sqlite3.c"
   $32 = ($31|0)==(0); //@line 129317 "c/sqlite3.c"
   do {
    if ($32) {
     $33 = $25 & 1024; //@line 129318 "c/sqlite3.c"
     $34 = ($33|0)==(0); //@line 129318 "c/sqlite3.c"
     if ($34) {
      $35 = ((($23)) + 24|0); //@line 129318 "c/sqlite3.c"
      $36 = HEAP16[$35>>1]|0; //@line 129318 "c/sqlite3.c"
      $37 = ($36<<16>>16)==(0); //@line 129318 "c/sqlite3.c"
      if (!($37)) {
       label = 7;
       break;
      }
     }
     $38 = $28 & 3; //@line 129319 "c/sqlite3.c"
     $39 = ($38|0)==(0); //@line 129319 "c/sqlite3.c"
     _sqlite3StrAccumInit($6,$19,$7,100,1000000000); //@line 129321 "c/sqlite3.c"
     if ($39) {
      $40 = 27386;$89 = 0;
     } else {
      label = 9;
     }
    } else {
     label = 7;
    }
   } while(0);
   if ((label|0) == 7) {
    _sqlite3StrAccumInit($6,$19,$7,100,1000000000); //@line 129321 "c/sqlite3.c"
    label = 9;
   }
   if ((label|0) == 9) {
    $40 = 27379;$89 = 1;
   }
   _sqlite3StrAccumAppendAll($6,$40); //@line 129322 "c/sqlite3.c"
   $41 = (((((($1)) + 8|0) + (($16*72)|0)|0)) + 20|0); //@line 129323 "c/sqlite3.c"
   $42 = HEAP32[$41>>2]|0; //@line 129323 "c/sqlite3.c"
   $43 = ($42|0)==(0|0); //@line 129323 "c/sqlite3.c"
   if ($43) {
    $47 = (((((($1)) + 8|0) + (($16*72)|0)|0)) + 8|0); //@line 129326 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 129326 "c/sqlite3.c"
    HEAP32[$vararg_buffer1>>2] = $48; //@line 129326 "c/sqlite3.c"
    _sqlite3XPrintf($6,27404,$vararg_buffer1); //@line 129326 "c/sqlite3.c"
   } else {
    $44 = (((((($1)) + 8|0) + (($16*72)|0)|0)) + 40|0); //@line 129324 "c/sqlite3.c"
    $45 = HEAP8[$44>>0]|0; //@line 129324 "c/sqlite3.c"
    $46 = $45&255; //@line 129324 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $46; //@line 129324 "c/sqlite3.c"
    _sqlite3XPrintf($6,27391,$vararg_buffer); //@line 129324 "c/sqlite3.c"
   }
   $49 = (((((($1)) + 8|0) + (($16*72)|0)|0)) + 12|0); //@line 129329 "c/sqlite3.c"
   $50 = HEAP32[$49>>2]|0; //@line 129329 "c/sqlite3.c"
   $51 = ($50|0)==(0|0); //@line 129329 "c/sqlite3.c"
   if (!($51)) {
    HEAP32[$vararg_buffer4>>2] = $50; //@line 129330 "c/sqlite3.c"
    _sqlite3XPrintf($6,27414,$vararg_buffer4); //@line 129330 "c/sqlite3.c"
   }
   $52 = $25 & 1280; //@line 129332 "c/sqlite3.c"
   $53 = ($52|0)==(0); //@line 129332 "c/sqlite3.c"
   do {
    if ($53) {
     $54 = ((($23)) + 32|0); //@line 129337 "c/sqlite3.c"
     $55 = HEAP32[$54>>2]|0; //@line 129337 "c/sqlite3.c"
     $56 = (((((($1)) + 8|0) + (($16*72)|0)|0)) + 16|0); //@line 129339 "c/sqlite3.c"
     $57 = HEAP32[$56>>2]|0; //@line 129339 "c/sqlite3.c"
     $58 = ((($57)) + 36|0); //@line 129339 "c/sqlite3.c"
     $59 = HEAP32[$58>>2]|0; //@line 129339 "c/sqlite3.c"
     $60 = $59 & 32; //@line 129339 "c/sqlite3.c"
     $61 = ($60|0)==(0); //@line 129339 "c/sqlite3.c"
     if ($61) {
      label = 19;
     } else {
      $62 = ((($55)) + 55|0); //@line 129339 "c/sqlite3.c"
      $63 = HEAPU8[$62>>0]|(HEAPU8[$62+1>>0]<<8); //@line 129339 "c/sqlite3.c"
      $64 = $63 & 3; //@line 129339 "c/sqlite3.c"
      $65 = ($64<<16>>16)==(2); //@line 129339 "c/sqlite3.c"
      if ($65) {
       if ($89) {
        $$073$ph = 27506;
       } else {
        break;
       }
      } else {
       label = 19;
      }
     }
     if ((label|0) == 19) {
      $66 = $25 & 131072; //@line 129343 "c/sqlite3.c"
      $67 = ($66|0)==(0); //@line 129343 "c/sqlite3.c"
      if ($67) {
       $68 = $25 & 16384; //@line 129345 "c/sqlite3.c"
       $69 = ($68|0)==(0); //@line 129345 "c/sqlite3.c"
       $70 = $25 & 64; //@line 129347 "c/sqlite3.c"
       $71 = ($70|0)==(0); //@line 129347 "c/sqlite3.c"
       $$ = $71 ? 27421 : 27430;
       $spec$select7 = $69 ? $$ : 27448; //@line 129345 "c/sqlite3.c"
       $$073$ph = $spec$select7;
      } else {
       $$073$ph = 27473;
      }
     }
     _sqlite3StrAccumAppend($6,27518,7); //@line 129353 "c/sqlite3.c"
     $72 = HEAP32[$55>>2]|0; //@line 129354 "c/sqlite3.c"
     HEAP32[$vararg_buffer7>>2] = $72; //@line 129354 "c/sqlite3.c"
     _sqlite3XPrintf($6,$$073$ph,$vararg_buffer7); //@line 129354 "c/sqlite3.c"
     _explainIndexRange($6,$23); //@line 129355 "c/sqlite3.c"
    } else {
     $73 = $25 & 256; //@line 129357 "c/sqlite3.c"
     $74 = ($73|0)==(0); //@line 129357 "c/sqlite3.c"
     $75 = $25 & 15; //@line 129357 "c/sqlite3.c"
     $76 = ($75|0)==(0); //@line 129357 "c/sqlite3.c"
     $or$cond = $74 | $76; //@line 129357 "c/sqlite3.c"
     if ($or$cond) {
      $82 = $25 & 1024; //@line 129372 "c/sqlite3.c"
      $83 = ($82|0)==(0); //@line 129372 "c/sqlite3.c"
      if ($83) {
       break;
      }
      $84 = ((($23)) + 24|0); //@line 129374 "c/sqlite3.c"
      $85 = HEAP32[$84>>2]|0; //@line 129374 "c/sqlite3.c"
      $86 = ((($23)) + 32|0); //@line 129374 "c/sqlite3.c"
      $87 = HEAP32[$86>>2]|0; //@line 129374 "c/sqlite3.c"
      HEAP32[$vararg_buffer13>>2] = $85; //@line 129373 "c/sqlite3.c"
      $vararg_ptr16 = ((($vararg_buffer13)) + 4|0); //@line 129373 "c/sqlite3.c"
      HEAP32[$vararg_ptr16>>2] = $87; //@line 129373 "c/sqlite3.c"
      _sqlite3XPrintf($6,27584,$vararg_buffer13); //@line 129373 "c/sqlite3.c"
      break;
     }
     $77 = $25 & 5; //@line 129359 "c/sqlite3.c"
     $78 = ($77|0)==(0); //@line 129359 "c/sqlite3.c"
     if ($78) {
      $79 = ($31|0)==(48); //@line 129361 "c/sqlite3.c"
      $80 = $25 & 32; //@line 129363 "c/sqlite3.c"
      $81 = ($80|0)==(0); //@line 129363 "c/sqlite3.c"
      $$3 = $81 ? 27526 : 27528;
      $spec$select8 = $79 ? 27530 : $$3; //@line 129361 "c/sqlite3.c"
      $$0 = $spec$select8;
     } else {
      $$0 = 27544;
     }
     HEAP32[$vararg_buffer10>>2] = $$0; //@line 129369 "c/sqlite3.c"
     _sqlite3XPrintf($6,27546,$vararg_buffer10); //@line 129369 "c/sqlite3.c"
    }
   } while(0);
   $88 = (_sqlite3StrAccumFinish($6)|0); //@line 129384 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($18,169,$21,$3,$4,$88,-7)|0); //@line 129385 "c/sqlite3.c"
   STACKTOP = sp;return;
  }
 }
 STACKTOP = sp;return;
}
function _sqlite3WhereCodeOneLoopStart($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$01002 = 0, $$01003 = 0, $$01007 = 0, $$0927$lcssa = 0, $$09271089 = 0, $$09311068 = 0, $$09331043 = 0, $$09361042 = 0, $$09391049 = 0, $$0942 = 0, $$0943$lcssa = 0, $$09431083 = 0, $$09461027 = 0, $$09461028 = 0, $$0949 = 0, $$09501077 = 0, $$09591063 = 0, $$09601022 = 0, $$0962 = 0, $$0963 = 0;
 var $$0965 = 0, $$09671062 = 0, $$0971 = 0, $$09721055 = 0, $$0973$lcssa1097 = 0, $$09731054 = 0, $$0978 = 0, $$0979 = 0, $$0980 = 0, $$0982 = 0, $$0983 = 0, $$09851053 = 0, $$0989 = 0, $$0990 = 0, $$0996 = 0, $$0997 = 0, $$0999 = 0, $$0999$ = 0, $$11000 = 0, $$11000$ = 0;
 var $$11004 = 0, $$19281084 = 0, $$19371039 = 0, $$1941 = 0, $$1951 = 0, $$1961 = 0, $$1968 = 0, $$1981 = 0, $$1984 = 0, $$1986 = 0, $$1991 = 0, $$1993 = 0, $$1995 = 0, $$1998 = 0, $$21001 = 0, $$21005 = 0, $$29291079 = 0, $$29291079$in = 0, $$2935 = 0, $$29381037 = 0;
 var $$2945 = 0, $$2948 = 0, $$2952 = 0, $$31006 = 0, $$3930 = 0, $$3970 = 0, $$3976 = 0, $$3988 = 0, $$4 = 0, $$51071 = 0, $$61045 = 0, $$71040 = 0, $$81038 = 0, $$lcssa1036 = 0, $$lobit = 0, $$old2 = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0;
 var $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0;
 var $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0;
 var $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0;
 var $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0;
 var $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0;
 var $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0;
 var $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0;
 var $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0;
 var $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0;
 var $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0;
 var $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0;
 var $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0;
 var $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0;
 var $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0;
 var $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0;
 var $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0;
 var $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0;
 var $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0;
 var $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0;
 var $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0;
 var $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0;
 var $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0;
 var $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0;
 var $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0;
 var $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0;
 var $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0;
 var $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0;
 var $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0, $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0;
 var $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0, $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0;
 var $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0, $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0;
 var $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0, $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0;
 var $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0, $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0;
 var $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0, $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0;
 var $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0, $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0;
 var $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0, $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0;
 var $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0, $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0;
 var $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0, $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0;
 var $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0, $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0, $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0;
 var $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0, $799 = 0, $8 = 0, $80 = 0, $800 = 0, $801 = 0, $802 = 0, $803 = 0, $804 = 0, $805 = 0, $806 = 0;
 var $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0, $813 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0;
 var $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond1095 = 0, $exitcond1096 = 0, $or$cond = 0, $or$cond1014 = 0, $or$cond1016 = 0, $or$cond1021 = 0, $or$cond1034 = 0, $spec$select = 0, $spec$select1011 = 0, $spec$select1012 = 0, $spec$select1013 = 0, $spec$select1017 = 0;
 var $spec$select1018 = 0, $spec$select1019 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp;
 $5 = HEAP32[$0>>2]|0; //@line 130355 "c/sqlite3.c"
 $6 = ((($5)) + 8|0); //@line 130356 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 130356 "c/sqlite3.c"
 $8 = ((($0)) + 80|0); //@line 130357 "c/sqlite3.c"
 $9 = HEAP32[$5>>2]|0; //@line 130358 "c/sqlite3.c"
 $10 = (((($0)) + 752|0) + (($1*80)|0)|0); //@line 130359 "c/sqlite3.c"
 $11 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 64|0); //@line 130360 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 130360 "c/sqlite3.c"
 $13 = ((($0)) + 4|0); //@line 130361 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 130361 "c/sqlite3.c"
 $15 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 44|0); //@line 130361 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 130361 "c/sqlite3.c"
 $17 = $16&255; //@line 130361 "c/sqlite3.c"
 $18 = (((($14)) + 8|0) + (($17*72)|0)|0); //@line 130361 "c/sqlite3.c"
 $19 = (((((($14)) + 8|0) + (($17*72)|0)|0)) + 44|0); //@line 130362 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 130362 "c/sqlite3.c"
 $21 = ((($0)) + 488|0); //@line 130363 "c/sqlite3.c"
 $22 = (_sqlite3WhereGetMask($21,$20)|0); //@line 130363 "c/sqlite3.c"
 $23 = tempRet0; //@line 130363 "c/sqlite3.c"
 $24 = $22 ^ -1; //@line 130363 "c/sqlite3.c"
 $25 = $23 ^ -1; //@line 130363 "c/sqlite3.c"
 $26 = $24 & $2; //@line 130363 "c/sqlite3.c"
 $27 = $25 & $3; //@line 130363 "c/sqlite3.c"
 $28 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 72|0); //@line 130363 "c/sqlite3.c"
 $29 = $28; //@line 130363 "c/sqlite3.c"
 $30 = $29; //@line 130363 "c/sqlite3.c"
 HEAP32[$30>>2] = $26; //@line 130363 "c/sqlite3.c"
 $31 = (($29) + 4)|0; //@line 130363 "c/sqlite3.c"
 $32 = $31; //@line 130363 "c/sqlite3.c"
 HEAP32[$32>>2] = $27; //@line 130363 "c/sqlite3.c"
 $33 = ((($0)) + 64|0); //@line 130364 "c/sqlite3.c"
 $34 = $33; //@line 130364 "c/sqlite3.c"
 $35 = $34; //@line 130364 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 130364 "c/sqlite3.c"
 $37 = (($34) + 4)|0; //@line 130364 "c/sqlite3.c"
 $38 = $37; //@line 130364 "c/sqlite3.c"
 $39 = HEAP32[$38>>2]|0; //@line 130364 "c/sqlite3.c"
 $40 = (_bitshift64Lshr(($36|0),($39|0),($1|0))|0); //@line 130364 "c/sqlite3.c"
 $41 = tempRet0; //@line 130364 "c/sqlite3.c"
 $42 = $40 & 1; //@line 130364 "c/sqlite3.c"
 $43 = ((($12)) + 36|0); //@line 130365 "c/sqlite3.c"
 $44 = HEAP32[$43>>2]|0; //@line 130365 "c/sqlite3.c"
 $45 = $44 & 64; //@line 130365 "c/sqlite3.c"
 $46 = ($45|0)==(0); //@line 130365 "c/sqlite3.c"
 if ($46) {
  $470 = 0;
 } else {
  $47 = ((($0)) + 44|0); //@line 130366 "c/sqlite3.c"
  $48 = HEAP16[$47>>1]|0; //@line 130366 "c/sqlite3.c"
  $49 = $48 & 32; //@line 130366 "c/sqlite3.c"
  $50 = ($49<<16>>16)==(0); //@line 130366 "c/sqlite3.c"
  $470 = $50;
 }
 $51 = (_sqlite3VdbeMakeLabel($7)|0); //@line 130379 "c/sqlite3.c"
 $52 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 16|0); //@line 130379 "c/sqlite3.c"
 HEAP32[$52>>2] = $51; //@line 130379 "c/sqlite3.c"
 $53 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 12|0); //@line 130379 "c/sqlite3.c"
 HEAP32[$53>>2] = $51; //@line 130379 "c/sqlite3.c"
 $54 = (_sqlite3VdbeMakeLabel($7)|0); //@line 130380 "c/sqlite3.c"
 $55 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 24|0); //@line 130380 "c/sqlite3.c"
 HEAP32[$55>>2] = $54; //@line 130380 "c/sqlite3.c"
 $56 = HEAP8[$15>>0]|0; //@line 130386 "c/sqlite3.c"
 $57 = ($56<<24>>24)==(0); //@line 130386 "c/sqlite3.c"
 if (!($57)) {
  $58 = (((((($14)) + 8|0) + (($17*72)|0)|0)) + 36|0); //@line 130386 "c/sqlite3.c"
  $59 = HEAP8[$58>>0]|0; //@line 130386 "c/sqlite3.c"
  $60 = $59 & 8; //@line 130386 "c/sqlite3.c"
  $61 = ($60<<24>>24)==(0); //@line 130386 "c/sqlite3.c"
  if (!($61)) {
   $62 = ((($5)) + 44|0); //@line 130387 "c/sqlite3.c"
   $63 = HEAP32[$62>>2]|0; //@line 130387 "c/sqlite3.c"
   $64 = (($63) + 1)|0; //@line 130387 "c/sqlite3.c"
   HEAP32[$62>>2] = $64; //@line 130387 "c/sqlite3.c"
   HEAP32[$10>>2] = $64; //@line 130387 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($7,67,0,$64)|0); //@line 130388 "c/sqlite3.c"
  }
 }
 $65 = ($1|0)>(0); //@line 130394 "c/sqlite3.c"
 L8: do {
  if ($65) {
   $$09271089 = $1;
   while(1) {
    $66 = (((($0)) + 752|0) + (($$09271089*80)|0)|0); //@line 130394 "c/sqlite3.c"
    $67 = HEAP32[$66>>2]|0; //@line 130394 "c/sqlite3.c"
    $68 = ($67|0)==(0); //@line 130394 "c/sqlite3.c"
    if (!($68)) {
     $$0927$lcssa = $$09271089;
     break L8;
    }
    $69 = (($$09271089) + -1)|0; //@line 130394 "c/sqlite3.c"
    $70 = ($$09271089|0)>(1); //@line 130394 "c/sqlite3.c"
    if ($70) {
     $$09271089 = $69;
    } else {
     $$0927$lcssa = $69;
     break;
    }
   }
  } else {
   $$0927$lcssa = $1;
  }
 } while(0);
 $71 = (((((($0)) + 752|0) + (($$0927$lcssa*80)|0)|0)) + 12|0); //@line 130395 "c/sqlite3.c"
 $72 = HEAP32[$71>>2]|0; //@line 130395 "c/sqlite3.c"
 $73 = (((((($14)) + 8|0) + (($17*72)|0)|0)) + 37|0); //@line 130398 "c/sqlite3.c"
 $74 = HEAP8[$73>>0]|0; //@line 130398 "c/sqlite3.c"
 $75 = $74 & 16; //@line 130398 "c/sqlite3.c"
 $76 = ($75<<24>>24)==(0); //@line 130398 "c/sqlite3.c"
 do {
  if ($76) {
   $84 = HEAP32[$43>>2]|0; //@line 130408 "c/sqlite3.c"
   $85 = $84 & 1024; //@line 130408 "c/sqlite3.c"
   $86 = ($85|0)==(0); //@line 130408 "c/sqlite3.c"
   if (!($86)) {
    $87 = ((($12)) + 40|0); //@line 130414 "c/sqlite3.c"
    $88 = HEAP16[$87>>1]|0; //@line 130414 "c/sqlite3.c"
    $89 = $88&65535; //@line 130414 "c/sqlite3.c"
    _sqlite3ExprCachePush($5); //@line 130417 "c/sqlite3.c"
    $90 = (($89) + 2)|0; //@line 130418 "c/sqlite3.c"
    $91 = (_sqlite3GetTempRange($5,$90)|0); //@line 130418 "c/sqlite3.c"
    $92 = HEAP32[$53>>2]|0; //@line 130419 "c/sqlite3.c"
    $93 = ($88<<16>>16)==(0); //@line 130420 "c/sqlite3.c"
    if ($93) {
     $$0943$lcssa = $92;
    } else {
     $94 = (($91) + 2)|0;
     $95 = ((($12)) + 48|0);
     $$09431083 = $92;$$19281084 = 0;
     while(1) {
      $96 = (($94) + ($$19281084))|0; //@line 130421 "c/sqlite3.c"
      $97 = HEAP32[$95>>2]|0; //@line 130422 "c/sqlite3.c"
      $98 = (($97) + ($$19281084<<2)|0); //@line 130422 "c/sqlite3.c"
      $99 = HEAP32[$98>>2]|0; //@line 130422 "c/sqlite3.c"
      $100 = ($99|0)==(0|0); //@line 130423 "c/sqlite3.c"
      do {
       if ($100) {
        $$2945 = $$09431083;
       } else {
        $101 = ((($99)) + 12|0); //@line 130424 "c/sqlite3.c"
        $102 = HEAP16[$101>>1]|0; //@line 130424 "c/sqlite3.c"
        $103 = $102 & 1; //@line 130424 "c/sqlite3.c"
        $104 = ($103<<16>>16)==(0); //@line 130424 "c/sqlite3.c"
        if ($104) {
         $106 = HEAP32[$99>>2]|0; //@line 130428 "c/sqlite3.c"
         $107 = ((($106)) + 16|0); //@line 130428 "c/sqlite3.c"
         $108 = HEAP32[$107>>2]|0; //@line 130428 "c/sqlite3.c"
         _codeExprOrVector($5,$108,$96,1); //@line 130429 "c/sqlite3.c"
         $$2945 = $$09431083;
         break;
        } else {
         (_codeEqualityTerm($5,$99,$10,$$19281084,$42,$96)|0); //@line 130425 "c/sqlite3.c"
         $105 = HEAP32[$52>>2]|0; //@line 130426 "c/sqlite3.c"
         $$2945 = $105;
         break;
        }
       }
      } while(0);
      $109 = (($$19281084) + 1)|0; //@line 130420 "c/sqlite3.c"
      $exitcond1096 = ($109|0)==($89|0); //@line 130420 "c/sqlite3.c"
      if ($exitcond1096) {
       $$0943$lcssa = $$2945;
       break;
      } else {
       $$09431083 = $$2945;$$19281084 = $109;
      }
     }
    }
    $110 = ((($12)) + 24|0); //@line 130432 "c/sqlite3.c"
    $111 = HEAP32[$110>>2]|0; //@line 130432 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($7,67,$111,$91)|0); //@line 130432 "c/sqlite3.c"
    $112 = (($91) + 1)|0; //@line 130433 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($7,67,$89,$112)|0); //@line 130433 "c/sqlite3.c"
    $113 = ((($12)) + 32|0); //@line 130435 "c/sqlite3.c"
    $114 = HEAP32[$113>>2]|0; //@line 130435 "c/sqlite3.c"
    $115 = ((($12)) + 28|0); //@line 130436 "c/sqlite3.c"
    $116 = HEAP8[$115>>0]|0; //@line 130436 "c/sqlite3.c"
    $117 = ($116<<24>>24)==(0); //@line 130436 "c/sqlite3.c"
    $118 = $117 ? -1 : -7; //@line 130436 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4($7,11,$20,$$0943$lcssa,$91,$114,$118)|0); //@line 130434 "c/sqlite3.c"
    HEAP8[$115>>0] = 0; //@line 130438 "c/sqlite3.c"
    $119 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 48|0); //@line 130439 "c/sqlite3.c"
    HEAP32[$119>>2] = $20; //@line 130439 "c/sqlite3.c"
    $120 = ((($0)) + 49|0); //@line 130440 "c/sqlite3.c"
    $121 = HEAP8[$120>>0]|0; //@line 130440 "c/sqlite3.c"
    $122 = ($121<<24>>24)==(0); //@line 130440 "c/sqlite3.c"
    $123 = $122 ? 61 : -88; //@line 130440 "c/sqlite3.c"
    $124 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 130440 "c/sqlite3.c"
    HEAP8[$124>>0] = $123; //@line 130440 "c/sqlite3.c"
    $125 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 130441 "c/sqlite3.c"
    $126 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 52|0); //@line 130441 "c/sqlite3.c"
    HEAP32[$126>>2] = $125; //@line 130441 "c/sqlite3.c"
    $127 = ($88<<16>>16)==(0); //@line 130443 "c/sqlite3.c"
    if (!($127)) {
     $128 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 56|0); //@line 130442 "c/sqlite3.c"
     $129 = HEAP32[$128>>2]|0; //@line 130442 "c/sqlite3.c"
     $130 = ((($12)) + 48|0);
     $131 = ((($12)) + 30|0);
     $132 = ((($9)) + 73|0);
     $133 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 60|0);
     $134 = (($91) + 2)|0;
     $$09501077 = $129;$$29291079$in = $89;
     while(1) {
      $$29291079 = (($$29291079$in) + -1)|0;
      $135 = HEAP32[$130>>2]|0; //@line 130444 "c/sqlite3.c"
      $136 = (($135) + ($$29291079<<2)|0); //@line 130444 "c/sqlite3.c"
      $137 = HEAP32[$136>>2]|0; //@line 130444 "c/sqlite3.c"
      $138 = ($$29291079$in|0)<(17); //@line 130445 "c/sqlite3.c"
      if ($138) {
       $139 = HEAP16[$131>>1]|0; //@line 130445 "c/sqlite3.c"
       $140 = $139&65535; //@line 130445 "c/sqlite3.c"
       $141 = 1 << $$29291079; //@line 130445 "c/sqlite3.c"
       $142 = $141 & $140; //@line 130445 "c/sqlite3.c"
       $143 = ($142|0)==(0); //@line 130445 "c/sqlite3.c"
       if ($143) {
        label = 25;
       } else {
        _disableTerm($10,$137); //@line 130446 "c/sqlite3.c"
        $$2952 = $$09501077;
       }
      } else {
       label = 25;
      }
      if ((label|0) == 25) {
       label = 0;
       $144 = ((($137)) + 12|0); //@line 130447 "c/sqlite3.c"
       $145 = HEAP16[$144>>1]|0; //@line 130447 "c/sqlite3.c"
       $146 = $145 & 1; //@line 130447 "c/sqlite3.c"
       $147 = ($146<<16>>16)==(0); //@line 130447 "c/sqlite3.c"
       if ($147) {
        $$2952 = $$09501077;
       } else {
        $148 = HEAP8[$132>>0]|0; //@line 130457 "c/sqlite3.c"
        $149 = ($148<<24>>24)==(0); //@line 130457 "c/sqlite3.c"
        if ($149) {
         $150 = HEAP32[$133>>2]|0; //@line 130459 "c/sqlite3.c"
         $151 = (($$09501077) + -1)|0; //@line 130459 "c/sqlite3.c"
         $152 = (((($150) + (($151*12)|0)|0)) + 4|0); //@line 130459 "c/sqlite3.c"
         $153 = HEAP32[$152>>2]|0; //@line 130459 "c/sqlite3.c"
         $154 = (_sqlite3VdbeGetOp($7,$153)|0); //@line 130459 "c/sqlite3.c"
         $155 = HEAP8[$154>>0]|0; //@line 130464 "c/sqlite3.c"
         $156 = $155&255; //@line 130464 "c/sqlite3.c"
         $157 = ((($154)) + 4|0); //@line 130464 "c/sqlite3.c"
         $158 = HEAP32[$157>>2]|0; //@line 130464 "c/sqlite3.c"
         $159 = ((($154)) + 8|0); //@line 130464 "c/sqlite3.c"
         $160 = HEAP32[$159>>2]|0; //@line 130464 "c/sqlite3.c"
         $161 = ((($154)) + 12|0); //@line 130464 "c/sqlite3.c"
         $162 = HEAP32[$161>>2]|0; //@line 130464 "c/sqlite3.c"
         (_sqlite3VdbeAddOp3($7,$156,$158,$160,$162)|0); //@line 130464 "c/sqlite3.c"
         $$1951 = $151;
        } else {
         $$1951 = $$09501077;
        }
        $163 = (_sqlite3PExpr($5,53,0,0)|0); //@line 130469 "c/sqlite3.c"
        $164 = ($163|0)==(0|0); //@line 130471 "c/sqlite3.c"
        if ($164) {
         $$2952 = $$1951;
        } else {
         $165 = HEAP32[$137>>2]|0; //@line 130472 "c/sqlite3.c"
         $166 = ((($165)) + 12|0); //@line 130472 "c/sqlite3.c"
         $167 = HEAP32[$166>>2]|0; //@line 130472 "c/sqlite3.c"
         $168 = ((($163)) + 12|0); //@line 130472 "c/sqlite3.c"
         HEAP32[$168>>2] = $167; //@line 130472 "c/sqlite3.c"
         $169 = (_sqlite3Expr($9,150,0)|0); //@line 130473 "c/sqlite3.c"
         $170 = ((($163)) + 16|0); //@line 130473 "c/sqlite3.c"
         HEAP32[$170>>2] = $169; //@line 130473 "c/sqlite3.c"
         $171 = ($169|0)==(0|0); //@line 130474 "c/sqlite3.c"
         if (!($171)) {
          $172 = ((($169)) + 28|0); //@line 130475 "c/sqlite3.c"
          $173 = (($134) + ($$29291079))|0; //@line 130475 "c/sqlite3.c"
          HEAP32[$172>>2] = $173; //@line 130475 "c/sqlite3.c"
          $174 = HEAP32[$55>>2]|0; //@line 130476 "c/sqlite3.c"
          _sqlite3ExprIfFalse($5,$163,$174,0); //@line 130476 "c/sqlite3.c"
         }
         HEAP32[$168>>2] = 0; //@line 130478 "c/sqlite3.c"
         _sqlite3ExprDelete($9,$163); //@line 130479 "c/sqlite3.c"
         $$2952 = $$1951;
        }
       }
      }
      $175 = ($$29291079$in|0)>(1); //@line 130443 "c/sqlite3.c"
      if ($175) {
       $$09501077 = $$2952;$$29291079$in = $$29291079;
      } else {
       break;
      }
     }
    }
    _sqlite3ExprCachePop($5); //@line 130490 "c/sqlite3.c"
    $$1941 = 0;
    break;
   }
   $176 = $84 & 256; //@line 130494 "c/sqlite3.c"
   $177 = ($176|0)==(0); //@line 130494 "c/sqlite3.c"
   $178 = $84 & 5; //@line 130495 "c/sqlite3.c"
   $179 = ($178|0)==(0); //@line 130495 "c/sqlite3.c"
   $or$cond = $177 | $179; //@line 130495 "c/sqlite3.c"
   if (!($or$cond)) {
    $180 = ((($12)) + 48|0); //@line 130503 "c/sqlite3.c"
    $181 = HEAP32[$180>>2]|0; //@line 130503 "c/sqlite3.c"
    $182 = HEAP32[$181>>2]|0; //@line 130503 "c/sqlite3.c"
    $183 = ((($5)) + 44|0); //@line 130508 "c/sqlite3.c"
    $184 = HEAP32[$183>>2]|0; //@line 130508 "c/sqlite3.c"
    $185 = (($184) + 1)|0; //@line 130508 "c/sqlite3.c"
    HEAP32[$183>>2] = $185; //@line 130508 "c/sqlite3.c"
    $186 = (_codeEqualityTerm($5,$182,$10,0,$42,$185)|0); //@line 130509 "c/sqlite3.c"
    $187 = ($186|0)==($185|0); //@line 130510 "c/sqlite3.c"
    if (!($187)) {
     _sqlite3ReleaseTempReg($5,$185); //@line 130510 "c/sqlite3.c"
    }
    $188 = HEAP32[$52>>2]|0; //@line 130511 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($7,31,$20,$188,$186)|0); //@line 130512 "c/sqlite3.c"
    _sqlite3ExprCacheAffinityChange($5,$186,1); //@line 130514 "c/sqlite3.c"
    _sqlite3ExprCacheStore($5,$20,-1,$186); //@line 130515 "c/sqlite3.c"
    $189 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 130517 "c/sqlite3.c"
    HEAP8[$189>>0] = -88; //@line 130517 "c/sqlite3.c"
    $$1941 = 0;
    break;
   }
   $190 = $84 & 258; //@line 130519 "c/sqlite3.c"
   $191 = ($190|0)==(258); //@line 130519 "c/sqlite3.c"
   if ($191) {
    $192 = $84 & 32; //@line 130531 "c/sqlite3.c"
    $193 = ($192|0)==(0); //@line 130531 "c/sqlite3.c"
    if ($193) {
     $$0963 = 0;$$3930 = 0;
    } else {
     $194 = ((($12)) + 48|0); //@line 130531 "c/sqlite3.c"
     $195 = HEAP32[$194>>2]|0; //@line 130531 "c/sqlite3.c"
     $196 = HEAP32[$195>>2]|0; //@line 130531 "c/sqlite3.c"
     $$0963 = $196;$$3930 = 1;
    }
    $197 = $84 & 16; //@line 130532 "c/sqlite3.c"
    $198 = ($197|0)==(0); //@line 130532 "c/sqlite3.c"
    if ($198) {
     $$0965 = 0;
    } else {
     $199 = ((($12)) + 48|0); //@line 130532 "c/sqlite3.c"
     $200 = HEAP32[$199>>2]|0; //@line 130532 "c/sqlite3.c"
     $201 = (($200) + ($$3930<<2)|0); //@line 130532 "c/sqlite3.c"
     $202 = HEAP32[$201>>2]|0; //@line 130532 "c/sqlite3.c"
     $$0965 = $202;
    }
    $203 = ($42|0)==(0); //@line 130534 "c/sqlite3.c"
    $spec$select = $203 ? $$0965 : $$0963; //@line 130534 "c/sqlite3.c"
    $spec$select1011 = $203 ? $$0963 : $$0965; //@line 130534 "c/sqlite3.c"
    $204 = ($spec$select1011|0)==(0|0); //@line 130540 "c/sqlite3.c"
    if ($204) {
     $224 = $42 << 2; //@line 130581 "c/sqlite3.c"
     $225 = $224 ^ 37; //@line 130581 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($7,$225,$20,$72)|0); //@line 130581 "c/sqlite3.c"
    } else {
     $205 = HEAP32[$spec$select1011>>2]|0; //@line 130560 "c/sqlite3.c"
     $206 = ((($205)) + 16|0); //@line 130563 "c/sqlite3.c"
     $207 = HEAP32[$206>>2]|0; //@line 130563 "c/sqlite3.c"
     $208 = (_sqlite3ExprIsVector($207)|0); //@line 130563 "c/sqlite3.c"
     $209 = ($208|0)==(0); //@line 130563 "c/sqlite3.c"
     if ($209) {
      $216 = (_sqlite3ExprCodeTemp($5,$207,$4)|0); //@line 130568 "c/sqlite3.c"
      _disableTerm($10,$spec$select1011); //@line 130569 "c/sqlite3.c"
      $217 = HEAP8[$205>>0]|0; //@line 130570 "c/sqlite3.c"
      $218 = $217&255; //@line 130570 "c/sqlite3.c"
      $219 = (($218) + -54)|0; //@line 130570 "c/sqlite3.c"
      $$0971 = $216;$$sink = $219;
     } else {
      $210 = (_sqlite3GetTempReg($5)|0); //@line 130564 "c/sqlite3.c"
      HEAP32[$4>>2] = $210; //@line 130564 "c/sqlite3.c"
      $211 = HEAP32[$206>>2]|0; //@line 130565 "c/sqlite3.c"
      _codeExprOrVector($5,$211,$210,1); //@line 130565 "c/sqlite3.c"
      $212 = HEAP8[$205>>0]|0; //@line 130566 "c/sqlite3.c"
      $213 = $212&255; //@line 130566 "c/sqlite3.c"
      $214 = (($213) + -54)|0; //@line 130566 "c/sqlite3.c"
      $215 = $214 | 1; //@line 130566 "c/sqlite3.c"
      $$0971 = $210;$$sink = $215;
     }
     $220 = (27359 + ($$sink)|0);
     $221 = HEAP8[$220>>0]|0;
     $222 = $221&255;
     (_sqlite3VdbeAddOp3($7,$222,$20,$51,$$0971)|0); //@line 130572 "c/sqlite3.c"
     _sqlite3ExprCacheAffinityChange($5,$$0971,1); //@line 130578 "c/sqlite3.c"
     $223 = HEAP32[$4>>2]|0; //@line 130579 "c/sqlite3.c"
     _sqlite3ReleaseTempReg($5,$223); //@line 130579 "c/sqlite3.c"
    }
    $226 = ($spec$select|0)==(0|0); //@line 130585 "c/sqlite3.c"
    do {
     if ($226) {
      $$0962 = 0;$$1961 = 168;
     } else {
      $227 = HEAP32[$spec$select>>2]|0; //@line 130587 "c/sqlite3.c"
      $228 = ((($5)) + 44|0); //@line 130592 "c/sqlite3.c"
      $229 = HEAP32[$228>>2]|0; //@line 130592 "c/sqlite3.c"
      $230 = (($229) + 1)|0; //@line 130592 "c/sqlite3.c"
      HEAP32[$228>>2] = $230; //@line 130592 "c/sqlite3.c"
      $231 = ((($227)) + 16|0); //@line 130593 "c/sqlite3.c"
      $232 = HEAP32[$231>>2]|0; //@line 130593 "c/sqlite3.c"
      _codeExprOrVector($5,$232,$230,1); //@line 130593 "c/sqlite3.c"
      $233 = HEAP32[$231>>2]|0; //@line 130594 "c/sqlite3.c"
      $234 = (_sqlite3ExprIsVector($233)|0); //@line 130594 "c/sqlite3.c"
      $235 = ($234|0)==(0); //@line 130594 "c/sqlite3.c"
      if (!($235)) {
       $242 = $42 << 1; //@line 130599 "c/sqlite3.c"
       $243 = (($242) + 54)|0; //@line 130599 "c/sqlite3.c"
       $$0962 = $230;$$1961 = $243;
       break;
      }
      $236 = HEAP8[$227>>0]|0; //@line 130595 "c/sqlite3.c"
      switch ($236<<24>>24) {
      case 54: case 56:  {
       $239 = $42 << 1; //@line 130597 "c/sqlite3.c"
       $240 = $239 ^ 2; //@line 130597 "c/sqlite3.c"
       $241 = (($240) + 55)|0; //@line 130597 "c/sqlite3.c"
       $$09601022 = $241;
       break;
      }
      default: {
       $237 = $42 << 1; //@line 130599 "c/sqlite3.c"
       $238 = (($237) + 54)|0; //@line 130599 "c/sqlite3.c"
       $$09601022 = $238;
      }
      }
      _disableTerm($10,$spec$select); //@line 130602 "c/sqlite3.c"
      $$0962 = $230;$$1961 = $$09601022;
     }
    } while(0);
    $244 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 130605 "c/sqlite3.c"
    $245 = $42 ^ 7; //@line 130606 "c/sqlite3.c"
    $246 = $245&255; //@line 130606 "c/sqlite3.c"
    $247 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 130606 "c/sqlite3.c"
    HEAP8[$247>>0] = $246; //@line 130606 "c/sqlite3.c"
    $248 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 48|0); //@line 130607 "c/sqlite3.c"
    HEAP32[$248>>2] = $20; //@line 130607 "c/sqlite3.c"
    $249 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 52|0); //@line 130608 "c/sqlite3.c"
    HEAP32[$249>>2] = $244; //@line 130608 "c/sqlite3.c"
    $250 = ($$1961|0)==(168); //@line 130610 "c/sqlite3.c"
    if ($250) {
     $$1941 = 0;
     break;
    }
    $251 = ((($5)) + 44|0); //@line 130611 "c/sqlite3.c"
    $252 = HEAP32[$251>>2]|0; //@line 130611 "c/sqlite3.c"
    $253 = (($252) + 1)|0; //@line 130611 "c/sqlite3.c"
    HEAP32[$251>>2] = $253; //@line 130611 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($7,124,$20,$253)|0); //@line 130612 "c/sqlite3.c"
    _sqlite3ExprCacheStore($5,$20,-1,$253); //@line 130613 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($7,$$1961,$$0962,$51,$253)|0); //@line 130614 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($7,83); //@line 130619 "c/sqlite3.c"
    $$1941 = 0;
    break;
   }
   $254 = $84 & 512; //@line 130621 "c/sqlite3.c"
   $255 = ($254|0)==(0); //@line 130621 "c/sqlite3.c"
   if ($255) {
    $471 = $84 & 8192; //@line 130934 "c/sqlite3.c"
    $472 = ($471|0)==(0); //@line 130934 "c/sqlite3.c"
    if ($472) {
     $656 = $74 & 32; //@line 131227 "c/sqlite3.c"
     $657 = ($656<<24>>24)==(0); //@line 131227 "c/sqlite3.c"
     if ($657) {
      $659 = (27375 + ($42)|0); //@line 131233 "c/sqlite3.c"
      $660 = HEAP8[$659>>0]|0; //@line 131233 "c/sqlite3.c"
      $661 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 131233 "c/sqlite3.c"
      HEAP8[$661>>0] = $660; //@line 131233 "c/sqlite3.c"
      $662 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 48|0); //@line 131234 "c/sqlite3.c"
      HEAP32[$662>>2] = $20; //@line 131234 "c/sqlite3.c"
      $663 = (27377 + ($42)|0); //@line 131235 "c/sqlite3.c"
      $664 = HEAP8[$663>>0]|0; //@line 131235 "c/sqlite3.c"
      $665 = $664&255; //@line 131235 "c/sqlite3.c"
      $666 = (_sqlite3VdbeAddOp2($7,$665,$20,$72)|0); //@line 131235 "c/sqlite3.c"
      $667 = (($666) + 1)|0; //@line 131235 "c/sqlite3.c"
      $668 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 52|0); //@line 131235 "c/sqlite3.c"
      HEAP32[$668>>2] = $667; //@line 131235 "c/sqlite3.c"
      $669 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 47|0); //@line 131238 "c/sqlite3.c"
      HEAP8[$669>>0] = 1; //@line 131238 "c/sqlite3.c"
      $$1941 = 0;
      break;
     } else {
      $658 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 131230 "c/sqlite3.c"
      HEAP8[$658>>0] = -88; //@line 131230 "c/sqlite3.c"
      $$1941 = 0;
      break;
     }
    }
    $473 = ((($5)) + 40|0); //@line 130981 "c/sqlite3.c"
    $474 = HEAP32[$473>>2]|0; //@line 130981 "c/sqlite3.c"
    $475 = (($474) + 1)|0; //@line 130981 "c/sqlite3.c"
    HEAP32[$473>>2] = $475; //@line 130981 "c/sqlite3.c"
    $476 = ((($5)) + 44|0); //@line 130983 "c/sqlite3.c"
    $477 = HEAP32[$476>>2]|0; //@line 130983 "c/sqlite3.c"
    $478 = (($477) + 1)|0; //@line 130983 "c/sqlite3.c"
    HEAP32[$476>>2] = $478; //@line 130983 "c/sqlite3.c"
    $479 = (_sqlite3VdbeMakeLabel($7)|0); //@line 130986 "c/sqlite3.c"
    $480 = (((((($14)) + 8|0) + (($17*72)|0)|0)) + 16|0); //@line 130992 "c/sqlite3.c"
    $481 = HEAP32[$480>>2]|0; //@line 130992 "c/sqlite3.c"
    $482 = ((($12)) + 48|0); //@line 130994 "c/sqlite3.c"
    $483 = HEAP32[$482>>2]|0; //@line 130994 "c/sqlite3.c"
    $484 = HEAP32[$483>>2]|0; //@line 130994 "c/sqlite3.c"
    $485 = ((($484)) + 28|0); //@line 130998 "c/sqlite3.c"
    $486 = HEAP32[$485>>2]|0; //@line 130998 "c/sqlite3.c"
    $487 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 130999 "c/sqlite3.c"
    HEAP8[$487>>0] = 63; //@line 130999 "c/sqlite3.c"
    $488 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 48|0); //@line 131000 "c/sqlite3.c"
    HEAP32[$488>>2] = $478; //@line 131000 "c/sqlite3.c"
    $489 = ((($0)) + 46|0); //@line 131006 "c/sqlite3.c"
    $490 = HEAP8[$489>>0]|0; //@line 131006 "c/sqlite3.c"
    $491 = ($490&255)>(1); //@line 131006 "c/sqlite3.c"
    if ($491) {
     $492 = $490&255; //@line 131006 "c/sqlite3.c"
     $493 = (($492) - ($1))|0; //@line 131009 "c/sqlite3.c"
     $494 = ($493*72)|0; //@line 131010 "c/sqlite3.c"
     $495 = (($494) + 8)|0; //@line 131010 "c/sqlite3.c"
     $496 = (_sqlite3DbMallocRaw($9,$495,0)|0); //@line 131010 "c/sqlite3.c"
     $497 = ($496|0)==(0|0); //@line 131012 "c/sqlite3.c"
     if ($497) {
      $812 = $3;$813 = $2;
      tempRet0 = ($812); //@line 131373 "c/sqlite3.c"
      STACKTOP = sp;return ($813|0); //@line 131373 "c/sqlite3.c"
     }
     $498 = $493 & 255; //@line 131013 "c/sqlite3.c"
     $499 = ((($496)) + 4|0); //@line 131013 "c/sqlite3.c"
     HEAP32[$499>>2] = $498; //@line 131013 "c/sqlite3.c"
     HEAP32[$496>>2] = $498; //@line 131014 "c/sqlite3.c"
     $500 = ((($496)) + 8|0); //@line 131015 "c/sqlite3.c"
     dest=$500; src=$18; stop=dest+72|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 131015 "c/sqlite3.c"
     $501 = HEAP32[$13>>2]|0; //@line 131016 "c/sqlite3.c"
     $502 = ($493|0)>(1); //@line 131017 "c/sqlite3.c"
     if ($502) {
      $$09311068 = 1;
      while(1) {
       $503 = (($500) + (($$09311068*72)|0)|0); //@line 131018 "c/sqlite3.c"
       $504 = (((($10) + (($$09311068*80)|0)|0)) + 44|0); //@line 131018 "c/sqlite3.c"
       $505 = HEAP8[$504>>0]|0; //@line 131018 "c/sqlite3.c"
       $506 = $505&255; //@line 131018 "c/sqlite3.c"
       $507 = (((($501)) + 8|0) + (($506*72)|0)|0); //@line 131018 "c/sqlite3.c"
       dest=$503; src=$507; stop=dest+72|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 131018 "c/sqlite3.c"
       $508 = (($$09311068) + 1)|0; //@line 131017 "c/sqlite3.c"
       $exitcond1095 = ($508|0)==($493|0); //@line 131017 "c/sqlite3.c"
       if ($exitcond1095) {
        $$0989 = $496;$654 = $496;
        break;
       } else {
        $$09311068 = $508;
       }
      }
     } else {
      $$0989 = $496;$654 = $496;
     }
    } else {
     $509 = HEAP32[$13>>2]|0; //@line 131021 "c/sqlite3.c"
     $$0989 = $509;$654 = $509;
    }
    $510 = ((($0)) + 44|0); //@line 131036 "c/sqlite3.c"
    $511 = HEAP16[$510>>1]|0; //@line 131036 "c/sqlite3.c"
    $512 = $511 & 16; //@line 131036 "c/sqlite3.c"
    $513 = ($512<<16>>16)==(0); //@line 131036 "c/sqlite3.c"
    if ($513) {
     $514 = ((($481)) + 36|0); //@line 131037 "c/sqlite3.c"
     $515 = HEAP32[$514>>2]|0; //@line 131037 "c/sqlite3.c"
     $516 = $515 & 32; //@line 131037 "c/sqlite3.c"
     $517 = ($516|0)==(0); //@line 131037 "c/sqlite3.c"
     if ($517) {
      $518 = HEAP32[$476>>2]|0; //@line 131038 "c/sqlite3.c"
      $519 = (($518) + 1)|0; //@line 131038 "c/sqlite3.c"
      HEAP32[$476>>2] = $519; //@line 131038 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($7,70,0,$519)|0); //@line 131039 "c/sqlite3.c"
      $$0980 = $519;
     } else {
      $520 = (_sqlite3PrimaryKeyIndex($481)|0); //@line 131041 "c/sqlite3.c"
      $521 = HEAP32[$473>>2]|0; //@line 131042 "c/sqlite3.c"
      $522 = (($521) + 1)|0; //@line 131042 "c/sqlite3.c"
      HEAP32[$473>>2] = $522; //@line 131042 "c/sqlite3.c"
      $523 = ((($520)) + 50|0); //@line 131043 "c/sqlite3.c"
      $524 = HEAP16[$523>>1]|0; //@line 131043 "c/sqlite3.c"
      $525 = $524&65535; //@line 131043 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($7,109,$521,$525)|0); //@line 131043 "c/sqlite3.c"
      _sqlite3VdbeSetP4KeyInfo($5,$520); //@line 131044 "c/sqlite3.c"
      $$0980 = $521;
     }
     $526 = HEAP32[$476>>2]|0; //@line 131046 "c/sqlite3.c"
     $527 = (($526) + 1)|0; //@line 131046 "c/sqlite3.c"
     HEAP32[$476>>2] = $527; //@line 131046 "c/sqlite3.c"
     $$0979 = $527;$$1981 = $$0980;
    } else {
     $$0979 = 0;$$1981 = 0;
    }
    $528 = (_sqlite3VdbeAddOp2($7,67,0,$478)|0); //@line 131048 "c/sqlite3.c"
    $529 = ((($0)) + 92|0); //@line 131064 "c/sqlite3.c"
    $530 = HEAP32[$529>>2]|0; //@line 131064 "c/sqlite3.c"
    $531 = ($530|0)>(1); //@line 131064 "c/sqlite3.c"
    if ($531) {
     $532 = HEAP32[$529>>2]|0; //@line 131066 "c/sqlite3.c"
     $533 = ($532|0)>(0); //@line 131066 "c/sqlite3.c"
     if ($533) {
      $534 = ((($0)) + 100|0);
      $$09591063 = 0;$$09671062 = 0;
      while(1) {
       $535 = HEAP32[$534>>2]|0; //@line 131067 "c/sqlite3.c"
       $536 = (($535) + (($$09591063*48)|0)|0); //@line 131067 "c/sqlite3.c"
       $537 = HEAP32[$536>>2]|0; //@line 131067 "c/sqlite3.c"
       $538 = ($536|0)==($484|0); //@line 131068 "c/sqlite3.c"
       do {
        if ($538) {
         $$1968 = $$09671062;
        } else {
         $539 = ((($537)) + 4|0); //@line 131069 "c/sqlite3.c"
         $540 = HEAP32[$539>>2]|0; //@line 131069 "c/sqlite3.c"
         $541 = $540 & 1; //@line 131069 "c/sqlite3.c"
         $542 = ($541|0)==(0); //@line 131069 "c/sqlite3.c"
         if ($542) {
          $543 = (((($535) + (($$09591063*48)|0)|0)) + 10|0); //@line 131072 "c/sqlite3.c"
          $544 = HEAP16[$543>>1]|0; //@line 131072 "c/sqlite3.c"
          $545 = $544 & 6; //@line 131072 "c/sqlite3.c"
          $546 = ($545<<16>>16)==(0); //@line 131072 "c/sqlite3.c"
          if (!($546)) {
           $$1968 = $$09671062;
           break;
          }
          $547 = (((($535) + (($$09591063*48)|0)|0)) + 12|0); //@line 131073 "c/sqlite3.c"
          $548 = HEAP16[$547>>1]|0; //@line 131073 "c/sqlite3.c"
          $549 = $548 & 8191; //@line 131073 "c/sqlite3.c"
          $550 = ($549<<16>>16)==(0); //@line 131073 "c/sqlite3.c"
          if ($550) {
           $$1968 = $$09671062;
           break;
          }
          $551 = (_sqlite3ExprDup($9,$537,0)|0); //@line 131075 "c/sqlite3.c"
          $552 = (_sqlite3ExprAnd($9,$$09671062,$551)|0); //@line 131076 "c/sqlite3.c"
          $$1968 = $552;
         } else {
          $$1968 = $$09671062;
         }
        }
       } while(0);
       $553 = (($$09591063) + 1)|0; //@line 131066 "c/sqlite3.c"
       $554 = HEAP32[$529>>2]|0; //@line 131066 "c/sqlite3.c"
       $555 = ($553|0)<($554|0); //@line 131066 "c/sqlite3.c"
       if ($555) {
        $$09591063 = $553;$$09671062 = $$1968;
       } else {
        break;
       }
      }
      $556 = ($$1968|0)==(0|0); //@line 131078 "c/sqlite3.c"
      if ($556) {
       $$3970 = 0;
      } else {
       $557 = (_sqlite3PExpr($5,300,0,$$1968)|0); //@line 131079 "c/sqlite3.c"
       $$3970 = $557;
      }
     } else {
      $$3970 = 0;
     }
    } else {
     $$3970 = 0;
    }
    $558 = HEAP16[$510>>1]|0; //@line 131087 "c/sqlite3.c"
    $559 = $558 & 1024; //@line 131087 "c/sqlite3.c"
    $560 = $559 | 32; //@line 131087 "c/sqlite3.c"
    $561 = ((($486)) + 12|0); //@line 131088 "c/sqlite3.c"
    $562 = HEAP32[$561>>2]|0; //@line 131088 "c/sqlite3.c"
    $563 = ($562|0)>(0); //@line 131088 "c/sqlite3.c"
    if ($563) {
     $565 = ((($486)) + 20|0);
     $566 = ($$3970|0)==(0|0);
     $567 = ((($$3970)) + 12|0);
     $568 = ((($481)) + 36|0);
     $569 = ((($481)) + 36|0);
     $$09721055 = 0;$$09731054 = 0;$$09851053 = 0;
     while(1) {
      $570 = HEAP32[$565>>2]|0; //@line 131089 "c/sqlite3.c"
      $571 = (((($570) + (($$09721055*48)|0)|0)) + 20|0); //@line 131090 "c/sqlite3.c"
      $572 = HEAP32[$571>>2]|0; //@line 131090 "c/sqlite3.c"
      $573 = ($572|0)==($20|0); //@line 131090 "c/sqlite3.c"
      if ($573) {
       label = 153;
      } else {
       $574 = (((($570) + (($$09721055*48)|0)|0)) + 12|0); //@line 131090 "c/sqlite3.c"
       $575 = HEAP16[$574>>1]|0; //@line 131090 "c/sqlite3.c"
       $576 = $575 & 1024; //@line 131090 "c/sqlite3.c"
       $577 = ($576<<16>>16)==(0); //@line 131090 "c/sqlite3.c"
       if ($577) {
        $$3976 = $$09731054;$$3988 = $$09851053;
       } else {
        label = 153;
       }
      }
      do {
       if ((label|0) == 153) {
        label = 0;
        $578 = (($570) + (($$09721055*48)|0)|0); //@line 131092 "c/sqlite3.c"
        $579 = HEAP32[$578>>2]|0; //@line 131092 "c/sqlite3.c"
        do {
         if ($566) {
          $$0949 = $579;
         } else {
          $580 = ((($579)) + 4|0); //@line 131094 "c/sqlite3.c"
          $581 = HEAP32[$580>>2]|0; //@line 131094 "c/sqlite3.c"
          $582 = $581 & 1; //@line 131094 "c/sqlite3.c"
          $583 = ($582|0)==(0); //@line 131094 "c/sqlite3.c"
          if (!($583)) {
           $$0949 = $579;
           break;
          }
          HEAP32[$567>>2] = $579; //@line 131095 "c/sqlite3.c"
          $$0949 = $$3970;
         }
        } while(0);
        $584 = (_sqlite3WhereBegin($5,$$0989,$$0949,0,0,$560,$474)|0); //@line 131100 "c/sqlite3.c"
        $585 = ($584|0)==(0|0); //@line 131103 "c/sqlite3.c"
        if ($585) {
         $$3976 = $$09731054;$$3988 = $$09851053;
         break;
        }
        $586 = ((($584)) + 752|0); //@line 131106 "c/sqlite3.c"
        $587 = HEAP8[$15>>0]|0; //@line 131106 "c/sqlite3.c"
        $588 = $587&255; //@line 131106 "c/sqlite3.c"
        _sqlite3WhereExplainOneScan($5,$$0989,$586,$1,$588,0); //@line 131105 "c/sqlite3.c"
        $589 = HEAP16[$510>>1]|0; //@line 131115 "c/sqlite3.c"
        $590 = $589 & 16; //@line 131115 "c/sqlite3.c"
        $591 = ($590<<16>>16)==(0); //@line 131115 "c/sqlite3.c"
        do {
         if ($591) {
          $592 = HEAP32[$561>>2]|0; //@line 131117 "c/sqlite3.c"
          $593 = (($592) + -1)|0; //@line 131117 "c/sqlite3.c"
          $594 = ($$09721055|0)==($593|0); //@line 131117 "c/sqlite3.c"
          $595 = $594 ? -1 : $$09721055; //@line 131117 "c/sqlite3.c"
          $596 = HEAP32[$568>>2]|0; //@line 131118 "c/sqlite3.c"
          $597 = $596 & 32; //@line 131118 "c/sqlite3.c"
          $598 = ($597|0)==(0); //@line 131118 "c/sqlite3.c"
          if ($598) {
           $599 = (_sqlite3ExprCodeGetColumn($5,$481,-1,$20,$$0979,0)|0); //@line 131119 "c/sqlite3.c"
           $600 = (_sqlite3VdbeAddOp4Int($7,45,$$1981,0,$599,$595)|0); //@line 131120 "c/sqlite3.c"
           $$2948 = $600;
          } else {
           $601 = (_sqlite3PrimaryKeyIndex($481)|0); //@line 131124 "c/sqlite3.c"
           $602 = ((($601)) + 50|0); //@line 131125 "c/sqlite3.c"
           $603 = HEAP16[$602>>1]|0; //@line 131125 "c/sqlite3.c"
           $604 = $603&65535; //@line 131125 "c/sqlite3.c"
           $605 = (_sqlite3GetTempRange($5,$604)|0); //@line 131129 "c/sqlite3.c"
           $606 = ($603<<16>>16)==(0); //@line 131130 "c/sqlite3.c"
           if (!($606)) {
            $607 = ((($601)) + 4|0);
            $$09391049 = 0;
            while(1) {
             $608 = HEAP32[$607>>2]|0; //@line 131131 "c/sqlite3.c"
             $609 = (($608) + ($$09391049<<1)|0); //@line 131131 "c/sqlite3.c"
             $610 = HEAP16[$609>>1]|0; //@line 131131 "c/sqlite3.c"
             $611 = $610 << 16 >> 16; //@line 131131 "c/sqlite3.c"
             $612 = (($$09391049) + ($605))|0; //@line 131132 "c/sqlite3.c"
             _sqlite3ExprCodeGetColumnToReg($5,$481,$611,$20,$612); //@line 131132 "c/sqlite3.c"
             $613 = (($$09391049) + 1)|0; //@line 131130 "c/sqlite3.c"
             $exitcond = ($613|0)==($604|0); //@line 131130 "c/sqlite3.c"
             if ($exitcond) {
              break;
             } else {
              $$09391049 = $613;
             }
            }
           }
           $614 = ($595|0)!=(0); //@line 131146 "c/sqlite3.c"
           if ($614) {
            $615 = (_sqlite3VdbeAddOp4Int($7,30,$$1981,0,$605,$604)|0); //@line 131147 "c/sqlite3.c"
            $616 = ($595|0)>(-1); //@line 131150 "c/sqlite3.c"
            if ($616) {
             $$09461028 = $615;
             label = 166;
            } else {
             $$09461027 = $615;
            }
           } else {
            $$09461028 = 0;
            label = 166;
           }
           do {
            if ((label|0) == 166) {
             label = 0;
             (_sqlite3VdbeAddOp3($7,100,$605,$604,$$0979)|0); //@line 131151 "c/sqlite3.c"
             (_sqlite3VdbeAddOp4Int($7,128,$$1981,$$0979,$605,$604)|0); //@line 131152 "c/sqlite3.c"
             if (!($614)) {
              $$09461027 = $$09461028;
              break;
             }
             _sqlite3VdbeChangeP5($7,16); //@line 131154 "c/sqlite3.c"
             $$09461027 = $$09461028;
            }
           } while(0);
           _sqlite3ReleaseTempRange($5,$605,$604); //@line 131158 "c/sqlite3.c"
           $$2948 = $$09461027;
          }
          (_sqlite3VdbeAddOp2($7,14,$478,$479)|0); //@line 131163 "c/sqlite3.c"
          $617 = ($$2948|0)==(0); //@line 131167 "c/sqlite3.c"
          if ($617) {
           break;
          }
          _sqlite3VdbeJumpHere($7,$$2948); //@line 131167 "c/sqlite3.c"
         } else {
          (_sqlite3VdbeAddOp2($7,14,$478,$479)|0); //@line 131163 "c/sqlite3.c"
         }
        } while(0);
        $618 = ((($584)) + 50|0); //@line 131174 "c/sqlite3.c"
        $619 = HEAP8[$618>>0]|0; //@line 131174 "c/sqlite3.c"
        $620 = ($619<<24>>24)==(0); //@line 131174 "c/sqlite3.c"
        $spec$select1018 = $620 ? $$09731054 : 1; //@line 131174 "c/sqlite3.c"
        $621 = ((($584)) + 816|0); //@line 131188 "c/sqlite3.c"
        $622 = HEAP32[$621>>2]|0; //@line 131188 "c/sqlite3.c"
        $623 = ((($622)) + 36|0); //@line 131190 "c/sqlite3.c"
        $624 = HEAP32[$623>>2]|0; //@line 131190 "c/sqlite3.c"
        $625 = $624 & 512; //@line 131190 "c/sqlite3.c"
        $626 = ($625|0)==(0); //@line 131190 "c/sqlite3.c"
        do {
         if ($626) {
          $$1986 = 0;
         } else {
          $627 = ($$09721055|0)==(0); //@line 131191 "c/sqlite3.c"
          if (!($627)) {
           $628 = ((($622)) + 32|0); //@line 131191 "c/sqlite3.c"
           $629 = HEAP32[$628>>2]|0; //@line 131191 "c/sqlite3.c"
           $630 = ($629|0)==($$09851053|0); //@line 131191 "c/sqlite3.c"
           if (!($630)) {
            $$1986 = 0;
            break;
           }
          }
          $631 = HEAP32[$569>>2]|0; //@line 131192 "c/sqlite3.c"
          $632 = $631 & 32; //@line 131192 "c/sqlite3.c"
          $633 = ($632|0)==(0); //@line 131192 "c/sqlite3.c"
          if (!($633)) {
           $634 = ((($622)) + 32|0); //@line 131192 "c/sqlite3.c"
           $635 = HEAP32[$634>>2]|0; //@line 131192 "c/sqlite3.c"
           $636 = ((($635)) + 55|0); //@line 131192 "c/sqlite3.c"
           $637 = HEAPU8[$636>>0]|(HEAPU8[$636+1>>0]<<8); //@line 131192 "c/sqlite3.c"
           $638 = $637 & 3; //@line 131192 "c/sqlite3.c"
           $639 = ($638<<16>>16)==(2); //@line 131192 "c/sqlite3.c"
           if ($639) {
            $$1986 = 0;
            break;
           }
          }
          $640 = ((($622)) + 32|0); //@line 131195 "c/sqlite3.c"
          $641 = HEAP32[$640>>2]|0; //@line 131195 "c/sqlite3.c"
          $$1986 = $641;
         }
        } while(0);
        _sqlite3WhereEnd($584); //@line 131201 "c/sqlite3.c"
        $$3976 = $spec$select1018;$$3988 = $$1986;
       }
      } while(0);
      $642 = (($$09721055) + 1)|0; //@line 131088 "c/sqlite3.c"
      $643 = HEAP32[$561>>2]|0; //@line 131088 "c/sqlite3.c"
      $644 = ($642|0)<($643|0); //@line 131088 "c/sqlite3.c"
      if ($644) {
       $$09721055 = $642;$$09731054 = $$3976;$$09851053 = $$3988;
      } else {
       break;
      }
     }
     $645 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 56|0); //@line 131205 "c/sqlite3.c"
     HEAP32[$645>>2] = $$3988; //@line 131205 "c/sqlite3.c"
     $646 = ($$3988|0)==(0|0); //@line 131206 "c/sqlite3.c"
     if ($646) {
      $$0973$lcssa1097 = $$3976;
     } else {
      $647 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 8|0); //@line 131206 "c/sqlite3.c"
      HEAP32[$647>>2] = $474; //@line 131206 "c/sqlite3.c"
      $$0973$lcssa1097 = $$3976;
     }
    } else {
     $564 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 56|0); //@line 131205 "c/sqlite3.c"
     HEAP32[$564>>2] = 0; //@line 131205 "c/sqlite3.c"
     $$0973$lcssa1097 = 0;
    }
    $648 = ($$3970|0)==(0|0); //@line 131207 "c/sqlite3.c"
    if (!($648)) {
     $649 = ((($$3970)) + 12|0); //@line 131208 "c/sqlite3.c"
     HEAP32[$649>>2] = 0; //@line 131208 "c/sqlite3.c"
     _sqlite3ExprDelete($9,$$3970); //@line 131209 "c/sqlite3.c"
    }
    $650 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 131211 "c/sqlite3.c"
    _sqlite3VdbeChangeP1($7,$528,$650); //@line 131211 "c/sqlite3.c"
    $651 = HEAP32[$53>>2]|0; //@line 131212 "c/sqlite3.c"
    _sqlite3VdbeGoto($7,$651); //@line 131212 "c/sqlite3.c"
    _sqlite3VdbeResolveLabel($7,$479); //@line 131213 "c/sqlite3.c"
    $652 = HEAP8[$489>>0]|0; //@line 131215 "c/sqlite3.c"
    $653 = ($652&255)>(1); //@line 131215 "c/sqlite3.c"
    if ($653) {
     _sqlite3DbFree($9,$654); //@line 131215 "c/sqlite3.c"
    }
    $655 = ($$0973$lcssa1097|0)==(0); //@line 131216 "c/sqlite3.c"
    if (!($655)) {
     $$1941 = 0;
     break;
    }
    _disableTerm($10,$484); //@line 131216 "c/sqlite3.c"
    $$1941 = 0;
    break;
   } else {
    $256 = ((($12)) + 24|0); //@line 130669 "c/sqlite3.c"
    $257 = HEAP16[$256>>1]|0; //@line 130669 "c/sqlite3.c"
    $258 = ((($12)) + 26|0); //@line 130670 "c/sqlite3.c"
    $259 = HEAP16[$258>>1]|0; //@line 130670 "c/sqlite3.c"
    $260 = ((($12)) + 28|0); //@line 130671 "c/sqlite3.c"
    $261 = HEAP16[$260>>1]|0; //@line 130671 "c/sqlite3.c"
    $262 = ((($12)) + 32|0); //@line 130687 "c/sqlite3.c"
    $263 = HEAP32[$262>>2]|0; //@line 130687 "c/sqlite3.c"
    $264 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 8|0); //@line 130688 "c/sqlite3.c"
    $265 = HEAP32[$264>>2]|0; //@line 130688 "c/sqlite3.c"
    $266 = ((($0)) + 44|0); //@line 130702 "c/sqlite3.c"
    $267 = HEAP16[$266>>1]|0; //@line 130702 "c/sqlite3.c"
    $268 = $267 & 1; //@line 130702 "c/sqlite3.c"
    $269 = ($268<<16>>16)==(0); //@line 130702 "c/sqlite3.c"
    if ($269) {
     $$01003 = 0;$$0999 = 0;
    } else {
     $270 = ((($0)) + 47|0); //@line 130703 "c/sqlite3.c"
     $271 = HEAP8[$270>>0]|0; //@line 130703 "c/sqlite3.c"
     $272 = ($271<<24>>24)>(0); //@line 130703 "c/sqlite3.c"
     if ($272) {
      $273 = ((($263)) + 50|0); //@line 130704 "c/sqlite3.c"
      $274 = HEAP16[$273>>1]|0; //@line 130704 "c/sqlite3.c"
      $275 = ($274&65535)>($257&65535); //@line 130704 "c/sqlite3.c"
      $spec$select1012 = $275&1; //@line 130702 "c/sqlite3.c"
      $spec$select1013 = $275&1; //@line 130702 "c/sqlite3.c"
      $$01003 = $spec$select1012;$$0999 = $spec$select1013;
     } else {
      $$01003 = 0;$$0999 = 0;
     }
    }
    $276 = $257&65535; //@line 130714 "c/sqlite3.c"
    $277 = $84 & 32; //@line 130715 "c/sqlite3.c"
    $278 = ($277|0)==(0); //@line 130715 "c/sqlite3.c"
    $279 = $259&65535; //@line 130717 "c/sqlite3.c"
    if ($278) {
     $$0983 = 0;$$11000 = $$0999;$$4 = $276;
    } else {
     $280 = ($$0999>>>0)>($279>>>0); //@line 130717 "c/sqlite3.c"
     $$0999$ = $280 ? $$0999 : $279; //@line 130717 "c/sqlite3.c"
     $281 = (($276) + 1)|0; //@line 130716 "c/sqlite3.c"
     $282 = ((($12)) + 48|0); //@line 130716 "c/sqlite3.c"
     $283 = HEAP32[$282>>2]|0; //@line 130716 "c/sqlite3.c"
     $284 = (($283) + ($276<<2)|0); //@line 130716 "c/sqlite3.c"
     $285 = HEAP32[$284>>2]|0; //@line 130716 "c/sqlite3.c"
     $$0983 = $285;$$11000 = $$0999$;$$4 = $281;
    }
    $286 = $84 & 16; //@line 130722 "c/sqlite3.c"
    $287 = ($286|0)==(0); //@line 130722 "c/sqlite3.c"
    do {
     if ($287) {
      $$0990 = 0;$$11004 = $$01003;$$21001 = $$11000;
     } else {
      $288 = ((($12)) + 48|0); //@line 130723 "c/sqlite3.c"
      $289 = HEAP32[$288>>2]|0; //@line 130723 "c/sqlite3.c"
      $290 = (($289) + ($$4<<2)|0); //@line 130723 "c/sqlite3.c"
      $291 = HEAP32[$290>>2]|0; //@line 130723 "c/sqlite3.c"
      $292 = $261&65535; //@line 130724 "c/sqlite3.c"
      $293 = ($$11000|0)>($292|0); //@line 130724 "c/sqlite3.c"
      $$11000$ = $293 ? $$11000 : $292; //@line 130724 "c/sqlite3.c"
      $294 = ((($291)) + 10|0); //@line 130726 "c/sqlite3.c"
      $295 = HEAP16[$294>>1]|0; //@line 130726 "c/sqlite3.c"
      $296 = $295 & 256; //@line 130726 "c/sqlite3.c"
      $297 = ($296<<16>>16)==(0); //@line 130726 "c/sqlite3.c"
      if (!($297)) {
       $298 = ((($5)) + 44|0); //@line 130729 "c/sqlite3.c"
       $299 = HEAP32[$298>>2]|0; //@line 130729 "c/sqlite3.c"
       $300 = (($299) + 1)|0; //@line 130729 "c/sqlite3.c"
       HEAP32[$298>>2] = $300; //@line 130729 "c/sqlite3.c"
       $301 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 36|0); //@line 130729 "c/sqlite3.c"
       HEAP32[$301>>2] = $300; //@line 130729 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($7,67,1,$300)|0); //@line 130730 "c/sqlite3.c"
       $302 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 130732 "c/sqlite3.c"
       $303 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 40|0); //@line 130732 "c/sqlite3.c"
       HEAP32[$303>>2] = $302; //@line 130732 "c/sqlite3.c"
       $304 = HEAP32[$301>>2]|0; //@line 130738 "c/sqlite3.c"
       $305 = $304 << 1; //@line 130738 "c/sqlite3.c"
       HEAP32[$301>>2] = $305; //@line 130738 "c/sqlite3.c"
       $306 = ((($263)) + 28|0); //@line 130739 "c/sqlite3.c"
       $307 = HEAP32[$306>>2]|0; //@line 130739 "c/sqlite3.c"
       $308 = (($307) + ($276)|0); //@line 130739 "c/sqlite3.c"
       $309 = HEAP8[$308>>0]|0; //@line 130739 "c/sqlite3.c"
       $310 = ($309<<24>>24)==(1); //@line 130739 "c/sqlite3.c"
       $311 = $310&1; //@line 130739 "c/sqlite3.c"
       $312 = $42 ^ $311; //@line 130739 "c/sqlite3.c"
       $313 = $312 | $305; //@line 130739 "c/sqlite3.c"
       HEAP32[$301>>2] = $313; //@line 130739 "c/sqlite3.c"
      }
      $314 = ($$0983|0)==(0|0); //@line 130742 "c/sqlite3.c"
      if ($314) {
       $315 = ((($263)) + 4|0); //@line 130743 "c/sqlite3.c"
       $316 = HEAP32[$315>>2]|0; //@line 130743 "c/sqlite3.c"
       $317 = (($316) + ($276<<1)|0); //@line 130743 "c/sqlite3.c"
       $318 = HEAP16[$317>>1]|0; //@line 130743 "c/sqlite3.c"
       $319 = ($318<<16>>16)>(-1); //@line 130744 "c/sqlite3.c"
       if ($319) {
        $320 = $318 << 16 >> 16; //@line 130743 "c/sqlite3.c"
        $321 = ((($263)) + 12|0); //@line 130744 "c/sqlite3.c"
        $322 = HEAP32[$321>>2]|0; //@line 130744 "c/sqlite3.c"
        $323 = ((($322)) + 4|0); //@line 130744 "c/sqlite3.c"
        $324 = HEAP32[$323>>2]|0; //@line 130744 "c/sqlite3.c"
        $325 = (((($324) + ($320<<4)|0)) + 12|0); //@line 130744 "c/sqlite3.c"
        $326 = HEAP8[$325>>0]|0; //@line 130744 "c/sqlite3.c"
        $327 = ($326<<24>>24)==(0); //@line 130744 "c/sqlite3.c"
        if (!($327)) {
         $$0990 = $291;$$11004 = $$01003;$$21001 = $$11000$;
         break;
        }
       } else {
        $$old2 = ($318<<16>>16)==(-2); //@line 130744 "c/sqlite3.c"
        if (!($$old2)) {
         $$0990 = $291;$$11004 = $$01003;$$21001 = $$11000$;
         break;
        }
       }
       $$0990 = $291;$$11004 = 1;$$21001 = $$11000$;
      } else {
       $$0990 = $291;$$11004 = $$01003;$$21001 = $$11000$;
      }
     }
    } while(0);
    $328 = ((($263)) + 50|0); //@line 130755 "c/sqlite3.c"
    $329 = HEAP16[$328>>1]|0; //@line 130755 "c/sqlite3.c"
    $330 = ($257&65535)<($329&65535); //@line 130755 "c/sqlite3.c"
    if ($330) {
     $331 = ((($263)) + 28|0); //@line 130755 "c/sqlite3.c"
     $332 = HEAP32[$331>>2]|0; //@line 130755 "c/sqlite3.c"
     $333 = (($332) + ($276)|0); //@line 130755 "c/sqlite3.c"
     $334 = HEAP8[$333>>0]|0; //@line 130755 "c/sqlite3.c"
     $335 = ($334<<24>>24)==(0); //@line 130755 "c/sqlite3.c"
     $336 = $40 & 1; //@line 130755 "c/sqlite3.c"
     $337 = ($336|0)!=(0); //@line 130755 "c/sqlite3.c"
     $338 = (0)!=(0); //@line 130755 "c/sqlite3.c"
     $339 = $337 | $338; //@line 130755 "c/sqlite3.c"
     $340 = $339 ^ $335; //@line 130755 "c/sqlite3.c"
     if ($340) {
      label = 74;
     } else {
      label = 75;
     }
    } else {
     label = 74;
    }
    if ((label|0) == 74) {
     $341 = ($42|0)!=(0); //@line 130756 "c/sqlite3.c"
     $342 = ($329<<16>>16)==($257<<16>>16); //@line 130756 "c/sqlite3.c"
     $or$cond1034 = $341 & $342; //@line 130756 "c/sqlite3.c"
     if ($or$cond1034) {
      label = 75;
     } else {
      $$01002 = 0;$$0978 = $259;$$0982 = $261;$$1984 = $$0983;$$1991 = $$0990;$$21005 = $$11004;
     }
    }
    if ((label|0) == 75) {
     $343 = $259 & 255; //@line 130760 "c/sqlite3.c"
     $$01002 = $$11004;$$0978 = $261;$$0982 = $343;$$1984 = $$0990;$$1991 = $$0983;$$21005 = 0;
    }
    $344 = (_codeAllEqualityTerms($5,$10,$42,$$21001,$4)|0); //@line 130768 "c/sqlite3.c"
    $345 = HEAP32[$4>>2]|0; //@line 130770 "c/sqlite3.c"
    $346 = ($345|0)==(0|0); //@line 130770 "c/sqlite3.c"
    $347 = ($$0982<<16>>16)==(0); //@line 130770 "c/sqlite3.c"
    $or$cond1014 = $347 | $346; //@line 130770 "c/sqlite3.c"
    if ($or$cond1014) {
     $$01007 = 0;
    } else {
     $348 = (($345) + ($276)|0); //@line 130771 "c/sqlite3.c"
     $349 = (_sqlite3DbStrDup($9,$348)|0); //@line 130771 "c/sqlite3.c"
     $$01007 = $349;
    }
    $350 = HEAP32[$52>>2]|0; //@line 130773 "c/sqlite3.c"
    $351 = ($$1984|0)!=(0|0); //@line 130779 "c/sqlite3.c"
    if ($351) {
     $352 = ((($$1984)) + 12|0); //@line 130779 "c/sqlite3.c"
     $353 = HEAP16[$352>>1]|0; //@line 130779 "c/sqlite3.c"
     $354 = $353 & 40; //@line 130779 "c/sqlite3.c"
     $355 = ($354<<16>>16)!=(0); //@line 130779 "c/sqlite3.c"
     $357 = $355;
    } else {
     $357 = 1;
    }
    $356 = $357&1; //@line 130779 "c/sqlite3.c"
    $358 = ($$1991|0)!=(0|0); //@line 130780 "c/sqlite3.c"
    if ($358) {
     $359 = ((($$1991)) + 12|0); //@line 130780 "c/sqlite3.c"
     $360 = HEAP16[$359>>1]|0; //@line 130780 "c/sqlite3.c"
     $361 = $360 & 40; //@line 130780 "c/sqlite3.c"
     $362 = ($361<<16>>16)!=(0); //@line 130780 "c/sqlite3.c"
     $364 = $362;
    } else {
     $364 = 1;
    }
    $363 = $364&1; //@line 130780 "c/sqlite3.c"
    $365 = ($257<<16>>16)!=(0); //@line 130781 "c/sqlite3.c"
    $366 = $365 | $351; //@line 130781 "c/sqlite3.c"
    $367 = $366&1; //@line 130781 "c/sqlite3.c"
    do {
     if ($351) {
      $368 = HEAP32[$$1984>>2]|0; //@line 130786 "c/sqlite3.c"
      $369 = ((($368)) + 16|0); //@line 130786 "c/sqlite3.c"
      $370 = HEAP32[$369>>2]|0; //@line 130786 "c/sqlite3.c"
      $371 = (($344) + ($276))|0; //@line 130787 "c/sqlite3.c"
      $372 = $$0978&65535; //@line 130787 "c/sqlite3.c"
      _codeExprOrVector($5,$370,$371,$372); //@line 130787 "c/sqlite3.c"
      _whereLikeOptimizationStringFixup($7,$10,$$1984); //@line 130788 "c/sqlite3.c"
      $373 = (_sqlite3ExprCanBeNull($370)|0); //@line 130790 "c/sqlite3.c"
      $374 = ($373|0)==(0); //@line 130790 "c/sqlite3.c"
      if (!($374)) {
       (_sqlite3VdbeAddOp2($7,50,$371,$350)|0); //@line 130792 "c/sqlite3.c"
      }
      if (!($346)) {
       $375 = (($345) + ($276)|0); //@line 130796 "c/sqlite3.c"
       _updateRangeAffinityStr($370,$372,$375); //@line 130796 "c/sqlite3.c"
      }
      $376 = (($372) + ($276))|0; //@line 130798 "c/sqlite3.c"
      $377 = (_sqlite3ExprIsVector($370)|0); //@line 130800 "c/sqlite3.c"
      $378 = ($377|0)==(0); //@line 130800 "c/sqlite3.c"
      if (!($378)) {
       $$0996 = $367;$$0997 = $376;$$1993 = 1;$$31006 = 0;
       break;
      }
      _disableTerm($10,$$1984); //@line 130801 "c/sqlite3.c"
      $$0996 = $367;$$0997 = $376;$$1993 = $356;$$31006 = 0;
     } else {
      $379 = ($$21005<<24>>24)==(0); //@line 130806 "c/sqlite3.c"
      if ($379) {
       $$0996 = $367;$$0997 = $276;$$1993 = $356;$$31006 = 0;
      } else {
       $380 = (($276) + 1)|0; //@line 130808 "c/sqlite3.c"
       $381 = (($344) + ($276))|0; //@line 130807 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($7,70,0,$381)|0); //@line 130807 "c/sqlite3.c"
       $$0996 = 1;$$0997 = $380;$$1993 = 0;$$31006 = 1;
      }
     }
    } while(0);
    $382 = (($$0997) - ($$31006))|0; //@line 130812 "c/sqlite3.c"
    $383 = HEAP32[$4>>2]|0; //@line 130812 "c/sqlite3.c"
    _codeApplyAffinity($5,$344,$382,$383); //@line 130812 "c/sqlite3.c"
    $384 = ((($12)) + 42|0); //@line 130813 "c/sqlite3.c"
    $385 = HEAP16[$384>>1]|0; //@line 130813 "c/sqlite3.c"
    $386 = ($385<<16>>16)!=(0); //@line 130813 "c/sqlite3.c"
    $387 = $385&65535; //@line 130813 "c/sqlite3.c"
    $388 = ($$0997|0)==($387|0); //@line 130813 "c/sqlite3.c"
    $or$cond1016 = $386 & $388; //@line 130813 "c/sqlite3.c"
    if (!($or$cond1016)) {
     $389 = $$0996 << 2; //@line 130818 "c/sqlite3.c"
     $390 = $$1993 << 1; //@line 130818 "c/sqlite3.c"
     $391 = $389 | $42; //@line 130818 "c/sqlite3.c"
     $392 = $391 | $390; //@line 130818 "c/sqlite3.c"
     $393 = (27363 + ($392)|0); //@line 130818 "c/sqlite3.c"
     $394 = HEAP8[$393>>0]|0; //@line 130818 "c/sqlite3.c"
     $395 = $394&255; //@line 130818 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4Int($7,$395,$265,$350,$344,$$0997)|0); //@line 130820 "c/sqlite3.c"
    }
    do {
     if ($358) {
      $396 = HEAP32[$$1991>>2]|0; //@line 130835 "c/sqlite3.c"
      $397 = ((($396)) + 16|0); //@line 130835 "c/sqlite3.c"
      $398 = HEAP32[$397>>2]|0; //@line 130835 "c/sqlite3.c"
      $399 = (($344) + ($276))|0; //@line 130836 "c/sqlite3.c"
      _sqlite3ExprCacheRemove($5,$399,1); //@line 130836 "c/sqlite3.c"
      $400 = $$0982&65535; //@line 130837 "c/sqlite3.c"
      _codeExprOrVector($5,$398,$399,$400); //@line 130837 "c/sqlite3.c"
      _whereLikeOptimizationStringFixup($7,$10,$$1991); //@line 130838 "c/sqlite3.c"
      $401 = (_sqlite3ExprCanBeNull($398)|0); //@line 130840 "c/sqlite3.c"
      $402 = ($401|0)==(0); //@line 130840 "c/sqlite3.c"
      if (!($402)) {
       (_sqlite3VdbeAddOp2($7,50,$399,$350)|0); //@line 130842 "c/sqlite3.c"
      }
      $403 = ($$01007|0)==(0|0); //@line 130845 "c/sqlite3.c"
      if (!($403)) {
       _updateRangeAffinityStr($398,$400,$$01007); //@line 130846 "c/sqlite3.c"
       _codeApplyAffinity($5,$399,$400,$$01007); //@line 130847 "c/sqlite3.c"
      }
      $404 = (($400) + ($276))|0; //@line 130851 "c/sqlite3.c"
      $405 = (_sqlite3ExprIsVector($398)|0); //@line 130854 "c/sqlite3.c"
      $406 = ($405|0)==(0); //@line 130854 "c/sqlite3.c"
      if (!($406)) {
       $$1995 = 1;$$1998 = $404;
       break;
      }
      _disableTerm($10,$$1991); //@line 130855 "c/sqlite3.c"
      $$1995 = $363;$$1998 = $404;
     } else {
      $407 = ($$01002<<24>>24)==(0); //@line 130859 "c/sqlite3.c"
      $408 = (($344) + ($276))|0; //@line 130860 "c/sqlite3.c"
      if ($407) {
       $$1995 = $363;$$1998 = $276;
       break;
      }
      $409 = (($276) + 1)|0; //@line 130863 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($7,70,0,$408)|0); //@line 130860 "c/sqlite3.c"
      _sqlite3ExprCacheRemove($5,$408,1); //@line 130861 "c/sqlite3.c"
      $$1995 = 0;$$1998 = $409;
     }
    } while(0);
    $410 = HEAP32[$4>>2]|0; //@line 130865 "c/sqlite3.c"
    _sqlite3DbFree($9,$410); //@line 130865 "c/sqlite3.c"
    _sqlite3DbFree($9,$$01007); //@line 130866 "c/sqlite3.c"
    $411 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 130869 "c/sqlite3.c"
    $412 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 52|0); //@line 130869 "c/sqlite3.c"
    HEAP32[$412>>2] = $411; //@line 130869 "c/sqlite3.c"
    $413 = ($$1998|0)==(0); //@line 130872 "c/sqlite3.c"
    if (!($413)) {
     $414 = $42 << 1; //@line 130873 "c/sqlite3.c"
     $415 = $$1995 | $414; //@line 130873 "c/sqlite3.c"
     $416 = (27371 + ($415)|0); //@line 130873 "c/sqlite3.c"
     $417 = HEAP8[$416>>0]|0; //@line 130873 "c/sqlite3.c"
     $418 = $417&255; //@line 130873 "c/sqlite3.c"
     (_sqlite3VdbeAddOp4Int($7,$418,$265,$350,$344,$$1998)|0); //@line 130874 "c/sqlite3.c"
    }
    L241: do {
     if (!($470)) {
      $419 = ((($263)) + 12|0); //@line 130884 "c/sqlite3.c"
      $420 = HEAP32[$419>>2]|0; //@line 130884 "c/sqlite3.c"
      $421 = ((($420)) + 36|0); //@line 130884 "c/sqlite3.c"
      $422 = HEAP32[$421>>2]|0; //@line 130884 "c/sqlite3.c"
      $423 = $422 & 32; //@line 130884 "c/sqlite3.c"
      $424 = ($423|0)==(0); //@line 130884 "c/sqlite3.c"
      if ($424) {
       $425 = HEAP16[$266>>1]|0; //@line 130885 "c/sqlite3.c"
       $426 = $425&65535; //@line 130885 "c/sqlite3.c"
       $427 = $426 & 1024; //@line 130885 "c/sqlite3.c"
       $428 = ($427|0)==(0); //@line 130885 "c/sqlite3.c"
       do {
        if ($428) {
         $429 = $426 & 4096; //@line 130886 "c/sqlite3.c"
         $430 = ($429|0)==(0); //@line 130886 "c/sqlite3.c"
         if (!($430)) {
          $431 = ((($0)) + 49|0); //@line 130887 "c/sqlite3.c"
          $432 = HEAP8[$431>>0]|0; //@line 130887 "c/sqlite3.c"
          $433 = ($432<<24>>24)==(1); //@line 130887 "c/sqlite3.c"
          if ($433) {
           break;
          }
         }
         _codeDeferredSeek($0,$263,$20,$265); //@line 130895 "c/sqlite3.c"
         break L241;
        }
       } while(0);
       $434 = ((($5)) + 44|0); //@line 130889 "c/sqlite3.c"
       $435 = HEAP32[$434>>2]|0; //@line 130889 "c/sqlite3.c"
       $436 = (($435) + 1)|0; //@line 130889 "c/sqlite3.c"
       HEAP32[$434>>2] = $436; //@line 130889 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($7,131,$265,$436)|0); //@line 130890 "c/sqlite3.c"
       _sqlite3ExprCacheStore($5,$20,-1,$436); //@line 130891 "c/sqlite3.c"
       (_sqlite3VdbeAddOp3($7,32,$20,0,$436)|0); //@line 130892 "c/sqlite3.c"
       break;
      }
      $437 = ($20|0)==($265|0); //@line 130897 "c/sqlite3.c"
      if ($437) {
       break;
      }
      $438 = (_sqlite3PrimaryKeyIndex($420)|0); //@line 130898 "c/sqlite3.c"
      $439 = ((($438)) + 50|0); //@line 130899 "c/sqlite3.c"
      $440 = HEAP16[$439>>1]|0; //@line 130899 "c/sqlite3.c"
      $441 = $440&65535; //@line 130899 "c/sqlite3.c"
      $442 = (_sqlite3GetTempRange($5,$441)|0); //@line 130899 "c/sqlite3.c"
      $443 = HEAP16[$439>>1]|0; //@line 130900 "c/sqlite3.c"
      $444 = ($443<<16>>16)==(0); //@line 130900 "c/sqlite3.c"
      if ($444) {
       $$lcssa1036 = 0;
      } else {
       $445 = ((($438)) + 4|0);
       $$51071 = 0;
       while(1) {
        $446 = HEAP32[$445>>2]|0; //@line 130901 "c/sqlite3.c"
        $447 = (($446) + ($$51071<<1)|0); //@line 130901 "c/sqlite3.c"
        $448 = HEAP16[$447>>1]|0; //@line 130901 "c/sqlite3.c"
        $449 = (_sqlite3ColumnOfIndex($263,$448)|0); //@line 130901 "c/sqlite3.c"
        $450 = $449 << 16 >> 16; //@line 130901 "c/sqlite3.c"
        $451 = (($$51071) + ($442))|0; //@line 130902 "c/sqlite3.c"
        (_sqlite3VdbeAddOp3($7,98,$265,$450,$451)|0); //@line 130902 "c/sqlite3.c"
        $452 = (($$51071) + 1)|0; //@line 130900 "c/sqlite3.c"
        $453 = HEAP16[$439>>1]|0; //@line 130900 "c/sqlite3.c"
        $454 = $453&65535; //@line 130900 "c/sqlite3.c"
        $455 = ($452>>>0)<($454>>>0); //@line 130900 "c/sqlite3.c"
        if ($455) {
         $$51071 = $452;
        } else {
         break;
        }
       }
       $456 = $453&65535; //@line 130900 "c/sqlite3.c"
       $$lcssa1036 = $456;
      }
      (_sqlite3VdbeAddOp4Int($7,29,$20,$54,$442,$$lcssa1036)|0); //@line 130904 "c/sqlite3.c"
     }
    } while(0);
    _whereIndexExprTrans($263,$20,$265,$0); //@line 130912 "c/sqlite3.c"
    $457 = HEAP32[$43>>2]|0; //@line 130916 "c/sqlite3.c"
    $458 = $457 & 4096; //@line 130916 "c/sqlite3.c"
    $459 = ($458|0)==(0); //@line 130916 "c/sqlite3.c"
    do {
     if ($459) {
      $461 = ($42|0)==(0); //@line 130918 "c/sqlite3.c"
      $462 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0);
      if ($461) {
       HEAP8[$462>>0] = 7; //@line 130921 "c/sqlite3.c"
       break;
      } else {
       HEAP8[$462>>0] = 6; //@line 130919 "c/sqlite3.c"
       break;
      }
     } else {
      $460 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 130917 "c/sqlite3.c"
      HEAP8[$460>>0] = -88; //@line 130917 "c/sqlite3.c"
     }
    } while(0);
    $463 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 48|0); //@line 130923 "c/sqlite3.c"
    HEAP32[$463>>2] = $265; //@line 130923 "c/sqlite3.c"
    $464 = $457 >>> 16; //@line 130924 "c/sqlite3.c"
    $$lobit = $464 & 1; //@line 130924 "c/sqlite3.c"
    $465 = $$lobit&255; //@line 130924 "c/sqlite3.c"
    $466 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 46|0); //@line 130924 "c/sqlite3.c"
    HEAP8[$466>>0] = $465; //@line 130924 "c/sqlite3.c"
    $467 = $457 & 15; //@line 130925 "c/sqlite3.c"
    $468 = ($467|0)==(0); //@line 130925 "c/sqlite3.c"
    if ($468) {
     $469 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 47|0); //@line 130926 "c/sqlite3.c"
     HEAP8[$469>>0] = 1; //@line 130926 "c/sqlite3.c"
    }
    $spec$select1017 = $470 ? 0 : $263; //@line 130930 "c/sqlite3.c"
    $$1941 = $spec$select1017;
    break;
   }
  } else {
   $77 = (((((($14)) + 8|0) + (($17*72)|0)|0)) + 28|0); //@line 130399 "c/sqlite3.c"
   $78 = HEAP32[$77>>2]|0; //@line 130399 "c/sqlite3.c"
   $79 = (((((($14)) + 8|0) + (($17*72)|0)|0)) + 24|0); //@line 130400 "c/sqlite3.c"
   $80 = HEAP32[$79>>2]|0; //@line 130400 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($7,15,$78,0,$80)|0); //@line 130400 "c/sqlite3.c"
   $81 = (_sqlite3VdbeAddOp2($7,16,$78,$51)|0); //@line 130401 "c/sqlite3.c"
   $82 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 52|0); //@line 130401 "c/sqlite3.c"
   HEAP32[$82>>2] = $81; //@line 130401 "c/sqlite3.c"
   $83 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 45|0); //@line 130404 "c/sqlite3.c"
   HEAP8[$83>>0] = 13; //@line 130404 "c/sqlite3.c"
   $$1941 = 0;
  }
 } while(0);
 $670 = ($$1941|0)==(0|0); //@line 131260 "c/sqlite3.c"
 $671 = $670 ? 2 : 1; //@line 131260 "c/sqlite3.c"
 $672 = ((($0)) + 100|0);
 $673 = ((($0)) + 92|0);
 $674 = ((($0)) + 50|0);
 $675 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 4|0);
 $676 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 36|0);
 $$0942 = $671;
 while(1) {
  $677 = HEAP32[$673>>2]|0; //@line 131263 "c/sqlite3.c"
  $678 = ($677|0)>(0); //@line 131263 "c/sqlite3.c"
  if (!($678)) {
   break;
  }
  $679 = HEAP32[$672>>2]|0; //@line 131263 "c/sqlite3.c"
  $680 = ($$0942|0)==(1);
  $681 = ($$0942|0)<(3);
  $$09331043 = 0;$$09361042 = $679;$$61045 = $677;
  while(1) {
   $682 = ((($$09361042)) + 10|0); //@line 131268 "c/sqlite3.c"
   $683 = HEAP16[$682>>1]|0; //@line 131268 "c/sqlite3.c"
   $684 = $683 & 6; //@line 131268 "c/sqlite3.c"
   $685 = ($684<<16>>16)==(0); //@line 131268 "c/sqlite3.c"
   do {
    if ($685) {
     $686 = ((($$09361042)) + 40|0); //@line 131269 "c/sqlite3.c"
     $687 = $686; //@line 131269 "c/sqlite3.c"
     $688 = $687; //@line 131269 "c/sqlite3.c"
     $689 = HEAP32[$688>>2]|0; //@line 131269 "c/sqlite3.c"
     $690 = (($687) + 4)|0; //@line 131269 "c/sqlite3.c"
     $691 = $690; //@line 131269 "c/sqlite3.c"
     $692 = HEAP32[$691>>2]|0; //@line 131269 "c/sqlite3.c"
     $693 = $28; //@line 131269 "c/sqlite3.c"
     $694 = $693; //@line 131269 "c/sqlite3.c"
     $695 = HEAP32[$694>>2]|0; //@line 131269 "c/sqlite3.c"
     $696 = (($693) + 4)|0; //@line 131269 "c/sqlite3.c"
     $697 = $696; //@line 131269 "c/sqlite3.c"
     $698 = HEAP32[$697>>2]|0; //@line 131269 "c/sqlite3.c"
     $699 = $695 & $689; //@line 131269 "c/sqlite3.c"
     $700 = $698 & $692; //@line 131269 "c/sqlite3.c"
     $701 = ($699|0)==(0); //@line 131269 "c/sqlite3.c"
     $702 = ($700|0)==(0); //@line 131269 "c/sqlite3.c"
     $703 = $701 & $702; //@line 131269 "c/sqlite3.c"
     if (!($703)) {
      HEAP8[$674>>0] = 1; //@line 131272 "c/sqlite3.c"
      $$2935 = $$09331043;
      break;
     }
     $704 = HEAP32[$$09361042>>2]|0; //@line 131275 "c/sqlite3.c"
     $705 = HEAP32[$10>>2]|0; //@line 131277 "c/sqlite3.c"
     $706 = ($705|0)==(0); //@line 131277 "c/sqlite3.c"
     if (!($706)) {
      $707 = ((($704)) + 4|0); //@line 131277 "c/sqlite3.c"
      $708 = HEAP32[$707>>2]|0; //@line 131277 "c/sqlite3.c"
      $709 = $708 & 1; //@line 131277 "c/sqlite3.c"
      $710 = ($709|0)==(0); //@line 131277 "c/sqlite3.c"
      if ($710) {
       $$2935 = $$09331043;
       break;
      }
     }
     if ($680) {
      $711 = HEAP32[$675>>2]|0; //@line 131281 "c/sqlite3.c"
      $712 = (_sqlite3ExprCoveredByIndex($704,$711,$$1941)|0); //@line 131281 "c/sqlite3.c"
      $713 = ($712|0)==(0); //@line 131281 "c/sqlite3.c"
      if ($713) {
       $$2935 = 2;
       break;
      } else {
       label = 201;
      }
     } else {
      if ($681) {
       label = 201;
      }
     }
     if ((label|0) == 201) {
      label = 0;
      $714 = HEAP16[$682>>1]|0; //@line 131285 "c/sqlite3.c"
      $715 = $714 & 4096; //@line 131285 "c/sqlite3.c"
      $716 = ($715<<16>>16)==(0); //@line 131285 "c/sqlite3.c"
      if (!($716)) {
       $717 = ($$09331043|0)==(0); //@line 131286 "c/sqlite3.c"
       $spec$select1019 = $717 ? 3 : $$09331043; //@line 131286 "c/sqlite3.c"
       $$2935 = $spec$select1019;
       break;
      }
     }
     $718 = HEAP16[$682>>1]|0; //@line 131290 "c/sqlite3.c"
     $719 = $718 & 512; //@line 131290 "c/sqlite3.c"
     $720 = ($719<<16>>16)==(0); //@line 131290 "c/sqlite3.c"
     if ($720) {
      _sqlite3ExprIfFalse($5,$704,$54,16); //@line 131311 "c/sqlite3.c"
     } else {
      $721 = HEAP32[$676>>2]|0; //@line 131299 "c/sqlite3.c"
      $722 = $721 & 1; //@line 131301 "c/sqlite3.c"
      $723 = (($722) + 21)|0; //@line 131301 "c/sqlite3.c"
      $724 = $721 >>> 1; //@line 131301 "c/sqlite3.c"
      $725 = (_sqlite3VdbeAddOp1($7,$723,$724)|0); //@line 131301 "c/sqlite3.c"
      _sqlite3ExprIfFalse($5,$704,$54,16); //@line 131311 "c/sqlite3.c"
      $726 = ($725|0)==(0); //@line 131312 "c/sqlite3.c"
      if (!($726)) {
       _sqlite3VdbeJumpHere($7,$725); //@line 131312 "c/sqlite3.c"
      }
     }
     $727 = HEAP16[$682>>1]|0; //@line 131313 "c/sqlite3.c"
     $728 = $727 | 4; //@line 131313 "c/sqlite3.c"
     HEAP16[$682>>1] = $728; //@line 131313 "c/sqlite3.c"
     $$2935 = $$09331043;
    } else {
     $$2935 = $$09331043;
    }
   } while(0);
   $729 = (($$61045) + -1)|0; //@line 131263 "c/sqlite3.c"
   $730 = ((($$09361042)) + 48|0); //@line 131263 "c/sqlite3.c"
   $731 = ($$61045|0)>(1); //@line 131263 "c/sqlite3.c"
   if ($731) {
    $$09331043 = $$2935;$$09361042 = $730;$$61045 = $729;
   } else {
    break;
   }
  }
  $732 = ($$2935|0)>(0); //@line 131316 "c/sqlite3.c"
  if ($732) {
   $$0942 = $$2935;
  } else {
   break;
  }
 }
 $733 = ((($0)) + 100|0); //@line 131263 "c/sqlite3.c"
 $734 = ((($0)) + 92|0); //@line 131263 "c/sqlite3.c"
 $735 = HEAP32[$734>>2]|0; //@line 131326 "c/sqlite3.c"
 $736 = ($735|0)>(0); //@line 131326 "c/sqlite3.c"
 if ($736) {
  $737 = HEAP32[$733>>2]|0; //@line 131326 "c/sqlite3.c"
  $738 = ((($4)) + 12|0);
  $$19371039 = $737;$$71040 = $735;
  while(1) {
   $739 = ((($$19371039)) + 10|0); //@line 131329 "c/sqlite3.c"
   $740 = HEAP16[$739>>1]|0; //@line 131329 "c/sqlite3.c"
   $741 = $740 & 6; //@line 131329 "c/sqlite3.c"
   $742 = ($741<<16>>16)==(0); //@line 131329 "c/sqlite3.c"
   if ($742) {
    $743 = ((($$19371039)) + 12|0); //@line 131330 "c/sqlite3.c"
    $744 = HEAP16[$743>>1]|0; //@line 131330 "c/sqlite3.c"
    $745 = $744&65535; //@line 131330 "c/sqlite3.c"
    $746 = $745 & 130; //@line 131330 "c/sqlite3.c"
    $747 = ($746|0)==(0); //@line 131330 "c/sqlite3.c"
    $748 = $745 & 2048; //@line 131331 "c/sqlite3.c"
    $749 = ($748|0)==(0); //@line 131331 "c/sqlite3.c"
    $or$cond1021 = $747 | $749; //@line 131330 "c/sqlite3.c"
    if (!($or$cond1021)) {
     $750 = ((($$19371039)) + 20|0); //@line 131332 "c/sqlite3.c"
     $751 = HEAP32[$750>>2]|0; //@line 131332 "c/sqlite3.c"
     $752 = ($751|0)==($20|0); //@line 131332 "c/sqlite3.c"
     if ($752) {
      $753 = HEAP32[$10>>2]|0; //@line 131333 "c/sqlite3.c"
      $754 = ($753|0)==(0); //@line 131333 "c/sqlite3.c"
      if ($754) {
       $755 = HEAP32[$$19371039>>2]|0; //@line 131334 "c/sqlite3.c"
       $756 = ((($$19371039)) + 28|0); //@line 131337 "c/sqlite3.c"
       $757 = HEAP32[$756>>2]|0; //@line 131337 "c/sqlite3.c"
       $758 = (_sqlite3WhereFindTerm($8,$20,$757,$2,$3,131,0)|0); //@line 131337 "c/sqlite3.c"
       $759 = ($758|0)==(0|0); //@line 131339 "c/sqlite3.c"
       if (!($759)) {
        $760 = ((($758)) + 10|0); //@line 131340 "c/sqlite3.c"
        $761 = HEAP16[$760>>1]|0; //@line 131340 "c/sqlite3.c"
        $762 = $761 & 4; //@line 131340 "c/sqlite3.c"
        $763 = ($762<<16>>16)==(0); //@line 131340 "c/sqlite3.c"
        if ($763) {
         $764 = HEAP32[$758>>2]|0; //@line 131345 "c/sqlite3.c"
         dest=$4; src=$764; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 131345 "c/sqlite3.c"
         $765 = ((($755)) + 12|0); //@line 131346 "c/sqlite3.c"
         $766 = HEAP32[$765>>2]|0; //@line 131346 "c/sqlite3.c"
         HEAP32[$738>>2] = $766; //@line 131346 "c/sqlite3.c"
         _sqlite3ExprIfFalse($5,$4,$54,16); //@line 131347 "c/sqlite3.c"
        }
       }
      }
     }
    }
   }
   $767 = (($$71040) + -1)|0; //@line 131326 "c/sqlite3.c"
   $768 = ((($$19371039)) + 48|0); //@line 131326 "c/sqlite3.c"
   $769 = ($$71040|0)>(1); //@line 131326 "c/sqlite3.c"
   if ($769) {
    $$19371039 = $768;$$71040 = $767;
   } else {
    break;
   }
  }
 }
 $770 = HEAP32[$10>>2]|0; //@line 131353 "c/sqlite3.c"
 $771 = ($770|0)==(0); //@line 131353 "c/sqlite3.c"
 if (!($771)) {
  $772 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 131354 "c/sqlite3.c"
  $773 = (((((($0)) + 752|0) + (($1*80)|0)|0)) + 28|0); //@line 131354 "c/sqlite3.c"
  HEAP32[$773>>2] = $772; //@line 131354 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($7,67,1,$770)|0); //@line 131355 "c/sqlite3.c"
  _sqlite3ExprCacheClear($5); //@line 131357 "c/sqlite3.c"
  $774 = HEAP32[$734>>2]|0; //@line 131358 "c/sqlite3.c"
  $775 = ($774|0)>(0); //@line 131358 "c/sqlite3.c"
  if ($775) {
   $776 = HEAP32[$733>>2]|0; //@line 131358 "c/sqlite3.c"
   $$29381037 = $776;$$81038 = 0;
   while(1) {
    $777 = ((($$29381037)) + 10|0); //@line 131361 "c/sqlite3.c"
    $778 = HEAP16[$777>>1]|0; //@line 131361 "c/sqlite3.c"
    $779 = $778 & 6; //@line 131361 "c/sqlite3.c"
    $780 = ($779<<16>>16)==(0); //@line 131361 "c/sqlite3.c"
    if ($780) {
     $781 = ((($$29381037)) + 40|0); //@line 131362 "c/sqlite3.c"
     $782 = $781; //@line 131362 "c/sqlite3.c"
     $783 = $782; //@line 131362 "c/sqlite3.c"
     $784 = HEAP32[$783>>2]|0; //@line 131362 "c/sqlite3.c"
     $785 = (($782) + 4)|0; //@line 131362 "c/sqlite3.c"
     $786 = $785; //@line 131362 "c/sqlite3.c"
     $787 = HEAP32[$786>>2]|0; //@line 131362 "c/sqlite3.c"
     $788 = $28; //@line 131362 "c/sqlite3.c"
     $789 = $788; //@line 131362 "c/sqlite3.c"
     $790 = HEAP32[$789>>2]|0; //@line 131362 "c/sqlite3.c"
     $791 = (($788) + 4)|0; //@line 131362 "c/sqlite3.c"
     $792 = $791; //@line 131362 "c/sqlite3.c"
     $793 = HEAP32[$792>>2]|0; //@line 131362 "c/sqlite3.c"
     $794 = $790 & $784; //@line 131362 "c/sqlite3.c"
     $795 = $793 & $787; //@line 131362 "c/sqlite3.c"
     $796 = ($794|0)==(0); //@line 131362 "c/sqlite3.c"
     $797 = ($795|0)==(0); //@line 131362 "c/sqlite3.c"
     $798 = $796 & $797; //@line 131362 "c/sqlite3.c"
     if ($798) {
      $799 = HEAP32[$$29381037>>2]|0; //@line 131367 "c/sqlite3.c"
      _sqlite3ExprIfFalse($5,$799,$54,16); //@line 131367 "c/sqlite3.c"
      $800 = HEAP16[$777>>1]|0; //@line 131368 "c/sqlite3.c"
      $801 = $800 | 4; //@line 131368 "c/sqlite3.c"
      HEAP16[$777>>1] = $801; //@line 131368 "c/sqlite3.c"
     }
    }
    $802 = (($$81038) + 1)|0; //@line 131358 "c/sqlite3.c"
    $803 = ((($$29381037)) + 48|0); //@line 131358 "c/sqlite3.c"
    $804 = HEAP32[$734>>2]|0; //@line 131358 "c/sqlite3.c"
    $805 = ($802|0)<($804|0); //@line 131358 "c/sqlite3.c"
    if ($805) {
     $$29381037 = $803;$$81038 = $802;
    } else {
     break;
    }
   }
  }
 }
 $806 = $28; //@line 131372 "c/sqlite3.c"
 $807 = $806; //@line 131372 "c/sqlite3.c"
 $808 = HEAP32[$807>>2]|0; //@line 131372 "c/sqlite3.c"
 $809 = (($806) + 4)|0; //@line 131372 "c/sqlite3.c"
 $810 = $809; //@line 131372 "c/sqlite3.c"
 $811 = HEAP32[$810>>2]|0; //@line 131372 "c/sqlite3.c"
 $812 = $811;$813 = $808;
 tempRet0 = ($812); //@line 131373 "c/sqlite3.c"
 STACKTOP = sp;return ($813|0); //@line 131373 "c/sqlite3.c"
}
function _sqlite3WhereGetMask($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$09 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 133090 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 133090 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 133090 "c/sqlite3.c"
 L1: do {
  if ($4) {
   $$09 = 0;
   while(1) {
    $5 = (((($0)) + 8|0) + ($$09<<2)|0); //@line 133091 "c/sqlite3.c"
    $6 = HEAP32[$5>>2]|0; //@line 133091 "c/sqlite3.c"
    $7 = ($6|0)==($1|0); //@line 133091 "c/sqlite3.c"
    if ($7) {
     break;
    }
    $10 = (($$09) + 1)|0; //@line 133090 "c/sqlite3.c"
    $11 = HEAP32[$2>>2]|0; //@line 133090 "c/sqlite3.c"
    $12 = ($10|0)<($11|0); //@line 133090 "c/sqlite3.c"
    if ($12) {
     $$09 = $10;
    } else {
     $13 = 0;$14 = 0;
     break L1;
    }
   }
   $8 = (_bitshift64Shl(1,0,($$09|0))|0); //@line 133092 "c/sqlite3.c"
   $9 = tempRet0; //@line 133092 "c/sqlite3.c"
   $13 = $9;$14 = $8;
  } else {
   $13 = 0;$14 = 0;
  }
 } while(0);
 tempRet0 = ($13); //@line 133096 "c/sqlite3.c"
 return ($14|0); //@line 133096 "c/sqlite3.c"
}
function _codeEqualityTerm($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0145 = 0, $$0147167 = 0, $$0149 = 0, $$0151 = 0, $$0153$lcssa = 0, $$0153169 = 0, $$0155172 = 0, $$0158 = 0, $$0159164 = 0, $$0161 = 0, $$1 = 0, $$1146 = 0, $$1148 = 0, $$1152 = 0, $$1156168 = 0, $$1160 = 0, $$1162 = 0, $$2 = 0, $$2157166 = 0, $$3 = 0;
 var $$sink = 0, $$sink177 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0;
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $spec$select = 0, $spec$select163 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = HEAP32[$1>>2]|0; //@line 129667 "c/sqlite3.c"
 $7 = ((($0)) + 8|0); //@line 129668 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 129668 "c/sqlite3.c"
 $9 = HEAP8[$6>>0]|0; //@line 129673 "c/sqlite3.c"
 switch ($9<<24>>24) {
 case 45: case 53:  {
  $10 = ((($6)) + 16|0); //@line 129674 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 129674 "c/sqlite3.c"
  $12 = (_sqlite3ExprCodeTarget($0,$11,$5)|0); //@line 129674 "c/sqlite3.c"
  $$0158 = $12;
  break;
 }
 case 50:  {
  (_sqlite3VdbeAddOp2($8,70,0,$5)|0); //@line 129677 "c/sqlite3.c"
  $$0158 = $5;
  break;
 }
 default: {
  $13 = ((($2)) + 64|0); //@line 129683 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 129683 "c/sqlite3.c"
  $15 = ((($14)) + 36|0); //@line 129688 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 129688 "c/sqlite3.c"
  $17 = $16 & 1024; //@line 129688 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 129688 "c/sqlite3.c"
  if ($18) {
   $19 = ((($14)) + 32|0); //@line 129689 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 129689 "c/sqlite3.c"
   $21 = ($20|0)==(0|0); //@line 129689 "c/sqlite3.c"
   if ($21) {
    $$0145 = $4;
   } else {
    $22 = ((($20)) + 28|0); //@line 129690 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 129690 "c/sqlite3.c"
    $24 = (($23) + ($3)|0); //@line 129690 "c/sqlite3.c"
    $25 = HEAP8[$24>>0]|0; //@line 129690 "c/sqlite3.c"
    $26 = ($25<<24>>24)==(0); //@line 129690 "c/sqlite3.c"
    $27 = ($4|0)==(0); //@line 129694 "c/sqlite3.c"
    $28 = $27&1; //@line 129694 "c/sqlite3.c"
    $spec$select163 = $26 ? $4 : $28; //@line 129688 "c/sqlite3.c"
    $$0145 = $spec$select163;
   }
  } else {
   $$0145 = $4;
  }
  $29 = ($3|0)>(0); //@line 129699 "c/sqlite3.c"
  L7: do {
   if ($29) {
    $30 = ((($14)) + 48|0);
    $31 = HEAP32[$30>>2]|0;
    $$0155172 = 0;
    while(1) {
     $32 = (($31) + ($$0155172<<2)|0); //@line 129700 "c/sqlite3.c"
     $33 = HEAP32[$32>>2]|0; //@line 129700 "c/sqlite3.c"
     $34 = ($33|0)==(0|0); //@line 129700 "c/sqlite3.c"
     if (!($34)) {
      $35 = HEAP32[$33>>2]|0; //@line 129700 "c/sqlite3.c"
      $36 = ($35|0)==($6|0); //@line 129700 "c/sqlite3.c"
      if ($36) {
       break;
      }
     }
     $37 = (($$0155172) + 1)|0; //@line 129699 "c/sqlite3.c"
     $38 = ($37|0)<($3|0); //@line 129699 "c/sqlite3.c"
     if ($38) {
      $$0155172 = $37;
     } else {
      break L7;
     }
    }
    _disableTerm($2,$1); //@line 129701 "c/sqlite3.c"
    $$1 = $5;
    return ($$1|0); //@line 129777 "c/sqlite3.c"
   }
  } while(0);
  $39 = ((($14)) + 40|0); //@line 129705 "c/sqlite3.c"
  $40 = HEAP16[$39>>1]|0; //@line 129705 "c/sqlite3.c"
  $41 = $40&65535; //@line 129705 "c/sqlite3.c"
  $42 = ($41|0)>($3|0); //@line 129705 "c/sqlite3.c"
  if ($42) {
   $43 = ((($14)) + 48|0);
   $44 = HEAP32[$43>>2]|0;
   $45 = HEAP16[$39>>1]|0;
   $46 = $45&65535;
   $$0153169 = 0;$$1156168 = $3;
   while(1) {
    $47 = (($44) + ($$1156168<<2)|0); //@line 129707 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 129707 "c/sqlite3.c"
    $49 = HEAP32[$48>>2]|0; //@line 129707 "c/sqlite3.c"
    $50 = ($49|0)==($6|0); //@line 129707 "c/sqlite3.c"
    $51 = $50&1; //@line 129707 "c/sqlite3.c"
    $spec$select = (($$0153169) + ($51))|0; //@line 129707 "c/sqlite3.c"
    $52 = (($$1156168) + 1)|0; //@line 129705 "c/sqlite3.c"
    $53 = ($52|0)<($46|0); //@line 129705 "c/sqlite3.c"
    if ($53) {
     $$0153169 = $spec$select;$$1156168 = $52;
    } else {
     $$0153$lcssa = $spec$select;
     break;
    }
   }
  } else {
   $$0153$lcssa = 0;
  }
  $54 = ((($6)) + 4|0); //@line 129710 "c/sqlite3.c"
  $55 = HEAP32[$54>>2]|0; //@line 129710 "c/sqlite3.c"
  $56 = $55 & 2048; //@line 129710 "c/sqlite3.c"
  $57 = ($56|0)==(0); //@line 129710 "c/sqlite3.c"
  if ($57) {
   label = 18;
  } else {
   $58 = ((($6)) + 20|0); //@line 129710 "c/sqlite3.c"
   $59 = HEAP32[$58>>2]|0; //@line 129710 "c/sqlite3.c"
   $60 = HEAP32[$59>>2]|0; //@line 129710 "c/sqlite3.c"
   $61 = HEAP32[$60>>2]|0; //@line 129710 "c/sqlite3.c"
   $62 = ($61|0)==(1); //@line 129710 "c/sqlite3.c"
   if ($62) {
    label = 18;
   } else {
    $64 = HEAP32[$0>>2]|0; //@line 129713 "c/sqlite3.c"
    $65 = (_removeUnindexableInClauseTerms($0,$3,$14,$6)|0); //@line 129714 "c/sqlite3.c"
    $66 = ((($64)) + 73|0); //@line 129716 "c/sqlite3.c"
    $67 = HEAP8[$66>>0]|0; //@line 129716 "c/sqlite3.c"
    $68 = ($67<<24>>24)==(0); //@line 129716 "c/sqlite3.c"
    if ($68) {
     $69 = HEAP32[$0>>2]|0; //@line 129717 "c/sqlite3.c"
     $70 = $$0153$lcssa << 2; //@line 129717 "c/sqlite3.c"
     $71 = (_sqlite3DbMallocZero($69,$70,0)|0); //@line 129717 "c/sqlite3.c"
     $72 = (_sqlite3FindInIndex($0,$65,4,0,$71)|0); //@line 129718 "c/sqlite3.c"
     $73 = ((($65)) + 28|0); //@line 129719 "c/sqlite3.c"
     $74 = HEAP32[$73>>2]|0; //@line 129719 "c/sqlite3.c"
     $75 = HEAP32[$1>>2]|0; //@line 129719 "c/sqlite3.c"
     $76 = ((($75)) + 28|0); //@line 129719 "c/sqlite3.c"
     HEAP32[$76>>2] = $74; //@line 129719 "c/sqlite3.c"
     $$0151 = $71;$$0161 = $72;$131 = $71;
    } else {
     $$0151 = 0;$$0161 = 5;$131 = 0;
    }
    _sqlite3ExprDelete($64,$65); //@line 129721 "c/sqlite3.c"
    $77 = HEAP32[$1>>2]|0; //@line 129722 "c/sqlite3.c"
    $$0149 = $77;$$1152 = $$0151;$$1162 = $$0161;$130 = $131;
   }
  }
  if ((label|0) == 18) {
   $63 = (_sqlite3FindInIndex($0,$6,4,0,0)|0); //@line 129711 "c/sqlite3.c"
   $$0149 = $6;$$1152 = 0;$$1162 = $63;$130 = 0;
  }
  $78 = ($$1162|0)==(4); //@line 129725 "c/sqlite3.c"
  $79 = ($$0145|0)==(0); //@line 129727 "c/sqlite3.c"
  $80 = $79&1; //@line 129727 "c/sqlite3.c"
  $$1146 = $78 ? $80 : $$0145; //@line 129725 "c/sqlite3.c"
  $81 = ((($$0149)) + 28|0); //@line 129729 "c/sqlite3.c"
  $82 = HEAP32[$81>>2]|0; //@line 129729 "c/sqlite3.c"
  $83 = ($$1146|0)!=(0); //@line 129730 "c/sqlite3.c"
  $84 = $83 ? 33 : 37; //@line 129730 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($8,$84,$82,0)|0); //@line 129730 "c/sqlite3.c"
  $85 = HEAP32[$15>>2]|0; //@line 129735 "c/sqlite3.c"
  $86 = $85 | 2048; //@line 129735 "c/sqlite3.c"
  HEAP32[$15>>2] = $86; //@line 129735 "c/sqlite3.c"
  $87 = ((($2)) + 56|0); //@line 129736 "c/sqlite3.c"
  $88 = HEAP32[$87>>2]|0; //@line 129736 "c/sqlite3.c"
  $89 = ($88|0)==(0); //@line 129736 "c/sqlite3.c"
  if ($89) {
   $90 = (_sqlite3VdbeMakeLabel($8)|0); //@line 129737 "c/sqlite3.c"
   $91 = ((($2)) + 16|0); //@line 129737 "c/sqlite3.c"
   HEAP32[$91>>2] = $90; //@line 129737 "c/sqlite3.c"
  }
  $92 = HEAP32[$87>>2]|0; //@line 129740 "c/sqlite3.c"
  $93 = (($92) + ($$0153$lcssa))|0; //@line 129741 "c/sqlite3.c"
  HEAP32[$87>>2] = $93; //@line 129741 "c/sqlite3.c"
  $94 = HEAP32[$0>>2]|0; //@line 129743 "c/sqlite3.c"
  $95 = ((($2)) + 60|0); //@line 129743 "c/sqlite3.c"
  $96 = HEAP32[$95>>2]|0; //@line 129743 "c/sqlite3.c"
  $97 = ($93*12)|0; //@line 129744 "c/sqlite3.c"
  $98 = (_sqlite3DbReallocOrFree($94,$96,$97,0)|0); //@line 129743 "c/sqlite3.c"
  HEAP32[$95>>2] = $98; //@line 129742 "c/sqlite3.c"
  $99 = ($98|0)==(0|0); //@line 129746 "c/sqlite3.c"
  if ($99) {
   HEAP32[$87>>2] = 0; //@line 129770 "c/sqlite3.c"
  } else {
   $100 = HEAP16[$39>>1]|0; //@line 129749 "c/sqlite3.c"
   $101 = $100&65535; //@line 129749 "c/sqlite3.c"
   $102 = ($101|0)>($3|0); //@line 129749 "c/sqlite3.c"
   if ($102) {
    $103 = (($98) + (($92*12)|0)|0); //@line 129748 "c/sqlite3.c"
    $104 = ((($14)) + 48|0);
    $105 = (($5) - ($3))|0;
    $106 = ($$1162|0)==(1);
    $107 = ($$1152|0)==(0|0);
    $108 = $83 ? 4 : 5;
    $$0147167 = 0;$$0159164 = $103;$$2157166 = $3;
    while(1) {
     $109 = HEAP32[$104>>2]|0; //@line 129750 "c/sqlite3.c"
     $110 = (($109) + ($$2157166<<2)|0); //@line 129750 "c/sqlite3.c"
     $111 = HEAP32[$110>>2]|0; //@line 129750 "c/sqlite3.c"
     $112 = HEAP32[$111>>2]|0; //@line 129750 "c/sqlite3.c"
     $113 = ($112|0)==($$0149|0); //@line 129750 "c/sqlite3.c"
     if ($113) {
      $114 = (($105) + ($$2157166))|0; //@line 129751 "c/sqlite3.c"
      if ($106) {
       $115 = (_sqlite3VdbeAddOp2($8,124,$82,$114)|0); //@line 129754 "c/sqlite3.c"
       $$2 = $$0147167;$$sink = $115;
      } else {
       if ($107) {
        $$1148 = $$0147167;$119 = 0;
       } else {
        $116 = (($$1152) + ($$0147167<<2)|0); //@line 129756 "c/sqlite3.c"
        $117 = (($$0147167) + 1)|0; //@line 129756 "c/sqlite3.c"
        $118 = HEAP32[$116>>2]|0; //@line 129756 "c/sqlite3.c"
        $$1148 = $117;$119 = $118;
       }
       $120 = (_sqlite3VdbeAddOp3($8,98,$82,$119,$114)|0); //@line 129757 "c/sqlite3.c"
       $$2 = $$1148;$$sink = $120;
      }
      $121 = ((($$0159164)) + 4|0);
      HEAP32[$121>>2] = $$sink;
      (_sqlite3VdbeAddOp1($8,50,$114)|0); //@line 129759 "c/sqlite3.c"
      $122 = ($$2157166|0)==($3|0); //@line 129760 "c/sqlite3.c"
      if ($122) {
       HEAP32[$$0159164>>2] = $82; //@line 129761 "c/sqlite3.c"
       $$sink177 = $108;
      } else {
       $$sink177 = -88;
      }
      $123 = ((($$0159164)) + 8|0);
      HEAP8[$123>>0] = $$sink177;
      $124 = ((($$0159164)) + 12|0); //@line 129766 "c/sqlite3.c"
      $$1160 = $124;$$3 = $$2;
     } else {
      $$1160 = $$0159164;$$3 = $$0147167;
     }
     $125 = (($$2157166) + 1)|0; //@line 129749 "c/sqlite3.c"
     $126 = HEAP16[$39>>1]|0; //@line 129749 "c/sqlite3.c"
     $127 = $126&65535; //@line 129749 "c/sqlite3.c"
     $128 = ($125|0)<($127|0); //@line 129749 "c/sqlite3.c"
     if ($128) {
      $$0147167 = $$3;$$0159164 = $$1160;$$2157166 = $125;
     } else {
      break;
     }
    }
   }
  }
  $129 = HEAP32[$0>>2]|0; //@line 129772 "c/sqlite3.c"
  _sqlite3DbFree($129,$130); //@line 129772 "c/sqlite3.c"
  $$0158 = $5;
 }
 }
 _disableTerm($2,$1); //@line 129775 "c/sqlite3.c"
 $$1 = $$0158;
 return ($$1|0); //@line 129777 "c/sqlite3.c"
}
function _codeExprOrVector($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$028 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($1|0)==(0|0); //@line 130240 "c/sqlite3.c"
 if (!($4)) {
  $5 = (_sqlite3ExprIsVector($1)|0); //@line 130240 "c/sqlite3.c"
  $6 = ($5|0)==(0); //@line 130240 "c/sqlite3.c"
  if (!($6)) {
   $7 = ((($1)) + 4|0); //@line 130242 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 130242 "c/sqlite3.c"
   $9 = $8 & 2048; //@line 130242 "c/sqlite3.c"
   $10 = ($9|0)==(0); //@line 130242 "c/sqlite3.c"
   if (!($10)) {
    $11 = ((($0)) + 8|0); //@line 130243 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 130243 "c/sqlite3.c"
    $13 = (_sqlite3CodeSubselect($0,$1,0,0)|0); //@line 130244 "c/sqlite3.c"
    $14 = (($3) + -1)|0; //@line 130245 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($12,75,$13,$2,$14)|0); //@line 130245 "c/sqlite3.c"
    return; //@line 130260 "c/sqlite3.c"
   }
   $15 = ((($1)) + 20|0); //@line 130250 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 130250 "c/sqlite3.c"
   $17 = ($3|0)>(0); //@line 130252 "c/sqlite3.c"
   if (!($17)) {
    return; //@line 130260 "c/sqlite3.c"
   }
   $$028 = 0;
   while(1) {
    $18 = (((($16)) + 4|0) + (($$028*20)|0)|0); //@line 130253 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 130253 "c/sqlite3.c"
    $20 = (($$028) + ($2))|0; //@line 130253 "c/sqlite3.c"
    _sqlite3ExprCode($0,$19,$20); //@line 130253 "c/sqlite3.c"
    $21 = (($$028) + 1)|0; //@line 130252 "c/sqlite3.c"
    $exitcond = ($21|0)==($3|0); //@line 130252 "c/sqlite3.c"
    if ($exitcond) {
     break;
    } else {
     $$028 = $21;
    }
   }
   return; //@line 130260 "c/sqlite3.c"
  }
 }
 _sqlite3ExprCode($0,$1,$2); //@line 130258 "c/sqlite3.c"
 return; //@line 130260 "c/sqlite3.c"
}
function _disableTerm($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01617 = 0, $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $storemerge = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 10|0); //@line 129466 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 129466 "c/sqlite3.c"
 $4 = $3 & 4; //@line 129466 "c/sqlite3.c"
 $5 = ($4<<16>>16)==(0); //@line 129466 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 129482 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0;
 $7 = ($6|0)==(0);
 $8 = ((($0)) + 72|0);
 $$01617 = $1;$$018 = 0;$34 = $3;$40 = $2;
 while(1) {
  if (!($7)) {
   $9 = HEAP32[$$01617>>2]|0; //@line 129467 "c/sqlite3.c"
   $10 = ((($9)) + 4|0); //@line 129467 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 129467 "c/sqlite3.c"
   $12 = $11 & 1; //@line 129467 "c/sqlite3.c"
   $13 = ($12|0)==(0); //@line 129467 "c/sqlite3.c"
   if ($13) {
    label = 13;
    break;
   }
  }
  $14 = $8; //@line 129468 "c/sqlite3.c"
  $15 = $14; //@line 129468 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 129468 "c/sqlite3.c"
  $17 = (($14) + 4)|0; //@line 129468 "c/sqlite3.c"
  $18 = $17; //@line 129468 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 129468 "c/sqlite3.c"
  $20 = ((($$01617)) + 40|0); //@line 129468 "c/sqlite3.c"
  $21 = $20; //@line 129468 "c/sqlite3.c"
  $22 = $21; //@line 129468 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 129468 "c/sqlite3.c"
  $24 = (($21) + 4)|0; //@line 129468 "c/sqlite3.c"
  $25 = $24; //@line 129468 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 129468 "c/sqlite3.c"
  $27 = $23 & $16; //@line 129468 "c/sqlite3.c"
  $28 = $26 & $19; //@line 129468 "c/sqlite3.c"
  $29 = ($27|0)==(0); //@line 129468 "c/sqlite3.c"
  $30 = ($28|0)==(0); //@line 129468 "c/sqlite3.c"
  $31 = $29 & $30; //@line 129468 "c/sqlite3.c"
  if (!($31)) {
   label = 13;
   break;
  }
  $32 = ($$018|0)==(0); //@line 129470 "c/sqlite3.c"
  if ($32) {
   label = 9;
  } else {
   $33 = $34&65535; //@line 129470 "c/sqlite3.c"
   $35 = $33 & 1024; //@line 129470 "c/sqlite3.c"
   $36 = ($35|0)==(0); //@line 129470 "c/sqlite3.c"
   if ($36) {
    label = 9;
   } else {
    $37 = $33 | 512; //@line 129471 "c/sqlite3.c"
    $38 = $37&65535; //@line 129471 "c/sqlite3.c"
    $storemerge = $38;
   }
  }
  if ((label|0) == 9) {
   label = 0;
   $39 = $34 | 4; //@line 129473 "c/sqlite3.c"
   $storemerge = $39;
  }
  HEAP16[$40>>1] = $storemerge;
  $41 = ((($$01617)) + 16|0); //@line 129475 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 129475 "c/sqlite3.c"
  $43 = ($42|0)<(0); //@line 129475 "c/sqlite3.c"
  if ($43) {
   label = 13;
   break;
  }
  $44 = ((($$01617)) + 4|0); //@line 129476 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 129476 "c/sqlite3.c"
  $46 = ((($45)) + 20|0); //@line 129476 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 129476 "c/sqlite3.c"
  $48 = (((($47) + (($42*48)|0)|0)) + 14|0); //@line 129478 "c/sqlite3.c"
  $49 = HEAP8[$48>>0]|0; //@line 129478 "c/sqlite3.c"
  $50 = (($49) + -1)<<24>>24; //@line 129478 "c/sqlite3.c"
  HEAP8[$48>>0] = $50; //@line 129478 "c/sqlite3.c"
  $51 = ($50<<24>>24)==(0); //@line 129479 "c/sqlite3.c"
  if (!($51)) {
   label = 13;
   break;
  }
  $52 = (($47) + (($42*48)|0)|0); //@line 129476 "c/sqlite3.c"
  $53 = (($$018) + 1)|0; //@line 129480 "c/sqlite3.c"
  $54 = (((($47) + (($42*48)|0)|0)) + 10|0); //@line 129466 "c/sqlite3.c"
  $55 = HEAP16[$54>>1]|0; //@line 129466 "c/sqlite3.c"
  $56 = $55 & 4; //@line 129466 "c/sqlite3.c"
  $57 = ($56<<16>>16)==(0); //@line 129466 "c/sqlite3.c"
  if ($57) {
   $$01617 = $52;$$018 = $53;$34 = $55;$40 = $54;
  } else {
   label = 13;
   break;
  }
 }
 if ((label|0) == 13) {
  return; //@line 129482 "c/sqlite3.c"
 }
}
function _codeAllEqualityTerms($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0110$lcssa = 0, $$0110112 = 0, $$0115 = 0, $$1111 = 0, $$1113 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $9 = 0, $exitcond = 0, $exitcond118 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 8|0); //@line 129833 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 129833 "c/sqlite3.c"
 $7 = ((($1)) + 64|0); //@line 129843 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 129843 "c/sqlite3.c"
 $9 = ((($8)) + 24|0); //@line 129845 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 129845 "c/sqlite3.c"
 $11 = ((($8)) + 42|0); //@line 129846 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 129846 "c/sqlite3.c"
 $13 = ((($8)) + 32|0); //@line 129847 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 129847 "c/sqlite3.c"
 $15 = ((($0)) + 44|0); //@line 129852 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 129852 "c/sqlite3.c"
 $17 = (($16) + 1)|0; //@line 129852 "c/sqlite3.c"
 $18 = $10&65535; //@line 129853 "c/sqlite3.c"
 $19 = (($18) + ($3))|0; //@line 129853 "c/sqlite3.c"
 $20 = (($16) + ($19))|0; //@line 129854 "c/sqlite3.c"
 HEAP32[$15>>2] = $20; //@line 129854 "c/sqlite3.c"
 $21 = HEAP32[$0>>2]|0; //@line 129856 "c/sqlite3.c"
 $22 = (_sqlite3IndexAffinityStr($21,$14)|0); //@line 129856 "c/sqlite3.c"
 $23 = (_sqlite3DbStrDup($21,$22)|0); //@line 129856 "c/sqlite3.c"
 $24 = ($12<<16>>16)==(0); //@line 129859 "c/sqlite3.c"
 if (!($24)) {
  $25 = ((($1)) + 8|0); //@line 129860 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 129860 "c/sqlite3.c"
  $27 = ($2|0)!=(0); //@line 129861 "c/sqlite3.c"
  $28 = $27 ? 33 : 37; //@line 129861 "c/sqlite3.c"
  (_sqlite3VdbeAddOp1($6,$28,$26)|0); //@line 129861 "c/sqlite3.c"
  $29 = (_sqlite3VdbeAddOp0($6,13)|0); //@line 129865 "c/sqlite3.c"
  $30 = $27 ? 24 : 27; //@line 129866 "c/sqlite3.c"
  $31 = $12&65535; //@line 129867 "c/sqlite3.c"
  $32 = (_sqlite3VdbeAddOp4Int($6,$30,$26,0,$17,$31)|0); //@line 129866 "c/sqlite3.c"
  $33 = ((($1)) + 20|0); //@line 129866 "c/sqlite3.c"
  HEAP32[$33>>2] = $32; //@line 129866 "c/sqlite3.c"
  _sqlite3VdbeJumpHere($6,$29); //@line 129870 "c/sqlite3.c"
  $$0115 = 0;
  while(1) {
   $34 = (($$0115) + ($17))|0; //@line 129872 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($6,98,$26,$$0115,$34)|0); //@line 129872 "c/sqlite3.c"
   $35 = (($$0115) + 1)|0; //@line 129871 "c/sqlite3.c"
   $exitcond118 = ($35|0)==($31|0); //@line 129871 "c/sqlite3.c"
   if ($exitcond118) {
    break;
   } else {
    $$0115 = $35;
   }
  }
 }
 $36 = ($12&65535)<($10&65535); //@line 129881 "c/sqlite3.c"
 if (!($36)) {
  $$0110$lcssa = $17;
  HEAP32[$4>>2] = $23; //@line 129922 "c/sqlite3.c"
  return ($$0110$lcssa|0); //@line 129923 "c/sqlite3.c"
 }
 $37 = $12&65535; //@line 129881 "c/sqlite3.c"
 $38 = ((($8)) + 48|0);
 $39 = ($19|0)==(1);
 $40 = ($23|0)!=(0|0);
 $41 = ($23|0)==(0|0);
 $42 = ((($1)) + 12|0);
 $$0110112 = $17;$$1113 = $37;
 while(1) {
  $43 = HEAP32[$38>>2]|0; //@line 129883 "c/sqlite3.c"
  $44 = (($43) + ($$1113<<2)|0); //@line 129883 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 129883 "c/sqlite3.c"
  $46 = (($$1113) + ($$0110112))|0; //@line 129889 "c/sqlite3.c"
  $47 = (_codeEqualityTerm($0,$45,$1,$$1113,$2,$46)|0); //@line 129889 "c/sqlite3.c"
  $48 = ($47|0)==($46|0); //@line 129890 "c/sqlite3.c"
  do {
   if ($48) {
    $$1111 = $$0110112;
   } else {
    if ($39) {
     _sqlite3ReleaseTempReg($0,$$0110112); //@line 129892 "c/sqlite3.c"
     $$1111 = $47;
     break;
    } else {
     (_sqlite3VdbeAddOp2($6,76,$47,$46)|0); //@line 129895 "c/sqlite3.c"
     $$1111 = $$0110112;
     break;
    }
   }
  } while(0);
  $49 = ((($45)) + 12|0); //@line 129898 "c/sqlite3.c"
  $50 = HEAP16[$49>>1]|0; //@line 129898 "c/sqlite3.c"
  $51 = $50&65535; //@line 129898 "c/sqlite3.c"
  $52 = $51 & 1; //@line 129898 "c/sqlite3.c"
  $53 = ($52|0)==(0); //@line 129898 "c/sqlite3.c"
  if ($53) {
   $60 = $51 & 256; //@line 129906 "c/sqlite3.c"
   $61 = ($60|0)==(0); //@line 129906 "c/sqlite3.c"
   if ($61) {
    $62 = HEAP32[$45>>2]|0; //@line 129907 "c/sqlite3.c"
    $63 = ((($62)) + 16|0); //@line 129907 "c/sqlite3.c"
    $64 = HEAP32[$63>>2]|0; //@line 129907 "c/sqlite3.c"
    $65 = ((($45)) + 10|0); //@line 129908 "c/sqlite3.c"
    $66 = HEAP16[$65>>1]|0; //@line 129908 "c/sqlite3.c"
    $67 = $66 & 2048; //@line 129908 "c/sqlite3.c"
    $68 = ($67<<16>>16)==(0); //@line 129908 "c/sqlite3.c"
    if ($68) {
     $69 = (_sqlite3ExprCanBeNull($64)|0); //@line 129908 "c/sqlite3.c"
     $70 = ($69|0)==(0); //@line 129908 "c/sqlite3.c"
     if (!($70)) {
      $71 = (($$1111) + ($$1113))|0; //@line 129909 "c/sqlite3.c"
      $72 = HEAP32[$42>>2]|0; //@line 129909 "c/sqlite3.c"
      (_sqlite3VdbeAddOp2($6,50,$71,$72)|0); //@line 129909 "c/sqlite3.c"
     }
    }
    if (!($41)) {
     $73 = (($23) + ($$1113)|0); //@line 129913 "c/sqlite3.c"
     $74 = HEAP8[$73>>0]|0; //@line 129913 "c/sqlite3.c"
     $75 = (_sqlite3CompareAffinity($64,$74)|0); //@line 129913 "c/sqlite3.c"
     $76 = ($75<<24>>24)==(65); //@line 129913 "c/sqlite3.c"
     if ($76) {
      HEAP8[$73>>0] = 65; //@line 129914 "c/sqlite3.c"
     }
     $77 = HEAP8[$73>>0]|0; //@line 129916 "c/sqlite3.c"
     $78 = (_sqlite3ExprNeedsNoAffinityChange($64,$77)|0); //@line 129916 "c/sqlite3.c"
     $79 = ($78|0)==(0); //@line 129916 "c/sqlite3.c"
     if (!($79)) {
      HEAP8[$73>>0] = 65; //@line 129917 "c/sqlite3.c"
     }
    }
   }
  } else {
   $54 = HEAP32[$45>>2]|0; //@line 129899 "c/sqlite3.c"
   $55 = ((($54)) + 4|0); //@line 129899 "c/sqlite3.c"
   $56 = HEAP32[$55>>2]|0; //@line 129899 "c/sqlite3.c"
   $57 = $56 & 2048; //@line 129899 "c/sqlite3.c"
   $58 = ($57|0)!=(0); //@line 129899 "c/sqlite3.c"
   $or$cond = $40 & $58; //@line 129899 "c/sqlite3.c"
   if ($or$cond) {
    $59 = (($23) + ($$1113)|0); //@line 129904 "c/sqlite3.c"
    HEAP8[$59>>0] = 65; //@line 129904 "c/sqlite3.c"
   }
  }
  $80 = (($$1113) + 1)|0; //@line 129881 "c/sqlite3.c"
  $exitcond = ($80|0)==($18|0); //@line 129881 "c/sqlite3.c"
  if ($exitcond) {
   $$0110$lcssa = $$1111;
   break;
  } else {
   $$0110112 = $$1111;$$1113 = $80;
  }
 }
 HEAP32[$4>>2] = $23; //@line 129922 "c/sqlite3.c"
 return ($$0110$lcssa|0); //@line 129923 "c/sqlite3.c"
}
function _whereLikeOptimizationStringFixup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $and$shrunk = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($2)) + 10|0); //@line 129949 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 129949 "c/sqlite3.c"
 $5 = $4 & 256; //@line 129949 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 129949 "c/sqlite3.c"
 if ($6) {
  return; //@line 129959 "c/sqlite3.c"
 }
 $7 = (_sqlite3VdbeGetOp($0,-1)|0); //@line 129952 "c/sqlite3.c"
 $8 = ((($1)) + 36|0); //@line 129956 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 129956 "c/sqlite3.c"
 $10 = $9 >>> 1; //@line 129956 "c/sqlite3.c"
 $11 = ((($7)) + 12|0); //@line 129956 "c/sqlite3.c"
 HEAP32[$11>>2] = $10; //@line 129956 "c/sqlite3.c"
 $and$shrunk = $9&65535; //@line 129957 "c/sqlite3.c"
 $12 = $and$shrunk & 1; //@line 129957 "c/sqlite3.c"
 $13 = ((($7)) + 2|0); //@line 129957 "c/sqlite3.c"
 HEAP16[$13>>1] = $12; //@line 129957 "c/sqlite3.c"
 return; //@line 129959 "c/sqlite3.c"
}
function _updateRangeAffinityStr($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$015 = 0, $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)>(0); //@line 129538 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 129546 "c/sqlite3.c"
 }
 $$015 = 0;
 while(1) {
  $4 = (_sqlite3VectorFieldSubexpr($0,$$015)|0); //@line 129539 "c/sqlite3.c"
  $5 = (($2) + ($$015)|0); //@line 129540 "c/sqlite3.c"
  $6 = HEAP8[$5>>0]|0; //@line 129540 "c/sqlite3.c"
  $7 = (_sqlite3CompareAffinity($4,$6)|0); //@line 129540 "c/sqlite3.c"
  $8 = ($7<<24>>24)==(65); //@line 129540 "c/sqlite3.c"
  if ($8) {
   label = 5;
  } else {
   $9 = HEAP8[$5>>0]|0; //@line 129541 "c/sqlite3.c"
   $10 = (_sqlite3ExprNeedsNoAffinityChange($4,$9)|0); //@line 129541 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 129541 "c/sqlite3.c"
   if (!($11)) {
    label = 5;
   }
  }
  if ((label|0) == 5) {
   label = 0;
   HEAP8[$5>>0] = 65; //@line 129543 "c/sqlite3.c"
  }
  $12 = (($$015) + 1)|0; //@line 129538 "c/sqlite3.c"
  $exitcond = ($12|0)==($1|0); //@line 129538 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$015 = $12;
  }
 }
 return; //@line 129546 "c/sqlite3.c"
}
function _codeApplyAffinity($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$lcssa = 0, $$019$lcssa = 0, $$01926 = 0, $$020$lcssa = 0, $$02025 = 0, $$027 = 0, $$1$lcssa = 0, $$123 = 0, $$124 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 8|0); //@line 129496 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 129496 "c/sqlite3.c"
 $6 = ($3|0)!=(0|0); //@line 129497 "c/sqlite3.c"
 $7 = ($2|0)>(0); //@line 129506 "c/sqlite3.c"
 $or$cond = $6 & $7; //@line 129497 "c/sqlite3.c"
 if (!($or$cond)) {
  return; //@line 129520 "c/sqlite3.c"
 }
 $$01926 = $3;$$02025 = $2;$$027 = $1;
 while(1) {
  $8 = HEAP8[$$01926>>0]|0; //@line 129506 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(65); //@line 129506 "c/sqlite3.c"
  if (!($9)) {
   $$0$lcssa = $$027;$$019$lcssa = $$01926;$$020$lcssa = $$02025;
   break;
  }
  $10 = (($$02025) + -1)|0; //@line 129507 "c/sqlite3.c"
  $11 = (($$027) + 1)|0; //@line 129508 "c/sqlite3.c"
  $12 = ((($$01926)) + 1|0); //@line 129509 "c/sqlite3.c"
  $13 = ($$02025|0)>(1); //@line 129506 "c/sqlite3.c"
  if ($13) {
   $$01926 = $12;$$02025 = $10;$$027 = $11;
  } else {
   $$0$lcssa = $11;$$019$lcssa = $12;$$020$lcssa = $10;
   break;
  }
 }
 $14 = ($$020$lcssa|0)>(1); //@line 129511 "c/sqlite3.c"
 L8: do {
  if ($14) {
   $$124 = $$020$lcssa;
   while(1) {
    $16 = (($$124) + -1)|0; //@line 129511 "c/sqlite3.c"
    $17 = (($$019$lcssa) + ($16)|0); //@line 129511 "c/sqlite3.c"
    $18 = HEAP8[$17>>0]|0; //@line 129511 "c/sqlite3.c"
    $19 = ($18<<24>>24)==(65); //@line 129511 "c/sqlite3.c"
    if (!($19)) {
     $$123 = $$124;
     break L8;
    }
    $15 = ($$124|0)>(2); //@line 129511 "c/sqlite3.c"
    if ($15) {
     $$124 = $16;
    } else {
     $$1$lcssa = $16;
     label = 9;
     break;
    }
   }
  } else {
   $$1$lcssa = $$020$lcssa;
   label = 9;
  }
 } while(0);
 if ((label|0) == 9) {
  $20 = ($$1$lcssa|0)==(1); //@line 129516 "c/sqlite3.c"
  if ($20) {
   $$123 = 1;
  } else {
   return; //@line 129520 "c/sqlite3.c"
  }
 }
 (_sqlite3VdbeAddOp4($5,99,$$0$lcssa,$$123,0,$$019$lcssa,$$123)|0); //@line 129517 "c/sqlite3.c"
 _sqlite3ExprCacheAffinityChange($0,$$0$lcssa,$$123); //@line 129518 "c/sqlite3.c"
 return; //@line 129520 "c/sqlite3.c"
}
function _codeDeferredSeek($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$033 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 130205 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 130206 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 130206 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($6,130,$3,0,$2)|0); //@line 130211 "c/sqlite3.c"
 $7 = ((($0)) + 44|0); //@line 130212 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 130212 "c/sqlite3.c"
 $9 = $8 & 32; //@line 130212 "c/sqlite3.c"
 $10 = ($9<<16>>16)==(0); //@line 130212 "c/sqlite3.c"
 if ($10) {
  return; //@line 130227 "c/sqlite3.c"
 }
 $11 = ((($4)) + 120|0); //@line 130213 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 130213 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 130213 "c/sqlite3.c"
 $spec$select = $13 ? $4 : $12; //@line 130213 "c/sqlite3.c"
 $14 = ((($spec$select)) + 88|0); //@line 130213 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 130213 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 130213 "c/sqlite3.c"
 if (!($16)) {
  return; //@line 130227 "c/sqlite3.c"
 }
 $17 = ((($1)) + 12|0); //@line 130216 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 130216 "c/sqlite3.c"
 $19 = HEAP32[$4>>2]|0; //@line 130217 "c/sqlite3.c"
 $20 = ((($18)) + 42|0); //@line 130217 "c/sqlite3.c"
 $21 = HEAP16[$20>>1]|0; //@line 130217 "c/sqlite3.c"
 $22 = $21 << 16 >> 16; //@line 130217 "c/sqlite3.c"
 $23 = $22 << 2; //@line 130217 "c/sqlite3.c"
 $24 = (($23) + 4)|0; //@line 130217 "c/sqlite3.c"
 $25 = (_sqlite3DbMallocZero($19,$24,0)|0); //@line 130217 "c/sqlite3.c"
 $26 = ($25|0)==(0|0); //@line 130218 "c/sqlite3.c"
 if ($26) {
  return; //@line 130227 "c/sqlite3.c"
 }
 $27 = HEAP16[$20>>1]|0; //@line 130219 "c/sqlite3.c"
 $28 = $27 << 16 >> 16; //@line 130219 "c/sqlite3.c"
 HEAP32[$25>>2] = $28; //@line 130219 "c/sqlite3.c"
 $29 = ((($1)) + 52|0); //@line 130220 "c/sqlite3.c"
 $30 = HEAP16[$29>>1]|0; //@line 130220 "c/sqlite3.c"
 $31 = ($30&65535)>(1); //@line 130220 "c/sqlite3.c"
 if ($31) {
  $32 = ((($1)) + 4|0);
  $33 = HEAP32[$32>>2]|0;
  $34 = HEAP16[$29>>1]|0;
  $35 = $34&65535;
  $36 = (($35) + -1)|0;
  $$033 = 0;
  while(1) {
   $37 = (($33) + ($$033<<1)|0); //@line 130222 "c/sqlite3.c"
   $38 = HEAP16[$37>>1]|0; //@line 130222 "c/sqlite3.c"
   $39 = ($38<<16>>16)>(-1); //@line 130222 "c/sqlite3.c"
   if ($39) {
    $40 = $38 << 16 >> 16; //@line 130222 "c/sqlite3.c"
    $41 = (($40) + 1)|0; //@line 130222 "c/sqlite3.c"
    $42 = (($25) + ($41<<2)|0); //@line 130222 "c/sqlite3.c"
    $43 = (($$033) + 1)|0; //@line 130222 "c/sqlite3.c"
    HEAP32[$42>>2] = $43; //@line 130222 "c/sqlite3.c"
   }
   $44 = (($$033) + 1)|0; //@line 130220 "c/sqlite3.c"
   $45 = ($44|0)<($36|0); //@line 130220 "c/sqlite3.c"
   if ($45) {
    $$033 = $44;
   } else {
    break;
   }
  }
 }
 _sqlite3VdbeChangeP4($6,-1,$25,-15); //@line 130224 "c/sqlite3.c"
 return; //@line 130227 "c/sqlite3.c"
}
function _whereIndexExprTrans($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$017 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp + 16|0;
 $5 = sp;
 $6 = ((($0)) + 40|0); //@line 130307 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 130307 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 130308 "c/sqlite3.c"
 if ($8) {
  STACKTOP = sp;return; //@line 130323 "c/sqlite3.c"
 }
 ;HEAP32[$4>>2]=0|0;HEAP32[$4+4>>2]=0|0;HEAP32[$4+8>>2]=0|0;HEAP32[$4+12>>2]=0|0;HEAP32[$4+16>>2]=0|0;HEAP32[$4+20>>2]=0|0; //@line 130309 "c/sqlite3.c"
 $9 = ((($4)) + 4|0); //@line 130310 "c/sqlite3.c"
 HEAP32[$9>>2] = 161; //@line 130310 "c/sqlite3.c"
 $10 = ((($4)) + 24|0); //@line 130311 "c/sqlite3.c"
 HEAP32[$10>>2] = $5; //@line 130311 "c/sqlite3.c"
 $11 = ((($5)) + 4|0); //@line 130312 "c/sqlite3.c"
 HEAP32[$11>>2] = $1; //@line 130312 "c/sqlite3.c"
 $12 = ((($5)) + 8|0); //@line 130313 "c/sqlite3.c"
 HEAP32[$12>>2] = $2; //@line 130313 "c/sqlite3.c"
 $13 = HEAP32[$7>>2]|0; //@line 130314 "c/sqlite3.c"
 $14 = ($13|0)>(0); //@line 130314 "c/sqlite3.c"
 if (!($14)) {
  STACKTOP = sp;return; //@line 130323 "c/sqlite3.c"
 }
 $15 = ((($0)) + 4|0);
 $16 = ((($5)) + 12|0);
 $17 = ((($3)) + 16|0);
 $18 = ((($3)) + 8|0);
 $19 = ((($3)) + 12|0);
 $$017 = 0;
 while(1) {
  $20 = HEAP32[$15>>2]|0; //@line 130315 "c/sqlite3.c"
  $21 = (($20) + ($$017<<1)|0); //@line 130315 "c/sqlite3.c"
  $22 = HEAP16[$21>>1]|0; //@line 130315 "c/sqlite3.c"
  $23 = ($22<<16>>16)==(-2); //@line 130315 "c/sqlite3.c"
  if ($23) {
   HEAP32[$16>>2] = $$017; //@line 130317 "c/sqlite3.c"
   $24 = (((($7)) + 4|0) + (($$017*20)|0)|0); //@line 130318 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 130318 "c/sqlite3.c"
   HEAP32[$5>>2] = $25; //@line 130318 "c/sqlite3.c"
   $26 = HEAP32[$17>>2]|0; //@line 130319 "c/sqlite3.c"
   (_sqlite3WalkExpr($4,$26)|0); //@line 130319 "c/sqlite3.c"
   $27 = HEAP32[$18>>2]|0; //@line 130320 "c/sqlite3.c"
   (_sqlite3WalkExprList($4,$27)|0); //@line 130320 "c/sqlite3.c"
   $28 = HEAP32[$19>>2]|0; //@line 130321 "c/sqlite3.c"
   (_sqlite3WalkExprList($4,$28)|0); //@line 130321 "c/sqlite3.c"
  }
  $29 = (($$017) + 1)|0; //@line 130314 "c/sqlite3.c"
  $30 = HEAP32[$7>>2]|0; //@line 130314 "c/sqlite3.c"
  $31 = ($29|0)<($30|0); //@line 130314 "c/sqlite3.c"
  if ($31) {
   $$017 = $29;
  } else {
   break;
  }
 }
 STACKTOP = sp;return; //@line 130323 "c/sqlite3.c"
}
function _sqlite3ExprCodeGetColumnToReg($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3ExprCodeGetColumn($0,$1,$2,$3,$4,0)|0); //@line 96055 "c/sqlite3.c"
 $6 = ($5|0)==($4|0); //@line 96056 "c/sqlite3.c"
 if ($6) {
  return; //@line 96057 "c/sqlite3.c"
 }
 $7 = ((($0)) + 8|0); //@line 96056 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 96056 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($8,76,$5,$4)|0); //@line 96056 "c/sqlite3.c"
 return; //@line 96057 "c/sqlite3.c"
}
function _sqlite3VdbeChangeP1($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeGetOp($0,$1)|0); //@line 73774 "c/sqlite3.c"
 $4 = ((($3)) + 4|0); //@line 73774 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 73774 "c/sqlite3.c"
 return; //@line 73775 "c/sqlite3.c"
}
function _sqlite3ExprCoveredByIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $3 = sp + 8|0;
 $4 = sp;
 ;HEAP32[$3>>2]=0|0;HEAP32[$3+4>>2]=0|0;HEAP32[$3+8>>2]=0|0;HEAP32[$3+12>>2]=0|0;HEAP32[$3+16>>2]=0|0;HEAP32[$3+20>>2]=0|0; //@line 97649 "c/sqlite3.c"
 $5 = ((($4)) + 4|0); //@line 97650 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 97650 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 97651 "c/sqlite3.c"
 $6 = ((($3)) + 4|0); //@line 97652 "c/sqlite3.c"
 HEAP32[$6>>2] = 162; //@line 97652 "c/sqlite3.c"
 $7 = ((($3)) + 24|0); //@line 97653 "c/sqlite3.c"
 HEAP32[$7>>2] = $4; //@line 97653 "c/sqlite3.c"
 (_sqlite3WalkExpr($3,$0)|0); //@line 97654 "c/sqlite3.c"
 $8 = ((($3)) + 20|0); //@line 97655 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 97655 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 97655 "c/sqlite3.c"
 $11 = $10&1; //@line 97655 "c/sqlite3.c"
 STACKTOP = sp;return ($11|0); //@line 97655 "c/sqlite3.c"
}
function _sqlite3WhereFindTerm($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$01921 = 0, $$020 = 0, $$022 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $7 = sp;
 $8 = (_whereScanInit($7,$0,$1,$2,$5,$6)|0); //@line 133291 "c/sqlite3.c"
 $9 = $5 & 130; //@line 133292 "c/sqlite3.c"
 $10 = ($8|0)==(0|0); //@line 133293 "c/sqlite3.c"
 if ($10) {
  $$020 = 0;
  STACKTOP = sp;return ($$020|0); //@line 133304 "c/sqlite3.c"
 }
 $$01921 = 0;$$022 = $8;
 while(1) {
  $11 = ((($$022)) + 32|0); //@line 133294 "c/sqlite3.c"
  $12 = $11; //@line 133294 "c/sqlite3.c"
  $13 = $12; //@line 133294 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 133294 "c/sqlite3.c"
  $15 = (($12) + 4)|0; //@line 133294 "c/sqlite3.c"
  $16 = $15; //@line 133294 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 133294 "c/sqlite3.c"
  $18 = $14 & $3; //@line 133294 "c/sqlite3.c"
  $19 = $17 & $4; //@line 133294 "c/sqlite3.c"
  $20 = ($18|0)==(0); //@line 133294 "c/sqlite3.c"
  $21 = ($19|0)==(0); //@line 133294 "c/sqlite3.c"
  $22 = $20 & $21; //@line 133294 "c/sqlite3.c"
  if ($22) {
   $23 = ($14|0)==(0); //@line 133295 "c/sqlite3.c"
   $24 = ($17|0)==(0); //@line 133295 "c/sqlite3.c"
   $25 = $23 & $24; //@line 133295 "c/sqlite3.c"
   if ($25) {
    $26 = ((($$022)) + 12|0); //@line 133295 "c/sqlite3.c"
    $27 = HEAP16[$26>>1]|0; //@line 133295 "c/sqlite3.c"
    $28 = $27&65535; //@line 133295 "c/sqlite3.c"
    $29 = $9 & $28; //@line 133295 "c/sqlite3.c"
    $30 = ($29|0)==(0); //@line 133295 "c/sqlite3.c"
    if (!($30)) {
     $$020 = $$022;
     label = 8;
     break;
    }
   }
   $31 = ($$01921|0)==(0|0); //@line 133299 "c/sqlite3.c"
   $spec$select = $31 ? $$022 : $$01921; //@line 133299 "c/sqlite3.c"
   $$1 = $spec$select;
  } else {
   $$1 = $$01921;
  }
  $32 = (_whereScanNext($7)|0); //@line 133301 "c/sqlite3.c"
  $33 = ($32|0)==(0|0); //@line 133293 "c/sqlite3.c"
  if ($33) {
   $$020 = $$1;
   label = 8;
   break;
  } else {
   $$01921 = $$1;$$022 = $32;
  }
 }
 if ((label|0) == 8) {
  STACKTOP = sp;return ($$020|0); //@line 133304 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereScanInit($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = $1; //@line 133225 "c/sqlite3.c"
 $6 = ((($0)) + 4|0); //@line 133226 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 133226 "c/sqlite3.c"
 $7 = ((($0)) + 12|0); //@line 133227 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 133227 "c/sqlite3.c"
 $8 = ((($0)) + 16|0); //@line 133228 "c/sqlite3.c"
 HEAP8[$8>>0] = 0; //@line 133228 "c/sqlite3.c"
 $9 = ((($0)) + 8|0); //@line 133229 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 133229 "c/sqlite3.c"
 $10 = ($5|0)==(0|0); //@line 133230 "c/sqlite3.c"
 do {
  if ($10) {
   $39 = ($3|0)==(-2); //@line 133242 "c/sqlite3.c"
   if ($39) {
    $$0 = 0;
    return ($$0|0); //@line 133252 "c/sqlite3.c"
   } else {
    $$1 = $3;
   }
  } else {
   $11 = ((($5)) + 4|0); //@line 133232 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 133232 "c/sqlite3.c"
   $13 = (($12) + ($3<<1)|0); //@line 133232 "c/sqlite3.c"
   $14 = HEAP16[$13>>1]|0; //@line 133232 "c/sqlite3.c"
   $15 = $14 << 16 >> 16; //@line 133232 "c/sqlite3.c"
   $16 = ($14<<16>>16)==(-2); //@line 133233 "c/sqlite3.c"
   if ($16) {
    $17 = ((($5)) + 40|0); //@line 133234 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 133234 "c/sqlite3.c"
    $19 = (((($18)) + 4|0) + (($3*20)|0)|0); //@line 133234 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 133234 "c/sqlite3.c"
    HEAP32[$7>>2] = $20; //@line 133234 "c/sqlite3.c"
    $21 = ((($5)) + 32|0); //@line 133235 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 133235 "c/sqlite3.c"
    $23 = (($22) + ($3<<2)|0); //@line 133235 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 133235 "c/sqlite3.c"
    HEAP32[$9>>2] = $24; //@line 133235 "c/sqlite3.c"
    $$1 = -2;
    break;
   }
   $25 = ((($5)) + 12|0); //@line 133236 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 133236 "c/sqlite3.c"
   $27 = ((($26)) + 40|0); //@line 133236 "c/sqlite3.c"
   $28 = HEAP16[$27>>1]|0; //@line 133236 "c/sqlite3.c"
   $29 = ($14<<16>>16)==($28<<16>>16); //@line 133236 "c/sqlite3.c"
   if ($29) {
    $$1 = -1;
   } else {
    $30 = ($14<<16>>16)>(-1); //@line 133238 "c/sqlite3.c"
    if ($30) {
     $31 = ((($26)) + 4|0); //@line 133239 "c/sqlite3.c"
     $32 = HEAP32[$31>>2]|0; //@line 133239 "c/sqlite3.c"
     $33 = (((($32) + ($15<<4)|0)) + 13|0); //@line 133239 "c/sqlite3.c"
     $34 = HEAP8[$33>>0]|0; //@line 133239 "c/sqlite3.c"
     HEAP8[$8>>0] = $34; //@line 133239 "c/sqlite3.c"
     $35 = ((($5)) + 32|0); //@line 133240 "c/sqlite3.c"
     $36 = HEAP32[$35>>2]|0; //@line 133240 "c/sqlite3.c"
     $37 = (($36) + ($3<<2)|0); //@line 133240 "c/sqlite3.c"
     $38 = HEAP32[$37>>2]|0; //@line 133240 "c/sqlite3.c"
     HEAP32[$9>>2] = $38; //@line 133240 "c/sqlite3.c"
     $$1 = $15;
    } else {
     $$1 = $15;
    }
   }
  }
 } while(0);
 $40 = ((($0)) + 20|0); //@line 133245 "c/sqlite3.c"
 HEAP32[$40>>2] = $4; //@line 133245 "c/sqlite3.c"
 $41 = ((($0)) + 24|0); //@line 133246 "c/sqlite3.c"
 HEAP32[$41>>2] = 0; //@line 133246 "c/sqlite3.c"
 $42 = ((($0)) + 28|0); //@line 133247 "c/sqlite3.c"
 HEAP32[$42>>2] = $2; //@line 133247 "c/sqlite3.c"
 $43 = $$1&65535; //@line 133248 "c/sqlite3.c"
 $44 = ((($0)) + 72|0); //@line 133248 "c/sqlite3.c"
 HEAP16[$44>>1] = $43; //@line 133248 "c/sqlite3.c"
 $45 = ((($0)) + 17|0); //@line 133249 "c/sqlite3.c"
 HEAP8[$45>>0] = 1; //@line 133249 "c/sqlite3.c"
 $46 = ((($0)) + 18|0); //@line 133250 "c/sqlite3.c"
 HEAP8[$46>>0] = 1; //@line 133250 "c/sqlite3.c"
 $47 = (_whereScanNext($0)|0); //@line 133251 "c/sqlite3.c"
 $$0 = $47;
 return ($$0|0); //@line 133252 "c/sqlite3.c"
}
function _whereScanNext($0) {
 $0 = $0|0;
 var $$093 = 0, $$094 = 0, $$095$lcssa = 0, $$095104 = 0, $$096 = 0, $$097109 = 0, $$098 = 0, $$1 = 0, $$199 = 0, $$2111 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0;
 var $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0;
 var $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 133122 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 133122 "c/sqlite3.c"
 $3 = ((($0)) + 4|0); //@line 133125 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 133125 "c/sqlite3.c"
 $5 = ((($0)) + 18|0);
 $6 = ((($0)) + 12|0);
 $7 = ((($0)) + 20|0);
 $8 = ((($0)) + 17|0);
 $9 = ((($0)) + 8|0);
 $10 = ((($0)) + 16|0);
 $11 = ((($0)) + 28|0);
 $12 = ((($0)) + 72|0);
 $13 = ((($0)) + 17|0);
 $$096 = $2;$$098 = $4;
 L1: while(1) {
  $14 = HEAP8[$5>>0]|0; //@line 133127 "c/sqlite3.c"
  $15 = $14&255; //@line 133127 "c/sqlite3.c"
  $16 = (($15) + -1)|0; //@line 133127 "c/sqlite3.c"
  $17 = (((($0)) + 72|0) + ($16<<1)|0); //@line 133127 "c/sqlite3.c"
  $18 = HEAP16[$17>>1]|0; //@line 133127 "c/sqlite3.c"
  $19 = (((($0)) + 28|0) + ($16<<2)|0); //@line 133128 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 133128 "c/sqlite3.c"
  $21 = $18 << 16 >> 16;
  $22 = ($18<<16>>16)==(-2);
  $$1 = $$096;$$199 = $$098;
  while(1) {
   $23 = ((($$199)) + 12|0); //@line 133131 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 133131 "c/sqlite3.c"
   $25 = ($$1|0)<($24|0); //@line 133131 "c/sqlite3.c"
   if ($25) {
    $26 = ((($$199)) + 20|0); //@line 133131 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 133131 "c/sqlite3.c"
    $28 = (($27) + (($$1*48)|0)|0); //@line 133131 "c/sqlite3.c"
    $$097109 = $28;$$2111 = $$1;
    while(1) {
     $29 = ((($$097109)) + 20|0); //@line 133132 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 133132 "c/sqlite3.c"
     $31 = ($30|0)==($20|0); //@line 133132 "c/sqlite3.c"
     do {
      if ($31) {
       $32 = ((($$097109)) + 28|0); //@line 133133 "c/sqlite3.c"
       $33 = HEAP32[$32>>2]|0; //@line 133133 "c/sqlite3.c"
       $34 = ($33|0)==($21|0); //@line 133133 "c/sqlite3.c"
       if ($34) {
        if ($22) {
         $35 = HEAP32[$$097109>>2]|0; //@line 133135 "c/sqlite3.c"
         $36 = ((($35)) + 12|0); //@line 133135 "c/sqlite3.c"
         $37 = HEAP32[$36>>2]|0; //@line 133135 "c/sqlite3.c"
         $38 = HEAP32[$6>>2]|0; //@line 133136 "c/sqlite3.c"
         $39 = (_sqlite3ExprCompareSkip($37,$38,$20)|0); //@line 133135 "c/sqlite3.c"
         $40 = ($39|0)==(0); //@line 133136 "c/sqlite3.c"
         if (!($40)) {
          break;
         }
        }
        $41 = HEAP8[$5>>0]|0; //@line 133137 "c/sqlite3.c"
        $42 = ($41&255)<(2); //@line 133137 "c/sqlite3.c"
        if (!($42)) {
         $43 = HEAP32[$$097109>>2]|0; //@line 133137 "c/sqlite3.c"
         $44 = ((($43)) + 4|0); //@line 133137 "c/sqlite3.c"
         $45 = HEAP32[$44>>2]|0; //@line 133137 "c/sqlite3.c"
         $46 = $45 & 1; //@line 133137 "c/sqlite3.c"
         $47 = ($46|0)==(0); //@line 133137 "c/sqlite3.c"
         if (!($47)) {
          break;
         }
        }
        $48 = ((($$097109)) + 12|0); //@line 133139 "c/sqlite3.c"
        $49 = HEAP16[$48>>1]|0; //@line 133139 "c/sqlite3.c"
        $50 = $49 & 2048; //@line 133139 "c/sqlite3.c"
        $51 = ($50<<16>>16)==(0); //@line 133139 "c/sqlite3.c"
        if (!($51)) {
         $52 = HEAP8[$8>>0]|0; //@line 133140 "c/sqlite3.c"
         $53 = ($52&255)<(11); //@line 133140 "c/sqlite3.c"
         if ($53) {
          $54 = HEAP32[$$097109>>2]|0; //@line 133141 "c/sqlite3.c"
          $55 = ((($54)) + 16|0); //@line 133141 "c/sqlite3.c"
          $56 = HEAP32[$55>>2]|0; //@line 133141 "c/sqlite3.c"
          $57 = (_sqlite3ExprSkipCollate($56)|0); //@line 133141 "c/sqlite3.c"
          $58 = HEAP8[$57>>0]|0; //@line 133141 "c/sqlite3.c"
          $59 = ($58<<24>>24)==(-111); //@line 133141 "c/sqlite3.c"
          if ($59) {
           $60 = $52&255; //@line 133144 "c/sqlite3.c"
           $61 = ($52<<24>>24)==(0); //@line 133144 "c/sqlite3.c"
           L22: do {
            if ($61) {
             $$095$lcssa = 0;
            } else {
             $62 = ((($57)) + 28|0);
             $63 = HEAP32[$62>>2]|0;
             $64 = ((($57)) + 32|0);
             $$095104 = 0;
             while(1) {
              $65 = (((($0)) + 28|0) + ($$095104<<2)|0); //@line 133145 "c/sqlite3.c"
              $66 = HEAP32[$65>>2]|0; //@line 133145 "c/sqlite3.c"
              $67 = ($66|0)==($63|0); //@line 133145 "c/sqlite3.c"
              if ($67) {
               $68 = (((($0)) + 72|0) + ($$095104<<1)|0); //@line 133146 "c/sqlite3.c"
               $69 = HEAP16[$68>>1]|0; //@line 133146 "c/sqlite3.c"
               $70 = HEAP16[$64>>1]|0; //@line 133146 "c/sqlite3.c"
               $71 = ($69<<16>>16)==($70<<16>>16); //@line 133146 "c/sqlite3.c"
               if ($71) {
                $$095$lcssa = $$095104;
                break L22;
               }
              }
              $72 = (($$095104) + 1)|0; //@line 133144 "c/sqlite3.c"
              $73 = ($72>>>0)<($60>>>0); //@line 133144 "c/sqlite3.c"
              if ($73) {
               $$095104 = $72;
              } else {
               $$095$lcssa = $72;
               break;
              }
             }
            }
           } while(0);
           $74 = ($$095$lcssa|0)==($60|0); //@line 133150 "c/sqlite3.c"
           if ($74) {
            $75 = ((($57)) + 28|0); //@line 133151 "c/sqlite3.c"
            $76 = HEAP32[$75>>2]|0; //@line 133151 "c/sqlite3.c"
            $77 = (((($0)) + 28|0) + ($$095$lcssa<<2)|0); //@line 133151 "c/sqlite3.c"
            HEAP32[$77>>2] = $76; //@line 133151 "c/sqlite3.c"
            $78 = ((($57)) + 32|0); //@line 133152 "c/sqlite3.c"
            $79 = HEAP16[$78>>1]|0; //@line 133152 "c/sqlite3.c"
            $80 = (((($0)) + 72|0) + ($$095$lcssa<<1)|0); //@line 133152 "c/sqlite3.c"
            HEAP16[$80>>1] = $79; //@line 133152 "c/sqlite3.c"
            $81 = (($52) + 1)<<24>>24; //@line 133153 "c/sqlite3.c"
            HEAP8[$8>>0] = $81; //@line 133153 "c/sqlite3.c"
           }
          }
         }
        }
        $82 = HEAP16[$48>>1]|0; //@line 133156 "c/sqlite3.c"
        $83 = $82&65535; //@line 133156 "c/sqlite3.c"
        $84 = HEAP32[$7>>2]|0; //@line 133156 "c/sqlite3.c"
        $85 = $84 & $83; //@line 133156 "c/sqlite3.c"
        $86 = ($85|0)==(0); //@line 133156 "c/sqlite3.c"
        if (!($86)) {
         $87 = HEAP32[$9>>2]|0; //@line 133158 "c/sqlite3.c"
         $88 = ($87|0)!=(0|0); //@line 133158 "c/sqlite3.c"
         $89 = $83 & 256; //@line 133158 "c/sqlite3.c"
         $90 = ($89|0)==(0); //@line 133158 "c/sqlite3.c"
         $or$cond = $90 & $88; //@line 133158 "c/sqlite3.c"
         if ($or$cond) {
          $91 = HEAP32[$$199>>2]|0; //@line 133160 "c/sqlite3.c"
          $92 = HEAP32[$91>>2]|0; //@line 133160 "c/sqlite3.c"
          $93 = HEAP32[$$097109>>2]|0; //@line 133161 "c/sqlite3.c"
          $94 = HEAP8[$10>>0]|0; //@line 133162 "c/sqlite3.c"
          $95 = (_sqlite3IndexAffinityOk($93,$94)|0); //@line 133162 "c/sqlite3.c"
          $96 = ($95|0)==(0); //@line 133162 "c/sqlite3.c"
          if ($96) {
           break;
          }
          $97 = ((($93)) + 12|0); //@line 133167 "c/sqlite3.c"
          $98 = HEAP32[$97>>2]|0; //@line 133167 "c/sqlite3.c"
          $99 = ((($93)) + 16|0); //@line 133167 "c/sqlite3.c"
          $100 = HEAP32[$99>>2]|0; //@line 133167 "c/sqlite3.c"
          $101 = (_sqlite3BinaryCompareCollSeq($92,$98,$100)|0); //@line 133166 "c/sqlite3.c"
          $102 = ($101|0)==(0|0); //@line 133168 "c/sqlite3.c"
          if ($102) {
           $103 = HEAP32[$92>>2]|0; //@line 133168 "c/sqlite3.c"
           $104 = ((($103)) + 8|0); //@line 133168 "c/sqlite3.c"
           $105 = HEAP32[$104>>2]|0; //@line 133168 "c/sqlite3.c"
           $$094 = $105;
          } else {
           $$094 = $101;
          }
          $106 = HEAP32[$$094>>2]|0; //@line 133169 "c/sqlite3.c"
          $107 = HEAP32[$9>>2]|0; //@line 133169 "c/sqlite3.c"
          $108 = (_sqlite3StrICmp($106,$107)|0); //@line 133169 "c/sqlite3.c"
          $109 = ($108|0)==(0); //@line 133169 "c/sqlite3.c"
          if (!($109)) {
           break;
          }
         }
         $110 = HEAP16[$48>>1]|0; //@line 133173 "c/sqlite3.c"
         $111 = $110 & 130; //@line 133173 "c/sqlite3.c"
         $112 = ($111<<16>>16)==(0); //@line 133173 "c/sqlite3.c"
         if ($112) {
          break L1;
         }
         $113 = HEAP32[$$097109>>2]|0; //@line 133174 "c/sqlite3.c"
         $114 = ((($113)) + 16|0); //@line 133174 "c/sqlite3.c"
         $115 = HEAP32[$114>>2]|0; //@line 133174 "c/sqlite3.c"
         $116 = HEAP8[$115>>0]|0; //@line 133174 "c/sqlite3.c"
         $117 = ($116<<24>>24)==(-111); //@line 133174 "c/sqlite3.c"
         if (!($117)) {
          break L1;
         }
         $118 = ((($115)) + 28|0); //@line 133175 "c/sqlite3.c"
         $119 = HEAP32[$118>>2]|0; //@line 133175 "c/sqlite3.c"
         $120 = HEAP32[$11>>2]|0; //@line 133175 "c/sqlite3.c"
         $121 = ($119|0)==($120|0); //@line 133175 "c/sqlite3.c"
         if (!($121)) {
          break L1;
         }
         $122 = ((($115)) + 32|0); //@line 133176 "c/sqlite3.c"
         $123 = HEAP16[$122>>1]|0; //@line 133176 "c/sqlite3.c"
         $124 = HEAP16[$12>>1]|0; //@line 133176 "c/sqlite3.c"
         $125 = ($123<<16>>16)==($124<<16>>16); //@line 133176 "c/sqlite3.c"
         if (!($125)) {
          break L1;
         }
        }
       }
      }
     } while(0);
     $127 = (($$2111) + 1)|0; //@line 133131 "c/sqlite3.c"
     $128 = ((($$097109)) + 48|0); //@line 133131 "c/sqlite3.c"
     $129 = HEAP32[$23>>2]|0; //@line 133131 "c/sqlite3.c"
     $130 = ($127|0)<($129|0); //@line 133131 "c/sqlite3.c"
     if ($130) {
      $$097109 = $128;$$2111 = $127;
     } else {
      break;
     }
    }
   }
   $131 = ((($$199)) + 4|0); //@line 133187 "c/sqlite3.c"
   $132 = HEAP32[$131>>2]|0; //@line 133187 "c/sqlite3.c"
   $133 = ($132|0)==(0|0); //@line 133189 "c/sqlite3.c"
   if ($133) {
    break;
   } else {
    $$1 = 0;$$199 = $132;
   }
  }
  $134 = HEAP8[$5>>0]|0; //@line 133190 "c/sqlite3.c"
  $135 = HEAP8[$13>>0]|0; //@line 133190 "c/sqlite3.c"
  $136 = ($134&255)<($135&255); //@line 133190 "c/sqlite3.c"
  if (!($136)) {
   $$093 = 0;
   label = 36;
   break;
  }
  $137 = HEAP32[$0>>2]|0; //@line 133191 "c/sqlite3.c"
  $138 = (($134) + 1)<<24>>24; //@line 133193 "c/sqlite3.c"
  HEAP8[$5>>0] = $138; //@line 133193 "c/sqlite3.c"
  $$096 = 0;$$098 = $137;
 }
 if ((label|0) == 36) {
  return ($$093|0); //@line 133196 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = $$199; //@line 133181 "c/sqlite3.c"
 $126 = (($$2111) + 1)|0; //@line 133182 "c/sqlite3.c"
 HEAP32[$1>>2] = $126; //@line 133182 "c/sqlite3.c"
 $$093 = $$097109;
 return ($$093|0); //@line 133196 "c/sqlite3.c"
}
function _sqlite3ExprCompareSkip($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ExprSkipCollate($0)|0); //@line 97556 "c/sqlite3.c"
 $4 = (_sqlite3ExprSkipCollate($1)|0); //@line 97557 "c/sqlite3.c"
 $5 = (_sqlite3ExprCompare(0,$3,$4,$2)|0); //@line 97555 "c/sqlite3.c"
 return ($5|0); //@line 97555 "c/sqlite3.c"
}
function _sqlite3IndexAffinityOk($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$shrunk = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_comparisonAffinity($0)|0); //@line 92965 "c/sqlite3.c"
 $3 = $2 << 24 >> 24; //@line 92966 "c/sqlite3.c"
 switch ($3|0) {
 case 65:  {
  $$0$shrunk = 1;
  break;
 }
 case 66:  {
  $4 = ($1<<24>>24)==(66); //@line 92970 "c/sqlite3.c"
  $$0$shrunk = $4;
  break;
 }
 default: {
  $5 = ($1<<24>>24)>(66); //@line 92972 "c/sqlite3.c"
  $$0$shrunk = $5;
 }
 }
 $$0 = $$0$shrunk&1;
 return ($$0|0); //@line 92974 "c/sqlite3.c"
}
function _comparisonAffinity($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 92947 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 92947 "c/sqlite3.c"
 $3 = (_sqlite3ExprAffinity($2)|0); //@line 92947 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 92948 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 92948 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 92948 "c/sqlite3.c"
 if (!($6)) {
  $7 = (_sqlite3CompareAffinity($5,$3)|0); //@line 92949 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 92955 "c/sqlite3.c"
 }
 $8 = ((($0)) + 4|0); //@line 92950 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 92950 "c/sqlite3.c"
 $10 = $9 & 2048; //@line 92950 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 92950 "c/sqlite3.c"
 if ($11) {
  $18 = ($3<<24>>24)==(0); //@line 92952 "c/sqlite3.c"
  $spec$select = $18 ? 65 : $3; //@line 92952 "c/sqlite3.c"
  return ($spec$select|0); //@line 92952 "c/sqlite3.c"
 }
 $12 = ((($0)) + 20|0); //@line 92951 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 92951 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 92951 "c/sqlite3.c"
 $15 = ((($14)) + 4|0); //@line 92951 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 92951 "c/sqlite3.c"
 $17 = (_sqlite3CompareAffinity($16,$3)|0); //@line 92951 "c/sqlite3.c"
 $$0 = $17;
 return ($$0|0); //@line 92955 "c/sqlite3.c"
}
function _exprIdxCover($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 97622 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(-111); //@line 97622 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 97630 "c/sqlite3.c"
 }
 $4 = ((($1)) + 28|0); //@line 97623 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 97623 "c/sqlite3.c"
 $6 = ((($0)) + 24|0); //@line 97623 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 97623 "c/sqlite3.c"
 $8 = ((($7)) + 4|0); //@line 97623 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 97623 "c/sqlite3.c"
 $10 = ($5|0)==($9|0); //@line 97623 "c/sqlite3.c"
 if (!($10)) {
  $$0 = 0;
  return ($$0|0); //@line 97630 "c/sqlite3.c"
 }
 $11 = HEAP32[$7>>2]|0; //@line 97624 "c/sqlite3.c"
 $12 = ((($1)) + 32|0); //@line 97624 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 97624 "c/sqlite3.c"
 $14 = (_sqlite3ColumnOfIndex($11,$13)|0); //@line 97624 "c/sqlite3.c"
 $15 = ($14<<16>>16)<(0); //@line 97624 "c/sqlite3.c"
 if (!($15)) {
  $$0 = 0;
  return ($$0|0); //@line 97630 "c/sqlite3.c"
 }
 $16 = ((($0)) + 20|0); //@line 97626 "c/sqlite3.c"
 HEAP8[$16>>0] = 1; //@line 97626 "c/sqlite3.c"
 $$0 = 2;
 return ($$0|0); //@line 97630 "c/sqlite3.c"
}
function _whereIndexExprTransNode($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 130280 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 130280 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 130281 "c/sqlite3.c"
 $5 = ((($3)) + 4|0); //@line 130281 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 130281 "c/sqlite3.c"
 $7 = (_sqlite3ExprCompare(0,$1,$4,$6)|0); //@line 130281 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 130281 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 0;
  return ($$0|0); //@line 130290 "c/sqlite3.c"
 }
 HEAP8[$1>>0] = -111; //@line 130282 "c/sqlite3.c"
 $9 = ((($3)) + 8|0); //@line 130283 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 130283 "c/sqlite3.c"
 $11 = ((($1)) + 28|0); //@line 130283 "c/sqlite3.c"
 HEAP32[$11>>2] = $10; //@line 130283 "c/sqlite3.c"
 $12 = ((($3)) + 12|0); //@line 130284 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 130284 "c/sqlite3.c"
 $14 = $13&65535; //@line 130284 "c/sqlite3.c"
 $15 = ((($1)) + 32|0); //@line 130284 "c/sqlite3.c"
 HEAP16[$15>>1] = $14; //@line 130284 "c/sqlite3.c"
 $16 = ((($1)) + 44|0); //@line 130285 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 130285 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 130290 "c/sqlite3.c"
}
function _sqlite3ExprNeedsNoAffinityChange($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$015 = 0, $$015$shrunk = 0, $$016$lcssa = 0, $$01617 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $narrow = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1<<24>>24)==(65); //@line 94723 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$015$shrunk = 1;
  } else {
   $3 = HEAP8[$0>>0]|0; //@line 94724 "c/sqlite3.c"
   $4 = $3 | 1; //@line 94724 "c/sqlite3.c"
   $5 = ($4<<24>>24)==(-107); //@line 94724 "c/sqlite3.c"
   if ($5) {
    $$01617 = $0;
    while(1) {
     $6 = ((($$01617)) + 12|0); //@line 94724 "c/sqlite3.c"
     $7 = HEAP32[$6>>2]|0; //@line 94724 "c/sqlite3.c"
     $8 = HEAP8[$7>>0]|0; //@line 94724 "c/sqlite3.c"
     $9 = $8 | 1; //@line 94724 "c/sqlite3.c"
     $10 = ($9<<24>>24)==(-107); //@line 94724 "c/sqlite3.c"
     if ($10) {
      $$01617 = $7;
     } else {
      $$016$lcssa = $7;$$lcssa = $8;
      break;
     }
    }
   } else {
    $$016$lcssa = $0;$$lcssa = $3;
   }
   $11 = ($$lcssa<<24>>24)==(-106); //@line 94726 "c/sqlite3.c"
   if ($11) {
    $12 = ((($$016$lcssa)) + 38|0); //@line 94726 "c/sqlite3.c"
    $13 = HEAP8[$12>>0]|0; //@line 94726 "c/sqlite3.c"
    $$0 = $13;
   } else {
    $$0 = $$lcssa;
   }
   switch ($$0<<24>>24) {
   case -123:  {
    $$015$shrunk = 1;
    break L1;
    break;
   }
   case -122:  {
    $14 = (($1) + -67)<<24>>24; //@line 94729 "c/sqlite3.c"
    $15 = ($14&255)<(2); //@line 94729 "c/sqlite3.c"
    $$015$shrunk = $15;
    break L1;
    break;
   }
   case -124:  {
    $16 = ($1<<24>>24)==(69); //@line 94732 "c/sqlite3.c"
    $17 = ($1<<24>>24)==(67); //@line 94732 "c/sqlite3.c"
    $18 = $16 | $17; //@line 94732 "c/sqlite3.c"
    $$015$shrunk = $18;
    break L1;
    break;
   }
   case 97:  {
    $19 = ($1<<24>>24)==(66); //@line 94735 "c/sqlite3.c"
    $$015$shrunk = $19;
    break L1;
    break;
   }
   case -111:  {
    $20 = ((($$016$lcssa)) + 32|0); //@line 94742 "c/sqlite3.c"
    $21 = HEAP16[$20>>1]|0; //@line 94742 "c/sqlite3.c"
    $22 = ($21<<16>>16)<(0); //@line 94742 "c/sqlite3.c"
    $23 = (($1) + -67)<<24>>24; //@line 94743 "c/sqlite3.c"
    $24 = ($23&255)<(2); //@line 94743 "c/sqlite3.c"
    $narrow = $24 & $22; //@line 94743 "c/sqlite3.c"
    $$015$shrunk = $narrow;
    break L1;
    break;
   }
   default: {
    $$015$shrunk = 0;
    break L1;
   }
   }
  }
 } while(0);
 $$015 = $$015$shrunk&1;
 return ($$015|0); //@line 94749 "c/sqlite3.c"
}
function _removeUnindexableInClauseTerms($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$lcssa = 0, $$072$lcssa = 0, $$07278 = 0, $$07477 = 0, $$079 = 0, $$1 = 0, $$173 = 0, $$17576 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 129584 "c/sqlite3.c"
 $5 = (_sqlite3ExprDup($4,$3,0)|0); //@line 129585 "c/sqlite3.c"
 $6 = ((($4)) + 73|0); //@line 129586 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 129586 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 129586 "c/sqlite3.c"
 if (!($8)) {
  return ($5|0); //@line 129640 "c/sqlite3.c"
 }
 $9 = ((($5)) + 20|0); //@line 129587 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 129587 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 129587 "c/sqlite3.c"
 $12 = ((($5)) + 12|0); //@line 129588 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 129588 "c/sqlite3.c"
 $14 = ((($13)) + 20|0); //@line 129588 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 129588 "c/sqlite3.c"
 $16 = ((($2)) + 40|0); //@line 129594 "c/sqlite3.c"
 $17 = HEAP16[$16>>1]|0; //@line 129594 "c/sqlite3.c"
 $18 = $17&65535; //@line 129594 "c/sqlite3.c"
 $19 = ($18|0)>($1|0); //@line 129594 "c/sqlite3.c"
 if ($19) {
  $20 = ((($2)) + 48|0);
  $$07278 = 0;$$07477 = $1;$$079 = 0;
  while(1) {
   $21 = HEAP32[$20>>2]|0; //@line 129595 "c/sqlite3.c"
   $22 = (($21) + ($$07477<<2)|0); //@line 129595 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 129595 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 129595 "c/sqlite3.c"
   $25 = ($24|0)==($3|0); //@line 129595 "c/sqlite3.c"
   if ($25) {
    $26 = ((($23)) + 24|0); //@line 129596 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 129596 "c/sqlite3.c"
    $28 = (($27) + -1)|0; //@line 129596 "c/sqlite3.c"
    $29 = (((($11)) + 4|0) + (($28*20)|0)|0); //@line 129598 "c/sqlite3.c"
    $30 = HEAP32[$29>>2]|0; //@line 129598 "c/sqlite3.c"
    $31 = (_sqlite3ExprListAppend($0,$$079,$30)|0); //@line 129598 "c/sqlite3.c"
    HEAP32[$29>>2] = 0; //@line 129599 "c/sqlite3.c"
    $32 = (((($15)) + 4|0) + (($28*20)|0)|0); //@line 129601 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 129601 "c/sqlite3.c"
    $34 = (_sqlite3ExprListAppend($0,$$07278,$33)|0); //@line 129601 "c/sqlite3.c"
    HEAP32[$32>>2] = 0; //@line 129602 "c/sqlite3.c"
    $$1 = $31;$$173 = $34;
   } else {
    $$1 = $$079;$$173 = $$07278;
   }
   $35 = (($$07477) + 1)|0; //@line 129594 "c/sqlite3.c"
   $36 = HEAP16[$16>>1]|0; //@line 129594 "c/sqlite3.c"
   $37 = $36&65535; //@line 129594 "c/sqlite3.c"
   $38 = ($35|0)<($37|0); //@line 129594 "c/sqlite3.c"
   if ($38) {
    $$07278 = $$173;$$07477 = $35;$$079 = $$1;
   } else {
    $$0$lcssa = $$1;$$072$lcssa = $$173;
    break;
   }
  }
 } else {
  $$0$lcssa = 0;$$072$lcssa = 0;
 }
 _sqlite3ExprListDelete($4,$11); //@line 129605 "c/sqlite3.c"
 _sqlite3ExprListDelete($4,$15); //@line 129606 "c/sqlite3.c"
 $39 = HEAP32[$12>>2]|0; //@line 129607 "c/sqlite3.c"
 $40 = ((($39)) + 20|0); //@line 129607 "c/sqlite3.c"
 HEAP32[$40>>2] = $$072$lcssa; //@line 129607 "c/sqlite3.c"
 $41 = HEAP32[$9>>2]|0; //@line 129608 "c/sqlite3.c"
 HEAP32[$41>>2] = $$0$lcssa; //@line 129608 "c/sqlite3.c"
 $42 = ($$072$lcssa|0)==(0|0); //@line 129609 "c/sqlite3.c"
 if (!($42)) {
  $43 = HEAP32[$$072$lcssa>>2]|0; //@line 129609 "c/sqlite3.c"
  $44 = ($43|0)==(1); //@line 129609 "c/sqlite3.c"
  if ($44) {
   $45 = ((($$072$lcssa)) + 4|0); //@line 129613 "c/sqlite3.c"
   $46 = HEAP32[$45>>2]|0; //@line 129613 "c/sqlite3.c"
   HEAP32[$45>>2] = 0; //@line 129614 "c/sqlite3.c"
   $47 = HEAP32[$12>>2]|0; //@line 129615 "c/sqlite3.c"
   _sqlite3ExprDelete($4,$47); //@line 129615 "c/sqlite3.c"
   HEAP32[$12>>2] = $46; //@line 129616 "c/sqlite3.c"
  }
 }
 $48 = HEAP32[$9>>2]|0; //@line 129618 "c/sqlite3.c"
 $49 = ((($48)) + 44|0); //@line 129619 "c/sqlite3.c"
 $50 = HEAP32[$49>>2]|0; //@line 129619 "c/sqlite3.c"
 $51 = ($50|0)==(0|0); //@line 129619 "c/sqlite3.c"
 if ($51) {
  return ($5|0); //@line 129640 "c/sqlite3.c"
 }
 $52 = HEAP32[$50>>2]|0; //@line 129628 "c/sqlite3.c"
 $53 = ($52|0)>(0); //@line 129628 "c/sqlite3.c"
 if (!($53)) {
  return ($5|0); //@line 129640 "c/sqlite3.c"
 }
 $54 = HEAP32[$50>>2]|0;
 $$17576 = 0;
 while(1) {
  $55 = (((((($50)) + 4|0) + (($$17576*20)|0)|0)) + 16|0); //@line 129629 "c/sqlite3.c"
  HEAP16[$55>>1] = 0; //@line 129629 "c/sqlite3.c"
  $56 = (($$17576) + 1)|0; //@line 129628 "c/sqlite3.c"
  $57 = ($56|0)<($54|0); //@line 129628 "c/sqlite3.c"
  if ($57) {
   $$17576 = $56;
  } else {
   break;
  }
 }
 return ($5|0); //@line 129640 "c/sqlite3.c"
}
function _explainIndexRange($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$041 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 129255 "c/sqlite3.c"
 $2 = ((($1)) + 32|0); //@line 129256 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 129256 "c/sqlite3.c"
 $4 = ((($1)) + 24|0); //@line 129257 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 129257 "c/sqlite3.c"
 $6 = $5&65535; //@line 129261 "c/sqlite3.c"
 $7 = ($5<<16>>16)==(0); //@line 129261 "c/sqlite3.c"
 do {
  if ($7) {
   $8 = ((($1)) + 36|0); //@line 129261 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 129261 "c/sqlite3.c"
   $10 = $9 & 48; //@line 129261 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 129261 "c/sqlite3.c"
   if ($11) {
    STACKTOP = sp;return; //@line 129278 "c/sqlite3.c"
   } else {
    _sqlite3StrAccumAppend($0,27611,2); //@line 129262 "c/sqlite3.c"
    $$0$lcssa = 0;
    break;
   }
  } else {
   $12 = ((($1)) + 42|0); //@line 129258 "c/sqlite3.c"
   $13 = HEAP16[$12>>1]|0; //@line 129258 "c/sqlite3.c"
   _sqlite3StrAccumAppend($0,27611,2); //@line 129262 "c/sqlite3.c"
   $14 = $13&65535;
   $$041 = 0;
   while(1) {
    $15 = (_explainIndexColumnName($3,$$041)|0); //@line 129264 "c/sqlite3.c"
    $16 = ($$041|0)==(0); //@line 129265 "c/sqlite3.c"
    if (!($16)) {
     _sqlite3StrAccumAppend($0,27614,5); //@line 129265 "c/sqlite3.c"
    }
    $17 = ($$041>>>0)<($14>>>0); //@line 129266 "c/sqlite3.c"
    $18 = $17 ? 27620 : 27628; //@line 129266 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $15; //@line 129266 "c/sqlite3.c"
    _sqlite3XPrintf($0,$18,$vararg_buffer); //@line 129266 "c/sqlite3.c"
    $19 = (($$041) + 1)|0; //@line 129263 "c/sqlite3.c"
    $exitcond = ($19|0)==($6|0); //@line 129263 "c/sqlite3.c"
    if ($exitcond) {
     $$0$lcssa = $6;
     break;
    } else {
     $$041 = $19;
    }
   }
  }
 } while(0);
 $20 = ((($1)) + 36|0); //@line 129270 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 129270 "c/sqlite3.c"
 $22 = $21 & 32; //@line 129270 "c/sqlite3.c"
 $23 = ($22|0)==(0); //@line 129270 "c/sqlite3.c"
 if ($23) {
  $$1 = $$0$lcssa;
 } else {
  $24 = ((($1)) + 26|0); //@line 129271 "c/sqlite3.c"
  $25 = HEAP16[$24>>1]|0; //@line 129271 "c/sqlite3.c"
  $26 = $25&65535; //@line 129271 "c/sqlite3.c"
  _explainAppendTerm($0,$3,$26,$$0$lcssa,$$0$lcssa,27528); //@line 129271 "c/sqlite3.c"
  $$1 = 1;
 }
 $27 = HEAP32[$20>>2]|0; //@line 129274 "c/sqlite3.c"
 $28 = $27 & 16; //@line 129274 "c/sqlite3.c"
 $29 = ($28|0)==(0); //@line 129274 "c/sqlite3.c"
 if (!($29)) {
  $30 = ((($1)) + 28|0); //@line 129275 "c/sqlite3.c"
  $31 = HEAP16[$30>>1]|0; //@line 129275 "c/sqlite3.c"
  $32 = $31&65535; //@line 129275 "c/sqlite3.c"
  _explainAppendTerm($0,$3,$32,$$0$lcssa,$$1,27526); //@line 129275 "c/sqlite3.c"
 }
 _sqlite3StrAccumAppend($0,20274,1); //@line 129277 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 129278 "c/sqlite3.c"
}
function _explainIndexColumnName($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 129197 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 129197 "c/sqlite3.c"
 $4 = (($3) + ($1<<1)|0); //@line 129197 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 129197 "c/sqlite3.c"
 switch ($5<<16>>16) {
 case -1:  {
  $$0 = 19225;
  return ($$0|0); //@line 129201 "c/sqlite3.c"
  break;
 }
 case -2:  {
  $$0 = 27635;
  return ($$0|0); //@line 129201 "c/sqlite3.c"
  break;
 }
 default: {
  $6 = $5 << 16 >> 16; //@line 129197 "c/sqlite3.c"
  $7 = ((($0)) + 12|0); //@line 129200 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 129200 "c/sqlite3.c"
  $9 = ((($8)) + 4|0); //@line 129200 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 129200 "c/sqlite3.c"
  $11 = (($10) + ($6<<4)|0); //@line 129200 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 129200 "c/sqlite3.c"
  $$0 = $12;
  return ($$0|0); //@line 129201 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _explainAppendTerm($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$028 = 0, $$127 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $exitcond32 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ($4|0)==(0); //@line 129222 "c/sqlite3.c"
 if (!($6)) {
  _sqlite3StrAccumAppend($0,27614,5); //@line 129222 "c/sqlite3.c"
 }
 $7 = ($2|0)>(1); //@line 129224 "c/sqlite3.c"
 if ($7) {
  _sqlite3StrAccumAppend($0,27633,1); //@line 129224 "c/sqlite3.c"
 } else {
  $8 = ($2|0)==(1); //@line 129225 "c/sqlite3.c"
  if (!($8)) {
   _sqlite3StrAccumAppend($0,$5,1); //@line 129231 "c/sqlite3.c"
   return; //@line 129239 "c/sqlite3.c"
  }
 }
 $$028 = 0;
 while(1) {
  $9 = ($$028|0)==(0); //@line 129226 "c/sqlite3.c"
  if (!($9)) {
   _sqlite3StrAccumAppend($0,17184,1); //@line 129226 "c/sqlite3.c"
  }
  $10 = (($$028) + ($3))|0; //@line 129227 "c/sqlite3.c"
  $11 = (_explainIndexColumnName($1,$10)|0); //@line 129227 "c/sqlite3.c"
  _sqlite3StrAccumAppendAll($0,$11); //@line 129227 "c/sqlite3.c"
  $12 = (($$028) + 1)|0; //@line 129225 "c/sqlite3.c"
  $exitcond32 = ($12|0)==($2|0); //@line 129225 "c/sqlite3.c"
  if ($exitcond32) {
   break;
  } else {
   $$028 = $12;
  }
 }
 if ($7) {
  _sqlite3StrAccumAppend($0,20274,1); //@line 129229 "c/sqlite3.c"
  _sqlite3StrAccumAppend($0,$5,1); //@line 129231 "c/sqlite3.c"
  _sqlite3StrAccumAppend($0,27633,1); //@line 129233 "c/sqlite3.c"
 } else {
  _sqlite3StrAccumAppend($0,$5,1); //@line 129231 "c/sqlite3.c"
  $13 = ($2|0)==(1); //@line 129234 "c/sqlite3.c"
  if (!($13)) {
   return; //@line 129239 "c/sqlite3.c"
  }
 }
 $$127 = 0;
 while(1) {
  $14 = ($$127|0)==(0); //@line 129235 "c/sqlite3.c"
  if (!($14)) {
   _sqlite3StrAccumAppend($0,17184,1); //@line 129235 "c/sqlite3.c"
  }
  _sqlite3StrAccumAppend($0,21718,1); //@line 129236 "c/sqlite3.c"
  $15 = (($$127) + 1)|0; //@line 129234 "c/sqlite3.c"
  $exitcond = ($15|0)==($2|0); //@line 129234 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$127 = $15;
  }
 }
 if (!($7)) {
  return; //@line 129239 "c/sqlite3.c"
 }
 _sqlite3StrAccumAppend($0,20274,1); //@line 129238 "c/sqlite3.c"
 return; //@line 129239 "c/sqlite3.c"
}
function _sqlite3ExprIsTableConstant($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_exprIsConst($0,3,$1)|0); //@line 94545 "c/sqlite3.c"
 return ($2|0); //@line 94545 "c/sqlite3.c"
}
function _termCanDriveIndex($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 20|0); //@line 133532 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 133532 "c/sqlite3.c"
 $6 = ((($1)) + 44|0); //@line 133532 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 133532 "c/sqlite3.c"
 $8 = ($5|0)==($7|0); //@line 133532 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 0;
  return ($$0|0); //@line 133549 "c/sqlite3.c"
 }
 $9 = ((($0)) + 12|0); //@line 133533 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 133533 "c/sqlite3.c"
 $11 = $10&65535; //@line 133533 "c/sqlite3.c"
 $12 = $11 & 130; //@line 133533 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 133533 "c/sqlite3.c"
 if ($13) {
  $$0 = 0;
  return ($$0|0); //@line 133549 "c/sqlite3.c"
 }
 $14 = ((($1)) + 36|0); //@line 133534 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 133534 "c/sqlite3.c"
 $16 = $15 & 8; //@line 133534 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 133534 "c/sqlite3.c"
 if (!($17)) {
  $18 = HEAP32[$0>>2]|0; //@line 133535 "c/sqlite3.c"
  $19 = ((($18)) + 4|0); //@line 133535 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 133535 "c/sqlite3.c"
  $21 = $20 & 1; //@line 133535 "c/sqlite3.c"
  $22 = ($21|0)!=(0); //@line 133535 "c/sqlite3.c"
  $23 = $11 & 128; //@line 133536 "c/sqlite3.c"
  $24 = ($23|0)==(0); //@line 133536 "c/sqlite3.c"
  $or$cond = $24 | $22; //@line 133536 "c/sqlite3.c"
  if (!($or$cond)) {
   $$0 = 0;
   return ($$0|0); //@line 133549 "c/sqlite3.c"
  }
 }
 $25 = ((($0)) + 32|0); //@line 133543 "c/sqlite3.c"
 $26 = $25; //@line 133543 "c/sqlite3.c"
 $27 = $26; //@line 133543 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 133543 "c/sqlite3.c"
 $29 = (($26) + 4)|0; //@line 133543 "c/sqlite3.c"
 $30 = $29; //@line 133543 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 133543 "c/sqlite3.c"
 $32 = $28 & $2; //@line 133543 "c/sqlite3.c"
 $33 = $31 & $3; //@line 133543 "c/sqlite3.c"
 $34 = ($32|0)==(0); //@line 133543 "c/sqlite3.c"
 $35 = ($33|0)==(0); //@line 133543 "c/sqlite3.c"
 $36 = $34 & $35; //@line 133543 "c/sqlite3.c"
 if (!($36)) {
  $$0 = 0;
  return ($$0|0); //@line 133549 "c/sqlite3.c"
 }
 $37 = ((($0)) + 28|0); //@line 133544 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 133544 "c/sqlite3.c"
 $39 = ($38|0)<(0); //@line 133544 "c/sqlite3.c"
 if ($39) {
  $$0 = 0;
  return ($$0|0); //@line 133549 "c/sqlite3.c"
 }
 $40 = ((($1)) + 16|0); //@line 133545 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 133545 "c/sqlite3.c"
 $42 = ((($41)) + 4|0); //@line 133545 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 133545 "c/sqlite3.c"
 $44 = (((($43) + ($38<<4)|0)) + 13|0); //@line 133545 "c/sqlite3.c"
 $45 = HEAP8[$44>>0]|0; //@line 133545 "c/sqlite3.c"
 $46 = HEAP32[$0>>2]|0; //@line 133546 "c/sqlite3.c"
 $47 = (_sqlite3IndexAffinityOk($46,$45)|0); //@line 133546 "c/sqlite3.c"
 $48 = ($47|0)!=(0); //@line 133546 "c/sqlite3.c"
 $$ = $48&1; //@line 133546 "c/sqlite3.c"
 $$0 = $$;
 return ($$0|0); //@line 133549 "c/sqlite3.c"
}
function _whereLoopResize($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 44|0); //@line 134751 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 134751 "c/sqlite3.c"
 $5 = $4&65535; //@line 134751 "c/sqlite3.c"
 $6 = ($5|0)<($2|0); //@line 134751 "c/sqlite3.c"
 if (!($6)) {
  $$0 = 0;
  return ($$0|0); //@line 134760 "c/sqlite3.c"
 }
 $7 = (($2) + 7)|0; //@line 134752 "c/sqlite3.c"
 $8 = $7 & -8; //@line 134752 "c/sqlite3.c"
 $9 = $8 << 2; //@line 134753 "c/sqlite3.c"
 $10 = (_sqlite3DbMallocRawNN($0,$9,0)|0); //@line 134753 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 134754 "c/sqlite3.c"
 if ($11) {
  $$0 = 7;
  return ($$0|0); //@line 134760 "c/sqlite3.c"
 }
 $12 = ((($1)) + 48|0); //@line 134755 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 134755 "c/sqlite3.c"
 $14 = HEAP16[$3>>1]|0; //@line 134755 "c/sqlite3.c"
 $15 = $14&65535; //@line 134755 "c/sqlite3.c"
 $16 = $15 << 2; //@line 134755 "c/sqlite3.c"
 _memcpy(($10|0),($13|0),($16|0))|0; //@line 134755 "c/sqlite3.c"
 $17 = HEAP32[$12>>2]|0; //@line 134756 "c/sqlite3.c"
 $18 = ((($1)) + 56|0); //@line 134756 "c/sqlite3.c"
 $19 = ($17|0)==($18|0); //@line 134756 "c/sqlite3.c"
 if (!($19)) {
  _sqlite3DbFreeNN($0,$17); //@line 134756 "c/sqlite3.c"
 }
 HEAP32[$12>>2] = $10; //@line 134757 "c/sqlite3.c"
 $20 = $8&65535; //@line 134758 "c/sqlite3.c"
 HEAP16[$3>>1] = $20; //@line 134758 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 134760 "c/sqlite3.c"
}
function _sqlite3AllocateIndexObject($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = $1 << 16 >> 16; //@line 104486 "c/sqlite3.c"
 $5 = $4 << 2; //@line 104486 "c/sqlite3.c"
 $6 = (($5) + 7)|0; //@line 104486 "c/sqlite3.c"
 $7 = $6 & -8; //@line 104486 "c/sqlite3.c"
 $8 = (($7) + 64)|0; //@line 104485 "c/sqlite3.c"
 $9 = $4 << 1; //@line 104487 "c/sqlite3.c"
 $10 = (($9) + 2)|0; //@line 104487 "c/sqlite3.c"
 $11 = (($4) + 7)|0; //@line 104487 "c/sqlite3.c"
 $12 = (($11) + ($9))|0; //@line 104487 "c/sqlite3.c"
 $13 = (($12) + ($10))|0; //@line 104487 "c/sqlite3.c"
 $14 = $13 & -8; //@line 104487 "c/sqlite3.c"
 $15 = (($8) + ($14))|0; //@line 104486 "c/sqlite3.c"
 $16 = (($15) + ($2))|0; //@line 104490 "c/sqlite3.c"
 $17 = ($16|0)<(0); //@line 104490 "c/sqlite3.c"
 $18 = $17 << 31 >> 31; //@line 104490 "c/sqlite3.c"
 $19 = (_sqlite3DbMallocZero($0,$16,$18)|0); //@line 104490 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 104491 "c/sqlite3.c"
 if ($20) {
  return ($19|0); //@line 104501 "c/sqlite3.c"
 }
 $21 = ((($19)) + 64|0); //@line 104492 "c/sqlite3.c"
 $22 = ((($19)) + 32|0); //@line 104493 "c/sqlite3.c"
 HEAP32[$22>>2] = $21; //@line 104493 "c/sqlite3.c"
 $23 = (($21) + ($7)|0); //@line 104493 "c/sqlite3.c"
 $24 = ((($19)) + 8|0); //@line 104494 "c/sqlite3.c"
 HEAP32[$24>>2] = $23; //@line 104494 "c/sqlite3.c"
 $25 = (($23) + ($10)|0); //@line 104494 "c/sqlite3.c"
 $26 = ((($19)) + 4|0); //@line 104495 "c/sqlite3.c"
 HEAP32[$26>>2] = $25; //@line 104495 "c/sqlite3.c"
 $27 = (($25) + ($9)|0); //@line 104495 "c/sqlite3.c"
 $28 = ((($19)) + 28|0); //@line 104496 "c/sqlite3.c"
 HEAP32[$28>>2] = $27; //@line 104496 "c/sqlite3.c"
 $29 = ((($19)) + 52|0); //@line 104497 "c/sqlite3.c"
 HEAP16[$29>>1] = $1; //@line 104497 "c/sqlite3.c"
 $30 = (($4) + 65535)|0; //@line 104498 "c/sqlite3.c"
 $31 = $30&65535; //@line 104498 "c/sqlite3.c"
 $32 = ((($19)) + 50|0); //@line 104498 "c/sqlite3.c"
 HEAP16[$32>>1] = $31; //@line 104498 "c/sqlite3.c"
 $33 = (($19) + ($15)|0); //@line 104499 "c/sqlite3.c"
 HEAP32[$3>>2] = $33; //@line 104499 "c/sqlite3.c"
 return ($19|0); //@line 104501 "c/sqlite3.c"
}
function _sqlite3WhereExprUsage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 132819 "c/sqlite3.c"
 if ($2) {
  $49 = 0;$50 = 0;
  tempRet0 = ($49); //@line 132836 "c/sqlite3.c"
  return ($50|0); //@line 132836 "c/sqlite3.c"
 }
 $3 = HEAP8[$1>>0]|0; //@line 132820 "c/sqlite3.c"
 switch ($3<<24>>24) {
 case -111:  {
  $4 = ((($1)) + 28|0); //@line 132821 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 132821 "c/sqlite3.c"
  $6 = (_sqlite3WhereGetMask($0,$5)|0); //@line 132821 "c/sqlite3.c"
  $7 = tempRet0; //@line 132821 "c/sqlite3.c"
  $49 = $7;$50 = $6;
  tempRet0 = ($49); //@line 132836 "c/sqlite3.c"
  return ($50|0); //@line 132836 "c/sqlite3.c"
  break;
 }
 case -103:  {
  $8 = ((($1)) + 28|0); //@line 132823 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 132823 "c/sqlite3.c"
  $10 = (_sqlite3WhereGetMask($0,$9)|0); //@line 132823 "c/sqlite3.c"
  $11 = tempRet0; //@line 132823 "c/sqlite3.c"
  $18 = $10;$20 = $11;
  break;
 }
 default: {
  $18 = 0;$20 = 0;
 }
 }
 $12 = ((($1)) + 12|0); //@line 132825 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 132825 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 132825 "c/sqlite3.c"
 if ($14) {
  $27 = $18;$29 = $20;
 } else {
  $15 = (_sqlite3WhereExprUsage($0,$13)|0); //@line 132825 "c/sqlite3.c"
  $16 = tempRet0; //@line 132825 "c/sqlite3.c"
  $17 = $15 | $18; //@line 132825 "c/sqlite3.c"
  $19 = $16 | $20; //@line 132825 "c/sqlite3.c"
  $27 = $17;$29 = $19;
 }
 $21 = ((($1)) + 16|0); //@line 132826 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 132826 "c/sqlite3.c"
 $23 = ($22|0)==(0|0); //@line 132826 "c/sqlite3.c"
 if (!($23)) {
  $24 = (_sqlite3WhereExprUsage($0,$22)|0); //@line 132827 "c/sqlite3.c"
  $25 = tempRet0; //@line 132827 "c/sqlite3.c"
  $26 = $24 | $27; //@line 132827 "c/sqlite3.c"
  $28 = $25 | $29; //@line 132827 "c/sqlite3.c"
  tempRet0 = ($28); //@line 132836 "c/sqlite3.c"
  return ($26|0); //@line 132836 "c/sqlite3.c"
 }
 $30 = ((($1)) + 4|0); //@line 132829 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 132829 "c/sqlite3.c"
 $32 = $31 & 2048; //@line 132829 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 132829 "c/sqlite3.c"
 if ($33) {
  $42 = ((($1)) + 20|0); //@line 132832 "c/sqlite3.c"
  $43 = HEAP32[$42>>2]|0; //@line 132832 "c/sqlite3.c"
  $44 = ($43|0)==(0|0); //@line 132832 "c/sqlite3.c"
  if ($44) {
   $49 = $29;$50 = $27;
   tempRet0 = ($49); //@line 132836 "c/sqlite3.c"
   return ($50|0); //@line 132836 "c/sqlite3.c"
  }
  $45 = (_sqlite3WhereExprListUsage($0,$43)|0); //@line 132833 "c/sqlite3.c"
  $46 = tempRet0; //@line 132833 "c/sqlite3.c"
  $47 = $45 | $27; //@line 132833 "c/sqlite3.c"
  $48 = $46 | $29; //@line 132833 "c/sqlite3.c"
  $49 = $48;$50 = $47;
  tempRet0 = ($49); //@line 132836 "c/sqlite3.c"
  return ($50|0); //@line 132836 "c/sqlite3.c"
 } else {
  $34 = $31 & 32; //@line 132830 "c/sqlite3.c"
  $35 = ($34|0)==(0); //@line 132830 "c/sqlite3.c"
  if (!($35)) {
   HEAP32[$0>>2] = 1; //@line 132830 "c/sqlite3.c"
  }
  $36 = ((($1)) + 20|0); //@line 132831 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 132831 "c/sqlite3.c"
  $38 = (_exprSelectUsage($0,$37)|0); //@line 132831 "c/sqlite3.c"
  $39 = tempRet0; //@line 132831 "c/sqlite3.c"
  $40 = $38 | $27; //@line 132831 "c/sqlite3.c"
  $41 = $39 | $29; //@line 132831 "c/sqlite3.c"
  $49 = $41;$50 = $40;
  tempRet0 = ($49); //@line 132836 "c/sqlite3.c"
  return ($50|0); //@line 132836 "c/sqlite3.c"
 }
 return (0)|0;
}
function _exprSelectUsage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$03540 = 0, $$038 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 132243 "c/sqlite3.c"
 if ($2) {
  $59 = 0;$60 = 0;
  tempRet0 = ($59); //@line 132259 "c/sqlite3.c"
  return ($60|0); //@line 132259 "c/sqlite3.c"
 }
 $$03540 = $1;$11 = 0;$9 = 0;
 while(1) {
  $3 = ((($$03540)) + 28|0); //@line 132244 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 132244 "c/sqlite3.c"
  $5 = HEAP32[$$03540>>2]|0; //@line 132245 "c/sqlite3.c"
  $6 = (_sqlite3WhereExprListUsage($0,$5)|0); //@line 132245 "c/sqlite3.c"
  $7 = tempRet0; //@line 132245 "c/sqlite3.c"
  $8 = $6 | $9; //@line 132245 "c/sqlite3.c"
  $10 = $7 | $11; //@line 132245 "c/sqlite3.c"
  $12 = ((($$03540)) + 36|0); //@line 132246 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 132246 "c/sqlite3.c"
  $14 = (_sqlite3WhereExprListUsage($0,$13)|0); //@line 132246 "c/sqlite3.c"
  $15 = tempRet0; //@line 132246 "c/sqlite3.c"
  $16 = $8 | $14; //@line 132246 "c/sqlite3.c"
  $17 = $10 | $15; //@line 132246 "c/sqlite3.c"
  $18 = ((($$03540)) + 44|0); //@line 132247 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 132247 "c/sqlite3.c"
  $20 = (_sqlite3WhereExprListUsage($0,$19)|0); //@line 132247 "c/sqlite3.c"
  $21 = tempRet0; //@line 132247 "c/sqlite3.c"
  $22 = $16 | $20; //@line 132247 "c/sqlite3.c"
  $23 = $17 | $21; //@line 132247 "c/sqlite3.c"
  $24 = ((($$03540)) + 32|0); //@line 132248 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 132248 "c/sqlite3.c"
  $26 = (_sqlite3WhereExprUsage($0,$25)|0); //@line 132248 "c/sqlite3.c"
  $27 = tempRet0; //@line 132248 "c/sqlite3.c"
  $28 = $22 | $26; //@line 132248 "c/sqlite3.c"
  $29 = $23 | $27; //@line 132248 "c/sqlite3.c"
  $30 = ((($$03540)) + 40|0); //@line 132249 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 132249 "c/sqlite3.c"
  $32 = (_sqlite3WhereExprUsage($0,$31)|0); //@line 132249 "c/sqlite3.c"
  $33 = tempRet0; //@line 132249 "c/sqlite3.c"
  $34 = $28 | $32; //@line 132249 "c/sqlite3.c"
  $35 = $29 | $33; //@line 132249 "c/sqlite3.c"
  $36 = ($4|0)==(0|0); //@line 132250 "c/sqlite3.c"
  if ($36) {
   $61 = $34;$62 = $35;
  } else {
   $37 = HEAP32[$4>>2]|0; //@line 132252 "c/sqlite3.c"
   $38 = ($37|0)>(0); //@line 132252 "c/sqlite3.c"
   if ($38) {
    $$038 = 0;$44 = $34;$46 = $35;
    while(1) {
     $39 = (((((($4)) + 8|0) + (($$038*72)|0)|0)) + 20|0); //@line 132253 "c/sqlite3.c"
     $40 = HEAP32[$39>>2]|0; //@line 132253 "c/sqlite3.c"
     $41 = (_exprSelectUsage($0,$40)|0); //@line 132253 "c/sqlite3.c"
     $42 = tempRet0; //@line 132253 "c/sqlite3.c"
     $43 = $41 | $44; //@line 132253 "c/sqlite3.c"
     $45 = $42 | $46; //@line 132253 "c/sqlite3.c"
     $47 = (((((($4)) + 8|0) + (($$038*72)|0)|0)) + 48|0); //@line 132254 "c/sqlite3.c"
     $48 = HEAP32[$47>>2]|0; //@line 132254 "c/sqlite3.c"
     $49 = (_sqlite3WhereExprUsage($0,$48)|0); //@line 132254 "c/sqlite3.c"
     $50 = tempRet0; //@line 132254 "c/sqlite3.c"
     $51 = $43 | $49; //@line 132254 "c/sqlite3.c"
     $52 = $45 | $50; //@line 132254 "c/sqlite3.c"
     $53 = (($$038) + 1)|0; //@line 132252 "c/sqlite3.c"
     $54 = HEAP32[$4>>2]|0; //@line 132252 "c/sqlite3.c"
     $55 = ($53|0)<($54|0); //@line 132252 "c/sqlite3.c"
     if ($55) {
      $$038 = $53;$44 = $51;$46 = $52;
     } else {
      $61 = $51;$62 = $52;
      break;
     }
    }
   } else {
    $61 = $34;$62 = $35;
   }
  }
  $56 = ((($$03540)) + 48|0); //@line 132257 "c/sqlite3.c"
  $57 = HEAP32[$56>>2]|0; //@line 132257 "c/sqlite3.c"
  $58 = ($57|0)==(0|0); //@line 132243 "c/sqlite3.c"
  if ($58) {
   $59 = $62;$60 = $61;
   break;
  } else {
   $$03540 = $57;$11 = $62;$9 = $61;
  }
 }
 tempRet0 = ($59); //@line 132259 "c/sqlite3.c"
 return ($60|0); //@line 132259 "c/sqlite3.c"
}
function _sqlite3LogEstAdd($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $0 << 16 >> 16; //@line 29903 "c/sqlite3.c"
 $3 = $1 << 16 >> 16; //@line 29903 "c/sqlite3.c"
 $4 = ($0<<16>>16)<($1<<16>>16); //@line 29903 "c/sqlite3.c"
 if ($4) {
  $17 = (($2) + 49)|0; //@line 29908 "c/sqlite3.c"
  $18 = ($17|0)<($3|0); //@line 29908 "c/sqlite3.c"
  if ($18) {
   $$0 = $1;
   return ($$0|0); //@line 29912 "c/sqlite3.c"
  }
  $19 = (($2) + 31)|0; //@line 29909 "c/sqlite3.c"
  $20 = ($19|0)<($3|0); //@line 29909 "c/sqlite3.c"
  if ($20) {
   $21 = (($3) + 1)|0; //@line 29909 "c/sqlite3.c"
   $22 = $21&65535; //@line 29909 "c/sqlite3.c"
   $$0 = $22;
   return ($$0|0); //@line 29912 "c/sqlite3.c"
  } else {
   $23 = (($3) - ($2))|0; //@line 29910 "c/sqlite3.c"
   $24 = (27697 + ($23)|0); //@line 29910 "c/sqlite3.c"
   $25 = HEAP8[$24>>0]|0; //@line 29910 "c/sqlite3.c"
   $26 = $25&255; //@line 29910 "c/sqlite3.c"
   $27 = (($26) + ($3))|0; //@line 29910 "c/sqlite3.c"
   $28 = $27&65535; //@line 29910 "c/sqlite3.c"
   $$0 = $28;
   return ($$0|0); //@line 29912 "c/sqlite3.c"
  }
 } else {
  $5 = (($3) + 49)|0; //@line 29904 "c/sqlite3.c"
  $6 = ($5|0)<($2|0); //@line 29904 "c/sqlite3.c"
  if ($6) {
   $$0 = $0;
   return ($$0|0); //@line 29912 "c/sqlite3.c"
  }
  $7 = (($3) + 31)|0; //@line 29905 "c/sqlite3.c"
  $8 = ($7|0)<($2|0); //@line 29905 "c/sqlite3.c"
  if ($8) {
   $9 = (($2) + 1)|0; //@line 29905 "c/sqlite3.c"
   $10 = $9&65535; //@line 29905 "c/sqlite3.c"
   $$0 = $10;
   return ($$0|0); //@line 29912 "c/sqlite3.c"
  } else {
   $11 = (($2) - ($3))|0; //@line 29906 "c/sqlite3.c"
   $12 = (27697 + ($11)|0); //@line 29906 "c/sqlite3.c"
   $13 = HEAP8[$12>>0]|0; //@line 29906 "c/sqlite3.c"
   $14 = $13&255; //@line 29906 "c/sqlite3.c"
   $15 = (($14) + ($2))|0; //@line 29906 "c/sqlite3.c"
   $16 = $15&65535; //@line 29906 "c/sqlite3.c"
   $$0 = $16;
   return ($$0|0); //@line 29912 "c/sqlite3.c"
  }
 }
 return (0)|0;
}
function _wherePathSatisfiesOrderBy($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0243412 = 0, $$0246411 = 0, $$0249324 = 0, $$0250367 = 0, $$0250431 = 0, $$0253354 = 0, $$0253408 = 0, $$0288458 = 0, $$0289457 = 0, $$0291426 = 0, $$0294322 = 0, $$0295422 = 0, $$0296376 = 0, $$0298378 = 0, $$10 = 0, $$10344 = 0, $$11 = 0, $$1244$ph = 0, $$1247$ph = 0, $$1251459 = 0;
 var $$1292 = 0, $$1297403 = 0, $$1299 = 0, $$1299383 = 0, $$1299384 = 0, $$2 = 0, $$2245$ph = 0, $$2248$ph = 0, $$2252410 = 0, $$2255$ph = 0, $$2293 = 0, $$2300391 = 0, $$3260 = 0, $$3301418 = 0, $$4261393 = 0, $$4302373 = 0, $$4302373$in = 0, $$6 = 0, $$6263 = 0, $$7 = 0;
 var $$8$ph = 0, $$9 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0;
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0;
 var $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0;
 var $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0;
 var $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0;
 var $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0;
 var $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0;
 var $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0;
 var $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0;
 var $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0;
 var $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0;
 var $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0;
 var $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0;
 var $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0;
 var $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0;
 var $370 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0;
 var $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $brmerge = 0, $exitcond = 0, $exitcond455 = 0, $or$cond$not = 0, $or$cond303$not = 0, $or$cond304 = 0, $or$cond309 = 0, $or$cond309390 = 0, $or$cond316 = 0, $spec$select306 = 0, $spec$select307 = 0, $spec$select308 = 0, $spec$select310 = 0, $spec$select314 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $7 = $4&65535; //@line 136484 "c/sqlite3.c"
 $8 = ($4<<16>>16)==(0); //@line 136484 "c/sqlite3.c"
 if (!($8)) {
  $9 = HEAP32[$0>>2]|0; //@line 136455 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 136455 "c/sqlite3.c"
  $11 = ((($10)) + 68|0); //@line 136484 "c/sqlite3.c"
  $12 = HEAP16[$11>>1]|0; //@line 136484 "c/sqlite3.c"
  $13 = $12 & 64; //@line 136484 "c/sqlite3.c"
  $14 = ($13<<16>>16)==(0); //@line 136484 "c/sqlite3.c"
  if (!($14)) {
   $$2 = 0;
   return ($$2|0); //@line 136710 "c/sqlite3.c"
  }
 }
 $15 = HEAP32[$1>>2]|0; //@line 136486 "c/sqlite3.c"
 $16 = $15 & 65535; //@line 136488 "c/sqlite3.c"
 $17 = ($16>>>0)>(63); //@line 136488 "c/sqlite3.c"
 if ($17) {
  $$2 = 0;
  return ($$2|0); //@line 136710 "c/sqlite3.c"
 }
 $18 = (_bitshift64Shl(1,0,($16|0))|0); //@line 136490 "c/sqlite3.c"
 $19 = tempRet0; //@line 136490 "c/sqlite3.c"
 $20 = (_i64Add(($18|0),($19|0),-1,-1)|0); //@line 136490 "c/sqlite3.c"
 $21 = tempRet0; //@line 136490 "c/sqlite3.c"
 $22 = $3&65535; //@line 136494 "c/sqlite3.c"
 $23 = $22 & 2048; //@line 136494 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 136494 "c/sqlite3.c"
 $25 = $23 >>> 11; //@line 136494 "c/sqlite3.c"
 $26 = $25&65535; //@line 136494 "c/sqlite3.c"
 $27 = $26 | 386; //@line 136494 "c/sqlite3.c"
 $28 = ($20|0)==(0); //@line 136495 "c/sqlite3.c"
 $29 = ($21|0)==(0); //@line 136495 "c/sqlite3.c"
 $30 = $28 & $29; //@line 136495 "c/sqlite3.c"
 L8: do {
  if ($30) {
   $$0250367 = 1;$337 = 0;$339 = 0;
  } else {
   $31 = ((($2)) + 24|0);
   $32 = ((($0)) + 4|0);
   $33 = ($16|0)==(0);
   $34 = ((($0)) + 80|0);
   $35 = $27&65535;
   $36 = ($16|0)==(0);
   $37 = ((($0)) + 488|0);
   $38 = ($16|0)!=(0);
   $39 = $22 & 192;
   $40 = ($39|0)==(0);
   $41 = $22 & 64;
   $42 = ($41|0)==(0);
   $$0250431 = 1;$$0291426 = 0;$$0295422 = 0;$293 = 0;$295 = 0;$52 = 0;$54 = 0;$67 = 0;$69 = 0;
   L10: while(1) {
    $43 = ($$0295422|0)==(0); //@line 136496 "c/sqlite3.c"
    if ($43) {
     $79 = $52;$81 = $54;
    } else {
     $44 = ((($$0291426)) + 8|0); //@line 136496 "c/sqlite3.c"
     $45 = $44; //@line 136496 "c/sqlite3.c"
     $46 = $45; //@line 136496 "c/sqlite3.c"
     $47 = HEAP32[$46>>2]|0; //@line 136496 "c/sqlite3.c"
     $48 = (($45) + 4)|0; //@line 136496 "c/sqlite3.c"
     $49 = $48; //@line 136496 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 136496 "c/sqlite3.c"
     $51 = $47 | $52; //@line 136496 "c/sqlite3.c"
     $53 = $50 | $54; //@line 136496 "c/sqlite3.c"
     $79 = $51;$81 = $53;
    }
    $55 = ($$0295422>>>0)<($7>>>0); //@line 136497 "c/sqlite3.c"
    if ($55) {
     $56 = HEAP32[$31>>2]|0; //@line 136498 "c/sqlite3.c"
     $57 = (($56) + ($$0295422<<2)|0); //@line 136498 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 136498 "c/sqlite3.c"
     if ($24) {
      $$1292 = $58;
      label = 10;
     } else {
      $$11 = $$0250431;$$2293 = $58;$329 = $69;$331 = $67;$355 = $293;$356 = $295;
     }
    } else {
     $$1292 = $5;
     label = 10;
    }
    if ((label|0) == 10) {
     label = 0;
     $59 = ((($$1292)) + 36|0); //@line 136503 "c/sqlite3.c"
     $60 = HEAP32[$59>>2]|0; //@line 136503 "c/sqlite3.c"
     $61 = $60 & 1024; //@line 136503 "c/sqlite3.c"
     $62 = ($61|0)==(0); //@line 136503 "c/sqlite3.c"
     $63 = ((($$1292)) + 24|0);
     if (!($62)) {
      label = 11;
      break;
     }
     $71 = ((($$1292)) + 30|0); //@line 136507 "c/sqlite3.c"
     HEAP16[$71>>1] = 0; //@line 136507 "c/sqlite3.c"
     $72 = HEAP32[$32>>2]|0; //@line 136509 "c/sqlite3.c"
     $73 = ((($$1292)) + 16|0); //@line 136509 "c/sqlite3.c"
     $74 = HEAP8[$73>>0]|0; //@line 136509 "c/sqlite3.c"
     $75 = $74&255; //@line 136509 "c/sqlite3.c"
     $76 = (((((($72)) + 8|0) + (($75*72)|0)|0)) + 44|0); //@line 136509 "c/sqlite3.c"
     $77 = HEAP32[$76>>2]|0; //@line 136509 "c/sqlite3.c"
     if ($33) {
      $357 = $67;$358 = $69;
     } else {
      $78 = $79 ^ -1;
      $80 = $81 ^ -1;
      $82 = ((($$1292)) + 40|0);
      $83 = ((($$1292)) + 48|0);
      $$0298378 = 0;$87 = $67;$89 = $69;
      while(1) {
       $84 = (_bitshift64Shl(1,0,($$0298378|0))|0); //@line 136517 "c/sqlite3.c"
       $85 = tempRet0; //@line 136517 "c/sqlite3.c"
       $86 = $84 & $87; //@line 136517 "c/sqlite3.c"
       $88 = $85 & $89; //@line 136517 "c/sqlite3.c"
       $90 = ($86|0)==(0); //@line 136517 "c/sqlite3.c"
       $91 = ($88|0)==(0); //@line 136517 "c/sqlite3.c"
       $92 = $90 & $91; //@line 136517 "c/sqlite3.c"
       L24: do {
        if ($92) {
         $93 = (((($1)) + 4|0) + (($$0298378*20)|0)|0); //@line 136518 "c/sqlite3.c"
         $94 = HEAP32[$93>>2]|0; //@line 136518 "c/sqlite3.c"
         $95 = (_sqlite3ExprSkipCollate($94)|0); //@line 136518 "c/sqlite3.c"
         $96 = HEAP8[$95>>0]|0; //@line 136519 "c/sqlite3.c"
         $97 = ($96<<24>>24)==(-111); //@line 136519 "c/sqlite3.c"
         if ($97) {
          $98 = ((($95)) + 28|0); //@line 136520 "c/sqlite3.c"
          $99 = HEAP32[$98>>2]|0; //@line 136520 "c/sqlite3.c"
          $100 = ($99|0)==($77|0); //@line 136520 "c/sqlite3.c"
          if ($100) {
           $101 = ((($95)) + 32|0); //@line 136521 "c/sqlite3.c"
           $102 = HEAP16[$101>>1]|0; //@line 136521 "c/sqlite3.c"
           $103 = $102 << 16 >> 16; //@line 136521 "c/sqlite3.c"
           $104 = (_sqlite3WhereFindTerm($34,$77,$103,$78,$80,$35,0)|0); //@line 136521 "c/sqlite3.c"
           $105 = ($104|0)==(0|0); //@line 136523 "c/sqlite3.c"
           if ($105) {
            $359 = $87;$360 = $89;
           } else {
            $106 = ((($104)) + 12|0); //@line 136524 "c/sqlite3.c"
            $107 = HEAP16[$106>>1]|0; //@line 136524 "c/sqlite3.c"
            $108 = ($107<<16>>16)==(1); //@line 136524 "c/sqlite3.c"
            L29: do {
             if ($108) {
              $109 = HEAP16[$82>>1]|0; //@line 136529 "c/sqlite3.c"
              $110 = ($109<<16>>16)==(0); //@line 136529 "c/sqlite3.c"
              if ($110) {
               $359 = $87;$360 = $89;
               break L24;
              }
              $111 = HEAP32[$83>>2]|0;
              $$0296376 = 0;
              while(1) {
               $116 = (($111) + ($$0296376<<2)|0); //@line 136529 "c/sqlite3.c"
               $117 = HEAP32[$116>>2]|0; //@line 136529 "c/sqlite3.c"
               $118 = ($104|0)==($117|0); //@line 136529 "c/sqlite3.c"
               $115 = (($$0296376) + 1)|0; //@line 136529 "c/sqlite3.c"
               if ($118) {
                break L29;
               }
               $112 = HEAP16[$82>>1]|0; //@line 136529 "c/sqlite3.c"
               $113 = $112&65535; //@line 136529 "c/sqlite3.c"
               $114 = ($115>>>0)<($113>>>0); //@line 136529 "c/sqlite3.c"
               if ($114) {
                $$0296376 = $115;
               } else {
                $359 = $87;$360 = $89;
                break L24;
               }
              }
             }
            } while(0);
            $119 = $107 & 130; //@line 136532 "c/sqlite3.c"
            $120 = ($119<<16>>16)==(0); //@line 136532 "c/sqlite3.c"
            do {
             if (!($120)) {
              $121 = HEAP16[$101>>1]|0; //@line 136532 "c/sqlite3.c"
              $122 = ($121<<16>>16)>(-1); //@line 136532 "c/sqlite3.c"
              if (!($122)) {
               break;
              }
              $123 = HEAP32[$0>>2]|0; //@line 136533 "c/sqlite3.c"
              $124 = HEAP32[$93>>2]|0; //@line 136534 "c/sqlite3.c"
              $125 = HEAP32[$104>>2]|0; //@line 136534 "c/sqlite3.c"
              $126 = (_sqlite3ExprCollSeqMatch($123,$124,$125)|0); //@line 136533 "c/sqlite3.c"
              $127 = ($126|0)==(0); //@line 136534 "c/sqlite3.c"
              if ($127) {
               $359 = $87;$360 = $89;
               break L24;
              }
             }
            } while(0);
            $128 = $84 | $87; //@line 136539 "c/sqlite3.c"
            $129 = $85 | $89; //@line 136539 "c/sqlite3.c"
            $359 = $128;$360 = $129;
           }
          } else {
           $359 = $87;$360 = $89;
          }
         } else {
          $359 = $87;$360 = $89;
         }
        } else {
         $359 = $87;$360 = $89;
        }
       } while(0);
       $130 = (($$0298378) + 1)|0; //@line 136516 "c/sqlite3.c"
       $exitcond = ($130|0)==($16|0); //@line 136516 "c/sqlite3.c"
       if ($exitcond) {
        $357 = $359;$358 = $360;
        break;
       } else {
        $$0298378 = $130;$87 = $359;$89 = $360;
       }
      }
     }
     $131 = HEAP32[$59>>2]|0; //@line 136542 "c/sqlite3.c"
     $132 = $131 & 4096; //@line 136542 "c/sqlite3.c"
     $133 = ($132|0)==(0); //@line 136542 "c/sqlite3.c"
     do {
      if ($133) {
       $134 = $131 & 256; //@line 136543 "c/sqlite3.c"
       $135 = ($134|0)==(0); //@line 136543 "c/sqlite3.c"
       if ($135) {
        $136 = ((($$1292)) + 32|0); //@line 136547 "c/sqlite3.c"
        $137 = HEAP32[$136>>2]|0; //@line 136547 "c/sqlite3.c"
        $138 = ($137|0)==(0|0); //@line 136547 "c/sqlite3.c"
        if ($138) {
         $$2 = 0;
         label = 83;
         break L10;
        }
        $139 = ((($137)) + 55|0); //@line 136547 "c/sqlite3.c"
        $140 = HEAPU8[$139>>0]|(HEAPU8[$139+1>>0]<<8); //@line 136547 "c/sqlite3.c"
        $141 = $140 & 4; //@line 136547 "c/sqlite3.c"
        $142 = ($141<<16>>16)==(0); //@line 136547 "c/sqlite3.c"
        if (!($142)) {
         $$2 = 0;
         label = 83;
         break L10;
        }
        $143 = ((($137)) + 50|0); //@line 136550 "c/sqlite3.c"
        $144 = HEAP16[$143>>1]|0; //@line 136550 "c/sqlite3.c"
        $145 = ((($137)) + 52|0); //@line 136551 "c/sqlite3.c"
        $146 = HEAP16[$145>>1]|0; //@line 136551 "c/sqlite3.c"
        $147 = ((($137)) + 54|0); //@line 136555 "c/sqlite3.c"
        $148 = HEAP8[$147>>0]|0; //@line 136555 "c/sqlite3.c"
        $149 = ($148<<24>>24)!=(0); //@line 136555 "c/sqlite3.c"
        $150 = $149&1; //@line 136555 "c/sqlite3.c"
        $151 = $146&65535; //@line 136563 "c/sqlite3.c"
        $152 = ($146<<16>>16)==(0); //@line 136563 "c/sqlite3.c"
        if ($152) {
         $$10 = $150;$361 = $357;$362 = $358;
         label = 66;
         break;
        } else {
         $$0288458 = $137;$$0289457 = $144;$$1251459 = $150;$282 = $151;
        }
       } else {
        $$0288458 = 0;$$0289457 = 0;$$1251459 = $$0250431;$282 = 1;
       }
       $153 = ((($$1292)) + 42|0);
       $154 = ($$0288458|0)==(0|0);
       $155 = ((($$1292)) + 48|0);
       $156 = ((($$0288458)) + 4|0);
       $157 = ((($$0288458)) + 28|0);
       $158 = ((($$0288458)) + 12|0);
       $159 = ((($$0288458)) + 32|0);
       $160 = ((($$0288458)) + 40|0);
       $161 = ((($$0288458)) + 12|0);
       $162 = (_bitshift64Shl(1,0,($$0295422|0))|0);
       $163 = tempRet0;
       $$0243412 = 0;$$0246411 = 0;$$0253408 = 0;$$1297403 = 0;$$2252410 = $$1251459;$214 = $357;$216 = $358;
       L49: while(1) {
        $164 = HEAP16[$63>>1]|0; //@line 136569 "c/sqlite3.c"
        $165 = $164&65535; //@line 136569 "c/sqlite3.c"
        $166 = ($$1297403>>>0)<($165>>>0); //@line 136569 "c/sqlite3.c"
        L51: do {
         if ($166) {
          $167 = HEAP16[$153>>1]|0; //@line 136569 "c/sqlite3.c"
          $168 = $167&65535; //@line 136569 "c/sqlite3.c"
          $169 = ($$1297403>>>0)<($168>>>0); //@line 136569 "c/sqlite3.c"
          if ($169) {
           $$3260 = 1;
           label = 43;
          } else {
           $170 = HEAP32[$155>>2]|0; //@line 136570 "c/sqlite3.c"
           $171 = (($170) + ($$1297403<<2)|0); //@line 136570 "c/sqlite3.c"
           $172 = HEAP32[$171>>2]|0; //@line 136570 "c/sqlite3.c"
           $173 = ((($172)) + 12|0); //@line 136570 "c/sqlite3.c"
           $174 = HEAP16[$173>>1]|0; //@line 136570 "c/sqlite3.c"
           $175 = $174&65535; //@line 136580 "c/sqlite3.c"
           $176 = $174 & $27; //@line 136580 "c/sqlite3.c"
           $177 = ($176<<16>>16)==(0); //@line 136580 "c/sqlite3.c"
           if (!($177)) {
            $187 = $175 & 256; //@line 136581 "c/sqlite3.c"
            $188 = ($187|0)==(0); //@line 136581 "c/sqlite3.c"
            $spec$select306 = $188 ? $$2252410 : 0; //@line 136581 "c/sqlite3.c"
            $$2245$ph = $$0243412;$$2248$ph = $$0246411;$$2255$ph = $$0253408;$$8$ph = $spec$select306;$363 = $214;$364 = $216;
            break;
           }
           $178 = $175 & 1; //@line 136586 "c/sqlite3.c"
           $179 = ($178|0)==(0); //@line 136586 "c/sqlite3.c"
           if ($179) {
            $$3260 = 1;
            label = 43;
           } else {
            $180 = HEAP32[$172>>2]|0; //@line 136591 "c/sqlite3.c"
            $$1299383 = (($$1297403) + 1)|0;
            $181 = ($$1299383>>>0)<($165>>>0); //@line 136592 "c/sqlite3.c"
            if ($181) {
             $$1299384 = $$1299383;
             while(1) {
              $183 = (($170) + ($$1299384<<2)|0); //@line 136593 "c/sqlite3.c"
              $184 = HEAP32[$183>>2]|0; //@line 136593 "c/sqlite3.c"
              $185 = HEAP32[$184>>2]|0; //@line 136593 "c/sqlite3.c"
              $186 = ($185|0)==($180|0); //@line 136593 "c/sqlite3.c"
              if ($186) {
               $$3260 = 0;
               label = 43;
               break L51;
              }
              $$1299 = (($$1299384) + 1)|0;
              $182 = ($$1299>>>0)<($165>>>0); //@line 136592 "c/sqlite3.c"
              if ($182) {
               $$1299384 = $$1299;
              } else {
               $$3260 = 1;
               label = 43;
               break;
              }
             }
            } else {
             $$3260 = 1;
             label = 43;
            }
           }
          }
         } else {
          $$3260 = 1;
          label = 43;
         }
        } while(0);
        if ((label|0) == 43) {
         label = 0;
         if ($154) {
          $$0249324 = 0;$$0294322 = -1;$$6 = $$2252410;
         } else {
          $189 = HEAP32[$156>>2]|0; //@line 136606 "c/sqlite3.c"
          $190 = (($189) + ($$1297403<<1)|0); //@line 136606 "c/sqlite3.c"
          $191 = HEAP16[$190>>1]|0; //@line 136606 "c/sqlite3.c"
          $192 = $191 << 16 >> 16; //@line 136606 "c/sqlite3.c"
          $193 = HEAP32[$157>>2]|0; //@line 136607 "c/sqlite3.c"
          $194 = (($193) + ($$1297403)|0); //@line 136607 "c/sqlite3.c"
          $195 = HEAP8[$194>>0]|0; //@line 136607 "c/sqlite3.c"
          $196 = HEAP32[$158>>2]|0; //@line 136608 "c/sqlite3.c"
          $197 = ((($196)) + 40|0); //@line 136608 "c/sqlite3.c"
          $198 = HEAP16[$197>>1]|0; //@line 136608 "c/sqlite3.c"
          $199 = ($191<<16>>16)==($198<<16>>16); //@line 136608 "c/sqlite3.c"
          $spec$select307 = $199 ? -1 : $192; //@line 136608 "c/sqlite3.c"
          $200 = ($$2252410<<24>>24)==(0); //@line 136617 "c/sqlite3.c"
          $201 = ($spec$select307|0)<(0); //@line 136618 "c/sqlite3.c"
          $or$cond$not = $200 | $201; //@line 136618 "c/sqlite3.c"
          $brmerge = $166 | $or$cond$not; //@line 136618 "c/sqlite3.c"
          if ($brmerge) {
           $$0249324 = $195;$$0294322 = $spec$select307;$$6 = $$2252410;
          } else {
           $202 = HEAP32[$161>>2]|0; //@line 136620 "c/sqlite3.c"
           $203 = ((($202)) + 4|0); //@line 136620 "c/sqlite3.c"
           $204 = HEAP32[$203>>2]|0; //@line 136620 "c/sqlite3.c"
           $205 = (((($204) + ($spec$select307<<4)|0)) + 12|0); //@line 136620 "c/sqlite3.c"
           $206 = HEAP8[$205>>0]|0; //@line 136620 "c/sqlite3.c"
           $207 = ($206<<24>>24)==(0); //@line 136620 "c/sqlite3.c"
           $spec$select308 = $207 ? 0 : $$2252410; //@line 136617 "c/sqlite3.c"
           $$0249324 = $195;$$0294322 = $spec$select307;$$6 = $spec$select308;
          }
         }
         $208 = ($$3260<<24>>24)!=(0); //@line 136629 "c/sqlite3.c"
         $or$cond309390 = $38 & $208; //@line 136629 "c/sqlite3.c"
         if (!($or$cond309390)) {
          label = 63;
          break;
         }
         $209 = ($$0294322|0)>(-2);
         $210 = ($$0294322|0)==(-1);
         $$2300391 = 0;$$4261393 = 1;
         L69: while(1) {
          $211 = (_bitshift64Shl(1,0,($$2300391|0))|0); //@line 136630 "c/sqlite3.c"
          $212 = tempRet0; //@line 136630 "c/sqlite3.c"
          $213 = $211 & $214; //@line 136630 "c/sqlite3.c"
          $215 = $212 & $216; //@line 136630 "c/sqlite3.c"
          $217 = ($213|0)==(0); //@line 136630 "c/sqlite3.c"
          $218 = ($215|0)==(0); //@line 136630 "c/sqlite3.c"
          $219 = $217 & $218; //@line 136630 "c/sqlite3.c"
          do {
           if ($219) {
            $220 = (((($1)) + 4|0) + (($$2300391*20)|0)|0); //@line 136631 "c/sqlite3.c"
            $221 = HEAP32[$220>>2]|0; //@line 136631 "c/sqlite3.c"
            $222 = (_sqlite3ExprSkipCollate($221)|0); //@line 136631 "c/sqlite3.c"
            $spec$select310 = $40 ? 0 : $$4261393; //@line 136634 "c/sqlite3.c"
            if ($209) {
             $223 = HEAP8[$222>>0]|0; //@line 136636 "c/sqlite3.c"
             $224 = ($223<<24>>24)==(-111); //@line 136636 "c/sqlite3.c"
             if (!($224)) {
              $$6263 = $spec$select310;
              break;
             }
             $225 = ((($222)) + 28|0); //@line 136637 "c/sqlite3.c"
             $226 = HEAP32[$225>>2]|0; //@line 136637 "c/sqlite3.c"
             $227 = ($226|0)==($77|0); //@line 136637 "c/sqlite3.c"
             if (!($227)) {
              $$6263 = $spec$select310;
              break;
             }
             $228 = ((($222)) + 32|0); //@line 136638 "c/sqlite3.c"
             $229 = HEAP16[$228>>1]|0; //@line 136638 "c/sqlite3.c"
             $230 = $229 << 16 >> 16; //@line 136638 "c/sqlite3.c"
             $231 = ($$0294322|0)==($230|0); //@line 136638 "c/sqlite3.c"
             if (!($231)) {
              $$6263 = $spec$select310;
              break;
             }
             if ($210) {
              break L69;
             }
            } else {
             $232 = HEAP32[$160>>2]|0; //@line 136640 "c/sqlite3.c"
             $233 = (((($232)) + 4|0) + (($$1297403*20)|0)|0); //@line 136640 "c/sqlite3.c"
             $234 = HEAP32[$233>>2]|0; //@line 136640 "c/sqlite3.c"
             $235 = (_sqlite3ExprCompareSkip($222,$234,$77)|0); //@line 136641 "c/sqlite3.c"
             $236 = ($235|0)==(0); //@line 136641 "c/sqlite3.c"
             if (!($236)) {
              $$6263 = $spec$select310;
              break;
             }
            }
            $237 = HEAP32[$0>>2]|0; //@line 136646 "c/sqlite3.c"
            $238 = HEAP32[$220>>2]|0; //@line 136646 "c/sqlite3.c"
            $239 = (_sqlite3ExprNNCollSeq($237,$238)|0); //@line 136646 "c/sqlite3.c"
            $240 = HEAP32[$239>>2]|0; //@line 136647 "c/sqlite3.c"
            $241 = HEAP32[$159>>2]|0; //@line 136647 "c/sqlite3.c"
            $242 = (($241) + ($$1297403<<2)|0); //@line 136647 "c/sqlite3.c"
            $243 = HEAP32[$242>>2]|0; //@line 136647 "c/sqlite3.c"
            $244 = (_sqlite3StrICmp($240,$243)|0); //@line 136647 "c/sqlite3.c"
            $245 = ($244|0)==(0); //@line 136647 "c/sqlite3.c"
            if ($245) {
             break L69;
            } else {
             $$6263 = $spec$select310;
            }
           } else {
            $$6263 = $$4261393;
           }
          } while(0);
          $246 = (($$2300391) + 1)|0; //@line 136629 "c/sqlite3.c"
          $247 = ($$6263<<24>>24)!=(0); //@line 136629 "c/sqlite3.c"
          $248 = ($246>>>0)<($16>>>0); //@line 136629 "c/sqlite3.c"
          $or$cond309 = $248 & $247; //@line 136629 "c/sqlite3.c"
          if ($or$cond309) {
           $$2300391 = $246;$$4261393 = $$6263;
          } else {
           label = 63;
           break L49;
          }
         }
         $249 = (($$1297403) + 1)|0; //@line 136649 "c/sqlite3.c"
         $250 = $249&65535; //@line 136649 "c/sqlite3.c"
         HEAP16[$71>>1] = $250; //@line 136649 "c/sqlite3.c"
         do {
          if ($42) {
           $251 = ($$0243412<<24>>24)==(0); //@line 136656 "c/sqlite3.c"
           if (!($251)) {
            $252 = $$0249324 ^ $$0246411; //@line 136657 "c/sqlite3.c"
            $253 = (((((($1)) + 4|0) + (($$2300391*20)|0)|0)) + 12|0); //@line 136657 "c/sqlite3.c"
            $254 = HEAP8[$253>>0]|0; //@line 136657 "c/sqlite3.c"
            $255 = ($252<<24>>24)==($254<<24>>24); //@line 136657 "c/sqlite3.c"
            if ($255) {
             $$1244$ph = $$0243412;$$1247$ph = $$0246411;
             break;
            } else {
             label = 63;
             break L49;
            }
           }
           $256 = (((((($1)) + 4|0) + (($$2300391*20)|0)|0)) + 12|0); //@line 136659 "c/sqlite3.c"
           $257 = HEAP8[$256>>0]|0; //@line 136659 "c/sqlite3.c"
           $258 = $257 ^ $$0249324; //@line 136659 "c/sqlite3.c"
           $259 = ($258<<24>>24)==(0); //@line 136660 "c/sqlite3.c"
           if ($259) {
            $$1244$ph = 1;$$1247$ph = 0;
            break;
           }
           $260 = $6; //@line 136660 "c/sqlite3.c"
           $261 = $260; //@line 136660 "c/sqlite3.c"
           $262 = HEAP32[$261>>2]|0; //@line 136660 "c/sqlite3.c"
           $263 = (($260) + 4)|0; //@line 136660 "c/sqlite3.c"
           $264 = $263; //@line 136660 "c/sqlite3.c"
           $265 = HEAP32[$264>>2]|0; //@line 136660 "c/sqlite3.c"
           $266 = $262 | $162; //@line 136660 "c/sqlite3.c"
           $267 = $265 | $163; //@line 136660 "c/sqlite3.c"
           $268 = $6; //@line 136660 "c/sqlite3.c"
           $269 = $268; //@line 136660 "c/sqlite3.c"
           HEAP32[$269>>2] = $266; //@line 136660 "c/sqlite3.c"
           $270 = (($268) + 4)|0; //@line 136660 "c/sqlite3.c"
           $271 = $270; //@line 136660 "c/sqlite3.c"
           HEAP32[$271>>2] = $267; //@line 136660 "c/sqlite3.c"
           $$1244$ph = 1;$$1247$ph = $258;
          } else {
           $$1244$ph = $$0243412;$$1247$ph = $$0246411;
          }
         } while(0);
         $272 = ($$0294322|0)==(-1); //@line 136665 "c/sqlite3.c"
         $spec$select314 = $272 ? 1 : $$0253408; //@line 136665 "c/sqlite3.c"
         $273 = (_bitshift64Shl(1,0,($$2300391|0))|0); //@line 136669 "c/sqlite3.c"
         $274 = tempRet0; //@line 136669 "c/sqlite3.c"
         $275 = $273 | $214; //@line 136669 "c/sqlite3.c"
         $276 = $274 | $216; //@line 136669 "c/sqlite3.c"
         $$2245$ph = $$1244$ph;$$2248$ph = $$1247$ph;$$2255$ph = $spec$select314;$$8$ph = $$6;$363 = $275;$364 = $276;
        }
        $280 = (($$1297403) + 1)|0; //@line 136563 "c/sqlite3.c"
        $281 = ($280>>>0)<($282>>>0); //@line 136563 "c/sqlite3.c"
        if ($281) {
         $$0243412 = $$2245$ph;$$0246411 = $$2248$ph;$$0253408 = $$2255$ph;$$1297403 = $280;$$2252410 = $$8$ph;$214 = $363;$216 = $364;
        } else {
         $$0253354 = $$2255$ph;$$9 = $$8$ph;$365 = $363;$366 = $364;
         break;
        }
       }
       if ((label|0) == 63) {
        label = 0;
        $277 = ($$1297403|0)==(0); //@line 136672 "c/sqlite3.c"
        $278 = $$0289457&65535; //@line 136672 "c/sqlite3.c"
        $279 = ($$1297403>>>0)<($278>>>0); //@line 136672 "c/sqlite3.c"
        $or$cond316 = $277 | $279; //@line 136672 "c/sqlite3.c"
        $$7 = $or$cond316 ? 0 : $$6; //@line 136672 "c/sqlite3.c"
        $$0253354 = $$0253408;$$9 = $$7;$365 = $214;$366 = $216;
       }
       $283 = ($$0253354<<24>>24)==(0); //@line 136679 "c/sqlite3.c"
       if ($283) {
        $$10 = $$9;$361 = $365;$362 = $366;
        label = 66;
       } else {
        $$10344 = 1;$367 = $365;$368 = $366;
       }
      } else {
       $$10 = $$0250431;$361 = $357;$362 = $358;
       label = 66;
      }
     } while(0);
     if ((label|0) == 66) {
      label = 0;
      $284 = ($$10<<24>>24)==(0); //@line 136686 "c/sqlite3.c"
      if ($284) {
       $$0250367 = 0;$337 = $361;$339 = $362;
       break L8;
      } else {
       $$10344 = $$10;$367 = $361;$368 = $362;
      }
     }
     $285 = ((($$1292)) + 8|0); //@line 136687 "c/sqlite3.c"
     $286 = $285; //@line 136687 "c/sqlite3.c"
     $287 = $286; //@line 136687 "c/sqlite3.c"
     $288 = HEAP32[$287>>2]|0; //@line 136687 "c/sqlite3.c"
     $289 = (($286) + 4)|0; //@line 136687 "c/sqlite3.c"
     $290 = $289; //@line 136687 "c/sqlite3.c"
     $291 = HEAP32[$290>>2]|0; //@line 136687 "c/sqlite3.c"
     $292 = $288 | $293; //@line 136687 "c/sqlite3.c"
     $294 = $291 | $295; //@line 136687 "c/sqlite3.c"
     if ($36) {
      $$11 = $$10344;$$2293 = $$1292;$329 = $368;$331 = $367;$355 = $292;$356 = $294;
     } else {
      $296 = $292 ^ -1;
      $297 = $294 ^ -1;
      $$3301418 = 0;$301 = $367;$303 = $368;
      while(1) {
       $298 = (_bitshift64Shl(1,0,($$3301418|0))|0); //@line 136691 "c/sqlite3.c"
       $299 = tempRet0; //@line 136691 "c/sqlite3.c"
       $300 = $298 & $301; //@line 136691 "c/sqlite3.c"
       $302 = $299 & $303; //@line 136691 "c/sqlite3.c"
       $304 = ($300|0)==(0); //@line 136691 "c/sqlite3.c"
       $305 = ($302|0)==(0); //@line 136691 "c/sqlite3.c"
       $306 = $304 & $305; //@line 136691 "c/sqlite3.c"
       do {
        if ($306) {
         $307 = (((($1)) + 4|0) + (($$3301418*20)|0)|0); //@line 136692 "c/sqlite3.c"
         $308 = HEAP32[$307>>2]|0; //@line 136692 "c/sqlite3.c"
         $309 = (_sqlite3WhereExprUsage($37,$308)|0); //@line 136693 "c/sqlite3.c"
         $310 = tempRet0; //@line 136693 "c/sqlite3.c"
         $311 = ($309|0)==(0); //@line 136694 "c/sqlite3.c"
         $312 = ($310|0)==(0); //@line 136694 "c/sqlite3.c"
         $313 = $311 & $312; //@line 136694 "c/sqlite3.c"
         if ($313) {
          $314 = (_sqlite3ExprIsConstant($308)|0); //@line 136694 "c/sqlite3.c"
          $315 = ($314|0)==(0); //@line 136694 "c/sqlite3.c"
          if ($315) {
           $369 = $301;$370 = $303;
           break;
          }
         }
         $316 = $309 & $296; //@line 136695 "c/sqlite3.c"
         $317 = $310 & $297; //@line 136695 "c/sqlite3.c"
         $318 = ($316|0)==(0); //@line 136695 "c/sqlite3.c"
         $319 = ($317|0)==(0); //@line 136695 "c/sqlite3.c"
         $320 = $318 & $319; //@line 136695 "c/sqlite3.c"
         $321 = $320 ? $298 : 0; //@line 136695 "c/sqlite3.c"
         $322 = $320 ? $299 : 0; //@line 136695 "c/sqlite3.c"
         $323 = $321 | $301; //@line 136695 "c/sqlite3.c"
         $324 = $322 | $303; //@line 136695 "c/sqlite3.c"
         $369 = $323;$370 = $324;
        } else {
         $369 = $301;$370 = $303;
        }
       } while(0);
       $325 = (($$3301418) + 1)|0; //@line 136688 "c/sqlite3.c"
       $exitcond455 = ($325|0)==($16|0); //@line 136688 "c/sqlite3.c"
       if ($exitcond455) {
        $$11 = $$10344;$$2293 = $$1292;$329 = $370;$331 = $369;$355 = $292;$356 = $294;
        break;
       } else {
        $$3301418 = $325;$301 = $369;$303 = $370;
       }
      }
     }
    }
    $326 = (($$0295422) + 1)|0; //@line 136495 "c/sqlite3.c"
    $327 = ($$11<<24>>24)==(0); //@line 136495 "c/sqlite3.c"
    $328 = ($329>>>0)>($21>>>0); //@line 136495 "c/sqlite3.c"
    $330 = ($331>>>0)>=($20>>>0); //@line 136495 "c/sqlite3.c"
    $332 = ($329|0)==($21|0); //@line 136495 "c/sqlite3.c"
    $333 = $332 & $330; //@line 136495 "c/sqlite3.c"
    $334 = $328 | $333; //@line 136495 "c/sqlite3.c"
    $or$cond303$not = $334 | $327; //@line 136495 "c/sqlite3.c"
    $335 = ($$0295422>>>0)>=($7>>>0); //@line 136495 "c/sqlite3.c"
    $or$cond304 = $335 | $or$cond303$not; //@line 136495 "c/sqlite3.c"
    if ($or$cond304) {
     $$0250367 = $$11;$337 = $331;$339 = $329;
     break L8;
    } else {
     $$0250431 = $$11;$$0291426 = $$2293;$$0295422 = $326;$293 = $355;$295 = $356;$52 = $79;$54 = $81;$67 = $331;$69 = $329;
    }
   }
   if ((label|0) == 11) {
    $64 = ((($63)) + 5|0); //@line 136504 "c/sqlite3.c"
    $65 = HEAP8[$64>>0]|0; //@line 136504 "c/sqlite3.c"
    $66 = ($65<<24>>24)==(0); //@line 136504 "c/sqlite3.c"
    $68 = $66 ? $67 : $20; //@line 136504 "c/sqlite3.c"
    $70 = $66 ? $69 : $21; //@line 136504 "c/sqlite3.c"
    $$0250367 = $$0250431;$337 = $68;$339 = $70;
    break;
   }
   else if ((label|0) == 83) {
    return ($$2|0); //@line 136710 "c/sqlite3.c"
   }
  }
 } while(0);
 $336 = ($337|0)==($20|0); //@line 136701 "c/sqlite3.c"
 $338 = ($339|0)==($21|0); //@line 136701 "c/sqlite3.c"
 $340 = $336 & $338; //@line 136701 "c/sqlite3.c"
 if ($340) {
  $341 = $15&255; //@line 136701 "c/sqlite3.c"
  $$2 = $341;
  return ($$2|0); //@line 136710 "c/sqlite3.c"
 }
 $342 = ($$0250367<<24>>24)==(0); //@line 136702 "c/sqlite3.c"
 if (!($342)) {
  $$2 = -1;
  return ($$2|0); //@line 136710 "c/sqlite3.c"
 }
 $343 = ($16>>>0)>(1); //@line 136703 "c/sqlite3.c"
 if (!($343)) {
  $$2 = 0;
  return ($$2|0); //@line 136710 "c/sqlite3.c"
 }
 $$4302373$in = $16;
 while(1) {
  $$4302373 = (($$4302373$in) + -1)|0;
  $345 = (_bitshift64Shl(1,0,($$4302373|0))|0); //@line 136704 "c/sqlite3.c"
  $346 = tempRet0; //@line 136704 "c/sqlite3.c"
  $347 = (_i64Add(($345|0),($346|0),-1,-1)|0); //@line 136704 "c/sqlite3.c"
  $348 = tempRet0; //@line 136704 "c/sqlite3.c"
  $349 = $347 & $337; //@line 136705 "c/sqlite3.c"
  $350 = $348 & $339; //@line 136705 "c/sqlite3.c"
  $351 = ($349|0)==($347|0); //@line 136705 "c/sqlite3.c"
  $352 = ($350|0)==($348|0); //@line 136705 "c/sqlite3.c"
  $353 = $351 & $352; //@line 136705 "c/sqlite3.c"
  if ($353) {
   break;
  }
  $344 = ($$4302373$in|0)>(2); //@line 136703 "c/sqlite3.c"
  if ($344) {
   $$4302373$in = $$4302373;
  } else {
   $$2 = 0;
   label = 83;
   break;
  }
 }
 if ((label|0) == 83) {
  return ($$2|0); //@line 136710 "c/sqlite3.c"
 }
 $354 = $$4302373&255; //@line 136705 "c/sqlite3.c"
 $$2 = $354;
 return ($$2|0); //@line 136710 "c/sqlite3.c"
}
function _whereSortingCost($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $reass$add = 0, $reass$mul = 0, $sext14 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (($2) - ($3))|0; //@line 136780 "c/sqlite3.c"
 $5 = ($4*100)|0; //@line 136780 "c/sqlite3.c"
 $6 = (($5|0) / ($2|0))&-1; //@line 136780 "c/sqlite3.c"
 $7 = ($6|0)<(0); //@line 136780 "c/sqlite3.c"
 $8 = $7 << 31 >> 31; //@line 136780 "c/sqlite3.c"
 $9 = (_sqlite3LogEst($6,$8)|0); //@line 136780 "c/sqlite3.c"
 $10 = $9&65535; //@line 136780 "c/sqlite3.c"
 $11 = $1&65535; //@line 136781 "c/sqlite3.c"
 $12 = ((($0)) + 44|0); //@line 136785 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 136785 "c/sqlite3.c"
 $14 = $13 & 16384; //@line 136785 "c/sqlite3.c"
 $15 = ($14<<16>>16)==(0); //@line 136785 "c/sqlite3.c"
 if ($15) {
  $$0 = $1;
 } else {
  $16 = ((($0)) + 20|0); //@line 136785 "c/sqlite3.c"
  $17 = HEAP16[$16>>1]|0; //@line 136785 "c/sqlite3.c"
  $18 = ($17<<16>>16)<($1<<16>>16); //@line 136785 "c/sqlite3.c"
  $spec$select = $18 ? $17 : $1; //@line 136785 "c/sqlite3.c"
  $$0 = $spec$select;
 }
 $19 = (_estLog($$0)|0); //@line 136788 "c/sqlite3.c"
 $20 = $19&65535; //@line 136788 "c/sqlite3.c"
 $reass$add = (($10) + ($11))|0;
 $reass$mul = $reass$add << 16;
 $sext14 = (($reass$mul) + -3276800)|0; //@line 136788 "c/sqlite3.c"
 $21 = $sext14 >>> 16; //@line 136788 "c/sqlite3.c"
 $22 = (($21) + ($20))|0; //@line 136788 "c/sqlite3.c"
 $23 = $22&65535; //@line 136788 "c/sqlite3.c"
 return ($23|0); //@line 136789 "c/sqlite3.c"
}
function _estLog($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0<<16>>16)<(11); //@line 133427 "c/sqlite3.c"
 if ($1) {
  $8 = 0;
  return ($8|0); //@line 133427 "c/sqlite3.c"
 }
 $2 = $0 << 16 >> 16; //@line 133427 "c/sqlite3.c"
 $3 = ($2|0)<(0); //@line 133427 "c/sqlite3.c"
 $4 = $3 << 31 >> 31; //@line 133427 "c/sqlite3.c"
 $5 = (_sqlite3LogEst($2,$4)|0); //@line 133427 "c/sqlite3.c"
 $6 = $5&65535; //@line 133427 "c/sqlite3.c"
 $7 = (($6) + 65503)|0; //@line 133427 "c/sqlite3.c"
 $phitmp = $7&65535; //@line 133427 "c/sqlite3.c"
 $8 = $phitmp;
 return ($8|0); //@line 133427 "c/sqlite3.c"
}
function _sqlite3ExprCollSeqMatch($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ExprNNCollSeq($0,$1)|0); //@line 92904 "c/sqlite3.c"
 $4 = (_sqlite3ExprNNCollSeq($0,$2)|0); //@line 92905 "c/sqlite3.c"
 $5 = HEAP32[$3>>2]|0; //@line 92906 "c/sqlite3.c"
 $6 = HEAP32[$4>>2]|0; //@line 92906 "c/sqlite3.c"
 $7 = (_sqlite3StrICmp($5,$6)|0); //@line 92906 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 92906 "c/sqlite3.c"
 $9 = $8&1; //@line 92906 "c/sqlite3.c"
 return ($9|0); //@line 92906 "c/sqlite3.c"
}
function _sqlite3ExprNNCollSeq($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3ExprCollSeq($0,$1)|0); //@line 92894 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 92895 "c/sqlite3.c"
 if (!($3)) {
  $$0 = $2;
  return ($$0|0); //@line 92897 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 92895 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 92895 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 92895 "c/sqlite3.c"
 $$0 = $6;
 return ($$0|0); //@line 92897 "c/sqlite3.c"
}
function _whereLoopAddVirtual($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0113138 = 0, $$0118165 = 0, $$1117$ph$lcssa = 0, $$1117$ph154 = 0, $$1119$ph$lcssa = 0, $$1119$ph153 = 0, $$1125$ph$lcssa = 0, $$3$ph = 0, $$3121$ph = 0, $$4128 = 0, $$5 = 0, $$6 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0;
 var $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $or$cond131 = 0, $spec$select = 0, $spec$select132 = 0, $spec$select133 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = sp + 4|0;
 $7 = HEAP32[$0>>2]|0; //@line 136133 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 136134 "c/sqlite3.c"
 $9 = ((($0)) + 4|0); //@line 136135 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 136135 "c/sqlite3.c"
 $11 = ((($0)) + 12|0); //@line 136136 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 136136 "c/sqlite3.c"
 $13 = ((($7)) + 4|0); //@line 136137 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 136137 "c/sqlite3.c"
 $15 = ((($12)) + 16|0); //@line 136137 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 136137 "c/sqlite3.c"
 $17 = $16&255; //@line 136137 "c/sqlite3.c"
 $18 = (((($14)) + 8|0) + (($17*72)|0)|0); //@line 136137 "c/sqlite3.c"
 $19 = ((($0)) + 8|0); //@line 136139 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 136139 "c/sqlite3.c"
 $21 = (_allocateIndexInfo($8,$10,$3,$4,$18,$20,$6)|0); //@line 136139 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 136141 "c/sqlite3.c"
 if ($22) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 136229 "c/sqlite3.c"
 }
 $23 = ((($12)) + 18|0); //@line 136142 "c/sqlite3.c"
 HEAP16[$23>>1] = 0; //@line 136142 "c/sqlite3.c"
 $24 = ((($12)) + 36|0); //@line 136143 "c/sqlite3.c"
 HEAP32[$24>>2] = 1024; //@line 136143 "c/sqlite3.c"
 $25 = ((($12)) + 40|0); //@line 136144 "c/sqlite3.c"
 HEAP16[$25>>1] = 0; //@line 136144 "c/sqlite3.c"
 $26 = ((($12)) + 28|0); //@line 136145 "c/sqlite3.c"
 HEAP8[$26>>0] = 0; //@line 136145 "c/sqlite3.c"
 $27 = HEAP32[$21>>2]|0; //@line 136146 "c/sqlite3.c"
 $28 = HEAP32[$8>>2]|0; //@line 136147 "c/sqlite3.c"
 $29 = (_whereLoopResize($28,$12,$27)|0); //@line 136147 "c/sqlite3.c"
 $30 = ($29|0)==(0); //@line 136147 "c/sqlite3.c"
 if (!($30)) {
  $31 = HEAP32[$8>>2]|0; //@line 136148 "c/sqlite3.c"
  _sqlite3DbFree($31,$21); //@line 136148 "c/sqlite3.c"
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 136229 "c/sqlite3.c"
 }
 $32 = HEAP16[$6>>1]|0; //@line 136154 "c/sqlite3.c"
 $33 = (_whereLoopAddVirtualOne($0,$1,$2,-1,-1,0,$21,$32,$5)|0); //@line 136154 "c/sqlite3.c"
 $34 = ($33|0)==(0); //@line 136161 "c/sqlite3.c"
 if ($34) {
  $35 = $12; //@line 136161 "c/sqlite3.c"
  $36 = $35; //@line 136161 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 136161 "c/sqlite3.c"
  $38 = (($35) + 4)|0; //@line 136161 "c/sqlite3.c"
  $39 = $38; //@line 136161 "c/sqlite3.c"
  $40 = HEAP32[$39>>2]|0; //@line 136161 "c/sqlite3.c"
  $41 = $1 ^ -1; //@line 136161 "c/sqlite3.c"
  $42 = $2 ^ -1; //@line 136161 "c/sqlite3.c"
  $43 = $37 & $41; //@line 136161 "c/sqlite3.c"
  $44 = $40 & $42; //@line 136161 "c/sqlite3.c"
  $45 = ($43|0)==(0); //@line 136161 "c/sqlite3.c"
  $46 = ($44|0)==(0); //@line 136161 "c/sqlite3.c"
  $47 = $45 & $46; //@line 136161 "c/sqlite3.c"
  if ($47) {
   $$6 = 0;
  } else {
   $48 = HEAP32[$5>>2]|0; //@line 136169 "c/sqlite3.c"
   $49 = ($48|0)==(0); //@line 136169 "c/sqlite3.c"
   if ($49) {
    $$0118165 = 0;$103 = 0;$105 = 0;
    label = 8;
   } else {
    $50 = (_whereLoopAddVirtualOne($0,$1,$2,-1,-1,1,$21,$32,$5)|0); //@line 136171 "c/sqlite3.c"
    $51 = $12; //@line 136174 "c/sqlite3.c"
    $52 = $51; //@line 136174 "c/sqlite3.c"
    $53 = HEAP32[$52>>2]|0; //@line 136174 "c/sqlite3.c"
    $54 = (($51) + 4)|0; //@line 136174 "c/sqlite3.c"
    $55 = $54; //@line 136174 "c/sqlite3.c"
    $56 = HEAP32[$55>>2]|0; //@line 136174 "c/sqlite3.c"
    $57 = $53 & $41; //@line 136174 "c/sqlite3.c"
    $58 = $56 & $42; //@line 136174 "c/sqlite3.c"
    $59 = ($57|0)==(0); //@line 136175 "c/sqlite3.c"
    $60 = ($58|0)==(0); //@line 136175 "c/sqlite3.c"
    $61 = $59 & $60; //@line 136175 "c/sqlite3.c"
    $spec$select = $61&1; //@line 136175 "c/sqlite3.c"
    $62 = ($50|0)==(0); //@line 136183 "c/sqlite3.c"
    if ($62) {
     $$0118165 = $spec$select;$103 = $57;$105 = $58;
     label = 8;
    } else {
     $$1117$ph$lcssa = $spec$select;$$1119$ph$lcssa = $spec$select;$$1125$ph$lcssa = $50;
    }
   }
   L13: do {
    if ((label|0) == 8) {
     $63 = ($27|0)>(0);
     $64 = ((($10)) + 20|0);
     $65 = ((($21)) + 4|0);
     $$1117$ph154 = $$0118165;$$1119$ph153 = $$0118165;$136 = 0;$137 = 0;
     while(1) {
      if (!($63)) {
       $$1117$ph$lcssa = $$1117$ph154;$$1119$ph$lcssa = $$1119$ph153;$$1125$ph$lcssa = 0;
       break L13;
      }
      $66 = HEAP32[$64>>2]|0;
      $67 = HEAP32[$65>>2]|0;
      $80 = $137;$82 = $136;
      while(1) {
       $$0113138 = 0;$87 = -1;$89 = -1;
       while(1) {
        $68 = (((($67) + (($$0113138*12)|0)|0)) + 8|0); //@line 136189 "c/sqlite3.c"
        $69 = HEAP32[$68>>2]|0; //@line 136189 "c/sqlite3.c"
        $70 = (((($66) + (($69*48)|0)|0)) + 32|0); //@line 136189 "c/sqlite3.c"
        $71 = $70; //@line 136189 "c/sqlite3.c"
        $72 = $71; //@line 136189 "c/sqlite3.c"
        $73 = HEAP32[$72>>2]|0; //@line 136189 "c/sqlite3.c"
        $74 = (($71) + 4)|0; //@line 136189 "c/sqlite3.c"
        $75 = $74; //@line 136189 "c/sqlite3.c"
        $76 = HEAP32[$75>>2]|0; //@line 136189 "c/sqlite3.c"
        $77 = $73 & $41; //@line 136189 "c/sqlite3.c"
        $78 = $76 & $42; //@line 136189 "c/sqlite3.c"
        $79 = ($78>>>0)>($80>>>0); //@line 136191 "c/sqlite3.c"
        $81 = ($77>>>0)>($82>>>0); //@line 136191 "c/sqlite3.c"
        $83 = ($78|0)==($80|0); //@line 136191 "c/sqlite3.c"
        $84 = $83 & $81; //@line 136191 "c/sqlite3.c"
        $85 = $79 | $84; //@line 136191 "c/sqlite3.c"
        $86 = ($78>>>0)<($87>>>0); //@line 136191 "c/sqlite3.c"
        $88 = ($77>>>0)<($89>>>0); //@line 136191 "c/sqlite3.c"
        $90 = ($78|0)==($87|0); //@line 136191 "c/sqlite3.c"
        $91 = $90 & $88; //@line 136191 "c/sqlite3.c"
        $92 = $86 | $91; //@line 136191 "c/sqlite3.c"
        $or$cond = $85 & $92; //@line 136191 "c/sqlite3.c"
        $93 = $or$cond ? $77 : $89; //@line 136191 "c/sqlite3.c"
        $94 = $or$cond ? $78 : $87; //@line 136191 "c/sqlite3.c"
        $95 = (($$0113138) + 1)|0; //@line 136187 "c/sqlite3.c"
        $exitcond = ($95|0)==($27|0); //@line 136187 "c/sqlite3.c"
        if ($exitcond) {
         break;
        } else {
         $$0113138 = $95;$87 = $94;$89 = $93;
        }
       }
       $96 = ($93|0)==(-1); //@line 136194 "c/sqlite3.c"
       $97 = ($94|0)==(-1); //@line 136194 "c/sqlite3.c"
       $98 = $96 & $97; //@line 136194 "c/sqlite3.c"
       if ($98) {
        $$1117$ph$lcssa = $$1117$ph154;$$1119$ph$lcssa = $$1119$ph153;$$1125$ph$lcssa = 0;
        break L13;
       }
       $99 = ($93|0)==($43|0); //@line 136195 "c/sqlite3.c"
       $100 = ($94|0)==($44|0); //@line 136195 "c/sqlite3.c"
       $101 = $99 & $100; //@line 136195 "c/sqlite3.c"
       $102 = ($93|0)==($103|0); //@line 136195 "c/sqlite3.c"
       $104 = ($94|0)==($105|0); //@line 136195 "c/sqlite3.c"
       $106 = $102 & $104; //@line 136195 "c/sqlite3.c"
       $or$cond131 = $101 | $106; //@line 136195 "c/sqlite3.c"
       if (!($or$cond131)) {
        break;
       }
       if ($63) {
        $80 = $94;$82 = $93;
       } else {
        $$1117$ph$lcssa = $$1117$ph154;$$1119$ph$lcssa = $$1119$ph153;$$1125$ph$lcssa = 0;
        break L13;
       }
      }
      $107 = $93 | $1; //@line 136199 "c/sqlite3.c"
      $108 = $94 | $2; //@line 136199 "c/sqlite3.c"
      $109 = (_whereLoopAddVirtualOne($0,$1,$2,$107,$108,0,$21,$32,$5)|0); //@line 136198 "c/sqlite3.c"
      $110 = $12; //@line 136200 "c/sqlite3.c"
      $111 = $110; //@line 136200 "c/sqlite3.c"
      $112 = HEAP32[$111>>2]|0; //@line 136200 "c/sqlite3.c"
      $113 = (($110) + 4)|0; //@line 136200 "c/sqlite3.c"
      $114 = $113; //@line 136200 "c/sqlite3.c"
      $115 = HEAP32[$114>>2]|0; //@line 136200 "c/sqlite3.c"
      $116 = ($112|0)==($1|0); //@line 136200 "c/sqlite3.c"
      $117 = ($115|0)==($2|0); //@line 136200 "c/sqlite3.c"
      $118 = $116 & $117; //@line 136200 "c/sqlite3.c"
      if ($118) {
       $119 = HEAP32[$5>>2]|0; //@line 136202 "c/sqlite3.c"
       $120 = ($119|0)==(0); //@line 136202 "c/sqlite3.c"
       $spec$select132 = $120 ? 1 : $$1117$ph154; //@line 136202 "c/sqlite3.c"
       $$3$ph = $spec$select132;$$3121$ph = 1;
      } else {
       $$3$ph = $$1117$ph154;$$3121$ph = $$1119$ph153;
      }
      $121 = ($109|0)==(0); //@line 136183 "c/sqlite3.c"
      if ($121) {
       $$1117$ph154 = $$3$ph;$$1119$ph153 = $$3121$ph;$136 = $93;$137 = $94;
      } else {
       $$1117$ph$lcssa = $$3$ph;$$1119$ph$lcssa = $$3121$ph;$$1125$ph$lcssa = $109;
       break;
      }
     }
    }
   } while(0);
   $122 = $$1119$ph$lcssa | $$1125$ph$lcssa; //@line 136209 "c/sqlite3.c"
   $123 = ($122|0)==(0); //@line 136209 "c/sqlite3.c"
   if ($123) {
    $124 = (_whereLoopAddVirtualOne($0,$1,$2,$1,$2,0,$21,$32,$5)|0); //@line 136211 "c/sqlite3.c"
    $125 = HEAP32[$5>>2]|0; //@line 136213 "c/sqlite3.c"
    $126 = ($125|0)==(0); //@line 136213 "c/sqlite3.c"
    $spec$select133 = $126 ? 1 : $$1117$ph$lcssa; //@line 136213 "c/sqlite3.c"
    $$4128 = $124;$$5 = $spec$select133;
   } else {
    $$4128 = $$1125$ph$lcssa;$$5 = $$1117$ph$lcssa;
   }
   $127 = $$5 | $$4128; //@line 136219 "c/sqlite3.c"
   $128 = ($127|0)==(0); //@line 136219 "c/sqlite3.c"
   if ($128) {
    $129 = (_whereLoopAddVirtualOne($0,$1,$2,$1,$2,1,$21,$32,$5)|0); //@line 136221 "c/sqlite3.c"
    $$6 = $129;
   } else {
    $$6 = $$4128;
   }
  }
 } else {
  $$6 = $33;
 }
 $130 = ((($21)) + 28|0); //@line 136226 "c/sqlite3.c"
 $131 = HEAP32[$130>>2]|0; //@line 136226 "c/sqlite3.c"
 $132 = ($131|0)==(0); //@line 136226 "c/sqlite3.c"
 if (!($132)) {
  $133 = ((($21)) + 24|0); //@line 136226 "c/sqlite3.c"
  $134 = HEAP32[$133>>2]|0; //@line 136226 "c/sqlite3.c"
  _sqlite3_free($134); //@line 136226 "c/sqlite3.c"
 }
 $135 = HEAP32[$8>>2]|0; //@line 136227 "c/sqlite3.c"
 _sqlite3DbFreeNN($135,$21); //@line 136227 "c/sqlite3.c"
 $$0 = $$6;
 STACKTOP = sp;return ($$0|0); //@line 136229 "c/sqlite3.c"
}
function _whereLoopAddBtree($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0206 = 0, $$0210228 = 0, $$0211225 = 0, $$0212$lcssa = 0, $$0212224 = 0, $$0217243 = 0, $$1207231 = 0, $$1209 = 0, $$2 = 0, $$2214$ph = 0, $$6 = 0, $$7 = 0, $$not = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0;
 var $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0;
 var $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0;
 var $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0;
 var $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0;
 var $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0;
 var $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0;
 var $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0;
 var $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0;
 var $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0;
 var $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0;
 var $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0;
 var $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $brmerge = 0, $or$cond = 0, $or$cond222 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $3 = sp;
 $4 = sp + 64|0;
 $5 = sp + 60|0;
 HEAP16[$5>>1] = -1; //@line 135697 "c/sqlite3.c"
 $6 = ((($0)) + 12|0); //@line 135709 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 135709 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 135710 "c/sqlite3.c"
 $9 = ((($8)) + 4|0); //@line 135711 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 135711 "c/sqlite3.c"
 $11 = ((($7)) + 16|0); //@line 135712 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 135712 "c/sqlite3.c"
 $13 = $12&255; //@line 135712 "c/sqlite3.c"
 $14 = (((($10)) + 8|0) + (($13*72)|0)|0); //@line 135712 "c/sqlite3.c"
 $15 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 16|0); //@line 135713 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 135713 "c/sqlite3.c"
 $17 = ((($0)) + 4|0); //@line 135714 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 135714 "c/sqlite3.c"
 $19 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 68|0); //@line 135717 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 135717 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 135717 "c/sqlite3.c"
 do {
  if ($21) {
   $22 = ((($16)) + 36|0); //@line 135720 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 135720 "c/sqlite3.c"
   $24 = $23 & 32; //@line 135720 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 135720 "c/sqlite3.c"
   if (!($25)) {
    $26 = ((($16)) + 8|0); //@line 135721 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 135721 "c/sqlite3.c"
    $$0206 = $27;
    break;
   }
   dest=$3; stop=dest+60|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 135728 "c/sqlite3.c"
   $28 = ((($3)) + 50|0); //@line 135729 "c/sqlite3.c"
   HEAP16[$28>>1] = 1; //@line 135729 "c/sqlite3.c"
   $29 = ((($3)) + 52|0); //@line 135730 "c/sqlite3.c"
   HEAP16[$29>>1] = 1; //@line 135730 "c/sqlite3.c"
   $30 = ((($3)) + 4|0); //@line 135731 "c/sqlite3.c"
   HEAP32[$30>>2] = $5; //@line 135731 "c/sqlite3.c"
   $31 = ((($3)) + 8|0); //@line 135732 "c/sqlite3.c"
   HEAP32[$31>>2] = $4; //@line 135732 "c/sqlite3.c"
   $32 = ((($3)) + 54|0); //@line 135733 "c/sqlite3.c"
   HEAP8[$32>>0] = 5; //@line 135733 "c/sqlite3.c"
   $33 = ((($3)) + 12|0); //@line 135734 "c/sqlite3.c"
   HEAP32[$33>>2] = $16; //@line 135734 "c/sqlite3.c"
   $34 = ((($16)) + 46|0); //@line 135735 "c/sqlite3.c"
   $35 = HEAP16[$34>>1]|0; //@line 135735 "c/sqlite3.c"
   $36 = ((($3)) + 48|0); //@line 135735 "c/sqlite3.c"
   HEAP16[$36>>1] = $35; //@line 135735 "c/sqlite3.c"
   $37 = ((($16)) + 44|0); //@line 135736 "c/sqlite3.c"
   $38 = HEAP16[$37>>1]|0; //@line 135736 "c/sqlite3.c"
   HEAP16[$4>>1] = $38; //@line 135736 "c/sqlite3.c"
   $39 = ((($4)) + 2|0); //@line 135737 "c/sqlite3.c"
   HEAP16[$39>>1] = 0; //@line 135737 "c/sqlite3.c"
   $40 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 37|0); //@line 135739 "c/sqlite3.c"
   $41 = HEAP8[$40>>0]|0; //@line 135739 "c/sqlite3.c"
   $42 = $41 & 1; //@line 135739 "c/sqlite3.c"
   $43 = ($42<<24>>24)==(0); //@line 135739 "c/sqlite3.c"
   if ($43) {
    $44 = HEAP32[$15>>2]|0; //@line 135738 "c/sqlite3.c"
    $45 = ((($44)) + 8|0); //@line 135738 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 135738 "c/sqlite3.c"
    $47 = ((($3)) + 20|0); //@line 135742 "c/sqlite3.c"
    HEAP32[$47>>2] = $46; //@line 135742 "c/sqlite3.c"
    $$0206 = $3;
   } else {
    $$0206 = $3;
   }
  } else {
   $$0206 = $20;
  }
 } while(0);
 $48 = ((($16)) + 44|0); //@line 135746 "c/sqlite3.c"
 $49 = HEAP16[$48>>1]|0; //@line 135746 "c/sqlite3.c"
 $50 = (_estLog($49)|0); //@line 135747 "c/sqlite3.c"
 $51 = ((($0)) + 16|0); //@line 135751 "c/sqlite3.c"
 $52 = HEAP32[$51>>2]|0; //@line 135751 "c/sqlite3.c"
 $53 = ($52|0)==(0|0); //@line 135751 "c/sqlite3.c"
 if ($53) {
  $54 = ((($8)) + 44|0); //@line 135752 "c/sqlite3.c"
  $55 = HEAP16[$54>>1]|0; //@line 135752 "c/sqlite3.c"
  $56 = $55 & 32; //@line 135752 "c/sqlite3.c"
  $57 = ($56<<16>>16)==(0); //@line 135752 "c/sqlite3.c"
  if ($57) {
   $58 = HEAP32[$8>>2]|0; //@line 135753 "c/sqlite3.c"
   $59 = HEAP32[$58>>2]|0; //@line 135753 "c/sqlite3.c"
   $60 = ((($59)) + 28|0); //@line 135753 "c/sqlite3.c"
   $61 = HEAP32[$60>>2]|0; //@line 135753 "c/sqlite3.c"
   $62 = $61 & 32768; //@line 135753 "c/sqlite3.c"
   $63 = ($62|0)==(0); //@line 135753 "c/sqlite3.c"
   $$not = $21 ^ 1; //@line 135754 "c/sqlite3.c"
   $brmerge = $63 | $$not; //@line 135754 "c/sqlite3.c"
   if ($brmerge) {
    $$2 = 0;
   } else {
    $64 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 37|0); //@line 135755 "c/sqlite3.c"
    $65 = HEAP8[$64>>0]|0; //@line 135755 "c/sqlite3.c"
    $66 = $65 & 1; //@line 135755 "c/sqlite3.c"
    $67 = ($66<<24>>24)==(0); //@line 135755 "c/sqlite3.c"
    if ($67) {
     $68 = ((($16)) + 36|0); //@line 135756 "c/sqlite3.c"
     $69 = HEAP32[$68>>2]|0; //@line 135756 "c/sqlite3.c"
     $70 = $69 & 32; //@line 135756 "c/sqlite3.c"
     $71 = ($70|0)==(0); //@line 135756 "c/sqlite3.c"
     $72 = $65 & 40; //@line 135757 "c/sqlite3.c"
     $73 = ($72<<24>>24)==(0); //@line 135757 "c/sqlite3.c"
     $74 = $73 & $71; //@line 135757 "c/sqlite3.c"
     if ($74) {
      $75 = ((($18)) + 20|0); //@line 135762 "c/sqlite3.c"
      $76 = HEAP32[$75>>2]|0; //@line 135762 "c/sqlite3.c"
      $77 = ((($18)) + 12|0); //@line 135762 "c/sqlite3.c"
      $78 = HEAP32[$77>>2]|0; //@line 135762 "c/sqlite3.c"
      $79 = (($76) + (($78*48)|0)|0); //@line 135762 "c/sqlite3.c"
      $80 = ($78|0)>(0); //@line 135763 "c/sqlite3.c"
      if ($80) {
       $81 = ((($7)) + 8|0);
       $82 = ((($7)) + 24|0);
       $83 = ((($7)) + 42|0);
       $84 = ((($7)) + 32|0);
       $85 = ((($7)) + 40|0);
       $86 = ((($7)) + 48|0);
       $87 = $50&65535;
       $88 = $49&65535;
       $89 = (($87) + ($88))|0;
       $90 = (($89) + 4)|0;
       $91 = $90&65535;
       $92 = ((($7)) + 18|0);
       $93 = ((($16)) + 12|0);
       $94 = (($89) + 28)|0;
       $95 = $94&65535;
       $96 = ((($7)) + 22|0);
       $97 = ((($7)) + 20|0);
       $98 = ((($7)) + 36|0);
       $$0217243 = $76;
       while(1) {
        $99 = ((($$0217243)) + 32|0); //@line 135764 "c/sqlite3.c"
        $100 = $99; //@line 135764 "c/sqlite3.c"
        $101 = $100; //@line 135764 "c/sqlite3.c"
        $102 = HEAP32[$101>>2]|0; //@line 135764 "c/sqlite3.c"
        $103 = (($100) + 4)|0; //@line 135764 "c/sqlite3.c"
        $104 = $103; //@line 135764 "c/sqlite3.c"
        $105 = HEAP32[$104>>2]|0; //@line 135764 "c/sqlite3.c"
        $106 = $81; //@line 135764 "c/sqlite3.c"
        $107 = $106; //@line 135764 "c/sqlite3.c"
        $108 = HEAP32[$107>>2]|0; //@line 135764 "c/sqlite3.c"
        $109 = (($106) + 4)|0; //@line 135764 "c/sqlite3.c"
        $110 = $109; //@line 135764 "c/sqlite3.c"
        $111 = HEAP32[$110>>2]|0; //@line 135764 "c/sqlite3.c"
        $112 = $108 & $102; //@line 135764 "c/sqlite3.c"
        $113 = $111 & $105; //@line 135764 "c/sqlite3.c"
        $114 = ($112|0)==(0); //@line 135764 "c/sqlite3.c"
        $115 = ($113|0)==(0); //@line 135764 "c/sqlite3.c"
        $116 = $114 & $115; //@line 135764 "c/sqlite3.c"
        if ($116) {
         $117 = (_termCanDriveIndex($$0217243,$14,0,0)|0); //@line 135765 "c/sqlite3.c"
         $118 = ($117|0)==(0); //@line 135765 "c/sqlite3.c"
         if ($118) {
          $$1209 = 0;
         } else {
          HEAP16[$82>>1] = 1; //@line 135766 "c/sqlite3.c"
          HEAP16[$83>>1] = 0; //@line 135767 "c/sqlite3.c"
          HEAP32[$84>>2] = 0; //@line 135768 "c/sqlite3.c"
          HEAP16[$85>>1] = 1; //@line 135769 "c/sqlite3.c"
          $119 = HEAP32[$86>>2]|0; //@line 135770 "c/sqlite3.c"
          HEAP32[$119>>2] = $$0217243; //@line 135770 "c/sqlite3.c"
          HEAP16[$92>>1] = $91; //@line 135779 "c/sqlite3.c"
          $120 = HEAP32[$93>>2]|0; //@line 135780 "c/sqlite3.c"
          $121 = ($120|0)==(0|0); //@line 135780 "c/sqlite3.c"
          do {
           if ($121) {
            $122 = HEAP32[$68>>2]|0; //@line 135780 "c/sqlite3.c"
            $123 = $122 & 2; //@line 135780 "c/sqlite3.c"
            $124 = ($123|0)==(0); //@line 135780 "c/sqlite3.c"
            if ($124) {
             HEAP16[$92>>1] = $95; //@line 135781 "c/sqlite3.c"
             $126 = $95;
             break;
            } else {
             $$pr = HEAP16[$92>>1]|0; //@line 135784 "c/sqlite3.c"
             $126 = $$pr;
             break;
            }
           } else {
            $126 = $91;
           }
          } while(0);
          $125 = ($126<<16>>16)<(0); //@line 135784 "c/sqlite3.c"
          if ($125) {
           HEAP16[$92>>1] = 0; //@line 135784 "c/sqlite3.c"
          }
          HEAP16[$96>>1] = 43; //@line 135789 "c/sqlite3.c"
          $127 = (_sqlite3LogEstAdd($50,43)|0); //@line 135790 "c/sqlite3.c"
          HEAP16[$97>>1] = $127; //@line 135790 "c/sqlite3.c"
          HEAP32[$98>>2] = 16384; //@line 135791 "c/sqlite3.c"
          $128 = $99; //@line 135792 "c/sqlite3.c"
          $129 = $128; //@line 135792 "c/sqlite3.c"
          $130 = HEAP32[$129>>2]|0; //@line 135792 "c/sqlite3.c"
          $131 = (($128) + 4)|0; //@line 135792 "c/sqlite3.c"
          $132 = $131; //@line 135792 "c/sqlite3.c"
          $133 = HEAP32[$132>>2]|0; //@line 135792 "c/sqlite3.c"
          $134 = $130 | $1; //@line 135792 "c/sqlite3.c"
          $135 = $133 | $2; //@line 135792 "c/sqlite3.c"
          $136 = $7; //@line 135792 "c/sqlite3.c"
          $137 = $136; //@line 135792 "c/sqlite3.c"
          HEAP32[$137>>2] = $134; //@line 135792 "c/sqlite3.c"
          $138 = (($136) + 4)|0; //@line 135792 "c/sqlite3.c"
          $139 = $138; //@line 135792 "c/sqlite3.c"
          HEAP32[$139>>2] = $135; //@line 135792 "c/sqlite3.c"
          $140 = (_whereLoopInsert($0,$7)|0); //@line 135793 "c/sqlite3.c"
          $$1209 = $140;
         }
        } else {
         $$1209 = 0;
        }
        $141 = ((($$0217243)) + 48|0); //@line 135763 "c/sqlite3.c"
        $142 = ($$1209|0)==(0); //@line 135763 "c/sqlite3.c"
        $143 = ($141>>>0)<($79>>>0); //@line 135763 "c/sqlite3.c"
        $or$cond222 = $143 & $142; //@line 135763 "c/sqlite3.c"
        if ($or$cond222) {
         $$0217243 = $141;
        } else {
         $$2 = $$1209;
         break;
        }
       }
      } else {
       $$2 = 0;
      }
     } else {
      $$2 = 0;
     }
    } else {
     $$2 = 0;
    }
   }
  } else {
   $$2 = 0;
  }
 } else {
  $$2 = 0;
 }
 $144 = ((($7)) + 36|0); //@line 135826 "c/sqlite3.c"
 $145 = ($$2|0)==(0); //@line 135801 "c/sqlite3.c"
 $146 = ($$0206|0)!=(0|0); //@line 135801 "c/sqlite3.c"
 $147 = $145 & $146; //@line 135801 "c/sqlite3.c"
 if (!($147)) {
  $$7 = $$2;
  STACKTOP = sp;return ($$7|0); //@line 135915 "c/sqlite3.c"
 }
 $148 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 44|0);
 $149 = ((($7)) + 24|0);
 $150 = ((($7)) + 26|0);
 $151 = ((($7)) + 28|0);
 $152 = ((($7)) + 42|0);
 $153 = ((($7)) + 40|0);
 $154 = ((($7)) + 17|0);
 $155 = ((($7)) + 18|0);
 $156 = ((($7)) + 22|0);
 $157 = ((($7)) + 32|0);
 $158 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 44|0);
 $159 = ((($7)) + 20|0);
 $160 = ((($0)) + 20|0);
 $161 = ((($16)) + 36|0);
 $162 = (((((($10)) + 8|0) + (($13*72)|0)|0)) + 56|0);
 $163 = ((($7)) + 36|0);
 $164 = ((($7)) + 36|0);
 $165 = ((($16)) + 46|0);
 $166 = ((($7)) + 20|0);
 $167 = ((($16)) + 36|0);
 $168 = ((($8)) + 100|0);
 $169 = ((($8)) + 92|0);
 $170 = ((($16)) + 46|0);
 $171 = ((($8)) + 44|0);
 $$0210228 = 1;$$1207231 = $$0206;
 L34: while(1) {
  $172 = ((($$1207231)) + 36|0); //@line 135804 "c/sqlite3.c"
  $173 = HEAP32[$172>>2]|0; //@line 135804 "c/sqlite3.c"
  $174 = ($173|0)==(0|0); //@line 135804 "c/sqlite3.c"
  if ($174) {
   label = 27;
  } else {
   $175 = HEAP32[$148>>2]|0; //@line 135805 "c/sqlite3.c"
   $176 = (_whereUsablePartialIndex($175,$18,$173)|0); //@line 135805 "c/sqlite3.c"
   $177 = ($176|0)==(0); //@line 135805 "c/sqlite3.c"
   if ($177) {
    $$6 = 0;
   } else {
    label = 27;
   }
  }
  if ((label|0) == 27) {
   label = 0;
   $178 = ((($$1207231)) + 55|0); //@line 135809 "c/sqlite3.c"
   $179 = HEAPU8[$178>>0]|(HEAPU8[$178+1>>0]<<8); //@line 135809 "c/sqlite3.c"
   $180 = $179 & 256; //@line 135809 "c/sqlite3.c"
   $181 = ($180<<16>>16)==(0); //@line 135809 "c/sqlite3.c"
   if ($181) {
    $182 = ((($$1207231)) + 8|0); //@line 135810 "c/sqlite3.c"
    $183 = HEAP32[$182>>2]|0; //@line 135810 "c/sqlite3.c"
    $184 = HEAP16[$183>>1]|0; //@line 135810 "c/sqlite3.c"
    HEAP16[$149>>1] = 0; //@line 135811 "c/sqlite3.c"
    HEAP16[$150>>1] = 0; //@line 135812 "c/sqlite3.c"
    HEAP16[$151>>1] = 0; //@line 135813 "c/sqlite3.c"
    HEAP16[$152>>1] = 0; //@line 135814 "c/sqlite3.c"
    HEAP16[$153>>1] = 0; //@line 135815 "c/sqlite3.c"
    HEAP8[$154>>0] = 0; //@line 135816 "c/sqlite3.c"
    HEAP16[$155>>1] = 0; //@line 135817 "c/sqlite3.c"
    $185 = $7; //@line 135818 "c/sqlite3.c"
    $186 = $185; //@line 135818 "c/sqlite3.c"
    HEAP32[$186>>2] = $1; //@line 135818 "c/sqlite3.c"
    $187 = (($185) + 4)|0; //@line 135818 "c/sqlite3.c"
    $188 = $187; //@line 135818 "c/sqlite3.c"
    HEAP32[$188>>2] = $2; //@line 135818 "c/sqlite3.c"
    HEAP16[$156>>1] = $184; //@line 135819 "c/sqlite3.c"
    HEAP32[$157>>2] = $$1207231; //@line 135820 "c/sqlite3.c"
    $189 = HEAP32[$158>>2]|0; //@line 135821 "c/sqlite3.c"
    $190 = (_indexMightHelpWithOrderBy($0,$$1207231,$189)|0); //@line 135821 "c/sqlite3.c"
    $191 = ((($$1207231)) + 44|0); //@line 135824 "c/sqlite3.c"
    $192 = HEAP32[$191>>2]|0; //@line 135824 "c/sqlite3.c"
    $193 = ($192|0)<(1); //@line 135824 "c/sqlite3.c"
    do {
     if ($193) {
      HEAP32[$144>>2] = 256; //@line 135826 "c/sqlite3.c"
      $194 = ($190|0)==(0); //@line 135829 "c/sqlite3.c"
      $195 = $$0210228&255; //@line 135829 "c/sqlite3.c"
      $196 = $194 ? 0 : $195; //@line 135829 "c/sqlite3.c"
      HEAP8[$154>>0] = $196; //@line 135829 "c/sqlite3.c"
      $197 = $184&65535; //@line 135831 "c/sqlite3.c"
      $198 = (($197) + 16)|0; //@line 135831 "c/sqlite3.c"
      $199 = $198&65535; //@line 135831 "c/sqlite3.c"
      HEAP16[$159>>1] = $199; //@line 135831 "c/sqlite3.c"
      _whereLoopOutputAdjust($18,$7,$184); //@line 135833 "c/sqlite3.c"
      $200 = (_whereLoopInsert($0,$7)|0); //@line 135834 "c/sqlite3.c"
      HEAP16[$156>>1] = $184; //@line 135835 "c/sqlite3.c"
      $201 = ($200|0)==(0); //@line 135836 "c/sqlite3.c"
      if (!($201)) {
       $$7 = $200;
       label = 56;
       break L34;
      }
     } else {
      $202 = HEAPU8[$178>>0]|(HEAPU8[$178+1>>0]<<8); //@line 135839 "c/sqlite3.c"
      $203 = $202 & 32; //@line 135839 "c/sqlite3.c"
      $204 = ($203<<16>>16)==(0); //@line 135839 "c/sqlite3.c"
      if ($204) {
       $205 = $162; //@line 135843 "c/sqlite3.c"
       $206 = $205; //@line 135843 "c/sqlite3.c"
       $207 = HEAP32[$206>>2]|0; //@line 135843 "c/sqlite3.c"
       $208 = (($205) + 4)|0; //@line 135843 "c/sqlite3.c"
       $209 = $208; //@line 135843 "c/sqlite3.c"
       $210 = HEAP32[$209>>2]|0; //@line 135843 "c/sqlite3.c"
       $211 = (_columnsInIndex($$1207231)|0); //@line 135843 "c/sqlite3.c"
       $212 = tempRet0; //@line 135843 "c/sqlite3.c"
       $213 = $211 ^ -1; //@line 135843 "c/sqlite3.c"
       $214 = $212 ^ -1; //@line 135843 "c/sqlite3.c"
       $215 = $207 & $213; //@line 135843 "c/sqlite3.c"
       $216 = $210 & $214; //@line 135843 "c/sqlite3.c"
       $217 = ($215|0)==(0); //@line 135844 "c/sqlite3.c"
       $218 = ($216|0)==(0); //@line 135844 "c/sqlite3.c"
       $219 = $217 & $218; //@line 135844 "c/sqlite3.c"
       $220 = $219 ? 576 : 512; //@line 135844 "c/sqlite3.c"
       HEAP32[$163>>2] = $220; //@line 135844 "c/sqlite3.c"
       $228 = $215;$230 = $216;
      } else {
       HEAP32[$164>>2] = 576; //@line 135840 "c/sqlite3.c"
       $228 = 0;$230 = 0;
      }
      $221 = ($190|0)!=(0); //@line 135848 "c/sqlite3.c"
      if (!($221)) {
       $222 = HEAP32[$167>>2]|0; //@line 135849 "c/sqlite3.c"
       $223 = $222 & 32; //@line 135849 "c/sqlite3.c"
       $224 = ($223|0)==(0); //@line 135849 "c/sqlite3.c"
       if ($224) {
        $225 = HEAP32[$172>>2]|0; //@line 135850 "c/sqlite3.c"
        $226 = ($225|0)==(0|0); //@line 135850 "c/sqlite3.c"
        if ($226) {
         $227 = ($228|0)==(0); //@line 135851 "c/sqlite3.c"
         $229 = ($230|0)==(0); //@line 135851 "c/sqlite3.c"
         $231 = $227 & $229; //@line 135851 "c/sqlite3.c"
         if (!($231)) {
          break;
         }
         $232 = HEAPU8[$178>>0]|(HEAPU8[$178+1>>0]<<8); //@line 135852 "c/sqlite3.c"
         $233 = $232 & 4; //@line 135852 "c/sqlite3.c"
         $234 = ($233<<16>>16)==(0); //@line 135852 "c/sqlite3.c"
         if (!($234)) {
          break;
         }
         $235 = ((($$1207231)) + 48|0); //@line 135853 "c/sqlite3.c"
         $236 = HEAP16[$235>>1]|0; //@line 135853 "c/sqlite3.c"
         $237 = HEAP16[$170>>1]|0; //@line 135853 "c/sqlite3.c"
         $238 = ($236<<16>>16)<($237<<16>>16); //@line 135853 "c/sqlite3.c"
         if (!($238)) {
          break;
         }
         $239 = HEAP16[$171>>1]|0; //@line 135854 "c/sqlite3.c"
         $240 = $239 & 4; //@line 135854 "c/sqlite3.c"
         $241 = ($240<<16>>16)==(0); //@line 135854 "c/sqlite3.c"
         $242 = HEAP32[(24)>>2]|0; //@line 135855 "c/sqlite3.c"
         $243 = ($242|0)!=(0); //@line 135855 "c/sqlite3.c"
         $or$cond = $241 & $243; //@line 135855 "c/sqlite3.c"
         if (!($or$cond)) {
          break;
         }
         $244 = HEAP32[$8>>2]|0; //@line 135856 "c/sqlite3.c"
         $245 = HEAP32[$244>>2]|0; //@line 135856 "c/sqlite3.c"
         $246 = ((($245)) + 68|0); //@line 135856 "c/sqlite3.c"
         $247 = HEAP16[$246>>1]|0; //@line 135856 "c/sqlite3.c"
         $248 = $247 & 32; //@line 135856 "c/sqlite3.c"
         $249 = ($248<<16>>16)==(0); //@line 135856 "c/sqlite3.c"
         if (!($249)) {
          break;
         }
        }
       }
      }
      $250 = $$0210228&255; //@line 135859 "c/sqlite3.c"
      $251 = $221 ? $250 : 0; //@line 135859 "c/sqlite3.c"
      HEAP8[$154>>0] = $251; //@line 135859 "c/sqlite3.c"
      $252 = $184 << 16 >> 16; //@line 135864 "c/sqlite3.c"
      $253 = (($252) + 1)|0; //@line 135864 "c/sqlite3.c"
      $254 = ((($$1207231)) + 48|0); //@line 135864 "c/sqlite3.c"
      $255 = HEAP16[$254>>1]|0; //@line 135864 "c/sqlite3.c"
      $256 = $255 << 16 >> 16; //@line 135864 "c/sqlite3.c"
      $257 = ($256*15)|0; //@line 135864 "c/sqlite3.c"
      $258 = HEAP16[$165>>1]|0; //@line 135864 "c/sqlite3.c"
      $259 = $258 << 16 >> 16; //@line 135864 "c/sqlite3.c"
      $260 = (($257|0) / ($259|0))&-1; //@line 135864 "c/sqlite3.c"
      $261 = (($253) + ($260))|0; //@line 135864 "c/sqlite3.c"
      $262 = $261&65535; //@line 135864 "c/sqlite3.c"
      HEAP16[$166>>1] = $262; //@line 135864 "c/sqlite3.c"
      $263 = ($228|0)==(0); //@line 135865 "c/sqlite3.c"
      $264 = ($230|0)==(0); //@line 135865 "c/sqlite3.c"
      $265 = $263 & $264; //@line 135865 "c/sqlite3.c"
      if (!($265)) {
       $266 = (($252) + 16)|0; //@line 135871 "c/sqlite3.c"
       $267 = $266&65535; //@line 135871 "c/sqlite3.c"
       $268 = HEAP32[$158>>2]|0; //@line 135873 "c/sqlite3.c"
       $269 = HEAP32[$169>>2]|0; //@line 135875 "c/sqlite3.c"
       $270 = ($269|0)>(0); //@line 135875 "c/sqlite3.c"
       L59: do {
        if ($270) {
         $$0211225 = 0;$$0212224 = $267;
         while(1) {
          $271 = HEAP32[$168>>2]|0; //@line 135876 "c/sqlite3.c"
          $272 = (($271) + (($$0211225*48)|0)|0); //@line 135877 "c/sqlite3.c"
          $273 = HEAP32[$272>>2]|0; //@line 135877 "c/sqlite3.c"
          $274 = (_sqlite3ExprCoveredByIndex($273,$268,$$1207231)|0); //@line 135877 "c/sqlite3.c"
          $275 = ($274|0)==(0); //@line 135877 "c/sqlite3.c"
          if ($275) {
           $$0212$lcssa = $$0212224;
           break L59;
          }
          $276 = (((($271) + (($$0211225*48)|0)|0)) + 8|0); //@line 135882 "c/sqlite3.c"
          $277 = HEAP16[$276>>1]|0; //@line 135882 "c/sqlite3.c"
          $278 = ($277<<16>>16)<(1); //@line 135882 "c/sqlite3.c"
          if ($278) {
           $279 = $277&65535; //@line 135882 "c/sqlite3.c"
           $280 = $$0212224&65535; //@line 135883 "c/sqlite3.c"
           $281 = (($279) + ($280))|0; //@line 135883 "c/sqlite3.c"
           $282 = $281&65535; //@line 135883 "c/sqlite3.c"
           $$2214$ph = $282;
          } else {
           $283 = (($$0212224) + -1)<<16>>16; //@line 135885 "c/sqlite3.c"
           $284 = (((($271) + (($$0211225*48)|0)|0)) + 12|0); //@line 135886 "c/sqlite3.c"
           $285 = HEAP16[$284>>1]|0; //@line 135886 "c/sqlite3.c"
           $286 = $285 & 130; //@line 135886 "c/sqlite3.c"
           $287 = ($286<<16>>16)==(0); //@line 135886 "c/sqlite3.c"
           if ($287) {
            $$2214$ph = $283;
           } else {
            $288 = $283&65535; //@line 135886 "c/sqlite3.c"
            $289 = (($288) + 65517)|0; //@line 135886 "c/sqlite3.c"
            $290 = $289&65535; //@line 135886 "c/sqlite3.c"
            $$2214$ph = $290;
           }
          }
          $291 = (($$0211225) + 1)|0; //@line 135875 "c/sqlite3.c"
          $292 = HEAP32[$169>>2]|0; //@line 135875 "c/sqlite3.c"
          $293 = ($291|0)<($292|0); //@line 135875 "c/sqlite3.c"
          if ($293) {
           $$0211225 = $291;$$0212224 = $$2214$ph;
          } else {
           $$0212$lcssa = $$2214$ph;
           break;
          }
         }
        } else {
         $$0212$lcssa = $267;
        }
       } while(0);
       $294 = HEAP16[$166>>1]|0; //@line 135890 "c/sqlite3.c"
       $295 = (_sqlite3LogEstAdd($294,$$0212$lcssa)|0); //@line 135890 "c/sqlite3.c"
       HEAP16[$166>>1] = $295; //@line 135890 "c/sqlite3.c"
      }
      _whereLoopOutputAdjust($18,$7,$184); //@line 135893 "c/sqlite3.c"
      $296 = (_whereLoopInsert($0,$7)|0); //@line 135894 "c/sqlite3.c"
      HEAP16[$156>>1] = $184; //@line 135895 "c/sqlite3.c"
      $297 = ($296|0)==(0); //@line 135896 "c/sqlite3.c"
      if (!($297)) {
       $$7 = $296;
       label = 56;
       break L34;
      }
     }
    } while(0);
    HEAP32[$160>>2] = 0; //@line 135900 "c/sqlite3.c"
    $298 = (_whereLoopAddBtreeIndex($0,$14,$$1207231,0)|0); //@line 135901 "c/sqlite3.c"
    $299 = HEAP32[$160>>2]|0; //@line 135902 "c/sqlite3.c"
    $300 = ($299|0)==(1); //@line 135902 "c/sqlite3.c"
    if ($300) {
     $301 = HEAP32[$161>>2]|0; //@line 135907 "c/sqlite3.c"
     $302 = $301 | 256; //@line 135907 "c/sqlite3.c"
     HEAP32[$161>>2] = $302; //@line 135907 "c/sqlite3.c"
     $$6 = $298;
    } else {
     $$6 = $298;
    }
   } else {
    $$6 = 0;
   }
  }
  $303 = HEAP32[$19>>2]|0; //@line 135802 "c/sqlite3.c"
  $304 = ($303|0)==(0|0); //@line 135802 "c/sqlite3.c"
  if (!($304)) {
   $$7 = $$6;
   label = 56;
   break;
  }
  $305 = ((($$1207231)) + 20|0); //@line 135802 "c/sqlite3.c"
  $306 = HEAP32[$305>>2]|0; //@line 135802 "c/sqlite3.c"
  $307 = (($$0210228) + 1)|0; //@line 135802 "c/sqlite3.c"
  $308 = ($$6|0)==(0); //@line 135801 "c/sqlite3.c"
  $309 = ($306|0)!=(0|0); //@line 135801 "c/sqlite3.c"
  $310 = $308 & $309; //@line 135801 "c/sqlite3.c"
  if ($310) {
   $$0210228 = $307;$$1207231 = $306;
  } else {
   $$7 = $$6;
   label = 56;
   break;
  }
 }
 if ((label|0) == 56) {
  STACKTOP = sp;return ($$7|0); //@line 135915 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereLoopAddOr($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0100 = 0, $$092101 = 0, $$093107 = 0, $$095106 = 0, $$096116 = 0, $$097$lcssa = 0, $$1110 = 0, $$194 = 0, $$198105 = 0, $$2 = 0, $$3 = 0, $$4 = 0, $$5 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0;
 var $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0;
 var $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 608|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(608|0);
 $5 = sp + 168|0;
 $6 = sp + 576|0;
 $7 = sp + 112|0;
 $8 = sp + 56|0;
 $9 = sp;
 $10 = HEAP32[$0>>2]|0; //@line 136241 "c/sqlite3.c"
 $11 = ((($0)) + 4|0); //@line 136252 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 136252 "c/sqlite3.c"
 $13 = ((($12)) + 20|0); //@line 136253 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 136253 "c/sqlite3.c"
 $15 = ((($12)) + 12|0); //@line 136253 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 136253 "c/sqlite3.c"
 $17 = (($14) + (($16*48)|0)|0); //@line 136253 "c/sqlite3.c"
 $18 = ((($0)) + 12|0); //@line 136254 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 136254 "c/sqlite3.c"
 dest=$7; stop=dest+56|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 136255 "c/sqlite3.c"
 $20 = ((($10)) + 4|0); //@line 136256 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 136256 "c/sqlite3.c"
 $22 = ((($19)) + 16|0); //@line 136256 "c/sqlite3.c"
 $23 = HEAP8[$22>>0]|0; //@line 136256 "c/sqlite3.c"
 $24 = $23&255; //@line 136256 "c/sqlite3.c"
 $25 = (((((($21)) + 8|0) + (($24*72)|0)|0)) + 44|0); //@line 136257 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 136257 "c/sqlite3.c"
 $27 = ($16|0)>(0); //@line 136259 "c/sqlite3.c"
 if (!($27)) {
  $$097$lcssa = 0;
  STACKTOP = sp;return ($$097$lcssa|0); //@line 136353 "c/sqlite3.c"
 }
 $28 = ((($19)) + 8|0);
 $29 = ((($6)) + 8|0);
 $30 = ((($6)) + 16|0);
 $31 = (((((($21)) + 8|0) + (($24*72)|0)|0)) + 16|0);
 $32 = ((($6)) + 4|0);
 $33 = ((($5)) + 4|0);
 $34 = ((($5)) + 8|0);
 $35 = ((($5)) + 12|0);
 $36 = ((($5)) + 20|0);
 $37 = ((($6)) + 4|0);
 $38 = ((($19)) + 40|0);
 $39 = ((($19)) + 48|0);
 $40 = ((($19)) + 36|0);
 $41 = ((($19)) + 18|0);
 $42 = ((($19)) + 17|0);
 $43 = ((($19)) + 24|0);
 $44 = ((($19)) + 20|0);
 $45 = ((($19)) + 22|0);
 $$096116 = $14;
 L4: while(1) {
  $46 = ((($$096116)) + 12|0); //@line 136260 "c/sqlite3.c"
  $47 = HEAP16[$46>>1]|0; //@line 136260 "c/sqlite3.c"
  $48 = $47 & 512; //@line 136260 "c/sqlite3.c"
  $49 = ($48<<16>>16)==(0); //@line 136260 "c/sqlite3.c"
  L6: do {
   if (!($49)) {
    $50 = ((($$096116)) + 28|0); //@line 136261 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 136261 "c/sqlite3.c"
    $52 = ((($51)) + 408|0); //@line 136261 "c/sqlite3.c"
    $53 = $52; //@line 136261 "c/sqlite3.c"
    $54 = $53; //@line 136261 "c/sqlite3.c"
    $55 = HEAP32[$54>>2]|0; //@line 136261 "c/sqlite3.c"
    $56 = (($53) + 4)|0; //@line 136261 "c/sqlite3.c"
    $57 = $56; //@line 136261 "c/sqlite3.c"
    $58 = HEAP32[$57>>2]|0; //@line 136261 "c/sqlite3.c"
    $59 = $28; //@line 136261 "c/sqlite3.c"
    $60 = $59; //@line 136261 "c/sqlite3.c"
    $61 = HEAP32[$60>>2]|0; //@line 136261 "c/sqlite3.c"
    $62 = (($59) + 4)|0; //@line 136261 "c/sqlite3.c"
    $63 = $62; //@line 136261 "c/sqlite3.c"
    $64 = HEAP32[$63>>2]|0; //@line 136261 "c/sqlite3.c"
    $65 = $61 & $55; //@line 136261 "c/sqlite3.c"
    $66 = $64 & $58; //@line 136261 "c/sqlite3.c"
    $67 = ($65|0)==(0); //@line 136261 "c/sqlite3.c"
    $68 = ($66|0)==(0); //@line 136261 "c/sqlite3.c"
    $69 = $67 & $68; //@line 136261 "c/sqlite3.c"
    if (!($69)) {
     $70 = ((($51)) + 20|0); //@line 136264 "c/sqlite3.c"
     $71 = HEAP32[$70>>2]|0; //@line 136264 "c/sqlite3.c"
     $72 = ((($51)) + 12|0); //@line 136264 "c/sqlite3.c"
     $73 = HEAP32[$72>>2]|0; //@line 136264 "c/sqlite3.c"
     $74 = (($71) + (($73*48)|0)|0); //@line 136264 "c/sqlite3.c"
     ;HEAP32[$6>>2]=HEAP32[$0>>2]|0;HEAP32[$6+4>>2]=HEAP32[$0+4>>2]|0;HEAP32[$6+8>>2]=HEAP32[$0+8>>2]|0;HEAP32[$6+12>>2]=HEAP32[$0+12>>2]|0;HEAP32[$6+16>>2]=HEAP32[$0+16>>2]|0;HEAP32[$6+20>>2]=HEAP32[$0+20>>2]|0; //@line 136269 "c/sqlite3.c"
     HEAP32[$29>>2] = 0; //@line 136270 "c/sqlite3.c"
     HEAP32[$30>>2] = $8; //@line 136271 "c/sqlite3.c"
     $75 = HEAP32[$70>>2]|0; //@line 136274 "c/sqlite3.c"
     $76 = ($75>>>0)<($74>>>0); //@line 136274 "c/sqlite3.c"
     L9: do {
      if ($76) {
       $$093107 = 1;$$095106 = $75;$$198105 = 0;
       L11: while(1) {
        $77 = ((($$095106)) + 12|0); //@line 136275 "c/sqlite3.c"
        $78 = HEAP16[$77>>1]|0; //@line 136275 "c/sqlite3.c"
        $79 = $78 & 1024; //@line 136275 "c/sqlite3.c"
        $80 = ($79<<16>>16)==(0); //@line 136275 "c/sqlite3.c"
        if ($80) {
         $83 = ((($$095106)) + 20|0); //@line 136277 "c/sqlite3.c"
         $84 = HEAP32[$83>>2]|0; //@line 136277 "c/sqlite3.c"
         $85 = ($84|0)==($26|0); //@line 136277 "c/sqlite3.c"
         if ($85) {
          $86 = HEAP32[$12>>2]|0; //@line 136278 "c/sqlite3.c"
          HEAP32[$5>>2] = $86; //@line 136278 "c/sqlite3.c"
          HEAP32[$33>>2] = $12; //@line 136279 "c/sqlite3.c"
          HEAP8[$34>>0] = 44; //@line 136280 "c/sqlite3.c"
          HEAP32[$35>>2] = 1; //@line 136281 "c/sqlite3.c"
          HEAP32[$36>>2] = $$095106; //@line 136282 "c/sqlite3.c"
          HEAP32[$37>>2] = $5; //@line 136283 "c/sqlite3.c"
          label = 11;
         } else {
          $$194 = $$093107;$$4 = $$198105;
         }
        } else {
         $81 = ((($$095106)) + 28|0); //@line 136276 "c/sqlite3.c"
         $82 = HEAP32[$81>>2]|0; //@line 136276 "c/sqlite3.c"
         HEAP32[$32>>2] = $82; //@line 136276 "c/sqlite3.c"
         label = 11;
        }
        do {
         if ((label|0) == 11) {
          label = 0;
          HEAP16[$8>>1] = 0; //@line 136287 "c/sqlite3.c"
          $87 = HEAP32[$31>>2]|0; //@line 136296 "c/sqlite3.c"
          $88 = ((($87)) + 56|0); //@line 136296 "c/sqlite3.c"
          $89 = HEAP32[$88>>2]|0; //@line 136296 "c/sqlite3.c"
          $90 = ($89|0)==(0); //@line 136296 "c/sqlite3.c"
          if ($90) {
           $92 = (_whereLoopAddBtree($6,$1,$2)|0); //@line 136301 "c/sqlite3.c"
           $$2 = $92;
          } else {
           $91 = (_whereLoopAddVirtual($6,$1,$2,$3,$4)|0); //@line 136297 "c/sqlite3.c"
           $$2 = $91;
          }
          $93 = ($$2|0)==(0); //@line 136303 "c/sqlite3.c"
          if ($93) {
           $94 = (_whereLoopAddOr($6,$1,$2,$3,$4)|0); //@line 136304 "c/sqlite3.c"
           $$3 = $94;
          } else {
           $$3 = $$2;
          }
          $95 = HEAP16[$8>>1]|0; //@line 136307 "c/sqlite3.c"
          $96 = ($95<<16>>16)==(0); //@line 136307 "c/sqlite3.c"
          if ($96) {
           break L11;
          }
          $97 = ($$093107|0)==(0); //@line 136310 "c/sqlite3.c"
          if (!($97)) {
           _whereOrMove($7,$8); //@line 136311 "c/sqlite3.c"
           $$194 = 0;$$4 = $$3;
           break;
          }
          _whereOrMove($9,$7); //@line 136315 "c/sqlite3.c"
          HEAP16[$7>>1] = 0; //@line 136316 "c/sqlite3.c"
          $98 = HEAP16[$9>>1]|0; //@line 136317 "c/sqlite3.c"
          $99 = ($98<<16>>16)==(0); //@line 136317 "c/sqlite3.c"
          if (!($99)) {
           $100 = HEAP16[$9>>1]|0;
           $101 = $100&65535;
           $$092101 = 0;
           while(1) {
            $102 = HEAP16[$8>>1]|0; //@line 136318 "c/sqlite3.c"
            $103 = ($102<<16>>16)==(0); //@line 136318 "c/sqlite3.c"
            if (!($103)) {
             $104 = (((($9)) + 8|0) + ($$092101<<4)|0);
             $105 = (((((($9)) + 8|0) + ($$092101<<4)|0)) + 8|0);
             $106 = (((((($9)) + 8|0) + ($$092101<<4)|0)) + 10|0);
             $$0100 = 0;
             while(1) {
              $107 = $104; //@line 136319 "c/sqlite3.c"
              $108 = $107; //@line 136319 "c/sqlite3.c"
              $109 = HEAP32[$108>>2]|0; //@line 136319 "c/sqlite3.c"
              $110 = (($107) + 4)|0; //@line 136319 "c/sqlite3.c"
              $111 = $110; //@line 136319 "c/sqlite3.c"
              $112 = HEAP32[$111>>2]|0; //@line 136319 "c/sqlite3.c"
              $113 = (((($8)) + 8|0) + ($$0100<<4)|0); //@line 136319 "c/sqlite3.c"
              $114 = $113; //@line 136319 "c/sqlite3.c"
              $115 = $114; //@line 136319 "c/sqlite3.c"
              $116 = HEAP32[$115>>2]|0; //@line 136319 "c/sqlite3.c"
              $117 = (($114) + 4)|0; //@line 136319 "c/sqlite3.c"
              $118 = $117; //@line 136319 "c/sqlite3.c"
              $119 = HEAP32[$118>>2]|0; //@line 136319 "c/sqlite3.c"
              $120 = $116 | $109; //@line 136319 "c/sqlite3.c"
              $121 = $119 | $112; //@line 136319 "c/sqlite3.c"
              $122 = HEAP16[$105>>1]|0; //@line 136320 "c/sqlite3.c"
              $123 = (((((($8)) + 8|0) + ($$0100<<4)|0)) + 8|0); //@line 136320 "c/sqlite3.c"
              $124 = HEAP16[$123>>1]|0; //@line 136320 "c/sqlite3.c"
              $125 = (_sqlite3LogEstAdd($122,$124)|0); //@line 136320 "c/sqlite3.c"
              $126 = HEAP16[$106>>1]|0; //@line 136321 "c/sqlite3.c"
              $127 = (((((($8)) + 8|0) + ($$0100<<4)|0)) + 10|0); //@line 136321 "c/sqlite3.c"
              $128 = HEAP16[$127>>1]|0; //@line 136321 "c/sqlite3.c"
              $129 = (_sqlite3LogEstAdd($126,$128)|0); //@line 136321 "c/sqlite3.c"
              _whereOrInsert($7,$120,$121,$125,$129); //@line 136319 "c/sqlite3.c"
              $130 = (($$0100) + 1)|0; //@line 136318 "c/sqlite3.c"
              $131 = HEAP16[$8>>1]|0; //@line 136318 "c/sqlite3.c"
              $132 = $131&65535; //@line 136318 "c/sqlite3.c"
              $133 = ($130>>>0)<($132>>>0); //@line 136318 "c/sqlite3.c"
              if ($133) {
               $$0100 = $130;
              } else {
               break;
              }
             }
            }
            $134 = (($$092101) + 1)|0; //@line 136317 "c/sqlite3.c"
            $135 = ($134>>>0)<($101>>>0); //@line 136317 "c/sqlite3.c"
            if ($135) {
             $$092101 = $134;
            } else {
             break;
            }
           }
          }
          $$194 = $$093107;$$4 = $$3;
         }
        } while(0);
        $136 = ((($$095106)) + 48|0); //@line 136274 "c/sqlite3.c"
        $137 = ($136>>>0)<($74>>>0); //@line 136274 "c/sqlite3.c"
        if ($137) {
         $$093107 = $$194;$$095106 = $136;$$198105 = $$4;
        } else {
         $$5 = $$4;
         break L9;
        }
       }
       HEAP16[$7>>1] = 0; //@line 136308 "c/sqlite3.c"
       $$5 = $$3;
      } else {
       $$5 = 0;
      }
     } while(0);
     HEAP16[$38>>1] = 1; //@line 136326 "c/sqlite3.c"
     $138 = HEAP32[$39>>2]|0; //@line 136327 "c/sqlite3.c"
     HEAP32[$138>>2] = $$096116; //@line 136327 "c/sqlite3.c"
     HEAP32[$40>>2] = 8192; //@line 136328 "c/sqlite3.c"
     HEAP16[$41>>1] = 0; //@line 136329 "c/sqlite3.c"
     HEAP8[$42>>0] = 0; //@line 136330 "c/sqlite3.c"
     ;HEAP32[$43>>2]=0|0;HEAP32[$43+4>>2]=0|0;HEAP32[$43+8>>2]=0|0; //@line 136331 "c/sqlite3.c"
     $139 = ($$5|0)==(0); //@line 136332 "c/sqlite3.c"
     if (!($139)) {
      $$097$lcssa = $$5;
      label = 33;
      break L4;
     }
     $140 = HEAP16[$7>>1]|0;
     $141 = $140&65535;
     $$1110 = 0;
     while(1) {
      $142 = ($$1110>>>0)<($141>>>0); //@line 136332 "c/sqlite3.c"
      if (!($142)) {
       break L6;
      }
      $143 = (((((($7)) + 8|0) + ($$1110<<4)|0)) + 8|0); //@line 136345 "c/sqlite3.c"
      $144 = HEAP16[$143>>1]|0; //@line 136345 "c/sqlite3.c"
      $145 = $144&65535; //@line 136345 "c/sqlite3.c"
      $146 = (($145) + 1)|0; //@line 136345 "c/sqlite3.c"
      $147 = $146&65535; //@line 136345 "c/sqlite3.c"
      HEAP16[$44>>1] = $147; //@line 136345 "c/sqlite3.c"
      $148 = (((((($7)) + 8|0) + ($$1110<<4)|0)) + 10|0); //@line 136346 "c/sqlite3.c"
      $149 = HEAP16[$148>>1]|0; //@line 136346 "c/sqlite3.c"
      HEAP16[$45>>1] = $149; //@line 136346 "c/sqlite3.c"
      $150 = (((($7)) + 8|0) + ($$1110<<4)|0); //@line 136347 "c/sqlite3.c"
      $151 = $150; //@line 136347 "c/sqlite3.c"
      $152 = $151; //@line 136347 "c/sqlite3.c"
      $153 = HEAP32[$152>>2]|0; //@line 136347 "c/sqlite3.c"
      $154 = (($151) + 4)|0; //@line 136347 "c/sqlite3.c"
      $155 = $154; //@line 136347 "c/sqlite3.c"
      $156 = HEAP32[$155>>2]|0; //@line 136347 "c/sqlite3.c"
      $157 = $19; //@line 136347 "c/sqlite3.c"
      $158 = $157; //@line 136347 "c/sqlite3.c"
      HEAP32[$158>>2] = $153; //@line 136347 "c/sqlite3.c"
      $159 = (($157) + 4)|0; //@line 136347 "c/sqlite3.c"
      $160 = $159; //@line 136347 "c/sqlite3.c"
      HEAP32[$160>>2] = $156; //@line 136347 "c/sqlite3.c"
      $161 = (_whereLoopInsert($0,$19)|0); //@line 136348 "c/sqlite3.c"
      $162 = (($$1110) + 1)|0; //@line 136332 "c/sqlite3.c"
      $163 = ($161|0)==(0); //@line 136332 "c/sqlite3.c"
      if ($163) {
       $$1110 = $162;
      } else {
       $$097$lcssa = $161;
       label = 33;
       break L4;
      }
     }
    }
   }
  } while(0);
  $164 = ((($$096116)) + 48|0); //@line 136259 "c/sqlite3.c"
  $165 = ($164>>>0)<($17>>>0); //@line 136259 "c/sqlite3.c"
  if ($165) {
   $$096116 = $164;
  } else {
   $$097$lcssa = 0;
   label = 33;
   break;
  }
 }
 if ((label|0) == 33) {
  STACKTOP = sp;return ($$097$lcssa|0); //@line 136353 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereOrMove($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP16[$1>>1]|0; //@line 133039 "c/sqlite3.c"
 HEAP16[$0>>1] = $2; //@line 133039 "c/sqlite3.c"
 $3 = ((($0)) + 8|0); //@line 133040 "c/sqlite3.c"
 $4 = ((($1)) + 8|0); //@line 133040 "c/sqlite3.c"
 $5 = $2&65535; //@line 133040 "c/sqlite3.c"
 $6 = $5 << 4; //@line 133040 "c/sqlite3.c"
 _memcpy(($3|0),($4|0),($6|0))|0; //@line 133040 "c/sqlite3.c"
 return; //@line 133041 "c/sqlite3.c"
}
function _whereOrInsert($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0407 = 0, $$08 = 0, $$15 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0;
 var $indvars$iv = 0, $indvars$iv$next = 0, $spec$select = 0, $wide$trip$count = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP16[$0>>1]|0; //@line 133058 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 133058 "c/sqlite3.c"
 $7 = ($5<<16>>16)==(0); //@line 133058 "c/sqlite3.c"
 L1: do {
  if ($7) {
   label = 9;
  } else {
   $$0407 = $5;$$08 = $6;
   while(1) {
    $8 = ((($$08)) + 8|0); //@line 133059 "c/sqlite3.c"
    $9 = HEAP16[$8>>1]|0; //@line 133059 "c/sqlite3.c"
    $10 = ($9<<16>>16)<($3<<16>>16); //@line 133059 "c/sqlite3.c"
    if (!($10)) {
     $11 = $$08; //@line 133059 "c/sqlite3.c"
     $12 = $11; //@line 133059 "c/sqlite3.c"
     $13 = HEAP32[$12>>2]|0; //@line 133059 "c/sqlite3.c"
     $14 = (($11) + 4)|0; //@line 133059 "c/sqlite3.c"
     $15 = $14; //@line 133059 "c/sqlite3.c"
     $16 = HEAP32[$15>>2]|0; //@line 133059 "c/sqlite3.c"
     $17 = $13 & $1; //@line 133059 "c/sqlite3.c"
     $18 = $16 & $2; //@line 133059 "c/sqlite3.c"
     $19 = ($17|0)==($1|0); //@line 133059 "c/sqlite3.c"
     $20 = ($18|0)==($2|0); //@line 133059 "c/sqlite3.c"
     $21 = $19 & $20; //@line 133059 "c/sqlite3.c"
     if ($21) {
      $$3 = $$08;
      break L1;
     }
    }
    $22 = ($9<<16>>16)>($3<<16>>16); //@line 133062 "c/sqlite3.c"
    if (!($22)) {
     $23 = $$08; //@line 133062 "c/sqlite3.c"
     $24 = $23; //@line 133062 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 133062 "c/sqlite3.c"
     $26 = (($23) + 4)|0; //@line 133062 "c/sqlite3.c"
     $27 = $26; //@line 133062 "c/sqlite3.c"
     $28 = HEAP32[$27>>2]|0; //@line 133062 "c/sqlite3.c"
     $29 = $25 & $1; //@line 133062 "c/sqlite3.c"
     $30 = $28 & $2; //@line 133062 "c/sqlite3.c"
     $31 = ($29|0)==($25|0); //@line 133062 "c/sqlite3.c"
     $32 = ($30|0)==($28|0); //@line 133062 "c/sqlite3.c"
     $33 = $31 & $32; //@line 133062 "c/sqlite3.c"
     if ($33) {
      label = 15;
      break;
     }
    }
    $34 = (($$0407) + -1)<<16>>16; //@line 133058 "c/sqlite3.c"
    $35 = ((($$08)) + 16|0); //@line 133058 "c/sqlite3.c"
    $36 = ($34<<16>>16)==(0); //@line 133058 "c/sqlite3.c"
    if ($36) {
     break;
    } else {
     $$0407 = $34;$$08 = $35;
    }
   }
   if ((label|0) == 15) {
    return;
   }
   $37 = ($5&65535)<(3); //@line 133066 "c/sqlite3.c"
   if ($37) {
    label = 9;
   } else {
    $42 = ((($0)) + 16|0);
    $43 = HEAP16[$42>>1]|0;
    $wide$trip$count = $5&65535;
    $$15 = $6;$47 = $43;$indvars$iv = 1;
    while(1) {
     $44 = (((((($0)) + 8|0) + ($indvars$iv<<4)|0)) + 8|0); //@line 133072 "c/sqlite3.c"
     $45 = HEAP16[$44>>1]|0; //@line 133072 "c/sqlite3.c"
     $46 = ($47<<16>>16)>($45<<16>>16); //@line 133072 "c/sqlite3.c"
     $48 = (((($0)) + 8|0) + ($indvars$iv<<4)|0); //@line 133072 "c/sqlite3.c"
     $spec$select = $46 ? $48 : $$15; //@line 133072 "c/sqlite3.c"
     $indvars$iv$next = (($indvars$iv) + 1)|0; //@line 133071 "c/sqlite3.c"
     $49 = ((($spec$select)) + 8|0);
     $50 = HEAP16[$49>>1]|0;
     $exitcond = ($indvars$iv$next|0)==($wide$trip$count|0); //@line 133071 "c/sqlite3.c"
     if ($exitcond) {
      break;
     } else {
      $$15 = $spec$select;$47 = $50;$indvars$iv = $indvars$iv$next;
     }
    }
    $51 = ($50<<16>>16)>($3<<16>>16); //@line 133074 "c/sqlite3.c"
    if ($51) {
     $$3 = $spec$select;
    } else {
     return;
    }
   }
  }
 } while(0);
 if ((label|0) == 9) {
  $38 = $5&65535; //@line 133066 "c/sqlite3.c"
  $39 = (($5) + 1)<<16>>16; //@line 133067 "c/sqlite3.c"
  HEAP16[$0>>1] = $39; //@line 133067 "c/sqlite3.c"
  $40 = (((($0)) + 8|0) + ($38<<4)|0); //@line 133067 "c/sqlite3.c"
  $41 = (((((($0)) + 8|0) + ($38<<4)|0)) + 10|0); //@line 133068 "c/sqlite3.c"
  HEAP16[$41>>1] = $4; //@line 133068 "c/sqlite3.c"
  $$3 = $40;
 }
 $52 = $$3; //@line 133077 "c/sqlite3.c"
 $53 = $52; //@line 133077 "c/sqlite3.c"
 HEAP32[$53>>2] = $1; //@line 133077 "c/sqlite3.c"
 $54 = (($52) + 4)|0; //@line 133077 "c/sqlite3.c"
 $55 = $54; //@line 133077 "c/sqlite3.c"
 HEAP32[$55>>2] = $2; //@line 133077 "c/sqlite3.c"
 $56 = ((($$3)) + 8|0); //@line 133078 "c/sqlite3.c"
 HEAP16[$56>>1] = $3; //@line 133078 "c/sqlite3.c"
 $57 = ((($$3)) + 10|0); //@line 133079 "c/sqlite3.c"
 $58 = HEAP16[$57>>1]|0; //@line 133079 "c/sqlite3.c"
 $59 = ($58<<16>>16)>($4<<16>>16); //@line 133079 "c/sqlite3.c"
 if (!($59)) {
  return;
 }
 HEAP16[$57>>1] = $4; //@line 133079 "c/sqlite3.c"
 return;
}
function _whereLoopInsert($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$055 = 0, $$05657 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 134996 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 134997 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 134997 "c/sqlite3.c"
 $5 = ((($0)) + 16|0); //@line 135003 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 135003 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 135003 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($1)) + 40|0); //@line 135004 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 135004 "c/sqlite3.c"
  $10 = ($9<<16>>16)==(0); //@line 135004 "c/sqlite3.c"
  if ($10) {
   $$0 = 0;
   return ($$0|0); //@line 135091 "c/sqlite3.c"
  }
  $11 = $1; //@line 135009 "c/sqlite3.c"
  $12 = $11; //@line 135009 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 135009 "c/sqlite3.c"
  $14 = (($11) + 4)|0; //@line 135009 "c/sqlite3.c"
  $15 = $14; //@line 135009 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 135009 "c/sqlite3.c"
  $17 = ((($1)) + 20|0); //@line 135009 "c/sqlite3.c"
  $18 = HEAP16[$17>>1]|0; //@line 135009 "c/sqlite3.c"
  $19 = ((($1)) + 22|0); //@line 135010 "c/sqlite3.c"
  $20 = HEAP16[$19>>1]|0; //@line 135010 "c/sqlite3.c"
  _whereOrInsert($6,$13,$16,$18,$20); //@line 135009 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 135091 "c/sqlite3.c"
 }
 $21 = ((($2)) + 60|0); //@line 135023 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 135023 "c/sqlite3.c"
 _whereLoopAdjustCost($22,$1); //@line 135023 "c/sqlite3.c"
 $23 = (_whereLoopFindLesser($21,$1)|0); //@line 135024 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 135026 "c/sqlite3.c"
 if ($24) {
  $$0 = 0;
  return ($$0|0); //@line 135091 "c/sqlite3.c"
 }
 $25 = HEAP32[$23>>2]|0; //@line 135037 "c/sqlite3.c"
 $26 = ($25|0)==(0|0); //@line 135056 "c/sqlite3.c"
 L11: do {
  if ($26) {
   $27 = (_sqlite3DbMallocRawNN($4,72,0)|0); //@line 135058 "c/sqlite3.c"
   HEAP32[$23>>2] = $27; //@line 135058 "c/sqlite3.c"
   $28 = ($27|0)==(0|0); //@line 135059 "c/sqlite3.c"
   if ($28) {
    $$0 = 7;
    return ($$0|0); //@line 135091 "c/sqlite3.c"
   } else {
    _whereLoopInit($27); //@line 135060 "c/sqlite3.c"
    $29 = ((($27)) + 52|0); //@line 135061 "c/sqlite3.c"
    HEAP32[$29>>2] = 0; //@line 135061 "c/sqlite3.c"
    $$055 = $27;
    break;
   }
  } else {
   $30 = ((($25)) + 52|0); //@line 135066 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 135068 "c/sqlite3.c"
   $32 = ($31|0)==(0|0); //@line 135068 "c/sqlite3.c"
   if ($32) {
    $$055 = $25;
   } else {
    $$05657 = $30;
    while(1) {
     $33 = (_whereLoopFindLesser($$05657,$1)|0); //@line 135069 "c/sqlite3.c"
     $34 = ($33|0)==(0|0); //@line 135070 "c/sqlite3.c"
     if ($34) {
      $$055 = $25;
      break L11;
     }
     $35 = HEAP32[$33>>2]|0; //@line 135071 "c/sqlite3.c"
     $36 = ($35|0)==(0|0); //@line 135072 "c/sqlite3.c"
     if ($36) {
      $$055 = $25;
      break L11;
     }
     $37 = ((($35)) + 52|0); //@line 135073 "c/sqlite3.c"
     $38 = HEAP32[$37>>2]|0; //@line 135073 "c/sqlite3.c"
     HEAP32[$33>>2] = $38; //@line 135073 "c/sqlite3.c"
     _whereLoopDelete($4,$35); //@line 135080 "c/sqlite3.c"
     $39 = HEAP32[$33>>2]|0; //@line 135068 "c/sqlite3.c"
     $40 = ($39|0)==(0|0); //@line 135068 "c/sqlite3.c"
     if ($40) {
      $$055 = $25;
      break;
     } else {
      $$05657 = $33;
     }
    }
   }
  }
 } while(0);
 $41 = (_whereLoopXfer($4,$$055,$1)|0); //@line 135083 "c/sqlite3.c"
 $42 = ((($$055)) + 36|0); //@line 135084 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 135084 "c/sqlite3.c"
 $44 = $43 & 1024; //@line 135084 "c/sqlite3.c"
 $45 = ($44|0)==(0); //@line 135084 "c/sqlite3.c"
 if (!($45)) {
  $$0 = $41;
  return ($$0|0); //@line 135091 "c/sqlite3.c"
 }
 $46 = ((($$055)) + 32|0); //@line 135085 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 135085 "c/sqlite3.c"
 $48 = ($47|0)==(0|0); //@line 135086 "c/sqlite3.c"
 if ($48) {
  $$0 = $41;
  return ($$0|0); //@line 135091 "c/sqlite3.c"
 }
 $49 = ((($47)) + 44|0); //@line 135086 "c/sqlite3.c"
 $50 = HEAP32[$49>>2]|0; //@line 135086 "c/sqlite3.c"
 $51 = ($50|0)==(0); //@line 135086 "c/sqlite3.c"
 if (!($51)) {
  $$0 = $41;
  return ($$0|0); //@line 135091 "c/sqlite3.c"
 }
 HEAP32[$46>>2] = 0; //@line 135087 "c/sqlite3.c"
 $$0 = $41;
 return ($$0|0); //@line 135091 "c/sqlite3.c"
}
function _whereLoopAdjustCost($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 36|0); //@line 134870 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 134870 "c/sqlite3.c"
 $4 = $3 & 512; //@line 134870 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 134870 "c/sqlite3.c"
 $6 = ($0|0)==(0|0); //@line 134871 "c/sqlite3.c"
 $or$cond = $5 | $6; //@line 134870 "c/sqlite3.c"
 if ($or$cond) {
  return; //@line 134890 "c/sqlite3.c"
 }
 $7 = ((($1)) + 16|0);
 $8 = ((($1)) + 20|0);
 $9 = ((($1)) + 22|0);
 $10 = ((($1)) + 20|0);
 $11 = ((($1)) + 22|0);
 $$018 = $0;
 while(1) {
  $12 = ((($$018)) + 16|0); //@line 134872 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 134872 "c/sqlite3.c"
  $14 = HEAP8[$7>>0]|0; //@line 134872 "c/sqlite3.c"
  $15 = ($13<<24>>24)==($14<<24>>24); //@line 134872 "c/sqlite3.c"
  do {
   if ($15) {
    $16 = ((($$018)) + 36|0); //@line 134873 "c/sqlite3.c"
    $17 = HEAP32[$16>>2]|0; //@line 134873 "c/sqlite3.c"
    $18 = $17 & 512; //@line 134873 "c/sqlite3.c"
    $19 = ($18|0)==(0); //@line 134873 "c/sqlite3.c"
    if (!($19)) {
     $20 = (_whereLoopCheaperProperSubset($$018,$1)|0); //@line 134874 "c/sqlite3.c"
     $21 = ($20|0)==(0); //@line 134874 "c/sqlite3.c"
     if (!($21)) {
      $22 = ((($$018)) + 20|0); //@line 134879 "c/sqlite3.c"
      $23 = HEAP16[$22>>1]|0; //@line 134879 "c/sqlite3.c"
      HEAP16[$8>>1] = $23; //@line 134879 "c/sqlite3.c"
      $24 = ((($$018)) + 22|0); //@line 134880 "c/sqlite3.c"
      $25 = HEAP16[$24>>1]|0; //@line 134880 "c/sqlite3.c"
      $26 = $25&65535; //@line 134880 "c/sqlite3.c"
      $27 = (($26) + 65535)|0; //@line 134880 "c/sqlite3.c"
      $28 = $27&65535; //@line 134880 "c/sqlite3.c"
      HEAP16[$9>>1] = $28; //@line 134880 "c/sqlite3.c"
      break;
     }
     $29 = (_whereLoopCheaperProperSubset($1,$$018)|0); //@line 134881 "c/sqlite3.c"
     $30 = ($29|0)==(0); //@line 134881 "c/sqlite3.c"
     if (!($30)) {
      $31 = ((($$018)) + 20|0); //@line 134886 "c/sqlite3.c"
      $32 = HEAP16[$31>>1]|0; //@line 134886 "c/sqlite3.c"
      HEAP16[$10>>1] = $32; //@line 134886 "c/sqlite3.c"
      $33 = ((($$018)) + 22|0); //@line 134887 "c/sqlite3.c"
      $34 = HEAP16[$33>>1]|0; //@line 134887 "c/sqlite3.c"
      $35 = $34&65535; //@line 134887 "c/sqlite3.c"
      $36 = (($35) + 1)|0; //@line 134887 "c/sqlite3.c"
      $37 = $36&65535; //@line 134887 "c/sqlite3.c"
      HEAP16[$11>>1] = $37; //@line 134887 "c/sqlite3.c"
     }
    }
   }
  } while(0);
  $38 = ((($$018)) + 52|0); //@line 134871 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 134871 "c/sqlite3.c"
  $40 = ($39|0)==(0|0); //@line 134871 "c/sqlite3.c"
  if ($40) {
   break;
  } else {
   $$018 = $39;
  }
 }
 return; //@line 134890 "c/sqlite3.c"
}
function _whereLoopFindLesser($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$034 = 0, $$03538 = 0, $$037 = 0, $$039 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$037 = HEAP32[$0>>2]|0;
 $2 = ($$037|0)==(0|0); //@line 134911 "c/sqlite3.c"
 if ($2) {
  $$034 = $0;
  return ($$034|0); //@line 134968 "c/sqlite3.c"
 }
 $3 = ((($1)) + 16|0);
 $4 = HEAP8[$3>>0]|0;
 $5 = ((($1)) + 17|0);
 $6 = ((($1)) + 42|0);
 $7 = ((($1)) + 18|0);
 $8 = ((($1)) + 36|0);
 $9 = ((($1)) + 20|0);
 $10 = ((($1)) + 20|0);
 $11 = ((($1)) + 22|0);
 $12 = ((($1)) + 22|0);
 $$03538 = $0;$$039 = $$037;
 while(1) {
  $13 = ((($$039)) + 16|0); //@line 134912 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 134912 "c/sqlite3.c"
  $15 = ($14<<24>>24)==($4<<24>>24); //@line 134912 "c/sqlite3.c"
  if ($15) {
   $16 = ((($$039)) + 17|0); //@line 134912 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 134912 "c/sqlite3.c"
   $18 = HEAP8[$5>>0]|0; //@line 134912 "c/sqlite3.c"
   $19 = ($17<<24>>24)==($18<<24>>24); //@line 134912 "c/sqlite3.c"
   if ($19) {
    $20 = ((($$039)) + 36|0); //@line 134932 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 134932 "c/sqlite3.c"
    $22 = $21 & 16384; //@line 134932 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 134932 "c/sqlite3.c"
    if (!($23)) {
     $24 = HEAP16[$6>>1]|0; //@line 134933 "c/sqlite3.c"
     $25 = ($24<<16>>16)==(0); //@line 134933 "c/sqlite3.c"
     if ($25) {
      $26 = HEAP32[$8>>2]|0; //@line 134934 "c/sqlite3.c"
      $27 = $26 & 513; //@line 134935 "c/sqlite3.c"
      $28 = ($27|0)==(513); //@line 134935 "c/sqlite3.c"
      if ($28) {
       $29 = $$039; //@line 134936 "c/sqlite3.c"
       $30 = $29; //@line 134936 "c/sqlite3.c"
       $31 = HEAP32[$30>>2]|0; //@line 134936 "c/sqlite3.c"
       $32 = (($29) + 4)|0; //@line 134936 "c/sqlite3.c"
       $33 = $32; //@line 134936 "c/sqlite3.c"
       $34 = HEAP32[$33>>2]|0; //@line 134936 "c/sqlite3.c"
       $35 = $1; //@line 134936 "c/sqlite3.c"
       $36 = $35; //@line 134936 "c/sqlite3.c"
       $37 = HEAP32[$36>>2]|0; //@line 134936 "c/sqlite3.c"
       $38 = (($35) + 4)|0; //@line 134936 "c/sqlite3.c"
       $39 = $38; //@line 134936 "c/sqlite3.c"
       $40 = HEAP32[$39>>2]|0; //@line 134936 "c/sqlite3.c"
       $41 = $37 & $31; //@line 134936 "c/sqlite3.c"
       $42 = $40 & $34; //@line 134936 "c/sqlite3.c"
       $43 = ($41|0)==($37|0); //@line 134936 "c/sqlite3.c"
       $44 = ($42|0)==($40|0); //@line 134936 "c/sqlite3.c"
       $45 = $43 & $44; //@line 134936 "c/sqlite3.c"
       if ($45) {
        $$034 = $$03538;
        label = 17;
        break;
       }
      }
     }
    }
    $46 = $$039; //@line 134946 "c/sqlite3.c"
    $47 = $46; //@line 134946 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 134946 "c/sqlite3.c"
    $49 = (($46) + 4)|0; //@line 134946 "c/sqlite3.c"
    $50 = $49; //@line 134946 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 134946 "c/sqlite3.c"
    $52 = $1; //@line 134946 "c/sqlite3.c"
    $53 = $52; //@line 134946 "c/sqlite3.c"
    $54 = HEAP32[$53>>2]|0; //@line 134946 "c/sqlite3.c"
    $55 = (($52) + 4)|0; //@line 134946 "c/sqlite3.c"
    $56 = $55; //@line 134946 "c/sqlite3.c"
    $57 = HEAP32[$56>>2]|0; //@line 134946 "c/sqlite3.c"
    $58 = $54 & $48; //@line 134946 "c/sqlite3.c"
    $59 = $57 & $51; //@line 134946 "c/sqlite3.c"
    $60 = ($58|0)==($48|0); //@line 134946 "c/sqlite3.c"
    $61 = ($59|0)==($51|0); //@line 134946 "c/sqlite3.c"
    $62 = $60 & $61; //@line 134946 "c/sqlite3.c"
    if ($62) {
     $63 = ((($$039)) + 18|0); //@line 134947 "c/sqlite3.c"
     $64 = HEAP16[$63>>1]|0; //@line 134947 "c/sqlite3.c"
     $65 = HEAP16[$7>>1]|0; //@line 134947 "c/sqlite3.c"
     $66 = ($64<<16>>16)>($65<<16>>16); //@line 134947 "c/sqlite3.c"
     if (!($66)) {
      $67 = ((($$039)) + 20|0); //@line 134948 "c/sqlite3.c"
      $68 = HEAP16[$67>>1]|0; //@line 134948 "c/sqlite3.c"
      $69 = HEAP16[$9>>1]|0; //@line 134948 "c/sqlite3.c"
      $70 = ($68<<16>>16)>($69<<16>>16); //@line 134948 "c/sqlite3.c"
      if (!($70)) {
       $71 = ((($$039)) + 22|0); //@line 134949 "c/sqlite3.c"
       $72 = HEAP16[$71>>1]|0; //@line 134949 "c/sqlite3.c"
       $73 = HEAP16[$11>>1]|0; //@line 134949 "c/sqlite3.c"
       $74 = ($72<<16>>16)>($73<<16>>16); //@line 134949 "c/sqlite3.c"
       if (!($74)) {
        $$034 = 0;
        label = 17;
        break;
       }
      }
     }
    }
    $75 = ($58|0)==($54|0); //@line 134959 "c/sqlite3.c"
    $76 = ($59|0)==($57|0); //@line 134959 "c/sqlite3.c"
    $77 = $75 & $76; //@line 134959 "c/sqlite3.c"
    if ($77) {
     $78 = ((($$039)) + 20|0); //@line 134960 "c/sqlite3.c"
     $79 = HEAP16[$78>>1]|0; //@line 134960 "c/sqlite3.c"
     $80 = HEAP16[$10>>1]|0; //@line 134960 "c/sqlite3.c"
     $81 = ($79<<16>>16)<($80<<16>>16); //@line 134960 "c/sqlite3.c"
     if (!($81)) {
      $82 = ((($$039)) + 22|0); //@line 134961 "c/sqlite3.c"
      $83 = HEAP16[$82>>1]|0; //@line 134961 "c/sqlite3.c"
      $84 = HEAP16[$12>>1]|0; //@line 134961 "c/sqlite3.c"
      $85 = ($83<<16>>16)<($84<<16>>16); //@line 134961 "c/sqlite3.c"
      if (!($85)) {
       $$034 = $$03538;
       label = 17;
       break;
      }
     }
    }
   }
  }
  $86 = ((($$039)) + 52|0); //@line 134911 "c/sqlite3.c"
  $$0 = HEAP32[$86>>2]|0;
  $87 = ($$0|0)==(0|0); //@line 134911 "c/sqlite3.c"
  if ($87) {
   $$034 = $86;
   label = 17;
   break;
  } else {
   $$03538 = $86;$$039 = $$0;
  }
 }
 if ((label|0) == 17) {
  return ($$034|0); //@line 134968 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereLoopXfer($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 _whereLoopClearUnion($0,$1); //@line 134766 "c/sqlite3.c"
 $3 = ((($2)) + 40|0); //@line 134767 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 134767 "c/sqlite3.c"
 $5 = $4&65535; //@line 134767 "c/sqlite3.c"
 $6 = (_whereLoopResize($0,$1,$5)|0); //@line 134767 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 134767 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($1)) + 24|0); //@line 134768 "c/sqlite3.c"
  ;HEAP32[$8>>2]=0|0;HEAP32[$8+4>>2]=0|0;HEAP32[$8+8>>2]=0|0; //@line 134768 "c/sqlite3.c"
  $$0 = 7;
  return ($$0|0); //@line 134779 "c/sqlite3.c"
 }
 dest=$1; src=$2; stop=dest+44|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 134771 "c/sqlite3.c"
 $9 = ((($1)) + 48|0); //@line 134772 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 134772 "c/sqlite3.c"
 $11 = ((($2)) + 48|0); //@line 134772 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 134772 "c/sqlite3.c"
 $13 = ((($1)) + 40|0); //@line 134772 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 134772 "c/sqlite3.c"
 $15 = $14&65535; //@line 134772 "c/sqlite3.c"
 $16 = $15 << 2; //@line 134772 "c/sqlite3.c"
 _memcpy(($10|0),($12|0),($16|0))|0; //@line 134772 "c/sqlite3.c"
 $17 = ((($2)) + 36|0); //@line 134773 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 134773 "c/sqlite3.c"
 $19 = $18 & 1024; //@line 134773 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 134773 "c/sqlite3.c"
 if (!($20)) {
  $21 = ((($2)) + 28|0); //@line 134774 "c/sqlite3.c"
  HEAP8[$21>>0] = 0; //@line 134774 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 134779 "c/sqlite3.c"
 }
 $22 = $18 & 16384; //@line 134775 "c/sqlite3.c"
 $23 = ($22|0)==(0); //@line 134775 "c/sqlite3.c"
 if ($23) {
  $$0 = 0;
  return ($$0|0); //@line 134779 "c/sqlite3.c"
 }
 $24 = ((($2)) + 32|0); //@line 134776 "c/sqlite3.c"
 HEAP32[$24>>2] = 0; //@line 134776 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 134779 "c/sqlite3.c"
}
function _whereLoopCheaperProperSubset($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02935 = 0, $$02935$in = 0, $$030 = 0, $$032 = 0, $$032$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 40|0); //@line 134833 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 134833 "c/sqlite3.c"
 $4 = $3&65535; //@line 134833 "c/sqlite3.c"
 $5 = ((($0)) + 42|0); //@line 134833 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 134833 "c/sqlite3.c"
 $7 = $6&65535; //@line 134833 "c/sqlite3.c"
 $8 = (($4) - ($7))|0; //@line 134833 "c/sqlite3.c"
 $9 = ((($1)) + 40|0); //@line 134833 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 134833 "c/sqlite3.c"
 $11 = $10&65535; //@line 134833 "c/sqlite3.c"
 $12 = ((($1)) + 42|0); //@line 134833 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 134833 "c/sqlite3.c"
 $14 = $13&65535; //@line 134833 "c/sqlite3.c"
 $15 = (($11) - ($14))|0; //@line 134833 "c/sqlite3.c"
 $16 = ($8|0)>=($15|0); //@line 134833 "c/sqlite3.c"
 $17 = ($13&65535)>($6&65535); //@line 134836 "c/sqlite3.c"
 $or$cond = $17 | $16; //@line 134833 "c/sqlite3.c"
 if ($or$cond) {
  $$030 = 0;
  return ($$030|0); //@line 134853 "c/sqlite3.c"
 }
 $18 = ((($0)) + 20|0); //@line 134837 "c/sqlite3.c"
 $19 = HEAP16[$18>>1]|0; //@line 134837 "c/sqlite3.c"
 $20 = ((($1)) + 20|0); //@line 134837 "c/sqlite3.c"
 $21 = HEAP16[$20>>1]|0; //@line 134837 "c/sqlite3.c"
 $22 = ($19<<16>>16)<($21<<16>>16); //@line 134837 "c/sqlite3.c"
 if (!($22)) {
  $23 = ($19<<16>>16)>($21<<16>>16); //@line 134838 "c/sqlite3.c"
  if ($23) {
   $$030 = 0;
   return ($$030|0); //@line 134853 "c/sqlite3.c"
  }
  $24 = ((($0)) + 22|0); //@line 134839 "c/sqlite3.c"
  $25 = HEAP16[$24>>1]|0; //@line 134839 "c/sqlite3.c"
  $26 = ((($1)) + 22|0); //@line 134839 "c/sqlite3.c"
  $27 = HEAP16[$26>>1]|0; //@line 134839 "c/sqlite3.c"
  $28 = ($25<<16>>16)>($27<<16>>16); //@line 134839 "c/sqlite3.c"
  if ($28) {
   $$030 = 0;
   return ($$030|0); //@line 134853 "c/sqlite3.c"
  }
 }
 $29 = ($3<<16>>16)==(0); //@line 134841 "c/sqlite3.c"
 L11: do {
  if (!($29)) {
   $30 = ((($0)) + 48|0);
   $31 = HEAP32[$30>>2]|0;
   $32 = ($10<<16>>16)==(0);
   $33 = ((($1)) + 48|0);
   $$02935$in = $4;
   L13: while(1) {
    $$02935 = (($$02935$in) + -1)|0;
    $34 = (($31) + ($$02935<<2)|0); //@line 134842 "c/sqlite3.c"
    $35 = HEAP32[$34>>2]|0; //@line 134842 "c/sqlite3.c"
    $36 = ($35|0)==(0|0); //@line 134842 "c/sqlite3.c"
    L15: do {
     if (!($36)) {
      if ($32) {
       $$030 = 0;
       label = 16;
       break L13;
      }
      $37 = HEAP32[$33>>2]|0;
      $$032$in = $11;
      while(1) {
       $$032 = (($$032$in) + -1)|0;
       $39 = (($37) + ($$032<<2)|0); //@line 134844 "c/sqlite3.c"
       $40 = HEAP32[$39>>2]|0; //@line 134844 "c/sqlite3.c"
       $41 = ($40|0)==($35|0); //@line 134844 "c/sqlite3.c"
       if ($41) {
        break L15;
       }
       $38 = ($$032$in|0)>(1); //@line 134843 "c/sqlite3.c"
       if ($38) {
        $$032$in = $$032;
       } else {
        $$030 = 0;
        label = 16;
        break L13;
       }
      }
     }
    } while(0);
    $42 = ($$02935$in|0)>(1); //@line 134841 "c/sqlite3.c"
    if ($42) {
     $$02935$in = $$02935;
    } else {
     break L11;
    }
   }
   if ((label|0) == 16) {
    return ($$030|0); //@line 134853 "c/sqlite3.c"
   }
  }
 } while(0);
 $43 = ((($0)) + 36|0); //@line 134848 "c/sqlite3.c"
 $44 = HEAP32[$43>>2]|0; //@line 134848 "c/sqlite3.c"
 $45 = $44 & 64; //@line 134848 "c/sqlite3.c"
 $46 = ($45|0)==(0); //@line 134848 "c/sqlite3.c"
 if (!($46)) {
  $47 = ((($1)) + 36|0); //@line 134849 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 134849 "c/sqlite3.c"
  $49 = $48 & 64; //@line 134849 "c/sqlite3.c"
  $50 = ($49|0)==(0); //@line 134849 "c/sqlite3.c"
  if ($50) {
   $$030 = 0;
   return ($$030|0); //@line 134853 "c/sqlite3.c"
  }
 }
 $$030 = 1;
 return ($$030|0); //@line 134853 "c/sqlite3.c"
}
function _whereUsablePartialIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03036 = 0, $$03135 = 0, $$032$lcssa = 0, $$03239 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$1>>2]|0; //@line 135636 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 135636 "c/sqlite3.c"
 $5 = HEAP8[$2>>0]|0; //@line 135637 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(44); //@line 135637 "c/sqlite3.c"
 L1: do {
  if ($6) {
   $$03239 = $2;
   while(1) {
    $7 = ((($$03239)) + 12|0); //@line 135638 "c/sqlite3.c"
    $8 = HEAP32[$7>>2]|0; //@line 135638 "c/sqlite3.c"
    $9 = (_whereUsablePartialIndex($0,$1,$8)|0); //@line 135638 "c/sqlite3.c"
    $10 = ($9|0)==(0); //@line 135638 "c/sqlite3.c"
    if ($10) {
     $$2 = 0;
     break;
    }
    $11 = ((($$03239)) + 16|0); //@line 135639 "c/sqlite3.c"
    $12 = HEAP32[$11>>2]|0; //@line 135639 "c/sqlite3.c"
    $13 = HEAP8[$12>>0]|0; //@line 135637 "c/sqlite3.c"
    $14 = ($13<<24>>24)==(44); //@line 135637 "c/sqlite3.c"
    if ($14) {
     $$03239 = $12;
    } else {
     $$032$lcssa = $12;
     break L1;
    }
   }
   return ($$2|0); //@line 135651 "c/sqlite3.c"
  } else {
   $$032$lcssa = $2;
  }
 } while(0);
 $15 = HEAP32[$4>>2]|0; //@line 135641 "c/sqlite3.c"
 $16 = ((($15)) + 28|0); //@line 135641 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 135641 "c/sqlite3.c"
 $18 = $17 & 8388608; //@line 135641 "c/sqlite3.c"
 $19 = ($18|0)==(0); //@line 135641 "c/sqlite3.c"
 $spec$select = $19 ? $4 : 0; //@line 135641 "c/sqlite3.c"
 $20 = ((($1)) + 12|0); //@line 135642 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 135642 "c/sqlite3.c"
 $22 = ($21|0)>(0); //@line 135642 "c/sqlite3.c"
 if (!($22)) {
  $$2 = 0;
  return ($$2|0); //@line 135651 "c/sqlite3.c"
 }
 $23 = ((($1)) + 20|0); //@line 135642 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 135642 "c/sqlite3.c"
 $$03036 = $24;$$03135 = 0;
 while(1) {
  $25 = HEAP32[$$03036>>2]|0; //@line 135643 "c/sqlite3.c"
  $26 = ((($25)) + 4|0); //@line 135644 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 135644 "c/sqlite3.c"
  $28 = $27 & 1; //@line 135644 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 135644 "c/sqlite3.c"
  if ($29) {
   label = 9;
  } else {
   $30 = ((($25)) + 36|0); //@line 135644 "c/sqlite3.c"
   $31 = HEAP16[$30>>1]|0; //@line 135644 "c/sqlite3.c"
   $32 = $31 << 16 >> 16; //@line 135644 "c/sqlite3.c"
   $33 = ($32|0)==($0|0); //@line 135644 "c/sqlite3.c"
   if ($33) {
    label = 9;
   }
  }
  if ((label|0) == 9) {
   label = 0;
   $34 = (_sqlite3ExprImpliesExpr($spec$select,$25,$$032$lcssa,$0)|0); //@line 135645 "c/sqlite3.c"
   $35 = ($34|0)==(0); //@line 135645 "c/sqlite3.c"
   if (!($35)) {
    $$2 = 1;
    label = 11;
    break;
   }
  }
  $36 = (($$03135) + 1)|0; //@line 135642 "c/sqlite3.c"
  $37 = ((($$03036)) + 48|0); //@line 135642 "c/sqlite3.c"
  $38 = HEAP32[$20>>2]|0; //@line 135642 "c/sqlite3.c"
  $39 = ($36|0)<($38|0); //@line 135642 "c/sqlite3.c"
  if ($39) {
   $$03036 = $37;$$03135 = $36;
  } else {
   $$2 = 0;
   label = 11;
   break;
  }
 }
 if ((label|0) == 11) {
  return ($$2|0); //@line 135651 "c/sqlite3.c"
 }
 return (0)|0;
}
function _indexMightHelpWithOrderBy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03847 = 0, $$04049 = 0, $$13946 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 55|0); //@line 135591 "c/sqlite3.c"
 $4 = HEAPU8[$3>>0]|(HEAPU8[$3+1>>0]<<8); //@line 135591 "c/sqlite3.c"
 $5 = $4 & 4; //@line 135591 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 135591 "c/sqlite3.c"
 if (!($6)) {
  $$2 = 0;
  return ($$2|0); //@line 135610 "c/sqlite3.c"
 }
 $7 = HEAP32[$0>>2]|0; //@line 135592 "c/sqlite3.c"
 $8 = ((($7)) + 8|0); //@line 135592 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 135592 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 135592 "c/sqlite3.c"
 if ($10) {
  $$2 = 0;
  return ($$2|0); //@line 135610 "c/sqlite3.c"
 }
 $11 = HEAP32[$9>>2]|0; //@line 135593 "c/sqlite3.c"
 $12 = ($11|0)>(0); //@line 135593 "c/sqlite3.c"
 if (!($12)) {
  $$2 = 0;
  return ($$2|0); //@line 135610 "c/sqlite3.c"
 }
 $13 = ((($1)) + 40|0);
 $14 = ((($1)) + 50|0);
 $15 = ((($1)) + 50|0);
 $16 = ((($1)) + 4|0);
 $17 = ((($1)) + 4|0);
 $$04049 = 0;
 L10: while(1) {
  $18 = (((($9)) + 4|0) + (($$04049*20)|0)|0); //@line 135594 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 135594 "c/sqlite3.c"
  $20 = (_sqlite3ExprSkipCollate($19)|0); //@line 135594 "c/sqlite3.c"
  $21 = HEAP8[$20>>0]|0; //@line 135595 "c/sqlite3.c"
  $22 = ($21<<24>>24)==(-111); //@line 135595 "c/sqlite3.c"
  if ($22) {
   $23 = ((($20)) + 28|0); //@line 135595 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 135595 "c/sqlite3.c"
   $25 = ($24|0)==($2|0); //@line 135595 "c/sqlite3.c"
   if ($25) {
    $26 = ((($20)) + 32|0); //@line 135596 "c/sqlite3.c"
    $27 = HEAP16[$26>>1]|0; //@line 135596 "c/sqlite3.c"
    $28 = ($27<<16>>16)<(0); //@line 135596 "c/sqlite3.c"
    if ($28) {
     $$2 = 1;
     label = 19;
     break;
    }
    $29 = HEAP16[$15>>1]|0; //@line 135597 "c/sqlite3.c"
    $30 = ($29<<16>>16)==(0); //@line 135597 "c/sqlite3.c"
    if (!($30)) {
     $31 = HEAP32[$17>>2]|0;
     $$03847 = 0;
     while(1) {
      $36 = (($31) + ($$03847<<1)|0); //@line 135598 "c/sqlite3.c"
      $37 = HEAP16[$36>>1]|0; //@line 135598 "c/sqlite3.c"
      $38 = ($27<<16>>16)==($37<<16>>16); //@line 135598 "c/sqlite3.c"
      $35 = (($$03847) + 1)|0; //@line 135597 "c/sqlite3.c"
      if ($38) {
       $$2 = 1;
       label = 19;
       break L10;
      }
      $32 = HEAP16[$15>>1]|0; //@line 135597 "c/sqlite3.c"
      $33 = $32&65535; //@line 135597 "c/sqlite3.c"
      $34 = ($35>>>0)<($33>>>0); //@line 135597 "c/sqlite3.c"
      if ($34) {
       $$03847 = $35;
      } else {
       break;
      }
     }
    }
   } else {
    label = 12;
   }
  } else {
   label = 12;
  }
  if ((label|0) == 12) {
   label = 0;
   $39 = HEAP32[$13>>2]|0; //@line 135600 "c/sqlite3.c"
   $40 = ($39|0)==(0|0); //@line 135600 "c/sqlite3.c"
   if (!($40)) {
    $41 = HEAP16[$14>>1]|0; //@line 135601 "c/sqlite3.c"
    $42 = ($41<<16>>16)==(0); //@line 135601 "c/sqlite3.c"
    if (!($42)) {
     $$13946 = 0;
     while(1) {
      $43 = HEAP32[$16>>2]|0; //@line 135602 "c/sqlite3.c"
      $44 = (($43) + ($$13946<<1)|0); //@line 135602 "c/sqlite3.c"
      $45 = HEAP16[$44>>1]|0; //@line 135602 "c/sqlite3.c"
      $46 = ($45<<16>>16)==(-2); //@line 135602 "c/sqlite3.c"
      if ($46) {
       $47 = (((($39)) + 4|0) + (($$13946*20)|0)|0); //@line 135603 "c/sqlite3.c"
       $48 = HEAP32[$47>>2]|0; //@line 135603 "c/sqlite3.c"
       $49 = (_sqlite3ExprCompareSkip($20,$48,$2)|0); //@line 135603 "c/sqlite3.c"
       $50 = ($49|0)==(0); //@line 135603 "c/sqlite3.c"
       if ($50) {
        $$2 = 1;
        label = 19;
        break L10;
       }
      }
      $51 = (($$13946) + 1)|0; //@line 135601 "c/sqlite3.c"
      $52 = HEAP16[$14>>1]|0; //@line 135601 "c/sqlite3.c"
      $53 = $52&65535; //@line 135601 "c/sqlite3.c"
      $54 = ($51>>>0)<($53>>>0); //@line 135601 "c/sqlite3.c"
      if ($54) {
       $$13946 = $51;
      } else {
       break;
      }
     }
    }
   }
  }
  $55 = (($$04049) + 1)|0; //@line 135593 "c/sqlite3.c"
  $56 = HEAP32[$9>>2]|0; //@line 135593 "c/sqlite3.c"
  $57 = ($55|0)<($56|0); //@line 135593 "c/sqlite3.c"
  if ($57) {
   $$04049 = $55;
  } else {
   $$2 = 0;
   label = 19;
   break;
  }
 }
 if ((label|0) == 19) {
  return ($$2|0); //@line 135610 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereLoopOutputAdjust($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$054$lcssa = 0, $$05461 = 0, $$05559 = 0, $$05559$in = 0, $$05660 = 0, $$063 = 0, $$1 = 0, $$2 = 0, $$off = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $11 = 0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = $1; //@line 135128 "c/sqlite3.c"
 $5 = $4; //@line 135128 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 135128 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 135128 "c/sqlite3.c"
 $8 = $7; //@line 135128 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 135128 "c/sqlite3.c"
 $10 = ((($1)) + 8|0); //@line 135128 "c/sqlite3.c"
 $11 = $10; //@line 135128 "c/sqlite3.c"
 $12 = $11; //@line 135128 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 135128 "c/sqlite3.c"
 $14 = (($11) + 4)|0; //@line 135128 "c/sqlite3.c"
 $15 = $14; //@line 135128 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 135128 "c/sqlite3.c"
 $17 = $13 | $6; //@line 135128 "c/sqlite3.c"
 $18 = $16 | $9; //@line 135128 "c/sqlite3.c"
 $19 = $17 ^ -1; //@line 135128 "c/sqlite3.c"
 $20 = $18 ^ -1; //@line 135128 "c/sqlite3.c"
 $21 = ((($0)) + 12|0); //@line 135133 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 135133 "c/sqlite3.c"
 $23 = ((($0)) + 20|0); //@line 135133 "c/sqlite3.c"
 $24 = ($22|0)>(0); //@line 135133 "c/sqlite3.c"
 L1: do {
  if ($24) {
   $25 = HEAP32[$23>>2]|0; //@line 135133 "c/sqlite3.c"
   $26 = ((($1)) + 40|0);
   $27 = ((($1)) + 48|0);
   $28 = ((($1)) + 22|0);
   $29 = ((($1)) + 22|0);
   $$05461 = 0;$$05660 = $22;$$063 = $25;
   while(1) {
    $30 = ((($$063)) + 10|0); //@line 135134 "c/sqlite3.c"
    $31 = HEAP16[$30>>1]|0; //@line 135134 "c/sqlite3.c"
    $32 = $31 & 2; //@line 135134 "c/sqlite3.c"
    $33 = ($32<<16>>16)==(0); //@line 135134 "c/sqlite3.c"
    if (!($33)) {
     $$054$lcssa = $$05461;
     break L1;
    }
    $34 = ((($$063)) + 40|0); //@line 135135 "c/sqlite3.c"
    $35 = $34; //@line 135135 "c/sqlite3.c"
    $36 = $35; //@line 135135 "c/sqlite3.c"
    $37 = HEAP32[$36>>2]|0; //@line 135135 "c/sqlite3.c"
    $38 = (($35) + 4)|0; //@line 135135 "c/sqlite3.c"
    $39 = $38; //@line 135135 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 135135 "c/sqlite3.c"
    $41 = $10; //@line 135135 "c/sqlite3.c"
    $42 = $41; //@line 135135 "c/sqlite3.c"
    $43 = HEAP32[$42>>2]|0; //@line 135135 "c/sqlite3.c"
    $44 = (($41) + 4)|0; //@line 135135 "c/sqlite3.c"
    $45 = $44; //@line 135135 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 135135 "c/sqlite3.c"
    $47 = $43 & $37; //@line 135135 "c/sqlite3.c"
    $48 = $46 & $40; //@line 135135 "c/sqlite3.c"
    $49 = ($47|0)!=(0); //@line 135135 "c/sqlite3.c"
    $50 = ($48|0)!=(0); //@line 135135 "c/sqlite3.c"
    $51 = $49 | $50; //@line 135135 "c/sqlite3.c"
    $52 = $37 & $19; //@line 135136 "c/sqlite3.c"
    $53 = $40 & $20; //@line 135136 "c/sqlite3.c"
    $54 = ($52|0)==(0); //@line 135136 "c/sqlite3.c"
    $55 = ($53|0)==(0); //@line 135136 "c/sqlite3.c"
    $56 = $54 & $55; //@line 135136 "c/sqlite3.c"
    $or$cond = $56 & $51; //@line 135135 "c/sqlite3.c"
    L6: do {
     if ($or$cond) {
      $57 = HEAP16[$26>>1]|0; //@line 135137 "c/sqlite3.c"
      $58 = ($57<<16>>16)==(0); //@line 135137 "c/sqlite3.c"
      if (!($58)) {
       $59 = $57&65535; //@line 135137 "c/sqlite3.c"
       $60 = HEAP32[$27>>2]|0;
       $$05559$in = $59;
       while(1) {
        $$05559 = (($$05559$in) + -1)|0;
        $61 = (($60) + ($$05559<<2)|0); //@line 135138 "c/sqlite3.c"
        $62 = HEAP32[$61>>2]|0; //@line 135138 "c/sqlite3.c"
        $63 = ($62|0)==(0|0); //@line 135139 "c/sqlite3.c"
        if (!($63)) {
         $64 = ($62|0)==($$063|0); //@line 135140 "c/sqlite3.c"
         if ($64) {
          $$2 = $$05461;
          break L6;
         }
         $65 = ((($62)) + 16|0); //@line 135141 "c/sqlite3.c"
         $66 = HEAP32[$65>>2]|0; //@line 135141 "c/sqlite3.c"
         $67 = ($66|0)>(-1); //@line 135141 "c/sqlite3.c"
         if ($67) {
          $68 = HEAP32[$23>>2]|0; //@line 135141 "c/sqlite3.c"
          $69 = (($68) + (($66*48)|0)|0); //@line 135141 "c/sqlite3.c"
          $70 = ($69|0)==($$063|0); //@line 135141 "c/sqlite3.c"
          if ($70) {
           $$2 = $$05461;
           break L6;
          }
         }
        }
        $71 = ($$05559$in|0)>(1); //@line 135137 "c/sqlite3.c"
        if ($71) {
         $$05559$in = $$05559;
        } else {
         break;
        }
       }
      }
      $72 = ((($$063)) + 8|0); //@line 135144 "c/sqlite3.c"
      $73 = HEAP16[$72>>1]|0; //@line 135144 "c/sqlite3.c"
      $74 = ($73<<16>>16)<(1); //@line 135144 "c/sqlite3.c"
      if ($74) {
       $75 = $73&65535; //@line 135144 "c/sqlite3.c"
       $76 = HEAP16[$28>>1]|0; //@line 135147 "c/sqlite3.c"
       $77 = $76&65535; //@line 135147 "c/sqlite3.c"
       $78 = (($77) + ($75))|0; //@line 135147 "c/sqlite3.c"
       $79 = $78&65535; //@line 135147 "c/sqlite3.c"
       HEAP16[$28>>1] = $79; //@line 135147 "c/sqlite3.c"
       $$2 = $$05461;
       break;
      }
      $80 = HEAP16[$29>>1]|0; //@line 135151 "c/sqlite3.c"
      $81 = (($80) + -1)<<16>>16; //@line 135151 "c/sqlite3.c"
      HEAP16[$29>>1] = $81; //@line 135151 "c/sqlite3.c"
      $82 = ((($$063)) + 12|0); //@line 135152 "c/sqlite3.c"
      $83 = HEAP16[$82>>1]|0; //@line 135152 "c/sqlite3.c"
      $84 = $83 & 130; //@line 135152 "c/sqlite3.c"
      $85 = ($84<<16>>16)==(0); //@line 135152 "c/sqlite3.c"
      if ($85) {
       $$2 = $$05461;
      } else {
       $86 = HEAP32[$$063>>2]|0; //@line 135153 "c/sqlite3.c"
       $87 = ((($86)) + 16|0); //@line 135153 "c/sqlite3.c"
       $88 = HEAP32[$87>>2]|0; //@line 135153 "c/sqlite3.c"
       $89 = (_sqlite3ExprIsInteger($88,$3)|0); //@line 135155 "c/sqlite3.c"
       $90 = ($89|0)!=(0); //@line 135155 "c/sqlite3.c"
       $91 = HEAP32[$3>>2]|0; //@line 135155 "c/sqlite3.c"
       $$off = (($91) + 1)|0; //@line 135155 "c/sqlite3.c"
       $92 = ($$off>>>0)<(3); //@line 135155 "c/sqlite3.c"
       $93 = $90 & $92; //@line 135155 "c/sqlite3.c"
       $$ = $93 ? 10 : 20; //@line 135157 "c/sqlite3.c"
       HEAP32[$3>>2] = $$;
       $94 = $$05461 << 16 >> 16; //@line 135160 "c/sqlite3.c"
       $95 = ($$|0)>($94|0); //@line 135160 "c/sqlite3.c"
       $96 = $$&65535; //@line 135160 "c/sqlite3.c"
       $$1 = $95 ? $96 : $$05461; //@line 135160 "c/sqlite3.c"
       $$2 = $$1;
      }
     } else {
      $$2 = $$05461;
     }
    } while(0);
    $97 = (($$05660) + -1)|0; //@line 135133 "c/sqlite3.c"
    $98 = ((($$063)) + 48|0); //@line 135133 "c/sqlite3.c"
    $99 = ($$05660|0)>(1); //@line 135133 "c/sqlite3.c"
    if ($99) {
     $$05461 = $$2;$$05660 = $97;$$063 = $98;
    } else {
     $$054$lcssa = $$2;
     break;
    }
   }
  } else {
   $$054$lcssa = 0;
  }
 } while(0);
 $100 = ((($1)) + 22|0); //@line 135165 "c/sqlite3.c"
 $101 = HEAP16[$100>>1]|0; //@line 135165 "c/sqlite3.c"
 $102 = $101 << 16 >> 16; //@line 135165 "c/sqlite3.c"
 $103 = $2 << 16 >> 16; //@line 135165 "c/sqlite3.c"
 $104 = $$054$lcssa << 16 >> 16; //@line 135165 "c/sqlite3.c"
 $105 = (($103) - ($104))|0; //@line 135165 "c/sqlite3.c"
 $106 = ($105|0)<($102|0); //@line 135165 "c/sqlite3.c"
 if (!($106)) {
  STACKTOP = sp;return; //@line 135166 "c/sqlite3.c"
 }
 $107 = $105&65535; //@line 135165 "c/sqlite3.c"
 HEAP16[$100>>1] = $107; //@line 135165 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 135166 "c/sqlite3.c"
}
function _columnsInIndex($0) {
 $0 = $0|0;
 var $$01518 = 0, $$01518$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 52|0); //@line 135619 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 135619 "c/sqlite3.c"
 $3 = ($2<<16>>16)==(0); //@line 135619 "c/sqlite3.c"
 if ($3) {
  $20 = 0;$21 = 0;
  tempRet0 = ($20); //@line 135627 "c/sqlite3.c"
  return ($21|0); //@line 135627 "c/sqlite3.c"
 }
 $4 = $2&65535; //@line 135619 "c/sqlite3.c"
 $5 = ((($0)) + 4|0);
 $6 = HEAP32[$5>>2]|0;
 $$01518$in = $4;$16 = 0;$18 = 0;
 while(1) {
  $$01518 = (($$01518$in) + -1)|0;
  $7 = (($6) + ($$01518<<1)|0); //@line 135620 "c/sqlite3.c"
  $8 = HEAP16[$7>>1]|0; //@line 135620 "c/sqlite3.c"
  $9 = ($8&65535)<(63); //@line 135621 "c/sqlite3.c"
  $10 = $8 << 16 >> 16; //@line 135620 "c/sqlite3.c"
  $11 = (_bitshift64Shl(1,0,($10|0))|0); //@line 135624 "c/sqlite3.c"
  $12 = tempRet0; //@line 135624 "c/sqlite3.c"
  $13 = $9 ? $11 : 0; //@line 135621 "c/sqlite3.c"
  $14 = $9 ? $12 : 0; //@line 135621 "c/sqlite3.c"
  $15 = $13 | $16; //@line 135621 "c/sqlite3.c"
  $17 = $14 | $18; //@line 135621 "c/sqlite3.c"
  $19 = ($$01518$in|0)>(1); //@line 135619 "c/sqlite3.c"
  if ($19) {
   $$01518$in = $$01518;$16 = $15;$18 = $17;
  } else {
   $20 = $17;$21 = $15;
   break;
  }
 }
 tempRet0 = ($20); //@line 135627 "c/sqlite3.c"
 return ($21|0); //@line 135627 "c/sqlite3.c"
}
function _whereLoopAddBtreeIndex($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$ = 0, $$0 = 0, $$0288318 = 0, $$0290315 = 0, $$0293314 = 0, $$0297317 = 0, $$0300316 = 0, $$1 = 0, $$1292$ph = 0, $$1294 = 0, $$1298 = 0, $$1301 = 0, $$2 = 0, $$2299$ph = 0, $$2302$ph = 0, $$309 = 0, $$3296 = 0, $$sink = 0, $$sink327 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0;
 var $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0;
 var $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0;
 var $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0;
 var $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0;
 var $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0;
 var $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0;
 var $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0;
 var $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0;
 var $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0;
 var $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0;
 var $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0;
 var $355 = 0, $356 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0;
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0;
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0;
 var $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $or$cond308 = 0, $or$cond313 = 0, $sext = 0, $sext304 = 0, $spec$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $4 = sp;
 $5 = HEAP32[$0>>2]|0; //@line 135262 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 135263 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 135264 "c/sqlite3.c"
 $8 = ((($0)) + 12|0); //@line 135282 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 135282 "c/sqlite3.c"
 $10 = ((($7)) + 73|0); //@line 135283 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 135283 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 135283 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
 }
 $13 = ((($9)) + 36|0); //@line 135289 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 135289 "c/sqlite3.c"
 $15 = $14 & 32; //@line 135289 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 135289 "c/sqlite3.c"
 $$ = $16 ? 447 : 24;
 $17 = ((($2)) + 55|0); //@line 135295 "c/sqlite3.c"
 $18 = HEAPU8[$17>>0]|(HEAPU8[$17+1>>0]<<8); //@line 135295 "c/sqlite3.c"
 $19 = $18 & 4; //@line 135295 "c/sqlite3.c"
 $20 = ($19<<16>>16)==(0); //@line 135295 "c/sqlite3.c"
 $21 = $$ & 387; //@line 135295 "c/sqlite3.c"
 $$1 = $20 ? $$ : $21; //@line 135295 "c/sqlite3.c"
 $22 = ((($9)) + 24|0); //@line 135299 "c/sqlite3.c"
 $23 = HEAP16[$22>>1]|0; //@line 135299 "c/sqlite3.c"
 $24 = ((($9)) + 26|0); //@line 135300 "c/sqlite3.c"
 $25 = HEAP16[$24>>1]|0; //@line 135300 "c/sqlite3.c"
 $26 = ((($9)) + 28|0); //@line 135301 "c/sqlite3.c"
 $27 = HEAP16[$26>>1]|0; //@line 135301 "c/sqlite3.c"
 $28 = ((($9)) + 42|0); //@line 135302 "c/sqlite3.c"
 $29 = HEAP16[$28>>1]|0; //@line 135302 "c/sqlite3.c"
 $30 = ((($9)) + 40|0); //@line 135303 "c/sqlite3.c"
 $31 = HEAP16[$30>>1]|0; //@line 135303 "c/sqlite3.c"
 $32 = $9; //@line 135305 "c/sqlite3.c"
 $33 = $32; //@line 135305 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 135305 "c/sqlite3.c"
 $35 = (($32) + 4)|0; //@line 135305 "c/sqlite3.c"
 $36 = $35; //@line 135305 "c/sqlite3.c"
 $37 = HEAP32[$36>>2]|0; //@line 135305 "c/sqlite3.c"
 $38 = ((($9)) + 22|0); //@line 135306 "c/sqlite3.c"
 $39 = HEAP16[$38>>1]|0; //@line 135306 "c/sqlite3.c"
 $40 = ((($0)) + 4|0); //@line 135307 "c/sqlite3.c"
 $41 = HEAP32[$40>>2]|0; //@line 135307 "c/sqlite3.c"
 $42 = ((($1)) + 44|0); //@line 135307 "c/sqlite3.c"
 $43 = HEAP32[$42>>2]|0; //@line 135307 "c/sqlite3.c"
 $44 = $23&65535; //@line 135307 "c/sqlite3.c"
 $45 = (_whereScanInit($4,$41,$43,$44,$$1,$2)|0); //@line 135307 "c/sqlite3.c"
 $46 = ((($9)) + 18|0); //@line 135309 "c/sqlite3.c"
 HEAP16[$46>>1] = 0; //@line 135309 "c/sqlite3.c"
 $47 = ((($2)) + 8|0); //@line 135310 "c/sqlite3.c"
 $48 = HEAP32[$47>>2]|0; //@line 135310 "c/sqlite3.c"
 $49 = HEAP16[$48>>1]|0; //@line 135310 "c/sqlite3.c"
 $50 = (_estLog($49)|0); //@line 135311 "c/sqlite3.c"
 $51 = ($45|0)==(0|0); //@line 135312 "c/sqlite3.c"
 L4: do {
  if ($51) {
   $$2 = 0;
  } else {
   $52 = ((($9)) + 8|0);
   $53 = ((($1)) + 36|0);
   $54 = ((($2)) + 54|0);
   $55 = $31&65535;
   $56 = (($55) + 1)|0;
   $57 = ((($2)) + 50|0);
   $58 = ((($9)) + 48|0);
   $59 = ((($2)) + 4|0);
   $60 = ((($2)) + 48|0);
   $61 = ((($1)) + 16|0);
   $62 = ((($9)) + 20|0);
   $63 = ($3<<16>>16)==(0);
   $64 = ((($2)) + 4|0);
   $65 = $3 << 16 >> 16;
   $66 = ((($2)) + 50|0);
   $67 = ((($2)) + 52|0);
   $$sink = ((($0)) + 20|0);
   $$0288318 = $45;$$0297317 = 0;$$0300316 = 0;
   while(1) {
    $68 = ((($$0288318)) + 12|0); //@line 135313 "c/sqlite3.c"
    $69 = HEAP16[$68>>1]|0; //@line 135313 "c/sqlite3.c"
    $70 = $69&65535; //@line 135320 "c/sqlite3.c"
    $71 = ($69<<16>>16)==(256); //@line 135320 "c/sqlite3.c"
    if ($71) {
     $72 = (_indexColumnNotNull($2,$44)|0); //@line 135321 "c/sqlite3.c"
     $73 = ($72|0)==(0); //@line 135321 "c/sqlite3.c"
     if ($73) {
      label = 6;
     } else {
      $$1292$ph = 0;$$2299$ph = $$0297317;$$2302$ph = $$0300316;
     }
    } else {
     label = 6;
    }
    do {
     if ((label|0) == 6) {
      label = 0;
      $74 = ((($$0288318)) + 32|0); //@line 135325 "c/sqlite3.c"
      $75 = $74; //@line 135325 "c/sqlite3.c"
      $76 = $75; //@line 135325 "c/sqlite3.c"
      $77 = HEAP32[$76>>2]|0; //@line 135325 "c/sqlite3.c"
      $78 = (($75) + 4)|0; //@line 135325 "c/sqlite3.c"
      $79 = $78; //@line 135325 "c/sqlite3.c"
      $80 = HEAP32[$79>>2]|0; //@line 135325 "c/sqlite3.c"
      $81 = $52; //@line 135325 "c/sqlite3.c"
      $82 = $81; //@line 135325 "c/sqlite3.c"
      $83 = HEAP32[$82>>2]|0; //@line 135325 "c/sqlite3.c"
      $84 = (($81) + 4)|0; //@line 135325 "c/sqlite3.c"
      $85 = $84; //@line 135325 "c/sqlite3.c"
      $86 = HEAP32[$85>>2]|0; //@line 135325 "c/sqlite3.c"
      $87 = $83 & $77; //@line 135325 "c/sqlite3.c"
      $88 = $86 & $80; //@line 135325 "c/sqlite3.c"
      $89 = ($87|0)==(0); //@line 135325 "c/sqlite3.c"
      $90 = ($88|0)==(0); //@line 135325 "c/sqlite3.c"
      $91 = $89 & $90; //@line 135325 "c/sqlite3.c"
      if ($91) {
       $92 = ((($$0288318)) + 10|0); //@line 135329 "c/sqlite3.c"
       $93 = HEAP16[$92>>1]|0; //@line 135329 "c/sqlite3.c"
       $94 = $93 & 256; //@line 135329 "c/sqlite3.c"
       $95 = ($94<<16>>16)!=(0); //@line 135329 "c/sqlite3.c"
       $96 = ($69<<16>>16)==(16); //@line 135329 "c/sqlite3.c"
       $or$cond313 = $96 & $95; //@line 135329 "c/sqlite3.c"
       if ($or$cond313) {
        $$1292$ph = 0;$$2299$ph = $$0297317;$$2302$ph = $$0300316;
       } else {
        $97 = HEAP8[$53>>0]|0; //@line 135334 "c/sqlite3.c"
        $98 = $97 & 8; //@line 135334 "c/sqlite3.c"
        $99 = ($98<<24>>24)==(0); //@line 135334 "c/sqlite3.c"
        if (!($99)) {
         $100 = HEAP32[$$0288318>>2]|0; //@line 135335 "c/sqlite3.c"
         $101 = ((($100)) + 4|0); //@line 135335 "c/sqlite3.c"
         $102 = HEAP32[$101>>2]|0; //@line 135335 "c/sqlite3.c"
         $103 = $102 & 1; //@line 135335 "c/sqlite3.c"
         $104 = ($103|0)!=(0); //@line 135335 "c/sqlite3.c"
         $105 = $70 & 384; //@line 135336 "c/sqlite3.c"
         $106 = ($105|0)==(0); //@line 135336 "c/sqlite3.c"
         $or$cond = $106 | $104; //@line 135336 "c/sqlite3.c"
         if (!($or$cond)) {
          $$1292$ph = 0;$$2299$ph = $$0297317;$$2302$ph = $$0300316;
          break;
         }
        }
        $107 = HEAP8[$54>>0]|0; //@line 135343 "c/sqlite3.c"
        $108 = ($107<<24>>24)==(0); //@line 135343 "c/sqlite3.c"
        if ($108) {
         label = 12;
        } else {
         $109 = HEAP16[$57>>1]|0; //@line 135343 "c/sqlite3.c"
         $110 = $109&65535; //@line 135343 "c/sqlite3.c"
         $111 = (($110) + -1)|0; //@line 135343 "c/sqlite3.c"
         $112 = ($111|0)==($44|0); //@line 135343 "c/sqlite3.c"
         if ($112) {
          $$sink327 = 2;
         } else {
          label = 12;
         }
        }
        if ((label|0) == 12) {
         label = 0;
         $$sink327 = 1;
        }
        $113 = HEAP32[$$sink>>2]|0;
        $114 = $113 | $$sink327;
        HEAP32[$$sink>>2] = $114;
        HEAP32[$13>>2] = $14; //@line 135348 "c/sqlite3.c"
        HEAP16[$22>>1] = $23; //@line 135349 "c/sqlite3.c"
        HEAP16[$24>>1] = $25; //@line 135350 "c/sqlite3.c"
        HEAP16[$26>>1] = $27; //@line 135351 "c/sqlite3.c"
        HEAP16[$30>>1] = $31; //@line 135352 "c/sqlite3.c"
        $115 = (_whereLoopResize($7,$9,$56)|0); //@line 135353 "c/sqlite3.c"
        $116 = ($115|0)==(0); //@line 135353 "c/sqlite3.c"
        if (!($116)) {
         $$2 = 0;
         break L4;
        }
        $117 = HEAP32[$58>>2]|0; //@line 135354 "c/sqlite3.c"
        $118 = HEAP16[$30>>1]|0; //@line 135354 "c/sqlite3.c"
        $119 = (($118) + 1)<<16>>16; //@line 135354 "c/sqlite3.c"
        HEAP16[$30>>1] = $119; //@line 135354 "c/sqlite3.c"
        $120 = $118&65535; //@line 135354 "c/sqlite3.c"
        $121 = (($117) + ($120<<2)|0); //@line 135354 "c/sqlite3.c"
        HEAP32[$121>>2] = $$0288318; //@line 135354 "c/sqlite3.c"
        $122 = $74; //@line 135355 "c/sqlite3.c"
        $123 = $122; //@line 135355 "c/sqlite3.c"
        $124 = HEAP32[$123>>2]|0; //@line 135355 "c/sqlite3.c"
        $125 = (($122) + 4)|0; //@line 135355 "c/sqlite3.c"
        $126 = $125; //@line 135355 "c/sqlite3.c"
        $127 = HEAP32[$126>>2]|0; //@line 135355 "c/sqlite3.c"
        $128 = $124 | $34; //@line 135355 "c/sqlite3.c"
        $129 = $127 | $37; //@line 135355 "c/sqlite3.c"
        $130 = $52; //@line 135355 "c/sqlite3.c"
        $131 = $130; //@line 135355 "c/sqlite3.c"
        $132 = HEAP32[$131>>2]|0; //@line 135355 "c/sqlite3.c"
        $133 = (($130) + 4)|0; //@line 135355 "c/sqlite3.c"
        $134 = $133; //@line 135355 "c/sqlite3.c"
        $135 = HEAP32[$134>>2]|0; //@line 135355 "c/sqlite3.c"
        $136 = $132 ^ -1; //@line 135355 "c/sqlite3.c"
        $137 = $135 ^ -1; //@line 135355 "c/sqlite3.c"
        $138 = $128 & $136; //@line 135355 "c/sqlite3.c"
        $139 = $129 & $137; //@line 135355 "c/sqlite3.c"
        $140 = $9; //@line 135355 "c/sqlite3.c"
        $141 = $140; //@line 135355 "c/sqlite3.c"
        HEAP32[$141>>2] = $138; //@line 135355 "c/sqlite3.c"
        $142 = (($140) + 4)|0; //@line 135355 "c/sqlite3.c"
        $143 = $142; //@line 135355 "c/sqlite3.c"
        HEAP32[$143>>2] = $139; //@line 135355 "c/sqlite3.c"
        $144 = $70 & 1; //@line 135363 "c/sqlite3.c"
        $145 = ($144|0)==(0); //@line 135363 "c/sqlite3.c"
        do {
         if ($145) {
          $172 = $70 & 130; //@line 135385 "c/sqlite3.c"
          $173 = ($172|0)==(0); //@line 135385 "c/sqlite3.c"
          if (!($173)) {
           $174 = HEAP32[$59>>2]|0; //@line 135386 "c/sqlite3.c"
           $175 = (($174) + ($44<<1)|0); //@line 135386 "c/sqlite3.c"
           $176 = HEAP16[$175>>1]|0; //@line 135386 "c/sqlite3.c"
           $177 = HEAP32[$13>>2]|0; //@line 135387 "c/sqlite3.c"
           $178 = $177 | 1; //@line 135387 "c/sqlite3.c"
           HEAP32[$13>>2] = $178; //@line 135387 "c/sqlite3.c"
           $179 = ($176<<16>>16)==(-1); //@line 135389 "c/sqlite3.c"
           if (!($179)) {
            $180 = ($176<<16>>16)>(-1); //@line 135390 "c/sqlite3.c"
            $or$cond308 = $63 & $180; //@line 135390 "c/sqlite3.c"
            if (!($or$cond308)) {
             $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
             break;
            }
            $181 = HEAP16[$66>>1]|0; //@line 135390 "c/sqlite3.c"
            $182 = $181&65535; //@line 135390 "c/sqlite3.c"
            $183 = (($182) + -1)|0; //@line 135390 "c/sqlite3.c"
            $184 = ($183|0)==($44|0); //@line 135390 "c/sqlite3.c"
            if (!($184)) {
             $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
             break;
            }
            $185 = HEAPU8[$17>>0]|(HEAPU8[$17+1>>0]<<8); //@line 135392 "c/sqlite3.c"
            $186 = $185 & 8; //@line 135392 "c/sqlite3.c"
            $187 = ($186<<16>>16)==(0); //@line 135392 "c/sqlite3.c"
            if ($187) {
             $188 = $177 | 65537; //@line 135393 "c/sqlite3.c"
             HEAP32[$13>>2] = $188; //@line 135393 "c/sqlite3.c"
             $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
             break;
            }
           }
           $189 = $177 | 4097; //@line 135395 "c/sqlite3.c"
           HEAP32[$13>>2] = $189; //@line 135395 "c/sqlite3.c"
           $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
           break;
          }
          $190 = $70 & 256; //@line 135398 "c/sqlite3.c"
          $191 = ($190|0)==(0); //@line 135398 "c/sqlite3.c"
          if (!($191)) {
           $192 = HEAP32[$13>>2]|0; //@line 135399 "c/sqlite3.c"
           $193 = $192 | 8; //@line 135399 "c/sqlite3.c"
           HEAP32[$13>>2] = $193; //@line 135399 "c/sqlite3.c"
           $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
           break;
          }
          $194 = $70 & 36; //@line 135400 "c/sqlite3.c"
          $195 = ($194|0)==(0); //@line 135400 "c/sqlite3.c"
          $196 = HEAP32[$13>>2]|0;
          if ($195) {
           $217 = $196 | 18; //@line 135425 "c/sqlite3.c"
           HEAP32[$13>>2] = $217; //@line 135425 "c/sqlite3.c"
           $218 = HEAP32[$42>>2]|0; //@line 135427 "c/sqlite3.c"
           $219 = (_whereRangeVectorLen($6,$218,$2,$44,$$0288318)|0); //@line 135426 "c/sqlite3.c"
           $220 = $219&65535; //@line 135426 "c/sqlite3.c"
           HEAP16[$26>>1] = $220; //@line 135426 "c/sqlite3.c"
           $221 = HEAP32[$13>>2]|0; //@line 135430 "c/sqlite3.c"
           $222 = $221 & 32; //@line 135430 "c/sqlite3.c"
           $223 = ($222|0)==(0); //@line 135430 "c/sqlite3.c"
           if ($223) {
            $$1298 = $$0288318;$$1301 = 0;$$3296 = 0;
            break;
           }
           $224 = HEAP32[$58>>2]|0; //@line 135431 "c/sqlite3.c"
           $225 = HEAP16[$30>>1]|0; //@line 135431 "c/sqlite3.c"
           $226 = $225&65535; //@line 135431 "c/sqlite3.c"
           $227 = (($226) + -2)|0; //@line 135431 "c/sqlite3.c"
           $228 = (($224) + ($227<<2)|0); //@line 135431 "c/sqlite3.c"
           $229 = HEAP32[$228>>2]|0; //@line 135431 "c/sqlite3.c"
           $$1298 = $$0288318;$$1301 = $229;$$3296 = 0;
           break;
          }
          $197 = $196 | 34; //@line 135403 "c/sqlite3.c"
          HEAP32[$13>>2] = $197; //@line 135403 "c/sqlite3.c"
          $198 = HEAP32[$42>>2]|0; //@line 135405 "c/sqlite3.c"
          $199 = (_whereRangeVectorLen($6,$198,$2,$44,$$0288318)|0); //@line 135404 "c/sqlite3.c"
          $200 = $199&65535; //@line 135404 "c/sqlite3.c"
          HEAP16[$24>>1] = $200; //@line 135404 "c/sqlite3.c"
          $201 = HEAP16[$92>>1]|0; //@line 135409 "c/sqlite3.c"
          $202 = $201 & 256; //@line 135409 "c/sqlite3.c"
          $203 = ($202<<16>>16)==(0); //@line 135409 "c/sqlite3.c"
          if ($203) {
           $$1298 = 0;$$1301 = $$0288318;$$3296 = 0;
          } else {
           $204 = ((($$0288318)) + 48|0); //@line 135412 "c/sqlite3.c"
           $205 = HEAP16[$30>>1]|0; //@line 135416 "c/sqlite3.c"
           $206 = $205&65535; //@line 135416 "c/sqlite3.c"
           $207 = (($206) + 1)|0; //@line 135416 "c/sqlite3.c"
           $208 = (_whereLoopResize($7,$9,$207)|0); //@line 135416 "c/sqlite3.c"
           $209 = ($208|0)==(0); //@line 135416 "c/sqlite3.c"
           if (!($209)) {
            $$2 = 0;
            break L4;
           }
           $210 = HEAP32[$58>>2]|0; //@line 135417 "c/sqlite3.c"
           $211 = HEAP16[$30>>1]|0; //@line 135417 "c/sqlite3.c"
           $212 = (($211) + 1)<<16>>16; //@line 135417 "c/sqlite3.c"
           HEAP16[$30>>1] = $212; //@line 135417 "c/sqlite3.c"
           $213 = $211&65535; //@line 135417 "c/sqlite3.c"
           $214 = (($210) + ($213<<2)|0); //@line 135417 "c/sqlite3.c"
           HEAP32[$214>>2] = $204; //@line 135417 "c/sqlite3.c"
           $215 = HEAP32[$13>>2]|0; //@line 135418 "c/sqlite3.c"
           $216 = $215 | 16; //@line 135418 "c/sqlite3.c"
           HEAP32[$13>>2] = $216; //@line 135418 "c/sqlite3.c"
           HEAP16[$26>>1] = 1; //@line 135419 "c/sqlite3.c"
           $$1298 = $204;$$1301 = $$0288318;$$3296 = 0;
          }
         } else {
          $146 = HEAP32[$$0288318>>2]|0; //@line 135364 "c/sqlite3.c"
          $147 = HEAP32[$13>>2]|0; //@line 135365 "c/sqlite3.c"
          $148 = $147 | 4; //@line 135365 "c/sqlite3.c"
          HEAP32[$13>>2] = $148; //@line 135365 "c/sqlite3.c"
          $149 = ((($146)) + 4|0); //@line 135366 "c/sqlite3.c"
          $150 = HEAP32[$149>>2]|0; //@line 135366 "c/sqlite3.c"
          $151 = $150 & 2048; //@line 135366 "c/sqlite3.c"
          $152 = ($151|0)==(0); //@line 135366 "c/sqlite3.c"
          if ($152) {
           $163 = ((($146)) + 20|0); //@line 135379 "c/sqlite3.c"
           $164 = HEAP32[$163>>2]|0; //@line 135379 "c/sqlite3.c"
           $165 = ($164|0)==(0|0); //@line 135379 "c/sqlite3.c"
           if ($165) {
            $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
            break;
           }
           $166 = HEAP32[$164>>2]|0; //@line 135379 "c/sqlite3.c"
           $167 = ($166|0)==(0); //@line 135379 "c/sqlite3.c"
           if ($167) {
            $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 0;
            break;
           }
           $168 = ($166|0)<(0); //@line 135381 "c/sqlite3.c"
           $169 = $168 << 31 >> 31; //@line 135381 "c/sqlite3.c"
           $170 = (_sqlite3LogEst($166,$169)|0); //@line 135381 "c/sqlite3.c"
           $171 = $170 << 16 >> 16; //@line 135381 "c/sqlite3.c"
           $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = $171;
           break;
          }
          $153 = $119&65535; //@line 135376 "c/sqlite3.c"
          $154 = (($153) + -1)|0; //@line 135376 "c/sqlite3.c"
          $155 = ($119&65535)>(1); //@line 135376 "c/sqlite3.c"
          if ($155) {
           $156 = HEAP32[$58>>2]|0;
           $$0290315 = 0;$$0293314 = 46;
           while(1) {
            $157 = (($156) + ($$0290315<<2)|0); //@line 135377 "c/sqlite3.c"
            $158 = HEAP32[$157>>2]|0; //@line 135377 "c/sqlite3.c"
            $159 = ($158|0)==(0|0); //@line 135377 "c/sqlite3.c"
            if ($159) {
             $$1294 = $$0293314;
            } else {
             $160 = HEAP32[$158>>2]|0; //@line 135377 "c/sqlite3.c"
             $161 = ($160|0)==($146|0); //@line 135377 "c/sqlite3.c"
             $spec$select = $161 ? 0 : $$0293314; //@line 135377 "c/sqlite3.c"
             $$1294 = $spec$select;
            }
            $162 = (($$0290315) + 1)|0; //@line 135376 "c/sqlite3.c"
            $exitcond = ($162|0)==($154|0); //@line 135376 "c/sqlite3.c"
            if ($exitcond) {
             $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = $$1294;
             break;
            } else {
             $$0290315 = $162;$$0293314 = $$1294;
            }
           }
          } else {
           $$1298 = $$0297317;$$1301 = $$0300316;$$3296 = 46;
          }
         }
        } while(0);
        $230 = HEAP32[$13>>2]|0; //@line 135440 "c/sqlite3.c"
        $231 = $230 & 2; //@line 135440 "c/sqlite3.c"
        $232 = ($231|0)==(0); //@line 135440 "c/sqlite3.c"
        do {
         if ($232) {
          $233 = HEAP16[$22>>1]|0; //@line 135445 "c/sqlite3.c"
          $234 = (($233) + 1)<<16>>16; //@line 135445 "c/sqlite3.c"
          HEAP16[$22>>1] = $234; //@line 135445 "c/sqlite3.c"
          $235 = $234&65535; //@line 135445 "c/sqlite3.c"
          $236 = ((($$0288318)) + 8|0); //@line 135449 "c/sqlite3.c"
          $237 = HEAP16[$236>>1]|0; //@line 135449 "c/sqlite3.c"
          $238 = $237&65535; //@line 135449 "c/sqlite3.c"
          $239 = ($237<<16>>16)<(1); //@line 135449 "c/sqlite3.c"
          if ($239) {
           $240 = HEAP32[$64>>2]|0; //@line 135449 "c/sqlite3.c"
           $241 = (($240) + ($44<<1)|0); //@line 135449 "c/sqlite3.c"
           $242 = HEAP16[$241>>1]|0; //@line 135449 "c/sqlite3.c"
           $243 = ($242<<16>>16)>(-1); //@line 135449 "c/sqlite3.c"
           if ($243) {
            $244 = HEAP16[$38>>1]|0; //@line 135452 "c/sqlite3.c"
            $245 = $244&65535; //@line 135452 "c/sqlite3.c"
            $246 = (($238) - ($$3296))|0; //@line 135452 "c/sqlite3.c"
            $247 = (($246) + ($245))|0; //@line 135453 "c/sqlite3.c"
            $248 = $247&65535; //@line 135453 "c/sqlite3.c"
            HEAP16[$38>>1] = $248; //@line 135453 "c/sqlite3.c"
            break;
           }
          }
          $249 = HEAP32[$47>>2]|0; //@line 135482 "c/sqlite3.c"
          $250 = (($249) + ($235<<1)|0); //@line 135482 "c/sqlite3.c"
          $251 = HEAP16[$250>>1]|0; //@line 135482 "c/sqlite3.c"
          $252 = $251&65535; //@line 135482 "c/sqlite3.c"
          $253 = (($235) + -1)|0; //@line 135482 "c/sqlite3.c"
          $254 = (($249) + ($253<<1)|0); //@line 135482 "c/sqlite3.c"
          $255 = HEAP16[$254>>1]|0; //@line 135482 "c/sqlite3.c"
          $256 = $255&65535; //@line 135482 "c/sqlite3.c"
          $257 = (($252) - ($256))|0; //@line 135482 "c/sqlite3.c"
          $258 = HEAP16[$38>>1]|0; //@line 135482 "c/sqlite3.c"
          $259 = $258&65535; //@line 135482 "c/sqlite3.c"
          $260 = (($257) + ($259))|0; //@line 135482 "c/sqlite3.c"
          $261 = $260&65535; //@line 135482 "c/sqlite3.c"
          HEAP16[$38>>1] = $261; //@line 135482 "c/sqlite3.c"
          $262 = $70 & 256; //@line 135483 "c/sqlite3.c"
          $263 = ($262|0)==(0); //@line 135483 "c/sqlite3.c"
          if (!($263)) {
           $264 = (($260) + 10)|0; //@line 135487 "c/sqlite3.c"
           $265 = $264&65535; //@line 135487 "c/sqlite3.c"
           HEAP16[$38>>1] = $265; //@line 135487 "c/sqlite3.c"
          }
         } else {
          _whereRangeScanEst($$1301,$$1298,$9); //@line 135443 "c/sqlite3.c"
         }
        } while(0);
        $266 = HEAP16[$38>>1]|0; //@line 135497 "c/sqlite3.c"
        $267 = $266&65535; //@line 135497 "c/sqlite3.c"
        $268 = (($267) + 1)|0; //@line 135497 "c/sqlite3.c"
        $269 = HEAP16[$60>>1]|0; //@line 135497 "c/sqlite3.c"
        $270 = $269 << 16 >> 16; //@line 135497 "c/sqlite3.c"
        $271 = ($270*15)|0; //@line 135497 "c/sqlite3.c"
        $272 = HEAP32[$61>>2]|0; //@line 135497 "c/sqlite3.c"
        $273 = ((($272)) + 46|0); //@line 135497 "c/sqlite3.c"
        $274 = HEAP16[$273>>1]|0; //@line 135497 "c/sqlite3.c"
        $275 = $274 << 16 >> 16; //@line 135497 "c/sqlite3.c"
        $276 = (($271|0) / ($275|0))&-1; //@line 135497 "c/sqlite3.c"
        $277 = (($268) + ($276))|0; //@line 135497 "c/sqlite3.c"
        $278 = $277&65535; //@line 135497 "c/sqlite3.c"
        $279 = (_sqlite3LogEstAdd($50,$278)|0); //@line 135498 "c/sqlite3.c"
        HEAP16[$62>>1] = $279; //@line 135498 "c/sqlite3.c"
        $280 = HEAP32[$13>>2]|0; //@line 135499 "c/sqlite3.c"
        $281 = $280 & 320; //@line 135499 "c/sqlite3.c"
        $282 = ($281|0)==(0); //@line 135499 "c/sqlite3.c"
        if ($282) {
         $283 = (($267) + 16)|0; //@line 135500 "c/sqlite3.c"
         $284 = $283&65535; //@line 135500 "c/sqlite3.c"
         $285 = (_sqlite3LogEstAdd($279,$284)|0); //@line 135500 "c/sqlite3.c"
         HEAP16[$62>>1] = $285; //@line 135500 "c/sqlite3.c"
        }
        $286 = (($$3296) + ($65))|0; //@line 135505 "c/sqlite3.c"
        $287 = HEAP16[$62>>1]|0; //@line 135505 "c/sqlite3.c"
        $288 = $287&65535; //@line 135505 "c/sqlite3.c"
        $289 = (($286) + ($288))|0; //@line 135505 "c/sqlite3.c"
        $290 = $289&65535; //@line 135505 "c/sqlite3.c"
        HEAP16[$62>>1] = $290; //@line 135505 "c/sqlite3.c"
        $291 = (($286) + ($267))|0; //@line 135506 "c/sqlite3.c"
        $292 = $291&65535; //@line 135506 "c/sqlite3.c"
        HEAP16[$38>>1] = $292; //@line 135506 "c/sqlite3.c"
        $293 = HEAP32[$40>>2]|0; //@line 135507 "c/sqlite3.c"
        _whereLoopOutputAdjust($293,$9,$49); //@line 135507 "c/sqlite3.c"
        $294 = (_whereLoopInsert($0,$9)|0); //@line 135508 "c/sqlite3.c"
        $295 = HEAP32[$13>>2]|0; //@line 135510 "c/sqlite3.c"
        $296 = $295 & 2; //@line 135510 "c/sqlite3.c"
        $297 = ($296|0)==(0); //@line 135510 "c/sqlite3.c"
        $$309 = $297 ? $266 : $39;
        HEAP16[$38>>1] = $$309;
        $298 = $295 & 16; //@line 135516 "c/sqlite3.c"
        $299 = ($298|0)==(0); //@line 135516 "c/sqlite3.c"
        if ($299) {
         $300 = HEAP16[$22>>1]|0; //@line 135517 "c/sqlite3.c"
         $301 = HEAP16[$67>>1]|0; //@line 135517 "c/sqlite3.c"
         $302 = ($300&65535)<($301&65535); //@line 135517 "c/sqlite3.c"
         if ($302) {
          $303 = $286&65535; //@line 135519 "c/sqlite3.c"
          (_whereLoopAddBtreeIndex($0,$1,$2,$303)|0); //@line 135519 "c/sqlite3.c"
         }
        }
        HEAP16[$38>>1] = $39; //@line 135521 "c/sqlite3.c"
        $$1292$ph = $294;$$2299$ph = $$1298;$$2302$ph = $$1301;
       }
      } else {
       $$1292$ph = 0;$$2299$ph = $$0297317;$$2302$ph = $$0300316;
      }
     }
    } while(0);
    $304 = (_whereScanNext($4)|0); //@line 135312 "c/sqlite3.c"
    $305 = ($$1292$ph|0)==(0); //@line 135312 "c/sqlite3.c"
    $306 = ($304|0)!=(0|0); //@line 135312 "c/sqlite3.c"
    $307 = $305 & $306; //@line 135312 "c/sqlite3.c"
    if ($307) {
     $$0288318 = $304;$$0297317 = $$2299$ph;$$0300316 = $$2302$ph;
    } else {
     $$2 = $$1292$ph;
     break;
    }
   }
  }
 } while(0);
 $308 = $9; //@line 135526 "c/sqlite3.c"
 $309 = $308; //@line 135526 "c/sqlite3.c"
 HEAP32[$309>>2] = $34; //@line 135526 "c/sqlite3.c"
 $310 = (($308) + 4)|0; //@line 135526 "c/sqlite3.c"
 $311 = $310; //@line 135526 "c/sqlite3.c"
 HEAP32[$311>>2] = $37; //@line 135526 "c/sqlite3.c"
 HEAP16[$22>>1] = $23; //@line 135527 "c/sqlite3.c"
 HEAP16[$24>>1] = $25; //@line 135528 "c/sqlite3.c"
 HEAP16[$26>>1] = $27; //@line 135529 "c/sqlite3.c"
 HEAP16[$28>>1] = $29; //@line 135530 "c/sqlite3.c"
 HEAP32[$13>>2] = $14; //@line 135531 "c/sqlite3.c"
 HEAP16[$38>>1] = $39; //@line 135532 "c/sqlite3.c"
 HEAP16[$30>>1] = $31; //@line 135533 "c/sqlite3.c"
 $312 = ($23<<16>>16)==($29<<16>>16); //@line 135546 "c/sqlite3.c"
 if (!($312)) {
  $$0 = $$2;
  STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
 }
 $313 = (($44) + 1)|0; //@line 135547 "c/sqlite3.c"
 $314 = ((($2)) + 50|0); //@line 135547 "c/sqlite3.c"
 $315 = HEAP16[$314>>1]|0; //@line 135547 "c/sqlite3.c"
 $316 = $315&65535; //@line 135547 "c/sqlite3.c"
 $317 = ($313>>>0)<($316>>>0); //@line 135547 "c/sqlite3.c"
 if (!($317)) {
  $$0 = $$2;
  STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
 }
 $318 = HEAPU8[$17>>0]|(HEAPU8[$17+1>>0]<<8); //@line 135548 "c/sqlite3.c"
 $319 = $318 & 64; //@line 135548 "c/sqlite3.c"
 $320 = ($319<<16>>16)==(0); //@line 135548 "c/sqlite3.c"
 if (!($320)) {
  $$0 = $$2;
  STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
 }
 $321 = HEAP32[$47>>2]|0; //@line 135549 "c/sqlite3.c"
 $322 = (($321) + ($313<<1)|0); //@line 135549 "c/sqlite3.c"
 $323 = HEAP16[$322>>1]|0; //@line 135549 "c/sqlite3.c"
 $324 = ($323<<16>>16)>(41); //@line 135549 "c/sqlite3.c"
 if (!($324)) {
  $$0 = $$2;
  STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
 }
 $325 = $31&65535; //@line 135550 "c/sqlite3.c"
 $326 = (($325) + 1)|0; //@line 135550 "c/sqlite3.c"
 $327 = (_whereLoopResize($7,$9,$326)|0); //@line 135550 "c/sqlite3.c"
 $328 = ($327|0)==(0); //@line 135550 "c/sqlite3.c"
 if (!($328)) {
  $$0 = $327;
  STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
 }
 $329 = HEAP16[$22>>1]|0; //@line 135553 "c/sqlite3.c"
 $330 = (($329) + 1)<<16>>16; //@line 135553 "c/sqlite3.c"
 HEAP16[$22>>1] = $330; //@line 135553 "c/sqlite3.c"
 $331 = HEAP16[$28>>1]|0; //@line 135554 "c/sqlite3.c"
 $332 = (($331) + 1)<<16>>16; //@line 135554 "c/sqlite3.c"
 HEAP16[$28>>1] = $332; //@line 135554 "c/sqlite3.c"
 $333 = ((($9)) + 48|0); //@line 135555 "c/sqlite3.c"
 $334 = HEAP32[$333>>2]|0; //@line 135555 "c/sqlite3.c"
 $335 = HEAP16[$30>>1]|0; //@line 135555 "c/sqlite3.c"
 $336 = (($335) + 1)<<16>>16; //@line 135555 "c/sqlite3.c"
 HEAP16[$30>>1] = $336; //@line 135555 "c/sqlite3.c"
 $337 = $335&65535; //@line 135555 "c/sqlite3.c"
 $338 = (($334) + ($337<<2)|0); //@line 135555 "c/sqlite3.c"
 HEAP32[$338>>2] = 0; //@line 135555 "c/sqlite3.c"
 $339 = HEAP32[$13>>2]|0; //@line 135556 "c/sqlite3.c"
 $340 = $339 | 32768; //@line 135556 "c/sqlite3.c"
 HEAP32[$13>>2] = $340; //@line 135556 "c/sqlite3.c"
 $341 = HEAP32[$47>>2]|0; //@line 135557 "c/sqlite3.c"
 $342 = (($341) + ($44<<1)|0); //@line 135557 "c/sqlite3.c"
 $343 = HEAP16[$342>>1]|0; //@line 135557 "c/sqlite3.c"
 $344 = $343&65535; //@line 135557 "c/sqlite3.c"
 $345 = (($341) + ($313<<1)|0); //@line 135557 "c/sqlite3.c"
 $346 = HEAP16[$345>>1]|0; //@line 135557 "c/sqlite3.c"
 $347 = $346&65535; //@line 135557 "c/sqlite3.c"
 $348 = (($344) - ($347))|0; //@line 135557 "c/sqlite3.c"
 $sext = $348 << 16; //@line 135558 "c/sqlite3.c"
 $349 = HEAP16[$38>>1]|0; //@line 135558 "c/sqlite3.c"
 $350 = $349&65535; //@line 135558 "c/sqlite3.c"
 $351 = (($350) - ($348))|0; //@line 135558 "c/sqlite3.c"
 $352 = $351&65535; //@line 135558 "c/sqlite3.c"
 HEAP16[$38>>1] = $352; //@line 135558 "c/sqlite3.c"
 $sext304 = (($sext) + 327680)|0; //@line 135562 "c/sqlite3.c"
 $353 = $sext304 >>> 16; //@line 135562 "c/sqlite3.c"
 $354 = $3&65535; //@line 135562 "c/sqlite3.c"
 $355 = (($353) + ($354))|0; //@line 135562 "c/sqlite3.c"
 $356 = $355&65535; //@line 135562 "c/sqlite3.c"
 (_whereLoopAddBtreeIndex($0,$1,$2,$356)|0); //@line 135562 "c/sqlite3.c"
 HEAP16[$38>>1] = $39; //@line 135563 "c/sqlite3.c"
 HEAP16[$22>>1] = $23; //@line 135564 "c/sqlite3.c"
 HEAP16[$28>>1] = $29; //@line 135565 "c/sqlite3.c"
 HEAP32[$13>>2] = $14; //@line 135566 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 135572 "c/sqlite3.c"
}
function _indexColumnNotNull($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 133346 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 133346 "c/sqlite3.c"
 $4 = (($3) + ($1<<1)|0); //@line 133346 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 133346 "c/sqlite3.c"
 $6 = ($5<<16>>16)>(-1); //@line 133347 "c/sqlite3.c"
 if ($6) {
  $7 = $5 << 16 >> 16; //@line 133346 "c/sqlite3.c"
  $8 = ((($0)) + 12|0); //@line 133348 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 133348 "c/sqlite3.c"
  $10 = ((($9)) + 4|0); //@line 133348 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 133348 "c/sqlite3.c"
  $12 = (((($11) + ($7<<4)|0)) + 12|0); //@line 133348 "c/sqlite3.c"
  $13 = HEAP8[$12>>0]|0; //@line 133348 "c/sqlite3.c"
  $14 = $13&255; //@line 133348 "c/sqlite3.c"
  $$0 = $14;
  return ($$0|0); //@line 133356 "c/sqlite3.c"
 } else {
  $15 = ($5<<16>>16)==(-1); //@line 133349 "c/sqlite3.c"
  $$ = $15&1; //@line 133350 "c/sqlite3.c"
  $$0 = $$;
  return ($$0|0); //@line 133356 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereRangeVectorLen($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$ = 0, $$053 = 0, $$053$in = 0, $$054$lcssa = 0, $$05461 = 0, $$pn = 0, $$pn$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = HEAP32[$4>>2]|0; //@line 135192 "c/sqlite3.c"
 $6 = ((($5)) + 12|0); //@line 135192 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 135192 "c/sqlite3.c"
 $8 = (_sqlite3ExprVectorSize($7)|0); //@line 135192 "c/sqlite3.c"
 $9 = ((($2)) + 52|0); //@line 135195 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 135195 "c/sqlite3.c"
 $11 = $10&65535; //@line 135195 "c/sqlite3.c"
 $12 = (($11) - ($3))|0; //@line 135195 "c/sqlite3.c"
 $13 = ($8|0)<($12|0); //@line 135195 "c/sqlite3.c"
 $$ = $13 ? $8 : $12; //@line 135195 "c/sqlite3.c"
 $14 = ((($2)) + 28|0); //@line 135217 "c/sqlite3.c"
 $15 = ($$|0)>(1); //@line 135196 "c/sqlite3.c"
 if (!($15)) {
  $$054$lcssa = 1;
  return ($$054$lcssa|0); //@line 135231 "c/sqlite3.c"
 }
 $16 = ((($2)) + 4|0);
 $17 = ((($2)) + 12|0);
 $18 = ((($2)) + 32|0);
 $$05461 = 1;
 while(1) {
  $19 = HEAP32[$4>>2]|0; //@line 135202 "c/sqlite3.c"
  $20 = ((($19)) + 12|0); //@line 135202 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 135202 "c/sqlite3.c"
  $22 = ((($21)) + 20|0); //@line 135202 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 135202 "c/sqlite3.c"
  $24 = (((($23)) + 4|0) + (($$05461*20)|0)|0); //@line 135202 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 135202 "c/sqlite3.c"
  $26 = ((($19)) + 16|0); //@line 135203 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 135203 "c/sqlite3.c"
  $28 = ((($27)) + 4|0); //@line 135204 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 135204 "c/sqlite3.c"
  $30 = $29 & 2048; //@line 135204 "c/sqlite3.c"
  $31 = ($30|0)==(0); //@line 135204 "c/sqlite3.c"
  $32 = ((($27)) + 20|0);
  if ($31) {
   $$pn$in = $32;
  } else {
   $33 = HEAP32[$32>>2]|0; //@line 135205 "c/sqlite3.c"
   $$pn$in = $33;
  }
  $$pn = HEAP32[$$pn$in>>2]|0;
  $$053$in = (((($$pn)) + 4|0) + (($$05461*20)|0)|0);
  $$053 = HEAP32[$$053$in>>2]|0;
  $34 = HEAP8[$25>>0]|0; //@line 135214 "c/sqlite3.c"
  $35 = ($34<<24>>24)==(-111); //@line 135214 "c/sqlite3.c"
  if (!($35)) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $36 = ((($25)) + 28|0); //@line 135215 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 135215 "c/sqlite3.c"
  $38 = ($37|0)==($1|0); //@line 135215 "c/sqlite3.c"
  if (!($38)) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $39 = ((($25)) + 32|0); //@line 135216 "c/sqlite3.c"
  $40 = HEAP16[$39>>1]|0; //@line 135216 "c/sqlite3.c"
  $41 = HEAP32[$16>>2]|0; //@line 135216 "c/sqlite3.c"
  $42 = (($$05461) + ($3))|0; //@line 135216 "c/sqlite3.c"
  $43 = (($41) + ($42<<1)|0); //@line 135216 "c/sqlite3.c"
  $44 = HEAP16[$43>>1]|0; //@line 135216 "c/sqlite3.c"
  $45 = ($40<<16>>16)==($44<<16>>16); //@line 135216 "c/sqlite3.c"
  if (!($45)) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $46 = HEAP32[$14>>2]|0; //@line 135217 "c/sqlite3.c"
  $47 = (($46) + ($42)|0); //@line 135217 "c/sqlite3.c"
  $48 = HEAP8[$47>>0]|0; //@line 135217 "c/sqlite3.c"
  $49 = (($46) + ($3)|0); //@line 135217 "c/sqlite3.c"
  $50 = HEAP8[$49>>0]|0; //@line 135217 "c/sqlite3.c"
  $51 = ($48<<24>>24)==($50<<24>>24); //@line 135217 "c/sqlite3.c"
  if (!($51)) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $52 = (_sqlite3ExprAffinity($25)|0); //@line 135223 "c/sqlite3.c"
  $53 = (_sqlite3CompareAffinity($$053,$52)|0); //@line 135223 "c/sqlite3.c"
  $54 = HEAP32[$17>>2]|0; //@line 135224 "c/sqlite3.c"
  $55 = HEAP16[$39>>1]|0; //@line 135224 "c/sqlite3.c"
  $56 = $55 << 16 >> 16; //@line 135224 "c/sqlite3.c"
  $57 = (_sqlite3TableColumnAffinity($54,$56)|0); //@line 135224 "c/sqlite3.c"
  $58 = ($53<<24>>24)==($57<<24>>24); //@line 135225 "c/sqlite3.c"
  if (!($58)) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $59 = (_sqlite3BinaryCompareCollSeq($0,$25,$$053)|0); //@line 135227 "c/sqlite3.c"
  $60 = ($59|0)==(0|0); //@line 135228 "c/sqlite3.c"
  if ($60) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $61 = HEAP32[$59>>2]|0; //@line 135229 "c/sqlite3.c"
  $62 = HEAP32[$18>>2]|0; //@line 135229 "c/sqlite3.c"
  $63 = (($62) + ($42<<2)|0); //@line 135229 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 135229 "c/sqlite3.c"
  $65 = (_sqlite3StrICmp($61,$64)|0); //@line 135229 "c/sqlite3.c"
  $66 = ($65|0)==(0); //@line 135229 "c/sqlite3.c"
  if (!($66)) {
   $$054$lcssa = $$05461;
   label = 14;
   break;
  }
  $67 = (($$05461) + 1)|0; //@line 135196 "c/sqlite3.c"
  $68 = ($67|0)<($$|0); //@line 135196 "c/sqlite3.c"
  if ($68) {
   $$05461 = $67;
  } else {
   $$054$lcssa = $67;
   label = 14;
   break;
  }
 }
 if ((label|0) == 14) {
  return ($$054$lcssa|0); //@line 135231 "c/sqlite3.c"
 }
 return (0)|0;
}
function _whereRangeScanEst($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$027 = 0, $$neg = 0, $$neg1 = 0, $$neg2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($2)) + 22|0); //@line 134340 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 134340 "c/sqlite3.c"
 $5 = $4 << 16 >> 16; //@line 134340 "c/sqlite3.c"
 $6 = (_whereRangeAdjust($0,$4)|0); //@line 134467 "c/sqlite3.c"
 $7 = (_whereRangeAdjust($1,$6)|0); //@line 134468 "c/sqlite3.c"
 $8 = ($0|0)!=(0|0); //@line 134476 "c/sqlite3.c"
 if ($8) {
  $9 = ((($0)) + 8|0); //@line 134476 "c/sqlite3.c"
  $10 = HEAP16[$9>>1]|0; //@line 134476 "c/sqlite3.c"
  $11 = ($10<<16>>16)>(0); //@line 134476 "c/sqlite3.c"
  $12 = ($1|0)!=(0|0); //@line 134476 "c/sqlite3.c"
  $or$cond = $12 & $11; //@line 134476 "c/sqlite3.c"
  if ($or$cond) {
   $13 = ((($1)) + 8|0); //@line 134476 "c/sqlite3.c"
   $14 = HEAP16[$13>>1]|0; //@line 134476 "c/sqlite3.c"
   $15 = ($14<<16>>16)>(0); //@line 134476 "c/sqlite3.c"
   if ($15) {
    $16 = $7&65535; //@line 134477 "c/sqlite3.c"
    $17 = (($16) + 65516)|0; //@line 134477 "c/sqlite3.c"
    $18 = $17&65535; //@line 134477 "c/sqlite3.c"
    $$0 = $18;
   } else {
    $$0 = $7;
   }
  } else {
   $$0 = $7;
  }
 } else {
  $$0 = $7;
 }
 $19 = ($1|0)!=(0|0); //@line 134480 "c/sqlite3.c"
 $$neg = $8 << 31 >> 31;
 $$neg1 = $19 << 31 >> 31;
 $$neg2 = (($$neg1) + ($$neg))|0; //@line 134480 "c/sqlite3.c"
 $20 = (($$neg2) + ($5))|0; //@line 134480 "c/sqlite3.c"
 $21 = ($$0<<16>>16)>(10); //@line 134481 "c/sqlite3.c"
 $spec$select = $21 ? $$0 : 10; //@line 134481 "c/sqlite3.c"
 $22 = $spec$select&65535; //@line 134482 "c/sqlite3.c"
 $23 = ($20|0)>($22|0); //@line 134482 "c/sqlite3.c"
 $$027 = $23 ? $22 : $20; //@line 134482 "c/sqlite3.c"
 $24 = $$027&65535; //@line 134489 "c/sqlite3.c"
 HEAP16[$3>>1] = $24; //@line 134489 "c/sqlite3.c"
 return;
}
function _whereRangeAdjust($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 134159 "c/sqlite3.c"
 if ($2) {
  $$0 = $1;
  return ($$0|0); //@line 134166 "c/sqlite3.c"
 }
 $3 = ((($0)) + 8|0); //@line 134160 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 134160 "c/sqlite3.c"
 $5 = ($4<<16>>16)<(1); //@line 134160 "c/sqlite3.c"
 if ($5) {
  $6 = $4&65535; //@line 134160 "c/sqlite3.c"
  $7 = $1&65535; //@line 134161 "c/sqlite3.c"
  $8 = (($6) + ($7))|0; //@line 134161 "c/sqlite3.c"
  $9 = $8&65535; //@line 134161 "c/sqlite3.c"
  $$0 = $9;
  return ($$0|0); //@line 134166 "c/sqlite3.c"
 } else {
  $10 = $1&65535; //@line 134163 "c/sqlite3.c"
  $11 = (($10) + 65516)|0; //@line 134163 "c/sqlite3.c"
  $12 = $11&65535; //@line 134163 "c/sqlite3.c"
  $$0 = $12;
  return ($$0|0); //@line 134166 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3ExprImpliesExpr($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$1 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3ExprCompare($0,$1,$2,$3)|0); //@line 97587 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 97587 "c/sqlite3.c"
 if ($5) {
  $$1 = 1;
  return ($$1|0); //@line 97602 "c/sqlite3.c"
 }
 $6 = HEAP8[$2>>0]|0; //@line 97590 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(43); //@line 97590 "c/sqlite3.c"
 do {
  if ($7) {
   $8 = ((($2)) + 12|0); //@line 97591 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 97591 "c/sqlite3.c"
   $10 = (_sqlite3ExprImpliesExpr($0,$1,$9,$3)|0); //@line 97591 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 97591 "c/sqlite3.c"
   if (!($11)) {
    $$1 = 1;
    return ($$1|0); //@line 97602 "c/sqlite3.c"
   }
   $12 = ((($2)) + 16|0); //@line 97592 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 97592 "c/sqlite3.c"
   $14 = (_sqlite3ExprImpliesExpr($0,$1,$13,$3)|0); //@line 97592 "c/sqlite3.c"
   $15 = ($14|0)==(0); //@line 97592 "c/sqlite3.c"
   if ($15) {
    $$pr = HEAP8[$2>>0]|0; //@line 97596 "c/sqlite3.c"
    $17 = $$pr;
    break;
   } else {
    $$1 = 1;
    return ($$1|0); //@line 97602 "c/sqlite3.c"
   }
  } else {
   $17 = $6;
  }
 } while(0);
 $16 = ($17<<24>>24)==(51); //@line 97596 "c/sqlite3.c"
 L13: do {
  if ($16) {
   $18 = HEAP8[$1>>0]|0; //@line 97596 "c/sqlite3.c"
   switch ($18<<24>>24) {
   case 45: case 50:  {
    break L13;
    break;
   }
   default: {
   }
   }
   $19 = ((($1)) + 12|0); //@line 97597 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 97597 "c/sqlite3.c"
   $21 = (_sqlite3ExprSkipCollate($20)|0); //@line 97597 "c/sqlite3.c"
   $22 = ((($2)) + 12|0); //@line 97599 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 97599 "c/sqlite3.c"
   $24 = (_sqlite3ExprCompare($0,$21,$23,$3)|0); //@line 97599 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 97599 "c/sqlite3.c"
   if ($25) {
    $$1 = 1;
    return ($$1|0); //@line 97602 "c/sqlite3.c"
   }
  }
 } while(0);
 $$1 = 0;
 return ($$1|0); //@line 97602 "c/sqlite3.c"
}
function _allocateIndexInfo($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0 = 0, $$0139173 = 0, $$0141157 = 0, $$0143$lcssa = 0, $$0143156 = 0, $$0147$lcssa = 0, $$0147172 = 0, $$0151171 = 0, $$1140$lcssa = 0, $$1140162 = 0, $$1142 = 0, $$1144 = 0, $$1148 = 0, $$1150 = 0, $$1152155 = 0, $$2145 = 0, $$2158 = 0, $$3146 = 0, $$3154 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $spec$select = 0, $spec$select153 = 0, $trunc = 0, $trunc$clear = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 133767 "c/sqlite3.c"
 $7 = ((($1)) + 20|0); //@line 133787 "c/sqlite3.c"
 $8 = ((($1)) + 12|0); //@line 133787 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 133787 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 133787 "c/sqlite3.c"
 if ($10) {
  $11 = HEAP32[$7>>2]|0; //@line 133787 "c/sqlite3.c"
  $12 = ((($4)) + 44|0);
  $13 = HEAP32[$12>>2]|0;
  $14 = HEAP32[$8>>2]|0;
  $$0139173 = 0;$$0147172 = 0;$$0151171 = $11;
  while(1) {
   $15 = ((($$0151171)) + 20|0); //@line 133788 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 133788 "c/sqlite3.c"
   $17 = ($16|0)==($13|0); //@line 133788 "c/sqlite3.c"
   if ($17) {
    $18 = ((($$0151171)) + 32|0); //@line 133789 "c/sqlite3.c"
    $19 = $18; //@line 133789 "c/sqlite3.c"
    $20 = $19; //@line 133789 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 133789 "c/sqlite3.c"
    $22 = (($19) + 4)|0; //@line 133789 "c/sqlite3.c"
    $23 = $22; //@line 133789 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 133789 "c/sqlite3.c"
    $25 = $21 & $2; //@line 133789 "c/sqlite3.c"
    $26 = $24 & $3; //@line 133789 "c/sqlite3.c"
    $27 = ($25|0)==(0); //@line 133789 "c/sqlite3.c"
    $28 = ($26|0)==(0); //@line 133789 "c/sqlite3.c"
    $29 = $27 & $28; //@line 133789 "c/sqlite3.c"
    if ($29) {
     $30 = ((($$0151171)) + 12|0); //@line 133795 "c/sqlite3.c"
     $31 = HEAP16[$30>>1]|0; //@line 133795 "c/sqlite3.c"
     $32 = $31 & -2049; //@line 133795 "c/sqlite3.c"
     $33 = ($32<<16>>16)!=(0); //@line 133795 "c/sqlite3.c"
     $34 = $33&1; //@line 133795 "c/sqlite3.c"
     $spec$select153 = (($$0147172) + ($34))|0; //@line 133795 "c/sqlite3.c"
     $$1148 = $spec$select153;
    } else {
     $$1148 = $$0147172;
    }
   } else {
    $$1148 = $$0147172;
   }
   $35 = (($$0139173) + 1)|0; //@line 133787 "c/sqlite3.c"
   $36 = ((($$0151171)) + 48|0); //@line 133787 "c/sqlite3.c"
   $37 = ($35|0)<($14|0); //@line 133787 "c/sqlite3.c"
   if ($37) {
    $$0139173 = $35;$$0147172 = $$1148;$$0151171 = $36;
   } else {
    $$0147$lcssa = $$1148;
    break;
   }
  }
 } else {
  $$0147$lcssa = 0;
 }
 $38 = ($5|0)==(0|0); //@line 133806 "c/sqlite3.c"
 if ($38) {
  $$1150 = 0;
 } else {
  $39 = HEAP32[$5>>2]|0; //@line 133807 "c/sqlite3.c"
  $40 = ($39|0)>(0); //@line 133808 "c/sqlite3.c"
  L12: do {
   if ($40) {
    $41 = ((($4)) + 44|0);
    $$1140162 = 0;
    while(1) {
     $42 = (((($5)) + 4|0) + (($$1140162*20)|0)|0); //@line 133809 "c/sqlite3.c"
     $43 = HEAP32[$42>>2]|0; //@line 133809 "c/sqlite3.c"
     $44 = HEAP8[$43>>0]|0; //@line 133810 "c/sqlite3.c"
     $45 = ($44<<24>>24)==(-111); //@line 133810 "c/sqlite3.c"
     if (!($45)) {
      $$1140$lcssa = $$1140162;
      break L12;
     }
     $46 = ((($43)) + 28|0); //@line 133810 "c/sqlite3.c"
     $47 = HEAP32[$46>>2]|0; //@line 133810 "c/sqlite3.c"
     $48 = HEAP32[$41>>2]|0; //@line 133810 "c/sqlite3.c"
     $49 = ($47|0)==($48|0); //@line 133810 "c/sqlite3.c"
     if (!($49)) {
      $$1140$lcssa = $$1140162;
      break L12;
     }
     $50 = (($$1140162) + 1)|0; //@line 133808 "c/sqlite3.c"
     $51 = ($50|0)<($39|0); //@line 133808 "c/sqlite3.c"
     if ($51) {
      $$1140162 = $50;
     } else {
      $$1140$lcssa = $50;
      break;
     }
    }
   } else {
    $$1140$lcssa = 0;
   }
  } while(0);
  $52 = ($$1140$lcssa|0)==($39|0); //@line 133812 "c/sqlite3.c"
  $spec$select = $52 ? $39 : 0; //@line 133812 "c/sqlite3.c"
  $$1150 = $spec$select;
 }
 $53 = HEAP32[$0>>2]|0; //@line 133819 "c/sqlite3.c"
 $54 = ($$0147$lcssa*20)|0; //@line 133820 "c/sqlite3.c"
 $55 = $$1150 << 3; //@line 133821 "c/sqlite3.c"
 $56 = (($54) + 80)|0; //@line 133821 "c/sqlite3.c"
 $57 = (($56) + ($55))|0; //@line 133821 "c/sqlite3.c"
 $58 = (_sqlite3DbMallocZero($53,$57,0)|0); //@line 133819 "c/sqlite3.c"
 $59 = ($58|0)==(0|0); //@line 133822 "c/sqlite3.c"
 if ($59) {
  _sqlite3ErrorMsg($0,17402,$vararg_buffer); //@line 133823 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 133900 "c/sqlite3.c"
 }
 $60 = ((($58)) + 72|0); //@line 133832 "c/sqlite3.c"
 $61 = ((($58)) + 80|0); //@line 133833 "c/sqlite3.c"
 $62 = (($61) + (($$0147$lcssa*12)|0)|0); //@line 133834 "c/sqlite3.c"
 $63 = (($62) + ($$1150<<3)|0); //@line 133835 "c/sqlite3.c"
 HEAP32[$58>>2] = $$0147$lcssa; //@line 133836 "c/sqlite3.c"
 $64 = ((($58)) + 8|0); //@line 133837 "c/sqlite3.c"
 HEAP32[$64>>2] = $$1150; //@line 133837 "c/sqlite3.c"
 $65 = ((($58)) + 4|0); //@line 133838 "c/sqlite3.c"
 HEAP32[$65>>2] = $61; //@line 133838 "c/sqlite3.c"
 $66 = ((($58)) + 12|0); //@line 133839 "c/sqlite3.c"
 HEAP32[$66>>2] = $62; //@line 133839 "c/sqlite3.c"
 $67 = ((($58)) + 16|0); //@line 133840 "c/sqlite3.c"
 HEAP32[$67>>2] = $63; //@line 133840 "c/sqlite3.c"
 HEAP32[$60>>2] = $1; //@line 133843 "c/sqlite3.c"
 $68 = ((($58)) + 76|0); //@line 133844 "c/sqlite3.c"
 HEAP32[$68>>2] = $0; //@line 133844 "c/sqlite3.c"
 $69 = HEAP32[$8>>2]|0; //@line 133845 "c/sqlite3.c"
 $70 = ($69|0)>(0); //@line 133845 "c/sqlite3.c"
 if ($70) {
  $71 = HEAP32[$7>>2]|0; //@line 133845 "c/sqlite3.c"
  $72 = ((($4)) + 44|0);
  $$0141157 = 0;$$0143156 = 0;$$1152155 = $71;$$2158 = 0;
  while(1) {
   $73 = ((($$1152155)) + 20|0); //@line 133847 "c/sqlite3.c"
   $74 = HEAP32[$73>>2]|0; //@line 133847 "c/sqlite3.c"
   $75 = HEAP32[$72>>2]|0; //@line 133847 "c/sqlite3.c"
   $76 = ($74|0)==($75|0); //@line 133847 "c/sqlite3.c"
   if ($76) {
    $77 = ((($$1152155)) + 32|0); //@line 133848 "c/sqlite3.c"
    $78 = $77; //@line 133848 "c/sqlite3.c"
    $79 = $78; //@line 133848 "c/sqlite3.c"
    $80 = HEAP32[$79>>2]|0; //@line 133848 "c/sqlite3.c"
    $81 = (($78) + 4)|0; //@line 133848 "c/sqlite3.c"
    $82 = $81; //@line 133848 "c/sqlite3.c"
    $83 = HEAP32[$82>>2]|0; //@line 133848 "c/sqlite3.c"
    $84 = $80 & $2; //@line 133848 "c/sqlite3.c"
    $85 = $83 & $3; //@line 133848 "c/sqlite3.c"
    $86 = ($84|0)==(0); //@line 133848 "c/sqlite3.c"
    $87 = ($85|0)==(0); //@line 133848 "c/sqlite3.c"
    $88 = $86 & $87; //@line 133848 "c/sqlite3.c"
    if ($88) {
     $89 = ((($$1152155)) + 12|0); //@line 133854 "c/sqlite3.c"
     $90 = HEAP16[$89>>1]|0; //@line 133854 "c/sqlite3.c"
     $91 = $90 & -2049; //@line 133854 "c/sqlite3.c"
     $92 = ($91<<16>>16)==(0); //@line 133854 "c/sqlite3.c"
     if ($92) {
      $$1142 = $$0141157;$$3146 = $$0143156;
     } else {
      $93 = ((($$1152155)) + 28|0); //@line 133857 "c/sqlite3.c"
      $94 = HEAP32[$93>>2]|0; //@line 133857 "c/sqlite3.c"
      $95 = (($61) + (($$0141157*12)|0)|0); //@line 133857 "c/sqlite3.c"
      HEAP32[$95>>2] = $94; //@line 133857 "c/sqlite3.c"
      $96 = (((($61) + (($$0141157*12)|0)|0)) + 8|0); //@line 133858 "c/sqlite3.c"
      HEAP32[$96>>2] = $$2158; //@line 133858 "c/sqlite3.c"
      $97 = $90 & 8191; //@line 133859 "c/sqlite3.c"
      $98 = ($97<<16>>16)==(1); //@line 133860 "c/sqlite3.c"
      $trunc = $98 ? 2 : $97; //@line 133860 "c/sqlite3.c"
      $99 = $trunc&65535; //@line 133861 "c/sqlite3.c"
      $100 = ($trunc<<16>>16)==(64); //@line 133861 "c/sqlite3.c"
      L32: do {
       if ($100) {
        $101 = ((($$1152155)) + 15|0); //@line 133862 "c/sqlite3.c"
        $102 = HEAP8[$101>>0]|0; //@line 133862 "c/sqlite3.c"
        $103 = (((($61) + (($$0141157*12)|0)|0)) + 4|0); //@line 133862 "c/sqlite3.c"
        HEAP8[$103>>0] = $102; //@line 133862 "c/sqlite3.c"
        $$2145 = $$0143156;
       } else {
        $104 = $99 & 384; //@line 133863 "c/sqlite3.c"
        $105 = ($104|0)==(0); //@line 133863 "c/sqlite3.c"
        if (!($105)) {
         $106 = ($trunc<<16>>16)==(256); //@line 133864 "c/sqlite3.c"
         $107 = (((($61) + (($$0141157*12)|0)|0)) + 4|0);
         if ($106) {
          HEAP8[$107>>0] = 71; //@line 133865 "c/sqlite3.c"
          $$2145 = $$0143156;
          break;
         } else {
          HEAP8[$107>>0] = 72; //@line 133867 "c/sqlite3.c"
          $$2145 = $$0143156;
          break;
         }
        }
        $108 = $trunc&255; //@line 133870 "c/sqlite3.c"
        $109 = (((($61) + (($$0141157*12)|0)|0)) + 4|0); //@line 133870 "c/sqlite3.c"
        HEAP8[$109>>0] = $108; //@line 133870 "c/sqlite3.c"
        $110 = $99 & 60; //@line 133881 "c/sqlite3.c"
        $111 = ($110|0)==(0); //@line 133881 "c/sqlite3.c"
        if ($111) {
         $$2145 = $$0143156;
        } else {
         $112 = HEAP32[$$1152155>>2]|0; //@line 133882 "c/sqlite3.c"
         $113 = ((($112)) + 16|0); //@line 133882 "c/sqlite3.c"
         $114 = HEAP32[$113>>2]|0; //@line 133882 "c/sqlite3.c"
         $115 = (_sqlite3ExprIsVector($114)|0); //@line 133882 "c/sqlite3.c"
         $116 = ($115|0)==(0); //@line 133882 "c/sqlite3.c"
         if ($116) {
          $$2145 = $$0143156;
         } else {
          $117 = ($$2158>>>0)<(16); //@line 133884 "c/sqlite3.c"
          $118 = 1 << $$2158; //@line 133884 "c/sqlite3.c"
          $119 = $$0143156&65535; //@line 133884 "c/sqlite3.c"
          $120 = $118 | $119; //@line 133884 "c/sqlite3.c"
          $121 = $120&65535; //@line 133884 "c/sqlite3.c"
          $$1144 = $117 ? $121 : $$0143156; //@line 133884 "c/sqlite3.c"
          $trunc$clear = $trunc & 8191; //@line 133885 "c/sqlite3.c"
          switch ($trunc$clear<<16>>16) {
          case 16:  {
           HEAP8[$109>>0] = 8; //@line 133885 "c/sqlite3.c"
           $$2145 = $$1144;
           break L32;
           break;
          }
          case 4:  {
           HEAP8[$109>>0] = 32; //@line 133886 "c/sqlite3.c"
           $$2145 = $$1144;
           break L32;
           break;
          }
          default: {
           $$2145 = $$1144;
           break L32;
          }
          }
         }
        }
       }
      } while(0);
      $122 = (($$0141157) + 1)|0; //@line 133890 "c/sqlite3.c"
      $$1142 = $122;$$3146 = $$2145;
     }
    } else {
     $$1142 = $$0141157;$$3146 = $$0143156;
    }
   } else {
    $$1142 = $$0141157;$$3146 = $$0143156;
   }
   $123 = (($$2158) + 1)|0; //@line 133845 "c/sqlite3.c"
   $124 = ((($$1152155)) + 48|0); //@line 133845 "c/sqlite3.c"
   $125 = HEAP32[$8>>2]|0; //@line 133845 "c/sqlite3.c"
   $126 = ($123|0)<($125|0); //@line 133845 "c/sqlite3.c"
   if ($126) {
    $$0141157 = $$1142;$$0143156 = $$3146;$$1152155 = $124;$$2158 = $123;
   } else {
    $$0143$lcssa = $$3146;
    break;
   }
  }
 } else {
  $$0143$lcssa = 0;
 }
 $127 = ($$1150|0)>(0); //@line 133892 "c/sqlite3.c"
 if ($127) {
  $$3154 = 0;
  while(1) {
   $128 = (((($5)) + 4|0) + (($$3154*20)|0)|0); //@line 133893 "c/sqlite3.c"
   $129 = HEAP32[$128>>2]|0; //@line 133893 "c/sqlite3.c"
   $130 = ((($129)) + 32|0); //@line 133894 "c/sqlite3.c"
   $131 = HEAP16[$130>>1]|0; //@line 133894 "c/sqlite3.c"
   $132 = $131 << 16 >> 16; //@line 133894 "c/sqlite3.c"
   $133 = (($62) + ($$3154<<3)|0); //@line 133894 "c/sqlite3.c"
   HEAP32[$133>>2] = $132; //@line 133894 "c/sqlite3.c"
   $134 = (((((($5)) + 4|0) + (($$3154*20)|0)|0)) + 12|0); //@line 133895 "c/sqlite3.c"
   $135 = HEAP8[$134>>0]|0; //@line 133895 "c/sqlite3.c"
   $136 = (((($62) + ($$3154<<3)|0)) + 4|0); //@line 133895 "c/sqlite3.c"
   HEAP8[$136>>0] = $135; //@line 133895 "c/sqlite3.c"
   $137 = (($$3154) + 1)|0; //@line 133892 "c/sqlite3.c"
   $exitcond = ($137|0)==($$1150|0); //@line 133892 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$3154 = $137;
   }
  }
 }
 HEAP16[$6>>1] = $$0143$lcssa; //@line 133898 "c/sqlite3.c"
 $$0 = $58;
 STACKTOP = sp;return ($$0|0); //@line 133900 "c/sqlite3.c"
}
function _whereLoopAddVirtualOne($0,$1,$2,$3,$4,$5,$6,$7,$8) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 var $$0140166 = 0, $$0142165 = 0, $$0147$lcssa = 0, $$0147158 = 0, $$1141160 = 0, $$1143161 = 0, $$2144159 = 0, $$4 = 0, $$4151$ph = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0;
 var $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0;
 var $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0;
 var $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0.0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0;
 var $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond170 = 0;
 var $or$cond = 0, $phitmp = 0, $spec$select = 0, $storemerge = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 135941 "c/sqlite3.c"
 $9 = ((($0)) + 4|0); //@line 135949 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 135949 "c/sqlite3.c"
 $11 = ((($6)) + 16|0); //@line 135951 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 135951 "c/sqlite3.c"
 $13 = ((($0)) + 12|0); //@line 135955 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 135955 "c/sqlite3.c"
 $15 = HEAP32[$0>>2]|0; //@line 135956 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 135956 "c/sqlite3.c"
 $17 = ((($15)) + 4|0); //@line 135957 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 135957 "c/sqlite3.c"
 $19 = ((($14)) + 16|0); //@line 135957 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 135957 "c/sqlite3.c"
 $21 = $20&255; //@line 135957 "c/sqlite3.c"
 $22 = HEAP32[$6>>2]|0; //@line 135958 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 135961 "c/sqlite3.c"
 $23 = $14; //@line 135962 "c/sqlite3.c"
 $24 = $23; //@line 135962 "c/sqlite3.c"
 HEAP32[$24>>2] = $1; //@line 135962 "c/sqlite3.c"
 $25 = (($23) + 4)|0; //@line 135962 "c/sqlite3.c"
 $26 = $25; //@line 135962 "c/sqlite3.c"
 HEAP32[$26>>2] = $2; //@line 135962 "c/sqlite3.c"
 $27 = ((($6)) + 4|0); //@line 135966 "c/sqlite3.c"
 $28 = ($22|0)>(0); //@line 135967 "c/sqlite3.c"
 if ($28) {
  $29 = HEAP32[$27>>2]|0; //@line 135966 "c/sqlite3.c"
  $30 = ((($10)) + 20|0);
  $31 = HEAP32[$30>>2]|0;
  $$0140166 = $29;$$0142165 = 0;
  while(1) {
   $32 = ((($$0140166)) + 8|0); //@line 135968 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 135968 "c/sqlite3.c"
   $34 = ((($$0140166)) + 5|0); //@line 135969 "c/sqlite3.c"
   HEAP8[$34>>0] = 0; //@line 135969 "c/sqlite3.c"
   $35 = (((($31) + (($33*48)|0)|0)) + 32|0); //@line 135970 "c/sqlite3.c"
   $36 = $35; //@line 135970 "c/sqlite3.c"
   $37 = $36; //@line 135970 "c/sqlite3.c"
   $38 = HEAP32[$37>>2]|0; //@line 135970 "c/sqlite3.c"
   $39 = (($36) + 4)|0; //@line 135970 "c/sqlite3.c"
   $40 = $39; //@line 135970 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 135970 "c/sqlite3.c"
   $42 = $38 & $3; //@line 135970 "c/sqlite3.c"
   $43 = $41 & $4; //@line 135970 "c/sqlite3.c"
   $44 = ($42|0)==($38|0); //@line 135970 "c/sqlite3.c"
   $45 = ($43|0)==($41|0); //@line 135970 "c/sqlite3.c"
   $46 = $44 & $45; //@line 135970 "c/sqlite3.c"
   if ($46) {
    $47 = (((($31) + (($33*48)|0)|0)) + 12|0); //@line 135971 "c/sqlite3.c"
    $48 = HEAP16[$47>>1]|0; //@line 135971 "c/sqlite3.c"
    $49 = $48 & $5; //@line 135971 "c/sqlite3.c"
    $50 = ($49<<16>>16)==(0); //@line 135971 "c/sqlite3.c"
    if ($50) {
     HEAP8[$34>>0] = 1; //@line 135973 "c/sqlite3.c"
    }
   }
   $51 = (($$0142165) + 1)|0; //@line 135967 "c/sqlite3.c"
   $52 = ((($$0140166)) + 12|0); //@line 135967 "c/sqlite3.c"
   $exitcond170 = ($51|0)==($22|0); //@line 135967 "c/sqlite3.c"
   if ($exitcond170) {
    break;
   } else {
    $$0140166 = $52;$$0142165 = $51;
   }
  }
 }
 $53 = $22 << 3; //@line 135978 "c/sqlite3.c"
 _memset(($12|0),0,($53|0))|0; //@line 135978 "c/sqlite3.c"
 $54 = ((($6)) + 24|0); //@line 135980 "c/sqlite3.c"
 HEAP32[$54>>2] = 0; //@line 135980 "c/sqlite3.c"
 $55 = ((($6)) + 20|0); //@line 135981 "c/sqlite3.c"
 HEAP32[$55>>2] = 0; //@line 135981 "c/sqlite3.c"
 $56 = ((($6)) + 32|0); //@line 135982 "c/sqlite3.c"
 HEAP32[$56>>2] = 0; //@line 135982 "c/sqlite3.c"
 $57 = ((($6)) + 40|0); //@line 135983 "c/sqlite3.c"
 HEAPF64[$57>>3] = 4.9999999999999998E+98; //@line 135983 "c/sqlite3.c"
 $58 = ((($6)) + 48|0); //@line 135984 "c/sqlite3.c"
 $59 = $58; //@line 135984 "c/sqlite3.c"
 $60 = $59; //@line 135984 "c/sqlite3.c"
 HEAP32[$60>>2] = 25; //@line 135984 "c/sqlite3.c"
 $61 = (($59) + 4)|0; //@line 135984 "c/sqlite3.c"
 $62 = $61; //@line 135984 "c/sqlite3.c"
 HEAP32[$62>>2] = 0; //@line 135984 "c/sqlite3.c"
 $63 = ((($6)) + 56|0); //@line 135985 "c/sqlite3.c"
 HEAP32[$63>>2] = 0; //@line 135985 "c/sqlite3.c"
 $64 = (((((($18)) + 8|0) + (($21*72)|0)|0)) + 56|0); //@line 135986 "c/sqlite3.c"
 $65 = $64; //@line 135986 "c/sqlite3.c"
 $66 = $65; //@line 135986 "c/sqlite3.c"
 $67 = HEAP32[$66>>2]|0; //@line 135986 "c/sqlite3.c"
 $68 = (($65) + 4)|0; //@line 135986 "c/sqlite3.c"
 $69 = $68; //@line 135986 "c/sqlite3.c"
 $70 = HEAP32[$69>>2]|0; //@line 135986 "c/sqlite3.c"
 $71 = ((($6)) + 64|0); //@line 135986 "c/sqlite3.c"
 $72 = $71; //@line 135986 "c/sqlite3.c"
 $73 = $72; //@line 135986 "c/sqlite3.c"
 HEAP32[$73>>2] = $67; //@line 135986 "c/sqlite3.c"
 $74 = (($72) + 4)|0; //@line 135986 "c/sqlite3.c"
 $75 = $74; //@line 135986 "c/sqlite3.c"
 HEAP32[$75>>2] = $70; //@line 135986 "c/sqlite3.c"
 $76 = (((((($18)) + 8|0) + (($21*72)|0)|0)) + 16|0); //@line 135989 "c/sqlite3.c"
 $77 = HEAP32[$76>>2]|0; //@line 135989 "c/sqlite3.c"
 $78 = (_vtabBestIndex($16,$77,$6)|0); //@line 135989 "c/sqlite3.c"
 $79 = ($78|0)==(0); //@line 135990 "c/sqlite3.c"
 if (!($79)) {
  $$4 = $78;
  STACKTOP = sp;return ($$4|0); //@line 136066 "c/sqlite3.c"
 }
 $80 = ($22|0)>(0); //@line 135994 "c/sqlite3.c"
 L13: do {
  if ($80) {
   $83 = ((($14)) + 48|0);
   $$1143161 = 0;
   while(1) {
    $84 = HEAP32[$83>>2]|0; //@line 135994 "c/sqlite3.c"
    $85 = (($84) + ($$1143161<<2)|0); //@line 135994 "c/sqlite3.c"
    HEAP32[$85>>2] = 0; //@line 135994 "c/sqlite3.c"
    $86 = (($$1143161) + 1)|0; //@line 135994 "c/sqlite3.c"
    $exitcond = ($86|0)==($22|0); //@line 135994 "c/sqlite3.c"
    if ($exitcond) {
     break;
    } else {
     $$1143161 = $86;
    }
   }
   $87 = ((($14)) + 24|0); //@line 135995 "c/sqlite3.c"
   $88 = ((($14)) + 30|0); //@line 135995 "c/sqlite3.c"
   HEAP16[$88>>1] = 0; //@line 135995 "c/sqlite3.c"
   $89 = ($22|0)>(0); //@line 135997 "c/sqlite3.c"
   if ($89) {
    $90 = HEAP32[$27>>2]|0; //@line 135996 "c/sqlite3.c"
    $91 = ((($10)) + 12|0);
    $92 = ((($14)) + 48|0);
    $93 = ((($10)) + 20|0);
    $$0147158 = -1;$$1141160 = $90;$$2144159 = 0;
    while(1) {
     $94 = (($12) + ($$2144159<<3)|0); //@line 135999 "c/sqlite3.c"
     $95 = HEAP32[$94>>2]|0; //@line 135999 "c/sqlite3.c"
     $96 = (($95) + -1)|0; //@line 135999 "c/sqlite3.c"
     $97 = ($95|0)>(0); //@line 135999 "c/sqlite3.c"
     if ($97) {
      $98 = ((($$1141160)) + 8|0); //@line 136001 "c/sqlite3.c"
      $99 = HEAP32[$98>>2]|0; //@line 136001 "c/sqlite3.c"
      $100 = ($95|0)>($22|0); //@line 136002 "c/sqlite3.c"
      $101 = ($99|0)<(0); //@line 136003 "c/sqlite3.c"
      $or$cond = $100 | $101; //@line 136003 "c/sqlite3.c"
      if ($or$cond) {
       break;
      }
      $102 = HEAP32[$91>>2]|0; //@line 136004 "c/sqlite3.c"
      $103 = ($99|0)<($102|0); //@line 136004 "c/sqlite3.c"
      if (!($103)) {
       break;
      }
      $104 = HEAP32[$92>>2]|0; //@line 136005 "c/sqlite3.c"
      $105 = (($104) + ($96<<2)|0); //@line 136005 "c/sqlite3.c"
      $106 = HEAP32[$105>>2]|0; //@line 136005 "c/sqlite3.c"
      $107 = ($106|0)==(0|0); //@line 136005 "c/sqlite3.c"
      if (!($107)) {
       break;
      }
      $108 = ((($$1141160)) + 5|0); //@line 136006 "c/sqlite3.c"
      $109 = HEAP8[$108>>0]|0; //@line 136006 "c/sqlite3.c"
      $110 = ($109<<24>>24)==(0); //@line 136006 "c/sqlite3.c"
      if ($110) {
       break;
      }
      $111 = HEAP32[$93>>2]|0; //@line 136015 "c/sqlite3.c"
      $112 = (($111) + (($99*48)|0)|0); //@line 136015 "c/sqlite3.c"
      $113 = (((($111) + (($99*48)|0)|0)) + 32|0); //@line 136016 "c/sqlite3.c"
      $114 = $113; //@line 136016 "c/sqlite3.c"
      $115 = $114; //@line 136016 "c/sqlite3.c"
      $116 = HEAP32[$115>>2]|0; //@line 136016 "c/sqlite3.c"
      $117 = (($114) + 4)|0; //@line 136016 "c/sqlite3.c"
      $118 = $117; //@line 136016 "c/sqlite3.c"
      $119 = HEAP32[$118>>2]|0; //@line 136016 "c/sqlite3.c"
      $120 = $14; //@line 136016 "c/sqlite3.c"
      $121 = $120; //@line 136016 "c/sqlite3.c"
      $122 = HEAP32[$121>>2]|0; //@line 136016 "c/sqlite3.c"
      $123 = (($120) + 4)|0; //@line 136016 "c/sqlite3.c"
      $124 = $123; //@line 136016 "c/sqlite3.c"
      $125 = HEAP32[$124>>2]|0; //@line 136016 "c/sqlite3.c"
      $126 = $122 | $116; //@line 136016 "c/sqlite3.c"
      $127 = $125 | $119; //@line 136016 "c/sqlite3.c"
      $128 = $14; //@line 136016 "c/sqlite3.c"
      $129 = $128; //@line 136016 "c/sqlite3.c"
      HEAP32[$129>>2] = $126; //@line 136016 "c/sqlite3.c"
      $130 = (($128) + 4)|0; //@line 136016 "c/sqlite3.c"
      $131 = $130; //@line 136016 "c/sqlite3.c"
      HEAP32[$131>>2] = $127; //@line 136016 "c/sqlite3.c"
      HEAP32[$105>>2] = $112; //@line 136018 "c/sqlite3.c"
      $132 = ($96|0)>($$0147158|0); //@line 136019 "c/sqlite3.c"
      $spec$select = $132 ? $96 : $$0147158; //@line 136019 "c/sqlite3.c"
      $133 = ($95|0)<(17); //@line 136022 "c/sqlite3.c"
      if ($133) {
       $134 = (((($12) + ($$2144159<<3)|0)) + 4|0); //@line 136022 "c/sqlite3.c"
       $135 = HEAP8[$134>>0]|0; //@line 136022 "c/sqlite3.c"
       $136 = ($135<<24>>24)==(0); //@line 136022 "c/sqlite3.c"
       if (!($136)) {
        $137 = 1 << $96; //@line 136022 "c/sqlite3.c"
        $138 = HEAP16[$88>>1]|0; //@line 136022 "c/sqlite3.c"
        $139 = $138&65535; //@line 136022 "c/sqlite3.c"
        $140 = $137 | $139; //@line 136022 "c/sqlite3.c"
        $141 = $140&65535; //@line 136022 "c/sqlite3.c"
        HEAP16[$88>>1] = $141; //@line 136022 "c/sqlite3.c"
       }
      }
      $142 = (((($111) + (($99*48)|0)|0)) + 12|0); //@line 136023 "c/sqlite3.c"
      $143 = HEAP16[$142>>1]|0; //@line 136023 "c/sqlite3.c"
      $144 = $143 & 1; //@line 136023 "c/sqlite3.c"
      $145 = ($144<<16>>16)==(0); //@line 136023 "c/sqlite3.c"
      if ($145) {
       $$4151$ph = $spec$select;
      } else {
       HEAP32[$56>>2] = 0; //@line 136029 "c/sqlite3.c"
       $146 = HEAP32[$63>>2]|0; //@line 136030 "c/sqlite3.c"
       $147 = $146 & -2; //@line 136030 "c/sqlite3.c"
       HEAP32[$63>>2] = $147; //@line 136030 "c/sqlite3.c"
       HEAP32[$8>>2] = 1; //@line 136031 "c/sqlite3.c"
       $$4151$ph = $spec$select;
      }
     } else {
      $$4151$ph = $$0147158;
     }
     $150 = (($$2144159) + 1)|0; //@line 135997 "c/sqlite3.c"
     $151 = ((($$1141160)) + 12|0); //@line 135997 "c/sqlite3.c"
     $152 = ($150|0)<($22|0); //@line 135997 "c/sqlite3.c"
     if ($152) {
      $$0147158 = $$4151$ph;$$1141160 = $151;$$2144159 = $150;
     } else {
      $$0147$lcssa = $$4151$ph;$155 = $88;$161 = $87;$173 = $87;
      break L13;
     }
    }
    $148 = HEAP32[$76>>2]|0; //@line 136009 "c/sqlite3.c"
    $149 = HEAP32[$148>>2]|0; //@line 136009 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $149; //@line 136009 "c/sqlite3.c"
    _sqlite3ErrorMsg($16,27729,$vararg_buffer); //@line 136009 "c/sqlite3.c"
    $$4 = 1;
    STACKTOP = sp;return ($$4|0); //@line 136066 "c/sqlite3.c"
   } else {
    $$0147$lcssa = -1;$155 = $88;$161 = $87;$173 = $87;
   }
  } else {
   $81 = ((($14)) + 24|0); //@line 135995 "c/sqlite3.c"
   $82 = ((($14)) + 30|0); //@line 135995 "c/sqlite3.c"
   HEAP16[$82>>1] = 0; //@line 135995 "c/sqlite3.c"
   $$0147$lcssa = -1;$155 = $82;$161 = $81;$173 = $81;
  }
 } while(0);
 $153 = $7 ^ -1; //@line 136035 "c/sqlite3.c"
 $154 = HEAP16[$155>>1]|0; //@line 136035 "c/sqlite3.c"
 $156 = $154 & $153; //@line 136035 "c/sqlite3.c"
 HEAP16[$155>>1] = $156; //@line 136035 "c/sqlite3.c"
 $157 = (($$0147$lcssa) + 1)|0; //@line 136037 "c/sqlite3.c"
 $158 = $157&65535; //@line 136037 "c/sqlite3.c"
 $159 = ((($14)) + 40|0); //@line 136037 "c/sqlite3.c"
 HEAP16[$159>>1] = $158; //@line 136037 "c/sqlite3.c"
 $160 = HEAP32[$55>>2]|0; //@line 136039 "c/sqlite3.c"
 HEAP32[$161>>2] = $160; //@line 136039 "c/sqlite3.c"
 $162 = ((($6)) + 28|0); //@line 136040 "c/sqlite3.c"
 $163 = HEAP32[$162>>2]|0; //@line 136040 "c/sqlite3.c"
 $164 = $163&255; //@line 136040 "c/sqlite3.c"
 $165 = ((($14)) + 28|0); //@line 136040 "c/sqlite3.c"
 HEAP8[$165>>0] = $164; //@line 136040 "c/sqlite3.c"
 HEAP32[$162>>2] = 0; //@line 136041 "c/sqlite3.c"
 $166 = HEAP32[$54>>2]|0; //@line 136042 "c/sqlite3.c"
 $167 = ((($14)) + 32|0); //@line 136042 "c/sqlite3.c"
 HEAP32[$167>>2] = $166; //@line 136042 "c/sqlite3.c"
 $168 = HEAP32[$56>>2]|0; //@line 136043 "c/sqlite3.c"
 $169 = ($168|0)==(0); //@line 136043 "c/sqlite3.c"
 if ($169) {
  $174 = 0;
 } else {
  $170 = ((($6)) + 8|0); //@line 136044 "c/sqlite3.c"
  $171 = HEAP32[$170>>2]|0; //@line 136044 "c/sqlite3.c"
  $phitmp = $171&255; //@line 136043 "c/sqlite3.c"
  $174 = $phitmp;
 }
 $172 = ((($173)) + 5|0); //@line 136043 "c/sqlite3.c"
 HEAP8[$172>>0] = $174; //@line 136043 "c/sqlite3.c"
 $175 = ((($14)) + 18|0); //@line 136045 "c/sqlite3.c"
 HEAP16[$175>>1] = 0; //@line 136045 "c/sqlite3.c"
 $176 = +HEAPF64[$57>>3]; //@line 136046 "c/sqlite3.c"
 $177 = (_sqlite3LogEstFromDouble($176)|0); //@line 136046 "c/sqlite3.c"
 $178 = ((($14)) + 20|0); //@line 136046 "c/sqlite3.c"
 HEAP16[$178>>1] = $177; //@line 136046 "c/sqlite3.c"
 $179 = $58; //@line 136047 "c/sqlite3.c"
 $180 = $179; //@line 136047 "c/sqlite3.c"
 $181 = HEAP32[$180>>2]|0; //@line 136047 "c/sqlite3.c"
 $182 = (($179) + 4)|0; //@line 136047 "c/sqlite3.c"
 $183 = $182; //@line 136047 "c/sqlite3.c"
 $184 = HEAP32[$183>>2]|0; //@line 136047 "c/sqlite3.c"
 $185 = (_sqlite3LogEst($181,$184)|0); //@line 136047 "c/sqlite3.c"
 $186 = ((($14)) + 22|0); //@line 136047 "c/sqlite3.c"
 HEAP16[$186>>1] = $185; //@line 136047 "c/sqlite3.c"
 $187 = HEAP32[$63>>2]|0; //@line 136051 "c/sqlite3.c"
 $188 = $187 & 1; //@line 136051 "c/sqlite3.c"
 $189 = ($188|0)==(0); //@line 136051 "c/sqlite3.c"
 $190 = ((($14)) + 36|0);
 $191 = HEAP32[$190>>2]|0;
 $192 = $191 & -4097; //@line 136054 "c/sqlite3.c"
 $193 = $191 | 4096; //@line 136052 "c/sqlite3.c"
 $storemerge = $189 ? $192 : $193; //@line 136051 "c/sqlite3.c"
 HEAP32[$190>>2] = $storemerge;
 $194 = (_whereLoopInsert($0,$14)|0); //@line 136056 "c/sqlite3.c"
 $195 = HEAP8[$165>>0]|0; //@line 136057 "c/sqlite3.c"
 $196 = ($195<<24>>24)==(0); //@line 136057 "c/sqlite3.c"
 if ($196) {
  $$4 = $194;
  STACKTOP = sp;return ($$4|0); //@line 136066 "c/sqlite3.c"
 }
 $197 = HEAP32[$167>>2]|0; //@line 136058 "c/sqlite3.c"
 _sqlite3_free($197); //@line 136058 "c/sqlite3.c"
 HEAP8[$165>>0] = 0; //@line 136059 "c/sqlite3.c"
 $$4 = $194;
 STACKTOP = sp;return ($$4|0); //@line 136066 "c/sqlite3.c"
}
function _vtabBestIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 133916 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 133916 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 133917 "c/sqlite3.c"
 $4 = (_sqlite3GetVTable($3,$1)|0); //@line 133917 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 133917 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 133917 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 133921 "c/sqlite3.c"
 $8 = ((($7)) + 12|0); //@line 133921 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 133921 "c/sqlite3.c"
 $10 = (FUNCTION_TABLE_iii[$9 & 255]($6,$2)|0); //@line 133921 "c/sqlite3.c"
 L1: do {
  switch ($10|0) {
  case 0:  {
   break;
  }
  case 7:  {
   $11 = HEAP32[$0>>2]|0; //@line 133926 "c/sqlite3.c"
   _sqlite3OomFault($11); //@line 133926 "c/sqlite3.c"
   break;
  }
  default: {
   $12 = ((($6)) + 8|0); //@line 133927 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 133927 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 133927 "c/sqlite3.c"
   if ($14) {
    $15 = (_sqlite3ErrStr($10)|0); //@line 133928 "c/sqlite3.c"
    HEAP32[$vararg_buffer>>2] = $15; //@line 133928 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,15687,$vararg_buffer); //@line 133928 "c/sqlite3.c"
    break L1;
   } else {
    HEAP32[$vararg_buffer1>>2] = $13; //@line 133930 "c/sqlite3.c"
    _sqlite3ErrorMsg($0,15687,$vararg_buffer1); //@line 133930 "c/sqlite3.c"
    break L1;
   }
  }
  }
 } while(0);
 $16 = ((($6)) + 8|0); //@line 133933 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 133933 "c/sqlite3.c"
 _sqlite3_free($17); //@line 133933 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 133934 "c/sqlite3.c"
 $18 = ((($0)) + 36|0); //@line 133947 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 133947 "c/sqlite3.c"
 STACKTOP = sp;return ($19|0); //@line 133947 "c/sqlite3.c"
}
function _sqlite3LogEstFromDouble($0) {
 $0 = +$0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = !($0 <= 1.0); //@line 29946 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 29951 "c/sqlite3.c"
 }
 $4 = !($0 <= 2.0E+9); //@line 29947 "c/sqlite3.c"
 if ($4) {
  $8 = (_bitshift64Lshr(($1|0),($2|0),52)|0); //@line 29949 "c/sqlite3.c"
  $9 = tempRet0; //@line 29949 "c/sqlite3.c"
  $10 = ($8*10)|0; //@line 29950 "c/sqlite3.c"
  $11 = (($10) + 55316)|0; //@line 29950 "c/sqlite3.c"
  $12 = $11&65535; //@line 29950 "c/sqlite3.c"
  $$0 = $12;
  return ($$0|0); //@line 29951 "c/sqlite3.c"
 } else {
  $5 = (~~$0)>>>0; //@line 29947 "c/sqlite3.c"
  $6 = +Math_abs($0) >= 1.0 ? $0 > 0.0 ? (~~+Math_min(+Math_floor($0 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($0 - +(~~$0 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 29947 "c/sqlite3.c"
  $7 = (_sqlite3LogEst($5,$6)|0); //@line 29947 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 29951 "c/sqlite3.c"
 }
 return (0)|0;
}
function _findIndexCol($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$03134 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($3)) + 32|0); //@line 133321 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 133321 "c/sqlite3.c"
 $7 = (($6) + ($4<<2)|0); //@line 133321 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 133321 "c/sqlite3.c"
 $9 = HEAP32[$1>>2]|0; //@line 133323 "c/sqlite3.c"
 $10 = ($9|0)>(0); //@line 133323 "c/sqlite3.c"
 if (!($10)) {
  $$4 = -1;
  return ($$4|0); //@line 133337 "c/sqlite3.c"
 }
 $11 = ((($3)) + 4|0);
 $$03134 = 0;
 while(1) {
  $12 = (((($1)) + 4|0) + (($$03134*20)|0)|0); //@line 133324 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 133324 "c/sqlite3.c"
  $14 = (_sqlite3ExprSkipCollate($13)|0); //@line 133324 "c/sqlite3.c"
  $15 = HEAP8[$14>>0]|0; //@line 133325 "c/sqlite3.c"
  $16 = ($15<<24>>24)==(-111); //@line 133325 "c/sqlite3.c"
  if ($16) {
   $17 = ((($14)) + 32|0); //@line 133326 "c/sqlite3.c"
   $18 = HEAP16[$17>>1]|0; //@line 133326 "c/sqlite3.c"
   $19 = HEAP32[$11>>2]|0; //@line 133326 "c/sqlite3.c"
   $20 = (($19) + ($4<<1)|0); //@line 133326 "c/sqlite3.c"
   $21 = HEAP16[$20>>1]|0; //@line 133326 "c/sqlite3.c"
   $22 = ($18<<16>>16)==($21<<16>>16); //@line 133326 "c/sqlite3.c"
   if ($22) {
    $23 = ((($14)) + 28|0); //@line 133327 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 133327 "c/sqlite3.c"
    $25 = ($24|0)==($2|0); //@line 133327 "c/sqlite3.c"
    if ($25) {
     $26 = (_sqlite3ExprNNCollSeq($0,$13)|0); //@line 133329 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 133330 "c/sqlite3.c"
     $28 = (_sqlite3StrICmp($27,$8)|0); //@line 133330 "c/sqlite3.c"
     $29 = ($28|0)==(0); //@line 133330 "c/sqlite3.c"
     if ($29) {
      $$4 = $$03134;
      label = 8;
      break;
     }
    }
   }
  }
  $30 = (($$03134) + 1)|0; //@line 133323 "c/sqlite3.c"
  $31 = HEAP32[$1>>2]|0; //@line 133323 "c/sqlite3.c"
  $32 = ($30|0)<($31|0); //@line 133323 "c/sqlite3.c"
  if ($32) {
   $$03134 = $30;
  } else {
   $$4 = -1;
   label = 8;
   break;
  }
 }
 if ((label|0) == 8) {
  return ($$4|0); //@line 133337 "c/sqlite3.c"
 }
 return (0)|0;
}
function _exprNodeIsDeterministic($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$lobit = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 137266 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(-112); //@line 137266 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 137271 "c/sqlite3.c"
 }
 $4 = ((($1)) + 4|0); //@line 137266 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 137266 "c/sqlite3.c"
 $$lobit = $5 & 524288; //@line 137266 "c/sqlite3.c"
 $6 = ($$lobit|0)==(0); //@line 137266 "c/sqlite3.c"
 if (!($6)) {
  $$0 = 0;
  return ($$0|0); //@line 137271 "c/sqlite3.c"
 }
 $7 = ((($0)) + 20|0); //@line 137267 "c/sqlite3.c"
 HEAP8[$7>>0] = 0; //@line 137267 "c/sqlite3.c"
 $$0 = 2;
 return ($$0|0); //@line 137271 "c/sqlite3.c"
}
function _exprAnalyze($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0378415 = 0, $$0385 = 0, $$0386416 = 0, $$0389 = 0, $$0394422 = 0, $$0395 = 0, $$1 = 0, $$11$ph$ph = 0, $$11411 = 0, $$1388 = 0, $$2392 = 0, $$4$ph = 0, $$6 = 0, $$7$ph = 0, $$8$lcssa = 0, $$8418 = 0, $$9 = 0, $$in = 0, $$pr = 0, $$pr406 = 0;
 var $$pr409$pr = 0, $$pr413 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0;
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0;
 var $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0;
 var $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0;
 var $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0;
 var $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0;
 var $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0;
 var $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0;
 var $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0;
 var $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0;
 var $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0;
 var $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0;
 var $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0;
 var $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0;
 var $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0;
 var $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0;
 var $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0;
 var $405 = 0, $406 = 0, $407 = 0, $408 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $or$cond = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 24|0;
 $4 = sp + 20|0;
 $5 = sp + 16|0;
 $6 = sp + 28|0;
 $7 = sp + 8|0;
 $8 = sp + 4|0;
 $9 = HEAP32[$1>>2]|0; //@line 132349 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 132356 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 132357 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 132358 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 132360 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 132361 "c/sqlite3.c"
 HEAP8[$6>>0] = 0; //@line 132362 "c/sqlite3.c"
 $12 = ((($11)) + 73|0); //@line 132365 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 132365 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 132365 "c/sqlite3.c"
 if (!($14)) {
  STACKTOP = sp;return; //@line 132737 "c/sqlite3.c"
 }
 $15 = ((($1)) + 20|0); //@line 132368 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 132368 "c/sqlite3.c"
 $17 = (($16) + (($2*48)|0)|0); //@line 132368 "c/sqlite3.c"
 $18 = ((($9)) + 488|0); //@line 132369 "c/sqlite3.c"
 $19 = HEAP32[$17>>2]|0; //@line 132370 "c/sqlite3.c"
 $20 = ((($19)) + 12|0); //@line 132372 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 132372 "c/sqlite3.c"
 $22 = (_sqlite3WhereExprUsage($18,$21)|0); //@line 132372 "c/sqlite3.c"
 $23 = tempRet0; //@line 132372 "c/sqlite3.c"
 $24 = HEAP8[$19>>0]|0; //@line 132373 "c/sqlite3.c"
 $25 = $24&255; //@line 132373 "c/sqlite3.c"
 L4: do {
  switch ($24<<24>>24) {
  case 49:  {
   $26 = (_sqlite3ExprCheckIN($10,$19)|0); //@line 132376 "c/sqlite3.c"
   $27 = ($26|0)==(0); //@line 132376 "c/sqlite3.c"
   if (!($27)) {
    STACKTOP = sp;return; //@line 132737 "c/sqlite3.c"
   }
   $28 = ((($19)) + 4|0); //@line 132377 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 132377 "c/sqlite3.c"
   $30 = $29 & 2048; //@line 132377 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 132377 "c/sqlite3.c"
   $32 = ((($19)) + 20|0);
   if ($31) {
    $36 = HEAP32[$32>>2]|0; //@line 132380 "c/sqlite3.c"
    $37 = (_sqlite3WhereExprListUsage($18,$36)|0); //@line 132380 "c/sqlite3.c"
    $38 = tempRet0; //@line 132380 "c/sqlite3.c"
    $46 = $37;$49 = $38;
    break L4;
   } else {
    $33 = HEAP32[$32>>2]|0; //@line 132378 "c/sqlite3.c"
    $34 = (_exprSelectUsage($18,$33)|0); //@line 132378 "c/sqlite3.c"
    $35 = tempRet0; //@line 132378 "c/sqlite3.c"
    $46 = $34;$49 = $35;
    break L4;
   }
   break;
  }
  case 50:  {
   $46 = 0;$49 = 0;
   break;
  }
  default: {
   $39 = ((($19)) + 16|0); //@line 132385 "c/sqlite3.c"
   $40 = HEAP32[$39>>2]|0; //@line 132385 "c/sqlite3.c"
   $41 = (_sqlite3WhereExprUsage($18,$40)|0); //@line 132385 "c/sqlite3.c"
   $42 = tempRet0; //@line 132385 "c/sqlite3.c"
   $46 = $41;$49 = $42;
  }
  }
 } while(0);
 $43 = (((($16) + (($2*48)|0)|0)) + 32|0);
 $44 = $43;
 $45 = $44;
 HEAP32[$45>>2] = $46;
 $47 = (($44) + 4)|0;
 $48 = $47;
 HEAP32[$48>>2] = $49;
 HEAP32[$18>>2] = 0; //@line 132387 "c/sqlite3.c"
 $50 = (_sqlite3WhereExprUsage($18,$19)|0); //@line 132388 "c/sqlite3.c"
 $51 = tempRet0; //@line 132388 "c/sqlite3.c"
 $52 = HEAP32[$18>>2]|0; //@line 132389 "c/sqlite3.c"
 $53 = ($52|0)==(0); //@line 132389 "c/sqlite3.c"
 $54 = (((($16) + (($2*48)|0)|0)) + 10|0); //@line 132389 "c/sqlite3.c"
 if (!($53)) {
  $55 = HEAP16[$54>>1]|0; //@line 132389 "c/sqlite3.c"
  $56 = $55 | 4096; //@line 132389 "c/sqlite3.c"
  HEAP16[$54>>1] = $56; //@line 132389 "c/sqlite3.c"
 }
 $57 = ((($19)) + 4|0); //@line 132390 "c/sqlite3.c"
 $58 = HEAP32[$57>>2]|0; //@line 132390 "c/sqlite3.c"
 $59 = $58 & 1; //@line 132390 "c/sqlite3.c"
 $60 = ($59|0)==(0); //@line 132390 "c/sqlite3.c"
 if ($60) {
  $164 = 0;$166 = 0;$80 = $50;$83 = $51;
 } else {
  $61 = ((($19)) + 36|0); //@line 132391 "c/sqlite3.c"
  $62 = HEAP16[$61>>1]|0; //@line 132391 "c/sqlite3.c"
  $63 = $62 << 16 >> 16; //@line 132391 "c/sqlite3.c"
  $64 = (_sqlite3WhereGetMask($18,$63)|0); //@line 132391 "c/sqlite3.c"
  $65 = tempRet0; //@line 132391 "c/sqlite3.c"
  $66 = $64 | $50; //@line 132392 "c/sqlite3.c"
  $67 = $65 | $51; //@line 132392 "c/sqlite3.c"
  $68 = (_i64Add(($64|0),($65|0),-1,-1)|0); //@line 132393 "c/sqlite3.c"
  $69 = tempRet0; //@line 132393 "c/sqlite3.c"
  $70 = (_bitshift64Lshr(($66|0),($67|0),1)|0); //@line 132395 "c/sqlite3.c"
  $71 = tempRet0; //@line 132395 "c/sqlite3.c"
  $72 = ($71>>>0)<($65>>>0); //@line 132395 "c/sqlite3.c"
  $73 = ($70>>>0)<($64>>>0); //@line 132395 "c/sqlite3.c"
  $74 = ($71|0)==($65|0); //@line 132395 "c/sqlite3.c"
  $75 = $74 & $73; //@line 132395 "c/sqlite3.c"
  $76 = $72 | $75; //@line 132395 "c/sqlite3.c"
  if ($76) {
   $164 = $68;$166 = $69;$80 = $66;$83 = $67;
  } else {
   _sqlite3ErrorMsg($10,27755,$vararg_buffer); //@line 132396 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 132737 "c/sqlite3.c"
  }
 }
 $77 = (((($16) + (($2*48)|0)|0)) + 40|0); //@line 132400 "c/sqlite3.c"
 $78 = $77; //@line 132400 "c/sqlite3.c"
 $79 = $78; //@line 132400 "c/sqlite3.c"
 HEAP32[$79>>2] = $80; //@line 132400 "c/sqlite3.c"
 $81 = (($78) + 4)|0; //@line 132400 "c/sqlite3.c"
 $82 = $81; //@line 132400 "c/sqlite3.c"
 HEAP32[$82>>2] = $83; //@line 132400 "c/sqlite3.c"
 $84 = (((($16) + (($2*48)|0)|0)) + 20|0); //@line 132401 "c/sqlite3.c"
 HEAP32[$84>>2] = -1; //@line 132401 "c/sqlite3.c"
 $85 = (((($16) + (($2*48)|0)|0)) + 16|0); //@line 132402 "c/sqlite3.c"
 HEAP32[$85>>2] = -1; //@line 132402 "c/sqlite3.c"
 $86 = (((($16) + (($2*48)|0)|0)) + 12|0); //@line 132403 "c/sqlite3.c"
 HEAP16[$86>>1] = 0; //@line 132403 "c/sqlite3.c"
 $87 = (_allowedOp($25)|0); //@line 132404 "c/sqlite3.c"
 $88 = ($87|0)==(0); //@line 132404 "c/sqlite3.c"
 L22: do {
  if ($88) {
   $186 = HEAP8[$19>>0]|0; //@line 132478 "c/sqlite3.c"
   switch ($186<<24>>24) {
   case 48:  {
    break;
   }
   case 43:  {
    _exprAnalyzeOrTerm($0,$1,$2); //@line 132506 "c/sqlite3.c"
    $208 = HEAP32[$15>>2]|0; //@line 132507 "c/sqlite3.c"
    $209 = (($208) + (($2*48)|0)|0); //@line 132507 "c/sqlite3.c"
    $$6 = $209;
    break L22;
    break;
   }
   default: {
    $$6 = $17;
    break L22;
   }
   }
   $187 = ((($1)) + 8|0); //@line 132478 "c/sqlite3.c"
   $188 = HEAP8[$187>>0]|0; //@line 132478 "c/sqlite3.c"
   $189 = ($188<<24>>24)==(44); //@line 132478 "c/sqlite3.c"
   if ($189) {
    $190 = ((($19)) + 20|0); //@line 132479 "c/sqlite3.c"
    $191 = HEAP32[$190>>2]|0; //@line 132479 "c/sqlite3.c"
    $192 = HEAP32[$20>>2]|0; //@line 132488 "c/sqlite3.c"
    $193 = (_sqlite3ExprDup($11,$192,0)|0); //@line 132488 "c/sqlite3.c"
    $194 = ((($191)) + 4|0); //@line 132489 "c/sqlite3.c"
    $195 = HEAP32[$194>>2]|0; //@line 132489 "c/sqlite3.c"
    $196 = (_sqlite3ExprDup($11,$195,0)|0); //@line 132489 "c/sqlite3.c"
    $197 = (_sqlite3PExpr($10,57,$193,$196)|0); //@line 132487 "c/sqlite3.c"
    _transferJoinMarkings($197,$19); //@line 132490 "c/sqlite3.c"
    $198 = (_whereClauseInsert($1,$197,3)|0); //@line 132491 "c/sqlite3.c"
    _exprAnalyze($0,$1,$198); //@line 132493 "c/sqlite3.c"
    _markTermAsChild($1,$198,$2); //@line 132495 "c/sqlite3.c"
    $199 = HEAP32[$20>>2]|0; //@line 132488 "c/sqlite3.c"
    $200 = (_sqlite3ExprDup($11,$199,0)|0); //@line 132488 "c/sqlite3.c"
    $201 = ((($191)) + 24|0); //@line 132489 "c/sqlite3.c"
    $202 = HEAP32[$201>>2]|0; //@line 132489 "c/sqlite3.c"
    $203 = (_sqlite3ExprDup($11,$202,0)|0); //@line 132489 "c/sqlite3.c"
    $204 = (_sqlite3PExpr($10,55,$200,$203)|0); //@line 132487 "c/sqlite3.c"
    _transferJoinMarkings($204,$19); //@line 132490 "c/sqlite3.c"
    $205 = (_whereClauseInsert($1,$204,3)|0); //@line 132491 "c/sqlite3.c"
    _exprAnalyze($0,$1,$205); //@line 132493 "c/sqlite3.c"
    $206 = HEAP32[$15>>2]|0; //@line 132494 "c/sqlite3.c"
    _markTermAsChild($1,$205,$2); //@line 132495 "c/sqlite3.c"
    $207 = (($206) + (($2*48)|0)|0); //@line 132494 "c/sqlite3.c"
    $$6 = $207;
   } else {
    $$6 = $17;
   }
  } else {
   $89 = HEAP32[$20>>2]|0; //@line 132406 "c/sqlite3.c"
   $90 = (_sqlite3ExprSkipCollate($89)|0); //@line 132406 "c/sqlite3.c"
   $91 = ((($19)) + 16|0); //@line 132407 "c/sqlite3.c"
   $92 = HEAP32[$91>>2]|0; //@line 132407 "c/sqlite3.c"
   $93 = (_sqlite3ExprSkipCollate($92)|0); //@line 132407 "c/sqlite3.c"
   $94 = (((($16) + (($2*48)|0)|0)) + 32|0); //@line 132408 "c/sqlite3.c"
   $95 = $94; //@line 132408 "c/sqlite3.c"
   $96 = $95; //@line 132408 "c/sqlite3.c"
   $97 = HEAP32[$96>>2]|0; //@line 132408 "c/sqlite3.c"
   $98 = (($95) + 4)|0; //@line 132408 "c/sqlite3.c"
   $99 = $98; //@line 132408 "c/sqlite3.c"
   $100 = HEAP32[$99>>2]|0; //@line 132408 "c/sqlite3.c"
   $101 = $97 & $22; //@line 132408 "c/sqlite3.c"
   $102 = $100 & $23; //@line 132408 "c/sqlite3.c"
   $103 = ($101|0)==(0); //@line 132408 "c/sqlite3.c"
   $104 = ($102|0)==(0); //@line 132408 "c/sqlite3.c"
   $105 = $103 & $104; //@line 132408 "c/sqlite3.c"
   $106 = $105 ? 8191 : 2048; //@line 132408 "c/sqlite3.c"
   $107 = (((($16) + (($2*48)|0)|0)) + 24|0); //@line 132410 "c/sqlite3.c"
   $108 = HEAP32[$107>>2]|0; //@line 132410 "c/sqlite3.c"
   $109 = ($108|0)>(0); //@line 132410 "c/sqlite3.c"
   if ($109) {
    $110 = (($108) + -1)|0; //@line 132413 "c/sqlite3.c"
    $111 = ((($90)) + 20|0); //@line 132413 "c/sqlite3.c"
    $112 = HEAP32[$111>>2]|0; //@line 132413 "c/sqlite3.c"
    $113 = (((($112)) + 4|0) + (($110*20)|0)|0); //@line 132413 "c/sqlite3.c"
    $114 = HEAP32[$113>>2]|0; //@line 132413 "c/sqlite3.c"
    $$0385 = $114;
   } else {
    $$0385 = $90;
   }
   $115 = (_exprMightBeIndexed($0,$22,$23,$7,$$0385,$25)|0); //@line 132416 "c/sqlite3.c"
   $116 = ($115|0)==(0); //@line 132416 "c/sqlite3.c"
   if (!($116)) {
    $117 = HEAP32[$7>>2]|0; //@line 132417 "c/sqlite3.c"
    HEAP32[$84>>2] = $117; //@line 132417 "c/sqlite3.c"
    $118 = ((($7)) + 4|0); //@line 132418 "c/sqlite3.c"
    $119 = HEAP32[$118>>2]|0; //@line 132418 "c/sqlite3.c"
    $120 = (((($16) + (($2*48)|0)|0)) + 28|0); //@line 132418 "c/sqlite3.c"
    HEAP32[$120>>2] = $119; //@line 132418 "c/sqlite3.c"
    $121 = (_operatorMask($25)|0); //@line 132419 "c/sqlite3.c"
    $122 = $121 & $106; //@line 132419 "c/sqlite3.c"
    HEAP16[$86>>1] = $122; //@line 132419 "c/sqlite3.c"
   }
   $123 = ($24<<24>>24)==(45); //@line 132421 "c/sqlite3.c"
   $124 = (((($16) + (($2*48)|0)|0)) + 10|0); //@line 132421 "c/sqlite3.c"
   if ($123) {
    $125 = HEAP16[$124>>1]|0; //@line 132421 "c/sqlite3.c"
    $126 = $125 | 2048; //@line 132421 "c/sqlite3.c"
    HEAP16[$124>>1] = $126; //@line 132421 "c/sqlite3.c"
   }
   $127 = ($93|0)==(0|0); //@line 132422 "c/sqlite3.c"
   if ($127) {
    $$4$ph = $17;
   } else {
    $128 = $94; //@line 132423 "c/sqlite3.c"
    $129 = $128; //@line 132423 "c/sqlite3.c"
    $130 = HEAP32[$129>>2]|0; //@line 132423 "c/sqlite3.c"
    $131 = (($128) + 4)|0; //@line 132423 "c/sqlite3.c"
    $132 = $131; //@line 132423 "c/sqlite3.c"
    $133 = HEAP32[$132>>2]|0; //@line 132423 "c/sqlite3.c"
    $134 = (_exprMightBeIndexed($0,$130,$133,$7,$93,$25)|0); //@line 132423 "c/sqlite3.c"
    $135 = ($134|0)==(0); //@line 132423 "c/sqlite3.c"
    if ($135) {
     $$4$ph = $17;
    } else {
     $136 = HEAP32[$84>>2]|0; //@line 132429 "c/sqlite3.c"
     $137 = ($136|0)>(-1); //@line 132429 "c/sqlite3.c"
     do {
      if ($137) {
       $138 = (_sqlite3ExprDup($11,$19,0)|0); //@line 132431 "c/sqlite3.c"
       $139 = HEAP8[$12>>0]|0; //@line 132432 "c/sqlite3.c"
       $140 = ($139<<24>>24)==(0); //@line 132432 "c/sqlite3.c"
       if ($140) {
        $141 = (_whereClauseInsert($1,$138,3)|0); //@line 132436 "c/sqlite3.c"
        $142 = ($141|0)==(0); //@line 132437 "c/sqlite3.c"
        if (!($142)) {
         $143 = HEAP32[$15>>2]|0; //@line 132438 "c/sqlite3.c"
         $144 = (($143) + (($141*48)|0)|0); //@line 132438 "c/sqlite3.c"
         _markTermAsChild($1,$141,$2); //@line 132439 "c/sqlite3.c"
         $145 = (((($143) + (($141*48)|0)|0)) + 10|0); //@line 132440 "c/sqlite3.c"
         if ($123) {
          $146 = HEAP16[$145>>1]|0; //@line 132440 "c/sqlite3.c"
          $147 = $146 | 2048; //@line 132440 "c/sqlite3.c"
          HEAP16[$145>>1] = $147; //@line 132440 "c/sqlite3.c"
         }
         $148 = HEAP32[$15>>2]|0; //@line 132441 "c/sqlite3.c"
         $149 = (($148) + (($2*48)|0)|0); //@line 132441 "c/sqlite3.c"
         $150 = (((($148) + (($2*48)|0)|0)) + 10|0); //@line 132442 "c/sqlite3.c"
         $151 = HEAP16[$150>>1]|0; //@line 132442 "c/sqlite3.c"
         $152 = $151 | 8; //@line 132442 "c/sqlite3.c"
         HEAP16[$150>>1] = $152; //@line 132442 "c/sqlite3.c"
         $153 = (_termIsEquivalence($10,$138)|0); //@line 132444 "c/sqlite3.c"
         $154 = ($153|0)==(0); //@line 132444 "c/sqlite3.c"
         $155 = (((($148) + (($2*48)|0)|0)) + 12|0); //@line 132445 "c/sqlite3.c"
         if ($154) {
          $$0389 = $138;$$1 = $149;$$1388 = $144;$$2392 = 0;
          break;
         }
         $156 = HEAP16[$155>>1]|0; //@line 132445 "c/sqlite3.c"
         $157 = $156 | 2048; //@line 132445 "c/sqlite3.c"
         HEAP16[$155>>1] = $157; //@line 132445 "c/sqlite3.c"
         $$0389 = $138;$$1 = $149;$$1388 = $144;$$2392 = 2048;
         break;
        }
       } else {
        _sqlite3ExprDelete($11,$138); //@line 132433 "c/sqlite3.c"
       }
       STACKTOP = sp;return; //@line 132737 "c/sqlite3.c"
      } else {
       $$0389 = $19;$$1 = $17;$$1388 = $17;$$2392 = 0;
      }
     } while(0);
     _exprCommute($10,$$0389); //@line 132452 "c/sqlite3.c"
     $158 = HEAP32[$7>>2]|0; //@line 132453 "c/sqlite3.c"
     $159 = ((($$1388)) + 20|0); //@line 132453 "c/sqlite3.c"
     HEAP32[$159>>2] = $158; //@line 132453 "c/sqlite3.c"
     $160 = ((($7)) + 4|0); //@line 132454 "c/sqlite3.c"
     $161 = HEAP32[$160>>2]|0; //@line 132454 "c/sqlite3.c"
     $162 = ((($$1388)) + 28|0); //@line 132454 "c/sqlite3.c"
     HEAP32[$162>>2] = $161; //@line 132454 "c/sqlite3.c"
     $163 = $164 | $22; //@line 132456 "c/sqlite3.c"
     $165 = $166 | $23; //@line 132456 "c/sqlite3.c"
     $167 = ((($$1388)) + 32|0); //@line 132456 "c/sqlite3.c"
     $168 = $167; //@line 132456 "c/sqlite3.c"
     $169 = $168; //@line 132456 "c/sqlite3.c"
     HEAP32[$169>>2] = $163; //@line 132456 "c/sqlite3.c"
     $170 = (($168) + 4)|0; //@line 132456 "c/sqlite3.c"
     $171 = $170; //@line 132456 "c/sqlite3.c"
     HEAP32[$171>>2] = $165; //@line 132456 "c/sqlite3.c"
     $172 = ((($$1388)) + 40|0); //@line 132457 "c/sqlite3.c"
     $173 = $172; //@line 132457 "c/sqlite3.c"
     $174 = $173; //@line 132457 "c/sqlite3.c"
     HEAP32[$174>>2] = $80; //@line 132457 "c/sqlite3.c"
     $175 = (($173) + 4)|0; //@line 132457 "c/sqlite3.c"
     $176 = $175; //@line 132457 "c/sqlite3.c"
     HEAP32[$176>>2] = $83; //@line 132457 "c/sqlite3.c"
     $177 = HEAP8[$$0389>>0]|0; //@line 132458 "c/sqlite3.c"
     $178 = $177&255; //@line 132458 "c/sqlite3.c"
     $179 = (_operatorMask($178)|0); //@line 132458 "c/sqlite3.c"
     $180 = $179&65535; //@line 132458 "c/sqlite3.c"
     $181 = (($$2392) + ($180))|0; //@line 132458 "c/sqlite3.c"
     $182 = $106&65535; //@line 132458 "c/sqlite3.c"
     $183 = $181 & $182; //@line 132458 "c/sqlite3.c"
     $184 = $183&65535; //@line 132458 "c/sqlite3.c"
     $185 = ((($$1388)) + 12|0); //@line 132458 "c/sqlite3.c"
     HEAP16[$185>>1] = $184; //@line 132458 "c/sqlite3.c"
     $$4$ph = $$1;
    }
   }
   $$6 = $$4$ph;
  }
 } while(0);
 $210 = ((($1)) + 8|0); //@line 132525 "c/sqlite3.c"
 $211 = HEAP8[$210>>0]|0; //@line 132525 "c/sqlite3.c"
 $212 = ($211<<24>>24)==(44); //@line 132525 "c/sqlite3.c"
 L56: do {
  if ($212) {
   $213 = (_isLikeOrGlob($10,$19,$3,$4,$5)|0); //@line 132526 "c/sqlite3.c"
   $214 = ($213|0)==(0); //@line 132526 "c/sqlite3.c"
   if ($214) {
    $$7$ph = $$6;
   } else {
    $215 = ((($19)) + 20|0); //@line 132537 "c/sqlite3.c"
    $216 = HEAP32[$215>>2]|0; //@line 132537 "c/sqlite3.c"
    $217 = ((($216)) + 24|0); //@line 132537 "c/sqlite3.c"
    $218 = HEAP32[$217>>2]|0; //@line 132537 "c/sqlite3.c"
    $219 = HEAP32[$3>>2]|0; //@line 132538 "c/sqlite3.c"
    $220 = (_sqlite3ExprDup($11,$219,0)|0); //@line 132538 "c/sqlite3.c"
    $221 = HEAP32[$5>>2]|0; //@line 132544 "c/sqlite3.c"
    $222 = ($221|0)==(0); //@line 132544 "c/sqlite3.c"
    if (!($222)) {
     $223 = HEAP32[$10>>2]|0; //@line 132544 "c/sqlite3.c"
     $224 = ((($223)) + 73|0); //@line 132544 "c/sqlite3.c"
     $225 = HEAP8[$224>>0]|0; //@line 132544 "c/sqlite3.c"
     $226 = ($225<<24>>24)==(0); //@line 132544 "c/sqlite3.c"
     if ($226) {
      $227 = ((($$6)) + 10|0); //@line 132547 "c/sqlite3.c"
      $228 = HEAP16[$227>>1]|0; //@line 132547 "c/sqlite3.c"
      $229 = $228 | 1024; //@line 132547 "c/sqlite3.c"
      HEAP16[$227>>1] = $229; //@line 132547 "c/sqlite3.c"
      $230 = ((($219)) + 8|0); //@line 132548 "c/sqlite3.c"
      $231 = HEAP32[$230>>2]|0; //@line 132548 "c/sqlite3.c"
      $232 = HEAP8[$231>>0]|0; //@line 132548 "c/sqlite3.c"
      $233 = ($232<<24>>24)==(0); //@line 132548 "c/sqlite3.c"
      if (!($233)) {
       $234 = ((($220)) + 8|0);
       $$0394422 = 0;$236 = $232;$242 = $231;
       while(1) {
        $235 = $236&255; //@line 132549 "c/sqlite3.c"
        $237 = (16281 + ($235)|0); //@line 132549 "c/sqlite3.c"
        $238 = HEAP8[$237>>0]|0; //@line 132549 "c/sqlite3.c"
        $239 = $238 & 32; //@line 132549 "c/sqlite3.c"
        $240 = $239 ^ -1; //@line 132549 "c/sqlite3.c"
        $241 = $236 & $240; //@line 132549 "c/sqlite3.c"
        HEAP8[$242>>0] = $241; //@line 132549 "c/sqlite3.c"
        $243 = (16025 + ($235)|0); //@line 132550 "c/sqlite3.c"
        $244 = HEAP8[$243>>0]|0; //@line 132550 "c/sqlite3.c"
        $245 = HEAP32[$234>>2]|0; //@line 132550 "c/sqlite3.c"
        $246 = (($245) + ($$0394422)|0); //@line 132550 "c/sqlite3.c"
        HEAP8[$246>>0] = $244; //@line 132550 "c/sqlite3.c"
        $247 = (($$0394422) + 1)|0; //@line 132548 "c/sqlite3.c"
        $248 = HEAP32[$230>>2]|0; //@line 132548 "c/sqlite3.c"
        $249 = (($248) + ($247)|0); //@line 132548 "c/sqlite3.c"
        $250 = HEAP8[$249>>0]|0; //@line 132548 "c/sqlite3.c"
        $251 = ($250<<24>>24)==(0); //@line 132548 "c/sqlite3.c"
        if ($251) {
         break;
        } else {
         $$0394422 = $247;$236 = $250;$242 = $249;
        }
       }
      }
     }
    }
    $252 = HEAP8[$12>>0]|0; //@line 132554 "c/sqlite3.c"
    $253 = ($252<<24>>24)==(0); //@line 132554 "c/sqlite3.c"
    if ($253) {
     $254 = ((($220)) + 8|0); //@line 132556 "c/sqlite3.c"
     $255 = HEAP32[$254>>2]|0; //@line 132556 "c/sqlite3.c"
     $256 = (_sqlite3Strlen30($255)|0); //@line 132556 "c/sqlite3.c"
     $257 = (($256) + -1)|0; //@line 132556 "c/sqlite3.c"
     $258 = (($255) + ($257)|0); //@line 132556 "c/sqlite3.c"
     $259 = HEAP8[$258>>0]|0; //@line 132557 "c/sqlite3.c"
     if ($222) {
      $$0395 = $259;
     } else {
      $260 = $259&255; //@line 132565 "c/sqlite3.c"
      $261 = ($259<<24>>24)==(64); //@line 132565 "c/sqlite3.c"
      if ($261) {
       HEAP32[$4>>2] = 0; //@line 132565 "c/sqlite3.c"
      }
      $262 = (16025 + ($260)|0); //@line 132566 "c/sqlite3.c"
      $263 = HEAP8[$262>>0]|0; //@line 132566 "c/sqlite3.c"
      $$0395 = $263;
     }
     $264 = $$0395&255; //@line 132568 "c/sqlite3.c"
     $265 = (($264) + 1)|0; //@line 132568 "c/sqlite3.c"
     $266 = $265&255; //@line 132568 "c/sqlite3.c"
     HEAP8[$258>>0] = $266; //@line 132568 "c/sqlite3.c"
    }
    $267 = $222 ? 18038 : 27796; //@line 132570 "c/sqlite3.c"
    $268 = (_sqlite3ExprDup($11,$218,0)|0); //@line 132571 "c/sqlite3.c"
    $269 = (_sqlite3ExprAddCollateString($10,$268,$267)|0); //@line 132573 "c/sqlite3.c"
    $270 = (_sqlite3PExpr($10,57,$269,$219)|0); //@line 132572 "c/sqlite3.c"
    _transferJoinMarkings($270,$19); //@line 132575 "c/sqlite3.c"
    $271 = (_whereClauseInsert($1,$270,259)|0); //@line 132576 "c/sqlite3.c"
    _exprAnalyze($0,$1,$271); //@line 132578 "c/sqlite3.c"
    $272 = (_sqlite3ExprDup($11,$218,0)|0); //@line 132579 "c/sqlite3.c"
    $273 = (_sqlite3ExprAddCollateString($10,$272,$267)|0); //@line 132581 "c/sqlite3.c"
    $274 = (_sqlite3PExpr($10,56,$273,$220)|0); //@line 132580 "c/sqlite3.c"
    _transferJoinMarkings($274,$19); //@line 132583 "c/sqlite3.c"
    $275 = (_whereClauseInsert($1,$274,259)|0); //@line 132584 "c/sqlite3.c"
    _exprAnalyze($0,$1,$275); //@line 132586 "c/sqlite3.c"
    $276 = HEAP32[$15>>2]|0; //@line 132587 "c/sqlite3.c"
    $277 = (($276) + (($2*48)|0)|0); //@line 132587 "c/sqlite3.c"
    $278 = HEAP32[$4>>2]|0; //@line 132588 "c/sqlite3.c"
    $279 = ($278|0)==(0); //@line 132588 "c/sqlite3.c"
    if ($279) {
     $$7$ph = $277;
    } else {
     _markTermAsChild($1,$271,$2); //@line 132589 "c/sqlite3.c"
     _markTermAsChild($1,$275,$2); //@line 132590 "c/sqlite3.c"
     $$7$ph = $277;
    }
   }
   $$pr = HEAP8[$210>>0]|0; //@line 132605 "c/sqlite3.c"
   $280 = ($$pr<<24>>24)==(44); //@line 132605 "c/sqlite3.c"
   if ($280) {
    HEAP32[$7>>2] = 0; //@line 132606 "c/sqlite3.c"
    HEAP32[$8>>2] = 0; //@line 132606 "c/sqlite3.c"
    $281 = (_isAuxiliaryVtabOperator($19,$6,$8,$7)|0); //@line 132607 "c/sqlite3.c"
    $282 = ($281|0)>(0); //@line 132608 "c/sqlite3.c"
    if ($282) {
     $283 = HEAP8[$6>>0]|0;
     $$8418 = $$7$ph;$$in = $281;
     while(1) {
      $284 = (($$in) + -1)|0; //@line 132608 "c/sqlite3.c"
      $285 = HEAP32[$7>>2]|0; //@line 132613 "c/sqlite3.c"
      $286 = (_sqlite3WhereExprUsage($18,$285)|0); //@line 132613 "c/sqlite3.c"
      $287 = tempRet0; //@line 132613 "c/sqlite3.c"
      $288 = HEAP32[$8>>2]|0; //@line 132614 "c/sqlite3.c"
      $289 = (_sqlite3WhereExprUsage($18,$288)|0); //@line 132614 "c/sqlite3.c"
      $290 = tempRet0; //@line 132614 "c/sqlite3.c"
      $291 = $289 & $286; //@line 132615 "c/sqlite3.c"
      $292 = $290 & $287; //@line 132615 "c/sqlite3.c"
      $293 = ($291|0)==(0); //@line 132615 "c/sqlite3.c"
      $294 = ($292|0)==(0); //@line 132615 "c/sqlite3.c"
      $295 = $293 & $294; //@line 132615 "c/sqlite3.c"
      if ($295) {
       $296 = (_sqlite3ExprDup($11,$285,0)|0); //@line 132618 "c/sqlite3.c"
       $297 = (_sqlite3PExpr($10,46,0,$296)|0); //@line 132617 "c/sqlite3.c"
       $298 = HEAP32[$57>>2]|0; //@line 132619 "c/sqlite3.c"
       $299 = $298 & 1; //@line 132619 "c/sqlite3.c"
       $300 = ($299|0)!=(0); //@line 132619 "c/sqlite3.c"
       $301 = ($297|0)!=(0|0); //@line 132619 "c/sqlite3.c"
       $or$cond = $301 & $300; //@line 132619 "c/sqlite3.c"
       if ($or$cond) {
        $302 = ((($297)) + 4|0); //@line 132620 "c/sqlite3.c"
        $303 = HEAP32[$302>>2]|0; //@line 132620 "c/sqlite3.c"
        $304 = $303 | 1; //@line 132620 "c/sqlite3.c"
        HEAP32[$302>>2] = $304; //@line 132620 "c/sqlite3.c"
       }
       $305 = (_whereClauseInsert($1,$297,3)|0); //@line 132622 "c/sqlite3.c"
       $306 = HEAP32[$15>>2]|0; //@line 132624 "c/sqlite3.c"
       $307 = (((($306) + (($305*48)|0)|0)) + 32|0); //@line 132625 "c/sqlite3.c"
       $308 = $307; //@line 132625 "c/sqlite3.c"
       $309 = $308; //@line 132625 "c/sqlite3.c"
       HEAP32[$309>>2] = $286; //@line 132625 "c/sqlite3.c"
       $310 = (($308) + 4)|0; //@line 132625 "c/sqlite3.c"
       $311 = $310; //@line 132625 "c/sqlite3.c"
       HEAP32[$311>>2] = $287; //@line 132625 "c/sqlite3.c"
       $312 = ((($288)) + 28|0); //@line 132626 "c/sqlite3.c"
       $313 = HEAP32[$312>>2]|0; //@line 132626 "c/sqlite3.c"
       $314 = (((($306) + (($305*48)|0)|0)) + 20|0); //@line 132626 "c/sqlite3.c"
       HEAP32[$314>>2] = $313; //@line 132626 "c/sqlite3.c"
       $315 = ((($288)) + 32|0); //@line 132627 "c/sqlite3.c"
       $316 = HEAP16[$315>>1]|0; //@line 132627 "c/sqlite3.c"
       $317 = $316 << 16 >> 16; //@line 132627 "c/sqlite3.c"
       $318 = (((($306) + (($305*48)|0)|0)) + 28|0); //@line 132627 "c/sqlite3.c"
       HEAP32[$318>>2] = $317; //@line 132627 "c/sqlite3.c"
       $319 = (((($306) + (($305*48)|0)|0)) + 12|0); //@line 132628 "c/sqlite3.c"
       HEAP16[$319>>1] = 64; //@line 132628 "c/sqlite3.c"
       $320 = (((($306) + (($305*48)|0)|0)) + 15|0); //@line 132629 "c/sqlite3.c"
       HEAP8[$320>>0] = $283; //@line 132629 "c/sqlite3.c"
       _markTermAsChild($1,$305,$2); //@line 132630 "c/sqlite3.c"
       $321 = HEAP32[$15>>2]|0; //@line 132631 "c/sqlite3.c"
       $322 = (($321) + (($2*48)|0)|0); //@line 132631 "c/sqlite3.c"
       $323 = (((($321) + (($2*48)|0)|0)) + 10|0); //@line 132632 "c/sqlite3.c"
       $324 = HEAP16[$323>>1]|0; //@line 132632 "c/sqlite3.c"
       $325 = $324 | 8; //@line 132632 "c/sqlite3.c"
       HEAP16[$323>>1] = $325; //@line 132632 "c/sqlite3.c"
       $326 = (((($321) + (($2*48)|0)|0)) + 40|0); //@line 132633 "c/sqlite3.c"
       $327 = $326; //@line 132633 "c/sqlite3.c"
       $328 = $327; //@line 132633 "c/sqlite3.c"
       $329 = HEAP32[$328>>2]|0; //@line 132633 "c/sqlite3.c"
       $330 = (($327) + 4)|0; //@line 132633 "c/sqlite3.c"
       $331 = $330; //@line 132633 "c/sqlite3.c"
       $332 = HEAP32[$331>>2]|0; //@line 132633 "c/sqlite3.c"
       $333 = (((($306) + (($305*48)|0)|0)) + 40|0); //@line 132633 "c/sqlite3.c"
       $334 = $333; //@line 132633 "c/sqlite3.c"
       $335 = $334; //@line 132633 "c/sqlite3.c"
       HEAP32[$335>>2] = $329; //@line 132633 "c/sqlite3.c"
       $336 = (($334) + 4)|0; //@line 132633 "c/sqlite3.c"
       $337 = $336; //@line 132633 "c/sqlite3.c"
       HEAP32[$337>>2] = $332; //@line 132633 "c/sqlite3.c"
       $$9 = $322;
      } else {
       $$9 = $$8418;
      }
      $338 = HEAP32[$8>>2]|0; //@line 132635 "c/sqlite3.c"
      $339 = HEAP32[$7>>2]|0; //@line 132635 "c/sqlite3.c"
      HEAP32[$8>>2] = $339; //@line 132635 "c/sqlite3.c"
      HEAP32[$7>>2] = $338; //@line 132635 "c/sqlite3.c"
      $340 = ($$in|0)>(1); //@line 132608 "c/sqlite3.c"
      if ($340) {
       $$8418 = $$9;$$in = $284;
      } else {
       $$8$lcssa = $$9;
       break;
      }
     }
    } else {
     $$8$lcssa = $$7$ph;
    }
    $$pr406 = HEAP8[$210>>0]|0; //@line 132647 "c/sqlite3.c"
    $341 = ($$pr406<<24>>24)==(44); //@line 132647 "c/sqlite3.c"
    if ($341) {
     $342 = HEAP8[$19>>0]|0; //@line 132648 "c/sqlite3.c"
     switch ($342<<24>>24) {
     case 45: case 53:  {
      $343 = HEAP32[$20>>2]|0; //@line 132649 "c/sqlite3.c"
      $344 = (_sqlite3ExprVectorSize($343)|0); //@line 132649 "c/sqlite3.c"
      $345 = ($344|0)>(1); //@line 132649 "c/sqlite3.c"
      do {
       if ($345) {
        $346 = ((($19)) + 16|0); //@line 132650 "c/sqlite3.c"
        $347 = HEAP32[$346>>2]|0; //@line 132650 "c/sqlite3.c"
        $348 = (_sqlite3ExprVectorSize($347)|0); //@line 132650 "c/sqlite3.c"
        $349 = ($348|0)==($344|0); //@line 132650 "c/sqlite3.c"
        if ($349) {
         $350 = ((($343)) + 4|0); //@line 132651 "c/sqlite3.c"
         $351 = HEAP32[$350>>2]|0; //@line 132651 "c/sqlite3.c"
         $352 = $351 & 2048; //@line 132651 "c/sqlite3.c"
         $353 = ($352|0)==(0); //@line 132651 "c/sqlite3.c"
         if (!($353)) {
          $354 = ((($347)) + 4|0); //@line 132652 "c/sqlite3.c"
          $355 = HEAP32[$354>>2]|0; //@line 132652 "c/sqlite3.c"
          $356 = $355 & 2048; //@line 132652 "c/sqlite3.c"
          $357 = ($356|0)==(0); //@line 132652 "c/sqlite3.c"
          if (!($357)) {
           $$11$ph$ph = $$8$lcssa;
           break;
          }
         }
         $$0386416 = 0;
         while(1) {
          $358 = HEAP32[$20>>2]|0; //@line 132658 "c/sqlite3.c"
          $359 = (_sqlite3ExprForVectorField($10,$358,$$0386416)|0); //@line 132658 "c/sqlite3.c"
          $360 = HEAP32[$346>>2]|0; //@line 132659 "c/sqlite3.c"
          $361 = (_sqlite3ExprForVectorField($10,$360,$$0386416)|0); //@line 132659 "c/sqlite3.c"
          $362 = HEAP8[$19>>0]|0; //@line 132661 "c/sqlite3.c"
          $363 = $362&255; //@line 132661 "c/sqlite3.c"
          $364 = (_sqlite3PExpr($10,$363,$359,$361)|0); //@line 132661 "c/sqlite3.c"
          _transferJoinMarkings($364,$19); //@line 132662 "c/sqlite3.c"
          $365 = (_whereClauseInsert($1,$364,1)|0); //@line 132663 "c/sqlite3.c"
          _exprAnalyze($0,$1,$365); //@line 132664 "c/sqlite3.c"
          $366 = (($$0386416) + 1)|0; //@line 132655 "c/sqlite3.c"
          $exitcond = ($366|0)==($344|0); //@line 132655 "c/sqlite3.c"
          if ($exitcond) {
           break;
          } else {
           $$0386416 = $366;
          }
         }
         $367 = HEAP32[$15>>2]|0; //@line 132666 "c/sqlite3.c"
         $368 = (($367) + (($2*48)|0)|0); //@line 132666 "c/sqlite3.c"
         $369 = (((($367) + (($2*48)|0)|0)) + 10|0); //@line 132667 "c/sqlite3.c"
         HEAP16[$369>>1] = 6; //@line 132667 "c/sqlite3.c"
         $370 = (((($367) + (($2*48)|0)|0)) + 12|0); //@line 132668 "c/sqlite3.c"
         HEAP16[$370>>1] = 0; //@line 132668 "c/sqlite3.c"
         $$11$ph$ph = $368;
        } else {
         $$11$ph$ph = $$8$lcssa;
        }
       } else {
        $$11$ph$ph = $$8$lcssa;
       }
      } while(0);
      $$pr409$pr = HEAP8[$210>>0]|0; //@line 132679 "c/sqlite3.c"
      $371 = ($$pr409$pr<<24>>24)==(44); //@line 132679 "c/sqlite3.c"
      if (!($371)) {
       break L56;
      }
      $$pr413 = HEAP8[$19>>0]|0; //@line 132679 "c/sqlite3.c"
      $$11411 = $$11$ph$ph;$373 = $$pr413;
      break;
     }
     default: {
      $$11411 = $$8$lcssa;$373 = $342;
     }
     }
     $372 = ($373<<24>>24)==(49); //@line 132679 "c/sqlite3.c"
     if ($372) {
      $374 = ((($$11411)) + 24|0); //@line 132679 "c/sqlite3.c"
      $375 = HEAP32[$374>>2]|0; //@line 132679 "c/sqlite3.c"
      $376 = ($375|0)==(0); //@line 132679 "c/sqlite3.c"
      if ($376) {
       $377 = HEAP32[$20>>2]|0; //@line 132680 "c/sqlite3.c"
       $378 = HEAP8[$377>>0]|0; //@line 132680 "c/sqlite3.c"
       $379 = ($378<<24>>24)==(-105); //@line 132680 "c/sqlite3.c"
       if ($379) {
        $380 = ((($19)) + 20|0); //@line 132681 "c/sqlite3.c"
        $381 = HEAP32[$380>>2]|0; //@line 132681 "c/sqlite3.c"
        $382 = ((($381)) + 48|0); //@line 132681 "c/sqlite3.c"
        $383 = HEAP32[$382>>2]|0; //@line 132681 "c/sqlite3.c"
        $384 = ($383|0)==(0|0); //@line 132681 "c/sqlite3.c"
        if ($384) {
         $385 = HEAP32[$20>>2]|0; //@line 132684 "c/sqlite3.c"
         $386 = (_sqlite3ExprVectorSize($385)|0); //@line 132684 "c/sqlite3.c"
         $387 = ($386|0)>(0); //@line 132684 "c/sqlite3.c"
         if ($387) {
          $$0378415 = 0;
          while(1) {
           $388 = (_whereClauseInsert($1,$19,2)|0); //@line 132686 "c/sqlite3.c"
           $389 = (($$0378415) + 1)|0; //@line 132687 "c/sqlite3.c"
           $390 = HEAP32[$15>>2]|0; //@line 132687 "c/sqlite3.c"
           $391 = (((($390) + (($388*48)|0)|0)) + 24|0); //@line 132687 "c/sqlite3.c"
           HEAP32[$391>>2] = $389; //@line 132687 "c/sqlite3.c"
           _exprAnalyze($0,$1,$388); //@line 132688 "c/sqlite3.c"
           _markTermAsChild($1,$388,$2); //@line 132689 "c/sqlite3.c"
           $392 = HEAP32[$20>>2]|0; //@line 132684 "c/sqlite3.c"
           $393 = (_sqlite3ExprVectorSize($392)|0); //@line 132684 "c/sqlite3.c"
           $394 = ($389|0)<($393|0); //@line 132684 "c/sqlite3.c"
           if ($394) {
            $$0378415 = $389;
           } else {
            break;
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 } while(0);
 $395 = HEAP32[$15>>2]|0; //@line 132735 "c/sqlite3.c"
 $396 = (((($395) + (($2*48)|0)|0)) + 32|0); //@line 132736 "c/sqlite3.c"
 $397 = $396; //@line 132736 "c/sqlite3.c"
 $398 = $397; //@line 132736 "c/sqlite3.c"
 $399 = HEAP32[$398>>2]|0; //@line 132736 "c/sqlite3.c"
 $400 = (($397) + 4)|0; //@line 132736 "c/sqlite3.c"
 $401 = $400; //@line 132736 "c/sqlite3.c"
 $402 = HEAP32[$401>>2]|0; //@line 132736 "c/sqlite3.c"
 $403 = $399 | $164; //@line 132736 "c/sqlite3.c"
 $404 = $402 | $166; //@line 132736 "c/sqlite3.c"
 $405 = $396; //@line 132736 "c/sqlite3.c"
 $406 = $405; //@line 132736 "c/sqlite3.c"
 HEAP32[$406>>2] = $403; //@line 132736 "c/sqlite3.c"
 $407 = (($405) + 4)|0; //@line 132736 "c/sqlite3.c"
 $408 = $407; //@line 132736 "c/sqlite3.c"
 HEAP32[$408>>2] = $404; //@line 132736 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 132737 "c/sqlite3.c"
}
function _allowedOp($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0|0) {
 case 50: case 53: case 54: case 55: case 56: case 57: case 49:  {
  $2 = 1;
  break;
 }
 default: {
  $1 = ($0|0)==(45); //@line 131482 "c/sqlite3.c"
  $phitmp = $1&1; //@line 131482 "c/sqlite3.c"
  $2 = $phitmp;
 }
 }
 return ($2|0); //@line 131482 "c/sqlite3.c"
}
function _exprMightBeIndexed($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $$019 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = HEAP8[$4>>0]|0; //@line 132312 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(-105); //@line 132312 "c/sqlite3.c"
 $$off = (($5) + -54)|0; //@line 132312 "c/sqlite3.c"
 $8 = ($$off>>>0)<(4); //@line 132312 "c/sqlite3.c"
 $9 = $8 & $7; //@line 132312 "c/sqlite3.c"
 if ($9) {
  $10 = ((($4)) + 20|0); //@line 132313 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 132313 "c/sqlite3.c"
  $12 = ((($11)) + 4|0); //@line 132313 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 132313 "c/sqlite3.c"
  $$019 = $13;
 } else {
  $$019 = $4;
 }
 $14 = HEAP8[$$019>>0]|0; //@line 132316 "c/sqlite3.c"
 $15 = ($14<<24>>24)==(-111); //@line 132316 "c/sqlite3.c"
 if ($15) {
  $16 = ((($$019)) + 28|0); //@line 132317 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 132317 "c/sqlite3.c"
  HEAP32[$3>>2] = $17; //@line 132317 "c/sqlite3.c"
  $18 = ((($$019)) + 32|0); //@line 132318 "c/sqlite3.c"
  $19 = HEAP16[$18>>1]|0; //@line 132318 "c/sqlite3.c"
  $20 = $19 << 16 >> 16; //@line 132318 "c/sqlite3.c"
  $21 = ((($3)) + 4|0); //@line 132318 "c/sqlite3.c"
  HEAP32[$21>>2] = $20; //@line 132318 "c/sqlite3.c"
  $$0 = 1;
  return ($$0|0); //@line 132324 "c/sqlite3.c"
 }
 $22 = ($1|0)==(0); //@line 132321 "c/sqlite3.c"
 $23 = ($2|0)==(0); //@line 132321 "c/sqlite3.c"
 $24 = $22 & $23; //@line 132321 "c/sqlite3.c"
 if ($24) {
  $$0 = 0;
  return ($$0|0); //@line 132324 "c/sqlite3.c"
 }
 $25 = (_i64Add(($1|0),($2|0),-1,-1)|0); //@line 132322 "c/sqlite3.c"
 $26 = tempRet0; //@line 132322 "c/sqlite3.c"
 $27 = $25 & $1; //@line 132322 "c/sqlite3.c"
 $28 = $26 & $2; //@line 132322 "c/sqlite3.c"
 $29 = ($27|0)==(0); //@line 132322 "c/sqlite3.c"
 $30 = ($28|0)==(0); //@line 132322 "c/sqlite3.c"
 $31 = $29 & $30; //@line 132322 "c/sqlite3.c"
 if (!($31)) {
  $$0 = 0;
  return ($$0|0); //@line 132324 "c/sqlite3.c"
 }
 $32 = (_exprMightBeIndexed2($0,$1,$2,$3,$$019)|0); //@line 132323 "c/sqlite3.c"
 $$0 = $32;
 return ($$0|0); //@line 132324 "c/sqlite3.c"
}
function _operatorMask($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0|0) {
 case 49:  {
  $$0 = 1;
  break;
 }
 case 50:  {
  $$0 = 256;
  break;
 }
 case 45:  {
  $$0 = 128;
  break;
 }
 default: {
  $1 = (($0) + -53)|0; //@line 131539 "c/sqlite3.c"
  $2 = 2 << $1; //@line 131539 "c/sqlite3.c"
  $3 = $2&65535; //@line 131539 "c/sqlite3.c"
  $$0 = $3;
 }
 }
 return ($$0|0); //@line 131549 "c/sqlite3.c"
}
function _whereClauseInsert($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$1 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 12|0); //@line 131440 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 131440 "c/sqlite3.c"
 $5 = ((($0)) + 16|0); //@line 131440 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 131440 "c/sqlite3.c"
 $7 = ($4|0)<($6|0); //@line 131440 "c/sqlite3.c"
 do {
  if (!($7)) {
   $8 = ((($0)) + 20|0); //@line 131441 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 131441 "c/sqlite3.c"
   $10 = HEAP32[$0>>2]|0; //@line 131442 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 131442 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 131442 "c/sqlite3.c"
   $13 = ($6*96)|0; //@line 131443 "c/sqlite3.c"
   $14 = (_sqlite3DbMallocRawNN($12,$13,0)|0); //@line 131443 "c/sqlite3.c"
   HEAP32[$8>>2] = $14; //@line 131443 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 131444 "c/sqlite3.c"
   if (!($15)) {
    $18 = HEAP32[$3>>2]|0; //@line 131451 "c/sqlite3.c"
    $19 = ($18*48)|0; //@line 131451 "c/sqlite3.c"
    _memcpy(($14|0),($9|0),($19|0))|0; //@line 131451 "c/sqlite3.c"
    $20 = ((($0)) + 24|0); //@line 131452 "c/sqlite3.c"
    $21 = ($9|0)==($20|0); //@line 131452 "c/sqlite3.c"
    if (!($21)) {
     _sqlite3DbFree($12,$9); //@line 131453 "c/sqlite3.c"
    }
    $22 = HEAP32[$8>>2]|0; //@line 131455 "c/sqlite3.c"
    $23 = (_sqlite3DbMallocSize($12,$22)|0); //@line 131455 "c/sqlite3.c"
    $24 = (($23>>>0) / 48)&-1; //@line 131455 "c/sqlite3.c"
    HEAP32[$5>>2] = $24; //@line 131455 "c/sqlite3.c"
    break;
   }
   $16 = $2 & 1; //@line 131445 "c/sqlite3.c"
   $17 = ($16<<16>>16)==(0); //@line 131445 "c/sqlite3.c"
   if (!($17)) {
    _sqlite3ExprDelete($12,$1); //@line 131446 "c/sqlite3.c"
   }
   HEAP32[$8>>2] = $9; //@line 131448 "c/sqlite3.c"
   $$1 = 0;
   return ($$1|0); //@line 131470 "c/sqlite3.c"
  }
 } while(0);
 $25 = ((($0)) + 20|0); //@line 131457 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 131457 "c/sqlite3.c"
 $27 = HEAP32[$3>>2]|0; //@line 131457 "c/sqlite3.c"
 $28 = (($27) + 1)|0; //@line 131457 "c/sqlite3.c"
 HEAP32[$3>>2] = $28; //@line 131457 "c/sqlite3.c"
 $29 = ($1|0)==(0|0); //@line 131458 "c/sqlite3.c"
 if ($29) {
  $$sink = 1;
 } else {
  $30 = ((($1)) + 4|0); //@line 131458 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 131458 "c/sqlite3.c"
  $32 = $31 & 262144; //@line 131458 "c/sqlite3.c"
  $33 = ($32|0)==(0); //@line 131458 "c/sqlite3.c"
  if ($33) {
   $$sink = 1;
  } else {
   $34 = ((($1)) + 28|0); //@line 131459 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 131459 "c/sqlite3.c"
   $36 = ($35|0)<(0); //@line 131459 "c/sqlite3.c"
   $37 = $36 << 31 >> 31; //@line 131459 "c/sqlite3.c"
   $38 = (_sqlite3LogEst($35,$37)|0); //@line 131459 "c/sqlite3.c"
   $39 = $38&65535; //@line 131459 "c/sqlite3.c"
   $40 = (($39) + 65266)|0; //@line 131459 "c/sqlite3.c"
   $41 = $40&65535; //@line 131459 "c/sqlite3.c"
   $$sink = $41;
  }
 }
 $42 = (((($26) + (($27*48)|0)|0)) + 8|0);
 HEAP16[$42>>1] = $$sink;
 $43 = (_sqlite3ExprSkipCollate($1)|0); //@line 131463 "c/sqlite3.c"
 $44 = (($26) + (($27*48)|0)|0); //@line 131463 "c/sqlite3.c"
 HEAP32[$44>>2] = $43; //@line 131463 "c/sqlite3.c"
 $45 = (((($26) + (($27*48)|0)|0)) + 10|0); //@line 131464 "c/sqlite3.c"
 HEAP16[$45>>1] = $2; //@line 131464 "c/sqlite3.c"
 $46 = (((($26) + (($27*48)|0)|0)) + 4|0); //@line 131465 "c/sqlite3.c"
 HEAP32[$46>>2] = $0; //@line 131465 "c/sqlite3.c"
 $47 = (((($26) + (($27*48)|0)|0)) + 16|0); //@line 131466 "c/sqlite3.c"
 HEAP32[$47>>2] = -1; //@line 131466 "c/sqlite3.c"
 $48 = (((($26) + (($27*48)|0)|0)) + 12|0); //@line 131467 "c/sqlite3.c"
 dest=$48; stop=dest+36|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 131467 "c/sqlite3.c"
 $$1 = $27;
 return ($$1|0); //@line 131470 "c/sqlite3.c"
}
function _markTermAsChild($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 20|0); //@line 131789 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 131789 "c/sqlite3.c"
 $5 = (((($4) + (($1*48)|0)|0)) + 16|0); //@line 131789 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 131789 "c/sqlite3.c"
 $6 = (((($4) + (($2*48)|0)|0)) + 8|0); //@line 131790 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 131790 "c/sqlite3.c"
 $8 = (((($4) + (($1*48)|0)|0)) + 8|0); //@line 131790 "c/sqlite3.c"
 HEAP16[$8>>1] = $7; //@line 131790 "c/sqlite3.c"
 $9 = (((($4) + (($2*48)|0)|0)) + 14|0); //@line 131791 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 131791 "c/sqlite3.c"
 $11 = (($10) + 1)<<24>>24; //@line 131791 "c/sqlite3.c"
 HEAP8[$9>>0] = $11; //@line 131791 "c/sqlite3.c"
 return; //@line 131792 "c/sqlite3.c"
}
function _termIsEquivalence($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 132221 "c/sqlite3.c"
 $3 = ((($2)) + 68|0); //@line 132221 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 132221 "c/sqlite3.c"
 $5 = $4 & 128; //@line 132221 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 132221 "c/sqlite3.c"
 if (!($6)) {
  $$0 = 0;
  return ($$0|0); //@line 132234 "c/sqlite3.c"
 }
 $7 = HEAP8[$1>>0]|0; //@line 132222 "c/sqlite3.c"
 switch ($7<<24>>24) {
 case 45: case 53:  {
  break;
 }
 default: {
  $$0 = 0;
  return ($$0|0); //@line 132234 "c/sqlite3.c"
 }
 }
 $8 = ((($1)) + 4|0); //@line 132223 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 132223 "c/sqlite3.c"
 $10 = $9 & 1; //@line 132223 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 132223 "c/sqlite3.c"
 if (!($11)) {
  $$0 = 0;
  return ($$0|0); //@line 132234 "c/sqlite3.c"
 }
 $12 = ((($1)) + 12|0); //@line 132224 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 132224 "c/sqlite3.c"
 $14 = (_sqlite3ExprAffinity($13)|0); //@line 132224 "c/sqlite3.c"
 $15 = ((($1)) + 16|0); //@line 132225 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 132225 "c/sqlite3.c"
 $17 = (_sqlite3ExprAffinity($16)|0); //@line 132225 "c/sqlite3.c"
 $18 = ($14<<24>>24)==($17<<24>>24); //@line 132226 "c/sqlite3.c"
 if (!($18)) {
  $19 = ($14<<24>>24)>(66); //@line 132227 "c/sqlite3.c"
  $20 = ($17<<24>>24)>(66); //@line 132227 "c/sqlite3.c"
  $or$cond = $19 & $20; //@line 132227 "c/sqlite3.c"
  if (!($or$cond)) {
   $$0 = 0;
   return ($$0|0); //@line 132234 "c/sqlite3.c"
  }
 }
 $21 = HEAP32[$12>>2]|0; //@line 132231 "c/sqlite3.c"
 $22 = HEAP32[$15>>2]|0; //@line 132231 "c/sqlite3.c"
 $23 = (_sqlite3BinaryCompareCollSeq($0,$21,$22)|0); //@line 132231 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 132232 "c/sqlite3.c"
 if ($24) {
  $$0 = 1;
  return ($$0|0); //@line 132234 "c/sqlite3.c"
 }
 $25 = HEAP32[$23>>2]|0; //@line 132232 "c/sqlite3.c"
 $26 = (_sqlite3StrICmp($25,18038)|0); //@line 132232 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 132232 "c/sqlite3.c"
 if ($27) {
  $$0 = 1;
  return ($$0|0); //@line 132234 "c/sqlite3.c"
 }
 $28 = HEAP32[$12>>2]|0; //@line 132233 "c/sqlite3.c"
 $29 = HEAP32[$15>>2]|0; //@line 132233 "c/sqlite3.c"
 $30 = (_sqlite3ExprCollSeqMatch($0,$28,$29)|0); //@line 132233 "c/sqlite3.c"
 $$0 = $30;
 return ($$0|0); //@line 132234 "c/sqlite3.c"
}
function _exprCommute($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 16|0); //@line 131498 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 131498 "c/sqlite3.c"
 $4 = ((($3)) + 4|0); //@line 131498 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 131498 "c/sqlite3.c"
 $6 = $5 & 256; //@line 131498 "c/sqlite3.c"
 $7 = ((($1)) + 12|0); //@line 131499 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 131499 "c/sqlite3.c"
 $9 = ((($8)) + 4|0); //@line 131499 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 131499 "c/sqlite3.c"
 $11 = $10 & 256; //@line 131499 "c/sqlite3.c"
 $12 = ($6|0)==($11|0); //@line 131501 "c/sqlite3.c"
 do {
  if ($12) {
   $13 = ($6|0)==(0); //@line 131503 "c/sqlite3.c"
   if (!($13)) {
    $14 = $5 & -257; //@line 131506 "c/sqlite3.c"
    HEAP32[$4>>2] = $14; //@line 131506 "c/sqlite3.c"
    break;
   }
   $15 = (_sqlite3ExprCollSeq($0,$8)|0); //@line 131507 "c/sqlite3.c"
   $16 = ($15|0)==(0|0); //@line 131507 "c/sqlite3.c"
   if (!($16)) {
    $17 = HEAP32[$7>>2]|0; //@line 131511 "c/sqlite3.c"
    $18 = ((($17)) + 4|0); //@line 131511 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 131511 "c/sqlite3.c"
    $20 = $19 | 256; //@line 131511 "c/sqlite3.c"
    HEAP32[$18>>2] = $20; //@line 131511 "c/sqlite3.c"
   }
  }
 } while(0);
 $21 = HEAP32[$2>>2]|0; //@line 131514 "c/sqlite3.c"
 $22 = HEAP32[$7>>2]|0; //@line 131514 "c/sqlite3.c"
 HEAP32[$2>>2] = $22; //@line 131514 "c/sqlite3.c"
 HEAP32[$7>>2] = $21; //@line 131514 "c/sqlite3.c"
 $23 = HEAP8[$1>>0]|0; //@line 131515 "c/sqlite3.c"
 $24 = ($23&255)>(53); //@line 131515 "c/sqlite3.c"
 if (!($24)) {
  return; //@line 131523 "c/sqlite3.c"
 }
 $25 = $23&255; //@line 131515 "c/sqlite3.c"
 $26 = (($25) + 202)|0; //@line 131521 "c/sqlite3.c"
 $27 = $26 ^ 2; //@line 131521 "c/sqlite3.c"
 $28 = (($27) + 54)|0; //@line 131521 "c/sqlite3.c"
 $29 = $28&255; //@line 131521 "c/sqlite3.c"
 HEAP8[$1>>0] = $29; //@line 131521 "c/sqlite3.c"
 return; //@line 131523 "c/sqlite3.c"
}
function _transferJoinMarkings($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 131779 "c/sqlite3.c"
 if ($2) {
  return; //@line 131783 "c/sqlite3.c"
 }
 $3 = ((($1)) + 4|0); //@line 131780 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 131780 "c/sqlite3.c"
 $5 = $4 & 1; //@line 131780 "c/sqlite3.c"
 $6 = ((($0)) + 4|0); //@line 131780 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 131780 "c/sqlite3.c"
 $8 = $7 | $5; //@line 131780 "c/sqlite3.c"
 HEAP32[$6>>2] = $8; //@line 131780 "c/sqlite3.c"
 $9 = ((($1)) + 36|0); //@line 131781 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 131781 "c/sqlite3.c"
 $11 = ((($0)) + 36|0); //@line 131781 "c/sqlite3.c"
 HEAP16[$11>>1] = $10; //@line 131781 "c/sqlite3.c"
 return; //@line 131783 "c/sqlite3.c"
}
function _exprAnalyzeOrTerm($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0214293 = 0, $$0214293$in = 0, $$0215$lcssa = 0, $$0215257 = 0, $$0217$lcssa = 0, $$0217256 = 0, $$0219292 = 0, $$0238277 = 0, $$0240285 = 0, $$0245283 = 0, $$1216 = 0, $$1218 = 0, $$1220261 = 0, $$1220261$1 = 0, $$1262 = 0, $$1262$1 = 0, $$1262$in = 0, $$1262$in$1 = 0, $$2221269 = 0, $$2221269$1 = 0;
 var $$2270 = 0, $$2270$1 = 0, $$3222255 = 0, $$3258 = 0, $$3258$in = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0;
 var $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0;
 var $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $or$cond246 = 0, $or$cond246$1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$1>>2]|0; //@line 131960 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 131961 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 131962 "c/sqlite3.c"
 $6 = ((($1)) + 20|0); //@line 131963 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 131963 "c/sqlite3.c"
 $8 = (($7) + (($2*48)|0)|0); //@line 131964 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 131964 "c/sqlite3.c"
 $10 = (_sqlite3DbMallocZero($5,416,0)|0); //@line 131979 "c/sqlite3.c"
 $11 = (((($7) + (($2*48)|0)|0)) + 28|0); //@line 131979 "c/sqlite3.c"
 HEAP32[$11>>2] = $10; //@line 131979 "c/sqlite3.c"
 $12 = ($10|0)==(0|0); //@line 131980 "c/sqlite3.c"
 if ($12) {
  return; //@line 132200 "c/sqlite3.c"
 }
 $13 = (((($7) + (($2*48)|0)|0)) + 10|0); //@line 131981 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 131981 "c/sqlite3.c"
 $15 = $14 | 16; //@line 131981 "c/sqlite3.c"
 HEAP16[$13>>1] = $15; //@line 131981 "c/sqlite3.c"
 $16 = ((($10)) + 24|0); //@line 131983 "c/sqlite3.c"
 _memset(($16|0),0,384)|0; //@line 131983 "c/sqlite3.c"
 _sqlite3WhereClauseInit($10,$3); //@line 131984 "c/sqlite3.c"
 _sqlite3WhereSplit($10,$9,43); //@line 131985 "c/sqlite3.c"
 _sqlite3WhereExprAnalyze($0,$10); //@line 131986 "c/sqlite3.c"
 $17 = ((($5)) + 73|0); //@line 131987 "c/sqlite3.c"
 $18 = HEAP8[$17>>0]|0; //@line 131987 "c/sqlite3.c"
 $19 = ($18<<24>>24)==(0); //@line 131987 "c/sqlite3.c"
 if (!($19)) {
  return; //@line 132200 "c/sqlite3.c"
 }
 $20 = ((($10)) + 12|0); //@line 131995 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 131995 "c/sqlite3.c"
 $22 = ((($10)) + 20|0); //@line 131995 "c/sqlite3.c"
 $23 = ($21|0)>(0); //@line 131995 "c/sqlite3.c"
 if ($23) {
  $30 = HEAP32[$22>>2]|0; //@line 131995 "c/sqlite3.c"
  $31 = ((($3)) + 488|0);
  $32 = ((($3)) + 488|0);
  $$0214293$in = $21;$$0219292 = $30;$106 = -1;$108 = -1;$76 = -1;$79 = -1;
  while(1) {
   $$0214293 = (($$0214293$in) + -1)|0;
   $33 = ((($$0219292)) + 12|0); //@line 131996 "c/sqlite3.c"
   $34 = HEAP16[$33>>1]|0; //@line 131996 "c/sqlite3.c"
   $35 = $34 & 511; //@line 131996 "c/sqlite3.c"
   $36 = ($35<<16>>16)==(0); //@line 131996 "c/sqlite3.c"
   if ($36) {
    $37 = (_sqlite3DbMallocRawNN($5,408,0)|0); //@line 132000 "c/sqlite3.c"
    $38 = ($37|0)==(0|0); //@line 132001 "c/sqlite3.c"
    if ($38) {
     $114 = $76;$116 = $79;$275 = 0;$276 = 0;
    } else {
     $39 = ((($$0219292)) + 28|0); //@line 132006 "c/sqlite3.c"
     HEAP32[$39>>2] = $37; //@line 132006 "c/sqlite3.c"
     $40 = ((($$0219292)) + 10|0); //@line 132007 "c/sqlite3.c"
     $41 = HEAP16[$40>>1]|0; //@line 132007 "c/sqlite3.c"
     $42 = $41 | 32; //@line 132007 "c/sqlite3.c"
     HEAP16[$40>>1] = $42; //@line 132007 "c/sqlite3.c"
     HEAP16[$33>>1] = 1024; //@line 132008 "c/sqlite3.c"
     $43 = ((($37)) + 24|0); //@line 132010 "c/sqlite3.c"
     _memset(($43|0),0,384)|0; //@line 132010 "c/sqlite3.c"
     $44 = HEAP32[$1>>2]|0; //@line 132011 "c/sqlite3.c"
     _sqlite3WhereClauseInit($37,$44); //@line 132011 "c/sqlite3.c"
     $45 = HEAP32[$$0219292>>2]|0; //@line 132012 "c/sqlite3.c"
     _sqlite3WhereSplit($37,$45,44); //@line 132012 "c/sqlite3.c"
     _sqlite3WhereExprAnalyze($0,$37); //@line 132013 "c/sqlite3.c"
     $46 = ((($37)) + 4|0); //@line 132014 "c/sqlite3.c"
     HEAP32[$46>>2] = $1; //@line 132014 "c/sqlite3.c"
     $47 = HEAP8[$17>>0]|0; //@line 132015 "c/sqlite3.c"
     $48 = ($47<<24>>24)==(0); //@line 132015 "c/sqlite3.c"
     if ($48) {
      $49 = ((($37)) + 12|0); //@line 132016 "c/sqlite3.c"
      $50 = HEAP32[$49>>2]|0; //@line 132016 "c/sqlite3.c"
      $51 = ($50|0)>(0); //@line 132016 "c/sqlite3.c"
      if ($51) {
       $52 = ((($37)) + 20|0); //@line 132016 "c/sqlite3.c"
       $53 = HEAP32[$52>>2]|0; //@line 132016 "c/sqlite3.c"
       $54 = HEAP32[$49>>2]|0;
       $$0240285 = $53;$$0245283 = 0;$68 = 0;$70 = 0;
       while(1) {
        $55 = HEAP32[$$0240285>>2]|0; //@line 132018 "c/sqlite3.c"
        $56 = HEAP8[$55>>0]|0; //@line 132018 "c/sqlite3.c"
        $57 = $56&255; //@line 132018 "c/sqlite3.c"
        $58 = (_allowedOp($57)|0); //@line 132018 "c/sqlite3.c"
        $59 = ($58|0)==(0); //@line 132018 "c/sqlite3.c"
        if ($59) {
         $60 = ((($$0240285)) + 12|0); //@line 132019 "c/sqlite3.c"
         $61 = HEAP16[$60>>1]|0; //@line 132019 "c/sqlite3.c"
         $62 = ($61<<16>>16)==(64); //@line 132019 "c/sqlite3.c"
         if ($62) {
          label = 13;
         } else {
          $277 = $68;$278 = $70;
         }
        } else {
         label = 13;
        }
        if ((label|0) == 13) {
         label = 0;
         $63 = ((($$0240285)) + 20|0); //@line 132021 "c/sqlite3.c"
         $64 = HEAP32[$63>>2]|0; //@line 132021 "c/sqlite3.c"
         $65 = (_sqlite3WhereGetMask($32,$64)|0); //@line 132021 "c/sqlite3.c"
         $66 = tempRet0; //@line 132021 "c/sqlite3.c"
         $67 = $65 | $68; //@line 132021 "c/sqlite3.c"
         $69 = $66 | $70; //@line 132021 "c/sqlite3.c"
         $277 = $67;$278 = $69;
        }
        $71 = (($$0245283) + 1)|0; //@line 132016 "c/sqlite3.c"
        $72 = ((($$0240285)) + 48|0); //@line 132016 "c/sqlite3.c"
        $73 = ($71|0)<($54|0); //@line 132016 "c/sqlite3.c"
        if ($73) {
         $$0240285 = $72;$$0245283 = $71;$68 = $277;$70 = $278;
        } else {
         $75 = $277;$78 = $278;
         break;
        }
       }
      } else {
       $75 = 0;$78 = 0;
      }
     } else {
      $75 = 0;$78 = 0;
     }
     $74 = $75 & $76; //@line 132025 "c/sqlite3.c"
     $77 = $78 & $79; //@line 132025 "c/sqlite3.c"
     $114 = $74;$116 = $77;$275 = 0;$276 = 0;
    }
   } else {
    $80 = ((($$0219292)) + 10|0); //@line 132027 "c/sqlite3.c"
    $81 = HEAP16[$80>>1]|0; //@line 132027 "c/sqlite3.c"
    $82 = $81 & 8; //@line 132027 "c/sqlite3.c"
    $83 = ($82<<16>>16)==(0); //@line 132027 "c/sqlite3.c"
    if ($83) {
     $84 = ((($$0219292)) + 20|0); //@line 132032 "c/sqlite3.c"
     $85 = HEAP32[$84>>2]|0; //@line 132032 "c/sqlite3.c"
     $86 = (_sqlite3WhereGetMask($31,$85)|0); //@line 132032 "c/sqlite3.c"
     $87 = tempRet0; //@line 132032 "c/sqlite3.c"
     $88 = $81 & 2; //@line 132033 "c/sqlite3.c"
     $89 = ($88<<16>>16)==(0); //@line 132033 "c/sqlite3.c"
     if ($89) {
      $100 = $86;$102 = $87;
     } else {
      $90 = HEAP32[$22>>2]|0; //@line 132034 "c/sqlite3.c"
      $91 = ((($$0219292)) + 16|0); //@line 132034 "c/sqlite3.c"
      $92 = HEAP32[$91>>2]|0; //@line 132034 "c/sqlite3.c"
      $93 = (((($90) + (($92*48)|0)|0)) + 20|0); //@line 132035 "c/sqlite3.c"
      $94 = HEAP32[$93>>2]|0; //@line 132035 "c/sqlite3.c"
      $95 = (_sqlite3WhereGetMask($31,$94)|0); //@line 132035 "c/sqlite3.c"
      $96 = tempRet0; //@line 132035 "c/sqlite3.c"
      $97 = $95 | $86; //@line 132035 "c/sqlite3.c"
      $98 = $96 | $87; //@line 132035 "c/sqlite3.c"
      $100 = $97;$102 = $98;
     }
     $99 = $100 & $76; //@line 132037 "c/sqlite3.c"
     $101 = $102 & $79; //@line 132037 "c/sqlite3.c"
     $103 = $34 & 2; //@line 132038 "c/sqlite3.c"
     $104 = ($103<<16>>16)==(0); //@line 132038 "c/sqlite3.c"
     $105 = $100 & $106; //@line 132041 "c/sqlite3.c"
     $107 = $102 & $108; //@line 132041 "c/sqlite3.c"
     $109 = $104 ? 0 : $105; //@line 132038 "c/sqlite3.c"
     $110 = $104 ? 0 : $107; //@line 132038 "c/sqlite3.c"
     $114 = $99;$116 = $101;$275 = $109;$276 = $110;
    } else {
     $114 = $76;$116 = $79;$275 = $106;$276 = $108;
    }
   }
   $111 = ((($$0219292)) + 48|0); //@line 131995 "c/sqlite3.c"
   $112 = ($$0214293$in|0)>(1); //@line 131995 "c/sqlite3.c"
   $113 = ($114|0)!=(0); //@line 131995 "c/sqlite3.c"
   $115 = ($116|0)!=(0); //@line 131995 "c/sqlite3.c"
   $117 = $113 | $115; //@line 131995 "c/sqlite3.c"
   $118 = $117 & $112; //@line 131995 "c/sqlite3.c"
   if ($118) {
    $$0214293$in = $$0214293;$$0219292 = $111;$106 = $275;$108 = $276;$76 = $114;$79 = $116;
   } else {
    break;
   }
  }
  $119 = ((($10)) + 408|0); //@line 132050 "c/sqlite3.c"
  $120 = $119; //@line 132050 "c/sqlite3.c"
  $121 = $120; //@line 132050 "c/sqlite3.c"
  HEAP32[$121>>2] = $114; //@line 132050 "c/sqlite3.c"
  $122 = (($120) + 4)|0; //@line 132050 "c/sqlite3.c"
  $123 = $122; //@line 132050 "c/sqlite3.c"
  HEAP32[$123>>2] = $116; //@line 132050 "c/sqlite3.c"
  $124 = ($114|0)==(0); //@line 132051 "c/sqlite3.c"
  $125 = ($116|0)==(0); //@line 132051 "c/sqlite3.c"
  $126 = $124 & $125; //@line 132051 "c/sqlite3.c"
  $127 = (((($7) + (($2*48)|0)|0)) + 12|0); //@line 132051 "c/sqlite3.c"
  if ($126) {
   HEAP16[$127>>1] = 0; //@line 132051 "c/sqlite3.c"
   $150 = $275;$152 = $276;
  } else {
   $$sink = $127;$273 = $275;$274 = $276;
   label = 23;
  }
 } else {
  $24 = ((($10)) + 408|0); //@line 132050 "c/sqlite3.c"
  $25 = $24; //@line 132050 "c/sqlite3.c"
  $26 = $25; //@line 132050 "c/sqlite3.c"
  HEAP32[$26>>2] = -1; //@line 132050 "c/sqlite3.c"
  $27 = (($25) + 4)|0; //@line 132050 "c/sqlite3.c"
  $28 = $27; //@line 132050 "c/sqlite3.c"
  HEAP32[$28>>2] = -1; //@line 132050 "c/sqlite3.c"
  $29 = (((($7) + (($2*48)|0)|0)) + 12|0); //@line 132051 "c/sqlite3.c"
  $$sink = $29;$273 = -1;$274 = -1;
  label = 23;
 }
 if ((label|0) == 23) {
  HEAP16[$$sink>>1] = 512; //@line 132051 "c/sqlite3.c"
  $128 = HEAP32[$20>>2]|0; //@line 132055 "c/sqlite3.c"
  $129 = ($128|0)==(2); //@line 132055 "c/sqlite3.c"
  if ($129) {
   $130 = HEAP32[$22>>2]|0; //@line 132058 "c/sqlite3.c"
   $131 = (_whereNthSubterm($130,0)|0); //@line 132058 "c/sqlite3.c"
   $132 = ($131|0)==(0|0); //@line 132058 "c/sqlite3.c"
   if ($132) {
    $150 = $273;$152 = $274;
   } else {
    $138 = $131;$146 = 1;
    while(1) {
     $133 = HEAP32[$22>>2]|0; //@line 132061 "c/sqlite3.c"
     $134 = ((($133)) + 48|0); //@line 132061 "c/sqlite3.c"
     $135 = (_whereNthSubterm($134,0)|0); //@line 132061 "c/sqlite3.c"
     $136 = ($135|0)==(0|0); //@line 132061 "c/sqlite3.c"
     if (!($136)) {
      $$0238277 = 0;$139 = $135;
      while(1) {
       $137 = (($$0238277) + 1)|0; //@line 132061 "c/sqlite3.c"
       _whereCombineDisjuncts($0,$1,$138,$139); //@line 132062 "c/sqlite3.c"
       $140 = HEAP32[$22>>2]|0; //@line 132061 "c/sqlite3.c"
       $141 = ((($140)) + 48|0); //@line 132061 "c/sqlite3.c"
       $142 = (_whereNthSubterm($141,$137)|0); //@line 132061 "c/sqlite3.c"
       $143 = ($142|0)==(0|0); //@line 132061 "c/sqlite3.c"
       if ($143) {
        break;
       } else {
        $$0238277 = $137;$139 = $142;
       }
      }
     }
     $144 = HEAP32[$22>>2]|0; //@line 132058 "c/sqlite3.c"
     $145 = (($146) + 1)|0; //@line 132058 "c/sqlite3.c"
     $147 = (_whereNthSubterm($144,$146)|0); //@line 132058 "c/sqlite3.c"
     $148 = ($147|0)==(0|0); //@line 132058 "c/sqlite3.c"
     if ($148) {
      $150 = $273;$152 = $274;
      break;
     } else {
      $138 = $147;$146 = $145;
     }
    }
   }
  } else {
   $150 = $273;$152 = $274;
  }
 }
 $149 = ($150|0)==(0); //@line 132088 "c/sqlite3.c"
 $151 = ($152|0)==(0); //@line 132088 "c/sqlite3.c"
 $153 = $149 & $151; //@line 132088 "c/sqlite3.c"
 if ($153) {
  return; //@line 132200 "c/sqlite3.c"
 }
 $154 = ((($3)) + 488|0);
 $155 = HEAP32[$20>>2]|0; //@line 132102 "c/sqlite3.c"
 $156 = ($155|0)>(0); //@line 132102 "c/sqlite3.c"
 if (!($156)) {
  return; //@line 132200 "c/sqlite3.c"
 }
 $157 = HEAP32[$22>>2]|0; //@line 132101 "c/sqlite3.c"
 $$1220261 = $157;$$1262$in = $155;
 while(1) {
  $$1262 = (($$1262$in) + -1)|0;
  $158 = ((($$1220261)) + 10|0); //@line 132104 "c/sqlite3.c"
  $159 = HEAP16[$158>>1]|0; //@line 132104 "c/sqlite3.c"
  $160 = $159 & -65; //@line 132104 "c/sqlite3.c"
  HEAP16[$158>>1] = $160; //@line 132104 "c/sqlite3.c"
  $161 = ((($$1220261)) + 20|0); //@line 132105 "c/sqlite3.c"
  $162 = HEAP32[$161>>2]|0; //@line 132105 "c/sqlite3.c"
  $163 = ($162|0)==(-1); //@line 132105 "c/sqlite3.c"
  if (!($163)) {
   $164 = (_sqlite3WhereGetMask($154,$162)|0); //@line 132111 "c/sqlite3.c"
   $165 = tempRet0; //@line 132111 "c/sqlite3.c"
   $166 = $164 & $150; //@line 132111 "c/sqlite3.c"
   $167 = $165 & $152; //@line 132111 "c/sqlite3.c"
   $168 = ($166|0)==(0); //@line 132112 "c/sqlite3.c"
   $169 = ($167|0)==(0); //@line 132112 "c/sqlite3.c"
   $170 = $168 & $169; //@line 132112 "c/sqlite3.c"
   if (!($170)) {
    break;
   }
  }
  $171 = ((($$1220261)) + 48|0); //@line 132102 "c/sqlite3.c"
  $172 = ($$1262$in|0)>(1); //@line 132102 "c/sqlite3.c"
  if ($172) {
   $$1220261 = $171;$$1262$in = $$1262;
  } else {
   label = 54;
   break;
  }
 }
 if ((label|0) == 54) {
  return; //@line 132200 "c/sqlite3.c"
 }
 $173 = ((($$1220261)) + 28|0); //@line 132122 "c/sqlite3.c"
 $174 = HEAP32[$173>>2]|0; //@line 132122 "c/sqlite3.c"
 $175 = ($$1262$in|0)>(0); //@line 132139 "c/sqlite3.c"
 L60: do {
  if ($175) {
   $$2221269 = $$1220261;$$2270 = $$1262;
   while(1) {
    $176 = ((($$2221269)) + 20|0); //@line 132141 "c/sqlite3.c"
    $177 = HEAP32[$176>>2]|0; //@line 132141 "c/sqlite3.c"
    $178 = ($177|0)==($162|0); //@line 132141 "c/sqlite3.c"
    if ($178) {
     $182 = ((($$2221269)) + 28|0); //@line 132143 "c/sqlite3.c"
     $183 = HEAP32[$182>>2]|0; //@line 132143 "c/sqlite3.c"
     $184 = ($183|0)==($174|0); //@line 132143 "c/sqlite3.c"
     if (!($184)) {
      break;
     }
     $185 = HEAP32[$$2221269>>2]|0; //@line 132151 "c/sqlite3.c"
     $186 = ((($185)) + 16|0); //@line 132151 "c/sqlite3.c"
     $187 = HEAP32[$186>>2]|0; //@line 132151 "c/sqlite3.c"
     $188 = (_sqlite3ExprAffinity($187)|0); //@line 132151 "c/sqlite3.c"
     $189 = HEAP32[$$2221269>>2]|0; //@line 132152 "c/sqlite3.c"
     $190 = ((($189)) + 12|0); //@line 132152 "c/sqlite3.c"
     $191 = HEAP32[$190>>2]|0; //@line 132152 "c/sqlite3.c"
     $192 = (_sqlite3ExprAffinity($191)|0); //@line 132152 "c/sqlite3.c"
     $193 = ($188<<24>>24)==(0); //@line 132153 "c/sqlite3.c"
     $194 = ($188<<24>>24)==($192<<24>>24); //@line 132153 "c/sqlite3.c"
     $or$cond246 = $193 | $194; //@line 132153 "c/sqlite3.c"
     if (!($or$cond246)) {
      break;
     }
     $195 = ((($$2221269)) + 10|0); //@line 132156 "c/sqlite3.c"
     $196 = HEAP16[$195>>1]|0; //@line 132156 "c/sqlite3.c"
     $197 = $196 | 64; //@line 132156 "c/sqlite3.c"
     HEAP16[$195>>1] = $197; //@line 132156 "c/sqlite3.c"
    } else {
     $179 = ((($$2221269)) + 10|0); //@line 132142 "c/sqlite3.c"
     $180 = HEAP16[$179>>1]|0; //@line 132142 "c/sqlite3.c"
     $181 = $180 & -65; //@line 132142 "c/sqlite3.c"
     HEAP16[$179>>1] = $181; //@line 132142 "c/sqlite3.c"
    }
    $198 = (($$2270) + -1)|0; //@line 132139 "c/sqlite3.c"
    $199 = ((($$2221269)) + 48|0); //@line 132139 "c/sqlite3.c"
    $200 = ($$2270|0)>(0); //@line 132139 "c/sqlite3.c"
    if ($200) {
     $$2221269 = $199;$$2270 = $198;
    } else {
     break L60;
    }
   }
   $201 = HEAP32[$20>>2]|0; //@line 132102 "c/sqlite3.c"
   $202 = ($201|0)>(0); //@line 132102 "c/sqlite3.c"
   if (!($202)) {
    return; //@line 132200 "c/sqlite3.c"
   }
   $229 = HEAP32[$22>>2]|0; //@line 132101 "c/sqlite3.c"
   $$1220261$1 = $229;$$1262$in$1 = $201;
   while(1) {
    $$1262$1 = (($$1262$in$1) + -1)|0;
    $230 = ((($$1220261$1)) + 10|0); //@line 132104 "c/sqlite3.c"
    $231 = HEAP16[$230>>1]|0; //@line 132104 "c/sqlite3.c"
    $232 = $231 & -65; //@line 132104 "c/sqlite3.c"
    HEAP16[$230>>1] = $232; //@line 132104 "c/sqlite3.c"
    $233 = ((($$1220261$1)) + 20|0); //@line 132105 "c/sqlite3.c"
    $234 = HEAP32[$233>>2]|0; //@line 132105 "c/sqlite3.c"
    $235 = ($234|0)==($162|0); //@line 132105 "c/sqlite3.c"
    if (!($235)) {
     $236 = (_sqlite3WhereGetMask($154,$234)|0); //@line 132111 "c/sqlite3.c"
     $237 = tempRet0; //@line 132111 "c/sqlite3.c"
     $238 = $236 & $150; //@line 132111 "c/sqlite3.c"
     $239 = $237 & $152; //@line 132111 "c/sqlite3.c"
     $240 = ($238|0)==(0); //@line 132112 "c/sqlite3.c"
     $241 = ($239|0)==(0); //@line 132112 "c/sqlite3.c"
     $242 = $240 & $241; //@line 132112 "c/sqlite3.c"
     if (!($242)) {
      break;
     }
    }
    $271 = ((($$1220261$1)) + 48|0); //@line 132102 "c/sqlite3.c"
    $272 = ($$1262$in$1|0)>(1); //@line 132102 "c/sqlite3.c"
    if ($272) {
     $$1220261$1 = $271;$$1262$in$1 = $$1262$1;
    } else {
     label = 54;
     break;
    }
   }
   if ((label|0) == 54) {
    return; //@line 132200 "c/sqlite3.c"
   }
   $243 = ((($$1220261$1)) + 28|0); //@line 132122 "c/sqlite3.c"
   $244 = HEAP32[$243>>2]|0; //@line 132122 "c/sqlite3.c"
   $245 = ($$1262$in$1|0)>(0); //@line 132139 "c/sqlite3.c"
   if ($245) {
    $$2221269$1 = $$1220261$1;$$2270$1 = $$1262$1;
    while(1) {
     $246 = ((($$2221269$1)) + 20|0); //@line 132141 "c/sqlite3.c"
     $247 = HEAP32[$246>>2]|0; //@line 132141 "c/sqlite3.c"
     $248 = ($247|0)==($234|0); //@line 132141 "c/sqlite3.c"
     if ($248) {
      $252 = ((($$2221269$1)) + 28|0); //@line 132143 "c/sqlite3.c"
      $253 = HEAP32[$252>>2]|0; //@line 132143 "c/sqlite3.c"
      $254 = ($253|0)==($244|0); //@line 132143 "c/sqlite3.c"
      if (!($254)) {
       label = 54;
       break;
      }
      $255 = HEAP32[$$2221269$1>>2]|0; //@line 132151 "c/sqlite3.c"
      $256 = ((($255)) + 16|0); //@line 132151 "c/sqlite3.c"
      $257 = HEAP32[$256>>2]|0; //@line 132151 "c/sqlite3.c"
      $258 = (_sqlite3ExprAffinity($257)|0); //@line 132151 "c/sqlite3.c"
      $259 = HEAP32[$$2221269$1>>2]|0; //@line 132152 "c/sqlite3.c"
      $260 = ((($259)) + 12|0); //@line 132152 "c/sqlite3.c"
      $261 = HEAP32[$260>>2]|0; //@line 132152 "c/sqlite3.c"
      $262 = (_sqlite3ExprAffinity($261)|0); //@line 132152 "c/sqlite3.c"
      $263 = ($258<<24>>24)==(0); //@line 132153 "c/sqlite3.c"
      $264 = ($258<<24>>24)==($262<<24>>24); //@line 132153 "c/sqlite3.c"
      $or$cond246$1 = $263 | $264; //@line 132153 "c/sqlite3.c"
      if (!($or$cond246$1)) {
       label = 54;
       break;
      }
      $265 = ((($$2221269$1)) + 10|0); //@line 132156 "c/sqlite3.c"
      $266 = HEAP16[$265>>1]|0; //@line 132156 "c/sqlite3.c"
      $267 = $266 | 64; //@line 132156 "c/sqlite3.c"
      HEAP16[$265>>1] = $267; //@line 132156 "c/sqlite3.c"
     } else {
      $249 = ((($$2221269$1)) + 10|0); //@line 132142 "c/sqlite3.c"
      $250 = HEAP16[$249>>1]|0; //@line 132142 "c/sqlite3.c"
      $251 = $250 & -65; //@line 132142 "c/sqlite3.c"
      HEAP16[$249>>1] = $251; //@line 132142 "c/sqlite3.c"
     }
     $268 = (($$2270$1) + -1)|0; //@line 132139 "c/sqlite3.c"
     $269 = ((($$2221269$1)) + 48|0); //@line 132139 "c/sqlite3.c"
     $270 = ($$2270$1|0)>(0); //@line 132139 "c/sqlite3.c"
     if ($270) {
      $$2221269$1 = $269;$$2270$1 = $268;
     } else {
      break L60;
     }
    }
    if ((label|0) == 54) {
     return; //@line 132200 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $203 = HEAP32[$20>>2]|0; //@line 132172 "c/sqlite3.c"
 $204 = ($203|0)>(0); //@line 132172 "c/sqlite3.c"
 if ($204) {
  $205 = HEAP32[$22>>2]|0; //@line 132172 "c/sqlite3.c"
  $$0215257 = 0;$$0217256 = 0;$$3222255 = $205;$$3258$in = $203;
  while(1) {
   $$3258 = (($$3258$in) + -1)|0;
   $206 = ((($$3222255)) + 10|0); //@line 132173 "c/sqlite3.c"
   $207 = HEAP16[$206>>1]|0; //@line 132173 "c/sqlite3.c"
   $208 = $207 & 64; //@line 132173 "c/sqlite3.c"
   $209 = ($208<<16>>16)==(0); //@line 132173 "c/sqlite3.c"
   if ($209) {
    $$1216 = $$0215257;$$1218 = $$0217256;
   } else {
    $210 = HEAP32[$$3222255>>2]|0; //@line 132177 "c/sqlite3.c"
    $211 = ((($210)) + 16|0); //@line 132177 "c/sqlite3.c"
    $212 = HEAP32[$211>>2]|0; //@line 132177 "c/sqlite3.c"
    $213 = (_sqlite3ExprDup($5,$212,0)|0); //@line 132177 "c/sqlite3.c"
    $214 = HEAP32[$3>>2]|0; //@line 132178 "c/sqlite3.c"
    $215 = (_sqlite3ExprListAppend($214,$$0217256,$213)|0); //@line 132178 "c/sqlite3.c"
    $216 = HEAP32[$$3222255>>2]|0; //@line 132179 "c/sqlite3.c"
    $217 = ((($216)) + 12|0); //@line 132179 "c/sqlite3.c"
    $218 = HEAP32[$217>>2]|0; //@line 132179 "c/sqlite3.c"
    $$1216 = $218;$$1218 = $215;
   }
   $219 = ((($$3222255)) + 48|0); //@line 132172 "c/sqlite3.c"
   $220 = ($$3258$in|0)>(1); //@line 132172 "c/sqlite3.c"
   if ($220) {
    $$0215257 = $$1216;$$0217256 = $$1218;$$3222255 = $219;$$3258$in = $$3258;
   } else {
    $$0215$lcssa = $$1216;$$0217$lcssa = $$1218;
    break;
   }
  }
 } else {
  $$0215$lcssa = 0;$$0217$lcssa = 0;
 }
 $221 = (_sqlite3ExprDup($5,$$0215$lcssa,0)|0); //@line 132182 "c/sqlite3.c"
 $222 = (_sqlite3PExpr($4,49,$221,0)|0); //@line 132183 "c/sqlite3.c"
 $223 = ($222|0)==(0|0); //@line 132184 "c/sqlite3.c"
 if ($223) {
  _sqlite3ExprListDelete($5,$$0217$lcssa); //@line 132195 "c/sqlite3.c"
  $228 = $7;
 } else {
  _transferJoinMarkings($222,$9); //@line 132186 "c/sqlite3.c"
  $224 = ((($222)) + 20|0); //@line 132188 "c/sqlite3.c"
  HEAP32[$224>>2] = $$0217$lcssa; //@line 132188 "c/sqlite3.c"
  $225 = (_whereClauseInsert($1,$222,3)|0); //@line 132189 "c/sqlite3.c"
  _exprAnalyze($0,$1,$225); //@line 132191 "c/sqlite3.c"
  $226 = HEAP32[$6>>2]|0; //@line 132192 "c/sqlite3.c"
  _markTermAsChild($1,$225,$2); //@line 132193 "c/sqlite3.c"
  $228 = $226;
 }
 $227 = (((($228) + (($2*48)|0)|0)) + 12|0); //@line 132197 "c/sqlite3.c"
 HEAP16[$227>>1] = 4096; //@line 132197 "c/sqlite3.c"
 return; //@line 132200 "c/sqlite3.c"
}
function _isLikeOrGlob($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0115 = 0, $$0116$lcssa = 0, $$0116129 = 0, $$0118$lcssa = 0, $$0118128 = 0, $$0119127 = 0, $$0121 = 0, $$0121126 = 0, $$1 = 0, $$1117 = 0, $$2 = 0, $$lcssa = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0;
 var $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0;
 var $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond143 = 0, $or$cond144 = 0;
 var $phitmp = 0, $spec$select = 0, $spec$select124 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = HEAP32[$0>>2]|0; //@line 131579 "c/sqlite3.c"
 $7 = (_sqlite3IsLikeFunction($6,$1,$4,$5)|0); //@line 131584 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 131584 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 131685 "c/sqlite3.c"
 }
 $9 = ((($1)) + 20|0); //@line 131590 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 131590 "c/sqlite3.c"
 $11 = ((($10)) + 24|0); //@line 131591 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 131591 "c/sqlite3.c"
 $13 = ((($10)) + 4|0); //@line 131593 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 131593 "c/sqlite3.c"
 $15 = (_sqlite3ExprSkipCollate($14)|0); //@line 131593 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 131594 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(-121); //@line 131595 "c/sqlite3.c"
 if ($17) {
  $18 = ((($6)) + 28|0); //@line 131595 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 131595 "c/sqlite3.c"
  $20 = $19 & 8388608; //@line 131595 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 131595 "c/sqlite3.c"
  if ($21) {
   $22 = ((($0)) + 424|0); //@line 131596 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 131596 "c/sqlite3.c"
   $24 = ((($15)) + 32|0); //@line 131597 "c/sqlite3.c"
   $25 = HEAP16[$24>>1]|0; //@line 131597 "c/sqlite3.c"
   $26 = $25 << 16 >> 16; //@line 131597 "c/sqlite3.c"
   $27 = (_sqlite3VdbeGetBoundValue($23,$26)|0); //@line 131598 "c/sqlite3.c"
   $28 = ($27|0)==(0|0); //@line 131599 "c/sqlite3.c"
   if ($28) {
    $$0115 = 0;
   } else {
    $29 = (_sqlite3_value_type($27)|0); //@line 131599 "c/sqlite3.c"
    $30 = ($29|0)==(3); //@line 131599 "c/sqlite3.c"
    if ($30) {
     $31 = (_sqlite3_value_text($27)|0); //@line 131600 "c/sqlite3.c"
     $$0115 = $31;
    } else {
     $$0115 = 0;
    }
   }
   $32 = ((($0)) + 8|0); //@line 131602 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 131602 "c/sqlite3.c"
   _sqlite3VdbeSetVarmask($33,$26); //@line 131602 "c/sqlite3.c"
   $$0121 = $27;$$1 = $$0115;
   label = 10;
  } else {
   $$0121126 = 0;$$2 = 0;
  }
 } else {
  $34 = ($16<<24>>24)==(97); //@line 131604 "c/sqlite3.c"
  if ($34) {
   $35 = ((($15)) + 8|0); //@line 131605 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 131605 "c/sqlite3.c"
   $$0121 = 0;$$1 = $36;
   label = 10;
  } else {
   $$0121126 = 0;$$2 = 0;
  }
 }
 if ((label|0) == 10) {
  $37 = ($$1|0)==(0|0); //@line 131607 "c/sqlite3.c"
  if ($37) {
   $$0121126 = $$0121;$$2 = 0;
  } else {
   $38 = HEAP8[$$1>>0]|0; //@line 131616 "c/sqlite3.c"
   $39 = $38&255; //@line 131616 "c/sqlite3.c"
   $40 = (($39) + -48)|0; //@line 131616 "c/sqlite3.c"
   $41 = ($40>>>0)<(10); //@line 131616 "c/sqlite3.c"
   $42 = ($38<<24>>24)==(45); //@line 131616 "c/sqlite3.c"
   $or$cond = $42 | $41; //@line 131616 "c/sqlite3.c"
   do {
    if ($or$cond) {
     $43 = HEAP8[$12>>0]|0; //@line 131617 "c/sqlite3.c"
     $44 = ($43<<24>>24)==(-111); //@line 131617 "c/sqlite3.c"
     if ($44) {
      $45 = (_sqlite3ExprAffinity($12)|0); //@line 131618 "c/sqlite3.c"
      $46 = ($45<<24>>24)==(66); //@line 131618 "c/sqlite3.c"
      if ($46) {
       $47 = ((($12)) + 44|0); //@line 131619 "c/sqlite3.c"
       $48 = HEAP32[$47>>2]|0; //@line 131619 "c/sqlite3.c"
       $49 = ((($48)) + 56|0); //@line 131619 "c/sqlite3.c"
       $50 = HEAP32[$49>>2]|0; //@line 131619 "c/sqlite3.c"
       $51 = ($50|0)==(0); //@line 131619 "c/sqlite3.c"
       if ($51) {
        break;
       }
      }
     }
     _sqlite3ValueFree($$0121); //@line 131621 "c/sqlite3.c"
     $$0 = 0;
     STACKTOP = sp;return ($$0|0); //@line 131685 "c/sqlite3.c"
    }
   } while(0);
   $52 = HEAP8[$$1>>0]|0; //@line 131628 "c/sqlite3.c"
   $53 = ($52<<24>>24)==(0); //@line 131628 "c/sqlite3.c"
   if ($53) {
    $$0121126 = $$0121;$$2 = 0;
   } else {
    $54 = $52&255; //@line 131628 "c/sqlite3.c"
    $55 = ((($5)) + 2|0); //@line 131628 "c/sqlite3.c"
    $56 = ((($5)) + 1|0); //@line 131628 "c/sqlite3.c"
    $57 = HEAP8[$5>>0]|0;
    $58 = $57 << 24 >> 24;
    $59 = HEAP8[$56>>0]|0;
    $60 = $59 << 24 >> 24;
    $61 = HEAP8[$55>>0]|0;
    $62 = $61 << 24 >> 24;
    $63 = ((($5)) + 3|0);
    $64 = HEAP8[$63>>0]|0;
    $65 = $64 << 24 >> 24;
    $$0116129 = 0;$67 = $54;
    while(1) {
     $66 = ($67|0)==($58|0); //@line 131628 "c/sqlite3.c"
     $68 = ($67|0)==($60|0); //@line 131628 "c/sqlite3.c"
     $or$cond143 = $66 | $68; //@line 131628 "c/sqlite3.c"
     $69 = ($67|0)==($62|0); //@line 131628 "c/sqlite3.c"
     $or$cond144 = $or$cond143 | $69; //@line 131628 "c/sqlite3.c"
     if ($or$cond144) {
      $$0116$lcssa = $$0116129;$$lcssa = $67;
      break;
     }
     $70 = (($$0116129) + 1)|0; //@line 131629 "c/sqlite3.c"
     $71 = ($67|0)==($65|0); //@line 131630 "c/sqlite3.c"
     if ($71) {
      $72 = (($$0116129) + 2)|0; //@line 131630 "c/sqlite3.c"
      $73 = (($$1) + ($70)|0); //@line 131630 "c/sqlite3.c"
      $74 = HEAP8[$73>>0]|0; //@line 131630 "c/sqlite3.c"
      $75 = ($74<<24>>24)==(0); //@line 131630 "c/sqlite3.c"
      $spec$select = $75 ? $70 : $72; //@line 131630 "c/sqlite3.c"
      $$1117 = $spec$select;
     } else {
      $$1117 = $70;
     }
     $76 = (($$1) + ($$1117)|0); //@line 131628 "c/sqlite3.c"
     $77 = HEAP8[$76>>0]|0; //@line 131628 "c/sqlite3.c"
     $78 = $77&255; //@line 131628 "c/sqlite3.c"
     $79 = ($77<<24>>24)==(0); //@line 131628 "c/sqlite3.c"
     if ($79) {
      $$0116$lcssa = $$1117;$$lcssa = 0;
      break;
     } else {
      $$0116129 = $$1117;$67 = $78;
     }
    }
    $80 = ($$0116$lcssa|0)==(0); //@line 131639 "c/sqlite3.c"
    if ($80) {
     $$0121126 = $$0121;$$2 = 0;
    } else {
     $81 = (($$0116$lcssa) + -1)|0; //@line 131639 "c/sqlite3.c"
     $82 = (($$1) + ($81)|0); //@line 131639 "c/sqlite3.c"
     $83 = HEAP8[$82>>0]|0; //@line 131639 "c/sqlite3.c"
     $84 = ($83<<24>>24)==(-1); //@line 131639 "c/sqlite3.c"
     if ($84) {
      $$0121126 = $$0121;$$2 = 0;
     } else {
      $85 = HEAP8[$5>>0]|0; //@line 131643 "c/sqlite3.c"
      $86 = $85 << 24 >> 24; //@line 131643 "c/sqlite3.c"
      $87 = ($$lcssa|0)==($86|0); //@line 131643 "c/sqlite3.c"
      if ($87) {
       $88 = (($$0116$lcssa) + 1)|0; //@line 131643 "c/sqlite3.c"
       $89 = (($$1) + ($88)|0); //@line 131643 "c/sqlite3.c"
       $90 = HEAP8[$89>>0]|0; //@line 131643 "c/sqlite3.c"
       $91 = ($90<<24>>24)==(0); //@line 131643 "c/sqlite3.c"
       $phitmp = $91&1;
       $92 = $phitmp;
      } else {
       $92 = 0;
      }
      HEAP32[$3>>2] = $92; //@line 131643 "c/sqlite3.c"
      $93 = (_sqlite3Expr($6,97,$$1)|0); //@line 131646 "c/sqlite3.c"
      $94 = ($93|0)==(0|0); //@line 131647 "c/sqlite3.c"
      if (!($94)) {
       $95 = ((($93)) + 8|0); //@line 131649 "c/sqlite3.c"
       $96 = HEAP32[$95>>2]|0; //@line 131649 "c/sqlite3.c"
       $97 = (($96) + ($$0116$lcssa)|0); //@line 131650 "c/sqlite3.c"
       HEAP8[$97>>0] = 0; //@line 131650 "c/sqlite3.c"
       $98 = ($$0116$lcssa|0)>(0); //@line 131651 "c/sqlite3.c"
       if ($98) {
        $99 = ((($5)) + 3|0);
        $100 = HEAP8[$99>>0]|0;
        $$0118128 = 0;$$0119127 = 0;
        while(1) {
         $101 = (($96) + ($$0119127)|0); //@line 131652 "c/sqlite3.c"
         $102 = HEAP8[$101>>0]|0; //@line 131652 "c/sqlite3.c"
         $103 = ($102<<24>>24)==($100<<24>>24); //@line 131652 "c/sqlite3.c"
         $104 = $103&1; //@line 131652 "c/sqlite3.c"
         $spec$select124 = (($$0119127) + ($104))|0; //@line 131652 "c/sqlite3.c"
         $105 = (($96) + ($spec$select124)|0); //@line 131653 "c/sqlite3.c"
         $106 = HEAP8[$105>>0]|0; //@line 131653 "c/sqlite3.c"
         $107 = (($$0118128) + 1)|0; //@line 131653 "c/sqlite3.c"
         $108 = (($96) + ($$0118128)|0); //@line 131653 "c/sqlite3.c"
         HEAP8[$108>>0] = $106; //@line 131653 "c/sqlite3.c"
         $109 = (($spec$select124) + 1)|0; //@line 131651 "c/sqlite3.c"
         $110 = ($109|0)<($$0116$lcssa|0); //@line 131651 "c/sqlite3.c"
         if ($110) {
          $$0118128 = $107;$$0119127 = $109;
         } else {
          $$0118$lcssa = $107;
          break;
         }
        }
       } else {
        $$0118$lcssa = 0;
       }
       $111 = (($96) + ($$0118$lcssa)|0); //@line 131655 "c/sqlite3.c"
       HEAP8[$111>>0] = 0; //@line 131655 "c/sqlite3.c"
      }
      HEAP32[$2>>2] = $93; //@line 131657 "c/sqlite3.c"
      if ($17) {
       $112 = ((($0)) + 8|0); //@line 131662 "c/sqlite3.c"
       $113 = HEAP32[$112>>2]|0; //@line 131662 "c/sqlite3.c"
       $114 = ((($15)) + 32|0); //@line 131663 "c/sqlite3.c"
       $115 = HEAP16[$114>>1]|0; //@line 131663 "c/sqlite3.c"
       $116 = $115 << 16 >> 16; //@line 131663 "c/sqlite3.c"
       _sqlite3VdbeSetVarmask($113,$116); //@line 131663 "c/sqlite3.c"
       $117 = HEAP32[$3>>2]|0; //@line 131664 "c/sqlite3.c"
       $118 = ($117|0)==(0); //@line 131664 "c/sqlite3.c"
       if ($118) {
        $$0121126 = $$0121;$$2 = $$1;
       } else {
        $119 = ((($15)) + 8|0); //@line 131664 "c/sqlite3.c"
        $120 = HEAP32[$119>>2]|0; //@line 131664 "c/sqlite3.c"
        $121 = ((($120)) + 1|0); //@line 131664 "c/sqlite3.c"
        $122 = HEAP8[$121>>0]|0; //@line 131664 "c/sqlite3.c"
        $123 = ($122<<24>>24)==(0); //@line 131664 "c/sqlite3.c"
        if ($123) {
         $$0121126 = $$0121;$$2 = $$1;
        } else {
         $124 = (_sqlite3GetTempReg($0)|0); //@line 131671 "c/sqlite3.c"
         (_sqlite3ExprCodeTarget($0,$15,$124)|0); //@line 131672 "c/sqlite3.c"
         $125 = (_sqlite3VdbeCurrentAddr($113)|0); //@line 131673 "c/sqlite3.c"
         $126 = (($125) + -1)|0; //@line 131673 "c/sqlite3.c"
         _sqlite3VdbeChangeP3($113,$126,0); //@line 131673 "c/sqlite3.c"
         _sqlite3ReleaseTempReg($0,$124); //@line 131674 "c/sqlite3.c"
         $$0121126 = $$0121;$$2 = $$1;
        }
       }
      } else {
       $$0121126 = $$0121;$$2 = $$1;
      }
     }
    }
   }
  }
 }
 $127 = ($$2|0)!=(0|0); //@line 131682 "c/sqlite3.c"
 $128 = $127&1; //@line 131682 "c/sqlite3.c"
 _sqlite3ValueFree($$0121126); //@line 131683 "c/sqlite3.c"
 $$0 = $128;
 STACKTOP = sp;return ($$0|0); //@line 131685 "c/sqlite3.c"
}
function _isAuxiliaryVtabOperator($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$056 = 0, $$057 = 0, $$058 = 0, $$06167$lcssa = 0, $$1 = 0, $$159 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $not$ = 0, $spec$select = 0, $spec$select62 = 0, $spec$select63 = 0, $spec$select64 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP8[$0>>0]|0; //@line 131722 "c/sqlite3.c"
 switch ($4<<24>>24) {
 case -112:  {
  $5 = ((($0)) + 20|0); //@line 131736 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 131736 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 131737 "c/sqlite3.c"
  if ($7) {
   $$1 = 0;
   return ($$1|0); //@line 131771 "c/sqlite3.c"
  }
  $8 = HEAP32[$6>>2]|0; //@line 131737 "c/sqlite3.c"
  $9 = ($8|0)==(2); //@line 131737 "c/sqlite3.c"
  if (!($9)) {
   $$1 = 0;
   return ($$1|0); //@line 131771 "c/sqlite3.c"
  }
  $10 = ((($6)) + 24|0); //@line 131740 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 131740 "c/sqlite3.c"
  $12 = HEAP8[$11>>0]|0; //@line 131741 "c/sqlite3.c"
  $13 = ($12<<24>>24)==(-111); //@line 131741 "c/sqlite3.c"
  if (!($13)) {
   $$1 = 0;
   return ($$1|0); //@line 131771 "c/sqlite3.c"
  }
  $14 = ((($11)) + 44|0); //@line 131741 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 131741 "c/sqlite3.c"
  $16 = ((($15)) + 56|0); //@line 131741 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 131741 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 131741 "c/sqlite3.c"
  if ($18) {
   $$1 = 0;
   return ($$1|0); //@line 131771 "c/sqlite3.c"
  }
  $19 = ((($0)) + 8|0);
  $20 = HEAP32[$19>>2]|0;
  $21 = (_sqlite3StrICmp($20,20437)|0); //@line 131745 "c/sqlite3.c"
  $22 = ($21|0)==(0); //@line 131745 "c/sqlite3.c"
  if ($22) {
   $$06167$lcssa = 0;
  } else {
   $27 = (_sqlite3StrICmp($20,16984)|0); //@line 131745 "c/sqlite3.c"
   $28 = ($27|0)==(0); //@line 131745 "c/sqlite3.c"
   if ($28) {
    $$06167$lcssa = 1;
   } else {
    $54 = (_sqlite3StrICmp($20,16993)|0); //@line 131745 "c/sqlite3.c"
    $55 = ($54|0)==(0); //@line 131745 "c/sqlite3.c"
    if ($55) {
     $$06167$lcssa = 2;
    } else {
     $56 = (_sqlite3StrICmp($20,27803)|0); //@line 131745 "c/sqlite3.c"
     $57 = ($56|0)==(0); //@line 131745 "c/sqlite3.c"
     if ($57) {
      $$06167$lcssa = 3;
     } else {
      $$1 = 0;
      return ($$1|0); //@line 131771 "c/sqlite3.c"
     }
    }
   }
  }
  $23 = (((6328 + ($$06167$lcssa<<3)|0)) + 4|0); //@line 131746 "c/sqlite3.c"
  $24 = HEAP8[$23>>0]|0; //@line 131746 "c/sqlite3.c"
  HEAP8[$1>>0] = $24; //@line 131746 "c/sqlite3.c"
  $25 = ((($6)) + 4|0); //@line 131747 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 131747 "c/sqlite3.c"
  HEAP32[$3>>2] = $26; //@line 131747 "c/sqlite3.c"
  HEAP32[$2>>2] = $11; //@line 131748 "c/sqlite3.c"
  $$1 = 1;
  return ($$1|0); //@line 131771 "c/sqlite3.c"
  break;
 }
 case 51: case -113: case 52:  {
  $29 = ((($0)) + 12|0); //@line 131754 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 131754 "c/sqlite3.c"
  $31 = ((($0)) + 16|0); //@line 131755 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 131755 "c/sqlite3.c"
  $33 = HEAP8[$30>>0]|0; //@line 131756 "c/sqlite3.c"
  $34 = ($33<<24>>24)==(-111); //@line 131756 "c/sqlite3.c"
  if ($34) {
   $35 = ((($30)) + 44|0); //@line 131756 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 131756 "c/sqlite3.c"
   $37 = ((($36)) + 56|0); //@line 131756 "c/sqlite3.c"
   $38 = HEAP32[$37>>2]|0; //@line 131756 "c/sqlite3.c"
   $39 = ($38|0)!=(0); //@line 131756 "c/sqlite3.c"
   $spec$select = $39&1; //@line 131756 "c/sqlite3.c"
   $$058 = $spec$select;
  } else {
   $$058 = 0;
  }
  $40 = ($32|0)==(0|0); //@line 131759 "c/sqlite3.c"
  if ($40) {
   $$056 = 0;$$057 = $30;$$159 = $$058;
  } else {
   $41 = HEAP8[$32>>0]|0; //@line 131759 "c/sqlite3.c"
   $42 = ($41<<24>>24)==(-111); //@line 131759 "c/sqlite3.c"
   if ($42) {
    $43 = ((($32)) + 44|0); //@line 131759 "c/sqlite3.c"
    $44 = HEAP32[$43>>2]|0; //@line 131759 "c/sqlite3.c"
    $45 = ((($44)) + 56|0); //@line 131759 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 131759 "c/sqlite3.c"
    $47 = ($46|0)==(0); //@line 131759 "c/sqlite3.c"
    $not$ = $47 ^ 1; //@line 131759 "c/sqlite3.c"
    $48 = $not$&1; //@line 131759 "c/sqlite3.c"
    $spec$select62 = (($$058) + ($48))|0; //@line 131759 "c/sqlite3.c"
    $spec$select63 = $47 ? $30 : $32; //@line 131759 "c/sqlite3.c"
    $spec$select64 = $47 ? $32 : $30; //@line 131759 "c/sqlite3.c"
    $$056 = $spec$select64;$$057 = $spec$select63;$$159 = $spec$select62;
   } else {
    $$056 = $32;$$057 = $30;$$159 = $$058;
   }
  }
  HEAP32[$2>>2] = $$057; //@line 131763 "c/sqlite3.c"
  HEAP32[$3>>2] = $$056; //@line 131764 "c/sqlite3.c"
  $49 = ($4<<24>>24)==(52); //@line 131765 "c/sqlite3.c"
  if ($49) {
   HEAP8[$1>>0] = 68; //@line 131765 "c/sqlite3.c"
  }
  $50 = HEAP8[$0>>0]|0; //@line 131766 "c/sqlite3.c"
  $51 = ($50<<24>>24)==(-113); //@line 131766 "c/sqlite3.c"
  if ($51) {
   HEAP8[$1>>0] = 69; //@line 131766 "c/sqlite3.c"
   $$pr = HEAP8[$0>>0]|0; //@line 131767 "c/sqlite3.c"
   $53 = $$pr;
  } else {
   $53 = $50;
  }
  $52 = ($53<<24>>24)==(51); //@line 131767 "c/sqlite3.c"
  if (!($52)) {
   $$1 = $$159;
   return ($$1|0); //@line 131771 "c/sqlite3.c"
  }
  HEAP8[$1>>0] = 70; //@line 131767 "c/sqlite3.c"
  $$1 = $$159;
  return ($$1|0); //@line 131771 "c/sqlite3.c"
  break;
 }
 default: {
  $$1 = 0;
  return ($$1|0); //@line 131771 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3ExprForVectorField($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$013 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP8[$1>>0]|0; //@line 93128 "c/sqlite3.c"
 switch ($3<<24>>24) {
 case 119:  {
  $4 = (_sqlite3PExpr($0,152,0,0)|0); //@line 93146 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 93147 "c/sqlite3.c"
  if ($5) {
   $$0 = 0;
   return ($$0|0); //@line 93156 "c/sqlite3.c"
  }
  $6 = $2&65535; //@line 93148 "c/sqlite3.c"
  $7 = ((($4)) + 32|0); //@line 93148 "c/sqlite3.c"
  HEAP16[$7>>1] = $6; //@line 93148 "c/sqlite3.c"
  $8 = ((($4)) + 12|0); //@line 93149 "c/sqlite3.c"
  HEAP32[$8>>2] = $1; //@line 93149 "c/sqlite3.c"
  $$0 = $4;
  return ($$0|0); //@line 93156 "c/sqlite3.c"
  break;
 }
 case -105:  {
  $9 = ((($1)) + 20|0); //@line 93153 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 93153 "c/sqlite3.c"
  $11 = (((($10)) + 4|0) + (($2*20)|0)|0); //@line 93153 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 93153 "c/sqlite3.c"
  $$013 = $12;
  break;
 }
 default: {
  $$013 = $1;
 }
 }
 $13 = HEAP32[$0>>2]|0; //@line 93154 "c/sqlite3.c"
 $14 = (_sqlite3ExprDup($13,$$013,0)|0); //@line 93154 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 93156 "c/sqlite3.c"
}
function _sqlite3IsLikeFunction($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$1 = 0, $$lobit = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP8[$1>>0]|0; //@line 109244 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(-112); //@line 109244 "c/sqlite3.c"
 if (!($5)) {
  $$1 = 0;
  return ($$1|0); //@line 109274 "c/sqlite3.c"
 }
 $6 = ((($1)) + 20|0); //@line 109244 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 109244 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 109244 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
  return ($$1|0); //@line 109274 "c/sqlite3.c"
 }
 $9 = HEAP32[$7>>2]|0; //@line 109248 "c/sqlite3.c"
 $10 = ((($1)) + 8|0); //@line 109249 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 109249 "c/sqlite3.c"
 $12 = (_sqlite3FindFunction($0,$11,$9,1,0)|0); //@line 109249 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 109250 "c/sqlite3.c"
 if ($13) {
  $$1 = 0;
  return ($$1|0); //@line 109274 "c/sqlite3.c"
 }
 $14 = ((($12)) + 2|0); //@line 109250 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 109250 "c/sqlite3.c"
 $16 = $15 & 4; //@line 109250 "c/sqlite3.c"
 $17 = ($16<<16>>16)==(0); //@line 109250 "c/sqlite3.c"
 if ($17) {
  $$1 = 0;
  return ($$1|0); //@line 109274 "c/sqlite3.c"
 }
 $18 = ($9|0)<(3); //@line 109253 "c/sqlite3.c"
 if ($18) {
  $$sink = 0;
 } else {
  $19 = HEAP32[$6>>2]|0; //@line 109256 "c/sqlite3.c"
  $20 = ((($19)) + 44|0); //@line 109256 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 109256 "c/sqlite3.c"
  $22 = HEAP8[$21>>0]|0; //@line 109258 "c/sqlite3.c"
  $23 = ($22<<24>>24)==(97); //@line 109258 "c/sqlite3.c"
  if (!($23)) {
   $$1 = 0;
   return ($$1|0); //@line 109274 "c/sqlite3.c"
  }
  $24 = ((($21)) + 8|0); //@line 109259 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 109259 "c/sqlite3.c"
  $26 = HEAP8[$25>>0]|0; //@line 109260 "c/sqlite3.c"
  $27 = ($26<<24>>24)==(0); //@line 109260 "c/sqlite3.c"
  if ($27) {
   $$1 = 0;
   return ($$1|0); //@line 109274 "c/sqlite3.c"
  }
  $28 = ((($25)) + 1|0); //@line 109260 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 109260 "c/sqlite3.c"
  $30 = ($29<<24>>24)==(0); //@line 109260 "c/sqlite3.c"
  if ($30) {
   $$sink = $26;
  } else {
   $$1 = 0;
   return ($$1|0); //@line 109274 "c/sqlite3.c"
  }
 }
 $31 = ((($3)) + 3|0);
 HEAP8[$31>>0] = $$sink;
 $32 = ((($12)) + 4|0); //@line 109268 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 109268 "c/sqlite3.c"
 ;HEAP8[$3>>0]=HEAP8[$33>>0]|0;HEAP8[$3+1>>0]=HEAP8[$33+1>>0]|0;HEAP8[$3+2>>0]=HEAP8[$33+2>>0]|0; //@line 109268 "c/sqlite3.c"
 $34 = HEAP16[$14>>1]|0; //@line 109272 "c/sqlite3.c"
 $35 = ($34&65535) >>> 3; //@line 109272 "c/sqlite3.c"
 $$lobit = $35 & 1; //@line 109272 "c/sqlite3.c"
 $36 = $$lobit ^ 1; //@line 109272 "c/sqlite3.c"
 $37 = $36&65535; //@line 109272 "c/sqlite3.c"
 HEAP32[$2>>2] = $37; //@line 109272 "c/sqlite3.c"
 $$1 = 1;
 return ($$1|0); //@line 109274 "c/sqlite3.c"
}
function _whereNthSubterm($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 131800 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 131800 "c/sqlite3.c"
 $4 = ($3<<16>>16)==(1024); //@line 131800 "c/sqlite3.c"
 if (!($4)) {
  $5 = ($1|0)==(0); //@line 131801 "c/sqlite3.c"
  $6 = $5 ? $0 : 0; //@line 131801 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 131807 "c/sqlite3.c"
 }
 $7 = ((($0)) + 28|0); //@line 131803 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 131803 "c/sqlite3.c"
 $9 = ((($8)) + 12|0); //@line 131803 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 131803 "c/sqlite3.c"
 $11 = ($10|0)>($1|0); //@line 131803 "c/sqlite3.c"
 if (!($11)) {
  $$0 = 0;
  return ($$0|0); //@line 131807 "c/sqlite3.c"
 }
 $12 = ((($8)) + 20|0); //@line 131804 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 131804 "c/sqlite3.c"
 $14 = (($13) + (($1*48)|0)|0); //@line 131804 "c/sqlite3.c"
 $$0 = $14;
 return ($$0|0); //@line 131807 "c/sqlite3.c"
}
function _whereCombineDisjuncts($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$ = 0, $$036 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond39 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($2)) + 12|0); //@line 131835 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 131835 "c/sqlite3.c"
 $6 = ((($3)) + 12|0); //@line 131835 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 131835 "c/sqlite3.c"
 $8 = $7 | $5; //@line 131835 "c/sqlite3.c"
 $9 = $5 & 62; //@line 131841 "c/sqlite3.c"
 $10 = ($9<<16>>16)==(0); //@line 131841 "c/sqlite3.c"
 $11 = $7 & 62; //@line 131842 "c/sqlite3.c"
 $12 = ($11<<16>>16)==(0); //@line 131842 "c/sqlite3.c"
 $or$cond39 = $10 | $12; //@line 131841 "c/sqlite3.c"
 if ($or$cond39) {
  return; //@line 131865 "c/sqlite3.c"
 }
 $13 = $8&65535; //@line 131843 "c/sqlite3.c"
 $14 = $13 & 26; //@line 131843 "c/sqlite3.c"
 $15 = ($14|0)==($13|0); //@line 131843 "c/sqlite3.c"
 $16 = $13 & 38; //@line 131844 "c/sqlite3.c"
 $17 = ($16|0)==($13|0); //@line 131844 "c/sqlite3.c"
 $or$cond = $15 | $17; //@line 131844 "c/sqlite3.c"
 if (!($or$cond)) {
  return; //@line 131865 "c/sqlite3.c"
 }
 $18 = HEAP32[$2>>2]|0; //@line 131847 "c/sqlite3.c"
 $19 = ((($18)) + 12|0); //@line 131847 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 131847 "c/sqlite3.c"
 $21 = HEAP32[$3>>2]|0; //@line 131847 "c/sqlite3.c"
 $22 = ((($21)) + 12|0); //@line 131847 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 131847 "c/sqlite3.c"
 $24 = (_sqlite3ExprCompare(0,$20,$23,-1)|0); //@line 131847 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 131847 "c/sqlite3.c"
 if (!($25)) {
  return; //@line 131865 "c/sqlite3.c"
 }
 $26 = HEAP32[$2>>2]|0; //@line 131848 "c/sqlite3.c"
 $27 = ((($26)) + 16|0); //@line 131848 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 131848 "c/sqlite3.c"
 $29 = HEAP32[$3>>2]|0; //@line 131848 "c/sqlite3.c"
 $30 = ((($29)) + 16|0); //@line 131848 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 131848 "c/sqlite3.c"
 $32 = (_sqlite3ExprCompare(0,$28,$31,-1)|0); //@line 131848 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 131848 "c/sqlite3.c"
 if (!($33)) {
  return; //@line 131865 "c/sqlite3.c"
 }
 $34 = HEAP32[$1>>2]|0; //@line 131858 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 131858 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 131858 "c/sqlite3.c"
 $37 = HEAP32[$2>>2]|0; //@line 131859 "c/sqlite3.c"
 $38 = (_sqlite3ExprDup($36,$37,0)|0); //@line 131859 "c/sqlite3.c"
 $39 = ($38|0)==(0|0); //@line 131860 "c/sqlite3.c"
 if ($39) {
  return; //@line 131865 "c/sqlite3.c"
 }
 $40 = (($13) + 65535)|0; //@line 131850 "c/sqlite3.c"
 $41 = $40 & $13; //@line 131850 "c/sqlite3.c"
 $42 = ($41|0)==(0); //@line 131850 "c/sqlite3.c"
 $43 = $13 & 24; //@line 131851 "c/sqlite3.c"
 $44 = ($43|0)==(0); //@line 131851 "c/sqlite3.c"
 $$ = $44 ? 32 : 8;
 $spec$select = $42 ? $8 : $$; //@line 131850 "c/sqlite3.c"
 $45 = $spec$select&65535;
 $$036 = 53;
 while(1) {
  $46 = (($$036) + -53)|0; //@line 131861 "c/sqlite3.c"
  $47 = 2 << $46; //@line 131861 "c/sqlite3.c"
  $48 = ($47|0)==($45|0); //@line 131861 "c/sqlite3.c"
  $49 = (($$036) + 1)|0; //@line 131861 "c/sqlite3.c"
  if ($48) {
   break;
  } else {
   $$036 = $49;
  }
 }
 $50 = $$036&255; //@line 131862 "c/sqlite3.c"
 HEAP8[$38>>0] = $50; //@line 131862 "c/sqlite3.c"
 $51 = (_whereClauseInsert($1,$38,3)|0); //@line 131863 "c/sqlite3.c"
 _exprAnalyze($0,$1,$51); //@line 131864 "c/sqlite3.c"
 return; //@line 131865 "c/sqlite3.c"
}
function _exprMightBeIndexed2($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$027$lcssa = 0, $$02736 = 0, $$028 = 0, $$02832 = 0, $$02833 = 0, $$131 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($2>>>0)>(0); //@line 132284 "c/sqlite3.c"
 $6 = ($1>>>0)>(1); //@line 132284 "c/sqlite3.c"
 $7 = ($2|0)==(0); //@line 132284 "c/sqlite3.c"
 $8 = $7 & $6; //@line 132284 "c/sqlite3.c"
 $9 = $5 | $8; //@line 132284 "c/sqlite3.c"
 if ($9) {
  $$02736 = 0;$11 = $1;$12 = $2;
  while(1) {
   $10 = (($$02736) + 1)|0; //@line 132284 "c/sqlite3.c"
   $13 = (_bitshift64Lshr(($11|0),($12|0),1)|0); //@line 132284 "c/sqlite3.c"
   $14 = tempRet0; //@line 132284 "c/sqlite3.c"
   $15 = ($12>>>0)>(0); //@line 132284 "c/sqlite3.c"
   $16 = ($11>>>0)>(3); //@line 132284 "c/sqlite3.c"
   $17 = ($12|0)==(0); //@line 132284 "c/sqlite3.c"
   $18 = $17 & $16; //@line 132284 "c/sqlite3.c"
   $19 = $15 | $18; //@line 132284 "c/sqlite3.c"
   if ($19) {
    $$02736 = $10;$11 = $13;$12 = $14;
   } else {
    $$027$lcssa = $10;
    break;
   }
  }
 } else {
  $$027$lcssa = 0;
 }
 $20 = (((((($0)) + 8|0) + (($$027$lcssa*72)|0)|0)) + 44|0); //@line 132285 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 132285 "c/sqlite3.c"
 $22 = (((((($0)) + 8|0) + (($$027$lcssa*72)|0)|0)) + 16|0); //@line 132286 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 132286 "c/sqlite3.c"
 $24 = ((($23)) + 8|0); //@line 132286 "c/sqlite3.c"
 $$02832 = HEAP32[$24>>2]|0;
 $25 = ($$02832|0)==(0|0); //@line 132286 "c/sqlite3.c"
 if ($25) {
  $$0 = 0;
  return ($$0|0); //@line 132298 "c/sqlite3.c"
 }
 $$02833 = $$02832;
 L9: while(1) {
  $26 = ((($$02833)) + 40|0); //@line 132287 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 132287 "c/sqlite3.c"
  $28 = ($27|0)==(0|0); //@line 132287 "c/sqlite3.c"
  if (!($28)) {
   $29 = ((($$02833)) + 50|0); //@line 132288 "c/sqlite3.c"
   $30 = HEAP16[$29>>1]|0; //@line 132288 "c/sqlite3.c"
   $31 = ($30<<16>>16)==(0); //@line 132288 "c/sqlite3.c"
   if (!($31)) {
    $32 = ((($$02833)) + 4|0);
    $$131 = 0;
    while(1) {
     $33 = HEAP32[$32>>2]|0; //@line 132289 "c/sqlite3.c"
     $34 = (($33) + ($$131<<1)|0); //@line 132289 "c/sqlite3.c"
     $35 = HEAP16[$34>>1]|0; //@line 132289 "c/sqlite3.c"
     $36 = ($35<<16>>16)==(-2); //@line 132289 "c/sqlite3.c"
     if ($36) {
      $37 = HEAP32[$26>>2]|0; //@line 132290 "c/sqlite3.c"
      $38 = (((($37)) + 4|0) + (($$131*20)|0)|0); //@line 132290 "c/sqlite3.c"
      $39 = HEAP32[$38>>2]|0; //@line 132290 "c/sqlite3.c"
      $40 = (_sqlite3ExprCompareSkip($4,$39,$21)|0); //@line 132290 "c/sqlite3.c"
      $41 = ($40|0)==(0); //@line 132290 "c/sqlite3.c"
      if ($41) {
       break L9;
      }
     }
     $43 = (($$131) + 1)|0; //@line 132288 "c/sqlite3.c"
     $44 = HEAP16[$29>>1]|0; //@line 132288 "c/sqlite3.c"
     $45 = $44&65535; //@line 132288 "c/sqlite3.c"
     $46 = ($43>>>0)<($45>>>0); //@line 132288 "c/sqlite3.c"
     if ($46) {
      $$131 = $43;
     } else {
      break;
     }
    }
   }
  }
  $47 = ((($$02833)) + 20|0); //@line 132286 "c/sqlite3.c"
  $$028 = HEAP32[$47>>2]|0;
  $48 = ($$028|0)==(0|0); //@line 132286 "c/sqlite3.c"
  if ($48) {
   $$0 = 0;
   label = 14;
   break;
  } else {
   $$02833 = $$028;
  }
 }
 if ((label|0) == 14) {
  return ($$0|0); //@line 132298 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = $21; //@line 132291 "c/sqlite3.c"
 $42 = ((($3)) + 4|0); //@line 132292 "c/sqlite3.c"
 HEAP32[$42>>2] = -2; //@line 132292 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 132298 "c/sqlite3.c"
}
function _checkConstraintUnchanged($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = ((($3)) + 20|0); //@line 111962 "c/sqlite3.c"
 $5 = ((($3)) + 4|0); //@line 111963 "c/sqlite3.c"
 ;HEAP32[$3>>2]=0|0;HEAP32[$3+4>>2]=0|0;HEAP32[$3+8>>2]=0|0;HEAP32[$3+12>>2]=0|0;HEAP32[$3+16>>2]=0|0;HEAP32[$3+20>>2]=0|0; //@line 111962 "c/sqlite3.c"
 HEAP32[$5>>2] = 163; //@line 111963 "c/sqlite3.c"
 $6 = ((($3)) + 24|0); //@line 111964 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 111964 "c/sqlite3.c"
 (_sqlite3WalkExpr($3,$0)|0); //@line 111965 "c/sqlite3.c"
 $7 = ($2|0)==(0); //@line 111966 "c/sqlite3.c"
 if ($7) {
  $8 = HEAP8[$4>>0]|0; //@line 111968 "c/sqlite3.c"
  $9 = $8 & -3; //@line 111968 "c/sqlite3.c"
  HEAP8[$4>>0] = $9; //@line 111968 "c/sqlite3.c"
 }
 $10 = HEAP8[$4>>0]|0; //@line 111974 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 111974 "c/sqlite3.c"
 $12 = $11&1; //@line 111974 "c/sqlite3.c"
 STACKTOP = sp;return ($12|0); //@line 111974 "c/sqlite3.c"
}
function _sqlite3RowidConstraint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$011 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer2 = sp + 8|0; //@line 105816 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 105816 "c/sqlite3.c"
 $3 = ((($2)) + 40|0); //@line 105822 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 105822 "c/sqlite3.c"
 $5 = ($4<<16>>16)>(-1); //@line 105822 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0;
 $7 = HEAP32[$2>>2]|0;
 if ($5) {
  $8 = $4 << 16 >> 16; //@line 105822 "c/sqlite3.c"
  $9 = ((($2)) + 4|0); //@line 105824 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 105824 "c/sqlite3.c"
  $11 = (($10) + ($8<<4)|0); //@line 105824 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 105824 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $7; //@line 105823 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 105823 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $12; //@line 105823 "c/sqlite3.c"
  $13 = (_sqlite3MPrintf($6,17909,$vararg_buffer)|0); //@line 105823 "c/sqlite3.c"
  $$0 = 1555;$$011 = $13;
  _sqlite3HaltConstraint($0,$$0,$1,$$011,-7,2); //@line 105830 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105832 "c/sqlite3.c"
 } else {
  HEAP32[$vararg_buffer2>>2] = $7; //@line 105827 "c/sqlite3.c"
  $14 = (_sqlite3MPrintf($6,27994,$vararg_buffer2)|0); //@line 105827 "c/sqlite3.c"
  $$0 = 2579;$$011 = $14;
  _sqlite3HaltConstraint($0,$$0,$1,$$011,-7,2); //@line 105830 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 105832 "c/sqlite3.c"
 }
}
function _sqlite3FkRequired($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$025 = 0, $$02536 = 0, $$02538 = 0, $$026$lcssa = 0, $$02637 = 0, $$129 = 0, $$133 = 0, $$232 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $phitmp = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 110523 "c/sqlite3.c"
 $5 = ((($4)) + 28|0); //@line 110523 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 110523 "c/sqlite3.c"
 $7 = $6 & 16384; //@line 110523 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 110523 "c/sqlite3.c"
 if ($8) {
  $$129 = 0;
  return ($$129|0); //@line 110552 "c/sqlite3.c"
 }
 $9 = ($2|0)==(0|0); //@line 110524 "c/sqlite3.c"
 if ($9) {
  $10 = (_sqlite3FkReferences($1)|0); //@line 110528 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 110528 "c/sqlite3.c"
  if (!($11)) {
   $$129 = 1;
   return ($$129|0); //@line 110552 "c/sqlite3.c"
  }
  $12 = ((($1)) + 16|0); //@line 110528 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 110528 "c/sqlite3.c"
  $14 = ($13|0)!=(0|0); //@line 110528 "c/sqlite3.c"
  $phitmp = $14&1; //@line 110528 "c/sqlite3.c"
  $$129 = $phitmp;
  return ($$129|0); //@line 110552 "c/sqlite3.c"
 }
 $15 = ((($1)) + 16|0); //@line 110535 "c/sqlite3.c"
 $$02536 = HEAP32[$15>>2]|0;
 $16 = ($$02536|0)==(0|0); //@line 110535 "c/sqlite3.c"
 L11: do {
  if ($16) {
   $$026$lcssa = 0;
  } else {
   $17 = HEAP32[$1>>2]|0;
   $$02538 = $$02536;$$02637 = 0;
   while(1) {
    $18 = ((($$02538)) + 8|0); //@line 110536 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 110536 "c/sqlite3.c"
    $20 = (_sqlite3_stricmp($17,$19)|0); //@line 110536 "c/sqlite3.c"
    $21 = ($20|0)==(0); //@line 110536 "c/sqlite3.c"
    if ($21) {
     $$129 = 2;
     break;
    }
    $22 = (_fkChildIsModified($1,$$02538,$2,$3)|0); //@line 110537 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 110537 "c/sqlite3.c"
    $spec$select = $23 ? $$02637 : 1; //@line 110537 "c/sqlite3.c"
    $24 = ((($$02538)) + 4|0); //@line 110535 "c/sqlite3.c"
    $$025 = HEAP32[$24>>2]|0;
    $25 = ($$025|0)==(0|0); //@line 110535 "c/sqlite3.c"
    if ($25) {
     $$026$lcssa = $spec$select;
     break L11;
    } else {
     $$02538 = $$025;$$02637 = $spec$select;
    }
   }
   return ($$129|0); //@line 110552 "c/sqlite3.c"
  }
 } while(0);
 $26 = (_sqlite3FkReferences($1)|0); //@line 110543 "c/sqlite3.c"
 $27 = ($26|0)==(0|0); //@line 110543 "c/sqlite3.c"
 if ($27) {
  $$129 = $$026$lcssa;
  return ($$129|0); //@line 110552 "c/sqlite3.c"
 }
 $$133 = $26;$$232 = $$026$lcssa;
 while(1) {
  $28 = (_fkParentIsModified($1,$$133,$2,$3)|0); //@line 110544 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 110544 "c/sqlite3.c"
  if ($29) {
   $$3 = $$232;
  } else {
   $30 = ((($$133)) + 26|0); //@line 110545 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 110545 "c/sqlite3.c"
   $32 = ($31<<24>>24)==(0); //@line 110545 "c/sqlite3.c"
   if ($32) {
    $$3 = 1;
   } else {
    $$129 = 2;
    label = 14;
    break;
   }
  }
  $33 = ((($$133)) + 12|0); //@line 110543 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 110543 "c/sqlite3.c"
  $35 = ($34|0)==(0|0); //@line 110543 "c/sqlite3.c"
  if ($35) {
   $$129 = $$3;
   label = 14;
   break;
  } else {
   $$133 = $34;$$232 = $$3;
  }
 }
 if ((label|0) == 14) {
  return ($$129|0); //@line 110552 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3MultiWrite($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 120|0); //@line 105730 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 105730 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 105730 "c/sqlite3.c"
 $spec$select = $3 ? $0 : $2; //@line 105730 "c/sqlite3.c"
 $4 = ((($spec$select)) + 20|0); //@line 105731 "c/sqlite3.c"
 HEAP8[$4>>0] = 1; //@line 105731 "c/sqlite3.c"
 return; //@line 105732 "c/sqlite3.c"
}
function _sqlite3GenerateRowDelete($0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$10) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 $8 = $8|0;
 $9 = $9|0;
 $10 = $10|0;
 var $$0103 = 0, $$0104107 = 0, $$0105 = 0, $$1 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $or$cond = 0, $or$cond106 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $11 = ((($0)) + 8|0); //@line 107240 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 107240 "c/sqlite3.c"
 $13 = (_sqlite3VdbeMakeLabel($12)|0); //@line 107253 "c/sqlite3.c"
 $14 = ((($1)) + 36|0); //@line 107254 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 107254 "c/sqlite3.c"
 $16 = $15 & 32; //@line 107254 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 107254 "c/sqlite3.c"
 $18 = $17 ? 32 : 29; //@line 107254 "c/sqlite3.c"
 $19 = ($9<<24>>24)==(0); //@line 107255 "c/sqlite3.c"
 if ($19) {
  $20 = $6 << 16 >> 16; //@line 107256 "c/sqlite3.c"
  $21 = $18&255; //@line 107256 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4Int($12,$21,$3,$13,$5,$20)|0); //@line 107256 "c/sqlite3.c"
 }
 $22 = (_sqlite3FkRequired($0,$1,0,0)|0); //@line 107263 "c/sqlite3.c"
 $23 = ($22|0)!=(0); //@line 107263 "c/sqlite3.c"
 $24 = ($2|0)!=(0|0); //@line 107263 "c/sqlite3.c"
 $or$cond = $24 | $23; //@line 107263 "c/sqlite3.c"
 if ($or$cond) {
  $25 = $8&255; //@line 107271 "c/sqlite3.c"
  $26 = (_sqlite3TriggerColmask($0,$2,0,0,3,$1,$25)|0); //@line 107270 "c/sqlite3.c"
  $27 = (_sqlite3FkOldmask($0,$1)|0); //@line 107273 "c/sqlite3.c"
  $28 = $27 | $26; //@line 107273 "c/sqlite3.c"
  $29 = ((($0)) + 44|0); //@line 107274 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 107274 "c/sqlite3.c"
  $31 = (($30) + 1)|0; //@line 107274 "c/sqlite3.c"
  $32 = ((($1)) + 42|0); //@line 107275 "c/sqlite3.c"
  $33 = HEAP16[$32>>1]|0; //@line 107275 "c/sqlite3.c"
  $34 = $33 << 16 >> 16; //@line 107275 "c/sqlite3.c"
  $35 = (($30) + 1)|0; //@line 107275 "c/sqlite3.c"
  $36 = (($35) + ($34))|0; //@line 107275 "c/sqlite3.c"
  HEAP32[$29>>2] = $36; //@line 107275 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($12,75,$5,$31)|0); //@line 107279 "c/sqlite3.c"
  $37 = HEAP16[$32>>1]|0; //@line 107280 "c/sqlite3.c"
  $38 = ($37<<16>>16)>(0); //@line 107280 "c/sqlite3.c"
  if ($38) {
   $39 = ($28|0)==(-1);
   $$0104107 = 0;
   while(1) {
    if ($39) {
     label = 9;
    } else {
     $40 = ($$0104107>>>0)<(32); //@line 107283 "c/sqlite3.c"
     if ($40) {
      $41 = 1 << $$0104107; //@line 107283 "c/sqlite3.c"
      $42 = $41 & $28; //@line 107283 "c/sqlite3.c"
      $43 = ($42|0)==(0); //@line 107283 "c/sqlite3.c"
      if (!($43)) {
       label = 9;
      }
     }
    }
    if ((label|0) == 9) {
     label = 0;
     $44 = (($$0104107) + 1)|0; //@line 107284 "c/sqlite3.c"
     $45 = (($44) + ($31))|0; //@line 107284 "c/sqlite3.c"
     _sqlite3ExprCodeGetColumnOfTable($12,$1,$3,$$0104107,$45); //@line 107284 "c/sqlite3.c"
    }
    $46 = (($$0104107) + 1)|0; //@line 107280 "c/sqlite3.c"
    $47 = HEAP16[$32>>1]|0; //@line 107280 "c/sqlite3.c"
    $48 = $47 << 16 >> 16; //@line 107280 "c/sqlite3.c"
    $49 = ($46|0)<($48|0); //@line 107280 "c/sqlite3.c"
    if ($49) {
     $$0104107 = $46;
    } else {
     break;
    }
   }
  }
  $50 = (_sqlite3VdbeCurrentAddr($12)|0); //@line 107289 "c/sqlite3.c"
  _sqlite3CodeRowTrigger($0,$2,109,0,1,$1,$31,$25,$13); //@line 107290 "c/sqlite3.c"
  $51 = (_sqlite3VdbeCurrentAddr($12)|0); //@line 107302 "c/sqlite3.c"
  $52 = ($50|0)<($51|0); //@line 107302 "c/sqlite3.c"
  if ($52) {
   $53 = $6 << 16 >> 16; //@line 107303 "c/sqlite3.c"
   $54 = $18&255; //@line 107303 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4Int($12,$54,$3,$13,$5,$53)|0); //@line 107303 "c/sqlite3.c"
   $$0103 = -1;
  } else {
   $$0103 = $10;
  }
  _sqlite3FkCheck($0,$1,$31,0,0,0); //@line 107313 "c/sqlite3.c"
  $$0105 = $31;$$1 = $$0103;
 } else {
  $$0105 = 0;$$1 = $10;
 }
 $55 = ((($1)) + 12|0); //@line 107326 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 107326 "c/sqlite3.c"
 $57 = ($56|0)==(0|0); //@line 107326 "c/sqlite3.c"
 if (!($57)) {
  _sqlite3FkActions($0,$1,0,$$0105,0,0); //@line 107346 "c/sqlite3.c"
  $69 = $8&255; //@line 107350 "c/sqlite3.c"
  _sqlite3CodeRowTrigger($0,$2,109,0,2,$1,$$0105,$69,$13); //@line 107349 "c/sqlite3.c"
  _sqlite3VdbeResolveLabel($12,$13); //@line 107356 "c/sqlite3.c"
  return; //@line 107358 "c/sqlite3.c"
 }
 _sqlite3GenerateRowIndexDelete($0,$1,$3,$4,0,$$1); //@line 107328 "c/sqlite3.c"
 $58 = ($7<<24>>24)!=(0); //@line 107329 "c/sqlite3.c"
 $59 = $58&1; //@line 107329 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($12,119,$3,$59)|0); //@line 107329 "c/sqlite3.c"
 $60 = ((($0)) + 18|0); //@line 107330 "c/sqlite3.c"
 $61 = HEAP8[$60>>0]|0; //@line 107330 "c/sqlite3.c"
 $62 = ($61<<24>>24)==(0); //@line 107330 "c/sqlite3.c"
 if ($62) {
  label = 17;
 } else {
  $63 = HEAP32[$1>>2]|0; //@line 107330 "c/sqlite3.c"
  $64 = (_sqlite3_stricmp($63,21606)|0); //@line 107330 "c/sqlite3.c"
  $65 = ($64|0)==(0); //@line 107330 "c/sqlite3.c"
  if ($65) {
   label = 17;
  }
 }
 if ((label|0) == 17) {
  _sqlite3VdbeAppendP4($12,$1,-6); //@line 107331 "c/sqlite3.c"
 }
 if (!($19)) {
  _sqlite3VdbeChangeP5($12,4); //@line 107334 "c/sqlite3.c"
 }
 $66 = ($$1|0)<(0); //@line 107336 "c/sqlite3.c"
 $67 = ($$1|0)==($3|0); //@line 107336 "c/sqlite3.c"
 $or$cond106 = $66 | $67; //@line 107336 "c/sqlite3.c"
 if (!($or$cond106)) {
  (_sqlite3VdbeAddOp1($12,119,$$1)|0); //@line 107337 "c/sqlite3.c"
 }
 $68 = ($9<<24>>24)==(2); //@line 107339 "c/sqlite3.c"
 $spec$select = $68 ? 2 : 0; //@line 107339 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($12,$spec$select); //@line 107340 "c/sqlite3.c"
 _sqlite3FkActions($0,$1,0,$$0105,0,0); //@line 107346 "c/sqlite3.c"
 $69 = $8&255; //@line 107350 "c/sqlite3.c"
 _sqlite3CodeRowTrigger($0,$2,109,0,2,$1,$$0105,$69,$13); //@line 107349 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($12,$13); //@line 107356 "c/sqlite3.c"
 return; //@line 107358 "c/sqlite3.c"
}
function _sqlite3GenerateRowIndexDelete($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$03844 = 0, $$03943 = 0, $$041 = 0, $$04142 = 0, $$04147 = 0, $$045 = 0, $$1 = 0, $$140 = 0, $$old = 0, $$sink = 0, $$sink$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp;
 $7 = ((($0)) + 8|0); //@line 107394 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 107394 "c/sqlite3.c"
 $9 = ((($1)) + 36|0); //@line 107395 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 107395 "c/sqlite3.c"
 $11 = $10 & 32; //@line 107395 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 107395 "c/sqlite3.c"
 if ($12) {
  $21 = 0;
 } else {
  $13 = (_sqlite3PrimaryKeyIndex($1)|0); //@line 107395 "c/sqlite3.c"
  $21 = $13;
 }
 $14 = ((($1)) + 8|0); //@line 107396 "c/sqlite3.c"
 $$04142 = HEAP32[$14>>2]|0;
 $15 = ($$04142|0)==(0|0); //@line 107396 "c/sqlite3.c"
 if ($15) {
  STACKTOP = sp;return; //@line 107409 "c/sqlite3.c"
 }
 $16 = ($4|0)==(0|0);
 $$03844 = -1;$$03943 = 0;$$04147 = $$04142;$$045 = 0;
 while(1) {
  if ($16) {
   $$old = ($$04147|0)==($21|0); //@line 107399 "c/sqlite3.c"
   if ($$old) {
    $$1 = $$03844;$$140 = $$03943;
   } else {
    label = 8;
   }
  } else {
   $17 = (($4) + ($$045<<2)|0); //@line 107398 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 107398 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 107398 "c/sqlite3.c"
   $20 = ($$04147|0)==($21|0); //@line 107399 "c/sqlite3.c"
   $or$cond = $20 | $19; //@line 107398 "c/sqlite3.c"
   if ($or$cond) {
    $$1 = $$03844;$$140 = $$03943;
   } else {
    label = 8;
   }
  }
  if ((label|0) == 8) {
   label = 0;
   $22 = (($$045) + ($3))|0; //@line 107400 "c/sqlite3.c"
   $23 = ($22|0)==($5|0); //@line 107400 "c/sqlite3.c"
   if ($23) {
    $$1 = $$03844;$$140 = $$03943;
   } else {
    $24 = (_sqlite3GenerateIndexKey($0,$$04147,$2,0,1,$6,$$03943,$$03844)|0); //@line 107402 "c/sqlite3.c"
    $25 = ((($$04147)) + 55|0); //@line 107405 "c/sqlite3.c"
    $26 = HEAPU8[$25>>0]|(HEAPU8[$25+1>>0]<<8); //@line 107405 "c/sqlite3.c"
    $27 = $26 & 8; //@line 107405 "c/sqlite3.c"
    $28 = ($27<<16>>16)==(0); //@line 107405 "c/sqlite3.c"
    $29 = ((($$04147)) + 52|0); //@line 107405 "c/sqlite3.c"
    $30 = ((($$04147)) + 50|0); //@line 107405 "c/sqlite3.c"
    $$sink$in = $28 ? $29 : $30; //@line 107405 "c/sqlite3.c"
    $$sink = HEAP16[$$sink$in>>1]|0;
    $31 = $$sink&65535;
    (_sqlite3VdbeAddOp3($8,129,$22,$24,$31)|0); //@line 107404 "c/sqlite3.c"
    $32 = HEAP32[$6>>2]|0; //@line 107406 "c/sqlite3.c"
    _sqlite3ResolvePartIdxLabel($0,$32); //@line 107406 "c/sqlite3.c"
    $$1 = $24;$$140 = $$04147;
   }
  }
  $33 = (($$045) + 1)|0; //@line 107396 "c/sqlite3.c"
  $34 = ((($$04147)) + 20|0); //@line 107396 "c/sqlite3.c"
  $$041 = HEAP32[$34>>2]|0;
  $35 = ($$041|0)==(0|0); //@line 107396 "c/sqlite3.c"
  if ($35) {
   break;
  } else {
   $$03844 = $$1;$$03943 = $$140;$$04147 = $$041;$$045 = $33;
  }
 }
 STACKTOP = sp;return; //@line 107409 "c/sqlite3.c"
}
function _sqlite3TriggerColmask($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0$lcssa = 0, $$02526 = 0, $$027 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $7 = ($2|0)==(0|0); //@line 126055 "c/sqlite3.c"
 $8 = $7 ? 109 : 110; //@line 126055 "c/sqlite3.c"
 $9 = ($1|0)==(0|0); //@line 126060 "c/sqlite3.c"
 if ($9) {
  $$0$lcssa = 0;
  return ($$0$lcssa|0); //@line 126072 "c/sqlite3.c"
 }
 $$02526 = $1;$$027 = 0;
 while(1) {
  $10 = ((($$02526)) + 8|0); //@line 126061 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 126061 "c/sqlite3.c"
  $12 = $11&255; //@line 126061 "c/sqlite3.c"
  $13 = ($8|0)==($12|0); //@line 126061 "c/sqlite3.c"
  if ($13) {
   $14 = ((($$02526)) + 9|0); //@line 126061 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 126061 "c/sqlite3.c"
   $16 = $15&255; //@line 126061 "c/sqlite3.c"
   $17 = $16 & $4; //@line 126061 "c/sqlite3.c"
   $18 = ($17|0)==(0); //@line 126061 "c/sqlite3.c"
   if ($18) {
    $$2 = $$027;
   } else {
    $19 = ((($$02526)) + 16|0); //@line 126062 "c/sqlite3.c"
    $20 = HEAP32[$19>>2]|0; //@line 126062 "c/sqlite3.c"
    $21 = (_checkColumnOverlap($20,$2)|0); //@line 126062 "c/sqlite3.c"
    $22 = ($21|0)==(0); //@line 126062 "c/sqlite3.c"
    if ($22) {
     $$2 = $$027;
    } else {
     $23 = (_getRowTrigger($0,$$02526,$5,$6)|0); //@line 126065 "c/sqlite3.c"
     $24 = ($23|0)==(0|0); //@line 126066 "c/sqlite3.c"
     if ($24) {
      $$2 = $$027;
     } else {
      $25 = (((($23)) + 16|0) + ($3<<2)|0); //@line 126067 "c/sqlite3.c"
      $26 = HEAP32[$25>>2]|0; //@line 126067 "c/sqlite3.c"
      $27 = $26 | $$027; //@line 126067 "c/sqlite3.c"
      $$2 = $27;
     }
    }
   }
  } else {
   $$2 = $$027;
  }
  $28 = ((($$02526)) + 32|0); //@line 126060 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 126060 "c/sqlite3.c"
  $30 = ($29|0)==(0|0); //@line 126060 "c/sqlite3.c"
  if ($30) {
   $$0$lcssa = $$2;
   break;
  } else {
   $$02526 = $29;$$027 = $$2;
  }
 }
 return ($$0$lcssa|0); //@line 126072 "c/sqlite3.c"
}
function _sqlite3FkOldmask($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$027 = 0, $$02742 = 0, $$02744 = 0, $$029$lcssa = 0, $$02943 = 0, $$039 = 0, $$12835 = 0, $$130$lcssa = 0, $$13038 = 0, $$133 = 0, $$234 = 0, $$332 = 0, $$4 = 0, $$5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 110473 "c/sqlite3.c"
 $4 = ((($3)) + 28|0); //@line 110473 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 110473 "c/sqlite3.c"
 $6 = $5 & 16384; //@line 110473 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 110473 "c/sqlite3.c"
 if ($7) {
  $$5 = 0;
  STACKTOP = sp;return ($$5|0); //@line 110490 "c/sqlite3.c"
 }
 $8 = ((($1)) + 16|0); //@line 110476 "c/sqlite3.c"
 $$02742 = HEAP32[$8>>2]|0;
 $9 = ($$02742|0)==(0|0); //@line 110476 "c/sqlite3.c"
 if ($9) {
  $$029$lcssa = 0;
 } else {
  $$02744 = $$02742;$$02943 = 0;
  while(1) {
   $10 = ((($$02744)) + 20|0); //@line 110477 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 110477 "c/sqlite3.c"
   $12 = ($11|0)>(0); //@line 110477 "c/sqlite3.c"
   if ($12) {
    $13 = HEAP32[$10>>2]|0;
    $$039 = 0;$$13038 = $$02943;
    while(1) {
     $14 = (((($$02744)) + 36|0) + ($$039<<3)|0); //@line 110477 "c/sqlite3.c"
     $15 = HEAP32[$14>>2]|0; //@line 110477 "c/sqlite3.c"
     $16 = ($15|0)>(31); //@line 110477 "c/sqlite3.c"
     $17 = 1 << $15; //@line 110477 "c/sqlite3.c"
     $spec$select = $16 ? -1 : $17; //@line 110477 "c/sqlite3.c"
     $18 = $spec$select | $$13038; //@line 110477 "c/sqlite3.c"
     $19 = (($$039) + 1)|0; //@line 110477 "c/sqlite3.c"
     $20 = ($19|0)<($13|0); //@line 110477 "c/sqlite3.c"
     if ($20) {
      $$039 = $19;$$13038 = $18;
     } else {
      $$130$lcssa = $18;
      break;
     }
    }
   } else {
    $$130$lcssa = $$02943;
   }
   $21 = ((($$02744)) + 4|0); //@line 110476 "c/sqlite3.c"
   $$027 = HEAP32[$21>>2]|0;
   $22 = ($$027|0)==(0|0); //@line 110476 "c/sqlite3.c"
   if ($22) {
    $$029$lcssa = $$130$lcssa;
    break;
   } else {
    $$02744 = $$027;$$02943 = $$130$lcssa;
   }
  }
 }
 $23 = (_sqlite3FkReferences($1)|0); //@line 110479 "c/sqlite3.c"
 $24 = ($23|0)==(0|0); //@line 110479 "c/sqlite3.c"
 if ($24) {
  $$5 = $$029$lcssa;
  STACKTOP = sp;return ($$5|0); //@line 110490 "c/sqlite3.c"
 }
 $$12835 = $23;$$234 = $$029$lcssa;
 while(1) {
  HEAP32[$2>>2] = 0; //@line 110480 "c/sqlite3.c"
  (_sqlite3FkLocateIndex($0,$1,$$12835,$2,0)|0); //@line 110481 "c/sqlite3.c"
  $25 = HEAP32[$2>>2]|0; //@line 110482 "c/sqlite3.c"
  $26 = ($25|0)==(0|0); //@line 110482 "c/sqlite3.c"
  if ($26) {
   $$4 = $$234;
  } else {
   $27 = ((($25)) + 50|0); //@line 110483 "c/sqlite3.c"
   $28 = HEAP16[$27>>1]|0; //@line 110483 "c/sqlite3.c"
   $29 = ($28<<16>>16)==(0); //@line 110483 "c/sqlite3.c"
   if ($29) {
    $$4 = $$234;
   } else {
    $30 = ((($25)) + 4|0);
    $31 = HEAP32[$30>>2]|0;
    $32 = HEAP16[$27>>1]|0;
    $33 = $32&65535;
    $$133 = 0;$$332 = $$234;
    while(1) {
     $34 = (($31) + ($$133<<1)|0); //@line 110485 "c/sqlite3.c"
     $35 = HEAP16[$34>>1]|0; //@line 110485 "c/sqlite3.c"
     $36 = ($35<<16>>16)>(31); //@line 110485 "c/sqlite3.c"
     $37 = $35 << 16 >> 16; //@line 110485 "c/sqlite3.c"
     $38 = 1 << $37; //@line 110485 "c/sqlite3.c"
     $39 = $36 ? -1 : $38; //@line 110485 "c/sqlite3.c"
     $40 = $39 | $$332; //@line 110485 "c/sqlite3.c"
     $41 = (($$133) + 1)|0; //@line 110483 "c/sqlite3.c"
     $42 = ($41>>>0)<($33>>>0); //@line 110483 "c/sqlite3.c"
     if ($42) {
      $$133 = $41;$$332 = $40;
     } else {
      $$4 = $40;
      break;
     }
    }
   }
  }
  $43 = ((($$12835)) + 12|0); //@line 110479 "c/sqlite3.c"
  $44 = HEAP32[$43>>2]|0; //@line 110479 "c/sqlite3.c"
  $45 = ($44|0)==(0|0); //@line 110479 "c/sqlite3.c"
  if ($45) {
   $$5 = $$4;
   break;
  } else {
   $$12835 = $44;$$234 = $$4;
  }
 }
 STACKTOP = sp;return ($$5|0); //@line 110490 "c/sqlite3.c"
}
function _sqlite3FkActions($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$020 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = HEAP32[$0>>2]|0; //@line 110777 "c/sqlite3.c"
 $7 = ((($6)) + 28|0); //@line 110777 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 110777 "c/sqlite3.c"
 $9 = $8 & 16384; //@line 110777 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 110777 "c/sqlite3.c"
 if ($10) {
  return; //@line 110788 "c/sqlite3.c"
 }
 $11 = (_sqlite3FkReferences($1)|0); //@line 110779 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 110779 "c/sqlite3.c"
 if ($12) {
  return; //@line 110788 "c/sqlite3.c"
 }
 $13 = ($4|0)==(0|0);
 $$020 = $11;
 while(1) {
  if ($13) {
   label = 6;
  } else {
   $14 = (_fkParentIsModified($1,$$020,$4,$5)|0); //@line 110780 "c/sqlite3.c"
   $15 = ($14|0)==(0); //@line 110780 "c/sqlite3.c"
   if (!($15)) {
    label = 6;
   }
  }
  if ((label|0) == 6) {
   label = 0;
   $16 = (_fkActionTrigger($0,$1,$$020,$2)|0); //@line 110781 "c/sqlite3.c"
   $17 = ($16|0)==(0|0); //@line 110782 "c/sqlite3.c"
   if (!($17)) {
    _sqlite3CodeRowTriggerDirect($0,$16,$1,$3,2,0); //@line 110783 "c/sqlite3.c"
   }
  }
  $18 = ((($$020)) + 12|0); //@line 110779 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 110779 "c/sqlite3.c"
  $20 = ($19|0)==(0|0); //@line 110779 "c/sqlite3.c"
  if ($20) {
   break;
  } else {
   $$020 = $19;
  }
 }
 return; //@line 110788 "c/sqlite3.c"
}
function _fkActionTrigger($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0172$lcssa = 0, $$0172186 = 0, $$0174185 = 0, $$0175 = 0, $$0176$lcssa = 0, $$0176184 = 0, $$0178$lcssa = 0, $$0178183 = 0, $$0180 = 0, $$1 = 0, $$1170 = 0, $$1173 = 0, $$1177 = 0, $$1179 = 0, $$2 = 0, $$in = 0, $$sink = 0, $$sink$in = 0, $$sink189 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0;
 var $or$cond = 0, $or$cond182 = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp + 36|0;
 $5 = sp + 32|0;
 $6 = sp + 8|0;
 $7 = sp;
 $8 = sp + 24|0;
 $9 = sp + 16|0;
 $10 = HEAP32[$0>>2]|0; //@line 110589 "c/sqlite3.c"
 $11 = ($3|0)!=(0|0); //@line 110592 "c/sqlite3.c"
 $12 = $11&1; //@line 110592 "c/sqlite3.c"
 $13 = (((($2)) + 25|0) + ($12)|0); //@line 110594 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 110594 "c/sqlite3.c"
 $15 = ($14<<24>>24)==(6); //@line 110595 "c/sqlite3.c"
 if ($15) {
  $16 = ((($10)) + 28|0); //@line 110595 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 110595 "c/sqlite3.c"
  $18 = $17 & 524288; //@line 110595 "c/sqlite3.c"
  $19 = ($18|0)==(0); //@line 110595 "c/sqlite3.c"
  if (!($19)) {
   $$1 = 0;
   STACKTOP = sp;return ($$1|0); //@line 110759 "c/sqlite3.c"
  }
 }
 $20 = (((($2)) + 28|0) + ($12<<2)|0); //@line 110598 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 110598 "c/sqlite3.c"
 $22 = ($14<<24>>24)==(0); //@line 110600 "c/sqlite3.c"
 $23 = ($21|0)!=(0|0); //@line 110600 "c/sqlite3.c"
 $or$cond = $22 | $23; //@line 110600 "c/sqlite3.c"
 if ($or$cond) {
  $$1 = $21;
  STACKTOP = sp;return ($$1|0); //@line 110759 "c/sqlite3.c"
 }
 HEAP32[$4>>2] = 0; //@line 110603 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 110604 "c/sqlite3.c"
 $24 = (_sqlite3FkLocateIndex($0,$1,$2,$4,$5)|0); //@line 110612 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 110612 "c/sqlite3.c"
 do {
  if ($25) {
   $26 = ((($2)) + 20|0); //@line 110615 "c/sqlite3.c"
   $27 = HEAP32[$26>>2]|0; //@line 110615 "c/sqlite3.c"
   $28 = ($27|0)>(0); //@line 110615 "c/sqlite3.c"
   if ($28) {
    $29 = 280;
    $30 = $29;
    $31 = HEAP32[$30>>2]|0;
    $32 = (($29) + 4)|0;
    $33 = $32;
    $34 = HEAP32[$33>>2]|0;
    $35 = 288;
    $36 = $35;
    $37 = HEAP32[$36>>2]|0;
    $38 = (($35) + 4)|0;
    $39 = $38;
    $40 = HEAP32[$39>>2]|0;
    $41 = ((($2)) + 36|0);
    $42 = ((($1)) + 4|0);
    $43 = HEAP32[$4>>2]|0;
    $44 = ($43|0)==(0|0);
    $45 = ((($1)) + 40|0);
    $46 = ((($43)) + 4|0);
    $47 = ($14<<24>>24)!=(6);
    $48 = ($14<<24>>24)!=(9);
    $or$cond3 = $11 | $48;
    $or$cond182 = $47 & $or$cond3;
    $$0172186 = 0;$$0174185 = 0;$$0176184 = 0;$$0178183 = 0;
    while(1) {
     $49 = $6; //@line 110616 "c/sqlite3.c"
     $50 = $49; //@line 110616 "c/sqlite3.c"
     HEAP32[$50>>2] = $31; //@line 110616 "c/sqlite3.c"
     $51 = (($49) + 4)|0; //@line 110616 "c/sqlite3.c"
     $52 = $51; //@line 110616 "c/sqlite3.c"
     HEAP32[$52>>2] = $34; //@line 110616 "c/sqlite3.c"
     $53 = $7; //@line 110617 "c/sqlite3.c"
     $54 = $53; //@line 110617 "c/sqlite3.c"
     HEAP32[$54>>2] = $37; //@line 110617 "c/sqlite3.c"
     $55 = (($53) + 4)|0; //@line 110617 "c/sqlite3.c"
     $56 = $55; //@line 110617 "c/sqlite3.c"
     HEAP32[$56>>2] = $40; //@line 110617 "c/sqlite3.c"
     $57 = HEAP32[$5>>2]|0; //@line 110623 "c/sqlite3.c"
     $58 = ($57|0)==(0|0); //@line 110623 "c/sqlite3.c"
     $59 = (($57) + ($$0174185<<2)|0); //@line 110623 "c/sqlite3.c"
     $$in = $58 ? $41 : $59; //@line 110623 "c/sqlite3.c"
     $60 = HEAP32[$$in>>2]|0; //@line 110623 "c/sqlite3.c"
     $61 = HEAP32[$42>>2]|0; //@line 110628 "c/sqlite3.c"
     if ($44) {
      $$sink$in = $45;
     } else {
      $62 = HEAP32[$46>>2]|0; //@line 110628 "c/sqlite3.c"
      $63 = (($62) + ($$0174185<<1)|0); //@line 110628 "c/sqlite3.c"
      $$sink$in = $63;
     }
     $$sink = HEAP16[$$sink$in>>1]|0;
     $64 = $$sink << 16 >> 16;
     $65 = (($61) + ($64<<4)|0); //@line 110628 "c/sqlite3.c"
     $66 = HEAP32[$65>>2]|0; //@line 110628 "c/sqlite3.c"
     _sqlite3TokenInit($9,$66); //@line 110627 "c/sqlite3.c"
     $67 = HEAP32[$2>>2]|0; //@line 110629 "c/sqlite3.c"
     $68 = ((($67)) + 4|0); //@line 110629 "c/sqlite3.c"
     $69 = HEAP32[$68>>2]|0; //@line 110629 "c/sqlite3.c"
     $70 = (($69) + ($60<<4)|0); //@line 110629 "c/sqlite3.c"
     $71 = HEAP32[$70>>2]|0; //@line 110629 "c/sqlite3.c"
     _sqlite3TokenInit($8,$71); //@line 110629 "c/sqlite3.c"
     $72 = (_sqlite3ExprAlloc($10,59,$6,0)|0); //@line 110637 "c/sqlite3.c"
     $73 = (_sqlite3ExprAlloc($10,59,$9,0)|0); //@line 110638 "c/sqlite3.c"
     $74 = (_sqlite3PExpr($0,122,$72,$73)|0); //@line 110636 "c/sqlite3.c"
     $75 = (_sqlite3ExprAlloc($10,59,$8,0)|0); //@line 110639 "c/sqlite3.c"
     $76 = (_sqlite3PExpr($0,53,$74,$75)|0); //@line 110635 "c/sqlite3.c"
     $77 = (_sqlite3ExprAnd($10,$$0178183,$76)|0); //@line 110641 "c/sqlite3.c"
     if ($11) {
      $78 = (_sqlite3ExprAlloc($10,59,$6,0)|0); //@line 110651 "c/sqlite3.c"
      $79 = (_sqlite3ExprAlloc($10,59,$9,0)|0); //@line 110652 "c/sqlite3.c"
      $80 = (_sqlite3PExpr($0,122,$78,$79)|0); //@line 110650 "c/sqlite3.c"
      $81 = (_sqlite3ExprAlloc($10,59,$7,0)|0); //@line 110654 "c/sqlite3.c"
      $82 = (_sqlite3ExprAlloc($10,59,$9,0)|0); //@line 110655 "c/sqlite3.c"
      $83 = (_sqlite3PExpr($0,122,$81,$82)|0); //@line 110653 "c/sqlite3.c"
      $84 = (_sqlite3PExpr($0,45,$80,$83)|0); //@line 110649 "c/sqlite3.c"
      $85 = (_sqlite3ExprAnd($10,$$0172186,$84)|0); //@line 110657 "c/sqlite3.c"
      $$1173 = $85;
     } else {
      $$1173 = $$0172186;
     }
     if ($or$cond182) {
      L22: do {
       switch ($14<<24>>24) {
       case 9:  {
        $86 = (_sqlite3ExprAlloc($10,59,$7,0)|0); //@line 110664 "c/sqlite3.c"
        $87 = (_sqlite3ExprAlloc($10,59,$9,0)|0); //@line 110665 "c/sqlite3.c"
        $88 = (_sqlite3PExpr($0,122,$86,$87)|0); //@line 110663 "c/sqlite3.c"
        $$1170 = $88;
        break;
       }
       case 8:  {
        $89 = HEAP32[$2>>2]|0; //@line 110667 "c/sqlite3.c"
        $90 = ((($89)) + 4|0); //@line 110667 "c/sqlite3.c"
        $91 = HEAP32[$90>>2]|0; //@line 110667 "c/sqlite3.c"
        $92 = (((($91) + ($60<<4)|0)) + 4|0); //@line 110667 "c/sqlite3.c"
        $93 = HEAP32[$92>>2]|0; //@line 110667 "c/sqlite3.c"
        $94 = ($93|0)==(0|0); //@line 110668 "c/sqlite3.c"
        if ($94) {
         $96 = (_sqlite3ExprAlloc($10,101,0,0)|0); //@line 110671 "c/sqlite3.c"
         $$1170 = $96;
         break L22;
        } else {
         $95 = (_sqlite3ExprDup($10,$93,0)|0); //@line 110669 "c/sqlite3.c"
         $$1170 = $95;
         break L22;
        }
        break;
       }
       default: {
        $97 = (_sqlite3ExprAlloc($10,101,0,0)|0); //@line 110674 "c/sqlite3.c"
        $$1170 = $97;
       }
       }
      } while(0);
      $98 = (_sqlite3ExprListAppend($0,$$0176184,$$1170)|0); //@line 110676 "c/sqlite3.c"
      _sqlite3ExprListSetName($0,$98,$8,0); //@line 110677 "c/sqlite3.c"
      $$1177 = $98;
     } else {
      $$1177 = $$0176184;
     }
     $99 = (($$0174185) + 1)|0; //@line 110615 "c/sqlite3.c"
     $100 = HEAP32[$26>>2]|0; //@line 110615 "c/sqlite3.c"
     $101 = ($99|0)<($100|0); //@line 110615 "c/sqlite3.c"
     if ($101) {
      $$0172186 = $$1173;$$0174185 = $99;$$0176184 = $$1177;$$0178183 = $77;
     } else {
      $$0172$lcssa = $$1173;$$0176$lcssa = $$1177;$$0178$lcssa = $77;
      break;
     }
    }
   } else {
    $$0172$lcssa = 0;$$0176$lcssa = 0;$$0178$lcssa = 0;
   }
   $102 = HEAP32[$5>>2]|0; //@line 110680 "c/sqlite3.c"
   _sqlite3DbFree($10,$102); //@line 110680 "c/sqlite3.c"
   $103 = HEAP32[$2>>2]|0; //@line 110682 "c/sqlite3.c"
   $104 = HEAP32[$103>>2]|0; //@line 110682 "c/sqlite3.c"
   $105 = (_sqlite3Strlen30($104)|0); //@line 110683 "c/sqlite3.c"
   if ($15) {
    HEAP32[$6>>2] = $104; //@line 110689 "c/sqlite3.c"
    $106 = ((($6)) + 4|0); //@line 110690 "c/sqlite3.c"
    HEAP32[$106>>2] = $105; //@line 110690 "c/sqlite3.c"
    $107 = (_sqlite3Expr($10,70,18442)|0); //@line 110691 "c/sqlite3.c"
    $108 = ($107|0)==(0|0); //@line 110692 "c/sqlite3.c"
    if (!($108)) {
     $109 = ((($107)) + 1|0); //@line 110693 "c/sqlite3.c"
     HEAP8[$109>>0] = 2; //@line 110693 "c/sqlite3.c"
    }
    $110 = (_sqlite3ExprListAppend($0,0,$107)|0); //@line 110696 "c/sqlite3.c"
    $111 = (_sqlite3SrcListAppend($10,0,$6,0)|0); //@line 110697 "c/sqlite3.c"
    $112 = (_sqlite3SelectNew($0,$110,$111,$$0178$lcssa,0,0,0,0,0)|0); //@line 110695 "c/sqlite3.c"
    $$0175 = $112;$$1179 = 0;
   } else {
    $$0175 = 0;$$1179 = $$0178$lcssa;
   }
   $113 = ((($10)) + 264|0); //@line 110705 "c/sqlite3.c"
   $114 = HEAP32[$113>>2]|0; //@line 110705 "c/sqlite3.c"
   $115 = (($114) + 1)|0; //@line 110705 "c/sqlite3.c"
   HEAP32[$113>>2] = $115; //@line 110705 "c/sqlite3.c"
   $116 = (($105) + 77)|0; //@line 110710 "c/sqlite3.c"
   $117 = (_sqlite3DbMallocZero($10,$116,0)|0); //@line 110707 "c/sqlite3.c"
   $118 = ($117|0)==(0|0); //@line 110712 "c/sqlite3.c"
   if ($118) {
    $$0180 = 0;$$2 = $$0172$lcssa;
   } else {
    $119 = ((($117)) + 36|0); //@line 110713 "c/sqlite3.c"
    $120 = ((($117)) + 28|0); //@line 110713 "c/sqlite3.c"
    HEAP32[$120>>2] = $119; //@line 110713 "c/sqlite3.c"
    $121 = ((($117)) + 76|0); //@line 110714 "c/sqlite3.c"
    $122 = ((($117)) + 48|0); //@line 110714 "c/sqlite3.c"
    HEAP32[$122>>2] = $121; //@line 110714 "c/sqlite3.c"
    _memcpy(($121|0),($104|0),($105|0))|0; //@line 110715 "c/sqlite3.c"
    $123 = (_sqlite3ExprDup($10,$$1179,1)|0); //@line 110717 "c/sqlite3.c"
    $124 = ((($117)) + 52|0); //@line 110717 "c/sqlite3.c"
    HEAP32[$124>>2] = $123; //@line 110717 "c/sqlite3.c"
    $125 = (_sqlite3ExprListDup($10,$$0176$lcssa,1)|0); //@line 110718 "c/sqlite3.c"
    $126 = ((($117)) + 56|0); //@line 110718 "c/sqlite3.c"
    HEAP32[$126>>2] = $125; //@line 110718 "c/sqlite3.c"
    $127 = (_sqlite3SelectDup($10,$$0175,1)|0); //@line 110719 "c/sqlite3.c"
    $128 = ((($117)) + 44|0); //@line 110719 "c/sqlite3.c"
    HEAP32[$128>>2] = $127; //@line 110719 "c/sqlite3.c"
    $129 = ($$0172$lcssa|0)==(0|0); //@line 110720 "c/sqlite3.c"
    if ($129) {
     $$0180 = $119;$$2 = 0;
    } else {
     $130 = (_sqlite3PExpr($0,19,$$0172$lcssa,0)|0); //@line 110721 "c/sqlite3.c"
     $131 = (_sqlite3ExprDup($10,$130,1)|0); //@line 110722 "c/sqlite3.c"
     $132 = ((($117)) + 12|0); //@line 110722 "c/sqlite3.c"
     HEAP32[$132>>2] = $131; //@line 110722 "c/sqlite3.c"
     $$0180 = $119;$$2 = $130;
    }
   }
   $133 = HEAP32[$113>>2]|0; //@line 110727 "c/sqlite3.c"
   $134 = (($133) + -1)|0; //@line 110727 "c/sqlite3.c"
   HEAP32[$113>>2] = $134; //@line 110727 "c/sqlite3.c"
   _sqlite3ExprDelete($10,$$1179); //@line 110729 "c/sqlite3.c"
   _sqlite3ExprDelete($10,$$2); //@line 110730 "c/sqlite3.c"
   _sqlite3ExprListDelete($10,$$0176$lcssa); //@line 110731 "c/sqlite3.c"
   _sqlite3SelectDelete($10,$$0175); //@line 110732 "c/sqlite3.c"
   $135 = ((($10)) + 73|0); //@line 110733 "c/sqlite3.c"
   $136 = HEAP8[$135>>0]|0; //@line 110733 "c/sqlite3.c"
   $137 = ($136<<24>>24)==(1); //@line 110733 "c/sqlite3.c"
   if ($137) {
    _fkTriggerDelete($10,$117); //@line 110734 "c/sqlite3.c"
    break;
   }
   switch ($14<<24>>24) {
   case 6:  {
    $$sink189 = 119;
    break;
   }
   case 9:  {
    if ($11) {
     label = 31;
    } else {
     $$sink189 = 109;
    }
    break;
   }
   default: {
    label = 31;
   }
   }
   if ((label|0) == 31) {
    $$sink189 = 110;
   }
   HEAP8[$$0180>>0] = $$sink189;
   $138 = ((($$0180)) + 4|0); //@line 110751 "c/sqlite3.c"
   HEAP32[$138>>2] = $117; //@line 110751 "c/sqlite3.c"
   $139 = ((($1)) + 72|0); //@line 110752 "c/sqlite3.c"
   $140 = HEAP32[$139>>2]|0; //@line 110752 "c/sqlite3.c"
   $141 = ((($117)) + 20|0); //@line 110752 "c/sqlite3.c"
   HEAP32[$141>>2] = $140; //@line 110752 "c/sqlite3.c"
   $142 = ((($117)) + 24|0); //@line 110753 "c/sqlite3.c"
   HEAP32[$142>>2] = $140; //@line 110753 "c/sqlite3.c"
   HEAP32[$20>>2] = $117; //@line 110754 "c/sqlite3.c"
   $143 = $11 ? 110 : 109; //@line 110755 "c/sqlite3.c"
   $144 = ((($117)) + 8|0); //@line 110755 "c/sqlite3.c"
   HEAP8[$144>>0] = $143; //@line 110755 "c/sqlite3.c"
   $$1 = $117;
   STACKTOP = sp;return ($$1|0); //@line 110759 "c/sqlite3.c"
  }
 } while(0);
 $$1 = 0;
 STACKTOP = sp;return ($$1|0); //@line 110759 "c/sqlite3.c"
}
function _sqlite3CodeRowTriggerDirect($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$lobit = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = (_sqlite3GetVdbe($0)|0); //@line 125920 "c/sqlite3.c"
 $7 = (_getRowTrigger($0,$1,$2,$4)|0); //@line 125922 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 125927 "c/sqlite3.c"
 if ($8) {
  return; //@line 125942 "c/sqlite3.c"
 }
 $9 = HEAP32[$1>>2]|0; //@line 125928 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 125928 "c/sqlite3.c"
 if ($10) {
  $22 = 0;
 } else {
  $11 = HEAP32[$0>>2]|0; //@line 125928 "c/sqlite3.c"
  $12 = ((($11)) + 28|0); //@line 125928 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 125928 "c/sqlite3.c"
  $14 = $13 >>> 13;
  $$lobit = $14 & 1;
  $15 = $$lobit ^ 1;
  $16 = $15&65535;
  $22 = $16;
 }
 $17 = ((($0)) + 44|0); //@line 125930 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 125930 "c/sqlite3.c"
 $19 = (($18) + 1)|0; //@line 125930 "c/sqlite3.c"
 HEAP32[$17>>2] = $19; //@line 125930 "c/sqlite3.c"
 $20 = ((($7)) + 8|0); //@line 125931 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 125931 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($6,46,$3,$5,$19,$21,-4)|0); //@line 125930 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($6,$22); //@line 125940 "c/sqlite3.c"
 return; //@line 125942 "c/sqlite3.c"
}
function _getRowTrigger($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$020 = 0, $$021 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 120|0); //@line 125884 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 125884 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 125884 "c/sqlite3.c"
 $spec$select = $6 ? $0 : $5; //@line 125884 "c/sqlite3.c"
 $7 = ((($spec$select)) + 460|0); //@line 125893 "c/sqlite3.c"
 $$020 = HEAP32[$7>>2]|0;
 $8 = ($$020|0)==(0|0); //@line 125894 "c/sqlite3.c"
 L1: do {
  if (!($8)) {
   $$021 = $$020;
   while(1) {
    $9 = HEAP32[$$021>>2]|0; //@line 125894 "c/sqlite3.c"
    $10 = ($9|0)==($1|0); //@line 125894 "c/sqlite3.c"
    if ($10) {
     $11 = ((($$021)) + 12|0); //@line 125894 "c/sqlite3.c"
     $12 = HEAP32[$11>>2]|0; //@line 125894 "c/sqlite3.c"
     $13 = ($12|0)==($3|0); //@line 125894 "c/sqlite3.c"
     if ($13) {
      $$1 = $$021;
      break;
     }
    }
    $14 = ((($$021)) + 4|0); //@line 125895 "c/sqlite3.c"
    $$0 = HEAP32[$14>>2]|0;
    $15 = ($$0|0)==(0|0); //@line 125894 "c/sqlite3.c"
    if ($15) {
     break L1;
    } else {
     $$021 = $$0;
    }
   }
   return ($$1|0); //@line 125903 "c/sqlite3.c"
  }
 } while(0);
 $16 = (_codeRowTrigger($0,$1,$2,$3)|0); //@line 125900 "c/sqlite3.c"
 $$1 = $16;
 return ($$1|0); //@line 125903 "c/sqlite3.c"
}
function _codeRowTrigger($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$097 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer = sp;
 $4 = sp + 8|0;
 $5 = ((($0)) + 120|0); //@line 125769 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 125769 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 125769 "c/sqlite3.c"
 $spec$select = $7 ? $0 : $6; //@line 125769 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 125770 "c/sqlite3.c"
 $9 = (_sqlite3DbMallocZero($8,24,0)|0); //@line 125785 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 125786 "c/sqlite3.c"
 if ($10) {
  $$097 = 0;
  STACKTOP = sp;return ($$097|0); //@line 125870 "c/sqlite3.c"
 }
 $11 = ((($spec$select)) + 460|0); //@line 125787 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 125787 "c/sqlite3.c"
 $13 = ((($9)) + 4|0); //@line 125787 "c/sqlite3.c"
 HEAP32[$13>>2] = $12; //@line 125787 "c/sqlite3.c"
 HEAP32[$11>>2] = $9; //@line 125788 "c/sqlite3.c"
 $14 = (_sqlite3DbMallocZero($8,28,0)|0); //@line 125789 "c/sqlite3.c"
 $15 = ((($9)) + 8|0); //@line 125789 "c/sqlite3.c"
 HEAP32[$15>>2] = $14; //@line 125789 "c/sqlite3.c"
 $16 = ($14|0)==(0|0); //@line 125790 "c/sqlite3.c"
 if ($16) {
  $$097 = 0;
  STACKTOP = sp;return ($$097|0); //@line 125870 "c/sqlite3.c"
 }
 $17 = ((($spec$select)) + 8|0); //@line 125791 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 125791 "c/sqlite3.c"
 _sqlite3VdbeLinkSubProgram($18,$14); //@line 125791 "c/sqlite3.c"
 HEAP32[$9>>2] = $1; //@line 125792 "c/sqlite3.c"
 $19 = ((($9)) + 12|0); //@line 125793 "c/sqlite3.c"
 HEAP32[$19>>2] = $3; //@line 125793 "c/sqlite3.c"
 $20 = ((($9)) + 16|0); //@line 125794 "c/sqlite3.c"
 HEAP32[$20>>2] = -1; //@line 125794 "c/sqlite3.c"
 $21 = ((($9)) + 20|0); //@line 125795 "c/sqlite3.c"
 HEAP32[$21>>2] = -1; //@line 125795 "c/sqlite3.c"
 $22 = (_sqlite3DbMallocZero($8,472,0)|0); //@line 125799 "c/sqlite3.c"
 $23 = ($22|0)==(0|0); //@line 125800 "c/sqlite3.c"
 if ($23) {
  $$097 = 0;
  STACKTOP = sp;return ($$097|0); //@line 125870 "c/sqlite3.c"
 }
 $24 = ((($4)) + 4|0);
 ;HEAP32[$24>>2]=0|0;HEAP32[$24+4>>2]=0|0;HEAP32[$24+8>>2]=0|0;HEAP32[$24+12>>2]=0|0;HEAP32[$24+16>>2]=0|0;HEAP32[$24+20>>2]=0|0;HEAP32[$24+24>>2]=0|0; //@line 125801 "c/sqlite3.c"
 HEAP32[$4>>2] = $22; //@line 125802 "c/sqlite3.c"
 HEAP32[$22>>2] = $8; //@line 125803 "c/sqlite3.c"
 $25 = ((($22)) + 124|0); //@line 125804 "c/sqlite3.c"
 HEAP32[$25>>2] = $2; //@line 125804 "c/sqlite3.c"
 $26 = ((($22)) + 120|0); //@line 125805 "c/sqlite3.c"
 HEAP32[$26>>2] = $spec$select; //@line 125805 "c/sqlite3.c"
 $27 = HEAP32[$1>>2]|0; //@line 125806 "c/sqlite3.c"
 $28 = ((($22)) + 440|0); //@line 125806 "c/sqlite3.c"
 HEAP32[$28>>2] = $27; //@line 125806 "c/sqlite3.c"
 $29 = ((($1)) + 8|0); //@line 125807 "c/sqlite3.c"
 $30 = HEAP8[$29>>0]|0; //@line 125807 "c/sqlite3.c"
 $31 = ((($22)) + 144|0); //@line 125807 "c/sqlite3.c"
 HEAP8[$31>>0] = $30; //@line 125807 "c/sqlite3.c"
 $32 = ((($0)) + 132|0); //@line 125808 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 125808 "c/sqlite3.c"
 $34 = ((($22)) + 132|0); //@line 125808 "c/sqlite3.c"
 HEAP32[$34>>2] = $33; //@line 125808 "c/sqlite3.c"
 $35 = (_sqlite3GetVdbe($22)|0); //@line 125810 "c/sqlite3.c"
 $36 = ($35|0)==(0|0); //@line 125811 "c/sqlite3.c"
 if (!($36)) {
  $37 = HEAP32[$1>>2]|0; //@line 125821 "c/sqlite3.c"
  $38 = ($37|0)==(0|0); //@line 125821 "c/sqlite3.c"
  if (!($38)) {
   HEAP32[$vararg_buffer>>2] = $37; //@line 125823 "c/sqlite3.c"
   $39 = (_sqlite3MPrintf($8,27846,$vararg_buffer)|0); //@line 125823 "c/sqlite3.c"
   _sqlite3VdbeChangeP4($35,-1,$39,-7); //@line 125822 "c/sqlite3.c"
  }
  $40 = ((($1)) + 12|0); //@line 125831 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 125831 "c/sqlite3.c"
  $42 = ($41|0)==(0|0); //@line 125831 "c/sqlite3.c"
  if ($42) {
   $$1 = 0;
  } else {
   $43 = (_sqlite3ExprDup($8,$41,0)|0); //@line 125832 "c/sqlite3.c"
   $44 = (_sqlite3ResolveExprNames($4,$43)|0); //@line 125833 "c/sqlite3.c"
   $45 = ($44|0)==(0); //@line 125833 "c/sqlite3.c"
   if ($45) {
    $46 = ((($8)) + 73|0); //@line 125834 "c/sqlite3.c"
    $47 = HEAP8[$46>>0]|0; //@line 125834 "c/sqlite3.c"
    $48 = ($47<<24>>24)==(0); //@line 125834 "c/sqlite3.c"
    if ($48) {
     $49 = (_sqlite3VdbeMakeLabel($35)|0); //@line 125836 "c/sqlite3.c"
     _sqlite3ExprIfFalse($22,$43,$49,16); //@line 125837 "c/sqlite3.c"
     $$0 = $49;
    } else {
     $$0 = 0;
    }
   } else {
    $$0 = 0;
   }
   _sqlite3ExprDelete($8,$43); //@line 125839 "c/sqlite3.c"
   $$1 = $$0;
  }
  $50 = ((($1)) + 28|0); //@line 125843 "c/sqlite3.c"
  $51 = HEAP32[$50>>2]|0; //@line 125843 "c/sqlite3.c"
  _codeTriggerProgram($22,$51,$3); //@line 125843 "c/sqlite3.c"
  $52 = ($$1|0)==(0); //@line 125846 "c/sqlite3.c"
  if (!($52)) {
   _sqlite3VdbeResolveLabel($35,$$1); //@line 125847 "c/sqlite3.c"
  }
  (_sqlite3VdbeAddOp0($35,66)|0); //@line 125849 "c/sqlite3.c"
  _transferParseError($0,$22); //@line 125852 "c/sqlite3.c"
  $53 = ((($8)) + 73|0); //@line 125853 "c/sqlite3.c"
  $54 = HEAP8[$53>>0]|0; //@line 125853 "c/sqlite3.c"
  $55 = ($54<<24>>24)==(0); //@line 125853 "c/sqlite3.c"
  if ($55) {
   $56 = ((($0)) + 36|0); //@line 125853 "c/sqlite3.c"
   $57 = HEAP32[$56>>2]|0; //@line 125853 "c/sqlite3.c"
   $58 = ($57|0)==(0); //@line 125853 "c/sqlite3.c"
   if ($58) {
    $59 = ((($14)) + 4|0); //@line 125854 "c/sqlite3.c"
    $60 = ((($spec$select)) + 104|0); //@line 125854 "c/sqlite3.c"
    $61 = (_sqlite3VdbeTakeOpArray($35,$59,$60)|0); //@line 125854 "c/sqlite3.c"
    HEAP32[$14>>2] = $61; //@line 125854 "c/sqlite3.c"
   }
  }
  $62 = ((($22)) + 44|0); //@line 125856 "c/sqlite3.c"
  $63 = HEAP32[$62>>2]|0; //@line 125856 "c/sqlite3.c"
  $64 = ((($14)) + 8|0); //@line 125856 "c/sqlite3.c"
  HEAP32[$64>>2] = $63; //@line 125856 "c/sqlite3.c"
  $65 = ((($22)) + 40|0); //@line 125857 "c/sqlite3.c"
  $66 = HEAP32[$65>>2]|0; //@line 125857 "c/sqlite3.c"
  $67 = ((($14)) + 12|0); //@line 125857 "c/sqlite3.c"
  HEAP32[$67>>2] = $66; //@line 125857 "c/sqlite3.c"
  $68 = ((($14)) + 20|0); //@line 125858 "c/sqlite3.c"
  HEAP32[$68>>2] = $1; //@line 125858 "c/sqlite3.c"
  $69 = ((($22)) + 136|0); //@line 125859 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 125859 "c/sqlite3.c"
  HEAP32[$20>>2] = $70; //@line 125859 "c/sqlite3.c"
  $71 = ((($22)) + 140|0); //@line 125860 "c/sqlite3.c"
  $72 = HEAP32[$71>>2]|0; //@line 125860 "c/sqlite3.c"
  HEAP32[$21>>2] = $72; //@line 125860 "c/sqlite3.c"
  _sqlite3VdbeDelete($35); //@line 125861 "c/sqlite3.c"
 }
 _sqlite3ParserReset($22); //@line 125866 "c/sqlite3.c"
 _sqlite3DbFree($8,$22); //@line 125867 "c/sqlite3.c"
 $$097 = $9;
 STACKTOP = sp;return ($$097|0); //@line 125870 "c/sqlite3.c"
}
function _sqlite3VdbeLinkSubProgram($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 208|0); //@line 73887 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 73887 "c/sqlite3.c"
 $4 = ((($1)) + 24|0); //@line 73887 "c/sqlite3.c"
 HEAP32[$4>>2] = $3; //@line 73887 "c/sqlite3.c"
 HEAP32[$2>>2] = $1; //@line 73888 "c/sqlite3.c"
 return; //@line 73889 "c/sqlite3.c"
}
function _codeTriggerProgram($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$01 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 8|0;
 $4 = ((($0)) + 8|0); //@line 125650 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 125650 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 125651 "c/sqlite3.c"
 $7 = ($1|0)==(0|0); //@line 125656 "c/sqlite3.c"
 if ($7) {
  STACKTOP = sp;return;
 }
 $8 = ($2|0)==(10);
 $9 = ((($0)) + 145|0);
 $10 = $2 & 255;
 $$01 = $1;
 while(1) {
  if ($8) {
   $11 = ((($$01)) + 1|0); //@line 125670 "c/sqlite3.c"
   $12 = HEAP8[$11>>0]|0; //@line 125670 "c/sqlite3.c"
   $13 = $12&255; //@line 125670 "c/sqlite3.c"
   $15 = $13;
  } else {
   $15 = $10;
  }
  $14 = $15&255; //@line 125670 "c/sqlite3.c"
  HEAP8[$9>>0] = $14; //@line 125670 "c/sqlite3.c"
  $16 = ((($$01)) + 28|0); //@line 125674 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 125674 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 125674 "c/sqlite3.c"
  if (!($18)) {
   HEAP32[$vararg_buffer>>2] = $17; //@line 125676 "c/sqlite3.c"
   $19 = (_sqlite3MPrintf($6,27988,$vararg_buffer)|0); //@line 125676 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($5,166,2147483647,1,0,$19,-7)|0); //@line 125675 "c/sqlite3.c"
  }
  $20 = HEAP8[$$01>>0]|0; //@line 125681 "c/sqlite3.c"
  switch ($20<<24>>24) {
  case 110:  {
   $21 = (_targetSrcList($0,$$01)|0); //@line 125684 "c/sqlite3.c"
   $22 = ((($$01)) + 20|0); //@line 125685 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 125685 "c/sqlite3.c"
   $24 = (_sqlite3ExprListDup($6,$23,0)|0); //@line 125685 "c/sqlite3.c"
   $25 = ((($$01)) + 16|0); //@line 125686 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 125686 "c/sqlite3.c"
   $27 = (_sqlite3ExprDup($6,$26,0)|0); //@line 125686 "c/sqlite3.c"
   $28 = HEAP8[$9>>0]|0; //@line 125687 "c/sqlite3.c"
   $29 = $28&255; //@line 125687 "c/sqlite3.c"
   _sqlite3Update($0,$21,$24,$27,$29); //@line 125683 "c/sqlite3.c"
   break;
  }
  case 108:  {
   $30 = (_targetSrcList($0,$$01)|0); //@line 125693 "c/sqlite3.c"
   $31 = ((($$01)) + 8|0); //@line 125694 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 125694 "c/sqlite3.c"
   $33 = (_sqlite3SelectDup($6,$32,0)|0); //@line 125694 "c/sqlite3.c"
   $34 = ((($$01)) + 24|0); //@line 125695 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 125695 "c/sqlite3.c"
   $36 = (_sqlite3IdListDup($6,$35)|0); //@line 125695 "c/sqlite3.c"
   $37 = HEAP8[$9>>0]|0; //@line 125696 "c/sqlite3.c"
   $38 = $37&255; //@line 125696 "c/sqlite3.c"
   _sqlite3Insert($0,$30,$33,$36,$38); //@line 125692 "c/sqlite3.c"
   break;
  }
  case 109:  {
   $39 = (_targetSrcList($0,$$01)|0); //@line 125702 "c/sqlite3.c"
   $40 = ((($$01)) + 16|0); //@line 125703 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 125703 "c/sqlite3.c"
   $42 = (_sqlite3ExprDup($6,$41,0)|0); //@line 125703 "c/sqlite3.c"
   _sqlite3DeleteFrom($0,$39,$42); //@line 125701 "c/sqlite3.c"
   break;
  }
  default: {
   $43 = ((($$01)) + 8|0); //@line 125709 "c/sqlite3.c"
   $44 = HEAP32[$43>>2]|0; //@line 125709 "c/sqlite3.c"
   $45 = (_sqlite3SelectDup($6,$44,0)|0); //@line 125709 "c/sqlite3.c"
   _sqlite3SelectDestInit($3,4,0); //@line 125710 "c/sqlite3.c"
   (_sqlite3Select($0,$45,$3)|0); //@line 125711 "c/sqlite3.c"
   _sqlite3SelectDelete($6,$45); //@line 125712 "c/sqlite3.c"
  }
  }
  $46 = HEAP8[$$01>>0]|0; //@line 125716 "c/sqlite3.c"
  $47 = ($46<<24>>24)==(119); //@line 125716 "c/sqlite3.c"
  if (!($47)) {
   (_sqlite3VdbeAddOp0($5,120)|0); //@line 125717 "c/sqlite3.c"
  }
  $48 = ((($$01)) + 32|0); //@line 125656 "c/sqlite3.c"
  $49 = HEAP32[$48>>2]|0; //@line 125656 "c/sqlite3.c"
  $50 = ($49|0)==(0|0); //@line 125656 "c/sqlite3.c"
  if ($50) {
   break;
  } else {
   $$01 = $49;
  }
 }
 STACKTOP = sp;return;
}
function _transferParseError($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 36|0); //@line 125750 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 125750 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 125750 "c/sqlite3.c"
 if ($4) {
  $5 = ((($1)) + 4|0); //@line 125751 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 125751 "c/sqlite3.c"
  $7 = ((($0)) + 4|0); //@line 125751 "c/sqlite3.c"
  HEAP32[$7>>2] = $6; //@line 125751 "c/sqlite3.c"
  $8 = ((($1)) + 36|0); //@line 125752 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 125752 "c/sqlite3.c"
  HEAP32[$2>>2] = $9; //@line 125752 "c/sqlite3.c"
  $10 = ((($1)) + 12|0); //@line 125753 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 125753 "c/sqlite3.c"
  $12 = ((($0)) + 12|0); //@line 125753 "c/sqlite3.c"
  HEAP32[$12>>2] = $11; //@line 125753 "c/sqlite3.c"
  return; //@line 125757 "c/sqlite3.c"
 } else {
  $13 = HEAP32[$1>>2]|0; //@line 125755 "c/sqlite3.c"
  $14 = ((($1)) + 4|0); //@line 125755 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 125755 "c/sqlite3.c"
  _sqlite3DbFree($13,$15); //@line 125755 "c/sqlite3.c"
  return; //@line 125757 "c/sqlite3.c"
 }
}
function _sqlite3VdbeTakeOpArray($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 88|0); //@line 73675 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 73675 "c/sqlite3.c"
 _resolveP2Values($0,$2); //@line 73681 "c/sqlite3.c"
 $5 = ((($0)) + 136|0); //@line 73682 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 73682 "c/sqlite3.c"
 HEAP32[$1>>2] = $6; //@line 73682 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 73683 "c/sqlite3.c"
 return ($4|0); //@line 73684 "c/sqlite3.c"
}
function _resolveP2Values($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$046 = 0, $$2 = 0, $$3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $spec$select47 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 73526 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 73528 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 73528 "c/sqlite3.c"
 $5 = ((($4)) + 72|0); //@line 73529 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 73529 "c/sqlite3.c"
 $7 = ((($0)) + 145|0); //@line 73530 "c/sqlite3.c"
 $8 = HEAPU8[$7>>0]|(HEAPU8[$7+1>>0]<<8); //@line 73530 "c/sqlite3.c"
 $9 = $8 & -385; //@line 73531 "c/sqlite3.c"
 $10 = $9 | 128; //@line 73531 "c/sqlite3.c"
 HEAP8[$7>>0]=$10&255;HEAP8[$7+1>>0]=$10>>8; //@line 73531 "c/sqlite3.c"
 $11 = ((($0)) + 88|0); //@line 73532 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 73532 "c/sqlite3.c"
 $13 = ((($0)) + 136|0); //@line 73532 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 73532 "c/sqlite3.c"
 $15 = (($14) + -1)|0; //@line 73532 "c/sqlite3.c"
 $16 = (($12) + (($15*20)|0)|0); //@line 73532 "c/sqlite3.c"
 $$0 = $2;$$046 = $16;
 while(1) {
  $17 = HEAP8[$$046>>0]|0; //@line 73541 "c/sqlite3.c"
  $18 = ($17&255)<(63); //@line 73541 "c/sqlite3.c"
  L3: do {
   if ($18) {
    switch ($17<<24>>24) {
    case 2:  {
     $19 = ((($$046)) + 8|0); //@line 73546 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 73546 "c/sqlite3.c"
     $21 = ($20|0)==(0); //@line 73546 "c/sqlite3.c"
     if ($21) {
      label = 6;
     } else {
      $22 = HEAPU8[$7>>0]|(HEAPU8[$7+1>>0]<<8); //@line 73546 "c/sqlite3.c"
      $23 = $22 & -129; //@line 73546 "c/sqlite3.c"
      HEAP8[$7>>0]=$23&255;HEAP8[$7+1>>0]=$23>>8; //@line 73546 "c/sqlite3.c"
      label = 6;
     }
     break;
    }
    case 0: case 1:  {
     label = 6;
     break;
    }
    case 9: case 10: case 8:  {
     $26 = HEAPU8[$7>>0]|(HEAPU8[$7+1>>0]<<8); //@line 73559 "c/sqlite3.c"
     $27 = $26 & -385; //@line 73560 "c/sqlite3.c"
     $28 = $27 | 256; //@line 73560 "c/sqlite3.c"
     HEAP8[$7>>0]=$28&255;HEAP8[$7+1>>0]=$28>>8; //@line 73560 "c/sqlite3.c"
     $$3 = $$0;
     break L3;
     break;
    }
    case 3: case 5: case 7:  {
     $29 = ((($$046)) + 16|0); //@line 73566 "c/sqlite3.c"
     HEAP32[$29>>2] = 164; //@line 73566 "c/sqlite3.c"
     $30 = ((($$046)) + 1|0); //@line 73567 "c/sqlite3.c"
     HEAP8[$30>>0] = -5; //@line 73567 "c/sqlite3.c"
     $$3 = $$0;
     break L3;
     break;
    }
    case 4: case 6:  {
     $31 = ((($$046)) + 16|0); //@line 73576 "c/sqlite3.c"
     HEAP32[$31>>2] = 165; //@line 73576 "c/sqlite3.c"
     $32 = ((($$046)) + 1|0); //@line 73577 "c/sqlite3.c"
     HEAP8[$32>>0] = -5; //@line 73577 "c/sqlite3.c"
     $$3 = $$0;
     break L3;
     break;
    }
    case 12:  {
     $33 = ((($$046)) + 8|0); //@line 73586 "c/sqlite3.c"
     $34 = HEAP32[$33>>2]|0; //@line 73586 "c/sqlite3.c"
     $35 = ($34|0)>($$0|0); //@line 73586 "c/sqlite3.c"
     $spec$select = $35 ? $34 : $$0; //@line 73586 "c/sqlite3.c"
     $$3 = $spec$select;
     break L3;
     break;
    }
    case 11:  {
     $36 = ((($$046)) + -16|0); //@line 73593 "c/sqlite3.c"
     $37 = HEAP32[$36>>2]|0; //@line 73593 "c/sqlite3.c"
     $38 = ($37|0)>($$0|0); //@line 73594 "c/sqlite3.c"
     $spec$select47 = $38 ? $37 : $$0; //@line 73594 "c/sqlite3.c"
     $$2 = $spec$select47;
     break;
    }
    default: {
     $$2 = $$0;
    }
    }
    if ((label|0) == 6) {
     label = 0;
     $24 = HEAPU8[$7>>0]|(HEAPU8[$7+1>>0]<<8); //@line 73551 "c/sqlite3.c"
     $25 = $24 | 256; //@line 73551 "c/sqlite3.c"
     HEAP8[$7>>0]=$25&255;HEAP8[$7+1>>0]=$25>>8; //@line 73551 "c/sqlite3.c"
     $$3 = $$0;
     break;
    }
    $39 = ((($$046)) + 8|0); //@line 73599 "c/sqlite3.c"
    $40 = HEAP32[$39>>2]|0; //@line 73599 "c/sqlite3.c"
    $41 = ($40|0)<(0); //@line 73599 "c/sqlite3.c"
    if ($41) {
     $42 = $40 ^ -1; //@line 73605 "c/sqlite3.c"
     $43 = (($6) + ($42<<2)|0); //@line 73605 "c/sqlite3.c"
     $44 = HEAP32[$43>>2]|0; //@line 73605 "c/sqlite3.c"
     HEAP32[$39>>2] = $44; //@line 73605 "c/sqlite3.c"
     $$3 = $$2;
    } else {
     $$3 = $$2;
    }
   } else {
    $$3 = $$0;
   }
  } while(0);
  $45 = HEAP32[$11>>2]|0; //@line 73615 "c/sqlite3.c"
  $46 = ($$046|0)==($45|0); //@line 73615 "c/sqlite3.c"
  $47 = ((($$046)) + -20|0); //@line 73616 "c/sqlite3.c"
  if ($46) {
   break;
  } else {
   $$0 = $$3;$$046 = $47;
  }
 }
 $48 = HEAP32[$0>>2]|0; //@line 73618 "c/sqlite3.c"
 $49 = HEAP32[$5>>2]|0; //@line 73618 "c/sqlite3.c"
 _sqlite3DbFree($48,$49); //@line 73618 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 73619 "c/sqlite3.c"
 $50 = ((($4)) + 68|0); //@line 73620 "c/sqlite3.c"
 HEAP32[$50>>2] = 0; //@line 73620 "c/sqlite3.c"
 HEAP32[$1>>2] = $$3; //@line 73621 "c/sqlite3.c"
 return; //@line 73623 "c/sqlite3.c"
}
function _sqlite3BtreeNext($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 42|0); //@line 66009 "c/sqlite3.c"
 HEAP16[$2>>1] = 0; //@line 66009 "c/sqlite3.c"
 $3 = ((($0)) + 1|0); //@line 66010 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 66010 "c/sqlite3.c"
 $5 = $4 & -7; //@line 66010 "c/sqlite3.c"
 HEAP8[$3>>0] = $5; //@line 66010 "c/sqlite3.c"
 $6 = HEAP8[$0>>0]|0; //@line 66011 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(1); //@line 66011 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_btreeNext($0)|0); //@line 66011 "c/sqlite3.c"
  $$0 = $8;
  return ($$0|0); //@line 66022 "c/sqlite3.c"
 }
 $9 = ((($0)) + 116|0); //@line 66012 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 66012 "c/sqlite3.c"
 $11 = ((($0)) + 70|0); //@line 66013 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 66013 "c/sqlite3.c"
 $13 = (($12) + 1)<<16>>16; //@line 66013 "c/sqlite3.c"
 HEAP16[$11>>1] = $13; //@line 66013 "c/sqlite3.c"
 $14 = ((($10)) + 22|0); //@line 66013 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 66013 "c/sqlite3.c"
 $16 = ($13&65535)<($15&65535); //@line 66013 "c/sqlite3.c"
 if (!($16)) {
  HEAP16[$11>>1] = $12; //@line 66014 "c/sqlite3.c"
  $17 = (_btreeNext($0)|0); //@line 66015 "c/sqlite3.c"
  $$0 = $17;
  return ($$0|0); //@line 66022 "c/sqlite3.c"
 }
 $18 = ((($10)) + 8|0); //@line 66017 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 66017 "c/sqlite3.c"
 $20 = ($19<<24>>24)==(0); //@line 66017 "c/sqlite3.c"
 if (!($20)) {
  $$0 = 0;
  return ($$0|0); //@line 66022 "c/sqlite3.c"
 }
 $21 = (_moveToLeftmost($0)|0); //@line 66020 "c/sqlite3.c"
 $$0 = $21;
 return ($$0|0); //@line 66022 "c/sqlite3.c"
}
function _sqlite3BtreePrevious($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 1|0); //@line 66104 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 66104 "c/sqlite3.c"
 $4 = $3 & -15; //@line 66104 "c/sqlite3.c"
 HEAP8[$2>>0] = $4; //@line 66104 "c/sqlite3.c"
 $5 = ((($0)) + 42|0); //@line 66105 "c/sqlite3.c"
 HEAP16[$5>>1] = 0; //@line 66105 "c/sqlite3.c"
 $6 = HEAP8[$0>>0]|0; //@line 66106 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(1); //@line 66106 "c/sqlite3.c"
 if ($7) {
  $8 = ((($0)) + 70|0); //@line 66107 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 66107 "c/sqlite3.c"
  $10 = ($9<<16>>16)==(0); //@line 66107 "c/sqlite3.c"
  if (!($10)) {
   $11 = ((($0)) + 116|0); //@line 66108 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 66108 "c/sqlite3.c"
   $13 = ((($12)) + 8|0); //@line 66108 "c/sqlite3.c"
   $14 = HEAP8[$13>>0]|0; //@line 66108 "c/sqlite3.c"
   $15 = ($14<<24>>24)==(0); //@line 66108 "c/sqlite3.c"
   if (!($15)) {
    $17 = (($9) + -1)<<16>>16; //@line 66112 "c/sqlite3.c"
    HEAP16[$8>>1] = $17; //@line 66112 "c/sqlite3.c"
    $$0 = 0;
    return ($$0|0); //@line 66114 "c/sqlite3.c"
   }
  }
 }
 $16 = (_btreePrevious($0)|0); //@line 66110 "c/sqlite3.c"
 $$0 = $16;
 return ($$0|0); //@line 66114 "c/sqlite3.c"
}
function _btreePrevious($0) {
 $0 = $0|0;
 var $$1 = 0, $$lcssa = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 66052 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(1); //@line 66052 "c/sqlite3.c"
 if (!($2)) {
  $3 = ($1&255)>(2); //@line 66053 "c/sqlite3.c"
  do {
   if ($3) {
    $4 = (_btreeRestoreCursorPosition($0)|0); //@line 66053 "c/sqlite3.c"
    $5 = ($4|0)==(0); //@line 66054 "c/sqlite3.c"
    if ($5) {
     $$pr = HEAP8[$0>>0]|0; //@line 66057 "c/sqlite3.c"
     $7 = $$pr;
     break;
    } else {
     $$1 = $4;
     return ($$1|0); //@line 66098 "c/sqlite3.c"
    }
   } else {
    $7 = $1;
   }
  } while(0);
  $6 = ($7<<24>>24)==(0); //@line 66057 "c/sqlite3.c"
  if ($6) {
   $$1 = 101;
   return ($$1|0); //@line 66098 "c/sqlite3.c"
  }
  $8 = ((($0)) + 64|0); //@line 66060 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 66060 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 66060 "c/sqlite3.c"
  if (!($10)) {
   HEAP8[$0>>0] = 1; //@line 66062 "c/sqlite3.c"
   $11 = ($9|0)<(0); //@line 66063 "c/sqlite3.c"
   HEAP32[$8>>2] = 0;
   if ($11) {
    $$1 = 0;
    return ($$1|0); //@line 66098 "c/sqlite3.c"
   }
  }
 }
 $12 = ((($0)) + 116|0); //@line 66071 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 66071 "c/sqlite3.c"
 $14 = ((($13)) + 8|0); //@line 66073 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 66073 "c/sqlite3.c"
 $16 = ($15<<24>>24)==(0); //@line 66073 "c/sqlite3.c"
 $17 = ((($0)) + 70|0);
 $18 = HEAP16[$17>>1]|0;
 if ($16) {
  $19 = $18&65535; //@line 66074 "c/sqlite3.c"
  $20 = ((($13)) + 56|0); //@line 66075 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 66075 "c/sqlite3.c"
  $22 = ((($13)) + 24|0); //@line 66075 "c/sqlite3.c"
  $23 = HEAP16[$22>>1]|0; //@line 66075 "c/sqlite3.c"
  $24 = $23&65535; //@line 66075 "c/sqlite3.c"
  $25 = ((($13)) + 64|0); //@line 66075 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 66075 "c/sqlite3.c"
  $27 = $19 << 1; //@line 66075 "c/sqlite3.c"
  $28 = (($26) + ($27)|0); //@line 66075 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 66075 "c/sqlite3.c"
  $30 = $29&255; //@line 66075 "c/sqlite3.c"
  $31 = $30 << 8; //@line 66075 "c/sqlite3.c"
  $32 = ((($28)) + 1|0); //@line 66075 "c/sqlite3.c"
  $33 = HEAP8[$32>>0]|0; //@line 66075 "c/sqlite3.c"
  $34 = $33&255; //@line 66075 "c/sqlite3.c"
  $35 = $31 | $34; //@line 66075 "c/sqlite3.c"
  $36 = $35 & $24; //@line 66075 "c/sqlite3.c"
  $37 = (($21) + ($36)|0); //@line 66075 "c/sqlite3.c"
  $38 = (_sqlite3Get4byte($37)|0); //@line 66075 "c/sqlite3.c"
  $39 = (_moveToChild($0,$38)|0); //@line 66075 "c/sqlite3.c"
  $40 = ($39|0)==(0); //@line 66076 "c/sqlite3.c"
  if (!($40)) {
   $$1 = $39;
   return ($$1|0); //@line 66098 "c/sqlite3.c"
  }
  $41 = (_moveToRightmost($0)|0); //@line 66077 "c/sqlite3.c"
  $$1 = $41;
  return ($$1|0); //@line 66098 "c/sqlite3.c"
 }
 $42 = ($18<<16>>16)==(0); //@line 66079 "c/sqlite3.c"
 L22: do {
  if ($42) {
   $43 = ((($0)) + 68|0);
   while(1) {
    $44 = HEAP8[$43>>0]|0; //@line 66080 "c/sqlite3.c"
    $45 = ($44<<24>>24)==(0); //@line 66080 "c/sqlite3.c"
    if ($45) {
     break;
    }
    _moveToParent($0); //@line 66084 "c/sqlite3.c"
    $46 = HEAP16[$17>>1]|0; //@line 66079 "c/sqlite3.c"
    $47 = ($46<<16>>16)==(0); //@line 66079 "c/sqlite3.c"
    if (!($47)) {
     $$lcssa = $46;
     break L22;
    }
   }
   HEAP8[$0>>0] = 0; //@line 66081 "c/sqlite3.c"
   $$1 = 101;
   return ($$1|0); //@line 66098 "c/sqlite3.c"
  } else {
   $$lcssa = $18;
  }
 } while(0);
 $48 = (($$lcssa) + -1)<<16>>16; //@line 66089 "c/sqlite3.c"
 HEAP16[$17>>1] = $48; //@line 66089 "c/sqlite3.c"
 $49 = HEAP32[$12>>2]|0; //@line 66090 "c/sqlite3.c"
 $50 = ((($49)) + 2|0); //@line 66091 "c/sqlite3.c"
 $51 = HEAP8[$50>>0]|0; //@line 66091 "c/sqlite3.c"
 $52 = ($51<<24>>24)==(0); //@line 66091 "c/sqlite3.c"
 if ($52) {
  $$1 = 0;
  return ($$1|0); //@line 66098 "c/sqlite3.c"
 }
 $53 = ((($49)) + 8|0); //@line 66091 "c/sqlite3.c"
 $54 = HEAP8[$53>>0]|0; //@line 66091 "c/sqlite3.c"
 $55 = ($54<<24>>24)==(0); //@line 66091 "c/sqlite3.c"
 if (!($55)) {
  $$1 = 0;
  return ($$1|0); //@line 66098 "c/sqlite3.c"
 }
 $56 = (_sqlite3BtreePrevious($0,0)|0); //@line 66092 "c/sqlite3.c"
 $$1 = $56;
 return ($$1|0); //@line 66098 "c/sqlite3.c"
}
function _btreeRestoreCursorPosition($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = HEAP8[$0>>0]|0; //@line 61235 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(4); //@line 61235 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 64|0); //@line 61236 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 61236 "c/sqlite3.c"
  $$0 = $5;
  STACKTOP = sp;return ($$0|0); //@line 61250 "c/sqlite3.c"
 }
 HEAP8[$0>>0] = 0; //@line 61238 "c/sqlite3.c"
 $6 = ((($0)) + 56|0); //@line 61239 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 61239 "c/sqlite3.c"
 $8 = ((($0)) + 48|0); //@line 61239 "c/sqlite3.c"
 $9 = $8; //@line 61239 "c/sqlite3.c"
 $10 = $9; //@line 61239 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 61239 "c/sqlite3.c"
 $12 = (($9) + 4)|0; //@line 61239 "c/sqlite3.c"
 $13 = $12; //@line 61239 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 61239 "c/sqlite3.c"
 $15 = (_btreeMoveto($0,$7,$11,$14,0,$1)|0); //@line 61239 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 61240 "c/sqlite3.c"
 if (!($16)) {
  $$0 = $15;
  STACKTOP = sp;return ($$0|0); //@line 61250 "c/sqlite3.c"
 }
 $17 = HEAP32[$6>>2]|0; //@line 61241 "c/sqlite3.c"
 _sqlite3_free($17); //@line 61241 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 61242 "c/sqlite3.c"
 $18 = HEAP32[$1>>2]|0; //@line 61244 "c/sqlite3.c"
 $19 = ((($0)) + 64|0); //@line 61244 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 61244 "c/sqlite3.c"
 $21 = $20 | $18; //@line 61244 "c/sqlite3.c"
 HEAP32[$19>>2] = $21; //@line 61244 "c/sqlite3.c"
 $22 = ($21|0)==(0); //@line 61245 "c/sqlite3.c"
 if ($22) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 61250 "c/sqlite3.c"
 }
 $23 = HEAP8[$0>>0]|0; //@line 61245 "c/sqlite3.c"
 $24 = ($23<<24>>24)==(1); //@line 61245 "c/sqlite3.c"
 if (!($24)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 61250 "c/sqlite3.c"
 }
 HEAP8[$0>>0] = 2; //@line 61246 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 61250 "c/sqlite3.c"
}
function _moveToChild($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 68|0); //@line 65328 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 65328 "c/sqlite3.c"
 $4 = ($3<<24>>24)>(18); //@line 65328 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3CorruptError(65329)|0); //@line 65329 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 65338 "c/sqlite3.c"
 } else {
  $6 = ((($0)) + 12|0); //@line 65322 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 65322 "c/sqlite3.c"
  $8 = ((($0)) + 42|0); //@line 65331 "c/sqlite3.c"
  HEAP16[$8>>1] = 0; //@line 65331 "c/sqlite3.c"
  $9 = ((($0)) + 1|0); //@line 65332 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 65332 "c/sqlite3.c"
  $11 = $10 & -7; //@line 65332 "c/sqlite3.c"
  HEAP8[$9>>0] = $11; //@line 65332 "c/sqlite3.c"
  $12 = ((($0)) + 70|0); //@line 65333 "c/sqlite3.c"
  $13 = HEAP16[$12>>1]|0; //@line 65333 "c/sqlite3.c"
  $14 = $3 << 24 >> 24; //@line 65333 "c/sqlite3.c"
  $15 = (((($0)) + 72|0) + ($14<<1)|0); //@line 65333 "c/sqlite3.c"
  HEAP16[$15>>1] = $13; //@line 65333 "c/sqlite3.c"
  $16 = ((($0)) + 116|0); //@line 65334 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 65334 "c/sqlite3.c"
  $18 = (((($0)) + 120|0) + ($14<<2)|0); //@line 65334 "c/sqlite3.c"
  HEAP32[$18>>2] = $17; //@line 65334 "c/sqlite3.c"
  HEAP16[$12>>1] = 0; //@line 65335 "c/sqlite3.c"
  $19 = (($3) + 1)<<24>>24; //@line 65336 "c/sqlite3.c"
  HEAP8[$2>>0] = $19; //@line 65336 "c/sqlite3.c"
  $20 = ((($0)) + 2|0); //@line 65337 "c/sqlite3.c"
  $21 = HEAP8[$20>>0]|0; //@line 65337 "c/sqlite3.c"
  $22 = $21&255; //@line 65337 "c/sqlite3.c"
  $23 = (_getAndInitPage($7,$1,$16,$0,$22)|0); //@line 65337 "c/sqlite3.c"
  $$0 = $23;
  return ($$0|0); //@line 65338 "c/sqlite3.c"
 }
 return (0)|0;
}
function _moveToRightmost($0) {
 $0 = $0|0;
 var $$0 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 116|0); //@line 65530 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 65530 "c/sqlite3.c"
 $3 = ((($2)) + 8|0); //@line 65530 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 65530 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 65530 "c/sqlite3.c"
 L1: do {
  if ($5) {
   $6 = ((($0)) + 70|0);
   $12 = $2;
   while(1) {
    $11 = ((($12)) + 56|0); //@line 65531 "c/sqlite3.c"
    $13 = HEAP32[$11>>2]|0; //@line 65531 "c/sqlite3.c"
    $14 = ((($12)) + 9|0); //@line 65531 "c/sqlite3.c"
    $15 = HEAP8[$14>>0]|0; //@line 65531 "c/sqlite3.c"
    $16 = $15&255; //@line 65531 "c/sqlite3.c"
    $17 = (($16) + 8)|0; //@line 65531 "c/sqlite3.c"
    $18 = (($13) + ($17)|0); //@line 65531 "c/sqlite3.c"
    $19 = (_sqlite3Get4byte($18)|0); //@line 65531 "c/sqlite3.c"
    $20 = ((($12)) + 22|0); //@line 65532 "c/sqlite3.c"
    $21 = HEAP16[$20>>1]|0; //@line 65532 "c/sqlite3.c"
    HEAP16[$6>>1] = $21; //@line 65532 "c/sqlite3.c"
    $22 = (_moveToChild($0,$19)|0); //@line 65533 "c/sqlite3.c"
    $23 = ($22|0)==(0); //@line 65534 "c/sqlite3.c"
    if (!($23)) {
     $$0 = $22;
     break;
    }
    $7 = HEAP32[$1>>2]|0; //@line 65530 "c/sqlite3.c"
    $8 = ((($7)) + 8|0); //@line 65530 "c/sqlite3.c"
    $9 = HEAP8[$8>>0]|0; //@line 65530 "c/sqlite3.c"
    $10 = ($9<<24>>24)==(0); //@line 65530 "c/sqlite3.c"
    if ($10) {
     $12 = $7;
    } else {
     $$lcssa = $7;
     break L1;
    }
   }
   return ($$0|0); //@line 65540 "c/sqlite3.c"
  } else {
   $$lcssa = $2;
  }
 } while(0);
 $24 = ((($$lcssa)) + 22|0); //@line 65536 "c/sqlite3.c"
 $25 = HEAP16[$24>>1]|0; //@line 65536 "c/sqlite3.c"
 $26 = $25&65535; //@line 65536 "c/sqlite3.c"
 $27 = (($26) + 65535)|0; //@line 65536 "c/sqlite3.c"
 $28 = $27&65535; //@line 65536 "c/sqlite3.c"
 $29 = ((($0)) + 70|0); //@line 65536 "c/sqlite3.c"
 HEAP16[$29>>1] = $28; //@line 65536 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 65540 "c/sqlite3.c"
}
function _moveToParent($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 42|0); //@line 65382 "c/sqlite3.c"
 HEAP16[$1>>1] = 0; //@line 65382 "c/sqlite3.c"
 $2 = ((($0)) + 1|0); //@line 65383 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 65383 "c/sqlite3.c"
 $4 = $3 & -7; //@line 65383 "c/sqlite3.c"
 HEAP8[$2>>0] = $4; //@line 65383 "c/sqlite3.c"
 $5 = ((($0)) + 68|0); //@line 65384 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 65384 "c/sqlite3.c"
 $7 = $6 << 24 >> 24; //@line 65384 "c/sqlite3.c"
 $8 = (($7) + -1)|0; //@line 65384 "c/sqlite3.c"
 $9 = (((($0)) + 72|0) + ($8<<1)|0); //@line 65384 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 65384 "c/sqlite3.c"
 $11 = ((($0)) + 70|0); //@line 65384 "c/sqlite3.c"
 HEAP16[$11>>1] = $10; //@line 65384 "c/sqlite3.c"
 $12 = ((($0)) + 116|0); //@line 65385 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 65385 "c/sqlite3.c"
 $14 = (($6) + -1)<<24>>24; //@line 65386 "c/sqlite3.c"
 HEAP8[$5>>0] = $14; //@line 65386 "c/sqlite3.c"
 $15 = $14 << 24 >> 24; //@line 65386 "c/sqlite3.c"
 $16 = (((($0)) + 120|0) + ($15<<2)|0); //@line 65386 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 65386 "c/sqlite3.c"
 HEAP32[$12>>2] = $17; //@line 65386 "c/sqlite3.c"
 _releasePageNotNull($13); //@line 65387 "c/sqlite3.c"
 return; //@line 65388 "c/sqlite3.c"
}
function _getAndInitPage($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$025 = 0, $$026 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = (_btreePagecount($0)|0); //@line 62505 "c/sqlite3.c"
 $7 = ($6>>>0)<($1>>>0); //@line 62505 "c/sqlite3.c"
 do {
  if ($7) {
   $8 = (_sqlite3CorruptError(62506)|0); //@line 62506 "c/sqlite3.c"
   $$0 = $8;
   label = 11;
  } else {
   $9 = HEAP32[$0>>2]|0; //@line 62509 "c/sqlite3.c"
   $10 = (_sqlite3PagerGet($9,$1,$5,$4)|0); //@line 62509 "c/sqlite3.c"
   $11 = ($10|0)==(0); //@line 62510 "c/sqlite3.c"
   if ($11) {
    $12 = HEAP32[$5>>2]|0; //@line 62513 "c/sqlite3.c"
    $13 = (_sqlite3PagerGetExtra($12)|0); //@line 62513 "c/sqlite3.c"
    HEAP32[$2>>2] = $13; //@line 62513 "c/sqlite3.c"
    $14 = HEAP8[$13>>0]|0; //@line 62514 "c/sqlite3.c"
    $15 = ($14<<24>>24)==(0); //@line 62514 "c/sqlite3.c"
    if ($15) {
     (_btreePageFromDbPage($12,$1,$0)|0); //@line 62515 "c/sqlite3.c"
     $16 = HEAP32[$2>>2]|0; //@line 62516 "c/sqlite3.c"
     $17 = (_btreeInitPage($16)|0); //@line 62516 "c/sqlite3.c"
     $18 = ($17|0)==(0); //@line 62517 "c/sqlite3.c"
     if (!($18)) {
      $19 = HEAP32[$2>>2]|0; //@line 62518 "c/sqlite3.c"
      _releasePage($19); //@line 62518 "c/sqlite3.c"
      $$0 = $17;
      label = 11;
      break;
     }
    }
    $20 = ($3|0)==(0|0); //@line 62527 "c/sqlite3.c"
    if ($20) {
     $$025 = 0;
     STACKTOP = sp;return ($$025|0); //@line 62542 "c/sqlite3.c"
    }
    $21 = HEAP32[$2>>2]|0; //@line 62527 "c/sqlite3.c"
    $22 = ((($21)) + 22|0); //@line 62527 "c/sqlite3.c"
    $23 = HEAP16[$22>>1]|0; //@line 62527 "c/sqlite3.c"
    $24 = ($23<<16>>16)==(0); //@line 62527 "c/sqlite3.c"
    if (!($24)) {
     $25 = ((($21)) + 2|0); //@line 62527 "c/sqlite3.c"
     $26 = HEAP8[$25>>0]|0; //@line 62527 "c/sqlite3.c"
     $27 = ((($3)) + 69|0); //@line 62527 "c/sqlite3.c"
     $28 = HEAP8[$27>>0]|0; //@line 62527 "c/sqlite3.c"
     $29 = ($26<<24>>24)==($28<<24>>24); //@line 62527 "c/sqlite3.c"
     if ($29) {
      $$025 = 0;
      STACKTOP = sp;return ($$025|0); //@line 62542 "c/sqlite3.c"
     }
    }
    $30 = (_sqlite3CorruptError(62528)|0); //@line 62528 "c/sqlite3.c"
    $31 = HEAP32[$2>>2]|0; //@line 62529 "c/sqlite3.c"
    _releasePage($31); //@line 62529 "c/sqlite3.c"
    $$026 = $30;
   } else {
    $$0 = $10;
    label = 11;
   }
  }
 } while(0);
 if ((label|0) == 11) {
  $32 = ($3|0)==(0|0); //@line 62535 "c/sqlite3.c"
  if ($32) {
   $$025 = $$0;
   STACKTOP = sp;return ($$025|0); //@line 62542 "c/sqlite3.c"
  } else {
   $$026 = $$0;
  }
 }
 $33 = ((($3)) + 68|0); //@line 62536 "c/sqlite3.c"
 $34 = HEAP8[$33>>0]|0; //@line 62536 "c/sqlite3.c"
 $35 = (($34) + -1)<<24>>24; //@line 62536 "c/sqlite3.c"
 HEAP8[$33>>0] = $35; //@line 62536 "c/sqlite3.c"
 $36 = $35 << 24 >> 24; //@line 62537 "c/sqlite3.c"
 $37 = (((($3)) + 120|0) + ($36<<2)|0); //@line 62537 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 62537 "c/sqlite3.c"
 $39 = ((($3)) + 116|0); //@line 62537 "c/sqlite3.c"
 HEAP32[$39>>2] = $38; //@line 62537 "c/sqlite3.c"
 $$025 = $$026;
 STACKTOP = sp;return ($$025|0); //@line 62542 "c/sqlite3.c"
}
function _btreeMoveto($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$02022 = 0, $$021 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ($1|0)==(0|0); //@line 61203 "c/sqlite3.c"
 if ($6) {
  $7 = (_sqlite3BtreeMovetoUnpacked($0,0,$2,$3,$4,$5)|0); //@line 61215 "c/sqlite3.c"
  $$021 = $7;
  return ($$021|0); //@line 61221 "c/sqlite3.c"
 }
 $8 = ((($0)) + 112|0); //@line 61205 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 61205 "c/sqlite3.c"
 $10 = (_sqlite3VdbeAllocUnpackedRecord($9)|0); //@line 61205 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 61206 "c/sqlite3.c"
 if ($11) {
  $$021 = 7;
  return ($$021|0); //@line 61221 "c/sqlite3.c"
 }
 $12 = HEAP32[$8>>2]|0; //@line 61207 "c/sqlite3.c"
 _sqlite3VdbeRecordUnpack($12,$2,$1,$10); //@line 61207 "c/sqlite3.c"
 $13 = ((($10)) + 8|0); //@line 61208 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 61208 "c/sqlite3.c"
 $15 = ($14<<16>>16)==(0); //@line 61208 "c/sqlite3.c"
 if ($15) {
  $16 = (_sqlite3CorruptError(61209)|0); //@line 61209 "c/sqlite3.c"
  $$02022 = $16;
 } else {
  $17 = (_sqlite3BtreeMovetoUnpacked($0,$10,$2,$3,$4,$5)|0); //@line 61215 "c/sqlite3.c"
  $$02022 = $17;
 }
 $18 = ((($0)) + 112|0); //@line 61218 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 61218 "c/sqlite3.c"
 $20 = ((($19)) + 12|0); //@line 61218 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 61218 "c/sqlite3.c"
 _sqlite3DbFree($21,$10); //@line 61218 "c/sqlite3.c"
 $$021 = $$02022;
 return ($$021|0); //@line 61221 "c/sqlite3.c"
}
function _sqlite3BtreeMovetoUnpacked($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$ = 0, $$0 = 0, $$0167 = 0, $$0176 = 0, $$0177 = 0, $$0178 = 0, $$0185 = 0, $$0190 = 0, $$0196 = 0, $$0204 = 0, $$1 = 0, $$1175 = 0, $$1179 = 0, $$1186 = 0, $$1191 = 0, $$1197 = 0, $$2 = 0, $$2180 = 0, $$2187 = 0, $$2192 = 0;
 var $$2198 = 0, $$3 = 0, $$3193 = 0, $$3199 = 0, $$3207 = 0, $$4 = 0, $$4189 = 0, $$4194 = 0, $$4200 = 0, $$5 = 0, $$5183 = 0, $$6 = 0, $$6173 = 0, $$6173220 = 0, $$6202 = 0, $$7 = 0, $$7203 = 0, $$8 = 0, $$9 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0;
 var $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0;
 var $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0;
 var $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0;
 var $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0;
 var $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond208 = 0, $trunc = 0, $trunc$clear = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp;
 $cond208 = ($1|0)==(0|0); //@line 65656 "c/sqlite3.c"
 L1: do {
  if ($cond208) {
   $7 = HEAP8[$0>>0]|0; //@line 65656 "c/sqlite3.c"
   $8 = ($7<<24>>24)==(1); //@line 65656 "c/sqlite3.c"
   if ($8) {
    $9 = ((($0)) + 1|0); //@line 65656 "c/sqlite3.c"
    $10 = HEAP8[$9>>0]|0; //@line 65656 "c/sqlite3.c"
    $11 = $10&255; //@line 65656 "c/sqlite3.c"
    $12 = $11 & 2; //@line 65656 "c/sqlite3.c"
    $13 = ($12|0)==(0); //@line 65656 "c/sqlite3.c"
    if ($13) {
     $$0176 = 0;
    } else {
     $14 = ((($0)) + 24|0); //@line 65658 "c/sqlite3.c"
     $15 = $14; //@line 65658 "c/sqlite3.c"
     $16 = $15; //@line 65658 "c/sqlite3.c"
     $17 = HEAP32[$16>>2]|0; //@line 65658 "c/sqlite3.c"
     $18 = (($15) + 4)|0; //@line 65658 "c/sqlite3.c"
     $19 = $18; //@line 65658 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 65658 "c/sqlite3.c"
     $21 = ($17|0)==($2|0); //@line 65658 "c/sqlite3.c"
     $22 = ($20|0)==($3|0); //@line 65658 "c/sqlite3.c"
     $23 = $21 & $22; //@line 65658 "c/sqlite3.c"
     if ($23) {
      HEAP32[$5>>2] = 0; //@line 65659 "c/sqlite3.c"
      $$6 = 0;
      STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
     }
     $24 = ($20|0)<($3|0); //@line 65662 "c/sqlite3.c"
     $25 = ($17>>>0)<($2>>>0); //@line 65662 "c/sqlite3.c"
     $26 = ($20|0)==($3|0); //@line 65662 "c/sqlite3.c"
     $27 = $26 & $25; //@line 65662 "c/sqlite3.c"
     $28 = $24 | $27; //@line 65662 "c/sqlite3.c"
     if ($28) {
      $29 = $11 & 8; //@line 65663 "c/sqlite3.c"
      $30 = ($29|0)==(0); //@line 65663 "c/sqlite3.c"
      if (!($30)) {
       HEAP32[$5>>2] = -1; //@line 65664 "c/sqlite3.c"
       $$6 = 0;
       STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
      }
      $31 = (_i64Add(($17|0),($20|0),1,0)|0); //@line 65671 "c/sqlite3.c"
      $32 = tempRet0; //@line 65671 "c/sqlite3.c"
      $33 = ($31|0)==($2|0); //@line 65671 "c/sqlite3.c"
      $34 = ($32|0)==($3|0); //@line 65671 "c/sqlite3.c"
      $35 = $33 & $34; //@line 65671 "c/sqlite3.c"
      if ($35) {
       $36 = ((($0)) + 64|0); //@line 65671 "c/sqlite3.c"
       $37 = HEAP32[$36>>2]|0; //@line 65671 "c/sqlite3.c"
       $38 = ($37|0)==(0); //@line 65671 "c/sqlite3.c"
       if ($38) {
        HEAP32[$5>>2] = 0; //@line 65672 "c/sqlite3.c"
        $39 = (_sqlite3BtreeNext($0,0)|0); //@line 65673 "c/sqlite3.c"
        switch ($39|0) {
        case 101:  {
         $$0176 = 0;
         break L1;
         break;
        }
        case 0:  {
         break;
        }
        default: {
         $$6 = $39;
         STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
        }
        }
        _getCellInfo($0); //@line 65675 "c/sqlite3.c"
        $40 = $14; //@line 65676 "c/sqlite3.c"
        $41 = $40; //@line 65676 "c/sqlite3.c"
        $42 = HEAP32[$41>>2]|0; //@line 65676 "c/sqlite3.c"
        $43 = (($40) + 4)|0; //@line 65676 "c/sqlite3.c"
        $44 = $43; //@line 65676 "c/sqlite3.c"
        $45 = HEAP32[$44>>2]|0; //@line 65676 "c/sqlite3.c"
        $46 = ($42|0)==($2|0); //@line 65676 "c/sqlite3.c"
        $47 = ($45|0)==($3|0); //@line 65676 "c/sqlite3.c"
        $48 = $46 & $47; //@line 65676 "c/sqlite3.c"
        if ($48) {
         $$6 = 0;
         STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
        } else {
         $$0176 = 0;
        }
       } else {
        $$0176 = 0;
       }
      } else {
       $$0176 = 0;
      }
     } else {
      $$0176 = 0;
     }
    }
   } else {
    $$0176 = 0;
   }
  } else {
   $49 = (_sqlite3VdbeFindCompare($1)|0); //@line 65689 "c/sqlite3.c"
   $50 = ((($1)) + 11|0); //@line 65690 "c/sqlite3.c"
   HEAP8[$50>>0] = 0; //@line 65690 "c/sqlite3.c"
   $$0176 = $49;
  }
 } while(0);
 $51 = (_moveToRoot($0)|0); //@line 65699 "c/sqlite3.c"
 switch ($51|0) {
 case 0:  {
  $52 = ((($0)) + 116|0);
  $53 = (1 - ($4))|0;
  $54 = ((($0)) + 70|0);
  $55 = ($$0176|0)==(0|0);
  $56 = ((($0)) + 1|0);
  $57 = ((($0)) + 24|0);
  $58 = ((($0)) + 42|0);
  $59 = ((($0)) + 24|0);
  $60 = ((($0)) + 1|0);
  $$0 = 0;$$0167 = 0;$$0178 = 0;
  L24: while(1) {
   $61 = HEAP32[$52>>2]|0; //@line 65717 "c/sqlite3.c"
   $62 = ((($61)) + 22|0); //@line 65729 "c/sqlite3.c"
   $63 = HEAP16[$62>>1]|0; //@line 65729 "c/sqlite3.c"
   $64 = $63&65535; //@line 65729 "c/sqlite3.c"
   $65 = (($64) + -1)|0; //@line 65729 "c/sqlite3.c"
   $66 = $65 >> $53; //@line 65731 "c/sqlite3.c"
   $67 = $66&65535; //@line 65732 "c/sqlite3.c"
   HEAP16[$54>>1] = $67; //@line 65732 "c/sqlite3.c"
   $68 = ((($61)) + 68|0);
   $69 = ((($61)) + 24|0);
   $70 = ((($61)) + 64|0);
   L26: do {
    if ($55) {
     $71 = ((($61)) + 3|0);
     $72 = ((($61)) + 60|0);
     $73 = ((($61)) + 8|0);
     $$0185 = $66;$$0190 = $65;$$0196 = 0;$$1 = $$0;$$1179 = $$0178;
     while(1) {
      $74 = HEAP32[$68>>2]|0; //@line 65736 "c/sqlite3.c"
      $75 = HEAP16[$69>>1]|0; //@line 65736 "c/sqlite3.c"
      $76 = $75&65535; //@line 65736 "c/sqlite3.c"
      $77 = HEAP32[$70>>2]|0; //@line 65736 "c/sqlite3.c"
      $78 = $$0185 << 1; //@line 65736 "c/sqlite3.c"
      $79 = (($77) + ($78)|0); //@line 65736 "c/sqlite3.c"
      $80 = HEAP8[$79>>0]|0; //@line 65736 "c/sqlite3.c"
      $81 = $80&255; //@line 65736 "c/sqlite3.c"
      $82 = $81 << 8; //@line 65736 "c/sqlite3.c"
      $83 = ((($79)) + 1|0); //@line 65736 "c/sqlite3.c"
      $84 = HEAP8[$83>>0]|0; //@line 65736 "c/sqlite3.c"
      $85 = $84&255; //@line 65736 "c/sqlite3.c"
      $86 = $82 | $85; //@line 65736 "c/sqlite3.c"
      $87 = $86 & $76; //@line 65736 "c/sqlite3.c"
      $88 = (($74) + ($87)|0); //@line 65736 "c/sqlite3.c"
      $89 = HEAP8[$71>>0]|0; //@line 65737 "c/sqlite3.c"
      $90 = ($89<<24>>24)==(0); //@line 65737 "c/sqlite3.c"
      L30: do {
       if ($90) {
        $$1175 = $88;
        label = 25;
       } else {
        $91 = ((($88)) + 1|0); //@line 65738 "c/sqlite3.c"
        $92 = HEAP8[$88>>0]|0; //@line 65738 "c/sqlite3.c"
        $93 = ($92<<24>>24)<(0); //@line 65738 "c/sqlite3.c"
        if ($93) {
         $94 = HEAP32[$72>>2]|0;
         $96 = $91;
         while(1) {
          $99 = ($96>>>0)<($94>>>0); //@line 65739 "c/sqlite3.c"
          if (!($99)) {
           break;
          }
          $95 = ((($96)) + 1|0); //@line 65738 "c/sqlite3.c"
          $97 = HEAP8[$96>>0]|0; //@line 65738 "c/sqlite3.c"
          $98 = ($97<<24>>24)<(0); //@line 65738 "c/sqlite3.c"
          if ($98) {
           $96 = $95;
          } else {
           $$1175 = $95;
           label = 25;
           break L30;
          }
         }
         $100 = (_sqlite3CorruptError(65740)|0); //@line 65740 "c/sqlite3.c"
         $$0204 = 1;$$1186 = $$0185;$$2 = $100;$$2180 = $$1179;$$2192 = $$0190;$$2198 = $$0196;
        } else {
         $$1175 = $91;
         label = 25;
        }
       }
      } while(0);
      L37: do {
       if ((label|0) == 25) {
        label = 0;
        (_sqlite3GetVarint($$1175,$6)|0); //@line 65744 "c/sqlite3.c"
        $101 = $6; //@line 65745 "c/sqlite3.c"
        $102 = $101; //@line 65745 "c/sqlite3.c"
        $103 = HEAP32[$102>>2]|0; //@line 65745 "c/sqlite3.c"
        $104 = (($101) + 4)|0; //@line 65745 "c/sqlite3.c"
        $105 = $104; //@line 65745 "c/sqlite3.c"
        $106 = HEAP32[$105>>2]|0; //@line 65745 "c/sqlite3.c"
        $107 = ($106|0)<($3|0); //@line 65745 "c/sqlite3.c"
        $108 = ($103>>>0)<($2>>>0); //@line 65745 "c/sqlite3.c"
        $109 = ($106|0)==($3|0); //@line 65745 "c/sqlite3.c"
        $110 = $109 & $108; //@line 65745 "c/sqlite3.c"
        $111 = $107 | $110; //@line 65745 "c/sqlite3.c"
        do {
         if ($111) {
          $112 = (($$0185) + 1)|0; //@line 65746 "c/sqlite3.c"
          $113 = ($$0185|0)<($$0190|0); //@line 65747 "c/sqlite3.c"
          if ($113) {
           $$1191 = $$0190;$$1197 = $112;
          } else {
           $$0204 = 4;$$1186 = $$0185;$$2 = $$1;$$2180 = -1;$$2192 = $$0190;$$2198 = $112;
           break L37;
          }
         } else {
          $114 = ($106|0)>($3|0); //@line 65748 "c/sqlite3.c"
          $115 = ($103>>>0)>($2>>>0); //@line 65748 "c/sqlite3.c"
          $116 = ($106|0)==($3|0); //@line 65748 "c/sqlite3.c"
          $117 = $116 & $115; //@line 65748 "c/sqlite3.c"
          $118 = $114 | $117; //@line 65748 "c/sqlite3.c"
          if ($118) {
           $119 = (($$0185) + -1)|0; //@line 65749 "c/sqlite3.c"
           $120 = ($$0196|0)<($$0185|0); //@line 65750 "c/sqlite3.c"
           if ($120) {
            $$1191 = $119;$$1197 = $$0196;
            break;
           } else {
            $$0204 = 4;$$1186 = $$0185;$$2 = $$1;$$2180 = 1;$$2192 = $119;$$2198 = $$0196;
            break L37;
           }
          }
          $121 = $$0185&65535; //@line 65753 "c/sqlite3.c"
          HEAP16[$54>>1] = $121; //@line 65753 "c/sqlite3.c"
          $122 = HEAP8[$73>>0]|0; //@line 65754 "c/sqlite3.c"
          $123 = ($122<<24>>24)==(0); //@line 65754 "c/sqlite3.c"
          if ($123) {
           $$0204 = 8;$$1186 = $$0185;$$2 = $$1;$$2180 = $$1179;$$2192 = $$0190;$$2198 = $$0185;
           break L37;
          }
          $124 = HEAP8[$56>>0]|0; //@line 65758 "c/sqlite3.c"
          $125 = $124 | 2; //@line 65758 "c/sqlite3.c"
          HEAP8[$56>>0] = $125; //@line 65758 "c/sqlite3.c"
          $126 = $57; //@line 65759 "c/sqlite3.c"
          $127 = $126; //@line 65759 "c/sqlite3.c"
          HEAP32[$127>>2] = $103; //@line 65759 "c/sqlite3.c"
          $128 = (($126) + 4)|0; //@line 65759 "c/sqlite3.c"
          $129 = $128; //@line 65759 "c/sqlite3.c"
          HEAP32[$129>>2] = $106; //@line 65759 "c/sqlite3.c"
          HEAP16[$58>>1] = 0; //@line 65760 "c/sqlite3.c"
          HEAP32[$5>>2] = 0; //@line 65761 "c/sqlite3.c"
          $$0204 = 1;$$1186 = $$0185;$$2 = 0;$$2180 = $$1179;$$2192 = $$0190;$$2198 = $$0196;
          break L37;
         }
        } while(0);
        $130 = (($$1191) + ($$1197))|0; //@line 65766 "c/sqlite3.c"
        $131 = $130 >> 1; //@line 65766 "c/sqlite3.c"
        $$0204 = 0;$$1186 = $131;$$2 = $$1;$$2180 = $$1179;$$2192 = $$1191;$$2198 = $$1197;
       }
      } while(0);
      $trunc = $$0204&255;
      $trunc$clear = $trunc & 15;
      switch ($trunc$clear<<24>>24) {
      case 4:  {
       $$3 = $$2;$$4189 = $$1186;$$6202 = $$2198;$$7 = $$2180;
       label = 53;
       break L26;
       break;
      }
      case 8:  {
       $$4 = $$2;$$7203 = $$2198;$$8 = $$2180;
       label = 55;
       break L26;
       break;
      }
      case 0:  {
       $$0185 = $$1186;$$0190 = $$2192;$$0196 = $$2198;$$1 = $$2;$$1179 = $$2180;
       break;
      }
      default: {
       $$3207 = $$0204;$$5 = $$2;$$6173 = $$0167;$$9 = $$2180;
       break L26;
      }
      }
     }
    } else {
     $132 = ((($61)) + 11|0);
     $133 = ((($61)) + 14|0);
     $134 = ((($61)) + 10|0);
     $135 = ((($61)) + 80|0);
     $$2187 = $66;$$3193 = $65;$$3199 = 0;
     while(1) {
      $136 = HEAP32[$68>>2]|0; //@line 65771 "c/sqlite3.c"
      $137 = HEAP16[$69>>1]|0; //@line 65771 "c/sqlite3.c"
      $138 = $137&65535; //@line 65771 "c/sqlite3.c"
      $139 = HEAP32[$70>>2]|0; //@line 65771 "c/sqlite3.c"
      $140 = $$2187 << 1; //@line 65771 "c/sqlite3.c"
      $141 = (($139) + ($140)|0); //@line 65771 "c/sqlite3.c"
      $142 = HEAP8[$141>>0]|0; //@line 65771 "c/sqlite3.c"
      $143 = $142&255; //@line 65771 "c/sqlite3.c"
      $144 = $143 << 8; //@line 65771 "c/sqlite3.c"
      $145 = ((($141)) + 1|0); //@line 65771 "c/sqlite3.c"
      $146 = HEAP8[$145>>0]|0; //@line 65771 "c/sqlite3.c"
      $147 = $146&255; //@line 65771 "c/sqlite3.c"
      $148 = $144 | $147; //@line 65771 "c/sqlite3.c"
      $149 = $148 & $138; //@line 65771 "c/sqlite3.c"
      $150 = (($136) + ($149)|0); //@line 65771 "c/sqlite3.c"
      $151 = HEAP8[$150>>0]|0; //@line 65781 "c/sqlite3.c"
      $152 = $151&255; //@line 65781 "c/sqlite3.c"
      $153 = HEAP8[$132>>0]|0; //@line 65782 "c/sqlite3.c"
      $154 = ($151&255)>($153&255); //@line 65782 "c/sqlite3.c"
      $155 = ((($150)) + 1|0);
      do {
       if ($154) {
        $157 = HEAP8[$155>>0]|0; //@line 65788 "c/sqlite3.c"
        $158 = $157&255; //@line 65788 "c/sqlite3.c"
        $159 = $158 & 128; //@line 65788 "c/sqlite3.c"
        $160 = ($159|0)==(0); //@line 65788 "c/sqlite3.c"
        if ($160) {
         $161 = $152 << 7; //@line 65789 "c/sqlite3.c"
         $162 = $161 & 16256; //@line 65789 "c/sqlite3.c"
         $163 = (($162) + ($158))|0; //@line 65789 "c/sqlite3.c"
         $164 = HEAP16[$133>>1]|0; //@line 65789 "c/sqlite3.c"
         $165 = $164&65535; //@line 65789 "c/sqlite3.c"
         $166 = ($163>>>0)>($165>>>0); //@line 65789 "c/sqlite3.c"
         if (!($166)) {
          $167 = ((($150)) + 2|0); //@line 65794 "c/sqlite3.c"
          $168 = (FUNCTION_TABLE_iiii[$$0176 & 127]($163,$167,$1)|0); //@line 65794 "c/sqlite3.c"
          $$5183 = $168;
          break;
         }
        }
        $169 = HEAP8[$134>>0]|0; //@line 65806 "c/sqlite3.c"
        $170 = $169&255; //@line 65806 "c/sqlite3.c"
        $171 = (0 - ($170))|0; //@line 65806 "c/sqlite3.c"
        $172 = (($150) + ($171)|0); //@line 65806 "c/sqlite3.c"
        $173 = HEAP32[$135>>2]|0; //@line 65807 "c/sqlite3.c"
        FUNCTION_TABLE_viii[$173 & 255]($61,$172,$59); //@line 65807 "c/sqlite3.c"
        $174 = $59; //@line 65808 "c/sqlite3.c"
        $175 = $174; //@line 65808 "c/sqlite3.c"
        $176 = HEAP32[$175>>2]|0; //@line 65808 "c/sqlite3.c"
        $177 = (($174) + 4)|0; //@line 65808 "c/sqlite3.c"
        $178 = $177; //@line 65808 "c/sqlite3.c"
        $179 = HEAP32[$178>>2]|0; //@line 65808 "c/sqlite3.c"
        $180 = ($176|0)<(2); //@line 65813 "c/sqlite3.c"
        if ($180) {
         label = 40;
         break L24;
        }
        $182 = (($176) + 18)|0; //@line 65817 "c/sqlite3.c"
        $183 = ($182|0)<(0); //@line 65817 "c/sqlite3.c"
        $184 = $183 << 31 >> 31; //@line 65817 "c/sqlite3.c"
        $185 = (_sqlite3Malloc($182,$184)|0); //@line 65817 "c/sqlite3.c"
        $186 = ($185|0)==(0|0); //@line 65818 "c/sqlite3.c"
        if ($186) {
         $$6173220 = 7;
         break L24;
        }
        $187 = $$2187&65535; //@line 65822 "c/sqlite3.c"
        HEAP16[$54>>1] = $187; //@line 65822 "c/sqlite3.c"
        $188 = (_accessPayload($0,0,$176,$185,0)|0); //@line 65823 "c/sqlite3.c"
        $189 = HEAP8[$60>>0]|0; //@line 65824 "c/sqlite3.c"
        $190 = $189 & -5; //@line 65824 "c/sqlite3.c"
        HEAP8[$60>>0] = $190; //@line 65824 "c/sqlite3.c"
        $191 = ($188|0)==(0); //@line 65825 "c/sqlite3.c"
        if (!($191)) {
         label = 43;
         break L24;
        }
        $192 = (FUNCTION_TABLE_iiii[$$0176 & 127]($176,$185,$1)|0); //@line 65829 "c/sqlite3.c"
        _sqlite3_free($185); //@line 65830 "c/sqlite3.c"
        $$5183 = $192;
       } else {
        $156 = (FUNCTION_TABLE_iiii[$$0176 & 127]($152,$155,$1)|0); //@line 65787 "c/sqlite3.c"
        $$5183 = $156;
       }
      } while(0);
      $193 = ($$5183|0)<(0); //@line 65836 "c/sqlite3.c"
      if ($193) {
       $194 = (($$2187) + 1)|0; //@line 65837 "c/sqlite3.c"
       $$4194 = $$3193;$$4200 = $194;
      } else {
       $195 = ($$5183|0)==(0); //@line 65838 "c/sqlite3.c"
       if ($195) {
        label = 49;
        break L24;
       }
       $196 = (($$2187) + -1)|0; //@line 65839 "c/sqlite3.c"
       $$4194 = $196;$$4200 = $$3199;
      }
      $202 = ($$4200|0)>($$4194|0); //@line 65848 "c/sqlite3.c"
      if ($202) {
       $$3 = $$0;$$4189 = $$2187;$$6202 = $$4200;$$7 = $$5183;
       label = 53;
       break L26;
      }
      $203 = (($$4194) + ($$4200))|0; //@line 65850 "c/sqlite3.c"
      $204 = $203 >> 1; //@line 65850 "c/sqlite3.c"
      $$2187 = $204;$$3193 = $$4194;$$3199 = $$4200;
     }
    }
   } while(0);
   if ((label|0) == 53) {
    label = 0;
    $205 = ((($61)) + 8|0); //@line 65855 "c/sqlite3.c"
    $206 = HEAP8[$205>>0]|0; //@line 65855 "c/sqlite3.c"
    $207 = ($206<<24>>24)==(0); //@line 65855 "c/sqlite3.c"
    if ($207) {
     $$4 = $$3;$$7203 = $$6202;$$8 = $$7;
     label = 55;
    } else {
     label = 54;
     break;
    }
   }
   if ((label|0) == 55) {
    label = 0;
    $209 = HEAP16[$62>>1]|0; //@line 65863 "c/sqlite3.c"
    $210 = $209&65535; //@line 65863 "c/sqlite3.c"
    $211 = ($$7203|0)<($210|0); //@line 65863 "c/sqlite3.c"
    $212 = ((($61)) + 56|0);
    $213 = HEAP32[$212>>2]|0;
    if ($211) {
     $220 = ((($61)) + 24|0); //@line 65866 "c/sqlite3.c"
     $221 = HEAP16[$220>>1]|0; //@line 65866 "c/sqlite3.c"
     $222 = $221&65535; //@line 65866 "c/sqlite3.c"
     $223 = ((($61)) + 64|0); //@line 65866 "c/sqlite3.c"
     $224 = HEAP32[$223>>2]|0; //@line 65866 "c/sqlite3.c"
     $225 = $$7203 << 1; //@line 65866 "c/sqlite3.c"
     $226 = (($224) + ($225)|0); //@line 65866 "c/sqlite3.c"
     $227 = HEAP8[$226>>0]|0; //@line 65866 "c/sqlite3.c"
     $228 = $227&255; //@line 65866 "c/sqlite3.c"
     $229 = $228 << 8; //@line 65866 "c/sqlite3.c"
     $230 = ((($226)) + 1|0); //@line 65866 "c/sqlite3.c"
     $231 = HEAP8[$230>>0]|0; //@line 65866 "c/sqlite3.c"
     $232 = $231&255; //@line 65866 "c/sqlite3.c"
     $233 = $229 | $232; //@line 65866 "c/sqlite3.c"
     $234 = $233 & $222; //@line 65866 "c/sqlite3.c"
     $235 = (($213) + ($234)|0); //@line 65866 "c/sqlite3.c"
     $236 = (_sqlite3Get4byte($235)|0); //@line 65866 "c/sqlite3.c"
     $$0177 = $236;
    } else {
     $214 = ((($61)) + 9|0); //@line 65864 "c/sqlite3.c"
     $215 = HEAP8[$214>>0]|0; //@line 65864 "c/sqlite3.c"
     $216 = $215&255; //@line 65864 "c/sqlite3.c"
     $217 = (($216) + 8)|0; //@line 65864 "c/sqlite3.c"
     $218 = (($213) + ($217)|0); //@line 65864 "c/sqlite3.c"
     $219 = (_sqlite3Get4byte($218)|0); //@line 65864 "c/sqlite3.c"
     $$0177 = $219;
    }
    $237 = $$7203&65535; //@line 65868 "c/sqlite3.c"
    HEAP16[$54>>1] = $237; //@line 65868 "c/sqlite3.c"
    $238 = (_moveToChild($0,$$0177)|0); //@line 65869 "c/sqlite3.c"
    $239 = ($238|0)==(0); //@line 65870 "c/sqlite3.c"
    $$ = $239 ? 0 : 2; //@line 65871 "c/sqlite3.c"
    $$3207 = $$;$$5 = $$4;$$6173 = $238;$$9 = $$8;
   }
   switch ($$3207|0) {
   case 0:  {
    $$0 = $$5;$$0167 = $$6173;$$0178 = $$9;
    break;
   }
   case 11: case 2:  {
    $$6173220 = $$6173;
    break L24;
    break;
   }
   default: {
    $$6 = $$5;
    label = 61;
    break L24;
   }
   }
  }
  if ((label|0) == 40) {
   $181 = (_sqlite3CorruptError(65814)|0); //@line 65814 "c/sqlite3.c"
   $$6173220 = $181;
  }
  else if ((label|0) == 43) {
   _sqlite3_free($185); //@line 65826 "c/sqlite3.c"
   $$6173220 = $188;
  }
  else if ((label|0) == 49) {
   HEAP32[$5>>2] = 0; //@line 65842 "c/sqlite3.c"
   $197 = $$2187&65535; //@line 65844 "c/sqlite3.c"
   HEAP16[$54>>1] = $197; //@line 65844 "c/sqlite3.c"
   $198 = ((($1)) + 11|0); //@line 65845 "c/sqlite3.c"
   $199 = HEAP8[$198>>0]|0; //@line 65845 "c/sqlite3.c"
   $200 = ($199<<24>>24)==(0); //@line 65845 "c/sqlite3.c"
   if ($200) {
    $$6173220 = 0;
   } else {
    $201 = (_sqlite3CorruptError(65845)|0); //@line 65845 "c/sqlite3.c"
    $$6173220 = $201;
   }
  }
  else if ((label|0) == 54) {
   $208 = $$4189&65535; //@line 65857 "c/sqlite3.c"
   HEAP16[$54>>1] = $208; //@line 65857 "c/sqlite3.c"
   HEAP32[$5>>2] = $$7; //@line 65858 "c/sqlite3.c"
   $$6173220 = 0;
  }
  else if ((label|0) == 61) {
   STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
  }
  $240 = ((($0)) + 42|0); //@line 65873 "c/sqlite3.c"
  HEAP16[$240>>1] = 0; //@line 65873 "c/sqlite3.c"
  $$6 = $$6173220;
  STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
  break;
 }
 case 16:  {
  HEAP32[$5>>2] = -1; //@line 65703 "c/sqlite3.c"
  $$6 = 0;
  STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
  break;
 }
 default: {
  $$6 = $51;
  STACKTOP = sp;return ($$6|0); //@line 65876 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3VdbeAllocUnpackedRecord($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 6|0); //@line 76521 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 76521 "c/sqlite3.c"
 $3 = $2&65535; //@line 76521 "c/sqlite3.c"
 $4 = ($3*40)|0; //@line 76521 "c/sqlite3.c"
 $5 = (($4) + 56)|0; //@line 76521 "c/sqlite3.c"
 $6 = ((($0)) + 12|0); //@line 76522 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 76522 "c/sqlite3.c"
 $8 = (_sqlite3DbMallocRaw($7,$5,0)|0); //@line 76522 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 76523 "c/sqlite3.c"
 if ($9) {
  $$0 = 0;
  return ($$0|0); //@line 76529 "c/sqlite3.c"
 }
 $10 = ((($8)) + 16|0); //@line 76524 "c/sqlite3.c"
 $11 = ((($8)) + 4|0); //@line 76524 "c/sqlite3.c"
 HEAP32[$11>>2] = $10; //@line 76524 "c/sqlite3.c"
 HEAP32[$8>>2] = $0; //@line 76526 "c/sqlite3.c"
 $12 = HEAP16[$1>>1]|0; //@line 76527 "c/sqlite3.c"
 $13 = $12&65535; //@line 76527 "c/sqlite3.c"
 $14 = (($13) + 1)|0; //@line 76527 "c/sqlite3.c"
 $15 = $14&65535; //@line 76527 "c/sqlite3.c"
 $16 = ((($8)) + 8|0); //@line 76527 "c/sqlite3.c"
 HEAP16[$16>>1] = $15; //@line 76527 "c/sqlite3.c"
 $$0 = $8;
 return ($$0|0); //@line 76529 "c/sqlite3.c"
}
function _sqlite3VdbeRecordUnpack($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$03745 = 0, $$03844 = 0, $$03943 = 0, $$04042 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond41 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 $6 = ((($3)) + 4|0); //@line 76547 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 76547 "c/sqlite3.c"
 $8 = ((($3)) + 10|0); //@line 76549 "c/sqlite3.c"
 HEAP8[$8>>0] = 0; //@line 76549 "c/sqlite3.c"
 $9 = HEAP8[$2>>0]|0; //@line 76551 "c/sqlite3.c"
 $10 = ($9<<24>>24)>(-1); //@line 76551 "c/sqlite3.c"
 if ($10) {
  $11 = $9&255; //@line 76551 "c/sqlite3.c"
  HEAP32[$4>>2] = $11; //@line 76551 "c/sqlite3.c"
  $14 = 1;
 } else {
  $12 = (_sqlite3GetVarint32($2,$4)|0); //@line 76551 "c/sqlite3.c"
  $14 = $12;
 }
 $13 = $14&255; //@line 76551 "c/sqlite3.c"
 $15 = HEAP32[$4>>2]|0; //@line 76552 "c/sqlite3.c"
 $16 = ($15>>>0)<=($13>>>0); //@line 76554 "c/sqlite3.c"
 $17 = ($15|0)>($1|0); //@line 76554 "c/sqlite3.c"
 $or$cond41 = $17 | $16; //@line 76554 "c/sqlite3.c"
 if ($or$cond41) {
  $$1 = 0;
  $46 = ((($3)) + 8|0); //@line 76568 "c/sqlite3.c"
  HEAP16[$46>>1] = $$1; //@line 76568 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 76569 "c/sqlite3.c"
 }
 $18 = ((($0)) + 4|0);
 $19 = ((($0)) + 12|0);
 $20 = ((($3)) + 8|0);
 $21 = HEAP32[$4>>2]|0;
 $$03745 = $7;$$03844 = 0;$$03943 = $13;$$04042 = $15;
 while(1) {
  $22 = (($2) + ($$03943)|0); //@line 76557 "c/sqlite3.c"
  $23 = HEAP8[$22>>0]|0; //@line 76557 "c/sqlite3.c"
  $24 = ($23<<24>>24)>(-1); //@line 76557 "c/sqlite3.c"
  if ($24) {
   $25 = $23&255; //@line 76557 "c/sqlite3.c"
   HEAP32[$5>>2] = $25; //@line 76557 "c/sqlite3.c"
   $43 = 1;
  } else {
   $26 = (_sqlite3GetVarint32($22,$5)|0); //@line 76557 "c/sqlite3.c"
   $27 = $26&255; //@line 76557 "c/sqlite3.c"
   $43 = $27;
  }
  $28 = HEAP8[$18>>0]|0; //@line 76558 "c/sqlite3.c"
  $29 = ((($$03745)) + 10|0); //@line 76558 "c/sqlite3.c"
  HEAP8[$29>>0] = $28; //@line 76558 "c/sqlite3.c"
  $30 = HEAP32[$19>>2]|0; //@line 76559 "c/sqlite3.c"
  $31 = ((($$03745)) + 32|0); //@line 76559 "c/sqlite3.c"
  HEAP32[$31>>2] = $30; //@line 76559 "c/sqlite3.c"
  $32 = ((($$03745)) + 24|0); //@line 76561 "c/sqlite3.c"
  HEAP32[$32>>2] = 0; //@line 76561 "c/sqlite3.c"
  $33 = ((($$03745)) + 16|0); //@line 76562 "c/sqlite3.c"
  HEAP32[$33>>2] = 0; //@line 76562 "c/sqlite3.c"
  $34 = (($2) + ($$04042)|0); //@line 76563 "c/sqlite3.c"
  $35 = HEAP32[$5>>2]|0; //@line 76563 "c/sqlite3.c"
  $36 = (_sqlite3VdbeSerialGet($34,$35,$$03745)|0); //@line 76563 "c/sqlite3.c"
  $37 = (($$03844) + 1)<<16>>16; //@line 76565 "c/sqlite3.c"
  $38 = HEAP16[$20>>1]|0; //@line 76565 "c/sqlite3.c"
  $39 = ($37&65535)<($38&65535); //@line 76565 "c/sqlite3.c"
  if (!($39)) {
   $$1 = $37;
   label = 11;
   break;
  }
  $40 = ((($$03745)) + 40|0); //@line 76564 "c/sqlite3.c"
  $41 = (($36) + ($$04042))|0; //@line 76563 "c/sqlite3.c"
  $42 = (($43) + ($$03943))|0; //@line 76557 "c/sqlite3.c"
  $44 = ($42>>>0)>=($21>>>0); //@line 76554 "c/sqlite3.c"
  $45 = ($41|0)>($1|0); //@line 76554 "c/sqlite3.c"
  $or$cond = $45 | $44; //@line 76554 "c/sqlite3.c"
  if ($or$cond) {
   $$1 = $37;
   label = 11;
   break;
  } else {
   $$03745 = $40;$$03844 = $37;$$03943 = $42;$$04042 = $41;
  }
 }
 if ((label|0) == 11) {
  $46 = ((($3)) + 8|0); //@line 76568 "c/sqlite3.c"
  HEAP16[$46>>1] = $$1; //@line 76568 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 76569 "c/sqlite3.c"
 }
}
function _sqlite3GetVarint32($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP8[$0>>0]|0; //@line 29520 "c/sqlite3.c"
 $4 = $3&255; //@line 29520 "c/sqlite3.c"
 $5 = ((($0)) + 1|0); //@line 29532 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 29533 "c/sqlite3.c"
 $7 = $6&255; //@line 29533 "c/sqlite3.c"
 $8 = $7 & 128; //@line 29535 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 29535 "c/sqlite3.c"
 if ($9) {
  $10 = $4 << 7; //@line 29539 "c/sqlite3.c"
  $11 = $10 & 16256; //@line 29539 "c/sqlite3.c"
  $12 = $11 | $7; //@line 29540 "c/sqlite3.c"
  HEAP32[$1>>2] = $12; //@line 29540 "c/sqlite3.c"
  $$0 = 2;
  STACKTOP = sp;return ($$0|0); //@line 29632 "c/sqlite3.c"
 }
 $13 = ((($0)) + 2|0); //@line 29545 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 29547 "c/sqlite3.c"
 $15 = $14&255; //@line 29547 "c/sqlite3.c"
 $16 = $15 & 128; //@line 29549 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 29549 "c/sqlite3.c"
 if ($17) {
  $18 = $4 << 14; //@line 29546 "c/sqlite3.c"
  $19 = $18 | $15; //@line 29547 "c/sqlite3.c"
  $20 = $19 & 2080895; //@line 29552 "c/sqlite3.c"
  $21 = $7 << 7; //@line 29554 "c/sqlite3.c"
  $22 = $21 & 16256; //@line 29554 "c/sqlite3.c"
  $23 = $20 | $22; //@line 29555 "c/sqlite3.c"
  HEAP32[$1>>2] = $23; //@line 29555 "c/sqlite3.c"
  $$0 = 3;
  STACKTOP = sp;return ($$0|0); //@line 29632 "c/sqlite3.c"
 } else {
  $24 = (_sqlite3GetVarint($0,$2)|0); //@line 29574 "c/sqlite3.c"
  $25 = $2; //@line 29576 "c/sqlite3.c"
  $26 = $25; //@line 29576 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 29576 "c/sqlite3.c"
  $28 = (($25) + 4)|0; //@line 29576 "c/sqlite3.c"
  $29 = $28; //@line 29576 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 29576 "c/sqlite3.c"
  $31 = ($27|0)==($27|0); //@line 29576 "c/sqlite3.c"
  $32 = (0)==($30|0); //@line 29576 "c/sqlite3.c"
  $33 = $31 & $32; //@line 29576 "c/sqlite3.c"
  $storemerge = $33 ? $27 : -1; //@line 29576 "c/sqlite3.c"
  HEAP32[$1>>2] = $storemerge;
  $$0 = $24;
  STACKTOP = sp;return ($$0|0); //@line 29632 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeSerialGet($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 do {
  switch ($1|0) {
  case 10:  {
   $3 = ((($2)) + 8|0); //@line 76419 "c/sqlite3.c"
   HEAP16[$3>>1] = 16385; //@line 76419 "c/sqlite3.c"
   $4 = ((($2)) + 12|0); //@line 76420 "c/sqlite3.c"
   HEAP32[$4>>2] = 0; //@line 76420 "c/sqlite3.c"
   HEAP32[$2>>2] = 0; //@line 76421 "c/sqlite3.c"
   $$0 = 0;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 0: case 11:  {
   $5 = ((($2)) + 8|0); //@line 76427 "c/sqlite3.c"
   HEAP16[$5>>1] = 1; //@line 76427 "c/sqlite3.c"
   $$0 = 0;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 1:  {
   $6 = HEAP8[$0>>0]|0; //@line 76433 "c/sqlite3.c"
   $7 = $6 << 24 >> 24; //@line 76433 "c/sqlite3.c"
   $8 = ($7|0)<(0); //@line 76433 "c/sqlite3.c"
   $9 = $8 << 31 >> 31; //@line 76433 "c/sqlite3.c"
   $10 = $2; //@line 76433 "c/sqlite3.c"
   $11 = $10; //@line 76433 "c/sqlite3.c"
   HEAP32[$11>>2] = $7; //@line 76433 "c/sqlite3.c"
   $12 = (($10) + 4)|0; //@line 76433 "c/sqlite3.c"
   $13 = $12; //@line 76433 "c/sqlite3.c"
   HEAP32[$13>>2] = $9; //@line 76433 "c/sqlite3.c"
   $14 = ((($2)) + 8|0); //@line 76434 "c/sqlite3.c"
   HEAP16[$14>>1] = 4; //@line 76434 "c/sqlite3.c"
   $$0 = 1;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 2:  {
   $15 = HEAP8[$0>>0]|0; //@line 76441 "c/sqlite3.c"
   $16 = $15 << 24 >> 24; //@line 76441 "c/sqlite3.c"
   $17 = $16 << 8; //@line 76441 "c/sqlite3.c"
   $18 = ((($0)) + 1|0); //@line 76441 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 76441 "c/sqlite3.c"
   $20 = $19&255; //@line 76441 "c/sqlite3.c"
   $21 = $17 | $20; //@line 76441 "c/sqlite3.c"
   $22 = ($21|0)<(0); //@line 76441 "c/sqlite3.c"
   $23 = $22 << 31 >> 31; //@line 76441 "c/sqlite3.c"
   $24 = $2; //@line 76441 "c/sqlite3.c"
   $25 = $24; //@line 76441 "c/sqlite3.c"
   HEAP32[$25>>2] = $21; //@line 76441 "c/sqlite3.c"
   $26 = (($24) + 4)|0; //@line 76441 "c/sqlite3.c"
   $27 = $26; //@line 76441 "c/sqlite3.c"
   HEAP32[$27>>2] = $23; //@line 76441 "c/sqlite3.c"
   $28 = ((($2)) + 8|0); //@line 76442 "c/sqlite3.c"
   HEAP16[$28>>1] = 4; //@line 76442 "c/sqlite3.c"
   $$0 = 2;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 3:  {
   $29 = HEAP8[$0>>0]|0; //@line 76449 "c/sqlite3.c"
   $30 = $29 << 24 >> 24; //@line 76449 "c/sqlite3.c"
   $31 = $30 << 16; //@line 76449 "c/sqlite3.c"
   $32 = ((($0)) + 1|0); //@line 76449 "c/sqlite3.c"
   $33 = HEAP8[$32>>0]|0; //@line 76449 "c/sqlite3.c"
   $34 = $33&255; //@line 76449 "c/sqlite3.c"
   $35 = $34 << 8; //@line 76449 "c/sqlite3.c"
   $36 = $35 | $31; //@line 76449 "c/sqlite3.c"
   $37 = ((($0)) + 2|0); //@line 76449 "c/sqlite3.c"
   $38 = HEAP8[$37>>0]|0; //@line 76449 "c/sqlite3.c"
   $39 = $38&255; //@line 76449 "c/sqlite3.c"
   $40 = $36 | $39; //@line 76449 "c/sqlite3.c"
   $41 = ($40|0)<(0); //@line 76449 "c/sqlite3.c"
   $42 = $41 << 31 >> 31; //@line 76449 "c/sqlite3.c"
   $43 = $2; //@line 76449 "c/sqlite3.c"
   $44 = $43; //@line 76449 "c/sqlite3.c"
   HEAP32[$44>>2] = $40; //@line 76449 "c/sqlite3.c"
   $45 = (($43) + 4)|0; //@line 76449 "c/sqlite3.c"
   $46 = $45; //@line 76449 "c/sqlite3.c"
   HEAP32[$46>>2] = $42; //@line 76449 "c/sqlite3.c"
   $47 = ((($2)) + 8|0); //@line 76450 "c/sqlite3.c"
   HEAP16[$47>>1] = 4; //@line 76450 "c/sqlite3.c"
   $$0 = 3;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 4:  {
   $48 = HEAP8[$0>>0]|0; //@line 76457 "c/sqlite3.c"
   $49 = $48 << 24 >> 24; //@line 76457 "c/sqlite3.c"
   $50 = $49 << 24; //@line 76457 "c/sqlite3.c"
   $51 = ((($0)) + 1|0); //@line 76457 "c/sqlite3.c"
   $52 = HEAP8[$51>>0]|0; //@line 76457 "c/sqlite3.c"
   $53 = $52&255; //@line 76457 "c/sqlite3.c"
   $54 = $53 << 16; //@line 76457 "c/sqlite3.c"
   $55 = $54 | $50; //@line 76457 "c/sqlite3.c"
   $56 = ((($0)) + 2|0); //@line 76457 "c/sqlite3.c"
   $57 = HEAP8[$56>>0]|0; //@line 76457 "c/sqlite3.c"
   $58 = $57&255; //@line 76457 "c/sqlite3.c"
   $59 = $58 << 8; //@line 76457 "c/sqlite3.c"
   $60 = $55 | $59; //@line 76457 "c/sqlite3.c"
   $61 = ((($0)) + 3|0); //@line 76457 "c/sqlite3.c"
   $62 = HEAP8[$61>>0]|0; //@line 76457 "c/sqlite3.c"
   $63 = $62&255; //@line 76457 "c/sqlite3.c"
   $64 = $60 | $63; //@line 76457 "c/sqlite3.c"
   $65 = ($64|0)<(0); //@line 76457 "c/sqlite3.c"
   $66 = $65 << 31 >> 31; //@line 76457 "c/sqlite3.c"
   $67 = $2; //@line 76457 "c/sqlite3.c"
   $68 = $67; //@line 76457 "c/sqlite3.c"
   HEAP32[$68>>2] = $64; //@line 76457 "c/sqlite3.c"
   $69 = (($67) + 4)|0; //@line 76457 "c/sqlite3.c"
   $70 = $69; //@line 76457 "c/sqlite3.c"
   HEAP32[$70>>2] = $66; //@line 76457 "c/sqlite3.c"
   $71 = ((($2)) + 8|0); //@line 76462 "c/sqlite3.c"
   HEAP16[$71>>1] = 4; //@line 76462 "c/sqlite3.c"
   $$0 = 4;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 5:  {
   $72 = ((($0)) + 2|0); //@line 76469 "c/sqlite3.c"
   $73 = HEAP8[$72>>0]|0; //@line 76469 "c/sqlite3.c"
   $74 = $73&255; //@line 76469 "c/sqlite3.c"
   $75 = $74 << 24; //@line 76469 "c/sqlite3.c"
   $76 = ((($0)) + 3|0); //@line 76469 "c/sqlite3.c"
   $77 = HEAP8[$76>>0]|0; //@line 76469 "c/sqlite3.c"
   $78 = $77&255; //@line 76469 "c/sqlite3.c"
   $79 = $78 << 16; //@line 76469 "c/sqlite3.c"
   $80 = $79 | $75; //@line 76469 "c/sqlite3.c"
   $81 = ((($0)) + 4|0); //@line 76469 "c/sqlite3.c"
   $82 = HEAP8[$81>>0]|0; //@line 76469 "c/sqlite3.c"
   $83 = $82&255; //@line 76469 "c/sqlite3.c"
   $84 = $83 << 8; //@line 76469 "c/sqlite3.c"
   $85 = $80 | $84; //@line 76469 "c/sqlite3.c"
   $86 = ((($0)) + 5|0); //@line 76469 "c/sqlite3.c"
   $87 = HEAP8[$86>>0]|0; //@line 76469 "c/sqlite3.c"
   $88 = $87&255; //@line 76469 "c/sqlite3.c"
   $89 = $85 | $88; //@line 76469 "c/sqlite3.c"
   $90 = HEAP8[$0>>0]|0; //@line 76469 "c/sqlite3.c"
   $91 = $90 << 24 >> 24; //@line 76469 "c/sqlite3.c"
   $92 = $91 << 8; //@line 76469 "c/sqlite3.c"
   $93 = ((($0)) + 1|0); //@line 76469 "c/sqlite3.c"
   $94 = HEAP8[$93>>0]|0; //@line 76469 "c/sqlite3.c"
   $95 = $94&255; //@line 76469 "c/sqlite3.c"
   $96 = $92 | $95; //@line 76469 "c/sqlite3.c"
   $97 = ($96|0)<(0); //@line 76469 "c/sqlite3.c"
   $97 << 31 >> 31; //@line 76469 "c/sqlite3.c"
   $98 = $2; //@line 76469 "c/sqlite3.c"
   $99 = $98; //@line 76469 "c/sqlite3.c"
   HEAP32[$99>>2] = $89; //@line 76469 "c/sqlite3.c"
   $100 = (($98) + 4)|0; //@line 76469 "c/sqlite3.c"
   $101 = $100; //@line 76469 "c/sqlite3.c"
   HEAP32[$101>>2] = $96; //@line 76469 "c/sqlite3.c"
   $102 = ((($2)) + 8|0); //@line 76470 "c/sqlite3.c"
   HEAP16[$102>>1] = 4; //@line 76470 "c/sqlite3.c"
   $$0 = 6;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 7: case 6:  {
   _serialGet($0,$1,$2); //@line 76478 "c/sqlite3.c"
   $$0 = 8;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  case 9: case 8:  {
   $103 = (($1) + -8)|0; //@line 76484 "c/sqlite3.c"
   $104 = $2; //@line 76484 "c/sqlite3.c"
   $105 = $104; //@line 76484 "c/sqlite3.c"
   HEAP32[$105>>2] = $103; //@line 76484 "c/sqlite3.c"
   $106 = (($104) + 4)|0; //@line 76484 "c/sqlite3.c"
   $107 = $106; //@line 76484 "c/sqlite3.c"
   HEAP32[$107>>2] = 0; //@line 76484 "c/sqlite3.c"
   $108 = ((($2)) + 8|0); //@line 76485 "c/sqlite3.c"
   HEAP16[$108>>1] = 4; //@line 76485 "c/sqlite3.c"
   $$0 = 0;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
   break;
  }
  default: {
   $109 = ((($2)) + 16|0); //@line 76494 "c/sqlite3.c"
   HEAP32[$109>>2] = $0; //@line 76494 "c/sqlite3.c"
   $110 = (($1) + -12)|0; //@line 76495 "c/sqlite3.c"
   $111 = $110 >>> 1; //@line 76495 "c/sqlite3.c"
   $112 = ((($2)) + 12|0); //@line 76495 "c/sqlite3.c"
   HEAP32[$112>>2] = $111; //@line 76495 "c/sqlite3.c"
   $113 = $1 & 1; //@line 76496 "c/sqlite3.c"
   $114 = (11722 + ($113<<1)|0); //@line 76496 "c/sqlite3.c"
   $115 = HEAP16[$114>>1]|0; //@line 76496 "c/sqlite3.c"
   $116 = ((($2)) + 8|0); //@line 76496 "c/sqlite3.c"
   HEAP16[$116>>1] = $115; //@line 76496 "c/sqlite3.c"
   $$0 = $111;
   return ($$0|0); //@line 76501 "c/sqlite3.c"
  }
  }
 } while(0);
 return (0)|0;
}
function _serialGet($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0.0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP8[$0>>0]|0; //@line 76380 "c/sqlite3.c"
 $4 = $3&255; //@line 76380 "c/sqlite3.c"
 $5 = $4 << 24; //@line 76380 "c/sqlite3.c"
 $6 = ((($0)) + 1|0); //@line 76380 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 76380 "c/sqlite3.c"
 $8 = $7&255; //@line 76380 "c/sqlite3.c"
 $9 = $8 << 16; //@line 76380 "c/sqlite3.c"
 $10 = $9 | $5; //@line 76380 "c/sqlite3.c"
 $11 = ((($0)) + 2|0); //@line 76380 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 76380 "c/sqlite3.c"
 $13 = $12&255; //@line 76380 "c/sqlite3.c"
 $14 = $13 << 8; //@line 76380 "c/sqlite3.c"
 $15 = $10 | $14; //@line 76380 "c/sqlite3.c"
 $16 = ((($0)) + 3|0); //@line 76380 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 76380 "c/sqlite3.c"
 $18 = $17&255; //@line 76380 "c/sqlite3.c"
 $19 = $15 | $18; //@line 76380 "c/sqlite3.c"
 $20 = ((($0)) + 4|0); //@line 76381 "c/sqlite3.c"
 $21 = HEAP8[$20>>0]|0; //@line 76381 "c/sqlite3.c"
 $22 = $21&255; //@line 76381 "c/sqlite3.c"
 $23 = $22 << 24; //@line 76381 "c/sqlite3.c"
 $24 = ((($0)) + 5|0); //@line 76381 "c/sqlite3.c"
 $25 = HEAP8[$24>>0]|0; //@line 76381 "c/sqlite3.c"
 $26 = $25&255; //@line 76381 "c/sqlite3.c"
 $27 = $26 << 16; //@line 76381 "c/sqlite3.c"
 $28 = $27 | $23; //@line 76381 "c/sqlite3.c"
 $29 = ((($0)) + 6|0); //@line 76381 "c/sqlite3.c"
 $30 = HEAP8[$29>>0]|0; //@line 76381 "c/sqlite3.c"
 $31 = $30&255; //@line 76381 "c/sqlite3.c"
 $32 = $31 << 8; //@line 76381 "c/sqlite3.c"
 $33 = $28 | $32; //@line 76381 "c/sqlite3.c"
 $34 = ((($0)) + 7|0); //@line 76381 "c/sqlite3.c"
 $35 = HEAP8[$34>>0]|0; //@line 76381 "c/sqlite3.c"
 $36 = $35&255; //@line 76381 "c/sqlite3.c"
 $37 = $33 | $36; //@line 76381 "c/sqlite3.c"
 $38 = ($1|0)==(6); //@line 76383 "c/sqlite3.c"
 $39 = $2;
 $40 = $39;
 HEAP32[$40>>2] = $37;
 $41 = (($39) + 4)|0;
 $42 = $41;
 HEAP32[$42>>2] = $19;
 if ($38) {
  $$sink = 4;
  $47 = ((($2)) + 8|0);
  HEAP16[$47>>1] = $$sink;
  return;
 }
 HEAP32[tempDoublePtr>>2] = $37;HEAP32[tempDoublePtr+4>>2] = $19;$43 = +HEAPF64[tempDoublePtr>>3]; //@line 76407 "c/sqlite3.c"
 $44 = (_sqlite3IsNaN($43)|0); //@line 76407 "c/sqlite3.c"
 $45 = ($44|0)==(0); //@line 76407 "c/sqlite3.c"
 $46 = $45 ? 8 : 1; //@line 76407 "c/sqlite3.c"
 $$sink = $46;
 $47 = ((($2)) + 8|0);
 HEAP16[$47>>1] = $$sink;
 return;
}
function _sqlite3VdbeFindCompare($0) {
 $0 = $0|0;
 var $$011$ph = 0, $$1 = 0, $$sink = 0, $$sink13 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 77347 "c/sqlite3.c"
 $2 = ((($1)) + 8|0); //@line 77347 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 77347 "c/sqlite3.c"
 $4 = ($3&65535)<(14); //@line 77347 "c/sqlite3.c"
 if (!($4)) {
  $$1 = 108;
  return ($$1|0); //@line 77369 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 77348 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 77348 "c/sqlite3.c"
 $7 = ((($6)) + 8|0); //@line 77348 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 77348 "c/sqlite3.c"
 $9 = $8&65535; //@line 77348 "c/sqlite3.c"
 $10 = ((($1)) + 16|0); //@line 77349 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 77349 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 77349 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 77349 "c/sqlite3.c"
 $14 = ((($0)) + 12|0);
 $$sink13 = $13 ? -1 : 1; //@line 77349 "c/sqlite3.c"
 $$sink = $13 ? 1 : -1; //@line 77349 "c/sqlite3.c"
 HEAP8[$14>>0] = $$sink13;
 $15 = ((($0)) + 13|0);
 HEAP8[$15>>0] = $$sink;
 $16 = $9 & 4; //@line 77356 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 77356 "c/sqlite3.c"
 if ($17) {
  $18 = $9 & 25; //@line 77362 "c/sqlite3.c"
  $19 = ($18|0)==(0); //@line 77362 "c/sqlite3.c"
  if (!($19)) {
   $$1 = 108;
   return ($$1|0); //@line 77369 "c/sqlite3.c"
  }
  $20 = ((($1)) + 20|0); //@line 77362 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 77362 "c/sqlite3.c"
  $22 = ($21|0)==(0|0); //@line 77362 "c/sqlite3.c"
  if ($22) {
   $$011$ph = 110;
  } else {
   $$1 = 108;
   return ($$1|0); //@line 77369 "c/sqlite3.c"
  }
 } else {
  $$011$ph = 109;
 }
 $$1 = $$011$ph;
 return ($$1|0); //@line 77369 "c/sqlite3.c"
}
function _moveToRoot($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 68|0); //@line 65422 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 65422 "c/sqlite3.c"
 $3 = ($2<<24>>24)>(-1); //@line 65422 "c/sqlite3.c"
 do {
  if ($3) {
   $4 = ($2<<24>>24)==(0); //@line 65423 "c/sqlite3.c"
   if ($4) {
    label = 16;
   } else {
    $5 = ((($0)) + 116|0); //@line 65424 "c/sqlite3.c"
    $6 = HEAP32[$5>>2]|0; //@line 65424 "c/sqlite3.c"
    _releasePageNotNull($6); //@line 65424 "c/sqlite3.c"
    $7 = HEAP8[$1>>0]|0; //@line 65425 "c/sqlite3.c"
    $8 = (($7) + -1)<<24>>24; //@line 65425 "c/sqlite3.c"
    HEAP8[$1>>0] = $8; //@line 65425 "c/sqlite3.c"
    $9 = ($8<<24>>24)==(0); //@line 65425 "c/sqlite3.c"
    if (!($9)) {
     $11 = $8;
     while(1) {
      $10 = $11 << 24 >> 24; //@line 65426 "c/sqlite3.c"
      $12 = (((($0)) + 120|0) + ($10<<2)|0); //@line 65426 "c/sqlite3.c"
      $13 = HEAP32[$12>>2]|0; //@line 65426 "c/sqlite3.c"
      _releasePageNotNull($13); //@line 65426 "c/sqlite3.c"
      $14 = HEAP8[$1>>0]|0; //@line 65425 "c/sqlite3.c"
      $15 = (($14) + -1)<<24>>24; //@line 65425 "c/sqlite3.c"
      HEAP8[$1>>0] = $15; //@line 65425 "c/sqlite3.c"
      $16 = ($15<<24>>24)==(0); //@line 65425 "c/sqlite3.c"
      if ($16) {
       break;
      } else {
       $11 = $15;
      }
     }
    }
    $17 = ((($0)) + 120|0);
    $18 = HEAP32[$17>>2]|0; //@line 65428 "c/sqlite3.c"
    HEAP32[$5>>2] = $18; //@line 65428 "c/sqlite3.c"
   }
  } else {
   $19 = ((($0)) + 60|0); //@line 65431 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 65431 "c/sqlite3.c"
   $21 = ($20|0)==(0); //@line 65431 "c/sqlite3.c"
   if ($21) {
    HEAP8[$0>>0] = 0; //@line 65432 "c/sqlite3.c"
    $$1 = 16;
    return ($$1|0); //@line 65489 "c/sqlite3.c"
   }
   $22 = HEAP8[$0>>0]|0; //@line 65436 "c/sqlite3.c"
   $23 = ($22&255)>(2); //@line 65436 "c/sqlite3.c"
   do {
    if ($23) {
     $24 = ($22<<24>>24)==(4); //@line 65437 "c/sqlite3.c"
     if (!($24)) {
      _sqlite3BtreeClearCursor($0); //@line 65441 "c/sqlite3.c"
      break;
     }
     $25 = ((($0)) + 64|0); //@line 65439 "c/sqlite3.c"
     $26 = HEAP32[$25>>2]|0; //@line 65439 "c/sqlite3.c"
     $$1 = $26;
     return ($$1|0); //@line 65489 "c/sqlite3.c"
    }
   } while(0);
   $27 = ((($0)) + 8|0); //@line 65443 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 65443 "c/sqlite3.c"
   $29 = ((($28)) + 4|0); //@line 65443 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 65443 "c/sqlite3.c"
   $31 = HEAP32[$19>>2]|0; //@line 65443 "c/sqlite3.c"
   $32 = ((($0)) + 116|0); //@line 65443 "c/sqlite3.c"
   $33 = ((($0)) + 2|0); //@line 65444 "c/sqlite3.c"
   $34 = HEAP8[$33>>0]|0; //@line 65444 "c/sqlite3.c"
   $35 = $34&255; //@line 65444 "c/sqlite3.c"
   $36 = (_getAndInitPage($30,$31,$32,0,$35)|0); //@line 65443 "c/sqlite3.c"
   $37 = ($36|0)==(0); //@line 65445 "c/sqlite3.c"
   if ($37) {
    HEAP8[$1>>0] = 0; //@line 65449 "c/sqlite3.c"
    $38 = HEAP32[$32>>2]|0; //@line 65450 "c/sqlite3.c"
    $39 = ((($38)) + 2|0); //@line 65450 "c/sqlite3.c"
    $40 = HEAP8[$39>>0]|0; //@line 65450 "c/sqlite3.c"
    $41 = ((($0)) + 69|0); //@line 65450 "c/sqlite3.c"
    HEAP8[$41>>0] = $40; //@line 65450 "c/sqlite3.c"
    label = 16;
    break;
   }
   HEAP8[$0>>0] = 0; //@line 65446 "c/sqlite3.c"
   $$1 = $36;
   return ($$1|0); //@line 65489 "c/sqlite3.c"
  }
 } while(0);
 do {
  if ((label|0) == 16) {
   $42 = ((($0)) + 116|0); //@line 65452 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 65452 "c/sqlite3.c"
   $44 = HEAP8[$43>>0]|0; //@line 65466 "c/sqlite3.c"
   $45 = ($44<<24>>24)==(0); //@line 65466 "c/sqlite3.c"
   if (!($45)) {
    $46 = ((($0)) + 112|0); //@line 65466 "c/sqlite3.c"
    $47 = HEAP32[$46>>2]|0; //@line 65466 "c/sqlite3.c"
    $48 = ($47|0)==(0|0); //@line 65466 "c/sqlite3.c"
    $49 = $48&1; //@line 65466 "c/sqlite3.c"
    $50 = ((($43)) + 2|0); //@line 65466 "c/sqlite3.c"
    $51 = HEAP8[$50>>0]|0; //@line 65466 "c/sqlite3.c"
    $52 = $51&255; //@line 65466 "c/sqlite3.c"
    $53 = ($49|0)==($52|0); //@line 65466 "c/sqlite3.c"
    if ($53) {
     break;
    }
   }
   $54 = (_sqlite3CorruptError(65467)|0); //@line 65467 "c/sqlite3.c"
   $$1 = $54;
   return ($$1|0); //@line 65489 "c/sqlite3.c"
  }
 } while(0);
 $55 = ((($0)) + 70|0); //@line 65471 "c/sqlite3.c"
 HEAP16[$55>>1] = 0; //@line 65471 "c/sqlite3.c"
 $56 = ((($0)) + 42|0); //@line 65472 "c/sqlite3.c"
 HEAP16[$56>>1] = 0; //@line 65472 "c/sqlite3.c"
 $57 = ((($0)) + 1|0); //@line 65473 "c/sqlite3.c"
 $58 = HEAP8[$57>>0]|0; //@line 65473 "c/sqlite3.c"
 $59 = $58 & -15; //@line 65473 "c/sqlite3.c"
 HEAP8[$57>>0] = $59; //@line 65473 "c/sqlite3.c"
 $60 = ((($0)) + 116|0); //@line 65475 "c/sqlite3.c"
 $61 = HEAP32[$60>>2]|0; //@line 65475 "c/sqlite3.c"
 $62 = ((($61)) + 22|0); //@line 65476 "c/sqlite3.c"
 $63 = HEAP16[$62>>1]|0; //@line 65476 "c/sqlite3.c"
 $64 = ($63<<16>>16)==(0); //@line 65476 "c/sqlite3.c"
 if (!($64)) {
  HEAP8[$0>>0] = 1; //@line 65477 "c/sqlite3.c"
  $$1 = 0;
  return ($$1|0); //@line 65489 "c/sqlite3.c"
 }
 $65 = ((($61)) + 8|0); //@line 65478 "c/sqlite3.c"
 $66 = HEAP8[$65>>0]|0; //@line 65478 "c/sqlite3.c"
 $67 = ($66<<24>>24)==(0); //@line 65478 "c/sqlite3.c"
 if (!($67)) {
  HEAP8[$0>>0] = 0; //@line 65485 "c/sqlite3.c"
  $$1 = 16;
  return ($$1|0); //@line 65489 "c/sqlite3.c"
 }
 $68 = ((($61)) + 4|0); //@line 65480 "c/sqlite3.c"
 $69 = HEAP32[$68>>2]|0; //@line 65480 "c/sqlite3.c"
 $70 = ($69|0)==(1); //@line 65480 "c/sqlite3.c"
 if ($70) {
  $71 = ((($61)) + 56|0); //@line 65481 "c/sqlite3.c"
  $72 = HEAP32[$71>>2]|0; //@line 65481 "c/sqlite3.c"
  $73 = ((($61)) + 9|0); //@line 65481 "c/sqlite3.c"
  $74 = HEAP8[$73>>0]|0; //@line 65481 "c/sqlite3.c"
  $75 = $74&255; //@line 65481 "c/sqlite3.c"
  $76 = (($75) + 8)|0; //@line 65481 "c/sqlite3.c"
  $77 = (($72) + ($76)|0); //@line 65481 "c/sqlite3.c"
  $78 = (_sqlite3Get4byte($77)|0); //@line 65481 "c/sqlite3.c"
  HEAP8[$0>>0] = 1; //@line 65482 "c/sqlite3.c"
  $79 = (_moveToChild($0,$78)|0); //@line 65483 "c/sqlite3.c"
  $$1 = $79;
  return ($$1|0); //@line 65489 "c/sqlite3.c"
 } else {
  $80 = (_sqlite3CorruptError(65480)|0); //@line 65480 "c/sqlite3.c"
  $$1 = $80;
  return ($$1|0); //@line 65489 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbeRecordCompareString($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$1 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($1)) + 1|0); //@line 77282 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 77282 "c/sqlite3.c"
 $6 = ($5<<24>>24)>(-1); //@line 77282 "c/sqlite3.c"
 if ($6) {
  $7 = $5&255; //@line 77282 "c/sqlite3.c"
  HEAP32[$3>>2] = $7; //@line 77282 "c/sqlite3.c"
  $9 = $7;
 } else {
  (_sqlite3GetVarint32($4,$3)|0); //@line 77282 "c/sqlite3.c"
  $$pr = HEAP32[$3>>2]|0; //@line 77283 "c/sqlite3.c"
  $9 = $$pr;
 }
 $8 = ($9|0)<(12); //@line 77283 "c/sqlite3.c"
 if ($8) {
  $10 = ((($2)) + 12|0); //@line 77284 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 77284 "c/sqlite3.c"
  $12 = $11 << 24 >> 24; //@line 77284 "c/sqlite3.c"
  $$1 = $12;
  STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
 }
 $13 = $9 & 1; //@line 77285 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 77285 "c/sqlite3.c"
 if ($14) {
  $15 = ((($2)) + 13|0); //@line 77286 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 77286 "c/sqlite3.c"
  $17 = $16 << 24 >> 24; //@line 77286 "c/sqlite3.c"
  $$1 = $17;
  STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
 }
 $18 = HEAP8[$1>>0]|0; //@line 77290 "c/sqlite3.c"
 $19 = $18&255; //@line 77290 "c/sqlite3.c"
 $20 = (($9) + -12)|0; //@line 77292 "c/sqlite3.c"
 $21 = (($20|0) / 2)&-1; //@line 77292 "c/sqlite3.c"
 $22 = (($21) + ($19))|0; //@line 77293 "c/sqlite3.c"
 $23 = ($22|0)>($0|0); //@line 77293 "c/sqlite3.c"
 if ($23) {
  $58 = (_sqlite3CorruptError(77294)|0); //@line 77294 "c/sqlite3.c"
  $59 = $58&255; //@line 77294 "c/sqlite3.c"
  $60 = ((($2)) + 11|0); //@line 77294 "c/sqlite3.c"
  HEAP8[$60>>0] = $59; //@line 77294 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
 }
 $24 = ((($2)) + 4|0); //@line 77297 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 77297 "c/sqlite3.c"
 $26 = ((($25)) + 12|0); //@line 77297 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 77297 "c/sqlite3.c"
 $28 = ($21|0)>($27|0); //@line 77297 "c/sqlite3.c"
 $$ = $28 ? $27 : $21; //@line 77297 "c/sqlite3.c"
 $29 = (($1) + ($19)|0); //@line 77298 "c/sqlite3.c"
 $30 = ((($25)) + 16|0); //@line 77298 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 77298 "c/sqlite3.c"
 $32 = (_memcmp($29,$31,$$)|0); //@line 77298 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 77300 "c/sqlite3.c"
 if (!($33)) {
  $51 = ($32|0)>(0); //@line 77314 "c/sqlite3.c"
  if ($51) {
   $52 = ((($2)) + 13|0); //@line 77315 "c/sqlite3.c"
   $53 = HEAP8[$52>>0]|0; //@line 77315 "c/sqlite3.c"
   $54 = $53 << 24 >> 24; //@line 77315 "c/sqlite3.c"
   $$1 = $54;
   STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
  } else {
   $55 = ((($2)) + 12|0); //@line 77317 "c/sqlite3.c"
   $56 = HEAP8[$55>>0]|0; //@line 77317 "c/sqlite3.c"
   $57 = $56 << 24 >> 24; //@line 77317 "c/sqlite3.c"
   $$1 = $57;
   STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
  }
 }
 $34 = (($21) - ($27))|0; //@line 77301 "c/sqlite3.c"
 $35 = ($34|0)==(0); //@line 77302 "c/sqlite3.c"
 if ($35) {
  $36 = ((($2)) + 8|0); //@line 77303 "c/sqlite3.c"
  $37 = HEAP16[$36>>1]|0; //@line 77303 "c/sqlite3.c"
  $38 = ($37&65535)>(1); //@line 77303 "c/sqlite3.c"
  if ($38) {
   $39 = (_sqlite3VdbeRecordCompareWithSkip($0,$1,$2,1)|0); //@line 77304 "c/sqlite3.c"
   $$1 = $39;
   STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
  } else {
   $40 = ((($2)) + 10|0); //@line 77306 "c/sqlite3.c"
   $41 = HEAP8[$40>>0]|0; //@line 77306 "c/sqlite3.c"
   $42 = $41 << 24 >> 24; //@line 77306 "c/sqlite3.c"
   $43 = ((($2)) + 14|0); //@line 77307 "c/sqlite3.c"
   HEAP8[$43>>0] = 1; //@line 77307 "c/sqlite3.c"
   $$1 = $42;
   STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
  }
 } else {
  $44 = ($34|0)>(0); //@line 77309 "c/sqlite3.c"
  if ($44) {
   $45 = ((($2)) + 13|0); //@line 77310 "c/sqlite3.c"
   $46 = HEAP8[$45>>0]|0; //@line 77310 "c/sqlite3.c"
   $47 = $46 << 24 >> 24; //@line 77310 "c/sqlite3.c"
   $$1 = $47;
   STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
  } else {
   $48 = ((($2)) + 12|0); //@line 77312 "c/sqlite3.c"
   $49 = HEAP8[$48>>0]|0; //@line 77312 "c/sqlite3.c"
   $50 = $49 << 24 >> 24; //@line 77312 "c/sqlite3.c"
   $$1 = $50;
   STACKTOP = sp;return ($$1|0); //@line 77326 "c/sqlite3.c"
  }
 }
 return (0)|0;
}
function _vdbeRecordCompareInt($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$063 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0;
 var $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0;
 var $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP8[$1>>0]|0; //@line 77182 "c/sqlite3.c"
 $4 = $3 & 63; //@line 77182 "c/sqlite3.c"
 $5 = $4&255; //@line 77182 "c/sqlite3.c"
 $6 = (($1) + ($5)|0); //@line 77182 "c/sqlite3.c"
 $7 = ((($1)) + 1|0); //@line 77183 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 77183 "c/sqlite3.c"
 switch ($8<<24>>24) {
 case 1:  {
  $9 = HEAP8[$6>>0]|0; //@line 77194 "c/sqlite3.c"
  $10 = $9 << 24 >> 24; //@line 77194 "c/sqlite3.c"
  $11 = ($10|0)<(0); //@line 77194 "c/sqlite3.c"
  $12 = $11 << 31 >> 31; //@line 77194 "c/sqlite3.c"
  $127 = $12;$129 = $10;
  break;
 }
 case 2:  {
  $13 = HEAP8[$6>>0]|0; //@line 77199 "c/sqlite3.c"
  $14 = $13 << 24 >> 24; //@line 77199 "c/sqlite3.c"
  $15 = $14 << 8; //@line 77199 "c/sqlite3.c"
  $16 = ((($6)) + 1|0); //@line 77199 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 77199 "c/sqlite3.c"
  $18 = $17&255; //@line 77199 "c/sqlite3.c"
  $19 = $15 | $18; //@line 77199 "c/sqlite3.c"
  $20 = ($19|0)<(0); //@line 77199 "c/sqlite3.c"
  $21 = $20 << 31 >> 31; //@line 77199 "c/sqlite3.c"
  $127 = $21;$129 = $19;
  break;
 }
 case 3:  {
  $22 = HEAP8[$6>>0]|0; //@line 77204 "c/sqlite3.c"
  $23 = $22 << 24 >> 24; //@line 77204 "c/sqlite3.c"
  $24 = $23 << 16; //@line 77204 "c/sqlite3.c"
  $25 = ((($6)) + 1|0); //@line 77204 "c/sqlite3.c"
  $26 = HEAP8[$25>>0]|0; //@line 77204 "c/sqlite3.c"
  $27 = $26&255; //@line 77204 "c/sqlite3.c"
  $28 = $27 << 8; //@line 77204 "c/sqlite3.c"
  $29 = $28 | $24; //@line 77204 "c/sqlite3.c"
  $30 = ((($6)) + 2|0); //@line 77204 "c/sqlite3.c"
  $31 = HEAP8[$30>>0]|0; //@line 77204 "c/sqlite3.c"
  $32 = $31&255; //@line 77204 "c/sqlite3.c"
  $33 = $29 | $32; //@line 77204 "c/sqlite3.c"
  $34 = ($33|0)<(0); //@line 77204 "c/sqlite3.c"
  $35 = $34 << 31 >> 31; //@line 77204 "c/sqlite3.c"
  $127 = $35;$129 = $33;
  break;
 }
 case 4:  {
  $36 = HEAP8[$6>>0]|0; //@line 77209 "c/sqlite3.c"
  $37 = $36&255; //@line 77209 "c/sqlite3.c"
  $38 = $37 << 24; //@line 77209 "c/sqlite3.c"
  $39 = ((($6)) + 1|0); //@line 77209 "c/sqlite3.c"
  $40 = HEAP8[$39>>0]|0; //@line 77209 "c/sqlite3.c"
  $41 = $40&255; //@line 77209 "c/sqlite3.c"
  $42 = $41 << 16; //@line 77209 "c/sqlite3.c"
  $43 = $42 | $38; //@line 77209 "c/sqlite3.c"
  $44 = ((($6)) + 2|0); //@line 77209 "c/sqlite3.c"
  $45 = HEAP8[$44>>0]|0; //@line 77209 "c/sqlite3.c"
  $46 = $45&255; //@line 77209 "c/sqlite3.c"
  $47 = $46 << 8; //@line 77209 "c/sqlite3.c"
  $48 = $43 | $47; //@line 77209 "c/sqlite3.c"
  $49 = ((($6)) + 3|0); //@line 77209 "c/sqlite3.c"
  $50 = HEAP8[$49>>0]|0; //@line 77209 "c/sqlite3.c"
  $51 = $50&255; //@line 77209 "c/sqlite3.c"
  $52 = $48 | $51; //@line 77209 "c/sqlite3.c"
  $53 = ($52|0)<(0); //@line 77210 "c/sqlite3.c"
  $54 = $53 << 31 >> 31; //@line 77210 "c/sqlite3.c"
  $127 = $54;$129 = $52;
  break;
 }
 case 5:  {
  $55 = ((($6)) + 2|0); //@line 77215 "c/sqlite3.c"
  $56 = HEAP8[$55>>0]|0; //@line 77215 "c/sqlite3.c"
  $57 = $56&255; //@line 77215 "c/sqlite3.c"
  $58 = $57 << 24; //@line 77215 "c/sqlite3.c"
  $59 = ((($55)) + 1|0); //@line 77215 "c/sqlite3.c"
  $60 = HEAP8[$59>>0]|0; //@line 77215 "c/sqlite3.c"
  $61 = $60&255; //@line 77215 "c/sqlite3.c"
  $62 = $61 << 16; //@line 77215 "c/sqlite3.c"
  $63 = $62 | $58; //@line 77215 "c/sqlite3.c"
  $64 = ((($55)) + 2|0); //@line 77215 "c/sqlite3.c"
  $65 = HEAP8[$64>>0]|0; //@line 77215 "c/sqlite3.c"
  $66 = $65&255; //@line 77215 "c/sqlite3.c"
  $67 = $66 << 8; //@line 77215 "c/sqlite3.c"
  $68 = $63 | $67; //@line 77215 "c/sqlite3.c"
  $69 = ((($55)) + 3|0); //@line 77215 "c/sqlite3.c"
  $70 = HEAP8[$69>>0]|0; //@line 77215 "c/sqlite3.c"
  $71 = $70&255; //@line 77215 "c/sqlite3.c"
  $72 = $68 | $71; //@line 77215 "c/sqlite3.c"
  $73 = HEAP8[$6>>0]|0; //@line 77215 "c/sqlite3.c"
  $74 = $73 << 24 >> 24; //@line 77215 "c/sqlite3.c"
  $75 = $74 << 8; //@line 77215 "c/sqlite3.c"
  $76 = ((($6)) + 1|0); //@line 77215 "c/sqlite3.c"
  $77 = HEAP8[$76>>0]|0; //@line 77215 "c/sqlite3.c"
  $78 = $77&255; //@line 77215 "c/sqlite3.c"
  $79 = $75 | $78; //@line 77215 "c/sqlite3.c"
  $80 = ($79|0)<(0); //@line 77215 "c/sqlite3.c"
  $80 << 31 >> 31; //@line 77215 "c/sqlite3.c"
  $127 = $79;$129 = $72;
  break;
 }
 case 6:  {
  $81 = HEAP8[$6>>0]|0; //@line 77220 "c/sqlite3.c"
  $82 = $81&255; //@line 77220 "c/sqlite3.c"
  $83 = $82 << 24; //@line 77220 "c/sqlite3.c"
  $84 = ((($6)) + 1|0); //@line 77220 "c/sqlite3.c"
  $85 = HEAP8[$84>>0]|0; //@line 77220 "c/sqlite3.c"
  $86 = $85&255; //@line 77220 "c/sqlite3.c"
  $87 = $86 << 16; //@line 77220 "c/sqlite3.c"
  $88 = $87 | $83; //@line 77220 "c/sqlite3.c"
  $89 = ((($6)) + 2|0); //@line 77220 "c/sqlite3.c"
  $90 = HEAP8[$89>>0]|0; //@line 77220 "c/sqlite3.c"
  $91 = $90&255; //@line 77220 "c/sqlite3.c"
  $92 = $91 << 8; //@line 77220 "c/sqlite3.c"
  $93 = $88 | $92; //@line 77220 "c/sqlite3.c"
  $94 = ((($6)) + 3|0); //@line 77220 "c/sqlite3.c"
  $95 = HEAP8[$94>>0]|0; //@line 77220 "c/sqlite3.c"
  $96 = $95&255; //@line 77220 "c/sqlite3.c"
  $97 = $93 | $96; //@line 77220 "c/sqlite3.c"
  $98 = ((($6)) + 4|0); //@line 77221 "c/sqlite3.c"
  $99 = HEAP8[$98>>0]|0; //@line 77221 "c/sqlite3.c"
  $100 = $99&255; //@line 77221 "c/sqlite3.c"
  $101 = $100 << 24; //@line 77221 "c/sqlite3.c"
  $102 = ((($98)) + 1|0); //@line 77221 "c/sqlite3.c"
  $103 = HEAP8[$102>>0]|0; //@line 77221 "c/sqlite3.c"
  $104 = $103&255; //@line 77221 "c/sqlite3.c"
  $105 = $104 << 16; //@line 77221 "c/sqlite3.c"
  $106 = $105 | $101; //@line 77221 "c/sqlite3.c"
  $107 = ((($98)) + 2|0); //@line 77221 "c/sqlite3.c"
  $108 = HEAP8[$107>>0]|0; //@line 77221 "c/sqlite3.c"
  $109 = $108&255; //@line 77221 "c/sqlite3.c"
  $110 = $109 << 8; //@line 77221 "c/sqlite3.c"
  $111 = $106 | $110; //@line 77221 "c/sqlite3.c"
  $112 = ((($98)) + 3|0); //@line 77221 "c/sqlite3.c"
  $113 = HEAP8[$112>>0]|0; //@line 77221 "c/sqlite3.c"
  $114 = $113&255; //@line 77221 "c/sqlite3.c"
  $115 = $111 | $114; //@line 77221 "c/sqlite3.c"
  $127 = $97;$129 = $115;
  break;
 }
 case 8:  {
  $127 = 0;$129 = 0;
  break;
 }
 case 9:  {
  $127 = 0;$129 = 1;
  break;
 }
 case 7: case 0:  {
  $116 = (_sqlite3VdbeRecordCompare($0,$1,$2)|0); //@line 77240 "c/sqlite3.c"
  $$063 = $116;
  return ($$063|0); //@line 77264 "c/sqlite3.c"
  break;
 }
 default: {
  $117 = (_sqlite3VdbeRecordCompare($0,$1,$2)|0); //@line 77243 "c/sqlite3.c"
  $$063 = $117;
  return ($$063|0); //@line 77264 "c/sqlite3.c"
 }
 }
 $118 = ((($2)) + 4|0); //@line 77246 "c/sqlite3.c"
 $119 = HEAP32[$118>>2]|0; //@line 77246 "c/sqlite3.c"
 $120 = $119; //@line 77246 "c/sqlite3.c"
 $121 = $120; //@line 77246 "c/sqlite3.c"
 $122 = HEAP32[$121>>2]|0; //@line 77246 "c/sqlite3.c"
 $123 = (($120) + 4)|0; //@line 77246 "c/sqlite3.c"
 $124 = $123; //@line 77246 "c/sqlite3.c"
 $125 = HEAP32[$124>>2]|0; //@line 77246 "c/sqlite3.c"
 $126 = ($125|0)>($127|0); //@line 77247 "c/sqlite3.c"
 $128 = ($122>>>0)>($129>>>0); //@line 77247 "c/sqlite3.c"
 $130 = ($125|0)==($127|0); //@line 77247 "c/sqlite3.c"
 $131 = $130 & $128; //@line 77247 "c/sqlite3.c"
 $132 = $126 | $131; //@line 77247 "c/sqlite3.c"
 if ($132) {
  $133 = ((($2)) + 12|0); //@line 77248 "c/sqlite3.c"
  $134 = HEAP8[$133>>0]|0; //@line 77248 "c/sqlite3.c"
  $135 = $134 << 24 >> 24; //@line 77248 "c/sqlite3.c"
  $$063 = $135;
  return ($$063|0); //@line 77264 "c/sqlite3.c"
 }
 $136 = ($125|0)<($127|0); //@line 77249 "c/sqlite3.c"
 $137 = ($122>>>0)<($129>>>0); //@line 77249 "c/sqlite3.c"
 $138 = ($125|0)==($127|0); //@line 77249 "c/sqlite3.c"
 $139 = $138 & $137; //@line 77249 "c/sqlite3.c"
 $140 = $136 | $139; //@line 77249 "c/sqlite3.c"
 if ($140) {
  $141 = ((($2)) + 13|0); //@line 77250 "c/sqlite3.c"
  $142 = HEAP8[$141>>0]|0; //@line 77250 "c/sqlite3.c"
  $143 = $142 << 24 >> 24; //@line 77250 "c/sqlite3.c"
  $$063 = $143;
  return ($$063|0); //@line 77264 "c/sqlite3.c"
 }
 $144 = ((($2)) + 8|0); //@line 77251 "c/sqlite3.c"
 $145 = HEAP16[$144>>1]|0; //@line 77251 "c/sqlite3.c"
 $146 = ($145&65535)>(1); //@line 77251 "c/sqlite3.c"
 if ($146) {
  $147 = (_sqlite3VdbeRecordCompareWithSkip($0,$1,$2,1)|0); //@line 77254 "c/sqlite3.c"
  $$063 = $147;
  return ($$063|0); //@line 77264 "c/sqlite3.c"
 } else {
  $148 = ((($2)) + 10|0); //@line 77258 "c/sqlite3.c"
  $149 = HEAP8[$148>>0]|0; //@line 77258 "c/sqlite3.c"
  $150 = $149 << 24 >> 24; //@line 77258 "c/sqlite3.c"
  $151 = ((($2)) + 14|0); //@line 77259 "c/sqlite3.c"
  HEAP8[$151>>0] = 1; //@line 77259 "c/sqlite3.c"
  $$063 = $150;
  return ($$063|0); //@line 77264 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeRecordCompare($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeRecordCompareWithSkip($0,$1,$2,0)|0); //@line 77165 "c/sqlite3.c"
 return ($3|0); //@line 77165 "c/sqlite3.c"
}
function _sqlite3VdbeRecordCompareWithSkip($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$ = 0, $$0129 = 0, $$0132 = 0, $$0135 = 0, $$0145 = 0, $$1130 = 0, $$1133 = 0, $$1136 = 0, $$1146 = 0, $$149 = 0, $$4 = 0, $$6 = 0, $$6155 = 0, $$8$ph = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0.0, $103 = 0;
 var $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0;
 var $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0;
 var $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0;
 var $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0;
 var $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0;
 var $195 = 0, $196 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0.0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0.0, $93 = 0.0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond151 = 0, $spec$select = 0, $spec$select150 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp + 44|0;
 $5 = sp;
 $6 = sp + 40|0;
 $7 = ((($2)) + 4|0); //@line 76985 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 76985 "c/sqlite3.c"
 $9 = HEAP32[$2>>2]|0; //@line 76986 "c/sqlite3.c"
 $10 = ($3|0)==(0); //@line 76993 "c/sqlite3.c"
 do {
  if ($10) {
   $25 = HEAP8[$1>>0]|0; //@line 77001 "c/sqlite3.c"
   $26 = ($25<<24>>24)>(-1); //@line 77001 "c/sqlite3.c"
   if ($26) {
    $27 = $25&255; //@line 77001 "c/sqlite3.c"
    HEAP32[$4>>2] = $27; //@line 77001 "c/sqlite3.c"
    $35 = 1;
   } else {
    $28 = (_sqlite3GetVarint32($1,$4)|0); //@line 77001 "c/sqlite3.c"
    $35 = $28;
   }
   $29 = HEAP32[$4>>2]|0; //@line 77002 "c/sqlite3.c"
   $30 = ($29>>>0)>($0>>>0); //@line 77003 "c/sqlite3.c"
   if (!($30)) {
    $34 = $35&255; //@line 77001 "c/sqlite3.c"
    $$0129 = $29;$$0132 = 0;$$0135 = $34;$$0145 = $8;
    break;
   }
   $31 = (_sqlite3CorruptError(77004)|0); //@line 77004 "c/sqlite3.c"
   $32 = $31&255; //@line 77004 "c/sqlite3.c"
   $33 = ((($2)) + 11|0); //@line 77004 "c/sqlite3.c"
   HEAP8[$33>>0] = $32; //@line 77004 "c/sqlite3.c"
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 77160 "c/sqlite3.c"
  } else {
   $11 = ((($1)) + 1|0); //@line 76995 "c/sqlite3.c"
   $12 = HEAP8[$11>>0]|0; //@line 76995 "c/sqlite3.c"
   $13 = ($12<<24>>24)>(-1); //@line 76995 "c/sqlite3.c"
   if ($13) {
    $14 = $12&255; //@line 76995 "c/sqlite3.c"
    HEAP32[$6>>2] = $14; //@line 76995 "c/sqlite3.c"
    $17 = 1;
   } else {
    $15 = (_sqlite3GetVarint32($11,$6)|0); //@line 76995 "c/sqlite3.c"
    $17 = $15;
   }
   $16 = $17&255; //@line 76995 "c/sqlite3.c"
   $18 = (($16) + 1)|0; //@line 76995 "c/sqlite3.c"
   $19 = HEAP8[$1>>0]|0; //@line 76996 "c/sqlite3.c"
   $20 = $19&255; //@line 76996 "c/sqlite3.c"
   HEAP32[$4>>2] = $20; //@line 76996 "c/sqlite3.c"
   $21 = HEAP32[$6>>2]|0; //@line 76997 "c/sqlite3.c"
   $22 = (_sqlite3VdbeSerialTypeLen($21)|0); //@line 76997 "c/sqlite3.c"
   $23 = (($22) + ($20))|0; //@line 76997 "c/sqlite3.c"
   $24 = ((($8)) + 40|0); //@line 76999 "c/sqlite3.c"
   $$0129 = $23;$$0132 = 1;$$0135 = $18;$$0145 = $24;
  }
 } while(0);
 $36 = ((($2)) + 8|0);
 $37 = ((($5)) + 12|0);
 $38 = ((($9)) + 4|0);
 $39 = ((($5)) + 10|0);
 $40 = ((($9)) + 12|0);
 $41 = ((($5)) + 32|0);
 $42 = ((($5)) + 8|0);
 $43 = ((($5)) + 16|0);
 $44 = ((($2)) + 11|0);
 $$1130 = $$0129;$$1133 = $$0132;$$1136 = $$0135;$$1146 = $$0145;
 L17: while(1) {
  $45 = ((($$1146)) + 8|0); //@line 77020 "c/sqlite3.c"
  $46 = HEAP16[$45>>1]|0; //@line 77020 "c/sqlite3.c"
  $47 = $46&65535; //@line 77020 "c/sqlite3.c"
  $48 = $47 & 4; //@line 77020 "c/sqlite3.c"
  $49 = ($48|0)==(0); //@line 77020 "c/sqlite3.c"
  L19: do {
   if ($49) {
    $83 = $47 & 8; //@line 77042 "c/sqlite3.c"
    $84 = ($83|0)==(0); //@line 77042 "c/sqlite3.c"
    if (!($84)) {
     $85 = (($1) + ($$1136)|0); //@line 77043 "c/sqlite3.c"
     $86 = HEAP8[$85>>0]|0; //@line 77043 "c/sqlite3.c"
     $87 = $86&255; //@line 77043 "c/sqlite3.c"
     HEAP32[$6>>2] = $87; //@line 77043 "c/sqlite3.c"
     $88 = ($86&255)>(9); //@line 77044 "c/sqlite3.c"
     if ($88) {
      $$6155 = 1;
      label = 49;
      break L17;
     }
     $89 = ($86<<24>>24)==(0); //@line 77050 "c/sqlite3.c"
     if ($89) {
      $$6155 = -1;
      label = 49;
      break L17;
     }
     $90 = (($1) + ($$1130)|0); //@line 77053 "c/sqlite3.c"
     (_sqlite3VdbeSerialGet($90,$87,$5)|0); //@line 77053 "c/sqlite3.c"
     $91 = ($86<<24>>24)==(7); //@line 77054 "c/sqlite3.c"
     if (!($91)) {
      $96 = $5; //@line 77061 "c/sqlite3.c"
      $97 = $96; //@line 77061 "c/sqlite3.c"
      $98 = HEAP32[$97>>2]|0; //@line 77061 "c/sqlite3.c"
      $99 = (($96) + 4)|0; //@line 77061 "c/sqlite3.c"
      $100 = $99; //@line 77061 "c/sqlite3.c"
      $101 = HEAP32[$100>>2]|0; //@line 77061 "c/sqlite3.c"
      $102 = +HEAPF64[$$1146>>3]; //@line 77061 "c/sqlite3.c"
      $103 = (_sqlite3IntFloatCompare($98,$101,$102)|0); //@line 77061 "c/sqlite3.c"
      $$6 = $103;
      label = 48;
      break;
     }
     $92 = +HEAPF64[$5>>3]; //@line 77055 "c/sqlite3.c"
     $93 = +HEAPF64[$$1146>>3]; //@line 77055 "c/sqlite3.c"
     $94 = $92 < $93; //@line 77055 "c/sqlite3.c"
     if ($94) {
      $$6155 = -1;
      label = 49;
      break L17;
     }
     $95 = $92 > $93; //@line 77057 "c/sqlite3.c"
     if ($95) {
      $$6155 = 1;
      label = 49;
      break L17;
     } else {
      break;
     }
    }
    $104 = $47 & 2; //@line 77067 "c/sqlite3.c"
    $105 = ($104|0)==(0); //@line 77067 "c/sqlite3.c"
    if (!($105)) {
     $106 = (($1) + ($$1136)|0); //@line 77068 "c/sqlite3.c"
     $107 = HEAP8[$106>>0]|0; //@line 77068 "c/sqlite3.c"
     $108 = ($107<<24>>24)>(-1); //@line 77068 "c/sqlite3.c"
     if ($108) {
      $109 = $107&255; //@line 77068 "c/sqlite3.c"
      HEAP32[$6>>2] = $109; //@line 77068 "c/sqlite3.c"
      $111 = $109;
     } else {
      (_sqlite3GetVarint32($106,$6)|0); //@line 77068 "c/sqlite3.c"
      $$pr = HEAP32[$6>>2]|0; //@line 77070 "c/sqlite3.c"
      $111 = $$pr;
     }
     $110 = ($111>>>0)<(12); //@line 77070 "c/sqlite3.c"
     if ($110) {
      $$6155 = -1;
      label = 49;
      break L17;
     }
     $112 = $111 & 1; //@line 77072 "c/sqlite3.c"
     $113 = ($112|0)==(0); //@line 77072 "c/sqlite3.c"
     if ($113) {
      $$6155 = 1;
      label = 49;
      break L17;
     }
     $114 = (($111) + -12)|0; //@line 77075 "c/sqlite3.c"
     $115 = $114 >>> 1; //@line 77075 "c/sqlite3.c"
     HEAP32[$37>>2] = $115; //@line 77075 "c/sqlite3.c"
     $116 = (($115) + ($$1130))|0; //@line 77078 "c/sqlite3.c"
     $117 = ($116>>>0)>($0>>>0); //@line 77078 "c/sqlite3.c"
     if ($117) {
      label = 32;
      break L17;
     }
     $121 = (((($9)) + 20|0) + ($$1133<<2)|0); //@line 77081 "c/sqlite3.c"
     $122 = HEAP32[$121>>2]|0; //@line 77081 "c/sqlite3.c"
     $123 = ($122|0)==(0|0); //@line 77081 "c/sqlite3.c"
     if ($123) {
      $128 = ((($$1146)) + 12|0); //@line 77090 "c/sqlite3.c"
      $129 = HEAP32[$128>>2]|0; //@line 77090 "c/sqlite3.c"
      $130 = ($115|0)<($129|0); //@line 77090 "c/sqlite3.c"
      $$ = $130 ? $115 : $129; //@line 77090 "c/sqlite3.c"
      $131 = (($1) + ($$1130)|0); //@line 77091 "c/sqlite3.c"
      $132 = ((($$1146)) + 16|0); //@line 77091 "c/sqlite3.c"
      $133 = HEAP32[$132>>2]|0; //@line 77091 "c/sqlite3.c"
      $134 = (_memcmp($131,$133,$$)|0); //@line 77091 "c/sqlite3.c"
      $135 = ($134|0)==(0); //@line 77092 "c/sqlite3.c"
      $136 = (($115) - ($129))|0; //@line 77092 "c/sqlite3.c"
      if ($135) {
       $$6 = $136;
       label = 48;
       break;
      } else {
       $$6155 = $134;
       label = 49;
       break L17;
      }
     } else {
      $124 = HEAP8[$38>>0]|0; //@line 77082 "c/sqlite3.c"
      HEAP8[$39>>0] = $124; //@line 77082 "c/sqlite3.c"
      $125 = HEAP32[$40>>2]|0; //@line 77083 "c/sqlite3.c"
      HEAP32[$41>>2] = $125; //@line 77083 "c/sqlite3.c"
      HEAP16[$42>>1] = 2; //@line 77084 "c/sqlite3.c"
      $126 = (($1) + ($$1130)|0); //@line 77085 "c/sqlite3.c"
      HEAP32[$43>>2] = $126; //@line 77085 "c/sqlite3.c"
      $127 = (_vdbeCompareMemString($5,$$1146,$122,$44)|0); //@line 77086 "c/sqlite3.c"
      $$6 = $127;
      label = 48;
      break;
     }
    }
    $137 = $47 & 16; //@line 77098 "c/sqlite3.c"
    $138 = ($137|0)==(0); //@line 77098 "c/sqlite3.c"
    $139 = (($1) + ($$1136)|0);
    $140 = HEAP8[$139>>0]|0;
    $141 = $140&255;
    if ($138) {
     HEAP32[$6>>2] = $141; //@line 77127 "c/sqlite3.c"
     $171 = ($140<<24>>24)!=(0); //@line 77128 "c/sqlite3.c"
     $172 = $171&1; //@line 77128 "c/sqlite3.c"
     $$6 = $172;
     label = 48;
     break;
    }
    $142 = ($140<<24>>24)>(-1); //@line 77100 "c/sqlite3.c"
    if ($142) {
     HEAP32[$6>>2] = $141; //@line 77100 "c/sqlite3.c"
    } else {
     (_sqlite3GetVarint32($139,$6)|0); //@line 77100 "c/sqlite3.c"
    }
    $143 = HEAP32[$6>>2]|0; //@line 77102 "c/sqlite3.c"
    $144 = ($143>>>0)>(11); //@line 77102 "c/sqlite3.c"
    $145 = $143 & 1; //@line 77102 "c/sqlite3.c"
    $146 = ($145|0)==(0); //@line 77102 "c/sqlite3.c"
    $or$cond = $144 & $146; //@line 77102 "c/sqlite3.c"
    if (!($or$cond)) {
     $$6155 = -1;
     label = 49;
     break L17;
    }
    $147 = (($143) + -12)|0; //@line 77105 "c/sqlite3.c"
    $148 = $147 >>> 1; //@line 77105 "c/sqlite3.c"
    $149 = (($148) + ($$1130))|0; //@line 77108 "c/sqlite3.c"
    $150 = ($149>>>0)>($0>>>0); //@line 77108 "c/sqlite3.c"
    if ($150) {
     label = 46;
     break L17;
    }
    $151 = HEAP16[$45>>1]|0; //@line 77111 "c/sqlite3.c"
    $152 = $151 & 16384; //@line 77111 "c/sqlite3.c"
    $153 = ($152<<16>>16)==(0); //@line 77111 "c/sqlite3.c"
    if ($153) {
     $159 = ((($$1146)) + 12|0); //@line 77118 "c/sqlite3.c"
     $160 = HEAP32[$159>>2]|0; //@line 77118 "c/sqlite3.c"
     $161 = ($148|0)<($160|0); //@line 77118 "c/sqlite3.c"
     $$149 = $161 ? $148 : $160; //@line 77118 "c/sqlite3.c"
     $162 = (($1) + ($$1130)|0); //@line 77119 "c/sqlite3.c"
     $163 = ((($$1146)) + 16|0); //@line 77119 "c/sqlite3.c"
     $164 = HEAP32[$163>>2]|0; //@line 77119 "c/sqlite3.c"
     $165 = (_memcmp($162,$164,$$149)|0); //@line 77119 "c/sqlite3.c"
     $166 = ($165|0)==(0); //@line 77120 "c/sqlite3.c"
     $167 = (($148) - ($160))|0; //@line 77120 "c/sqlite3.c"
     if ($166) {
      $$6 = $167;
      label = 48;
      break;
     } else {
      $$6155 = $165;
      label = 49;
      break L17;
     }
    }
    $154 = (($1) + ($$1130)|0); //@line 77112 "c/sqlite3.c"
    $155 = (_isAllZero($154,$148)|0); //@line 77112 "c/sqlite3.c"
    $156 = ($155|0)==(0); //@line 77112 "c/sqlite3.c"
    if ($156) {
     $$6155 = 1;
     label = 49;
     break L17;
    }
    $157 = HEAP32[$$1146>>2]|0; //@line 77115 "c/sqlite3.c"
    $158 = (($148) - ($157))|0; //@line 77115 "c/sqlite3.c"
    $$6 = $158;
    label = 48;
   } else {
    $50 = (($1) + ($$1136)|0); //@line 77021 "c/sqlite3.c"
    $51 = HEAP8[$50>>0]|0; //@line 77021 "c/sqlite3.c"
    $52 = $51&255; //@line 77021 "c/sqlite3.c"
    HEAP32[$6>>2] = $52; //@line 77021 "c/sqlite3.c"
    $53 = ($51&255)>(9); //@line 77023 "c/sqlite3.c"
    if ($53) {
     $$6155 = 1;
     label = 49;
     break L17;
    }
    switch ($51<<24>>24) {
    case 0:  {
     $$6155 = -1;
     label = 49;
     break L17;
     break;
    }
    case 7:  {
     $54 = (($1) + ($$1130)|0); //@line 77028 "c/sqlite3.c"
     (_sqlite3VdbeSerialGet($54,$52,$5)|0); //@line 77028 "c/sqlite3.c"
     $55 = $$1146; //@line 77029 "c/sqlite3.c"
     $56 = $55; //@line 77029 "c/sqlite3.c"
     $57 = HEAP32[$56>>2]|0; //@line 77029 "c/sqlite3.c"
     $58 = (($55) + 4)|0; //@line 77029 "c/sqlite3.c"
     $59 = $58; //@line 77029 "c/sqlite3.c"
     $60 = HEAP32[$59>>2]|0; //@line 77029 "c/sqlite3.c"
     $61 = +HEAPF64[$5>>3]; //@line 77029 "c/sqlite3.c"
     $62 = (_sqlite3IntFloatCompare($57,$60,$61)|0); //@line 77029 "c/sqlite3.c"
     $63 = (0 - ($62))|0; //@line 77029 "c/sqlite3.c"
     $$6 = $63;
     label = 48;
     break L19;
     break;
    }
    default: {
     $64 = (($1) + ($$1130)|0); //@line 77031 "c/sqlite3.c"
     $65 = (_vdbeRecordDecodeInt($52,$64)|0); //@line 77031 "c/sqlite3.c"
     $66 = tempRet0; //@line 77031 "c/sqlite3.c"
     $67 = $$1146; //@line 77032 "c/sqlite3.c"
     $68 = $67; //@line 77032 "c/sqlite3.c"
     $69 = HEAP32[$68>>2]|0; //@line 77032 "c/sqlite3.c"
     $70 = (($67) + 4)|0; //@line 77032 "c/sqlite3.c"
     $71 = $70; //@line 77032 "c/sqlite3.c"
     $72 = HEAP32[$71>>2]|0; //@line 77032 "c/sqlite3.c"
     $73 = ($66|0)<($72|0); //@line 77033 "c/sqlite3.c"
     $74 = ($65>>>0)<($69>>>0); //@line 77033 "c/sqlite3.c"
     $75 = ($66|0)==($72|0); //@line 77033 "c/sqlite3.c"
     $76 = $75 & $74; //@line 77033 "c/sqlite3.c"
     $77 = $73 | $76; //@line 77033 "c/sqlite3.c"
     $78 = ($66|0)>($72|0); //@line 77035 "c/sqlite3.c"
     $79 = ($65>>>0)>($69>>>0); //@line 77035 "c/sqlite3.c"
     $80 = ($66|0)==($72|0); //@line 77035 "c/sqlite3.c"
     $81 = $80 & $79; //@line 77035 "c/sqlite3.c"
     $82 = $78 | $81; //@line 77035 "c/sqlite3.c"
     $spec$select = $82&1; //@line 77035 "c/sqlite3.c"
     if ($77) {
      $$6155 = -1;
      label = 49;
      break L17;
     } else {
      $$6 = $spec$select;
      label = 48;
      break L19;
     }
    }
    }
   }
  } while(0);
  if ((label|0) == 48) {
   label = 0;
   $173 = ($$6|0)==(0); //@line 77131 "c/sqlite3.c"
   if (!($173)) {
    $$6155 = $$6;
    label = 49;
    break;
   }
  }
  $180 = (($$1133) + 1)|0; //@line 77140 "c/sqlite3.c"
  $181 = HEAP32[$6>>2]|0; //@line 77142 "c/sqlite3.c"
  $182 = (_sqlite3VdbeSerialTypeLen($181)|0); //@line 77142 "c/sqlite3.c"
  $183 = (($182) + ($$1130))|0; //@line 77142 "c/sqlite3.c"
  $184 = (_sqlite3VarintLen($181,0)|0); //@line 77143 "c/sqlite3.c"
  $185 = (($184) + ($$1136))|0; //@line 77143 "c/sqlite3.c"
  $186 = HEAP32[$4>>2]|0; //@line 77144 "c/sqlite3.c"
  $187 = ($185>>>0)<($186>>>0); //@line 77144 "c/sqlite3.c"
  if (!($187)) {
   label = 53;
   break;
  }
  $188 = ((($$1146)) + 40|0); //@line 77141 "c/sqlite3.c"
  $189 = HEAP16[$36>>1]|0; //@line 77144 "c/sqlite3.c"
  $190 = $189&65535; //@line 77144 "c/sqlite3.c"
  $191 = ($180>>>0)>=($190>>>0); //@line 77144 "c/sqlite3.c"
  $192 = ($183>>>0)>($0>>>0); //@line 77144 "c/sqlite3.c"
  $or$cond151 = $192 | $191; //@line 77144 "c/sqlite3.c"
  if ($or$cond151) {
   label = 53;
   break;
  } else {
   $$1130 = $183;$$1133 = $180;$$1136 = $185;$$1146 = $188;
  }
 }
 if ((label|0) == 32) {
  $118 = (_sqlite3CorruptError(77079)|0); //@line 77079 "c/sqlite3.c"
  $119 = $118&255; //@line 77079 "c/sqlite3.c"
  $120 = ((($2)) + 11|0); //@line 77079 "c/sqlite3.c"
  HEAP8[$120>>0] = $119; //@line 77079 "c/sqlite3.c"
  $$8$ph = 0;
 }
 else if ((label|0) == 46) {
  $168 = (_sqlite3CorruptError(77109)|0); //@line 77109 "c/sqlite3.c"
  $169 = $168&255; //@line 77109 "c/sqlite3.c"
  $170 = ((($2)) + 11|0); //@line 77109 "c/sqlite3.c"
  HEAP8[$170>>0] = $169; //@line 77109 "c/sqlite3.c"
  $$8$ph = 0;
 }
 else if ((label|0) == 49) {
  $174 = ((($9)) + 16|0); //@line 77132 "c/sqlite3.c"
  $175 = HEAP32[$174>>2]|0; //@line 77132 "c/sqlite3.c"
  $176 = (($175) + ($$1133)|0); //@line 77132 "c/sqlite3.c"
  $177 = HEAP8[$176>>0]|0; //@line 77132 "c/sqlite3.c"
  $178 = ($177<<24>>24)==(0); //@line 77132 "c/sqlite3.c"
  $179 = (0 - ($$6155))|0; //@line 77133 "c/sqlite3.c"
  $spec$select150 = $178 ? $$6155 : $179; //@line 77132 "c/sqlite3.c"
  $$8$ph = $spec$select150;
 }
 else if ((label|0) == 53) {
  $193 = ((($2)) + 14|0); //@line 77158 "c/sqlite3.c"
  HEAP8[$193>>0] = 1; //@line 77158 "c/sqlite3.c"
  $194 = ((($2)) + 10|0); //@line 77159 "c/sqlite3.c"
  $195 = HEAP8[$194>>0]|0; //@line 77159 "c/sqlite3.c"
  $196 = $195 << 24 >> 24; //@line 77159 "c/sqlite3.c"
  $$4 = $196;
  STACKTOP = sp;return ($$4|0); //@line 77160 "c/sqlite3.c"
 }
 $$4 = $$8$ph;
 STACKTOP = sp;return ($$4|0); //@line 77160 "c/sqlite3.c"
}
function _sqlite3VdbeSerialTypeLen($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0>>>0)>(127); //@line 76242 "c/sqlite3.c"
 if ($1) {
  $2 = (($0) + -12)|0; //@line 76243 "c/sqlite3.c"
  $3 = $2 >>> 1; //@line 76243 "c/sqlite3.c"
  $$0 = $3;
  return ($$0|0); //@line 76249 "c/sqlite3.c"
 } else {
  $4 = (27860 + ($0)|0); //@line 76247 "c/sqlite3.c"
  $5 = HEAP8[$4>>0]|0; //@line 76247 "c/sqlite3.c"
  $6 = $5&255; //@line 76247 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 76249 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbeRecordDecodeInt($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0;
 var $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 switch ($0|0) {
 case 1: case 0:  {
  $2 = HEAP8[$1>>0]|0; //@line 76927 "c/sqlite3.c"
  $3 = $2 << 24 >> 24; //@line 76927 "c/sqlite3.c"
  $4 = ($3|0)<(0); //@line 76927 "c/sqlite3.c"
  $5 = $4 << 31 >> 31; //@line 76927 "c/sqlite3.c"
  $110 = $5;$111 = $3;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
  break;
 }
 case 2:  {
  $6 = HEAP8[$1>>0]|0; //@line 76930 "c/sqlite3.c"
  $7 = $6 << 24 >> 24; //@line 76930 "c/sqlite3.c"
  $8 = $7 << 8; //@line 76930 "c/sqlite3.c"
  $9 = ((($1)) + 1|0); //@line 76930 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 76930 "c/sqlite3.c"
  $11 = $10&255; //@line 76930 "c/sqlite3.c"
  $12 = $8 | $11; //@line 76930 "c/sqlite3.c"
  $13 = ($12|0)<(0); //@line 76930 "c/sqlite3.c"
  $14 = $13 << 31 >> 31; //@line 76930 "c/sqlite3.c"
  $110 = $14;$111 = $12;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
  break;
 }
 case 3:  {
  $15 = HEAP8[$1>>0]|0; //@line 76933 "c/sqlite3.c"
  $16 = $15 << 24 >> 24; //@line 76933 "c/sqlite3.c"
  $17 = $16 << 16; //@line 76933 "c/sqlite3.c"
  $18 = ((($1)) + 1|0); //@line 76933 "c/sqlite3.c"
  $19 = HEAP8[$18>>0]|0; //@line 76933 "c/sqlite3.c"
  $20 = $19&255; //@line 76933 "c/sqlite3.c"
  $21 = $20 << 8; //@line 76933 "c/sqlite3.c"
  $22 = $21 | $17; //@line 76933 "c/sqlite3.c"
  $23 = ((($1)) + 2|0); //@line 76933 "c/sqlite3.c"
  $24 = HEAP8[$23>>0]|0; //@line 76933 "c/sqlite3.c"
  $25 = $24&255; //@line 76933 "c/sqlite3.c"
  $26 = $22 | $25; //@line 76933 "c/sqlite3.c"
  $27 = ($26|0)<(0); //@line 76933 "c/sqlite3.c"
  $28 = $27 << 31 >> 31; //@line 76933 "c/sqlite3.c"
  $110 = $28;$111 = $26;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
  break;
 }
 case 4:  {
  $29 = HEAP8[$1>>0]|0; //@line 76936 "c/sqlite3.c"
  $30 = $29&255; //@line 76936 "c/sqlite3.c"
  $31 = $30 << 24; //@line 76936 "c/sqlite3.c"
  $32 = ((($1)) + 1|0); //@line 76936 "c/sqlite3.c"
  $33 = HEAP8[$32>>0]|0; //@line 76936 "c/sqlite3.c"
  $34 = $33&255; //@line 76936 "c/sqlite3.c"
  $35 = $34 << 16; //@line 76936 "c/sqlite3.c"
  $36 = $35 | $31; //@line 76936 "c/sqlite3.c"
  $37 = ((($1)) + 2|0); //@line 76936 "c/sqlite3.c"
  $38 = HEAP8[$37>>0]|0; //@line 76936 "c/sqlite3.c"
  $39 = $38&255; //@line 76936 "c/sqlite3.c"
  $40 = $39 << 8; //@line 76936 "c/sqlite3.c"
  $41 = $36 | $40; //@line 76936 "c/sqlite3.c"
  $42 = ((($1)) + 3|0); //@line 76936 "c/sqlite3.c"
  $43 = HEAP8[$42>>0]|0; //@line 76936 "c/sqlite3.c"
  $44 = $43&255; //@line 76936 "c/sqlite3.c"
  $45 = $41 | $44; //@line 76936 "c/sqlite3.c"
  $46 = ($45|0)<(0); //@line 76937 "c/sqlite3.c"
  $47 = $46 << 31 >> 31; //@line 76937 "c/sqlite3.c"
  $110 = $47;$111 = $45;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
  break;
 }
 case 5:  {
  $48 = ((($1)) + 2|0); //@line 76941 "c/sqlite3.c"
  $49 = HEAP8[$48>>0]|0; //@line 76941 "c/sqlite3.c"
  $50 = $49&255; //@line 76941 "c/sqlite3.c"
  $51 = $50 << 24; //@line 76941 "c/sqlite3.c"
  $52 = ((($1)) + 3|0); //@line 76941 "c/sqlite3.c"
  $53 = HEAP8[$52>>0]|0; //@line 76941 "c/sqlite3.c"
  $54 = $53&255; //@line 76941 "c/sqlite3.c"
  $55 = $54 << 16; //@line 76941 "c/sqlite3.c"
  $56 = $55 | $51; //@line 76941 "c/sqlite3.c"
  $57 = ((($1)) + 4|0); //@line 76941 "c/sqlite3.c"
  $58 = HEAP8[$57>>0]|0; //@line 76941 "c/sqlite3.c"
  $59 = $58&255; //@line 76941 "c/sqlite3.c"
  $60 = $59 << 8; //@line 76941 "c/sqlite3.c"
  $61 = $56 | $60; //@line 76941 "c/sqlite3.c"
  $62 = ((($1)) + 5|0); //@line 76941 "c/sqlite3.c"
  $63 = HEAP8[$62>>0]|0; //@line 76941 "c/sqlite3.c"
  $64 = $63&255; //@line 76941 "c/sqlite3.c"
  $65 = $61 | $64; //@line 76941 "c/sqlite3.c"
  $66 = HEAP8[$1>>0]|0; //@line 76941 "c/sqlite3.c"
  $67 = $66 << 24 >> 24; //@line 76941 "c/sqlite3.c"
  $68 = $67 << 8; //@line 76941 "c/sqlite3.c"
  $69 = ((($1)) + 1|0); //@line 76941 "c/sqlite3.c"
  $70 = HEAP8[$69>>0]|0; //@line 76941 "c/sqlite3.c"
  $71 = $70&255; //@line 76941 "c/sqlite3.c"
  $72 = $68 | $71; //@line 76941 "c/sqlite3.c"
  $73 = ($72|0)<(0); //@line 76941 "c/sqlite3.c"
  $73 << 31 >> 31; //@line 76941 "c/sqlite3.c"
  $110 = $72;$111 = $65;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
  break;
 }
 case 6:  {
  $74 = HEAP8[$1>>0]|0; //@line 76944 "c/sqlite3.c"
  $75 = $74&255; //@line 76944 "c/sqlite3.c"
  $76 = $75 << 24; //@line 76944 "c/sqlite3.c"
  $77 = ((($1)) + 1|0); //@line 76944 "c/sqlite3.c"
  $78 = HEAP8[$77>>0]|0; //@line 76944 "c/sqlite3.c"
  $79 = $78&255; //@line 76944 "c/sqlite3.c"
  $80 = $79 << 16; //@line 76944 "c/sqlite3.c"
  $81 = $80 | $76; //@line 76944 "c/sqlite3.c"
  $82 = ((($1)) + 2|0); //@line 76944 "c/sqlite3.c"
  $83 = HEAP8[$82>>0]|0; //@line 76944 "c/sqlite3.c"
  $84 = $83&255; //@line 76944 "c/sqlite3.c"
  $85 = $84 << 8; //@line 76944 "c/sqlite3.c"
  $86 = $81 | $85; //@line 76944 "c/sqlite3.c"
  $87 = ((($1)) + 3|0); //@line 76944 "c/sqlite3.c"
  $88 = HEAP8[$87>>0]|0; //@line 76944 "c/sqlite3.c"
  $89 = $88&255; //@line 76944 "c/sqlite3.c"
  $90 = $86 | $89; //@line 76944 "c/sqlite3.c"
  $91 = ((($1)) + 4|0); //@line 76946 "c/sqlite3.c"
  $92 = HEAP8[$91>>0]|0; //@line 76946 "c/sqlite3.c"
  $93 = $92&255; //@line 76946 "c/sqlite3.c"
  $94 = $93 << 24; //@line 76946 "c/sqlite3.c"
  $95 = ((($1)) + 5|0); //@line 76946 "c/sqlite3.c"
  $96 = HEAP8[$95>>0]|0; //@line 76946 "c/sqlite3.c"
  $97 = $96&255; //@line 76946 "c/sqlite3.c"
  $98 = $97 << 16; //@line 76946 "c/sqlite3.c"
  $99 = $98 | $94; //@line 76946 "c/sqlite3.c"
  $100 = ((($1)) + 6|0); //@line 76946 "c/sqlite3.c"
  $101 = HEAP8[$100>>0]|0; //@line 76946 "c/sqlite3.c"
  $102 = $101&255; //@line 76946 "c/sqlite3.c"
  $103 = $102 << 8; //@line 76946 "c/sqlite3.c"
  $104 = $99 | $103; //@line 76946 "c/sqlite3.c"
  $105 = ((($1)) + 7|0); //@line 76946 "c/sqlite3.c"
  $106 = HEAP8[$105>>0]|0; //@line 76946 "c/sqlite3.c"
  $107 = $106&255; //@line 76946 "c/sqlite3.c"
  $108 = $104 | $107; //@line 76946 "c/sqlite3.c"
  $110 = $90;$111 = $108;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
  break;
 }
 default: {
  $109 = (($0) + -8)|0; //@line 76951 "c/sqlite3.c"
  $110 = 0;$111 = $109;
  tempRet0 = ($110); //@line 76952 "c/sqlite3.c"
  return ($111|0); //@line 76952 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3VarintLen($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0 = 1;$2 = $0;$3 = $1;
 while(1) {
  $4 = (_bitshift64Lshr(($2|0),($3|0),7)|0); //@line 29640 "c/sqlite3.c"
  $5 = tempRet0; //@line 29640 "c/sqlite3.c"
  $6 = ($4|0)==(0); //@line 29640 "c/sqlite3.c"
  $7 = ($5|0)==(0); //@line 29640 "c/sqlite3.c"
  $8 = $6 & $7; //@line 29640 "c/sqlite3.c"
  $9 = (($$0) + 1)|0; //@line 29640 "c/sqlite3.c"
  if ($8) {
   break;
  } else {
   $$0 = $9;$2 = $4;$3 = $5;
  }
 }
 return ($$0|0); //@line 29641 "c/sqlite3.c"
}
function _btreeNext($0) {
 $0 = $0|0;
 var $$0 = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 65946 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(1); //@line 65946 "c/sqlite3.c"
 if (!($2)) {
  $3 = ($1&255)>(2); //@line 65948 "c/sqlite3.c"
  do {
   if ($3) {
    $4 = (_btreeRestoreCursorPosition($0)|0); //@line 65948 "c/sqlite3.c"
    $5 = ($4|0)==(0); //@line 65949 "c/sqlite3.c"
    if ($5) {
     $$pr = HEAP8[$0>>0]|0; //@line 65952 "c/sqlite3.c"
     $7 = $$pr;
     break;
    } else {
     $$0 = $4;
     return ($$0|0); //@line 66002 "c/sqlite3.c"
    }
   } else {
    $7 = $1;
   }
  } while(0);
  $6 = ($7<<24>>24)==(0); //@line 65952 "c/sqlite3.c"
  if ($6) {
   $$0 = 101;
   return ($$0|0); //@line 66002 "c/sqlite3.c"
  }
  $8 = ((($0)) + 64|0); //@line 65955 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 65955 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 65955 "c/sqlite3.c"
  if (!($10)) {
   HEAP8[$0>>0] = 1; //@line 65957 "c/sqlite3.c"
   $11 = ($9|0)>(0); //@line 65958 "c/sqlite3.c"
   HEAP32[$8>>2] = 0;
   if ($11) {
    $$0 = 0;
    return ($$0|0); //@line 66002 "c/sqlite3.c"
   }
  }
 }
 $12 = ((($0)) + 116|0); //@line 65966 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 65966 "c/sqlite3.c"
 $14 = ((($0)) + 70|0); //@line 65967 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 65967 "c/sqlite3.c"
 $16 = (($15) + 1)<<16>>16; //@line 65967 "c/sqlite3.c"
 HEAP16[$14>>1] = $16; //@line 65967 "c/sqlite3.c"
 $17 = ((($13)) + 22|0); //@line 65977 "c/sqlite3.c"
 $18 = HEAP16[$17>>1]|0; //@line 65977 "c/sqlite3.c"
 $19 = ($16&65535)<($18&65535); //@line 65977 "c/sqlite3.c"
 $20 = ((($13)) + 8|0);
 $21 = HEAP8[$20>>0]|0;
 $22 = ($21<<24>>24)!=(0);
 if ($19) {
  if ($22) {
   $$0 = 0;
   return ($$0|0); //@line 66002 "c/sqlite3.c"
  }
  $46 = (_moveToLeftmost($0)|0); //@line 66000 "c/sqlite3.c"
  $$0 = $46;
  return ($$0|0); //@line 66002 "c/sqlite3.c"
 }
 if (!($22)) {
  $23 = ((($13)) + 56|0); //@line 65979 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 65979 "c/sqlite3.c"
  $25 = ((($13)) + 9|0); //@line 65979 "c/sqlite3.c"
  $26 = HEAP8[$25>>0]|0; //@line 65979 "c/sqlite3.c"
  $27 = $26&255; //@line 65979 "c/sqlite3.c"
  $28 = (($27) + 8)|0; //@line 65979 "c/sqlite3.c"
  $29 = (($24) + ($28)|0); //@line 65979 "c/sqlite3.c"
  $30 = (_sqlite3Get4byte($29)|0); //@line 65979 "c/sqlite3.c"
  $31 = (_moveToChild($0,$30)|0); //@line 65979 "c/sqlite3.c"
  $32 = ($31|0)==(0); //@line 65980 "c/sqlite3.c"
  if (!($32)) {
   $$0 = $31;
   return ($$0|0); //@line 66002 "c/sqlite3.c"
  }
  $33 = (_moveToLeftmost($0)|0); //@line 65981 "c/sqlite3.c"
  $$0 = $33;
  return ($$0|0); //@line 66002 "c/sqlite3.c"
 }
 $34 = ((($0)) + 68|0);
 while(1) {
  $35 = HEAP8[$34>>0]|0; //@line 65984 "c/sqlite3.c"
  $36 = ($35<<24>>24)==(0); //@line 65984 "c/sqlite3.c"
  if ($36) {
   label = 14;
   break;
  }
  _moveToParent($0); //@line 65988 "c/sqlite3.c"
  $37 = HEAP32[$12>>2]|0; //@line 65989 "c/sqlite3.c"
  $38 = HEAP16[$14>>1]|0; //@line 65990 "c/sqlite3.c"
  $39 = ((($37)) + 22|0); //@line 65990 "c/sqlite3.c"
  $40 = HEAP16[$39>>1]|0; //@line 65990 "c/sqlite3.c"
  $41 = ($38&65535)<($40&65535); //@line 65990 "c/sqlite3.c"
  if ($41) {
   break;
  }
 }
 if ((label|0) == 14) {
  HEAP8[$0>>0] = 0; //@line 65985 "c/sqlite3.c"
  $$0 = 101;
  return ($$0|0); //@line 66002 "c/sqlite3.c"
 }
 $42 = ((($37)) + 2|0); //@line 65991 "c/sqlite3.c"
 $43 = HEAP8[$42>>0]|0; //@line 65991 "c/sqlite3.c"
 $44 = ($43<<24>>24)==(0); //@line 65991 "c/sqlite3.c"
 if ($44) {
  $$0 = 0;
  return ($$0|0); //@line 66002 "c/sqlite3.c"
 }
 $45 = (_sqlite3BtreeNext($0,0)|0); //@line 65992 "c/sqlite3.c"
 $$0 = $45;
 return ($$0|0); //@line 66002 "c/sqlite3.c"
}
function _moveToLeftmost($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 116|0); //@line 65505 "c/sqlite3.c"
 $2 = ((($0)) + 70|0);
 while(1) {
  $3 = HEAP32[$1>>2]|0; //@line 65505 "c/sqlite3.c"
  $4 = ((($3)) + 8|0); //@line 65505 "c/sqlite3.c"
  $5 = HEAP8[$4>>0]|0; //@line 65505 "c/sqlite3.c"
  $6 = ($5<<24>>24)==(0); //@line 65505 "c/sqlite3.c"
  if (!($6)) {
   $$0$lcssa = 0;
   label = 4;
   break;
  }
  $7 = ((($3)) + 56|0); //@line 65507 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 65507 "c/sqlite3.c"
  $9 = ((($3)) + 24|0); //@line 65507 "c/sqlite3.c"
  $10 = HEAP16[$9>>1]|0; //@line 65507 "c/sqlite3.c"
  $11 = $10&65535; //@line 65507 "c/sqlite3.c"
  $12 = ((($3)) + 64|0); //@line 65507 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 65507 "c/sqlite3.c"
  $14 = HEAP16[$2>>1]|0; //@line 65507 "c/sqlite3.c"
  $15 = $14&65535; //@line 65507 "c/sqlite3.c"
  $16 = $15 << 1; //@line 65507 "c/sqlite3.c"
  $17 = (($13) + ($16)|0); //@line 65507 "c/sqlite3.c"
  $18 = HEAP8[$17>>0]|0; //@line 65507 "c/sqlite3.c"
  $19 = $18&255; //@line 65507 "c/sqlite3.c"
  $20 = $19 << 8; //@line 65507 "c/sqlite3.c"
  $21 = ((($17)) + 1|0); //@line 65507 "c/sqlite3.c"
  $22 = HEAP8[$21>>0]|0; //@line 65507 "c/sqlite3.c"
  $23 = $22&255; //@line 65507 "c/sqlite3.c"
  $24 = $20 | $23; //@line 65507 "c/sqlite3.c"
  $25 = $24 & $11; //@line 65507 "c/sqlite3.c"
  $26 = (($8) + ($25)|0); //@line 65507 "c/sqlite3.c"
  $27 = (_sqlite3Get4byte($26)|0); //@line 65507 "c/sqlite3.c"
  $28 = (_moveToChild($0,$27)|0); //@line 65508 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 65505 "c/sqlite3.c"
  if (!($29)) {
   $$0$lcssa = $28;
   label = 4;
   break;
  }
 }
 if ((label|0) == 4) {
  return ($$0$lcssa|0); //@line 65510 "c/sqlite3.c"
 }
 return (0)|0;
}
function _targetSrcList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 125621 "c/sqlite3.c"
 $3 = (_sqlite3SrcListAppend($2,0,0,0)|0); //@line 125625 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 125626 "c/sqlite3.c"
 if ($4) {
  return ($3|0); //@line 125637 "c/sqlite3.c"
 }
 $5 = ((($1)) + 12|0); //@line 125628 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 125628 "c/sqlite3.c"
 $7 = (_sqlite3DbStrDup($2,$6)|0); //@line 125628 "c/sqlite3.c"
 $8 = HEAP32[$3>>2]|0; //@line 125628 "c/sqlite3.c"
 $9 = (($8) + -1)|0; //@line 125628 "c/sqlite3.c"
 $10 = (((((($3)) + 8|0) + (($9*72)|0)|0)) + 8|0); //@line 125628 "c/sqlite3.c"
 HEAP32[$10>>2] = $7; //@line 125628 "c/sqlite3.c"
 $11 = ((($1)) + 4|0); //@line 125629 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 125629 "c/sqlite3.c"
 $13 = ((($12)) + 20|0); //@line 125629 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 125629 "c/sqlite3.c"
 $15 = (_sqlite3SchemaToIndex($2,$14)|0); //@line 125629 "c/sqlite3.c"
 $16 = ($15|0)==(0); //@line 125630 "c/sqlite3.c"
 $17 = ($15|0)>(1); //@line 125630 "c/sqlite3.c"
 $or$cond = $16 | $17; //@line 125630 "c/sqlite3.c"
 if (!($or$cond)) {
  return ($3|0); //@line 125637 "c/sqlite3.c"
 }
 $18 = ((($2)) + 16|0); //@line 125633 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 125633 "c/sqlite3.c"
 $20 = (($19) + ($15<<4)|0); //@line 125633 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 125633 "c/sqlite3.c"
 $22 = (_sqlite3DbStrDup($2,$21)|0); //@line 125634 "c/sqlite3.c"
 $23 = HEAP32[$3>>2]|0; //@line 125634 "c/sqlite3.c"
 $24 = (($23) + -1)|0; //@line 125634 "c/sqlite3.c"
 $25 = (((((($3)) + 8|0) + (($24*72)|0)|0)) + 4|0); //@line 125634 "c/sqlite3.c"
 HEAP32[$25>>2] = $22; //@line 125634 "c/sqlite3.c"
 return ($3|0); //@line 125637 "c/sqlite3.c"
}
function _checkColumnOverlap($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$010 = 0, $$011 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 125568 "c/sqlite3.c"
 $3 = ($1|0)==(0|0); //@line 125568 "c/sqlite3.c"
 $or$cond = $2 | $3; //@line 125568 "c/sqlite3.c"
 L1: do {
  if ($or$cond) {
   $$010 = 1;
  } else {
   $4 = HEAP32[$1>>2]|0; //@line 125569 "c/sqlite3.c"
   $5 = ($4|0)>(0); //@line 125569 "c/sqlite3.c"
   if ($5) {
    $$011 = 0;
    while(1) {
     $9 = (((((($1)) + 4|0) + (($$011*20)|0)|0)) + 4|0); //@line 125570 "c/sqlite3.c"
     $10 = HEAP32[$9>>2]|0; //@line 125570 "c/sqlite3.c"
     $11 = (_sqlite3IdListIndex($0,$10)|0); //@line 125570 "c/sqlite3.c"
     $12 = ($11|0)>(-1); //@line 125570 "c/sqlite3.c"
     $8 = (($$011) + 1)|0; //@line 125569 "c/sqlite3.c"
     if ($12) {
      $$010 = 1;
      break L1;
     }
     $6 = HEAP32[$1>>2]|0; //@line 125569 "c/sqlite3.c"
     $7 = ($8|0)<($6|0); //@line 125569 "c/sqlite3.c"
     if ($7) {
      $$011 = $8;
     } else {
      $$010 = 0;
      break;
     }
    }
   } else {
    $$010 = 0;
   }
  }
 } while(0);
 return ($$010|0); //@line 125573 "c/sqlite3.c"
}
function _checkConstraintExprNode($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$1>>0]|0; //@line 111936 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(-111); //@line 111936 "c/sqlite3.c"
 if (!($3)) {
  return 0; //@line 111946 "c/sqlite3.c"
 }
 $4 = ((($1)) + 32|0); //@line 111938 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 111938 "c/sqlite3.c"
 $6 = ($5<<16>>16)>(-1); //@line 111938 "c/sqlite3.c"
 if (!($6)) {
  $16 = ((($0)) + 20|0); //@line 111943 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 111943 "c/sqlite3.c"
  $18 = $17 | 2; //@line 111943 "c/sqlite3.c"
  HEAP8[$16>>0] = $18; //@line 111943 "c/sqlite3.c"
  return 0; //@line 111946 "c/sqlite3.c"
 }
 $7 = $5 << 16 >> 16; //@line 111938 "c/sqlite3.c"
 $8 = ((($0)) + 24|0); //@line 111939 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 111939 "c/sqlite3.c"
 $10 = (($9) + ($7<<2)|0); //@line 111939 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 111939 "c/sqlite3.c"
 $12 = ($11|0)>(-1); //@line 111939 "c/sqlite3.c"
 if (!($12)) {
  return 0; //@line 111946 "c/sqlite3.c"
 }
 $13 = ((($0)) + 20|0); //@line 111940 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 111940 "c/sqlite3.c"
 $15 = $14 | 1; //@line 111940 "c/sqlite3.c"
 HEAP8[$13>>0] = $15; //@line 111940 "c/sqlite3.c"
 return 0; //@line 111946 "c/sqlite3.c"
}
function _xferCompatibleIndex($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$027 = 0, $$028 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 50|0); //@line 112727 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 112727 "c/sqlite3.c"
 $4 = ((($1)) + 50|0); //@line 112727 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 112727 "c/sqlite3.c"
 $6 = ($3<<16>>16)==($5<<16>>16); //@line 112727 "c/sqlite3.c"
 if (!($6)) {
  $$027 = 0;
  return ($$027|0); //@line 112757 "c/sqlite3.c"
 }
 $7 = ((($0)) + 54|0); //@line 112730 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 112730 "c/sqlite3.c"
 $9 = ((($1)) + 54|0); //@line 112730 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 112730 "c/sqlite3.c"
 $11 = ($8<<24>>24)==($10<<24>>24); //@line 112730 "c/sqlite3.c"
 if (!($11)) {
  $$027 = 0;
  return ($$027|0); //@line 112757 "c/sqlite3.c"
 }
 $12 = HEAP16[$4>>1]|0; //@line 112733 "c/sqlite3.c"
 $13 = ($12<<16>>16)==(0); //@line 112733 "c/sqlite3.c"
 L7: do {
  if (!($13)) {
   $14 = ((($1)) + 4|0);
   $15 = ((($0)) + 4|0);
   $16 = ((($1)) + 40|0);
   $17 = ((($0)) + 40|0);
   $18 = ((($1)) + 28|0);
   $19 = ((($0)) + 28|0);
   $20 = ((($1)) + 32|0);
   $21 = ((($0)) + 32|0);
   $$028 = 0;
   while(1) {
    $26 = HEAP32[$14>>2]|0; //@line 112734 "c/sqlite3.c"
    $27 = (($26) + ($$028<<1)|0); //@line 112734 "c/sqlite3.c"
    $28 = HEAP16[$27>>1]|0; //@line 112734 "c/sqlite3.c"
    $29 = HEAP32[$15>>2]|0; //@line 112734 "c/sqlite3.c"
    $30 = (($29) + ($$028<<1)|0); //@line 112734 "c/sqlite3.c"
    $31 = HEAP16[$30>>1]|0; //@line 112734 "c/sqlite3.c"
    $32 = ($28<<16>>16)==($31<<16>>16); //@line 112734 "c/sqlite3.c"
    if (!($32)) {
     $$027 = 0;
     label = 12;
     break;
    }
    $33 = ($28<<16>>16)==(-2); //@line 112737 "c/sqlite3.c"
    if ($33) {
     $34 = HEAP32[$16>>2]|0; //@line 112739 "c/sqlite3.c"
     $35 = (((($34)) + 4|0) + (($$028*20)|0)|0); //@line 112739 "c/sqlite3.c"
     $36 = HEAP32[$35>>2]|0; //@line 112739 "c/sqlite3.c"
     $37 = HEAP32[$17>>2]|0; //@line 112740 "c/sqlite3.c"
     $38 = (((($37)) + 4|0) + (($$028*20)|0)|0); //@line 112740 "c/sqlite3.c"
     $39 = HEAP32[$38>>2]|0; //@line 112740 "c/sqlite3.c"
     $40 = (_sqlite3ExprCompare(0,$36,$39,-1)|0); //@line 112739 "c/sqlite3.c"
     $41 = ($40|0)==(0); //@line 112740 "c/sqlite3.c"
     if (!($41)) {
      $$027 = 0;
      label = 12;
      break;
     }
    }
    $42 = HEAP32[$18>>2]|0; //@line 112744 "c/sqlite3.c"
    $43 = (($42) + ($$028)|0); //@line 112744 "c/sqlite3.c"
    $44 = HEAP8[$43>>0]|0; //@line 112744 "c/sqlite3.c"
    $45 = HEAP32[$19>>2]|0; //@line 112744 "c/sqlite3.c"
    $46 = (($45) + ($$028)|0); //@line 112744 "c/sqlite3.c"
    $47 = HEAP8[$46>>0]|0; //@line 112744 "c/sqlite3.c"
    $48 = ($44<<24>>24)==($47<<24>>24); //@line 112744 "c/sqlite3.c"
    if (!($48)) {
     $$027 = 0;
     label = 12;
     break;
    }
    $49 = HEAP32[$20>>2]|0; //@line 112747 "c/sqlite3.c"
    $50 = (($49) + ($$028<<2)|0); //@line 112747 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 112747 "c/sqlite3.c"
    $52 = HEAP32[$21>>2]|0; //@line 112747 "c/sqlite3.c"
    $53 = (($52) + ($$028<<2)|0); //@line 112747 "c/sqlite3.c"
    $54 = HEAP32[$53>>2]|0; //@line 112747 "c/sqlite3.c"
    $55 = (_sqlite3_stricmp($51,$54)|0); //@line 112747 "c/sqlite3.c"
    $56 = ($55|0)==(0); //@line 112747 "c/sqlite3.c"
    $25 = (($$028) + 1)|0; //@line 112733 "c/sqlite3.c"
    if (!($56)) {
     $$027 = 0;
     label = 12;
     break;
    }
    $22 = HEAP16[$4>>1]|0; //@line 112733 "c/sqlite3.c"
    $23 = $22&65535; //@line 112733 "c/sqlite3.c"
    $24 = ($25>>>0)<($23>>>0); //@line 112733 "c/sqlite3.c"
    if ($24) {
     $$028 = $25;
    } else {
     break L7;
    }
   }
   if ((label|0) == 12) {
    return ($$027|0); //@line 112757 "c/sqlite3.c"
   }
  }
 } while(0);
 $57 = ((($1)) + 36|0); //@line 112751 "c/sqlite3.c"
 $58 = HEAP32[$57>>2]|0; //@line 112751 "c/sqlite3.c"
 $59 = ((($0)) + 36|0); //@line 112751 "c/sqlite3.c"
 $60 = HEAP32[$59>>2]|0; //@line 112751 "c/sqlite3.c"
 $61 = (_sqlite3ExprCompare(0,$58,$60,-1)|0); //@line 112751 "c/sqlite3.c"
 $62 = ($61|0)==(0); //@line 112751 "c/sqlite3.c"
 $$ = $62&1; //@line 112756 "c/sqlite3.c"
 $$027 = $$;
 return ($$027|0); //@line 112757 "c/sqlite3.c"
}
function _sqlite3AuthContextPush($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 4|0); //@line 101599 "c/sqlite3.c"
 HEAP32[$3>>2] = $0; //@line 101599 "c/sqlite3.c"
 $4 = ((($0)) + 440|0); //@line 101600 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 101600 "c/sqlite3.c"
 HEAP32[$1>>2] = $5; //@line 101600 "c/sqlite3.c"
 HEAP32[$4>>2] = $2; //@line 101601 "c/sqlite3.c"
 return; //@line 101602 "c/sqlite3.c"
}
function _sqlite3MaterializeView($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp;
 $5 = HEAP32[$0>>2]|0; //@line 106667 "c/sqlite3.c"
 $6 = ((($1)) + 72|0); //@line 106668 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 106668 "c/sqlite3.c"
 $8 = (_sqlite3SchemaToIndex($5,$7)|0); //@line 106668 "c/sqlite3.c"
 $9 = (_sqlite3ExprDup($5,$2,0)|0); //@line 106669 "c/sqlite3.c"
 $10 = (_sqlite3SrcListAppend($5,0,0,0)|0); //@line 106670 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 106671 "c/sqlite3.c"
 if (!($11)) {
  $12 = HEAP32[$1>>2]|0; //@line 106673 "c/sqlite3.c"
  $13 = (_sqlite3DbStrDup($5,$12)|0); //@line 106673 "c/sqlite3.c"
  $14 = ((($10)) + 16|0); //@line 106673 "c/sqlite3.c"
  HEAP32[$14>>2] = $13; //@line 106673 "c/sqlite3.c"
  $15 = ((($5)) + 16|0); //@line 106674 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 106674 "c/sqlite3.c"
  $17 = (($16) + ($8<<4)|0); //@line 106674 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 106674 "c/sqlite3.c"
  $19 = (_sqlite3DbStrDup($5,$18)|0); //@line 106674 "c/sqlite3.c"
  $20 = ((($10)) + 12|0); //@line 106674 "c/sqlite3.c"
  HEAP32[$20>>2] = $19; //@line 106674 "c/sqlite3.c"
 }
 $21 = (_sqlite3SelectNew($0,0,$10,$9,0,0,0,131072,0)|0); //@line 106678 "c/sqlite3.c"
 _sqlite3SelectDestInit($4,12,$3); //@line 106680 "c/sqlite3.c"
 (_sqlite3Select($0,$21,$4)|0); //@line 106681 "c/sqlite3.c"
 _sqlite3SelectDelete($5,$21); //@line 106682 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 106683 "c/sqlite3.c"
}
function _updateVirtualTable($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0132 = 0, $$0134 = 0, $$1133 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $8 = sp;
 $9 = ((($0)) + 8|0); //@line 126873 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 126873 "c/sqlite3.c"
 $11 = HEAP32[$0>>2]|0; //@line 126876 "c/sqlite3.c"
 $12 = (_sqlite3GetVTable($11,$2)|0); //@line 126877 "c/sqlite3.c"
 $13 = ((($2)) + 42|0); //@line 126879 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 126879 "c/sqlite3.c"
 $15 = $14 << 16 >> 16; //@line 126879 "c/sqlite3.c"
 $16 = (($15) + 2)|0; //@line 126879 "c/sqlite3.c"
 $17 = ((($1)) + 52|0); //@line 126883 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 126883 "c/sqlite3.c"
 $19 = ((($0)) + 40|0); //@line 126892 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 126892 "c/sqlite3.c"
 $21 = (($20) + 1)|0; //@line 126892 "c/sqlite3.c"
 HEAP32[$19>>2] = $21; //@line 126892 "c/sqlite3.c"
 $22 = (_sqlite3VdbeAddOp2($10,109,$20,$16)|0); //@line 126893 "c/sqlite3.c"
 $23 = ((($0)) + 44|0); //@line 126894 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 126894 "c/sqlite3.c"
 $25 = (($24) + 1)|0; //@line 126894 "c/sqlite3.c"
 $26 = (($24) + ($16))|0; //@line 126895 "c/sqlite3.c"
 $27 = (($26) + 1)|0; //@line 126896 "c/sqlite3.c"
 $28 = (($26) + 2)|0; //@line 126897 "c/sqlite3.c"
 HEAP32[$23>>2] = $28; //@line 126897 "c/sqlite3.c"
 $29 = (_sqlite3WhereBegin($0,$1,$6,0,0,4,0)|0); //@line 126900 "c/sqlite3.c"
 $30 = ($29|0)==(0|0); //@line 126901 "c/sqlite3.c"
 if ($30) {
  STACKTOP = sp;return; //@line 126981 "c/sqlite3.c"
 }
 $31 = HEAP16[$13>>1]|0; //@line 126904 "c/sqlite3.c"
 $32 = ($31<<16>>16)>(0); //@line 126904 "c/sqlite3.c"
 if ($32) {
  $33 = (($24) + 3)|0;
  $34 = (($24) + 3)|0;
  $$0134 = 0;
  while(1) {
   $35 = (($5) + ($$0134<<2)|0); //@line 126905 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 126905 "c/sqlite3.c"
   $37 = ($36|0)>(-1); //@line 126905 "c/sqlite3.c"
   if ($37) {
    $38 = (((($3)) + 4|0) + (($36*20)|0)|0); //@line 126906 "c/sqlite3.c"
    $39 = HEAP32[$38>>2]|0; //@line 126906 "c/sqlite3.c"
    $40 = (($33) + ($$0134))|0; //@line 126906 "c/sqlite3.c"
    _sqlite3ExprCode($0,$39,$40); //@line 126906 "c/sqlite3.c"
   } else {
    $41 = (($34) + ($$0134))|0; //@line 126908 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($10,158,$18,$$0134,$41)|0); //@line 126908 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($10,1); //@line 126909 "c/sqlite3.c"
   }
   $42 = (($$0134) + 1)|0; //@line 126904 "c/sqlite3.c"
   $43 = HEAP16[$13>>1]|0; //@line 126904 "c/sqlite3.c"
   $44 = $43 << 16 >> 16; //@line 126904 "c/sqlite3.c"
   $45 = ($42|0)<($44|0); //@line 126904 "c/sqlite3.c"
   if ($45) {
    $$0134 = $42;
   } else {
    break;
   }
  }
 }
 $46 = ((($2)) + 36|0); //@line 126912 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 126912 "c/sqlite3.c"
 $48 = $47 & 32; //@line 126912 "c/sqlite3.c"
 $49 = ($48|0)==(0); //@line 126912 "c/sqlite3.c"
 do {
  if ($49) {
   (_sqlite3VdbeAddOp2($10,124,$18,$25)|0); //@line 126913 "c/sqlite3.c"
   $50 = ($4|0)==(0|0); //@line 126914 "c/sqlite3.c"
   $51 = (($24) + 2)|0;
   if ($50) {
    (_sqlite3VdbeAddOp2($10,124,$18,$51)|0); //@line 126917 "c/sqlite3.c"
    break;
   } else {
    _sqlite3ExprCode($0,$4,$51); //@line 126915 "c/sqlite3.c"
    break;
   }
  } else {
   $52 = (_sqlite3PrimaryKeyIndex($2)|0); //@line 126922 "c/sqlite3.c"
   $53 = ((($52)) + 4|0); //@line 126925 "c/sqlite3.c"
   $54 = HEAP32[$53>>2]|0; //@line 126925 "c/sqlite3.c"
   $55 = HEAP16[$54>>1]|0; //@line 126925 "c/sqlite3.c"
   $56 = $55 << 16 >> 16; //@line 126926 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($10,158,$18,$56,$25)|0); //@line 126926 "c/sqlite3.c"
   $57 = (($24) + 3)|0; //@line 126927 "c/sqlite3.c"
   $58 = (($57) + ($56))|0; //@line 126927 "c/sqlite3.c"
   $59 = (($24) + 2)|0; //@line 126927 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($10,76,$58,$59)|0); //@line 126927 "c/sqlite3.c"
  }
 } while(0);
 $60 = (_sqlite3WhereOkOnePass($29,$8)|0); //@line 126930 "c/sqlite3.c"
 $61 = ($60|0)==(0); //@line 126932 "c/sqlite3.c"
 if ($61) {
  (_sqlite3VdbeAddOp3($10,100,$25,$16,$27)|0); //@line 126943 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($10,116,$20,$28)|0); //@line 126949 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($10,117,$20,$27,$28)|0); //@line 126950 "c/sqlite3.c"
  _sqlite3WhereEnd($29); //@line 126956 "c/sqlite3.c"
  $66 = (_sqlite3VdbeAddOp1($10,37,$20)|0); //@line 126959 "c/sqlite3.c"
  $67 = ($14<<16>>16)>(-2); //@line 126963 "c/sqlite3.c"
  if ($67) {
   $$1133 = 0;
   while(1) {
    $68 = (($$1133) + ($25))|0; //@line 126964 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($10,98,$20,$$1133,$68)|0); //@line 126964 "c/sqlite3.c"
    $69 = (($$1133) + 1)|0; //@line 126963 "c/sqlite3.c"
    $70 = ($69|0)<($16|0); //@line 126963 "c/sqlite3.c"
    if ($70) {
     $$1133 = $69;
    } else {
     $$0132 = $66;
     break;
    }
   }
  } else {
   $$0132 = $66;
  }
 } else {
  (_sqlite3VdbeChangeToNoop($10,$22)|0); //@line 126936 "c/sqlite3.c"
  $62 = ((($0)) + 120|0); //@line 126937 "c/sqlite3.c"
  $63 = HEAP32[$62>>2]|0; //@line 126937 "c/sqlite3.c"
  $64 = ($63|0)==(0|0); //@line 126937 "c/sqlite3.c"
  if ($64) {
   $65 = ((($0)) + 20|0); //@line 126938 "c/sqlite3.c"
   HEAP8[$65>>0] = 0; //@line 126938 "c/sqlite3.c"
   $$0132 = $22;
  } else {
   $$0132 = $22;
  }
 }
 _sqlite3VtabMakeWritable($0,$2); //@line 126967 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($10,12,0,$16,$25,$12,-12)|0); //@line 126968 "c/sqlite3.c"
 $71 = ($7|0)==(10); //@line 126969 "c/sqlite3.c"
 $72 = $7&65535; //@line 126969 "c/sqlite3.c"
 $73 = $71 ? 2 : $72; //@line 126969 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($10,$73); //@line 126969 "c/sqlite3.c"
 _sqlite3MayAbort($0); //@line 126970 "c/sqlite3.c"
 if ($61) {
  $74 = (($$0132) + 1)|0; //@line 126975 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($10,7,$20,$74)|0); //@line 126975 "c/sqlite3.c"
  _sqlite3VdbeJumpHere($10,$$0132); //@line 126976 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($10,113,$20,0)|0); //@line 126977 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126981 "c/sqlite3.c"
 } else {
  _sqlite3WhereEnd($29); //@line 126979 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 126981 "c/sqlite3.c"
 }
}
function _sqlite3WhereOkOnePass($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 133024 "c/sqlite3.c"
 $3 = $2; //@line 133024 "c/sqlite3.c"
 $4 = $3; //@line 133024 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 133024 "c/sqlite3.c"
 $6 = (($3) + 4)|0; //@line 133024 "c/sqlite3.c"
 $7 = $6; //@line 133024 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 133024 "c/sqlite3.c"
 $9 = $1; //@line 133024 "c/sqlite3.c"
 $10 = $9; //@line 133024 "c/sqlite3.c"
 HEAP32[$10>>2] = $5; //@line 133024 "c/sqlite3.c"
 $11 = (($9) + 4)|0; //@line 133024 "c/sqlite3.c"
 $12 = $11; //@line 133024 "c/sqlite3.c"
 HEAP32[$12>>2] = $8; //@line 133024 "c/sqlite3.c"
 $13 = ((($0)) + 49|0); //@line 133032 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 133032 "c/sqlite3.c"
 $15 = $14&255; //@line 133032 "c/sqlite3.c"
 return ($15|0); //@line 133032 "c/sqlite3.c"
}
function _sqlite3AuthContextPop($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 101609 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 101609 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 101609 "c/sqlite3.c"
 if ($3) {
  return; //@line 101613 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 101610 "c/sqlite3.c"
 $5 = ((($2)) + 440|0); //@line 101610 "c/sqlite3.c"
 HEAP32[$5>>2] = $4; //@line 101610 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 101611 "c/sqlite3.c"
 return; //@line 101613 "c/sqlite3.c"
}
function _sqlite3SrcListEnlarge($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$04751 = 0, $$04751$in = 0, $$1 = 0, $$146 = 0, $$14849 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0;
 var stop = 0;
 sp = STACKTOP;
 $4 = HEAP32[$1>>2]|0; //@line 105299 "c/sqlite3.c"
 $5 = (($4) + ($2))|0; //@line 105299 "c/sqlite3.c"
 $6 = ((($1)) + 4|0); //@line 105299 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 105299 "c/sqlite3.c"
 $8 = ($5>>>0)>($7>>>0); //@line 105299 "c/sqlite3.c"
 do {
  if ($8) {
   $9 = $4 << 1; //@line 105301 "c/sqlite3.c"
   $10 = (($9) + ($2))|0; //@line 105301 "c/sqlite3.c"
   $11 = ($10*72)|0; //@line 105304 "c/sqlite3.c"
   $12 = (($11) + 8)|0; //@line 105304 "c/sqlite3.c"
   $13 = (_sqlite3DbRealloc($0,$1,$12,0)|0); //@line 105303 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 105305 "c/sqlite3.c"
   if ($14) {
    $$1 = $1;
    return ($$1|0); //@line 105329 "c/sqlite3.c"
   } else {
    $15 = (_sqlite3DbMallocSize($0,$13)|0); //@line 105310 "c/sqlite3.c"
    $16 = (($15) + -80)|0; //@line 105310 "c/sqlite3.c"
    $17 = (($16>>>0) / 72)&-1; //@line 105310 "c/sqlite3.c"
    $18 = (($17) + 1)|0; //@line 105310 "c/sqlite3.c"
    $19 = ((($13)) + 4|0); //@line 105311 "c/sqlite3.c"
    HEAP32[$19>>2] = $18; //@line 105311 "c/sqlite3.c"
    $$146 = $13;
    break;
   }
  } else {
   $$146 = $1;
  }
 } while(0);
 $20 = HEAP32[$$146>>2]|0; //@line 105316 "c/sqlite3.c"
 $21 = ($20|0)>($3|0); //@line 105316 "c/sqlite3.c"
 if ($21) {
  $$04751$in = $20;
  while(1) {
   $$04751 = (($$04751$in) + -1)|0;
   $22 = (($$04751) + ($2))|0; //@line 105317 "c/sqlite3.c"
   $23 = (((($$146)) + 8|0) + (($22*72)|0)|0); //@line 105317 "c/sqlite3.c"
   $24 = (((($$146)) + 8|0) + (($$04751*72)|0)|0); //@line 105317 "c/sqlite3.c"
   dest=$23; src=$24; stop=dest+72|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 105317 "c/sqlite3.c"
   $25 = ($$04751|0)>($3|0); //@line 105316 "c/sqlite3.c"
   if ($25) {
    $$04751$in = $$04751;
   } else {
    break;
   }
  }
 }
 $26 = HEAP32[$$146>>2]|0; //@line 105319 "c/sqlite3.c"
 $27 = (($26) + ($2))|0; //@line 105319 "c/sqlite3.c"
 HEAP32[$$146>>2] = $27; //@line 105319 "c/sqlite3.c"
 $28 = (((($$146)) + 8|0) + (($3*72)|0)|0); //@line 105322 "c/sqlite3.c"
 $29 = ($2*72)|0; //@line 105322 "c/sqlite3.c"
 _memset(($28|0),0,($29|0))|0; //@line 105322 "c/sqlite3.c"
 $30 = (($3) + ($2))|0; //@line 105323 "c/sqlite3.c"
 $31 = ($2|0)>(0); //@line 105323 "c/sqlite3.c"
 if (!($31)) {
  $$1 = $$146;
  return ($$1|0); //@line 105329 "c/sqlite3.c"
 }
 $$14849 = $3;
 while(1) {
  $32 = (((((($$146)) + 8|0) + (($$14849*72)|0)|0)) + 44|0); //@line 105324 "c/sqlite3.c"
  HEAP32[$32>>2] = -1; //@line 105324 "c/sqlite3.c"
  $33 = (($$14849) + 1)|0; //@line 105323 "c/sqlite3.c"
  $34 = ($33|0)<($30|0); //@line 105323 "c/sqlite3.c"
  if ($34) {
   $$14849 = $33;
  } else {
   $$1 = $$146;
   break;
  }
 }
 return ($$1|0); //@line 105329 "c/sqlite3.c"
}
function _generateColumnNames($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$083 = 0, $$084 = 0, $$08586 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer2 = sp + 8|0; //@line 120262 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 120262 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 120265 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 120265 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 120270 "c/sqlite3.c"
 $5 = ((($0)) + 399|0); //@line 120276 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 120276 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 120276 "c/sqlite3.c"
 if (!($7)) {
  STACKTOP = sp;return; //@line 120329 "c/sqlite3.c"
 }
 $8 = ((($0)) + 16|0); //@line 120281 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 120281 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 120281 "c/sqlite3.c"
 if (!($10)) {
  STACKTOP = sp;return; //@line 120329 "c/sqlite3.c"
 }
 $11 = ((($4)) + 73|0); //@line 120281 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 120281 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(0); //@line 120281 "c/sqlite3.c"
 if (!($13)) {
  STACKTOP = sp;return; //@line 120329 "c/sqlite3.c"
 }
 $$0 = $1;
 while(1) {
  $14 = ((($$0)) + 48|0); //@line 120283 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 120283 "c/sqlite3.c"
  $16 = ($15|0)==(0|0); //@line 120283 "c/sqlite3.c"
  if ($16) {
   break;
  } else {
   $$0 = $15;
  }
 }
 $17 = ((($$0)) + 28|0); //@line 120285 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 120285 "c/sqlite3.c"
 $19 = HEAP32[$$0>>2]|0; //@line 120286 "c/sqlite3.c"
 HEAP8[$8>>0] = 1; //@line 120289 "c/sqlite3.c"
 $20 = ((($4)) + 28|0); //@line 120290 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 120290 "c/sqlite3.c"
 $22 = $21 & 4; //@line 120290 "c/sqlite3.c"
 $23 = ($22|0)==(0); //@line 120290 "c/sqlite3.c"
 $24 = $21 & 68; //@line 120291 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 120291 "c/sqlite3.c"
 $26 = HEAP32[$19>>2]|0; //@line 120292 "c/sqlite3.c"
 _sqlite3VdbeSetNumCols($3,$26); //@line 120292 "c/sqlite3.c"
 $27 = HEAP32[$19>>2]|0; //@line 120293 "c/sqlite3.c"
 $28 = ($27|0)>(0); //@line 120293 "c/sqlite3.c"
 if ($28) {
  $$08586 = 0;
  while(1) {
   $29 = (((($19)) + 4|0) + (($$08586*20)|0)|0); //@line 120294 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 120294 "c/sqlite3.c"
   $31 = (((((($19)) + 4|0) + (($$08586*20)|0)|0)) + 4|0); //@line 120299 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 120299 "c/sqlite3.c"
   $33 = ($32|0)==(0|0); //@line 120299 "c/sqlite3.c"
   do {
    if ($33) {
     if (!($25)) {
      $34 = HEAP8[$30>>0]|0; //@line 120303 "c/sqlite3.c"
      $35 = ($34<<24>>24)==(-111); //@line 120303 "c/sqlite3.c"
      if ($35) {
       $36 = ((($30)) + 32|0); //@line 120305 "c/sqlite3.c"
       $37 = HEAP16[$36>>1]|0; //@line 120305 "c/sqlite3.c"
       $38 = $37 << 16 >> 16; //@line 120305 "c/sqlite3.c"
       $39 = ((($30)) + 44|0); //@line 120306 "c/sqlite3.c"
       $40 = HEAP32[$39>>2]|0; //@line 120306 "c/sqlite3.c"
       $41 = ($37<<16>>16)<(0); //@line 120308 "c/sqlite3.c"
       if ($41) {
        $42 = ((($40)) + 40|0); //@line 120308 "c/sqlite3.c"
        $43 = HEAP16[$42>>1]|0; //@line 120308 "c/sqlite3.c"
        $44 = $43 << 16 >> 16; //@line 120308 "c/sqlite3.c"
        $$083 = $44;
       } else {
        $$083 = $38;
       }
       $45 = ($$083|0)<(0); //@line 120310 "c/sqlite3.c"
       if ($45) {
        $$084 = 19225;
       } else {
        $46 = ((($40)) + 4|0); //@line 120313 "c/sqlite3.c"
        $47 = HEAP32[$46>>2]|0; //@line 120313 "c/sqlite3.c"
        $48 = (($47) + ($$083<<4)|0); //@line 120313 "c/sqlite3.c"
        $49 = HEAP32[$48>>2]|0; //@line 120313 "c/sqlite3.c"
        $$084 = $49;
       }
       if ($23) {
        _sqlite3VdbeSetColName($3,$$08586,0,$$084,(-1)); //@line 120320 "c/sqlite3.c"
        break;
       } else {
        $50 = HEAP32[$40>>2]|0; //@line 120317 "c/sqlite3.c"
        HEAP32[$vararg_buffer>>2] = $50; //@line 120317 "c/sqlite3.c"
        $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 120317 "c/sqlite3.c"
        HEAP32[$vararg_ptr1>>2] = $$084; //@line 120317 "c/sqlite3.c"
        $51 = (_sqlite3MPrintf($4,17909,$vararg_buffer)|0); //@line 120317 "c/sqlite3.c"
        _sqlite3VdbeSetColName($3,$$08586,0,$51,157); //@line 120318 "c/sqlite3.c"
        break;
       }
      }
     }
     $52 = (((((($19)) + 4|0) + (($$08586*20)|0)|0)) + 8|0); //@line 120323 "c/sqlite3.c"
     $53 = HEAP32[$52>>2]|0; //@line 120323 "c/sqlite3.c"
     $54 = ($53|0)==(0|0); //@line 120324 "c/sqlite3.c"
     if ($54) {
      $55 = (($$08586) + 1)|0; //@line 120324 "c/sqlite3.c"
      HEAP32[$vararg_buffer2>>2] = $55; //@line 120324 "c/sqlite3.c"
      $56 = (_sqlite3MPrintf($4,22893,$vararg_buffer2)|0); //@line 120324 "c/sqlite3.c"
      $58 = $56;
     } else {
      $57 = (_sqlite3DbStrDup($4,$53)|0); //@line 120324 "c/sqlite3.c"
      $58 = $57;
     }
     _sqlite3VdbeSetColName($3,$$08586,0,$58,157); //@line 120325 "c/sqlite3.c"
    } else {
     _sqlite3VdbeSetColName($3,$$08586,0,$32,(-1)); //@line 120302 "c/sqlite3.c"
    }
   } while(0);
   $59 = (($$08586) + 1)|0; //@line 120293 "c/sqlite3.c"
   $60 = HEAP32[$19>>2]|0; //@line 120293 "c/sqlite3.c"
   $61 = ($59|0)<($60|0); //@line 120293 "c/sqlite3.c"
   if ($61) {
    $$08586 = $59;
   } else {
    break;
   }
  }
 }
 _generateColumnTypes($0,$18,$19); //@line 120328 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 120329 "c/sqlite3.c"
}
function _flattenSubquery($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0230 = 0, $$0231267 = 0, $$0232 = 0, $$0232273 = 0, $$0232275 = 0, $$0234282 = 0, $$0235 = 0, $$0237265 = 0, $$0240 = 0, $$0241279 = 0, $$0245260 = 0, $$1233266 = 0, $$1236291 = 0, $$1236292 = 0, $$1238$lcssa = 0, $$1246261 = 0, $$4 = 0, $$old = 0, $$old253 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0;
 var $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0;
 var $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0;
 var $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0;
 var $21 = 0, $210 = 0, $211 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0;
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0;
 var $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $brmerge = 0, $brmerge$not = 0, $brmerge250 = 0, $exitcond = 0, $or$cond = 0, $or$cond257 = 0, $or$cond4 = 0, $spec$select = 0, $storemerge = 0, dest = 0, label = 0, sp = 0, src = 0;
 var stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp;
 $5 = ((($0)) + 440|0); //@line 122101 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 122101 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 122113 "c/sqlite3.c"
 $8 = ((($7)) + 68|0); //@line 122119 "c/sqlite3.c"
 $9 = HEAP16[$8>>1]|0; //@line 122119 "c/sqlite3.c"
 $10 = $9 & 1; //@line 122119 "c/sqlite3.c"
 $11 = ($10<<16>>16)==(0); //@line 122119 "c/sqlite3.c"
 if (!($11)) {
  $$4 = 0;
  STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
 }
 $12 = ((($1)) + 28|0); //@line 122120 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 122120 "c/sqlite3.c"
 $14 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 44|0); //@line 122123 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 122123 "c/sqlite3.c"
 $16 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 20|0); //@line 122124 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 122124 "c/sqlite3.c"
 $18 = ((($17)) + 28|0); //@line 122127 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 122127 "c/sqlite3.c"
 $20 = ((($17)) + 56|0); //@line 122134 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 122134 "c/sqlite3.c"
 $22 = ($21|0)==(0|0); //@line 122134 "c/sqlite3.c"
 if ($22) {
  $23 = ((($1)) + 8|0); //@line 122136 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 122136 "c/sqlite3.c"
  $58 = $24;
 } else {
  $25 = ((($1)) + 56|0); //@line 122134 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 122134 "c/sqlite3.c"
  $27 = ($26|0)==(0|0); //@line 122134 "c/sqlite3.c"
  if (!($27)) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
  $28 = ((($21)) + 16|0); //@line 122135 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 122135 "c/sqlite3.c"
  $30 = ($29|0)==(0|0); //@line 122135 "c/sqlite3.c"
  if (!($30)) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
  $31 = ((($1)) + 8|0); //@line 122136 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 122136 "c/sqlite3.c"
  $33 = $32 & 256; //@line 122136 "c/sqlite3.c"
  $34 = ($33|0)==(0); //@line 122136 "c/sqlite3.c"
  $brmerge250 = $22 | $34; //@line 122136 "c/sqlite3.c"
  if ($brmerge250) {
   $58 = $32;
  } else {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 }
 $35 = HEAP32[$19>>2]|0; //@line 122139 "c/sqlite3.c"
 $36 = ($35|0)==(0); //@line 122139 "c/sqlite3.c"
 if ($36) {
  $$4 = 0;
  STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
 }
 $37 = ((($17)) + 8|0); //@line 122140 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 122140 "c/sqlite3.c"
 $39 = $38 & 1; //@line 122140 "c/sqlite3.c"
 $40 = ($39|0)==(0); //@line 122140 "c/sqlite3.c"
 if (!($40)) {
  $$4 = 0;
  STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
 }
 if (!($22)) {
  $41 = HEAP32[$13>>2]|0; //@line 122141 "c/sqlite3.c"
  $42 = ($41|0)>(1); //@line 122141 "c/sqlite3.c"
  $43 = ($3|0)!=(0); //@line 122141 "c/sqlite3.c"
  $or$cond = $43 | $42; //@line 122141 "c/sqlite3.c"
  if ($or$cond) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 }
 $44 = ((($1)) + 44|0); //@line 122144 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 122144 "c/sqlite3.c"
 $46 = ($45|0)==(0|0); //@line 122144 "c/sqlite3.c"
 if (!($46)) {
  $47 = ((($17)) + 44|0); //@line 122144 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 122144 "c/sqlite3.c"
  $49 = ($48|0)==(0|0); //@line 122144 "c/sqlite3.c"
  if (!($49)) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 }
 $50 = ($3|0)!=(0); //@line 122147 "c/sqlite3.c"
 if ($50) {
  $51 = ((($17)) + 44|0); //@line 122147 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 122147 "c/sqlite3.c"
  $53 = ($52|0)==(0|0); //@line 122147 "c/sqlite3.c"
  if (!($53)) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 }
 if ($22) {
  $$old = $38 & 8192; //@line 122152 "c/sqlite3.c"
  $$old253 = ($$old|0)==(0); //@line 122152 "c/sqlite3.c"
  if (!($$old253)) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 } else {
  $54 = ((($1)) + 32|0); //@line 122148 "c/sqlite3.c"
  $55 = HEAP32[$54>>2]|0; //@line 122148 "c/sqlite3.c"
  $56 = ($55|0)==(0|0); //@line 122148 "c/sqlite3.c"
  $57 = $58 & 1; //@line 122149 "c/sqlite3.c"
  $59 = $38 & 8192; //@line 122152 "c/sqlite3.c"
  $60 = $59 | $57; //@line 122148 "c/sqlite3.c"
  $61 = ($60|0)==(0); //@line 122148 "c/sqlite3.c"
  $62 = $61 & $56; //@line 122148 "c/sqlite3.c"
  if (!($62)) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 }
 $63 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 36|0); //@line 122176 "c/sqlite3.c"
 $64 = HEAP8[$63>>0]|0; //@line 122176 "c/sqlite3.c"
 $65 = $64 & 32; //@line 122176 "c/sqlite3.c"
 $66 = ($65<<24>>24)==(0); //@line 122176 "c/sqlite3.c"
 if ($66) {
  $$0240 = 0;
 } else {
  $67 = ($35|0)>(1); //@line 122178 "c/sqlite3.c"
  $or$cond4 = $50 | $67; //@line 122178 "c/sqlite3.c"
  if ($or$cond4) {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
  $68 = ((($19)) + 24|0); //@line 122178 "c/sqlite3.c"
  $69 = HEAP32[$68>>2]|0; //@line 122178 "c/sqlite3.c"
  $70 = ((($69)) + 56|0); //@line 122178 "c/sqlite3.c"
  $71 = HEAP32[$70>>2]|0; //@line 122178 "c/sqlite3.c"
  $72 = ($71|0)==(0); //@line 122178 "c/sqlite3.c"
  if ($72) {
   $$0240 = 1;
  } else {
   $$4 = 0;
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 }
 $73 = ((($17)) + 48|0); //@line 122198 "c/sqlite3.c"
 $74 = HEAP32[$73>>2]|0; //@line 122198 "c/sqlite3.c"
 $75 = ($74|0)==(0|0); //@line 122198 "c/sqlite3.c"
 L46: do {
  if (!($75)) {
   $76 = ((($17)) + 44|0); //@line 122199 "c/sqlite3.c"
   $77 = HEAP32[$76>>2]|0; //@line 122199 "c/sqlite3.c"
   $78 = ($77|0)!=(0|0); //@line 122199 "c/sqlite3.c"
   $brmerge = $50 | $78; //@line 122199 "c/sqlite3.c"
   $brmerge$not = $brmerge ^ 1; //@line 122199 "c/sqlite3.c"
   $79 = $58 & 1; //@line 122202 "c/sqlite3.c"
   $80 = ($79|0)==(0); //@line 122202 "c/sqlite3.c"
   $or$cond257 = $80 & $brmerge$not; //@line 122199 "c/sqlite3.c"
   if (!($or$cond257)) {
    $$4 = 0;
    STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
   }
   $81 = HEAP32[$13>>2]|0; //@line 122202 "c/sqlite3.c"
   $82 = ($81|0)==(1); //@line 122202 "c/sqlite3.c"
   if (!($82)) {
    $$4 = 0;
    STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
   }
   $$0234282 = $17;
   while(1) {
    $85 = ((($$0234282)) + 8|0); //@line 122210 "c/sqlite3.c"
    $86 = HEAP32[$85>>2]|0; //@line 122210 "c/sqlite3.c"
    $87 = $86 & 9; //@line 122210 "c/sqlite3.c"
    $88 = ($87|0)==(0); //@line 122210 "c/sqlite3.c"
    if (!($88)) {
     $$4 = 0;
     label = 71;
     break;
    }
    $89 = ((($$0234282)) + 48|0); //@line 122211 "c/sqlite3.c"
    $84 = HEAP32[$89>>2]|0; //@line 122211 "c/sqlite3.c"
    $90 = ($84|0)==(0|0); //@line 122211 "c/sqlite3.c"
    if (!($90)) {
     $91 = ((($$0234282)) + 4|0); //@line 122211 "c/sqlite3.c"
     $92 = HEAP8[$91>>0]|0; //@line 122211 "c/sqlite3.c"
     $93 = ($92<<24>>24)==(116); //@line 122211 "c/sqlite3.c"
     if (!($93)) {
      $$4 = 0;
      label = 71;
      break;
     }
    }
    $94 = ((($$0234282)) + 28|0); //@line 122212 "c/sqlite3.c"
    $95 = HEAP32[$94>>2]|0; //@line 122212 "c/sqlite3.c"
    $96 = HEAP32[$95>>2]|0; //@line 122212 "c/sqlite3.c"
    $97 = ($96|0)<(1); //@line 122212 "c/sqlite3.c"
    if ($97) {
     $$4 = 0;
     label = 71;
     break;
    }
    $83 = ($84|0)==(0|0); //@line 122205 "c/sqlite3.c"
    if ($83) {
     label = 30;
     break;
    } else {
     $$0234282 = $84;
    }
   }
   if ((label|0) == 30) {
    if ($46) {
     break;
    }
    $98 = HEAP32[$45>>2]|0; //@line 122222 "c/sqlite3.c"
    $99 = ($98|0)>(0); //@line 122222 "c/sqlite3.c"
    if (!($99)) {
     break;
    }
    $$0241279 = 0;
    while(1) {
     $103 = (((((($45)) + 4|0) + (($$0241279*20)|0)|0)) + 16|0); //@line 122223 "c/sqlite3.c"
     $104 = HEAP16[$103>>1]|0; //@line 122223 "c/sqlite3.c"
     $105 = ($104<<16>>16)==(0); //@line 122223 "c/sqlite3.c"
     $102 = (($$0241279) + 1)|0; //@line 122222 "c/sqlite3.c"
     if ($105) {
      $$4 = 0;
      break;
     }
     $100 = HEAP32[$45>>2]|0; //@line 122222 "c/sqlite3.c"
     $101 = ($102|0)<($100|0); //@line 122222 "c/sqlite3.c"
     if ($101) {
      $$0241279 = $102;
     } else {
      break L46;
     }
    }
    STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
   }
   else if ((label|0) == 71) {
    STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
   }
  }
 } while(0);
 $106 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 8|0); //@line 122241 "c/sqlite3.c"
 $107 = HEAP32[$106>>2]|0; //@line 122241 "c/sqlite3.c"
 HEAP32[$5>>2] = $107; //@line 122241 "c/sqlite3.c"
 (_sqlite3AuthCheck($0,21,0,0,0)|0); //@line 122242 "c/sqlite3.c"
 HEAP32[$5>>2] = $6; //@line 122244 "c/sqlite3.c"
 $$0232273 = HEAP32[$73>>2]|0;
 $108 = ($$0232273|0)==(0|0); //@line 122279 "c/sqlite3.c"
 L73: do {
  if (!($108)) {
   $109 = ((($1)) + 56|0);
   $110 = ((($1)) + 48|0);
   $111 = ((($1)) + 4|0);
   $112 = ((($7)) + 73|0);
   $$0232275 = $$0232273;
   while(1) {
    $115 = HEAP32[$44>>2]|0; //@line 122281 "c/sqlite3.c"
    $116 = HEAP32[$109>>2]|0; //@line 122282 "c/sqlite3.c"
    $117 = HEAP32[$110>>2]|0; //@line 122283 "c/sqlite3.c"
    HEAP32[$44>>2] = 0; //@line 122284 "c/sqlite3.c"
    HEAP32[$12>>2] = 0; //@line 122285 "c/sqlite3.c"
    HEAP32[$110>>2] = 0; //@line 122286 "c/sqlite3.c"
    HEAP32[$109>>2] = 0; //@line 122287 "c/sqlite3.c"
    $118 = (_sqlite3SelectDup($7,$1,0)|0); //@line 122288 "c/sqlite3.c"
    HEAP32[$109>>2] = $116; //@line 122290 "c/sqlite3.c"
    HEAP32[$44>>2] = $115; //@line 122291 "c/sqlite3.c"
    HEAP32[$12>>2] = $13; //@line 122292 "c/sqlite3.c"
    HEAP8[$111>>0] = 116; //@line 122293 "c/sqlite3.c"
    $119 = ($118|0)==(0|0); //@line 122294 "c/sqlite3.c"
    if ($119) {
     $storemerge = $117;
    } else {
     $120 = ((($118)) + 48|0); //@line 122297 "c/sqlite3.c"
     HEAP32[$120>>2] = $117; //@line 122297 "c/sqlite3.c"
     $121 = ($117|0)==(0|0); //@line 122298 "c/sqlite3.c"
     if (!($121)) {
      $122 = ((($117)) + 52|0); //@line 122298 "c/sqlite3.c"
      HEAP32[$122>>2] = $118; //@line 122298 "c/sqlite3.c"
     }
     $123 = ((($118)) + 52|0); //@line 122299 "c/sqlite3.c"
     HEAP32[$123>>2] = $1; //@line 122299 "c/sqlite3.c"
     $storemerge = $118;
    }
    HEAP32[$110>>2] = $storemerge;
    $124 = HEAP8[$112>>0]|0; //@line 122305 "c/sqlite3.c"
    $125 = ($124<<24>>24)==(0); //@line 122305 "c/sqlite3.c"
    if (!($125)) {
     $$4 = 1;
     break;
    }
    $113 = ((($$0232275)) + 48|0); //@line 122279 "c/sqlite3.c"
    $$0232 = HEAP32[$113>>2]|0;
    $114 = ($$0232|0)==(0|0); //@line 122279 "c/sqlite3.c"
    if ($114) {
     break L73;
    } else {
     $$0232275 = $$0232;
    }
   }
   STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
  }
 } while(0);
 $126 = HEAP32[$16>>2]|0; //@line 122311 "c/sqlite3.c"
 $127 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 4|0); //@line 122316 "c/sqlite3.c"
 $128 = HEAP32[$127>>2]|0; //@line 122316 "c/sqlite3.c"
 _sqlite3DbFree($7,$128); //@line 122316 "c/sqlite3.c"
 $129 = HEAP32[$106>>2]|0; //@line 122317 "c/sqlite3.c"
 _sqlite3DbFree($7,$129); //@line 122317 "c/sqlite3.c"
 $130 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 12|0); //@line 122318 "c/sqlite3.c"
 $131 = HEAP32[$130>>2]|0; //@line 122318 "c/sqlite3.c"
 _sqlite3DbFree($7,$131); //@line 122318 "c/sqlite3.c"
 HEAP32[$127>>2] = 0; //@line 122319 "c/sqlite3.c"
 HEAP32[$106>>2] = 0; //@line 122320 "c/sqlite3.c"
 HEAP32[$130>>2] = 0; //@line 122321 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 122322 "c/sqlite3.c"
 $132 = (((((($13)) + 8|0) + (($2*72)|0)|0)) + 16|0); //@line 122331 "c/sqlite3.c"
 $133 = HEAP32[$132>>2]|0; //@line 122331 "c/sqlite3.c"
 $134 = ($133|0)==(0|0); //@line 122331 "c/sqlite3.c"
 if (!($134)) {
  $135 = ((($133)) + 32|0); //@line 122333 "c/sqlite3.c"
  $136 = HEAP32[$135>>2]|0; //@line 122333 "c/sqlite3.c"
  $137 = ($136|0)==(1); //@line 122333 "c/sqlite3.c"
  if ($137) {
   $138 = ((($0)) + 120|0); //@line 122334 "c/sqlite3.c"
   $139 = HEAP32[$138>>2]|0; //@line 122334 "c/sqlite3.c"
   $140 = ($139|0)==(0|0); //@line 122334 "c/sqlite3.c"
   $spec$select = $140 ? $0 : $139; //@line 122334 "c/sqlite3.c"
   $141 = ((($spec$select)) + 456|0); //@line 122335 "c/sqlite3.c"
   $142 = HEAP32[$141>>2]|0; //@line 122335 "c/sqlite3.c"
   $143 = ((($133)) + 76|0); //@line 122335 "c/sqlite3.c"
   HEAP32[$143>>2] = $142; //@line 122335 "c/sqlite3.c"
   HEAP32[$141>>2] = $133; //@line 122336 "c/sqlite3.c"
  } else {
   $144 = (($136) + -1)|0; //@line 122338 "c/sqlite3.c"
   HEAP32[$135>>2] = $144; //@line 122338 "c/sqlite3.c"
  }
  HEAP32[$132>>2] = 0; //@line 122340 "c/sqlite3.c"
 }
 $145 = ($1|0)==(0|0); //@line 122356 "c/sqlite3.c"
 L93: do {
  if (!($145)) {
   $146 = (($2) + 1)|0;
   $147 = ((($7)) + 73|0);
   $148 = ($$0240|0)==(0);
   $149 = ((($7)) + 73|0);
   $150 = ((($4)) + 4|0);
   $151 = ((($4)) + 8|0);
   $152 = ((($4)) + 12|0);
   $153 = ((($4)) + 16|0);
   $$0231267 = $1;$$0237265 = -1;$$1233266 = $126;
   while(1) {
    $154 = ((($$1233266)) + 28|0); //@line 122359 "c/sqlite3.c"
    $155 = HEAP32[$154>>2]|0; //@line 122359 "c/sqlite3.c"
    $156 = HEAP32[$155>>2]|0; //@line 122360 "c/sqlite3.c"
    $157 = ((($$0231267)) + 28|0); //@line 122361 "c/sqlite3.c"
    $158 = HEAP32[$157>>2]|0; //@line 122361 "c/sqlite3.c"
    $159 = ($158|0)==(0|0); //@line 122363 "c/sqlite3.c"
    if ($159) {
     $161 = (_sqlite3SrcListAppend($7,0,0,0)|0); //@line 122368 "c/sqlite3.c"
     HEAP32[$157>>2] = $161; //@line 122368 "c/sqlite3.c"
     $162 = ($161|0)==(0|0); //@line 122369 "c/sqlite3.c"
     if ($162) {
      break L93;
     } else {
      $$0230 = 0;$$0235 = $161;
     }
    } else {
     $160 = HEAP8[$63>>0]|0; //@line 122365 "c/sqlite3.c"
     $$0230 = $160;$$0235 = $158;
    }
    $163 = ($156|0)>(1); //@line 122390 "c/sqlite3.c"
    if ($163) {
     $164 = (($156) + -1)|0; //@line 122391 "c/sqlite3.c"
     $165 = (_sqlite3SrcListEnlarge($7,$$0235,$164,$146)|0); //@line 122391 "c/sqlite3.c"
     HEAP32[$157>>2] = $165; //@line 122391 "c/sqlite3.c"
     $166 = HEAP8[$147>>0]|0; //@line 122392 "c/sqlite3.c"
     $167 = ($166<<24>>24)==(0); //@line 122392 "c/sqlite3.c"
     if ($167) {
      $$1236292 = $165;
      label = 56;
     } else {
      break L93;
     }
    } else {
     $168 = ($156|0)==(1); //@line 122400 "c/sqlite3.c"
     if ($168) {
      $$1236292 = $$0235;
      label = 56;
     } else {
      $$1236291 = $$0235;$$1238$lcssa = $$0237265;
     }
    }
    if ((label|0) == 56) {
     label = 0;
     $$0245260 = 0;
     while(1) {
      $169 = (($$0245260) + ($2))|0; //@line 122401 "c/sqlite3.c"
      $170 = (((($$1236292)) + 8|0) + (($169*72)|0)|0); //@line 122401 "c/sqlite3.c"
      $171 = (((((($$1236292)) + 8|0) + (($169*72)|0)|0)) + 52|0); //@line 122401 "c/sqlite3.c"
      $172 = HEAP32[$171>>2]|0; //@line 122401 "c/sqlite3.c"
      _sqlite3IdListDelete($7,$172); //@line 122401 "c/sqlite3.c"
      $173 = (((($155)) + 8|0) + (($$0245260*72)|0)|0); //@line 122403 "c/sqlite3.c"
      dest=$170; src=$173; stop=dest+72|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 122403 "c/sqlite3.c"
      $174 = (((((($155)) + 8|0) + (($$0245260*72)|0)|0)) + 44|0); //@line 122404 "c/sqlite3.c"
      $175 = HEAP32[$174>>2]|0; //@line 122404 "c/sqlite3.c"
      dest=$173; stop=dest+72|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 122405 "c/sqlite3.c"
      $176 = (($$0245260) + 1)|0; //@line 122400 "c/sqlite3.c"
      $exitcond = ($176|0)==($156|0); //@line 122400 "c/sqlite3.c"
      if ($exitcond) {
       $$1236291 = $$1236292;$$1238$lcssa = $175;
       break;
      } else {
       $$0245260 = $176;
      }
     }
    }
    $177 = (((((($$1236291)) + 8|0) + (($2*72)|0)|0)) + 36|0); //@line 122407 "c/sqlite3.c"
    HEAP8[$177>>0] = $$0230; //@line 122407 "c/sqlite3.c"
    $178 = ((($$1233266)) + 44|0); //@line 122421 "c/sqlite3.c"
    $179 = HEAP32[$178>>2]|0; //@line 122421 "c/sqlite3.c"
    $180 = ($179|0)==(0|0); //@line 122421 "c/sqlite3.c"
    if (!($180)) {
     $181 = HEAP32[$179>>2]|0; //@line 122433 "c/sqlite3.c"
     $182 = ($181|0)>(0); //@line 122433 "c/sqlite3.c"
     if ($182) {
      $183 = HEAP32[$179>>2]|0;
      $$1246261 = 0;
      while(1) {
       $184 = (((((($179)) + 4|0) + (($$1246261*20)|0)|0)) + 16|0); //@line 122434 "c/sqlite3.c"
       HEAP16[$184>>1] = 0; //@line 122434 "c/sqlite3.c"
       $185 = (($$1246261) + 1)|0; //@line 122433 "c/sqlite3.c"
       $186 = ($185|0)<($183|0); //@line 122433 "c/sqlite3.c"
       if ($186) {
        $$1246261 = $185;
       } else {
        break;
       }
      }
     }
     $187 = ((($$0231267)) + 44|0); //@line 122438 "c/sqlite3.c"
     HEAP32[$187>>2] = $179; //@line 122438 "c/sqlite3.c"
     HEAP32[$178>>2] = 0; //@line 122439 "c/sqlite3.c"
    }
    $188 = ((($$1233266)) + 32|0); //@line 122441 "c/sqlite3.c"
    $189 = HEAP32[$188>>2]|0; //@line 122441 "c/sqlite3.c"
    $190 = (_sqlite3ExprDup($7,$189,0)|0); //@line 122441 "c/sqlite3.c"
    if (!($148)) {
     _setJoinExpr($190,$$1238$lcssa); //@line 122443 "c/sqlite3.c"
    }
    $191 = ((($$0231267)) + 32|0); //@line 122445 "c/sqlite3.c"
    $192 = HEAP32[$191>>2]|0; //@line 122445 "c/sqlite3.c"
    $193 = (_sqlite3ExprAnd($7,$190,$192)|0); //@line 122445 "c/sqlite3.c"
    HEAP32[$191>>2] = $193; //@line 122445 "c/sqlite3.c"
    $194 = HEAP8[$149>>0]|0; //@line 122446 "c/sqlite3.c"
    $195 = ($194<<24>>24)==(0); //@line 122446 "c/sqlite3.c"
    if ($195) {
     HEAP32[$4>>2] = $0; //@line 122448 "c/sqlite3.c"
     HEAP32[$150>>2] = $15; //@line 122449 "c/sqlite3.c"
     HEAP32[$151>>2] = $$1238$lcssa; //@line 122450 "c/sqlite3.c"
     HEAP32[$152>>2] = $$0240; //@line 122451 "c/sqlite3.c"
     $196 = HEAP32[$$1233266>>2]|0; //@line 122452 "c/sqlite3.c"
     HEAP32[$153>>2] = $196; //@line 122452 "c/sqlite3.c"
     _substSelect($4,$$0231267,0); //@line 122453 "c/sqlite3.c"
    }
    $197 = ((($$1233266)) + 8|0); //@line 122459 "c/sqlite3.c"
    $198 = HEAP32[$197>>2]|0; //@line 122459 "c/sqlite3.c"
    $199 = $198 & 1; //@line 122459 "c/sqlite3.c"
    $200 = ((($$0231267)) + 8|0); //@line 122459 "c/sqlite3.c"
    $201 = HEAP32[$200>>2]|0; //@line 122459 "c/sqlite3.c"
    $202 = $201 | $199; //@line 122459 "c/sqlite3.c"
    HEAP32[$200>>2] = $202; //@line 122459 "c/sqlite3.c"
    $203 = ((($$1233266)) + 56|0); //@line 122467 "c/sqlite3.c"
    $204 = HEAP32[$203>>2]|0; //@line 122467 "c/sqlite3.c"
    $205 = ($204|0)==(0|0); //@line 122467 "c/sqlite3.c"
    if (!($205)) {
     $206 = ((($$0231267)) + 56|0); //@line 122468 "c/sqlite3.c"
     HEAP32[$206>>2] = $204; //@line 122468 "c/sqlite3.c"
     HEAP32[$203>>2] = 0; //@line 122469 "c/sqlite3.c"
    }
    $207 = ((($$0231267)) + 48|0); //@line 122356 "c/sqlite3.c"
    $208 = HEAP32[$207>>2]|0; //@line 122356 "c/sqlite3.c"
    $209 = ((($$1233266)) + 48|0); //@line 122356 "c/sqlite3.c"
    $210 = HEAP32[$209>>2]|0; //@line 122356 "c/sqlite3.c"
    $211 = ($208|0)==(0|0); //@line 122356 "c/sqlite3.c"
    if ($211) {
     break;
    } else {
     $$0231267 = $208;$$0237265 = $$1238$lcssa;$$1233266 = $210;
    }
   }
  }
 } while(0);
 _sqlite3SelectDelete($7,$126); //@line 122476 "c/sqlite3.c"
 $$4 = 1;
 STACKTOP = sp;return ($$4|0); //@line 122486 "c/sqlite3.c"
}
function _multiSelect($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$0 = 0, $$0299332 = 0, $$0300330 = 0, $$0306331 = 0, $$0308 = 0, $$0318 = 0, $$0319 = 0, $$3 = 0, $$3304 = 0, $$3312 = 0, $$4305 = 0, $$5 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0;
 var $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0;
 var $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0;
 var $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0;
 var $99 = 0, $exitcond = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer = sp;
 $3 = sp + 32|0;
 $4 = sp + 8|0;
 $5 = HEAP32[$0>>2]|0; //@line 120965 "c/sqlite3.c"
 $6 = ((($1)) + 48|0); //@line 120966 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 120966 "c/sqlite3.c"
 ;HEAP32[$3>>2]=HEAP32[$2>>2]|0;HEAP32[$3+4>>2]=HEAP32[$2+4>>2]|0;HEAP32[$3+8>>2]=HEAP32[$2+8>>2]|0;HEAP32[$3+12>>2]=HEAP32[$2+12>>2]|0;HEAP32[$3+16>>2]=HEAP32[$2+16>>2]|0;HEAP32[$3+20>>2]=HEAP32[$2+20>>2]|0; //@line 120967 "c/sqlite3.c"
 $8 = ((($7)) + 44|0); //@line 120968 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 120968 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 120968 "c/sqlite3.c"
 L1: do {
  if ($10) {
   $11 = ((($7)) + 56|0); //@line 120968 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 120968 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 120968 "c/sqlite3.c"
   if ($13) {
    $19 = (_sqlite3GetVdbe($0)|0); //@line 120975 "c/sqlite3.c"
    $20 = HEAP8[$3>>0]|0; //@line 120980 "c/sqlite3.c"
    $21 = ($20<<24>>24)==(12); //@line 120980 "c/sqlite3.c"
    if ($21) {
     $22 = ((($3)) + 4|0); //@line 120982 "c/sqlite3.c"
     $23 = HEAP32[$22>>2]|0; //@line 120982 "c/sqlite3.c"
     $24 = HEAP32[$1>>2]|0; //@line 120982 "c/sqlite3.c"
     $25 = HEAP32[$24>>2]|0; //@line 120982 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($19,109,$23,$25)|0); //@line 120982 "c/sqlite3.c"
     HEAP8[$3>>0] = 14; //@line 120983 "c/sqlite3.c"
    }
    $26 = ((($1)) + 8|0); //@line 120988 "c/sqlite3.c"
    $27 = HEAP32[$26>>2]|0; //@line 120988 "c/sqlite3.c"
    $28 = $27 & 1024; //@line 120988 "c/sqlite3.c"
    $29 = ($28|0)==(0); //@line 120988 "c/sqlite3.c"
    if (!($29)) {
     $30 = (_multiSelectValues($0,$1,$3)|0); //@line 120989 "c/sqlite3.c"
     $$4305 = 0;$$5 = $30;
     break;
    }
    $31 = $27 & 8192; //@line 121000 "c/sqlite3.c"
    $32 = ($31|0)==(0); //@line 121000 "c/sqlite3.c"
    L10: do {
     if ($32) {
      $33 = ((($1)) + 44|0); //@line 121007 "c/sqlite3.c"
      $34 = HEAP32[$33>>2]|0; //@line 121007 "c/sqlite3.c"
      $35 = ($34|0)==(0|0); //@line 121007 "c/sqlite3.c"
      if (!($35)) {
       $36 = (_multiSelectOrderBy($0,$1,$2)|0); //@line 121008 "c/sqlite3.c"
       $$0 = $36;
       STACKTOP = sp;return ($$0|0); //@line 121273 "c/sqlite3.c"
      }
      $37 = ((($1)) + 4|0); //@line 121013 "c/sqlite3.c"
      $38 = HEAP8[$37>>0]|0; //@line 121013 "c/sqlite3.c"
      switch ($38<<24>>24) {
      case 116:  {
       $39 = ((($1)) + 12|0); //@line 121018 "c/sqlite3.c"
       $40 = HEAP32[$39>>2]|0; //@line 121018 "c/sqlite3.c"
       $41 = ((($7)) + 12|0); //@line 121018 "c/sqlite3.c"
       HEAP32[$41>>2] = $40; //@line 121018 "c/sqlite3.c"
       $42 = ((($1)) + 16|0); //@line 121019 "c/sqlite3.c"
       $43 = HEAP32[$42>>2]|0; //@line 121019 "c/sqlite3.c"
       $44 = ((($7)) + 16|0); //@line 121019 "c/sqlite3.c"
       HEAP32[$44>>2] = $43; //@line 121019 "c/sqlite3.c"
       $45 = ((($1)) + 56|0); //@line 121020 "c/sqlite3.c"
       $46 = HEAP32[$45>>2]|0; //@line 121020 "c/sqlite3.c"
       HEAP32[$11>>2] = $46; //@line 121020 "c/sqlite3.c"
       $47 = ((($0)) + 416|0); //@line 121021 "c/sqlite3.c"
       $48 = HEAP32[$47>>2]|0; //@line 121021 "c/sqlite3.c"
       $49 = (_sqlite3Select($0,$7,$3)|0); //@line 121022 "c/sqlite3.c"
       HEAP32[$45>>2] = 0; //@line 121023 "c/sqlite3.c"
       $50 = ($49|0)==(0); //@line 121024 "c/sqlite3.c"
       if (!($50)) {
        $$4305 = 0;$$5 = $49;
        break L1;
       }
       HEAP32[$6>>2] = 0; //@line 121027 "c/sqlite3.c"
       $51 = HEAP32[$41>>2]|0; //@line 121028 "c/sqlite3.c"
       HEAP32[$39>>2] = $51; //@line 121028 "c/sqlite3.c"
       $52 = HEAP32[$44>>2]|0; //@line 121029 "c/sqlite3.c"
       HEAP32[$42>>2] = $52; //@line 121029 "c/sqlite3.c"
       $53 = ($51|0)==(0); //@line 121030 "c/sqlite3.c"
       if ($53) {
        $$0318 = 0;
       } else {
        $54 = (_sqlite3VdbeAddOp1($19,22,$51)|0); //@line 121031 "c/sqlite3.c"
        $55 = HEAP32[$42>>2]|0; //@line 121033 "c/sqlite3.c"
        $56 = ($55|0)==(0); //@line 121033 "c/sqlite3.c"
        if ($56) {
         $$0318 = $54;
        } else {
         $57 = (($55) + 1)|0; //@line 121035 "c/sqlite3.c"
         $58 = HEAP32[$39>>2]|0; //@line 121035 "c/sqlite3.c"
         (_sqlite3VdbeAddOp3($19,148,$58,$57,$55)|0); //@line 121034 "c/sqlite3.c"
         $$0318 = $54;
        }
       }
       $59 = HEAP32[$47>>2]|0; //@line 121038 "c/sqlite3.c"
       $60 = (_sqlite3Select($0,$1,$3)|0); //@line 121039 "c/sqlite3.c"
       $61 = HEAP32[$6>>2]|0; //@line 121041 "c/sqlite3.c"
       HEAP32[$6>>2] = $7; //@line 121042 "c/sqlite3.c"
       $62 = ((($1)) + 6|0); //@line 121043 "c/sqlite3.c"
       $63 = HEAP16[$62>>1]|0; //@line 121043 "c/sqlite3.c"
       $64 = ((($7)) + 6|0); //@line 121043 "c/sqlite3.c"
       $65 = HEAP16[$64>>1]|0; //@line 121043 "c/sqlite3.c"
       $66 = (_sqlite3LogEstAdd($63,$65)|0); //@line 121043 "c/sqlite3.c"
       HEAP16[$62>>1] = $66; //@line 121043 "c/sqlite3.c"
       $67 = HEAP32[$11>>2]|0; //@line 121044 "c/sqlite3.c"
       $68 = ($67|0)==(0|0); //@line 121044 "c/sqlite3.c"
       if (!($68)) {
        $69 = ((($67)) + 12|0); //@line 121045 "c/sqlite3.c"
        $70 = HEAP32[$69>>2]|0; //@line 121045 "c/sqlite3.c"
        $71 = (_sqlite3ExprIsInteger($70,$4)|0); //@line 121045 "c/sqlite3.c"
        $72 = ($71|0)!=(0); //@line 121045 "c/sqlite3.c"
        $73 = HEAP32[$4>>2]|0; //@line 121046 "c/sqlite3.c"
        $74 = ($73|0)>(0); //@line 121046 "c/sqlite3.c"
        $or$cond = $72 & $74; //@line 121046 "c/sqlite3.c"
        if ($or$cond) {
         $75 = HEAP16[$62>>1]|0; //@line 121046 "c/sqlite3.c"
         $76 = ($73|0)<(0); //@line 121046 "c/sqlite3.c"
         $77 = $76 << 31 >> 31; //@line 121046 "c/sqlite3.c"
         $78 = (_sqlite3LogEst($73,$77)|0); //@line 121046 "c/sqlite3.c"
         $79 = ($75<<16>>16)>($78<<16>>16); //@line 121046 "c/sqlite3.c"
         if ($79) {
          HEAP16[$62>>1] = $78; //@line 121048 "c/sqlite3.c"
         }
        }
       }
       $80 = ($$0318|0)==(0); //@line 121050 "c/sqlite3.c"
       if (!($80)) {
        _sqlite3VdbeJumpHere($19,$$0318); //@line 121051 "c/sqlite3.c"
       }
       $$0308 = $48;$$3 = $60;$$3304 = $61;$$3312 = $59;
       break L10;
       break;
      }
      case 115: case 117:  {
       $81 = HEAP8[$3>>0]|0; //@line 121067 "c/sqlite3.c"
       $82 = ($81<<24>>24)==(1); //@line 121067 "c/sqlite3.c"
       if ($82) {
        $83 = ((($3)) + 4|0); //@line 121072 "c/sqlite3.c"
        $84 = HEAP32[$83>>2]|0; //@line 121072 "c/sqlite3.c"
        $$0319 = $84;
       } else {
        $85 = ((($0)) + 40|0); //@line 121077 "c/sqlite3.c"
        $86 = HEAP32[$85>>2]|0; //@line 121077 "c/sqlite3.c"
        $87 = (($86) + 1)|0; //@line 121077 "c/sqlite3.c"
        HEAP32[$85>>2] = $87; //@line 121077 "c/sqlite3.c"
        $88 = (_sqlite3VdbeAddOp2($19,109,$86,0)|0); //@line 121079 "c/sqlite3.c"
        $89 = ((($1)) + 20|0); //@line 121081 "c/sqlite3.c"
        HEAP32[$89>>2] = $88; //@line 121081 "c/sqlite3.c"
        $90 = (_findRightmost($1)|0); //@line 121082 "c/sqlite3.c"
        $91 = ((($90)) + 8|0); //@line 121082 "c/sqlite3.c"
        $92 = HEAP32[$91>>2]|0; //@line 121082 "c/sqlite3.c"
        $93 = $92 | 32; //@line 121082 "c/sqlite3.c"
        HEAP32[$91>>2] = $93; //@line 121082 "c/sqlite3.c"
        $$0319 = $86;
       }
       _sqlite3SelectDestInit($4,1,$$0319); //@line 121089 "c/sqlite3.c"
       $94 = ((($0)) + 416|0); //@line 121090 "c/sqlite3.c"
       $95 = HEAP32[$94>>2]|0; //@line 121090 "c/sqlite3.c"
       $96 = (_sqlite3Select($0,$7,$4)|0); //@line 121091 "c/sqlite3.c"
       $97 = ($96|0)==(0); //@line 121092 "c/sqlite3.c"
       if (!($97)) {
        $$4305 = 0;$$5 = $96;
        break L1;
       }
       $98 = HEAP8[$37>>0]|0; //@line 121098 "c/sqlite3.c"
       $99 = ($98<<24>>24)==(117); //@line 121098 "c/sqlite3.c"
       $$ = $99 ? 2 : 1; //@line 121100 "c/sqlite3.c"
       HEAP32[$6>>2] = 0; //@line 121104 "c/sqlite3.c"
       $100 = ((($1)) + 56|0); //@line 121105 "c/sqlite3.c"
       $101 = HEAP32[$100>>2]|0; //@line 121105 "c/sqlite3.c"
       HEAP32[$100>>2] = 0; //@line 121106 "c/sqlite3.c"
       HEAP8[$4>>0] = $$; //@line 121107 "c/sqlite3.c"
       $102 = HEAP32[$94>>2]|0; //@line 121108 "c/sqlite3.c"
       $103 = (_sqlite3Select($0,$1,$4)|0); //@line 121109 "c/sqlite3.c"
       $104 = HEAP32[$33>>2]|0; //@line 121113 "c/sqlite3.c"
       _sqlite3ExprListDelete($5,$104); //@line 121113 "c/sqlite3.c"
       $105 = HEAP32[$6>>2]|0; //@line 121114 "c/sqlite3.c"
       HEAP32[$6>>2] = $7; //@line 121115 "c/sqlite3.c"
       HEAP32[$33>>2] = 0; //@line 121116 "c/sqlite3.c"
       $106 = HEAP8[$37>>0]|0; //@line 121117 "c/sqlite3.c"
       $107 = ($106<<24>>24)==(115); //@line 121117 "c/sqlite3.c"
       if ($107) {
        $108 = ((($1)) + 6|0); //@line 121118 "c/sqlite3.c"
        $109 = HEAP16[$108>>1]|0; //@line 121118 "c/sqlite3.c"
        $110 = ((($7)) + 6|0); //@line 121118 "c/sqlite3.c"
        $111 = HEAP16[$110>>1]|0; //@line 121118 "c/sqlite3.c"
        $112 = (_sqlite3LogEstAdd($109,$111)|0); //@line 121118 "c/sqlite3.c"
        HEAP16[$108>>1] = $112; //@line 121118 "c/sqlite3.c"
       }
       $113 = HEAP32[$100>>2]|0; //@line 121120 "c/sqlite3.c"
       _sqlite3ExprDelete($5,$113); //@line 121120 "c/sqlite3.c"
       HEAP32[$100>>2] = $101; //@line 121121 "c/sqlite3.c"
       $114 = ((($1)) + 12|0); //@line 121122 "c/sqlite3.c"
       HEAP32[$114>>2] = 0; //@line 121122 "c/sqlite3.c"
       $115 = ((($1)) + 16|0); //@line 121123 "c/sqlite3.c"
       HEAP32[$115>>2] = 0; //@line 121123 "c/sqlite3.c"
       $116 = HEAP8[$3>>0]|0; //@line 121129 "c/sqlite3.c"
       $117 = ($116<<24>>24)==(1); //@line 121129 "c/sqlite3.c"
       if (!($117)) {
        $118 = (_sqlite3VdbeMakeLabel($19)|0); //@line 121132 "c/sqlite3.c"
        $119 = (_sqlite3VdbeMakeLabel($19)|0); //@line 121133 "c/sqlite3.c"
        _computeLimitRegisters($0,$1,$118); //@line 121134 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($19,37,$$0319,$118)|0); //@line 121135 "c/sqlite3.c"
        $120 = (_sqlite3VdbeCurrentAddr($19)|0); //@line 121136 "c/sqlite3.c"
        _selectInnerLoop($0,$1,$$0319,0,0,$3,$119,$118); //@line 121137 "c/sqlite3.c"
        _sqlite3VdbeResolveLabel($19,$119); //@line 121139 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($19,7,$$0319,$120)|0); //@line 121140 "c/sqlite3.c"
        _sqlite3VdbeResolveLabel($19,$118); //@line 121141 "c/sqlite3.c"
        (_sqlite3VdbeAddOp2($19,113,$$0319,0)|0); //@line 121142 "c/sqlite3.c"
       }
       $$0308 = $95;$$3 = $103;$$3304 = $105;$$3312 = $102;
       break L10;
       break;
      }
      default: {
       $121 = ((($0)) + 40|0); //@line 121158 "c/sqlite3.c"
       $122 = HEAP32[$121>>2]|0; //@line 121158 "c/sqlite3.c"
       $123 = (($122) + 1)|0; //@line 121158 "c/sqlite3.c"
       $124 = (($122) + 2)|0; //@line 121159 "c/sqlite3.c"
       HEAP32[$121>>2] = $124; //@line 121159 "c/sqlite3.c"
       $125 = (_sqlite3VdbeAddOp2($19,109,$122,0)|0); //@line 121162 "c/sqlite3.c"
       $126 = ((($1)) + 20|0); //@line 121164 "c/sqlite3.c"
       HEAP32[$126>>2] = $125; //@line 121164 "c/sqlite3.c"
       $127 = (_findRightmost($1)|0); //@line 121165 "c/sqlite3.c"
       $128 = ((($127)) + 8|0); //@line 121165 "c/sqlite3.c"
       $129 = HEAP32[$128>>2]|0; //@line 121165 "c/sqlite3.c"
       $130 = $129 | 32; //@line 121165 "c/sqlite3.c"
       HEAP32[$128>>2] = $130; //@line 121165 "c/sqlite3.c"
       _sqlite3SelectDestInit($4,1,$122); //@line 121170 "c/sqlite3.c"
       $131 = ((($0)) + 416|0); //@line 121171 "c/sqlite3.c"
       $132 = HEAP32[$131>>2]|0; //@line 121171 "c/sqlite3.c"
       $133 = (_sqlite3Select($0,$7,$4)|0); //@line 121172 "c/sqlite3.c"
       $134 = ($133|0)==(0); //@line 121173 "c/sqlite3.c"
       if (!($134)) {
        $$4305 = 0;$$5 = $133;
        break L1;
       }
       $135 = (_sqlite3VdbeAddOp2($19,109,$123,0)|0); //@line 121179 "c/sqlite3.c"
       $136 = ((($1)) + 24|0); //@line 121181 "c/sqlite3.c"
       HEAP32[$136>>2] = $135; //@line 121181 "c/sqlite3.c"
       HEAP32[$6>>2] = 0; //@line 121182 "c/sqlite3.c"
       $137 = ((($1)) + 56|0); //@line 121183 "c/sqlite3.c"
       $138 = HEAP32[$137>>2]|0; //@line 121183 "c/sqlite3.c"
       HEAP32[$137>>2] = 0; //@line 121184 "c/sqlite3.c"
       $139 = ((($4)) + 4|0); //@line 121185 "c/sqlite3.c"
       HEAP32[$139>>2] = $123; //@line 121185 "c/sqlite3.c"
       $140 = HEAP32[$131>>2]|0; //@line 121186 "c/sqlite3.c"
       $141 = (_sqlite3Select($0,$1,$4)|0); //@line 121187 "c/sqlite3.c"
       $142 = HEAP32[$6>>2]|0; //@line 121189 "c/sqlite3.c"
       HEAP32[$6>>2] = $7; //@line 121190 "c/sqlite3.c"
       $143 = ((($1)) + 6|0); //@line 121191 "c/sqlite3.c"
       $144 = HEAP16[$143>>1]|0; //@line 121191 "c/sqlite3.c"
       $145 = ((($7)) + 6|0); //@line 121191 "c/sqlite3.c"
       $146 = HEAP16[$145>>1]|0; //@line 121191 "c/sqlite3.c"
       $147 = ($144<<16>>16)>($146<<16>>16); //@line 121191 "c/sqlite3.c"
       if ($147) {
        HEAP16[$143>>1] = $146; //@line 121191 "c/sqlite3.c"
       }
       $148 = HEAP32[$137>>2]|0; //@line 121192 "c/sqlite3.c"
       _sqlite3ExprDelete($5,$148); //@line 121192 "c/sqlite3.c"
       HEAP32[$137>>2] = $138; //@line 121193 "c/sqlite3.c"
       $149 = (_sqlite3VdbeMakeLabel($19)|0); //@line 121199 "c/sqlite3.c"
       $150 = (_sqlite3VdbeMakeLabel($19)|0); //@line 121200 "c/sqlite3.c"
       _computeLimitRegisters($0,$1,$149); //@line 121201 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($19,37,$122,$149)|0); //@line 121202 "c/sqlite3.c"
       $151 = (_sqlite3GetTempReg($0)|0); //@line 121203 "c/sqlite3.c"
       $152 = (_sqlite3VdbeAddOp2($19,123,$122,$151)|0); //@line 121204 "c/sqlite3.c"
       (_sqlite3VdbeAddOp4Int($19,29,$123,$150,$151,0)|0); //@line 121205 "c/sqlite3.c"
       _sqlite3ReleaseTempReg($0,$151); //@line 121206 "c/sqlite3.c"
       _selectInnerLoop($0,$1,$122,0,0,$3,$150,$149); //@line 121207 "c/sqlite3.c"
       _sqlite3VdbeResolveLabel($19,$150); //@line 121209 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($19,7,$122,$152)|0); //@line 121210 "c/sqlite3.c"
       _sqlite3VdbeResolveLabel($19,$149); //@line 121211 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($19,113,$123,0)|0); //@line 121212 "c/sqlite3.c"
       (_sqlite3VdbeAddOp2($19,113,$122,0)|0); //@line 121213 "c/sqlite3.c"
       $$0308 = $132;$$3 = $141;$$3304 = $142;$$3312 = $140;
       break L10;
      }
      }
     } else {
      _generateWithRecursiveQuery($0,$1,$3); //@line 121001 "c/sqlite3.c"
      $$0308 = 0;$$3 = 0;$$3304 = 0;$$3312 = 0;
     }
    } while(0);
    $153 = ((($1)) + 4|0); //@line 121218 "c/sqlite3.c"
    $154 = HEAP8[$153>>0]|0; //@line 121218 "c/sqlite3.c"
    $155 = $154&255; //@line 121218 "c/sqlite3.c"
    $156 = ($154<<24>>24)!=(116); //@line 121218 "c/sqlite3.c"
    $157 = $156&1; //@line 121218 "c/sqlite3.c"
    _explainComposite($0,$155,$$0308,$$3312,$157); //@line 121218 "c/sqlite3.c"
    $158 = HEAP32[$26>>2]|0; //@line 121229 "c/sqlite3.c"
    $159 = $158 & 32; //@line 121229 "c/sqlite3.c"
    $160 = ($159|0)==(0); //@line 121229 "c/sqlite3.c"
    if ($160) {
     $$4305 = $$3304;$$5 = $$3;
    } else {
     $161 = HEAP32[$1>>2]|0; //@line 121237 "c/sqlite3.c"
     $162 = HEAP32[$161>>2]|0; //@line 121237 "c/sqlite3.c"
     $163 = (_sqlite3KeyInfoAlloc($5,$162,1)|0); //@line 121238 "c/sqlite3.c"
     $164 = ($163|0)==(0|0); //@line 121239 "c/sqlite3.c"
     if ($164) {
      $$4305 = $$3304;$$5 = 7;
     } else {
      $165 = ($162|0)>(0); //@line 121243 "c/sqlite3.c"
      if ($165) {
       $166 = ((($163)) + 20|0); //@line 121243 "c/sqlite3.c"
       $167 = ((($5)) + 8|0);
       $$0299332 = $166;$$0306331 = 0;
       while(1) {
        $168 = (_multiSelectCollSeq($0,$1,$$0306331)|0); //@line 121244 "c/sqlite3.c"
        HEAP32[$$0299332>>2] = $168; //@line 121244 "c/sqlite3.c"
        $169 = ($168|0)==(0|0); //@line 121245 "c/sqlite3.c"
        if ($169) {
         $170 = HEAP32[$167>>2]|0; //@line 121246 "c/sqlite3.c"
         HEAP32[$$0299332>>2] = $170; //@line 121246 "c/sqlite3.c"
        }
        $171 = (($$0306331) + 1)|0; //@line 121243 "c/sqlite3.c"
        $172 = ((($$0299332)) + 4|0); //@line 121243 "c/sqlite3.c"
        $exitcond = ($171|0)==($162|0); //@line 121243 "c/sqlite3.c"
        if ($exitcond) {
         break;
        } else {
         $$0299332 = $172;$$0306331 = $171;
        }
       }
       $173 = ($1|0)==(0|0); //@line 121250 "c/sqlite3.c"
       if (!($173)) {
        label = 48;
       }
      } else {
       label = 48;
      }
      if ((label|0) == 48) {
       $$0300330 = $1;
       while(1) {
        $174 = ((($$0300330)) + 20|0); //@line 121252 "c/sqlite3.c"
        $175 = HEAP32[$174>>2]|0; //@line 121252 "c/sqlite3.c"
        $176 = ($175|0)<(0); //@line 121253 "c/sqlite3.c"
        if (!($176)) {
         _sqlite3VdbeChangeP2($19,$175,$162); //@line 121259 "c/sqlite3.c"
         $177 = (_sqlite3KeyInfoRef($163)|0); //@line 121260 "c/sqlite3.c"
         _sqlite3VdbeChangeP4($19,$175,$163,-9); //@line 121260 "c/sqlite3.c"
         HEAP32[$174>>2] = -1; //@line 121262 "c/sqlite3.c"
         $178 = ((($$0300330)) + 24|0); //@line 121252 "c/sqlite3.c"
         $179 = HEAP32[$178>>2]|0; //@line 121252 "c/sqlite3.c"
         $180 = ($179|0)<(0); //@line 121253 "c/sqlite3.c"
         if (!($180)) {
          _sqlite3VdbeChangeP2($19,$179,$162); //@line 121259 "c/sqlite3.c"
          $190 = (_sqlite3KeyInfoRef($163)|0); //@line 121260 "c/sqlite3.c"
          _sqlite3VdbeChangeP4($19,$179,$163,-9); //@line 121260 "c/sqlite3.c"
          HEAP32[$178>>2] = -1; //@line 121262 "c/sqlite3.c"
         }
        }
        $181 = ((($$0300330)) + 48|0); //@line 121250 "c/sqlite3.c"
        $182 = HEAP32[$181>>2]|0; //@line 121250 "c/sqlite3.c"
        $183 = ($182|0)==(0|0); //@line 121250 "c/sqlite3.c"
        if ($183) {
         break;
        } else {
         $$0300330 = $182;
        }
       }
      }
      _sqlite3KeyInfoUnref($163); //@line 121265 "c/sqlite3.c"
      $$4305 = $$3304;$$5 = $$3;
     }
    }
   } else {
    label = 3;
   }
  } else {
   label = 3;
  }
 } while(0);
 if ((label|0) == 3) {
  $14 = $10 ? 28576 : 28452; //@line 120970 "c/sqlite3.c"
  $15 = ((($1)) + 4|0); //@line 120970 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 120970 "c/sqlite3.c"
  $17 = $16&255; //@line 120970 "c/sqlite3.c"
  $18 = (_selectOpName($17)|0); //@line 120970 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $14; //@line 120969 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 120969 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $18; //@line 120969 "c/sqlite3.c"
  _sqlite3ErrorMsg($0,28582,$vararg_buffer); //@line 120969 "c/sqlite3.c"
  $$4305 = 0;$$5 = 1;
 }
 $184 = ((($3)) + 8|0); //@line 121269 "c/sqlite3.c"
 $185 = HEAP32[$184>>2]|0; //@line 121269 "c/sqlite3.c"
 $186 = ((($2)) + 8|0); //@line 121269 "c/sqlite3.c"
 HEAP32[$186>>2] = $185; //@line 121269 "c/sqlite3.c"
 $187 = ((($3)) + 12|0); //@line 121270 "c/sqlite3.c"
 $188 = HEAP32[$187>>2]|0; //@line 121270 "c/sqlite3.c"
 $189 = ((($2)) + 12|0); //@line 121270 "c/sqlite3.c"
 HEAP32[$189>>2] = $188; //@line 121270 "c/sqlite3.c"
 _sqlite3SelectDelete($5,$$4305); //@line 121271 "c/sqlite3.c"
 $$0 = $$5;
 STACKTOP = sp;return ($$0|0); //@line 121273 "c/sqlite3.c"
}
function _sqlite3SelectExprHeight($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = 0; //@line 93402 "c/sqlite3.c"
 _heightOfSelect($0,$1); //@line 93403 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 93404 "c/sqlite3.c"
 STACKTOP = sp;return ($2|0); //@line 93404 "c/sqlite3.c"
}
function _pushDownWhereTerms($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$lcssa = 0, $$034 = 0, $$035$lcssa = 0, $$03538 = 0, $$03637 = 0, $$039 = 0, $$sink = 0, $$sink45 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp;
 $5 = ($2|0)==(0|0); //@line 122539 "c/sqlite3.c"
 if ($5) {
  $$034 = 0;
  STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
 }
 $6 = ((($1)) + 8|0); //@line 122540 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 122540 "c/sqlite3.c"
 $8 = $7 & 8192; //@line 122540 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 122540 "c/sqlite3.c"
 if (!($9)) {
  $$034 = 0;
  STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
 }
 $10 = ((($1)) + 56|0); //@line 122555 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 122555 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 122555 "c/sqlite3.c"
 if (!($12)) {
  $$034 = 0;
  STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
 }
 $13 = HEAP8[$2>>0]|0; //@line 122558 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(44); //@line 122558 "c/sqlite3.c"
 if ($14) {
  $$03538 = $2;$$039 = 0;
  while(1) {
   $15 = ((($$03538)) + 16|0); //@line 122559 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 122559 "c/sqlite3.c"
   $17 = (_pushDownWhereTerms($0,$1,$16,$3)|0); //@line 122559 "c/sqlite3.c"
   $18 = (($17) + ($$039))|0; //@line 122559 "c/sqlite3.c"
   $19 = ((($$03538)) + 12|0); //@line 122560 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 122560 "c/sqlite3.c"
   $21 = HEAP8[$20>>0]|0; //@line 122558 "c/sqlite3.c"
   $22 = ($21<<24>>24)==(44); //@line 122558 "c/sqlite3.c"
   if ($22) {
    $$03538 = $20;$$039 = $18;
   } else {
    $$0$lcssa = $18;$$035$lcssa = $20;
    break;
   }
  }
 } else {
  $$0$lcssa = 0;$$035$lcssa = $2;
 }
 $23 = ((($$035$lcssa)) + 4|0); //@line 122562 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 122562 "c/sqlite3.c"
 $25 = $24 & 1; //@line 122562 "c/sqlite3.c"
 $26 = ($25|0)==(0); //@line 122562 "c/sqlite3.c"
 if (!($26)) {
  $$034 = 0;
  STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
 }
 $27 = (_sqlite3ExprIsTableConstant($$035$lcssa,$3)|0); //@line 122563 "c/sqlite3.c"
 $28 = ($27|0)==(0); //@line 122563 "c/sqlite3.c"
 if ($28) {
  $$034 = $$0$lcssa;
  STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
 }
 $29 = (($$0$lcssa) + 1)|0; //@line 122564 "c/sqlite3.c"
 $30 = ($1|0)==(0|0); //@line 122565 "c/sqlite3.c"
 if ($30) {
  $$034 = $29;
  STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
 }
 $31 = ((($4)) + 4|0);
 $32 = ((($4)) + 8|0);
 $33 = ((($4)) + 12|0);
 $34 = ((($4)) + 16|0);
 $$03637 = $1;
 while(1) {
  $35 = HEAP32[$0>>2]|0; //@line 122567 "c/sqlite3.c"
  $36 = (_sqlite3ExprDup($35,$$035$lcssa,0)|0); //@line 122567 "c/sqlite3.c"
  HEAP32[$4>>2] = $0; //@line 122568 "c/sqlite3.c"
  HEAP32[$31>>2] = $3; //@line 122569 "c/sqlite3.c"
  HEAP32[$32>>2] = $3; //@line 122570 "c/sqlite3.c"
  HEAP32[$33>>2] = 0; //@line 122571 "c/sqlite3.c"
  $37 = HEAP32[$$03637>>2]|0; //@line 122572 "c/sqlite3.c"
  HEAP32[$34>>2] = $37; //@line 122572 "c/sqlite3.c"
  $38 = (_substExpr($4,$36)|0); //@line 122573 "c/sqlite3.c"
  $39 = ((($$03637)) + 8|0); //@line 122574 "c/sqlite3.c"
  $40 = HEAP32[$39>>2]|0; //@line 122574 "c/sqlite3.c"
  $41 = $40 & 8; //@line 122574 "c/sqlite3.c"
  $42 = ($41|0)==(0); //@line 122574 "c/sqlite3.c"
  $43 = HEAP32[$0>>2]|0;
  $44 = ((($$03637)) + 32|0); //@line 122577 "c/sqlite3.c"
  $45 = ((($$03637)) + 40|0); //@line 122575 "c/sqlite3.c"
  $$sink = $42 ? $44 : $45; //@line 122574 "c/sqlite3.c"
  $$sink45 = $42 ? $44 : $45; //@line 122574 "c/sqlite3.c"
  $46 = HEAP32[$$sink>>2]|0;
  $47 = (_sqlite3ExprAnd($43,$46,$38)|0);
  HEAP32[$$sink45>>2] = $47;
  $48 = ((($$03637)) + 48|0); //@line 122579 "c/sqlite3.c"
  $49 = HEAP32[$48>>2]|0; //@line 122579 "c/sqlite3.c"
  $50 = ($49|0)==(0|0); //@line 122565 "c/sqlite3.c"
  if ($50) {
   $$034 = $29;
   break;
  } else {
   $$03637 = $49;
  }
 }
 STACKTOP = sp;return ($$034|0); //@line 122583 "c/sqlite3.c"
}
function _isSelfJoinView($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $$017 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 123680 "c/sqlite3.c"
 $3 = ((($1)) + 20|0); //@line 123687 "c/sqlite3.c"
 $4 = ($2>>>0)<($1>>>0); //@line 123680 "c/sqlite3.c"
 if (!($4)) {
  $$016 = 0;
  return ($$016|0); //@line 123696 "c/sqlite3.c"
 }
 $5 = ((($1)) + 4|0);
 $6 = ((($1)) + 8|0);
 $$017 = $2;
 while(1) {
  $7 = ((($$017)) + 20|0); //@line 123681 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 123681 "c/sqlite3.c"
  $9 = ($8|0)==(0|0); //@line 123681 "c/sqlite3.c"
  if (!($9)) {
   $10 = ((($$017)) + 37|0); //@line 123682 "c/sqlite3.c"
   $11 = HEAP8[$10>>0]|0; //@line 123682 "c/sqlite3.c"
   $12 = $11 & 16; //@line 123682 "c/sqlite3.c"
   $13 = ($12<<24>>24)==(0); //@line 123682 "c/sqlite3.c"
   if ($13) {
    $14 = ((($$017)) + 8|0); //@line 123683 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 123683 "c/sqlite3.c"
    $16 = ($15|0)==(0|0); //@line 123683 "c/sqlite3.c"
    if (!($16)) {
     $17 = ((($$017)) + 4|0); //@line 123684 "c/sqlite3.c"
     $18 = HEAP32[$17>>2]|0; //@line 123684 "c/sqlite3.c"
     $19 = HEAP32[$5>>2]|0; //@line 123684 "c/sqlite3.c"
     $20 = (_sqlite3_stricmp($18,$19)|0); //@line 123684 "c/sqlite3.c"
     $21 = ($20|0)==(0); //@line 123684 "c/sqlite3.c"
     if ($21) {
      $22 = HEAP32[$6>>2]|0; //@line 123685 "c/sqlite3.c"
      $23 = (_sqlite3_stricmp($15,$22)|0); //@line 123685 "c/sqlite3.c"
      $24 = ($23|0)==(0); //@line 123685 "c/sqlite3.c"
      if ($24) {
       $25 = HEAP32[$3>>2]|0; //@line 123687 "c/sqlite3.c"
       $26 = ((($25)) + 32|0); //@line 123687 "c/sqlite3.c"
       $27 = HEAP32[$26>>2]|0; //@line 123687 "c/sqlite3.c"
       $28 = ((($8)) + 32|0); //@line 123687 "c/sqlite3.c"
       $29 = HEAP32[$28>>2]|0; //@line 123687 "c/sqlite3.c"
       $30 = (_sqlite3ExprCompare(0,$27,$29,-1)|0); //@line 123686 "c/sqlite3.c"
       $31 = ($30|0)==(0); //@line 123686 "c/sqlite3.c"
       if ($31) {
        $$016 = $$017;
        label = 10;
        break;
       }
      }
     }
    }
   }
  }
  $32 = ((($$017)) + 72|0); //@line 123680 "c/sqlite3.c"
  $33 = ($32>>>0)<($1>>>0); //@line 123680 "c/sqlite3.c"
  if ($33) {
   $$017 = $32;
  } else {
   $$016 = 0;
   label = 10;
   break;
  }
 }
 if ((label|0) == 10) {
  return ($$016|0); //@line 123696 "c/sqlite3.c"
 }
 return (0)|0;
}
function _keyInfoFromExprList($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$03233 = 0, $$034 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $exitcond = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 119787 "c/sqlite3.c"
 $5 = HEAP32[$1>>2]|0; //@line 119790 "c/sqlite3.c"
 $6 = (($5) - ($2))|0; //@line 119791 "c/sqlite3.c"
 $7 = (($3) + 1)|0; //@line 119791 "c/sqlite3.c"
 $8 = (_sqlite3KeyInfoAlloc($4,$6,$7)|0); //@line 119791 "c/sqlite3.c"
 $9 = ($8|0)!=(0|0); //@line 119792 "c/sqlite3.c"
 $10 = ($5|0)>($2|0); //@line 119794 "c/sqlite3.c"
 $or$cond = $9 & $10; //@line 119792 "c/sqlite3.c"
 if (!($or$cond)) {
  return ($8|0); //@line 119799 "c/sqlite3.c"
 }
 $11 = (((($1)) + 4|0) + (($2*20)|0)|0); //@line 119794 "c/sqlite3.c"
 $12 = ((($8)) + 16|0);
 $$03233 = $11;$$034 = $2;
 while(1) {
  $13 = HEAP32[$$03233>>2]|0; //@line 119795 "c/sqlite3.c"
  $14 = (_sqlite3ExprNNCollSeq($0,$13)|0); //@line 119795 "c/sqlite3.c"
  $15 = (($$034) - ($2))|0; //@line 119795 "c/sqlite3.c"
  $16 = (((($8)) + 20|0) + ($15<<2)|0); //@line 119795 "c/sqlite3.c"
  HEAP32[$16>>2] = $14; //@line 119795 "c/sqlite3.c"
  $17 = ((($$03233)) + 12|0); //@line 119796 "c/sqlite3.c"
  $18 = HEAP8[$17>>0]|0; //@line 119796 "c/sqlite3.c"
  $19 = HEAP32[$12>>2]|0; //@line 119796 "c/sqlite3.c"
  $20 = (($19) + ($15)|0); //@line 119796 "c/sqlite3.c"
  HEAP8[$20>>0] = $18; //@line 119796 "c/sqlite3.c"
  $21 = (($$034) + 1)|0; //@line 119794 "c/sqlite3.c"
  $22 = ((($$03233)) + 20|0); //@line 119794 "c/sqlite3.c"
  $exitcond = ($21|0)==($5|0); //@line 119794 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$03233 = $22;$$034 = $21;
  }
 }
 return ($8|0); //@line 119799 "c/sqlite3.c"
}
function _computeLimitRegisters($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($1)) + 56|0); //@line 120584 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 120584 "c/sqlite3.c"
 $6 = ((($1)) + 12|0); //@line 120586 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 120586 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 120586 "c/sqlite3.c"
 if (!($8)) {
  STACKTOP = sp;return; //@line 120626 "c/sqlite3.c"
 }
 _sqlite3ExprCacheClear($0); //@line 120594 "c/sqlite3.c"
 $9 = ($5|0)==(0|0); //@line 120595 "c/sqlite3.c"
 if ($9) {
  STACKTOP = sp;return; //@line 120626 "c/sqlite3.c"
 }
 $10 = ((($0)) + 44|0); //@line 120598 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 120598 "c/sqlite3.c"
 $12 = (($11) + 1)|0; //@line 120598 "c/sqlite3.c"
 HEAP32[$10>>2] = $12; //@line 120598 "c/sqlite3.c"
 HEAP32[$6>>2] = $12; //@line 120598 "c/sqlite3.c"
 $13 = (_sqlite3GetVdbe($0)|0); //@line 120599 "c/sqlite3.c"
 $14 = ((($5)) + 12|0); //@line 120601 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 120601 "c/sqlite3.c"
 $16 = (_sqlite3ExprIsInteger($15,$3)|0); //@line 120601 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 120601 "c/sqlite3.c"
 do {
  if ($17) {
   $30 = HEAP32[$14>>2]|0; //@line 120611 "c/sqlite3.c"
   _sqlite3ExprCode($0,$30,$12); //@line 120611 "c/sqlite3.c"
   (_sqlite3VdbeAddOp1($13,17,$12)|0); //@line 120612 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($13,22,$12,$2)|0); //@line 120614 "c/sqlite3.c"
  } else {
   $18 = HEAP32[$3>>2]|0; //@line 120602 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($13,67,$18,$12)|0); //@line 120602 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 120604 "c/sqlite3.c"
   if ($19) {
    _sqlite3VdbeGoto($13,$2); //@line 120605 "c/sqlite3.c"
    break;
   }
   $20 = ($18|0)>(-1); //@line 120606 "c/sqlite3.c"
   if ($20) {
    $21 = ((($1)) + 6|0); //@line 120606 "c/sqlite3.c"
    $22 = HEAP16[$21>>1]|0; //@line 120606 "c/sqlite3.c"
    $23 = ($18|0)<(0); //@line 120606 "c/sqlite3.c"
    $24 = $23 << 31 >> 31; //@line 120606 "c/sqlite3.c"
    $25 = (_sqlite3LogEst($18,$24)|0); //@line 120606 "c/sqlite3.c"
    $26 = ($22<<16>>16)>($25<<16>>16); //@line 120606 "c/sqlite3.c"
    if ($26) {
     HEAP16[$21>>1] = $25; //@line 120607 "c/sqlite3.c"
     $27 = ((($1)) + 8|0); //@line 120608 "c/sqlite3.c"
     $28 = HEAP32[$27>>2]|0; //@line 120608 "c/sqlite3.c"
     $29 = $28 | 16384; //@line 120608 "c/sqlite3.c"
     HEAP32[$27>>2] = $29; //@line 120608 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $31 = ((($5)) + 16|0); //@line 120616 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 120616 "c/sqlite3.c"
 $33 = ($32|0)==(0|0); //@line 120616 "c/sqlite3.c"
 if ($33) {
  STACKTOP = sp;return; //@line 120626 "c/sqlite3.c"
 }
 $34 = HEAP32[$10>>2]|0; //@line 120617 "c/sqlite3.c"
 $35 = (($34) + 1)|0; //@line 120617 "c/sqlite3.c"
 $36 = ((($1)) + 16|0); //@line 120617 "c/sqlite3.c"
 HEAP32[$36>>2] = $35; //@line 120617 "c/sqlite3.c"
 $37 = (($34) + 2)|0; //@line 120618 "c/sqlite3.c"
 HEAP32[$10>>2] = $37; //@line 120618 "c/sqlite3.c"
 _sqlite3ExprCode($0,$32,$35); //@line 120619 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($13,17,$35)|0); //@line 120620 "c/sqlite3.c"
 $38 = (($34) + 2)|0; //@line 120622 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($13,148,$12,$38,$35)|0); //@line 120622 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 120626 "c/sqlite3.c"
}
function _sqlite3VdbeChangeOpcode($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3VdbeGetOp($0,$1)|0); //@line 73771 "c/sqlite3.c"
 HEAP8[$3>>0] = $2; //@line 73771 "c/sqlite3.c"
 return; //@line 73772 "c/sqlite3.c"
}
function _sqlite3WhereOutputRowCount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 72|0); //@line 132958 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 132958 "c/sqlite3.c"
 return ($2|0); //@line 132958 "c/sqlite3.c"
}
function _sqlite3WhereIsDistinct($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 51|0); //@line 132966 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 132966 "c/sqlite3.c"
 $3 = $2&255; //@line 132966 "c/sqlite3.c"
 return ($3|0); //@line 132966 "c/sqlite3.c"
}
function _sqlite3WhereIsOrdered($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 47|0); //@line 132974 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 132974 "c/sqlite3.c"
 $3 = $2 << 24 >> 24; //@line 132974 "c/sqlite3.c"
 return ($3|0); //@line 132974 "c/sqlite3.c"
}
function _sqlite3WhereOrderedInnerLoop($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 52|0); //@line 132986 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 132986 "c/sqlite3.c"
 $3 = $2&255; //@line 132986 "c/sqlite3.c"
 return ($3|0); //@line 132986 "c/sqlite3.c"
}
function _sqlite3WhereContinueLabel($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 32|0); //@line 132995 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 132995 "c/sqlite3.c"
 return ($2|0); //@line 132995 "c/sqlite3.c"
}
function _sqlite3WhereBreakLabel($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 36|0); //@line 133003 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 133003 "c/sqlite3.c"
 return ($2|0); //@line 133003 "c/sqlite3.c"
}
function _selectInnerLoop($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0 = 0, $$0336347 = 0, $$0337357 = 0, $$0338 = 0, $$0342 = 0, $$0344 = 0, $$1340 = 0, $$1343 = 0, $$1345 = 0, $$1360 = 0, $$2341 = 0, $$2341$ph = 0, $$2353 = 0, $$3352 = 0, $$sink365 = 0, $$sink366 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0;
 var $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0;
 var $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0;
 var $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0;
 var $99 = 0, $exitcond = 0, $exitcond363 = 0, $exitcond364 = 0, $or$cond = 0, $or$cond7 = 0, $spec$select = 0, $spec$select346 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = ((($0)) + 8|0); //@line 119364 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 119364 "c/sqlite3.c"
 $10 = HEAP8[$5>>0]|0; //@line 119367 "c/sqlite3.c"
 $11 = ((($5)) + 4|0); //@line 119368 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 119368 "c/sqlite3.c"
 $13 = ($4|0)==(0|0); //@line 119382 "c/sqlite3.c"
 if ($13) {
  $22 = 0;
 } else {
  $14 = ((($4)) + 1|0); //@line 119382 "c/sqlite3.c"
  $15 = HEAP8[$14>>0]|0; //@line 119382 "c/sqlite3.c"
  $16 = $15&255; //@line 119382 "c/sqlite3.c"
  $22 = $16;
 }
 $17 = ($3|0)==(0|0); //@line 119383 "c/sqlite3.c"
 if ($17) {
  $$0 = 0;
 } else {
  $18 = HEAP32[$3>>2]|0; //@line 119383 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 119383 "c/sqlite3.c"
  $spec$select = $19 ? 0 : $3; //@line 119383 "c/sqlite3.c"
  $$0 = $spec$select;
 }
 $20 = ($$0|0)!=(0|0); //@line 119384 "c/sqlite3.c"
 $21 = ($22|0)!=(0); //@line 119384 "c/sqlite3.c"
 $or$cond = $21 | $20; //@line 119384 "c/sqlite3.c"
 if (!($or$cond)) {
  $23 = ((($1)) + 16|0); //@line 119386 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 119386 "c/sqlite3.c"
  _codeOffset($9,$24,$6); //@line 119386 "c/sqlite3.c"
 }
 $25 = HEAP32[$1>>2]|0; //@line 119391 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 119391 "c/sqlite3.c"
 $27 = ((($5)) + 8|0); //@line 119393 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 119393 "c/sqlite3.c"
 $29 = ($28|0)==(0); //@line 119393 "c/sqlite3.c"
 if ($29) {
  if ($20) {
   $30 = HEAP32[$$0>>2]|0; //@line 119395 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 119395 "c/sqlite3.c"
   $32 = ((($$0)) + 28|0); //@line 119396 "c/sqlite3.c"
   $33 = HEAP8[$32>>0]|0; //@line 119396 "c/sqlite3.c"
   $34 = $33 & 1; //@line 119396 "c/sqlite3.c"
   $35 = $34 ^ 1; //@line 119396 "c/sqlite3.c"
   $36 = $35&255; //@line 119396 "c/sqlite3.c"
   $spec$select346 = (($31) + ($36))|0; //@line 119396 "c/sqlite3.c"
   $37 = ((($0)) + 44|0); //@line 119397 "c/sqlite3.c"
   $38 = HEAP32[$37>>2]|0; //@line 119397 "c/sqlite3.c"
   $39 = (($spec$select346) + ($38))|0; //@line 119397 "c/sqlite3.c"
   HEAP32[$37>>2] = $39; //@line 119397 "c/sqlite3.c"
   $$1340 = $spec$select346;
  } else {
   $$1340 = 0;
  }
  $40 = ((($0)) + 44|0); //@line 119399 "c/sqlite3.c"
  $41 = HEAP32[$40>>2]|0; //@line 119399 "c/sqlite3.c"
  $42 = (($41) + 1)|0; //@line 119399 "c/sqlite3.c"
  HEAP32[$27>>2] = $42; //@line 119399 "c/sqlite3.c"
  $$2341$ph = $$1340;$$sink365 = $40;$$sink366 = $41;
  label = 12;
 } else {
  $43 = (($28) + ($26))|0; //@line 119401 "c/sqlite3.c"
  $44 = ((($0)) + 44|0); //@line 119401 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 119401 "c/sqlite3.c"
  $46 = ($43|0)>($45|0); //@line 119401 "c/sqlite3.c"
  if ($46) {
   $$2341$ph = 0;$$sink365 = $44;$$sink366 = $45;
   label = 12;
  } else {
   $$2341 = 0;
  }
 }
 if ((label|0) == 12) {
  $47 = (($$sink366) + ($26))|0;
  HEAP32[$$sink365>>2] = $47;
  $$2341 = $$2341$ph;
 }
 $48 = ((($5)) + 12|0); //@line 119409 "c/sqlite3.c"
 HEAP32[$48>>2] = $26; //@line 119409 "c/sqlite3.c"
 $49 = HEAP32[$27>>2]|0; //@line 119410 "c/sqlite3.c"
 $50 = ($2|0)>(-1); //@line 119411 "c/sqlite3.c"
 L19: do {
  if ($50) {
   $51 = ($26|0)>(0); //@line 119412 "c/sqlite3.c"
   if ($51) {
    $$0337357 = 0;
    while(1) {
     $52 = (($$0337357) + ($49))|0; //@line 119413 "c/sqlite3.c"
     (_sqlite3VdbeAddOp3($9,98,$2,$$0337357,$52)|0); //@line 119413 "c/sqlite3.c"
     $53 = (($$0337357) + 1)|0; //@line 119412 "c/sqlite3.c"
     $exitcond364 = ($53|0)==($26|0); //@line 119412 "c/sqlite3.c"
     if ($exitcond364) {
      $$0338 = $26;$$1343 = $49;
      break;
     } else {
      $$0337357 = $53;
     }
    }
   } else {
    $$0338 = $26;$$1343 = $49;
   }
  } else {
   switch ($10<<24>>24) {
   case 3:  {
    $$0338 = $26;$$1343 = $49;
    break L19;
    break;
   }
   case 9: case 10: case 13:  {
    $$0344 = 1;
    break;
   }
   default: {
    $$0344 = 0;
   }
   }
   $54 = ($22|0)==(0); //@line 119426 "c/sqlite3.c"
   $or$cond7 = $54 & $20; //@line 119426 "c/sqlite3.c"
   $55 = $10 | 2; //@line 119426 "c/sqlite3.c"
   $56 = ($55<<24>>24)!=(14); //@line 119426 "c/sqlite3.c"
   $57 = $56 & $or$cond7; //@line 119426 "c/sqlite3.c"
   if ($57) {
    $58 = $$0344 | 12; //@line 119433 "c/sqlite3.c"
    $59 = ((($$0)) + 4|0); //@line 119434 "c/sqlite3.c"
    $60 = HEAP32[$59>>2]|0; //@line 119434 "c/sqlite3.c"
    $61 = HEAP32[$$0>>2]|0; //@line 119434 "c/sqlite3.c"
    $62 = HEAP32[$61>>2]|0; //@line 119434 "c/sqlite3.c"
    $63 = ($60|0)<($62|0); //@line 119434 "c/sqlite3.c"
    if ($63) {
     $$1360 = $60;$65 = $61;
     while(1) {
      $64 = (((((($65)) + 4|0) + (($$1360*20)|0)|0)) + 16|0); //@line 119436 "c/sqlite3.c"
      $66 = HEAP16[$64>>1]|0; //@line 119436 "c/sqlite3.c"
      $67 = ($66<<16>>16)==(0); //@line 119436 "c/sqlite3.c"
      if (!($67)) {
       $68 = $66&65535; //@line 119436 "c/sqlite3.c"
       $69 = (($$1360) + 1)|0; //@line 119437 "c/sqlite3.c"
       $70 = HEAP32[$59>>2]|0; //@line 119437 "c/sqlite3.c"
       $71 = (($69) - ($70))|0; //@line 119437 "c/sqlite3.c"
       $72 = $71&65535; //@line 119437 "c/sqlite3.c"
       $73 = HEAP32[$1>>2]|0; //@line 119437 "c/sqlite3.c"
       $74 = (($68) + -1)|0; //@line 119437 "c/sqlite3.c"
       $75 = (((((($73)) + 4|0) + (($74*20)|0)|0)) + 16|0); //@line 119437 "c/sqlite3.c"
       HEAP16[$75>>1] = $72; //@line 119437 "c/sqlite3.c"
      }
      $76 = (($$1360) + 1)|0; //@line 119434 "c/sqlite3.c"
      $77 = HEAP32[$$0>>2]|0; //@line 119434 "c/sqlite3.c"
      $78 = HEAP32[$77>>2]|0; //@line 119434 "c/sqlite3.c"
      $79 = ($76|0)<($78|0); //@line 119434 "c/sqlite3.c"
      if ($79) {
       $$1360 = $76;$65 = $77;
      } else {
       $$0342 = 0;$$1345 = $58;
       break;
      }
     }
    } else {
     $$0342 = 0;$$1345 = $58;
    }
   } else {
    $$0342 = $49;$$1345 = $$0344;
   }
   $80 = HEAP32[$1>>2]|0; //@line 119444 "c/sqlite3.c"
   $81 = (_sqlite3ExprCodeExprList($0,$80,$49,0,$$1345)|0); //@line 119444 "c/sqlite3.c"
   $$0338 = $81;$$1343 = $$0342;
  }
 } while(0);
 if ($21) {
  $82 = ((($4)) + 1|0); //@line 119453 "c/sqlite3.c"
  $83 = HEAP8[$82>>0]|0; //@line 119453 "c/sqlite3.c"
  switch ($83<<24>>24) {
  case 2:  {
   $84 = ((($0)) + 44|0); //@line 119460 "c/sqlite3.c"
   $85 = HEAP32[$84>>2]|0; //@line 119460 "c/sqlite3.c"
   $86 = (($85) + 1)|0; //@line 119460 "c/sqlite3.c"
   $87 = (($85) + ($$0338))|0; //@line 119461 "c/sqlite3.c"
   HEAP32[$84>>2] = $87; //@line 119461 "c/sqlite3.c"
   $88 = ((($4)) + 8|0); //@line 119469 "c/sqlite3.c"
   $89 = HEAP32[$88>>2]|0; //@line 119469 "c/sqlite3.c"
   (_sqlite3VdbeChangeToNoop($9,$89)|0); //@line 119469 "c/sqlite3.c"
   $90 = HEAP32[$88>>2]|0; //@line 119470 "c/sqlite3.c"
   $91 = (_sqlite3VdbeGetOp($9,$90)|0); //@line 119470 "c/sqlite3.c"
   HEAP8[$91>>0] = 70; //@line 119471 "c/sqlite3.c"
   $92 = ((($91)) + 4|0); //@line 119472 "c/sqlite3.c"
   HEAP32[$92>>2] = 1; //@line 119472 "c/sqlite3.c"
   $93 = ((($91)) + 8|0); //@line 119473 "c/sqlite3.c"
   HEAP32[$93>>2] = $86; //@line 119473 "c/sqlite3.c"
   $94 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 119475 "c/sqlite3.c"
   $95 = (($94) + ($$0338))|0; //@line 119475 "c/sqlite3.c"
   $96 = ($$0338|0)>(0); //@line 119476 "c/sqlite3.c"
   if ($96) {
    $97 = (($$0338) + -1)|0;
    $$2353 = 0;
    while(1) {
     $98 = HEAP32[$1>>2]|0; //@line 119477 "c/sqlite3.c"
     $99 = (((($98)) + 4|0) + (($$2353*20)|0)|0); //@line 119477 "c/sqlite3.c"
     $100 = HEAP32[$99>>2]|0; //@line 119477 "c/sqlite3.c"
     $101 = (_sqlite3ExprCollSeq($0,$100)|0); //@line 119477 "c/sqlite3.c"
     $102 = ($$2353|0)<($97|0); //@line 119478 "c/sqlite3.c"
     $103 = (($$2353) + ($49))|0;
     $104 = (($$2353) + ($86))|0;
     if ($102) {
      (_sqlite3VdbeAddOp3($9,52,$103,$95,$104)|0); //@line 119479 "c/sqlite3.c"
     } else {
      (_sqlite3VdbeAddOp3($9,53,$103,$6,$104)|0); //@line 119482 "c/sqlite3.c"
     }
     _sqlite3VdbeChangeP4($9,-1,$101,-2); //@line 119485 "c/sqlite3.c"
     _sqlite3VdbeChangeP5($9,128); //@line 119486 "c/sqlite3.c"
     $105 = (($$2353) + 1)|0; //@line 119476 "c/sqlite3.c"
     $exitcond363 = ($105|0)==($$0338|0); //@line 119476 "c/sqlite3.c"
     if ($exitcond363) {
      break;
     } else {
      $$2353 = $105;
     }
    }
   }
   $106 = (($$0338) + -1)|0; //@line 119489 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($9,75,$49,$86,$106)|0); //@line 119489 "c/sqlite3.c"
   break;
  }
  case 1:  {
   $107 = ((($4)) + 8|0); //@line 119494 "c/sqlite3.c"
   $108 = HEAP32[$107>>2]|0; //@line 119494 "c/sqlite3.c"
   (_sqlite3VdbeChangeToNoop($9,$108)|0); //@line 119494 "c/sqlite3.c"
   break;
  }
  default: {
   $109 = ((($4)) + 4|0); //@line 119500 "c/sqlite3.c"
   $110 = HEAP32[$109>>2]|0; //@line 119500 "c/sqlite3.c"
   _codeDistinct($0,$110,$6,$$0338,$49); //@line 119500 "c/sqlite3.c"
  }
  }
  $111 = ($$0|0)==(0|0); //@line 119505 "c/sqlite3.c"
  if ($111) {
   $112 = ((($1)) + 16|0); //@line 119506 "c/sqlite3.c"
   $113 = HEAP32[$112>>2]|0; //@line 119506 "c/sqlite3.c"
   _codeOffset($9,$113,$6); //@line 119506 "c/sqlite3.c"
  }
 }
 L56: do {
  switch ($10<<24>>24) {
  case 1:  {
   $114 = (_sqlite3GetTempReg($0)|0); //@line 119517 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($9,100,$49,$$0338,$114)|0); //@line 119518 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4Int($9,128,$12,$114,$49,$$0338)|0); //@line 119519 "c/sqlite3.c"
   _sqlite3ReleaseTempReg($0,$114); //@line 119520 "c/sqlite3.c"
   label = 68;
   break;
  }
  case 2:  {
   (_sqlite3VdbeAddOp3($9,129,$12,$49,$$0338)|0); //@line 119529 "c/sqlite3.c"
   label = 68;
   break;
  }
  case 12: case 14: case 6: case 5:  {
   $115 = (($$2341) + 1)|0; //@line 119540 "c/sqlite3.c"
   $116 = (_sqlite3GetTempRange($0,$115)|0); //@line 119540 "c/sqlite3.c"
   $117 = (($116) + ($$2341))|0; //@line 119545 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($9,100,$49,$$0338,$117)|0); //@line 119545 "c/sqlite3.c"
   $118 = ($10<<24>>24)==(6); //@line 119547 "c/sqlite3.c"
   $119 = (($12) + 1)|0; //@line 119554 "c/sqlite3.c"
   if ($118) {
    $120 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 119553 "c/sqlite3.c"
    $121 = (($120) + 4)|0; //@line 119553 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4Int($9,30,$119,$121,$116,0)|0); //@line 119554 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4Int($9,128,$119,$116,$49,$$0338)|0); //@line 119556 "c/sqlite3.c"
   }
   if ($20) {
    _pushOntoSorter($0,$$0,$1,$117,$49,1,$$2341); //@line 119561 "c/sqlite3.c"
   } else {
    $122 = (_sqlite3GetTempReg($0)|0); //@line 119563 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($9,116,$12,$122)|0); //@line 119564 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($9,117,$12,$116,$122)|0); //@line 119565 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($9,8); //@line 119566 "c/sqlite3.c"
    _sqlite3ReleaseTempReg($0,$122); //@line 119567 "c/sqlite3.c"
   }
   _sqlite3ReleaseTempRange($0,$116,$115); //@line 119569 "c/sqlite3.c"
   label = 68;
   break;
  }
  case 11:  {
   if (!($20)) {
    $123 = (_sqlite3GetTempReg($0)|0); //@line 119587 "c/sqlite3.c"
    $124 = ((($5)) + 16|0); //@line 119590 "c/sqlite3.c"
    $125 = HEAP32[$124>>2]|0; //@line 119590 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4($9,100,$49,$$0338,$123,$125,$$0338)|0); //@line 119589 "c/sqlite3.c"
    _sqlite3ExprCacheAffinityChange($0,$49,$$0338); //@line 119591 "c/sqlite3.c"
    (_sqlite3VdbeAddOp4Int($9,128,$12,$123,$49,$$0338)|0); //@line 119592 "c/sqlite3.c"
    _sqlite3ReleaseTempReg($0,$123); //@line 119593 "c/sqlite3.c"
    break L56;
   }
   _pushOntoSorter($0,$$0,$1,$49,$$1343,$$0338,$$2341); //@line 119584 "c/sqlite3.c"
   return; //@line 119709 "c/sqlite3.c"
   break;
  }
  case 3:  {
   (_sqlite3VdbeAddOp2($9,67,1,$12)|0); //@line 119601 "c/sqlite3.c"
   label = 68;
   break;
  }
  case 10:  {
   if ($20) {
    _pushOntoSorter($0,$$0,$1,$49,$$1343,$$0338,$$2341); //@line 119613 "c/sqlite3.c"
    return; //@line 119709 "c/sqlite3.c"
   }
   break;
  }
  case 9: case 13:  {
   if ($20) {
    _pushOntoSorter($0,$$0,$1,$49,$$1343,$$0338,$$2341); //@line 119629 "c/sqlite3.c"
    return; //@line 119709 "c/sqlite3.c"
   }
   $126 = ($10<<24>>24)==(13); //@line 119631 "c/sqlite3.c"
   if ($126) {
    $127 = HEAP32[$11>>2]|0; //@line 119632 "c/sqlite3.c"
    (_sqlite3VdbeAddOp1($9,16,$127)|0); //@line 119632 "c/sqlite3.c"
    break L56;
   } else {
    (_sqlite3VdbeAddOp2($9,78,$49,$$0338)|0); //@line 119634 "c/sqlite3.c"
    _sqlite3ExprCacheAffinityChange($0,$49,$$0338); //@line 119635 "c/sqlite3.c"
    break L56;
   }
   break;
  }
  case 7: case 8:  {
   $128 = ((($5)) + 20|0); //@line 119653 "c/sqlite3.c"
   $129 = HEAP32[$128>>2]|0; //@line 119653 "c/sqlite3.c"
   $130 = HEAP32[$129>>2]|0; //@line 119655 "c/sqlite3.c"
   $131 = (_sqlite3GetTempReg($0)|0); //@line 119656 "c/sqlite3.c"
   $132 = (($130) + 2)|0; //@line 119657 "c/sqlite3.c"
   $133 = (_sqlite3GetTempRange($0,$132)|0); //@line 119657 "c/sqlite3.c"
   $134 = (($133) + ($130))|0; //@line 119658 "c/sqlite3.c"
   $135 = (($134) + 1)|0; //@line 119658 "c/sqlite3.c"
   $136 = ($10<<24>>24)==(8); //@line 119659 "c/sqlite3.c"
   if ($136) {
    $137 = (($12) + 1)|0; //@line 119663 "c/sqlite3.c"
    $138 = (_sqlite3VdbeAddOp4Int($9,30,$137,0,$49,$$0338)|0); //@line 119663 "c/sqlite3.c"
    (_sqlite3VdbeAddOp3($9,100,$49,$$0338,$135)|0); //@line 119667 "c/sqlite3.c"
    $139 = (($12) + 1)|0; //@line 119669 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($9,128,$139,$135)|0); //@line 119669 "c/sqlite3.c"
    _sqlite3VdbeChangeP5($9,16); //@line 119670 "c/sqlite3.c"
    $$0336347 = $138;
   } else {
    (_sqlite3VdbeAddOp3($9,100,$49,$$0338,$135)|0); //@line 119667 "c/sqlite3.c"
    $$0336347 = 0;
   }
   $140 = ($130|0)>(0); //@line 119672 "c/sqlite3.c"
   if ($140) {
    $141 = (($49) + -1)|0;
    $$3352 = 0;
    while(1) {
     $142 = (((((($129)) + 4|0) + (($$3352*20)|0)|0)) + 16|0); //@line 119674 "c/sqlite3.c"
     $143 = HEAP16[$142>>1]|0; //@line 119674 "c/sqlite3.c"
     $144 = $143&65535; //@line 119674 "c/sqlite3.c"
     $145 = (($141) + ($144))|0; //@line 119674 "c/sqlite3.c"
     $146 = (($$3352) + ($133))|0; //@line 119675 "c/sqlite3.c"
     (_sqlite3VdbeAddOp2($9,76,$145,$146)|0); //@line 119673 "c/sqlite3.c"
     $147 = (($$3352) + 1)|0; //@line 119672 "c/sqlite3.c"
     $exitcond = ($147|0)==($130|0); //@line 119672 "c/sqlite3.c"
     if ($exitcond) {
      break;
     } else {
      $$3352 = $147;
     }
    }
   }
   (_sqlite3VdbeAddOp2($9,115,$12,$134)|0); //@line 119677 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($9,100,$133,$132,$131)|0); //@line 119678 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4Int($9,128,$12,$131,$133,$132)|0); //@line 119679 "c/sqlite3.c"
   $148 = ($$0336347|0)==(0); //@line 119680 "c/sqlite3.c"
   if (!($148)) {
    _sqlite3VdbeJumpHere($9,$$0336347); //@line 119680 "c/sqlite3.c"
   }
   _sqlite3ReleaseTempReg($0,$131); //@line 119681 "c/sqlite3.c"
   _sqlite3ReleaseTempRange($0,$133,$132); //@line 119682 "c/sqlite3.c"
   label = 68;
   break;
  }
  default: {
   label = 68;
  }
  }
 } while(0);
 if ((label|0) == 68) {
  $149 = ($$0|0)==(0|0); //@line 119706 "c/sqlite3.c"
  if (!($149)) {
   return; //@line 119709 "c/sqlite3.c"
  }
 }
 $150 = ((($1)) + 12|0); //@line 119706 "c/sqlite3.c"
 $151 = HEAP32[$150>>2]|0; //@line 119706 "c/sqlite3.c"
 $152 = ($151|0)==(0); //@line 119706 "c/sqlite3.c"
 if ($152) {
  return; //@line 119709 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($9,59,$151,$7)|0); //@line 119707 "c/sqlite3.c"
 return; //@line 119709 "c/sqlite3.c"
}
function _sqlite3ExprAnalyzeAggList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01011 = 0, $$012 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 97918 "c/sqlite3.c"
 if ($2) {
  return; //@line 97923 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 97919 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 97919 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 97923 "c/sqlite3.c"
 }
 $5 = ((($1)) + 4|0); //@line 97919 "c/sqlite3.c"
 $$01011 = $5;$$012 = 0;
 while(1) {
  $6 = HEAP32[$$01011>>2]|0; //@line 97920 "c/sqlite3.c"
  _sqlite3ExprAnalyzeAggregates($0,$6); //@line 97920 "c/sqlite3.c"
  $7 = (($$012) + 1)|0; //@line 97919 "c/sqlite3.c"
  $8 = ((($$01011)) + 20|0); //@line 97919 "c/sqlite3.c"
  $9 = HEAP32[$1>>2]|0; //@line 97919 "c/sqlite3.c"
  $10 = ($7|0)<($9|0); //@line 97919 "c/sqlite3.c"
  if ($10) {
   $$01011 = $8;$$012 = $7;
  } else {
   break;
  }
 }
 return; //@line 97923 "c/sqlite3.c"
}
function _havingToWhere($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp + 32|0;
 $5 = sp;
 HEAP32[$4>>2] = $3; //@line 123660 "c/sqlite3.c"
 $6 = ((($4)) + 4|0); //@line 123661 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 123661 "c/sqlite3.c"
 $7 = ((($5)) + 8|0);
 ;HEAP32[$7>>2]=0|0;HEAP32[$7+4>>2]=0|0;HEAP32[$7+8>>2]=0|0;HEAP32[$7+12>>2]=0|0; //@line 123663 "c/sqlite3.c"
 HEAP32[$5>>2] = $0; //@line 123664 "c/sqlite3.c"
 $8 = ((($5)) + 4|0); //@line 123665 "c/sqlite3.c"
 HEAP32[$8>>2] = 166; //@line 123665 "c/sqlite3.c"
 $9 = ((($5)) + 24|0); //@line 123666 "c/sqlite3.c"
 HEAP32[$9>>2] = $4; //@line 123666 "c/sqlite3.c"
 (_sqlite3WalkExpr($5,$2)|0); //@line 123667 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 123668 "c/sqlite3.c"
}
function _sqlite3ExprAnalyzeAggregates($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = ((($2)) + 4|0); //@line 97900 "c/sqlite3.c"
 HEAP32[$3>>2] = 167; //@line 97900 "c/sqlite3.c"
 $4 = ((($2)) + 8|0); //@line 97901 "c/sqlite3.c"
 HEAP32[$4>>2] = 168; //@line 97901 "c/sqlite3.c"
 $5 = ((($2)) + 12|0); //@line 97902 "c/sqlite3.c"
 HEAP32[$5>>2] = 76; //@line 97902 "c/sqlite3.c"
 $6 = ((($2)) + 16|0); //@line 97903 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 97903 "c/sqlite3.c"
 $7 = ((($2)) + 24|0); //@line 97904 "c/sqlite3.c"
 HEAP32[$7>>2] = $0; //@line 97904 "c/sqlite3.c"
 (_sqlite3WalkExpr($2,$1)|0); //@line 97906 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 97907 "c/sqlite3.c"
}
function _minMaxQuery($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$022 = 0, $$023 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 20|0); //@line 122604 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 122604 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 122611 "c/sqlite3.c"
 do {
  if ($5) {
   $$022 = 0;
  } else {
   $6 = HEAP32[$4>>2]|0; //@line 122611 "c/sqlite3.c"
   $7 = ($6|0)==(1); //@line 122611 "c/sqlite3.c"
   if ($7) {
    $8 = ((($1)) + 8|0); //@line 122612 "c/sqlite3.c"
    $9 = HEAP32[$8>>2]|0; //@line 122612 "c/sqlite3.c"
    $10 = (_sqlite3StrICmp($9,16728)|0); //@line 122613 "c/sqlite3.c"
    $11 = ($10|0)==(0); //@line 122613 "c/sqlite3.c"
    if ($11) {
     $$0 = 0;$$023 = 1;
    } else {
     $12 = (_sqlite3StrICmp($9,16732)|0); //@line 122616 "c/sqlite3.c"
     $13 = ($12|0)==(0); //@line 122616 "c/sqlite3.c"
     if ($13) {
      $$0 = 1;$$023 = 2;
     } else {
      $$022 = 0;
      break;
     }
    }
    $14 = (_sqlite3ExprListDup($0,$4,0)|0); //@line 122622 "c/sqlite3.c"
    HEAP32[$2>>2] = $14; //@line 122622 "c/sqlite3.c"
    $15 = ($14|0)==(0|0); //@line 122624 "c/sqlite3.c"
    if ($15) {
     $$022 = $$023;
    } else {
     $16 = ((($14)) + 16|0); //@line 122624 "c/sqlite3.c"
     HEAP8[$16>>0] = $$0; //@line 122624 "c/sqlite3.c"
     $$022 = $$023;
    }
   } else {
    $$022 = 0;
   }
  }
 } while(0);
 return ($$022|0); //@line 122626 "c/sqlite3.c"
}
function _explainTempTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 119827 "c/sqlite3.c"
 $2 = ((($0)) + 399|0); //@line 119828 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 119828 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(2); //@line 119828 "c/sqlite3.c"
 if (!($4)) {
  STACKTOP = sp;return; //@line 119833 "c/sqlite3.c"
 }
 $5 = ((($0)) + 8|0); //@line 119829 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 119829 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 119830 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $1; //@line 119830 "c/sqlite3.c"
 $8 = (_sqlite3MPrintf($7,28553,$vararg_buffer)|0); //@line 119830 "c/sqlite3.c"
 $9 = ((($0)) + 412|0); //@line 119831 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 119831 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($6,169,$10,0,0,$8,-7)|0); //@line 119831 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 119833 "c/sqlite3.c"
}
function _sqlite3WhereIsSorted($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 48|0); //@line 136739 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 136739 "c/sqlite3.c"
 $3 = $2&255; //@line 136739 "c/sqlite3.c"
 return ($3|0); //@line 136739 "c/sqlite3.c"
}
function _sqlite3ExprCodeMove($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 8|0); //@line 96095 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 96095 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($5,74,$1,$2,$3)|0); //@line 96095 "c/sqlite3.c"
 _sqlite3ExprCacheRemove($0,$1,$3); //@line 96096 "c/sqlite3.c"
 return; //@line 96097 "c/sqlite3.c"
}
function _updateAccumulator($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0100 = 0, $$0101 = 0, $$0102 = 0, $$0103108 = 0, $$0104117 = 0, $$0105 = 0, $$0106116 = 0, $$0112 = 0, $$096111 = 0, $$098118 = 0, $$1 = 0, $$1107 = 0, $$199109 = 0, $$2 = 0, $$not = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 123496 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 123496 "c/sqlite3.c"
 HEAP8[$1>>0] = 1; //@line 123503 "c/sqlite3.c"
 $4 = ((($1)) + 44|0); //@line 123504 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 123504 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 123504 "c/sqlite3.c"
 if ($6) {
  $7 = ((($1)) + 40|0); //@line 123504 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 123504 "c/sqlite3.c"
  $9 = ((($1)) + 36|0);
  $10 = ((($0)) + 44|0);
  $$0104117 = $8;$$0106116 = 0;$$098118 = 0;
  while(1) {
   $11 = HEAP32[$$0104117>>2]|0; //@line 123508 "c/sqlite3.c"
   $12 = ((($11)) + 20|0); //@line 123508 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 123508 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 123510 "c/sqlite3.c"
   if ($14) {
    $$0100 = 0;$$0102 = 0;
   } else {
    $15 = HEAP32[$13>>2]|0; //@line 123511 "c/sqlite3.c"
    $16 = (_sqlite3GetTempRange($0,$15)|0); //@line 123512 "c/sqlite3.c"
    (_sqlite3ExprCodeExprList($0,$13,$16,0,1)|0); //@line 123513 "c/sqlite3.c"
    $$0100 = $16;$$0102 = $15;
   }
   $17 = ((($$0104117)) + 12|0); //@line 123518 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 123518 "c/sqlite3.c"
   $19 = ($18|0)>(-1); //@line 123518 "c/sqlite3.c"
   if ($19) {
    $20 = (_sqlite3VdbeMakeLabel($3)|0); //@line 123519 "c/sqlite3.c"
    $21 = HEAP32[$17>>2]|0; //@line 123522 "c/sqlite3.c"
    _codeDistinct($0,$21,$20,1,$$0100); //@line 123522 "c/sqlite3.c"
    $$0101 = $20;
   } else {
    $$0101 = 0;
   }
   $22 = ((($$0104117)) + 4|0); //@line 123524 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 123524 "c/sqlite3.c"
   $24 = ((($23)) + 2|0); //@line 123524 "c/sqlite3.c"
   $25 = HEAP16[$24>>1]|0; //@line 123524 "c/sqlite3.c"
   $26 = $25 & 32; //@line 123524 "c/sqlite3.c"
   $27 = ($26<<16>>16)==(0); //@line 123524 "c/sqlite3.c"
   if ($27) {
    $$2 = $$0106116;
   } else {
    $28 = ($$0102|0)>(0); //@line 123529 "c/sqlite3.c"
    if ($28) {
     $29 = ((($13)) + 4|0); //@line 123529 "c/sqlite3.c"
     $$0112 = 0;$$096111 = $29;
     while(1) {
      $30 = HEAP32[$$096111>>2]|0; //@line 123530 "c/sqlite3.c"
      $31 = (_sqlite3ExprCollSeq($0,$30)|0); //@line 123530 "c/sqlite3.c"
      $32 = (($$0112) + 1)|0; //@line 123529 "c/sqlite3.c"
      $33 = ((($$096111)) + 20|0); //@line 123529 "c/sqlite3.c"
      $34 = ($31|0)!=(0|0); //@line 123529 "c/sqlite3.c"
      $$not = $34 ^ 1; //@line 123529 "c/sqlite3.c"
      $35 = ($32|0)<($$0102|0); //@line 123529 "c/sqlite3.c"
      $or$cond = $35 & $$not; //@line 123529 "c/sqlite3.c"
      if ($or$cond) {
       $$0112 = $32;$$096111 = $33;
      } else {
       break;
      }
     }
     if ($34) {
      $$1 = $31;
     } else {
      label = 12;
     }
    } else {
     label = 12;
    }
    if ((label|0) == 12) {
     label = 0;
     $36 = HEAP32[$0>>2]|0; //@line 123533 "c/sqlite3.c"
     $37 = ((($36)) + 8|0); //@line 123533 "c/sqlite3.c"
     $38 = HEAP32[$37>>2]|0; //@line 123533 "c/sqlite3.c"
     $$1 = $38;
    }
    $39 = ($$0106116|0)==(0); //@line 123535 "c/sqlite3.c"
    if ($39) {
     $40 = HEAP32[$9>>2]|0; //@line 123535 "c/sqlite3.c"
     $41 = ($40|0)==(0); //@line 123535 "c/sqlite3.c"
     if ($41) {
      $$1107 = 0;
     } else {
      $42 = HEAP32[$10>>2]|0; //@line 123535 "c/sqlite3.c"
      $43 = (($42) + 1)|0; //@line 123535 "c/sqlite3.c"
      HEAP32[$10>>2] = $43; //@line 123535 "c/sqlite3.c"
      $$1107 = $43;
     }
    } else {
     $$1107 = $$0106116;
    }
    (_sqlite3VdbeAddOp4($3,79,$$1107,0,0,$$1,-2)|0); //@line 123536 "c/sqlite3.c"
    $$2 = $$1107;
   }
   $44 = ((($$0104117)) + 8|0); //@line 123538 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 123538 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($3,149,0,$$0100,$45)|0); //@line 123538 "c/sqlite3.c"
   $46 = HEAP32[$22>>2]|0; //@line 123539 "c/sqlite3.c"
   _sqlite3VdbeAppendP4($3,$46,-8); //@line 123539 "c/sqlite3.c"
   $47 = $$0102&65535; //@line 123540 "c/sqlite3.c"
   $48 = $47 & 255; //@line 123540 "c/sqlite3.c"
   _sqlite3VdbeChangeP5($3,$48); //@line 123540 "c/sqlite3.c"
   _sqlite3ExprCacheAffinityChange($0,$$0100,$$0102); //@line 123541 "c/sqlite3.c"
   _sqlite3ReleaseTempRange($0,$$0100,$$0102); //@line 123542 "c/sqlite3.c"
   $49 = ($$0101|0)==(0); //@line 123543 "c/sqlite3.c"
   if (!($49)) {
    _sqlite3VdbeResolveLabel($3,$$0101); //@line 123544 "c/sqlite3.c"
    _sqlite3ExprCacheClear($0); //@line 123545 "c/sqlite3.c"
   }
   $50 = (($$098118) + 1)|0; //@line 123504 "c/sqlite3.c"
   $51 = ((($$0104117)) + 16|0); //@line 123504 "c/sqlite3.c"
   $52 = HEAP32[$4>>2]|0; //@line 123504 "c/sqlite3.c"
   $53 = ($50|0)<($52|0); //@line 123504 "c/sqlite3.c"
   if ($53) {
    $$0104117 = $51;$$0106116 = $$2;$$098118 = $50;
   } else {
    break;
   }
  }
  $54 = ($$2|0)==(0); //@line 123559 "c/sqlite3.c"
  if ($54) {
   $$0105 = 0;
  } else {
   $55 = (_sqlite3VdbeAddOp1($3,21,$$2)|0); //@line 123560 "c/sqlite3.c"
   $$0105 = $55;
  }
 } else {
  $$0105 = 0;
 }
 _sqlite3ExprCacheClear($0); //@line 123562 "c/sqlite3.c"
 $56 = ((($1)) + 36|0); //@line 123563 "c/sqlite3.c"
 $57 = HEAP32[$56>>2]|0; //@line 123563 "c/sqlite3.c"
 $58 = ($57|0)>(0); //@line 123563 "c/sqlite3.c"
 if ($58) {
  $59 = ((($1)) + 28|0); //@line 123563 "c/sqlite3.c"
  $60 = HEAP32[$59>>2]|0; //@line 123563 "c/sqlite3.c"
  $$0103108 = $60;$$199109 = 0;
  while(1) {
   $61 = ((($$0103108)) + 20|0); //@line 123564 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 123564 "c/sqlite3.c"
   $63 = ((($$0103108)) + 16|0); //@line 123564 "c/sqlite3.c"
   $64 = HEAP32[$63>>2]|0; //@line 123564 "c/sqlite3.c"
   _sqlite3ExprCode($0,$62,$64); //@line 123564 "c/sqlite3.c"
   $65 = (($$199109) + 1)|0; //@line 123563 "c/sqlite3.c"
   $66 = ((($$0103108)) + 24|0); //@line 123563 "c/sqlite3.c"
   $67 = HEAP32[$56>>2]|0; //@line 123563 "c/sqlite3.c"
   $68 = ($65|0)<($67|0); //@line 123563 "c/sqlite3.c"
   if ($68) {
    $$0103108 = $66;$$199109 = $65;
   } else {
    break;
   }
  }
 }
 HEAP8[$1>>0] = 0; //@line 123566 "c/sqlite3.c"
 _sqlite3ExprCacheClear($0); //@line 123567 "c/sqlite3.c"
 $69 = ($$0105|0)==(0); //@line 123568 "c/sqlite3.c"
 if ($69) {
  return; //@line 123571 "c/sqlite3.c"
 }
 _sqlite3VdbeJumpHere($3,$$0105); //@line 123569 "c/sqlite3.c"
 return; //@line 123571 "c/sqlite3.c"
}
function _finalizeAggFunctions($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01920 = 0, $$021 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 123480 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 123480 "c/sqlite3.c"
 $4 = ((($1)) + 44|0); //@line 123483 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 123483 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 123483 "c/sqlite3.c"
 if (!($6)) {
  return; //@line 123489 "c/sqlite3.c"
 }
 $7 = ((($1)) + 40|0); //@line 123483 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 123483 "c/sqlite3.c"
 $$01920 = $8;$$021 = 0;
 while(1) {
  $9 = HEAP32[$$01920>>2]|0; //@line 123484 "c/sqlite3.c"
  $10 = ((($9)) + 20|0); //@line 123484 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 123484 "c/sqlite3.c"
  $12 = ((($$01920)) + 8|0); //@line 123486 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 123486 "c/sqlite3.c"
  $14 = ($11|0)==(0|0); //@line 123486 "c/sqlite3.c"
  if ($14) {
   $16 = 0;
  } else {
   $15 = HEAP32[$11>>2]|0; //@line 123486 "c/sqlite3.c"
   $16 = $15;
  }
  (_sqlite3VdbeAddOp2($3,151,$13,$16)|0); //@line 123486 "c/sqlite3.c"
  $17 = ((($$01920)) + 4|0); //@line 123487 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 123487 "c/sqlite3.c"
  _sqlite3VdbeAppendP4($3,$18,-8); //@line 123487 "c/sqlite3.c"
  $19 = (($$021) + 1)|0; //@line 123483 "c/sqlite3.c"
  $20 = ((($$01920)) + 16|0); //@line 123483 "c/sqlite3.c"
  $21 = HEAP32[$4>>2]|0; //@line 123483 "c/sqlite3.c"
  $22 = ($19|0)<($21|0); //@line 123483 "c/sqlite3.c"
  if ($22) {
   $$01920 = $20;$$021 = $19;
  } else {
   break;
  }
 }
 return; //@line 123489 "c/sqlite3.c"
}
function _resetAccumulator($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$03334 = 0, $$035 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 123438 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 123439 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 123439 "c/sqlite3.c"
 $4 = ((($1)) + 44|0); //@line 123442 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 123442 "c/sqlite3.c"
 $6 = ((($1)) + 32|0); //@line 123442 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 123442 "c/sqlite3.c"
 $8 = (0 - ($7))|0; //@line 123443 "c/sqlite3.c"
 $9 = ($5|0)==($8|0); //@line 123443 "c/sqlite3.c"
 if ($9) {
  STACKTOP = sp;return; //@line 123473 "c/sqlite3.c"
 }
 $10 = ((($1)) + 16|0); //@line 123457 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 123457 "c/sqlite3.c"
 $12 = ((($1)) + 20|0); //@line 123457 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 123457 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($3,70,0,$11,$13)|0); //@line 123457 "c/sqlite3.c"
 $14 = HEAP32[$4>>2]|0; //@line 123458 "c/sqlite3.c"
 $15 = ($14|0)>(0); //@line 123458 "c/sqlite3.c"
 if (!($15)) {
  STACKTOP = sp;return; //@line 123473 "c/sqlite3.c"
 }
 $16 = ((($1)) + 40|0); //@line 123458 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 123458 "c/sqlite3.c"
 $$03334 = $17;$$035 = 0;
 while(1) {
  $18 = ((($$03334)) + 12|0); //@line 123459 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 123459 "c/sqlite3.c"
  $20 = ($19|0)>(-1); //@line 123459 "c/sqlite3.c"
  do {
   if ($20) {
    $21 = HEAP32[$$03334>>2]|0; //@line 123460 "c/sqlite3.c"
    $22 = ((($21)) + 20|0); //@line 123462 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 123462 "c/sqlite3.c"
    $24 = ($23|0)==(0|0); //@line 123462 "c/sqlite3.c"
    if (!($24)) {
     $25 = HEAP32[$23>>2]|0; //@line 123462 "c/sqlite3.c"
     $26 = ($25|0)==(1); //@line 123462 "c/sqlite3.c"
     if ($26) {
      $27 = (_keyInfoFromExprList($0,$23,0,0)|0); //@line 123467 "c/sqlite3.c"
      $28 = HEAP32[$18>>2]|0; //@line 123468 "c/sqlite3.c"
      (_sqlite3VdbeAddOp4($3,109,$28,0,0,$27,-9)|0); //@line 123468 "c/sqlite3.c"
      break;
     }
    }
    _sqlite3ErrorMsg($0,28502,$vararg_buffer); //@line 123463 "c/sqlite3.c"
    HEAP32[$18>>2] = -1; //@line 123465 "c/sqlite3.c"
   }
  } while(0);
  $29 = (($$035) + 1)|0; //@line 123458 "c/sqlite3.c"
  $30 = ((($$03334)) + 16|0); //@line 123458 "c/sqlite3.c"
  $31 = HEAP32[$4>>2]|0; //@line 123458 "c/sqlite3.c"
  $32 = ($29|0)<($31|0); //@line 123458 "c/sqlite3.c"
  if ($32) {
   $$03334 = $30;$$035 = $29;
  } else {
   break;
  }
 }
 STACKTOP = sp;return; //@line 123473 "c/sqlite3.c"
}
function _isSimpleCount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 32|0); //@line 122645 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 122645 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 122645 "c/sqlite3.c"
 if (!($4)) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 122645 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 122645 "c/sqlite3.c"
 $7 = ($6|0)==(1); //@line 122645 "c/sqlite3.c"
 if (!($7)) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $8 = ((($0)) + 28|0); //@line 122646 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 122646 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 122646 "c/sqlite3.c"
 $11 = ($10|0)==(1); //@line 122646 "c/sqlite3.c"
 if (!($11)) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $12 = ((($9)) + 28|0); //@line 122646 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 122646 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 122646 "c/sqlite3.c"
 if (!($14)) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $15 = ((($9)) + 24|0); //@line 122650 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 122650 "c/sqlite3.c"
 $17 = ((($5)) + 4|0); //@line 122651 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 122651 "c/sqlite3.c"
 $19 = ((($16)) + 56|0); //@line 122654 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 122654 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 122654 "c/sqlite3.c"
 if (!($21)) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $22 = HEAP8[$18>>0]|0; //@line 122655 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(-110); //@line 122655 "c/sqlite3.c"
 if (!($23)) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $24 = ((($1)) + 44|0); //@line 122656 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 122656 "c/sqlite3.c"
 $26 = ($25|0)==(0); //@line 122656 "c/sqlite3.c"
 if ($26) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $27 = ((($1)) + 40|0); //@line 122657 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 122657 "c/sqlite3.c"
 $29 = ((($28)) + 4|0); //@line 122657 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 122657 "c/sqlite3.c"
 $31 = ((($30)) + 2|0); //@line 122657 "c/sqlite3.c"
 $32 = HEAP16[$31>>1]|0; //@line 122657 "c/sqlite3.c"
 $33 = $32 & 256; //@line 122657 "c/sqlite3.c"
 $34 = ($33<<16>>16)==(0); //@line 122657 "c/sqlite3.c"
 if ($34) {
  $$0 = 0;
  return ($$0|0); //@line 122661 "c/sqlite3.c"
 }
 $35 = ((($18)) + 4|0); //@line 122658 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 122658 "c/sqlite3.c"
 $37 = $36 & 16; //@line 122658 "c/sqlite3.c"
 $38 = ($37|0)==(0); //@line 122658 "c/sqlite3.c"
 $$ = $38 ? $16 : 0; //@line 122660 "c/sqlite3.c"
 $$0 = $$;
 return ($$0|0); //@line 122661 "c/sqlite3.c"
}
function _explainSimpleCount($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 123579 "c/sqlite3.c"
 $3 = ((($0)) + 399|0); //@line 123583 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 123583 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(2); //@line 123583 "c/sqlite3.c"
 if (!($5)) {
  STACKTOP = sp;return; //@line 123594 "c/sqlite3.c"
 }
 $6 = ($2|0)==(0|0); //@line 123584 "c/sqlite3.c"
 do {
  if ($6) {
   $7 = HEAP32[$0>>2]|0; //@line 123585 "c/sqlite3.c"
   $8 = HEAP32[$1>>2]|0; //@line 123586 "c/sqlite3.c"
   $22 = $8;$23 = 41388;$24 = 41388;$25 = $7;
  } else {
   $9 = ((($1)) + 36|0); //@line 123584 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 123584 "c/sqlite3.c"
   $11 = $10 & 32; //@line 123584 "c/sqlite3.c"
   $12 = ($11|0)==(0); //@line 123584 "c/sqlite3.c"
   if ($12) {
    $13 = HEAP32[$0>>2]|0; //@line 123585 "c/sqlite3.c"
    $14 = HEAP32[$1>>2]|0; //@line 123586 "c/sqlite3.c"
    $31 = $14;$32 = $13;
   } else {
    $15 = ((($2)) + 55|0); //@line 123584 "c/sqlite3.c"
    $16 = HEAPU8[$15>>0]|(HEAPU8[$15+1>>0]<<8); //@line 123584 "c/sqlite3.c"
    $17 = $16 & 3; //@line 123584 "c/sqlite3.c"
    $18 = ($17<<16>>16)==(2); //@line 123584 "c/sqlite3.c"
    $19 = HEAP32[$0>>2]|0; //@line 123585 "c/sqlite3.c"
    $20 = HEAP32[$1>>2]|0; //@line 123586 "c/sqlite3.c"
    if ($18) {
     $22 = $20;$23 = 41388;$24 = 41388;$25 = $19;
     break;
    } else {
     $31 = $20;$32 = $19;
    }
   }
   $21 = HEAP32[$2>>2]|0; //@line 123588 "c/sqlite3.c"
   $22 = $31;$23 = 28461;$24 = $21;$25 = $32;
  }
 } while(0);
 HEAP32[$vararg_buffer>>2] = $22; //@line 123585 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 123585 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $23; //@line 123585 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 123585 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $24; //@line 123585 "c/sqlite3.c"
 $26 = (_sqlite3MPrintf($25,28484,$vararg_buffer)|0); //@line 123585 "c/sqlite3.c"
 $27 = ((($0)) + 8|0); //@line 123591 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 123591 "c/sqlite3.c"
 $29 = ((($0)) + 412|0); //@line 123591 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 123591 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($28,169,$30,0,0,$26,-7)|0); //@line 123590 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 123594 "c/sqlite3.c"
}
function _generateSortTail($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0161 = 0, $$0161$in = 0, $$0162 = 0, $$0163 = 0, $$0164171 = 0, $$0166 = 0, $$0167 = 0, $$0168170 = 0, $$0169 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 8|0); //@line 119900 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 119900 "c/sqlite3.c"
 $7 = ((($2)) + 24|0); //@line 119901 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 119901 "c/sqlite3.c"
 $9 = (_sqlite3VdbeMakeLabel($6)|0); //@line 119902 "c/sqlite3.c"
 $10 = HEAP32[$2>>2]|0; //@line 119906 "c/sqlite3.c"
 $11 = HEAP8[$4>>0]|0; //@line 119907 "c/sqlite3.c"
 $12 = ((($4)) + 4|0); //@line 119908 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 119908 "c/sqlite3.c"
 $14 = HEAP32[$1>>2]|0; //@line 119917 "c/sqlite3.c"
 $15 = ((($2)) + 16|0); //@line 119920 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 119920 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 119920 "c/sqlite3.c"
 if (!($17)) {
  $18 = ((($2)) + 12|0); //@line 119921 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 119921 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($6,14,$19,$16)|0); //@line 119921 "c/sqlite3.c"
  _sqlite3VdbeGoto($6,$8); //@line 119922 "c/sqlite3.c"
  $20 = HEAP32[$15>>2]|0; //@line 119923 "c/sqlite3.c"
  _sqlite3VdbeResolveLabel($6,$20); //@line 119923 "c/sqlite3.c"
 }
 $21 = ((($2)) + 8|0); //@line 119925 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 119925 "c/sqlite3.c"
 switch ($11<<24>>24) {
 case 9: case 10: case 13:  {
  $23 = ((($4)) + 8|0); //@line 119928 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 119928 "c/sqlite3.c"
  $$0167 = $24;$$0169 = 0;
  break;
 }
 default: {
  $25 = (_sqlite3GetTempReg($0)|0); //@line 119931 "c/sqlite3.c"
  $26 = (_sqlite3GetTempRange($0,$3)|0); //@line 119932 "c/sqlite3.c"
  $$0167 = $26;$$0169 = $25;
 }
 }
 $27 = HEAP32[$10>>2]|0; //@line 119935 "c/sqlite3.c"
 $28 = ((($2)) + 4|0); //@line 119935 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 119935 "c/sqlite3.c"
 $30 = (($27) - ($29))|0; //@line 119935 "c/sqlite3.c"
 $31 = ((($2)) + 28|0); //@line 119936 "c/sqlite3.c"
 $32 = HEAP8[$31>>0]|0; //@line 119936 "c/sqlite3.c"
 $33 = $32 & 1; //@line 119936 "c/sqlite3.c"
 $34 = ($33<<24>>24)==(0); //@line 119936 "c/sqlite3.c"
 if ($34) {
  $50 = (_sqlite3VdbeAddOp2($6,36,$22,$8)|0); //@line 119950 "c/sqlite3.c"
  $51 = ((($1)) + 16|0); //@line 119951 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 119951 "c/sqlite3.c"
  _codeOffset($6,$52,$9); //@line 119951 "c/sqlite3.c"
  $$0161$in = $50;$$0163 = 1;$$0166 = $22;
 } else {
  $35 = ((($0)) + 44|0); //@line 119937 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 119937 "c/sqlite3.c"
  $37 = (($36) + 1)|0; //@line 119937 "c/sqlite3.c"
  HEAP32[$35>>2] = $37; //@line 119937 "c/sqlite3.c"
  $38 = ((($0)) + 40|0); //@line 119938 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 119938 "c/sqlite3.c"
  $40 = (($39) + 1)|0; //@line 119938 "c/sqlite3.c"
  HEAP32[$38>>2] = $40; //@line 119938 "c/sqlite3.c"
  $41 = HEAP32[$15>>2]|0; //@line 119939 "c/sqlite3.c"
  $42 = ($41|0)==(0); //@line 119939 "c/sqlite3.c"
  if ($42) {
   $$0162 = 0;
  } else {
   $43 = (_sqlite3VdbeAddOp0($6,20)|0); //@line 119940 "c/sqlite3.c"
   $$0162 = $43;
  }
  $44 = (($3) + 1)|0; //@line 119942 "c/sqlite3.c"
  $45 = (($44) + ($30))|0; //@line 119942 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($6,112,$39,$37,$45)|0); //@line 119942 "c/sqlite3.c"
  $46 = ($$0162|0)==(0); //@line 119943 "c/sqlite3.c"
  if (!($46)) {
   _sqlite3VdbeJumpHere($6,$$0162); //@line 119943 "c/sqlite3.c"
  }
  $47 = (_sqlite3VdbeAddOp2($6,35,$22,$8)|0); //@line 119944 "c/sqlite3.c"
  $48 = ((($1)) + 16|0); //@line 119946 "c/sqlite3.c"
  $49 = HEAP32[$48>>2]|0; //@line 119946 "c/sqlite3.c"
  _codeOffset($6,$49,$9); //@line 119946 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($6,122,$22,$37,$39)|0); //@line 119947 "c/sqlite3.c"
  $$0161$in = $47;$$0163 = 0;$$0166 = $39;
 }
 $$0161 = (($$0161$in) + 1)|0;
 $53 = ($3|0)>(0); //@line 119955 "c/sqlite3.c"
 if ($53) {
  $54 = (($$0163) + ($30))|0; //@line 119955 "c/sqlite3.c"
  $$0164171 = 0;$$0168170 = $54;
  while(1) {
   $55 = (((((($14)) + 4|0) + (($$0164171*20)|0)|0)) + 16|0); //@line 119957 "c/sqlite3.c"
   $56 = HEAP16[$55>>1]|0; //@line 119957 "c/sqlite3.c"
   $57 = ($56<<16>>16)==(0); //@line 119957 "c/sqlite3.c"
   $58 = $56&65535; //@line 119958 "c/sqlite3.c"
   $59 = (($58) + -1)|0; //@line 119958 "c/sqlite3.c"
   $60 = $57&1; //@line 119957 "c/sqlite3.c"
   $$1 = (($$0168170) + ($60))|0; //@line 119957 "c/sqlite3.c"
   $$0 = $57 ? $$0168170 : $59; //@line 119957 "c/sqlite3.c"
   $61 = (($$0164171) + ($$0167))|0; //@line 119962 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($6,98,$$0166,$$0,$61)|0); //@line 119962 "c/sqlite3.c"
   $62 = (($$0164171) + 1)|0; //@line 119955 "c/sqlite3.c"
   $exitcond = ($62|0)==($3|0); //@line 119955 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$0164171 = $62;$$0168170 = $$1;
   }
  }
 }
 switch ($11<<24>>24) {
 case 12: case 14:  {
  (_sqlite3VdbeAddOp2($6,116,$13,$$0169)|0); //@line 119968 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($6,117,$13,$$0167,$$0169)|0); //@line 119969 "c/sqlite3.c"
  _sqlite3VdbeChangeP5($6,8); //@line 119970 "c/sqlite3.c"
  break;
 }
 case 11:  {
  $63 = ((($4)) + 16|0); //@line 119977 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 119977 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4($6,100,$$0167,$3,$$0169,$64,$3)|0); //@line 119976 "c/sqlite3.c"
  _sqlite3ExprCacheAffinityChange($0,$$0167,$3); //@line 119978 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4Int($6,128,$13,$$0169,$$0167,$3)|0); //@line 119979 "c/sqlite3.c"
  break;
 }
 case 10:  {
  break;
 }
 case 9:  {
  $65 = ((($4)) + 8|0); //@line 119992 "c/sqlite3.c"
  $66 = HEAP32[$65>>2]|0; //@line 119992 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($6,78,$66,$3)|0); //@line 119992 "c/sqlite3.c"
  $67 = HEAP32[$65>>2]|0; //@line 119993 "c/sqlite3.c"
  _sqlite3ExprCacheAffinityChange($0,$67,$3); //@line 119993 "c/sqlite3.c"
  break;
 }
 default: {
  $68 = HEAP32[$12>>2]|0; //@line 119995 "c/sqlite3.c"
  (_sqlite3VdbeAddOp1($6,16,$68)|0); //@line 119995 "c/sqlite3.c"
 }
 }
 $69 = ($$0169|0)==(0); //@line 120000 "c/sqlite3.c"
 if (!($69)) {
  $70 = ($11<<24>>24)==(11); //@line 120001 "c/sqlite3.c"
  if ($70) {
   _sqlite3ReleaseTempRange($0,$$0167,$3); //@line 120002 "c/sqlite3.c"
  } else {
   _sqlite3ReleaseTempReg($0,$$0167); //@line 120004 "c/sqlite3.c"
  }
  _sqlite3ReleaseTempReg($0,$$0169); //@line 120006 "c/sqlite3.c"
 }
 _sqlite3VdbeResolveLabel($6,$9); //@line 120010 "c/sqlite3.c"
 $71 = HEAP8[$31>>0]|0; //@line 120011 "c/sqlite3.c"
 $72 = $71 & 1; //@line 120011 "c/sqlite3.c"
 $73 = ($72<<24>>24)==(0); //@line 120011 "c/sqlite3.c"
 if ($73) {
  (_sqlite3VdbeAddOp2($6,7,$22,$$0161)|0); //@line 120014 "c/sqlite3.c"
 } else {
  (_sqlite3VdbeAddOp2($6,3,$22,$$0161)|0); //@line 120012 "c/sqlite3.c"
 }
 $74 = ((($2)) + 12|0); //@line 120016 "c/sqlite3.c"
 $75 = HEAP32[$74>>2]|0; //@line 120016 "c/sqlite3.c"
 $76 = ($75|0)==(0); //@line 120016 "c/sqlite3.c"
 if ($76) {
  _sqlite3VdbeResolveLabel($6,$8); //@line 120017 "c/sqlite3.c"
  return; //@line 120018 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp1($6,63,$75)|0); //@line 120016 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($6,$8); //@line 120017 "c/sqlite3.c"
 return; //@line 120018 "c/sqlite3.c"
}
function _codeOffset($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)>(0); //@line 119311 "c/sqlite3.c"
 if ($3) {
  (_sqlite3VdbeAddOp3($0,48,$1,$2,1)|0); //@line 119312 "c/sqlite3.c"
 }
 return; //@line 119315 "c/sqlite3.c"
}
function _codeDistinct($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 8|0); //@line 119336 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 119336 "c/sqlite3.c"
 $7 = (_sqlite3GetTempReg($0)|0); //@line 119337 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4Int($6,30,$1,$2,$4,$3)|0); //@line 119338 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($6,100,$4,$3,$7)|0); //@line 119339 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4Int($6,128,$1,$7,$4,$3)|0); //@line 119340 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($6,16); //@line 119341 "c/sqlite3.c"
 _sqlite3ReleaseTempReg($0,$7); //@line 119342 "c/sqlite3.c"
 return; //@line 119343 "c/sqlite3.c"
}
function _analyzeAggregate($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0129156 = 0, $$0131152 = 0, $$0133147 = 0, $$0134151 = 0, $$0135149 = 0, $$0136146 = 0, $$0137148 = 0, $$1132$lcssa = 0, $$1132155 = 0, $$1138 = 0, $$2 = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0;
 var $142 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 97756 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 97756 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 97757 "c/sqlite3.c"
 $5 = ((($3)) + 4|0); //@line 97758 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 97758 "c/sqlite3.c"
 $7 = ((($3)) + 12|0); //@line 97759 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 97759 "c/sqlite3.c"
 $9 = HEAP8[$1>>0]|0; //@line 97761 "c/sqlite3.c"
 switch ($9<<24>>24) {
 case -111: case -109:  {
  $10 = ($6|0)==(0|0); //@line 97768 "c/sqlite3.c"
  if ($10) {
   $$0 = 1;
   return ($$0|0); //@line 97878 "c/sqlite3.c"
  }
  $11 = HEAP32[$6>>2]|0; //@line 97770 "c/sqlite3.c"
  $12 = ($11|0)>(0); //@line 97770 "c/sqlite3.c"
  if (!($12)) {
   $$0 = 1;
   return ($$0|0); //@line 97878 "c/sqlite3.c"
  }
  $13 = ((($6)) + 8|0); //@line 97769 "c/sqlite3.c"
  $14 = ((($1)) + 28|0);
  $15 = HEAP32[$14>>2]|0;
  $$0131152 = 0;$$0134151 = $13;
  while(1) {
   $16 = ((($$0134151)) + 44|0); //@line 97773 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 97773 "c/sqlite3.c"
   $18 = ($15|0)==($17|0); //@line 97773 "c/sqlite3.c"
   if ($18) {
    break;
   }
   $82 = (($$0131152) + 1)|0; //@line 97770 "c/sqlite3.c"
   $83 = ((($$0134151)) + 72|0); //@line 97770 "c/sqlite3.c"
   $84 = HEAP32[$6>>2]|0; //@line 97770 "c/sqlite3.c"
   $85 = ($82|0)<($84|0); //@line 97770 "c/sqlite3.c"
   if ($85) {
    $$0131152 = $82;$$0134151 = $83;
   } else {
    $$0 = 1;
    label = 38;
    break;
   }
  }
  if ((label|0) == 38) {
   return ($$0|0); //@line 97878 "c/sqlite3.c"
  }
  $19 = ((($1)) + 28|0); //@line 97773 "c/sqlite3.c"
  $20 = ((($8)) + 28|0); //@line 97781 "c/sqlite3.c"
  $21 = ((($8)) + 32|0); //@line 97782 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 97782 "c/sqlite3.c"
  $23 = ($22|0)>(0); //@line 97782 "c/sqlite3.c"
  L15: do {
   if ($23) {
    $24 = HEAP32[$20>>2]|0; //@line 97781 "c/sqlite3.c"
    $25 = ((($1)) + 32|0);
    $$0135149 = $24;$$0137148 = 0;
    while(1) {
     $26 = ((($$0135149)) + 4|0); //@line 97783 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 97783 "c/sqlite3.c"
     $28 = ($27|0)==($15|0); //@line 97783 "c/sqlite3.c"
     if ($28) {
      $29 = ((($$0135149)) + 8|0); //@line 97784 "c/sqlite3.c"
      $30 = HEAP32[$29>>2]|0; //@line 97784 "c/sqlite3.c"
      $31 = HEAP16[$25>>1]|0; //@line 97784 "c/sqlite3.c"
      $32 = $31 << 16 >> 16; //@line 97784 "c/sqlite3.c"
      $33 = ($30|0)==($32|0); //@line 97784 "c/sqlite3.c"
      if ($33) {
       $$1138 = $$0137148;
       break L15;
      }
     }
     $34 = (($$0137148) + 1)|0; //@line 97782 "c/sqlite3.c"
     $35 = ((($$0135149)) + 24|0); //@line 97782 "c/sqlite3.c"
     $36 = HEAP32[$21>>2]|0; //@line 97782 "c/sqlite3.c"
     $37 = ($34|0)<($36|0); //@line 97782 "c/sqlite3.c"
     if ($37) {
      $$0135149 = $35;$$0137148 = $34;
     } else {
      label = 11;
      break;
     }
    }
   } else {
    label = 11;
   }
  } while(0);
  L22: do {
   if ((label|0) == 11) {
    $38 = HEAP32[$4>>2]|0; //@line 97789 "c/sqlite3.c"
    $39 = (_addAggInfoColumn($38,$8)|0); //@line 97789 "c/sqlite3.c"
    $40 = ($39|0)>(-1); //@line 97789 "c/sqlite3.c"
    if ($40) {
     $41 = HEAP32[$20>>2]|0; //@line 97791 "c/sqlite3.c"
     $42 = (($41) + (($39*24)|0)|0); //@line 97791 "c/sqlite3.c"
     $43 = ((($1)) + 44|0); //@line 97792 "c/sqlite3.c"
     $44 = HEAP32[$43>>2]|0; //@line 97792 "c/sqlite3.c"
     HEAP32[$42>>2] = $44; //@line 97792 "c/sqlite3.c"
     $45 = HEAP32[$19>>2]|0; //@line 97793 "c/sqlite3.c"
     $46 = (((($41) + (($39*24)|0)|0)) + 4|0); //@line 97793 "c/sqlite3.c"
     HEAP32[$46>>2] = $45; //@line 97793 "c/sqlite3.c"
     $47 = ((($1)) + 32|0); //@line 97794 "c/sqlite3.c"
     $48 = HEAP16[$47>>1]|0; //@line 97794 "c/sqlite3.c"
     $49 = $48 << 16 >> 16; //@line 97794 "c/sqlite3.c"
     $50 = (((($41) + (($39*24)|0)|0)) + 8|0); //@line 97794 "c/sqlite3.c"
     HEAP32[$50>>2] = $49; //@line 97794 "c/sqlite3.c"
     $51 = ((($4)) + 44|0); //@line 97795 "c/sqlite3.c"
     $52 = HEAP32[$51>>2]|0; //@line 97795 "c/sqlite3.c"
     $53 = (($52) + 1)|0; //@line 97795 "c/sqlite3.c"
     HEAP32[$51>>2] = $53; //@line 97795 "c/sqlite3.c"
     $54 = (((($41) + (($39*24)|0)|0)) + 16|0); //@line 97795 "c/sqlite3.c"
     HEAP32[$54>>2] = $53; //@line 97795 "c/sqlite3.c"
     $55 = (((($41) + (($39*24)|0)|0)) + 12|0); //@line 97796 "c/sqlite3.c"
     HEAP32[$55>>2] = -1; //@line 97796 "c/sqlite3.c"
     $56 = (((($41) + (($39*24)|0)|0)) + 20|0); //@line 97797 "c/sqlite3.c"
     HEAP32[$56>>2] = $1; //@line 97797 "c/sqlite3.c"
     $57 = ((($8)) + 24|0); //@line 97798 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 97798 "c/sqlite3.c"
     $59 = ($58|0)==(0|0); //@line 97798 "c/sqlite3.c"
     L25: do {
      if (!($59)) {
       $60 = HEAP32[$58>>2]|0; //@line 97802 "c/sqlite3.c"
       $61 = ($60|0)>(0); //@line 97803 "c/sqlite3.c"
       if ($61) {
        $62 = ((($58)) + 4|0); //@line 97801 "c/sqlite3.c"
        $$0133147 = $62;$$0136146 = 0;
        while(1) {
         $63 = HEAP32[$$0133147>>2]|0; //@line 97804 "c/sqlite3.c"
         $64 = HEAP8[$63>>0]|0; //@line 97805 "c/sqlite3.c"
         $65 = ($64<<24>>24)==(-111); //@line 97805 "c/sqlite3.c"
         if ($65) {
          $66 = ((($63)) + 28|0); //@line 97805 "c/sqlite3.c"
          $67 = HEAP32[$66>>2]|0; //@line 97805 "c/sqlite3.c"
          $68 = ($67|0)==($45|0); //@line 97805 "c/sqlite3.c"
          if ($68) {
           $69 = ((($63)) + 32|0); //@line 97806 "c/sqlite3.c"
           $70 = HEAP16[$69>>1]|0; //@line 97806 "c/sqlite3.c"
           $71 = ($70<<16>>16)==($48<<16>>16); //@line 97806 "c/sqlite3.c"
           if ($71) {
            break;
           }
          }
         }
         $72 = (($$0136146) + 1)|0; //@line 97803 "c/sqlite3.c"
         $73 = ((($$0133147)) + 20|0); //@line 97803 "c/sqlite3.c"
         $74 = ($72|0)<($60|0); //@line 97803 "c/sqlite3.c"
         if ($74) {
          $$0133147 = $73;$$0136146 = $72;
         } else {
          break L25;
         }
        }
        HEAP32[$55>>2] = $$0136146; //@line 97807 "c/sqlite3.c"
        $$1138 = $39;
        break L22;
       }
      }
     } while(0);
     $$pr = HEAP32[$55>>2]|0; //@line 97812 "c/sqlite3.c"
     $75 = ($$pr|0)<(0); //@line 97812 "c/sqlite3.c"
     if ($75) {
      $76 = ((($8)) + 12|0); //@line 97813 "c/sqlite3.c"
      $77 = HEAP32[$76>>2]|0; //@line 97813 "c/sqlite3.c"
      $78 = (($77) + 1)|0; //@line 97813 "c/sqlite3.c"
      HEAP32[$76>>2] = $78; //@line 97813 "c/sqlite3.c"
      HEAP32[$55>>2] = $77; //@line 97813 "c/sqlite3.c"
      $$1138 = $39;
     } else {
      $$1138 = $39;
     }
    } else {
     $$1138 = $39;
    }
   }
  } while(0);
  $79 = ((($1)) + 40|0); //@line 97822 "c/sqlite3.c"
  HEAP32[$79>>2] = $8; //@line 97822 "c/sqlite3.c"
  HEAP8[$1>>0] = -109; //@line 97823 "c/sqlite3.c"
  $80 = $$1138&65535; //@line 97824 "c/sqlite3.c"
  $81 = ((($1)) + 34|0); //@line 97824 "c/sqlite3.c"
  HEAP16[$81>>1] = $80; //@line 97824 "c/sqlite3.c"
  $$0 = 1;
  return ($$0|0); //@line 97878 "c/sqlite3.c"
  break;
 }
 case -110:  {
  $86 = ((($3)) + 28|0); //@line 97832 "c/sqlite3.c"
  $87 = HEAP16[$86>>1]|0; //@line 97832 "c/sqlite3.c"
  $88 = $87 & 8; //@line 97832 "c/sqlite3.c"
  $89 = ($88<<16>>16)==(0); //@line 97832 "c/sqlite3.c"
  if (!($89)) {
   $$0 = 0;
   return ($$0|0); //@line 97878 "c/sqlite3.c"
  }
  $90 = ((($0)) + 16|0); //@line 97833 "c/sqlite3.c"
  $91 = HEAP32[$90>>2]|0; //@line 97833 "c/sqlite3.c"
  $92 = ((($1)) + 38|0); //@line 97833 "c/sqlite3.c"
  $93 = HEAP8[$92>>0]|0; //@line 97833 "c/sqlite3.c"
  $94 = $93&255; //@line 97833 "c/sqlite3.c"
  $95 = ($91|0)==($94|0); //@line 97833 "c/sqlite3.c"
  if (!($95)) {
   $$0 = 0;
   return ($$0|0); //@line 97878 "c/sqlite3.c"
  }
  $96 = ((($8)) + 40|0); //@line 97838 "c/sqlite3.c"
  $97 = ((($8)) + 44|0); //@line 97839 "c/sqlite3.c"
  $98 = HEAP32[$97>>2]|0; //@line 97839 "c/sqlite3.c"
  $99 = ($98|0)>(0); //@line 97839 "c/sqlite3.c"
  L46: do {
   if ($99) {
    $100 = HEAP32[$96>>2]|0; //@line 97838 "c/sqlite3.c"
    $$0129156 = $100;$$1132155 = 0;
    while(1) {
     $101 = HEAP32[$$0129156>>2]|0; //@line 97840 "c/sqlite3.c"
     $102 = (_sqlite3ExprCompare(0,$101,$1,-1)|0); //@line 97840 "c/sqlite3.c"
     $103 = ($102|0)==(0); //@line 97840 "c/sqlite3.c"
     if ($103) {
      $$1132$lcssa = $$1132155;
      break L46;
     }
     $104 = (($$1132155) + 1)|0; //@line 97839 "c/sqlite3.c"
     $105 = ((($$0129156)) + 16|0); //@line 97839 "c/sqlite3.c"
     $106 = HEAP32[$97>>2]|0; //@line 97839 "c/sqlite3.c"
     $107 = ($104|0)<($106|0); //@line 97839 "c/sqlite3.c"
     if ($107) {
      $$0129156 = $105;$$1132155 = $104;
     } else {
      $$1132$lcssa = $104;
      break;
     }
    }
   } else {
    $$1132$lcssa = 0;
   }
  } while(0);
  $108 = HEAP32[$97>>2]|0; //@line 97844 "c/sqlite3.c"
  $109 = ($$1132$lcssa|0)<($108|0); //@line 97844 "c/sqlite3.c"
  do {
   if ($109) {
    $$2 = $$1132$lcssa;
   } else {
    $110 = HEAP32[$4>>2]|0; //@line 97847 "c/sqlite3.c"
    $111 = ((($110)) + 70|0); //@line 97847 "c/sqlite3.c"
    $112 = HEAP8[$111>>0]|0; //@line 97847 "c/sqlite3.c"
    $113 = (_addAggInfoFunc($110,$8)|0); //@line 97848 "c/sqlite3.c"
    $114 = ($113|0)>(-1); //@line 97849 "c/sqlite3.c"
    if ($114) {
     $115 = HEAP32[$96>>2]|0; //@line 97851 "c/sqlite3.c"
     $116 = (($115) + ($113<<4)|0); //@line 97852 "c/sqlite3.c"
     HEAP32[$116>>2] = $1; //@line 97852 "c/sqlite3.c"
     $117 = ((($4)) + 44|0); //@line 97853 "c/sqlite3.c"
     $118 = HEAP32[$117>>2]|0; //@line 97853 "c/sqlite3.c"
     $119 = (($118) + 1)|0; //@line 97853 "c/sqlite3.c"
     HEAP32[$117>>2] = $119; //@line 97853 "c/sqlite3.c"
     $120 = (((($115) + ($113<<4)|0)) + 8|0); //@line 97853 "c/sqlite3.c"
     HEAP32[$120>>2] = $119; //@line 97853 "c/sqlite3.c"
     $121 = HEAP32[$4>>2]|0; //@line 97855 "c/sqlite3.c"
     $122 = ((($1)) + 8|0); //@line 97856 "c/sqlite3.c"
     $123 = HEAP32[$122>>2]|0; //@line 97856 "c/sqlite3.c"
     $124 = ((($1)) + 20|0); //@line 97857 "c/sqlite3.c"
     $125 = HEAP32[$124>>2]|0; //@line 97857 "c/sqlite3.c"
     $126 = ($125|0)==(0|0); //@line 97857 "c/sqlite3.c"
     if ($126) {
      $128 = 0;
     } else {
      $127 = HEAP32[$125>>2]|0; //@line 97857 "c/sqlite3.c"
      $128 = $127;
     }
     $129 = (_sqlite3FindFunction($121,$123,$128,$112,0)|0); //@line 97855 "c/sqlite3.c"
     $130 = (((($115) + ($113<<4)|0)) + 4|0); //@line 97855 "c/sqlite3.c"
     HEAP32[$130>>2] = $129; //@line 97855 "c/sqlite3.c"
     $131 = ((($1)) + 4|0); //@line 97858 "c/sqlite3.c"
     $132 = HEAP32[$131>>2]|0; //@line 97858 "c/sqlite3.c"
     $133 = $132 & 16; //@line 97858 "c/sqlite3.c"
     $134 = ($133|0)==(0); //@line 97858 "c/sqlite3.c"
     if ($134) {
      $139 = (((($115) + ($113<<4)|0)) + 12|0); //@line 97861 "c/sqlite3.c"
      HEAP32[$139>>2] = -1; //@line 97861 "c/sqlite3.c"
      $$2 = $113;
      break;
     } else {
      $135 = ((($4)) + 40|0); //@line 97859 "c/sqlite3.c"
      $136 = HEAP32[$135>>2]|0; //@line 97859 "c/sqlite3.c"
      $137 = (($136) + 1)|0; //@line 97859 "c/sqlite3.c"
      HEAP32[$135>>2] = $137; //@line 97859 "c/sqlite3.c"
      $138 = (((($115) + ($113<<4)|0)) + 12|0); //@line 97859 "c/sqlite3.c"
      HEAP32[$138>>2] = $136; //@line 97859 "c/sqlite3.c"
      $$2 = $113;
      break;
     }
    } else {
     $$2 = $113;
    }
   }
  } while(0);
  $140 = $$2&65535; //@line 97869 "c/sqlite3.c"
  $141 = ((($1)) + 34|0); //@line 97869 "c/sqlite3.c"
  HEAP16[$141>>1] = $140; //@line 97869 "c/sqlite3.c"
  $142 = ((($1)) + 40|0); //@line 97870 "c/sqlite3.c"
  HEAP32[$142>>2] = $8; //@line 97870 "c/sqlite3.c"
  $$0 = 1;
  return ($$0|0); //@line 97878 "c/sqlite3.c"
  break;
 }
 default: {
  $$0 = 0;
  return ($$0|0); //@line 97878 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _analyzeAggregatesInSelect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 16|0); //@line 97881 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 97881 "c/sqlite3.c"
 $4 = (($3) + 1)|0; //@line 97881 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 97881 "c/sqlite3.c"
 return 0; //@line 97882 "c/sqlite3.c"
}
function _analyzeAggregatesInSelectEnd($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 16|0); //@line 97886 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 97886 "c/sqlite3.c"
 $4 = (($3) + -1)|0; //@line 97886 "c/sqlite3.c"
 HEAP32[$2>>2] = $4; //@line 97886 "c/sqlite3.c"
 return; //@line 97887 "c/sqlite3.c"
}
function _addAggInfoColumn($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($1)) + 28|0); //@line 97725 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 97725 "c/sqlite3.c"
 $5 = ((($1)) + 32|0); //@line 97727 "c/sqlite3.c"
 $6 = (_sqlite3ArrayAllocate($0,$4,24,$5,$2)|0); //@line 97723 "c/sqlite3.c"
 HEAP32[$3>>2] = $6; //@line 97723 "c/sqlite3.c"
 $7 = HEAP32[$2>>2]|0; //@line 97730 "c/sqlite3.c"
 STACKTOP = sp;return ($7|0); //@line 97730 "c/sqlite3.c"
}
function _addAggInfoFunc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($1)) + 40|0); //@line 97741 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 97741 "c/sqlite3.c"
 $5 = ((($1)) + 44|0); //@line 97743 "c/sqlite3.c"
 $6 = (_sqlite3ArrayAllocate($0,$4,16,$5,$2)|0); //@line 97739 "c/sqlite3.c"
 HEAP32[$3>>2] = $6; //@line 97739 "c/sqlite3.c"
 $7 = HEAP32[$2>>2]|0; //@line 97746 "c/sqlite3.c"
 STACKTOP = sp;return ($7|0); //@line 97746 "c/sqlite3.c"
}
function _havingToWhereExprCb($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0;
 var label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $2 = sp;
 $3 = HEAP8[$1>>0]|0; //@line 123619 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(44); //@line 123619 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 123634 "c/sqlite3.c"
 }
 $5 = ((($0)) + 24|0); //@line 123620 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 123620 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 123621 "c/sqlite3.c"
 $8 = ((($6)) + 4|0); //@line 123621 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 123621 "c/sqlite3.c"
 $10 = (_sqlite3ExprIsConstantOrGroupBy($7,$1,$9)|0); //@line 123621 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 123621 "c/sqlite3.c"
 if ($11) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 123634 "c/sqlite3.c"
 }
 $12 = HEAP32[$0>>2]|0; //@line 123622 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 123622 "c/sqlite3.c"
 $14 = (_sqlite3ExprAlloc($13,134,(4988),0)|0); //@line 123623 "c/sqlite3.c"
 $15 = ($14|0)==(0|0); //@line 123624 "c/sqlite3.c"
 if ($15) {
  $$0 = 1;
  STACKTOP = sp;return ($$0|0); //@line 123634 "c/sqlite3.c"
 }
 $16 = HEAP32[$6>>2]|0; //@line 123625 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 123625 "c/sqlite3.c"
 dest=$2; src=$14; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 123626 "c/sqlite3.c"
 dest=$14; src=$1; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 123626 "c/sqlite3.c"
 dest=$1; src=$2; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 123626 "c/sqlite3.c"
 $18 = (_sqlite3ExprAnd($13,$17,$14)|0); //@line 123627 "c/sqlite3.c"
 $19 = HEAP32[$6>>2]|0; //@line 123628 "c/sqlite3.c"
 HEAP32[$19>>2] = $18; //@line 123628 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 123634 "c/sqlite3.c"
}
function _sqlite3ExprIsConstantOrGroupBy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = ((($3)) + 20|0); //@line 94598 "c/sqlite3.c"
 HEAP8[$4>>0] = 1; //@line 94598 "c/sqlite3.c"
 $5 = ((($3)) + 4|0); //@line 94599 "c/sqlite3.c"
 HEAP32[$5>>2] = 169; //@line 94599 "c/sqlite3.c"
 $6 = ((($3)) + 8|0); //@line 94600 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 94600 "c/sqlite3.c"
 $7 = ((($3)) + 24|0); //@line 94601 "c/sqlite3.c"
 HEAP32[$7>>2] = $2; //@line 94601 "c/sqlite3.c"
 HEAP32[$3>>2] = $0; //@line 94602 "c/sqlite3.c"
 (_sqlite3WalkExpr($3,$1)|0); //@line 94603 "c/sqlite3.c"
 $8 = HEAP8[$4>>0]|0; //@line 94604 "c/sqlite3.c"
 $9 = $8&255; //@line 94604 "c/sqlite3.c"
 STACKTOP = sp;return ($9|0); //@line 94604 "c/sqlite3.c"
}
function _exprNodeIsConstantOrGroupBy($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02628 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 24|0); //@line 94553 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 94553 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 94558 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 94558 "c/sqlite3.c"
 L1: do {
  if ($5) {
   $$02628 = 0;
   while(1) {
    $6 = (((($3)) + 4|0) + (($$02628*20)|0)|0); //@line 94559 "c/sqlite3.c"
    $7 = HEAP32[$6>>2]|0; //@line 94559 "c/sqlite3.c"
    $8 = (_sqlite3ExprCompare(0,$1,$7,-1)|0); //@line 94560 "c/sqlite3.c"
    $9 = ($8|0)<(2); //@line 94560 "c/sqlite3.c"
    if ($9) {
     $10 = HEAP32[$0>>2]|0; //@line 94561 "c/sqlite3.c"
     $11 = (_sqlite3ExprNNCollSeq($10,$7)|0); //@line 94561 "c/sqlite3.c"
     $12 = HEAP32[$11>>2]|0; //@line 94562 "c/sqlite3.c"
     $13 = (_sqlite3_stricmp(18038,$12)|0); //@line 94562 "c/sqlite3.c"
     $14 = ($13|0)==(0); //@line 94562 "c/sqlite3.c"
     if ($14) {
      $$4 = 1;
      break;
     }
    }
    $15 = (($$02628) + 1)|0; //@line 94558 "c/sqlite3.c"
    $16 = HEAP32[$3>>2]|0; //@line 94558 "c/sqlite3.c"
    $17 = ($15|0)<($16|0); //@line 94558 "c/sqlite3.c"
    if ($17) {
     $$02628 = $15;
    } else {
     break L1;
    }
   }
   return ($$4|0); //@line 94575 "c/sqlite3.c"
  }
 } while(0);
 $18 = ((($1)) + 4|0); //@line 94569 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 94569 "c/sqlite3.c"
 $20 = $19 & 2048; //@line 94569 "c/sqlite3.c"
 $21 = ($20|0)==(0); //@line 94569 "c/sqlite3.c"
 if ($21) {
  $23 = (_exprNodeIsConstant($0,$1)|0); //@line 94574 "c/sqlite3.c"
  $$4 = $23;
  return ($$4|0); //@line 94575 "c/sqlite3.c"
 } else {
  $22 = ((($0)) + 20|0); //@line 94570 "c/sqlite3.c"
  HEAP8[$22>>0] = 0; //@line 94570 "c/sqlite3.c"
  $$4 = 2;
  return ($$4|0); //@line 94575 "c/sqlite3.c"
 }
 return (0)|0;
}
function _pushOntoSorter($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$0 = 0, $$0169 = 0, $$0172 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $7 = ((($0)) + 8|0); //@line 119194 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 119194 "c/sqlite3.c"
 $9 = ((($1)) + 28|0); //@line 119195 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 119195 "c/sqlite3.c"
 $11 = $10 & 1; //@line 119195 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 119195 "c/sqlite3.c"
 $13 = $11 ^ 1; //@line 119195 "c/sqlite3.c"
 $14 = $13&255; //@line 119195 "c/sqlite3.c"
 $15 = HEAP32[$1>>2]|0; //@line 119196 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 119196 "c/sqlite3.c"
 $17 = (($16) + ($14))|0; //@line 119197 "c/sqlite3.c"
 $18 = (($17) + ($5))|0; //@line 119197 "c/sqlite3.c"
 $19 = ((($0)) + 44|0); //@line 119199 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 119199 "c/sqlite3.c"
 $21 = (($20) + 1)|0; //@line 119199 "c/sqlite3.c"
 HEAP32[$19>>2] = $21; //@line 119199 "c/sqlite3.c"
 $22 = ((($1)) + 4|0); //@line 119200 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 119200 "c/sqlite3.c"
 $24 = ($6|0)==(0); //@line 119206 "c/sqlite3.c"
 if ($24) {
  $27 = (($20) + 2)|0; //@line 119210 "c/sqlite3.c"
  $28 = (($18) + ($21))|0; //@line 119211 "c/sqlite3.c"
  HEAP32[$19>>2] = $28; //@line 119211 "c/sqlite3.c"
  $$0 = $27;
 } else {
  $25 = (($3) - ($16))|0; //@line 119208 "c/sqlite3.c"
  $26 = (($25) - ($14))|0; //@line 119208 "c/sqlite3.c"
  $$0 = $26;
 }
 $29 = ((($2)) + 16|0); //@line 119214 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 119214 "c/sqlite3.c"
 $31 = ($30|0)==(0); //@line 119214 "c/sqlite3.c"
 if ($31) {
  $33 = ((($2)) + 12|0); //@line 119214 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 119214 "c/sqlite3.c"
  $96 = $34;
 } else {
  $32 = (($30) + 1)|0; //@line 119214 "c/sqlite3.c"
  $96 = $32;
 }
 $35 = (_sqlite3VdbeMakeLabel($8)|0); //@line 119215 "c/sqlite3.c"
 $36 = ((($1)) + 24|0); //@line 119215 "c/sqlite3.c"
 HEAP32[$36>>2] = $35; //@line 119215 "c/sqlite3.c"
 $37 = HEAP32[$1>>2]|0; //@line 119216 "c/sqlite3.c"
 $38 = ($4|0)==(0); //@line 119217 "c/sqlite3.c"
 $39 = $38 ? 1 : 5; //@line 119217 "c/sqlite3.c"
 (_sqlite3ExprCodeExprList($0,$37,$$0,$4,$39)|0); //@line 119216 "c/sqlite3.c"
 if ($12) {
  $40 = (($$0) + ($16))|0; //@line 119219 "c/sqlite3.c"
  $41 = ((($1)) + 8|0); //@line 119219 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 119219 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($8,115,$42,$40)|0); //@line 119219 "c/sqlite3.c"
 }
 $43 = ($5|0)>(0); //@line 119221 "c/sqlite3.c"
 $or$cond = $43 & $24; //@line 119221 "c/sqlite3.c"
 if ($or$cond) {
  $44 = (($$0) + ($16))|0; //@line 119222 "c/sqlite3.c"
  $45 = (($44) + ($14))|0; //@line 119222 "c/sqlite3.c"
  _sqlite3ExprCodeMove($0,$3,$45,$5); //@line 119222 "c/sqlite3.c"
 }
 $46 = (($$0) + ($23))|0; //@line 119224 "c/sqlite3.c"
 $47 = (($18) - ($23))|0; //@line 119224 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($8,100,$46,$47,$21)|0); //@line 119224 "c/sqlite3.c"
 $48 = ($23|0)>(0); //@line 119225 "c/sqlite3.c"
 if ($48) {
  $49 = HEAP32[$19>>2]|0; //@line 119233 "c/sqlite3.c"
  $50 = (($49) + 1)|0; //@line 119233 "c/sqlite3.c"
  $51 = HEAP32[$22>>2]|0; //@line 119234 "c/sqlite3.c"
  $52 = (($51) + ($49))|0; //@line 119234 "c/sqlite3.c"
  HEAP32[$19>>2] = $52; //@line 119234 "c/sqlite3.c"
  if ($12) {
   $53 = (($$0) + ($16))|0; //@line 119237 "c/sqlite3.c"
   $54 = (_sqlite3VdbeAddOp1($8,22,$53)|0); //@line 119237 "c/sqlite3.c"
   $$0172 = $54;
  } else {
   $55 = ((($1)) + 8|0); //@line 119239 "c/sqlite3.c"
   $56 = HEAP32[$55>>2]|0; //@line 119239 "c/sqlite3.c"
   $57 = (_sqlite3VdbeAddOp1($8,111,$56)|0); //@line 119239 "c/sqlite3.c"
   $$0172 = $57;
  }
  $58 = HEAP32[$22>>2]|0; //@line 119242 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($8,94,$50,$$0,$58)|0); //@line 119242 "c/sqlite3.c"
  $59 = ((($1)) + 20|0); //@line 119243 "c/sqlite3.c"
  $60 = HEAP32[$59>>2]|0; //@line 119243 "c/sqlite3.c"
  $61 = (_sqlite3VdbeGetOp($8,$60)|0); //@line 119243 "c/sqlite3.c"
  $62 = HEAP32[$0>>2]|0; //@line 119244 "c/sqlite3.c"
  $63 = ((($62)) + 73|0); //@line 119244 "c/sqlite3.c"
  $64 = HEAP8[$63>>0]|0; //@line 119244 "c/sqlite3.c"
  $65 = ($64<<24>>24)==(0); //@line 119244 "c/sqlite3.c"
  if (!($65)) {
   return; //@line 119301 "c/sqlite3.c"
  }
  $66 = (($16) + ($14))|0; //@line 119235 "c/sqlite3.c"
  $67 = (($66) + ($5))|0; //@line 119235 "c/sqlite3.c"
  $68 = (($67) - ($51))|0; //@line 119245 "c/sqlite3.c"
  $69 = ((($61)) + 8|0); //@line 119245 "c/sqlite3.c"
  HEAP32[$69>>2] = $68; //@line 119245 "c/sqlite3.c"
  $70 = ((($61)) + 16|0); //@line 119246 "c/sqlite3.c"
  $71 = HEAP32[$70>>2]|0; //@line 119246 "c/sqlite3.c"
  $72 = ((($71)) + 16|0); //@line 119247 "c/sqlite3.c"
  $73 = HEAP32[$72>>2]|0; //@line 119247 "c/sqlite3.c"
  $74 = ((($71)) + 6|0); //@line 119247 "c/sqlite3.c"
  $75 = HEAP16[$74>>1]|0; //@line 119247 "c/sqlite3.c"
  $76 = $75&65535; //@line 119247 "c/sqlite3.c"
  _memset(($73|0),0,($76|0))|0; //@line 119247 "c/sqlite3.c"
  _sqlite3VdbeChangeP4($8,-1,$71,-9); //@line 119248 "c/sqlite3.c"
  $77 = HEAP32[$1>>2]|0; //@line 119250 "c/sqlite3.c"
  $78 = ((($71)) + 8|0); //@line 119251 "c/sqlite3.c"
  $79 = HEAP16[$78>>1]|0; //@line 119251 "c/sqlite3.c"
  $80 = $79&65535; //@line 119251 "c/sqlite3.c"
  $81 = HEAP16[$74>>1]|0; //@line 119251 "c/sqlite3.c"
  $82 = $81&65535; //@line 119251 "c/sqlite3.c"
  $83 = (($80) + -1)|0; //@line 119251 "c/sqlite3.c"
  $84 = (($83) - ($82))|0; //@line 119251 "c/sqlite3.c"
  $85 = (_keyInfoFromExprList($0,$77,$23,$84)|0); //@line 119250 "c/sqlite3.c"
  HEAP32[$70>>2] = $85; //@line 119250 "c/sqlite3.c"
  $86 = (_sqlite3VdbeCurrentAddr($8)|0); //@line 119252 "c/sqlite3.c"
  $87 = (($86) + 1)|0; //@line 119253 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($8,18,$87,0,$87)|0); //@line 119253 "c/sqlite3.c"
  $88 = (_sqlite3VdbeMakeLabel($8)|0); //@line 119254 "c/sqlite3.c"
  $89 = ((($1)) + 16|0); //@line 119254 "c/sqlite3.c"
  HEAP32[$89>>2] = $88; //@line 119254 "c/sqlite3.c"
  $90 = HEAP32[$19>>2]|0; //@line 119255 "c/sqlite3.c"
  $91 = (($90) + 1)|0; //@line 119255 "c/sqlite3.c"
  HEAP32[$19>>2] = $91; //@line 119255 "c/sqlite3.c"
  $92 = ((($1)) + 12|0); //@line 119255 "c/sqlite3.c"
  HEAP32[$92>>2] = $91; //@line 119255 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($8,14,$91,$88)|0); //@line 119256 "c/sqlite3.c"
  $93 = ((($1)) + 8|0); //@line 119257 "c/sqlite3.c"
  $94 = HEAP32[$93>>2]|0; //@line 119257 "c/sqlite3.c"
  (_sqlite3VdbeAddOp1($8,135,$94)|0); //@line 119257 "c/sqlite3.c"
  $95 = ($96|0)==(0); //@line 119258 "c/sqlite3.c"
  if (!($95)) {
   $97 = HEAP32[$36>>2]|0; //@line 119259 "c/sqlite3.c"
   (_sqlite3VdbeAddOp2($8,22,$96,$97)|0); //@line 119259 "c/sqlite3.c"
  }
  _sqlite3VdbeJumpHere($8,$$0172); //@line 119262 "c/sqlite3.c"
  $98 = HEAP32[$22>>2]|0; //@line 119263 "c/sqlite3.c"
  _sqlite3ExprCodeMove($0,$$0,$50,$98); //@line 119263 "c/sqlite3.c"
  _sqlite3VdbeJumpHere($8,$86); //@line 119264 "c/sqlite3.c"
 }
 $99 = HEAP8[$9>>0]|0; //@line 119266 "c/sqlite3.c"
 $100 = $99 & 1; //@line 119266 "c/sqlite3.c"
 $101 = $100&255;
 $102 = (128 - ($101))|0;
 $103 = ((($1)) + 8|0); //@line 119271 "c/sqlite3.c"
 $104 = HEAP32[$103>>2]|0; //@line 119271 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4Int($8,$102,$104,$21,$46,$47)|0); //@line 119271 "c/sqlite3.c"
 $105 = ($96|0)==(0); //@line 119273 "c/sqlite3.c"
 if ($105) {
  return; //@line 119301 "c/sqlite3.c"
 }
 $106 = (_sqlite3VdbeAddOp1($8,49,$96)|0); //@line 119280 "c/sqlite3.c"
 $107 = HEAP32[$103>>2]|0; //@line 119281 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($8,33,$107)|0); //@line 119281 "c/sqlite3.c"
 $108 = ((($1)) + 29|0); //@line 119282 "c/sqlite3.c"
 $109 = HEAP8[$108>>0]|0; //@line 119282 "c/sqlite3.c"
 $110 = ($109<<24>>24)==(0); //@line 119282 "c/sqlite3.c"
 if ($110) {
  $$0169 = 0;
 } else {
  $111 = HEAP32[$19>>2]|0; //@line 119283 "c/sqlite3.c"
  $112 = (($111) + 1)|0; //@line 119283 "c/sqlite3.c"
  HEAP32[$19>>2] = $112; //@line 119283 "c/sqlite3.c"
  $113 = HEAP32[$103>>2]|0; //@line 119284 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($8,98,$113,$16,$112)|0); //@line 119284 "c/sqlite3.c"
  $$0169 = $112;
 }
 $114 = HEAP32[$103>>2]|0; //@line 119287 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($8,119,$114)|0); //@line 119287 "c/sqlite3.c"
 $115 = HEAP8[$108>>0]|0; //@line 119288 "c/sqlite3.c"
 $116 = ($115<<24>>24)==(0); //@line 119288 "c/sqlite3.c"
 if (!($116)) {
  $117 = (($$0) + ($16))|0; //@line 119295 "c/sqlite3.c"
  $118 = (_sqlite3VdbeCurrentAddr($8)|0); //@line 119294 "c/sqlite3.c"
  $119 = (($118) + 2)|0; //@line 119294 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($8,53,$117,$119,$$0169)|0); //@line 119295 "c/sqlite3.c"
  _sqlite3VdbeChangeP5($8,128); //@line 119296 "c/sqlite3.c"
 }
 _sqlite3VdbeJumpHere($8,$106); //@line 119299 "c/sqlite3.c"
 return; //@line 119301 "c/sqlite3.c"
}
function _substExpr($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$055 = 0, $$056 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $8 = 0, $9 = 0;
 var dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $2 = sp;
 $3 = ($1|0)==(0|0); //@line 121856 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 121907 "c/sqlite3.c"
 }
 $4 = ((($1)) + 4|0); //@line 121857 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 121857 "c/sqlite3.c"
 $6 = $5 & 1; //@line 121857 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 121857 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($1)) + 36|0); //@line 121858 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 121858 "c/sqlite3.c"
  $10 = $9 << 16 >> 16; //@line 121858 "c/sqlite3.c"
  $11 = ((($0)) + 4|0); //@line 121858 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 121858 "c/sqlite3.c"
  $13 = ($12|0)==($10|0); //@line 121858 "c/sqlite3.c"
  if ($13) {
   $14 = ((($0)) + 8|0); //@line 121860 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 121860 "c/sqlite3.c"
   $16 = $15&65535; //@line 121860 "c/sqlite3.c"
   HEAP16[$8>>1] = $16; //@line 121860 "c/sqlite3.c"
  }
 }
 $17 = HEAP8[$1>>0]|0; //@line 121862 "c/sqlite3.c"
 switch ($17<<24>>24) {
 case -111:  {
  $18 = ((($1)) + 28|0); //@line 121862 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 121862 "c/sqlite3.c"
  $20 = ((($0)) + 4|0); //@line 121862 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 121862 "c/sqlite3.c"
  $22 = ($19|0)==($21|0); //@line 121862 "c/sqlite3.c"
  if ($22) {
   $23 = ((($1)) + 32|0); //@line 121863 "c/sqlite3.c"
   $24 = HEAP16[$23>>1]|0; //@line 121863 "c/sqlite3.c"
   $25 = ($24<<16>>16)<(0); //@line 121863 "c/sqlite3.c"
   if ($25) {
    HEAP8[$1>>0] = 101; //@line 121864 "c/sqlite3.c"
    $$0 = $1;
    STACKTOP = sp;return ($$0|0); //@line 121907 "c/sqlite3.c"
   }
   $26 = $24 << 16 >> 16; //@line 121863 "c/sqlite3.c"
   $27 = ((($0)) + 16|0); //@line 121867 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 121867 "c/sqlite3.c"
   $29 = (((($28)) + 4|0) + (($26*20)|0)|0); //@line 121867 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 121867 "c/sqlite3.c"
   $31 = (_sqlite3ExprIsVector($30)|0); //@line 121871 "c/sqlite3.c"
   $32 = ($31|0)==(0); //@line 121871 "c/sqlite3.c"
   $33 = HEAP32[$0>>2]|0;
   if ($32) {
    $34 = HEAP32[$33>>2]|0; //@line 121874 "c/sqlite3.c"
    $35 = ((($0)) + 12|0); //@line 121875 "c/sqlite3.c"
    $36 = HEAP32[$35>>2]|0; //@line 121875 "c/sqlite3.c"
    $37 = ($36|0)==(0); //@line 121875 "c/sqlite3.c"
    if ($37) {
     $$055 = $30;
    } else {
     $38 = HEAP8[$30>>0]|0; //@line 121875 "c/sqlite3.c"
     $39 = ($38<<24>>24)==(-111); //@line 121875 "c/sqlite3.c"
     if ($39) {
      $$055 = $30;
     } else {
      dest=$2; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 121876 "c/sqlite3.c"
      HEAP8[$2>>0] = -103; //@line 121877 "c/sqlite3.c"
      $40 = ((($2)) + 12|0); //@line 121878 "c/sqlite3.c"
      HEAP32[$40>>2] = $30; //@line 121878 "c/sqlite3.c"
      $41 = ((($0)) + 8|0); //@line 121879 "c/sqlite3.c"
      $42 = HEAP32[$41>>2]|0; //@line 121879 "c/sqlite3.c"
      $43 = ((($2)) + 28|0); //@line 121879 "c/sqlite3.c"
      HEAP32[$43>>2] = $42; //@line 121879 "c/sqlite3.c"
      $$055 = $2;
     }
    }
    $44 = (_sqlite3ExprDup($34,$$055,0)|0); //@line 121882 "c/sqlite3.c"
    $45 = ($44|0)==(0|0); //@line 121883 "c/sqlite3.c"
    if (!($45)) {
     $46 = HEAP32[$35>>2]|0; //@line 121883 "c/sqlite3.c"
     $47 = ($46|0)==(0); //@line 121883 "c/sqlite3.c"
     if (!($47)) {
      $48 = ((($44)) + 4|0); //@line 121884 "c/sqlite3.c"
      $49 = HEAP32[$48>>2]|0; //@line 121884 "c/sqlite3.c"
      $50 = $49 | 1048576; //@line 121884 "c/sqlite3.c"
      HEAP32[$48>>2] = $50; //@line 121884 "c/sqlite3.c"
     }
     $51 = HEAP32[$4>>2]|0; //@line 121886 "c/sqlite3.c"
     $52 = $51 & 1; //@line 121886 "c/sqlite3.c"
     $53 = ($52|0)==(0); //@line 121886 "c/sqlite3.c"
     if (!($53)) {
      $54 = ((($1)) + 36|0); //@line 121887 "c/sqlite3.c"
      $55 = HEAP16[$54>>1]|0; //@line 121887 "c/sqlite3.c"
      $56 = ((($44)) + 36|0); //@line 121887 "c/sqlite3.c"
      HEAP16[$56>>1] = $55; //@line 121887 "c/sqlite3.c"
      $57 = ((($44)) + 4|0); //@line 121888 "c/sqlite3.c"
      $58 = HEAP32[$57>>2]|0; //@line 121888 "c/sqlite3.c"
      $59 = $58 | 1; //@line 121888 "c/sqlite3.c"
      HEAP32[$57>>2] = $59; //@line 121888 "c/sqlite3.c"
     }
    }
    _sqlite3ExprDelete($34,$1); //@line 121890 "c/sqlite3.c"
    $$056 = $44;
   } else {
    _sqlite3VectorErrorMsg($33,$30); //@line 121872 "c/sqlite3.c"
    $$056 = $1;
   }
   $$0 = $$056;
   STACKTOP = sp;return ($$0|0); //@line 121907 "c/sqlite3.c"
  }
  break;
 }
 case -103:  {
  $60 = ((($1)) + 28|0); //@line 121895 "c/sqlite3.c"
  $61 = HEAP32[$60>>2]|0; //@line 121895 "c/sqlite3.c"
  $62 = ((($0)) + 4|0); //@line 121895 "c/sqlite3.c"
  $63 = HEAP32[$62>>2]|0; //@line 121895 "c/sqlite3.c"
  $64 = ($61|0)==($63|0); //@line 121895 "c/sqlite3.c"
  if ($64) {
   $65 = ((($0)) + 8|0); //@line 121896 "c/sqlite3.c"
   $66 = HEAP32[$65>>2]|0; //@line 121896 "c/sqlite3.c"
   HEAP32[$60>>2] = $66; //@line 121896 "c/sqlite3.c"
  }
  break;
 }
 default: {
 }
 }
 $67 = ((($1)) + 12|0); //@line 121898 "c/sqlite3.c"
 $68 = HEAP32[$67>>2]|0; //@line 121898 "c/sqlite3.c"
 $69 = (_substExpr($0,$68)|0); //@line 121898 "c/sqlite3.c"
 HEAP32[$67>>2] = $69; //@line 121898 "c/sqlite3.c"
 $70 = ((($1)) + 16|0); //@line 121899 "c/sqlite3.c"
 $71 = HEAP32[$70>>2]|0; //@line 121899 "c/sqlite3.c"
 $72 = (_substExpr($0,$71)|0); //@line 121899 "c/sqlite3.c"
 HEAP32[$70>>2] = $72; //@line 121899 "c/sqlite3.c"
 $73 = HEAP32[$4>>2]|0; //@line 121900 "c/sqlite3.c"
 $74 = $73 & 2048; //@line 121900 "c/sqlite3.c"
 $75 = ($74|0)==(0); //@line 121900 "c/sqlite3.c"
 $76 = ((($1)) + 20|0);
 if ($75) {
  $78 = HEAP32[$76>>2]|0; //@line 121903 "c/sqlite3.c"
  _substExprList($0,$78); //@line 121903 "c/sqlite3.c"
  $$0 = $1;
  STACKTOP = sp;return ($$0|0); //@line 121907 "c/sqlite3.c"
 } else {
  $77 = HEAP32[$76>>2]|0; //@line 121901 "c/sqlite3.c"
  _substSelect($0,$77,1); //@line 121901 "c/sqlite3.c"
  $$0 = $1;
  STACKTOP = sp;return ($$0|0); //@line 121907 "c/sqlite3.c"
 }
 return (0)|0;
}
function _substSelect($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03032 = 0, $$031 = 0, $$033 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 121926 "c/sqlite3.c"
 if ($3) {
  return; //@line 121942 "c/sqlite3.c"
 }
 $4 = ($2|0)==(0);
 $$031 = $1;
 while(1) {
  $5 = HEAP32[$$031>>2]|0; //@line 121928 "c/sqlite3.c"
  _substExprList($0,$5); //@line 121928 "c/sqlite3.c"
  $6 = ((($$031)) + 36|0); //@line 121929 "c/sqlite3.c"
  $7 = HEAP32[$6>>2]|0; //@line 121929 "c/sqlite3.c"
  _substExprList($0,$7); //@line 121929 "c/sqlite3.c"
  $8 = ((($$031)) + 44|0); //@line 121930 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 121930 "c/sqlite3.c"
  _substExprList($0,$9); //@line 121930 "c/sqlite3.c"
  $10 = ((($$031)) + 40|0); //@line 121931 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 121931 "c/sqlite3.c"
  $12 = (_substExpr($0,$11)|0); //@line 121931 "c/sqlite3.c"
  HEAP32[$10>>2] = $12; //@line 121931 "c/sqlite3.c"
  $13 = ((($$031)) + 32|0); //@line 121932 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 121932 "c/sqlite3.c"
  $15 = (_substExpr($0,$14)|0); //@line 121932 "c/sqlite3.c"
  HEAP32[$13>>2] = $15; //@line 121932 "c/sqlite3.c"
  $16 = ((($$031)) + 28|0); //@line 121933 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 121933 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 121935 "c/sqlite3.c"
  $19 = ($18|0)>(0); //@line 121935 "c/sqlite3.c"
  if ($19) {
   $20 = ((($17)) + 8|0); //@line 121935 "c/sqlite3.c"
   $$03032 = $20;$$033 = $18;
   while(1) {
    $21 = ((($$03032)) + 20|0); //@line 121936 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 121936 "c/sqlite3.c"
    _substSelect($0,$22,1); //@line 121936 "c/sqlite3.c"
    $23 = ((($$03032)) + 37|0); //@line 121937 "c/sqlite3.c"
    $24 = HEAP8[$23>>0]|0; //@line 121937 "c/sqlite3.c"
    $25 = $24 & 4; //@line 121937 "c/sqlite3.c"
    $26 = ($25<<24>>24)==(0); //@line 121937 "c/sqlite3.c"
    if (!($26)) {
     $27 = ((($$03032)) + 64|0); //@line 121938 "c/sqlite3.c"
     $28 = HEAP32[$27>>2]|0; //@line 121938 "c/sqlite3.c"
     _substExprList($0,$28); //@line 121938 "c/sqlite3.c"
    }
    $29 = (($$033) + -1)|0; //@line 121935 "c/sqlite3.c"
    $30 = ((($$03032)) + 72|0); //@line 121935 "c/sqlite3.c"
    $31 = ($$033|0)>(1); //@line 121935 "c/sqlite3.c"
    if ($31) {
     $$03032 = $30;$$033 = $29;
    } else {
     break;
    }
   }
  }
  if ($4) {
   label = 10;
   break;
  }
  $32 = ((($$031)) + 48|0); //@line 121941 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 121941 "c/sqlite3.c"
  $34 = ($33|0)==(0|0); //@line 121941 "c/sqlite3.c"
  if ($34) {
   label = 10;
   break;
  } else {
   $$031 = $33;
  }
 }
 if ((label|0) == 10) {
  return; //@line 121942 "c/sqlite3.c"
 }
}
function _substExprList($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$09 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 121913 "c/sqlite3.c"
 if ($2) {
  return; //@line 121917 "c/sqlite3.c"
 }
 $3 = HEAP32[$1>>2]|0; //@line 121914 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 121914 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 121917 "c/sqlite3.c"
 }
 $$09 = 0;
 while(1) {
  $5 = (((($1)) + 4|0) + (($$09*20)|0)|0); //@line 121915 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 121915 "c/sqlite3.c"
  $7 = (_substExpr($0,$6)|0); //@line 121915 "c/sqlite3.c"
  HEAP32[$5>>2] = $7; //@line 121915 "c/sqlite3.c"
  $8 = (($$09) + 1)|0; //@line 121914 "c/sqlite3.c"
  $9 = HEAP32[$1>>2]|0; //@line 121914 "c/sqlite3.c"
  $10 = ($8|0)<($9|0); //@line 121914 "c/sqlite3.c"
  if ($10) {
   $$09 = $8;
  } else {
   break;
  }
 }
 return; //@line 121917 "c/sqlite3.c"
}
function _multiSelectValues($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$024 = 0, $$025 = 0, $$1 = 0, $$12627 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$024 = 1;$$025 = $1;
 while(1) {
  $3 = ((($$025)) + 48|0); //@line 120896 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 120896 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 120896 "c/sqlite3.c"
  $6 = (($$024) + 1)|0; //@line 120899 "c/sqlite3.c"
  if ($5) {
   break;
  } else {
   $$024 = $6;$$025 = $4;
  }
 }
 $7 = ((($1)) + 56|0); //@line 120906 "c/sqlite3.c"
 $8 = ($$025|0)==(0|0); //@line 120901 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
  return ($$1|0); //@line 120910 "c/sqlite3.c"
 }
 $9 = $$024&65535;
 $$12627 = $$025;
 while(1) {
  $10 = ((($$12627)) + 48|0); //@line 120902 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 120902 "c/sqlite3.c"
  HEAP32[$10>>2] = 0; //@line 120903 "c/sqlite3.c"
  $12 = (_sqlite3Select($0,$$12627,$2)|0); //@line 120904 "c/sqlite3.c"
  HEAP32[$10>>2] = $11; //@line 120905 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 120906 "c/sqlite3.c"
  if (!($13)) {
   $$1 = $12;
   label = 8;
   break;
  }
  $14 = HEAP32[$7>>2]|0; //@line 120906 "c/sqlite3.c"
  $15 = ($14|0)==(0|0); //@line 120906 "c/sqlite3.c"
  if (!($15)) {
   $$1 = 0;
   label = 8;
   break;
  }
  $16 = ((($$12627)) + 6|0); //@line 120907 "c/sqlite3.c"
  HEAP16[$16>>1] = $9; //@line 120907 "c/sqlite3.c"
  $17 = ((($$12627)) + 52|0); //@line 120908 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 120908 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 120901 "c/sqlite3.c"
  if ($19) {
   $$1 = 0;
   label = 8;
   break;
  } else {
   $$12627 = $18;
  }
 }
 if ((label|0) == 8) {
  return ($$1|0); //@line 120910 "c/sqlite3.c"
 }
 return (0)|0;
}
function _generateWithRecursiveQuery($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0140 = 0, $$0141 = 0, $$0142144 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 8|0;
 $4 = ((($1)) + 28|0); //@line 120734 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 120734 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 120735 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 120735 "c/sqlite3.c"
 $8 = ((($0)) + 8|0); //@line 120736 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 120736 "c/sqlite3.c"
 $10 = ((($1)) + 48|0); //@line 120737 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 120737 "c/sqlite3.c"
 $12 = (_sqlite3AuthCheck($0,33,0,0,0)|0); //@line 120753 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 120753 "c/sqlite3.c"
 if (!($13)) {
  STACKTOP = sp;return; //@line 120856 "c/sqlite3.c"
 }
 $14 = (_sqlite3VdbeMakeLabel($9)|0); //@line 120756 "c/sqlite3.c"
 $15 = ((($1)) + 6|0); //@line 120757 "c/sqlite3.c"
 HEAP16[$15>>1] = 320; //@line 120757 "c/sqlite3.c"
 _computeLimitRegisters($0,$1,$14); //@line 120758 "c/sqlite3.c"
 $16 = ((($1)) + 56|0); //@line 120759 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 120759 "c/sqlite3.c"
 $18 = ((($1)) + 12|0); //@line 120760 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 120760 "c/sqlite3.c"
 $20 = ((($1)) + 16|0); //@line 120761 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 120761 "c/sqlite3.c"
 HEAP32[$16>>2] = 0; //@line 120762 "c/sqlite3.c"
 HEAP32[$20>>2] = 0; //@line 120763 "c/sqlite3.c"
 HEAP32[$18>>2] = 0; //@line 120763 "c/sqlite3.c"
 $22 = ((($1)) + 44|0); //@line 120764 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 120764 "c/sqlite3.c"
 $24 = HEAP32[$5>>2]|0; //@line 120767 "c/sqlite3.c"
 $25 = ($24|0)>(0); //@line 120767 "c/sqlite3.c"
 L4: do {
  if ($25) {
   $$0142144 = 0;
   while(1) {
    $26 = (((((($5)) + 8|0) + (($$0142144*72)|0)|0)) + 37|0); //@line 120768 "c/sqlite3.c"
    $27 = HEAP8[$26>>0]|0; //@line 120768 "c/sqlite3.c"
    $28 = $27 & 32; //@line 120768 "c/sqlite3.c"
    $29 = ($28<<24>>24)==(0); //@line 120768 "c/sqlite3.c"
    if (!($29)) {
     break;
    }
    $32 = (($$0142144) + 1)|0; //@line 120767 "c/sqlite3.c"
    $33 = HEAP32[$5>>2]|0; //@line 120767 "c/sqlite3.c"
    $34 = ($32|0)<($33|0); //@line 120767 "c/sqlite3.c"
    if ($34) {
     $$0142144 = $32;
    } else {
     $$0 = 0;
     break L4;
    }
   }
   $30 = (((((($5)) + 8|0) + (($$0142144*72)|0)|0)) + 44|0); //@line 120769 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 120769 "c/sqlite3.c"
   $$0 = $31;
  } else {
   $$0 = 0;
  }
 } while(0);
 $35 = ((($0)) + 40|0); //@line 120777 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 120777 "c/sqlite3.c"
 $37 = (($36) + 1)|0; //@line 120777 "c/sqlite3.c"
 HEAP32[$35>>2] = $37; //@line 120777 "c/sqlite3.c"
 $38 = ((($1)) + 4|0); //@line 120778 "c/sqlite3.c"
 $39 = HEAP8[$38>>0]|0; //@line 120778 "c/sqlite3.c"
 $40 = ($39<<24>>24)==(115); //@line 120778 "c/sqlite3.c"
 $41 = ($23|0)!=(0|0);
 if ($40) {
  $42 = $41 ? 8 : 6; //@line 120779 "c/sqlite3.c"
  $43 = (($36) + 2)|0; //@line 120780 "c/sqlite3.c"
  HEAP32[$35>>2] = $43; //@line 120780 "c/sqlite3.c"
  $$0140 = $37;$$0141 = $42;
 } else {
  $44 = $41 ? 7 : 5; //@line 120782 "c/sqlite3.c"
  $$0140 = 0;$$0141 = $44;
 }
 _sqlite3SelectDestInit($3,$$0141,$36); //@line 120784 "c/sqlite3.c"
 $45 = ((($0)) + 44|0); //@line 120787 "c/sqlite3.c"
 $46 = HEAP32[$45>>2]|0; //@line 120787 "c/sqlite3.c"
 $47 = (($46) + 1)|0; //@line 120787 "c/sqlite3.c"
 HEAP32[$45>>2] = $47; //@line 120787 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($9,112,$$0,$47,$7)|0); //@line 120788 "c/sqlite3.c"
 if ($41) {
  $48 = (_multiSelectOrderByKeyInfo($0,$1)|0); //@line 120790 "c/sqlite3.c"
  $49 = HEAP32[$23>>2]|0; //@line 120791 "c/sqlite3.c"
  $50 = (($49) + 2)|0; //@line 120791 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4($9,109,$36,$50,0,$48,-9)|0); //@line 120791 "c/sqlite3.c"
  $51 = ((($3)) + 20|0); //@line 120793 "c/sqlite3.c"
  HEAP32[$51>>2] = $23; //@line 120793 "c/sqlite3.c"
 } else {
  (_sqlite3VdbeAddOp2($9,109,$36,$7)|0); //@line 120795 "c/sqlite3.c"
 }
 $52 = ($$0140|0)==(0); //@line 120798 "c/sqlite3.c"
 if (!($52)) {
  $53 = (_sqlite3VdbeAddOp2($9,109,$$0140,0)|0); //@line 120799 "c/sqlite3.c"
  $54 = ((($1)) + 20|0); //@line 120799 "c/sqlite3.c"
  HEAP32[$54>>2] = $53; //@line 120799 "c/sqlite3.c"
  $55 = ((($1)) + 8|0); //@line 120800 "c/sqlite3.c"
  $56 = HEAP32[$55>>2]|0; //@line 120800 "c/sqlite3.c"
  $57 = $56 | 32; //@line 120800 "c/sqlite3.c"
  HEAP32[$55>>2] = $57; //@line 120800 "c/sqlite3.c"
 }
 HEAP32[$22>>2] = 0; //@line 120804 "c/sqlite3.c"
 $58 = ((($11)) + 52|0); //@line 120807 "c/sqlite3.c"
 HEAP32[$58>>2] = 0; //@line 120807 "c/sqlite3.c"
 $59 = (_sqlite3Select($0,$11,$3)|0); //@line 120808 "c/sqlite3.c"
 HEAP32[$58>>2] = $1; //@line 120809 "c/sqlite3.c"
 $60 = ($59|0)==(0); //@line 120810 "c/sqlite3.c"
 if ($60) {
  $61 = (_sqlite3VdbeAddOp2($9,37,$36,$14)|0); //@line 120813 "c/sqlite3.c"
  (_sqlite3VdbeAddOp1($9,125,$$0)|0); //@line 120816 "c/sqlite3.c"
  if ($41) {
   $62 = HEAP32[$23>>2]|0; //@line 120818 "c/sqlite3.c"
   $63 = (($62) + 1)|0; //@line 120818 "c/sqlite3.c"
   (_sqlite3VdbeAddOp3($9,98,$36,$63,$47)|0); //@line 120818 "c/sqlite3.c"
  } else {
   (_sqlite3VdbeAddOp2($9,123,$36,$47)|0); //@line 120820 "c/sqlite3.c"
  }
  (_sqlite3VdbeAddOp1($9,119,$36)|0); //@line 120822 "c/sqlite3.c"
  $64 = (_sqlite3VdbeMakeLabel($9)|0); //@line 120825 "c/sqlite3.c"
  _codeOffset($9,$21,$64); //@line 120826 "c/sqlite3.c"
  _selectInnerLoop($0,$1,$$0,0,0,$2,$64,$14); //@line 120827 "c/sqlite3.c"
  $65 = ($19|0)==(0); //@line 120829 "c/sqlite3.c"
  if (!($65)) {
   (_sqlite3VdbeAddOp2($9,59,$19,$14)|0); //@line 120830 "c/sqlite3.c"
  }
  _sqlite3VdbeResolveLabel($9,$64); //@line 120833 "c/sqlite3.c"
  $66 = ((($1)) + 8|0); //@line 120838 "c/sqlite3.c"
  $67 = HEAP32[$66>>2]|0; //@line 120838 "c/sqlite3.c"
  $68 = $67 & 8; //@line 120838 "c/sqlite3.c"
  $69 = ($68|0)==(0); //@line 120838 "c/sqlite3.c"
  if ($69) {
   HEAP32[$10>>2] = 0; //@line 120841 "c/sqlite3.c"
   (_sqlite3Select($0,$1,$3)|0); //@line 120842 "c/sqlite3.c"
   HEAP32[$10>>2] = $11; //@line 120844 "c/sqlite3.c"
  } else {
   _sqlite3ErrorMsg($0,28680,$vararg_buffer); //@line 120839 "c/sqlite3.c"
  }
  _sqlite3VdbeGoto($9,$61); //@line 120848 "c/sqlite3.c"
  _sqlite3VdbeResolveLabel($9,$14); //@line 120849 "c/sqlite3.c"
 }
 $70 = HEAP32[$0>>2]|0; //@line 120852 "c/sqlite3.c"
 $71 = HEAP32[$22>>2]|0; //@line 120852 "c/sqlite3.c"
 _sqlite3ExprListDelete($70,$71); //@line 120852 "c/sqlite3.c"
 HEAP32[$22>>2] = $23; //@line 120853 "c/sqlite3.c"
 HEAP32[$16>>2] = $17; //@line 120854 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 120856 "c/sqlite3.c"
}
function _multiSelectOrderBy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0333373 = 0, $$0336384 = 0, $$0339376 = 0, $$0340$lcssa = 0, $$0340375 = 0, $$0341 = 0, $$0342 = 0, $$0343383 = 0, $$0348382 = 0, $$0353 = 0, $$0354 = 0, $$0355 = 0, $$0356 = 0, $$0357 = 0, $$0358 = 0, $$0359 = 0, $$0360 = 0, $$0361 = 0, $$1337372 = 0, $$2338371 = 0;
 var $$3351$ph = 0, $$4 = 0, $$4347$ph = 0, $$4352 = 0, $$5 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0;
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0;
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0;
 var $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0;
 var $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond393 = 0, $or$cond = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $3 = sp + 24|0;
 $4 = sp;
 $5 = HEAP32[$0>>2]|0; //@line 121564 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 121565 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 121565 "c/sqlite3.c"
 $8 = (_sqlite3VdbeMakeLabel($7)|0); //@line 121567 "c/sqlite3.c"
 $9 = (_sqlite3VdbeMakeLabel($7)|0); //@line 121568 "c/sqlite3.c"
 $10 = ((($1)) + 4|0); //@line 121573 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 121573 "c/sqlite3.c"
 $12 = ((($1)) + 48|0); //@line 121574 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 121574 "c/sqlite3.c"
 $14 = ((($1)) + 44|0); //@line 121576 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 121576 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 121578 "c/sqlite3.c"
 $17 = ($11<<24>>24)==(116); //@line 121584 "c/sqlite3.c"
 L1: do {
  if ($17) {
   $$4352 = $15;$$5 = $16;
  } else {
   $18 = ((($5)) + 73|0); //@line 121585 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 121585 "c/sqlite3.c"
   $20 = ($19<<24>>24)==(0); //@line 121585 "c/sqlite3.c"
   if ($20) {
    $$0336384 = 1;$$0343383 = $16;$$0348382 = $15;
    while(1) {
     $21 = HEAP32[$1>>2]|0; //@line 121585 "c/sqlite3.c"
     $22 = HEAP32[$21>>2]|0; //@line 121585 "c/sqlite3.c"
     $23 = ($$0336384|0)>($22|0); //@line 121585 "c/sqlite3.c"
     if ($23) {
      $$4352 = $$0348382;$$5 = $$0343383;
      break L1;
     }
     $24 = ($$0343383|0)>(0); //@line 121587 "c/sqlite3.c"
     L7: do {
      if ($24) {
       $25 = ((($$0348382)) + 4|0); //@line 121587 "c/sqlite3.c"
       $$0339376 = $25;$$0340375 = 0;
       while(1) {
        $26 = ((($$0339376)) + 16|0); //@line 121589 "c/sqlite3.c"
        $27 = HEAP16[$26>>1]|0; //@line 121589 "c/sqlite3.c"
        $28 = $27&65535; //@line 121589 "c/sqlite3.c"
        $29 = ($$0336384|0)==($28|0); //@line 121589 "c/sqlite3.c"
        if ($29) {
         $$0340$lcssa = $$0340375;
         break L7;
        }
        $30 = (($$0340375) + 1)|0; //@line 121587 "c/sqlite3.c"
        $31 = ((($$0339376)) + 20|0); //@line 121587 "c/sqlite3.c"
        $32 = ($30|0)<($$0343383|0); //@line 121587 "c/sqlite3.c"
        if ($32) {
         $$0339376 = $31;$$0340375 = $30;
        } else {
         $$0340$lcssa = $30;
         break;
        }
       }
      } else {
       $$0340$lcssa = 0;
      }
     } while(0);
     $33 = ($$0340$lcssa|0)==($$0343383|0); //@line 121591 "c/sqlite3.c"
     if ($33) {
      $34 = (_sqlite3Expr($5,134,0)|0); //@line 121592 "c/sqlite3.c"
      $35 = ($34|0)==(0|0); //@line 121593 "c/sqlite3.c"
      if ($35) {
       $$4 = 7;
       break;
      }
      $36 = ((($34)) + 4|0); //@line 121594 "c/sqlite3.c"
      $37 = HEAP32[$36>>2]|0; //@line 121594 "c/sqlite3.c"
      $38 = $37 | 1024; //@line 121594 "c/sqlite3.c"
      HEAP32[$36>>2] = $38; //@line 121594 "c/sqlite3.c"
      $39 = ((($34)) + 8|0); //@line 121595 "c/sqlite3.c"
      HEAP32[$39>>2] = $$0336384; //@line 121595 "c/sqlite3.c"
      $40 = (_sqlite3ExprListAppend($0,$$0348382,$34)|0); //@line 121596 "c/sqlite3.c"
      HEAP32[$14>>2] = $40; //@line 121596 "c/sqlite3.c"
      $41 = ($40|0)==(0|0); //@line 121597 "c/sqlite3.c"
      if ($41) {
       $$3351$ph = 0;$$4347$ph = $$0343383;
      } else {
       $42 = (((((($40)) + 4|0) + (($$0343383*20)|0)|0)) + 16|0); //@line 121597 "c/sqlite3.c"
       $43 = (($$0343383) + 1)|0; //@line 121597 "c/sqlite3.c"
       $44 = $$0336384&65535; //@line 121597 "c/sqlite3.c"
       HEAP16[$42>>1] = $44; //@line 121597 "c/sqlite3.c"
       $$3351$ph = $40;$$4347$ph = $43;
      }
     } else {
      $$3351$ph = $$0348382;$$4347$ph = $$0343383;
     }
     $45 = (($$0336384) + 1)|0; //@line 121585 "c/sqlite3.c"
     $46 = HEAP8[$18>>0]|0; //@line 121585 "c/sqlite3.c"
     $47 = ($46<<24>>24)==(0); //@line 121585 "c/sqlite3.c"
     if ($47) {
      $$0336384 = $45;$$0343383 = $$4347$ph;$$0348382 = $$3351$ph;
     } else {
      $$4352 = $$3351$ph;$$5 = $$4347$ph;
      break L1;
     }
    }
    STACKTOP = sp;return ($$4|0); //@line 121816 "c/sqlite3.c"
   } else {
    $$4352 = $15;$$5 = $16;
   }
  }
 } while(0);
 $48 = $$5 << 2; //@line 121609 "c/sqlite3.c"
 $49 = (($48) + 4)|0; //@line 121609 "c/sqlite3.c"
 $50 = (_sqlite3DbMallocRawNN($5,$49,0)|0); //@line 121609 "c/sqlite3.c"
 $51 = ($50|0)==(0|0); //@line 121610 "c/sqlite3.c"
 if ($51) {
  $$0354 = 0;
 } else {
  HEAP32[$50>>2] = $$5; //@line 121612 "c/sqlite3.c"
  $52 = ($$5|0)<(1); //@line 121613 "c/sqlite3.c"
  if (!($52)) {
   $53 = ((($$4352)) + 4|0); //@line 121613 "c/sqlite3.c"
   $$0333373 = $53;$$1337372 = 1;
   while(1) {
    $54 = ((($$0333373)) + 16|0); //@line 121616 "c/sqlite3.c"
    $55 = HEAP16[$54>>1]|0; //@line 121616 "c/sqlite3.c"
    $56 = $55&65535; //@line 121616 "c/sqlite3.c"
    $57 = (($56) + -1)|0; //@line 121616 "c/sqlite3.c"
    $58 = (($50) + ($$1337372<<2)|0); //@line 121616 "c/sqlite3.c"
    HEAP32[$58>>2] = $57; //@line 121616 "c/sqlite3.c"
    $59 = (($$1337372) + 1)|0; //@line 121613 "c/sqlite3.c"
    $60 = ((($$0333373)) + 20|0); //@line 121613 "c/sqlite3.c"
    $exitcond393 = ($$1337372|0)==($$5|0); //@line 121613 "c/sqlite3.c"
    if ($exitcond393) {
     break;
    } else {
     $$0333373 = $60;$$1337372 = $59;
    }
   }
  }
  $61 = (_multiSelectOrderByKeyInfo($0,$1)|0); //@line 121618 "c/sqlite3.c"
  $$0354 = $61;
 }
 HEAP32[$14>>2] = $$4352; //@line 121625 "c/sqlite3.c"
 $62 = HEAP32[$0>>2]|0; //@line 121626 "c/sqlite3.c"
 $63 = (_sqlite3ExprListDup($62,$$4352,0)|0); //@line 121626 "c/sqlite3.c"
 $64 = ((($13)) + 44|0); //@line 121626 "c/sqlite3.c"
 HEAP32[$64>>2] = $63; //@line 121626 "c/sqlite3.c"
 if ($17) {
  $$0355 = 0;$$0361 = 0;
 } else {
  $65 = HEAP32[$1>>2]|0; //@line 121635 "c/sqlite3.c"
  $66 = HEAP32[$65>>2]|0; //@line 121635 "c/sqlite3.c"
  $67 = ((($0)) + 44|0); //@line 121637 "c/sqlite3.c"
  $68 = HEAP32[$67>>2]|0; //@line 121637 "c/sqlite3.c"
  $69 = (($68) + 1)|0; //@line 121637 "c/sqlite3.c"
  $70 = (($68) + 1)|0; //@line 121638 "c/sqlite3.c"
  $71 = (($70) + ($66))|0; //@line 121638 "c/sqlite3.c"
  HEAP32[$67>>2] = $71; //@line 121638 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($7,67,0,$69)|0); //@line 121639 "c/sqlite3.c"
  $72 = (_sqlite3KeyInfoAlloc($5,$66,1)|0); //@line 121640 "c/sqlite3.c"
  $73 = ($72|0)==(0|0); //@line 121641 "c/sqlite3.c"
  if ($73) {
   $$0355 = 0;$$0361 = $69;
  } else {
   $74 = ($66|0)>(0); //@line 121643 "c/sqlite3.c"
   if ($74) {
    $75 = ((($72)) + 16|0);
    $$2338371 = 0;
    while(1) {
     $76 = (_multiSelectCollSeq($0,$1,$$2338371)|0); //@line 121644 "c/sqlite3.c"
     $77 = (((($72)) + 20|0) + ($$2338371<<2)|0); //@line 121644 "c/sqlite3.c"
     HEAP32[$77>>2] = $76; //@line 121644 "c/sqlite3.c"
     $78 = HEAP32[$75>>2]|0; //@line 121645 "c/sqlite3.c"
     $79 = (($78) + ($$2338371)|0); //@line 121645 "c/sqlite3.c"
     HEAP8[$79>>0] = 0; //@line 121645 "c/sqlite3.c"
     $80 = (($$2338371) + 1)|0; //@line 121643 "c/sqlite3.c"
     $exitcond = ($80|0)==($66|0); //@line 121643 "c/sqlite3.c"
     if ($exitcond) {
      $$0355 = $72;$$0361 = $69;
      break;
     } else {
      $$2338371 = $80;
     }
    }
   } else {
    $$0355 = $72;$$0361 = $69;
   }
  }
 }
 HEAP32[$12>>2] = 0; //@line 121652 "c/sqlite3.c"
 $81 = ((($13)) + 52|0); //@line 121653 "c/sqlite3.c"
 HEAP32[$81>>2] = 0; //@line 121653 "c/sqlite3.c"
 $82 = HEAP32[$14>>2]|0; //@line 121654 "c/sqlite3.c"
 (_sqlite3ResolveOrderGroupBy($0,$1,$82,22954)|0); //@line 121654 "c/sqlite3.c"
 $83 = ((($13)) + 48|0); //@line 121655 "c/sqlite3.c"
 $84 = HEAP32[$83>>2]|0; //@line 121655 "c/sqlite3.c"
 $85 = ($84|0)==(0|0); //@line 121655 "c/sqlite3.c"
 if ($85) {
  $86 = HEAP32[$64>>2]|0; //@line 121656 "c/sqlite3.c"
  (_sqlite3ResolveOrderGroupBy($0,$13,$86,22954)|0); //@line 121656 "c/sqlite3.c"
 }
 _computeLimitRegisters($0,$1,$8); //@line 121660 "c/sqlite3.c"
 $87 = ((($1)) + 12|0); //@line 121661 "c/sqlite3.c"
 $88 = HEAP32[$87>>2]|0; //@line 121661 "c/sqlite3.c"
 $89 = ($88|0)!=(0); //@line 121661 "c/sqlite3.c"
 $or$cond = $17 & $89; //@line 121661 "c/sqlite3.c"
 if ($or$cond) {
  $90 = ((($0)) + 44|0); //@line 121662 "c/sqlite3.c"
  $91 = HEAP32[$90>>2]|0; //@line 121662 "c/sqlite3.c"
  $92 = (($91) + 1)|0; //@line 121662 "c/sqlite3.c"
  $93 = (($91) + 2)|0; //@line 121663 "c/sqlite3.c"
  HEAP32[$90>>2] = $93; //@line 121663 "c/sqlite3.c"
  $94 = ((($1)) + 16|0); //@line 121664 "c/sqlite3.c"
  $95 = HEAP32[$94>>2]|0; //@line 121664 "c/sqlite3.c"
  $96 = ($95|0)==(0); //@line 121664 "c/sqlite3.c"
  $97 = (($95) + 1)|0; //@line 121664 "c/sqlite3.c"
  $spec$select = $96 ? $88 : $97; //@line 121664 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($7,75,$spec$select,$92)|0); //@line 121664 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($7,75,$92,$93)|0); //@line 121666 "c/sqlite3.c"
  $$0359 = $92;$$0360 = $93;
 } else {
  $$0359 = 0;$$0360 = 0;
 }
 $98 = ((($1)) + 56|0); //@line 121670 "c/sqlite3.c"
 $99 = HEAP32[$98>>2]|0; //@line 121670 "c/sqlite3.c"
 _sqlite3ExprDelete($5,$99); //@line 121670 "c/sqlite3.c"
 HEAP32[$98>>2] = 0; //@line 121671 "c/sqlite3.c"
 $100 = ((($0)) + 44|0); //@line 121673 "c/sqlite3.c"
 $101 = HEAP32[$100>>2]|0; //@line 121673 "c/sqlite3.c"
 $102 = (($101) + 1)|0; //@line 121673 "c/sqlite3.c"
 $103 = (($101) + 2)|0; //@line 121674 "c/sqlite3.c"
 $104 = (($101) + 3)|0; //@line 121675 "c/sqlite3.c"
 $105 = (($101) + 4)|0; //@line 121676 "c/sqlite3.c"
 HEAP32[$100>>2] = $105; //@line 121676 "c/sqlite3.c"
 _sqlite3SelectDestInit($3,13,$102); //@line 121677 "c/sqlite3.c"
 _sqlite3SelectDestInit($4,13,$103); //@line 121678 "c/sqlite3.c"
 $106 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 121683 "c/sqlite3.c"
 $107 = (($106) + 1)|0; //@line 121683 "c/sqlite3.c"
 $108 = (_sqlite3VdbeAddOp3($7,15,$102,0,$107)|0); //@line 121684 "c/sqlite3.c"
 $109 = ((($13)) + 12|0); //@line 121686 "c/sqlite3.c"
 HEAP32[$109>>2] = $$0359; //@line 121686 "c/sqlite3.c"
 $110 = ((($0)) + 416|0); //@line 121687 "c/sqlite3.c"
 $111 = HEAP32[$110>>2]|0; //@line 121687 "c/sqlite3.c"
 (_sqlite3Select($0,$13,$3)|0); //@line 121688 "c/sqlite3.c"
 _sqlite3VdbeEndCoroutine($7,$102); //@line 121689 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($7,$108); //@line 121690 "c/sqlite3.c"
 $112 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 121695 "c/sqlite3.c"
 $113 = (($112) + 1)|0; //@line 121695 "c/sqlite3.c"
 $114 = (_sqlite3VdbeAddOp3($7,15,$103,0,$113)|0); //@line 121696 "c/sqlite3.c"
 $115 = HEAP32[$87>>2]|0; //@line 121698 "c/sqlite3.c"
 $116 = ((($1)) + 16|0); //@line 121699 "c/sqlite3.c"
 $117 = HEAP32[$116>>2]|0; //@line 121699 "c/sqlite3.c"
 HEAP32[$87>>2] = $$0360; //@line 121700 "c/sqlite3.c"
 HEAP32[$116>>2] = 0; //@line 121701 "c/sqlite3.c"
 $118 = HEAP32[$110>>2]|0; //@line 121702 "c/sqlite3.c"
 (_sqlite3Select($0,$1,$4)|0); //@line 121703 "c/sqlite3.c"
 HEAP32[$87>>2] = $115; //@line 121704 "c/sqlite3.c"
 HEAP32[$116>>2] = $117; //@line 121705 "c/sqlite3.c"
 _sqlite3VdbeEndCoroutine($7,$103); //@line 121706 "c/sqlite3.c"
 $119 = (_generateOutputSubroutine($0,$1,$3,$2,$104,$$0361,$$0355,$8)|0); //@line 121712 "c/sqlite3.c"
 $120 = (($11) + -115)<<24>>24; //@line 121719 "c/sqlite3.c"
 $121 = ($120&255)<(2); //@line 121719 "c/sqlite3.c"
 if ($121) {
  $122 = (_generateOutputSubroutine($0,$1,$4,$2,$105,$$0361,$$0355,$8)|0); //@line 121721 "c/sqlite3.c"
  $$0341 = $122;
 } else {
  $$0341 = 0;
 }
 _sqlite3KeyInfoUnref($$0355); //@line 121725 "c/sqlite3.c"
 $123 = ($11<<24>>24)==(118); //@line 121730 "c/sqlite3.c"
 $124 = (($11) + -117)<<24>>24; //@line 121730 "c/sqlite3.c"
 $125 = ($124&255)<(2); //@line 121730 "c/sqlite3.c"
 if ($125) {
  $$0342 = $8;$$0353 = $8;
 } else {
  $126 = (_sqlite3VdbeAddOp2($7,14,$105,$$0341)|0); //@line 121734 "c/sqlite3.c"
  $127 = (_sqlite3VdbeAddOp2($7,16,$103,$8)|0); //@line 121735 "c/sqlite3.c"
  _sqlite3VdbeGoto($7,$126); //@line 121737 "c/sqlite3.c"
  $128 = ((($1)) + 6|0); //@line 121738 "c/sqlite3.c"
  $129 = HEAP16[$128>>1]|0; //@line 121738 "c/sqlite3.c"
  $130 = ((($13)) + 6|0); //@line 121738 "c/sqlite3.c"
  $131 = HEAP16[$130>>1]|0; //@line 121738 "c/sqlite3.c"
  $132 = (_sqlite3LogEstAdd($129,$131)|0); //@line 121738 "c/sqlite3.c"
  HEAP16[$128>>1] = $132; //@line 121738 "c/sqlite3.c"
  $$0342 = $126;$$0353 = $127;
 }
 if ($123) {
  $133 = ((($1)) + 6|0); //@line 121746 "c/sqlite3.c"
  $134 = HEAP16[$133>>1]|0; //@line 121746 "c/sqlite3.c"
  $135 = ((($13)) + 6|0); //@line 121746 "c/sqlite3.c"
  $136 = HEAP16[$135>>1]|0; //@line 121746 "c/sqlite3.c"
  $137 = ($134<<16>>16)>($136<<16>>16); //@line 121746 "c/sqlite3.c"
  if ($137) {
   HEAP16[$133>>1] = $136; //@line 121746 "c/sqlite3.c"
   $$0356 = $$0342;
  } else {
   $$0356 = $$0342;
  }
 } else {
  $138 = (_sqlite3VdbeAddOp2($7,14,$104,$119)|0); //@line 121749 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($7,16,$102,$8)|0); //@line 121750 "c/sqlite3.c"
  _sqlite3VdbeGoto($7,$138); //@line 121751 "c/sqlite3.c"
  $$0356 = $138;
 }
 $139 = (_sqlite3VdbeAddOp2($7,14,$104,$119)|0); //@line 121757 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($7,16,$102,$$0342)|0); //@line 121758 "c/sqlite3.c"
 _sqlite3VdbeGoto($7,$9); //@line 121759 "c/sqlite3.c"
 do {
  if ($17) {
   $$0357 = $139;$$0358 = $139;
  } else {
   if ($123) {
    $140 = (($139) + 1)|0; //@line 121767 "c/sqlite3.c"
    $$0357 = $140;$$0358 = $139;
    break;
   } else {
    $141 = (_sqlite3VdbeAddOp2($7,16,$102,$$0342)|0); //@line 121771 "c/sqlite3.c"
    _sqlite3VdbeGoto($7,$9); //@line 121772 "c/sqlite3.c"
    $$0357 = $139;$$0358 = $141;
    break;
   }
  }
 } while(0);
 $142 = (_sqlite3VdbeCurrentAddr($7)|0); //@line 121778 "c/sqlite3.c"
 if ($121) {
  (_sqlite3VdbeAddOp2($7,14,$105,$$0341)|0); //@line 121780 "c/sqlite3.c"
 }
 (_sqlite3VdbeAddOp2($7,16,$103,$$0356)|0); //@line 121782 "c/sqlite3.c"
 _sqlite3VdbeGoto($7,$9); //@line 121783 "c/sqlite3.c"
 _sqlite3VdbeJumpHere($7,$114); //@line 121787 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($7,16,$102,$$0353)|0); //@line 121788 "c/sqlite3.c"
 (_sqlite3VdbeAddOp2($7,16,$103,$$0356)|0); //@line 121789 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($7,$9); //@line 121793 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($7,83,0,0,0,$50,-15)|0); //@line 121794 "c/sqlite3.c"
 $143 = ((($3)) + 8|0); //@line 121795 "c/sqlite3.c"
 $144 = HEAP32[$143>>2]|0; //@line 121795 "c/sqlite3.c"
 $145 = ((($4)) + 8|0); //@line 121795 "c/sqlite3.c"
 $146 = HEAP32[$145>>2]|0; //@line 121795 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($7,94,$144,$146,$$5,$$0354,-9)|0); //@line 121795 "c/sqlite3.c"
 _sqlite3VdbeChangeP5($7,1); //@line 121797 "c/sqlite3.c"
 (_sqlite3VdbeAddOp3($7,18,$$0357,$$0358,$142)|0); //@line 121798 "c/sqlite3.c"
 _sqlite3VdbeResolveLabel($7,$8); //@line 121802 "c/sqlite3.c"
 $147 = HEAP32[$12>>2]|0; //@line 121806 "c/sqlite3.c"
 $148 = ($147|0)==(0|0); //@line 121806 "c/sqlite3.c"
 if (!($148)) {
  _sqlite3SelectDelete($5,$147); //@line 121807 "c/sqlite3.c"
 }
 HEAP32[$12>>2] = $13; //@line 121809 "c/sqlite3.c"
 HEAP32[$81>>2] = $1; //@line 121810 "c/sqlite3.c"
 $149 = HEAP8[$10>>0]|0; //@line 121814 "c/sqlite3.c"
 $150 = $149&255; //@line 121814 "c/sqlite3.c"
 _explainComposite($0,$150,$111,$118,0); //@line 121814 "c/sqlite3.c"
 $151 = ((($0)) + 36|0); //@line 121815 "c/sqlite3.c"
 $152 = HEAP32[$151>>2]|0; //@line 121815 "c/sqlite3.c"
 $153 = ($152|0)!=(0); //@line 121815 "c/sqlite3.c"
 $154 = $153&1; //@line 121815 "c/sqlite3.c"
 $$4 = $154;
 STACKTOP = sp;return ($$4|0); //@line 121816 "c/sqlite3.c"
}
function _explainComposite($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 119866 "c/sqlite3.c"
 $5 = ((($0)) + 399|0); //@line 119873 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 119873 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(2); //@line 119873 "c/sqlite3.c"
 if (!($7)) {
  STACKTOP = sp;return; //@line 119881 "c/sqlite3.c"
 }
 $8 = ((($0)) + 8|0); //@line 119874 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 119874 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 119876 "c/sqlite3.c"
 $11 = ($4|0)==(0); //@line 119877 "c/sqlite3.c"
 $12 = $11 ? 41388 : 28624; //@line 119877 "c/sqlite3.c"
 $13 = (_selectOpName($1)|0); //@line 119877 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 119875 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 119875 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $3; //@line 119875 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 119875 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $12; //@line 119875 "c/sqlite3.c"
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 119875 "c/sqlite3.c"
 HEAP32[$vararg_ptr3>>2] = $13; //@line 119875 "c/sqlite3.c"
 $14 = (_sqlite3MPrintf($10,28643,$vararg_buffer)|0); //@line 119875 "c/sqlite3.c"
 $15 = ((($0)) + 412|0); //@line 119879 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 119879 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($9,169,$16,0,0,$14,-7)|0); //@line 119879 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 119881 "c/sqlite3.c"
}
function _multiSelectCollSeq($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 48|0); //@line 120639 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 120639 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 120639 "c/sqlite3.c"
 if (!($5)) {
  $6 = (_multiSelectCollSeq($0,$4,$2)|0); //@line 120640 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 120648 "c/sqlite3.c"
  if (!($7)) {
   $$1 = $6;
   return ($$1|0); //@line 120651 "c/sqlite3.c"
  }
 }
 $8 = HEAP32[$1>>2]|0; //@line 120648 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 120648 "c/sqlite3.c"
 $10 = ($9|0)>($2|0); //@line 120648 "c/sqlite3.c"
 if (!($10)) {
  $$1 = 0;
  return ($$1|0); //@line 120651 "c/sqlite3.c"
 }
 $11 = (((($8)) + 4|0) + (($2*20)|0)|0); //@line 120649 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 120649 "c/sqlite3.c"
 $13 = (_sqlite3ExprCollSeq($0,$12)|0); //@line 120649 "c/sqlite3.c"
 $$1 = $13;
 return ($$1|0); //@line 120651 "c/sqlite3.c"
}
function _multiSelectOrderByKeyInfo($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0471 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 44|0); //@line 120664 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 120664 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 120665 "c/sqlite3.c"
 $5 = HEAP32[$0>>2]|0; //@line 120666 "c/sqlite3.c"
 $6 = (($4) + 1)|0; //@line 120667 "c/sqlite3.c"
 $7 = (_sqlite3KeyInfoAlloc($5,$6,1)|0); //@line 120667 "c/sqlite3.c"
 $8 = ($7|0)!=(0|0); //@line 120668 "c/sqlite3.c"
 $9 = ($4|0)>(0); //@line 120670 "c/sqlite3.c"
 $or$cond = $8 & $9; //@line 120668 "c/sqlite3.c"
 if (!($or$cond)) {
  return ($7|0); //@line 120689 "c/sqlite3.c"
 }
 $10 = ((($7)) + 16|0);
 $11 = ((($5)) + 8|0);
 $$0471 = 0;
 while(1) {
  $12 = (((($3)) + 4|0) + (($$0471*20)|0)|0); //@line 120672 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 120672 "c/sqlite3.c"
  $14 = ((($13)) + 4|0); //@line 120675 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 120675 "c/sqlite3.c"
  $16 = $15 & 256; //@line 120675 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 120675 "c/sqlite3.c"
  if ($17) {
   $19 = (((((($3)) + 4|0) + (($$0471*20)|0)|0)) + 16|0); //@line 120678 "c/sqlite3.c"
   $20 = HEAP16[$19>>1]|0; //@line 120678 "c/sqlite3.c"
   $21 = $20&65535; //@line 120678 "c/sqlite3.c"
   $22 = (($21) + -1)|0; //@line 120678 "c/sqlite3.c"
   $23 = (_multiSelectCollSeq($0,$1,$22)|0); //@line 120678 "c/sqlite3.c"
   $24 = ($23|0)==(0|0); //@line 120679 "c/sqlite3.c"
   if ($24) {
    $25 = HEAP32[$11>>2]|0; //@line 120679 "c/sqlite3.c"
    $$0 = $25;
   } else {
    $$0 = $23;
   }
   $26 = HEAP32[$$0>>2]|0; //@line 120681 "c/sqlite3.c"
   $27 = (_sqlite3ExprAddCollateString($0,$13,$26)|0); //@line 120681 "c/sqlite3.c"
   HEAP32[$12>>2] = $27; //@line 120680 "c/sqlite3.c"
   $$1 = $$0;
  } else {
   $18 = (_sqlite3ExprCollSeq($0,$13)|0); //@line 120676 "c/sqlite3.c"
   $$1 = $18;
  }
  $28 = (((($7)) + 20|0) + ($$0471<<2)|0); //@line 120684 "c/sqlite3.c"
  HEAP32[$28>>2] = $$1; //@line 120684 "c/sqlite3.c"
  $29 = (((((($3)) + 4|0) + (($$0471*20)|0)|0)) + 12|0); //@line 120685 "c/sqlite3.c"
  $30 = HEAP8[$29>>0]|0; //@line 120685 "c/sqlite3.c"
  $31 = HEAP32[$10>>2]|0; //@line 120685 "c/sqlite3.c"
  $32 = (($31) + ($$0471)|0); //@line 120685 "c/sqlite3.c"
  HEAP8[$32>>0] = $30; //@line 120685 "c/sqlite3.c"
  $33 = (($$0471) + 1)|0; //@line 120670 "c/sqlite3.c"
  $exitcond = ($33|0)==($4|0); //@line 120670 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$0471 = $33;
  }
 }
 return ($7|0); //@line 120689 "c/sqlite3.c"
}
function _generateOutputSubroutine($0,$1,$2,$3,$4,$5,$6,$7) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 $7 = $7|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $8 = ((($0)) + 8|0); //@line 121319 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 121319 "c/sqlite3.c"
 $10 = (_sqlite3VdbeCurrentAddr($9)|0); //@line 121323 "c/sqlite3.c"
 $11 = (_sqlite3VdbeMakeLabel($9)|0); //@line 121324 "c/sqlite3.c"
 $12 = ($5|0)==(0); //@line 121328 "c/sqlite3.c"
 if (!($12)) {
  $13 = (_sqlite3VdbeAddOp1($9,22,$5)|0); //@line 121330 "c/sqlite3.c"
  $14 = ((($2)) + 8|0); //@line 121331 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 121331 "c/sqlite3.c"
  $16 = (($5) + 1)|0; //@line 121331 "c/sqlite3.c"
  $17 = ((($2)) + 12|0); //@line 121331 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 121331 "c/sqlite3.c"
  $19 = (_sqlite3KeyInfoRef($6)|0); //@line 121332 "c/sqlite3.c"
  $20 = (_sqlite3VdbeAddOp4($9,94,$15,$16,$18,$6,-9)|0); //@line 121331 "c/sqlite3.c"
  $21 = (($20) + 2)|0; //@line 121333 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($9,18,$21,$11,$21)|0); //@line 121333 "c/sqlite3.c"
  _sqlite3VdbeJumpHere($9,$13); //@line 121334 "c/sqlite3.c"
  $22 = HEAP32[$14>>2]|0; //@line 121335 "c/sqlite3.c"
  $23 = HEAP32[$17>>2]|0; //@line 121335 "c/sqlite3.c"
  $24 = (($23) + -1)|0; //@line 121335 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($9,75,$22,$16,$24)|0); //@line 121335 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($9,67,1,$5)|0); //@line 121336 "c/sqlite3.c"
 }
 $25 = HEAP32[$0>>2]|0; //@line 121338 "c/sqlite3.c"
 $26 = ((($25)) + 73|0); //@line 121338 "c/sqlite3.c"
 $27 = HEAP8[$26>>0]|0; //@line 121338 "c/sqlite3.c"
 $28 = ($27<<24>>24)==(0); //@line 121338 "c/sqlite3.c"
 if (!($28)) {
  $$0 = 0;
  return ($$0|0); //@line 121430 "c/sqlite3.c"
 }
 $29 = ((($1)) + 16|0); //@line 121342 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 121342 "c/sqlite3.c"
 _codeOffset($9,$30,$11); //@line 121342 "c/sqlite3.c"
 $31 = HEAP8[$3>>0]|0; //@line 121346 "c/sqlite3.c"
 switch ($31<<24>>24) {
 case 12:  {
  $32 = (_sqlite3GetTempReg($0)|0); //@line 121350 "c/sqlite3.c"
  $33 = (_sqlite3GetTempReg($0)|0); //@line 121351 "c/sqlite3.c"
  $34 = ((($2)) + 8|0); //@line 121352 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 121352 "c/sqlite3.c"
  $36 = ((($2)) + 12|0); //@line 121352 "c/sqlite3.c"
  $37 = HEAP32[$36>>2]|0; //@line 121352 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($9,100,$35,$37,$32)|0); //@line 121352 "c/sqlite3.c"
  $38 = ((($3)) + 4|0); //@line 121353 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 121353 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($9,116,$39,$33)|0); //@line 121353 "c/sqlite3.c"
  $40 = HEAP32[$38>>2]|0; //@line 121354 "c/sqlite3.c"
  (_sqlite3VdbeAddOp3($9,117,$40,$32,$33)|0); //@line 121354 "c/sqlite3.c"
  _sqlite3VdbeChangeP5($9,8); //@line 121355 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$33); //@line 121356 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$32); //@line 121357 "c/sqlite3.c"
  break;
 }
 case 11:  {
  $41 = (_sqlite3GetTempReg($0)|0); //@line 121367 "c/sqlite3.c"
  $42 = ((($2)) + 8|0); //@line 121368 "c/sqlite3.c"
  $43 = HEAP32[$42>>2]|0; //@line 121368 "c/sqlite3.c"
  $44 = ((($2)) + 12|0); //@line 121368 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 121368 "c/sqlite3.c"
  $46 = ((($3)) + 16|0); //@line 121369 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 121369 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4($9,100,$43,$45,$41,$47,$45)|0); //@line 121368 "c/sqlite3.c"
  $48 = HEAP32[$42>>2]|0; //@line 121370 "c/sqlite3.c"
  $49 = HEAP32[$44>>2]|0; //@line 121370 "c/sqlite3.c"
  _sqlite3ExprCacheAffinityChange($0,$48,$49); //@line 121370 "c/sqlite3.c"
  $50 = ((($3)) + 4|0); //@line 121371 "c/sqlite3.c"
  $51 = HEAP32[$50>>2]|0; //@line 121371 "c/sqlite3.c"
  $52 = HEAP32[$42>>2]|0; //@line 121372 "c/sqlite3.c"
  $53 = HEAP32[$44>>2]|0; //@line 121372 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4Int($9,128,$51,$41,$52,$53)|0); //@line 121371 "c/sqlite3.c"
  _sqlite3ReleaseTempReg($0,$41); //@line 121373 "c/sqlite3.c"
  break;
 }
 case 10:  {
  $54 = ((($2)) + 8|0); //@line 121383 "c/sqlite3.c"
  $55 = HEAP32[$54>>2]|0; //@line 121383 "c/sqlite3.c"
  $56 = ((($3)) + 4|0); //@line 121383 "c/sqlite3.c"
  $57 = HEAP32[$56>>2]|0; //@line 121383 "c/sqlite3.c"
  _sqlite3ExprCodeMove($0,$55,$57,1); //@line 121383 "c/sqlite3.c"
  break;
 }
 case 13:  {
  $58 = ((($3)) + 8|0); //@line 121393 "c/sqlite3.c"
  $59 = HEAP32[$58>>2]|0; //@line 121393 "c/sqlite3.c"
  $60 = ($59|0)==(0); //@line 121393 "c/sqlite3.c"
  if ($60) {
   $61 = ((($2)) + 12|0); //@line 121394 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 121394 "c/sqlite3.c"
   $63 = (_sqlite3GetTempRange($0,$62)|0); //@line 121394 "c/sqlite3.c"
   HEAP32[$58>>2] = $63; //@line 121394 "c/sqlite3.c"
   $64 = HEAP32[$61>>2]|0; //@line 121395 "c/sqlite3.c"
   $65 = ((($3)) + 12|0); //@line 121395 "c/sqlite3.c"
   HEAP32[$65>>2] = $64; //@line 121395 "c/sqlite3.c"
  }
  $66 = ((($2)) + 8|0); //@line 121397 "c/sqlite3.c"
  $67 = HEAP32[$66>>2]|0; //@line 121397 "c/sqlite3.c"
  $68 = HEAP32[$58>>2]|0; //@line 121397 "c/sqlite3.c"
  $69 = ((($2)) + 12|0); //@line 121397 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 121397 "c/sqlite3.c"
  _sqlite3ExprCodeMove($0,$67,$68,$70); //@line 121397 "c/sqlite3.c"
  $71 = ((($3)) + 4|0); //@line 121398 "c/sqlite3.c"
  $72 = HEAP32[$71>>2]|0; //@line 121398 "c/sqlite3.c"
  (_sqlite3VdbeAddOp1($9,16,$72)|0); //@line 121398 "c/sqlite3.c"
  break;
 }
 default: {
  $73 = ((($2)) + 8|0); //@line 121412 "c/sqlite3.c"
  $74 = HEAP32[$73>>2]|0; //@line 121412 "c/sqlite3.c"
  $75 = ((($2)) + 12|0); //@line 121412 "c/sqlite3.c"
  $76 = HEAP32[$75>>2]|0; //@line 121412 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($9,78,$74,$76)|0); //@line 121412 "c/sqlite3.c"
  $77 = HEAP32[$73>>2]|0; //@line 121413 "c/sqlite3.c"
  $78 = HEAP32[$75>>2]|0; //@line 121413 "c/sqlite3.c"
  _sqlite3ExprCacheAffinityChange($0,$77,$78); //@line 121413 "c/sqlite3.c"
 }
 }
 $79 = ((($1)) + 12|0); //@line 121420 "c/sqlite3.c"
 $80 = HEAP32[$79>>2]|0; //@line 121420 "c/sqlite3.c"
 $81 = ($80|0)==(0); //@line 121420 "c/sqlite3.c"
 if (!($81)) {
  (_sqlite3VdbeAddOp2($9,59,$80,$7)|0); //@line 121421 "c/sqlite3.c"
 }
 _sqlite3VdbeResolveLabel($9,$11); //@line 121426 "c/sqlite3.c"
 (_sqlite3VdbeAddOp1($9,63,$4)|0); //@line 121427 "c/sqlite3.c"
 $$0 = $10;
 return ($$0|0); //@line 121430 "c/sqlite3.c"
}
function _generateColumnTypes($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$018 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp;
 $4 = ((($0)) + 8|0); //@line 120200 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 120200 "c/sqlite3.c"
 $6 = ((($3)) + 4|0); //@line 120203 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 120203 "c/sqlite3.c"
 HEAP32[$3>>2] = $0; //@line 120204 "c/sqlite3.c"
 $7 = ((($3)) + 16|0); //@line 120205 "c/sqlite3.c"
 HEAP32[$7>>2] = 0; //@line 120205 "c/sqlite3.c"
 $8 = HEAP32[$2>>2]|0; //@line 120206 "c/sqlite3.c"
 $9 = ($8|0)>(0); //@line 120206 "c/sqlite3.c"
 if (!($9)) {
  STACKTOP = sp;return; //@line 120228 "c/sqlite3.c"
 }
 $$018 = 0;
 while(1) {
  $10 = (((($2)) + 4|0) + (($$018*20)|0)|0); //@line 120207 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 120207 "c/sqlite3.c"
  $12 = (_columnTypeImpl($3,$11)|0); //@line 120223 "c/sqlite3.c"
  _sqlite3VdbeSetColName($5,$$018,1,$12,(-1)); //@line 120225 "c/sqlite3.c"
  $13 = (($$018) + 1)|0; //@line 120206 "c/sqlite3.c"
  $14 = HEAP32[$2>>2]|0; //@line 120206 "c/sqlite3.c"
  $15 = ($13|0)<($14|0); //@line 120206 "c/sqlite3.c"
  if ($15) {
   $$018 = $13;
  } else {
   break;
  }
 }
 STACKTOP = sp;return; //@line 120228 "c/sqlite3.c"
}
function _sqlite3FkDropTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$036 = 0, $$03640 = 0, $$03641 = 0, $$138 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0; //@line 110119 "c/sqlite3.c"
 $4 = ((($3)) + 28|0); //@line 110120 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 110120 "c/sqlite3.c"
 $6 = $5 & 16384; //@line 110120 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 110120 "c/sqlite3.c"
 if ($7) {
  return;
 }
 $8 = ((($2)) + 56|0); //@line 110120 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 110120 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 110120 "c/sqlite3.c"
 if (!($10)) {
  return;
 }
 $11 = ((($2)) + 12|0); //@line 110120 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 110120 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 110120 "c/sqlite3.c"
 if (!($13)) {
  return;
 }
 $14 = (_sqlite3GetVdbe($0)|0); //@line 110122 "c/sqlite3.c"
 $15 = (_sqlite3FkReferences($2)|0); //@line 110125 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 110125 "c/sqlite3.c"
 do {
  if ($16) {
   $17 = ((($2)) + 16|0); //@line 110132 "c/sqlite3.c"
   $$03640 = HEAP32[$17>>2]|0;
   $18 = ($$03640|0)==(0|0); //@line 110132 "c/sqlite3.c"
   if ($18) {
    return;
   }
   $$03641 = $$03640;
   while(1) {
    $21 = ((($$03641)) + 24|0); //@line 110133 "c/sqlite3.c"
    $22 = HEAP8[$21>>0]|0; //@line 110133 "c/sqlite3.c"
    $23 = ($22<<24>>24)==(0); //@line 110133 "c/sqlite3.c"
    if (!($23)) {
     label = 10;
     break;
    }
    $24 = HEAP32[$4>>2]|0; //@line 110133 "c/sqlite3.c"
    $25 = $24 & 524288; //@line 110133 "c/sqlite3.c"
    $26 = ($25|0)==(0); //@line 110133 "c/sqlite3.c"
    if (!($26)) {
     label = 10;
     break;
    }
    $19 = ((($$03641)) + 4|0); //@line 110132 "c/sqlite3.c"
    $$036 = HEAP32[$19>>2]|0;
    $20 = ($$036|0)==(0|0); //@line 110132 "c/sqlite3.c"
    if ($20) {
     label = 15;
     break;
    } else {
     $$03641 = $$036;
    }
   }
   if ((label|0) == 10) {
    $27 = (_sqlite3VdbeMakeLabel($14)|0); //@line 110136 "c/sqlite3.c"
    (_sqlite3VdbeAddOp2($14,47,1,$27)|0); //@line 110137 "c/sqlite3.c"
    $$138 = $27;
    break;
   }
   else if ((label|0) == 15) {
    return;
   }
  } else {
   $$138 = 0;
  }
 } while(0);
 $28 = ((($0)) + 146|0); //@line 110140 "c/sqlite3.c"
 HEAP8[$28>>0] = 1; //@line 110140 "c/sqlite3.c"
 $29 = (_sqlite3SrcListDup($3,$1,0)|0); //@line 110141 "c/sqlite3.c"
 _sqlite3DeleteFrom($0,$29,0); //@line 110141 "c/sqlite3.c"
 HEAP8[$28>>0] = 0; //@line 110142 "c/sqlite3.c"
 $30 = HEAP32[$4>>2]|0; //@line 110153 "c/sqlite3.c"
 $31 = $30 & 524288; //@line 110153 "c/sqlite3.c"
 $32 = ($31|0)==(0); //@line 110153 "c/sqlite3.c"
 if ($32) {
  $33 = (_sqlite3VdbeCurrentAddr($14)|0); //@line 110154 "c/sqlite3.c"
  $34 = (($33) + 2)|0; //@line 110154 "c/sqlite3.c"
  (_sqlite3VdbeAddOp2($14,47,0,$34)|0); //@line 110154 "c/sqlite3.c"
  _sqlite3HaltConstraint($0,787,2,0,-1,4); //@line 110156 "c/sqlite3.c"
 }
 $35 = ($$138|0)==(0); //@line 110160 "c/sqlite3.c"
 if ($35) {
  return;
 }
 _sqlite3VdbeResolveLabel($14,$$138); //@line 110161 "c/sqlite3.c"
 return;
}
function _sqlite3CodeDropTable($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$042 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_ptr1 = 0, $vararg_ptr5 = 0, $vararg_ptr6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer2 = sp + 8|0; //@line 104060 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 104060 "c/sqlite3.c"
 $4 = HEAP32[$0>>2]|0; //@line 104062 "c/sqlite3.c"
 $5 = ((($4)) + 16|0); //@line 104064 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 104064 "c/sqlite3.c"
 $7 = (($6) + ($2<<4)|0); //@line 104064 "c/sqlite3.c"
 $8 = (_sqlite3GetVdbe($0)|0); //@line 104066 "c/sqlite3.c"
 _sqlite3BeginWriteOperation($0,1,$2); //@line 104068 "c/sqlite3.c"
 $9 = ((($1)) + 56|0); //@line 104071 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 104071 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 104071 "c/sqlite3.c"
 if (!($11)) {
  (_sqlite3VdbeAddOp0($8,154)|0); //@line 104072 "c/sqlite3.c"
 }
 $12 = (_sqlite3TriggerList($0,$1)|0); //@line 104080 "c/sqlite3.c"
 $13 = ($12|0)==(0|0); //@line 104081 "c/sqlite3.c"
 if (!($13)) {
  $$042 = $12;
  while(1) {
   _sqlite3DropTriggerPtr($0,$$042); //@line 104084 "c/sqlite3.c"
   $14 = ((($$042)) + 32|0); //@line 104085 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 104085 "c/sqlite3.c"
   $16 = ($15|0)==(0|0); //@line 104081 "c/sqlite3.c"
   if ($16) {
    break;
   } else {
    $$042 = $15;
   }
  }
 }
 $17 = ((($1)) + 36|0); //@line 104094 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 104094 "c/sqlite3.c"
 $19 = $18 & 8; //@line 104094 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 104094 "c/sqlite3.c"
 if (!($20)) {
  $21 = HEAP32[$7>>2]|0; //@line 104097 "c/sqlite3.c"
  $22 = HEAP32[$1>>2]|0; //@line 104097 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $21; //@line 104095 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 104095 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $22; //@line 104095 "c/sqlite3.c"
  _sqlite3NestedParse($0,28869,$vararg_buffer); //@line 104095 "c/sqlite3.c"
 }
 $23 = HEAP32[$7>>2]|0; //@line 104111 "c/sqlite3.c"
 $24 = HEAP32[$1>>2]|0; //@line 104111 "c/sqlite3.c"
 HEAP32[$vararg_buffer2>>2] = $23; //@line 104109 "c/sqlite3.c"
 $vararg_ptr5 = ((($vararg_buffer2)) + 4|0); //@line 104109 "c/sqlite3.c"
 HEAP32[$vararg_ptr5>>2] = 19754; //@line 104109 "c/sqlite3.c"
 $vararg_ptr6 = ((($vararg_buffer2)) + 8|0); //@line 104109 "c/sqlite3.c"
 HEAP32[$vararg_ptr6>>2] = $24; //@line 104109 "c/sqlite3.c"
 _sqlite3NestedParse($0,28914,$vararg_buffer2); //@line 104109 "c/sqlite3.c"
 $25 = ($3|0)==(0); //@line 104112 "c/sqlite3.c"
 if ($25) {
  $26 = HEAP32[$9>>2]|0; //@line 104112 "c/sqlite3.c"
  $27 = ($26|0)==(0); //@line 104112 "c/sqlite3.c"
  if ($27) {
   _destroyTable($0,$1); //@line 104113 "c/sqlite3.c"
   label = 11;
  }
 } else {
  label = 11;
 }
 if ((label|0) == 11) {
  $$pr = HEAP32[$9>>2]|0; //@line 104119 "c/sqlite3.c"
  $28 = ($$pr|0)==(0); //@line 104119 "c/sqlite3.c"
  if ($28) {
   $30 = HEAP32[$1>>2]|0; //@line 104122 "c/sqlite3.c"
   (_sqlite3VdbeAddOp4($8,140,$2,0,0,$30,0)|0); //@line 104122 "c/sqlite3.c"
   _sqlite3ChangeCookie($0,$2); //@line 104123 "c/sqlite3.c"
   _sqliteViewResetAll($4,$2); //@line 104124 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 104125 "c/sqlite3.c"
  }
 }
 $29 = HEAP32[$1>>2]|0; //@line 104120 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($8,156,$2,0,0,$29,0)|0); //@line 104120 "c/sqlite3.c"
 $30 = HEAP32[$1>>2]|0; //@line 104122 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4($8,140,$2,0,0,$30,0)|0); //@line 104122 "c/sqlite3.c"
 _sqlite3ChangeCookie($0,$2); //@line 104123 "c/sqlite3.c"
 _sqliteViewResetAll($4,$2); //@line 104124 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 104125 "c/sqlite3.c"
}
function _destroyTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$034 = 0, $$03440 = 0, $$03442 = 0, $$035 = 0, $$136$lcssa = 0, $$13641 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond37 = 0, $or$cond38 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 28|0); //@line 104005 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 104005 "c/sqlite3.c"
 $4 = ((($1)) + 8|0);
 $5 = ((($1)) + 72|0);
 $$0 = 0;
 while(1) {
  $6 = ($$0|0)==(0); //@line 104012 "c/sqlite3.c"
  $7 = ($3|0)<($$0|0); //@line 104012 "c/sqlite3.c"
  $or$cond = $6 | $7; //@line 104012 "c/sqlite3.c"
  $$035 = $or$cond ? $3 : 0; //@line 104012 "c/sqlite3.c"
  $$03440 = HEAP32[$4>>2]|0;
  $8 = ($$03440|0)==(0|0); //@line 104015 "c/sqlite3.c"
  if ($8) {
   $$136$lcssa = $$035;
  } else {
   $$03442 = $$03440;$$13641 = $$035;
   while(1) {
    $9 = ((($$03442)) + 44|0); //@line 104016 "c/sqlite3.c"
    $10 = HEAP32[$9>>2]|0; //@line 104016 "c/sqlite3.c"
    $11 = ($10|0)<($$0|0); //@line 104018 "c/sqlite3.c"
    $or$cond37 = $6 | $11; //@line 104018 "c/sqlite3.c"
    $12 = ($10|0)>($$13641|0); //@line 104018 "c/sqlite3.c"
    $or$cond38 = $12 & $or$cond37; //@line 104018 "c/sqlite3.c"
    $$2 = $or$cond38 ? $10 : $$13641; //@line 104018 "c/sqlite3.c"
    $13 = ((($$03442)) + 20|0); //@line 104015 "c/sqlite3.c"
    $$034 = HEAP32[$13>>2]|0;
    $14 = ($$034|0)==(0|0); //@line 104015 "c/sqlite3.c"
    if ($14) {
     $$136$lcssa = $$2;
     break;
    } else {
     $$03442 = $$034;$$13641 = $$2;
    }
   }
  }
  $15 = ($$136$lcssa|0)==(0); //@line 104022 "c/sqlite3.c"
  if ($15) {
   break;
  }
  $16 = HEAP32[$0>>2]|0; //@line 104025 "c/sqlite3.c"
  $17 = HEAP32[$5>>2]|0; //@line 104025 "c/sqlite3.c"
  $18 = (_sqlite3SchemaToIndex($16,$17)|0); //@line 104025 "c/sqlite3.c"
  _destroyRootPage($0,$$136$lcssa,$18); //@line 104027 "c/sqlite3.c"
  $$0 = $$136$lcssa;
 }
 return; //@line 104031 "c/sqlite3.c"
}
function _sqliteViewResetAll($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$016 = 0, $$017 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 16|0); //@line 103896 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 103896 "c/sqlite3.c"
 $4 = (((($3) + ($1<<4)|0)) + 12|0); //@line 103896 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 103896 "c/sqlite3.c"
 $6 = ((($5)) + 78|0); //@line 103896 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 103896 "c/sqlite3.c"
 $8 = $7 & 2; //@line 103896 "c/sqlite3.c"
 $9 = ($8<<16>>16)==(0); //@line 103896 "c/sqlite3.c"
 if ($9) {
  return; //@line 103906 "c/sqlite3.c"
 }
 $10 = ((($5)) + 16|0); //@line 103897 "c/sqlite3.c"
 $$016 = HEAP32[$10>>2]|0;
 $11 = ($$016|0)==(0|0); //@line 103897 "c/sqlite3.c"
 if (!($11)) {
  $$017 = $$016;
  while(1) {
   $12 = ((($$017)) + 8|0); //@line 103898 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 103898 "c/sqlite3.c"
   $14 = ((($13)) + 12|0); //@line 103899 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 103899 "c/sqlite3.c"
   $16 = ($15|0)==(0|0); //@line 103899 "c/sqlite3.c"
   if (!($16)) {
    _sqlite3DeleteColumnNames($0,$13); //@line 103900 "c/sqlite3.c"
    $17 = ((($13)) + 4|0); //@line 103901 "c/sqlite3.c"
    HEAP32[$17>>2] = 0; //@line 103901 "c/sqlite3.c"
    $18 = ((($13)) + 42|0); //@line 103902 "c/sqlite3.c"
    HEAP16[$18>>1] = 0; //@line 103902 "c/sqlite3.c"
   }
   $$0 = HEAP32[$$017>>2]|0;
   $19 = ($$0|0)==(0|0); //@line 103897 "c/sqlite3.c"
   if ($19) {
    break;
   } else {
    $$017 = $$0;
   }
  }
 }
 $20 = HEAP32[$2>>2]|0; //@line 103905 "c/sqlite3.c"
 $21 = (((($20) + ($1<<4)|0)) + 12|0); //@line 103905 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 103905 "c/sqlite3.c"
 $23 = ((($22)) + 78|0); //@line 103905 "c/sqlite3.c"
 $24 = HEAP16[$23>>1]|0; //@line 103905 "c/sqlite3.c"
 $25 = $24 & -3; //@line 103905 "c/sqlite3.c"
 HEAP16[$23>>1] = $25; //@line 103905 "c/sqlite3.c"
 return; //@line 103906 "c/sqlite3.c"
}
function _sqlite3BtreeIsReadonly($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 70359 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70359 "c/sqlite3.c"
 $3 = ((($2)) + 22|0); //@line 70359 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 70359 "c/sqlite3.c"
 $5 = $4 & 1; //@line 70359 "c/sqlite3.c"
 $6 = $5&65535; //@line 70359 "c/sqlite3.c"
 return ($6|0); //@line 70359 "c/sqlite3.c"
}
function _sqlite3ResolveSelfReference($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(112|0);
 $5 = sp;
 $6 = sp + 80|0;
 $7 = ((($6)) + 8|0);
 ;HEAP32[$7>>2]=0|0;HEAP32[$7+4>>2]=0|0;HEAP32[$7+8>>2]=0|0;HEAP32[$7+12>>2]=0|0;HEAP32[$7+16>>2]=0|0;HEAP32[$7+20>>2]=0|0; //@line 92673 "c/sqlite3.c"
 dest=$5; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 92674 "c/sqlite3.c"
 HEAP32[$5>>2] = 1; //@line 92675 "c/sqlite3.c"
 $8 = HEAP32[$1>>2]|0; //@line 92676 "c/sqlite3.c"
 $9 = ((($5)) + 16|0); //@line 92676 "c/sqlite3.c"
 HEAP32[$9>>2] = $8; //@line 92676 "c/sqlite3.c"
 $10 = ((($5)) + 24|0); //@line 92677 "c/sqlite3.c"
 HEAP32[$10>>2] = $1; //@line 92677 "c/sqlite3.c"
 $11 = ((($5)) + 52|0); //@line 92678 "c/sqlite3.c"
 HEAP32[$11>>2] = -1; //@line 92678 "c/sqlite3.c"
 HEAP32[$6>>2] = $0; //@line 92679 "c/sqlite3.c"
 $12 = ((($6)) + 4|0); //@line 92680 "c/sqlite3.c"
 HEAP32[$12>>2] = $5; //@line 92680 "c/sqlite3.c"
 $13 = $2&65535; //@line 92681 "c/sqlite3.c"
 $14 = ((($6)) + 28|0); //@line 92681 "c/sqlite3.c"
 HEAP16[$14>>1] = $13; //@line 92681 "c/sqlite3.c"
 $15 = (_sqlite3ResolveExprNames($6,$3)|0); //@line 92682 "c/sqlite3.c"
 $16 = ($15|0)!=(0); //@line 92682 "c/sqlite3.c"
 $17 = ($4|0)==(0|0); //@line 92683 "c/sqlite3.c"
 $or$cond = $17 | $16; //@line 92682 "c/sqlite3.c"
 if ($or$cond) {
  STACKTOP = sp;return; //@line 92684 "c/sqlite3.c"
 }
 (_sqlite3ResolveExprListNames($6,$4)|0); //@line 92683 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 92684 "c/sqlite3.c"
}
function _sqlite3StringToId($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 102892 "c/sqlite3.c"
 switch ($1<<24>>24) {
 case 97:  {
  HEAP8[$0>>0] = 59; //@line 102893 "c/sqlite3.c"
  break;
 }
 case 94:  {
  $2 = ((($0)) + 12|0); //@line 102894 "c/sqlite3.c"
  $3 = HEAP32[$2>>2]|0; //@line 102894 "c/sqlite3.c"
  $4 = HEAP8[$3>>0]|0; //@line 102894 "c/sqlite3.c"
  $5 = ($4<<24>>24)==(97); //@line 102894 "c/sqlite3.c"
  if ($5) {
   HEAP8[$3>>0] = 59; //@line 102895 "c/sqlite3.c"
  }
  break;
 }
 default: {
 }
 }
 return; //@line 102897 "c/sqlite3.c"
}
function _hasColumn($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$045 = 0, $$in = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)>(0); //@line 103284 "c/sqlite3.c"
 L1: do {
  if ($3) {
   $$045 = $0;$$in = $1;
   while(1) {
    $7 = HEAP16[$$045>>1]|0; //@line 103284 "c/sqlite3.c"
    $8 = $7 << 16 >> 16; //@line 103284 "c/sqlite3.c"
    $9 = ($8|0)==($2|0); //@line 103284 "c/sqlite3.c"
    if ($9) {
     $$0 = 1;
     break L1;
    }
    $4 = (($$in) + -1)|0; //@line 103284 "c/sqlite3.c"
    $5 = ((($$045)) + 2|0); //@line 103284 "c/sqlite3.c"
    $6 = ($$in|0)>(1); //@line 103284 "c/sqlite3.c"
    if ($6) {
     $$045 = $5;$$in = $4;
    } else {
     $$0 = 0;
     break;
    }
   }
  } else {
   $$0 = 0;
  }
 } while(0);
 return ($$0|0); //@line 103286 "c/sqlite3.c"
}
function _estimateIndexWidth($0) {
 $0 = $0|0;
 var $$01920 = 0, $$021 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 103272 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 103272 "c/sqlite3.c"
 $3 = ((($2)) + 4|0); //@line 103272 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 103272 "c/sqlite3.c"
 $5 = ((($0)) + 52|0); //@line 103273 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 103273 "c/sqlite3.c"
 $7 = ($6<<16>>16)==(0); //@line 103273 "c/sqlite3.c"
 if ($7) {
  $23 = 0;$24 = 0;
  $25 = (_sqlite3LogEst($23,$24)|0); //@line 103278 "c/sqlite3.c"
  $26 = ((($0)) + 48|0); //@line 103278 "c/sqlite3.c"
  HEAP16[$26>>1] = $25; //@line 103278 "c/sqlite3.c"
  return; //@line 103279 "c/sqlite3.c"
 }
 $8 = ((($0)) + 4|0);
 $9 = HEAP32[$8>>2]|0;
 $10 = HEAP16[$5>>1]|0;
 $11 = $10&65535;
 $$01920 = 0;$$021 = 0;
 while(1) {
  $12 = (($9) + ($$01920<<1)|0); //@line 103274 "c/sqlite3.c"
  $13 = HEAP16[$12>>1]|0; //@line 103274 "c/sqlite3.c"
  $14 = ($13<<16>>16)<(0); //@line 103276 "c/sqlite3.c"
  if ($14) {
   $20 = 1;
  } else {
   $15 = $13 << 16 >> 16; //@line 103276 "c/sqlite3.c"
   $16 = (((($4) + ($15<<4)|0)) + 14|0); //@line 103276 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 103276 "c/sqlite3.c"
   $18 = $17&255; //@line 103276 "c/sqlite3.c"
   $20 = $18;
  }
  $19 = (($20) + ($$021))|0; //@line 103276 "c/sqlite3.c"
  $21 = (($$01920) + 1)|0; //@line 103273 "c/sqlite3.c"
  $22 = ($21>>>0)<($11>>>0); //@line 103273 "c/sqlite3.c"
  if ($22) {
   $$01920 = $21;$$021 = $19;
  } else {
   break;
  }
 }
 $phitmp = $19 << 2; //@line 103278 "c/sqlite3.c"
 $23 = $phitmp;$24 = 0;
 $25 = (_sqlite3LogEst($23,$24)|0); //@line 103278 "c/sqlite3.c"
 $26 = ((($0)) + 48|0); //@line 103278 "c/sqlite3.c"
 HEAP16[$26>>1] = $25; //@line 103278 "c/sqlite3.c"
 return; //@line 103279 "c/sqlite3.c"
}
function _sqlite3ExprIsConstantOrFunction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1&255; //@line 94618 "c/sqlite3.c"
 $3 = (($2) + 4)|0; //@line 94618 "c/sqlite3.c"
 $4 = (_exprIsConst($0,$3,0)|0); //@line 94618 "c/sqlite3.c"
 return ($4|0); //@line 94618 "c/sqlite3.c"
}
function _convertToWithoutRowidTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0126 = 0, $$0126152 = 0, $$0126153 = 0, $$0131164 = 0, $$0133$lcssa = 0, $$0133157 = 0, $$0146 = 0, $$1130 = 0, $$1132158 = 0, $$1134 = 0, $$2135148 = 0, $$2145 = 0, $$3136 = 0, $$3149 = 0, $$4137143 = 0, $$4144 = 0, $$5 = 0, $10 = 0, $100 = 0, $101 = 0;
 var $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0;
 var $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0;
 var $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0;
 var $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0;
 var $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond168 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 103317 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 103318 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 103318 "c/sqlite3.c"
 $6 = ((($3)) + 159|0); //@line 103322 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 103322 "c/sqlite3.c"
 $8 = ($7<<24>>24)==(0); //@line 103322 "c/sqlite3.c"
 if ($8) {
  $9 = ((($1)) + 42|0); //@line 103323 "c/sqlite3.c"
  $10 = HEAP16[$9>>1]|0; //@line 103323 "c/sqlite3.c"
  $11 = ($10<<16>>16)>(0); //@line 103323 "c/sqlite3.c"
  if ($11) {
   $12 = ((($1)) + 4|0);
   $13 = HEAP32[$12>>2]|0;
   $14 = HEAP16[$9>>1]|0;
   $15 = $14 << 16 >> 16;
   $$0131164 = 0;
   while(1) {
    $16 = (((($13) + ($$0131164<<4)|0)) + 15|0); //@line 103324 "c/sqlite3.c"
    $17 = HEAP8[$16>>0]|0; //@line 103324 "c/sqlite3.c"
    $18 = $17 & 1; //@line 103324 "c/sqlite3.c"
    $19 = ($18<<24>>24)==(0); //@line 103324 "c/sqlite3.c"
    if (!($19)) {
     $20 = (((($13) + ($$0131164<<4)|0)) + 12|0); //@line 103325 "c/sqlite3.c"
     HEAP8[$20>>0] = 2; //@line 103325 "c/sqlite3.c"
    }
    $21 = (($$0131164) + 1)|0; //@line 103323 "c/sqlite3.c"
    $22 = ($21|0)<($15|0); //@line 103323 "c/sqlite3.c"
    if ($22) {
     $$0131164 = $21;
    } else {
     break;
    }
   }
  }
 }
 $23 = ((($0)) + 400|0); //@line 103332 "c/sqlite3.c"
 $24 = HEAP8[$23>>0]|0; //@line 103332 "c/sqlite3.c"
 $25 = ($24<<24>>24)==(0); //@line 103332 "c/sqlite3.c"
 if (!($25)) {
  STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
 }
 $26 = ((($0)) + 128|0); //@line 103337 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 103337 "c/sqlite3.c"
 $28 = ($27|0)==(0); //@line 103337 "c/sqlite3.c"
 if (!($28)) {
  _sqlite3VdbeChangeP3($5,$27,2); //@line 103339 "c/sqlite3.c"
 }
 $29 = ((($1)) + 40|0); //@line 103345 "c/sqlite3.c"
 $30 = HEAP16[$29>>1]|0; //@line 103345 "c/sqlite3.c"
 $31 = ($30<<16>>16)>(-1); //@line 103345 "c/sqlite3.c"
 do {
  if ($31) {
   $32 = ((($1)) + 4|0); //@line 103348 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 103348 "c/sqlite3.c"
   $34 = $30 << 16 >> 16; //@line 103348 "c/sqlite3.c"
   $35 = (($33) + ($34<<4)|0); //@line 103348 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 103348 "c/sqlite3.c"
   _sqlite3TokenInit($2,$36); //@line 103348 "c/sqlite3.c"
   $37 = (_sqlite3ExprAlloc($3,59,$2,0)|0); //@line 103350 "c/sqlite3.c"
   $38 = (_sqlite3ExprListAppend($0,0,$37)|0); //@line 103349 "c/sqlite3.c"
   $39 = ($38|0)==(0|0); //@line 103351 "c/sqlite3.c"
   if (!($39)) {
    $40 = ((($0)) + 398|0); //@line 103352 "c/sqlite3.c"
    $41 = HEAP8[$40>>0]|0; //@line 103352 "c/sqlite3.c"
    $42 = ((($38)) + 16|0); //@line 103352 "c/sqlite3.c"
    HEAP8[$42>>0] = $41; //@line 103352 "c/sqlite3.c"
    $43 = ((($1)) + 48|0); //@line 103354 "c/sqlite3.c"
    $44 = HEAP8[$43>>0]|0; //@line 103354 "c/sqlite3.c"
    $45 = $44&255; //@line 103354 "c/sqlite3.c"
    _sqlite3CreateIndex($0,0,0,0,$38,$45,0,0,0,0,2); //@line 103354 "c/sqlite3.c"
    $46 = ((($3)) + 73|0); //@line 103356 "c/sqlite3.c"
    $47 = HEAP8[$46>>0]|0; //@line 103356 "c/sqlite3.c"
    $48 = ($47<<24>>24)==(0); //@line 103356 "c/sqlite3.c"
    if ($48) {
     $49 = (_sqlite3PrimaryKeyIndex($1)|0); //@line 103357 "c/sqlite3.c"
     HEAP16[$29>>1] = -1; //@line 103358 "c/sqlite3.c"
     $$1130 = $49;
     break;
    }
   }
   STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
  } else {
   $50 = (_sqlite3PrimaryKeyIndex($1)|0); //@line 103360 "c/sqlite3.c"
   $51 = ((($50)) + 50|0); //@line 103367 "c/sqlite3.c"
   $52 = HEAP16[$51>>1]|0; //@line 103367 "c/sqlite3.c"
   $53 = ($52&65535)>(1); //@line 103367 "c/sqlite3.c"
   if ($53) {
    $54 = ((($50)) + 4|0);
    $55 = ((($50)) + 52|0);
    $$0133157 = 1;$$1132158 = 1;
    while(1) {
     $56 = HEAP32[$54>>2]|0; //@line 103368 "c/sqlite3.c"
     $57 = (($56) + ($$1132158<<1)|0); //@line 103368 "c/sqlite3.c"
     $58 = HEAP16[$57>>1]|0; //@line 103368 "c/sqlite3.c"
     $59 = $58 << 16 >> 16; //@line 103368 "c/sqlite3.c"
     $60 = (_hasColumn($56,$$0133157,$59)|0); //@line 103368 "c/sqlite3.c"
     $61 = ($60|0)==(0); //@line 103368 "c/sqlite3.c"
     if ($61) {
      $64 = (($$0133157) + 1)|0; //@line 103371 "c/sqlite3.c"
      $65 = (($56) + ($$0133157<<1)|0); //@line 103371 "c/sqlite3.c"
      HEAP16[$65>>1] = $58; //@line 103371 "c/sqlite3.c"
      $$1134 = $64;
     } else {
      $62 = HEAP16[$55>>1]|0; //@line 103369 "c/sqlite3.c"
      $63 = (($62) + -1)<<16>>16; //@line 103369 "c/sqlite3.c"
      HEAP16[$55>>1] = $63; //@line 103369 "c/sqlite3.c"
      $$1134 = $$0133157;
     }
     $66 = (($$1132158) + 1)|0; //@line 103367 "c/sqlite3.c"
     $67 = HEAP16[$51>>1]|0; //@line 103367 "c/sqlite3.c"
     $68 = $67&65535; //@line 103367 "c/sqlite3.c"
     $69 = ($66>>>0)<($68>>>0); //@line 103367 "c/sqlite3.c"
     if ($69) {
      $$0133157 = $$1134;$$1132158 = $66;
     } else {
      $$0133$lcssa = $$1134;
      break;
     }
    }
   } else {
    $$0133$lcssa = 1;
   }
   $70 = $$0133$lcssa&65535; //@line 103374 "c/sqlite3.c"
   HEAP16[$51>>1] = $70; //@line 103374 "c/sqlite3.c"
   $$1130 = $50;
  }
 } while(0);
 $71 = ((($$1130)) + 55|0); //@line 103377 "c/sqlite3.c"
 $72 = HEAPU8[$71>>0]|(HEAPU8[$71+1>>0]<<8); //@line 103377 "c/sqlite3.c"
 $73 = $72 | 32; //@line 103377 "c/sqlite3.c"
 HEAP8[$71>>0]=$73&255;HEAP8[$71+1>>0]=$73>>8; //@line 103377 "c/sqlite3.c"
 $74 = HEAP8[$6>>0]|0; //@line 103378 "c/sqlite3.c"
 $75 = ($74<<24>>24)==(0); //@line 103378 "c/sqlite3.c"
 if ($75) {
  $76 = $72 | 40; //@line 103378 "c/sqlite3.c"
  HEAP8[$71>>0]=$76&255;HEAP8[$71+1>>0]=$76>>8; //@line 103378 "c/sqlite3.c"
 }
 $77 = ((($$1130)) + 50|0); //@line 103379 "c/sqlite3.c"
 $78 = HEAP16[$77>>1]|0; //@line 103379 "c/sqlite3.c"
 $79 = $78&65535; //@line 103379 "c/sqlite3.c"
 $80 = ($5|0)==(0|0); //@line 103385 "c/sqlite3.c"
 if (!($80)) {
  $81 = ((($$1130)) + 44|0); //@line 103385 "c/sqlite3.c"
  $82 = HEAP32[$81>>2]|0; //@line 103385 "c/sqlite3.c"
  $83 = ($82|0)>(0); //@line 103385 "c/sqlite3.c"
  if ($83) {
   _sqlite3VdbeChangeOpcode($5,$82,13); //@line 103387 "c/sqlite3.c"
  }
 }
 $84 = ((($1)) + 28|0); //@line 103391 "c/sqlite3.c"
 $85 = HEAP32[$84>>2]|0; //@line 103391 "c/sqlite3.c"
 $86 = ((($$1130)) + 44|0); //@line 103391 "c/sqlite3.c"
 HEAP32[$86>>2] = $85; //@line 103391 "c/sqlite3.c"
 $87 = ((($1)) + 8|0); //@line 103396 "c/sqlite3.c"
 $$0126152 = HEAP32[$87>>2]|0;
 $88 = ($$0126152|0)==(0|0); //@line 103396 "c/sqlite3.c"
 L41: do {
  if (!($88)) {
   $89 = ($78<<16>>16)==(0);
   $90 = ((($$1130)) + 4|0);
   $91 = ($78<<16>>16)==(0);
   $92 = ((($$1130)) + 4|0);
   $93 = ((($$1130)) + 32|0);
   $$0126153 = $$0126152;
   L43: while(1) {
    $94 = ((($$0126153)) + 55|0); //@line 103398 "c/sqlite3.c"
    $95 = HEAPU8[$94>>0]|(HEAPU8[$94+1>>0]<<8); //@line 103398 "c/sqlite3.c"
    $96 = $95 & 3; //@line 103398 "c/sqlite3.c"
    $97 = ($96<<16>>16)==(2); //@line 103398 "c/sqlite3.c"
    L45: do {
     if (!($97)) {
      if ($89) {
       $98 = ((($$0126153)) + 50|0);
       $99 = HEAP16[$98>>1]|0;
       $117 = $99;
      } else {
       $100 = ((($$0126153)) + 4|0);
       $101 = HEAP32[$100>>2]|0;
       $102 = ((($$0126153)) + 50|0);
       $103 = HEAP16[$102>>1]|0;
       $104 = $103&65535;
       $105 = HEAP32[$90>>2]|0;
       $$0146 = 0;$$2145 = 0;
       while(1) {
        $106 = (($105) + ($$2145<<1)|0); //@line 103400 "c/sqlite3.c"
        $107 = HEAP16[$106>>1]|0; //@line 103400 "c/sqlite3.c"
        $108 = $107 << 16 >> 16; //@line 103400 "c/sqlite3.c"
        $109 = (_hasColumn($101,$104,$108)|0); //@line 103400 "c/sqlite3.c"
        $110 = ($109|0)==(0); //@line 103400 "c/sqlite3.c"
        $111 = $110&1; //@line 103400 "c/sqlite3.c"
        $spec$select = (($$0146) + ($111))|0; //@line 103400 "c/sqlite3.c"
        $112 = (($$2145) + 1)|0; //@line 103399 "c/sqlite3.c"
        $exitcond = ($112|0)==($79|0); //@line 103399 "c/sqlite3.c"
        if ($exitcond) {
         break;
        } else {
         $$0146 = $spec$select;$$2145 = $112;
        }
       }
       $113 = ($spec$select|0)==(0); //@line 103402 "c/sqlite3.c"
       $114 = ((($$0126153)) + 50|0);
       $115 = HEAP16[$114>>1]|0;
       if ($113) {
        $117 = $115;
       } else {
        $118 = $115&65535; //@line 103407 "c/sqlite3.c"
        $119 = (($spec$select) + ($118))|0; //@line 103407 "c/sqlite3.c"
        $120 = (_resizeIndexObject($3,$$0126153,$119)|0); //@line 103407 "c/sqlite3.c"
        $121 = ($120|0)==(0); //@line 103407 "c/sqlite3.c"
        if (!($121)) {
         break L43;
        }
        if ($91) {
         break;
        }
        $122 = HEAP16[$114>>1]|0; //@line 103408 "c/sqlite3.c"
        $123 = $122&65535; //@line 103408 "c/sqlite3.c"
        $124 = ((($$0126153)) + 4|0);
        $125 = ((($$0126153)) + 32|0);
        $$2135148 = $123;$$3149 = 0;
        while(1) {
         $126 = HEAP32[$124>>2]|0; //@line 103409 "c/sqlite3.c"
         $127 = HEAP16[$114>>1]|0; //@line 103409 "c/sqlite3.c"
         $128 = $127&65535; //@line 103409 "c/sqlite3.c"
         $129 = HEAP32[$92>>2]|0; //@line 103409 "c/sqlite3.c"
         $130 = (($129) + ($$3149<<1)|0); //@line 103409 "c/sqlite3.c"
         $131 = HEAP16[$130>>1]|0; //@line 103409 "c/sqlite3.c"
         $132 = $131 << 16 >> 16; //@line 103409 "c/sqlite3.c"
         $133 = (_hasColumn($126,$128,$132)|0); //@line 103409 "c/sqlite3.c"
         $134 = ($133|0)==(0); //@line 103409 "c/sqlite3.c"
         if ($134) {
          $135 = (($126) + ($$2135148<<1)|0); //@line 103410 "c/sqlite3.c"
          HEAP16[$135>>1] = $131; //@line 103410 "c/sqlite3.c"
          $136 = HEAP32[$93>>2]|0; //@line 103411 "c/sqlite3.c"
          $137 = (($136) + ($$3149<<2)|0); //@line 103411 "c/sqlite3.c"
          $138 = HEAP32[$137>>2]|0; //@line 103411 "c/sqlite3.c"
          $139 = HEAP32[$125>>2]|0; //@line 103411 "c/sqlite3.c"
          $140 = (($139) + ($$2135148<<2)|0); //@line 103411 "c/sqlite3.c"
          HEAP32[$140>>2] = $138; //@line 103411 "c/sqlite3.c"
          $141 = (($$2135148) + 1)|0; //@line 103412 "c/sqlite3.c"
          $$3136 = $141;
         } else {
          $$3136 = $$2135148;
         }
         $142 = (($$3149) + 1)|0; //@line 103408 "c/sqlite3.c"
         $exitcond168 = ($142|0)==($79|0); //@line 103408 "c/sqlite3.c"
         if ($exitcond168) {
          break L45;
         } else {
          $$2135148 = $$3136;$$3149 = $142;
         }
        }
       }
      }
      $116 = ((($$0126153)) + 52|0); //@line 103404 "c/sqlite3.c"
      HEAP16[$116>>1] = $117; //@line 103404 "c/sqlite3.c"
     }
    } while(0);
    $143 = ((($$0126153)) + 20|0); //@line 103396 "c/sqlite3.c"
    $$0126 = HEAP32[$143>>2]|0;
    $144 = ($$0126|0)==(0|0); //@line 103396 "c/sqlite3.c"
    if ($144) {
     break L41;
    } else {
     $$0126153 = $$0126;
    }
   }
   STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
  }
 } while(0);
 $145 = ((($1)) + 42|0); //@line 103421 "c/sqlite3.c"
 $146 = HEAP16[$145>>1]|0; //@line 103421 "c/sqlite3.c"
 $147 = $146 << 16 >> 16; //@line 103421 "c/sqlite3.c"
 $148 = ($79|0)<($147|0); //@line 103421 "c/sqlite3.c"
 if (!($148)) {
  $167 = ((($$1130)) + 52|0); //@line 103434 "c/sqlite3.c"
  HEAP16[$167>>1] = $146; //@line 103434 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
 }
 $149 = (_resizeIndexObject($3,$$1130,$147)|0); //@line 103422 "c/sqlite3.c"
 $150 = ($149|0)==(0); //@line 103422 "c/sqlite3.c"
 if (!($150)) {
  STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
 }
 $151 = HEAP16[$145>>1]|0; //@line 103423 "c/sqlite3.c"
 $152 = ($151<<16>>16)>(0); //@line 103423 "c/sqlite3.c"
 if (!($152)) {
  STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
 }
 $153 = ((($$1130)) + 4|0);
 $154 = ((($$1130)) + 32|0);
 $$4137143 = $79;$$4144 = 0;
 while(1) {
  $155 = HEAP32[$153>>2]|0; //@line 103424 "c/sqlite3.c"
  $156 = (_hasColumn($155,$$4137143,$$4144)|0); //@line 103424 "c/sqlite3.c"
  $157 = ($156|0)==(0); //@line 103424 "c/sqlite3.c"
  if ($157) {
   $158 = $$4144&65535; //@line 103426 "c/sqlite3.c"
   $159 = (($155) + ($$4137143<<1)|0); //@line 103426 "c/sqlite3.c"
   HEAP16[$159>>1] = $158; //@line 103426 "c/sqlite3.c"
   $160 = HEAP32[$154>>2]|0; //@line 103427 "c/sqlite3.c"
   $161 = (($160) + ($$4137143<<2)|0); //@line 103427 "c/sqlite3.c"
   HEAP32[$161>>2] = 18038; //@line 103427 "c/sqlite3.c"
   $162 = (($$4137143) + 1)|0; //@line 103428 "c/sqlite3.c"
   $$5 = $162;
  } else {
   $$5 = $$4137143;
  }
  $163 = (($$4144) + 1)|0; //@line 103423 "c/sqlite3.c"
  $164 = HEAP16[$145>>1]|0; //@line 103423 "c/sqlite3.c"
  $165 = $164 << 16 >> 16; //@line 103423 "c/sqlite3.c"
  $166 = ($163|0)<($165|0); //@line 103423 "c/sqlite3.c"
  if ($166) {
   $$4137143 = $$5;$$4144 = $163;
  } else {
   break;
  }
 }
 STACKTOP = sp;return; //@line 103436 "c/sqlite3.c"
}
function _estimateTableWidth($0) {
 $0 = $0|0;
 var $$01518 = 0, $$016$lcssa = 0, $$01617 = 0, $$019 = 0, $$lobit = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 42|0); //@line 103259 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 103259 "c/sqlite3.c"
 $3 = ($2<<16>>16)>(0); //@line 103259 "c/sqlite3.c"
 if ($3) {
  $4 = $2 << 16 >> 16; //@line 103259 "c/sqlite3.c"
  $5 = ((($0)) + 4|0); //@line 103259 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 103259 "c/sqlite3.c"
  $$01518 = $6;$$01617 = 0;$$019 = $4;
  while(1) {
   $7 = ((($$01518)) + 14|0); //@line 103260 "c/sqlite3.c"
   $8 = HEAP8[$7>>0]|0; //@line 103260 "c/sqlite3.c"
   $9 = $8&255; //@line 103260 "c/sqlite3.c"
   $10 = (($$01617) + ($9))|0; //@line 103260 "c/sqlite3.c"
   $11 = (($$019) + -1)|0; //@line 103259 "c/sqlite3.c"
   $12 = ((($$01518)) + 16|0); //@line 103259 "c/sqlite3.c"
   $13 = ($$019|0)>(1); //@line 103259 "c/sqlite3.c"
   if ($13) {
    $$01518 = $12;$$01617 = $10;$$019 = $11;
   } else {
    $$016$lcssa = $10;
    break;
   }
  }
 } else {
  $$016$lcssa = 0;
 }
 $14 = ((($0)) + 40|0); //@line 103262 "c/sqlite3.c"
 $15 = HEAP16[$14>>1]|0; //@line 103262 "c/sqlite3.c"
 $$lobit = ($15&65535) >>> 15; //@line 103262 "c/sqlite3.c"
 $16 = $$lobit&65535; //@line 103262 "c/sqlite3.c"
 $spec$select = (($$016$lcssa) + ($16))|0; //@line 103262 "c/sqlite3.c"
 $17 = $spec$select << 2; //@line 103263 "c/sqlite3.c"
 $18 = (_sqlite3LogEst($17,0)|0); //@line 103263 "c/sqlite3.c"
 $19 = ((($0)) + 46|0); //@line 103263 "c/sqlite3.c"
 HEAP16[$19>>1] = $18; //@line 103263 "c/sqlite3.c"
 return; //@line 103264 "c/sqlite3.c"
}
function _createTableStmt($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $$06079 = 0, $$06178 = 0, $$067$lcssa = 0, $$06777 = 0, $$16274 = 0, $$175 = 0, $$68 = 0, $$69 = 0, $$lcssa = 0, $$lcssa70 = 0, $$lcssa71 = 0, $$pn = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0;
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0;
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0;
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, $vararg_buffer5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer5 = sp + 24|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 28|0;
 $3 = ((($1)) + 4|0); //@line 103169 "c/sqlite3.c"
 $4 = ((($1)) + 42|0); //@line 103169 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 103169 "c/sqlite3.c"
 $6 = $5 << 16 >> 16; //@line 103169 "c/sqlite3.c"
 $7 = ($5<<16>>16)>(0); //@line 103169 "c/sqlite3.c"
 if ($7) {
  $8 = HEAP32[$3>>2]|0; //@line 103169 "c/sqlite3.c"
  $9 = HEAP16[$4>>1]|0;
  $10 = $9 << 16 >> 16;
  $$06079 = 0;$$06178 = $8;$$06777 = 0;
  while(1) {
   $11 = HEAP32[$$06178>>2]|0; //@line 103170 "c/sqlite3.c"
   $12 = (_identLength($11)|0); //@line 103170 "c/sqlite3.c"
   $13 = (($$06777) + 5)|0; //@line 103170 "c/sqlite3.c"
   $14 = (($13) + ($12))|0; //@line 103170 "c/sqlite3.c"
   $15 = (($$06079) + 1)|0; //@line 103169 "c/sqlite3.c"
   $16 = ((($$06178)) + 16|0); //@line 103169 "c/sqlite3.c"
   $17 = ($15|0)<($10|0); //@line 103169 "c/sqlite3.c"
   if ($17) {
    $$06079 = $15;$$06178 = $16;$$06777 = $14;
   } else {
    break;
   }
  }
  $18 = $9 << 16 >> 16; //@line 103169 "c/sqlite3.c"
  $$067$lcssa = $14;$$lcssa71 = $18;
 } else {
  $$067$lcssa = 0;$$lcssa71 = $6;
 }
 $19 = HEAP32[$1>>2]|0; //@line 103172 "c/sqlite3.c"
 $20 = (_identLength($19)|0); //@line 103172 "c/sqlite3.c"
 $21 = (($20) + ($$067$lcssa))|0; //@line 103172 "c/sqlite3.c"
 $22 = ($21|0)<(50); //@line 103173 "c/sqlite3.c"
 $$68 = $22 ? 17184 : 30075; //@line 103177 "c/sqlite3.c"
 $$69 = $22 ? 20274 : 30080; //@line 103177 "c/sqlite3.c"
 $23 = ($$lcssa71*6)|0; //@line 103182 "c/sqlite3.c"
 $24 = (($23) + 35)|0; //@line 103182 "c/sqlite3.c"
 $25 = (($24) + ($21))|0; //@line 103182 "c/sqlite3.c"
 $26 = ($25|0)<(0); //@line 103183 "c/sqlite3.c"
 $27 = $26 << 31 >> 31; //@line 103183 "c/sqlite3.c"
 $28 = (_sqlite3DbMallocRaw(0,$25,$27)|0); //@line 103183 "c/sqlite3.c"
 $29 = ($28|0)==(0|0); //@line 103184 "c/sqlite3.c"
 if ($29) {
  _sqlite3OomFault($0); //@line 103185 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 103225 "c/sqlite3.c"
 }
 (_sqlite3_snprintf($25,$28,30083,$vararg_buffer)|0); //@line 103188 "c/sqlite3.c"
 $30 = (_sqlite3Strlen30($28)|0); //@line 103189 "c/sqlite3.c"
 HEAP32[$2>>2] = $30; //@line 103189 "c/sqlite3.c"
 $31 = HEAP32[$1>>2]|0; //@line 103190 "c/sqlite3.c"
 _identPut($28,$2,$31); //@line 103190 "c/sqlite3.c"
 $32 = HEAP32[$2>>2]|0; //@line 103191 "c/sqlite3.c"
 $33 = (($32) + 1)|0; //@line 103191 "c/sqlite3.c"
 HEAP32[$2>>2] = $33; //@line 103191 "c/sqlite3.c"
 $34 = (($28) + ($32)|0); //@line 103191 "c/sqlite3.c"
 HEAP8[$34>>0] = 40; //@line 103191 "c/sqlite3.c"
 $35 = HEAP16[$4>>1]|0; //@line 103192 "c/sqlite3.c"
 $36 = ($35<<16>>16)>(0); //@line 103192 "c/sqlite3.c"
 $37 = (($25) - ($33))|0;
 $38 = (($28) + ($33)|0);
 if ($36) {
  $39 = HEAP32[$3>>2]|0; //@line 103192 "c/sqlite3.c"
  $$ = $22 ? 41388 : 30097; //@line 103177 "c/sqlite3.c"
  (_sqlite3_snprintf($37,$38,$$,$vararg_buffer1)|0); //@line 103203 "c/sqlite3.c"
  $40 = (_sqlite3Strlen30($38)|0); //@line 103204 "c/sqlite3.c"
  $41 = (($40) + ($33))|0; //@line 103204 "c/sqlite3.c"
  HEAP32[$2>>2] = $41; //@line 103204 "c/sqlite3.c"
  $42 = HEAP32[$39>>2]|0; //@line 103206 "c/sqlite3.c"
  _identPut($28,$2,$42); //@line 103206 "c/sqlite3.c"
  $43 = ((($39)) + 13|0); //@line 103215 "c/sqlite3.c"
  $44 = HEAP8[$43>>0]|0; //@line 103215 "c/sqlite3.c"
  $45 = $44 << 24 >> 24; //@line 103215 "c/sqlite3.c"
  $46 = (($45) + -65)|0; //@line 103215 "c/sqlite3.c"
  $47 = (6360 + ($46<<2)|0); //@line 103215 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 103215 "c/sqlite3.c"
  $49 = (_sqlite3Strlen30($48)|0); //@line 103216 "c/sqlite3.c"
  $50 = HEAP32[$2>>2]|0; //@line 103219 "c/sqlite3.c"
  $51 = (($28) + ($50)|0); //@line 103219 "c/sqlite3.c"
  _memcpy(($51|0),($48|0),($49|0))|0; //@line 103219 "c/sqlite3.c"
  $52 = (($50) + ($49))|0; //@line 103220 "c/sqlite3.c"
  HEAP32[$2>>2] = $52; //@line 103220 "c/sqlite3.c"
  $53 = HEAP16[$4>>1]|0; //@line 103192 "c/sqlite3.c"
  $54 = ($53<<16>>16)>(1); //@line 103192 "c/sqlite3.c"
  $55 = (($25) - ($52))|0;
  $56 = (($28) + ($52)|0);
  if ($54) {
   $$175 = 1;$$pn = $39;$57 = $55;$58 = $56;$61 = $52;
   while(1) {
    $$16274 = ((($$pn)) + 16|0); //@line 103192 "c/sqlite3.c"
    (_sqlite3_snprintf($57,$58,$$68,$vararg_buffer3)|0); //@line 103203 "c/sqlite3.c"
    $59 = (_sqlite3Strlen30($58)|0); //@line 103204 "c/sqlite3.c"
    $60 = (($59) + ($61))|0; //@line 103204 "c/sqlite3.c"
    HEAP32[$2>>2] = $60; //@line 103204 "c/sqlite3.c"
    $62 = HEAP32[$$16274>>2]|0; //@line 103206 "c/sqlite3.c"
    _identPut($28,$2,$62); //@line 103206 "c/sqlite3.c"
    $63 = ((($$pn)) + 29|0); //@line 103215 "c/sqlite3.c"
    $64 = HEAP8[$63>>0]|0; //@line 103215 "c/sqlite3.c"
    $65 = $64 << 24 >> 24; //@line 103215 "c/sqlite3.c"
    $66 = (($65) + -65)|0; //@line 103215 "c/sqlite3.c"
    $67 = (6360 + ($66<<2)|0); //@line 103215 "c/sqlite3.c"
    $68 = HEAP32[$67>>2]|0; //@line 103215 "c/sqlite3.c"
    $69 = (_sqlite3Strlen30($68)|0); //@line 103216 "c/sqlite3.c"
    $70 = HEAP32[$2>>2]|0; //@line 103219 "c/sqlite3.c"
    $71 = (($28) + ($70)|0); //@line 103219 "c/sqlite3.c"
    _memcpy(($71|0),($68|0),($69|0))|0; //@line 103219 "c/sqlite3.c"
    $72 = (($70) + ($69))|0; //@line 103220 "c/sqlite3.c"
    HEAP32[$2>>2] = $72; //@line 103220 "c/sqlite3.c"
    $73 = (($$175) + 1)|0; //@line 103192 "c/sqlite3.c"
    $74 = HEAP16[$4>>1]|0; //@line 103192 "c/sqlite3.c"
    $75 = $74 << 16 >> 16; //@line 103192 "c/sqlite3.c"
    $76 = ($73|0)<($75|0); //@line 103192 "c/sqlite3.c"
    $77 = (($25) - ($72))|0;
    $78 = (($28) + ($72)|0);
    if ($76) {
     $$175 = $73;$$pn = $$16274;$57 = $77;$58 = $78;$61 = $72;
    } else {
     $$lcssa = $78;$$lcssa70 = $77;
     break;
    }
   }
  } else {
   $$lcssa = $56;$$lcssa70 = $55;
  }
 } else {
  $$lcssa = $38;$$lcssa70 = $37;
 }
 HEAP32[$vararg_buffer5>>2] = $$69; //@line 103223 "c/sqlite3.c"
 (_sqlite3_snprintf($$lcssa70,$$lcssa,15687,$vararg_buffer5)|0); //@line 103223 "c/sqlite3.c"
 $$0 = $28;
 STACKTOP = sp;return ($$0|0); //@line 103225 "c/sqlite3.c"
}
function _identLength($0) {
 $0 = $0|0;
 var $$0 = 0, $$06 = 0, $$1 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0 = 0;$$06 = $0;
 L1: while(1) {
  $1 = HEAP8[$$06>>0]|0; //@line 103116 "c/sqlite3.c"
  switch ($1<<24>>24) {
  case 0:  {
   break L1;
   break;
  }
  case 34:  {
   $2 = (($$0) + 1)|0; //@line 103117 "c/sqlite3.c"
   $$1 = $2;
   break;
  }
  default: {
   $$1 = $$0;
  }
  }
  $3 = (($$1) + 1)|0; //@line 103116 "c/sqlite3.c"
  $4 = ((($$06)) + 1|0); //@line 103116 "c/sqlite3.c"
  $$0 = $3;$$06 = $4;
 }
 $5 = (($$0) + 2)|0; //@line 103119 "c/sqlite3.c"
 return ($5|0); //@line 103119 "c/sqlite3.c"
}
function _identPut($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$042$lcssa = 0, $$04250 = 0, $$1$lcssa = 0, $$14346 = 0, $$147 = 0, $$2 = 0, $$3 = 0, $$lcssa = 0, $$lcssa44 = 0, $$lcssa45 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$1>>2]|0; //@line 103138 "c/sqlite3.c"
 $4 = HEAP8[$2>>0]|0; //@line 103140 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 103140 "c/sqlite3.c"
 L1: do {
  if ($5) {
   $$042$lcssa = 0;$$lcssa45 = $2;
  } else {
   $$04250 = 0;$47 = $2;$7 = $4;
   while(1) {
    $6 = $7&255; //@line 103141 "c/sqlite3.c"
    $8 = (16281 + ($6)|0); //@line 103141 "c/sqlite3.c"
    $9 = HEAP8[$8>>0]|0; //@line 103141 "c/sqlite3.c"
    $10 = $9 & 6; //@line 103141 "c/sqlite3.c"
    $11 = ($10<<24>>24)!=(0); //@line 103141 "c/sqlite3.c"
    $12 = ($7<<24>>24)==(95); //@line 103141 "c/sqlite3.c"
    $or$cond = $12 | $11; //@line 103141 "c/sqlite3.c"
    if (!($or$cond)) {
     $$042$lcssa = $$04250;$$lcssa45 = $47;
     break L1;
    }
    $13 = (($$04250) + 1)|0; //@line 103140 "c/sqlite3.c"
    $14 = (($2) + ($13)|0); //@line 103140 "c/sqlite3.c"
    $15 = HEAP8[$14>>0]|0; //@line 103140 "c/sqlite3.c"
    $16 = ($15<<24>>24)==(0); //@line 103140 "c/sqlite3.c"
    if ($16) {
     $$042$lcssa = $13;$$lcssa45 = $14;
     break;
    } else {
     $$04250 = $13;$47 = $14;$7 = $15;
    }
   }
  }
 } while(0);
 $17 = HEAP8[$2>>0]|0; //@line 103143 "c/sqlite3.c"
 $18 = $17&255; //@line 103143 "c/sqlite3.c"
 $19 = (($18) + -48)|0; //@line 103143 "c/sqlite3.c"
 $20 = ($19>>>0)<(10); //@line 103143 "c/sqlite3.c"
 if ($20) {
  label = 8;
 } else {
  $21 = (_sqlite3KeywordCode($2,$$042$lcssa)|0); //@line 103144 "c/sqlite3.c"
  $22 = ($21|0)==(59); //@line 103144 "c/sqlite3.c"
  if ($22) {
   $23 = ($$042$lcssa|0)==(0); //@line 103146 "c/sqlite3.c"
   $24 = HEAP8[$$lcssa45>>0]|0; //@line 103145 "c/sqlite3.c"
   $25 = ($24<<24>>24)!=(0); //@line 103145 "c/sqlite3.c"
   $spec$select = $23 | $25; //@line 103146 "c/sqlite3.c"
   if ($spec$select) {
    label = 8;
   } else {
    $$0 = $3;$48 = 0;
   }
  } else {
   label = 8;
  }
 }
 if ((label|0) == 8) {
  $26 = (($3) + 1)|0; //@line 103148 "c/sqlite3.c"
  $27 = (($0) + ($3)|0); //@line 103148 "c/sqlite3.c"
  HEAP8[$27>>0] = 34; //@line 103148 "c/sqlite3.c"
  $$0 = $26;$48 = 1;
 }
 $28 = HEAP8[$2>>0]|0; //@line 103149 "c/sqlite3.c"
 $29 = ($28<<24>>24)==(0); //@line 103149 "c/sqlite3.c"
 $30 = (($$0) + 1)|0;
 $31 = (($0) + ($$0)|0);
 if ($29) {
  $$1$lcssa = $$0;$$lcssa = $31;$$lcssa44 = $30;
 } else {
  $$14346 = 0;$$147 = $$0;$32 = $28;$33 = $31;$35 = $2;$38 = $30;
  while(1) {
   HEAP8[$33>>0] = $32; //@line 103150 "c/sqlite3.c"
   $34 = HEAP8[$35>>0]|0; //@line 103151 "c/sqlite3.c"
   $36 = ($34<<24>>24)==(34); //@line 103151 "c/sqlite3.c"
   if ($36) {
    $37 = (($0) + ($38)|0); //@line 103151 "c/sqlite3.c"
    $39 = (($$147) + 2)|0; //@line 103151 "c/sqlite3.c"
    HEAP8[$37>>0] = 34; //@line 103151 "c/sqlite3.c"
    $$2 = $39;
   } else {
    $$2 = $38;
   }
   $40 = (($$14346) + 1)|0; //@line 103149 "c/sqlite3.c"
   $41 = (($2) + ($40)|0); //@line 103149 "c/sqlite3.c"
   $42 = HEAP8[$41>>0]|0; //@line 103149 "c/sqlite3.c"
   $43 = ($42<<24>>24)==(0); //@line 103149 "c/sqlite3.c"
   $44 = (($$2) + 1)|0;
   $45 = (($0) + ($$2)|0);
   if ($43) {
    $$1$lcssa = $$2;$$lcssa = $45;$$lcssa44 = $44;
    break;
   } else {
    $$14346 = $40;$$147 = $$2;$32 = $42;$33 = $45;$35 = $41;$38 = $44;
   }
  }
 }
 if (!($48)) {
  $$3 = $$1$lcssa;
  $46 = (($0) + ($$3)|0); //@line 103154 "c/sqlite3.c"
  HEAP8[$46>>0] = 0; //@line 103154 "c/sqlite3.c"
  HEAP32[$1>>2] = $$3; //@line 103155 "c/sqlite3.c"
  return; //@line 103156 "c/sqlite3.c"
 }
 HEAP8[$$lcssa>>0] = 34; //@line 103153 "c/sqlite3.c"
 $$3 = $$lcssa44;
 $46 = (($0) + ($$3)|0); //@line 103154 "c/sqlite3.c"
 HEAP8[$46>>0] = 0; //@line 103154 "c/sqlite3.c"
 HEAP32[$1>>2] = $$3; //@line 103155 "c/sqlite3.c"
 return; //@line 103156 "c/sqlite3.c"
}
function _sqlite3KeywordCode($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$2>>2] = 59; //@line 142496 "c/sqlite3.c"
 (_keywordCode($0,$1,$2)|0); //@line 142497 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 142498 "c/sqlite3.c"
 STACKTOP = sp;return ($3|0); //@line 142498 "c/sqlite3.c"
}
function _keywordCode($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02629 = 0, $$033 = 0, $$033$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)>(1); //@line 142352 "c/sqlite3.c"
 if (!($3)) {
  return ($1|0); //@line 142493 "c/sqlite3.c"
 }
 $4 = HEAP8[$0>>0]|0; //@line 142353 "c/sqlite3.c"
 $5 = $4&255; //@line 142353 "c/sqlite3.c"
 $6 = (16025 + ($5)|0); //@line 142353 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 142353 "c/sqlite3.c"
 $8 = $7&255; //@line 142353 "c/sqlite3.c"
 $9 = $8 << 2; //@line 142353 "c/sqlite3.c"
 $10 = (($1) + -1)|0; //@line 142353 "c/sqlite3.c"
 $11 = (($0) + ($10)|0); //@line 142353 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 142353 "c/sqlite3.c"
 $13 = $12&255; //@line 142353 "c/sqlite3.c"
 $14 = (16025 + ($13)|0); //@line 142353 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 142353 "c/sqlite3.c"
 $16 = $15&255; //@line 142353 "c/sqlite3.c"
 $17 = ($16*3)|0; //@line 142353 "c/sqlite3.c"
 $18 = $9 ^ $1; //@line 142353 "c/sqlite3.c"
 $19 = $18 ^ $17; //@line 142353 "c/sqlite3.c"
 $20 = (($19|0) % 127)&-1; //@line 142353 "c/sqlite3.c"
 $21 = (30123 + ($20)|0); //@line 142354 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 142354 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(0); //@line 142354 "c/sqlite3.c"
 if ($23) {
  return ($1|0); //@line 142493 "c/sqlite3.c"
 }
 $24 = $22&255; //@line 142354 "c/sqlite3.c"
 $$033$in = $24;
 L7: while(1) {
  $$033 = (($$033$in) + -1)|0;
  $25 = (30250 + ($$033)|0); //@line 142355 "c/sqlite3.c"
  $26 = HEAP8[$25>>0]|0; //@line 142355 "c/sqlite3.c"
  $27 = $26&255; //@line 142355 "c/sqlite3.c"
  $28 = ($27|0)==($1|0); //@line 142355 "c/sqlite3.c"
  L9: do {
   if ($28) {
    $29 = (11726 + ($$033<<1)|0); //@line 142357 "c/sqlite3.c"
    $30 = HEAP16[$29>>1]|0; //@line 142357 "c/sqlite3.c"
    $31 = $30&65535; //@line 142357 "c/sqlite3.c"
    $32 = (30374 + ($31)|0); //@line 142357 "c/sqlite3.c"
    $$02629 = 0;
    while(1) {
     $35 = (($0) + ($$02629)|0); //@line 142359 "c/sqlite3.c"
     $36 = HEAP8[$35>>0]|0; //@line 142359 "c/sqlite3.c"
     $37 = $36 & -33; //@line 142359 "c/sqlite3.c"
     $38 = (($32) + ($$02629)|0); //@line 142359 "c/sqlite3.c"
     $39 = HEAP8[$38>>0]|0; //@line 142359 "c/sqlite3.c"
     $40 = ($37<<24>>24)==($39<<24>>24); //@line 142359 "c/sqlite3.c"
     $34 = (($$02629) + 1)|0; //@line 142359 "c/sqlite3.c"
     if (!($40)) {
      break L9;
     }
     $33 = ($34|0)<($1|0); //@line 142359 "c/sqlite3.c"
     if ($33) {
      $$02629 = $34;
     } else {
      break L7;
     }
    }
   }
  } while(0);
  $44 = (31051 + ($$033)|0); //@line 142354 "c/sqlite3.c"
  $45 = HEAP8[$44>>0]|0; //@line 142354 "c/sqlite3.c"
  $46 = $45&255; //@line 142354 "c/sqlite3.c"
  $47 = ($45<<24>>24)==(0); //@line 142354 "c/sqlite3.c"
  if ($47) {
   label = 10;
   break;
  } else {
   $$033$in = $46;
  }
 }
 if ((label|0) == 10) {
  return ($1|0); //@line 142493 "c/sqlite3.c"
 }
 $41 = (30927 + ($$033)|0); //@line 142489 "c/sqlite3.c"
 $42 = HEAP8[$41>>0]|0; //@line 142489 "c/sqlite3.c"
 $43 = $42&255; //@line 142489 "c/sqlite3.c"
 HEAP32[$2>>2] = $43; //@line 142489 "c/sqlite3.c"
 return ($1|0); //@line 142493 "c/sqlite3.c"
}
function _resizeIndexObject($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 52|0); //@line 103234 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 103234 "c/sqlite3.c"
 $5 = $4&65535; //@line 103234 "c/sqlite3.c"
 $6 = ($5|0)<($2|0); //@line 103234 "c/sqlite3.c"
 if (!($6)) {
  $$0 = 0;
  return ($$0|0); //@line 103250 "c/sqlite3.c"
 }
 $7 = ($2*7)|0; //@line 103236 "c/sqlite3.c"
 $8 = ($7|0)<(0); //@line 103237 "c/sqlite3.c"
 $9 = $8 << 31 >> 31; //@line 103237 "c/sqlite3.c"
 $10 = (_sqlite3DbMallocZero($0,$7,$9)|0); //@line 103237 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 103238 "c/sqlite3.c"
 if ($11) {
  $$0 = 7;
  return ($$0|0); //@line 103250 "c/sqlite3.c"
 }
 $12 = ((($1)) + 32|0); //@line 103239 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 103239 "c/sqlite3.c"
 $14 = HEAP16[$3>>1]|0; //@line 103239 "c/sqlite3.c"
 $15 = $14&65535; //@line 103239 "c/sqlite3.c"
 $16 = $15 << 2; //@line 103239 "c/sqlite3.c"
 _memcpy(($10|0),($13|0),($16|0))|0; //@line 103239 "c/sqlite3.c"
 HEAP32[$12>>2] = $10; //@line 103240 "c/sqlite3.c"
 $17 = $2 << 2; //@line 103241 "c/sqlite3.c"
 $18 = (($10) + ($17)|0); //@line 103241 "c/sqlite3.c"
 $19 = ((($1)) + 4|0); //@line 103242 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 103242 "c/sqlite3.c"
 $21 = HEAP16[$3>>1]|0; //@line 103242 "c/sqlite3.c"
 $22 = $21&65535; //@line 103242 "c/sqlite3.c"
 $23 = $22 << 1; //@line 103242 "c/sqlite3.c"
 _memcpy(($18|0),($20|0),($23|0))|0; //@line 103242 "c/sqlite3.c"
 HEAP32[$19>>2] = $18; //@line 103243 "c/sqlite3.c"
 $24 = $2 << 1; //@line 103244 "c/sqlite3.c"
 $25 = (($18) + ($24)|0); //@line 103244 "c/sqlite3.c"
 $26 = ((($1)) + 28|0); //@line 103245 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 103245 "c/sqlite3.c"
 $28 = HEAP16[$3>>1]|0; //@line 103245 "c/sqlite3.c"
 $29 = $28&65535; //@line 103245 "c/sqlite3.c"
 _memcpy(($25|0),($27|0),($29|0))|0; //@line 103245 "c/sqlite3.c"
 HEAP32[$26>>2] = $25; //@line 103246 "c/sqlite3.c"
 $30 = $2&65535; //@line 103247 "c/sqlite3.c"
 HEAP16[$3>>1] = $30; //@line 103247 "c/sqlite3.c"
 $31 = ((($1)) + 55|0); //@line 103248 "c/sqlite3.c"
 $32 = HEAPU8[$31>>0]|(HEAPU8[$31+1>>0]<<8); //@line 103248 "c/sqlite3.c"
 $33 = $32 | 16; //@line 103248 "c/sqlite3.c"
 HEAP8[$31>>0]=$33&255;HEAP8[$31+1>>0]=$33>>8; //@line 103248 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 103250 "c/sqlite3.c"
}
function _sqlite3OpenMasterTable($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3GetVdbe($0)|0); //@line 102320 "c/sqlite3.c"
 _sqlite3TableLock($0,$1,1,1,19754); //@line 102321 "c/sqlite3.c"
 (_sqlite3VdbeAddOp4Int($2,106,0,1,$1,5)|0); //@line 102322 "c/sqlite3.c"
 $3 = ((($0)) + 40|0); //@line 102323 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 102323 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 102323 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 102326 "c/sqlite3.c"
 }
 HEAP32[$3>>2] = 1; //@line 102324 "c/sqlite3.c"
 return; //@line 102326 "c/sqlite3.c"
}
function _codeTableLocks($0) {
 $0 = $0|0;
 var $$018 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3GetVdbe($0)|0); //@line 101713 "c/sqlite3.c"
 $2 = ((($0)) + 108|0); //@line 101716 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 101716 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 101716 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 101722 "c/sqlite3.c"
 }
 $5 = ((($0)) + 112|0);
 $$018 = 0;
 while(1) {
  $6 = HEAP32[$5>>2]|0; //@line 101717 "c/sqlite3.c"
  $7 = (($6) + ($$018<<4)|0); //@line 101718 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 101718 "c/sqlite3.c"
  $9 = (((($6) + ($$018<<4)|0)) + 4|0); //@line 101719 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 101719 "c/sqlite3.c"
  $11 = (((($6) + ($$018<<4)|0)) + 8|0); //@line 101719 "c/sqlite3.c"
  $12 = HEAP8[$11>>0]|0; //@line 101719 "c/sqlite3.c"
  $13 = $12&255; //@line 101719 "c/sqlite3.c"
  $14 = (((($6) + ($$018<<4)|0)) + 12|0); //@line 101720 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 101720 "c/sqlite3.c"
  (_sqlite3VdbeAddOp4($1,153,$8,$10,$13,$15,-1)|0); //@line 101719 "c/sqlite3.c"
  $16 = (($$018) + 1)|0; //@line 101716 "c/sqlite3.c"
  $17 = HEAP32[$2>>2]|0; //@line 101716 "c/sqlite3.c"
  $18 = ($16|0)<($17|0); //@line 101716 "c/sqlite3.c"
  if ($18) {
   $$018 = $16;
  } else {
   break;
  }
 }
 return; //@line 101722 "c/sqlite3.c"
}
function _sqlite3AutoincrementBegin($0) {
 $0 = $0|0;
 var $$044 = 0, $$04445 = 0, $$04446 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 111095 "c/sqlite3.c"
 $2 = ((($0)) + 8|0); //@line 111098 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 111098 "c/sqlite3.c"
 $4 = ((($0)) + 116|0); //@line 111106 "c/sqlite3.c"
 $5 = ((($1)) + 16|0); //@line 111121 "c/sqlite3.c"
 $$04445 = HEAP32[$4>>2]|0;
 $6 = ($$04445|0)==(0|0); //@line 111106 "c/sqlite3.c"
 if ($6) {
  return; //@line 111138 "c/sqlite3.c"
 }
 $$04446 = $$04445;
 while(1) {
  $7 = HEAP32[$5>>2]|0; //@line 111121 "c/sqlite3.c"
  $8 = ((($$04446)) + 8|0); //@line 111121 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 111121 "c/sqlite3.c"
  $10 = ((($$04446)) + 12|0); //@line 111122 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 111122 "c/sqlite3.c"
  $12 = (((($7) + ($9<<4)|0)) + 12|0); //@line 111124 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 111124 "c/sqlite3.c"
  $14 = ((($13)) + 72|0); //@line 111124 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 111124 "c/sqlite3.c"
  _sqlite3OpenTable($0,0,$9,$15,105); //@line 111124 "c/sqlite3.c"
  $16 = (($11) + -1)|0; //@line 111125 "c/sqlite3.c"
  $17 = ((($$04446)) + 4|0); //@line 111125 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 111125 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 111125 "c/sqlite3.c"
  (_sqlite3VdbeLoadString($3,$16,$19)|0); //@line 111125 "c/sqlite3.c"
  $20 = (_sqlite3VdbeAddOpList($3,10,31315)|0); //@line 111126 "c/sqlite3.c"
  $21 = ($20|0)==(0|0); //@line 111127 "c/sqlite3.c"
  if ($21) {
   label = 5;
   break;
  }
  $22 = ((($20)) + 8|0); //@line 111128 "c/sqlite3.c"
  HEAP32[$22>>2] = $11; //@line 111128 "c/sqlite3.c"
  $23 = (($11) + 1)|0; //@line 111129 "c/sqlite3.c"
  $24 = ((($20)) + 12|0); //@line 111129 "c/sqlite3.c"
  HEAP32[$24>>2] = $23; //@line 111129 "c/sqlite3.c"
  $25 = ((($20)) + 52|0); //@line 111130 "c/sqlite3.c"
  HEAP32[$25>>2] = $11; //@line 111130 "c/sqlite3.c"
  $26 = ((($20)) + 64|0); //@line 111131 "c/sqlite3.c"
  HEAP32[$26>>2] = $16; //@line 111131 "c/sqlite3.c"
  $27 = ((($20)) + 72|0); //@line 111132 "c/sqlite3.c"
  HEAP32[$27>>2] = $11; //@line 111132 "c/sqlite3.c"
  $28 = ((($20)) + 62|0); //@line 111133 "c/sqlite3.c"
  HEAP16[$28>>1] = 16; //@line 111133 "c/sqlite3.c"
  $29 = ((($20)) + 88|0); //@line 111134 "c/sqlite3.c"
  HEAP32[$29>>2] = $23; //@line 111134 "c/sqlite3.c"
  $30 = ((($20)) + 112|0); //@line 111135 "c/sqlite3.c"
  HEAP32[$30>>2] = $11; //@line 111135 "c/sqlite3.c"
  $31 = ((($20)) + 168|0); //@line 111136 "c/sqlite3.c"
  HEAP32[$31>>2] = $11; //@line 111136 "c/sqlite3.c"
  $$044 = HEAP32[$$04446>>2]|0;
  $32 = ($$044|0)==(0|0); //@line 111106 "c/sqlite3.c"
  if ($32) {
   label = 5;
   break;
  } else {
   $$04446 = $$044;
  }
 }
 if ((label|0) == 5) {
  return; //@line 111138 "c/sqlite3.c"
 }
}
function _sqlite3VdbeMakeReady($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $or$cond = 0, $or$cond3 = 0, $phitmp = 0, $phitmp71 = 0, $spec$select = 0, $spec$select72 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 12|0;
 $3 = sp;
 $4 = HEAP32[$0>>2]|0; //@line 74947 "c/sqlite3.c"
 $5 = ((($1)) + 396|0); //@line 74949 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 74949 "c/sqlite3.c"
 $7 = $6 << 16 >> 16; //@line 74949 "c/sqlite3.c"
 $8 = ((($1)) + 44|0); //@line 74950 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 74950 "c/sqlite3.c"
 $10 = ((($1)) + 40|0); //@line 74951 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 74951 "c/sqlite3.c"
 $12 = ((($1)) + 104|0); //@line 74952 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 74952 "c/sqlite3.c"
 HEAP32[$2>>2] = $13; //@line 74952 "c/sqlite3.c"
 $14 = (($11) + ($9))|0; //@line 74959 "c/sqlite3.c"
 $15 = ($11|0)==(0); //@line 74960 "c/sqlite3.c"
 $16 = ($14|0)>(0); //@line 74960 "c/sqlite3.c"
 $or$cond = $15 & $16; //@line 74960 "c/sqlite3.c"
 $17 = $or$cond&1; //@line 74960 "c/sqlite3.c"
 $spec$select = (($14) + ($17))|0; //@line 74960 "c/sqlite3.c"
 $18 = ((($0)) + 136|0); //@line 74966 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 74966 "c/sqlite3.c"
 $20 = ($19*20)|0; //@line 74966 "c/sqlite3.c"
 $21 = (($20) + 7)|0; //@line 74966 "c/sqlite3.c"
 $22 = $21 & -8; //@line 74966 "c/sqlite3.c"
 $23 = ((($0)) + 88|0); //@line 74967 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 74967 "c/sqlite3.c"
 $25 = (($24) + ($22)|0); //@line 74967 "c/sqlite3.c"
 HEAP32[$3>>2] = $25; //@line 74967 "c/sqlite3.c"
 $26 = ((($1)) + 52|0); //@line 74969 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 74969 "c/sqlite3.c"
 $28 = (($27) - ($22))|0; //@line 74969 "c/sqlite3.c"
 $29 = $28 & -8; //@line 74969 "c/sqlite3.c"
 $30 = ((($3)) + 4|0); //@line 74969 "c/sqlite3.c"
 HEAP32[$30>>2] = $29; //@line 74969 "c/sqlite3.c"
 _resolveP2Values($0,$2); //@line 74973 "c/sqlite3.c"
 $31 = ((($1)) + 20|0); //@line 74974 "c/sqlite3.c"
 $32 = HEAP8[$31>>0]|0; //@line 74974 "c/sqlite3.c"
 $33 = ($32<<24>>24)==(0); //@line 74974 "c/sqlite3.c"
 if ($33) {
  $41 = 0;
 } else {
  $34 = ((($1)) + 21|0); //@line 74974 "c/sqlite3.c"
  $35 = HEAP8[$34>>0]|0; //@line 74974 "c/sqlite3.c"
  $36 = ($35<<24>>24)!=(0); //@line 74974 "c/sqlite3.c"
  $phitmp71 = $36&1;
  $phitmp = ($phitmp71 << 6)&65535;
  $41 = $phitmp;
 }
 $37 = ((($0)) + 145|0); //@line 74974 "c/sqlite3.c"
 $38 = HEAPU8[$37>>0]|(HEAPU8[$37+1>>0]<<8); //@line 74974 "c/sqlite3.c"
 $39 = $38 & -65; //@line 74974 "c/sqlite3.c"
 $40 = $39 | $41; //@line 74974 "c/sqlite3.c"
 HEAP8[$37>>0]=$40&255;HEAP8[$37+1>>0]=$40>>8; //@line 74974 "c/sqlite3.c"
 $42 = ((($1)) + 399|0); //@line 74975 "c/sqlite3.c"
 $43 = HEAP8[$42>>0]|0; //@line 74975 "c/sqlite3.c"
 $44 = ($43<<24>>24)!=(0); //@line 74975 "c/sqlite3.c"
 $45 = ($spec$select|0)<(10); //@line 74975 "c/sqlite3.c"
 $or$cond3 = $45 & $44; //@line 74975 "c/sqlite3.c"
 $spec$select72 = $or$cond3 ? 10 : $spec$select; //@line 74975 "c/sqlite3.c"
 $46 = $40 & -2; //@line 74978 "c/sqlite3.c"
 HEAP8[$37>>0]=$46&255;HEAP8[$37+1>>0]=$46>>8; //@line 74978 "c/sqlite3.c"
 $47 = ((($3)) + 8|0);
 $48 = ((($0)) + 92|0);
 $49 = ($spec$select72*40)|0;
 $50 = ((($0)) + 116|0);
 $51 = ($7*40)|0;
 $52 = ((($0)) + 96|0);
 $53 = HEAP32[$2>>2]|0;
 $54 = $53 << 2;
 $55 = ((($0)) + 112|0);
 $56 = $11 << 2;
 $57 = ((($0)) + 188|0);
 $58 = ((($4)) + 73|0);
 while(1) {
  HEAP32[$47>>2] = 0; //@line 74991 "c/sqlite3.c"
  $59 = HEAP32[$48>>2]|0; //@line 74992 "c/sqlite3.c"
  $60 = (_allocSpace($3,$59,$49)|0); //@line 74992 "c/sqlite3.c"
  HEAP32[$48>>2] = $60; //@line 74992 "c/sqlite3.c"
  $61 = HEAP32[$50>>2]|0; //@line 74993 "c/sqlite3.c"
  $62 = (_allocSpace($3,$61,$51)|0); //@line 74993 "c/sqlite3.c"
  HEAP32[$50>>2] = $62; //@line 74993 "c/sqlite3.c"
  $63 = HEAP32[$52>>2]|0; //@line 74994 "c/sqlite3.c"
  $64 = (_allocSpace($3,$63,$54)|0); //@line 74994 "c/sqlite3.c"
  HEAP32[$52>>2] = $64; //@line 74994 "c/sqlite3.c"
  $65 = HEAP32[$55>>2]|0; //@line 74995 "c/sqlite3.c"
  $66 = (_allocSpace($3,$65,$56)|0); //@line 74995 "c/sqlite3.c"
  HEAP32[$55>>2] = $66; //@line 74995 "c/sqlite3.c"
  $67 = HEAP32[$47>>2]|0; //@line 74999 "c/sqlite3.c"
  $68 = ($67|0)==(0); //@line 74999 "c/sqlite3.c"
  if ($68) {
   break;
  }
  $69 = ($67|0)<(0); //@line 75000 "c/sqlite3.c"
  $70 = $69 << 31 >> 31; //@line 75000 "c/sqlite3.c"
  $71 = (_sqlite3DbMallocRawNN($4,$67,$70)|0); //@line 75000 "c/sqlite3.c"
  HEAP32[$57>>2] = $71; //@line 75000 "c/sqlite3.c"
  HEAP32[$3>>2] = $71; //@line 75000 "c/sqlite3.c"
  HEAP32[$30>>2] = $67; //@line 75001 "c/sqlite3.c"
  $72 = HEAP8[$58>>0]|0; //@line 75002 "c/sqlite3.c"
  $73 = ($72<<24>>24)==(0); //@line 75002 "c/sqlite3.c"
  if (!($73)) {
   break;
  }
 }
 $74 = ((($1)) + 420|0); //@line 75004 "c/sqlite3.c"
 $75 = HEAP32[$74>>2]|0; //@line 75004 "c/sqlite3.c"
 $76 = ((($0)) + 120|0); //@line 75004 "c/sqlite3.c"
 HEAP32[$76>>2] = $75; //@line 75004 "c/sqlite3.c"
 HEAP32[$74>>2] = 0; //@line 75005 "c/sqlite3.c"
 $77 = HEAP8[$42>>0]|0; //@line 75006 "c/sqlite3.c"
 $78 = HEAPU8[$37>>0]|(HEAPU8[$37+1>>0]<<8); //@line 75006 "c/sqlite3.c"
 $79 = ($77 << 2)&255; //@line 75006 "c/sqlite3.c"
 $80 = $79 & 12; //@line 75006 "c/sqlite3.c"
 $81 = $80&255; //@line 75006 "c/sqlite3.c"
 $82 = $78 & -13; //@line 75006 "c/sqlite3.c"
 $83 = $82 | $81; //@line 75006 "c/sqlite3.c"
 HEAP8[$37>>0]=$83&255;HEAP8[$37+1>>0]=$83>>8; //@line 75006 "c/sqlite3.c"
 $84 = ((($4)) + 73|0); //@line 75007 "c/sqlite3.c"
 $85 = HEAP8[$84>>0]|0; //@line 75007 "c/sqlite3.c"
 $86 = ($85<<24>>24)==(0); //@line 75007 "c/sqlite3.c"
 if ($86) {
  $90 = ((($0)) + 28|0); //@line 75012 "c/sqlite3.c"
  HEAP32[$90>>2] = $11; //@line 75012 "c/sqlite3.c"
  $91 = ((($0)) + 16|0); //@line 75013 "c/sqlite3.c"
  HEAP16[$91>>1] = $6; //@line 75013 "c/sqlite3.c"
  $92 = HEAP32[$50>>2]|0; //@line 75014 "c/sqlite3.c"
  _initMemArray($92,$7,$4,1); //@line 75014 "c/sqlite3.c"
  $93 = ((($0)) + 24|0); //@line 75015 "c/sqlite3.c"
  HEAP32[$93>>2] = $spec$select72; //@line 75015 "c/sqlite3.c"
  $94 = HEAP32[$48>>2]|0; //@line 75016 "c/sqlite3.c"
  _initMemArray($94,$spec$select72,$4,128); //@line 75016 "c/sqlite3.c"
  $95 = HEAP32[$55>>2]|0; //@line 75017 "c/sqlite3.c"
  _memset(($95|0),0,($56|0))|0; //@line 75017 "c/sqlite3.c"
  _sqlite3VdbeRewind($0); //@line 75022 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 75023 "c/sqlite3.c"
 } else {
  $87 = ((($0)) + 16|0); //@line 75008 "c/sqlite3.c"
  HEAP16[$87>>1] = 0; //@line 75008 "c/sqlite3.c"
  $88 = ((($0)) + 28|0); //@line 75009 "c/sqlite3.c"
  HEAP32[$88>>2] = 0; //@line 75009 "c/sqlite3.c"
  $89 = ((($0)) + 24|0); //@line 75010 "c/sqlite3.c"
  HEAP32[$89>>2] = 0; //@line 75010 "c/sqlite3.c"
  _sqlite3VdbeRewind($0); //@line 75022 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 75023 "c/sqlite3.c"
 }
}
function _allocSpace($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0|0); //@line 74860 "c/sqlite3.c"
 if (!($3)) {
  $$0 = $1;
  return ($$0|0); //@line 74870 "c/sqlite3.c"
 }
 $4 = (($2) + 7)|0; //@line 74861 "c/sqlite3.c"
 $5 = $4 & -8; //@line 74861 "c/sqlite3.c"
 $6 = ((($0)) + 4|0); //@line 74862 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 74862 "c/sqlite3.c"
 $8 = ($7|0)<($5|0); //@line 74862 "c/sqlite3.c"
 if ($8) {
  $12 = ((($0)) + 8|0); //@line 74866 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 74866 "c/sqlite3.c"
  $14 = (($13) + ($5))|0; //@line 74866 "c/sqlite3.c"
  HEAP32[$12>>2] = $14; //@line 74866 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 74870 "c/sqlite3.c"
 } else {
  $9 = (($7) - ($5))|0; //@line 74863 "c/sqlite3.c"
  HEAP32[$6>>2] = $9; //@line 74863 "c/sqlite3.c"
  $10 = HEAP32[$0>>2]|0; //@line 74864 "c/sqlite3.c"
  $11 = (($10) + ($9)|0); //@line 74864 "c/sqlite3.c"
  $$0 = $11;
  return ($$0|0); //@line 74870 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeRewind($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 74889 "c/sqlite3.c"
 HEAP32[$1>>2] = 770837923; //@line 74889 "c/sqlite3.c"
 $2 = ((($0)) + 36|0); //@line 74896 "c/sqlite3.c"
 HEAP32[$2>>2] = -1; //@line 74896 "c/sqlite3.c"
 $3 = ((($0)) + 40|0); //@line 74897 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 74897 "c/sqlite3.c"
 $4 = ((($0)) + 142|0); //@line 74898 "c/sqlite3.c"
 HEAP8[$4>>0] = 2; //@line 74898 "c/sqlite3.c"
 $5 = ((($0)) + 44|0); //@line 74899 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 74899 "c/sqlite3.c"
 $6 = ((($0)) + 32|0); //@line 74900 "c/sqlite3.c"
 HEAP32[$6>>2] = 1; //@line 74900 "c/sqlite3.c"
 $7 = ((($0)) + 143|0); //@line 74901 "c/sqlite3.c"
 HEAP8[$7>>0] = -1; //@line 74901 "c/sqlite3.c"
 $8 = ((($0)) + 48|0); //@line 74902 "c/sqlite3.c"
 HEAP32[$8>>2] = 0; //@line 74902 "c/sqlite3.c"
 $9 = ((($0)) + 64|0); //@line 74903 "c/sqlite3.c"
 $10 = $9; //@line 74903 "c/sqlite3.c"
 $11 = $10; //@line 74903 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 74903 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 74903 "c/sqlite3.c"
 $13 = $12; //@line 74903 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 74903 "c/sqlite3.c"
 return; //@line 74910 "c/sqlite3.c"
}
function _btreeEnterAll($0) {
 $0 = $0|0;
 var $$014$lcssa = 0, $$01415 = 0, $$016 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 60283 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60283 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 60283 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 16|0);
  $$01415 = 1;$$016 = 0;
  while(1) {
   $5 = HEAP32[$4>>2]|0; //@line 60284 "c/sqlite3.c"
   $6 = (((($5) + ($$016<<4)|0)) + 4|0); //@line 60284 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 60284 "c/sqlite3.c"
   $8 = ($7|0)==(0|0); //@line 60285 "c/sqlite3.c"
   if ($8) {
    $$1 = $$01415;
   } else {
    $9 = ((($7)) + 9|0); //@line 60285 "c/sqlite3.c"
    $10 = HEAP8[$9>>0]|0; //@line 60285 "c/sqlite3.c"
    $11 = ($10<<24>>24)==(0); //@line 60285 "c/sqlite3.c"
    if ($11) {
     $$1 = $$01415;
    } else {
     _sqlite3BtreeEnter($7); //@line 60286 "c/sqlite3.c"
     $$1 = 0;
    }
   }
   $12 = (($$016) + 1)|0; //@line 60283 "c/sqlite3.c"
   $13 = HEAP32[$1>>2]|0; //@line 60283 "c/sqlite3.c"
   $14 = ($12|0)<($13|0); //@line 60283 "c/sqlite3.c"
   if ($14) {
    $$01415 = $$1;$$016 = $12;
   } else {
    $$014$lcssa = $$1;
    break;
   }
  }
 } else {
  $$014$lcssa = 1;
 }
 $15 = $$014$lcssa&255; //@line 60290 "c/sqlite3.c"
 $16 = ((($0)) + 81|0); //@line 60290 "c/sqlite3.c"
 HEAP8[$16>>0] = $15; //@line 60290 "c/sqlite3.c"
 return; //@line 60291 "c/sqlite3.c"
}
function _logBadConnection($0) {
 $0 = $0|0;
 var $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 29729 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $0; //@line 29730 "c/sqlite3.c"
 _sqlite3_log(21,33434,$vararg_buffer); //@line 29730 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 29734 "c/sqlite3.c"
}
function _sqlite3SafetyCheckSickOrOk($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $switch$split12D = 0, $switch$split2D = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 88|0); //@line 29769 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 29769 "c/sqlite3.c"
 $switch$split2D = ($2|0)<(-264537850);
 L1: do {
  if ($switch$split2D) {
   switch ($2|0) {
   case -1607883113:  {
    $$0 = 1;
    break;
   }
   default: {
    label = 2;
   }
   }
  } else {
   $switch$split12D = ($2|0)<(1266094736);
   if ($switch$split12D) {
    switch ($2|0) {
    case -264537850:  {
     $$0 = 1;
     break L1;
     break;
    }
    default: {
     label = 2;
     break L1;
    }
    }
   } else {
    switch ($2|0) {
    case 1266094736:  {
     $$0 = 1;
     break L1;
     break;
    }
    default: {
     label = 2;
     break L1;
    }
    }
   }
  }
 } while(0);
 if ((label|0) == 2) {
  _logBadConnection(33426); //@line 29774 "c/sqlite3.c"
  $$0 = 0;
 }
 return ($$0|0); //@line 29779 "c/sqlite3.c"
}
function _sqlite3VdbeExpandSql($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$06273 = 0, $$06371 = 0, $$069 = 0, $$274 = 0, $$lcssa = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0;
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0;
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0;
 var $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0.0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0;
 var $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer12 = 0, $vararg_buffer15 = 0, $vararg_buffer4 = 0, $vararg_buffer8 = 0;
 var $vararg_ptr11 = 0, $vararg_ptr7 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 224|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(224|0);
 $vararg_buffer15 = sp + 80|0;
 $vararg_buffer12 = sp + 72|0;
 $vararg_buffer8 = sp + 64|0;
 $vararg_buffer4 = sp + 56|0;
 $vararg_buffer1 = sp + 48|0;
 $vararg_buffer = sp + 40|0;
 $2 = sp + 116|0;
 $3 = sp + 112|0;
 $4 = sp + 88|0;
 $5 = sp;
 $6 = sp + 120|0;
 HEAP32[$2>>2] = 0; //@line 79771 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 79783 "c/sqlite3.c"
 $8 = ((($7)) + 100|0); //@line 79785 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 79785 "c/sqlite3.c"
 _sqlite3StrAccumInit($4,0,$6,100,$9); //@line 79784 "c/sqlite3.c"
 $10 = ((($7)) + 172|0); //@line 79786 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 79786 "c/sqlite3.c"
 $12 = ($11|0)>(1); //@line 79786 "c/sqlite3.c"
 L1: do {
  if ($12) {
   $13 = HEAP8[$1>>0]|0; //@line 79787 "c/sqlite3.c"
   $14 = ($13<<24>>24)==(0); //@line 79787 "c/sqlite3.c"
   if (!($14)) {
    $$069 = $1;$17 = $13;
    while(1) {
     $15 = ((($$069)) + 1|0); //@line 79789 "c/sqlite3.c"
     $16 = ($17<<24>>24)==(10); //@line 79789 "c/sqlite3.c"
     L6: do {
      if ($16) {
       $$lcssa = $15;
      } else {
       $19 = $15;
       while(1) {
        $21 = HEAP8[$19>>0]|0; //@line 79789 "c/sqlite3.c"
        $22 = ($21<<24>>24)==(0); //@line 79789 "c/sqlite3.c"
        if ($22) {
         $$lcssa = $19;
         break L6;
        }
        $18 = ((($19)) + 1|0); //@line 79789 "c/sqlite3.c"
        $20 = ($21<<24>>24)==(10); //@line 79789 "c/sqlite3.c"
        if ($20) {
         $$lcssa = $18;
         break;
        } else {
         $19 = $18;
        }
       }
      }
     } while(0);
     _sqlite3StrAccumAppend($4,33479,3); //@line 79790 "c/sqlite3.c"
     $23 = $$lcssa; //@line 79792 "c/sqlite3.c"
     $24 = $$069; //@line 79792 "c/sqlite3.c"
     $25 = (($23) - ($24))|0; //@line 79792 "c/sqlite3.c"
     _sqlite3StrAccumAppend($4,$$069,$25); //@line 79792 "c/sqlite3.c"
     $26 = HEAP8[$$lcssa>>0]|0; //@line 79787 "c/sqlite3.c"
     $27 = ($26<<24>>24)==(0); //@line 79787 "c/sqlite3.c"
     if ($27) {
      break;
     } else {
      $$069 = $$lcssa;$17 = $26;
     }
    }
   }
  } else {
   $28 = ((($0)) + 16|0); //@line 79794 "c/sqlite3.c"
   $29 = HEAP16[$28>>1]|0; //@line 79794 "c/sqlite3.c"
   $30 = ($29<<16>>16)==(0); //@line 79794 "c/sqlite3.c"
   if ($30) {
    $31 = (_sqlite3Strlen30($1)|0); //@line 79795 "c/sqlite3.c"
    _sqlite3StrAccumAppend($4,$1,$31); //@line 79795 "c/sqlite3.c"
    break;
   }
   $32 = HEAP8[$1>>0]|0; //@line 79797 "c/sqlite3.c"
   $33 = ($32<<24>>24)==(0); //@line 79797 "c/sqlite3.c"
   if (!($33)) {
    $34 = ((($0)) + 116|0);
    $35 = ((($7)) + 70|0);
    $36 = ((($5)) + 32|0);
    $37 = ((($4)) + 20|0);
    $38 = ((($4)) + 8|0);
    $39 = ((($5)) + 12|0);
    $40 = ((($5)) + 16|0);
    $$06273 = 1;$$274 = $1;
    while(1) {
     $41 = (_findNextHostParameter($$274,$3)|0); //@line 79798 "c/sqlite3.c"
     _sqlite3StrAccumAppend($4,$$274,$41); //@line 79800 "c/sqlite3.c"
     $42 = (($$274) + ($41)|0); //@line 79801 "c/sqlite3.c"
     $43 = HEAP32[$3>>2]|0; //@line 79803 "c/sqlite3.c"
     $44 = ($43|0)==(0); //@line 79803 "c/sqlite3.c"
     if ($44) {
      break L1;
     }
     $45 = HEAP8[$42>>0]|0; //@line 79804 "c/sqlite3.c"
     $46 = ($45<<24>>24)==(63); //@line 79804 "c/sqlite3.c"
     do {
      if ($46) {
       $47 = ($43|0)>(1); //@line 79805 "c/sqlite3.c"
       if ($47) {
        $48 = ((($42)) + 1|0); //@line 79807 "c/sqlite3.c"
        (_sqlite3GetInt32($48,$2)|0); //@line 79807 "c/sqlite3.c"
        break;
       } else {
        HEAP32[$2>>2] = $$06273; //@line 79809 "c/sqlite3.c"
        break;
       }
      } else {
       $49 = (_sqlite3VdbeParameterIndex($0,$42,$43)|0); //@line 79818 "c/sqlite3.c"
       HEAP32[$2>>2] = $49; //@line 79818 "c/sqlite3.c"
      }
     } while(0);
     $50 = (($42) + ($43)|0); //@line 79821 "c/sqlite3.c"
     $51 = HEAP32[$2>>2]|0; //@line 79822 "c/sqlite3.c"
     $52 = (($51) + 1)|0; //@line 79822 "c/sqlite3.c"
     $53 = HEAP32[$34>>2]|0; //@line 79824 "c/sqlite3.c"
     $54 = (($51) + -1)|0; //@line 79824 "c/sqlite3.c"
     $55 = (($53) + (($54*40)|0)|0); //@line 79824 "c/sqlite3.c"
     $56 = (((($53) + (($54*40)|0)|0)) + 8|0); //@line 79825 "c/sqlite3.c"
     $57 = HEAP16[$56>>1]|0; //@line 79825 "c/sqlite3.c"
     $58 = $57&65535; //@line 79825 "c/sqlite3.c"
     $59 = $58 & 1; //@line 79825 "c/sqlite3.c"
     $60 = ($59|0)==(0); //@line 79825 "c/sqlite3.c"
     do {
      if ($60) {
       $61 = $58 & 4; //@line 79827 "c/sqlite3.c"
       $62 = ($61|0)==(0); //@line 79827 "c/sqlite3.c"
       if (!($62)) {
        $63 = $55; //@line 79828 "c/sqlite3.c"
        $64 = $63; //@line 79828 "c/sqlite3.c"
        $65 = HEAP32[$64>>2]|0; //@line 79828 "c/sqlite3.c"
        $66 = (($63) + 4)|0; //@line 79828 "c/sqlite3.c"
        $67 = $66; //@line 79828 "c/sqlite3.c"
        $68 = HEAP32[$67>>2]|0; //@line 79828 "c/sqlite3.c"
        $69 = $vararg_buffer; //@line 79828 "c/sqlite3.c"
        $70 = $69; //@line 79828 "c/sqlite3.c"
        HEAP32[$70>>2] = $65; //@line 79828 "c/sqlite3.c"
        $71 = (($69) + 4)|0; //@line 79828 "c/sqlite3.c"
        $72 = $71; //@line 79828 "c/sqlite3.c"
        HEAP32[$72>>2] = $68; //@line 79828 "c/sqlite3.c"
        _sqlite3XPrintf($4,17149,$vararg_buffer); //@line 79828 "c/sqlite3.c"
        break;
       }
       $73 = $58 & 8; //@line 79829 "c/sqlite3.c"
       $74 = ($73|0)==(0); //@line 79829 "c/sqlite3.c"
       if (!($74)) {
        $75 = +HEAPF64[$55>>3]; //@line 79830 "c/sqlite3.c"
        HEAPF64[$vararg_buffer1>>3] = $75; //@line 79830 "c/sqlite3.c"
        _sqlite3XPrintf($4,17154,$vararg_buffer1); //@line 79830 "c/sqlite3.c"
        break;
       }
       $76 = $58 & 2; //@line 79831 "c/sqlite3.c"
       $77 = ($76|0)==(0); //@line 79831 "c/sqlite3.c"
       if (!($77)) {
        $78 = HEAP8[$35>>0]|0; //@line 79834 "c/sqlite3.c"
        $79 = ($78<<24>>24)==(1); //@line 79835 "c/sqlite3.c"
        if ($79) {
         $88 = (((($53) + (($54*40)|0)|0)) + 12|0); //@line 79846 "c/sqlite3.c"
         $89 = HEAP32[$88>>2]|0; //@line 79846 "c/sqlite3.c"
         $90 = (((($53) + (($54*40)|0)|0)) + 16|0); //@line 79853 "c/sqlite3.c"
         $91 = HEAP32[$90>>2]|0; //@line 79853 "c/sqlite3.c"
         HEAP32[$vararg_buffer8>>2] = $89; //@line 79853 "c/sqlite3.c"
         $vararg_ptr11 = ((($vararg_buffer8)) + 4|0); //@line 79853 "c/sqlite3.c"
         HEAP32[$vararg_ptr11>>2] = $91; //@line 79853 "c/sqlite3.c"
         _sqlite3XPrintf($4,33483,$vararg_buffer8); //@line 79853 "c/sqlite3.c"
         break;
        }
        dest=$5; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 79836 "c/sqlite3.c"
        HEAP32[$36>>2] = $7; //@line 79837 "c/sqlite3.c"
        $80 = (((($53) + (($54*40)|0)|0)) + 16|0); //@line 79838 "c/sqlite3.c"
        $81 = HEAP32[$80>>2]|0; //@line 79838 "c/sqlite3.c"
        $82 = (((($53) + (($54*40)|0)|0)) + 12|0); //@line 79838 "c/sqlite3.c"
        $83 = HEAP32[$82>>2]|0; //@line 79838 "c/sqlite3.c"
        (_sqlite3VdbeMemSetStr($5,$81,$83,$78,0)|0); //@line 79838 "c/sqlite3.c"
        $84 = (_sqlite3VdbeChangeEncoding($5,1)|0); //@line 79839 "c/sqlite3.c"
        $85 = ($84|0)==(7); //@line 79839 "c/sqlite3.c"
        if ($85) {
         HEAP8[$37>>0] = 1; //@line 79840 "c/sqlite3.c"
         HEAP32[$38>>2] = 0; //@line 79841 "c/sqlite3.c"
        }
        $86 = HEAP32[$39>>2]|0; //@line 79846 "c/sqlite3.c"
        $87 = HEAP32[$40>>2]|0; //@line 79853 "c/sqlite3.c"
        HEAP32[$vararg_buffer4>>2] = $86; //@line 79853 "c/sqlite3.c"
        $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 79853 "c/sqlite3.c"
        HEAP32[$vararg_ptr7>>2] = $87; //@line 79853 "c/sqlite3.c"
        _sqlite3XPrintf($4,33483,$vararg_buffer4); //@line 79853 "c/sqlite3.c"
        _sqlite3VdbeMemRelease($5); //@line 79860 "c/sqlite3.c"
        break;
       }
       $92 = $58 & 16384; //@line 79862 "c/sqlite3.c"
       $93 = ($92|0)==(0); //@line 79862 "c/sqlite3.c"
       if (!($93)) {
        $94 = HEAP32[$55>>2]|0; //@line 79863 "c/sqlite3.c"
        HEAP32[$vararg_buffer12>>2] = $94; //@line 79863 "c/sqlite3.c"
        _sqlite3XPrintf($4,33490,$vararg_buffer12); //@line 79863 "c/sqlite3.c"
        break;
       }
       _sqlite3StrAccumAppend($4,33503,2); //@line 79867 "c/sqlite3.c"
       $95 = (((($53) + (($54*40)|0)|0)) + 12|0); //@line 79868 "c/sqlite3.c"
       $96 = HEAP32[$95>>2]|0; //@line 79868 "c/sqlite3.c"
       $97 = ($96|0)>(0); //@line 79872 "c/sqlite3.c"
       if ($97) {
        $98 = (((($53) + (($54*40)|0)|0)) + 16|0);
        $$06371 = 0;
        while(1) {
         $99 = HEAP32[$98>>2]|0; //@line 79873 "c/sqlite3.c"
         $100 = (($99) + ($$06371)|0); //@line 79873 "c/sqlite3.c"
         $101 = HEAP8[$100>>0]|0; //@line 79873 "c/sqlite3.c"
         $102 = $101&255; //@line 79873 "c/sqlite3.c"
         HEAP32[$vararg_buffer15>>2] = $102; //@line 79873 "c/sqlite3.c"
         _sqlite3XPrintf($4,33506,$vararg_buffer15); //@line 79873 "c/sqlite3.c"
         $103 = (($$06371) + 1)|0; //@line 79872 "c/sqlite3.c"
         $exitcond = ($103|0)==($96|0); //@line 79872 "c/sqlite3.c"
         if ($exitcond) {
          break;
         } else {
          $$06371 = $103;
         }
        }
       }
       _sqlite3StrAccumAppend($4,33511,1); //@line 79875 "c/sqlite3.c"
      } else {
       _sqlite3StrAccumAppend($4,15390,4); //@line 79826 "c/sqlite3.c"
      }
     } while(0);
     $104 = HEAP8[$50>>0]|0; //@line 79797 "c/sqlite3.c"
     $105 = ($104<<24>>24)==(0); //@line 79797 "c/sqlite3.c"
     if ($105) {
      break;
     } else {
      $$06273 = $52;$$274 = $50;
     }
    }
   }
  }
 } while(0);
 $106 = ((($4)) + 20|0); //@line 79884 "c/sqlite3.c"
 $107 = HEAP8[$106>>0]|0; //@line 79884 "c/sqlite3.c"
 $108 = ($107<<24>>24)==(0); //@line 79884 "c/sqlite3.c"
 if ($108) {
  $109 = (_sqlite3StrAccumFinish($4)|0); //@line 79885 "c/sqlite3.c"
  STACKTOP = sp;return ($109|0); //@line 79885 "c/sqlite3.c"
 }
 _sqlite3StrAccumReset($4); //@line 79884 "c/sqlite3.c"
 $109 = (_sqlite3StrAccumFinish($4)|0); //@line 79885 "c/sqlite3.c"
 STACKTOP = sp;return ($109|0); //@line 79885 "c/sqlite3.c"
}
function _findNextHostParameter($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01113 = 0, $$01114 = 0, $$015 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$1>>2] = 0; //@line 79728 "c/sqlite3.c"
 $3 = HEAP8[$0>>0]|0; //@line 79729 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 79729 "c/sqlite3.c"
 if ($4) {
  $$01113 = 0;
  STACKTOP = sp;return ($$01113|0); //@line 79739 "c/sqlite3.c"
 }
 $$01114 = 0;$$015 = $0;
 while(1) {
  $5 = (_sqlite3GetToken($$015,$2)|0); //@line 79730 "c/sqlite3.c"
  $6 = HEAP32[$2>>2]|0; //@line 79732 "c/sqlite3.c"
  $7 = ($6|0)==(135); //@line 79732 "c/sqlite3.c"
  if ($7) {
   break;
  }
  $8 = (($5) + ($$01114))|0; //@line 79736 "c/sqlite3.c"
  $9 = (($$015) + ($5)|0); //@line 79737 "c/sqlite3.c"
  $10 = HEAP8[$9>>0]|0; //@line 79729 "c/sqlite3.c"
  $11 = ($10<<24>>24)==(0); //@line 79729 "c/sqlite3.c"
  if ($11) {
   $$01113 = $8;
   label = 6;
   break;
  } else {
   $$01114 = $8;$$015 = $9;
  }
 }
 if ((label|0) == 6) {
  STACKTOP = sp;return ($$01113|0); //@line 79739 "c/sqlite3.c"
 }
 HEAP32[$1>>2] = $5; //@line 79733 "c/sqlite3.c"
 $$01113 = $$01114;
 STACKTOP = sp;return ($$01113|0); //@line 79739 "c/sqlite3.c"
}
function _sqlite3VdbeParameterIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($0|0)==(0|0); //@line 79272 "c/sqlite3.c"
 $4 = ($1|0)==(0|0); //@line 79272 "c/sqlite3.c"
 $or$cond = $3 | $4; //@line 79272 "c/sqlite3.c"
 if ($or$cond) {
  $$0 = 0;
  return ($$0|0); //@line 79274 "c/sqlite3.c"
 }
 $5 = ((($0)) + 120|0); //@line 79273 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 79273 "c/sqlite3.c"
 $7 = (_sqlite3VListNameToNum($6,$1,$2)|0); //@line 79273 "c/sqlite3.c"
 $$0 = $7;
 return ($$0|0); //@line 79274 "c/sqlite3.c"
}
function _sqlite3PagerFlush($0) {
 $0 = $0|0;
 var $$01516 = 0, $$1 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 52601 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 52601 "c/sqlite3.c"
 $3 = ((($0)) + 15|0); //@line 52602 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 52602 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 52602 "c/sqlite3.c"
 if (!($5)) {
  $$2 = $2;
  return ($$2|0); //@line 52614 "c/sqlite3.c"
 }
 $6 = ((($0)) + 208|0); //@line 52603 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 52603 "c/sqlite3.c"
 $8 = (_sqlite3PcacheDirtyList($7)|0); //@line 52603 "c/sqlite3.c"
 $9 = ($2|0)==(0); //@line 52605 "c/sqlite3.c"
 $10 = ($8|0)!=(0|0); //@line 52605 "c/sqlite3.c"
 $11 = $10 & $9; //@line 52605 "c/sqlite3.c"
 if (!($11)) {
  $$2 = $2;
  return ($$2|0); //@line 52614 "c/sqlite3.c"
 }
 $$01516 = $8;
 while(1) {
  $12 = ((($$01516)) + 16|0); //@line 52606 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 52606 "c/sqlite3.c"
  $14 = ((($$01516)) + 30|0); //@line 52607 "c/sqlite3.c"
  $15 = HEAP16[$14>>1]|0; //@line 52607 "c/sqlite3.c"
  $16 = ($15<<16>>16)==(0); //@line 52607 "c/sqlite3.c"
  if ($16) {
   $17 = (_pagerStress($0,$$01516)|0); //@line 52608 "c/sqlite3.c"
   $$1 = $17;
  } else {
   $$1 = 0;
  }
  $18 = ($$1|0)==(0); //@line 52605 "c/sqlite3.c"
  $19 = ($13|0)!=(0|0); //@line 52605 "c/sqlite3.c"
  $20 = $19 & $18; //@line 52605 "c/sqlite3.c"
  if ($20) {
   $$01516 = $13;
  } else {
   $$2 = $$1;
   break;
  }
 }
 return ($$2|0); //@line 52614 "c/sqlite3.c"
}
function _bindText($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $magicptr = 0, $or$cond32 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = (_vdbeUnbind($0,$1)|0); //@line 79053 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 79054 "c/sqlite3.c"
 if (!($7)) {
  $magicptr = $4; //@line 79067 "c/sqlite3.c"
  switch ($magicptr|0) {
  case 0: case -1:  {
   $$2 = $6;
   return ($$2|0); //@line 79070 "c/sqlite3.c"
   break;
  }
  default: {
  }
  }
  FUNCTION_TABLE_vi[$4 & 127]($2); //@line 79068 "c/sqlite3.c"
  $$2 = $6;
  return ($$2|0); //@line 79070 "c/sqlite3.c"
 }
 $8 = ($2|0)==(0|0); //@line 79055 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
 } else {
  $9 = ((($0)) + 116|0); //@line 79056 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 79056 "c/sqlite3.c"
  $11 = (($1) + -1)|0; //@line 79056 "c/sqlite3.c"
  $12 = (($10) + (($11*40)|0)|0); //@line 79056 "c/sqlite3.c"
  $13 = (_sqlite3VdbeMemSetStr($12,$2,$3,$5,$4)|0); //@line 79057 "c/sqlite3.c"
  $14 = ($13|0)!=(0); //@line 79058 "c/sqlite3.c"
  $15 = ($5<<24>>24)==(0); //@line 79058 "c/sqlite3.c"
  $or$cond32 = $15 | $14; //@line 79058 "c/sqlite3.c"
  if ($or$cond32) {
   $$0 = $13;
  } else {
   $16 = HEAP32[$0>>2]|0; //@line 79059 "c/sqlite3.c"
   $17 = ((($16)) + 70|0); //@line 79059 "c/sqlite3.c"
   $18 = HEAP8[$17>>0]|0; //@line 79059 "c/sqlite3.c"
   $19 = $18&255; //@line 79059 "c/sqlite3.c"
   $20 = (_sqlite3VdbeChangeEncoding($12,$19)|0); //@line 79059 "c/sqlite3.c"
   $$0 = $20;
  }
  $21 = ($$0|0)==(0); //@line 79061 "c/sqlite3.c"
  if ($21) {
   $$1 = 0;
  } else {
   $22 = HEAP32[$0>>2]|0; //@line 79062 "c/sqlite3.c"
   _sqlite3Error($22,$$0); //@line 79062 "c/sqlite3.c"
   $23 = HEAP32[$0>>2]|0; //@line 79063 "c/sqlite3.c"
   $24 = (_sqlite3ApiExit($23,$$0)|0); //@line 79063 "c/sqlite3.c"
   $$1 = $24;
  }
 }
 $25 = HEAP32[$0>>2]|0; //@line 79066 "c/sqlite3.c"
 $26 = ((($25)) + 12|0); //@line 79066 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 79066 "c/sqlite3.c"
 _sqlite3_mutex_leave($27); //@line 79066 "c/sqlite3.c"
 $$2 = $$1;
 return ($$2|0); //@line 79070 "c/sqlite3.c"
}
function _sqlite3Checkpoint($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0$lcssa = 0, $$02333 = 0, $$024$lcssa = 0, $$02632 = 0, $$02831 = 0, $$034 = 0, $$1 = 0, $$125 = 0, $$127 = 0, $$129 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, $spec$select = 0, $spec$select30 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 20|0); //@line 145557 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 145557 "c/sqlite3.c"
 $7 = ($6|0)>(0); //@line 145557 "c/sqlite3.c"
 if (!($7)) {
  $$0$lcssa = 0;$$024$lcssa = 0;$$lcssa = 1;
  $21 = ($$0$lcssa|0)!=(0); //@line 145569 "c/sqlite3.c"
  $or$cond3 = $$lcssa & $21; //@line 145569 "c/sqlite3.c"
  $22 = $or$cond3 ? 5 : $$024$lcssa; //@line 145569 "c/sqlite3.c"
  return ($22|0); //@line 145569 "c/sqlite3.c"
 }
 $8 = ($1|0)==(10);
 $9 = ((($0)) + 16|0);
 $$02333 = 0;$$02632 = $4;$$02831 = $3;$$034 = 0;
 while(1) {
  $10 = ($$02333|0)==($1|0); //@line 145558 "c/sqlite3.c"
  $or$cond = $8 | $10; //@line 145558 "c/sqlite3.c"
  if ($or$cond) {
   $11 = HEAP32[$9>>2]|0; //@line 145559 "c/sqlite3.c"
   $12 = (((($11) + ($$02333<<4)|0)) + 4|0); //@line 145559 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 145559 "c/sqlite3.c"
   $14 = (_sqlite3BtreeCheckpoint($13,$2,$$02831,$$02632)|0); //@line 145559 "c/sqlite3.c"
   $15 = ($14|0)==(5); //@line 145562 "c/sqlite3.c"
   $spec$select = $15 ? 0 : $14; //@line 145562 "c/sqlite3.c"
   $spec$select30 = $15 ? 1 : $$034; //@line 145562 "c/sqlite3.c"
   $$1 = $spec$select30;$$125 = $spec$select;$$127 = 0;$$129 = 0;
  } else {
   $$1 = $$034;$$125 = 0;$$127 = $$02632;$$129 = $$02831;
  }
  $16 = (($$02333) + 1)|0; //@line 145557 "c/sqlite3.c"
  $17 = HEAP32[$5>>2]|0; //@line 145557 "c/sqlite3.c"
  $18 = ($16|0)<($17|0); //@line 145557 "c/sqlite3.c"
  $19 = ($$125|0)==(0); //@line 145557 "c/sqlite3.c"
  $20 = $19 & $18; //@line 145557 "c/sqlite3.c"
  if ($20) {
   $$02333 = $16;$$02632 = $$127;$$02831 = $$129;$$034 = $$1;
  } else {
   $$0$lcssa = $$1;$$024$lcssa = $$125;$$lcssa = $19;
   break;
  }
 }
 $21 = ($$0$lcssa|0)!=(0); //@line 145569 "c/sqlite3.c"
 $or$cond3 = $$lcssa & $21; //@line 145569 "c/sqlite3.c"
 $22 = $or$cond3 ? 5 : $$024$lcssa; //@line 145569 "c/sqlite3.c"
 return ($22|0); //@line 145569 "c/sqlite3.c"
}
function _sqlite3BtreeCheckpoint($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ($0|0)==(0|0); //@line 70145 "c/sqlite3.c"
 if ($4) {
  $$1 = 0;
  return ($$1|0); //@line 70155 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 70146 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 70146 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 70147 "c/sqlite3.c"
 $7 = ((($6)) + 20|0); //@line 70148 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 70148 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 70148 "c/sqlite3.c"
 if ($9) {
  $10 = HEAP32[$6>>2]|0; //@line 70151 "c/sqlite3.c"
  $11 = HEAP32[$0>>2]|0; //@line 70151 "c/sqlite3.c"
  $12 = (_sqlite3PagerCheckpoint($10,$11,$1,$2,$3)|0); //@line 70151 "c/sqlite3.c"
  $$0 = $12;
 } else {
  $$0 = 6;
 }
 _sqlite3BtreeLeave($0); //@line 70153 "c/sqlite3.c"
 $$1 = $$0;
 return ($$1|0); //@line 70155 "c/sqlite3.c"
}
function _sqlite3PagerCheckpoint($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 212|0); //@line 55369 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 55369 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 55369 "c/sqlite3.c"
 if ($7) {
  $$0 = 0;
  return ($$0|0); //@line 55377 "c/sqlite3.c"
 }
 $8 = ($2|0)==(0); //@line 55371 "c/sqlite3.c"
 if ($8) {
  $20 = 0;
 } else {
  $9 = ((($0)) + 176|0); //@line 55371 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 55371 "c/sqlite3.c"
  $20 = $10;
 }
 $11 = ((($0)) + 180|0); //@line 55372 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 55372 "c/sqlite3.c"
 $13 = ((($0)) + 11|0); //@line 55373 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 55373 "c/sqlite3.c"
 $15 = $14&255; //@line 55373 "c/sqlite3.c"
 $16 = ((($0)) + 152|0); //@line 55373 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 55373 "c/sqlite3.c"
 $18 = ((($0)) + 204|0); //@line 55373 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 55373 "c/sqlite3.c"
 $21 = (_sqlite3WalCheckpoint($6,$1,$2,$20,$12,$15,$17,$19,$3,$4)|0); //@line 55370 "c/sqlite3.c"
 $$0 = $21;
 return ($$0|0); //@line 55377 "c/sqlite3.c"
}
function _sqlite3PagerShrink($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 208|0); //@line 51518 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 51518 "c/sqlite3.c"
 _sqlite3PcacheShrink($2); //@line 51518 "c/sqlite3.c"
 return; //@line 51519 "c/sqlite3.c"
}
function _sqlite3PcacheShrink($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[(168)>>2]|0; //@line 46016 "c/sqlite3.c"
 $2 = ((($0)) + 44|0); //@line 46016 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 46016 "c/sqlite3.c"
 FUNCTION_TABLE_vi[$1 & 127]($3); //@line 46016 "c/sqlite3.c"
 return; //@line 46017 "c/sqlite3.c"
}
function _sqlite3DbNameToBtree($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0); //@line 147354 "c/sqlite3.c"
 if ($2) {
  $8 = 0;
 } else {
  $3 = (_sqlite3FindDbName($0,$1)|0); //@line 147354 "c/sqlite3.c"
  $4 = ($3|0)<(0); //@line 147355 "c/sqlite3.c"
  if ($4) {
   $10 = 0;
   return ($10|0); //@line 147355 "c/sqlite3.c"
  } else {
   $8 = $3;
  }
 }
 $5 = ((($0)) + 16|0); //@line 147355 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 147355 "c/sqlite3.c"
 $7 = (((($6) + ($8<<4)|0)) + 4|0); //@line 147355 "c/sqlite3.c"
 $9 = HEAP32[$7>>2]|0; //@line 147355 "c/sqlite3.c"
 $10 = $9;
 return ($10|0); //@line 147355 "c/sqlite3.c"
}
function _sqlite3Close($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 144420 "c/sqlite3.c"
 $2 = ($0|0)==(0|0); //@line 144421 "c/sqlite3.c"
 if ($2) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 144468 "c/sqlite3.c"
 }
 $3 = (_sqlite3SafetyCheckSickOrOk($0)|0); //@line 144426 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 144426 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3MisuseError(144427)|0); //@line 144427 "c/sqlite3.c"
  $$0 = $5;
  STACKTOP = sp;return ($$0|0); //@line 144468 "c/sqlite3.c"
 }
 $6 = ((($0)) + 12|0); //@line 144429 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 144429 "c/sqlite3.c"
 _sqlite3_mutex_enter($7); //@line 144429 "c/sqlite3.c"
 $8 = ((($0)) + 80|0); //@line 144430 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 144430 "c/sqlite3.c"
 $10 = $9 & 8; //@line 144430 "c/sqlite3.c"
 $11 = ($10<<24>>24)==(0); //@line 144430 "c/sqlite3.c"
 if (!($11)) {
  $12 = ((($0)) + 188|0); //@line 144431 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 144431 "c/sqlite3.c"
  $14 = ((($0)) + 192|0); //@line 144431 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 144431 "c/sqlite3.c"
  (FUNCTION_TABLE_iiiii[$13 & 127](8,$15,$0,0)|0); //@line 144431 "c/sqlite3.c"
 }
 _disconnectAllVtab($0); //@line 144435 "c/sqlite3.c"
 _sqlite3VtabRollback($0); //@line 144444 "c/sqlite3.c"
 $16 = ($1|0)==(0); //@line 144449 "c/sqlite3.c"
 if ($16) {
  $17 = (_connectionIsBusy($0)|0); //@line 144449 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 144449 "c/sqlite3.c"
  if (!($18)) {
   _sqlite3ErrorWithMsg($0,5,33534,$vararg_buffer); //@line 144450 "c/sqlite3.c"
   $19 = HEAP32[$6>>2]|0; //@line 144452 "c/sqlite3.c"
   _sqlite3_mutex_leave($19); //@line 144452 "c/sqlite3.c"
   $$0 = 5;
   STACKTOP = sp;return ($$0|0); //@line 144468 "c/sqlite3.c"
  }
 }
 $20 = ((($0)) + 88|0); //@line 144465 "c/sqlite3.c"
 HEAP32[$20>>2] = 1691352191; //@line 144465 "c/sqlite3.c"
 _sqlite3LeaveMutexAndCloseZombie($0); //@line 144466 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 144468 "c/sqlite3.c"
}
function _disconnectAllVtab($0) {
 $0 = $0|0;
 var $$032 = 0, $$03235 = 0, $$03236 = 0, $$039 = 0, $$1 = 0, $$133 = 0, $$134 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnterAll($0); //@line 144379 "c/sqlite3.c"
 $1 = ((($0)) + 20|0); //@line 144380 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144380 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 144380 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 16|0);
  $$039 = 0;
  while(1) {
   $5 = HEAP32[$4>>2]|0; //@line 144381 "c/sqlite3.c"
   $6 = (((($5) + ($$039<<4)|0)) + 12|0); //@line 144381 "c/sqlite3.c"
   $7 = HEAP32[$6>>2]|0; //@line 144381 "c/sqlite3.c"
   $8 = ($7|0)==(0|0); //@line 144382 "c/sqlite3.c"
   if (!($8)) {
    $9 = ((($7)) + 16|0); //@line 144383 "c/sqlite3.c"
    $$03235 = HEAP32[$9>>2]|0;
    $10 = ($$03235|0)==(0|0); //@line 144383 "c/sqlite3.c"
    if (!($10)) {
     $$03236 = $$03235;
     while(1) {
      $11 = ((($$03236)) + 8|0); //@line 144384 "c/sqlite3.c"
      $12 = HEAP32[$11>>2]|0; //@line 144384 "c/sqlite3.c"
      $13 = ((($12)) + 56|0); //@line 144385 "c/sqlite3.c"
      $14 = HEAP32[$13>>2]|0; //@line 144385 "c/sqlite3.c"
      $15 = ($14|0)==(0); //@line 144385 "c/sqlite3.c"
      if (!($15)) {
       _sqlite3VtabDisconnect($0,$12); //@line 144385 "c/sqlite3.c"
      }
      $$032 = HEAP32[$$03236>>2]|0;
      $16 = ($$032|0)==(0|0); //@line 144383 "c/sqlite3.c"
      if ($16) {
       break;
      } else {
       $$03236 = $$032;
      }
     }
    }
   }
   $17 = (($$039) + 1)|0; //@line 144380 "c/sqlite3.c"
   $18 = HEAP32[$1>>2]|0; //@line 144380 "c/sqlite3.c"
   $19 = ($17|0)<($18|0); //@line 144380 "c/sqlite3.c"
   if ($19) {
    $$039 = $17;
   } else {
    break;
   }
  }
 }
 $20 = ((($0)) + 336|0); //@line 144389 "c/sqlite3.c"
 $$133 = HEAP32[$20>>2]|0;
 $21 = ($$133|0)==(0|0); //@line 144389 "c/sqlite3.c"
 if ($21) {
  _sqlite3VtabUnlockList($0); //@line 144395 "c/sqlite3.c"
  _sqlite3BtreeLeaveAll($0); //@line 144396 "c/sqlite3.c"
  return; //@line 144400 "c/sqlite3.c"
 }
 $$134 = $$133;
 while(1) {
  $22 = ((($$134)) + 8|0); //@line 144390 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 144390 "c/sqlite3.c"
  $24 = ((($23)) + 16|0); //@line 144391 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 144391 "c/sqlite3.c"
  $26 = ($25|0)==(0|0); //@line 144391 "c/sqlite3.c"
  if (!($26)) {
   _sqlite3VtabDisconnect($0,$25); //@line 144392 "c/sqlite3.c"
  }
  $$1 = HEAP32[$$134>>2]|0;
  $27 = ($$1|0)==(0|0); //@line 144389 "c/sqlite3.c"
  if ($27) {
   break;
  } else {
   $$134 = $$1;
  }
 }
 _sqlite3VtabUnlockList($0); //@line 144395 "c/sqlite3.c"
 _sqlite3BtreeLeaveAll($0); //@line 144396 "c/sqlite3.c"
 return; //@line 144400 "c/sqlite3.c"
}
function _connectionIsBusy($0) {
 $0 = $0|0;
 var $$01314 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 144409 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144409 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 144409 "c/sqlite3.c"
 if (!($3)) {
  $$2 = 1;
  return ($$2|0); //@line 144415 "c/sqlite3.c"
 }
 $4 = ((($0)) + 20|0); //@line 144410 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 144410 "c/sqlite3.c"
 $6 = ($5|0)>(0); //@line 144410 "c/sqlite3.c"
 if (!($6)) {
  $$2 = 0;
  return ($$2|0); //@line 144415 "c/sqlite3.c"
 }
 $7 = ((($0)) + 16|0);
 $8 = HEAP32[$7>>2]|0;
 $$01314 = 0;
 while(1) {
  $9 = (((($8) + ($$01314<<4)|0)) + 4|0); //@line 144411 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 144411 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 144412 "c/sqlite3.c"
  if (!($11)) {
   $12 = (_sqlite3BtreeIsInBackup($10)|0); //@line 144412 "c/sqlite3.c"
   $13 = ($12|0)==(0); //@line 144412 "c/sqlite3.c"
   if (!($13)) {
    $$2 = 1;
    label = 7;
    break;
   }
  }
  $14 = (($$01314) + 1)|0; //@line 144410 "c/sqlite3.c"
  $15 = HEAP32[$4>>2]|0; //@line 144410 "c/sqlite3.c"
  $16 = ($14|0)<($15|0); //@line 144410 "c/sqlite3.c"
  if ($16) {
   $$01314 = $14;
  } else {
   $$2 = 0;
   label = 7;
   break;
  }
 }
 if ((label|0) == 7) {
  return ($$2|0); //@line 144415 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3LeaveMutexAndCloseZombie($0) {
 $0 = $0|0;
 var $$0 = 0, $$08299 = 0, $$084 = 0, $$094 = 0, $$095 = 0, $$1 = 0, $$189 = 0, $$190 = 0, $$2 = 0, $$286 = 0, $$287 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 88|0); //@line 144499 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 144499 "c/sqlite3.c"
 $3 = ($2|0)==(1691352191); //@line 144499 "c/sqlite3.c"
 if ($3) {
  $4 = (_connectionIsBusy($0)|0); //@line 144499 "c/sqlite3.c"
  $5 = ($4|0)==(0); //@line 144499 "c/sqlite3.c"
  if ($5) {
   _sqlite3RollbackAll($0,0); //@line 144514 "c/sqlite3.c"
   _sqlite3CloseSavepoints($0); //@line 144517 "c/sqlite3.c"
   $8 = ((($0)) + 20|0); //@line 144520 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 144520 "c/sqlite3.c"
   $10 = ($9|0)>(0); //@line 144520 "c/sqlite3.c"
   $11 = ((($0)) + 16|0);
   $12 = HEAP32[$11>>2]|0;
   if ($10) {
    $$08299 = 0;$14 = $12;
    while(1) {
     $13 = (((($14) + ($$08299<<4)|0)) + 4|0); //@line 144522 "c/sqlite3.c"
     $15 = HEAP32[$13>>2]|0; //@line 144522 "c/sqlite3.c"
     $16 = ($15|0)==(0|0); //@line 144522 "c/sqlite3.c"
     if (!($16)) {
      _sqlite3BtreeClose($15); //@line 144523 "c/sqlite3.c"
      HEAP32[$13>>2] = 0; //@line 144524 "c/sqlite3.c"
      $17 = ($$08299|0)==(1); //@line 144525 "c/sqlite3.c"
      if (!($17)) {
       $18 = (((($14) + ($$08299<<4)|0)) + 12|0); //@line 144526 "c/sqlite3.c"
       HEAP32[$18>>2] = 0; //@line 144526 "c/sqlite3.c"
      }
     }
     $19 = (($$08299) + 1)|0; //@line 144520 "c/sqlite3.c"
     $20 = HEAP32[$8>>2]|0; //@line 144520 "c/sqlite3.c"
     $21 = ($19|0)<($20|0); //@line 144520 "c/sqlite3.c"
     $22 = HEAP32[$11>>2]|0;
     if ($21) {
      $$08299 = $19;$14 = $22;
     } else {
      $$lcssa = $22;
      break;
     }
    }
   } else {
    $$lcssa = $12;
   }
   $23 = ((($$lcssa)) + 28|0); //@line 144531 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 144531 "c/sqlite3.c"
   $25 = ($24|0)==(0|0); //@line 144531 "c/sqlite3.c"
   if (!($25)) {
    _sqlite3SchemaClear($24); //@line 144532 "c/sqlite3.c"
   }
   _sqlite3VtabUnlockList($0); //@line 144534 "c/sqlite3.c"
   _sqlite3CollapseDatabaseArray($0); //@line 144537 "c/sqlite3.c"
   $26 = ((($0)) + 356|0); //@line 144546 "c/sqlite3.c"
   $27 = ((($0)) + 364|0); //@line 144546 "c/sqlite3.c"
   $$094 = HEAP32[$27>>2]|0;
   $28 = ($$094|0)==(0|0); //@line 144546 "c/sqlite3.c"
   if (!($28)) {
    $$095 = $$094;
    while(1) {
     $29 = ((($$095)) + 8|0); //@line 144548 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 144548 "c/sqlite3.c"
     $$084 = $30;
     while(1) {
      _functionDestroy($0,$$084); //@line 144550 "c/sqlite3.c"
      $31 = ((($$084)) + 8|0); //@line 144551 "c/sqlite3.c"
      $32 = HEAP32[$31>>2]|0; //@line 144551 "c/sqlite3.c"
      _sqlite3DbFree($0,$$084); //@line 144552 "c/sqlite3.c"
      $33 = ($32|0)==(0|0); //@line 144554 "c/sqlite3.c"
      if ($33) {
       break;
      } else {
       $$084 = $32;
      }
     }
     $$0 = HEAP32[$$095>>2]|0;
     $34 = ($$0|0)==(0|0); //@line 144546 "c/sqlite3.c"
     if ($34) {
      break;
     } else {
      $$095 = $$0;
     }
    }
   }
   _sqlite3HashClear($26); //@line 144556 "c/sqlite3.c"
   $35 = ((($0)) + 372|0); //@line 144557 "c/sqlite3.c"
   $36 = ((($0)) + 380|0); //@line 144557 "c/sqlite3.c"
   $$189 = HEAP32[$36>>2]|0;
   $37 = ($$189|0)==(0|0); //@line 144557 "c/sqlite3.c"
   if (!($37)) {
    $$190 = $$189;
    while(1) {
     $38 = ((($$190)) + 8|0); //@line 144558 "c/sqlite3.c"
     $39 = HEAP32[$38>>2]|0; //@line 144558 "c/sqlite3.c"
     $40 = ((($39)) + 16|0); //@line 144561 "c/sqlite3.c"
     $41 = HEAP32[$40>>2]|0; //@line 144561 "c/sqlite3.c"
     $42 = ($41|0)==(0|0); //@line 144561 "c/sqlite3.c"
     if (!($42)) {
      $43 = ((($39)) + 8|0); //@line 144562 "c/sqlite3.c"
      $44 = HEAP32[$43>>2]|0; //@line 144562 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$41 & 127]($44); //@line 144562 "c/sqlite3.c"
     }
     $45 = ((($39)) + 36|0); //@line 144561 "c/sqlite3.c"
     $46 = HEAP32[$45>>2]|0; //@line 144561 "c/sqlite3.c"
     $47 = ($46|0)==(0|0); //@line 144561 "c/sqlite3.c"
     if (!($47)) {
      $72 = ((($39)) + 28|0); //@line 144562 "c/sqlite3.c"
      $73 = HEAP32[$72>>2]|0; //@line 144562 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$46 & 127]($73); //@line 144562 "c/sqlite3.c"
     }
     $74 = ((($39)) + 56|0); //@line 144561 "c/sqlite3.c"
     $75 = HEAP32[$74>>2]|0; //@line 144561 "c/sqlite3.c"
     $76 = ($75|0)==(0|0); //@line 144561 "c/sqlite3.c"
     if (!($76)) {
      $77 = ((($39)) + 48|0); //@line 144562 "c/sqlite3.c"
      $78 = HEAP32[$77>>2]|0; //@line 144562 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$75 & 127]($78); //@line 144562 "c/sqlite3.c"
     }
     _sqlite3DbFree($0,$39); //@line 144565 "c/sqlite3.c"
     $$1 = HEAP32[$$190>>2]|0;
     $79 = ($$1|0)==(0|0); //@line 144557 "c/sqlite3.c"
     if ($79) {
      break;
     } else {
      $$190 = $$1;
     }
    }
   }
   _sqlite3HashClear($35); //@line 144567 "c/sqlite3.c"
   $48 = ((($0)) + 328|0); //@line 144569 "c/sqlite3.c"
   $49 = ((($0)) + 336|0); //@line 144569 "c/sqlite3.c"
   $$286 = HEAP32[$49>>2]|0;
   $50 = ($$286|0)==(0|0); //@line 144569 "c/sqlite3.c"
   if (!($50)) {
    $$287 = $$286;
    while(1) {
     $51 = ((($$287)) + 8|0); //@line 144570 "c/sqlite3.c"
     $52 = HEAP32[$51>>2]|0; //@line 144570 "c/sqlite3.c"
     $53 = ((($52)) + 12|0); //@line 144571 "c/sqlite3.c"
     $54 = HEAP32[$53>>2]|0; //@line 144571 "c/sqlite3.c"
     $55 = ($54|0)==(0|0); //@line 144571 "c/sqlite3.c"
     if (!($55)) {
      $56 = ((($52)) + 8|0); //@line 144572 "c/sqlite3.c"
      $57 = HEAP32[$56>>2]|0; //@line 144572 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$54 & 127]($57); //@line 144572 "c/sqlite3.c"
     }
     _sqlite3VtabEponymousTableClear($0,$52); //@line 144574 "c/sqlite3.c"
     _sqlite3DbFree($0,$52); //@line 144575 "c/sqlite3.c"
     $$2 = HEAP32[$$287>>2]|0;
     $58 = ($$2|0)==(0|0); //@line 144569 "c/sqlite3.c"
     if ($58) {
      break;
     } else {
      $$287 = $$2;
     }
    }
   }
   _sqlite3HashClear($48); //@line 144577 "c/sqlite3.c"
   _sqlite3Error($0,0); //@line 144580 "c/sqlite3.c"
   $59 = ((($0)) + 248|0); //@line 144581 "c/sqlite3.c"
   $60 = HEAP32[$59>>2]|0; //@line 144581 "c/sqlite3.c"
   _sqlite3ValueFree($60); //@line 144581 "c/sqlite3.c"
   _sqlite3CloseExtensions($0); //@line 144582 "c/sqlite3.c"
   HEAP32[$1>>2] = -1254786768; //@line 144588 "c/sqlite3.c"
   $61 = HEAP32[$11>>2]|0; //@line 144596 "c/sqlite3.c"
   $62 = ((($61)) + 28|0); //@line 144596 "c/sqlite3.c"
   $63 = HEAP32[$62>>2]|0; //@line 144596 "c/sqlite3.c"
   _sqlite3DbFree($0,$63); //@line 144596 "c/sqlite3.c"
   $64 = ((($0)) + 12|0); //@line 144597 "c/sqlite3.c"
   $65 = HEAP32[$64>>2]|0; //@line 144597 "c/sqlite3.c"
   _sqlite3_mutex_leave($65); //@line 144597 "c/sqlite3.c"
   HEAP32[$1>>2] = -1623446221; //@line 144598 "c/sqlite3.c"
   $66 = HEAP32[$64>>2]|0; //@line 144599 "c/sqlite3.c"
   _sqlite3_mutex_free($66); //@line 144599 "c/sqlite3.c"
   $67 = ((($0)) + 270|0); //@line 144601 "c/sqlite3.c"
   $68 = HEAP8[$67>>0]|0; //@line 144601 "c/sqlite3.c"
   $69 = ($68<<24>>24)==(0); //@line 144601 "c/sqlite3.c"
   if (!($69)) {
    $70 = ((($0)) + 296|0); //@line 144602 "c/sqlite3.c"
    $71 = HEAP32[$70>>2]|0; //@line 144602 "c/sqlite3.c"
    _sqlite3_free($71); //@line 144602 "c/sqlite3.c"
   }
   _sqlite3_free($0); //@line 144604 "c/sqlite3.c"
   return; //@line 144605 "c/sqlite3.c"
  }
 }
 $6 = ((($0)) + 12|0); //@line 144500 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 144500 "c/sqlite3.c"
 _sqlite3_mutex_leave($7); //@line 144500 "c/sqlite3.c"
 return; //@line 144605 "c/sqlite3.c"
}
function _sqlite3CloseExtensions($0) {
 $0 = $0|0;
 var $$07 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 180|0); //@line 114450 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 114450 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 114450 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 184|0);
  $$07 = 0;
  while(1) {
   $5 = HEAP32[$0>>2]|0; //@line 114451 "c/sqlite3.c"
   $6 = HEAP32[$4>>2]|0; //@line 114451 "c/sqlite3.c"
   $7 = (($6) + ($$07<<2)|0); //@line 114451 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 114451 "c/sqlite3.c"
   _sqlite3OsDlClose($5,$8); //@line 114451 "c/sqlite3.c"
   $9 = (($$07) + 1)|0; //@line 114450 "c/sqlite3.c"
   $10 = HEAP32[$1>>2]|0; //@line 114450 "c/sqlite3.c"
   $11 = ($9|0)<($10|0); //@line 114450 "c/sqlite3.c"
   if ($11) {
    $$07 = $9;
   } else {
    break;
   }
  }
 }
 $12 = ((($0)) + 184|0); //@line 114453 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 114453 "c/sqlite3.c"
 _sqlite3DbFree($0,$13); //@line 114453 "c/sqlite3.c"
 return; //@line 114454 "c/sqlite3.c"
}
function _sqlite3VtabDisconnect($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$015 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($1)) + 64|0); //@line 127585 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 127585 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 127585 "c/sqlite3.c"
 if ($4) {
  return; //@line 127593 "c/sqlite3.c"
 }
 $$015 = $2;$9 = $3;
 while(1) {
  $8 = HEAP32[$9>>2]|0; //@line 127586 "c/sqlite3.c"
  $10 = ($8|0)==($0|0); //@line 127586 "c/sqlite3.c"
  $6 = ((($9)) + 24|0);
  if ($10) {
   break;
  }
  $5 = HEAP32[$6>>2]|0; //@line 127585 "c/sqlite3.c"
  $7 = ($5|0)==(0|0); //@line 127585 "c/sqlite3.c"
  if ($7) {
   label = 6;
   break;
  } else {
   $$015 = $6;$9 = $5;
  }
 }
 if ((label|0) == 6) {
  return; //@line 127593 "c/sqlite3.c"
 }
 $11 = HEAP32[$6>>2]|0; //@line 127588 "c/sqlite3.c"
 HEAP32[$$015>>2] = $11; //@line 127588 "c/sqlite3.c"
 _sqlite3VtabUnlock($9); //@line 127589 "c/sqlite3.c"
 return; //@line 127593 "c/sqlite3.c"
}
function _blobSeekToRow($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$250 = 0, $$3 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer4 = sp + 16|0; //@line 87345 "c/sqlite3.c"
 $vararg_buffer1 = sp + 8|0; //@line 87345 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 87345 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 87348 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 87348 "c/sqlite3.c"
 $6 = ((($5)) + 92|0); //@line 87353 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 87353 "c/sqlite3.c"
 $8 = ((($7)) + 48|0); //@line 87353 "c/sqlite3.c"
 HEAP16[$8>>1] = 4; //@line 87353 "c/sqlite3.c"
 $9 = ((($7)) + 40|0); //@line 87354 "c/sqlite3.c"
 $10 = $9; //@line 87354 "c/sqlite3.c"
 $11 = $10; //@line 87354 "c/sqlite3.c"
 HEAP32[$11>>2] = $1; //@line 87354 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 87354 "c/sqlite3.c"
 $13 = $12; //@line 87354 "c/sqlite3.c"
 HEAP32[$13>>2] = $2; //@line 87354 "c/sqlite3.c"
 $14 = ((($5)) + 36|0); //@line 87360 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 87360 "c/sqlite3.c"
 $16 = ($15|0)>(4); //@line 87360 "c/sqlite3.c"
 if ($16) {
  HEAP32[$14>>2] = 4; //@line 87361 "c/sqlite3.c"
  $17 = (_sqlite3VdbeExec($5)|0); //@line 87363 "c/sqlite3.c"
  $$0 = $17;
 } else {
  $18 = HEAP32[$4>>2]|0; //@line 87365 "c/sqlite3.c"
  $19 = (_sqlite3_step($18)|0); //@line 87365 "c/sqlite3.c"
  $$0 = $19;
 }
 $20 = ($$0|0)==(100); //@line 87367 "c/sqlite3.c"
 if (!($20)) {
  $$pr = HEAP32[$4>>2]|0; //@line 87389 "c/sqlite3.c"
  $53 = ($$pr|0)==(0|0); //@line 87389 "c/sqlite3.c"
  if ($53) {
   $$250 = 0;$$3 = $$0;
   HEAP32[$3>>2] = $$250; //@line 87403 "c/sqlite3.c"
   STACKTOP = sp;return ($$3|0); //@line 87404 "c/sqlite3.c"
  }
  $54 = (_sqlite3_finalize($$pr)|0); //@line 87390 "c/sqlite3.c"
  HEAP32[$4>>2] = 0; //@line 87391 "c/sqlite3.c"
  $55 = ($54|0)==(0); //@line 87392 "c/sqlite3.c"
  $56 = ((($0)) + 20|0);
  $57 = HEAP32[$56>>2]|0;
  if ($55) {
   $58 = $vararg_buffer1; //@line 87393 "c/sqlite3.c"
   $59 = $58; //@line 87393 "c/sqlite3.c"
   HEAP32[$59>>2] = $1; //@line 87393 "c/sqlite3.c"
   $60 = (($58) + 4)|0; //@line 87393 "c/sqlite3.c"
   $61 = $60; //@line 87393 "c/sqlite3.c"
   HEAP32[$61>>2] = $2; //@line 87393 "c/sqlite3.c"
   $62 = (_sqlite3MPrintf($57,33636,$vararg_buffer1)|0); //@line 87393 "c/sqlite3.c"
   $$250 = $62;$$3 = 1;
   HEAP32[$3>>2] = $$250; //@line 87403 "c/sqlite3.c"
   STACKTOP = sp;return ($$3|0); //@line 87404 "c/sqlite3.c"
  } else {
   $63 = (_sqlite3_errmsg($57)|0); //@line 87396 "c/sqlite3.c"
   HEAP32[$vararg_buffer4>>2] = $63; //@line 87396 "c/sqlite3.c"
   $64 = (_sqlite3MPrintf($57,15687,$vararg_buffer4)|0); //@line 87396 "c/sqlite3.c"
   $$250 = $64;$$3 = $54;
   HEAP32[$3>>2] = $$250; //@line 87403 "c/sqlite3.c"
   STACKTOP = sp;return ($$3|0); //@line 87404 "c/sqlite3.c"
  }
 }
 $21 = ((($5)) + 112|0); //@line 87368 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 87368 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 87368 "c/sqlite3.c"
 $24 = ((($23)) + 58|0); //@line 87369 "c/sqlite3.c"
 $25 = HEAP16[$24>>1]|0; //@line 87369 "c/sqlite3.c"
 $26 = ((($0)) + 8|0); //@line 87369 "c/sqlite3.c"
 $27 = HEAP16[$26>>1]|0; //@line 87369 "c/sqlite3.c"
 $28 = ($25&65535)>($27&65535); //@line 87369 "c/sqlite3.c"
 L16: do {
  if ($28) {
   $31 = $27&65535; //@line 87369 "c/sqlite3.c"
   $32 = (((($23)) + 88|0) + ($31<<2)|0); //@line 87369 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 87369 "c/sqlite3.c"
   $34 = ($33>>>0)<(12); //@line 87372 "c/sqlite3.c"
   if ($34) {
    $35 = ((($0)) + 20|0); //@line 87373 "c/sqlite3.c"
    $36 = HEAP32[$35>>2]|0; //@line 87373 "c/sqlite3.c"
    switch ($33|0) {
    case 7:  {
     $37 = 17806;$38 = $36;
     break L16;
     break;
    }
    case 0:  {
     $65 = $36;
     label = 9;
     break L16;
     break;
    }
    default: {
    }
    }
    $37 = 17798;$38 = $36;
    break;
   } else {
    $41 = $27&65535; //@line 87380 "c/sqlite3.c"
    $42 = ((($23)) + 56|0); //@line 87380 "c/sqlite3.c"
    $43 = HEAP16[$42>>1]|0; //@line 87380 "c/sqlite3.c"
    $44 = $43 << 16 >> 16; //@line 87380 "c/sqlite3.c"
    $45 = (($44) + ($41))|0; //@line 87380 "c/sqlite3.c"
    $46 = (((($23)) + 88|0) + ($45<<2)|0); //@line 87380 "c/sqlite3.c"
    $47 = HEAP32[$46>>2]|0; //@line 87380 "c/sqlite3.c"
    $48 = ((($0)) + 4|0); //@line 87380 "c/sqlite3.c"
    HEAP32[$48>>2] = $47; //@line 87380 "c/sqlite3.c"
    $49 = (_sqlite3VdbeSerialTypeLen($33)|0); //@line 87381 "c/sqlite3.c"
    HEAP32[$0>>2] = $49; //@line 87381 "c/sqlite3.c"
    $50 = ((($23)) + 40|0); //@line 87382 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 87382 "c/sqlite3.c"
    $52 = ((($0)) + 12|0); //@line 87382 "c/sqlite3.c"
    HEAP32[$52>>2] = $51; //@line 87382 "c/sqlite3.c"
    _sqlite3BtreeIncrblobCursor($51); //@line 87383 "c/sqlite3.c"
    $$250 = 0;$$3 = 0;
    HEAP32[$3>>2] = $$250; //@line 87403 "c/sqlite3.c"
    STACKTOP = sp;return ($$3|0); //@line 87404 "c/sqlite3.c"
   }
  } else {
   $29 = ((($0)) + 20|0); //@line 87373 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 87373 "c/sqlite3.c"
   $65 = $30;
   label = 9;
  }
 } while(0);
 if ((label|0) == 9) {
  $37 = 17821;$38 = $65;
 }
 HEAP32[$vararg_buffer>>2] = $37; //@line 87373 "c/sqlite3.c"
 $39 = (_sqlite3MPrintf($38,33607,$vararg_buffer)|0); //@line 87373 "c/sqlite3.c"
 $40 = HEAP32[$4>>2]|0; //@line 87377 "c/sqlite3.c"
 (_sqlite3_finalize($40)|0); //@line 87377 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 87378 "c/sqlite3.c"
 $$250 = $39;$$3 = 1;
 HEAP32[$3>>2] = $$250; //@line 87403 "c/sqlite3.c"
 STACKTOP = sp;return ($$3|0); //@line 87404 "c/sqlite3.c"
}
function _sqlite3VdbeExec($0) {
 $0 = $0|0;
 var $$ = 0, $$02792 = 0, $$02793 = 0, $$02793$ = 0, $$028003839 = 0, $$02801 = 0, $$02814 = 0, $$028213778 = 0, $$028213778$in = 0, $$02822 = 0, $$02830 = 0, $$02835 = 0, $$02838 = 0, $$02839 = 0, $$02839$sink = 0, $$028433782 = 0, $$02844 = 0, $$028483781 = 0, $$028493844 = 0, $$02852 = 0;
 var $$029213843 = 0, $$02922 = 0, $$02923 = 0, $$029243776 = 0, $$02925 = 0, $$02928 = 0.0, $$029303786 = 0, $$02933 = 0, $$02934 = 0, $$029343093 = 0, $$0293430943256 = 0, $$02936 = 0, $$02939 = 0, $$029433835 = 0, $$02944 = 0, $$02945 = 0, $$02947 = 0, $$02948 = 0, $$02949 = 0, $$02951 = 0;
 var $$02952 = 0, $$02957 = 0, $$02962 = 0, $$02968 = 0, $$029723104 = 0, $$029733793 = 0, $$029733793$in = 0, $$02974 = 0, $$02975 = 0, $$02976 = 0, $$02977 = 0, $$02978 = 0, $$029783808 = 0, $$029783810 = 0, $$029793809 = 0, $$029813824 = 0, $$02983 = 0, $$029833796 = 0, $$029833797 = 0, $$02985 = 0;
 var $$029854312 = 0, $$029863800 = 0, $$02987 = 0, $$02988 = 0, $$02990 = 0, $$02991 = 0, $$02992 = 0, $$02993 = 0, $$02994 = 0, $$02999 = 0, $$030003803 = 0, $$03001 = 0, $$03002 = 0, $$03003 = 0, $$03004 = 0, $$03005 = 0, $$03006 = 0, $$03007 = 0, $$03008 = 0, $$03009 = 0;
 var $$03010 = 0, $$11 = 0, $$12 = 0, $$12794 = 0, $$12802 = 0, $$12831 = 0, $$12836 = 0, $$12845 = 0, $$12850 = 0, $$12937 = 0, $$12940 = 0, $$12950 = 0, $$12953 = 0, $$12959 = 0, $$12963 = 0, $$12969 = 0, $$12980 = 0, $$129823828 = 0, $$12984 = 0, $$12995 = 0;
 var $$12997 = 0, $$14$ph3100 = 0, $$16 = 0, $$17$lcssa = 0, $$19 = 0, $$22803 = 0, $$22816$ph = 0, $$22832 = 0, $$22837 = 0, $$22846 = 0, $$22851 = 0, $$22938 = 0, $$229383091 = 0, $$2293830923257 = 0, $$2293830923261 = 0, $$22941 = 0, $$22954 = 0, $$22960 = 0, $$229603218 = 0, $$22964 = 0;
 var $$26 = 0, $$27 = 0, $$28 = 0, $$3 = 0, $$30$ph = 0, $$30$ph$ph = 0, $$3018 = 0, $$3031 = 0, $$3048 = 0, $$31 = 0, $$32804 = 0, $$32817 = 0, $$32833 = 0, $$32842 = 0, $$32942 = 0, $$329423089 = 0, $$329423090$ph = 0, $$3294230903258 = 0, $$3294230903262 = 0, $$34 = 0;
 var $$35 = 0, $$4 = 0, $$40$ph = 0, $$40$ph3160 = 0, $$42 = 0, $$42797$ph = 0, $$42818 = 0, $$42834 = 0, $$43 = 0, $$44 = 0, $$45$ph = 0, $$47 = 0, $$48 = 0, $$48$ph = 0, $$5 = 0, $$50 = 0, $$51 = 0, $$52 = 0, $$52819 = 0, $$55$ph = 0;
 var $$57 = 0, $$58 = 0, $$6 = 0, $$62807 = 0, $$62820 = 0, $$64 = 0, $$65 = 0, $$70 = 0, $$72808 = 0, $$72829 = 0, $$75 = 0, $$76$ph = 0, $$8 = 0, $$83$ph = 0, $$84 = 0, $$85 = 0, $$87 = 0, $$88 = 0, $$9 = 0, $$90 = 0;
 var $$pn3269 = 0, $$pr = 0, $$pr4311 = 0, $$pr4315 = 0, $$sink5212 = 0, $1 = 0, $10 = 0, $100 = 0, $1000 = 0, $1001 = 0, $1002 = 0, $1003 = 0, $1004 = 0, $1005 = 0, $1006 = 0, $1007 = 0, $1008 = 0, $1009 = 0, $101 = 0, $1010 = 0;
 var $1011 = 0, $1012 = 0, $1013 = 0, $1014 = 0, $1015 = 0, $1016 = 0, $1017 = 0, $1018 = 0, $1019 = 0, $102 = 0, $1020 = 0, $1021 = 0, $1022 = 0, $1023 = 0, $1024 = 0, $1025 = 0, $1026 = 0, $1027 = 0, $1028 = 0, $1029 = 0;
 var $103 = 0, $1030 = 0, $1031 = 0, $1032 = 0, $1033 = 0, $1034 = 0, $1035 = 0, $1036 = 0, $1037 = 0, $1038 = 0, $1039 = 0, $104 = 0, $1040 = 0, $1041 = 0, $1042 = 0, $1043 = 0, $1044 = 0, $1045 = 0, $1046 = 0, $1047 = 0;
 var $1048 = 0, $1049 = 0, $105 = 0, $1050 = 0, $1051 = 0, $1052 = 0, $1053 = 0, $1054 = 0, $1055 = 0, $1056 = 0, $1057 = 0, $1058 = 0, $1059 = 0, $106 = 0, $1060 = 0, $1061 = 0, $1062 = 0, $1063 = 0, $1064 = 0, $1065 = 0;
 var $1066 = 0, $1067 = 0, $1068 = 0, $1069 = 0, $107 = 0, $1070 = 0, $1071 = 0, $1072 = 0, $1073 = 0, $1074 = 0, $1075 = 0, $1076 = 0, $1077 = 0, $1078 = 0, $1079 = 0, $108 = 0, $1080 = 0, $1081 = 0, $1082 = 0, $1083 = 0;
 var $1084 = 0, $1085 = 0, $1086 = 0, $1087 = 0, $1088 = 0, $1089 = 0, $109 = 0, $1090 = 0, $1091 = 0, $1092 = 0, $1093 = 0, $1094 = 0, $1095 = 0, $1096 = 0, $1097 = 0, $1098 = 0, $1099 = 0, $11 = 0, $110 = 0, $1100 = 0;
 var $1101 = 0, $1102 = 0, $1103 = 0, $1104 = 0, $1105 = 0, $1106 = 0, $1107 = 0, $1108 = 0, $1109 = 0, $111 = 0, $1110 = 0, $1111 = 0, $1112 = 0, $1113 = 0, $1114 = 0, $1115 = 0, $1116 = 0, $1117 = 0, $1118 = 0, $1119 = 0;
 var $112 = 0, $1120 = 0, $1121 = 0, $1122 = 0, $1123 = 0, $1124 = 0, $1125 = 0, $1126 = 0, $1127 = 0, $1128 = 0, $1129 = 0, $113 = 0, $1130 = 0, $1131 = 0, $1132 = 0, $1133 = 0, $1134 = 0, $1135 = 0, $1136 = 0, $1137 = 0;
 var $1138 = 0, $1139 = 0, $114 = 0, $1140 = 0, $1141 = 0, $1142 = 0, $1143 = 0, $1144 = 0, $1145 = 0, $1146 = 0, $1147 = 0, $1148 = 0, $1149 = 0, $115 = 0, $1150 = 0, $1151 = 0, $1152 = 0, $1153 = 0, $1154 = 0, $1155 = 0;
 var $1156 = 0, $1157 = 0, $1158 = 0, $1159 = 0, $116 = 0, $1160 = 0, $1161 = 0, $1162 = 0, $1163 = 0, $1164 = 0, $1165 = 0, $1166 = 0, $1167 = 0, $1168 = 0, $1169 = 0, $117 = 0, $1170 = 0, $1171 = 0, $1172 = 0, $1173 = 0;
 var $1174 = 0, $1175 = 0, $1176 = 0, $1177 = 0, $1178 = 0, $1179 = 0, $118 = 0, $1180 = 0, $1181 = 0, $1182 = 0, $1183 = 0, $1184 = 0, $1185 = 0, $1186 = 0, $1187 = 0, $1188 = 0, $1189 = 0, $119 = 0, $1190 = 0, $1191 = 0;
 var $1192 = 0, $1193 = 0, $1194 = 0, $1195 = 0, $1196 = 0, $1197 = 0, $1198 = 0, $1199 = 0, $12 = 0, $120 = 0, $1200 = 0, $1201 = 0, $1202 = 0, $1203 = 0, $1204 = 0, $1205 = 0, $1206 = 0, $1207 = 0, $1208 = 0, $1209 = 0;
 var $121 = 0, $1210 = 0, $1211 = 0, $1212 = 0, $1213 = 0, $1214 = 0, $1215 = 0, $1216 = 0, $1217 = 0, $1218 = 0, $1219 = 0, $122 = 0, $1220 = 0, $1221 = 0, $1222 = 0, $1223 = 0, $1224 = 0, $1225 = 0, $1226 = 0, $1227 = 0;
 var $1228 = 0, $1229 = 0, $123 = 0, $1230 = 0, $1231 = 0, $1232 = 0, $1233 = 0, $1234 = 0, $1235 = 0, $1236 = 0, $1237 = 0, $1238 = 0, $1239 = 0, $124 = 0, $1240 = 0, $1241 = 0, $1242 = 0, $1243 = 0, $1244 = 0, $1245 = 0;
 var $1246 = 0, $1247 = 0, $1248 = 0, $1249 = 0, $125 = 0, $1250 = 0, $1251 = 0, $1252 = 0, $1253 = 0, $1254 = 0, $1255 = 0, $1256 = 0, $1257 = 0, $1258 = 0, $1259 = 0, $126 = 0, $1260 = 0, $1261 = 0, $1262 = 0, $1263 = 0;
 var $1264 = 0, $1265 = 0, $1266 = 0, $1267 = 0, $1268 = 0, $1269 = 0.0, $127 = 0, $1270 = 0, $1271 = 0, $1272 = 0, $1273 = 0, $1274 = 0, $1275 = 0, $1276 = 0, $1277 = 0, $1278 = 0, $1279 = 0, $128 = 0, $1280 = 0, $1281 = 0;
 var $1282 = 0, $1283 = 0, $1284 = 0, $1285 = 0, $1286 = 0, $1287 = 0, $1288 = 0, $1289 = 0, $129 = 0, $1290 = 0, $1291 = 0, $1292 = 0, $1293 = 0, $1294 = 0, $1295 = 0, $1296 = 0, $1297 = 0, $1298 = 0, $1299 = 0, $13 = 0;
 var $130 = 0, $1300 = 0, $1301 = 0, $1302 = 0, $1303 = 0, $1304 = 0, $1305 = 0, $1306 = 0, $1307 = 0, $1308 = 0, $1309 = 0, $131 = 0, $1310 = 0, $1311 = 0, $1312 = 0, $1313 = 0, $1314 = 0, $1315 = 0, $1316 = 0, $1317 = 0;
 var $1318 = 0, $1319 = 0, $132 = 0, $1320 = 0, $1321 = 0, $1322 = 0, $1323 = 0, $1324 = 0, $1325 = 0, $1326 = 0, $1327 = 0, $1328 = 0, $1329 = 0, $133 = 0, $1330 = 0, $1331 = 0, $1332 = 0, $1333 = 0, $1334 = 0, $1335 = 0;
 var $1336 = 0, $1337 = 0, $1338 = 0, $1339 = 0, $134 = 0, $1340 = 0, $1341 = 0, $1342 = 0, $1343 = 0, $1344 = 0, $1345 = 0, $1346 = 0, $1347 = 0, $1348 = 0, $1349 = 0, $135 = 0, $1350 = 0, $1351 = 0, $1352 = 0, $1353 = 0;
 var $1354 = 0, $1355 = 0, $1356 = 0, $1357 = 0, $1358 = 0, $1359 = 0, $136 = 0, $1360 = 0, $1361 = 0, $1362 = 0, $1363 = 0, $1364 = 0, $1365 = 0, $1366 = 0, $1367 = 0, $1368 = 0, $1369 = 0, $137 = 0, $1370 = 0, $1371 = 0;
 var $1372 = 0, $1373 = 0, $1374 = 0, $1375 = 0, $1376 = 0, $1377 = 0, $1378 = 0, $1379 = 0, $138 = 0, $1380 = 0, $1381 = 0, $1382 = 0, $1383 = 0, $1384 = 0, $1385 = 0, $1386 = 0, $1387 = 0, $1388 = 0, $1389 = 0, $139 = 0;
 var $1390 = 0, $1391 = 0, $1392 = 0, $1393 = 0, $1394 = 0, $1395 = 0, $1396 = 0, $1397 = 0, $1398 = 0, $1399 = 0, $14 = 0, $140 = 0, $1400 = 0, $1401 = 0, $1402 = 0, $1403 = 0, $1404 = 0, $1405 = 0, $1406 = 0, $1407 = 0;
 var $1408 = 0, $1409 = 0, $141 = 0, $1410 = 0, $1411 = 0, $1412 = 0, $1413 = 0, $1414 = 0, $1415 = 0, $1416 = 0, $1417 = 0, $1418 = 0, $1419 = 0, $142 = 0, $1420 = 0, $1421 = 0, $1422 = 0, $1423 = 0, $1424 = 0, $1425 = 0;
 var $1426 = 0, $1427 = 0, $1428 = 0, $1429 = 0, $143 = 0, $1430 = 0, $1431 = 0, $1432 = 0, $1433 = 0, $1434 = 0, $1435 = 0, $1436 = 0, $1437 = 0, $1438 = 0, $1439 = 0, $144 = 0, $1440 = 0, $1441 = 0, $1442 = 0, $1443 = 0;
 var $1444 = 0, $1445 = 0, $1446 = 0, $1447 = 0, $1448 = 0, $1449 = 0, $145 = 0, $1450 = 0, $1451 = 0, $1452 = 0, $1453 = 0, $1454 = 0, $1455 = 0, $1456 = 0, $1457 = 0, $1458 = 0, $1459 = 0, $146 = 0, $1460 = 0, $1461 = 0;
 var $1462 = 0, $1463 = 0, $1464 = 0, $1465 = 0, $1466 = 0, $1467 = 0, $1468 = 0, $1469 = 0, $147 = 0, $1470 = 0, $1471 = 0, $1472 = 0, $1473 = 0, $1474 = 0, $1475 = 0, $1476 = 0, $1477 = 0, $1478 = 0, $1479 = 0, $148 = 0;
 var $1480 = 0, $1481 = 0, $1482 = 0, $1483 = 0, $1484 = 0, $1485 = 0, $1486 = 0, $1487 = 0, $1488 = 0, $1489 = 0, $149 = 0, $1490 = 0, $1491 = 0, $1492 = 0, $1493 = 0, $1494 = 0, $1495 = 0, $1496 = 0, $1497 = 0, $1498 = 0;
 var $1499 = 0, $15 = 0, $150 = 0, $1500 = 0, $1501 = 0, $1502 = 0, $1503 = 0, $1504 = 0, $1505 = 0, $1506 = 0, $1507 = 0, $1508 = 0, $1509 = 0, $151 = 0, $1510 = 0, $1511 = 0, $1512 = 0, $1513 = 0, $1514 = 0, $1515 = 0;
 var $1516 = 0, $1517 = 0, $1518 = 0, $1519 = 0, $152 = 0, $1520 = 0, $1521 = 0, $1522 = 0, $1523 = 0, $1524 = 0, $1525 = 0, $1526 = 0, $1527 = 0, $1528 = 0, $1529 = 0, $153 = 0, $1530 = 0, $1531 = 0, $1532 = 0, $1533 = 0;
 var $1534 = 0, $1535 = 0, $1536 = 0, $1537 = 0, $1538 = 0, $1539 = 0, $154 = 0, $1540 = 0, $1541 = 0, $1542 = 0, $1543 = 0, $1544 = 0, $1545 = 0, $1546 = 0, $1547 = 0, $1548 = 0, $1549 = 0, $155 = 0, $1550 = 0, $1551 = 0;
 var $1552 = 0, $1553 = 0, $1554 = 0, $1555 = 0, $1556 = 0, $1557 = 0, $1558 = 0, $1559 = 0, $156 = 0, $1560 = 0, $1561 = 0, $1562 = 0, $1563 = 0, $1564 = 0, $1565 = 0, $1566 = 0, $1567 = 0, $1568 = 0, $1569 = 0, $157 = 0;
 var $1570 = 0, $1571 = 0, $1572 = 0, $1573 = 0, $1574 = 0, $1575 = 0, $1576 = 0, $1577 = 0, $1578 = 0, $1579 = 0, $158 = 0, $1580 = 0, $1581 = 0, $1582 = 0, $1583 = 0, $1584 = 0, $1585 = 0, $1586 = 0, $1587 = 0, $1588 = 0;
 var $1589 = 0, $159 = 0, $1590 = 0, $1591 = 0, $1592 = 0, $1593 = 0, $1594 = 0, $1595 = 0, $1596 = 0, $1597 = 0, $1598 = 0, $1599 = 0, $16 = 0, $160 = 0, $1600 = 0, $1601 = 0, $1602 = 0, $1603 = 0, $1604 = 0, $1605 = 0;
 var $1606 = 0, $1607 = 0, $1608 = 0, $1609 = 0, $161 = 0, $1610 = 0, $1611 = 0, $1612 = 0, $1613 = 0, $1614 = 0, $1615 = 0, $1616 = 0, $1617 = 0, $1618 = 0, $1619 = 0, $162 = 0, $1620 = 0, $1621 = 0, $1622 = 0, $1623 = 0;
 var $1624 = 0, $1625 = 0, $1626 = 0, $1627 = 0, $1628 = 0, $1629 = 0, $163 = 0, $1630 = 0, $1631 = 0, $1632 = 0, $1633 = 0, $1634 = 0, $1635 = 0, $1636 = 0, $1637 = 0, $1638 = 0, $1639 = 0, $164 = 0, $1640 = 0, $1641 = 0;
 var $1642 = 0, $1643 = 0, $1644 = 0, $1645 = 0, $1646 = 0, $1647 = 0, $1648 = 0, $1649 = 0, $165 = 0, $1650 = 0, $1651 = 0, $1652 = 0, $1653 = 0, $1654 = 0, $1655 = 0, $1656 = 0, $1657 = 0, $1658 = 0, $1659 = 0, $166 = 0;
 var $1660 = 0, $1661 = 0, $1662 = 0, $1663 = 0, $1664 = 0, $1665 = 0, $1666 = 0, $1667 = 0, $1668 = 0, $1669 = 0, $167 = 0, $1670 = 0, $1671 = 0, $1672 = 0, $1673 = 0, $1674 = 0, $1675 = 0, $1676 = 0, $1677 = 0, $1678 = 0;
 var $1679 = 0, $168 = 0, $1680 = 0, $1681 = 0, $1682 = 0, $1683 = 0, $1684 = 0, $1685 = 0, $1686 = 0, $1687 = 0, $1688 = 0, $1689 = 0, $169 = 0, $1690 = 0, $1691 = 0, $1692 = 0, $1693 = 0, $1694 = 0, $1695 = 0, $1696 = 0;
 var $1697 = 0, $1698 = 0, $1699 = 0, $17 = 0, $170 = 0, $1700 = 0, $1701 = 0, $1702 = 0, $1703 = 0, $1704 = 0, $1705 = 0, $1706 = 0, $1707 = 0, $1708 = 0, $1709 = 0, $171 = 0, $1710 = 0, $1711 = 0, $1712 = 0, $1713 = 0;
 var $1714 = 0, $1715 = 0, $1716 = 0, $1717 = 0, $1718 = 0, $1719 = 0, $172 = 0, $1720 = 0, $1721 = 0, $1722 = 0, $1723 = 0, $1724 = 0, $1725 = 0, $1726 = 0, $1727 = 0, $1728 = 0, $1729 = 0, $173 = 0, $1730 = 0, $1731 = 0;
 var $1732 = 0, $1733 = 0, $1734 = 0, $1735 = 0, $1736 = 0, $1737 = 0, $1738 = 0, $1739 = 0, $174 = 0, $1740 = 0, $1741 = 0, $1742 = 0, $1743 = 0, $1744 = 0, $1745 = 0, $1746 = 0, $1747 = 0, $1748 = 0, $1749 = 0, $175 = 0;
 var $1750 = 0, $1751 = 0, $1752 = 0, $1753 = 0, $1754 = 0, $1755 = 0, $1756 = 0, $1757 = 0, $1758 = 0, $1759 = 0, $176 = 0, $1760 = 0, $1761 = 0, $1762 = 0, $1763 = 0, $1764 = 0, $1765 = 0, $1766 = 0, $1767 = 0, $1768 = 0;
 var $1769 = 0, $177 = 0, $1770 = 0, $1771 = 0, $1772 = 0, $1773 = 0, $1774 = 0, $1775 = 0, $1776 = 0, $1777 = 0, $1778 = 0, $1779 = 0, $178 = 0, $1780 = 0, $1781 = 0, $1782 = 0, $1783 = 0, $1784 = 0, $1785 = 0, $1786 = 0;
 var $1787 = 0, $1788 = 0, $1789 = 0, $179 = 0, $1790 = 0, $1791 = 0, $1792 = 0, $1793 = 0, $1794 = 0, $1795 = 0, $1796 = 0, $1797 = 0, $1798 = 0, $1799 = 0, $18 = 0, $180 = 0, $1800 = 0, $1801 = 0, $1802 = 0, $1803 = 0;
 var $1804 = 0, $1805 = 0, $1806 = 0, $1807 = 0, $1808 = 0, $1809 = 0, $181 = 0, $1810 = 0, $1811 = 0, $1812 = 0, $1813 = 0, $1814 = 0, $1815 = 0, $1816 = 0, $1817 = 0, $1818 = 0, $1819 = 0, $182 = 0, $1820 = 0, $1821 = 0;
 var $1822 = 0, $1823 = 0, $1824 = 0, $1825 = 0, $1826 = 0, $1827 = 0, $1828 = 0, $1829 = 0, $183 = 0, $1830 = 0, $1831 = 0, $1832 = 0, $1833 = 0, $1834 = 0, $1835 = 0, $1836 = 0, $1837 = 0, $1838 = 0, $1839 = 0, $184 = 0;
 var $1840 = 0, $1841 = 0, $1842 = 0, $1843 = 0, $1844 = 0, $1845 = 0, $1846 = 0, $1847 = 0, $1848 = 0, $1849 = 0, $185 = 0, $1850 = 0, $1851 = 0, $1852 = 0, $1853 = 0, $1854 = 0, $1855 = 0, $1856 = 0, $1857 = 0, $1858 = 0;
 var $1859 = 0, $186 = 0, $1860 = 0, $1861 = 0, $1862 = 0, $1863 = 0, $1864 = 0, $1865 = 0, $1866 = 0, $1867 = 0, $1868 = 0, $1869 = 0, $187 = 0, $1870 = 0, $1871 = 0, $1872 = 0, $1873 = 0, $1874 = 0, $1875 = 0, $1876 = 0;
 var $1877 = 0, $1878 = 0, $1879 = 0, $188 = 0, $1880 = 0, $1881 = 0, $1882 = 0, $1883 = 0, $1884 = 0, $1885 = 0, $1886 = 0, $1887 = 0, $1888 = 0, $1889 = 0, $189 = 0, $1890 = 0, $1891 = 0, $1892 = 0, $1893 = 0, $1894 = 0;
 var $1895 = 0, $1896 = 0, $1897 = 0, $1898 = 0, $1899 = 0, $19 = 0, $190 = 0, $1900 = 0, $1901 = 0, $1902 = 0, $1903 = 0, $1904 = 0, $1905 = 0, $1906 = 0, $1907 = 0, $1908 = 0, $1909 = 0, $191 = 0, $1910 = 0, $1911 = 0;
 var $1912 = 0, $1913 = 0, $1914 = 0, $1915 = 0, $1916 = 0, $1917 = 0, $1918 = 0, $1919 = 0, $192 = 0, $1920 = 0, $1921 = 0, $1922 = 0, $1923 = 0, $1924 = 0, $1925 = 0, $1926 = 0, $1927 = 0, $1928 = 0, $1929 = 0, $193 = 0;
 var $1930 = 0, $1931 = 0, $1932 = 0, $1933 = 0, $1934 = 0, $1935 = 0, $1936 = 0, $1937 = 0, $1938 = 0, $1939 = 0, $194 = 0, $1940 = 0, $1941 = 0, $1942 = 0, $1943 = 0, $1944 = 0, $1945 = 0, $1946 = 0, $1947 = 0, $1948 = 0;
 var $1949 = 0, $195 = 0, $1950 = 0, $1951 = 0, $1952 = 0, $1953 = 0, $1954 = 0, $1955 = 0, $1956 = 0, $1957 = 0, $1958 = 0, $1959 = 0, $196 = 0, $1960 = 0, $1961 = 0, $1962 = 0, $1963 = 0, $1964 = 0, $1965 = 0, $1966 = 0;
 var $1967 = 0, $1968 = 0, $1969 = 0, $197 = 0, $1970 = 0, $1971 = 0, $1972 = 0, $1973 = 0, $1974 = 0, $1975 = 0, $1976 = 0, $1977 = 0, $1978 = 0, $1979 = 0, $198 = 0, $1980 = 0, $1981 = 0, $1982 = 0, $1983 = 0, $1984 = 0;
 var $1985 = 0, $1986 = 0, $1987 = 0, $1988 = 0, $1989 = 0, $199 = 0, $1990 = 0, $1991 = 0, $1992 = 0, $1993 = 0, $1994 = 0, $1995 = 0, $1996 = 0, $1997 = 0, $1998 = 0, $1999 = 0, $2 = 0, $20 = 0, $200 = 0, $2000 = 0;
 var $2001 = 0, $2002 = 0, $2003 = 0, $2004 = 0, $2005 = 0, $2006 = 0, $2007 = 0, $2008 = 0, $2009 = 0, $201 = 0, $2010 = 0, $2011 = 0, $2012 = 0, $2013 = 0, $2014 = 0, $2015 = 0, $2016 = 0, $2017 = 0, $2018 = 0, $2019 = 0;
 var $202 = 0, $2020 = 0, $2021 = 0, $2022 = 0, $2023 = 0, $2024 = 0, $2025 = 0, $2026 = 0, $2027 = 0, $2028 = 0, $2029 = 0, $203 = 0, $2030 = 0, $2031 = 0, $2032 = 0, $2033 = 0, $2034 = 0, $2035 = 0, $2036 = 0, $2037 = 0;
 var $2038 = 0, $2039 = 0, $204 = 0, $2040 = 0, $2041 = 0, $2042 = 0, $2043 = 0, $2044 = 0, $2045 = 0, $2046 = 0, $2047 = 0, $2048 = 0, $2049 = 0, $205 = 0, $2050 = 0, $2051 = 0, $2052 = 0, $2053 = 0, $2054 = 0, $2055 = 0;
 var $2056 = 0, $2057 = 0, $2058 = 0, $2059 = 0, $206 = 0, $2060 = 0, $2061 = 0, $2062 = 0, $2063 = 0, $2064 = 0, $2065 = 0, $2066 = 0, $2067 = 0, $2068 = 0, $2069 = 0, $207 = 0, $2070 = 0, $2071 = 0, $2072 = 0, $2073 = 0;
 var $2074 = 0, $2075 = 0, $2076 = 0, $2077 = 0, $2078 = 0, $2079 = 0, $208 = 0, $2080 = 0, $2081 = 0, $2082 = 0, $2083 = 0, $2084 = 0, $2085 = 0, $2086 = 0, $2087 = 0, $2088 = 0, $2089 = 0, $209 = 0, $2090 = 0, $2091 = 0;
 var $2092 = 0, $2093 = 0, $2094 = 0, $2095 = 0, $2096 = 0, $2097 = 0, $2098 = 0, $2099 = 0, $21 = 0, $210 = 0, $2100 = 0, $2101 = 0, $2102 = 0, $2103 = 0, $2104 = 0, $2105 = 0, $2106 = 0, $2107 = 0, $2108 = 0, $2109 = 0;
 var $211 = 0, $2110 = 0, $2111 = 0, $2112 = 0, $2113 = 0, $2114 = 0, $2115 = 0, $2116 = 0, $2117 = 0, $2118 = 0, $2119 = 0, $212 = 0, $2120 = 0, $2121 = 0, $2122 = 0, $2123 = 0, $2124 = 0, $2125 = 0, $2126 = 0, $2127 = 0;
 var $2128 = 0, $2129 = 0, $213 = 0, $2130 = 0, $2131 = 0, $2132 = 0, $2133 = 0, $2134 = 0, $2135 = 0, $2136 = 0, $2137 = 0, $2138 = 0, $2139 = 0, $214 = 0, $2140 = 0, $2141 = 0, $2142 = 0, $2143 = 0, $2144 = 0, $2145 = 0;
 var $2146 = 0, $2147 = 0, $2148 = 0, $2149 = 0, $215 = 0, $2150 = 0, $2151 = 0, $2152 = 0, $2153 = 0, $2154 = 0, $2155 = 0, $2156 = 0, $2157 = 0, $2158 = 0, $2159 = 0, $216 = 0, $2160 = 0, $2161 = 0, $2162 = 0, $2163 = 0;
 var $2164 = 0, $2165 = 0, $2166 = 0, $2167 = 0, $2168 = 0, $2169 = 0, $217 = 0, $2170 = 0, $2171 = 0, $2172 = 0, $2173 = 0, $2174 = 0, $2175 = 0, $2176 = 0, $2177 = 0, $2178 = 0, $2179 = 0, $218 = 0, $2180 = 0, $2181 = 0;
 var $2182 = 0, $2183 = 0, $2184 = 0, $2185 = 0, $2186 = 0, $2187 = 0, $2188 = 0, $2189 = 0, $219 = 0, $2190 = 0, $2191 = 0, $2192 = 0, $2193 = 0, $2194 = 0, $2195 = 0, $2196 = 0, $2197 = 0, $2198 = 0, $2199 = 0, $22 = 0;
 var $220 = 0, $2200 = 0, $2201 = 0, $2202 = 0, $2203 = 0, $2204 = 0, $2205 = 0, $2206 = 0, $2207 = 0, $2208 = 0, $2209 = 0, $221 = 0, $2210 = 0, $2211 = 0, $2212 = 0, $2213 = 0, $2214 = 0, $2215 = 0, $2216 = 0, $2217 = 0;
 var $2218 = 0.0, $2219 = 0.0, $222 = 0, $2220 = 0, $2221 = 0, $2222 = 0, $2223 = 0, $2224 = 0, $2225 = 0, $2226 = 0, $2227 = 0, $2228 = 0, $2229 = 0, $223 = 0, $2230 = 0, $2231 = 0, $2232 = 0, $2233 = 0, $2234 = 0, $2235 = 0;
 var $2236 = 0, $2237 = 0, $2238 = 0, $2239 = 0, $224 = 0, $2240 = 0, $2241 = 0, $2242 = 0, $2243 = 0, $2244 = 0, $2245 = 0, $2246 = 0, $2247 = 0, $2248 = 0, $2249 = 0, $225 = 0, $2250 = 0, $2251 = 0, $2252 = 0, $2253 = 0;
 var $2254 = 0, $2255 = 0, $2256 = 0, $2257 = 0, $2258 = 0, $2259 = 0, $226 = 0, $2260 = 0, $2261 = 0, $2262 = 0, $2263 = 0, $2264 = 0, $2265 = 0, $2266 = 0, $2267 = 0, $2268 = 0, $2269 = 0, $227 = 0, $2270 = 0, $2271 = 0;
 var $2272 = 0, $2273 = 0, $2274 = 0, $2275 = 0, $2276 = 0, $2277 = 0, $2278 = 0, $2279 = 0, $228 = 0, $2280 = 0, $2281 = 0, $2282 = 0, $2283 = 0, $2284 = 0, $2285 = 0, $2286 = 0, $2287 = 0, $2288 = 0, $2289 = 0, $229 = 0;
 var $2290 = 0, $2291 = 0, $2292 = 0, $2293 = 0, $2294 = 0, $2295 = 0, $2296 = 0, $2297 = 0, $2298 = 0, $2299 = 0, $23 = 0, $230 = 0, $2300 = 0, $2301 = 0, $2302 = 0, $2303 = 0, $2304 = 0, $2305 = 0, $2306 = 0, $2307 = 0;
 var $2308 = 0, $2309 = 0, $231 = 0, $2310 = 0, $2311 = 0, $2312 = 0, $2313 = 0, $2314 = 0, $2315 = 0, $2316 = 0, $2317 = 0, $2318 = 0, $2319 = 0, $232 = 0, $2320 = 0, $2321 = 0, $2322 = 0, $2323 = 0, $2324 = 0, $2325 = 0;
 var $2326 = 0, $2327 = 0, $2328 = 0, $2329 = 0, $233 = 0, $2330 = 0, $2331 = 0, $2332 = 0, $2333 = 0, $2334 = 0, $2335 = 0, $2336 = 0, $2337 = 0, $2338 = 0, $2339 = 0, $234 = 0, $2340 = 0, $2341 = 0, $2342 = 0, $2343 = 0;
 var $2344 = 0, $2345 = 0, $2346 = 0, $2347 = 0, $2348 = 0, $2349 = 0, $235 = 0, $2350 = 0, $2351 = 0, $2352 = 0, $2353 = 0, $2354 = 0, $2355 = 0, $2356 = 0, $2357 = 0, $2358 = 0, $2359 = 0, $236 = 0, $2360 = 0, $2361 = 0;
 var $2362 = 0, $2363 = 0, $2364 = 0, $2365 = 0, $2366 = 0, $2367 = 0, $2368 = 0, $2369 = 0, $237 = 0, $2370 = 0, $2371 = 0, $2372 = 0, $2373 = 0, $2374 = 0, $2375 = 0, $2376 = 0, $2377 = 0, $2378 = 0, $2379 = 0, $238 = 0;
 var $2380 = 0, $2381 = 0, $2382 = 0, $2383 = 0, $2384 = 0, $2385 = 0, $2386 = 0, $2387 = 0, $2388 = 0, $2389 = 0, $239 = 0, $2390 = 0, $2391 = 0, $2392 = 0, $2393 = 0, $2394 = 0, $2395 = 0, $2396 = 0, $2397 = 0, $2398 = 0;
 var $2399 = 0, $24 = 0, $240 = 0, $2400 = 0, $2401 = 0, $2402 = 0, $2403 = 0, $2404 = 0, $2405 = 0, $2406 = 0, $2407 = 0, $2408 = 0, $2409 = 0, $241 = 0, $2410 = 0, $2411 = 0, $2412 = 0, $2413 = 0, $2414 = 0, $2415 = 0;
 var $2416 = 0, $2417 = 0, $2418 = 0, $2419 = 0, $242 = 0, $2420 = 0, $2421 = 0, $2422 = 0, $2423 = 0, $2424 = 0, $2425 = 0, $2426 = 0, $2427 = 0, $2428 = 0, $2429 = 0, $243 = 0, $2430 = 0, $2431 = 0, $2432 = 0, $2433 = 0;
 var $2434 = 0, $2435 = 0, $2436 = 0, $2437 = 0, $2438 = 0, $2439 = 0, $244 = 0, $2440 = 0, $2441 = 0, $2442 = 0, $2443 = 0, $2444 = 0, $2445 = 0, $2446 = 0, $2447 = 0, $2448 = 0, $2449 = 0, $245 = 0, $2450 = 0, $2451 = 0;
 var $2452 = 0, $2453 = 0, $2454 = 0, $2455 = 0, $2456 = 0, $2457 = 0, $2458 = 0, $2459 = 0, $246 = 0, $2460 = 0, $2461 = 0, $2462 = 0, $2463 = 0, $2464 = 0, $2465 = 0, $2466 = 0, $2467 = 0, $2468 = 0, $2469 = 0, $247 = 0;
 var $2470 = 0, $2471 = 0, $2472 = 0, $2473 = 0, $2474 = 0, $2475 = 0, $2476 = 0, $2477 = 0, $2478 = 0, $2479 = 0, $248 = 0, $2480 = 0, $2481 = 0, $2482 = 0, $2483 = 0, $2484 = 0, $2485 = 0, $2486 = 0, $2487 = 0, $2488 = 0;
 var $2489 = 0, $249 = 0, $2490 = 0, $2491 = 0, $2492 = 0, $2493 = 0, $2494 = 0, $2495 = 0, $2496 = 0, $2497 = 0, $2498 = 0, $2499 = 0, $25 = 0, $250 = 0, $2500 = 0, $2501 = 0, $2502 = 0, $2503 = 0, $2504 = 0, $2505 = 0;
 var $2506 = 0, $2507 = 0, $2508 = 0, $2509 = 0, $251 = 0, $2510 = 0, $2511 = 0, $2512 = 0, $2513 = 0, $2514 = 0, $2515 = 0, $2516 = 0, $2517 = 0, $2518 = 0, $2519 = 0, $252 = 0, $2520 = 0, $2521 = 0, $2522 = 0, $2523 = 0;
 var $2524 = 0, $2525 = 0, $2526 = 0, $2527 = 0, $2528 = 0, $2529 = 0, $253 = 0, $2530 = 0, $2531 = 0, $2532 = 0, $2533 = 0, $2534 = 0, $2535 = 0, $2536 = 0, $2537 = 0, $2538 = 0, $2539 = 0, $254 = 0, $2540 = 0, $2541 = 0;
 var $2542 = 0, $2543 = 0, $2544 = 0, $2545 = 0, $2546 = 0, $2547 = 0, $2548 = 0, $2549 = 0, $255 = 0, $2550 = 0, $2551 = 0, $2552 = 0, $2553 = 0, $2554 = 0, $2555 = 0, $2556 = 0, $2557 = 0, $2558 = 0, $2559 = 0, $256 = 0;
 var $2560 = 0, $2561 = 0, $2562 = 0, $2563 = 0, $2564 = 0, $2565 = 0, $2566 = 0, $2567 = 0, $2568 = 0, $2569 = 0, $257 = 0, $2570 = 0, $2571 = 0, $2572 = 0, $2573 = 0, $2574 = 0, $2575 = 0, $2576 = 0, $2577 = 0, $2578 = 0;
 var $2579 = 0, $258 = 0, $2580 = 0, $2581 = 0, $2582 = 0, $2583 = 0, $2584 = 0, $2585 = 0, $2586 = 0, $2587 = 0, $2588 = 0, $2589 = 0, $259 = 0, $2590 = 0, $2591 = 0, $2592 = 0, $2593 = 0, $2594 = 0, $2595 = 0, $2596 = 0;
 var $2597 = 0, $2598 = 0, $2599 = 0, $26 = 0, $260 = 0, $2600 = 0, $2601 = 0, $2602 = 0, $2603 = 0, $2604 = 0, $2605 = 0, $2606 = 0, $2607 = 0, $2608 = 0, $2609 = 0, $261 = 0, $2610 = 0, $2611 = 0, $2612 = 0, $2613 = 0;
 var $2614 = 0, $2615 = 0, $2616 = 0, $2617 = 0, $2618 = 0, $2619 = 0, $262 = 0, $2620 = 0, $2621 = 0, $2622 = 0, $2623 = 0, $2624 = 0, $2625 = 0, $2626 = 0, $2627 = 0, $2628 = 0, $2629 = 0, $263 = 0, $2630 = 0, $2631 = 0;
 var $2632 = 0, $2633 = 0, $2634 = 0, $2635 = 0, $2636 = 0, $2637 = 0, $2638 = 0, $2639 = 0, $264 = 0, $2640 = 0, $2641 = 0, $2642 = 0, $2643 = 0, $2644 = 0, $2645 = 0, $2646 = 0, $2647 = 0, $2648 = 0, $2649 = 0, $265 = 0;
 var $2650 = 0, $2651 = 0, $2652 = 0, $2653 = 0, $2654 = 0, $2655 = 0, $2656 = 0, $2657 = 0, $2658 = 0, $2659 = 0, $266 = 0, $2660 = 0, $2661 = 0, $2662 = 0, $2663 = 0, $2664 = 0, $2665 = 0, $2666 = 0, $2667 = 0, $2668 = 0;
 var $2669 = 0, $267 = 0, $2670 = 0, $2671 = 0, $2672 = 0, $2673 = 0, $2674 = 0, $2675 = 0, $2676 = 0, $2677 = 0, $2678 = 0, $2679 = 0, $268 = 0, $2680 = 0, $2681 = 0, $2682 = 0, $2683 = 0, $2684 = 0, $2685 = 0, $2686 = 0;
 var $2687 = 0, $2688 = 0, $2689 = 0, $269 = 0, $2690 = 0, $2691 = 0, $2692 = 0, $2693 = 0, $2694 = 0, $2695 = 0, $2696 = 0, $2697 = 0, $2698 = 0, $2699 = 0, $27 = 0, $270 = 0, $2700 = 0, $2701 = 0, $2702 = 0, $2703 = 0;
 var $2704 = 0, $2705 = 0, $2706 = 0, $2707 = 0, $2708 = 0, $2709 = 0, $271 = 0, $2710 = 0, $2711 = 0, $2712 = 0, $2713 = 0, $2714 = 0, $2715 = 0, $2716 = 0, $2717 = 0, $2718 = 0, $2719 = 0, $272 = 0, $2720 = 0, $2721 = 0;
 var $2722 = 0, $2723 = 0, $2724 = 0, $2725 = 0, $2726 = 0, $2727 = 0, $2728 = 0, $2729 = 0, $273 = 0, $2730 = 0, $2731 = 0, $2732 = 0, $2733 = 0, $2734 = 0, $2735 = 0, $2736 = 0, $2737 = 0, $2738 = 0, $2739 = 0, $274 = 0;
 var $2740 = 0, $2741 = 0, $2742 = 0, $2743 = 0, $2744 = 0, $2745 = 0, $2746 = 0, $2747 = 0, $2748 = 0, $2749 = 0, $275 = 0, $2750 = 0, $2751 = 0, $2752 = 0, $2753 = 0, $2754 = 0, $2755 = 0, $2756 = 0, $2757 = 0, $2758 = 0;
 var $2759 = 0, $276 = 0, $2760 = 0, $2761 = 0, $2762 = 0, $2763 = 0, $2764 = 0, $2765 = 0, $2766 = 0, $2767 = 0, $2768 = 0, $2769 = 0, $277 = 0, $2770 = 0, $2771 = 0, $2772 = 0, $2773 = 0, $2774 = 0, $2775 = 0, $2776 = 0;
 var $2777 = 0, $2778 = 0, $2779 = 0, $278 = 0, $2780 = 0, $2781 = 0, $2782 = 0, $2783 = 0, $2784 = 0, $2785 = 0, $2786 = 0, $2787 = 0, $2788 = 0, $2789 = 0, $279 = 0, $2790 = 0, $2791 = 0, $2792 = 0, $2793 = 0, $2794 = 0;
 var $2795 = 0, $2796 = 0, $2797 = 0, $2798 = 0, $2799 = 0, $28 = 0, $280 = 0, $2800 = 0, $2801 = 0, $2802 = 0, $2803 = 0, $2804 = 0, $2805 = 0, $2806 = 0, $2807 = 0, $2808 = 0, $2809 = 0, $281 = 0, $2810 = 0, $2811 = 0;
 var $2812 = 0, $2813 = 0, $2814 = 0, $2815 = 0, $2816 = 0, $2817 = 0, $2818 = 0, $2819 = 0, $282 = 0, $2820 = 0, $2821 = 0, $2822 = 0, $2823 = 0, $2824 = 0, $2825 = 0, $2826 = 0, $2827 = 0, $2828 = 0, $2829 = 0, $283 = 0;
 var $2830 = 0, $2831 = 0, $2832 = 0, $2833 = 0, $2834 = 0, $2835 = 0, $2836 = 0, $2837 = 0, $2838 = 0, $2839 = 0, $284 = 0, $2840 = 0, $2841 = 0, $2842 = 0, $2843 = 0, $2844 = 0, $2845 = 0, $2846 = 0, $2847 = 0, $2848 = 0;
 var $2849 = 0, $285 = 0, $2850 = 0, $2851 = 0, $2852 = 0, $2853 = 0, $2854 = 0, $2855 = 0, $2856 = 0, $2857 = 0, $2858 = 0, $2859 = 0, $286 = 0, $2860 = 0, $2861 = 0, $2862 = 0, $2863 = 0, $2864 = 0, $2865 = 0, $2866 = 0;
 var $2867 = 0, $2868 = 0, $2869 = 0, $287 = 0, $2870 = 0, $2871 = 0, $2872 = 0, $2873 = 0, $2874 = 0, $2875 = 0, $2876 = 0, $2877 = 0, $2878 = 0, $2879 = 0, $288 = 0, $2880 = 0, $2881 = 0, $2882 = 0, $2883 = 0, $2884 = 0;
 var $2885 = 0, $2886 = 0, $2887 = 0, $2888 = 0, $2889 = 0, $289 = 0, $2890 = 0, $2891 = 0, $2892 = 0, $2893 = 0, $2894 = 0, $2895 = 0, $2896 = 0, $2897 = 0, $2898 = 0, $2899 = 0, $29 = 0, $290 = 0, $2900 = 0, $2901 = 0;
 var $2902 = 0, $2903 = 0, $2904 = 0, $2905 = 0, $2906 = 0, $2907 = 0, $2908 = 0, $2909 = 0, $291 = 0, $2910 = 0, $2911 = 0, $2912 = 0, $2913 = 0, $2914 = 0, $2915 = 0, $2916 = 0, $2917 = 0, $2918 = 0, $2919 = 0, $292 = 0;
 var $2920 = 0, $2921 = 0, $2922 = 0, $2923 = 0, $2924 = 0, $2925 = 0, $2926 = 0, $2927 = 0, $2928 = 0, $2929 = 0, $293 = 0, $2930 = 0, $2931 = 0, $2932 = 0, $2933 = 0, $2934 = 0, $2935 = 0, $2936 = 0, $2937 = 0, $2938 = 0;
 var $2939 = 0, $294 = 0, $2940 = 0, $2941 = 0, $2942 = 0, $2943 = 0, $2944 = 0, $2945 = 0, $2946 = 0, $2947 = 0, $2948 = 0, $2949 = 0, $295 = 0, $2950 = 0, $2951 = 0, $2952 = 0, $2953 = 0, $2954 = 0, $2955 = 0, $2956 = 0;
 var $2957 = 0, $2958 = 0, $2959 = 0, $296 = 0, $2960 = 0, $2961 = 0, $2962 = 0, $2963 = 0, $2964 = 0, $2965 = 0, $2966 = 0, $2967 = 0, $2968 = 0, $2969 = 0, $297 = 0, $2970 = 0, $2971 = 0, $2972 = 0, $2973 = 0, $2974 = 0;
 var $2975 = 0, $2976 = 0, $2977 = 0, $2978 = 0, $2979 = 0, $298 = 0, $2980 = 0, $2981 = 0, $2982 = 0, $2983 = 0, $2984 = 0, $2985 = 0, $2986 = 0, $2987 = 0, $2988 = 0, $2989 = 0, $299 = 0, $2990 = 0, $2991 = 0, $2992 = 0;
 var $2993 = 0, $2994 = 0, $2995 = 0, $2996 = 0, $2997 = 0, $2998 = 0, $2999 = 0, $3 = 0, $30 = 0, $300 = 0, $3000 = 0, $3001 = 0, $3002 = 0, $3003 = 0, $3004 = 0, $3005 = 0, $3006 = 0, $3007 = 0, $3008 = 0, $3009 = 0;
 var $301 = 0, $3010 = 0, $3011 = 0, $3012 = 0, $3013 = 0, $3014 = 0, $3015 = 0, $3016 = 0, $3017 = 0, $3018 = 0, $3019 = 0, $302 = 0, $3020 = 0, $3021 = 0, $3022 = 0, $3023 = 0, $3024 = 0, $3025 = 0, $3026 = 0, $3027 = 0;
 var $3028 = 0, $3029 = 0, $303 = 0, $3030 = 0, $3031 = 0, $3032 = 0, $3033 = 0, $3034 = 0, $3035 = 0, $3036 = 0, $3037 = 0, $3038 = 0, $3039 = 0, $304 = 0, $3040 = 0, $3041 = 0, $3042 = 0, $3043 = 0, $3044 = 0, $3045 = 0;
 var $3046 = 0, $3047 = 0, $3048 = 0, $3049 = 0, $305 = 0, $3050 = 0, $3051 = 0, $3052 = 0, $3053 = 0, $3054 = 0, $3055 = 0, $3056 = 0, $3057 = 0, $3058 = 0, $3059 = 0, $306 = 0, $3060 = 0, $3061 = 0, $3062 = 0, $3063 = 0;
 var $3064 = 0, $3065 = 0, $3066 = 0, $3067 = 0, $3068 = 0, $3069 = 0, $307 = 0, $3070 = 0, $3071 = 0, $3072 = 0, $3073 = 0, $3074 = 0, $3075 = 0, $3076 = 0, $3077 = 0, $3078 = 0, $3079 = 0, $308 = 0, $3080 = 0, $3081 = 0;
 var $3082 = 0, $3083 = 0, $3084 = 0, $3085 = 0, $3086 = 0, $3087 = 0, $3088 = 0, $3089 = 0, $309 = 0, $3090 = 0, $3091 = 0, $3092 = 0, $3093 = 0, $3094 = 0, $3095 = 0, $3096 = 0, $3097 = 0, $3098 = 0, $3099 = 0, $31 = 0;
 var $310 = 0, $3100 = 0, $3101 = 0, $3102 = 0, $3103 = 0, $3104 = 0, $3105 = 0, $3106 = 0, $3107 = 0, $3108 = 0, $3109 = 0, $311 = 0, $3110 = 0, $3111 = 0, $3112 = 0, $3113 = 0, $3114 = 0, $3115 = 0, $3116 = 0, $3117 = 0;
 var $3118 = 0, $3119 = 0, $312 = 0, $3120 = 0, $3121 = 0, $3122 = 0, $3123 = 0, $3124 = 0, $3125 = 0, $3126 = 0, $3127 = 0, $3128 = 0, $3129 = 0, $313 = 0, $3130 = 0, $3131 = 0, $3132 = 0, $3133 = 0, $3134 = 0, $3135 = 0;
 var $3136 = 0, $3137 = 0, $3138 = 0, $3139 = 0, $314 = 0, $3140 = 0, $3141 = 0, $3142 = 0, $3143 = 0, $3144 = 0, $3145 = 0, $3146 = 0, $3147 = 0, $3148 = 0, $3149 = 0, $315 = 0, $3150 = 0, $3151 = 0, $3152 = 0, $3153 = 0;
 var $3154 = 0, $3155 = 0, $3156 = 0, $3157 = 0, $3158 = 0, $3159 = 0, $316 = 0, $3160 = 0, $3161 = 0, $3162 = 0, $3163 = 0, $3164 = 0, $3165 = 0, $3166 = 0, $3167 = 0, $3168 = 0, $3169 = 0, $317 = 0, $3170 = 0, $3171 = 0;
 var $3172 = 0, $3173 = 0, $3174 = 0, $3175 = 0, $3176 = 0, $3177 = 0, $3178 = 0, $3179 = 0, $318 = 0, $3180 = 0, $3181 = 0, $3182 = 0, $3183 = 0, $3184 = 0, $3185 = 0, $3186 = 0, $3187 = 0, $3188 = 0, $3189 = 0, $319 = 0;
 var $3190 = 0, $3191 = 0, $3192 = 0, $3193 = 0, $3194 = 0, $3195 = 0, $3196 = 0, $3197 = 0, $3198 = 0, $3199 = 0, $32 = 0, $320 = 0, $3200 = 0, $3201 = 0, $3202 = 0, $3203 = 0, $3204 = 0, $3205 = 0, $3206 = 0, $3207 = 0;
 var $3208 = 0, $3209 = 0, $321 = 0, $3210 = 0, $3211 = 0, $3212 = 0, $3213 = 0, $3214 = 0, $3215 = 0, $3216 = 0, $3217 = 0, $3218 = 0, $3219 = 0, $322 = 0, $3220 = 0, $3221 = 0, $3222 = 0, $3223 = 0, $3224 = 0, $3225 = 0;
 var $3226 = 0, $3227 = 0, $3228 = 0, $3229 = 0, $323 = 0, $3230 = 0, $3231 = 0, $3232 = 0, $3233 = 0, $3234 = 0, $3235 = 0, $3236 = 0, $3237 = 0, $3238 = 0, $3239 = 0, $324 = 0, $3240 = 0, $3241 = 0, $3242 = 0, $3243 = 0;
 var $3244 = 0, $3245 = 0, $3246 = 0, $3247 = 0, $3248 = 0, $3249 = 0, $325 = 0, $3250 = 0, $3251 = 0, $3252 = 0, $3253 = 0, $3254 = 0, $3255 = 0, $3256 = 0, $3257 = 0, $3258 = 0, $3259 = 0, $326 = 0, $3260 = 0, $3261 = 0;
 var $3262 = 0, $3263 = 0, $3264 = 0, $3265 = 0, $3266 = 0, $3267 = 0, $3268 = 0, $3269 = 0, $327 = 0, $3270 = 0, $3271 = 0, $3272 = 0, $3273 = 0, $3274 = 0, $3275 = 0, $3276 = 0, $3277 = 0, $3278 = 0, $3279 = 0, $328 = 0;
 var $3280 = 0, $3281 = 0, $3282 = 0, $3283 = 0, $3284 = 0, $3285 = 0, $3286 = 0, $3287 = 0, $3288 = 0, $3289 = 0, $329 = 0, $3290 = 0, $3291 = 0, $3292 = 0, $3293 = 0, $3294 = 0, $3295 = 0, $3296 = 0, $3297 = 0, $3298 = 0;
 var $3299 = 0, $33 = 0, $330 = 0, $3300 = 0, $3301 = 0, $3302 = 0, $3303 = 0, $3304 = 0, $3305 = 0, $3306 = 0, $3307 = 0, $3308 = 0, $3309 = 0, $331 = 0, $3310 = 0, $3311 = 0, $3312 = 0, $3313 = 0, $3314 = 0, $3315 = 0;
 var $3316 = 0, $3317 = 0, $3318 = 0, $3319 = 0, $332 = 0, $3320 = 0, $3321 = 0, $3322 = 0, $3323 = 0, $3324 = 0, $3325 = 0, $3326 = 0, $3327 = 0, $3328 = 0, $3329 = 0, $333 = 0, $3330 = 0, $3331 = 0, $3332 = 0, $3333 = 0;
 var $3334 = 0, $3335 = 0, $3336 = 0, $3337 = 0, $3338 = 0, $3339 = 0, $334 = 0, $3340 = 0, $3341 = 0, $3342 = 0, $3343 = 0, $3344 = 0, $3345 = 0, $3346 = 0, $3347 = 0, $3348 = 0, $3349 = 0, $335 = 0, $3350 = 0, $3351 = 0;
 var $3352 = 0, $3353 = 0, $3354 = 0, $3355 = 0, $3356 = 0, $3357 = 0, $3358 = 0, $3359 = 0, $336 = 0, $3360 = 0, $3361 = 0, $3362 = 0, $3363 = 0, $3364 = 0, $3365 = 0, $3366 = 0, $3367 = 0, $3368 = 0, $3369 = 0, $337 = 0;
 var $3370 = 0, $3371 = 0, $3372 = 0, $3373 = 0, $3374 = 0, $3375 = 0, $3376 = 0, $3377 = 0, $3378 = 0, $3379 = 0, $338 = 0, $3380 = 0, $3381 = 0, $3382 = 0, $3383 = 0, $3384 = 0, $3385 = 0, $3386 = 0, $3387 = 0, $3388 = 0;
 var $3389 = 0, $339 = 0, $3390 = 0, $3391 = 0, $3392 = 0, $3393 = 0, $3394 = 0, $3395 = 0, $3396 = 0, $3397 = 0, $3398 = 0, $3399 = 0, $34 = 0, $340 = 0, $3400 = 0, $3401 = 0, $3402 = 0, $3403 = 0, $3404 = 0, $3405 = 0;
 var $3406 = 0, $3407 = 0, $3408 = 0, $3409 = 0, $341 = 0, $3410 = 0, $3411 = 0, $3412 = 0, $3413 = 0, $3414 = 0, $3415 = 0, $3416 = 0, $3417 = 0, $3418 = 0, $3419 = 0, $342 = 0, $3420 = 0, $3421 = 0, $3422 = 0, $3423 = 0;
 var $3424 = 0, $3425 = 0, $3426 = 0, $3427 = 0, $3428 = 0, $3429 = 0, $343 = 0, $3430 = 0, $3431 = 0, $3432 = 0, $3433 = 0, $3434 = 0, $3435 = 0, $3436 = 0, $3437 = 0, $3438 = 0, $3439 = 0, $344 = 0, $3440 = 0, $3441 = 0;
 var $3442 = 0, $3443 = 0, $3444 = 0, $3445 = 0, $3446 = 0, $3447 = 0, $3448 = 0, $3449 = 0, $345 = 0, $3450 = 0, $3451 = 0, $3452 = 0, $3453 = 0, $3454 = 0, $3455 = 0, $3456 = 0, $3457 = 0, $3458 = 0, $3459 = 0, $346 = 0;
 var $3460 = 0, $3461 = 0, $3462 = 0, $3463 = 0, $3464 = 0, $3465 = 0, $3466 = 0, $3467 = 0, $3468 = 0, $3469 = 0, $347 = 0, $3470 = 0, $3471 = 0, $3472 = 0, $3473 = 0, $3474 = 0, $3475 = 0, $3476 = 0, $3477 = 0, $3478 = 0;
 var $3479 = 0, $348 = 0, $3480 = 0, $3481 = 0, $3482 = 0, $3483 = 0, $3484 = 0, $3485 = 0, $3486 = 0, $3487 = 0, $3488 = 0, $3489 = 0, $349 = 0, $3490 = 0, $3491 = 0, $3492 = 0, $3493 = 0, $3494 = 0, $3495 = 0, $3496 = 0;
 var $3497 = 0, $3498 = 0, $3499 = 0, $35 = 0, $350 = 0, $3500 = 0, $3501 = 0, $3502 = 0, $3503 = 0, $3504 = 0, $3505 = 0, $3506 = 0, $3507 = 0, $3508 = 0, $3509 = 0, $351 = 0, $3510 = 0, $3511 = 0, $3512 = 0, $3513 = 0;
 var $3514 = 0, $3515 = 0, $3516 = 0, $3517 = 0, $3518 = 0, $3519 = 0, $352 = 0, $3520 = 0, $3521 = 0, $3522 = 0, $3523 = 0, $3524 = 0, $3525 = 0, $3526 = 0, $3527 = 0, $3528 = 0, $3529 = 0, $353 = 0, $3530 = 0, $3531 = 0;
 var $3532 = 0, $3533 = 0, $3534 = 0, $3535 = 0, $3536 = 0, $3537 = 0, $3538 = 0, $3539 = 0, $354 = 0, $3540 = 0, $3541 = 0, $3542 = 0, $3543 = 0, $3544 = 0, $3545 = 0, $3546 = 0, $3547 = 0, $3548 = 0, $3549 = 0, $355 = 0;
 var $3550 = 0, $3551 = 0, $3552 = 0, $3553 = 0, $3554 = 0, $3555 = 0, $3556 = 0, $3557 = 0, $3558 = 0, $3559 = 0, $356 = 0, $3560 = 0, $3561 = 0, $3562 = 0, $3563 = 0, $3564 = 0, $3565 = 0, $3566 = 0, $3567 = 0, $3568 = 0;
 var $3569 = 0, $357 = 0, $3570 = 0, $3571 = 0, $3572 = 0, $3573 = 0, $3574 = 0, $3575 = 0, $3576 = 0, $3577 = 0, $3578 = 0, $3579 = 0, $358 = 0, $3580 = 0, $3581 = 0, $3582 = 0, $3583 = 0, $3584 = 0, $3585 = 0, $3586 = 0;
 var $3587 = 0, $3588 = 0, $3589 = 0, $359 = 0, $3590 = 0, $3591 = 0, $3592 = 0, $3593 = 0, $3594 = 0, $3595 = 0, $3596 = 0, $3597 = 0, $3598 = 0, $3599 = 0, $36 = 0, $360 = 0, $3600 = 0, $3601 = 0, $3602 = 0, $3603 = 0;
 var $3604 = 0, $3605 = 0, $3606 = 0, $3607 = 0, $3608 = 0, $3609 = 0, $361 = 0, $3610 = 0, $3611 = 0, $3612 = 0, $3613 = 0, $3614 = 0, $3615 = 0, $3616 = 0, $3617 = 0, $3618 = 0, $3619 = 0, $362 = 0, $3620 = 0, $3621 = 0;
 var $3622 = 0, $3623 = 0, $3624 = 0, $3625 = 0, $3626 = 0, $3627 = 0, $3628 = 0, $3629 = 0, $363 = 0, $3630 = 0, $3631 = 0, $3632 = 0, $3633 = 0, $3634 = 0, $3635 = 0, $3636 = 0, $3637 = 0, $3638 = 0, $3639 = 0, $364 = 0;
 var $3640 = 0, $3641 = 0, $3642 = 0, $3643 = 0, $3644 = 0, $3645 = 0, $3646 = 0, $3647 = 0, $3648 = 0, $3649 = 0, $365 = 0, $3650 = 0, $3651 = 0, $3652 = 0, $3653 = 0, $3654 = 0, $3655 = 0, $3656 = 0, $3657 = 0, $3658 = 0;
 var $3659 = 0, $366 = 0, $3660 = 0, $3661 = 0, $3662 = 0, $3663 = 0, $3664 = 0, $3665 = 0, $3666 = 0, $3667 = 0, $3668 = 0, $3669 = 0, $367 = 0, $3670 = 0, $3671 = 0, $3672 = 0, $3673 = 0, $3674 = 0, $3675 = 0, $3676 = 0;
 var $3677 = 0, $3678 = 0, $3679 = 0, $368 = 0, $3680 = 0, $3681 = 0, $3682 = 0, $3683 = 0, $3684 = 0, $3685 = 0, $3686 = 0, $3687 = 0, $3688 = 0, $3689 = 0, $369 = 0, $3690 = 0, $3691 = 0, $3692 = 0, $3693 = 0, $3694 = 0;
 var $3695 = 0, $3696 = 0, $3697 = 0, $3698 = 0, $3699 = 0, $37 = 0, $370 = 0, $3700 = 0, $3701 = 0, $3702 = 0, $3703 = 0, $3704 = 0, $3705 = 0, $3706 = 0, $3707 = 0, $3708 = 0, $3709 = 0, $371 = 0, $3710 = 0, $3711 = 0;
 var $3712 = 0, $3713 = 0, $3714 = 0, $3715 = 0, $3716 = 0, $3717 = 0, $3718 = 0, $3719 = 0, $372 = 0, $3720 = 0, $3721 = 0, $3722 = 0, $3723 = 0, $3724 = 0, $3725 = 0, $3726 = 0, $3727 = 0, $3728 = 0, $3729 = 0, $373 = 0;
 var $3730 = 0, $3731 = 0, $3732 = 0, $3733 = 0, $3734 = 0, $3735 = 0, $3736 = 0, $3737 = 0, $3738 = 0, $3739 = 0, $374 = 0, $3740 = 0, $3741 = 0, $3742 = 0, $3743 = 0, $3744 = 0, $3745 = 0, $3746 = 0, $3747 = 0, $3748 = 0;
 var $3749 = 0, $375 = 0, $3750 = 0, $3751 = 0, $3752 = 0, $3753 = 0, $3754 = 0, $3755 = 0, $3756 = 0, $3757 = 0, $3758 = 0, $3759 = 0, $376 = 0, $3760 = 0, $3761 = 0, $3762 = 0, $3763 = 0, $3764 = 0, $3765 = 0, $3766 = 0;
 var $3767 = 0, $3768 = 0, $3769 = 0, $377 = 0, $3770 = 0, $3771 = 0, $3772 = 0, $3773 = 0, $3774 = 0, $3775 = 0, $3776 = 0, $3777 = 0, $3778 = 0, $3779 = 0, $378 = 0, $3780 = 0, $3781 = 0, $3782 = 0, $3783 = 0, $3784 = 0;
 var $3785 = 0, $3786 = 0, $3787 = 0, $3788 = 0, $3789 = 0, $379 = 0, $3790 = 0, $3791 = 0, $3792 = 0, $3793 = 0, $3794 = 0, $3795 = 0, $3796 = 0, $3797 = 0, $3798 = 0, $3799 = 0, $38 = 0, $380 = 0, $3800 = 0, $3801 = 0;
 var $3802 = 0, $3803 = 0, $3804 = 0, $3805 = 0, $3806 = 0, $3807 = 0, $3808 = 0, $3809 = 0, $381 = 0, $3810 = 0, $3811 = 0, $3812 = 0, $3813 = 0, $3814 = 0, $3815 = 0, $3816 = 0, $3817 = 0, $3818 = 0, $3819 = 0, $382 = 0;
 var $3820 = 0, $3821 = 0, $3822 = 0, $3823 = 0, $3824 = 0, $3825 = 0, $3826 = 0, $3827 = 0, $3828 = 0, $3829 = 0, $383 = 0, $3830 = 0, $3831 = 0, $3832 = 0, $3833 = 0, $3834 = 0, $3835 = 0, $3836 = 0, $3837 = 0, $3838 = 0;
 var $3839 = 0, $384 = 0, $3840 = 0, $3841 = 0, $3842 = 0, $3843 = 0, $3844 = 0, $3845 = 0, $3846 = 0, $3847 = 0, $3848 = 0, $3849 = 0, $385 = 0, $3850 = 0, $3851 = 0, $3852 = 0, $3853 = 0, $3854 = 0, $3855 = 0, $3856 = 0;
 var $3857 = 0, $3858 = 0, $3859 = 0, $386 = 0, $3860 = 0, $3861 = 0, $3862 = 0, $3863 = 0, $3864 = 0, $3865 = 0, $3866 = 0, $3867 = 0, $3868 = 0, $3869 = 0, $387 = 0, $3870 = 0, $3871 = 0, $3872 = 0, $3873 = 0, $3874 = 0;
 var $3875 = 0, $3876 = 0, $3877 = 0, $3878 = 0, $3879 = 0, $388 = 0, $3880 = 0, $3881 = 0, $3882 = 0, $3883 = 0, $3884 = 0, $3885 = 0, $3886 = 0, $3887 = 0, $3888 = 0, $3889 = 0, $389 = 0, $3890 = 0, $3891 = 0, $3892 = 0;
 var $3893 = 0, $3894 = 0, $3895 = 0, $3896 = 0, $3897 = 0, $3898 = 0, $3899 = 0, $39 = 0, $390 = 0, $3900 = 0, $3901 = 0, $3902 = 0, $3903 = 0, $3904 = 0, $3905 = 0, $3906 = 0, $3907 = 0, $3908 = 0, $3909 = 0, $391 = 0;
 var $3910 = 0, $3911 = 0, $3912 = 0, $3913 = 0, $3914 = 0, $3915 = 0, $3916 = 0, $3917 = 0, $3918 = 0, $3919 = 0, $392 = 0, $3920 = 0, $3921 = 0, $3922 = 0, $3923 = 0, $3924 = 0, $3925 = 0, $3926 = 0, $3927 = 0, $3928 = 0;
 var $3929 = 0, $393 = 0, $3930 = 0, $3931 = 0, $3932 = 0, $3933 = 0, $3934 = 0, $3935 = 0, $3936 = 0, $3937 = 0, $3938 = 0, $3939 = 0, $394 = 0, $3940 = 0, $3941 = 0, $3942 = 0, $3943 = 0, $3944 = 0, $3945 = 0, $3946 = 0;
 var $3947 = 0, $3948 = 0, $3949 = 0, $395 = 0, $3950 = 0, $3951 = 0, $3952 = 0, $3953 = 0, $3954 = 0, $3955 = 0, $3956 = 0, $3957 = 0, $3958 = 0, $3959 = 0, $396 = 0, $3960 = 0, $3961 = 0, $3962 = 0, $3963 = 0, $3964 = 0;
 var $3965 = 0, $3966 = 0, $3967 = 0, $3968 = 0, $3969 = 0, $397 = 0, $3970 = 0, $3971 = 0, $3972 = 0, $3973 = 0, $3974 = 0, $3975 = 0, $3976 = 0, $3977 = 0, $3978 = 0, $3979 = 0, $398 = 0, $3980 = 0, $3981 = 0, $3982 = 0;
 var $3983 = 0, $3984 = 0, $3985 = 0, $3986 = 0, $3987 = 0, $3988 = 0, $3989 = 0, $399 = 0, $3990 = 0, $3991 = 0, $3992 = 0, $3993 = 0, $3994 = 0, $3995 = 0, $3996 = 0, $3997 = 0, $3998 = 0, $3999 = 0, $4 = 0, $40 = 0;
 var $400 = 0, $4000 = 0, $4001 = 0, $4002 = 0, $4003 = 0, $4004 = 0, $4005 = 0, $4006 = 0, $4007 = 0, $4008 = 0, $4009 = 0, $401 = 0, $4010 = 0, $4011 = 0, $4012 = 0, $4013 = 0, $4014 = 0, $4015 = 0, $4016 = 0, $4017 = 0;
 var $4018 = 0, $4019 = 0, $402 = 0, $4020 = 0, $4021 = 0, $4022 = 0, $4023 = 0, $4024 = 0, $4025 = 0, $4026 = 0, $4027 = 0, $4028 = 0, $4029 = 0, $403 = 0, $4030 = 0, $4031 = 0, $4032 = 0, $4033 = 0, $4034 = 0, $4035 = 0;
 var $4036 = 0, $4037 = 0, $4038 = 0, $4039 = 0, $404 = 0, $4040 = 0, $4041 = 0, $4042 = 0, $4043 = 0, $4044 = 0, $4045 = 0, $4046 = 0, $4047 = 0, $4048 = 0, $4049 = 0, $405 = 0, $4050 = 0, $4051 = 0, $4052 = 0, $4053 = 0;
 var $4054 = 0, $4055 = 0, $4056 = 0, $4057 = 0, $4058 = 0, $4059 = 0, $406 = 0, $4060 = 0, $4061 = 0, $4062 = 0, $4063 = 0, $4064 = 0, $4065 = 0, $4066 = 0, $4067 = 0, $4068 = 0, $4069 = 0, $407 = 0, $4070 = 0, $4071 = 0;
 var $4072 = 0, $4073 = 0, $4074 = 0, $4075 = 0, $4076 = 0, $4077 = 0, $4078 = 0, $4079 = 0, $408 = 0, $4080 = 0, $4081 = 0, $4082 = 0, $4083 = 0, $4084 = 0, $4085 = 0, $4086 = 0, $4087 = 0, $4088 = 0, $4089 = 0, $409 = 0;
 var $4090 = 0, $4091 = 0, $4092 = 0, $4093 = 0, $4094 = 0, $4095 = 0, $4096 = 0, $4097 = 0, $4098 = 0, $4099 = 0, $41 = 0, $410 = 0, $4100 = 0, $4101 = 0, $4102 = 0, $4103 = 0, $4104 = 0, $4105 = 0, $4106 = 0, $4107 = 0;
 var $4108 = 0, $4109 = 0, $411 = 0, $4110 = 0, $4111 = 0, $4112 = 0, $4113 = 0, $4114 = 0, $4115 = 0, $4116 = 0, $4117 = 0, $4118 = 0, $4119 = 0, $412 = 0, $4120 = 0, $4121 = 0, $4122 = 0, $4123 = 0, $4124 = 0, $4125 = 0;
 var $4126 = 0, $4127 = 0, $4128 = 0, $4129 = 0, $413 = 0, $4130 = 0, $4131 = 0, $4132 = 0, $4133 = 0, $4134 = 0, $4135 = 0, $4136 = 0, $4137 = 0, $4138 = 0, $4139 = 0, $414 = 0, $4140 = 0, $4141 = 0, $4142 = 0, $4143 = 0;
 var $4144 = 0, $4145 = 0, $4146 = 0, $4147 = 0, $4148 = 0, $4149 = 0, $415 = 0, $4150 = 0, $4151 = 0, $4152 = 0, $4153 = 0, $4154 = 0, $4155 = 0, $4156 = 0, $4157 = 0, $4158 = 0, $4159 = 0, $416 = 0, $4160 = 0, $4161 = 0;
 var $4162 = 0, $4163 = 0, $4164 = 0, $4165 = 0, $4166 = 0, $4167 = 0, $4168 = 0, $4169 = 0, $417 = 0, $4170 = 0, $4171 = 0, $4172 = 0, $4173 = 0, $4174 = 0, $4175 = 0, $4176 = 0, $4177 = 0, $4178 = 0, $4179 = 0, $418 = 0;
 var $4180 = 0, $4181 = 0, $4182 = 0, $4183 = 0, $4184 = 0, $4185 = 0, $4186 = 0, $4187 = 0, $4188 = 0, $4189 = 0, $419 = 0, $4190 = 0, $4191 = 0, $4192 = 0, $4193 = 0, $4194 = 0, $4195 = 0, $4196 = 0, $4197 = 0, $4198 = 0;
 var $4199 = 0, $42 = 0, $420 = 0, $4200 = 0, $4201 = 0, $4202 = 0, $4203 = 0, $4204 = 0, $4205 = 0, $4206 = 0, $4207 = 0, $4208 = 0, $4209 = 0, $421 = 0, $4210 = 0, $4211 = 0, $4212 = 0, $4213 = 0, $4214 = 0, $4215 = 0;
 var $4216 = 0, $4217 = 0, $4218 = 0, $4219 = 0, $422 = 0, $4220 = 0, $4221 = 0, $4222 = 0, $4223 = 0, $4224 = 0, $4225 = 0, $4226 = 0, $4227 = 0, $4228 = 0, $4229 = 0, $423 = 0, $4230 = 0, $4231 = 0, $4232 = 0, $4233 = 0;
 var $4234 = 0, $4235 = 0, $4236 = 0, $4237 = 0, $4238 = 0, $4239 = 0, $424 = 0, $4240 = 0, $4241 = 0, $4242 = 0, $4243 = 0, $4244 = 0, $4245 = 0, $4246 = 0, $4247 = 0, $4248 = 0, $4249 = 0, $425 = 0, $4250 = 0, $426 = 0;
 var $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0.0;
 var $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0;
 var $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0;
 var $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0;
 var $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0;
 var $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0;
 var $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0;
 var $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0;
 var $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0;
 var $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0, $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0;
 var $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0, $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0;
 var $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0, $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0;
 var $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0, $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0;
 var $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0, $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0;
 var $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0, $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0;
 var $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0, $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0;
 var $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0, $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0;
 var $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0, $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0;
 var $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0, $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0;
 var $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0, $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0, $785 = 0.0, $786 = 0.0, $787 = 0;
 var $788 = 0.0, $789 = 0.0, $79 = 0, $790 = 0.0, $791 = 0, $792 = 0.0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0, $799 = 0, $8 = 0, $80 = 0, $800 = 0, $801 = 0, $802 = 0, $803 = 0, $804 = 0;
 var $805 = 0.0, $806 = 0, $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0, $813 = 0, $814 = 0, $815 = 0, $816 = 0, $817 = 0, $818 = 0, $819 = 0, $82 = 0, $820 = 0, $821 = 0, $822 = 0;
 var $823 = 0, $824 = 0, $825 = 0, $826 = 0, $827 = 0, $828 = 0, $829 = 0, $83 = 0, $830 = 0, $831 = 0, $832 = 0, $833 = 0, $834 = 0, $835 = 0, $836 = 0, $837 = 0, $838 = 0, $839 = 0, $84 = 0, $840 = 0;
 var $841 = 0, $842 = 0, $843 = 0, $844 = 0, $845 = 0, $846 = 0, $847 = 0, $848 = 0, $849 = 0, $85 = 0, $850 = 0, $851 = 0, $852 = 0, $853 = 0, $854 = 0, $855 = 0, $856 = 0, $857 = 0, $858 = 0, $859 = 0;
 var $86 = 0, $860 = 0, $861 = 0, $862 = 0, $863 = 0, $864 = 0, $865 = 0, $866 = 0, $867 = 0, $868 = 0, $869 = 0, $87 = 0, $870 = 0, $871 = 0, $872 = 0, $873 = 0, $874 = 0, $875 = 0, $876 = 0, $877 = 0;
 var $878 = 0, $879 = 0, $88 = 0, $880 = 0, $881 = 0, $882 = 0, $883 = 0, $884 = 0, $885 = 0, $886 = 0, $887 = 0, $888 = 0, $889 = 0, $89 = 0, $890 = 0, $891 = 0, $892 = 0, $893 = 0, $894 = 0, $895 = 0;
 var $896 = 0, $897 = 0, $898 = 0, $899 = 0, $9 = 0, $90 = 0, $900 = 0, $901 = 0, $902 = 0, $903 = 0, $904 = 0, $905 = 0, $906 = 0, $907 = 0, $908 = 0, $909 = 0, $91 = 0, $910 = 0, $911 = 0, $912 = 0;
 var $913 = 0, $914 = 0, $915 = 0, $916 = 0, $917 = 0, $918 = 0, $919 = 0, $92 = 0, $920 = 0, $921 = 0, $922 = 0, $923 = 0, $924 = 0, $925 = 0, $926 = 0, $927 = 0, $928 = 0, $929 = 0, $93 = 0, $930 = 0;
 var $931 = 0, $932 = 0, $933 = 0, $934 = 0, $935 = 0, $936 = 0, $937 = 0, $938 = 0, $939 = 0, $94 = 0, $940 = 0, $941 = 0, $942 = 0, $943 = 0, $944 = 0, $945 = 0, $946 = 0, $947 = 0, $948 = 0, $949 = 0;
 var $95 = 0, $950 = 0, $951 = 0, $952 = 0, $953 = 0, $954 = 0, $955 = 0, $956 = 0, $957 = 0, $958 = 0, $959 = 0, $96 = 0, $960 = 0, $961 = 0, $962 = 0, $963 = 0, $964 = 0, $965 = 0, $966 = 0, $967 = 0;
 var $968 = 0, $969 = 0, $97 = 0, $970 = 0, $971 = 0, $972 = 0, $973 = 0, $974 = 0, $975 = 0, $976 = 0, $977 = 0, $978 = 0, $979 = 0, $98 = 0, $980 = 0, $981 = 0, $982 = 0, $983 = 0, $984 = 0, $985 = 0;
 var $986 = 0, $987 = 0, $988 = 0, $989 = 0, $99 = 0, $990 = 0, $991 = 0, $992 = 0, $993 = 0, $994 = 0, $995 = 0, $996 = 0, $997 = 0, $998 = 0, $999 = 0, $cond = 0, $cond107 = 0, $cond108 = 0, $cond109 = 0, $exitcond = 0;
 var $exitcond4308 = 0, $not$ = 0, $not$3014 = 0, $or$cond = 0, $or$cond13 = 0, $or$cond15 = 0, $or$cond17 = 0, $or$cond21 = 0, $or$cond23 = 0, $or$cond3015 = 0, $or$cond3017 = 0, $or$cond3020 = 0, $or$cond3022 = 0, $or$cond3025 = 0, $or$cond3027$not = 0, $or$cond3038 = 0, $or$cond3041 = 0, $or$cond3268 = 0, $or$cond33 = 0, $or$cond37 = 0;
 var $or$cond39 = 0, $or$cond6 = 0, $phitmp = 0, $sext = 0, $spec$select = 0, $spec$select3028 = 0, $spec$select3036 = 0, $spec$select3039 = 0, $spec$select30423151 = 0, $spec$select30423153 = 0, $spec$select3051 = 0, $spec$select3055 = 0, $spec$select3059 = 0, $spec$select3063 = 0, $spec$select3068 = 0, $spec$select3072 = 0, $spec$select3074 = 0, $spec$select3266 = 0, $spec$select3266$v = 0, $sqlite3VdbeExec$or_logic$sink = 0;
 var $storemerge3011 = 0, $storemerge3013 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer13 = 0, $vararg_buffer15 = 0, $vararg_buffer18 = 0, $vararg_buffer20 = 0, $vararg_buffer22 = 0, $vararg_buffer24 = 0, $vararg_buffer29 = 0, $vararg_buffer31 = 0, $vararg_buffer34 = 0, $vararg_buffer37 = 0, $vararg_buffer40 = 0, $vararg_buffer43 = 0, $vararg_buffer46 = 0, $vararg_buffer49 = 0, $vararg_buffer5 = 0, $vararg_buffer52 = 0;
 var $vararg_buffer57 = 0, $vararg_buffer59 = 0, $vararg_buffer61 = 0, $vararg_buffer8 = 0, $vararg_ptr11 = 0, $vararg_ptr12 = 0, $vararg_ptr27 = 0, $vararg_ptr28 = 0, $vararg_ptr4 = 0, $vararg_ptr55 = 0, $vararg_ptr56 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 304|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(304|0);
 $vararg_buffer61 = sp + 272|0;
 $vararg_buffer59 = sp + 264|0;
 $vararg_buffer57 = sp + 256|0;
 $vararg_buffer52 = sp + 240|0;
 $vararg_buffer49 = sp + 232|0;
 $vararg_buffer46 = sp + 224|0;
 $vararg_buffer43 = sp + 216|0;
 $vararg_buffer40 = sp + 208|0;
 $vararg_buffer37 = sp + 200|0;
 $vararg_buffer34 = sp + 192|0;
 $vararg_buffer31 = sp + 184|0;
 $vararg_buffer29 = sp + 176|0;
 $vararg_buffer24 = sp + 160|0;
 $vararg_buffer22 = sp + 152|0;
 $vararg_buffer20 = sp + 144|0;
 $vararg_buffer18 = sp + 136|0;
 $vararg_buffer15 = sp + 128|0;
 $vararg_buffer13 = sp + 120|0;
 $vararg_buffer8 = sp + 104|0;
 $vararg_buffer5 = sp + 96|0;
 $vararg_buffer1 = sp + 88|0;
 $vararg_buffer = sp + 80|0;
 $1 = sp + 40|0;
 $2 = sp + 288|0;
 $3 = sp;
 $4 = sp + 276|0;
 $5 = sp + 280|0;
 $6 = ((($0)) + 88|0); //@line 80541 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 80541 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 80550 "c/sqlite3.c"
 $9 = ((($8)) + 70|0); //@line 80552 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 80552 "c/sqlite3.c"
 $11 = ((($0)) + 92|0); //@line 80558 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 80558 "c/sqlite3.c"
 _sqlite3VdbeEnter($0); //@line 80569 "c/sqlite3.c"
 $13 = ((($0)) + 40|0); //@line 80570 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 80570 "c/sqlite3.c"
 $15 = ($14|0)==(7); //@line 80570 "c/sqlite3.c"
 L1: do {
  if ($15) {
   $$11 = $7;$$32833 = 0;$$5 = $7;$$52819 = 0;
   label = 853;
  } else {
   $16 = ((($0)) + 56|0); //@line 80577 "c/sqlite3.c"
   $17 = $16; //@line 80577 "c/sqlite3.c"
   $18 = $17; //@line 80577 "c/sqlite3.c"
   HEAP32[$18>>2] = 0; //@line 80577 "c/sqlite3.c"
   $19 = (($17) + 4)|0; //@line 80577 "c/sqlite3.c"
   $20 = $19; //@line 80577 "c/sqlite3.c"
   HEAP32[$20>>2] = 0; //@line 80577 "c/sqlite3.c"
   $21 = ((($0)) + 104|0); //@line 80579 "c/sqlite3.c"
   HEAP32[$21>>2] = 0; //@line 80579 "c/sqlite3.c"
   $22 = ((($8)) + 396|0); //@line 80580 "c/sqlite3.c"
   HEAP32[$22>>2] = 0; //@line 80580 "c/sqlite3.c"
   $23 = ((($8)) + 256|0); //@line 80581 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 80581 "c/sqlite3.c"
   $25 = ($24|0)==(0); //@line 80581 "c/sqlite3.c"
   L3: do {
    if ($25) {
     $26 = ((($8)) + 312|0); //@line 80584 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 80584 "c/sqlite3.c"
     $28 = ($27|0)==(0|0); //@line 80584 "c/sqlite3.c"
     if ($28) {
      $$02835 = -1;
     } else {
      $29 = ((($0)) + 172|0); //@line 80585 "c/sqlite3.c"
      $30 = HEAP32[$29>>2]|0; //@line 80585 "c/sqlite3.c"
      $31 = ((($8)) + 320|0); //@line 80587 "c/sqlite3.c"
      $32 = HEAP32[$31>>2]|0; //@line 80587 "c/sqlite3.c"
      $33 = (($30>>>0) % ($32>>>0))&-1; //@line 80587 "c/sqlite3.c"
      $34 = (($32) - ($33))|0; //@line 80587 "c/sqlite3.c"
      $$02835 = $34;
     }
     $35 = ((($0)) + 36|0); //@line 80619 "c/sqlite3.c"
     $36 = HEAP32[$35>>2]|0; //@line 80619 "c/sqlite3.c"
     $37 = (($7) + (($36*20)|0)|0); //@line 80619 "c/sqlite3.c"
     $38 = ($10<<24>>24)==(1);
     $39 = ((($0)) + 116|0);
     $40 = ((($8)) + 80|0);
     $41 = ((($0)) + 192|0);
     $42 = ((($0)) + 112|0);
     $43 = ((($0)) + 112|0);
     $44 = ((($0)) + 143|0);
     $45 = ((($0)) + 112|0);
     $46 = ((($8)) + 16|0);
     $47 = ((($8)) + 16|0);
     $48 = ((($0)) + 112|0);
     $49 = ((($0)) + 145|0);
     $50 = ((($0)) + 112|0);
     $51 = ((($0)) + 112|0);
     $52 = ((($0)) + 112|0);
     $53 = ((($0)) + 112|0);
     $54 = ((($0)) + 112|0);
     $55 = ((($0)) + 112|0);
     $56 = ((($0)) + 112|0);
     $57 = ((($0)) + 112|0);
     $58 = ((($0)) + 112|0);
     $59 = ((($0)) + 112|0);
     $60 = ((($0)) + 44|0);
     $61 = ((($0)) + 112|0);
     $62 = ((($0)) + 112|0);
     $63 = ((($0)) + 112|0);
     $64 = ((($8)) + 100|0);
     $65 = ((($0)) + 112|0);
     $66 = ((($0)) + 112|0);
     $67 = ((($0)) + 112|0);
     $68 = ((($0)) + 112|0);
     $69 = ((($0)) + 164|0);
     $70 = ((($0)) + 112|0);
     $71 = ((($0)) + 112|0);
     $72 = ((($0)) + 112|0);
     $73 = ((($0)) + 112|0);
     $74 = ((($0)) + 112|0);
     $75 = ((($0)) + 112|0);
     $76 = ((($2)) + 8|0);
     $77 = ((($2)) + 10|0);
     $78 = ((($2)) + 4|0);
     $79 = ((($0)) + 112|0);
     $80 = ((($0)) + 112|0);
     $81 = ((($2)) + 8|0);
     $82 = ((($2)) + 10|0);
     $83 = ((($2)) + 4|0);
     $84 = ((($8)) + 164|0);
     $85 = ((($8)) + 176|0);
     $86 = ((($8)) + 16|0);
     $87 = ((($0)) + 112|0);
     $88 = ((($8)) + 16|0);
     $89 = ((($8)) + 82|0);
     $90 = ((($1)) + 8|0);
     $91 = ((($0)) + 108|0);
     $92 = ((($1)) + 4|0);
     $93 = ((($8)) + 16|0);
     $94 = ((($8)) + 16|0);
     $95 = ((($0)) + 192|0);
     $96 = ((($8)) + 28|0);
     $97 = ((($0)) + 192|0);
     $98 = ((($1)) + 8|0);
     $99 = ((($1)) + 4|0);
     $100 = ((($8)) + 16|0);
     $101 = ((($0)) + 108|0);
     $102 = ((($8)) + 16|0);
     $103 = ((($1)) + 32|0);
     $104 = ((($8)) + 176|0);
     $105 = ((($0)) + 112|0);
     $106 = ((($0)) + 96|0);
     $107 = ((($0)) + 112|0);
     $108 = ((($0)) + 112|0);
     $109 = ((($8)) + 16|0);
     $110 = ((($8)) + 16|0);
     $111 = ((($0)) + 192|0);
     $112 = ((($8)) + 100|0);
     $113 = $10&255;
     $114 = ((($0)) + 145|0);
     $115 = ((($0)) + 32|0);
     $116 = ((($8)) + 168|0);
     $117 = ((($8)) + 432|0);
     $118 = ((($8)) + 16|0);
     $119 = ((($8)) + 28|0);
     $120 = ((($8)) + 24|0);
     $121 = ((($8)) + 16|0);
     $122 = ((($2)) + 8|0);
     $123 = ((($2)) + 10|0);
     $124 = ((($2)) + 4|0);
     $125 = ((($2)) + 14|0);
     $126 = ((($2)) + 8|0);
     $127 = ((($2)) + 4|0);
     $128 = ((($1)) + 8|0);
     $129 = ((($1)) + 8|0);
     $130 = ((($8)) + 224|0);
     $131 = ((($0)) + 44|0);
     $132 = ((($8)) + 16|0);
     $133 = ((($0)) + 44|0);
     $134 = ((($8)) + 157|0);
     $135 = ((($1)) + 12|0);
     $136 = $10&255;
     $137 = ((($0)) + 200|0);
     $138 = ((($8)) + 140|0);
     $139 = ((($0)) + 192|0);
     $140 = ((($8)) + 456|0);
     $141 = ((($0)) + 64|0);
     $142 = ((($8)) + 448|0);
     $143 = $10&255;
     $144 = $10&255;
     $145 = ((($0)) + 145|0);
     $146 = ((($8)) + 28|0);
     $147 = ((($8)) + 16|0);
     $148 = ((($0)) + 108|0);
     $149 = ((($0)) + 145|0);
     $150 = ((($0)) + 200|0);
     $151 = ((($0)) + 44|0);
     $152 = ((($0)) + 180|0);
     $153 = ((($8)) + 444|0);
     $154 = ((($8)) + 440|0);
     $155 = ((($0)) + 145|0);
     $156 = ((($0)) + 143|0);
     $157 = ((($0)) + 192|0);
     $158 = ((($8)) + 224|0);
     $159 = ((($8)) + 16|0);
     $160 = ((($0)) + 64|0);
     $161 = ((($8)) + 448|0);
     $162 = ((($8)) + 456|0);
     $163 = ((($8)) + 456|0);
     $164 = ((($1)) + 20|0);
     $165 = $10&255;
     $166 = ((($8)) + 320|0);
     $167 = ((($8)) + 316|0);
     $168 = ((($0)) + 136|0);
     $169 = ((($0)) + 184|0);
     $170 = ((($8)) + 100|0);
     $171 = ((($8)) + 16|0);
     $172 = ((($0)) + 44|0);
     $173 = ((($0)) + 44|0);
     $174 = ((($8)) + 224|0);
     $175 = ((($1)) + 8|0);
     $176 = ((($1)) + 20|0);
     $177 = ((($1)) + 24|0);
     $178 = ((($0)) + 192|0);
     $179 = ((($8)) + 32|0);
     $180 = ((($0)) + 44|0);
     $181 = ((($0)) + 212|0);
     $182 = ((($0)) + 24|0);
     $183 = ((($0)) + 28|0);
     $184 = ((($0)) + 112|0);
     $185 = ((($0)) + 136|0);
     $186 = ((($8)) + 71|0);
     $187 = ((($8)) + 78|0);
     $188 = ((($0)) + 96|0);
     $189 = $10&255;
     $190 = ((($0)) + 212|0);
     $191 = ((($8)) + 188|0);
     $192 = ((($8)) + 192|0);
     $193 = ((($8)) + 172|0);
     $194 = ((($8)) + 71|0);
     $195 = ((($8)) + 168|0);
     $196 = ((($0)) + 145|0);
     $197 = ((($1)) + 16|0);
     $198 = ((($1)) + 28|0);
     $199 = ((($1)) + 8|0);
     $200 = ((($8)) + 32|0);
     $201 = ((($0)) + 24|0);
     $202 = ((($0)) + 112|0);
     $203 = ((($0)) + 28|0);
     $204 = ((($0)) + 136|0);
     $205 = ((($8)) + 164|0);
     $206 = ((($8)) + 100|0);
     $207 = ((($8)) + 188|0);
     $208 = ((($8)) + 192|0);
     $209 = ((($8)) + 188|0);
     $210 = ((($8)) + 192|0);
     $211 = ((($8)) + 100|0);
     $212 = ((($8)) + 432|0);
     $213 = ((($8)) + 448|0);
     $214 = ((($8)) + 456|0);
     $215 = ((($8)) + 79|0);
     $216 = ((($8)) + 71|0);
     $217 = ((($8)) + 220|0);
     $218 = ((($3)) + 16|0);
     $219 = ((($8)) + 79|0);
     $220 = ((($8)) + 440|0);
     $221 = ((($0)) + 48|0);
     $222 = ((($8)) + 164|0);
     $223 = ((($1)) + 32|0);
     $224 = ((($1)) + 32|0);
     $225 = ((($0)) + 44|0);
     $226 = ((($8)) + 32|0);
     $227 = ((($8)) + 440|0);
     $228 = ((($8)) + 24|0);
     $229 = ((($8)) + 20|0);
     $230 = ((($8)) + 20|0);
     $231 = ((($8)) + 444|0);
     $232 = ((($8)) + 440|0);
     $233 = ((($8)) + 71|0);
     $234 = ((($8)) + 448|0);
     $235 = ((($8)) + 456|0);
     $236 = ((($8)) + 16|0);
     $237 = ((($8)) + 16|0);
     $238 = ((($8)) + 448|0);
     $239 = ((($0)) + 72|0);
     $240 = ((($8)) + 456|0);
     $241 = ((($0)) + 80|0);
     $242 = ((($8)) + 224|0);
     $243 = ((($8)) + 220|0);
     $244 = ((($1)) + 8|0);
     $245 = ((($8)) + 79|0);
     $246 = ((($8)) + 440|0);
     $247 = ((($8)) + 24|0);
     $248 = ((($1)) + 4|0);
     $249 = ((($1)) + 8|0);
     $250 = ((($1)) + 4|0);
     $$02792 = $7;$$02793 = $37;$$02801 = 0;$$02814 = 0;$$02822 = 0;$$02830 = 0;$$02839 = $12;$$12836 = $$02835;
     L8: while(1) {
      $251 = (($$02830) + 1)|0; //@line 80628 "c/sqlite3.c"
      $252 = HEAP8[$$02793>>0]|0; //@line 80695 "c/sqlite3.c"
      L10: do {
       switch ($252<<24>>24) {
       case 78:  {
        label = 63;
        break L8;
        break;
       }
       case 1:  {
        label = 357;
        break L8;
        break;
       }
       case 13:  {
        $$12802 = $$02801;
        label = 7;
        break;
       }
       case 14:  {
        $269 = ((($$02793)) + 4|0); //@line 80787 "c/sqlite3.c"
        $270 = HEAP32[$269>>2]|0; //@line 80787 "c/sqlite3.c"
        $271 = (((($$02839) + (($270*40)|0)|0)) + 8|0); //@line 80790 "c/sqlite3.c"
        HEAP16[$271>>1] = 4; //@line 80790 "c/sqlite3.c"
        $272 = $$02793; //@line 80791 "c/sqlite3.c"
        $273 = $$02792; //@line 80791 "c/sqlite3.c"
        $274 = (($272) - ($273))|0; //@line 80791 "c/sqlite3.c"
        $275 = (($274|0) / 20)&-1; //@line 80791 "c/sqlite3.c"
        $276 = ($275|0)<(0); //@line 80791 "c/sqlite3.c"
        $277 = $276 << 31 >> 31; //@line 80791 "c/sqlite3.c"
        $278 = (($$02839) + (($270*40)|0)|0); //@line 80791 "c/sqlite3.c"
        $279 = $278; //@line 80791 "c/sqlite3.c"
        $280 = $279; //@line 80791 "c/sqlite3.c"
        HEAP32[$280>>2] = $275; //@line 80791 "c/sqlite3.c"
        $281 = (($279) + 4)|0; //@line 80791 "c/sqlite3.c"
        $282 = $281; //@line 80791 "c/sqlite3.c"
        HEAP32[$282>>2] = $277; //@line 80791 "c/sqlite3.c"
        $$32804 = $$02801;
        label = 13;
        break;
       }
       case 63:  {
        $287 = ((($$02793)) + 4|0); //@line 80807 "c/sqlite3.c"
        $288 = HEAP32[$287>>2]|0; //@line 80807 "c/sqlite3.c"
        $289 = (($$02839) + (($288*40)|0)|0); //@line 80807 "c/sqlite3.c"
        $290 = $289; //@line 80809 "c/sqlite3.c"
        $291 = $290; //@line 80809 "c/sqlite3.c"
        $292 = HEAP32[$291>>2]|0; //@line 80809 "c/sqlite3.c"
        $293 = (($290) + 4)|0; //@line 80809 "c/sqlite3.c"
        $294 = $293; //@line 80809 "c/sqlite3.c"
        $295 = HEAP32[$294>>2]|0; //@line 80809 "c/sqlite3.c"
        $296 = (($$02792) + (($292*20)|0)|0); //@line 80809 "c/sqlite3.c"
        $297 = (((($$02839) + (($288*40)|0)|0)) + 8|0); //@line 80810 "c/sqlite3.c"
        HEAP16[$297>>1] = 128; //@line 80810 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $296;$$87 = $$02801;
        break;
       }
       case 15:  {
        $298 = ((($$02793)) + 4|0); //@line 80829 "c/sqlite3.c"
        $299 = HEAP32[$298>>2]|0; //@line 80829 "c/sqlite3.c"
        $300 = (($$02839) + (($299*40)|0)|0); //@line 80829 "c/sqlite3.c"
        $301 = ((($$02793)) + 12|0); //@line 80831 "c/sqlite3.c"
        $302 = HEAP32[$301>>2]|0; //@line 80831 "c/sqlite3.c"
        $303 = (($302) + -1)|0; //@line 80831 "c/sqlite3.c"
        $304 = ($303|0)<(0); //@line 80831 "c/sqlite3.c"
        $305 = $304 << 31 >> 31; //@line 80831 "c/sqlite3.c"
        $306 = $300; //@line 80831 "c/sqlite3.c"
        $307 = $306; //@line 80831 "c/sqlite3.c"
        HEAP32[$307>>2] = $303; //@line 80831 "c/sqlite3.c"
        $308 = (($306) + 4)|0; //@line 80831 "c/sqlite3.c"
        $309 = $308; //@line 80831 "c/sqlite3.c"
        HEAP32[$309>>2] = $305; //@line 80831 "c/sqlite3.c"
        $310 = (((($$02839) + (($299*40)|0)|0)) + 8|0); //@line 80832 "c/sqlite3.c"
        HEAP16[$310>>1] = 4; //@line 80832 "c/sqlite3.c"
        $311 = ((($$02793)) + 8|0); //@line 80833 "c/sqlite3.c"
        $312 = HEAP32[$311>>2]|0; //@line 80833 "c/sqlite3.c"
        $313 = ($312|0)==(0); //@line 80833 "c/sqlite3.c"
        if ($313) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$32804 = $$02801;
         label = 13;
        }
        break;
       }
       case 64:  {
        $314 = ((($$02793)) + 4|0); //@line 80847 "c/sqlite3.c"
        $315 = HEAP32[$314>>2]|0; //@line 80847 "c/sqlite3.c"
        $316 = (($$02839) + (($315*40)|0)|0); //@line 80847 "c/sqlite3.c"
        $317 = $316; //@line 80850 "c/sqlite3.c"
        $318 = $317; //@line 80850 "c/sqlite3.c"
        $319 = HEAP32[$318>>2]|0; //@line 80850 "c/sqlite3.c"
        $320 = (($317) + 4)|0; //@line 80850 "c/sqlite3.c"
        $321 = $320; //@line 80850 "c/sqlite3.c"
        $322 = HEAP32[$321>>2]|0; //@line 80850 "c/sqlite3.c"
        $323 = (((($$02792) + (($319*20)|0)|0)) + 8|0); //@line 80853 "c/sqlite3.c"
        $324 = HEAP32[$323>>2]|0; //@line 80853 "c/sqlite3.c"
        $325 = (($324) + -1)|0; //@line 80853 "c/sqlite3.c"
        $326 = (($$02792) + (($325*20)|0)|0); //@line 80853 "c/sqlite3.c"
        $327 = (((($$02839) + (($315*40)|0)|0)) + 8|0); //@line 80854 "c/sqlite3.c"
        HEAP16[$327>>1] = 128; //@line 80854 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $326;$$87 = $$02801;
        break;
       }
       case 16:  {
        $328 = ((($$02793)) + 4|0); //@line 80873 "c/sqlite3.c"
        $329 = HEAP32[$328>>2]|0; //@line 80873 "c/sqlite3.c"
        $330 = (((($$02839) + (($329*40)|0)|0)) + 8|0); //@line 80875 "c/sqlite3.c"
        HEAP16[$330>>1] = 4; //@line 80875 "c/sqlite3.c"
        $331 = (($$02839) + (($329*40)|0)|0); //@line 80876 "c/sqlite3.c"
        $332 = $331; //@line 80876 "c/sqlite3.c"
        $333 = $332; //@line 80876 "c/sqlite3.c"
        $334 = HEAP32[$333>>2]|0; //@line 80876 "c/sqlite3.c"
        $335 = (($332) + 4)|0; //@line 80876 "c/sqlite3.c"
        $336 = $335; //@line 80876 "c/sqlite3.c"
        $337 = HEAP32[$336>>2]|0; //@line 80876 "c/sqlite3.c"
        $338 = $$02793; //@line 80877 "c/sqlite3.c"
        $339 = $$02792; //@line 80877 "c/sqlite3.c"
        $340 = (($338) - ($339))|0; //@line 80877 "c/sqlite3.c"
        $341 = (($340|0) / 20)&-1; //@line 80877 "c/sqlite3.c"
        $342 = ($341|0)<(0); //@line 80877 "c/sqlite3.c"
        $343 = $342 << 31 >> 31; //@line 80877 "c/sqlite3.c"
        $344 = $331; //@line 80877 "c/sqlite3.c"
        $345 = $344; //@line 80877 "c/sqlite3.c"
        HEAP32[$345>>2] = $341; //@line 80877 "c/sqlite3.c"
        $346 = (($344) + 4)|0; //@line 80877 "c/sqlite3.c"
        $347 = $346; //@line 80877 "c/sqlite3.c"
        HEAP32[$347>>2] = $343; //@line 80877 "c/sqlite3.c"
        $348 = (($$02792) + (($334*20)|0)|0); //@line 80879 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $348;$$87 = $$02801;
        break;
       }
       case 65:  {
        $349 = ((($$02793)) + 12|0); //@line 80892 "c/sqlite3.c"
        $350 = HEAP32[$349>>2]|0; //@line 80892 "c/sqlite3.c"
        $351 = (((($$02839) + (($350*40)|0)|0)) + 8|0); //@line 80893 "c/sqlite3.c"
        $352 = HEAP16[$351>>1]|0; //@line 80893 "c/sqlite3.c"
        $353 = $352 & 1; //@line 80893 "c/sqlite3.c"
        $354 = ($353<<16>>16)==(0); //@line 80893 "c/sqlite3.c"
        if ($354) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         label = 19;
        }
        break;
       }
       case 66:  {
        label = 19;
        break;
       }
       case 67:  {
        $418 = (_out2Prerelease($0,$$02793)|0); //@line 80991 "c/sqlite3.c"
        $419 = ((($$02793)) + 4|0); //@line 80992 "c/sqlite3.c"
        $420 = HEAP32[$419>>2]|0; //@line 80992 "c/sqlite3.c"
        $421 = ($420|0)<(0); //@line 80992 "c/sqlite3.c"
        $422 = $421 << 31 >> 31; //@line 80992 "c/sqlite3.c"
        $423 = $418; //@line 80992 "c/sqlite3.c"
        $424 = $423; //@line 80992 "c/sqlite3.c"
        HEAP32[$424>>2] = $420; //@line 80992 "c/sqlite3.c"
        $425 = (($423) + 4)|0; //@line 80992 "c/sqlite3.c"
        $426 = $425; //@line 80992 "c/sqlite3.c"
        HEAP32[$426>>2] = $422; //@line 80992 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 68:  {
        $427 = (_out2Prerelease($0,$$02793)|0); //@line 81003 "c/sqlite3.c"
        $428 = ((($$02793)) + 16|0); //@line 81005 "c/sqlite3.c"
        $429 = HEAP32[$428>>2]|0; //@line 81005 "c/sqlite3.c"
        $430 = $429; //@line 81005 "c/sqlite3.c"
        $431 = $430; //@line 81005 "c/sqlite3.c"
        $432 = HEAP32[$431>>2]|0; //@line 81005 "c/sqlite3.c"
        $433 = (($430) + 4)|0; //@line 81005 "c/sqlite3.c"
        $434 = $433; //@line 81005 "c/sqlite3.c"
        $435 = HEAP32[$434>>2]|0; //@line 81005 "c/sqlite3.c"
        $436 = $427; //@line 81005 "c/sqlite3.c"
        $437 = $436; //@line 81005 "c/sqlite3.c"
        HEAP32[$437>>2] = $432; //@line 81005 "c/sqlite3.c"
        $438 = (($436) + 4)|0; //@line 81005 "c/sqlite3.c"
        $439 = $438; //@line 81005 "c/sqlite3.c"
        HEAP32[$439>>2] = $435; //@line 81005 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -124:  {
        $440 = (_out2Prerelease($0,$$02793)|0); //@line 81017 "c/sqlite3.c"
        $441 = ((($440)) + 8|0); //@line 81018 "c/sqlite3.c"
        HEAP16[$441>>1] = 8; //@line 81018 "c/sqlite3.c"
        $442 = ((($$02793)) + 16|0); //@line 81020 "c/sqlite3.c"
        $443 = HEAP32[$442>>2]|0; //@line 81020 "c/sqlite3.c"
        $444 = +HEAPF64[$443>>3]; //@line 81020 "c/sqlite3.c"
        HEAPF64[$440>>3] = $444; //@line 81020 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 97:  {
        $445 = (_out2Prerelease($0,$$02793)|0); //@line 81035 "c/sqlite3.c"
        HEAP8[$$02793>>0] = 69; //@line 81036 "c/sqlite3.c"
        $446 = ((($$02793)) + 16|0); //@line 81037 "c/sqlite3.c"
        $447 = HEAP32[$446>>2]|0; //@line 81037 "c/sqlite3.c"
        $448 = (_sqlite3Strlen30($447)|0); //@line 81037 "c/sqlite3.c"
        $449 = ((($$02793)) + 4|0); //@line 81037 "c/sqlite3.c"
        HEAP32[$449>>2] = $448; //@line 81037 "c/sqlite3.c"
        if ($38) {
         $$62807 = $$02801;
        } else {
         $450 = (_sqlite3VdbeMemSetStr($445,$447,-1,1,0)|0); //@line 81041 "c/sqlite3.c"
         $451 = (_sqlite3VdbeChangeEncoding($445,$113)|0); //@line 81043 "c/sqlite3.c"
         $452 = ($451|0)==(0); //@line 81043 "c/sqlite3.c"
         if (!($452)) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
         $453 = ((($445)) + 24|0); //@line 81046 "c/sqlite3.c"
         HEAP32[$453>>2] = 0; //@line 81046 "c/sqlite3.c"
         $454 = ((($445)) + 8|0); //@line 81047 "c/sqlite3.c"
         $455 = HEAP16[$454>>1]|0; //@line 81047 "c/sqlite3.c"
         $456 = $455 | 2048; //@line 81047 "c/sqlite3.c"
         HEAP16[$454>>1] = $456; //@line 81047 "c/sqlite3.c"
         $457 = ((($$02793)) + 1|0); //@line 81048 "c/sqlite3.c"
         $458 = HEAP8[$457>>0]|0; //@line 81048 "c/sqlite3.c"
         $459 = ($458<<24>>24)==(-7); //@line 81048 "c/sqlite3.c"
         if ($459) {
          $460 = HEAP32[$446>>2]|0; //@line 81049 "c/sqlite3.c"
          _sqlite3DbFree($8,$460); //@line 81049 "c/sqlite3.c"
         }
         HEAP8[$457>>0] = -7; //@line 81051 "c/sqlite3.c"
         $461 = ((($445)) + 16|0); //@line 81052 "c/sqlite3.c"
         $462 = HEAP32[$461>>2]|0; //@line 81052 "c/sqlite3.c"
         HEAP32[$446>>2] = $462; //@line 81052 "c/sqlite3.c"
         $463 = ((($445)) + 12|0); //@line 81053 "c/sqlite3.c"
         $464 = HEAP32[$463>>2]|0; //@line 81053 "c/sqlite3.c"
         HEAP32[$449>>2] = $464; //@line 81053 "c/sqlite3.c"
         $$62807 = $450;
        }
        $465 = HEAP32[$449>>2]|0; //@line 81057 "c/sqlite3.c"
        $466 = HEAP32[$112>>2]|0; //@line 81057 "c/sqlite3.c"
        $467 = ($465|0)>($466|0); //@line 81057 "c/sqlite3.c"
        if ($467) {
         label = 852;
         break L8;
        } else {
         $$72808 = $$62807;
         label = 42;
        }
        break;
       }
       case 69:  {
        $$72808 = $$02801;
        label = 42;
        break;
       }
       case 70:  {
        $493 = (_out2Prerelease($0,$$02793)|0); //@line 81110 "c/sqlite3.c"
        $494 = ((($$02793)) + 12|0); //@line 81111 "c/sqlite3.c"
        $495 = HEAP32[$494>>2]|0; //@line 81111 "c/sqlite3.c"
        $496 = ((($$02793)) + 8|0); //@line 81111 "c/sqlite3.c"
        $497 = HEAP32[$496>>2]|0; //@line 81111 "c/sqlite3.c"
        $498 = (($495) - ($497))|0; //@line 81111 "c/sqlite3.c"
        $499 = ((($$02793)) + 4|0); //@line 81113 "c/sqlite3.c"
        $500 = HEAP32[$499>>2]|0; //@line 81113 "c/sqlite3.c"
        $501 = ($500|0)==(0); //@line 81113 "c/sqlite3.c"
        $502 = $501 ? 1 : 257; //@line 81113 "c/sqlite3.c"
        $503 = ((($493)) + 8|0); //@line 81113 "c/sqlite3.c"
        HEAP16[$503>>1] = $502; //@line 81113 "c/sqlite3.c"
        $504 = ((($493)) + 12|0); //@line 81114 "c/sqlite3.c"
        HEAP32[$504>>2] = 0; //@line 81114 "c/sqlite3.c"
        $505 = ($498|0)>(0); //@line 81115 "c/sqlite3.c"
        if ($505) {
         $$028493844 = $493;$$029213843 = $498;
         while(1) {
          $506 = ((($$028493844)) + 40|0); //@line 81116 "c/sqlite3.c"
          _sqlite3VdbeMemSetNull($506); //@line 81118 "c/sqlite3.c"
          $507 = ((($$028493844)) + 48|0); //@line 81119 "c/sqlite3.c"
          HEAP16[$507>>1] = $502; //@line 81119 "c/sqlite3.c"
          $508 = ((($$028493844)) + 52|0); //@line 81120 "c/sqlite3.c"
          HEAP32[$508>>2] = 0; //@line 81120 "c/sqlite3.c"
          $509 = (($$029213843) + -1)|0; //@line 81121 "c/sqlite3.c"
          $510 = ($$029213843|0)>(1); //@line 81115 "c/sqlite3.c"
          if ($510) {
           $$028493844 = $506;$$029213843 = $509;
          } else {
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
           break;
          }
         }
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 71:  {
        $511 = ((($$02793)) + 4|0); //@line 81136 "c/sqlite3.c"
        $512 = HEAP32[$511>>2]|0; //@line 81136 "c/sqlite3.c"
        $513 = (((($$02839) + (($512*40)|0)|0)) + 8|0); //@line 81137 "c/sqlite3.c"
        $514 = HEAP16[$513>>1]|0; //@line 81137 "c/sqlite3.c"
        $515 = $514 & -160; //@line 81137 "c/sqlite3.c"
        $516 = $515 | 1; //@line 81137 "c/sqlite3.c"
        HEAP16[$513>>1] = $516; //@line 81137 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 72:  {
        $517 = (_out2Prerelease($0,$$02793)|0); //@line 81149 "c/sqlite3.c"
        $518 = ((($$02793)) + 16|0); //@line 81150 "c/sqlite3.c"
        $519 = HEAP32[$518>>2]|0; //@line 81150 "c/sqlite3.c"
        $520 = ((($$02793)) + 4|0); //@line 81150 "c/sqlite3.c"
        $521 = HEAP32[$520>>2]|0; //@line 81150 "c/sqlite3.c"
        (_sqlite3VdbeMemSetStr($517,$519,$521,0,0)|0); //@line 81150 "c/sqlite3.c"
        $522 = ((($517)) + 10|0); //@line 81151 "c/sqlite3.c"
        HEAP8[$522>>0] = $10; //@line 81151 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 73:  {
        $523 = HEAP32[$39>>2]|0; //@line 81169 "c/sqlite3.c"
        $524 = ((($$02793)) + 4|0); //@line 81169 "c/sqlite3.c"
        $525 = HEAP32[$524>>2]|0; //@line 81169 "c/sqlite3.c"
        $526 = (($525) + -1)|0; //@line 81169 "c/sqlite3.c"
        $527 = (($523) + (($526*40)|0)|0); //@line 81169 "c/sqlite3.c"
        $528 = (_sqlite3VdbeMemTooBig($527)|0); //@line 81170 "c/sqlite3.c"
        $529 = ($528|0)==(0); //@line 81170 "c/sqlite3.c"
        if (!($529)) {
         label = 852;
         break L8;
        }
        $530 = ((($$02793)) + 8|0); //@line 81173 "c/sqlite3.c"
        $531 = HEAP32[$530>>2]|0; //@line 81173 "c/sqlite3.c"
        $532 = (($$02839) + (($531*40)|0)|0); //@line 81173 "c/sqlite3.c"
        _sqlite3VdbeMemShallowCopy($532,$527,2048); //@line 81174 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 74:  {
        $533 = ((($$02793)) + 12|0); //@line 81193 "c/sqlite3.c"
        $534 = HEAP32[$533>>2]|0; //@line 81193 "c/sqlite3.c"
        $535 = ((($$02793)) + 4|0); //@line 81194 "c/sqlite3.c"
        $536 = HEAP32[$535>>2]|0; //@line 81194 "c/sqlite3.c"
        $537 = ((($$02793)) + 8|0); //@line 81195 "c/sqlite3.c"
        $538 = HEAP32[$537>>2]|0; //@line 81195 "c/sqlite3.c"
        $539 = (($$02839) + (($536*40)|0)|0); //@line 81199 "c/sqlite3.c"
        $540 = (($$02839) + (($538*40)|0)|0); //@line 81200 "c/sqlite3.c"
        $$02844 = $539;$$02922 = $534;$$12850 = $540;
        while(1) {
         _sqlite3VdbeMemMove($$12850,$$02844); //@line 81206 "c/sqlite3.c"
         $541 = ((($$12850)) + 8|0); //@line 81212 "c/sqlite3.c"
         $542 = HEAP16[$541>>1]|0; //@line 81212 "c/sqlite3.c"
         $543 = $542 & 4096; //@line 81212 "c/sqlite3.c"
         $544 = ($543<<16>>16)==(0); //@line 81212 "c/sqlite3.c"
         if (!($544)) {
          $545 = (_sqlite3VdbeMemMakeWriteable($$12850)|0); //@line 81212 "c/sqlite3.c"
          $546 = ($545|0)==(0); //@line 81212 "c/sqlite3.c"
          if (!($546)) {
           $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
           label = 853;
           break L1;
          }
         }
         $547 = ((($$02844)) + 40|0); //@line 81214 "c/sqlite3.c"
         $548 = ((($$12850)) + 40|0); //@line 81215 "c/sqlite3.c"
         $549 = (($$02922) + -1)|0; //@line 81216 "c/sqlite3.c"
         $550 = ($549|0)==(0); //@line 81216 "c/sqlite3.c"
         if ($550) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break;
         } else {
          $$02844 = $547;$$02922 = $549;$$12850 = $548;
         }
        }
        break;
       }
       case 75:  {
        $551 = ((($$02793)) + 12|0); //@line 81231 "c/sqlite3.c"
        $552 = HEAP32[$551>>2]|0; //@line 81231 "c/sqlite3.c"
        $553 = ((($$02793)) + 4|0); //@line 81232 "c/sqlite3.c"
        $554 = HEAP32[$553>>2]|0; //@line 81232 "c/sqlite3.c"
        $555 = (($$02839) + (($554*40)|0)|0); //@line 81232 "c/sqlite3.c"
        $556 = ((($$02793)) + 8|0); //@line 81233 "c/sqlite3.c"
        $557 = HEAP32[$556>>2]|0; //@line 81233 "c/sqlite3.c"
        $558 = (($$02839) + (($557*40)|0)|0); //@line 81233 "c/sqlite3.c"
        $$02923 = $552;$$12845 = $555;$$22851 = $558;
        while(1) {
         _sqlite3VdbeMemShallowCopy($$22851,$$12845,4096); //@line 81236 "c/sqlite3.c"
         $559 = ((($$22851)) + 8|0); //@line 81237 "c/sqlite3.c"
         $560 = HEAP16[$559>>1]|0; //@line 81237 "c/sqlite3.c"
         $561 = $560 & 4096; //@line 81237 "c/sqlite3.c"
         $562 = ($561<<16>>16)==(0); //@line 81237 "c/sqlite3.c"
         if (!($562)) {
          $563 = (_sqlite3VdbeMemMakeWriteable($$22851)|0); //@line 81237 "c/sqlite3.c"
          $564 = ($563|0)==(0); //@line 81237 "c/sqlite3.c"
          if (!($564)) {
           $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
           label = 853;
           break L1;
          }
         }
         $565 = ($$02923|0)==(0); //@line 81242 "c/sqlite3.c"
         if ($565) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
         $566 = (($$02923) + -1)|0; //@line 81242 "c/sqlite3.c"
         $567 = ((($$22851)) + 40|0); //@line 81243 "c/sqlite3.c"
         $568 = ((($$12845)) + 40|0); //@line 81244 "c/sqlite3.c"
         $$02923 = $566;$$12845 = $568;$$22851 = $567;
        }
        break;
       }
       case 76:  {
        $569 = ((($$02793)) + 4|0); //@line 81263 "c/sqlite3.c"
        $570 = HEAP32[$569>>2]|0; //@line 81263 "c/sqlite3.c"
        $571 = (($$02839) + (($570*40)|0)|0); //@line 81263 "c/sqlite3.c"
        $572 = ((($$02793)) + 8|0); //@line 81264 "c/sqlite3.c"
        $573 = HEAP32[$572>>2]|0; //@line 81264 "c/sqlite3.c"
        $574 = (($$02839) + (($573*40)|0)|0); //@line 81264 "c/sqlite3.c"
        _sqlite3VdbeMemShallowCopy($574,$571,4096); //@line 81266 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 77:  {
        $575 = ((($$02793)) + 4|0); //@line 81282 "c/sqlite3.c"
        $576 = HEAP32[$575>>2]|0; //@line 81282 "c/sqlite3.c"
        $577 = ((($$02793)) + 8|0); //@line 81284 "c/sqlite3.c"
        $578 = HEAP32[$577>>2]|0; //@line 81284 "c/sqlite3.c"
        $579 = (($$02839) + (($578*40)|0)|0); //@line 81284 "c/sqlite3.c"
        $580 = (($$02839) + (($576*40)|0)|0); //@line 81285 "c/sqlite3.c"
        $581 = $580; //@line 81285 "c/sqlite3.c"
        $582 = $581; //@line 81285 "c/sqlite3.c"
        $583 = HEAP32[$582>>2]|0; //@line 81285 "c/sqlite3.c"
        $584 = (($581) + 4)|0; //@line 81285 "c/sqlite3.c"
        $585 = $584; //@line 81285 "c/sqlite3.c"
        $586 = HEAP32[$585>>2]|0; //@line 81285 "c/sqlite3.c"
        _sqlite3VdbeMemSetInt64($579,$583,$586); //@line 81285 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 93:  {
        $632 = ((($$02793)) + 4|0); //@line 81390 "c/sqlite3.c"
        $633 = HEAP32[$632>>2]|0; //@line 81390 "c/sqlite3.c"
        $634 = (($$02839) + (($633*40)|0)|0); //@line 81390 "c/sqlite3.c"
        $635 = ((($$02793)) + 8|0); //@line 81391 "c/sqlite3.c"
        $636 = HEAP32[$635>>2]|0; //@line 81391 "c/sqlite3.c"
        $637 = (($$02839) + (($636*40)|0)|0); //@line 81391 "c/sqlite3.c"
        $638 = ((($$02793)) + 12|0); //@line 81392 "c/sqlite3.c"
        $639 = HEAP32[$638>>2]|0; //@line 81392 "c/sqlite3.c"
        $640 = (($$02839) + (($639*40)|0)|0); //@line 81392 "c/sqlite3.c"
        $641 = (((($$02839) + (($633*40)|0)|0)) + 8|0); //@line 81394 "c/sqlite3.c"
        $642 = HEAP16[$641>>1]|0; //@line 81394 "c/sqlite3.c"
        $643 = (((($$02839) + (($636*40)|0)|0)) + 8|0); //@line 81394 "c/sqlite3.c"
        $644 = HEAP16[$643>>1]|0; //@line 81394 "c/sqlite3.c"
        $645 = $644 | $642; //@line 81394 "c/sqlite3.c"
        $646 = $645 & 1; //@line 81394 "c/sqlite3.c"
        $647 = ($646<<16>>16)==(0); //@line 81394 "c/sqlite3.c"
        if (!($647)) {
         _sqlite3VdbeMemSetNull($640); //@line 81395 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        $648 = $642 & 16384; //@line 81398 "c/sqlite3.c"
        $649 = ($648<<16>>16)==(0); //@line 81398 "c/sqlite3.c"
        if (!($649)) {
         $650 = (_sqlite3VdbeMemExpandBlob($634)|0); //@line 81398 "c/sqlite3.c"
         $651 = ($650|0)==(0); //@line 81398 "c/sqlite3.c"
         if (!($651)) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
        }
        $652 = HEAP16[$643>>1]|0; //@line 81398 "c/sqlite3.c"
        $653 = $652 & 16384; //@line 81398 "c/sqlite3.c"
        $654 = ($653<<16>>16)==(0); //@line 81398 "c/sqlite3.c"
        if (!($654)) {
         $655 = (_sqlite3VdbeMemExpandBlob($637)|0); //@line 81398 "c/sqlite3.c"
         $656 = ($655|0)==(0); //@line 81398 "c/sqlite3.c"
         if (!($656)) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
        }
        $657 = HEAP16[$641>>1]|0; //@line 81399 "c/sqlite3.c"
        $658 = $657 & 18; //@line 81399 "c/sqlite3.c"
        $659 = ($658<<16>>16)==(0); //@line 81399 "c/sqlite3.c"
        if ($659) {
         $660 = (_sqlite3VdbeMemStringify($634,$10,0)|0); //@line 81399 "c/sqlite3.c"
         $661 = ($660|0)==(0); //@line 81399 "c/sqlite3.c"
         if (!($661)) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
        }
        $662 = HEAP16[$643>>1]|0; //@line 81400 "c/sqlite3.c"
        $663 = $662 & 18; //@line 81400 "c/sqlite3.c"
        $664 = ($663<<16>>16)==(0); //@line 81400 "c/sqlite3.c"
        if ($664) {
         $665 = (_sqlite3VdbeMemStringify($637,$10,0)|0); //@line 81400 "c/sqlite3.c"
         $666 = ($665|0)==(0); //@line 81400 "c/sqlite3.c"
         if (!($666)) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
        }
        $667 = (((($$02839) + (($633*40)|0)|0)) + 12|0); //@line 81401 "c/sqlite3.c"
        $668 = HEAP32[$667>>2]|0; //@line 81401 "c/sqlite3.c"
        $669 = (((($$02839) + (($636*40)|0)|0)) + 12|0); //@line 81401 "c/sqlite3.c"
        $670 = HEAP32[$669>>2]|0; //@line 81401 "c/sqlite3.c"
        $671 = (($670) + ($668))|0; //@line 81401 "c/sqlite3.c"
        $672 = HEAP32[$206>>2]|0; //@line 81402 "c/sqlite3.c"
        $673 = ($671|0)>($672|0); //@line 81402 "c/sqlite3.c"
        if ($673) {
         label = 852;
         break L8;
        }
        $674 = (($671) + 2)|0; //@line 81405 "c/sqlite3.c"
        $675 = ($639|0)==($636|0); //@line 81405 "c/sqlite3.c"
        $676 = $675&1; //@line 81405 "c/sqlite3.c"
        $677 = (_sqlite3VdbeMemGrow($640,$674,$676)|0); //@line 81405 "c/sqlite3.c"
        $678 = ($677|0)==(0); //@line 81405 "c/sqlite3.c"
        if (!($678)) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $679 = (((($$02839) + (($639*40)|0)|0)) + 8|0); //@line 81408 "c/sqlite3.c"
        $680 = HEAP16[$679>>1]|0; //@line 81408 "c/sqlite3.c"
        $681 = $680 & 15872; //@line 81408 "c/sqlite3.c"
        $682 = $681 | 2; //@line 81408 "c/sqlite3.c"
        HEAP16[$679>>1] = $682; //@line 81408 "c/sqlite3.c"
        if (!($675)) {
         $683 = (((($$02839) + (($636*40)|0)|0)) + 16|0); //@line 81410 "c/sqlite3.c"
         $684 = (((($$02839) + (($639*40)|0)|0)) + 16|0); //@line 81410 "c/sqlite3.c"
         $685 = HEAP32[$684>>2]|0; //@line 81410 "c/sqlite3.c"
         $686 = HEAP32[$683>>2]|0; //@line 81410 "c/sqlite3.c"
         $687 = HEAP32[$669>>2]|0; //@line 81410 "c/sqlite3.c"
         _memcpy(($685|0),($686|0),($687|0))|0; //@line 81410 "c/sqlite3.c"
        }
        $688 = (((($$02839) + (($639*40)|0)|0)) + 16|0); //@line 81412 "c/sqlite3.c"
        $689 = HEAP32[$688>>2]|0; //@line 81412 "c/sqlite3.c"
        $690 = HEAP32[$669>>2]|0; //@line 81412 "c/sqlite3.c"
        $691 = (($689) + ($690)|0); //@line 81412 "c/sqlite3.c"
        $692 = (((($$02839) + (($633*40)|0)|0)) + 16|0); //@line 81412 "c/sqlite3.c"
        $693 = HEAP32[$692>>2]|0; //@line 81412 "c/sqlite3.c"
        $694 = HEAP32[$667>>2]|0; //@line 81412 "c/sqlite3.c"
        _memcpy(($691|0),($693|0),($694|0))|0; //@line 81412 "c/sqlite3.c"
        $695 = HEAP32[$688>>2]|0; //@line 81413 "c/sqlite3.c"
        $696 = (($695) + ($671)|0); //@line 81413 "c/sqlite3.c"
        HEAP8[$696>>0] = 0; //@line 81413 "c/sqlite3.c"
        $697 = HEAP32[$688>>2]|0; //@line 81414 "c/sqlite3.c"
        $698 = (($671) + 1)|0; //@line 81414 "c/sqlite3.c"
        $699 = (($697) + ($698)|0); //@line 81414 "c/sqlite3.c"
        HEAP8[$699>>0] = 0; //@line 81414 "c/sqlite3.c"
        $700 = HEAP16[$679>>1]|0; //@line 81415 "c/sqlite3.c"
        $701 = $700 | 512; //@line 81415 "c/sqlite3.c"
        HEAP16[$679>>1] = $701; //@line 81415 "c/sqlite3.c"
        $702 = (((($$02839) + (($639*40)|0)|0)) + 12|0); //@line 81416 "c/sqlite3.c"
        HEAP32[$702>>2] = $671; //@line 81416 "c/sqlite3.c"
        $703 = (((($$02839) + (($639*40)|0)|0)) + 10|0); //@line 81417 "c/sqlite3.c"
        HEAP8[$703>>0] = $10; //@line 81417 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 92: case 91: case 90: case 89: case 88:  {
        $704 = ((($$02793)) + 4|0); //@line 81474 "c/sqlite3.c"
        $705 = HEAP32[$704>>2]|0; //@line 81474 "c/sqlite3.c"
        $706 = (($$02839) + (($705*40)|0)|0); //@line 81474 "c/sqlite3.c"
        $707 = (_numericType($706)|0); //@line 81475 "c/sqlite3.c"
        $708 = ((($$02793)) + 8|0); //@line 81476 "c/sqlite3.c"
        $709 = HEAP32[$708>>2]|0; //@line 81476 "c/sqlite3.c"
        $710 = (($$02839) + (($709*40)|0)|0); //@line 81476 "c/sqlite3.c"
        $711 = (_numericType($710)|0); //@line 81477 "c/sqlite3.c"
        $712 = ((($$02793)) + 12|0); //@line 81478 "c/sqlite3.c"
        $713 = HEAP32[$712>>2]|0; //@line 81478 "c/sqlite3.c"
        $714 = (($$02839) + (($713*40)|0)|0); //@line 81478 "c/sqlite3.c"
        $715 = $707 & 4; //@line 81480 "c/sqlite3.c"
        $716 = $715 & $711; //@line 81480 "c/sqlite3.c"
        $717 = ($716<<16>>16)==(0); //@line 81480 "c/sqlite3.c"
        L73: do {
         if ($717) {
          $778 = (((($$02839) + (($705*40)|0)|0)) + 8|0); //@line 81479 "c/sqlite3.c"
          $779 = HEAP16[$778>>1]|0; //@line 81479 "c/sqlite3.c"
          $780 = (((($$02839) + (($709*40)|0)|0)) + 8|0); //@line 81479 "c/sqlite3.c"
          $781 = HEAP16[$780>>1]|0; //@line 81479 "c/sqlite3.c"
          $782 = $781 | $779; //@line 81479 "c/sqlite3.c"
          $783 = $782 & 1; //@line 81503 "c/sqlite3.c"
          $784 = ($783<<16>>16)==(0); //@line 81503 "c/sqlite3.c"
          if ($784) {
           $$02925 = 0;
           label = 105;
          } else {
           label = 119;
          }
         } else {
          $718 = $706; //@line 81481 "c/sqlite3.c"
          $719 = $718; //@line 81481 "c/sqlite3.c"
          $720 = HEAP32[$719>>2]|0; //@line 81481 "c/sqlite3.c"
          $721 = (($718) + 4)|0; //@line 81481 "c/sqlite3.c"
          $722 = $721; //@line 81481 "c/sqlite3.c"
          $723 = HEAP32[$722>>2]|0; //@line 81481 "c/sqlite3.c"
          $724 = $710; //@line 81482 "c/sqlite3.c"
          $725 = $724; //@line 81482 "c/sqlite3.c"
          $726 = HEAP32[$725>>2]|0; //@line 81482 "c/sqlite3.c"
          $727 = (($724) + 4)|0; //@line 81482 "c/sqlite3.c"
          $728 = $727; //@line 81482 "c/sqlite3.c"
          $729 = HEAP32[$728>>2]|0; //@line 81482 "c/sqlite3.c"
          $730 = $1; //@line 81482 "c/sqlite3.c"
          $731 = $730; //@line 81482 "c/sqlite3.c"
          HEAP32[$731>>2] = $726; //@line 81482 "c/sqlite3.c"
          $732 = (($730) + 4)|0; //@line 81482 "c/sqlite3.c"
          $733 = $732; //@line 81482 "c/sqlite3.c"
          HEAP32[$733>>2] = $729; //@line 81482 "c/sqlite3.c"
          $734 = HEAP8[$$02793>>0]|0; //@line 81484 "c/sqlite3.c"
          switch ($734<<24>>24) {
          case 88:  {
           $735 = (_sqlite3AddInt64($1,$720,$723)|0); //@line 81485 "c/sqlite3.c"
           $736 = ($735|0)==(0); //@line 81485 "c/sqlite3.c"
           if (!($736)) {
            $$02925 = 1;
            label = 105;
            break L73;
           }
           break;
          }
          case 89:  {
           $737 = (_sqlite3SubInt64($1,$720,$723)|0); //@line 81486 "c/sqlite3.c"
           $738 = ($737|0)==(0); //@line 81486 "c/sqlite3.c"
           if (!($738)) {
            $$02925 = 1;
            label = 105;
            break L73;
           }
           break;
          }
          case 90:  {
           $739 = (_sqlite3MulInt64($1,$720,$723)|0); //@line 81487 "c/sqlite3.c"
           $740 = ($739|0)==(0); //@line 81487 "c/sqlite3.c"
           if (!($740)) {
            $$02925 = 1;
            label = 105;
            break L73;
           }
           break;
          }
          case 91:  {
           $741 = ($720|0)==(0); //@line 81489 "c/sqlite3.c"
           $742 = ($723|0)==(0); //@line 81489 "c/sqlite3.c"
           $743 = $741 & $742; //@line 81489 "c/sqlite3.c"
           if ($743) {
            label = 119;
            break L73;
           }
           $744 = ($720|0)==(-1); //@line 81490 "c/sqlite3.c"
           $745 = ($723|0)==(-1); //@line 81490 "c/sqlite3.c"
           $746 = $744 & $745; //@line 81490 "c/sqlite3.c"
           $747 = ($726|0)==(0); //@line 81490 "c/sqlite3.c"
           $748 = ($729|0)==(-2147483648); //@line 81490 "c/sqlite3.c"
           $749 = $747 & $748; //@line 81490 "c/sqlite3.c"
           $or$cond = $746 & $749; //@line 81490 "c/sqlite3.c"
           if ($or$cond) {
            $$02925 = 1;
            label = 105;
            break L73;
           }
           $750 = (___divdi3(($726|0),($729|0),($720|0),($723|0))|0); //@line 81491 "c/sqlite3.c"
           $751 = tempRet0; //@line 81491 "c/sqlite3.c"
           $752 = $1; //@line 81491 "c/sqlite3.c"
           $753 = $752; //@line 81491 "c/sqlite3.c"
           HEAP32[$753>>2] = $750; //@line 81491 "c/sqlite3.c"
           $754 = (($752) + 4)|0; //@line 81491 "c/sqlite3.c"
           $755 = $754; //@line 81491 "c/sqlite3.c"
           HEAP32[$755>>2] = $751; //@line 81491 "c/sqlite3.c"
           break;
          }
          default: {
           switch ($720|0) {
           case 0:  {
            $cond109 = ($723|0)==(0);
            if ($cond109) {
             label = 119;
             break L73;
            } else {
             $756 = $720;$757 = $723;
            }
            break;
           }
           case -1:  {
            $cond108 = ($723|0)==(-1);
            if ($cond108) {
             $756 = 1;$757 = 0;
            } else {
             $756 = $720;$757 = $723;
            }
            break;
           }
           default: {
            $756 = $720;$757 = $723;
           }
           }
           $758 = (___remdi3(($726|0),($729|0),($756|0),($757|0))|0); //@line 81497 "c/sqlite3.c"
           $759 = tempRet0; //@line 81497 "c/sqlite3.c"
           $760 = $1; //@line 81497 "c/sqlite3.c"
           $761 = $760; //@line 81497 "c/sqlite3.c"
           HEAP32[$761>>2] = $758; //@line 81497 "c/sqlite3.c"
           $762 = (($760) + 4)|0; //@line 81497 "c/sqlite3.c"
           $763 = $762; //@line 81497 "c/sqlite3.c"
           HEAP32[$763>>2] = $759; //@line 81497 "c/sqlite3.c"
          }
          }
          $764 = $1; //@line 81501 "c/sqlite3.c"
          $765 = $764; //@line 81501 "c/sqlite3.c"
          $766 = HEAP32[$765>>2]|0; //@line 81501 "c/sqlite3.c"
          $767 = (($764) + 4)|0; //@line 81501 "c/sqlite3.c"
          $768 = $767; //@line 81501 "c/sqlite3.c"
          $769 = HEAP32[$768>>2]|0; //@line 81501 "c/sqlite3.c"
          $770 = $714; //@line 81501 "c/sqlite3.c"
          $771 = $770; //@line 81501 "c/sqlite3.c"
          HEAP32[$771>>2] = $766; //@line 81501 "c/sqlite3.c"
          $772 = (($770) + 4)|0; //@line 81501 "c/sqlite3.c"
          $773 = $772; //@line 81501 "c/sqlite3.c"
          HEAP32[$773>>2] = $769; //@line 81501 "c/sqlite3.c"
          $774 = (((($$02839) + (($713*40)|0)|0)) + 8|0); //@line 81502 "c/sqlite3.c"
          $775 = HEAP16[$774>>1]|0; //@line 81502 "c/sqlite3.c"
          $776 = $775 & 15872; //@line 81502 "c/sqlite3.c"
          $777 = $776 | 4; //@line 81502 "c/sqlite3.c"
          HEAP16[$774>>1] = $777; //@line 81502 "c/sqlite3.c"
         }
        } while(0);
        L90: do {
         if ((label|0) == 105) {
          label = 0;
          $785 = (+_sqlite3VdbeRealValue($706)); //@line 81508 "c/sqlite3.c"
          $786 = (+_sqlite3VdbeRealValue($710)); //@line 81509 "c/sqlite3.c"
          $787 = HEAP8[$$02793>>0]|0; //@line 81510 "c/sqlite3.c"
          switch ($787<<24>>24) {
          case 88:  {
           $788 = $785 + $786; //@line 81511 "c/sqlite3.c"
           $$02928 = $788;
           break;
          }
          case 89:  {
           $789 = $786 - $785; //@line 81512 "c/sqlite3.c"
           $$02928 = $789;
           break;
          }
          case 90:  {
           $790 = $785 * $786; //@line 81513 "c/sqlite3.c"
           $$02928 = $790;
           break;
          }
          case 91:  {
           $791 = $785 == 0.0; //@line 81516 "c/sqlite3.c"
           if ($791) {
            label = 119;
            break L90;
           }
           $792 = $786 / $785; //@line 81517 "c/sqlite3.c"
           $$02928 = $792;
           break;
          }
          default: {
           $793 = (~~$785)>>>0; //@line 81521 "c/sqlite3.c"
           $794 = +Math_abs($785) >= 1.0 ? $785 > 0.0 ? (~~+Math_min(+Math_floor($785 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($785 - +(~~$785 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 81521 "c/sqlite3.c"
           $795 = (~~$786)>>>0; //@line 81522 "c/sqlite3.c"
           $796 = +Math_abs($786) >= 1.0 ? $786 > 0.0 ? (~~+Math_min(+Math_floor($786 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($786 - +(~~$786 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 81522 "c/sqlite3.c"
           $797 = $1; //@line 81522 "c/sqlite3.c"
           $798 = $797; //@line 81522 "c/sqlite3.c"
           HEAP32[$798>>2] = $795; //@line 81522 "c/sqlite3.c"
           $799 = (($797) + 4)|0; //@line 81522 "c/sqlite3.c"
           $800 = $799; //@line 81522 "c/sqlite3.c"
           HEAP32[$800>>2] = $796; //@line 81522 "c/sqlite3.c"
           switch ($793|0) {
           case 0:  {
            $cond107 = ($794|0)==(0);
            if ($cond107) {
             label = 119;
             break L90;
            } else {
             $801 = $793;$802 = $794;
            }
            break;
           }
           case -1:  {
            $cond = ($794|0)==(-1);
            if ($cond) {
             $801 = 1;$802 = 0;
            } else {
             $801 = $793;$802 = $794;
            }
            break;
           }
           default: {
            $801 = $793;$802 = $794;
           }
           }
           $803 = (___remdi3(($795|0),($796|0),($801|0),($802|0))|0); //@line 81525 "c/sqlite3.c"
           $804 = tempRet0; //@line 81525 "c/sqlite3.c"
           $805 = (+($803>>>0)) + (4294967296.0*(+($804|0))); //@line 81525 "c/sqlite3.c"
           $$02928 = $805;
          }
          }
          $806 = (_sqlite3IsNaN($$02928)|0); //@line 81533 "c/sqlite3.c"
          $807 = ($806|0)==(0); //@line 81533 "c/sqlite3.c"
          if ($807) {
           HEAPF64[$714>>3] = $$02928; //@line 81536 "c/sqlite3.c"
           $808 = (((($$02839) + (($713*40)|0)|0)) + 8|0); //@line 81537 "c/sqlite3.c"
           $809 = HEAP16[$808>>1]|0; //@line 81537 "c/sqlite3.c"
           $810 = $809 & 15872; //@line 81537 "c/sqlite3.c"
           $811 = $810 | 8; //@line 81537 "c/sqlite3.c"
           HEAP16[$808>>1] = $811; //@line 81537 "c/sqlite3.c"
           $812 = $711 | $707; //@line 81538 "c/sqlite3.c"
           $813 = $812 & 8; //@line 81538 "c/sqlite3.c"
           $814 = ($813<<16>>16)!=(0); //@line 81538 "c/sqlite3.c"
           $815 = ($$02925<<24>>24)!=(0); //@line 81538 "c/sqlite3.c"
           $or$cond6 = $814 | $815; //@line 81538 "c/sqlite3.c"
           if (!($or$cond6)) {
            _sqlite3VdbeIntegerAffinity($714); //@line 81539 "c/sqlite3.c"
           }
          } else {
           label = 119;
          }
         }
        } while(0);
        if ((label|0) == 119) {
         label = 0;
         _sqlite3VdbeMemSetNull($714); //@line 81546 "c/sqlite3.c"
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 79:  {
        $816 = ((($$02793)) + 4|0); //@line 81567 "c/sqlite3.c"
        $817 = HEAP32[$816>>2]|0; //@line 81567 "c/sqlite3.c"
        $818 = ($817|0)==(0); //@line 81567 "c/sqlite3.c"
        if ($818) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $819 = (($$02839) + (($817*40)|0)|0); //@line 81568 "c/sqlite3.c"
         _sqlite3VdbeMemSetInt64($819,0,0); //@line 81568 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 87: case 86: case 85: case 84:  {
        $820 = ((($$02793)) + 4|0); //@line 81612 "c/sqlite3.c"
        $821 = HEAP32[$820>>2]|0; //@line 81612 "c/sqlite3.c"
        $822 = ((($$02793)) + 8|0); //@line 81613 "c/sqlite3.c"
        $823 = HEAP32[$822>>2]|0; //@line 81613 "c/sqlite3.c"
        $824 = ((($$02793)) + 12|0); //@line 81614 "c/sqlite3.c"
        $825 = HEAP32[$824>>2]|0; //@line 81614 "c/sqlite3.c"
        $826 = (($$02839) + (($825*40)|0)|0); //@line 81614 "c/sqlite3.c"
        $827 = (((($$02839) + (($821*40)|0)|0)) + 8|0); //@line 81615 "c/sqlite3.c"
        $828 = HEAP16[$827>>1]|0; //@line 81615 "c/sqlite3.c"
        $829 = (((($$02839) + (($823*40)|0)|0)) + 8|0); //@line 81615 "c/sqlite3.c"
        $830 = HEAP16[$829>>1]|0; //@line 81615 "c/sqlite3.c"
        $831 = $830 | $828; //@line 81615 "c/sqlite3.c"
        $832 = $831 & 1; //@line 81615 "c/sqlite3.c"
        $833 = ($832<<16>>16)==(0); //@line 81615 "c/sqlite3.c"
        if (!($833)) {
         _sqlite3VdbeMemSetNull($826); //@line 81616 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        $834 = (($$02839) + (($823*40)|0)|0); //@line 81613 "c/sqlite3.c"
        $835 = (($$02839) + (($821*40)|0)|0); //@line 81612 "c/sqlite3.c"
        $836 = (_sqlite3VdbeIntValue($834)|0); //@line 81619 "c/sqlite3.c"
        $837 = tempRet0; //@line 81619 "c/sqlite3.c"
        $838 = (_sqlite3VdbeIntValue($835)|0); //@line 81620 "c/sqlite3.c"
        $839 = tempRet0; //@line 81620 "c/sqlite3.c"
        $840 = HEAP8[$$02793>>0]|0; //@line 81621 "c/sqlite3.c"
        $841 = $840&255; //@line 81622 "c/sqlite3.c"
        L116: do {
         switch ($840<<24>>24) {
         case 84:  {
          $842 = $838 & $836; //@line 81623 "c/sqlite3.c"
          $843 = $839 & $837; //@line 81623 "c/sqlite3.c"
          $889 = $842;$892 = $843;
          break;
         }
         case 85:  {
          $844 = $838 | $836; //@line 81625 "c/sqlite3.c"
          $845 = $839 | $837; //@line 81625 "c/sqlite3.c"
          $889 = $844;$892 = $845;
          break;
         }
         default: {
          $846 = ($838|0)==(0); //@line 81626 "c/sqlite3.c"
          $847 = ($839|0)==(0); //@line 81626 "c/sqlite3.c"
          $848 = $846 & $847; //@line 81626 "c/sqlite3.c"
          if ($848) {
           $889 = $836;$892 = $837;
          } else {
           $849 = ($839|0)<(0); //@line 81630 "c/sqlite3.c"
           $850 = (173 - ($841))|0; //@line 81632 "c/sqlite3.c"
           $851 = ($839|0)>(-1); //@line 81633 "c/sqlite3.c"
           $852 = ($838>>>0)>(4294967232); //@line 81633 "c/sqlite3.c"
           $853 = ($839|0)==(-1); //@line 81633 "c/sqlite3.c"
           $854 = $853 & $852; //@line 81633 "c/sqlite3.c"
           $855 = $851 | $854; //@line 81633 "c/sqlite3.c"
           $856 = (_i64Subtract(0,0,($838|0),($839|0))|0); //@line 81633 "c/sqlite3.c"
           $857 = tempRet0; //@line 81633 "c/sqlite3.c"
           $858 = $855 ? $856 : 64; //@line 81633 "c/sqlite3.c"
           $859 = $855 ? $857 : 0; //@line 81633 "c/sqlite3.c"
           $860 = $850&255; //@line 81632 "c/sqlite3.c"
           $$02933 = $849 ? $860 : $840; //@line 81630 "c/sqlite3.c"
           $861 = $849 ? $858 : $838; //@line 81630 "c/sqlite3.c"
           $862 = $849 ? $859 : $839; //@line 81630 "c/sqlite3.c"
           $863 = ($862|0)>(0); //@line 81636 "c/sqlite3.c"
           $864 = ($861>>>0)>(63); //@line 81636 "c/sqlite3.c"
           $865 = ($862|0)==(0); //@line 81636 "c/sqlite3.c"
           $866 = $865 & $864; //@line 81636 "c/sqlite3.c"
           $867 = $863 | $866; //@line 81636 "c/sqlite3.c"
           if ($867) {
            $868 = ($837|0)<(0); //@line 81637 "c/sqlite3.c"
            $869 = ($$02933<<24>>24)!=(86); //@line 81637 "c/sqlite3.c"
            $not$3014 = $868 & $869; //@line 81637 "c/sqlite3.c"
            $870 = $not$3014 << 31 >> 31; //@line 81637 "c/sqlite3.c"
            $871 = ($870|0)<(0); //@line 81637 "c/sqlite3.c"
            $872 = $871 << 31 >> 31; //@line 81637 "c/sqlite3.c"
            $889 = $870;$892 = $872;
            break L116;
           }
           $873 = ($$02933<<24>>24)==(86); //@line 81640 "c/sqlite3.c"
           if ($873) {
            $874 = (_bitshift64Shl(($836|0),($837|0),($861|0))|0); //@line 81641 "c/sqlite3.c"
            $875 = tempRet0; //@line 81641 "c/sqlite3.c"
            $889 = $874;$892 = $875;
            break L116;
           } else {
            $876 = (_bitshift64Lshr(($836|0),($837|0),($861|0))|0); //@line 81643 "c/sqlite3.c"
            $877 = tempRet0; //@line 81643 "c/sqlite3.c"
            $878 = ($837|0)<(0); //@line 81645 "c/sqlite3.c"
            $879 = (_i64Subtract(64,0,($861|0),($862|0))|0); //@line 81645 "c/sqlite3.c"
            $880 = tempRet0; //@line 81645 "c/sqlite3.c"
            $881 = (_bitshift64Shl(-1,-1,($879|0))|0); //@line 81645 "c/sqlite3.c"
            $882 = tempRet0; //@line 81645 "c/sqlite3.c"
            $883 = $878 ? $881 : 0; //@line 81645 "c/sqlite3.c"
            $884 = $878 ? $882 : 0; //@line 81645 "c/sqlite3.c"
            $885 = $883 | $876; //@line 81645 "c/sqlite3.c"
            $886 = $884 | $877; //@line 81645 "c/sqlite3.c"
            $889 = $885;$892 = $886;
            break L116;
           }
          }
         }
         }
        } while(0);
        $887 = $826; //@line 81650 "c/sqlite3.c"
        $888 = $887; //@line 81650 "c/sqlite3.c"
        HEAP32[$888>>2] = $889; //@line 81650 "c/sqlite3.c"
        $890 = (($887) + 4)|0; //@line 81650 "c/sqlite3.c"
        $891 = $890; //@line 81650 "c/sqlite3.c"
        HEAP32[$891>>2] = $892; //@line 81650 "c/sqlite3.c"
        $893 = (((($$02839) + (($825*40)|0)|0)) + 8|0); //@line 81651 "c/sqlite3.c"
        $894 = HEAP16[$893>>1]|0; //@line 81651 "c/sqlite3.c"
        $895 = $894 & 15872; //@line 81651 "c/sqlite3.c"
        $896 = $895 | 4; //@line 81651 "c/sqlite3.c"
        HEAP16[$893>>1] = $896; //@line 81651 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 80:  {
        $897 = ((($$02793)) + 4|0); //@line 81664 "c/sqlite3.c"
        $898 = HEAP32[$897>>2]|0; //@line 81664 "c/sqlite3.c"
        $899 = (($$02839) + (($898*40)|0)|0); //@line 81664 "c/sqlite3.c"
        _sqlite3VdbeMemIntegerify($899); //@line 81666 "c/sqlite3.c"
        $900 = ((($$02793)) + 8|0); //@line 81667 "c/sqlite3.c"
        $901 = HEAP32[$900>>2]|0; //@line 81667 "c/sqlite3.c"
        $902 = ($901|0)<(0); //@line 81667 "c/sqlite3.c"
        $903 = $902 << 31 >> 31; //@line 81667 "c/sqlite3.c"
        $904 = $899; //@line 81667 "c/sqlite3.c"
        $905 = $904; //@line 81667 "c/sqlite3.c"
        $906 = HEAP32[$905>>2]|0; //@line 81667 "c/sqlite3.c"
        $907 = (($904) + 4)|0; //@line 81667 "c/sqlite3.c"
        $908 = $907; //@line 81667 "c/sqlite3.c"
        $909 = HEAP32[$908>>2]|0; //@line 81667 "c/sqlite3.c"
        $910 = (_i64Add(($906|0),($909|0),($901|0),($903|0))|0); //@line 81667 "c/sqlite3.c"
        $911 = tempRet0; //@line 81667 "c/sqlite3.c"
        $912 = $899; //@line 81667 "c/sqlite3.c"
        $913 = $912; //@line 81667 "c/sqlite3.c"
        HEAP32[$913>>2] = $910; //@line 81667 "c/sqlite3.c"
        $914 = (($912) + 4)|0; //@line 81667 "c/sqlite3.c"
        $915 = $914; //@line 81667 "c/sqlite3.c"
        HEAP32[$915>>2] = $911; //@line 81667 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 17:  {
        $916 = ((($$02793)) + 4|0); //@line 81679 "c/sqlite3.c"
        $917 = HEAP32[$916>>2]|0; //@line 81679 "c/sqlite3.c"
        $918 = (((($$02839) + (($917*40)|0)|0)) + 8|0); //@line 81680 "c/sqlite3.c"
        $919 = HEAP16[$918>>1]|0; //@line 81680 "c/sqlite3.c"
        $920 = $919 & 4; //@line 81680 "c/sqlite3.c"
        $921 = ($920<<16>>16)==(0); //@line 81680 "c/sqlite3.c"
        if ($921) {
         $922 = (($$02839) + (($917*40)|0)|0); //@line 81679 "c/sqlite3.c"
         _applyAffinity($922,67,$10); //@line 81681 "c/sqlite3.c"
         $923 = HEAP16[$918>>1]|0; //@line 81683 "c/sqlite3.c"
         $924 = $923 & 4; //@line 81683 "c/sqlite3.c"
         $925 = ($924<<16>>16)==(0); //@line 81683 "c/sqlite3.c"
         if ($925) {
          $926 = ((($$02793)) + 8|0); //@line 81684 "c/sqlite3.c"
          $927 = HEAP32[$926>>2]|0; //@line 81684 "c/sqlite3.c"
          $928 = ($927|0)==(0); //@line 81684 "c/sqlite3.c"
          if ($928) {
           $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 20;$$9 = $$02793;
           break L1;
          } else {
           $$32804 = $$02801;
           label = 13;
           break L10;
          }
         }
        }
        $929 = HEAP16[$918>>1]|0; //@line 81692 "c/sqlite3.c"
        $930 = $929 & 15872; //@line 81692 "c/sqlite3.c"
        $931 = $930 | 4; //@line 81692 "c/sqlite3.c"
        HEAP16[$918>>1] = $931; //@line 81692 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 81:  {
        $932 = ((($$02793)) + 4|0); //@line 81707 "c/sqlite3.c"
        $933 = HEAP32[$932>>2]|0; //@line 81707 "c/sqlite3.c"
        $934 = (((($$02839) + (($933*40)|0)|0)) + 8|0); //@line 81708 "c/sqlite3.c"
        $935 = HEAP16[$934>>1]|0; //@line 81708 "c/sqlite3.c"
        $936 = $935 & 4; //@line 81708 "c/sqlite3.c"
        $937 = ($936<<16>>16)==(0); //@line 81708 "c/sqlite3.c"
        if ($937) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $938 = (($$02839) + (($933*40)|0)|0); //@line 81707 "c/sqlite3.c"
         _sqlite3VdbeMemRealify($938); //@line 81709 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 82:  {
        $939 = ((($$02793)) + 4|0); //@line 81738 "c/sqlite3.c"
        $940 = HEAP32[$939>>2]|0; //@line 81738 "c/sqlite3.c"
        $941 = (($$02839) + (($940*40)|0)|0); //@line 81738 "c/sqlite3.c"
        $942 = (((($$02839) + (($940*40)|0)|0)) + 8|0); //@line 81740 "c/sqlite3.c"
        $943 = HEAP16[$942>>1]|0; //@line 81740 "c/sqlite3.c"
        $944 = $943 & 16384; //@line 81740 "c/sqlite3.c"
        $945 = ($944<<16>>16)==(0); //@line 81740 "c/sqlite3.c"
        if ($945) {
         $951 = 0;
        } else {
         $946 = (_sqlite3VdbeMemExpandBlob($941)|0); //@line 81740 "c/sqlite3.c"
         $951 = $946;
        }
        $947 = ((($$02793)) + 8|0); //@line 81741 "c/sqlite3.c"
        $948 = HEAP32[$947>>2]|0; //@line 81741 "c/sqlite3.c"
        $949 = $948&255; //@line 81741 "c/sqlite3.c"
        _sqlite3VdbeMemCast($941,$949,$10); //@line 81741 "c/sqlite3.c"
        $950 = ($951|0)==(0); //@line 81743 "c/sqlite3.c"
        if ($950) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $951;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 57: case 54: case 55: case 56: case 52: case 53:  {
        $952 = ((($$02793)) + 4|0); //@line 81855 "c/sqlite3.c"
        $953 = HEAP32[$952>>2]|0; //@line 81855 "c/sqlite3.c"
        $954 = (($$02839) + (($953*40)|0)|0); //@line 81855 "c/sqlite3.c"
        $955 = ((($$02793)) + 12|0); //@line 81856 "c/sqlite3.c"
        $956 = HEAP32[$955>>2]|0; //@line 81856 "c/sqlite3.c"
        $957 = (($$02839) + (($956*40)|0)|0); //@line 81856 "c/sqlite3.c"
        $958 = (((($$02839) + (($953*40)|0)|0)) + 8|0); //@line 81857 "c/sqlite3.c"
        $959 = HEAP16[$958>>1]|0; //@line 81857 "c/sqlite3.c"
        $960 = (((($$02839) + (($956*40)|0)|0)) + 8|0); //@line 81858 "c/sqlite3.c"
        $961 = HEAP16[$960>>1]|0; //@line 81858 "c/sqlite3.c"
        $962 = $959&65535; //@line 81859 "c/sqlite3.c"
        $963 = $961&65535; //@line 81859 "c/sqlite3.c"
        $964 = $961 | $959; //@line 81859 "c/sqlite3.c"
        $965 = $964&65535; //@line 81859 "c/sqlite3.c"
        $966 = $965 & 1; //@line 81859 "c/sqlite3.c"
        $967 = ($966|0)==(0); //@line 81859 "c/sqlite3.c"
        $968 = ((($$02793)) + 2|0);
        $969 = HEAP16[$968>>1]|0;
        $970 = $969&65535;
        do {
         if ($967) {
          $988 = $970 & 71; //@line 81897 "c/sqlite3.c"
          $989 = ($988>>>0)>(66); //@line 81898 "c/sqlite3.c"
          if ($989) {
           $990 = $965 & 2; //@line 81899 "c/sqlite3.c"
           $991 = ($990|0)==(0); //@line 81899 "c/sqlite3.c"
           if ($991) {
            $$12940 = $961;
           } else {
            $992 = $962 & 14; //@line 81900 "c/sqlite3.c"
            $993 = ($992|0)==(2); //@line 81900 "c/sqlite3.c"
            if ($993) {
             _applyNumericAffinity($954,0); //@line 81901 "c/sqlite3.c"
             $994 = HEAP16[$960>>1]|0; //@line 81903 "c/sqlite3.c"
             $$02939 = $994;
            } else {
             $$02939 = $961;
            }
            $995 = $$02939 & 14; //@line 81905 "c/sqlite3.c"
            $996 = ($995<<16>>16)==(2); //@line 81905 "c/sqlite3.c"
            if ($996) {
             _applyNumericAffinity($957,0); //@line 81906 "c/sqlite3.c"
             $$12940 = $$02939;
            } else {
             $$12940 = $$02939;
            }
           }
           $997 = HEAP16[$958>>1]|0; //@line 81911 "c/sqlite3.c"
           $998 = HEAP16[$960>>1]|0; //@line 81911 "c/sqlite3.c"
           $999 = $997 & 4; //@line 81911 "c/sqlite3.c"
           $1000 = $999 & $998; //@line 81911 "c/sqlite3.c"
           $1001 = ($1000<<16>>16)==(0); //@line 81911 "c/sqlite3.c"
           if ($1001) {
            $$12937 = $959;$$22941 = $$12940;
            label = 164;
           } else {
            $1002 = $957; //@line 81912 "c/sqlite3.c"
            $1003 = $1002; //@line 81912 "c/sqlite3.c"
            $1004 = HEAP32[$1003>>2]|0; //@line 81912 "c/sqlite3.c"
            $1005 = (($1002) + 4)|0; //@line 81912 "c/sqlite3.c"
            $1006 = $1005; //@line 81912 "c/sqlite3.c"
            $1007 = HEAP32[$1006>>2]|0; //@line 81912 "c/sqlite3.c"
            $1008 = $954; //@line 81912 "c/sqlite3.c"
            $1009 = $1008; //@line 81912 "c/sqlite3.c"
            $1010 = HEAP32[$1009>>2]|0; //@line 81912 "c/sqlite3.c"
            $1011 = (($1008) + 4)|0; //@line 81912 "c/sqlite3.c"
            $1012 = $1011; //@line 81912 "c/sqlite3.c"
            $1013 = HEAP32[$1012>>2]|0; //@line 81912 "c/sqlite3.c"
            $1014 = ($1007|0)>($1013|0); //@line 81912 "c/sqlite3.c"
            $1015 = ($1004>>>0)>($1010>>>0); //@line 81912 "c/sqlite3.c"
            $1016 = ($1007|0)==($1013|0); //@line 81912 "c/sqlite3.c"
            $1017 = $1016 & $1015; //@line 81912 "c/sqlite3.c"
            $1018 = $1014 | $1017; //@line 81912 "c/sqlite3.c"
            $1019 = ($1007|0)<($1013|0); //@line 81913 "c/sqlite3.c"
            $1020 = ($1004>>>0)<($1010>>>0); //@line 81913 "c/sqlite3.c"
            $1021 = ($1007|0)==($1013|0); //@line 81913 "c/sqlite3.c"
            $1022 = $1021 & $1020; //@line 81913 "c/sqlite3.c"
            $1023 = $1019 | $1022; //@line 81913 "c/sqlite3.c"
            $$3018 = $1023 << 31 >> 31; //@line 81913 "c/sqlite3.c"
            if ($1018) {
             $$329423090$ph = $$12940;
             label = 168;
             break;
            } else {
             $$02934 = $$3018;$$22938 = $959;$$32942 = $$12940;
            }
           }
          } else {
           $1024 = ($988|0)==(66); //@line 81917 "c/sqlite3.c"
           if ($1024) {
            $1025 = $962 & 2; //@line 81918 "c/sqlite3.c"
            $1026 = ($1025|0)!=(0); //@line 81918 "c/sqlite3.c"
            $1027 = $962 & 12; //@line 81918 "c/sqlite3.c"
            $1028 = ($1027|0)==(0); //@line 81918 "c/sqlite3.c"
            $or$cond3020 = $1026 | $1028; //@line 81918 "c/sqlite3.c"
            if ($or$cond3020) {
             $$02936 = $959;
            } else {
             (_sqlite3VdbeMemStringify($954,$10,1)|0); //@line 81921 "c/sqlite3.c"
             $1029 = HEAP16[$958>>1]|0; //@line 81923 "c/sqlite3.c"
             $1030 = $1029 & 15872; //@line 81923 "c/sqlite3.c"
             $1031 = $1030&65535; //@line 81923 "c/sqlite3.c"
             $1032 = $962 & 49663; //@line 81923 "c/sqlite3.c"
             $1033 = $1032 | $1031; //@line 81923 "c/sqlite3.c"
             $1034 = $1033&65535; //@line 81923 "c/sqlite3.c"
             $$02936 = $1034;
            }
            $1035 = $963 & 2; //@line 81926 "c/sqlite3.c"
            $1036 = ($1035|0)!=(0); //@line 81926 "c/sqlite3.c"
            $1037 = $963 & 12; //@line 81926 "c/sqlite3.c"
            $1038 = ($1037|0)==(0); //@line 81926 "c/sqlite3.c"
            $or$cond3022 = $1036 | $1038; //@line 81926 "c/sqlite3.c"
            if ($or$cond3022) {
             $$12937 = $$02936;$$22941 = $961;
             label = 164;
            } else {
             (_sqlite3VdbeMemStringify($957,$10,1)|0); //@line 81929 "c/sqlite3.c"
             $1039 = HEAP16[$960>>1]|0; //@line 81931 "c/sqlite3.c"
             $1040 = $1039 & 15872; //@line 81931 "c/sqlite3.c"
             $1041 = $1040&65535; //@line 81931 "c/sqlite3.c"
             $1042 = $963 & 49663; //@line 81931 "c/sqlite3.c"
             $1043 = $1042 | $1041; //@line 81931 "c/sqlite3.c"
             $1044 = $1043&65535; //@line 81931 "c/sqlite3.c"
             $$12937 = $$02936;$$22941 = $1044;
             label = 164;
            }
           } else {
            $$12937 = $959;$$22941 = $961;
            label = 164;
           }
          }
          if ((label|0) == 164) {
           label = 0;
           $1045 = ((($$02793)) + 16|0); //@line 81935 "c/sqlite3.c"
           $1046 = HEAP32[$1045>>2]|0; //@line 81935 "c/sqlite3.c"
           $1047 = (_sqlite3MemCompare($957,$954,$1046)|0); //@line 81935 "c/sqlite3.c"
           $$02934 = $1047;$$22938 = $$12937;$$32942 = $$22941;
          }
          $1048 = ($$02934|0)<(0); //@line 81946 "c/sqlite3.c"
          if ($1048) {
           $1049 = HEAP8[$$02793>>0]|0; //@line 81948 "c/sqlite3.c"
           $1050 = $1049&255; //@line 81948 "c/sqlite3.c"
           $1051 = (($1050) + -52)|0; //@line 81948 "c/sqlite3.c"
           $1052 = (33708 + ($1051)|0); //@line 81948 "c/sqlite3.c"
           $$029343093 = $$02934;$$229383091 = $$22938;$$329423089 = $$32942;$$sink5212 = $1052;
           break;
          } else {
           $1059 = ($$02934|0)==(0); //@line 81949 "c/sqlite3.c"
           $1060 = HEAP8[$$02793>>0]|0;
           $1061 = $1060&255;
           $1062 = (($1061) + -52)|0;
           if ($1059) {
            $$2293830923261 = $$22938;$$3294230903262 = $$32942;$1064 = $1062;
            label = 170;
            break;
           } else {
            $$0293430943256 = $$02934;$$2293830923257 = $$22938;$$3294230903258 = $$32942;$1066 = $1062;
            label = 171;
            break;
           }
          }
         } else {
          $971 = $970 & 128; //@line 81861 "c/sqlite3.c"
          $972 = ($971|0)==(0); //@line 81861 "c/sqlite3.c"
          if (!($972)) {
           $973 = $959 & 1; //@line 81869 "c/sqlite3.c"
           $974 = $973 & $961; //@line 81869 "c/sqlite3.c"
           $975 = ($974<<16>>16)!=(0); //@line 81869 "c/sqlite3.c"
           $976 = $963 & 256; //@line 81870 "c/sqlite3.c"
           $977 = ($976|0)==(0); //@line 81870 "c/sqlite3.c"
           $or$cond3017 = $975 & $977; //@line 81870 "c/sqlite3.c"
           if (!($or$cond3017)) {
            $$329423090$ph = $961;
            label = 168;
            break;
           }
           $1053 = HEAP8[$$02793>>0]|0;
           $1054 = $1053&255;
           $1055 = (($1054) + -52)|0;
           $$2293830923261 = $959;$$3294230903262 = $961;$1064 = $1055;
           label = 170;
           break;
          }
          $978 = $970 & 32; //@line 81881 "c/sqlite3.c"
          $979 = ($978|0)==(0); //@line 81881 "c/sqlite3.c"
          if ($979) {
           $986 = $970 & 16; //@line 81889 "c/sqlite3.c"
           $987 = ($986|0)==(0); //@line 81889 "c/sqlite3.c"
           if ($987) {
            $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
            break L10;
           } else {
            $$32804 = $$02801;
            label = 13;
            break L10;
           }
          } else {
           $980 = ((($$02793)) + 8|0); //@line 81882 "c/sqlite3.c"
           $981 = HEAP32[$980>>2]|0; //@line 81882 "c/sqlite3.c"
           $982 = (((($$02839) + (($981*40)|0)|0)) + 8|0); //@line 81885 "c/sqlite3.c"
           $983 = HEAP16[$982>>1]|0; //@line 81885 "c/sqlite3.c"
           $984 = $983 & 15872; //@line 81885 "c/sqlite3.c"
           $985 = $984 | 1; //@line 81885 "c/sqlite3.c"
           HEAP16[$982>>1] = $985; //@line 81885 "c/sqlite3.c"
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = 1;$$8 = $$02793;$$87 = $$02801;
           break L10;
          }
         }
        } while(0);
        if ((label|0) == 168) {
         label = 0;
         $1056 = HEAP8[$$02793>>0]|0;
         $1057 = $1056&255;
         $1058 = (($1057) + -52)|0;
         $$0293430943256 = 1;$$2293830923257 = $959;$$3294230903258 = $$329423090$ph;$1066 = $1058;
         label = 171;
        }
        else if ((label|0) == 170) {
         label = 0;
         $1063 = (33714 + ($1064)|0); //@line 81951 "c/sqlite3.c"
         $$029343093 = 0;$$229383091 = $$2293830923261;$$329423089 = $$3294230903262;$$sink5212 = $1063;
        }
        if ((label|0) == 171) {
         label = 0;
         $1065 = (33720 + ($1066)|0); //@line 81954 "c/sqlite3.c"
         $$029343093 = $$0293430943256;$$229383091 = $$2293830923257;$$329423089 = $$3294230903258;$$sink5212 = $1065;
        }
        $1067 = HEAP8[$$sink5212>>0]|0;
        $1068 = $1067&255;
        HEAP16[$958>>1] = $$229383091; //@line 81959 "c/sqlite3.c"
        HEAP16[$960>>1] = $$329423089; //@line 81961 "c/sqlite3.c"
        $1069 = HEAP16[$968>>1]|0; //@line 81963 "c/sqlite3.c"
        $1070 = $1069&65535; //@line 81963 "c/sqlite3.c"
        $1071 = $1070 & 32; //@line 81963 "c/sqlite3.c"
        $1072 = ($1071|0)==(0); //@line 81963 "c/sqlite3.c"
        if ($1072) {
         $1091 = ($1067<<24>>24)==(0); //@line 81988 "c/sqlite3.c"
         if ($1091) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         } else {
          $$32804 = $$02801;
          label = 13;
          break L10;
         }
        }
        $1073 = ((($$02793)) + 8|0); //@line 81964 "c/sqlite3.c"
        $1074 = HEAP32[$1073>>2]|0; //@line 81964 "c/sqlite3.c"
        $1075 = $1070 & 8; //@line 81966 "c/sqlite3.c"
        $1076 = ($1075|0)==(0); //@line 81966 "c/sqlite3.c"
        if (!($1076)) {
         $1077 = HEAP8[$$02793>>0]|0; //@line 81980 "c/sqlite3.c"
         $1078 = ($1077<<24>>24)==(53); //@line 81980 "c/sqlite3.c"
         $1079 = $1078&1; //@line 81980 "c/sqlite3.c"
         $1080 = ($1068|0)==($1079|0); //@line 81980 "c/sqlite3.c"
         if ($1080) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$029343093;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
        }
        $1081 = (((($$02839) + (($1074*40)|0)|0)) + 8|0); //@line 81983 "c/sqlite3.c"
        $1082 = HEAP16[$1081>>1]|0; //@line 81983 "c/sqlite3.c"
        $1083 = $1082 & 15872; //@line 81983 "c/sqlite3.c"
        $1084 = $1083 | 4; //@line 81983 "c/sqlite3.c"
        HEAP16[$1081>>1] = $1084; //@line 81983 "c/sqlite3.c"
        $1085 = $1067&255; //@line 81984 "c/sqlite3.c"
        $1086 = (($$02839) + (($1074*40)|0)|0); //@line 81984 "c/sqlite3.c"
        $1087 = $1086; //@line 81984 "c/sqlite3.c"
        $1088 = $1087; //@line 81984 "c/sqlite3.c"
        HEAP32[$1088>>2] = $1085; //@line 81984 "c/sqlite3.c"
        $1089 = (($1087) + 4)|0; //@line 81984 "c/sqlite3.c"
        $1090 = $1089; //@line 81984 "c/sqlite3.c"
        HEAP32[$1090>>2] = 0; //@line 81984 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$029343093;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 58:  {
        $1092 = ($$02822|0)==(0); //@line 82008 "c/sqlite3.c"
        if ($1092) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = 0;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$32804 = $$02801;
         label = 13;
        }
        break;
       }
       case -90: case 62:  {
        $4176 = HEAP8[$40>>0]|0; //@line 87100 "c/sqlite3.c"
        $4177 = $4176 & -127; //@line 87100 "c/sqlite3.c"
        $4178 = ($4177<<24>>24)==(0); //@line 87100 "c/sqlite3.c"
        do {
         if (!($4178)) {
          $4179 = HEAPU8[$114>>0]|(HEAPU8[$114+1>>0]<<8); //@line 87101 "c/sqlite3.c"
          $4180 = $4179 & 2; //@line 87101 "c/sqlite3.c"
          $4181 = ($4180<<16>>16)==(0); //@line 87101 "c/sqlite3.c"
          if ($4181) {
           $4182 = ((($$02793)) + 16|0); //@line 87102 "c/sqlite3.c"
           $4183 = HEAP32[$4182>>2]|0; //@line 87102 "c/sqlite3.c"
           $4184 = ($4183|0)==(0|0); //@line 87102 "c/sqlite3.c"
           if ($4184) {
            $4185 = HEAP32[$169>>2]|0; //@line 87102 "c/sqlite3.c"
            $4186 = ($4185|0)==(0|0); //@line 87102 "c/sqlite3.c"
            if ($4186) {
             break;
            } else {
             $4189 = $4185;
            }
           } else {
            $4189 = $4183;
           }
           $4187 = ($4176<<24>>24)<(0); //@line 87105 "c/sqlite3.c"
           if ($4187) {
            $4188 = HEAP32[$191>>2]|0; //@line 87106 "c/sqlite3.c"
            $4190 = (_sqlite3VdbeExpandSql($0,$4189)|0); //@line 87107 "c/sqlite3.c"
            $4191 = HEAP32[$192>>2]|0; //@line 87108 "c/sqlite3.c"
            FUNCTION_TABLE_vii[$4188 & 127]($4191,$4190); //@line 87108 "c/sqlite3.c"
            _sqlite3_free($4190); //@line 87109 "c/sqlite3.c"
            break;
           }
           $4192 = HEAP32[$193>>2]|0; //@line 87112 "c/sqlite3.c"
           $4193 = ($4192|0)>(1); //@line 87112 "c/sqlite3.c"
           if ($4193) {
            HEAP32[$vararg_buffer46>>2] = $4189; //@line 87113 "c/sqlite3.c"
            $4194 = (_sqlite3MPrintf($8,27988,$vararg_buffer46)|0); //@line 87113 "c/sqlite3.c"
            $4195 = HEAP32[$207>>2]|0; //@line 87114 "c/sqlite3.c"
            $4196 = HEAP32[$208>>2]|0; //@line 87114 "c/sqlite3.c"
            (FUNCTION_TABLE_iiiii[$4195 & 127](1,$4196,$0,$4194)|0); //@line 87114 "c/sqlite3.c"
            _sqlite3DbFree($8,$4194); //@line 87115 "c/sqlite3.c"
            break;
           } else {
            $4197 = HEAP32[$209>>2]|0; //@line 87117 "c/sqlite3.c"
            $4198 = HEAP32[$210>>2]|0; //@line 87117 "c/sqlite3.c"
            (FUNCTION_TABLE_iiiii[$4197 & 127](1,$4198,$0,$4189)|0); //@line 87117 "c/sqlite3.c"
            break;
           }
          }
         }
        } while(0);
        $4199 = ((($$02793)) + 4|0); //@line 87139 "c/sqlite3.c"
        $4200 = HEAP32[$4199>>2]|0; //@line 87139 "c/sqlite3.c"
        $4201 = HEAP32[(276)>>2]|0; //@line 87139 "c/sqlite3.c"
        $4202 = ($4200|0)<($4201|0); //@line 87139 "c/sqlite3.c"
        if (!($4202)) {
         $4203 = HEAP8[$$02793>>0]|0; //@line 87140 "c/sqlite3.c"
         $4204 = ($4203<<24>>24)==(-90); //@line 87140 "c/sqlite3.c"
         if ($4204) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
         $4205 = HEAP32[$168>>2]|0; //@line 87141 "c/sqlite3.c"
         $4206 = ($4205|0)>(1); //@line 87141 "c/sqlite3.c"
         if ($4206) {
          $4207 = HEAP32[$6>>2]|0;
          $4208 = HEAP32[$168>>2]|0;
          $$028003839 = 1;
          while(1) {
           $4209 = (($4207) + (($$028003839*20)|0)|0); //@line 87142 "c/sqlite3.c"
           $4210 = HEAP8[$4209>>0]|0; //@line 87142 "c/sqlite3.c"
           $4211 = ($4210<<24>>24)==(20); //@line 87142 "c/sqlite3.c"
           if ($4211) {
            $4212 = (((($4207) + (($$028003839*20)|0)|0)) + 4|0); //@line 87142 "c/sqlite3.c"
            HEAP32[$4212>>2] = 0; //@line 87142 "c/sqlite3.c"
           }
           $4213 = (($$028003839) + 1)|0; //@line 87141 "c/sqlite3.c"
           $4214 = ($4213|0)<($4208|0); //@line 87141 "c/sqlite3.c"
           if ($4214) {
            $$028003839 = $4213;
           } else {
            break;
           }
          }
         }
         HEAP32[$4199>>2] = 0; //@line 87144 "c/sqlite3.c"
        }
        $4215 = HEAP32[$4199>>2]|0; //@line 87146 "c/sqlite3.c"
        $4216 = (($4215) + 1)|0; //@line 87146 "c/sqlite3.c"
        HEAP32[$4199>>2] = $4216; //@line 87146 "c/sqlite3.c"
        $4217 = HEAP32[$152>>2]|0; //@line 87147 "c/sqlite3.c"
        $4218 = (($4217) + 1)|0; //@line 87147 "c/sqlite3.c"
        HEAP32[$152>>2] = $4218; //@line 87147 "c/sqlite3.c"
        $$32804 = $$02801;
        label = 13;
        break;
       }
       case 94:  {
        $1093 = ((($$02793)) + 2|0); //@line 82064 "c/sqlite3.c"
        $1094 = HEAP16[$1093>>1]|0; //@line 82064 "c/sqlite3.c"
        $1095 = $1094 & 1; //@line 82064 "c/sqlite3.c"
        $1096 = ($1095<<16>>16)==(0); //@line 82064 "c/sqlite3.c"
        if ($1096) {
         $$02944 = 0;
        } else {
         $1097 = ((($$02793)) + -4|0); //@line 82070 "c/sqlite3.c"
         $1098 = HEAP32[$1097>>2]|0; //@line 82070 "c/sqlite3.c"
         $1099 = ((($1098)) + 4|0); //@line 82070 "c/sqlite3.c"
         $$02944 = $1099;
        }
        $1100 = ((($$02793)) + 12|0); //@line 82073 "c/sqlite3.c"
        $1101 = HEAP32[$1100>>2]|0; //@line 82073 "c/sqlite3.c"
        $1102 = ((($$02793)) + 16|0); //@line 82074 "c/sqlite3.c"
        $1103 = HEAP32[$1102>>2]|0; //@line 82074 "c/sqlite3.c"
        $1104 = ((($$02793)) + 4|0); //@line 82077 "c/sqlite3.c"
        $1105 = HEAP32[$1104>>2]|0; //@line 82077 "c/sqlite3.c"
        $1106 = ((($$02793)) + 8|0); //@line 82078 "c/sqlite3.c"
        $1107 = HEAP32[$1106>>2]|0; //@line 82078 "c/sqlite3.c"
        $1108 = ($1101|0)>(0); //@line 82090 "c/sqlite3.c"
        if ($1108) {
         $1109 = ($$02944|0)==(0|0);
         $1110 = ((($1103)) + 16|0);
         $$029433835 = 0;
         while(1) {
          if ($1109) {
           $1121 = $$029433835;
          } else {
           $1113 = (($$02944) + ($$029433835<<2)|0); //@line 82091 "c/sqlite3.c"
           $1114 = HEAP32[$1113>>2]|0; //@line 82091 "c/sqlite3.c"
           $1121 = $1114;
          }
          $1115 = (((($1103)) + 20|0) + ($$029433835<<2)|0); //@line 82097 "c/sqlite3.c"
          $1116 = HEAP32[$1115>>2]|0; //@line 82097 "c/sqlite3.c"
          $1117 = HEAP32[$1110>>2]|0; //@line 82098 "c/sqlite3.c"
          $1118 = (($1117) + ($$029433835)|0); //@line 82098 "c/sqlite3.c"
          $1119 = HEAP8[$1118>>0]|0; //@line 82098 "c/sqlite3.c"
          $1120 = (($1121) + ($1105))|0; //@line 82099 "c/sqlite3.c"
          $1122 = (($$02839) + (($1120*40)|0)|0); //@line 82099 "c/sqlite3.c"
          $1123 = (($1121) + ($1107))|0; //@line 82099 "c/sqlite3.c"
          $1124 = (($$02839) + (($1123*40)|0)|0); //@line 82099 "c/sqlite3.c"
          $1125 = (_sqlite3MemCompare($1122,$1124,$1116)|0); //@line 82099 "c/sqlite3.c"
          $1126 = ($1125|0)==(0); //@line 82100 "c/sqlite3.c"
          $1112 = (($$029433835) + 1)|0; //@line 82090 "c/sqlite3.c"
          if (!($1126)) {
           break;
          }
          $1111 = ($1112|0)<($1101|0); //@line 82090 "c/sqlite3.c"
          if ($1111) {
           $$029433835 = $1112;
          } else {
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = 0;$$8 = $$02793;$$87 = $$02801;
           break L10;
          }
         }
         $1127 = ($1119<<24>>24)==(0); //@line 82101 "c/sqlite3.c"
         $1128 = (0 - ($1125))|0; //@line 82101 "c/sqlite3.c"
         $spec$select = $1127 ? $1125 : $1128; //@line 82101 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $spec$select;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 18:  {
        $1129 = ($$02822|0)<(0); //@line 82115 "c/sqlite3.c"
        if ($1129) {
         $1130 = ((($$02793)) + 4|0); //@line 82116 "c/sqlite3.c"
         $1131 = HEAP32[$1130>>2]|0; //@line 82116 "c/sqlite3.c"
         $1132 = (($1131) + -1)|0; //@line 82116 "c/sqlite3.c"
         $1133 = (($$02792) + (($1132*20)|0)|0); //@line 82116 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $1133;$$87 = $$02801;
         break L10;
        }
        $1134 = ($$02822|0)==(0); //@line 82117 "c/sqlite3.c"
        if ($1134) {
         $1135 = ((($$02793)) + 8|0); //@line 82118 "c/sqlite3.c"
         $1136 = HEAP32[$1135>>2]|0; //@line 82118 "c/sqlite3.c"
         $1137 = (($1136) + -1)|0; //@line 82118 "c/sqlite3.c"
         $1138 = (($$02792) + (($1137*20)|0)|0); //@line 82118 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = 0;$$8 = $1138;$$87 = $$02801;
         break L10;
        } else {
         $1139 = ((($$02793)) + 12|0); //@line 82120 "c/sqlite3.c"
         $1140 = HEAP32[$1139>>2]|0; //@line 82120 "c/sqlite3.c"
         $1141 = (($1140) + -1)|0; //@line 82120 "c/sqlite3.c"
         $1142 = (($$02792) + (($1141*20)|0)|0); //@line 82120 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $1142;$$87 = $$02801;
         break L10;
        }
        break;
       }
       case 43: case 44:  {
        $1143 = ((($$02793)) + 4|0); //@line 82150 "c/sqlite3.c"
        $1144 = HEAP32[$1143>>2]|0; //@line 82150 "c/sqlite3.c"
        $1145 = (((($$02839) + (($1144*40)|0)|0)) + 8|0); //@line 82151 "c/sqlite3.c"
        $1146 = HEAP16[$1145>>1]|0; //@line 82151 "c/sqlite3.c"
        $1147 = $1146 & 1; //@line 82151 "c/sqlite3.c"
        $1148 = ($1147<<16>>16)==(0); //@line 82151 "c/sqlite3.c"
        if ($1148) {
         $1149 = (($$02839) + (($1144*40)|0)|0); //@line 82150 "c/sqlite3.c"
         $1150 = (_sqlite3VdbeIntValue($1149)|0); //@line 82154 "c/sqlite3.c"
         $1151 = tempRet0; //@line 82154 "c/sqlite3.c"
         $1152 = ($1150|0)!=(0); //@line 82154 "c/sqlite3.c"
         $1153 = ($1151|0)!=(0); //@line 82154 "c/sqlite3.c"
         $1154 = $1152 | $1153; //@line 82154 "c/sqlite3.c"
         $1155 = $1154&1; //@line 82154 "c/sqlite3.c"
         $$02945 = $1155;
        } else {
         $$02945 = 2;
        }
        $1156 = ((($$02793)) + 8|0); //@line 82156 "c/sqlite3.c"
        $1157 = HEAP32[$1156>>2]|0; //@line 82156 "c/sqlite3.c"
        $1158 = (((($$02839) + (($1157*40)|0)|0)) + 8|0); //@line 82157 "c/sqlite3.c"
        $1159 = HEAP16[$1158>>1]|0; //@line 82157 "c/sqlite3.c"
        $1160 = $1159 & 1; //@line 82157 "c/sqlite3.c"
        $1161 = ($1160<<16>>16)==(0); //@line 82157 "c/sqlite3.c"
        if ($1161) {
         $1162 = (($$02839) + (($1157*40)|0)|0); //@line 82156 "c/sqlite3.c"
         $1163 = (_sqlite3VdbeIntValue($1162)|0); //@line 82160 "c/sqlite3.c"
         $1164 = tempRet0; //@line 82160 "c/sqlite3.c"
         $1165 = ($1163|0)!=(0); //@line 82160 "c/sqlite3.c"
         $1166 = ($1164|0)!=(0); //@line 82160 "c/sqlite3.c"
         $1167 = $1165 | $1166; //@line 82160 "c/sqlite3.c"
         $1168 = $1167&1; //@line 82160 "c/sqlite3.c"
         $$02947 = $1168;
        } else {
         $$02947 = 2;
        }
        $1169 = HEAP8[$$02793>>0]|0; //@line 82162 "c/sqlite3.c"
        $1170 = ($1169<<24>>24)==(44); //@line 82162 "c/sqlite3.c"
        $1171 = ($$02945*3)|0;
        $1172 = (($$02947) + ($1171))|0;
        $sqlite3VdbeExec$or_logic$sink = $1170 ? 33726 : 33735; //@line 82162 "c/sqlite3.c"
        $1173 = (($sqlite3VdbeExec$or_logic$sink) + ($1172)|0);
        $1174 = HEAP8[$1173>>0]|0;
        $1175 = ((($$02793)) + 12|0); //@line 82169 "c/sqlite3.c"
        $1176 = HEAP32[$1175>>2]|0; //@line 82169 "c/sqlite3.c"
        $1177 = ($1174<<24>>24)==(2); //@line 82170 "c/sqlite3.c"
        if ($1177) {
         $1178 = (((($$02839) + (($1176*40)|0)|0)) + 8|0); //@line 82171 "c/sqlite3.c"
         $1179 = HEAP16[$1178>>1]|0; //@line 82171 "c/sqlite3.c"
         $1180 = $1179 & 15872; //@line 82171 "c/sqlite3.c"
         $1181 = $1180 | 1; //@line 82171 "c/sqlite3.c"
         HEAP16[$1178>>1] = $1181; //@line 82171 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        } else {
         $1182 = (($$02839) + (($1176*40)|0)|0); //@line 82169 "c/sqlite3.c"
         $1183 = $1174&255; //@line 82173 "c/sqlite3.c"
         $1184 = $1182; //@line 82173 "c/sqlite3.c"
         $1185 = $1184; //@line 82173 "c/sqlite3.c"
         HEAP32[$1185>>2] = $1183; //@line 82173 "c/sqlite3.c"
         $1186 = (($1184) + 4)|0; //@line 82173 "c/sqlite3.c"
         $1187 = $1186; //@line 82173 "c/sqlite3.c"
         HEAP32[$1187>>2] = 0; //@line 82173 "c/sqlite3.c"
         $1188 = (((($$02839) + (($1176*40)|0)|0)) + 8|0); //@line 82174 "c/sqlite3.c"
         $1189 = HEAP16[$1188>>1]|0; //@line 82174 "c/sqlite3.c"
         $1190 = $1189 & 15872; //@line 82174 "c/sqlite3.c"
         $1191 = $1190 | 4; //@line 82174 "c/sqlite3.c"
         HEAP16[$1188>>1] = $1191; //@line 82174 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        break;
       }
       case 19:  {
        $1192 = ((($$02793)) + 4|0); //@line 82187 "c/sqlite3.c"
        $1193 = HEAP32[$1192>>2]|0; //@line 82187 "c/sqlite3.c"
        $1194 = ((($$02793)) + 8|0); //@line 82188 "c/sqlite3.c"
        $1195 = HEAP32[$1194>>2]|0; //@line 82188 "c/sqlite3.c"
        $1196 = (($$02839) + (($1195*40)|0)|0); //@line 82188 "c/sqlite3.c"
        _sqlite3VdbeMemSetNull($1196); //@line 82189 "c/sqlite3.c"
        $1197 = (((($$02839) + (($1193*40)|0)|0)) + 8|0); //@line 82190 "c/sqlite3.c"
        $1198 = HEAP16[$1197>>1]|0; //@line 82190 "c/sqlite3.c"
        $1199 = $1198 & 1; //@line 82190 "c/sqlite3.c"
        $1200 = ($1199<<16>>16)==(0); //@line 82190 "c/sqlite3.c"
        if ($1200) {
         $1201 = (($$02839) + (($1193*40)|0)|0); //@line 82187 "c/sqlite3.c"
         $1202 = (((($$02839) + (($1195*40)|0)|0)) + 8|0); //@line 82191 "c/sqlite3.c"
         HEAP16[$1202>>1] = 4; //@line 82191 "c/sqlite3.c"
         $1203 = (_sqlite3VdbeIntValue($1201)|0); //@line 82192 "c/sqlite3.c"
         $1204 = tempRet0; //@line 82192 "c/sqlite3.c"
         $1205 = ($1203|0)==(0); //@line 82192 "c/sqlite3.c"
         $1206 = ($1204|0)==(0); //@line 82192 "c/sqlite3.c"
         $1207 = $1205 & $1206; //@line 82192 "c/sqlite3.c"
         $1208 = $1207&1; //@line 82192 "c/sqlite3.c"
         $1209 = $1196; //@line 82192 "c/sqlite3.c"
         $1210 = $1209; //@line 82192 "c/sqlite3.c"
         HEAP32[$1210>>2] = $1208; //@line 82192 "c/sqlite3.c"
         $1211 = (($1209) + 4)|0; //@line 82192 "c/sqlite3.c"
         $1212 = $1211; //@line 82192 "c/sqlite3.c"
         HEAP32[$1212>>2] = 0; //@line 82192 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 95:  {
        $1213 = ((($$02793)) + 4|0); //@line 82205 "c/sqlite3.c"
        $1214 = HEAP32[$1213>>2]|0; //@line 82205 "c/sqlite3.c"
        $1215 = ((($$02793)) + 8|0); //@line 82206 "c/sqlite3.c"
        $1216 = HEAP32[$1215>>2]|0; //@line 82206 "c/sqlite3.c"
        $1217 = (($$02839) + (($1216*40)|0)|0); //@line 82206 "c/sqlite3.c"
        _sqlite3VdbeMemSetNull($1217); //@line 82207 "c/sqlite3.c"
        $1218 = (((($$02839) + (($1214*40)|0)|0)) + 8|0); //@line 82208 "c/sqlite3.c"
        $1219 = HEAP16[$1218>>1]|0; //@line 82208 "c/sqlite3.c"
        $1220 = $1219 & 1; //@line 82208 "c/sqlite3.c"
        $1221 = ($1220<<16>>16)==(0); //@line 82208 "c/sqlite3.c"
        if ($1221) {
         $1222 = (((($$02839) + (($1216*40)|0)|0)) + 8|0); //@line 82209 "c/sqlite3.c"
         $1223 = (($$02839) + (($1214*40)|0)|0); //@line 82205 "c/sqlite3.c"
         HEAP16[$1222>>1] = 4; //@line 82209 "c/sqlite3.c"
         $1224 = (_sqlite3VdbeIntValue($1223)|0); //@line 82210 "c/sqlite3.c"
         $1225 = tempRet0; //@line 82210 "c/sqlite3.c"
         $1226 = $1224 ^ -1; //@line 82210 "c/sqlite3.c"
         $1227 = $1225 ^ -1; //@line 82210 "c/sqlite3.c"
         $1228 = $1217; //@line 82210 "c/sqlite3.c"
         $1229 = $1228; //@line 82210 "c/sqlite3.c"
         HEAP32[$1229>>2] = $1226; //@line 82210 "c/sqlite3.c"
         $1230 = (($1228) + 4)|0; //@line 82210 "c/sqlite3.c"
         $1231 = $1230; //@line 82210 "c/sqlite3.c"
         HEAP32[$1231>>2] = $1227; //@line 82210 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 20:  {
        $1232 = HEAP32[$41>>2]|0; //@line 82235 "c/sqlite3.c"
        $1233 = ($1232|0)==(0|0); //@line 82235 "c/sqlite3.c"
        if ($1233) {
         $1250 = HEAP32[$6>>2]|0; //@line 82243 "c/sqlite3.c"
         $1251 = ((($1250)) + 4|0); //@line 82243 "c/sqlite3.c"
         $1252 = HEAP32[$1251>>2]|0; //@line 82243 "c/sqlite3.c"
         $1253 = ((($$02793)) + 4|0); //@line 82243 "c/sqlite3.c"
         $1254 = HEAP32[$1253>>2]|0; //@line 82243 "c/sqlite3.c"
         $1255 = ($1252|0)==($1254|0); //@line 82243 "c/sqlite3.c"
         if ($1255) {
          $$32804 = $$02801;
          label = 13;
          break L10;
         }
        } else {
         $1234 = HEAP32[$6>>2]|0; //@line 82236 "c/sqlite3.c"
         $1235 = $$02793; //@line 82236 "c/sqlite3.c"
         $1236 = (($1235) - ($1234))|0; //@line 82236 "c/sqlite3.c"
         $1237 = (($1236|0) / 20)&-1; //@line 82236 "c/sqlite3.c"
         $1238 = ((($1232)) + 24|0); //@line 82237 "c/sqlite3.c"
         $1239 = HEAP32[$1238>>2]|0; //@line 82237 "c/sqlite3.c"
         $1240 = $1237 >>> 3; //@line 82237 "c/sqlite3.c"
         $1241 = (($1239) + ($1240)|0); //@line 82237 "c/sqlite3.c"
         $1242 = HEAP8[$1241>>0]|0; //@line 82237 "c/sqlite3.c"
         $1243 = $1242&255; //@line 82237 "c/sqlite3.c"
         $1244 = $1237 & 7; //@line 82237 "c/sqlite3.c"
         $1245 = 1 << $1244; //@line 82237 "c/sqlite3.c"
         $1246 = $1245 & $1243; //@line 82237 "c/sqlite3.c"
         $1247 = ($1246|0)==(0); //@line 82237 "c/sqlite3.c"
         if (!($1247)) {
          $$32804 = $$02801;
          label = 13;
          break L10;
         }
         $1248 = $1245 | $1243; //@line 82241 "c/sqlite3.c"
         $1249 = $1248&255; //@line 82241 "c/sqlite3.c"
         HEAP8[$1241>>0] = $1249; //@line 82241 "c/sqlite3.c"
        }
        $1256 = HEAP32[$6>>2]|0; //@line 82249 "c/sqlite3.c"
        $1257 = ((($1256)) + 4|0); //@line 82249 "c/sqlite3.c"
        $1258 = HEAP32[$1257>>2]|0; //@line 82249 "c/sqlite3.c"
        $1259 = ((($$02793)) + 4|0); //@line 82249 "c/sqlite3.c"
        HEAP32[$1259>>2] = $1258; //@line 82249 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 22: case 21:  {
        $1260 = ((($$02793)) + 4|0); //@line 82268 "c/sqlite3.c"
        $1261 = HEAP32[$1260>>2]|0; //@line 82268 "c/sqlite3.c"
        $1262 = (((($$02839) + (($1261*40)|0)|0)) + 8|0); //@line 82269 "c/sqlite3.c"
        $1263 = HEAP16[$1262>>1]|0; //@line 82269 "c/sqlite3.c"
        $1264 = $1263 & 1; //@line 82269 "c/sqlite3.c"
        $1265 = ($1264<<16>>16)==(0); //@line 82269 "c/sqlite3.c"
        if ($1265) {
         $1268 = (($$02839) + (($1261*40)|0)|0); //@line 82268 "c/sqlite3.c"
         $1269 = (+_sqlite3VdbeRealValue($1268)); //@line 82275 "c/sqlite3.c"
         $1270 = $1269 != 0.0; //@line 82275 "c/sqlite3.c"
         $1271 = HEAP8[$$02793>>0]|0; //@line 82277 "c/sqlite3.c"
         $1272 = ($1271<<24>>24)==(22); //@line 82277 "c/sqlite3.c"
         $spec$select3266$v = $1270 ^ $1272; //@line 82277 "c/sqlite3.c"
         $spec$select3266 = $spec$select3266$v&1; //@line 82277 "c/sqlite3.c"
         $$02948 = $spec$select3266;
        } else {
         $1266 = ((($$02793)) + 12|0); //@line 82270 "c/sqlite3.c"
         $1267 = HEAP32[$1266>>2]|0; //@line 82270 "c/sqlite3.c"
         $$02948 = $1267;
        }
        $1273 = ($$02948|0)==(0); //@line 82280 "c/sqlite3.c"
        if ($1273) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$32804 = $$02801;
         label = 13;
        }
        break;
       }
       case 50:  {
        $1274 = ((($$02793)) + 4|0); //@line 82292 "c/sqlite3.c"
        $1275 = HEAP32[$1274>>2]|0; //@line 82292 "c/sqlite3.c"
        $1276 = (((($$02839) + (($1275*40)|0)|0)) + 8|0); //@line 82294 "c/sqlite3.c"
        $1277 = HEAP16[$1276>>1]|0; //@line 82294 "c/sqlite3.c"
        $1278 = $1277 & 1; //@line 82294 "c/sqlite3.c"
        $1279 = ($1278<<16>>16)==(0); //@line 82294 "c/sqlite3.c"
        if ($1279) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$32804 = $$02801;
         label = 13;
        }
        break;
       }
       case 51:  {
        $1280 = ((($$02793)) + 4|0); //@line 82306 "c/sqlite3.c"
        $1281 = HEAP32[$1280>>2]|0; //@line 82306 "c/sqlite3.c"
        $1282 = (((($$02839) + (($1281*40)|0)|0)) + 8|0); //@line 82308 "c/sqlite3.c"
        $1283 = HEAP16[$1282>>1]|0; //@line 82308 "c/sqlite3.c"
        $1284 = $1283 & 1; //@line 82308 "c/sqlite3.c"
        $1285 = ($1284<<16>>16)==(0); //@line 82308 "c/sqlite3.c"
        if ($1285) {
         $$32804 = $$02801;
         label = 13;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 23:  {
        $1286 = HEAP32[$42>>2]|0; //@line 82325 "c/sqlite3.c"
        $1287 = ((($$02793)) + 4|0); //@line 82325 "c/sqlite3.c"
        $1288 = HEAP32[$1287>>2]|0; //@line 82325 "c/sqlite3.c"
        $1289 = (($1286) + ($1288<<2)|0); //@line 82325 "c/sqlite3.c"
        $1290 = HEAP32[$1289>>2]|0; //@line 82325 "c/sqlite3.c"
        $1291 = ((($1290)) + 2|0); //@line 82325 "c/sqlite3.c"
        $1292 = HEAP8[$1291>>0]|0; //@line 82325 "c/sqlite3.c"
        $1293 = ($1292<<24>>24)==(0); //@line 82325 "c/sqlite3.c"
        if ($1293) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $1294 = ((($$02793)) + 12|0); //@line 82326 "c/sqlite3.c"
         $1295 = HEAP32[$1294>>2]|0; //@line 82326 "c/sqlite3.c"
         $1296 = (($$02839) + (($1295*40)|0)|0); //@line 82326 "c/sqlite3.c"
         _sqlite3VdbeMemSetNull($1296); //@line 82326 "c/sqlite3.c"
         $$32804 = $$02801;
         label = 13;
        }
        break;
       }
       case 98:  {
        $1297 = HEAP32[$43>>2]|0; //@line 82403 "c/sqlite3.c"
        $1298 = ((($$02793)) + 4|0); //@line 82403 "c/sqlite3.c"
        $1299 = HEAP32[$1298>>2]|0; //@line 82403 "c/sqlite3.c"
        $1300 = (($1297) + ($1299<<2)|0); //@line 82403 "c/sqlite3.c"
        $1301 = HEAP32[$1300>>2]|0; //@line 82403 "c/sqlite3.c"
        HEAP32[$2>>2] = $1301; //@line 82403 "c/sqlite3.c"
        $1302 = ((($$02793)) + 8|0); //@line 82404 "c/sqlite3.c"
        $1303 = HEAP32[$1302>>2]|0; //@line 82404 "c/sqlite3.c"
        HEAP32[$1>>2] = $1303; //@line 82404 "c/sqlite3.c"
        $1304 = (_sqlite3VdbeCursorMoveto($2,$1)|0); //@line 82409 "c/sqlite3.c"
        $1305 = ($1304|0)==(0); //@line 82410 "c/sqlite3.c"
        if (!($1305)) {
         $$14$ph3100 = $1304;
         label = 275;
         break L8;
        }
        $1306 = ((($$02793)) + 12|0); //@line 82413 "c/sqlite3.c"
        $1307 = HEAP32[$1306>>2]|0; //@line 82413 "c/sqlite3.c"
        $1308 = (($$02839) + (($1307*40)|0)|0); //@line 82413 "c/sqlite3.c"
        $1309 = HEAP32[$2>>2]|0; //@line 82418 "c/sqlite3.c"
        $1310 = ((($1309)) + 72|0); //@line 82418 "c/sqlite3.c"
        $1311 = HEAP32[$1310>>2]|0; //@line 82418 "c/sqlite3.c"
        $1312 = ((($1309)) + 28|0); //@line 82423 "c/sqlite3.c"
        $1313 = HEAP32[$1312>>2]|0; //@line 82423 "c/sqlite3.c"
        $1314 = HEAP32[$115>>2]|0; //@line 82423 "c/sqlite3.c"
        $1315 = ($1313|0)==($1314|0); //@line 82423 "c/sqlite3.c"
        L262: do {
         if ($1315) {
          label = 231;
         } else {
          $1316 = ((($1309)) + 2|0); //@line 82424 "c/sqlite3.c"
          $1317 = HEAP8[$1316>>0]|0; //@line 82424 "c/sqlite3.c"
          $1318 = ($1317<<24>>24)==(0); //@line 82424 "c/sqlite3.c"
          do {
           if ($1318) {
            $1330 = ((($1309)) + 40|0); //@line 82439 "c/sqlite3.c"
            $1331 = HEAP32[$1330>>2]|0; //@line 82439 "c/sqlite3.c"
            $1332 = (_sqlite3BtreePayloadSize($1331)|0); //@line 82443 "c/sqlite3.c"
            $1333 = HEAP32[$2>>2]|0; //@line 82443 "c/sqlite3.c"
            $1334 = ((($1333)) + 80|0); //@line 82443 "c/sqlite3.c"
            HEAP32[$1334>>2] = $1332; //@line 82443 "c/sqlite3.c"
            $1335 = ((($1333)) + 84|0); //@line 82444 "c/sqlite3.c"
            $1336 = (_sqlite3BtreePayloadFetch($1331,$1335)|0); //@line 82444 "c/sqlite3.c"
            $1337 = ((($1333)) + 76|0); //@line 82444 "c/sqlite3.c"
            HEAP32[$1337>>2] = $1336; //@line 82444 "c/sqlite3.c"
            $1338 = ((($1333)) + 80|0); //@line 82447 "c/sqlite3.c"
            $1339 = HEAP32[$1338>>2]|0; //@line 82447 "c/sqlite3.c"
            $1340 = HEAP32[$170>>2]|0; //@line 82447 "c/sqlite3.c"
            $1341 = ($1339>>>0)>($1340>>>0); //@line 82447 "c/sqlite3.c"
            if ($1341) {
             label = 223;
             break L8;
            }
           } else {
            $1319 = HEAP8[$1309>>0]|0; //@line 82425 "c/sqlite3.c"
            $1320 = ($1319<<24>>24)==(3); //@line 82425 "c/sqlite3.c"
            if ($1320) {
             $1321 = ((($1309)) + 32|0); //@line 82429 "c/sqlite3.c"
             $1322 = HEAP32[$1321>>2]|0; //@line 82429 "c/sqlite3.c"
             $1323 = (((($$02839) + (($1322*40)|0)|0)) + 12|0); //@line 82432 "c/sqlite3.c"
             $1324 = HEAP32[$1323>>2]|0; //@line 82432 "c/sqlite3.c"
             $1325 = ((($1309)) + 84|0); //@line 82432 "c/sqlite3.c"
             HEAP32[$1325>>2] = $1324; //@line 82432 "c/sqlite3.c"
             $1326 = ((($1309)) + 80|0); //@line 82432 "c/sqlite3.c"
             HEAP32[$1326>>2] = $1324; //@line 82432 "c/sqlite3.c"
             $1327 = (((($$02839) + (($1322*40)|0)|0)) + 16|0); //@line 82433 "c/sqlite3.c"
             $1328 = HEAP32[$1327>>2]|0; //@line 82433 "c/sqlite3.c"
             $1329 = ((($1309)) + 76|0); //@line 82433 "c/sqlite3.c"
             HEAP32[$1329>>2] = $1328; //@line 82433 "c/sqlite3.c"
             break;
            } else {
             _sqlite3VdbeMemSetNull($1308); //@line 82435 "c/sqlite3.c"
             $$42797$ph = $$02793;
             break L262;
            }
           }
          } while(0);
          $1342 = HEAP32[$115>>2]|0; //@line 82451 "c/sqlite3.c"
          $1343 = HEAP32[$2>>2]|0; //@line 82451 "c/sqlite3.c"
          $1344 = ((($1343)) + 28|0); //@line 82451 "c/sqlite3.c"
          HEAP32[$1344>>2] = $1342; //@line 82451 "c/sqlite3.c"
          $1345 = ((($1343)) + 76|0); //@line 82452 "c/sqlite3.c"
          $1346 = HEAP32[$1345>>2]|0; //@line 82452 "c/sqlite3.c"
          $1347 = HEAP8[$1346>>0]|0; //@line 82452 "c/sqlite3.c"
          $1348 = ($1347<<24>>24)>(-1); //@line 82452 "c/sqlite3.c"
          if ($1348) {
           $1349 = $1347&255; //@line 82452 "c/sqlite3.c"
           HEAP32[$1311>>2] = $1349; //@line 82452 "c/sqlite3.c"
           $1354 = 1;
          } else {
           $1350 = (_sqlite3GetVarint32($1346,$1311)|0); //@line 82452 "c/sqlite3.c"
           $1351 = $1350&255; //@line 82452 "c/sqlite3.c"
           $1354 = $1351;
          }
          $1352 = HEAP32[$2>>2]|0; //@line 82452 "c/sqlite3.c"
          $1353 = ((($1352)) + 48|0); //@line 82452 "c/sqlite3.c"
          HEAP32[$1353>>2] = $1354; //@line 82452 "c/sqlite3.c"
          $1355 = ((($1352)) + 58|0); //@line 82453 "c/sqlite3.c"
          HEAP16[$1355>>1] = 0; //@line 82453 "c/sqlite3.c"
          $1356 = ((($1352)) + 84|0); //@line 82456 "c/sqlite3.c"
          $1357 = HEAP32[$1356>>2]|0; //@line 82456 "c/sqlite3.c"
          $1358 = HEAP32[$1311>>2]|0; //@line 82456 "c/sqlite3.c"
          $1359 = ($1357>>>0)<($1358>>>0); //@line 82456 "c/sqlite3.c"
          $1360 = ((($1352)) + 76|0);
          if (!($1359)) {
           $1366 = HEAP32[$1360>>2]|0; //@line 82490 "c/sqlite3.c"
           $$02951 = $1366;
           label = 236;
           break;
          }
          HEAP32[$1360>>2] = 0; //@line 82461 "c/sqlite3.c"
          HEAP32[$1356>>2] = 0; //@line 82462 "c/sqlite3.c"
          $1361 = HEAP32[$1311>>2]|0; //@line 82473 "c/sqlite3.c"
          $1362 = ($1361>>>0)>(98307); //@line 82473 "c/sqlite3.c"
          if ($1362) {
           label = 271;
          } else {
           $1363 = ((($1352)) + 80|0); //@line 82473 "c/sqlite3.c"
           $1364 = HEAP32[$1363>>2]|0; //@line 82473 "c/sqlite3.c"
           $1365 = ($1361>>>0)>($1364>>>0); //@line 82473 "c/sqlite3.c"
           if ($1365) {
            label = 271;
           } else {
            label = 231;
           }
          }
         }
        } while(0);
        do {
         if ((label|0) == 231) {
          label = 0;
          $1367 = HEAP32[$2>>2]|0; //@line 82500 "c/sqlite3.c"
          $1368 = ((($1367)) + 58|0); //@line 82500 "c/sqlite3.c"
          $1369 = HEAP16[$1368>>1]|0; //@line 82500 "c/sqlite3.c"
          $1370 = $1369&65535; //@line 82500 "c/sqlite3.c"
          $1371 = HEAP32[$1>>2]|0; //@line 82500 "c/sqlite3.c"
          $1372 = ($1371|0)<($1370|0); //@line 82500 "c/sqlite3.c"
          if ($1372) {
           $1460 = (((($1367)) + 88|0) + ($1371<<2)|0); //@line 82571 "c/sqlite3.c"
           $1461 = HEAP32[$1460>>2]|0; //@line 82571 "c/sqlite3.c"
           HEAP32[$4>>2] = $1461; //@line 82571 "c/sqlite3.c"
           label = 256;
           break;
          }
          $1373 = ((($1367)) + 48|0); //@line 82504 "c/sqlite3.c"
          $1374 = HEAP32[$1373>>2]|0; //@line 82504 "c/sqlite3.c"
          $1375 = HEAP32[$1311>>2]|0; //@line 82504 "c/sqlite3.c"
          $1376 = ($1374>>>0)<($1375>>>0); //@line 82504 "c/sqlite3.c"
          if (!($1376)) {
           HEAP32[$4>>2] = 0; //@line 82555 "c/sqlite3.c"
           label = 251;
           break;
          }
          $1377 = ((($1367)) + 76|0); //@line 82506 "c/sqlite3.c"
          $1378 = HEAP32[$1377>>2]|0; //@line 82506 "c/sqlite3.c"
          $1379 = ($1378|0)==(0|0); //@line 82506 "c/sqlite3.c"
          if ($1379) {
           dest=$3; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 82507 "c/sqlite3.c"
           $1380 = ((($1367)) + 40|0); //@line 82508 "c/sqlite3.c"
           $1381 = HEAP32[$1380>>2]|0; //@line 82508 "c/sqlite3.c"
           $1382 = HEAP32[$1311>>2]|0; //@line 82508 "c/sqlite3.c"
           $1383 = (_sqlite3VdbeMemFromBtree($1381,0,$1382,$3)|0); //@line 82508 "c/sqlite3.c"
           $1384 = ($1383|0)==(0); //@line 82509 "c/sqlite3.c"
           if (!($1384)) {
            $$14$ph3100 = $1383;
            label = 275;
            break L8;
           }
           $1385 = HEAP32[$218>>2]|0; //@line 82510 "c/sqlite3.c"
           $$02951 = $1385;
           label = 236;
          } else {
           $$02951 = $1378;
           label = 236;
          }
         }
        } while(0);
        do {
         if ((label|0) == 236) {
          label = 0;
          $1386 = HEAP32[$2>>2]|0; //@line 82517 "c/sqlite3.c"
          $1387 = ((($1386)) + 58|0); //@line 82517 "c/sqlite3.c"
          $1388 = HEAP16[$1387>>1]|0; //@line 82517 "c/sqlite3.c"
          $1389 = $1388&65535; //@line 82517 "c/sqlite3.c"
          $1390 = (($1311) + ($1389<<2)|0); //@line 82518 "c/sqlite3.c"
          $1391 = HEAP32[$1390>>2]|0; //@line 82518 "c/sqlite3.c"
          $1392 = ((($1386)) + 48|0); //@line 82519 "c/sqlite3.c"
          $1393 = HEAP32[$1392>>2]|0; //@line 82519 "c/sqlite3.c"
          $1394 = (($$02951) + ($1393)|0); //@line 82519 "c/sqlite3.c"
          $1395 = HEAP32[$1311>>2]|0; //@line 82520 "c/sqlite3.c"
          $1396 = (($$02951) + ($1395)|0); //@line 82520 "c/sqlite3.c"
          $$02949 = $1389;$$02952 = $1394;$1410 = $1391;$1411 = 0;
          while(1) {
           $1397 = HEAP8[$$02952>>0]|0; //@line 82523 "c/sqlite3.c"
           $1398 = $1397&255; //@line 82523 "c/sqlite3.c"
           HEAP32[$4>>2] = $1398; //@line 82523 "c/sqlite3.c"
           $1399 = ($1397<<24>>24)>(-1); //@line 82523 "c/sqlite3.c"
           if ($1399) {
            $1400 = ((($$02952)) + 1|0); //@line 82524 "c/sqlite3.c"
            $1401 = (_sqlite3VdbeOneByteSerialTypeLen($1397)|0); //@line 82525 "c/sqlite3.c"
            $1402 = $1401&255; //@line 82525 "c/sqlite3.c"
            $$12953 = $1400;$1408 = $1402;$1409 = 0;
           } else {
            $1403 = (_sqlite3GetVarint32($$02952,$4)|0); //@line 82527 "c/sqlite3.c"
            $1404 = $1403&255; //@line 82527 "c/sqlite3.c"
            $1405 = (($$02952) + ($1404)|0); //@line 82527 "c/sqlite3.c"
            $1406 = HEAP32[$4>>2]|0; //@line 82528 "c/sqlite3.c"
            $1407 = (_sqlite3VdbeSerialTypeLen($1406)|0); //@line 82528 "c/sqlite3.c"
            $$12953 = $1405;$1408 = $1407;$1409 = 0;
           }
           $1412 = (_i64Add(($1408|0),($1409|0),($1410|0),($1411|0))|0);
           $1413 = tempRet0;
           $1414 = HEAP32[$4>>2]|0; //@line 82530 "c/sqlite3.c"
           $1415 = HEAP32[$2>>2]|0; //@line 82530 "c/sqlite3.c"
           $1416 = (($$02949) + 1)|0; //@line 82530 "c/sqlite3.c"
           $1417 = (((($1415)) + 88|0) + ($$02949<<2)|0); //@line 82530 "c/sqlite3.c"
           HEAP32[$1417>>2] = $1414; //@line 82530 "c/sqlite3.c"
           $1418 = (($1311) + ($1416<<2)|0); //@line 82531 "c/sqlite3.c"
           HEAP32[$1418>>2] = $1412; //@line 82531 "c/sqlite3.c"
           $1419 = HEAP32[$1>>2]|0; //@line 82532 "c/sqlite3.c"
           $1420 = ($$02949|0)<($1419|0); //@line 82532 "c/sqlite3.c"
           $1421 = ($$12953>>>0)<($1396>>>0); //@line 82532 "c/sqlite3.c"
           $or$cond3025 = $1421 & $1420; //@line 82532 "c/sqlite3.c"
           if ($or$cond3025) {
            $$02949 = $1416;$$02952 = $$12953;$1410 = $1412;$1411 = $1413;
           } else {
            break;
           }
          }
          if ($1421) {
           label = 244;
          } else {
           $1422 = ($$12953>>>0)>($1396>>>0); //@line 82539 "c/sqlite3.c"
           if ($1422) {
            label = 245;
           } else {
            $1423 = ((($1415)) + 80|0); //@line 82539 "c/sqlite3.c"
            $1424 = HEAP32[$1423>>2]|0; //@line 82539 "c/sqlite3.c"
            $1425 = ($1412|0)==($1424|0); //@line 82539 "c/sqlite3.c"
            $1426 = ($1413|0)==(0); //@line 82539 "c/sqlite3.c"
            $1427 = $1425 & $1426; //@line 82539 "c/sqlite3.c"
            if ($1427) {
             label = 244;
            } else {
             label = 245;
            }
           }
          }
          if ((label|0) == 244) {
           label = 0;
           $1428 = ((($1415)) + 80|0); //@line 82540 "c/sqlite3.c"
           $1429 = HEAP32[$1428>>2]|0; //@line 82540 "c/sqlite3.c"
           $1430 = ($1413>>>0)>(0); //@line 82540 "c/sqlite3.c"
           $1431 = ($1412>>>0)>($1429>>>0); //@line 82540 "c/sqlite3.c"
           $1432 = ($1413|0)==(0); //@line 82540 "c/sqlite3.c"
           $1433 = $1432 & $1431; //@line 82540 "c/sqlite3.c"
           $1434 = $1430 | $1433; //@line 82540 "c/sqlite3.c"
           if ($1434) {
            label = 245;
           } else {
            $$12950 = $1416;$$22954 = $$12953;
           }
          }
          if ((label|0) == 245) {
           label = 0;
           $1435 = HEAP32[$1311>>2]|0; //@line 82542 "c/sqlite3.c"
           $1436 = ($1435|0)==(0); //@line 82542 "c/sqlite3.c"
           if ($1436) {
            $$12950 = 0;$$22954 = $1396;
           } else {
            $1437 = ((($1415)) + 76|0); //@line 82546 "c/sqlite3.c"
            $1438 = HEAP32[$1437>>2]|0; //@line 82546 "c/sqlite3.c"
            $1439 = ($1438|0)==(0|0); //@line 82546 "c/sqlite3.c"
            if (!($1439)) {
             label = 271;
             break;
            }
            _sqlite3VdbeMemRelease($3); //@line 82546 "c/sqlite3.c"
            label = 271;
            break;
           }
          }
          $1440 = $$12950&65535; //@line 82551 "c/sqlite3.c"
          $1441 = ((($1415)) + 58|0); //@line 82551 "c/sqlite3.c"
          HEAP16[$1441>>1] = $1440; //@line 82551 "c/sqlite3.c"
          $1442 = $$22954; //@line 82552 "c/sqlite3.c"
          $1443 = $$02951; //@line 82552 "c/sqlite3.c"
          $1444 = (($1442) - ($1443))|0; //@line 82552 "c/sqlite3.c"
          $1445 = ((($1415)) + 48|0); //@line 82552 "c/sqlite3.c"
          HEAP32[$1445>>2] = $1444; //@line 82552 "c/sqlite3.c"
          $1446 = ((($1415)) + 76|0); //@line 82553 "c/sqlite3.c"
          $1447 = HEAP32[$1446>>2]|0; //@line 82553 "c/sqlite3.c"
          $1448 = ($1447|0)==(0|0); //@line 82553 "c/sqlite3.c"
          if ($1448) {
           _sqlite3VdbeMemRelease($3); //@line 82553 "c/sqlite3.c"
           label = 251;
          } else {
           label = 251;
          }
         }
        } while(0);
        do {
         if ((label|0) == 251) {
          label = 0;
          $1449 = HEAP32[$2>>2]|0; //@line 82562 "c/sqlite3.c"
          $1450 = ((($1449)) + 58|0); //@line 82562 "c/sqlite3.c"
          $1451 = HEAP16[$1450>>1]|0; //@line 82562 "c/sqlite3.c"
          $1452 = $1451&65535; //@line 82562 "c/sqlite3.c"
          $1453 = HEAP32[$1>>2]|0; //@line 82562 "c/sqlite3.c"
          $1454 = ($1453|0)<($1452|0); //@line 82562 "c/sqlite3.c"
          if ($1454) {
           label = 256;
          } else {
           $1455 = ((($$02793)) + 1|0); //@line 82563 "c/sqlite3.c"
           $1456 = HEAP8[$1455>>0]|0; //@line 82563 "c/sqlite3.c"
           $1457 = ($1456<<24>>24)==(-11); //@line 82563 "c/sqlite3.c"
           if ($1457) {
            $1458 = ((($$02793)) + 16|0); //@line 82564 "c/sqlite3.c"
            $1459 = HEAP32[$1458>>2]|0; //@line 82564 "c/sqlite3.c"
            _sqlite3VdbeMemShallowCopy($1308,$1459,2048); //@line 82564 "c/sqlite3.c"
            $$42797$ph = $$02793;
            break;
           } else {
            _sqlite3VdbeMemSetNull($1308); //@line 82566 "c/sqlite3.c"
            $$42797$ph = $$02793;
            break;
           }
          }
         }
         else if ((label|0) == 271) {
          label = 0;
          $1529 = ((($$02792)) + 12|0); //@line 82644 "c/sqlite3.c"
          $1530 = HEAP32[$1529>>2]|0; //@line 82644 "c/sqlite3.c"
          $1531 = ($1530|0)>(0); //@line 82644 "c/sqlite3.c"
          if (!($1531)) {
           label = 273;
           break L8;
          }
          $1532 = (($1530) + -1)|0; //@line 82645 "c/sqlite3.c"
          $1533 = (($$02792) + (($1532*20)|0)|0); //@line 82645 "c/sqlite3.c"
          $$42797$ph = $1533;
         }
        } while(0);
        do {
         if ((label|0) == 256) {
          label = 0;
          $1462 = (((($$02839) + (($1307*40)|0)|0)) + 8|0); //@line 82581 "c/sqlite3.c"
          $1463 = HEAP16[$1462>>1]|0; //@line 82581 "c/sqlite3.c"
          $1464 = $1463 & 9312; //@line 82581 "c/sqlite3.c"
          $1465 = ($1464<<16>>16)==(0); //@line 82581 "c/sqlite3.c"
          if (!($1465)) {
           _sqlite3VdbeMemSetNull($1308); //@line 82582 "c/sqlite3.c"
          }
          $1466 = HEAP32[$2>>2]|0; //@line 82585 "c/sqlite3.c"
          $1467 = ((($1466)) + 84|0); //@line 82585 "c/sqlite3.c"
          $1468 = HEAP32[$1467>>2]|0; //@line 82585 "c/sqlite3.c"
          $1469 = HEAP32[$1>>2]|0; //@line 82585 "c/sqlite3.c"
          $1470 = (($1469) + 1)|0; //@line 82585 "c/sqlite3.c"
          $1471 = (($1311) + ($1470<<2)|0); //@line 82585 "c/sqlite3.c"
          $1472 = HEAP32[$1471>>2]|0; //@line 82585 "c/sqlite3.c"
          $1473 = ($1468>>>0)<($1472>>>0); //@line 82585 "c/sqlite3.c"
          if ($1473) {
           $1504 = (((($$02839) + (($1307*40)|0)|0)) + 10|0); //@line 82611 "c/sqlite3.c"
           HEAP8[$1504>>0] = $10; //@line 82611 "c/sqlite3.c"
           $1505 = ((($$02793)) + 2|0); //@line 82613 "c/sqlite3.c"
           $1506 = HEAP16[$1505>>1]|0; //@line 82613 "c/sqlite3.c"
           $1507 = $1506 & 192; //@line 82613 "c/sqlite3.c"
           $1508 = ($1507<<16>>16)==(0); //@line 82613 "c/sqlite3.c"
           if ($1508) {
            label = 267;
           } else {
            $1509 = HEAP32[$4>>2]|0; //@line 82614 "c/sqlite3.c"
            $1510 = ($1509>>>0)<(12); //@line 82614 "c/sqlite3.c"
            $1511 = $1509 & 1; //@line 82614 "c/sqlite3.c"
            $1512 = ($1511|0)!=(0); //@line 82614 "c/sqlite3.c"
            $or$cond3027$not = $1510 | $1512; //@line 82614 "c/sqlite3.c"
            $1513 = $1506 & 128; //@line 82614 "c/sqlite3.c"
            $1514 = ($1513<<16>>16)==(0); //@line 82614 "c/sqlite3.c"
            $or$cond3268 = $1514 & $or$cond3027$not; //@line 82614 "c/sqlite3.c"
            if ($or$cond3268) {
             label = 267;
            }
           }
           if ((label|0) == 267) {
            label = 0;
            $1515 = HEAP32[$4>>2]|0; //@line 82615 "c/sqlite3.c"
            $1516 = (_sqlite3VdbeSerialTypeLen($1515)|0); //@line 82615 "c/sqlite3.c"
            $1517 = ($1516|0)==(0); //@line 82615 "c/sqlite3.c"
            if (!($1517)) {
             $1519 = ((($1466)) + 40|0); //@line 82631 "c/sqlite3.c"
             $1520 = HEAP32[$1519>>2]|0; //@line 82631 "c/sqlite3.c"
             $1521 = (($1311) + ($1469<<2)|0); //@line 82631 "c/sqlite3.c"
             $1522 = HEAP32[$1521>>2]|0; //@line 82631 "c/sqlite3.c"
             $1523 = (_sqlite3VdbeMemFromBtree($1520,$1522,$1516,$1308)|0); //@line 82631 "c/sqlite3.c"
             $1524 = ($1523|0)==(0); //@line 82632 "c/sqlite3.c"
             if (!($1524)) {
              $$14$ph3100 = $1523;
              label = 275;
              break L8;
             }
             $1525 = (((($$02839) + (($1307*40)|0)|0)) + 16|0); //@line 82633 "c/sqlite3.c"
             $1526 = HEAP32[$1525>>2]|0; //@line 82633 "c/sqlite3.c"
             (_sqlite3VdbeSerialGet($1526,$1515,$1308)|0); //@line 82633 "c/sqlite3.c"
             $1527 = HEAP16[$1462>>1]|0; //@line 82634 "c/sqlite3.c"
             $1528 = $1527 & -4097; //@line 82634 "c/sqlite3.c"
             HEAP16[$1462>>1] = $1528; //@line 82634 "c/sqlite3.c"
             $$42797$ph = $$02793;
             break;
            }
           }
           $1518 = HEAP32[$4>>2]|0; //@line 82629 "c/sqlite3.c"
           (_sqlite3VdbeSerialGet(41677,$1518,$1308)|0); //@line 82629 "c/sqlite3.c"
           $$42797$ph = $$02793;
           break;
          } else {
           $1474 = ((($1466)) + 76|0); //@line 82588 "c/sqlite3.c"
           $1475 = HEAP32[$1474>>2]|0; //@line 82588 "c/sqlite3.c"
           $1476 = (($1311) + ($1469<<2)|0); //@line 82588 "c/sqlite3.c"
           $1477 = HEAP32[$1476>>2]|0; //@line 82588 "c/sqlite3.c"
           $1478 = (($1475) + ($1477)|0); //@line 82588 "c/sqlite3.c"
           $1479 = HEAP32[$4>>2]|0; //@line 82589 "c/sqlite3.c"
           $1480 = ($1479>>>0)<(12); //@line 82589 "c/sqlite3.c"
           if ($1480) {
            (_sqlite3VdbeSerialGet($1478,$1479,$1308)|0); //@line 82590 "c/sqlite3.c"
            $$42797$ph = $$02793;
            break;
           }
           $1481 = (($1479) + -12)|0; //@line 82597 "c/sqlite3.c"
           $1482 = $1481 >>> 1; //@line 82597 "c/sqlite3.c"
           $1483 = (((($$02839) + (($1307*40)|0)|0)) + 12|0); //@line 82597 "c/sqlite3.c"
           HEAP32[$1483>>2] = $1482; //@line 82597 "c/sqlite3.c"
           $1484 = (((($$02839) + (($1307*40)|0)|0)) + 10|0); //@line 82598 "c/sqlite3.c"
           HEAP8[$1484>>0] = $10; //@line 82598 "c/sqlite3.c"
           $1485 = (((($$02839) + (($1307*40)|0)|0)) + 24|0); //@line 82599 "c/sqlite3.c"
           $1486 = HEAP32[$1485>>2]|0; //@line 82599 "c/sqlite3.c"
           $1487 = (($1482) + 2)|0; //@line 82599 "c/sqlite3.c"
           $1488 = ($1486|0)<($1487|0); //@line 82599 "c/sqlite3.c"
           if ($1488) {
            HEAP16[$1462>>1] = 1; //@line 82600 "c/sqlite3.c"
            $1489 = (_sqlite3VdbeMemGrow($1308,$1487,0)|0); //@line 82601 "c/sqlite3.c"
            $1490 = ($1489|0)==(0); //@line 82601 "c/sqlite3.c"
            if (!($1490)) {
             label = 276;
             break L8;
            }
           } else {
            $1491 = (((($$02839) + (($1307*40)|0)|0)) + 20|0); //@line 82603 "c/sqlite3.c"
            $1492 = HEAP32[$1491>>2]|0; //@line 82603 "c/sqlite3.c"
            $1493 = (((($$02839) + (($1307*40)|0)|0)) + 16|0); //@line 82603 "c/sqlite3.c"
            HEAP32[$1493>>2] = $1492; //@line 82603 "c/sqlite3.c"
           }
           $1494 = (((($$02839) + (($1307*40)|0)|0)) + 16|0); //@line 82605 "c/sqlite3.c"
           $1495 = HEAP32[$1494>>2]|0; //@line 82605 "c/sqlite3.c"
           _memcpy(($1495|0),($1478|0),($1482|0))|0; //@line 82605 "c/sqlite3.c"
           $1496 = HEAP32[$1494>>2]|0; //@line 82606 "c/sqlite3.c"
           $1497 = (($1496) + ($1482)|0); //@line 82606 "c/sqlite3.c"
           HEAP8[$1497>>0] = 0; //@line 82606 "c/sqlite3.c"
           $1498 = HEAP32[$1494>>2]|0; //@line 82607 "c/sqlite3.c"
           $1499 = (($1482) + 1)|0; //@line 82607 "c/sqlite3.c"
           $1500 = (($1498) + ($1499)|0); //@line 82607 "c/sqlite3.c"
           HEAP8[$1500>>0] = 0; //@line 82607 "c/sqlite3.c"
           $1501 = $1479 & 1; //@line 82608 "c/sqlite3.c"
           $1502 = (13838 + ($1501<<1)|0); //@line 82608 "c/sqlite3.c"
           $1503 = HEAP16[$1502>>1]|0; //@line 82608 "c/sqlite3.c"
           HEAP16[$1462>>1] = $1503; //@line 82608 "c/sqlite3.c"
           $$42797$ph = $$02793;
           break;
          }
         }
        } while(0);
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$42797$ph;$$87 = 0;
        break;
       }
       case 99:  {
        $1535 = ((($$02793)) + 16|0); //@line 82665 "c/sqlite3.c"
        $1536 = HEAP32[$1535>>2]|0; //@line 82665 "c/sqlite3.c"
        $1537 = ((($$02793)) + 4|0); //@line 82669 "c/sqlite3.c"
        $1538 = HEAP32[$1537>>2]|0; //@line 82669 "c/sqlite3.c"
        $1539 = (($$02839) + (($1538*40)|0)|0); //@line 82669 "c/sqlite3.c"
        $$02957 = $1536;$$22846 = $1539;
        while(1) {
         $1540 = ((($$02957)) + 1|0); //@line 82673 "c/sqlite3.c"
         $1541 = HEAP8[$$02957>>0]|0; //@line 82673 "c/sqlite3.c"
         _applyAffinity($$22846,$1541,$10); //@line 82673 "c/sqlite3.c"
         $1542 = ((($$22846)) + 40|0); //@line 82674 "c/sqlite3.c"
         $1543 = HEAP8[$1540>>0]|0; //@line 82675 "c/sqlite3.c"
         $1544 = ($1543<<24>>24)==(0); //@line 82675 "c/sqlite3.c"
         if ($1544) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break;
         } else {
          $$02957 = $1540;$$22846 = $1542;
         }
        }
        break;
       }
       case 100:  {
        $1545 = ((($$02793)) + 4|0); //@line 82731 "c/sqlite3.c"
        $1546 = HEAP32[$1545>>2]|0; //@line 82731 "c/sqlite3.c"
        $1547 = ((($$02793)) + 16|0); //@line 82732 "c/sqlite3.c"
        $1548 = HEAP32[$1547>>2]|0; //@line 82732 "c/sqlite3.c"
        $1549 = (($$02839) + (($1546*40)|0)|0); //@line 82734 "c/sqlite3.c"
        $1550 = ((($$02793)) + 8|0); //@line 82735 "c/sqlite3.c"
        $1551 = HEAP32[$1550>>2]|0; //@line 82735 "c/sqlite3.c"
        $1552 = (($1551) + -1)|0; //@line 82736 "c/sqlite3.c"
        $1553 = (($1549) + (($1552*40)|0)|0); //@line 82736 "c/sqlite3.c"
        $1554 = HEAP8[$44>>0]|0; //@line 82737 "c/sqlite3.c"
        $1555 = $1554&255; //@line 82737 "c/sqlite3.c"
        $1556 = ((($$02793)) + 12|0); //@line 82741 "c/sqlite3.c"
        $1557 = HEAP32[$1556>>2]|0; //@line 82741 "c/sqlite3.c"
        $1558 = (($$02839) + (($1557*40)|0)|0); //@line 82741 "c/sqlite3.c"
        $1559 = ($1548|0)==(0|0); //@line 82747 "c/sqlite3.c"
        if (!($1559)) {
         $$02962 = $1549;$$02974 = $1548;
         while(1) {
          $1560 = ((($$02962)) + 40|0); //@line 82750 "c/sqlite3.c"
          $1561 = ((($$02974)) + 1|0); //@line 82750 "c/sqlite3.c"
          $1562 = HEAP8[$$02974>>0]|0; //@line 82750 "c/sqlite3.c"
          _applyAffinity($$02962,$1562,$10); //@line 82750 "c/sqlite3.c"
          $1563 = HEAP8[$1561>>0]|0; //@line 82752 "c/sqlite3.c"
          $1564 = ($1563<<24>>24)==(0); //@line 82752 "c/sqlite3.c"
          if ($1564) {
           break;
          } else {
           $$02962 = $1560;$$02974 = $1561;
          }
         }
        }
        $$02968 = 0;$$12963 = $1553;$1572 = 0;$1573 = 0;$1584 = 0;$1585 = 0;
        while(1) {
         $1565 = (_sqlite3VdbeSerialType($$12963,$1555,$1)|0); //@line 82775 "c/sqlite3.c"
         $1566 = ((($$12963)) + 8|0); //@line 82776 "c/sqlite3.c"
         $1567 = HEAP16[$1566>>1]|0; //@line 82776 "c/sqlite3.c"
         $1568 = $1567 & 16384; //@line 82776 "c/sqlite3.c"
         $1569 = ($1568<<16>>16)==(0); //@line 82776 "c/sqlite3.c"
         do {
          if ($1569) {
           $4247 = $1584;$4248 = $1585;
           label = 289;
          } else {
           $1570 = ($1565|0)==(0); //@line 82777 "c/sqlite3.c"
           if ($1570) {
            $1571 = HEAP32[$1>>2]|0; //@line 82793 "c/sqlite3.c"
            $1574 = (_i64Add(($1572|0),($1573|0),($1571|0),0)|0); //@line 82793 "c/sqlite3.c"
            $1575 = tempRet0; //@line 82793 "c/sqlite3.c"
            $$029723104 = 10;$1596 = 1;$1613 = $1574;$1614 = $1575;$1617 = $1584;$1618 = $1585;
            break;
           }
           $1576 = ($1572|0)==(0); //@line 82786 "c/sqlite3.c"
           $1577 = ($1573|0)==(0); //@line 82786 "c/sqlite3.c"
           $1578 = $1576 & $1577; //@line 82786 "c/sqlite3.c"
           if ($1578) {
            $1581 = HEAP32[$$12963>>2]|0; //@line 82789 "c/sqlite3.c"
            $1582 = ($1581|0)<(0); //@line 82789 "c/sqlite3.c"
            $1583 = $1582 << 31 >> 31; //@line 82789 "c/sqlite3.c"
            $1586 = (_i64Add(($1584|0),($1585|0),($1581|0),($1583|0))|0); //@line 82789 "c/sqlite3.c"
            $1587 = tempRet0; //@line 82789 "c/sqlite3.c"
            $1588 = HEAP32[$1>>2]|0; //@line 82790 "c/sqlite3.c"
            $1589 = (($1588) - ($1581))|0; //@line 82790 "c/sqlite3.c"
            HEAP32[$1>>2] = $1589; //@line 82790 "c/sqlite3.c"
            $4247 = $1586;$4248 = $1587;
            label = 289;
            break;
           } else {
            $1579 = (_sqlite3VdbeMemExpandBlob($$12963)|0); //@line 82787 "c/sqlite3.c"
            $1580 = ($1579|0)==(0); //@line 82787 "c/sqlite3.c"
            if ($1580) {
             $4247 = $1584;$4248 = $1585;
             label = 289;
             break;
            } else {
             label = 308;
             break L8;
            }
           }
          }
         } while(0);
         if ((label|0) == 289) {
          label = 0;
          $1590 = HEAP32[$1>>2]|0; //@line 82793 "c/sqlite3.c"
          $1591 = (_i64Add(($1572|0),($1573|0),($1590|0),0)|0); //@line 82793 "c/sqlite3.c"
          $1592 = tempRet0; //@line 82793 "c/sqlite3.c"
          $1593 = ($1565>>>0)<(128); //@line 82796 "c/sqlite3.c"
          if ($1593) {
           $$029723104 = $1565;$1596 = 1;$1613 = $1591;$1614 = $1592;$1617 = $4247;$1618 = $4248;
          } else {
           $1594 = (_sqlite3VarintLen($1565,0)|0); //@line 82796 "c/sqlite3.c"
           $$029723104 = $1565;$1596 = $1594;$1613 = $1591;$1614 = $1592;$1617 = $4247;$1618 = $4248;
          }
         }
         $1595 = (($1596) + ($$02968))|0; //@line 82796 "c/sqlite3.c"
         $1597 = ((($$12963)) + 28|0); //@line 82797 "c/sqlite3.c"
         HEAP32[$1597>>2] = $$029723104; //@line 82797 "c/sqlite3.c"
         $1598 = ($$12963|0)==($1549|0); //@line 82798 "c/sqlite3.c"
         $1599 = ((($$12963)) + -40|0); //@line 82799 "c/sqlite3.c"
         if ($1598) {
          break;
         } else {
          $$02968 = $1595;$$12963 = $1599;$1572 = $1613;$1573 = $1614;$1584 = $1617;$1585 = $1618;
         }
        }
        $1600 = ($1595|0)<(127); //@line 82808 "c/sqlite3.c"
        if ($1600) {
         $1601 = (($1595) + 1)|0; //@line 82810 "c/sqlite3.c"
         $$12969 = $1601;
        } else {
         $1602 = ($1595|0)<(0); //@line 82813 "c/sqlite3.c"
         $1603 = $1602 << 31 >> 31; //@line 82813 "c/sqlite3.c"
         $1604 = (_sqlite3VarintLen($1595,$1603)|0); //@line 82813 "c/sqlite3.c"
         $1605 = (($1604) + ($1595))|0; //@line 82814 "c/sqlite3.c"
         $1606 = ($1605|0)<(0); //@line 82815 "c/sqlite3.c"
         $1607 = $1606 << 31 >> 31; //@line 82815 "c/sqlite3.c"
         $1608 = (_sqlite3VarintLen($1605,$1607)|0); //@line 82815 "c/sqlite3.c"
         $1609 = ($1604|0)<($1608|0); //@line 82815 "c/sqlite3.c"
         $1610 = $1609&1; //@line 82815 "c/sqlite3.c"
         $spec$select3028 = (($1605) + ($1610))|0; //@line 82815 "c/sqlite3.c"
         $$12969 = $spec$select3028;
        }
        $1611 = ($$12969|0)<(0); //@line 82817 "c/sqlite3.c"
        $1612 = $1611 << 31 >> 31; //@line 82817 "c/sqlite3.c"
        $1615 = (_i64Add(($1613|0),($1614|0),($$12969|0),($1612|0))|0); //@line 82817 "c/sqlite3.c"
        $1616 = tempRet0; //@line 82817 "c/sqlite3.c"
        $1619 = (_i64Add(($1615|0),($1616|0),($1617|0),($1618|0))|0); //@line 82818 "c/sqlite3.c"
        $1620 = tempRet0; //@line 82818 "c/sqlite3.c"
        $1621 = HEAP32[$211>>2]|0; //@line 82818 "c/sqlite3.c"
        $1622 = ($1621|0)<(0); //@line 82818 "c/sqlite3.c"
        $1623 = $1622 << 31 >> 31; //@line 82818 "c/sqlite3.c"
        $1624 = ($1620|0)>($1623|0); //@line 82818 "c/sqlite3.c"
        $1625 = ($1619>>>0)>($1621>>>0); //@line 82818 "c/sqlite3.c"
        $1626 = ($1620|0)==($1623|0); //@line 82818 "c/sqlite3.c"
        $1627 = $1626 & $1625; //@line 82818 "c/sqlite3.c"
        $1628 = $1624 | $1627; //@line 82818 "c/sqlite3.c"
        if ($1628) {
         label = 309;
         break L8;
        }
        $1629 = (_sqlite3VdbeMemClearAndResize($1558,$1615)|0); //@line 82827 "c/sqlite3.c"
        $1630 = ($1629|0)==(0); //@line 82827 "c/sqlite3.c"
        if (!($1630)) {
         label = 308;
         break L8;
        }
        $1631 = (((($$02839) + (($1557*40)|0)|0)) + 16|0); //@line 82830 "c/sqlite3.c"
        $1632 = HEAP32[$1631>>2]|0; //@line 82830 "c/sqlite3.c"
        $1633 = ($$12969>>>0)<(128); //@line 82833 "c/sqlite3.c"
        if ($1633) {
         $1634 = $$12969&255; //@line 82833 "c/sqlite3.c"
         HEAP8[$1632>>0] = $1634; //@line 82833 "c/sqlite3.c"
         $1637 = 1;
        } else {
         $1635 = (_sqlite3PutVarint($1632,$$12969,$1612)|0); //@line 82833 "c/sqlite3.c"
         $1637 = $1635;
        }
        $1636 = $1637 & 255; //@line 82833 "c/sqlite3.c"
        $$02975 = $1636;$$02977 = $$12969;$$22964 = $1549;
        while(1) {
         $1638 = ((($$22964)) + 28|0); //@line 82838 "c/sqlite3.c"
         $1639 = HEAP32[$1638>>2]|0; //@line 82838 "c/sqlite3.c"
         $1640 = ($1639>>>0)<(128); //@line 82841 "c/sqlite3.c"
         if ($1640) {
          $1641 = $1639&255; //@line 82841 "c/sqlite3.c"
          $1642 = (($1632) + ($$02975)|0); //@line 82841 "c/sqlite3.c"
          HEAP8[$1642>>0] = $1641; //@line 82841 "c/sqlite3.c"
          $1646 = 1;
         } else {
          $1643 = (($1632) + ($$02975)|0); //@line 82841 "c/sqlite3.c"
          $1644 = (_sqlite3PutVarint($1643,$1639,0)|0); //@line 82841 "c/sqlite3.c"
          $1646 = $1644;
         }
         $1645 = $1646 & 255; //@line 82841 "c/sqlite3.c"
         $1647 = (($1645) + ($$02975))|0; //@line 82841 "c/sqlite3.c"
         $1648 = (($1632) + ($$02977)|0); //@line 82844 "c/sqlite3.c"
         $1649 = (_sqlite3VdbeSerialPut($1648,$$22964,$1639)|0); //@line 82844 "c/sqlite3.c"
         $1650 = (($1649) + ($$02977))|0; //@line 82844 "c/sqlite3.c"
         $1651 = ((($$22964)) + 40|0); //@line 82845 "c/sqlite3.c"
         $1652 = ($1651>>>0)>($1553>>>0); //@line 82845 "c/sqlite3.c"
         if ($1652) {
          break;
         } else {
          $$02975 = $1647;$$02977 = $1650;$$22964 = $1651;
         }
        }
        $1653 = (((($$02839) + (($1557*40)|0)|0)) + 12|0); //@line 82850 "c/sqlite3.c"
        HEAP32[$1653>>2] = $1615; //@line 82850 "c/sqlite3.c"
        $1654 = (((($$02839) + (($1557*40)|0)|0)) + 8|0); //@line 82851 "c/sqlite3.c"
        HEAP16[$1654>>1] = 16; //@line 82851 "c/sqlite3.c"
        $1655 = ($1617|0)==(0); //@line 82852 "c/sqlite3.c"
        $1656 = ($1618|0)==(0); //@line 82852 "c/sqlite3.c"
        $1657 = $1655 & $1656; //@line 82852 "c/sqlite3.c"
        if (!($1657)) {
         HEAP32[$1558>>2] = $1617; //@line 82853 "c/sqlite3.c"
         HEAP16[$1654>>1] = 16400; //@line 82854 "c/sqlite3.c"
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 101:  {
        $1658 = HEAP32[$45>>2]|0; //@line 82873 "c/sqlite3.c"
        $1659 = ((($$02793)) + 4|0); //@line 82873 "c/sqlite3.c"
        $1660 = HEAP32[$1659>>2]|0; //@line 82873 "c/sqlite3.c"
        $1661 = (($1658) + ($1660<<2)|0); //@line 82873 "c/sqlite3.c"
        $1662 = HEAP32[$1661>>2]|0; //@line 82873 "c/sqlite3.c"
        $1663 = ((($1662)) + 40|0); //@line 82873 "c/sqlite3.c"
        $1664 = HEAP32[$1663>>2]|0; //@line 82873 "c/sqlite3.c"
        $1665 = $1; //@line 82875 "c/sqlite3.c"
        $1666 = $1665; //@line 82875 "c/sqlite3.c"
        HEAP32[$1666>>2] = 0; //@line 82875 "c/sqlite3.c"
        $1667 = (($1665) + 4)|0; //@line 82875 "c/sqlite3.c"
        $1668 = $1667; //@line 82875 "c/sqlite3.c"
        HEAP32[$1668>>2] = 0; //@line 82875 "c/sqlite3.c"
        $1669 = (_sqlite3BtreeCount($1664,$1)|0); //@line 82876 "c/sqlite3.c"
        $1670 = ($1669|0)==(0); //@line 82877 "c/sqlite3.c"
        if (!($1670)) {
         label = 312;
         break L8;
        }
        $1671 = (_out2Prerelease($0,$$02793)|0); //@line 82878 "c/sqlite3.c"
        $1672 = $1; //@line 82879 "c/sqlite3.c"
        $1673 = $1672; //@line 82879 "c/sqlite3.c"
        $1674 = HEAP32[$1673>>2]|0; //@line 82879 "c/sqlite3.c"
        $1675 = (($1672) + 4)|0; //@line 82879 "c/sqlite3.c"
        $1676 = $1675; //@line 82879 "c/sqlite3.c"
        $1677 = HEAP32[$1676>>2]|0; //@line 82879 "c/sqlite3.c"
        $1678 = $1671; //@line 82879 "c/sqlite3.c"
        $1679 = $1678; //@line 82879 "c/sqlite3.c"
        HEAP32[$1679>>2] = $1674; //@line 82879 "c/sqlite3.c"
        $1680 = (($1678) + 4)|0; //@line 82879 "c/sqlite3.c"
        $1681 = $1680; //@line 82879 "c/sqlite3.c"
        HEAP32[$1681>>2] = $1677; //@line 82879 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 0:  {
        $1682 = ((($$02793)) + 4|0); //@line 82900 "c/sqlite3.c"
        $1683 = HEAP32[$1682>>2]|0; //@line 82900 "c/sqlite3.c"
        $1684 = ((($$02793)) + 16|0); //@line 82901 "c/sqlite3.c"
        $1685 = HEAP32[$1684>>2]|0; //@line 82901 "c/sqlite3.c"
        $1686 = ($1683|0)==(0); //@line 82912 "c/sqlite3.c"
        if ($1686) {
         $1687 = HEAP32[$116>>2]|0; //@line 82913 "c/sqlite3.c"
         $1688 = ($1687|0)>(0); //@line 82913 "c/sqlite3.c"
         if ($1688) {
          label = 315;
          break L8;
         }
         $1689 = (_sqlite3Strlen30($1685)|0); //@line 82920 "c/sqlite3.c"
         $1690 = HEAP32[$153>>2]|0; //@line 82929 "c/sqlite3.c"
         $1691 = HEAP32[$154>>2]|0; //@line 82929 "c/sqlite3.c"
         $1692 = (($1691) + ($1690))|0; //@line 82929 "c/sqlite3.c"
         $1693 = (_sqlite3VtabSavepoint($8,0,$1692)|0); //@line 82928 "c/sqlite3.c"
         $1694 = ($1693|0)==(0); //@line 82930 "c/sqlite3.c"
         if (!($1694)) {
          $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $1693;$$9 = $$02793;
          break L1;
         }
         $1695 = (($1689) + 33)|0; //@line 82934 "c/sqlite3.c"
         $1696 = (_sqlite3DbMallocRawNN($8,$1695,0)|0); //@line 82934 "c/sqlite3.c"
         $1697 = ($1696|0)==(0|0); //@line 82935 "c/sqlite3.c"
         if ($1697) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
          break L10;
         }
         $1698 = ((($1696)) + 32|0); //@line 82936 "c/sqlite3.c"
         HEAP32[$1696>>2] = $1698; //@line 82936 "c/sqlite3.c"
         $1699 = (($1689) + 1)|0; //@line 82937 "c/sqlite3.c"
         _memcpy(($1698|0),($1685|0),($1699|0))|0; //@line 82937 "c/sqlite3.c"
         $1700 = HEAP8[$194>>0]|0; //@line 82941 "c/sqlite3.c"
         $1701 = ($1700<<24>>24)==(0); //@line 82941 "c/sqlite3.c"
         if ($1701) {
          $1702 = HEAP32[$154>>2]|0; //@line 82945 "c/sqlite3.c"
          $1703 = (($1702) + 1)|0; //@line 82945 "c/sqlite3.c"
          HEAP32[$154>>2] = $1703; //@line 82945 "c/sqlite3.c"
         } else {
          HEAP8[$194>>0] = 0; //@line 82942 "c/sqlite3.c"
          HEAP8[$215>>0] = 1; //@line 82943 "c/sqlite3.c"
         }
         $1704 = HEAP32[$212>>2]|0; //@line 82949 "c/sqlite3.c"
         $1705 = ((($1696)) + 24|0); //@line 82949 "c/sqlite3.c"
         HEAP32[$1705>>2] = $1704; //@line 82949 "c/sqlite3.c"
         HEAP32[$212>>2] = $1696; //@line 82950 "c/sqlite3.c"
         $1706 = $213; //@line 82951 "c/sqlite3.c"
         $1707 = $1706; //@line 82951 "c/sqlite3.c"
         $1708 = HEAP32[$1707>>2]|0; //@line 82951 "c/sqlite3.c"
         $1709 = (($1706) + 4)|0; //@line 82951 "c/sqlite3.c"
         $1710 = $1709; //@line 82951 "c/sqlite3.c"
         $1711 = HEAP32[$1710>>2]|0; //@line 82951 "c/sqlite3.c"
         $1712 = ((($1696)) + 8|0); //@line 82951 "c/sqlite3.c"
         $1713 = $1712; //@line 82951 "c/sqlite3.c"
         $1714 = $1713; //@line 82951 "c/sqlite3.c"
         HEAP32[$1714>>2] = $1708; //@line 82951 "c/sqlite3.c"
         $1715 = (($1713) + 4)|0; //@line 82951 "c/sqlite3.c"
         $1716 = $1715; //@line 82951 "c/sqlite3.c"
         HEAP32[$1716>>2] = $1711; //@line 82951 "c/sqlite3.c"
         $1717 = $214; //@line 82952 "c/sqlite3.c"
         $1718 = $1717; //@line 82952 "c/sqlite3.c"
         $1719 = HEAP32[$1718>>2]|0; //@line 82952 "c/sqlite3.c"
         $1720 = (($1717) + 4)|0; //@line 82952 "c/sqlite3.c"
         $1721 = $1720; //@line 82952 "c/sqlite3.c"
         $1722 = HEAP32[$1721>>2]|0; //@line 82952 "c/sqlite3.c"
         $1723 = ((($1696)) + 16|0); //@line 82952 "c/sqlite3.c"
         $1724 = $1723; //@line 82952 "c/sqlite3.c"
         $1725 = $1724; //@line 82952 "c/sqlite3.c"
         HEAP32[$1725>>2] = $1719; //@line 82952 "c/sqlite3.c"
         $1726 = (($1724) + 4)|0; //@line 82952 "c/sqlite3.c"
         $1727 = $1726; //@line 82952 "c/sqlite3.c"
         HEAP32[$1727>>2] = $1722; //@line 82952 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
         break L10;
        }
        $$029783808 = HEAP32[$117>>2]|0;
        $1728 = ($$029783808|0)==(0|0); //@line 82962 "c/sqlite3.c"
        if ($1728) {
         label = 326;
         break L8;
        }
        $$029783810 = $$029783808;$$029793809 = 0;
        while(1) {
         $1729 = HEAP32[$$029783810>>2]|0; //@line 82962 "c/sqlite3.c"
         $1730 = (_sqlite3StrICmp($1729,$1685)|0); //@line 82962 "c/sqlite3.c"
         $1731 = ($1730|0)==(0); //@line 82962 "c/sqlite3.c"
         if ($1731) {
          break;
         }
         $1732 = (($$029793809) + 1)|0; //@line 82965 "c/sqlite3.c"
         $1733 = ((($$029783810)) + 24|0); //@line 82963 "c/sqlite3.c"
         $$02978 = HEAP32[$1733>>2]|0;
         $1734 = ($$02978|0)==(0|0); //@line 82962 "c/sqlite3.c"
         if ($1734) {
          label = 326;
          break L8;
         } else {
          $$029783810 = $$02978;$$029793809 = $1732;
         }
        }
        $1735 = HEAP32[$195>>2]|0; //@line 82970 "c/sqlite3.c"
        $1736 = ($1735|0)>(0); //@line 82970 "c/sqlite3.c"
        $1737 = ($1683|0)==(1); //@line 82970 "c/sqlite3.c"
        $or$cond13 = $1737 & $1736; //@line 82970 "c/sqlite3.c"
        if ($or$cond13) {
         label = 328;
         break L8;
        }
        $1738 = ((($$029783810)) + 24|0); //@line 82983 "c/sqlite3.c"
        $1739 = HEAP32[$1738>>2]|0; //@line 82983 "c/sqlite3.c"
        $1740 = ($1739|0)==(0|0); //@line 82983 "c/sqlite3.c"
        if ($1740) {
         $1741 = HEAP8[$219>>0]|0; //@line 82983 "c/sqlite3.c"
         $1742 = ($1741<<24>>24)!=(0); //@line 82983 "c/sqlite3.c"
         $or$cond15 = $1737 & $1742; //@line 82984 "c/sqlite3.c"
         if ($or$cond15) {
          $1743 = (_sqlite3VdbeCheckFk($0,1)|0); //@line 82985 "c/sqlite3.c"
          $1744 = ($1743|0)==(0); //@line 82985 "c/sqlite3.c"
          if (!($1744)) {
           $$22832 = $251;$$90 = $1743;
           label = 851;
           break L8;
          }
          HEAP8[$233>>0] = 1; //@line 82988 "c/sqlite3.c"
          $1745 = (_sqlite3VdbeHalt($0)|0); //@line 82989 "c/sqlite3.c"
          $1746 = ($1745|0)==(5); //@line 82989 "c/sqlite3.c"
          if ($1746) {
           label = 333;
           break L8;
          }
          HEAP8[$245>>0] = 0; //@line 82995 "c/sqlite3.c"
          $1752 = HEAP32[$13>>2]|0; //@line 82996 "c/sqlite3.c"
          $$12980 = $$029793809;$$19 = $1752;$1818 = $1742;
         } else {
          $4249 = $1742;
          label = 335;
         }
        } else {
         $4249 = 0;
         label = 335;
        }
        if ((label|0) == 335) {
         label = 0;
         $1753 = HEAP32[$220>>2]|0; //@line 82999 "c/sqlite3.c"
         $1754 = (($1753) - ($$029793809))|0; //@line 82999 "c/sqlite3.c"
         $1755 = (($1754) + -1)|0; //@line 82999 "c/sqlite3.c"
         $1756 = ($1683|0)==(2); //@line 83000 "c/sqlite3.c"
         if ($1756) {
          $1757 = HEAP32[$228>>2]|0; //@line 83001 "c/sqlite3.c"
          $1758 = $1757 & 1; //@line 83001 "c/sqlite3.c"
          $1759 = HEAP32[$229>>2]|0; //@line 83002 "c/sqlite3.c"
          $1760 = ($1759|0)>(0); //@line 83002 "c/sqlite3.c"
          if ($1760) {
           $1761 = $1758 ^ 1;
           $$029813824 = 0;
           while(1) {
            $1765 = HEAP32[$236>>2]|0; //@line 83003 "c/sqlite3.c"
            $1766 = (((($1765) + ($$029813824<<4)|0)) + 4|0); //@line 83003 "c/sqlite3.c"
            $1767 = HEAP32[$1766>>2]|0; //@line 83003 "c/sqlite3.c"
            $1768 = (_sqlite3BtreeTripAllCursors($1767,516,$1761)|0); //@line 83003 "c/sqlite3.c"
            $1769 = ($1768|0)==(0); //@line 83006 "c/sqlite3.c"
            $1764 = (($$029813824) + 1)|0; //@line 83002 "c/sqlite3.c"
            if (!($1769)) {
             $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $1768;$$9 = $$02793;
             break L1;
            }
            $1762 = HEAP32[$229>>2]|0; //@line 83002 "c/sqlite3.c"
            $1763 = ($1764|0)<($1762|0); //@line 83002 "c/sqlite3.c"
            if ($1763) {
             $$029813824 = $1764;
            } else {
             $$02985 = $1758;$$16 = 0;$1771 = $1762;
             label = 341;
             break;
            }
           }
          } else {
           $$029854312 = $1758;$$17$lcssa = $$02801;
          }
         } else {
          $$pr4311 = HEAP32[$230>>2]|0; //@line 83011 "c/sqlite3.c"
          $$02985 = 0;$$16 = $$02801;$1771 = $$pr4311;
          label = 341;
         }
         if ((label|0) == 341) {
          label = 0;
          $1770 = ($1771|0)>(0); //@line 83011 "c/sqlite3.c"
          if ($1770) {
           $$129823828 = 0;
           while(1) {
            $1775 = HEAP32[$237>>2]|0; //@line 83012 "c/sqlite3.c"
            $1776 = (((($1775) + ($$129823828<<4)|0)) + 4|0); //@line 83012 "c/sqlite3.c"
            $1777 = HEAP32[$1776>>2]|0; //@line 83012 "c/sqlite3.c"
            $1778 = (_sqlite3BtreeSavepoint($1777,$1683,$1755)|0); //@line 83012 "c/sqlite3.c"
            $1779 = ($1778|0)==(0); //@line 83013 "c/sqlite3.c"
            $1774 = (($$129823828) + 1)|0; //@line 83011 "c/sqlite3.c"
            if (!($1779)) {
             $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $1778;$$9 = $$02793;
             break L1;
            }
            $1772 = HEAP32[$230>>2]|0; //@line 83011 "c/sqlite3.c"
            $1773 = ($1774|0)<($1772|0); //@line 83011 "c/sqlite3.c"
            if ($1773) {
             $$129823828 = $1774;
            } else {
             $$029854312 = $$02985;$$17$lcssa = 0;
             break;
            }
           }
          } else {
           $$029854312 = $$02985;$$17$lcssa = $$16;
          }
         }
         $1780 = ($$029854312|0)==(0); //@line 83017 "c/sqlite3.c"
         if ($1780) {
          $$12980 = $1755;$$19 = $$17$lcssa;$1818 = $4249;
         } else {
          _sqlite3ExpirePreparedStatements($8); //@line 83018 "c/sqlite3.c"
          _sqlite3ResetAllSchemasOfConnection($8); //@line 83019 "c/sqlite3.c"
          $1781 = HEAP32[$247>>2]|0; //@line 83020 "c/sqlite3.c"
          $1782 = $1781 | 1; //@line 83020 "c/sqlite3.c"
          HEAP32[$247>>2] = $1782; //@line 83020 "c/sqlite3.c"
          $$12980 = $1755;$$19 = $$17$lcssa;$1818 = $4249;
         }
        }
        $1783 = HEAP32[$117>>2]|0; //@line 83026 "c/sqlite3.c"
        $1784 = ($1783|0)==($$029783810|0); //@line 83026 "c/sqlite3.c"
        if (!($1784)) {
         $1786 = $1783;
         while(1) {
          $1785 = ((($1786)) + 24|0); //@line 83028 "c/sqlite3.c"
          $1787 = HEAP32[$1785>>2]|0; //@line 83028 "c/sqlite3.c"
          HEAP32[$117>>2] = $1787; //@line 83028 "c/sqlite3.c"
          _sqlite3DbFree($8,$1786); //@line 83029 "c/sqlite3.c"
          $1788 = HEAP32[$227>>2]|0; //@line 83030 "c/sqlite3.c"
          $1789 = (($1788) + -1)|0; //@line 83030 "c/sqlite3.c"
          HEAP32[$227>>2] = $1789; //@line 83030 "c/sqlite3.c"
          $1790 = HEAP32[$117>>2]|0; //@line 83026 "c/sqlite3.c"
          $1791 = ($1790|0)==($$029783810|0); //@line 83026 "c/sqlite3.c"
          if ($1791) {
           break;
          } else {
           $1786 = $1790;
          }
         }
        }
        if ($1737) {
         $1792 = HEAP32[$1738>>2]|0; //@line 83039 "c/sqlite3.c"
         HEAP32[$117>>2] = $1792; //@line 83039 "c/sqlite3.c"
         _sqlite3DbFree($8,$$029783810); //@line 83040 "c/sqlite3.c"
         if ($1818) {
          label = 354;
         } else {
          $1793 = HEAP32[$246>>2]|0; //@line 83042 "c/sqlite3.c"
          $1794 = (($1793) + -1)|0; //@line 83042 "c/sqlite3.c"
          HEAP32[$246>>2] = $1794; //@line 83042 "c/sqlite3.c"
         }
        } else {
         $1795 = ((($$029783810)) + 8|0); //@line 83045 "c/sqlite3.c"
         $1796 = $1795; //@line 83045 "c/sqlite3.c"
         $1797 = $1796; //@line 83045 "c/sqlite3.c"
         $1798 = HEAP32[$1797>>2]|0; //@line 83045 "c/sqlite3.c"
         $1799 = (($1796) + 4)|0; //@line 83045 "c/sqlite3.c"
         $1800 = $1799; //@line 83045 "c/sqlite3.c"
         $1801 = HEAP32[$1800>>2]|0; //@line 83045 "c/sqlite3.c"
         $1802 = $234; //@line 83045 "c/sqlite3.c"
         $1803 = $1802; //@line 83045 "c/sqlite3.c"
         HEAP32[$1803>>2] = $1798; //@line 83045 "c/sqlite3.c"
         $1804 = (($1802) + 4)|0; //@line 83045 "c/sqlite3.c"
         $1805 = $1804; //@line 83045 "c/sqlite3.c"
         HEAP32[$1805>>2] = $1801; //@line 83045 "c/sqlite3.c"
         $1806 = ((($$029783810)) + 16|0); //@line 83046 "c/sqlite3.c"
         $1807 = $1806; //@line 83046 "c/sqlite3.c"
         $1808 = $1807; //@line 83046 "c/sqlite3.c"
         $1809 = HEAP32[$1808>>2]|0; //@line 83046 "c/sqlite3.c"
         $1810 = (($1807) + 4)|0; //@line 83046 "c/sqlite3.c"
         $1811 = $1810; //@line 83046 "c/sqlite3.c"
         $1812 = HEAP32[$1811>>2]|0; //@line 83046 "c/sqlite3.c"
         $1813 = $235; //@line 83046 "c/sqlite3.c"
         $1814 = $1813; //@line 83046 "c/sqlite3.c"
         HEAP32[$1814>>2] = $1809; //@line 83046 "c/sqlite3.c"
         $1815 = (($1813) + 4)|0; //@line 83046 "c/sqlite3.c"
         $1816 = $1815; //@line 83046 "c/sqlite3.c"
         HEAP32[$1816>>2] = $1812; //@line 83046 "c/sqlite3.c"
         label = 354;
        }
        if ((label|0) == 354) {
         label = 0;
         $1817 = $1818 ^ 1; //@line 83049 "c/sqlite3.c"
         $1819 = ($1683|0)==(2); //@line 83049 "c/sqlite3.c"
         $or$cond17 = $1819 | $1817; //@line 83049 "c/sqlite3.c"
         if (!($or$cond17)) {
          $1822 = ($$19|0)==(0); //@line 83055 "c/sqlite3.c"
          if ($1822) {
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
           break L10;
          } else {
           $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$19;$$9 = $$02793;
           break L1;
          }
         }
        }
        $1820 = (_sqlite3VtabSavepoint($8,$1683,$$12980)|0); //@line 83050 "c/sqlite3.c"
        $1821 = ($1820|0)==(0); //@line 83051 "c/sqlite3.c"
        if ($1821) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $1820;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 2:  {
        $1853 = ((($$02793)) + 8|0); //@line 83167 "c/sqlite3.c"
        $1854 = HEAP32[$1853>>2]|0; //@line 83167 "c/sqlite3.c"
        $1855 = ($1854|0)==(0); //@line 83167 "c/sqlite3.c"
        if (!($1855)) {
         $1856 = HEAP32[$119>>2]|0; //@line 83167 "c/sqlite3.c"
         $1857 = $1856 & 1048576; //@line 83167 "c/sqlite3.c"
         $1858 = ($1857|0)==(0); //@line 83167 "c/sqlite3.c"
         if (!($1858)) {
          $$30$ph$ph = 8;
          label = 393;
          break L8;
         }
        }
        $1859 = HEAP32[$118>>2]|0; //@line 83171 "c/sqlite3.c"
        $1860 = ((($$02793)) + 4|0); //@line 83171 "c/sqlite3.c"
        $1861 = HEAP32[$1860>>2]|0; //@line 83171 "c/sqlite3.c"
        $1862 = (((($1859) + ($1861<<4)|0)) + 4|0); //@line 83171 "c/sqlite3.c"
        $1863 = HEAP32[$1862>>2]|0; //@line 83171 "c/sqlite3.c"
        $1864 = ($1863|0)==(0|0); //@line 83173 "c/sqlite3.c"
        if ($1864) {
         HEAP32[$1>>2] = 0; //@line 83216 "c/sqlite3.c"
         $$02987 = 0;$$28 = $$02801;
        } else {
         $1865 = (_sqlite3BtreeBeginTrans($1863,$1854)|0); //@line 83174 "c/sqlite3.c"
         $1866 = ($1865|0)==(0); //@line 83177 "c/sqlite3.c"
         if (!($1866)) {
          label = 373;
          break L8;
         }
         $1869 = HEAP32[$1853>>2]|0; //@line 83186 "c/sqlite3.c"
         $1870 = ($1869|0)==(0); //@line 83186 "c/sqlite3.c"
         do {
          if ($1870) {
           $$27 = 0;
          } else {
           $1871 = HEAPU8[$196>>0]|(HEAPU8[$196+1>>0]<<8); //@line 83186 "c/sqlite3.c"
           $1872 = $1871 & 64; //@line 83186 "c/sqlite3.c"
           $1873 = ($1872<<16>>16)==(0); //@line 83186 "c/sqlite3.c"
           if ($1873) {
            $$27 = 0;
           } else {
            $1874 = HEAP8[$216>>0]|0; //@line 83187 "c/sqlite3.c"
            $1875 = ($1874<<24>>24)==(0); //@line 83187 "c/sqlite3.c"
            if (!($1875)) {
             $1876 = HEAP32[$222>>2]|0; //@line 83187 "c/sqlite3.c"
             $1877 = ($1876|0)>(1); //@line 83187 "c/sqlite3.c"
             if (!($1877)) {
              $$27 = 0;
              break;
             }
            }
            $1878 = HEAP32[$221>>2]|0; //@line 83190 "c/sqlite3.c"
            $1879 = ($1878|0)==(0); //@line 83190 "c/sqlite3.c"
            if ($1879) {
             $1880 = HEAP32[$231>>2]|0; //@line 83192 "c/sqlite3.c"
             $1881 = (($1880) + 1)|0; //@line 83192 "c/sqlite3.c"
             HEAP32[$231>>2] = $1881; //@line 83192 "c/sqlite3.c"
             $1882 = HEAP32[$232>>2]|0; //@line 83193 "c/sqlite3.c"
             $1883 = (($1882) + ($1881))|0; //@line 83193 "c/sqlite3.c"
             HEAP32[$221>>2] = $1883; //@line 83193 "c/sqlite3.c"
            }
            $1884 = HEAP32[$221>>2]|0; //@line 83196 "c/sqlite3.c"
            $1885 = (($1884) + -1)|0; //@line 83196 "c/sqlite3.c"
            $1886 = (_sqlite3VtabSavepoint($8,0,$1885)|0); //@line 83196 "c/sqlite3.c"
            $1887 = ($1886|0)==(0); //@line 83197 "c/sqlite3.c"
            if ($1887) {
             $1888 = HEAP32[$221>>2]|0; //@line 83198 "c/sqlite3.c"
             $1889 = (_sqlite3BtreeBeginStmt($1863,$1888)|0); //@line 83198 "c/sqlite3.c"
             $$26 = $1889;
            } else {
             $$26 = $1886;
            }
            $1890 = $238; //@line 83204 "c/sqlite3.c"
            $1891 = $1890; //@line 83204 "c/sqlite3.c"
            $1892 = HEAP32[$1891>>2]|0; //@line 83204 "c/sqlite3.c"
            $1893 = (($1890) + 4)|0; //@line 83204 "c/sqlite3.c"
            $1894 = $1893; //@line 83204 "c/sqlite3.c"
            $1895 = HEAP32[$1894>>2]|0; //@line 83204 "c/sqlite3.c"
            $1896 = $239; //@line 83204 "c/sqlite3.c"
            $1897 = $1896; //@line 83204 "c/sqlite3.c"
            HEAP32[$1897>>2] = $1892; //@line 83204 "c/sqlite3.c"
            $1898 = (($1896) + 4)|0; //@line 83204 "c/sqlite3.c"
            $1899 = $1898; //@line 83204 "c/sqlite3.c"
            HEAP32[$1899>>2] = $1895; //@line 83204 "c/sqlite3.c"
            $1900 = $240; //@line 83205 "c/sqlite3.c"
            $1901 = $1900; //@line 83205 "c/sqlite3.c"
            $1902 = HEAP32[$1901>>2]|0; //@line 83205 "c/sqlite3.c"
            $1903 = (($1900) + 4)|0; //@line 83205 "c/sqlite3.c"
            $1904 = $1903; //@line 83205 "c/sqlite3.c"
            $1905 = HEAP32[$1904>>2]|0; //@line 83205 "c/sqlite3.c"
            $1906 = $241; //@line 83205 "c/sqlite3.c"
            $1907 = $1906; //@line 83205 "c/sqlite3.c"
            HEAP32[$1907>>2] = $1902; //@line 83205 "c/sqlite3.c"
            $1908 = (($1906) + 4)|0; //@line 83205 "c/sqlite3.c"
            $1909 = $1908; //@line 83205 "c/sqlite3.c"
            HEAP32[$1909>>2] = $1905; //@line 83205 "c/sqlite3.c"
            $$27 = $$26;
           }
          }
         } while(0);
         _sqlite3BtreeGetMeta($1863,1,$1); //@line 83213 "c/sqlite3.c"
         $1910 = HEAP32[$118>>2]|0; //@line 83214 "c/sqlite3.c"
         $1911 = HEAP32[$1860>>2]|0; //@line 83214 "c/sqlite3.c"
         $1912 = (((($1910) + ($1911<<4)|0)) + 12|0); //@line 83214 "c/sqlite3.c"
         $1913 = HEAP32[$1912>>2]|0; //@line 83214 "c/sqlite3.c"
         $1914 = ((($1913)) + 4|0); //@line 83214 "c/sqlite3.c"
         $1915 = HEAP32[$1914>>2]|0; //@line 83214 "c/sqlite3.c"
         $$02987 = $1915;$$28 = $$27;
        }
        $1916 = ((($$02793)) + 2|0); //@line 83219 "c/sqlite3.c"
        $1917 = HEAP16[$1916>>1]|0; //@line 83219 "c/sqlite3.c"
        $1918 = ($1917<<16>>16)==(0); //@line 83219 "c/sqlite3.c"
        if (!($1918)) {
         $1919 = HEAP32[$1>>2]|0; //@line 83219 "c/sqlite3.c"
         $1920 = ((($$02793)) + 12|0); //@line 83219 "c/sqlite3.c"
         $1921 = HEAP32[$1920>>2]|0; //@line 83219 "c/sqlite3.c"
         $1922 = ($1919|0)==($1921|0); //@line 83219 "c/sqlite3.c"
         if (!($1922)) {
          label = 388;
          break L8;
         }
         $1923 = ((($$02793)) + 16|0); //@line 83219 "c/sqlite3.c"
         $1924 = HEAP32[$1923>>2]|0; //@line 83219 "c/sqlite3.c"
         $1925 = ($$02987|0)==($1924|0); //@line 83219 "c/sqlite3.c"
         if (!($1925)) {
          label = 388;
          break L8;
         }
        }
        $1938 = ($$28|0)==(0); //@line 83241 "c/sqlite3.c"
        if (!($1938)) {
         $$30$ph$ph = $$28;
         label = 393;
         break L8;
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 102:  {
        $1943 = ((($$02793)) + 4|0); //@line 83263 "c/sqlite3.c"
        $1944 = HEAP32[$1943>>2]|0; //@line 83263 "c/sqlite3.c"
        $1945 = ((($$02793)) + 12|0); //@line 83264 "c/sqlite3.c"
        $1946 = HEAP32[$1945>>2]|0; //@line 83264 "c/sqlite3.c"
        $1947 = HEAP32[$46>>2]|0; //@line 83270 "c/sqlite3.c"
        $1948 = (((($1947) + ($1944<<4)|0)) + 4|0); //@line 83270 "c/sqlite3.c"
        $1949 = HEAP32[$1948>>2]|0; //@line 83270 "c/sqlite3.c"
        _sqlite3BtreeGetMeta($1949,$1946,$1); //@line 83270 "c/sqlite3.c"
        $1950 = (_out2Prerelease($0,$$02793)|0); //@line 83271 "c/sqlite3.c"
        $1951 = HEAP32[$1>>2]|0; //@line 83272 "c/sqlite3.c"
        $1952 = ($1951|0)<(0); //@line 83272 "c/sqlite3.c"
        $1953 = $1952 << 31 >> 31; //@line 83272 "c/sqlite3.c"
        $1954 = $1950; //@line 83272 "c/sqlite3.c"
        $1955 = $1954; //@line 83272 "c/sqlite3.c"
        HEAP32[$1955>>2] = $1951; //@line 83272 "c/sqlite3.c"
        $1956 = (($1954) + 4)|0; //@line 83272 "c/sqlite3.c"
        $1957 = $1956; //@line 83272 "c/sqlite3.c"
        HEAP32[$1957>>2] = $1953; //@line 83272 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 103:  {
        $1958 = HEAP32[$47>>2]|0; //@line 83292 "c/sqlite3.c"
        $1959 = ((($$02793)) + 4|0); //@line 83292 "c/sqlite3.c"
        $1960 = HEAP32[$1959>>2]|0; //@line 83292 "c/sqlite3.c"
        $1961 = (((($1958) + ($1960<<4)|0)) + 4|0); //@line 83296 "c/sqlite3.c"
        $1962 = HEAP32[$1961>>2]|0; //@line 83296 "c/sqlite3.c"
        $1963 = ((($$02793)) + 8|0); //@line 83296 "c/sqlite3.c"
        $1964 = HEAP32[$1963>>2]|0; //@line 83296 "c/sqlite3.c"
        $1965 = ((($$02793)) + 12|0); //@line 83296 "c/sqlite3.c"
        $1966 = HEAP32[$1965>>2]|0; //@line 83296 "c/sqlite3.c"
        $1967 = (_sqlite3BtreeUpdateMeta($1962,$1964,$1966)|0); //@line 83296 "c/sqlite3.c"
        $1968 = HEAP32[$1963>>2]|0; //@line 83297 "c/sqlite3.c"
        switch ($1968|0) {
        case 1:  {
         $1969 = HEAP32[$1965>>2]|0; //@line 83299 "c/sqlite3.c"
         $1970 = (((($1958) + ($1960<<4)|0)) + 12|0); //@line 83299 "c/sqlite3.c"
         $1971 = HEAP32[$1970>>2]|0; //@line 83299 "c/sqlite3.c"
         HEAP32[$1971>>2] = $1969; //@line 83299 "c/sqlite3.c"
         $1972 = HEAP32[$120>>2]|0; //@line 83300 "c/sqlite3.c"
         $1973 = $1972 | 1; //@line 83300 "c/sqlite3.c"
         HEAP32[$120>>2] = $1973; //@line 83300 "c/sqlite3.c"
         break;
        }
        case 2:  {
         $1974 = HEAP32[$1965>>2]|0; //@line 83303 "c/sqlite3.c"
         $1975 = $1974&255; //@line 83303 "c/sqlite3.c"
         $1976 = (((($1958) + ($1960<<4)|0)) + 12|0); //@line 83303 "c/sqlite3.c"
         $1977 = HEAP32[$1976>>2]|0; //@line 83303 "c/sqlite3.c"
         $1978 = ((($1977)) + 76|0); //@line 83303 "c/sqlite3.c"
         HEAP8[$1978>>0] = $1975; //@line 83303 "c/sqlite3.c"
         break;
        }
        default: {
        }
        }
        $1979 = HEAP32[$1959>>2]|0; //@line 83305 "c/sqlite3.c"
        $1980 = ($1979|0)==(1); //@line 83305 "c/sqlite3.c"
        if ($1980) {
         _sqlite3ExpirePreparedStatements($8); //@line 83308 "c/sqlite3.c"
         $1981 = HEAPU8[$155>>0]|(HEAPU8[$155+1>>0]<<8); //@line 83309 "c/sqlite3.c"
         $1982 = $1981 & -2; //@line 83309 "c/sqlite3.c"
         HEAP8[$155>>0]=$1982&255;HEAP8[$155+1>>0]=$1982>>8; //@line 83309 "c/sqlite3.c"
        }
        $1983 = ($1967|0)==(0); //@line 83311 "c/sqlite3.c"
        if ($1983) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $1967;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 104:  {
        $1984 = HEAP32[$48>>2]|0; //@line 83392 "c/sqlite3.c"
        $1985 = ((($$02793)) + 4|0); //@line 83392 "c/sqlite3.c"
        $1986 = HEAP32[$1985>>2]|0; //@line 83392 "c/sqlite3.c"
        $1987 = (($1984) + ($1986<<2)|0); //@line 83392 "c/sqlite3.c"
        $1988 = HEAP32[$1987>>2]|0; //@line 83392 "c/sqlite3.c"
        $1989 = ($1988|0)==(0|0); //@line 83393 "c/sqlite3.c"
        if ($1989) {
         label = 405;
        } else {
         $1990 = ((($1988)) + 52|0); //@line 83393 "c/sqlite3.c"
         $1991 = HEAP32[$1990>>2]|0; //@line 83393 "c/sqlite3.c"
         $1992 = ((($$02793)) + 8|0); //@line 83393 "c/sqlite3.c"
         $1993 = HEAP32[$1992>>2]|0; //@line 83393 "c/sqlite3.c"
         $1994 = ($1991|0)==($1993|0); //@line 83393 "c/sqlite3.c"
         if ($1994) {
          $$02993 = $1988;$$31 = $$02801;
          label = 416;
         } else {
          label = 405;
         }
        }
        break;
       }
       case 106: case 105:  {
        label = 405;
        break;
       }
       case 107:  {
        $2061 = HEAP32[$50>>2]|0; //@line 83497 "c/sqlite3.c"
        $2062 = ((($$02793)) + 8|0); //@line 83497 "c/sqlite3.c"
        $2063 = HEAP32[$2062>>2]|0; //@line 83497 "c/sqlite3.c"
        $2064 = (($2061) + ($2063<<2)|0); //@line 83497 "c/sqlite3.c"
        $2065 = HEAP32[$2064>>2]|0; //@line 83497 "c/sqlite3.c"
        $2066 = ((($$02793)) + 4|0); //@line 83500 "c/sqlite3.c"
        $2067 = HEAP32[$2066>>2]|0; //@line 83500 "c/sqlite3.c"
        $2068 = ((($2065)) + 56|0); //@line 83500 "c/sqlite3.c"
        $2069 = HEAP16[$2068>>1]|0; //@line 83500 "c/sqlite3.c"
        $2070 = $2069 << 16 >> 16; //@line 83500 "c/sqlite3.c"
        $2071 = (_allocateCursor($0,$2067,$2070,-1,0)|0); //@line 83500 "c/sqlite3.c"
        $2072 = ($2071|0)==(0|0); //@line 83501 "c/sqlite3.c"
        if ($2072) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $2073 = ((($2071)) + 2|0); //@line 83502 "c/sqlite3.c"
        HEAP8[$2073>>0] = 1; //@line 83502 "c/sqlite3.c"
        $2074 = ((($2071)) + 5|0); //@line 83503 "c/sqlite3.c"
        $2075 = HEAP8[$2074>>0]|0; //@line 83503 "c/sqlite3.c"
        $2076 = $2075 | 1; //@line 83503 "c/sqlite3.c"
        HEAP8[$2074>>0] = $2076; //@line 83503 "c/sqlite3.c"
        $2077 = ((($2065)) + 44|0); //@line 83504 "c/sqlite3.c"
        $2078 = HEAP32[$2077>>2]|0; //@line 83504 "c/sqlite3.c"
        $2079 = ((($2071)) + 44|0); //@line 83504 "c/sqlite3.c"
        HEAP32[$2079>>2] = $2078; //@line 83504 "c/sqlite3.c"
        $2080 = ((($2065)) + 4|0); //@line 83505 "c/sqlite3.c"
        $2081 = HEAP8[$2080>>0]|0; //@line 83505 "c/sqlite3.c"
        $2082 = ((($2071)) + 4|0); //@line 83505 "c/sqlite3.c"
        HEAP8[$2082>>0] = $2081; //@line 83505 "c/sqlite3.c"
        $2083 = ((($2065)) + 8|0); //@line 83506 "c/sqlite3.c"
        $2084 = HEAP32[$2083>>2]|0; //@line 83506 "c/sqlite3.c"
        $2085 = HEAP32[$2079>>2]|0; //@line 83507 "c/sqlite3.c"
        $2086 = ((($2071)) + 40|0); //@line 83507 "c/sqlite3.c"
        $2087 = HEAP32[$2086>>2]|0; //@line 83507 "c/sqlite3.c"
        $2088 = (_sqlite3BtreeCursor($2084,1,4,$2085,$2087)|0); //@line 83506 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $2088;
        break;
       }
       case 109: case 108:  {
        $2089 = ((($$02793)) + 4|0); //@line 83555 "c/sqlite3.c"
        $2090 = HEAP32[$2089>>2]|0; //@line 83555 "c/sqlite3.c"
        $2091 = ((($$02793)) + 8|0); //@line 83555 "c/sqlite3.c"
        $2092 = HEAP32[$2091>>2]|0; //@line 83555 "c/sqlite3.c"
        $2093 = (_allocateCursor($0,$2090,$2092,-1,0)|0); //@line 83555 "c/sqlite3.c"
        $2094 = ($2093|0)==(0|0); //@line 83556 "c/sqlite3.c"
        if ($2094) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $2095 = ((($2093)) + 2|0); //@line 83557 "c/sqlite3.c"
        HEAP8[$2095>>0] = 1; //@line 83557 "c/sqlite3.c"
        $2096 = ((($2093)) + 5|0); //@line 83558 "c/sqlite3.c"
        $2097 = HEAP8[$2096>>0]|0; //@line 83558 "c/sqlite3.c"
        $2098 = $2097 | 1; //@line 83558 "c/sqlite3.c"
        HEAP8[$2096>>0] = $2098; //@line 83558 "c/sqlite3.c"
        $2099 = HEAP32[$8>>2]|0; //@line 83559 "c/sqlite3.c"
        $2100 = ((($2093)) + 8|0); //@line 83559 "c/sqlite3.c"
        $2101 = ((($$02793)) + 2|0); //@line 83560 "c/sqlite3.c"
        $2102 = HEAP16[$2101>>1]|0; //@line 83560 "c/sqlite3.c"
        $2103 = $2102 | 5; //@line 83560 "c/sqlite3.c"
        $2104 = $2103&65535; //@line 83560 "c/sqlite3.c"
        $2105 = (_sqlite3BtreeOpen($2099,0,$8,$2100,$2104,1054)|0); //@line 83559 "c/sqlite3.c"
        $2106 = ($2105|0)==(0); //@line 83561 "c/sqlite3.c"
        if (!($2106)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2105;$$9 = $$02793;
         break L1;
        }
        $2107 = HEAP32[$2100>>2]|0; //@line 83562 "c/sqlite3.c"
        $2108 = (_sqlite3BtreeBeginTrans($2107,1)|0); //@line 83562 "c/sqlite3.c"
        $2109 = ($2108|0)==(0); //@line 83564 "c/sqlite3.c"
        if (!($2109)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2108;$$9 = $$02793;
         break L1;
        }
        $2110 = ((($$02793)) + 16|0); //@line 83570 "c/sqlite3.c"
        $2111 = HEAP32[$2110>>2]|0; //@line 83570 "c/sqlite3.c"
        $2112 = ((($2093)) + 44|0); //@line 83570 "c/sqlite3.c"
        HEAP32[$2112>>2] = $2111; //@line 83570 "c/sqlite3.c"
        $2113 = ($2111|0)==(0|0); //@line 83570 "c/sqlite3.c"
        if ($2113) {
         $2126 = HEAP32[$2100>>2]|0; //@line 83583 "c/sqlite3.c"
         $2127 = ((($2093)) + 40|0); //@line 83584 "c/sqlite3.c"
         $2128 = HEAP32[$2127>>2]|0; //@line 83584 "c/sqlite3.c"
         $2129 = (_sqlite3BtreeCursor($2126,1,4,0,$2128)|0); //@line 83583 "c/sqlite3.c"
         $2130 = ((($2093)) + 4|0); //@line 83585 "c/sqlite3.c"
         HEAP8[$2130>>0] = 1; //@line 83585 "c/sqlite3.c"
         $$35 = $2129;
        } else {
         $2114 = HEAP32[$2100>>2]|0; //@line 83573 "c/sqlite3.c"
         $2115 = HEAP16[$2101>>1]|0; //@line 83573 "c/sqlite3.c"
         $2116 = $2115 | 2; //@line 83573 "c/sqlite3.c"
         $2117 = $2116&65535; //@line 83573 "c/sqlite3.c"
         $2118 = (_sqlite3BtreeCreateTable($2114,$1,$2117)|0); //@line 83573 "c/sqlite3.c"
         $2119 = ($2118|0)==(0); //@line 83574 "c/sqlite3.c"
         if ($2119) {
          $2120 = HEAP32[$2100>>2]|0; //@line 83578 "c/sqlite3.c"
          $2121 = HEAP32[$1>>2]|0; //@line 83578 "c/sqlite3.c"
          $2122 = ((($2093)) + 40|0); //@line 83579 "c/sqlite3.c"
          $2123 = HEAP32[$2122>>2]|0; //@line 83579 "c/sqlite3.c"
          $2124 = (_sqlite3BtreeCursor($2120,$2121,4,$2111,$2123)|0); //@line 83578 "c/sqlite3.c"
          $$34 = $2124;
         } else {
          $$34 = $2118;
         }
         $2125 = ((($2093)) + 4|0); //@line 83581 "c/sqlite3.c"
         HEAP8[$2125>>0] = 0; //@line 83581 "c/sqlite3.c"
         $$35 = $$34;
        }
        $2131 = ($$35|0)==(0); //@line 83588 "c/sqlite3.c"
        if (!($2131)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$35;$$9 = $$02793;
         break L1;
        }
        $2132 = HEAP16[$2101>>1]|0; //@line 83589 "c/sqlite3.c"
        $2133 = ($2132<<16>>16)!=(8); //@line 83589 "c/sqlite3.c"
        $2134 = $2133&1; //@line 83589 "c/sqlite3.c"
        $2135 = HEAP8[$2096>>0]|0; //@line 83589 "c/sqlite3.c"
        $2136 = ($2134 << 2)&255; //@line 83589 "c/sqlite3.c"
        $2137 = $2135 & -5; //@line 83589 "c/sqlite3.c"
        $2138 = $2136 | $2137; //@line 83589 "c/sqlite3.c"
        HEAP8[$2096>>0] = $2138; //@line 83589 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 110:  {
        $2139 = ((($$02793)) + 4|0); //@line 83608 "c/sqlite3.c"
        $2140 = HEAP32[$2139>>2]|0; //@line 83608 "c/sqlite3.c"
        $2141 = ((($$02793)) + 8|0); //@line 83608 "c/sqlite3.c"
        $2142 = HEAP32[$2141>>2]|0; //@line 83608 "c/sqlite3.c"
        $2143 = (_allocateCursor($0,$2140,$2142,-1,1)|0); //@line 83608 "c/sqlite3.c"
        $2144 = ($2143|0)==(0|0); //@line 83609 "c/sqlite3.c"
        if ($2144) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $2145 = ((($$02793)) + 16|0); //@line 83610 "c/sqlite3.c"
        $2146 = HEAP32[$2145>>2]|0; //@line 83610 "c/sqlite3.c"
        $2147 = ((($2143)) + 44|0); //@line 83610 "c/sqlite3.c"
        HEAP32[$2147>>2] = $2146; //@line 83610 "c/sqlite3.c"
        $2148 = ((($$02793)) + 12|0); //@line 83613 "c/sqlite3.c"
        $2149 = HEAP32[$2148>>2]|0; //@line 83613 "c/sqlite3.c"
        $2150 = (_sqlite3VdbeSorterInit($8,$2149,$2143)|0); //@line 83613 "c/sqlite3.c"
        $2151 = ($2150|0)==(0); //@line 83614 "c/sqlite3.c"
        if ($2151) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2150;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 111:  {
        $2152 = HEAP32[$51>>2]|0; //@line 83628 "c/sqlite3.c"
        $2153 = ((($$02793)) + 4|0); //@line 83628 "c/sqlite3.c"
        $2154 = HEAP32[$2153>>2]|0; //@line 83628 "c/sqlite3.c"
        $2155 = (($2152) + ($2154<<2)|0); //@line 83628 "c/sqlite3.c"
        $2156 = HEAP32[$2155>>2]|0; //@line 83628 "c/sqlite3.c"
        $2157 = ((($2156)) + 16|0); //@line 83630 "c/sqlite3.c"
        $2158 = $2157; //@line 83630 "c/sqlite3.c"
        $2159 = $2158; //@line 83630 "c/sqlite3.c"
        $2160 = HEAP32[$2159>>2]|0; //@line 83630 "c/sqlite3.c"
        $2161 = (($2158) + 4)|0; //@line 83630 "c/sqlite3.c"
        $2162 = $2161; //@line 83630 "c/sqlite3.c"
        $2163 = HEAP32[$2162>>2]|0; //@line 83630 "c/sqlite3.c"
        $2164 = (_i64Add(($2160|0),($2163|0),1,0)|0); //@line 83630 "c/sqlite3.c"
        $2165 = tempRet0; //@line 83630 "c/sqlite3.c"
        $2166 = $2157; //@line 83630 "c/sqlite3.c"
        $2167 = $2166; //@line 83630 "c/sqlite3.c"
        HEAP32[$2167>>2] = $2164; //@line 83630 "c/sqlite3.c"
        $2168 = (($2166) + 4)|0; //@line 83630 "c/sqlite3.c"
        $2169 = $2168; //@line 83630 "c/sqlite3.c"
        HEAP32[$2169>>2] = $2165; //@line 83630 "c/sqlite3.c"
        $2170 = ($2160|0)==(0); //@line 83630 "c/sqlite3.c"
        $2171 = ($2163|0)==(0); //@line 83630 "c/sqlite3.c"
        $2172 = $2170 & $2171; //@line 83630 "c/sqlite3.c"
        if ($2172) {
         $$32804 = $$02801;
         label = 13;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 112:  {
        $2173 = ((($$02793)) + 4|0); //@line 83657 "c/sqlite3.c"
        $2174 = HEAP32[$2173>>2]|0; //@line 83657 "c/sqlite3.c"
        $2175 = ((($$02793)) + 12|0); //@line 83657 "c/sqlite3.c"
        $2176 = HEAP32[$2175>>2]|0; //@line 83657 "c/sqlite3.c"
        $2177 = (_allocateCursor($0,$2174,$2176,-1,3)|0); //@line 83657 "c/sqlite3.c"
        $2178 = ($2177|0)==(0|0); //@line 83658 "c/sqlite3.c"
        if ($2178) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $2179 = ((($2177)) + 2|0); //@line 83659 "c/sqlite3.c"
        HEAP8[$2179>>0] = 1; //@line 83659 "c/sqlite3.c"
        $2180 = ((($$02793)) + 8|0); //@line 83660 "c/sqlite3.c"
        $2181 = HEAP32[$2180>>2]|0; //@line 83660 "c/sqlite3.c"
        $2182 = ((($2177)) + 32|0); //@line 83660 "c/sqlite3.c"
        HEAP32[$2182>>2] = $2181; //@line 83660 "c/sqlite3.c"
        $2183 = ((($2177)) + 4|0); //@line 83661 "c/sqlite3.c"
        HEAP8[$2183>>0] = 1; //@line 83661 "c/sqlite3.c"
        $2184 = ((($2177)) + 40|0); //@line 83666 "c/sqlite3.c"
        HEAP32[$2184>>2] = 34058; //@line 83666 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 113:  {
        $2185 = HEAP32[$52>>2]|0; //@line 83678 "c/sqlite3.c"
        $2186 = ((($$02793)) + 4|0); //@line 83678 "c/sqlite3.c"
        $2187 = HEAP32[$2186>>2]|0; //@line 83678 "c/sqlite3.c"
        $2188 = (($2185) + ($2187<<2)|0); //@line 83678 "c/sqlite3.c"
        $2189 = HEAP32[$2188>>2]|0; //@line 83678 "c/sqlite3.c"
        _sqlite3VdbeFreeCursor($0,$2189); //@line 83678 "c/sqlite3.c"
        $2190 = HEAP32[$52>>2]|0; //@line 83679 "c/sqlite3.c"
        $2191 = HEAP32[$2186>>2]|0; //@line 83679 "c/sqlite3.c"
        $2192 = (($2190) + ($2191<<2)|0); //@line 83679 "c/sqlite3.c"
        HEAP32[$2192>>2] = 0; //@line 83679 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 27: case 26: case 25: case 24:  {
        $2193 = HEAP32[$53>>2]|0; //@line 83803 "c/sqlite3.c"
        $2194 = ((($$02793)) + 4|0); //@line 83803 "c/sqlite3.c"
        $2195 = HEAP32[$2194>>2]|0; //@line 83803 "c/sqlite3.c"
        $2196 = (($2193) + ($2195<<2)|0); //@line 83803 "c/sqlite3.c"
        $2197 = HEAP32[$2196>>2]|0; //@line 83803 "c/sqlite3.c"
        $2198 = $252&255; //@line 83811 "c/sqlite3.c"
        $2199 = ((($2197)) + 2|0); //@line 83813 "c/sqlite3.c"
        HEAP8[$2199>>0] = 0; //@line 83813 "c/sqlite3.c"
        $2200 = ((($2197)) + 4|0); //@line 83818 "c/sqlite3.c"
        $2201 = HEAP8[$2200>>0]|0; //@line 83818 "c/sqlite3.c"
        $2202 = ($2201<<24>>24)==(0); //@line 83818 "c/sqlite3.c"
        L498: do {
         if ($2202) {
          $2235 = ((($2197)) + 40|0); //@line 83875 "c/sqlite3.c"
          $2236 = HEAP32[$2235>>2]|0; //@line 83875 "c/sqlite3.c"
          $2237 = (_sqlite3BtreeCursorHasHint($2236)|0); //@line 83875 "c/sqlite3.c"
          $2238 = ($2237|0)!=(0); //@line 83875 "c/sqlite3.c"
          $2239 = ((($$02793)) + 16|0); //@line 83885 "c/sqlite3.c"
          $2240 = HEAP32[$2239>>2]|0; //@line 83885 "c/sqlite3.c"
          $2241 = ((($2197)) + 44|0); //@line 83888 "c/sqlite3.c"
          $2242 = HEAP32[$2241>>2]|0; //@line 83888 "c/sqlite3.c"
          HEAP32[$2>>2] = $2242; //@line 83888 "c/sqlite3.c"
          $2243 = $2240&65535; //@line 83889 "c/sqlite3.c"
          HEAP16[$122>>1] = $2243; //@line 83889 "c/sqlite3.c"
          $2244 = $2198 << 1; //@line 83898 "c/sqlite3.c"
          $2245 = $2244 & 2; //@line 83898 "c/sqlite3.c"
          $2246 = $2245 ^ 2; //@line 83898 "c/sqlite3.c"
          $2247 = (($2246) + 255)|0; //@line 83898 "c/sqlite3.c"
          $2248 = $2247&255; //@line 83898 "c/sqlite3.c"
          HEAP8[$123>>0] = $2248; //@line 83898 "c/sqlite3.c"
          $2249 = ((($$02793)) + 12|0); //@line 83904 "c/sqlite3.c"
          $2250 = HEAP32[$2249>>2]|0; //@line 83904 "c/sqlite3.c"
          $2251 = (($$02839) + (($2250*40)|0)|0); //@line 83904 "c/sqlite3.c"
          HEAP32[$124>>2] = $2251; //@line 83904 "c/sqlite3.c"
          HEAP8[$125>>0] = 0; //@line 83908 "c/sqlite3.c"
          $2252 = (_sqlite3BtreeMovetoUnpacked($2236,$2,0,0,0,$1)|0); //@line 83909 "c/sqlite3.c"
          $2253 = ($2252|0)==(0); //@line 83910 "c/sqlite3.c"
          if (!($2253)) {
           $$40$ph = $2252;
           label = 459;
           break L8;
          }
          $spec$select3039 = $2238&1; //@line 83875 "c/sqlite3.c"
          $2254 = HEAP8[$125>>0]|0; //@line 83913 "c/sqlite3.c"
          $2255 = ($2254<<24>>24)==(0); //@line 83913 "c/sqlite3.c"
          $or$cond3041 = $2238 & $2255; //@line 83913 "c/sqlite3.c"
          if ($or$cond3041) {
           $$pr = HEAP32[$1>>2]|0; //@line 83961 "c/sqlite3.c"
           $2272 = ($$pr|0)==(0); //@line 83961 "c/sqlite3.c"
           $2273 = ((($$02793)) + 20|0); //@line 83965 "c/sqlite3.c"
           if ($2272) {
            $spec$select30423153 = $2273;
            label = 461;
           } else {
            $$40$ph3160 = 0;
            label = 460;
           }
          } else {
           $$12995 = $2198;$$12997 = $spec$select3039;
           label = 446;
          }
         } else {
          $2203 = ((($$02793)) + 12|0); //@line 83826 "c/sqlite3.c"
          $2204 = HEAP32[$2203>>2]|0; //@line 83826 "c/sqlite3.c"
          $2205 = (($$02839) + (($2204*40)|0)|0); //@line 83826 "c/sqlite3.c"
          $2206 = (((($$02839) + (($2204*40)|0)|0)) + 8|0); //@line 83827 "c/sqlite3.c"
          $2207 = HEAP16[$2206>>1]|0; //@line 83827 "c/sqlite3.c"
          $2208 = $2207 & 14; //@line 83827 "c/sqlite3.c"
          $2209 = ($2208<<16>>16)==(2); //@line 83827 "c/sqlite3.c"
          if ($2209) {
           _applyNumericAffinity($2205,0); //@line 83828 "c/sqlite3.c"
          }
          $2210 = (_sqlite3VdbeIntValue($2205)|0); //@line 83830 "c/sqlite3.c"
          $2211 = tempRet0; //@line 83830 "c/sqlite3.c"
          $2212 = HEAP16[$2206>>1]|0; //@line 83834 "c/sqlite3.c"
          $2213 = $2212&65535; //@line 83834 "c/sqlite3.c"
          $2214 = $2213 & 4; //@line 83834 "c/sqlite3.c"
          $2215 = ($2214|0)==(0); //@line 83834 "c/sqlite3.c"
          do {
           if ($2215) {
            $2216 = $2213 & 8; //@line 83835 "c/sqlite3.c"
            $2217 = ($2216|0)==(0); //@line 83835 "c/sqlite3.c"
            if ($2217) {
             $$40$ph3160 = $$02801;
             label = 460;
             break L498;
            }
            $2218 = +HEAPF64[$2205>>3]; //@line 83849 "c/sqlite3.c"
            $2219 = (+($2210>>>0)) + (4294967296.0*(+($2211|0))); //@line 83849 "c/sqlite3.c"
            $2220 = $2218 < $2219; //@line 83849 "c/sqlite3.c"
            if ($2220) {
             $2221 = $2198 << 31; //@line 83853 "c/sqlite3.c"
             $sext = $2221 >> 31; //@line 83853 "c/sqlite3.c"
             $spec$select3036 = (($sext) + ($2198))|0; //@line 83853 "c/sqlite3.c"
             $$02994 = $spec$select3036;
             break;
            } else {
             $2222 = $2218 > $2219; //@line 83858 "c/sqlite3.c"
             $2223 = $2198 & 1; //@line 83862 "c/sqlite3.c"
             $2224 = ($2223|0)==(0); //@line 83862 "c/sqlite3.c"
             $or$cond3038 = $2224 & $2222; //@line 83858 "c/sqlite3.c"
             $2225 = $or$cond3038&1; //@line 83858 "c/sqlite3.c"
             $spec$select3074 = (($2225) + ($2198))|0; //@line 83858 "c/sqlite3.c"
             $$02994 = $spec$select3074;
             break;
            }
           } else {
            $$02994 = $2198;
           }
          } while(0);
          $2226 = ((($2197)) + 40|0); //@line 83865 "c/sqlite3.c"
          $2227 = HEAP32[$2226>>2]|0; //@line 83865 "c/sqlite3.c"
          $2228 = (_sqlite3BtreeMovetoUnpacked($2227,0,$2210,$2211,0,$1)|0); //@line 83865 "c/sqlite3.c"
          $2229 = ((($2197)) + 64|0); //@line 83866 "c/sqlite3.c"
          $2230 = $2229; //@line 83866 "c/sqlite3.c"
          $2231 = $2230; //@line 83866 "c/sqlite3.c"
          HEAP32[$2231>>2] = $2210; //@line 83866 "c/sqlite3.c"
          $2232 = (($2230) + 4)|0; //@line 83866 "c/sqlite3.c"
          $2233 = $2232; //@line 83866 "c/sqlite3.c"
          HEAP32[$2233>>2] = $2211; //@line 83866 "c/sqlite3.c"
          $2234 = ($2228|0)==(0); //@line 83867 "c/sqlite3.c"
          if ($2234) {
           $$12995 = $$02994;$$12997 = 0;
           label = 446;
          } else {
           $$40$ph = $2228;
           label = 459;
           break L8;
          }
         }
        } while(0);
        L513: do {
         if ((label|0) == 446) {
          label = 0;
          $2256 = ((($2197)) + 3|0); //@line 83918 "c/sqlite3.c"
          HEAP8[$2256>>0] = 0; //@line 83918 "c/sqlite3.c"
          $2257 = ((($2197)) + 28|0); //@line 83919 "c/sqlite3.c"
          HEAP32[$2257>>2] = 0; //@line 83919 "c/sqlite3.c"
          $2258 = ($$12995|0)>(25); //@line 83923 "c/sqlite3.c"
          $2259 = HEAP32[$1>>2]|0;
          L515: do {
           if ($2258) {
            $2260 = ($2259|0)<(0); //@line 83924 "c/sqlite3.c"
            if (!($2260)) {
             $2261 = ($2259|0)==(0); //@line 83924 "c/sqlite3.c"
             $2262 = ($$12995|0)==(27); //@line 83924 "c/sqlite3.c"
             $or$cond21 = $2262 & $2261; //@line 83924 "c/sqlite3.c"
             if (!($or$cond21)) {
              HEAP32[$1>>2] = 0; //@line 83936 "c/sqlite3.c"
              break;
             }
            }
            HEAP32[$1>>2] = 0; //@line 83925 "c/sqlite3.c"
            $2263 = ((($2197)) + 40|0); //@line 83926 "c/sqlite3.c"
            $2264 = HEAP32[$2263>>2]|0; //@line 83926 "c/sqlite3.c"
            $2265 = (_sqlite3BtreeNext($2264,0)|0); //@line 83926 "c/sqlite3.c"
            switch ($2265|0) {
            case 0:  {
             break L515;
             break;
            }
            case 101:  {
             break;
            }
            default: {
             $$40$ph = $2265;
             label = 459;
             break L8;
            }
            }
            HEAP32[$1>>2] = 1; //@line 83930 "c/sqlite3.c"
            $$40$ph3160 = 0;
            label = 460;
            break L513;
           } else {
            $2266 = ($2259|0)>(0); //@line 83940 "c/sqlite3.c"
            if (!($2266)) {
             $2267 = ($2259|0)==(0); //@line 83940 "c/sqlite3.c"
             $2268 = ($$12995|0)==(24); //@line 83940 "c/sqlite3.c"
             $or$cond23 = $2268 & $2267; //@line 83940 "c/sqlite3.c"
             if (!($or$cond23)) {
              $2276 = ((($2197)) + 40|0); //@line 83955 "c/sqlite3.c"
              $2277 = HEAP32[$2276>>2]|0; //@line 83955 "c/sqlite3.c"
              $2278 = (_sqlite3BtreeEof($2277)|0); //@line 83955 "c/sqlite3.c"
              HEAP32[$1>>2] = $2278; //@line 83955 "c/sqlite3.c"
              $2279 = ($2278|0)==(0); //@line 83961 "c/sqlite3.c"
              $2280 = ($$12997|0)==(0); //@line 83963 "c/sqlite3.c"
              $2281 = ((($$02793)) + 20|0); //@line 83965 "c/sqlite3.c"
              $$02793$ = $2280 ? $$02793 : $2281; //@line 83961 "c/sqlite3.c"
              if ($2279) {
               $spec$select30423153 = $$02793$;
               label = 461;
               break L513;
              } else {
               $$40$ph3160 = 0;
               label = 460;
               break L513;
              }
             }
            }
            HEAP32[$1>>2] = 0; //@line 83941 "c/sqlite3.c"
            $2269 = ((($2197)) + 40|0); //@line 83942 "c/sqlite3.c"
            $2270 = HEAP32[$2269>>2]|0; //@line 83942 "c/sqlite3.c"
            $2271 = (_sqlite3BtreePrevious($2270,0)|0); //@line 83942 "c/sqlite3.c"
            switch ($2271|0) {
            case 0:  {
             break L515;
             break;
            }
            case 101:  {
             break;
            }
            default: {
             $$40$ph = $2271;
             label = 459;
             break L8;
            }
            }
            HEAP32[$1>>2] = 1; //@line 83946 "c/sqlite3.c"
            $$40$ph3160 = 0;
            label = 460;
            break L513;
           }
          } while(0);
          $2274 = ($$12997|0)==(0); //@line 83963 "c/sqlite3.c"
          $2275 = ((($$02793)) + 20|0); //@line 83965 "c/sqlite3.c"
          $spec$select30423151 = $2274 ? $$02793 : $2275; //@line 83963 "c/sqlite3.c"
          $spec$select30423153 = $spec$select30423151;
          label = 461;
         }
        } while(0);
        if ((label|0) == 460) {
         label = 0;
         $$32804 = $$40$ph3160;
         label = 13;
         break L10;
        }
        else if ((label|0) == 461) {
         label = 0;
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $spec$select30423153;$$87 = 0;
         break L10;
        }
        break;
       }
       case 30: case 29: case 28:  {
        $2282 = HEAP32[$54>>2]|0; //@line 84047 "c/sqlite3.c"
        $2283 = ((($$02793)) + 4|0); //@line 84047 "c/sqlite3.c"
        $2284 = HEAP32[$2283>>2]|0; //@line 84047 "c/sqlite3.c"
        $2285 = (($2282) + ($2284<<2)|0); //@line 84047 "c/sqlite3.c"
        $2286 = HEAP32[$2285>>2]|0; //@line 84047 "c/sqlite3.c"
        $2287 = ((($$02793)) + 12|0); //@line 84052 "c/sqlite3.c"
        $2288 = HEAP32[$2287>>2]|0; //@line 84052 "c/sqlite3.c"
        $2289 = (($$02839) + (($2288*40)|0)|0); //@line 84052 "c/sqlite3.c"
        $2290 = ((($$02793)) + 16|0); //@line 84056 "c/sqlite3.c"
        $2291 = HEAP32[$2290>>2]|0; //@line 84056 "c/sqlite3.c"
        $2292 = ($2291|0)>(0); //@line 84056 "c/sqlite3.c"
        if ($2292) {
         $2293 = ((($2286)) + 44|0); //@line 84057 "c/sqlite3.c"
         $2294 = HEAP32[$2293>>2]|0; //@line 84057 "c/sqlite3.c"
         HEAP32[$2>>2] = $2294; //@line 84057 "c/sqlite3.c"
         $2295 = $2291&65535; //@line 84058 "c/sqlite3.c"
         HEAP16[$126>>1] = $2295; //@line 84058 "c/sqlite3.c"
         HEAP32[$127>>2] = $2289; //@line 84059 "c/sqlite3.c"
         $$03001 = 0;$$03002 = $2;
        } else {
         $2296 = (((($$02839) + (($2288*40)|0)|0)) + 8|0); //@line 84071 "c/sqlite3.c"
         $2297 = HEAP16[$2296>>1]|0; //@line 84071 "c/sqlite3.c"
         $2298 = $2297 & 16384; //@line 84071 "c/sqlite3.c"
         $2299 = ($2298<<16>>16)==(0); //@line 84071 "c/sqlite3.c"
         if (!($2299)) {
          $2300 = (_sqlite3VdbeMemExpandBlob($2289)|0); //@line 84071 "c/sqlite3.c"
          $2301 = ($2300|0)==(0); //@line 84073 "c/sqlite3.c"
          if (!($2301)) {
           label = 481;
           break L8;
          }
         }
         $2302 = ((($2286)) + 44|0); //@line 84074 "c/sqlite3.c"
         $2303 = HEAP32[$2302>>2]|0; //@line 84074 "c/sqlite3.c"
         $2304 = (_sqlite3VdbeAllocUnpackedRecord($2303)|0); //@line 84074 "c/sqlite3.c"
         $2305 = ($2304|0)==(0|0); //@line 84075 "c/sqlite3.c"
         if ($2305) {
          label = 481;
          break L8;
         }
         $2306 = HEAP32[$2302>>2]|0; //@line 84076 "c/sqlite3.c"
         $2307 = (((($$02839) + (($2288*40)|0)|0)) + 12|0); //@line 84076 "c/sqlite3.c"
         $2308 = HEAP32[$2307>>2]|0; //@line 84076 "c/sqlite3.c"
         $2309 = (((($$02839) + (($2288*40)|0)|0)) + 16|0); //@line 84076 "c/sqlite3.c"
         $2310 = HEAP32[$2309>>2]|0; //@line 84076 "c/sqlite3.c"
         _sqlite3VdbeRecordUnpack($2306,$2308,$2310,$2304); //@line 84076 "c/sqlite3.c"
         $$03001 = $2304;$$03002 = $2304;
        }
        $2311 = ((($$03002)) + 10|0); //@line 84078 "c/sqlite3.c"
        HEAP8[$2311>>0] = 0; //@line 84078 "c/sqlite3.c"
        $2312 = HEAP8[$$02793>>0]|0; //@line 84080 "c/sqlite3.c"
        $2313 = ($2312<<24>>24)==(28); //@line 84080 "c/sqlite3.c"
        L541: do {
         if ($2313) {
          $2314 = ((($$03002)) + 8|0); //@line 84084 "c/sqlite3.c"
          $2315 = HEAP16[$2314>>1]|0; //@line 84084 "c/sqlite3.c"
          $2316 = ($2315<<16>>16)==(0); //@line 84084 "c/sqlite3.c"
          if ($2316) {
           $$02999 = 0;
          } else {
           $2317 = ((($$03002)) + 4|0); //@line 84085 "c/sqlite3.c"
           $2318 = HEAP32[$2317>>2]|0;
           $$030003803 = 0;
           while(1) {
            $2323 = (((($2318) + (($$030003803*40)|0)|0)) + 8|0); //@line 84085 "c/sqlite3.c"
            $2324 = HEAP16[$2323>>1]|0; //@line 84085 "c/sqlite3.c"
            $2325 = $2324 & 1; //@line 84085 "c/sqlite3.c"
            $2326 = ($2325<<16>>16)==(0); //@line 84085 "c/sqlite3.c"
            $2322 = (($$030003803) + 1)|0; //@line 84084 "c/sqlite3.c"
            if (!($2326)) {
             $$02999 = 1;
             break L541;
            }
            $2319 = HEAP16[$2314>>1]|0; //@line 84084 "c/sqlite3.c"
            $2320 = $2319&65535; //@line 84084 "c/sqlite3.c"
            $2321 = ($2322>>>0)<($2320>>>0); //@line 84084 "c/sqlite3.c"
            if ($2321) {
             $$030003803 = $2322;
            } else {
             $$02999 = 0;
             break;
            }
           }
          }
         } else {
          $$02999 = 0;
         }
        } while(0);
        $2327 = ((($2286)) + 40|0); //@line 84091 "c/sqlite3.c"
        $2328 = HEAP32[$2327>>2]|0; //@line 84091 "c/sqlite3.c"
        $2329 = (_sqlite3BtreeMovetoUnpacked($2328,$$03002,0,0,0,$1)|0); //@line 84091 "c/sqlite3.c"
        $2330 = ($$03001|0)==(0|0); //@line 84092 "c/sqlite3.c"
        if (!($2330)) {
         _sqlite3DbFreeNN($8,$$03001); //@line 84092 "c/sqlite3.c"
        }
        $2331 = ($2329|0)==(0); //@line 84093 "c/sqlite3.c"
        if (!($2331)) {
         label = 482;
         break L8;
        }
        $2332 = HEAP32[$1>>2]|0; //@line 84096 "c/sqlite3.c"
        $2333 = ((($2286)) + 32|0); //@line 84096 "c/sqlite3.c"
        HEAP32[$2333>>2] = $2332; //@line 84096 "c/sqlite3.c"
        $2334 = ($2332|0)==(0); //@line 84097 "c/sqlite3.c"
        $not$ = $2334 ^ 1; //@line 84098 "c/sqlite3.c"
        $2335 = $not$&1; //@line 84098 "c/sqlite3.c"
        $2336 = ((($2286)) + 2|0); //@line 84098 "c/sqlite3.c"
        HEAP8[$2336>>0] = $2335; //@line 84098 "c/sqlite3.c"
        $2337 = ((($2286)) + 3|0); //@line 84099 "c/sqlite3.c"
        HEAP8[$2337>>0] = 0; //@line 84099 "c/sqlite3.c"
        $2338 = ((($2286)) + 28|0); //@line 84100 "c/sqlite3.c"
        HEAP32[$2338>>2] = 0; //@line 84100 "c/sqlite3.c"
        $2339 = HEAP8[$$02793>>0]|0; //@line 84101 "c/sqlite3.c"
        $2340 = ($2339<<24>>24)==(30); //@line 84101 "c/sqlite3.c"
        if ($2340) {
         if ($2334) {
          label = 480;
         } else {
          label = 479;
         }
        } else {
         $2341 = $2332 | $$02999; //@line 84106 "c/sqlite3.c"
         $2342 = ($2341|0)==(0); //@line 84106 "c/sqlite3.c"
         if ($2342) {
          label = 479;
         } else {
          label = 480;
         }
        }
        if ((label|0) == 479) {
         label = 0;
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
         break L10;
        }
        else if ((label|0) == 480) {
         label = 0;
         $$32804 = 0;
         label = 13;
         break L10;
        }
        break;
       }
       case 31:  {
        $2343 = ((($$02793)) + 12|0); //@line 84164 "c/sqlite3.c"
        $2344 = HEAP32[$2343>>2]|0; //@line 84164 "c/sqlite3.c"
        $2345 = (((($$02839) + (($2344*40)|0)|0)) + 8|0); //@line 84165 "c/sqlite3.c"
        $2346 = HEAP16[$2345>>1]|0; //@line 84165 "c/sqlite3.c"
        $2347 = $2346 & 4; //@line 84165 "c/sqlite3.c"
        $2348 = ($2347<<16>>16)==(0); //@line 84165 "c/sqlite3.c"
        if ($2348) {
         $2349 = (($$02839) + (($2344*40)|0)|0); //@line 84164 "c/sqlite3.c"
         _applyAffinity($2349,67,$10); //@line 84166 "c/sqlite3.c"
         $2350 = HEAP16[$2345>>1]|0; //@line 84167 "c/sqlite3.c"
         $2351 = $2350 & 4; //@line 84167 "c/sqlite3.c"
         $2352 = ($2351<<16>>16)==(0); //@line 84167 "c/sqlite3.c"
         if ($2352) {
          $$32804 = $$02801;
          label = 13;
         } else {
          label = 485;
         }
        } else {
         label = 485;
        }
        break;
       }
       case 32:  {
        label = 485;
        break;
       }
       case 115:  {
        $2386 = (_out2Prerelease($0,$$02793)|0); //@line 84217 "c/sqlite3.c"
        $2387 = HEAP32[$56>>2]|0; //@line 84218 "c/sqlite3.c"
        $2388 = ((($$02793)) + 4|0); //@line 84218 "c/sqlite3.c"
        $2389 = HEAP32[$2388>>2]|0; //@line 84218 "c/sqlite3.c"
        $2390 = (($2387) + ($2389<<2)|0); //@line 84218 "c/sqlite3.c"
        $2391 = HEAP32[$2390>>2]|0; //@line 84218 "c/sqlite3.c"
        $2392 = ((($2391)) + 16|0); //@line 84218 "c/sqlite3.c"
        $2393 = $2392; //@line 84218 "c/sqlite3.c"
        $2394 = $2393; //@line 84218 "c/sqlite3.c"
        $2395 = HEAP32[$2394>>2]|0; //@line 84218 "c/sqlite3.c"
        $2396 = (($2393) + 4)|0; //@line 84218 "c/sqlite3.c"
        $2397 = $2396; //@line 84218 "c/sqlite3.c"
        $2398 = HEAP32[$2397>>2]|0; //@line 84218 "c/sqlite3.c"
        $2399 = (_i64Add(($2395|0),($2398|0),1,0)|0); //@line 84218 "c/sqlite3.c"
        $2400 = tempRet0; //@line 84218 "c/sqlite3.c"
        $2401 = $2392; //@line 84218 "c/sqlite3.c"
        $2402 = $2401; //@line 84218 "c/sqlite3.c"
        HEAP32[$2402>>2] = $2399; //@line 84218 "c/sqlite3.c"
        $2403 = (($2401) + 4)|0; //@line 84218 "c/sqlite3.c"
        $2404 = $2403; //@line 84218 "c/sqlite3.c"
        HEAP32[$2404>>2] = $2400; //@line 84218 "c/sqlite3.c"
        $2405 = $2386; //@line 84218 "c/sqlite3.c"
        $2406 = $2405; //@line 84218 "c/sqlite3.c"
        HEAP32[$2406>>2] = $2395; //@line 84218 "c/sqlite3.c"
        $2407 = (($2405) + 4)|0; //@line 84218 "c/sqlite3.c"
        $2408 = $2407; //@line 84218 "c/sqlite3.c"
        HEAP32[$2408>>2] = $2398; //@line 84218 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 116:  {
        $2409 = $1; //@line 84246 "c/sqlite3.c"
        $2410 = $2409; //@line 84246 "c/sqlite3.c"
        HEAP32[$2410>>2] = 0; //@line 84246 "c/sqlite3.c"
        $2411 = (($2409) + 4)|0; //@line 84246 "c/sqlite3.c"
        $2412 = $2411; //@line 84246 "c/sqlite3.c"
        HEAP32[$2412>>2] = 0; //@line 84246 "c/sqlite3.c"
        HEAP32[$2>>2] = 0; //@line 84247 "c/sqlite3.c"
        $2413 = (_out2Prerelease($0,$$02793)|0); //@line 84248 "c/sqlite3.c"
        $2414 = HEAP32[$57>>2]|0; //@line 84250 "c/sqlite3.c"
        $2415 = ((($$02793)) + 4|0); //@line 84250 "c/sqlite3.c"
        $2416 = HEAP32[$2415>>2]|0; //@line 84250 "c/sqlite3.c"
        $2417 = (($2414) + ($2416<<2)|0); //@line 84250 "c/sqlite3.c"
        $2418 = HEAP32[$2417>>2]|0; //@line 84250 "c/sqlite3.c"
        $2419 = ((($2418)) + 5|0); //@line 84280 "c/sqlite3.c"
        $2420 = HEAP8[$2419>>0]|0; //@line 84280 "c/sqlite3.c"
        $2421 = $2420 & 2; //@line 84280 "c/sqlite3.c"
        $2422 = ($2421<<24>>24)==(0); //@line 84280 "c/sqlite3.c"
        do {
         if ($2422) {
          $2423 = ((($2418)) + 40|0); //@line 84281 "c/sqlite3.c"
          $2424 = HEAP32[$2423>>2]|0; //@line 84281 "c/sqlite3.c"
          $2425 = (_sqlite3BtreeLast($2424,$2)|0); //@line 84281 "c/sqlite3.c"
          $2426 = ($2425|0)==(0); //@line 84282 "c/sqlite3.c"
          if (!($2426)) {
           $$45$ph = $2425;
           label = 513;
           break L8;
          }
          $2427 = HEAP32[$2>>2]|0; //@line 84285 "c/sqlite3.c"
          $2428 = ($2427|0)==(0); //@line 84285 "c/sqlite3.c"
          if (!($2428)) {
           $2429 = $1; //@line 84286 "c/sqlite3.c"
           $2430 = $2429; //@line 84286 "c/sqlite3.c"
           HEAP32[$2430>>2] = 1; //@line 84286 "c/sqlite3.c"
           $2431 = (($2429) + 4)|0; //@line 84286 "c/sqlite3.c"
           $2432 = $2431; //@line 84286 "c/sqlite3.c"
           HEAP32[$2432>>2] = 0; //@line 84286 "c/sqlite3.c"
           $$43 = 0;
           break;
          }
          $2433 = HEAP32[$2423>>2]|0; //@line 84289 "c/sqlite3.c"
          $2434 = (_sqlite3BtreeIntegerKey($2433)|0); //@line 84289 "c/sqlite3.c"
          $2435 = tempRet0; //@line 84289 "c/sqlite3.c"
          $2436 = $1; //@line 84289 "c/sqlite3.c"
          $2437 = $2436; //@line 84289 "c/sqlite3.c"
          HEAP32[$2437>>2] = $2434; //@line 84289 "c/sqlite3.c"
          $2438 = (($2436) + 4)|0; //@line 84289 "c/sqlite3.c"
          $2439 = $2438; //@line 84289 "c/sqlite3.c"
          HEAP32[$2439>>2] = $2435; //@line 84289 "c/sqlite3.c"
          $2440 = ($2434|0)==(-1); //@line 84290 "c/sqlite3.c"
          $2441 = ($2435|0)==(2147483647); //@line 84290 "c/sqlite3.c"
          $2442 = $2440 & $2441; //@line 84290 "c/sqlite3.c"
          if ($2442) {
           $2443 = HEAP8[$2419>>0]|0; //@line 84291 "c/sqlite3.c"
           $2444 = $2443 | 2; //@line 84291 "c/sqlite3.c"
           HEAP8[$2419>>0] = $2444; //@line 84291 "c/sqlite3.c"
           $$43 = 0;
           break;
          } else {
           $2445 = (_i64Add(($2434|0),($2435|0),1,0)|0); //@line 84293 "c/sqlite3.c"
           $2446 = tempRet0; //@line 84293 "c/sqlite3.c"
           $2447 = $1; //@line 84293 "c/sqlite3.c"
           $2448 = $2447; //@line 84293 "c/sqlite3.c"
           HEAP32[$2448>>2] = $2445; //@line 84293 "c/sqlite3.c"
           $2449 = (($2447) + 4)|0; //@line 84293 "c/sqlite3.c"
           $2450 = $2449; //@line 84293 "c/sqlite3.c"
           HEAP32[$2450>>2] = $2446; //@line 84293 "c/sqlite3.c"
           $$43 = 0;
           break;
          }
         } else {
          $$43 = $$02801;
         }
        } while(0);
        $2451 = ((($$02793)) + 12|0); //@line 84299 "c/sqlite3.c"
        $2452 = HEAP32[$2451>>2]|0; //@line 84299 "c/sqlite3.c"
        $2453 = ($2452|0)==(0); //@line 84299 "c/sqlite3.c"
        if (!($2453)) {
         $2454 = HEAP32[$157>>2]|0; //@line 84302 "c/sqlite3.c"
         $2455 = ($2454|0)==(0|0); //@line 84302 "c/sqlite3.c"
         if ($2455) {
          $$pn3269 = $$02839;
         } else {
          $$03005 = $2454;
          while(1) {
           $2456 = ((($$03005)) + 4|0); //@line 84303 "c/sqlite3.c"
           $2457 = HEAP32[$2456>>2]|0; //@line 84303 "c/sqlite3.c"
           $2458 = ($2457|0)==(0|0); //@line 84303 "c/sqlite3.c"
           if ($2458) {
            break;
           } else {
            $$03005 = $2457;
           }
          }
          $2459 = ((($$03005)) + 16|0); //@line 84306 "c/sqlite3.c"
          $2460 = HEAP32[$2459>>2]|0; //@line 84306 "c/sqlite3.c"
          $$pn3269 = $2460;
         }
         $$03004 = (($$pn3269) + (($2452*40)|0)|0);
         _sqlite3VdbeMemIntegerify($$03004); //@line 84316 "c/sqlite3.c"
         $2461 = $$03004; //@line 84318 "c/sqlite3.c"
         $2462 = $2461; //@line 84318 "c/sqlite3.c"
         $2463 = HEAP32[$2462>>2]|0; //@line 84318 "c/sqlite3.c"
         $2464 = (($2461) + 4)|0; //@line 84318 "c/sqlite3.c"
         $2465 = $2464; //@line 84318 "c/sqlite3.c"
         $2466 = HEAP32[$2465>>2]|0; //@line 84318 "c/sqlite3.c"
         $2467 = ($2463|0)==(-1); //@line 84318 "c/sqlite3.c"
         $2468 = ($2466|0)==(2147483647); //@line 84318 "c/sqlite3.c"
         $2469 = $2467 & $2468; //@line 84318 "c/sqlite3.c"
         if ($2469) {
          $$45$ph = 13;
          label = 513;
          break L8;
         }
         $2470 = HEAP8[$2419>>0]|0; //@line 84318 "c/sqlite3.c"
         $2471 = $2470 & 2; //@line 84318 "c/sqlite3.c"
         $2472 = ($2471<<24>>24)==(0); //@line 84318 "c/sqlite3.c"
         if (!($2472)) {
          $$45$ph = 13;
          label = 513;
          break L8;
         }
         $2473 = $1; //@line 84322 "c/sqlite3.c"
         $2474 = $2473; //@line 84322 "c/sqlite3.c"
         $2475 = HEAP32[$2474>>2]|0; //@line 84322 "c/sqlite3.c"
         $2476 = (($2473) + 4)|0; //@line 84322 "c/sqlite3.c"
         $2477 = $2476; //@line 84322 "c/sqlite3.c"
         $2478 = HEAP32[$2477>>2]|0; //@line 84322 "c/sqlite3.c"
         $2479 = ($2478|0)>($2466|0); //@line 84322 "c/sqlite3.c"
         $2480 = ($2475>>>0)>($2463>>>0); //@line 84322 "c/sqlite3.c"
         $2481 = ($2478|0)==($2466|0); //@line 84322 "c/sqlite3.c"
         $2482 = $2481 & $2480; //@line 84322 "c/sqlite3.c"
         $2483 = $2479 | $2482; //@line 84322 "c/sqlite3.c"
         if (!($2483)) {
          $2484 = (_i64Add(($2463|0),($2466|0),1,0)|0); //@line 84322 "c/sqlite3.c"
          $2485 = tempRet0; //@line 84322 "c/sqlite3.c"
          $2486 = $1; //@line 84323 "c/sqlite3.c"
          $2487 = $2486; //@line 84323 "c/sqlite3.c"
          HEAP32[$2487>>2] = $2484; //@line 84323 "c/sqlite3.c"
          $2488 = (($2486) + 4)|0; //@line 84323 "c/sqlite3.c"
          $2489 = $2488; //@line 84323 "c/sqlite3.c"
          HEAP32[$2489>>2] = $2485; //@line 84323 "c/sqlite3.c"
         }
         $2490 = $1; //@line 84325 "c/sqlite3.c"
         $2491 = $2490; //@line 84325 "c/sqlite3.c"
         $2492 = HEAP32[$2491>>2]|0; //@line 84325 "c/sqlite3.c"
         $2493 = (($2490) + 4)|0; //@line 84325 "c/sqlite3.c"
         $2494 = $2493; //@line 84325 "c/sqlite3.c"
         $2495 = HEAP32[$2494>>2]|0; //@line 84325 "c/sqlite3.c"
         $2496 = $$03004; //@line 84325 "c/sqlite3.c"
         $2497 = $2496; //@line 84325 "c/sqlite3.c"
         HEAP32[$2497>>2] = $2492; //@line 84325 "c/sqlite3.c"
         $2498 = (($2496) + 4)|0; //@line 84325 "c/sqlite3.c"
         $2499 = $2498; //@line 84325 "c/sqlite3.c"
         HEAP32[$2499>>2] = $2495; //@line 84325 "c/sqlite3.c"
        }
        $2500 = HEAP8[$2419>>0]|0; //@line 84328 "c/sqlite3.c"
        $2501 = $2500 & 2; //@line 84328 "c/sqlite3.c"
        $2502 = ($2501<<24>>24)==(0); //@line 84328 "c/sqlite3.c"
        if ($2502) {
         $$44 = $$43;
        } else {
         $2503 = ((($2418)) + 40|0);
         $$03003 = 0;
         while(1) {
          _sqlite3_randomness(8,$1); //@line 84337 "c/sqlite3.c"
          $2504 = $1; //@line 84338 "c/sqlite3.c"
          $2505 = $2504; //@line 84338 "c/sqlite3.c"
          $2506 = HEAP32[$2505>>2]|0; //@line 84338 "c/sqlite3.c"
          $2507 = (($2504) + 4)|0; //@line 84338 "c/sqlite3.c"
          $2508 = $2507; //@line 84338 "c/sqlite3.c"
          $2509 = HEAP32[$2508>>2]|0; //@line 84338 "c/sqlite3.c"
          $2510 = $2509 & 1073741823; //@line 84338 "c/sqlite3.c"
          $2511 = (_i64Add(($2506|0),($2510|0),1,0)|0); //@line 84338 "c/sqlite3.c"
          $2512 = tempRet0; //@line 84338 "c/sqlite3.c"
          $2513 = $1; //@line 84338 "c/sqlite3.c"
          $2514 = $2513; //@line 84338 "c/sqlite3.c"
          HEAP32[$2514>>2] = $2511; //@line 84338 "c/sqlite3.c"
          $2515 = (($2513) + 4)|0; //@line 84338 "c/sqlite3.c"
          $2516 = $2515; //@line 84338 "c/sqlite3.c"
          HEAP32[$2516>>2] = $2512; //@line 84338 "c/sqlite3.c"
          $2517 = HEAP32[$2503>>2]|0; //@line 84339 "c/sqlite3.c"
          $2518 = (_sqlite3BtreeMovetoUnpacked($2517,0,$2511,$2512,0,$2)|0); //@line 84339 "c/sqlite3.c"
          $2519 = HEAP32[$2>>2]|0; //@line 84341 "c/sqlite3.c"
          $2520 = $2519 | $2518; //@line 84341 "c/sqlite3.c"
          $2521 = ($2520|0)==(0); //@line 84341 "c/sqlite3.c"
          if (!($2521)) {
           break;
          }
          $2522 = (($$03003) + 1)|0; //@line 84342 "c/sqlite3.c"
          $2523 = ($2522>>>0)<(100); //@line 84342 "c/sqlite3.c"
          if ($2523) {
           $$03003 = $2522;
          } else {
           break;
          }
         }
         $2524 = ($2518|0)==(0); //@line 84343 "c/sqlite3.c"
         if (!($2524)) {
          $$45$ph = $2518;
          label = 513;
          break L8;
         }
         $2525 = ($2519|0)==(0); //@line 84344 "c/sqlite3.c"
         if ($2525) {
          $$45$ph = 13;
          label = 513;
          break L8;
         } else {
          $$44 = 0;
         }
        }
        $2526 = ((($2418)) + 3|0); //@line 84350 "c/sqlite3.c"
        HEAP8[$2526>>0] = 0; //@line 84350 "c/sqlite3.c"
        $2527 = ((($2418)) + 28|0); //@line 84351 "c/sqlite3.c"
        HEAP32[$2527>>2] = 0; //@line 84351 "c/sqlite3.c"
        $2528 = $1; //@line 84353 "c/sqlite3.c"
        $2529 = $2528; //@line 84353 "c/sqlite3.c"
        $2530 = HEAP32[$2529>>2]|0; //@line 84353 "c/sqlite3.c"
        $2531 = (($2528) + 4)|0; //@line 84353 "c/sqlite3.c"
        $2532 = $2531; //@line 84353 "c/sqlite3.c"
        $2533 = HEAP32[$2532>>2]|0; //@line 84353 "c/sqlite3.c"
        $2534 = $2413; //@line 84353 "c/sqlite3.c"
        $2535 = $2534; //@line 84353 "c/sqlite3.c"
        HEAP32[$2535>>2] = $2530; //@line 84353 "c/sqlite3.c"
        $2536 = (($2534) + 4)|0; //@line 84353 "c/sqlite3.c"
        $2537 = $2536; //@line 84353 "c/sqlite3.c"
        HEAP32[$2537>>2] = $2533; //@line 84353 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$44;
        break;
       }
       case 118: case 117:  {
        $2538 = ((($$02793)) + 8|0); //@line 84410 "c/sqlite3.c"
        $2539 = HEAP32[$2538>>2]|0; //@line 84410 "c/sqlite3.c"
        $2540 = HEAP32[$58>>2]|0; //@line 84413 "c/sqlite3.c"
        $2541 = ((($$02793)) + 4|0); //@line 84413 "c/sqlite3.c"
        $2542 = HEAP32[$2541>>2]|0; //@line 84413 "c/sqlite3.c"
        $2543 = (($2540) + ($2542<<2)|0); //@line 84413 "c/sqlite3.c"
        $2544 = HEAP32[$2543>>2]|0; //@line 84413 "c/sqlite3.c"
        $2545 = ($252<<24>>24)==(117); //@line 84421 "c/sqlite3.c"
        $2546 = ((($$02793)) + 12|0);
        $2547 = HEAP32[$2546>>2]|0;
        if ($2545) {
         $2548 = (($$02839) + (($2547*40)|0)|0); //@line 84426 "c/sqlite3.c"
         $2549 = $2548; //@line 84426 "c/sqlite3.c"
         $2550 = $2549; //@line 84426 "c/sqlite3.c"
         $2551 = HEAP32[$2550>>2]|0; //@line 84426 "c/sqlite3.c"
         $2552 = (($2549) + 4)|0; //@line 84426 "c/sqlite3.c"
         $2553 = $2552; //@line 84426 "c/sqlite3.c"
         $2554 = HEAP32[$2553>>2]|0; //@line 84426 "c/sqlite3.c"
         $2555 = $128; //@line 84426 "c/sqlite3.c"
         $2556 = $2555; //@line 84426 "c/sqlite3.c"
         HEAP32[$2556>>2] = $2551; //@line 84426 "c/sqlite3.c"
         $2557 = (($2555) + 4)|0; //@line 84426 "c/sqlite3.c"
         $2558 = $2557; //@line 84426 "c/sqlite3.c"
         HEAP32[$2558>>2] = $2554; //@line 84426 "c/sqlite3.c"
        } else {
         $2559 = ($2547|0)<(0); //@line 84429 "c/sqlite3.c"
         $2560 = $2559 << 31 >> 31; //@line 84429 "c/sqlite3.c"
         $2561 = $129; //@line 84429 "c/sqlite3.c"
         $2562 = $2561; //@line 84429 "c/sqlite3.c"
         HEAP32[$2562>>2] = $2547; //@line 84429 "c/sqlite3.c"
         $2563 = (($2561) + 4)|0; //@line 84429 "c/sqlite3.c"
         $2564 = $2563; //@line 84429 "c/sqlite3.c"
         HEAP32[$2564>>2] = $2560; //@line 84429 "c/sqlite3.c"
        }
        $2565 = ((($$02793)) + 1|0); //@line 84432 "c/sqlite3.c"
        $2566 = HEAP8[$2565>>0]|0; //@line 84432 "c/sqlite3.c"
        $2567 = ($2566<<24>>24)==(-6); //@line 84432 "c/sqlite3.c"
        if ($2567) {
         $2568 = HEAP32[$158>>2]|0; //@line 84432 "c/sqlite3.c"
         $2569 = ($2568|0)==(0|0); //@line 84432 "c/sqlite3.c"
         if ($2569) {
          $$03006 = 0;$$03007 = 0;
         } else {
          $2570 = HEAP32[$171>>2]|0; //@line 84434 "c/sqlite3.c"
          $2571 = ((($2544)) + 1|0); //@line 84434 "c/sqlite3.c"
          $2572 = HEAP8[$2571>>0]|0; //@line 84434 "c/sqlite3.c"
          $2573 = $2572 << 24 >> 24; //@line 84434 "c/sqlite3.c"
          $2574 = (($2570) + ($2573<<4)|0); //@line 84434 "c/sqlite3.c"
          $2575 = HEAP32[$2574>>2]|0; //@line 84434 "c/sqlite3.c"
          $2576 = ((($$02793)) + 16|0); //@line 84435 "c/sqlite3.c"
          $2577 = HEAP32[$2576>>2]|0; //@line 84435 "c/sqlite3.c"
          $$03006 = $2575;$$03007 = $2577;
         }
        } else {
         $$03006 = 0;$$03007 = 0;
        }
        $2578 = ((($$02793)) + 2|0); //@line 84456 "c/sqlite3.c"
        $2579 = HEAP16[$2578>>1]|0; //@line 84456 "c/sqlite3.c"
        $2580 = $2579 & 1; //@line 84456 "c/sqlite3.c"
        $2581 = ($2580<<16>>16)==(0); //@line 84456 "c/sqlite3.c"
        if (!($2581)) {
         $2582 = HEAP32[$172>>2]|0; //@line 84456 "c/sqlite3.c"
         $2583 = (($2582) + 1)|0; //@line 84456 "c/sqlite3.c"
         HEAP32[$172>>2] = $2583; //@line 84456 "c/sqlite3.c"
        }
        $2584 = $2579 & 32; //@line 84457 "c/sqlite3.c"
        $2585 = ($2584<<16>>16)==(0); //@line 84457 "c/sqlite3.c"
        if (!($2585)) {
         $2586 = $199; //@line 84457 "c/sqlite3.c"
         $2587 = $2586; //@line 84457 "c/sqlite3.c"
         $2588 = HEAP32[$2587>>2]|0; //@line 84457 "c/sqlite3.c"
         $2589 = (($2586) + 4)|0; //@line 84457 "c/sqlite3.c"
         $2590 = $2589; //@line 84457 "c/sqlite3.c"
         $2591 = HEAP32[$2590>>2]|0; //@line 84457 "c/sqlite3.c"
         $2592 = $200; //@line 84457 "c/sqlite3.c"
         $2593 = $2592; //@line 84457 "c/sqlite3.c"
         HEAP32[$2593>>2] = $2588; //@line 84457 "c/sqlite3.c"
         $2594 = (($2592) + 4)|0; //@line 84457 "c/sqlite3.c"
         $2595 = $2594; //@line 84457 "c/sqlite3.c"
         HEAP32[$2595>>2] = $2591; //@line 84457 "c/sqlite3.c"
        }
        $2596 = (((($$02839) + (($2539*40)|0)|0)) + 16|0); //@line 84459 "c/sqlite3.c"
        $2597 = HEAP32[$2596>>2]|0; //@line 84459 "c/sqlite3.c"
        HEAP32[$197>>2] = $2597; //@line 84459 "c/sqlite3.c"
        $2598 = (((($$02839) + (($2539*40)|0)|0)) + 12|0); //@line 84460 "c/sqlite3.c"
        $2599 = HEAP32[$2598>>2]|0; //@line 84460 "c/sqlite3.c"
        HEAP32[$198>>2] = $2599; //@line 84460 "c/sqlite3.c"
        $2600 = $2579 & 16; //@line 84461 "c/sqlite3.c"
        $2601 = ($2600<<16>>16)==(0); //@line 84461 "c/sqlite3.c"
        if ($2601) {
         $2614 = 0;
        } else {
         $2602 = ((($2544)) + 32|0); //@line 84461 "c/sqlite3.c"
         $2603 = HEAP32[$2602>>2]|0; //@line 84461 "c/sqlite3.c"
         $2614 = $2603;
        }
        $2604 = (((($$02839) + (($2539*40)|0)|0)) + 8|0); //@line 84462 "c/sqlite3.c"
        $2605 = HEAP16[$2604>>1]|0; //@line 84462 "c/sqlite3.c"
        $2606 = $2605 & 16384; //@line 84462 "c/sqlite3.c"
        $2607 = ($2606<<16>>16)==(0); //@line 84462 "c/sqlite3.c"
        if ($2607) {
         HEAP32[$223>>2] = 0; //@line 84465 "c/sqlite3.c"
        } else {
         $2608 = (($$02839) + (($2539*40)|0)|0); //@line 84463 "c/sqlite3.c"
         $2609 = HEAP32[$2608>>2]|0; //@line 84463 "c/sqlite3.c"
         HEAP32[$224>>2] = $2609; //@line 84463 "c/sqlite3.c"
        }
        HEAP32[$1>>2] = 0; //@line 84467 "c/sqlite3.c"
        $2610 = ((($2544)) + 40|0); //@line 84468 "c/sqlite3.c"
        $2611 = HEAP32[$2610>>2]|0; //@line 84468 "c/sqlite3.c"
        $2612 = $2579 & 10; //@line 84469 "c/sqlite3.c"
        $2613 = $2612&65535; //@line 84469 "c/sqlite3.c"
        $2615 = (_sqlite3BtreeInsert($2611,$1,$2613,$2614)|0); //@line 84468 "c/sqlite3.c"
        $2616 = ((($2544)) + 3|0); //@line 84471 "c/sqlite3.c"
        HEAP8[$2616>>0] = 0; //@line 84471 "c/sqlite3.c"
        $2617 = ((($2544)) + 28|0); //@line 84472 "c/sqlite3.c"
        HEAP32[$2617>>2] = 0; //@line 84472 "c/sqlite3.c"
        $2618 = ($2615|0)==(0); //@line 84475 "c/sqlite3.c"
        if (!($2618)) {
         label = 534;
         break L8;
        }
        $2619 = ($$03007|0)==(0|0); //@line 84476 "c/sqlite3.c"
        if (!($2619)) {
         $2620 = HEAP32[$242>>2]|0; //@line 84479 "c/sqlite3.c"
         $2621 = HEAP32[$243>>2]|0; //@line 84479 "c/sqlite3.c"
         $2622 = HEAP16[$2578>>1]|0; //@line 84480 "c/sqlite3.c"
         $2623 = $2622 & 4; //@line 84480 "c/sqlite3.c"
         $2624 = ($2623<<16>>16)==(0); //@line 84480 "c/sqlite3.c"
         $2625 = $2624 ? 18 : 23; //@line 84480 "c/sqlite3.c"
         $2626 = HEAP32[$$03007>>2]|0; //@line 84481 "c/sqlite3.c"
         $2627 = $244; //@line 84481 "c/sqlite3.c"
         $2628 = $2627; //@line 84481 "c/sqlite3.c"
         $2629 = HEAP32[$2628>>2]|0; //@line 84481 "c/sqlite3.c"
         $2630 = (($2627) + 4)|0; //@line 84481 "c/sqlite3.c"
         $2631 = $2630; //@line 84481 "c/sqlite3.c"
         $2632 = HEAP32[$2631>>2]|0; //@line 84481 "c/sqlite3.c"
         FUNCTION_TABLE_viiiiii[$2620 & 127]($2621,$2625,$$03006,$2626,$2629,$2632); //@line 84479 "c/sqlite3.c"
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 119:  {
        $2633 = ((($$02793)) + 8|0); //@line 84527 "c/sqlite3.c"
        $2634 = HEAP32[$2633>>2]|0; //@line 84527 "c/sqlite3.c"
        $2635 = HEAP32[$59>>2]|0; //@line 84529 "c/sqlite3.c"
        $2636 = ((($$02793)) + 4|0); //@line 84529 "c/sqlite3.c"
        $2637 = HEAP32[$2636>>2]|0; //@line 84529 "c/sqlite3.c"
        $2638 = (($2635) + ($2637<<2)|0); //@line 84529 "c/sqlite3.c"
        $2639 = HEAP32[$2638>>2]|0; //@line 84529 "c/sqlite3.c"
        $2640 = ((($$02793)) + 1|0); //@line 84550 "c/sqlite3.c"
        $2641 = HEAP8[$2640>>0]|0; //@line 84550 "c/sqlite3.c"
        $2642 = ($2641<<24>>24)==(-6); //@line 84550 "c/sqlite3.c"
        if ($2642) {
         $2643 = HEAP32[$130>>2]|0; //@line 84550 "c/sqlite3.c"
         $2644 = ($2643|0)==(0|0); //@line 84550 "c/sqlite3.c"
         if ($2644) {
          $$03008 = 0;$$03009 = 0;
         } else {
          $2645 = HEAP32[$159>>2]|0; //@line 84553 "c/sqlite3.c"
          $2646 = ((($2639)) + 1|0); //@line 84553 "c/sqlite3.c"
          $2647 = HEAP8[$2646>>0]|0; //@line 84553 "c/sqlite3.c"
          $2648 = $2647 << 24 >> 24; //@line 84553 "c/sqlite3.c"
          $2649 = (($2645) + ($2648<<4)|0); //@line 84553 "c/sqlite3.c"
          $2650 = HEAP32[$2649>>2]|0; //@line 84553 "c/sqlite3.c"
          $2651 = ((($$02793)) + 16|0); //@line 84554 "c/sqlite3.c"
          $2652 = HEAP32[$2651>>2]|0; //@line 84554 "c/sqlite3.c"
          $2653 = ((($$02793)) + 2|0); //@line 84555 "c/sqlite3.c"
          $2654 = HEAP16[$2653>>1]|0; //@line 84555 "c/sqlite3.c"
          $2655 = $2654 & 2; //@line 84555 "c/sqlite3.c"
          $2656 = ($2655<<16>>16)==(0); //@line 84555 "c/sqlite3.c"
          if ($2656) {
           $$03008 = $2650;$$03009 = $2652;
          } else {
           $2657 = ((($2639)) + 4|0); //@line 84555 "c/sqlite3.c"
           $2658 = HEAP8[$2657>>0]|0; //@line 84555 "c/sqlite3.c"
           $2659 = ($2658<<24>>24)==(0); //@line 84555 "c/sqlite3.c"
           if ($2659) {
            $$03008 = $2650;$$03009 = $2652;
           } else {
            $2660 = ((($2639)) + 40|0); //@line 84556 "c/sqlite3.c"
            $2661 = HEAP32[$2660>>2]|0; //@line 84556 "c/sqlite3.c"
            $2662 = (_sqlite3BtreeIntegerKey($2661)|0); //@line 84556 "c/sqlite3.c"
            $2663 = tempRet0; //@line 84556 "c/sqlite3.c"
            $2664 = ((($2639)) + 64|0); //@line 84556 "c/sqlite3.c"
            $2665 = $2664; //@line 84556 "c/sqlite3.c"
            $2666 = $2665; //@line 84556 "c/sqlite3.c"
            HEAP32[$2666>>2] = $2662; //@line 84556 "c/sqlite3.c"
            $2667 = (($2665) + 4)|0; //@line 84556 "c/sqlite3.c"
            $2668 = $2667; //@line 84556 "c/sqlite3.c"
            HEAP32[$2668>>2] = $2663; //@line 84556 "c/sqlite3.c"
            $$03008 = $2650;$$03009 = $2652;
           }
          }
         }
        } else {
         $$03008 = 0;$$03009 = 0;
        }
        $2669 = ((($2639)) + 40|0); //@line 84598 "c/sqlite3.c"
        $2670 = HEAP32[$2669>>2]|0; //@line 84598 "c/sqlite3.c"
        $2671 = ((($$02793)) + 2|0); //@line 84598 "c/sqlite3.c"
        $2672 = HEAP16[$2671>>1]|0; //@line 84598 "c/sqlite3.c"
        $2673 = $2672&255; //@line 84598 "c/sqlite3.c"
        $2674 = (_sqlite3BtreeDelete($2670,$2673)|0); //@line 84598 "c/sqlite3.c"
        $2675 = ((($2639)) + 28|0); //@line 84599 "c/sqlite3.c"
        HEAP32[$2675>>2] = 0; //@line 84599 "c/sqlite3.c"
        $2676 = ((($2639)) + 32|0); //@line 84600 "c/sqlite3.c"
        HEAP32[$2676>>2] = 0; //@line 84600 "c/sqlite3.c"
        $2677 = ($2674|0)==(0); //@line 84601 "c/sqlite3.c"
        if (!($2677)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2674;$$9 = $$02793;
         break L1;
        }
        $2678 = $2634 & 1; //@line 84604 "c/sqlite3.c"
        $2679 = ($2678|0)==(0); //@line 84604 "c/sqlite3.c"
        if ($2679) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $2680 = HEAP32[$173>>2]|0; //@line 84605 "c/sqlite3.c"
         $2681 = (($2680) + 1)|0; //@line 84605 "c/sqlite3.c"
         HEAP32[$173>>2] = $2681; //@line 84605 "c/sqlite3.c"
         $2682 = HEAP32[$174>>2]|0; //@line 84606 "c/sqlite3.c"
         $2683 = ($2682|0)==(0|0); //@line 84606 "c/sqlite3.c"
         if ($2683) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
         } else {
          $2684 = ((($$03009)) + 36|0); //@line 84606 "c/sqlite3.c"
          $2685 = HEAP32[$2684>>2]|0; //@line 84606 "c/sqlite3.c"
          $2686 = $2685 & 32; //@line 84606 "c/sqlite3.c"
          $2687 = ($2686|0)==(0); //@line 84606 "c/sqlite3.c"
          if ($2687) {
           $2688 = HEAP32[$217>>2]|0; //@line 84607 "c/sqlite3.c"
           $2689 = HEAP32[$$03009>>2]|0; //@line 84607 "c/sqlite3.c"
           $2690 = ((($2639)) + 64|0); //@line 84608 "c/sqlite3.c"
           $2691 = $2690; //@line 84608 "c/sqlite3.c"
           $2692 = $2691; //@line 84608 "c/sqlite3.c"
           $2693 = HEAP32[$2692>>2]|0; //@line 84608 "c/sqlite3.c"
           $2694 = (($2691) + 4)|0; //@line 84608 "c/sqlite3.c"
           $2695 = $2694; //@line 84608 "c/sqlite3.c"
           $2696 = HEAP32[$2695>>2]|0; //@line 84608 "c/sqlite3.c"
           FUNCTION_TABLE_viiiiii[$2682 & 127]($2688,9,$$03008,$2689,$2693,$2696); //@line 84607 "c/sqlite3.c"
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
          } else {
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
          }
         }
        }
        break;
       }
       case 120:  {
        $2697 = HEAP32[$60>>2]|0; //@line 84623 "c/sqlite3.c"
        _sqlite3VdbeSetChanges($8,$2697); //@line 84623 "c/sqlite3.c"
        HEAP32[$60>>2] = 0; //@line 84624 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 121:  {
        $2698 = HEAP32[$61>>2]|0; //@line 84648 "c/sqlite3.c"
        $2699 = ((($$02793)) + 4|0); //@line 84648 "c/sqlite3.c"
        $2700 = HEAP32[$2699>>2]|0; //@line 84648 "c/sqlite3.c"
        $2701 = (($2698) + ($2700<<2)|0); //@line 84648 "c/sqlite3.c"
        $2702 = HEAP32[$2701>>2]|0; //@line 84648 "c/sqlite3.c"
        $2703 = ((($$02793)) + 12|0); //@line 84651 "c/sqlite3.c"
        $2704 = HEAP32[$2703>>2]|0; //@line 84651 "c/sqlite3.c"
        $2705 = (($$02839) + (($2704*40)|0)|0); //@line 84651 "c/sqlite3.c"
        $2706 = ((($$02793)) + 16|0); //@line 84652 "c/sqlite3.c"
        $2707 = HEAP32[$2706>>2]|0; //@line 84652 "c/sqlite3.c"
        HEAP32[$1>>2] = 0; //@line 84653 "c/sqlite3.c"
        $2708 = (_sqlite3VdbeSorterCompare($2702,$2705,$2707,$1)|0); //@line 84654 "c/sqlite3.c"
        $2709 = ($2708|0)==(0); //@line 84656 "c/sqlite3.c"
        if (!($2709)) {
         label = 547;
         break L8;
        }
        $2710 = HEAP32[$1>>2]|0; //@line 84657 "c/sqlite3.c"
        $2711 = ($2710|0)==(0); //@line 84657 "c/sqlite3.c"
        if ($2711) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$32804 = 0;
         label = 13;
        }
        break;
       }
       case 122:  {
        $2712 = ((($$02793)) + 8|0); //@line 84676 "c/sqlite3.c"
        $2713 = HEAP32[$2712>>2]|0; //@line 84676 "c/sqlite3.c"
        $2714 = (($$02839) + (($2713*40)|0)|0); //@line 84676 "c/sqlite3.c"
        $2715 = HEAP32[$62>>2]|0; //@line 84677 "c/sqlite3.c"
        $2716 = ((($$02793)) + 4|0); //@line 84677 "c/sqlite3.c"
        $2717 = HEAP32[$2716>>2]|0; //@line 84677 "c/sqlite3.c"
        $2718 = (($2715) + ($2717<<2)|0); //@line 84677 "c/sqlite3.c"
        $2719 = HEAP32[$2718>>2]|0; //@line 84677 "c/sqlite3.c"
        $2720 = (_sqlite3VdbeSorterRowkey($2719,$2714)|0); //@line 84679 "c/sqlite3.c"
        $2721 = ($2720|0)==(0); //@line 84682 "c/sqlite3.c"
        if (!($2721)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2720;$$9 = $$02793;
         break L1;
        }
        $2722 = HEAP32[$62>>2]|0; //@line 84683 "c/sqlite3.c"
        $2723 = ((($$02793)) + 12|0); //@line 84683 "c/sqlite3.c"
        $2724 = HEAP32[$2723>>2]|0; //@line 84683 "c/sqlite3.c"
        $2725 = (($2722) + ($2724<<2)|0); //@line 84683 "c/sqlite3.c"
        $2726 = HEAP32[$2725>>2]|0; //@line 84683 "c/sqlite3.c"
        $2727 = ((($2726)) + 28|0); //@line 84683 "c/sqlite3.c"
        HEAP32[$2727>>2] = 0; //@line 84683 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 123:  {
        $2728 = (_out2Prerelease($0,$$02793)|0); //@line 84720 "c/sqlite3.c"
        $2729 = HEAP32[$63>>2]|0; //@line 84723 "c/sqlite3.c"
        $2730 = ((($$02793)) + 4|0); //@line 84723 "c/sqlite3.c"
        $2731 = HEAP32[$2730>>2]|0; //@line 84723 "c/sqlite3.c"
        $2732 = (($2729) + ($2731<<2)|0); //@line 84723 "c/sqlite3.c"
        $2733 = HEAP32[$2732>>2]|0; //@line 84723 "c/sqlite3.c"
        $2734 = ((($2733)) + 40|0); //@line 84729 "c/sqlite3.c"
        $2735 = HEAP32[$2734>>2]|0; //@line 84729 "c/sqlite3.c"
        $2736 = (_sqlite3BtreePayloadSize($2735)|0); //@line 84746 "c/sqlite3.c"
        $2737 = HEAP32[$64>>2]|0; //@line 84747 "c/sqlite3.c"
        $2738 = ($2736>>>0)>($2737>>>0); //@line 84747 "c/sqlite3.c"
        if ($2738) {
         label = 852;
         break L8;
        }
        $2739 = (_sqlite3VdbeMemFromBtree($2735,0,$2736,$2728)|0); //@line 84751 "c/sqlite3.c"
        $2740 = ($2739|0)==(0); //@line 84752 "c/sqlite3.c"
        if (!($2740)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2739;$$9 = $$02793;
         break L1;
        }
        $2741 = ((($$02793)) + 12|0); //@line 84753 "c/sqlite3.c"
        $2742 = HEAP32[$2741>>2]|0; //@line 84753 "c/sqlite3.c"
        $2743 = ($2742|0)==(0); //@line 84753 "c/sqlite3.c"
        if ($2743) {
         $2744 = ((($2728)) + 8|0); //@line 84753 "c/sqlite3.c"
         $2745 = HEAP16[$2744>>1]|0; //@line 84753 "c/sqlite3.c"
         $2746 = $2745 & 4096; //@line 84753 "c/sqlite3.c"
         $2747 = ($2746<<16>>16)==(0); //@line 84753 "c/sqlite3.c"
         if ($2747) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
         } else {
          $2748 = (_sqlite3VdbeMemMakeWriteable($2728)|0); //@line 84753 "c/sqlite3.c"
          $2749 = ($2748|0)==(0); //@line 84753 "c/sqlite3.c"
          if ($2749) {
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
          } else {
           $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
           label = 853;
           break L1;
          }
         }
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        }
        break;
       }
       case 124:  {
        $2750 = (_out2Prerelease($0,$$02793)|0); //@line 84775 "c/sqlite3.c"
        $2751 = HEAP32[$65>>2]|0; //@line 84777 "c/sqlite3.c"
        $2752 = ((($$02793)) + 4|0); //@line 84777 "c/sqlite3.c"
        $2753 = HEAP32[$2752>>2]|0; //@line 84777 "c/sqlite3.c"
        $2754 = (($2751) + ($2753<<2)|0); //@line 84777 "c/sqlite3.c"
        $2755 = HEAP32[$2754>>2]|0; //@line 84777 "c/sqlite3.c"
        $2756 = ((($2755)) + 2|0); //@line 84780 "c/sqlite3.c"
        $2757 = HEAP8[$2756>>0]|0; //@line 84780 "c/sqlite3.c"
        $2758 = ($2757<<24>>24)==(0); //@line 84780 "c/sqlite3.c"
        L642: do {
         if ($2758) {
          $2760 = ((($2755)) + 3|0); //@line 84783 "c/sqlite3.c"
          $2761 = HEAP8[$2760>>0]|0; //@line 84783 "c/sqlite3.c"
          $2762 = ($2761<<24>>24)==(0); //@line 84783 "c/sqlite3.c"
          do {
           if ($2762) {
            $2774 = HEAP8[$2755>>0]|0; //@line 84786 "c/sqlite3.c"
            $2775 = ($2774<<24>>24)==(2); //@line 84786 "c/sqlite3.c"
            if ($2775) {
             $2776 = ((($2755)) + 40|0); //@line 84788 "c/sqlite3.c"
             $2777 = HEAP32[$2776>>2]|0; //@line 84788 "c/sqlite3.c"
             $2778 = HEAP32[$2777>>2]|0; //@line 84788 "c/sqlite3.c"
             $2779 = HEAP32[$2778>>2]|0; //@line 84789 "c/sqlite3.c"
             $2780 = ((($2779)) + 48|0); //@line 84791 "c/sqlite3.c"
             $2781 = HEAP32[$2780>>2]|0; //@line 84791 "c/sqlite3.c"
             $2782 = (FUNCTION_TABLE_iii[$2781 & 255]($2777,$1)|0); //@line 84791 "c/sqlite3.c"
             _sqlite3VtabImportErrmsg($0,$2778); //@line 84792 "c/sqlite3.c"
             $2783 = ($2782|0)==(0); //@line 84793 "c/sqlite3.c"
             if ($2783) {
              $$47 = 0;
              break;
             } else {
              $$48 = $2782;
              label = 568;
              break L8;
             }
            }
            $2784 = (_sqlite3VdbeCursorRestore($2755)|0); //@line 84798 "c/sqlite3.c"
            $2785 = ($2784|0)==(0); //@line 84799 "c/sqlite3.c"
            if (!($2785)) {
             $$48 = $2784;
             label = 568;
             break L8;
            }
            $2786 = HEAP8[$2756>>0]|0; //@line 84800 "c/sqlite3.c"
            $2787 = ($2786<<24>>24)==(0); //@line 84800 "c/sqlite3.c"
            if ($2787) {
             $2789 = ((($2755)) + 40|0); //@line 84804 "c/sqlite3.c"
             $2790 = HEAP32[$2789>>2]|0; //@line 84804 "c/sqlite3.c"
             $2791 = (_sqlite3BtreeIntegerKey($2790)|0); //@line 84804 "c/sqlite3.c"
             $2792 = tempRet0; //@line 84804 "c/sqlite3.c"
             $2793 = $1; //@line 84804 "c/sqlite3.c"
             $2794 = $2793; //@line 84804 "c/sqlite3.c"
             HEAP32[$2794>>2] = $2791; //@line 84804 "c/sqlite3.c"
             $2795 = (($2793) + 4)|0; //@line 84804 "c/sqlite3.c"
             $2796 = $2795; //@line 84804 "c/sqlite3.c"
             HEAP32[$2796>>2] = $2792; //@line 84804 "c/sqlite3.c"
             $$47 = 0;
             break;
            } else {
             $2788 = ((($2750)) + 8|0); //@line 84801 "c/sqlite3.c"
             HEAP16[$2788>>1] = 1; //@line 84801 "c/sqlite3.c"
             $$48$ph = 0;
             break L642;
            }
           } else {
            $2763 = ((($2755)) + 64|0); //@line 84784 "c/sqlite3.c"
            $2764 = $2763; //@line 84784 "c/sqlite3.c"
            $2765 = $2764; //@line 84784 "c/sqlite3.c"
            $2766 = HEAP32[$2765>>2]|0; //@line 84784 "c/sqlite3.c"
            $2767 = (($2764) + 4)|0; //@line 84784 "c/sqlite3.c"
            $2768 = $2767; //@line 84784 "c/sqlite3.c"
            $2769 = HEAP32[$2768>>2]|0; //@line 84784 "c/sqlite3.c"
            $2770 = $1; //@line 84784 "c/sqlite3.c"
            $2771 = $2770; //@line 84784 "c/sqlite3.c"
            HEAP32[$2771>>2] = $2766; //@line 84784 "c/sqlite3.c"
            $2772 = (($2770) + 4)|0; //@line 84784 "c/sqlite3.c"
            $2773 = $2772; //@line 84784 "c/sqlite3.c"
            HEAP32[$2773>>2] = $2769; //@line 84784 "c/sqlite3.c"
            $$47 = $$02801;
           }
          } while(0);
          $2797 = $1; //@line 84806 "c/sqlite3.c"
          $2798 = $2797; //@line 84806 "c/sqlite3.c"
          $2799 = HEAP32[$2798>>2]|0; //@line 84806 "c/sqlite3.c"
          $2800 = (($2797) + 4)|0; //@line 84806 "c/sqlite3.c"
          $2801 = $2800; //@line 84806 "c/sqlite3.c"
          $2802 = HEAP32[$2801>>2]|0; //@line 84806 "c/sqlite3.c"
          $2803 = $2750; //@line 84806 "c/sqlite3.c"
          $2804 = $2803; //@line 84806 "c/sqlite3.c"
          HEAP32[$2804>>2] = $2799; //@line 84806 "c/sqlite3.c"
          $2805 = (($2803) + 4)|0; //@line 84806 "c/sqlite3.c"
          $2806 = $2805; //@line 84806 "c/sqlite3.c"
          HEAP32[$2806>>2] = $2802; //@line 84806 "c/sqlite3.c"
          $$48$ph = $$47;
         } else {
          $2759 = ((($2750)) + 8|0); //@line 84781 "c/sqlite3.c"
          HEAP16[$2759>>1] = 1; //@line 84781 "c/sqlite3.c"
          $$48$ph = $$02801;
         }
        } while(0);
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$48$ph;
        break;
       }
       case 125:  {
        $2807 = HEAP32[$66>>2]|0; //@line 84820 "c/sqlite3.c"
        $2808 = ((($$02793)) + 4|0); //@line 84820 "c/sqlite3.c"
        $2809 = HEAP32[$2808>>2]|0; //@line 84820 "c/sqlite3.c"
        $2810 = (($2807) + ($2809<<2)|0); //@line 84820 "c/sqlite3.c"
        $2811 = HEAP32[$2810>>2]|0; //@line 84820 "c/sqlite3.c"
        $2812 = ((($2811)) + 2|0); //@line 84822 "c/sqlite3.c"
        HEAP8[$2812>>0] = 1; //@line 84822 "c/sqlite3.c"
        $2813 = ((($2811)) + 28|0); //@line 84823 "c/sqlite3.c"
        HEAP32[$2813>>2] = 0; //@line 84823 "c/sqlite3.c"
        $2814 = HEAP8[$2811>>0]|0; //@line 84824 "c/sqlite3.c"
        $2815 = ($2814<<24>>24)==(0); //@line 84824 "c/sqlite3.c"
        if ($2815) {
         $2816 = ((($2811)) + 40|0); //@line 84826 "c/sqlite3.c"
         $2817 = HEAP32[$2816>>2]|0; //@line 84826 "c/sqlite3.c"
         _sqlite3BtreeClearCursor($2817); //@line 84826 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 33: case 126:  {
        $2818 = HEAP32[$67>>2]|0; //@line 84860 "c/sqlite3.c"
        $2819 = ((($$02793)) + 4|0); //@line 84860 "c/sqlite3.c"
        $2820 = HEAP32[$2819>>2]|0; //@line 84860 "c/sqlite3.c"
        $2821 = (($2818) + ($2820<<2)|0); //@line 84860 "c/sqlite3.c"
        $2822 = HEAP32[$2821>>2]|0; //@line 84860 "c/sqlite3.c"
        $2823 = ((($2822)) + 40|0); //@line 84863 "c/sqlite3.c"
        $2824 = HEAP32[$2823>>2]|0; //@line 84863 "c/sqlite3.c"
        HEAP32[$1>>2] = 0; //@line 84864 "c/sqlite3.c"
        $2825 = ($252<<24>>24)==(126); //@line 84869 "c/sqlite3.c"
        if ($2825) {
         $2826 = ((($2822)) + 32|0); //@line 84871 "c/sqlite3.c"
         HEAP32[$2826>>2] = -1; //@line 84871 "c/sqlite3.c"
         $2827 = (_sqlite3BtreeCursorIsValidNN($2824)|0); //@line 84872 "c/sqlite3.c"
         $2828 = ($2827|0)==(0); //@line 84872 "c/sqlite3.c"
         if (!($2828)) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
        }
        $2829 = (_sqlite3BtreeLast($2824,$1)|0); //@line 84876 "c/sqlite3.c"
        $2830 = HEAP32[$1>>2]|0; //@line 84877 "c/sqlite3.c"
        $2831 = $2830&255; //@line 84877 "c/sqlite3.c"
        $2832 = ((($2822)) + 2|0); //@line 84877 "c/sqlite3.c"
        HEAP8[$2832>>0] = $2831; //@line 84877 "c/sqlite3.c"
        $2833 = ((($2822)) + 3|0); //@line 84878 "c/sqlite3.c"
        HEAP8[$2833>>0] = 0; //@line 84878 "c/sqlite3.c"
        $2834 = ((($2822)) + 28|0); //@line 84879 "c/sqlite3.c"
        HEAP32[$2834>>2] = 0; //@line 84879 "c/sqlite3.c"
        $2835 = ($2829|0)==(0); //@line 84880 "c/sqlite3.c"
        if (!($2835)) {
         label = 575;
         break L8;
        }
        $2836 = ($2830|0)!=(0); //@line 84883 "c/sqlite3.c"
        $2837 = ((($$02793)) + 8|0); //@line 84881 "c/sqlite3.c"
        $2838 = HEAP32[$2837>>2]|0; //@line 84881 "c/sqlite3.c"
        $2839 = ($2838|0)>(0); //@line 84881 "c/sqlite3.c"
        $or$cond39 = $2836 & $2839; //@line 84881 "c/sqlite3.c"
        if ($or$cond39) {
         $$32804 = 0;
         label = 13;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        }
        break;
       }
       case 34:  {
        $2840 = HEAP32[$68>>2]|0; //@line 84900 "c/sqlite3.c"
        $2841 = ((($$02793)) + 4|0); //@line 84900 "c/sqlite3.c"
        $2842 = HEAP32[$2841>>2]|0; //@line 84900 "c/sqlite3.c"
        $2843 = (($2840) + ($2842<<2)|0); //@line 84900 "c/sqlite3.c"
        $2844 = HEAP32[$2843>>2]|0; //@line 84900 "c/sqlite3.c"
        $2845 = ((($2844)) + 40|0); //@line 84902 "c/sqlite3.c"
        $2846 = HEAP32[$2845>>2]|0; //@line 84902 "c/sqlite3.c"
        $2847 = (_sqlite3BtreeFirst($2846,$1)|0); //@line 84904 "c/sqlite3.c"
        $2848 = ($2847|0)==(0); //@line 84905 "c/sqlite3.c"
        if (!($2848)) {
         label = 578;
         break L8;
        }
        $2849 = HEAP32[$1>>2]|0; //@line 84906 "c/sqlite3.c"
        $2850 = ($2849|0)==(0); //@line 84906 "c/sqlite3.c"
        do {
         if ($2850) {
          $2851 = (_sqlite3BtreeRowCountEst($2846)|0); //@line 84907 "c/sqlite3.c"
          $2852 = tempRet0; //@line 84907 "c/sqlite3.c"
          $2853 = ($2852|0)>(-1); //@line 84908 "c/sqlite3.c"
          $2854 = ($2851>>>0)>(4294967295); //@line 84908 "c/sqlite3.c"
          $2855 = ($2852|0)==(-1); //@line 84908 "c/sqlite3.c"
          $2856 = $2855 & $2854; //@line 84908 "c/sqlite3.c"
          $2857 = $2853 | $2856; //@line 84908 "c/sqlite3.c"
          if (!($2857)) {
           $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
           break L10;
          }
          $2858 = (_sqlite3LogEst($2851,$2852)|0); //@line 84908 "c/sqlite3.c"
          $2859 = $2858 << 16 >> 16; //@line 84908 "c/sqlite3.c"
          $2860 = ((($$02793)) + 12|0); //@line 84908 "c/sqlite3.c"
          $2861 = HEAP32[$2860>>2]|0; //@line 84908 "c/sqlite3.c"
          $2862 = ($2861|0)>($2859|0); //@line 84908 "c/sqlite3.c"
          if ($2862) {
           HEAP32[$1>>2] = 1; //@line 84908 "c/sqlite3.c"
           break;
          } else {
           $$pr4315 = HEAP32[$1>>2]|0; //@line 84911 "c/sqlite3.c"
           $2863 = ($$pr4315|0)==(0); //@line 84911 "c/sqlite3.c"
           if ($2863) {
            $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
            break L10;
           } else {
            $$32804 = 0;
            label = 13;
            break L10;
           }
          }
         }
        } while(0);
        $$32804 = 0;
        label = 13;
        break;
       }
       case 36: case 35:  {
        $2864 = HEAP32[$69>>2]|0; //@line 84943 "c/sqlite3.c"
        $2865 = (($2864) + 1)|0; //@line 84943 "c/sqlite3.c"
        HEAP32[$69>>2] = $2865; //@line 84943 "c/sqlite3.c"
        label = 587;
        break;
       }
       case 37:  {
        label = 587;
        break;
       }
       case 3:  {
        $2884 = HEAP32[$71>>2]|0; //@line 85062 "c/sqlite3.c"
        $2885 = ((($$02793)) + 4|0); //@line 85062 "c/sqlite3.c"
        $2886 = HEAP32[$2885>>2]|0; //@line 85062 "c/sqlite3.c"
        $2887 = (($2884) + ($2886<<2)|0); //@line 85062 "c/sqlite3.c"
        $2888 = HEAP32[$2887>>2]|0; //@line 85062 "c/sqlite3.c"
        $2889 = (_sqlite3VdbeSorterNext($8,$2888)|0); //@line 85064 "c/sqlite3.c"
        $$03010 = $2888;$$51 = $2889;
        label = 596;
        break;
       }
       case 5: case 4:  {
        $2890 = HEAP32[$72>>2]|0; //@line 85068 "c/sqlite3.c"
        $2891 = ((($$02793)) + 4|0); //@line 85068 "c/sqlite3.c"
        $2892 = HEAP32[$2891>>2]|0; //@line 85068 "c/sqlite3.c"
        $2893 = (($2890) + ($2892<<2)|0); //@line 85068 "c/sqlite3.c"
        $2894 = HEAP32[$2893>>2]|0; //@line 85068 "c/sqlite3.c"
        $2895 = ($2894|0)==(0|0); //@line 85068 "c/sqlite3.c"
        if ($2895) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         label = 595;
        }
        break;
       }
       case 7: case 6:  {
        label = 595;
        break;
       }
       case -128: case 127:  {
        $2917 = HEAP32[$74>>2]|0; //@line 85151 "c/sqlite3.c"
        $2918 = ((($$02793)) + 4|0); //@line 85151 "c/sqlite3.c"
        $2919 = HEAP32[$2918>>2]|0; //@line 85151 "c/sqlite3.c"
        $2920 = (($2917) + ($2919<<2)|0); //@line 85151 "c/sqlite3.c"
        $2921 = HEAP32[$2920>>2]|0; //@line 85151 "c/sqlite3.c"
        $2922 = ((($$02793)) + 8|0); //@line 85154 "c/sqlite3.c"
        $2923 = HEAP32[$2922>>2]|0; //@line 85154 "c/sqlite3.c"
        $2924 = (($$02839) + (($2923*40)|0)|0); //@line 85154 "c/sqlite3.c"
        $2925 = ((($$02793)) + 2|0); //@line 85156 "c/sqlite3.c"
        $2926 = HEAP16[$2925>>1]|0; //@line 85156 "c/sqlite3.c"
        $2927 = $2926 & 1; //@line 85156 "c/sqlite3.c"
        $2928 = ($2927<<16>>16)==(0); //@line 85156 "c/sqlite3.c"
        if (!($2928)) {
         $2929 = HEAP32[$131>>2]|0; //@line 85156 "c/sqlite3.c"
         $2930 = (($2929) + 1)|0; //@line 85156 "c/sqlite3.c"
         HEAP32[$131>>2] = $2930; //@line 85156 "c/sqlite3.c"
        }
        $2931 = (((($$02839) + (($2923*40)|0)|0)) + 8|0); //@line 85159 "c/sqlite3.c"
        $2932 = HEAP16[$2931>>1]|0; //@line 85159 "c/sqlite3.c"
        $2933 = $2932 & 16384; //@line 85159 "c/sqlite3.c"
        $2934 = ($2933<<16>>16)==(0); //@line 85159 "c/sqlite3.c"
        if (!($2934)) {
         $2935 = (_sqlite3VdbeMemExpandBlob($2924)|0); //@line 85159 "c/sqlite3.c"
         $2936 = ($2935|0)==(0); //@line 85160 "c/sqlite3.c"
         if (!($2936)) {
          label = 603;
          break L8;
         }
        }
        $2937 = HEAP8[$$02793>>0]|0; //@line 85161 "c/sqlite3.c"
        $2938 = ($2937<<24>>24)==(127); //@line 85161 "c/sqlite3.c"
        if ($2938) {
         $2939 = (_sqlite3VdbeSorterWrite($2921,$2924)|0); //@line 85162 "c/sqlite3.c"
         $$52 = $2939;
        } else {
         $2940 = (((($$02839) + (($2923*40)|0)|0)) + 12|0); //@line 85164 "c/sqlite3.c"
         $2941 = HEAP32[$2940>>2]|0; //@line 85164 "c/sqlite3.c"
         $2942 = ($2941|0)<(0); //@line 85164 "c/sqlite3.c"
         $2943 = $2942 << 31 >> 31; //@line 85164 "c/sqlite3.c"
         $2944 = $175; //@line 85164 "c/sqlite3.c"
         $2945 = $2944; //@line 85164 "c/sqlite3.c"
         HEAP32[$2945>>2] = $2941; //@line 85164 "c/sqlite3.c"
         $2946 = (($2944) + 4)|0; //@line 85164 "c/sqlite3.c"
         $2947 = $2946; //@line 85164 "c/sqlite3.c"
         HEAP32[$2947>>2] = $2943; //@line 85164 "c/sqlite3.c"
         $2948 = (((($$02839) + (($2923*40)|0)|0)) + 16|0); //@line 85165 "c/sqlite3.c"
         $2949 = HEAP32[$2948>>2]|0; //@line 85165 "c/sqlite3.c"
         HEAP32[$1>>2] = $2949; //@line 85165 "c/sqlite3.c"
         $2950 = ((($$02793)) + 12|0); //@line 85166 "c/sqlite3.c"
         $2951 = HEAP32[$2950>>2]|0; //@line 85166 "c/sqlite3.c"
         $2952 = (($$02839) + (($2951*40)|0)|0); //@line 85166 "c/sqlite3.c"
         HEAP32[$176>>2] = $2952; //@line 85166 "c/sqlite3.c"
         $2953 = ((($$02793)) + 16|0); //@line 85167 "c/sqlite3.c"
         $2954 = HEAP32[$2953>>2]|0; //@line 85167 "c/sqlite3.c"
         $2955 = $2954&65535; //@line 85167 "c/sqlite3.c"
         HEAP16[$177>>1] = $2955; //@line 85167 "c/sqlite3.c"
         $2956 = ((($2921)) + 40|0); //@line 85168 "c/sqlite3.c"
         $2957 = HEAP32[$2956>>2]|0; //@line 85168 "c/sqlite3.c"
         $2958 = HEAP16[$2925>>1]|0; //@line 85169 "c/sqlite3.c"
         $2959 = $2958&65535; //@line 85169 "c/sqlite3.c"
         $2960 = $2959 & 10; //@line 85169 "c/sqlite3.c"
         $2961 = $2959 & 16; //@line 85170 "c/sqlite3.c"
         $2962 = ($2961|0)==(0); //@line 85170 "c/sqlite3.c"
         if ($2962) {
          $2965 = 0;
         } else {
          $2963 = ((($2921)) + 32|0); //@line 85170 "c/sqlite3.c"
          $2964 = HEAP32[$2963>>2]|0; //@line 85170 "c/sqlite3.c"
          $2965 = $2964;
         }
         $2966 = (_sqlite3BtreeInsert($2957,$1,$2960,$2965)|0); //@line 85168 "c/sqlite3.c"
         $2967 = ((($2921)) + 28|0); //@line 85173 "c/sqlite3.c"
         HEAP32[$2967>>2] = 0; //@line 85173 "c/sqlite3.c"
         $$52 = $2966;
        }
        $2968 = ($$52|0)==(0); //@line 85175 "c/sqlite3.c"
        if ($2968) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$52;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -127:  {
        $2969 = HEAP32[$75>>2]|0; //@line 85195 "c/sqlite3.c"
        $2970 = ((($$02793)) + 4|0); //@line 85195 "c/sqlite3.c"
        $2971 = HEAP32[$2970>>2]|0; //@line 85195 "c/sqlite3.c"
        $2972 = (($2969) + ($2971<<2)|0); //@line 85195 "c/sqlite3.c"
        $2973 = HEAP32[$2972>>2]|0; //@line 85195 "c/sqlite3.c"
        $2974 = ((($2973)) + 40|0); //@line 85198 "c/sqlite3.c"
        $2975 = HEAP32[$2974>>2]|0; //@line 85198 "c/sqlite3.c"
        $2976 = ((($2973)) + 44|0); //@line 85201 "c/sqlite3.c"
        $2977 = HEAP32[$2976>>2]|0; //@line 85201 "c/sqlite3.c"
        HEAP32[$2>>2] = $2977; //@line 85201 "c/sqlite3.c"
        $2978 = ((($$02793)) + 12|0); //@line 85202 "c/sqlite3.c"
        $2979 = HEAP32[$2978>>2]|0; //@line 85202 "c/sqlite3.c"
        $2980 = $2979&65535; //@line 85202 "c/sqlite3.c"
        HEAP16[$76>>1] = $2980; //@line 85202 "c/sqlite3.c"
        HEAP8[$77>>0] = 0; //@line 85203 "c/sqlite3.c"
        $2981 = ((($$02793)) + 8|0); //@line 85204 "c/sqlite3.c"
        $2982 = HEAP32[$2981>>2]|0; //@line 85204 "c/sqlite3.c"
        $2983 = (($$02839) + (($2982*40)|0)|0); //@line 85204 "c/sqlite3.c"
        HEAP32[$78>>2] = $2983; //@line 85204 "c/sqlite3.c"
        $2984 = (_sqlite3BtreeMovetoUnpacked($2975,$2,0,0,0,$1)|0); //@line 85205 "c/sqlite3.c"
        $2985 = ($2984|0)==(0); //@line 85206 "c/sqlite3.c"
        if (!($2985)) {
         $$55$ph = $2984;
         label = 613;
         break L8;
        }
        $2986 = HEAP32[$1>>2]|0; //@line 85207 "c/sqlite3.c"
        $2987 = ($2986|0)==(0); //@line 85207 "c/sqlite3.c"
        if ($2987) {
         $2988 = (_sqlite3BtreeDelete($2975,4)|0); //@line 85208 "c/sqlite3.c"
         $2989 = ($2988|0)==(0); //@line 85209 "c/sqlite3.c"
         if (!($2989)) {
          $$55$ph = $2988;
          label = 613;
          break L8;
         }
        }
        $2990 = ((($2973)) + 28|0); //@line 85212 "c/sqlite3.c"
        HEAP32[$2990>>2] = 0; //@line 85212 "c/sqlite3.c"
        $2991 = ((($2973)) + 32|0); //@line 85213 "c/sqlite3.c"
        HEAP32[$2991>>2] = 0; //@line 85213 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case -125: case -126:  {
        $2992 = HEAP32[$79>>2]|0; //@line 85252 "c/sqlite3.c"
        $2993 = ((($$02793)) + 4|0); //@line 85252 "c/sqlite3.c"
        $2994 = HEAP32[$2993>>2]|0; //@line 85252 "c/sqlite3.c"
        $2995 = (($2992) + ($2994<<2)|0); //@line 85252 "c/sqlite3.c"
        $2996 = HEAP32[$2995>>2]|0; //@line 85252 "c/sqlite3.c"
        $2997 = (_sqlite3VdbeCursorRestore($2996)|0); //@line 85262 "c/sqlite3.c"
        $2998 = ($2997|0)==(0); //@line 85267 "c/sqlite3.c"
        if (!($2998)) {
         $$57 = $2997;
         label = 623;
         break L8;
        }
        $2999 = ((($2996)) + 2|0); //@line 85269 "c/sqlite3.c"
        $3000 = HEAP8[$2999>>0]|0; //@line 85269 "c/sqlite3.c"
        $3001 = ($3000<<24>>24)==(0); //@line 85269 "c/sqlite3.c"
        do {
         if ($3001) {
          $3002 = $1; //@line 85270 "c/sqlite3.c"
          $3003 = $3002; //@line 85270 "c/sqlite3.c"
          HEAP32[$3003>>2] = 0; //@line 85270 "c/sqlite3.c"
          $3004 = (($3002) + 4)|0; //@line 85270 "c/sqlite3.c"
          $3005 = $3004; //@line 85270 "c/sqlite3.c"
          HEAP32[$3005>>2] = 0; //@line 85270 "c/sqlite3.c"
          $3006 = ((($2996)) + 40|0); //@line 85271 "c/sqlite3.c"
          $3007 = HEAP32[$3006>>2]|0; //@line 85271 "c/sqlite3.c"
          $3008 = (_sqlite3VdbeIdxRowid($8,$3007,$1)|0); //@line 85271 "c/sqlite3.c"
          $3009 = ($3008|0)==(0); //@line 85272 "c/sqlite3.c"
          if (!($3009)) {
           $$57 = $3008;
           label = 623;
           break L8;
          }
          $3010 = HEAP8[$$02793>>0]|0; //@line 85275 "c/sqlite3.c"
          $3011 = ($3010<<24>>24)==(-126); //@line 85275 "c/sqlite3.c"
          if ($3011) {
           $3012 = HEAP32[$79>>2]|0; //@line 85277 "c/sqlite3.c"
           $3013 = ((($$02793)) + 12|0); //@line 85277 "c/sqlite3.c"
           $3014 = HEAP32[$3013>>2]|0; //@line 85277 "c/sqlite3.c"
           $3015 = (($3012) + ($3014<<2)|0); //@line 85277 "c/sqlite3.c"
           $3016 = HEAP32[$3015>>2]|0; //@line 85277 "c/sqlite3.c"
           $3017 = ((($3016)) + 2|0); //@line 85282 "c/sqlite3.c"
           HEAP8[$3017>>0] = 0; //@line 85282 "c/sqlite3.c"
           $3018 = $1; //@line 85283 "c/sqlite3.c"
           $3019 = $3018; //@line 85283 "c/sqlite3.c"
           $3020 = HEAP32[$3019>>2]|0; //@line 85283 "c/sqlite3.c"
           $3021 = (($3018) + 4)|0; //@line 85283 "c/sqlite3.c"
           $3022 = $3021; //@line 85283 "c/sqlite3.c"
           $3023 = HEAP32[$3022>>2]|0; //@line 85283 "c/sqlite3.c"
           $3024 = ((($3016)) + 64|0); //@line 85283 "c/sqlite3.c"
           $3025 = $3024; //@line 85283 "c/sqlite3.c"
           $3026 = $3025; //@line 85283 "c/sqlite3.c"
           HEAP32[$3026>>2] = $3020; //@line 85283 "c/sqlite3.c"
           $3027 = (($3025) + 4)|0; //@line 85283 "c/sqlite3.c"
           $3028 = $3027; //@line 85283 "c/sqlite3.c"
           HEAP32[$3028>>2] = $3023; //@line 85283 "c/sqlite3.c"
           $3029 = ((($3016)) + 3|0); //@line 85284 "c/sqlite3.c"
           HEAP8[$3029>>0] = 1; //@line 85284 "c/sqlite3.c"
           $3030 = ((($$02793)) + 16|0); //@line 85286 "c/sqlite3.c"
           $3031 = HEAP32[$3030>>2]|0; //@line 85286 "c/sqlite3.c"
           $3032 = ((($3016)) + 24|0); //@line 85286 "c/sqlite3.c"
           HEAP32[$3032>>2] = $3031; //@line 85286 "c/sqlite3.c"
           $3033 = ((($3016)) + 36|0); //@line 85287 "c/sqlite3.c"
           HEAP32[$3033>>2] = $2996; //@line 85287 "c/sqlite3.c"
           break;
          } else {
           $3034 = (_out2Prerelease($0,$$02793)|0); //@line 85289 "c/sqlite3.c"
           $3035 = $1; //@line 85290 "c/sqlite3.c"
           $3036 = $3035; //@line 85290 "c/sqlite3.c"
           $3037 = HEAP32[$3036>>2]|0; //@line 85290 "c/sqlite3.c"
           $3038 = (($3035) + 4)|0; //@line 85290 "c/sqlite3.c"
           $3039 = $3038; //@line 85290 "c/sqlite3.c"
           $3040 = HEAP32[$3039>>2]|0; //@line 85290 "c/sqlite3.c"
           $3041 = $3034; //@line 85290 "c/sqlite3.c"
           $3042 = $3041; //@line 85290 "c/sqlite3.c"
           HEAP32[$3042>>2] = $3037; //@line 85290 "c/sqlite3.c"
           $3043 = (($3041) + 4)|0; //@line 85290 "c/sqlite3.c"
           $3044 = $3043; //@line 85290 "c/sqlite3.c"
           HEAP32[$3044>>2] = $3040; //@line 85290 "c/sqlite3.c"
           break;
          }
         } else {
          $3045 = ((($$02793)) + 8|0); //@line 85294 "c/sqlite3.c"
          $3046 = HEAP32[$3045>>2]|0; //@line 85294 "c/sqlite3.c"
          $3047 = (($$02839) + (($3046*40)|0)|0); //@line 85294 "c/sqlite3.c"
          _sqlite3VdbeMemSetNull($3047); //@line 85294 "c/sqlite3.c"
         }
        } while(0);
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 41: case 40: case 39: case 38:  {
        $3048 = HEAP32[$80>>2]|0; //@line 85352 "c/sqlite3.c"
        $3049 = ((($$02793)) + 4|0); //@line 85352 "c/sqlite3.c"
        $3050 = HEAP32[$3049>>2]|0; //@line 85352 "c/sqlite3.c"
        $3051 = (($3048) + ($3050<<2)|0); //@line 85352 "c/sqlite3.c"
        $3052 = HEAP32[$3051>>2]|0; //@line 85352 "c/sqlite3.c"
        $3053 = ((($3052)) + 44|0); //@line 85360 "c/sqlite3.c"
        $3054 = HEAP32[$3053>>2]|0; //@line 85360 "c/sqlite3.c"
        HEAP32[$2>>2] = $3054; //@line 85360 "c/sqlite3.c"
        $3055 = ((($$02793)) + 16|0); //@line 85361 "c/sqlite3.c"
        $3056 = HEAP32[$3055>>2]|0; //@line 85361 "c/sqlite3.c"
        $3057 = $3056&65535; //@line 85361 "c/sqlite3.c"
        HEAP16[$81>>1] = $3057; //@line 85361 "c/sqlite3.c"
        $3058 = ($252&255)<(40); //@line 85362 "c/sqlite3.c"
        $$3048 = $3058 << 31 >> 31; //@line 85365 "c/sqlite3.c"
        HEAP8[$82>>0] = $$3048;
        $3059 = ((($$02793)) + 12|0); //@line 85369 "c/sqlite3.c"
        $3060 = HEAP32[$3059>>2]|0; //@line 85369 "c/sqlite3.c"
        $3061 = (($$02839) + (($3060*40)|0)|0); //@line 85369 "c/sqlite3.c"
        HEAP32[$83>>2] = $3061; //@line 85369 "c/sqlite3.c"
        HEAP32[$1>>2] = 0; //@line 85373 "c/sqlite3.c"
        $3062 = (_sqlite3VdbeIdxKeyCompare($8,$3052,$2,$1)|0); //@line 85374 "c/sqlite3.c"
        $3063 = HEAP8[$$02793>>0]|0; //@line 85376 "c/sqlite3.c"
        $3064 = HEAP32[$1>>2]|0;
        $3065 = ($3062|0)==(0); //@line 85384 "c/sqlite3.c"
        if (!($3065)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3062;$$9 = $$02793;
         break L1;
        }
        $3066 = $3063 & 1; //@line 85376 "c/sqlite3.c"
        $3067 = ($3066<<24>>24)==(0); //@line 85376 "c/sqlite3.c"
        $3068 = (0 - ($3064))|0; //@line 85378 "c/sqlite3.c"
        $3069 = (($3064) + 1)|0; //@line 85381 "c/sqlite3.c"
        $storemerge3011 = $3067 ? $3068 : $3069; //@line 85376 "c/sqlite3.c"
        $3070 = ($storemerge3011|0)>(0); //@line 85385 "c/sqlite3.c"
        if ($3070) {
         $$32804 = 0;
         label = 13;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        }
        break;
       }
       case -123:  {
        $3071 = (_out2Prerelease($0,$$02793)|0); //@line 85422 "c/sqlite3.c"
        $3072 = ((($3071)) + 8|0); //@line 85423 "c/sqlite3.c"
        HEAP16[$3072>>1] = 1; //@line 85423 "c/sqlite3.c"
        $3073 = HEAP32[$84>>2]|0; //@line 85424 "c/sqlite3.c"
        $3074 = HEAP32[$85>>2]|0; //@line 85424 "c/sqlite3.c"
        $3075 = (($3074) + 1)|0; //@line 85424 "c/sqlite3.c"
        $3076 = ($3073|0)>($3075|0); //@line 85424 "c/sqlite3.c"
        if ($3076) {
         label = 627;
         break L8;
        }
        $3078 = ((($$02793)) + 12|0); //@line 85429 "c/sqlite3.c"
        $3079 = HEAP32[$3078>>2]|0; //@line 85429 "c/sqlite3.c"
        HEAP32[$1>>2] = 0; //@line 85431 "c/sqlite3.c"
        $3080 = HEAP32[$132>>2]|0; //@line 85432 "c/sqlite3.c"
        $3081 = (((($3080) + ($3079<<4)|0)) + 4|0); //@line 85432 "c/sqlite3.c"
        $3082 = HEAP32[$3081>>2]|0; //@line 85432 "c/sqlite3.c"
        $3083 = ((($$02793)) + 4|0); //@line 85432 "c/sqlite3.c"
        $3084 = HEAP32[$3083>>2]|0; //@line 85432 "c/sqlite3.c"
        $3085 = (_sqlite3BtreeDropTable($3082,$3084,$1)|0); //@line 85432 "c/sqlite3.c"
        HEAP16[$3072>>1] = 4; //@line 85433 "c/sqlite3.c"
        $3086 = HEAP32[$1>>2]|0; //@line 85434 "c/sqlite3.c"
        $3087 = ($3086|0)<(0); //@line 85434 "c/sqlite3.c"
        $3088 = $3087 << 31 >> 31; //@line 85434 "c/sqlite3.c"
        $3089 = $3071; //@line 85434 "c/sqlite3.c"
        $3090 = $3089; //@line 85434 "c/sqlite3.c"
        HEAP32[$3090>>2] = $3086; //@line 85434 "c/sqlite3.c"
        $3091 = (($3089) + 4)|0; //@line 85434 "c/sqlite3.c"
        $3092 = $3091; //@line 85434 "c/sqlite3.c"
        HEAP32[$3092>>2] = $3088; //@line 85434 "c/sqlite3.c"
        $3093 = ($3085|0)==(0); //@line 85435 "c/sqlite3.c"
        if (!($3093)) {
         $$58 = $3085;
         label = 632;
         break L8;
        }
        $3094 = ($3086|0)==(0); //@line 85437 "c/sqlite3.c"
        if ($3094) {
         $$22816$ph = $$02814;
        } else {
         $3095 = (($3079) + 1)|0; //@line 85441 "c/sqlite3.c"
         $3096 = HEAP32[$3083>>2]|0; //@line 85438 "c/sqlite3.c"
         _sqlite3RootPageMoved($8,$3079,$3086,$3096); //@line 85438 "c/sqlite3.c"
         $3097 = $3095&255; //@line 85441 "c/sqlite3.c"
         $$22816$ph = $3097;
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$22816$ph;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case -122:  {
        HEAP32[$1>>2] = 0; //@line 85469 "c/sqlite3.c"
        $3098 = HEAP32[$86>>2]|0; //@line 85473 "c/sqlite3.c"
        $3099 = ((($$02793)) + 8|0); //@line 85473 "c/sqlite3.c"
        $3100 = HEAP32[$3099>>2]|0; //@line 85473 "c/sqlite3.c"
        $3101 = (((($3098) + ($3100<<4)|0)) + 4|0); //@line 85473 "c/sqlite3.c"
        $3102 = HEAP32[$3101>>2]|0; //@line 85473 "c/sqlite3.c"
        $3103 = ((($$02793)) + 4|0); //@line 85473 "c/sqlite3.c"
        $3104 = HEAP32[$3103>>2]|0; //@line 85473 "c/sqlite3.c"
        $3105 = ((($$02793)) + 12|0); //@line 85473 "c/sqlite3.c"
        $3106 = HEAP32[$3105>>2]|0; //@line 85473 "c/sqlite3.c"
        $3107 = ($3106|0)==(0); //@line 85473 "c/sqlite3.c"
        $$ = $3107 ? 0 : $1; //@line 85473 "c/sqlite3.c"
        $3108 = (_sqlite3BtreeClearTable($3102,$3104,$$)|0); //@line 85472 "c/sqlite3.c"
        $3109 = HEAP32[$3105>>2]|0; //@line 85475 "c/sqlite3.c"
        $3110 = ($3109|0)==(0); //@line 85475 "c/sqlite3.c"
        if (!($3110)) {
         $3111 = HEAP32[$1>>2]|0; //@line 85476 "c/sqlite3.c"
         $3112 = HEAP32[$133>>2]|0; //@line 85476 "c/sqlite3.c"
         $3113 = (($3112) + ($3111))|0; //@line 85476 "c/sqlite3.c"
         HEAP32[$133>>2] = $3113; //@line 85476 "c/sqlite3.c"
         $3114 = ($3109|0)>(0); //@line 85477 "c/sqlite3.c"
         $3115 = (($$02839) + (($3109*40)|0)|0); //@line 85480 "c/sqlite3.c"
         if ($3114) {
          $3116 = ($3111|0)<(0); //@line 85480 "c/sqlite3.c"
          $3117 = $3116 << 31 >> 31; //@line 85480 "c/sqlite3.c"
          $3118 = $3115; //@line 85480 "c/sqlite3.c"
          $3119 = $3118; //@line 85480 "c/sqlite3.c"
          $3120 = HEAP32[$3119>>2]|0; //@line 85480 "c/sqlite3.c"
          $3121 = (($3118) + 4)|0; //@line 85480 "c/sqlite3.c"
          $3122 = $3121; //@line 85480 "c/sqlite3.c"
          $3123 = HEAP32[$3122>>2]|0; //@line 85480 "c/sqlite3.c"
          $3124 = (_i64Add(($3120|0),($3123|0),($3111|0),($3117|0))|0); //@line 85480 "c/sqlite3.c"
          $3125 = tempRet0; //@line 85480 "c/sqlite3.c"
          $3126 = $3115; //@line 85480 "c/sqlite3.c"
          $3127 = $3126; //@line 85480 "c/sqlite3.c"
          HEAP32[$3127>>2] = $3124; //@line 85480 "c/sqlite3.c"
          $3128 = (($3126) + 4)|0; //@line 85480 "c/sqlite3.c"
          $3129 = $3128; //@line 85480 "c/sqlite3.c"
          HEAP32[$3129>>2] = $3125; //@line 85480 "c/sqlite3.c"
         }
        }
        $3130 = ($3108|0)==(0); //@line 85483 "c/sqlite3.c"
        if ($3130) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3108;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -121:  {
        $3131 = HEAP32[$87>>2]|0; //@line 85499 "c/sqlite3.c"
        $3132 = ((($$02793)) + 4|0); //@line 85499 "c/sqlite3.c"
        $3133 = HEAP32[$3132>>2]|0; //@line 85499 "c/sqlite3.c"
        $3134 = (($3131) + ($3133<<2)|0); //@line 85499 "c/sqlite3.c"
        $3135 = HEAP32[$3134>>2]|0; //@line 85499 "c/sqlite3.c"
        $3136 = HEAP8[$3135>>0]|0; //@line 85501 "c/sqlite3.c"
        $3137 = ($3136<<24>>24)==(1); //@line 85501 "c/sqlite3.c"
        if ($3137) {
         $3138 = ((($3135)) + 40|0); //@line 85502 "c/sqlite3.c"
         $3139 = HEAP32[$3138>>2]|0; //@line 85502 "c/sqlite3.c"
         _sqlite3VdbeSorterReset($8,$3139); //@line 85502 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        } else {
         $3140 = ((($3135)) + 40|0); //@line 85506 "c/sqlite3.c"
         $3141 = HEAP32[$3140>>2]|0; //@line 85506 "c/sqlite3.c"
         $3142 = (_sqlite3BtreeClearTableOfCursor($3141)|0); //@line 85506 "c/sqlite3.c"
         $3143 = ($3142|0)==(0); //@line 85507 "c/sqlite3.c"
         if ($3143) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
          break L10;
         } else {
          $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3142;$$9 = $$02793;
          break L1;
         }
        }
        break;
       }
       case -120:  {
        $3144 = (_out2Prerelease($0,$$02793)|0); //@line 85525 "c/sqlite3.c"
        HEAP32[$1>>2] = 0; //@line 85526 "c/sqlite3.c"
        $3145 = HEAP32[$88>>2]|0; //@line 85531 "c/sqlite3.c"
        $3146 = ((($$02793)) + 4|0); //@line 85531 "c/sqlite3.c"
        $3147 = HEAP32[$3146>>2]|0; //@line 85531 "c/sqlite3.c"
        $3148 = (((($3145) + ($3147<<4)|0)) + 4|0); //@line 85533 "c/sqlite3.c"
        $3149 = HEAP32[$3148>>2]|0; //@line 85533 "c/sqlite3.c"
        $3150 = ((($$02793)) + 12|0); //@line 85533 "c/sqlite3.c"
        $3151 = HEAP32[$3150>>2]|0; //@line 85533 "c/sqlite3.c"
        $3152 = (_sqlite3BtreeCreateTable($3149,$1,$3151)|0); //@line 85533 "c/sqlite3.c"
        $3153 = ($3152|0)==(0); //@line 85534 "c/sqlite3.c"
        if (!($3153)) {
         label = 642;
         break L8;
        }
        $3154 = HEAP32[$1>>2]|0; //@line 85535 "c/sqlite3.c"
        $3155 = ($3154|0)<(0); //@line 85535 "c/sqlite3.c"
        $3156 = $3155 << 31 >> 31; //@line 85535 "c/sqlite3.c"
        $3157 = $3144; //@line 85535 "c/sqlite3.c"
        $3158 = $3157; //@line 85535 "c/sqlite3.c"
        HEAP32[$3158>>2] = $3154; //@line 85535 "c/sqlite3.c"
        $3159 = (($3157) + 4)|0; //@line 85535 "c/sqlite3.c"
        $3160 = $3159; //@line 85535 "c/sqlite3.c"
        HEAP32[$3160>>2] = $3156; //@line 85535 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case -119:  {
        $3161 = HEAP8[$89>>0]|0; //@line 85544 "c/sqlite3.c"
        $3162 = (($3161) + 1)<<24>>24; //@line 85544 "c/sqlite3.c"
        HEAP8[$89>>0] = $3162; //@line 85544 "c/sqlite3.c"
        $3163 = ((($$02793)) + 16|0); //@line 85545 "c/sqlite3.c"
        $3164 = HEAP32[$3163>>2]|0; //@line 85545 "c/sqlite3.c"
        $3165 = (_sqlite3_exec($8,$3164,0,0,0)|0); //@line 85545 "c/sqlite3.c"
        $3166 = HEAP8[$89>>0]|0; //@line 85546 "c/sqlite3.c"
        $3167 = (($3166) + -1)<<24>>24; //@line 85546 "c/sqlite3.c"
        HEAP8[$89>>0] = $3167; //@line 85546 "c/sqlite3.c"
        $3168 = ($3165|0)==(0); //@line 85547 "c/sqlite3.c"
        if ($3168) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3165;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -118:  {
        $3169 = ((($$02793)) + 4|0); //@line 85575 "c/sqlite3.c"
        $3170 = HEAP32[$3169>>2]|0; //@line 85575 "c/sqlite3.c"
        HEAP32[$1>>2] = $8; //@line 85580 "c/sqlite3.c"
        HEAP32[$90>>2] = $3170; //@line 85581 "c/sqlite3.c"
        HEAP32[$92>>2] = $91; //@line 85582 "c/sqlite3.c"
        $3171 = HEAP32[$93>>2]|0; //@line 85585 "c/sqlite3.c"
        $3172 = (($3171) + ($3170<<4)|0); //@line 85585 "c/sqlite3.c"
        $3173 = HEAP32[$3172>>2]|0; //@line 85585 "c/sqlite3.c"
        $3174 = ((($$02793)) + 16|0); //@line 85585 "c/sqlite3.c"
        $3175 = HEAP32[$3174>>2]|0; //@line 85585 "c/sqlite3.c"
        HEAP32[$vararg_buffer24>>2] = $3173; //@line 85583 "c/sqlite3.c"
        $vararg_ptr27 = ((($vararg_buffer24)) + 4|0); //@line 85583 "c/sqlite3.c"
        HEAP32[$vararg_ptr27>>2] = 19754; //@line 85583 "c/sqlite3.c"
        $vararg_ptr28 = ((($vararg_buffer24)) + 8|0); //@line 85583 "c/sqlite3.c"
        HEAP32[$vararg_ptr28>>2] = $3175; //@line 85583 "c/sqlite3.c"
        $3176 = (_sqlite3MPrintf($8,34059,$vararg_buffer24)|0); //@line 85583 "c/sqlite3.c"
        $3177 = ($3176|0)==(0|0); //@line 85586 "c/sqlite3.c"
        if ($3177) {
         label = 648;
         break L8;
        }
        HEAP8[$134>>0] = 1; //@line 85590 "c/sqlite3.c"
        HEAP32[$135>>2] = 0; //@line 85591 "c/sqlite3.c"
        $3178 = (_sqlite3_exec($8,$3176,90,$1,0)|0); //@line 85593 "c/sqlite3.c"
        $3179 = ($3178|0)==(0); //@line 85594 "c/sqlite3.c"
        $3180 = HEAP32[$135>>2]|0; //@line 85594 "c/sqlite3.c"
        $spec$select3051 = $3179 ? $3180 : $3178; //@line 85594 "c/sqlite3.c"
        _sqlite3DbFreeNN($8,$3176); //@line 85595 "c/sqlite3.c"
        HEAP8[$134>>0] = 0; //@line 85596 "c/sqlite3.c"
        switch ($spec$select3051|0) {
        case 7:  {
         label = 648;
         break L8;
         break;
        }
        case 0:  {
         break;
        }
        default: {
         label = 646;
         break L8;
        }
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case -117:  {
        $3181 = ((($$02793)) + 4|0); //@line 85618 "c/sqlite3.c"
        $3182 = HEAP32[$3181>>2]|0; //@line 85618 "c/sqlite3.c"
        $3183 = (_sqlite3AnalysisLoad($8,$3182)|0); //@line 85618 "c/sqlite3.c"
        $3184 = ($3183|0)==(0); //@line 85619 "c/sqlite3.c"
        if ($3184) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3183;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -116:  {
        $3185 = ((($$02793)) + 4|0); //@line 85633 "c/sqlite3.c"
        $3186 = HEAP32[$3185>>2]|0; //@line 85633 "c/sqlite3.c"
        $3187 = ((($$02793)) + 16|0); //@line 85633 "c/sqlite3.c"
        $3188 = HEAP32[$3187>>2]|0; //@line 85633 "c/sqlite3.c"
        _sqlite3UnlinkAndDeleteTable($8,$3186,$3188); //@line 85633 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -115:  {
        $3189 = ((($$02793)) + 4|0); //@line 85646 "c/sqlite3.c"
        $3190 = HEAP32[$3189>>2]|0; //@line 85646 "c/sqlite3.c"
        $3191 = ((($$02793)) + 16|0); //@line 85646 "c/sqlite3.c"
        $3192 = HEAP32[$3191>>2]|0; //@line 85646 "c/sqlite3.c"
        _sqlite3UnlinkAndDeleteIndex($8,$3190,$3192); //@line 85646 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -114:  {
        $3193 = ((($$02793)) + 4|0); //@line 85659 "c/sqlite3.c"
        $3194 = HEAP32[$3193>>2]|0; //@line 85659 "c/sqlite3.c"
        $3195 = ((($$02793)) + 16|0); //@line 85659 "c/sqlite3.c"
        $3196 = HEAP32[$3195>>2]|0; //@line 85659 "c/sqlite3.c"
        _sqlite3UnlinkAndDeleteTrigger($8,$3194,$3196); //@line 85659 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -113:  {
        $3197 = ((($$02793)) + 8|0); //@line 85692 "c/sqlite3.c"
        $3198 = HEAP32[$3197>>2]|0; //@line 85692 "c/sqlite3.c"
        $3199 = ((($$02793)) + 16|0); //@line 85693 "c/sqlite3.c"
        $3200 = HEAP32[$3199>>2]|0; //@line 85693 "c/sqlite3.c"
        $3201 = ((($$02793)) + 12|0); //@line 85697 "c/sqlite3.c"
        $3202 = HEAP32[$3201>>2]|0; //@line 85697 "c/sqlite3.c"
        $3203 = ((($$02793)) + 4|0); //@line 85700 "c/sqlite3.c"
        $3204 = HEAP32[$3203>>2]|0; //@line 85700 "c/sqlite3.c"
        $3205 = (($$02839) + (($3204*40)|0)|0); //@line 85700 "c/sqlite3.c"
        $3206 = HEAP32[$94>>2]|0; //@line 85703 "c/sqlite3.c"
        $3207 = ((($$02793)) + 2|0); //@line 85703 "c/sqlite3.c"
        $3208 = HEAP16[$3207>>1]|0; //@line 85703 "c/sqlite3.c"
        $3209 = $3208&65535; //@line 85703 "c/sqlite3.c"
        $3210 = (((($3206) + ($3209<<4)|0)) + 4|0); //@line 85703 "c/sqlite3.c"
        $3211 = HEAP32[$3210>>2]|0; //@line 85703 "c/sqlite3.c"
        $3212 = ((($3200)) + 4|0); //@line 85703 "c/sqlite3.c"
        $3213 = (($$02839) + (($3202*40)|0)|0); //@line 85704 "c/sqlite3.c"
        $3214 = $3213; //@line 85704 "c/sqlite3.c"
        $3215 = $3214; //@line 85704 "c/sqlite3.c"
        $3216 = HEAP32[$3215>>2]|0; //@line 85704 "c/sqlite3.c"
        $3217 = (($3214) + 4)|0; //@line 85704 "c/sqlite3.c"
        $3218 = $3217; //@line 85704 "c/sqlite3.c"
        $3219 = HEAP32[$3218>>2]|0; //@line 85704 "c/sqlite3.c"
        $3220 = (($3216) + 1)|0; //@line 85704 "c/sqlite3.c"
        $3221 = (_sqlite3BtreeIntegrityCheck($3211,$3212,$3198,$3220,$1)|0); //@line 85703 "c/sqlite3.c"
        _sqlite3VdbeMemSetNull($3205); //@line 85705 "c/sqlite3.c"
        $3222 = HEAP32[$1>>2]|0; //@line 85706 "c/sqlite3.c"
        $3223 = ($3222|0)==(0); //@line 85706 "c/sqlite3.c"
        if (!($3223)) {
         $3224 = ($3221|0)==(0|0); //@line 85708 "c/sqlite3.c"
         if ($3224) {
          label = 657;
          break L8;
         }
         $3225 = (($3222) + -1)|0; //@line 85711 "c/sqlite3.c"
         $3226 = ($3225|0)<(0); //@line 85711 "c/sqlite3.c"
         $3227 = $3226 << 31 >> 31; //@line 85711 "c/sqlite3.c"
         $3228 = $3213; //@line 85711 "c/sqlite3.c"
         $3229 = $3228; //@line 85711 "c/sqlite3.c"
         $3230 = HEAP32[$3229>>2]|0; //@line 85711 "c/sqlite3.c"
         $3231 = (($3228) + 4)|0; //@line 85711 "c/sqlite3.c"
         $3232 = $3231; //@line 85711 "c/sqlite3.c"
         $3233 = HEAP32[$3232>>2]|0; //@line 85711 "c/sqlite3.c"
         $3234 = (_i64Subtract(($3230|0),($3233|0),($3225|0),($3227|0))|0); //@line 85711 "c/sqlite3.c"
         $3235 = tempRet0; //@line 85711 "c/sqlite3.c"
         $3236 = $3213; //@line 85711 "c/sqlite3.c"
         $3237 = $3236; //@line 85711 "c/sqlite3.c"
         HEAP32[$3237>>2] = $3234; //@line 85711 "c/sqlite3.c"
         $3238 = (($3236) + 4)|0; //@line 85711 "c/sqlite3.c"
         $3239 = $3238; //@line 85711 "c/sqlite3.c"
         HEAP32[$3239>>2] = $3235; //@line 85711 "c/sqlite3.c"
         (_sqlite3VdbeMemSetStr($3205,$3221,-1,1,83)|0); //@line 85712 "c/sqlite3.c"
        }
        (_sqlite3VdbeChangeEncoding($3205,$136)|0); //@line 85715 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -112:  {
        $3240 = ((($$02793)) + 4|0); //@line 85729 "c/sqlite3.c"
        $3241 = HEAP32[$3240>>2]|0; //@line 85729 "c/sqlite3.c"
        $3242 = (($$02839) + (($3241*40)|0)|0); //@line 85729 "c/sqlite3.c"
        $3243 = ((($$02793)) + 8|0); //@line 85730 "c/sqlite3.c"
        $3244 = HEAP32[$3243>>2]|0; //@line 85730 "c/sqlite3.c"
        $3245 = (((($$02839) + (($3241*40)|0)|0)) + 8|0); //@line 85732 "c/sqlite3.c"
        $3246 = HEAP16[$3245>>1]|0; //@line 85732 "c/sqlite3.c"
        $3247 = $3246 & 32; //@line 85732 "c/sqlite3.c"
        $3248 = ($3247<<16>>16)==(0); //@line 85732 "c/sqlite3.c"
        if ($3248) {
         _sqlite3VdbeMemSetRowSet($3242); //@line 85733 "c/sqlite3.c"
         $3249 = HEAP16[$3245>>1]|0; //@line 85734 "c/sqlite3.c"
         $3250 = $3249 & 32; //@line 85734 "c/sqlite3.c"
         $3251 = ($3250<<16>>16)==(0); //@line 85734 "c/sqlite3.c"
         if ($3251) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
        }
        $3252 = HEAP32[$3242>>2]|0; //@line 85736 "c/sqlite3.c"
        $3253 = (($$02839) + (($3244*40)|0)|0); //@line 85736 "c/sqlite3.c"
        $3254 = $3253; //@line 85736 "c/sqlite3.c"
        $3255 = $3254; //@line 85736 "c/sqlite3.c"
        $3256 = HEAP32[$3255>>2]|0; //@line 85736 "c/sqlite3.c"
        $3257 = (($3254) + 4)|0; //@line 85736 "c/sqlite3.c"
        $3258 = $3257; //@line 85736 "c/sqlite3.c"
        $3259 = HEAP32[$3258>>2]|0; //@line 85736 "c/sqlite3.c"
        _sqlite3RowSetInsert($3252,$3256,$3259); //@line 85736 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 42:  {
        $3260 = ((($$02793)) + 4|0); //@line 85751 "c/sqlite3.c"
        $3261 = HEAP32[$3260>>2]|0; //@line 85751 "c/sqlite3.c"
        $3262 = (($$02839) + (($3261*40)|0)|0); //@line 85751 "c/sqlite3.c"
        $3263 = (((($$02839) + (($3261*40)|0)|0)) + 8|0); //@line 85752 "c/sqlite3.c"
        $3264 = HEAP16[$3263>>1]|0; //@line 85752 "c/sqlite3.c"
        $3265 = $3264 & 32; //@line 85752 "c/sqlite3.c"
        $3266 = ($3265<<16>>16)==(0); //@line 85752 "c/sqlite3.c"
        if (!($3266)) {
         $3267 = HEAP32[$3262>>2]|0; //@line 85753 "c/sqlite3.c"
         $3268 = (_sqlite3RowSetNext($3267,$1)|0); //@line 85753 "c/sqlite3.c"
         $3269 = ($3268|0)==(0); //@line 85753 "c/sqlite3.c"
         if (!($3269)) {
          $3270 = ((($$02793)) + 12|0); //@line 85762 "c/sqlite3.c"
          $3271 = HEAP32[$3270>>2]|0; //@line 85762 "c/sqlite3.c"
          $3272 = (($$02839) + (($3271*40)|0)|0); //@line 85762 "c/sqlite3.c"
          $3273 = $1; //@line 85762 "c/sqlite3.c"
          $3274 = $3273; //@line 85762 "c/sqlite3.c"
          $3275 = HEAP32[$3274>>2]|0; //@line 85762 "c/sqlite3.c"
          $3276 = (($3273) + 4)|0; //@line 85762 "c/sqlite3.c"
          $3277 = $3276; //@line 85762 "c/sqlite3.c"
          $3278 = HEAP32[$3277>>2]|0; //@line 85762 "c/sqlite3.c"
          _sqlite3VdbeMemSetInt64($3272,$3275,$3278); //@line 85762 "c/sqlite3.c"
          $$12794 = $$02793;$$22803 = $$02801;
          label = 8;
          break L10;
         }
        }
        _sqlite3VdbeMemSetNull($3262); //@line 85756 "c/sqlite3.c"
        $$12802 = $$02801;
        label = 7;
        break;
       }
       case 45:  {
        $3279 = ((($$02793)) + 4|0); //@line 85794 "c/sqlite3.c"
        $3280 = HEAP32[$3279>>2]|0; //@line 85794 "c/sqlite3.c"
        $3281 = (($$02839) + (($3280*40)|0)|0); //@line 85794 "c/sqlite3.c"
        $3282 = ((($$02793)) + 12|0); //@line 85795 "c/sqlite3.c"
        $3283 = HEAP32[$3282>>2]|0; //@line 85795 "c/sqlite3.c"
        $3284 = (($$02839) + (($3283*40)|0)|0); //@line 85795 "c/sqlite3.c"
        $3285 = ((($$02793)) + 16|0); //@line 85796 "c/sqlite3.c"
        $3286 = HEAP32[$3285>>2]|0; //@line 85796 "c/sqlite3.c"
        $3287 = (((($$02839) + (($3280*40)|0)|0)) + 8|0); //@line 85802 "c/sqlite3.c"
        $3288 = HEAP16[$3287>>1]|0; //@line 85802 "c/sqlite3.c"
        $3289 = $3288 & 32; //@line 85802 "c/sqlite3.c"
        $3290 = ($3289<<16>>16)==(0); //@line 85802 "c/sqlite3.c"
        if ($3290) {
         _sqlite3VdbeMemSetRowSet($3281); //@line 85803 "c/sqlite3.c"
         $3291 = HEAP16[$3287>>1]|0; //@line 85804 "c/sqlite3.c"
         $3292 = $3291 & 32; //@line 85804 "c/sqlite3.c"
         $3293 = ($3292<<16>>16)==(0); //@line 85804 "c/sqlite3.c"
         if ($3293) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
        }
        $3294 = ($3286|0)==(0); //@line 85809 "c/sqlite3.c"
        if (!($3294)) {
         $3295 = HEAP32[$3281>>2]|0; //@line 85810 "c/sqlite3.c"
         $3296 = $3284; //@line 85810 "c/sqlite3.c"
         $3297 = $3296; //@line 85810 "c/sqlite3.c"
         $3298 = HEAP32[$3297>>2]|0; //@line 85810 "c/sqlite3.c"
         $3299 = (($3296) + 4)|0; //@line 85810 "c/sqlite3.c"
         $3300 = $3299; //@line 85810 "c/sqlite3.c"
         $3301 = HEAP32[$3300>>2]|0; //@line 85810 "c/sqlite3.c"
         $3302 = (_sqlite3RowSetTest($3295,$3286,$3298,$3301)|0); //@line 85810 "c/sqlite3.c"
         $3303 = ($3302|0)==(0); //@line 85812 "c/sqlite3.c"
         if (!($3303)) {
          $$32804 = $$02801;
          label = 13;
          break L10;
         }
         $3304 = ($3286|0)>(-1); //@line 85814 "c/sqlite3.c"
         if (!($3304)) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
        }
        $3305 = HEAP32[$3281>>2]|0; //@line 85815 "c/sqlite3.c"
        $3306 = $3284; //@line 85815 "c/sqlite3.c"
        $3307 = $3306; //@line 85815 "c/sqlite3.c"
        $3308 = HEAP32[$3307>>2]|0; //@line 85815 "c/sqlite3.c"
        $3309 = (($3306) + 4)|0; //@line 85815 "c/sqlite3.c"
        $3310 = $3309; //@line 85815 "c/sqlite3.c"
        $3311 = HEAP32[$3310>>2]|0; //@line 85815 "c/sqlite3.c"
        _sqlite3RowSetInsert($3305,$3308,$3311); //@line 85815 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 46:  {
        $3312 = ((($$02793)) + 16|0); //@line 85848 "c/sqlite3.c"
        $3313 = HEAP32[$3312>>2]|0; //@line 85848 "c/sqlite3.c"
        $3314 = ((($$02793)) + 12|0); //@line 85849 "c/sqlite3.c"
        $3315 = HEAP32[$3314>>2]|0; //@line 85849 "c/sqlite3.c"
        $3316 = (($$02839) + (($3315*40)|0)|0); //@line 85849 "c/sqlite3.c"
        $3317 = ((($$02793)) + 2|0); //@line 85863 "c/sqlite3.c"
        $3318 = HEAP16[$3317>>1]|0; //@line 85863 "c/sqlite3.c"
        $3319 = ($3318<<16>>16)==(0); //@line 85863 "c/sqlite3.c"
        if (!($3319)) {
         $3320 = ((($3313)) + 20|0); //@line 85864 "c/sqlite3.c"
         $3321 = HEAP32[$3320>>2]|0; //@line 85864 "c/sqlite3.c"
         $$029833796 = HEAP32[$139>>2]|0;
         $3322 = ($$029833796|0)==(0|0); //@line 85865 "c/sqlite3.c"
         if (!($3322)) {
          $$029833797 = $$029833796;
          while(1) {
           $3325 = ((($$029833797)) + 28|0); //@line 85865 "c/sqlite3.c"
           $3326 = HEAP32[$3325>>2]|0; //@line 85865 "c/sqlite3.c"
           $3327 = ($3326|0)==($3321|0); //@line 85865 "c/sqlite3.c"
           if ($3327) {
            $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
            break L10;
           }
           $3323 = ((($$029833797)) + 4|0); //@line 85865 "c/sqlite3.c"
           $$02983 = HEAP32[$3323>>2]|0;
           $3324 = ($$02983|0)==(0|0); //@line 85865 "c/sqlite3.c"
           if ($3324) {
            break;
           } else {
            $$029833797 = $$02983;
           }
          }
         }
        }
        $3328 = HEAP32[$137>>2]|0; //@line 85869 "c/sqlite3.c"
        $3329 = HEAP32[$138>>2]|0; //@line 85869 "c/sqlite3.c"
        $3330 = ($3328|0)<($3329|0); //@line 85869 "c/sqlite3.c"
        if (!($3330)) {
         label = 677;
         break L8;
        }
        $3331 = (((($$02839) + (($3315*40)|0)|0)) + 8|0); //@line 85879 "c/sqlite3.c"
        $3332 = HEAP16[$3331>>1]|0; //@line 85879 "c/sqlite3.c"
        $3333 = $3332 & 64; //@line 85879 "c/sqlite3.c"
        $3334 = ($3333<<16>>16)==(0); //@line 85879 "c/sqlite3.c"
        if ($3334) {
         $3335 = ((($3313)) + 8|0); //@line 85885 "c/sqlite3.c"
         $3336 = HEAP32[$3335>>2]|0; //@line 85885 "c/sqlite3.c"
         $3337 = ((($3313)) + 12|0); //@line 85885 "c/sqlite3.c"
         $3338 = HEAP32[$3337>>2]|0; //@line 85885 "c/sqlite3.c"
         $3339 = (($3338) + ($3336))|0; //@line 85885 "c/sqlite3.c"
         $3340 = ($3338|0)==(0); //@line 85887 "c/sqlite3.c"
         $3341 = $3340&1; //@line 85887 "c/sqlite3.c"
         $spec$select3055 = (($3339) + ($3341))|0; //@line 85887 "c/sqlite3.c"
         $3342 = ($spec$select3055*40)|0; //@line 85889 "c/sqlite3.c"
         $3343 = $3338 << 2; //@line 85890 "c/sqlite3.c"
         $3344 = ((($3313)) + 4|0); //@line 85891 "c/sqlite3.c"
         $3345 = HEAP32[$3344>>2]|0; //@line 85891 "c/sqlite3.c"
         $3346 = (($3345) + 7)|0; //@line 85891 "c/sqlite3.c"
         $3347 = (($3346|0) / 8)&-1; //@line 85891 "c/sqlite3.c"
         $3348 = (($3343) + 80)|0; //@line 85889 "c/sqlite3.c"
         $3349 = (($3348) + ($3347))|0; //@line 85890 "c/sqlite3.c"
         $3350 = (($3349) + ($3342))|0; //@line 85891 "c/sqlite3.c"
         $3351 = ($3350|0)<(0); //@line 85892 "c/sqlite3.c"
         $3352 = $3351 << 31 >> 31; //@line 85892 "c/sqlite3.c"
         $3353 = (_sqlite3DbMallocZero($8,$3350,$3352)|0); //@line 85892 "c/sqlite3.c"
         $3354 = ($3353|0)==(0|0); //@line 85893 "c/sqlite3.c"
         if ($3354) {
          $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
          label = 853;
          break L1;
         }
         _sqlite3VdbeMemRelease($3316); //@line 85896 "c/sqlite3.c"
         HEAP16[$3331>>1] = 64; //@line 85897 "c/sqlite3.c"
         HEAP32[$3316>>2] = $3353; //@line 85898 "c/sqlite3.c"
         HEAP32[$3353>>2] = $0; //@line 85900 "c/sqlite3.c"
         $3355 = ((($3353)) + 60|0); //@line 85901 "c/sqlite3.c"
         HEAP32[$3355>>2] = $spec$select3055; //@line 85901 "c/sqlite3.c"
         $3356 = HEAP32[$3337>>2]|0; //@line 85902 "c/sqlite3.c"
         $3357 = ((($3353)) + 64|0); //@line 85902 "c/sqlite3.c"
         HEAP32[$3357>>2] = $3356; //@line 85902 "c/sqlite3.c"
         $3358 = $$02793; //@line 85903 "c/sqlite3.c"
         $3359 = $$02792; //@line 85903 "c/sqlite3.c"
         $3360 = (($3358) - ($3359))|0; //@line 85903 "c/sqlite3.c"
         $3361 = (($3360|0) / 20)&-1; //@line 85903 "c/sqlite3.c"
         $3362 = ((($3353)) + 48|0); //@line 85903 "c/sqlite3.c"
         HEAP32[$3362>>2] = $3361; //@line 85903 "c/sqlite3.c"
         $3363 = HEAP32[$11>>2]|0; //@line 85904 "c/sqlite3.c"
         $3364 = ((($3353)) + 16|0); //@line 85904 "c/sqlite3.c"
         HEAP32[$3364>>2] = $3363; //@line 85904 "c/sqlite3.c"
         $3365 = HEAP32[$201>>2]|0; //@line 85905 "c/sqlite3.c"
         $3366 = ((($3353)) + 56|0); //@line 85905 "c/sqlite3.c"
         HEAP32[$3366>>2] = $3365; //@line 85905 "c/sqlite3.c"
         $3367 = HEAP32[$202>>2]|0; //@line 85906 "c/sqlite3.c"
         $3368 = ((($3353)) + 20|0); //@line 85906 "c/sqlite3.c"
         HEAP32[$3368>>2] = $3367; //@line 85906 "c/sqlite3.c"
         $3369 = HEAP32[$203>>2]|0; //@line 85907 "c/sqlite3.c"
         $3370 = ((($3353)) + 44|0); //@line 85907 "c/sqlite3.c"
         HEAP32[$3370>>2] = $3369; //@line 85907 "c/sqlite3.c"
         $3371 = HEAP32[$6>>2]|0; //@line 85908 "c/sqlite3.c"
         $3372 = ((($3353)) + 8|0); //@line 85908 "c/sqlite3.c"
         HEAP32[$3372>>2] = $3371; //@line 85908 "c/sqlite3.c"
         $3373 = HEAP32[$204>>2]|0; //@line 85909 "c/sqlite3.c"
         $3374 = ((($3353)) + 52|0); //@line 85909 "c/sqlite3.c"
         HEAP32[$3374>>2] = $3373; //@line 85909 "c/sqlite3.c"
         $3375 = ((($3313)) + 20|0); //@line 85910 "c/sqlite3.c"
         $3376 = HEAP32[$3375>>2]|0; //@line 85910 "c/sqlite3.c"
         $3377 = ((($3353)) + 28|0); //@line 85910 "c/sqlite3.c"
         HEAP32[$3377>>2] = $3376; //@line 85910 "c/sqlite3.c"
         $3378 = ((($3353)) + 80|0); //@line 85915 "c/sqlite3.c"
         $3379 = (($3378) + (($spec$select3055*40)|0)|0); //@line 85915 "c/sqlite3.c"
         $3380 = ($3379|0)==($3378|0); //@line 85916 "c/sqlite3.c"
         if ($3380) {
          $$12984 = $3353;$3409 = $3353;
         } else {
          $$029863800 = $3378;
          while(1) {
           $3381 = ((($$029863800)) + 8|0); //@line 85917 "c/sqlite3.c"
           HEAP16[$3381>>1] = 128; //@line 85917 "c/sqlite3.c"
           $3382 = ((($$029863800)) + 32|0); //@line 85918 "c/sqlite3.c"
           HEAP32[$3382>>2] = $8; //@line 85918 "c/sqlite3.c"
           $3383 = ((($$029863800)) + 40|0); //@line 85916 "c/sqlite3.c"
           $3384 = ($3383|0)==($3379|0); //@line 85916 "c/sqlite3.c"
           if ($3384) {
            $$12984 = $3353;$3409 = $3353;
            break;
           } else {
            $$029863800 = $3383;
           }
          }
         }
        } else {
         $3385 = HEAP32[$3316>>2]|0; //@line 85921 "c/sqlite3.c"
         $$12984 = $3385;$3409 = $3385;
        }
        $3386 = HEAP32[$137>>2]|0; //@line 85928 "c/sqlite3.c"
        $3387 = (($3386) + 1)|0; //@line 85928 "c/sqlite3.c"
        HEAP32[$137>>2] = $3387; //@line 85928 "c/sqlite3.c"
        $3388 = HEAP32[$178>>2]|0; //@line 85929 "c/sqlite3.c"
        $3389 = ((($$12984)) + 4|0); //@line 85929 "c/sqlite3.c"
        HEAP32[$3389>>2] = $3388; //@line 85929 "c/sqlite3.c"
        $3390 = $179; //@line 85930 "c/sqlite3.c"
        $3391 = $3390; //@line 85930 "c/sqlite3.c"
        $3392 = HEAP32[$3391>>2]|0; //@line 85930 "c/sqlite3.c"
        $3393 = (($3390) + 4)|0; //@line 85930 "c/sqlite3.c"
        $3394 = $3393; //@line 85930 "c/sqlite3.c"
        $3395 = HEAP32[$3394>>2]|0; //@line 85930 "c/sqlite3.c"
        $3396 = ((($$12984)) + 32|0); //@line 85930 "c/sqlite3.c"
        $3397 = $3396; //@line 85930 "c/sqlite3.c"
        $3398 = $3397; //@line 85930 "c/sqlite3.c"
        HEAP32[$3398>>2] = $3392; //@line 85930 "c/sqlite3.c"
        $3399 = (($3397) + 4)|0; //@line 85930 "c/sqlite3.c"
        $3400 = $3399; //@line 85930 "c/sqlite3.c"
        HEAP32[$3400>>2] = $3395; //@line 85930 "c/sqlite3.c"
        $3401 = HEAP32[$180>>2]|0; //@line 85931 "c/sqlite3.c"
        $3402 = ((($$12984)) + 68|0); //@line 85931 "c/sqlite3.c"
        HEAP32[$3402>>2] = $3401; //@line 85931 "c/sqlite3.c"
        $3403 = HEAP32[$0>>2]|0; //@line 85932 "c/sqlite3.c"
        $3404 = ((($3403)) + 92|0); //@line 85932 "c/sqlite3.c"
        $3405 = HEAP32[$3404>>2]|0; //@line 85932 "c/sqlite3.c"
        $3406 = ((($$12984)) + 72|0); //@line 85932 "c/sqlite3.c"
        HEAP32[$3406>>2] = $3405; //@line 85932 "c/sqlite3.c"
        $3407 = HEAP32[$181>>2]|0; //@line 85934 "c/sqlite3.c"
        $3408 = ((($$12984)) + 40|0); //@line 85934 "c/sqlite3.c"
        HEAP32[$3408>>2] = $3407; //@line 85934 "c/sqlite3.c"
        HEAP32[$181>>2] = 0; //@line 85935 "c/sqlite3.c"
        HEAP32[$180>>2] = 0; //@line 85936 "c/sqlite3.c"
        HEAP32[$178>>2] = $3409; //@line 85937 "c/sqlite3.c"
        $3410 = ((($3409)) + 80|0); //@line 85938 "c/sqlite3.c"
        HEAP32[$11>>2] = $3410; //@line 85938 "c/sqlite3.c"
        $3411 = ((($$12984)) + 60|0); //@line 85939 "c/sqlite3.c"
        $3412 = HEAP32[$3411>>2]|0; //@line 85939 "c/sqlite3.c"
        HEAP32[$182>>2] = $3412; //@line 85939 "c/sqlite3.c"
        $3413 = ((($$12984)) + 64|0); //@line 85940 "c/sqlite3.c"
        $3414 = HEAP32[$3413>>2]|0; //@line 85940 "c/sqlite3.c"
        $3415 = $3414 & 65535; //@line 85940 "c/sqlite3.c"
        HEAP32[$183>>2] = $3415; //@line 85940 "c/sqlite3.c"
        $3416 = (($3410) + (($3412*40)|0)|0); //@line 85941 "c/sqlite3.c"
        HEAP32[$184>>2] = $3416; //@line 85941 "c/sqlite3.c"
        $3417 = ((($3313)) + 12|0); //@line 85942 "c/sqlite3.c"
        $3418 = HEAP32[$3417>>2]|0; //@line 85942 "c/sqlite3.c"
        $3419 = (($3416) + ($3418<<2)|0); //@line 85942 "c/sqlite3.c"
        $3420 = ((($$12984)) + 24|0); //@line 85942 "c/sqlite3.c"
        HEAP32[$3420>>2] = $3419; //@line 85942 "c/sqlite3.c"
        $3421 = ((($3313)) + 4|0); //@line 85943 "c/sqlite3.c"
        $3422 = HEAP32[$3421>>2]|0; //@line 85943 "c/sqlite3.c"
        $3423 = (($3422) + 7)|0; //@line 85943 "c/sqlite3.c"
        $3424 = (($3423|0) / 8)&-1; //@line 85943 "c/sqlite3.c"
        _memset(($3419|0),0,($3424|0))|0; //@line 85943 "c/sqlite3.c"
        $3425 = HEAP32[$3313>>2]|0; //@line 85944 "c/sqlite3.c"
        HEAP32[$6>>2] = $3425; //@line 85944 "c/sqlite3.c"
        $3426 = HEAP32[$3421>>2]|0; //@line 85945 "c/sqlite3.c"
        HEAP32[$185>>2] = $3426; //@line 85945 "c/sqlite3.c"
        $3427 = ((($3425)) + -20|0); //@line 85949 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $3425;$$32817 = $$02814;$$32842 = $3410;$$72829 = $$02822;$$8 = $3427;$$87 = $$02801;
        break;
       }
       case -111:  {
        $3428 = (_out2Prerelease($0,$$02793)|0); //@line 85969 "c/sqlite3.c"
        $3429 = HEAP32[$95>>2]|0; //@line 85970 "c/sqlite3.c"
        $3430 = ((($3429)) + 16|0); //@line 85971 "c/sqlite3.c"
        $3431 = HEAP32[$3430>>2]|0; //@line 85971 "c/sqlite3.c"
        $3432 = ((($$02793)) + 4|0); //@line 85971 "c/sqlite3.c"
        $3433 = HEAP32[$3432>>2]|0; //@line 85971 "c/sqlite3.c"
        $3434 = ((($3429)) + 8|0); //@line 85971 "c/sqlite3.c"
        $3435 = HEAP32[$3434>>2]|0; //@line 85971 "c/sqlite3.c"
        $3436 = ((($3429)) + 48|0); //@line 85971 "c/sqlite3.c"
        $3437 = HEAP32[$3436>>2]|0; //@line 85971 "c/sqlite3.c"
        $3438 = (((($3435) + (($3437*20)|0)|0)) + 4|0); //@line 85971 "c/sqlite3.c"
        $3439 = HEAP32[$3438>>2]|0; //@line 85971 "c/sqlite3.c"
        $3440 = (($3439) + ($3433))|0; //@line 85971 "c/sqlite3.c"
        $3441 = (($3431) + (($3440*40)|0)|0); //@line 85971 "c/sqlite3.c"
        _sqlite3VdbeMemShallowCopy($3428,$3441,4096); //@line 85972 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -110:  {
        $3442 = HEAP32[$96>>2]|0; //@line 85988 "c/sqlite3.c"
        $3443 = $3442 & 524288; //@line 85988 "c/sqlite3.c"
        $3444 = ($3443|0)==(0); //@line 85988 "c/sqlite3.c"
        if (!($3444)) {
         $3445 = ((($$02793)) + 8|0); //@line 85989 "c/sqlite3.c"
         $3446 = HEAP32[$3445>>2]|0; //@line 85989 "c/sqlite3.c"
         $3447 = ($3446|0)<(0); //@line 85989 "c/sqlite3.c"
         $3448 = $3447 << 31 >> 31; //@line 85989 "c/sqlite3.c"
         $3449 = $140; //@line 85989 "c/sqlite3.c"
         $3450 = $3449; //@line 85989 "c/sqlite3.c"
         $3451 = HEAP32[$3450>>2]|0; //@line 85989 "c/sqlite3.c"
         $3452 = (($3449) + 4)|0; //@line 85989 "c/sqlite3.c"
         $3453 = $3452; //@line 85989 "c/sqlite3.c"
         $3454 = HEAP32[$3453>>2]|0; //@line 85989 "c/sqlite3.c"
         $3455 = (_i64Add(($3451|0),($3454|0),($3446|0),($3448|0))|0); //@line 85989 "c/sqlite3.c"
         $3456 = tempRet0; //@line 85989 "c/sqlite3.c"
         $3457 = $140; //@line 85989 "c/sqlite3.c"
         $3458 = $3457; //@line 85989 "c/sqlite3.c"
         HEAP32[$3458>>2] = $3455; //@line 85989 "c/sqlite3.c"
         $3459 = (($3457) + 4)|0; //@line 85989 "c/sqlite3.c"
         $3460 = $3459; //@line 85989 "c/sqlite3.c"
         HEAP32[$3460>>2] = $3456; //@line 85989 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        $3461 = ((($$02793)) + 4|0); //@line 85990 "c/sqlite3.c"
        $3462 = HEAP32[$3461>>2]|0; //@line 85990 "c/sqlite3.c"
        $3463 = ($3462|0)==(0); //@line 85990 "c/sqlite3.c"
        $3464 = ((($$02793)) + 8|0);
        $3465 = HEAP32[$3464>>2]|0;
        $3466 = ($3465|0)<(0);
        $3467 = $3466 << 31 >> 31;
        if ($3463) {
         $3480 = $160; //@line 85993 "c/sqlite3.c"
         $3481 = $3480; //@line 85993 "c/sqlite3.c"
         $3482 = HEAP32[$3481>>2]|0; //@line 85993 "c/sqlite3.c"
         $3483 = (($3480) + 4)|0; //@line 85993 "c/sqlite3.c"
         $3484 = $3483; //@line 85993 "c/sqlite3.c"
         $3485 = HEAP32[$3484>>2]|0; //@line 85993 "c/sqlite3.c"
         $3486 = (_i64Add(($3482|0),($3485|0),($3465|0),($3467|0))|0); //@line 85993 "c/sqlite3.c"
         $3487 = tempRet0; //@line 85993 "c/sqlite3.c"
         $3488 = $160; //@line 85993 "c/sqlite3.c"
         $3489 = $3488; //@line 85993 "c/sqlite3.c"
         HEAP32[$3489>>2] = $3486; //@line 85993 "c/sqlite3.c"
         $3490 = (($3488) + 4)|0; //@line 85993 "c/sqlite3.c"
         $3491 = $3490; //@line 85993 "c/sqlite3.c"
         HEAP32[$3491>>2] = $3487; //@line 85993 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        } else {
         $3468 = $161; //@line 85991 "c/sqlite3.c"
         $3469 = $3468; //@line 85991 "c/sqlite3.c"
         $3470 = HEAP32[$3469>>2]|0; //@line 85991 "c/sqlite3.c"
         $3471 = (($3468) + 4)|0; //@line 85991 "c/sqlite3.c"
         $3472 = $3471; //@line 85991 "c/sqlite3.c"
         $3473 = HEAP32[$3472>>2]|0; //@line 85991 "c/sqlite3.c"
         $3474 = (_i64Add(($3470|0),($3473|0),($3465|0),($3467|0))|0); //@line 85991 "c/sqlite3.c"
         $3475 = tempRet0; //@line 85991 "c/sqlite3.c"
         $3476 = $161; //@line 85991 "c/sqlite3.c"
         $3477 = $3476; //@line 85991 "c/sqlite3.c"
         HEAP32[$3477>>2] = $3474; //@line 85991 "c/sqlite3.c"
         $3478 = (($3476) + 4)|0; //@line 85991 "c/sqlite3.c"
         $3479 = $3478; //@line 85991 "c/sqlite3.c"
         HEAP32[$3479>>2] = $3475; //@line 85991 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        break;
       }
       case 47:  {
        $3492 = ((($$02793)) + 4|0); //@line 86011 "c/sqlite3.c"
        $3493 = HEAP32[$3492>>2]|0; //@line 86011 "c/sqlite3.c"
        $3494 = ($3493|0)==(0); //@line 86011 "c/sqlite3.c"
        if ($3494) {
         $3513 = $141; //@line 86016 "c/sqlite3.c"
         $3514 = $3513; //@line 86016 "c/sqlite3.c"
         $3515 = HEAP32[$3514>>2]|0; //@line 86016 "c/sqlite3.c"
         $3516 = (($3513) + 4)|0; //@line 86016 "c/sqlite3.c"
         $3517 = $3516; //@line 86016 "c/sqlite3.c"
         $3518 = HEAP32[$3517>>2]|0; //@line 86016 "c/sqlite3.c"
         $3519 = ($3515|0)==(0); //@line 86016 "c/sqlite3.c"
         $3520 = ($3518|0)==(0); //@line 86016 "c/sqlite3.c"
         $3521 = $3519 & $3520; //@line 86016 "c/sqlite3.c"
         if (!($3521)) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
         $3522 = $162; //@line 86016 "c/sqlite3.c"
         $3523 = $3522; //@line 86016 "c/sqlite3.c"
         $3524 = HEAP32[$3523>>2]|0; //@line 86016 "c/sqlite3.c"
         $3525 = (($3522) + 4)|0; //@line 86016 "c/sqlite3.c"
         $3526 = $3525; //@line 86016 "c/sqlite3.c"
         $3527 = HEAP32[$3526>>2]|0; //@line 86016 "c/sqlite3.c"
         $3528 = ($3524|0)==(0); //@line 86016 "c/sqlite3.c"
         $3529 = ($3527|0)==(0); //@line 86016 "c/sqlite3.c"
         $3530 = $3528 & $3529; //@line 86016 "c/sqlite3.c"
         if ($3530) {
          $$32804 = $$02801;
          label = 13;
          break L10;
         } else {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
        } else {
         $3495 = $142; //@line 86013 "c/sqlite3.c"
         $3496 = $3495; //@line 86013 "c/sqlite3.c"
         $3497 = HEAP32[$3496>>2]|0; //@line 86013 "c/sqlite3.c"
         $3498 = (($3495) + 4)|0; //@line 86013 "c/sqlite3.c"
         $3499 = $3498; //@line 86013 "c/sqlite3.c"
         $3500 = HEAP32[$3499>>2]|0; //@line 86013 "c/sqlite3.c"
         $3501 = ($3497|0)==(0); //@line 86013 "c/sqlite3.c"
         $3502 = ($3500|0)==(0); //@line 86013 "c/sqlite3.c"
         $3503 = $3501 & $3502; //@line 86013 "c/sqlite3.c"
         if (!($3503)) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
         $3504 = $163; //@line 86013 "c/sqlite3.c"
         $3505 = $3504; //@line 86013 "c/sqlite3.c"
         $3506 = HEAP32[$3505>>2]|0; //@line 86013 "c/sqlite3.c"
         $3507 = (($3504) + 4)|0; //@line 86013 "c/sqlite3.c"
         $3508 = $3507; //@line 86013 "c/sqlite3.c"
         $3509 = HEAP32[$3508>>2]|0; //@line 86013 "c/sqlite3.c"
         $3510 = ($3506|0)==(0); //@line 86013 "c/sqlite3.c"
         $3511 = ($3509|0)==(0); //@line 86013 "c/sqlite3.c"
         $3512 = $3510 & $3511; //@line 86013 "c/sqlite3.c"
         if ($3512) {
          $$32804 = $$02801;
          label = 13;
          break L10;
         } else {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
        }
        break;
       }
       case -109:  {
        $3531 = HEAP32[$97>>2]|0; //@line 86036 "c/sqlite3.c"
        $3532 = ($3531|0)==(0|0); //@line 86036 "c/sqlite3.c"
        if ($3532) {
         $$02839$sink = $$02839;
        } else {
         $$02976 = $3531;
         while(1) {
          $3533 = ((($$02976)) + 4|0); //@line 86037 "c/sqlite3.c"
          $3534 = HEAP32[$3533>>2]|0; //@line 86037 "c/sqlite3.c"
          $3535 = ($3534|0)==(0|0); //@line 86037 "c/sqlite3.c"
          if ($3535) {
           break;
          } else {
           $$02976 = $3534;
          }
         }
         $3536 = ((($$02976)) + 16|0); //@line 86038 "c/sqlite3.c"
         $3537 = HEAP32[$3536>>2]|0; //@line 86038 "c/sqlite3.c"
         $$02839$sink = $3537;
        }
        $3538 = ((($$02793)) + 4|0);
        $3539 = HEAP32[$3538>>2]|0;
        $3540 = (($$02839$sink) + (($3539*40)|0)|0);
        _sqlite3VdbeMemIntegerify($3540); //@line 86043 "c/sqlite3.c"
        $3541 = ((($$02793)) + 8|0); //@line 86044 "c/sqlite3.c"
        $3542 = HEAP32[$3541>>2]|0; //@line 86044 "c/sqlite3.c"
        $3543 = (($$02839) + (($3542*40)|0)|0); //@line 86044 "c/sqlite3.c"
        _sqlite3VdbeMemIntegerify($3543); //@line 86045 "c/sqlite3.c"
        $3544 = $3540; //@line 86046 "c/sqlite3.c"
        $3545 = $3544; //@line 86046 "c/sqlite3.c"
        $3546 = HEAP32[$3545>>2]|0; //@line 86046 "c/sqlite3.c"
        $3547 = (($3544) + 4)|0; //@line 86046 "c/sqlite3.c"
        $3548 = $3547; //@line 86046 "c/sqlite3.c"
        $3549 = HEAP32[$3548>>2]|0; //@line 86046 "c/sqlite3.c"
        $3550 = $3543; //@line 86046 "c/sqlite3.c"
        $3551 = $3550; //@line 86046 "c/sqlite3.c"
        $3552 = HEAP32[$3551>>2]|0; //@line 86046 "c/sqlite3.c"
        $3553 = (($3550) + 4)|0; //@line 86046 "c/sqlite3.c"
        $3554 = $3553; //@line 86046 "c/sqlite3.c"
        $3555 = HEAP32[$3554>>2]|0; //@line 86046 "c/sqlite3.c"
        $3556 = ($3549|0)<($3555|0); //@line 86046 "c/sqlite3.c"
        $3557 = ($3546>>>0)<($3552>>>0); //@line 86046 "c/sqlite3.c"
        $3558 = ($3549|0)==($3555|0); //@line 86046 "c/sqlite3.c"
        $3559 = $3558 & $3557; //@line 86046 "c/sqlite3.c"
        $3560 = $3556 | $3559; //@line 86046 "c/sqlite3.c"
        if ($3560) {
         $3561 = $3540; //@line 86047 "c/sqlite3.c"
         $3562 = $3561; //@line 86047 "c/sqlite3.c"
         HEAP32[$3562>>2] = $3552; //@line 86047 "c/sqlite3.c"
         $3563 = (($3561) + 4)|0; //@line 86047 "c/sqlite3.c"
         $3564 = $3563; //@line 86047 "c/sqlite3.c"
         HEAP32[$3564>>2] = $3555; //@line 86047 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case 48:  {
        $3565 = ((($$02793)) + 4|0); //@line 86064 "c/sqlite3.c"
        $3566 = HEAP32[$3565>>2]|0; //@line 86064 "c/sqlite3.c"
        $3567 = (($$02839) + (($3566*40)|0)|0); //@line 86067 "c/sqlite3.c"
        $3568 = $3567; //@line 86067 "c/sqlite3.c"
        $3569 = $3568; //@line 86067 "c/sqlite3.c"
        $3570 = HEAP32[$3569>>2]|0; //@line 86067 "c/sqlite3.c"
        $3571 = (($3568) + 4)|0; //@line 86067 "c/sqlite3.c"
        $3572 = $3571; //@line 86067 "c/sqlite3.c"
        $3573 = HEAP32[$3572>>2]|0; //@line 86067 "c/sqlite3.c"
        $3574 = ($3573|0)>(0); //@line 86067 "c/sqlite3.c"
        $3575 = ($3570>>>0)>(0); //@line 86067 "c/sqlite3.c"
        $3576 = ($3573|0)==(0); //@line 86067 "c/sqlite3.c"
        $3577 = $3576 & $3575; //@line 86067 "c/sqlite3.c"
        $3578 = $3574 | $3577; //@line 86067 "c/sqlite3.c"
        if ($3578) {
         $3579 = ((($$02793)) + 12|0); //@line 86068 "c/sqlite3.c"
         $3580 = HEAP32[$3579>>2]|0; //@line 86068 "c/sqlite3.c"
         $3581 = ($3580|0)<(0); //@line 86068 "c/sqlite3.c"
         $3582 = $3581 << 31 >> 31; //@line 86068 "c/sqlite3.c"
         $3583 = (_i64Subtract(($3570|0),($3573|0),($3580|0),($3582|0))|0); //@line 86068 "c/sqlite3.c"
         $3584 = tempRet0; //@line 86068 "c/sqlite3.c"
         $3585 = $3567; //@line 86068 "c/sqlite3.c"
         $3586 = $3585; //@line 86068 "c/sqlite3.c"
         HEAP32[$3586>>2] = $3583; //@line 86068 "c/sqlite3.c"
         $3587 = (($3585) + 4)|0; //@line 86068 "c/sqlite3.c"
         $3588 = $3587; //@line 86068 "c/sqlite3.c"
         HEAP32[$3588>>2] = $3584; //@line 86068 "c/sqlite3.c"
         $$32804 = $$02801;
         label = 13;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case -108:  {
        $3589 = ((($$02793)) + 4|0); //@line 86094 "c/sqlite3.c"
        $3590 = HEAP32[$3589>>2]|0; //@line 86094 "c/sqlite3.c"
        $3591 = ((($$02793)) + 12|0); //@line 86095 "c/sqlite3.c"
        $3592 = HEAP32[$3591>>2]|0; //@line 86095 "c/sqlite3.c"
        $3593 = (_out2Prerelease($0,$$02793)|0); //@line 86096 "c/sqlite3.c"
        $3594 = (($$02839) + (($3590*40)|0)|0); //@line 86099 "c/sqlite3.c"
        $3595 = $3594; //@line 86099 "c/sqlite3.c"
        $3596 = $3595; //@line 86099 "c/sqlite3.c"
        $3597 = HEAP32[$3596>>2]|0; //@line 86099 "c/sqlite3.c"
        $3598 = (($3595) + 4)|0; //@line 86099 "c/sqlite3.c"
        $3599 = $3598; //@line 86099 "c/sqlite3.c"
        $3600 = HEAP32[$3599>>2]|0; //@line 86099 "c/sqlite3.c"
        $3601 = $1; //@line 86099 "c/sqlite3.c"
        $3602 = $3601; //@line 86099 "c/sqlite3.c"
        HEAP32[$3602>>2] = $3597; //@line 86099 "c/sqlite3.c"
        $3603 = (($3601) + 4)|0; //@line 86099 "c/sqlite3.c"
        $3604 = $3603; //@line 86099 "c/sqlite3.c"
        HEAP32[$3604>>2] = $3600; //@line 86099 "c/sqlite3.c"
        $3605 = ($3600|0)<(0); //@line 86100 "c/sqlite3.c"
        $3606 = ($3597>>>0)<(1); //@line 86100 "c/sqlite3.c"
        $3607 = ($3600|0)==(0); //@line 86100 "c/sqlite3.c"
        $3608 = $3607 & $3606; //@line 86100 "c/sqlite3.c"
        $3609 = $3605 | $3608; //@line 86100 "c/sqlite3.c"
        if ($3609) {
         $3636 = -1;$3639 = -1;
        } else {
         $3610 = (($$02839) + (($3592*40)|0)|0); //@line 86100 "c/sqlite3.c"
         $3611 = $3610; //@line 86100 "c/sqlite3.c"
         $3612 = $3611; //@line 86100 "c/sqlite3.c"
         $3613 = HEAP32[$3612>>2]|0; //@line 86100 "c/sqlite3.c"
         $3614 = (($3611) + 4)|0; //@line 86100 "c/sqlite3.c"
         $3615 = $3614; //@line 86100 "c/sqlite3.c"
         $3616 = HEAP32[$3615>>2]|0; //@line 86100 "c/sqlite3.c"
         $3617 = ($3616|0)>(0); //@line 86100 "c/sqlite3.c"
         $3618 = ($3613>>>0)>(0); //@line 86100 "c/sqlite3.c"
         $3619 = ($3616|0)==(0); //@line 86100 "c/sqlite3.c"
         $3620 = $3619 & $3618; //@line 86100 "c/sqlite3.c"
         $3621 = $3617 | $3620; //@line 86100 "c/sqlite3.c"
         $3622 = $3621 ? $3613 : 0; //@line 86100 "c/sqlite3.c"
         $3623 = $3621 ? $3616 : 0; //@line 86100 "c/sqlite3.c"
         $3624 = (_sqlite3AddInt64($1,$3622,$3623)|0); //@line 86100 "c/sqlite3.c"
         $3625 = ($3624|0)==(0); //@line 86100 "c/sqlite3.c"
         $3626 = $1; //@line 86110 "c/sqlite3.c"
         $3627 = $3626; //@line 86110 "c/sqlite3.c"
         $3628 = HEAP32[$3627>>2]|0; //@line 86110 "c/sqlite3.c"
         $3629 = (($3626) + 4)|0; //@line 86110 "c/sqlite3.c"
         $3630 = $3629; //@line 86110 "c/sqlite3.c"
         $3631 = HEAP32[$3630>>2]|0; //@line 86110 "c/sqlite3.c"
         $3632 = $3625 ? $3628 : -1; //@line 86100 "c/sqlite3.c"
         $3633 = $3625 ? $3631 : -1; //@line 86100 "c/sqlite3.c"
         $3636 = $3632;$3639 = $3633;
        }
        $3634 = $3593;
        $3635 = $3634;
        HEAP32[$3635>>2] = $3636;
        $3637 = (($3634) + 4)|0;
        $3638 = $3637;
        HEAP32[$3638>>2] = $3639;
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case 49:  {
        $3640 = ((($$02793)) + 4|0); //@line 86124 "c/sqlite3.c"
        $3641 = HEAP32[$3640>>2]|0; //@line 86124 "c/sqlite3.c"
        $3642 = (($$02839) + (($3641*40)|0)|0); //@line 86127 "c/sqlite3.c"
        $3643 = $3642; //@line 86127 "c/sqlite3.c"
        $3644 = $3643; //@line 86127 "c/sqlite3.c"
        $3645 = HEAP32[$3644>>2]|0; //@line 86127 "c/sqlite3.c"
        $3646 = (($3643) + 4)|0; //@line 86127 "c/sqlite3.c"
        $3647 = $3646; //@line 86127 "c/sqlite3.c"
        $3648 = HEAP32[$3647>>2]|0; //@line 86127 "c/sqlite3.c"
        $3649 = ($3645|0)==(0); //@line 86127 "c/sqlite3.c"
        $3650 = ($3648|0)==(0); //@line 86127 "c/sqlite3.c"
        $3651 = $3649 & $3650; //@line 86127 "c/sqlite3.c"
        if ($3651) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $3652 = ($3648|0)>(0); //@line 86128 "c/sqlite3.c"
         $3653 = ($3645>>>0)>(0); //@line 86128 "c/sqlite3.c"
         $3654 = ($3648|0)==(0); //@line 86128 "c/sqlite3.c"
         $3655 = $3654 & $3653; //@line 86128 "c/sqlite3.c"
         $3656 = $3652 | $3655; //@line 86128 "c/sqlite3.c"
         if ($3656) {
          $3657 = (_i64Add(($3645|0),($3648|0),-1,-1)|0); //@line 86128 "c/sqlite3.c"
          $3658 = tempRet0; //@line 86128 "c/sqlite3.c"
          $3659 = $3642; //@line 86128 "c/sqlite3.c"
          $3660 = $3659; //@line 86128 "c/sqlite3.c"
          HEAP32[$3660>>2] = $3657; //@line 86128 "c/sqlite3.c"
          $3661 = (($3659) + 4)|0; //@line 86128 "c/sqlite3.c"
          $3662 = $3661; //@line 86128 "c/sqlite3.c"
          HEAP32[$3662>>2] = $3658; //@line 86128 "c/sqlite3.c"
          $$32804 = $$02801;
          label = 13;
         } else {
          $$32804 = $$02801;
          label = 13;
         }
        }
        break;
       }
       case 59:  {
        $3663 = ((($$02793)) + 4|0); //@line 86141 "c/sqlite3.c"
        $3664 = HEAP32[$3663>>2]|0; //@line 86141 "c/sqlite3.c"
        $3665 = (($$02839) + (($3664*40)|0)|0); //@line 86143 "c/sqlite3.c"
        $3666 = $3665; //@line 86143 "c/sqlite3.c"
        $3667 = $3666; //@line 86143 "c/sqlite3.c"
        $3668 = HEAP32[$3667>>2]|0; //@line 86143 "c/sqlite3.c"
        $3669 = (($3666) + 4)|0; //@line 86143 "c/sqlite3.c"
        $3670 = $3669; //@line 86143 "c/sqlite3.c"
        $3671 = HEAP32[$3670>>2]|0; //@line 86143 "c/sqlite3.c"
        $3672 = ($3668|0)==(0); //@line 86143 "c/sqlite3.c"
        $3673 = ($3671|0)==(-2147483648); //@line 86143 "c/sqlite3.c"
        $3674 = $3672 & $3673; //@line 86143 "c/sqlite3.c"
        $3675 = (_i64Add(($3668|0),($3671|0),-1,-1)|0); //@line 86143 "c/sqlite3.c"
        $3676 = tempRet0; //@line 86143 "c/sqlite3.c"
        if ($3674) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        } else {
         $3677 = $3665; //@line 86143 "c/sqlite3.c"
         $3678 = $3677; //@line 86143 "c/sqlite3.c"
         HEAP32[$3678>>2] = $3675; //@line 86143 "c/sqlite3.c"
         $3679 = (($3677) + 4)|0; //@line 86143 "c/sqlite3.c"
         $3680 = $3679; //@line 86143 "c/sqlite3.c"
         HEAP32[$3680>>2] = $3676; //@line 86143 "c/sqlite3.c"
         $3681 = ($3675|0)==(0); //@line 86145 "c/sqlite3.c"
         $3682 = ($3676|0)==(0); //@line 86145 "c/sqlite3.c"
         $3683 = $3681 & $3682; //@line 86145 "c/sqlite3.c"
         if ($3683) {
          $$32804 = $$02801;
          label = 13;
         } else {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         }
        }
        break;
       }
       case -107:  {
        $3684 = ((($$02793)) + 2|0); //@line 86183 "c/sqlite3.c"
        $3685 = HEAP16[$3684>>1]|0; //@line 86183 "c/sqlite3.c"
        $3686 = $3685&65535; //@line 86183 "c/sqlite3.c"
        $3687 = $3686 << 2; //@line 86187 "c/sqlite3.c"
        $3688 = (($3687) + 28)|0; //@line 86187 "c/sqlite3.c"
        $3689 = (_sqlite3DbMallocRawNN($8,$3688,0)|0); //@line 86187 "c/sqlite3.c"
        $3690 = ($3689|0)==(0|0); //@line 86188 "c/sqlite3.c"
        if ($3690) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $3691 = ((($3689)) + 8|0); //@line 86189 "c/sqlite3.c"
        HEAP32[$3691>>2] = 0; //@line 86189 "c/sqlite3.c"
        $3692 = ((($$02793)) + 16|0); //@line 86190 "c/sqlite3.c"
        $3693 = HEAP32[$3692>>2]|0; //@line 86190 "c/sqlite3.c"
        $3694 = ((($3689)) + 4|0); //@line 86190 "c/sqlite3.c"
        HEAP32[$3694>>2] = $3693; //@line 86190 "c/sqlite3.c"
        $3695 = $$02793; //@line 86191 "c/sqlite3.c"
        $3696 = $$02792; //@line 86191 "c/sqlite3.c"
        $3697 = (($3695) - ($3696))|0; //@line 86191 "c/sqlite3.c"
        $3698 = (($3697|0) / 20)&-1; //@line 86191 "c/sqlite3.c"
        $3699 = ((($3689)) + 16|0); //@line 86191 "c/sqlite3.c"
        HEAP32[$3699>>2] = $3698; //@line 86191 "c/sqlite3.c"
        $3700 = ((($3689)) + 12|0); //@line 86192 "c/sqlite3.c"
        HEAP32[$3700>>2] = $0; //@line 86192 "c/sqlite3.c"
        $3701 = $3685&255; //@line 86193 "c/sqlite3.c"
        $3702 = ((($3689)) + 26|0); //@line 86193 "c/sqlite3.c"
        HEAP8[$3702>>0] = $3701; //@line 86193 "c/sqlite3.c"
        $3703 = ((($$02793)) + 1|0); //@line 86194 "c/sqlite3.c"
        HEAP8[$3703>>0] = -16; //@line 86194 "c/sqlite3.c"
        HEAP32[$3692>>2] = $3689; //@line 86195 "c/sqlite3.c"
        HEAP8[$$02793>>0] = -106; //@line 86196 "c/sqlite3.c"
        label = 714;
        break;
       }
       case -106:  {
        label = 714;
        break;
       }
       case -105:  {
        $3749 = ((($$02793)) + 4|0); //@line 86265 "c/sqlite3.c"
        $3750 = HEAP32[$3749>>2]|0; //@line 86265 "c/sqlite3.c"
        $3751 = (($$02839) + (($3750*40)|0)|0); //@line 86265 "c/sqlite3.c"
        $3752 = ((($$02793)) + 16|0); //@line 86267 "c/sqlite3.c"
        $3753 = HEAP32[$3752>>2]|0; //@line 86267 "c/sqlite3.c"
        $3754 = (_sqlite3VdbeMemFinalize($3751,$3753)|0); //@line 86267 "c/sqlite3.c"
        $3755 = ($3754|0)==(0); //@line 86268 "c/sqlite3.c"
        if (!($3755)) {
         label = 728;
         break L8;
        }
        (_sqlite3VdbeChangeEncoding($3751,$143)|0); //@line 86272 "c/sqlite3.c"
        $3757 = (_sqlite3VdbeMemTooBig($3751)|0); //@line 86274 "c/sqlite3.c"
        $3758 = ($3757|0)==(0); //@line 86274 "c/sqlite3.c"
        if ($3758) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         label = 852;
         break L8;
        }
        break;
       }
       case 8:  {
        HEAP32[$1>>2] = 0; //@line 86298 "c/sqlite3.c"
        HEAP32[$98>>2] = -1; //@line 86299 "c/sqlite3.c"
        HEAP32[$99>>2] = -1; //@line 86299 "c/sqlite3.c"
        $3759 = ((($$02793)) + 4|0); //@line 86305 "c/sqlite3.c"
        $3760 = HEAP32[$3759>>2]|0; //@line 86305 "c/sqlite3.c"
        $3761 = ((($$02793)) + 8|0); //@line 86305 "c/sqlite3.c"
        $3762 = HEAP32[$3761>>2]|0; //@line 86305 "c/sqlite3.c"
        $3763 = (_sqlite3Checkpoint($8,$3760,$3762,$99,$98)|0); //@line 86305 "c/sqlite3.c"
        switch ($3763|0) {
        case 0:  {
         break;
        }
        case 5:  {
         HEAP32[$1>>2] = 1; //@line 86309 "c/sqlite3.c"
         break;
        }
        default: {
         label = 733;
         break L8;
        }
        }
        $3764 = ((($$02793)) + 12|0); //@line 86311 "c/sqlite3.c"
        $3765 = HEAP32[$3764>>2]|0; //@line 86311 "c/sqlite3.c"
        $3766 = (($$02839) + (($3765*40)|0)|0); //@line 86311 "c/sqlite3.c"
        $3767 = HEAP32[$1>>2]|0; //@line 86312 "c/sqlite3.c"
        $3768 = ($3767|0)<(0); //@line 86312 "c/sqlite3.c"
        $3769 = $3768 << 31 >> 31; //@line 86312 "c/sqlite3.c"
        _sqlite3VdbeMemSetInt64($3766,$3767,$3769); //@line 86312 "c/sqlite3.c"
        $3770 = ((($3766)) + 40|0); //@line 86311 "c/sqlite3.c"
        $3771 = HEAP32[$248>>2]|0; //@line 86312 "c/sqlite3.c"
        $3772 = ($3771|0)<(0); //@line 86312 "c/sqlite3.c"
        $3773 = $3772 << 31 >> 31; //@line 86312 "c/sqlite3.c"
        _sqlite3VdbeMemSetInt64($3770,$3771,$3773); //@line 86312 "c/sqlite3.c"
        $3774 = ((($3770)) + 40|0); //@line 86311 "c/sqlite3.c"
        $3775 = HEAP32[$249>>2]|0; //@line 86312 "c/sqlite3.c"
        $3776 = ($3775|0)<(0); //@line 86312 "c/sqlite3.c"
        $3777 = $3776 << 31 >> 31; //@line 86312 "c/sqlite3.c"
        _sqlite3VdbeMemSetInt64($3774,$3775,$3777); //@line 86312 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 9:  {
        $3778 = (_out2Prerelease($0,$$02793)|0); //@line 86339 "c/sqlite3.c"
        $3779 = ((($$02793)) + 12|0); //@line 86340 "c/sqlite3.c"
        $3780 = HEAP32[$3779>>2]|0; //@line 86340 "c/sqlite3.c"
        $3781 = HEAP32[$100>>2]|0; //@line 86352 "c/sqlite3.c"
        $3782 = ((($$02793)) + 4|0); //@line 86352 "c/sqlite3.c"
        $3783 = HEAP32[$3782>>2]|0; //@line 86352 "c/sqlite3.c"
        $3784 = (((($3781) + ($3783<<4)|0)) + 4|0); //@line 86352 "c/sqlite3.c"
        $3785 = HEAP32[$3784>>2]|0; //@line 86352 "c/sqlite3.c"
        $3786 = (_sqlite3BtreePager($3785)|0); //@line 86353 "c/sqlite3.c"
        $3787 = (_sqlite3PagerGetJournalMode($3786)|0); //@line 86354 "c/sqlite3.c"
        $3788 = ($3780|0)==(-1); //@line 86355 "c/sqlite3.c"
        $3789 = (_sqlite3PagerOkToChangeJournalMode($3786)|0); //@line 86356 "c/sqlite3.c"
        $3790 = ($3789|0)==(0); //@line 86356 "c/sqlite3.c"
        $3791 = $3788 | $3790; //@line 86356 "c/sqlite3.c"
        $$12959 = $3791 ? $3787 : $3780; //@line 86356 "c/sqlite3.c"
        $3792 = ($$12959|0)==(5); //@line 86364 "c/sqlite3.c"
        if ($3792) {
         $3793 = (_sqlite3PagerFilename($3786,1)|0); //@line 86359 "c/sqlite3.c"
         $3794 = (_sqlite3Strlen30($3793)|0); //@line 86365 "c/sqlite3.c"
         $3795 = ($3794|0)==(0); //@line 86365 "c/sqlite3.c"
         if ($3795) {
          $$229603218 = $3787;$$70 = $$02801;
         } else {
          $3796 = (_sqlite3PagerWalSupported($3786)|0); //@line 86366 "c/sqlite3.c"
          $3797 = ($3796|0)==(0); //@line 86366 "c/sqlite3.c"
          if ($3797) {
           $$229603218 = $3787;$$70 = $$02801;
          } else {
           $$22960 = 5;
           label = 737;
          }
         }
        } else {
         $$22960 = $$12959;
         label = 737;
        }
        do {
         if ((label|0) == 737) {
          label = 0;
          $3798 = ($$22960|0)==($3787|0); //@line 86371 "c/sqlite3.c"
          if ($3798) {
           $$229603218 = $$22960;$$70 = $$02801;
          } else {
           $3799 = ($3787|0)==(5); //@line 86372 "c/sqlite3.c"
           $3800 = ($$22960|0)==(5); //@line 86372 "c/sqlite3.c"
           $or$cond33 = $3799 | $3800; //@line 86372 "c/sqlite3.c"
           if ($or$cond33) {
            $3801 = HEAP8[$186>>0]|0; //@line 86374 "c/sqlite3.c"
            $3802 = ($3801<<24>>24)==(0); //@line 86374 "c/sqlite3.c"
            if ($3802) {
             label = 741;
             break L8;
            }
            $3803 = HEAP32[$205>>2]|0; //@line 86374 "c/sqlite3.c"
            $3804 = ($3803|0)>(1); //@line 86374 "c/sqlite3.c"
            if ($3804) {
             label = 741;
             break L8;
            }
            if ($3799) {
             $3806 = (_sqlite3PagerCloseWal($3786,$8)|0); //@line 86389 "c/sqlite3.c"
             $3807 = ($3806|0)==(0); //@line 86390 "c/sqlite3.c"
             if (!($3807)) {
              $$229603218 = $$22960;$$70 = $3806;
              break;
             }
             (_sqlite3PagerSetJournalMode($3786,$$22960)|0); //@line 86391 "c/sqlite3.c"
             $3808 = $3800 ? 2 : 1; //@line 86404 "c/sqlite3.c"
             $3812 = $3808;
            } else {
             $3809 = ($3787|0)==(4); //@line 86393 "c/sqlite3.c"
             if ($3809) {
              (_sqlite3PagerSetJournalMode($3786,2)|0); //@line 86396 "c/sqlite3.c"
             }
             $3810 = ($$02801|0)==(0); //@line 86403 "c/sqlite3.c"
             $3811 = $3800 ? 2 : 1; //@line 86404 "c/sqlite3.c"
             if ($3810) {
              $3812 = $3811;
             } else {
              $$229603218 = $$22960;$$70 = $$02801;
              break;
             }
            }
            $3813 = (_sqlite3BtreeSetVersion($3785,$3812)|0); //@line 86404 "c/sqlite3.c"
            $$229603218 = $$22960;$$70 = $3813;
           } else {
            $$229603218 = $$22960;$$70 = $$02801;
           }
          }
         }
        } while(0);
        $3814 = ($$70|0)!=(0); //@line 86410 "c/sqlite3.c"
        $spec$select3059 = $3814 ? $3787 : $$229603218; //@line 86410 "c/sqlite3.c"
        $3815 = (_sqlite3PagerSetJournalMode($3786,$spec$select3059)|0); //@line 86411 "c/sqlite3.c"
        $3816 = ((($3778)) + 8|0); //@line 86413 "c/sqlite3.c"
        HEAP16[$3816>>1] = 2562; //@line 86413 "c/sqlite3.c"
        $3817 = (_sqlite3JournalModename($3815)|0); //@line 86414 "c/sqlite3.c"
        $3818 = ((($3778)) + 16|0); //@line 86414 "c/sqlite3.c"
        HEAP32[$3818>>2] = $3817; //@line 86414 "c/sqlite3.c"
        $3819 = (_sqlite3Strlen30($3817)|0); //@line 86415 "c/sqlite3.c"
        $3820 = ((($3778)) + 12|0); //@line 86415 "c/sqlite3.c"
        HEAP32[$3820>>2] = $3819; //@line 86415 "c/sqlite3.c"
        $3821 = ((($3778)) + 10|0); //@line 86416 "c/sqlite3.c"
        HEAP8[$3821>>0] = 1; //@line 86416 "c/sqlite3.c"
        (_sqlite3VdbeChangeEncoding($3778,$144)|0); //@line 86417 "c/sqlite3.c"
        if ($3814) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$70;$$9 = $$02793;
         break L1;
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        }
        break;
       }
       case 10:  {
        $3822 = ((($$02793)) + 4|0); //@line 86431 "c/sqlite3.c"
        $3823 = HEAP32[$3822>>2]|0; //@line 86431 "c/sqlite3.c"
        $3824 = (_sqlite3RunVacuum($101,$8,$3823)|0); //@line 86431 "c/sqlite3.c"
        $3825 = ($3824|0)==(0); //@line 86432 "c/sqlite3.c"
        if ($3825) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3824;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 60:  {
        $3826 = HEAP32[$102>>2]|0; //@line 86450 "c/sqlite3.c"
        $3827 = ((($$02793)) + 4|0); //@line 86450 "c/sqlite3.c"
        $3828 = HEAP32[$3827>>2]|0; //@line 86450 "c/sqlite3.c"
        $3829 = (((($3826) + ($3828<<4)|0)) + 4|0); //@line 86450 "c/sqlite3.c"
        $3830 = HEAP32[$3829>>2]|0; //@line 86450 "c/sqlite3.c"
        $3831 = (_sqlite3BtreeIncrVacuum($3830)|0); //@line 86451 "c/sqlite3.c"
        switch ($3831|0) {
        case 0:  {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $3831;
         break;
        }
        case 101:  {
         $$32804 = 0;
         label = 13;
         break;
        }
        default: {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3831;$$9 = $$02793;
         break L1;
        }
        }
        break;
       }
       case -104:  {
        $3832 = ((($$02793)) + 4|0); //@line 86473 "c/sqlite3.c"
        $3833 = HEAP32[$3832>>2]|0; //@line 86473 "c/sqlite3.c"
        $3834 = ($3833|0)==(0); //@line 86473 "c/sqlite3.c"
        if ($3834) {
         _sqlite3ExpirePreparedStatements($8); //@line 86474 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        } else {
         $3835 = HEAPU8[$145>>0]|(HEAPU8[$145+1>>0]<<8); //@line 86476 "c/sqlite3.c"
         $3836 = $3835 | 1; //@line 86476 "c/sqlite3.c"
         HEAP8[$145>>0]=$3836&255;HEAP8[$145+1>>0]=$3836>>8; //@line 86476 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        break;
       }
       case -103:  {
        $3837 = ((($$02793)) + 12|0); //@line 86498 "c/sqlite3.c"
        $3838 = HEAP32[$3837>>2]|0; //@line 86498 "c/sqlite3.c"
        $3839 = $3838&255; //@line 86498 "c/sqlite3.c"
        $3840 = $3838 & 255; //@line 86499 "c/sqlite3.c"
        $3841 = ($3840|0)==(0); //@line 86499 "c/sqlite3.c"
        if ($3841) {
         $3842 = HEAP32[$146>>2]|0; //@line 86499 "c/sqlite3.c"
         $3843 = $3842 & 1024; //@line 86499 "c/sqlite3.c"
         $3844 = ($3843|0)==(0); //@line 86499 "c/sqlite3.c"
         if (!($3844)) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
          break L10;
         }
        }
        $3845 = ((($$02793)) + 4|0); //@line 86500 "c/sqlite3.c"
        $3846 = HEAP32[$3845>>2]|0; //@line 86500 "c/sqlite3.c"
        $3847 = HEAP32[$147>>2]|0; //@line 86504 "c/sqlite3.c"
        $3848 = (((($3847) + ($3846<<4)|0)) + 4|0); //@line 86504 "c/sqlite3.c"
        $3849 = HEAP32[$3848>>2]|0; //@line 86504 "c/sqlite3.c"
        $3850 = ((($$02793)) + 8|0); //@line 86504 "c/sqlite3.c"
        $3851 = HEAP32[$3850>>2]|0; //@line 86504 "c/sqlite3.c"
        $3852 = (_sqlite3BtreeLockTable($3849,$3851,$3839)|0); //@line 86504 "c/sqlite3.c"
        $3853 = ($3852|0)==(0); //@line 86505 "c/sqlite3.c"
        if ($3853) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         label = 758;
         break L8;
        }
        break;
       }
       case -102:  {
        $3858 = ((($$02793)) + 16|0); //@line 86529 "c/sqlite3.c"
        $3859 = HEAP32[$3858>>2]|0; //@line 86529 "c/sqlite3.c"
        $3860 = (_sqlite3VtabBegin($8,$3859)|0); //@line 86530 "c/sqlite3.c"
        $3861 = ($3859|0)==(0|0); //@line 86531 "c/sqlite3.c"
        if (!($3861)) {
         $3862 = ((($3859)) + 8|0); //@line 86531 "c/sqlite3.c"
         $3863 = HEAP32[$3862>>2]|0; //@line 86531 "c/sqlite3.c"
         _sqlite3VtabImportErrmsg($0,$3863); //@line 86531 "c/sqlite3.c"
        }
        $3864 = ($3860|0)==(0); //@line 86532 "c/sqlite3.c"
        if ($3864) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3860;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -101:  {
        dest=$1; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 86547 "c/sqlite3.c"
        HEAP32[$103>>2] = $8; //@line 86548 "c/sqlite3.c"
        $3865 = ((($$02793)) + 8|0); //@line 86553 "c/sqlite3.c"
        $3866 = HEAP32[$3865>>2]|0; //@line 86553 "c/sqlite3.c"
        $3867 = (($$02839) + (($3866*40)|0)|0); //@line 86553 "c/sqlite3.c"
        $3868 = (_sqlite3VdbeMemCopy($1,$3867)|0); //@line 86553 "c/sqlite3.c"
        $3869 = (_sqlite3_value_text($1)|0); //@line 86555 "c/sqlite3.c"
        $3870 = ($3869|0)==(0|0); //@line 86557 "c/sqlite3.c"
        if ($3870) {
         $$75 = $3868;
        } else {
         $3871 = ((($$02793)) + 4|0); //@line 86558 "c/sqlite3.c"
         $3872 = HEAP32[$3871>>2]|0; //@line 86558 "c/sqlite3.c"
         $3873 = (_sqlite3VtabCallCreate($8,$3872,$3869,$148)|0); //@line 86558 "c/sqlite3.c"
         $$75 = $3873;
        }
        _sqlite3VdbeMemRelease($1); //@line 86560 "c/sqlite3.c"
        $3874 = ($$75|0)==(0); //@line 86561 "c/sqlite3.c"
        if ($3874) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$75;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -100:  {
        $3875 = HEAP32[$104>>2]|0; //@line 86573 "c/sqlite3.c"
        $3876 = (($3875) + 1)|0; //@line 86573 "c/sqlite3.c"
        HEAP32[$104>>2] = $3876; //@line 86573 "c/sqlite3.c"
        $3877 = ((($$02793)) + 4|0); //@line 86574 "c/sqlite3.c"
        $3878 = HEAP32[$3877>>2]|0; //@line 86574 "c/sqlite3.c"
        $3879 = ((($$02793)) + 16|0); //@line 86574 "c/sqlite3.c"
        $3880 = HEAP32[$3879>>2]|0; //@line 86574 "c/sqlite3.c"
        $3881 = (_sqlite3VtabCallDestroy($8,$3878,$3880)|0); //@line 86574 "c/sqlite3.c"
        $3882 = HEAP32[$104>>2]|0; //@line 86575 "c/sqlite3.c"
        $3883 = (($3882) + -1)|0; //@line 86575 "c/sqlite3.c"
        HEAP32[$104>>2] = $3883; //@line 86575 "c/sqlite3.c"
        $3884 = ($3881|0)==(0); //@line 86576 "c/sqlite3.c"
        if ($3884) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3881;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case -99:  {
        HEAP32[$1>>2] = 0; //@line 86596 "c/sqlite3.c"
        $3885 = ((($$02793)) + 16|0); //@line 86597 "c/sqlite3.c"
        $3886 = HEAP32[$3885>>2]|0; //@line 86597 "c/sqlite3.c"
        $3887 = ((($3886)) + 8|0); //@line 86597 "c/sqlite3.c"
        $3888 = HEAP32[$3887>>2]|0; //@line 86597 "c/sqlite3.c"
        $3889 = ($3888|0)==(0|0); //@line 86598 "c/sqlite3.c"
        if ($3889) {
         $$76$ph = 6;
         label = 772;
         break L8;
        }
        $3890 = HEAP32[$3888>>2]|0; //@line 86598 "c/sqlite3.c"
        $3891 = ($3890|0)==(0|0); //@line 86598 "c/sqlite3.c"
        if ($3891) {
         $$76$ph = 6;
         label = 772;
         break L8;
        }
        $3892 = ((($3890)) + 24|0); //@line 86603 "c/sqlite3.c"
        $3893 = HEAP32[$3892>>2]|0; //@line 86603 "c/sqlite3.c"
        $3894 = (FUNCTION_TABLE_iii[$3893 & 255]($3888,$1)|0); //@line 86603 "c/sqlite3.c"
        _sqlite3VtabImportErrmsg($0,$3888); //@line 86604 "c/sqlite3.c"
        $3895 = ($3894|0)==(0); //@line 86605 "c/sqlite3.c"
        if (!($3895)) {
         $$76$ph = $3894;
         label = 772;
         break L8;
        }
        $3896 = HEAP32[$1>>2]|0; //@line 86608 "c/sqlite3.c"
        HEAP32[$3896>>2] = $3888; //@line 86608 "c/sqlite3.c"
        $3897 = ((($$02793)) + 4|0); //@line 86611 "c/sqlite3.c"
        $3898 = HEAP32[$3897>>2]|0; //@line 86611 "c/sqlite3.c"
        $3899 = (_allocateCursor($0,$3898,0,-1,2)|0); //@line 86611 "c/sqlite3.c"
        $3900 = ($3899|0)==(0|0); //@line 86612 "c/sqlite3.c"
        if ($3900) {
         label = 773;
         break L8;
        }
        $3901 = HEAP32[$1>>2]|0; //@line 86613 "c/sqlite3.c"
        $3902 = ((($3899)) + 40|0); //@line 86613 "c/sqlite3.c"
        HEAP32[$3902>>2] = $3901; //@line 86613 "c/sqlite3.c"
        $3903 = ((($3888)) + 4|0); //@line 86614 "c/sqlite3.c"
        $3904 = HEAP32[$3903>>2]|0; //@line 86614 "c/sqlite3.c"
        $3905 = (($3904) + 1)|0; //@line 86614 "c/sqlite3.c"
        HEAP32[$3903>>2] = $3905; //@line 86614 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        break;
       }
       case 11:  {
        $3909 = ((($$02793)) + 12|0); //@line 86657 "c/sqlite3.c"
        $3910 = HEAP32[$3909>>2]|0; //@line 86657 "c/sqlite3.c"
        $3911 = (($$02839) + (($3910*40)|0)|0); //@line 86657 "c/sqlite3.c"
        $3912 = ((($3911)) + 40|0); //@line 86658 "c/sqlite3.c"
        $3913 = HEAP32[$105>>2]|0; //@line 86659 "c/sqlite3.c"
        $3914 = ((($$02793)) + 4|0); //@line 86659 "c/sqlite3.c"
        $3915 = HEAP32[$3914>>2]|0; //@line 86659 "c/sqlite3.c"
        $3916 = (($3913) + ($3915<<2)|0); //@line 86659 "c/sqlite3.c"
        $3917 = HEAP32[$3916>>2]|0; //@line 86659 "c/sqlite3.c"
        $3918 = ((($3917)) + 40|0); //@line 86663 "c/sqlite3.c"
        $3919 = HEAP32[$3918>>2]|0; //@line 86663 "c/sqlite3.c"
        $3920 = HEAP32[$3919>>2]|0; //@line 86664 "c/sqlite3.c"
        $3921 = HEAP32[$3920>>2]|0; //@line 86665 "c/sqlite3.c"
        $3922 = $3912; //@line 86669 "c/sqlite3.c"
        $3923 = $3922; //@line 86669 "c/sqlite3.c"
        $3924 = HEAP32[$3923>>2]|0; //@line 86669 "c/sqlite3.c"
        $3925 = (($3922) + 4)|0; //@line 86669 "c/sqlite3.c"
        $3926 = $3925; //@line 86669 "c/sqlite3.c"
        $3927 = HEAP32[$3926>>2]|0; //@line 86669 "c/sqlite3.c"
        $3928 = $3911; //@line 86670 "c/sqlite3.c"
        $3929 = $3928; //@line 86670 "c/sqlite3.c"
        $3930 = HEAP32[$3929>>2]|0; //@line 86670 "c/sqlite3.c"
        $3931 = (($3928) + 4)|0; //@line 86670 "c/sqlite3.c"
        $3932 = $3931; //@line 86670 "c/sqlite3.c"
        $3933 = HEAP32[$3932>>2]|0; //@line 86670 "c/sqlite3.c"
        $3934 = HEAP32[$106>>2]|0; //@line 86674 "c/sqlite3.c"
        $3935 = ($3924|0)>(0); //@line 86675 "c/sqlite3.c"
        if ($3935) {
         $$029303786 = 0;
         while(1) {
          $3936 = (($$029303786) + 1)|0; //@line 86676 "c/sqlite3.c"
          $3937 = (($3912) + (($3936*40)|0)|0); //@line 86676 "c/sqlite3.c"
          $3938 = (($3934) + ($$029303786<<2)|0); //@line 86676 "c/sqlite3.c"
          HEAP32[$3938>>2] = $3937; //@line 86676 "c/sqlite3.c"
          $exitcond4308 = ($3936|0)==($3924|0); //@line 86675 "c/sqlite3.c"
          if ($exitcond4308) {
           break;
          } else {
           $$029303786 = $3936;
          }
         }
        }
        $3939 = ((($3921)) + 32|0); //@line 86678 "c/sqlite3.c"
        $3940 = HEAP32[$3939>>2]|0; //@line 86678 "c/sqlite3.c"
        $3941 = ((($$02793)) + 16|0); //@line 86678 "c/sqlite3.c"
        $3942 = HEAP32[$3941>>2]|0; //@line 86678 "c/sqlite3.c"
        $3943 = (FUNCTION_TABLE_iiiiii[$3940 & 127]($3919,$3930,$3942,$3924,$3934)|0); //@line 86678 "c/sqlite3.c"
        _sqlite3VtabImportErrmsg($0,$3920); //@line 86679 "c/sqlite3.c"
        $3944 = ($3943|0)==(0); //@line 86680 "c/sqlite3.c"
        if (!($3944)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3943;$$9 = $$02793;
         break L1;
        }
        $3945 = ((($3921)) + 40|0); //@line 86681 "c/sqlite3.c"
        $3946 = HEAP32[$3945>>2]|0; //@line 86681 "c/sqlite3.c"
        $3947 = (FUNCTION_TABLE_ii[$3946 & 255]($3919)|0); //@line 86681 "c/sqlite3.c"
        $3948 = ((($3917)) + 2|0); //@line 86682 "c/sqlite3.c"
        HEAP8[$3948>>0] = 0; //@line 86682 "c/sqlite3.c"
        $3949 = ($3947|0)==(0); //@line 86684 "c/sqlite3.c"
        if ($3949) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$32804 = 0;
         label = 13;
        }
        break;
       }
       case -98:  {
        $3950 = HEAP32[$107>>2]|0; //@line 86709 "c/sqlite3.c"
        $3951 = ((($$02793)) + 4|0); //@line 86709 "c/sqlite3.c"
        $3952 = HEAP32[$3951>>2]|0; //@line 86709 "c/sqlite3.c"
        $3953 = (($3950) + ($3952<<2)|0); //@line 86709 "c/sqlite3.c"
        $3954 = HEAP32[$3953>>2]|0; //@line 86709 "c/sqlite3.c"
        $3955 = ((($$02793)) + 12|0); //@line 86712 "c/sqlite3.c"
        $3956 = HEAP32[$3955>>2]|0; //@line 86712 "c/sqlite3.c"
        $3957 = (($$02839) + (($3956*40)|0)|0); //@line 86712 "c/sqlite3.c"
        $3958 = ((($3954)) + 2|0); //@line 86714 "c/sqlite3.c"
        $3959 = HEAP8[$3958>>0]|0; //@line 86714 "c/sqlite3.c"
        $3960 = ($3959<<24>>24)==(0); //@line 86714 "c/sqlite3.c"
        if (!($3960)) {
         _sqlite3VdbeMemSetNull($3957); //@line 86715 "c/sqlite3.c"
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
         break L10;
        }
        $3961 = ((($3954)) + 40|0); //@line 86718 "c/sqlite3.c"
        $3962 = HEAP32[$3961>>2]|0; //@line 86718 "c/sqlite3.c"
        $3963 = HEAP32[$3962>>2]|0; //@line 86718 "c/sqlite3.c"
        $3964 = HEAP32[$3963>>2]|0; //@line 86719 "c/sqlite3.c"
        ;HEAP32[$250>>2]=0|0;HEAP32[$250+4>>2]=0|0;HEAP32[$250+8>>2]=0|0;HEAP32[$250+12>>2]=0|0;HEAP32[$250+16>>2]=0|0;HEAP32[$250+20>>2]=0|0;HEAP32[$250+24>>2]=0|0; //@line 86721 "c/sqlite3.c"
        HEAP32[$1>>2] = $3957; //@line 86722 "c/sqlite3.c"
        $3965 = ((($$02793)) + 2|0); //@line 86723 "c/sqlite3.c"
        $3966 = HEAP16[$3965>>1]|0; //@line 86723 "c/sqlite3.c"
        $3967 = ($3966<<16>>16)==(0); //@line 86723 "c/sqlite3.c"
        if ($3967) {
         $3969 = (((($$02839) + (($3956*40)|0)|0)) + 8|0); //@line 86728 "c/sqlite3.c"
         $3970 = HEAP16[$3969>>1]|0; //@line 86728 "c/sqlite3.c"
         $3971 = $3970 & 15872; //@line 86728 "c/sqlite3.c"
         $3972 = $3971 | 1; //@line 86728 "c/sqlite3.c"
         HEAP16[$3969>>1] = $3972; //@line 86728 "c/sqlite3.c"
        } else {
         _sqlite3VdbeMemSetNull($3957); //@line 86724 "c/sqlite3.c"
         $3968 = (((($$02839) + (($3956*40)|0)|0)) + 8|0); //@line 86725 "c/sqlite3.c"
         HEAP16[$3968>>1] = 16385; //@line 86725 "c/sqlite3.c"
         HEAP32[$3957>>2] = 0; //@line 86726 "c/sqlite3.c"
        }
        $3973 = ((($3964)) + 44|0); //@line 86730 "c/sqlite3.c"
        $3974 = HEAP32[$3973>>2]|0; //@line 86730 "c/sqlite3.c"
        $3975 = HEAP32[$3961>>2]|0; //@line 86730 "c/sqlite3.c"
        $3976 = ((($$02793)) + 8|0); //@line 86730 "c/sqlite3.c"
        $3977 = HEAP32[$3976>>2]|0; //@line 86730 "c/sqlite3.c"
        $3978 = (FUNCTION_TABLE_iiii[$3974 & 127]($3975,$1,$3977)|0); //@line 86730 "c/sqlite3.c"
        _sqlite3VtabImportErrmsg($0,$3963); //@line 86731 "c/sqlite3.c"
        $3979 = HEAP32[$164>>2]|0; //@line 86732 "c/sqlite3.c"
        $3980 = ($3979|0)==(0); //@line 86732 "c/sqlite3.c"
        $spec$select3063 = $3980 ? $3978 : $3979; //@line 86732 "c/sqlite3.c"
        (_sqlite3VdbeChangeEncoding($3957,$165)|0); //@line 86735 "c/sqlite3.c"
        $3981 = (_sqlite3VdbeMemTooBig($3957)|0); //@line 86739 "c/sqlite3.c"
        $3982 = ($3981|0)==(0); //@line 86739 "c/sqlite3.c"
        if (!($3982)) {
         label = 852;
         break L8;
        }
        $3983 = ($spec$select3063|0)==(0); //@line 86742 "c/sqlite3.c"
        if ($3983) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $spec$select3063;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 61:  {
        $3984 = HEAP32[$108>>2]|0; //@line 86761 "c/sqlite3.c"
        $3985 = ((($$02793)) + 4|0); //@line 86761 "c/sqlite3.c"
        $3986 = HEAP32[$3985>>2]|0; //@line 86761 "c/sqlite3.c"
        $3987 = (($3984) + ($3986<<2)|0); //@line 86761 "c/sqlite3.c"
        $3988 = HEAP32[$3987>>2]|0; //@line 86761 "c/sqlite3.c"
        $3989 = ((($3988)) + 2|0); //@line 86763 "c/sqlite3.c"
        $3990 = HEAP8[$3989>>0]|0; //@line 86763 "c/sqlite3.c"
        $3991 = ($3990<<24>>24)==(0); //@line 86763 "c/sqlite3.c"
        if ($3991) {
         $3992 = ((($3988)) + 40|0); //@line 86766 "c/sqlite3.c"
         $3993 = HEAP32[$3992>>2]|0; //@line 86766 "c/sqlite3.c"
         $3994 = HEAP32[$3993>>2]|0; //@line 86766 "c/sqlite3.c"
         $3995 = HEAP32[$3994>>2]|0; //@line 86767 "c/sqlite3.c"
         $3996 = ((($3995)) + 36|0); //@line 86776 "c/sqlite3.c"
         $3997 = HEAP32[$3996>>2]|0; //@line 86776 "c/sqlite3.c"
         $3998 = (FUNCTION_TABLE_ii[$3997 & 255]($3993)|0); //@line 86776 "c/sqlite3.c"
         _sqlite3VtabImportErrmsg($0,$3994); //@line 86777 "c/sqlite3.c"
         $3999 = ($3998|0)==(0); //@line 86778 "c/sqlite3.c"
         if (!($3999)) {
          $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3998;$$9 = $$02793;
          break L1;
         }
         $4000 = ((($3995)) + 40|0); //@line 86779 "c/sqlite3.c"
         $4001 = HEAP32[$4000>>2]|0; //@line 86779 "c/sqlite3.c"
         $4002 = HEAP32[$3992>>2]|0; //@line 86779 "c/sqlite3.c"
         $4003 = (FUNCTION_TABLE_ii[$4001 & 255]($4002)|0); //@line 86779 "c/sqlite3.c"
         $4004 = ($4003|0)==(0); //@line 86781 "c/sqlite3.c"
         if ($4004) {
          $$12802 = 0;
          label = 7;
         } else {
          $$12794 = $$02793;$$22803 = 0;
          label = 8;
         }
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        }
        break;
       }
       case -97:  {
        $4005 = ((($$02793)) + 16|0); //@line 86800 "c/sqlite3.c"
        $4006 = HEAP32[$4005>>2]|0; //@line 86800 "c/sqlite3.c"
        $4007 = ((($4006)) + 8|0); //@line 86800 "c/sqlite3.c"
        $4008 = HEAP32[$4007>>2]|0; //@line 86800 "c/sqlite3.c"
        $4009 = ((($$02793)) + 4|0); //@line 86801 "c/sqlite3.c"
        $4010 = HEAP32[$4009>>2]|0; //@line 86801 "c/sqlite3.c"
        $4011 = (($$02839) + (($4010*40)|0)|0); //@line 86801 "c/sqlite3.c"
        $4012 = (_sqlite3VdbeChangeEncoding($4011,1)|0); //@line 86810 "c/sqlite3.c"
        $4013 = ($4012|0)==(0); //@line 86811 "c/sqlite3.c"
        if (!($4013)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $4012;$$9 = $$02793;
         break L1;
        }
        $4014 = HEAP32[$4008>>2]|0; //@line 86812 "c/sqlite3.c"
        $4015 = ((($4014)) + 76|0); //@line 86812 "c/sqlite3.c"
        $4016 = HEAP32[$4015>>2]|0; //@line 86812 "c/sqlite3.c"
        $4017 = (((($$02839) + (($4010*40)|0)|0)) + 16|0); //@line 86812 "c/sqlite3.c"
        $4018 = HEAP32[$4017>>2]|0; //@line 86812 "c/sqlite3.c"
        $4019 = (FUNCTION_TABLE_iii[$4016 & 255]($4008,$4018)|0); //@line 86812 "c/sqlite3.c"
        _sqlite3VtabImportErrmsg($0,$4008); //@line 86813 "c/sqlite3.c"
        $4020 = HEAPU8[$149>>0]|(HEAPU8[$149+1>>0]<<8); //@line 86814 "c/sqlite3.c"
        $4021 = $4020 & -2; //@line 86814 "c/sqlite3.c"
        HEAP8[$149>>0]=$4021&255;HEAP8[$149+1>>0]=$4021>>8; //@line 86814 "c/sqlite3.c"
        $4022 = ($4019|0)==(0); //@line 86815 "c/sqlite3.c"
        if ($4022) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $4019;$$9 = $$02793;
         break L1;
        }
        break;
       }
       case 12:  {
        $4023 = ((($$02793)) + 16|0); //@line 86861 "c/sqlite3.c"
        $4024 = HEAP32[$4023>>2]|0; //@line 86861 "c/sqlite3.c"
        $4025 = ((($4024)) + 8|0); //@line 86861 "c/sqlite3.c"
        $4026 = HEAP32[$4025>>2]|0; //@line 86861 "c/sqlite3.c"
        $4027 = ($4026|0)==(0|0); //@line 86862 "c/sqlite3.c"
        if ($4027) {
         label = 808;
         break L8;
        }
        $4028 = HEAP32[$4026>>2]|0; //@line 86862 "c/sqlite3.c"
        $4029 = ($4028|0)==(0|0); //@line 86862 "c/sqlite3.c"
        if ($4029) {
         label = 808;
         break L8;
        }
        $4030 = ((($$02793)) + 8|0); //@line 86867 "c/sqlite3.c"
        $4031 = HEAP32[$4030>>2]|0; //@line 86867 "c/sqlite3.c"
        $4032 = ((($4028)) + 52|0); //@line 86869 "c/sqlite3.c"
        $4033 = HEAP32[$4032>>2]|0; //@line 86869 "c/sqlite3.c"
        $4034 = ($4033|0)==(0|0); //@line 86869 "c/sqlite3.c"
        L882: do {
         if ($4034) {
          $$83$ph = $$02801;
         } else {
          $4035 = HEAP8[$187>>0]|0; //@line 86870 "c/sqlite3.c"
          $4036 = HEAP32[$188>>2]|0; //@line 86871 "c/sqlite3.c"
          $4037 = ($4031|0)>(0); //@line 86873 "c/sqlite3.c"
          if ($4037) {
           $4038 = ((($$02793)) + 12|0); //@line 86872 "c/sqlite3.c"
           $4039 = HEAP32[$4038>>2]|0; //@line 86872 "c/sqlite3.c"
           $4040 = (($$02839) + (($4039*40)|0)|0); //@line 86872 "c/sqlite3.c"
           $$028433782 = $4040;$$028483781 = 0;
           while(1) {
            $4041 = (($4036) + ($$028483781<<2)|0); //@line 86876 "c/sqlite3.c"
            HEAP32[$4041>>2] = $$028433782; //@line 86876 "c/sqlite3.c"
            $4042 = ((($$028433782)) + 40|0); //@line 86877 "c/sqlite3.c"
            $4043 = (($$028483781) + 1)|0; //@line 86873 "c/sqlite3.c"
            $exitcond = ($4043|0)==($4031|0); //@line 86873 "c/sqlite3.c"
            if ($exitcond) {
             break;
            } else {
             $$028433782 = $4042;$$028483781 = $4043;
            }
           }
          }
          $4044 = ((($$02793)) + 2|0); //@line 86879 "c/sqlite3.c"
          $4045 = HEAP16[$4044>>1]|0; //@line 86879 "c/sqlite3.c"
          $4046 = $4045&255; //@line 86879 "c/sqlite3.c"
          HEAP8[$187>>0] = $4046; //@line 86879 "c/sqlite3.c"
          $4047 = HEAP32[$4032>>2]|0; //@line 86880 "c/sqlite3.c"
          $4048 = (FUNCTION_TABLE_iiiii[$4047 & 127]($4026,$4031,$4036,$1)|0); //@line 86880 "c/sqlite3.c"
          HEAP8[$187>>0] = $4035; //@line 86881 "c/sqlite3.c"
          _sqlite3VtabImportErrmsg($0,$4026); //@line 86882 "c/sqlite3.c"
          $4049 = ($4048|0)==(0); //@line 86883 "c/sqlite3.c"
          if ($4049) {
           $4050 = ((($$02793)) + 4|0); //@line 86883 "c/sqlite3.c"
           $4051 = HEAP32[$4050>>2]|0; //@line 86883 "c/sqlite3.c"
           $4052 = ($4051|0)==(0); //@line 86883 "c/sqlite3.c"
           if (!($4052)) {
            $4053 = $1; //@line 86885 "c/sqlite3.c"
            $4054 = $4053; //@line 86885 "c/sqlite3.c"
            $4055 = HEAP32[$4054>>2]|0; //@line 86885 "c/sqlite3.c"
            $4056 = (($4053) + 4)|0; //@line 86885 "c/sqlite3.c"
            $4057 = $4056; //@line 86885 "c/sqlite3.c"
            $4058 = HEAP32[$4057>>2]|0; //@line 86885 "c/sqlite3.c"
            $4059 = $226; //@line 86885 "c/sqlite3.c"
            $4060 = $4059; //@line 86885 "c/sqlite3.c"
            HEAP32[$4060>>2] = $4055; //@line 86885 "c/sqlite3.c"
            $4061 = (($4059) + 4)|0; //@line 86885 "c/sqlite3.c"
            $4062 = $4061; //@line 86885 "c/sqlite3.c"
            HEAP32[$4062>>2] = $4058; //@line 86885 "c/sqlite3.c"
           }
           $4075 = HEAP32[$225>>2]|0; //@line 86894 "c/sqlite3.c"
           $4076 = (($4075) + 1)|0; //@line 86894 "c/sqlite3.c"
           HEAP32[$225>>2] = $4076; //@line 86894 "c/sqlite3.c"
           $$83$ph = 0;
           break;
          } else {
           $4063 = $4048 & 255; //@line 86887 "c/sqlite3.c"
           $4064 = ($4063|0)==(19); //@line 86887 "c/sqlite3.c"
           if (!($4064)) {
            label = 805;
            break L8;
           }
           $4065 = HEAP32[$4023>>2]|0; //@line 86887 "c/sqlite3.c"
           $4066 = ((($4065)) + 16|0); //@line 86887 "c/sqlite3.c"
           $4067 = HEAP8[$4066>>0]|0; //@line 86887 "c/sqlite3.c"
           $4068 = ($4067<<24>>24)==(0); //@line 86887 "c/sqlite3.c"
           if ($4068) {
            label = 805;
            break L8;
           }
           $4069 = HEAP16[$4044>>1]|0; //@line 86888 "c/sqlite3.c"
           switch ($4069<<16>>16) {
           case 5:  {
            $4071 = 2;
            label = 804;
            break L8;
            break;
           }
           case 4:  {
            $$83$ph = 0;
            break L882;
            break;
           }
           default: {
            label = 803;
            break L8;
           }
           }
          }
         }
        } while(0);
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$83$ph;
        break;
       }
       case -96:  {
        $4077 = (_out2Prerelease($0,$$02793)|0); //@line 86908 "c/sqlite3.c"
        $4078 = HEAP32[$109>>2]|0; //@line 86909 "c/sqlite3.c"
        $4079 = ((($$02793)) + 4|0); //@line 86909 "c/sqlite3.c"
        $4080 = HEAP32[$4079>>2]|0; //@line 86909 "c/sqlite3.c"
        $4081 = (((($4078) + ($4080<<4)|0)) + 4|0); //@line 86909 "c/sqlite3.c"
        $4082 = HEAP32[$4081>>2]|0; //@line 86909 "c/sqlite3.c"
        $4083 = (_sqlite3BtreeLastPage($4082)|0); //@line 86909 "c/sqlite3.c"
        $4084 = $4077; //@line 86909 "c/sqlite3.c"
        $4085 = $4084; //@line 86909 "c/sqlite3.c"
        HEAP32[$4085>>2] = $4083; //@line 86909 "c/sqlite3.c"
        $4086 = (($4084) + 4)|0; //@line 86909 "c/sqlite3.c"
        $4087 = $4086; //@line 86909 "c/sqlite3.c"
        HEAP32[$4087>>2] = 0; //@line 86909 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -95:  {
        $4088 = (_out2Prerelease($0,$$02793)|0); //@line 86928 "c/sqlite3.c"
        $4089 = HEAP32[$110>>2]|0; //@line 86929 "c/sqlite3.c"
        $4090 = ((($$02793)) + 4|0); //@line 86929 "c/sqlite3.c"
        $4091 = HEAP32[$4090>>2]|0; //@line 86929 "c/sqlite3.c"
        $4092 = (((($4089) + ($4091<<4)|0)) + 4|0); //@line 86929 "c/sqlite3.c"
        $4093 = HEAP32[$4092>>2]|0; //@line 86929 "c/sqlite3.c"
        $4094 = ((($$02793)) + 12|0); //@line 86931 "c/sqlite3.c"
        $4095 = HEAP32[$4094>>2]|0; //@line 86931 "c/sqlite3.c"
        $4096 = ($4095|0)==(0); //@line 86931 "c/sqlite3.c"
        if ($4096) {
         $$02838 = 0;
        } else {
         $4097 = (_sqlite3BtreeLastPage($4093)|0); //@line 86932 "c/sqlite3.c"
         $4098 = ($4097>>>0)<($4095>>>0); //@line 86933 "c/sqlite3.c"
         $spec$select3068 = $4098 ? $4095 : $4097; //@line 86933 "c/sqlite3.c"
         $$02838 = $spec$select3068;
        }
        $4099 = (_sqlite3BtreeMaxPageCount($4093,$$02838)|0); //@line 86935 "c/sqlite3.c"
        $4100 = ($4099|0)<(0); //@line 86935 "c/sqlite3.c"
        $4101 = $4100 << 31 >> 31; //@line 86935 "c/sqlite3.c"
        $4102 = $4088; //@line 86935 "c/sqlite3.c"
        $4103 = $4102; //@line 86935 "c/sqlite3.c"
        HEAP32[$4103>>2] = $4099; //@line 86935 "c/sqlite3.c"
        $4104 = (($4102) + 4)|0; //@line 86935 "c/sqlite3.c"
        $4105 = $4104; //@line 86935 "c/sqlite3.c"
        HEAP32[$4105>>2] = $4101; //@line 86935 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
        break;
       }
       case -93: case -94:  {
        $4106 = ((($$02793)) + 2|0); //@line 86987 "c/sqlite3.c"
        $4107 = HEAP16[$4106>>1]|0; //@line 86987 "c/sqlite3.c"
        $4108 = $4107&65535; //@line 86987 "c/sqlite3.c"
        $4109 = $4108 << 2; //@line 86991 "c/sqlite3.c"
        $4110 = (($4109) + 28)|0; //@line 86991 "c/sqlite3.c"
        $4111 = (_sqlite3DbMallocRawNN($8,$4110,0)|0); //@line 86991 "c/sqlite3.c"
        $4112 = ($4111|0)==(0|0); //@line 86992 "c/sqlite3.c"
        if ($4112) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        HEAP32[$4111>>2] = 0; //@line 86993 "c/sqlite3.c"
        $4113 = ((($$02793)) + 16|0); //@line 86994 "c/sqlite3.c"
        $4114 = HEAP32[$4113>>2]|0; //@line 86994 "c/sqlite3.c"
        $4115 = ((($4111)) + 4|0); //@line 86994 "c/sqlite3.c"
        HEAP32[$4115>>2] = $4114; //@line 86994 "c/sqlite3.c"
        $4116 = $$02793; //@line 86995 "c/sqlite3.c"
        $4117 = $$02792; //@line 86995 "c/sqlite3.c"
        $4118 = (($4116) - ($4117))|0; //@line 86995 "c/sqlite3.c"
        $4119 = (($4118|0) / 20)&-1; //@line 86995 "c/sqlite3.c"
        $4120 = ((($4111)) + 16|0); //@line 86995 "c/sqlite3.c"
        HEAP32[$4120>>2] = $4119; //@line 86995 "c/sqlite3.c"
        $4121 = ((($4111)) + 12|0); //@line 86996 "c/sqlite3.c"
        HEAP32[$4121>>2] = $0; //@line 86996 "c/sqlite3.c"
        $4122 = $4107&255; //@line 86997 "c/sqlite3.c"
        $4123 = ((($4111)) + 26|0); //@line 86997 "c/sqlite3.c"
        HEAP8[$4123>>0] = $4122; //@line 86997 "c/sqlite3.c"
        $4124 = ((($$02793)) + 1|0); //@line 86998 "c/sqlite3.c"
        HEAP8[$4124>>0] = -16; //@line 86998 "c/sqlite3.c"
        HEAP32[$4113>>2] = $4111; //@line 86999 "c/sqlite3.c"
        $4125 = HEAP8[$$02793>>0]|0; //@line 87002 "c/sqlite3.c"
        $4126 = $4125&255; //@line 87002 "c/sqlite3.c"
        $4127 = (($4126) + 2)|0; //@line 87002 "c/sqlite3.c"
        $4128 = $4127&255; //@line 87002 "c/sqlite3.c"
        HEAP8[$$02793>>0] = $4128; //@line 87002 "c/sqlite3.c"
        label = 816;
        break;
       }
       case -91: case -92:  {
        label = 816;
        break;
       }
       default: {
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$02801;
       }
       }
      } while(0);
      do {
       if ((label|0) == 19) {
        label = 0;
        $355 = ((($$02793)) + 4|0); //@line 80932 "c/sqlite3.c"
        $356 = HEAP32[$355>>2]|0; //@line 80932 "c/sqlite3.c"
        $357 = ($356|0)==(0); //@line 80932 "c/sqlite3.c"
        if (!($357)) {
         label = 24;
         break L8;
        }
        $358 = HEAP32[$111>>2]|0; //@line 80932 "c/sqlite3.c"
        $359 = ($358|0)==(0|0); //@line 80932 "c/sqlite3.c"
        if ($359) {
         label = 23;
         break L8;
        }
        $360 = ((($358)) + 4|0); //@line 80935 "c/sqlite3.c"
        $361 = HEAP32[$360>>2]|0; //@line 80935 "c/sqlite3.c"
        HEAP32[$111>>2] = $361; //@line 80935 "c/sqlite3.c"
        $362 = HEAP32[$150>>2]|0; //@line 80936 "c/sqlite3.c"
        $363 = (($362) + -1)|0; //@line 80936 "c/sqlite3.c"
        HEAP32[$150>>2] = $363; //@line 80936 "c/sqlite3.c"
        $364 = HEAP32[$151>>2]|0; //@line 80937 "c/sqlite3.c"
        _sqlite3VdbeSetChanges($8,$364); //@line 80937 "c/sqlite3.c"
        $365 = (_sqlite3VdbeFrameRestore($358)|0); //@line 80938 "c/sqlite3.c"
        $366 = ((($$02793)) + 8|0); //@line 80939 "c/sqlite3.c"
        $367 = HEAP32[$366>>2]|0; //@line 80939 "c/sqlite3.c"
        $368 = ($367|0)==(4); //@line 80939 "c/sqlite3.c"
        if ($368) {
         $369 = HEAP32[$6>>2]|0; //@line 80945 "c/sqlite3.c"
         $370 = (((($369) + (($365*20)|0)|0)) + 8|0); //@line 80945 "c/sqlite3.c"
         $371 = HEAP32[$370>>2]|0; //@line 80945 "c/sqlite3.c"
         $372 = (($371) + -1)|0; //@line 80945 "c/sqlite3.c"
         $$02852 = $372;
        } else {
         $$02852 = $365;
        }
        $415 = HEAP32[$6>>2]|0; //@line 80947 "c/sqlite3.c"
        $416 = HEAP32[$11>>2]|0; //@line 80948 "c/sqlite3.c"
        $417 = (($415) + (($$02852*20)|0)|0); //@line 80949 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $415;$$32817 = $$02814;$$32842 = $416;$$72829 = $$02822;$$8 = $417;$$87 = $$02801;
       }
       else if ((label|0) == 42) {
        label = 0;
        $468 = (_out2Prerelease($0,$$02793)|0); //@line 81078 "c/sqlite3.c"
        $469 = ((($468)) + 8|0); //@line 81079 "c/sqlite3.c"
        HEAP16[$469>>1] = 2562; //@line 81079 "c/sqlite3.c"
        $470 = ((($$02793)) + 16|0); //@line 81080 "c/sqlite3.c"
        $471 = HEAP32[$470>>2]|0; //@line 81080 "c/sqlite3.c"
        $472 = ((($468)) + 16|0); //@line 81080 "c/sqlite3.c"
        HEAP32[$472>>2] = $471; //@line 81080 "c/sqlite3.c"
        $473 = ((($$02793)) + 4|0); //@line 81081 "c/sqlite3.c"
        $474 = HEAP32[$473>>2]|0; //@line 81081 "c/sqlite3.c"
        $475 = ((($468)) + 12|0); //@line 81081 "c/sqlite3.c"
        HEAP32[$475>>2] = $474; //@line 81081 "c/sqlite3.c"
        $476 = ((($468)) + 10|0); //@line 81082 "c/sqlite3.c"
        HEAP8[$476>>0] = $10; //@line 81082 "c/sqlite3.c"
        $477 = ((($$02793)) + 12|0); //@line 81085 "c/sqlite3.c"
        $478 = HEAP32[$477>>2]|0; //@line 81085 "c/sqlite3.c"
        $479 = ($478|0)>(0); //@line 81085 "c/sqlite3.c"
        if ($479) {
         $480 = (($$02839) + (($478*40)|0)|0); //@line 81089 "c/sqlite3.c"
         $481 = $480; //@line 81089 "c/sqlite3.c"
         $482 = $481; //@line 81089 "c/sqlite3.c"
         $483 = HEAP32[$482>>2]|0; //@line 81089 "c/sqlite3.c"
         $484 = (($481) + 4)|0; //@line 81089 "c/sqlite3.c"
         $485 = $484; //@line 81089 "c/sqlite3.c"
         $486 = HEAP32[$485>>2]|0; //@line 81089 "c/sqlite3.c"
         $487 = ((($$02793)) + 2|0); //@line 81089 "c/sqlite3.c"
         $488 = HEAP16[$487>>1]|0; //@line 81089 "c/sqlite3.c"
         $489 = $488&65535; //@line 81089 "c/sqlite3.c"
         $490 = ($483|0)==($489|0); //@line 81089 "c/sqlite3.c"
         $491 = ($486|0)==(0); //@line 81089 "c/sqlite3.c"
         $492 = $490 & $491; //@line 81089 "c/sqlite3.c"
         if ($492) {
          HEAP16[$469>>1] = 2576; //@line 81089 "c/sqlite3.c"
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$72808;
         } else {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$72808;
         }
        } else {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$72808;
        }
       }
       else if ((label|0) == 405) {
        label = 0;
        $1995 = HEAPU8[$49>>0]|(HEAPU8[$49+1>>0]<<8); //@line 83407 "c/sqlite3.c"
        $1996 = $1995 & 1; //@line 83407 "c/sqlite3.c"
        $1997 = ($1996<<16>>16)==(0); //@line 83407 "c/sqlite3.c"
        if (!($1997)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 516;$$9 = $$02793;
         break L1;
        }
        $1998 = ((($$02793)) + 8|0); //@line 83414 "c/sqlite3.c"
        $1999 = HEAP32[$1998>>2]|0; //@line 83414 "c/sqlite3.c"
        $2000 = ((($$02793)) + 12|0); //@line 83415 "c/sqlite3.c"
        $2001 = HEAP32[$2000>>2]|0; //@line 83415 "c/sqlite3.c"
        $2002 = HEAP32[$121>>2]|0; //@line 83418 "c/sqlite3.c"
        $2003 = (((($2002) + ($2001<<4)|0)) + 4|0); //@line 83419 "c/sqlite3.c"
        $2004 = HEAP32[$2003>>2]|0; //@line 83419 "c/sqlite3.c"
        $2005 = ($252<<24>>24)==(106); //@line 83421 "c/sqlite3.c"
        if ($2005) {
         $2006 = ((($$02793)) + 2|0); //@line 83423 "c/sqlite3.c"
         $2007 = HEAP16[$2006>>1]|0; //@line 83423 "c/sqlite3.c"
         $2008 = $2007 & 8; //@line 83423 "c/sqlite3.c"
         $2009 = $2008 | 4; //@line 83423 "c/sqlite3.c"
         $2010 = $2009&65535; //@line 83423 "c/sqlite3.c"
         $2011 = (((($2002) + ($2001<<4)|0)) + 12|0); //@line 83425 "c/sqlite3.c"
         $2012 = HEAP32[$2011>>2]|0; //@line 83425 "c/sqlite3.c"
         $2013 = ((($2012)) + 76|0); //@line 83425 "c/sqlite3.c"
         $2014 = HEAP8[$2013>>0]|0; //@line 83425 "c/sqlite3.c"
         $2015 = HEAP8[$156>>0]|0; //@line 83425 "c/sqlite3.c"
         $2016 = ($2014&255)<($2015&255); //@line 83425 "c/sqlite3.c"
         if ($2016) {
          HEAP8[$156>>0] = $2014; //@line 83426 "c/sqlite3.c"
          $$02992 = $2010;
         } else {
          $$02992 = $2010;
         }
        } else {
         $$02992 = 0;
        }
        $2017 = ((($$02793)) + 2|0); //@line 83431 "c/sqlite3.c"
        $2018 = HEAP16[$2017>>1]|0; //@line 83431 "c/sqlite3.c"
        $2019 = $2018 & 16; //@line 83431 "c/sqlite3.c"
        $2020 = ($2019<<16>>16)==(0); //@line 83431 "c/sqlite3.c"
        $2021 = (($$02839) + (($1999*40)|0)|0); //@line 83434 "c/sqlite3.c"
        if ($2020) {
         $$02991 = $1999;
        } else {
         _sqlite3VdbeMemIntegerify($2021); //@line 83437 "c/sqlite3.c"
         $2022 = $2021; //@line 83438 "c/sqlite3.c"
         $2023 = $2022; //@line 83438 "c/sqlite3.c"
         $2024 = HEAP32[$2023>>2]|0; //@line 83438 "c/sqlite3.c"
         $2025 = (($2022) + 4)|0; //@line 83438 "c/sqlite3.c"
         $2026 = $2025; //@line 83438 "c/sqlite3.c"
         $2027 = HEAP32[$2026>>2]|0; //@line 83438 "c/sqlite3.c"
         $$02991 = $2024;
        }
        $2028 = ((($$02793)) + 1|0); //@line 83445 "c/sqlite3.c"
        $2029 = HEAP8[$2028>>0]|0; //@line 83445 "c/sqlite3.c"
        switch ($2029<<24>>24) {
        case -9:  {
         $2030 = ((($$02793)) + 16|0); //@line 83446 "c/sqlite3.c"
         $2031 = HEAP32[$2030>>2]|0; //@line 83446 "c/sqlite3.c"
         $2032 = ((($2031)) + 8|0); //@line 83449 "c/sqlite3.c"
         $2033 = HEAP16[$2032>>1]|0; //@line 83449 "c/sqlite3.c"
         $2034 = $2033&65535; //@line 83449 "c/sqlite3.c"
         $$02988 = $2034;$$02990 = $2031;
         break;
        }
        case -3:  {
         $2035 = ((($$02793)) + 16|0); //@line 83451 "c/sqlite3.c"
         $2036 = HEAP32[$2035>>2]|0; //@line 83451 "c/sqlite3.c"
         $$02988 = $2036;$$02990 = 0;
         break;
        }
        default: {
         $$02988 = 0;$$02990 = 0;
        }
        }
        $2037 = ((($$02793)) + 4|0); //@line 83456 "c/sqlite3.c"
        $2038 = HEAP32[$2037>>2]|0; //@line 83456 "c/sqlite3.c"
        $2039 = (_allocateCursor($0,$2038,$$02988,$2001,0)|0); //@line 83456 "c/sqlite3.c"
        $2040 = ($2039|0)==(0|0); //@line 83457 "c/sqlite3.c"
        if ($2040) {
         $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
         label = 853;
         break L1;
        }
        $2041 = ((($2039)) + 2|0); //@line 83458 "c/sqlite3.c"
        HEAP8[$2041>>0] = 1; //@line 83458 "c/sqlite3.c"
        $2042 = ((($2039)) + 5|0); //@line 83459 "c/sqlite3.c"
        $2043 = HEAP8[$2042>>0]|0; //@line 83459 "c/sqlite3.c"
        $2044 = $2043 | 4; //@line 83459 "c/sqlite3.c"
        HEAP8[$2042>>0] = $2044; //@line 83459 "c/sqlite3.c"
        $2045 = ((($2039)) + 52|0); //@line 83460 "c/sqlite3.c"
        HEAP32[$2045>>2] = $$02991; //@line 83460 "c/sqlite3.c"
        $2046 = ((($2039)) + 40|0); //@line 83464 "c/sqlite3.c"
        $2047 = HEAP32[$2046>>2]|0; //@line 83464 "c/sqlite3.c"
        $2048 = (_sqlite3BtreeCursor($2004,$$02991,$$02992,$$02990,$2047)|0); //@line 83464 "c/sqlite3.c"
        $2049 = ((($2039)) + 44|0); //@line 83465 "c/sqlite3.c"
        HEAP32[$2049>>2] = $$02990; //@line 83465 "c/sqlite3.c"
        $2050 = HEAP8[$2028>>0]|0; //@line 83470 "c/sqlite3.c"
        $2051 = ($2050<<24>>24)!=(-9); //@line 83470 "c/sqlite3.c"
        $2052 = $2051&1; //@line 83470 "c/sqlite3.c"
        $2053 = ((($2039)) + 4|0); //@line 83470 "c/sqlite3.c"
        HEAP8[$2053>>0] = $2052; //@line 83470 "c/sqlite3.c"
        $$02993 = $2039;$$31 = $2048;
        label = 416;
       }
       else if ((label|0) == 485) {
        label = 0;
        $2353 = ((($$02793)) + 12|0); //@line 84171 "c/sqlite3.c"
        $2354 = HEAP32[$2353>>2]|0; //@line 84171 "c/sqlite3.c"
        $2355 = HEAP32[$55>>2]|0; //@line 84174 "c/sqlite3.c"
        $2356 = ((($$02793)) + 4|0); //@line 84174 "c/sqlite3.c"
        $2357 = HEAP32[$2356>>2]|0; //@line 84174 "c/sqlite3.c"
        $2358 = (($2355) + ($2357<<2)|0); //@line 84174 "c/sqlite3.c"
        $2359 = HEAP32[$2358>>2]|0; //@line 84174 "c/sqlite3.c"
        $2360 = ((($2359)) + 40|0); //@line 84181 "c/sqlite3.c"
        $2361 = HEAP32[$2360>>2]|0; //@line 84181 "c/sqlite3.c"
        HEAP32[$5>>2] = 0; //@line 84183 "c/sqlite3.c"
        $2362 = (($$02839) + (($2354*40)|0)|0); //@line 84184 "c/sqlite3.c"
        $2363 = $2362; //@line 84184 "c/sqlite3.c"
        $2364 = $2363; //@line 84184 "c/sqlite3.c"
        $2365 = HEAP32[$2364>>2]|0; //@line 84184 "c/sqlite3.c"
        $2366 = (($2363) + 4)|0; //@line 84184 "c/sqlite3.c"
        $2367 = $2366; //@line 84184 "c/sqlite3.c"
        $2368 = HEAP32[$2367>>2]|0; //@line 84184 "c/sqlite3.c"
        $2369 = (_sqlite3BtreeMovetoUnpacked($2361,0,$2365,$2368,0,$5)|0); //@line 84185 "c/sqlite3.c"
        $2370 = ((($2359)) + 64|0); //@line 84187 "c/sqlite3.c"
        $2371 = $2370; //@line 84187 "c/sqlite3.c"
        $2372 = $2371; //@line 84187 "c/sqlite3.c"
        HEAP32[$2372>>2] = $2365; //@line 84187 "c/sqlite3.c"
        $2373 = (($2371) + 4)|0; //@line 84187 "c/sqlite3.c"
        $2374 = $2373; //@line 84187 "c/sqlite3.c"
        HEAP32[$2374>>2] = $2368; //@line 84187 "c/sqlite3.c"
        $2375 = ((($2359)) + 2|0); //@line 84188 "c/sqlite3.c"
        HEAP8[$2375>>0] = 0; //@line 84188 "c/sqlite3.c"
        $2376 = ((($2359)) + 28|0); //@line 84189 "c/sqlite3.c"
        HEAP32[$2376>>2] = 0; //@line 84189 "c/sqlite3.c"
        $2377 = ((($2359)) + 3|0); //@line 84190 "c/sqlite3.c"
        HEAP8[$2377>>0] = 0; //@line 84190 "c/sqlite3.c"
        $2378 = HEAP32[$5>>2]|0; //@line 84192 "c/sqlite3.c"
        $2379 = ((($2359)) + 32|0); //@line 84192 "c/sqlite3.c"
        HEAP32[$2379>>2] = $2378; //@line 84192 "c/sqlite3.c"
        $2380 = ($2378|0)==(0); //@line 84193 "c/sqlite3.c"
        if ($2380) {
         $$42 = $2369;
        } else {
         $2381 = ((($$02793)) + 8|0); //@line 84195 "c/sqlite3.c"
         $2382 = HEAP32[$2381>>2]|0; //@line 84195 "c/sqlite3.c"
         $2383 = ($2382|0)==(0); //@line 84195 "c/sqlite3.c"
         if (!($2383)) {
          $$32804 = $2369;
          label = 13;
          break;
         }
         $2384 = (_sqlite3CorruptError(84196)|0); //@line 84196 "c/sqlite3.c"
         $$42 = $2384;
        }
        $2385 = ($$42|0)==(0); //@line 84201 "c/sqlite3.c"
        if ($2385) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$42;$$9 = $$02793;
         break L1;
        }
       }
       else if ((label|0) == 587) {
        label = 0;
        $2866 = HEAP32[$70>>2]|0; //@line 84964 "c/sqlite3.c"
        $2867 = ((($$02793)) + 4|0); //@line 84964 "c/sqlite3.c"
        $2868 = HEAP32[$2867>>2]|0; //@line 84964 "c/sqlite3.c"
        $2869 = (($2866) + ($2868<<2)|0); //@line 84964 "c/sqlite3.c"
        $2870 = HEAP32[$2869>>2]|0; //@line 84964 "c/sqlite3.c"
        HEAP32[$1>>2] = 1; //@line 84967 "c/sqlite3.c"
        $2871 = HEAP8[$2870>>0]|0; //@line 84971 "c/sqlite3.c"
        $2872 = ($2871<<24>>24)==(1); //@line 84971 "c/sqlite3.c"
        if ($2872) {
         $2873 = (_sqlite3VdbeSorterRewind($2870,$1)|0); //@line 84972 "c/sqlite3.c"
         $$50 = $2873;
        } else {
         $2874 = ((($2870)) + 40|0); //@line 84975 "c/sqlite3.c"
         $2875 = HEAP32[$2874>>2]|0; //@line 84975 "c/sqlite3.c"
         $2876 = (_sqlite3BtreeFirst($2875,$1)|0); //@line 84977 "c/sqlite3.c"
         $2877 = ((($2870)) + 3|0); //@line 84978 "c/sqlite3.c"
         HEAP8[$2877>>0] = 0; //@line 84978 "c/sqlite3.c"
         $2878 = ((($2870)) + 28|0); //@line 84979 "c/sqlite3.c"
         HEAP32[$2878>>2] = 0; //@line 84979 "c/sqlite3.c"
         $$50 = $2876;
        }
        $2879 = ($$50|0)==(0); //@line 84981 "c/sqlite3.c"
        if (!($2879)) {
         label = 591;
         break L8;
        }
        $2880 = HEAP32[$1>>2]|0; //@line 84982 "c/sqlite3.c"
        $2881 = $2880&255; //@line 84982 "c/sqlite3.c"
        $2882 = ((($2870)) + 2|0); //@line 84982 "c/sqlite3.c"
        HEAP8[$2882>>0] = $2881; //@line 84982 "c/sqlite3.c"
        $2883 = ($2880|0)==(0); //@line 84985 "c/sqlite3.c"
        if ($2883) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$32804 = 0;
         label = 13;
        }
       }
       else if ((label|0) == 595) {
        label = 0;
        $2896 = HEAP32[$73>>2]|0; //@line 85074 "c/sqlite3.c"
        $2897 = ((($$02793)) + 4|0); //@line 85074 "c/sqlite3.c"
        $2898 = HEAP32[$2897>>2]|0; //@line 85074 "c/sqlite3.c"
        $2899 = (($2896) + ($2898<<2)|0); //@line 85074 "c/sqlite3.c"
        $2900 = HEAP32[$2899>>2]|0; //@line 85074 "c/sqlite3.c"
        $2901 = ((($$02793)) + 16|0); //@line 85092 "c/sqlite3.c"
        $2902 = HEAP32[$2901>>2]|0; //@line 85092 "c/sqlite3.c"
        $2903 = ((($2900)) + 40|0); //@line 85092 "c/sqlite3.c"
        $2904 = HEAP32[$2903>>2]|0; //@line 85092 "c/sqlite3.c"
        $2905 = ((($$02793)) + 12|0); //@line 85092 "c/sqlite3.c"
        $2906 = HEAP32[$2905>>2]|0; //@line 85092 "c/sqlite3.c"
        $2907 = (FUNCTION_TABLE_iii[$2902 & 255]($2904,$2906)|0); //@line 85092 "c/sqlite3.c"
        $$03010 = $2900;$$51 = $2907;
        label = 596;
       }
       else if ((label|0) == 714) {
        label = 0;
        $3704 = ((($$02793)) + 16|0); //@line 86206 "c/sqlite3.c"
        $3705 = HEAP32[$3704>>2]|0; //@line 86206 "c/sqlite3.c"
        $3706 = ((($$02793)) + 12|0); //@line 86207 "c/sqlite3.c"
        $3707 = HEAP32[$3706>>2]|0; //@line 86207 "c/sqlite3.c"
        $3708 = (($$02839) + (($3707*40)|0)|0); //@line 86207 "c/sqlite3.c"
        $3709 = ((($3705)) + 8|0); //@line 86213 "c/sqlite3.c"
        $3710 = HEAP32[$3709>>2]|0; //@line 86213 "c/sqlite3.c"
        $3711 = ($3710|0)==($3708|0); //@line 86213 "c/sqlite3.c"
        if (!($3711)) {
         HEAP32[$3709>>2] = $3708; //@line 86214 "c/sqlite3.c"
         $3712 = ((($3705)) + 26|0); //@line 86215 "c/sqlite3.c"
         $3713 = HEAP8[$3712>>0]|0; //@line 86215 "c/sqlite3.c"
         $3714 = ($3713<<24>>24)==(0); //@line 86215 "c/sqlite3.c"
         if (!($3714)) {
          $3715 = $3713&255; //@line 86215 "c/sqlite3.c"
          $3716 = ((($$02793)) + 8|0);
          $3717 = HEAP32[$3716>>2]|0;
          $$029733793$in = $3715;
          while(1) {
           $$029733793 = (($$029733793$in) + -1)|0;
           $3718 = (($3717) + ($$029733793))|0; //@line 86215 "c/sqlite3.c"
           $3719 = (($$02839) + (($3718*40)|0)|0); //@line 86215 "c/sqlite3.c"
           $3720 = (((($3705)) + 28|0) + ($$029733793<<2)|0); //@line 86215 "c/sqlite3.c"
           HEAP32[$3720>>2] = $3719; //@line 86215 "c/sqlite3.c"
           $3721 = ($$029733793$in|0)>(1); //@line 86215 "c/sqlite3.c"
           if ($3721) {
            $$029733793$in = $$029733793;
           } else {
            break;
           }
          }
         }
        }
        $3722 = (((($$02839) + (($3707*40)|0)|0)) + 12|0); //@line 86225 "c/sqlite3.c"
        $3723 = HEAP32[$3722>>2]|0; //@line 86225 "c/sqlite3.c"
        $3724 = (($3723) + 1)|0; //@line 86225 "c/sqlite3.c"
        HEAP32[$3722>>2] = $3724; //@line 86225 "c/sqlite3.c"
        _sqlite3VdbeMemInit($1,$8,1); //@line 86226 "c/sqlite3.c"
        HEAP32[$3705>>2] = $1; //@line 86227 "c/sqlite3.c"
        $3725 = ((($3705)) + 25|0); //@line 86228 "c/sqlite3.c"
        HEAP8[$3725>>0] = 0; //@line 86228 "c/sqlite3.c"
        $3726 = ((($3705)) + 24|0); //@line 86229 "c/sqlite3.c"
        HEAP8[$3726>>0] = 0; //@line 86229 "c/sqlite3.c"
        $3727 = ((($3705)) + 4|0); //@line 86230 "c/sqlite3.c"
        $3728 = HEAP32[$3727>>2]|0; //@line 86230 "c/sqlite3.c"
        $3729 = ((($3728)) + 12|0); //@line 86230 "c/sqlite3.c"
        $3730 = HEAP32[$3729>>2]|0; //@line 86230 "c/sqlite3.c"
        $3731 = ((($3705)) + 26|0); //@line 86230 "c/sqlite3.c"
        $3732 = HEAP8[$3731>>0]|0; //@line 86230 "c/sqlite3.c"
        $3733 = $3732&255; //@line 86230 "c/sqlite3.c"
        $3734 = ((($3705)) + 28|0); //@line 86230 "c/sqlite3.c"
        FUNCTION_TABLE_viii[$3730 & 255]($3705,$3733,$3734); //@line 86230 "c/sqlite3.c"
        $3735 = HEAP8[$3725>>0]|0; //@line 86231 "c/sqlite3.c"
        $3736 = ($3735<<24>>24)==(0); //@line 86231 "c/sqlite3.c"
        if ($3736) {
         $$65 = $$02801;
        } else {
         $3737 = ((($3705)) + 20|0); //@line 86232 "c/sqlite3.c"
         $3738 = HEAP32[$3737>>2]|0; //@line 86232 "c/sqlite3.c"
         $3739 = ($3738|0)==(0); //@line 86232 "c/sqlite3.c"
         if ($3739) {
          $$64 = $$02801;
         } else {
          $3740 = (_sqlite3_value_text($1)|0); //@line 86233 "c/sqlite3.c"
          HEAP32[$vararg_buffer31>>2] = $3740; //@line 86233 "c/sqlite3.c"
          _sqlite3VdbeError($0,15687,$vararg_buffer31); //@line 86233 "c/sqlite3.c"
          $3741 = HEAP32[$3737>>2]|0; //@line 86234 "c/sqlite3.c"
          $$64 = $3741;
         }
         _sqlite3VdbeMemRelease($1); //@line 86236 "c/sqlite3.c"
         $3742 = ($$64|0)==(0); //@line 86237 "c/sqlite3.c"
         if ($3742) {
          $$65 = 0;
         } else {
          label = 726;
          break L8;
         }
        }
        $3743 = HEAP8[$3726>>0]|0; //@line 86241 "c/sqlite3.c"
        $3744 = ($3743<<24>>24)==(0); //@line 86241 "c/sqlite3.c"
        if (!($3744)) {
         $3745 = ((($$02793)) + -16|0); //@line 86243 "c/sqlite3.c"
         $3746 = HEAP32[$3745>>2]|0; //@line 86243 "c/sqlite3.c"
         $3747 = ($3746|0)==(0); //@line 86244 "c/sqlite3.c"
         if (!($3747)) {
          $3748 = (($$02839) + (($3746*40)|0)|0); //@line 86244 "c/sqlite3.c"
          _sqlite3VdbeMemSetInt64($3748,1,0); //@line 86244 "c/sqlite3.c"
         }
        }
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$65;
       }
       else if ((label|0) == 816) {
        label = 0;
        $4129 = ((($$02793)) + 16|0); //@line 87011 "c/sqlite3.c"
        $4130 = HEAP32[$4129>>2]|0; //@line 87011 "c/sqlite3.c"
        $4131 = ((($$02793)) + 12|0); //@line 87017 "c/sqlite3.c"
        $4132 = HEAP32[$4131>>2]|0; //@line 87017 "c/sqlite3.c"
        $4133 = (($$02839) + (($4132*40)|0)|0); //@line 87017 "c/sqlite3.c"
        $4134 = HEAP32[$4130>>2]|0; //@line 87018 "c/sqlite3.c"
        $4135 = ($4134|0)==($4133|0); //@line 87018 "c/sqlite3.c"
        if (!($4135)) {
         HEAP32[$4130>>2] = $4133; //@line 87019 "c/sqlite3.c"
         $4136 = ((($4130)) + 26|0); //@line 87020 "c/sqlite3.c"
         $4137 = HEAP8[$4136>>0]|0; //@line 87020 "c/sqlite3.c"
         $4138 = ($4137<<24>>24)==(0); //@line 87020 "c/sqlite3.c"
         if (!($4138)) {
          $4139 = $4137&255; //@line 87020 "c/sqlite3.c"
          $4140 = ((($$02793)) + 8|0);
          $4141 = HEAP32[$4140>>2]|0;
          $$028213778$in = $4139;
          while(1) {
           $$028213778 = (($$028213778$in) + -1)|0;
           $4142 = (($4141) + ($$028213778))|0; //@line 87020 "c/sqlite3.c"
           $4143 = (($$02839) + (($4142*40)|0)|0); //@line 87020 "c/sqlite3.c"
           $4144 = (((($4130)) + 28|0) + ($$028213778<<2)|0); //@line 87020 "c/sqlite3.c"
           HEAP32[$4144>>2] = $4143; //@line 87020 "c/sqlite3.c"
           $4145 = ($$028213778$in|0)>(1); //@line 87020 "c/sqlite3.c"
           if ($4145) {
            $$028213778$in = $$028213778;
           } else {
            break;
           }
          }
         }
        }
        $4146 = (((($$02839) + (($4132*40)|0)|0)) + 8|0); //@line 87030 "c/sqlite3.c"
        $4147 = HEAP16[$4146>>1]|0; //@line 87030 "c/sqlite3.c"
        $4148 = $4147 & 15872; //@line 87030 "c/sqlite3.c"
        $4149 = $4148 | 1; //@line 87030 "c/sqlite3.c"
        HEAP16[$4146>>1] = $4149; //@line 87030 "c/sqlite3.c"
        $4150 = ((($4130)) + 25|0); //@line 87031 "c/sqlite3.c"
        HEAP8[$4150>>0] = 0; //@line 87031 "c/sqlite3.c"
        $4151 = ((($4130)) + 4|0); //@line 87032 "c/sqlite3.c"
        $4152 = HEAP32[$4151>>2]|0; //@line 87032 "c/sqlite3.c"
        $4153 = ((($4152)) + 12|0); //@line 87032 "c/sqlite3.c"
        $4154 = HEAP32[$4153>>2]|0; //@line 87032 "c/sqlite3.c"
        $4155 = ((($4130)) + 26|0); //@line 87032 "c/sqlite3.c"
        $4156 = HEAP8[$4155>>0]|0; //@line 87032 "c/sqlite3.c"
        $4157 = $4156&255; //@line 87032 "c/sqlite3.c"
        $4158 = ((($4130)) + 28|0); //@line 87032 "c/sqlite3.c"
        FUNCTION_TABLE_viii[$4154 & 255]($4130,$4157,$4158); //@line 87032 "c/sqlite3.c"
        $4159 = HEAP8[$4150>>0]|0; //@line 87035 "c/sqlite3.c"
        $4160 = ($4159<<24>>24)==(0); //@line 87035 "c/sqlite3.c"
        if ($4160) {
         $$85 = $$02801;
        } else {
         $4161 = ((($4130)) + 20|0); //@line 87036 "c/sqlite3.c"
         $4162 = HEAP32[$4161>>2]|0; //@line 87036 "c/sqlite3.c"
         $4163 = ($4162|0)==(0); //@line 87036 "c/sqlite3.c"
         if ($4163) {
          $$84 = $$02801;
         } else {
          $4164 = (_sqlite3_value_text($4133)|0); //@line 87037 "c/sqlite3.c"
          HEAP32[$vararg_buffer43>>2] = $4164; //@line 87037 "c/sqlite3.c"
          _sqlite3VdbeError($0,15687,$vararg_buffer43); //@line 87037 "c/sqlite3.c"
          $4165 = HEAP32[$4161>>2]|0; //@line 87038 "c/sqlite3.c"
          $$84 = $4165;
         }
         $4166 = ((($4130)) + 16|0); //@line 87040 "c/sqlite3.c"
         $4167 = HEAP32[$4166>>2]|0; //@line 87040 "c/sqlite3.c"
         $4168 = ((($$02793)) + 4|0); //@line 87040 "c/sqlite3.c"
         $4169 = HEAP32[$4168>>2]|0; //@line 87040 "c/sqlite3.c"
         _sqlite3VdbeDeleteAuxData($8,$190,$4167,$4169); //@line 87040 "c/sqlite3.c"
         $4170 = ($$84|0)==(0); //@line 87041 "c/sqlite3.c"
         if ($4170) {
          $$85 = 0;
         } else {
          $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$84;$$9 = $$02793;
          break L1;
         }
        }
        $4171 = HEAP16[$4146>>1]|0; //@line 87045 "c/sqlite3.c"
        $4172 = $4171 & 18; //@line 87045 "c/sqlite3.c"
        $4173 = ($4172<<16>>16)==(0); //@line 87045 "c/sqlite3.c"
        if ($4173) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$85;
        } else {
         (_sqlite3VdbeChangeEncoding($4133,$189)|0); //@line 87046 "c/sqlite3.c"
         $4174 = (_sqlite3VdbeMemTooBig($4133)|0); //@line 87047 "c/sqlite3.c"
         $4175 = ($4174|0)==(0); //@line 87047 "c/sqlite3.c"
         if ($4175) {
          $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = $$85;
         } else {
          label = 852;
          break L8;
         }
        }
       }
      } while(0);
      L972: do {
       if ((label|0) == 13) {
        label = 0;
        $283 = ((($$02793)) + 8|0); //@line 80797 "c/sqlite3.c"
        $284 = HEAP32[$283>>2]|0; //@line 80797 "c/sqlite3.c"
        $285 = (($284) + -1)|0; //@line 80797 "c/sqlite3.c"
        $286 = (($$02792) + (($285*20)|0)|0); //@line 80797 "c/sqlite3.c"
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $286;$$87 = $$32804;
       }
       else if ((label|0) == 416) {
        label = 0;
        $2054 = ((($$02993)) + 40|0); //@line 83479 "c/sqlite3.c"
        $2055 = HEAP32[$2054>>2]|0; //@line 83479 "c/sqlite3.c"
        $2056 = ((($$02793)) + 2|0); //@line 83480 "c/sqlite3.c"
        $2057 = HEAP16[$2056>>1]|0; //@line 83480 "c/sqlite3.c"
        $2058 = $2057 & 3; //@line 83480 "c/sqlite3.c"
        $2059 = $2058&65535; //@line 83480 "c/sqlite3.c"
        _sqlite3BtreeCursorHintFlags($2055,$2059); //@line 83479 "c/sqlite3.c"
        $2060 = ($$31|0)==(0); //@line 83481 "c/sqlite3.c"
        if ($2060) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$02793;$$87 = 0;
        } else {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$31;$$9 = $$02793;
         break L1;
        }
       }
       else if ((label|0) == 596) {
        label = 0;
        $2908 = ((($$03010)) + 28|0); //@line 85094 "c/sqlite3.c"
        HEAP32[$2908>>2] = 0; //@line 85094 "c/sqlite3.c"
        switch ($$51|0) {
        case 0:  {
         $2909 = ((($$03010)) + 2|0); //@line 85097 "c/sqlite3.c"
         HEAP8[$2909>>0] = 0; //@line 85097 "c/sqlite3.c"
         $2910 = ((($$02793)) + 2|0); //@line 85098 "c/sqlite3.c"
         $2911 = HEAP16[$2910>>1]|0; //@line 85098 "c/sqlite3.c"
         $2912 = $2911&65535; //@line 85098 "c/sqlite3.c"
         $2913 = (((($0)) + 156|0) + ($2912<<2)|0); //@line 85098 "c/sqlite3.c"
         $2914 = HEAP32[$2913>>2]|0; //@line 85098 "c/sqlite3.c"
         $2915 = (($2914) + 1)|0; //@line 85098 "c/sqlite3.c"
         HEAP32[$2913>>2] = $2915; //@line 85098 "c/sqlite3.c"
         $$12802 = 0;
         label = 7;
         break L972;
         break;
        }
        case 101:  {
         $2916 = ((($$03010)) + 2|0); //@line 85106 "c/sqlite3.c"
         HEAP8[$2916>>0] = 1; //@line 85106 "c/sqlite3.c"
         $$12794 = $$02793;$$22803 = 0;
         label = 8;
         break L972;
         break;
        }
        default: {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$51;$$9 = $$02793;
         break L1;
        }
        }
       }
      } while(0);
      if ((label|0) == 7) {
       label = 0;
       $253 = ((($$02793)) + 8|0); //@line 80746 "c/sqlite3.c"
       $254 = HEAP32[$253>>2]|0; //@line 80746 "c/sqlite3.c"
       $255 = (($254) + -1)|0; //@line 80746 "c/sqlite3.c"
       $256 = (($$02792) + (($255*20)|0)|0); //@line 80746 "c/sqlite3.c"
       $$12794 = $256;$$22803 = $$12802;
       label = 8;
      }
      if ((label|0) == 8) {
       label = 0;
       $257 = HEAP32[$23>>2]|0; //@line 80759 "c/sqlite3.c"
       $258 = ($257|0)==(0); //@line 80759 "c/sqlite3.c"
       if (!($258)) {
        $$12 = $$12794;$$42834 = $251;$$6 = $$02792;$$62820 = $$02814;
        break L3;
       }
       $259 = ($251>>>0)<($$12836>>>0); //@line 80767 "c/sqlite3.c"
       if ($259) {
        $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$12794;$$87 = $$22803;
       } else {
        $260 = HEAP32[$26>>2]|0; //@line 80767 "c/sqlite3.c"
        $261 = ($260|0)==(0|0); //@line 80767 "c/sqlite3.c"
        if ($261) {
         $$22837 = $$12836;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$12794;$$87 = $$22803;
        } else {
         $262 = HEAP32[$166>>2]|0; //@line 80769 "c/sqlite3.c"
         $263 = (($262) + ($251))|0; //@line 80769 "c/sqlite3.c"
         $264 = (($251>>>0) % ($262>>>0))&-1; //@line 80769 "c/sqlite3.c"
         $265 = (($263) - ($264))|0; //@line 80769 "c/sqlite3.c"
         $266 = HEAP32[$167>>2]|0; //@line 80770 "c/sqlite3.c"
         $267 = (FUNCTION_TABLE_ii[$260 & 255]($266)|0); //@line 80770 "c/sqlite3.c"
         $268 = ($267|0)==(0); //@line 80770 "c/sqlite3.c"
         if ($268) {
          $$22837 = $265;$$3 = $$02792;$$32817 = $$02814;$$32842 = $$02839;$$72829 = $$02822;$$8 = $$12794;$$87 = $$22803;
         } else {
          $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 9;$$9 = $$12794;
          break L1;
         }
        }
       }
      }
      $4219 = ((($$8)) + 20|0); //@line 80619 "c/sqlite3.c"
      $$02792 = $$3;$$02793 = $4219;$$02801 = $$87;$$02814 = $$32817;$$02822 = $$72829;$$02830 = $251;$$02839 = $$32842;$$12836 = $$22837;
     }
     switch (label|0) {
      case 23: {
       $373 = $$02793; //@line 80931 "c/sqlite3.c"
       $374 = $$02792; //@line 80931 "c/sqlite3.c"
       $375 = (($373) - ($374))|0; //@line 80931 "c/sqlite3.c"
       $376 = (($375|0) / 20)&-1; //@line 80931 "c/sqlite3.c"
       HEAP32[$13>>2] = $356; //@line 80952 "c/sqlite3.c"
       $377 = ((($$02793)) + 8|0); //@line 80953 "c/sqlite3.c"
       $378 = HEAP32[$377>>2]|0; //@line 80953 "c/sqlite3.c"
       $379 = $378&255; //@line 80953 "c/sqlite3.c"
       $380 = ((($0)) + 142|0); //@line 80953 "c/sqlite3.c"
       HEAP8[$380>>0] = $379; //@line 80953 "c/sqlite3.c"
       HEAP32[$35>>2] = $376; //@line 80954 "c/sqlite3.c"
       label = 29;
       break;
      }
      case 24: {
       $381 = $$02793; //@line 80931 "c/sqlite3.c"
       $382 = $$02792; //@line 80931 "c/sqlite3.c"
       $383 = (($381) - ($382))|0; //@line 80931 "c/sqlite3.c"
       $384 = (($383|0) / 20)&-1; //@line 80931 "c/sqlite3.c"
       HEAP32[$13>>2] = $356; //@line 80952 "c/sqlite3.c"
       $385 = ((($$02793)) + 8|0); //@line 80953 "c/sqlite3.c"
       $386 = HEAP32[$385>>2]|0; //@line 80953 "c/sqlite3.c"
       $387 = $386&255; //@line 80953 "c/sqlite3.c"
       $388 = ((($0)) + 142|0); //@line 80953 "c/sqlite3.c"
       HEAP8[$388>>0] = $387; //@line 80953 "c/sqlite3.c"
       HEAP32[$35>>2] = $384; //@line 80954 "c/sqlite3.c"
       $389 = ((($$02793)) + 4|0); //@line 80932 "c/sqlite3.c"
       $390 = ((($$02793)) + 2|0); //@line 80957 "c/sqlite3.c"
       $391 = HEAP16[$390>>1]|0; //@line 80957 "c/sqlite3.c"
       $392 = ($391<<16>>16)==(0); //@line 80957 "c/sqlite3.c"
       if ($392) {
        $403 = ((($$02793)) + 16|0); //@line 80969 "c/sqlite3.c"
        $404 = HEAP32[$403>>2]|0; //@line 80969 "c/sqlite3.c"
        HEAP32[$vararg_buffer5>>2] = $404; //@line 80969 "c/sqlite3.c"
        _sqlite3VdbeError($0,15687,$vararg_buffer5); //@line 80969 "c/sqlite3.c"
       } else {
        $393 = $391&65535; //@line 80964 "c/sqlite3.c"
        $394 = (($393) + -1)|0; //@line 80964 "c/sqlite3.c"
        $395 = (6392 + ($394<<2)|0); //@line 80964 "c/sqlite3.c"
        $396 = HEAP32[$395>>2]|0; //@line 80964 "c/sqlite3.c"
        HEAP32[$vararg_buffer>>2] = $396; //@line 80964 "c/sqlite3.c"
        _sqlite3VdbeError($0,33656,$vararg_buffer); //@line 80964 "c/sqlite3.c"
        $397 = ((($$02793)) + 16|0); //@line 80965 "c/sqlite3.c"
        $398 = HEAP32[$397>>2]|0; //@line 80965 "c/sqlite3.c"
        $399 = ($398|0)==(0|0); //@line 80965 "c/sqlite3.c"
        if (!($399)) {
         $400 = ((($0)) + 108|0); //@line 80966 "c/sqlite3.c"
         $401 = HEAP32[$400>>2]|0; //@line 80966 "c/sqlite3.c"
         HEAP32[$vararg_buffer1>>2] = $401; //@line 80966 "c/sqlite3.c"
         $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 80966 "c/sqlite3.c"
         HEAP32[$vararg_ptr4>>2] = $398; //@line 80966 "c/sqlite3.c"
         $402 = (_sqlite3MPrintf($8,33677,$vararg_buffer1)|0); //@line 80966 "c/sqlite3.c"
         HEAP32[$400>>2] = $402; //@line 80966 "c/sqlite3.c"
        }
       }
       $405 = HEAP32[$389>>2]|0; //@line 80971 "c/sqlite3.c"
       $406 = ((($0)) + 184|0); //@line 80971 "c/sqlite3.c"
       $407 = HEAP32[$406>>2]|0; //@line 80971 "c/sqlite3.c"
       $408 = ((($0)) + 108|0); //@line 80971 "c/sqlite3.c"
       $409 = HEAP32[$408>>2]|0; //@line 80971 "c/sqlite3.c"
       HEAP32[$vararg_buffer8>>2] = $384; //@line 80971 "c/sqlite3.c"
       $vararg_ptr11 = ((($vararg_buffer8)) + 4|0); //@line 80971 "c/sqlite3.c"
       HEAP32[$vararg_ptr11>>2] = $407; //@line 80971 "c/sqlite3.c"
       $vararg_ptr12 = ((($vararg_buffer8)) + 8|0); //@line 80971 "c/sqlite3.c"
       HEAP32[$vararg_ptr12>>2] = $409; //@line 80971 "c/sqlite3.c"
       _sqlite3_log($405,33684,$vararg_buffer8); //@line 80971 "c/sqlite3.c"
       label = 29;
       break;
      }
      case 63: {
       $587 = HEAP32[$26>>2]|0; //@line 81308 "c/sqlite3.c"
       $588 = ($587|0)==(0|0); //@line 81308 "c/sqlite3.c"
       $589 = ($251>>>0)<($$12836>>>0); //@line 81309 "c/sqlite3.c"
       $or$cond3015 = $589 | $588; //@line 81309 "c/sqlite3.c"
       if (!($or$cond3015)) {
        $590 = ((($8)) + 316|0); //@line 81310 "c/sqlite3.c"
        $591 = HEAP32[$590>>2]|0; //@line 81310 "c/sqlite3.c"
        $592 = (FUNCTION_TABLE_ii[$587 & 255]($591)|0); //@line 81310 "c/sqlite3.c"
        $593 = ($592|0)==(0); //@line 81310 "c/sqlite3.c"
        if (!($593)) {
         $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 9;$$9 = $$02793;
         break L1;
        }
       }
       $594 = (_sqlite3VdbeCheckFk($0,0)|0); //@line 81320 "c/sqlite3.c"
       $595 = ($594|0)==(0); //@line 81320 "c/sqlite3.c"
       if (!($595)) {
        $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $594;$$9 = $$02793;
        break L1;
       }
       (_sqlite3VdbeCloseStatement($0,1)|0); //@line 81342 "c/sqlite3.c"
       $596 = ((($0)) + 32|0); //@line 81346 "c/sqlite3.c"
       $597 = HEAP32[$596>>2]|0; //@line 81346 "c/sqlite3.c"
       $598 = (($597) + 2)|0; //@line 81346 "c/sqlite3.c"
       $599 = $598 | 1; //@line 81346 "c/sqlite3.c"
       HEAP32[$596>>2] = $599; //@line 81346 "c/sqlite3.c"
       $600 = ((($$02793)) + 4|0); //@line 81352 "c/sqlite3.c"
       $601 = HEAP32[$600>>2]|0; //@line 81352 "c/sqlite3.c"
       $602 = (($$02839) + (($601*40)|0)|0); //@line 81352 "c/sqlite3.c"
       HEAP32[$21>>2] = $602; //@line 81352 "c/sqlite3.c"
       $603 = ((($$02793)) + 8|0); //@line 81353 "c/sqlite3.c"
       $604 = HEAP32[$603>>2]|0; //@line 81353 "c/sqlite3.c"
       $605 = ($604|0)>(0); //@line 81353 "c/sqlite3.c"
       if ($605) {
        $$029243776 = 0;
        while(1) {
         $606 = (($602) + (($$029243776*40)|0)|0); //@line 81355 "c/sqlite3.c"
         $607 = ((($606)) + 8|0); //@line 81355 "c/sqlite3.c"
         $608 = HEAP16[$607>>1]|0; //@line 81355 "c/sqlite3.c"
         $609 = $608 & 4096; //@line 81355 "c/sqlite3.c"
         $610 = ($609<<16>>16)==(0); //@line 81355 "c/sqlite3.c"
         if (!($610)) {
          $611 = (_sqlite3VdbeMemMakeWriteable($606)|0); //@line 81355 "c/sqlite3.c"
          $612 = ($611|0)==(0); //@line 81355 "c/sqlite3.c"
          if (!($612)) {
           $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
           label = 853;
           break L1;
          }
         }
         _sqlite3VdbeMemNulTerminate($606); //@line 81358 "c/sqlite3.c"
         $613 = (($$029243776) + 1)|0; //@line 81353 "c/sqlite3.c"
         $614 = HEAP32[$603>>2]|0; //@line 81353 "c/sqlite3.c"
         $615 = ($613|0)<($614|0); //@line 81353 "c/sqlite3.c"
         if ($615) {
          $$029243776 = $613;
         } else {
          break;
         }
        }
       }
       $616 = ((($8)) + 73|0); //@line 81361 "c/sqlite3.c"
       $617 = HEAP8[$616>>0]|0; //@line 81361 "c/sqlite3.c"
       $618 = ($617<<24>>24)==(0); //@line 81361 "c/sqlite3.c"
       if (!($618)) {
        $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
        label = 853;
        break L1;
       }
       $619 = ((($8)) + 80|0); //@line 81363 "c/sqlite3.c"
       $620 = HEAP8[$619>>0]|0; //@line 81363 "c/sqlite3.c"
       $621 = $620 & 4; //@line 81363 "c/sqlite3.c"
       $622 = ($621<<24>>24)==(0); //@line 81363 "c/sqlite3.c"
       if (!($622)) {
        $623 = ((($8)) + 188|0); //@line 81364 "c/sqlite3.c"
        $624 = HEAP32[$623>>2]|0; //@line 81364 "c/sqlite3.c"
        $625 = ((($8)) + 192|0); //@line 81364 "c/sqlite3.c"
        $626 = HEAP32[$625>>2]|0; //@line 81364 "c/sqlite3.c"
        (FUNCTION_TABLE_iiiii[$624 & 127](4,$626,$0,0)|0); //@line 81364 "c/sqlite3.c"
       }
       $627 = $$02793; //@line 81369 "c/sqlite3.c"
       $628 = $$02792; //@line 81369 "c/sqlite3.c"
       $629 = (($627) - ($628))|0; //@line 81369 "c/sqlite3.c"
       $630 = (($629|0) / 20)&-1; //@line 81369 "c/sqlite3.c"
       $631 = (($630) + 1)|0; //@line 81369 "c/sqlite3.c"
       HEAP32[$35>>2] = $631; //@line 81369 "c/sqlite3.c"
       $$22832 = $251;$$90 = 100;
       $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
       $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
       $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
       HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
       _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
       STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
       break;
      }
      case 223: {
       label = 852;
       break;
      }
      case 273: {
       $1534 = (_sqlite3CorruptError(82648)|0); //@line 82648 "c/sqlite3.c"
       $$14$ph3100 = $1534;
       label = 275;
       break;
      }
      case 276: {
       $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
       label = 853;
       break L1;
       break;
      }
      case 308: {
       $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
       label = 853;
       break L1;
       break;
      }
      case 309: {
       label = 852;
       break;
      }
      case 312: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $1669;$$9 = $$02793;
       break L1;
       break;
      }
      case 315: {
       _sqlite3VdbeError($0,33744,$vararg_buffer13); //@line 82917 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 5;$$9 = $$02793;
       break L1;
       break;
      }
      case 326: {
       HEAP32[$vararg_buffer15>>2] = $1685; //@line 82968 "c/sqlite3.c"
       _sqlite3VdbeError($0,33795,$vararg_buffer15); //@line 82968 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 1;$$9 = $$02793;
       break L1;
       break;
      }
      case 328: {
       _sqlite3VdbeError($0,33817,$vararg_buffer18); //@line 82974 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 5;$$9 = $$02793;
       break L1;
       break;
      }
      case 333: {
       $1747 = ((($8)) + 71|0); //@line 82988 "c/sqlite3.c"
       $1748 = $$02793; //@line 82990 "c/sqlite3.c"
       $1749 = $$02792; //@line 82990 "c/sqlite3.c"
       $1750 = (($1748) - ($1749))|0; //@line 82990 "c/sqlite3.c"
       $1751 = (($1750|0) / 20)&-1; //@line 82990 "c/sqlite3.c"
       HEAP32[$35>>2] = $1751; //@line 82990 "c/sqlite3.c"
       HEAP8[$1747>>0] = 0; //@line 82991 "c/sqlite3.c"
       HEAP32[$13>>2] = 5; //@line 82992 "c/sqlite3.c"
       $$22832 = $251;$$90 = 5;
       $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
       $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
       $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
       HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
       _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
       STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
       break;
      }
      case 357: {
       $1823 = ((($$02793)) + 4|0); //@line 83073 "c/sqlite3.c"
       $1824 = HEAP32[$1823>>2]|0; //@line 83073 "c/sqlite3.c"
       $1825 = ((($$02793)) + 8|0); //@line 83074 "c/sqlite3.c"
       $1826 = HEAP32[$1825>>2]|0; //@line 83074 "c/sqlite3.c"
       $1827 = ((($8)) + 71|0); //@line 83080 "c/sqlite3.c"
       $1828 = HEAP8[$1827>>0]|0; //@line 83080 "c/sqlite3.c"
       $1829 = $1828&255; //@line 83080 "c/sqlite3.c"
       $1830 = ($1824|0)==($1829|0); //@line 83080 "c/sqlite3.c"
       if ($1830) {
        $1849 = ($1824|0)==(0); //@line 83114 "c/sqlite3.c"
        $1850 = ($1826|0)==(0); //@line 83115 "c/sqlite3.c"
        $1851 = $1850 ? 33926 : 33967; //@line 83115 "c/sqlite3.c"
        $1852 = $1849 ? 34010 : $1851; //@line 83114 "c/sqlite3.c"
        _sqlite3VdbeError($0,$1852,$vararg_buffer22); //@line 83113 "c/sqlite3.c"
        $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 1;$$9 = $$02793;
        break L1;
       }
       $1831 = ($1826|0)==(0); //@line 83081 "c/sqlite3.c"
       do {
        if ($1831) {
         $1832 = ($1824|0)==(0); //@line 83085 "c/sqlite3.c"
         if (!($1832)) {
          $1833 = ((($8)) + 168|0); //@line 83085 "c/sqlite3.c"
          $1834 = HEAP32[$1833>>2]|0; //@line 83085 "c/sqlite3.c"
          $1835 = ($1834|0)>(0); //@line 83085 "c/sqlite3.c"
          if ($1835) {
           _sqlite3VdbeError($0,33871,$vararg_buffer20); //@line 83089 "c/sqlite3.c"
           $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 5;$$9 = $$02793;
           break L1;
          }
         }
         $1836 = (_sqlite3VdbeCheckFk($0,1)|0); //@line 83093 "c/sqlite3.c"
         $1837 = ($1836|0)==(0); //@line 83093 "c/sqlite3.c"
         if ($1837) {
          $1838 = $1824&255; //@line 83096 "c/sqlite3.c"
          $storemerge3013 = $1838;
          break;
         } else {
          $$22832 = $251;$$90 = $1836;
          $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
          $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
          $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
          HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
          _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
          STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
         }
        } else {
         _sqlite3RollbackAll($8,516); //@line 83083 "c/sqlite3.c"
         $storemerge3013 = 1;
        }
       } while(0);
       HEAP8[$1827>>0] = $storemerge3013;
       $1839 = (_sqlite3VdbeHalt($0)|0); //@line 83098 "c/sqlite3.c"
       $1840 = ($1839|0)==(5); //@line 83098 "c/sqlite3.c"
       if ($1840) {
        $1841 = $$02793; //@line 83099 "c/sqlite3.c"
        $1842 = $$02792; //@line 83099 "c/sqlite3.c"
        $1843 = (($1841) - ($1842))|0; //@line 83099 "c/sqlite3.c"
        $1844 = (($1843|0) / 20)&-1; //@line 83099 "c/sqlite3.c"
        HEAP32[$35>>2] = $1844; //@line 83099 "c/sqlite3.c"
        $1845 = (1 - ($1824))|0; //@line 83100 "c/sqlite3.c"
        $1846 = $1845&255; //@line 83100 "c/sqlite3.c"
        HEAP8[$1827>>0] = $1846; //@line 83100 "c/sqlite3.c"
        HEAP32[$13>>2] = 5; //@line 83101 "c/sqlite3.c"
        $$22832 = $251;$$90 = 5;
        $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
        $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
        $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
        HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
        _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
        STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
       } else {
        _sqlite3CloseSavepoints($8); //@line 83105 "c/sqlite3.c"
        $1847 = HEAP32[$13>>2]|0; //@line 83106 "c/sqlite3.c"
        $1848 = ($1847|0)==(0); //@line 83106 "c/sqlite3.c"
        $$3031 = $1848 ? 101 : 1; //@line 83108 "c/sqlite3.c"
        $$22832 = $251;$$90 = $$3031;
        $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
        $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
        $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
        HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
        _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
        STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
       }
       break;
      }
      case 373: {
       $1867 = $1865 & 255; //@line 83178 "c/sqlite3.c"
       $1868 = ($1867|0)==(5); //@line 83178 "c/sqlite3.c"
       if ($1868) {
        $1939 = $$02793; //@line 83179 "c/sqlite3.c"
        $1940 = $$02792; //@line 83179 "c/sqlite3.c"
        $1941 = (($1939) - ($1940))|0; //@line 83179 "c/sqlite3.c"
        $1942 = (($1941|0) / 20)&-1; //@line 83179 "c/sqlite3.c"
        HEAP32[$35>>2] = $1942; //@line 83179 "c/sqlite3.c"
        HEAP32[$13>>2] = $1865; //@line 83180 "c/sqlite3.c"
        $$22832 = $251;$$90 = $1865;
        $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
        $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
        $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
        HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
        _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
        STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
       } else {
        $$30$ph = $1865;$4250 = $1;
        label = 394;
       }
       break;
      }
      case 388: {
       $1926 = ((($0)) + 108|0); //@line 83220 "c/sqlite3.c"
       $1927 = HEAP32[$1926>>2]|0; //@line 83220 "c/sqlite3.c"
       _sqlite3DbFree($8,$1927); //@line 83220 "c/sqlite3.c"
       $1928 = (_sqlite3DbStrDup($8,17602)|0); //@line 83221 "c/sqlite3.c"
       HEAP32[$1926>>2] = $1928; //@line 83221 "c/sqlite3.c"
       $1929 = HEAP32[$118>>2]|0; //@line 83235 "c/sqlite3.c"
       $1930 = HEAP32[$1860>>2]|0; //@line 83235 "c/sqlite3.c"
       $1931 = (((($1929) + ($1930<<4)|0)) + 12|0); //@line 83235 "c/sqlite3.c"
       $1932 = HEAP32[$1931>>2]|0; //@line 83235 "c/sqlite3.c"
       $1933 = HEAP32[$1932>>2]|0; //@line 83235 "c/sqlite3.c"
       $1934 = ($1933|0)==($1919|0); //@line 83235 "c/sqlite3.c"
       if (!($1934)) {
        _sqlite3ResetOneSchema($8,$1930); //@line 83236 "c/sqlite3.c"
       }
       $1935 = ((($0)) + 145|0); //@line 83238 "c/sqlite3.c"
       $1936 = HEAPU8[$1935>>0]|(HEAPU8[$1935+1>>0]<<8); //@line 83238 "c/sqlite3.c"
       $1937 = $1936 | 1; //@line 83238 "c/sqlite3.c"
       HEAP8[$1935>>0]=$1937&255;HEAP8[$1935+1>>0]=$1937>>8; //@line 83238 "c/sqlite3.c"
       $$30$ph = 17;$4250 = $1;
       label = 394;
       break;
      }
      case 393: {
       $$30$ph = $$30$ph$ph;$4250 = $1;
       label = 394;
       break;
      }
      case 459: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$40$ph;$$9 = $$02793;
       break L1;
       break;
      }
      case 481: {
       $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
       label = 853;
       break L1;
       break;
      }
      case 482: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2329;$$9 = $$02793;
       break L1;
       break;
      }
      case 513: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$45$ph;$$9 = $$02793;
       break L1;
       break;
      }
      case 534: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2615;$$9 = $$02793;
       break L1;
       break;
      }
      case 547: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2708;$$9 = $$02793;
       break L1;
       break;
      }
      case 568: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$48;$$9 = $$02793;
       break L1;
       break;
      }
      case 575: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2829;$$9 = $$02793;
       break L1;
       break;
      }
      case 578: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2847;$$9 = $$02793;
       break L1;
       break;
      }
      case 591: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$50;$$9 = $$02793;
       break L1;
       break;
      }
      case 603: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $2935;$$9 = $$02793;
       break L1;
       break;
      }
      case 613: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$55$ph;$$9 = $$02793;
       break L1;
       break;
      }
      case 623: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$57;$$9 = $$02793;
       break L1;
       break;
      }
      case 627: {
       $3077 = ((($0)) + 142|0); //@line 85426 "c/sqlite3.c"
       HEAP8[$3077>>0] = 2; //@line 85426 "c/sqlite3.c"
       $$58 = 6;
       label = 632;
       break;
      }
      case 642: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3152;$$9 = $$02793;
       break L1;
       break;
      }
      case 646: {
       _sqlite3ResetAllSchemasOfConnection($8); //@line 85600 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $spec$select3051;$$9 = $$02793;
       break L1;
       break;
      }
      case 648: {
       _sqlite3ResetAllSchemasOfConnection($8); //@line 85600 "c/sqlite3.c"
       $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
       label = 853;
       break L1;
       break;
      }
      case 657: {
       $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
       label = 853;
       break L1;
       break;
      }
      case 677: {
       _sqlite3VdbeError($0,34123,$vararg_buffer29); //@line 85871 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 1;$$9 = $$02793;
       break L1;
       break;
      }
      case 726: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$64;$$9 = $$02793;
       break L1;
       break;
      }
      case 728: {
       $3756 = (_sqlite3_value_text($3751)|0); //@line 86269 "c/sqlite3.c"
       HEAP32[$vararg_buffer34>>2] = $3756; //@line 86269 "c/sqlite3.c"
       _sqlite3VdbeError($0,15687,$vararg_buffer34); //@line 86269 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3754;$$9 = $$02793;
       break L1;
       break;
      }
      case 733: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3763;$$9 = $$02793;
       break L1;
       break;
      }
      case 741: {
       $3805 = $3800 ? 34160 : 34165; //@line 86378 "c/sqlite3.c"
       HEAP32[$vararg_buffer37>>2] = $3805; //@line 86376 "c/sqlite3.c"
       _sqlite3VdbeError($0,34172,$vararg_buffer37); //@line 86376 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 1;$$9 = $$02793;
       break L1;
       break;
      }
      case 758: {
       $3854 = $3852 & 255; //@line 86506 "c/sqlite3.c"
       $3855 = ($3854|0)==(6); //@line 86506 "c/sqlite3.c"
       if (!($3855)) {
        $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3852;$$9 = $$02793;
        break L1;
       }
       $3856 = ((($$02793)) + 16|0); //@line 86507 "c/sqlite3.c"
       $3857 = HEAP32[$3856>>2]|0; //@line 86507 "c/sqlite3.c"
       HEAP32[$vararg_buffer40>>2] = $3857; //@line 86508 "c/sqlite3.c"
       _sqlite3VdbeError($0,34224,$vararg_buffer40); //@line 86508 "c/sqlite3.c"
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $3852;$$9 = $$02793;
       break L1;
       break;
      }
      case 772: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$76$ph;$$9 = $$02793;
       break L1;
       break;
      }
      case 773: {
       $3906 = ((($3890)) + 28|0); //@line 86617 "c/sqlite3.c"
       $3907 = HEAP32[$3906>>2]|0; //@line 86617 "c/sqlite3.c"
       $3908 = HEAP32[$1>>2]|0; //@line 86617 "c/sqlite3.c"
       (FUNCTION_TABLE_ii[$3907 & 255]($3908)|0); //@line 86617 "c/sqlite3.c"
       $$11 = $$02793;$$32833 = $251;$$5 = $$02792;$$52819 = $$02814;
       label = 853;
       break L1;
       break;
      }
      case 803: {
       $phitmp = $4069&255; //@line 86891 "c/sqlite3.c"
       $4071 = $phitmp;
       label = 804;
       break;
      }
      case 805: {
       $4072 = ((($0)) + 44|0); //@line 86894 "c/sqlite3.c"
       $4073 = HEAP32[$4072>>2]|0; //@line 86894 "c/sqlite3.c"
       $4074 = (($4073) + 1)|0; //@line 86894 "c/sqlite3.c"
       HEAP32[$4072>>2] = $4074; //@line 86894 "c/sqlite3.c"
       break;
      }
      case 808: {
       $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 6;$$9 = $$02793;
       break L1;
       break;
      }
      case 851: {
       $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
       $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
       $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
       HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
       _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
       STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
       break;
      }
     }
     if ((label|0) == 29) {
      $410 = (_sqlite3VdbeHalt($0)|0); //@line 80973 "c/sqlite3.c"
      $411 = ($410|0)==(5); //@line 80975 "c/sqlite3.c"
      if ($411) {
       HEAP32[$13>>2] = 5; //@line 80976 "c/sqlite3.c"
       $$22832 = $251;$$90 = 5;
       $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
       $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
       $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
       HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
       _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
       STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
      } else {
       $412 = HEAP32[$13>>2]|0; //@line 80980 "c/sqlite3.c"
       $413 = ($412|0)==(0); //@line 80980 "c/sqlite3.c"
       $414 = $413 ? 101 : 1; //@line 80980 "c/sqlite3.c"
       $$22832 = $251;$$90 = $414;
       $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
       $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
       $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
       HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
       _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
       STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
      }
     }
     else if ((label|0) == 275) {
      $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$14$ph3100;$$9 = $$02793;
      break L1;
     }
     else if ((label|0) == 394) {
      $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$30$ph;$$9 = $$02793;
      break L1;
     }
     else if ((label|0) == 632) {
      $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $$58;$$9 = $$02793;
      break L1;
     }
     else if ((label|0) == 804) {
      $4070 = ((($0)) + 142|0); //@line 86891 "c/sqlite3.c"
      HEAP8[$4070>>0] = $4071; //@line 86891 "c/sqlite3.c"
     }
     else if ((label|0) == 852) {
      _sqlite3VdbeError($0,17161,$vararg_buffer57); //@line 87266 "c/sqlite3.c"
      $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = 18;$$9 = $$02793;
      break L1;
     }
     $$12831 = $251;$$4 = $$02792;$$42818 = $$02814;$$88 = $4048;$$9 = $$02793;
     break L1;
    } else {
     $$12 = $7;$$42834 = 0;$$6 = $7;$$62820 = 0;
    }
   } while(0);
   $4242 = ((($8)) + 73|0); //@line 87283 "c/sqlite3.c"
   $4243 = HEAP8[$4242>>0]|0; //@line 87283 "c/sqlite3.c"
   $4244 = ($4243<<24>>24)==(0); //@line 87283 "c/sqlite3.c"
   $4245 = $4244 ? 9 : 7; //@line 87283 "c/sqlite3.c"
   HEAP32[$13>>2] = $4245; //@line 87284 "c/sqlite3.c"
   $4246 = (_sqlite3ErrStr($4245)|0); //@line 87285 "c/sqlite3.c"
   HEAP32[$vararg_buffer61>>2] = $4246; //@line 87285 "c/sqlite3.c"
   _sqlite3VdbeError($0,15687,$vararg_buffer61); //@line 87285 "c/sqlite3.c"
   $$12831 = $$42834;$$4 = $$6;$$42818 = $$62820;$$88 = $4245;$$9 = $$12;
  }
 } while(0);
 if ((label|0) == 853) {
  _sqlite3OomFault($8); //@line 87273 "c/sqlite3.c"
  _sqlite3VdbeError($0,17402,$vararg_buffer59); //@line 87274 "c/sqlite3.c"
  $$12831 = $$32833;$$4 = $$5;$$42818 = $$52819;$$88 = 7;$$9 = $$11;
 }
 $4220 = ((($8)) + 73|0); //@line 87233 "c/sqlite3.c"
 $4221 = HEAP8[$4220>>0]|0; //@line 87233 "c/sqlite3.c"
 $4222 = ($4221<<24>>24)==(0); //@line 87233 "c/sqlite3.c"
 $spec$select3072 = $4222 ? $$88 : 7; //@line 87233 "c/sqlite3.c"
 $4223 = ((($0)) + 108|0); //@line 87235 "c/sqlite3.c"
 $4224 = HEAP32[$4223>>2]|0; //@line 87235 "c/sqlite3.c"
 $4225 = ($4224|0)==(0|0); //@line 87235 "c/sqlite3.c"
 $4226 = ($spec$select3072|0)!=(3082); //@line 87235 "c/sqlite3.c"
 $or$cond37 = $4225 & $4226; //@line 87235 "c/sqlite3.c"
 if ($or$cond37) {
  $4227 = (_sqlite3ErrStr($spec$select3072)|0); //@line 87236 "c/sqlite3.c"
  HEAP32[$vararg_buffer49>>2] = $4227; //@line 87236 "c/sqlite3.c"
  _sqlite3VdbeError($0,15687,$vararg_buffer49); //@line 87236 "c/sqlite3.c"
 }
 HEAP32[$13>>2] = $spec$select3072; //@line 87238 "c/sqlite3.c"
 _sqlite3SystemError($8,$spec$select3072); //@line 87239 "c/sqlite3.c"
 $4228 = $$9; //@line 87242 "c/sqlite3.c"
 $4229 = $$4; //@line 87242 "c/sqlite3.c"
 $4230 = (($4228) - ($4229))|0; //@line 87242 "c/sqlite3.c"
 $4231 = (($4230|0) / 20)&-1; //@line 87242 "c/sqlite3.c"
 $4232 = ((($0)) + 184|0); //@line 87242 "c/sqlite3.c"
 $4233 = HEAP32[$4232>>2]|0; //@line 87242 "c/sqlite3.c"
 $4234 = HEAP32[$4223>>2]|0; //@line 87242 "c/sqlite3.c"
 HEAP32[$vararg_buffer52>>2] = $4231; //@line 87241 "c/sqlite3.c"
 $vararg_ptr55 = ((($vararg_buffer52)) + 4|0); //@line 87241 "c/sqlite3.c"
 HEAP32[$vararg_ptr55>>2] = $4233; //@line 87241 "c/sqlite3.c"
 $vararg_ptr56 = ((($vararg_buffer52)) + 8|0); //@line 87241 "c/sqlite3.c"
 HEAP32[$vararg_ptr56>>2] = $4234; //@line 87241 "c/sqlite3.c"
 _sqlite3_log($spec$select3072,34253,$vararg_buffer52); //@line 87241 "c/sqlite3.c"
 (_sqlite3VdbeHalt($0)|0); //@line 87243 "c/sqlite3.c"
 $4235 = ($spec$select3072|0)==(3082); //@line 87244 "c/sqlite3.c"
 if ($4235) {
  _sqlite3OomFault($8); //@line 87244 "c/sqlite3.c"
 }
 $4236 = ($$42818<<24>>24)==(0); //@line 87246 "c/sqlite3.c"
 if ($4236) {
  $$22832 = $$12831;$$90 = 1;
  $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
  $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
  $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
  HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
  _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
  STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
 }
 $4237 = $$42818&255; //@line 87246 "c/sqlite3.c"
 $4238 = (($4237) + -1)|0; //@line 87247 "c/sqlite3.c"
 _sqlite3ResetOneSchema($8,$4238); //@line 87247 "c/sqlite3.c"
 $$22832 = $$12831;$$90 = 1;
 $4239 = ((($0)) + 172|0); //@line 87255 "c/sqlite3.c"
 $4240 = HEAP32[$4239>>2]|0; //@line 87255 "c/sqlite3.c"
 $4241 = (($4240) + ($$22832))|0; //@line 87255 "c/sqlite3.c"
 HEAP32[$4239>>2] = $4241; //@line 87255 "c/sqlite3.c"
 _sqlite3VdbeLeave($0); //@line 87256 "c/sqlite3.c"
 STACKTOP = sp;return ($$90|0); //@line 87287 "c/sqlite3.c"
}
function _sqlite3BtreeIncrblobCursor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 1|0); //@line 70306 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 70306 "c/sqlite3.c"
 $3 = $2 | 16; //@line 70306 "c/sqlite3.c"
 HEAP8[$1>>0] = $3; //@line 70306 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 70307 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 70307 "c/sqlite3.c"
 $6 = ((($5)) + 11|0); //@line 70307 "c/sqlite3.c"
 HEAP8[$6>>0] = 1; //@line 70307 "c/sqlite3.c"
 return; //@line 70308 "c/sqlite3.c"
}
function _out2Prerelease($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 92|0); //@line 80523 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 80523 "c/sqlite3.c"
 $4 = ((($1)) + 8|0); //@line 80523 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 80523 "c/sqlite3.c"
 $6 = (($3) + (($5*40)|0)|0); //@line 80523 "c/sqlite3.c"
 $7 = (((($3) + (($5*40)|0)|0)) + 8|0); //@line 80525 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 80525 "c/sqlite3.c"
 $9 = $8 & 9312; //@line 80525 "c/sqlite3.c"
 $10 = ($9<<16>>16)==(0); //@line 80525 "c/sqlite3.c"
 if ($10) {
  HEAP16[$7>>1] = 4; //@line 80528 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 80531 "c/sqlite3.c"
 } else {
  $11 = (_out2PrereleaseWithClear($6)|0); //@line 80526 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 80531 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeMemTooBig($0) {
 $0 = $0|0;
 var $$0 = 0, $$08 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 71988 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 71988 "c/sqlite3.c"
 $3 = $2&65535; //@line 71988 "c/sqlite3.c"
 $4 = $3 & 18; //@line 71988 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 71988 "c/sqlite3.c"
 if ($5) {
  $$08 = 0;
  return ($$08|0); //@line 71996 "c/sqlite3.c"
 }
 $6 = ((($0)) + 12|0); //@line 71989 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 71989 "c/sqlite3.c"
 $8 = $3 & 16384; //@line 71990 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 71990 "c/sqlite3.c"
 if ($9) {
  $$0 = $7;
 } else {
  $10 = HEAP32[$0>>2]|0; //@line 71991 "c/sqlite3.c"
  $11 = (($10) + ($7))|0; //@line 71991 "c/sqlite3.c"
  $$0 = $11;
 }
 $12 = ((($0)) + 32|0); //@line 71993 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 71993 "c/sqlite3.c"
 $14 = ((($13)) + 100|0); //@line 71993 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 71993 "c/sqlite3.c"
 $16 = ($$0|0)>($15|0); //@line 71993 "c/sqlite3.c"
 $17 = $16&1; //@line 71993 "c/sqlite3.c"
 $$08 = $17;
 return ($$08|0); //@line 71996 "c/sqlite3.c"
}
function _sqlite3VdbeMemMove($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 _sqlite3VdbeMemRelease($0); //@line 72076 "c/sqlite3.c"
 dest=$0; src=$1; stop=dest+40|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 72077 "c/sqlite3.c"
 $2 = ((($1)) + 8|0); //@line 72078 "c/sqlite3.c"
 HEAP16[$2>>1] = 1; //@line 72078 "c/sqlite3.c"
 $3 = ((($1)) + 24|0); //@line 72079 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 72079 "c/sqlite3.c"
 return; //@line 72080 "c/sqlite3.c"
}
function _numericType($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 80262 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 80262 "c/sqlite3.c"
 $3 = $2&65535; //@line 80262 "c/sqlite3.c"
 $4 = $3 & 12; //@line 80262 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 80262 "c/sqlite3.c"
 if (!($5)) {
  $6 = $4&65535; //@line 80263 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 80269 "c/sqlite3.c"
 }
 $7 = $3 & 18; //@line 80265 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 80265 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 80269 "c/sqlite3.c"
 }
 $9 = (_computeNumericType($0)|0); //@line 80266 "c/sqlite3.c"
 $$0 = $9;
 return ($$0|0); //@line 80269 "c/sqlite3.c"
}
function _sqlite3SubInt64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($1|0)==(0); //@line 29812 "c/sqlite3.c"
 $4 = ($2|0)==(-2147483648); //@line 29812 "c/sqlite3.c"
 $5 = $3 & $4; //@line 29812 "c/sqlite3.c"
 if (!($5)) {
  $23 = (_i64Subtract(0,0,($1|0),($2|0))|0); //@line 29818 "c/sqlite3.c"
  $24 = tempRet0; //@line 29818 "c/sqlite3.c"
  $25 = (_sqlite3AddInt64($0,$23,$24)|0); //@line 29818 "c/sqlite3.c"
  $$0 = $25;
  return ($$0|0); //@line 29821 "c/sqlite3.c"
 }
 $6 = $0; //@line 29814 "c/sqlite3.c"
 $7 = $6; //@line 29814 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 29814 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 29814 "c/sqlite3.c"
 $10 = $9; //@line 29814 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 29814 "c/sqlite3.c"
 $12 = ($11|0)>(-1); //@line 29814 "c/sqlite3.c"
 $13 = ($8>>>0)>(4294967295); //@line 29814 "c/sqlite3.c"
 $14 = ($11|0)==(-1); //@line 29814 "c/sqlite3.c"
 $15 = $14 & $13; //@line 29814 "c/sqlite3.c"
 $16 = $12 | $15; //@line 29814 "c/sqlite3.c"
 if ($16) {
  $$0 = 1;
  return ($$0|0); //@line 29821 "c/sqlite3.c"
 }
 $17 = (_i64Subtract(($8|0),($11|0),($1|0),($2|0))|0); //@line 29815 "c/sqlite3.c"
 $18 = tempRet0; //@line 29815 "c/sqlite3.c"
 $19 = $0; //@line 29815 "c/sqlite3.c"
 $20 = $19; //@line 29815 "c/sqlite3.c"
 HEAP32[$20>>2] = $17; //@line 29815 "c/sqlite3.c"
 $21 = (($19) + 4)|0; //@line 29815 "c/sqlite3.c"
 $22 = $21; //@line 29815 "c/sqlite3.c"
 HEAP32[$22>>2] = $18; //@line 29815 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 29821 "c/sqlite3.c"
}
function _sqlite3MulInt64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $0; //@line 29826 "c/sqlite3.c"
 $4 = $3; //@line 29826 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 29826 "c/sqlite3.c"
 $6 = (($3) + 4)|0; //@line 29826 "c/sqlite3.c"
 $7 = $6; //@line 29826 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 29826 "c/sqlite3.c"
 $9 = ($2|0)>(0); //@line 29827 "c/sqlite3.c"
 $10 = ($1>>>0)>(0); //@line 29827 "c/sqlite3.c"
 $11 = ($2|0)==(0); //@line 29827 "c/sqlite3.c"
 $12 = $11 & $10; //@line 29827 "c/sqlite3.c"
 $13 = $9 | $12; //@line 29827 "c/sqlite3.c"
 do {
  if ($13) {
   $14 = (___udivdi3(-1,2147483647,($1|0),($2|0))|0);
   $15 = tempRet0;
   $16 = ($8|0)>($15|0); //@line 29828 "c/sqlite3.c"
   $17 = ($5>>>0)>($14>>>0); //@line 29828 "c/sqlite3.c"
   $18 = ($8|0)==($15|0); //@line 29828 "c/sqlite3.c"
   $19 = $18 & $17; //@line 29828 "c/sqlite3.c"
   $20 = $16 | $19; //@line 29828 "c/sqlite3.c"
   if ($20) {
    $$0 = 1;
    return ($$0|0); //@line 29842 "c/sqlite3.c"
   }
   $21 = (___divdi3(0,-2147483648,($1|0),($2|0))|0); //@line 29829 "c/sqlite3.c"
   $22 = tempRet0; //@line 29829 "c/sqlite3.c"
   $23 = ($8|0)<($22|0); //@line 29829 "c/sqlite3.c"
   $24 = ($5>>>0)<($21>>>0); //@line 29829 "c/sqlite3.c"
   $25 = ($8|0)==($22|0); //@line 29829 "c/sqlite3.c"
   $26 = $25 & $24; //@line 29829 "c/sqlite3.c"
   $27 = $23 | $26; //@line 29829 "c/sqlite3.c"
   if ($27) {
    $$0 = 1;
    return ($$0|0); //@line 29842 "c/sqlite3.c"
   }
  } else {
   $28 = ($2|0)<(0); //@line 29830 "c/sqlite3.c"
   if ($28) {
    $29 = ($8|0)>(0); //@line 29831 "c/sqlite3.c"
    $30 = ($5>>>0)>(0); //@line 29831 "c/sqlite3.c"
    $31 = ($8|0)==(0); //@line 29831 "c/sqlite3.c"
    $32 = $31 & $30; //@line 29831 "c/sqlite3.c"
    $33 = $29 | $32; //@line 29831 "c/sqlite3.c"
    if ($33) {
     $34 = (___divdi3(0,-2147483648,($5|0),($8|0))|0); //@line 29832 "c/sqlite3.c"
     $35 = tempRet0; //@line 29832 "c/sqlite3.c"
     $36 = ($35|0)>($2|0); //@line 29832 "c/sqlite3.c"
     $37 = ($34>>>0)>($1>>>0); //@line 29832 "c/sqlite3.c"
     $38 = ($35|0)==($2|0); //@line 29832 "c/sqlite3.c"
     $39 = $38 & $37; //@line 29832 "c/sqlite3.c"
     $40 = $36 | $39; //@line 29832 "c/sqlite3.c"
     if ($40) {
      $$0 = 1;
     } else {
      break;
     }
     return ($$0|0); //@line 29842 "c/sqlite3.c"
    }
    $41 = ($8|0)<(0); //@line 29833 "c/sqlite3.c"
    if ($41) {
     $42 = ($1|0)==(0); //@line 29834 "c/sqlite3.c"
     $43 = ($2|0)==(-2147483648); //@line 29834 "c/sqlite3.c"
     $44 = $42 & $43; //@line 29834 "c/sqlite3.c"
     $45 = ($5|0)==(0); //@line 29835 "c/sqlite3.c"
     $46 = ($8|0)==(-2147483648); //@line 29835 "c/sqlite3.c"
     $47 = $45 & $46; //@line 29835 "c/sqlite3.c"
     $or$cond = $44 | $47; //@line 29834 "c/sqlite3.c"
     if ($or$cond) {
      $$0 = 1;
      return ($$0|0); //@line 29842 "c/sqlite3.c"
     }
     $48 = (_i64Subtract(0,0,($5|0),($8|0))|0); //@line 29836 "c/sqlite3.c"
     $49 = tempRet0; //@line 29836 "c/sqlite3.c"
     $50 = (_i64Subtract(0,0,($1|0),($2|0))|0); //@line 29836 "c/sqlite3.c"
     $51 = tempRet0; //@line 29836 "c/sqlite3.c"
     $52 = (___divdi3(-1,2147483647,($50|0),($51|0))|0); //@line 29836 "c/sqlite3.c"
     $53 = tempRet0; //@line 29836 "c/sqlite3.c"
     $54 = ($53|0)<($49|0); //@line 29836 "c/sqlite3.c"
     $55 = ($52>>>0)<($48>>>0); //@line 29836 "c/sqlite3.c"
     $56 = ($53|0)==($49|0); //@line 29836 "c/sqlite3.c"
     $57 = $56 & $55; //@line 29836 "c/sqlite3.c"
     $58 = $54 | $57; //@line 29836 "c/sqlite3.c"
     if ($58) {
      $$0 = 1;
      return ($$0|0); //@line 29842 "c/sqlite3.c"
     }
    }
   }
  }
 } while(0);
 $59 = (___muldi3(($5|0),($8|0),($1|0),($2|0))|0); //@line 29839 "c/sqlite3.c"
 $60 = tempRet0; //@line 29839 "c/sqlite3.c"
 $61 = $0; //@line 29839 "c/sqlite3.c"
 $62 = $61; //@line 29839 "c/sqlite3.c"
 HEAP32[$62>>2] = $59; //@line 29839 "c/sqlite3.c"
 $63 = (($61) + 4)|0; //@line 29839 "c/sqlite3.c"
 $64 = $63; //@line 29839 "c/sqlite3.c"
 HEAP32[$64>>2] = $60; //@line 29839 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 29842 "c/sqlite3.c"
}
function _sqlite3VdbeCursorMoveto($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 76107 "c/sqlite3.c"
 $3 = ((($2)) + 3|0); //@line 76109 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 76109 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 76109 "c/sqlite3.c"
 if ($5) {
  $18 = ((($2)) + 40|0); //@line 76118 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 76118 "c/sqlite3.c"
  $20 = (_sqlite3BtreeCursorHasMoved($19)|0); //@line 76118 "c/sqlite3.c"
  $21 = ($20|0)==(0); //@line 76118 "c/sqlite3.c"
  if ($21) {
   $$1 = 0;
   return ($$1|0); //@line 76122 "c/sqlite3.c"
  }
  $22 = (_handleMovedCursor($2)|0); //@line 76119 "c/sqlite3.c"
  $$1 = $22;
  return ($$1|0); //@line 76122 "c/sqlite3.c"
 }
 $6 = ((($2)) + 24|0); //@line 76111 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 76111 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 76111 "c/sqlite3.c"
 if (!($8)) {
  $9 = HEAP32[$1>>2]|0; //@line 76111 "c/sqlite3.c"
  $10 = (($9) + 1)|0; //@line 76111 "c/sqlite3.c"
  $11 = (($7) + ($10<<2)|0); //@line 76111 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 76111 "c/sqlite3.c"
  $13 = ($12|0)>(0); //@line 76111 "c/sqlite3.c"
  if ($13) {
   $14 = ((($2)) + 36|0); //@line 76112 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 76112 "c/sqlite3.c"
   HEAP32[$0>>2] = $15; //@line 76112 "c/sqlite3.c"
   $16 = (($12) + -1)|0; //@line 76113 "c/sqlite3.c"
   HEAP32[$1>>2] = $16; //@line 76113 "c/sqlite3.c"
   $$1 = 0;
   return ($$1|0); //@line 76122 "c/sqlite3.c"
  }
 }
 $17 = (_handleDeferredMoveto($2)|0); //@line 76116 "c/sqlite3.c"
 $$1 = $17;
 return ($$1|0); //@line 76122 "c/sqlite3.c"
}
function _sqlite3BtreePayloadFetch($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_fetchPayload($0,$1)|0); //@line 65308 "c/sqlite3.c"
 return ($2|0); //@line 65308 "c/sqlite3.c"
}
function _sqlite3VdbeMemFromBtree($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 HEAP32[$4>>2] = 0; //@line 72223 "c/sqlite3.c"
 $5 = (_sqlite3BtreePayloadFetch($0,$4)|0); //@line 72232 "c/sqlite3.c"
 $6 = (($2) + ($1))|0; //@line 72235 "c/sqlite3.c"
 $7 = HEAP32[$4>>2]|0; //@line 72235 "c/sqlite3.c"
 $8 = ($6>>>0)>($7>>>0); //@line 72235 "c/sqlite3.c"
 if ($8) {
  $13 = (_vdbeMemFromBtreeResize($0,$1,$2,$3)|0); //@line 72240 "c/sqlite3.c"
  $$0 = $13;
  STACKTOP = sp;return ($$0|0); //@line 72243 "c/sqlite3.c"
 } else {
  $9 = (($5) + ($1)|0); //@line 72236 "c/sqlite3.c"
  $10 = ((($3)) + 16|0); //@line 72236 "c/sqlite3.c"
  HEAP32[$10>>2] = $9; //@line 72236 "c/sqlite3.c"
  $11 = ((($3)) + 8|0); //@line 72237 "c/sqlite3.c"
  HEAP16[$11>>1] = 4112; //@line 72237 "c/sqlite3.c"
  $12 = ((($3)) + 12|0); //@line 72238 "c/sqlite3.c"
  HEAP32[$12>>2] = $2; //@line 72238 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 72243 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeOneByteSerialTypeLen($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0&255; //@line 76252 "c/sqlite3.c"
 $2 = (27860 + ($1)|0); //@line 76252 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 76252 "c/sqlite3.c"
 return ($3|0); //@line 76252 "c/sqlite3.c"
}
function _sqlite3VdbeSerialType($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$040 = 0, $$1 = 0, $$lobit = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 8|0); //@line 76170 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 76170 "c/sqlite3.c"
 $5 = $4&65535; //@line 76170 "c/sqlite3.c"
 $6 = $5 & 1; //@line 76174 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 76174 "c/sqlite3.c"
 if (!($7)) {
  HEAP32[$2>>2] = 0; //@line 76175 "c/sqlite3.c"
  $$1 = 0;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 }
 $8 = $5 & 4; //@line 76178 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 76178 "c/sqlite3.c"
 if ($9) {
  $51 = $5 & 8; //@line 76204 "c/sqlite3.c"
  $52 = ($51|0)==(0); //@line 76204 "c/sqlite3.c"
  if (!($52)) {
   HEAP32[$2>>2] = 8; //@line 76205 "c/sqlite3.c"
   $$1 = 7;
   return ($$1|0); //@line 76216 "c/sqlite3.c"
  }
  $53 = ((($0)) + 12|0); //@line 76210 "c/sqlite3.c"
  $54 = HEAP32[$53>>2]|0; //@line 76210 "c/sqlite3.c"
  $55 = $5 & 16384; //@line 76211 "c/sqlite3.c"
  $56 = ($55|0)==(0); //@line 76211 "c/sqlite3.c"
  if ($56) {
   $$040 = $54;
  } else {
   $57 = HEAP32[$0>>2]|0; //@line 76212 "c/sqlite3.c"
   $58 = (($57) + ($54))|0; //@line 76212 "c/sqlite3.c"
   $$040 = $58;
  }
  HEAP32[$2>>2] = $$040; //@line 76214 "c/sqlite3.c"
  $59 = $$040 << 1; //@line 76215 "c/sqlite3.c"
  $60 = (($59) + 12)|0; //@line 76215 "c/sqlite3.c"
  $61 = $5 >>> 1; //@line 76215 "c/sqlite3.c"
  $$lobit = $61 & 1; //@line 76215 "c/sqlite3.c"
  $62 = $60 | $$lobit; //@line 76215 "c/sqlite3.c"
  $$1 = $62;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 }
 $10 = $0; //@line 76181 "c/sqlite3.c"
 $11 = $10; //@line 76181 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 76181 "c/sqlite3.c"
 $13 = (($10) + 4)|0; //@line 76181 "c/sqlite3.c"
 $14 = $13; //@line 76181 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 76181 "c/sqlite3.c"
 $16 = (_bitshift64Ashr(($12|0),($15|0),63)|0); //@line 76183 "c/sqlite3.c"
 $17 = tempRet0; //@line 76183 "c/sqlite3.c"
 $18 = $16 ^ $12; //@line 76183 "c/sqlite3.c"
 $19 = $17 ^ $15; //@line 76183 "c/sqlite3.c"
 $20 = ($19>>>0)<(0); //@line 76188 "c/sqlite3.c"
 $21 = ($18>>>0)<(128); //@line 76188 "c/sqlite3.c"
 $22 = ($19|0)==(0); //@line 76188 "c/sqlite3.c"
 $23 = $22 & $21; //@line 76188 "c/sqlite3.c"
 $24 = $20 | $23; //@line 76188 "c/sqlite3.c"
 if ($24) {
  $25 = $12 & 1; //@line 76189 "c/sqlite3.c"
  $26 = ($25|0)==($12|0); //@line 76189 "c/sqlite3.c"
  $27 = (0)==($15|0); //@line 76189 "c/sqlite3.c"
  $28 = $26 & $27; //@line 76189 "c/sqlite3.c"
  $29 = ($1|0)>(3); //@line 76189 "c/sqlite3.c"
  $or$cond = $29 & $28; //@line 76189 "c/sqlite3.c"
  if ($or$cond) {
   HEAP32[$2>>2] = 0; //@line 76190 "c/sqlite3.c"
   $30 = (($18) + 8)|0; //@line 76191 "c/sqlite3.c"
   $$1 = $30;
   return ($$1|0); //@line 76216 "c/sqlite3.c"
  } else {
   HEAP32[$2>>2] = 1; //@line 76193 "c/sqlite3.c"
   $$1 = 1;
   return ($$1|0); //@line 76216 "c/sqlite3.c"
  }
 }
 $31 = ($19>>>0)<(0); //@line 76197 "c/sqlite3.c"
 $32 = ($18>>>0)<(32768); //@line 76197 "c/sqlite3.c"
 $33 = ($19|0)==(0); //@line 76197 "c/sqlite3.c"
 $34 = $33 & $32; //@line 76197 "c/sqlite3.c"
 $35 = $31 | $34; //@line 76197 "c/sqlite3.c"
 if ($35) {
  HEAP32[$2>>2] = 2; //@line 76197 "c/sqlite3.c"
  $$1 = 2;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 }
 $36 = ($19>>>0)<(0); //@line 76198 "c/sqlite3.c"
 $37 = ($18>>>0)<(8388608); //@line 76198 "c/sqlite3.c"
 $38 = ($19|0)==(0); //@line 76198 "c/sqlite3.c"
 $39 = $38 & $37; //@line 76198 "c/sqlite3.c"
 $40 = $36 | $39; //@line 76198 "c/sqlite3.c"
 if ($40) {
  HEAP32[$2>>2] = 3; //@line 76198 "c/sqlite3.c"
  $$1 = 3;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 }
 $41 = ($19>>>0)<(0); //@line 76199 "c/sqlite3.c"
 $42 = ($18>>>0)<(2147483648); //@line 76199 "c/sqlite3.c"
 $43 = ($19|0)==(0); //@line 76199 "c/sqlite3.c"
 $44 = $43 & $42; //@line 76199 "c/sqlite3.c"
 $45 = $41 | $44; //@line 76199 "c/sqlite3.c"
 if ($45) {
  HEAP32[$2>>2] = 4; //@line 76199 "c/sqlite3.c"
  $$1 = 4;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 }
 $46 = ($19>>>0)<(32768); //@line 76200 "c/sqlite3.c"
 $47 = ($18>>>0)<(0); //@line 76200 "c/sqlite3.c"
 $48 = ($19|0)==(32768); //@line 76200 "c/sqlite3.c"
 $49 = $48 & $47; //@line 76200 "c/sqlite3.c"
 $50 = $46 | $49; //@line 76200 "c/sqlite3.c"
 if ($50) {
  HEAP32[$2>>2] = 6; //@line 76200 "c/sqlite3.c"
  $$1 = 5;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 } else {
  HEAP32[$2>>2] = 8; //@line 76201 "c/sqlite3.c"
  $$1 = 6;
  return ($$1|0); //@line 76216 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3PutVarint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2>>>0)<(0); //@line 29315 "c/sqlite3.c"
 $4 = ($1>>>0)<(128); //@line 29315 "c/sqlite3.c"
 $5 = ($2|0)==(0); //@line 29315 "c/sqlite3.c"
 $6 = $5 & $4; //@line 29315 "c/sqlite3.c"
 $7 = $3 | $6; //@line 29315 "c/sqlite3.c"
 if ($7) {
  $8 = $1&255; //@line 29316 "c/sqlite3.c"
  $9 = $8 & 127; //@line 29316 "c/sqlite3.c"
  HEAP8[$0>>0] = $9; //@line 29316 "c/sqlite3.c"
  $$0 = 1;
  return ($$0|0); //@line 29325 "c/sqlite3.c"
 }
 $10 = ($2>>>0)<(0); //@line 29319 "c/sqlite3.c"
 $11 = ($1>>>0)<(16384); //@line 29319 "c/sqlite3.c"
 $12 = ($2|0)==(0); //@line 29319 "c/sqlite3.c"
 $13 = $12 & $11; //@line 29319 "c/sqlite3.c"
 $14 = $10 | $13; //@line 29319 "c/sqlite3.c"
 if ($14) {
  $15 = (_bitshift64Lshr(($1|0),($2|0),7)|0); //@line 29320 "c/sqlite3.c"
  $16 = tempRet0; //@line 29320 "c/sqlite3.c"
  $17 = $15&255; //@line 29320 "c/sqlite3.c"
  $18 = $17 | -128; //@line 29320 "c/sqlite3.c"
  HEAP8[$0>>0] = $18; //@line 29320 "c/sqlite3.c"
  $19 = $1&255; //@line 29321 "c/sqlite3.c"
  $20 = $19 & 127; //@line 29321 "c/sqlite3.c"
  $21 = ((($0)) + 1|0); //@line 29321 "c/sqlite3.c"
  HEAP8[$21>>0] = $20; //@line 29321 "c/sqlite3.c"
  $$0 = 2;
  return ($$0|0); //@line 29325 "c/sqlite3.c"
 } else {
  $22 = (_putVarint64($0,$1,$2)|0); //@line 29324 "c/sqlite3.c"
  $$0 = $22;
  return ($$0|0); //@line 29325 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeSerialPut($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$026 = 0, $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$off = (($2) + -1)|0; //@line 76325 "c/sqlite3.c"
 $3 = ($$off>>>0)<(7); //@line 76325 "c/sqlite3.c"
 if ($3) {
  $4 = $1;
  $5 = $4;
  $6 = HEAP32[$5>>2]|0;
  $7 = (($4) + 4)|0;
  $8 = $7;
  $9 = HEAP32[$8>>2]|0;
  $10 = (27860 + ($2)|0); //@line 76335 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 76335 "c/sqlite3.c"
  $12 = $11&255; //@line 76335 "c/sqlite3.c"
  $$0 = $12;$14 = $6;$17 = $9;
  while(1) {
   $13 = $14&255; //@line 76338 "c/sqlite3.c"
   $15 = (($$0) + -1)|0; //@line 76338 "c/sqlite3.c"
   $16 = (($0) + ($15)|0); //@line 76338 "c/sqlite3.c"
   HEAP8[$16>>0] = $13; //@line 76338 "c/sqlite3.c"
   $18 = (_bitshift64Lshr(($14|0),($17|0),8)|0); //@line 76339 "c/sqlite3.c"
   $19 = tempRet0; //@line 76339 "c/sqlite3.c"
   $20 = ($15|0)==(0); //@line 76340 "c/sqlite3.c"
   if ($20) {
    $$026 = $12;
    break;
   } else {
    $$0 = $15;$14 = $18;$17 = $19;
   }
  }
  return ($$026|0); //@line 76355 "c/sqlite3.c"
 }
 $21 = ($2>>>0)>(11); //@line 76345 "c/sqlite3.c"
 if (!($21)) {
  $$026 = 0;
  return ($$026|0); //@line 76355 "c/sqlite3.c"
 }
 $22 = ((($1)) + 12|0); //@line 76348 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 76348 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 76349 "c/sqlite3.c"
 if ($24) {
  $$026 = 0;
  return ($$026|0); //@line 76355 "c/sqlite3.c"
 }
 $25 = ((($1)) + 16|0); //@line 76349 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 76349 "c/sqlite3.c"
 _memcpy(($0|0),($26|0),($23|0))|0; //@line 76349 "c/sqlite3.c"
 $$026 = $23;
 return ($$026|0); //@line 76355 "c/sqlite3.c"
}
function _sqlite3BtreeCount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$2 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = (_moveToRoot($0)|0); //@line 69413 "c/sqlite3.c"
 switch ($2|0) {
 case 16:  {
  $3 = $1; //@line 69415 "c/sqlite3.c"
  $4 = $3; //@line 69415 "c/sqlite3.c"
  HEAP32[$4>>2] = 0; //@line 69415 "c/sqlite3.c"
  $5 = (($3) + 4)|0; //@line 69415 "c/sqlite3.c"
  $6 = $5; //@line 69415 "c/sqlite3.c"
  HEAP32[$6>>2] = 0; //@line 69415 "c/sqlite3.c"
  $$2 = 0;
  return ($$2|0); //@line 69472 "c/sqlite3.c"
  break;
 }
 case 0:  {
  $7 = ((($0)) + 116|0);
  $8 = ((($0)) + 70|0);
  $9 = ((($0)) + 68|0);
  $10 = ((($0)) + 70|0);
  $11 = ((($0)) + 70|0);
  $22 = 0;$23 = 0;
  L5: while(1) {
   $12 = HEAP32[$7>>2]|0; //@line 69430 "c/sqlite3.c"
   $13 = ((($12)) + 8|0); //@line 69431 "c/sqlite3.c"
   $14 = HEAP8[$13>>0]|0; //@line 69431 "c/sqlite3.c"
   $15 = ($14<<24>>24)==(0); //@line 69431 "c/sqlite3.c"
   if ($15) {
    $16 = ((($12)) + 2|0); //@line 69431 "c/sqlite3.c"
    $17 = HEAP8[$16>>0]|0; //@line 69431 "c/sqlite3.c"
    $18 = ($17<<24>>24)==(0); //@line 69431 "c/sqlite3.c"
    if ($18) {
     $19 = ((($12)) + 22|0); //@line 69432 "c/sqlite3.c"
     $20 = HEAP16[$19>>1]|0; //@line 69432 "c/sqlite3.c"
     $21 = $20&65535; //@line 69432 "c/sqlite3.c"
     $24 = (_i64Add(($22|0),($23|0),($21|0),0)|0); //@line 69432 "c/sqlite3.c"
     $25 = tempRet0; //@line 69432 "c/sqlite3.c"
     $$0 = $12;$76 = $24;$77 = $25;
    } else {
     $$0 = $12;$76 = $22;$77 = $23;
    }
   } else {
    $26 = ((($12)) + 22|0); //@line 69432 "c/sqlite3.c"
    $27 = HEAP16[$26>>1]|0; //@line 69432 "c/sqlite3.c"
    $28 = $27&65535; //@line 69432 "c/sqlite3.c"
    $29 = (_i64Add(($22|0),($23|0),($28|0),0)|0); //@line 69432 "c/sqlite3.c"
    $30 = tempRet0; //@line 69432 "c/sqlite3.c"
    while(1) {
     $31 = HEAP8[$9>>0]|0; //@line 69447 "c/sqlite3.c"
     $32 = ($31<<24>>24)==(0); //@line 69447 "c/sqlite3.c"
     if ($32) {
      break L5;
     }
     _moveToParent($0); //@line 69452 "c/sqlite3.c"
     $33 = HEAP16[$10>>1]|0; //@line 69453 "c/sqlite3.c"
     $34 = HEAP32[$7>>2]|0; //@line 69453 "c/sqlite3.c"
     $35 = ((($34)) + 22|0); //@line 69453 "c/sqlite3.c"
     $36 = HEAP16[$35>>1]|0; //@line 69453 "c/sqlite3.c"
     $37 = ($33&65535)<($36&65535); //@line 69453 "c/sqlite3.c"
     if ($37) {
      break;
     }
    }
    $38 = (($33) + 1)<<16>>16; //@line 69455 "c/sqlite3.c"
    HEAP16[$11>>1] = $38; //@line 69455 "c/sqlite3.c"
    $$0 = $34;$76 = $29;$77 = $30;
   }
   $39 = HEAP16[$8>>1]|0; //@line 69462 "c/sqlite3.c"
   $40 = ((($$0)) + 22|0); //@line 69463 "c/sqlite3.c"
   $41 = HEAP16[$40>>1]|0; //@line 69463 "c/sqlite3.c"
   $42 = ($39<<16>>16)==($41<<16>>16); //@line 69463 "c/sqlite3.c"
   $43 = ((($$0)) + 56|0);
   $44 = HEAP32[$43>>2]|0;
   if ($42) {
    $45 = ((($$0)) + 9|0); //@line 69464 "c/sqlite3.c"
    $46 = HEAP8[$45>>0]|0; //@line 69464 "c/sqlite3.c"
    $47 = $46&255; //@line 69464 "c/sqlite3.c"
    $48 = (($47) + 8)|0; //@line 69464 "c/sqlite3.c"
    $49 = (($44) + ($48)|0); //@line 69464 "c/sqlite3.c"
    $50 = (_sqlite3Get4byte($49)|0); //@line 69464 "c/sqlite3.c"
    $$sink = $50;
   } else {
    $51 = $39&65535; //@line 69462 "c/sqlite3.c"
    $52 = ((($$0)) + 24|0); //@line 69466 "c/sqlite3.c"
    $53 = HEAP16[$52>>1]|0; //@line 69466 "c/sqlite3.c"
    $54 = $53&65535; //@line 69466 "c/sqlite3.c"
    $55 = ((($$0)) + 64|0); //@line 69466 "c/sqlite3.c"
    $56 = HEAP32[$55>>2]|0; //@line 69466 "c/sqlite3.c"
    $57 = $51 << 1; //@line 69466 "c/sqlite3.c"
    $58 = (($56) + ($57)|0); //@line 69466 "c/sqlite3.c"
    $59 = HEAP8[$58>>0]|0; //@line 69466 "c/sqlite3.c"
    $60 = $59&255; //@line 69466 "c/sqlite3.c"
    $61 = $60 << 8; //@line 69466 "c/sqlite3.c"
    $62 = ((($58)) + 1|0); //@line 69466 "c/sqlite3.c"
    $63 = HEAP8[$62>>0]|0; //@line 69466 "c/sqlite3.c"
    $64 = $63&255; //@line 69466 "c/sqlite3.c"
    $65 = $61 | $64; //@line 69466 "c/sqlite3.c"
    $66 = $65 & $54; //@line 69466 "c/sqlite3.c"
    $67 = (($44) + ($66)|0); //@line 69466 "c/sqlite3.c"
    $68 = (_sqlite3Get4byte($67)|0); //@line 69466 "c/sqlite3.c"
    $$sink = $68;
   }
   $74 = (_moveToChild($0,$$sink)|0);
   $75 = ($74|0)==(0); //@line 69422 "c/sqlite3.c"
   if ($75) {
    $22 = $76;$23 = $77;
   } else {
    $$2 = $74;
    label = 16;
    break;
   }
  }
  if ((label|0) == 16) {
   return ($$2|0); //@line 69472 "c/sqlite3.c"
  }
  $69 = $1; //@line 69449 "c/sqlite3.c"
  $70 = $69; //@line 69449 "c/sqlite3.c"
  HEAP32[$70>>2] = $29; //@line 69449 "c/sqlite3.c"
  $71 = (($69) + 4)|0; //@line 69449 "c/sqlite3.c"
  $72 = $71; //@line 69449 "c/sqlite3.c"
  HEAP32[$72>>2] = $30; //@line 69449 "c/sqlite3.c"
  $73 = (_moveToRoot($0)|0); //@line 69450 "c/sqlite3.c"
  $$2 = $73;
  return ($$2|0); //@line 69472 "c/sqlite3.c"
  break;
 }
 default: {
  $$2 = $2;
  return ($$2|0); //@line 69472 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3BtreeBeginStmt($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 64551 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 64551 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 64552 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 64563 "c/sqlite3.c"
 $5 = (_sqlite3PagerOpenSavepoint($4,$1)|0); //@line 64563 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 64564 "c/sqlite3.c"
 return ($5|0); //@line 64565 "c/sqlite3.c"
}
function _sqlite3BtreeUpdateMeta($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 69377 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 69377 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 69381 "c/sqlite3.c"
 $5 = ((($4)) + 12|0); //@line 69384 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 69384 "c/sqlite3.c"
 $7 = ((($6)) + 56|0); //@line 69384 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 69384 "c/sqlite3.c"
 $9 = ((($6)) + 72|0); //@line 69385 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 69385 "c/sqlite3.c"
 $11 = (_sqlite3PagerWrite($10)|0); //@line 69385 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 69386 "c/sqlite3.c"
 if (!($12)) {
  _sqlite3BtreeLeave($0); //@line 69396 "c/sqlite3.c"
  return ($11|0); //@line 69397 "c/sqlite3.c"
 }
 $13 = $1 << 2; //@line 69387 "c/sqlite3.c"
 $14 = (($13) + 36)|0; //@line 69387 "c/sqlite3.c"
 $15 = (($8) + ($14)|0); //@line 69387 "c/sqlite3.c"
 _sqlite3Put4byte($15,$2); //@line 69387 "c/sqlite3.c"
 $16 = ($1|0)==(7); //@line 69389 "c/sqlite3.c"
 if (!($16)) {
  _sqlite3BtreeLeave($0); //@line 69396 "c/sqlite3.c"
  return ($11|0); //@line 69397 "c/sqlite3.c"
 }
 $17 = $2&255; //@line 69392 "c/sqlite3.c"
 $18 = ((($4)) + 18|0); //@line 69392 "c/sqlite3.c"
 HEAP8[$18>>0] = $17; //@line 69392 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 69396 "c/sqlite3.c"
 return ($11|0); //@line 69397 "c/sqlite3.c"
}
function _allocateCursor($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, dest = 0, label = 0, sp = 0;
 var stop = 0;
 sp = STACKTOP;
 $5 = ($1|0)>(0); //@line 80100 "c/sqlite3.c"
 $6 = ((($0)) + 92|0);
 $7 = HEAP32[$6>>2]|0;
 if ($5) {
  $8 = ((($0)) + 24|0); //@line 80100 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 80100 "c/sqlite3.c"
  $10 = (($9) - ($1))|0; //@line 80100 "c/sqlite3.c"
  $11 = (($7) + (($10*40)|0)|0); //@line 80100 "c/sqlite3.c"
  $23 = $11;
 } else {
  $23 = $7;
 }
 $12 = $2 << 3; //@line 80105 "c/sqlite3.c"
 $13 = (($12) + 96)|0; //@line 80105 "c/sqlite3.c"
 $14 = ($4<<24>>24)==(0); //@line 80106 "c/sqlite3.c"
 $spec$select = $14 ? 200 : 0; //@line 80106 "c/sqlite3.c"
 $15 = (($spec$select) + ($13))|0; //@line 80105 "c/sqlite3.c"
 $16 = ((($0)) + 112|0); //@line 80109 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 80109 "c/sqlite3.c"
 $18 = (($17) + ($1<<2)|0); //@line 80109 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 80109 "c/sqlite3.c"
 $20 = ($19|0)==(0|0); //@line 80109 "c/sqlite3.c"
 if (!($20)) {
  _sqlite3VdbeFreeCursor($0,$19); //@line 80110 "c/sqlite3.c"
  $21 = HEAP32[$16>>2]|0; //@line 80111 "c/sqlite3.c"
  $22 = (($21) + ($1<<2)|0); //@line 80111 "c/sqlite3.c"
  HEAP32[$22>>2] = 0; //@line 80111 "c/sqlite3.c"
 }
 $24 = (_sqlite3VdbeMemClearAndResize($23,$15)|0); //@line 80113 "c/sqlite3.c"
 $25 = ($24|0)==(0); //@line 80113 "c/sqlite3.c"
 if (!($25)) {
  $$0 = 0;
  return ($$0|0); //@line 80126 "c/sqlite3.c"
 }
 $26 = ((($23)) + 16|0); //@line 80114 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 80114 "c/sqlite3.c"
 $28 = HEAP32[$16>>2]|0; //@line 80114 "c/sqlite3.c"
 $29 = (($28) + ($1<<2)|0); //@line 80114 "c/sqlite3.c"
 HEAP32[$29>>2] = $27; //@line 80114 "c/sqlite3.c"
 dest=$27; stop=dest+36|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 80115 "c/sqlite3.c"
 HEAP8[$27>>0] = $4; //@line 80116 "c/sqlite3.c"
 $30 = $3&255; //@line 80117 "c/sqlite3.c"
 $31 = ((($27)) + 1|0); //@line 80117 "c/sqlite3.c"
 HEAP8[$31>>0] = $30; //@line 80117 "c/sqlite3.c"
 $32 = $2&65535; //@line 80118 "c/sqlite3.c"
 $33 = ((($27)) + 56|0); //@line 80118 "c/sqlite3.c"
 HEAP16[$33>>1] = $32; //@line 80118 "c/sqlite3.c"
 $34 = ((($27)) + 88|0); //@line 80119 "c/sqlite3.c"
 $35 = (($34) + ($2<<2)|0); //@line 80119 "c/sqlite3.c"
 $36 = ((($27)) + 72|0); //@line 80119 "c/sqlite3.c"
 HEAP32[$36>>2] = $35; //@line 80119 "c/sqlite3.c"
 if (!($14)) {
  $$0 = $27;
  return ($$0|0); //@line 80126 "c/sqlite3.c"
 }
 $37 = HEAP32[$26>>2]|0; //@line 80122 "c/sqlite3.c"
 $38 = (($37) + ($13)|0); //@line 80122 "c/sqlite3.c"
 $39 = ((($27)) + 40|0); //@line 80121 "c/sqlite3.c"
 HEAP32[$39>>2] = $38; //@line 80121 "c/sqlite3.c"
 _sqlite3BtreeCursorZero($38); //@line 80123 "c/sqlite3.c"
 $$0 = $27;
 return ($$0|0); //@line 80126 "c/sqlite3.c"
}
function _sqlite3BtreeCursor($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)<(1); //@line 64720 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3CorruptError(64721)|0); //@line 64721 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 64727 "c/sqlite3.c"
 } else {
  _sqlite3BtreeEnter($0); //@line 64723 "c/sqlite3.c"
  $7 = (_btreeCursor($0,$1,$2,$3,$4)|0); //@line 64724 "c/sqlite3.c"
  _sqlite3BtreeLeave($0); //@line 64725 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 64727 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeCursorHintFlags($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1&255; //@line 61332 "c/sqlite3.c"
 $3 = ((($0)) + 3|0); //@line 61332 "c/sqlite3.c"
 HEAP8[$3>>0] = $2; //@line 61332 "c/sqlite3.c"
 return; //@line 61333 "c/sqlite3.c"
}
function _sqlite3BtreeCreateTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 69110 "c/sqlite3.c"
 $3 = (_btreeCreateTable($0,$1,$2)|0); //@line 69111 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 69112 "c/sqlite3.c"
 return ($3|0); //@line 69113 "c/sqlite3.c"
}
function _sqlite3VdbeSorterInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$089 = 0, $$090 = 0, $$1 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $exitcond = 0, $or$cond = 0, $or$cond3 = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3TempInMemory($0)|0); //@line 88747 "c/sqlite3.c"
 $4 = ($3|0)!=(0); //@line 88747 "c/sqlite3.c"
 $5 = HEAP32[(12)>>2]|0; //@line 88747 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 88747 "c/sqlite3.c"
 $or$cond = $4 | $6; //@line 88747 "c/sqlite3.c"
 if ($or$cond) {
  $$089 = 0;
 } else {
  $7 = ((($0)) + 144|0); //@line 88750 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 88750 "c/sqlite3.c"
  $$089 = $8;
 }
 $9 = ((($2)) + 44|0); //@line 88764 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 88764 "c/sqlite3.c"
 $11 = ((($10)) + 6|0); //@line 88764 "c/sqlite3.c"
 $12 = HEAP16[$11>>1]|0; //@line 88764 "c/sqlite3.c"
 $13 = $12&65535; //@line 88764 "c/sqlite3.c"
 $14 = $13 << 2; //@line 88764 "c/sqlite3.c"
 $15 = (($14) + 20)|0; //@line 88764 "c/sqlite3.c"
 $16 = ($$089*72)|0; //@line 88765 "c/sqlite3.c"
 $17 = (($16) + 136)|0; //@line 88765 "c/sqlite3.c"
 $18 = (($15) + ($17))|0; //@line 88767 "c/sqlite3.c"
 $19 = ($18|0)<(0); //@line 88767 "c/sqlite3.c"
 $20 = $19 << 31 >> 31; //@line 88767 "c/sqlite3.c"
 $21 = (_sqlite3DbMallocZero($0,$18,$20)|0); //@line 88767 "c/sqlite3.c"
 $22 = ((($2)) + 40|0); //@line 88768 "c/sqlite3.c"
 HEAP32[$22>>2] = $21; //@line 88768 "c/sqlite3.c"
 $23 = ($21|0)==(0|0); //@line 88769 "c/sqlite3.c"
 if ($23) {
  $$2 = 7;
  return ($$2|0); //@line 88821 "c/sqlite3.c"
 }
 $24 = (($21) + ($17)|0); //@line 88772 "c/sqlite3.c"
 $25 = ((($21)) + 28|0); //@line 88772 "c/sqlite3.c"
 HEAP32[$25>>2] = $24; //@line 88772 "c/sqlite3.c"
 $26 = HEAP32[$9>>2]|0; //@line 88773 "c/sqlite3.c"
 _memcpy(($24|0),($26|0),($15|0))|0; //@line 88773 "c/sqlite3.c"
 $27 = ((($24)) + 12|0); //@line 88774 "c/sqlite3.c"
 HEAP32[$27>>2] = 0; //@line 88774 "c/sqlite3.c"
 $28 = ($1|0)!=(0); //@line 88775 "c/sqlite3.c"
 $29 = ($$089|0)==(0); //@line 88775 "c/sqlite3.c"
 $or$cond3 = $28 & $29; //@line 88775 "c/sqlite3.c"
 if ($or$cond3) {
  $30 = $1&65535; //@line 88776 "c/sqlite3.c"
  $31 = ((($24)) + 6|0); //@line 88776 "c/sqlite3.c"
  HEAP16[$31>>1] = $30; //@line 88776 "c/sqlite3.c"
 }
 $32 = ((($0)) + 16|0); //@line 88778 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 88778 "c/sqlite3.c"
 $34 = ((($33)) + 4|0); //@line 88778 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 88778 "c/sqlite3.c"
 $36 = (_sqlite3BtreeGetPageSize($35)|0); //@line 88778 "c/sqlite3.c"
 $37 = ((($21)) + 12|0); //@line 88778 "c/sqlite3.c"
 HEAP32[$37>>2] = $36; //@line 88778 "c/sqlite3.c"
 $38 = (($$089) + 1)|0; //@line 88779 "c/sqlite3.c"
 $39 = $38&255; //@line 88779 "c/sqlite3.c"
 $40 = ((($21)) + 59|0); //@line 88779 "c/sqlite3.c"
 HEAP8[$40>>0] = $39; //@line 88779 "c/sqlite3.c"
 $41 = (($$089) + 255)|0; //@line 88780 "c/sqlite3.c"
 $42 = $41&255; //@line 88780 "c/sqlite3.c"
 $43 = ((($21)) + 58|0); //@line 88780 "c/sqlite3.c"
 HEAP8[$43>>0] = $42; //@line 88780 "c/sqlite3.c"
 $44 = $38 & 254; //@line 88781 "c/sqlite3.c"
 $45 = ($44|0)!=(0); //@line 88781 "c/sqlite3.c"
 $46 = $45&1; //@line 88781 "c/sqlite3.c"
 $47 = ((($21)) + 57|0); //@line 88781 "c/sqlite3.c"
 HEAP8[$47>>0] = $46; //@line 88781 "c/sqlite3.c"
 $48 = ((($21)) + 24|0); //@line 88782 "c/sqlite3.c"
 HEAP32[$48>>2] = $0; //@line 88782 "c/sqlite3.c"
 $49 = $38 & 255; //@line 88783 "c/sqlite3.c"
 $50 = ($49|0)==(0); //@line 88783 "c/sqlite3.c"
 if (!($50)) {
  $51 = ((($21)) + 64|0);
  $$090 = 0;
  while(1) {
   $52 = (((($51) + (($$090*72)|0)|0)) + 8|0); //@line 88785 "c/sqlite3.c"
   HEAP32[$52>>2] = $21; //@line 88785 "c/sqlite3.c"
   $53 = (($$090) + 1)|0; //@line 88783 "c/sqlite3.c"
   $exitcond = ($53|0)==($49|0); //@line 88783 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$090 = $53;
   }
  }
 }
 $54 = (_sqlite3TempInMemory($0)|0); //@line 88788 "c/sqlite3.c"
 $55 = ($54|0)==(0); //@line 88788 "c/sqlite3.c"
 if ($55) {
  $56 = HEAP32[(228)>>2]|0; //@line 88790 "c/sqlite3.c"
  $57 = Math_imul($56, $36)|0; //@line 88791 "c/sqlite3.c"
  HEAP32[$21>>2] = $57; //@line 88791 "c/sqlite3.c"
  $58 = ((($33)) + 12|0); //@line 88793 "c/sqlite3.c"
  $59 = HEAP32[$58>>2]|0; //@line 88793 "c/sqlite3.c"
  $60 = ((($59)) + 80|0); //@line 88793 "c/sqlite3.c"
  $61 = HEAP32[$60>>2]|0; //@line 88793 "c/sqlite3.c"
  $62 = ($61|0)<(0); //@line 88793 "c/sqlite3.c"
  $63 = $62 << 31 >> 31; //@line 88793 "c/sqlite3.c"
  $64 = ($61|0)<(0); //@line 88794 "c/sqlite3.c"
  $65 = ($36|0)<(0); //@line 88799 "c/sqlite3.c"
  $66 = $65 << 31 >> 31; //@line 88799 "c/sqlite3.c"
  $67 = $64 ? -1024 : $36; //@line 88794 "c/sqlite3.c"
  $68 = $64 ? -1 : $66; //@line 88794 "c/sqlite3.c"
  $69 = (___muldi3(($67|0),($68|0),($61|0),($63|0))|0); //@line 88794 "c/sqlite3.c"
  $70 = tempRet0; //@line 88794 "c/sqlite3.c"
  $71 = ($70|0)<(0); //@line 88801 "c/sqlite3.c"
  $72 = ($69>>>0)<(536870912); //@line 88801 "c/sqlite3.c"
  $73 = ($70|0)==(0); //@line 88801 "c/sqlite3.c"
  $74 = $73 & $72; //@line 88801 "c/sqlite3.c"
  $75 = $71 | $74; //@line 88801 "c/sqlite3.c"
  $76 = $75 ? $69 : 536870912; //@line 88801 "c/sqlite3.c"
  $75 ? $70 : 0; //@line 88801 "c/sqlite3.c"
  $77 = ($57|0)>($76|0); //@line 88802 "c/sqlite3.c"
  $$ = $77 ? $57 : $76; //@line 88802 "c/sqlite3.c"
  $78 = ((($21)) + 4|0); //@line 88802 "c/sqlite3.c"
  HEAP32[$78>>2] = $$; //@line 88802 "c/sqlite3.c"
  $79 = HEAP32[(28)>>2]|0; //@line 88806 "c/sqlite3.c"
  $80 = ($79|0)==(0); //@line 88806 "c/sqlite3.c"
  if ($80) {
   $81 = ((($21)) + 52|0); //@line 88808 "c/sqlite3.c"
   HEAP32[$81>>2] = $36; //@line 88808 "c/sqlite3.c"
   $82 = (_sqlite3Malloc($36,$66)|0); //@line 88809 "c/sqlite3.c"
   $83 = ((($21)) + 40|0); //@line 88809 "c/sqlite3.c"
   HEAP32[$83>>2] = $82; //@line 88809 "c/sqlite3.c"
   $84 = ($82|0)==(0|0); //@line 88810 "c/sqlite3.c"
   $spec$select = $84 ? 7 : 0; //@line 88810 "c/sqlite3.c"
   $$1 = $spec$select;
  } else {
   $$1 = 0;
  }
 } else {
  $$1 = 0;
 }
 $85 = ((($24)) + 8|0); //@line 88814 "c/sqlite3.c"
 $86 = HEAP16[$85>>1]|0; //@line 88814 "c/sqlite3.c"
 $87 = ($86&65535)<(13); //@line 88814 "c/sqlite3.c"
 if (!($87)) {
  $$2 = $$1;
  return ($$2|0); //@line 88821 "c/sqlite3.c"
 }
 $88 = ((($24)) + 20|0); //@line 88815 "c/sqlite3.c"
 $89 = HEAP32[$88>>2]|0; //@line 88815 "c/sqlite3.c"
 $90 = ($89|0)==(0|0); //@line 88815 "c/sqlite3.c"
 if (!($90)) {
  $91 = ((($0)) + 8|0); //@line 88815 "c/sqlite3.c"
  $92 = HEAP32[$91>>2]|0; //@line 88815 "c/sqlite3.c"
  $93 = ($89|0)==($92|0); //@line 88815 "c/sqlite3.c"
  if (!($93)) {
   $$2 = $$1;
   return ($$2|0); //@line 88821 "c/sqlite3.c"
  }
 }
 $94 = ((($21)) + 60|0); //@line 88817 "c/sqlite3.c"
 HEAP8[$94>>0] = 3; //@line 88817 "c/sqlite3.c"
 $$2 = $$1;
 return ($$2|0); //@line 88821 "c/sqlite3.c"
}
function _sqlite3BtreeCursorHasHint($0) {
 $0 = $0|0;
 var $$lobit = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 3|0); //@line 70352 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 70352 "c/sqlite3.c"
 $3 = ($2&255) >>> 1; //@line 70352 "c/sqlite3.c"
 $$lobit = $3 & 1; //@line 70352 "c/sqlite3.c"
 $4 = $$lobit&255; //@line 70352 "c/sqlite3.c"
 return ($4|0); //@line 70352 "c/sqlite3.c"
}
function _sqlite3BtreeEof($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 65891 "c/sqlite3.c"
 $2 = ($1<<24>>24)!=(1); //@line 65891 "c/sqlite3.c"
 $3 = $2&1; //@line 65891 "c/sqlite3.c"
 return ($3|0); //@line 65891 "c/sqlite3.c"
}
function _sqlite3BtreeLast($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 65575 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(1); //@line 65575 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 1|0); //@line 65575 "c/sqlite3.c"
  $5 = HEAP8[$4>>0]|0; //@line 65575 "c/sqlite3.c"
  $6 = $5 & 8; //@line 65575 "c/sqlite3.c"
  $7 = ($6<<24>>24)==(0); //@line 65575 "c/sqlite3.c"
  if (!($7)) {
   $$012 = 0;
   return ($$012|0); //@line 65605 "c/sqlite3.c"
  }
 }
 $8 = (_moveToRoot($0)|0); //@line 65589 "c/sqlite3.c"
 switch ($8|0) {
 case 0:  {
  HEAP32[$1>>2] = 0; //@line 65592 "c/sqlite3.c"
  $9 = (_moveToRightmost($0)|0); //@line 65593 "c/sqlite3.c"
  $10 = ($9|0)==(0); //@line 65594 "c/sqlite3.c"
  $11 = ((($0)) + 1|0);
  $12 = HEAP8[$11>>0]|0;
  $13 = $12&255;
  if ($10) {
   $14 = $13 | 8; //@line 65595 "c/sqlite3.c"
   $15 = $14&255; //@line 65595 "c/sqlite3.c"
   HEAP8[$11>>0] = $15; //@line 65595 "c/sqlite3.c"
   $$012 = 0;
   return ($$012|0); //@line 65605 "c/sqlite3.c"
  } else {
   $16 = $13 & 247; //@line 65597 "c/sqlite3.c"
   $17 = $16&255; //@line 65597 "c/sqlite3.c"
   HEAP8[$11>>0] = $17; //@line 65597 "c/sqlite3.c"
   $$012 = $9;
   return ($$012|0); //@line 65605 "c/sqlite3.c"
  }
  break;
 }
 case 16:  {
  HEAP32[$1>>2] = 1; //@line 65601 "c/sqlite3.c"
  $$012 = 0;
  return ($$012|0); //@line 65605 "c/sqlite3.c"
  break;
 }
 default: {
  $$012 = $8;
  return ($$012|0); //@line 65605 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3BtreeInsert($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$092$ph = 0, $$093 = 0, $$1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0;
 var $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0;
 var $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0;
 var $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0;
 var $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp + 32|0;
 $5 = sp + 28|0;
 $6 = sp + 24|0;
 $7 = sp;
 HEAP32[$5>>2] = $3; //@line 68579 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 68580 "c/sqlite3.c"
 $8 = ((($0)) + 8|0); //@line 68583 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 68583 "c/sqlite3.c"
 $10 = ((($9)) + 4|0); //@line 68584 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 68584 "c/sqlite3.c"
 $12 = HEAP8[$0>>0]|0; //@line 68590 "c/sqlite3.c"
 $13 = ($12<<24>>24)==(4); //@line 68590 "c/sqlite3.c"
 if ($13) {
  $14 = ((($0)) + 64|0); //@line 68592 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 68592 "c/sqlite3.c"
  $$1 = $15;
  STACKTOP = sp;return ($$1|0); //@line 68771 "c/sqlite3.c"
 }
 $16 = ((($0)) + 1|0); //@line 68619 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 68619 "c/sqlite3.c"
 $18 = $17 & 32; //@line 68619 "c/sqlite3.c"
 $19 = ($18<<24>>24)==(0); //@line 68619 "c/sqlite3.c"
 if (!($19)) {
  $20 = ((($0)) + 60|0); //@line 68620 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 68620 "c/sqlite3.c"
  $22 = (_saveAllCursors($11,$21,$0)|0); //@line 68620 "c/sqlite3.c"
  HEAP32[$4>>2] = $22; //@line 68620 "c/sqlite3.c"
  $23 = ($22|0)==(0); //@line 68621 "c/sqlite3.c"
  if (!($23)) {
   $$1 = $22;
   STACKTOP = sp;return ($$1|0); //@line 68771 "c/sqlite3.c"
  }
 }
 $24 = ((($0)) + 112|0); //@line 68624 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 68624 "c/sqlite3.c"
 $26 = ($25|0)==(0|0); //@line 68624 "c/sqlite3.c"
 do {
  if ($26) {
   $27 = ((($0)) + 60|0); //@line 68628 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 68628 "c/sqlite3.c"
   $29 = ((($1)) + 8|0); //@line 68628 "c/sqlite3.c"
   $30 = $29; //@line 68628 "c/sqlite3.c"
   $31 = $30; //@line 68628 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 68628 "c/sqlite3.c"
   $33 = (($30) + 4)|0; //@line 68628 "c/sqlite3.c"
   $34 = $33; //@line 68628 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 68628 "c/sqlite3.c"
   _invalidateIncrblobCursors($9,$28,$32,$35,0); //@line 68628 "c/sqlite3.c"
   $36 = HEAP8[$16>>0]|0; //@line 68638 "c/sqlite3.c"
   $37 = $36 & 2; //@line 68638 "c/sqlite3.c"
   $38 = ($37<<24>>24)==(0); //@line 68638 "c/sqlite3.c"
   if (!($38)) {
    $39 = $29; //@line 68638 "c/sqlite3.c"
    $40 = $39; //@line 68638 "c/sqlite3.c"
    $41 = HEAP32[$40>>2]|0; //@line 68638 "c/sqlite3.c"
    $42 = (($39) + 4)|0; //@line 68638 "c/sqlite3.c"
    $43 = $42; //@line 68638 "c/sqlite3.c"
    $44 = HEAP32[$43>>2]|0; //@line 68638 "c/sqlite3.c"
    $45 = ((($0)) + 24|0); //@line 68638 "c/sqlite3.c"
    $46 = $45; //@line 68638 "c/sqlite3.c"
    $47 = $46; //@line 68638 "c/sqlite3.c"
    $48 = HEAP32[$47>>2]|0; //@line 68638 "c/sqlite3.c"
    $49 = (($46) + 4)|0; //@line 68638 "c/sqlite3.c"
    $50 = $49; //@line 68638 "c/sqlite3.c"
    $51 = HEAP32[$50>>2]|0; //@line 68638 "c/sqlite3.c"
    $52 = ($41|0)==($48|0); //@line 68638 "c/sqlite3.c"
    $53 = ($44|0)==($51|0); //@line 68638 "c/sqlite3.c"
    $54 = $52 & $53; //@line 68638 "c/sqlite3.c"
    if ($54) {
     HEAP32[$5>>2] = 0; //@line 68639 "c/sqlite3.c"
     break;
    }
   }
   $55 = HEAP32[$5>>2]|0; //@line 68640 "c/sqlite3.c"
   $56 = ($55|0)==(0); //@line 68640 "c/sqlite3.c"
   if ($56) {
    $57 = $29; //@line 68641 "c/sqlite3.c"
    $58 = $57; //@line 68641 "c/sqlite3.c"
    $59 = HEAP32[$58>>2]|0; //@line 68641 "c/sqlite3.c"
    $60 = (($57) + 4)|0; //@line 68641 "c/sqlite3.c"
    $61 = $60; //@line 68641 "c/sqlite3.c"
    $62 = HEAP32[$61>>2]|0; //@line 68641 "c/sqlite3.c"
    $63 = ($2|0)!=(0); //@line 68641 "c/sqlite3.c"
    $64 = $63&1; //@line 68641 "c/sqlite3.c"
    $65 = (_sqlite3BtreeMovetoUnpacked($0,0,$59,$62,$64,$5)|0); //@line 68641 "c/sqlite3.c"
    HEAP32[$4>>2] = $65; //@line 68641 "c/sqlite3.c"
    $66 = ($65|0)==(0); //@line 68642 "c/sqlite3.c"
    if (!($66)) {
     $$1 = $65;
     STACKTOP = sp;return ($$1|0); //@line 68771 "c/sqlite3.c"
    }
   }
  } else {
   $67 = HEAP32[$5>>2]|0; //@line 68644 "c/sqlite3.c"
   $68 = $2 & 2; //@line 68644 "c/sqlite3.c"
   $69 = $67 | $68; //@line 68644 "c/sqlite3.c"
   $70 = ($69|0)==(0); //@line 68644 "c/sqlite3.c"
   if ($70) {
    $71 = ((($1)) + 24|0); //@line 68645 "c/sqlite3.c"
    $72 = HEAP16[$71>>1]|0; //@line 68645 "c/sqlite3.c"
    $73 = ($72<<16>>16)==(0); //@line 68645 "c/sqlite3.c"
    if ($73) {
     $83 = HEAP32[$1>>2]|0; //@line 68657 "c/sqlite3.c"
     $84 = ((($1)) + 8|0); //@line 68657 "c/sqlite3.c"
     $85 = $84; //@line 68657 "c/sqlite3.c"
     $86 = $85; //@line 68657 "c/sqlite3.c"
     $87 = HEAP32[$86>>2]|0; //@line 68657 "c/sqlite3.c"
     $88 = (($85) + 4)|0; //@line 68657 "c/sqlite3.c"
     $89 = $88; //@line 68657 "c/sqlite3.c"
     $90 = HEAP32[$89>>2]|0; //@line 68657 "c/sqlite3.c"
     $91 = ($2|0)!=(0); //@line 68657 "c/sqlite3.c"
     $92 = $91&1; //@line 68657 "c/sqlite3.c"
     $93 = (_btreeMoveto($0,$83,$87,$90,$92,$5)|0); //@line 68657 "c/sqlite3.c"
     HEAP32[$4>>2] = $93; //@line 68657 "c/sqlite3.c"
     $95 = $93;
    } else {
     $74 = HEAP32[$24>>2]|0; //@line 68647 "c/sqlite3.c"
     HEAP32[$7>>2] = $74; //@line 68647 "c/sqlite3.c"
     $75 = ((($1)) + 20|0); //@line 68648 "c/sqlite3.c"
     $76 = HEAP32[$75>>2]|0; //@line 68648 "c/sqlite3.c"
     $77 = ((($7)) + 4|0); //@line 68648 "c/sqlite3.c"
     HEAP32[$77>>2] = $76; //@line 68648 "c/sqlite3.c"
     $78 = ((($7)) + 8|0); //@line 68649 "c/sqlite3.c"
     HEAP16[$78>>1] = $72; //@line 68649 "c/sqlite3.c"
     $79 = ((($7)) + 10|0); //@line 68650 "c/sqlite3.c"
     $80 = ($2|0)!=(0); //@line 68655 "c/sqlite3.c"
     $81 = $80&1; //@line 68655 "c/sqlite3.c"
     ;HEAP16[$79>>1]=0|0;HEAP16[$79+2>>1]=0|0;HEAP8[$79+4>>0]=0|0; //@line 68651 "c/sqlite3.c"
     $82 = (_sqlite3BtreeMovetoUnpacked($0,$7,0,0,$81,$5)|0); //@line 68655 "c/sqlite3.c"
     HEAP32[$4>>2] = $82; //@line 68655 "c/sqlite3.c"
     $95 = $82;
    }
    $94 = ($95|0)==(0); //@line 68659 "c/sqlite3.c"
    if (!($94)) {
     $$1 = $95;
     STACKTOP = sp;return ($$1|0); //@line 68771 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $96 = ((($0)) + 116|0); //@line 68663 "c/sqlite3.c"
 $97 = HEAP32[$96>>2]|0; //@line 68663 "c/sqlite3.c"
 $98 = ((($11)) + 80|0); //@line 68671 "c/sqlite3.c"
 $99 = HEAP32[$98>>2]|0; //@line 68671 "c/sqlite3.c"
 $100 = (_fillInCell($97,$99,$1,$6)|0); //@line 68673 "c/sqlite3.c"
 HEAP32[$4>>2] = $100; //@line 68673 "c/sqlite3.c"
 $101 = ($100|0)==(0); //@line 68674 "c/sqlite3.c"
 do {
  if ($101) {
   $102 = ((($0)) + 70|0); //@line 68677 "c/sqlite3.c"
   $103 = HEAP16[$102>>1]|0; //@line 68677 "c/sqlite3.c"
   $104 = $103&65535; //@line 68677 "c/sqlite3.c"
   $105 = HEAP32[$5>>2]|0; //@line 68678 "c/sqlite3.c"
   $106 = ($105|0)==(0); //@line 68678 "c/sqlite3.c"
   if ($106) {
    $107 = ((($97)) + 72|0); //@line 68681 "c/sqlite3.c"
    $108 = HEAP32[$107>>2]|0; //@line 68681 "c/sqlite3.c"
    $109 = (_sqlite3PagerWrite($108)|0); //@line 68681 "c/sqlite3.c"
    HEAP32[$4>>2] = $109; //@line 68681 "c/sqlite3.c"
    $110 = ($109|0)==(0); //@line 68682 "c/sqlite3.c"
    if (!($110)) {
     break;
    }
    $111 = ((($97)) + 56|0); //@line 68685 "c/sqlite3.c"
    $112 = HEAP32[$111>>2]|0; //@line 68685 "c/sqlite3.c"
    $113 = ((($97)) + 24|0); //@line 68685 "c/sqlite3.c"
    $114 = HEAP16[$113>>1]|0; //@line 68685 "c/sqlite3.c"
    $115 = $114&65535; //@line 68685 "c/sqlite3.c"
    $116 = ((($97)) + 64|0); //@line 68685 "c/sqlite3.c"
    $117 = HEAP32[$116>>2]|0; //@line 68685 "c/sqlite3.c"
    $118 = $104 << 1; //@line 68685 "c/sqlite3.c"
    $119 = (($117) + ($118)|0); //@line 68685 "c/sqlite3.c"
    $120 = HEAP8[$119>>0]|0; //@line 68685 "c/sqlite3.c"
    $121 = $120&255; //@line 68685 "c/sqlite3.c"
    $122 = $121 << 8; //@line 68685 "c/sqlite3.c"
    $123 = ((($119)) + 1|0); //@line 68685 "c/sqlite3.c"
    $124 = HEAP8[$123>>0]|0; //@line 68685 "c/sqlite3.c"
    $125 = $124&255; //@line 68685 "c/sqlite3.c"
    $126 = $122 | $125; //@line 68685 "c/sqlite3.c"
    $127 = $126 & $115; //@line 68685 "c/sqlite3.c"
    $128 = (($112) + ($127)|0); //@line 68685 "c/sqlite3.c"
    $129 = ((($97)) + 8|0); //@line 68686 "c/sqlite3.c"
    $130 = HEAP8[$129>>0]|0; //@line 68686 "c/sqlite3.c"
    $131 = ($130<<24>>24)==(0); //@line 68686 "c/sqlite3.c"
    if ($131) {
     $132 = HEAPU8[$128>>0]|(HEAPU8[$128+1>>0]<<8)|(HEAPU8[$128+2>>0]<<16)|(HEAPU8[$128+3>>0]<<24); //@line 68687 "c/sqlite3.c"
     HEAP8[$99>>0]=$132&255;HEAP8[$99+1>>0]=($132>>8)&255;HEAP8[$99+2>>0]=($132>>16)&255;HEAP8[$99+3>>0]=$132>>24; //@line 68687 "c/sqlite3.c"
    }
    $133 = (_clearCell($97,$128,$7)|0); //@line 68689 "c/sqlite3.c"
    HEAP32[$4>>2] = $133; //@line 68689 "c/sqlite3.c"
    $134 = ((($7)) + 18|0); //@line 68690 "c/sqlite3.c"
    $135 = HEAP16[$134>>1]|0; //@line 68690 "c/sqlite3.c"
    $136 = $135&65535; //@line 68690 "c/sqlite3.c"
    $137 = HEAP32[$6>>2]|0; //@line 68690 "c/sqlite3.c"
    $138 = ($137|0)==($136|0); //@line 68690 "c/sqlite3.c"
    do {
     if ($138) {
      $139 = ((($7)) + 16|0); //@line 68690 "c/sqlite3.c"
      $140 = HEAP16[$139>>1]|0; //@line 68690 "c/sqlite3.c"
      $141 = $140&65535; //@line 68690 "c/sqlite3.c"
      $142 = ((($7)) + 12|0); //@line 68690 "c/sqlite3.c"
      $143 = HEAP32[$142>>2]|0; //@line 68690 "c/sqlite3.c"
      $144 = ($143|0)==($141|0); //@line 68690 "c/sqlite3.c"
      if ($144) {
       $145 = ((($11)) + 17|0); //@line 68691 "c/sqlite3.c"
       $146 = HEAP8[$145>>0]|0; //@line 68691 "c/sqlite3.c"
       $147 = ($146<<24>>24)==(0); //@line 68691 "c/sqlite3.c"
       if (!($147)) {
        $148 = ((($97)) + 16|0); //@line 68691 "c/sqlite3.c"
        $149 = HEAP16[$148>>1]|0; //@line 68691 "c/sqlite3.c"
        $150 = $149&65535; //@line 68691 "c/sqlite3.c"
        $151 = ($137|0)<($150|0); //@line 68691 "c/sqlite3.c"
        if (!($151)) {
         break;
        }
       }
       $152 = (($128) + ($137)|0); //@line 68703 "c/sqlite3.c"
       $153 = ((($97)) + 60|0); //@line 68703 "c/sqlite3.c"
       $154 = HEAP32[$153>>2]|0; //@line 68703 "c/sqlite3.c"
       $155 = ($152>>>0)>($154>>>0); //@line 68703 "c/sqlite3.c"
       if ($155) {
        $156 = (_sqlite3CorruptError(68703)|0); //@line 68703 "c/sqlite3.c"
        $$092$ph = $156;
       } else {
        _memcpy(($128|0),($99|0),($137|0))|0; //@line 68704 "c/sqlite3.c"
        $$092$ph = 0;
       }
       $$1 = $$092$ph;
       STACKTOP = sp;return ($$1|0); //@line 68771 "c/sqlite3.c"
      }
     }
    } while(0);
    _dropCell($97,$104,$136,$4); //@line 68707 "c/sqlite3.c"
    $157 = HEAP32[$4>>2]|0; //@line 68708 "c/sqlite3.c"
    $158 = ($157|0)==(0); //@line 68708 "c/sqlite3.c"
    if ($158) {
     $$093 = $104;
    } else {
     break;
    }
   } else {
    $159 = ($105|0)<(0); //@line 68709 "c/sqlite3.c"
    if ($159) {
     $160 = ((($97)) + 22|0); //@line 68709 "c/sqlite3.c"
     $161 = HEAP16[$160>>1]|0; //@line 68709 "c/sqlite3.c"
     $162 = ($161<<16>>16)==(0); //@line 68709 "c/sqlite3.c"
     $163 = (($103) + 1)<<16>>16; //@line 68711 "c/sqlite3.c"
     if ($162) {
      $$093 = $104;
     } else {
      $164 = $163&65535; //@line 68711 "c/sqlite3.c"
      HEAP16[$102>>1] = $163; //@line 68711 "c/sqlite3.c"
      $165 = HEAP8[$16>>0]|0; //@line 68712 "c/sqlite3.c"
      $166 = $165 & -3; //@line 68712 "c/sqlite3.c"
      HEAP8[$16>>0] = $166; //@line 68712 "c/sqlite3.c"
      $$093 = $164;
     }
    } else {
     $$093 = $104;
    }
   }
   $167 = HEAP32[$6>>2]|0; //@line 68716 "c/sqlite3.c"
   _insertCell($97,$$093,$99,$167,0,0,$4); //@line 68716 "c/sqlite3.c"
   $168 = ((($0)) + 42|0); //@line 68740 "c/sqlite3.c"
   HEAP16[$168>>1] = 0; //@line 68740 "c/sqlite3.c"
   $169 = ((($97)) + 12|0); //@line 68741 "c/sqlite3.c"
   $170 = HEAP8[$169>>0]|0; //@line 68741 "c/sqlite3.c"
   $171 = ($170<<24>>24)==(0); //@line 68741 "c/sqlite3.c"
   if (!($171)) {
    $172 = HEAP8[$16>>0]|0; //@line 68743 "c/sqlite3.c"
    $173 = $172 & -3; //@line 68743 "c/sqlite3.c"
    HEAP8[$16>>0] = $173; //@line 68743 "c/sqlite3.c"
    $174 = (_balance($0)|0); //@line 68744 "c/sqlite3.c"
    HEAP32[$4>>2] = $174; //@line 68744 "c/sqlite3.c"
    $175 = HEAP32[$96>>2]|0; //@line 68750 "c/sqlite3.c"
    $176 = ((($175)) + 12|0); //@line 68750 "c/sqlite3.c"
    HEAP8[$176>>0] = 0; //@line 68750 "c/sqlite3.c"
    HEAP8[$0>>0] = 0; //@line 68751 "c/sqlite3.c"
    $177 = $2 & 2; //@line 68752 "c/sqlite3.c"
    $178 = ($177|0)!=(0); //@line 68752 "c/sqlite3.c"
    $179 = ($174|0)==(0); //@line 68752 "c/sqlite3.c"
    $or$cond = $178 & $179; //@line 68752 "c/sqlite3.c"
    if ($or$cond) {
     _btreeReleaseAllCursorPages($0); //@line 68753 "c/sqlite3.c"
     $180 = HEAP32[$24>>2]|0; //@line 68754 "c/sqlite3.c"
     $181 = ($180|0)==(0|0); //@line 68754 "c/sqlite3.c"
     do {
      if (!($181)) {
       $182 = ((($1)) + 8|0); //@line 68756 "c/sqlite3.c"
       $183 = $182; //@line 68756 "c/sqlite3.c"
       $184 = $183; //@line 68756 "c/sqlite3.c"
       $185 = HEAP32[$184>>2]|0; //@line 68756 "c/sqlite3.c"
       $186 = (($183) + 4)|0; //@line 68756 "c/sqlite3.c"
       $187 = $186; //@line 68756 "c/sqlite3.c"
       $188 = HEAP32[$187>>2]|0; //@line 68756 "c/sqlite3.c"
       $189 = (_sqlite3Malloc($185,$188)|0); //@line 68756 "c/sqlite3.c"
       $190 = ((($0)) + 56|0); //@line 68756 "c/sqlite3.c"
       HEAP32[$190>>2] = $189; //@line 68756 "c/sqlite3.c"
       $191 = ($189|0)==(0|0); //@line 68757 "c/sqlite3.c"
       if ($191) {
        HEAP32[$4>>2] = 7; //@line 68758 "c/sqlite3.c"
        break;
       } else {
        $192 = HEAP32[$1>>2]|0; //@line 68760 "c/sqlite3.c"
        $193 = $182; //@line 68760 "c/sqlite3.c"
        $194 = $193; //@line 68760 "c/sqlite3.c"
        $195 = HEAP32[$194>>2]|0; //@line 68760 "c/sqlite3.c"
        $196 = (($193) + 4)|0; //@line 68760 "c/sqlite3.c"
        $197 = $196; //@line 68760 "c/sqlite3.c"
        $198 = HEAP32[$197>>2]|0; //@line 68760 "c/sqlite3.c"
        _memcpy(($189|0),($192|0),($195|0))|0; //@line 68760 "c/sqlite3.c"
        break;
       }
      }
     } while(0);
     HEAP8[$0>>0] = 3; //@line 68763 "c/sqlite3.c"
     $199 = ((($1)) + 8|0); //@line 68764 "c/sqlite3.c"
     $200 = $199; //@line 68764 "c/sqlite3.c"
     $201 = $200; //@line 68764 "c/sqlite3.c"
     $202 = HEAP32[$201>>2]|0; //@line 68764 "c/sqlite3.c"
     $203 = (($200) + 4)|0; //@line 68764 "c/sqlite3.c"
     $204 = $203; //@line 68764 "c/sqlite3.c"
     $205 = HEAP32[$204>>2]|0; //@line 68764 "c/sqlite3.c"
     $206 = ((($0)) + 48|0); //@line 68764 "c/sqlite3.c"
     $207 = $206; //@line 68764 "c/sqlite3.c"
     $208 = $207; //@line 68764 "c/sqlite3.c"
     HEAP32[$208>>2] = $202; //@line 68764 "c/sqlite3.c"
     $209 = (($207) + 4)|0; //@line 68764 "c/sqlite3.c"
     $210 = $209; //@line 68764 "c/sqlite3.c"
     HEAP32[$210>>2] = $205; //@line 68764 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $211 = HEAP32[$4>>2]|0; //@line 68770 "c/sqlite3.c"
 $$1 = $211;
 STACKTOP = sp;return ($$1|0); //@line 68771 "c/sqlite3.c"
}
function _sqlite3BtreeDelete($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0105 = 0, $$0105$in = 0, $$0106 = 0, $$1 = 0, $$lcssa = 0, $$pn = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0;
 var $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp + 24|0;
 $3 = sp;
 $4 = ((($0)) + 8|0); //@line 68791 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 68791 "c/sqlite3.c"
 $6 = ((($5)) + 4|0); //@line 68792 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 68792 "c/sqlite3.c"
 $8 = $1 & 2; //@line 68800 "c/sqlite3.c"
 $9 = ((($0)) + 68|0); //@line 68812 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 68812 "c/sqlite3.c"
 $11 = $10 << 24 >> 24; //@line 68812 "c/sqlite3.c"
 $12 = ((($0)) + 70|0); //@line 68813 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 68813 "c/sqlite3.c"
 $14 = $13&65535; //@line 68813 "c/sqlite3.c"
 $15 = ((($0)) + 116|0); //@line 68814 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 68814 "c/sqlite3.c"
 $17 = ((($16)) + 56|0); //@line 68815 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 68815 "c/sqlite3.c"
 $19 = ((($16)) + 24|0); //@line 68815 "c/sqlite3.c"
 $20 = HEAP16[$19>>1]|0; //@line 68815 "c/sqlite3.c"
 $21 = $20&65535; //@line 68815 "c/sqlite3.c"
 $22 = ((($16)) + 64|0); //@line 68815 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 68815 "c/sqlite3.c"
 $24 = $14 << 1; //@line 68815 "c/sqlite3.c"
 $25 = (($23) + ($24)|0); //@line 68815 "c/sqlite3.c"
 $26 = HEAP8[$25>>0]|0; //@line 68815 "c/sqlite3.c"
 $27 = $26&255; //@line 68815 "c/sqlite3.c"
 $28 = $27 << 8; //@line 68815 "c/sqlite3.c"
 $29 = ((($25)) + 1|0); //@line 68815 "c/sqlite3.c"
 $30 = HEAP8[$29>>0]|0; //@line 68815 "c/sqlite3.c"
 $31 = $30&255; //@line 68815 "c/sqlite3.c"
 $32 = $28 | $31; //@line 68815 "c/sqlite3.c"
 $33 = $32 & $21; //@line 68815 "c/sqlite3.c"
 $34 = (($18) + ($33)|0); //@line 68815 "c/sqlite3.c"
 $35 = ($8<<24>>24)!=(0); //@line 68826 "c/sqlite3.c"
 do {
  if ($35) {
   $36 = ((($16)) + 8|0); //@line 68827 "c/sqlite3.c"
   $37 = HEAP8[$36>>0]|0; //@line 68827 "c/sqlite3.c"
   $38 = ($37<<24>>24)==(0); //@line 68827 "c/sqlite3.c"
   if (!($38)) {
    $39 = ((($16)) + 20|0); //@line 68828 "c/sqlite3.c"
    $40 = HEAP16[$39>>1]|0; //@line 68828 "c/sqlite3.c"
    $41 = $40&65535; //@line 68828 "c/sqlite3.c"
    $42 = (_cellSizePtr($16,$34)|0); //@line 68828 "c/sqlite3.c"
    $43 = $42&65535; //@line 68828 "c/sqlite3.c"
    $44 = (($41) + 2)|0; //@line 68828 "c/sqlite3.c"
    $45 = (($44) + ($43))|0; //@line 68828 "c/sqlite3.c"
    $46 = ((($7)) + 36|0); //@line 68828 "c/sqlite3.c"
    $47 = HEAP32[$46>>2]|0; //@line 68828 "c/sqlite3.c"
    $48 = $47 << 1; //@line 68828 "c/sqlite3.c"
    $49 = (($48>>>0) / 3)&-1; //@line 68828 "c/sqlite3.c"
    $50 = ($45>>>0)>($49>>>0); //@line 68828 "c/sqlite3.c"
    if (!($50)) {
     $$0106 = 1;
     break;
    }
   }
   $51 = (_saveCursorKey($0)|0); //@line 68832 "c/sqlite3.c"
   HEAP32[$2>>2] = $51; //@line 68832 "c/sqlite3.c"
   $52 = ($51|0)==(0); //@line 68833 "c/sqlite3.c"
   if ($52) {
    $$0106 = 0;
   } else {
    $$1 = $51;
    STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
   }
  } else {
   $$0106 = 0;
  }
 } while(0);
 $53 = ((($16)) + 8|0); //@line 68846 "c/sqlite3.c"
 $54 = HEAP8[$53>>0]|0; //@line 68846 "c/sqlite3.c"
 $55 = ($54<<24>>24)==(0); //@line 68846 "c/sqlite3.c"
 if ($55) {
  $56 = (_sqlite3BtreePrevious($0,0)|0); //@line 68847 "c/sqlite3.c"
  HEAP32[$2>>2] = $56; //@line 68847 "c/sqlite3.c"
  $57 = ($56|0)==(0); //@line 68849 "c/sqlite3.c"
  if (!($57)) {
   $$1 = $56;
   STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
  }
 }
 $58 = ((($0)) + 1|0); //@line 68854 "c/sqlite3.c"
 $59 = HEAP8[$58>>0]|0; //@line 68854 "c/sqlite3.c"
 $60 = $59 & 32; //@line 68854 "c/sqlite3.c"
 $61 = ($60<<24>>24)==(0); //@line 68854 "c/sqlite3.c"
 if (!($61)) {
  $62 = ((($0)) + 60|0); //@line 68855 "c/sqlite3.c"
  $63 = HEAP32[$62>>2]|0; //@line 68855 "c/sqlite3.c"
  $64 = (_saveAllCursors($7,$63,$0)|0); //@line 68855 "c/sqlite3.c"
  HEAP32[$2>>2] = $64; //@line 68855 "c/sqlite3.c"
  $65 = ($64|0)==(0); //@line 68856 "c/sqlite3.c"
  if (!($65)) {
   $$1 = $64;
   STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
  }
 }
 $66 = ((($0)) + 112|0); //@line 68861 "c/sqlite3.c"
 $67 = HEAP32[$66>>2]|0; //@line 68861 "c/sqlite3.c"
 $68 = ($67|0)==(0|0); //@line 68861 "c/sqlite3.c"
 if ($68) {
  $69 = ((($0)) + 60|0); //@line 68862 "c/sqlite3.c"
  $70 = HEAP32[$69>>2]|0; //@line 68862 "c/sqlite3.c"
  $71 = ((($0)) + 24|0); //@line 68862 "c/sqlite3.c"
  $72 = $71; //@line 68862 "c/sqlite3.c"
  $73 = $72; //@line 68862 "c/sqlite3.c"
  $74 = HEAP32[$73>>2]|0; //@line 68862 "c/sqlite3.c"
  $75 = (($72) + 4)|0; //@line 68862 "c/sqlite3.c"
  $76 = $75; //@line 68862 "c/sqlite3.c"
  $77 = HEAP32[$76>>2]|0; //@line 68862 "c/sqlite3.c"
  _invalidateIncrblobCursors($5,$70,$74,$77,0); //@line 68862 "c/sqlite3.c"
 }
 $78 = ((($16)) + 72|0); //@line 68868 "c/sqlite3.c"
 $79 = HEAP32[$78>>2]|0; //@line 68868 "c/sqlite3.c"
 $80 = (_sqlite3PagerWrite($79)|0); //@line 68868 "c/sqlite3.c"
 HEAP32[$2>>2] = $80; //@line 68868 "c/sqlite3.c"
 $81 = ($80|0)==(0); //@line 68869 "c/sqlite3.c"
 if (!($81)) {
  $$1 = $80;
  STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
 }
 $82 = (_clearCell($16,$34,$3)|0); //@line 68870 "c/sqlite3.c"
 HEAP32[$2>>2] = $82; //@line 68870 "c/sqlite3.c"
 $83 = ((($3)) + 18|0); //@line 68871 "c/sqlite3.c"
 $84 = HEAP16[$83>>1]|0; //@line 68871 "c/sqlite3.c"
 $85 = $84&65535; //@line 68871 "c/sqlite3.c"
 _dropCell($16,$14,$85,$2); //@line 68871 "c/sqlite3.c"
 $86 = HEAP32[$2>>2]|0; //@line 68872 "c/sqlite3.c"
 $87 = ($86|0)==(0); //@line 68872 "c/sqlite3.c"
 if (!($87)) {
  $$1 = $86;
  STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
 }
 $88 = HEAP8[$53>>0]|0; //@line 68879 "c/sqlite3.c"
 $89 = ($88<<24>>24)==(0); //@line 68879 "c/sqlite3.c"
 if ($89) {
  $90 = HEAP32[$15>>2]|0; //@line 68880 "c/sqlite3.c"
  $91 = HEAP8[$9>>0]|0; //@line 68885 "c/sqlite3.c"
  $92 = $91 << 24 >> 24; //@line 68885 "c/sqlite3.c"
  $93 = (($92) + -1)|0; //@line 68885 "c/sqlite3.c"
  $94 = ($93|0)>($11|0); //@line 68885 "c/sqlite3.c"
  if ($94) {
   $95 = (($11) + 1)|0; //@line 68886 "c/sqlite3.c"
   $96 = (((($0)) + 120|0) + ($95<<2)|0); //@line 68886 "c/sqlite3.c"
   $97 = HEAP32[$96>>2]|0; //@line 68886 "c/sqlite3.c"
   $$pn = $97;
  } else {
   $$pn = $90;
  }
  $$0105$in = ((($$pn)) + 4|0);
  $$0105 = HEAP32[$$0105$in>>2]|0;
  $98 = ((($90)) + 56|0); //@line 68890 "c/sqlite3.c"
  $99 = HEAP32[$98>>2]|0; //@line 68890 "c/sqlite3.c"
  $100 = ((($90)) + 24|0); //@line 68890 "c/sqlite3.c"
  $101 = HEAP16[$100>>1]|0; //@line 68890 "c/sqlite3.c"
  $102 = $101&65535; //@line 68890 "c/sqlite3.c"
  $103 = ((($90)) + 64|0); //@line 68890 "c/sqlite3.c"
  $104 = HEAP32[$103>>2]|0; //@line 68890 "c/sqlite3.c"
  $105 = ((($90)) + 22|0); //@line 68890 "c/sqlite3.c"
  $106 = HEAP16[$105>>1]|0; //@line 68890 "c/sqlite3.c"
  $107 = $106&65535; //@line 68890 "c/sqlite3.c"
  $108 = $107 << 1; //@line 68890 "c/sqlite3.c"
  $109 = (($108) + -2)|0; //@line 68890 "c/sqlite3.c"
  $110 = (($104) + ($109)|0); //@line 68890 "c/sqlite3.c"
  $111 = HEAP8[$110>>0]|0; //@line 68890 "c/sqlite3.c"
  $112 = $111&255; //@line 68890 "c/sqlite3.c"
  $113 = $112 << 8; //@line 68890 "c/sqlite3.c"
  $114 = ((($110)) + 1|0); //@line 68890 "c/sqlite3.c"
  $115 = HEAP8[$114>>0]|0; //@line 68890 "c/sqlite3.c"
  $116 = $115&255; //@line 68890 "c/sqlite3.c"
  $117 = $113 | $116; //@line 68890 "c/sqlite3.c"
  $118 = $117 & $102; //@line 68890 "c/sqlite3.c"
  $119 = (($99) + ($118)|0); //@line 68890 "c/sqlite3.c"
  $120 = ($118>>>0)<(4); //@line 68891 "c/sqlite3.c"
  if ($120) {
   $121 = (_sqlite3CorruptError(68891)|0); //@line 68891 "c/sqlite3.c"
   $$1 = $121;
   STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
  }
  $122 = ((($90)) + 76|0); //@line 68892 "c/sqlite3.c"
  $123 = HEAP32[$122>>2]|0; //@line 68892 "c/sqlite3.c"
  $124 = (FUNCTION_TABLE_iii[$123 & 255]($90,$119)|0); //@line 68892 "c/sqlite3.c"
  $125 = $124&65535; //@line 68892 "c/sqlite3.c"
  $126 = ((($7)) + 80|0); //@line 68894 "c/sqlite3.c"
  $127 = HEAP32[$126>>2]|0; //@line 68894 "c/sqlite3.c"
  $128 = ((($90)) + 72|0); //@line 68896 "c/sqlite3.c"
  $129 = HEAP32[$128>>2]|0; //@line 68896 "c/sqlite3.c"
  $130 = (_sqlite3PagerWrite($129)|0); //@line 68896 "c/sqlite3.c"
  HEAP32[$2>>2] = $130; //@line 68896 "c/sqlite3.c"
  $131 = ($130|0)==(0); //@line 68897 "c/sqlite3.c"
  if ($131) {
   $132 = (($125) + 4)|0; //@line 68898 "c/sqlite3.c"
   $133 = ((($119)) + -4|0); //@line 68898 "c/sqlite3.c"
   _insertCell($16,$14,$133,$132,$127,$$0105,$2); //@line 68898 "c/sqlite3.c"
  }
  $134 = HEAP16[$105>>1]|0; //@line 68900 "c/sqlite3.c"
  $135 = $134&65535; //@line 68900 "c/sqlite3.c"
  $136 = (($135) + -1)|0; //@line 68900 "c/sqlite3.c"
  _dropCell($90,$136,$125,$2); //@line 68900 "c/sqlite3.c"
  $137 = HEAP32[$2>>2]|0; //@line 68901 "c/sqlite3.c"
  $138 = ($137|0)==(0); //@line 68901 "c/sqlite3.c"
  if (!($138)) {
   $$1 = $137;
   STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
  }
 }
 $139 = (_balance($0)|0); //@line 68919 "c/sqlite3.c"
 HEAP32[$2>>2] = $139; //@line 68919 "c/sqlite3.c"
 $140 = ($139|0)==(0); //@line 68920 "c/sqlite3.c"
 do {
  if ($140) {
   $141 = HEAP8[$9>>0]|0; //@line 68920 "c/sqlite3.c"
   $142 = ($141<<24>>24)>($10<<24>>24); //@line 68920 "c/sqlite3.c"
   if ($142) {
    $143 = HEAP32[$15>>2]|0; //@line 68921 "c/sqlite3.c"
    _releasePageNotNull($143); //@line 68921 "c/sqlite3.c"
    $144 = HEAP8[$9>>0]|0; //@line 68922 "c/sqlite3.c"
    $145 = (($144) + -1)<<24>>24; //@line 68922 "c/sqlite3.c"
    HEAP8[$9>>0] = $145; //@line 68922 "c/sqlite3.c"
    $146 = $145 << 24 >> 24; //@line 68923 "c/sqlite3.c"
    $147 = ($145<<24>>24)>($10<<24>>24); //@line 68923 "c/sqlite3.c"
    if ($147) {
     $149 = $145;$151 = $146;
     while(1) {
      $148 = (($149) + -1)<<24>>24; //@line 68924 "c/sqlite3.c"
      HEAP8[$9>>0] = $148; //@line 68924 "c/sqlite3.c"
      $150 = (((($0)) + 120|0) + ($151<<2)|0); //@line 68924 "c/sqlite3.c"
      $152 = HEAP32[$150>>2]|0; //@line 68924 "c/sqlite3.c"
      _releasePage($152); //@line 68924 "c/sqlite3.c"
      $153 = HEAP8[$9>>0]|0; //@line 68923 "c/sqlite3.c"
      $154 = $153 << 24 >> 24; //@line 68923 "c/sqlite3.c"
      $155 = ($153<<24>>24)>($10<<24>>24); //@line 68923 "c/sqlite3.c"
      if ($155) {
       $149 = $153;$151 = $154;
      } else {
       $$lcssa = $154;
       break;
      }
     }
    } else {
     $$lcssa = $146;
    }
    $156 = (((($0)) + 120|0) + ($$lcssa<<2)|0); //@line 68926 "c/sqlite3.c"
    $157 = HEAP32[$156>>2]|0; //@line 68926 "c/sqlite3.c"
    HEAP32[$15>>2] = $157; //@line 68926 "c/sqlite3.c"
    $158 = (_balance($0)|0); //@line 68927 "c/sqlite3.c"
    HEAP32[$2>>2] = $158; //@line 68927 "c/sqlite3.c"
    $159 = ($158|0)==(0); //@line 68930 "c/sqlite3.c"
    if (!($159)) {
     break;
    }
   }
   $160 = ($$0106|0)==(0); //@line 68931 "c/sqlite3.c"
   if (!($160)) {
    HEAP8[$0>>0] = 2; //@line 68935 "c/sqlite3.c"
    $161 = ((($16)) + 22|0); //@line 68936 "c/sqlite3.c"
    $162 = HEAP16[$161>>1]|0; //@line 68936 "c/sqlite3.c"
    $163 = ($13&65535)<($162&65535); //@line 68936 "c/sqlite3.c"
    $164 = ((($0)) + 64|0);
    if ($163) {
     HEAP32[$164>>2] = 1; //@line 68940 "c/sqlite3.c"
     break;
    } else {
     HEAP32[$164>>2] = -1; //@line 68937 "c/sqlite3.c"
     $165 = $162&65535; //@line 68938 "c/sqlite3.c"
     $166 = (($165) + 65535)|0; //@line 68938 "c/sqlite3.c"
     $167 = $166&65535; //@line 68938 "c/sqlite3.c"
     HEAP16[$12>>1] = $167; //@line 68938 "c/sqlite3.c"
     break;
    }
   }
   $168 = (_moveToRoot($0)|0); //@line 68943 "c/sqlite3.c"
   HEAP32[$2>>2] = $168; //@line 68943 "c/sqlite3.c"
   if ($35) {
    _btreeReleaseAllCursorPages($0); //@line 68945 "c/sqlite3.c"
    HEAP8[$0>>0] = 3; //@line 68946 "c/sqlite3.c"
   }
   $169 = ($168|0)==(16); //@line 68948 "c/sqlite3.c"
   if ($169) {
    HEAP32[$2>>2] = 0; //@line 68948 "c/sqlite3.c"
   }
  }
 } while(0);
 $170 = HEAP32[$2>>2]|0; //@line 68951 "c/sqlite3.c"
 $$1 = $170;
 STACKTOP = sp;return ($$1|0); //@line 68952 "c/sqlite3.c"
}
function _sqlite3VdbeSorterCompare($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$03234 = 0, $$033 = 0, $$sink = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = ((($0)) + 40|0); //@line 90530 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 90530 "c/sqlite3.c"
 $7 = ((($6)) + 32|0); //@line 90531 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 90531 "c/sqlite3.c"
 $9 = ((($0)) + 44|0); //@line 90532 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 90532 "c/sqlite3.c"
 $11 = ($8|0)==(0|0); //@line 90533 "c/sqlite3.c"
 do {
  if ($11) {
   $12 = (_sqlite3VdbeAllocUnpackedRecord($10)|0); //@line 90534 "c/sqlite3.c"
   HEAP32[$7>>2] = $12; //@line 90534 "c/sqlite3.c"
   $13 = ($12|0)==(0|0); //@line 90535 "c/sqlite3.c"
   if ($13) {
    $$0 = 7;
    STACKTOP = sp;return ($$0|0); //@line 90551 "c/sqlite3.c"
   } else {
    $14 = $2&65535; //@line 90536 "c/sqlite3.c"
    $15 = ((($12)) + 8|0); //@line 90536 "c/sqlite3.c"
    HEAP16[$15>>1] = $14; //@line 90536 "c/sqlite3.c"
    $$033 = $12;
    break;
   }
  } else {
   $$033 = $8;
  }
 } while(0);
 $16 = (_vdbeSorterRowkey($6,$4)|0); //@line 90540 "c/sqlite3.c"
 $17 = HEAP32[$4>>2]|0; //@line 90541 "c/sqlite3.c"
 _sqlite3VdbeRecordUnpack($10,$17,$16,$$033); //@line 90541 "c/sqlite3.c"
 $18 = ($2|0)>(0); //@line 90542 "c/sqlite3.c"
 L7: do {
  if ($18) {
   $19 = ((($$033)) + 4|0);
   $20 = HEAP32[$19>>2]|0;
   $$03234 = 0;
   while(1) {
    $23 = (((($20) + (($$03234*40)|0)|0)) + 8|0); //@line 90543 "c/sqlite3.c"
    $24 = HEAP16[$23>>1]|0; //@line 90543 "c/sqlite3.c"
    $25 = $24 & 1; //@line 90543 "c/sqlite3.c"
    $26 = ($25<<16>>16)==(0); //@line 90543 "c/sqlite3.c"
    $22 = (($$03234) + 1)|0; //@line 90542 "c/sqlite3.c"
    if (!($26)) {
     $$sink = -1;
     break L7;
    }
    $21 = ($22|0)<($2|0); //@line 90542 "c/sqlite3.c"
    if ($21) {
     $$03234 = $22;
    } else {
     label = 8;
     break;
    }
   }
  } else {
   label = 8;
  }
 } while(0);
 if ((label|0) == 8) {
  $27 = ((($1)) + 12|0); //@line 90549 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 90549 "c/sqlite3.c"
  $29 = ((($1)) + 16|0); //@line 90549 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 90549 "c/sqlite3.c"
  $31 = (_sqlite3VdbeRecordCompare($28,$30,$$033)|0); //@line 90549 "c/sqlite3.c"
  $$sink = $31;
 }
 HEAP32[$3>>2] = $$sink;
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 90551 "c/sqlite3.c"
}
function _sqlite3VdbeSorterRowkey($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 40|0); //@line 90489 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 90489 "c/sqlite3.c"
 $5 = (_vdbeSorterRowkey($4,$2)|0); //@line 90490 "c/sqlite3.c"
 $6 = HEAP32[$2>>2]|0; //@line 90491 "c/sqlite3.c"
 $7 = (_sqlite3VdbeMemClearAndResize($1,$6)|0); //@line 90491 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 90491 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 90499 "c/sqlite3.c"
 }
 $9 = ((($1)) + 12|0); //@line 90494 "c/sqlite3.c"
 HEAP32[$9>>2] = $6; //@line 90494 "c/sqlite3.c"
 $10 = ((($1)) + 8|0); //@line 90495 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 90495 "c/sqlite3.c"
 $12 = $11 & 15872; //@line 90495 "c/sqlite3.c"
 $13 = $12 | 16; //@line 90495 "c/sqlite3.c"
 HEAP16[$10>>1] = $13; //@line 90495 "c/sqlite3.c"
 $14 = ((($1)) + 16|0); //@line 90496 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 90496 "c/sqlite3.c"
 _memcpy(($15|0),($5|0),($6|0))|0; //@line 90496 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 90499 "c/sqlite3.c"
}
function _sqlite3VdbeCursorRestore($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 76087 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 76087 "c/sqlite3.c"
 $3 = (_sqlite3BtreeCursorHasMoved($2)|0); //@line 76087 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 76087 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  return ($$0|0); //@line 76091 "c/sqlite3.c"
 }
 $5 = (_handleMovedCursor($0)|0); //@line 76088 "c/sqlite3.c"
 $$0 = $5;
 return ($$0|0); //@line 76091 "c/sqlite3.c"
}
function _sqlite3BtreeCursorIsValidNN($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 64824 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(1); //@line 64824 "c/sqlite3.c"
 $3 = $2&1; //@line 64824 "c/sqlite3.c"
 return ($3|0); //@line 64824 "c/sqlite3.c"
}
function _sqlite3BtreeFirst($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_moveToRoot($0)|0); //@line 65551 "c/sqlite3.c"
 switch ($2|0) {
 case 0:  {
  HEAP32[$1>>2] = 0; //@line 65554 "c/sqlite3.c"
  $3 = (_moveToLeftmost($0)|0); //@line 65555 "c/sqlite3.c"
  $$0 = $3;
  break;
 }
 case 16:  {
  HEAP32[$1>>2] = 1; //@line 65558 "c/sqlite3.c"
  $$0 = 0;
  break;
 }
 default: {
  $$0 = $2;
 }
 }
 return ($$0|0); //@line 65561 "c/sqlite3.c"
}
function _sqlite3BtreeRowCountEst($0) {
 $0 = $0|0;
 var $$014 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 65909 "c/sqlite3.c"
 $2 = ($1<<24>>24)==(1); //@line 65909 "c/sqlite3.c"
 if ($2) {
  $3 = ((($0)) + 116|0); //@line 65910 "c/sqlite3.c"
  $4 = HEAP32[$3>>2]|0; //@line 65910 "c/sqlite3.c"
  $5 = ((($4)) + 8|0); //@line 65910 "c/sqlite3.c"
  $6 = HEAP8[$5>>0]|0; //@line 65910 "c/sqlite3.c"
  $7 = ($6<<24>>24)==(0); //@line 65910 "c/sqlite3.c"
  if ($7) {
   $29 = -1;$30 = -1;
  } else {
   $8 = ((($4)) + 22|0); //@line 65912 "c/sqlite3.c"
   $9 = HEAP16[$8>>1]|0; //@line 65912 "c/sqlite3.c"
   $10 = $9&65535; //@line 65912 "c/sqlite3.c"
   $11 = ((($0)) + 68|0); //@line 65913 "c/sqlite3.c"
   $12 = HEAP8[$11>>0]|0; //@line 65913 "c/sqlite3.c"
   $13 = ($12<<24>>24)>(0); //@line 65913 "c/sqlite3.c"
   if ($13) {
    $14 = HEAP8[$11>>0]|0;
    $15 = $14 << 24 >> 24;
    $$014 = 0;$17 = 0;$22 = $10;$23 = 0;
    while(1) {
     $16 = (((($0)) + 120|0) + ($17<<2)|0); //@line 65914 "c/sqlite3.c"
     $18 = HEAP32[$16>>2]|0; //@line 65914 "c/sqlite3.c"
     $19 = ((($18)) + 22|0); //@line 65914 "c/sqlite3.c"
     $20 = HEAP16[$19>>1]|0; //@line 65914 "c/sqlite3.c"
     $21 = $20&65535; //@line 65914 "c/sqlite3.c"
     $24 = (___muldi3(($22|0),($23|0),($21|0),0)|0); //@line 65914 "c/sqlite3.c"
     $25 = tempRet0; //@line 65914 "c/sqlite3.c"
     $26 = (($$014) + 1)<<24>>24; //@line 65913 "c/sqlite3.c"
     $27 = $26&255; //@line 65913 "c/sqlite3.c"
     $28 = ($27|0)<($15|0); //@line 65913 "c/sqlite3.c"
     if ($28) {
      $$014 = $26;$17 = $27;$22 = $24;$23 = $25;
     } else {
      $29 = $25;$30 = $24;
      break;
     }
    }
   } else {
    $29 = 0;$30 = $10;
   }
  }
 } else {
  $29 = -1;$30 = -1;
 }
 tempRet0 = ($29); //@line 65917 "c/sqlite3.c"
 return ($30|0); //@line 65917 "c/sqlite3.c"
}
function _sqlite3VdbeSorterRewind($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$016 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 40|0); //@line 90372 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 90372 "c/sqlite3.c"
 $4 = ((($3)) + 56|0); //@line 90378 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 90378 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 90378 "c/sqlite3.c"
 if (!($6)) {
  $12 = (_vdbeSorterFlushPMA($3)|0); //@line 90393 "c/sqlite3.c"
  $13 = (_vdbeSorterJoinAll($3,$12)|0); //@line 90396 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 90403 "c/sqlite3.c"
  if (!($14)) {
   $$016 = $13;
   return ($$016|0); //@line 90410 "c/sqlite3.c"
  }
  $15 = (_vdbeSorterSetupMerge($3)|0); //@line 90404 "c/sqlite3.c"
  HEAP32[$1>>2] = 0; //@line 90405 "c/sqlite3.c"
  $$016 = $15;
  return ($$016|0); //@line 90410 "c/sqlite3.c"
 }
 $7 = ((($3)) + 36|0); //@line 90379 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 90379 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 90379 "c/sqlite3.c"
 if ($9) {
  HEAP32[$1>>2] = 1; //@line 90383 "c/sqlite3.c"
  $$016 = 0;
  return ($$016|0); //@line 90410 "c/sqlite3.c"
 } else {
  HEAP32[$1>>2] = 0; //@line 90380 "c/sqlite3.c"
  $10 = ((($3)) + 64|0); //@line 90381 "c/sqlite3.c"
  $11 = (_vdbeSorterSort($10,$7)|0); //@line 90381 "c/sqlite3.c"
  $$016 = $11;
  return ($$016|0); //@line 90410 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeSorterNext($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($1)) + 40|0); //@line 90424 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 90424 "c/sqlite3.c"
 $5 = ((($4)) + 56|0); //@line 90426 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 90426 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 90426 "c/sqlite3.c"
 if ($7) {
  $25 = ((($4)) + 36|0); //@line 90444 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 90444 "c/sqlite3.c"
  $27 = ((($26)) + 4|0); //@line 90445 "c/sqlite3.c"
  $28 = HEAP32[$27>>2]|0; //@line 90445 "c/sqlite3.c"
  HEAP32[$25>>2] = $28; //@line 90445 "c/sqlite3.c"
  HEAP32[$27>>2] = 0; //@line 90446 "c/sqlite3.c"
  $29 = ((($4)) + 40|0); //@line 90447 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 90447 "c/sqlite3.c"
  $31 = ($30|0)==(0|0); //@line 90447 "c/sqlite3.c"
  if ($31) {
   _vdbeSorterRecordFree($0,$26); //@line 90447 "c/sqlite3.c"
  }
  $32 = HEAP32[$25>>2]|0; //@line 90448 "c/sqlite3.c"
  $33 = ($32|0)==(0|0); //@line 90448 "c/sqlite3.c"
  $34 = $33 ? 101 : 0; //@line 90448 "c/sqlite3.c"
  $$0 = $34;
  STACKTOP = sp;return ($$0|0); //@line 90450 "c/sqlite3.c"
 }
 $8 = ((($4)) + 57|0); //@line 90431 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 90431 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 90431 "c/sqlite3.c"
 if ($10) {
  HEAP32[$2>>2] = 0; //@line 90437 "c/sqlite3.c"
  $19 = ((($4)) + 20|0); //@line 90440 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 90440 "c/sqlite3.c"
  $21 = (_vdbeMergeEngineStep($20,$2)|0); //@line 90440 "c/sqlite3.c"
  $22 = ($21|0)==(0); //@line 90441 "c/sqlite3.c"
  $23 = HEAP32[$2>>2]|0; //@line 90441 "c/sqlite3.c"
  $24 = ($23|0)!=(0); //@line 90441 "c/sqlite3.c"
  $or$cond = $22 & $24; //@line 90441 "c/sqlite3.c"
  $spec$store$select = $or$cond ? 101 : $21; //@line 90441 "c/sqlite3.c"
  $$0 = $spec$store$select;
  STACKTOP = sp;return ($$0|0); //@line 90450 "c/sqlite3.c"
 }
 $11 = ((($4)) + 16|0); //@line 90432 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 90432 "c/sqlite3.c"
 $13 = (_vdbePmaReaderNext($12)|0); //@line 90432 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 90433 "c/sqlite3.c"
 if ($14) {
  $15 = HEAP32[$11>>2]|0; //@line 90433 "c/sqlite3.c"
  $16 = ((($15)) + 24|0); //@line 90433 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 90433 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 90433 "c/sqlite3.c"
  $spec$select = $18 ? 101 : $13; //@line 90433 "c/sqlite3.c"
  STACKTOP = sp;return ($spec$select|0); //@line 90433 "c/sqlite3.c"
 } else {
  $$0 = $13;
  STACKTOP = sp;return ($$0|0); //@line 90450 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3VdbeSorterWrite($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0104 = 0, $$099 = 0, $$099$in = 0, $$1106 = 0, $$1106$ph = 0, $$2 = 0, $$3 = 0, $$off = 0, $$sink = 0, $$sink118 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $brmerge = 0, $or$cond = 0, $or$cond4 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 40|0); //@line 89575 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 89575 "c/sqlite3.c"
 $5 = ((($1)) + 16|0); //@line 89576 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89576 "c/sqlite3.c"
 $7 = ((($6)) + 1|0); //@line 89576 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 89576 "c/sqlite3.c"
 $9 = ($8<<24>>24)>(-1); //@line 89576 "c/sqlite3.c"
 if ($9) {
  $10 = $8&255; //@line 89576 "c/sqlite3.c"
  HEAP32[$2>>2] = $10; //@line 89576 "c/sqlite3.c"
 } else {
  (_sqlite3GetVarint32($7,$2)|0); //@line 89576 "c/sqlite3.c"
 }
 $11 = HEAP32[$2>>2]|0; //@line 89577 "c/sqlite3.c"
 $$off = (($11) + -1)|0; //@line 89577 "c/sqlite3.c"
 $12 = ($$off>>>0)<(9); //@line 89577 "c/sqlite3.c"
 $13 = ($11|0)!=(7); //@line 89577 "c/sqlite3.c"
 $or$cond4 = $13 & $12; //@line 89577 "c/sqlite3.c"
 do {
  if ($or$cond4) {
   $14 = ((($4)) + 60|0); //@line 89578 "c/sqlite3.c"
   $15 = HEAP8[$14>>0]|0; //@line 89578 "c/sqlite3.c"
   $16 = $15 & 1; //@line 89578 "c/sqlite3.c"
   HEAP8[$14>>0] = $16; //@line 89578 "c/sqlite3.c"
  } else {
   $17 = ($11|0)<(11); //@line 89579 "c/sqlite3.c"
   $18 = $11 & 1; //@line 89579 "c/sqlite3.c"
   $19 = ($18|0)==(0); //@line 89579 "c/sqlite3.c"
   $or$cond = $17 | $19; //@line 89579 "c/sqlite3.c"
   $20 = ((($4)) + 60|0);
   if ($or$cond) {
    HEAP8[$20>>0] = 0; //@line 89582 "c/sqlite3.c"
    break;
   } else {
    $21 = HEAP8[$20>>0]|0; //@line 89580 "c/sqlite3.c"
    $22 = $21 & 2; //@line 89580 "c/sqlite3.c"
    HEAP8[$20>>0] = $22; //@line 89580 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $23 = ((($1)) + 12|0); //@line 89603 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 89603 "c/sqlite3.c"
 $25 = (($24) + 8)|0; //@line 89603 "c/sqlite3.c"
 $26 = ($24|0)<(0); //@line 89604 "c/sqlite3.c"
 $27 = $26 << 31 >> 31; //@line 89604 "c/sqlite3.c"
 $28 = (_sqlite3VarintLen($24,$27)|0); //@line 89604 "c/sqlite3.c"
 $29 = (($28) + ($24))|0; //@line 89604 "c/sqlite3.c"
 $30 = ((($4)) + 4|0); //@line 89605 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 89605 "c/sqlite3.c"
 $32 = ($31|0)==(0); //@line 89605 "c/sqlite3.c"
 do {
  if ($32) {
   $$0104 = 0;
  } else {
   $33 = ((($4)) + 40|0); //@line 89606 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 89606 "c/sqlite3.c"
   $35 = ($34|0)==(0|0); //@line 89606 "c/sqlite3.c"
   if ($35) {
    $41 = ((($4)) + 44|0); //@line 89610 "c/sqlite3.c"
    $42 = HEAP32[$41>>2]|0; //@line 89610 "c/sqlite3.c"
    $43 = ($42|0)>($31|0); //@line 89610 "c/sqlite3.c"
    if (!($43)) {
     $44 = HEAP32[$4>>2]|0; //@line 89611 "c/sqlite3.c"
     $45 = ($42|0)>($44|0); //@line 89611 "c/sqlite3.c"
     if (!($45)) {
      $$0104 = 0;
      break;
     }
     $46 = (_sqlite3HeapNearlyFull()|0); //@line 89611 "c/sqlite3.c"
     $47 = ($46|0)==(0); //@line 89611 "c/sqlite3.c"
     if ($47) {
      $$0104 = 0;
      break;
     }
    }
   } else {
    $36 = ((($4)) + 48|0); //@line 89607 "c/sqlite3.c"
    $37 = HEAP32[$36>>2]|0; //@line 89607 "c/sqlite3.c"
    $38 = ($37|0)==(0); //@line 89607 "c/sqlite3.c"
    $39 = (($37) + ($25))|0; //@line 89607 "c/sqlite3.c"
    $40 = ($39|0)<=($31|0); //@line 89607 "c/sqlite3.c"
    $brmerge = $38 | $40;
    if ($brmerge) {
     $$0104 = 0;
     break;
    }
   }
   $48 = (_vdbeSorterFlushPMA($4)|0); //@line 89615 "c/sqlite3.c"
   $49 = ((($4)) + 44|0); //@line 89616 "c/sqlite3.c"
   HEAP32[$49>>2] = 0; //@line 89616 "c/sqlite3.c"
   $50 = ((($4)) + 48|0); //@line 89617 "c/sqlite3.c"
   HEAP32[$50>>2] = 0; //@line 89617 "c/sqlite3.c"
   $$0104 = $48;
  }
 } while(0);
 $51 = ((($4)) + 36|0); //@line 89622 "c/sqlite3.c"
 $52 = ((($4)) + 44|0); //@line 89622 "c/sqlite3.c"
 $53 = HEAP32[$52>>2]|0; //@line 89622 "c/sqlite3.c"
 $54 = (($53) + ($29))|0; //@line 89622 "c/sqlite3.c"
 HEAP32[$52>>2] = $54; //@line 89622 "c/sqlite3.c"
 $55 = ((($4)) + 8|0); //@line 89623 "c/sqlite3.c"
 $56 = HEAP32[$55>>2]|0; //@line 89623 "c/sqlite3.c"
 $57 = ($29|0)>($56|0); //@line 89623 "c/sqlite3.c"
 if ($57) {
  HEAP32[$55>>2] = $29; //@line 89624 "c/sqlite3.c"
 }
 $58 = ((($4)) + 40|0); //@line 89627 "c/sqlite3.c"
 $59 = HEAP32[$58>>2]|0; //@line 89627 "c/sqlite3.c"
 $60 = ($59|0)==(0|0); //@line 89627 "c/sqlite3.c"
 do {
  if ($60) {
   $90 = ($25|0)<(0); //@line 89651 "c/sqlite3.c"
   $91 = $90 << 31 >> 31; //@line 89651 "c/sqlite3.c"
   $92 = (_sqlite3Malloc($25,$91)|0); //@line 89651 "c/sqlite3.c"
   $93 = ($92|0)==(0|0); //@line 89652 "c/sqlite3.c"
   if ($93) {
    $$3 = 7;
    STACKTOP = sp;return ($$3|0); //@line 89663 "c/sqlite3.c"
   } else {
    $94 = HEAP32[$51>>2]|0; //@line 89655 "c/sqlite3.c"
    $$1106$ph = $92;$$sink = $94;$$sink118 = $92;
    label = 28;
    break;
   }
  } else {
   $61 = ((($4)) + 48|0); //@line 89628 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 89628 "c/sqlite3.c"
   $63 = (($62) + ($25))|0; //@line 89628 "c/sqlite3.c"
   $64 = ((($4)) + 52|0); //@line 89630 "c/sqlite3.c"
   $65 = HEAP32[$64>>2]|0; //@line 89630 "c/sqlite3.c"
   $66 = ($63|0)>($65|0); //@line 89630 "c/sqlite3.c"
   do {
    if ($66) {
     $67 = HEAP32[$51>>2]|0; //@line 89632 "c/sqlite3.c"
     $68 = $59; //@line 89632 "c/sqlite3.c"
     $$099$in = $65;
     while(1) {
      $$099 = $$099$in << 1;
      $69 = ($$099|0)<($63|0); //@line 89634 "c/sqlite3.c"
      if ($69) {
       $$099$in = $$099;
      } else {
       break;
      }
     }
     $70 = HEAP32[$30>>2]|0; //@line 89635 "c/sqlite3.c"
     $71 = ($$099|0)>($70|0); //@line 89635 "c/sqlite3.c"
     $spec$select = $71 ? $70 : $$099; //@line 89635 "c/sqlite3.c"
     $72 = ($spec$select|0)<($63|0); //@line 89636 "c/sqlite3.c"
     $$2 = $72 ? $63 : $spec$select; //@line 89636 "c/sqlite3.c"
     $73 = ($$2|0)<(0); //@line 89638 "c/sqlite3.c"
     $74 = $73 << 31 >> 31; //@line 89638 "c/sqlite3.c"
     $75 = (_sqlite3Realloc($59,$$2,$74)|0); //@line 89638 "c/sqlite3.c"
     $76 = ($75|0)==(0|0); //@line 89639 "c/sqlite3.c"
     if ($76) {
      $$3 = 7;
      STACKTOP = sp;return ($$3|0); //@line 89663 "c/sqlite3.c"
     } else {
      $77 = (($67) - ($68))|0; //@line 89632 "c/sqlite3.c"
      $78 = (($75) + ($77)|0); //@line 89640 "c/sqlite3.c"
      HEAP32[$51>>2] = $78; //@line 89640 "c/sqlite3.c"
      HEAP32[$58>>2] = $75; //@line 89641 "c/sqlite3.c"
      HEAP32[$64>>2] = $$2; //@line 89642 "c/sqlite3.c"
      break;
     }
    }
   } while(0);
   $79 = HEAP32[$58>>2]|0; //@line 89645 "c/sqlite3.c"
   $80 = HEAP32[$61>>2]|0; //@line 89645 "c/sqlite3.c"
   $81 = (($79) + ($80)|0); //@line 89645 "c/sqlite3.c"
   $82 = (($24) + 15)|0; //@line 89646 "c/sqlite3.c"
   $83 = $82 & -8; //@line 89646 "c/sqlite3.c"
   $84 = (($80) + ($83))|0; //@line 89646 "c/sqlite3.c"
   HEAP32[$61>>2] = $84; //@line 89646 "c/sqlite3.c"
   $85 = HEAP32[$51>>2]|0; //@line 89647 "c/sqlite3.c"
   $86 = ($85|0)==(0|0); //@line 89647 "c/sqlite3.c"
   if ($86) {
    $$1106 = $81;
   } else {
    $87 = HEAP32[$58>>2]|0; //@line 89648 "c/sqlite3.c"
    $88 = $85; //@line 89648 "c/sqlite3.c"
    $89 = (($88) - ($87))|0; //@line 89648 "c/sqlite3.c"
    $$1106$ph = $81;$$sink = $89;$$sink118 = $81;
    label = 28;
   }
  }
 } while(0);
 if ((label|0) == 28) {
  $95 = ((($$sink118)) + 4|0);
  HEAP32[$95>>2] = $$sink;
  $$1106 = $$1106$ph;
 }
 $96 = ((($$1106)) + 8|0); //@line 89658 "c/sqlite3.c"
 $97 = HEAP32[$5>>2]|0; //@line 89658 "c/sqlite3.c"
 $98 = HEAP32[$23>>2]|0; //@line 89658 "c/sqlite3.c"
 _memcpy(($96|0),($97|0),($98|0))|0; //@line 89658 "c/sqlite3.c"
 $99 = HEAP32[$23>>2]|0; //@line 89659 "c/sqlite3.c"
 HEAP32[$$1106>>2] = $99; //@line 89659 "c/sqlite3.c"
 HEAP32[$51>>2] = $$1106; //@line 89660 "c/sqlite3.c"
 $$3 = $$0104;
 STACKTOP = sp;return ($$3|0); //@line 89663 "c/sqlite3.c"
}
function _sqlite3VdbeIdxRowid($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 96|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(96|0);
 $3 = sp + 84|0;
 $4 = sp + 80|0;
 $5 = sp + 40|0;
 $6 = sp;
 $7 = (_sqlite3BtreePayloadSize($1)|0); //@line 77393 "c/sqlite3.c"
 _sqlite3VdbeMemInit($5,$0,0); //@line 77397 "c/sqlite3.c"
 $8 = (_sqlite3VdbeMemFromBtree($1,0,$7,$5)|0); //@line 77398 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 77399 "c/sqlite3.c"
 if (!($9)) {
  $$0 = $8;
  STACKTOP = sp;return ($$0|0); //@line 77443 "c/sqlite3.c"
 }
 $10 = ((($5)) + 16|0); //@line 77404 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 77404 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 77404 "c/sqlite3.c"
 $13 = ($12<<24>>24)>(-1); //@line 77404 "c/sqlite3.c"
 if ($13) {
  $14 = $12&255; //@line 77404 "c/sqlite3.c"
  HEAP32[$3>>2] = $14; //@line 77404 "c/sqlite3.c"
  $16 = $14;
 } else {
  (_sqlite3GetVarint32($11,$3)|0); //@line 77404 "c/sqlite3.c"
  $$pr = HEAP32[$3>>2]|0; //@line 77407 "c/sqlite3.c"
  $16 = $$pr;
 }
 $15 = ($16>>>0)<(3); //@line 77407 "c/sqlite3.c"
 if (!($15)) {
  $17 = ((($5)) + 12|0); //@line 77407 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 77407 "c/sqlite3.c"
  $19 = ($16|0)>($18|0); //@line 77407 "c/sqlite3.c"
  if (!($19)) {
   $20 = HEAP32[$10>>2]|0; //@line 77413 "c/sqlite3.c"
   $21 = (($16) + -1)|0; //@line 77413 "c/sqlite3.c"
   $22 = (($20) + ($21)|0); //@line 77413 "c/sqlite3.c"
   $23 = HEAP8[$22>>0]|0; //@line 77413 "c/sqlite3.c"
   $24 = ($23<<24>>24)>(-1); //@line 77413 "c/sqlite3.c"
   if ($24) {
    $25 = $23&255; //@line 77413 "c/sqlite3.c"
    HEAP32[$4>>2] = $25; //@line 77413 "c/sqlite3.c"
   } else {
    (_sqlite3GetVarint32($22,$4)|0); //@line 77413 "c/sqlite3.c"
   }
   $26 = HEAP32[$4>>2]|0; //@line 77422 "c/sqlite3.c"
   $27 = (($26) + -1)|0; //@line 77422 "c/sqlite3.c"
   $28 = ($27>>>0)>(8); //@line 77422 "c/sqlite3.c"
   $29 = ($26|0)==(7); //@line 77422 "c/sqlite3.c"
   $or$cond3 = $29 | $28; //@line 77422 "c/sqlite3.c"
   if (!($or$cond3)) {
    $30 = (27860 + ($26)|0); //@line 77425 "c/sqlite3.c"
    $31 = HEAP8[$30>>0]|0; //@line 77425 "c/sqlite3.c"
    $32 = $31&255; //@line 77425 "c/sqlite3.c"
    $33 = HEAP32[$17>>2]|0; //@line 77427 "c/sqlite3.c"
    $34 = (($16) + ($32))|0; //@line 77427 "c/sqlite3.c"
    $35 = ($33>>>0)<($34>>>0); //@line 77427 "c/sqlite3.c"
    if (!($35)) {
     $36 = HEAP32[$10>>2]|0; //@line 77432 "c/sqlite3.c"
     $37 = (($33) - ($32))|0; //@line 77432 "c/sqlite3.c"
     $38 = (($36) + ($37)|0); //@line 77432 "c/sqlite3.c"
     (_sqlite3VdbeSerialGet($38,$26,$6)|0); //@line 77432 "c/sqlite3.c"
     $39 = $6; //@line 77433 "c/sqlite3.c"
     $40 = $39; //@line 77433 "c/sqlite3.c"
     $41 = HEAP32[$40>>2]|0; //@line 77433 "c/sqlite3.c"
     $42 = (($39) + 4)|0; //@line 77433 "c/sqlite3.c"
     $43 = $42; //@line 77433 "c/sqlite3.c"
     $44 = HEAP32[$43>>2]|0; //@line 77433 "c/sqlite3.c"
     $45 = $2; //@line 77433 "c/sqlite3.c"
     $46 = $45; //@line 77433 "c/sqlite3.c"
     HEAP32[$46>>2] = $41; //@line 77433 "c/sqlite3.c"
     $47 = (($45) + 4)|0; //@line 77433 "c/sqlite3.c"
     $48 = $47; //@line 77433 "c/sqlite3.c"
     HEAP32[$48>>2] = $44; //@line 77433 "c/sqlite3.c"
     _sqlite3VdbeMemRelease($5); //@line 77434 "c/sqlite3.c"
     $$0 = 0;
     STACKTOP = sp;return ($$0|0); //@line 77443 "c/sqlite3.c"
    }
   }
  }
 }
 _sqlite3VdbeMemRelease($5); //@line 77441 "c/sqlite3.c"
 $49 = (_sqlite3CorruptError(77442)|0); //@line 77442 "c/sqlite3.c"
 $$0 = $49;
 STACKTOP = sp;return ($$0|0); //@line 77443 "c/sqlite3.c"
}
function _sqlite3VdbeIdxKeyCompare($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $4 = sp;
 $5 = ((($1)) + 40|0); //@line 77468 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 77468 "c/sqlite3.c"
 $7 = (_sqlite3BtreePayloadSize($6)|0); //@line 77470 "c/sqlite3.c"
 $8 = ($7|0)<(1); //@line 77473 "c/sqlite3.c"
 if ($8) {
  HEAP32[$3>>2] = 0; //@line 77474 "c/sqlite3.c"
  $9 = (_sqlite3CorruptError(77475)|0); //@line 77475 "c/sqlite3.c"
  $$0 = $9;
  STACKTOP = sp;return ($$0|0); //@line 77485 "c/sqlite3.c"
 }
 _sqlite3VdbeMemInit($4,$0,0); //@line 77477 "c/sqlite3.c"
 $10 = (_sqlite3VdbeMemFromBtree($6,0,$7,$4)|0); //@line 77478 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 77479 "c/sqlite3.c"
 if (!($11)) {
  $$0 = $10;
  STACKTOP = sp;return ($$0|0); //@line 77485 "c/sqlite3.c"
 }
 $12 = ((($4)) + 12|0); //@line 77482 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 77482 "c/sqlite3.c"
 $14 = ((($4)) + 16|0); //@line 77482 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 77482 "c/sqlite3.c"
 $16 = (_sqlite3VdbeRecordCompare($13,$15,$2)|0); //@line 77482 "c/sqlite3.c"
 HEAP32[$3>>2] = $16; //@line 77482 "c/sqlite3.c"
 _sqlite3VdbeMemRelease($4); //@line 77483 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 77485 "c/sqlite3.c"
}
function _sqlite3BtreeDropTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 69319 "c/sqlite3.c"
 $3 = (_btreeDropTable($0,$1,$2)|0); //@line 69320 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 69321 "c/sqlite3.c"
 return ($3|0); //@line 69322 "c/sqlite3.c"
}
function _sqlite3RootPageMoved($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$030 = 0, $$031 = 0, $$1 = 0, $$128 = 0, $$129 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 16|0); //@line 103935 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 103935 "c/sqlite3.c"
 $6 = (((($5) + ($1<<4)|0)) + 12|0); //@line 103936 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 103936 "c/sqlite3.c"
 $8 = ((($7)) + 16|0); //@line 103937 "c/sqlite3.c"
 $$030 = HEAP32[$8>>2]|0;
 $9 = ($$030|0)==(0|0); //@line 103937 "c/sqlite3.c"
 if (!($9)) {
  $$031 = $$030;
  while(1) {
   $10 = ((($$031)) + 8|0); //@line 103938 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 103938 "c/sqlite3.c"
   $12 = ((($11)) + 28|0); //@line 103939 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 103939 "c/sqlite3.c"
   $14 = ($13|0)==($2|0); //@line 103939 "c/sqlite3.c"
   if ($14) {
    HEAP32[$12>>2] = $3; //@line 103940 "c/sqlite3.c"
   }
   $$0 = HEAP32[$$031>>2]|0;
   $15 = ($$0|0)==(0|0); //@line 103937 "c/sqlite3.c"
   if ($15) {
    break;
   } else {
    $$031 = $$0;
   }
  }
 }
 $16 = ((($7)) + 32|0); //@line 103944 "c/sqlite3.c"
 $$128 = HEAP32[$16>>2]|0;
 $17 = ($$128|0)==(0|0); //@line 103944 "c/sqlite3.c"
 if ($17) {
  return; //@line 103950 "c/sqlite3.c"
 }
 $$129 = $$128;
 while(1) {
  $18 = ((($$129)) + 8|0); //@line 103945 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 103945 "c/sqlite3.c"
  $20 = ((($19)) + 44|0); //@line 103946 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 103946 "c/sqlite3.c"
  $22 = ($21|0)==($2|0); //@line 103946 "c/sqlite3.c"
  if ($22) {
   HEAP32[$20>>2] = $3; //@line 103947 "c/sqlite3.c"
  }
  $$1 = HEAP32[$$129>>2]|0;
  $23 = ($$1|0)==(0|0); //@line 103944 "c/sqlite3.c"
  if ($23) {
   break;
  } else {
   $$129 = $$1;
  }
 }
 return; //@line 103950 "c/sqlite3.c"
}
function _sqlite3BtreeClearTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 69189 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 69189 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 69190 "c/sqlite3.c"
 $5 = (_saveAllCursors($4,$1,0)|0); //@line 69193 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 69195 "c/sqlite3.c"
 if (!($6)) {
  $$0 = $5;
  _sqlite3BtreeLeave($0); //@line 69202 "c/sqlite3.c"
  return ($$0|0); //@line 69203 "c/sqlite3.c"
 }
 _invalidateIncrblobCursors($0,$1,0,0,1); //@line 69199 "c/sqlite3.c"
 $7 = (_clearDatabasePage($4,$1,0,$2)|0); //@line 69200 "c/sqlite3.c"
 $$0 = $7;
 _sqlite3BtreeLeave($0); //@line 69202 "c/sqlite3.c"
 return ($$0|0); //@line 69203 "c/sqlite3.c"
}
function _sqlite3BtreeClearTableOfCursor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 69212 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 69212 "c/sqlite3.c"
 $3 = ((($0)) + 60|0); //@line 69212 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 69212 "c/sqlite3.c"
 $5 = (_sqlite3BtreeClearTable($2,$4,0)|0); //@line 69212 "c/sqlite3.c"
 return ($5|0); //@line 69212 "c/sqlite3.c"
}
function _sqlite3UnlinkAndDeleteTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 102285 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 102285 "c/sqlite3.c"
 $5 = (((($4) + ($1<<4)|0)) + 12|0); //@line 102286 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 102286 "c/sqlite3.c"
 $7 = ((($6)) + 8|0); //@line 102286 "c/sqlite3.c"
 $8 = (_sqlite3HashInsert($7,$2,0)|0); //@line 102286 "c/sqlite3.c"
 _sqlite3DeleteTable($0,$8); //@line 102287 "c/sqlite3.c"
 $9 = ((($0)) + 24|0); //@line 102288 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 102288 "c/sqlite3.c"
 $11 = $10 | 1; //@line 102288 "c/sqlite3.c"
 HEAP32[$9>>2] = $11; //@line 102288 "c/sqlite3.c"
 return; //@line 102289 "c/sqlite3.c"
}
function _sqlite3UnlinkAndDeleteIndex($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$026 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 102083 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 102083 "c/sqlite3.c"
 $5 = (((($4) + ($1<<4)|0)) + 12|0); //@line 102083 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 102083 "c/sqlite3.c"
 $7 = ((($6)) + 24|0); //@line 102083 "c/sqlite3.c"
 $8 = (_sqlite3HashInsert($7,$2,0)|0); //@line 102084 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 102085 "c/sqlite3.c"
 if ($9) {
  $25 = ((($0)) + 24|0); //@line 102100 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 102100 "c/sqlite3.c"
  $27 = $26 | 1; //@line 102100 "c/sqlite3.c"
  HEAP32[$25>>2] = $27; //@line 102100 "c/sqlite3.c"
  return; //@line 102101 "c/sqlite3.c"
 }
 $10 = ((($8)) + 12|0); //@line 102086 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 102086 "c/sqlite3.c"
 $12 = ((($11)) + 8|0); //@line 102086 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 102086 "c/sqlite3.c"
 $14 = ($13|0)==($8|0); //@line 102086 "c/sqlite3.c"
 L4: do {
  if ($14) {
   $15 = ((($8)) + 20|0); //@line 102087 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 102087 "c/sqlite3.c"
   HEAP32[$12>>2] = $16; //@line 102087 "c/sqlite3.c"
  } else {
   $17 = ($13|0)==(0|0); //@line 102093 "c/sqlite3.c"
   if (!($17)) {
    $$026 = $13;
    while(1) {
     $20 = ((($$026)) + 20|0); //@line 102093 "c/sqlite3.c"
     $19 = HEAP32[$20>>2]|0; //@line 102093 "c/sqlite3.c"
     $21 = ($19|0)==($8|0); //@line 102093 "c/sqlite3.c"
     if ($21) {
      break;
     }
     $18 = ($19|0)==(0|0); //@line 102093 "c/sqlite3.c"
     if ($18) {
      break L4;
     } else {
      $$026 = $19;
     }
    }
    $22 = ((($$026)) + 20|0); //@line 102093 "c/sqlite3.c"
    $23 = ((($8)) + 20|0); //@line 102095 "c/sqlite3.c"
    $24 = HEAP32[$23>>2]|0; //@line 102095 "c/sqlite3.c"
    HEAP32[$22>>2] = $24; //@line 102095 "c/sqlite3.c"
   }
  }
 } while(0);
 _freeIndex($0,$8); //@line 102098 "c/sqlite3.c"
 $25 = ((($0)) + 24|0); //@line 102100 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 102100 "c/sqlite3.c"
 $27 = $26 | 1; //@line 102100 "c/sqlite3.c"
 HEAP32[$25>>2] = $27; //@line 102100 "c/sqlite3.c"
 return; //@line 102101 "c/sqlite3.c"
}
function _sqlite3UnlinkAndDeleteTrigger($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 125543 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 125543 "c/sqlite3.c"
 $5 = (((($4) + ($1<<4)|0)) + 12|0); //@line 125543 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 125543 "c/sqlite3.c"
 $7 = ((($6)) + 40|0); //@line 125543 "c/sqlite3.c"
 $8 = (_sqlite3HashInsert($7,$2,0)|0); //@line 125544 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 125545 "c/sqlite3.c"
 if ($9) {
  return; //@line 125555 "c/sqlite3.c"
 }
 $10 = ((($8)) + 20|0); //@line 125546 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 125546 "c/sqlite3.c"
 $12 = ((($8)) + 24|0); //@line 125546 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 125546 "c/sqlite3.c"
 $14 = ($11|0)==($13|0); //@line 125546 "c/sqlite3.c"
 if ($14) {
  $15 = (_tableOfTrigger($8)|0); //@line 125547 "c/sqlite3.c"
  $16 = ((($15)) + 68|0); //@line 125549 "c/sqlite3.c"
  $$0 = $16;
  while(1) {
   $17 = HEAP32[$$0>>2]|0; //@line 125549 "c/sqlite3.c"
   $18 = ($17|0)==($8|0); //@line 125549 "c/sqlite3.c"
   $19 = ((($17)) + 32|0);
   if ($18) {
    break;
   } else {
    $$0 = $19;
   }
  }
  $20 = HEAP32[$19>>2]|0; //@line 125550 "c/sqlite3.c"
  HEAP32[$$0>>2] = $20; //@line 125550 "c/sqlite3.c"
 }
 _sqlite3DeleteTrigger($0,$8); //@line 125552 "c/sqlite3.c"
 $21 = ((($0)) + 24|0); //@line 125553 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 125553 "c/sqlite3.c"
 $23 = $22 | 1; //@line 125553 "c/sqlite3.c"
 HEAP32[$21>>2] = $23; //@line 125553 "c/sqlite3.c"
 return; //@line 125555 "c/sqlite3.c"
}
function _sqlite3BtreeIntegrityCheck($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$04850 = 0, $$149 = 0, $$pr = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0;
 var $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 192|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(192|0);
 $vararg_buffer1 = sp + 16|0;
 $vararg_buffer = sp + 8|0;
 $5 = sp + 20|0;
 $6 = sp + 88|0;
 $7 = sp;
 $8 = ((($0)) + 4|0); //@line 69998 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 69998 "c/sqlite3.c"
 $10 = ((($9)) + 4|0); //@line 69999 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 69999 "c/sqlite3.c"
 $12 = ((($11)) + 28|0); //@line 69999 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 69999 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 70003 "c/sqlite3.c"
 HEAP32[$5>>2] = $9; //@line 70007 "c/sqlite3.c"
 $14 = HEAP32[$9>>2]|0; //@line 70008 "c/sqlite3.c"
 $15 = ((($5)) + 4|0); //@line 70008 "c/sqlite3.c"
 HEAP32[$15>>2] = $14; //@line 70008 "c/sqlite3.c"
 $16 = (_btreePagecount($9)|0); //@line 70009 "c/sqlite3.c"
 $17 = ((($5)) + 12|0); //@line 70009 "c/sqlite3.c"
 HEAP32[$17>>2] = $16; //@line 70009 "c/sqlite3.c"
 $18 = ((($5)) + 16|0); //@line 70010 "c/sqlite3.c"
 HEAP32[$18>>2] = $3; //@line 70010 "c/sqlite3.c"
 $19 = ((($5)) + 20|0); //@line 70011 "c/sqlite3.c"
 $20 = ((($5)) + 24|0); //@line 70012 "c/sqlite3.c"
 $21 = ((($5)) + 28|0); //@line 70013 "c/sqlite3.c"
 $22 = ((($5)) + 8|0); //@line 70016 "c/sqlite3.c"
 HEAP32[$22>>2] = 0; //@line 70016 "c/sqlite3.c"
 $23 = ((($5)) + 64|0); //@line 70017 "c/sqlite3.c"
 HEAP32[$23>>2] = 0; //@line 70017 "c/sqlite3.c"
 $24 = ((($5)) + 40|0); //@line 70018 "c/sqlite3.c"
 ;HEAP32[$19>>2]=0|0;HEAP32[$19+4>>2]=0|0;HEAP32[$19+8>>2]=0|0;HEAP32[$19+12>>2]=0|0;HEAP32[$19+16>>2]=0|0; //@line 70012 "c/sqlite3.c"
 _sqlite3StrAccumInit($24,0,$6,100,1000000000); //@line 70018 "c/sqlite3.c"
 $25 = ((($5)) + 61|0); //@line 70019 "c/sqlite3.c"
 HEAP8[$25>>0] = 1; //@line 70019 "c/sqlite3.c"
 $26 = HEAP32[$17>>2]|0; //@line 70020 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 70020 "c/sqlite3.c"
 do {
  if (!($27)) {
   $28 = $26 >>> 3; //@line 70024 "c/sqlite3.c"
   $29 = (($28) + 1)|0; //@line 70024 "c/sqlite3.c"
   $30 = (_sqlite3MallocZero($29,0)|0); //@line 70024 "c/sqlite3.c"
   HEAP32[$22>>2] = $30; //@line 70024 "c/sqlite3.c"
   $31 = ($30|0)==(0|0); //@line 70025 "c/sqlite3.c"
   if ($31) {
    HEAP32[$20>>2] = 1; //@line 70026 "c/sqlite3.c"
    break;
   }
   $32 = ((($9)) + 32|0); //@line 70029 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 70029 "c/sqlite3.c"
   $34 = (_sqlite3PageMalloc($33)|0); //@line 70029 "c/sqlite3.c"
   HEAP32[$23>>2] = $34; //@line 70029 "c/sqlite3.c"
   $35 = ($34|0)==(0|0); //@line 70030 "c/sqlite3.c"
   if ($35) {
    HEAP32[$20>>2] = 1; //@line 70031 "c/sqlite3.c"
    break;
   }
   $36 = HEAP32[513]|0; //@line 70035 "c/sqlite3.c"
   $37 = HEAP32[$32>>2]|0; //@line 70035 "c/sqlite3.c"
   $38 = (($36>>>0) / ($37>>>0))&-1; //@line 70035 "c/sqlite3.c"
   $39 = (($38) + 1)|0; //@line 70035 "c/sqlite3.c"
   $40 = HEAP32[$17>>2]|0; //@line 70036 "c/sqlite3.c"
   $41 = ($39>>>0)>($40>>>0); //@line 70036 "c/sqlite3.c"
   if (!($41)) {
    _setPageReferenced($5,$39); //@line 70036 "c/sqlite3.c"
   }
   HEAP32[$21>>2] = 34851; //@line 70040 "c/sqlite3.c"
   $42 = ((($9)) + 12|0); //@line 70041 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 70041 "c/sqlite3.c"
   $44 = ((($43)) + 56|0); //@line 70041 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 70041 "c/sqlite3.c"
   $46 = ((($45)) + 32|0); //@line 70041 "c/sqlite3.c"
   $47 = (_sqlite3Get4byte($46)|0); //@line 70041 "c/sqlite3.c"
   $48 = ((($45)) + 36|0); //@line 70042 "c/sqlite3.c"
   $49 = (_sqlite3Get4byte($48)|0); //@line 70042 "c/sqlite3.c"
   _checkList($5,1,$47,$49); //@line 70041 "c/sqlite3.c"
   HEAP32[$21>>2] = 0; //@line 70043 "c/sqlite3.c"
   $50 = HEAP32[$10>>2]|0; //@line 70048 "c/sqlite3.c"
   $51 = ((($50)) + 28|0); //@line 70048 "c/sqlite3.c"
   $52 = HEAP32[$51>>2]|0; //@line 70048 "c/sqlite3.c"
   $53 = $52 & -2097153; //@line 70048 "c/sqlite3.c"
   HEAP32[$51>>2] = $53; //@line 70048 "c/sqlite3.c"
   $54 = ($2|0)>(0); //@line 70049 "c/sqlite3.c"
   $55 = HEAP32[$18>>2]|0; //@line 70049 "c/sqlite3.c"
   $56 = ($55|0)!=(0); //@line 70049 "c/sqlite3.c"
   $57 = $54 & $56; //@line 70049 "c/sqlite3.c"
   if ($57) {
    $58 = ((($9)) + 17|0);
    $$04850 = 0;
    while(1) {
     $59 = (($1) + ($$04850<<2)|0); //@line 70051 "c/sqlite3.c"
     $60 = HEAP32[$59>>2]|0; //@line 70051 "c/sqlite3.c"
     $61 = ($60|0)==(0); //@line 70051 "c/sqlite3.c"
     if (!($61)) {
      $62 = HEAP8[$58>>0]|0; //@line 70053 "c/sqlite3.c"
      $63 = ($62<<24>>24)!=(0); //@line 70053 "c/sqlite3.c"
      $64 = ($60|0)>(1); //@line 70053 "c/sqlite3.c"
      $or$cond = $64 & $63; //@line 70053 "c/sqlite3.c"
      if ($or$cond) {
       _checkPtrmap($5,$60,1,0); //@line 70054 "c/sqlite3.c"
      }
      $65 = HEAP32[$59>>2]|0; //@line 70057 "c/sqlite3.c"
      (_checkTreePage($5,$65,$7,-1,2147483647)|0); //@line 70057 "c/sqlite3.c"
     }
     $66 = (($$04850) + 1)|0; //@line 70049 "c/sqlite3.c"
     $67 = ($66|0)<($2|0); //@line 70049 "c/sqlite3.c"
     $68 = HEAP32[$18>>2]|0; //@line 70049 "c/sqlite3.c"
     $69 = ($68|0)!=(0); //@line 70049 "c/sqlite3.c"
     $70 = $67 & $69; //@line 70049 "c/sqlite3.c"
     if ($70) {
      $$04850 = $66;
     } else {
      break;
     }
    }
   }
   $71 = HEAP32[$10>>2]|0; //@line 70059 "c/sqlite3.c"
   $72 = ((($71)) + 28|0); //@line 70059 "c/sqlite3.c"
   HEAP32[$72>>2] = $13; //@line 70059 "c/sqlite3.c"
   $73 = HEAP32[$17>>2]|0; //@line 70063 "c/sqlite3.c"
   $74 = ($73|0)!=(0); //@line 70063 "c/sqlite3.c"
   $75 = HEAP32[$18>>2]|0; //@line 70063 "c/sqlite3.c"
   $76 = ($75|0)!=(0); //@line 70063 "c/sqlite3.c"
   $77 = $74 & $76; //@line 70063 "c/sqlite3.c"
   if ($77) {
    $78 = ((($9)) + 17|0);
    $79 = ((($9)) + 17|0);
    $$149 = 1;
    while(1) {
     $80 = (_getPageReferenced($5,$$149)|0); //@line 70072 "c/sqlite3.c"
     $81 = ($80|0)==(0); //@line 70072 "c/sqlite3.c"
     do {
      if ($81) {
       $82 = (_ptrmapPageno($9,$$149)|0); //@line 70073 "c/sqlite3.c"
       $83 = ($82|0)==($$149|0); //@line 70073 "c/sqlite3.c"
       if ($83) {
        $84 = HEAP8[$78>>0]|0; //@line 70073 "c/sqlite3.c"
        $85 = ($84<<24>>24)==(0); //@line 70073 "c/sqlite3.c"
        if (!($85)) {
         break;
        }
       }
       HEAP32[$vararg_buffer>>2] = $$149; //@line 70074 "c/sqlite3.c"
       _checkAppendMsg($5,34867,$vararg_buffer); //@line 70074 "c/sqlite3.c"
      }
     } while(0);
     $86 = (_getPageReferenced($5,$$149)|0); //@line 70076 "c/sqlite3.c"
     $87 = ($86|0)==(0); //@line 70076 "c/sqlite3.c"
     if (!($87)) {
      $88 = (_ptrmapPageno($9,$$149)|0); //@line 70077 "c/sqlite3.c"
      $89 = ($88|0)==($$149|0); //@line 70077 "c/sqlite3.c"
      if ($89) {
       $90 = HEAP8[$79>>0]|0; //@line 70077 "c/sqlite3.c"
       $91 = ($90<<24>>24)==(0); //@line 70077 "c/sqlite3.c"
       if (!($91)) {
        HEAP32[$vararg_buffer1>>2] = $$149; //@line 70078 "c/sqlite3.c"
        _checkAppendMsg($5,34889,$vararg_buffer1); //@line 70078 "c/sqlite3.c"
       }
      }
     }
     $92 = (($$149) + 1)|0; //@line 70063 "c/sqlite3.c"
     $93 = HEAP32[$17>>2]|0; //@line 70063 "c/sqlite3.c"
     $94 = ($92>>>0)<=($93>>>0); //@line 70063 "c/sqlite3.c"
     $95 = HEAP32[$18>>2]|0; //@line 70063 "c/sqlite3.c"
     $96 = ($95|0)!=(0); //@line 70063 "c/sqlite3.c"
     $97 = $94 & $96; //@line 70063 "c/sqlite3.c"
     if ($97) {
      $$149 = $92;
     } else {
      break;
     }
    }
   }
  }
 } while(0);
 $98 = HEAP32[$23>>2]|0; //@line 70086 "c/sqlite3.c"
 _sqlite3PageFree($98); //@line 70086 "c/sqlite3.c"
 $99 = HEAP32[$22>>2]|0; //@line 70087 "c/sqlite3.c"
 _sqlite3_free($99); //@line 70087 "c/sqlite3.c"
 $100 = HEAP32[$20>>2]|0; //@line 70088 "c/sqlite3.c"
 $101 = ($100|0)==(0); //@line 70088 "c/sqlite3.c"
 if ($101) {
  $$pr = HEAP32[$19>>2]|0; //@line 70092 "c/sqlite3.c"
  $104 = $$pr;
 } else {
  _sqlite3StrAccumReset($24); //@line 70089 "c/sqlite3.c"
  $102 = HEAP32[$19>>2]|0; //@line 70090 "c/sqlite3.c"
  $103 = (($102) + 1)|0; //@line 70090 "c/sqlite3.c"
  HEAP32[$19>>2] = $103; //@line 70090 "c/sqlite3.c"
  $104 = $103;
 }
 HEAP32[$4>>2] = $104; //@line 70092 "c/sqlite3.c"
 $105 = ($104|0)==(0); //@line 70093 "c/sqlite3.c"
 if (!($105)) {
  _sqlite3BtreeLeave($0); //@line 70096 "c/sqlite3.c"
  $106 = (_sqlite3StrAccumFinish($24)|0); //@line 70097 "c/sqlite3.c"
  STACKTOP = sp;return ($106|0); //@line 70097 "c/sqlite3.c"
 }
 _sqlite3StrAccumReset($24); //@line 70093 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 70096 "c/sqlite3.c"
 $106 = (_sqlite3StrAccumFinish($24)|0); //@line 70097 "c/sqlite3.c"
 STACKTOP = sp;return ($106|0); //@line 70097 "c/sqlite3.c"
}
function _sqlite3VdbeMemSetRowSet($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 32|0); //@line 71965 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 71965 "c/sqlite3.c"
 _sqlite3VdbeMemRelease($0); //@line 71968 "c/sqlite3.c"
 $3 = (_sqlite3DbMallocRawNN($2,64,0)|0); //@line 71969 "c/sqlite3.c"
 $4 = ((($0)) + 20|0); //@line 71969 "c/sqlite3.c"
 HEAP32[$4>>2] = $3; //@line 71969 "c/sqlite3.c"
 $5 = ((($2)) + 73|0); //@line 71970 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 71970 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 71970 "c/sqlite3.c"
 if ($7) {
  $10 = (_sqlite3DbMallocSize($2,$3)|0); //@line 71975 "c/sqlite3.c"
  $11 = ((($0)) + 24|0); //@line 71975 "c/sqlite3.c"
  HEAP32[$11>>2] = $10; //@line 71975 "c/sqlite3.c"
  $12 = HEAP32[$4>>2]|0; //@line 71976 "c/sqlite3.c"
  $13 = (_sqlite3RowSetInit($2,$12,$10)|0); //@line 71976 "c/sqlite3.c"
  HEAP32[$0>>2] = $13; //@line 71976 "c/sqlite3.c"
  $14 = ((($0)) + 8|0); //@line 71978 "c/sqlite3.c"
  HEAP16[$14>>1] = 32; //@line 71978 "c/sqlite3.c"
  return; //@line 71980 "c/sqlite3.c"
 } else {
  $8 = ((($0)) + 8|0); //@line 71971 "c/sqlite3.c"
  HEAP16[$8>>1] = 1; //@line 71971 "c/sqlite3.c"
  $9 = ((($0)) + 24|0); //@line 71972 "c/sqlite3.c"
  HEAP32[$9>>2] = 0; //@line 71972 "c/sqlite3.c"
  return; //@line 71980 "c/sqlite3.c"
 }
}
function _sqlite3RowSetInsert($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_rowSetEntryAlloc($0)|0); //@line 47526 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 47527 "c/sqlite3.c"
 if ($4) {
  return; //@line 47542 "c/sqlite3.c"
 }
 $5 = $3; //@line 47528 "c/sqlite3.c"
 $6 = $5; //@line 47528 "c/sqlite3.c"
 HEAP32[$6>>2] = $1; //@line 47528 "c/sqlite3.c"
 $7 = (($5) + 4)|0; //@line 47528 "c/sqlite3.c"
 $8 = $7; //@line 47528 "c/sqlite3.c"
 HEAP32[$8>>2] = $2; //@line 47528 "c/sqlite3.c"
 $9 = ((($3)) + 8|0); //@line 47529 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 47529 "c/sqlite3.c"
 $10 = ((($0)) + 12|0); //@line 47530 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 47530 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 47531 "c/sqlite3.c"
 if ($12) {
  $28 = ((($0)) + 8|0); //@line 47539 "c/sqlite3.c"
  HEAP32[$28>>2] = $3; //@line 47539 "c/sqlite3.c"
 } else {
  $13 = $11; //@line 47532 "c/sqlite3.c"
  $14 = $13; //@line 47532 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 47532 "c/sqlite3.c"
  $16 = (($13) + 4)|0; //@line 47532 "c/sqlite3.c"
  $17 = $16; //@line 47532 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 47532 "c/sqlite3.c"
  $19 = ($18|0)<($2|0); //@line 47532 "c/sqlite3.c"
  $20 = ($15>>>0)<($1>>>0); //@line 47532 "c/sqlite3.c"
  $21 = ($18|0)==($2|0); //@line 47532 "c/sqlite3.c"
  $22 = $21 & $20; //@line 47532 "c/sqlite3.c"
  $23 = $19 | $22; //@line 47532 "c/sqlite3.c"
  if (!($23)) {
   $24 = ((($0)) + 26|0); //@line 47535 "c/sqlite3.c"
   $25 = HEAP16[$24>>1]|0; //@line 47535 "c/sqlite3.c"
   $26 = $25 & -2; //@line 47535 "c/sqlite3.c"
   HEAP16[$24>>1] = $26; //@line 47535 "c/sqlite3.c"
  }
  $27 = ((($11)) + 8|0); //@line 47537 "c/sqlite3.c"
  HEAP32[$27>>2] = $3; //@line 47537 "c/sqlite3.c"
 }
 HEAP32[$10>>2] = $3; //@line 47541 "c/sqlite3.c"
 return; //@line 47542 "c/sqlite3.c"
}
function _sqlite3RowSetNext($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 26|0); //@line 47722 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 47722 "c/sqlite3.c"
 $4 = $3&65535; //@line 47722 "c/sqlite3.c"
 $5 = $4 & 2; //@line 47722 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 47722 "c/sqlite3.c"
 if ($6) {
  $7 = $4 & 1; //@line 47723 "c/sqlite3.c"
  $8 = ($7|0)==(0); //@line 47723 "c/sqlite3.c"
  if ($8) {
   $9 = ((($0)) + 8|0); //@line 47724 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 47724 "c/sqlite3.c"
   $11 = (_rowSetEntrySort($10)|0); //@line 47724 "c/sqlite3.c"
   HEAP32[$9>>2] = $11; //@line 47724 "c/sqlite3.c"
  }
  $12 = HEAP16[$2>>1]|0; //@line 47726 "c/sqlite3.c"
  $13 = $12 | 3; //@line 47726 "c/sqlite3.c"
  HEAP16[$2>>1] = $13; //@line 47726 "c/sqlite3.c"
 }
 $14 = ((($0)) + 8|0); //@line 47730 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 47730 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 47730 "c/sqlite3.c"
 if ($16) {
  $$0 = 0;
  return ($$0|0); //@line 47741 "c/sqlite3.c"
 }
 $17 = $15; //@line 47731 "c/sqlite3.c"
 $18 = $17; //@line 47731 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 47731 "c/sqlite3.c"
 $20 = (($17) + 4)|0; //@line 47731 "c/sqlite3.c"
 $21 = $20; //@line 47731 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 47731 "c/sqlite3.c"
 $23 = $1; //@line 47731 "c/sqlite3.c"
 $24 = $23; //@line 47731 "c/sqlite3.c"
 HEAP32[$24>>2] = $19; //@line 47731 "c/sqlite3.c"
 $25 = (($23) + 4)|0; //@line 47731 "c/sqlite3.c"
 $26 = $25; //@line 47731 "c/sqlite3.c"
 HEAP32[$26>>2] = $22; //@line 47731 "c/sqlite3.c"
 $27 = ((($15)) + 8|0); //@line 47732 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 47732 "c/sqlite3.c"
 HEAP32[$14>>2] = $28; //@line 47732 "c/sqlite3.c"
 $29 = ($28|0)==(0|0); //@line 47733 "c/sqlite3.c"
 if (!($29)) {
  $$0 = 1;
  return ($$0|0); //@line 47741 "c/sqlite3.c"
 }
 _sqlite3RowSetClear($0); //@line 47735 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 47741 "c/sqlite3.c"
}
function _sqlite3RowSetTest($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$045 = 0, $$045$in$lcssa = 0, $$04560 = 0, $$04562 = 0, $$047 = 0, $$049 = 0, $$146 = 0, $$14656 = 0, $$14657 = 0, $$148$lcssa = 0, $$14861 = 0, $$2 = 0, $$254 = 0, $$255 = 0, $$3$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 4|0;
 $5 = sp;
 $6 = ((($0)) + 28|0); //@line 47760 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 47760 "c/sqlite3.c"
 $8 = ($7|0)==($1|0); //@line 47760 "c/sqlite3.c"
 if (!($8)) {
  $9 = ((($0)) + 8|0); //@line 47761 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 47761 "c/sqlite3.c"
  $11 = ($10|0)==(0|0); //@line 47762 "c/sqlite3.c"
  if (!($11)) {
   $12 = ((($0)) + 20|0); //@line 47763 "c/sqlite3.c"
   $13 = ((($0)) + 26|0); //@line 47764 "c/sqlite3.c"
   $14 = HEAP16[$13>>1]|0; //@line 47764 "c/sqlite3.c"
   $15 = $14 & 1; //@line 47764 "c/sqlite3.c"
   $16 = ($15<<16>>16)==(0); //@line 47764 "c/sqlite3.c"
   if ($16) {
    $17 = (_rowSetEntrySort($10)|0); //@line 47766 "c/sqlite3.c"
    $$047 = $17;
   } else {
    $$047 = $10;
   }
   $$04560 = HEAP32[$12>>2]|0;
   $18 = ($$04560|0)==(0|0); //@line 47768 "c/sqlite3.c"
   do {
    if ($18) {
     $$045$in$lcssa = $12;$$148$lcssa = $$047;
     label = 11;
    } else {
     $$04562 = $$04560;$$14861 = $$047;
     while(1) {
      $19 = ((($$04562)) + 12|0); //@line 47770 "c/sqlite3.c"
      $20 = HEAP32[$19>>2]|0; //@line 47770 "c/sqlite3.c"
      $21 = ($20|0)==(0|0); //@line 47770 "c/sqlite3.c"
      if ($21) {
       label = 9;
       break;
      }
      $22 = ((($$04562)) + 8|0); //@line 47769 "c/sqlite3.c"
      _rowSetTreeToList($20,$4,$5); //@line 47775 "c/sqlite3.c"
      HEAP32[$19>>2] = 0; //@line 47776 "c/sqlite3.c"
      $23 = HEAP32[$4>>2]|0; //@line 47777 "c/sqlite3.c"
      $24 = (_rowSetEntryMerge($23,$$14861)|0); //@line 47777 "c/sqlite3.c"
      $$045 = HEAP32[$22>>2]|0;
      $25 = ($$045|0)==(0|0); //@line 47768 "c/sqlite3.c"
      if ($25) {
       label = 10;
       break;
      } else {
       $$04562 = $$045;$$14861 = $24;
      }
     }
     if ((label|0) == 9) {
      $26 = (_rowSetListToTree($$14861)|0); //@line 47771 "c/sqlite3.c"
      HEAP32[$19>>2] = $26; //@line 47771 "c/sqlite3.c"
      break;
     }
     else if ((label|0) == 10) {
      $27 = ((($$04562)) + 8|0); //@line 47769 "c/sqlite3.c"
      $$045$in$lcssa = $27;$$148$lcssa = $24;
      label = 11;
      break;
     }
    }
   } while(0);
   if ((label|0) == 11) {
    $28 = (_rowSetEntryAlloc($0)|0); //@line 47781 "c/sqlite3.c"
    HEAP32[$$045$in$lcssa>>2] = $28; //@line 47781 "c/sqlite3.c"
    $29 = ($28|0)==(0|0); //@line 47782 "c/sqlite3.c"
    if (!($29)) {
     $30 = $28; //@line 47783 "c/sqlite3.c"
     $31 = $30; //@line 47783 "c/sqlite3.c"
     HEAP32[$31>>2] = 0; //@line 47783 "c/sqlite3.c"
     $32 = (($30) + 4)|0; //@line 47783 "c/sqlite3.c"
     $33 = $32; //@line 47783 "c/sqlite3.c"
     HEAP32[$33>>2] = 0; //@line 47783 "c/sqlite3.c"
     $34 = ((($28)) + 8|0); //@line 47784 "c/sqlite3.c"
     HEAP32[$34>>2] = 0; //@line 47784 "c/sqlite3.c"
     $35 = (_rowSetListToTree($$148$lcssa)|0); //@line 47785 "c/sqlite3.c"
     $36 = ((($28)) + 12|0); //@line 47785 "c/sqlite3.c"
     HEAP32[$36>>2] = $35; //@line 47785 "c/sqlite3.c"
    }
   }
   HEAP32[$9>>2] = 0; //@line 47788 "c/sqlite3.c"
   $37 = ((($0)) + 12|0); //@line 47789 "c/sqlite3.c"
   HEAP32[$37>>2] = 0; //@line 47789 "c/sqlite3.c"
   $38 = HEAP16[$13>>1]|0; //@line 47790 "c/sqlite3.c"
   $39 = $38 | 1; //@line 47790 "c/sqlite3.c"
   HEAP16[$13>>1] = $39; //@line 47790 "c/sqlite3.c"
  }
  HEAP32[$6>>2] = $1; //@line 47792 "c/sqlite3.c"
 }
 $40 = ((($0)) + 20|0); //@line 47798 "c/sqlite3.c"
 $$14656 = HEAP32[$40>>2]|0;
 $41 = ($$14656|0)==(0|0); //@line 47798 "c/sqlite3.c"
 if ($41) {
  $$049 = 0;
  STACKTOP = sp;return ($$049|0); //@line 47811 "c/sqlite3.c"
 }
 $$14657 = $$14656;
 L25: while(1) {
  $42 = ((($$14657)) + 12|0); //@line 47799 "c/sqlite3.c"
  $$254 = HEAP32[$42>>2]|0;
  $43 = ($$254|0)==(0|0); //@line 47800 "c/sqlite3.c"
  if (!($43)) {
   $$255 = $$254;
   while(1) {
    $44 = $$255; //@line 47801 "c/sqlite3.c"
    $45 = $44; //@line 47801 "c/sqlite3.c"
    $46 = HEAP32[$45>>2]|0; //@line 47801 "c/sqlite3.c"
    $47 = (($44) + 4)|0; //@line 47801 "c/sqlite3.c"
    $48 = $47; //@line 47801 "c/sqlite3.c"
    $49 = HEAP32[$48>>2]|0; //@line 47801 "c/sqlite3.c"
    $50 = ($49|0)<($3|0); //@line 47801 "c/sqlite3.c"
    $51 = ($46>>>0)<($2>>>0); //@line 47801 "c/sqlite3.c"
    $52 = ($49|0)==($3|0); //@line 47801 "c/sqlite3.c"
    $53 = $52 & $51; //@line 47801 "c/sqlite3.c"
    $54 = $50 | $53; //@line 47801 "c/sqlite3.c"
    if ($54) {
     $55 = ((($$255)) + 8|0); //@line 47802 "c/sqlite3.c"
     $$3$in = $55;
    } else {
     $56 = ($49|0)>($3|0); //@line 47803 "c/sqlite3.c"
     $57 = ($46>>>0)>($2>>>0); //@line 47803 "c/sqlite3.c"
     $58 = ($49|0)==($3|0); //@line 47803 "c/sqlite3.c"
     $59 = $58 & $57; //@line 47803 "c/sqlite3.c"
     $60 = $56 | $59; //@line 47803 "c/sqlite3.c"
     if (!($60)) {
      $$049 = 1;
      label = 25;
      break L25;
     }
     $61 = ((($$255)) + 12|0); //@line 47804 "c/sqlite3.c"
     $$3$in = $61;
    }
    $$2 = HEAP32[$$3$in>>2]|0;
    $62 = ($$2|0)==(0|0); //@line 47800 "c/sqlite3.c"
    if ($62) {
     break;
    } else {
     $$255 = $$2;
    }
   }
  }
  $63 = ((($$14657)) + 8|0); //@line 47798 "c/sqlite3.c"
  $$146 = HEAP32[$63>>2]|0;
  $64 = ($$146|0)==(0|0); //@line 47798 "c/sqlite3.c"
  if ($64) {
   $$049 = 0;
   label = 25;
   break;
  } else {
   $$14657 = $$146;
  }
 }
 if ((label|0) == 25) {
  STACKTOP = sp;return ($$049|0); //@line 47811 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3PagerOkToChangeJournalMode($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 55313 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 55313 "c/sqlite3.c"
 $3 = ($2&255)>(2); //@line 55313 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  return ($$0|0); //@line 55316 "c/sqlite3.c"
 }
 $4 = ((($0)) + 64|0); //@line 55314 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 55314 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 55314 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 55314 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($0)) + 72|0); //@line 55314 "c/sqlite3.c"
  $9 = $8; //@line 55314 "c/sqlite3.c"
  $10 = $9; //@line 55314 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 55314 "c/sqlite3.c"
  $12 = (($9) + 4)|0; //@line 55314 "c/sqlite3.c"
  $13 = $12; //@line 55314 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 55314 "c/sqlite3.c"
  $15 = ($14|0)>(0); //@line 55314 "c/sqlite3.c"
  $16 = ($11>>>0)>(0); //@line 55314 "c/sqlite3.c"
  $17 = ($14|0)==(0); //@line 55314 "c/sqlite3.c"
  $18 = $17 & $16; //@line 55314 "c/sqlite3.c"
  $19 = $15 | $18; //@line 55314 "c/sqlite3.c"
  if ($19) {
   $$0 = 0;
   return ($$0|0); //@line 55316 "c/sqlite3.c"
  }
 }
 $$0 = 1;
 return ($$0|0); //@line 55316 "c/sqlite3.c"
}
function _sqlite3PagerCloseWal($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $$3 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 212|0); //@line 55511 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 55511 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 55511 "c/sqlite3.c"
 if ($5) {
  HEAP32[$2>>2] = 0; //@line 55512 "c/sqlite3.c"
  $6 = (_pagerLockDb($0,1)|0); //@line 55513 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 55514 "c/sqlite3.c"
  if (!($7)) {
   $$3 = $6;
   STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
  }
  $8 = HEAP32[$0>>2]|0; //@line 55516 "c/sqlite3.c"
  $9 = ((($0)) + 216|0); //@line 55516 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 55516 "c/sqlite3.c"
  $11 = (_sqlite3OsAccess($8,$10,0,$2)|0); //@line 55515 "c/sqlite3.c"
  $12 = ($11|0)==(0); //@line 55519 "c/sqlite3.c"
  $13 = HEAP32[$2>>2]|0; //@line 55519 "c/sqlite3.c"
  $14 = ($13|0)!=(0); //@line 55519 "c/sqlite3.c"
  $or$cond = $12 & $14; //@line 55519 "c/sqlite3.c"
  if ($or$cond) {
   $15 = (_pagerOpenWal($0)|0); //@line 55520 "c/sqlite3.c"
   $$1 = $15;
  } else {
   $$1 = $11;
  }
  $16 = ($$1|0)==(0); //@line 55527 "c/sqlite3.c"
  if (!($16)) {
   $$3 = $$1;
   STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
  }
  $$pr = HEAP32[$3>>2]|0; //@line 55527 "c/sqlite3.c"
  $17 = ($$pr|0)==(0|0); //@line 55527 "c/sqlite3.c"
  if ($17) {
   $$3 = 0;
   STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
  }
 }
 $18 = (_pagerExclusiveLock($0)|0); //@line 55528 "c/sqlite3.c"
 $19 = ($18|0)==(0); //@line 55529 "c/sqlite3.c"
 if (!($19)) {
  $$3 = $18;
  STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
 }
 $20 = HEAP32[$3>>2]|0; //@line 55530 "c/sqlite3.c"
 $21 = ((($0)) + 11|0); //@line 55530 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 55530 "c/sqlite3.c"
 $23 = $22&255; //@line 55530 "c/sqlite3.c"
 $24 = ((($0)) + 152|0); //@line 55531 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 55531 "c/sqlite3.c"
 $26 = ((($0)) + 204|0); //@line 55531 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 55531 "c/sqlite3.c"
 $28 = (_sqlite3WalClose($20,$1,$23,$25,$27)|0); //@line 55530 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 55532 "c/sqlite3.c"
 $29 = ($28|0)==(0); //@line 55534 "c/sqlite3.c"
 if ($29) {
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
 }
 $30 = ((($0)) + 4|0); //@line 55534 "c/sqlite3.c"
 $31 = HEAP8[$30>>0]|0; //@line 55534 "c/sqlite3.c"
 $32 = ($31<<24>>24)==(0); //@line 55534 "c/sqlite3.c"
 if (!($32)) {
  $$3 = $28;
  STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
 }
 (_pagerUnlockDb($0,1)|0); //@line 55534 "c/sqlite3.c"
 $$3 = $28;
 STACKTOP = sp;return ($$3|0); //@line 55537 "c/sqlite3.c"
}
function _sqlite3PagerSetJournalMode($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$037 = 0, $$1 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, $or$cond40 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 5|0); //@line 55205 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 55205 "c/sqlite3.c"
 $4 = ((($0)) + 15|0); //@line 55231 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 55231 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 55231 "c/sqlite3.c"
 if ($6) {
  label = 3;
 } else {
  switch ($1|0) {
  case 2: case 4:  {
   label = 3;
   break;
  }
  default: {
  }
  }
 }
 do {
  if ((label|0) == 3) {
   $7 = $3&255; //@line 55238 "c/sqlite3.c"
   $8 = ($7|0)==($1|0); //@line 55238 "c/sqlite3.c"
   if (!($8)) {
    $9 = $1&255; //@line 55242 "c/sqlite3.c"
    HEAP8[$2>>0] = $9; //@line 55242 "c/sqlite3.c"
    $10 = ((($0)) + 4|0); //@line 55256 "c/sqlite3.c"
    $11 = HEAP8[$10>>0]|0; //@line 55256 "c/sqlite3.c"
    $12 = ($11<<24>>24)==(0); //@line 55256 "c/sqlite3.c"
    $13 = $7 & 5; //@line 55256 "c/sqlite3.c"
    $14 = ($13|0)==(1); //@line 55256 "c/sqlite3.c"
    $or$cond = $14 & $12; //@line 55256 "c/sqlite3.c"
    $15 = $1 & 1; //@line 55256 "c/sqlite3.c"
    $16 = ($15|0)==(0); //@line 55256 "c/sqlite3.c"
    $or$cond40 = $16 & $or$cond; //@line 55256 "c/sqlite3.c"
    if (!($or$cond40)) {
     $37 = ($1|0)==(2); //@line 55290 "c/sqlite3.c"
     if (!($37)) {
      break;
     }
     $38 = ((($0)) + 64|0); //@line 55291 "c/sqlite3.c"
     $39 = HEAP32[$38>>2]|0; //@line 55291 "c/sqlite3.c"
     _sqlite3OsClose($39); //@line 55291 "c/sqlite3.c"
     break;
    }
    $17 = ((($0)) + 64|0); //@line 55266 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 55266 "c/sqlite3.c"
    _sqlite3OsClose($18); //@line 55266 "c/sqlite3.c"
    $19 = ((($0)) + 17|0); //@line 55267 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 55267 "c/sqlite3.c"
    $21 = ($20&255)>(1); //@line 55267 "c/sqlite3.c"
    if ($21) {
     $22 = HEAP32[$0>>2]|0; //@line 55268 "c/sqlite3.c"
     $23 = ((($0)) + 172|0); //@line 55268 "c/sqlite3.c"
     $24 = HEAP32[$23>>2]|0; //@line 55268 "c/sqlite3.c"
     (_sqlite3OsDelete($22,$24,0)|0); //@line 55268 "c/sqlite3.c"
     break;
    }
    $25 = ((($0)) + 16|0); //@line 55271 "c/sqlite3.c"
    $26 = HEAP8[$25>>0]|0; //@line 55271 "c/sqlite3.c"
    $27 = ($26<<24>>24)==(0); //@line 55273 "c/sqlite3.c"
    if ($27) {
     $28 = (_sqlite3PagerSharedLock($0)|0); //@line 55274 "c/sqlite3.c"
     $$pr = HEAP8[$25>>0]|0; //@line 55276 "c/sqlite3.c"
     $$037 = $28;$30 = $$pr;
    } else {
     $$037 = 0;$30 = $26;
    }
    $29 = ($30<<24>>24)==(1); //@line 55276 "c/sqlite3.c"
    if ($29) {
     $31 = (_pagerLockDb($0,2)|0); //@line 55278 "c/sqlite3.c"
     $$1 = $31;
    } else {
     $$1 = $$037;
    }
    $32 = ($$1|0)==(0); //@line 55280 "c/sqlite3.c"
    if ($32) {
     $33 = HEAP32[$0>>2]|0; //@line 55281 "c/sqlite3.c"
     $34 = ((($0)) + 172|0); //@line 55281 "c/sqlite3.c"
     $35 = HEAP32[$34>>2]|0; //@line 55281 "c/sqlite3.c"
     (_sqlite3OsDelete($33,$35,0)|0); //@line 55281 "c/sqlite3.c"
     $36 = ($26<<24>>24)==(1); //@line 55283 "c/sqlite3.c"
     $or$cond3 = $36 & $32; //@line 55283 "c/sqlite3.c"
     if ($or$cond3) {
      (_pagerUnlockDb($0,1)|0); //@line 55284 "c/sqlite3.c"
      break;
     }
    }
    if ($27) {
     _pager_unlock($0); //@line 55286 "c/sqlite3.c"
    }
   }
  }
 } while(0);
 $40 = HEAP8[$2>>0]|0; //@line 55296 "c/sqlite3.c"
 $41 = $40&255; //@line 55296 "c/sqlite3.c"
 return ($41|0); //@line 55296 "c/sqlite3.c"
}
function _sqlite3BtreeSetVersion($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 70317 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 70317 "c/sqlite3.c"
 $4 = ((($3)) + 22|0); //@line 70325 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 70325 "c/sqlite3.c"
 $6 = $5 & -33; //@line 70325 "c/sqlite3.c"
 $7 = ($1|0)==(1); //@line 70326 "c/sqlite3.c"
 $8 = $5 | 32; //@line 70326 "c/sqlite3.c"
 $spec$select = $7 ? $8 : $6; //@line 70326 "c/sqlite3.c"
 HEAP16[$4>>1] = $spec$select;
 $9 = (_sqlite3BtreeBeginTrans($0,0)|0); //@line 70328 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 70329 "c/sqlite3.c"
 do {
  if ($10) {
   $11 = ((($3)) + 12|0); //@line 70330 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 70330 "c/sqlite3.c"
   $13 = ((($12)) + 56|0); //@line 70330 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 70330 "c/sqlite3.c"
   $15 = ((($14)) + 18|0); //@line 70331 "c/sqlite3.c"
   $16 = HEAP8[$15>>0]|0; //@line 70331 "c/sqlite3.c"
   $17 = $1&255; //@line 70331 "c/sqlite3.c"
   $18 = ($16<<24>>24)==($17<<24>>24); //@line 70331 "c/sqlite3.c"
   if ($18) {
    $19 = ((($14)) + 19|0); //@line 70331 "c/sqlite3.c"
    $20 = HEAP8[$19>>0]|0; //@line 70331 "c/sqlite3.c"
    $21 = ($20<<24>>24)==($17<<24>>24); //@line 70331 "c/sqlite3.c"
    if ($21) {
     $$1 = 0;
     break;
    }
   }
   $22 = (_sqlite3BtreeBeginTrans($0,2)|0); //@line 70332 "c/sqlite3.c"
   $23 = ($22|0)==(0); //@line 70333 "c/sqlite3.c"
   if ($23) {
    $24 = HEAP32[$11>>2]|0; //@line 70334 "c/sqlite3.c"
    $25 = ((($24)) + 72|0); //@line 70334 "c/sqlite3.c"
    $26 = HEAP32[$25>>2]|0; //@line 70334 "c/sqlite3.c"
    $27 = (_sqlite3PagerWrite($26)|0); //@line 70334 "c/sqlite3.c"
    $28 = ($27|0)==(0); //@line 70335 "c/sqlite3.c"
    if ($28) {
     HEAP8[$15>>0] = $17; //@line 70336 "c/sqlite3.c"
     $29 = ((($14)) + 19|0); //@line 70337 "c/sqlite3.c"
     HEAP8[$29>>0] = $17; //@line 70337 "c/sqlite3.c"
     $$1 = 0;
    } else {
     $$1 = $27;
    }
   } else {
    $$1 = $22;
   }
  } else {
   $$1 = $9;
  }
 } while(0);
 $30 = HEAP16[$4>>1]|0; //@line 70343 "c/sqlite3.c"
 $31 = $30 & -33; //@line 70343 "c/sqlite3.c"
 HEAP16[$4>>1] = $31; //@line 70343 "c/sqlite3.c"
 return ($$1|0); //@line 70344 "c/sqlite3.c"
}
function _sqlite3RunVacuum($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0137 = 0, $$0138$ph = 0, $$0139 = 0, $$1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $12 = 0, $13 = 0, $14 = 0;
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0;
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0;
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0;
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0;
 var $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer7 = sp + 24|0;
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = ((($1)) + 71|0); //@line 127129 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 127129 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 127129 "c/sqlite3.c"
 if ($5) {
  _sqlite3SetString($0,$1,34285); //@line 127130 "c/sqlite3.c"
  $$0137 = 1;
  STACKTOP = sp;return ($$0137|0); //@line 127354 "c/sqlite3.c"
 }
 $6 = ((($1)) + 160|0); //@line 127133 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 127133 "c/sqlite3.c"
 $8 = ($7|0)>(1); //@line 127133 "c/sqlite3.c"
 if ($8) {
  _sqlite3SetString($0,$1,34325); //@line 127134 "c/sqlite3.c"
  $$0137 = 1;
  STACKTOP = sp;return ($$0137|0); //@line 127354 "c/sqlite3.c"
 }
 $9 = ((($1)) + 28|0); //@line 127141 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 127141 "c/sqlite3.c"
 $11 = ((($1)) + 24|0); //@line 127142 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 127142 "c/sqlite3.c"
 $13 = ((($1)) + 92|0); //@line 127143 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 127143 "c/sqlite3.c"
 $15 = ((($1)) + 96|0); //@line 127144 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 127144 "c/sqlite3.c"
 $17 = ((($1)) + 80|0); //@line 127145 "c/sqlite3.c"
 $18 = HEAP8[$17>>0]|0; //@line 127145 "c/sqlite3.c"
 $19 = $12 | 6; //@line 127147 "c/sqlite3.c"
 HEAP32[$11>>2] = $19; //@line 127147 "c/sqlite3.c"
 $20 = $10 & -21122; //@line 127148 "c/sqlite3.c"
 $21 = $20 | 513; //@line 127148 "c/sqlite3.c"
 HEAP32[$9>>2] = $21; //@line 127148 "c/sqlite3.c"
 HEAP8[$17>>0] = 0; //@line 127149 "c/sqlite3.c"
 $22 = ((($1)) + 16|0); //@line 127151 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 127151 "c/sqlite3.c"
 $24 = (($23) + ($2<<4)|0); //@line 127151 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 127151 "c/sqlite3.c"
 $26 = (((($23) + ($2<<4)|0)) + 4|0); //@line 127152 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 127152 "c/sqlite3.c"
 $28 = (_sqlite3BtreePager($27)|0); //@line 127153 "c/sqlite3.c"
 $29 = (_sqlite3PagerIsMemdb($28)|0); //@line 127153 "c/sqlite3.c"
 $30 = ((($1)) + 20|0); //@line 127169 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 127169 "c/sqlite3.c"
 $32 = (_execSql($1,$0,34368)|0); //@line 127170 "c/sqlite3.c"
 $33 = ($32|0)==(0); //@line 127171 "c/sqlite3.c"
 L9: do {
  if ($33) {
   $34 = HEAP32[$22>>2]|0; //@line 127173 "c/sqlite3.c"
   $35 = (($34) + ($31<<4)|0); //@line 127173 "c/sqlite3.c"
   $36 = (((($34) + ($31<<4)|0)) + 4|0); //@line 127175 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 127175 "c/sqlite3.c"
   (_sqlite3BtreeCommit($37)|0); //@line 127181 "c/sqlite3.c"
   $38 = (_sqlite3BtreeGetOptimalReserve($27)|0); //@line 127183 "c/sqlite3.c"
   $39 = HEAP32[$22>>2]|0; //@line 127196 "c/sqlite3.c"
   $40 = (((($39) + ($2<<4)|0)) + 12|0); //@line 127196 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 127196 "c/sqlite3.c"
   $42 = ((($41)) + 80|0); //@line 127196 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 127196 "c/sqlite3.c"
   _sqlite3BtreeSetCacheSize($37,$43); //@line 127196 "c/sqlite3.c"
   $44 = (_sqlite3BtreeSetSpillSize($27,0)|0); //@line 127197 "c/sqlite3.c"
   (_sqlite3BtreeSetSpillSize($37,$44)|0); //@line 127197 "c/sqlite3.c"
   _sqlite3BtreeSetPagerFlags($37,33); //@line 127198 "c/sqlite3.c"
   $45 = (_execSql($1,$0,31285)|0); //@line 127204 "c/sqlite3.c"
   $46 = ($45|0)==(0); //@line 127205 "c/sqlite3.c"
   if ($46) {
    $47 = (_sqlite3BtreeBeginTrans($27,2)|0); //@line 127206 "c/sqlite3.c"
    $48 = ($47|0)==(0); //@line 127207 "c/sqlite3.c"
    if ($48) {
     $49 = (_sqlite3BtreePager($27)|0); //@line 127210 "c/sqlite3.c"
     $50 = (_sqlite3PagerGetJournalMode($49)|0); //@line 127210 "c/sqlite3.c"
     $51 = ($50|0)==(5); //@line 127211 "c/sqlite3.c"
     if ($51) {
      $52 = ((($1)) + 84|0); //@line 127212 "c/sqlite3.c"
      HEAP32[$52>>2] = 0; //@line 127212 "c/sqlite3.c"
     }
     $53 = (_sqlite3BtreeGetPageSize($27)|0); //@line 127215 "c/sqlite3.c"
     $54 = (_sqlite3BtreeSetPageSize($37,$53,$38,0)|0); //@line 127215 "c/sqlite3.c"
     $55 = ($54|0)==(0); //@line 127215 "c/sqlite3.c"
     if ($55) {
      $56 = ($29|0)==(0); //@line 127216 "c/sqlite3.c"
      if ($56) {
       $57 = ((($1)) + 84|0); //@line 127216 "c/sqlite3.c"
       $58 = HEAP32[$57>>2]|0; //@line 127216 "c/sqlite3.c"
       $59 = (_sqlite3BtreeSetPageSize($37,$58,$38,0)|0); //@line 127216 "c/sqlite3.c"
       $60 = ($59|0)==(0); //@line 127216 "c/sqlite3.c"
       if (!($60)) {
        $$0139 = $35;$$1 = 7;
        break;
       }
      }
      $61 = ((($1)) + 73|0); //@line 127217 "c/sqlite3.c"
      $62 = HEAP8[$61>>0]|0; //@line 127217 "c/sqlite3.c"
      $63 = ($62<<24>>24)==(0); //@line 127217 "c/sqlite3.c"
      if ($63) {
       $64 = ((($1)) + 76|0); //@line 127224 "c/sqlite3.c"
       $65 = HEAP8[$64>>0]|0; //@line 127224 "c/sqlite3.c"
       $66 = ($65<<24>>24)>(-1); //@line 127224 "c/sqlite3.c"
       if ($66) {
        $67 = $65 << 24 >> 24; //@line 127224 "c/sqlite3.c"
        $69 = $67;
       } else {
        $68 = (_sqlite3BtreeGetAutoVacuum($27)|0); //@line 127225 "c/sqlite3.c"
        $69 = $68;
       }
       (_sqlite3BtreeSetAutoVacuum($37,$69)|0); //@line 127224 "c/sqlite3.c"
       $70 = $31&255; //@line 127231 "c/sqlite3.c"
       $71 = ((($1)) + 156|0); //@line 127231 "c/sqlite3.c"
       HEAP8[$71>>0] = $70; //@line 127231 "c/sqlite3.c"
       HEAP32[$vararg_buffer>>2] = $25; //@line 127232 "c/sqlite3.c"
       $72 = (_execSqlF($1,$0,34389,$vararg_buffer)|0); //@line 127232 "c/sqlite3.c"
       $73 = ($72|0)==(0); //@line 127238 "c/sqlite3.c"
       if ($73) {
        HEAP32[$vararg_buffer1>>2] = $25; //@line 127239 "c/sqlite3.c"
        $74 = (_execSqlF($1,$0,34497,$vararg_buffer1)|0); //@line 127239 "c/sqlite3.c"
        $75 = ($74|0)==(0); //@line 127244 "c/sqlite3.c"
        if ($75) {
         HEAP8[$71>>0] = 0; //@line 127245 "c/sqlite3.c"
         HEAP32[$vararg_buffer4>>2] = $25; //@line 127251 "c/sqlite3.c"
         $76 = (_execSqlF($1,$0,34570,$vararg_buffer4)|0); //@line 127251 "c/sqlite3.c"
         $77 = HEAP32[$11>>2]|0; //@line 127259 "c/sqlite3.c"
         $78 = $77 & -5; //@line 127259 "c/sqlite3.c"
         HEAP32[$11>>2] = $78; //@line 127259 "c/sqlite3.c"
         $79 = ($76|0)==(0); //@line 127260 "c/sqlite3.c"
         if ($79) {
          HEAP32[$vararg_buffer7>>2] = $25; //@line 127267 "c/sqlite3.c"
          $80 = (_execSqlF($1,$0,34721,$vararg_buffer7)|0); //@line 127267 "c/sqlite3.c"
          $81 = ($80|0)==(0); //@line 127274 "c/sqlite3.c"
          if ($81) {
           _sqlite3BtreeGetMeta($27,1,$vararg_buffer7); //@line 127307 "c/sqlite3.c"
           $85 = HEAP32[$vararg_buffer7>>2]|0; //@line 127308 "c/sqlite3.c"
           $86 = (($85) + 1)|0; //@line 127308 "c/sqlite3.c"
           $87 = (_sqlite3BtreeUpdateMeta($37,1,$86)|0); //@line 127308 "c/sqlite3.c"
           $88 = ($87|0)==(0); //@line 127309 "c/sqlite3.c"
           do {
            if ($88) {
             _sqlite3BtreeGetMeta($27,3,$vararg_buffer7); //@line 127307 "c/sqlite3.c"
             $82 = HEAP32[$vararg_buffer7>>2]|0; //@line 127308 "c/sqlite3.c"
             $83 = (_sqlite3BtreeUpdateMeta($37,3,$82)|0); //@line 127308 "c/sqlite3.c"
             $84 = ($83|0)==(0); //@line 127309 "c/sqlite3.c"
             if ($84) {
              _sqlite3BtreeGetMeta($27,5,$vararg_buffer7); //@line 127307 "c/sqlite3.c"
              $100 = HEAP32[$vararg_buffer7>>2]|0; //@line 127308 "c/sqlite3.c"
              $101 = (_sqlite3BtreeUpdateMeta($37,5,$100)|0); //@line 127308 "c/sqlite3.c"
              $102 = ($101|0)==(0); //@line 127309 "c/sqlite3.c"
              if ($102) {
               _sqlite3BtreeGetMeta($27,6,$vararg_buffer7); //@line 127307 "c/sqlite3.c"
               $103 = HEAP32[$vararg_buffer7>>2]|0; //@line 127308 "c/sqlite3.c"
               $104 = (_sqlite3BtreeUpdateMeta($37,6,$103)|0); //@line 127308 "c/sqlite3.c"
               $105 = ($104|0)==(0); //@line 127309 "c/sqlite3.c"
               if ($105) {
                _sqlite3BtreeGetMeta($27,8,$vararg_buffer7); //@line 127307 "c/sqlite3.c"
                $106 = HEAP32[$vararg_buffer7>>2]|0; //@line 127308 "c/sqlite3.c"
                $107 = (_sqlite3BtreeUpdateMeta($37,8,$106)|0); //@line 127308 "c/sqlite3.c"
                $108 = ($107|0)==(0); //@line 127309 "c/sqlite3.c"
                if (!($108)) {
                 $$0138$ph = $107;
                 break;
                }
                $109 = (_sqlite3BtreeCopyFile($27,$37)|0); //@line 127312 "c/sqlite3.c"
                $110 = ($109|0)==(0); //@line 127313 "c/sqlite3.c"
                if (!($110)) {
                 $$0138$ph = $109;
                 break;
                }
                $89 = (_sqlite3BtreeCommit($37)|0); //@line 127314 "c/sqlite3.c"
                $90 = ($89|0)==(0); //@line 127315 "c/sqlite3.c"
                if (!($90)) {
                 $$0138$ph = $89;
                 break;
                }
                $91 = (_sqlite3BtreeGetAutoVacuum($37)|0); //@line 127317 "c/sqlite3.c"
                (_sqlite3BtreeSetAutoVacuum($27,$91)|0); //@line 127317 "c/sqlite3.c"
                $92 = (_sqlite3BtreeGetPageSize($37)|0); //@line 127322 "c/sqlite3.c"
                $93 = (_sqlite3BtreeSetPageSize($27,$92,$38,1)|0); //@line 127322 "c/sqlite3.c"
                $$0139 = $35;$$1 = $93;
                break L9;
               } else {
                $$0138$ph = $104;
               }
              } else {
               $$0138$ph = $101;
              }
             } else {
              $$0138$ph = $83;
             }
            } else {
             $$0138$ph = $87;
            }
           } while(0);
           $$0139 = $35;$$1 = $$0138$ph;
          } else {
           $$0139 = $35;$$1 = $80;
          }
         } else {
          $$0139 = $35;$$1 = $76;
         }
        } else {
         $$0139 = $35;$$1 = $74;
        }
       } else {
        $$0139 = $35;$$1 = $72;
       }
      } else {
       $$0139 = $35;$$1 = 7;
      }
     } else {
      $$0139 = $35;$$1 = 7;
     }
    } else {
     $$0139 = $35;$$1 = $47;
    }
   } else {
    $$0139 = $35;$$1 = $45;
   }
  } else {
   $$0139 = 0;$$1 = $32;
  }
 } while(0);
 $94 = ((($1)) + 156|0); //@line 127326 "c/sqlite3.c"
 HEAP8[$94>>0] = 0; //@line 127326 "c/sqlite3.c"
 $95 = $12 & 65535; //@line 127327 "c/sqlite3.c"
 HEAP32[$11>>2] = $95; //@line 127327 "c/sqlite3.c"
 HEAP32[$9>>2] = $10; //@line 127328 "c/sqlite3.c"
 HEAP32[$13>>2] = $14; //@line 127329 "c/sqlite3.c"
 HEAP32[$15>>2] = $16; //@line 127330 "c/sqlite3.c"
 HEAP8[$17>>0] = $18; //@line 127331 "c/sqlite3.c"
 (_sqlite3BtreeSetPageSize($27,-1,-1,1)|0); //@line 127332 "c/sqlite3.c"
 HEAP8[$3>>0] = 1; //@line 127341 "c/sqlite3.c"
 $96 = ($$0139|0)==(0|0); //@line 127343 "c/sqlite3.c"
 if (!($96)) {
  $97 = ((($$0139)) + 4|0); //@line 127344 "c/sqlite3.c"
  $98 = HEAP32[$97>>2]|0; //@line 127344 "c/sqlite3.c"
  _sqlite3BtreeClose($98); //@line 127344 "c/sqlite3.c"
  HEAP32[$97>>2] = 0; //@line 127345 "c/sqlite3.c"
  $99 = ((($$0139)) + 12|0); //@line 127346 "c/sqlite3.c"
  HEAP32[$99>>2] = 0; //@line 127346 "c/sqlite3.c"
 }
 _sqlite3ResetAllSchemasOfConnection($1); //@line 127351 "c/sqlite3.c"
 $$0137 = $$1;
 STACKTOP = sp;return ($$0137|0); //@line 127354 "c/sqlite3.c"
}
function _sqlite3BtreeIncrVacuum($0) {
 $0 = $0|0;
 var $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 64164 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 64164 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 64166 "c/sqlite3.c"
 $3 = ((($2)) + 17|0); //@line 64168 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 64168 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 64168 "c/sqlite3.c"
 do {
  if ($5) {
   $$2 = 101;
  } else {
   $6 = (_btreePagecount($2)|0); //@line 64171 "c/sqlite3.c"
   $7 = ((($2)) + 12|0); //@line 64172 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 64172 "c/sqlite3.c"
   $9 = ((($8)) + 56|0); //@line 64172 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 64172 "c/sqlite3.c"
   $11 = ((($10)) + 36|0); //@line 64172 "c/sqlite3.c"
   $12 = (_sqlite3Get4byte($11)|0); //@line 64172 "c/sqlite3.c"
   $13 = (_finalDbSize($2,$6,$12)|0); //@line 64173 "c/sqlite3.c"
   $14 = ($6>>>0)<($13>>>0); //@line 64175 "c/sqlite3.c"
   if ($14) {
    $15 = (_sqlite3CorruptError(64176)|0); //@line 64176 "c/sqlite3.c"
    $$2 = $15;
    break;
   }
   $16 = ($12|0)==(0); //@line 64177 "c/sqlite3.c"
   if ($16) {
    $$2 = 101;
   } else {
    $17 = (_saveAllCursors($2,0,0)|0); //@line 64178 "c/sqlite3.c"
    $18 = ($17|0)==(0); //@line 64179 "c/sqlite3.c"
    if ($18) {
     _invalidateAllOverflowCache($2); //@line 64180 "c/sqlite3.c"
     $19 = (_incrVacuumStep($2,$13,$6,0)|0); //@line 64181 "c/sqlite3.c"
     $20 = ($19|0)==(0); //@line 64183 "c/sqlite3.c"
     if ($20) {
      $21 = HEAP32[$7>>2]|0; //@line 64184 "c/sqlite3.c"
      $22 = ((($21)) + 72|0); //@line 64184 "c/sqlite3.c"
      $23 = HEAP32[$22>>2]|0; //@line 64184 "c/sqlite3.c"
      $24 = (_sqlite3PagerWrite($23)|0); //@line 64184 "c/sqlite3.c"
      $25 = HEAP32[$7>>2]|0; //@line 64185 "c/sqlite3.c"
      $26 = ((($25)) + 56|0); //@line 64185 "c/sqlite3.c"
      $27 = HEAP32[$26>>2]|0; //@line 64185 "c/sqlite3.c"
      $28 = ((($27)) + 28|0); //@line 64185 "c/sqlite3.c"
      $29 = ((($2)) + 44|0); //@line 64185 "c/sqlite3.c"
      $30 = HEAP32[$29>>2]|0; //@line 64185 "c/sqlite3.c"
      _sqlite3Put4byte($28,$30); //@line 64185 "c/sqlite3.c"
      $$2 = $24;
     } else {
      $$2 = $19;
     }
    } else {
     $$2 = $17;
    }
   }
  }
 } while(0);
 _sqlite3BtreeLeave($0); //@line 64191 "c/sqlite3.c"
 return ($$2|0); //@line 64192 "c/sqlite3.c"
}
function _sqlite3BtreeLockTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 9|0); //@line 70230 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 70230 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 70230 "c/sqlite3.c"
 if ($5) {
  $$1 = 0;
  return ($$1|0); //@line 70242 "c/sqlite3.c"
 }
 $6 = $2&255; //@line 70231 "c/sqlite3.c"
 $7 = (($6) + 1)|0; //@line 70231 "c/sqlite3.c"
 $8 = $7&255; //@line 70231 "c/sqlite3.c"
 _sqlite3BtreeEnter($0); //@line 70235 "c/sqlite3.c"
 $9 = (_querySharedCacheTableLock($0,$1,$8)|0); //@line 70236 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 70237 "c/sqlite3.c"
 if ($10) {
  $11 = (_setSharedCacheTableLock($0,$1,$8)|0); //@line 70238 "c/sqlite3.c"
  $$0 = $11;
 } else {
  $$0 = $9;
 }
 _sqlite3BtreeLeave($0); //@line 70240 "c/sqlite3.c"
 $$1 = $$0;
 return ($$1|0); //@line 70242 "c/sqlite3.c"
}
function _sqlite3VtabBegin($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$03539 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 324|0); //@line 128301 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 128301 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 128301 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 348|0); //@line 128301 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 128301 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 128301 "c/sqlite3.c"
  if ($7) {
   $$1 = 6;
   return ($$1|0); //@line 128335 "c/sqlite3.c"
  }
 }
 $8 = ($1|0)==(0|0); //@line 128304 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
  return ($$1|0); //@line 128335 "c/sqlite3.c"
 }
 $9 = ((($1)) + 8|0); //@line 128307 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 128307 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 128307 "c/sqlite3.c"
 $12 = ((($11)) + 56|0); //@line 128309 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 128309 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 128309 "c/sqlite3.c"
 if ($14) {
  $$1 = 0;
  return ($$1|0); //@line 128335 "c/sqlite3.c"
 }
 $15 = ($3|0)>(0); //@line 128313 "c/sqlite3.c"
 L11: do {
  if ($15) {
   $16 = ((($0)) + 348|0);
   $17 = HEAP32[$16>>2]|0;
   $$03539 = 0;
   while(1) {
    $20 = (($17) + ($$03539<<2)|0); //@line 128314 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 128314 "c/sqlite3.c"
    $22 = ($21|0)==($1|0); //@line 128314 "c/sqlite3.c"
    $19 = (($$03539) + 1)|0; //@line 128313 "c/sqlite3.c"
    if ($22) {
     $$1 = 0;
     break;
    }
    $18 = ($19|0)<($3|0); //@line 128313 "c/sqlite3.c"
    if ($18) {
     $$03539 = $19;
    } else {
     break L11;
    }
   }
   return ($$1|0); //@line 128335 "c/sqlite3.c"
  }
 } while(0);
 $23 = (_growVTrans($0)|0); //@line 128321 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 128322 "c/sqlite3.c"
 if (!($24)) {
  $$1 = $23;
  return ($$1|0); //@line 128335 "c/sqlite3.c"
 }
 $25 = HEAP32[$12>>2]|0; //@line 128323 "c/sqlite3.c"
 $26 = HEAP32[$9>>2]|0; //@line 128323 "c/sqlite3.c"
 $27 = (FUNCTION_TABLE_ii[$25 & 255]($26)|0); //@line 128323 "c/sqlite3.c"
 $28 = ($27|0)==(0); //@line 128324 "c/sqlite3.c"
 if (!($28)) {
  $$1 = $27;
  return ($$1|0); //@line 128335 "c/sqlite3.c"
 }
 $29 = ((($0)) + 444|0); //@line 128325 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 128325 "c/sqlite3.c"
 $31 = ((($0)) + 440|0); //@line 128325 "c/sqlite3.c"
 $32 = HEAP32[$31>>2]|0; //@line 128325 "c/sqlite3.c"
 $33 = (($32) + ($30))|0; //@line 128325 "c/sqlite3.c"
 _addToVTrans($0,$1); //@line 128326 "c/sqlite3.c"
 $34 = ($33|0)==(0); //@line 128327 "c/sqlite3.c"
 if ($34) {
  $$1 = 0;
  return ($$1|0); //@line 128335 "c/sqlite3.c"
 }
 $35 = ((($11)) + 80|0); //@line 128327 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 128327 "c/sqlite3.c"
 $37 = ($36|0)==(0|0); //@line 128327 "c/sqlite3.c"
 if ($37) {
  $$1 = 0;
  return ($$1|0); //@line 128335 "c/sqlite3.c"
 }
 $38 = (($33) + -1)|0; //@line 128329 "c/sqlite3.c"
 $39 = ((($1)) + 20|0); //@line 128328 "c/sqlite3.c"
 HEAP32[$39>>2] = $33; //@line 128328 "c/sqlite3.c"
 $40 = HEAP32[$9>>2]|0; //@line 128329 "c/sqlite3.c"
 $41 = (FUNCTION_TABLE_iii[$36 & 255]($40,$38)|0); //@line 128329 "c/sqlite3.c"
 $$1 = $41;
 return ($$1|0); //@line 128335 "c/sqlite3.c"
}
function _sqlite3VtabCallCreate($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 128056 "c/sqlite3.c"
 $4 = ((($0)) + 16|0); //@line 128062 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 128062 "c/sqlite3.c"
 $6 = (($5) + ($1<<4)|0); //@line 128062 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 128062 "c/sqlite3.c"
 $8 = (_sqlite3FindTable($0,$2,$7)|0); //@line 128062 "c/sqlite3.c"
 $9 = ((($8)) + 60|0); //@line 128066 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 128066 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 128066 "c/sqlite3.c"
 $12 = ((($0)) + 328|0); //@line 128067 "c/sqlite3.c"
 $13 = (_sqlite3HashFind($12,$11)|0); //@line 128067 "c/sqlite3.c"
 $14 = ($13|0)==(0|0); //@line 128073 "c/sqlite3.c"
 if (!($14)) {
  $15 = HEAP32[$13>>2]|0; //@line 128073 "c/sqlite3.c"
  $16 = ((($15)) + 4|0); //@line 128073 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 128073 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 128073 "c/sqlite3.c"
  if (!($18)) {
   $19 = ((($15)) + 20|0); //@line 128073 "c/sqlite3.c"
   $20 = HEAP32[$19>>2]|0; //@line 128073 "c/sqlite3.c"
   $21 = ($20|0)==(0|0); //@line 128073 "c/sqlite3.c"
   if (!($21)) {
    $23 = (_vtabCallConstructor($0,$8,$13,$17,$3)|0); //@line 128077 "c/sqlite3.c"
    $24 = ($23|0)==(0); //@line 128082 "c/sqlite3.c"
    if (!($24)) {
     $$1 = $23;
     STACKTOP = sp;return ($$1|0); //@line 128089 "c/sqlite3.c"
    }
    $25 = (_sqlite3GetVTable($0,$8)|0); //@line 128082 "c/sqlite3.c"
    $26 = ($25|0)==(0|0); //@line 128082 "c/sqlite3.c"
    if ($26) {
     $$1 = 0;
     STACKTOP = sp;return ($$1|0); //@line 128089 "c/sqlite3.c"
    }
    $27 = (_growVTrans($0)|0); //@line 128083 "c/sqlite3.c"
    $28 = ($27|0)==(0); //@line 128084 "c/sqlite3.c"
    if (!($28)) {
     $$1 = $27;
     STACKTOP = sp;return ($$1|0); //@line 128089 "c/sqlite3.c"
    }
    $29 = (_sqlite3GetVTable($0,$8)|0); //@line 128085 "c/sqlite3.c"
    _addToVTrans($0,$29); //@line 128085 "c/sqlite3.c"
    $$1 = 0;
    STACKTOP = sp;return ($$1|0); //@line 128089 "c/sqlite3.c"
   }
  }
 }
 HEAP32[$vararg_buffer>>2] = $11; //@line 128074 "c/sqlite3.c"
 $22 = (_sqlite3MPrintf($0,24452,$vararg_buffer)|0); //@line 128074 "c/sqlite3.c"
 HEAP32[$3>>2] = $22; //@line 128074 "c/sqlite3.c"
 $$1 = 1;
 STACKTOP = sp;return ($$1|0); //@line 128089 "c/sqlite3.c"
}
function _sqlite3VtabCallDestroy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$02932 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 16|0); //@line 128186 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 128186 "c/sqlite3.c"
 $5 = (($4) + ($1<<4)|0); //@line 128186 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 128186 "c/sqlite3.c"
 $7 = (_sqlite3FindTable($0,$2,$6)|0); //@line 128186 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 128187 "c/sqlite3.c"
 if ($8) {
  $$1 = 0;
  return ($$1|0); //@line 128210 "c/sqlite3.c"
 }
 $9 = ((($7)) + 64|0); //@line 128187 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 128187 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 128187 "c/sqlite3.c"
 if ($11) {
  $$1 = 0;
  return ($$1|0); //@line 128210 "c/sqlite3.c"
 }
 $$02932 = $10;
 while(1) {
  $12 = ((($$02932)) + 8|0); //@line 128192 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 128192 "c/sqlite3.c"
  $14 = ((($13)) + 4|0); //@line 128192 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 128192 "c/sqlite3.c"
  $16 = ($15|0)>(0); //@line 128192 "c/sqlite3.c"
  if ($16) {
   $$1 = 6;
   label = 8;
   break;
  }
  $17 = ((($$02932)) + 24|0); //@line 128190 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 128190 "c/sqlite3.c"
  $19 = ($18|0)==(0|0); //@line 128190 "c/sqlite3.c"
  if ($19) {
   break;
  } else {
   $$02932 = $18;
  }
 }
 if ((label|0) == 8) {
  return ($$1|0); //@line 128210 "c/sqlite3.c"
 }
 $20 = (_vtabDisconnectAll($0,$7)|0); //@line 128196 "c/sqlite3.c"
 $21 = ((($20)) + 4|0); //@line 128197 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 128197 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 128197 "c/sqlite3.c"
 $24 = ((($23)) + 20|0); //@line 128197 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 128197 "c/sqlite3.c"
 $26 = ((($20)) + 8|0); //@line 128199 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 128199 "c/sqlite3.c"
 $28 = (FUNCTION_TABLE_ii[$25 & 255]($27)|0); //@line 128199 "c/sqlite3.c"
 $29 = ($28|0)==(0); //@line 128201 "c/sqlite3.c"
 if (!($29)) {
  $$1 = $28;
  return ($$1|0); //@line 128210 "c/sqlite3.c"
 }
 HEAP32[$26>>2] = 0; //@line 128203 "c/sqlite3.c"
 HEAP32[$9>>2] = 0; //@line 128204 "c/sqlite3.c"
 _sqlite3VtabUnlock($20); //@line 128205 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 128210 "c/sqlite3.c"
}
function _sqlite3BtreeMaxPageCount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 63265 "c/sqlite3.c"
 $2 = ((($0)) + 4|0); //@line 63266 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 63266 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63266 "c/sqlite3.c"
 $5 = (_sqlite3PagerMaxPageCount($4,$1)|0); //@line 63266 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63267 "c/sqlite3.c"
 return ($5|0); //@line 63268 "c/sqlite3.c"
}
function _sqlite3PagerMaxPageCount($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 51793 "c/sqlite3.c"
 if ($2) {
  $3 = ((($0)) + 156|0); //@line 51794 "c/sqlite3.c"
  HEAP32[$3>>2] = $1; //@line 51794 "c/sqlite3.c"
 }
 $4 = ((($0)) + 156|0); //@line 51798 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 51798 "c/sqlite3.c"
 return ($5|0); //@line 51798 "c/sqlite3.c"
}
function _growVTrans($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 324|0); //@line 128024 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 128024 "c/sqlite3.c"
 $3 = (($2|0) % 5)&-1; //@line 128024 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 128024 "c/sqlite3.c"
 if (!($4)) {
  $$1 = 0;
  return ($$1|0); //@line 128036 "c/sqlite3.c"
 }
 $5 = $2 << 2; //@line 128026 "c/sqlite3.c"
 $6 = (($5) + 20)|0; //@line 128026 "c/sqlite3.c"
 $7 = ((($0)) + 348|0); //@line 128027 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 128027 "c/sqlite3.c"
 $9 = ($6|0)<(0); //@line 128027 "c/sqlite3.c"
 $10 = $9 << 31 >> 31; //@line 128027 "c/sqlite3.c"
 $11 = (_sqlite3DbRealloc($0,$8,$6,$10)|0); //@line 128027 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 128028 "c/sqlite3.c"
 if ($12) {
  $$1 = 7;
  return ($$1|0); //@line 128036 "c/sqlite3.c"
 }
 $13 = HEAP32[$1>>2]|0; //@line 128031 "c/sqlite3.c"
 $14 = (($11) + ($13<<2)|0); //@line 128031 "c/sqlite3.c"
 ;HEAP32[$14>>2]=0|0;HEAP32[$14+4>>2]=0|0;HEAP32[$14+8>>2]=0|0;HEAP32[$14+12>>2]=0|0;HEAP32[$14+16>>2]=0|0; //@line 128031 "c/sqlite3.c"
 HEAP32[$7>>2] = $11; //@line 128032 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 128036 "c/sqlite3.c"
}
function _addToVTrans($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 348|0); //@line 128044 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 128044 "c/sqlite3.c"
 $4 = ((($0)) + 324|0); //@line 128044 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 128044 "c/sqlite3.c"
 $6 = (($5) + 1)|0; //@line 128044 "c/sqlite3.c"
 HEAP32[$4>>2] = $6; //@line 128044 "c/sqlite3.c"
 $7 = (($3) + ($5<<2)|0); //@line 128044 "c/sqlite3.c"
 HEAP32[$7>>2] = $1; //@line 128044 "c/sqlite3.c"
 _sqlite3VtabLock($1); //@line 128045 "c/sqlite3.c"
 return; //@line 128046 "c/sqlite3.c"
}
function _setSharedCacheTableLock($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$029 = 0, $$031 = 0, $$032 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 4|0); //@line 60751 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 60751 "c/sqlite3.c"
 $5 = ((($4)) + 72|0); //@line 60771 "c/sqlite3.c"
 $$031 = HEAP32[$5>>2]|0;
 $6 = ($$031|0)==(0|0); //@line 60771 "c/sqlite3.c"
 L1: do {
  if ($6) {
   label = 6;
  } else {
   $$032 = $$031;
   while(1) {
    $7 = ((($$032)) + 4|0); //@line 60772 "c/sqlite3.c"
    $8 = HEAP32[$7>>2]|0; //@line 60772 "c/sqlite3.c"
    $9 = ($8|0)==($1|0); //@line 60772 "c/sqlite3.c"
    if ($9) {
     $10 = HEAP32[$$032>>2]|0; //@line 60772 "c/sqlite3.c"
     $11 = ($10|0)==($0|0); //@line 60772 "c/sqlite3.c"
     if ($11) {
      $$1 = $$032;
      break L1;
     }
    }
    $12 = ((($$032)) + 12|0); //@line 60771 "c/sqlite3.c"
    $$0 = HEAP32[$12>>2]|0;
    $13 = ($$0|0)==(0|0); //@line 60771 "c/sqlite3.c"
    if ($13) {
     label = 6;
     break;
    } else {
     $$032 = $$0;
    }
   }
  }
 } while(0);
 do {
  if ((label|0) == 6) {
   $14 = (_sqlite3MallocZero(16,0)|0); //@line 60782 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 60783 "c/sqlite3.c"
   if ($15) {
    $$029 = 7;
    return ($$029|0); //@line 60802 "c/sqlite3.c"
   } else {
    $16 = ((($14)) + 4|0); //@line 60786 "c/sqlite3.c"
    HEAP32[$16>>2] = $1; //@line 60786 "c/sqlite3.c"
    HEAP32[$14>>2] = $0; //@line 60787 "c/sqlite3.c"
    $17 = HEAP32[$5>>2]|0; //@line 60788 "c/sqlite3.c"
    $18 = ((($14)) + 12|0); //@line 60788 "c/sqlite3.c"
    HEAP32[$18>>2] = $17; //@line 60788 "c/sqlite3.c"
    HEAP32[$5>>2] = $14; //@line 60789 "c/sqlite3.c"
    $$1 = $14;
    break;
   }
  }
 } while(0);
 $19 = ((($$1)) + 8|0); //@line 60797 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 60797 "c/sqlite3.c"
 $21 = ($20&255)<($2&255); //@line 60797 "c/sqlite3.c"
 if (!($21)) {
  $$029 = 0;
  return ($$029|0); //@line 60802 "c/sqlite3.c"
 }
 HEAP8[$19>>0] = $2; //@line 60798 "c/sqlite3.c"
 $$029 = 0;
 return ($$029|0); //@line 60802 "c/sqlite3.c"
}
function _execSql($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$2 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = (_sqlite3_prepare_v2($0,$2,-1,$3,0)|0); //@line 127022 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 127023 "c/sqlite3.c"
 if (!($5)) {
  $$0 = $4;
  STACKTOP = sp;return ($$0|0); //@line 127040 "c/sqlite3.c"
 }
 $6 = HEAP32[$3>>2]|0; //@line 127024 "c/sqlite3.c"
 $7 = (_sqlite3_step($6)|0); //@line 127024 "c/sqlite3.c"
 $8 = ($7|0)==(100); //@line 127024 "c/sqlite3.c"
 L4: do {
  if ($8) {
   $9 = HEAP32[$3>>2]|0;
   $10 = $6;
   while(1) {
    $11 = (_sqlite3_column_text($10,0)|0); //@line 127025 "c/sqlite3.c"
    $12 = ($11|0)==(0|0); //@line 127027 "c/sqlite3.c"
    if (!($12)) {
     $13 = (_execSql($0,$1,$11)|0); //@line 127029 "c/sqlite3.c"
     $14 = ($13|0)==(0); //@line 127030 "c/sqlite3.c"
     if (!($14)) {
      $$2 = $13;$$lcssa = $10;
      break L4;
     }
    }
    $15 = (_sqlite3_step($9)|0); //@line 127024 "c/sqlite3.c"
    $16 = ($15|0)==(100); //@line 127024 "c/sqlite3.c"
    if ($16) {
     $10 = $9;
    } else {
     $$2 = $15;$$lcssa = $9;
     break;
    }
   }
  } else {
   $$2 = $7;$$lcssa = $6;
  }
 } while(0);
 $17 = ($$2|0)==(101); //@line 127034 "c/sqlite3.c"
 $spec$select = $17 ? 0 : $$2; //@line 127034 "c/sqlite3.c"
 $18 = ($spec$select|0)==(0); //@line 127035 "c/sqlite3.c"
 if (!($18)) {
  $19 = (_sqlite3_errmsg($0)|0); //@line 127036 "c/sqlite3.c"
  _sqlite3SetString($1,$0,$19); //@line 127036 "c/sqlite3.c"
 }
 (_sqlite3_finalize($$lcssa)|0); //@line 127038 "c/sqlite3.c"
 $$0 = $spec$select;
 STACKTOP = sp;return ($$0|0); //@line 127040 "c/sqlite3.c"
}
function _sqlite3BtreeGetOptimalReserve($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 63248 "c/sqlite3.c"
 $1 = (_sqlite3BtreeGetReserveNoMutex($0)|0); //@line 63249 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63253 "c/sqlite3.c"
 return ($1|0); //@line 63254 "c/sqlite3.c"
}
function _execSqlF($0,$1,$2,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $varargs = $varargs|0;
 var $$0 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 HEAP32[$3>>2] = $varargs; //@line 127045 "c/sqlite3.c"
 $4 = (_sqlite3VMPrintf($0,$2,$3)|0); //@line 127046 "c/sqlite3.c"
 $5 = ($4|0)==(0|0); //@line 127048 "c/sqlite3.c"
 if ($5) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 127052 "c/sqlite3.c"
 }
 $6 = (_execSql($0,$1,$4)|0); //@line 127049 "c/sqlite3.c"
 _sqlite3DbFree($0,$4); //@line 127050 "c/sqlite3.c"
 $$0 = $6;
 STACKTOP = sp;return ($$0|0); //@line 127052 "c/sqlite3.c"
}
function _sqlite3BtreeCopyFile($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$022 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$store$select = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $2 = sp + 8|0;
 $3 = sp;
 _sqlite3BtreeEnter($0); //@line 71138 "c/sqlite3.c"
 _sqlite3BtreeEnter($1); //@line 71139 "c/sqlite3.c"
 $4 = (_sqlite3BtreePager($0)|0); //@line 71142 "c/sqlite3.c"
 $5 = (_sqlite3PagerFile($4)|0); //@line 71142 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 71143 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 71143 "c/sqlite3.c"
 if (!($7)) {
  $8 = (_sqlite3BtreeGetPageSize($1)|0); //@line 71144 "c/sqlite3.c"
  $9 = ($8|0)<(0); //@line 71144 "c/sqlite3.c"
  $10 = $9 << 31 >> 31; //@line 71144 "c/sqlite3.c"
  $11 = (_sqlite3BtreeLastPage($1)|0); //@line 71144 "c/sqlite3.c"
  $12 = (___muldi3(($11|0),0,($8|0),($10|0))|0); //@line 71144 "c/sqlite3.c"
  $13 = tempRet0; //@line 71144 "c/sqlite3.c"
  $14 = $3; //@line 71144 "c/sqlite3.c"
  $15 = $14; //@line 71144 "c/sqlite3.c"
  HEAP32[$15>>2] = $12; //@line 71144 "c/sqlite3.c"
  $16 = (($14) + 4)|0; //@line 71144 "c/sqlite3.c"
  $17 = $16; //@line 71144 "c/sqlite3.c"
  HEAP32[$17>>2] = $13; //@line 71144 "c/sqlite3.c"
  $18 = (_sqlite3OsFileControl($5,11,$3)|0); //@line 71145 "c/sqlite3.c"
  $19 = ($18|0)==(12); //@line 71146 "c/sqlite3.c"
  $spec$store$select = $19 ? 0 : $18; //@line 71146 "c/sqlite3.c"
  $20 = ($spec$store$select|0)==(0); //@line 71147 "c/sqlite3.c"
  if (!($20)) {
   $$022 = $spec$store$select;
   _sqlite3BtreeLeave($1); //@line 71183 "c/sqlite3.c"
   _sqlite3BtreeLeave($0); //@line 71184 "c/sqlite3.c"
   STACKTOP = sp;return ($$022|0); //@line 71186 "c/sqlite3.c"
  }
 }
 dest=$2; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 71155 "c/sqlite3.c"
 $21 = HEAP32[$1>>2]|0; //@line 71156 "c/sqlite3.c"
 $22 = ((($2)) + 20|0); //@line 71156 "c/sqlite3.c"
 HEAP32[$22>>2] = $21; //@line 71156 "c/sqlite3.c"
 $23 = ((($2)) + 24|0); //@line 71157 "c/sqlite3.c"
 HEAP32[$23>>2] = $1; //@line 71157 "c/sqlite3.c"
 $24 = ((($2)) + 4|0); //@line 71158 "c/sqlite3.c"
 HEAP32[$24>>2] = $0; //@line 71158 "c/sqlite3.c"
 $25 = ((($2)) + 16|0); //@line 71159 "c/sqlite3.c"
 HEAP32[$25>>2] = 1; //@line 71159 "c/sqlite3.c"
 (_sqlite3_backup_step($2,2147483647)|0); //@line 71171 "c/sqlite3.c"
 $26 = (_sqlite3_backup_finish($2)|0); //@line 71174 "c/sqlite3.c"
 $27 = ($26|0)==(0); //@line 71175 "c/sqlite3.c"
 if ($27) {
  $28 = ((($0)) + 4|0); //@line 71176 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 71176 "c/sqlite3.c"
  $30 = ((($29)) + 22|0); //@line 71176 "c/sqlite3.c"
  $31 = HEAP16[$30>>1]|0; //@line 71176 "c/sqlite3.c"
  $32 = $31 & -3; //@line 71176 "c/sqlite3.c"
  HEAP16[$30>>1] = $32; //@line 71176 "c/sqlite3.c"
  $$022 = 0;
  _sqlite3BtreeLeave($1); //@line 71183 "c/sqlite3.c"
  _sqlite3BtreeLeave($0); //@line 71184 "c/sqlite3.c"
  STACKTOP = sp;return ($$022|0); //@line 71186 "c/sqlite3.c"
 } else {
  $33 = HEAP32[$24>>2]|0; //@line 71178 "c/sqlite3.c"
  $34 = (_sqlite3BtreePager($33)|0); //@line 71178 "c/sqlite3.c"
  _sqlite3PagerClearCache($34); //@line 71178 "c/sqlite3.c"
  $$022 = $26;
  _sqlite3BtreeLeave($1); //@line 71183 "c/sqlite3.c"
  _sqlite3BtreeLeave($0); //@line 71184 "c/sqlite3.c"
  STACKTOP = sp;return ($$022|0); //@line 71186 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3PagerClearCache($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 55348 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 55348 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 55348 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 55349 "c/sqlite3.c"
 }
 _pager_reset($0); //@line 55348 "c/sqlite3.c"
 return; //@line 55349 "c/sqlite3.c"
}
function _sqlite3BtreeGetReserveNoMutex($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 63233 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63233 "c/sqlite3.c"
 $3 = ((($2)) + 32|0); //@line 63233 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 63233 "c/sqlite3.c"
 $5 = ((($2)) + 36|0); //@line 63233 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 63233 "c/sqlite3.c"
 $7 = (($4) - ($6))|0; //@line 63233 "c/sqlite3.c"
 return ($7|0); //@line 63234 "c/sqlite3.c"
}
function _rowSetEntrySort($0) {
 $0 = $0|0;
 var $$02125 = 0, $$028 = 0, $$1$lcssa = 0, $$12223 = 0, $$126 = 0, $$224 = 0, $$3 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 160|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(160|0);
 $1 = sp;
 _memset(($1|0),0,160)|0; //@line 47589 "c/sqlite3.c"
 $2 = ($0|0)==(0|0); //@line 47590 "c/sqlite3.c"
 if (!($2)) {
  $$028 = $0;
  while(1) {
   $3 = ((($$028)) + 8|0); //@line 47591 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 47591 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 47592 "c/sqlite3.c"
   $5 = HEAP32[$1>>2]|0; //@line 47593 "c/sqlite3.c"
   $6 = ($5|0)==(0|0); //@line 47593 "c/sqlite3.c"
   if ($6) {
    $$1$lcssa = $$028;$$lcssa = $1;
   } else {
    $$02125 = 0;$$126 = $$028;$7 = $5;$9 = $1;
    while(1) {
     $8 = (_rowSetEntryMerge($7,$$126)|0); //@line 47594 "c/sqlite3.c"
     HEAP32[$9>>2] = 0; //@line 47595 "c/sqlite3.c"
     $10 = (($$02125) + 1)|0; //@line 47593 "c/sqlite3.c"
     $11 = (($1) + ($10<<2)|0); //@line 47593 "c/sqlite3.c"
     $12 = HEAP32[$11>>2]|0; //@line 47593 "c/sqlite3.c"
     $13 = ($12|0)==(0|0); //@line 47593 "c/sqlite3.c"
     if ($13) {
      $$1$lcssa = $8;$$lcssa = $11;
      break;
     } else {
      $$02125 = $10;$$126 = $8;$7 = $12;$9 = $11;
     }
    }
   }
   HEAP32[$$lcssa>>2] = $$1$lcssa; //@line 47597 "c/sqlite3.c"
   $14 = ($4|0)==(0|0); //@line 47590 "c/sqlite3.c"
   if ($14) {
    break;
   } else {
    $$028 = $4;
   }
  }
 }
 $15 = HEAP32[$1>>2]|0; //@line 47600 "c/sqlite3.c"
 $$12223 = 1;$$224 = $15;
 while(1) {
  $16 = (($1) + ($$12223<<2)|0); //@line 47602 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 47602 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 47602 "c/sqlite3.c"
  if ($18) {
   $$3 = $$224;
  } else {
   $19 = ($$224|0)==(0|0); //@line 47603 "c/sqlite3.c"
   if ($19) {
    $$3 = $17;
   } else {
    $20 = (_rowSetEntryMerge($$224,$17)|0); //@line 47603 "c/sqlite3.c"
    $$3 = $20;
   }
  }
  $21 = (($$12223) + 1)|0; //@line 47601 "c/sqlite3.c"
  $exitcond = ($21|0)==(40); //@line 47601 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$12223 = $21;$$224 = $$3;
  }
 }
 STACKTOP = sp;return ($$3|0); //@line 47605 "c/sqlite3.c"
}
function _rowSetTreeToList($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($0)) + 12|0); //@line 47620 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 47620 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 47620 "c/sqlite3.c"
 if ($6) {
  HEAP32[$1>>2] = $0; //@line 47625 "c/sqlite3.c"
 } else {
  _rowSetTreeToList($5,$1,$3); //@line 47622 "c/sqlite3.c"
  $7 = HEAP32[$3>>2]|0; //@line 47623 "c/sqlite3.c"
  $8 = ((($7)) + 8|0); //@line 47623 "c/sqlite3.c"
  HEAP32[$8>>2] = $0; //@line 47623 "c/sqlite3.c"
 }
 $9 = ((($0)) + 8|0); //@line 47627 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 47627 "c/sqlite3.c"
 $11 = ($10|0)==(0|0); //@line 47627 "c/sqlite3.c"
 if ($11) {
  HEAP32[$2>>2] = $0; //@line 47630 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 47633 "c/sqlite3.c"
 } else {
  _rowSetTreeToList($10,$9,$2); //@line 47628 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 47633 "c/sqlite3.c"
 }
}
function _rowSetEntryMerge($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$ph = 0, $$0$phi = 0, $$017 = 0, $$017$ph = 0, $$017$sink = 0, $$019$ph = 0, $$019$sink = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $$0$ph = $2;$$017$ph = $1;$$019$ph = $0;
 L1: while(1) {
  $3 = $$019$ph;
  $4 = $3;
  $5 = HEAP32[$4>>2]|0;
  $6 = (($3) + 4)|0;
  $7 = $6;
  $8 = HEAP32[$7>>2]|0;
  $$0 = $$0$ph;$$017 = $$017$ph;
  while(1) {
   $9 = $$017; //@line 47562 "c/sqlite3.c"
   $10 = $9; //@line 47562 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 47562 "c/sqlite3.c"
   $12 = (($9) + 4)|0; //@line 47562 "c/sqlite3.c"
   $13 = $12; //@line 47562 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 47562 "c/sqlite3.c"
   $15 = ($8|0)>($14|0); //@line 47562 "c/sqlite3.c"
   $16 = ($5>>>0)>($11>>>0); //@line 47562 "c/sqlite3.c"
   $17 = ($8|0)==($14|0); //@line 47562 "c/sqlite3.c"
   $18 = $17 & $16; //@line 47562 "c/sqlite3.c"
   $19 = $15 | $18; //@line 47562 "c/sqlite3.c"
   if (!($19)) {
    break;
   }
   $29 = ((($$0)) + 8|0); //@line 47570 "c/sqlite3.c"
   HEAP32[$29>>2] = $$017; //@line 47570 "c/sqlite3.c"
   $30 = ((($$017)) + 8|0); //@line 47571 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 47571 "c/sqlite3.c"
   $32 = ($31|0)==(0|0); //@line 47572 "c/sqlite3.c"
   if ($32) {
    $$017$sink = $$017;$$019$sink = $$019$ph;
    label = 8;
    break L1;
   } else {
    $$0$phi = $$017;$$017 = $31;$$0 = $$0$phi;
   }
  }
  $20 = ($8|0)<($14|0); //@line 47563 "c/sqlite3.c"
  $21 = ($5>>>0)<($11>>>0); //@line 47563 "c/sqlite3.c"
  $22 = ($8|0)==($14|0); //@line 47563 "c/sqlite3.c"
  $23 = $22 & $21; //@line 47563 "c/sqlite3.c"
  $24 = $20 | $23; //@line 47563 "c/sqlite3.c"
  if ($24) {
   $25 = ((($$0)) + 8|0); //@line 47563 "c/sqlite3.c"
   HEAP32[$25>>2] = $$019$ph; //@line 47563 "c/sqlite3.c"
   $$1 = $$019$ph;
  } else {
   $$1 = $$0;
  }
  $26 = ((($$019$ph)) + 8|0); //@line 47564 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 47564 "c/sqlite3.c"
  $28 = ($27|0)==(0|0); //@line 47565 "c/sqlite3.c"
  if ($28) {
   $$017$sink = $$1;$$019$sink = $$017;
   label = 8;
   break;
  } else {
   $$0$ph = $$1;$$017$ph = $$017;$$019$ph = $27;
  }
 }
 if ((label|0) == 8) {
  $33 = ((($$017$sink)) + 8|0);
  HEAP32[$33>>2] = $$019$sink;
  $34 = ((($2)) + 8|0); //@line 47578 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 47578 "c/sqlite3.c"
  STACKTOP = sp;return ($35|0); //@line 47578 "c/sqlite3.c"
 }
 return (0)|0;
}
function _rowSetListToTree($0) {
 $0 = $0|0;
 var $$014$lcssa = 0, $$01415 = 0, $$01415$phi = 0, $$016 = 0, $$pr = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 8|0); //@line 47692 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 47692 "c/sqlite3.c"
 HEAP32[$1>>2] = $3; //@line 47692 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 47693 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 47693 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 47693 "c/sqlite3.c"
 $5 = ($3|0)==(0); //@line 47694 "c/sqlite3.c"
 if ($5) {
  $$014$lcssa = $0;
  STACKTOP = sp;return ($$014$lcssa|0); //@line 47701 "c/sqlite3.c"
 }
 $6 = $3;
 $$01415 = $0;$$016 = 1;$8 = $6;
 while(1) {
  $7 = ((($8)) + 8|0); //@line 47697 "c/sqlite3.c"
  $9 = HEAP32[$7>>2]|0; //@line 47697 "c/sqlite3.c"
  HEAP32[$1>>2] = $9; //@line 47697 "c/sqlite3.c"
  $10 = ((($8)) + 12|0); //@line 47698 "c/sqlite3.c"
  HEAP32[$10>>2] = $$01415; //@line 47698 "c/sqlite3.c"
  $11 = (_rowSetNDeepTree($1,$$016)|0); //@line 47699 "c/sqlite3.c"
  HEAP32[$7>>2] = $11; //@line 47699 "c/sqlite3.c"
  $12 = (($$016) + 1)|0; //@line 47694 "c/sqlite3.c"
  $$pr = HEAP32[$1>>2]|0; //@line 47694 "c/sqlite3.c"
  $13 = ($$pr|0)==(0|0); //@line 47694 "c/sqlite3.c"
  if ($13) {
   $$014$lcssa = $8;
   break;
  } else {
   $$01415$phi = $8;$$016 = $12;$8 = $$pr;$$01415 = $$01415$phi;
  }
 }
 STACKTOP = sp;return ($$014$lcssa|0); //@line 47701 "c/sqlite3.c"
}
function _rowSetEntryAlloc($0) {
 $0 = $0|0;
 var $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 47496 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 47496 "c/sqlite3.c"
 $3 = ($2<<16>>16)==(0); //@line 47496 "c/sqlite3.c"
 do {
  if ($3) {
   $4 = ((($0)) + 4|0); //@line 47500 "c/sqlite3.c"
   $5 = HEAP32[$4>>2]|0; //@line 47500 "c/sqlite3.c"
   $6 = (_sqlite3DbMallocRawNN($5,1016,0)|0); //@line 47500 "c/sqlite3.c"
   $7 = ($6|0)==(0|0); //@line 47501 "c/sqlite3.c"
   if ($7) {
    $$1 = 0;
    return ($$1|0); //@line 47511 "c/sqlite3.c"
   } else {
    $8 = HEAP32[$0>>2]|0; //@line 47504 "c/sqlite3.c"
    HEAP32[$6>>2] = $8; //@line 47504 "c/sqlite3.c"
    HEAP32[$0>>2] = $6; //@line 47505 "c/sqlite3.c"
    $9 = ((($6)) + 8|0); //@line 47506 "c/sqlite3.c"
    $10 = ((($0)) + 16|0); //@line 47506 "c/sqlite3.c"
    HEAP32[$10>>2] = $9; //@line 47506 "c/sqlite3.c"
    HEAP16[$1>>1] = 63; //@line 47507 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $11 = HEAP16[$1>>1]|0; //@line 47509 "c/sqlite3.c"
 $12 = (($11) + -1)<<16>>16; //@line 47509 "c/sqlite3.c"
 HEAP16[$1>>1] = $12; //@line 47509 "c/sqlite3.c"
 $13 = ((($0)) + 16|0); //@line 47510 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 47510 "c/sqlite3.c"
 $15 = ((($14)) + 16|0); //@line 47510 "c/sqlite3.c"
 HEAP32[$13>>2] = $15; //@line 47510 "c/sqlite3.c"
 $$1 = $14;
 return ($$1|0); //@line 47511 "c/sqlite3.c"
}
function _rowSetNDeepTree($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 47655 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 47655 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  return ($$0|0); //@line 47679 "c/sqlite3.c"
 }
 $4 = ($1|0)>(1); //@line 47659 "c/sqlite3.c"
 if (!($4)) {
  $13 = ((($2)) + 8|0); //@line 47675 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 47675 "c/sqlite3.c"
  HEAP32[$0>>2] = $14; //@line 47675 "c/sqlite3.c"
  HEAP32[$13>>2] = 0; //@line 47676 "c/sqlite3.c"
  $15 = ((($2)) + 12|0); //@line 47676 "c/sqlite3.c"
  HEAP32[$15>>2] = 0; //@line 47676 "c/sqlite3.c"
  $$0 = $2;
  return ($$0|0); //@line 47679 "c/sqlite3.c"
 }
 $5 = (($1) + -1)|0; //@line 47663 "c/sqlite3.c"
 $6 = (_rowSetNDeepTree($0,$5)|0); //@line 47663 "c/sqlite3.c"
 $7 = HEAP32[$0>>2]|0; //@line 47664 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 47665 "c/sqlite3.c"
 if ($8) {
  $$0 = $6;
  return ($$0|0); //@line 47679 "c/sqlite3.c"
 } else {
  $9 = ((($7)) + 12|0); //@line 47670 "c/sqlite3.c"
  HEAP32[$9>>2] = $6; //@line 47670 "c/sqlite3.c"
  $10 = ((($7)) + 8|0); //@line 47671 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 47671 "c/sqlite3.c"
  HEAP32[$0>>2] = $11; //@line 47671 "c/sqlite3.c"
  $12 = (_rowSetNDeepTree($0,$5)|0); //@line 47672 "c/sqlite3.c"
  HEAP32[$10>>2] = $12; //@line 47672 "c/sqlite3.c"
  return ($7|0); //@line 47679 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3RowSetInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$1>>2] = 0; //@line 47455 "c/sqlite3.c"
 $3 = ((($1)) + 4|0); //@line 47456 "c/sqlite3.c"
 HEAP32[$3>>2] = $0; //@line 47456 "c/sqlite3.c"
 $4 = ((($1)) + 8|0); //@line 47457 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 47457 "c/sqlite3.c"
 $5 = ((($1)) + 12|0); //@line 47458 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 47458 "c/sqlite3.c"
 $6 = ((($1)) + 20|0); //@line 47459 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 47459 "c/sqlite3.c"
 $7 = ((($1)) + 32|0); //@line 47460 "c/sqlite3.c"
 $8 = ((($1)) + 16|0); //@line 47460 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 47460 "c/sqlite3.c"
 $9 = (($2) + 1048544)|0; //@line 47461 "c/sqlite3.c"
 $10 = $9 >>> 4; //@line 47461 "c/sqlite3.c"
 $11 = $10&65535; //@line 47461 "c/sqlite3.c"
 $12 = ((($1)) + 24|0); //@line 47461 "c/sqlite3.c"
 HEAP16[$12>>1] = $11; //@line 47461 "c/sqlite3.c"
 $13 = ((($1)) + 26|0); //@line 47462 "c/sqlite3.c"
 HEAP16[$13>>1] = 1; //@line 47462 "c/sqlite3.c"
 $14 = ((($1)) + 28|0); //@line 47463 "c/sqlite3.c"
 HEAP32[$14>>2] = 0; //@line 47463 "c/sqlite3.c"
 return ($1|0); //@line 47464 "c/sqlite3.c"
}
function _setPageReferenced($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1 & 7; //@line 69527 "c/sqlite3.c"
 $3 = 1 << $2; //@line 69527 "c/sqlite3.c"
 $4 = ((($0)) + 8|0); //@line 69527 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 69527 "c/sqlite3.c"
 $6 = $1 >>> 3; //@line 69527 "c/sqlite3.c"
 $7 = (($5) + ($6)|0); //@line 69527 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 69527 "c/sqlite3.c"
 $9 = $8&255; //@line 69527 "c/sqlite3.c"
 $10 = $3 | $9; //@line 69527 "c/sqlite3.c"
 $11 = $10&255; //@line 69527 "c/sqlite3.c"
 HEAP8[$7>>0] = $11; //@line 69527 "c/sqlite3.c"
 return; //@line 69528 "c/sqlite3.c"
}
function _checkList($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$06273 = 0, $$075 = 0, $$2 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer3 = 0;
 var $vararg_buffer6 = 0, $vararg_buffer9 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer9 = sp + 32|0;
 $vararg_buffer6 = sp + 24|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $4 = sp + 36|0;
 $5 = ($3|0)>(0); //@line 69597 "c/sqlite3.c"
 if (!($5)) {
  STACKTOP = sp;return; //@line 69655 "c/sqlite3.c"
 }
 $6 = ((($0)) + 16|0);
 $7 = ((($0)) + 4|0);
 $8 = ($1|0)!=(0);
 $$075 = $2;$$in = $3;
 while(1) {
  $9 = (($$in) + -1)|0; //@line 69597 "c/sqlite3.c"
  $10 = HEAP32[$6>>2]|0; //@line 69597 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 69597 "c/sqlite3.c"
  if ($11) {
   label = 27;
   break;
  }
  $12 = ($$075|0)<(1); //@line 69600 "c/sqlite3.c"
  if ($12) {
   label = 5;
   break;
  }
  $13 = (_checkRef($0,$$075)|0); //@line 69606 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 69606 "c/sqlite3.c"
  if (!($14)) {
   break;
  }
  $15 = HEAP32[$7>>2]|0; //@line 69607 "c/sqlite3.c"
  $16 = (_sqlite3PagerGet($15,$$075,$4,0)|0); //@line 69607 "c/sqlite3.c"
  $17 = ($16|0)==(0); //@line 69607 "c/sqlite3.c"
  if (!($17)) {
   label = 8;
   break;
  }
  $18 = HEAP32[$4>>2]|0; //@line 69611 "c/sqlite3.c"
  $19 = (_sqlite3PagerGetData($18)|0); //@line 69611 "c/sqlite3.c"
  do {
   if ($8) {
    $20 = ((($19)) + 4|0); //@line 69613 "c/sqlite3.c"
    $21 = (_sqlite3Get4byte($20)|0); //@line 69613 "c/sqlite3.c"
    $22 = HEAP32[$0>>2]|0; //@line 69615 "c/sqlite3.c"
    $23 = ((($22)) + 17|0); //@line 69615 "c/sqlite3.c"
    $24 = HEAP8[$23>>0]|0; //@line 69615 "c/sqlite3.c"
    $25 = ($24<<24>>24)==(0); //@line 69615 "c/sqlite3.c"
    if (!($25)) {
     _checkPtrmap($0,$$075,2,0); //@line 69616 "c/sqlite3.c"
    }
    $26 = HEAP32[$0>>2]|0; //@line 69619 "c/sqlite3.c"
    $27 = ((($26)) + 36|0); //@line 69619 "c/sqlite3.c"
    $28 = HEAP32[$27>>2]|0; //@line 69619 "c/sqlite3.c"
    $29 = (($28|0) / 4)&-1; //@line 69619 "c/sqlite3.c"
    $30 = (($29) + -2)|0; //@line 69619 "c/sqlite3.c"
    $31 = ($21|0)>($30|0); //@line 69619 "c/sqlite3.c"
    if ($31) {
     HEAP32[$vararg_buffer6>>2] = $$075; //@line 69620 "c/sqlite3.c"
     _checkAppendMsg($0,35467,$vararg_buffer6); //@line 69620 "c/sqlite3.c"
     $32 = (($$in) + -2)|0; //@line 69622 "c/sqlite3.c"
     $$2 = $32;
     break;
    }
    $33 = ($21|0)>(0); //@line 69624 "c/sqlite3.c"
    if ($33) {
     $$06273 = 0;
     while(1) {
      $34 = $$06273 << 2; //@line 69625 "c/sqlite3.c"
      $35 = (($34) + 8)|0; //@line 69625 "c/sqlite3.c"
      $36 = (($19) + ($35)|0); //@line 69625 "c/sqlite3.c"
      $37 = (_sqlite3Get4byte($36)|0); //@line 69625 "c/sqlite3.c"
      $38 = HEAP32[$0>>2]|0; //@line 69627 "c/sqlite3.c"
      $39 = ((($38)) + 17|0); //@line 69627 "c/sqlite3.c"
      $40 = HEAP8[$39>>0]|0; //@line 69627 "c/sqlite3.c"
      $41 = ($40<<24>>24)==(0); //@line 69627 "c/sqlite3.c"
      if (!($41)) {
       _checkPtrmap($0,$37,2,0); //@line 69628 "c/sqlite3.c"
      }
      (_checkRef($0,$37)|0); //@line 69631 "c/sqlite3.c"
      $42 = (($$06273) + 1)|0; //@line 69624 "c/sqlite3.c"
      $exitcond = ($42|0)==($21|0); //@line 69624 "c/sqlite3.c"
      if ($exitcond) {
       break;
      } else {
       $$06273 = $42;
      }
     }
    }
    $43 = (($9) - ($21))|0; //@line 69633 "c/sqlite3.c"
    $$2 = $43;
   } else {
    $44 = HEAP32[$0>>2]|0; //@line 69642 "c/sqlite3.c"
    $45 = ((($44)) + 17|0); //@line 69642 "c/sqlite3.c"
    $46 = HEAP8[$45>>0]|0; //@line 69642 "c/sqlite3.c"
    $47 = ($46<<24>>24)!=(0); //@line 69642 "c/sqlite3.c"
    $48 = ($$in|0)>(1); //@line 69642 "c/sqlite3.c"
    $or$cond = $48 & $47; //@line 69642 "c/sqlite3.c"
    if ($or$cond) {
     $49 = (_sqlite3Get4byte($19)|0); //@line 69643 "c/sqlite3.c"
     _checkPtrmap($0,$49,4,$$075); //@line 69644 "c/sqlite3.c"
     $$2 = $9;
    } else {
     $$2 = $9;
    }
   }
  } while(0);
  $50 = (_sqlite3Get4byte($19)|0); //@line 69648 "c/sqlite3.c"
  $51 = HEAP32[$4>>2]|0; //@line 69649 "c/sqlite3.c"
  _sqlite3PagerUnref($51); //@line 69649 "c/sqlite3.c"
  if ($8) {
   $52 = ($50|0)!=(0); //@line 69651 "c/sqlite3.c"
   $53 = $52&1; //@line 69651 "c/sqlite3.c"
   $54 = ($$2|0)<($53|0); //@line 69651 "c/sqlite3.c"
   if ($54) {
    _checkAppendMsg($0,35506,$vararg_buffer9); //@line 69652 "c/sqlite3.c"
   }
  }
  $55 = ($$2|0)>(0); //@line 69597 "c/sqlite3.c"
  if ($55) {
   $$075 = $50;$$in = $$2;
  } else {
   label = 27;
   break;
  }
 }
 if ((label|0) == 5) {
  HEAP32[$vararg_buffer>>2] = $$in; //@line 69601 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 69601 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $3; //@line 69601 "c/sqlite3.c"
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 69601 "c/sqlite3.c"
  HEAP32[$vararg_ptr2>>2] = $2; //@line 69601 "c/sqlite3.c"
  _checkAppendMsg($0,35388,$vararg_buffer); //@line 69601 "c/sqlite3.c"
 }
 else if ((label|0) == 8) {
  HEAP32[$vararg_buffer3>>2] = $$075; //@line 69608 "c/sqlite3.c"
  _checkAppendMsg($0,35445,$vararg_buffer3); //@line 69608 "c/sqlite3.c"
 }
 else if ((label|0) == 27) {
  STACKTOP = sp;return; //@line 69655 "c/sqlite3.c"
 }
 STACKTOP = sp;return; //@line 69655 "c/sqlite3.c"
}
function _checkPtrmap($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $switch$split2D = 0, $switch$split92D = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_ptr4 = 0, $vararg_ptr5 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $4 = sp + 32|0;
 $5 = sp + 28|0;
 $6 = HEAP32[$0>>2]|0; //@line 69569 "c/sqlite3.c"
 $7 = (_ptrmapGet($6,$1,$4,$5)|0); //@line 69569 "c/sqlite3.c"
 $switch$split2D = ($7|0)<(7);
 L1: do {
  if ($switch$split2D) {
   switch ($7|0) {
   case 0:  {
    break;
   }
   default: {
    break L1;
   }
   }
   $9 = HEAP8[$4>>0]|0; //@line 69576 "c/sqlite3.c"
   $10 = ($9<<24>>24)==($2<<24>>24); //@line 69576 "c/sqlite3.c"
   $11 = HEAP32[$5>>2]|0; //@line 69576 "c/sqlite3.c"
   $12 = ($11|0)==($3|0); //@line 69576 "c/sqlite3.c"
   $or$cond = $10 & $12; //@line 69576 "c/sqlite3.c"
   if ($or$cond) {
    STACKTOP = sp;return; //@line 69581 "c/sqlite3.c"
   }
   $13 = $9&255; //@line 69579 "c/sqlite3.c"
   $14 = $2&255; //@line 69576 "c/sqlite3.c"
   HEAP32[$vararg_buffer1>>2] = $1; //@line 69577 "c/sqlite3.c"
   $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 69577 "c/sqlite3.c"
   HEAP32[$vararg_ptr4>>2] = $14; //@line 69577 "c/sqlite3.c"
   $vararg_ptr5 = ((($vararg_buffer1)) + 8|0); //@line 69577 "c/sqlite3.c"
   HEAP32[$vararg_ptr5>>2] = $3; //@line 69577 "c/sqlite3.c"
   $vararg_ptr6 = ((($vararg_buffer1)) + 12|0); //@line 69577 "c/sqlite3.c"
   HEAP32[$vararg_ptr6>>2] = $13; //@line 69577 "c/sqlite3.c"
   $vararg_ptr7 = ((($vararg_buffer1)) + 16|0); //@line 69577 "c/sqlite3.c"
   HEAP32[$vararg_ptr7>>2] = $11; //@line 69577 "c/sqlite3.c"
   _checkAppendMsg($0,35334,$vararg_buffer1); //@line 69577 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 69581 "c/sqlite3.c"
  } else {
   $switch$split92D = ($7|0)<(3082);
   if ($switch$split92D) {
    switch ($7|0) {
    case 7:  {
     break;
    }
    default: {
     break L1;
    }
    }
   } else {
    switch ($7|0) {
    case 3082:  {
     break;
    }
    default: {
     break L1;
    }
    }
   }
   $8 = ((($0)) + 24|0); //@line 69571 "c/sqlite3.c"
   HEAP32[$8>>2] = 1; //@line 69571 "c/sqlite3.c"
  }
 } while(0);
 HEAP32[$vararg_buffer>>2] = $1; //@line 69572 "c/sqlite3.c"
 _checkAppendMsg($0,35305,$vararg_buffer); //@line 69572 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 69581 "c/sqlite3.c"
}
function _checkTreePage($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0213256 = 0, $$0214 = 0, $$0219241 = 0, $$0219245 = 0, $$0220$lcssa = 0, $$0220$lcssa270 = 0, $$0220254 = 0, $$0223 = 0, $$0228243 = 0, $$0228244 = 0, $$0229 = 0, $$0231252 = 0, $$1215$lcssa = 0, $$1215$lcssa271 = 0, $$1215$lcssa272 = 0, $$1215255 = 0, $$1221 = 0, $$1224253 = 0, $$1230 = 0;
 var $$1249 = 0, $$2225 = 0, $$2247 = 0, $$3 = 0, $$4227 = 0, $$4232 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0;
 var $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0;
 var $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer14 = 0, $vararg_buffer16 = 0, $vararg_buffer20 = 0, $vararg_buffer4 = 0, $vararg_buffer9 = 0, $vararg_ptr19 = 0;
 var $vararg_ptr23 = 0, $vararg_ptr24 = 0, $vararg_ptr7 = 0, $vararg_ptr8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 128|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(128|0);
 $vararg_buffer20 = sp + 96|0;
 $vararg_buffer16 = sp + 88|0;
 $vararg_buffer14 = sp + 80|0;
 $vararg_buffer11 = sp + 72|0;
 $vararg_buffer9 = sp + 64|0;
 $vararg_buffer4 = sp + 48|0;
 $vararg_buffer1 = sp + 40|0;
 $vararg_buffer = sp + 32|0;
 $5 = sp + 24|0;
 $6 = sp + 112|0;
 $7 = sp + 108|0;
 $8 = sp;
 $9 = $5;
 $10 = $9;
 HEAP32[$10>>2] = $3;
 $11 = (($9) + 4)|0;
 $12 = $11;
 HEAP32[$12>>2] = $4;
 HEAP32[$6>>2] = 0; //@line 69730 "c/sqlite3.c"
 $13 = ((($0)) + 28|0); //@line 69751 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 69751 "c/sqlite3.c"
 $15 = ((($0)) + 32|0); //@line 69752 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 69752 "c/sqlite3.c"
 $17 = ((($0)) + 36|0); //@line 69753 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 69753 "c/sqlite3.c"
 $19 = HEAP32[$0>>2]|0; //@line 69758 "c/sqlite3.c"
 $20 = ((($19)) + 36|0); //@line 69759 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 69759 "c/sqlite3.c"
 $22 = ($1|0)==(0); //@line 69760 "c/sqlite3.c"
 if ($22) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 69972 "c/sqlite3.c"
 }
 $23 = (_checkRef($0,$1)|0); //@line 69761 "c/sqlite3.c"
 $24 = ($23|0)==(0); //@line 69761 "c/sqlite3.c"
 if (!($24)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 69972 "c/sqlite3.c"
 }
 HEAP32[$13>>2] = 34925; //@line 69762 "c/sqlite3.c"
 HEAP32[$15>>2] = $1; //@line 69763 "c/sqlite3.c"
 $25 = (_btreeGetPage($19,$1,$6,0)|0); //@line 69764 "c/sqlite3.c"
 $26 = ($25|0)==(0); //@line 69764 "c/sqlite3.c"
 do {
  if ($26) {
   $27 = HEAP32[$6>>2]|0; //@line 69772 "c/sqlite3.c"
   $28 = HEAP8[$27>>0]|0; //@line 69772 "c/sqlite3.c"
   HEAP8[$27>>0] = 0; //@line 69773 "c/sqlite3.c"
   $29 = (_btreeInitPage($27)|0); //@line 69774 "c/sqlite3.c"
   $30 = ($29|0)==(0); //@line 69774 "c/sqlite3.c"
   if (!($30)) {
    HEAP32[$vararg_buffer1>>2] = $29; //@line 69776 "c/sqlite3.c"
    _checkAppendMsg($0,34973,$vararg_buffer1); //@line 69776 "c/sqlite3.c"
    $$4232 = -1;
    break;
   }
   $31 = ((($27)) + 56|0); //@line 69780 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 69780 "c/sqlite3.c"
   $33 = ((($27)) + 9|0); //@line 69781 "c/sqlite3.c"
   $34 = HEAP8[$33>>0]|0; //@line 69781 "c/sqlite3.c"
   $35 = $34&255; //@line 69781 "c/sqlite3.c"
   HEAP32[$13>>2] = 35011; //@line 69784 "c/sqlite3.c"
   $36 = (($35) + 5)|0; //@line 69785 "c/sqlite3.c"
   $37 = (($32) + ($36)|0); //@line 69785 "c/sqlite3.c"
   $38 = HEAP8[$37>>0]|0; //@line 69785 "c/sqlite3.c"
   $39 = $38&255; //@line 69785 "c/sqlite3.c"
   $40 = $39 << 8; //@line 69785 "c/sqlite3.c"
   $41 = ((($37)) + 1|0); //@line 69785 "c/sqlite3.c"
   $42 = HEAP8[$41>>0]|0; //@line 69785 "c/sqlite3.c"
   $43 = $42&255; //@line 69785 "c/sqlite3.c"
   $44 = $40 | $43; //@line 69785 "c/sqlite3.c"
   $45 = (($44) + 65535)|0; //@line 69785 "c/sqlite3.c"
   $46 = $45 & 65535; //@line 69785 "c/sqlite3.c"
   $47 = (($46) + 1)|0; //@line 69785 "c/sqlite3.c"
   $48 = (($35) + 3)|0; //@line 69790 "c/sqlite3.c"
   $49 = (($32) + ($48)|0); //@line 69790 "c/sqlite3.c"
   $50 = HEAP8[$49>>0]|0; //@line 69790 "c/sqlite3.c"
   $51 = $50&255; //@line 69790 "c/sqlite3.c"
   $52 = $51 << 8; //@line 69790 "c/sqlite3.c"
   $53 = ((($49)) + 1|0); //@line 69790 "c/sqlite3.c"
   $54 = HEAP8[$53>>0]|0; //@line 69790 "c/sqlite3.c"
   $55 = $54&255; //@line 69790 "c/sqlite3.c"
   $56 = $52 | $55; //@line 69790 "c/sqlite3.c"
   $57 = (($35) + 12)|0; //@line 69795 "c/sqlite3.c"
   $58 = ((($27)) + 8|0); //@line 69795 "c/sqlite3.c"
   $59 = HEAP8[$58>>0]|0; //@line 69795 "c/sqlite3.c"
   $60 = $59&255; //@line 69795 "c/sqlite3.c"
   $61 = $60 << 2; //@line 69795 "c/sqlite3.c"
   $62 = (($57) - ($61))|0; //@line 69795 "c/sqlite3.c"
   $63 = (($56) + -1)|0; //@line 69797 "c/sqlite3.c"
   $64 = $63 << 1; //@line 69797 "c/sqlite3.c"
   $65 = (($62) + ($64))|0; //@line 69797 "c/sqlite3.c"
   $66 = (($32) + ($65)|0); //@line 69797 "c/sqlite3.c"
   $67 = ($59<<24>>24)==(0); //@line 69799 "c/sqlite3.c"
   if ($67) {
    $68 = (($35) + 8)|0; //@line 69801 "c/sqlite3.c"
    $69 = (($32) + ($68)|0); //@line 69801 "c/sqlite3.c"
    $70 = (_sqlite3Get4byte($69)|0); //@line 69801 "c/sqlite3.c"
    $71 = ((($19)) + 17|0); //@line 69803 "c/sqlite3.c"
    $72 = HEAP8[$71>>0]|0; //@line 69803 "c/sqlite3.c"
    $73 = ($72<<24>>24)==(0); //@line 69803 "c/sqlite3.c"
    if (!($73)) {
     HEAP32[$13>>2] = 35037; //@line 69804 "c/sqlite3.c"
     _checkPtrmap($0,$70,5,$1); //@line 69805 "c/sqlite3.c"
    }
    $74 = (_checkTreePage($0,$70,$5,$3,$4)|0); //@line 69808 "c/sqlite3.c"
    $$0214 = $74;$$0223 = 0;$$0229 = 0;
   } else {
    $75 = ((($0)) + 64|0); //@line 69813 "c/sqlite3.c"
    $76 = HEAP32[$75>>2]|0; //@line 69813 "c/sqlite3.c"
    HEAP32[$76>>2] = 0; //@line 69814 "c/sqlite3.c"
    $$0214 = -1;$$0223 = 1;$$0229 = $76;
   }
   $77 = ((($0)) + 16|0); //@line 69819 "c/sqlite3.c"
   $78 = ($56|0)==(0); //@line 69819 "c/sqlite3.c"
   if ($78) {
    $79 = $5; //@line 69884 "c/sqlite3.c"
    $80 = $79; //@line 69884 "c/sqlite3.c"
    $81 = HEAP32[$80>>2]|0; //@line 69884 "c/sqlite3.c"
    $82 = (($79) + 4)|0; //@line 69884 "c/sqlite3.c"
    $83 = $82; //@line 69884 "c/sqlite3.c"
    $84 = HEAP32[$83>>2]|0; //@line 69884 "c/sqlite3.c"
    $85 = $2; //@line 69884 "c/sqlite3.c"
    $86 = $85; //@line 69884 "c/sqlite3.c"
    HEAP32[$86>>2] = $81; //@line 69884 "c/sqlite3.c"
    $87 = (($85) + 4)|0; //@line 69884 "c/sqlite3.c"
    $88 = $87; //@line 69884 "c/sqlite3.c"
    HEAP32[$88>>2] = $84; //@line 69884 "c/sqlite3.c"
    HEAP32[$13>>2] = 0; //@line 69888 "c/sqlite3.c"
    $$0220$lcssa270 = 1;$$1215$lcssa271 = $$0214;
    label = 38;
   } else {
    $89 = (($21) + -4)|0;
    $90 = (($21) + -4)|0;
    $91 = ((($27)) + 80|0);
    $92 = ((($8)) + 18|0);
    $93 = ((($27)) + 2|0);
    $94 = ((($8)) + 12|0);
    $95 = ((($8)) + 16|0);
    $96 = (($21) + -5)|0;
    $97 = ((($19)) + 17|0);
    $98 = ((($19)) + 17|0);
    $$0213256 = $63;$$0220254 = 1;$$0231252 = $66;$$1215255 = $$0214;$$1224253 = $$0223;
    while(1) {
     $99 = HEAP32[$77>>2]|0; //@line 69819 "c/sqlite3.c"
     $100 = ($99|0)==(0); //@line 69819 "c/sqlite3.c"
     if ($100) {
      $$0220$lcssa = $$0220254;$$1215$lcssa = $$1215255;
      break;
     }
     HEAP32[$17>>2] = $$0213256; //@line 69823 "c/sqlite3.c"
     $101 = HEAP8[$$0231252>>0]|0; //@line 69825 "c/sqlite3.c"
     $102 = $101&255; //@line 69825 "c/sqlite3.c"
     $103 = $102 << 8; //@line 69825 "c/sqlite3.c"
     $104 = ((($$0231252)) + 1|0); //@line 69825 "c/sqlite3.c"
     $105 = HEAP8[$104>>0]|0; //@line 69825 "c/sqlite3.c"
     $106 = $105&255; //@line 69825 "c/sqlite3.c"
     $107 = $103 | $106; //@line 69825 "c/sqlite3.c"
     $108 = ((($$0231252)) + -2|0); //@line 69826 "c/sqlite3.c"
     $109 = ($107>>>0)<=($46>>>0); //@line 69827 "c/sqlite3.c"
     $110 = ($107>>>0)>($89>>>0); //@line 69827 "c/sqlite3.c"
     $or$cond = $109 | $110; //@line 69827 "c/sqlite3.c"
     do {
      if ($or$cond) {
       HEAP32[$vararg_buffer4>>2] = $107; //@line 69828 "c/sqlite3.c"
       $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 69828 "c/sqlite3.c"
       HEAP32[$vararg_ptr7>>2] = $47; //@line 69828 "c/sqlite3.c"
       $vararg_ptr8 = ((($vararg_buffer4)) + 8|0); //@line 69828 "c/sqlite3.c"
       HEAP32[$vararg_ptr8>>2] = $90; //@line 69828 "c/sqlite3.c"
       _checkAppendMsg($0,35065,$vararg_buffer4); //@line 69828 "c/sqlite3.c"
       $$1221 = 0;$$3 = $$1215255;$$4227 = $$1224253;
      } else {
       $111 = (($32) + ($107)|0); //@line 69833 "c/sqlite3.c"
       $112 = HEAP32[$91>>2]|0; //@line 69834 "c/sqlite3.c"
       FUNCTION_TABLE_viii[$112 & 255]($27,$111,$8); //@line 69834 "c/sqlite3.c"
       $113 = HEAP16[$92>>1]|0; //@line 69835 "c/sqlite3.c"
       $114 = $113&65535; //@line 69835 "c/sqlite3.c"
       $115 = (($107) + ($114))|0; //@line 69835 "c/sqlite3.c"
       $116 = ($115>>>0)>($21>>>0); //@line 69835 "c/sqlite3.c"
       if ($116) {
        _checkAppendMsg($0,35095,$vararg_buffer9); //@line 69836 "c/sqlite3.c"
        $$1221 = 0;$$3 = $$1215255;$$4227 = $$1224253;
        break;
       }
       $117 = HEAP8[$93>>0]|0; //@line 69842 "c/sqlite3.c"
       $118 = ($117<<24>>24)==(0); //@line 69842 "c/sqlite3.c"
       if ($118) {
        $$2225 = $$1224253;
       } else {
        $119 = ($$1224253|0)==(0); //@line 69843 "c/sqlite3.c"
        $120 = $8;
        $121 = $120;
        $122 = HEAP32[$121>>2]|0;
        $123 = (($120) + 4)|0;
        $124 = $123;
        $125 = HEAP32[$124>>2]|0;
        $126 = $5;
        $127 = $126;
        $128 = HEAP32[$127>>2]|0;
        $129 = (($126) + 4)|0;
        $130 = $129;
        $131 = HEAP32[$130>>2]|0;
        if ($119) {
         $137 = ($125|0)<($131|0); //@line 69843 "c/sqlite3.c"
         $138 = ($122>>>0)<($128>>>0); //@line 69843 "c/sqlite3.c"
         $139 = ($125|0)==($131|0); //@line 69843 "c/sqlite3.c"
         $140 = $139 & $138; //@line 69843 "c/sqlite3.c"
         $141 = $137 | $140; //@line 69843 "c/sqlite3.c"
         if (!($141)) {
          label = 24;
         }
        } else {
         $132 = ($125|0)>($131|0); //@line 69843 "c/sqlite3.c"
         $133 = ($122>>>0)>($128>>>0); //@line 69843 "c/sqlite3.c"
         $134 = ($125|0)==($131|0); //@line 69843 "c/sqlite3.c"
         $135 = $134 & $133; //@line 69843 "c/sqlite3.c"
         $136 = $132 | $135; //@line 69843 "c/sqlite3.c"
         if ($136) {
          label = 24;
         }
        }
        if ((label|0) == 24) {
         label = 0;
         $142 = $vararg_buffer11; //@line 69844 "c/sqlite3.c"
         $143 = $142; //@line 69844 "c/sqlite3.c"
         HEAP32[$143>>2] = $122; //@line 69844 "c/sqlite3.c"
         $144 = (($142) + 4)|0; //@line 69844 "c/sqlite3.c"
         $145 = $144; //@line 69844 "c/sqlite3.c"
         HEAP32[$145>>2] = $125; //@line 69844 "c/sqlite3.c"
         _checkAppendMsg($0,35119,$vararg_buffer11); //@line 69844 "c/sqlite3.c"
        }
        $146 = $8; //@line 69846 "c/sqlite3.c"
        $147 = $146; //@line 69846 "c/sqlite3.c"
        $148 = HEAP32[$147>>2]|0; //@line 69846 "c/sqlite3.c"
        $149 = (($146) + 4)|0; //@line 69846 "c/sqlite3.c"
        $150 = $149; //@line 69846 "c/sqlite3.c"
        $151 = HEAP32[$150>>2]|0; //@line 69846 "c/sqlite3.c"
        $152 = $5; //@line 69846 "c/sqlite3.c"
        $153 = $152; //@line 69846 "c/sqlite3.c"
        HEAP32[$153>>2] = $148; //@line 69846 "c/sqlite3.c"
        $154 = (($152) + 4)|0; //@line 69846 "c/sqlite3.c"
        $155 = $154; //@line 69846 "c/sqlite3.c"
        HEAP32[$155>>2] = $151; //@line 69846 "c/sqlite3.c"
        $$2225 = 0;
       }
       $156 = HEAP32[$94>>2]|0; //@line 69851 "c/sqlite3.c"
       $157 = HEAP16[$95>>1]|0; //@line 69851 "c/sqlite3.c"
       $158 = $157&65535; //@line 69851 "c/sqlite3.c"
       $159 = ($156>>>0)>($158>>>0); //@line 69851 "c/sqlite3.c"
       if ($159) {
        $160 = (($96) + ($156))|0; //@line 69855 "c/sqlite3.c"
        $161 = (($160) - ($158))|0; //@line 69855 "c/sqlite3.c"
        $162 = (($161>>>0) / ($89>>>0))&-1; //@line 69855 "c/sqlite3.c"
        $163 = HEAP16[$92>>1]|0; //@line 69856 "c/sqlite3.c"
        $164 = $163&65535; //@line 69856 "c/sqlite3.c"
        $165 = (($164) + -4)|0; //@line 69856 "c/sqlite3.c"
        $166 = (($111) + ($165)|0); //@line 69856 "c/sqlite3.c"
        $167 = (_sqlite3Get4byte($166)|0); //@line 69856 "c/sqlite3.c"
        $168 = HEAP8[$97>>0]|0; //@line 69858 "c/sqlite3.c"
        $169 = ($168<<24>>24)==(0); //@line 69858 "c/sqlite3.c"
        if (!($169)) {
         _checkPtrmap($0,$167,3,$1); //@line 69859 "c/sqlite3.c"
        }
        _checkList($0,0,$167,$162); //@line 69862 "c/sqlite3.c"
       }
       $170 = HEAP8[$58>>0]|0; //@line 69865 "c/sqlite3.c"
       $171 = ($170<<24>>24)==(0); //@line 69865 "c/sqlite3.c"
       if (!($171)) {
        $183 = $107 << 16; //@line 69881 "c/sqlite3.c"
        $184 = HEAP16[$92>>1]|0; //@line 69881 "c/sqlite3.c"
        $185 = $184&65535; //@line 69881 "c/sqlite3.c"
        $186 = (($107) + -1)|0; //@line 69881 "c/sqlite3.c"
        $187 = (($186) + ($185))|0; //@line 69881 "c/sqlite3.c"
        $188 = $187 | $183; //@line 69881 "c/sqlite3.c"
        _btreeHeapInsert($$0229,$188); //@line 69881 "c/sqlite3.c"
        $$1221 = $$0220254;$$3 = $$1215255;$$4227 = $$2225;
        break;
       }
       $172 = (_sqlite3Get4byte($111)|0); //@line 69867 "c/sqlite3.c"
       $173 = HEAP8[$98>>0]|0; //@line 69869 "c/sqlite3.c"
       $174 = ($173<<24>>24)==(0); //@line 69869 "c/sqlite3.c"
       if (!($174)) {
        _checkPtrmap($0,$172,5,$1); //@line 69870 "c/sqlite3.c"
       }
       $175 = $5; //@line 69873 "c/sqlite3.c"
       $176 = $175; //@line 69873 "c/sqlite3.c"
       $177 = HEAP32[$176>>2]|0; //@line 69873 "c/sqlite3.c"
       $178 = (($175) + 4)|0; //@line 69873 "c/sqlite3.c"
       $179 = $178; //@line 69873 "c/sqlite3.c"
       $180 = HEAP32[$179>>2]|0; //@line 69873 "c/sqlite3.c"
       $181 = (_checkTreePage($0,$172,$5,$177,$180)|0); //@line 69873 "c/sqlite3.c"
       $182 = ($181|0)==($$1215255|0); //@line 69875 "c/sqlite3.c"
       if ($182) {
        $$1221 = $$0220254;$$3 = $$1215255;$$4227 = 0;
       } else {
        _checkAppendMsg($0,35143,$vararg_buffer14); //@line 69876 "c/sqlite3.c"
        $$1221 = $$0220254;$$3 = $181;$$4227 = 0;
       }
      }
     } while(0);
     $189 = (($$0213256) + -1)|0; //@line 69819 "c/sqlite3.c"
     $190 = ($$0213256|0)>(0); //@line 69819 "c/sqlite3.c"
     if ($190) {
      $$0213256 = $189;$$0220254 = $$1221;$$0231252 = $108;$$1215255 = $$3;$$1224253 = $$4227;
     } else {
      $$0220$lcssa = $$1221;$$1215$lcssa = $$3;
      break;
     }
    }
    $191 = $5; //@line 69884 "c/sqlite3.c"
    $192 = $191; //@line 69884 "c/sqlite3.c"
    $193 = HEAP32[$192>>2]|0; //@line 69884 "c/sqlite3.c"
    $194 = (($191) + 4)|0; //@line 69884 "c/sqlite3.c"
    $195 = $194; //@line 69884 "c/sqlite3.c"
    $196 = HEAP32[$195>>2]|0; //@line 69884 "c/sqlite3.c"
    $197 = $2; //@line 69884 "c/sqlite3.c"
    $198 = $197; //@line 69884 "c/sqlite3.c"
    HEAP32[$198>>2] = $193; //@line 69884 "c/sqlite3.c"
    $199 = (($197) + 4)|0; //@line 69884 "c/sqlite3.c"
    $200 = $199; //@line 69884 "c/sqlite3.c"
    HEAP32[$200>>2] = $196; //@line 69884 "c/sqlite3.c"
    HEAP32[$13>>2] = 0; //@line 69888 "c/sqlite3.c"
    $201 = ($$0220$lcssa|0)==(0); //@line 69889 "c/sqlite3.c"
    if ($201) {
     $$1215$lcssa272 = $$1215$lcssa;
    } else {
     $$0220$lcssa270 = $$0220$lcssa;$$1215$lcssa271 = $$1215$lcssa;
     label = 38;
    }
   }
   if ((label|0) == 38) {
    $202 = ((($0)) + 16|0); //@line 69889 "c/sqlite3.c"
    $203 = HEAP32[$202>>2]|0; //@line 69889 "c/sqlite3.c"
    $204 = ($203|0)>(0); //@line 69889 "c/sqlite3.c"
    if (!($204)) {
     $$4232 = $$1215$lcssa271;
     break;
    }
    $205 = HEAP8[$58>>0]|0; //@line 69893 "c/sqlite3.c"
    $206 = ($205<<24>>24)==(0); //@line 69893 "c/sqlite3.c"
    if ($206) {
     $207 = ((($0)) + 64|0); //@line 69894 "c/sqlite3.c"
     $208 = HEAP32[$207>>2]|0; //@line 69894 "c/sqlite3.c"
     HEAP32[$208>>2] = 0; //@line 69895 "c/sqlite3.c"
     $209 = ($56|0)==(0); //@line 69896 "c/sqlite3.c"
     if ($209) {
      $$1230 = $208;
     } else {
      $210 = ((($27)) + 76|0);
      $$1249 = $63;
      while(1) {
       $211 = $$1249 << 1; //@line 69898 "c/sqlite3.c"
       $212 = (($211) + ($62))|0; //@line 69898 "c/sqlite3.c"
       $213 = (($32) + ($212)|0); //@line 69898 "c/sqlite3.c"
       $214 = HEAP8[$213>>0]|0; //@line 69898 "c/sqlite3.c"
       $215 = $214&255; //@line 69898 "c/sqlite3.c"
       $216 = $215 << 8; //@line 69898 "c/sqlite3.c"
       $217 = ((($213)) + 1|0); //@line 69898 "c/sqlite3.c"
       $218 = HEAP8[$217>>0]|0; //@line 69898 "c/sqlite3.c"
       $219 = $218&255; //@line 69898 "c/sqlite3.c"
       $220 = $216 | $219; //@line 69898 "c/sqlite3.c"
       $221 = HEAP32[$210>>2]|0; //@line 69899 "c/sqlite3.c"
       $222 = (($32) + ($220)|0); //@line 69899 "c/sqlite3.c"
       $223 = (FUNCTION_TABLE_iii[$221 & 255]($27,$222)|0); //@line 69899 "c/sqlite3.c"
       $224 = $223&65535; //@line 69899 "c/sqlite3.c"
       $225 = $220 << 16; //@line 69900 "c/sqlite3.c"
       $226 = (($220) + -1)|0; //@line 69900 "c/sqlite3.c"
       $227 = (($226) + ($224))|0; //@line 69900 "c/sqlite3.c"
       $228 = $227 | $225; //@line 69900 "c/sqlite3.c"
       _btreeHeapInsert($208,$228); //@line 69900 "c/sqlite3.c"
       $229 = (($$1249) + -1)|0; //@line 69896 "c/sqlite3.c"
       $230 = ($$1249|0)>(0); //@line 69896 "c/sqlite3.c"
       if ($230) {
        $$1249 = $229;
       } else {
        $$1230 = $208;
        break;
       }
      }
     }
    } else {
     $$1230 = $$0229;
    }
    $231 = (($35) + 1)|0; //@line 69909 "c/sqlite3.c"
    $232 = (($32) + ($231)|0); //@line 69909 "c/sqlite3.c"
    $233 = HEAP8[$232>>0]|0; //@line 69909 "c/sqlite3.c"
    $234 = $233&255; //@line 69909 "c/sqlite3.c"
    $235 = $234 << 8; //@line 69909 "c/sqlite3.c"
    $236 = ((($232)) + 1|0); //@line 69909 "c/sqlite3.c"
    $237 = HEAP8[$236>>0]|0; //@line 69909 "c/sqlite3.c"
    $238 = $237&255; //@line 69909 "c/sqlite3.c"
    $239 = $235 | $238; //@line 69909 "c/sqlite3.c"
    $240 = ($239|0)==(0); //@line 69910 "c/sqlite3.c"
    if (!($240)) {
     $$2247 = $239;
     while(1) {
      $241 = (($$2247) + 2)|0; //@line 69913 "c/sqlite3.c"
      $242 = (($32) + ($241)|0); //@line 69913 "c/sqlite3.c"
      $243 = HEAP8[$242>>0]|0; //@line 69913 "c/sqlite3.c"
      $244 = $243&255; //@line 69913 "c/sqlite3.c"
      $245 = $244 << 8; //@line 69913 "c/sqlite3.c"
      $246 = ((($242)) + 1|0); //@line 69913 "c/sqlite3.c"
      $247 = HEAP8[$246>>0]|0; //@line 69913 "c/sqlite3.c"
      $248 = $247&255; //@line 69913 "c/sqlite3.c"
      $249 = $245 | $248; //@line 69913 "c/sqlite3.c"
      $250 = $$2247 << 16; //@line 69915 "c/sqlite3.c"
      $251 = (($$2247) + -1)|0; //@line 69915 "c/sqlite3.c"
      $252 = (($251) + ($249))|0; //@line 69915 "c/sqlite3.c"
      $253 = $252 | $250; //@line 69915 "c/sqlite3.c"
      _btreeHeapInsert($$1230,$253); //@line 69915 "c/sqlite3.c"
      $254 = (($32) + ($$2247)|0); //@line 69920 "c/sqlite3.c"
      $255 = HEAP8[$254>>0]|0; //@line 69920 "c/sqlite3.c"
      $256 = $255&255; //@line 69920 "c/sqlite3.c"
      $257 = $256 << 8; //@line 69920 "c/sqlite3.c"
      $258 = ((($254)) + 1|0); //@line 69920 "c/sqlite3.c"
      $259 = HEAP8[$258>>0]|0; //@line 69920 "c/sqlite3.c"
      $260 = $259&255; //@line 69920 "c/sqlite3.c"
      $261 = $257 | $260; //@line 69920 "c/sqlite3.c"
      $262 = ($261|0)==(0); //@line 69910 "c/sqlite3.c"
      if ($262) {
       break;
      } else {
       $$2247 = $261;
      }
     }
    }
    $263 = (_btreeHeapPull($$1230,$7)|0); //@line 69942 "c/sqlite3.c"
    $264 = ($263|0)==(0); //@line 69942 "c/sqlite3.c"
    L69: do {
     if ($264) {
      $$0219241 = 0;$$0228243 = $46;
     } else {
      $$0219245 = 0;$$0228244 = $46;
      while(1) {
       $265 = $$0228244 & 65535; //@line 69943 "c/sqlite3.c"
       $266 = HEAP32[$7>>2]|0; //@line 69943 "c/sqlite3.c"
       $267 = $266 >>> 16; //@line 69943 "c/sqlite3.c"
       $268 = ($267>>>0)>($265>>>0); //@line 69943 "c/sqlite3.c"
       if (!($268)) {
        break;
       }
       $269 = (($$0219245) + -1)|0; //@line 69948 "c/sqlite3.c"
       $270 = (($269) - ($265))|0; //@line 69948 "c/sqlite3.c"
       $271 = (($270) + ($267))|0; //@line 69948 "c/sqlite3.c"
       $272 = (_btreeHeapPull($$1230,$7)|0); //@line 69942 "c/sqlite3.c"
       $273 = ($272|0)==(0); //@line 69942 "c/sqlite3.c"
       if ($273) {
        $$0219241 = $271;$$0228243 = $266;
        break L69;
       } else {
        $$0219245 = $271;$$0228244 = $266;
       }
      }
      HEAP32[$vararg_buffer16>>2] = $267; //@line 69944 "c/sqlite3.c"
      $vararg_ptr19 = ((($vararg_buffer16)) + 4|0); //@line 69944 "c/sqlite3.c"
      HEAP32[$vararg_ptr19>>2] = $1; //@line 69944 "c/sqlite3.c"
      _checkAppendMsg($0,35168,$vararg_buffer16); //@line 69944 "c/sqlite3.c"
      $$0219241 = $$0219245;$$0228243 = $$0228244;
     }
    } while(0);
    $274 = $$0228243 & 65535; //@line 69952 "c/sqlite3.c"
    $275 = (($$0219241) + -1)|0; //@line 69952 "c/sqlite3.c"
    $276 = (($275) + ($21))|0; //@line 69952 "c/sqlite3.c"
    $277 = (($276) - ($274))|0; //@line 69952 "c/sqlite3.c"
    $278 = HEAP32[$$1230>>2]|0; //@line 69958 "c/sqlite3.c"
    $279 = ($278|0)==(0); //@line 69958 "c/sqlite3.c"
    if ($279) {
     $280 = (($35) + 7)|0; //@line 69958 "c/sqlite3.c"
     $281 = (($32) + ($280)|0); //@line 69958 "c/sqlite3.c"
     $282 = HEAP8[$281>>0]|0; //@line 69958 "c/sqlite3.c"
     $283 = $282&255; //@line 69958 "c/sqlite3.c"
     $284 = ($277|0)==($283|0); //@line 69958 "c/sqlite3.c"
     if (!($284)) {
      HEAP32[$vararg_buffer20>>2] = $277; //@line 69959 "c/sqlite3.c"
      $vararg_ptr23 = ((($vararg_buffer20)) + 4|0); //@line 69959 "c/sqlite3.c"
      HEAP32[$vararg_ptr23>>2] = $283; //@line 69959 "c/sqlite3.c"
      $vararg_ptr24 = ((($vararg_buffer20)) + 8|0); //@line 69959 "c/sqlite3.c"
      HEAP32[$vararg_ptr24>>2] = $1; //@line 69959 "c/sqlite3.c"
      _checkAppendMsg($0,35205,$vararg_buffer20); //@line 69959 "c/sqlite3.c"
     }
    }
    $285 = ($$0220$lcssa270|0)==(0); //@line 69966 "c/sqlite3.c"
    if ($285) {
     $$1215$lcssa272 = $$1215$lcssa271;
    } else {
     $$4232 = $$1215$lcssa271;
     break;
    }
   }
   $286 = HEAP32[$6>>2]|0; //@line 69966 "c/sqlite3.c"
   HEAP8[$286>>0] = $28; //@line 69966 "c/sqlite3.c"
   $$4232 = $$1215$lcssa272;
  } else {
   HEAP32[$vararg_buffer>>2] = $25; //@line 69765 "c/sqlite3.c"
   _checkAppendMsg($0,34935,$vararg_buffer); //@line 69765 "c/sqlite3.c"
   $$4232 = -1;
  }
 } while(0);
 $287 = HEAP32[$6>>2]|0; //@line 69967 "c/sqlite3.c"
 _releasePage($287); //@line 69967 "c/sqlite3.c"
 HEAP32[$13>>2] = $14; //@line 69968 "c/sqlite3.c"
 HEAP32[$15>>2] = $16; //@line 69969 "c/sqlite3.c"
 HEAP32[$17>>2] = $18; //@line 69970 "c/sqlite3.c"
 $288 = (($$4232) + 1)|0; //@line 69971 "c/sqlite3.c"
 $$0 = $288;
 STACKTOP = sp;return ($$0|0); //@line 69972 "c/sqlite3.c"
}
function _getPageReferenced($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 8|0); //@line 69519 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 69519 "c/sqlite3.c"
 $4 = $1 >>> 3; //@line 69519 "c/sqlite3.c"
 $5 = (($3) + ($4)|0); //@line 69519 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 69519 "c/sqlite3.c"
 $7 = $6&255; //@line 69519 "c/sqlite3.c"
 $8 = $1 & 7; //@line 69519 "c/sqlite3.c"
 $9 = 1 << $8; //@line 69519 "c/sqlite3.c"
 $10 = $9 & $7; //@line 69519 "c/sqlite3.c"
 return ($10|0); //@line 69519 "c/sqlite3.c"
}
function _checkAppendMsg($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $2 = sp + 8|0;
 $3 = ((($0)) + 16|0); //@line 69493 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 69493 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 69493 "c/sqlite3.c"
 if ($5) {
  STACKTOP = sp;return; //@line 69508 "c/sqlite3.c"
 }
 $6 = (($4) + -1)|0; //@line 69494 "c/sqlite3.c"
 HEAP32[$3>>2] = $6; //@line 69494 "c/sqlite3.c"
 $7 = ((($0)) + 20|0); //@line 69495 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 69495 "c/sqlite3.c"
 $9 = (($8) + 1)|0; //@line 69495 "c/sqlite3.c"
 HEAP32[$7>>2] = $9; //@line 69495 "c/sqlite3.c"
 HEAP32[$2>>2] = $varargs; //@line 69496 "c/sqlite3.c"
 $10 = ((($0)) + 40|0); //@line 69497 "c/sqlite3.c"
 $11 = ((($0)) + 56|0); //@line 69497 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 69497 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 69497 "c/sqlite3.c"
 if (!($13)) {
  _sqlite3StrAccumAppend($10,34923,1); //@line 69498 "c/sqlite3.c"
 }
 $14 = ((($0)) + 28|0); //@line 69500 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 69500 "c/sqlite3.c"
 $16 = ($15|0)==(0|0); //@line 69500 "c/sqlite3.c"
 if (!($16)) {
  $17 = ((($0)) + 32|0); //@line 69501 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 69501 "c/sqlite3.c"
  $19 = ((($0)) + 36|0); //@line 69501 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 69501 "c/sqlite3.c"
  HEAP32[$vararg_buffer>>2] = $18; //@line 69501 "c/sqlite3.c"
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 69501 "c/sqlite3.c"
  HEAP32[$vararg_ptr1>>2] = $20; //@line 69501 "c/sqlite3.c"
  _sqlite3XPrintf($10,$15,$vararg_buffer); //@line 69501 "c/sqlite3.c"
 }
 _sqlite3VXPrintf($10,$1,$2); //@line 69503 "c/sqlite3.c"
 $21 = ((($0)) + 60|0); //@line 69505 "c/sqlite3.c"
 $22 = HEAP8[$21>>0]|0; //@line 69505 "c/sqlite3.c"
 $23 = ($22<<24>>24)==(1); //@line 69505 "c/sqlite3.c"
 if (!($23)) {
  STACKTOP = sp;return; //@line 69508 "c/sqlite3.c"
 }
 $24 = ((($0)) + 24|0); //@line 69506 "c/sqlite3.c"
 HEAP32[$24>>2] = 1; //@line 69506 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 69508 "c/sqlite3.c"
}
function _checkRef($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 69539 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 69539 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 69540 "c/sqlite3.c"
 do {
  if ($2) {
   $$0 = 1;
  } else {
   $3 = ((($0)) + 12|0); //@line 69541 "c/sqlite3.c"
   $4 = HEAP32[$3>>2]|0; //@line 69541 "c/sqlite3.c"
   $5 = ($4>>>0)<($1>>>0); //@line 69541 "c/sqlite3.c"
   if ($5) {
    HEAP32[$vararg_buffer>>2] = $1; //@line 69542 "c/sqlite3.c"
    _checkAppendMsg($0,35257,$vararg_buffer); //@line 69542 "c/sqlite3.c"
    $$0 = 1;
    break;
   }
   $6 = (_getPageReferenced($0,$1)|0); //@line 69545 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 69545 "c/sqlite3.c"
   if ($7) {
    _setPageReferenced($0,$1); //@line 69549 "c/sqlite3.c"
    $$0 = 0;
    break;
   } else {
    HEAP32[$vararg_buffer1>>2] = $1; //@line 69546 "c/sqlite3.c"
    _checkAppendMsg($0,35280,$vararg_buffer1); //@line 69546 "c/sqlite3.c"
    $$0 = 1;
    break;
   }
  }
 } while(0);
 STACKTOP = sp;return ($$0|0); //@line 69551 "c/sqlite3.c"
}
function _btreeHeapInsert($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$021 = 0, $$021$phi = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 69681 "c/sqlite3.c"
 $3 = (($2) + 1)|0; //@line 69681 "c/sqlite3.c"
 HEAP32[$0>>2] = $3; //@line 69681 "c/sqlite3.c"
 $4 = (($0) + ($3<<2)|0); //@line 69682 "c/sqlite3.c"
 HEAP32[$4>>2] = $1; //@line 69682 "c/sqlite3.c"
 $5 = $3 >>> 1; //@line 69683 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 69683 "c/sqlite3.c"
 if ($6) {
  return; //@line 69689 "c/sqlite3.c"
 }
 $$021 = $3;$8 = $5;
 while(1) {
  $7 = (($0) + ($8<<2)|0); //@line 69683 "c/sqlite3.c"
  $9 = HEAP32[$7>>2]|0; //@line 69683 "c/sqlite3.c"
  $10 = (($0) + ($$021<<2)|0); //@line 69683 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 69683 "c/sqlite3.c"
  $12 = ($9>>>0)>($11>>>0); //@line 69683 "c/sqlite3.c"
  if (!($12)) {
   label = 5;
   break;
  }
  HEAP32[$7>>2] = $11; //@line 69685 "c/sqlite3.c"
  HEAP32[$10>>2] = $9; //@line 69686 "c/sqlite3.c"
  $13 = $8 >>> 1; //@line 69683 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 69683 "c/sqlite3.c"
  if ($14) {
   label = 5;
   break;
  } else {
   $$021$phi = $8;$8 = $13;$$021 = $$021$phi;
  }
 }
 if ((label|0) == 5) {
  return; //@line 69689 "c/sqlite3.c"
 }
}
function _btreeHeapPull($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$036 = 0, $$037 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 69692 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 69692 "c/sqlite3.c"
 if ($3) {
  $$036 = 0;
  return ($$036|0); //@line 69707 "c/sqlite3.c"
 }
 $4 = ((($0)) + 4|0); //@line 69693 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 69693 "c/sqlite3.c"
 HEAP32[$1>>2] = $5; //@line 69693 "c/sqlite3.c"
 $6 = (($0) + ($2<<2)|0); //@line 69694 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 69694 "c/sqlite3.c"
 HEAP32[$4>>2] = $7; //@line 69694 "c/sqlite3.c"
 HEAP32[$6>>2] = -1; //@line 69695 "c/sqlite3.c"
 $8 = HEAP32[$0>>2]|0; //@line 69696 "c/sqlite3.c"
 $9 = (($8) + -1)|0; //@line 69696 "c/sqlite3.c"
 HEAP32[$0>>2] = $9; //@line 69696 "c/sqlite3.c"
 $10 = ($9>>>0)<(2); //@line 69698 "c/sqlite3.c"
 if ($10) {
  $$036 = 1;
  return ($$036|0); //@line 69707 "c/sqlite3.c"
 }
 $$037 = 1;$12 = 2;
 while(1) {
  $11 = (($0) + ($12<<2)|0); //@line 69699 "c/sqlite3.c"
  $13 = HEAP32[$11>>2]|0; //@line 69699 "c/sqlite3.c"
  $14 = $12 | 1; //@line 69699 "c/sqlite3.c"
  $15 = (($0) + ($14<<2)|0); //@line 69699 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 69699 "c/sqlite3.c"
  $17 = ($13>>>0)>($16>>>0); //@line 69699 "c/sqlite3.c"
  $spec$select = $17 ? $14 : $12; //@line 69699 "c/sqlite3.c"
  $18 = (($0) + ($$037<<2)|0); //@line 69700 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 69700 "c/sqlite3.c"
  $20 = (($0) + ($spec$select<<2)|0); //@line 69700 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 69700 "c/sqlite3.c"
  $22 = ($19>>>0)<($21>>>0); //@line 69700 "c/sqlite3.c"
  if ($22) {
   $$036 = 1;
   label = 6;
   break;
  }
  HEAP32[$18>>2] = $21; //@line 69702 "c/sqlite3.c"
  HEAP32[$20>>2] = $19; //@line 69703 "c/sqlite3.c"
  $23 = $spec$select << 1; //@line 69698 "c/sqlite3.c"
  $24 = HEAP32[$0>>2]|0; //@line 69698 "c/sqlite3.c"
  $25 = ($23>>>0)>($24>>>0); //@line 69698 "c/sqlite3.c"
  if ($25) {
   $$036 = 1;
   label = 6;
   break;
  } else {
   $$037 = $spec$select;$12 = $23;
  }
 }
 if ((label|0) == 6) {
  return ($$036|0); //@line 69707 "c/sqlite3.c"
 }
 return (0)|0;
}
function _invalidateIncrblobCursors($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$013 = 0, $$014 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 11|0); //@line 60940 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 60940 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 60940 "c/sqlite3.c"
 if ($7) {
  return; //@line 60951 "c/sqlite3.c"
 }
 HEAP8[$5>>0] = 0; //@line 60942 "c/sqlite3.c"
 $8 = ((($0)) + 4|0); //@line 60943 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 60943 "c/sqlite3.c"
 $10 = ((($9)) + 8|0); //@line 60943 "c/sqlite3.c"
 $$013 = HEAP32[$10>>2]|0;
 $11 = ($$013|0)==(0|0); //@line 60943 "c/sqlite3.c"
 if ($11) {
  return; //@line 60951 "c/sqlite3.c"
 }
 $12 = ($4|0)==(0);
 $$014 = $$013;
 while(1) {
  $13 = ((($$014)) + 1|0); //@line 60944 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 60944 "c/sqlite3.c"
  $15 = $14 & 16; //@line 60944 "c/sqlite3.c"
  $16 = ($15<<24>>24)==(0); //@line 60944 "c/sqlite3.c"
  do {
   if (!($16)) {
    HEAP8[$5>>0] = 1; //@line 60945 "c/sqlite3.c"
    $17 = ((($$014)) + 60|0); //@line 60946 "c/sqlite3.c"
    $18 = HEAP32[$17>>2]|0; //@line 60946 "c/sqlite3.c"
    $19 = ($18|0)==($1|0); //@line 60946 "c/sqlite3.c"
    if ($19) {
     if ($12) {
      $20 = ((($$014)) + 24|0); //@line 60946 "c/sqlite3.c"
      $21 = $20; //@line 60946 "c/sqlite3.c"
      $22 = $21; //@line 60946 "c/sqlite3.c"
      $23 = HEAP32[$22>>2]|0; //@line 60946 "c/sqlite3.c"
      $24 = (($21) + 4)|0; //@line 60946 "c/sqlite3.c"
      $25 = $24; //@line 60946 "c/sqlite3.c"
      $26 = HEAP32[$25>>2]|0; //@line 60946 "c/sqlite3.c"
      $27 = ($23|0)==($2|0); //@line 60946 "c/sqlite3.c"
      $28 = ($26|0)==($3|0); //@line 60946 "c/sqlite3.c"
      $29 = $27 & $28; //@line 60946 "c/sqlite3.c"
      if (!($29)) {
       break;
      }
     }
     HEAP8[$$014>>0] = 0; //@line 60947 "c/sqlite3.c"
    }
   }
  } while(0);
  $30 = ((($$014)) + 16|0); //@line 60943 "c/sqlite3.c"
  $$0 = HEAP32[$30>>2]|0;
  $31 = ($$0|0)==(0|0); //@line 60943 "c/sqlite3.c"
  if ($31) {
   break;
  } else {
   $$014 = $$0;
  }
 }
 return; //@line 60951 "c/sqlite3.c"
}
function _clearDatabasePage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$02426 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $4 = sp + 28|0;
 $5 = sp + 24|0;
 $6 = sp;
 $7 = (_btreePagecount($0)|0); //@line 69134 "c/sqlite3.c"
 $8 = ($7>>>0)<($1>>>0); //@line 69134 "c/sqlite3.c"
 if ($8) {
  $9 = (_sqlite3CorruptError(69135)|0); //@line 69135 "c/sqlite3.c"
  $$0 = $9;
  STACKTOP = sp;return ($$0|0); //@line 69172 "c/sqlite3.c"
 }
 $10 = (_getAndInitPage($0,$1,$4,0,0)|0); //@line 69137 "c/sqlite3.c"
 HEAP32[$5>>2] = $10; //@line 69137 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 69138 "c/sqlite3.c"
 if (!($11)) {
  $$0 = $10;
  STACKTOP = sp;return ($$0|0); //@line 69172 "c/sqlite3.c"
 }
 $12 = HEAP32[$4>>2]|0; //@line 69139 "c/sqlite3.c"
 $13 = ((($12)) + 1|0); //@line 69139 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 69139 "c/sqlite3.c"
 $15 = ($14<<24>>24)==(0); //@line 69139 "c/sqlite3.c"
 L8: do {
  if ($15) {
   HEAP8[$13>>0] = 1; //@line 69143 "c/sqlite3.c"
   $17 = ((($12)) + 9|0); //@line 69144 "c/sqlite3.c"
   $18 = HEAP8[$17>>0]|0; //@line 69144 "c/sqlite3.c"
   $19 = $18&255; //@line 69144 "c/sqlite3.c"
   $20 = ((($12)) + 22|0); //@line 69145 "c/sqlite3.c"
   $21 = HEAP16[$20>>1]|0; //@line 69145 "c/sqlite3.c"
   $22 = ($21<<16>>16)==(0); //@line 69145 "c/sqlite3.c"
   do {
    if ($22) {
     $$lcssa = 0;
    } else {
     $23 = ((($12)) + 56|0);
     $24 = ((($12)) + 24|0);
     $25 = ((($12)) + 64|0);
     $26 = ((($12)) + 8|0);
     $$02426 = 0;
     while(1) {
      $31 = HEAP32[$23>>2]|0; //@line 69146 "c/sqlite3.c"
      $32 = HEAP16[$24>>1]|0; //@line 69146 "c/sqlite3.c"
      $33 = $32&65535; //@line 69146 "c/sqlite3.c"
      $34 = HEAP32[$25>>2]|0; //@line 69146 "c/sqlite3.c"
      $35 = $$02426 << 1; //@line 69146 "c/sqlite3.c"
      $36 = (($34) + ($35)|0); //@line 69146 "c/sqlite3.c"
      $37 = HEAP8[$36>>0]|0; //@line 69146 "c/sqlite3.c"
      $38 = $37&255; //@line 69146 "c/sqlite3.c"
      $39 = $38 << 8; //@line 69146 "c/sqlite3.c"
      $40 = ((($36)) + 1|0); //@line 69146 "c/sqlite3.c"
      $41 = HEAP8[$40>>0]|0; //@line 69146 "c/sqlite3.c"
      $42 = $41&255; //@line 69146 "c/sqlite3.c"
      $43 = $39 | $42; //@line 69146 "c/sqlite3.c"
      $44 = $43 & $33; //@line 69146 "c/sqlite3.c"
      $45 = (($31) + ($44)|0); //@line 69146 "c/sqlite3.c"
      $46 = HEAP8[$26>>0]|0; //@line 69147 "c/sqlite3.c"
      $47 = ($46<<24>>24)==(0); //@line 69147 "c/sqlite3.c"
      if ($47) {
       $48 = (_sqlite3Get4byte($45)|0); //@line 69148 "c/sqlite3.c"
       $49 = (_clearDatabasePage($0,$48,1,$3)|0); //@line 69148 "c/sqlite3.c"
       $50 = ($49|0)==(0); //@line 69149 "c/sqlite3.c"
       if (!($50)) {
        $78 = $49;
        label = 21;
        break;
       }
      }
      $51 = (_clearCell($12,$45,$6)|0); //@line 69151 "c/sqlite3.c"
      $52 = ($51|0)==(0); //@line 69152 "c/sqlite3.c"
      $30 = (($$02426) + 1)|0; //@line 69145 "c/sqlite3.c"
      if (!($52)) {
       $78 = $51;
       label = 21;
       break;
      }
      $27 = HEAP16[$20>>1]|0; //@line 69145 "c/sqlite3.c"
      $28 = $27&65535; //@line 69145 "c/sqlite3.c"
      $29 = ($30>>>0)<($28>>>0); //@line 69145 "c/sqlite3.c"
      if ($29) {
       $$02426 = $30;
      } else {
       label = 12;
       break;
      }
     }
     if ((label|0) == 12) {
      HEAP32[$5>>2] = $51; //@line 69151 "c/sqlite3.c"
      $53 = $27&65535; //@line 69145 "c/sqlite3.c"
      $$lcssa = $53;
      break;
     }
     else if ((label|0) == 21) {
      HEAP32[$5>>2] = $78; //@line 69151 "c/sqlite3.c"
      break L8;
     }
    }
   } while(0);
   $54 = ((($12)) + 8|0); //@line 69154 "c/sqlite3.c"
   $55 = HEAP8[$54>>0]|0; //@line 69154 "c/sqlite3.c"
   $56 = ($55<<24>>24)==(0); //@line 69154 "c/sqlite3.c"
   if ($56) {
    $57 = ((($12)) + 56|0); //@line 69155 "c/sqlite3.c"
    $58 = HEAP32[$57>>2]|0; //@line 69155 "c/sqlite3.c"
    $59 = (($19) + 8)|0; //@line 69155 "c/sqlite3.c"
    $60 = (($58) + ($59)|0); //@line 69155 "c/sqlite3.c"
    $61 = (_sqlite3Get4byte($60)|0); //@line 69155 "c/sqlite3.c"
    $62 = (_clearDatabasePage($0,$61,1,$3)|0); //@line 69155 "c/sqlite3.c"
    HEAP32[$5>>2] = $62; //@line 69155 "c/sqlite3.c"
    $63 = ($62|0)==(0); //@line 69156 "c/sqlite3.c"
    if (!($63)) {
     break;
    }
   } else {
    $64 = ($3|0)==(0|0); //@line 69157 "c/sqlite3.c"
    if (!($64)) {
     $65 = HEAP32[$3>>2]|0; //@line 69160 "c/sqlite3.c"
     $66 = (($65) + ($$lcssa))|0; //@line 69160 "c/sqlite3.c"
     HEAP32[$3>>2] = $66; //@line 69160 "c/sqlite3.c"
    }
   }
   $67 = ($2|0)==(0); //@line 69162 "c/sqlite3.c"
   if (!($67)) {
    _freePage($12,$5); //@line 69163 "c/sqlite3.c"
    break;
   }
   $68 = ((($12)) + 72|0); //@line 69164 "c/sqlite3.c"
   $69 = HEAP32[$68>>2]|0; //@line 69164 "c/sqlite3.c"
   $70 = (_sqlite3PagerWrite($69)|0); //@line 69164 "c/sqlite3.c"
   HEAP32[$5>>2] = $70; //@line 69164 "c/sqlite3.c"
   $71 = ($70|0)==(0); //@line 69164 "c/sqlite3.c"
   if ($71) {
    $72 = ((($12)) + 56|0); //@line 69165 "c/sqlite3.c"
    $73 = HEAP32[$72>>2]|0; //@line 69165 "c/sqlite3.c"
    $74 = (($73) + ($19)|0); //@line 69165 "c/sqlite3.c"
    $75 = HEAP8[$74>>0]|0; //@line 69165 "c/sqlite3.c"
    $76 = $75 | 8; //@line 69165 "c/sqlite3.c"
    $77 = $76&255; //@line 69165 "c/sqlite3.c"
    _zeroPage($12,$77); //@line 69165 "c/sqlite3.c"
   }
  } else {
   $16 = (_sqlite3CorruptError(69140)|0); //@line 69140 "c/sqlite3.c"
   HEAP32[$5>>2] = $16; //@line 69140 "c/sqlite3.c"
  }
 } while(0);
 HEAP8[$13>>0] = 0; //@line 69169 "c/sqlite3.c"
 _releasePage($12); //@line 69170 "c/sqlite3.c"
 $79 = HEAP32[$5>>2]|0; //@line 69171 "c/sqlite3.c"
 $$0 = $79;
 STACKTOP = sp;return ($$0|0); //@line 69172 "c/sqlite3.c"
}
function _clearCell($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$045 = 0, $$04654 = 0, $$1$ph = 0, $$2 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 4|0;
 $4 = sp;
 $5 = ((($0)) + 80|0); //@line 66611 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 66611 "c/sqlite3.c"
 FUNCTION_TABLE_viii[$6 & 255]($0,$1,$2); //@line 66611 "c/sqlite3.c"
 $7 = ((($2)) + 16|0); //@line 66612 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 66612 "c/sqlite3.c"
 $9 = $8&65535; //@line 66612 "c/sqlite3.c"
 $10 = ((($2)) + 12|0); //@line 66612 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 66612 "c/sqlite3.c"
 $12 = ($11|0)==($9|0); //@line 66612 "c/sqlite3.c"
 if ($12) {
  $$2 = 0;
  STACKTOP = sp;return ($$2|0); //@line 66666 "c/sqlite3.c"
 }
 $13 = ((($2)) + 18|0); //@line 66615 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 66615 "c/sqlite3.c"
 $15 = $14&65535; //@line 66615 "c/sqlite3.c"
 $16 = (($1) + ($15)|0); //@line 66615 "c/sqlite3.c"
 $17 = ((($16)) + -1|0); //@line 66615 "c/sqlite3.c"
 $18 = ((($0)) + 56|0); //@line 66615 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 66615 "c/sqlite3.c"
 $20 = ((($0)) + 24|0); //@line 66615 "c/sqlite3.c"
 $21 = HEAP16[$20>>1]|0; //@line 66615 "c/sqlite3.c"
 $22 = $21&65535; //@line 66615 "c/sqlite3.c"
 $23 = (($19) + ($22)|0); //@line 66615 "c/sqlite3.c"
 $24 = ($17>>>0)>($23>>>0); //@line 66615 "c/sqlite3.c"
 if ($24) {
  $25 = (_sqlite3CorruptError(66617)|0); //@line 66617 "c/sqlite3.c"
  $$2 = $25;
  STACKTOP = sp;return ($$2|0); //@line 66666 "c/sqlite3.c"
 }
 $26 = ((($0)) + 52|0); //@line 66620 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 66620 "c/sqlite3.c"
 $28 = ((($27)) + 36|0); //@line 66622 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 66622 "c/sqlite3.c"
 $30 = (($29) + -4)|0; //@line 66622 "c/sqlite3.c"
 $31 = $9 ^ -1; //@line 66623 "c/sqlite3.c"
 $32 = (($11) + ($31))|0; //@line 66623 "c/sqlite3.c"
 $33 = (($32) + ($30))|0; //@line 66623 "c/sqlite3.c"
 $34 = ($30>>>0)>($33>>>0); //@line 66627 "c/sqlite3.c"
 if ($34) {
  $$2 = 0;
  STACKTOP = sp;return ($$2|0); //@line 66666 "c/sqlite3.c"
 }
 $35 = (($33>>>0) / ($30>>>0))&-1; //@line 66623 "c/sqlite3.c"
 $36 = ((($16)) + -4|0); //@line 66619 "c/sqlite3.c"
 $37 = (_sqlite3Get4byte($36)|0); //@line 66619 "c/sqlite3.c"
 $$04654 = $37;$$in = $35;
 while(1) {
  $39 = (($$in) + -1)|0; //@line 66627 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 66628 "c/sqlite3.c"
  HEAP32[$4>>2] = 0; //@line 66629 "c/sqlite3.c"
  $40 = ($$04654>>>0)<(2); //@line 66630 "c/sqlite3.c"
  if ($40) {
   label = 9;
   break;
  }
  $41 = (_btreePagecount($27)|0); //@line 66630 "c/sqlite3.c"
  $42 = ($$04654>>>0)>($41>>>0); //@line 66630 "c/sqlite3.c"
  if ($42) {
   label = 9;
   break;
  }
  $44 = ($39|0)==(0); //@line 66636 "c/sqlite3.c"
  if (!($44)) {
   $45 = (_getOverflowPage($27,$$04654,$4,$3)|0); //@line 66637 "c/sqlite3.c"
   $46 = ($45|0)==(0); //@line 66638 "c/sqlite3.c"
   if (!($46)) {
    $$1$ph = $45;
    break;
   }
  }
  $47 = HEAP32[$4>>2]|0; //@line 66641 "c/sqlite3.c"
  $48 = ($47|0)==(0|0); //@line 66641 "c/sqlite3.c"
  if ($48) {
   $49 = (_btreePageLookup($27,$$04654)|0); //@line 66641 "c/sqlite3.c"
   HEAP32[$4>>2] = $49; //@line 66641 "c/sqlite3.c"
   $50 = ($49|0)==(0|0); //@line 66641 "c/sqlite3.c"
   if ($50) {
    label = 16;
   } else {
    label = 14;
   }
  } else {
   label = 14;
  }
  if ((label|0) == 14) {
   label = 0;
   $51 = HEAP32[$4>>2]|0; //@line 66642 "c/sqlite3.c"
   $52 = ((($51)) + 72|0); //@line 66642 "c/sqlite3.c"
   $53 = HEAP32[$52>>2]|0; //@line 66642 "c/sqlite3.c"
   $54 = (_sqlite3PagerPageRefcount($53)|0); //@line 66642 "c/sqlite3.c"
   $55 = ($54|0)==(1); //@line 66642 "c/sqlite3.c"
   if ($55) {
    label = 16;
   } else {
    $56 = (_sqlite3CorruptError(66654)|0); //@line 66654 "c/sqlite3.c"
    $$045 = $56;
   }
  }
  if ((label|0) == 16) {
   label = 0;
   $57 = HEAP32[$4>>2]|0; //@line 66656 "c/sqlite3.c"
   $58 = (_freePage2($27,$57,$$04654)|0); //@line 66656 "c/sqlite3.c"
   $$045 = $58;
  }
  $59 = HEAP32[$4>>2]|0; //@line 66659 "c/sqlite3.c"
  $60 = ($59|0)==(0|0); //@line 66659 "c/sqlite3.c"
  if (!($60)) {
   $61 = ((($59)) + 72|0); //@line 66660 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 66660 "c/sqlite3.c"
   _sqlite3PagerUnref($62); //@line 66660 "c/sqlite3.c"
  }
  $63 = ($$045|0)==(0); //@line 66662 "c/sqlite3.c"
  $64 = HEAP32[$3>>2]|0; //@line 66663 "c/sqlite3.c"
  if (!($63)) {
   $$2 = $$045;
   label = 21;
   break;
  }
  $38 = ($39|0)==(0); //@line 66627 "c/sqlite3.c"
  if ($38) {
   $$2 = 0;
   label = 21;
   break;
  } else {
   $$04654 = $64;$$in = $39;
  }
 }
 if ((label|0) == 9) {
  $43 = (_sqlite3CorruptError(66634)|0); //@line 66634 "c/sqlite3.c"
  $$1$ph = $43;
 }
 else if ((label|0) == 21) {
  STACKTOP = sp;return ($$2|0); //@line 66666 "c/sqlite3.c"
 }
 $$2 = $$1$ph;
 STACKTOP = sp;return ($$2|0); //@line 66666 "c/sqlite3.c"
}
function _freePage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 66589 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 66589 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 66592 "c/sqlite3.c"
 }
 $4 = ((($0)) + 52|0); //@line 66590 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 66590 "c/sqlite3.c"
 $6 = ((($0)) + 4|0); //@line 66590 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 66590 "c/sqlite3.c"
 $8 = (_freePage2($5,$0,$7)|0); //@line 66590 "c/sqlite3.c"
 HEAP32[$1>>2] = $8; //@line 66590 "c/sqlite3.c"
 return; //@line 66592 "c/sqlite3.c"
}
function _freePage2($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$044 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0;
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0;
 var $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 8|0;
 $4 = sp + 4|0;
 $5 = sp;
 HEAP32[$3>>2] = 0; //@line 66461 "c/sqlite3.c"
 $6 = ((($0)) + 12|0); //@line 66463 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 66463 "c/sqlite3.c"
 $8 = ($2>>>0)<(2); //@line 66472 "c/sqlite3.c"
 if ($8) {
  $9 = (_sqlite3CorruptError(66472)|0); //@line 66472 "c/sqlite3.c"
  $$0 = $9;
  STACKTOP = sp;return ($$0|0); //@line 66587 "c/sqlite3.c"
 }
 $10 = ($1|0)==(0|0); //@line 66473 "c/sqlite3.c"
 if ($10) {
  $13 = (_btreePageLookup($0,$2)|0); //@line 66477 "c/sqlite3.c"
  HEAP32[$4>>2] = $13; //@line 66477 "c/sqlite3.c"
 } else {
  HEAP32[$4>>2] = $1; //@line 66474 "c/sqlite3.c"
  $11 = ((($1)) + 72|0); //@line 66475 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 66475 "c/sqlite3.c"
  _sqlite3PagerRef($12); //@line 66475 "c/sqlite3.c"
 }
 $14 = ((($7)) + 72|0); //@line 66481 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 66481 "c/sqlite3.c"
 $16 = (_sqlite3PagerWrite($15)|0); //@line 66481 "c/sqlite3.c"
 HEAP32[$5>>2] = $16; //@line 66481 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 66482 "c/sqlite3.c"
 do {
  if ($17) {
   $18 = ((($7)) + 56|0); //@line 66483 "c/sqlite3.c"
   $19 = HEAP32[$18>>2]|0; //@line 66483 "c/sqlite3.c"
   $20 = ((($19)) + 36|0); //@line 66483 "c/sqlite3.c"
   $21 = (_sqlite3Get4byte($20)|0); //@line 66483 "c/sqlite3.c"
   $22 = (($21) + 1)|0; //@line 66484 "c/sqlite3.c"
   _sqlite3Put4byte($20,$22); //@line 66484 "c/sqlite3.c"
   $23 = ((($0)) + 22|0); //@line 66486 "c/sqlite3.c"
   $24 = HEAP16[$23>>1]|0; //@line 66486 "c/sqlite3.c"
   $25 = $24 & 4; //@line 66486 "c/sqlite3.c"
   $26 = ($25<<16>>16)==(0); //@line 66486 "c/sqlite3.c"
   if (!($26)) {
    $27 = HEAP32[$4>>2]|0; //@line 66490 "c/sqlite3.c"
    $28 = ($27|0)==(0|0); //@line 66490 "c/sqlite3.c"
    if ($28) {
     $29 = (_btreeGetPage($0,$2,$4,0)|0); //@line 66490 "c/sqlite3.c"
     HEAP32[$5>>2] = $29; //@line 66490 "c/sqlite3.c"
     $30 = ($29|0)==(0); //@line 66490 "c/sqlite3.c"
     if (!($30)) {
      break;
     }
    }
    $31 = HEAP32[$4>>2]|0; //@line 66491 "c/sqlite3.c"
    $32 = ((($31)) + 72|0); //@line 66491 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 66491 "c/sqlite3.c"
    $34 = (_sqlite3PagerWrite($33)|0); //@line 66491 "c/sqlite3.c"
    HEAP32[$5>>2] = $34; //@line 66491 "c/sqlite3.c"
    $35 = ($34|0)==(0); //@line 66491 "c/sqlite3.c"
    if (!($35)) {
     break;
    }
    $36 = ((($31)) + 56|0); //@line 66495 "c/sqlite3.c"
    $37 = HEAP32[$36>>2]|0; //@line 66495 "c/sqlite3.c"
    $38 = ((($31)) + 52|0); //@line 66495 "c/sqlite3.c"
    $39 = HEAP32[$38>>2]|0; //@line 66495 "c/sqlite3.c"
    $40 = ((($39)) + 32|0); //@line 66495 "c/sqlite3.c"
    $41 = HEAP32[$40>>2]|0; //@line 66495 "c/sqlite3.c"
    _memset(($37|0),0,($41|0))|0; //@line 66495 "c/sqlite3.c"
   }
   $42 = ((($0)) + 17|0); //@line 66501 "c/sqlite3.c"
   $43 = HEAP8[$42>>0]|0; //@line 66501 "c/sqlite3.c"
   $44 = ($43<<24>>24)==(0); //@line 66501 "c/sqlite3.c"
   if (!($44)) {
    _ptrmapPut($0,$2,2,0,$5); //@line 66502 "c/sqlite3.c"
    $45 = HEAP32[$5>>2]|0; //@line 66503 "c/sqlite3.c"
    $46 = ($45|0)==(0); //@line 66503 "c/sqlite3.c"
    if (!($46)) {
     break;
    }
   }
   $47 = ($21|0)==(0); //@line 66513 "c/sqlite3.c"
   if ($47) {
    $$044 = 0;
   } else {
    $48 = HEAP32[$18>>2]|0; //@line 66516 "c/sqlite3.c"
    $49 = ((($48)) + 32|0); //@line 66516 "c/sqlite3.c"
    $50 = (_sqlite3Get4byte($49)|0); //@line 66516 "c/sqlite3.c"
    $51 = (_btreeGetPage($0,$50,$3,0)|0); //@line 66517 "c/sqlite3.c"
    HEAP32[$5>>2] = $51; //@line 66517 "c/sqlite3.c"
    $52 = ($51|0)==(0); //@line 66518 "c/sqlite3.c"
    if (!($52)) {
     break;
    }
    $53 = HEAP32[$3>>2]|0; //@line 66522 "c/sqlite3.c"
    $54 = ((($53)) + 56|0); //@line 66522 "c/sqlite3.c"
    $55 = HEAP32[$54>>2]|0; //@line 66522 "c/sqlite3.c"
    $56 = ((($55)) + 4|0); //@line 66522 "c/sqlite3.c"
    $57 = (_sqlite3Get4byte($56)|0); //@line 66522 "c/sqlite3.c"
    $58 = ((($0)) + 36|0); //@line 66524 "c/sqlite3.c"
    $59 = HEAP32[$58>>2]|0; //@line 66524 "c/sqlite3.c"
    $60 = $59 >>> 2; //@line 66524 "c/sqlite3.c"
    $61 = (($60) + -2)|0; //@line 66524 "c/sqlite3.c"
    $62 = ($57>>>0)>($61>>>0); //@line 66524 "c/sqlite3.c"
    if ($62) {
     $63 = (_sqlite3CorruptError(66525)|0); //@line 66525 "c/sqlite3.c"
     HEAP32[$5>>2] = $63; //@line 66525 "c/sqlite3.c"
     break;
    }
    $64 = (($60) + -8)|0; //@line 66528 "c/sqlite3.c"
    $65 = ($57>>>0)<($64>>>0); //@line 66528 "c/sqlite3.c"
    if ($65) {
     $66 = ((($53)) + 72|0); //@line 66548 "c/sqlite3.c"
     $67 = HEAP32[$66>>2]|0; //@line 66548 "c/sqlite3.c"
     $68 = (_sqlite3PagerWrite($67)|0); //@line 66548 "c/sqlite3.c"
     HEAP32[$5>>2] = $68; //@line 66548 "c/sqlite3.c"
     $69 = ($68|0)==(0); //@line 66549 "c/sqlite3.c"
     if (!($69)) {
      break;
     }
     $70 = HEAP32[$54>>2]|0; //@line 66550 "c/sqlite3.c"
     $71 = ((($70)) + 4|0); //@line 66550 "c/sqlite3.c"
     $72 = (($57) + 1)|0; //@line 66550 "c/sqlite3.c"
     _sqlite3Put4byte($71,$72); //@line 66550 "c/sqlite3.c"
     $73 = HEAP32[$54>>2]|0; //@line 66551 "c/sqlite3.c"
     $74 = $57 << 2; //@line 66551 "c/sqlite3.c"
     $75 = (($74) + 8)|0; //@line 66551 "c/sqlite3.c"
     $76 = (($73) + ($75)|0); //@line 66551 "c/sqlite3.c"
     _sqlite3Put4byte($76,$2); //@line 66551 "c/sqlite3.c"
     $77 = HEAP32[$4>>2]|0; //@line 66552 "c/sqlite3.c"
     $78 = ($77|0)==(0|0); //@line 66552 "c/sqlite3.c"
     if (!($78)) {
      $79 = HEAP16[$23>>1]|0; //@line 66552 "c/sqlite3.c"
      $80 = $79 & 4; //@line 66552 "c/sqlite3.c"
      $81 = ($80<<16>>16)==(0); //@line 66552 "c/sqlite3.c"
      if ($81) {
       $82 = ((($77)) + 72|0); //@line 66553 "c/sqlite3.c"
       $83 = HEAP32[$82>>2]|0; //@line 66553 "c/sqlite3.c"
       _sqlite3PagerDontWrite($83); //@line 66553 "c/sqlite3.c"
      }
     }
     $84 = (_btreeSetHasContent($0,$2)|0); //@line 66555 "c/sqlite3.c"
     HEAP32[$5>>2] = $84; //@line 66555 "c/sqlite3.c"
     break;
    } else {
     $$044 = $50;
    }
   }
   $85 = HEAP32[$4>>2]|0; //@line 66568 "c/sqlite3.c"
   $86 = ($85|0)==(0|0); //@line 66568 "c/sqlite3.c"
   if ($86) {
    $87 = (_btreeGetPage($0,$2,$4,0)|0); //@line 66568 "c/sqlite3.c"
    HEAP32[$5>>2] = $87; //@line 66568 "c/sqlite3.c"
    $88 = ($87|0)==(0); //@line 66568 "c/sqlite3.c"
    if (!($88)) {
     break;
    }
   }
   $89 = HEAP32[$4>>2]|0; //@line 66571 "c/sqlite3.c"
   $90 = ((($89)) + 72|0); //@line 66571 "c/sqlite3.c"
   $91 = HEAP32[$90>>2]|0; //@line 66571 "c/sqlite3.c"
   $92 = (_sqlite3PagerWrite($91)|0); //@line 66571 "c/sqlite3.c"
   HEAP32[$5>>2] = $92; //@line 66571 "c/sqlite3.c"
   $93 = ($92|0)==(0); //@line 66572 "c/sqlite3.c"
   if ($93) {
    $94 = ((($89)) + 56|0); //@line 66575 "c/sqlite3.c"
    $95 = HEAP32[$94>>2]|0; //@line 66575 "c/sqlite3.c"
    _sqlite3Put4byte($95,$$044); //@line 66575 "c/sqlite3.c"
    $96 = HEAP32[$94>>2]|0; //@line 66576 "c/sqlite3.c"
    $97 = ((($96)) + 4|0); //@line 66576 "c/sqlite3.c"
    _sqlite3Put4byte($97,0); //@line 66576 "c/sqlite3.c"
    $98 = HEAP32[$18>>2]|0; //@line 66577 "c/sqlite3.c"
    $99 = ((($98)) + 32|0); //@line 66577 "c/sqlite3.c"
    _sqlite3Put4byte($99,$2); //@line 66577 "c/sqlite3.c"
   }
  }
 } while(0);
 $100 = HEAP32[$4>>2]|0; //@line 66581 "c/sqlite3.c"
 $101 = ($100|0)==(0|0); //@line 66581 "c/sqlite3.c"
 if (!($101)) {
  HEAP8[$100>>0] = 0; //@line 66582 "c/sqlite3.c"
 }
 _releasePage($100); //@line 66584 "c/sqlite3.c"
 $102 = HEAP32[$3>>2]|0; //@line 66585 "c/sqlite3.c"
 _releasePage($102); //@line 66585 "c/sqlite3.c"
 $103 = HEAP32[$5>>2]|0; //@line 66586 "c/sqlite3.c"
 $$0 = $103;
 STACKTOP = sp;return ($$0|0); //@line 66587 "c/sqlite3.c"
}
function _sqlite3PagerRef($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3PcacheRef($0); //@line 52156 "c/sqlite3.c"
 return; //@line 52157 "c/sqlite3.c"
}
function _btreePageLookup($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 62458 "c/sqlite3.c"
 $3 = (_sqlite3PagerLookup($2,$1)|0); //@line 62458 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 62459 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  return ($$0|0); //@line 62463 "c/sqlite3.c"
 }
 $5 = (_btreePageFromDbPage($3,$1,$0)|0); //@line 62460 "c/sqlite3.c"
 $$0 = $5;
 return ($$0|0); //@line 62463 "c/sqlite3.c"
}
function _sqlite3PagerDontWrite($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 54124 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54124 "c/sqlite3.c"
 $3 = ((($2)) + 12|0); //@line 54125 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 54125 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 54125 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 54133 "c/sqlite3.c"
 }
 $6 = ((($0)) + 28|0); //@line 54125 "c/sqlite3.c"
 $7 = HEAP16[$6>>1]|0; //@line 54125 "c/sqlite3.c"
 $8 = $7&65535; //@line 54125 "c/sqlite3.c"
 $9 = $8 & 2; //@line 54125 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 54125 "c/sqlite3.c"
 if ($10) {
  return; //@line 54133 "c/sqlite3.c"
 }
 $11 = ((($2)) + 96|0); //@line 54125 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 54125 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 54125 "c/sqlite3.c"
 if (!($13)) {
  return; //@line 54133 "c/sqlite3.c"
 }
 $14 = $8 & 65515; //@line 54129 "c/sqlite3.c"
 $15 = $14 | 16; //@line 54129 "c/sqlite3.c"
 $16 = $15&65535; //@line 54129 "c/sqlite3.c"
 HEAP16[$6>>1] = $16; //@line 54129 "c/sqlite3.c"
 return; //@line 54133 "c/sqlite3.c"
}
function _btreeSetHasContent($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 60|0); //@line 60995 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 60995 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 60995 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 44|0); //@line 60997 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 60997 "c/sqlite3.c"
  $7 = (_sqlite3BitvecCreate($6)|0); //@line 60997 "c/sqlite3.c"
  HEAP32[$2>>2] = $7; //@line 60997 "c/sqlite3.c"
  $8 = ($7|0)==(0|0); //@line 60998 "c/sqlite3.c"
  if ($8) {
   $$1 = 7;
   return ($$1|0); //@line 61005 "c/sqlite3.c"
  }
 }
 $9 = HEAP32[$2>>2]|0; //@line 61002 "c/sqlite3.c"
 $10 = (_sqlite3BitvecSize($9)|0); //@line 61002 "c/sqlite3.c"
 $11 = ($10>>>0)<($1>>>0); //@line 61002 "c/sqlite3.c"
 if ($11) {
  $$1 = 0;
  return ($$1|0); //@line 61005 "c/sqlite3.c"
 }
 $12 = (_sqlite3BitvecSet($9,$1)|0); //@line 61003 "c/sqlite3.c"
 $$1 = $12;
 return ($$1|0); //@line 61005 "c/sqlite3.c"
}
function _sqlite3PcacheRef($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 30|0); //@line 45703 "c/sqlite3.c"
 $2 = HEAP16[$1>>1]|0; //@line 45703 "c/sqlite3.c"
 $3 = (($2) + 1)<<16>>16; //@line 45703 "c/sqlite3.c"
 HEAP16[$1>>1] = $3; //@line 45703 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 45704 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 45704 "c/sqlite3.c"
 $6 = ((($5)) + 12|0); //@line 45704 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 45704 "c/sqlite3.c"
 $8 = (($7) + 1)|0; //@line 45704 "c/sqlite3.c"
 HEAP32[$6>>2] = $8; //@line 45704 "c/sqlite3.c"
 return; //@line 45705 "c/sqlite3.c"
}
function _btreeDropTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$021$ph = 0, $$2$ph = 0, $$3 = 0, $$promoted = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $storemerge = 0, $storemerge$in27 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 12|0;
 $4 = sp + 8|0;
 $5 = sp + 4|0;
 $6 = sp;
 HEAP32[$4>>2] = 0; //@line 69237 "c/sqlite3.c"
 $7 = ((($0)) + 4|0); //@line 69238 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 69238 "c/sqlite3.c"
 $9 = (_btreeGetPage($8,$1,$4,0)|0); //@line 69244 "c/sqlite3.c"
 HEAP32[$3>>2] = $9; //@line 69244 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 69245 "c/sqlite3.c"
 if (!($10)) {
  $$3 = $9;
  STACKTOP = sp;return ($$3|0); //@line 69316 "c/sqlite3.c"
 }
 $11 = (_sqlite3BtreeClearTable($0,$1,0)|0); //@line 69246 "c/sqlite3.c"
 HEAP32[$3>>2] = $11; //@line 69246 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 69247 "c/sqlite3.c"
 if (!($12)) {
  $13 = HEAP32[$4>>2]|0; //@line 69248 "c/sqlite3.c"
  _releasePage($13); //@line 69248 "c/sqlite3.c"
  $$3 = $11;
  STACKTOP = sp;return ($$3|0); //@line 69316 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = 0; //@line 69252 "c/sqlite3.c"
 $14 = ((($8)) + 17|0); //@line 69258 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 69258 "c/sqlite3.c"
 $16 = ($15<<24>>24)==(0); //@line 69258 "c/sqlite3.c"
 if ($16) {
  $41 = HEAP32[$4>>2]|0; //@line 69311 "c/sqlite3.c"
  _freePage($41,$3); //@line 69311 "c/sqlite3.c"
  _releasePage($41); //@line 69312 "c/sqlite3.c"
 } else {
  _sqlite3BtreeGetMeta($0,4,$5); //@line 69260 "c/sqlite3.c"
  $17 = HEAP32[$5>>2]|0; //@line 69262 "c/sqlite3.c"
  $18 = ($17|0)==($1|0); //@line 69262 "c/sqlite3.c"
  do {
   if ($18) {
    $19 = HEAP32[$4>>2]|0; //@line 69266 "c/sqlite3.c"
    _freePage($19,$3); //@line 69266 "c/sqlite3.c"
    _releasePage($19); //@line 69267 "c/sqlite3.c"
    $20 = HEAP32[$3>>2]|0; //@line 69268 "c/sqlite3.c"
    $21 = ($20|0)==(0); //@line 69268 "c/sqlite3.c"
    if (!($21)) {
     $$2$ph = $20;
     label = 16;
    }
   } else {
    $22 = HEAP32[$4>>2]|0; //@line 69277 "c/sqlite3.c"
    _releasePage($22); //@line 69277 "c/sqlite3.c"
    $23 = (_btreeGetPage($8,$17,$6,0)|0); //@line 69278 "c/sqlite3.c"
    HEAP32[$3>>2] = $23; //@line 69278 "c/sqlite3.c"
    $24 = ($23|0)==(0); //@line 69279 "c/sqlite3.c"
    if ($24) {
     $25 = HEAP32[$6>>2]|0; //@line 69282 "c/sqlite3.c"
     $26 = (_relocatePage($8,$25,1,0,$1,0)|0); //@line 69282 "c/sqlite3.c"
     HEAP32[$3>>2] = $26; //@line 69282 "c/sqlite3.c"
     _releasePage($25); //@line 69283 "c/sqlite3.c"
     $27 = ($26|0)==(0); //@line 69284 "c/sqlite3.c"
     if ($27) {
      HEAP32[$6>>2] = 0; //@line 69287 "c/sqlite3.c"
      $28 = (_btreeGetPage($8,$17,$6,0)|0); //@line 69288 "c/sqlite3.c"
      HEAP32[$3>>2] = $28; //@line 69288 "c/sqlite3.c"
      $29 = HEAP32[$6>>2]|0; //@line 69289 "c/sqlite3.c"
      _freePage($29,$3); //@line 69289 "c/sqlite3.c"
      _releasePage($29); //@line 69290 "c/sqlite3.c"
      $30 = HEAP32[$3>>2]|0; //@line 69291 "c/sqlite3.c"
      $31 = ($30|0)==(0); //@line 69291 "c/sqlite3.c"
      if ($31) {
       HEAP32[$2>>2] = $17; //@line 69294 "c/sqlite3.c"
       break;
      } else {
       $$021$ph = $30;
      }
     } else {
      $$021$ph = $26;
     }
    } else {
     $$021$ph = $23;
    }
    $$2$ph = $$021$ph;
    label = 16;
   }
  } while(0);
  if ((label|0) == 16) {
   $$3 = $$2$ph;
   STACKTOP = sp;return ($$3|0); //@line 69316 "c/sqlite3.c"
  }
  $32 = HEAP32[513]|0;
  $33 = ((($8)) + 32|0);
  $34 = HEAP32[$33>>2]|0;
  $35 = (($32>>>0) / ($34>>>0))&-1;
  $36 = (($35) + 1)|0;
  $$promoted = HEAP32[$5>>2]|0;
  $storemerge$in27 = $$promoted;
  while(1) {
   $storemerge = (($storemerge$in27) + -1)|0;
   $37 = ($storemerge|0)==($36|0); //@line 69303 "c/sqlite3.c"
   if (!($37)) {
    $38 = (_ptrmapPageno($8,$storemerge)|0); //@line 69304 "c/sqlite3.c"
    $39 = ($38|0)==($storemerge|0); //@line 69304 "c/sqlite3.c"
    if (!($39)) {
     break;
    }
   }
   $storemerge$in27 = $storemerge;
  }
  $40 = (_sqlite3BtreeUpdateMeta($0,4,$storemerge)|0); //@line 69309 "c/sqlite3.c"
  HEAP32[$3>>2] = $40; //@line 69309 "c/sqlite3.c"
 }
 $42 = HEAP32[$3>>2]|0; //@line 69315 "c/sqlite3.c"
 $$3 = $42;
 STACKTOP = sp;return ($$3|0); //@line 69316 "c/sqlite3.c"
}
function _vdbeSorterFlushPMA($0) {
 $0 = $0|0;
 var $$060$lcssa = 0, $$06069 = 0, $$1 = 0, $$162$ph = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 59|0); //@line 89503 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 89503 "c/sqlite3.c"
 $3 = $2&255; //@line 89503 "c/sqlite3.c"
 $4 = (($3) + -1)|0; //@line 89503 "c/sqlite3.c"
 $5 = ((($0)) + 56|0); //@line 89507 "c/sqlite3.c"
 HEAP8[$5>>0] = 1; //@line 89507 "c/sqlite3.c"
 $6 = ($2&255)>(1); //@line 89517 "c/sqlite3.c"
 L1: do {
  if ($6) {
   $7 = ((($0)) + 58|0);
   $$06069 = 0;
   while(1) {
    $8 = HEAP8[$7>>0]|0; //@line 89518 "c/sqlite3.c"
    $9 = $8&255; //@line 89518 "c/sqlite3.c"
    $10 = (($$06069) + 1)|0; //@line 89518 "c/sqlite3.c"
    $11 = (($10) + ($9))|0; //@line 89518 "c/sqlite3.c"
    $12 = (($11|0) % ($4|0))&-1; //@line 89518 "c/sqlite3.c"
    $13 = (((($0)) + 64|0) + (($12*72)|0)|0); //@line 89519 "c/sqlite3.c"
    $14 = (((((($0)) + 64|0) + (($12*72)|0)|0)) + 4|0); //@line 89520 "c/sqlite3.c"
    $15 = HEAP32[$14>>2]|0; //@line 89520 "c/sqlite3.c"
    $16 = ($15|0)==(0); //@line 89520 "c/sqlite3.c"
    if (!($16)) {
     $17 = (_vdbeSorterJoinThread($13)|0); //@line 89521 "c/sqlite3.c"
     $18 = ($17|0)==(0); //@line 89523 "c/sqlite3.c"
     if (!($18)) {
      $$1 = $17;
      break;
     }
    }
    $19 = HEAP32[$13>>2]|0; //@line 89523 "c/sqlite3.c"
    $20 = ($19|0)==(0|0); //@line 89523 "c/sqlite3.c"
    if ($20) {
     $$060$lcssa = $$06069;$$162$ph = $13;
     break L1;
    }
    $21 = (($$06069) + 1)|0; //@line 89517 "c/sqlite3.c"
    $22 = ($21|0)<($4|0); //@line 89517 "c/sqlite3.c"
    if ($22) {
     $$06069 = $21;
    } else {
     $$060$lcssa = $21;$$162$ph = $13;
     break L1;
    }
   }
   return ($$1|0); //@line 89557 "c/sqlite3.c"
  } else {
   $$060$lcssa = 0;$$162$ph = 0;
  }
 } while(0);
 $23 = ($$060$lcssa|0)==($4|0); //@line 89527 "c/sqlite3.c"
 if ($23) {
  $24 = (((($0)) + 64|0) + (($4*72)|0)|0); //@line 89529 "c/sqlite3.c"
  $25 = ((($0)) + 36|0); //@line 89529 "c/sqlite3.c"
  $26 = (_vdbeSorterListToPMA($24,$25)|0); //@line 89529 "c/sqlite3.c"
  $$1 = $26;
  return ($$1|0); //@line 89557 "c/sqlite3.c"
 }
 $27 = ((($$162$ph)) + 16|0); //@line 89532 "c/sqlite3.c"
 $28 = ((($$162$ph)) + 20|0); //@line 89532 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 89532 "c/sqlite3.c"
 $30 = ((($0)) + 64|0); //@line 89539 "c/sqlite3.c"
 $31 = $$162$ph; //@line 89539 "c/sqlite3.c"
 $32 = $30; //@line 89539 "c/sqlite3.c"
 $33 = (($31) - ($32))|0; //@line 89539 "c/sqlite3.c"
 $34 = (($33|0) / 72)&-1; //@line 89539 "c/sqlite3.c"
 $35 = $34&255; //@line 89539 "c/sqlite3.c"
 $36 = ((($0)) + 58|0); //@line 89539 "c/sqlite3.c"
 HEAP8[$36>>0] = $35; //@line 89539 "c/sqlite3.c"
 $37 = ((($0)) + 36|0); //@line 89540 "c/sqlite3.c"
 ;HEAP32[$27>>2]=HEAP32[$37>>2]|0;HEAP32[$27+4>>2]=HEAP32[$37+4>>2]|0;HEAP32[$27+8>>2]=HEAP32[$37+8>>2]|0; //@line 89540 "c/sqlite3.c"
 HEAP32[$37>>2] = 0; //@line 89541 "c/sqlite3.c"
 $38 = ((($0)) + 44|0); //@line 89542 "c/sqlite3.c"
 HEAP32[$38>>2] = 0; //@line 89542 "c/sqlite3.c"
 $39 = ($29|0)==(0|0); //@line 89543 "c/sqlite3.c"
 $40 = ((($0)) + 40|0);
 if ($39) {
  $43 = HEAP32[$40>>2]|0; //@line 89546 "c/sqlite3.c"
  $44 = ($43|0)==(0|0); //@line 89546 "c/sqlite3.c"
  if (!($44)) {
   $45 = ((($0)) + 52|0); //@line 89547 "c/sqlite3.c"
   $46 = HEAP32[$45>>2]|0; //@line 89547 "c/sqlite3.c"
   $47 = ($46|0)<(0); //@line 89547 "c/sqlite3.c"
   $48 = $47 << 31 >> 31; //@line 89547 "c/sqlite3.c"
   $49 = (_sqlite3Malloc($46,$48)|0); //@line 89547 "c/sqlite3.c"
   HEAP32[$40>>2] = $49; //@line 89547 "c/sqlite3.c"
   $50 = ($49|0)==(0|0); //@line 89548 "c/sqlite3.c"
   if ($50) {
    $$1 = 7;
    return ($$1|0); //@line 89557 "c/sqlite3.c"
   }
  }
 } else {
  HEAP32[$40>>2] = $29; //@line 89544 "c/sqlite3.c"
  $41 = (_sqlite3MallocSize($29)|0); //@line 89545 "c/sqlite3.c"
  $42 = ((($0)) + 52|0); //@line 89545 "c/sqlite3.c"
  HEAP32[$42>>2] = $41; //@line 89545 "c/sqlite3.c"
 }
 $51 = (_vdbeSorterCreateThread($$162$ph,159,$$162$ph)|0); //@line 89551 "c/sqlite3.c"
 $$1 = $51;
 return ($$1|0); //@line 89557 "c/sqlite3.c"
}
function _vdbeSorterListToPMA($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$2 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $2 = sp;
 $3 = ((($0)) + 8|0); //@line 89347 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 89347 "c/sqlite3.c"
 $5 = ((($4)) + 24|0); //@line 89347 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89347 "c/sqlite3.c"
 dest=$2; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 89358 "c/sqlite3.c"
 $7 = ((($0)) + 40|0); //@line 89362 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 89362 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 89362 "c/sqlite3.c"
 if ($9) {
  $10 = (_vdbeSorterOpenTempFile($6,$7)|0); //@line 89363 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 89375 "c/sqlite3.c"
  if (!($11)) {
   $$2 = $10;
   STACKTOP = sp;return ($$2|0); //@line 89400 "c/sqlite3.c"
  }
 }
 $12 = (_vdbeSorterSort($0,$1)|0); //@line 89376 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 89379 "c/sqlite3.c"
 if (!($13)) {
  $$2 = $12;
  STACKTOP = sp;return ($$2|0); //@line 89400 "c/sqlite3.c"
 }
 $14 = HEAP32[$7>>2]|0; //@line 89383 "c/sqlite3.c"
 $15 = HEAP32[$3>>2]|0; //@line 89383 "c/sqlite3.c"
 $16 = ((($15)) + 12|0); //@line 89383 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 89383 "c/sqlite3.c"
 $18 = ((($0)) + 48|0); //@line 89384 "c/sqlite3.c"
 $19 = $18; //@line 89384 "c/sqlite3.c"
 $20 = $19; //@line 89384 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 89384 "c/sqlite3.c"
 $22 = (($19) + 4)|0; //@line 89384 "c/sqlite3.c"
 $23 = $22; //@line 89384 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 89384 "c/sqlite3.c"
 _vdbePmaWriterInit($14,$2,$17,$21,$24); //@line 89383 "c/sqlite3.c"
 $25 = ((($0)) + 28|0); //@line 89385 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 89385 "c/sqlite3.c"
 $27 = (($26) + 1)|0; //@line 89385 "c/sqlite3.c"
 HEAP32[$25>>2] = $27; //@line 89385 "c/sqlite3.c"
 $28 = ((($1)) + 8|0); //@line 89386 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 89386 "c/sqlite3.c"
 $30 = ($29|0)<(0); //@line 89386 "c/sqlite3.c"
 $31 = $30 << 31 >> 31; //@line 89386 "c/sqlite3.c"
 _vdbePmaWriteVarint($2,$29,$31); //@line 89386 "c/sqlite3.c"
 $32 = HEAP32[$1>>2]|0; //@line 89387 "c/sqlite3.c"
 $33 = ($32|0)==(0|0); //@line 89387 "c/sqlite3.c"
 if (!($33)) {
  $34 = ((($1)) + 4|0);
  $$in = $32;
  while(1) {
   $35 = ((($$in)) + 4|0); //@line 89388 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 89388 "c/sqlite3.c"
   $37 = HEAP32[$$in>>2]|0; //@line 89389 "c/sqlite3.c"
   $38 = ($37|0)<(0); //@line 89389 "c/sqlite3.c"
   $39 = $38 << 31 >> 31; //@line 89389 "c/sqlite3.c"
   _vdbePmaWriteVarint($2,$37,$39); //@line 89389 "c/sqlite3.c"
   $40 = ((($$in)) + 8|0); //@line 89390 "c/sqlite3.c"
   $41 = HEAP32[$$in>>2]|0; //@line 89390 "c/sqlite3.c"
   _vdbePmaWriteBlob($2,$40,$41); //@line 89390 "c/sqlite3.c"
   $42 = HEAP32[$34>>2]|0; //@line 89391 "c/sqlite3.c"
   $43 = ($42|0)==(0|0); //@line 89391 "c/sqlite3.c"
   if ($43) {
    _sqlite3_free($$in); //@line 89391 "c/sqlite3.c"
   }
   $44 = ($36|0)==(0|0); //@line 89387 "c/sqlite3.c"
   if ($44) {
    break;
   } else {
    $$in = $36;
   }
  }
 }
 HEAP32[$1>>2] = 0; //@line 89393 "c/sqlite3.c"
 $45 = (_vdbePmaWriterFinish($2,$18)|0); //@line 89394 "c/sqlite3.c"
 $$2 = $45;
 STACKTOP = sp;return ($$2|0); //@line 89400 "c/sqlite3.c"
}
function _vdbeSorterFlushThread($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 89485 "c/sqlite3.c"
 $2 = (_vdbeSorterListToPMA($0,$1)|0); //@line 89485 "c/sqlite3.c"
 $3 = ((($0)) + 4|0); //@line 89486 "c/sqlite3.c"
 HEAP32[$3>>2] = 1; //@line 89486 "c/sqlite3.c"
 $4 = $2; //@line 89487 "c/sqlite3.c"
 return ($4|0); //@line 89487 "c/sqlite3.c"
}
function _vdbeSorterCreateThread($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3ThreadCreate($0,$1,$2)|0); //@line 88933 "c/sqlite3.c"
 return ($3|0); //@line 88933 "c/sqlite3.c"
}
function _sqlite3ThreadCreate($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$020 = 0, $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = 0; //@line 27720 "c/sqlite3.c"
 $3 = (_sqlite3Malloc(20,0)|0); //@line 27721 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 27722 "c/sqlite3.c"
 if ($4) {
  $$020 = 7;
  return ($$020|0); //@line 27741 "c/sqlite3.c"
 }
 ;HEAP32[$3>>2]=0|0;HEAP32[$3+4>>2]=0|0;HEAP32[$3+8>>2]=0|0; //@line 27723 "c/sqlite3.c"
 $5 = ((($3)) + 12|0); //@line 27724 "c/sqlite3.c"
 HEAP32[$5>>2] = $1; //@line 27724 "c/sqlite3.c"
 $6 = ((($3)) + 16|0); //@line 27725 "c/sqlite3.c"
 HEAP32[$6>>2] = $2; //@line 27725 "c/sqlite3.c"
 $7 = (_sqlite3FaultSim(200)|0); //@line 27730 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 27730 "c/sqlite3.c"
 if ($8) {
  $9 = (_pthread_create(($3|0),(0|0),($1|0),($2|0))|0); //@line 27733 "c/sqlite3.c"
  $phitmp = ($9|0)==(0);
  if (!($phitmp)) {
   label = 4;
  }
 } else {
  label = 4;
 }
 if ((label|0) == 4) {
  $10 = ((($3)) + 4|0); //@line 27736 "c/sqlite3.c"
  HEAP32[$10>>2] = 1; //@line 27736 "c/sqlite3.c"
  $11 = (FUNCTION_TABLE_ii[$1 & 255]($2)|0); //@line 27737 "c/sqlite3.c"
  $12 = ((($3)) + 8|0); //@line 27737 "c/sqlite3.c"
  HEAP32[$12>>2] = $11; //@line 27737 "c/sqlite3.c"
 }
 HEAP32[$0>>2] = $3; //@line 27739 "c/sqlite3.c"
 $$020 = 0;
 return ($$020|0); //@line 27741 "c/sqlite3.c"
}
function _vdbeIncrPopulateThread($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_vdbeIncrPopulate($0)|0); //@line 89714 "c/sqlite3.c"
 $2 = $1; //@line 89714 "c/sqlite3.c"
 $3 = HEAP32[$0>>2]|0; //@line 89715 "c/sqlite3.c"
 $4 = ((($3)) + 4|0); //@line 89715 "c/sqlite3.c"
 HEAP32[$4>>2] = 1; //@line 89715 "c/sqlite3.c"
 return ($2|0); //@line 89716 "c/sqlite3.c"
}
function _vdbePmaReaderBgIncrInit($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_vdbePmaReaderIncrMergeInit($0,1)|0); //@line 90044 "c/sqlite3.c"
 $2 = $1; //@line 90044 "c/sqlite3.c"
 $3 = ((($0)) + 48|0); //@line 90047 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 90047 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 90047 "c/sqlite3.c"
 $6 = ((($5)) + 4|0); //@line 90047 "c/sqlite3.c"
 HEAP32[$6>>2] = 1; //@line 90047 "c/sqlite3.c"
 return ($2|0); //@line 90048 "c/sqlite3.c"
}
function _vdbePmaReaderIncrMergeInit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$3 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 48|0); //@line 89977 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 89977 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 89978 "c/sqlite3.c"
 $5 = ((($4)) + 8|0); //@line 89979 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89979 "c/sqlite3.c"
 $7 = ((($6)) + 24|0); //@line 89979 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 89979 "c/sqlite3.c"
 $9 = ((($3)) + 4|0); //@line 89984 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 89984 "c/sqlite3.c"
 $11 = (_vdbeMergeEngineInit($4,$10,$1)|0); //@line 89984 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 89989 "c/sqlite3.c"
 if (!($12)) {
  $$4 = $11;
  return ($$4|0); //@line 90034 "c/sqlite3.c"
 }
 $13 = ((($3)) + 16|0); //@line 89990 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 89990 "c/sqlite3.c"
 $15 = ((($3)) + 24|0); //@line 89992 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 89992 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 89992 "c/sqlite3.c"
 if ($17) {
  $21 = ((($4)) + 56|0); //@line 90000 "c/sqlite3.c"
  $22 = HEAP32[$21>>2]|0; //@line 90000 "c/sqlite3.c"
  $23 = ($22|0)==(0|0); //@line 90000 "c/sqlite3.c"
  if ($23) {
   $24 = ((($4)) + 64|0); //@line 90002 "c/sqlite3.c"
   $25 = (_vdbeSorterOpenTempFile($8,$21)|0); //@line 90002 "c/sqlite3.c"
   $26 = $24; //@line 90003 "c/sqlite3.c"
   $27 = $26; //@line 90003 "c/sqlite3.c"
   HEAP32[$27>>2] = 0; //@line 90003 "c/sqlite3.c"
   $28 = (($26) + 4)|0; //@line 90003 "c/sqlite3.c"
   $29 = $28; //@line 90003 "c/sqlite3.c"
   HEAP32[$29>>2] = 0; //@line 90003 "c/sqlite3.c"
   $30 = ($25|0)==(0); //@line 90005 "c/sqlite3.c"
   if (!($30)) {
    $$4 = $25;
    return ($$4|0); //@line 90034 "c/sqlite3.c"
   }
  }
  $31 = HEAP32[$21>>2]|0; //@line 90006 "c/sqlite3.c"
  $32 = ((($3)) + 48|0); //@line 90006 "c/sqlite3.c"
  HEAP32[$32>>2] = $31; //@line 90006 "c/sqlite3.c"
  $33 = ((($4)) + 64|0); //@line 90007 "c/sqlite3.c"
  $34 = $33; //@line 90007 "c/sqlite3.c"
  $35 = $34; //@line 90007 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 90007 "c/sqlite3.c"
  $37 = (($34) + 4)|0; //@line 90007 "c/sqlite3.c"
  $38 = $37; //@line 90007 "c/sqlite3.c"
  $39 = HEAP32[$38>>2]|0; //@line 90007 "c/sqlite3.c"
  $40 = ((($3)) + 8|0); //@line 90007 "c/sqlite3.c"
  $41 = $40; //@line 90007 "c/sqlite3.c"
  $42 = $41; //@line 90007 "c/sqlite3.c"
  HEAP32[$42>>2] = $36; //@line 90007 "c/sqlite3.c"
  $43 = (($41) + 4)|0; //@line 90007 "c/sqlite3.c"
  $44 = $43; //@line 90007 "c/sqlite3.c"
  HEAP32[$44>>2] = $39; //@line 90007 "c/sqlite3.c"
  $45 = ($14|0)<(0); //@line 90008 "c/sqlite3.c"
  $46 = $45 << 31 >> 31; //@line 90008 "c/sqlite3.c"
  $47 = (_i64Add(($36|0),($39|0),($14|0),($46|0))|0); //@line 90008 "c/sqlite3.c"
  $48 = tempRet0; //@line 90008 "c/sqlite3.c"
  $49 = $33; //@line 90008 "c/sqlite3.c"
  $50 = $49; //@line 90008 "c/sqlite3.c"
  HEAP32[$50>>2] = $47; //@line 90008 "c/sqlite3.c"
  $51 = (($49) + 4)|0; //@line 90008 "c/sqlite3.c"
  $52 = $51; //@line 90008 "c/sqlite3.c"
  HEAP32[$52>>2] = $48; //@line 90008 "c/sqlite3.c"
 } else {
  $18 = ((($3)) + 32|0); //@line 89993 "c/sqlite3.c"
  $19 = (_vdbeSorterOpenTempFile($8,$18)|0); //@line 89993 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 89994 "c/sqlite3.c"
  if (!($20)) {
   $$4 = $19;
   return ($$4|0); //@line 90034 "c/sqlite3.c"
  }
  $53 = ((($3)) + 48|0); //@line 89995 "c/sqlite3.c"
  $54 = (_vdbeSorterOpenTempFile($8,$53)|0); //@line 89995 "c/sqlite3.c"
  $55 = ($54|0)==(0); //@line 90014 "c/sqlite3.c"
  if (!($55)) {
   $$4 = $54;
   return ($$4|0); //@line 90034 "c/sqlite3.c"
  }
 }
 $56 = ((($3)) + 24|0); //@line 90014 "c/sqlite3.c"
 $57 = HEAP32[$56>>2]|0; //@line 90014 "c/sqlite3.c"
 $58 = ($57|0)==(0); //@line 90014 "c/sqlite3.c"
 if ($58) {
  $$3 = 0;
 } else {
  $59 = (_vdbeIncrPopulate($3)|0); //@line 90026 "c/sqlite3.c"
  $$3 = $59;
 }
 $60 = ($$3|0)==(0); //@line 90030 "c/sqlite3.c"
 $61 = ($1|0)!=(1); //@line 90030 "c/sqlite3.c"
 $or$cond = $61 & $60; //@line 90030 "c/sqlite3.c"
 if (!($or$cond)) {
  $$4 = $$3;
  return ($$4|0); //@line 90034 "c/sqlite3.c"
 }
 $62 = (_vdbePmaReaderNext($0)|0); //@line 90031 "c/sqlite3.c"
 $$4 = $62;
 return ($$4|0); //@line 90034 "c/sqlite3.c"
}
function _vdbeMergeEngineInit($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$02428 = 0, $$025 = 0, $$127 = 0, $$127$in = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$1>>2]|0; //@line 89911 "c/sqlite3.c"
 $4 = ((($1)) + 4|0); //@line 89918 "c/sqlite3.c"
 HEAP32[$4>>2] = $0; //@line 89918 "c/sqlite3.c"
 $5 = ($3|0)>(0); //@line 89920 "c/sqlite3.c"
 if ($5) {
  $6 = ($2|0)==(2);
  $7 = ((($1)) + 12|0);
  $8 = (($3) + -1)|0;
  $$02428 = 0;
  while(1) {
   $11 = HEAP32[$7>>2]|0;
   if ($6) {
    $12 = (($8) - ($$02428))|0; //@line 89929 "c/sqlite3.c"
    $13 = (($11) + (($12*56)|0)|0); //@line 89929 "c/sqlite3.c"
    $14 = (_vdbePmaReaderNext($13)|0); //@line 89929 "c/sqlite3.c"
    $$025 = $14;
   } else {
    $15 = (($11) + (($$02428*56)|0)|0); //@line 89931 "c/sqlite3.c"
    $16 = (_vdbePmaReaderIncrInit($15,0)|0); //@line 89931 "c/sqlite3.c"
    $$025 = $16;
   }
   $17 = ($$025|0)==(0); //@line 89933 "c/sqlite3.c"
   $10 = (($$02428) + 1)|0; //@line 89920 "c/sqlite3.c"
   if (!($17)) {
    $$0 = $$025;
    label = 12;
    break;
   }
   $9 = ($3|0)>($10|0); //@line 89920 "c/sqlite3.c"
   if ($9) {
    $$02428 = $10;
   } else {
    break;
   }
  }
  if ((label|0) == 12) {
   return ($$0|0); //@line 89940 "c/sqlite3.c"
  }
  $$pr = HEAP32[$1>>2]|0; //@line 89936 "c/sqlite3.c"
  $18 = ($$pr|0)>(1); //@line 89936 "c/sqlite3.c"
  if ($18) {
   $$127$in = $$pr;
   while(1) {
    $$127 = (($$127$in) + -1)|0;
    _vdbeMergeEngineCompare($1,$$127); //@line 89937 "c/sqlite3.c"
    $19 = ($$127$in|0)>(2); //@line 89936 "c/sqlite3.c"
    if ($19) {
     $$127$in = $$127;
    } else {
     break;
    }
   }
  }
 }
 $20 = ((($0)) + 12|0); //@line 89939 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 89939 "c/sqlite3.c"
 $22 = ((($21)) + 11|0); //@line 89939 "c/sqlite3.c"
 $23 = HEAP8[$22>>0]|0; //@line 89939 "c/sqlite3.c"
 $24 = $23&255; //@line 89939 "c/sqlite3.c"
 $$0 = $24;
 return ($$0|0); //@line 89940 "c/sqlite3.c"
}
function _vdbeSorterOpenTempFile($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 8|0;
 $3 = sp;
 $4 = (_sqlite3FaultSim(202)|0); //@line 89104 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 89104 "c/sqlite3.c"
 if (!($5)) {
  $$0 = 3338;
  STACKTOP = sp;return ($$0|0); //@line 89118 "c/sqlite3.c"
 }
 $6 = HEAP32[$0>>2]|0; //@line 89105 "c/sqlite3.c"
 $7 = (_sqlite3OsOpenMalloc($6,0,$1,4126,$2)|0); //@line 89105 "c/sqlite3.c"
 HEAP32[$2>>2] = $7; //@line 89105 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 89110 "c/sqlite3.c"
 if ($8) {
  $9 = $3; //@line 89111 "c/sqlite3.c"
  $10 = $9; //@line 89111 "c/sqlite3.c"
  HEAP32[$10>>2] = 0; //@line 89111 "c/sqlite3.c"
  $11 = (($9) + 4)|0; //@line 89111 "c/sqlite3.c"
  $12 = $11; //@line 89111 "c/sqlite3.c"
  HEAP32[$12>>2] = 0; //@line 89111 "c/sqlite3.c"
  $13 = HEAP32[$1>>2]|0; //@line 89112 "c/sqlite3.c"
  _sqlite3OsFileControlHint($13,18,$3); //@line 89112 "c/sqlite3.c"
 }
 $14 = HEAP32[$2>>2]|0; //@line 89117 "c/sqlite3.c"
 $$0 = $14;
 STACKTOP = sp;return ($$0|0); //@line 89118 "c/sqlite3.c"
}
function _vdbeIncrPopulate($0) {
 $0 = $0|0;
 var $$04244 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $1 = sp;
 $2 = sp + 40|0;
 $3 = ((($0)) + 8|0); //@line 89673 "c/sqlite3.c"
 $4 = $3; //@line 89673 "c/sqlite3.c"
 $5 = $4; //@line 89673 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89673 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 89673 "c/sqlite3.c"
 $8 = $7; //@line 89673 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 89673 "c/sqlite3.c"
 $10 = HEAP32[$0>>2]|0; //@line 89675 "c/sqlite3.c"
 $11 = ((($0)) + 4|0); //@line 89676 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 89676 "c/sqlite3.c"
 $13 = ((($0)) + 48|0); //@line 89682 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 89682 "c/sqlite3.c"
 $15 = ((($10)) + 8|0); //@line 89682 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 89682 "c/sqlite3.c"
 $17 = ((($16)) + 12|0); //@line 89682 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 89682 "c/sqlite3.c"
 _vdbePmaWriterInit($14,$1,$18,$6,$9); //@line 89682 "c/sqlite3.c"
 $19 = ((($12)) + 12|0);
 $20 = ((($12)) + 8|0);
 $21 = ((($1)) + 24|0);
 $22 = ((($1)) + 16|0);
 $23 = ((($0)) + 16|0);
 while(1) {
  $24 = HEAP32[$19>>2]|0; //@line 89685 "c/sqlite3.c"
  $25 = HEAP32[$20>>2]|0; //@line 89685 "c/sqlite3.c"
  $26 = ((($25)) + 4|0); //@line 89685 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 89685 "c/sqlite3.c"
  $28 = (((($24) + (($27*56)|0)|0)) + 20|0); //@line 89686 "c/sqlite3.c"
  $29 = HEAP32[$28>>2]|0; //@line 89686 "c/sqlite3.c"
  $30 = (((($24) + (($27*56)|0)|0)) + 24|0); //@line 89691 "c/sqlite3.c"
  $31 = HEAP32[$30>>2]|0; //@line 89691 "c/sqlite3.c"
  $32 = ($31|0)==(0|0); //@line 89691 "c/sqlite3.c"
  if ($32) {
   break;
  }
  $33 = $21; //@line 89687 "c/sqlite3.c"
  $34 = $33; //@line 89687 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 89687 "c/sqlite3.c"
  $36 = (($33) + 4)|0; //@line 89687 "c/sqlite3.c"
  $37 = $36; //@line 89687 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 89687 "c/sqlite3.c"
  $39 = HEAP32[$22>>2]|0; //@line 89687 "c/sqlite3.c"
  $40 = ($39|0)<(0); //@line 89687 "c/sqlite3.c"
  $41 = $40 << 31 >> 31; //@line 89687 "c/sqlite3.c"
  $42 = ($29|0)<(0); //@line 89692 "c/sqlite3.c"
  $43 = $42 << 31 >> 31; //@line 89692 "c/sqlite3.c"
  $44 = (_sqlite3VarintLen($29,$43)|0); //@line 89692 "c/sqlite3.c"
  $45 = ($44|0)<(0); //@line 89692 "c/sqlite3.c"
  $46 = $45 << 31 >> 31; //@line 89692 "c/sqlite3.c"
  $47 = (_i64Add(($35|0),($38|0),($29|0),($43|0))|0); //@line 89687 "c/sqlite3.c"
  $48 = tempRet0; //@line 89687 "c/sqlite3.c"
  $49 = (_i64Add(($47|0),($48|0),($39|0),($41|0))|0); //@line 89692 "c/sqlite3.c"
  $50 = tempRet0; //@line 89692 "c/sqlite3.c"
  $51 = (_i64Add(($49|0),($50|0),($44|0),($46|0))|0); //@line 89692 "c/sqlite3.c"
  $52 = tempRet0; //@line 89692 "c/sqlite3.c"
  $53 = HEAP32[$23>>2]|0; //@line 89692 "c/sqlite3.c"
  $54 = ($53|0)<(0); //@line 89692 "c/sqlite3.c"
  $55 = $54 << 31 >> 31; //@line 89692 "c/sqlite3.c"
  $56 = (_i64Add(($6|0),($9|0),($53|0),($55|0))|0); //@line 89692 "c/sqlite3.c"
  $57 = tempRet0; //@line 89692 "c/sqlite3.c"
  $58 = ($52|0)>($57|0); //@line 89692 "c/sqlite3.c"
  $59 = ($51>>>0)>($56>>>0); //@line 89692 "c/sqlite3.c"
  $60 = ($52|0)==($57|0); //@line 89692 "c/sqlite3.c"
  $61 = $60 & $59; //@line 89692 "c/sqlite3.c"
  $62 = $58 | $61; //@line 89692 "c/sqlite3.c"
  if ($62) {
   break;
  }
  _vdbePmaWriteVarint($1,$29,$43); //@line 89695 "c/sqlite3.c"
  $63 = (((($24) + (($27*56)|0)|0)) + 32|0); //@line 89696 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 89696 "c/sqlite3.c"
  _vdbePmaWriteBlob($1,$64,$29); //@line 89696 "c/sqlite3.c"
  $65 = HEAP32[$11>>2]|0; //@line 89698 "c/sqlite3.c"
  $66 = (_vdbeMergeEngineStep($65,$2)|0); //@line 89698 "c/sqlite3.c"
  $67 = ($66|0)==(0); //@line 89683 "c/sqlite3.c"
  if (!($67)) {
   $$04244 = $66;
   label = 6;
   break;
  }
 }
 if ((label|0) == 6) {
  $68 = ((($0)) + 56|0); //@line 89701 "c/sqlite3.c"
  $69 = (_vdbePmaWriterFinish($1,$68)|0); //@line 89701 "c/sqlite3.c"
  $70 = ($$04244|0)==(0); //@line 89702 "c/sqlite3.c"
  $spec$select = $70 ? $69 : $$04244; //@line 89702 "c/sqlite3.c"
  STACKTOP = sp;return ($spec$select|0); //@line 89704 "c/sqlite3.c"
 }
 $$04244 = 0;
 $68 = ((($0)) + 56|0); //@line 89701 "c/sqlite3.c"
 $69 = (_vdbePmaWriterFinish($1,$68)|0); //@line 89701 "c/sqlite3.c"
 $70 = ($$04244|0)==(0); //@line 89702 "c/sqlite3.c"
 $spec$select = $70 ? $69 : $$04244; //@line 89702 "c/sqlite3.c"
 STACKTOP = sp;return ($spec$select|0); //@line 89704 "c/sqlite3.c"
}
function _vdbePmaReaderNext($0) {
 $0 = $0|0;
 var $$029$ph = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = $1; //@line 88480 "c/sqlite3.c"
 $3 = $2; //@line 88480 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 88480 "c/sqlite3.c"
 $4 = (($2) + 4)|0; //@line 88480 "c/sqlite3.c"
 $5 = $4; //@line 88480 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 88480 "c/sqlite3.c"
 $6 = $0; //@line 88483 "c/sqlite3.c"
 $7 = $6; //@line 88483 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 88483 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 88483 "c/sqlite3.c"
 $10 = $9; //@line 88483 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 88483 "c/sqlite3.c"
 $12 = ((($0)) + 8|0); //@line 88483 "c/sqlite3.c"
 $13 = $12; //@line 88483 "c/sqlite3.c"
 $14 = $13; //@line 88483 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 88483 "c/sqlite3.c"
 $16 = (($13) + 4)|0; //@line 88483 "c/sqlite3.c"
 $17 = $16; //@line 88483 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 88483 "c/sqlite3.c"
 $19 = ($11|0)<($18|0); //@line 88483 "c/sqlite3.c"
 $20 = ($8>>>0)<($15>>>0); //@line 88483 "c/sqlite3.c"
 $21 = ($11|0)==($18|0); //@line 88483 "c/sqlite3.c"
 $22 = $21 & $20; //@line 88483 "c/sqlite3.c"
 $23 = $19 | $22; //@line 88483 "c/sqlite3.c"
 do {
  if (!($23)) {
   $24 = ((($0)) + 48|0); //@line 88484 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 88484 "c/sqlite3.c"
   $26 = ($25|0)==(0|0); //@line 88486 "c/sqlite3.c"
   if ($26) {
    $$029$ph = 0;
   } else {
    $27 = (_vdbeIncrSwap($25)|0); //@line 88487 "c/sqlite3.c"
    $28 = ($27|0)==(0); //@line 88488 "c/sqlite3.c"
    if ($28) {
     $29 = ((($25)) + 20|0); //@line 88488 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 88488 "c/sqlite3.c"
     $31 = ($30|0)==(0); //@line 88488 "c/sqlite3.c"
     if ($31) {
      $32 = HEAP32[$25>>2]|0; //@line 88490 "c/sqlite3.c"
      $33 = ((($25)) + 32|0); //@line 88490 "c/sqlite3.c"
      $34 = ((($25)) + 8|0); //@line 88490 "c/sqlite3.c"
      $35 = $34; //@line 88490 "c/sqlite3.c"
      $36 = $35; //@line 88490 "c/sqlite3.c"
      $37 = HEAP32[$36>>2]|0; //@line 88490 "c/sqlite3.c"
      $38 = (($35) + 4)|0; //@line 88490 "c/sqlite3.c"
      $39 = $38; //@line 88490 "c/sqlite3.c"
      $40 = HEAP32[$39>>2]|0; //@line 88490 "c/sqlite3.c"
      $41 = (_vdbePmaReaderSeek($32,$0,$33,$37,$40)|0); //@line 88489 "c/sqlite3.c"
      $42 = ($41|0)==(0); //@line 88504 "c/sqlite3.c"
      if ($42) {
       break;
      } else {
       $$1 = $41;
      }
      STACKTOP = sp;return ($$1|0); //@line 88514 "c/sqlite3.c"
     } else {
      $$029$ph = 0;
     }
    } else {
     $$029$ph = $27;
    }
   }
   _vdbePmaReaderClear($0); //@line 88498 "c/sqlite3.c"
   $$1 = $$029$ph;
   STACKTOP = sp;return ($$1|0); //@line 88514 "c/sqlite3.c"
  }
 } while(0);
 $43 = (_vdbePmaReadVarint($0,$1)|0); //@line 88505 "c/sqlite3.c"
 $44 = ($43|0)==(0); //@line 88507 "c/sqlite3.c"
 if (!($44)) {
  $$1 = $43;
  STACKTOP = sp;return ($$1|0); //@line 88514 "c/sqlite3.c"
 }
 $45 = $1; //@line 88508 "c/sqlite3.c"
 $46 = $45; //@line 88508 "c/sqlite3.c"
 $47 = HEAP32[$46>>2]|0; //@line 88508 "c/sqlite3.c"
 $48 = (($45) + 4)|0; //@line 88508 "c/sqlite3.c"
 $49 = $48; //@line 88508 "c/sqlite3.c"
 $50 = HEAP32[$49>>2]|0; //@line 88508 "c/sqlite3.c"
 $51 = ((($0)) + 20|0); //@line 88508 "c/sqlite3.c"
 HEAP32[$51>>2] = $47; //@line 88508 "c/sqlite3.c"
 $52 = ((($0)) + 32|0); //@line 88509 "c/sqlite3.c"
 $53 = (_vdbePmaReadBlob($0,$47,$52)|0); //@line 88509 "c/sqlite3.c"
 $$1 = $53;
 STACKTOP = sp;return ($$1|0); //@line 88514 "c/sqlite3.c"
}
function _vdbeIncrSwap($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 24|0); //@line 89750 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 89750 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 89750 "c/sqlite3.c"
 if ($4) {
  $29 = (_vdbeIncrPopulate($0)|0); //@line 89769 "c/sqlite3.c"
  $30 = ((($0)) + 32|0); //@line 89770 "c/sqlite3.c"
  $31 = ((($0)) + 48|0); //@line 89770 "c/sqlite3.c"
  ;HEAP32[$30>>2]=HEAP32[$31>>2]|0;HEAP32[$30+4>>2]=HEAP32[$31+4>>2]|0;HEAP32[$30+8>>2]=HEAP32[$31+8>>2]|0;HEAP32[$30+12>>2]=HEAP32[$31+12>>2]|0; //@line 89770 "c/sqlite3.c"
  $32 = ((($0)) + 40|0); //@line 89771 "c/sqlite3.c"
  $33 = $32; //@line 89771 "c/sqlite3.c"
  $34 = $33; //@line 89771 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 89771 "c/sqlite3.c"
  $36 = (($33) + 4)|0; //@line 89771 "c/sqlite3.c"
  $37 = $36; //@line 89771 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 89771 "c/sqlite3.c"
  $39 = ((($0)) + 8|0); //@line 89771 "c/sqlite3.c"
  $40 = $39; //@line 89771 "c/sqlite3.c"
  $41 = $40; //@line 89771 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 89771 "c/sqlite3.c"
  $43 = (($40) + 4)|0; //@line 89771 "c/sqlite3.c"
  $44 = $43; //@line 89771 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 89771 "c/sqlite3.c"
  $46 = ($35|0)==($42|0); //@line 89771 "c/sqlite3.c"
  $47 = ($38|0)==($45|0); //@line 89771 "c/sqlite3.c"
  $48 = $46 & $47; //@line 89771 "c/sqlite3.c"
  if (!($48)) {
   $$0 = $29;
   STACKTOP = sp;return ($$0|0); //@line 89776 "c/sqlite3.c"
  }
  $49 = ((($0)) + 20|0); //@line 89772 "c/sqlite3.c"
  HEAP32[$49>>2] = 1; //@line 89772 "c/sqlite3.c"
  $$0 = $29;
  STACKTOP = sp;return ($$0|0); //@line 89776 "c/sqlite3.c"
 }
 $5 = HEAP32[$0>>2]|0; //@line 89751 "c/sqlite3.c"
 $6 = (_vdbeSorterJoinThread($5)|0); //@line 89751 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 89753 "c/sqlite3.c"
 if (!($7)) {
  $$0 = $6;
  STACKTOP = sp;return ($$0|0); //@line 89776 "c/sqlite3.c"
 }
 $8 = ((($0)) + 32|0); //@line 89754 "c/sqlite3.c"
 ;HEAP32[$1>>2]=HEAP32[$8>>2]|0;HEAP32[$1+4>>2]=HEAP32[$8+4>>2]|0;HEAP32[$1+8>>2]=HEAP32[$8+8>>2]|0;HEAP32[$1+12>>2]=HEAP32[$8+12>>2]|0; //@line 89754 "c/sqlite3.c"
 $9 = ((($0)) + 48|0); //@line 89755 "c/sqlite3.c"
 ;HEAP32[$8>>2]=HEAP32[$9>>2]|0;HEAP32[$8+4>>2]=HEAP32[$9+4>>2]|0;HEAP32[$8+8>>2]=HEAP32[$9+8>>2]|0;HEAP32[$8+12>>2]=HEAP32[$9+12>>2]|0; //@line 89755 "c/sqlite3.c"
 ;HEAP32[$9>>2]=HEAP32[$1>>2]|0;HEAP32[$9+4>>2]=HEAP32[$1+4>>2]|0;HEAP32[$9+8>>2]=HEAP32[$1+8>>2]|0;HEAP32[$9+12>>2]=HEAP32[$1+12>>2]|0; //@line 89756 "c/sqlite3.c"
 $10 = ((($0)) + 40|0); //@line 89760 "c/sqlite3.c"
 $11 = $10; //@line 89760 "c/sqlite3.c"
 $12 = $11; //@line 89760 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 89760 "c/sqlite3.c"
 $14 = (($11) + 4)|0; //@line 89760 "c/sqlite3.c"
 $15 = $14; //@line 89760 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 89760 "c/sqlite3.c"
 $17 = ((($0)) + 8|0); //@line 89760 "c/sqlite3.c"
 $18 = $17; //@line 89760 "c/sqlite3.c"
 $19 = $18; //@line 89760 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 89760 "c/sqlite3.c"
 $21 = (($18) + 4)|0; //@line 89760 "c/sqlite3.c"
 $22 = $21; //@line 89760 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 89760 "c/sqlite3.c"
 $24 = ($13|0)==($20|0); //@line 89760 "c/sqlite3.c"
 $25 = ($16|0)==($23|0); //@line 89760 "c/sqlite3.c"
 $26 = $24 & $25; //@line 89760 "c/sqlite3.c"
 if ($26) {
  $27 = ((($0)) + 20|0); //@line 89761 "c/sqlite3.c"
  HEAP32[$27>>2] = 1; //@line 89761 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 89776 "c/sqlite3.c"
 } else {
  $28 = (_vdbeIncrBgPopulate($0)|0); //@line 89763 "c/sqlite3.c"
  $$0 = $28;
  STACKTOP = sp;return ($$0|0); //@line 89776 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbePmaReaderSeek($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$047 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $5 = (_sqlite3FaultSim(201)|0); //@line 88441 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 88441 "c/sqlite3.c"
 if (!($6)) {
  $$047 = 266;
  return ($$047|0); //@line 88472 "c/sqlite3.c"
 }
 $7 = ((($1)) + 44|0); //@line 88442 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 88442 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 88442 "c/sqlite3.c"
 if (!($9)) {
  HEAP32[$7>>2] = 0; //@line 88444 "c/sqlite3.c"
 }
 $10 = $1; //@line 88446 "c/sqlite3.c"
 $11 = $10; //@line 88446 "c/sqlite3.c"
 HEAP32[$11>>2] = $3; //@line 88446 "c/sqlite3.c"
 $12 = (($10) + 4)|0; //@line 88446 "c/sqlite3.c"
 $13 = $12; //@line 88446 "c/sqlite3.c"
 HEAP32[$13>>2] = $4; //@line 88446 "c/sqlite3.c"
 $14 = ((($2)) + 8|0); //@line 88447 "c/sqlite3.c"
 $15 = $14; //@line 88447 "c/sqlite3.c"
 $16 = $15; //@line 88447 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 88447 "c/sqlite3.c"
 $18 = (($15) + 4)|0; //@line 88447 "c/sqlite3.c"
 $19 = $18; //@line 88447 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 88447 "c/sqlite3.c"
 $21 = ((($1)) + 8|0); //@line 88447 "c/sqlite3.c"
 $22 = $21; //@line 88447 "c/sqlite3.c"
 $23 = $22; //@line 88447 "c/sqlite3.c"
 HEAP32[$23>>2] = $17; //@line 88447 "c/sqlite3.c"
 $24 = (($22) + 4)|0; //@line 88447 "c/sqlite3.c"
 $25 = $24; //@line 88447 "c/sqlite3.c"
 HEAP32[$25>>2] = $20; //@line 88447 "c/sqlite3.c"
 $26 = HEAP32[$2>>2]|0; //@line 88448 "c/sqlite3.c"
 $27 = ((($1)) + 24|0); //@line 88448 "c/sqlite3.c"
 HEAP32[$27>>2] = $26; //@line 88448 "c/sqlite3.c"
 _vdbeSorterMapFile($0,$2,$7); //@line 88450 "c/sqlite3.c"
 $28 = HEAP32[$7>>2]|0; //@line 88451 "c/sqlite3.c"
 $29 = ($28|0)==(0|0); //@line 88451 "c/sqlite3.c"
 if (!($29)) {
  $$047 = 0;
  return ($$047|0); //@line 88472 "c/sqlite3.c"
 }
 $30 = ((($0)) + 8|0); //@line 88452 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 88452 "c/sqlite3.c"
 $32 = ((($31)) + 12|0); //@line 88452 "c/sqlite3.c"
 $33 = HEAP32[$32>>2]|0; //@line 88452 "c/sqlite3.c"
 $34 = $1; //@line 88453 "c/sqlite3.c"
 $35 = $34; //@line 88453 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 88453 "c/sqlite3.c"
 $37 = (($34) + 4)|0; //@line 88453 "c/sqlite3.c"
 $38 = $37; //@line 88453 "c/sqlite3.c"
 $39 = HEAP32[$38>>2]|0; //@line 88453 "c/sqlite3.c"
 $40 = ($33|0)<(0); //@line 88453 "c/sqlite3.c"
 $41 = $40 << 31 >> 31; //@line 88453 "c/sqlite3.c"
 $42 = (___remdi3(($36|0),($39|0),($33|0),($41|0))|0); //@line 88453 "c/sqlite3.c"
 $43 = tempRet0; //@line 88453 "c/sqlite3.c"
 $44 = ((($1)) + 36|0); //@line 88454 "c/sqlite3.c"
 $45 = HEAP32[$44>>2]|0; //@line 88454 "c/sqlite3.c"
 $46 = ($45|0)==(0|0); //@line 88454 "c/sqlite3.c"
 if ($46) {
  $47 = (_sqlite3Malloc($33,$41)|0); //@line 88455 "c/sqlite3.c"
  HEAP32[$44>>2] = $47; //@line 88455 "c/sqlite3.c"
  $48 = ($47|0)==(0|0); //@line 88456 "c/sqlite3.c"
  $spec$select = $48 ? 7 : 0; //@line 88456 "c/sqlite3.c"
  $49 = ((($1)) + 40|0); //@line 88457 "c/sqlite3.c"
  HEAP32[$49>>2] = $33; //@line 88457 "c/sqlite3.c"
  $$1 = $spec$select;
 } else {
  $$1 = 0;
 }
 $50 = ($$1|0)==(0); //@line 88459 "c/sqlite3.c"
 $51 = ($42|0)!=(0); //@line 88459 "c/sqlite3.c"
 $or$cond = $51 & $50; //@line 88459 "c/sqlite3.c"
 if (!($or$cond)) {
  $$047 = $$1;
  return ($$047|0); //@line 88472 "c/sqlite3.c"
 }
 $52 = (($33) - ($42))|0; //@line 88460 "c/sqlite3.c"
 $53 = $1; //@line 88461 "c/sqlite3.c"
 $54 = $53; //@line 88461 "c/sqlite3.c"
 $55 = HEAP32[$54>>2]|0; //@line 88461 "c/sqlite3.c"
 $56 = (($53) + 4)|0; //@line 88461 "c/sqlite3.c"
 $57 = $56; //@line 88461 "c/sqlite3.c"
 $58 = HEAP32[$57>>2]|0; //@line 88461 "c/sqlite3.c"
 $59 = ($52|0)<(0); //@line 88461 "c/sqlite3.c"
 $60 = $59 << 31 >> 31; //@line 88461 "c/sqlite3.c"
 $61 = (_i64Add(($55|0),($58|0),($52|0),($60|0))|0); //@line 88461 "c/sqlite3.c"
 $62 = tempRet0; //@line 88461 "c/sqlite3.c"
 $63 = $21; //@line 88461 "c/sqlite3.c"
 $64 = $63; //@line 88461 "c/sqlite3.c"
 $65 = HEAP32[$64>>2]|0; //@line 88461 "c/sqlite3.c"
 $66 = (($63) + 4)|0; //@line 88461 "c/sqlite3.c"
 $67 = $66; //@line 88461 "c/sqlite3.c"
 $68 = HEAP32[$67>>2]|0; //@line 88461 "c/sqlite3.c"
 $69 = ($62|0)>($68|0); //@line 88461 "c/sqlite3.c"
 $70 = ($61>>>0)>($65>>>0); //@line 88461 "c/sqlite3.c"
 $71 = ($62|0)==($68|0); //@line 88461 "c/sqlite3.c"
 $72 = $71 & $70; //@line 88461 "c/sqlite3.c"
 $73 = $69 | $72; //@line 88461 "c/sqlite3.c"
 $74 = (_i64Subtract(($65|0),($68|0),($55|0),($58|0))|0); //@line 88462 "c/sqlite3.c"
 $75 = tempRet0; //@line 88462 "c/sqlite3.c"
 $$0 = $73 ? $74 : $52; //@line 88461 "c/sqlite3.c"
 $76 = HEAP32[$27>>2]|0; //@line 88465 "c/sqlite3.c"
 $77 = HEAP32[$44>>2]|0; //@line 88465 "c/sqlite3.c"
 $78 = (($77) + ($42)|0); //@line 88465 "c/sqlite3.c"
 $79 = (_sqlite3OsRead($76,$78,$$0,$55,$58)|0); //@line 88464 "c/sqlite3.c"
 $$047 = $79;
 return ($$047|0); //@line 88472 "c/sqlite3.c"
}
function _vdbePmaReadVarint($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$025 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp + 8|0;
 $3 = sp;
 $4 = ((($0)) + 44|0); //@line 88384 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 88384 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 88384 "c/sqlite3.c"
 $7 = $0;
 $8 = $7;
 $9 = HEAP32[$8>>2]|0;
 $10 = (($7) + 4)|0;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 if (!($6)) {
  $13 = (($5) + ($9)|0); //@line 88385 "c/sqlite3.c"
  $14 = (_sqlite3GetVarint($13,$1)|0); //@line 88385 "c/sqlite3.c"
  $15 = $14&255; //@line 88385 "c/sqlite3.c"
  $16 = $0; //@line 88385 "c/sqlite3.c"
  $17 = $16; //@line 88385 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 88385 "c/sqlite3.c"
  $19 = (($16) + 4)|0; //@line 88385 "c/sqlite3.c"
  $20 = $19; //@line 88385 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 88385 "c/sqlite3.c"
  $22 = (_i64Add(($18|0),($21|0),($15|0),0)|0); //@line 88385 "c/sqlite3.c"
  $23 = tempRet0; //@line 88385 "c/sqlite3.c"
  $24 = $0; //@line 88385 "c/sqlite3.c"
  $25 = $24; //@line 88385 "c/sqlite3.c"
  HEAP32[$25>>2] = $22; //@line 88385 "c/sqlite3.c"
  $26 = (($24) + 4)|0; //@line 88385 "c/sqlite3.c"
  $27 = $26; //@line 88385 "c/sqlite3.c"
  HEAP32[$27>>2] = $23; //@line 88385 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 88403 "c/sqlite3.c"
 }
 $28 = ((($0)) + 40|0); //@line 88387 "c/sqlite3.c"
 $29 = HEAP32[$28>>2]|0; //@line 88387 "c/sqlite3.c"
 $30 = ($29|0)<(0); //@line 88387 "c/sqlite3.c"
 $31 = $30 << 31 >> 31; //@line 88387 "c/sqlite3.c"
 $32 = (___remdi3(($9|0),($12|0),($29|0),($31|0))|0); //@line 88387 "c/sqlite3.c"
 $33 = tempRet0; //@line 88387 "c/sqlite3.c"
 $34 = ($32|0)!=(0); //@line 88388 "c/sqlite3.c"
 $35 = (($29) - ($32))|0; //@line 88388 "c/sqlite3.c"
 $36 = ($35|0)>(8); //@line 88388 "c/sqlite3.c"
 $or$cond = $34 & $36; //@line 88388 "c/sqlite3.c"
 if ($or$cond) {
  $37 = ((($0)) + 36|0); //@line 88389 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 88389 "c/sqlite3.c"
  $39 = (($38) + ($32)|0); //@line 88389 "c/sqlite3.c"
  $40 = (_sqlite3GetVarint($39,$1)|0); //@line 88389 "c/sqlite3.c"
  $41 = $40&255; //@line 88389 "c/sqlite3.c"
  $42 = $0; //@line 88389 "c/sqlite3.c"
  $43 = $42; //@line 88389 "c/sqlite3.c"
  $44 = HEAP32[$43>>2]|0; //@line 88389 "c/sqlite3.c"
  $45 = (($42) + 4)|0; //@line 88389 "c/sqlite3.c"
  $46 = $45; //@line 88389 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 88389 "c/sqlite3.c"
  $48 = (_i64Add(($44|0),($47|0),($41|0),0)|0); //@line 88389 "c/sqlite3.c"
  $49 = tempRet0; //@line 88389 "c/sqlite3.c"
  $50 = $0; //@line 88389 "c/sqlite3.c"
  $51 = $50; //@line 88389 "c/sqlite3.c"
  HEAP32[$51>>2] = $48; //@line 88389 "c/sqlite3.c"
  $52 = (($50) + 4)|0; //@line 88389 "c/sqlite3.c"
  $53 = $52; //@line 88389 "c/sqlite3.c"
  HEAP32[$53>>2] = $49; //@line 88389 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 88403 "c/sqlite3.c"
 }
 $$025 = 0;
 while(1) {
  $54 = (_vdbePmaReadBlob($0,1,$3)|0); //@line 88394 "c/sqlite3.c"
  $55 = ($54|0)==(0); //@line 88395 "c/sqlite3.c"
  if (!($55)) {
   label = 9;
   break;
  }
  $56 = HEAP32[$3>>2]|0; //@line 88396 "c/sqlite3.c"
  $57 = HEAP8[$56>>0]|0; //@line 88396 "c/sqlite3.c"
  $58 = (($$025) + 1)|0; //@line 88396 "c/sqlite3.c"
  $59 = $$025 & 15; //@line 88396 "c/sqlite3.c"
  $60 = (($2) + ($59)|0); //@line 88396 "c/sqlite3.c"
  HEAP8[$60>>0] = $57; //@line 88396 "c/sqlite3.c"
  $61 = ($57<<24>>24)<(0); //@line 88397 "c/sqlite3.c"
  if ($61) {
   $$025 = $58;
  } else {
   label = 8;
   break;
  }
 }
 if ((label|0) == 8) {
  (_sqlite3GetVarint($2,$1)|0); //@line 88398 "c/sqlite3.c"
  $$1 = 0;
  STACKTOP = sp;return ($$1|0); //@line 88403 "c/sqlite3.c"
 }
 else if ((label|0) == 9) {
  $$1 = $54;
  STACKTOP = sp;return ($$1|0); //@line 88403 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbePmaReadBlob($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$092 = 0, $$097109 = 0, $$099 = 0, $$7 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $spec$select = 0, $spec$select100 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($0)) + 44|0); //@line 88295 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 88295 "c/sqlite3.c"
 $6 = ($5|0)==(0|0); //@line 88295 "c/sqlite3.c"
 $7 = $0;
 $8 = $7;
 $9 = HEAP32[$8>>2]|0;
 $10 = (($7) + 4)|0;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 if (!($6)) {
  $13 = (($5) + ($9)|0); //@line 88296 "c/sqlite3.c"
  HEAP32[$2>>2] = $13; //@line 88296 "c/sqlite3.c"
  $14 = ($1|0)<(0); //@line 88297 "c/sqlite3.c"
  $15 = $14 << 31 >> 31; //@line 88297 "c/sqlite3.c"
  $16 = (_i64Add(($9|0),($12|0),($1|0),($15|0))|0); //@line 88297 "c/sqlite3.c"
  $17 = tempRet0; //@line 88297 "c/sqlite3.c"
  $18 = $0; //@line 88297 "c/sqlite3.c"
  $19 = $18; //@line 88297 "c/sqlite3.c"
  HEAP32[$19>>2] = $16; //@line 88297 "c/sqlite3.c"
  $20 = (($18) + 4)|0; //@line 88297 "c/sqlite3.c"
  $21 = $20; //@line 88297 "c/sqlite3.c"
  HEAP32[$21>>2] = $17; //@line 88297 "c/sqlite3.c"
  $$7 = 0;
  STACKTOP = sp;return ($$7|0); //@line 88375 "c/sqlite3.c"
 }
 $22 = ((($0)) + 40|0); //@line 88306 "c/sqlite3.c"
 $23 = HEAP32[$22>>2]|0; //@line 88306 "c/sqlite3.c"
 $24 = ($23|0)<(0); //@line 88306 "c/sqlite3.c"
 $25 = $24 << 31 >> 31; //@line 88306 "c/sqlite3.c"
 $26 = (___remdi3(($9|0),($12|0),($23|0),($25|0))|0); //@line 88306 "c/sqlite3.c"
 $27 = tempRet0; //@line 88306 "c/sqlite3.c"
 $28 = ($26|0)==(0); //@line 88307 "c/sqlite3.c"
 if ($28) {
  $29 = ((($0)) + 8|0); //@line 88312 "c/sqlite3.c"
  $30 = $29; //@line 88312 "c/sqlite3.c"
  $31 = $30; //@line 88312 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 88312 "c/sqlite3.c"
  $33 = (($30) + 4)|0; //@line 88312 "c/sqlite3.c"
  $34 = $33; //@line 88312 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 88312 "c/sqlite3.c"
  $36 = (_i64Subtract(($32|0),($35|0),($9|0),($12|0))|0); //@line 88312 "c/sqlite3.c"
  $37 = tempRet0; //@line 88312 "c/sqlite3.c"
  $38 = ($37|0)>($25|0); //@line 88312 "c/sqlite3.c"
  $39 = ($36>>>0)>($23>>>0); //@line 88312 "c/sqlite3.c"
  $40 = ($37|0)==($25|0); //@line 88312 "c/sqlite3.c"
  $41 = $40 & $39; //@line 88312 "c/sqlite3.c"
  $42 = $38 | $41; //@line 88312 "c/sqlite3.c"
  $$099 = $42 ? $23 : $36; //@line 88312 "c/sqlite3.c"
  $43 = ((($0)) + 24|0); //@line 88320 "c/sqlite3.c"
  $44 = HEAP32[$43>>2]|0; //@line 88320 "c/sqlite3.c"
  $45 = ((($0)) + 36|0); //@line 88320 "c/sqlite3.c"
  $46 = HEAP32[$45>>2]|0; //@line 88320 "c/sqlite3.c"
  $47 = (_sqlite3OsRead($44,$46,$$099,$9,$12)|0); //@line 88320 "c/sqlite3.c"
  $48 = ($47|0)==(0); //@line 88322 "c/sqlite3.c"
  if (!($48)) {
   $$7 = $47;
   STACKTOP = sp;return ($$7|0); //@line 88375 "c/sqlite3.c"
  }
 }
 $49 = HEAP32[$22>>2]|0; //@line 88324 "c/sqlite3.c"
 $50 = (($49) - ($26))|0; //@line 88324 "c/sqlite3.c"
 $51 = ($50|0)<($1|0); //@line 88326 "c/sqlite3.c"
 if (!($51)) {
  $52 = ((($0)) + 36|0); //@line 88330 "c/sqlite3.c"
  $53 = HEAP32[$52>>2]|0; //@line 88330 "c/sqlite3.c"
  $54 = (($53) + ($26)|0); //@line 88330 "c/sqlite3.c"
  HEAP32[$2>>2] = $54; //@line 88330 "c/sqlite3.c"
  $55 = ($1|0)<(0); //@line 88331 "c/sqlite3.c"
  $56 = $55 << 31 >> 31; //@line 88331 "c/sqlite3.c"
  $57 = $0; //@line 88331 "c/sqlite3.c"
  $58 = $57; //@line 88331 "c/sqlite3.c"
  $59 = HEAP32[$58>>2]|0; //@line 88331 "c/sqlite3.c"
  $60 = (($57) + 4)|0; //@line 88331 "c/sqlite3.c"
  $61 = $60; //@line 88331 "c/sqlite3.c"
  $62 = HEAP32[$61>>2]|0; //@line 88331 "c/sqlite3.c"
  $63 = (_i64Add(($59|0),($62|0),($1|0),($56|0))|0); //@line 88331 "c/sqlite3.c"
  $64 = tempRet0; //@line 88331 "c/sqlite3.c"
  $65 = $0; //@line 88331 "c/sqlite3.c"
  $66 = $65; //@line 88331 "c/sqlite3.c"
  HEAP32[$66>>2] = $63; //@line 88331 "c/sqlite3.c"
  $67 = (($65) + 4)|0; //@line 88331 "c/sqlite3.c"
  $68 = $67; //@line 88331 "c/sqlite3.c"
  HEAP32[$68>>2] = $64; //@line 88331 "c/sqlite3.c"
  $$7 = 0;
  STACKTOP = sp;return ($$7|0); //@line 88375 "c/sqlite3.c"
 }
 $69 = ((($0)) + 16|0); //@line 88339 "c/sqlite3.c"
 $70 = HEAP32[$69>>2]|0; //@line 88339 "c/sqlite3.c"
 $71 = ($70|0)<($1|0); //@line 88339 "c/sqlite3.c"
 do {
  if ($71) {
   $72 = ($70|0)<(64); //@line 88341 "c/sqlite3.c"
   $73 = $70 << 1; //@line 88341 "c/sqlite3.c"
   $spec$select = $72 ? 128 : $73; //@line 88341 "c/sqlite3.c"
   $$092 = $spec$select;
   while(1) {
    $74 = ($$092|0)<($1|0); //@line 88342 "c/sqlite3.c"
    $75 = $$092 << 1; //@line 88342 "c/sqlite3.c"
    if ($74) {
     $$092 = $75;
    } else {
     break;
    }
   }
   $76 = ((($0)) + 28|0); //@line 88343 "c/sqlite3.c"
   $77 = HEAP32[$76>>2]|0; //@line 88343 "c/sqlite3.c"
   $78 = ($$092|0)<(0); //@line 88343 "c/sqlite3.c"
   $79 = $78 << 31 >> 31; //@line 88343 "c/sqlite3.c"
   $80 = (_sqlite3Realloc($77,$$092,$79)|0); //@line 88343 "c/sqlite3.c"
   $81 = ($80|0)==(0|0); //@line 88344 "c/sqlite3.c"
   if ($81) {
    $$7 = 7;
    STACKTOP = sp;return ($$7|0); //@line 88375 "c/sqlite3.c"
   } else {
    HEAP32[$69>>2] = $$092; //@line 88345 "c/sqlite3.c"
    HEAP32[$76>>2] = $80; //@line 88346 "c/sqlite3.c"
    break;
   }
  }
 } while(0);
 $82 = ((($0)) + 28|0); //@line 88351 "c/sqlite3.c"
 $83 = HEAP32[$82>>2]|0; //@line 88351 "c/sqlite3.c"
 $84 = ((($0)) + 36|0); //@line 88351 "c/sqlite3.c"
 $85 = HEAP32[$84>>2]|0; //@line 88351 "c/sqlite3.c"
 $86 = (($85) + ($26)|0); //@line 88351 "c/sqlite3.c"
 _memcpy(($83|0),($86|0),($50|0))|0; //@line 88351 "c/sqlite3.c"
 $87 = ($50|0)<(0); //@line 88352 "c/sqlite3.c"
 $88 = $87 << 31 >> 31; //@line 88352 "c/sqlite3.c"
 $89 = $0; //@line 88352 "c/sqlite3.c"
 $90 = $89; //@line 88352 "c/sqlite3.c"
 $91 = HEAP32[$90>>2]|0; //@line 88352 "c/sqlite3.c"
 $92 = (($89) + 4)|0; //@line 88352 "c/sqlite3.c"
 $93 = $92; //@line 88352 "c/sqlite3.c"
 $94 = HEAP32[$93>>2]|0; //@line 88352 "c/sqlite3.c"
 $95 = (_i64Add(($91|0),($94|0),($50|0),($88|0))|0); //@line 88352 "c/sqlite3.c"
 $96 = tempRet0; //@line 88352 "c/sqlite3.c"
 $97 = $0; //@line 88352 "c/sqlite3.c"
 $98 = $97; //@line 88352 "c/sqlite3.c"
 HEAP32[$98>>2] = $95; //@line 88352 "c/sqlite3.c"
 $99 = (($97) + 4)|0; //@line 88352 "c/sqlite3.c"
 $100 = $99; //@line 88352 "c/sqlite3.c"
 HEAP32[$100>>2] = $96; //@line 88352 "c/sqlite3.c"
 $101 = (($1) - ($50))|0; //@line 88353 "c/sqlite3.c"
 $102 = ($101|0)>(0); //@line 88357 "c/sqlite3.c"
 L22: do {
  if ($102) {
   $$097109 = $101;
   while(1) {
    $103 = HEAP32[$22>>2]|0; //@line 88363 "c/sqlite3.c"
    $104 = ($$097109|0)>($103|0); //@line 88363 "c/sqlite3.c"
    $spec$select100 = $104 ? $103 : $$097109; //@line 88363 "c/sqlite3.c"
    $105 = (_vdbePmaReadBlob($0,$spec$select100,$3)|0); //@line 88364 "c/sqlite3.c"
    $106 = ($105|0)==(0); //@line 88365 "c/sqlite3.c"
    if (!($106)) {
     break;
    }
    $107 = (($$097109) - ($spec$select100))|0; //@line 88368 "c/sqlite3.c"
    $108 = (($1) - ($$097109))|0; //@line 88367 "c/sqlite3.c"
    $109 = HEAP32[$82>>2]|0; //@line 88367 "c/sqlite3.c"
    $110 = (($109) + ($108)|0); //@line 88367 "c/sqlite3.c"
    $111 = HEAP32[$3>>2]|0; //@line 88367 "c/sqlite3.c"
    _memcpy(($110|0),($111|0),($spec$select100|0))|0; //@line 88367 "c/sqlite3.c"
    $112 = ($107|0)>(0); //@line 88357 "c/sqlite3.c"
    if ($112) {
     $$097109 = $107;
    } else {
     break L22;
    }
   }
   $$7 = $105;
   STACKTOP = sp;return ($$7|0); //@line 88375 "c/sqlite3.c"
  }
 } while(0);
 $113 = HEAP32[$82>>2]|0; //@line 88371 "c/sqlite3.c"
 HEAP32[$2>>2] = $113; //@line 88371 "c/sqlite3.c"
 $$7 = 0;
 STACKTOP = sp;return ($$7|0); //@line 88375 "c/sqlite3.c"
}
function _vdbeSorterMapFile($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($1)) + 8|0); //@line 88416 "c/sqlite3.c"
 $4 = $3; //@line 88416 "c/sqlite3.c"
 $5 = $4; //@line 88416 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 88416 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 88416 "c/sqlite3.c"
 $8 = $7; //@line 88416 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 88416 "c/sqlite3.c"
 $10 = ((($0)) + 8|0); //@line 88416 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 88416 "c/sqlite3.c"
 $12 = ((($11)) + 24|0); //@line 88416 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 88416 "c/sqlite3.c"
 $14 = ((($13)) + 148|0); //@line 88416 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 88416 "c/sqlite3.c"
 $16 = ($15|0)<(0); //@line 88416 "c/sqlite3.c"
 $17 = $16 << 31 >> 31; //@line 88416 "c/sqlite3.c"
 $18 = ($9|0)>($17|0); //@line 88416 "c/sqlite3.c"
 $19 = ($6>>>0)>($15>>>0); //@line 88416 "c/sqlite3.c"
 $20 = ($9|0)==($17|0); //@line 88416 "c/sqlite3.c"
 $21 = $20 & $19; //@line 88416 "c/sqlite3.c"
 $22 = $18 | $21; //@line 88416 "c/sqlite3.c"
 if ($22) {
  return;
 }
 $23 = HEAP32[$1>>2]|0; //@line 88417 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 88418 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 88418 "c/sqlite3.c"
 $26 = ($25|0)>(2); //@line 88418 "c/sqlite3.c"
 if (!($26)) {
  return;
 }
 _sqlite3OsFetch($2); //@line 88419 "c/sqlite3.c"
 return;
}
function _sqlite3OsFetch($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$0>>2] = 0; //@line 21000 "c/sqlite3.c"
 return;
}
function _vdbeIncrBgPopulate($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP32[$0>>2]|0; //@line 89725 "c/sqlite3.c"
 $2 = (_vdbeSorterCreateThread($1,160,$0)|0); //@line 89725 "c/sqlite3.c"
 return ($2|0); //@line 89725 "c/sqlite3.c"
}
function _vdbePmaWriterInit($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$1; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 89257 "c/sqlite3.c"
 $5 = ($2|0)<(0); //@line 89258 "c/sqlite3.c"
 $6 = $5 << 31 >> 31; //@line 89258 "c/sqlite3.c"
 $7 = (_sqlite3Malloc($2,$6)|0); //@line 89258 "c/sqlite3.c"
 $8 = ((($1)) + 4|0); //@line 89258 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 89258 "c/sqlite3.c"
 $9 = ($7|0)==(0|0); //@line 89259 "c/sqlite3.c"
 if ($9) {
  HEAP32[$1>>2] = 7; //@line 89260 "c/sqlite3.c"
  return; //@line 89267 "c/sqlite3.c"
 } else {
  $10 = (___remdi3(($3|0),($4|0),($2|0),($6|0))|0); //@line 89262 "c/sqlite3.c"
  $11 = tempRet0; //@line 89262 "c/sqlite3.c"
  $12 = ((($1)) + 12|0); //@line 89262 "c/sqlite3.c"
  HEAP32[$12>>2] = $10; //@line 89262 "c/sqlite3.c"
  $13 = ((($1)) + 16|0); //@line 89262 "c/sqlite3.c"
  HEAP32[$13>>2] = $10; //@line 89262 "c/sqlite3.c"
  $14 = ($10|0)<(0); //@line 89263 "c/sqlite3.c"
  $15 = $14 << 31 >> 31; //@line 89263 "c/sqlite3.c"
  $16 = (_i64Subtract(($3|0),($4|0),($10|0),($15|0))|0); //@line 89263 "c/sqlite3.c"
  $17 = tempRet0; //@line 89263 "c/sqlite3.c"
  $18 = ((($1)) + 24|0); //@line 89263 "c/sqlite3.c"
  $19 = $18; //@line 89263 "c/sqlite3.c"
  $20 = $19; //@line 89263 "c/sqlite3.c"
  HEAP32[$20>>2] = $16; //@line 89263 "c/sqlite3.c"
  $21 = (($19) + 4)|0; //@line 89263 "c/sqlite3.c"
  $22 = $21; //@line 89263 "c/sqlite3.c"
  HEAP32[$22>>2] = $17; //@line 89263 "c/sqlite3.c"
  $23 = ((($1)) + 8|0); //@line 89264 "c/sqlite3.c"
  HEAP32[$23>>2] = $2; //@line 89264 "c/sqlite3.c"
  $24 = ((($1)) + 32|0); //@line 89265 "c/sqlite3.c"
  HEAP32[$24>>2] = $0; //@line 89265 "c/sqlite3.c"
  return; //@line 89267 "c/sqlite3.c"
 }
}
function _vdbePmaWriteVarint($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = (_sqlite3PutVarint($3,$1,$2)|0); //@line 89328 "c/sqlite3.c"
 _vdbePmaWriteBlob($0,$3,$4); //@line 89329 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 89330 "c/sqlite3.c"
}
function _vdbePmaWriteBlob($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03536 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)>(0); //@line 89275 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 89295 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0);
 $5 = ((($0)) + 16|0);
 $6 = ((($0)) + 4|0);
 $7 = ((($0)) + 32|0);
 $8 = ((($0)) + 12|0);
 $9 = ((($0)) + 24|0);
 $$03536 = $2;
 while(1) {
  $10 = HEAP32[$0>>2]|0; //@line 89275 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 89275 "c/sqlite3.c"
  if (!($11)) {
   label = 7;
   break;
  }
  $12 = HEAP32[$4>>2]|0; //@line 89277 "c/sqlite3.c"
  $13 = HEAP32[$5>>2]|0; //@line 89277 "c/sqlite3.c"
  $14 = (($12) - ($13))|0; //@line 89277 "c/sqlite3.c"
  $15 = ($$03536|0)>($14|0); //@line 89277 "c/sqlite3.c"
  $spec$select = $15 ? $14 : $$03536; //@line 89277 "c/sqlite3.c"
  $16 = HEAP32[$6>>2]|0; //@line 89281 "c/sqlite3.c"
  $17 = (($16) + ($13)|0); //@line 89281 "c/sqlite3.c"
  $18 = (($2) - ($$03536))|0; //@line 89281 "c/sqlite3.c"
  $19 = (($1) + ($18)|0); //@line 89281 "c/sqlite3.c"
  _memcpy(($17|0),($19|0),($spec$select|0))|0; //@line 89281 "c/sqlite3.c"
  $20 = HEAP32[$5>>2]|0; //@line 89282 "c/sqlite3.c"
  $21 = (($20) + ($spec$select))|0; //@line 89282 "c/sqlite3.c"
  HEAP32[$5>>2] = $21; //@line 89282 "c/sqlite3.c"
  $22 = HEAP32[$4>>2]|0; //@line 89283 "c/sqlite3.c"
  $23 = ($21|0)==($22|0); //@line 89283 "c/sqlite3.c"
  if ($23) {
   $24 = HEAP32[$7>>2]|0; //@line 89284 "c/sqlite3.c"
   $25 = HEAP32[$6>>2]|0; //@line 89285 "c/sqlite3.c"
   $26 = HEAP32[$8>>2]|0; //@line 89285 "c/sqlite3.c"
   $27 = (($25) + ($26)|0); //@line 89285 "c/sqlite3.c"
   $28 = (($21) - ($26))|0; //@line 89285 "c/sqlite3.c"
   $29 = $9; //@line 89286 "c/sqlite3.c"
   $30 = $29; //@line 89286 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 89286 "c/sqlite3.c"
   $32 = (($29) + 4)|0; //@line 89286 "c/sqlite3.c"
   $33 = $32; //@line 89286 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 89286 "c/sqlite3.c"
   $35 = ($26|0)<(0); //@line 89286 "c/sqlite3.c"
   $36 = $35 << 31 >> 31; //@line 89286 "c/sqlite3.c"
   $37 = (_i64Add(($31|0),($34|0),($26|0),($36|0))|0); //@line 89286 "c/sqlite3.c"
   $38 = tempRet0; //@line 89286 "c/sqlite3.c"
   $39 = (_sqlite3OsWrite($24,$27,$28,$37,$38)|0); //@line 89284 "c/sqlite3.c"
   HEAP32[$0>>2] = $39; //@line 89284 "c/sqlite3.c"
   HEAP32[$5>>2] = 0; //@line 89288 "c/sqlite3.c"
   HEAP32[$8>>2] = 0; //@line 89288 "c/sqlite3.c"
   $40 = HEAP32[$4>>2]|0; //@line 89289 "c/sqlite3.c"
   $41 = ($40|0)<(0); //@line 89289 "c/sqlite3.c"
   $42 = $41 << 31 >> 31; //@line 89289 "c/sqlite3.c"
   $43 = $9; //@line 89289 "c/sqlite3.c"
   $44 = $43; //@line 89289 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 89289 "c/sqlite3.c"
   $46 = (($43) + 4)|0; //@line 89289 "c/sqlite3.c"
   $47 = $46; //@line 89289 "c/sqlite3.c"
   $48 = HEAP32[$47>>2]|0; //@line 89289 "c/sqlite3.c"
   $49 = (_i64Add(($45|0),($48|0),($40|0),($42|0))|0); //@line 89289 "c/sqlite3.c"
   $50 = tempRet0; //@line 89289 "c/sqlite3.c"
   $51 = $9; //@line 89289 "c/sqlite3.c"
   $52 = $51; //@line 89289 "c/sqlite3.c"
   HEAP32[$52>>2] = $49; //@line 89289 "c/sqlite3.c"
   $53 = (($51) + 4)|0; //@line 89289 "c/sqlite3.c"
   $54 = $53; //@line 89289 "c/sqlite3.c"
   HEAP32[$54>>2] = $50; //@line 89289 "c/sqlite3.c"
  }
  $55 = (($$03536) - ($spec$select))|0; //@line 89293 "c/sqlite3.c"
  $56 = ($55|0)>(0); //@line 89275 "c/sqlite3.c"
  if ($56) {
   $$03536 = $55;
  } else {
   label = 7;
   break;
  }
 }
 if ((label|0) == 7) {
  return; //@line 89295 "c/sqlite3.c"
 }
}
function _vdbeMergeEngineStep($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$05869 = 0, $$05968 = 0, $$06170 = 0, $$06170$in = 0, $$1 = 0, $$160 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = ((($0)) + 8|0); //@line 89415 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 89415 "c/sqlite3.c"
 $5 = ((($4)) + 4|0); //@line 89415 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89415 "c/sqlite3.c"
 $7 = ((($0)) + 4|0); //@line 89416 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 89416 "c/sqlite3.c"
 $9 = ((($0)) + 12|0); //@line 89419 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 89419 "c/sqlite3.c"
 $11 = (($10) + (($6*56)|0)|0); //@line 89419 "c/sqlite3.c"
 $12 = (_vdbePmaReaderNext($11)|0); //@line 89419 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 89422 "c/sqlite3.c"
 if (!($13)) {
  $79 = $12;
  STACKTOP = sp;return ($79|0); //@line 89474 "c/sqlite3.c"
 }
 HEAP32[$2>>2] = 0; //@line 89426 "c/sqlite3.c"
 $14 = HEAP32[$9>>2]|0; //@line 89430 "c/sqlite3.c"
 $15 = HEAP32[$0>>2]|0; //@line 89433 "c/sqlite3.c"
 $16 = (($15) + ($6))|0; //@line 89433 "c/sqlite3.c"
 $17 = ($16|0)>(1); //@line 89433 "c/sqlite3.c"
 if ($17) {
  $18 = $6 | 1; //@line 89431 "c/sqlite3.c"
  $19 = (($14) + (($18*56)|0)|0); //@line 89431 "c/sqlite3.c"
  $20 = $6 & 65534; //@line 89430 "c/sqlite3.c"
  $21 = (($14) + (($20*56)|0)|0); //@line 89430 "c/sqlite3.c"
  $22 = ((($8)) + 32|0);
  $$05869 = $19;$$05968 = $21;$$06170$in = $16;
  while(1) {
   $$06170 = (($$06170$in|0) / 2)&-1;
   $23 = ((($$05968)) + 24|0); //@line 89436 "c/sqlite3.c"
   $24 = HEAP32[$23>>2]|0; //@line 89436 "c/sqlite3.c"
   $25 = ($24|0)==(0|0); //@line 89436 "c/sqlite3.c"
   do {
    if ($25) {
     label = 11;
    } else {
     $26 = ((($$05869)) + 24|0); //@line 89438 "c/sqlite3.c"
     $27 = HEAP32[$26>>2]|0; //@line 89438 "c/sqlite3.c"
     $28 = ($27|0)==(0|0); //@line 89438 "c/sqlite3.c"
     if (!($28)) {
      $29 = HEAP32[$22>>2]|0; //@line 89441 "c/sqlite3.c"
      $30 = ((($$05968)) + 32|0); //@line 89442 "c/sqlite3.c"
      $31 = HEAP32[$30>>2]|0; //@line 89442 "c/sqlite3.c"
      $32 = ((($$05968)) + 20|0); //@line 89442 "c/sqlite3.c"
      $33 = HEAP32[$32>>2]|0; //@line 89442 "c/sqlite3.c"
      $34 = ((($$05869)) + 32|0); //@line 89442 "c/sqlite3.c"
      $35 = HEAP32[$34>>2]|0; //@line 89442 "c/sqlite3.c"
      $36 = ((($$05869)) + 20|0); //@line 89442 "c/sqlite3.c"
      $37 = HEAP32[$36>>2]|0; //@line 89442 "c/sqlite3.c"
      $38 = (FUNCTION_TABLE_iiiiiii[$29 & 127]($8,$2,$31,$33,$35,$37)|0); //@line 89441 "c/sqlite3.c"
      $39 = ($38|0)<(0); //@line 89461 "c/sqlite3.c"
      if (!($39)) {
       $40 = ($38|0)==(0); //@line 89461 "c/sqlite3.c"
       $41 = ($$05968>>>0)<($$05869>>>0); //@line 89461 "c/sqlite3.c"
       $or$cond = $41 & $40; //@line 89461 "c/sqlite3.c"
       if (!($or$cond)) {
        $$pr = HEAP32[$23>>2]|0; //@line 89466 "c/sqlite3.c"
        $53 = ($$pr|0)==(0|0); //@line 89466 "c/sqlite3.c"
        if ($53) {
         label = 11;
         break;
        }
        HEAP32[$2>>2] = 0; //@line 89466 "c/sqlite3.c"
        label = 11;
        break;
       }
      }
     }
     $42 = HEAP32[$9>>2]|0; //@line 89462 "c/sqlite3.c"
     $43 = $$05968; //@line 89462 "c/sqlite3.c"
     $44 = (($43) - ($42))|0; //@line 89462 "c/sqlite3.c"
     $45 = (($44|0) / 56)&-1; //@line 89462 "c/sqlite3.c"
     $46 = HEAP32[$3>>2]|0; //@line 89462 "c/sqlite3.c"
     $47 = (($46) + ($$06170<<2)|0); //@line 89462 "c/sqlite3.c"
     HEAP32[$47>>2] = $45; //@line 89462 "c/sqlite3.c"
     $48 = HEAP32[$9>>2]|0; //@line 89463 "c/sqlite3.c"
     $49 = $$06170 ^ 1; //@line 89463 "c/sqlite3.c"
     $50 = (($46) + ($49<<2)|0); //@line 89463 "c/sqlite3.c"
     $51 = HEAP32[$50>>2]|0; //@line 89463 "c/sqlite3.c"
     $52 = (($48) + (($51*56)|0)|0); //@line 89463 "c/sqlite3.c"
     HEAP32[$2>>2] = 0; //@line 89464 "c/sqlite3.c"
     $$1 = $52;$$160 = $$05968;
    }
   } while(0);
   if ((label|0) == 11) {
    label = 0;
    $54 = HEAP32[$9>>2]|0; //@line 89467 "c/sqlite3.c"
    $55 = $$05869; //@line 89467 "c/sqlite3.c"
    $56 = (($55) - ($54))|0; //@line 89467 "c/sqlite3.c"
    $57 = (($56|0) / 56)&-1; //@line 89467 "c/sqlite3.c"
    $58 = HEAP32[$3>>2]|0; //@line 89467 "c/sqlite3.c"
    $59 = (($58) + ($$06170<<2)|0); //@line 89467 "c/sqlite3.c"
    HEAP32[$59>>2] = $57; //@line 89467 "c/sqlite3.c"
    $60 = HEAP32[$9>>2]|0; //@line 89468 "c/sqlite3.c"
    $61 = $$06170 ^ 1; //@line 89468 "c/sqlite3.c"
    $62 = (($58) + ($61<<2)|0); //@line 89468 "c/sqlite3.c"
    $63 = HEAP32[$62>>2]|0; //@line 89468 "c/sqlite3.c"
    $64 = (($60) + (($63*56)|0)|0); //@line 89468 "c/sqlite3.c"
    $$1 = $$05869;$$160 = $64;
   }
   $65 = ($$06170$in|0)>(3); //@line 89433 "c/sqlite3.c"
   if ($65) {
    $$05869 = $$1;$$05968 = $$160;$$06170$in = $$06170;
   } else {
    break;
   }
  }
 }
 $66 = HEAP32[$9>>2]|0; //@line 89471 "c/sqlite3.c"
 $67 = HEAP32[$3>>2]|0; //@line 89471 "c/sqlite3.c"
 $68 = ((($67)) + 4|0); //@line 89471 "c/sqlite3.c"
 $69 = HEAP32[$68>>2]|0; //@line 89471 "c/sqlite3.c"
 $70 = (((($66) + (($69*56)|0)|0)) + 24|0); //@line 89471 "c/sqlite3.c"
 $71 = HEAP32[$70>>2]|0; //@line 89471 "c/sqlite3.c"
 $72 = ($71|0)==(0|0); //@line 89471 "c/sqlite3.c"
 $73 = $72&1; //@line 89471 "c/sqlite3.c"
 HEAP32[$1>>2] = $73; //@line 89471 "c/sqlite3.c"
 $74 = ((($8)) + 12|0); //@line 89474 "c/sqlite3.c"
 $75 = HEAP32[$74>>2]|0; //@line 89474 "c/sqlite3.c"
 $76 = ((($75)) + 11|0); //@line 89474 "c/sqlite3.c"
 $77 = HEAP8[$76>>0]|0; //@line 89474 "c/sqlite3.c"
 $78 = $77&255; //@line 89474 "c/sqlite3.c"
 $79 = $78;
 STACKTOP = sp;return ($79|0); //@line 89474 "c/sqlite3.c"
}
function _vdbePmaWriterFinish($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 $2 = HEAP32[$0>>2]|0; //@line 89308 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 89308 "c/sqlite3.c"
 if ($3) {
  $4 = ((($0)) + 4|0); //@line 89308 "c/sqlite3.c"
  $5 = HEAP32[$4>>2]|0; //@line 89308 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 89308 "c/sqlite3.c"
  if (!($6)) {
   $7 = ((($0)) + 16|0); //@line 89308 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 89308 "c/sqlite3.c"
   $9 = ((($0)) + 12|0); //@line 89308 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 89308 "c/sqlite3.c"
   $11 = ($8|0)>($10|0); //@line 89308 "c/sqlite3.c"
   if ($11) {
    $12 = ((($0)) + 32|0); //@line 89309 "c/sqlite3.c"
    $13 = HEAP32[$12>>2]|0; //@line 89309 "c/sqlite3.c"
    $14 = (($5) + ($10)|0); //@line 89310 "c/sqlite3.c"
    $15 = (($8) - ($10))|0; //@line 89310 "c/sqlite3.c"
    $16 = ((($0)) + 24|0); //@line 89311 "c/sqlite3.c"
    $17 = $16; //@line 89311 "c/sqlite3.c"
    $18 = $17; //@line 89311 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 89311 "c/sqlite3.c"
    $20 = (($17) + 4)|0; //@line 89311 "c/sqlite3.c"
    $21 = $20; //@line 89311 "c/sqlite3.c"
    $22 = HEAP32[$21>>2]|0; //@line 89311 "c/sqlite3.c"
    $23 = ($10|0)<(0); //@line 89311 "c/sqlite3.c"
    $24 = $23 << 31 >> 31; //@line 89311 "c/sqlite3.c"
    $25 = (_i64Add(($19|0),($22|0),($10|0),($24|0))|0); //@line 89311 "c/sqlite3.c"
    $26 = tempRet0; //@line 89311 "c/sqlite3.c"
    $27 = (_sqlite3OsWrite($13,$14,$15,$25,$26)|0); //@line 89309 "c/sqlite3.c"
    HEAP32[$0>>2] = $27; //@line 89309 "c/sqlite3.c"
   }
  }
 }
 $28 = ((($0)) + 24|0); //@line 89314 "c/sqlite3.c"
 $29 = $28; //@line 89314 "c/sqlite3.c"
 $30 = $29; //@line 89314 "c/sqlite3.c"
 $31 = HEAP32[$30>>2]|0; //@line 89314 "c/sqlite3.c"
 $32 = (($29) + 4)|0; //@line 89314 "c/sqlite3.c"
 $33 = $32; //@line 89314 "c/sqlite3.c"
 $34 = HEAP32[$33>>2]|0; //@line 89314 "c/sqlite3.c"
 $35 = ((($0)) + 16|0); //@line 89314 "c/sqlite3.c"
 $36 = HEAP32[$35>>2]|0; //@line 89314 "c/sqlite3.c"
 $37 = ($36|0)<(0); //@line 89314 "c/sqlite3.c"
 $38 = $37 << 31 >> 31; //@line 89314 "c/sqlite3.c"
 $39 = (_i64Add(($31|0),($34|0),($36|0),($38|0))|0); //@line 89314 "c/sqlite3.c"
 $40 = tempRet0; //@line 89314 "c/sqlite3.c"
 $41 = $1; //@line 89314 "c/sqlite3.c"
 $42 = $41; //@line 89314 "c/sqlite3.c"
 HEAP32[$42>>2] = $39; //@line 89314 "c/sqlite3.c"
 $43 = (($41) + 4)|0; //@line 89314 "c/sqlite3.c"
 $44 = $43; //@line 89314 "c/sqlite3.c"
 HEAP32[$44>>2] = $40; //@line 89314 "c/sqlite3.c"
 $45 = ((($0)) + 4|0); //@line 89315 "c/sqlite3.c"
 $46 = HEAP32[$45>>2]|0; //@line 89315 "c/sqlite3.c"
 _sqlite3_free($46); //@line 89315 "c/sqlite3.c"
 $47 = HEAP32[$0>>2]|0; //@line 89316 "c/sqlite3.c"
 dest=$0; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 89317 "c/sqlite3.c"
 return ($47|0); //@line 89318 "c/sqlite3.c"
}
function _vdbePmaReaderIncrInit($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 48|0); //@line 90064 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 90064 "c/sqlite3.c"
 $4 = ($3|0)==(0|0); //@line 90066 "c/sqlite3.c"
 if ($4) {
  $$0 = 0;
  return ($$0|0); //@line 90078 "c/sqlite3.c"
 }
 $5 = ((($3)) + 24|0); //@line 90069 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 90069 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 90069 "c/sqlite3.c"
 if ($7) {
  $10 = (_vdbePmaReaderIncrMergeInit($0,$1)|0); //@line 90075 "c/sqlite3.c"
  $$0 = $10;
  return ($$0|0); //@line 90078 "c/sqlite3.c"
 } else {
  $8 = HEAP32[$3>>2]|0; //@line 90071 "c/sqlite3.c"
  $9 = (_vdbeSorterCreateThread($8,161,$0)|0); //@line 90071 "c/sqlite3.c"
  $$0 = $9;
  return ($$0|0); //@line 90078 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbeMergeEngineCompare($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$$042 = 0, $$042 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 89834 "c/sqlite3.c"
 $4 = (($3|0) / 2)&-1; //@line 89834 "c/sqlite3.c"
 $5 = ($4|0)>($1|0); //@line 89834 "c/sqlite3.c"
 if ($5) {
  $9 = ((($0)) + 8|0); //@line 89838 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 89838 "c/sqlite3.c"
  $11 = $1 << 1; //@line 89838 "c/sqlite3.c"
  $12 = (($10) + ($11<<2)|0); //@line 89838 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 89838 "c/sqlite3.c"
  $14 = $11 | 1; //@line 89839 "c/sqlite3.c"
  $15 = (($10) + ($14<<2)|0); //@line 89839 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 89839 "c/sqlite3.c"
  $$0 = $13;$$042 = $16;
 } else {
  $6 = (($1) - ($4))|0; //@line 89835 "c/sqlite3.c"
  $7 = $6 << 1; //@line 89835 "c/sqlite3.c"
  $8 = $7 | 1; //@line 89836 "c/sqlite3.c"
  $$0 = $7;$$042 = $8;
 }
 $17 = ((($0)) + 12|0); //@line 89842 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 89842 "c/sqlite3.c"
 $19 = (((($18) + (($$0*56)|0)|0)) + 24|0); //@line 89845 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 89845 "c/sqlite3.c"
 $21 = ($20|0)==(0|0); //@line 89845 "c/sqlite3.c"
 if ($21) {
  $$1 = $$042;
 } else {
  $22 = (((($18) + (($$042*56)|0)|0)) + 24|0); //@line 89847 "c/sqlite3.c"
  $23 = HEAP32[$22>>2]|0; //@line 89847 "c/sqlite3.c"
  $24 = ($23|0)==(0|0); //@line 89847 "c/sqlite3.c"
  if ($24) {
   $$1 = $$0;
  } else {
   $25 = ((($0)) + 4|0); //@line 89850 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 89850 "c/sqlite3.c"
   HEAP32[$2>>2] = 0; //@line 89851 "c/sqlite3.c"
   $27 = ((($26)) + 32|0); //@line 89854 "c/sqlite3.c"
   $28 = HEAP32[$27>>2]|0; //@line 89854 "c/sqlite3.c"
   $29 = (((($18) + (($$0*56)|0)|0)) + 32|0); //@line 89855 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 89855 "c/sqlite3.c"
   $31 = (((($18) + (($$0*56)|0)|0)) + 20|0); //@line 89855 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 89855 "c/sqlite3.c"
   $33 = (((($18) + (($$042*56)|0)|0)) + 32|0); //@line 89855 "c/sqlite3.c"
   $34 = HEAP32[$33>>2]|0; //@line 89855 "c/sqlite3.c"
   $35 = (((($18) + (($$042*56)|0)|0)) + 20|0); //@line 89855 "c/sqlite3.c"
   $36 = HEAP32[$35>>2]|0; //@line 89855 "c/sqlite3.c"
   $37 = (FUNCTION_TABLE_iiiiiii[$28 & 127]($26,$2,$30,$32,$34,$36)|0); //@line 89854 "c/sqlite3.c"
   $38 = ($37|0)<(1); //@line 89857 "c/sqlite3.c"
   $$0$$042 = $38 ? $$0 : $$042; //@line 89859 "c/sqlite3.c"
   $$1 = $$0$$042;
  }
 }
 $39 = ((($0)) + 8|0); //@line 89864 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 89864 "c/sqlite3.c"
 $41 = (($40) + ($1<<2)|0); //@line 89864 "c/sqlite3.c"
 HEAP32[$41>>2] = $$1; //@line 89864 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 89865 "c/sqlite3.c"
}
function _vdbeSorterSort($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$051 = 0, $$05260 = 0, $$05357 = 0, $$1$lcssa = 0, $$15455 = 0, $$158 = 0, $$256 = 0, $$3 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_vdbeSortAllocUnpacked($0)|0); //@line 89201 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 89202 "c/sqlite3.c"
 if (!($3)) {
  $$051 = $2;
  return ($$051|0); //@line 89246 "c/sqlite3.c"
 }
 $4 = HEAP32[$1>>2]|0; //@line 89204 "c/sqlite3.c"
 $5 = ((($0)) + 8|0); //@line 89205 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 89205 "c/sqlite3.c"
 $7 = (_vdbeSorterGetCompare($6)|0); //@line 89205 "c/sqlite3.c"
 $8 = ((($0)) + 32|0); //@line 89205 "c/sqlite3.c"
 HEAP32[$8>>2] = $7; //@line 89205 "c/sqlite3.c"
 $9 = (_sqlite3MallocZero(256,0)|0); //@line 89207 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 89208 "c/sqlite3.c"
 if ($10) {
  $$051 = 7;
  return ($$051|0); //@line 89246 "c/sqlite3.c"
 }
 $11 = ($4|0)==(0|0); //@line 89212 "c/sqlite3.c"
 if (!($11)) {
  $12 = ((($1)) + 4|0);
  $$05260 = $4;$16 = $4;
  while(1) {
   $13 = HEAP32[$12>>2]|0; //@line 89214 "c/sqlite3.c"
   $14 = ($13|0)==(0|0); //@line 89214 "c/sqlite3.c"
   if ($14) {
    $20 = ((($$05260)) + 4|0); //@line 89222 "c/sqlite3.c"
    $21 = HEAP32[$20>>2]|0; //@line 89222 "c/sqlite3.c"
    $$0 = $21;$44 = $21;
   } else {
    $15 = ($16|0)==($13|0); //@line 89215 "c/sqlite3.c"
    if ($15) {
     $$0 = 0;$44 = 0;
    } else {
     $17 = ((($$05260)) + 4|0); //@line 89219 "c/sqlite3.c"
     $18 = HEAP32[$17>>2]|0; //@line 89219 "c/sqlite3.c"
     $19 = (($13) + ($18)|0); //@line 89219 "c/sqlite3.c"
     $$0 = $19;$44 = $19;
    }
   }
   $22 = ((($$05260)) + 4|0); //@line 89225 "c/sqlite3.c"
   HEAP32[$22>>2] = 0; //@line 89225 "c/sqlite3.c"
   $23 = HEAP32[$9>>2]|0; //@line 89226 "c/sqlite3.c"
   $24 = ($23|0)==(0|0); //@line 89226 "c/sqlite3.c"
   if ($24) {
    $$1$lcssa = $$05260;$$lcssa = $9;
   } else {
    $$05357 = 0;$$158 = $$05260;$25 = $23;$27 = $9;
    while(1) {
     $26 = (_vdbeSorterMerge($0,$$158,$25)|0); //@line 89227 "c/sqlite3.c"
     HEAP32[$27>>2] = 0; //@line 89228 "c/sqlite3.c"
     $28 = (($$05357) + 1)|0; //@line 89226 "c/sqlite3.c"
     $29 = (($9) + ($28<<2)|0); //@line 89226 "c/sqlite3.c"
     $30 = HEAP32[$29>>2]|0; //@line 89226 "c/sqlite3.c"
     $31 = ($30|0)==(0|0); //@line 89226 "c/sqlite3.c"
     if ($31) {
      $$1$lcssa = $26;$$lcssa = $29;
      break;
     } else {
      $$05357 = $28;$$158 = $26;$25 = $30;$27 = $29;
     }
    }
   }
   HEAP32[$$lcssa>>2] = $$1$lcssa; //@line 89230 "c/sqlite3.c"
   $32 = ($$0|0)==(0|0); //@line 89212 "c/sqlite3.c"
   if ($32) {
    break;
   } else {
    $$05260 = $$0;$16 = $44;
   }
  }
 }
 $$15455 = 0;$$256 = 0;
 while(1) {
  $33 = (($9) + ($$15455<<2)|0); //@line 89236 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 89236 "c/sqlite3.c"
  $35 = ($34|0)==(0|0); //@line 89236 "c/sqlite3.c"
  if ($35) {
   $$3 = $$256;
  } else {
   $36 = ($$256|0)==(0|0); //@line 89237 "c/sqlite3.c"
   if ($36) {
    $$3 = $34;
   } else {
    $37 = (_vdbeSorterMerge($0,$$256,$34)|0); //@line 89237 "c/sqlite3.c"
    $$3 = $37;
   }
  }
  $38 = (($$15455) + 1)|0; //@line 89235 "c/sqlite3.c"
  $exitcond = ($38|0)==(64); //@line 89235 "c/sqlite3.c"
  if ($exitcond) {
   break;
  } else {
   $$15455 = $38;$$256 = $$3;
  }
 }
 HEAP32[$1>>2] = $$3; //@line 89239 "c/sqlite3.c"
 _sqlite3_free($9); //@line 89241 "c/sqlite3.c"
 $39 = ((($0)) + 12|0); //@line 89245 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 89245 "c/sqlite3.c"
 $41 = ((($40)) + 11|0); //@line 89245 "c/sqlite3.c"
 $42 = HEAP8[$41>>0]|0; //@line 89245 "c/sqlite3.c"
 $43 = $42&255; //@line 89245 "c/sqlite3.c"
 $$051 = $43;
 return ($$051|0); //@line 89246 "c/sqlite3.c"
}
function _vdbeSortAllocUnpacked($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 89126 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 89126 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 89126 "c/sqlite3.c"
 if (!($3)) {
  $$0 = 0;
  return ($$0|0); //@line 89133 "c/sqlite3.c"
 }
 $4 = ((($0)) + 8|0); //@line 89127 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 89127 "c/sqlite3.c"
 $6 = ((($5)) + 28|0); //@line 89127 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 89127 "c/sqlite3.c"
 $8 = (_sqlite3VdbeAllocUnpackedRecord($7)|0); //@line 89127 "c/sqlite3.c"
 HEAP32[$1>>2] = $8; //@line 89127 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 89128 "c/sqlite3.c"
 if ($9) {
  $$0 = 7;
  return ($$0|0); //@line 89133 "c/sqlite3.c"
 }
 $10 = HEAP32[$4>>2]|0; //@line 89129 "c/sqlite3.c"
 $11 = ((($10)) + 28|0); //@line 89129 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 89129 "c/sqlite3.c"
 $13 = ((($12)) + 6|0); //@line 89129 "c/sqlite3.c"
 $14 = HEAP16[$13>>1]|0; //@line 89129 "c/sqlite3.c"
 $15 = ((($8)) + 8|0); //@line 89129 "c/sqlite3.c"
 HEAP16[$15>>1] = $14; //@line 89129 "c/sqlite3.c"
 $16 = ((($8)) + 11|0); //@line 89130 "c/sqlite3.c"
 HEAP8[$16>>0] = 0; //@line 89130 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 89133 "c/sqlite3.c"
}
function _vdbeSorterGetCompare($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $switch$select = 0, $switch$select4 = 0, $switch$selectcmp = 0, $switch$selectcmp3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 60|0); //@line 89182 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 89182 "c/sqlite3.c"
 $switch$selectcmp = ($2<<24>>24)==(2); //@line 89182 "c/sqlite3.c"
 $switch$select = $switch$selectcmp ? 73 : 72; //@line 89182 "c/sqlite3.c"
 $switch$selectcmp3 = ($2<<24>>24)==(1); //@line 89182 "c/sqlite3.c"
 $switch$select4 = $switch$selectcmp3 ? 74 : $switch$select; //@line 89182 "c/sqlite3.c"
 return ($switch$select4|0); //@line 89188 "c/sqlite3.c"
}
function _vdbeSorterMerge($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$$0$ = 0, $$024 = 0, $$024$ph = 0, $$025 = 0, $$025$ph = 0, $$028$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp + 4|0;
 $4 = sp;
 HEAP32[$3>>2] = 0; //@line 89144 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 89146 "c/sqlite3.c"
 $5 = ((($0)) + 32|0);
 $$024$ph = $1;$$025$ph = $3;$$028$ph = $2;
 L1: while(1) {
  $6 = ((($$028$ph)) + 8|0);
  $$024 = $$024$ph;$$025 = $$025$ph;
  while(1) {
   $7 = HEAP32[$5>>2]|0; //@line 89151 "c/sqlite3.c"
   $8 = ((($$024)) + 8|0); //@line 89152 "c/sqlite3.c"
   $9 = HEAP32[$$024>>2]|0; //@line 89152 "c/sqlite3.c"
   $10 = HEAP32[$$028$ph>>2]|0; //@line 89152 "c/sqlite3.c"
   $11 = (FUNCTION_TABLE_iiiiiii[$7 & 127]($0,$4,$8,$9,$6,$10)|0); //@line 89151 "c/sqlite3.c"
   $12 = ($11|0)<(1); //@line 89155 "c/sqlite3.c"
   if (!($12)) {
    break;
   }
   HEAP32[$$025>>2] = $$024; //@line 89156 "c/sqlite3.c"
   $13 = ((($$024)) + 4|0); //@line 89157 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 89158 "c/sqlite3.c"
   $15 = ($14|0)==(0|0); //@line 89159 "c/sqlite3.c"
   if ($15) {
    label = 5;
    break L1;
   } else {
    $$024 = $14;$$025 = $13;
   }
  }
  HEAP32[$$025>>2] = $$028$ph; //@line 89164 "c/sqlite3.c"
  $16 = ((($$028$ph)) + 4|0); //@line 89165 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 89166 "c/sqlite3.c"
  HEAP32[$4>>2] = 0; //@line 89167 "c/sqlite3.c"
  $18 = ($17|0)==(0|0); //@line 89168 "c/sqlite3.c"
  if ($18) {
   label = 7;
   break;
  } else {
   $$024$ph = $$024;$$025$ph = $16;$$028$ph = $17;
  }
 }
 if ((label|0) == 5) {
  HEAP32[$13>>2] = $$028$ph; //@line 89160 "c/sqlite3.c"
  $$0$$0$ = HEAP32[$3>>2]|0; //@line 89174 "c/sqlite3.c"
  STACKTOP = sp;return ($$0$$0$|0); //@line 89174 "c/sqlite3.c"
 }
 else if ((label|0) == 7) {
  HEAP32[$16>>2] = $$024; //@line 89169 "c/sqlite3.c"
  $$0$$0$ = HEAP32[$3>>2]|0; //@line 89174 "c/sqlite3.c"
  STACKTOP = sp;return ($$0$$0$|0); //@line 89174 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbeSorterCompareText($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$031 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp + 4|0;
 $7 = sp;
 $8 = HEAP8[$2>>0]|0; //@line 88612 "c/sqlite3.c"
 $9 = $8&255; //@line 88612 "c/sqlite3.c"
 $10 = (($2) + ($9)|0); //@line 88612 "c/sqlite3.c"
 $11 = HEAP8[$4>>0]|0; //@line 88613 "c/sqlite3.c"
 $12 = $11&255; //@line 88613 "c/sqlite3.c"
 $13 = (($4) + ($12)|0); //@line 88613 "c/sqlite3.c"
 $14 = ((($2)) + 1|0); //@line 88619 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 88619 "c/sqlite3.c"
 $16 = ($15<<24>>24)>(-1); //@line 88619 "c/sqlite3.c"
 if ($16) {
  $17 = $15&255; //@line 88619 "c/sqlite3.c"
  HEAP32[$6>>2] = $17; //@line 88619 "c/sqlite3.c"
 } else {
  (_sqlite3GetVarint32($14,$6)|0); //@line 88619 "c/sqlite3.c"
 }
 $18 = ((($4)) + 1|0); //@line 88620 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 88620 "c/sqlite3.c"
 $20 = ($19<<24>>24)>(-1); //@line 88620 "c/sqlite3.c"
 if ($20) {
  $21 = $19&255; //@line 88620 "c/sqlite3.c"
  HEAP32[$7>>2] = $21; //@line 88620 "c/sqlite3.c"
 } else {
  (_sqlite3GetVarint32($18,$7)|0); //@line 88620 "c/sqlite3.c"
 }
 $22 = HEAP32[$6>>2]|0; //@line 88621 "c/sqlite3.c"
 $23 = HEAP32[$7>>2]|0; //@line 88621 "c/sqlite3.c"
 $24 = ($22|0)<($23|0); //@line 88621 "c/sqlite3.c"
 $25 = $24 ? $22 : $23; //@line 88621 "c/sqlite3.c"
 $26 = (($25) + -13)|0; //@line 88621 "c/sqlite3.c"
 $27 = (($26|0) / 2)&-1; //@line 88621 "c/sqlite3.c"
 $28 = (_memcmp($10,$13,$27)|0); //@line 88621 "c/sqlite3.c"
 $29 = ($28|0)==(0); //@line 88622 "c/sqlite3.c"
 $30 = (($22) - ($23))|0; //@line 88623 "c/sqlite3.c"
 if ($29) {
  $35 = ($30|0)==(0); //@line 88626 "c/sqlite3.c"
  $36 = ((($0)) + 8|0);
  $37 = HEAP32[$36>>2]|0;
  $38 = ((($37)) + 28|0);
  $39 = HEAP32[$38>>2]|0;
  if ($35) {
   $40 = ((($39)) + 6|0); //@line 88627 "c/sqlite3.c"
   $41 = HEAP16[$40>>1]|0; //@line 88627 "c/sqlite3.c"
   $42 = ($41&65535)>(1); //@line 88627 "c/sqlite3.c"
   if (!($42)) {
    $$1 = 0;
    STACKTOP = sp;return ($$1|0); //@line 88638 "c/sqlite3.c"
   }
   $43 = (_vdbeSorterCompareTail($0,$1,$2,$3,$4,$5)|0); //@line 88628 "c/sqlite3.c"
   $$1 = $43;
   STACKTOP = sp;return ($$1|0); //@line 88638 "c/sqlite3.c"
  } else {
   $$031 = $30;$45 = $39;
  }
 } else {
  $31 = ((($0)) + 8|0);
  $32 = HEAP32[$31>>2]|0;
  $33 = ((($32)) + 28|0);
  $34 = HEAP32[$33>>2]|0;
  $$031 = $28;$45 = $34;
 }
 $44 = ((($45)) + 16|0); //@line 88633 "c/sqlite3.c"
 $46 = HEAP32[$44>>2]|0; //@line 88633 "c/sqlite3.c"
 $47 = HEAP8[$46>>0]|0; //@line 88633 "c/sqlite3.c"
 $48 = ($47<<24>>24)==(0); //@line 88633 "c/sqlite3.c"
 $49 = (0 - ($$031))|0; //@line 88634 "c/sqlite3.c"
 $spec$select = $48 ? $$031 : $49; //@line 88633 "c/sqlite3.c"
 $$1 = $spec$select;
 STACKTOP = sp;return ($$1|0); //@line 88638 "c/sqlite3.c"
}
function _vdbeSorterCompare($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ((($0)) + 12|0); //@line 88591 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 88591 "c/sqlite3.c"
 $8 = HEAP32[$1>>2]|0; //@line 88592 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 88592 "c/sqlite3.c"
 if (!($9)) {
  $14 = (_sqlite3VdbeRecordCompare($3,$2,$7)|0); //@line 88596 "c/sqlite3.c"
  return ($14|0); //@line 88596 "c/sqlite3.c"
 }
 $10 = ((($0)) + 8|0); //@line 88593 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 88593 "c/sqlite3.c"
 $12 = ((($11)) + 28|0); //@line 88593 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 88593 "c/sqlite3.c"
 _sqlite3VdbeRecordUnpack($13,$5,$4,$7); //@line 88593 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 88594 "c/sqlite3.c"
 $14 = (_sqlite3VdbeRecordCompare($3,$2,$7)|0); //@line 88596 "c/sqlite3.c"
 return ($14|0); //@line 88596 "c/sqlite3.c"
}
function _vdbeSorterCompareInt($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$065 = 0, $$2 = 0, $$3 = 0, $$3$ph = 0, $$361 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, $spec$select59 = 0, $spec$select60 = 0, $spec$select64 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ((($2)) + 1|0); //@line 88653 "c/sqlite3.c"
 $7 = HEAP8[$6>>0]|0; //@line 88653 "c/sqlite3.c"
 $8 = $7&255; //@line 88653 "c/sqlite3.c"
 $9 = ((($4)) + 1|0); //@line 88654 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 88654 "c/sqlite3.c"
 $11 = HEAP8[$2>>0]|0; //@line 88655 "c/sqlite3.c"
 $12 = $11&255; //@line 88655 "c/sqlite3.c"
 $13 = (($2) + ($12)|0); //@line 88655 "c/sqlite3.c"
 $14 = HEAP8[$4>>0]|0; //@line 88656 "c/sqlite3.c"
 $15 = $14&255; //@line 88656 "c/sqlite3.c"
 $16 = (($4) + ($15)|0); //@line 88656 "c/sqlite3.c"
 $17 = ($7<<24>>24)==($10<<24>>24); //@line 88662 "c/sqlite3.c"
 L1: do {
  if ($17) {
   $18 = (35545 + ($8)|0); //@line 88665 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 88665 "c/sqlite3.c"
   $20 = $19&255; //@line 88668 "c/sqlite3.c"
   $21 = (($8) + -1)|0; //@line 88668 "c/sqlite3.c"
   $22 = ($21>>>0)<(6); //@line 88668 "c/sqlite3.c"
   L3: do {
    if ($22) {
     $$065 = 0;
     while(1) {
      $29 = (($13) + ($$065)|0); //@line 88669 "c/sqlite3.c"
      $30 = HEAP8[$29>>0]|0; //@line 88669 "c/sqlite3.c"
      $31 = $30&255; //@line 88669 "c/sqlite3.c"
      $32 = (($16) + ($$065)|0); //@line 88669 "c/sqlite3.c"
      $33 = HEAP8[$32>>0]|0; //@line 88669 "c/sqlite3.c"
      $34 = $33&255; //@line 88669 "c/sqlite3.c"
      $35 = (($31) - ($34))|0; //@line 88669 "c/sqlite3.c"
      $36 = ($35|0)==(0); //@line 88669 "c/sqlite3.c"
      $24 = (($$065) + 1)|0; //@line 88668 "c/sqlite3.c"
      if (!($36)) {
       break;
      }
      $23 = ($24>>>0)<($20>>>0); //@line 88668 "c/sqlite3.c"
      if ($23) {
       $$065 = $24;
      } else {
       break L3;
      }
     }
     $37 = HEAP8[$13>>0]|0; //@line 88670 "c/sqlite3.c"
     $38 = HEAP8[$16>>0]|0; //@line 88670 "c/sqlite3.c"
     $39 = $38 ^ $37; //@line 88670 "c/sqlite3.c"
     $40 = ($39<<24>>24)<(0); //@line 88670 "c/sqlite3.c"
     $41 = ($37&255) >>> 6; //@line 88671 "c/sqlite3.c"
     $42 = $41 & 2; //@line 88671 "c/sqlite3.c"
     $43 = $42 ^ 2; //@line 88671 "c/sqlite3.c"
     $44 = $43&255; //@line 88671 "c/sqlite3.c"
     $45 = (($44) + -1)|0; //@line 88671 "c/sqlite3.c"
     $spec$select64 = $40 ? $45 : $35; //@line 88670 "c/sqlite3.c"
     $$3$ph = $spec$select64;
     label = 12;
     break L1;
    }
   } while(0);
   $25 = ((($0)) + 8|0);
   $26 = HEAP32[$25>>2]|0;
   $27 = ((($26)) + 28|0);
   $28 = HEAP32[$27>>2]|0;
   $65 = $28;
  } else {
   $46 = $10&255; //@line 88654 "c/sqlite3.c"
   $47 = ($7&255)>(7); //@line 88676 "c/sqlite3.c"
   $48 = ($10&255)>(7); //@line 88676 "c/sqlite3.c"
   $or$cond = $47 & $48; //@line 88676 "c/sqlite3.c"
   $49 = (($8) - ($46))|0;
   do {
    if ($or$cond) {
     $$3 = $49;
    } else {
     $spec$select60 = $47 ? -1 : $49; //@line 88681 "c/sqlite3.c"
     $$2 = $48 ? 1 : $spec$select60; //@line 88679 "c/sqlite3.c"
     $50 = ($$2|0)>(0); //@line 88688 "c/sqlite3.c"
     if ($50) {
      $51 = HEAP8[$13>>0]|0; //@line 88689 "c/sqlite3.c"
      $52 = ($51<<24>>24)<(0); //@line 88689 "c/sqlite3.c"
      $spec$select = $52 ? -1 : $$2; //@line 88689 "c/sqlite3.c"
      $$3 = $spec$select;
      break;
     } else {
      $53 = HEAP8[$16>>0]|0; //@line 88691 "c/sqlite3.c"
      $54 = ($53<<24>>24)<(0); //@line 88691 "c/sqlite3.c"
      if ($54) {
       $$3$ph = 1;
       label = 12;
       break L1;
      } else {
       $$3 = $$2;
       break;
      }
     }
    }
   } while(0);
   $59 = ($$3|0)==(0); //@line 88695 "c/sqlite3.c"
   $60 = ((($0)) + 8|0);
   $61 = HEAP32[$60>>2]|0;
   $62 = ((($61)) + 28|0);
   $63 = HEAP32[$62>>2]|0;
   if ($59) {
    $65 = $63;
   } else {
    $$361 = $$3;$70 = $63;
    $69 = ((($70)) + 16|0); //@line 88701 "c/sqlite3.c"
    $71 = HEAP32[$69>>2]|0; //@line 88701 "c/sqlite3.c"
    $72 = HEAP8[$71>>0]|0; //@line 88701 "c/sqlite3.c"
    $73 = ($72<<24>>24)==(0); //@line 88701 "c/sqlite3.c"
    $74 = (0 - ($$361))|0; //@line 88702 "c/sqlite3.c"
    $spec$select59 = $73 ? $$361 : $74; //@line 88701 "c/sqlite3.c"
    return ($spec$select59|0); //@line 88701 "c/sqlite3.c"
   }
  }
 } while(0);
 if ((label|0) == 12) {
  $55 = ((($0)) + 8|0);
  $56 = HEAP32[$55>>2]|0;
  $57 = ((($56)) + 28|0);
  $58 = HEAP32[$57>>2]|0;
  $$361 = $$3$ph;$70 = $58;
  $69 = ((($70)) + 16|0); //@line 88701 "c/sqlite3.c"
  $71 = HEAP32[$69>>2]|0; //@line 88701 "c/sqlite3.c"
  $72 = HEAP8[$71>>0]|0; //@line 88701 "c/sqlite3.c"
  $73 = ($72<<24>>24)==(0); //@line 88701 "c/sqlite3.c"
  $74 = (0 - ($$361))|0; //@line 88702 "c/sqlite3.c"
  $spec$select59 = $73 ? $$361 : $74; //@line 88701 "c/sqlite3.c"
  return ($spec$select59|0); //@line 88701 "c/sqlite3.c"
 }
 $64 = ((($65)) + 6|0); //@line 88696 "c/sqlite3.c"
 $66 = HEAP16[$64>>1]|0; //@line 88696 "c/sqlite3.c"
 $67 = ($66&65535)>(1); //@line 88696 "c/sqlite3.c"
 if (!($67)) {
  $$4 = 0;
  return ($$4|0); //@line 88705 "c/sqlite3.c"
 }
 $68 = (_vdbeSorterCompareTail($0,$1,$2,$3,$4,$5)|0); //@line 88697 "c/sqlite3.c"
 $$4 = $68;
 return ($$4|0); //@line 88705 "c/sqlite3.c"
}
function _vdbeSorterCompareTail($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $6 = ((($0)) + 12|0); //@line 88564 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 88564 "c/sqlite3.c"
 $8 = HEAP32[$1>>2]|0; //@line 88565 "c/sqlite3.c"
 $9 = ($8|0)==(0); //@line 88565 "c/sqlite3.c"
 if (!($9)) {
  $14 = (_sqlite3VdbeRecordCompareWithSkip($3,$2,$7,1)|0); //@line 88569 "c/sqlite3.c"
  return ($14|0); //@line 88569 "c/sqlite3.c"
 }
 $10 = ((($0)) + 8|0); //@line 88566 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 88566 "c/sqlite3.c"
 $12 = ((($11)) + 28|0); //@line 88566 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 88566 "c/sqlite3.c"
 _sqlite3VdbeRecordUnpack($13,$5,$4,$7); //@line 88566 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 88567 "c/sqlite3.c"
 $14 = (_sqlite3VdbeRecordCompareWithSkip($3,$2,$7,1)|0); //@line 88569 "c/sqlite3.c"
 return ($14|0); //@line 88569 "c/sqlite3.c"
}
function _vdbeSorterSetupMerge($0) {
 $0 = $0|0;
 var $$06076 = 0, $$06174 = 0, $$16273 = 0, $$2$ph = 0, $$5 = 0, $$570 = 0, $$571 = 0, $$cast = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 64|0); //@line 90287 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 90288 "c/sqlite3.c"
 $3 = ((($0)) + 72|0); //@line 90290 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 90290 "c/sqlite3.c"
 $5 = ((($4)) + 24|0); //@line 90290 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 90290 "c/sqlite3.c"
 $7 = (_vdbeSorterGetCompare($0)|0); //@line 90292 "c/sqlite3.c"
 $8 = ((($0)) + 59|0); //@line 90293 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 90293 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 90293 "c/sqlite3.c"
 if (!($10)) {
  $11 = HEAP8[$8>>0]|0;
  $12 = $11&255;
  $$06076 = 0;
  while(1) {
   $13 = (((((($0)) + 64|0) + (($$06076*72)|0)|0)) + 32|0); //@line 90294 "c/sqlite3.c"
   HEAP32[$13>>2] = $7; //@line 90294 "c/sqlite3.c"
   $14 = (($$06076) + 1)|0; //@line 90293 "c/sqlite3.c"
   $15 = ($14>>>0)<($12>>>0); //@line 90293 "c/sqlite3.c"
   if ($15) {
    $$06076 = $14;
   } else {
    break;
   }
  }
 }
 $16 = (_vdbeSorterMergeTreeBuild($0,$1)|0); //@line 90298 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 90299 "c/sqlite3.c"
 L6: do {
  if ($17) {
   $18 = ((($0)) + 57|0); //@line 90302 "c/sqlite3.c"
   $19 = HEAP8[$18>>0]|0; //@line 90302 "c/sqlite3.c"
   $20 = ($19<<24>>24)==(0); //@line 90302 "c/sqlite3.c"
   L8: do {
    if ($20) {
     $60 = HEAP32[$1>>2]|0; //@line 90349 "c/sqlite3.c"
     $61 = (_vdbeMergeEngineInit($2,$60,0)|0); //@line 90349 "c/sqlite3.c"
     $$cast = $60; //@line 90350 "c/sqlite3.c"
     $62 = ((($0)) + 20|0); //@line 90350 "c/sqlite3.c"
     HEAP32[$62>>2] = $$cast; //@line 90350 "c/sqlite3.c"
     HEAP32[$1>>2] = 0; //@line 90351 "c/sqlite3.c"
     $$5 = $61;
    } else {
     $21 = HEAP8[$8>>0]|0; //@line 90305 "c/sqlite3.c"
     $22 = $21&255; //@line 90305 "c/sqlite3.c"
     $23 = (($22) + -1)|0; //@line 90305 "c/sqlite3.c"
     $24 = (((($0)) + 64|0) + (($23*72)|0)|0); //@line 90305 "c/sqlite3.c"
     $25 = (_vdbeSortAllocUnpacked($24)|0); //@line 90306 "c/sqlite3.c"
     $26 = ($25|0)==(0); //@line 90307 "c/sqlite3.c"
     if (!($26)) {
      $$570 = $25;
      break L6;
     }
     $27 = (_sqlite3DbMallocZero($6,56,0)|0); //@line 90308 "c/sqlite3.c"
     $28 = ((($0)) + 16|0); //@line 90309 "c/sqlite3.c"
     HEAP32[$28>>2] = $27; //@line 90309 "c/sqlite3.c"
     $29 = ($27|0)==(0|0); //@line 90310 "c/sqlite3.c"
     if ($29) {
      $$570 = 7;
      break L6;
     }
     $30 = HEAP32[$1>>2]|0; //@line 90313 "c/sqlite3.c"
     $31 = ((($27)) + 48|0); //@line 90313 "c/sqlite3.c"
     $32 = (_vdbeIncrMergerNew($24,$30,$31)|0); //@line 90313 "c/sqlite3.c"
     $33 = ($32|0)==(0); //@line 90314 "c/sqlite3.c"
     L13: do {
      if ($33) {
       $34 = HEAP32[$31>>2]|0; //@line 90315 "c/sqlite3.c"
       _vdbeIncrMergerSetThreads($34); //@line 90315 "c/sqlite3.c"
       $35 = HEAP8[$8>>0]|0; //@line 90316 "c/sqlite3.c"
       $36 = ($35&255)>(1); //@line 90316 "c/sqlite3.c"
       if ($36) {
        $37 = HEAP32[$1>>2]|0;
        $38 = ((($37)) + 12|0);
        $$06174 = 0;
        while(1) {
         $39 = HEAP32[$38>>2]|0; //@line 90318 "c/sqlite3.c"
         $40 = (((($39) + (($$06174*56)|0)|0)) + 48|0); //@line 90318 "c/sqlite3.c"
         $41 = HEAP32[$40>>2]|0; //@line 90318 "c/sqlite3.c"
         $42 = ($41|0)==(0|0); //@line 90318 "c/sqlite3.c"
         if (!($42)) {
          _vdbeIncrMergerSetThreads($41); //@line 90319 "c/sqlite3.c"
         }
         $43 = (($$06174) + 1)|0; //@line 90316 "c/sqlite3.c"
         $44 = HEAP8[$8>>0]|0; //@line 90316 "c/sqlite3.c"
         $45 = $44&255; //@line 90316 "c/sqlite3.c"
         $46 = (($45) + -1)|0; //@line 90316 "c/sqlite3.c"
         $47 = ($43|0)<($46|0); //@line 90316 "c/sqlite3.c"
         if ($47) {
          $$06174 = $43;
         } else {
          break;
         }
        }
        $48 = ($32|0)==(0); //@line 90323 "c/sqlite3.c"
        if (!($48)) {
         $$2$ph = $32;
         break;
        }
       }
       $49 = HEAP32[$1>>2]|0;
       $50 = ((($49)) + 12|0);
       $$16273 = 0;
       while(1) {
        $51 = HEAP8[$8>>0]|0; //@line 90323 "c/sqlite3.c"
        $52 = $51&255; //@line 90323 "c/sqlite3.c"
        $53 = ($$16273>>>0)<($52>>>0); //@line 90323 "c/sqlite3.c"
        if (!($53)) {
         break;
        }
        $54 = HEAP32[$50>>2]|0; //@line 90333 "c/sqlite3.c"
        $55 = (($54) + (($$16273*56)|0)|0); //@line 90333 "c/sqlite3.c"
        $56 = (_vdbePmaReaderIncrInit($55,1)|0); //@line 90338 "c/sqlite3.c"
        $57 = (($$16273) + 1)|0; //@line 90323 "c/sqlite3.c"
        $58 = ($56|0)==(0); //@line 90323 "c/sqlite3.c"
        if ($58) {
         $$16273 = $57;
        } else {
         $$2$ph = $56;
         break L13;
        }
       }
       HEAP32[$1>>2] = 0; //@line 90341 "c/sqlite3.c"
       $59 = (_vdbePmaReaderIncrMergeInit($27,2)|0); //@line 90344 "c/sqlite3.c"
       $$5 = $59;
       break L8;
      } else {
       $$2$ph = $32;
      }
     } while(0);
     HEAP32[$1>>2] = 0; //@line 90341 "c/sqlite3.c"
     $$570 = $$2$ph;
     break L6;
    }
   } while(0);
   $63 = ($$5|0)==(0); //@line 90355 "c/sqlite3.c"
   if ($63) {
    $$571 = 0;
    STACKTOP = sp;return ($$571|0); //@line 90358 "c/sqlite3.c"
   } else {
    $$570 = $$5;
   }
  } else {
   $$570 = $16;
  }
 } while(0);
 $64 = HEAP32[$1>>2]|0; //@line 90356 "c/sqlite3.c"
 _vdbeMergeEngineFree($64); //@line 90356 "c/sqlite3.c"
 $$571 = $$570;
 STACKTOP = sp;return ($$571|0); //@line 90358 "c/sqlite3.c"
}
function _vdbeSorterMergeTreeBuild($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$ph = 0, $$05267 = 0, $$05466 = 0, $$06069 = 0, $$1$lcssa = 0, $$153 = 0, $$156$lcssa = 0, $$15665 = 0, $$172 = 0, $$2 = 0, $$3 = 0, $$4 = 0, $$459 = 0, $$5 = 0, $$6 = 0, $$7 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0;
 var $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0;
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cond = 0, $not$ = 0, $spec$select61 = 0, $spec$select62 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 12|0;
 $3 = sp;
 $4 = sp + 8|0;
 $5 = ((($0)) + 59|0); //@line 90219 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 90219 "c/sqlite3.c"
 $7 = ($6&255)>(1); //@line 90219 "c/sqlite3.c"
 if ($7) {
  $8 = $6&255; //@line 90219 "c/sqlite3.c"
  $9 = (_vdbeMergeEngineNew($8)|0); //@line 90220 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 90221 "c/sqlite3.c"
  if ($10) {
   $$1$lcssa = 0;$$156$lcssa = 7;
  } else {
   $$0$ph = $9;
   label = 3;
  }
 } else {
  $$0$ph = 0;
  label = 3;
 }
 L3: do {
  if ((label|0) == 3) {
   $$06069 = 0;$$172 = $$0$ph;
   while(1) {
    $11 = HEAP8[$5>>0]|0; //@line 90225 "c/sqlite3.c"
    $12 = $11&255; //@line 90225 "c/sqlite3.c"
    $13 = ($$06069>>>0)<($12>>>0); //@line 90225 "c/sqlite3.c"
    if (!($13)) {
     $$15665 = 0;$$4 = $$172;
     break;
    }
    $14 = (((($0)) + 64|0) + (($$06069*72)|0)|0); //@line 90226 "c/sqlite3.c"
    $15 = (((((($0)) + 64|0) + (($$06069*72)|0)|0)) + 28|0); //@line 90228 "c/sqlite3.c"
    $16 = HEAP32[$15>>2]|0; //@line 90228 "c/sqlite3.c"
    $17 = ($16|0)==(0); //@line 90228 "c/sqlite3.c"
    if ($17) {
     $$3 = $$172;$$7 = 0;
    } else {
     HEAP32[$2>>2] = 0; //@line 90229 "c/sqlite3.c"
     $18 = (_vdbeSorterTreeDepth($16)|0); //@line 90230 "c/sqlite3.c"
     $19 = $3; //@line 90231 "c/sqlite3.c"
     $20 = $19; //@line 90231 "c/sqlite3.c"
     HEAP32[$20>>2] = 0; //@line 90231 "c/sqlite3.c"
     $21 = (($19) + 4)|0; //@line 90231 "c/sqlite3.c"
     $22 = $21; //@line 90231 "c/sqlite3.c"
     HEAP32[$22>>2] = 0; //@line 90231 "c/sqlite3.c"
     $23 = ($16|0)<(17); //@line 90233 "c/sqlite3.c"
     if ($23) {
      $24 = (_vdbeMergeEngineLevel0($14,$16,$3,$2)|0); //@line 90234 "c/sqlite3.c"
      $$5 = $24;
     } else {
      $25 = (_vdbeMergeEngineNew(16)|0); //@line 90238 "c/sqlite3.c"
      HEAP32[$2>>2] = $25; //@line 90238 "c/sqlite3.c"
      $26 = ($25|0)==(0|0); //@line 90239 "c/sqlite3.c"
      $spec$select61 = $26 ? 7 : 0; //@line 90239 "c/sqlite3.c"
      $27 = HEAP32[$15>>2]|0; //@line 90240 "c/sqlite3.c"
      $28 = ($27|0)>(0); //@line 90240 "c/sqlite3.c"
      $not$ = $26 ^ 1; //@line 90240 "c/sqlite3.c"
      $29 = $28 & $not$; //@line 90240 "c/sqlite3.c"
      if ($29) {
       $$05267 = 0;$$05466 = 0;$31 = $27;
       while(1) {
        HEAP32[$4>>2] = 0; //@line 90241 "c/sqlite3.c"
        $30 = (($31) - ($$05466))|0; //@line 90244 "c/sqlite3.c"
        $32 = ($30|0)<(16); //@line 90244 "c/sqlite3.c"
        $spec$select62 = $32 ? $30 : 16; //@line 90244 "c/sqlite3.c"
        $33 = (_vdbeMergeEngineLevel0($14,$spec$select62,$3,$4)|0); //@line 90245 "c/sqlite3.c"
        $34 = ($33|0)==(0); //@line 90246 "c/sqlite3.c"
        if ($34) {
         $35 = (($$05267) + 1)|0; //@line 90247 "c/sqlite3.c"
         $36 = HEAP32[$4>>2]|0; //@line 90247 "c/sqlite3.c"
         $37 = (_vdbeSorterAddToTree($14,$18,$$05267,$25,$36)|0); //@line 90247 "c/sqlite3.c"
         $$153 = $35;$$459 = $37;
        } else {
         $$153 = $$05267;$$459 = $33;
        }
        $38 = (($$05466) + 16)|0; //@line 90240 "c/sqlite3.c"
        $39 = HEAP32[$15>>2]|0; //@line 90240 "c/sqlite3.c"
        $40 = ($39|0)>($38|0); //@line 90240 "c/sqlite3.c"
        $41 = ($$459|0)==(0); //@line 90240 "c/sqlite3.c"
        $42 = $41 & $40; //@line 90240 "c/sqlite3.c"
        if ($42) {
         $$05267 = $$153;$$05466 = $38;$31 = $39;
        } else {
         $$5 = $$459;
         break;
        }
       }
      } else {
       $$5 = $spec$select61;
      }
     }
     $43 = ($$5|0)==(0); //@line 90252 "c/sqlite3.c"
     if ($43) {
      $44 = ($$172|0)==(0|0); //@line 90254 "c/sqlite3.c"
      $45 = HEAP32[$2>>2]|0;
      if ($44) {
       $$2 = $45;$$6 = 0;
      } else {
       $46 = ((($$172)) + 12|0); //@line 90255 "c/sqlite3.c"
       $47 = HEAP32[$46>>2]|0; //@line 90255 "c/sqlite3.c"
       $48 = (((($47) + (($$06069*56)|0)|0)) + 48|0); //@line 90255 "c/sqlite3.c"
       $49 = (_vdbeIncrMergerNew($14,$45,$48)|0); //@line 90255 "c/sqlite3.c"
       $$2 = $$172;$$6 = $49;
      }
     } else {
      $50 = HEAP32[$2>>2]|0; //@line 90263 "c/sqlite3.c"
      _vdbeMergeEngineFree($50); //@line 90263 "c/sqlite3.c"
      $$2 = $$172;$$6 = $$5;
     }
     $$3 = $$2;$$7 = $$6;
    }
    $51 = (($$06069) + 1)|0; //@line 90225 "c/sqlite3.c"
    $cond = ($$7|0)==(0); //@line 90225 "c/sqlite3.c"
    if ($cond) {
     $$06069 = $51;$$172 = $$3;
    } else {
     $$1$lcssa = $$3;$$156$lcssa = $$7;
     break L3;
    }
   }
   HEAP32[$1>>2] = $$4; //@line 90272 "c/sqlite3.c"
   STACKTOP = sp;return ($$15665|0); //@line 90273 "c/sqlite3.c"
  }
 } while(0);
 _vdbeMergeEngineFree($$1$lcssa); //@line 90269 "c/sqlite3.c"
 $$15665 = $$156$lcssa;$$4 = 0;
 HEAP32[$1>>2] = $$4; //@line 90272 "c/sqlite3.c"
 STACKTOP = sp;return ($$15665|0); //@line 90273 "c/sqlite3.c"
}
function _vdbeIncrMergerNew($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3FaultSim(100)|0); //@line 89792 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 89792 "c/sqlite3.c"
 if ($4) {
  $5 = (_sqlite3MallocZero(64,0)|0); //@line 89792 "c/sqlite3.c"
  HEAP32[$2>>2] = $5; //@line 89791 "c/sqlite3.c"
  $6 = ($5|0)==(0|0); //@line 89793 "c/sqlite3.c"
  if (!($6)) {
   $7 = ((($5)) + 4|0); //@line 89794 "c/sqlite3.c"
   HEAP32[$7>>2] = $1; //@line 89794 "c/sqlite3.c"
   HEAP32[$5>>2] = $0; //@line 89795 "c/sqlite3.c"
   $8 = ((($0)) + 8|0); //@line 89796 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 89796 "c/sqlite3.c"
   $10 = ((($9)) + 8|0); //@line 89796 "c/sqlite3.c"
   $11 = HEAP32[$10>>2]|0; //@line 89796 "c/sqlite3.c"
   $12 = (($11) + 9)|0; //@line 89796 "c/sqlite3.c"
   $13 = ((($9)) + 4|0); //@line 89796 "c/sqlite3.c"
   $14 = HEAP32[$13>>2]|0; //@line 89796 "c/sqlite3.c"
   $15 = (($14|0) / 2)&-1; //@line 89796 "c/sqlite3.c"
   $16 = ($12|0)>($15|0); //@line 89796 "c/sqlite3.c"
   $$ = $16 ? $12 : $15; //@line 89796 "c/sqlite3.c"
   $17 = ((($5)) + 16|0); //@line 89796 "c/sqlite3.c"
   HEAP32[$17>>2] = $$; //@line 89796 "c/sqlite3.c"
   $18 = ($$|0)<(0); //@line 89797 "c/sqlite3.c"
   $19 = $18 << 31 >> 31; //@line 89797 "c/sqlite3.c"
   $20 = ((($0)) + 64|0); //@line 89797 "c/sqlite3.c"
   $21 = $20; //@line 89797 "c/sqlite3.c"
   $22 = $21; //@line 89797 "c/sqlite3.c"
   $23 = HEAP32[$22>>2]|0; //@line 89797 "c/sqlite3.c"
   $24 = (($21) + 4)|0; //@line 89797 "c/sqlite3.c"
   $25 = $24; //@line 89797 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 89797 "c/sqlite3.c"
   $27 = (_i64Add(($23|0),($26|0),($$|0),($19|0))|0); //@line 89797 "c/sqlite3.c"
   $28 = tempRet0; //@line 89797 "c/sqlite3.c"
   $29 = $20; //@line 89797 "c/sqlite3.c"
   $30 = $29; //@line 89797 "c/sqlite3.c"
   HEAP32[$30>>2] = $27; //@line 89797 "c/sqlite3.c"
   $31 = (($29) + 4)|0; //@line 89797 "c/sqlite3.c"
   $32 = $31; //@line 89797 "c/sqlite3.c"
   HEAP32[$32>>2] = $28; //@line 89797 "c/sqlite3.c"
   $$0 = 0;
   return ($$0|0); //@line 89802 "c/sqlite3.c"
  }
 } else {
  HEAP32[$2>>2] = 0; //@line 89791 "c/sqlite3.c"
 }
 _vdbeMergeEngineFree($1); //@line 89799 "c/sqlite3.c"
 $$0 = 7;
 return ($$0|0); //@line 89802 "c/sqlite3.c"
}
function _vdbeIncrMergerSetThreads($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 89810 "c/sqlite3.c"
 HEAP32[$1>>2] = 1; //@line 89810 "c/sqlite3.c"
 $2 = ((($0)) + 16|0); //@line 89811 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 89811 "c/sqlite3.c"
 $4 = ($3|0)<(0); //@line 89811 "c/sqlite3.c"
 $5 = $4 << 31 >> 31; //@line 89811 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 89811 "c/sqlite3.c"
 $7 = ((($6)) + 64|0); //@line 89811 "c/sqlite3.c"
 $8 = $7; //@line 89811 "c/sqlite3.c"
 $9 = $8; //@line 89811 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 89811 "c/sqlite3.c"
 $11 = (($8) + 4)|0; //@line 89811 "c/sqlite3.c"
 $12 = $11; //@line 89811 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 89811 "c/sqlite3.c"
 $14 = (_i64Subtract(($10|0),($13|0),($3|0),($5|0))|0); //@line 89811 "c/sqlite3.c"
 $15 = tempRet0; //@line 89811 "c/sqlite3.c"
 $16 = $7; //@line 89811 "c/sqlite3.c"
 $17 = $16; //@line 89811 "c/sqlite3.c"
 HEAP32[$17>>2] = $14; //@line 89811 "c/sqlite3.c"
 $18 = (($16) + 4)|0; //@line 89811 "c/sqlite3.c"
 $19 = $18; //@line 89811 "c/sqlite3.c"
 HEAP32[$19>>2] = $15; //@line 89811 "c/sqlite3.c"
 return; //@line 89812 "c/sqlite3.c"
}
function _vdbeMergeEngineNew($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$0 = 2;
 while(1) {
  $1 = ($$0|0)<($0|0); //@line 88977 "c/sqlite3.c"
  $2 = $$0 << 1; //@line 88977 "c/sqlite3.c"
  if ($1) {
   $$0 = $2;
  } else {
   break;
  }
 }
 $3 = (_sqlite3FaultSim(100)|0); //@line 88980 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 88980 "c/sqlite3.c"
 if (!($4)) {
  $16 = 0;
  return ($16|0); //@line 88987 "c/sqlite3.c"
 }
 $5 = ($$0*60)|0; //@line 88978 "c/sqlite3.c"
 $6 = (($5) + 16)|0; //@line 88978 "c/sqlite3.c"
 $7 = ($6|0)<(0); //@line 88980 "c/sqlite3.c"
 $8 = $7 << 31 >> 31; //@line 88980 "c/sqlite3.c"
 $9 = (_sqlite3MallocZero($6,$8)|0); //@line 88980 "c/sqlite3.c"
 $10 = ($9|0)==(0|0); //@line 88981 "c/sqlite3.c"
 $11 = ((($9)) + 16|0); //@line 88984 "c/sqlite3.c"
 if ($10) {
  $16 = 0;
  return ($16|0); //@line 88987 "c/sqlite3.c"
 }
 $12 = ((($9)) + 8|0); //@line 88985 "c/sqlite3.c"
 $13 = (($11) + (($$0*56)|0)|0); //@line 88985 "c/sqlite3.c"
 $14 = ((($9)) + 12|0); //@line 88984 "c/sqlite3.c"
 $15 = ((($9)) + 4|0); //@line 88983 "c/sqlite3.c"
 HEAP32[$9>>2] = $$0; //@line 88982 "c/sqlite3.c"
 HEAP32[$15>>2] = 0; //@line 88983 "c/sqlite3.c"
 HEAP32[$14>>2] = $11; //@line 88984 "c/sqlite3.c"
 HEAP32[$12>>2] = $13; //@line 88985 "c/sqlite3.c"
 $16 = $9;
 return ($16|0); //@line 88987 "c/sqlite3.c"
}
function _vdbeSorterTreeDepth($0) {
 $0 = $0|0;
 var $$08$lcssa = 0, $$089 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)<(0); //@line 90135 "c/sqlite3.c"
 $2 = $1 << 31 >> 31; //@line 90135 "c/sqlite3.c"
 $3 = ($0|0)>(16); //@line 90135 "c/sqlite3.c"
 if (!($3)) {
  $$08$lcssa = 0;
  return ($$08$lcssa|0); //@line 90139 "c/sqlite3.c"
 }
 $$089 = 0;$4 = 16;$5 = 0;
 while(1) {
  $6 = (_bitshift64Shl(($4|0),($5|0),4)|0); //@line 90136 "c/sqlite3.c"
  $7 = tempRet0; //@line 90136 "c/sqlite3.c"
  $8 = (($$089) + 1)|0; //@line 90137 "c/sqlite3.c"
  $9 = ($7|0)<($2|0); //@line 90135 "c/sqlite3.c"
  $10 = ($6>>>0)<($0>>>0); //@line 90135 "c/sqlite3.c"
  $11 = ($7|0)==($2|0); //@line 90135 "c/sqlite3.c"
  $12 = $11 & $10; //@line 90135 "c/sqlite3.c"
  $13 = $9 | $12; //@line 90135 "c/sqlite3.c"
  if ($13) {
   $$089 = $8;$4 = $6;$5 = $7;
  } else {
   $$08$lcssa = $8;
   break;
  }
 }
 return ($$08$lcssa|0); //@line 90139 "c/sqlite3.c"
}
function _vdbeMergeEngineLevel0($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$03031 = 0, $$1$lcssa = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $not$ = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp;
 $5 = $2; //@line 90100 "c/sqlite3.c"
 $6 = $5; //@line 90100 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 90100 "c/sqlite3.c"
 $8 = (($5) + 4)|0; //@line 90100 "c/sqlite3.c"
 $9 = $8; //@line 90100 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 90100 "c/sqlite3.c"
 $11 = (_vdbeMergeEngineNew($1)|0); //@line 90104 "c/sqlite3.c"
 HEAP32[$3>>2] = $11; //@line 90104 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 90105 "c/sqlite3.c"
 $spec$select = $12 ? 7 : 0; //@line 90105 "c/sqlite3.c"
 $13 = ($1|0)>(0); //@line 90107 "c/sqlite3.c"
 $not$ = $12 ^ 1; //@line 90107 "c/sqlite3.c"
 $14 = $13 & $not$; //@line 90107 "c/sqlite3.c"
 if ($14) {
  $15 = ((($11)) + 12|0);
  $16 = ((($0)) + 40|0);
  $$03031 = 0;$23 = $7;$24 = $10;
  while(1) {
   $17 = $4; //@line 90108 "c/sqlite3.c"
   $18 = $17; //@line 90108 "c/sqlite3.c"
   HEAP32[$18>>2] = 0; //@line 90108 "c/sqlite3.c"
   $19 = (($17) + 4)|0; //@line 90108 "c/sqlite3.c"
   $20 = $19; //@line 90108 "c/sqlite3.c"
   HEAP32[$20>>2] = 0; //@line 90108 "c/sqlite3.c"
   $21 = HEAP32[$15>>2]|0; //@line 90109 "c/sqlite3.c"
   $22 = (($21) + (($$03031*56)|0)|0); //@line 90109 "c/sqlite3.c"
   $25 = (_vdbePmaReaderInit($0,$16,$23,$24,$22,$4)|0); //@line 90110 "c/sqlite3.c"
   $26 = (((($21) + (($$03031*56)|0)|0)) + 8|0); //@line 90111 "c/sqlite3.c"
   $27 = $26; //@line 90111 "c/sqlite3.c"
   $28 = $27; //@line 90111 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 90111 "c/sqlite3.c"
   $30 = (($27) + 4)|0; //@line 90111 "c/sqlite3.c"
   $31 = $30; //@line 90111 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 90111 "c/sqlite3.c"
   $33 = (($$03031) + 1)|0; //@line 90107 "c/sqlite3.c"
   $34 = ($33|0)<($1|0); //@line 90107 "c/sqlite3.c"
   $35 = ($25|0)==(0); //@line 90107 "c/sqlite3.c"
   $36 = $34 & $35; //@line 90107 "c/sqlite3.c"
   if ($36) {
    $$03031 = $33;$23 = $29;$24 = $32;
   } else {
    $$1$lcssa = $25;$$lcssa = $35;$39 = $29;$42 = $32;
    break;
   }
  }
 } else {
  $$1$lcssa = $spec$select;$$lcssa = $not$;$39 = $7;$42 = $10;
 }
 if ($$lcssa) {
  $37 = $2; //@line 90118 "c/sqlite3.c"
  $38 = $37; //@line 90118 "c/sqlite3.c"
  HEAP32[$38>>2] = $39; //@line 90118 "c/sqlite3.c"
  $40 = (($37) + 4)|0; //@line 90118 "c/sqlite3.c"
  $41 = $40; //@line 90118 "c/sqlite3.c"
  HEAP32[$41>>2] = $42; //@line 90118 "c/sqlite3.c"
  STACKTOP = sp;return ($$1$lcssa|0); //@line 90119 "c/sqlite3.c"
 }
 _vdbeMergeEngineFree($11); //@line 90115 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 90116 "c/sqlite3.c"
 $37 = $2; //@line 90118 "c/sqlite3.c"
 $38 = $37; //@line 90118 "c/sqlite3.c"
 HEAP32[$38>>2] = $39; //@line 90118 "c/sqlite3.c"
 $40 = (($37) + 4)|0; //@line 90118 "c/sqlite3.c"
 $41 = $40; //@line 90118 "c/sqlite3.c"
 HEAP32[$41>>2] = $42; //@line 90118 "c/sqlite3.c"
 STACKTOP = sp;return ($$1$lcssa|0); //@line 90119 "c/sqlite3.c"
}
function _vdbeSorterAddToTree($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0$lcssa = 0, $$0$lcssa65 = 0, $$0$lcssa66 = 0, $$0$lcssa67 = 0, $$03955 = 0, $$04254 = 0, $$044$lcssa = 0, $$044$lcssa64 = 0, $$04449 = 0, $$14051 = 0, $$14350 = 0, $$246$ph = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = (_vdbeIncrMergerNew($0,$4,$5)|0); //@line 90163 "c/sqlite3.c"
 $7 = ($1|0)>(1); //@line 90165 "c/sqlite3.c"
 L1: do {
  if ($7) {
   $$03955 = 1;$$04254 = 1;
   while(1) {
    $10 = $$03955 << 4; //@line 90166 "c/sqlite3.c"
    $11 = (($$04254) + 1)|0; //@line 90165 "c/sqlite3.c"
    $exitcond = ($11|0)==($1|0); //@line 90165 "c/sqlite3.c"
    if ($exitcond) {
     break;
    } else {
     $$03955 = $10;$$04254 = $11;
    }
   }
   $12 = ($1|0)>(1); //@line 90169 "c/sqlite3.c"
   $13 = ($6|0)==(0); //@line 90169 "c/sqlite3.c"
   $14 = $12 & $13; //@line 90169 "c/sqlite3.c"
   L6: do {
    if ($14) {
     $$04449 = $3;$$14051 = $10;$$14350 = 1;
     while(1) {
      $15 = (($2|0) / ($$14051|0))&-1; //@line 90170 "c/sqlite3.c"
      $16 = (($15|0) % 16)&-1; //@line 90170 "c/sqlite3.c"
      $17 = ((($$04449)) + 12|0); //@line 90171 "c/sqlite3.c"
      $18 = HEAP32[$17>>2]|0; //@line 90171 "c/sqlite3.c"
      $19 = (((($18) + (($16*56)|0)|0)) + 48|0); //@line 90173 "c/sqlite3.c"
      $20 = HEAP32[$19>>2]|0; //@line 90173 "c/sqlite3.c"
      $21 = ($20|0)==(0|0); //@line 90173 "c/sqlite3.c"
      if ($21) {
       $22 = (_vdbeMergeEngineNew(16)|0); //@line 90174 "c/sqlite3.c"
       $23 = ($22|0)==(0|0); //@line 90175 "c/sqlite3.c"
       if ($23) {
        $$246$ph = 7;
        break;
       }
       $24 = (_vdbeIncrMergerNew($0,$22,$19)|0); //@line 90178 "c/sqlite3.c"
       $25 = ($24|0)==(0); //@line 90181 "c/sqlite3.c"
       if (!($25)) {
        $$246$ph = $24;
        break;
       }
      }
      $27 = HEAP32[$19>>2]|0; //@line 90182 "c/sqlite3.c"
      $28 = ((($27)) + 4|0); //@line 90182 "c/sqlite3.c"
      $29 = HEAP32[$28>>2]|0; //@line 90182 "c/sqlite3.c"
      $30 = (($$14051|0) / 16)&-1; //@line 90183 "c/sqlite3.c"
      $31 = (($$14350) + 1)|0; //@line 90169 "c/sqlite3.c"
      $32 = ($31|0)<($1|0); //@line 90169 "c/sqlite3.c"
      if ($32) {
       $$04449 = $29;$$14051 = $30;$$14350 = $31;
      } else {
       $$0$lcssa = 0;$$044$lcssa = $29;$$lcssa = 1;
       break L6;
      }
     }
     $26 = HEAP32[$5>>2]|0;
     $$0$lcssa66 = $$246$ph;$39 = $26;
     label = 14;
     break L1;
    } else {
     $$0$lcssa = $6;$$044$lcssa = $3;$$lcssa = $13;
    }
   } while(0);
   $33 = HEAP32[$5>>2]|0;
   if ($$lcssa) {
    $$0$lcssa67 = $$0$lcssa;$$044$lcssa64 = $$044$lcssa;$38 = $33;
    label = 13;
   } else {
    $$0$lcssa66 = $$0$lcssa;$39 = $33;
    label = 14;
   }
  } else {
   $8 = ($6|0)==(0); //@line 90169 "c/sqlite3.c"
   $9 = HEAP32[$5>>2]|0;
   if ($8) {
    $$0$lcssa67 = 0;$$044$lcssa64 = $3;$38 = $9;
    label = 13;
   } else {
    $$0$lcssa66 = $6;$39 = $9;
    label = 14;
   }
  }
 } while(0);
 if ((label|0) == 13) {
  $34 = ((($$044$lcssa64)) + 12|0); //@line 90188 "c/sqlite3.c"
  $35 = HEAP32[$34>>2]|0; //@line 90188 "c/sqlite3.c"
  $36 = (($2|0) % 16)&-1; //@line 90188 "c/sqlite3.c"
  $37 = (((($35) + (($36*56)|0)|0)) + 48|0); //@line 90188 "c/sqlite3.c"
  HEAP32[$37>>2] = $38; //@line 90188 "c/sqlite3.c"
  $$0$lcssa65 = $$0$lcssa67;
  STACKTOP = sp;return ($$0$lcssa65|0); //@line 90192 "c/sqlite3.c"
 }
 else if ((label|0) == 14) {
  _vdbeIncrFree($39); //@line 90190 "c/sqlite3.c"
  $$0$lcssa65 = $$0$lcssa66;
  STACKTOP = sp;return ($$0$lcssa65|0); //@line 90192 "c/sqlite3.c"
 }
 return (0)|0;
}
function _vdbePmaReaderInit($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $6 = sp;
 $7 = (_vdbePmaReaderSeek($0,$4,$1,$2,$3)|0); //@line 88539 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 88540 "c/sqlite3.c"
 if (!($8)) {
  $$1 = $7;
  STACKTOP = sp;return ($$1|0); //@line 88550 "c/sqlite3.c"
 }
 $9 = $6; //@line 88541 "c/sqlite3.c"
 $10 = $9; //@line 88541 "c/sqlite3.c"
 HEAP32[$10>>2] = 0; //@line 88541 "c/sqlite3.c"
 $11 = (($9) + 4)|0; //@line 88541 "c/sqlite3.c"
 $12 = $11; //@line 88541 "c/sqlite3.c"
 HEAP32[$12>>2] = 0; //@line 88541 "c/sqlite3.c"
 $13 = (_vdbePmaReadVarint($4,$6)|0); //@line 88542 "c/sqlite3.c"
 $14 = $4; //@line 88543 "c/sqlite3.c"
 $15 = $14; //@line 88543 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 88543 "c/sqlite3.c"
 $17 = (($14) + 4)|0; //@line 88543 "c/sqlite3.c"
 $18 = $17; //@line 88543 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 88543 "c/sqlite3.c"
 $20 = $6; //@line 88543 "c/sqlite3.c"
 $21 = $20; //@line 88543 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 88543 "c/sqlite3.c"
 $23 = (($20) + 4)|0; //@line 88543 "c/sqlite3.c"
 $24 = $23; //@line 88543 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 88543 "c/sqlite3.c"
 $26 = (_i64Add(($22|0),($25|0),($16|0),($19|0))|0); //@line 88543 "c/sqlite3.c"
 $27 = tempRet0; //@line 88543 "c/sqlite3.c"
 $28 = ((($4)) + 8|0); //@line 88543 "c/sqlite3.c"
 $29 = $28; //@line 88543 "c/sqlite3.c"
 $30 = $29; //@line 88543 "c/sqlite3.c"
 HEAP32[$30>>2] = $26; //@line 88543 "c/sqlite3.c"
 $31 = (($29) + 4)|0; //@line 88543 "c/sqlite3.c"
 $32 = $31; //@line 88543 "c/sqlite3.c"
 HEAP32[$32>>2] = $27; //@line 88543 "c/sqlite3.c"
 $33 = $5; //@line 88544 "c/sqlite3.c"
 $34 = $33; //@line 88544 "c/sqlite3.c"
 $35 = HEAP32[$34>>2]|0; //@line 88544 "c/sqlite3.c"
 $36 = (($33) + 4)|0; //@line 88544 "c/sqlite3.c"
 $37 = $36; //@line 88544 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 88544 "c/sqlite3.c"
 $39 = (_i64Add(($35|0),($38|0),($22|0),($25|0))|0); //@line 88544 "c/sqlite3.c"
 $40 = tempRet0; //@line 88544 "c/sqlite3.c"
 $41 = $5; //@line 88544 "c/sqlite3.c"
 $42 = $41; //@line 88544 "c/sqlite3.c"
 HEAP32[$42>>2] = $39; //@line 88544 "c/sqlite3.c"
 $43 = (($41) + 4)|0; //@line 88544 "c/sqlite3.c"
 $44 = $43; //@line 88544 "c/sqlite3.c"
 HEAP32[$44>>2] = $40; //@line 88544 "c/sqlite3.c"
 $45 = ($13|0)==(0); //@line 88547 "c/sqlite3.c"
 if (!($45)) {
  $$1 = $13;
  STACKTOP = sp;return ($$1|0); //@line 88550 "c/sqlite3.c"
 }
 $46 = (_vdbePmaReaderNext($4)|0); //@line 88548 "c/sqlite3.c"
 $$1 = $46;
 STACKTOP = sp;return ($$1|0); //@line 88550 "c/sqlite3.c"
}
function _sqlite3BtreeCursorHasMoved($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = HEAP8[$0>>0]|0; //@line 61270 "c/sqlite3.c"
 $2 = ($1<<24>>24)!=(1); //@line 61270 "c/sqlite3.c"
 $3 = $2&1; //@line 61270 "c/sqlite3.c"
 return ($3|0); //@line 61270 "c/sqlite3.c"
}
function _handleMovedCursor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 40|0); //@line 76075 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 76075 "c/sqlite3.c"
 $4 = (_sqlite3BtreeCursorRestore($3,$1)|0); //@line 76075 "c/sqlite3.c"
 $5 = ((($0)) + 28|0); //@line 76076 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 76076 "c/sqlite3.c"
 $6 = HEAP32[$1>>2]|0; //@line 76077 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 76077 "c/sqlite3.c"
 if ($7) {
  STACKTOP = sp;return ($4|0); //@line 76078 "c/sqlite3.c"
 }
 $8 = ((($0)) + 2|0); //@line 76077 "c/sqlite3.c"
 HEAP8[$8>>0] = 1; //@line 76077 "c/sqlite3.c"
 STACKTOP = sp;return ($4|0); //@line 76078 "c/sqlite3.c"
}
function _sqlite3BtreeCursorRestore($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$ = 0, $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $storemerge8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0; //@line 61302 "c/sqlite3.c"
 $3 = ($2&255)>(2); //@line 61302 "c/sqlite3.c"
 if ($3) {
  $4 = (_btreeRestoreCursorPosition($0)|0); //@line 61302 "c/sqlite3.c"
  $5 = ($4|0)==(0); //@line 61303 "c/sqlite3.c"
  if (!($5)) {
   $$0 = $4;$storemerge8 = 1;
   HEAP32[$1>>2] = $storemerge8;
   return ($$0|0); //@line 61314 "c/sqlite3.c"
  }
 }
 $6 = HEAP8[$0>>0]|0; //@line 61307 "c/sqlite3.c"
 $7 = ($6<<24>>24)!=(1); //@line 61307 "c/sqlite3.c"
 $$ = $7&1;
 $$0 = 0;$storemerge8 = $$;
 HEAP32[$1>>2] = $storemerge8;
 return ($$0|0); //@line 61314 "c/sqlite3.c"
}
function _vdbeSorterRowkey($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$014 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 56|0); //@line 90462 "c/sqlite3.c"
 $3 = HEAP8[$2>>0]|0; //@line 90462 "c/sqlite3.c"
 $4 = ($3<<24>>24)==(0); //@line 90462 "c/sqlite3.c"
 if ($4) {
  $23 = ((($0)) + 36|0); //@line 90475 "c/sqlite3.c"
  $24 = HEAP32[$23>>2]|0; //@line 90475 "c/sqlite3.c"
  $25 = HEAP32[$24>>2]|0; //@line 90475 "c/sqlite3.c"
  HEAP32[$1>>2] = $25; //@line 90475 "c/sqlite3.c"
  $26 = ((($24)) + 8|0); //@line 90476 "c/sqlite3.c"
  $$014 = $26;
  return ($$014|0); //@line 90478 "c/sqlite3.c"
 }
 $5 = ((($0)) + 57|0); //@line 90465 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 90465 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 90465 "c/sqlite3.c"
 if ($7) {
  $10 = ((($0)) + 20|0); //@line 90470 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 90470 "c/sqlite3.c"
  $12 = ((($11)) + 12|0); //@line 90470 "c/sqlite3.c"
  $13 = HEAP32[$12>>2]|0; //@line 90470 "c/sqlite3.c"
  $14 = ((($11)) + 8|0); //@line 90470 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 90470 "c/sqlite3.c"
  $16 = ((($15)) + 4|0); //@line 90470 "c/sqlite3.c"
  $17 = HEAP32[$16>>2]|0; //@line 90470 "c/sqlite3.c"
  $18 = (($13) + (($17*56)|0)|0); //@line 90470 "c/sqlite3.c"
  $$0 = $18;
 } else {
  $8 = ((($0)) + 16|0); //@line 90466 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 90466 "c/sqlite3.c"
  $$0 = $9;
 }
 $19 = ((($$0)) + 20|0); //@line 90472 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 90472 "c/sqlite3.c"
 HEAP32[$1>>2] = $20; //@line 90472 "c/sqlite3.c"
 $21 = ((($$0)) + 32|0); //@line 90473 "c/sqlite3.c"
 $22 = HEAP32[$21>>2]|0; //@line 90473 "c/sqlite3.c"
 $$014 = $22;
 return ($$014|0); //@line 90478 "c/sqlite3.c"
}
function _dropCell($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$3>>2]|0; //@line 66877 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 66877 "c/sqlite3.c"
 if (!($5)) {
  return; //@line 66909 "c/sqlite3.c"
 }
 $6 = ((($0)) + 56|0); //@line 66882 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 66882 "c/sqlite3.c"
 $8 = ((($0)) + 64|0); //@line 66883 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 66883 "c/sqlite3.c"
 $10 = $1 << 1; //@line 66883 "c/sqlite3.c"
 $11 = (($9) + ($10)|0); //@line 66883 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 66884 "c/sqlite3.c"
 $13 = $12&255; //@line 66884 "c/sqlite3.c"
 $14 = $13 << 8; //@line 66884 "c/sqlite3.c"
 $15 = ((($11)) + 1|0); //@line 66884 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 66884 "c/sqlite3.c"
 $17 = $16&255; //@line 66884 "c/sqlite3.c"
 $18 = $14 | $17; //@line 66884 "c/sqlite3.c"
 $19 = ((($0)) + 9|0); //@line 66885 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 66885 "c/sqlite3.c"
 $21 = $20&255; //@line 66885 "c/sqlite3.c"
 $22 = (($18) + ($2))|0; //@line 66888 "c/sqlite3.c"
 $23 = ((($0)) + 52|0); //@line 66888 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 66888 "c/sqlite3.c"
 $25 = ((($24)) + 36|0); //@line 66888 "c/sqlite3.c"
 $26 = HEAP32[$25>>2]|0; //@line 66888 "c/sqlite3.c"
 $27 = ($22>>>0)>($26>>>0); //@line 66888 "c/sqlite3.c"
 if ($27) {
  $28 = (_sqlite3CorruptError(66889)|0); //@line 66889 "c/sqlite3.c"
  HEAP32[$3>>2] = $28; //@line 66889 "c/sqlite3.c"
  return; //@line 66909 "c/sqlite3.c"
 }
 $29 = $18&65535; //@line 66892 "c/sqlite3.c"
 $30 = $2&65535; //@line 66892 "c/sqlite3.c"
 $31 = (_freeSpace($0,$29,$30)|0); //@line 66892 "c/sqlite3.c"
 $32 = ($31|0)==(0); //@line 66893 "c/sqlite3.c"
 if (!($32)) {
  HEAP32[$3>>2] = $31; //@line 66894 "c/sqlite3.c"
  return; //@line 66909 "c/sqlite3.c"
 }
 $33 = ((($0)) + 22|0); //@line 66897 "c/sqlite3.c"
 $34 = HEAP16[$33>>1]|0; //@line 66897 "c/sqlite3.c"
 $35 = (($34) + -1)<<16>>16; //@line 66897 "c/sqlite3.c"
 HEAP16[$33>>1] = $35; //@line 66897 "c/sqlite3.c"
 $36 = ($35<<16>>16)==(0); //@line 66898 "c/sqlite3.c"
 if ($36) {
  $37 = (($21) + 1)|0; //@line 66899 "c/sqlite3.c"
  $38 = (($7) + ($37)|0); //@line 66899 "c/sqlite3.c"
  HEAP8[$38>>0]=0&255;HEAP8[$38+1>>0]=(0>>8)&255;HEAP8[$38+2>>0]=(0>>16)&255;HEAP8[$38+3>>0]=0>>24; //@line 66899 "c/sqlite3.c"
  $39 = (($21) + 7)|0; //@line 66900 "c/sqlite3.c"
  $40 = (($7) + ($39)|0); //@line 66900 "c/sqlite3.c"
  HEAP8[$40>>0] = 0; //@line 66900 "c/sqlite3.c"
  $41 = HEAP32[$23>>2]|0; //@line 66901 "c/sqlite3.c"
  $42 = ((($41)) + 36|0); //@line 66901 "c/sqlite3.c"
  $43 = HEAP32[$42>>2]|0; //@line 66901 "c/sqlite3.c"
  $44 = $43 >>> 8; //@line 66901 "c/sqlite3.c"
  $45 = $44&255; //@line 66901 "c/sqlite3.c"
  $46 = (($21) + 5)|0; //@line 66901 "c/sqlite3.c"
  $47 = (($7) + ($46)|0); //@line 66901 "c/sqlite3.c"
  HEAP8[$47>>0] = $45; //@line 66901 "c/sqlite3.c"
  $48 = HEAP32[$23>>2]|0; //@line 66901 "c/sqlite3.c"
  $49 = ((($48)) + 36|0); //@line 66901 "c/sqlite3.c"
  $50 = HEAP32[$49>>2]|0; //@line 66901 "c/sqlite3.c"
  $51 = $50&255; //@line 66901 "c/sqlite3.c"
  $52 = ((($47)) + 1|0); //@line 66901 "c/sqlite3.c"
  HEAP8[$52>>0] = $51; //@line 66901 "c/sqlite3.c"
  $53 = HEAP32[$23>>2]|0; //@line 66902 "c/sqlite3.c"
  $54 = ((($53)) + 36|0); //@line 66902 "c/sqlite3.c"
  $55 = HEAP32[$54>>2]|0; //@line 66902 "c/sqlite3.c"
  $56 = HEAP8[$19>>0]|0; //@line 66902 "c/sqlite3.c"
  $57 = $56&255; //@line 66902 "c/sqlite3.c"
  $58 = ((($0)) + 10|0); //@line 66903 "c/sqlite3.c"
  $59 = HEAP8[$58>>0]|0; //@line 66903 "c/sqlite3.c"
  $60 = $59&255; //@line 66903 "c/sqlite3.c"
  $61 = (($55) + 65528)|0; //@line 66902 "c/sqlite3.c"
  $62 = (($61) - ($57))|0; //@line 66903 "c/sqlite3.c"
  $63 = (($62) - ($60))|0; //@line 66903 "c/sqlite3.c"
  $64 = $63&65535; //@line 66902 "c/sqlite3.c"
  $65 = ((($0)) + 20|0); //@line 66902 "c/sqlite3.c"
  HEAP16[$65>>1] = $64; //@line 66902 "c/sqlite3.c"
  return; //@line 66909 "c/sqlite3.c"
 } else {
  $66 = $35&65535; //@line 66898 "c/sqlite3.c"
  $67 = ((($11)) + 2|0); //@line 66905 "c/sqlite3.c"
  $68 = (($66) - ($1))|0; //@line 66905 "c/sqlite3.c"
  $69 = $68 << 1; //@line 66905 "c/sqlite3.c"
  _memmove(($11|0),($67|0),($69|0))|0; //@line 66905 "c/sqlite3.c"
  $70 = HEAP16[$33>>1]|0; //@line 66906 "c/sqlite3.c"
  $71 = ($70&65535) >>> 8; //@line 66906 "c/sqlite3.c"
  $72 = $71&255; //@line 66906 "c/sqlite3.c"
  $73 = (($21) + 3)|0; //@line 66906 "c/sqlite3.c"
  $74 = (($7) + ($73)|0); //@line 66906 "c/sqlite3.c"
  HEAP8[$74>>0] = $72; //@line 66906 "c/sqlite3.c"
  $75 = HEAP16[$33>>1]|0; //@line 66906 "c/sqlite3.c"
  $76 = $75&255; //@line 66906 "c/sqlite3.c"
  $77 = ((($74)) + 1|0); //@line 66906 "c/sqlite3.c"
  HEAP8[$77>>0] = $76; //@line 66906 "c/sqlite3.c"
  $78 = ((($0)) + 20|0); //@line 66907 "c/sqlite3.c"
  $79 = HEAP16[$78>>1]|0; //@line 66907 "c/sqlite3.c"
  $80 = $79&65535; //@line 66907 "c/sqlite3.c"
  $81 = (($80) + 2)|0; //@line 66907 "c/sqlite3.c"
  $82 = $81&65535; //@line 66907 "c/sqlite3.c"
  HEAP16[$78>>1] = $82; //@line 66907 "c/sqlite3.c"
  return; //@line 66909 "c/sqlite3.c"
 }
}
function _insertCell($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$060 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $7 = sp;
 HEAP32[$7>>2] = 0; //@line 66934 "c/sqlite3.c"
 $8 = ((($0)) + 12|0); //@line 66952 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 66952 "c/sqlite3.c"
 $10 = ($9<<24>>24)==(0); //@line 66952 "c/sqlite3.c"
 if ($10) {
  $11 = (($3) + 2)|0; //@line 66952 "c/sqlite3.c"
  $12 = ((($0)) + 20|0); //@line 66952 "c/sqlite3.c"
  $13 = HEAP16[$12>>1]|0; //@line 66952 "c/sqlite3.c"
  $14 = $13&65535; //@line 66952 "c/sqlite3.c"
  $15 = ($11|0)>($14|0); //@line 66952 "c/sqlite3.c"
  if (!($15)) {
   $24 = ((($0)) + 72|0); //@line 66976 "c/sqlite3.c"
   $25 = HEAP32[$24>>2]|0; //@line 66976 "c/sqlite3.c"
   $26 = (_sqlite3PagerWrite($25)|0); //@line 66976 "c/sqlite3.c"
   $27 = ($26|0)==(0); //@line 66977 "c/sqlite3.c"
   if (!($27)) {
    HEAP32[$6>>2] = $26; //@line 66978 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 67012 "c/sqlite3.c"
   }
   $28 = ((($0)) + 56|0); //@line 66982 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 66982 "c/sqlite3.c"
   $30 = (_allocateSpace($0,$3,$7)|0); //@line 66984 "c/sqlite3.c"
   $31 = ($30|0)==(0); //@line 66985 "c/sqlite3.c"
   if (!($31)) {
    HEAP32[$6>>2] = $30; //@line 66985 "c/sqlite3.c"
    STACKTOP = sp;return; //@line 67012 "c/sqlite3.c"
   }
   $32 = HEAP16[$12>>1]|0; //@line 66991 "c/sqlite3.c"
   $33 = $32&65535; //@line 66991 "c/sqlite3.c"
   $34 = (($33) - ($11))|0; //@line 66991 "c/sqlite3.c"
   $35 = $34&65535; //@line 66991 "c/sqlite3.c"
   HEAP16[$12>>1] = $35; //@line 66991 "c/sqlite3.c"
   $36 = HEAP32[$7>>2]|0; //@line 66992 "c/sqlite3.c"
   $37 = (($29) + ($36)|0); //@line 66992 "c/sqlite3.c"
   _memcpy(($37|0),($2|0),($3|0))|0; //@line 66992 "c/sqlite3.c"
   $38 = ($5|0)==(0); //@line 66993 "c/sqlite3.c"
   if (!($38)) {
    _sqlite3Put4byte($37,$5); //@line 66994 "c/sqlite3.c"
   }
   $39 = ((($0)) + 64|0); //@line 66996 "c/sqlite3.c"
   $40 = HEAP32[$39>>2]|0; //@line 66996 "c/sqlite3.c"
   $41 = $1 << 1; //@line 66996 "c/sqlite3.c"
   $42 = (($40) + ($41)|0); //@line 66996 "c/sqlite3.c"
   $43 = ((($42)) + 2|0); //@line 66997 "c/sqlite3.c"
   $44 = ((($0)) + 22|0); //@line 66997 "c/sqlite3.c"
   $45 = HEAP16[$44>>1]|0; //@line 66997 "c/sqlite3.c"
   $46 = $45&65535; //@line 66997 "c/sqlite3.c"
   $47 = (($46) - ($1))|0; //@line 66997 "c/sqlite3.c"
   $48 = $47 << 1; //@line 66997 "c/sqlite3.c"
   _memmove(($43|0),($42|0),($48|0))|0; //@line 66997 "c/sqlite3.c"
   $49 = $36 >>> 8; //@line 66998 "c/sqlite3.c"
   $50 = $49&255; //@line 66998 "c/sqlite3.c"
   HEAP8[$42>>0] = $50; //@line 66998 "c/sqlite3.c"
   $51 = $36&255; //@line 66998 "c/sqlite3.c"
   $52 = ((($42)) + 1|0); //@line 66998 "c/sqlite3.c"
   HEAP8[$52>>0] = $51; //@line 66998 "c/sqlite3.c"
   $53 = HEAP16[$44>>1]|0; //@line 66999 "c/sqlite3.c"
   $54 = (($53) + 1)<<16>>16; //@line 66999 "c/sqlite3.c"
   HEAP16[$44>>1] = $54; //@line 66999 "c/sqlite3.c"
   $55 = ((($0)) + 9|0); //@line 67001 "c/sqlite3.c"
   $56 = HEAP8[$55>>0]|0; //@line 67001 "c/sqlite3.c"
   $57 = $56&255; //@line 67001 "c/sqlite3.c"
   $58 = (($57) + 4)|0; //@line 67001 "c/sqlite3.c"
   $59 = (($29) + ($58)|0); //@line 67001 "c/sqlite3.c"
   $60 = HEAP8[$59>>0]|0; //@line 67001 "c/sqlite3.c"
   $61 = (($60) + 1)<<24>>24; //@line 67001 "c/sqlite3.c"
   HEAP8[$59>>0] = $61; //@line 67001 "c/sqlite3.c"
   $62 = ($61<<24>>24)==(0); //@line 67001 "c/sqlite3.c"
   if ($62) {
    $63 = HEAP8[$55>>0]|0; //@line 67001 "c/sqlite3.c"
    $64 = $63&255; //@line 67001 "c/sqlite3.c"
    $65 = (($64) + 3)|0; //@line 67001 "c/sqlite3.c"
    $66 = (($29) + ($65)|0); //@line 67001 "c/sqlite3.c"
    $67 = HEAP8[$66>>0]|0; //@line 67001 "c/sqlite3.c"
    $68 = (($67) + 1)<<24>>24; //@line 67001 "c/sqlite3.c"
    HEAP8[$66>>0] = $68; //@line 67001 "c/sqlite3.c"
   }
   $69 = ((($0)) + 52|0); //@line 67004 "c/sqlite3.c"
   $70 = HEAP32[$69>>2]|0; //@line 67004 "c/sqlite3.c"
   $71 = ((($70)) + 17|0); //@line 67004 "c/sqlite3.c"
   $72 = HEAP8[$71>>0]|0; //@line 67004 "c/sqlite3.c"
   $73 = ($72<<24>>24)==(0); //@line 67004 "c/sqlite3.c"
   if ($73) {
    STACKTOP = sp;return; //@line 67012 "c/sqlite3.c"
   }
   _ptrmapPutOvflPtr($0,$2,$6); //@line 67008 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 67012 "c/sqlite3.c"
  }
 }
 $16 = ($4|0)==(0|0); //@line 66953 "c/sqlite3.c"
 if ($16) {
  $$060 = $2;
 } else {
  _memcpy(($4|0),($2|0),($3|0))|0; //@line 66954 "c/sqlite3.c"
  $$060 = $4;
 }
 $17 = ($5|0)==(0); //@line 66957 "c/sqlite3.c"
 if (!($17)) {
  _sqlite3Put4byte($$060,$5); //@line 66958 "c/sqlite3.c"
 }
 $18 = HEAP8[$8>>0]|0; //@line 66960 "c/sqlite3.c"
 $19 = (($18) + 1)<<24>>24; //@line 66960 "c/sqlite3.c"
 HEAP8[$8>>0] = $19; //@line 66960 "c/sqlite3.c"
 $20 = $18&255; //@line 66960 "c/sqlite3.c"
 $21 = (((($0)) + 36|0) + ($20<<2)|0); //@line 66965 "c/sqlite3.c"
 HEAP32[$21>>2] = $$060; //@line 66965 "c/sqlite3.c"
 $22 = $1&65535; //@line 66966 "c/sqlite3.c"
 $23 = (((($0)) + 26|0) + ($20<<1)|0); //@line 66966 "c/sqlite3.c"
 HEAP16[$23>>1] = $22; //@line 66966 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 67012 "c/sqlite3.c"
}
function _balance($0) {
 $0 = $0|0;
 var $$067 = 0, $$1 = 0, $$168 = 0, $$3 = 0, $$370 = 0, $$37073 = 0, $$374 = 0, $$sink76$in = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 12|0); //@line 68424 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 68424 "c/sqlite3.c"
 $4 = ((($3)) + 36|0); //@line 68424 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 68424 "c/sqlite3.c"
 $6 = $5 << 1; //@line 68424 "c/sqlite3.c"
 $7 = (($6>>>0) / 3)&-1; //@line 68424 "c/sqlite3.c"
 $8 = ((($0)) + 124|0); //@line 68444 "c/sqlite3.c"
 $9 = ((($0)) + 68|0);
 $10 = ((($0)) + 116|0);
 $11 = ((($0)) + 70|0);
 $12 = ((($0)) + 72|0);
 $13 = ((($0)) + 120|0);
 $14 = ((($0)) + 3|0);
 $$067 = 0;
 while(1) {
  $15 = HEAP8[$9>>0]|0; //@line 68432 "c/sqlite3.c"
  $16 = $15 << 24 >> 24; //@line 68432 "c/sqlite3.c"
  $17 = HEAP32[$10>>2]|0; //@line 68433 "c/sqlite3.c"
  $18 = ($15<<24>>24)==(0); //@line 68435 "c/sqlite3.c"
  $19 = ((($17)) + 12|0);
  $20 = HEAP8[$19>>0]|0;
  $21 = ($20<<24>>24)==(0);
  if ($18) {
   if ($21) {
    $$37073 = $$067;$$374 = 0;
    break;
   }
   $22 = (_balance_deeper($17,$8)|0); //@line 68444 "c/sqlite3.c"
   $23 = ($22|0)==(0); //@line 68445 "c/sqlite3.c"
   if (!($23)) {
    $$37073 = $$067;$$374 = $22;
    break;
   }
   HEAP8[$9>>0] = 1; //@line 68446 "c/sqlite3.c"
   HEAP16[$11>>1] = 0; //@line 68447 "c/sqlite3.c"
   HEAP16[$12>>1] = 0; //@line 68448 "c/sqlite3.c"
   HEAP32[$13>>2] = $17; //@line 68449 "c/sqlite3.c"
   $$3 = 0;$$370 = $$067;$$sink76$in = $8;
  } else {
   if ($21) {
    $24 = ((($17)) + 20|0); //@line 68456 "c/sqlite3.c"
    $25 = HEAP16[$24>>1]|0; //@line 68456 "c/sqlite3.c"
    $26 = $25&65535; //@line 68456 "c/sqlite3.c"
    $27 = ($7>>>0)<($26>>>0); //@line 68456 "c/sqlite3.c"
    if (!($27)) {
     $$37073 = $$067;$$374 = 0;
     break;
    }
   }
   $28 = (($16) + -1)|0; //@line 68459 "c/sqlite3.c"
   $29 = (((($0)) + 120|0) + ($28<<2)|0); //@line 68459 "c/sqlite3.c"
   $30 = HEAP32[$29>>2]|0; //@line 68459 "c/sqlite3.c"
   $31 = (((($0)) + 72|0) + ($28<<1)|0); //@line 68460 "c/sqlite3.c"
   $32 = HEAP16[$31>>1]|0; //@line 68460 "c/sqlite3.c"
   $33 = $32&65535; //@line 68460 "c/sqlite3.c"
   $34 = ((($30)) + 72|0); //@line 68462 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 68462 "c/sqlite3.c"
   $36 = (_sqlite3PagerWrite($35)|0); //@line 68462 "c/sqlite3.c"
   $37 = ($36|0)==(0); //@line 68463 "c/sqlite3.c"
   do {
    if ($37) {
     $38 = ((($17)) + 3|0); //@line 68465 "c/sqlite3.c"
     $39 = HEAP8[$38>>0]|0; //@line 68465 "c/sqlite3.c"
     $40 = ($39<<24>>24)==(0); //@line 68465 "c/sqlite3.c"
     if (!($40)) {
      $41 = HEAP8[$19>>0]|0; //@line 68466 "c/sqlite3.c"
      $42 = ($41<<24>>24)==(1); //@line 68466 "c/sqlite3.c"
      if ($42) {
       $43 = ((($17)) + 26|0); //@line 68467 "c/sqlite3.c"
       $44 = HEAP16[$43>>1]|0; //@line 68467 "c/sqlite3.c"
       $45 = ((($17)) + 22|0); //@line 68467 "c/sqlite3.c"
       $46 = HEAP16[$45>>1]|0; //@line 68467 "c/sqlite3.c"
       $47 = ($44<<16>>16)==($46<<16>>16); //@line 68467 "c/sqlite3.c"
       if ($47) {
        $48 = ((($30)) + 4|0); //@line 68468 "c/sqlite3.c"
        $49 = HEAP32[$48>>2]|0; //@line 68468 "c/sqlite3.c"
        $50 = ($49|0)==(1); //@line 68468 "c/sqlite3.c"
        if (!($50)) {
         $51 = ((($30)) + 22|0); //@line 68469 "c/sqlite3.c"
         $52 = HEAP16[$51>>1]|0; //@line 68469 "c/sqlite3.c"
         $53 = ($52<<16>>16)==($32<<16>>16); //@line 68469 "c/sqlite3.c"
         if ($53) {
          $54 = (_balance_quick($30,$17,$1)|0); //@line 68486 "c/sqlite3.c"
          $$1 = $54;$$168 = $$067;
          break;
         }
        }
       }
      }
     }
     $55 = HEAP32[$2>>2]|0; //@line 68507 "c/sqlite3.c"
     $56 = ((($55)) + 32|0); //@line 68507 "c/sqlite3.c"
     $57 = HEAP32[$56>>2]|0; //@line 68507 "c/sqlite3.c"
     $58 = (_sqlite3PageMalloc($57)|0); //@line 68507 "c/sqlite3.c"
     $59 = ($15<<24>>24)==(1); //@line 68508 "c/sqlite3.c"
     $60 = $59&1; //@line 68508 "c/sqlite3.c"
     $61 = HEAP8[$14>>0]|0; //@line 68509 "c/sqlite3.c"
     $62 = $61 & 1; //@line 68509 "c/sqlite3.c"
     $63 = $62&255; //@line 68509 "c/sqlite3.c"
     $64 = (_balance_nonroot($30,$33,$58,$60,$63)|0); //@line 68508 "c/sqlite3.c"
     $65 = ($$067|0)==(0|0); //@line 68510 "c/sqlite3.c"
     if ($65) {
      $$1 = $64;$$168 = $58;
     } else {
      _sqlite3PageFree($$067); //@line 68515 "c/sqlite3.c"
      $$1 = $64;$$168 = $58;
     }
    } else {
     $$1 = $36;$$168 = $$067;
    }
   } while(0);
   HEAP8[$19>>0] = 0; //@line 68525 "c/sqlite3.c"
   _releasePage($17); //@line 68528 "c/sqlite3.c"
   $66 = HEAP8[$9>>0]|0; //@line 68529 "c/sqlite3.c"
   $67 = (($66) + -1)<<24>>24; //@line 68529 "c/sqlite3.c"
   HEAP8[$9>>0] = $67; //@line 68529 "c/sqlite3.c"
   $68 = $67 << 24 >> 24; //@line 68531 "c/sqlite3.c"
   $69 = (((($0)) + 120|0) + ($68<<2)|0); //@line 68531 "c/sqlite3.c"
   $$3 = $$1;$$370 = $$168;$$sink76$in = $69;
  }
  $70 = HEAP32[$$sink76$in>>2]|0;
  HEAP32[$10>>2] = $70;
  $71 = ($$3|0)==(0); //@line 68533 "c/sqlite3.c"
  if ($71) {
   $$067 = $$370;
  } else {
   $$37073 = $$370;$$374 = $$3;
   break;
  }
 }
 $72 = ($$37073|0)==(0|0); //@line 68535 "c/sqlite3.c"
 if ($72) {
  STACKTOP = sp;return ($$374|0); //@line 68538 "c/sqlite3.c"
 }
 _sqlite3PageFree($$37073); //@line 68536 "c/sqlite3.c"
 STACKTOP = sp;return ($$374|0); //@line 68538 "c/sqlite3.c"
}
function _balance_deeper($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 8|0;
 $3 = sp + 4|0;
 $4 = sp;
 HEAP32[$3>>2] = 0; //@line 68367 "c/sqlite3.c"
 HEAP32[$4>>2] = 0; //@line 68368 "c/sqlite3.c"
 $5 = ((($0)) + 52|0); //@line 68369 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 68369 "c/sqlite3.c"
 $7 = ((($0)) + 72|0); //@line 68378 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 68378 "c/sqlite3.c"
 $9 = (_sqlite3PagerWrite($8)|0); //@line 68378 "c/sqlite3.c"
 HEAP32[$2>>2] = $9; //@line 68378 "c/sqlite3.c"
 $10 = ($9|0)==(0); //@line 68379 "c/sqlite3.c"
 if ($10) {
  $11 = ((($0)) + 4|0); //@line 68380 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 68380 "c/sqlite3.c"
  $13 = (_allocateBtreePage($6,$3,$4,$12,0)|0); //@line 68380 "c/sqlite3.c"
  HEAP32[$2>>2] = $13; //@line 68380 "c/sqlite3.c"
  $14 = HEAP32[$3>>2]|0; //@line 68381 "c/sqlite3.c"
  _copyNodeContent($0,$14,$2); //@line 68381 "c/sqlite3.c"
  $15 = ((($6)) + 17|0); //@line 68382 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 68382 "c/sqlite3.c"
  $17 = ($16<<24>>24)==(0); //@line 68382 "c/sqlite3.c"
  if (!($17)) {
   $18 = HEAP32[$4>>2]|0; //@line 68383 "c/sqlite3.c"
   $19 = HEAP32[$11>>2]|0; //@line 68383 "c/sqlite3.c"
   _ptrmapPut($6,$18,5,$19,$2); //@line 68383 "c/sqlite3.c"
  }
  $$pr = HEAP32[$2>>2]|0; //@line 68386 "c/sqlite3.c"
  $20 = ($$pr|0)==(0); //@line 68386 "c/sqlite3.c"
  if ($20) {
   $22 = HEAP32[$3>>2]|0; //@line 68398 "c/sqlite3.c"
   $23 = ((($22)) + 26|0); //@line 68398 "c/sqlite3.c"
   $24 = ((($0)) + 26|0); //@line 68398 "c/sqlite3.c"
   $25 = ((($0)) + 12|0); //@line 68399 "c/sqlite3.c"
   $26 = HEAP8[$25>>0]|0; //@line 68399 "c/sqlite3.c"
   $27 = $26&255; //@line 68399 "c/sqlite3.c"
   $28 = $27 << 1; //@line 68399 "c/sqlite3.c"
   _memcpy(($23|0),($24|0),($28|0))|0; //@line 68398 "c/sqlite3.c"
   $29 = ((($22)) + 36|0); //@line 68400 "c/sqlite3.c"
   $30 = ((($0)) + 36|0); //@line 68400 "c/sqlite3.c"
   $31 = HEAP8[$25>>0]|0; //@line 68401 "c/sqlite3.c"
   $32 = $31&255; //@line 68401 "c/sqlite3.c"
   $33 = $32 << 2; //@line 68401 "c/sqlite3.c"
   _memcpy(($29|0),($30|0),($33|0))|0; //@line 68400 "c/sqlite3.c"
   $34 = HEAP8[$25>>0]|0; //@line 68402 "c/sqlite3.c"
   $35 = ((($22)) + 12|0); //@line 68402 "c/sqlite3.c"
   HEAP8[$35>>0] = $34; //@line 68402 "c/sqlite3.c"
   $36 = ((($22)) + 56|0); //@line 68405 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 68405 "c/sqlite3.c"
   $38 = HEAP8[$37>>0]|0; //@line 68405 "c/sqlite3.c"
   $39 = $38 & -9; //@line 68405 "c/sqlite3.c"
   $40 = $39&255; //@line 68405 "c/sqlite3.c"
   _zeroPage($0,$40); //@line 68405 "c/sqlite3.c"
   $41 = ((($0)) + 56|0); //@line 68406 "c/sqlite3.c"
   $42 = HEAP32[$41>>2]|0; //@line 68406 "c/sqlite3.c"
   $43 = ((($0)) + 9|0); //@line 68406 "c/sqlite3.c"
   $44 = HEAP8[$43>>0]|0; //@line 68406 "c/sqlite3.c"
   $45 = $44&255; //@line 68406 "c/sqlite3.c"
   $46 = (($45) + 8)|0; //@line 68406 "c/sqlite3.c"
   $47 = (($42) + ($46)|0); //@line 68406 "c/sqlite3.c"
   $48 = HEAP32[$4>>2]|0; //@line 68406 "c/sqlite3.c"
   _sqlite3Put4byte($47,$48); //@line 68406 "c/sqlite3.c"
   $49 = HEAP32[$3>>2]|0; //@line 68408 "c/sqlite3.c"
   HEAP32[$1>>2] = $49; //@line 68408 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 68410 "c/sqlite3.c"
  } else {
   $50 = $$pr;
  }
 } else {
  $50 = $9;
 }
 HEAP32[$1>>2] = 0; //@line 68387 "c/sqlite3.c"
 $21 = HEAP32[$3>>2]|0; //@line 68388 "c/sqlite3.c"
 _releasePage($21); //@line 68388 "c/sqlite3.c"
 $$0 = $50;
 STACKTOP = sp;return ($$0|0); //@line 68410 "c/sqlite3.c"
}
function _balance_quick($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$1 = 0, $$add = 0, $$cast = 0, $$idx = 0, $$ptr = 0, $$ptr$le = 0, $$ptr43 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0;
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0;
 var $95 = 0, $96 = 0, $97 = 0, $or$cond = 0, $or$cond38 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp + 12|0;
 $4 = sp + 8|0;
 $5 = sp + 4|0;
 $6 = sp;
 $7 = sp + 16|0;
 $8 = ((($1)) + 52|0); //@line 67380 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 67380 "c/sqlite3.c"
 $10 = ((($1)) + 22|0); //@line 67390 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 67390 "c/sqlite3.c"
 $12 = ($11<<16>>16)==(0); //@line 67390 "c/sqlite3.c"
 if ($12) {
  $13 = (_sqlite3CorruptError(67390)|0); //@line 67390 "c/sqlite3.c"
  $$1 = $13;
  STACKTOP = sp;return ($$1|0); //@line 67461 "c/sqlite3.c"
 }
 $14 = (_allocateBtreePage($9,$3,$5,0,0)|0); //@line 67396 "c/sqlite3.c"
 HEAP32[$4>>2] = $14; //@line 67396 "c/sqlite3.c"
 $15 = ($14|0)==(0); //@line 67398 "c/sqlite3.c"
 if ($15) {
  $16 = ((($2)) + 4|0); //@line 67400 "c/sqlite3.c"
  $17 = ((($1)) + 36|0); //@line 67401 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 67401 "c/sqlite3.c"
  HEAP32[$6>>2] = $18; //@line 67401 "c/sqlite3.c"
  $19 = ((($1)) + 76|0); //@line 67402 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 67402 "c/sqlite3.c"
  $$cast = $18; //@line 67402 "c/sqlite3.c"
  $21 = (FUNCTION_TABLE_iii[$20 & 255]($1,$$cast)|0); //@line 67402 "c/sqlite3.c"
  HEAP16[$7>>1] = $21; //@line 67402 "c/sqlite3.c"
  $22 = HEAP32[$3>>2]|0; //@line 67407 "c/sqlite3.c"
  _zeroPage($22,13); //@line 67407 "c/sqlite3.c"
  $23 = (_rebuildPage($22,1,$6,$7)|0); //@line 67408 "c/sqlite3.c"
  HEAP32[$4>>2] = $23; //@line 67408 "c/sqlite3.c"
  $24 = ($23|0)==(0); //@line 67409 "c/sqlite3.c"
  if (!($24)) {
   $$1 = $23;
   STACKTOP = sp;return ($$1|0); //@line 67461 "c/sqlite3.c"
  }
  $25 = ((($9)) + 36|0); //@line 67410 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 67410 "c/sqlite3.c"
  $27 = ((($22)) + 18|0); //@line 67410 "c/sqlite3.c"
  $28 = HEAP16[$27>>1]|0; //@line 67410 "c/sqlite3.c"
  $29 = $28&65535; //@line 67410 "c/sqlite3.c"
  $30 = $21&65535; //@line 67410 "c/sqlite3.c"
  $31 = (65534 - ($30))|0; //@line 67410 "c/sqlite3.c"
  $32 = (($31) + ($26))|0; //@line 67410 "c/sqlite3.c"
  $33 = (($32) - ($29))|0; //@line 67410 "c/sqlite3.c"
  $34 = $33&65535; //@line 67410 "c/sqlite3.c"
  $35 = ((($22)) + 20|0); //@line 67410 "c/sqlite3.c"
  HEAP16[$35>>1] = $34; //@line 67410 "c/sqlite3.c"
  $36 = ((($9)) + 17|0); //@line 67421 "c/sqlite3.c"
  $37 = HEAP8[$36>>0]|0; //@line 67421 "c/sqlite3.c"
  $38 = ($37<<24>>24)==(0); //@line 67421 "c/sqlite3.c"
  if (!($38)) {
   $39 = HEAP32[$5>>2]|0; //@line 67422 "c/sqlite3.c"
   $40 = ((($0)) + 4|0); //@line 67422 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 67422 "c/sqlite3.c"
   _ptrmapPut($9,$39,5,$41,$4); //@line 67422 "c/sqlite3.c"
   $42 = ((($22)) + 16|0); //@line 67423 "c/sqlite3.c"
   $43 = HEAP16[$42>>1]|0; //@line 67423 "c/sqlite3.c"
   $44 = ($21&65535)>($43&65535); //@line 67423 "c/sqlite3.c"
   if ($44) {
    $45 = HEAP32[$6>>2]|0; //@line 67424 "c/sqlite3.c"
    _ptrmapPutOvflPtr($22,$45,$4); //@line 67424 "c/sqlite3.c"
   }
  }
  $46 = ((($1)) + 56|0); //@line 67441 "c/sqlite3.c"
  $47 = HEAP32[$46>>2]|0; //@line 67441 "c/sqlite3.c"
  $48 = ((($1)) + 24|0); //@line 67441 "c/sqlite3.c"
  $49 = HEAP16[$48>>1]|0; //@line 67441 "c/sqlite3.c"
  $50 = $49&65535; //@line 67441 "c/sqlite3.c"
  $51 = ((($1)) + 64|0); //@line 67441 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 67441 "c/sqlite3.c"
  $53 = HEAP16[$10>>1]|0; //@line 67441 "c/sqlite3.c"
  $54 = $53&65535; //@line 67441 "c/sqlite3.c"
  $55 = $54 << 1; //@line 67441 "c/sqlite3.c"
  $56 = (($55) + -2)|0; //@line 67441 "c/sqlite3.c"
  $57 = (($52) + ($56)|0); //@line 67441 "c/sqlite3.c"
  $58 = HEAP8[$57>>0]|0; //@line 67441 "c/sqlite3.c"
  $59 = $58&255; //@line 67441 "c/sqlite3.c"
  $60 = $59 << 8; //@line 67441 "c/sqlite3.c"
  $61 = ((($57)) + 1|0); //@line 67441 "c/sqlite3.c"
  $62 = HEAP8[$61>>0]|0; //@line 67441 "c/sqlite3.c"
  $63 = $62&255; //@line 67441 "c/sqlite3.c"
  $64 = $60 | $63; //@line 67441 "c/sqlite3.c"
  $65 = $64 & $50; //@line 67441 "c/sqlite3.c"
  $66 = (($47) + ($65)|0); //@line 67441 "c/sqlite3.c"
  HEAP32[$6>>2] = $66; //@line 67441 "c/sqlite3.c"
  $$idx = 0;
  while(1) {
   $$ptr = (($66) + ($$idx)|0); //@line 67401 "c/sqlite3.c"
   $$add = (($$idx) + 1)|0; //@line 67443 "c/sqlite3.c"
   $67 = HEAP8[$$ptr>>0]|0; //@line 67443 "c/sqlite3.c"
   $68 = ($67<<24>>24)<(0); //@line 67443 "c/sqlite3.c"
   $69 = ($$add>>>0)<(9); //@line 67443 "c/sqlite3.c"
   $or$cond = $69 & $68; //@line 67443 "c/sqlite3.c"
   if ($or$cond) {
    $$idx = $$add;
   } else {
    break;
   }
  }
  $$ptr$le = (($66) + ($$idx)|0); //@line 67401 "c/sqlite3.c"
  $$ptr43 = (($66) + ($$add)|0); //@line 67401 "c/sqlite3.c"
  HEAP32[$6>>2] = $$ptr43; //@line 67443 "c/sqlite3.c"
  $70 = ((($$ptr$le)) + 10|0); //@line 67444 "c/sqlite3.c"
  $$0 = $16;
  while(1) {
   $71 = HEAP32[$6>>2]|0; //@line 67445 "c/sqlite3.c"
   $72 = ((($71)) + 1|0); //@line 67445 "c/sqlite3.c"
   HEAP32[$6>>2] = $72; //@line 67445 "c/sqlite3.c"
   $73 = HEAP8[$71>>0]|0; //@line 67445 "c/sqlite3.c"
   $74 = ((($$0)) + 1|0); //@line 67445 "c/sqlite3.c"
   HEAP8[$$0>>0] = $73; //@line 67445 "c/sqlite3.c"
   $75 = ($73<<24>>24)<(0); //@line 67445 "c/sqlite3.c"
   $76 = HEAP32[$6>>2]|0; //@line 67445 "c/sqlite3.c"
   $77 = ($76>>>0)<($70>>>0); //@line 67445 "c/sqlite3.c"
   $or$cond38 = $75 & $77; //@line 67445 "c/sqlite3.c"
   if ($or$cond38) {
    $$0 = $74;
   } else {
    break;
   }
  }
  $78 = HEAP32[$4>>2]|0; //@line 67448 "c/sqlite3.c"
  $79 = ($78|0)==(0); //@line 67448 "c/sqlite3.c"
  if ($79) {
   $80 = ((($1)) + 4|0); //@line 67450 "c/sqlite3.c"
   $81 = $74; //@line 67449 "c/sqlite3.c"
   $82 = $2; //@line 67449 "c/sqlite3.c"
   $83 = (($81) - ($82))|0; //@line 67449 "c/sqlite3.c"
   $84 = ((($0)) + 22|0); //@line 67449 "c/sqlite3.c"
   $85 = HEAP16[$84>>1]|0; //@line 67449 "c/sqlite3.c"
   $86 = $85&65535; //@line 67449 "c/sqlite3.c"
   $87 = HEAP32[$80>>2]|0; //@line 67450 "c/sqlite3.c"
   _insertCell($0,$86,$2,$83,0,$87,$4); //@line 67449 "c/sqlite3.c"
  }
  $88 = ((($0)) + 56|0); //@line 67454 "c/sqlite3.c"
  $89 = HEAP32[$88>>2]|0; //@line 67454 "c/sqlite3.c"
  $90 = ((($0)) + 9|0); //@line 67454 "c/sqlite3.c"
  $91 = HEAP8[$90>>0]|0; //@line 67454 "c/sqlite3.c"
  $92 = $91&255; //@line 67454 "c/sqlite3.c"
  $93 = (($92) + 8)|0; //@line 67454 "c/sqlite3.c"
  $94 = (($89) + ($93)|0); //@line 67454 "c/sqlite3.c"
  $95 = HEAP32[$5>>2]|0; //@line 67454 "c/sqlite3.c"
  _sqlite3Put4byte($94,$95); //@line 67454 "c/sqlite3.c"
  $96 = HEAP32[$3>>2]|0; //@line 67457 "c/sqlite3.c"
  _releasePage($96); //@line 67457 "c/sqlite3.c"
 }
 $97 = HEAP32[$4>>2]|0; //@line 67460 "c/sqlite3.c"
 $$1 = $97;
 STACKTOP = sp;return ($$1|0); //@line 67461 "c/sqlite3.c"
}
function _balance_nonroot($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$0540 = 0, $$0541 = 0, $$0542 = 0, $$0543769 = 0, $$0544$lcssa806808 = 0, $$0544711 = 0, $$0545 = 0, $$0546 = 0, $$0547 = 0, $$0548 = 0, $$0552747 = 0, $$0556687 = 0, $$0558686 = 0, $$0561752 = 0, $$0567685 = 0, $$0569684 = 0, $$0571683 = 0, $$0574 = 0, $$0576$lcssa = 0;
 var $$0576691 = 0, $$0578 = 0, $$0579 = 0, $$0579$in = 0, $$0580 = 0, $$0582 = 0, $$0584 = 0, $$0586763 = 0, $$0591679 = 0, $$0592 = 0, $$0603$lcssa804 = 0, $$0603746 = 0, $$1 = 0, $$10680 = 0, $$11675 = 0, $$12672 = 0, $$13669 = 0, $$14665 = 0, $$1549$lcssa = 0, $$1549768 = 0;
 var $$1553738 = 0, $$1557 = 0, $$1559 = 0, $$1562$lcssa = 0, $$1562732 = 0, $$15664 = 0, $$1568 = 0, $$1570 = 0, $$1572 = 0, $$1575 = 0, $$1581 = 0, $$1583 = 0, $$1585 = 0, $$1587759 = 0, $$1604 = 0, $$2$ph = 0, $$2550764 = 0, $$2554701 = 0, $$2560$ph = 0, $$2563$lcssa = 0;
 var $$2563720 = 0, $$2573$ph = 0, $$2588 = 0, $$2605755 = 0, $$3 = 0, $$3551742 = 0, $$3555692 = 0, $$3564 = 0, $$4590$ph = 0, $$4733 = 0, $$5566$ph = 0, $$5716 = 0, $$6710 = 0, $$7705 = 0, $$8696 = 0, $$9688 = 0, $$cast = 0, $$cast639 = 0, $$in = 0, $$lcssa657 = 0;
 var $$neg640 = 0, $$neg642 = 0, $$neg644 = 0, $$pn = 0, $$promoted = 0, $$promoted774 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0;
 var $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0;
 var $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0;
 var $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0;
 var $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0;
 var $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0;
 var $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0;
 var $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0;
 var $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0;
 var $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0;
 var $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0;
 var $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0;
 var $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0;
 var $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0;
 var $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0;
 var $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0;
 var $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0;
 var $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0;
 var $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0;
 var $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0, $60 = 0, $600 = 0;
 var $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0, $618 = 0, $619 = 0;
 var $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0, $636 = 0, $637 = 0;
 var $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0, $654 = 0, $655 = 0;
 var $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0, $672 = 0, $673 = 0;
 var $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0, $690 = 0, $691 = 0;
 var $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0, $708 = 0, $709 = 0;
 var $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0, $726 = 0, $727 = 0;
 var $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0, $744 = 0, $745 = 0;
 var $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0, $762 = 0, $763 = 0;
 var $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $exitcond798 = 0, $exitcond799 = 0, $exitcond800 = 0, $exitcond801 = 0;
 var $exitcond802 = 0, $exitcond803 = 0, $or$cond = 0, $or$cond3$not = 0, $or$cond618 = 0, $or$cond619$not = 0, $or$cond621 = 0, $or$cond778 = 0, $scevgep = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 208|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(208|0);
 $5 = sp + 184|0;
 $6 = sp + 172|0;
 $7 = sp + 152|0;
 $8 = sp + 144|0;
 $9 = sp + 124|0;
 $10 = sp + 104|0;
 $11 = sp + 84|0;
 $12 = sp + 80|0;
 $13 = sp + 198|0;
 $14 = sp + 60|0;
 $15 = sp + 40|0;
 $16 = sp + 188|0;
 $17 = sp + 24|0;
 $18 = sp;
 HEAP32[$5>>2] = 0; //@line 67617 "c/sqlite3.c"
 ;HEAP8[$13>>0]=0|0;HEAP8[$13+1>>0]=0|0;HEAP8[$13+2>>0]=0|0;HEAP8[$13+3>>0]=0|0;HEAP8[$13+4>>0]=0|0; //@line 67640 "c/sqlite3.c"
 HEAP32[$17>>2] = 0; //@line 67641 "c/sqlite3.c"
 $19 = ((($17)) + 8|0); //@line 67642 "c/sqlite3.c"
 HEAP32[$19>>2] = 0; //@line 67642 "c/sqlite3.c"
 $20 = ((($0)) + 52|0); //@line 67643 "c/sqlite3.c"
 $21 = HEAP32[$20>>2]|0; //@line 67643 "c/sqlite3.c"
 $22 = ($2|0)==(0|0); //@line 67659 "c/sqlite3.c"
 if ($22) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 68343 "c/sqlite3.c"
 }
 $23 = ((($0)) + 12|0); //@line 67674 "c/sqlite3.c"
 $24 = HEAP8[$23>>0]|0; //@line 67674 "c/sqlite3.c"
 $25 = $24&255; //@line 67674 "c/sqlite3.c"
 $26 = ((($0)) + 22|0); //@line 67674 "c/sqlite3.c"
 $27 = HEAP16[$26>>1]|0; //@line 67674 "c/sqlite3.c"
 $28 = $27&65535; //@line 67674 "c/sqlite3.c"
 $29 = (($28) + ($25))|0; //@line 67674 "c/sqlite3.c"
 $30 = ($29>>>0)<(2); //@line 67675 "c/sqlite3.c"
 if ($30) {
  $$0548 = $29;$$1575 = 0;
 } else {
  $31 = ($1|0)==(0); //@line 67679 "c/sqlite3.c"
  do {
   if ($31) {
    $$0574 = 0;
   } else {
    $32 = ($29|0)==($1|0); //@line 67681 "c/sqlite3.c"
    if ($32) {
     $33 = (($4) + -2)|0; //@line 67682 "c/sqlite3.c"
     $34 = (($33) + ($29))|0; //@line 67682 "c/sqlite3.c"
     $$0574 = $34;
     break;
    } else {
     $35 = (($1) + -1)|0; //@line 67684 "c/sqlite3.c"
     $$0574 = $35;
     break;
    }
   }
  } while(0);
  $36 = (2 - ($4))|0; //@line 67686 "c/sqlite3.c"
  $$0548 = $36;$$1575 = $$0574;
 }
 $37 = (($$0548) + 1)|0; //@line 67688 "c/sqlite3.c"
 $38 = (($$1575) - ($25))|0; //@line 67689 "c/sqlite3.c"
 $39 = (($38) + ($$0548))|0; //@line 67689 "c/sqlite3.c"
 $40 = ($39|0)==($28|0); //@line 67689 "c/sqlite3.c"
 $41 = ((($0)) + 56|0);
 $42 = HEAP32[$41>>2]|0;
 if ($40) {
  $43 = ((($0)) + 9|0); //@line 67690 "c/sqlite3.c"
  $44 = HEAP8[$43>>0]|0; //@line 67690 "c/sqlite3.c"
  $45 = $44&255; //@line 67690 "c/sqlite3.c"
  $46 = (($45) + 8)|0; //@line 67690 "c/sqlite3.c"
  $$pn = $46;
 } else {
  $47 = ((($0)) + 24|0); //@line 67692 "c/sqlite3.c"
  $48 = HEAP16[$47>>1]|0; //@line 67692 "c/sqlite3.c"
  $49 = $48&65535; //@line 67692 "c/sqlite3.c"
  $50 = ((($0)) + 64|0); //@line 67692 "c/sqlite3.c"
  $51 = HEAP32[$50>>2]|0; //@line 67692 "c/sqlite3.c"
  $52 = $39 << 1; //@line 67692 "c/sqlite3.c"
  $53 = (($51) + ($52)|0); //@line 67692 "c/sqlite3.c"
  $54 = HEAP8[$53>>0]|0; //@line 67692 "c/sqlite3.c"
  $55 = $54&255; //@line 67692 "c/sqlite3.c"
  $56 = $55 << 8; //@line 67692 "c/sqlite3.c"
  $57 = ((($53)) + 1|0); //@line 67692 "c/sqlite3.c"
  $58 = HEAP8[$57>>0]|0; //@line 67692 "c/sqlite3.c"
  $59 = $58&255; //@line 67692 "c/sqlite3.c"
  $60 = $56 | $59; //@line 67692 "c/sqlite3.c"
  $61 = $60 & $49; //@line 67692 "c/sqlite3.c"
  $$pn = $61;
 }
 $$0592 = (($42) + ($$pn)|0);
 $62 = (_sqlite3Get4byte($$0592)|0); //@line 67694 "c/sqlite3.c"
 HEAP32[$12>>2] = $62; //@line 67694 "c/sqlite3.c"
 $63 = (($6) + ($$0548<<2)|0); //@line 67696 "c/sqlite3.c"
 $64 = (_getAndInitPage($21,$62,$63,0,0)|0); //@line 67696 "c/sqlite3.c"
 HEAP32[$5>>2] = $64; //@line 67696 "c/sqlite3.c"
 $65 = ($64|0)==(0); //@line 67697 "c/sqlite3.c"
 L17: do {
  if ($65) {
   $66 = ((($0)) + 24|0);
   $67 = ((($0)) + 64|0);
   $68 = ((($0)) + 76|0);
   $69 = ((($21)) + 22|0);
   $70 = ((($0)) + 26|0);
   $71 = ((($21)) + 36|0);
   $72 = ((($0)) + 36|0);
   $73 = ((($0)) + 76|0);
   $$promoted774 = HEAP32[$12>>2]|0; //@line 67711 "c/sqlite3.c"
   $$0543769 = 0;$$1549768 = $$0548;$149 = $$promoted774;$78 = $63;
   while(1) {
    $77 = HEAP32[$78>>2]|0; //@line 67701 "c/sqlite3.c"
    $79 = ((($77)) + 22|0); //@line 67701 "c/sqlite3.c"
    $80 = HEAP16[$79>>1]|0; //@line 67701 "c/sqlite3.c"
    $81 = $80&65535; //@line 67701 "c/sqlite3.c"
    $82 = ((($77)) + 12|0); //@line 67701 "c/sqlite3.c"
    $83 = HEAP8[$82>>0]|0; //@line 67701 "c/sqlite3.c"
    $84 = $83&255; //@line 67701 "c/sqlite3.c"
    $85 = (($$0543769) + 1)|0; //@line 67701 "c/sqlite3.c"
    $86 = (($85) + ($81))|0; //@line 67701 "c/sqlite3.c"
    $87 = (($86) + ($84))|0; //@line 67701 "c/sqlite3.c"
    $88 = (($$1549768) + -1)|0; //@line 67702 "c/sqlite3.c"
    $89 = ($$1549768|0)==(0); //@line 67702 "c/sqlite3.c"
    if ($89) {
     label = 25;
     break;
    }
    $90 = HEAP8[$23>>0]|0; //@line 67704 "c/sqlite3.c"
    $91 = ($90<<24>>24)==(0); //@line 67704 "c/sqlite3.c"
    if ($91) {
     label = 19;
    } else {
     $92 = (($88) + ($$1575))|0; //@line 67704 "c/sqlite3.c"
     $93 = HEAP16[$70>>1]|0; //@line 67704 "c/sqlite3.c"
     $94 = $93&65535; //@line 67704 "c/sqlite3.c"
     $95 = ($92|0)==($94|0); //@line 67704 "c/sqlite3.c"
     if ($95) {
      $96 = HEAP32[$72>>2]|0; //@line 67705 "c/sqlite3.c"
      $97 = (($8) + ($88<<2)|0); //@line 67705 "c/sqlite3.c"
      HEAP32[$97>>2] = $96; //@line 67705 "c/sqlite3.c"
      $98 = (_sqlite3Get4byte($96)|0); //@line 67706 "c/sqlite3.c"
      $99 = HEAP32[$73>>2]|0; //@line 67707 "c/sqlite3.c"
      $100 = (FUNCTION_TABLE_iii[$99 & 255]($0,$96)|0); //@line 67707 "c/sqlite3.c"
      $101 = $100&65535; //@line 67707 "c/sqlite3.c"
      $102 = (($11) + ($88<<2)|0); //@line 67707 "c/sqlite3.c"
      HEAP32[$102>>2] = $101; //@line 67707 "c/sqlite3.c"
      HEAP8[$23>>0] = 0; //@line 67708 "c/sqlite3.c"
      $74 = $98;
     } else {
      label = 19;
     }
    }
    if ((label|0) == 19) {
     label = 0;
     $103 = HEAP32[$41>>2]|0; //@line 67710 "c/sqlite3.c"
     $104 = HEAP16[$66>>1]|0; //@line 67710 "c/sqlite3.c"
     $105 = $104&65535; //@line 67710 "c/sqlite3.c"
     $106 = HEAP32[$67>>2]|0; //@line 67710 "c/sqlite3.c"
     $107 = (($88) + ($$1575))|0; //@line 67710 "c/sqlite3.c"
     $108 = $90&255; //@line 67710 "c/sqlite3.c"
     $109 = (($107) - ($108))|0; //@line 67710 "c/sqlite3.c"
     $110 = $109 << 1; //@line 67710 "c/sqlite3.c"
     $111 = (($106) + ($110)|0); //@line 67710 "c/sqlite3.c"
     $112 = HEAP8[$111>>0]|0; //@line 67710 "c/sqlite3.c"
     $113 = $112&255; //@line 67710 "c/sqlite3.c"
     $114 = $113 << 8; //@line 67710 "c/sqlite3.c"
     $115 = ((($111)) + 1|0); //@line 67710 "c/sqlite3.c"
     $116 = HEAP8[$115>>0]|0; //@line 67710 "c/sqlite3.c"
     $117 = $116&255; //@line 67710 "c/sqlite3.c"
     $118 = $114 | $117; //@line 67710 "c/sqlite3.c"
     $119 = $118 & $105; //@line 67710 "c/sqlite3.c"
     $120 = (($103) + ($119)|0); //@line 67710 "c/sqlite3.c"
     $121 = (($8) + ($88<<2)|0); //@line 67710 "c/sqlite3.c"
     HEAP32[$121>>2] = $120; //@line 67710 "c/sqlite3.c"
     $122 = (_sqlite3Get4byte($120)|0); //@line 67711 "c/sqlite3.c"
     $123 = HEAP32[$68>>2]|0; //@line 67712 "c/sqlite3.c"
     $124 = (FUNCTION_TABLE_iii[$123 & 255]($0,$120)|0); //@line 67712 "c/sqlite3.c"
     $125 = $124&65535; //@line 67712 "c/sqlite3.c"
     $126 = (($11) + ($88<<2)|0); //@line 67712 "c/sqlite3.c"
     HEAP32[$126>>2] = $125; //@line 67712 "c/sqlite3.c"
     $127 = HEAP16[$69>>1]|0; //@line 67726 "c/sqlite3.c"
     $128 = $127 & 12; //@line 67726 "c/sqlite3.c"
     $129 = ($128<<16>>16)==(0); //@line 67726 "c/sqlite3.c"
     if (!($129)) {
      $130 = $120; //@line 67729 "c/sqlite3.c"
      $131 = HEAP32[$41>>2]|0; //@line 67729 "c/sqlite3.c"
      $132 = (($130) - ($131))|0; //@line 67729 "c/sqlite3.c"
      $133 = (($132) + ($125))|0; //@line 67730 "c/sqlite3.c"
      $134 = HEAP32[$71>>2]|0; //@line 67730 "c/sqlite3.c"
      $135 = ($133|0)>($134|0); //@line 67730 "c/sqlite3.c"
      if ($135) {
       label = 22;
       break;
      }
      $136 = (($2) + ($132)|0); //@line 67735 "c/sqlite3.c"
      _memcpy(($136|0),($120|0),($125|0))|0; //@line 67735 "c/sqlite3.c"
      $137 = HEAP32[$121>>2]|0; //@line 67736 "c/sqlite3.c"
      $138 = HEAP32[$41>>2]|0; //@line 67736 "c/sqlite3.c"
      $139 = (($137) - ($138))|0; //@line 67736 "c/sqlite3.c"
      $140 = (($2) + ($139)|0); //@line 67736 "c/sqlite3.c"
      HEAP32[$121>>2] = $140; //@line 67736 "c/sqlite3.c"
     }
     $143 = HEAP8[$23>>0]|0; //@line 67739 "c/sqlite3.c"
     $144 = $143&255; //@line 67739 "c/sqlite3.c"
     $145 = (($107) - ($144))|0; //@line 67739 "c/sqlite3.c"
     _dropCell($0,$145,$125,$5); //@line 67739 "c/sqlite3.c"
     $74 = $122;
    }
    $146 = (($6) + ($88<<2)|0); //@line 67696 "c/sqlite3.c"
    $147 = (_getAndInitPage($21,$74,$146,0,0)|0); //@line 67696 "c/sqlite3.c"
    HEAP32[$5>>2] = $147; //@line 67696 "c/sqlite3.c"
    $148 = ($147|0)==(0); //@line 67697 "c/sqlite3.c"
    if ($148) {
     $$0543769 = $87;$$1549768 = $88;$149 = $74;$78 = $146;
    } else {
     label = 13;
     break;
    }
   }
   if ((label|0) == 13) {
    HEAP32[$12>>2] = $74; //@line 67711 "c/sqlite3.c"
    $$1549$lcssa = $88;
    label = 14;
    break;
   }
   else if ((label|0) == 22) {
    HEAP32[$12>>2] = $122; //@line 67711 "c/sqlite3.c"
    $141 = (_sqlite3CorruptError(67731)|0); //@line 67731 "c/sqlite3.c"
    HEAP32[$5>>2] = $141; //@line 67731 "c/sqlite3.c"
    $142 = $$1549768 << 2; //@line 67732 "c/sqlite3.c"
    _memset(($6|0),0,($142|0))|0; //@line 67732 "c/sqlite3.c"
    $$3 = 0;
    break;
   }
   else if ((label|0) == 25) {
    HEAP32[$12>>2] = $149; //@line 67711 "c/sqlite3.c"
    $150 = (($87) + 3)|0; //@line 67745 "c/sqlite3.c"
    $151 = $150 & -4; //@line 67745 "c/sqlite3.c"
    $152 = ($151*6)|0; //@line 67752 "c/sqlite3.c"
    $153 = ((($21)) + 32|0); //@line 67753 "c/sqlite3.c"
    $154 = HEAP32[$153>>2]|0; //@line 67753 "c/sqlite3.c"
    $155 = (($154) + ($152))|0; //@line 67753 "c/sqlite3.c"
    $156 = ($155|0)<(0); //@line 67756 "c/sqlite3.c"
    $157 = $156 << 31 >> 31; //@line 67756 "c/sqlite3.c"
    $158 = (_sqlite3DbMallocRaw(0,$155,$157)|0); //@line 67756 "c/sqlite3.c"
    HEAP32[$19>>2] = $158; //@line 67756 "c/sqlite3.c"
    $159 = ($158|0)==(0|0); //@line 67757 "c/sqlite3.c"
    if ($159) {
     HEAP32[$5>>2] = 7; //@line 67758 "c/sqlite3.c"
     $$3 = 0;
     break;
    }
    $160 = (($158) + ($151<<2)|0); //@line 67761 "c/sqlite3.c"
    $161 = ((($17)) + 12|0); //@line 67761 "c/sqlite3.c"
    HEAP32[$161>>2] = $160; //@line 67761 "c/sqlite3.c"
    $162 = (($160) + ($151<<1)|0); //@line 67762 "c/sqlite3.c"
    $163 = HEAP32[$6>>2]|0; //@line 67781 "c/sqlite3.c"
    $164 = ((($17)) + 4|0); //@line 67781 "c/sqlite3.c"
    HEAP32[$164>>2] = $163; //@line 67781 "c/sqlite3.c"
    $165 = ((($163)) + 8|0); //@line 67782 "c/sqlite3.c"
    $166 = HEAP8[$165>>0]|0; //@line 67782 "c/sqlite3.c"
    $167 = $166&255; //@line 67782 "c/sqlite3.c"
    $168 = $167 << 2; //@line 67782 "c/sqlite3.c"
    $169 = $168&65535; //@line 67782 "c/sqlite3.c"
    $170 = ((($163)) + 3|0); //@line 67783 "c/sqlite3.c"
    $171 = HEAP8[$170>>0]|0; //@line 67783 "c/sqlite3.c"
    $172 = $171&255; //@line 67783 "c/sqlite3.c"
    $173 = ($$0548|0)<(0); //@line 67784 "c/sqlite3.c"
    L37: do {
     if ($173) {
      $174 = ((($21)) + 36|0); //@line 67890 "c/sqlite3.c"
      $175 = HEAP32[$174>>2]|0; //@line 67890 "c/sqlite3.c"
      $176 = (($168) + -12)|0; //@line 67890 "c/sqlite3.c"
      $177 = (($176) + ($175))|0; //@line 67890 "c/sqlite3.c"
      $$1562$lcssa = $37;$573 = $174;$728 = $177;
     } else {
      $178 = ((($163)) + 56|0);
      $179 = ($171<<24>>24)!=(0);
      $$0586763 = 0;$$2550764 = 0;
      while(1) {
       $180 = (($6) + ($$2550764<<2)|0); //@line 67785 "c/sqlite3.c"
       $181 = HEAP32[$180>>2]|0; //@line 67785 "c/sqlite3.c"
       $182 = ((($181)) + 22|0); //@line 67786 "c/sqlite3.c"
       $183 = ((($181)) + 56|0); //@line 67787 "c/sqlite3.c"
       $184 = HEAP32[$183>>2]|0; //@line 67787 "c/sqlite3.c"
       $185 = ((($181)) + 24|0); //@line 67788 "c/sqlite3.c"
       $186 = HEAP16[$185>>1]|0; //@line 67788 "c/sqlite3.c"
       $187 = ((($181)) + 18|0); //@line 67789 "c/sqlite3.c"
       $188 = HEAP16[$187>>1]|0; //@line 67789 "c/sqlite3.c"
       $189 = $188&65535; //@line 67789 "c/sqlite3.c"
       $190 = (($184) + ($189)|0); //@line 67789 "c/sqlite3.c"
       $191 = HEAP8[$184>>0]|0; //@line 67795 "c/sqlite3.c"
       $192 = HEAP32[$178>>2]|0; //@line 67795 "c/sqlite3.c"
       $193 = HEAP8[$192>>0]|0; //@line 67795 "c/sqlite3.c"
       $194 = ($191<<24>>24)==($193<<24>>24); //@line 67795 "c/sqlite3.c"
       if (!($194)) {
        label = 50;
        break;
       }
       $195 = HEAP16[$182>>1]|0; //@line 67786 "c/sqlite3.c"
       $196 = $195&65535; //@line 67786 "c/sqlite3.c"
       $197 = HEAP32[$161>>2]|0; //@line 67817 "c/sqlite3.c"
       $198 = HEAP32[$17>>2]|0; //@line 67817 "c/sqlite3.c"
       $199 = (($197) + ($198<<1)|0); //@line 67817 "c/sqlite3.c"
       $200 = ((($181)) + 12|0); //@line 67817 "c/sqlite3.c"
       $201 = HEAP8[$200>>0]|0; //@line 67817 "c/sqlite3.c"
       $202 = $201&255; //@line 67817 "c/sqlite3.c"
       $203 = (($202) + ($196))|0; //@line 67817 "c/sqlite3.c"
       $204 = $203 << 1; //@line 67817 "c/sqlite3.c"
       _memset(($199|0),0,($204|0))|0; //@line 67817 "c/sqlite3.c"
       $205 = HEAP8[$200>>0]|0; //@line 67818 "c/sqlite3.c"
       $206 = ($205<<24>>24)==(0); //@line 67818 "c/sqlite3.c"
       do {
        if ($206) {
         $$1604 = $190;
        } else {
         $207 = ((($181)) + 26|0); //@line 67819 "c/sqlite3.c"
         $208 = HEAP16[$207>>1]|0; //@line 67819 "c/sqlite3.c"
         $209 = $208&65535; //@line 67819 "c/sqlite3.c"
         $210 = ($208<<16>>16)==(0); //@line 67820 "c/sqlite3.c"
         if ($210) {
          $211 = $205&255; //@line 67825 "c/sqlite3.c"
          $$0603$lcssa804 = $190;$239 = $211;
         } else {
          $212 = $186&65535;
          $213 = $209 << 1; //@line 67820 "c/sqlite3.c"
          $214 = (($213) + ($189))|0; //@line 67820 "c/sqlite3.c"
          $$0552747 = 0;$$0603746 = $190;
          while(1) {
           $215 = HEAP8[$$0603746>>0]|0; //@line 67821 "c/sqlite3.c"
           $216 = $215&255; //@line 67821 "c/sqlite3.c"
           $217 = $216 << 8; //@line 67821 "c/sqlite3.c"
           $218 = ((($$0603746)) + 1|0); //@line 67821 "c/sqlite3.c"
           $219 = HEAP8[$218>>0]|0; //@line 67821 "c/sqlite3.c"
           $220 = $219&255; //@line 67821 "c/sqlite3.c"
           $221 = $217 | $220; //@line 67821 "c/sqlite3.c"
           $222 = $221 & $212; //@line 67821 "c/sqlite3.c"
           $223 = (($184) + ($222)|0); //@line 67821 "c/sqlite3.c"
           $224 = HEAP32[$19>>2]|0; //@line 67821 "c/sqlite3.c"
           $225 = HEAP32[$17>>2]|0; //@line 67821 "c/sqlite3.c"
           $226 = (($224) + ($225<<2)|0); //@line 67821 "c/sqlite3.c"
           HEAP32[$226>>2] = $223; //@line 67821 "c/sqlite3.c"
           $227 = ((($$0603746)) + 2|0); //@line 67822 "c/sqlite3.c"
           $228 = (($225) + 1)|0; //@line 67823 "c/sqlite3.c"
           HEAP32[$17>>2] = $228; //@line 67823 "c/sqlite3.c"
           $229 = (($$0552747) + 1)|0; //@line 67820 "c/sqlite3.c"
           $exitcond802 = ($229|0)==($209|0); //@line 67820 "c/sqlite3.c"
           if ($exitcond802) {
            break;
           } else {
            $$0552747 = $229;$$0603746 = $227;
           }
          }
          $scevgep = (($184) + ($214)|0); //@line 67820 "c/sqlite3.c"
          $230 = $205&255; //@line 67825 "c/sqlite3.c"
          $231 = ($205<<24>>24)==(0); //@line 67825 "c/sqlite3.c"
          if ($231) {
           $$1604 = $scevgep;
           break;
          } else {
           $$0603$lcssa804 = $scevgep;$239 = $230;
          }
         }
         $$promoted = HEAP32[$17>>2]|0; //@line 67828 "c/sqlite3.c"
         $$0561752 = 0;$236 = $$promoted;
         while(1) {
          $232 = (((($181)) + 36|0) + ($$0561752<<2)|0); //@line 67827 "c/sqlite3.c"
          $233 = HEAP32[$232>>2]|0; //@line 67827 "c/sqlite3.c"
          $234 = HEAP32[$19>>2]|0; //@line 67827 "c/sqlite3.c"
          $235 = (($234) + ($236<<2)|0); //@line 67827 "c/sqlite3.c"
          HEAP32[$235>>2] = $233; //@line 67827 "c/sqlite3.c"
          $237 = (($236) + 1)|0; //@line 67828 "c/sqlite3.c"
          $238 = (($$0561752) + 1)|0; //@line 67825 "c/sqlite3.c"
          $exitcond803 = ($238|0)==($239|0); //@line 67825 "c/sqlite3.c"
          if ($exitcond803) {
           break;
          } else {
           $$0561752 = $238;$236 = $237;
          }
         }
         $240 = (($$promoted) + ($239))|0; //@line 67825 "c/sqlite3.c"
         HEAP32[$17>>2] = $240; //@line 67828 "c/sqlite3.c"
         $$1604 = $$0603$lcssa804;
        }
       } while(0);
       $241 = HEAP16[$187>>1]|0; //@line 67831 "c/sqlite3.c"
       $242 = $241&65535; //@line 67831 "c/sqlite3.c"
       $243 = (($184) + ($242)|0); //@line 67831 "c/sqlite3.c"
       $244 = HEAP16[$182>>1]|0; //@line 67831 "c/sqlite3.c"
       $245 = $244&65535; //@line 67831 "c/sqlite3.c"
       $246 = $245 << 1; //@line 67831 "c/sqlite3.c"
       $247 = (($243) + ($246)|0); //@line 67831 "c/sqlite3.c"
       $248 = ($$1604>>>0)<($247>>>0); //@line 67832 "c/sqlite3.c"
       if ($248) {
        $249 = $186&65535;
        $$2605755 = $$1604;
        while(1) {
         $250 = HEAP8[$$2605755>>0]|0; //@line 67834 "c/sqlite3.c"
         $251 = $250&255; //@line 67834 "c/sqlite3.c"
         $252 = $251 << 8; //@line 67834 "c/sqlite3.c"
         $253 = ((($$2605755)) + 1|0); //@line 67834 "c/sqlite3.c"
         $254 = HEAP8[$253>>0]|0; //@line 67834 "c/sqlite3.c"
         $255 = $254&255; //@line 67834 "c/sqlite3.c"
         $256 = $252 | $255; //@line 67834 "c/sqlite3.c"
         $257 = $256 & $249; //@line 67834 "c/sqlite3.c"
         $258 = (($184) + ($257)|0); //@line 67834 "c/sqlite3.c"
         $259 = HEAP32[$19>>2]|0; //@line 67834 "c/sqlite3.c"
         $260 = HEAP32[$17>>2]|0; //@line 67834 "c/sqlite3.c"
         $261 = (($259) + ($260<<2)|0); //@line 67834 "c/sqlite3.c"
         HEAP32[$261>>2] = $258; //@line 67834 "c/sqlite3.c"
         $262 = ((($$2605755)) + 2|0); //@line 67835 "c/sqlite3.c"
         $263 = (($260) + 1)|0; //@line 67836 "c/sqlite3.c"
         HEAP32[$17>>2] = $263; //@line 67836 "c/sqlite3.c"
         $264 = ($262>>>0)<($247>>>0); //@line 67832 "c/sqlite3.c"
         if ($264) {
          $$2605755 = $262;
         } else {
          break;
         }
        }
       }
       $265 = HEAP32[$17>>2]|0; //@line 67839 "c/sqlite3.c"
       $266 = (($10) + ($$2550764<<2)|0); //@line 67839 "c/sqlite3.c"
       HEAP32[$266>>2] = $265; //@line 67839 "c/sqlite3.c"
       $267 = ($$2550764|0)>=($$0548|0); //@line 67840 "c/sqlite3.c"
       $or$cond = $179 | $267; //@line 67840 "c/sqlite3.c"
       if ($or$cond) {
        $$4590$ph = $$0586763;
       } else {
        $268 = (($11) + ($$2550764<<2)|0); //@line 67841 "c/sqlite3.c"
        $269 = HEAP32[$268>>2]|0; //@line 67841 "c/sqlite3.c"
        $270 = $269&65535; //@line 67841 "c/sqlite3.c"
        $271 = HEAP32[$161>>2]|0; //@line 67844 "c/sqlite3.c"
        $272 = (($271) + ($265<<1)|0); //@line 67844 "c/sqlite3.c"
        HEAP16[$272>>1] = $270; //@line 67844 "c/sqlite3.c"
        $273 = (($162) + ($$0586763)|0); //@line 67845 "c/sqlite3.c"
        $274 = $269 & 65535; //@line 67846 "c/sqlite3.c"
        $275 = (($274) + ($$0586763))|0; //@line 67846 "c/sqlite3.c"
        $276 = (($8) + ($$2550764<<2)|0); //@line 67849 "c/sqlite3.c"
        $277 = HEAP32[$276>>2]|0; //@line 67849 "c/sqlite3.c"
        _memcpy(($273|0),($277|0),($274|0))|0; //@line 67849 "c/sqlite3.c"
        $278 = (($273) + ($168)|0); //@line 67850 "c/sqlite3.c"
        $279 = HEAP32[$19>>2]|0; //@line 67850 "c/sqlite3.c"
        $280 = HEAP32[$17>>2]|0; //@line 67850 "c/sqlite3.c"
        $281 = (($279) + ($280<<2)|0); //@line 67850 "c/sqlite3.c"
        HEAP32[$281>>2] = $278; //@line 67850 "c/sqlite3.c"
        $282 = HEAP32[$161>>2]|0; //@line 67852 "c/sqlite3.c"
        $283 = (($282) + ($280<<1)|0); //@line 67852 "c/sqlite3.c"
        $284 = HEAP16[$283>>1]|0; //@line 67852 "c/sqlite3.c"
        $285 = $284&65535; //@line 67852 "c/sqlite3.c"
        $286 = (($285) - ($168))|0; //@line 67852 "c/sqlite3.c"
        $287 = $286&65535; //@line 67852 "c/sqlite3.c"
        HEAP16[$283>>1] = $287; //@line 67852 "c/sqlite3.c"
        $288 = ((($181)) + 8|0); //@line 67853 "c/sqlite3.c"
        $289 = HEAP8[$288>>0]|0; //@line 67853 "c/sqlite3.c"
        $290 = ($289<<24>>24)==(0); //@line 67853 "c/sqlite3.c"
        if ($290) {
         $291 = HEAP32[$19>>2]|0; //@line 67858 "c/sqlite3.c"
         $292 = (($291) + ($280<<2)|0); //@line 67858 "c/sqlite3.c"
         $293 = HEAP32[$292>>2]|0; //@line 67858 "c/sqlite3.c"
         $294 = HEAP32[$183>>2]|0; //@line 67858 "c/sqlite3.c"
         $295 = ((($294)) + 8|0); //@line 67858 "c/sqlite3.c"
         $296 = HEAPU8[$295>>0]|(HEAPU8[$295+1>>0]<<8)|(HEAPU8[$295+2>>0]<<16)|(HEAPU8[$295+3>>0]<<24); //@line 67858 "c/sqlite3.c"
         HEAP8[$293>>0]=$296&255;HEAP8[$293+1>>0]=($296>>8)&255;HEAP8[$293+2>>0]=($296>>16)&255;HEAP8[$293+3>>0]=$296>>24; //@line 67858 "c/sqlite3.c"
         $$2588 = $275;
        } else {
         $297 = HEAP32[$161>>2]|0; //@line 67861 "c/sqlite3.c"
         $298 = HEAP32[$17>>2]|0; //@line 67861 "c/sqlite3.c"
         $299 = (($297) + ($298<<1)|0); //@line 67861 "c/sqlite3.c"
         $300 = HEAP16[$299>>1]|0; //@line 67861 "c/sqlite3.c"
         $301 = ($300&65535)<(4); //@line 67861 "c/sqlite3.c"
         if ($301) {
          $$1587759 = $275;
          while(1) {
           $302 = (($$1587759) + 1)|0; //@line 67866 "c/sqlite3.c"
           $303 = (($162) + ($$1587759)|0); //@line 67866 "c/sqlite3.c"
           HEAP8[$303>>0] = 0; //@line 67866 "c/sqlite3.c"
           $304 = HEAP32[$161>>2]|0; //@line 67867 "c/sqlite3.c"
           $305 = HEAP32[$17>>2]|0; //@line 67867 "c/sqlite3.c"
           $306 = (($304) + ($305<<1)|0); //@line 67867 "c/sqlite3.c"
           $307 = HEAP16[$306>>1]|0; //@line 67867 "c/sqlite3.c"
           $308 = (($307) + 1)<<16>>16; //@line 67867 "c/sqlite3.c"
           HEAP16[$306>>1] = $308; //@line 67867 "c/sqlite3.c"
           $309 = HEAP32[$161>>2]|0; //@line 67861 "c/sqlite3.c"
           $310 = HEAP32[$17>>2]|0; //@line 67861 "c/sqlite3.c"
           $311 = (($309) + ($310<<1)|0); //@line 67861 "c/sqlite3.c"
           $312 = HEAP16[$311>>1]|0; //@line 67861 "c/sqlite3.c"
           $313 = ($312&65535)<(4); //@line 67861 "c/sqlite3.c"
           if ($313) {
            $$1587759 = $302;
           } else {
            $$2588 = $302;
            break;
           }
          }
         } else {
          $$2588 = $275;
         }
        }
        $314 = HEAP32[$17>>2]|0; //@line 67870 "c/sqlite3.c"
        $315 = (($314) + 1)|0; //@line 67870 "c/sqlite3.c"
        HEAP32[$17>>2] = $315; //@line 67870 "c/sqlite3.c"
        $$4590$ph = $$2588;
       }
       $317 = (($$2550764) + 1)|0; //@line 67784 "c/sqlite3.c"
       $318 = ($$2550764|0)<($$0548|0); //@line 67784 "c/sqlite3.c"
       if ($318) {
        $$0586763 = $$4590$ph;$$2550764 = $317;
       } else {
        break;
       }
      }
      if ((label|0) == 50) {
       $316 = (_sqlite3CorruptError(67796)|0); //@line 67796 "c/sqlite3.c"
       HEAP32[$5>>2] = $316; //@line 67796 "c/sqlite3.c"
       $$3 = 0;
       break L17;
      }
      $319 = ((($21)) + 36|0); //@line 67890 "c/sqlite3.c"
      $320 = HEAP32[$319>>2]|0; //@line 67890 "c/sqlite3.c"
      $321 = (($168) + -12)|0; //@line 67890 "c/sqlite3.c"
      $322 = (($321) + ($320))|0; //@line 67890 "c/sqlite3.c"
      $323 = ($$0548|0)<(0); //@line 67891 "c/sqlite3.c"
      if ($323) {
       $$1562$lcssa = $37;$573 = $319;$728 = $322;
      } else {
       $$3551742 = 0;
       while(1) {
        $324 = (($6) + ($$3551742<<2)|0); //@line 67892 "c/sqlite3.c"
        $325 = HEAP32[$324>>2]|0; //@line 67892 "c/sqlite3.c"
        $326 = ((($325)) + 20|0); //@line 67893 "c/sqlite3.c"
        $327 = HEAP16[$326>>1]|0; //@line 67893 "c/sqlite3.c"
        $328 = $327&65535; //@line 67893 "c/sqlite3.c"
        $329 = (($322) - ($328))|0; //@line 67893 "c/sqlite3.c"
        $330 = (($11) + ($$3551742<<2)|0); //@line 67893 "c/sqlite3.c"
        HEAP32[$330>>2] = $329; //@line 67893 "c/sqlite3.c"
        $331 = ((($325)) + 12|0); //@line 67894 "c/sqlite3.c"
        $332 = HEAP8[$331>>0]|0; //@line 67894 "c/sqlite3.c"
        $333 = ($332<<24>>24)==(0); //@line 67894 "c/sqlite3.c"
        if (!($333)) {
         $334 = ((($325)) + 76|0);
         $$1553738 = 0;
         while(1) {
          $335 = HEAP32[$334>>2]|0; //@line 67895 "c/sqlite3.c"
          $336 = (((($325)) + 36|0) + ($$1553738<<2)|0); //@line 67895 "c/sqlite3.c"
          $337 = HEAP32[$336>>2]|0; //@line 67895 "c/sqlite3.c"
          $338 = (FUNCTION_TABLE_iii[$335 & 255]($325,$337)|0); //@line 67895 "c/sqlite3.c"
          $339 = $338&65535; //@line 67895 "c/sqlite3.c"
          $340 = (($339) + 2)|0; //@line 67895 "c/sqlite3.c"
          $341 = HEAP32[$330>>2]|0; //@line 67895 "c/sqlite3.c"
          $342 = (($340) + ($341))|0; //@line 67895 "c/sqlite3.c"
          HEAP32[$330>>2] = $342; //@line 67895 "c/sqlite3.c"
          $343 = (($$1553738) + 1)|0; //@line 67894 "c/sqlite3.c"
          $344 = HEAP8[$331>>0]|0; //@line 67894 "c/sqlite3.c"
          $345 = $344&255; //@line 67894 "c/sqlite3.c"
          $346 = ($343>>>0)<($345>>>0); //@line 67894 "c/sqlite3.c"
          if ($346) {
           $$1553738 = $343;
          } else {
           break;
          }
         }
        }
        $347 = (($10) + ($$3551742<<2)|0); //@line 67897 "c/sqlite3.c"
        $348 = HEAP32[$347>>2]|0; //@line 67897 "c/sqlite3.c"
        $349 = (($9) + ($$3551742<<2)|0); //@line 67897 "c/sqlite3.c"
        HEAP32[$349>>2] = $348; //@line 67897 "c/sqlite3.c"
        $350 = (($$3551742) + 1)|0; //@line 67891 "c/sqlite3.c"
        $exitcond801 = ($$3551742|0)==($$0548|0); //@line 67891 "c/sqlite3.c"
        if ($exitcond801) {
         break;
        } else {
         $$3551742 = $350;
        }
       }
       $351 = ($$0548|0)>(-1); //@line 67900 "c/sqlite3.c"
       if ($351) {
        $352 = ($171<<24>>24)==(0);
        $353 = ($171<<24>>24)==(0);
        $$1562732 = $37;$$4733 = 0;
        L84: while(1) {
         $354 = (($11) + ($$4733<<2)|0); //@line 67902 "c/sqlite3.c"
         $355 = HEAP32[$354>>2]|0; //@line 67902 "c/sqlite3.c"
         $356 = ($355|0)>($322|0); //@line 67902 "c/sqlite3.c"
         if ($356) {
          $357 = (($$4733) + 1)|0;
          $358 = (($9) + ($$4733<<2)|0);
          $359 = (($$4733) + 2)|0;
          $360 = ($359>>>0)>(5);
          $361 = (($11) + ($357<<2)|0);
          $362 = (($11) + ($357<<2)|0);
          $363 = (($9) + ($357<<2)|0);
          $$2563720 = $$1562732;$373 = $355;
          while(1) {
           $364 = ($357|0)<($$2563720|0); //@line 67903 "c/sqlite3.c"
           if ($364) {
            $$3564 = $$2563720;
           } else {
            if ($360) {
             label = 64;
             break L84;
            }
            HEAP32[$362>>2] = 0; //@line 67906 "c/sqlite3.c"
            $366 = HEAP32[$17>>2]|0; //@line 67907 "c/sqlite3.c"
            HEAP32[$363>>2] = $366; //@line 67907 "c/sqlite3.c"
            $$3564 = $359;
           }
           $367 = HEAP32[$358>>2]|0; //@line 67909 "c/sqlite3.c"
           $368 = (($367) + -1)|0; //@line 67909 "c/sqlite3.c"
           $369 = (_cachedCellSize($17,$368)|0); //@line 67909 "c/sqlite3.c"
           $370 = $369&65535; //@line 67909 "c/sqlite3.c"
           $371 = (($370) + 2)|0; //@line 67909 "c/sqlite3.c"
           $372 = (($373) - ($371))|0; //@line 67910 "c/sqlite3.c"
           HEAP32[$354>>2] = $372; //@line 67910 "c/sqlite3.c"
           if ($352) {
            $374 = HEAP32[$17>>2]|0; //@line 67912 "c/sqlite3.c"
            $375 = ($367|0)<($374|0); //@line 67912 "c/sqlite3.c"
            if ($375) {
             $376 = (_cachedCellSize($17,$367)|0); //@line 67913 "c/sqlite3.c"
             $377 = $376&65535; //@line 67913 "c/sqlite3.c"
             $378 = (($377) + 2)|0; //@line 67913 "c/sqlite3.c"
             $$0584 = $378;
            } else {
             $$0584 = 0;
            }
           } else {
            $$0584 = $371;
           }
           $379 = HEAP32[$361>>2]|0; //@line 67918 "c/sqlite3.c"
           $380 = (($379) + ($$0584))|0; //@line 67918 "c/sqlite3.c"
           HEAP32[$361>>2] = $380; //@line 67918 "c/sqlite3.c"
           HEAP32[$358>>2] = $368; //@line 67919 "c/sqlite3.c"
           $381 = HEAP32[$354>>2]|0; //@line 67902 "c/sqlite3.c"
           $382 = ($381|0)>($322|0); //@line 67902 "c/sqlite3.c"
           if ($382) {
            $$2563720 = $$3564;$373 = $381;
           } else {
            $$2563$lcssa = $$3564;
            break;
           }
          }
         } else {
          $$2563$lcssa = $$1562732;
         }
         $383 = (($9) + ($$4733<<2)|0); //@line 67921 "c/sqlite3.c"
         $384 = HEAP32[$383>>2]|0; //@line 67921 "c/sqlite3.c"
         $385 = HEAP32[$17>>2]|0; //@line 67921 "c/sqlite3.c"
         $386 = ($384|0)<($385|0); //@line 67921 "c/sqlite3.c"
         L99: do {
          if ($386) {
           $387 = (($$4733) + 1)|0;
           $388 = (($11) + ($387<<2)|0);
           $389 = $384;
           while(1) {
            $390 = (_cachedCellSize($17,$389)|0); //@line 67922 "c/sqlite3.c"
            $391 = $390&65535; //@line 67922 "c/sqlite3.c"
            $392 = (($391) + 2)|0; //@line 67922 "c/sqlite3.c"
            $393 = HEAP32[$354>>2]|0; //@line 67923 "c/sqlite3.c"
            $394 = (($392) + ($393))|0; //@line 67923 "c/sqlite3.c"
            $395 = ($394|0)>($322|0); //@line 67923 "c/sqlite3.c"
            if ($395) {
             $$lcssa657 = $389;
             break L99;
            }
            HEAP32[$354>>2] = $394; //@line 67924 "c/sqlite3.c"
            $396 = (($389) + 1)|0; //@line 67925 "c/sqlite3.c"
            HEAP32[$383>>2] = $396; //@line 67925 "c/sqlite3.c"
            if ($353) {
             $397 = HEAP32[$17>>2]|0; //@line 67927 "c/sqlite3.c"
             $398 = ($396|0)<($397|0); //@line 67927 "c/sqlite3.c"
             if ($398) {
              $399 = (_cachedCellSize($17,$396)|0); //@line 67928 "c/sqlite3.c"
              $400 = $399&65535; //@line 67928 "c/sqlite3.c"
              $401 = (($400) + 2)|0; //@line 67928 "c/sqlite3.c"
              $$1585 = $401;
             } else {
              $$1585 = 0;
             }
            } else {
             $$1585 = $392;
            }
            $402 = HEAP32[$388>>2]|0; //@line 67933 "c/sqlite3.c"
            $403 = (($402) - ($$1585))|0; //@line 67933 "c/sqlite3.c"
            HEAP32[$388>>2] = $403; //@line 67933 "c/sqlite3.c"
            $404 = HEAP32[$383>>2]|0; //@line 67921 "c/sqlite3.c"
            $405 = HEAP32[$17>>2]|0; //@line 67921 "c/sqlite3.c"
            $406 = ($404|0)<($405|0); //@line 67921 "c/sqlite3.c"
            if ($406) {
             $389 = $404;
            } else {
             $$lcssa657 = $404;
             break;
            }
           }
          } else {
           $$lcssa657 = $384;
          }
         } while(0);
         $407 = HEAP32[$17>>2]|0; //@line 67935 "c/sqlite3.c"
         $408 = ($$lcssa657|0)<($407|0); //@line 67935 "c/sqlite3.c"
         if ($408) {
          $410 = ($$4733|0)==(0); //@line 67937 "c/sqlite3.c"
          if ($410) {
           $415 = 0;
          } else {
           $411 = (($$4733) + -1)|0; //@line 67937 "c/sqlite3.c"
           $412 = (($9) + ($411<<2)|0); //@line 67937 "c/sqlite3.c"
           $413 = HEAP32[$412>>2]|0; //@line 67937 "c/sqlite3.c"
           $415 = $413;
          }
          $414 = ($$lcssa657|0)>($415|0); //@line 67937 "c/sqlite3.c"
          if ($414) {
           $$5566$ph = $$2563$lcssa;
          } else {
           label = 82;
           break;
          }
         } else {
          $409 = (($$4733) + 1)|0; //@line 67936 "c/sqlite3.c"
          $$5566$ph = $409;
         }
         $417 = (($$4733) + 1)|0; //@line 67900 "c/sqlite3.c"
         $418 = ($417|0)<($$5566$ph|0); //@line 67900 "c/sqlite3.c"
         if ($418) {
          $$1562732 = $$5566$ph;$$4733 = $417;
         } else {
          $$1562$lcssa = $$5566$ph;$573 = $319;$728 = $322;
          break L37;
         }
        }
        if ((label|0) == 64) {
         $365 = (_sqlite3CorruptError(67905)|0); //@line 67905 "c/sqlite3.c"
         HEAP32[$5>>2] = $365; //@line 67905 "c/sqlite3.c"
         $$3 = 0;
         break L17;
        }
        else if ((label|0) == 82) {
         $416 = (_sqlite3CorruptError(67938)|0); //@line 67938 "c/sqlite3.c"
         HEAP32[$5>>2] = $416; //@line 67938 "c/sqlite3.c"
         $$3 = 0;
         break L17;
        }
       } else {
        $$1562$lcssa = $37;$573 = $319;$728 = $322;
       }
      }
     }
    } while(0);
    $419 = (($$1562$lcssa) + -1)|0; //@line 67954 "c/sqlite3.c"
    $420 = ($$1562$lcssa|0)>(1); //@line 67954 "c/sqlite3.c"
    L120: do {
     if ($420) {
      $421 = ($4|0)==(0);
      $$5716 = $419;
      while(1) {
       $423 = (($11) + ($$5716<<2)|0); //@line 67955 "c/sqlite3.c"
       $424 = HEAP32[$423>>2]|0; //@line 67955 "c/sqlite3.c"
       $425 = (($$5716) + -1)|0; //@line 67956 "c/sqlite3.c"
       $426 = (($11) + ($425<<2)|0); //@line 67956 "c/sqlite3.c"
       $427 = HEAP32[$426>>2]|0; //@line 67956 "c/sqlite3.c"
       $428 = (($9) + ($425<<2)|0); //@line 67960 "c/sqlite3.c"
       $429 = HEAP32[$428>>2]|0; //@line 67960 "c/sqlite3.c"
       $430 = (($429) - ($172))|0; //@line 67961 "c/sqlite3.c"
       (_cachedCellSize($17,$430)|0); //@line 67962 "c/sqlite3.c"
       $431 = ($$5716|0)==($419|0);
       $$neg640 = $431 ? 0 : -2;
       $$0578 = $430;$$0579$in = $429;$$0580 = $427;$$0582 = $424;
       while(1) {
        $$0579 = (($$0579$in) + -1)|0;
        (_cachedCellSize($17,$$0579)|0); //@line 67966 "c/sqlite3.c"
        $432 = ($$0582|0)==(0); //@line 67967 "c/sqlite3.c"
        if (!($432)) {
         if (!($421)) {
          $$1581 = $$0580;$$1583 = $$0582;
          break;
         }
         $433 = HEAP32[$161>>2]|0; //@line 67968 "c/sqlite3.c"
         $434 = (($433) + ($$0578<<1)|0); //@line 67968 "c/sqlite3.c"
         $435 = HEAP16[$434>>1]|0; //@line 67968 "c/sqlite3.c"
         $436 = $435&65535; //@line 67968 "c/sqlite3.c"
         $437 = (($$0582) + 2)|0; //@line 67968 "c/sqlite3.c"
         $438 = (($437) + ($436))|0; //@line 67968 "c/sqlite3.c"
         $439 = (($433) + ($$0579<<1)|0); //@line 67968 "c/sqlite3.c"
         $440 = HEAP16[$439>>1]|0; //@line 67968 "c/sqlite3.c"
         $441 = $440&65535; //@line 67968 "c/sqlite3.c"
         $$neg642 = (($$0580) + ($$neg640))|0; //@line 67968 "c/sqlite3.c"
         $442 = (($$neg642) - ($441))|0; //@line 67968 "c/sqlite3.c"
         $443 = ($438|0)>($442|0); //@line 67968 "c/sqlite3.c"
         if ($443) {
          $$1581 = $$0580;$$1583 = $$0582;
          break;
         }
        }
        $444 = HEAP32[$161>>2]|0; //@line 67971 "c/sqlite3.c"
        $445 = (($444) + ($$0578<<1)|0); //@line 67971 "c/sqlite3.c"
        $446 = HEAP16[$445>>1]|0; //@line 67971 "c/sqlite3.c"
        $447 = $446&65535; //@line 67971 "c/sqlite3.c"
        $448 = (($$0582) + 2)|0; //@line 67971 "c/sqlite3.c"
        $449 = (($448) + ($447))|0; //@line 67971 "c/sqlite3.c"
        $450 = (($444) + ($$0579<<1)|0); //@line 67972 "c/sqlite3.c"
        $451 = HEAP16[$450>>1]|0; //@line 67972 "c/sqlite3.c"
        $452 = $451&65535; //@line 67972 "c/sqlite3.c"
        $$neg644 = (($$0580) + -2)|0; //@line 67972 "c/sqlite3.c"
        $453 = (($$neg644) - ($452))|0; //@line 67972 "c/sqlite3.c"
        HEAP32[$428>>2] = $$0579; //@line 67973 "c/sqlite3.c"
        $454 = (($$0578) + -1)|0; //@line 67975 "c/sqlite3.c"
        $455 = ($$0579$in|0)>(1); //@line 67976 "c/sqlite3.c"
        if ($455) {
         $$0578 = $454;$$0579$in = $$0579;$$0580 = $453;$$0582 = $449;
        } else {
         $$1581 = $453;$$1583 = $449;
         break;
        }
       }
       HEAP32[$423>>2] = $$1583; //@line 67977 "c/sqlite3.c"
       HEAP32[$426>>2] = $$1581; //@line 67978 "c/sqlite3.c"
       $456 = HEAP32[$428>>2]|0; //@line 67979 "c/sqlite3.c"
       $457 = ($$5716|0)>(1); //@line 67979 "c/sqlite3.c"
       if ($457) {
        $458 = (($$5716) + -2)|0; //@line 67979 "c/sqlite3.c"
        $459 = (($9) + ($458<<2)|0); //@line 67979 "c/sqlite3.c"
        $460 = HEAP32[$459>>2]|0; //@line 67979 "c/sqlite3.c"
        $462 = $460;
       } else {
        $462 = 0;
       }
       $461 = ($456|0)>($462|0); //@line 67979 "c/sqlite3.c"
       if (!($461)) {
        break;
       }
       $422 = ($$5716|0)>(1); //@line 67954 "c/sqlite3.c"
       if ($422) {
        $$5716 = $425;
       } else {
        break L120;
       }
      }
      $463 = (_sqlite3CorruptError(67980)|0); //@line 67980 "c/sqlite3.c"
      HEAP32[$5>>2] = $463; //@line 67980 "c/sqlite3.c"
      $$3 = 0;
      break L17;
     }
    } while(0);
    $464 = ((($163)) + 56|0); //@line 68002 "c/sqlite3.c"
    $465 = HEAP32[$464>>2]|0; //@line 68002 "c/sqlite3.c"
    $466 = HEAP8[$465>>0]|0; //@line 68002 "c/sqlite3.c"
    $467 = $466&255; //@line 68002 "c/sqlite3.c"
    $468 = ($$1562$lcssa|0)>(0); //@line 68003 "c/sqlite3.c"
    if ($468) {
     $469 = ($4|0)==(0);
     $470 = ((($21)) + 17|0);
     $471 = ((($0)) + 4|0);
     $$0544711 = 0;$$6710 = 0;
     while(1) {
      $472 = ($$6710|0)>($$0548|0); //@line 68005 "c/sqlite3.c"
      if ($472) {
       $481 = HEAP32[$12>>2]|0; //@line 68013 "c/sqlite3.c"
       $482 = $469 ? $481 : 1; //@line 68013 "c/sqlite3.c"
       $483 = (_allocateBtreePage($21,$18,$12,$482,0)|0); //@line 68013 "c/sqlite3.c"
       HEAP32[$5>>2] = $483; //@line 68013 "c/sqlite3.c"
       $484 = ($483|0)==(0); //@line 68014 "c/sqlite3.c"
       if (!($484)) {
        $$2$ph = $$0544711;
        label = 103;
        break;
       }
       $485 = HEAP32[$18>>2]|0; //@line 68015 "c/sqlite3.c"
       _zeroPage($485,$467); //@line 68015 "c/sqlite3.c"
       $$cast639 = $485; //@line 68016 "c/sqlite3.c"
       $486 = (($7) + ($$6710<<2)|0); //@line 68016 "c/sqlite3.c"
       HEAP32[$486>>2] = $$cast639; //@line 68016 "c/sqlite3.c"
       $487 = (($$0544711) + 1)|0; //@line 68017 "c/sqlite3.c"
       $488 = HEAP32[$17>>2]|0; //@line 68018 "c/sqlite3.c"
       $489 = (($10) + ($$6710<<2)|0); //@line 68018 "c/sqlite3.c"
       HEAP32[$489>>2] = $488; //@line 68018 "c/sqlite3.c"
       $490 = HEAP8[$470>>0]|0; //@line 68021 "c/sqlite3.c"
       $491 = ($490<<24>>24)==(0); //@line 68021 "c/sqlite3.c"
       if ($491) {
        $$1 = $487;
       } else {
        $492 = ((($485)) + 4|0); //@line 68022 "c/sqlite3.c"
        $493 = HEAP32[$492>>2]|0; //@line 68022 "c/sqlite3.c"
        $494 = HEAP32[$471>>2]|0; //@line 68022 "c/sqlite3.c"
        _ptrmapPut($21,$493,5,$494,$5); //@line 68022 "c/sqlite3.c"
        $495 = HEAP32[$5>>2]|0; //@line 68023 "c/sqlite3.c"
        $496 = ($495|0)==(0); //@line 68023 "c/sqlite3.c"
        if ($496) {
         $$1 = $487;
        } else {
         $$2$ph = $487;
         label = 103;
         break;
        }
       }
      } else {
       $473 = (($6) + ($$6710<<2)|0); //@line 68006 "c/sqlite3.c"
       $474 = HEAP32[$473>>2]|0; //@line 68006 "c/sqlite3.c"
       $475 = (($7) + ($$6710<<2)|0); //@line 68006 "c/sqlite3.c"
       HEAP32[$475>>2] = $474; //@line 68006 "c/sqlite3.c"
       HEAP32[$18>>2] = $474; //@line 68006 "c/sqlite3.c"
       HEAP32[$473>>2] = 0; //@line 68007 "c/sqlite3.c"
       $$cast = $474; //@line 68008 "c/sqlite3.c"
       $476 = ((($$cast)) + 72|0); //@line 68008 "c/sqlite3.c"
       $477 = HEAP32[$476>>2]|0; //@line 68008 "c/sqlite3.c"
       $478 = (_sqlite3PagerWrite($477)|0); //@line 68008 "c/sqlite3.c"
       HEAP32[$5>>2] = $478; //@line 68008 "c/sqlite3.c"
       $479 = (($$0544711) + 1)|0; //@line 68009 "c/sqlite3.c"
       $480 = ($478|0)==(0); //@line 68010 "c/sqlite3.c"
       if ($480) {
        $$1 = $479;
       } else {
        $$2$ph = $479;
        label = 103;
        break;
       }
      }
      $497 = (($$6710) + 1)|0; //@line 68003 "c/sqlite3.c"
      $498 = ($497|0)<($$1562$lcssa|0); //@line 68003 "c/sqlite3.c"
      if ($498) {
       $$0544711 = $$1;$$6710 = $497;
      } else {
       break;
      }
     }
     if ((label|0) == 103) {
      $$3 = $$2$ph;
      break;
     }
     $499 = ($$1|0)>(0); //@line 68042 "c/sqlite3.c"
     if ($499) {
      $$7705 = 0;
      L151: while(1) {
       $500 = (($7) + ($$7705<<2)|0); //@line 68043 "c/sqlite3.c"
       $501 = HEAP32[$500>>2]|0; //@line 68043 "c/sqlite3.c"
       $502 = ((($501)) + 4|0); //@line 68043 "c/sqlite3.c"
       $503 = HEAP32[$502>>2]|0; //@line 68043 "c/sqlite3.c"
       $504 = (($14) + ($$7705<<2)|0); //@line 68043 "c/sqlite3.c"
       HEAP32[$504>>2] = $503; //@line 68043 "c/sqlite3.c"
       $505 = (($15) + ($$7705<<2)|0); //@line 68043 "c/sqlite3.c"
       HEAP32[$505>>2] = $503; //@line 68043 "c/sqlite3.c"
       $506 = ((($501)) + 72|0); //@line 68044 "c/sqlite3.c"
       $507 = HEAP32[$506>>2]|0; //@line 68044 "c/sqlite3.c"
       $508 = ((($507)) + 28|0); //@line 68044 "c/sqlite3.c"
       $509 = HEAP16[$508>>1]|0; //@line 68044 "c/sqlite3.c"
       $510 = (($16) + ($$7705<<1)|0); //@line 68044 "c/sqlite3.c"
       HEAP16[$510>>1] = $509; //@line 68044 "c/sqlite3.c"
       $511 = ($$7705|0)==(0); //@line 68045 "c/sqlite3.c"
       if (!($511)) {
        $$2554701 = 0;
        while(1) {
         $514 = (($14) + ($$2554701<<2)|0); //@line 68046 "c/sqlite3.c"
         $515 = HEAP32[$514>>2]|0; //@line 68046 "c/sqlite3.c"
         $516 = ($515|0)==($503|0); //@line 68046 "c/sqlite3.c"
         $513 = (($$2554701) + 1)|0; //@line 68045 "c/sqlite3.c"
         if ($516) {
          label = 111;
          break L151;
         }
         $512 = ($513>>>0)<($$7705>>>0); //@line 68045 "c/sqlite3.c"
         if ($512) {
          $$2554701 = $513;
         } else {
          break;
         }
        }
       }
       $518 = (($$7705) + 1)|0; //@line 68042 "c/sqlite3.c"
       $519 = ($518|0)<($$1|0); //@line 68042 "c/sqlite3.c"
       if ($519) {
        $$7705 = $518;
       } else {
        break;
       }
      }
      if ((label|0) == 111) {
       $517 = (_sqlite3CorruptError(68054)|0); //@line 68054 "c/sqlite3.c"
       HEAP32[$5>>2] = $517; //@line 68054 "c/sqlite3.c"
       $$3 = $$1;
       break;
      }
      $520 = ($$1|0)>(0); //@line 68059 "c/sqlite3.c"
      if ($520) {
       $521 = ($$1|0)==(1);
       $522 = ((($21)) + 44|0);
       $$8696 = 0;
       while(1) {
        if ($521) {
         $$0576$lcssa = 0;
        } else {
         $$0576691 = 0;$$3555692 = 1;
         while(1) {
          $523 = (($15) + ($$3555692<<2)|0); //@line 68062 "c/sqlite3.c"
          $524 = HEAP32[$523>>2]|0; //@line 68062 "c/sqlite3.c"
          $525 = (($15) + ($$0576691<<2)|0); //@line 68062 "c/sqlite3.c"
          $526 = HEAP32[$525>>2]|0; //@line 68062 "c/sqlite3.c"
          $527 = ($524>>>0)<($526>>>0); //@line 68062 "c/sqlite3.c"
          $spec$select = $527 ? $$3555692 : $$0576691; //@line 68062 "c/sqlite3.c"
          $528 = (($$3555692) + 1)|0; //@line 68061 "c/sqlite3.c"
          $529 = ($528|0)<($$1|0); //@line 68061 "c/sqlite3.c"
          if ($529) {
           $$0576691 = $spec$select;$$3555692 = $528;
          } else {
           $$0576$lcssa = $spec$select;
           break;
          }
         }
        }
        $530 = (($15) + ($$0576$lcssa<<2)|0); //@line 68064 "c/sqlite3.c"
        $531 = HEAP32[$530>>2]|0; //@line 68064 "c/sqlite3.c"
        HEAP32[$530>>2] = -1; //@line 68065 "c/sqlite3.c"
        $532 = ($$0576$lcssa|0)==($$8696|0); //@line 68066 "c/sqlite3.c"
        if (!($532)) {
         $533 = ($$0576$lcssa|0)>($$8696|0); //@line 68067 "c/sqlite3.c"
         if ($533) {
          $534 = (($7) + ($$0576$lcssa<<2)|0); //@line 68068 "c/sqlite3.c"
          $535 = HEAP32[$534>>2]|0; //@line 68068 "c/sqlite3.c"
          $536 = ((($535)) + 72|0); //@line 68068 "c/sqlite3.c"
          $537 = HEAP32[$536>>2]|0; //@line 68068 "c/sqlite3.c"
          $538 = HEAP32[$522>>2]|0; //@line 68068 "c/sqlite3.c"
          $539 = (($$0576$lcssa) + 1)|0; //@line 68068 "c/sqlite3.c"
          $540 = (($539) + ($538))|0; //@line 68068 "c/sqlite3.c"
          _sqlite3PagerRekey($537,$540,0); //@line 68068 "c/sqlite3.c"
         }
         $541 = (($7) + ($$8696<<2)|0); //@line 68070 "c/sqlite3.c"
         $542 = HEAP32[$541>>2]|0; //@line 68070 "c/sqlite3.c"
         $543 = ((($542)) + 72|0); //@line 68070 "c/sqlite3.c"
         $544 = HEAP32[$543>>2]|0; //@line 68070 "c/sqlite3.c"
         $545 = (($16) + ($$0576$lcssa<<1)|0); //@line 68070 "c/sqlite3.c"
         $546 = HEAP16[$545>>1]|0; //@line 68070 "c/sqlite3.c"
         _sqlite3PagerRekey($544,$531,$546); //@line 68070 "c/sqlite3.c"
         $547 = ((($542)) + 4|0); //@line 68071 "c/sqlite3.c"
         HEAP32[$547>>2] = $531; //@line 68071 "c/sqlite3.c"
        }
        $548 = (($$8696) + 1)|0; //@line 68059 "c/sqlite3.c"
        $exitcond800 = ($548|0)==($$1|0); //@line 68059 "c/sqlite3.c"
        if ($exitcond800) {
         break;
        } else {
         $$8696 = $548;
        }
       }
       HEAP32[$12>>2] = $531; //@line 68064 "c/sqlite3.c"
       $$0544$lcssa806808 = $$1;
      } else {
       $$0544$lcssa806808 = $$1;
      }
     } else {
      $$0544$lcssa806808 = $$1;
     }
    } else {
     $$0544$lcssa806808 = 0;
    }
    $549 = (($$0544$lcssa806808) + -1)|0; //@line 68089 "c/sqlite3.c"
    $550 = (($7) + ($549<<2)|0); //@line 68089 "c/sqlite3.c"
    $551 = HEAP32[$550>>2]|0; //@line 68089 "c/sqlite3.c"
    $552 = ((($551)) + 4|0); //@line 68089 "c/sqlite3.c"
    $553 = HEAP32[$552>>2]|0; //@line 68089 "c/sqlite3.c"
    _sqlite3Put4byte($$0592,$553); //@line 68089 "c/sqlite3.c"
    $554 = $467 & 8; //@line 68094 "c/sqlite3.c"
    $555 = ($554|0)!=(0); //@line 68094 "c/sqlite3.c"
    $556 = ($37|0)==($$0544$lcssa806808|0); //@line 68094 "c/sqlite3.c"
    $or$cond618 = $555 | $556; //@line 68094 "c/sqlite3.c"
    if (!($or$cond618)) {
     $557 = ($$0544$lcssa806808|0)>($37|0); //@line 68095 "c/sqlite3.c"
     $558 = $557 ? $7 : $6; //@line 68095 "c/sqlite3.c"
     $559 = (($558) + ($$0548<<2)|0); //@line 68095 "c/sqlite3.c"
     $560 = HEAP32[$559>>2]|0; //@line 68095 "c/sqlite3.c"
     $561 = ((($551)) + 56|0); //@line 68096 "c/sqlite3.c"
     $562 = HEAP32[$561>>2]|0; //@line 68096 "c/sqlite3.c"
     $563 = ((($562)) + 8|0); //@line 68096 "c/sqlite3.c"
     $564 = ((($560)) + 56|0); //@line 68096 "c/sqlite3.c"
     $565 = HEAP32[$564>>2]|0; //@line 68096 "c/sqlite3.c"
     $566 = ((($565)) + 8|0); //@line 68096 "c/sqlite3.c"
     $567 = HEAPU8[$566>>0]|(HEAPU8[$566+1>>0]<<8)|(HEAPU8[$566+2>>0]<<16)|(HEAPU8[$566+3>>0]<<24); //@line 68096 "c/sqlite3.c"
     HEAP8[$563>>0]=$567&255;HEAP8[$563+1>>0]=($567>>8)&255;HEAP8[$563+2>>0]=($567>>16)&255;HEAP8[$563+3>>0]=$567>>24; //@line 68096 "c/sqlite3.c"
    }
    $568 = ((($21)) + 17|0); //@line 68115 "c/sqlite3.c"
    $569 = HEAP8[$568>>0]|0; //@line 68115 "c/sqlite3.c"
    $570 = ($569<<24>>24)==(0); //@line 68115 "c/sqlite3.c"
    if (!($570)) {
     $571 = HEAP32[$7>>2]|0; //@line 68116 "c/sqlite3.c"
     $572 = HEAP32[$573>>2]|0; //@line 68119 "c/sqlite3.c"
     $574 = HEAP32[$17>>2]|0; //@line 68123 "c/sqlite3.c"
     $575 = ($574|0)>(0); //@line 68123 "c/sqlite3.c"
     if ($575) {
      $576 = ((($571)) + 12|0); //@line 68118 "c/sqlite3.c"
      $577 = HEAP8[$576>>0]|0; //@line 68118 "c/sqlite3.c"
      $578 = $577&255; //@line 68118 "c/sqlite3.c"
      $579 = ((($571)) + 22|0); //@line 68118 "c/sqlite3.c"
      $580 = HEAP16[$579>>1]|0; //@line 68118 "c/sqlite3.c"
      $581 = $580&65535; //@line 68118 "c/sqlite3.c"
      $582 = (($578) + ($581))|0; //@line 68118 "c/sqlite3.c"
      $583 = ((($571)) + 56|0); //@line 68117 "c/sqlite3.c"
      $584 = HEAP32[$583>>2]|0; //@line 68117 "c/sqlite3.c"
      $585 = ($171<<24>>24)==(0);
      $586 = $585&1;
      $587 = ($171<<24>>24)==(0);
      $588 = ($169<<16>>16)==(0);
      $$0556687 = 0;$$0558686 = 0;$$0567685 = $582;$$0569684 = $584;$$0571683 = $571;$$9688 = 0;
      while(1) {
       $589 = HEAP32[$19>>2]|0; //@line 68124 "c/sqlite3.c"
       $590 = (($589) + ($$9688<<2)|0); //@line 68124 "c/sqlite3.c"
       $591 = HEAP32[$590>>2]|0; //@line 68124 "c/sqlite3.c"
       $592 = ($$9688|0)==($$0567685|0); //@line 68125 "c/sqlite3.c"
       if ($592) {
        $593 = (($$0556687) + 1)|0; //@line 68126 "c/sqlite3.c"
        $594 = ($593|0)<($$0544$lcssa806808|0); //@line 68126 "c/sqlite3.c"
        $595 = (($7) + ($593<<2)|0); //@line 68126 "c/sqlite3.c"
        $596 = (($6) + ($593<<2)|0); //@line 68126 "c/sqlite3.c"
        $$in = $594 ? $595 : $596; //@line 68126 "c/sqlite3.c"
        $597 = HEAP32[$$in>>2]|0; //@line 68126 "c/sqlite3.c"
        $598 = ((($597)) + 22|0); //@line 68127 "c/sqlite3.c"
        $599 = HEAP16[$598>>1]|0; //@line 68127 "c/sqlite3.c"
        $600 = $599&65535; //@line 68127 "c/sqlite3.c"
        $601 = ((($597)) + 12|0); //@line 68127 "c/sqlite3.c"
        $602 = HEAP8[$601>>0]|0; //@line 68127 "c/sqlite3.c"
        $603 = $602&255; //@line 68127 "c/sqlite3.c"
        $604 = (($$0567685) + ($586))|0; //@line 68127 "c/sqlite3.c"
        $605 = (($604) + ($600))|0; //@line 68127 "c/sqlite3.c"
        $606 = (($605) + ($603))|0; //@line 68127 "c/sqlite3.c"
        $607 = ((($597)) + 56|0); //@line 68128 "c/sqlite3.c"
        $608 = HEAP32[$607>>2]|0; //@line 68128 "c/sqlite3.c"
        $$1557 = $593;$$1568 = $606;$$1570 = $608;
       } else {
        $$1557 = $$0556687;$$1568 = $$0567685;$$1570 = $$0569684;
       }
       $609 = (($9) + ($$0558686<<2)|0); //@line 68130 "c/sqlite3.c"
       $610 = HEAP32[$609>>2]|0; //@line 68130 "c/sqlite3.c"
       $611 = ($$9688|0)==($610|0); //@line 68130 "c/sqlite3.c"
       if ($611) {
        $612 = (($$0558686) + 1)|0; //@line 68131 "c/sqlite3.c"
        $613 = (($7) + ($612<<2)|0); //@line 68131 "c/sqlite3.c"
        $614 = HEAP32[$613>>2]|0; //@line 68131 "c/sqlite3.c"
        if ($587) {
         $$2560$ph = $612;$$2573$ph = $614;
        } else {
         $$1559 = $612;$$1572 = $614;
         label = 133;
        }
       } else {
        $$1559 = $$0558686;$$1572 = $$0571683;
        label = 133;
       }
       do {
        if ((label|0) == 133) {
         label = 0;
         $615 = ($$1557|0)<($$0544$lcssa806808|0); //@line 68141 "c/sqlite3.c"
         if ($615) {
          $616 = ((($$1572)) + 4|0); //@line 68142 "c/sqlite3.c"
          $617 = HEAP32[$616>>2]|0; //@line 68142 "c/sqlite3.c"
          $618 = (($14) + ($$1557<<2)|0); //@line 68142 "c/sqlite3.c"
          $619 = HEAP32[$618>>2]|0; //@line 68142 "c/sqlite3.c"
          $620 = ($617|0)==($619|0); //@line 68142 "c/sqlite3.c"
          $621 = ($591>>>0)>=($$1570>>>0); //@line 68143 "c/sqlite3.c"
          $or$cond619$not = $621 & $620; //@line 68143 "c/sqlite3.c"
          $622 = (($$1570) + ($572)|0); //@line 68143 "c/sqlite3.c"
          $623 = ($591>>>0)<($622>>>0); //@line 68143 "c/sqlite3.c"
          $or$cond621 = $623 & $or$cond619$not; //@line 68143 "c/sqlite3.c"
          if ($or$cond621) {
           $$2560$ph = $$1559;$$2573$ph = $$1572;
           break;
          }
         }
         if ($588) {
          $624 = (_sqlite3Get4byte($591)|0); //@line 68146 "c/sqlite3.c"
          $625 = ((($$1572)) + 4|0); //@line 68146 "c/sqlite3.c"
          $626 = HEAP32[$625>>2]|0; //@line 68146 "c/sqlite3.c"
          _ptrmapPut($21,$624,5,$626,$5); //@line 68146 "c/sqlite3.c"
         }
         $627 = (_cachedCellSize($17,$$9688)|0); //@line 68148 "c/sqlite3.c"
         $628 = ((($$1572)) + 16|0); //@line 68148 "c/sqlite3.c"
         $629 = HEAP16[$628>>1]|0; //@line 68148 "c/sqlite3.c"
         $630 = ($627&65535)>($629&65535); //@line 68148 "c/sqlite3.c"
         if ($630) {
          _ptrmapPutOvflPtr($$1572,$591,$5); //@line 68149 "c/sqlite3.c"
         }
         $631 = HEAP32[$5>>2]|0; //@line 68151 "c/sqlite3.c"
         $632 = ($631|0)==(0); //@line 68151 "c/sqlite3.c"
         if ($632) {
          $$2560$ph = $$1559;$$2573$ph = $$1572;
         } else {
          $$3 = $$0544$lcssa806808;
          break L17;
         }
        }
       } while(0);
       $633 = (($$9688) + 1)|0; //@line 68123 "c/sqlite3.c"
       $634 = HEAP32[$17>>2]|0; //@line 68123 "c/sqlite3.c"
       $635 = ($633|0)<($634|0); //@line 68123 "c/sqlite3.c"
       if ($635) {
        $$0556687 = $$1557;$$0558686 = $$2560$ph;$$0567685 = $$1568;$$0569684 = $$1570;$$0571683 = $$2573$ph;$$9688 = $633;
       } else {
        break;
       }
      }
     }
    }
    $636 = ($$0544$lcssa806808|0)>(1); //@line 68157 "c/sqlite3.c"
    if ($636) {
     $637 = ($171<<24>>24)==(0);
     $638 = ((($0)) + 76|0);
     $$0591679 = 0;$$10680 = 0;
     while(1) {
      $639 = (($7) + ($$10680<<2)|0); //@line 68161 "c/sqlite3.c"
      $640 = HEAP32[$639>>2]|0; //@line 68161 "c/sqlite3.c"
      $641 = (($9) + ($$10680<<2)|0); //@line 68162 "c/sqlite3.c"
      $642 = HEAP32[$641>>2]|0; //@line 68162 "c/sqlite3.c"
      $643 = HEAP32[$19>>2]|0; //@line 68166 "c/sqlite3.c"
      $644 = (($643) + ($642<<2)|0); //@line 68166 "c/sqlite3.c"
      $645 = HEAP32[$644>>2]|0; //@line 68166 "c/sqlite3.c"
      $646 = HEAP32[$161>>2]|0; //@line 68167 "c/sqlite3.c"
      $647 = (($646) + ($642<<1)|0); //@line 68167 "c/sqlite3.c"
      $648 = HEAP16[$647>>1]|0; //@line 68167 "c/sqlite3.c"
      $649 = $648&65535; //@line 68167 "c/sqlite3.c"
      $650 = (($168) + ($649))|0; //@line 68167 "c/sqlite3.c"
      $651 = (($2) + ($$0591679)|0); //@line 68168 "c/sqlite3.c"
      $652 = ((($640)) + 8|0); //@line 68169 "c/sqlite3.c"
      $653 = HEAP8[$652>>0]|0; //@line 68169 "c/sqlite3.c"
      $654 = ($653<<24>>24)==(0); //@line 68169 "c/sqlite3.c"
      do {
       if ($654) {
        $655 = ((($640)) + 56|0); //@line 68170 "c/sqlite3.c"
        $656 = HEAP32[$655>>2]|0; //@line 68170 "c/sqlite3.c"
        $657 = ((($656)) + 8|0); //@line 68170 "c/sqlite3.c"
        $658 = HEAPU8[$645>>0]|(HEAPU8[$645+1>>0]<<8)|(HEAPU8[$645+2>>0]<<16)|(HEAPU8[$645+3>>0]<<24); //@line 68170 "c/sqlite3.c"
        HEAP8[$657>>0]=$658&255;HEAP8[$657+1>>0]=($658>>8)&255;HEAP8[$657+2>>0]=($658>>16)&255;HEAP8[$657+3>>0]=$658>>24; //@line 68170 "c/sqlite3.c"
        $$0545 = $650;$$0546 = $651;$$0547 = $645;
       } else {
        if (!($637)) {
         $659 = (($642) + -1)|0; //@line 68178 "c/sqlite3.c"
         $660 = ((($640)) + 80|0); //@line 68179 "c/sqlite3.c"
         $661 = HEAP32[$660>>2]|0; //@line 68179 "c/sqlite3.c"
         $662 = (($643) + ($659<<2)|0); //@line 68179 "c/sqlite3.c"
         $663 = HEAP32[$662>>2]|0; //@line 68179 "c/sqlite3.c"
         FUNCTION_TABLE_viii[$661 & 255]($640,$663,$18); //@line 68179 "c/sqlite3.c"
         $664 = ((($651)) + 4|0); //@line 68181 "c/sqlite3.c"
         $665 = $18; //@line 68181 "c/sqlite3.c"
         $666 = $665; //@line 68181 "c/sqlite3.c"
         $667 = HEAP32[$666>>2]|0; //@line 68181 "c/sqlite3.c"
         $668 = (($665) + 4)|0; //@line 68181 "c/sqlite3.c"
         $669 = $668; //@line 68181 "c/sqlite3.c"
         $670 = HEAP32[$669>>2]|0; //@line 68181 "c/sqlite3.c"
         $671 = (_sqlite3PutVarint($664,$667,$670)|0); //@line 68181 "c/sqlite3.c"
         $672 = (($671) + 4)|0; //@line 68181 "c/sqlite3.c"
         $$0545 = $672;$$0546 = 0;$$0547 = $651;
         break;
        }
        $673 = ((($645)) + -4|0); //@line 68184 "c/sqlite3.c"
        $674 = ($648<<16>>16)==(4); //@line 68196 "c/sqlite3.c"
        if ($674) {
         $675 = HEAP32[$638>>2]|0; //@line 68198 "c/sqlite3.c"
         $676 = (FUNCTION_TABLE_iii[$675 & 255]($0,$673)|0); //@line 68198 "c/sqlite3.c"
         $677 = $676&65535; //@line 68198 "c/sqlite3.c"
         $$0545 = $677;$$0546 = $651;$$0547 = $673;
        } else {
         $$0545 = $650;$$0546 = $651;$$0547 = $673;
        }
       }
      } while(0);
      $678 = (($$10680) + ($$1575))|0; //@line 68204 "c/sqlite3.c"
      $679 = ((($640)) + 4|0); //@line 68204 "c/sqlite3.c"
      $680 = HEAP32[$679>>2]|0; //@line 68204 "c/sqlite3.c"
      _insertCell($0,$678,$$0547,$$0545,$$0546,$680,$5); //@line 68204 "c/sqlite3.c"
      $681 = HEAP32[$5>>2]|0; //@line 68205 "c/sqlite3.c"
      $682 = ($681|0)==(0); //@line 68205 "c/sqlite3.c"
      if (!($682)) {
       $$3 = $$0544$lcssa806808;
       break L17;
      }
      $683 = (($$0545) + ($$0591679))|0; //@line 68201 "c/sqlite3.c"
      $684 = (($$10680) + 1)|0; //@line 68157 "c/sqlite3.c"
      $685 = ($684|0)<($549|0); //@line 68157 "c/sqlite3.c"
      if ($685) {
       $$0591679 = $683;$$10680 = $684;
      } else {
       break;
      }
     }
    }
    $686 = (1 - ($$0544$lcssa806808))|0; //@line 68231 "c/sqlite3.c"
    $687 = ($686|0)<($$0544$lcssa806808|0); //@line 68231 "c/sqlite3.c"
    if ($687) {
     $688 = HEAP32[$9>>2]|0;
     $689 = ($171<<24>>24)==(0);
     $690 = $689&1;
     $691 = ($171<<24>>24)==(0);
     $692 = $691&1;
     $$11675 = $686;
     while(1) {
      $693 = ($$11675|0)<(0); //@line 68232 "c/sqlite3.c"
      $694 = (0 - ($$11675))|0; //@line 68232 "c/sqlite3.c"
      $695 = $693 ? $694 : $$11675; //@line 68232 "c/sqlite3.c"
      $696 = (($13) + ($695)|0); //@line 68234 "c/sqlite3.c"
      $697 = HEAP8[$696>>0]|0; //@line 68234 "c/sqlite3.c"
      $698 = ($697<<24>>24)==(0); //@line 68234 "c/sqlite3.c"
      do {
       if ($698) {
        $699 = ($$11675|0)>(-1); //@line 68235 "c/sqlite3.c"
        if (!($699)) {
         $700 = (($695) + -1)|0; //@line 68236 "c/sqlite3.c"
         $701 = (($10) + ($700<<2)|0); //@line 68236 "c/sqlite3.c"
         $702 = HEAP32[$701>>2]|0; //@line 68236 "c/sqlite3.c"
         $703 = (($9) + ($700<<2)|0); //@line 68236 "c/sqlite3.c"
         $704 = HEAP32[$703>>2]|0; //@line 68236 "c/sqlite3.c"
         $705 = ($702|0)<($704|0); //@line 68236 "c/sqlite3.c"
         if ($705) {
          break;
         }
        }
        $706 = ($695|0)==(0); //@line 68250 "c/sqlite3.c"
        if ($706) {
         $$0540 = $688;$$0541 = 0;$$0542 = 0;
        } else {
         $707 = ($695|0)>($$0548|0); //@line 68254 "c/sqlite3.c"
         if ($707) {
          $712 = HEAP32[$17>>2]|0; //@line 68254 "c/sqlite3.c"
          $773 = $712;
         } else {
          $708 = (($695) + -1)|0; //@line 68254 "c/sqlite3.c"
          $709 = (($10) + ($708<<2)|0); //@line 68254 "c/sqlite3.c"
          $710 = HEAP32[$709>>2]|0; //@line 68254 "c/sqlite3.c"
          $711 = (($710) + ($692))|0; //@line 68254 "c/sqlite3.c"
          $773 = $711;
         }
         $713 = (($695) + -1)|0; //@line 68255 "c/sqlite3.c"
         $714 = (($9) + ($713<<2)|0); //@line 68255 "c/sqlite3.c"
         $715 = HEAP32[$714>>2]|0; //@line 68255 "c/sqlite3.c"
         $716 = (($715) + ($690))|0; //@line 68255 "c/sqlite3.c"
         $717 = (($9) + ($695<<2)|0); //@line 68256 "c/sqlite3.c"
         $718 = HEAP32[$717>>2]|0; //@line 68256 "c/sqlite3.c"
         $719 = (($718) - ($716))|0; //@line 68256 "c/sqlite3.c"
         $$0540 = $719;$$0541 = $773;$$0542 = $716;
        }
        $720 = (($7) + ($695<<2)|0); //@line 68259 "c/sqlite3.c"
        $721 = HEAP32[$720>>2]|0; //@line 68259 "c/sqlite3.c"
        $722 = (_editPage($721,$$0541,$$0542,$$0540,$17)|0); //@line 68259 "c/sqlite3.c"
        HEAP32[$5>>2] = $722; //@line 68259 "c/sqlite3.c"
        $723 = ($722|0)==(0); //@line 68260 "c/sqlite3.c"
        if (!($723)) {
         $$3 = $$0544$lcssa806808;
         break L17;
        }
        $724 = (($697) + 1)<<24>>24; //@line 68261 "c/sqlite3.c"
        HEAP8[$696>>0] = $724; //@line 68261 "c/sqlite3.c"
        $725 = (($11) + ($695<<2)|0); //@line 68262 "c/sqlite3.c"
        $726 = HEAP32[$725>>2]|0; //@line 68262 "c/sqlite3.c"
        $727 = (($728) - ($726))|0; //@line 68262 "c/sqlite3.c"
        $729 = $727&65535; //@line 68262 "c/sqlite3.c"
        $730 = ((($721)) + 20|0); //@line 68262 "c/sqlite3.c"
        HEAP16[$730>>1] = $729; //@line 68262 "c/sqlite3.c"
       }
      } while(0);
      $731 = (($$11675) + 1)|0; //@line 68231 "c/sqlite3.c"
      $732 = ($731|0)<($$0544$lcssa806808|0); //@line 68231 "c/sqlite3.c"
      if ($732) {
       $$11675 = $731;
      } else {
       break;
      }
     }
    }
    $733 = ($3|0)==(0); //@line 68274 "c/sqlite3.c"
    if ($733) {
     label = 168;
    } else {
     $734 = HEAP16[$26>>1]|0; //@line 68274 "c/sqlite3.c"
     $735 = ($734<<16>>16)==(0); //@line 68274 "c/sqlite3.c"
     if ($735) {
      $736 = ((($0)) + 9|0); //@line 68274 "c/sqlite3.c"
      $737 = HEAP8[$736>>0]|0; //@line 68274 "c/sqlite3.c"
      $738 = $737&255; //@line 68274 "c/sqlite3.c"
      $739 = HEAP32[$7>>2]|0; //@line 68274 "c/sqlite3.c"
      $740 = ((($739)) + 20|0); //@line 68274 "c/sqlite3.c"
      $741 = HEAP16[$740>>1]|0; //@line 68274 "c/sqlite3.c"
      $742 = $741&65535; //@line 68274 "c/sqlite3.c"
      $743 = ($738>>>0)>($742>>>0); //@line 68274 "c/sqlite3.c"
      if ($743) {
       label = 168;
      } else {
       $744 = (_defragmentPage($739,-1)|0); //@line 68291 "c/sqlite3.c"
       HEAP32[$5>>2] = $744; //@line 68291 "c/sqlite3.c"
       _copyNodeContent($739,$0,$5); //@line 68297 "c/sqlite3.c"
       _freePage($739,$5); //@line 68298 "c/sqlite3.c"
      }
     } else {
      label = 168;
     }
    }
    if ((label|0) == 168) {
     $745 = HEAP8[$568>>0]|0; //@line 68299 "c/sqlite3.c"
     $746 = ($745<<24>>24)!=(0); //@line 68299 "c/sqlite3.c"
     $747 = ($169<<16>>16)==(0); //@line 68299 "c/sqlite3.c"
     $or$cond3$not = $746 & $747; //@line 68299 "c/sqlite3.c"
     $748 = ($$0544$lcssa806808|0)>(0); //@line 68303 "c/sqlite3.c"
     $or$cond778 = $or$cond3$not & $748; //@line 68299 "c/sqlite3.c"
     if ($or$cond778) {
      $$12672 = 0;
      while(1) {
       $749 = (($7) + ($$12672<<2)|0); //@line 68304 "c/sqlite3.c"
       $750 = HEAP32[$749>>2]|0; //@line 68304 "c/sqlite3.c"
       $751 = ((($750)) + 56|0); //@line 68304 "c/sqlite3.c"
       $752 = HEAP32[$751>>2]|0; //@line 68304 "c/sqlite3.c"
       $753 = ((($752)) + 8|0); //@line 68304 "c/sqlite3.c"
       $754 = (_sqlite3Get4byte($753)|0); //@line 68304 "c/sqlite3.c"
       $755 = ((($750)) + 4|0); //@line 68305 "c/sqlite3.c"
       $756 = HEAP32[$755>>2]|0; //@line 68305 "c/sqlite3.c"
       _ptrmapPut($21,$754,5,$756,$5); //@line 68305 "c/sqlite3.c"
       $757 = (($$12672) + 1)|0; //@line 68303 "c/sqlite3.c"
       $exitcond799 = ($757|0)==($$0544$lcssa806808|0); //@line 68303 "c/sqlite3.c"
       if ($exitcond799) {
        break;
       } else {
        $$12672 = $757;
       }
      }
     }
    }
    $758 = ($$0544$lcssa806808|0)>($$0548|0); //@line 68315 "c/sqlite3.c"
    if ($758) {
     $$3 = $$0544$lcssa806808;
     break;
    }
    $$13669 = $$0544$lcssa806808;
    while(1) {
     $759 = (($6) + ($$13669<<2)|0); //@line 68316 "c/sqlite3.c"
     $760 = HEAP32[$759>>2]|0; //@line 68316 "c/sqlite3.c"
     _freePage($760,$5); //@line 68316 "c/sqlite3.c"
     $761 = (($$13669) + 1)|0; //@line 68315 "c/sqlite3.c"
     $762 = ($$13669|0)<($$0548|0); //@line 68315 "c/sqlite3.c"
     if ($762) {
      $$13669 = $761;
     } else {
      $$3 = $$0544$lcssa806808;
      break;
     }
    }
   }
  } else {
   $$1549$lcssa = $$0548;
   label = 14;
  }
 } while(0);
 if ((label|0) == 14) {
  $75 = $$1549$lcssa << 2; //@line 67698 "c/sqlite3.c"
  $76 = (($75) + 4)|0; //@line 67698 "c/sqlite3.c"
  _memset(($6|0),0,($76|0))|0; //@line 67698 "c/sqlite3.c"
  $$3 = 0;
 }
 $763 = HEAP32[$19>>2]|0; //@line 68334 "c/sqlite3.c"
 _sqlite3DbFree(0,$763); //@line 68334 "c/sqlite3.c"
 $764 = ($$0548|0)<(0); //@line 68335 "c/sqlite3.c"
 if (!($764)) {
  $$14665 = 0;
  while(1) {
   $765 = (($6) + ($$14665<<2)|0); //@line 68336 "c/sqlite3.c"
   $766 = HEAP32[$765>>2]|0; //@line 68336 "c/sqlite3.c"
   _releasePage($766); //@line 68336 "c/sqlite3.c"
   $767 = (($$14665) + 1)|0; //@line 68335 "c/sqlite3.c"
   $exitcond798 = ($$14665|0)==($$0548|0); //@line 68335 "c/sqlite3.c"
   if ($exitcond798) {
    break;
   } else {
    $$14665 = $767;
   }
  }
 }
 $768 = ($$3|0)>(0); //@line 68338 "c/sqlite3.c"
 if ($768) {
  $$15664 = 0;
  while(1) {
   $769 = (($7) + ($$15664<<2)|0); //@line 68339 "c/sqlite3.c"
   $770 = HEAP32[$769>>2]|0; //@line 68339 "c/sqlite3.c"
   _releasePage($770); //@line 68339 "c/sqlite3.c"
   $771 = (($$15664) + 1)|0; //@line 68338 "c/sqlite3.c"
   $exitcond = ($771|0)==($$3|0); //@line 68338 "c/sqlite3.c"
   if ($exitcond) {
    break;
   } else {
    $$15664 = $771;
   }
  }
 }
 $772 = HEAP32[$5>>2]|0; //@line 68342 "c/sqlite3.c"
 $$0 = $772;
 STACKTOP = sp;return ($$0|0); //@line 68343 "c/sqlite3.c"
}
function _cachedCellSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 12|0); //@line 67056 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 67056 "c/sqlite3.c"
 $4 = (($3) + ($1<<1)|0); //@line 67056 "c/sqlite3.c"
 $5 = HEAP16[$4>>1]|0; //@line 67056 "c/sqlite3.c"
 $6 = ($5<<16>>16)==(0); //@line 67056 "c/sqlite3.c"
 if (!($6)) {
  $$0 = $5;
  return ($$0|0); //@line 67058 "c/sqlite3.c"
 }
 $7 = (_computeCellSize($0,$1)|0); //@line 67057 "c/sqlite3.c"
 $$0 = $7;
 return ($$0|0); //@line 67058 "c/sqlite3.c"
}
function _sqlite3PagerRekey($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 28|0); //@line 55141 "c/sqlite3.c"
 HEAP16[$3>>1] = $2; //@line 55141 "c/sqlite3.c"
 _sqlite3PcacheMove($0,$1); //@line 55142 "c/sqlite3.c"
 return; //@line 55143 "c/sqlite3.c"
}
function _editPage($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$ = 0, $$0 = 0, $$0139 = 0, $$0141145 = 0, $$1140 = 0, $$3 = 0, $$4$lcssa = 0, $$4146 = 0, $$5 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0;
 var $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0;
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0;
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $5 = sp;
 $6 = ((($0)) + 56|0); //@line 67252 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 67252 "c/sqlite3.c"
 $8 = ((($0)) + 9|0); //@line 67253 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 67253 "c/sqlite3.c"
 $10 = $9&255; //@line 67253 "c/sqlite3.c"
 $11 = ((($0)) + 64|0); //@line 67254 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 67254 "c/sqlite3.c"
 $13 = $3 << 1; //@line 67254 "c/sqlite3.c"
 $14 = (($12) + ($13)|0); //@line 67254 "c/sqlite3.c"
 $15 = ((($0)) + 22|0); //@line 67255 "c/sqlite3.c"
 $16 = HEAP16[$15>>1]|0; //@line 67255 "c/sqlite3.c"
 $17 = $16&65535; //@line 67255 "c/sqlite3.c"
 $18 = (($17) + ($1))|0; //@line 67259 "c/sqlite3.c"
 $19 = ((($0)) + 12|0); //@line 67259 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 67259 "c/sqlite3.c"
 $21 = $20&255; //@line 67259 "c/sqlite3.c"
 $22 = (($18) + ($21))|0; //@line 67259 "c/sqlite3.c"
 $23 = (($3) + ($2))|0; //@line 67260 "c/sqlite3.c"
 $24 = ($1|0)<($2|0); //@line 67268 "c/sqlite3.c"
 if ($24) {
  $25 = (($2) - ($1))|0; //@line 67269 "c/sqlite3.c"
  $26 = (_pageFreeArray($0,$1,$25,$4)|0); //@line 67269 "c/sqlite3.c"
  $27 = HEAP32[$11>>2]|0; //@line 67270 "c/sqlite3.c"
  $28 = $26 << 1; //@line 67270 "c/sqlite3.c"
  $29 = (($27) + ($28)|0); //@line 67270 "c/sqlite3.c"
  $30 = $17 << 1; //@line 67270 "c/sqlite3.c"
  _memmove(($27|0),($29|0),($30|0))|0; //@line 67270 "c/sqlite3.c"
  $31 = (($17) - ($26))|0; //@line 67271 "c/sqlite3.c"
  $$0139 = $31;
 } else {
  $$0139 = $17;
 }
 $32 = ($22|0)>($23|0); //@line 67273 "c/sqlite3.c"
 if ($32) {
  $33 = (($22) - ($23))|0; //@line 67274 "c/sqlite3.c"
  $34 = (_pageFreeArray($0,$23,$33,$4)|0); //@line 67274 "c/sqlite3.c"
  $35 = (($$0139) - ($34))|0; //@line 67274 "c/sqlite3.c"
  $$1140 = $35;
 } else {
  $$1140 = $$0139;
 }
 $36 = (($10) + 5)|0; //@line 67277 "c/sqlite3.c"
 $37 = (($7) + ($36)|0); //@line 67277 "c/sqlite3.c"
 $38 = HEAP8[$37>>0]|0; //@line 67277 "c/sqlite3.c"
 $39 = $38&255; //@line 67277 "c/sqlite3.c"
 $40 = $39 << 8; //@line 67277 "c/sqlite3.c"
 $41 = ((($37)) + 1|0); //@line 67277 "c/sqlite3.c"
 $42 = HEAP8[$41>>0]|0; //@line 67277 "c/sqlite3.c"
 $43 = $42&255; //@line 67277 "c/sqlite3.c"
 $44 = $40 | $43; //@line 67277 "c/sqlite3.c"
 $45 = (($44) + 65535)|0; //@line 67277 "c/sqlite3.c"
 $46 = $45 & 65535; //@line 67277 "c/sqlite3.c"
 $47 = (($46) + 1)|0; //@line 67277 "c/sqlite3.c"
 $48 = (($7) + ($47)|0); //@line 67277 "c/sqlite3.c"
 HEAP32[$5>>2] = $48; //@line 67277 "c/sqlite3.c"
 $49 = ($48>>>0)<($14>>>0); //@line 67278 "c/sqlite3.c"
 L7: do {
  if (!($49)) {
   $50 = ($2|0)<($1|0); //@line 67281 "c/sqlite3.c"
   if ($50) {
    $51 = (($1) - ($2))|0; //@line 67282 "c/sqlite3.c"
    $52 = ($51|0)>($3|0); //@line 67282 "c/sqlite3.c"
    $$ = $52 ? $3 : $51; //@line 67282 "c/sqlite3.c"
    $53 = HEAP32[$11>>2]|0; //@line 67284 "c/sqlite3.c"
    $54 = $$ << 1; //@line 67285 "c/sqlite3.c"
    $55 = (($53) + ($54)|0); //@line 67285 "c/sqlite3.c"
    $56 = $$1140 << 1; //@line 67285 "c/sqlite3.c"
    _memmove(($55|0),($53|0),($56|0))|0; //@line 67285 "c/sqlite3.c"
    $57 = (_pageInsertArray($0,$14,$5,$53,$2,$$,$4)|0); //@line 67286 "c/sqlite3.c"
    $58 = ($57|0)==(0); //@line 67286 "c/sqlite3.c"
    $59 = (($$1140) + ($$))|0; //@line 67290 "c/sqlite3.c"
    if ($58) {
     $$3 = $59;
    } else {
     break;
    }
   } else {
    $$3 = $$1140;
   }
   $60 = HEAP8[$19>>0]|0; //@line 67294 "c/sqlite3.c"
   $61 = ($60<<24>>24)==(0); //@line 67294 "c/sqlite3.c"
   if ($61) {
    $$4$lcssa = $$3;
   } else {
    $$0141145 = 0;$$4146 = $$3;
    while(1) {
     $62 = (((($0)) + 26|0) + ($$0141145<<1)|0); //@line 67295 "c/sqlite3.c"
     $63 = HEAP16[$62>>1]|0; //@line 67295 "c/sqlite3.c"
     $64 = $63&65535; //@line 67295 "c/sqlite3.c"
     $65 = (($64) + ($1))|0; //@line 67295 "c/sqlite3.c"
     $66 = (($65) - ($2))|0; //@line 67295 "c/sqlite3.c"
     $67 = ($66|0)>(-1); //@line 67296 "c/sqlite3.c"
     $68 = ($66|0)<($3|0); //@line 67296 "c/sqlite3.c"
     $or$cond = $67 & $68; //@line 67296 "c/sqlite3.c"
     if ($or$cond) {
      $69 = HEAP32[$11>>2]|0; //@line 67297 "c/sqlite3.c"
      $70 = $66 << 1; //@line 67297 "c/sqlite3.c"
      $71 = (($69) + ($70)|0); //@line 67297 "c/sqlite3.c"
      $72 = ((($71)) + 2|0); //@line 67298 "c/sqlite3.c"
      $73 = (($$4146) - ($66))|0; //@line 67298 "c/sqlite3.c"
      $74 = $73 << 1; //@line 67298 "c/sqlite3.c"
      _memmove(($72|0),($71|0),($74|0))|0; //@line 67298 "c/sqlite3.c"
      $75 = (($$4146) + 1)|0; //@line 67299 "c/sqlite3.c"
      $76 = (_pageInsertArray($0,$14,$5,$71,$65,1,$4)|0); //@line 67300 "c/sqlite3.c"
      $77 = ($76|0)==(0); //@line 67300 "c/sqlite3.c"
      if ($77) {
       $$5 = $75;
      } else {
       break L7;
      }
     } else {
      $$5 = $$4146;
     }
     $78 = (($$0141145) + 1)|0; //@line 67294 "c/sqlite3.c"
     $79 = HEAP8[$19>>0]|0; //@line 67294 "c/sqlite3.c"
     $80 = $79&255; //@line 67294 "c/sqlite3.c"
     $81 = ($78>>>0)<($80>>>0); //@line 67294 "c/sqlite3.c"
     if ($81) {
      $$0141145 = $78;$$4146 = $$5;
     } else {
      $$4$lcssa = $$5;
      break;
     }
    }
   }
   $82 = HEAP32[$11>>2]|0; //@line 67308 "c/sqlite3.c"
   $83 = $$4$lcssa << 1; //@line 67308 "c/sqlite3.c"
   $84 = (($82) + ($83)|0); //@line 67308 "c/sqlite3.c"
   $85 = (($$4$lcssa) + ($2))|0; //@line 67311 "c/sqlite3.c"
   $86 = (($3) - ($$4$lcssa))|0; //@line 67311 "c/sqlite3.c"
   $87 = (_pageInsertArray($0,$14,$5,$84,$85,$86,$4)|0); //@line 67309 "c/sqlite3.c"
   $88 = ($87|0)==(0); //@line 67309 "c/sqlite3.c"
   if ($88) {
    $89 = $3&65535; //@line 67314 "c/sqlite3.c"
    HEAP16[$15>>1] = $89; //@line 67314 "c/sqlite3.c"
    HEAP8[$19>>0] = 0; //@line 67315 "c/sqlite3.c"
    $90 = $3 >>> 8; //@line 67317 "c/sqlite3.c"
    $91 = $90&255; //@line 67317 "c/sqlite3.c"
    $92 = (($10) + 3)|0; //@line 67317 "c/sqlite3.c"
    $93 = (($7) + ($92)|0); //@line 67317 "c/sqlite3.c"
    HEAP8[$93>>0] = $91; //@line 67317 "c/sqlite3.c"
    $94 = HEAP16[$15>>1]|0; //@line 67317 "c/sqlite3.c"
    $95 = $94&255; //@line 67317 "c/sqlite3.c"
    $96 = ((($93)) + 1|0); //@line 67317 "c/sqlite3.c"
    HEAP8[$96>>0] = $95; //@line 67317 "c/sqlite3.c"
    $97 = HEAP32[$5>>2]|0; //@line 67318 "c/sqlite3.c"
    $98 = $7; //@line 67318 "c/sqlite3.c"
    $99 = (($97) - ($98))|0; //@line 67318 "c/sqlite3.c"
    $100 = $99 >>> 8; //@line 67318 "c/sqlite3.c"
    $101 = $100&255; //@line 67318 "c/sqlite3.c"
    HEAP8[$37>>0] = $101; //@line 67318 "c/sqlite3.c"
    $102 = $99&255; //@line 67318 "c/sqlite3.c"
    HEAP8[$41>>0] = $102; //@line 67318 "c/sqlite3.c"
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 67337 "c/sqlite3.c"
   }
  }
 } while(0);
 _populateCellCache($4,$2,$3); //@line 67335 "c/sqlite3.c"
 $103 = ((($4)) + 8|0); //@line 67336 "c/sqlite3.c"
 $104 = HEAP32[$103>>2]|0; //@line 67336 "c/sqlite3.c"
 $105 = (($104) + ($2<<2)|0); //@line 67336 "c/sqlite3.c"
 $106 = ((($4)) + 12|0); //@line 67336 "c/sqlite3.c"
 $107 = HEAP32[$106>>2]|0; //@line 67336 "c/sqlite3.c"
 $108 = (($107) + ($2<<1)|0); //@line 67336 "c/sqlite3.c"
 $109 = (_rebuildPage($0,$3,$105,$108)|0); //@line 67336 "c/sqlite3.c"
 $$0 = $109;
 STACKTOP = sp;return ($$0|0); //@line 67337 "c/sqlite3.c"
}
function _defragmentPage($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0203242 = 0, $$0209 = 0, $$0209$pn = 0, $$0210 = 0, $$0211243 = 0, $$0219240 = 0, $$0223239 = 0, $$2221 = 0, $$2225 = 0, $$3222 = 0, $$3226 = 0, $$4216$lcssa = 0, $$4216241 = 0, $$6218 = 0, $$7 = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0;
 var $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0;
 var $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0;
 var $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0;
 var $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0;
 var $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0;
 var $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0;
 var $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0;
 var $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond228 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 56|0); //@line 61799 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 61799 "c/sqlite3.c"
 $4 = ((($0)) + 9|0); //@line 61800 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 61800 "c/sqlite3.c"
 $6 = $5&255; //@line 61800 "c/sqlite3.c"
 $7 = ((($0)) + 18|0); //@line 61801 "c/sqlite3.c"
 $8 = HEAP16[$7>>1]|0; //@line 61801 "c/sqlite3.c"
 $9 = $8&65535; //@line 61801 "c/sqlite3.c"
 $10 = ((($0)) + 22|0); //@line 61802 "c/sqlite3.c"
 $11 = HEAP16[$10>>1]|0; //@line 61802 "c/sqlite3.c"
 $12 = $11&65535; //@line 61802 "c/sqlite3.c"
 $13 = $12 << 1; //@line 61804 "c/sqlite3.c"
 $14 = (($13) + ($9))|0; //@line 61804 "c/sqlite3.c"
 $15 = ((($0)) + 52|0); //@line 61805 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 61805 "c/sqlite3.c"
 $17 = ((($16)) + 36|0); //@line 61805 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 61805 "c/sqlite3.c"
 $19 = (($6) + 7)|0; //@line 61812 "c/sqlite3.c"
 $20 = (($3) + ($19)|0); //@line 61812 "c/sqlite3.c"
 $21 = HEAP8[$20>>0]|0; //@line 61812 "c/sqlite3.c"
 $22 = $21&255; //@line 61812 "c/sqlite3.c"
 $23 = ($22|0)>($1|0); //@line 61812 "c/sqlite3.c"
 do {
  if ($23) {
   label = 16;
  } else {
   $24 = (($6) + 1)|0; //@line 61813 "c/sqlite3.c"
   $25 = (($3) + ($24)|0); //@line 61813 "c/sqlite3.c"
   $26 = HEAP8[$25>>0]|0; //@line 61813 "c/sqlite3.c"
   $27 = $26&255; //@line 61813 "c/sqlite3.c"
   $28 = $27 << 8; //@line 61813 "c/sqlite3.c"
   $29 = ((($25)) + 1|0); //@line 61813 "c/sqlite3.c"
   $30 = HEAP8[$29>>0]|0; //@line 61813 "c/sqlite3.c"
   $31 = $30&255; //@line 61813 "c/sqlite3.c"
   $32 = $28 | $31; //@line 61813 "c/sqlite3.c"
   $33 = ($32|0)==(0); //@line 61814 "c/sqlite3.c"
   if ($33) {
    label = 16;
   } else {
    $34 = (($3) + ($32)|0); //@line 61815 "c/sqlite3.c"
    $35 = HEAP8[$34>>0]|0; //@line 61815 "c/sqlite3.c"
    $36 = $35&255; //@line 61815 "c/sqlite3.c"
    $37 = $36 << 8; //@line 61815 "c/sqlite3.c"
    $38 = ((($34)) + 1|0); //@line 61815 "c/sqlite3.c"
    $39 = HEAP8[$38>>0]|0; //@line 61815 "c/sqlite3.c"
    $40 = $39&255; //@line 61815 "c/sqlite3.c"
    $41 = $37 | $40; //@line 61815 "c/sqlite3.c"
    $42 = ($41|0)==(0); //@line 61827 "c/sqlite3.c"
    if (!($42)) {
     $43 = (($3) + ($41)|0); //@line 61827 "c/sqlite3.c"
     $44 = HEAP8[$43>>0]|0; //@line 61827 "c/sqlite3.c"
     $45 = ($44<<24>>24)==(0); //@line 61827 "c/sqlite3.c"
     if (!($45)) {
      label = 16;
      break;
     }
     $46 = (($41) + 1)|0; //@line 61827 "c/sqlite3.c"
     $47 = (($3) + ($46)|0); //@line 61827 "c/sqlite3.c"
     $48 = HEAP8[$47>>0]|0; //@line 61827 "c/sqlite3.c"
     $49 = ($48<<24>>24)==(0); //@line 61827 "c/sqlite3.c"
     if (!($49)) {
      label = 16;
      break;
     }
    }
    $50 = (($3) + ($14)|0); //@line 61828 "c/sqlite3.c"
    $51 = (($32) + 2)|0; //@line 61831 "c/sqlite3.c"
    $52 = (($3) + ($51)|0); //@line 61831 "c/sqlite3.c"
    $53 = HEAP8[$52>>0]|0; //@line 61831 "c/sqlite3.c"
    $54 = $53&255; //@line 61831 "c/sqlite3.c"
    $55 = $54 << 8; //@line 61831 "c/sqlite3.c"
    $56 = ((($52)) + 1|0); //@line 61831 "c/sqlite3.c"
    $57 = HEAP8[$56>>0]|0; //@line 61831 "c/sqlite3.c"
    $58 = $57&255; //@line 61831 "c/sqlite3.c"
    $59 = $55 | $58; //@line 61831 "c/sqlite3.c"
    $60 = (($6) + 5)|0; //@line 61832 "c/sqlite3.c"
    $61 = (($3) + ($60)|0); //@line 61832 "c/sqlite3.c"
    $62 = HEAP8[$61>>0]|0; //@line 61832 "c/sqlite3.c"
    $63 = $62&255; //@line 61832 "c/sqlite3.c"
    $64 = $63 << 8; //@line 61832 "c/sqlite3.c"
    $65 = ((($61)) + 1|0); //@line 61832 "c/sqlite3.c"
    $66 = HEAP8[$65>>0]|0; //@line 61832 "c/sqlite3.c"
    $67 = $66&255; //@line 61832 "c/sqlite3.c"
    $68 = $64 | $67; //@line 61832 "c/sqlite3.c"
    $69 = ($32>>>0)>($68>>>0); //@line 61833 "c/sqlite3.c"
    if (!($69)) {
     $70 = (_sqlite3CorruptError(61834)|0); //@line 61834 "c/sqlite3.c"
     $$7 = $70;
     return ($$7|0); //@line 61903 "c/sqlite3.c"
    }
    if ($42) {
     $$0209 = $59;$$0210 = 0;
    } else {
     $71 = (($41) + 2)|0; //@line 61838 "c/sqlite3.c"
     $72 = (($3) + ($71)|0); //@line 61838 "c/sqlite3.c"
     $73 = HEAP8[$72>>0]|0; //@line 61838 "c/sqlite3.c"
     $74 = $73&255; //@line 61838 "c/sqlite3.c"
     $75 = $74 << 8; //@line 61838 "c/sqlite3.c"
     $76 = ((($72)) + 1|0); //@line 61838 "c/sqlite3.c"
     $77 = HEAP8[$76>>0]|0; //@line 61838 "c/sqlite3.c"
     $78 = $77&255; //@line 61838 "c/sqlite3.c"
     $79 = $75 | $78; //@line 61838 "c/sqlite3.c"
     $80 = (($59) + ($32))|0; //@line 61840 "c/sqlite3.c"
     $81 = (($79) + ($80))|0; //@line 61840 "c/sqlite3.c"
     $82 = (($3) + ($81)|0); //@line 61840 "c/sqlite3.c"
     $83 = (($3) + ($80)|0); //@line 61840 "c/sqlite3.c"
     $84 = (($41) - ($80))|0; //@line 61840 "c/sqlite3.c"
     _memmove(($82|0),($83|0),($84|0))|0; //@line 61840 "c/sqlite3.c"
     $85 = (($79) + ($59))|0; //@line 61841 "c/sqlite3.c"
     $$0209 = $85;$$0210 = $79;
    }
    $86 = (($$0209) + ($68))|0; //@line 61843 "c/sqlite3.c"
    $87 = (($3) + ($86)|0); //@line 61845 "c/sqlite3.c"
    $88 = (($3) + ($68)|0); //@line 61845 "c/sqlite3.c"
    $89 = (($32) - ($68))|0; //@line 61845 "c/sqlite3.c"
    _memmove(($87|0),($88|0),($89|0))|0; //@line 61845 "c/sqlite3.c"
    $90 = ($11<<16>>16)==(0); //@line 61846 "c/sqlite3.c"
    if ($90) {
     $$6218 = $86;
    } else {
     $91 = (($3) + ($9)|0); //@line 61846 "c/sqlite3.c"
     $$0211243 = $91;
     while(1) {
      $92 = HEAP8[$$0211243>>0]|0; //@line 61847 "c/sqlite3.c"
      $93 = $92&255; //@line 61847 "c/sqlite3.c"
      $94 = $93 << 8; //@line 61847 "c/sqlite3.c"
      $95 = ((($$0211243)) + 1|0); //@line 61847 "c/sqlite3.c"
      $96 = HEAP8[$95>>0]|0; //@line 61847 "c/sqlite3.c"
      $97 = $96&255; //@line 61847 "c/sqlite3.c"
      $98 = $94 | $97; //@line 61847 "c/sqlite3.c"
      $99 = ($98>>>0)<($32>>>0); //@line 61848 "c/sqlite3.c"
      if ($99) {
       $$0209$pn = $$0209;
       label = 14;
      } else {
       $100 = ($98>>>0)<($41>>>0); //@line 61849 "c/sqlite3.c"
       if ($100) {
        $$0209$pn = $$0210;
        label = 14;
       }
      }
      if ((label|0) == 14) {
       label = 0;
       $$sink = (($98) + ($$0209$pn))|0;
       $101 = $$sink >>> 8;
       $102 = $101&255;
       HEAP8[$$0211243>>0] = $102;
       $103 = $$sink&255;
       HEAP8[$95>>0] = $103;
      }
      $104 = ((($$0211243)) + 2|0); //@line 61846 "c/sqlite3.c"
      $105 = ($104>>>0)<($50>>>0); //@line 61846 "c/sqlite3.c"
      if ($105) {
       $$0211243 = $104;
      } else {
       $$6218 = $86;
       break;
      }
     }
    }
   }
  }
 } while(0);
 if ((label|0) == 16) {
  $106 = (($18) + -4)|0; //@line 61857 "c/sqlite3.c"
  $107 = ($11<<16>>16)==(0); //@line 61858 "c/sqlite3.c"
  L25: do {
   if ($107) {
    $$4216$lcssa = $18;
   } else {
    $108 = ((($0)) + 76|0);
    $109 = (($6) + 5)|0;
    $110 = (($3) + ($109)|0);
    $111 = ((($110)) + 1|0);
    $$0203242 = 0;$$0219240 = 0;$$0223239 = $3;$$4216241 = $18;
    while(1) {
     $112 = $$0203242 << 1; //@line 61860 "c/sqlite3.c"
     $113 = (($112) + ($9))|0; //@line 61860 "c/sqlite3.c"
     $114 = (($3) + ($113)|0); //@line 61860 "c/sqlite3.c"
     $115 = HEAP8[$114>>0]|0; //@line 61861 "c/sqlite3.c"
     $116 = $115&255; //@line 61861 "c/sqlite3.c"
     $117 = $116 << 8; //@line 61861 "c/sqlite3.c"
     $118 = ((($114)) + 1|0); //@line 61861 "c/sqlite3.c"
     $119 = HEAP8[$118>>0]|0; //@line 61861 "c/sqlite3.c"
     $120 = $119&255; //@line 61861 "c/sqlite3.c"
     $121 = $117 | $120; //@line 61861 "c/sqlite3.c"
     $122 = ($121>>>0)<($14>>>0); //@line 61867 "c/sqlite3.c"
     $123 = ($121|0)>($106|0); //@line 61867 "c/sqlite3.c"
     $or$cond = $122 | $123; //@line 61867 "c/sqlite3.c"
     if ($or$cond) {
      label = 19;
      break;
     }
     $125 = HEAP32[$108>>2]|0; //@line 61871 "c/sqlite3.c"
     $126 = (($$0223239) + ($121)|0); //@line 61871 "c/sqlite3.c"
     $127 = (FUNCTION_TABLE_iii[$125 & 255]($0,$126)|0); //@line 61871 "c/sqlite3.c"
     $128 = $127&65535; //@line 61871 "c/sqlite3.c"
     $129 = (($$4216241) - ($128))|0; //@line 61872 "c/sqlite3.c"
     $130 = ($129|0)<($14|0); //@line 61873 "c/sqlite3.c"
     $131 = (($121) + ($128))|0; //@line 61873 "c/sqlite3.c"
     $132 = ($131|0)>($18|0); //@line 61873 "c/sqlite3.c"
     $or$cond228 = $130 | $132; //@line 61873 "c/sqlite3.c"
     if ($or$cond228) {
      label = 21;
      break;
     }
     $134 = $129 >>> 8; //@line 61879 "c/sqlite3.c"
     $135 = $134&255; //@line 61879 "c/sqlite3.c"
     HEAP8[$114>>0] = $135; //@line 61879 "c/sqlite3.c"
     $136 = $129&255; //@line 61879 "c/sqlite3.c"
     HEAP8[$118>>0] = $136; //@line 61879 "c/sqlite3.c"
     $137 = ($$0219240|0)==(0|0); //@line 61880 "c/sqlite3.c"
     if ($137) {
      $138 = ($129|0)==($121|0); //@line 61882 "c/sqlite3.c"
      if ($138) {
       $$3222 = 0;$$3226 = $$0223239;
      } else {
       $139 = HEAP32[$15>>2]|0; //@line 61883 "c/sqlite3.c"
       $140 = HEAP32[$139>>2]|0; //@line 61883 "c/sqlite3.c"
       $141 = (_sqlite3PagerTempSpace($140)|0); //@line 61883 "c/sqlite3.c"
       $142 = HEAP8[$110>>0]|0; //@line 61884 "c/sqlite3.c"
       $143 = $142&255; //@line 61884 "c/sqlite3.c"
       $144 = $143 << 8; //@line 61884 "c/sqlite3.c"
       $145 = HEAP8[$111>>0]|0; //@line 61884 "c/sqlite3.c"
       $146 = $145&255; //@line 61884 "c/sqlite3.c"
       $147 = $144 | $146; //@line 61884 "c/sqlite3.c"
       $148 = (($141) + ($147)|0); //@line 61885 "c/sqlite3.c"
       $149 = (($3) + ($147)|0); //@line 61885 "c/sqlite3.c"
       $150 = (($$4216241) - ($147))|0; //@line 61885 "c/sqlite3.c"
       _memcpy(($148|0),($149|0),($150|0))|0; //@line 61885 "c/sqlite3.c"
       $$2221 = $141;$$2225 = $141;
       label = 25;
      }
     } else {
      $$2221 = $$0219240;$$2225 = $$0223239;
      label = 25;
     }
     if ((label|0) == 25) {
      label = 0;
      $151 = (($3) + ($129)|0); //@line 61888 "c/sqlite3.c"
      $152 = (($$2225) + ($121)|0); //@line 61888 "c/sqlite3.c"
      _memcpy(($151|0),($152|0),($128|0))|0; //@line 61888 "c/sqlite3.c"
      $$3222 = $$2221;$$3226 = $$2225;
     }
     $153 = (($$0203242) + 1)|0; //@line 61858 "c/sqlite3.c"
     $154 = ($153>>>0)<($12>>>0); //@line 61858 "c/sqlite3.c"
     if ($154) {
      $$0203242 = $153;$$0219240 = $$3222;$$0223239 = $$3226;$$4216241 = $129;
     } else {
      $$4216$lcssa = $129;
      break L25;
     }
    }
    if ((label|0) == 19) {
     $124 = (_sqlite3CorruptError(61868)|0); //@line 61868 "c/sqlite3.c"
     $$7 = $124;
     return ($$7|0); //@line 61903 "c/sqlite3.c"
    }
    else if ((label|0) == 21) {
     $133 = (_sqlite3CorruptError(61874)|0); //@line 61874 "c/sqlite3.c"
     $$7 = $133;
     return ($$7|0); //@line 61903 "c/sqlite3.c"
    }
   }
  } while(0);
  HEAP8[$20>>0] = 0; //@line 61890 "c/sqlite3.c"
  $$6218 = $$4216$lcssa;
 }
 $155 = HEAP8[$20>>0]|0; //@line 61893 "c/sqlite3.c"
 $156 = $155&255; //@line 61893 "c/sqlite3.c"
 $157 = (($$6218) - ($14))|0; //@line 61893 "c/sqlite3.c"
 $158 = (($157) + ($156))|0; //@line 61893 "c/sqlite3.c"
 $159 = ((($0)) + 20|0); //@line 61893 "c/sqlite3.c"
 $160 = HEAP16[$159>>1]|0; //@line 61893 "c/sqlite3.c"
 $161 = $160&65535; //@line 61893 "c/sqlite3.c"
 $162 = ($158|0)==($161|0); //@line 61893 "c/sqlite3.c"
 if ($162) {
  $164 = $$6218 >>> 8; //@line 61897 "c/sqlite3.c"
  $165 = $164&255; //@line 61897 "c/sqlite3.c"
  $166 = (($6) + 5)|0; //@line 61897 "c/sqlite3.c"
  $167 = (($3) + ($166)|0); //@line 61897 "c/sqlite3.c"
  HEAP8[$167>>0] = $165; //@line 61897 "c/sqlite3.c"
  $168 = $$6218&255; //@line 61897 "c/sqlite3.c"
  $169 = ((($167)) + 1|0); //@line 61897 "c/sqlite3.c"
  HEAP8[$169>>0] = $168; //@line 61897 "c/sqlite3.c"
  $170 = (($6) + 1)|0; //@line 61898 "c/sqlite3.c"
  $171 = (($3) + ($170)|0); //@line 61898 "c/sqlite3.c"
  HEAP8[$171>>0] = 0; //@line 61898 "c/sqlite3.c"
  $172 = (($6) + 2)|0; //@line 61899 "c/sqlite3.c"
  $173 = (($3) + ($172)|0); //@line 61899 "c/sqlite3.c"
  HEAP8[$173>>0] = 0; //@line 61899 "c/sqlite3.c"
  $174 = (($3) + ($14)|0); //@line 61900 "c/sqlite3.c"
  $175 = (($$6218) - ($14))|0; //@line 61900 "c/sqlite3.c"
  _memset(($174|0),0,($175|0))|0; //@line 61900 "c/sqlite3.c"
  $$7 = 0;
  return ($$7|0); //@line 61903 "c/sqlite3.c"
 } else {
  $163 = (_sqlite3CorruptError(61894)|0); //@line 61894 "c/sqlite3.c"
  $$7 = $163;
  return ($$7|0); //@line 61903 "c/sqlite3.c"
 }
 return (0)|0;
}
function _copyNodeContent($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$2>>2]|0; //@line 67524 "c/sqlite3.c"
 $4 = ($3|0)==(0); //@line 67524 "c/sqlite3.c"
 if (!($4)) {
  return;
 }
 $5 = ((($0)) + 52|0); //@line 67525 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 67525 "c/sqlite3.c"
 $7 = ((($0)) + 56|0); //@line 67526 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 67526 "c/sqlite3.c"
 $9 = ((($1)) + 56|0); //@line 67527 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 67527 "c/sqlite3.c"
 $11 = ((($0)) + 9|0); //@line 67528 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 67528 "c/sqlite3.c"
 $13 = $12&255; //@line 67528 "c/sqlite3.c"
 $14 = ((($1)) + 4|0); //@line 67529 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 67529 "c/sqlite3.c"
 $16 = ($15|0)==(1); //@line 67529 "c/sqlite3.c"
 $17 = $16 ? 100 : 0; //@line 67529 "c/sqlite3.c"
 $18 = (($13) + 5)|0; //@line 67539 "c/sqlite3.c"
 $19 = (($8) + ($18)|0); //@line 67539 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 67539 "c/sqlite3.c"
 $21 = $20&255; //@line 67539 "c/sqlite3.c"
 $22 = $21 << 8; //@line 67539 "c/sqlite3.c"
 $23 = ((($19)) + 1|0); //@line 67539 "c/sqlite3.c"
 $24 = HEAP8[$23>>0]|0; //@line 67539 "c/sqlite3.c"
 $25 = $24&255; //@line 67539 "c/sqlite3.c"
 $26 = $22 | $25; //@line 67539 "c/sqlite3.c"
 $27 = (($10) + ($26)|0); //@line 67540 "c/sqlite3.c"
 $28 = (($8) + ($26)|0); //@line 67540 "c/sqlite3.c"
 $29 = ((($6)) + 36|0); //@line 67540 "c/sqlite3.c"
 $30 = HEAP32[$29>>2]|0; //@line 67540 "c/sqlite3.c"
 $31 = (($30) - ($26))|0; //@line 67540 "c/sqlite3.c"
 _memcpy(($27|0),($28|0),($31|0))|0; //@line 67540 "c/sqlite3.c"
 $32 = (($10) + ($17)|0); //@line 67541 "c/sqlite3.c"
 $33 = (($8) + ($13)|0); //@line 67541 "c/sqlite3.c"
 $34 = ((($0)) + 18|0); //@line 67541 "c/sqlite3.c"
 $35 = HEAP16[$34>>1]|0; //@line 67541 "c/sqlite3.c"
 $36 = $35&65535; //@line 67541 "c/sqlite3.c"
 $37 = ((($0)) + 22|0); //@line 67541 "c/sqlite3.c"
 $38 = HEAP16[$37>>1]|0; //@line 67541 "c/sqlite3.c"
 $39 = $38&65535; //@line 67541 "c/sqlite3.c"
 $40 = $39 << 1; //@line 67541 "c/sqlite3.c"
 $41 = (($40) + ($36))|0; //@line 67541 "c/sqlite3.c"
 _memcpy(($32|0),($33|0),($41|0))|0; //@line 67541 "c/sqlite3.c"
 HEAP8[$1>>0] = 0; //@line 67548 "c/sqlite3.c"
 $42 = (_btreeInitPage($1)|0); //@line 67549 "c/sqlite3.c"
 $43 = ($42|0)==(0); //@line 67550 "c/sqlite3.c"
 if (!($43)) {
  HEAP32[$2>>2] = $42; //@line 67551 "c/sqlite3.c"
  return;
 }
 $44 = ((($6)) + 17|0); //@line 67558 "c/sqlite3.c"
 $45 = HEAP8[$44>>0]|0; //@line 67558 "c/sqlite3.c"
 $46 = ($45<<24>>24)==(0); //@line 67558 "c/sqlite3.c"
 if ($46) {
  return;
 }
 $47 = (_setChildPtrmaps($1)|0); //@line 67559 "c/sqlite3.c"
 HEAP32[$2>>2] = $47; //@line 67559 "c/sqlite3.c"
 return;
}
function _sqlite3PagerTempSpace($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 204|0); //@line 51782 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 51782 "c/sqlite3.c"
 return ($2|0); //@line 51782 "c/sqlite3.c"
}
function _pageFreeArray($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$06794 = 0, $$07193 = 0, $$07692 = 0, $$08191 = 0, $$172 = 0, $$370$ph = 0, $$4 = 0, $$475$ph = 0, $$480$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 56|0); //@line 67194 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 67194 "c/sqlite3.c"
 $6 = ((($0)) + 52|0); //@line 67195 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 67195 "c/sqlite3.c"
 $8 = ((($7)) + 36|0); //@line 67195 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 67195 "c/sqlite3.c"
 $10 = (($5) + ($9)|0); //@line 67195 "c/sqlite3.c"
 $11 = ((($0)) + 9|0); //@line 67196 "c/sqlite3.c"
 $12 = HEAP8[$11>>0]|0; //@line 67196 "c/sqlite3.c"
 $13 = $12&255; //@line 67196 "c/sqlite3.c"
 $14 = (($13) + 8)|0; //@line 67196 "c/sqlite3.c"
 $15 = ((($0)) + 10|0); //@line 67196 "c/sqlite3.c"
 $16 = HEAP8[$15>>0]|0; //@line 67196 "c/sqlite3.c"
 $17 = $16&255; //@line 67196 "c/sqlite3.c"
 $18 = (($14) + ($17))|0; //@line 67196 "c/sqlite3.c"
 $19 = (($5) + ($18)|0); //@line 67196 "c/sqlite3.c"
 $20 = (($2) + ($1))|0; //@line 67199 "c/sqlite3.c"
 $21 = ($2|0)>(0); //@line 67203 "c/sqlite3.c"
 if (!($21)) {
  $$4 = 0;
  return ($$4|0); //@line 67231 "c/sqlite3.c"
 }
 $22 = ((($3)) + 8|0);
 $23 = ((($3)) + 12|0);
 $24 = $5;
 $$06794 = 0;$$07193 = 0;$$07692 = 0;$$08191 = $1;
 while(1) {
  $25 = HEAP32[$22>>2]|0; //@line 67204 "c/sqlite3.c"
  $26 = (($25) + ($$08191<<2)|0); //@line 67204 "c/sqlite3.c"
  $27 = HEAP32[$26>>2]|0; //@line 67204 "c/sqlite3.c"
  $28 = ($27>>>0)>=($19>>>0); //@line 67205 "c/sqlite3.c"
  $29 = ($27>>>0)<($10>>>0); //@line 67205 "c/sqlite3.c"
  $or$cond = $28 & $29; //@line 67205 "c/sqlite3.c"
  if ($or$cond) {
   $30 = HEAP32[$23>>2]|0; //@line 67210 "c/sqlite3.c"
   $31 = (($30) + ($$08191<<1)|0); //@line 67210 "c/sqlite3.c"
   $32 = HEAP16[$31>>1]|0; //@line 67210 "c/sqlite3.c"
   $33 = $32&65535; //@line 67210 "c/sqlite3.c"
   $34 = (($27) + ($33)|0); //@line 67211 "c/sqlite3.c"
   $35 = ($$07692|0)==($34|0); //@line 67211 "c/sqlite3.c"
   if ($35) {
    $42 = (($$07193) + ($33))|0; //@line 67221 "c/sqlite3.c"
    $$172 = $42;
   } else {
    $36 = ($$07692|0)==(0|0); //@line 67212 "c/sqlite3.c"
    if (!($36)) {
     $37 = $$07692; //@line 67214 "c/sqlite3.c"
     $38 = (($37) - ($24))|0; //@line 67214 "c/sqlite3.c"
     $39 = $38&65535; //@line 67214 "c/sqlite3.c"
     $40 = $$07193&65535; //@line 67214 "c/sqlite3.c"
     (_freeSpace($0,$39,$40)|0); //@line 67214 "c/sqlite3.c"
    }
    $41 = ($34>>>0)>($10>>>0); //@line 67218 "c/sqlite3.c"
    if ($41) {
     $$4 = 0;
     label = 13;
     break;
    } else {
     $$172 = $33;
    }
   }
   $43 = (($$06794) + 1)|0; //@line 67223 "c/sqlite3.c"
   $$370$ph = $43;$$475$ph = $$172;$$480$ph = $27;
  } else {
   $$370$ph = $$06794;$$475$ph = $$07193;$$480$ph = $$07692;
  }
  $44 = (($$08191) + 1)|0; //@line 67203 "c/sqlite3.c"
  $45 = ($44|0)<($20|0); //@line 67203 "c/sqlite3.c"
  if ($45) {
   $$06794 = $$370$ph;$$07193 = $$475$ph;$$07692 = $$480$ph;$$08191 = $44;
  } else {
   break;
  }
 }
 if ((label|0) == 13) {
  return ($$4|0); //@line 67231 "c/sqlite3.c"
 }
 $46 = ($$480$ph|0)==(0|0); //@line 67226 "c/sqlite3.c"
 if ($46) {
  $$4 = $$370$ph;
  return ($$4|0); //@line 67231 "c/sqlite3.c"
 }
 $47 = $$480$ph; //@line 67228 "c/sqlite3.c"
 $48 = $5; //@line 67228 "c/sqlite3.c"
 $49 = (($47) - ($48))|0; //@line 67228 "c/sqlite3.c"
 $50 = $49&65535; //@line 67228 "c/sqlite3.c"
 $51 = $$475$ph&65535; //@line 67228 "c/sqlite3.c"
 (_freeSpace($0,$50,$51)|0); //@line 67228 "c/sqlite3.c"
 $$4 = $$370$ph;
 return ($$4|0); //@line 67231 "c/sqlite3.c"
}
function _pageInsertArray($0,$1,$2,$3,$4,$5,$6) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 $6 = $6|0;
 var $$045 = 0, $$04759 = 0, $$049$lcssa = 0, $$04957 = 0, $$05256 = 0, $$150 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $7 = sp;
 $8 = ((($0)) + 56|0); //@line 67152 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 67152 "c/sqlite3.c"
 $10 = HEAP32[$2>>2]|0; //@line 67153 "c/sqlite3.c"
 $11 = (($5) + ($4))|0; //@line 67154 "c/sqlite3.c"
 $12 = ($5|0)>(0); //@line 67156 "c/sqlite3.c"
 L1: do {
  if ($12) {
   $13 = ((($9)) + 1|0);
   $14 = ((($9)) + 2|0);
   $15 = $1;
   $16 = ((($6)) + 8|0);
   $17 = $9;
   $$04759 = $3;$$04957 = $10;$$05256 = $4;
   while(1) {
    $18 = (_cachedCellSize($6,$$05256)|0); //@line 67159 "c/sqlite3.c"
    $19 = $18&65535; //@line 67159 "c/sqlite3.c"
    $20 = HEAP8[$13>>0]|0; //@line 67160 "c/sqlite3.c"
    $21 = ($20<<24>>24)==(0); //@line 67160 "c/sqlite3.c"
    if ($21) {
     $22 = HEAP8[$14>>0]|0; //@line 67160 "c/sqlite3.c"
     $23 = ($22<<24>>24)==(0); //@line 67160 "c/sqlite3.c"
     if ($23) {
      label = 6;
     } else {
      label = 5;
     }
    } else {
     label = 5;
    }
    if ((label|0) == 5) {
     label = 0;
     $24 = (_pageFindSlot($0,$19,$7)|0); //@line 67160 "c/sqlite3.c"
     $25 = ($24|0)==(0|0); //@line 67160 "c/sqlite3.c"
     if ($25) {
      label = 6;
     } else {
      $$045 = $24;$$150 = $$04957;
     }
    }
    if ((label|0) == 6) {
     label = 0;
     $26 = $$04957; //@line 67161 "c/sqlite3.c"
     $27 = (($26) - ($15))|0; //@line 67161 "c/sqlite3.c"
     $28 = ($27|0)<($19|0); //@line 67161 "c/sqlite3.c"
     if ($28) {
      break;
     }
     $29 = (0 - ($19))|0; //@line 67162 "c/sqlite3.c"
     $30 = (($$04957) + ($29)|0); //@line 67162 "c/sqlite3.c"
     $$045 = $30;$$150 = $30;
    }
    $31 = HEAP32[$16>>2]|0; //@line 67171 "c/sqlite3.c"
    $32 = (($31) + ($$05256<<2)|0); //@line 67171 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 67171 "c/sqlite3.c"
    _memmove(($$045|0),($33|0),($19|0))|0; //@line 67171 "c/sqlite3.c"
    $34 = $$045; //@line 67172 "c/sqlite3.c"
    $35 = (($34) - ($17))|0; //@line 67172 "c/sqlite3.c"
    $36 = $35 >>> 8; //@line 67172 "c/sqlite3.c"
    $37 = $36&255; //@line 67172 "c/sqlite3.c"
    HEAP8[$$04759>>0] = $37; //@line 67172 "c/sqlite3.c"
    $38 = $35&255; //@line 67172 "c/sqlite3.c"
    $39 = ((($$04759)) + 1|0); //@line 67172 "c/sqlite3.c"
    HEAP8[$39>>0] = $38; //@line 67172 "c/sqlite3.c"
    $40 = ((($$04759)) + 2|0); //@line 67173 "c/sqlite3.c"
    $41 = (($$05256) + 1)|0; //@line 67156 "c/sqlite3.c"
    $42 = ($41|0)<($11|0); //@line 67156 "c/sqlite3.c"
    if ($42) {
     $$04759 = $40;$$04957 = $$150;$$05256 = $41;
    } else {
     $$049$lcssa = $$150;
     break L1;
    }
   }
   $$2 = 1;
   STACKTOP = sp;return ($$2|0); //@line 67177 "c/sqlite3.c"
  } else {
   $$049$lcssa = $10;
  }
 } while(0);
 HEAP32[$2>>2] = $$049$lcssa; //@line 67175 "c/sqlite3.c"
 $$2 = 0;
 STACKTOP = sp;return ($$2|0); //@line 67177 "c/sqlite3.c"
}
function _populateCellCache($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$01011 = 0, $$012 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)>(0); //@line 67032 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 67043 "c/sqlite3.c"
 }
 $4 = ((($0)) + 12|0);
 $5 = ((($0)) + 4|0);
 $6 = ((($0)) + 8|0);
 $$01011 = $1;$$012 = $2;
 while(1) {
  $7 = HEAP32[$4>>2]|0; //@line 67034 "c/sqlite3.c"
  $8 = (($7) + ($$01011<<1)|0); //@line 67034 "c/sqlite3.c"
  $9 = HEAP16[$8>>1]|0; //@line 67034 "c/sqlite3.c"
  $10 = ($9<<16>>16)==(0); //@line 67034 "c/sqlite3.c"
  if ($10) {
   $11 = HEAP32[$5>>2]|0; //@line 67035 "c/sqlite3.c"
   $12 = ((($11)) + 76|0); //@line 67035 "c/sqlite3.c"
   $13 = HEAP32[$12>>2]|0; //@line 67035 "c/sqlite3.c"
   $14 = HEAP32[$6>>2]|0; //@line 67035 "c/sqlite3.c"
   $15 = (($14) + ($$01011<<2)|0); //@line 67035 "c/sqlite3.c"
   $16 = HEAP32[$15>>2]|0; //@line 67035 "c/sqlite3.c"
   $17 = (FUNCTION_TABLE_iii[$13 & 255]($11,$16)|0); //@line 67035 "c/sqlite3.c"
   $18 = HEAP32[$4>>2]|0; //@line 67035 "c/sqlite3.c"
   $19 = (($18) + ($$01011<<1)|0); //@line 67035 "c/sqlite3.c"
   HEAP16[$19>>1] = $17; //@line 67035 "c/sqlite3.c"
  }
  $20 = (($$01011) + 1)|0; //@line 67040 "c/sqlite3.c"
  $21 = (($$012) + -1)|0; //@line 67041 "c/sqlite3.c"
  $22 = ($$012|0)>(1); //@line 67032 "c/sqlite3.c"
  if ($22) {
   $$01011 = $20;$$012 = $21;
  } else {
   break;
  }
 }
 return; //@line 67043 "c/sqlite3.c"
}
function _rebuildPage($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$087 = 0, $$088$lcssa = 0, $$08896 = 0, $$09095 = 0, $$09194 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 9|0); //@line 67079 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 67079 "c/sqlite3.c"
 $6 = $5&255; //@line 67079 "c/sqlite3.c"
 $7 = ((($0)) + 56|0); //@line 67080 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 67080 "c/sqlite3.c"
 $9 = ((($0)) + 52|0); //@line 67081 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 67081 "c/sqlite3.c"
 $11 = ((($10)) + 36|0); //@line 67081 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 67081 "c/sqlite3.c"
 $13 = (($8) + ($12)|0); //@line 67082 "c/sqlite3.c"
 $14 = ((($0)) + 64|0); //@line 67084 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 67084 "c/sqlite3.c"
 $16 = HEAP32[$10>>2]|0; //@line 67085 "c/sqlite3.c"
 $17 = (_sqlite3PagerTempSpace($16)|0); //@line 67085 "c/sqlite3.c"
 $18 = (($6) + 5)|0; //@line 67088 "c/sqlite3.c"
 $19 = (($8) + ($18)|0); //@line 67088 "c/sqlite3.c"
 $20 = HEAP8[$19>>0]|0; //@line 67088 "c/sqlite3.c"
 $21 = $20&255; //@line 67088 "c/sqlite3.c"
 $22 = $21 << 8; //@line 67088 "c/sqlite3.c"
 $23 = ((($19)) + 1|0); //@line 67088 "c/sqlite3.c"
 $24 = HEAP8[$23>>0]|0; //@line 67088 "c/sqlite3.c"
 $25 = $24&255; //@line 67088 "c/sqlite3.c"
 $26 = $22 | $25; //@line 67088 "c/sqlite3.c"
 $27 = (($17) + ($26)|0); //@line 67089 "c/sqlite3.c"
 $28 = (($8) + ($26)|0); //@line 67089 "c/sqlite3.c"
 $29 = (($12) - ($26))|0; //@line 67089 "c/sqlite3.c"
 _memcpy(($27|0),($28|0),($29|0))|0; //@line 67089 "c/sqlite3.c"
 $30 = ($1|0)>(0); //@line 67092 "c/sqlite3.c"
 L1: do {
  if ($30) {
   $31 = $8;
   $$08896 = $13;$$09095 = $15;$$09194 = 0;
   while(1) {
    $32 = (($2) + ($$09194<<2)|0); //@line 67093 "c/sqlite3.c"
    $33 = HEAP32[$32>>2]|0; //@line 67093 "c/sqlite3.c"
    $34 = (($3) + ($$09194<<1)|0); //@line 67097 "c/sqlite3.c"
    $35 = HEAP16[$34>>1]|0; //@line 67097 "c/sqlite3.c"
    $36 = $35&65535; //@line 67097 "c/sqlite3.c"
    $37 = (0 - ($36))|0; //@line 67097 "c/sqlite3.c"
    $38 = (($$08896) + ($37)|0); //@line 67097 "c/sqlite3.c"
    $39 = $38; //@line 67098 "c/sqlite3.c"
    $40 = (($39) - ($31))|0; //@line 67098 "c/sqlite3.c"
    $41 = $40 >>> 8; //@line 67098 "c/sqlite3.c"
    $42 = $41&255; //@line 67098 "c/sqlite3.c"
    HEAP8[$$09095>>0] = $42; //@line 67098 "c/sqlite3.c"
    $43 = $40&255; //@line 67098 "c/sqlite3.c"
    $44 = ((($$09095)) + 1|0); //@line 67098 "c/sqlite3.c"
    HEAP8[$44>>0] = $43; //@line 67098 "c/sqlite3.c"
    $45 = ((($$09095)) + 2|0); //@line 67099 "c/sqlite3.c"
    $46 = ($38>>>0)<($45>>>0); //@line 67100 "c/sqlite3.c"
    if ($46) {
     break;
    }
    $48 = ($33>>>0)>=($8>>>0); //@line 67094 "c/sqlite3.c"
    $49 = ($33>>>0)<($13>>>0); //@line 67094 "c/sqlite3.c"
    $or$cond = $48 & $49; //@line 67094 "c/sqlite3.c"
    $50 = $33; //@line 67094 "c/sqlite3.c"
    $51 = (($50) - ($31))|0; //@line 67095 "c/sqlite3.c"
    $52 = (($17) + ($51)|0); //@line 67095 "c/sqlite3.c"
    $$087 = $or$cond ? $52 : $33; //@line 67094 "c/sqlite3.c"
    $53 = HEAP16[$34>>1]|0; //@line 67101 "c/sqlite3.c"
    $54 = $53&65535; //@line 67101 "c/sqlite3.c"
    _memcpy(($38|0),($$087|0),($54|0))|0; //@line 67101 "c/sqlite3.c"
    $55 = (($$09194) + 1)|0; //@line 67092 "c/sqlite3.c"
    $56 = ($55|0)<($1|0); //@line 67092 "c/sqlite3.c"
    if ($56) {
     $$08896 = $38;$$09095 = $45;$$09194 = $55;
    } else {
     $$088$lcssa = $38;
     break L1;
    }
   }
   $47 = (_sqlite3CorruptError(67100)|0); //@line 67100 "c/sqlite3.c"
   $$2 = $47;
   return ($$2|0); //@line 67115 "c/sqlite3.c"
  } else {
   $$088$lcssa = $13;
  }
 } while(0);
 $57 = $1&65535; //@line 67107 "c/sqlite3.c"
 $58 = ((($0)) + 22|0); //@line 67107 "c/sqlite3.c"
 HEAP16[$58>>1] = $57; //@line 67107 "c/sqlite3.c"
 $59 = ((($0)) + 12|0); //@line 67108 "c/sqlite3.c"
 HEAP8[$59>>0] = 0; //@line 67108 "c/sqlite3.c"
 $60 = (($6) + 1)|0; //@line 67110 "c/sqlite3.c"
 $61 = (($8) + ($60)|0); //@line 67110 "c/sqlite3.c"
 HEAP8[$61>>0] = 0; //@line 67110 "c/sqlite3.c"
 $62 = ((($61)) + 1|0); //@line 67110 "c/sqlite3.c"
 HEAP8[$62>>0] = 0; //@line 67110 "c/sqlite3.c"
 $63 = HEAP16[$58>>1]|0; //@line 67111 "c/sqlite3.c"
 $64 = ($63&65535) >>> 8; //@line 67111 "c/sqlite3.c"
 $65 = $64&255; //@line 67111 "c/sqlite3.c"
 $66 = (($6) + 3)|0; //@line 67111 "c/sqlite3.c"
 $67 = (($8) + ($66)|0); //@line 67111 "c/sqlite3.c"
 HEAP8[$67>>0] = $65; //@line 67111 "c/sqlite3.c"
 $68 = HEAP16[$58>>1]|0; //@line 67111 "c/sqlite3.c"
 $69 = $68&255; //@line 67111 "c/sqlite3.c"
 $70 = ((($67)) + 1|0); //@line 67111 "c/sqlite3.c"
 HEAP8[$70>>0] = $69; //@line 67111 "c/sqlite3.c"
 $71 = $$088$lcssa; //@line 67112 "c/sqlite3.c"
 $72 = $8; //@line 67112 "c/sqlite3.c"
 $73 = (($71) - ($72))|0; //@line 67112 "c/sqlite3.c"
 $74 = $73 >>> 8; //@line 67112 "c/sqlite3.c"
 $75 = $74&255; //@line 67112 "c/sqlite3.c"
 HEAP8[$19>>0] = $75; //@line 67112 "c/sqlite3.c"
 $76 = $73&255; //@line 67112 "c/sqlite3.c"
 HEAP8[$23>>0] = $76; //@line 67112 "c/sqlite3.c"
 $77 = (($6) + 7)|0; //@line 67113 "c/sqlite3.c"
 $78 = (($8) + ($77)|0); //@line 67113 "c/sqlite3.c"
 HEAP8[$78>>0] = 0; //@line 67113 "c/sqlite3.c"
 $$2 = 0;
 return ($$2|0); //@line 67115 "c/sqlite3.c"
}
function _pageFindSlot($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$06270 = 0, $$06270$phi = 0, $$06369 = 0, $$1 = 0, $$sink98 = 0, $$sink99 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ((($0)) + 9|0); //@line 61920 "c/sqlite3.c"
 $4 = HEAP8[$3>>0]|0; //@line 61920 "c/sqlite3.c"
 $5 = $4&255; //@line 61920 "c/sqlite3.c"
 $6 = ((($0)) + 56|0); //@line 61921 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 61921 "c/sqlite3.c"
 $8 = (($5) + 1)|0; //@line 61922 "c/sqlite3.c"
 $9 = (($7) + ($8)|0); //@line 61923 "c/sqlite3.c"
 $10 = HEAP8[$9>>0]|0; //@line 61923 "c/sqlite3.c"
 $11 = $10&255; //@line 61923 "c/sqlite3.c"
 $12 = $11 << 8; //@line 61923 "c/sqlite3.c"
 $13 = ((($9)) + 1|0); //@line 61923 "c/sqlite3.c"
 $14 = HEAP8[$13>>0]|0; //@line 61923 "c/sqlite3.c"
 $15 = $14&255; //@line 61923 "c/sqlite3.c"
 $16 = $12 | $15; //@line 61923 "c/sqlite3.c"
 $17 = ((($0)) + 52|0); //@line 61925 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 61925 "c/sqlite3.c"
 $19 = ((($18)) + 36|0); //@line 61925 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 61925 "c/sqlite3.c"
 $21 = (($20) + -4)|0; //@line 61929 "c/sqlite3.c"
 $22 = ($16|0)>($21|0); //@line 61929 "c/sqlite3.c"
 L1: do {
  if ($22) {
   $$1 = $16;
  } else {
   $$06270 = $8;$$06369 = $16;
   while(1) {
    $23 = (($$06369) + 2)|0; //@line 61933 "c/sqlite3.c"
    $24 = (($7) + ($23)|0); //@line 61933 "c/sqlite3.c"
    $25 = HEAP8[$24>>0]|0; //@line 61933 "c/sqlite3.c"
    $26 = $25&255; //@line 61933 "c/sqlite3.c"
    $27 = $26 << 8; //@line 61933 "c/sqlite3.c"
    $28 = ((($24)) + 1|0); //@line 61933 "c/sqlite3.c"
    $29 = HEAP8[$28>>0]|0; //@line 61933 "c/sqlite3.c"
    $30 = $29&255; //@line 61933 "c/sqlite3.c"
    $31 = $27 | $30; //@line 61933 "c/sqlite3.c"
    $32 = (($31) - ($1))|0; //@line 61934 "c/sqlite3.c"
    $33 = ($32|0)>(-1); //@line 61934 "c/sqlite3.c"
    if ($33) {
     break;
    }
    $54 = (($7) + ($$06369)|0); //@line 61957 "c/sqlite3.c"
    $55 = HEAP8[$54>>0]|0; //@line 61957 "c/sqlite3.c"
    $56 = $55&255; //@line 61957 "c/sqlite3.c"
    $57 = $56 << 8; //@line 61957 "c/sqlite3.c"
    $58 = ((($54)) + 1|0); //@line 61957 "c/sqlite3.c"
    $59 = HEAP8[$58>>0]|0; //@line 61957 "c/sqlite3.c"
    $60 = $59&255; //@line 61957 "c/sqlite3.c"
    $61 = $57 | $60; //@line 61957 "c/sqlite3.c"
    $62 = (($31) + ($$06369))|0; //@line 61958 "c/sqlite3.c"
    $63 = ($61|0)<($62|0); //@line 61958 "c/sqlite3.c"
    $64 = ($61|0)>($21|0); //@line 61929 "c/sqlite3.c"
    $or$cond = $63 | $64; //@line 61958 "c/sqlite3.c"
    if ($or$cond) {
     $$1 = $61;
     break L1;
    } else {
     $$06270$phi = $$06369;$$06369 = $61;$$06270 = $$06270$phi;
    }
   }
   $34 = ((($24)) + 1|0); //@line 61933 "c/sqlite3.c"
   $35 = (($31) + ($$06369))|0; //@line 61937 "c/sqlite3.c"
   $36 = ($35|0)>($20|0); //@line 61937 "c/sqlite3.c"
   if ($36) {
    $37 = (_sqlite3CorruptError(61938)|0); //@line 61938 "c/sqlite3.c"
    HEAP32[$2>>2] = $37; //@line 61938 "c/sqlite3.c"
    $$0 = 0;
    return ($$0|0); //@line 61965 "c/sqlite3.c"
   }
   $38 = ($32|0)<(4); //@line 61940 "c/sqlite3.c"
   do {
    if ($38) {
     $39 = (($5) + 7)|0; //@line 61943 "c/sqlite3.c"
     $40 = (($7) + ($39)|0); //@line 61943 "c/sqlite3.c"
     $41 = HEAP8[$40>>0]|0; //@line 61943 "c/sqlite3.c"
     $42 = ($41&255)>(57); //@line 61943 "c/sqlite3.c"
     if ($42) {
      $$0 = 0;
      return ($$0|0); //@line 61965 "c/sqlite3.c"
     } else {
      $43 = (($7) + ($$06270)|0); //@line 61947 "c/sqlite3.c"
      $44 = (($7) + ($$06369)|0); //@line 61947 "c/sqlite3.c"
      $45 = HEAPU8[$44>>0]|(HEAPU8[$44+1>>0]<<8); //@line 61947 "c/sqlite3.c"
      HEAP8[$43>>0]=$45&255;HEAP8[$43+1>>0]=$45>>8; //@line 61947 "c/sqlite3.c"
      $46 = HEAP8[$40>>0]|0; //@line 61948 "c/sqlite3.c"
      $47 = $46&255; //@line 61948 "c/sqlite3.c"
      $48 = (($32) + ($47))|0; //@line 61948 "c/sqlite3.c"
      $$sink98 = $40;$$sink99 = $48;
      break;
     }
    } else {
     $49 = $32 >>> 8; //@line 61952 "c/sqlite3.c"
     $50 = $49&255; //@line 61952 "c/sqlite3.c"
     HEAP8[$24>>0] = $50; //@line 61952 "c/sqlite3.c"
     $$sink98 = $34;$$sink99 = $32;
    }
   } while(0);
   $51 = $$sink99&255;
   HEAP8[$$sink98>>0] = $51;
   $52 = (($32) + ($$06369))|0; //@line 61954 "c/sqlite3.c"
   $53 = (($7) + ($52)|0); //@line 61954 "c/sqlite3.c"
   $$0 = $53;
   return ($$0|0); //@line 61965 "c/sqlite3.c"
  }
 } while(0);
 $65 = ($$1|0)==(0); //@line 61960 "c/sqlite3.c"
 if ($65) {
  $$0 = 0;
  return ($$0|0); //@line 61965 "c/sqlite3.c"
 }
 $66 = (_sqlite3CorruptError(61961)|0); //@line 61961 "c/sqlite3.c"
 HEAP32[$2>>2] = $66; //@line 61961 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 61965 "c/sqlite3.c"
}
function _freeSpace($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0125 = 0, $$0127 = 0, $$0131163 = 0, $$0131164 = 0, $$0131164$phi = 0, $$0133 = 0, $$0137$off0 = 0, $$0137$off8 = 0, $$1 = 0, $$1126 = 0, $$1132 = 0, $$1138$off0 = 0, $$1138$off8 = 0, $$2 = 0, $$3 = 0, $$3130 = 0, $$3136 = 0, $$4 = 0, $$off8 = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0;
 var $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0;
 var $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $extract = 0;
 var $extract$t = 0, $extract$t171 = 0, $extract$t173 = 0, $extract170 = 0, $extract172 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $1&65535; //@line 62077 "c/sqlite3.c"
 $4 = $2&65535; //@line 62077 "c/sqlite3.c"
 $5 = (($4) + ($3))|0; //@line 62077 "c/sqlite3.c"
 $6 = ((($0)) + 56|0); //@line 62078 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 62078 "c/sqlite3.c"
 $8 = ((($0)) + 9|0); //@line 62091 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 62091 "c/sqlite3.c"
 $10 = $9&255; //@line 62092 "c/sqlite3.c"
 $11 = (($10) + 1)|0; //@line 62092 "c/sqlite3.c"
 $12 = $11&65535; //@line 62092 "c/sqlite3.c"
 $13 = (($10) + 2)|0; //@line 62093 "c/sqlite3.c"
 $14 = (($7) + ($13)|0); //@line 62093 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 62093 "c/sqlite3.c"
 $16 = ($15<<24>>24)==(0); //@line 62093 "c/sqlite3.c"
 if ($16) {
  $17 = (($7) + ($11)|0); //@line 62093 "c/sqlite3.c"
  $18 = HEAP8[$17>>0]|0; //@line 62093 "c/sqlite3.c"
  $19 = ($18<<24>>24)==(0); //@line 62093 "c/sqlite3.c"
  if ($19) {
   $$1126 = $5;$$1132 = $12;$$1138$off0 = 0;$$1138$off8 = 0;$$3 = $1;$$4 = $2;
  } else {
   label = 3;
  }
 } else {
  label = 3;
 }
 do {
  if ((label|0) == 3) {
   $20 = (($7) + ($11)|0); //@line 62096 "c/sqlite3.c"
   $21 = HEAP8[$20>>0]|0; //@line 62096 "c/sqlite3.c"
   $22 = $21&255; //@line 62096 "c/sqlite3.c"
   $23 = $22 << 8; //@line 62096 "c/sqlite3.c"
   $24 = ((($20)) + 1|0); //@line 62096 "c/sqlite3.c"
   $25 = HEAP8[$24>>0]|0; //@line 62096 "c/sqlite3.c"
   $26 = $25&255; //@line 62096 "c/sqlite3.c"
   $27 = $23 | $26; //@line 62096 "c/sqlite3.c"
   $28 = $27&65535; //@line 62096 "c/sqlite3.c"
   $29 = ($27>>>0)<($3>>>0); //@line 62096 "c/sqlite3.c"
   $extract170 = ($28&65535) >>> 8; //@line 62096 "c/sqlite3.c"
   $extract$t171 = $extract170&255; //@line 62096 "c/sqlite3.c"
   do {
    if ($29) {
     $$0131164 = $12;$161 = $26;$162 = $25;$31 = $28;$43 = $11;$45 = $27;
     while(1) {
      $42 = (($43) + 4)|0; //@line 62097 "c/sqlite3.c"
      $44 = ($45>>>0)<($42>>>0); //@line 62097 "c/sqlite3.c"
      if ($44) {
       break;
      }
      $30 = $31&65535; //@line 62096 "c/sqlite3.c"
      $32 = (($7) + ($30)|0); //@line 62096 "c/sqlite3.c"
      $33 = HEAP8[$32>>0]|0; //@line 62096 "c/sqlite3.c"
      $34 = $33&255; //@line 62096 "c/sqlite3.c"
      $35 = $34 << 8; //@line 62096 "c/sqlite3.c"
      $36 = ((($32)) + 1|0); //@line 62096 "c/sqlite3.c"
      $37 = HEAP8[$36>>0]|0; //@line 62096 "c/sqlite3.c"
      $38 = $37&255; //@line 62096 "c/sqlite3.c"
      $39 = $35 | $38; //@line 62096 "c/sqlite3.c"
      $40 = $39&65535; //@line 62096 "c/sqlite3.c"
      $41 = ($39>>>0)<($3>>>0); //@line 62096 "c/sqlite3.c"
      if ($41) {
       $$0131164$phi = $31;$161 = $38;$162 = $37;$31 = $40;$43 = $30;$45 = $39;$$0131164 = $$0131164$phi;
      } else {
       label = 9;
       break;
      }
     }
     if ((label|0) == 9) {
      $extract172 = ($40&65535) >>> 8; //@line 62096 "c/sqlite3.c"
      $extract$t173 = $extract172&255; //@line 62096 "c/sqlite3.c"
      $$0131163 = $31;$$off8 = $extract$t173;$160 = $37;$54 = $39;$60 = $38;$83 = $30;
      break;
     }
     $46 = ($45|0)==(0); //@line 62098 "c/sqlite3.c"
     $extract = ($31&65535) >>> 8; //@line 62098 "c/sqlite3.c"
     $extract$t = $extract&255; //@line 62098 "c/sqlite3.c"
     if ($46) {
      $$0131163 = $$0131164;$$off8 = $extract$t;$160 = $162;$54 = 0;$60 = $161;$83 = $43;
     } else {
      $47 = (_sqlite3CorruptError(62099)|0); //@line 62099 "c/sqlite3.c"
      $$1 = $47;
      return ($$1|0); //@line 62162 "c/sqlite3.c"
     }
    } else {
     $$0131163 = $12;$$off8 = $extract$t171;$160 = $25;$54 = $27;$60 = $26;$83 = $11;
    }
   } while(0);
   $48 = ((($0)) + 52|0); //@line 62103 "c/sqlite3.c"
   $49 = HEAP32[$48>>2]|0; //@line 62103 "c/sqlite3.c"
   $50 = ((($49)) + 36|0); //@line 62103 "c/sqlite3.c"
   $51 = HEAP32[$50>>2]|0; //@line 62103 "c/sqlite3.c"
   $52 = (($51) + -4)|0; //@line 62103 "c/sqlite3.c"
   $53 = ($54>>>0)>($52>>>0); //@line 62103 "c/sqlite3.c"
   if ($53) {
    $55 = (_sqlite3CorruptError(62104)|0); //@line 62104 "c/sqlite3.c"
    $$1 = $55;
    return ($$1|0); //@line 62162 "c/sqlite3.c"
   }
   $56 = (($5) + 3)|0; //@line 62114 "c/sqlite3.c"
   $57 = (($54) + -1)|0; //@line 62114 "c/sqlite3.c"
   $58 = ($57>>>0)<($56>>>0); //@line 62114 "c/sqlite3.c"
   do {
    if ($58) {
     $59 = (($60) - ($5))|0; //@line 62115 "c/sqlite3.c"
     $61 = $59&255; //@line 62115 "c/sqlite3.c"
     $62 = ($5>>>0)>($54>>>0); //@line 62116 "c/sqlite3.c"
     if ($62) {
      $63 = (_sqlite3CorruptError(62116)|0); //@line 62116 "c/sqlite3.c"
      $$1 = $63;
      return ($$1|0); //@line 62162 "c/sqlite3.c"
     }
     $64 = (($54) + 2)|0; //@line 62117 "c/sqlite3.c"
     $65 = (($7) + ($64)|0); //@line 62117 "c/sqlite3.c"
     $66 = HEAP8[$65>>0]|0; //@line 62117 "c/sqlite3.c"
     $67 = $66&255; //@line 62117 "c/sqlite3.c"
     $68 = $67 << 8; //@line 62117 "c/sqlite3.c"
     $69 = ((($65)) + 1|0); //@line 62117 "c/sqlite3.c"
     $70 = HEAP8[$69>>0]|0; //@line 62117 "c/sqlite3.c"
     $71 = $70&255; //@line 62117 "c/sqlite3.c"
     $72 = $68 | $71; //@line 62117 "c/sqlite3.c"
     $73 = (($72) + ($54))|0; //@line 62117 "c/sqlite3.c"
     $74 = ($73>>>0)>($51>>>0); //@line 62118 "c/sqlite3.c"
     if (!($74)) {
      $76 = (($73) - ($3))|0; //@line 62121 "c/sqlite3.c"
      $77 = $76&65535; //@line 62121 "c/sqlite3.c"
      $78 = (($7) + ($54)|0); //@line 62122 "c/sqlite3.c"
      $79 = HEAP8[$78>>0]|0; //@line 62122 "c/sqlite3.c"
      $80 = ((($78)) + 1|0); //@line 62122 "c/sqlite3.c"
      $81 = HEAP8[$80>>0]|0; //@line 62122 "c/sqlite3.c"
      $$0125 = $73;$$0127 = $77;$$0133 = $61;$$0137$off0 = $81;$$0137$off8 = $79;
      break;
     }
     $75 = (_sqlite3CorruptError(62119)|0); //@line 62119 "c/sqlite3.c"
     $$1 = $75;
     return ($$1|0); //@line 62162 "c/sqlite3.c"
    } else {
     $$0125 = $5;$$0127 = $2;$$0133 = 0;$$0137$off0 = $160;$$0137$off8 = $$off8;
    }
   } while(0);
   $82 = ($11>>>0)<($83>>>0); //@line 62129 "c/sqlite3.c"
   do {
    if ($82) {
     $84 = (($83) + 2)|0; //@line 62130 "c/sqlite3.c"
     $85 = (($7) + ($84)|0); //@line 62130 "c/sqlite3.c"
     $86 = HEAP8[$85>>0]|0; //@line 62130 "c/sqlite3.c"
     $87 = $86&255; //@line 62130 "c/sqlite3.c"
     $88 = $87 << 8; //@line 62130 "c/sqlite3.c"
     $89 = ((($85)) + 1|0); //@line 62130 "c/sqlite3.c"
     $90 = HEAP8[$89>>0]|0; //@line 62130 "c/sqlite3.c"
     $91 = $90&255; //@line 62130 "c/sqlite3.c"
     $92 = $88 | $91; //@line 62130 "c/sqlite3.c"
     $93 = (($92) + ($83))|0; //@line 62130 "c/sqlite3.c"
     $94 = (($93) + 3)|0; //@line 62131 "c/sqlite3.c"
     $95 = ($94>>>0)<($3>>>0); //@line 62131 "c/sqlite3.c"
     if ($95) {
      $$2 = $1;$$3130 = $$0127;$$3136 = $$0133;
     } else {
      $96 = ($93>>>0)>($3>>>0); //@line 62132 "c/sqlite3.c"
      if (!($96)) {
       $97 = $$0133&255; //@line 62133 "c/sqlite3.c"
       $98 = (($97) + ($3))|0; //@line 62133 "c/sqlite3.c"
       $99 = (($98) - ($93))|0; //@line 62133 "c/sqlite3.c"
       $100 = $99&255; //@line 62133 "c/sqlite3.c"
       $101 = (($$0125) - ($83))|0; //@line 62134 "c/sqlite3.c"
       $102 = $101&65535; //@line 62134 "c/sqlite3.c"
       $$2 = $$0131163;$$3130 = $102;$$3136 = $100;
       break;
      }
      $103 = (_sqlite3CorruptError(62132)|0); //@line 62132 "c/sqlite3.c"
      $$1 = $103;
      return ($$1|0); //@line 62162 "c/sqlite3.c"
     }
    } else {
     $$2 = $1;$$3130 = $$0127;$$3136 = $$0133;
    }
   } while(0);
   $104 = (($10) + 7)|0; //@line 62138 "c/sqlite3.c"
   $105 = (($7) + ($104)|0); //@line 62138 "c/sqlite3.c"
   $106 = HEAP8[$105>>0]|0; //@line 62138 "c/sqlite3.c"
   $107 = ($106&255)<($$3136&255); //@line 62138 "c/sqlite3.c"
   if (!($107)) {
    $109 = $106&255; //@line 62138 "c/sqlite3.c"
    $110 = $$3136&255; //@line 62138 "c/sqlite3.c"
    $111 = (($109) - ($110))|0; //@line 62139 "c/sqlite3.c"
    $112 = $111&255; //@line 62139 "c/sqlite3.c"
    HEAP8[$105>>0] = $112; //@line 62139 "c/sqlite3.c"
    $$1126 = $$0125;$$1132 = $$0131163;$$1138$off0 = $$0137$off0;$$1138$off8 = $$0137$off8;$$3 = $$2;$$4 = $$3130;
    break;
   }
   $108 = (_sqlite3CorruptError(62138)|0); //@line 62138 "c/sqlite3.c"
   $$1 = $108;
   return ($$1|0); //@line 62162 "c/sqlite3.c"
  }
 } while(0);
 $113 = (($10) + 5)|0; //@line 62141 "c/sqlite3.c"
 $114 = (($7) + ($113)|0); //@line 62141 "c/sqlite3.c"
 $115 = HEAP8[$114>>0]|0; //@line 62141 "c/sqlite3.c"
 $116 = $115&255; //@line 62141 "c/sqlite3.c"
 $117 = $116 << 8; //@line 62141 "c/sqlite3.c"
 $118 = ((($114)) + 1|0); //@line 62141 "c/sqlite3.c"
 $119 = HEAP8[$118>>0]|0; //@line 62141 "c/sqlite3.c"
 $120 = $119&255; //@line 62141 "c/sqlite3.c"
 $121 = $117 | $120; //@line 62141 "c/sqlite3.c"
 $122 = $$3&65535; //@line 62142 "c/sqlite3.c"
 $123 = ($121>>>0)<($122>>>0); //@line 62142 "c/sqlite3.c"
 do {
  if ($123) {
   $133 = ($$3&65535) >>> 8; //@line 62151 "c/sqlite3.c"
   $134 = $133&255; //@line 62151 "c/sqlite3.c"
   $135 = $$1132&65535; //@line 62151 "c/sqlite3.c"
   $136 = (($7) + ($135)|0); //@line 62151 "c/sqlite3.c"
   HEAP8[$136>>0] = $134; //@line 62151 "c/sqlite3.c"
   $137 = $$3&255; //@line 62151 "c/sqlite3.c"
   $138 = ((($136)) + 1|0); //@line 62151 "c/sqlite3.c"
   HEAP8[$138>>0] = $137; //@line 62151 "c/sqlite3.c"
  } else {
   $124 = ($121>>>0)<=($122>>>0); //@line 62146 "c/sqlite3.c"
   $125 = $$1132&65535; //@line 62146 "c/sqlite3.c"
   $126 = ($11|0)==($125|0); //@line 62146 "c/sqlite3.c"
   $or$cond = $126 & $124; //@line 62146 "c/sqlite3.c"
   if ($or$cond) {
    $128 = (($7) + ($11)|0); //@line 62147 "c/sqlite3.c"
    HEAP8[$128>>0] = $$1138$off8; //@line 62147 "c/sqlite3.c"
    $129 = ((($128)) + 1|0); //@line 62147 "c/sqlite3.c"
    HEAP8[$129>>0] = $$1138$off0; //@line 62147 "c/sqlite3.c"
    $130 = $$1126 >>> 8; //@line 62148 "c/sqlite3.c"
    $131 = $130&255; //@line 62148 "c/sqlite3.c"
    HEAP8[$114>>0] = $131; //@line 62148 "c/sqlite3.c"
    $132 = $$1126&255; //@line 62148 "c/sqlite3.c"
    HEAP8[$118>>0] = $132; //@line 62148 "c/sqlite3.c"
    break;
   }
   $127 = (_sqlite3CorruptError(62146)|0); //@line 62146 "c/sqlite3.c"
   $$1 = $127;
   return ($$1|0); //@line 62162 "c/sqlite3.c"
  }
 } while(0);
 $139 = ((($0)) + 52|0); //@line 62153 "c/sqlite3.c"
 $140 = HEAP32[$139>>2]|0; //@line 62153 "c/sqlite3.c"
 $141 = ((($140)) + 22|0); //@line 62153 "c/sqlite3.c"
 $142 = HEAP16[$141>>1]|0; //@line 62153 "c/sqlite3.c"
 $143 = $142 & 12; //@line 62153 "c/sqlite3.c"
 $144 = ($143<<16>>16)==(0); //@line 62153 "c/sqlite3.c"
 if (!($144)) {
  $145 = $$4&65535; //@line 62156 "c/sqlite3.c"
  $146 = (($7) + ($122)|0); //@line 62156 "c/sqlite3.c"
  _memset(($146|0),0,($145|0))|0; //@line 62156 "c/sqlite3.c"
 }
 $147 = (($7) + ($122)|0); //@line 62158 "c/sqlite3.c"
 HEAP8[$147>>0] = $$1138$off8; //@line 62158 "c/sqlite3.c"
 $148 = ((($147)) + 1|0); //@line 62158 "c/sqlite3.c"
 HEAP8[$148>>0] = $$1138$off0; //@line 62158 "c/sqlite3.c"
 $149 = ($$4&65535) >>> 8; //@line 62159 "c/sqlite3.c"
 $150 = $149&255; //@line 62159 "c/sqlite3.c"
 $151 = (($122) + 2)|0; //@line 62159 "c/sqlite3.c"
 $152 = (($7) + ($151)|0); //@line 62159 "c/sqlite3.c"
 HEAP8[$152>>0] = $150; //@line 62159 "c/sqlite3.c"
 $153 = $$4&255; //@line 62159 "c/sqlite3.c"
 $154 = ((($152)) + 1|0); //@line 62159 "c/sqlite3.c"
 HEAP8[$154>>0] = $153; //@line 62159 "c/sqlite3.c"
 $155 = ((($0)) + 20|0); //@line 62160 "c/sqlite3.c"
 $156 = HEAP16[$155>>1]|0; //@line 62160 "c/sqlite3.c"
 $157 = $156&65535; //@line 62160 "c/sqlite3.c"
 $158 = (($157) + ($4))|0; //@line 62160 "c/sqlite3.c"
 $159 = $158&65535; //@line 62160 "c/sqlite3.c"
 HEAP16[$155>>1] = $159; //@line 62160 "c/sqlite3.c"
 $$1 = 0;
 return ($$1|0); //@line 62162 "c/sqlite3.c"
}
function _computeCellSize($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0); //@line 67051 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 67051 "c/sqlite3.c"
 $4 = ((($3)) + 76|0); //@line 67051 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 67051 "c/sqlite3.c"
 $6 = ((($0)) + 8|0); //@line 67051 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 67051 "c/sqlite3.c"
 $8 = (($7) + ($1<<2)|0); //@line 67051 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 67051 "c/sqlite3.c"
 $10 = (FUNCTION_TABLE_iii[$5 & 255]($3,$9)|0); //@line 67051 "c/sqlite3.c"
 $11 = ((($0)) + 12|0); //@line 67051 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 67051 "c/sqlite3.c"
 $13 = (($12) + ($1<<1)|0); //@line 67051 "c/sqlite3.c"
 HEAP16[$13>>1] = $10; //@line 67051 "c/sqlite3.c"
 return ($10|0); //@line 67052 "c/sqlite3.c"
}
function _allocateSpace($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$057 = 0, $$1 = 0, $$158 = 0, $$neg61 = 0, $$old = 0, $$old59 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ((($0)) + 9|0); //@line 61981 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 61981 "c/sqlite3.c"
 $6 = $5&255; //@line 61981 "c/sqlite3.c"
 $7 = ((($0)) + 56|0); //@line 61982 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 61982 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 61984 "c/sqlite3.c"
 $9 = ((($0)) + 18|0); //@line 61996 "c/sqlite3.c"
 $10 = HEAP16[$9>>1]|0; //@line 61996 "c/sqlite3.c"
 $11 = $10&65535; //@line 61996 "c/sqlite3.c"
 $12 = ((($0)) + 22|0); //@line 61996 "c/sqlite3.c"
 $13 = HEAP16[$12>>1]|0; //@line 61996 "c/sqlite3.c"
 $14 = $13&65535; //@line 61996 "c/sqlite3.c"
 $15 = $14 << 1; //@line 61996 "c/sqlite3.c"
 $16 = (($15) + ($11))|0; //@line 61996 "c/sqlite3.c"
 $17 = (($6) + 5)|0; //@line 62003 "c/sqlite3.c"
 $18 = (($8) + ($17)|0); //@line 62003 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 62003 "c/sqlite3.c"
 $20 = $19&255; //@line 62003 "c/sqlite3.c"
 $21 = $20 << 8; //@line 62003 "c/sqlite3.c"
 $22 = ((($18)) + 1|0); //@line 62003 "c/sqlite3.c"
 $23 = HEAP8[$22>>0]|0; //@line 62003 "c/sqlite3.c"
 $24 = $23&255; //@line 62003 "c/sqlite3.c"
 $25 = $21 | $24; //@line 62003 "c/sqlite3.c"
 $26 = ($16>>>0)>($25>>>0); //@line 62005 "c/sqlite3.c"
 do {
  if ($26) {
   $27 = ($25|0)==(0); //@line 62006 "c/sqlite3.c"
   if ($27) {
    $28 = ((($0)) + 52|0); //@line 62006 "c/sqlite3.c"
    $29 = HEAP32[$28>>2]|0; //@line 62006 "c/sqlite3.c"
    $30 = ((($29)) + 36|0); //@line 62006 "c/sqlite3.c"
    $31 = HEAP32[$30>>2]|0; //@line 62006 "c/sqlite3.c"
    $32 = ($31|0)==(65536); //@line 62006 "c/sqlite3.c"
    if ($32) {
     $$057 = 65536;
     break;
    }
   }
   $33 = (_sqlite3CorruptError(62009)|0); //@line 62009 "c/sqlite3.c"
   $$1 = $33;
   STACKTOP = sp;return ($$1|0); //@line 62055 "c/sqlite3.c"
  } else {
   $$057 = $25;
  }
 } while(0);
 $34 = (($6) + 2)|0; //@line 62020 "c/sqlite3.c"
 $35 = (($8) + ($34)|0); //@line 62020 "c/sqlite3.c"
 $36 = HEAP8[$35>>0]|0; //@line 62020 "c/sqlite3.c"
 $37 = ($36<<24>>24)==(0); //@line 62020 "c/sqlite3.c"
 if ($37) {
  $38 = (($6) + 1)|0; //@line 62020 "c/sqlite3.c"
  $39 = (($8) + ($38)|0); //@line 62020 "c/sqlite3.c"
  $40 = HEAP8[$39>>0]|0; //@line 62020 "c/sqlite3.c"
  $41 = ($40<<24>>24)==(0); //@line 62020 "c/sqlite3.c"
  $42 = (($16) + 2)|0; //@line 62020 "c/sqlite3.c"
  $43 = ($42|0)>($$057|0); //@line 62020 "c/sqlite3.c"
  $or$cond = $43 | $41; //@line 62020 "c/sqlite3.c"
  if (!($or$cond)) {
   label = 8;
  }
 } else {
  $$old = (($16) + 2)|0; //@line 62020 "c/sqlite3.c"
  $$old59 = ($$old|0)>($$057|0); //@line 62020 "c/sqlite3.c"
  if (!($$old59)) {
   label = 8;
  }
 }
 do {
  if ((label|0) == 8) {
   $44 = (_pageFindSlot($0,$1,$3)|0); //@line 62021 "c/sqlite3.c"
   $45 = ($44|0)==(0|0); //@line 62022 "c/sqlite3.c"
   if ($45) {
    $49 = HEAP32[$3>>2]|0; //@line 62026 "c/sqlite3.c"
    $50 = ($49|0)==(0); //@line 62026 "c/sqlite3.c"
    if ($50) {
     break;
    } else {
     $$1 = $49;
    }
    STACKTOP = sp;return ($$1|0); //@line 62055 "c/sqlite3.c"
   } else {
    $46 = $44; //@line 62024 "c/sqlite3.c"
    $47 = $8; //@line 62024 "c/sqlite3.c"
    $48 = (($46) - ($47))|0; //@line 62024 "c/sqlite3.c"
    HEAP32[$2>>2] = $48; //@line 62024 "c/sqlite3.c"
    $$1 = 0;
    STACKTOP = sp;return ($$1|0); //@line 62055 "c/sqlite3.c"
   }
  }
 } while(0);
 $51 = (($16) + 2)|0; //@line 62035 "c/sqlite3.c"
 $52 = (($51) + ($1))|0; //@line 62035 "c/sqlite3.c"
 $53 = ($52|0)>($$057|0); //@line 62035 "c/sqlite3.c"
 do {
  if ($53) {
   $54 = ((($0)) + 20|0); //@line 62037 "c/sqlite3.c"
   $55 = HEAP16[$54>>1]|0; //@line 62037 "c/sqlite3.c"
   $56 = $55&65535; //@line 62037 "c/sqlite3.c"
   $$neg61 = (-2 - ($1))|0; //@line 62037 "c/sqlite3.c"
   $57 = (($$neg61) + ($56))|0; //@line 62037 "c/sqlite3.c"
   $58 = ($57|0)<(4); //@line 62037 "c/sqlite3.c"
   $spec$select = $58 ? $57 : 4; //@line 62037 "c/sqlite3.c"
   $59 = (_defragmentPage($0,$spec$select)|0); //@line 62037 "c/sqlite3.c"
   HEAP32[$3>>2] = $59; //@line 62037 "c/sqlite3.c"
   $60 = ($59|0)==(0); //@line 62038 "c/sqlite3.c"
   if ($60) {
    $61 = HEAP8[$18>>0]|0; //@line 62039 "c/sqlite3.c"
    $62 = $61&255; //@line 62039 "c/sqlite3.c"
    $63 = $62 << 8; //@line 62039 "c/sqlite3.c"
    $64 = HEAP8[$22>>0]|0; //@line 62039 "c/sqlite3.c"
    $65 = $64&255; //@line 62039 "c/sqlite3.c"
    $66 = $63 | $65; //@line 62039 "c/sqlite3.c"
    $67 = (($66) + 65535)|0; //@line 62039 "c/sqlite3.c"
    $68 = $67 & 65535; //@line 62039 "c/sqlite3.c"
    $69 = (($68) + 1)|0; //@line 62039 "c/sqlite3.c"
    $$158 = $69;
    break;
   } else {
    $$1 = $59;
    STACKTOP = sp;return ($$1|0); //@line 62055 "c/sqlite3.c"
   }
  } else {
   $$158 = $$057;
  }
 } while(0);
 $70 = (($$158) - ($1))|0; //@line 62050 "c/sqlite3.c"
 $71 = $70 >>> 8; //@line 62051 "c/sqlite3.c"
 $72 = $71&255; //@line 62051 "c/sqlite3.c"
 HEAP8[$18>>0] = $72; //@line 62051 "c/sqlite3.c"
 $73 = $70&255; //@line 62051 "c/sqlite3.c"
 HEAP8[$22>>0] = $73; //@line 62051 "c/sqlite3.c"
 HEAP32[$2>>2] = $70; //@line 62053 "c/sqlite3.c"
 $$1 = 0;
 STACKTOP = sp;return ($$1|0); //@line 62055 "c/sqlite3.c"
}
function _fillInCell($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0127 = 0, $$0130 = 0, $$0131 = 0, $$0133 = 0, $$0133$ph = 0, $$0136$ph = 0, $$0139$ph = 0, $$0142 = 0, $$0142$ph = 0, $$0145 = 0, $$1128 = 0, $$1128$ph = 0, $$1132 = 0, $$1132$ph = 0, $$1146 = 0, $$1146$ph = 0, $$2149 = 0, $$3 = 0, $$promoted = 0, $10 = 0;
 var $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0;
 var $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0;
 var $or$cond164 = 0, $phitmp = 0, $phitmp151 = 0, $spec$select = 0, $spec$select152 = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $4 = sp + 8|0;
 $5 = sp + 4|0;
 $6 = sp;
 $7 = ((($0)) + 10|0); //@line 66705 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 66705 "c/sqlite3.c"
 $9 = $8&255; //@line 66705 "c/sqlite3.c"
 $10 = ((($0)) + 2|0); //@line 66706 "c/sqlite3.c"
 $11 = HEAP8[$10>>0]|0; //@line 66706 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 66706 "c/sqlite3.c"
 if ($12) {
  $39 = ((($2)) + 8|0); //@line 66715 "c/sqlite3.c"
  $40 = $39; //@line 66715 "c/sqlite3.c"
  $41 = $40; //@line 66715 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 66715 "c/sqlite3.c"
  $43 = (($40) + 4)|0; //@line 66715 "c/sqlite3.c"
  $44 = $43; //@line 66715 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 66715 "c/sqlite3.c"
  $46 = HEAP32[$2>>2]|0; //@line 66716 "c/sqlite3.c"
  $47 = ($42>>>0)<(128); //@line 66717 "c/sqlite3.c"
  if ($47) {
   $48 = $42&255; //@line 66717 "c/sqlite3.c"
   $49 = (($1) + ($9)|0); //@line 66717 "c/sqlite3.c"
   HEAP8[$49>>0] = $48; //@line 66717 "c/sqlite3.c"
   $55 = 1;
  } else {
   $50 = (($1) + ($9)|0); //@line 66717 "c/sqlite3.c"
   $51 = ($42|0)<(0); //@line 66717 "c/sqlite3.c"
   $52 = $51 << 31 >> 31; //@line 66717 "c/sqlite3.c"
   $53 = (_sqlite3PutVarint($50,$42,$52)|0); //@line 66717 "c/sqlite3.c"
   $phitmp = $53 & 255; //@line 66717 "c/sqlite3.c"
   $55 = $phitmp;
  }
  $54 = (($55) + ($9))|0; //@line 66717 "c/sqlite3.c"
  $$0127 = $42;$$0130 = $54;$$0131 = $46;$$0145 = $42;
 } else {
  $13 = ((($2)) + 28|0); //@line 66707 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 66707 "c/sqlite3.c"
  $15 = ((($2)) + 32|0); //@line 66707 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 66707 "c/sqlite3.c"
  $17 = (($16) + ($14))|0; //@line 66707 "c/sqlite3.c"
  $18 = ((($2)) + 16|0); //@line 66708 "c/sqlite3.c"
  $19 = HEAP32[$18>>2]|0; //@line 66708 "c/sqlite3.c"
  $20 = ($17>>>0)<(128); //@line 66711 "c/sqlite3.c"
  if ($20) {
   $21 = $17&255; //@line 66711 "c/sqlite3.c"
   $22 = (($1) + ($9)|0); //@line 66711 "c/sqlite3.c"
   HEAP8[$22>>0] = $21; //@line 66711 "c/sqlite3.c"
   $28 = 1;
  } else {
   $23 = (($1) + ($9)|0); //@line 66711 "c/sqlite3.c"
   $24 = ($17|0)<(0); //@line 66711 "c/sqlite3.c"
   $25 = $24 << 31 >> 31; //@line 66711 "c/sqlite3.c"
   $26 = (_sqlite3PutVarint($23,$17,$25)|0); //@line 66711 "c/sqlite3.c"
   $phitmp151 = $26 & 255; //@line 66711 "c/sqlite3.c"
   $28 = $phitmp151;
  }
  $27 = (($28) + ($9))|0; //@line 66711 "c/sqlite3.c"
  $29 = (($1) + ($27)|0); //@line 66712 "c/sqlite3.c"
  $30 = ((($2)) + 8|0); //@line 66712 "c/sqlite3.c"
  $31 = $30; //@line 66712 "c/sqlite3.c"
  $32 = $31; //@line 66712 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 66712 "c/sqlite3.c"
  $34 = (($31) + 4)|0; //@line 66712 "c/sqlite3.c"
  $35 = $34; //@line 66712 "c/sqlite3.c"
  $36 = HEAP32[$35>>2]|0; //@line 66712 "c/sqlite3.c"
  $37 = (_sqlite3PutVarint($29,$33,$36)|0); //@line 66712 "c/sqlite3.c"
  $38 = (($37) + ($27))|0; //@line 66712 "c/sqlite3.c"
  $$0127 = $17;$$0130 = $38;$$0131 = $19;$$0145 = $14;
 }
 $56 = (($1) + ($$0130)|0); //@line 66721 "c/sqlite3.c"
 $57 = ((($0)) + 14|0); //@line 66722 "c/sqlite3.c"
 $58 = HEAP16[$57>>1]|0; //@line 66722 "c/sqlite3.c"
 $59 = $58&65535; //@line 66722 "c/sqlite3.c"
 $60 = ($$0127|0)>($59|0); //@line 66722 "c/sqlite3.c"
 if (!($60)) {
  $61 = (($$0127) + ($$0130))|0; //@line 66725 "c/sqlite3.c"
  $62 = ($61|0)>(4); //@line 66728 "c/sqlite3.c"
  $spec$store$select = $62 ? $61 : 4; //@line 66728 "c/sqlite3.c"
  HEAP32[$3>>2] = $spec$store$select; //@line 66729 "c/sqlite3.c"
  _memcpy(($56|0),($$0131|0),($$0145|0))|0; //@line 66732 "c/sqlite3.c"
  $63 = (($56) + ($$0145)|0); //@line 66733 "c/sqlite3.c"
  $64 = (($$0127) - ($$0145))|0; //@line 66733 "c/sqlite3.c"
  _memset(($63|0),0,($64|0))|0; //@line 66733 "c/sqlite3.c"
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 66860 "c/sqlite3.c"
 }
 $65 = ((($0)) + 16|0); //@line 66740 "c/sqlite3.c"
 $66 = HEAP16[$65>>1]|0; //@line 66740 "c/sqlite3.c"
 $67 = $66&65535; //@line 66740 "c/sqlite3.c"
 $68 = (($$0127) - ($67))|0; //@line 66741 "c/sqlite3.c"
 $69 = ((($0)) + 52|0); //@line 66741 "c/sqlite3.c"
 $70 = HEAP32[$69>>2]|0; //@line 66741 "c/sqlite3.c"
 $71 = ((($70)) + 36|0); //@line 66741 "c/sqlite3.c"
 $72 = HEAP32[$71>>2]|0; //@line 66741 "c/sqlite3.c"
 $73 = (($72) + -4)|0; //@line 66741 "c/sqlite3.c"
 $74 = (($68>>>0) % ($73>>>0))&-1; //@line 66741 "c/sqlite3.c"
 $75 = (($74) + ($67))|0; //@line 66741 "c/sqlite3.c"
 $76 = ($75|0)>($59|0); //@line 66744 "c/sqlite3.c"
 $spec$select = $76 ? $67 : $75; //@line 66744 "c/sqlite3.c"
 $77 = (($spec$select) + ($$0130))|0; //@line 66746 "c/sqlite3.c"
 $78 = (($77) + 4)|0; //@line 66746 "c/sqlite3.c"
 HEAP32[$3>>2] = $78; //@line 66746 "c/sqlite3.c"
 $79 = (($1) + ($77)|0); //@line 66747 "c/sqlite3.c"
 HEAP32[$5>>2] = 0; //@line 66749 "c/sqlite3.c"
 $80 = ((($70)) + 17|0);
 $81 = ((($70)) + 32|0);
 $$0133$ph = $56;$$0136$ph = $79;$$0139$ph = 0;$$0142$ph = $spec$select;$$1128$ph = $$0127;$$1132$ph = $$0131;$$1146$ph = $$0145;
 L17: while(1) {
  $$0133 = $$0133$ph;$$0142 = $$0142$ph;$$1128 = $$1128$ph;$$1132 = $$1132$ph;$$1146 = $$1146$ph;
  while(1) {
   $82 = ($$1128|0)>($$0142|0); //@line 66778 "c/sqlite3.c"
   $spec$select152 = $82 ? $$0142 : $$1128; //@line 66778 "c/sqlite3.c"
   $83 = ($$1146|0)<($spec$select152|0); //@line 66789 "c/sqlite3.c"
   do {
    if ($83) {
     $84 = ($$1146|0)>(0); //@line 66791 "c/sqlite3.c"
     if ($84) {
      _memcpy(($$0133|0),($$1132|0),($$1146|0))|0; //@line 66793 "c/sqlite3.c"
      $$2149 = $$1146;
      break;
     } else {
      _memset(($$0133|0),0,($spec$select152|0))|0; //@line 66795 "c/sqlite3.c"
      $$2149 = $spec$select152;
      break;
     }
    } else {
     _memcpy(($$0133|0),($$1132|0),($spec$select152|0))|0; //@line 66790 "c/sqlite3.c"
     $$2149 = $spec$select152;
    }
   } while(0);
   $85 = (($$1128) - ($$2149))|0; //@line 66797 "c/sqlite3.c"
   $86 = ($85|0)<(1); //@line 66798 "c/sqlite3.c"
   if ($86) {
    label = 31;
    break L17;
   }
   $87 = (($$0133) + ($$2149)|0); //@line 66799 "c/sqlite3.c"
   $88 = (($$1132) + ($$2149)|0); //@line 66800 "c/sqlite3.c"
   $89 = (($$1146) - ($$2149))|0; //@line 66801 "c/sqlite3.c"
   $90 = (($$0142) - ($$2149))|0; //@line 66802 "c/sqlite3.c"
   $91 = ($90|0)==(0); //@line 66803 "c/sqlite3.c"
   if ($91) {
    break;
   } else {
    $$0133 = $87;$$0142 = $90;$$1128 = $85;$$1132 = $88;$$1146 = $89;
   }
  }
  HEAP32[$6>>2] = 0; //@line 66804 "c/sqlite3.c"
  $92 = HEAP32[$5>>2]|0; //@line 66806 "c/sqlite3.c"
  $93 = HEAP8[$80>>0]|0; //@line 66807 "c/sqlite3.c"
  $94 = ($93<<24>>24)==(0); //@line 66807 "c/sqlite3.c"
  if (!($94)) {
   $95 = HEAP32[513]|0;
   $96 = HEAP32[$81>>2]|0;
   $97 = (($95>>>0) / ($96>>>0))&-1;
   $$promoted = HEAP32[$5>>2]|0; //@line 66809 "c/sqlite3.c"
   $99 = $$promoted;
   while(1) {
    $98 = (($99) + 1)|0; //@line 66809 "c/sqlite3.c"
    $100 = (_ptrmapPageno($70,$98)|0); //@line 66811 "c/sqlite3.c"
    $101 = ($100|0)==($98|0); //@line 66811 "c/sqlite3.c"
    $102 = ($99|0)==($97|0); //@line 66811 "c/sqlite3.c"
    $or$cond164 = $101 | $102; //@line 66811 "c/sqlite3.c"
    if ($or$cond164) {
     $99 = $98;
    } else {
     break;
    }
   }
   HEAP32[$5>>2] = $98; //@line 66809 "c/sqlite3.c"
  }
  $103 = HEAP32[$5>>2]|0; //@line 66815 "c/sqlite3.c"
  $104 = (_allocateBtreePage($70,$6,$5,$103,0)|0); //@line 66815 "c/sqlite3.c"
  HEAP32[$4>>2] = $104; //@line 66815 "c/sqlite3.c"
  $105 = HEAP8[$80>>0]|0; //@line 66827 "c/sqlite3.c"
  $106 = ($105<<24>>24)!=(0); //@line 66827 "c/sqlite3.c"
  $107 = ($104|0)==(0); //@line 66827 "c/sqlite3.c"
  $or$cond = $107 & $106; //@line 66827 "c/sqlite3.c"
  if ($or$cond) {
   $108 = ($92|0)==(0); //@line 66828 "c/sqlite3.c"
   $109 = $108 ? 3 : 4; //@line 66828 "c/sqlite3.c"
   $110 = HEAP32[$5>>2]|0; //@line 66829 "c/sqlite3.c"
   _ptrmapPut($70,$110,$109,$92,$4); //@line 66829 "c/sqlite3.c"
   $111 = HEAP32[$4>>2]|0; //@line 66830 "c/sqlite3.c"
   $112 = ($111|0)==(0); //@line 66830 "c/sqlite3.c"
   if (!($112)) {
    label = 27;
    break;
   }
  } else {
   $114 = ($104|0)==(0); //@line 66835 "c/sqlite3.c"
   if (!($114)) {
    $123 = $104;
    break;
   }
  }
  $115 = HEAP32[$5>>2]|0; //@line 66849 "c/sqlite3.c"
  _sqlite3Put4byte($$0136$ph,$115); //@line 66849 "c/sqlite3.c"
  _releasePage($$0139$ph); //@line 66850 "c/sqlite3.c"
  $116 = HEAP32[$6>>2]|0; //@line 66851 "c/sqlite3.c"
  $117 = ((($116)) + 56|0); //@line 66852 "c/sqlite3.c"
  $118 = HEAP32[$117>>2]|0; //@line 66852 "c/sqlite3.c"
  _sqlite3Put4byte($118,0); //@line 66853 "c/sqlite3.c"
  $119 = HEAP32[$117>>2]|0; //@line 66854 "c/sqlite3.c"
  $120 = ((($119)) + 4|0); //@line 66854 "c/sqlite3.c"
  $121 = HEAP32[$71>>2]|0; //@line 66855 "c/sqlite3.c"
  $122 = (($121) + -4)|0; //@line 66855 "c/sqlite3.c"
  $$0133$ph = $120;$$0136$ph = $118;$$0139$ph = $116;$$0142$ph = $122;$$1128$ph = $85;$$1132$ph = $88;$$1146$ph = $89;
 }
 if ((label|0) == 27) {
  $113 = HEAP32[$6>>2]|0; //@line 66831 "c/sqlite3.c"
  _releasePage($113); //@line 66831 "c/sqlite3.c"
  $123 = $111;
 }
 else if ((label|0) == 31) {
  _releasePage($$0139$ph); //@line 66858 "c/sqlite3.c"
  $$3 = 0;
  STACKTOP = sp;return ($$3|0); //@line 66860 "c/sqlite3.c"
 }
 _releasePage($$0139$ph); //@line 66836 "c/sqlite3.c"
 $$3 = $123;
 STACKTOP = sp;return ($$3|0); //@line 66860 "c/sqlite3.c"
}
function _btreeCreateTable($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$025$ph = 0, $$2$ph = 0, $$3 = 0, $$off = 0, $$promoted = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0;
 var $60 = 0, $61 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $storemerge = 0, $storemerge$in32 = 0, $switch = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $3 = sp + 20|0;
 $4 = sp + 16|0;
 $5 = sp + 12|0;
 $6 = sp + 8|0;
 $7 = sp + 4|0;
 $8 = sp + 24|0;
 $9 = sp;
 $10 = ((($0)) + 4|0); //@line 68966 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 68966 "c/sqlite3.c"
 $12 = ((($11)) + 17|0); //@line 68982 "c/sqlite3.c"
 $13 = HEAP8[$12>>0]|0; //@line 68982 "c/sqlite3.c"
 $14 = ($13<<24>>24)==(0); //@line 68982 "c/sqlite3.c"
 L1: do {
  if ($14) {
   $54 = (_allocateBtreePage($11,$3,$4,1,0)|0); //@line 69092 "c/sqlite3.c"
   HEAP32[$5>>2] = $54; //@line 69092 "c/sqlite3.c"
   $55 = ($54|0)==(0); //@line 69093 "c/sqlite3.c"
   if (!($55)) {
    $$3 = $54;
    STACKTOP = sp;return ($$3|0); //@line 69107 "c/sqlite3.c"
   }
  } else {
   _invalidateAllOverflowCache($11); //@line 68991 "c/sqlite3.c"
   _sqlite3BtreeGetMeta($0,4,$4); //@line 68997 "c/sqlite3.c"
   $15 = HEAP32[513]|0;
   $16 = ((($11)) + 32|0);
   $17 = HEAP32[$16>>2]|0;
   $18 = (($15>>>0) / ($17>>>0))&-1;
   $$promoted = HEAP32[$4>>2]|0;
   $storemerge$in32 = $$promoted;
   while(1) {
    $storemerge = (($storemerge$in32) + 1)|0;
    $19 = (_ptrmapPageno($11,$storemerge)|0); //@line 69003 "c/sqlite3.c"
    $20 = ($storemerge|0)==($19|0); //@line 69003 "c/sqlite3.c"
    $21 = ($storemerge$in32|0)==($18|0); //@line 69004 "c/sqlite3.c"
    $or$cond = $20 | $21; //@line 69003 "c/sqlite3.c"
    if ($or$cond) {
     $storemerge$in32 = $storemerge;
    } else {
     break;
    }
   }
   HEAP32[$4>>2] = $storemerge;
   $22 = (_allocateBtreePage($11,$7,$6,$storemerge,1)|0); //@line 69014 "c/sqlite3.c"
   HEAP32[$5>>2] = $22; //@line 69014 "c/sqlite3.c"
   $23 = ($22|0)==(0); //@line 69015 "c/sqlite3.c"
   L8: do {
    if ($23) {
     $24 = HEAP32[$6>>2]|0; //@line 69019 "c/sqlite3.c"
     $25 = ($24|0)==($storemerge|0); //@line 69019 "c/sqlite3.c"
     L10: do {
      if ($25) {
       $47 = HEAP32[$7>>2]|0; //@line 69070 "c/sqlite3.c"
       HEAP32[$3>>2] = $47; //@line 69070 "c/sqlite3.c"
      } else {
       HEAP8[$8>>0] = 0; //@line 69026 "c/sqlite3.c"
       HEAP32[$9>>2] = 0; //@line 69027 "c/sqlite3.c"
       $26 = (_saveAllCursors($11,0,0)|0); //@line 69032 "c/sqlite3.c"
       HEAP32[$5>>2] = $26; //@line 69032 "c/sqlite3.c"
       $27 = HEAP32[$7>>2]|0; //@line 69033 "c/sqlite3.c"
       _releasePage($27); //@line 69033 "c/sqlite3.c"
       $28 = ($26|0)==(0); //@line 69034 "c/sqlite3.c"
       do {
        if ($28) {
         $29 = (_btreeGetPage($11,$storemerge,$3,0)|0); //@line 69039 "c/sqlite3.c"
         HEAP32[$5>>2] = $29; //@line 69039 "c/sqlite3.c"
         $30 = ($29|0)==(0); //@line 69040 "c/sqlite3.c"
         if ($30) {
          $31 = (_ptrmapGet($11,$storemerge,$8,$9)|0); //@line 69043 "c/sqlite3.c"
          HEAP32[$5>>2] = $31; //@line 69043 "c/sqlite3.c"
          $32 = HEAP8[$8>>0]|0; //@line 69044 "c/sqlite3.c"
          $$off = (($32) + -1)<<24>>24; //@line 69044 "c/sqlite3.c"
          $switch = ($$off&255)<(2); //@line 69044 "c/sqlite3.c"
          if ($switch) {
           $33 = (_sqlite3CorruptError(69045)|0); //@line 69045 "c/sqlite3.c"
           HEAP32[$5>>2] = $33; //@line 69045 "c/sqlite3.c"
           $35 = $33;
          } else {
           $35 = $31;
          }
          $34 = ($35|0)==(0); //@line 69047 "c/sqlite3.c"
          $36 = HEAP32[$3>>2]|0;
          if (!($34)) {
           _releasePage($36); //@line 69048 "c/sqlite3.c"
           $$025$ph = $35;
           break;
          }
          $37 = HEAP32[$9>>2]|0; //@line 69053 "c/sqlite3.c"
          $38 = (_relocatePage($11,$36,$32,$37,$24,0)|0); //@line 69053 "c/sqlite3.c"
          HEAP32[$5>>2] = $38; //@line 69053 "c/sqlite3.c"
          _releasePage($36); //@line 69054 "c/sqlite3.c"
          $39 = ($38|0)==(0); //@line 69057 "c/sqlite3.c"
          if ($39) {
           $40 = (_btreeGetPage($11,$storemerge,$3,0)|0); //@line 69060 "c/sqlite3.c"
           HEAP32[$5>>2] = $40; //@line 69060 "c/sqlite3.c"
           $41 = ($40|0)==(0); //@line 69061 "c/sqlite3.c"
           if ($41) {
            $42 = HEAP32[$3>>2]|0; //@line 69064 "c/sqlite3.c"
            $43 = ((($42)) + 72|0); //@line 69064 "c/sqlite3.c"
            $44 = HEAP32[$43>>2]|0; //@line 69064 "c/sqlite3.c"
            $45 = (_sqlite3PagerWrite($44)|0); //@line 69064 "c/sqlite3.c"
            HEAP32[$5>>2] = $45; //@line 69064 "c/sqlite3.c"
            $46 = ($45|0)==(0); //@line 69065 "c/sqlite3.c"
            if ($46) {
             break L10;
            } else {
             _releasePage($42); //@line 69066 "c/sqlite3.c"
             $$025$ph = $45;
             break;
            }
           } else {
            $$025$ph = $40;
           }
          } else {
           $$025$ph = $38;
          }
         } else {
          $$025$ph = $29;
         }
        } else {
         $$025$ph = $26;
        }
       } while(0);
       $$2$ph = $$025$ph;
       break L8;
      }
     } while(0);
     _ptrmapPut($11,$storemerge,1,0,$5); //@line 69074 "c/sqlite3.c"
     $48 = HEAP32[$5>>2]|0; //@line 69075 "c/sqlite3.c"
     $49 = ($48|0)==(0); //@line 69075 "c/sqlite3.c"
     if (!($49)) {
      $50 = HEAP32[$3>>2]|0; //@line 69076 "c/sqlite3.c"
      _releasePage($50); //@line 69076 "c/sqlite3.c"
      $$2$ph = $48;
      break;
     }
     $51 = (_sqlite3BtreeUpdateMeta($0,4,$storemerge)|0); //@line 69085 "c/sqlite3.c"
     HEAP32[$5>>2] = $51; //@line 69085 "c/sqlite3.c"
     $52 = ($51|0)==(0); //@line 69086 "c/sqlite3.c"
     if ($52) {
      break L1;
     } else {
      $53 = HEAP32[$3>>2]|0; //@line 69087 "c/sqlite3.c"
      _releasePage($53); //@line 69087 "c/sqlite3.c"
      $$2$ph = $51;
      break;
     }
    } else {
     $$2$ph = $22;
    }
   } while(0);
   $$3 = $$2$ph;
   STACKTOP = sp;return ($$3|0); //@line 69107 "c/sqlite3.c"
  }
 } while(0);
 $56 = $2 & 1; //@line 69097 "c/sqlite3.c"
 $57 = ($56|0)==(0); //@line 69097 "c/sqlite3.c"
 $$ = $57 ? 10 : 13;
 $58 = HEAP32[$3>>2]|0; //@line 69102 "c/sqlite3.c"
 _zeroPage($58,$$); //@line 69102 "c/sqlite3.c"
 $59 = ((($58)) + 72|0); //@line 69103 "c/sqlite3.c"
 $60 = HEAP32[$59>>2]|0; //@line 69103 "c/sqlite3.c"
 _sqlite3PagerUnref($60); //@line 69103 "c/sqlite3.c"
 $61 = HEAP32[$4>>2]|0; //@line 69105 "c/sqlite3.c"
 HEAP32[$1>>2] = $61; //@line 69105 "c/sqlite3.c"
 $$3 = 0;
 STACKTOP = sp;return ($$3|0); //@line 69107 "c/sqlite3.c"
}
function _btreeCursor($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$034 = 0, $$035 = 0, $$036 = 0, $$037 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 4|0); //@line 64659 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 64659 "c/sqlite3.c"
 $7 = ($2|0)!=(0); //@line 64681 "c/sqlite3.c"
 if ($7) {
  _allocateTempSpace($6); //@line 64682 "c/sqlite3.c"
  $8 = ((($6)) + 80|0); //@line 64683 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 64683 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 64683 "c/sqlite3.c"
  if ($10) {
   $$034 = 7;
   return ($$034|0); //@line 64711 "c/sqlite3.c"
  }
 }
 $11 = ($1|0)==(1); //@line 64685 "c/sqlite3.c"
 if ($11) {
  $12 = (_btreePagecount($6)|0); //@line 64685 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 64685 "c/sqlite3.c"
  $spec$select = $13 ? 0 : $1; //@line 64685 "c/sqlite3.c"
  $$035 = $spec$select;
 } else {
  $$035 = $1;
 }
 $14 = ((($4)) + 60|0); //@line 64692 "c/sqlite3.c"
 HEAP32[$14>>2] = $$035; //@line 64692 "c/sqlite3.c"
 $15 = ((($4)) + 68|0); //@line 64693 "c/sqlite3.c"
 HEAP8[$15>>0] = -1; //@line 64693 "c/sqlite3.c"
 $16 = ((($4)) + 112|0); //@line 64694 "c/sqlite3.c"
 HEAP32[$16>>2] = $3; //@line 64694 "c/sqlite3.c"
 $17 = ((($4)) + 8|0); //@line 64695 "c/sqlite3.c"
 HEAP32[$17>>2] = $0; //@line 64695 "c/sqlite3.c"
 $18 = ((($4)) + 12|0); //@line 64696 "c/sqlite3.c"
 HEAP32[$18>>2] = $6; //@line 64696 "c/sqlite3.c"
 $19 = $7&1; //@line 64697 "c/sqlite3.c"
 $20 = ((($4)) + 1|0); //@line 64697 "c/sqlite3.c"
 HEAP8[$20>>0] = $19; //@line 64697 "c/sqlite3.c"
 $21 = $7 ? 0 : 2; //@line 64698 "c/sqlite3.c"
 $22 = ((($4)) + 2|0); //@line 64698 "c/sqlite3.c"
 HEAP8[$22>>0] = $21; //@line 64698 "c/sqlite3.c"
 $23 = ((($6)) + 8|0); //@line 64701 "c/sqlite3.c"
 $$036 = HEAP32[$23>>2]|0;
 $24 = ($$036|0)==(0|0); //@line 64701 "c/sqlite3.c"
 if (!($24)) {
  $$037 = $$036;
  while(1) {
   $25 = ((($$037)) + 60|0); //@line 64702 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 64702 "c/sqlite3.c"
   $27 = ($26|0)==($$035|0); //@line 64702 "c/sqlite3.c"
   if ($27) {
    $28 = ((($$037)) + 1|0); //@line 64703 "c/sqlite3.c"
    $29 = HEAP8[$28>>0]|0; //@line 64703 "c/sqlite3.c"
    $30 = $29 | 32; //@line 64703 "c/sqlite3.c"
    HEAP8[$28>>0] = $30; //@line 64703 "c/sqlite3.c"
    $31 = HEAP8[$20>>0]|0; //@line 64704 "c/sqlite3.c"
    $32 = $31 | 32; //@line 64704 "c/sqlite3.c"
    HEAP8[$20>>0] = $32; //@line 64704 "c/sqlite3.c"
   }
   $33 = ((($$037)) + 16|0); //@line 64701 "c/sqlite3.c"
   $$0 = HEAP32[$33>>2]|0;
   $34 = ($$0|0)==(0|0); //@line 64701 "c/sqlite3.c"
   if ($34) {
    break;
   } else {
    $$037 = $$0;
   }
  }
 }
 $35 = HEAP32[$23>>2]|0; //@line 64707 "c/sqlite3.c"
 $36 = ((($4)) + 16|0); //@line 64707 "c/sqlite3.c"
 HEAP32[$36>>2] = $35; //@line 64707 "c/sqlite3.c"
 HEAP32[$23>>2] = $4; //@line 64708 "c/sqlite3.c"
 HEAP8[$4>>0] = 0; //@line 64709 "c/sqlite3.c"
 $$034 = 0;
 return ($$034|0); //@line 64711 "c/sqlite3.c"
}
function _allocateTempSpace($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 80|0); //@line 62995 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 62995 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 62995 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 63018 "c/sqlite3.c"
 }
 $4 = ((($0)) + 32|0); //@line 62996 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 62996 "c/sqlite3.c"
 $6 = (_sqlite3PageMalloc($5)|0); //@line 62996 "c/sqlite3.c"
 HEAP32[$1>>2] = $6; //@line 62996 "c/sqlite3.c"
 $7 = ($6|0)==(0|0); //@line 63013 "c/sqlite3.c"
 if ($7) {
  return; //@line 63018 "c/sqlite3.c"
 }
 $8 = $6; //@line 63014 "c/sqlite3.c"
 $9 = $8; //@line 63014 "c/sqlite3.c"
 HEAP8[$9>>0]=0&255;HEAP8[$9+1>>0]=(0>>8)&255;HEAP8[$9+2>>0]=(0>>16)&255;HEAP8[$9+3>>0]=0>>24; //@line 63014 "c/sqlite3.c"
 $10 = (($8) + 4)|0; //@line 63014 "c/sqlite3.c"
 $11 = $10; //@line 63014 "c/sqlite3.c"
 HEAP8[$11>>0]=0&255;HEAP8[$11+1>>0]=(0>>8)&255;HEAP8[$11+2>>0]=(0>>16)&255;HEAP8[$11+3>>0]=0>>24; //@line 63014 "c/sqlite3.c"
 $12 = HEAP32[$1>>2]|0; //@line 63015 "c/sqlite3.c"
 $13 = ((($12)) + 4|0); //@line 63015 "c/sqlite3.c"
 HEAP32[$1>>2] = $13; //@line 63015 "c/sqlite3.c"
 return; //@line 63018 "c/sqlite3.c"
}
function _sqlite3BtreeCursorZero($0) {
 $0 = $0|0;
 var dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$0; stop=dest+68|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 64751 "c/sqlite3.c"
 return; //@line 64752 "c/sqlite3.c"
}
function _putVarint64($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$02736 = 0, $$031 = 0, $$135 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = ($2>>>0)>(16777215); //@line 29293 "c/sqlite3.c"
 $5 = ($1>>>0)>(4294967295); //@line 29293 "c/sqlite3.c"
 $6 = ($2|0)==(16777215); //@line 29293 "c/sqlite3.c"
 $7 = $6 & $5; //@line 29293 "c/sqlite3.c"
 $8 = $4 | $7; //@line 29293 "c/sqlite3.c"
 if ($8) {
  $9 = $1&255; //@line 29294 "c/sqlite3.c"
  $10 = ((($0)) + 8|0); //@line 29294 "c/sqlite3.c"
  HEAP8[$10>>0] = $9; //@line 29294 "c/sqlite3.c"
  $11 = (_bitshift64Lshr(($1|0),($2|0),8)|0); //@line 29295 "c/sqlite3.c"
  $12 = tempRet0; //@line 29295 "c/sqlite3.c"
  $13 = $11&255; //@line 29297 "c/sqlite3.c"
  $14 = $13 | -128; //@line 29297 "c/sqlite3.c"
  $15 = ((($0)) + 7|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$15>>0] = $14; //@line 29297 "c/sqlite3.c"
  $16 = (_bitshift64Lshr(($1|0),($2|0),15)|0); //@line 29298 "c/sqlite3.c"
  $17 = tempRet0; //@line 29298 "c/sqlite3.c"
  $18 = $16&255; //@line 29297 "c/sqlite3.c"
  $19 = $18 | -128; //@line 29297 "c/sqlite3.c"
  $20 = ((($0)) + 6|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$20>>0] = $19; //@line 29297 "c/sqlite3.c"
  $21 = (_bitshift64Lshr(($1|0),($2|0),22)|0); //@line 29298 "c/sqlite3.c"
  $22 = tempRet0; //@line 29298 "c/sqlite3.c"
  $23 = $21&255; //@line 29297 "c/sqlite3.c"
  $24 = $23 | -128; //@line 29297 "c/sqlite3.c"
  $25 = ((($0)) + 5|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$25>>0] = $24; //@line 29297 "c/sqlite3.c"
  $26 = (_bitshift64Lshr(($1|0),($2|0),29)|0); //@line 29298 "c/sqlite3.c"
  $27 = tempRet0; //@line 29298 "c/sqlite3.c"
  $28 = $26&255; //@line 29297 "c/sqlite3.c"
  $29 = $28 | -128; //@line 29297 "c/sqlite3.c"
  $30 = ((($0)) + 4|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$30>>0] = $29; //@line 29297 "c/sqlite3.c"
  $31 = (_bitshift64Lshr(($1|0),($2|0),36)|0); //@line 29298 "c/sqlite3.c"
  $32 = tempRet0; //@line 29298 "c/sqlite3.c"
  $33 = $31&255; //@line 29297 "c/sqlite3.c"
  $34 = $33 | -128; //@line 29297 "c/sqlite3.c"
  $35 = ((($0)) + 3|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$35>>0] = $34; //@line 29297 "c/sqlite3.c"
  $36 = (_bitshift64Lshr(($1|0),($2|0),43)|0); //@line 29298 "c/sqlite3.c"
  $37 = tempRet0; //@line 29298 "c/sqlite3.c"
  $38 = $36&255; //@line 29297 "c/sqlite3.c"
  $39 = $38 | -128; //@line 29297 "c/sqlite3.c"
  $40 = ((($0)) + 2|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$40>>0] = $39; //@line 29297 "c/sqlite3.c"
  $41 = (_bitshift64Lshr(($1|0),($2|0),50)|0); //@line 29298 "c/sqlite3.c"
  $42 = tempRet0; //@line 29298 "c/sqlite3.c"
  $43 = $41&255; //@line 29297 "c/sqlite3.c"
  $44 = $43 | -128; //@line 29297 "c/sqlite3.c"
  $45 = ((($0)) + 1|0); //@line 29297 "c/sqlite3.c"
  HEAP8[$45>>0] = $44; //@line 29297 "c/sqlite3.c"
  $46 = (_bitshift64Lshr(($1|0),($2|0),57)|0); //@line 29298 "c/sqlite3.c"
  $47 = tempRet0; //@line 29298 "c/sqlite3.c"
  $48 = $46&255; //@line 29297 "c/sqlite3.c"
  $49 = $48 | -128; //@line 29297 "c/sqlite3.c"
  HEAP8[$0>>0] = $49; //@line 29297 "c/sqlite3.c"
  $$031 = 9;
  STACKTOP = sp;return ($$031|0); //@line 29313 "c/sqlite3.c"
 }
 $$0 = 0;$51 = $1;$55 = $2;
 while(1) {
  $50 = $51&255; //@line 29304 "c/sqlite3.c"
  $52 = $50 | -128; //@line 29304 "c/sqlite3.c"
  $53 = (($$0) + 1)|0; //@line 29304 "c/sqlite3.c"
  $54 = (($3) + ($$0)|0); //@line 29304 "c/sqlite3.c"
  HEAP8[$54>>0] = $52; //@line 29304 "c/sqlite3.c"
  $56 = (_bitshift64Lshr(($51|0),($55|0),7)|0); //@line 29305 "c/sqlite3.c"
  $57 = tempRet0; //@line 29305 "c/sqlite3.c"
  $58 = ($56|0)==(0); //@line 29306 "c/sqlite3.c"
  $59 = ($57|0)==(0); //@line 29306 "c/sqlite3.c"
  $60 = $58 & $59; //@line 29306 "c/sqlite3.c"
  if ($60) {
   break;
  } else {
   $$0 = $53;$51 = $56;$55 = $57;
  }
 }
 $61 = HEAP8[$3>>0]|0; //@line 29307 "c/sqlite3.c"
 $62 = $61 & 127; //@line 29307 "c/sqlite3.c"
 HEAP8[$3>>0] = $62; //@line 29307 "c/sqlite3.c"
 $$02736 = $$0;$$135 = 0;
 while(1) {
  $63 = (($3) + ($$02736)|0); //@line 29310 "c/sqlite3.c"
  $64 = HEAP8[$63>>0]|0; //@line 29310 "c/sqlite3.c"
  $65 = (($0) + ($$135)|0); //@line 29310 "c/sqlite3.c"
  HEAP8[$65>>0] = $64; //@line 29310 "c/sqlite3.c"
  $66 = (($$02736) + -1)|0; //@line 29309 "c/sqlite3.c"
  $67 = (($$135) + 1)|0; //@line 29309 "c/sqlite3.c"
  $68 = ($$02736|0)>(0); //@line 29309 "c/sqlite3.c"
  if ($68) {
   $$02736 = $66;$$135 = $67;
  } else {
   $$031 = $53;
   break;
  }
 }
 STACKTOP = sp;return ($$031|0); //@line 29313 "c/sqlite3.c"
}
function _vdbeMemFromBtreeResize($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($3)) + 8|0); //@line 72203 "c/sqlite3.c"
 HEAP16[$4>>1] = 1; //@line 72203 "c/sqlite3.c"
 $5 = (($2) + 1)|0; //@line 72204 "c/sqlite3.c"
 $6 = (_sqlite3VdbeMemClearAndResize($3,$5)|0); //@line 72204 "c/sqlite3.c"
 $7 = ($6|0)==(0); //@line 72204 "c/sqlite3.c"
 if (!($7)) {
  $$0 = $6;
  return ($$0|0); //@line 72214 "c/sqlite3.c"
 }
 $8 = ((($3)) + 16|0); //@line 72205 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 72205 "c/sqlite3.c"
 $10 = (_sqlite3BtreePayload($0,$1,$2,$9)|0); //@line 72205 "c/sqlite3.c"
 $11 = ($10|0)==(0); //@line 72206 "c/sqlite3.c"
 if ($11) {
  $12 = HEAP32[$8>>2]|0; //@line 72207 "c/sqlite3.c"
  $13 = (($12) + ($2)|0); //@line 72207 "c/sqlite3.c"
  HEAP8[$13>>0] = 0; //@line 72207 "c/sqlite3.c"
  HEAP16[$4>>1] = 16; //@line 72208 "c/sqlite3.c"
  $14 = ((($3)) + 12|0); //@line 72209 "c/sqlite3.c"
  HEAP32[$14>>2] = $2; //@line 72209 "c/sqlite3.c"
  $$0 = 0;
  return ($$0|0); //@line 72214 "c/sqlite3.c"
 } else {
  _sqlite3VdbeMemRelease($3); //@line 72211 "c/sqlite3.c"
  $$0 = $10;
  return ($$0|0); //@line 72214 "c/sqlite3.c"
 }
 return (0)|0;
}
function _fetchPayload($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 40|0); //@line 65281 "c/sqlite3.c"
 $3 = HEAP16[$2>>1]|0; //@line 65281 "c/sqlite3.c"
 $4 = $3&65535; //@line 65281 "c/sqlite3.c"
 $5 = ((($0)) + 116|0); //@line 65282 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 65282 "c/sqlite3.c"
 $7 = ((($6)) + 60|0); //@line 65282 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 65282 "c/sqlite3.c"
 $9 = ((($0)) + 32|0); //@line 65282 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 65282 "c/sqlite3.c"
 $11 = (($8) - ($10))|0; //@line 65282 "c/sqlite3.c"
 $12 = ($11|0)<($4|0); //@line 65282 "c/sqlite3.c"
 $13 = ($11|0)>(0); //@line 65286 "c/sqlite3.c"
 $spec$select = $13 ? $11 : 0; //@line 65286 "c/sqlite3.c"
 $$0 = $12 ? $spec$select : $4; //@line 65282 "c/sqlite3.c"
 HEAP32[$1>>2] = $$0; //@line 65288 "c/sqlite3.c"
 $14 = HEAP32[$9>>2]|0; //@line 65289 "c/sqlite3.c"
 return ($14|0); //@line 65289 "c/sqlite3.c"
}
function _handleDeferredMoveto($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ((($0)) + 40|0); //@line 76052 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 76052 "c/sqlite3.c"
 $4 = ((($0)) + 64|0); //@line 76052 "c/sqlite3.c"
 $5 = $4; //@line 76052 "c/sqlite3.c"
 $6 = $5; //@line 76052 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 76052 "c/sqlite3.c"
 $8 = (($5) + 4)|0; //@line 76052 "c/sqlite3.c"
 $9 = $8; //@line 76052 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 76052 "c/sqlite3.c"
 $11 = (_sqlite3BtreeMovetoUnpacked($3,0,$7,$10,0,$1)|0); //@line 76052 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 76053 "c/sqlite3.c"
 if (!($12)) {
  $$0 = $11;
  STACKTOP = sp;return ($$0|0); //@line 76061 "c/sqlite3.c"
 }
 $13 = HEAP32[$1>>2]|0; //@line 76054 "c/sqlite3.c"
 $14 = ($13|0)==(0); //@line 76054 "c/sqlite3.c"
 if ($14) {
  $16 = ((($0)) + 3|0); //@line 76058 "c/sqlite3.c"
  HEAP8[$16>>0] = 0; //@line 76058 "c/sqlite3.c"
  $17 = ((($0)) + 28|0); //@line 76059 "c/sqlite3.c"
  HEAP32[$17>>2] = 0; //@line 76059 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 76061 "c/sqlite3.c"
 } else {
  $15 = (_sqlite3CorruptError(76054)|0); //@line 76054 "c/sqlite3.c"
  $$0 = $15;
  STACKTOP = sp;return ($$0|0); //@line 76061 "c/sqlite3.c"
 }
 return (0)|0;
}
function _computeNumericType($0) {
 $0 = $0|0;
 var $$ = 0, $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 16|0); //@line 80245 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 80245 "c/sqlite3.c"
 $3 = ((($0)) + 12|0); //@line 80245 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 80245 "c/sqlite3.c"
 $5 = ((($0)) + 10|0); //@line 80245 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 80245 "c/sqlite3.c"
 $7 = (_sqlite3AtoF($2,$0,$4,$6)|0); //@line 80245 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 80245 "c/sqlite3.c"
 if ($8) {
  $$0 = 0;
  return ($$0|0); //@line 80252 "c/sqlite3.c"
 }
 $9 = HEAP32[$1>>2]|0; //@line 80248 "c/sqlite3.c"
 $10 = HEAP32[$3>>2]|0; //@line 80248 "c/sqlite3.c"
 $11 = HEAP8[$5>>0]|0; //@line 80248 "c/sqlite3.c"
 $12 = (_sqlite3Atoi64($9,$0,$10,$11)|0); //@line 80248 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 80248 "c/sqlite3.c"
 $$ = $13 ? 4 : 8; //@line 80249 "c/sqlite3.c"
 $$0 = $$;
 return ($$0|0); //@line 80252 "c/sqlite3.c"
}
function _out2PrereleaseWithClear($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3VdbeMemSetNull($0); //@line 80515 "c/sqlite3.c"
 $1 = ((($0)) + 8|0); //@line 80516 "c/sqlite3.c"
 HEAP16[$1>>1] = 4; //@line 80516 "c/sqlite3.c"
 return ($0|0); //@line 80517 "c/sqlite3.c"
}
function _sqlite3LookasideUsed($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 288|0); //@line 19367 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 19367 "c/sqlite3.c"
 $4 = (_countLookasideSlots($3)|0); //@line 19367 "c/sqlite3.c"
 $5 = ((($0)) + 292|0); //@line 19368 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 19368 "c/sqlite3.c"
 $7 = (_countLookasideSlots($6)|0); //@line 19368 "c/sqlite3.c"
 $8 = ($1|0)==(0|0); //@line 19369 "c/sqlite3.c"
 if (!($8)) {
  $9 = ((($0)) + 272|0); //@line 19369 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 19369 "c/sqlite3.c"
  $11 = (($10) - ($4))|0; //@line 19369 "c/sqlite3.c"
  HEAP32[$1>>2] = $11; //@line 19369 "c/sqlite3.c"
 }
 $12 = ((($0)) + 272|0); //@line 19370 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 19370 "c/sqlite3.c"
 $14 = (($7) + ($4))|0; //@line 19370 "c/sqlite3.c"
 $15 = (($13) - ($14))|0; //@line 19370 "c/sqlite3.c"
 return ($15|0); //@line 19370 "c/sqlite3.c"
}
function _sqlite3PagerMemUsed($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 152|0); //@line 54657 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54657 "c/sqlite3.c"
 $3 = ((($0)) + 140|0); //@line 54657 "c/sqlite3.c"
 $4 = HEAP16[$3>>1]|0; //@line 54657 "c/sqlite3.c"
 $5 = $4&65535; //@line 54657 "c/sqlite3.c"
 $6 = (($2) + 60)|0; //@line 54657 "c/sqlite3.c"
 $7 = (($6) + ($5))|0; //@line 54658 "c/sqlite3.c"
 $8 = ((($0)) + 208|0); //@line 54659 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 54659 "c/sqlite3.c"
 $10 = (_sqlite3PcachePagecount($9)|0); //@line 54659 "c/sqlite3.c"
 $11 = Math_imul($7, $10)|0; //@line 54659 "c/sqlite3.c"
 $12 = (_sqlite3MallocSize($0)|0); //@line 54660 "c/sqlite3.c"
 $13 = (($11) + ($12))|0; //@line 54660 "c/sqlite3.c"
 $14 = HEAP32[$1>>2]|0; //@line 54661 "c/sqlite3.c"
 $15 = (($13) + ($14))|0; //@line 54661 "c/sqlite3.c"
 return ($15|0); //@line 54659 "c/sqlite3.c"
}
function _sqlite3BtreeConnectionCount($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 70382 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70382 "c/sqlite3.c"
 $3 = ((($2)) + 64|0); //@line 70382 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 70382 "c/sqlite3.c"
 return ($4|0); //@line 70382 "c/sqlite3.c"
}
function _sqlite3PagerCacheStat($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (($1) + -7)|0; //@line 54710 "c/sqlite3.c"
 $5 = (((($0)) + 184|0) + ($4<<2)|0); //@line 54710 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 54710 "c/sqlite3.c"
 $7 = HEAP32[$3>>2]|0; //@line 54710 "c/sqlite3.c"
 $8 = (($7) + ($6))|0; //@line 54710 "c/sqlite3.c"
 HEAP32[$3>>2] = $8; //@line 54710 "c/sqlite3.c"
 $9 = ($2|0)==(0); //@line 54711 "c/sqlite3.c"
 if ($9) {
  return; //@line 54714 "c/sqlite3.c"
 }
 HEAP32[$5>>2] = 0; //@line 54712 "c/sqlite3.c"
 return; //@line 54714 "c/sqlite3.c"
}
function _countLookasideSlots($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $$045 = 0, $$06 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 19356 "c/sqlite3.c"
 if ($1) {
  $$0$lcssa = 0;
 } else {
  $$045 = $0;$$06 = 0;
  while(1) {
   $2 = HEAP32[$$045>>2]|0; //@line 19357 "c/sqlite3.c"
   $3 = (($$06) + 1)|0; //@line 19358 "c/sqlite3.c"
   $4 = ($2|0)==(0|0); //@line 19356 "c/sqlite3.c"
   if ($4) {
    $$0$lcssa = $3;
    break;
   } else {
    $$045 = $2;$$06 = $3;
   }
  }
 }
 return ($$0$lcssa|0); //@line 19360 "c/sqlite3.c"
}
function _setupLookaside($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0$in$lcssa = 0, $$0$in58 = 0, $$052 = 0, $$052$in57 = 0, $$053 = 0, $$055 = 0, $$056 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$select = 0, $spec$store$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = (_sqlite3LookasideUsed($0,0)|0); //@line 144029 "c/sqlite3.c"
 $5 = ($4|0)>(0); //@line 144029 "c/sqlite3.c"
 if ($5) {
  $$056 = 5;
  return ($$056|0); //@line 144083 "c/sqlite3.c"
 }
 $6 = ((($0)) + 264|0); //@line 144036 "c/sqlite3.c"
 $7 = ((($0)) + 270|0); //@line 144036 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 144036 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(0); //@line 144036 "c/sqlite3.c"
 if (!($9)) {
  $10 = ((($0)) + 296|0); //@line 144037 "c/sqlite3.c"
  $11 = HEAP32[$10>>2]|0; //@line 144037 "c/sqlite3.c"
  _sqlite3_free($11); //@line 144037 "c/sqlite3.c"
 }
 $12 = $2 & -8; //@line 144042 "c/sqlite3.c"
 $13 = ($12|0)<(5); //@line 144043 "c/sqlite3.c"
 $spec$store$select = $13 ? 0 : $12; //@line 144043 "c/sqlite3.c"
 $14 = ($3|0)>(0); //@line 144044 "c/sqlite3.c"
 $spec$select = $14 ? $3 : 0; //@line 144044 "c/sqlite3.c"
 $15 = ($spec$store$select|0)==(0); //@line 144045 "c/sqlite3.c"
 $16 = ($3|0)<(1); //@line 144045 "c/sqlite3.c"
 $or$cond = $16 | $15; //@line 144045 "c/sqlite3.c"
 if ($or$cond) {
  $$053 = 0;$$055 = 0;$$1 = $spec$select;
 } else {
  $17 = ($1|0)==(0|0); //@line 144048 "c/sqlite3.c"
  if ($17) {
   _sqlite3BeginBenignMalloc(); //@line 144049 "c/sqlite3.c"
   $18 = Math_imul($spec$store$select, $spec$select)|0; //@line 144050 "c/sqlite3.c"
   $19 = ($18|0)<(0); //@line 144050 "c/sqlite3.c"
   $20 = $19 << 31 >> 31; //@line 144050 "c/sqlite3.c"
   $21 = (_sqlite3Malloc($18,$20)|0); //@line 144050 "c/sqlite3.c"
   _sqlite3EndBenignMalloc(); //@line 144051 "c/sqlite3.c"
   $22 = ($21|0)==(0|0); //@line 144052 "c/sqlite3.c"
   if ($22) {
    $$053 = 0;$$055 = $spec$store$select;$$1 = $spec$select;
   } else {
    $23 = (_sqlite3MallocSize($21)|0); //@line 144052 "c/sqlite3.c"
    $24 = (($23|0) / ($12|0))&-1; //@line 144052 "c/sqlite3.c"
    $$053 = $21;$$055 = $spec$store$select;$$1 = $24;
   }
  } else {
   $$053 = $1;$$055 = $spec$store$select;$$1 = $spec$select;
  }
 }
 $25 = ((($0)) + 296|0); //@line 144056 "c/sqlite3.c"
 HEAP32[$25>>2] = $$053; //@line 144056 "c/sqlite3.c"
 $26 = ((($0)) + 288|0); //@line 144057 "c/sqlite3.c"
 HEAP32[$26>>2] = 0; //@line 144057 "c/sqlite3.c"
 $27 = ((($0)) + 292|0); //@line 144058 "c/sqlite3.c"
 HEAP32[$27>>2] = 0; //@line 144058 "c/sqlite3.c"
 $28 = $$055&65535; //@line 144059 "c/sqlite3.c"
 $29 = ((($0)) + 268|0); //@line 144059 "c/sqlite3.c"
 HEAP16[$29>>1] = $28; //@line 144059 "c/sqlite3.c"
 $30 = ($$053|0)==(0|0); //@line 144060 "c/sqlite3.c"
 if ($30) {
  HEAP32[$25>>2] = $0; //@line 144075 "c/sqlite3.c"
  $39 = ((($0)) + 300|0); //@line 144076 "c/sqlite3.c"
  HEAP32[$39>>2] = $0; //@line 144076 "c/sqlite3.c"
  HEAP32[$6>>2] = 1; //@line 144077 "c/sqlite3.c"
  HEAP8[$7>>0] = 0; //@line 144078 "c/sqlite3.c"
  $40 = ((($0)) + 272|0); //@line 144079 "c/sqlite3.c"
  HEAP32[$40>>2] = 0; //@line 144079 "c/sqlite3.c"
  $$056 = 0;
  return ($$056|0); //@line 144083 "c/sqlite3.c"
 }
 $31 = ((($0)) + 272|0); //@line 144064 "c/sqlite3.c"
 HEAP32[$31>>2] = $$1; //@line 144064 "c/sqlite3.c"
 $32 = ($$1|0)>(0); //@line 144066 "c/sqlite3.c"
 if ($32) {
  $$0$in58 = $$053;$$052$in57 = $$1;
  while(1) {
   $$052 = (($$052$in57) + -1)|0;
   $33 = HEAP32[$26>>2]|0; //@line 144067 "c/sqlite3.c"
   HEAP32[$$0$in58>>2] = $33; //@line 144067 "c/sqlite3.c"
   HEAP32[$26>>2] = $$0$in58; //@line 144068 "c/sqlite3.c"
   $34 = (($$0$in58) + ($$055)|0); //@line 144069 "c/sqlite3.c"
   $35 = ($$052$in57|0)>(1); //@line 144066 "c/sqlite3.c"
   if ($35) {
    $$0$in58 = $34;$$052$in57 = $$052;
   } else {
    $$0$in$lcssa = $34;
    break;
   }
  }
 } else {
  $$0$in$lcssa = $$053;
 }
 $36 = ((($0)) + 300|0); //@line 144071 "c/sqlite3.c"
 HEAP32[$36>>2] = $$0$in$lcssa; //@line 144071 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 144072 "c/sqlite3.c"
 $37 = ($1|0)==(0|0); //@line 144073 "c/sqlite3.c"
 $38 = $37&1; //@line 144073 "c/sqlite3.c"
 HEAP8[$7>>0] = $38; //@line 144073 "c/sqlite3.c"
 $$056 = 0;
 return ($$056|0); //@line 144083 "c/sqlite3.c"
}
function _setDestPgsz($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 4|0); //@line 70502 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70502 "c/sqlite3.c"
 $3 = ((($0)) + 24|0); //@line 70502 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 70502 "c/sqlite3.c"
 $5 = (_sqlite3BtreeGetPageSize($4)|0); //@line 70502 "c/sqlite3.c"
 $6 = (_sqlite3BtreeSetPageSize($2,$5,-1,0)|0); //@line 70502 "c/sqlite3.c"
 return ($6|0); //@line 70503 "c/sqlite3.c"
}
function _attachBackupObject($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 24|0); //@line 70726 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 70726 "c/sqlite3.c"
 $3 = (_sqlite3BtreePager($2)|0); //@line 70726 "c/sqlite3.c"
 $4 = (_sqlite3PagerBackupPtr($3)|0); //@line 70726 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 70727 "c/sqlite3.c"
 $6 = ((($0)) + 44|0); //@line 70727 "c/sqlite3.c"
 HEAP32[$6>>2] = $5; //@line 70727 "c/sqlite3.c"
 HEAP32[$4>>2] = $0; //@line 70728 "c/sqlite3.c"
 $7 = ((($0)) + 40|0); //@line 70729 "c/sqlite3.c"
 HEAP32[$7>>2] = 1; //@line 70729 "c/sqlite3.c"
 return; //@line 70730 "c/sqlite3.c"
}
function _sqlite3BtreeNewDb($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 _sqlite3BtreeEnter($0); //@line 63652 "c/sqlite3.c"
 $1 = ((($0)) + 4|0); //@line 63653 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 63653 "c/sqlite3.c"
 $3 = ((($2)) + 44|0); //@line 63653 "c/sqlite3.c"
 HEAP32[$3>>2] = 0; //@line 63653 "c/sqlite3.c"
 $4 = (_newDatabase($2)|0); //@line 63654 "c/sqlite3.c"
 _sqlite3BtreeLeave($0); //@line 63655 "c/sqlite3.c"
 return ($4|0); //@line 63656 "c/sqlite3.c"
}
function _backupTruncateFile($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = (_sqlite3OsFileSize($0,$3)|0); //@line 70712 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 70713 "c/sqlite3.c"
 $6 = $3; //@line 70713 "c/sqlite3.c"
 $7 = $6; //@line 70713 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 70713 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 70713 "c/sqlite3.c"
 $10 = $9; //@line 70713 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 70713 "c/sqlite3.c"
 $12 = ($11|0)>($2|0); //@line 70713 "c/sqlite3.c"
 $13 = ($8>>>0)>($1>>>0); //@line 70713 "c/sqlite3.c"
 $14 = ($11|0)==($2|0); //@line 70713 "c/sqlite3.c"
 $15 = $14 & $13; //@line 70713 "c/sqlite3.c"
 $16 = $12 | $15; //@line 70713 "c/sqlite3.c"
 $or$cond = $5 & $16; //@line 70713 "c/sqlite3.c"
 if (!($or$cond)) {
  $$0 = $4;
  STACKTOP = sp;return ($$0|0); //@line 70716 "c/sqlite3.c"
 }
 $17 = (_sqlite3OsTruncate($0,$1,$2)|0); //@line 70714 "c/sqlite3.c"
 $$0 = $17;
 STACKTOP = sp;return ($$0|0); //@line 70716 "c/sqlite3.c"
}
function _sqlite3PagerBackupPtr($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 88|0); //@line 55339 "c/sqlite3.c"
 return ($1|0); //@line 55339 "c/sqlite3.c"
}
function _findBtree($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 496|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(496|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = sp + 16|0;
 $4 = (_sqlite3FindDbName($1,$2)|0); //@line 70470 "c/sqlite3.c"
 $5 = ($4|0)==(1); //@line 70472 "c/sqlite3.c"
 do {
  if ($5) {
   $6 = ((($3)) + 4|0);
   _memset(($6|0),0,468)|0; //@line 70475 "c/sqlite3.c"
   HEAP32[$3>>2] = $1; //@line 70476 "c/sqlite3.c"
   $7 = (_sqlite3OpenTempDatabase($3)|0); //@line 70477 "c/sqlite3.c"
   $8 = ($7|0)==(0); //@line 70477 "c/sqlite3.c"
   if ($8) {
    $13 = ((($3)) + 4|0); //@line 70481 "c/sqlite3.c"
    $14 = HEAP32[$13>>2]|0; //@line 70481 "c/sqlite3.c"
    _sqlite3DbFree($0,$14); //@line 70481 "c/sqlite3.c"
    _sqlite3ParserReset($3); //@line 70482 "c/sqlite3.c"
    break;
   }
   $9 = ((($3)) + 12|0); //@line 70478 "c/sqlite3.c"
   $10 = HEAP32[$9>>2]|0; //@line 70478 "c/sqlite3.c"
   $11 = ((($3)) + 4|0); //@line 70478 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 70478 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $12; //@line 70478 "c/sqlite3.c"
   _sqlite3ErrorWithMsg($0,$10,15687,$vararg_buffer); //@line 70478 "c/sqlite3.c"
   _sqlite3DbFree($0,$12); //@line 70481 "c/sqlite3.c"
   _sqlite3ParserReset($3); //@line 70482 "c/sqlite3.c"
   $$1 = 0;
   STACKTOP = sp;return ($$1|0); //@line 70494 "c/sqlite3.c"
  } else {
   $15 = ($4|0)<(0); //@line 70488 "c/sqlite3.c"
   if ($15) {
    HEAP32[$vararg_buffer1>>2] = $2; //@line 70489 "c/sqlite3.c"
    _sqlite3ErrorWithMsg($0,1,35660,$vararg_buffer1); //@line 70489 "c/sqlite3.c"
    $$1 = 0;
    STACKTOP = sp;return ($$1|0); //@line 70494 "c/sqlite3.c"
   }
  }
 } while(0);
 $16 = ((($1)) + 16|0); //@line 70493 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 70493 "c/sqlite3.c"
 $18 = (((($17) + ($4<<4)|0)) + 4|0); //@line 70493 "c/sqlite3.c"
 $19 = HEAP32[$18>>2]|0; //@line 70493 "c/sqlite3.c"
 $$1 = $19;
 STACKTOP = sp;return ($$1|0); //@line 70494 "c/sqlite3.c"
}
function _checkReadTransaction($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 70512 "c/sqlite3.c"
 $2 = (_sqlite3BtreeIsInReadTrans($1)|0); //@line 70513 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 70513 "c/sqlite3.c"
 if ($3) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 70518 "c/sqlite3.c"
 }
 _sqlite3ErrorWithMsg($0,1,35629,$vararg_buffer); //@line 70514 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 70518 "c/sqlite3.c"
}
function _sqlite3PrngSaveState() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 _memcpy((41693|0),(41389|0),259)|0; //@line 27640 "c/sqlite3.c"
 return; //@line 27645 "c/sqlite3.c"
}
function _sqlite3PrngRestoreState() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 _memcpy((41389|0),(41693|0),259)|0; //@line 27647 "c/sqlite3.c"
 return; //@line 27652 "c/sqlite3.c"
}
function _sqlite3BitvecBuiltinTest($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$054 = 0, $$055 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, $spec$select = 0, $storemerge57 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = (_sqlite3BitvecCreate($0)|0); //@line 45110 "c/sqlite3.c"
 $4 = (($0) + 7)|0; //@line 45111 "c/sqlite3.c"
 $5 = (($4|0) / 8)&-1; //@line 45111 "c/sqlite3.c"
 $6 = (($5) + 1)|0; //@line 45111 "c/sqlite3.c"
 $7 = ($6|0)<(0); //@line 45111 "c/sqlite3.c"
 $8 = $7 << 31 >> 31; //@line 45111 "c/sqlite3.c"
 $9 = (_sqlite3MallocZero($6,$8)|0); //@line 45111 "c/sqlite3.c"
 $10 = (_sqlite3_malloc64(512,0)|0); //@line 45112 "c/sqlite3.c"
 $11 = ($3|0)==(0|0); //@line 45113 "c/sqlite3.c"
 $12 = ($9|0)==(0|0); //@line 45113 "c/sqlite3.c"
 $or$cond = $11 | $12; //@line 45113 "c/sqlite3.c"
 $13 = ($10|0)==(0|0); //@line 45113 "c/sqlite3.c"
 $or$cond3 = $or$cond | $13; //@line 45113 "c/sqlite3.c"
 if ($or$cond3) {
  $$055 = -1;
  _sqlite3_free($10); //@line 45170 "c/sqlite3.c"
  _sqlite3_free($9); //@line 45171 "c/sqlite3.c"
  _sqlite3BitvecDestroy($3); //@line 45172 "c/sqlite3.c"
  STACKTOP = sp;return ($$055|0); //@line 45173 "c/sqlite3.c"
 }
 (_sqlite3BitvecSet(0,1)|0); //@line 45116 "c/sqlite3.c"
 _sqlite3BitvecClear(0,1,$10); //@line 45117 "c/sqlite3.c"
 $$0 = 0;
 L4: while(1) {
  $14 = (($1) + ($$0<<2)|0); //@line 45121 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 45121 "c/sqlite3.c"
  switch ($15|0) {
  case 0:  {
   break L4;
   break;
  }
  case 5: case 2: case 1:  {
   $16 = (($$0) + 2)|0; //@line 45127 "c/sqlite3.c"
   $17 = (($1) + ($16<<2)|0); //@line 45127 "c/sqlite3.c"
   $18 = HEAP32[$17>>2]|0; //@line 45127 "c/sqlite3.c"
   $19 = (($18) + -1)|0; //@line 45127 "c/sqlite3.c"
   HEAP32[$2>>2] = $19; //@line 45127 "c/sqlite3.c"
   $20 = (($$0) + 3)|0; //@line 45128 "c/sqlite3.c"
   $21 = (($1) + ($20<<2)|0); //@line 45128 "c/sqlite3.c"
   $22 = HEAP32[$21>>2]|0; //@line 45128 "c/sqlite3.c"
   $23 = (($22) + ($18))|0; //@line 45128 "c/sqlite3.c"
   HEAP32[$17>>2] = $23; //@line 45128 "c/sqlite3.c"
   $$054 = 4;
   break;
  }
  default: {
   _sqlite3_randomness(4,$2); //@line 45135 "c/sqlite3.c"
   $$054 = 2;
  }
  }
  $24 = $$0 | 1; //@line 45139 "c/sqlite3.c"
  $25 = (($1) + ($24<<2)|0); //@line 45139 "c/sqlite3.c"
  $26 = HEAP32[$25>>2]|0; //@line 45139 "c/sqlite3.c"
  $27 = (($26) + -1)|0; //@line 45139 "c/sqlite3.c"
  HEAP32[$25>>2] = $27; //@line 45139 "c/sqlite3.c"
  $28 = ($26|0)>(1); //@line 45139 "c/sqlite3.c"
  $spec$select = $28 ? 0 : $$054; //@line 45139 "c/sqlite3.c"
  $29 = (($spec$select) + ($$0))|0; //@line 45140 "c/sqlite3.c"
  $30 = HEAP32[$2>>2]|0; //@line 45141 "c/sqlite3.c"
  $31 = $30 & 2147483647; //@line 45141 "c/sqlite3.c"
  $32 = (($31|0) % ($0|0))&-1; //@line 45141 "c/sqlite3.c"
  HEAP32[$2>>2] = $32; //@line 45141 "c/sqlite3.c"
  $33 = $15 & 1; //@line 45142 "c/sqlite3.c"
  $34 = ($33|0)==(0); //@line 45142 "c/sqlite3.c"
  $35 = (($32) + 1)|0;
  $36 = $35 & 7;
  $37 = 1 << $36;
  if ($34) {
   $49 = $37 ^ 255; //@line 45148 "c/sqlite3.c"
   $50 = $35 >>> 3; //@line 45148 "c/sqlite3.c"
   $51 = (($9) + ($50)|0); //@line 45148 "c/sqlite3.c"
   $52 = HEAP8[$51>>0]|0; //@line 45148 "c/sqlite3.c"
   $53 = $52&255; //@line 45148 "c/sqlite3.c"
   $54 = $49 & $53; //@line 45148 "c/sqlite3.c"
   $55 = $54&255; //@line 45148 "c/sqlite3.c"
   HEAP8[$51>>0] = $55; //@line 45148 "c/sqlite3.c"
   $56 = HEAP32[$2>>2]|0; //@line 45149 "c/sqlite3.c"
   $57 = (($56) + 1)|0; //@line 45149 "c/sqlite3.c"
   _sqlite3BitvecClear($3,$57,$10); //@line 45149 "c/sqlite3.c"
  } else {
   $38 = $35 >>> 3; //@line 45143 "c/sqlite3.c"
   $39 = (($9) + ($38)|0); //@line 45143 "c/sqlite3.c"
   $40 = HEAP8[$39>>0]|0; //@line 45143 "c/sqlite3.c"
   $41 = $40&255; //@line 45143 "c/sqlite3.c"
   $42 = $37 | $41; //@line 45143 "c/sqlite3.c"
   $43 = $42&255; //@line 45143 "c/sqlite3.c"
   HEAP8[$39>>0] = $43; //@line 45143 "c/sqlite3.c"
   $44 = ($15|0)==(5); //@line 45144 "c/sqlite3.c"
   if (!($44)) {
    $45 = HEAP32[$2>>2]|0; //@line 45145 "c/sqlite3.c"
    $46 = (($45) + 1)|0; //@line 45145 "c/sqlite3.c"
    $47 = (_sqlite3BitvecSet($3,$46)|0); //@line 45145 "c/sqlite3.c"
    $48 = ($47|0)==(0); //@line 45145 "c/sqlite3.c"
    if (!($48)) {
     $$055 = -1;
     label = 15;
     break;
    }
   }
  }
  $$0 = $29;
 }
 if ((label|0) == 15) {
  _sqlite3_free($10); //@line 45170 "c/sqlite3.c"
  _sqlite3_free($9); //@line 45171 "c/sqlite3.c"
  _sqlite3BitvecDestroy($3); //@line 45172 "c/sqlite3.c"
  STACKTOP = sp;return ($$055|0); //@line 45173 "c/sqlite3.c"
 }
 $58 = (_sqlite3BitvecTest(0,0)|0); //@line 45158 "c/sqlite3.c"
 $59 = (($0) + 1)|0; //@line 45158 "c/sqlite3.c"
 $60 = (_sqlite3BitvecTest($3,$59)|0); //@line 45158 "c/sqlite3.c"
 $61 = (_sqlite3BitvecTest($3,0)|0); //@line 45159 "c/sqlite3.c"
 $62 = (_sqlite3BitvecSize($3)|0); //@line 45160 "c/sqlite3.c"
 $63 = (($58) - ($0))|0; //@line 45160 "c/sqlite3.c"
 $64 = (($63) + ($60))|0; //@line 45158 "c/sqlite3.c"
 $65 = (($64) + ($61))|0; //@line 45159 "c/sqlite3.c"
 $66 = (($65) + ($62))|0; //@line 45160 "c/sqlite3.c"
 HEAP32[$2>>2] = 1;
 $67 = ($0|0)<(1); //@line 45161 "c/sqlite3.c"
 if ($67) {
  $$055 = $66;
  _sqlite3_free($10); //@line 45170 "c/sqlite3.c"
  _sqlite3_free($9); //@line 45171 "c/sqlite3.c"
  _sqlite3BitvecDestroy($3); //@line 45172 "c/sqlite3.c"
  STACKTOP = sp;return ($$055|0); //@line 45173 "c/sqlite3.c"
 }
 $storemerge57 = 1;
 while(1) {
  $68 = $storemerge57 >>> 3; //@line 45162 "c/sqlite3.c"
  $69 = (($9) + ($68)|0); //@line 45162 "c/sqlite3.c"
  $70 = HEAP8[$69>>0]|0; //@line 45162 "c/sqlite3.c"
  $71 = $70&255; //@line 45162 "c/sqlite3.c"
  $72 = $storemerge57 & 7; //@line 45162 "c/sqlite3.c"
  $73 = 1 << $72; //@line 45162 "c/sqlite3.c"
  $74 = $73 & $71; //@line 45162 "c/sqlite3.c"
  $75 = ($74|0)!=(0); //@line 45162 "c/sqlite3.c"
  $76 = $75&1; //@line 45162 "c/sqlite3.c"
  $77 = (_sqlite3BitvecTest($3,$storemerge57)|0); //@line 45162 "c/sqlite3.c"
  $78 = ($77|0)==($76|0); //@line 45162 "c/sqlite3.c"
  if (!($78)) {
   $$055 = $storemerge57;
   label = 15;
   break;
  }
  $79 = (($storemerge57) + 1)|0; //@line 45161 "c/sqlite3.c"
  HEAP32[$2>>2] = $79;
  $80 = ($storemerge57|0)<($0|0); //@line 45161 "c/sqlite3.c"
  if ($80) {
   $storemerge57 = $79;
  } else {
   $$055 = $66;
   label = 15;
   break;
  }
 }
 if ((label|0) == 15) {
  _sqlite3_free($10); //@line 45170 "c/sqlite3.c"
  _sqlite3_free($9); //@line 45171 "c/sqlite3.c"
  _sqlite3BitvecDestroy($3); //@line 45172 "c/sqlite3.c"
  STACKTOP = sp;return ($$055|0); //@line 45173 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BenignMallocHooks($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[10100] = $0; //@line 21295 "c/sqlite3.c"
 HEAP32[10099] = $1; //@line 21296 "c/sqlite3.c"
 return; //@line 21297 "c/sqlite3.c"
}
function _openDatabase($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$092 = 0, $$09398 = 0, $$095 = 0, $$1 = 0, $$194 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0;
 var $spec$select = 0, $switch$split2D = 0, $vararg_buffer = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $4 = sp + 12|0;
 $5 = sp + 8|0;
 $6 = sp + 4|0;
 HEAP32[$4>>2] = $2;
 HEAP32[$5>>2] = 0; //@line 146171 "c/sqlite3.c"
 HEAP32[$6>>2] = 0; //@line 146172 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 146177 "c/sqlite3.c"
 $7 = (_sqlite3_initialize()|0); //@line 146179 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 146180 "c/sqlite3.c"
 if (!($8)) {
  $$095 = $7;
  STACKTOP = sp;return ($$095|0); //@line 146515 "c/sqlite3.c"
 }
 $9 = HEAP32[(12)>>2]|0; //@line 146183 "c/sqlite3.c"
 $10 = ($9|0)!=(0); //@line 146183 "c/sqlite3.c"
 $11 = $2 & 32768; //@line 146185 "c/sqlite3.c"
 $12 = ($11|0)==(0); //@line 146185 "c/sqlite3.c"
 $or$cond = $12 & $10; //@line 146183 "c/sqlite3.c"
 if ($or$cond) {
  $13 = $2 & 65536; //@line 146187 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 146187 "c/sqlite3.c"
  $15 = HEAP32[(16)>>2]|0; //@line 146190 "c/sqlite3.c"
  $spec$select = $14 ? $15 : 1; //@line 146187 "c/sqlite3.c"
  $$0 = $spec$select;
 } else {
  $$0 = 0;
 }
 $16 = $2 & 262144; //@line 146193 "c/sqlite3.c"
 $17 = ($16|0)==(0); //@line 146193 "c/sqlite3.c"
 if ($17) {
  $19 = HEAP32[(224)>>2]|0; //@line 146195 "c/sqlite3.c"
  $20 = ($19|0)==(0); //@line 146195 "c/sqlite3.c"
  if (!($20)) {
   $21 = $2 | 131072; //@line 146196 "c/sqlite3.c"
   HEAP32[$4>>2] = $21; //@line 146196 "c/sqlite3.c"
  }
 } else {
  $18 = $2 & -131073; //@line 146194 "c/sqlite3.c"
  HEAP32[$4>>2] = $18; //@line 146194 "c/sqlite3.c"
 }
 $22 = HEAP32[$4>>2]|0; //@line 146208 "c/sqlite3.c"
 $23 = $22 & -655129; //@line 146208 "c/sqlite3.c"
 HEAP32[$4>>2] = $23; //@line 146208 "c/sqlite3.c"
 $24 = (_sqlite3MallocZero(472,0)|0); //@line 146223 "c/sqlite3.c"
 $25 = ($24|0)==(0|0); //@line 146224 "c/sqlite3.c"
 do {
  if ($25) {
   $$09398 = 0;
  } else {
   $26 = ($$0|0)==(0); //@line 146225 "c/sqlite3.c"
   if (!($26)) {
    $27 = (_sqlite3MutexAlloc(1)|0); //@line 146230 "c/sqlite3.c"
    $28 = ((($24)) + 12|0); //@line 146230 "c/sqlite3.c"
    HEAP32[$28>>2] = $27; //@line 146230 "c/sqlite3.c"
    $29 = ($27|0)==(0|0); //@line 146231 "c/sqlite3.c"
    if ($29) {
     _sqlite3_free($24); //@line 146232 "c/sqlite3.c"
     $$09398 = 0;
     break;
    }
   }
   $30 = ((($24)) + 12|0); //@line 146240 "c/sqlite3.c"
   $31 = HEAP32[$30>>2]|0; //@line 146240 "c/sqlite3.c"
   _sqlite3_mutex_enter($31); //@line 146240 "c/sqlite3.c"
   $32 = ((($24)) + 60|0); //@line 146241 "c/sqlite3.c"
   HEAP32[$32>>2] = 255; //@line 146241 "c/sqlite3.c"
   $33 = ((($24)) + 20|0); //@line 146242 "c/sqlite3.c"
   HEAP32[$33>>2] = 2; //@line 146242 "c/sqlite3.c"
   $34 = ((($24)) + 88|0); //@line 146243 "c/sqlite3.c"
   HEAP32[$34>>2] = -264537850; //@line 146243 "c/sqlite3.c"
   $35 = ((($24)) + 400|0); //@line 146244 "c/sqlite3.c"
   $36 = ((($24)) + 16|0); //@line 146244 "c/sqlite3.c"
   HEAP32[$36>>2] = $35; //@line 146244 "c/sqlite3.c"
   $37 = ((($24)) + 100|0); //@line 146247 "c/sqlite3.c"
   dest=$37; src=6464; stop=dest+44|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 146247 "c/sqlite3.c"
   $38 = ((($24)) + 144|0); //@line 146248 "c/sqlite3.c"
   HEAP32[$38>>2] = 0; //@line 146248 "c/sqlite3.c"
   $39 = ((($24)) + 71|0); //@line 146249 "c/sqlite3.c"
   HEAP8[$39>>0] = 1; //@line 146249 "c/sqlite3.c"
   $40 = ((($24)) + 76|0); //@line 146250 "c/sqlite3.c"
   HEAP8[$40>>0] = -1; //@line 146250 "c/sqlite3.c"
   $41 = (192); //@line 146251 "c/sqlite3.c"
   $42 = $41; //@line 146251 "c/sqlite3.c"
   $43 = HEAP32[$42>>2]|0; //@line 146251 "c/sqlite3.c"
   $44 = (($41) + 4)|0; //@line 146251 "c/sqlite3.c"
   $45 = $44; //@line 146251 "c/sqlite3.c"
   $46 = HEAP32[$45>>2]|0; //@line 146251 "c/sqlite3.c"
   $47 = ((($24)) + 40|0); //@line 146251 "c/sqlite3.c"
   $48 = $47; //@line 146251 "c/sqlite3.c"
   $49 = $48; //@line 146251 "c/sqlite3.c"
   HEAP32[$49>>2] = $43; //@line 146251 "c/sqlite3.c"
   $50 = (($48) + 4)|0; //@line 146251 "c/sqlite3.c"
   $51 = $50; //@line 146251 "c/sqlite3.c"
   HEAP32[$51>>2] = $46; //@line 146251 "c/sqlite3.c"
   $52 = ((($24)) + 84|0); //@line 146252 "c/sqlite3.c"
   HEAP32[$52>>2] = 0; //@line 146252 "c/sqlite3.c"
   $53 = ((($24)) + 148|0); //@line 146253 "c/sqlite3.c"
   HEAP32[$53>>2] = 2147483647; //@line 146253 "c/sqlite3.c"
   $54 = ((($24)) + 28|0); //@line 146254 "c/sqlite3.c"
   $55 = HEAP32[$54>>2]|0; //@line 146254 "c/sqlite3.c"
   $56 = $55 | 295008; //@line 146254 "c/sqlite3.c"
   HEAP32[$54>>2] = $56; //@line 146254 "c/sqlite3.c"
   $57 = ((($24)) + 372|0); //@line 146286 "c/sqlite3.c"
   _sqlite3HashInit($57); //@line 146286 "c/sqlite3.c"
   $58 = ((($24)) + 328|0); //@line 146288 "c/sqlite3.c"
   _sqlite3HashInit($58); //@line 146288 "c/sqlite3.c"
   (_createCollation($24,18038,1,0,87,0)|0); //@line 146298 "c/sqlite3.c"
   (_createCollation($24,18038,3,0,87,0)|0); //@line 146299 "c/sqlite3.c"
   (_createCollation($24,18038,2,0,87,0)|0); //@line 146300 "c/sqlite3.c"
   (_createCollation($24,27796,1,0,88,0)|0); //@line 146301 "c/sqlite3.c"
   (_createCollation($24,35680,1,(1),87,0)|0); //@line 146302 "c/sqlite3.c"
   $59 = ((($24)) + 73|0); //@line 146303 "c/sqlite3.c"
   $60 = HEAP8[$59>>0]|0; //@line 146303 "c/sqlite3.c"
   $61 = ($60<<24>>24)==(0); //@line 146303 "c/sqlite3.c"
   L18: do {
    if ($61) {
     $62 = (_sqlite3FindCollSeq($24,1,18038,0)|0); //@line 146309 "c/sqlite3.c"
     $63 = ((($24)) + 8|0); //@line 146309 "c/sqlite3.c"
     HEAP32[$63>>2] = $62; //@line 146309 "c/sqlite3.c"
     $64 = ((($24)) + 52|0); //@line 146324 "c/sqlite3.c"
     HEAP32[$64>>2] = $23; //@line 146324 "c/sqlite3.c"
     $65 = $22 & 7; //@line 146331 "c/sqlite3.c"
     $66 = 1 << $65; //@line 146331 "c/sqlite3.c"
     $67 = $66 & 70; //@line 146331 "c/sqlite3.c"
     $68 = ($67|0)==(0); //@line 146331 "c/sqlite3.c"
     if ($68) {
      $69 = (_sqlite3MisuseError(146332)|0); //@line 146332 "c/sqlite3.c"
      $$092 = $69;
     } else {
      $70 = (_sqlite3ParseUri($3,$0,$4,$24,$5,$6)|0); //@line 146334 "c/sqlite3.c"
      $$092 = $70;
     }
     switch ($$092|0) {
     case 0:  {
      $74 = HEAP32[$24>>2]|0; //@line 146344 "c/sqlite3.c"
      $75 = HEAP32[$5>>2]|0; //@line 146344 "c/sqlite3.c"
      $76 = HEAP32[$36>>2]|0; //@line 146344 "c/sqlite3.c"
      $77 = ((($76)) + 4|0); //@line 146344 "c/sqlite3.c"
      $78 = HEAP32[$4>>2]|0; //@line 146345 "c/sqlite3.c"
      $79 = $78 | 256; //@line 146345 "c/sqlite3.c"
      $80 = (_sqlite3BtreeOpen($74,$75,$24,$77,0,$79)|0); //@line 146344 "c/sqlite3.c"
      $switch$split2D = ($80|0)<(3082);
      L26: do {
       if ($switch$split2D) {
        switch ($80|0) {
        case 0:  {
         break;
        }
        default: {
         $$1 = $80;
         break L26;
        }
        }
        $81 = HEAP32[$36>>2]|0; //@line 146353 "c/sqlite3.c"
        $82 = ((($81)) + 4|0); //@line 146353 "c/sqlite3.c"
        $83 = HEAP32[$82>>2]|0; //@line 146353 "c/sqlite3.c"
        _sqlite3BtreeEnter($83); //@line 146353 "c/sqlite3.c"
        $84 = HEAP32[$36>>2]|0; //@line 146354 "c/sqlite3.c"
        $85 = ((($84)) + 4|0); //@line 146354 "c/sqlite3.c"
        $86 = HEAP32[$85>>2]|0; //@line 146354 "c/sqlite3.c"
        $87 = (_sqlite3SchemaGet($24,$86)|0); //@line 146354 "c/sqlite3.c"
        $88 = HEAP32[$36>>2]|0; //@line 146354 "c/sqlite3.c"
        $89 = ((($88)) + 12|0); //@line 146354 "c/sqlite3.c"
        HEAP32[$89>>2] = $87; //@line 146354 "c/sqlite3.c"
        $90 = HEAP8[$59>>0]|0; //@line 146355 "c/sqlite3.c"
        $91 = ($90<<24>>24)==(0); //@line 146355 "c/sqlite3.c"
        if ($91) {
         $92 = ((($87)) + 77|0); //@line 146355 "c/sqlite3.c"
         $93 = HEAP8[$92>>0]|0; //@line 146355 "c/sqlite3.c"
         $94 = ((($24)) + 70|0); //@line 146355 "c/sqlite3.c"
         HEAP8[$94>>0] = $93; //@line 146355 "c/sqlite3.c"
        }
        $95 = ((($88)) + 4|0); //@line 146356 "c/sqlite3.c"
        $96 = HEAP32[$95>>2]|0; //@line 146356 "c/sqlite3.c"
        _sqlite3BtreeLeave($96); //@line 146356 "c/sqlite3.c"
        $97 = (_sqlite3SchemaGet($24,0)|0); //@line 146357 "c/sqlite3.c"
        $98 = HEAP32[$36>>2]|0; //@line 146357 "c/sqlite3.c"
        $99 = ((($98)) + 28|0); //@line 146357 "c/sqlite3.c"
        HEAP32[$99>>2] = $97; //@line 146357 "c/sqlite3.c"
        HEAP32[$98>>2] = 21361; //@line 146362 "c/sqlite3.c"
        $100 = ((($98)) + 8|0); //@line 146363 "c/sqlite3.c"
        HEAP8[$100>>0] = 3; //@line 146363 "c/sqlite3.c"
        $101 = ((($98)) + 16|0); //@line 146364 "c/sqlite3.c"
        HEAP32[$101>>2] = 35686; //@line 146364 "c/sqlite3.c"
        $102 = ((($98)) + 24|0); //@line 146365 "c/sqlite3.c"
        HEAP8[$102>>0] = 1; //@line 146365 "c/sqlite3.c"
        HEAP32[$34>>2] = -1607883113; //@line 146367 "c/sqlite3.c"
        $103 = HEAP8[$59>>0]|0; //@line 146368 "c/sqlite3.c"
        $104 = ($103<<24>>24)==(0); //@line 146368 "c/sqlite3.c"
        if (!($104)) {
         break L18;
        }
        _sqlite3Error($24,0); //@line 146376 "c/sqlite3.c"
        _sqlite3RegisterPerConnectionBuiltinFunctions($24); //@line 146377 "c/sqlite3.c"
        $105 = (_sqlite3_errcode($24)|0); //@line 146378 "c/sqlite3.c"
        $106 = ($105|0)==(0); //@line 146392 "c/sqlite3.c"
        if ($106) {
         _sqlite3AutoLoadExtensions($24); //@line 146393 "c/sqlite3.c"
         $107 = (_sqlite3_errcode($24)|0); //@line 146394 "c/sqlite3.c"
         $108 = ($107|0)==(0); //@line 146395 "c/sqlite3.c"
         if (!($108)) {
          break L18;
         }
        } else {
         _sqlite3Error($24,$105); //@line 146466 "c/sqlite3.c"
        }
        $109 = HEAP32[(40)>>2]|0; //@line 146469 "c/sqlite3.c"
        $110 = HEAP32[(44)>>2]|0; //@line 146470 "c/sqlite3.c"
        (_setupLookaside($24,0,$109,$110)|0); //@line 146469 "c/sqlite3.c"
        (_sqlite3_wal_autocheckpoint($24,1000)|0); //@line 146472 "c/sqlite3.c"
        break L18;
       } else {
        switch ($80|0) {
        case 3082:  {
         break;
        }
        default: {
         $$1 = $80;
         break L26;
        }
        }
        $$1 = 7;
       }
      } while(0);
      _sqlite3Error($24,$$1); //@line 146350 "c/sqlite3.c"
      break L18;
      break;
     }
     case 7:  {
      _sqlite3OomFault($24); //@line 146337 "c/sqlite3.c"
      break;
     }
     default: {
     }
     }
     $71 = HEAP32[$6>>2]|0; //@line 146338 "c/sqlite3.c"
     $72 = ($71|0)==(0|0); //@line 146338 "c/sqlite3.c"
     $73 = $72 ? 0 : 15687; //@line 146338 "c/sqlite3.c"
     HEAP32[$vararg_buffer>>2] = $71; //@line 146338 "c/sqlite3.c"
     _sqlite3ErrorWithMsg($24,$$092,$73,$vararg_buffer); //@line 146338 "c/sqlite3.c"
     _sqlite3_free($71); //@line 146339 "c/sqlite3.c"
    }
   } while(0);
   $111 = ((($24)) + 12|0); //@line 146478 "c/sqlite3.c"
   $112 = HEAP32[$111>>2]|0; //@line 146478 "c/sqlite3.c"
   _sqlite3_mutex_leave($112); //@line 146478 "c/sqlite3.c"
   $$09398 = $24;
  }
 } while(0);
 $113 = (_sqlite3_errcode($$09398)|0); //@line 146480 "c/sqlite3.c"
 switch ($113|0) {
 case 7:  {
  (_sqlite3_close($$09398)|0); //@line 146483 "c/sqlite3.c"
  $$194 = 0;
  break;
 }
 case 0:  {
  $$194 = $$09398;
  break;
 }
 default: {
  $114 = ((($$09398)) + 88|0); //@line 146486 "c/sqlite3.c"
  HEAP32[$114>>2] = 1266094736; //@line 146486 "c/sqlite3.c"
  $$194 = $$09398;
 }
 }
 HEAP32[$1>>2] = $$194; //@line 146488 "c/sqlite3.c"
 $115 = HEAP32[$5>>2]|0; //@line 146513 "c/sqlite3.c"
 _sqlite3_free($115); //@line 146513 "c/sqlite3.c"
 $116 = $113 & 255; //@line 146514 "c/sqlite3.c"
 $$095 = $116;
 STACKTOP = sp;return ($$095|0); //@line 146515 "c/sqlite3.c"
}
function _binCollFunc($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)<($3|0); //@line 144238 "c/sqlite3.c"
 $6 = $5 ? $1 : $3; //@line 144238 "c/sqlite3.c"
 $7 = (_memcmp($2,$4,$6)|0); //@line 144243 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 144244 "c/sqlite3.c"
 if (!($8)) {
  $$0 = $7;
  return ($$0|0); //@line 144258 "c/sqlite3.c"
 }
 $9 = ($0|0)==(0|0); //@line 144245 "c/sqlite3.c"
 if (!($9)) {
  $10 = (($2) + ($6)|0); //@line 144246 "c/sqlite3.c"
  $11 = (($1) - ($6))|0; //@line 144246 "c/sqlite3.c"
  $12 = (_allSpaces($10,$11)|0); //@line 144246 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 144246 "c/sqlite3.c"
  if (!($13)) {
   $14 = (($4) + ($6)|0); //@line 144247 "c/sqlite3.c"
   $15 = (($3) - ($6))|0; //@line 144247 "c/sqlite3.c"
   $16 = (_allSpaces($14,$15)|0); //@line 144247 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 144247 "c/sqlite3.c"
   if (!($17)) {
    $$0 = 0;
    return ($$0|0); //@line 144258 "c/sqlite3.c"
   }
  }
 }
 $18 = (($1) - ($3))|0; //@line 144255 "c/sqlite3.c"
 $$0 = $18;
 return ($$0|0); //@line 144258 "c/sqlite3.c"
}
function _createCollation($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $$05354 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0;
 var $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 145719 "c/sqlite3.c"
 $6 = $2&255; //@line 145735 "c/sqlite3.c"
 switch ($2<<24>>24) {
 case 4: case 8:  {
  $$05354 = 2;
  break;
 }
 default: {
  $7 = (($6) + -1)|0; //@line 145741 "c/sqlite3.c"
  $8 = ($7>>>0)>(2); //@line 145741 "c/sqlite3.c"
  if ($8) {
   $9 = (_sqlite3MisuseError(145742)|0); //@line 145742 "c/sqlite3.c"
   $$0 = $9;
   STACKTOP = sp;return ($$0|0); //@line 145787 "c/sqlite3.c"
  } else {
   $$05354 = $6;
  }
 }
 }
 $10 = $$05354&255; //@line 145749 "c/sqlite3.c"
 $11 = (_sqlite3FindCollSeq($0,$10,$1,0)|0); //@line 145749 "c/sqlite3.c"
 $12 = ($11|0)==(0|0); //@line 145750 "c/sqlite3.c"
 if (!($12)) {
  $13 = ((($11)) + 12|0); //@line 145750 "c/sqlite3.c"
  $14 = HEAP32[$13>>2]|0; //@line 145750 "c/sqlite3.c"
  $15 = ($14|0)==(0|0); //@line 145750 "c/sqlite3.c"
  if (!($15)) {
   $16 = ((($0)) + 160|0); //@line 145751 "c/sqlite3.c"
   $17 = HEAP32[$16>>2]|0; //@line 145751 "c/sqlite3.c"
   $18 = ($17|0)==(0); //@line 145751 "c/sqlite3.c"
   if (!($18)) {
    _sqlite3ErrorWithMsg($0,5,35736,$vararg_buffer); //@line 145752 "c/sqlite3.c"
    $$0 = 5;
    STACKTOP = sp;return ($$0|0); //@line 145787 "c/sqlite3.c"
   }
   _sqlite3ExpirePreparedStatements($0); //@line 145756 "c/sqlite3.c"
   $19 = ((($11)) + 4|0); //@line 145764 "c/sqlite3.c"
   $20 = HEAP8[$19>>0]|0; //@line 145764 "c/sqlite3.c"
   $21 = $20 & -9; //@line 145764 "c/sqlite3.c"
   $22 = $21&255; //@line 145764 "c/sqlite3.c"
   $23 = ($$05354|0)==($22|0); //@line 145764 "c/sqlite3.c"
   if ($23) {
    $24 = ((($0)) + 372|0); //@line 145765 "c/sqlite3.c"
    $25 = (_sqlite3HashFind($24,$1)|0); //@line 145765 "c/sqlite3.c"
    $26 = ((($25)) + 4|0); //@line 145769 "c/sqlite3.c"
    $27 = HEAP8[$26>>0]|0; //@line 145769 "c/sqlite3.c"
    $28 = HEAP8[$19>>0]|0; //@line 145769 "c/sqlite3.c"
    $29 = ($27<<24>>24)==($28<<24>>24); //@line 145769 "c/sqlite3.c"
    if ($29) {
     $30 = ((($25)) + 16|0); //@line 145770 "c/sqlite3.c"
     $31 = HEAP32[$30>>2]|0; //@line 145770 "c/sqlite3.c"
     $32 = ($31|0)==(0|0); //@line 145770 "c/sqlite3.c"
     if (!($32)) {
      $33 = ((($25)) + 8|0); //@line 145771 "c/sqlite3.c"
      $34 = HEAP32[$33>>2]|0; //@line 145771 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$31 & 127]($34); //@line 145771 "c/sqlite3.c"
     }
     $35 = ((($25)) + 12|0); //@line 145773 "c/sqlite3.c"
     HEAP32[$35>>2] = 0; //@line 145773 "c/sqlite3.c"
    }
    $36 = ((($25)) + 24|0); //@line 145769 "c/sqlite3.c"
    $37 = HEAP8[$36>>0]|0; //@line 145769 "c/sqlite3.c"
    $38 = HEAP8[$19>>0]|0; //@line 145769 "c/sqlite3.c"
    $39 = ($37<<24>>24)==($38<<24>>24); //@line 145769 "c/sqlite3.c"
    if ($39) {
     $49 = ((($25)) + 36|0); //@line 145770 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 145770 "c/sqlite3.c"
     $51 = ($50|0)==(0|0); //@line 145770 "c/sqlite3.c"
     if (!($51)) {
      $52 = ((($25)) + 28|0); //@line 145771 "c/sqlite3.c"
      $53 = HEAP32[$52>>2]|0; //@line 145771 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$50 & 127]($53); //@line 145771 "c/sqlite3.c"
     }
     $54 = ((($25)) + 32|0); //@line 145773 "c/sqlite3.c"
     HEAP32[$54>>2] = 0; //@line 145773 "c/sqlite3.c"
    }
    $55 = ((($25)) + 44|0); //@line 145769 "c/sqlite3.c"
    $56 = HEAP8[$55>>0]|0; //@line 145769 "c/sqlite3.c"
    $57 = HEAP8[$19>>0]|0; //@line 145769 "c/sqlite3.c"
    $58 = ($56<<24>>24)==($57<<24>>24); //@line 145769 "c/sqlite3.c"
    if ($58) {
     $59 = ((($25)) + 56|0); //@line 145770 "c/sqlite3.c"
     $60 = HEAP32[$59>>2]|0; //@line 145770 "c/sqlite3.c"
     $61 = ($60|0)==(0|0); //@line 145770 "c/sqlite3.c"
     if (!($61)) {
      $62 = ((($25)) + 48|0); //@line 145771 "c/sqlite3.c"
      $63 = HEAP32[$62>>2]|0; //@line 145771 "c/sqlite3.c"
      FUNCTION_TABLE_vi[$60 & 127]($63); //@line 145771 "c/sqlite3.c"
     }
     $64 = ((($25)) + 52|0); //@line 145773 "c/sqlite3.c"
     HEAP32[$64>>2] = 0; //@line 145773 "c/sqlite3.c"
    }
   }
  }
 }
 $40 = (_sqlite3FindCollSeq($0,$10,$1,1)|0); //@line 145779 "c/sqlite3.c"
 $41 = ($40|0)==(0|0); //@line 145780 "c/sqlite3.c"
 if ($41) {
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 145787 "c/sqlite3.c"
 }
 $42 = ((($40)) + 12|0); //@line 145781 "c/sqlite3.c"
 HEAP32[$42>>2] = $4; //@line 145781 "c/sqlite3.c"
 $43 = ((($40)) + 8|0); //@line 145782 "c/sqlite3.c"
 HEAP32[$43>>2] = $3; //@line 145782 "c/sqlite3.c"
 $44 = ((($40)) + 16|0); //@line 145783 "c/sqlite3.c"
 HEAP32[$44>>2] = $5; //@line 145783 "c/sqlite3.c"
 $45 = $6 & 8; //@line 145784 "c/sqlite3.c"
 $46 = $$05354 | $45; //@line 145784 "c/sqlite3.c"
 $47 = $46&255; //@line 145784 "c/sqlite3.c"
 $48 = ((($40)) + 4|0); //@line 145784 "c/sqlite3.c"
 HEAP8[$48>>0] = $47; //@line 145784 "c/sqlite3.c"
 _sqlite3Error($0,0); //@line 145785 "c/sqlite3.c"
 $$0 = 0;
 STACKTOP = sp;return ($$0|0); //@line 145787 "c/sqlite3.c"
}
function _nocaseCollatingFunc($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ($1|0)<($3|0); //@line 144276 "c/sqlite3.c"
 $6 = $5 ? $1 : $3; //@line 144276 "c/sqlite3.c"
 $7 = (_sqlite3_strnicmp($2,$4,$6)|0); //@line 144275 "c/sqlite3.c"
 $8 = ($7|0)==(0); //@line 144278 "c/sqlite3.c"
 $9 = (($1) - ($3))|0; //@line 144279 "c/sqlite3.c"
 $spec$select = $8 ? $9 : $7; //@line 144278 "c/sqlite3.c"
 return ($spec$select|0); //@line 144281 "c/sqlite3.c"
}
function _sqlite3RegisterPerConnectionBuiltinFunctions($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_sqlite3_overload_function($0,35730,2)|0); //@line 109185 "c/sqlite3.c"
 $2 = ($1|0)==(7); //@line 109187 "c/sqlite3.c"
 if (!($2)) {
  return; //@line 109190 "c/sqlite3.c"
 }
 _sqlite3OomFault($0); //@line 109188 "c/sqlite3.c"
 return; //@line 109190 "c/sqlite3.c"
}
function _sqlite3AutoLoadExtensions($0) {
 $0 = $0|0;
 var $$02224 = 0, $$025 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $1 = sp + 4|0;
 $2 = HEAP32[10113]|0; //@line 114607 "c/sqlite3.c"
 $3 = ($2|0)==(0); //@line 114607 "c/sqlite3.c"
 if ($3) {
  STACKTOP = sp;return; //@line 114637 "c/sqlite3.c"
 }
 $$02224 = 1;$$025 = 0;
 while(1) {
  $4 = (_sqlite3MutexAlloc(2)|0); //@line 114614 "c/sqlite3.c"
  _sqlite3_mutex_enter($4); //@line 114621 "c/sqlite3.c"
  $5 = HEAP32[10113]|0; //@line 114622 "c/sqlite3.c"
  $6 = ($$025>>>0)<($5>>>0); //@line 114622 "c/sqlite3.c"
  if ($6) {
   $7 = HEAP32[10112]|0; //@line 114626 "c/sqlite3.c"
   $8 = (($7) + ($$025<<2)|0); //@line 114626 "c/sqlite3.c"
   $9 = HEAP32[$8>>2]|0; //@line 114626 "c/sqlite3.c"
   _sqlite3_mutex_leave($4); //@line 114628 "c/sqlite3.c"
   HEAP32[$1>>2] = 0; //@line 114629 "c/sqlite3.c"
   $10 = ($9|0)==(0|0); //@line 114630 "c/sqlite3.c"
   if ($10) {
    $$2 = $$02224;
   } else {
    $11 = (FUNCTION_TABLE_iiii[$9 & 127]($0,$1,3932)|0); //@line 114630 "c/sqlite3.c"
    $12 = ($11|0)==(0); //@line 114630 "c/sqlite3.c"
    if ($12) {
     $$2 = $$02224;
    } else {
     $13 = HEAP32[$1>>2]|0; //@line 114632 "c/sqlite3.c"
     HEAP32[$vararg_buffer>>2] = $13; //@line 114631 "c/sqlite3.c"
     _sqlite3ErrorWithMsg($0,$11,35691,$vararg_buffer); //@line 114631 "c/sqlite3.c"
     $$2 = 0;
    }
   }
  } else {
   _sqlite3_mutex_leave($4); //@line 114628 "c/sqlite3.c"
   HEAP32[$1>>2] = 0; //@line 114629 "c/sqlite3.c"
   $$2 = 0;
  }
  $14 = HEAP32[$1>>2]|0; //@line 114635 "c/sqlite3.c"
  _sqlite3_free($14); //@line 114635 "c/sqlite3.c"
  $15 = (($$025) + 1)|0; //@line 114611 "c/sqlite3.c"
  $16 = ($$2|0)==(0); //@line 114611 "c/sqlite3.c"
  if ($16) {
   break;
  } else {
   $$02224 = $$2;$$025 = $15;
  }
 }
 STACKTOP = sp;return; //@line 114637 "c/sqlite3.c"
}
function _allSpaces($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$03 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)>(0); //@line 144221 "c/sqlite3.c"
 L1: do {
  if ($2) {
   $$03 = $1;
   while(1) {
    $4 = (($$03) + -1)|0; //@line 144221 "c/sqlite3.c"
    $5 = (($0) + ($4)|0); //@line 144221 "c/sqlite3.c"
    $6 = HEAP8[$5>>0]|0; //@line 144221 "c/sqlite3.c"
    $7 = ($6<<24>>24)==(32); //@line 144221 "c/sqlite3.c"
    if (!($7)) {
     $$0$lcssa = $$03;
     break L1;
    }
    $3 = ($$03|0)>(1); //@line 144221 "c/sqlite3.c"
    if ($3) {
     $$03 = $4;
    } else {
     $$0$lcssa = $4;
     break;
    }
   }
  } else {
   $$0$lcssa = $1;
  }
 } while(0);
 $8 = ($$0$lcssa|0)==(0); //@line 144222 "c/sqlite3.c"
 $9 = $8&1; //@line 144222 "c/sqlite3.c"
 return ($9|0); //@line 144222 "c/sqlite3.c"
}
function _sqlite3PagerJrnlFile($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 212|0); //@line 54924 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 54924 "c/sqlite3.c"
 $3 = ($2|0)==(0|0); //@line 54924 "c/sqlite3.c"
 if ($3) {
  $5 = ((($0)) + 64|0); //@line 54924 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 54924 "c/sqlite3.c"
  $7 = $6;
  return ($7|0); //@line 54924 "c/sqlite3.c"
 } else {
  $4 = (_sqlite3WalFile($2)|0); //@line 54924 "c/sqlite3.c"
  $7 = $4;
  return ($7|0); //@line 54924 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3WalFile($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 59378 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 59378 "c/sqlite3.c"
 return ($2|0); //@line 59378 "c/sqlite3.c"
}
function _sqlite3BtreePutData($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP8[$0>>0]|0; //@line 70263 "c/sqlite3.c"
 $5 = ($4&255)>(2); //@line 70263 "c/sqlite3.c"
 do {
  if ($5) {
   $6 = (_btreeRestoreCursorPosition($0)|0); //@line 70263 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 70264 "c/sqlite3.c"
   if ($7) {
    $$pr = HEAP8[$0>>0]|0; //@line 70268 "c/sqlite3.c"
    $9 = $$pr;
    break;
   } else {
    $$0 = $6;
    return ($$0|0); //@line 70300 "c/sqlite3.c"
   }
  } else {
   $9 = $4;
  }
 } while(0);
 $8 = ($9<<24>>24)==(1); //@line 70268 "c/sqlite3.c"
 if (!($8)) {
  $$0 = 4;
  return ($$0|0); //@line 70300 "c/sqlite3.c"
 }
 $10 = ((($0)) + 12|0); //@line 70280 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 70280 "c/sqlite3.c"
 $12 = ((($0)) + 60|0); //@line 70280 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 70280 "c/sqlite3.c"
 (_saveAllCursors($11,$13,$0)|0); //@line 70280 "c/sqlite3.c"
 $14 = ((($0)) + 1|0); //@line 70290 "c/sqlite3.c"
 $15 = HEAP8[$14>>0]|0; //@line 70290 "c/sqlite3.c"
 $16 = $15 & 1; //@line 70290 "c/sqlite3.c"
 $17 = ($16<<24>>24)==(0); //@line 70290 "c/sqlite3.c"
 if ($17) {
  $$0 = 8;
  return ($$0|0); //@line 70300 "c/sqlite3.c"
 }
 $18 = (_accessPayload($0,$1,$2,$3,1)|0); //@line 70299 "c/sqlite3.c"
 $$0 = $18;
 return ($$0|0); //@line 70300 "c/sqlite3.c"
}
function _blobReadWrite($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $$038 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $5 = ($0|0)==(0|0); //@line 87675 "c/sqlite3.c"
 if ($5) {
  $6 = (_sqlite3MisuseError(87675)|0); //@line 87675 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 87731 "c/sqlite3.c"
 }
 $7 = ((($0)) + 20|0); //@line 87676 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 87676 "c/sqlite3.c"
 $9 = ((($8)) + 12|0); //@line 87677 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 87677 "c/sqlite3.c"
 _sqlite3_mutex_enter($10); //@line 87677 "c/sqlite3.c"
 $11 = ((($0)) + 16|0); //@line 87678 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 87678 "c/sqlite3.c"
 $13 = $3 | $2; //@line 87680 "c/sqlite3.c"
 $14 = ($13|0)<(0); //@line 87680 "c/sqlite3.c"
 do {
  if ($14) {
   $$038 = 1;
  } else {
   $15 = ($3|0)<(0); //@line 87680 "c/sqlite3.c"
   $16 = $15 << 31 >> 31; //@line 87680 "c/sqlite3.c"
   $17 = ($2|0)<(0); //@line 87680 "c/sqlite3.c"
   $18 = $17 << 31 >> 31; //@line 87680 "c/sqlite3.c"
   $19 = (_i64Add(($3|0),($16|0),($2|0),($18|0))|0); //@line 87680 "c/sqlite3.c"
   $20 = tempRet0; //@line 87680 "c/sqlite3.c"
   $21 = HEAP32[$0>>2]|0; //@line 87680 "c/sqlite3.c"
   $22 = ($21|0)<(0); //@line 87680 "c/sqlite3.c"
   $23 = $22 << 31 >> 31; //@line 87680 "c/sqlite3.c"
   $24 = ($20|0)>($23|0); //@line 87680 "c/sqlite3.c"
   $25 = ($19>>>0)>($21>>>0); //@line 87680 "c/sqlite3.c"
   $26 = ($20|0)==($23|0); //@line 87680 "c/sqlite3.c"
   $27 = $26 & $25; //@line 87680 "c/sqlite3.c"
   $28 = $24 | $27; //@line 87680 "c/sqlite3.c"
   if ($28) {
    $$038 = 1;
   } else {
    $29 = ($12|0)==(0|0); //@line 87683 "c/sqlite3.c"
    if ($29) {
     $$038 = 4;
    } else {
     $30 = ((($0)) + 12|0); //@line 87693 "c/sqlite3.c"
     $31 = HEAP32[$30>>2]|0; //@line 87693 "c/sqlite3.c"
     _sqlite3BtreeEnterCursor($31); //@line 87693 "c/sqlite3.c"
     $32 = HEAP32[$30>>2]|0; //@line 87718 "c/sqlite3.c"
     $33 = ((($0)) + 4|0); //@line 87718 "c/sqlite3.c"
     $34 = HEAP32[$33>>2]|0; //@line 87718 "c/sqlite3.c"
     $35 = (($34) + ($3))|0; //@line 87718 "c/sqlite3.c"
     $36 = (FUNCTION_TABLE_iiiii[$4 & 127]($32,$35,$2,$1)|0); //@line 87718 "c/sqlite3.c"
     $37 = HEAP32[$30>>2]|0; //@line 87719 "c/sqlite3.c"
     _sqlite3BtreeLeaveCursor($37); //@line 87719 "c/sqlite3.c"
     $38 = ($36|0)==(4); //@line 87720 "c/sqlite3.c"
     if ($38) {
      (_sqlite3VdbeFinalize($12)|0); //@line 87721 "c/sqlite3.c"
      HEAP32[$11>>2] = 0; //@line 87722 "c/sqlite3.c"
      $$038 = 4;
      break;
     } else {
      $39 = ((($12)) + 40|0); //@line 87724 "c/sqlite3.c"
      HEAP32[$39>>2] = $36; //@line 87724 "c/sqlite3.c"
      $$038 = $36;
      break;
     }
    }
   }
  }
 } while(0);
 _sqlite3Error($8,$$038); //@line 87727 "c/sqlite3.c"
 $40 = (_sqlite3ApiExit($8,$$038)|0); //@line 87728 "c/sqlite3.c"
 $41 = HEAP32[$9>>2]|0; //@line 87729 "c/sqlite3.c"
 _sqlite3_mutex_leave($41); //@line 87729 "c/sqlite3.c"
 $$0 = $40;
 return ($$0|0); //@line 87731 "c/sqlite3.c"
}
function _sqlite3BtreeEnterCursor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 60391 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60391 "c/sqlite3.c"
 _sqlite3BtreeEnter($2); //@line 60391 "c/sqlite3.c"
 return; //@line 60392 "c/sqlite3.c"
}
function _sqlite3BtreePayloadChecked($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP8[$0>>0]|0; //@line 65240 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(1); //@line 65240 "c/sqlite3.c"
 if ($5) {
  $6 = (_accessPayload($0,$1,$2,$3,0)|0); //@line 65242 "c/sqlite3.c"
  $$0 = $6;
  return ($$0|0); //@line 65246 "c/sqlite3.c"
 } else {
  $7 = (_accessPayloadChecked($0,$1,$2,$3)|0); //@line 65244 "c/sqlite3.c"
  $$0 = $7;
  return ($$0|0); //@line 65246 "c/sqlite3.c"
 }
 return (0)|0;
}
function _sqlite3BtreeLeaveCursor($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 8|0); //@line 60395 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 60395 "c/sqlite3.c"
 _sqlite3BtreeLeave($2); //@line 60395 "c/sqlite3.c"
 return; //@line 60396 "c/sqlite3.c"
}
function _accessPayloadChecked($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = HEAP8[$0>>0]|0; //@line 65232 "c/sqlite3.c"
 $5 = ($4<<24>>24)==(0); //@line 65232 "c/sqlite3.c"
 if ($5) {
  $$0 = 4;
 } else {
  $6 = (_btreeRestoreCursorPosition($0)|0); //@line 65236 "c/sqlite3.c"
  $7 = ($6|0)==(0); //@line 65237 "c/sqlite3.c"
  if ($7) {
   $8 = (_accessPayload($0,$1,$2,$3,0)|0); //@line 65237 "c/sqlite3.c"
   $$0 = $8;
  } else {
   $$0 = $6;
  }
 }
 return ($$0|0); //@line 65238 "c/sqlite3.c"
}
function _createModule($0,$1,$2,$3,$4) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $5 = ((($0)) + 12|0); //@line 127441 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 127441 "c/sqlite3.c"
 _sqlite3_mutex_enter($6); //@line 127441 "c/sqlite3.c"
 $7 = ((($0)) + 328|0); //@line 127442 "c/sqlite3.c"
 $8 = (_sqlite3HashFind($7,$1)|0); //@line 127442 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 127442 "c/sqlite3.c"
 if ($9) {
  (_sqlite3VtabCreateModule($0,$1,$2,$3,$4)|0); //@line 127445 "c/sqlite3.c"
  $$0 = 0;
 } else {
  $10 = (_sqlite3MisuseError(127443)|0); //@line 127443 "c/sqlite3.c"
  $$0 = $10;
 }
 $11 = (_sqlite3ApiExit($0,$$0)|0); //@line 127447 "c/sqlite3.c"
 $12 = ($11|0)!=(0); //@line 127448 "c/sqlite3.c"
 $13 = ($4|0)!=(0|0); //@line 127448 "c/sqlite3.c"
 $or$cond = $13 & $12; //@line 127448 "c/sqlite3.c"
 if (!($or$cond)) {
  $14 = HEAP32[$5>>2]|0; //@line 127449 "c/sqlite3.c"
  _sqlite3_mutex_leave($14); //@line 127449 "c/sqlite3.c"
  return ($11|0); //@line 127450 "c/sqlite3.c"
 }
 FUNCTION_TABLE_vi[$4 & 127]($3); //@line 127448 "c/sqlite3.c"
 $14 = HEAP32[$5>>2]|0; //@line 127449 "c/sqlite3.c"
 _sqlite3_mutex_leave($14); //@line 127449 "c/sqlite3.c"
 return ($11|0); //@line 127450 "c/sqlite3.c"
}
function _sqlite3InvalidFunction($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp; //@line 78509 "c/sqlite3.c"
 $3 = ((($0)) + 4|0); //@line 78513 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 78513 "c/sqlite3.c"
 $5 = ((($4)) + 20|0); //@line 78513 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 78513 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $6; //@line 78516 "c/sqlite3.c"
 $7 = (_sqlite3_mprintf(35990,$vararg_buffer)|0); //@line 78516 "c/sqlite3.c"
 _sqlite3_result_error($0,$7,-1); //@line 78518 "c/sqlite3.c"
 _sqlite3_free($7); //@line 78519 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 78520 "c/sqlite3.c"
}
function _sqlite3TransferBindings($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = HEAP32[$1>>2]|0; //@line 79288 "c/sqlite3.c"
 $3 = ((($2)) + 12|0); //@line 79288 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 79288 "c/sqlite3.c"
 _sqlite3_mutex_enter($4); //@line 79288 "c/sqlite3.c"
 $5 = ((($0)) + 16|0); //@line 79289 "c/sqlite3.c"
 $6 = HEAP16[$5>>1]|0; //@line 79289 "c/sqlite3.c"
 $7 = ($6<<16>>16)>(0); //@line 79289 "c/sqlite3.c"
 if (!($7)) {
  $18 = HEAP32[$1>>2]|0; //@line 79292 "c/sqlite3.c"
  $19 = ((($18)) + 12|0); //@line 79292 "c/sqlite3.c"
  $20 = HEAP32[$19>>2]|0; //@line 79292 "c/sqlite3.c"
  _sqlite3_mutex_leave($20); //@line 79292 "c/sqlite3.c"
  return;
 }
 $8 = ((($1)) + 116|0);
 $9 = ((($0)) + 116|0);
 $$01 = 0;
 while(1) {
  $10 = HEAP32[$8>>2]|0; //@line 79290 "c/sqlite3.c"
  $11 = (($10) + (($$01*40)|0)|0); //@line 79290 "c/sqlite3.c"
  $12 = HEAP32[$9>>2]|0; //@line 79290 "c/sqlite3.c"
  $13 = (($12) + (($$01*40)|0)|0); //@line 79290 "c/sqlite3.c"
  _sqlite3VdbeMemMove($11,$13); //@line 79290 "c/sqlite3.c"
  $14 = (($$01) + 1)|0; //@line 79289 "c/sqlite3.c"
  $15 = HEAP16[$5>>1]|0; //@line 79289 "c/sqlite3.c"
  $16 = $15 << 16 >> 16; //@line 79289 "c/sqlite3.c"
  $17 = ($14|0)<($16|0); //@line 79289 "c/sqlite3.c"
  if ($17) {
   $$01 = $14;
  } else {
   break;
  }
 }
 $18 = HEAP32[$1>>2]|0; //@line 79292 "c/sqlite3.c"
 $19 = ((($18)) + 12|0); //@line 79292 "c/sqlite3.c"
 $20 = HEAP32[$19>>2]|0; //@line 79292 "c/sqlite3.c"
 _sqlite3_mutex_leave($20); //@line 79292 "c/sqlite3.c"
 return;
}
function _sqlite3Step($0) {
 $0 = $0|0;
 var $$0 = 0, $$053 = 0, $$1 = 0, $$2 = 0, $$3 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0;
 var $96 = 0, $97 = 0, $cond = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 78261 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 78261 "c/sqlite3.c"
 $3 = ($2|0)==(770837923); //@line 78261 "c/sqlite3.c"
 if (!($3)) {
  (_sqlite3_reset($0)|0); //@line 78285 "c/sqlite3.c"
 }
 $4 = HEAP32[$0>>2]|0; //@line 78290 "c/sqlite3.c"
 $5 = ((($4)) + 73|0); //@line 78291 "c/sqlite3.c"
 $6 = HEAP8[$5>>0]|0; //@line 78291 "c/sqlite3.c"
 $7 = ($6<<24>>24)==(0); //@line 78291 "c/sqlite3.c"
 if (!($7)) {
  $8 = ((($0)) + 40|0); //@line 78292 "c/sqlite3.c"
  HEAP32[$8>>2] = 7; //@line 78292 "c/sqlite3.c"
  $$053 = 7;
  return ($$053|0); //@line 78382 "c/sqlite3.c"
 }
 $9 = ((($0)) + 36|0); //@line 78296 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 78296 "c/sqlite3.c"
 $11 = ($10|0)<(1); //@line 78296 "c/sqlite3.c"
 do {
  if ($11) {
   $12 = ((($0)) + 145|0); //@line 78296 "c/sqlite3.c"
   $13 = HEAPU8[$12>>0]|(HEAPU8[$12+1>>0]<<8); //@line 78296 "c/sqlite3.c"
   $14 = $13 & 1; //@line 78296 "c/sqlite3.c"
   $15 = ($14<<16>>16)==(0); //@line 78296 "c/sqlite3.c"
   if (!($15)) {
    $16 = ((($0)) + 40|0); //@line 78297 "c/sqlite3.c"
    HEAP32[$16>>2] = 17; //@line 78297 "c/sqlite3.c"
    $$2 = 1;
    break;
   }
   $17 = ($10|0)<(0); //@line 78301 "c/sqlite3.c"
   if ($17) {
    $18 = ((($4)) + 160|0); //@line 78306 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 78306 "c/sqlite3.c"
    $20 = ($19|0)==(0); //@line 78306 "c/sqlite3.c"
    if ($20) {
     $21 = ((($4)) + 256|0); //@line 78307 "c/sqlite3.c"
     HEAP32[$21>>2] = 0; //@line 78307 "c/sqlite3.c"
    }
    $22 = ((($4)) + 196|0); //@line 78315 "c/sqlite3.c"
    $23 = HEAP32[$22>>2]|0; //@line 78315 "c/sqlite3.c"
    $24 = ($23|0)==(0|0); //@line 78315 "c/sqlite3.c"
    if ($24) {
     $25 = ((($4)) + 80|0); //@line 78315 "c/sqlite3.c"
     $26 = HEAP8[$25>>0]|0; //@line 78315 "c/sqlite3.c"
     $27 = $26 & 2; //@line 78315 "c/sqlite3.c"
     $28 = ($27<<24>>24)==(0); //@line 78315 "c/sqlite3.c"
     if (!($28)) {
      label = 13;
     }
    } else {
     label = 13;
    }
    if ((label|0) == 13) {
     $29 = ((($4)) + 157|0); //@line 78316 "c/sqlite3.c"
     $30 = HEAP8[$29>>0]|0; //@line 78316 "c/sqlite3.c"
     $31 = ($30<<24>>24)==(0); //@line 78316 "c/sqlite3.c"
     if ($31) {
      $32 = ((($0)) + 184|0); //@line 78316 "c/sqlite3.c"
      $33 = HEAP32[$32>>2]|0; //@line 78316 "c/sqlite3.c"
      $34 = ($33|0)==(0|0); //@line 78316 "c/sqlite3.c"
      if (!($34)) {
       $35 = HEAP32[$4>>2]|0; //@line 78317 "c/sqlite3.c"
       $36 = ((($0)) + 128|0); //@line 78317 "c/sqlite3.c"
       (_sqlite3OsCurrentTimeInt64($35,$36)|0); //@line 78317 "c/sqlite3.c"
      }
     }
    }
    $37 = HEAP32[$18>>2]|0; //@line 78323 "c/sqlite3.c"
    $38 = (($37) + 1)|0; //@line 78323 "c/sqlite3.c"
    HEAP32[$18>>2] = $38; //@line 78323 "c/sqlite3.c"
    $39 = ((($0)) + 145|0); //@line 78324 "c/sqlite3.c"
    $40 = HEAPU8[$39>>0]|(HEAPU8[$39+1>>0]<<8); //@line 78324 "c/sqlite3.c"
    $41 = $40 & 128; //@line 78324 "c/sqlite3.c"
    $42 = ($41<<16>>16)==(0); //@line 78324 "c/sqlite3.c"
    if ($42) {
     $43 = ((($4)) + 168|0); //@line 78324 "c/sqlite3.c"
     $44 = HEAP32[$43>>2]|0; //@line 78324 "c/sqlite3.c"
     $45 = (($44) + 1)|0; //@line 78324 "c/sqlite3.c"
     HEAP32[$43>>2] = $45; //@line 78324 "c/sqlite3.c"
    }
    $46 = HEAPU8[$39>>0]|(HEAPU8[$39+1>>0]<<8); //@line 78325 "c/sqlite3.c"
    $47 = $46 & 256; //@line 78325 "c/sqlite3.c"
    $48 = ($47<<16>>16)==(0); //@line 78325 "c/sqlite3.c"
    if (!($48)) {
     $49 = ((($4)) + 164|0); //@line 78325 "c/sqlite3.c"
     $50 = HEAP32[$49>>2]|0; //@line 78325 "c/sqlite3.c"
     $51 = (($50) + 1)|0; //@line 78325 "c/sqlite3.c"
     HEAP32[$49>>2] = $51; //@line 78325 "c/sqlite3.c"
    }
    HEAP32[$9>>2] = 0; //@line 78326 "c/sqlite3.c"
    label = 21;
   } else {
    label = 21;
   }
  } else {
   label = 21;
  }
 } while(0);
 if ((label|0) == 21) {
  $52 = ((($0)) + 145|0); //@line 78332 "c/sqlite3.c"
  $53 = HEAPU8[$52>>0]|(HEAPU8[$52+1>>0]<<8); //@line 78332 "c/sqlite3.c"
  $54 = $53 & 12; //@line 78332 "c/sqlite3.c"
  $55 = ($54<<16>>16)==(0); //@line 78332 "c/sqlite3.c"
  if ($55) {
   $57 = ((($4)) + 172|0); //@line 78337 "c/sqlite3.c"
   $58 = HEAP32[$57>>2]|0; //@line 78337 "c/sqlite3.c"
   $59 = (($58) + 1)|0; //@line 78337 "c/sqlite3.c"
   HEAP32[$57>>2] = $59; //@line 78337 "c/sqlite3.c"
   $60 = (_sqlite3VdbeExec($0)|0); //@line 78338 "c/sqlite3.c"
   $61 = HEAP32[$57>>2]|0; //@line 78339 "c/sqlite3.c"
   $62 = (($61) + -1)|0; //@line 78339 "c/sqlite3.c"
   HEAP32[$57>>2] = $62; //@line 78339 "c/sqlite3.c"
   $$0 = $60;
  } else {
   $56 = (_sqlite3VdbeList($0)|0); //@line 78333 "c/sqlite3.c"
   $$0 = $56;
  }
  $cond = ($$0|0)==(100); //@line 78344 "c/sqlite3.c"
  if ($cond) {
   $$1 = 100;
  } else {
   $63 = ((($0)) + 128|0); //@line 78344 "c/sqlite3.c"
   $64 = $63; //@line 78344 "c/sqlite3.c"
   $65 = $64; //@line 78344 "c/sqlite3.c"
   $66 = HEAP32[$65>>2]|0; //@line 78344 "c/sqlite3.c"
   $67 = (($64) + 4)|0; //@line 78344 "c/sqlite3.c"
   $68 = $67; //@line 78344 "c/sqlite3.c"
   $69 = HEAP32[$68>>2]|0; //@line 78344 "c/sqlite3.c"
   $70 = ($69|0)>(0); //@line 78344 "c/sqlite3.c"
   $71 = ($66>>>0)>(0); //@line 78344 "c/sqlite3.c"
   $72 = ($69|0)==(0); //@line 78344 "c/sqlite3.c"
   $73 = $72 & $71; //@line 78344 "c/sqlite3.c"
   $74 = $70 | $73; //@line 78344 "c/sqlite3.c"
   if ($74) {
    _invokeProfileCallback($4,$0); //@line 78344 "c/sqlite3.c"
   }
   $75 = ($$0|0)==(101); //@line 78347 "c/sqlite3.c"
   if ($75) {
    $76 = ((($4)) + 71|0); //@line 78347 "c/sqlite3.c"
    $77 = HEAP8[$76>>0]|0; //@line 78347 "c/sqlite3.c"
    $78 = ($77<<24>>24)==(0); //@line 78347 "c/sqlite3.c"
    if ($78) {
     $$1 = 101;
    } else {
     $79 = (_doWalCallbacks($4)|0); //@line 78349 "c/sqlite3.c"
     $80 = ((($0)) + 40|0); //@line 78349 "c/sqlite3.c"
     HEAP32[$80>>2] = $79; //@line 78349 "c/sqlite3.c"
     $81 = ($79|0)==(0); //@line 78350 "c/sqlite3.c"
     $spec$select = $81 ? $$0 : 1; //@line 78350 "c/sqlite3.c"
     $$1 = $spec$select;
    }
   } else {
    $$1 = $$0;
   }
  }
  $82 = ((($4)) + 56|0); //@line 78355 "c/sqlite3.c"
  HEAP32[$82>>2] = $$1; //@line 78355 "c/sqlite3.c"
  $83 = HEAP32[$0>>2]|0; //@line 78356 "c/sqlite3.c"
  $84 = ((($0)) + 40|0); //@line 78356 "c/sqlite3.c"
  $85 = HEAP32[$84>>2]|0; //@line 78356 "c/sqlite3.c"
  $86 = (_sqlite3ApiExit($83,$85)|0); //@line 78356 "c/sqlite3.c"
  $87 = ($86|0)==(7); //@line 78356 "c/sqlite3.c"
  if ($87) {
   HEAP32[$84>>2] = 7; //@line 78357 "c/sqlite3.c"
   $$2 = $$1;
  } else {
   $$2 = $$1;
  }
 }
 $88 = ((($0)) + 144|0); //@line 78371 "c/sqlite3.c"
 $89 = HEAP8[$88>>0]|0; //@line 78371 "c/sqlite3.c"
 $90 = ($89<<24>>24)<(0); //@line 78371 "c/sqlite3.c"
 $91 = $$2 | 1; //@line 78372 "c/sqlite3.c"
 $92 = ($91|0)!=(101); //@line 78372 "c/sqlite3.c"
 $93 = $92 & $90; //@line 78372 "c/sqlite3.c"
 if ($93) {
  $94 = (_sqlite3VdbeTransferError($0)|0); //@line 78379 "c/sqlite3.c"
  $$3 = $94;
 } else {
  $$3 = $$2;
 }
 $95 = ((($4)) + 60|0); //@line 78381 "c/sqlite3.c"
 $96 = HEAP32[$95>>2]|0; //@line 78381 "c/sqlite3.c"
 $97 = $96 & $$3; //@line 78381 "c/sqlite3.c"
 $$053 = $97;
 return ($$053|0); //@line 78382 "c/sqlite3.c"
}
function _sqlite3Reprepare($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = (_sqlite3_sql($0)|0); //@line 118496 "c/sqlite3.c"
 $3 = (_sqlite3VdbeDb($0)|0); //@line 118498 "c/sqlite3.c"
 $4 = (_sqlite3VdbePrepareFlags($0)|0); //@line 118500 "c/sqlite3.c"
 $5 = $4&255; //@line 118501 "c/sqlite3.c"
 $6 = (_sqlite3LockAndPrepare($3,$2,-1,$5,$0,$1,0)|0); //@line 118501 "c/sqlite3.c"
 switch ($6|0) {
 case 0:  {
  $7 = HEAP32[$1>>2]|0; //@line 118511 "c/sqlite3.c"
  _sqlite3VdbeSwap($7,$0); //@line 118511 "c/sqlite3.c"
  _sqlite3TransferBindings($7,$0); //@line 118512 "c/sqlite3.c"
  _sqlite3VdbeResetStepResult($7); //@line 118513 "c/sqlite3.c"
  (_sqlite3VdbeFinalize($7)|0); //@line 118514 "c/sqlite3.c"
  $$0 = 0;
  STACKTOP = sp;return ($$0|0); //@line 118516 "c/sqlite3.c"
  break;
 }
 case 7:  {
  _sqlite3OomFault($3); //@line 118504 "c/sqlite3.c"
  $$0 = 7;
  STACKTOP = sp;return ($$0|0); //@line 118516 "c/sqlite3.c"
  break;
 }
 default: {
  $$0 = $6;
  STACKTOP = sp;return ($$0|0); //@line 118516 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3VdbePrepareFlags($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 144|0); //@line 77533 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 77533 "c/sqlite3.c"
 return ($2|0); //@line 77533 "c/sqlite3.c"
}
function _sqlite3VdbeSwap($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 224|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(224|0);
 $2 = sp;
 _memcpy(($2|0),($0|0),216)|0; //@line 73036 "c/sqlite3.c"
 _memcpy(($0|0),($1|0),216)|0; //@line 73037 "c/sqlite3.c"
 _memcpy(($1|0),($2|0),216)|0; //@line 73038 "c/sqlite3.c"
 $3 = ((($0)) + 8|0); //@line 73039 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 73039 "c/sqlite3.c"
 $5 = ((($1)) + 8|0); //@line 73040 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 73040 "c/sqlite3.c"
 HEAP32[$3>>2] = $6; //@line 73040 "c/sqlite3.c"
 HEAP32[$5>>2] = $4; //@line 73041 "c/sqlite3.c"
 $7 = ((($0)) + 4|0); //@line 73042 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 73042 "c/sqlite3.c"
 $9 = ((($1)) + 4|0); //@line 73043 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 73043 "c/sqlite3.c"
 HEAP32[$7>>2] = $10; //@line 73043 "c/sqlite3.c"
 HEAP32[$9>>2] = $8; //@line 73044 "c/sqlite3.c"
 $11 = ((($0)) + 184|0); //@line 73045 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 73045 "c/sqlite3.c"
 $13 = ((($1)) + 184|0); //@line 73046 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 73046 "c/sqlite3.c"
 HEAP32[$11>>2] = $14; //@line 73046 "c/sqlite3.c"
 HEAP32[$13>>2] = $12; //@line 73047 "c/sqlite3.c"
 $15 = ((($0)) + 204|0); //@line 73048 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 73048 "c/sqlite3.c"
 $17 = ((($1)) + 204|0); //@line 73048 "c/sqlite3.c"
 HEAP32[$17>>2] = $16; //@line 73048 "c/sqlite3.c"
 $18 = ((($0)) + 144|0); //@line 73049 "c/sqlite3.c"
 $19 = HEAP8[$18>>0]|0; //@line 73049 "c/sqlite3.c"
 $20 = ((($1)) + 144|0); //@line 73049 "c/sqlite3.c"
 HEAP8[$20>>0] = $19; //@line 73049 "c/sqlite3.c"
 $21 = ((($1)) + 156|0); //@line 73050 "c/sqlite3.c"
 $22 = ((($0)) + 156|0); //@line 73050 "c/sqlite3.c"
 ;HEAP32[$21>>2]=HEAP32[$22>>2]|0;HEAP32[$21+4>>2]=HEAP32[$22+4>>2]|0;HEAP32[$21+8>>2]=HEAP32[$22+8>>2]|0;HEAP32[$21+12>>2]=HEAP32[$22+12>>2]|0;HEAP32[$21+16>>2]=HEAP32[$22+16>>2]|0;HEAP32[$21+20>>2]=HEAP32[$22+20>>2]|0;HEAP32[$21+24>>2]=HEAP32[$22+24>>2]|0; //@line 73050 "c/sqlite3.c"
 $23 = ((($1)) + 176|0); //@line 73051 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 73051 "c/sqlite3.c"
 $25 = (($24) + 1)|0; //@line 73051 "c/sqlite3.c"
 HEAP32[$23>>2] = $25; //@line 73051 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 73052 "c/sqlite3.c"
}
function _sqlite3VdbeResetStepResult($0) {
 $0 = $0|0;
 var $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 75785 "c/sqlite3.c"
 HEAP32[$1>>2] = 0; //@line 75785 "c/sqlite3.c"
 return; //@line 75786 "c/sqlite3.c"
}
function _sqlite3OsCurrentTimeInt64($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 $3 = HEAP32[$0>>2]|0; //@line 21084 "c/sqlite3.c"
 $4 = ($3|0)>(1); //@line 21084 "c/sqlite3.c"
 if ($4) {
  $5 = ((($0)) + 72|0); //@line 21084 "c/sqlite3.c"
  $6 = HEAP32[$5>>2]|0; //@line 21084 "c/sqlite3.c"
  $7 = ($6|0)==(0|0); //@line 21084 "c/sqlite3.c"
  if (!($7)) {
   $8 = (FUNCTION_TABLE_iii[$6 & 255]($0,$1)|0); //@line 21085 "c/sqlite3.c"
   $$0 = $8;
   STACKTOP = sp;return ($$0|0); //@line 21091 "c/sqlite3.c"
  }
 }
 $9 = ((($0)) + 64|0); //@line 21088 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 21088 "c/sqlite3.c"
 $11 = (FUNCTION_TABLE_iii[$10 & 255]($0,$2)|0); //@line 21088 "c/sqlite3.c"
 $12 = +HEAPF64[$2>>3]; //@line 21089 "c/sqlite3.c"
 $13 = $12 * 8.64E+7; //@line 21089 "c/sqlite3.c"
 $14 = (~~$13)>>>0; //@line 21089 "c/sqlite3.c"
 $15 = +Math_abs($13) >= 1.0 ? $13 > 0.0 ? (~~+Math_min(+Math_floor($13 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($13 - +(~~$13 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 21089 "c/sqlite3.c"
 $16 = $1; //@line 21089 "c/sqlite3.c"
 $17 = $16; //@line 21089 "c/sqlite3.c"
 HEAP32[$17>>2] = $14; //@line 21089 "c/sqlite3.c"
 $18 = (($16) + 4)|0; //@line 21089 "c/sqlite3.c"
 $19 = $18; //@line 21089 "c/sqlite3.c"
 HEAP32[$19>>2] = $15; //@line 21089 "c/sqlite3.c"
 $$0 = $11;
 STACKTOP = sp;return ($$0|0); //@line 21091 "c/sqlite3.c"
}
function _sqlite3VdbeList($0) {
 $0 = $0|0;
 var $$0151$lcssa = 0, $$0151194 = 0, $$0152202 = 0, $$0154192 = 0, $$0166 = 0, $$0173201 = 0, $$0183 = 0, $$1 = 0, $$1153 = 0, $$1158 = 0, $$1161 = 0, $$1174$lcssa = 0, $$1174191 = 0, $$1178 = 0, $$2 = 0, $$2162 = 0, $$2175 = 0, $$2179 = 0, $$5 = 0, $$5165 = 0;
 var $$5182 = 0, $$lcssa = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0;
 var $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0;
 var $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0;
 var $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0;
 var $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0;
 var $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0;
 var $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0;
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0;
 var $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $exitcond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 74594 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 74594 "c/sqlite3.c"
 $1 = HEAP32[$0>>2]|0; //@line 74600 "c/sqlite3.c"
 $2 = ((($0)) + 92|0); //@line 74603 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 74603 "c/sqlite3.c"
 $4 = ((($3)) + 40|0); //@line 74603 "c/sqlite3.c"
 $5 = ((($0)) + 145|0); //@line 74604 "c/sqlite3.c"
 $6 = HEAPU8[$5>>0]|(HEAPU8[$5+1>>0]<<8); //@line 74604 "c/sqlite3.c"
 $7 = $6 & 12; //@line 74604 "c/sqlite3.c"
 $8 = ($7<<16>>16)==(4); //@line 74604 "c/sqlite3.c"
 if ($8) {
  $187 = 1;
 } else {
  $9 = ((($1)) + 28|0); //@line 74604 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 74604 "c/sqlite3.c"
  $11 = $10 & 16777216; //@line 74604 "c/sqlite3.c"
  $12 = ($11|0)!=(0); //@line 74604 "c/sqlite3.c"
  $187 = $12;
 }
 _releaseMemArray($4,8); //@line 74615 "c/sqlite3.c"
 $13 = ((($0)) + 104|0); //@line 74616 "c/sqlite3.c"
 HEAP32[$13>>2] = 0; //@line 74616 "c/sqlite3.c"
 $14 = ((($0)) + 40|0); //@line 74618 "c/sqlite3.c"
 $15 = HEAP32[$14>>2]|0; //@line 74618 "c/sqlite3.c"
 $16 = ($15|0)==(7); //@line 74618 "c/sqlite3.c"
 if ($16) {
  _sqlite3OomFault($1); //@line 74621 "c/sqlite3.c"
  $$1 = 1;
  STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
 }
 $17 = ((($0)) + 136|0); //@line 74632 "c/sqlite3.c"
 $18 = HEAP32[$17>>2]|0; //@line 74632 "c/sqlite3.c"
 if ($187) {
  $19 = HEAP32[$2>>2]|0; //@line 74639 "c/sqlite3.c"
  $20 = ((($19)) + 360|0); //@line 74639 "c/sqlite3.c"
  $21 = ((($19)) + 368|0); //@line 74640 "c/sqlite3.c"
  $22 = HEAP16[$21>>1]|0; //@line 74640 "c/sqlite3.c"
  $23 = $22 & 16; //@line 74640 "c/sqlite3.c"
  $24 = ($23<<16>>16)==(0); //@line 74640 "c/sqlite3.c"
  if ($24) {
   $$0183 = $20;$$1153 = $18;$$1161 = 0;$$1178 = 0;
  } else {
   $25 = ((($19)) + 372|0); //@line 74643 "c/sqlite3.c"
   $26 = HEAP32[$25>>2]|0; //@line 74643 "c/sqlite3.c"
   $27 = $26 >>> 2; //@line 74643 "c/sqlite3.c"
   $28 = ((($19)) + 376|0); //@line 74644 "c/sqlite3.c"
   $29 = HEAP32[$28>>2]|0; //@line 74644 "c/sqlite3.c"
   $30 = ($27|0)==(0); //@line 74646 "c/sqlite3.c"
   if ($30) {
    $$0183 = $20;$$1153 = $18;$$1161 = 0;$$1178 = $29;
   } else {
    $$0152202 = $18;$$0173201 = 0;
    while(1) {
     $31 = (($29) + ($$0173201<<2)|0); //@line 74647 "c/sqlite3.c"
     $32 = HEAP32[$31>>2]|0; //@line 74647 "c/sqlite3.c"
     $33 = ((($32)) + 4|0); //@line 74647 "c/sqlite3.c"
     $34 = HEAP32[$33>>2]|0; //@line 74647 "c/sqlite3.c"
     $35 = (($34) + ($$0152202))|0; //@line 74647 "c/sqlite3.c"
     $36 = (($$0173201) + 1)|0; //@line 74646 "c/sqlite3.c"
     $exitcond = ($36|0)==($27|0); //@line 74646 "c/sqlite3.c"
     if ($exitcond) {
      $$0183 = $20;$$1153 = $35;$$1161 = $27;$$1178 = $29;
      break;
     } else {
      $$0152202 = $35;$$0173201 = $36;
     }
    }
   }
  }
 } else {
  $$0183 = 0;$$1153 = $18;$$1161 = 0;$$1178 = 0;
 }
 $37 = ((($0)) + 36|0);
 $38 = ((($0)) + 88|0);
 $39 = ((($$0183)) + 16|0);
 $40 = ((($$0183)) + 8|0);
 $41 = ((($$0183)) + 12|0);
 $$2 = $$1153;$$2162 = $$1161;$$2179 = $$1178;
 while(1) {
  $42 = HEAP32[$37>>2]|0; //@line 74652 "c/sqlite3.c"
  $43 = (($42) + 1)|0; //@line 74652 "c/sqlite3.c"
  HEAP32[$37>>2] = $43; //@line 74652 "c/sqlite3.c"
  $44 = ($42|0)<($$2|0); //@line 74653 "c/sqlite3.c"
  if (!($44)) {
   label = 12;
   break;
  }
  $45 = HEAP32[$17>>2]|0; //@line 74658 "c/sqlite3.c"
  $46 = ($42|0)<($45|0); //@line 74658 "c/sqlite3.c"
  if ($46) {
   $47 = HEAP32[$38>>2]|0; //@line 74661 "c/sqlite3.c"
   $48 = (($47) + (($42*20)|0)|0); //@line 74661 "c/sqlite3.c"
   $$1158 = $48;$$2175 = $42;
  } else {
   $49 = (($42) - ($45))|0; //@line 74666 "c/sqlite3.c"
   $50 = HEAP32[$$2179>>2]|0; //@line 74667 "c/sqlite3.c"
   $51 = ((($50)) + 4|0); //@line 74667 "c/sqlite3.c"
   $52 = HEAP32[$51>>2]|0; //@line 74667 "c/sqlite3.c"
   $53 = ($49|0)<($52|0); //@line 74667 "c/sqlite3.c"
   if ($53) {
    $$1174$lcssa = $49;$$lcssa = $50;
   } else {
    $$0154192 = 0;$$1174191 = $49;$55 = $52;
    while(1) {
     $54 = (($$1174191) - ($55))|0; //@line 74668 "c/sqlite3.c"
     $56 = (($$0154192) + 1)|0; //@line 74667 "c/sqlite3.c"
     $57 = (($$2179) + ($56<<2)|0); //@line 74667 "c/sqlite3.c"
     $58 = HEAP32[$57>>2]|0; //@line 74667 "c/sqlite3.c"
     $59 = ((($58)) + 4|0); //@line 74667 "c/sqlite3.c"
     $60 = HEAP32[$59>>2]|0; //@line 74667 "c/sqlite3.c"
     $61 = ($54|0)<($60|0); //@line 74667 "c/sqlite3.c"
     if ($61) {
      $$1174$lcssa = $54;$$lcssa = $58;
      break;
     } else {
      $$0154192 = $56;$$1174191 = $54;$55 = $60;
     }
    }
   }
   $62 = HEAP32[$$lcssa>>2]|0; //@line 74670 "c/sqlite3.c"
   $63 = (($62) + (($$1174$lcssa*20)|0)|0); //@line 74670 "c/sqlite3.c"
   $$1158 = $63;$$2175 = $$1174$lcssa;
  }
  if ($187) {
   $64 = ((($$1158)) + 1|0); //@line 74678 "c/sqlite3.c"
   $65 = HEAP8[$64>>0]|0; //@line 74678 "c/sqlite3.c"
   $66 = ($65<<24>>24)==(-4); //@line 74678 "c/sqlite3.c"
   if ($66) {
    $67 = (($$2162) + 1)|0; //@line 74679 "c/sqlite3.c"
    $68 = $67 << 2; //@line 74679 "c/sqlite3.c"
    $69 = ($$2162|0)>(0); //@line 74681 "c/sqlite3.c"
    L30: do {
     if ($69) {
      $70 = ((($$1158)) + 16|0);
      $71 = HEAP32[$70>>2]|0;
      $$0151194 = 0;
      while(1) {
       $72 = (($$2179) + ($$0151194<<2)|0); //@line 74682 "c/sqlite3.c"
       $73 = HEAP32[$72>>2]|0; //@line 74682 "c/sqlite3.c"
       $74 = ($73|0)==($71|0); //@line 74682 "c/sqlite3.c"
       if ($74) {
        $$0151$lcssa = $$0151194;
        break L30;
       }
       $75 = (($$0151194) + 1)|0; //@line 74681 "c/sqlite3.c"
       $76 = ($75|0)<($$2162|0); //@line 74681 "c/sqlite3.c"
       if ($76) {
        $$0151194 = $75;
       } else {
        $$0151$lcssa = $75;
        break;
       }
      }
     } else {
      $$0151$lcssa = 0;
     }
    } while(0);
    $77 = ($$0151$lcssa|0)==($$2162|0); //@line 74684 "c/sqlite3.c"
    if ($77) {
     $78 = ($$2162|0)!=(0); //@line 74685 "c/sqlite3.c"
     $79 = $78&1; //@line 74685 "c/sqlite3.c"
     $80 = (_sqlite3VdbeMemGrow($$0183,$68,$79)|0); //@line 74685 "c/sqlite3.c"
     HEAP32[$14>>2] = $80; //@line 74685 "c/sqlite3.c"
     $81 = ($80|0)==(0); //@line 74686 "c/sqlite3.c"
     if (!($81)) {
      $$1 = 1;
      label = 42;
      break;
     }
     $82 = HEAP32[$39>>2]|0; //@line 74690 "c/sqlite3.c"
     $83 = ((($$1158)) + 16|0); //@line 74691 "c/sqlite3.c"
     $84 = HEAP32[$83>>2]|0; //@line 74691 "c/sqlite3.c"
     $85 = (($82) + ($$2162<<2)|0); //@line 74691 "c/sqlite3.c"
     HEAP32[$85>>2] = $84; //@line 74691 "c/sqlite3.c"
     $86 = HEAP16[$40>>1]|0; //@line 74692 "c/sqlite3.c"
     $87 = $86 | 16; //@line 74692 "c/sqlite3.c"
     HEAP16[$40>>1] = $87; //@line 74692 "c/sqlite3.c"
     HEAP32[$41>>2] = $68; //@line 74693 "c/sqlite3.c"
     $88 = HEAP32[$83>>2]|0; //@line 74694 "c/sqlite3.c"
     $89 = ((($88)) + 4|0); //@line 74694 "c/sqlite3.c"
     $90 = HEAP32[$89>>2]|0; //@line 74694 "c/sqlite3.c"
     $91 = (($90) + ($$2))|0; //@line 74694 "c/sqlite3.c"
     $$5 = $91;$$5165 = $67;$$5182 = $82;
    } else {
     $$5 = $$2;$$5165 = $$2162;$$5182 = $$2179;
    }
   } else {
    $$5 = $$2;$$5165 = $$2162;$$5182 = $$2179;
   }
  } else {
   $$5 = $$2;$$5165 = $$2162;$$5182 = $$2179;
  }
  $92 = HEAPU8[$5>>0]|(HEAPU8[$5+1>>0]<<8); //@line 74697 "c/sqlite3.c"
  $93 = $92 & 12; //@line 74697 "c/sqlite3.c"
  $94 = ($93<<16>>16)==(8); //@line 74697 "c/sqlite3.c"
  if (!($94)) {
   label = 30;
   break;
  }
  $95 = HEAP8[$$1158>>0]|0; //@line 74697 "c/sqlite3.c"
  $96 = ($95<<24>>24)==(-87); //@line 74697 "c/sqlite3.c"
  if ($96) {
   label = 30;
   break;
  } else {
   $$2 = $$5;$$2162 = $$5165;$$2179 = $$5182;
  }
 }
 if ((label|0) == 12) {
  HEAP32[$14>>2] = 0; //@line 74654 "c/sqlite3.c"
  $$1 = 101;
  STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
 }
 else if ((label|0) == 30) {
  $97 = ((($1)) + 256|0); //@line 74700 "c/sqlite3.c"
  $98 = HEAP32[$97>>2]|0; //@line 74700 "c/sqlite3.c"
  $99 = ($98|0)==(0); //@line 74700 "c/sqlite3.c"
  if (!($99)) {
   HEAP32[$14>>2] = 9; //@line 74701 "c/sqlite3.c"
   $100 = (_sqlite3ErrStr(9)|0); //@line 74703 "c/sqlite3.c"
   _sqlite3VdbeError($0,$100,$vararg_buffer); //@line 74703 "c/sqlite3.c"
   $$1 = 1;
   STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
  }
  $101 = HEAPU8[$5>>0]|(HEAPU8[$5+1>>0]<<8); //@line 74706 "c/sqlite3.c"
  $102 = $101 & 12; //@line 74706 "c/sqlite3.c"
  $103 = ($102<<16>>16)==(4); //@line 74706 "c/sqlite3.c"
  if ($103) {
   $104 = ((($3)) + 48|0); //@line 74707 "c/sqlite3.c"
   HEAP16[$104>>1] = 4; //@line 74707 "c/sqlite3.c"
   $105 = ($$2175|0)<(0); //@line 74708 "c/sqlite3.c"
   $106 = $105 << 31 >> 31; //@line 74708 "c/sqlite3.c"
   $107 = $4; //@line 74708 "c/sqlite3.c"
   $108 = $107; //@line 74708 "c/sqlite3.c"
   HEAP32[$108>>2] = $$2175; //@line 74708 "c/sqlite3.c"
   $109 = (($107) + 4)|0; //@line 74708 "c/sqlite3.c"
   $110 = $109; //@line 74708 "c/sqlite3.c"
   HEAP32[$110>>2] = $106; //@line 74708 "c/sqlite3.c"
   $111 = ((($3)) + 88|0); //@line 74711 "c/sqlite3.c"
   HEAP16[$111>>1] = 2562; //@line 74711 "c/sqlite3.c"
   $112 = HEAP8[$$1158>>0]|0; //@line 74712 "c/sqlite3.c"
   $113 = $112&255; //@line 74712 "c/sqlite3.c"
   $114 = (_sqlite3OpcodeName($113)|0); //@line 74712 "c/sqlite3.c"
   $115 = ((($3)) + 96|0); //@line 74712 "c/sqlite3.c"
   HEAP32[$115>>2] = $114; //@line 74712 "c/sqlite3.c"
   $116 = (_sqlite3Strlen30($114)|0); //@line 74714 "c/sqlite3.c"
   $117 = ((($3)) + 92|0); //@line 74714 "c/sqlite3.c"
   HEAP32[$117>>2] = $116; //@line 74714 "c/sqlite3.c"
   $118 = ((($3)) + 90|0); //@line 74715 "c/sqlite3.c"
   HEAP8[$118>>0] = 1; //@line 74715 "c/sqlite3.c"
   $119 = ((($3)) + 120|0); //@line 74716 "c/sqlite3.c"
   $$0166 = $119;
  } else {
   $$0166 = $4;
  }
  $120 = ((($$0166)) + 8|0); //@line 74719 "c/sqlite3.c"
  HEAP16[$120>>1] = 4; //@line 74719 "c/sqlite3.c"
  $121 = ((($$1158)) + 4|0); //@line 74720 "c/sqlite3.c"
  $122 = HEAP32[$121>>2]|0; //@line 74720 "c/sqlite3.c"
  $123 = ($122|0)<(0); //@line 74720 "c/sqlite3.c"
  $124 = $123 << 31 >> 31; //@line 74720 "c/sqlite3.c"
  $125 = $$0166; //@line 74720 "c/sqlite3.c"
  $126 = $125; //@line 74720 "c/sqlite3.c"
  HEAP32[$126>>2] = $122; //@line 74720 "c/sqlite3.c"
  $127 = (($125) + 4)|0; //@line 74720 "c/sqlite3.c"
  $128 = $127; //@line 74720 "c/sqlite3.c"
  HEAP32[$128>>2] = $124; //@line 74720 "c/sqlite3.c"
  $129 = ((($$0166)) + 40|0); //@line 74721 "c/sqlite3.c"
  $130 = ((($$0166)) + 48|0); //@line 74723 "c/sqlite3.c"
  HEAP16[$130>>1] = 4; //@line 74723 "c/sqlite3.c"
  $131 = ((($$1158)) + 8|0); //@line 74724 "c/sqlite3.c"
  $132 = HEAP32[$131>>2]|0; //@line 74724 "c/sqlite3.c"
  $133 = ($132|0)<(0); //@line 74724 "c/sqlite3.c"
  $134 = $133 << 31 >> 31; //@line 74724 "c/sqlite3.c"
  $135 = $129; //@line 74724 "c/sqlite3.c"
  $136 = $135; //@line 74724 "c/sqlite3.c"
  HEAP32[$136>>2] = $132; //@line 74724 "c/sqlite3.c"
  $137 = (($135) + 4)|0; //@line 74724 "c/sqlite3.c"
  $138 = $137; //@line 74724 "c/sqlite3.c"
  HEAP32[$138>>2] = $134; //@line 74724 "c/sqlite3.c"
  $139 = ((($$0166)) + 80|0); //@line 74725 "c/sqlite3.c"
  $140 = ((($$0166)) + 88|0); //@line 74727 "c/sqlite3.c"
  HEAP16[$140>>1] = 4; //@line 74727 "c/sqlite3.c"
  $141 = ((($$1158)) + 12|0); //@line 74728 "c/sqlite3.c"
  $142 = HEAP32[$141>>2]|0; //@line 74728 "c/sqlite3.c"
  $143 = ($142|0)<(0); //@line 74728 "c/sqlite3.c"
  $144 = $143 << 31 >> 31; //@line 74728 "c/sqlite3.c"
  $145 = $139; //@line 74728 "c/sqlite3.c"
  $146 = $145; //@line 74728 "c/sqlite3.c"
  HEAP32[$146>>2] = $142; //@line 74728 "c/sqlite3.c"
  $147 = (($145) + 4)|0; //@line 74728 "c/sqlite3.c"
  $148 = $147; //@line 74728 "c/sqlite3.c"
  HEAP32[$148>>2] = $144; //@line 74728 "c/sqlite3.c"
  $149 = ((($$0166)) + 120|0); //@line 74729 "c/sqlite3.c"
  $150 = (_sqlite3VdbeMemClearAndResize($149,100)|0); //@line 74731 "c/sqlite3.c"
  $151 = ($150|0)==(0); //@line 74731 "c/sqlite3.c"
  if (!($151)) {
   $$1 = 1;
   STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
  }
  $152 = ((($$0166)) + 128|0); //@line 74735 "c/sqlite3.c"
  HEAP16[$152>>1] = 514; //@line 74735 "c/sqlite3.c"
  $153 = ((($$0166)) + 136|0); //@line 74736 "c/sqlite3.c"
  $154 = HEAP32[$153>>2]|0; //@line 74736 "c/sqlite3.c"
  $155 = ((($$0166)) + 144|0); //@line 74736 "c/sqlite3.c"
  $156 = HEAP32[$155>>2]|0; //@line 74736 "c/sqlite3.c"
  $157 = (_displayP4($$1158,$154,$156)|0); //@line 74736 "c/sqlite3.c"
  $158 = HEAP32[$153>>2]|0; //@line 74737 "c/sqlite3.c"
  $159 = ($157|0)==($158|0); //@line 74737 "c/sqlite3.c"
  if ($159) {
   $161 = (_sqlite3Strlen30($158)|0); //@line 74742 "c/sqlite3.c"
   $162 = ((($$0166)) + 132|0); //@line 74742 "c/sqlite3.c"
   HEAP32[$162>>2] = $161; //@line 74742 "c/sqlite3.c"
   $163 = ((($$0166)) + 130|0); //@line 74743 "c/sqlite3.c"
   HEAP8[$163>>0] = 1; //@line 74743 "c/sqlite3.c"
  } else {
   $160 = ((($$0166)) + 132|0); //@line 74738 "c/sqlite3.c"
   HEAP32[$160>>2] = 0; //@line 74738 "c/sqlite3.c"
   (_sqlite3VdbeMemSetStr($149,$157,-1,1,0)|0); //@line 74739 "c/sqlite3.c"
  }
  $164 = HEAPU8[$5>>0]|(HEAPU8[$5+1>>0]<<8); //@line 74747 "c/sqlite3.c"
  $165 = $164 & 12; //@line 74747 "c/sqlite3.c"
  $166 = ($165<<16>>16)==(4); //@line 74747 "c/sqlite3.c"
  do {
   if ($166) {
    $167 = ((($$0166)) + 160|0); //@line 74745 "c/sqlite3.c"
    $168 = (_sqlite3VdbeMemClearAndResize($167,4)|0); //@line 74748 "c/sqlite3.c"
    $169 = ($168|0)==(0); //@line 74748 "c/sqlite3.c"
    if ($169) {
     $170 = ((($$0166)) + 168|0); //@line 74752 "c/sqlite3.c"
     HEAP16[$170>>1] = 514; //@line 74752 "c/sqlite3.c"
     $171 = ((($$0166)) + 172|0); //@line 74753 "c/sqlite3.c"
     HEAP32[$171>>2] = 2; //@line 74753 "c/sqlite3.c"
     $172 = ((($$0166)) + 176|0); //@line 74754 "c/sqlite3.c"
     $173 = HEAP32[$172>>2]|0; //@line 74754 "c/sqlite3.c"
     $174 = ((($$1158)) + 2|0); //@line 74754 "c/sqlite3.c"
     $175 = HEAP16[$174>>1]|0; //@line 74754 "c/sqlite3.c"
     $176 = $175&65535; //@line 74754 "c/sqlite3.c"
     HEAP32[$vararg_buffer1>>2] = $176; //@line 74754 "c/sqlite3.c"
     (_sqlite3_snprintf(3,$173,36069,$vararg_buffer1)|0); //@line 74754 "c/sqlite3.c"
     $177 = ((($$0166)) + 170|0); //@line 74755 "c/sqlite3.c"
     HEAP8[$177>>0] = 1; //@line 74755 "c/sqlite3.c"
     $178 = ((($$0166)) + 208|0); //@line 74767 "c/sqlite3.c"
     HEAP16[$178>>1] = 1; //@line 74767 "c/sqlite3.c"
     break;
    } else {
     $$1 = 1;
     STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
    }
   }
  } while(0);
  $179 = HEAPU8[$5>>0]|(HEAPU8[$5+1>>0]<<8); //@line 74771 "c/sqlite3.c"
  $180 = $179 & 12; //@line 74771 "c/sqlite3.c"
  $181 = $180&65535; //@line 74771 "c/sqlite3.c"
  $182 = (12 - ($181))|0; //@line 74771 "c/sqlite3.c"
  $183 = $182&65535; //@line 74771 "c/sqlite3.c"
  $184 = ((($0)) + 140|0); //@line 74771 "c/sqlite3.c"
  HEAP16[$184>>1] = $183; //@line 74771 "c/sqlite3.c"
  $185 = HEAP32[$2>>2]|0; //@line 74772 "c/sqlite3.c"
  $186 = ((($185)) + 40|0); //@line 74772 "c/sqlite3.c"
  HEAP32[$13>>2] = $186; //@line 74772 "c/sqlite3.c"
  HEAP32[$14>>2] = 0; //@line 74773 "c/sqlite3.c"
  $$1 = 100;
  STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
 }
 else if ((label|0) == 42) {
  STACKTOP = sp;return ($$1|0); //@line 74778 "c/sqlite3.c"
 }
 return (0)|0;
}
function _invokeProfileCallback($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp + 8|0;
 $3 = sp;
 $4 = HEAP32[$0>>2]|0; //@line 77773 "c/sqlite3.c"
 (_sqlite3OsCurrentTimeInt64($4,$2)|0); //@line 77773 "c/sqlite3.c"
 $5 = $2; //@line 77774 "c/sqlite3.c"
 $6 = $5; //@line 77774 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 77774 "c/sqlite3.c"
 $8 = (($5) + 4)|0; //@line 77774 "c/sqlite3.c"
 $9 = $8; //@line 77774 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 77774 "c/sqlite3.c"
 $11 = ((($1)) + 128|0); //@line 77774 "c/sqlite3.c"
 $12 = $11; //@line 77774 "c/sqlite3.c"
 $13 = $12; //@line 77774 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 77774 "c/sqlite3.c"
 $15 = (($12) + 4)|0; //@line 77774 "c/sqlite3.c"
 $16 = $15; //@line 77774 "c/sqlite3.c"
 $17 = HEAP32[$16>>2]|0; //@line 77774 "c/sqlite3.c"
 $18 = (_i64Subtract(($7|0),($10|0),($14|0),($17|0))|0); //@line 77774 "c/sqlite3.c"
 $19 = tempRet0; //@line 77774 "c/sqlite3.c"
 $20 = (___muldi3(($18|0),($19|0),1000000,0)|0); //@line 77774 "c/sqlite3.c"
 $21 = tempRet0; //@line 77774 "c/sqlite3.c"
 $22 = $3; //@line 77774 "c/sqlite3.c"
 $23 = $22; //@line 77774 "c/sqlite3.c"
 HEAP32[$23>>2] = $20; //@line 77774 "c/sqlite3.c"
 $24 = (($22) + 4)|0; //@line 77774 "c/sqlite3.c"
 $25 = $24; //@line 77774 "c/sqlite3.c"
 HEAP32[$25>>2] = $21; //@line 77774 "c/sqlite3.c"
 $26 = ((($0)) + 196|0); //@line 77775 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 77775 "c/sqlite3.c"
 $28 = ($27|0)==(0|0); //@line 77775 "c/sqlite3.c"
 if (!($28)) {
  $29 = ((($0)) + 200|0); //@line 77776 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 77776 "c/sqlite3.c"
  $31 = ((($1)) + 184|0); //@line 77776 "c/sqlite3.c"
  $32 = HEAP32[$31>>2]|0; //@line 77776 "c/sqlite3.c"
  FUNCTION_TABLE_viiii[$27 & 127]($30,$32,$20,$21); //@line 77776 "c/sqlite3.c"
 }
 $33 = ((($0)) + 80|0); //@line 77778 "c/sqlite3.c"
 $34 = HEAP8[$33>>0]|0; //@line 77778 "c/sqlite3.c"
 $35 = $34 & 2; //@line 77778 "c/sqlite3.c"
 $36 = ($35<<24>>24)==(0); //@line 77778 "c/sqlite3.c"
 if ($36) {
  $41 = $11; //@line 77781 "c/sqlite3.c"
  $42 = $41; //@line 77781 "c/sqlite3.c"
  HEAP32[$42>>2] = 0; //@line 77781 "c/sqlite3.c"
  $43 = (($41) + 4)|0; //@line 77781 "c/sqlite3.c"
  $44 = $43; //@line 77781 "c/sqlite3.c"
  HEAP32[$44>>2] = 0; //@line 77781 "c/sqlite3.c"
  STACKTOP = sp;return; //@line 77782 "c/sqlite3.c"
 }
 $37 = ((($0)) + 188|0); //@line 77779 "c/sqlite3.c"
 $38 = HEAP32[$37>>2]|0; //@line 77779 "c/sqlite3.c"
 $39 = ((($0)) + 192|0); //@line 77779 "c/sqlite3.c"
 $40 = HEAP32[$39>>2]|0; //@line 77779 "c/sqlite3.c"
 (FUNCTION_TABLE_iiiii[$38 & 127](2,$40,$1,$3)|0); //@line 77779 "c/sqlite3.c"
 $41 = $11; //@line 77781 "c/sqlite3.c"
 $42 = $41; //@line 77781 "c/sqlite3.c"
 HEAP32[$42>>2] = 0; //@line 77781 "c/sqlite3.c"
 $43 = (($41) + 4)|0; //@line 77781 "c/sqlite3.c"
 $44 = $43; //@line 77781 "c/sqlite3.c"
 HEAP32[$44>>2] = 0; //@line 77781 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 77782 "c/sqlite3.c"
}
function _doWalCallbacks($0) {
 $0 = $0|0;
 var $$0$lcssa = 0, $$02627 = 0, $$028 = 0, $$2 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0); //@line 78230 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 78230 "c/sqlite3.c"
 $3 = ($2|0)>(0); //@line 78230 "c/sqlite3.c"
 if (!($3)) {
  $$0$lcssa = 0;
  return ($$0$lcssa|0); //@line 78243 "c/sqlite3.c"
 }
 $4 = ((($0)) + 16|0);
 $5 = ((($0)) + 228|0);
 $6 = ((($0)) + 232|0);
 $$02627 = 0;$$028 = 0;
 while(1) {
  $7 = HEAP32[$4>>2]|0; //@line 78231 "c/sqlite3.c"
  $8 = (((($7) + ($$02627<<4)|0)) + 4|0); //@line 78231 "c/sqlite3.c"
  $9 = HEAP32[$8>>2]|0; //@line 78231 "c/sqlite3.c"
  $10 = ($9|0)==(0|0); //@line 78232 "c/sqlite3.c"
  if ($10) {
   $$2 = $$028;
  } else {
   _sqlite3BtreeEnter($9); //@line 78234 "c/sqlite3.c"
   $11 = (_sqlite3BtreePager($9)|0); //@line 78235 "c/sqlite3.c"
   $12 = (_sqlite3PagerWalCallback($11)|0); //@line 78235 "c/sqlite3.c"
   _sqlite3BtreeLeave($9); //@line 78236 "c/sqlite3.c"
   $13 = ($12|0)>(0); //@line 78237 "c/sqlite3.c"
   if ($13) {
    $14 = HEAP32[$5>>2]|0; //@line 78237 "c/sqlite3.c"
    $15 = ($14|0)!=(0|0); //@line 78237 "c/sqlite3.c"
    $16 = ($$028|0)==(0); //@line 78237 "c/sqlite3.c"
    $or$cond = $16 & $15; //@line 78237 "c/sqlite3.c"
    if ($or$cond) {
     $17 = HEAP32[$6>>2]|0; //@line 78238 "c/sqlite3.c"
     $18 = HEAP32[$4>>2]|0; //@line 78238 "c/sqlite3.c"
     $19 = (($18) + ($$02627<<4)|0); //@line 78238 "c/sqlite3.c"
     $20 = HEAP32[$19>>2]|0; //@line 78238 "c/sqlite3.c"
     $21 = (FUNCTION_TABLE_iiiii[$14 & 127]($17,$0,$20,$12)|0); //@line 78238 "c/sqlite3.c"
     $$2 = $21;
    } else {
     $$2 = $$028;
    }
   } else {
    $$2 = $$028;
   }
  }
  $22 = (($$02627) + 1)|0; //@line 78230 "c/sqlite3.c"
  $23 = HEAP32[$1>>2]|0; //@line 78230 "c/sqlite3.c"
  $24 = ($22|0)<($23|0); //@line 78230 "c/sqlite3.c"
  if ($24) {
   $$02627 = $22;$$028 = $$2;
  } else {
   $$0$lcssa = $$2;
   break;
  }
 }
 return ($$0$lcssa|0); //@line 78243 "c/sqlite3.c"
}
function _sqlite3PagerWalCallback($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 212|0); //@line 55381 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 55381 "c/sqlite3.c"
 $3 = (_sqlite3WalCallback($2)|0); //@line 55381 "c/sqlite3.c"
 return ($3|0); //@line 55381 "c/sqlite3.c"
}
function _sqlite3WalCallback($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 59235 "c/sqlite3.c"
 if ($1) {
  $$0 = 0;
  return ($$0|0); //@line 59239 "c/sqlite3.c"
 }
 $2 = ((($0)) + 12|0); //@line 59236 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 59236 "c/sqlite3.c"
 HEAP32[$2>>2] = 0; //@line 59237 "c/sqlite3.c"
 $$0 = $3;
 return ($$0|0); //@line 59239 "c/sqlite3.c"
}
function _sqlite3OpcodeName($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (6512 + ($0<<2)|0); //@line 30541 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 30541 "c/sqlite3.c"
 return ($2|0); //@line 30541 "c/sqlite3.c"
}
function _displayP4($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$ = 0, $$06972 = 0, $$07073 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0.0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0;
 var $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0.0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0;
 var $99 = 0, $exitcond = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer12 = 0, $vararg_buffer15 = 0, $vararg_buffer18 = 0, $vararg_buffer21 = 0, $vararg_buffer24 = 0, $vararg_buffer27 = 0, $vararg_buffer30 = 0, $vararg_buffer33 = 0, $vararg_buffer35 = 0, $vararg_buffer5 = 0, $vararg_buffer8 = 0, $vararg_ptr11 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 128|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(128|0);
 $vararg_buffer35 = sp + 96|0;
 $vararg_buffer33 = sp + 88|0;
 $vararg_buffer30 = sp + 80|0;
 $vararg_buffer27 = sp + 72|0;
 $vararg_buffer24 = sp + 64|0;
 $vararg_buffer21 = sp + 56|0;
 $vararg_buffer18 = sp + 48|0;
 $vararg_buffer15 = sp + 40|0;
 $vararg_buffer12 = sp + 32|0;
 $vararg_buffer8 = sp + 24|0;
 $vararg_buffer5 = sp + 16|0;
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $3 = sp + 104|0;
 _sqlite3StrAccumInit($3,0,$1,$2,0); //@line 74281 "c/sqlite3.c"
 $4 = ((($0)) + 1|0); //@line 74282 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 74282 "c/sqlite3.c"
 $6 = $5 << 24 >> 24; //@line 74282 "c/sqlite3.c"
 L1: do {
  switch ($6|0) {
  case -9:  {
   $7 = ((($0)) + 16|0); //@line 74285 "c/sqlite3.c"
   $8 = HEAP32[$7>>2]|0; //@line 74285 "c/sqlite3.c"
   $9 = ((($8)) + 6|0); //@line 74287 "c/sqlite3.c"
   $10 = HEAP16[$9>>1]|0; //@line 74287 "c/sqlite3.c"
   $11 = $10&65535; //@line 74287 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $11; //@line 74287 "c/sqlite3.c"
   _sqlite3XPrintf($3,36074,$vararg_buffer); //@line 74287 "c/sqlite3.c"
   $12 = HEAP16[$9>>1]|0; //@line 74288 "c/sqlite3.c"
   $13 = ($12<<16>>16)==(0); //@line 74288 "c/sqlite3.c"
   if (!($13)) {
    $14 = ((($8)) + 16|0);
    $$06972 = 0;
    while(1) {
     $15 = (((($8)) + 20|0) + ($$06972<<2)|0); //@line 74289 "c/sqlite3.c"
     $16 = HEAP32[$15>>2]|0; //@line 74289 "c/sqlite3.c"
     $17 = ($16|0)==(0|0); //@line 74290 "c/sqlite3.c"
     if ($17) {
      $19 = 41388;
     } else {
      $18 = HEAP32[$16>>2]|0; //@line 74290 "c/sqlite3.c"
      $19 = $18;
     }
     $20 = (_strcmp($19,18038)|0); //@line 74291 "c/sqlite3.c"
     $21 = ($20|0)==(0); //@line 74291 "c/sqlite3.c"
     $spec$select = $21 ? 36079 : $19; //@line 74291 "c/sqlite3.c"
     $22 = HEAP32[$14>>2]|0; //@line 74292 "c/sqlite3.c"
     $23 = (($22) + ($$06972)|0); //@line 74292 "c/sqlite3.c"
     $24 = HEAP8[$23>>0]|0; //@line 74292 "c/sqlite3.c"
     $25 = ($24<<24>>24)==(0); //@line 74292 "c/sqlite3.c"
     $26 = $25 ? 41388 : 22143; //@line 74292 "c/sqlite3.c"
     HEAP32[$vararg_buffer1>>2] = $26; //@line 74292 "c/sqlite3.c"
     $vararg_ptr4 = ((($vararg_buffer1)) + 4|0); //@line 74292 "c/sqlite3.c"
     HEAP32[$vararg_ptr4>>2] = $spec$select; //@line 74292 "c/sqlite3.c"
     _sqlite3XPrintf($3,36081,$vararg_buffer1); //@line 74292 "c/sqlite3.c"
     $27 = (($$06972) + 1)|0; //@line 74288 "c/sqlite3.c"
     $28 = HEAP16[$9>>1]|0; //@line 74288 "c/sqlite3.c"
     $29 = $28&65535; //@line 74288 "c/sqlite3.c"
     $30 = ($27>>>0)<($29>>>0); //@line 74288 "c/sqlite3.c"
     if ($30) {
      $$06972 = $27;
     } else {
      break;
     }
    }
   }
   _sqlite3StrAccumAppend($3,20274,1); //@line 74294 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -2:  {
   $31 = ((($0)) + 16|0); //@line 74304 "c/sqlite3.c"
   $32 = HEAP32[$31>>2]|0; //@line 74304 "c/sqlite3.c"
   $33 = HEAP32[$32>>2]|0; //@line 74305 "c/sqlite3.c"
   HEAP32[$vararg_buffer5>>2] = $33; //@line 74305 "c/sqlite3.c"
   _sqlite3XPrintf($3,36087,$vararg_buffer5); //@line 74305 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -8:  {
   $34 = ((($0)) + 16|0); //@line 74309 "c/sqlite3.c"
   $35 = HEAP32[$34>>2]|0; //@line 74309 "c/sqlite3.c"
   $36 = ((($35)) + 20|0); //@line 74310 "c/sqlite3.c"
   $37 = HEAP32[$36>>2]|0; //@line 74310 "c/sqlite3.c"
   $38 = HEAP8[$35>>0]|0; //@line 74310 "c/sqlite3.c"
   $39 = $38 << 24 >> 24; //@line 74310 "c/sqlite3.c"
   HEAP32[$vararg_buffer8>>2] = $37; //@line 74310 "c/sqlite3.c"
   $vararg_ptr11 = ((($vararg_buffer8)) + 4|0); //@line 74310 "c/sqlite3.c"
   HEAP32[$vararg_ptr11>>2] = $39; //@line 74310 "c/sqlite3.c"
   _sqlite3XPrintf($3,36095,$vararg_buffer8); //@line 74310 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -14:  {
   $40 = ((($0)) + 16|0); //@line 74321 "c/sqlite3.c"
   $41 = HEAP32[$40>>2]|0; //@line 74321 "c/sqlite3.c"
   $42 = $41; //@line 74321 "c/sqlite3.c"
   $43 = $42; //@line 74321 "c/sqlite3.c"
   $44 = HEAP32[$43>>2]|0; //@line 74321 "c/sqlite3.c"
   $45 = (($42) + 4)|0; //@line 74321 "c/sqlite3.c"
   $46 = $45; //@line 74321 "c/sqlite3.c"
   $47 = HEAP32[$46>>2]|0; //@line 74321 "c/sqlite3.c"
   $48 = $vararg_buffer12; //@line 74321 "c/sqlite3.c"
   $49 = $48; //@line 74321 "c/sqlite3.c"
   HEAP32[$49>>2] = $44; //@line 74321 "c/sqlite3.c"
   $50 = (($48) + 4)|0; //@line 74321 "c/sqlite3.c"
   $51 = $50; //@line 74321 "c/sqlite3.c"
   HEAP32[$51>>2] = $47; //@line 74321 "c/sqlite3.c"
   _sqlite3XPrintf($3,17149,$vararg_buffer12); //@line 74321 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -3:  {
   $52 = ((($0)) + 16|0); //@line 74325 "c/sqlite3.c"
   $53 = HEAP32[$52>>2]|0; //@line 74325 "c/sqlite3.c"
   HEAP32[$vararg_buffer15>>2] = $53; //@line 74325 "c/sqlite3.c"
   _sqlite3XPrintf($3,36102,$vararg_buffer15); //@line 74325 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -13:  {
   $54 = ((($0)) + 16|0); //@line 74329 "c/sqlite3.c"
   $55 = HEAP32[$54>>2]|0; //@line 74329 "c/sqlite3.c"
   $56 = +HEAPF64[$55>>3]; //@line 74329 "c/sqlite3.c"
   HEAPF64[$vararg_buffer18>>3] = $56; //@line 74329 "c/sqlite3.c"
   _sqlite3XPrintf($3,36105,$vararg_buffer18); //@line 74329 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -11:  {
   $57 = ((($0)) + 16|0); //@line 74333 "c/sqlite3.c"
   $58 = HEAP32[$57>>2]|0; //@line 74333 "c/sqlite3.c"
   $59 = ((($58)) + 8|0); //@line 74334 "c/sqlite3.c"
   $60 = HEAP16[$59>>1]|0; //@line 74334 "c/sqlite3.c"
   $61 = $60&65535; //@line 74334 "c/sqlite3.c"
   $62 = $61 & 2; //@line 74334 "c/sqlite3.c"
   $63 = ($62|0)==(0); //@line 74334 "c/sqlite3.c"
   if (!($63)) {
    $64 = ((($58)) + 16|0); //@line 74335 "c/sqlite3.c"
    $65 = HEAP32[$64>>2]|0; //@line 74335 "c/sqlite3.c"
    $$1 = $65;
    break L1;
   }
   $66 = $61 & 4; //@line 74336 "c/sqlite3.c"
   $67 = ($66|0)==(0); //@line 74336 "c/sqlite3.c"
   if (!($67)) {
    $68 = $58; //@line 74337 "c/sqlite3.c"
    $69 = $68; //@line 74337 "c/sqlite3.c"
    $70 = HEAP32[$69>>2]|0; //@line 74337 "c/sqlite3.c"
    $71 = (($68) + 4)|0; //@line 74337 "c/sqlite3.c"
    $72 = $71; //@line 74337 "c/sqlite3.c"
    $73 = HEAP32[$72>>2]|0; //@line 74337 "c/sqlite3.c"
    $74 = $vararg_buffer21; //@line 74337 "c/sqlite3.c"
    $75 = $74; //@line 74337 "c/sqlite3.c"
    HEAP32[$75>>2] = $70; //@line 74337 "c/sqlite3.c"
    $76 = (($74) + 4)|0; //@line 74337 "c/sqlite3.c"
    $77 = $76; //@line 74337 "c/sqlite3.c"
    HEAP32[$77>>2] = $73; //@line 74337 "c/sqlite3.c"
    _sqlite3XPrintf($3,17149,$vararg_buffer21); //@line 74337 "c/sqlite3.c"
    $$1 = $1;
    break L1;
   }
   $78 = $61 & 8; //@line 74338 "c/sqlite3.c"
   $79 = ($78|0)==(0); //@line 74338 "c/sqlite3.c"
   if ($79) {
    $81 = $61 & 1; //@line 74340 "c/sqlite3.c"
    $82 = ($81|0)==(0); //@line 74340 "c/sqlite3.c"
    $$ = $82 ? 36111 : 15390;
    $$1 = $$;
    break L1;
   } else {
    $80 = +HEAPF64[$58>>3]; //@line 74339 "c/sqlite3.c"
    HEAPF64[$vararg_buffer24>>3] = $80; //@line 74339 "c/sqlite3.c"
    _sqlite3XPrintf($3,36105,$vararg_buffer24); //@line 74339 "c/sqlite3.c"
    $$1 = $1;
    break L1;
   }
   break;
  }
  case -12:  {
   $83 = ((($0)) + 16|0); //@line 74350 "c/sqlite3.c"
   $84 = HEAP32[$83>>2]|0; //@line 74350 "c/sqlite3.c"
   $85 = ((($84)) + 8|0); //@line 74350 "c/sqlite3.c"
   $86 = HEAP32[$85>>2]|0; //@line 74350 "c/sqlite3.c"
   HEAP32[$vararg_buffer27>>2] = $86; //@line 74351 "c/sqlite3.c"
   _sqlite3XPrintf($3,36118,$vararg_buffer27); //@line 74351 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -15:  {
   $87 = ((($0)) + 16|0); //@line 74357 "c/sqlite3.c"
   $88 = HEAP32[$87>>2]|0; //@line 74357 "c/sqlite3.c"
   $89 = HEAP32[$88>>2]|0; //@line 74358 "c/sqlite3.c"
   $90 = ($89|0)<(1); //@line 74360 "c/sqlite3.c"
   if (!($90)) {
    $$07073 = 1;
    while(1) {
     $91 = (($88) + ($$07073<<2)|0); //@line 74361 "c/sqlite3.c"
     $92 = HEAP32[$91>>2]|0; //@line 74361 "c/sqlite3.c"
     HEAP32[$vararg_buffer30>>2] = $92; //@line 74361 "c/sqlite3.c"
     _sqlite3XPrintf($3,36126,$vararg_buffer30); //@line 74361 "c/sqlite3.c"
     $93 = (($$07073) + 1)|0; //@line 74360 "c/sqlite3.c"
     $exitcond = ($$07073|0)==($89|0); //@line 74360 "c/sqlite3.c"
     if ($exitcond) {
      break;
     } else {
      $$07073 = $93;
     }
    }
   }
   HEAP8[$1>>0] = 91; //@line 74363 "c/sqlite3.c"
   _sqlite3StrAccumAppend($3,36130,1); //@line 74364 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -4:  {
   _sqlite3XPrintf($3,36132,$vararg_buffer33); //@line 74368 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -5: case -17:  {
   HEAP8[$1>>0] = 0; //@line 74373 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  case -6:  {
   $94 = ((($0)) + 16|0); //@line 74377 "c/sqlite3.c"
   $95 = HEAP32[$94>>2]|0; //@line 74377 "c/sqlite3.c"
   $96 = HEAP32[$95>>2]|0; //@line 74377 "c/sqlite3.c"
   HEAP32[$vararg_buffer35>>2] = $96; //@line 74377 "c/sqlite3.c"
   _sqlite3XPrintf($3,15687,$vararg_buffer35); //@line 74377 "c/sqlite3.c"
   $$1 = $1;
   break;
  }
  default: {
   $97 = ((($0)) + 16|0); //@line 74381 "c/sqlite3.c"
   $98 = HEAP32[$97>>2]|0; //@line 74381 "c/sqlite3.c"
   $99 = ($98|0)==(0|0); //@line 74382 "c/sqlite3.c"
   if ($99) {
    HEAP8[$1>>0] = 0; //@line 74384 "c/sqlite3.c"
    $$1 = $1;
   } else {
    $$1 = $98;
   }
  }
  }
 } while(0);
 (_sqlite3StrAccumFinish($3)|0); //@line 74388 "c/sqlite3.c"
 STACKTOP = sp;return ($$1|0); //@line 74390 "c/sqlite3.c"
}
function _sqlite3_get_table_cb($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$066 = 0, $$067 = 0, $$06878 = 0, $$16977 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0; //@line 124779 "c/sqlite3.c"
 $vararg_buffer = sp; //@line 124779 "c/sqlite3.c"
 $4 = ((($0)) + 12|0); //@line 124788 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 124788 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 124788 "c/sqlite3.c"
 $7 = ($2|0)!=(0|0); //@line 124788 "c/sqlite3.c"
 $or$cond = $7 & $6; //@line 124788 "c/sqlite3.c"
 $8 = $or$cond&1; //@line 124788 "c/sqlite3.c"
 $$066 = $1 << $8; //@line 124788 "c/sqlite3.c"
 $9 = ((($0)) + 20|0); //@line 124793 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 124793 "c/sqlite3.c"
 $11 = (($$066) + ($10))|0; //@line 124793 "c/sqlite3.c"
 $12 = ((($0)) + 8|0); //@line 124793 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 124793 "c/sqlite3.c"
 $14 = ($11>>>0)>($13>>>0); //@line 124793 "c/sqlite3.c"
 if ($14) {
  $15 = $13 << 1; //@line 124795 "c/sqlite3.c"
  $16 = (($$066) + ($15))|0; //@line 124795 "c/sqlite3.c"
  HEAP32[$12>>2] = $16; //@line 124795 "c/sqlite3.c"
  $17 = HEAP32[$0>>2]|0; //@line 124796 "c/sqlite3.c"
  $18 = $16 << 2; //@line 124796 "c/sqlite3.c"
  $19 = (_sqlite3_realloc64($17,$18,0)|0); //@line 124796 "c/sqlite3.c"
  $20 = ($19|0)==(0|0); //@line 124797 "c/sqlite3.c"
  if (!($20)) {
   HEAP32[$0>>2] = $19; //@line 124798 "c/sqlite3.c"
   label = 4;
  }
 } else {
  label = 4;
 }
 L4: do {
  if ((label|0) == 4) {
   $21 = HEAP32[$4>>2]|0; //@line 124804 "c/sqlite3.c"
   $22 = ($21|0)==(0); //@line 124804 "c/sqlite3.c"
   $23 = ((($0)) + 16|0);
   if ($22) {
    HEAP32[$23>>2] = $1; //@line 124805 "c/sqlite3.c"
    $24 = ($1|0)>(0); //@line 124806 "c/sqlite3.c"
    if ($24) {
     $$06878 = 0;
     while(1) {
      $25 = (($3) + ($$06878<<2)|0); //@line 124807 "c/sqlite3.c"
      $26 = HEAP32[$25>>2]|0; //@line 124807 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $26; //@line 124807 "c/sqlite3.c"
      $27 = (_sqlite3_mprintf(15687,$vararg_buffer)|0); //@line 124807 "c/sqlite3.c"
      $28 = ($27|0)==(0|0); //@line 124808 "c/sqlite3.c"
      if ($28) {
       break L4;
      }
      $29 = HEAP32[$0>>2]|0; //@line 124809 "c/sqlite3.c"
      $30 = HEAP32[$9>>2]|0; //@line 124809 "c/sqlite3.c"
      $31 = (($30) + 1)|0; //@line 124809 "c/sqlite3.c"
      HEAP32[$9>>2] = $31; //@line 124809 "c/sqlite3.c"
      $32 = (($29) + ($30<<2)|0); //@line 124809 "c/sqlite3.c"
      HEAP32[$32>>2] = $27; //@line 124809 "c/sqlite3.c"
      $33 = (($$06878) + 1)|0; //@line 124806 "c/sqlite3.c"
      $34 = ($33|0)<($1|0); //@line 124806 "c/sqlite3.c"
      if ($34) {
       $$06878 = $33;
      } else {
       break;
      }
     }
    }
   } else {
    $35 = HEAP32[$23>>2]|0; //@line 124811 "c/sqlite3.c"
    $36 = ($35|0)==($1|0); //@line 124811 "c/sqlite3.c"
    if (!($36)) {
     $37 = ((($0)) + 4|0); //@line 124812 "c/sqlite3.c"
     $38 = HEAP32[$37>>2]|0; //@line 124812 "c/sqlite3.c"
     _sqlite3_free($38); //@line 124812 "c/sqlite3.c"
     $39 = (_sqlite3_mprintf(37562,$vararg_buffer1)|0); //@line 124813 "c/sqlite3.c"
     HEAP32[$37>>2] = $39; //@line 124813 "c/sqlite3.c"
     $40 = ((($0)) + 24|0); //@line 124816 "c/sqlite3.c"
     HEAP32[$40>>2] = 1; //@line 124816 "c/sqlite3.c"
     $$0 = 1;
     STACKTOP = sp;return ($$0|0); //@line 124841 "c/sqlite3.c"
    }
   }
   if (!($7)) {
    $$0 = 0;
    STACKTOP = sp;return ($$0|0); //@line 124841 "c/sqlite3.c"
   }
   $41 = ($1|0)>(0); //@line 124823 "c/sqlite3.c"
   if ($41) {
    $$16977 = 0;
    while(1) {
     $42 = (($2) + ($$16977<<2)|0); //@line 124824 "c/sqlite3.c"
     $43 = HEAP32[$42>>2]|0; //@line 124824 "c/sqlite3.c"
     $44 = ($43|0)==(0|0); //@line 124824 "c/sqlite3.c"
     if ($44) {
      $$067 = 0;
     } else {
      $45 = (_sqlite3Strlen30($43)|0); //@line 124827 "c/sqlite3.c"
      $46 = (($45) + 1)|0; //@line 124827 "c/sqlite3.c"
      $47 = ($46|0)<(0); //@line 124828 "c/sqlite3.c"
      $48 = $47 << 31 >> 31; //@line 124828 "c/sqlite3.c"
      $49 = (_sqlite3_malloc64($46,$48)|0); //@line 124828 "c/sqlite3.c"
      $50 = ($49|0)==(0|0); //@line 124829 "c/sqlite3.c"
      if ($50) {
       break L4;
      }
      $51 = HEAP32[$42>>2]|0; //@line 124830 "c/sqlite3.c"
      _memcpy(($49|0),($51|0),($46|0))|0; //@line 124830 "c/sqlite3.c"
      $$067 = $49;
     }
     $52 = HEAP32[$0>>2]|0; //@line 124832 "c/sqlite3.c"
     $53 = HEAP32[$9>>2]|0; //@line 124832 "c/sqlite3.c"
     $54 = (($53) + 1)|0; //@line 124832 "c/sqlite3.c"
     HEAP32[$9>>2] = $54; //@line 124832 "c/sqlite3.c"
     $55 = (($52) + ($53<<2)|0); //@line 124832 "c/sqlite3.c"
     HEAP32[$55>>2] = $$067; //@line 124832 "c/sqlite3.c"
     $56 = (($$16977) + 1)|0; //@line 124823 "c/sqlite3.c"
     $57 = ($56|0)<($1|0); //@line 124823 "c/sqlite3.c"
     if ($57) {
      $$16977 = $56;
     } else {
      break;
     }
    }
   }
   $58 = HEAP32[$4>>2]|0; //@line 124834 "c/sqlite3.c"
   $59 = (($58) + 1)|0; //@line 124834 "c/sqlite3.c"
   HEAP32[$4>>2] = $59; //@line 124834 "c/sqlite3.c"
   $$0 = 0;
   STACKTOP = sp;return ($$0|0); //@line 124841 "c/sqlite3.c"
  }
 } while(0);
 $60 = ((($0)) + 24|0); //@line 124839 "c/sqlite3.c"
 HEAP32[$60>>2] = 7; //@line 124839 "c/sqlite3.c"
 $$0 = 1;
 STACKTOP = sp;return ($$0|0); //@line 124841 "c/sqlite3.c"
}
function _columnMem($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$015 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0); //@line 78725 "c/sqlite3.c"
 if ($2) {
  $$015 = 296;
  return ($$015|0); //@line 78735 "c/sqlite3.c"
 }
 $3 = HEAP32[$0>>2]|0; //@line 78727 "c/sqlite3.c"
 $4 = ((($3)) + 12|0); //@line 78727 "c/sqlite3.c"
 $5 = HEAP32[$4>>2]|0; //@line 78727 "c/sqlite3.c"
 _sqlite3_mutex_enter($5); //@line 78727 "c/sqlite3.c"
 $6 = ((($0)) + 104|0); //@line 78728 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 78728 "c/sqlite3.c"
 $8 = ($7|0)==(0|0); //@line 78728 "c/sqlite3.c"
 if (!($8)) {
  $9 = ((($0)) + 140|0); //@line 78728 "c/sqlite3.c"
  $10 = HEAP16[$9>>1]|0; //@line 78728 "c/sqlite3.c"
  $11 = $10&65535; //@line 78728 "c/sqlite3.c"
  $12 = ($11>>>0)>($1>>>0); //@line 78728 "c/sqlite3.c"
  if ($12) {
   $13 = (($7) + (($1*40)|0)|0); //@line 78729 "c/sqlite3.c"
   $$015 = $13;
   return ($$015|0); //@line 78735 "c/sqlite3.c"
  }
 }
 $14 = HEAP32[$0>>2]|0; //@line 78731 "c/sqlite3.c"
 _sqlite3Error($14,25); //@line 78731 "c/sqlite3.c"
 $$015 = 296;
 return ($$015|0); //@line 78735 "c/sqlite3.c"
}
function _columnMallocFailure($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0); //@line 78763 "c/sqlite3.c"
 if ($1) {
  return; //@line 78769 "c/sqlite3.c"
 }
 $2 = HEAP32[$0>>2]|0; //@line 78766 "c/sqlite3.c"
 $3 = ((($0)) + 40|0); //@line 78766 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 78766 "c/sqlite3.c"
 $5 = (_sqlite3ApiExit($2,$4)|0); //@line 78766 "c/sqlite3.c"
 HEAP32[$3>>2] = $5; //@line 78766 "c/sqlite3.c"
 $6 = HEAP32[$0>>2]|0; //@line 78767 "c/sqlite3.c"
 $7 = ((($6)) + 12|0); //@line 78767 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 78767 "c/sqlite3.c"
 _sqlite3_mutex_leave($8); //@line 78767 "c/sqlite3.c"
 return; //@line 78769 "c/sqlite3.c"
}
function _columnName($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $4 = HEAP32[$0>>2]|0; //@line 78871 "c/sqlite3.c"
 $5 = (_sqlite3_column_count($0)|0); //@line 78873 "c/sqlite3.c"
 $6 = ($5|0)>($1|0); //@line 78874 "c/sqlite3.c"
 $7 = ($1|0)>(-1); //@line 78874 "c/sqlite3.c"
 $or$cond = $7 & $6; //@line 78874 "c/sqlite3.c"
 if (!($or$cond)) {
  $$1 = 0;
  return ($$1|0); //@line 78888 "c/sqlite3.c"
 }
 $8 = Math_imul($5, $3)|0; //@line 78875 "c/sqlite3.c"
 $9 = (($8) + ($1))|0; //@line 78875 "c/sqlite3.c"
 $10 = ((($4)) + 12|0); //@line 78876 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 78876 "c/sqlite3.c"
 _sqlite3_mutex_enter($11); //@line 78876 "c/sqlite3.c"
 $12 = ((($0)) + 100|0); //@line 78878 "c/sqlite3.c"
 $13 = HEAP32[$12>>2]|0; //@line 78878 "c/sqlite3.c"
 $14 = (($13) + (($9*40)|0)|0); //@line 78878 "c/sqlite3.c"
 $15 = (FUNCTION_TABLE_ii[$2 & 255]($14)|0); //@line 78878 "c/sqlite3.c"
 $16 = ((($4)) + 73|0); //@line 78882 "c/sqlite3.c"
 $17 = HEAP8[$16>>0]|0; //@line 78882 "c/sqlite3.c"
 $18 = ($17<<24>>24)==(0); //@line 78882 "c/sqlite3.c"
 if ($18) {
  $$0 = $15;
 } else {
  _sqlite3OomClear($4); //@line 78883 "c/sqlite3.c"
  $$0 = 0;
 }
 $19 = HEAP32[$10>>2]|0; //@line 78886 "c/sqlite3.c"
 _sqlite3_mutex_leave($19); //@line 78886 "c/sqlite3.c"
 $$1 = $$0;
 return ($$1|0); //@line 78888 "c/sqlite3.c"
}
function _sqliteDefaultBusyCallback($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 436|0); //@line 144860 "c/sqlite3.c"
 $3 = HEAP32[$2>>2]|0; //@line 144860 "c/sqlite3.c"
 $4 = ($1*1000)|0; //@line 144861 "c/sqlite3.c"
 $5 = (($4) + 1000)|0; //@line 144861 "c/sqlite3.c"
 $6 = ($5|0)>($3|0); //@line 144861 "c/sqlite3.c"
 if ($6) {
  $$0 = 0;
  return ($$0|0); //@line 144867 "c/sqlite3.c"
 }
 $7 = HEAP32[$0>>2]|0; //@line 144864 "c/sqlite3.c"
 (_sqlite3OsSleep($7,1000000)|0); //@line 144864 "c/sqlite3.c"
 $$0 = 1;
 return ($$0|0); //@line 144867 "c/sqlite3.c"
}
function _juliandayFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $3 = sp;
 $4 = (_isDate($0,$1,$2,$3)|0); //@line 20480 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 20480 "c/sqlite3.c"
 if (!($5)) {
  STACKTOP = sp;return; //@line 20484 "c/sqlite3.c"
 }
 _computeJD($3); //@line 20481 "c/sqlite3.c"
 $6 = $3; //@line 20482 "c/sqlite3.c"
 $7 = $6; //@line 20482 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 20482 "c/sqlite3.c"
 $9 = (($6) + 4)|0; //@line 20482 "c/sqlite3.c"
 $10 = $9; //@line 20482 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 20482 "c/sqlite3.c"
 $12 = (+($8>>>0)) + (4294967296.0*(+($11|0))); //@line 20482 "c/sqlite3.c"
 $13 = $12 / 8.64E+7; //@line 20482 "c/sqlite3.c"
 _sqlite3_result_double($0,$13); //@line 20482 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 20484 "c/sqlite3.c"
}
function _dateFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 160|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(160|0);
 $vararg_buffer = sp + 48|0;
 $3 = sp;
 $4 = sp + 60|0;
 $5 = (_isDate($0,$1,$2,$3)|0); //@line 20536 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 20536 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return; //@line 20542 "c/sqlite3.c"
 }
 _computeYMD($3); //@line 20538 "c/sqlite3.c"
 $7 = ((($3)) + 8|0); //@line 20539 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 20539 "c/sqlite3.c"
 $9 = ((($3)) + 12|0); //@line 20539 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 20539 "c/sqlite3.c"
 $11 = ((($3)) + 16|0); //@line 20539 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 20539 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $8; //@line 20539 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 20539 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $10; //@line 20539 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 20539 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $12; //@line 20539 "c/sqlite3.c"
 (_sqlite3_snprintf(100,$4,38072,$vararg_buffer)|0); //@line 20539 "c/sqlite3.c"
 _sqlite3_result_text($0,$4,-1,(-1)); //@line 20540 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 20542 "c/sqlite3.c"
}
function _timeFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 160|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(160|0);
 $vararg_buffer = sp + 48|0;
 $3 = sp;
 $4 = sp + 60|0;
 $5 = (_isDate($0,$1,$2,$3)|0); //@line 20517 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 20517 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return; //@line 20523 "c/sqlite3.c"
 }
 _computeHMS($3); //@line 20519 "c/sqlite3.c"
 $7 = ((($3)) + 20|0); //@line 20520 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 20520 "c/sqlite3.c"
 $9 = ((($3)) + 24|0); //@line 20520 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 20520 "c/sqlite3.c"
 $11 = ((($3)) + 32|0); //@line 20520 "c/sqlite3.c"
 $12 = +HEAPF64[$11>>3]; //@line 20520 "c/sqlite3.c"
 $13 = (~~(($12))); //@line 20520 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $8; //@line 20520 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 20520 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $10; //@line 20520 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 20520 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $13; //@line 20520 "c/sqlite3.c"
 (_sqlite3_snprintf(100,$4,38057,$vararg_buffer)|0); //@line 20520 "c/sqlite3.c"
 _sqlite3_result_text($0,$4,-1,(-1)); //@line 20521 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 20523 "c/sqlite3.c"
}
function _datetimeFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0;
 var $vararg_ptr3 = 0, $vararg_ptr4 = 0, $vararg_ptr5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 176|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(176|0);
 $vararg_buffer = sp + 48|0;
 $3 = sp;
 $4 = sp + 72|0;
 $5 = (_isDate($0,$1,$2,$3)|0); //@line 20497 "c/sqlite3.c"
 $6 = ($5|0)==(0); //@line 20497 "c/sqlite3.c"
 if (!($6)) {
  STACKTOP = sp;return; //@line 20504 "c/sqlite3.c"
 }
 _computeYMD_HMS($3); //@line 20499 "c/sqlite3.c"
 $7 = ((($3)) + 8|0); //@line 20501 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 20501 "c/sqlite3.c"
 $9 = ((($3)) + 12|0); //@line 20501 "c/sqlite3.c"
 $10 = HEAP32[$9>>2]|0; //@line 20501 "c/sqlite3.c"
 $11 = ((($3)) + 16|0); //@line 20501 "c/sqlite3.c"
 $12 = HEAP32[$11>>2]|0; //@line 20501 "c/sqlite3.c"
 $13 = ((($3)) + 20|0); //@line 20501 "c/sqlite3.c"
 $14 = HEAP32[$13>>2]|0; //@line 20501 "c/sqlite3.c"
 $15 = ((($3)) + 24|0); //@line 20501 "c/sqlite3.c"
 $16 = HEAP32[$15>>2]|0; //@line 20501 "c/sqlite3.c"
 $17 = ((($3)) + 32|0); //@line 20501 "c/sqlite3.c"
 $18 = +HEAPF64[$17>>3]; //@line 20501 "c/sqlite3.c"
 $19 = (~~(($18))); //@line 20501 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $8; //@line 20500 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 20500 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $10; //@line 20500 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 20500 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $12; //@line 20500 "c/sqlite3.c"
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 20500 "c/sqlite3.c"
 HEAP32[$vararg_ptr3>>2] = $14; //@line 20500 "c/sqlite3.c"
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0); //@line 20500 "c/sqlite3.c"
 HEAP32[$vararg_ptr4>>2] = $16; //@line 20500 "c/sqlite3.c"
 $vararg_ptr5 = ((($vararg_buffer)) + 20|0); //@line 20500 "c/sqlite3.c"
 HEAP32[$vararg_ptr5>>2] = $19; //@line 20500 "c/sqlite3.c"
 (_sqlite3_snprintf(100,$4,38027,$vararg_buffer)|0); //@line 20500 "c/sqlite3.c"
 _sqlite3_result_text($0,$4,-1,(-1)); //@line 20502 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 20504 "c/sqlite3.c"
}
function _strftimeFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0114 = 0, $$0117 = 0.0, $$0118 = 0, $$0121 = 0, $$1115 = 0, $$2116 = 0, $$2120 = 0, $$3 = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0.0, $126 = 0.0, $127 = 0;
 var $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0;
 var $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0.0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0;
 var $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0;
 var $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0;
 var $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0;
 var $74 = 0, $75 = 0, $76 = 0, $77 = 0.0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0;
 var $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer10 = 0, $vararg_buffer13 = 0, $vararg_buffer16 = 0, $vararg_buffer19 = 0, $vararg_buffer22 = 0, $vararg_buffer25 = 0, $vararg_buffer28 = 0, $vararg_buffer4 = 0, $vararg_buffer7 = 0, dest = 0;
 var label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 288|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(288|0);
 $vararg_buffer28 = sp + 176|0;
 $vararg_buffer25 = sp + 168|0;
 $vararg_buffer22 = sp + 160|0;
 $vararg_buffer19 = sp + 152|0;
 $vararg_buffer16 = sp + 144|0;
 $vararg_buffer13 = sp + 136|0;
 $vararg_buffer10 = sp + 128|0;
 $vararg_buffer7 = sp + 120|0;
 $vararg_buffer4 = sp + 112|0;
 $vararg_buffer1 = sp + 104|0;
 $vararg_buffer = sp + 96|0;
 $3 = sp + 48|0;
 $4 = sp + 180|0;
 $5 = sp;
 $6 = ($1|0)==(0); //@line 20575 "c/sqlite3.c"
 if ($6) {
  STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
 }
 $7 = HEAP32[$2>>2]|0; //@line 20576 "c/sqlite3.c"
 $8 = (_sqlite3_value_text($7)|0); //@line 20576 "c/sqlite3.c"
 $9 = ($8|0)==(0|0); //@line 20577 "c/sqlite3.c"
 if ($9) {
  STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
 }
 $10 = (($1) + -1)|0; //@line 20577 "c/sqlite3.c"
 $11 = ((($2)) + 4|0); //@line 20577 "c/sqlite3.c"
 $12 = (_isDate($0,$10,$11,$3)|0); //@line 20577 "c/sqlite3.c"
 $13 = ($12|0)==(0); //@line 20577 "c/sqlite3.c"
 if (!($13)) {
  STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
 }
 $14 = (_sqlite3_context_db_handle($0)|0); //@line 20578 "c/sqlite3.c"
 $$0114 = 0;$21 = 1;$22 = 0;
 L10: while(1) {
  $15 = (($8) + ($$0114)|0); //@line 20579 "c/sqlite3.c"
  $16 = HEAP8[$15>>0]|0; //@line 20579 "c/sqlite3.c"
  L12: do {
   switch ($16<<24>>24) {
   case 0:  {
    break L10;
    break;
   }
   case 37:  {
    $17 = (($$0114) + 1)|0; //@line 20581 "c/sqlite3.c"
    $18 = (($8) + ($17)|0); //@line 20581 "c/sqlite3.c"
    $19 = HEAP8[$18>>0]|0; //@line 20581 "c/sqlite3.c"
    $20 = $19 << 24 >> 24; //@line 20581 "c/sqlite3.c"
    switch ($20|0) {
    case 37: case 119:  {
     $$1115 = $17;$34 = $21;$35 = $22;
     break L12;
     break;
    }
    case 87: case 83: case 77: case 109: case 72: case 100:  {
     $23 = (_i64Add(($21|0),($22|0),1,0)|0); //@line 20588 "c/sqlite3.c"
     $24 = tempRet0; //@line 20588 "c/sqlite3.c"
     $$1115 = $17;$34 = $23;$35 = $24;
     break L12;
     break;
    }
    case 102:  {
     $25 = (_i64Add(($21|0),($22|0),8,0)|0); //@line 20594 "c/sqlite3.c"
     $26 = tempRet0; //@line 20594 "c/sqlite3.c"
     $$1115 = $17;$34 = $25;$35 = $26;
     break L12;
     break;
    }
    case 106:  {
     $27 = (_i64Add(($21|0),($22|0),3,0)|0); //@line 20597 "c/sqlite3.c"
     $28 = tempRet0; //@line 20597 "c/sqlite3.c"
     $$1115 = $17;$34 = $27;$35 = $28;
     break L12;
     break;
    }
    case 89:  {
     $29 = (_i64Add(($21|0),($22|0),8,0)|0); //@line 20600 "c/sqlite3.c"
     $30 = tempRet0; //@line 20600 "c/sqlite3.c"
     $$1115 = $17;$34 = $29;$35 = $30;
     break L12;
     break;
    }
    case 74: case 115:  {
     $31 = (_i64Add(($21|0),($22|0),50,0)|0); //@line 20604 "c/sqlite3.c"
     $32 = tempRet0; //@line 20604 "c/sqlite3.c"
     $$1115 = $17;$34 = $31;$35 = $32;
     break L12;
     break;
    }
    default: {
     label = 39;
     break L10;
    }
    }
    break;
   }
   default: {
    $$1115 = $$0114;$34 = $21;$35 = $22;
   }
   }
  } while(0);
  $33 = (($$1115) + 1)|0; //@line 20579 "c/sqlite3.c"
  $36 = (_i64Add(($34|0),($35|0),1,0)|0); //@line 20579 "c/sqlite3.c"
  $37 = tempRet0; //@line 20579 "c/sqlite3.c"
  $$0114 = $33;$21 = $36;$22 = $37;
 }
 if ((label|0) == 39) {
  STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
 }
 $38 = ($22>>>0)<(0); //@line 20616 "c/sqlite3.c"
 $39 = ($21>>>0)<(100); //@line 20616 "c/sqlite3.c"
 $40 = ($22|0)==(0); //@line 20616 "c/sqlite3.c"
 $41 = $40 & $39; //@line 20616 "c/sqlite3.c"
 $42 = $38 | $41; //@line 20616 "c/sqlite3.c"
 if ($42) {
  $$0121 = $4;
 } else {
  $43 = ((($14)) + 100|0); //@line 20618 "c/sqlite3.c"
  $44 = HEAP32[$43>>2]|0; //@line 20618 "c/sqlite3.c"
  $45 = ($44|0)<(0); //@line 20618 "c/sqlite3.c"
  $46 = $45 << 31 >> 31; //@line 20618 "c/sqlite3.c"
  $47 = ($22>>>0)>($46>>>0); //@line 20618 "c/sqlite3.c"
  $48 = ($21>>>0)>($44>>>0); //@line 20618 "c/sqlite3.c"
  $49 = ($22|0)==($46|0); //@line 20618 "c/sqlite3.c"
  $50 = $49 & $48; //@line 20618 "c/sqlite3.c"
  $51 = $47 | $50; //@line 20618 "c/sqlite3.c"
  if ($51) {
   _sqlite3_result_error_toobig($0); //@line 20619 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
  }
  $52 = (_bitshift64Ashr(0,($21|0),32)|0); //@line 20622 "c/sqlite3.c"
  $53 = tempRet0; //@line 20622 "c/sqlite3.c"
  $54 = (_sqlite3DbMallocRawNN($14,$52,$53)|0); //@line 20622 "c/sqlite3.c"
  $55 = ($54|0)==(0|0); //@line 20623 "c/sqlite3.c"
  if ($55) {
   _sqlite3_result_error_nomem($0); //@line 20624 "c/sqlite3.c"
   STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
  } else {
   $$0121 = $54;
  }
 }
 _computeJD($3); //@line 20628 "c/sqlite3.c"
 _computeYMD_HMS($3); //@line 20629 "c/sqlite3.c"
 $56 = ((($3)) + 16|0);
 $57 = ((($3)) + 32|0);
 $58 = ((($3)) + 20|0);
 $59 = ((($5)) + 40|0);
 $60 = ((($5)) + 12|0);
 $61 = ((($5)) + 16|0);
 $62 = ((($3)) + 12|0);
 $63 = ((($3)) + 24|0);
 $64 = ((($3)) + 32|0);
 $65 = ((($3)) + 8|0);
 $$0118 = 0;$$2116 = 0;
 L33: while(1) {
  $66 = (($8) + ($$2116)|0); //@line 20630 "c/sqlite3.c"
  $67 = HEAP8[$66>>0]|0; //@line 20630 "c/sqlite3.c"
  L35: do {
   switch ($67<<24>>24) {
   case 0:  {
    break L33;
    break;
   }
   case 37:  {
    $70 = (($$2116) + 1)|0; //@line 20634 "c/sqlite3.c"
    $71 = (($8) + ($70)|0); //@line 20635 "c/sqlite3.c"
    $72 = HEAP8[$71>>0]|0; //@line 20635 "c/sqlite3.c"
    $73 = $72 << 24 >> 24; //@line 20635 "c/sqlite3.c"
    do {
     switch ($73|0) {
     case 100:  {
      $74 = (($$0121) + ($$0118)|0); //@line 20636 "c/sqlite3.c"
      $75 = HEAP32[$56>>2]|0; //@line 20636 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $75; //@line 20636 "c/sqlite3.c"
      (_sqlite3_snprintf(3,$74,37802,$vararg_buffer)|0); //@line 20636 "c/sqlite3.c"
      $76 = (($$0118) + 2)|0; //@line 20636 "c/sqlite3.c"
      $$2120 = $76;$$3 = $70;
      break L35;
      break;
     }
     case 102:  {
      $77 = +HEAPF64[$57>>3]; //@line 20638 "c/sqlite3.c"
      $78 = $77 > 59.999000000000002; //@line 20639 "c/sqlite3.c"
      $$0117 = $78 ? 59.999000000000002 : $77; //@line 20639 "c/sqlite3.c"
      $79 = (($$0121) + ($$0118)|0); //@line 20640 "c/sqlite3.c"
      HEAPF64[$vararg_buffer1>>3] = $$0117; //@line 20640 "c/sqlite3.c"
      (_sqlite3_snprintf(7,$79,37807,$vararg_buffer1)|0); //@line 20640 "c/sqlite3.c"
      $80 = (_sqlite3Strlen30($79)|0); //@line 20641 "c/sqlite3.c"
      $81 = (($80) + ($$0118))|0; //@line 20641 "c/sqlite3.c"
      $$2120 = $81;$$3 = $70;
      break L35;
      break;
     }
     case 72:  {
      $82 = (($$0121) + ($$0118)|0); //@line 20644 "c/sqlite3.c"
      $83 = HEAP32[$58>>2]|0; //@line 20644 "c/sqlite3.c"
      HEAP32[$vararg_buffer4>>2] = $83; //@line 20644 "c/sqlite3.c"
      (_sqlite3_snprintf(3,$82,37802,$vararg_buffer4)|0); //@line 20644 "c/sqlite3.c"
      $84 = (($$0118) + 2)|0; //@line 20644 "c/sqlite3.c"
      $$2120 = $84;$$3 = $70;
      break L35;
      break;
     }
     case 106: case 87:  {
      dest=$5; src=$3; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 20648 "c/sqlite3.c"
      HEAP8[$59>>0] = 0; //@line 20649 "c/sqlite3.c"
      HEAP32[$60>>2] = 1; //@line 20650 "c/sqlite3.c"
      HEAP32[$61>>2] = 1; //@line 20651 "c/sqlite3.c"
      _computeJD($5); //@line 20652 "c/sqlite3.c"
      $85 = $3; //@line 20653 "c/sqlite3.c"
      $86 = $85; //@line 20653 "c/sqlite3.c"
      $87 = HEAP32[$86>>2]|0; //@line 20653 "c/sqlite3.c"
      $88 = (($85) + 4)|0; //@line 20653 "c/sqlite3.c"
      $89 = $88; //@line 20653 "c/sqlite3.c"
      $90 = HEAP32[$89>>2]|0; //@line 20653 "c/sqlite3.c"
      $91 = $5; //@line 20653 "c/sqlite3.c"
      $92 = $91; //@line 20653 "c/sqlite3.c"
      $93 = HEAP32[$92>>2]|0; //@line 20653 "c/sqlite3.c"
      $94 = (($91) + 4)|0; //@line 20653 "c/sqlite3.c"
      $95 = $94; //@line 20653 "c/sqlite3.c"
      $96 = HEAP32[$95>>2]|0; //@line 20653 "c/sqlite3.c"
      $97 = (_i64Add(($87|0),($90|0),43200000,0)|0); //@line 20653 "c/sqlite3.c"
      $98 = tempRet0; //@line 20653 "c/sqlite3.c"
      $99 = (_i64Subtract(($97|0),($98|0),($93|0),($96|0))|0); //@line 20653 "c/sqlite3.c"
      $100 = tempRet0; //@line 20653 "c/sqlite3.c"
      $101 = (___divdi3(($99|0),($100|0),86400000,0)|0); //@line 20653 "c/sqlite3.c"
      $102 = tempRet0; //@line 20653 "c/sqlite3.c"
      $103 = HEAP8[$71>>0]|0; //@line 20654 "c/sqlite3.c"
      $104 = ($103<<24>>24)==(87); //@line 20654 "c/sqlite3.c"
      if ($104) {
       $105 = (_i64Add(($87|0),($90|0),43200000,0)|0); //@line 20656 "c/sqlite3.c"
       $106 = tempRet0; //@line 20656 "c/sqlite3.c"
       $107 = (___divdi3(($105|0),($106|0),86400000,0)|0); //@line 20656 "c/sqlite3.c"
       $108 = tempRet0; //@line 20656 "c/sqlite3.c"
       $109 = (___remdi3(($107|0),($108|0),7,0)|0); //@line 20656 "c/sqlite3.c"
       $110 = tempRet0; //@line 20656 "c/sqlite3.c"
       $111 = (($$0121) + ($$0118)|0); //@line 20657 "c/sqlite3.c"
       $112 = (($101) + 7)|0; //@line 20657 "c/sqlite3.c"
       $113 = (($112) - ($109))|0; //@line 20657 "c/sqlite3.c"
       $114 = (($113|0) / 7)&-1; //@line 20657 "c/sqlite3.c"
       HEAP32[$vararg_buffer7>>2] = $114; //@line 20657 "c/sqlite3.c"
       (_sqlite3_snprintf(3,$111,37802,$vararg_buffer7)|0); //@line 20657 "c/sqlite3.c"
       $$sink = 2;
      } else {
       $115 = (($$0121) + ($$0118)|0); //@line 20660 "c/sqlite3.c"
       $116 = (($101) + 1)|0; //@line 20660 "c/sqlite3.c"
       HEAP32[$vararg_buffer10>>2] = $116; //@line 20660 "c/sqlite3.c"
       (_sqlite3_snprintf(4,$115,37814,$vararg_buffer10)|0); //@line 20660 "c/sqlite3.c"
       $$sink = 3;
      }
      $117 = (($$0118) + ($$sink))|0;
      $$2120 = $117;$$3 = $70;
      break L35;
      break;
     }
     case 74:  {
      $118 = (($$0121) + ($$0118)|0); //@line 20666 "c/sqlite3.c"
      $119 = $3; //@line 20666 "c/sqlite3.c"
      $120 = $119; //@line 20666 "c/sqlite3.c"
      $121 = HEAP32[$120>>2]|0; //@line 20666 "c/sqlite3.c"
      $122 = (($119) + 4)|0; //@line 20666 "c/sqlite3.c"
      $123 = $122; //@line 20666 "c/sqlite3.c"
      $124 = HEAP32[$123>>2]|0; //@line 20666 "c/sqlite3.c"
      $125 = (+($121>>>0)) + (4294967296.0*(+($124|0))); //@line 20666 "c/sqlite3.c"
      $126 = $125 / 8.64E+7; //@line 20666 "c/sqlite3.c"
      HEAPF64[$vararg_buffer13>>3] = $126; //@line 20666 "c/sqlite3.c"
      (_sqlite3_snprintf(20,$118,36105,$vararg_buffer13)|0); //@line 20666 "c/sqlite3.c"
      $127 = (_sqlite3Strlen30($118)|0); //@line 20667 "c/sqlite3.c"
      $128 = (($127) + ($$0118))|0; //@line 20667 "c/sqlite3.c"
      $$2120 = $128;$$3 = $70;
      break L35;
      break;
     }
     case 109:  {
      $129 = (($$0121) + ($$0118)|0); //@line 20670 "c/sqlite3.c"
      $130 = HEAP32[$62>>2]|0; //@line 20670 "c/sqlite3.c"
      HEAP32[$vararg_buffer16>>2] = $130; //@line 20670 "c/sqlite3.c"
      (_sqlite3_snprintf(3,$129,37802,$vararg_buffer16)|0); //@line 20670 "c/sqlite3.c"
      $131 = (($$0118) + 2)|0; //@line 20670 "c/sqlite3.c"
      $$2120 = $131;$$3 = $70;
      break L35;
      break;
     }
     case 77:  {
      $132 = (($$0121) + ($$0118)|0); //@line 20671 "c/sqlite3.c"
      $133 = HEAP32[$63>>2]|0; //@line 20671 "c/sqlite3.c"
      HEAP32[$vararg_buffer19>>2] = $133; //@line 20671 "c/sqlite3.c"
      (_sqlite3_snprintf(3,$132,37802,$vararg_buffer19)|0); //@line 20671 "c/sqlite3.c"
      $134 = (($$0118) + 2)|0; //@line 20671 "c/sqlite3.c"
      $$2120 = $134;$$3 = $70;
      break L35;
      break;
     }
     case 115:  {
      $135 = (($$0121) + ($$0118)|0); //@line 20673 "c/sqlite3.c"
      $136 = $3; //@line 20674 "c/sqlite3.c"
      $137 = $136; //@line 20674 "c/sqlite3.c"
      $138 = HEAP32[$137>>2]|0; //@line 20674 "c/sqlite3.c"
      $139 = (($136) + 4)|0; //@line 20674 "c/sqlite3.c"
      $140 = $139; //@line 20674 "c/sqlite3.c"
      $141 = HEAP32[$140>>2]|0; //@line 20674 "c/sqlite3.c"
      $142 = (___divdi3(($138|0),($141|0),1000,0)|0); //@line 20674 "c/sqlite3.c"
      $143 = tempRet0; //@line 20674 "c/sqlite3.c"
      $144 = (_i64Add(($142|0),($143|0),-413362496,-50)|0); //@line 20674 "c/sqlite3.c"
      $145 = tempRet0; //@line 20674 "c/sqlite3.c"
      $146 = $vararg_buffer22; //@line 20673 "c/sqlite3.c"
      $147 = $146; //@line 20673 "c/sqlite3.c"
      HEAP32[$147>>2] = $144; //@line 20673 "c/sqlite3.c"
      $148 = (($146) + 4)|0; //@line 20673 "c/sqlite3.c"
      $149 = $148; //@line 20673 "c/sqlite3.c"
      HEAP32[$149>>2] = $145; //@line 20673 "c/sqlite3.c"
      (_sqlite3_snprintf(30,$135,17149,$vararg_buffer22)|0); //@line 20673 "c/sqlite3.c"
      $150 = (_sqlite3Strlen30($135)|0); //@line 20675 "c/sqlite3.c"
      $151 = (($150) + ($$0118))|0; //@line 20675 "c/sqlite3.c"
      $$2120 = $151;$$3 = $70;
      break L35;
      break;
     }
     case 83:  {
      $152 = (($$0121) + ($$0118)|0); //@line 20678 "c/sqlite3.c"
      $153 = +HEAPF64[$64>>3]; //@line 20678 "c/sqlite3.c"
      $154 = (~~(($153))); //@line 20678 "c/sqlite3.c"
      HEAP32[$vararg_buffer25>>2] = $154; //@line 20678 "c/sqlite3.c"
      (_sqlite3_snprintf(3,$152,37802,$vararg_buffer25)|0); //@line 20678 "c/sqlite3.c"
      $155 = (($$0118) + 2)|0; //@line 20678 "c/sqlite3.c"
      $$2120 = $155;$$3 = $70;
      break L35;
      break;
     }
     case 119:  {
      $156 = $3; //@line 20680 "c/sqlite3.c"
      $157 = $156; //@line 20680 "c/sqlite3.c"
      $158 = HEAP32[$157>>2]|0; //@line 20680 "c/sqlite3.c"
      $159 = (($156) + 4)|0; //@line 20680 "c/sqlite3.c"
      $160 = $159; //@line 20680 "c/sqlite3.c"
      $161 = HEAP32[$160>>2]|0; //@line 20680 "c/sqlite3.c"
      $162 = (_i64Add(($158|0),($161|0),129600000,0)|0); //@line 20680 "c/sqlite3.c"
      $163 = tempRet0; //@line 20680 "c/sqlite3.c"
      $164 = (___divdi3(($162|0),($163|0),86400000,0)|0); //@line 20680 "c/sqlite3.c"
      $165 = tempRet0; //@line 20680 "c/sqlite3.c"
      $166 = (___remdi3(($164|0),($165|0),7,0)|0); //@line 20680 "c/sqlite3.c"
      $167 = tempRet0; //@line 20680 "c/sqlite3.c"
      $168 = (($166) + 48)|0; //@line 20680 "c/sqlite3.c"
      $169 = $168&255; //@line 20680 "c/sqlite3.c"
      $170 = (($$0118) + 1)|0; //@line 20680 "c/sqlite3.c"
      $171 = (($$0121) + ($$0118)|0); //@line 20680 "c/sqlite3.c"
      HEAP8[$171>>0] = $169; //@line 20680 "c/sqlite3.c"
      $$2120 = $170;$$3 = $70;
      break L35;
      break;
     }
     case 89:  {
      $172 = (($$0121) + ($$0118)|0); //@line 20684 "c/sqlite3.c"
      $173 = HEAP32[$65>>2]|0; //@line 20684 "c/sqlite3.c"
      HEAP32[$vararg_buffer28>>2] = $173; //@line 20684 "c/sqlite3.c"
      (_sqlite3_snprintf(5,$172,37819,$vararg_buffer28)|0); //@line 20684 "c/sqlite3.c"
      $174 = (_sqlite3Strlen30($172)|0); //@line 20684 "c/sqlite3.c"
      $175 = (($174) + ($$0118))|0; //@line 20684 "c/sqlite3.c"
      $$2120 = $175;$$3 = $70;
      break L35;
      break;
     }
     default: {
      $176 = (($$0118) + 1)|0; //@line 20687 "c/sqlite3.c"
      $177 = (($$0121) + ($$0118)|0); //@line 20687 "c/sqlite3.c"
      HEAP8[$177>>0] = 37; //@line 20687 "c/sqlite3.c"
      $$2120 = $176;$$3 = $70;
      break L35;
     }
     }
    } while(0);
    break;
   }
   default: {
    $68 = (($$0118) + 1)|0; //@line 20632 "c/sqlite3.c"
    $69 = (($$0121) + ($$0118)|0); //@line 20632 "c/sqlite3.c"
    HEAP8[$69>>0] = $67; //@line 20632 "c/sqlite3.c"
    $$2120 = $68;$$3 = $$2116;
   }
   }
  } while(0);
  $178 = (($$3) + 1)|0; //@line 20630 "c/sqlite3.c"
  $$0118 = $$2120;$$2116 = $178;
 }
 $179 = (($$0121) + ($$0118)|0); //@line 20691 "c/sqlite3.c"
 HEAP8[$179>>0] = 0; //@line 20691 "c/sqlite3.c"
 $180 = ($$0121|0)==($4|0); //@line 20693 "c/sqlite3.c"
 $181 = $180 ? (-1) : 157; //@line 20693 "c/sqlite3.c"
 _sqlite3_result_text($0,$$0121,-1,$181); //@line 20692 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 20694 "c/sqlite3.c"
}
function _ctimeFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _timeFunc($0,0,0); //@line 20707 "c/sqlite3.c"
 return; //@line 20708 "c/sqlite3.c"
}
function _ctimestampFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _datetimeFunc($0,0,0); //@line 20735 "c/sqlite3.c"
 return; //@line 20736 "c/sqlite3.c"
}
function _cdateFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _dateFunc($0,0,0); //@line 20721 "c/sqlite3.c"
 return; //@line 20722 "c/sqlite3.c"
}
function _isDate($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $$03637 = 0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$3; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 20440 "c/sqlite3.c"
 $4 = ($1|0)==(0); //@line 20441 "c/sqlite3.c"
 if ($4) {
  $5 = (_setDateTimeToCurrent($0,$3)|0); //@line 20442 "c/sqlite3.c"
  $$0 = $5;
  return ($$0|0); //@line 20461 "c/sqlite3.c"
 }
 $6 = HEAP32[$2>>2]|0; //@line 20444 "c/sqlite3.c"
 $7 = (_sqlite3_value_type($6)|0); //@line 20444 "c/sqlite3.c"
 $8 = (($7) + -1)|0; //@line 20445 "c/sqlite3.c"
 $9 = ($8>>>0)<(2); //@line 20445 "c/sqlite3.c"
 if ($9) {
  $10 = (+_sqlite3_value_double($6)); //@line 20446 "c/sqlite3.c"
  _setRawDateNumber($3,$10); //@line 20446 "c/sqlite3.c"
 } else {
  $11 = (_sqlite3_value_text($6)|0); //@line 20448 "c/sqlite3.c"
  $12 = ($11|0)==(0|0); //@line 20449 "c/sqlite3.c"
  if ($12) {
   $$0 = 1;
   return ($$0|0); //@line 20461 "c/sqlite3.c"
  }
  $13 = (_parseDateOrTime($0,$11,$3)|0); //@line 20449 "c/sqlite3.c"
  $14 = ($13|0)==(0); //@line 20449 "c/sqlite3.c"
  if (!($14)) {
   $$0 = 1;
   return ($$0|0); //@line 20461 "c/sqlite3.c"
  }
 }
 $15 = ($1|0)>(1); //@line 20453 "c/sqlite3.c"
 L13: do {
  if ($15) {
   $$03637 = 1;
   while(1) {
    $18 = (($2) + ($$03637<<2)|0); //@line 20454 "c/sqlite3.c"
    $19 = HEAP32[$18>>2]|0; //@line 20454 "c/sqlite3.c"
    $20 = (_sqlite3_value_text($19)|0); //@line 20454 "c/sqlite3.c"
    $21 = HEAP32[$18>>2]|0; //@line 20455 "c/sqlite3.c"
    (_sqlite3_value_bytes($21)|0); //@line 20455 "c/sqlite3.c"
    $22 = ($20|0)==(0|0); //@line 20456 "c/sqlite3.c"
    if ($22) {
     $$0 = 1;
     label = 14;
     break;
    }
    $23 = (_parseModifier($0,$20,$3)|0); //@line 20456 "c/sqlite3.c"
    $24 = ($23|0)==(0); //@line 20456 "c/sqlite3.c"
    $17 = (($$03637) + 1)|0; //@line 20453 "c/sqlite3.c"
    if (!($24)) {
     $$0 = 1;
     label = 14;
     break;
    }
    $16 = ($17|0)<($1|0); //@line 20453 "c/sqlite3.c"
    if ($16) {
     $$03637 = $17;
    } else {
     break L13;
    }
   }
   if ((label|0) == 14) {
    return ($$0|0); //@line 20461 "c/sqlite3.c"
   }
  }
 } while(0);
 _computeJD($3); //@line 20458 "c/sqlite3.c"
 $25 = ((($3)) + 46|0); //@line 20459 "c/sqlite3.c"
 $26 = HEAP8[$25>>0]|0; //@line 20459 "c/sqlite3.c"
 $27 = ($26<<24>>24)==(0); //@line 20459 "c/sqlite3.c"
 if ($27) {
  $28 = $3; //@line 20459 "c/sqlite3.c"
  $29 = $28; //@line 20459 "c/sqlite3.c"
  $30 = HEAP32[$29>>2]|0; //@line 20459 "c/sqlite3.c"
  $31 = (($28) + 4)|0; //@line 20459 "c/sqlite3.c"
  $32 = $31; //@line 20459 "c/sqlite3.c"
  $33 = HEAP32[$32>>2]|0; //@line 20459 "c/sqlite3.c"
  $34 = (_validJulianDay($30,$33)|0); //@line 20459 "c/sqlite3.c"
  $35 = ($34|0)==(0); //@line 20459 "c/sqlite3.c"
  $spec$select = $35&1; //@line 20459 "c/sqlite3.c"
  return ($spec$select|0); //@line 20459 "c/sqlite3.c"
 } else {
  $$0 = 1;
  return ($$0|0); //@line 20461 "c/sqlite3.c"
 }
 return (0)|0;
}
function _computeJD($0) {
 $0 = $0|0;
 var $$0$off = 0, $$04752 = 0, $$04951 = 0, $$053 = 0, $$1 = 0, $$148 = 0, $$neg = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 40|0); //@line 19812 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 19812 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 19812 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 19845 "c/sqlite3.c"
 }
 $4 = ((($0)) + 42|0); //@line 19813 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 19813 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 19813 "c/sqlite3.c"
 if ($6) {
  $$04752 = 1;$$04951 = 1;$$053 = 2000;
  label = 4;
 } else {
  $7 = ((($0)) + 8|0); //@line 19814 "c/sqlite3.c"
  $8 = HEAP32[$7>>2]|0; //@line 19814 "c/sqlite3.c"
  $9 = ((($0)) + 12|0); //@line 19815 "c/sqlite3.c"
  $10 = HEAP32[$9>>2]|0; //@line 19815 "c/sqlite3.c"
  $11 = ((($0)) + 16|0); //@line 19816 "c/sqlite3.c"
  $12 = HEAP32[$11>>2]|0; //@line 19816 "c/sqlite3.c"
  $$0$off = (($8) + 4713)|0; //@line 19822 "c/sqlite3.c"
  $13 = ($$0$off>>>0)>(14712); //@line 19822 "c/sqlite3.c"
  if (!($13)) {
   $$04752 = $10;$$04951 = $12;$$053 = $8;
   label = 4;
  }
 }
 if ((label|0) == 4) {
  $14 = ((($0)) + 41|0); //@line 19822 "c/sqlite3.c"
  $15 = HEAP8[$14>>0]|0; //@line 19822 "c/sqlite3.c"
  $16 = ($15<<24>>24)==(0); //@line 19822 "c/sqlite3.c"
  if ($16) {
   $17 = ($$04752|0)<(3); //@line 19826 "c/sqlite3.c"
   $18 = (($$04752) + 12)|0; //@line 19828 "c/sqlite3.c"
   $$148 = $17 ? $18 : $$04752; //@line 19826 "c/sqlite3.c"
   $19 = $17 << 31 >> 31; //@line 19826 "c/sqlite3.c"
   $$1 = (($$053) + ($19))|0; //@line 19826 "c/sqlite3.c"
   $$neg = (($$1|0) / -100)&-1;
   $20 = (($$1|0) / 400)&-1; //@line 19831 "c/sqlite3.c"
   $21 = ($$1*36525)|0; //@line 19832 "c/sqlite3.c"
   $22 = (($21) + 172251900)|0; //@line 19832 "c/sqlite3.c"
   $23 = (($22|0) / 100)&-1; //@line 19832 "c/sqlite3.c"
   $24 = ($$148*306001)|0; //@line 19833 "c/sqlite3.c"
   $25 = (($24) + 306001)|0; //@line 19833 "c/sqlite3.c"
   $26 = (($25|0) / 10000)&-1; //@line 19833 "c/sqlite3.c"
   $27 = (($$04951) + 2)|0; //@line 19834 "c/sqlite3.c"
   $28 = (($27) + ($$neg))|0; //@line 19834 "c/sqlite3.c"
   $29 = (($28) + ($20))|0; //@line 19831 "c/sqlite3.c"
   $30 = (($29) + ($26))|0; //@line 19831 "c/sqlite3.c"
   $31 = (($30) + ($23))|0; //@line 19834 "c/sqlite3.c"
   $32 = (+($31|0)); //@line 19834 "c/sqlite3.c"
   $33 = $32 + -1524.5; //@line 19834 "c/sqlite3.c"
   $34 = $33 * 8.64E+7; //@line 19834 "c/sqlite3.c"
   $35 = (~~$34)>>>0; //@line 19834 "c/sqlite3.c"
   $36 = +Math_abs($34) >= 1.0 ? $34 > 0.0 ? (~~+Math_min(+Math_floor($34 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($34 - +(~~$34 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 19834 "c/sqlite3.c"
   $37 = $0; //@line 19834 "c/sqlite3.c"
   $38 = $37; //@line 19834 "c/sqlite3.c"
   HEAP32[$38>>2] = $35; //@line 19834 "c/sqlite3.c"
   $39 = (($37) + 4)|0; //@line 19834 "c/sqlite3.c"
   $40 = $39; //@line 19834 "c/sqlite3.c"
   HEAP32[$40>>2] = $36; //@line 19834 "c/sqlite3.c"
   HEAP8[$1>>0] = 1; //@line 19835 "c/sqlite3.c"
   $41 = ((($0)) + 43|0); //@line 19836 "c/sqlite3.c"
   $42 = HEAP8[$41>>0]|0; //@line 19836 "c/sqlite3.c"
   $43 = ($42<<24>>24)==(0); //@line 19836 "c/sqlite3.c"
   if ($43) {
    return; //@line 19845 "c/sqlite3.c"
   }
   $44 = ((($0)) + 20|0); //@line 19837 "c/sqlite3.c"
   $45 = HEAP32[$44>>2]|0; //@line 19837 "c/sqlite3.c"
   $46 = Math_imul($45, 3600000)|0; //@line 19837 "c/sqlite3.c"
   $47 = ((($0)) + 24|0); //@line 19837 "c/sqlite3.c"
   $48 = HEAP32[$47>>2]|0; //@line 19837 "c/sqlite3.c"
   $49 = ($48*60000)|0; //@line 19837 "c/sqlite3.c"
   $50 = (($49) + ($46))|0; //@line 19837 "c/sqlite3.c"
   $51 = ($50|0)<(0); //@line 19837 "c/sqlite3.c"
   $52 = $51 << 31 >> 31; //@line 19837 "c/sqlite3.c"
   $53 = ((($0)) + 32|0); //@line 19837 "c/sqlite3.c"
   $54 = +HEAPF64[$53>>3]; //@line 19837 "c/sqlite3.c"
   $55 = $54 * 1000.0; //@line 19837 "c/sqlite3.c"
   $56 = (~~$55)>>>0; //@line 19837 "c/sqlite3.c"
   $57 = +Math_abs($55) >= 1.0 ? $55 > 0.0 ? (~~+Math_min(+Math_floor($55 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($55 - +(~~$55 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 19837 "c/sqlite3.c"
   $58 = (_i64Add(($56|0),($57|0),($35|0),($36|0))|0); //@line 19837 "c/sqlite3.c"
   $59 = tempRet0; //@line 19837 "c/sqlite3.c"
   $60 = (_i64Add(($58|0),($59|0),($50|0),($52|0))|0); //@line 19837 "c/sqlite3.c"
   $61 = tempRet0; //@line 19837 "c/sqlite3.c"
   $62 = $0; //@line 19837 "c/sqlite3.c"
   $63 = $62; //@line 19837 "c/sqlite3.c"
   HEAP32[$63>>2] = $60; //@line 19837 "c/sqlite3.c"
   $64 = (($62) + 4)|0; //@line 19837 "c/sqlite3.c"
   $65 = $64; //@line 19837 "c/sqlite3.c"
   HEAP32[$65>>2] = $61; //@line 19837 "c/sqlite3.c"
   $66 = ((($0)) + 44|0); //@line 19838 "c/sqlite3.c"
   $67 = HEAP8[$66>>0]|0; //@line 19838 "c/sqlite3.c"
   $68 = ($67<<24>>24)==(0); //@line 19838 "c/sqlite3.c"
   if ($68) {
    return; //@line 19845 "c/sqlite3.c"
   }
   $69 = ((($0)) + 28|0); //@line 19839 "c/sqlite3.c"
   $70 = HEAP32[$69>>2]|0; //@line 19839 "c/sqlite3.c"
   $71 = ($70*60000)|0; //@line 19839 "c/sqlite3.c"
   $72 = ($71|0)<(0); //@line 19839 "c/sqlite3.c"
   $73 = $72 << 31 >> 31; //@line 19839 "c/sqlite3.c"
   $74 = (_i64Subtract(($60|0),($61|0),($71|0),($73|0))|0); //@line 19839 "c/sqlite3.c"
   $75 = tempRet0; //@line 19839 "c/sqlite3.c"
   $76 = $0; //@line 19839 "c/sqlite3.c"
   $77 = $76; //@line 19839 "c/sqlite3.c"
   HEAP32[$77>>2] = $74; //@line 19839 "c/sqlite3.c"
   $78 = (($76) + 4)|0; //@line 19839 "c/sqlite3.c"
   $79 = $78; //@line 19839 "c/sqlite3.c"
   HEAP32[$79>>2] = $75; //@line 19839 "c/sqlite3.c"
   HEAP8[$4>>0] = 0; //@line 19840 "c/sqlite3.c"
   HEAP8[$41>>0] = 0; //@line 19841 "c/sqlite3.c"
   HEAP8[$66>>0] = 0; //@line 19842 "c/sqlite3.c"
   return; //@line 19845 "c/sqlite3.c"
  }
 }
 _datetimeError($0); //@line 19823 "c/sqlite3.c"
 return; //@line 19845 "c/sqlite3.c"
}
function _computeYMD_HMS($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 _computeYMD($0); //@line 20026 "c/sqlite3.c"
 _computeHMS($0); //@line 20027 "c/sqlite3.c"
 return; //@line 20028 "c/sqlite3.c"
}
function _computeYMD($0) {
 $0 = $0|0;
 var $$neg = 0, $$v = 0, $$v39 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0.0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0.0, $38 = 0.0, $39 = 0, $4 = 0, $40 = 0.0, $41 = 0.0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 42|0); //@line 19979 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 19979 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 19979 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 20001 "c/sqlite3.c"
 }
 $4 = ((($0)) + 40|0); //@line 19980 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 19980 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 19980 "c/sqlite3.c"
 do {
  if ($6) {
   $7 = ((($0)) + 8|0); //@line 19981 "c/sqlite3.c"
   HEAP32[$7>>2] = 2000; //@line 19981 "c/sqlite3.c"
   $8 = ((($0)) + 12|0); //@line 19982 "c/sqlite3.c"
   HEAP32[$8>>2] = 1; //@line 19982 "c/sqlite3.c"
   $9 = ((($0)) + 16|0); //@line 19983 "c/sqlite3.c"
   HEAP32[$9>>2] = 1; //@line 19983 "c/sqlite3.c"
  } else {
   $10 = $0; //@line 19984 "c/sqlite3.c"
   $11 = $10; //@line 19984 "c/sqlite3.c"
   $12 = HEAP32[$11>>2]|0; //@line 19984 "c/sqlite3.c"
   $13 = (($10) + 4)|0; //@line 19984 "c/sqlite3.c"
   $14 = $13; //@line 19984 "c/sqlite3.c"
   $15 = HEAP32[$14>>2]|0; //@line 19984 "c/sqlite3.c"
   $16 = (_validJulianDay($12,$15)|0); //@line 19984 "c/sqlite3.c"
   $17 = ($16|0)==(0); //@line 19984 "c/sqlite3.c"
   if (!($17)) {
    $18 = (_i64Add(($12|0),($15|0),43200000,0)|0); //@line 19988 "c/sqlite3.c"
    $19 = tempRet0; //@line 19988 "c/sqlite3.c"
    $20 = (___divdi3(($18|0),($19|0),86400000,0)|0); //@line 19988 "c/sqlite3.c"
    $21 = tempRet0; //@line 19988 "c/sqlite3.c"
    $22 = (+($20|0)); //@line 19989 "c/sqlite3.c"
    $23 = $22 + -1867216.25; //@line 19989 "c/sqlite3.c"
    $24 = $23 / 36524.25; //@line 19989 "c/sqlite3.c"
    $25 = (~~(($24))); //@line 19989 "c/sqlite3.c"
    $$neg = (($25|0) / -4)&-1;
    $26 = (($20) + 1525)|0; //@line 19990 "c/sqlite3.c"
    $27 = (($26) + ($25))|0; //@line 19990 "c/sqlite3.c"
    $28 = (($27) + ($$neg))|0; //@line 19991 "c/sqlite3.c"
    $29 = (+($28|0)); //@line 19992 "c/sqlite3.c"
    $30 = $29 + -122.09999999999999; //@line 19992 "c/sqlite3.c"
    $31 = $30 / 365.25; //@line 19992 "c/sqlite3.c"
    $32 = (~~(($31))); //@line 19992 "c/sqlite3.c"
    $33 = $32 & 32767; //@line 19993 "c/sqlite3.c"
    $34 = ($33*36525)|0; //@line 19993 "c/sqlite3.c"
    $35 = (($34>>>0) / 100)&-1; //@line 19993 "c/sqlite3.c"
    $36 = (($28) - ($35))|0; //@line 19994 "c/sqlite3.c"
    $37 = (+($36|0)); //@line 19994 "c/sqlite3.c"
    $38 = $37 / 30.600100000000001; //@line 19994 "c/sqlite3.c"
    $39 = (~~(($38))); //@line 19994 "c/sqlite3.c"
    $40 = (+($39|0)); //@line 19995 "c/sqlite3.c"
    $41 = $40 * 30.600100000000001; //@line 19995 "c/sqlite3.c"
    $42 = (~~(($41))); //@line 19995 "c/sqlite3.c"
    $43 = (($36) - ($42))|0; //@line 19996 "c/sqlite3.c"
    $44 = ((($0)) + 16|0); //@line 19996 "c/sqlite3.c"
    HEAP32[$44>>2] = $43; //@line 19996 "c/sqlite3.c"
    $45 = ($39|0)<(14); //@line 19997 "c/sqlite3.c"
    $$v = $45 ? -1 : -13; //@line 19997 "c/sqlite3.c"
    $46 = (($$v) + ($39))|0; //@line 19997 "c/sqlite3.c"
    $47 = ((($0)) + 12|0); //@line 19997 "c/sqlite3.c"
    HEAP32[$47>>2] = $46; //@line 19997 "c/sqlite3.c"
    $48 = ($46|0)>(2); //@line 19998 "c/sqlite3.c"
    $$v39 = $48 ? -4716 : -4715; //@line 19998 "c/sqlite3.c"
    $49 = (($$v39) + ($32))|0; //@line 19998 "c/sqlite3.c"
    $50 = ((($0)) + 8|0); //@line 19998 "c/sqlite3.c"
    HEAP32[$50>>2] = $49; //@line 19998 "c/sqlite3.c"
    break;
   }
   _datetimeError($0); //@line 19985 "c/sqlite3.c"
   return; //@line 20001 "c/sqlite3.c"
  }
 } while(0);
 HEAP8[$1>>0] = 1; //@line 20000 "c/sqlite3.c"
 return; //@line 20001 "c/sqlite3.c"
}
function _computeHMS($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 43|0); //@line 20008 "c/sqlite3.c"
 $2 = HEAP8[$1>>0]|0; //@line 20008 "c/sqlite3.c"
 $3 = ($2<<24>>24)==(0); //@line 20008 "c/sqlite3.c"
 if (!($3)) {
  return; //@line 20020 "c/sqlite3.c"
 }
 _computeJD($0); //@line 20009 "c/sqlite3.c"
 $4 = $0; //@line 20010 "c/sqlite3.c"
 $5 = $4; //@line 20010 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 20010 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 20010 "c/sqlite3.c"
 $8 = $7; //@line 20010 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 20010 "c/sqlite3.c"
 $10 = (_i64Add(($6|0),($9|0),43200000,0)|0); //@line 20010 "c/sqlite3.c"
 $11 = tempRet0; //@line 20010 "c/sqlite3.c"
 $12 = (___remdi3(($10|0),($11|0),86400000,0)|0); //@line 20010 "c/sqlite3.c"
 $13 = tempRet0; //@line 20010 "c/sqlite3.c"
 $14 = (+($12|0)); //@line 20011 "c/sqlite3.c"
 $15 = $14 / 1000.0; //@line 20011 "c/sqlite3.c"
 $16 = ((($0)) + 32|0); //@line 20011 "c/sqlite3.c"
 $17 = (~~(($15))); //@line 20012 "c/sqlite3.c"
 $18 = (+($17|0)); //@line 20013 "c/sqlite3.c"
 $19 = $15 - $18; //@line 20013 "c/sqlite3.c"
 $20 = (($17|0) / 3600)&-1; //@line 20014 "c/sqlite3.c"
 $21 = ((($0)) + 20|0); //@line 20014 "c/sqlite3.c"
 HEAP32[$21>>2] = $20; //@line 20014 "c/sqlite3.c"
 $22 = Math_imul($20, -3600)|0; //@line 20015 "c/sqlite3.c"
 $23 = (($22) + ($17))|0; //@line 20015 "c/sqlite3.c"
 $24 = (($23|0) / 60)&-1; //@line 20016 "c/sqlite3.c"
 $25 = ((($0)) + 24|0); //@line 20016 "c/sqlite3.c"
 HEAP32[$25>>2] = $24; //@line 20016 "c/sqlite3.c"
 $26 = Math_imul($24, -60)|0; //@line 20017 "c/sqlite3.c"
 $27 = (($26) + ($23))|0; //@line 20017 "c/sqlite3.c"
 $28 = (+($27|0)); //@line 20017 "c/sqlite3.c"
 $29 = $19 + $28; //@line 20017 "c/sqlite3.c"
 HEAPF64[$16>>3] = $29; //@line 20017 "c/sqlite3.c"
 $30 = ((($0)) + 41|0); //@line 20018 "c/sqlite3.c"
 HEAP8[$30>>0] = 0; //@line 20018 "c/sqlite3.c"
 HEAP8[$1>>0] = 1; //@line 20019 "c/sqlite3.c"
 return; //@line 20020 "c/sqlite3.c"
}
function _validJulianDay($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1>>>0)<(108096); //@line 19971 "c/sqlite3.c"
 $3 = ($0>>>0)<(275971584); //@line 19971 "c/sqlite3.c"
 $4 = ($1|0)==(108096); //@line 19971 "c/sqlite3.c"
 $5 = $4 & $3; //@line 19971 "c/sqlite3.c"
 $6 = $2 | $5; //@line 19971 "c/sqlite3.c"
 $7 = $6&1; //@line 19971 "c/sqlite3.c"
 return ($7|0); //@line 19971 "c/sqlite3.c"
}
function _datetimeError($0) {
 $0 = $0|0;
 var $1 = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$0; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 19799 "c/sqlite3.c"
 $1 = ((($0)) + 46|0); //@line 19800 "c/sqlite3.c"
 HEAP8[$1>>0] = 1; //@line 19800 "c/sqlite3.c"
 return; //@line 19801 "c/sqlite3.c"
}
function _setDateTimeToCurrent($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (_sqlite3StmtCurrentTime($0)|0); //@line 19897 "c/sqlite3.c"
 $3 = tempRet0; //@line 19897 "c/sqlite3.c"
 $4 = $1; //@line 19897 "c/sqlite3.c"
 $5 = $4; //@line 19897 "c/sqlite3.c"
 HEAP32[$5>>2] = $2; //@line 19897 "c/sqlite3.c"
 $6 = (($4) + 4)|0; //@line 19897 "c/sqlite3.c"
 $7 = $6; //@line 19897 "c/sqlite3.c"
 HEAP32[$7>>2] = $3; //@line 19897 "c/sqlite3.c"
 $8 = ($3|0)>(0); //@line 19898 "c/sqlite3.c"
 $9 = ($2>>>0)>(0); //@line 19898 "c/sqlite3.c"
 $10 = ($3|0)==(0); //@line 19898 "c/sqlite3.c"
 $11 = $10 & $9; //@line 19898 "c/sqlite3.c"
 $12 = $8 | $11; //@line 19898 "c/sqlite3.c"
 if (!($12)) {
  $$0 = 1;
  return ($$0|0); //@line 19904 "c/sqlite3.c"
 }
 $13 = ((($1)) + 40|0); //@line 19899 "c/sqlite3.c"
 HEAP8[$13>>0] = 1; //@line 19899 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 19904 "c/sqlite3.c"
}
function _setRawDateNumber($0,$1) {
 $0 = $0|0;
 $1 = +$1;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 32|0); //@line 19913 "c/sqlite3.c"
 HEAPF64[$2>>3] = $1; //@line 19913 "c/sqlite3.c"
 $3 = ((($0)) + 41|0); //@line 19914 "c/sqlite3.c"
 HEAP8[$3>>0] = 1; //@line 19914 "c/sqlite3.c"
 $4 = $1 >= 0.0; //@line 19915 "c/sqlite3.c"
 $5 = $1 < 5373484.5; //@line 19915 "c/sqlite3.c"
 $or$cond = $4 & $5; //@line 19915 "c/sqlite3.c"
 if (!($or$cond)) {
  return; //@line 19919 "c/sqlite3.c"
 }
 $6 = ((($0)) + 40|0); //@line 19917 "c/sqlite3.c"
 $7 = $1 * 8.64E+7; //@line 19916 "c/sqlite3.c"
 $8 = $7 + 0.5; //@line 19916 "c/sqlite3.c"
 $9 = (~~$8)>>>0; //@line 19916 "c/sqlite3.c"
 $10 = +Math_abs($8) >= 1.0 ? $8 > 0.0 ? (~~+Math_min(+Math_floor($8 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($8 - +(~~$8 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 19916 "c/sqlite3.c"
 $11 = $0; //@line 19916 "c/sqlite3.c"
 $12 = $11; //@line 19916 "c/sqlite3.c"
 HEAP32[$12>>2] = $9; //@line 19916 "c/sqlite3.c"
 $13 = (($11) + 4)|0; //@line 19916 "c/sqlite3.c"
 $14 = $13; //@line 19916 "c/sqlite3.c"
 HEAP32[$14>>2] = $10; //@line 19916 "c/sqlite3.c"
 HEAP8[$6>>0] = 1; //@line 19917 "c/sqlite3.c"
 return; //@line 19919 "c/sqlite3.c"
}
function _parseDateOrTime($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $3 = sp;
 $4 = (_parseYyyyMmDd($1,$2)|0); //@line 19943 "c/sqlite3.c"
 $5 = ($4|0)==(0); //@line 19943 "c/sqlite3.c"
 do {
  if ($5) {
   $$0 = 0;
  } else {
   $6 = (_parseHhMmSs($1,$2)|0); //@line 19945 "c/sqlite3.c"
   $7 = ($6|0)==(0); //@line 19945 "c/sqlite3.c"
   if ($7) {
    $$0 = 0;
   } else {
    $8 = (_sqlite3StrICmp($1,38011)|0); //@line 19947 "c/sqlite3.c"
    $9 = ($8|0)==(0); //@line 19947 "c/sqlite3.c"
    if ($9) {
     $10 = (_sqlite3NotPureFunc($0)|0); //@line 19947 "c/sqlite3.c"
     $11 = ($10|0)==(0); //@line 19947 "c/sqlite3.c"
     if (!($11)) {
      $12 = (_setDateTimeToCurrent($0,$2)|0); //@line 19948 "c/sqlite3.c"
      $$0 = $12;
      break;
     }
    }
    $13 = (_sqlite3Strlen30($1)|0); //@line 19949 "c/sqlite3.c"
    $14 = (_sqlite3AtoF($1,$3,$13,1)|0); //@line 19949 "c/sqlite3.c"
    $15 = ($14|0)==(0); //@line 19949 "c/sqlite3.c"
    if ($15) {
     $$0 = 1;
    } else {
     $16 = +HEAPF64[$3>>3]; //@line 19950 "c/sqlite3.c"
     _setRawDateNumber($2,$16); //@line 19950 "c/sqlite3.c"
     $$0 = 0;
    }
   }
  }
 } while(0);
 STACKTOP = sp;return ($$0|0); //@line 19954 "c/sqlite3.c"
}
function _parseModifier($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$0144 = 0, $$01476$lcssa = 0, $$in = 0, $$in$v = 0, $$off = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0;
 var $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0;
 var $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0;
 var $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0;
 var $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0;
 var $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0.0, $234 = 0, $235 = 0.0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0.0, $255 = 0.0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0.0, $262 = 0.0, $263 = 0.0, $264 = 0, $265 = 0.0, $266 = 0.0, $267 = 0.0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0;
 var $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0, $38 = 0, $39 = 0;
 var $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0;
 var $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0;
 var $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0.0, $92 = 0, $93 = 0.0;
 var $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0, $or$cond3 = 0, $or$cond4 = 0, $or$cond4$1 = 0, $or$cond4$2 = 0, $or$cond4$3 = 0, $or$cond4$4 = 0, $or$cond4$5 = 0, $or$cond5 = 0, $spec$select1 = 0, $spec$select2 = 0, dest = 0, label = 0, sp = 0;
 var stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $3 = sp + 56|0;
 $4 = sp + 48|0;
 $5 = sp;
 HEAP32[$3>>2] = 1; //@line 20220 "c/sqlite3.c"
 $6 = HEAP8[$1>>0]|0; //@line 20222 "c/sqlite3.c"
 $7 = $6&255; //@line 20222 "c/sqlite3.c"
 $8 = (16025 + ($7)|0); //@line 20222 "c/sqlite3.c"
 $9 = HEAP8[$8>>0]|0; //@line 20222 "c/sqlite3.c"
 switch ($9<<24>>24) {
 case 108:  {
  $10 = (_sqlite3_stricmp($1,37824)|0); //@line 20230 "c/sqlite3.c"
  $11 = ($10|0)==(0); //@line 20230 "c/sqlite3.c"
  if (!($11)) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $12 = (_sqlite3NotPureFunc($0)|0); //@line 20230 "c/sqlite3.c"
  $13 = ($12|0)==(0); //@line 20230 "c/sqlite3.c"
  if ($13) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  _computeJD($2); //@line 20231 "c/sqlite3.c"
  $14 = (_localtimeOffset($2,$0,$3)|0); //@line 20232 "c/sqlite3.c"
  $15 = tempRet0; //@line 20232 "c/sqlite3.c"
  $16 = $2; //@line 20232 "c/sqlite3.c"
  $17 = $16; //@line 20232 "c/sqlite3.c"
  $18 = HEAP32[$17>>2]|0; //@line 20232 "c/sqlite3.c"
  $19 = (($16) + 4)|0; //@line 20232 "c/sqlite3.c"
  $20 = $19; //@line 20232 "c/sqlite3.c"
  $21 = HEAP32[$20>>2]|0; //@line 20232 "c/sqlite3.c"
  $22 = (_i64Add(($18|0),($21|0),($14|0),($15|0))|0); //@line 20232 "c/sqlite3.c"
  $23 = tempRet0; //@line 20232 "c/sqlite3.c"
  $24 = $2; //@line 20232 "c/sqlite3.c"
  $25 = $24; //@line 20232 "c/sqlite3.c"
  HEAP32[$25>>2] = $22; //@line 20232 "c/sqlite3.c"
  $26 = (($24) + 4)|0; //@line 20232 "c/sqlite3.c"
  $27 = $26; //@line 20232 "c/sqlite3.c"
  HEAP32[$27>>2] = $23; //@line 20232 "c/sqlite3.c"
  _clearYMD_HMS_TZ($2); //@line 20233 "c/sqlite3.c"
  $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
  STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  break;
 }
 case 117:  {
  $28 = (_sqlite3_stricmp($1,37834)|0); //@line 20245 "c/sqlite3.c"
  $29 = ($28|0)==(0); //@line 20245 "c/sqlite3.c"
  if ($29) {
   $30 = ((($2)) + 41|0); //@line 20245 "c/sqlite3.c"
   $31 = HEAP8[$30>>0]|0; //@line 20245 "c/sqlite3.c"
   $32 = ($31<<24>>24)==(0); //@line 20245 "c/sqlite3.c"
   if (!($32)) {
    $33 = ((($2)) + 32|0); //@line 20246 "c/sqlite3.c"
    $34 = +HEAPF64[$33>>3]; //@line 20246 "c/sqlite3.c"
    $35 = $34 * 1000.0; //@line 20246 "c/sqlite3.c"
    $36 = $35 + 2.1086676E+14; //@line 20246 "c/sqlite3.c"
    HEAPF64[$4>>3] = $36; //@line 20246 "c/sqlite3.c"
    $37 = $36 >= 0.0; //@line 20247 "c/sqlite3.c"
    $38 = $36 < 4.642690608E+14; //@line 20247 "c/sqlite3.c"
    $or$cond = $37 & $38; //@line 20247 "c/sqlite3.c"
    if (!($or$cond)) {
     $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
     STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
    }
    _clearYMD_HMS_TZ($2); //@line 20248 "c/sqlite3.c"
    $39 = (~~$36)>>>0; //@line 20249 "c/sqlite3.c"
    $40 = +Math_abs($36) >= 1.0 ? $36 > 0.0 ? (~~+Math_min(+Math_floor($36 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($36 - +(~~$36 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 20249 "c/sqlite3.c"
    $41 = $2; //@line 20249 "c/sqlite3.c"
    $42 = $41; //@line 20249 "c/sqlite3.c"
    HEAP32[$42>>2] = $39; //@line 20249 "c/sqlite3.c"
    $43 = (($41) + 4)|0; //@line 20249 "c/sqlite3.c"
    $44 = $43; //@line 20249 "c/sqlite3.c"
    HEAP32[$44>>2] = $40; //@line 20249 "c/sqlite3.c"
    $45 = ((($2)) + 40|0); //@line 20250 "c/sqlite3.c"
    HEAP8[$45>>0] = 1; //@line 20250 "c/sqlite3.c"
    HEAP8[$30>>0] = 0; //@line 20251 "c/sqlite3.c"
    HEAP32[$3>>2] = 0; //@line 20252 "c/sqlite3.c"
    $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
    STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
   }
  }
  $46 = (_sqlite3_stricmp($1,37844)|0); //@line 20256 "c/sqlite3.c"
  $47 = ($46|0)==(0); //@line 20256 "c/sqlite3.c"
  if (!($47)) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $48 = (_sqlite3NotPureFunc($0)|0); //@line 20256 "c/sqlite3.c"
  $49 = ($48|0)==(0); //@line 20256 "c/sqlite3.c"
  if ($49) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $50 = ((($2)) + 45|0); //@line 20257 "c/sqlite3.c"
  $51 = HEAP8[$50>>0]|0; //@line 20257 "c/sqlite3.c"
  $52 = ($51<<24>>24)==(0); //@line 20257 "c/sqlite3.c"
  if (!($52)) {
   HEAP32[$3>>2] = 0; //@line 20268 "c/sqlite3.c"
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  _computeJD($2); //@line 20259 "c/sqlite3.c"
  $53 = (_localtimeOffset($2,$0,$3)|0); //@line 20260 "c/sqlite3.c"
  $54 = tempRet0; //@line 20260 "c/sqlite3.c"
  $55 = HEAP32[$3>>2]|0; //@line 20261 "c/sqlite3.c"
  $56 = ($55|0)==(0); //@line 20261 "c/sqlite3.c"
  if ($56) {
   $57 = $2; //@line 20262 "c/sqlite3.c"
   $58 = $57; //@line 20262 "c/sqlite3.c"
   $59 = HEAP32[$58>>2]|0; //@line 20262 "c/sqlite3.c"
   $60 = (($57) + 4)|0; //@line 20262 "c/sqlite3.c"
   $61 = $60; //@line 20262 "c/sqlite3.c"
   $62 = HEAP32[$61>>2]|0; //@line 20262 "c/sqlite3.c"
   $63 = (_i64Subtract(($59|0),($62|0),($53|0),($54|0))|0); //@line 20262 "c/sqlite3.c"
   $64 = tempRet0; //@line 20262 "c/sqlite3.c"
   $65 = $2; //@line 20262 "c/sqlite3.c"
   $66 = $65; //@line 20262 "c/sqlite3.c"
   HEAP32[$66>>2] = $63; //@line 20262 "c/sqlite3.c"
   $67 = (($65) + 4)|0; //@line 20262 "c/sqlite3.c"
   $68 = $67; //@line 20262 "c/sqlite3.c"
   HEAP32[$68>>2] = $64; //@line 20262 "c/sqlite3.c"
   _clearYMD_HMS_TZ($2); //@line 20263 "c/sqlite3.c"
   $69 = (_localtimeOffset($2,$0,$3)|0); //@line 20264 "c/sqlite3.c"
   $70 = tempRet0; //@line 20264 "c/sqlite3.c"
   $71 = (_i64Subtract(($53|0),($54|0),($69|0),($70|0))|0); //@line 20264 "c/sqlite3.c"
   $72 = tempRet0; //@line 20264 "c/sqlite3.c"
   $73 = $2; //@line 20264 "c/sqlite3.c"
   $74 = $73; //@line 20264 "c/sqlite3.c"
   $75 = HEAP32[$74>>2]|0; //@line 20264 "c/sqlite3.c"
   $76 = (($73) + 4)|0; //@line 20264 "c/sqlite3.c"
   $77 = $76; //@line 20264 "c/sqlite3.c"
   $78 = HEAP32[$77>>2]|0; //@line 20264 "c/sqlite3.c"
   $79 = (_i64Add(($71|0),($72|0),($75|0),($78|0))|0); //@line 20264 "c/sqlite3.c"
   $80 = tempRet0; //@line 20264 "c/sqlite3.c"
   $81 = $2; //@line 20264 "c/sqlite3.c"
   $82 = $81; //@line 20264 "c/sqlite3.c"
   HEAP32[$82>>2] = $79; //@line 20264 "c/sqlite3.c"
   $83 = (($81) + 4)|0; //@line 20264 "c/sqlite3.c"
   $84 = $83; //@line 20264 "c/sqlite3.c"
   HEAP32[$84>>2] = $80; //@line 20264 "c/sqlite3.c"
  }
  HEAP8[$50>>0] = 1; //@line 20266 "c/sqlite3.c"
  $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
  STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  break;
 }
 case 119:  {
  $85 = (_sqlite3_strnicmp($1,37848,8)|0); //@line 20282 "c/sqlite3.c"
  $86 = ($85|0)==(0); //@line 20282 "c/sqlite3.c"
  if (!($86)) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $87 = ((($1)) + 8|0); //@line 20283 "c/sqlite3.c"
  $88 = (_sqlite3Strlen30($87)|0); //@line 20283 "c/sqlite3.c"
  $89 = (_sqlite3AtoF($87,$4,$88,1)|0); //@line 20283 "c/sqlite3.c"
  $90 = ($89|0)==(0); //@line 20283 "c/sqlite3.c"
  if ($90) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $91 = +HEAPF64[$4>>3]; //@line 20284 "c/sqlite3.c"
  $92 = (~~(($91))); //@line 20284 "c/sqlite3.c"
  $93 = (+($92|0)); //@line 20284 "c/sqlite3.c"
  $94 = $91 == $93; //@line 20284 "c/sqlite3.c"
  $95 = ($92|0)>(-1); //@line 20284 "c/sqlite3.c"
  $or$cond3 = $95 & $94; //@line 20284 "c/sqlite3.c"
  $96 = $91 < 7.0; //@line 20284 "c/sqlite3.c"
  $or$cond5 = $96 & $or$cond3; //@line 20284 "c/sqlite3.c"
  if (!($or$cond5)) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  _computeYMD_HMS($2); //@line 20286 "c/sqlite3.c"
  $97 = ((($2)) + 44|0); //@line 20287 "c/sqlite3.c"
  HEAP8[$97>>0] = 0; //@line 20287 "c/sqlite3.c"
  $98 = ((($2)) + 40|0); //@line 20288 "c/sqlite3.c"
  HEAP8[$98>>0] = 0; //@line 20288 "c/sqlite3.c"
  _computeJD($2); //@line 20289 "c/sqlite3.c"
  $99 = $2; //@line 20290 "c/sqlite3.c"
  $100 = $99; //@line 20290 "c/sqlite3.c"
  $101 = HEAP32[$100>>2]|0; //@line 20290 "c/sqlite3.c"
  $102 = (($99) + 4)|0; //@line 20290 "c/sqlite3.c"
  $103 = $102; //@line 20290 "c/sqlite3.c"
  $104 = HEAP32[$103>>2]|0; //@line 20290 "c/sqlite3.c"
  $105 = (_i64Add(($101|0),($104|0),129600000,0)|0); //@line 20290 "c/sqlite3.c"
  $106 = tempRet0; //@line 20290 "c/sqlite3.c"
  $107 = (___divdi3(($105|0),($106|0),86400000,0)|0); //@line 20290 "c/sqlite3.c"
  $108 = tempRet0; //@line 20290 "c/sqlite3.c"
  $109 = (___remdi3(($107|0),($108|0),7,0)|0); //@line 20290 "c/sqlite3.c"
  $110 = tempRet0; //@line 20290 "c/sqlite3.c"
  $111 = ($92|0)<(0); //@line 20291 "c/sqlite3.c"
  $112 = $111 << 31 >> 31; //@line 20291 "c/sqlite3.c"
  $113 = ($110|0)>($112|0); //@line 20291 "c/sqlite3.c"
  $114 = ($109>>>0)>($92>>>0); //@line 20291 "c/sqlite3.c"
  $115 = ($110|0)==($112|0); //@line 20291 "c/sqlite3.c"
  $116 = $115 & $114; //@line 20291 "c/sqlite3.c"
  $117 = $113 | $116; //@line 20291 "c/sqlite3.c"
  $118 = (_i64Add(($109|0),($110|0),-7,-1)|0); //@line 20291 "c/sqlite3.c"
  $119 = tempRet0; //@line 20291 "c/sqlite3.c"
  $120 = $117 ? $118 : $109; //@line 20291 "c/sqlite3.c"
  $121 = $117 ? $119 : $110; //@line 20291 "c/sqlite3.c"
  $122 = (_i64Subtract(($92|0),($112|0),($120|0),($121|0))|0); //@line 20292 "c/sqlite3.c"
  $123 = tempRet0; //@line 20292 "c/sqlite3.c"
  $124 = (___muldi3(($122|0),($123|0),86400000,0)|0); //@line 20292 "c/sqlite3.c"
  $125 = tempRet0; //@line 20292 "c/sqlite3.c"
  $126 = (_i64Add(($124|0),($125|0),($101|0),($104|0))|0); //@line 20292 "c/sqlite3.c"
  $127 = tempRet0; //@line 20292 "c/sqlite3.c"
  $128 = $2; //@line 20292 "c/sqlite3.c"
  $129 = $128; //@line 20292 "c/sqlite3.c"
  HEAP32[$129>>2] = $126; //@line 20292 "c/sqlite3.c"
  $130 = (($128) + 4)|0; //@line 20292 "c/sqlite3.c"
  $131 = $130; //@line 20292 "c/sqlite3.c"
  HEAP32[$131>>2] = $127; //@line 20292 "c/sqlite3.c"
  _clearYMD_HMS_TZ($2); //@line 20293 "c/sqlite3.c"
  HEAP32[$3>>2] = 0; //@line 20294 "c/sqlite3.c"
  $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
  STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  break;
 }
 case 115:  {
  $132 = (_sqlite3_strnicmp($1,37857,9)|0); //@line 20305 "c/sqlite3.c"
  $133 = ($132|0)==(0); //@line 20305 "c/sqlite3.c"
  if (!($133)) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $134 = ((($2)) + 40|0); //@line 20306 "c/sqlite3.c"
  $135 = HEAP8[$134>>0]|0; //@line 20306 "c/sqlite3.c"
  $136 = ($135<<24>>24)==(0); //@line 20306 "c/sqlite3.c"
  if ($136) {
   $137 = ((($2)) + 42|0); //@line 20306 "c/sqlite3.c"
   $138 = HEAP8[$137>>0]|0; //@line 20306 "c/sqlite3.c"
   $139 = ($138<<24>>24)==(0); //@line 20306 "c/sqlite3.c"
   if ($139) {
    $140 = ((($2)) + 43|0); //@line 20306 "c/sqlite3.c"
    $141 = HEAP8[$140>>0]|0; //@line 20306 "c/sqlite3.c"
    $142 = ($141<<24>>24)==(0); //@line 20306 "c/sqlite3.c"
    if ($142) {
     $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
     STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
    }
   }
  }
  $143 = ((($1)) + 9|0); //@line 20307 "c/sqlite3.c"
  _computeYMD($2); //@line 20308 "c/sqlite3.c"
  $144 = ((($2)) + 43|0); //@line 20309 "c/sqlite3.c"
  HEAP8[$144>>0] = 1; //@line 20309 "c/sqlite3.c"
  $145 = ((($2)) + 24|0); //@line 20310 "c/sqlite3.c"
  HEAP32[$145>>2] = 0; //@line 20310 "c/sqlite3.c"
  $146 = ((($2)) + 20|0); //@line 20310 "c/sqlite3.c"
  HEAP32[$146>>2] = 0; //@line 20310 "c/sqlite3.c"
  $147 = ((($2)) + 32|0); //@line 20311 "c/sqlite3.c"
  HEAPF64[$147>>3] = 0.0; //@line 20311 "c/sqlite3.c"
  $148 = ((($2)) + 41|0); //@line 20312 "c/sqlite3.c"
  HEAP8[$148>>0] = 0; //@line 20312 "c/sqlite3.c"
  $149 = ((($2)) + 44|0); //@line 20313 "c/sqlite3.c"
  HEAP8[$149>>0] = 0; //@line 20313 "c/sqlite3.c"
  HEAP8[$134>>0] = 0; //@line 20314 "c/sqlite3.c"
  $150 = (_sqlite3_stricmp($143,37867)|0); //@line 20315 "c/sqlite3.c"
  $151 = ($150|0)==(0); //@line 20315 "c/sqlite3.c"
  if ($151) {
   $152 = ((($2)) + 16|0); //@line 20316 "c/sqlite3.c"
   HEAP32[$152>>2] = 1; //@line 20316 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 20317 "c/sqlite3.c"
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $153 = (_sqlite3_stricmp($143,37873)|0); //@line 20318 "c/sqlite3.c"
  $154 = ($153|0)==(0); //@line 20318 "c/sqlite3.c"
  if ($154) {
   $155 = ((($2)) + 12|0); //@line 20319 "c/sqlite3.c"
   HEAP32[$155>>2] = 1; //@line 20319 "c/sqlite3.c"
   $156 = ((($2)) + 16|0); //@line 20320 "c/sqlite3.c"
   HEAP32[$156>>2] = 1; //@line 20320 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 20321 "c/sqlite3.c"
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $157 = (_sqlite3_stricmp($143,37878)|0); //@line 20322 "c/sqlite3.c"
  $158 = ($157|0)==(0); //@line 20322 "c/sqlite3.c"
  if (!($158)) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  HEAP32[$3>>2] = 0; //@line 20323 "c/sqlite3.c"
  $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
  STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  break;
 }
 case 57: case 56: case 55: case 54: case 53: case 52: case 51: case 50: case 49: case 48: case 45: case 43:  {
  $$0144 = 1;
  L66: while(1) {
   $159 = (($1) + ($$0144)|0); //@line 20341 "c/sqlite3.c"
   $160 = HEAP8[$159>>0]|0; //@line 20341 "c/sqlite3.c"
   switch ($160<<24>>24) {
   case 58: case 0:  {
    break L66;
    break;
   }
   default: {
   }
   }
   $161 = $160&255; //@line 20341 "c/sqlite3.c"
   $162 = (16281 + ($161)|0); //@line 20341 "c/sqlite3.c"
   $163 = HEAP8[$162>>0]|0; //@line 20341 "c/sqlite3.c"
   $164 = $163 & 1; //@line 20341 "c/sqlite3.c"
   $165 = ($164<<24>>24)==(0); //@line 20341 "c/sqlite3.c"
   if (!($165)) {
    break;
   }
   $166 = (($$0144) + 1)|0; //@line 20341 "c/sqlite3.c"
   $$0144 = $166;
  }
  $167 = (($1) + ($$0144)|0); //@line 20341 "c/sqlite3.c"
  $168 = (_sqlite3AtoF($1,$4,$$0144,1)|0); //@line 20342 "c/sqlite3.c"
  $169 = ($168|0)==(0); //@line 20342 "c/sqlite3.c"
  if ($169) {
   HEAP32[$3>>2] = 1; //@line 20343 "c/sqlite3.c"
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $170 = HEAP8[$167>>0]|0; //@line 20346 "c/sqlite3.c"
  $171 = ($170<<24>>24)==(58); //@line 20346 "c/sqlite3.c"
  if ($171) {
   $172 = HEAP8[$1>>0]|0; //@line 20355 "c/sqlite3.c"
   $173 = $172&255; //@line 20355 "c/sqlite3.c"
   $174 = (($173) + -48)|0; //@line 20355 "c/sqlite3.c"
   $175 = ($174>>>0)<(10); //@line 20355 "c/sqlite3.c"
   $176 = ((($1)) + 1|0); //@line 20355 "c/sqlite3.c"
   $spec$select1 = $175 ? $1 : $176; //@line 20355 "c/sqlite3.c"
   dest=$5; stop=dest+48|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 20356 "c/sqlite3.c"
   $177 = (_parseHhMmSs($spec$select1,$5)|0); //@line 20357 "c/sqlite3.c"
   $178 = ($177|0)==(0); //@line 20357 "c/sqlite3.c"
   if ($178) {
    _computeJD($5); //@line 20358 "c/sqlite3.c"
    $179 = $5; //@line 20359 "c/sqlite3.c"
    $180 = $179; //@line 20359 "c/sqlite3.c"
    $181 = HEAP32[$180>>2]|0; //@line 20359 "c/sqlite3.c"
    $182 = (($179) + 4)|0; //@line 20359 "c/sqlite3.c"
    $183 = $182; //@line 20359 "c/sqlite3.c"
    $184 = HEAP32[$183>>2]|0; //@line 20359 "c/sqlite3.c"
    $185 = (_i64Add(($181|0),($184|0),-43200000,-1)|0); //@line 20359 "c/sqlite3.c"
    $186 = tempRet0; //@line 20359 "c/sqlite3.c"
    $187 = (___remdi3(($185|0),($186|0),86400000,0)|0); //@line 20361 "c/sqlite3.c"
    $188 = tempRet0; //@line 20361 "c/sqlite3.c"
    $189 = $5; //@line 20361 "c/sqlite3.c"
    $190 = $189; //@line 20361 "c/sqlite3.c"
    HEAP32[$190>>2] = $187; //@line 20361 "c/sqlite3.c"
    $191 = (($189) + 4)|0; //@line 20361 "c/sqlite3.c"
    $192 = $191; //@line 20361 "c/sqlite3.c"
    HEAP32[$192>>2] = $188; //@line 20361 "c/sqlite3.c"
    $193 = HEAP8[$1>>0]|0; //@line 20362 "c/sqlite3.c"
    $194 = ($193<<24>>24)==(45); //@line 20362 "c/sqlite3.c"
    if ($194) {
     $195 = (_i64Subtract(0,0,($187|0),($188|0))|0); //@line 20362 "c/sqlite3.c"
     $196 = tempRet0; //@line 20362 "c/sqlite3.c"
     $197 = $5; //@line 20362 "c/sqlite3.c"
     $198 = $197; //@line 20362 "c/sqlite3.c"
     HEAP32[$198>>2] = $195; //@line 20362 "c/sqlite3.c"
     $199 = (($197) + 4)|0; //@line 20362 "c/sqlite3.c"
     $200 = $199; //@line 20362 "c/sqlite3.c"
     HEAP32[$200>>2] = $196; //@line 20362 "c/sqlite3.c"
    }
    _computeJD($2); //@line 20363 "c/sqlite3.c"
    _clearYMD_HMS_TZ($2); //@line 20364 "c/sqlite3.c"
    $201 = $5; //@line 20365 "c/sqlite3.c"
    $202 = $201; //@line 20365 "c/sqlite3.c"
    $203 = HEAP32[$202>>2]|0; //@line 20365 "c/sqlite3.c"
    $204 = (($201) + 4)|0; //@line 20365 "c/sqlite3.c"
    $205 = $204; //@line 20365 "c/sqlite3.c"
    $206 = HEAP32[$205>>2]|0; //@line 20365 "c/sqlite3.c"
    $207 = $2; //@line 20365 "c/sqlite3.c"
    $208 = $207; //@line 20365 "c/sqlite3.c"
    $209 = HEAP32[$208>>2]|0; //@line 20365 "c/sqlite3.c"
    $210 = (($207) + 4)|0; //@line 20365 "c/sqlite3.c"
    $211 = $210; //@line 20365 "c/sqlite3.c"
    $212 = HEAP32[$211>>2]|0; //@line 20365 "c/sqlite3.c"
    $213 = (_i64Add(($209|0),($212|0),($203|0),($206|0))|0); //@line 20365 "c/sqlite3.c"
    $214 = tempRet0; //@line 20365 "c/sqlite3.c"
    $215 = $2; //@line 20365 "c/sqlite3.c"
    $216 = $215; //@line 20365 "c/sqlite3.c"
    HEAP32[$216>>2] = $213; //@line 20365 "c/sqlite3.c"
    $217 = (($215) + 4)|0; //@line 20365 "c/sqlite3.c"
    $218 = $217; //@line 20365 "c/sqlite3.c"
    HEAP32[$218>>2] = $214; //@line 20365 "c/sqlite3.c"
    HEAP32[$3>>2] = 0; //@line 20366 "c/sqlite3.c"
   }
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $$0 = $167;
  while(1) {
   $219 = HEAP8[$$0>>0]|0; //@line 20373 "c/sqlite3.c"
   $220 = $219&255; //@line 20373 "c/sqlite3.c"
   $221 = (16281 + ($220)|0); //@line 20373 "c/sqlite3.c"
   $222 = HEAP8[$221>>0]|0; //@line 20373 "c/sqlite3.c"
   $223 = $222 & 1; //@line 20373 "c/sqlite3.c"
   $224 = ($223<<24>>24)==(0); //@line 20373 "c/sqlite3.c"
   $225 = ((($$0)) + 1|0); //@line 20373 "c/sqlite3.c"
   if ($224) {
    break;
   } else {
    $$0 = $225;
   }
  }
  $226 = (_sqlite3Strlen30($$0)|0); //@line 20374 "c/sqlite3.c"
  $$off = (($226) + -3)|0; //@line 20375 "c/sqlite3.c"
  $227 = ($$off>>>0)>(7); //@line 20375 "c/sqlite3.c"
  if ($227) {
   $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
   STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  }
  $228 = (($226) + -1)|0; //@line 20376 "c/sqlite3.c"
  $229 = (($$0) + ($228)|0); //@line 20376 "c/sqlite3.c"
  $230 = HEAP8[$229>>0]|0; //@line 20376 "c/sqlite3.c"
  $231 = $230 | 32; //@line 20376 "c/sqlite3.c"
  $232 = ($231<<24>>24)==(115); //@line 20376 "c/sqlite3.c"
  $spec$select2 = $232 ? $228 : $226; //@line 20376 "c/sqlite3.c"
  _computeJD($2); //@line 20377 "c/sqlite3.c"
  HEAP32[$3>>2] = 1; //@line 20378 "c/sqlite3.c"
  $233 = +HEAPF64[$4>>3]; //@line 20379 "c/sqlite3.c"
  $234 = $233 < 0.0; //@line 20379 "c/sqlite3.c"
  $235 = $234 ? -0.5 : 0.5; //@line 20379 "c/sqlite3.c"
  L91: do {
   switch ($spec$select2|0) {
   case 6:  {
    $236 = (_sqlite3_strnicmp(37882,$$0,$spec$select2)|0); //@line 20382 "c/sqlite3.c"
    $237 = ($236|0)==(0); //@line 20382 "c/sqlite3.c"
    if ($237) {
     $238 = $233 > -464269060800.0; //@line 20383 "c/sqlite3.c"
     $239 = $233 < 464269060800.0; //@line 20383 "c/sqlite3.c"
     $or$cond4 = $238 & $239; //@line 20383 "c/sqlite3.c"
     if ($or$cond4) {
      $$01476$lcssa = 0;
      label = 48;
      break L91;
     }
    }
    $283 = (_sqlite3_strnicmp(37889,$$0,$spec$select2)|0); //@line 20382 "c/sqlite3.c"
    $284 = ($283|0)==(0); //@line 20382 "c/sqlite3.c"
    if ($284) {
     $285 = $233 > -7737817680.0; //@line 20383 "c/sqlite3.c"
     $286 = $233 < 7737817680.0; //@line 20383 "c/sqlite3.c"
     $or$cond4$1 = $285 & $286; //@line 20383 "c/sqlite3.c"
     if ($or$cond4$1) {
      $$01476$lcssa = 1;
      label = 48;
     }
    }
    break;
   }
   case 4:  {
    $287 = (_sqlite3_strnicmp(37896,$$0,$spec$select2)|0); //@line 20382 "c/sqlite3.c"
    $288 = ($287|0)==(0); //@line 20382 "c/sqlite3.c"
    if ($288) {
     $289 = $233 > -128963628.0; //@line 20383 "c/sqlite3.c"
     $290 = $233 < 128963628.0; //@line 20383 "c/sqlite3.c"
     $or$cond4$2 = $289 & $290; //@line 20383 "c/sqlite3.c"
     if ($or$cond4$2) {
      $$01476$lcssa = 2;
      label = 48;
      break L91;
     }
    }
    $299 = (_sqlite3_strnicmp(37873,$$0,$spec$select2)|0); //@line 20382 "c/sqlite3.c"
    $300 = ($299|0)==(0); //@line 20382 "c/sqlite3.c"
    if ($300) {
     $301 = $233 > -14713.0; //@line 20383 "c/sqlite3.c"
     $302 = $233 < 14713.0; //@line 20383 "c/sqlite3.c"
     $or$cond4$5 = $301 & $302; //@line 20383 "c/sqlite3.c"
     if ($or$cond4$5) {
      $$01476$lcssa = 5;
      label = 48;
     }
    }
    break;
   }
   case 3:  {
    $291 = (_sqlite3_strnicmp(37878,$$0,$spec$select2)|0); //@line 20382 "c/sqlite3.c"
    $292 = ($291|0)==(0); //@line 20382 "c/sqlite3.c"
    if ($292) {
     $293 = $233 > -5373485.0; //@line 20383 "c/sqlite3.c"
     $294 = $233 < 5373485.0; //@line 20383 "c/sqlite3.c"
     $or$cond4$3 = $293 & $294; //@line 20383 "c/sqlite3.c"
     if ($or$cond4$3) {
      $$01476$lcssa = 3;
      label = 48;
     }
    }
    break;
   }
   case 5:  {
    $295 = (_sqlite3_strnicmp(37867,$$0,$spec$select2)|0); //@line 20382 "c/sqlite3.c"
    $296 = ($295|0)==(0); //@line 20382 "c/sqlite3.c"
    if ($296) {
     $297 = $233 > -176546.0; //@line 20383 "c/sqlite3.c"
     $298 = $233 < 176546.0; //@line 20383 "c/sqlite3.c"
     $or$cond4$4 = $297 & $298; //@line 20383 "c/sqlite3.c"
     if ($or$cond4$4) {
      $$01476$lcssa = 4;
      label = 48;
     }
    }
    break;
   }
   default: {
   }
   }
  } while(0);
  if ((label|0) == 48) {
   $240 = (336 + (($$01476$lcssa*24)|0)|0); //@line 20385 "c/sqlite3.c"
   $241 = HEAP8[$240>>0]|0; //@line 20385 "c/sqlite3.c"
   switch ($241<<24>>24) {
   case 1:  {
    _computeYMD_HMS($2); //@line 20388 "c/sqlite3.c"
    $242 = (~~(($233))); //@line 20389 "c/sqlite3.c"
    $243 = ((($2)) + 12|0); //@line 20389 "c/sqlite3.c"
    $244 = HEAP32[$243>>2]|0; //@line 20389 "c/sqlite3.c"
    $245 = (($244) + ($242))|0; //@line 20389 "c/sqlite3.c"
    $246 = ($245|0)>(0); //@line 20390 "c/sqlite3.c"
    $$in$v = $246 ? -1 : -12; //@line 20390 "c/sqlite3.c"
    $$in = (($$in$v) + ($245))|0; //@line 20390 "c/sqlite3.c"
    $247 = (($$in|0) / 12)&-1; //@line 20390 "c/sqlite3.c"
    $248 = ((($2)) + 8|0); //@line 20391 "c/sqlite3.c"
    $249 = HEAP32[$248>>2]|0; //@line 20391 "c/sqlite3.c"
    $250 = (($247) + ($249))|0; //@line 20391 "c/sqlite3.c"
    HEAP32[$248>>2] = $250; //@line 20391 "c/sqlite3.c"
    $251 = Math_imul($247, -12)|0; //@line 20392 "c/sqlite3.c"
    $252 = (($251) + ($245))|0; //@line 20392 "c/sqlite3.c"
    HEAP32[$243>>2] = $252; //@line 20392 "c/sqlite3.c"
    $253 = ((($2)) + 40|0); //@line 20393 "c/sqlite3.c"
    HEAP8[$253>>0] = 0; //@line 20393 "c/sqlite3.c"
    $254 = (+($242|0)); //@line 20394 "c/sqlite3.c"
    $255 = $233 - $254; //@line 20394 "c/sqlite3.c"
    HEAPF64[$4>>3] = $255; //@line 20394 "c/sqlite3.c"
    break;
   }
   case 2:  {
    $256 = (~~(($233))); //@line 20398 "c/sqlite3.c"
    _computeYMD_HMS($2); //@line 20399 "c/sqlite3.c"
    $257 = ((($2)) + 8|0); //@line 20400 "c/sqlite3.c"
    $258 = HEAP32[$257>>2]|0; //@line 20400 "c/sqlite3.c"
    $259 = (($258) + ($256))|0; //@line 20400 "c/sqlite3.c"
    HEAP32[$257>>2] = $259; //@line 20400 "c/sqlite3.c"
    $260 = ((($2)) + 40|0); //@line 20401 "c/sqlite3.c"
    HEAP8[$260>>0] = 0; //@line 20401 "c/sqlite3.c"
    $261 = (+($256|0)); //@line 20402 "c/sqlite3.c"
    $262 = $233 - $261; //@line 20402 "c/sqlite3.c"
    HEAPF64[$4>>3] = $262; //@line 20402 "c/sqlite3.c"
    break;
   }
   default: {
   }
   }
   _computeJD($2); //@line 20406 "c/sqlite3.c"
   $263 = +HEAPF64[$4>>3]; //@line 20407 "c/sqlite3.c"
   $264 = (((336 + (($$01476$lcssa*24)|0)|0)) + 16|0); //@line 20407 "c/sqlite3.c"
   $265 = +HEAPF64[$264>>3]; //@line 20407 "c/sqlite3.c"
   $266 = $263 * $265; //@line 20407 "c/sqlite3.c"
   $267 = $235 + $266; //@line 20407 "c/sqlite3.c"
   $268 = (~~$267)>>>0; //@line 20407 "c/sqlite3.c"
   $269 = +Math_abs($267) >= 1.0 ? $267 > 0.0 ? (~~+Math_min(+Math_floor($267 / 4294967296.0), 4294967295.0)) >>> 0 : ~~+Math_ceil(($267 - +(~~$267 >>> 0)) / 4294967296.0) >>> 0 : 0; //@line 20407 "c/sqlite3.c"
   $270 = $2; //@line 20407 "c/sqlite3.c"
   $271 = $270; //@line 20407 "c/sqlite3.c"
   $272 = HEAP32[$271>>2]|0; //@line 20407 "c/sqlite3.c"
   $273 = (($270) + 4)|0; //@line 20407 "c/sqlite3.c"
   $274 = $273; //@line 20407 "c/sqlite3.c"
   $275 = HEAP32[$274>>2]|0; //@line 20407 "c/sqlite3.c"
   $276 = (_i64Add(($272|0),($275|0),($268|0),($269|0))|0); //@line 20407 "c/sqlite3.c"
   $277 = tempRet0; //@line 20407 "c/sqlite3.c"
   $278 = $2; //@line 20407 "c/sqlite3.c"
   $279 = $278; //@line 20407 "c/sqlite3.c"
   HEAP32[$279>>2] = $276; //@line 20407 "c/sqlite3.c"
   $280 = (($278) + 4)|0; //@line 20407 "c/sqlite3.c"
   $281 = $280; //@line 20407 "c/sqlite3.c"
   HEAP32[$281>>2] = $277; //@line 20407 "c/sqlite3.c"
   HEAP32[$3>>2] = 0; //@line 20408 "c/sqlite3.c"
  }
  _clearYMD_HMS_TZ($2); //@line 20412 "c/sqlite3.c"
  $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
  STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
  break;
 }
 default: {
  $282 = HEAP32[$3>>2]|0; //@line 20419 "c/sqlite3.c"
  STACKTOP = sp;return ($282|0); //@line 20419 "c/sqlite3.c"
 }
 }
 return (0)|0;
}
function _sqlite3NotPureFunc($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 77589 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 77589 "c/sqlite3.c"
 $3 = ((($2)) + 88|0); //@line 77589 "c/sqlite3.c"
 $4 = HEAP32[$3>>2]|0; //@line 77589 "c/sqlite3.c"
 $5 = ((($0)) + 16|0); //@line 77589 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 77589 "c/sqlite3.c"
 $7 = (($4) + (($6*20)|0)|0); //@line 77589 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 77589 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(-92); //@line 77589 "c/sqlite3.c"
 if (!($9)) {
  $$0 = 1;
  return ($$0|0); //@line 77596 "c/sqlite3.c"
 }
 _sqlite3_result_error($0,37944,-1); //@line 77590 "c/sqlite3.c"
 $$0 = 0;
 return ($$0|0); //@line 77596 "c/sqlite3.c"
}
function _localtimeOffset($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$off = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0;
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0.0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 144|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(144|0);
 $3 = sp + 48|0;
 $4 = sp;
 $5 = sp + 140|0;
 $6 = sp + 96|0;
 dest=$6; stop=dest+44|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0)); //@line 20120 "c/sqlite3.c"
 dest=$3; src=$0; stop=dest+48|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 20122 "c/sqlite3.c"
 _computeYMD_HMS($3); //@line 20123 "c/sqlite3.c"
 $7 = ((($3)) + 8|0); //@line 20124 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 20124 "c/sqlite3.c"
 $$off = (($8) + -1971)|0; //@line 20124 "c/sqlite3.c"
 $9 = ($$off>>>0)>(66); //@line 20124 "c/sqlite3.c"
 if ($9) {
  HEAP32[$7>>2] = 2000; //@line 20130 "c/sqlite3.c"
  $10 = ((($3)) + 12|0); //@line 20131 "c/sqlite3.c"
  HEAP32[$10>>2] = 1; //@line 20131 "c/sqlite3.c"
  $11 = ((($3)) + 16|0); //@line 20132 "c/sqlite3.c"
  HEAP32[$11>>2] = 1; //@line 20132 "c/sqlite3.c"
  $12 = ((($3)) + 20|0); //@line 20133 "c/sqlite3.c"
  HEAP32[$12>>2] = 0; //@line 20133 "c/sqlite3.c"
  $13 = ((($3)) + 24|0); //@line 20134 "c/sqlite3.c"
  HEAP32[$13>>2] = 0; //@line 20134 "c/sqlite3.c"
  $14 = ((($3)) + 32|0); //@line 20135 "c/sqlite3.c"
  HEAPF64[$14>>3] = 0.0; //@line 20135 "c/sqlite3.c"
 } else {
  $15 = ((($3)) + 32|0); //@line 20137 "c/sqlite3.c"
  $16 = +HEAPF64[$15>>3]; //@line 20137 "c/sqlite3.c"
  $17 = $16 + 0.5; //@line 20137 "c/sqlite3.c"
  $18 = (~~(($17))); //@line 20137 "c/sqlite3.c"
  $19 = (+($18|0)); //@line 20138 "c/sqlite3.c"
  HEAPF64[$15>>3] = $19; //@line 20138 "c/sqlite3.c"
 }
 $20 = ((($3)) + 28|0); //@line 20140 "c/sqlite3.c"
 HEAP32[$20>>2] = 0; //@line 20140 "c/sqlite3.c"
 $21 = ((($3)) + 40|0); //@line 20141 "c/sqlite3.c"
 HEAP8[$21>>0] = 0; //@line 20141 "c/sqlite3.c"
 _computeJD($3); //@line 20142 "c/sqlite3.c"
 $22 = $3; //@line 20143 "c/sqlite3.c"
 $23 = $22; //@line 20143 "c/sqlite3.c"
 $24 = HEAP32[$23>>2]|0; //@line 20143 "c/sqlite3.c"
 $25 = (($22) + 4)|0; //@line 20143 "c/sqlite3.c"
 $26 = $25; //@line 20143 "c/sqlite3.c"
 $27 = HEAP32[$26>>2]|0; //@line 20143 "c/sqlite3.c"
 $28 = (___divdi3(($24|0),($27|0),1000,0)|0); //@line 20143 "c/sqlite3.c"
 $29 = tempRet0; //@line 20143 "c/sqlite3.c"
 $30 = (($28) + -413362496)|0; //@line 20143 "c/sqlite3.c"
 HEAP32[$5>>2] = $30; //@line 20143 "c/sqlite3.c"
 $31 = (_osLocaltime($5,$6)|0); //@line 20144 "c/sqlite3.c"
 $32 = ($31|0)==(0); //@line 20144 "c/sqlite3.c"
 if ($32) {
  $33 = ((($6)) + 20|0); //@line 20149 "c/sqlite3.c"
  $34 = HEAP32[$33>>2]|0; //@line 20149 "c/sqlite3.c"
  $35 = (($34) + 1900)|0; //@line 20149 "c/sqlite3.c"
  $36 = ((($4)) + 8|0); //@line 20149 "c/sqlite3.c"
  HEAP32[$36>>2] = $35; //@line 20149 "c/sqlite3.c"
  $37 = ((($6)) + 16|0); //@line 20150 "c/sqlite3.c"
  $38 = HEAP32[$37>>2]|0; //@line 20150 "c/sqlite3.c"
  $39 = (($38) + 1)|0; //@line 20150 "c/sqlite3.c"
  $40 = ((($4)) + 12|0); //@line 20150 "c/sqlite3.c"
  HEAP32[$40>>2] = $39; //@line 20150 "c/sqlite3.c"
  $41 = ((($6)) + 12|0); //@line 20151 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 20151 "c/sqlite3.c"
  $43 = ((($4)) + 16|0); //@line 20151 "c/sqlite3.c"
  HEAP32[$43>>2] = $42; //@line 20151 "c/sqlite3.c"
  $44 = ((($6)) + 8|0); //@line 20152 "c/sqlite3.c"
  $45 = HEAP32[$44>>2]|0; //@line 20152 "c/sqlite3.c"
  $46 = ((($4)) + 20|0); //@line 20152 "c/sqlite3.c"
  HEAP32[$46>>2] = $45; //@line 20152 "c/sqlite3.c"
  $47 = ((($6)) + 4|0); //@line 20153 "c/sqlite3.c"
  $48 = HEAP32[$47>>2]|0; //@line 20153 "c/sqlite3.c"
  $49 = ((($4)) + 24|0); //@line 20153 "c/sqlite3.c"
  HEAP32[$49>>2] = $48; //@line 20153 "c/sqlite3.c"
  $50 = HEAP32[$6>>2]|0; //@line 20154 "c/sqlite3.c"
  $51 = (+($50|0)); //@line 20154 "c/sqlite3.c"
  $52 = ((($4)) + 32|0); //@line 20154 "c/sqlite3.c"
  HEAPF64[$52>>3] = $51; //@line 20154 "c/sqlite3.c"
  $53 = ((($4)) + 42|0); //@line 20155 "c/sqlite3.c"
  HEAP8[$53>>0] = 1; //@line 20155 "c/sqlite3.c"
  $54 = ((($4)) + 43|0); //@line 20156 "c/sqlite3.c"
  HEAP8[$54>>0] = 1; //@line 20156 "c/sqlite3.c"
  $55 = ((($4)) + 40|0); //@line 20157 "c/sqlite3.c"
  HEAP8[$55>>0] = 0; //@line 20157 "c/sqlite3.c"
  $56 = ((($4)) + 41|0); //@line 20158 "c/sqlite3.c"
  HEAP8[$56>>0] = 0; //@line 20158 "c/sqlite3.c"
  $57 = ((($4)) + 44|0); //@line 20159 "c/sqlite3.c"
  HEAP8[$57>>0] = 0; //@line 20159 "c/sqlite3.c"
  $58 = ((($4)) + 46|0); //@line 20160 "c/sqlite3.c"
  HEAP8[$58>>0] = 0; //@line 20160 "c/sqlite3.c"
  _computeJD($4); //@line 20161 "c/sqlite3.c"
  HEAP32[$2>>2] = 0; //@line 20162 "c/sqlite3.c"
  $59 = $4; //@line 20163 "c/sqlite3.c"
  $60 = $59; //@line 20163 "c/sqlite3.c"
  $61 = HEAP32[$60>>2]|0; //@line 20163 "c/sqlite3.c"
  $62 = (($59) + 4)|0; //@line 20163 "c/sqlite3.c"
  $63 = $62; //@line 20163 "c/sqlite3.c"
  $64 = HEAP32[$63>>2]|0; //@line 20163 "c/sqlite3.c"
  $65 = (_i64Subtract(($61|0),($64|0),($24|0),($27|0))|0); //@line 20163 "c/sqlite3.c"
  $66 = tempRet0; //@line 20163 "c/sqlite3.c"
  $67 = $66;$68 = $65;
  tempRet0 = ($67); //@line 20164 "c/sqlite3.c"
  STACKTOP = sp;return ($68|0); //@line 20164 "c/sqlite3.c"
 } else {
  _sqlite3_result_error($1,37921,-1); //@line 20145 "c/sqlite3.c"
  HEAP32[$2>>2] = 1; //@line 20146 "c/sqlite3.c"
  $67 = 0;$68 = 0;
  tempRet0 = ($67); //@line 20164 "c/sqlite3.c"
  STACKTOP = sp;return ($68|0); //@line 20164 "c/sqlite3.c"
 }
 return (0)|0;
}
function _clearYMD_HMS_TZ($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 42|0); //@line 20034 "c/sqlite3.c"
 HEAP8[$1>>0] = 0; //@line 20034 "c/sqlite3.c"
 $2 = ((($0)) + 43|0); //@line 20035 "c/sqlite3.c"
 HEAP8[$2>>0] = 0; //@line 20035 "c/sqlite3.c"
 $3 = ((($0)) + 44|0); //@line 20036 "c/sqlite3.c"
 HEAP8[$3>>0] = 0; //@line 20036 "c/sqlite3.c"
 return; //@line 20037 "c/sqlite3.c"
}
function _parseHhMmSs($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0.0, $$030$lcssa = 0.0, $$03035 = 0.0, $$031 = 0, $$032$lcssa = 0, $$03234 = 0, $$036 = 0.0, $$1 = 0.0, $$133 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0.0, $27 = 0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0.0, $46 = 0.0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = sp + 20|0;
 $3 = sp + 16|0;
 $4 = sp + 12|0;
 HEAP32[$vararg_buffer>>2] = $2; //@line 19761 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 19761 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $3; //@line 19761 "c/sqlite3.c"
 $5 = (_getDigits($0,37901,$vararg_buffer)|0); //@line 19761 "c/sqlite3.c"
 $6 = ($5|0)==(2); //@line 19761 "c/sqlite3.c"
 if (!($6)) {
  $$031 = 1;
  STACKTOP = sp;return ($$031|0); //@line 19793 "c/sqlite3.c"
 }
 $7 = ((($0)) + 5|0); //@line 19764 "c/sqlite3.c"
 $8 = HEAP8[$7>>0]|0; //@line 19765 "c/sqlite3.c"
 $9 = ($8<<24>>24)==(58); //@line 19765 "c/sqlite3.c"
 if ($9) {
  $10 = ((($0)) + 6|0); //@line 19766 "c/sqlite3.c"
  HEAP32[$vararg_buffer2>>2] = $4; //@line 19767 "c/sqlite3.c"
  $11 = (_getDigits($10,37909,$vararg_buffer2)|0); //@line 19767 "c/sqlite3.c"
  $12 = ($11|0)==(1); //@line 19767 "c/sqlite3.c"
  if (!($12)) {
   $$031 = 1;
   STACKTOP = sp;return ($$031|0); //@line 19793 "c/sqlite3.c"
  }
  $13 = ((($0)) + 8|0); //@line 19770 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 19771 "c/sqlite3.c"
  $15 = ($14<<24>>24)==(46); //@line 19771 "c/sqlite3.c"
  if ($15) {
   $16 = ((($0)) + 9|0); //@line 19771 "c/sqlite3.c"
   $17 = HEAP8[$16>>0]|0; //@line 19771 "c/sqlite3.c"
   $18 = $17&255; //@line 19771 "c/sqlite3.c"
   $19 = (($18) + -48)|0; //@line 19771 "c/sqlite3.c"
   $20 = ($19>>>0)<(10); //@line 19771 "c/sqlite3.c"
   if ($20) {
    $21 = HEAP8[$16>>0]|0; //@line 19774 "c/sqlite3.c"
    $22 = $21&255; //@line 19774 "c/sqlite3.c"
    $23 = (($22) + -48)|0; //@line 19774 "c/sqlite3.c"
    $24 = ($23>>>0)<(10); //@line 19774 "c/sqlite3.c"
    if ($24) {
     $$03035 = 0.0;$$03234 = $16;$$036 = 1.0;$27 = $21;
     while(1) {
      $25 = $$03035 * 10.0; //@line 19775 "c/sqlite3.c"
      $26 = (+($27<<24>>24)); //@line 19775 "c/sqlite3.c"
      $28 = $25 + $26; //@line 19775 "c/sqlite3.c"
      $29 = $28 + -48.0; //@line 19775 "c/sqlite3.c"
      $30 = $$036 * 10.0; //@line 19776 "c/sqlite3.c"
      $31 = ((($$03234)) + 1|0); //@line 19777 "c/sqlite3.c"
      $32 = HEAP8[$31>>0]|0; //@line 19774 "c/sqlite3.c"
      $33 = $32&255; //@line 19774 "c/sqlite3.c"
      $34 = (($33) + -48)|0; //@line 19774 "c/sqlite3.c"
      $35 = ($34>>>0)<(10); //@line 19774 "c/sqlite3.c"
      if ($35) {
       $$03035 = $29;$$03234 = $31;$$036 = $30;$27 = $32;
      } else {
       $$0$lcssa = $30;$$030$lcssa = $29;$$032$lcssa = $31;
       break;
      }
     }
    } else {
     $$0$lcssa = 1.0;$$030$lcssa = 0.0;$$032$lcssa = $16;
    }
    $36 = $$030$lcssa / $$0$lcssa; //@line 19779 "c/sqlite3.c"
    $$1 = $36;$$133 = $$032$lcssa;
   } else {
    $$1 = 0.0;$$133 = $13;
   }
  } else {
   $$1 = 0.0;$$133 = $13;
  }
 } else {
  HEAP32[$4>>2] = 0; //@line 19782 "c/sqlite3.c"
  $$1 = 0.0;$$133 = $7;
 }
 $37 = ((($1)) + 40|0); //@line 19784 "c/sqlite3.c"
 HEAP8[$37>>0] = 0; //@line 19784 "c/sqlite3.c"
 $38 = ((($1)) + 41|0); //@line 19785 "c/sqlite3.c"
 HEAP8[$38>>0] = 0; //@line 19785 "c/sqlite3.c"
 $39 = ((($1)) + 43|0); //@line 19786 "c/sqlite3.c"
 HEAP8[$39>>0] = 1; //@line 19786 "c/sqlite3.c"
 $40 = HEAP32[$2>>2]|0; //@line 19787 "c/sqlite3.c"
 $41 = ((($1)) + 20|0); //@line 19787 "c/sqlite3.c"
 HEAP32[$41>>2] = $40; //@line 19787 "c/sqlite3.c"
 $42 = HEAP32[$3>>2]|0; //@line 19788 "c/sqlite3.c"
 $43 = ((($1)) + 24|0); //@line 19788 "c/sqlite3.c"
 HEAP32[$43>>2] = $42; //@line 19788 "c/sqlite3.c"
 $44 = HEAP32[$4>>2]|0; //@line 19789 "c/sqlite3.c"
 $45 = (+($44|0)); //@line 19789 "c/sqlite3.c"
 $46 = $$1 + $45; //@line 19789 "c/sqlite3.c"
 $47 = ((($1)) + 32|0); //@line 19789 "c/sqlite3.c"
 HEAPF64[$47>>3] = $46; //@line 19789 "c/sqlite3.c"
 $48 = (_parseTimezone($$133,$1)|0); //@line 19790 "c/sqlite3.c"
 $49 = ($48|0)==(0); //@line 19790 "c/sqlite3.c"
 if (!($49)) {
  $$031 = 1;
  STACKTOP = sp;return ($$031|0); //@line 19793 "c/sqlite3.c"
 }
 $50 = ((($1)) + 28|0); //@line 19791 "c/sqlite3.c"
 $51 = HEAP32[$50>>2]|0; //@line 19791 "c/sqlite3.c"
 $52 = ($51|0)!=(0); //@line 19791 "c/sqlite3.c"
 $53 = $52&1; //@line 19791 "c/sqlite3.c"
 $54 = ((($1)) + 44|0); //@line 19791 "c/sqlite3.c"
 HEAP8[$54>>0] = $53; //@line 19791 "c/sqlite3.c"
 $$031 = 0;
 STACKTOP = sp;return ($$031|0); //@line 19793 "c/sqlite3.c"
}
function _getDigits($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $$030 = 0, $$031$lcssa = 0, $$03147 = 0, $$032 = 0, $$035 = 0, $$1$lcssa = 0, $$13638 = 0, $$148 = 0, $$in = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $arglist_current = 0, $arglist_current2 = 0, $arglist_next = 0, $arglist_next3 = 0, $expanded = 0, $expanded10 = 0, $expanded12 = 0, $expanded13 = 0, $expanded14 = 0, $expanded3 = 0, $expanded5 = 0, $expanded6 = 0, $expanded7 = 0, $expanded9 = 0, $or$cond = 0, $sext = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $2 = sp;
 HEAP32[$2>>2] = $varargs; //@line 19675 "c/sqlite3.c"
 $$030 = $0;$$032 = $1;$$035 = 0;
 L1: while(1) {
  $3 = HEAP8[$$032>>0]|0; //@line 19677 "c/sqlite3.c"
  $4 = $3&255; //@line 19677 "c/sqlite3.c"
  $5 = (($4) + 208)|0; //@line 19677 "c/sqlite3.c"
  $6 = $5&255; //@line 19677 "c/sqlite3.c"
  $7 = ((($$032)) + 1|0); //@line 19678 "c/sqlite3.c"
  $8 = HEAP8[$7>>0]|0; //@line 19678 "c/sqlite3.c"
  $9 = $8&255; //@line 19678 "c/sqlite3.c"
  $10 = ((($$032)) + 2|0); //@line 19683 "c/sqlite3.c"
  $11 = HEAP8[$10>>0]|0; //@line 19683 "c/sqlite3.c"
  $12 = $11 << 24 >> 24; //@line 19683 "c/sqlite3.c"
  $13 = (($12) + -97)|0; //@line 19683 "c/sqlite3.c"
  $14 = (13938 + ($13<<1)|0); //@line 19683 "c/sqlite3.c"
  $15 = HEAP16[$14>>1]|0; //@line 19683 "c/sqlite3.c"
  $16 = ((($$032)) + 3|0); //@line 19684 "c/sqlite3.c"
  $17 = HEAP8[$16>>0]|0; //@line 19684 "c/sqlite3.c"
  $18 = ($6<<24>>24)==(0); //@line 19686 "c/sqlite3.c"
  if ($18) {
   $$031$lcssa = 0;$$1$lcssa = $$030;
  } else {
   $$03147 = 0;$$148 = $$030;$$in = $6;
   while(1) {
    $19 = (($$in) + -1)<<24>>24; //@line 19686 "c/sqlite3.c"
    $20 = HEAP8[$$148>>0]|0; //@line 19687 "c/sqlite3.c"
    $21 = $20&255; //@line 19687 "c/sqlite3.c"
    $22 = (($21) + -48)|0; //@line 19687 "c/sqlite3.c"
    $23 = ($22>>>0)<(10); //@line 19687 "c/sqlite3.c"
    if (!($23)) {
     $$13638 = $$035;
     label = 11;
     break L1;
    }
    $24 = ($$03147*10)|0; //@line 19690 "c/sqlite3.c"
    $25 = $20 << 24 >> 24; //@line 19690 "c/sqlite3.c"
    $26 = (($24) + -48)|0; //@line 19690 "c/sqlite3.c"
    $27 = (($26) + ($25))|0; //@line 19690 "c/sqlite3.c"
    $28 = ((($$148)) + 1|0); //@line 19691 "c/sqlite3.c"
    $29 = ($19<<24>>24)==(0); //@line 19686 "c/sqlite3.c"
    if ($29) {
     $$031$lcssa = $27;$$1$lcssa = $28;
     break;
    } else {
     $$03147 = $27;$$148 = $28;$$in = $19;
    }
   }
  }
  $30 = $9 << 24; //@line 19693 "c/sqlite3.c"
  $sext = (($30) + -805306368)|0; //@line 19693 "c/sqlite3.c"
  $31 = $sext >> 24; //@line 19693 "c/sqlite3.c"
  $32 = ($$031$lcssa|0)<($31|0); //@line 19693 "c/sqlite3.c"
  $33 = $15&65535; //@line 19693 "c/sqlite3.c"
  $34 = ($$031$lcssa|0)>($33|0); //@line 19693 "c/sqlite3.c"
  $or$cond = $32 | $34; //@line 19693 "c/sqlite3.c"
  if ($or$cond) {
   $$13638 = $$035;
   label = 11;
   break;
  }
  $35 = ($17<<24>>24)==(0); //@line 19693 "c/sqlite3.c"
  if ($35) {
   label = 8;
   break;
  }
  $44 = HEAP8[$$1$lcssa>>0]|0; //@line 19693 "c/sqlite3.c"
  $45 = ($17<<24>>24)==($44<<24>>24); //@line 19693 "c/sqlite3.c"
  if (!($45)) {
   $$13638 = $$035;
   label = 11;
   break;
  }
  $arglist_current2 = HEAP32[$2>>2]|0; //@line 19696 "c/sqlite3.c"
  $46 = $arglist_current2; //@line 19696 "c/sqlite3.c"
  $47 = ((0) + 4|0);
  $expanded10 = $47;
  $expanded9 = (($expanded10) - 1)|0;
  $48 = (($46) + ($expanded9))|0; //@line 19696 "c/sqlite3.c"
  $49 = ((0) + 4|0);
  $expanded14 = $49;
  $expanded13 = (($expanded14) - 1)|0;
  $expanded12 = $expanded13 ^ -1;
  $50 = $48 & $expanded12; //@line 19696 "c/sqlite3.c"
  $51 = $50; //@line 19696 "c/sqlite3.c"
  $52 = HEAP32[$51>>2]|0; //@line 19696 "c/sqlite3.c"
  $arglist_next3 = ((($51)) + 4|0); //@line 19696 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next3; //@line 19696 "c/sqlite3.c"
  HEAP32[$52>>2] = $$031$lcssa; //@line 19696 "c/sqlite3.c"
  $53 = ((($$1$lcssa)) + 1|0); //@line 19697 "c/sqlite3.c"
  $54 = (($$035) + 1)|0; //@line 19698 "c/sqlite3.c"
  $55 = ((($$032)) + 4|0); //@line 19699 "c/sqlite3.c"
  $$030 = $53;$$032 = $55;$$035 = $54;
 }
 if ((label|0) == 8) {
  $arglist_current = HEAP32[$2>>2]|0; //@line 19696 "c/sqlite3.c"
  $36 = $arglist_current; //@line 19696 "c/sqlite3.c"
  $37 = ((0) + 4|0);
  $expanded3 = $37;
  $expanded = (($expanded3) - 1)|0;
  $38 = (($36) + ($expanded))|0; //@line 19696 "c/sqlite3.c"
  $39 = ((0) + 4|0);
  $expanded7 = $39;
  $expanded6 = (($expanded7) - 1)|0;
  $expanded5 = $expanded6 ^ -1;
  $40 = $38 & $expanded5; //@line 19696 "c/sqlite3.c"
  $41 = $40; //@line 19696 "c/sqlite3.c"
  $42 = HEAP32[$41>>2]|0; //@line 19696 "c/sqlite3.c"
  $arglist_next = ((($41)) + 4|0); //@line 19696 "c/sqlite3.c"
  HEAP32[$2>>2] = $arglist_next; //@line 19696 "c/sqlite3.c"
  HEAP32[$42>>2] = $$031$lcssa; //@line 19696 "c/sqlite3.c"
  $43 = (($$035) + 1)|0; //@line 19698 "c/sqlite3.c"
  $$13638 = $43;
  STACKTOP = sp;return ($$13638|0); //@line 19704 "c/sqlite3.c"
 }
 else if ((label|0) == 11) {
  STACKTOP = sp;return ($$13638|0); //@line 19704 "c/sqlite3.c"
 }
 return (0)|0;
}
function _parseTimezone($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$0$shrunk = 0, $$023 = 0, $$024 = 0, $$2 = 0, $$2$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = sp + 12|0;
 $3 = sp + 8|0;
 $$024 = $0;
 while(1) {
  $4 = HEAP8[$$024>>0]|0; //@line 19726 "c/sqlite3.c"
  $5 = $4&255; //@line 19726 "c/sqlite3.c"
  $6 = (16281 + ($5)|0); //@line 19726 "c/sqlite3.c"
  $7 = HEAP8[$6>>0]|0; //@line 19726 "c/sqlite3.c"
  $8 = $7 & 1; //@line 19726 "c/sqlite3.c"
  $9 = ($8<<24>>24)==(0); //@line 19726 "c/sqlite3.c"
  $10 = ((($$024)) + 1|0); //@line 19726 "c/sqlite3.c"
  if ($9) {
   break;
  } else {
   $$024 = $10;
  }
 }
 $11 = ((($1)) + 28|0); //@line 19727 "c/sqlite3.c"
 HEAP32[$11>>2] = 0; //@line 19727 "c/sqlite3.c"
 $12 = HEAP8[$$024>>0]|0; //@line 19728 "c/sqlite3.c"
 L4: do {
  switch ($12<<24>>24) {
  case 45:  {
   $$023 = -1;
   label = 8;
   break;
  }
  case 43:  {
   $$023 = 1;
   label = 8;
   break;
  }
  default: {
   $13 = $12 | 32; //@line 19733 "c/sqlite3.c"
   $14 = ($13<<24>>24)==(122); //@line 19733 "c/sqlite3.c"
   if ($14) {
    $15 = ((($$024)) + 1|0); //@line 19734 "c/sqlite3.c"
    $$2$ph = $15;
    break L4;
   }
   $16 = ($12<<24>>24)!=(0); //@line 19737 "c/sqlite3.c"
   $$0$shrunk = $16;
   $$0 = $$0$shrunk&1;
   STACKTOP = sp;return ($$0|0); //@line 19749 "c/sqlite3.c"
  }
  }
 } while(0);
 do {
  if ((label|0) == 8) {
   $17 = ((($$024)) + 1|0); //@line 19739 "c/sqlite3.c"
   HEAP32[$vararg_buffer>>2] = $2; //@line 19740 "c/sqlite3.c"
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 19740 "c/sqlite3.c"
   HEAP32[$vararg_ptr1>>2] = $3; //@line 19740 "c/sqlite3.c"
   $18 = (_getDigits($17,37913,$vararg_buffer)|0); //@line 19740 "c/sqlite3.c"
   $19 = ($18|0)==(2); //@line 19740 "c/sqlite3.c"
   if ($19) {
    $20 = ((($$024)) + 6|0); //@line 19743 "c/sqlite3.c"
    $21 = HEAP32[$3>>2]|0; //@line 19744 "c/sqlite3.c"
    $22 = HEAP32[$2>>2]|0; //@line 19744 "c/sqlite3.c"
    $23 = ($22*60)|0; //@line 19744 "c/sqlite3.c"
    $24 = (($23) + ($21))|0; //@line 19744 "c/sqlite3.c"
    $25 = Math_imul($24, $$023)|0; //@line 19744 "c/sqlite3.c"
    HEAP32[$11>>2] = $25; //@line 19744 "c/sqlite3.c"
    $$2$ph = $20;
    break;
   } else {
    $$0$shrunk = 1;
    $$0 = $$0$shrunk&1;
    STACKTOP = sp;return ($$0|0); //@line 19749 "c/sqlite3.c"
   }
  }
 } while(0);
 $$2 = $$2$ph;
 while(1) {
  $26 = HEAP8[$$2>>0]|0; //@line 19746 "c/sqlite3.c"
  $27 = $26&255; //@line 19746 "c/sqlite3.c"
  $28 = (16281 + ($27)|0); //@line 19746 "c/sqlite3.c"
  $29 = HEAP8[$28>>0]|0; //@line 19746 "c/sqlite3.c"
  $30 = $29 & 1; //@line 19746 "c/sqlite3.c"
  $31 = ($30<<24>>24)==(0); //@line 19746 "c/sqlite3.c"
  $32 = ((($$2)) + 1|0); //@line 19746 "c/sqlite3.c"
  if ($31) {
   break;
  } else {
   $$2 = $32;
  }
 }
 $33 = ((($1)) + 45|0); //@line 19747 "c/sqlite3.c"
 HEAP8[$33>>0] = 1; //@line 19747 "c/sqlite3.c"
 $34 = HEAP8[$$2>>0]|0; //@line 19748 "c/sqlite3.c"
 $35 = ($34<<24>>24)!=(0); //@line 19748 "c/sqlite3.c"
 $$0$shrunk = $35;
 $$0 = $$0$shrunk&1;
 STACKTOP = sp;return ($$0|0); //@line 19749 "c/sqlite3.c"
}
function _osLocaltime($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 $2 = (_sqlite3MutexAlloc(2)|0); //@line 20076 "c/sqlite3.c"
 _sqlite3_mutex_enter($2); //@line 20078 "c/sqlite3.c"
 $3 = (_localtime(($0|0))|0); //@line 20079 "c/sqlite3.c"
 $4 = HEAP32[(272)>>2]|0; //@line 20081 "c/sqlite3.c"
 $5 = ($4|0)!=(0); //@line 20081 "c/sqlite3.c"
 $6 = ($3|0)==(0|0); //@line 20083 "c/sqlite3.c"
 $7 = $6 | $5; //@line 20083 "c/sqlite3.c"
 if (!($7)) {
  dest=$1; src=$3; stop=dest+44|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0)); //@line 20083 "c/sqlite3.c"
 }
 _sqlite3_mutex_leave($2); //@line 20084 "c/sqlite3.c"
 $8 = $7&1; //@line 20085 "c/sqlite3.c"
 return ($8|0); //@line 20096 "c/sqlite3.c"
}
function _parseYyyyMmDd($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$019 = 0, $$020 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, $vararg_buffer = 0;
 var $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $2 = sp + 20|0;
 $3 = sp + 16|0;
 $4 = sp + 12|0;
 $5 = HEAP8[$0>>0]|0; //@line 19862 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(45); //@line 19862 "c/sqlite3.c"
 $7 = ((($0)) + 1|0); //@line 19863 "c/sqlite3.c"
 $$020 = $6 ? $7 : $0; //@line 19862 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $2; //@line 19868 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 19868 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $3; //@line 19868 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 19868 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $4; //@line 19868 "c/sqlite3.c"
 $8 = (_getDigits($$020,38015,$vararg_buffer)|0); //@line 19868 "c/sqlite3.c"
 $9 = ($8|0)==(3); //@line 19868 "c/sqlite3.c"
 if (!($9)) {
  $$019 = 1;
  STACKTOP = sp;return ($$019|0); //@line 19889 "c/sqlite3.c"
 }
 $10 = ((($$020)) + 10|0); //@line 19871 "c/sqlite3.c"
 $$1 = $10;
 while(1) {
  $11 = HEAP8[$$1>>0]|0; //@line 19872 "c/sqlite3.c"
  $12 = $11&255; //@line 19872 "c/sqlite3.c"
  $13 = (16281 + ($12)|0); //@line 19872 "c/sqlite3.c"
  $14 = HEAP8[$13>>0]|0; //@line 19872 "c/sqlite3.c"
  $15 = $14 & 1; //@line 19872 "c/sqlite3.c"
  $16 = ($15<<24>>24)!=(0); //@line 19872 "c/sqlite3.c"
  $17 = ($11<<24>>24)==(84); //@line 19872 "c/sqlite3.c"
  $spec$select = $17 | $16; //@line 19872 "c/sqlite3.c"
  $18 = ((($$1)) + 1|0); //@line 19872 "c/sqlite3.c"
  if ($spec$select) {
   $$1 = $18;
  } else {
   break;
  }
 }
 $19 = (_parseHhMmSs($$1,$1)|0); //@line 19873 "c/sqlite3.c"
 $20 = ($19|0)==(0); //@line 19873 "c/sqlite3.c"
 do {
  if (!($20)) {
   $21 = HEAP8[$$1>>0]|0; //@line 19875 "c/sqlite3.c"
   $22 = ($21<<24>>24)==(0); //@line 19875 "c/sqlite3.c"
   if ($22) {
    $23 = ((($1)) + 43|0); //@line 19876 "c/sqlite3.c"
    HEAP8[$23>>0] = 0; //@line 19876 "c/sqlite3.c"
    break;
   } else {
    $$019 = 1;
    STACKTOP = sp;return ($$019|0); //@line 19889 "c/sqlite3.c"
   }
  }
 } while(0);
 $24 = ((($1)) + 40|0); //@line 19880 "c/sqlite3.c"
 HEAP8[$24>>0] = 0; //@line 19880 "c/sqlite3.c"
 $25 = ((($1)) + 42|0); //@line 19881 "c/sqlite3.c"
 HEAP8[$25>>0] = 1; //@line 19881 "c/sqlite3.c"
 $26 = HEAP32[$2>>2]|0;
 $27 = (0 - ($26))|0; //@line 19882 "c/sqlite3.c"
 $28 = $6 ? $27 : $26; //@line 19882 "c/sqlite3.c"
 $29 = ((($1)) + 8|0); //@line 19882 "c/sqlite3.c"
 HEAP32[$29>>2] = $28; //@line 19882 "c/sqlite3.c"
 $30 = HEAP32[$3>>2]|0; //@line 19883 "c/sqlite3.c"
 $31 = ((($1)) + 12|0); //@line 19883 "c/sqlite3.c"
 HEAP32[$31>>2] = $30; //@line 19883 "c/sqlite3.c"
 $32 = HEAP32[$4>>2]|0; //@line 19884 "c/sqlite3.c"
 $33 = ((($1)) + 16|0); //@line 19884 "c/sqlite3.c"
 HEAP32[$33>>2] = $32; //@line 19884 "c/sqlite3.c"
 $34 = ((($1)) + 44|0); //@line 19885 "c/sqlite3.c"
 $35 = HEAP8[$34>>0]|0; //@line 19885 "c/sqlite3.c"
 $36 = ($35<<24>>24)==(0); //@line 19885 "c/sqlite3.c"
 if ($36) {
  $$019 = 0;
  STACKTOP = sp;return ($$019|0); //@line 19889 "c/sqlite3.c"
 }
 _computeJD($1); //@line 19886 "c/sqlite3.c"
 $$019 = 0;
 STACKTOP = sp;return ($$019|0); //@line 19889 "c/sqlite3.c"
}
function _sqlite3StmtCurrentTime($0) {
 $0 = $0|0;
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 12|0); //@line 78487 "c/sqlite3.c"
 $2 = HEAP32[$1>>2]|0; //@line 78487 "c/sqlite3.c"
 $3 = ((($2)) + 56|0); //@line 78487 "c/sqlite3.c"
 $4 = $3; //@line 78493 "c/sqlite3.c"
 $5 = $4; //@line 78493 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 78493 "c/sqlite3.c"
 $7 = (($4) + 4)|0; //@line 78493 "c/sqlite3.c"
 $8 = $7; //@line 78493 "c/sqlite3.c"
 $9 = HEAP32[$8>>2]|0; //@line 78493 "c/sqlite3.c"
 $10 = ($6|0)==(0); //@line 78493 "c/sqlite3.c"
 $11 = ($9|0)==(0); //@line 78493 "c/sqlite3.c"
 $12 = $10 & $11; //@line 78493 "c/sqlite3.c"
 if ($12) {
  $13 = HEAP32[$0>>2]|0; //@line 78494 "c/sqlite3.c"
  $14 = ((($13)) + 32|0); //@line 78494 "c/sqlite3.c"
  $15 = HEAP32[$14>>2]|0; //@line 78494 "c/sqlite3.c"
  $16 = HEAP32[$15>>2]|0; //@line 78494 "c/sqlite3.c"
  $17 = (_sqlite3OsCurrentTimeInt64($16,$3)|0); //@line 78494 "c/sqlite3.c"
  $18 = ($17|0)==(0); //@line 78495 "c/sqlite3.c"
  if (!($18)) {
   $19 = $3; //@line 78495 "c/sqlite3.c"
   $20 = $19; //@line 78495 "c/sqlite3.c"
   HEAP32[$20>>2] = 0; //@line 78495 "c/sqlite3.c"
   $21 = (($19) + 4)|0; //@line 78495 "c/sqlite3.c"
   $22 = $21; //@line 78495 "c/sqlite3.c"
   HEAP32[$22>>2] = 0; //@line 78495 "c/sqlite3.c"
  }
 }
 $23 = $3; //@line 78497 "c/sqlite3.c"
 $24 = $23; //@line 78497 "c/sqlite3.c"
 $25 = HEAP32[$24>>2]|0; //@line 78497 "c/sqlite3.c"
 $26 = (($23) + 4)|0; //@line 78497 "c/sqlite3.c"
 $27 = $26; //@line 78497 "c/sqlite3.c"
 $28 = HEAP32[$27>>2]|0; //@line 78497 "c/sqlite3.c"
 tempRet0 = ($28); //@line 78497 "c/sqlite3.c"
 return ($25|0); //@line 78497 "c/sqlite3.c"
}
function _renameTableFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$03139 = 0, $$040 = 0, $$1 = 0, $$132 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 16|0;
 $4 = HEAP32[$2>>2]|0; //@line 98061 "c/sqlite3.c"
 $5 = (_sqlite3_value_text($4)|0); //@line 98061 "c/sqlite3.c"
 $6 = ((($2)) + 4|0); //@line 98062 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 98062 "c/sqlite3.c"
 $8 = (_sqlite3_value_text($7)|0); //@line 98062 "c/sqlite3.c"
 $9 = (_sqlite3_context_db_handle($0)|0); //@line 98070 "c/sqlite3.c"
 $10 = ($5|0)==(0|0); //@line 98078 "c/sqlite3.c"
 if ($10) {
  STACKTOP = sp;return; //@line 98103 "c/sqlite3.c"
 }
 $11 = HEAP8[$5>>0]|0; //@line 98080 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 98080 "c/sqlite3.c"
 if ($12) {
  STACKTOP = sp;return; //@line 98103 "c/sqlite3.c"
 }
 $$03139 = 0;$$040 = $5;
 L7: while(1) {
  $$1 = $$040;$$132 = $$03139;
  L9: while(1) {
   $14 = (($$1) + ($$132)|0); //@line 98093 "c/sqlite3.c"
   $16 = (_sqlite3GetToken($14,$3)|0); //@line 98094 "c/sqlite3.c"
   $17 = HEAP32[$3>>2]|0; //@line 98095 "c/sqlite3.c"
   switch ($17|0) {
   case 22: case 125:  {
    break L7;
    break;
   }
   case 158:  {
    $$1 = $14;$$132 = $16;
    break;
   }
   default: {
    break L9;
   }
   }
  }
  $13 = HEAP8[$14>>0]|0; //@line 98080 "c/sqlite3.c"
  $15 = ($13<<24>>24)==(0); //@line 98080 "c/sqlite3.c"
  if ($15) {
   label = 8;
   break;
  } else {
   $$03139 = $16;$$040 = $14;
  }
 }
 if ((label|0) == 8) {
  STACKTOP = sp;return; //@line 98103 "c/sqlite3.c"
 }
 $18 = $$040; //@line 98099 "c/sqlite3.c"
 $19 = $5; //@line 98099 "c/sqlite3.c"
 $20 = (($18) - ($19))|0; //@line 98099 "c/sqlite3.c"
 $21 = (($$040) + ($$03139)|0); //@line 98100 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $20; //@line 98099 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 98099 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $5; //@line 98099 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 98099 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $8; //@line 98099 "c/sqlite3.c"
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 98099 "c/sqlite3.c"
 HEAP32[$vararg_ptr3>>2] = $21; //@line 98099 "c/sqlite3.c"
 $22 = (_sqlite3MPrintf($9,38161,$vararg_buffer)|0); //@line 98099 "c/sqlite3.c"
 _sqlite3_result_text($0,$22,-1,157); //@line 98101 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98103 "c/sqlite3.c"
}
function _renameTriggerFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$be = 0, $$04149 = 0, $$04248 = 0, $$050 = 0, $$1 = 0, $$143 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $spec$store$select = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 16|0;
 $4 = HEAP32[$2>>2]|0; //@line 98183 "c/sqlite3.c"
 $5 = (_sqlite3_value_text($4)|0); //@line 98183 "c/sqlite3.c"
 $6 = ((($2)) + 4|0); //@line 98184 "c/sqlite3.c"
 $7 = HEAP32[$6>>2]|0; //@line 98184 "c/sqlite3.c"
 $8 = (_sqlite3_value_text($7)|0); //@line 98184 "c/sqlite3.c"
 $9 = (_sqlite3_context_db_handle($0)|0); //@line 98192 "c/sqlite3.c"
 $10 = ($5|0)==(0|0); //@line 98201 "c/sqlite3.c"
 if ($10) {
  STACKTOP = sp;return; //@line 98244 "c/sqlite3.c"
 }
 $11 = HEAP8[$5>>0]|0; //@line 98204 "c/sqlite3.c"
 $12 = ($11<<24>>24)==(0); //@line 98204 "c/sqlite3.c"
 if ($12) {
  STACKTOP = sp;return; //@line 98244 "c/sqlite3.c"
 }
 $$04149 = $5;$$04248 = 0;$$050 = 3;
 L7: while(1) {
  $$1 = $$04149;$$143 = $$04248;
  while(1) {
   $14 = (($$1) + ($$143)|0); //@line 98217 "c/sqlite3.c"
   $16 = (_sqlite3GetToken($14,$3)|0); //@line 98218 "c/sqlite3.c"
   $17 = HEAP32[$3>>2]|0; //@line 98219 "c/sqlite3.c"
   $18 = ($17|0)==(158); //@line 98219 "c/sqlite3.c"
   if ($18) {
    $$1 = $14;$$143 = $16;
   } else {
    break;
   }
  }
  $19 = (($$050) + 1)|0; //@line 98231 "c/sqlite3.c"
  $20 = ($17|0)==(122); //@line 98232 "c/sqlite3.c"
  $21 = ($17|0)==(107); //@line 98232 "c/sqlite3.c"
  $or$cond = $20 | $21; //@line 98232 "c/sqlite3.c"
  $spec$store$select = $or$cond ? 0 : $19; //@line 98232 "c/sqlite3.c"
  $22 = ($spec$store$select|0)==(2); //@line 98235 "c/sqlite3.c"
  if ($22) {
   switch ($17|0) {
   case 5: case 61: case 137:  {
    break L7;
    break;
   }
   default: {
    $$0$be = 2;
   }
   }
  } else {
   $$0$be = $spec$store$select;
  }
  $13 = HEAP8[$14>>0]|0; //@line 98204 "c/sqlite3.c"
  $15 = ($13<<24>>24)==(0); //@line 98204 "c/sqlite3.c"
  if ($15) {
   label = 10;
   break;
  } else {
   $$04149 = $14;$$04248 = $16;$$050 = $$0$be;
  }
 }
 if ((label|0) == 10) {
  STACKTOP = sp;return; //@line 98244 "c/sqlite3.c"
 }
 $23 = $$04149; //@line 98240 "c/sqlite3.c"
 $24 = $5; //@line 98240 "c/sqlite3.c"
 $25 = (($23) - ($24))|0; //@line 98240 "c/sqlite3.c"
 $26 = (($$04149) + ($$04248)|0); //@line 98241 "c/sqlite3.c"
 HEAP32[$vararg_buffer>>2] = $25; //@line 98240 "c/sqlite3.c"
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 98240 "c/sqlite3.c"
 HEAP32[$vararg_ptr1>>2] = $5; //@line 98240 "c/sqlite3.c"
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 98240 "c/sqlite3.c"
 HEAP32[$vararg_ptr2>>2] = $8; //@line 98240 "c/sqlite3.c"
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 98240 "c/sqlite3.c"
 HEAP32[$vararg_ptr3>>2] = $26; //@line 98240 "c/sqlite3.c"
 $27 = (_sqlite3MPrintf($9,38161,$vararg_buffer)|0); //@line 98240 "c/sqlite3.c"
 _sqlite3_result_text($0,$27,-1,157); //@line 98242 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98244 "c/sqlite3.c"
}
function _renameParentFunc($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$06482 = 0, $$06484 = 0, $$070 = 0, $$07283 = 0, $$080 = 0, $$085 = 0, $$1 = 0, $$165 = 0, $$171 = 0, $$173 = 0, $$274 = 0, $$3 = 0, $$367 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer4 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr7 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer4 = sp + 16|0;
 $vararg_buffer = sp;
 $3 = sp + 24|0;
 $4 = (_sqlite3_context_db_handle($0)|0); //@line 98126 "c/sqlite3.c"
 $5 = HEAP32[$2>>2]|0; //@line 98129 "c/sqlite3.c"
 $6 = (_sqlite3_value_text($5)|0); //@line 98129 "c/sqlite3.c"
 $7 = ((($2)) + 4|0); //@line 98130 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 98130 "c/sqlite3.c"
 $9 = (_sqlite3_value_text($8)|0); //@line 98130 "c/sqlite3.c"
 $10 = ((($2)) + 8|0); //@line 98131 "c/sqlite3.c"
 $11 = HEAP32[$10>>2]|0; //@line 98131 "c/sqlite3.c"
 $12 = (_sqlite3_value_text($11)|0); //@line 98131 "c/sqlite3.c"
 $13 = ($6|0)==(0|0); //@line 98138 "c/sqlite3.c"
 $14 = ($9|0)==(0|0); //@line 98138 "c/sqlite3.c"
 $or$cond = $13 | $14; //@line 98138 "c/sqlite3.c"
 if ($or$cond) {
  STACKTOP = sp;return; //@line 98167 "c/sqlite3.c"
 }
 $15 = HEAP8[$6>>0]|0; //@line 98139 "c/sqlite3.c"
 $16 = ($15<<24>>24)==(0); //@line 98139 "c/sqlite3.c"
 L4: do {
  if ($16) {
   $$06482 = $6;$$080 = 0;
  } else {
   $$06484 = $6;$$07283 = $6;$$085 = 0;
   while(1) {
    $17 = (_sqlite3GetToken($$07283,$3)|0); //@line 98140 "c/sqlite3.c"
    $18 = HEAP32[$3>>2]|0; //@line 98141 "c/sqlite3.c"
    $19 = ($18|0)==(105); //@line 98141 "c/sqlite3.c"
    if ($19) {
     $$070 = $17;$$173 = $$07283;
     L10: while(1) {
      $20 = (($$173) + ($$070)|0); //@line 98144 "c/sqlite3.c"
      $21 = (_sqlite3GetToken($20,$3)|0); //@line 98145 "c/sqlite3.c"
      $22 = HEAP32[$3>>2]|0; //@line 98146 "c/sqlite3.c"
      switch ($22|0) {
      case 159:  {
       $$06482 = $$06484;$$080 = $$085;
       break L4;
       break;
      }
      case 158:  {
       $$070 = $21;$$173 = $20;
       break;
      }
      default: {
       break L10;
      }
      }
     }
     $23 = ($21|0)<(0); //@line 98149 "c/sqlite3.c"
     $24 = $23 << 31 >> 31; //@line 98149 "c/sqlite3.c"
     $25 = (_sqlite3DbStrNDup($4,$20,$21,$24)|0); //@line 98149 "c/sqlite3.c"
     $26 = ($25|0)==(0|0); //@line 98150 "c/sqlite3.c"
     if ($26) {
      $$06482 = $$06484;$$080 = $$085;
      break L4;
     }
     _sqlite3Dequote($25); //@line 98151 "c/sqlite3.c"
     $27 = (_sqlite3StrICmp($9,$25)|0); //@line 98152 "c/sqlite3.c"
     $28 = ($27|0)==(0); //@line 98152 "c/sqlite3.c"
     if ($28) {
      $29 = (($20) + ($21)|0); //@line 98158 "c/sqlite3.c"
      $30 = $20; //@line 98154 "c/sqlite3.c"
      $31 = $$06484; //@line 98154 "c/sqlite3.c"
      $32 = (($30) - ($31))|0; //@line 98154 "c/sqlite3.c"
      $33 = ($$085|0)==(0|0); //@line 98154 "c/sqlite3.c"
      $34 = $33 ? 41388 : $$085; //@line 98154 "c/sqlite3.c"
      HEAP32[$vararg_buffer>>2] = $34; //@line 98153 "c/sqlite3.c"
      $vararg_ptr1 = ((($vararg_buffer)) + 4|0); //@line 98153 "c/sqlite3.c"
      HEAP32[$vararg_ptr1>>2] = $32; //@line 98153 "c/sqlite3.c"
      $vararg_ptr2 = ((($vararg_buffer)) + 8|0); //@line 98153 "c/sqlite3.c"
      HEAP32[$vararg_ptr2>>2] = $$06484; //@line 98153 "c/sqlite3.c"
      $vararg_ptr3 = ((($vararg_buffer)) + 12|0); //@line 98153 "c/sqlite3.c"
      HEAP32[$vararg_ptr3>>2] = $12; //@line 98153 "c/sqlite3.c"
      $35 = (_sqlite3MPrintf($4,38150,$vararg_buffer)|0); //@line 98153 "c/sqlite3.c"
      _sqlite3DbFree($4,$$085); //@line 98156 "c/sqlite3.c"
      $$1 = $35;$$165 = $29;
     } else {
      $$1 = $$085;$$165 = $$06484;
     }
     _sqlite3DbFree($4,$25); //@line 98160 "c/sqlite3.c"
     $$171 = $21;$$274 = $20;$$3 = $$1;$$367 = $$165;
    } else {
     $$171 = $17;$$274 = $$07283;$$3 = $$085;$$367 = $$06484;
    }
    $36 = (($$274) + ($$171)|0); //@line 98139 "c/sqlite3.c"
    $37 = HEAP8[$36>>0]|0; //@line 98139 "c/sqlite3.c"
    $38 = ($37<<24>>24)==(0); //@line 98139 "c/sqlite3.c"
    if ($38) {
     $$06482 = $$367;$$080 = $$3;
     break;
    } else {
     $$06484 = $$367;$$07283 = $36;$$085 = $$3;
    }
   }
  }
 } while(0);
 $39 = ($$080|0)==(0|0); //@line 98164 "c/sqlite3.c"
 $40 = $39 ? 41388 : $$080; //@line 98164 "c/sqlite3.c"
 HEAP32[$vararg_buffer4>>2] = $40; //@line 98164 "c/sqlite3.c"
 $vararg_ptr7 = ((($vararg_buffer4)) + 4|0); //@line 98164 "c/sqlite3.c"
 HEAP32[$vararg_ptr7>>2] = $$06482; //@line 98164 "c/sqlite3.c"
 $41 = (_sqlite3MPrintf($4,22145,$vararg_buffer4)|0); //@line 98164 "c/sqlite3.c"
 _sqlite3_result_text($0,$41,-1,157); //@line 98165 "c/sqlite3.c"
 _sqlite3DbFree($4,$$080); //@line 98166 "c/sqlite3.c"
 STACKTOP = sp;return; //@line 98167 "c/sqlite3.c"
}
function _noopMutexInit() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 23878 "c/sqlite3.c"
}
function _pthreadMutexInit() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 24159 "c/sqlite3.c"
}
function _pthreadMutexEnd() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 24160 "c/sqlite3.c"
}
function _pthreadMutexAlloc($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 switch ($0|0) {
 case 1:  {
  $2 = (_sqlite3MallocZero(28,0)|0); //@line 24228 "c/sqlite3.c"
  $3 = ($2|0)==(0|0); //@line 24229 "c/sqlite3.c"
  if ($3) {
   $$0 = $2;
  } else {
   (_pthread_mutexattr_init(($1|0))|0); //@line 24237 "c/sqlite3.c"
   (_pthread_mutexattr_settype(($1|0),1)|0); //@line 24238 "c/sqlite3.c"
   (_pthread_mutex_init(($2|0),($1|0))|0); //@line 24239 "c/sqlite3.c"
   (_pthread_mutexattr_destroy(($1|0))|0); //@line 24240 "c/sqlite3.c"
   $$0 = $2;
  }
  break;
 }
 case 0:  {
  $4 = (_sqlite3MallocZero(28,0)|0); //@line 24246 "c/sqlite3.c"
  $5 = ($4|0)==(0|0); //@line 24247 "c/sqlite3.c"
  if ($5) {
   $$0 = $4;
  } else {
   (_pthread_mutex_init(($4|0),(0|0))|0); //@line 24248 "c/sqlite3.c"
   $$0 = $4;
  }
  break;
 }
 default: {
  $6 = (($0) + -2)|0; //@line 24259 "c/sqlite3.c"
  $7 = (40456 + (($6*28)|0)|0); //@line 24259 "c/sqlite3.c"
  $$0 = $7;
 }
 }
 STACKTOP = sp;return ($$0|0); //@line 24266 "c/sqlite3.c"
}
function _pthreadMutexFree($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_pthread_mutex_destroy(($0|0))|0); //@line 24281 "c/sqlite3.c"
 _sqlite3_free($0); //@line 24282 "c/sqlite3.c"
 return; //@line 24289 "c/sqlite3.c"
}
function _pthreadMutexEnter($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_pthread_mutex_lock(($0|0))|0); //@line 24330 "c/sqlite3.c"
 return; //@line 24343 "c/sqlite3.c"
}
function _pthreadMutexTry($0) {
 $0 = $0|0;
 var $$ = 0, $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_pthread_mutex_trylock(($0|0))|0); //@line 24376 "c/sqlite3.c"
 $2 = ($1|0)==(0); //@line 24376 "c/sqlite3.c"
 $$ = $2 ? 0 : 5; //@line 24382 "c/sqlite3.c"
 return ($$|0); //@line 24392 "c/sqlite3.c"
}
function _pthreadMutexLeave($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (_pthread_mutex_unlock(($0|0))|0); //@line 24414 "c/sqlite3.c"
 return; //@line 24422 "c/sqlite3.c"
}
function _noopMutexEnd() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 23879 "c/sqlite3.c"
}
function _noopMutexAlloc($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return ((8)|0); //@line 23882 "c/sqlite3.c"
}
function _noopMutexFree($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 23884 "c/sqlite3.c"
}
function _noopMutexEnter($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 23885 "c/sqlite3.c"
}
function _noopMutexTry($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0; //@line 23888 "c/sqlite3.c"
}
function _noopMutexLeave($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return; //@line 23890 "c/sqlite3.c"
}
function _dbReallocFinish($0,$1,$2,$3) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = ((($0)) + 73|0); //@line 25700 "c/sqlite3.c"
 $5 = HEAP8[$4>>0]|0; //@line 25700 "c/sqlite3.c"
 $6 = ($5<<24>>24)==(0); //@line 25700 "c/sqlite3.c"
 do {
  if ($6) {
   $7 = (_isLookaside($0,$1)|0); //@line 25701 "c/sqlite3.c"
   $8 = ($7|0)==(0); //@line 25701 "c/sqlite3.c"
   if ($8) {
    $14 = (_sqlite3_realloc64($1,$2,$3)|0); //@line 25711 "c/sqlite3.c"
    $15 = ($14|0)==(0|0); //@line 25712 "c/sqlite3.c"
    if (!($15)) {
     $$0 = $14;
     break;
    }
    _sqlite3OomFault($0); //@line 25713 "c/sqlite3.c"
    $$0 = 0;
    break;
   } else {
    $9 = (_sqlite3DbMallocRawNN($0,$2,$3)|0); //@line 25702 "c/sqlite3.c"
    $10 = ($9|0)==(0|0); //@line 25703 "c/sqlite3.c"
    if ($10) {
     $$0 = 0;
     break;
    }
    $11 = ((($0)) + 268|0); //@line 25704 "c/sqlite3.c"
    $12 = HEAP16[$11>>1]|0; //@line 25704 "c/sqlite3.c"
    $13 = $12&65535; //@line 25704 "c/sqlite3.c"
    _memcpy(($9|0),($1|0),($13|0))|0; //@line 25704 "c/sqlite3.c"
    _sqlite3DbFree($0,$1); //@line 25705 "c/sqlite3.c"
    $$0 = $9;
    break;
   }
  } else {
   $$0 = 0;
  }
 } while(0);
 return ($$0|0); //@line 25719 "c/sqlite3.c"
}
function _enlargeAndAppend($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = (_sqlite3StrAccumEnlarge($0,$2)|0); //@line 26696 "c/sqlite3.c"
 $4 = ($3|0)>(0); //@line 26697 "c/sqlite3.c"
 if (!($4)) {
  return; //@line 26701 "c/sqlite3.c"
 }
 $5 = ((($0)) + 4|0); //@line 26698 "c/sqlite3.c"
 $6 = HEAP32[$5>>2]|0; //@line 26698 "c/sqlite3.c"
 $7 = ((($0)) + 16|0); //@line 26698 "c/sqlite3.c"
 $8 = HEAP32[$7>>2]|0; //@line 26698 "c/sqlite3.c"
 $9 = (($6) + ($8)|0); //@line 26698 "c/sqlite3.c"
 _memcpy(($9|0),($1|0),($3|0))|0; //@line 26698 "c/sqlite3.c"
 $10 = HEAP32[$7>>2]|0; //@line 26699 "c/sqlite3.c"
 $11 = (($10) + ($3))|0; //@line 26699 "c/sqlite3.c"
 HEAP32[$7>>2] = $11; //@line 26699 "c/sqlite3.c"
 return; //@line 26701 "c/sqlite3.c"
}
function _malloc($0) {
 $0 = $0|0;
 var $$0 = 0, $$0$i$i = 0, $$0$i$i$i = 0, $$0$i16$i = 0, $$0187$i = 0, $$0189$i = 0, $$0190$i = 0, $$0191$i = 0, $$0197 = 0, $$0199 = 0, $$02065$i$i = 0, $$0207$lcssa$i$i = 0, $$02074$i$i = 0, $$0211$i$i = 0, $$0212$i$i = 0, $$024372$i = 0, $$0286$i$i = 0, $$028711$i$i = 0, $$0288$lcssa$i$i = 0, $$028810$i$i = 0;
 var $$0294$i$i = 0, $$0295$i$i = 0, $$0340$i = 0, $$034217$i = 0, $$0343$lcssa$i = 0, $$034316$i = 0, $$0345$i = 0, $$0351$i = 0, $$0357$i = 0, $$0358$i = 0, $$0360$i = 0, $$0361$i = 0, $$0367$i = 0, $$1194$i = 0, $$1194$i$be = 0, $$1194$i$ph = 0, $$1196$i = 0, $$1196$i$be = 0, $$1196$i$ph = 0, $$124471$i = 0;
 var $$1290$i$i = 0, $$1290$i$i$be = 0, $$1290$i$i$ph = 0, $$1292$i$i = 0, $$1292$i$i$be = 0, $$1292$i$i$ph = 0, $$1341$i = 0, $$1346$i = 0, $$1362$i = 0, $$1369$i = 0, $$1369$i$be = 0, $$1369$i$ph = 0, $$1373$i = 0, $$1373$i$be = 0, $$1373$i$ph = 0, $$2234243136$i = 0, $$2247$ph$i = 0, $$2253$ph$i = 0, $$2353$i = 0, $$3$i = 0;
 var $$3$i$i = 0, $$3$i203 = 0, $$3$i203218 = 0, $$3348$i = 0, $$3371$i = 0, $$4$lcssa$i = 0, $$420$i = 0, $$420$i$ph = 0, $$4236$i = 0, $$4349$lcssa$i = 0, $$434919$i = 0, $$434919$i$ph = 0, $$4355$i = 0, $$535618$i = 0, $$535618$i$ph = 0, $$723947$i = 0, $$748$i = 0, $$pre = 0, $$pre$i = 0, $$pre$i$i = 0;
 var $$pre$i17$i = 0, $$pre$i208 = 0, $$pre$i210 = 0, $$pre$phi$i$iZ2D = 0, $$pre$phi$i18$iZ2D = 0, $$pre$phi$i209Z2D = 0, $$pre$phi$iZ2D = 0, $$pre$phi17$i$iZ2D = 0, $$pre$phiZ2D = 0, $$pre16$i$i = 0, $$sink = 0, $$sink325 = 0, $$sink326 = 0, $1 = 0, $10 = 0, $100 = 0, $1000 = 0, $1001 = 0, $1002 = 0, $1003 = 0;
 var $1004 = 0, $1005 = 0, $1006 = 0, $1007 = 0, $1008 = 0, $1009 = 0, $101 = 0, $1010 = 0, $1011 = 0, $1012 = 0, $1013 = 0, $1014 = 0, $1015 = 0, $1016 = 0, $1017 = 0, $1018 = 0, $1019 = 0, $102 = 0, $1020 = 0, $1021 = 0;
 var $1022 = 0, $1023 = 0, $1024 = 0, $1025 = 0, $1026 = 0, $1027 = 0, $1028 = 0, $1029 = 0, $103 = 0, $1030 = 0, $1031 = 0, $1032 = 0, $1033 = 0, $1034 = 0, $1035 = 0, $1036 = 0, $1037 = 0, $1038 = 0, $1039 = 0, $104 = 0;
 var $1040 = 0, $1041 = 0, $1042 = 0, $1043 = 0, $1044 = 0, $1045 = 0, $1046 = 0, $1047 = 0, $1048 = 0, $1049 = 0, $105 = 0, $1050 = 0, $1051 = 0, $1052 = 0, $1053 = 0, $1054 = 0, $1055 = 0, $1056 = 0, $1057 = 0, $1058 = 0;
 var $1059 = 0, $106 = 0, $1060 = 0, $1061 = 0, $1062 = 0, $1063 = 0, $1064 = 0, $1065 = 0, $1066 = 0, $1067 = 0, $1068 = 0, $1069 = 0, $107 = 0, $1070 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0;
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0;
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0;
 var $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0;
 var $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0;
 var $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0;
 var $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0;
 var $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0;
 var $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0;
 var $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0;
 var $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0;
 var $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0;
 var $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0;
 var $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0;
 var $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0;
 var $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0;
 var $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0;
 var $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0;
 var $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0;
 var $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0;
 var $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0;
 var $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0;
 var $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0;
 var $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0;
 var $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0;
 var $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0;
 var $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0;
 var $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0;
 var $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0;
 var $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0;
 var $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0;
 var $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0;
 var $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0, $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0, $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0;
 var $799 = 0, $8 = 0, $80 = 0, $800 = 0, $801 = 0, $802 = 0, $803 = 0, $804 = 0, $805 = 0, $806 = 0, $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0, $813 = 0, $814 = 0, $815 = 0;
 var $816 = 0, $817 = 0, $818 = 0, $819 = 0, $82 = 0, $820 = 0, $821 = 0, $822 = 0, $823 = 0, $824 = 0, $825 = 0, $826 = 0, $827 = 0, $828 = 0, $829 = 0, $83 = 0, $830 = 0, $831 = 0, $832 = 0, $833 = 0;
 var $834 = 0, $835 = 0, $836 = 0, $837 = 0, $838 = 0, $839 = 0, $84 = 0, $840 = 0, $841 = 0, $842 = 0, $843 = 0, $844 = 0, $845 = 0, $846 = 0, $847 = 0, $848 = 0, $849 = 0, $85 = 0, $850 = 0, $851 = 0;
 var $852 = 0, $853 = 0, $854 = 0, $855 = 0, $856 = 0, $857 = 0, $858 = 0, $859 = 0, $86 = 0, $860 = 0, $861 = 0, $862 = 0, $863 = 0, $864 = 0, $865 = 0, $866 = 0, $867 = 0, $868 = 0, $869 = 0, $87 = 0;
 var $870 = 0, $871 = 0, $872 = 0, $873 = 0, $874 = 0, $875 = 0, $876 = 0, $877 = 0, $878 = 0, $879 = 0, $88 = 0, $880 = 0, $881 = 0, $882 = 0, $883 = 0, $884 = 0, $885 = 0, $886 = 0, $887 = 0, $888 = 0;
 var $889 = 0, $89 = 0, $890 = 0, $891 = 0, $892 = 0, $893 = 0, $894 = 0, $895 = 0, $896 = 0, $897 = 0, $898 = 0, $899 = 0, $9 = 0, $90 = 0, $900 = 0, $901 = 0, $902 = 0, $903 = 0, $904 = 0, $905 = 0;
 var $906 = 0, $907 = 0, $908 = 0, $909 = 0, $91 = 0, $910 = 0, $911 = 0, $912 = 0, $913 = 0, $914 = 0, $915 = 0, $916 = 0, $917 = 0, $918 = 0, $919 = 0, $92 = 0, $920 = 0, $921 = 0, $922 = 0, $923 = 0;
 var $924 = 0, $925 = 0, $926 = 0, $927 = 0, $928 = 0, $929 = 0, $93 = 0, $930 = 0, $931 = 0, $932 = 0, $933 = 0, $934 = 0, $935 = 0, $936 = 0, $937 = 0, $938 = 0, $939 = 0, $94 = 0, $940 = 0, $941 = 0;
 var $942 = 0, $943 = 0, $944 = 0, $945 = 0, $946 = 0, $947 = 0, $948 = 0, $949 = 0, $95 = 0, $950 = 0, $951 = 0, $952 = 0, $953 = 0, $954 = 0, $955 = 0, $956 = 0, $957 = 0, $958 = 0, $959 = 0, $96 = 0;
 var $960 = 0, $961 = 0, $962 = 0, $963 = 0, $964 = 0, $965 = 0, $966 = 0, $967 = 0, $968 = 0, $969 = 0, $97 = 0, $970 = 0, $971 = 0, $972 = 0, $973 = 0, $974 = 0, $975 = 0, $976 = 0, $977 = 0, $978 = 0;
 var $979 = 0, $98 = 0, $980 = 0, $981 = 0, $982 = 0, $983 = 0, $984 = 0, $985 = 0, $986 = 0, $987 = 0, $988 = 0, $989 = 0, $99 = 0, $990 = 0, $991 = 0, $992 = 0, $993 = 0, $994 = 0, $995 = 0, $996 = 0;
 var $997 = 0, $998 = 0, $999 = 0, $cond$i = 0, $cond$i$i = 0, $cond$i207 = 0, $not$$i = 0, $or$cond$i = 0, $or$cond$i213 = 0, $or$cond1$i = 0, $or$cond11$i = 0, $or$cond2$i = 0, $or$cond2$i214 = 0, $or$cond5$i = 0, $or$cond50$i = 0, $or$cond51$i = 0, $or$cond6$i = 0, $or$cond7$i = 0, $or$cond8$i = 0, $or$cond8$not$i = 0;
 var $spec$select$i = 0, $spec$select$i205 = 0, $spec$select1$i = 0, $spec$select3$i = 0, $spec$select49$i = 0, $spec$select7$i = 0, $spec$select9$i = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 $2 = ($0>>>0)<(245);
 do {
  if ($2) {
   $3 = ($0>>>0)<(11);
   $4 = (($0) + 11)|0;
   $5 = $4 & -8;
   $6 = $3 ? 16 : $5;
   $7 = $6 >>> 3;
   $8 = HEAP32[10198]|0;
   $9 = $8 >>> $7;
   $10 = $9 & 3;
   $11 = ($10|0)==(0);
   if (!($11)) {
    $12 = $9 & 1;
    $13 = $12 ^ 1;
    $14 = (($13) + ($7))|0;
    $15 = $14 << 1;
    $16 = (40832 + ($15<<2)|0);
    $17 = ((($16)) + 8|0);
    $18 = HEAP32[$17>>2]|0;
    $19 = ((($18)) + 8|0);
    $20 = HEAP32[$19>>2]|0;
    $21 = ($20|0)==($16|0);
    do {
     if ($21) {
      $22 = 1 << $14;
      $23 = $22 ^ -1;
      $24 = $8 & $23;
      HEAP32[10198] = $24;
     } else {
      $25 = HEAP32[(40808)>>2]|0;
      $26 = ($25>>>0)>($20>>>0);
      if ($26) {
       _abort();
       // unreachable;
      }
      $27 = ((($20)) + 12|0);
      $28 = HEAP32[$27>>2]|0;
      $29 = ($28|0)==($18|0);
      if ($29) {
       HEAP32[$27>>2] = $16;
       HEAP32[$17>>2] = $20;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $30 = $14 << 3;
    $31 = $30 | 3;
    $32 = ((($18)) + 4|0);
    HEAP32[$32>>2] = $31;
    $33 = (($18) + ($30)|0);
    $34 = ((($33)) + 4|0);
    $35 = HEAP32[$34>>2]|0;
    $36 = $35 | 1;
    HEAP32[$34>>2] = $36;
    $$0 = $19;
    STACKTOP = sp;return ($$0|0);
   }
   $37 = HEAP32[(40800)>>2]|0;
   $38 = ($6>>>0)>($37>>>0);
   if ($38) {
    $39 = ($9|0)==(0);
    if (!($39)) {
     $40 = $9 << $7;
     $41 = 2 << $7;
     $42 = (0 - ($41))|0;
     $43 = $41 | $42;
     $44 = $40 & $43;
     $45 = (0 - ($44))|0;
     $46 = $44 & $45;
     $47 = (($46) + -1)|0;
     $48 = $47 >>> 12;
     $49 = $48 & 16;
     $50 = $47 >>> $49;
     $51 = $50 >>> 5;
     $52 = $51 & 8;
     $53 = $52 | $49;
     $54 = $50 >>> $52;
     $55 = $54 >>> 2;
     $56 = $55 & 4;
     $57 = $53 | $56;
     $58 = $54 >>> $56;
     $59 = $58 >>> 1;
     $60 = $59 & 2;
     $61 = $57 | $60;
     $62 = $58 >>> $60;
     $63 = $62 >>> 1;
     $64 = $63 & 1;
     $65 = $61 | $64;
     $66 = $62 >>> $64;
     $67 = (($65) + ($66))|0;
     $68 = $67 << 1;
     $69 = (40832 + ($68<<2)|0);
     $70 = ((($69)) + 8|0);
     $71 = HEAP32[$70>>2]|0;
     $72 = ((($71)) + 8|0);
     $73 = HEAP32[$72>>2]|0;
     $74 = ($73|0)==($69|0);
     do {
      if ($74) {
       $75 = 1 << $67;
       $76 = $75 ^ -1;
       $77 = $8 & $76;
       HEAP32[10198] = $77;
       $98 = $77;
      } else {
       $78 = HEAP32[(40808)>>2]|0;
       $79 = ($78>>>0)>($73>>>0);
       if ($79) {
        _abort();
        // unreachable;
       }
       $80 = ((($73)) + 12|0);
       $81 = HEAP32[$80>>2]|0;
       $82 = ($81|0)==($71|0);
       if ($82) {
        HEAP32[$80>>2] = $69;
        HEAP32[$70>>2] = $73;
        $98 = $8;
        break;
       } else {
        _abort();
        // unreachable;
       }
      }
     } while(0);
     $83 = $67 << 3;
     $84 = (($83) - ($6))|0;
     $85 = $6 | 3;
     $86 = ((($71)) + 4|0);
     HEAP32[$86>>2] = $85;
     $87 = (($71) + ($6)|0);
     $88 = $84 | 1;
     $89 = ((($87)) + 4|0);
     HEAP32[$89>>2] = $88;
     $90 = (($71) + ($83)|0);
     HEAP32[$90>>2] = $84;
     $91 = ($37|0)==(0);
     if (!($91)) {
      $92 = HEAP32[(40812)>>2]|0;
      $93 = $37 >>> 3;
      $94 = $93 << 1;
      $95 = (40832 + ($94<<2)|0);
      $96 = 1 << $93;
      $97 = $98 & $96;
      $99 = ($97|0)==(0);
      if ($99) {
       $100 = $98 | $96;
       HEAP32[10198] = $100;
       $$pre = ((($95)) + 8|0);
       $$0199 = $95;$$pre$phiZ2D = $$pre;
      } else {
       $101 = ((($95)) + 8|0);
       $102 = HEAP32[$101>>2]|0;
       $103 = HEAP32[(40808)>>2]|0;
       $104 = ($103>>>0)>($102>>>0);
       if ($104) {
        _abort();
        // unreachable;
       } else {
        $$0199 = $102;$$pre$phiZ2D = $101;
       }
      }
      HEAP32[$$pre$phiZ2D>>2] = $92;
      $105 = ((($$0199)) + 12|0);
      HEAP32[$105>>2] = $92;
      $106 = ((($92)) + 8|0);
      HEAP32[$106>>2] = $$0199;
      $107 = ((($92)) + 12|0);
      HEAP32[$107>>2] = $95;
     }
     HEAP32[(40800)>>2] = $84;
     HEAP32[(40812)>>2] = $87;
     $$0 = $72;
     STACKTOP = sp;return ($$0|0);
    }
    $108 = HEAP32[(40796)>>2]|0;
    $109 = ($108|0)==(0);
    if ($109) {
     $$0197 = $6;
    } else {
     $110 = (0 - ($108))|0;
     $111 = $108 & $110;
     $112 = (($111) + -1)|0;
     $113 = $112 >>> 12;
     $114 = $113 & 16;
     $115 = $112 >>> $114;
     $116 = $115 >>> 5;
     $117 = $116 & 8;
     $118 = $117 | $114;
     $119 = $115 >>> $117;
     $120 = $119 >>> 2;
     $121 = $120 & 4;
     $122 = $118 | $121;
     $123 = $119 >>> $121;
     $124 = $123 >>> 1;
     $125 = $124 & 2;
     $126 = $122 | $125;
     $127 = $123 >>> $125;
     $128 = $127 >>> 1;
     $129 = $128 & 1;
     $130 = $126 | $129;
     $131 = $127 >>> $129;
     $132 = (($130) + ($131))|0;
     $133 = (41096 + ($132<<2)|0);
     $134 = HEAP32[$133>>2]|0;
     $135 = ((($134)) + 4|0);
     $136 = HEAP32[$135>>2]|0;
     $137 = $136 & -8;
     $138 = (($137) - ($6))|0;
     $$0189$i = $134;$$0190$i = $134;$$0191$i = $138;
     while(1) {
      $139 = ((($$0189$i)) + 16|0);
      $140 = HEAP32[$139>>2]|0;
      $141 = ($140|0)==(0|0);
      if ($141) {
       $142 = ((($$0189$i)) + 20|0);
       $143 = HEAP32[$142>>2]|0;
       $144 = ($143|0)==(0|0);
       if ($144) {
        break;
       } else {
        $146 = $143;
       }
      } else {
       $146 = $140;
      }
      $145 = ((($146)) + 4|0);
      $147 = HEAP32[$145>>2]|0;
      $148 = $147 & -8;
      $149 = (($148) - ($6))|0;
      $150 = ($149>>>0)<($$0191$i>>>0);
      $spec$select$i = $150 ? $149 : $$0191$i;
      $spec$select1$i = $150 ? $146 : $$0190$i;
      $$0189$i = $146;$$0190$i = $spec$select1$i;$$0191$i = $spec$select$i;
     }
     $151 = HEAP32[(40808)>>2]|0;
     $152 = ($151>>>0)>($$0190$i>>>0);
     if ($152) {
      _abort();
      // unreachable;
     }
     $153 = (($$0190$i) + ($6)|0);
     $154 = ($153>>>0)>($$0190$i>>>0);
     if (!($154)) {
      _abort();
      // unreachable;
     }
     $155 = ((($$0190$i)) + 24|0);
     $156 = HEAP32[$155>>2]|0;
     $157 = ((($$0190$i)) + 12|0);
     $158 = HEAP32[$157>>2]|0;
     $159 = ($158|0)==($$0190$i|0);
     do {
      if ($159) {
       $169 = ((($$0190$i)) + 20|0);
       $170 = HEAP32[$169>>2]|0;
       $171 = ($170|0)==(0|0);
       if ($171) {
        $172 = ((($$0190$i)) + 16|0);
        $173 = HEAP32[$172>>2]|0;
        $174 = ($173|0)==(0|0);
        if ($174) {
         $$3$i = 0;
         break;
        } else {
         $$1194$i$ph = $173;$$1196$i$ph = $172;
        }
       } else {
        $$1194$i$ph = $170;$$1196$i$ph = $169;
       }
       $$1194$i = $$1194$i$ph;$$1196$i = $$1196$i$ph;
       while(1) {
        $175 = ((($$1194$i)) + 20|0);
        $176 = HEAP32[$175>>2]|0;
        $177 = ($176|0)==(0|0);
        if ($177) {
         $178 = ((($$1194$i)) + 16|0);
         $179 = HEAP32[$178>>2]|0;
         $180 = ($179|0)==(0|0);
         if ($180) {
          break;
         } else {
          $$1194$i$be = $179;$$1196$i$be = $178;
         }
        } else {
         $$1194$i$be = $176;$$1196$i$be = $175;
        }
        $$1194$i = $$1194$i$be;$$1196$i = $$1196$i$be;
       }
       $181 = ($151>>>0)>($$1196$i>>>0);
       if ($181) {
        _abort();
        // unreachable;
       } else {
        HEAP32[$$1196$i>>2] = 0;
        $$3$i = $$1194$i;
        break;
       }
      } else {
       $160 = ((($$0190$i)) + 8|0);
       $161 = HEAP32[$160>>2]|0;
       $162 = ($151>>>0)>($161>>>0);
       if ($162) {
        _abort();
        // unreachable;
       }
       $163 = ((($161)) + 12|0);
       $164 = HEAP32[$163>>2]|0;
       $165 = ($164|0)==($$0190$i|0);
       if (!($165)) {
        _abort();
        // unreachable;
       }
       $166 = ((($158)) + 8|0);
       $167 = HEAP32[$166>>2]|0;
       $168 = ($167|0)==($$0190$i|0);
       if ($168) {
        HEAP32[$163>>2] = $158;
        HEAP32[$166>>2] = $161;
        $$3$i = $158;
        break;
       } else {
        _abort();
        // unreachable;
       }
      }
     } while(0);
     $182 = ($156|0)==(0|0);
     L78: do {
      if (!($182)) {
       $183 = ((($$0190$i)) + 28|0);
       $184 = HEAP32[$183>>2]|0;
       $185 = (41096 + ($184<<2)|0);
       $186 = HEAP32[$185>>2]|0;
       $187 = ($$0190$i|0)==($186|0);
       do {
        if ($187) {
         HEAP32[$185>>2] = $$3$i;
         $cond$i = ($$3$i|0)==(0|0);
         if ($cond$i) {
          $188 = 1 << $184;
          $189 = $188 ^ -1;
          $190 = $108 & $189;
          HEAP32[(40796)>>2] = $190;
          break L78;
         }
        } else {
         $191 = HEAP32[(40808)>>2]|0;
         $192 = ($191>>>0)>($156>>>0);
         if ($192) {
          _abort();
          // unreachable;
         } else {
          $193 = ((($156)) + 16|0);
          $194 = HEAP32[$193>>2]|0;
          $195 = ($194|0)==($$0190$i|0);
          $196 = ((($156)) + 20|0);
          $$sink = $195 ? $193 : $196;
          HEAP32[$$sink>>2] = $$3$i;
          $197 = ($$3$i|0)==(0|0);
          if ($197) {
           break L78;
          } else {
           break;
          }
         }
        }
       } while(0);
       $198 = HEAP32[(40808)>>2]|0;
       $199 = ($198>>>0)>($$3$i>>>0);
       if ($199) {
        _abort();
        // unreachable;
       }
       $200 = ((($$3$i)) + 24|0);
       HEAP32[$200>>2] = $156;
       $201 = ((($$0190$i)) + 16|0);
       $202 = HEAP32[$201>>2]|0;
       $203 = ($202|0)==(0|0);
       do {
        if (!($203)) {
         $204 = ($198>>>0)>($202>>>0);
         if ($204) {
          _abort();
          // unreachable;
         } else {
          $205 = ((($$3$i)) + 16|0);
          HEAP32[$205>>2] = $202;
          $206 = ((($202)) + 24|0);
          HEAP32[$206>>2] = $$3$i;
          break;
         }
        }
       } while(0);
       $207 = ((($$0190$i)) + 20|0);
       $208 = HEAP32[$207>>2]|0;
       $209 = ($208|0)==(0|0);
       if (!($209)) {
        $210 = HEAP32[(40808)>>2]|0;
        $211 = ($210>>>0)>($208>>>0);
        if ($211) {
         _abort();
         // unreachable;
        } else {
         $212 = ((($$3$i)) + 20|0);
         HEAP32[$212>>2] = $208;
         $213 = ((($208)) + 24|0);
         HEAP32[$213>>2] = $$3$i;
         break;
        }
       }
      }
     } while(0);
     $214 = ($$0191$i>>>0)<(16);
     if ($214) {
      $215 = (($$0191$i) + ($6))|0;
      $216 = $215 | 3;
      $217 = ((($$0190$i)) + 4|0);
      HEAP32[$217>>2] = $216;
      $218 = (($$0190$i) + ($215)|0);
      $219 = ((($218)) + 4|0);
      $220 = HEAP32[$219>>2]|0;
      $221 = $220 | 1;
      HEAP32[$219>>2] = $221;
     } else {
      $222 = $6 | 3;
      $223 = ((($$0190$i)) + 4|0);
      HEAP32[$223>>2] = $222;
      $224 = $$0191$i | 1;
      $225 = ((($153)) + 4|0);
      HEAP32[$225>>2] = $224;
      $226 = (($153) + ($$0191$i)|0);
      HEAP32[$226>>2] = $$0191$i;
      $227 = ($37|0)==(0);
      if (!($227)) {
       $228 = HEAP32[(40812)>>2]|0;
       $229 = $37 >>> 3;
       $230 = $229 << 1;
       $231 = (40832 + ($230<<2)|0);
       $232 = 1 << $229;
       $233 = $232 & $8;
       $234 = ($233|0)==(0);
       if ($234) {
        $235 = $232 | $8;
        HEAP32[10198] = $235;
        $$pre$i = ((($231)) + 8|0);
        $$0187$i = $231;$$pre$phi$iZ2D = $$pre$i;
       } else {
        $236 = ((($231)) + 8|0);
        $237 = HEAP32[$236>>2]|0;
        $238 = HEAP32[(40808)>>2]|0;
        $239 = ($238>>>0)>($237>>>0);
        if ($239) {
         _abort();
         // unreachable;
        } else {
         $$0187$i = $237;$$pre$phi$iZ2D = $236;
        }
       }
       HEAP32[$$pre$phi$iZ2D>>2] = $228;
       $240 = ((($$0187$i)) + 12|0);
       HEAP32[$240>>2] = $228;
       $241 = ((($228)) + 8|0);
       HEAP32[$241>>2] = $$0187$i;
       $242 = ((($228)) + 12|0);
       HEAP32[$242>>2] = $231;
      }
      HEAP32[(40800)>>2] = $$0191$i;
      HEAP32[(40812)>>2] = $153;
     }
     $243 = ((($$0190$i)) + 8|0);
     $$0 = $243;
     STACKTOP = sp;return ($$0|0);
    }
   } else {
    $$0197 = $6;
   }
  } else {
   $244 = ($0>>>0)>(4294967231);
   if ($244) {
    $$0197 = -1;
   } else {
    $245 = (($0) + 11)|0;
    $246 = $245 & -8;
    $247 = HEAP32[(40796)>>2]|0;
    $248 = ($247|0)==(0);
    if ($248) {
     $$0197 = $246;
    } else {
     $249 = (0 - ($246))|0;
     $250 = $245 >>> 8;
     $251 = ($250|0)==(0);
     if ($251) {
      $$0357$i = 0;
     } else {
      $252 = ($246>>>0)>(16777215);
      if ($252) {
       $$0357$i = 31;
      } else {
       $253 = (($250) + 1048320)|0;
       $254 = $253 >>> 16;
       $255 = $254 & 8;
       $256 = $250 << $255;
       $257 = (($256) + 520192)|0;
       $258 = $257 >>> 16;
       $259 = $258 & 4;
       $260 = $259 | $255;
       $261 = $256 << $259;
       $262 = (($261) + 245760)|0;
       $263 = $262 >>> 16;
       $264 = $263 & 2;
       $265 = $260 | $264;
       $266 = (14 - ($265))|0;
       $267 = $261 << $264;
       $268 = $267 >>> 15;
       $269 = (($266) + ($268))|0;
       $270 = $269 << 1;
       $271 = (($269) + 7)|0;
       $272 = $246 >>> $271;
       $273 = $272 & 1;
       $274 = $273 | $270;
       $$0357$i = $274;
      }
     }
     $275 = (41096 + ($$0357$i<<2)|0);
     $276 = HEAP32[$275>>2]|0;
     $277 = ($276|0)==(0|0);
     L122: do {
      if ($277) {
       $$2353$i = 0;$$3$i203 = 0;$$3348$i = $249;
       label = 85;
      } else {
       $278 = ($$0357$i|0)==(31);
       $279 = $$0357$i >>> 1;
       $280 = (25 - ($279))|0;
       $281 = $278 ? 0 : $280;
       $282 = $246 << $281;
       $$0340$i = 0;$$0345$i = $249;$$0351$i = $276;$$0358$i = $282;$$0361$i = 0;
       while(1) {
        $283 = ((($$0351$i)) + 4|0);
        $284 = HEAP32[$283>>2]|0;
        $285 = $284 & -8;
        $286 = (($285) - ($246))|0;
        $287 = ($286>>>0)<($$0345$i>>>0);
        if ($287) {
         $288 = ($286|0)==(0);
         if ($288) {
          $$420$i$ph = $$0351$i;$$434919$i$ph = 0;$$535618$i$ph = $$0351$i;
          label = 89;
          break L122;
         } else {
          $$1341$i = $$0351$i;$$1346$i = $286;
         }
        } else {
         $$1341$i = $$0340$i;$$1346$i = $$0345$i;
        }
        $289 = ((($$0351$i)) + 20|0);
        $290 = HEAP32[$289>>2]|0;
        $291 = $$0358$i >>> 31;
        $292 = (((($$0351$i)) + 16|0) + ($291<<2)|0);
        $293 = HEAP32[$292>>2]|0;
        $294 = ($290|0)==(0|0);
        $295 = ($290|0)==($293|0);
        $or$cond2$i = $294 | $295;
        $$1362$i = $or$cond2$i ? $$0361$i : $290;
        $296 = ($293|0)==(0|0);
        $spec$select7$i = $$0358$i << 1;
        if ($296) {
         $$2353$i = $$1362$i;$$3$i203 = $$1341$i;$$3348$i = $$1346$i;
         label = 85;
         break;
        } else {
         $$0340$i = $$1341$i;$$0345$i = $$1346$i;$$0351$i = $293;$$0358$i = $spec$select7$i;$$0361$i = $$1362$i;
        }
       }
      }
     } while(0);
     if ((label|0) == 85) {
      $297 = ($$2353$i|0)==(0|0);
      $298 = ($$3$i203|0)==(0|0);
      $or$cond$i = $297 & $298;
      if ($or$cond$i) {
       $299 = 2 << $$0357$i;
       $300 = (0 - ($299))|0;
       $301 = $299 | $300;
       $302 = $301 & $247;
       $303 = ($302|0)==(0);
       if ($303) {
        $$0197 = $246;
        break;
       }
       $304 = (0 - ($302))|0;
       $305 = $302 & $304;
       $306 = (($305) + -1)|0;
       $307 = $306 >>> 12;
       $308 = $307 & 16;
       $309 = $306 >>> $308;
       $310 = $309 >>> 5;
       $311 = $310 & 8;
       $312 = $311 | $308;
       $313 = $309 >>> $311;
       $314 = $313 >>> 2;
       $315 = $314 & 4;
       $316 = $312 | $315;
       $317 = $313 >>> $315;
       $318 = $317 >>> 1;
       $319 = $318 & 2;
       $320 = $316 | $319;
       $321 = $317 >>> $319;
       $322 = $321 >>> 1;
       $323 = $322 & 1;
       $324 = $320 | $323;
       $325 = $321 >>> $323;
       $326 = (($324) + ($325))|0;
       $327 = (41096 + ($326<<2)|0);
       $328 = HEAP32[$327>>2]|0;
       $$3$i203218 = 0;$$4355$i = $328;
      } else {
       $$3$i203218 = $$3$i203;$$4355$i = $$2353$i;
      }
      $329 = ($$4355$i|0)==(0|0);
      if ($329) {
       $$4$lcssa$i = $$3$i203218;$$4349$lcssa$i = $$3348$i;
      } else {
       $$420$i$ph = $$3$i203218;$$434919$i$ph = $$3348$i;$$535618$i$ph = $$4355$i;
       label = 89;
      }
     }
     if ((label|0) == 89) {
      $$420$i = $$420$i$ph;$$434919$i = $$434919$i$ph;$$535618$i = $$535618$i$ph;
      while(1) {
       $330 = ((($$535618$i)) + 4|0);
       $331 = HEAP32[$330>>2]|0;
       $332 = $331 & -8;
       $333 = (($332) - ($246))|0;
       $334 = ($333>>>0)<($$434919$i>>>0);
       $spec$select$i205 = $334 ? $333 : $$434919$i;
       $spec$select3$i = $334 ? $$535618$i : $$420$i;
       $335 = ((($$535618$i)) + 16|0);
       $336 = HEAP32[$335>>2]|0;
       $337 = ($336|0)==(0|0);
       if ($337) {
        $338 = ((($$535618$i)) + 20|0);
        $339 = HEAP32[$338>>2]|0;
        $341 = $339;
       } else {
        $341 = $336;
       }
       $340 = ($341|0)==(0|0);
       if ($340) {
        $$4$lcssa$i = $spec$select3$i;$$4349$lcssa$i = $spec$select$i205;
        break;
       } else {
        $$420$i = $spec$select3$i;$$434919$i = $spec$select$i205;$$535618$i = $341;
       }
      }
     }
     $342 = ($$4$lcssa$i|0)==(0|0);
     if ($342) {
      $$0197 = $246;
     } else {
      $343 = HEAP32[(40800)>>2]|0;
      $344 = (($343) - ($246))|0;
      $345 = ($$4349$lcssa$i>>>0)<($344>>>0);
      if ($345) {
       $346 = HEAP32[(40808)>>2]|0;
       $347 = ($346>>>0)>($$4$lcssa$i>>>0);
       if ($347) {
        _abort();
        // unreachable;
       }
       $348 = (($$4$lcssa$i) + ($246)|0);
       $349 = ($348>>>0)>($$4$lcssa$i>>>0);
       if (!($349)) {
        _abort();
        // unreachable;
       }
       $350 = ((($$4$lcssa$i)) + 24|0);
       $351 = HEAP32[$350>>2]|0;
       $352 = ((($$4$lcssa$i)) + 12|0);
       $353 = HEAP32[$352>>2]|0;
       $354 = ($353|0)==($$4$lcssa$i|0);
       do {
        if ($354) {
         $364 = ((($$4$lcssa$i)) + 20|0);
         $365 = HEAP32[$364>>2]|0;
         $366 = ($365|0)==(0|0);
         if ($366) {
          $367 = ((($$4$lcssa$i)) + 16|0);
          $368 = HEAP32[$367>>2]|0;
          $369 = ($368|0)==(0|0);
          if ($369) {
           $$3371$i = 0;
           break;
          } else {
           $$1369$i$ph = $368;$$1373$i$ph = $367;
          }
         } else {
          $$1369$i$ph = $365;$$1373$i$ph = $364;
         }
         $$1369$i = $$1369$i$ph;$$1373$i = $$1373$i$ph;
         while(1) {
          $370 = ((($$1369$i)) + 20|0);
          $371 = HEAP32[$370>>2]|0;
          $372 = ($371|0)==(0|0);
          if ($372) {
           $373 = ((($$1369$i)) + 16|0);
           $374 = HEAP32[$373>>2]|0;
           $375 = ($374|0)==(0|0);
           if ($375) {
            break;
           } else {
            $$1369$i$be = $374;$$1373$i$be = $373;
           }
          } else {
           $$1369$i$be = $371;$$1373$i$be = $370;
          }
          $$1369$i = $$1369$i$be;$$1373$i = $$1373$i$be;
         }
         $376 = ($346>>>0)>($$1373$i>>>0);
         if ($376) {
          _abort();
          // unreachable;
         } else {
          HEAP32[$$1373$i>>2] = 0;
          $$3371$i = $$1369$i;
          break;
         }
        } else {
         $355 = ((($$4$lcssa$i)) + 8|0);
         $356 = HEAP32[$355>>2]|0;
         $357 = ($346>>>0)>($356>>>0);
         if ($357) {
          _abort();
          // unreachable;
         }
         $358 = ((($356)) + 12|0);
         $359 = HEAP32[$358>>2]|0;
         $360 = ($359|0)==($$4$lcssa$i|0);
         if (!($360)) {
          _abort();
          // unreachable;
         }
         $361 = ((($353)) + 8|0);
         $362 = HEAP32[$361>>2]|0;
         $363 = ($362|0)==($$4$lcssa$i|0);
         if ($363) {
          HEAP32[$358>>2] = $353;
          HEAP32[$361>>2] = $356;
          $$3371$i = $353;
          break;
         } else {
          _abort();
          // unreachable;
         }
        }
       } while(0);
       $377 = ($351|0)==(0|0);
       L176: do {
        if ($377) {
         $469 = $247;
        } else {
         $378 = ((($$4$lcssa$i)) + 28|0);
         $379 = HEAP32[$378>>2]|0;
         $380 = (41096 + ($379<<2)|0);
         $381 = HEAP32[$380>>2]|0;
         $382 = ($$4$lcssa$i|0)==($381|0);
         do {
          if ($382) {
           HEAP32[$380>>2] = $$3371$i;
           $cond$i207 = ($$3371$i|0)==(0|0);
           if ($cond$i207) {
            $383 = 1 << $379;
            $384 = $383 ^ -1;
            $385 = $247 & $384;
            HEAP32[(40796)>>2] = $385;
            $469 = $385;
            break L176;
           }
          } else {
           $386 = HEAP32[(40808)>>2]|0;
           $387 = ($386>>>0)>($351>>>0);
           if ($387) {
            _abort();
            // unreachable;
           } else {
            $388 = ((($351)) + 16|0);
            $389 = HEAP32[$388>>2]|0;
            $390 = ($389|0)==($$4$lcssa$i|0);
            $391 = ((($351)) + 20|0);
            $$sink325 = $390 ? $388 : $391;
            HEAP32[$$sink325>>2] = $$3371$i;
            $392 = ($$3371$i|0)==(0|0);
            if ($392) {
             $469 = $247;
             break L176;
            } else {
             break;
            }
           }
          }
         } while(0);
         $393 = HEAP32[(40808)>>2]|0;
         $394 = ($393>>>0)>($$3371$i>>>0);
         if ($394) {
          _abort();
          // unreachable;
         }
         $395 = ((($$3371$i)) + 24|0);
         HEAP32[$395>>2] = $351;
         $396 = ((($$4$lcssa$i)) + 16|0);
         $397 = HEAP32[$396>>2]|0;
         $398 = ($397|0)==(0|0);
         do {
          if (!($398)) {
           $399 = ($393>>>0)>($397>>>0);
           if ($399) {
            _abort();
            // unreachable;
           } else {
            $400 = ((($$3371$i)) + 16|0);
            HEAP32[$400>>2] = $397;
            $401 = ((($397)) + 24|0);
            HEAP32[$401>>2] = $$3371$i;
            break;
           }
          }
         } while(0);
         $402 = ((($$4$lcssa$i)) + 20|0);
         $403 = HEAP32[$402>>2]|0;
         $404 = ($403|0)==(0|0);
         if ($404) {
          $469 = $247;
         } else {
          $405 = HEAP32[(40808)>>2]|0;
          $406 = ($405>>>0)>($403>>>0);
          if ($406) {
           _abort();
           // unreachable;
          } else {
           $407 = ((($$3371$i)) + 20|0);
           HEAP32[$407>>2] = $403;
           $408 = ((($403)) + 24|0);
           HEAP32[$408>>2] = $$3371$i;
           $469 = $247;
           break;
          }
         }
        }
       } while(0);
       $409 = ($$4349$lcssa$i>>>0)<(16);
       L200: do {
        if ($409) {
         $410 = (($$4349$lcssa$i) + ($246))|0;
         $411 = $410 | 3;
         $412 = ((($$4$lcssa$i)) + 4|0);
         HEAP32[$412>>2] = $411;
         $413 = (($$4$lcssa$i) + ($410)|0);
         $414 = ((($413)) + 4|0);
         $415 = HEAP32[$414>>2]|0;
         $416 = $415 | 1;
         HEAP32[$414>>2] = $416;
        } else {
         $417 = $246 | 3;
         $418 = ((($$4$lcssa$i)) + 4|0);
         HEAP32[$418>>2] = $417;
         $419 = $$4349$lcssa$i | 1;
         $420 = ((($348)) + 4|0);
         HEAP32[$420>>2] = $419;
         $421 = (($348) + ($$4349$lcssa$i)|0);
         HEAP32[$421>>2] = $$4349$lcssa$i;
         $422 = $$4349$lcssa$i >>> 3;
         $423 = ($$4349$lcssa$i>>>0)<(256);
         if ($423) {
          $424 = $422 << 1;
          $425 = (40832 + ($424<<2)|0);
          $426 = HEAP32[10198]|0;
          $427 = 1 << $422;
          $428 = $426 & $427;
          $429 = ($428|0)==(0);
          if ($429) {
           $430 = $426 | $427;
           HEAP32[10198] = $430;
           $$pre$i208 = ((($425)) + 8|0);
           $$0367$i = $425;$$pre$phi$i209Z2D = $$pre$i208;
          } else {
           $431 = ((($425)) + 8|0);
           $432 = HEAP32[$431>>2]|0;
           $433 = HEAP32[(40808)>>2]|0;
           $434 = ($433>>>0)>($432>>>0);
           if ($434) {
            _abort();
            // unreachable;
           } else {
            $$0367$i = $432;$$pre$phi$i209Z2D = $431;
           }
          }
          HEAP32[$$pre$phi$i209Z2D>>2] = $348;
          $435 = ((($$0367$i)) + 12|0);
          HEAP32[$435>>2] = $348;
          $436 = ((($348)) + 8|0);
          HEAP32[$436>>2] = $$0367$i;
          $437 = ((($348)) + 12|0);
          HEAP32[$437>>2] = $425;
          break;
         }
         $438 = $$4349$lcssa$i >>> 8;
         $439 = ($438|0)==(0);
         if ($439) {
          $$0360$i = 0;
         } else {
          $440 = ($$4349$lcssa$i>>>0)>(16777215);
          if ($440) {
           $$0360$i = 31;
          } else {
           $441 = (($438) + 1048320)|0;
           $442 = $441 >>> 16;
           $443 = $442 & 8;
           $444 = $438 << $443;
           $445 = (($444) + 520192)|0;
           $446 = $445 >>> 16;
           $447 = $446 & 4;
           $448 = $447 | $443;
           $449 = $444 << $447;
           $450 = (($449) + 245760)|0;
           $451 = $450 >>> 16;
           $452 = $451 & 2;
           $453 = $448 | $452;
           $454 = (14 - ($453))|0;
           $455 = $449 << $452;
           $456 = $455 >>> 15;
           $457 = (($454) + ($456))|0;
           $458 = $457 << 1;
           $459 = (($457) + 7)|0;
           $460 = $$4349$lcssa$i >>> $459;
           $461 = $460 & 1;
           $462 = $461 | $458;
           $$0360$i = $462;
          }
         }
         $463 = (41096 + ($$0360$i<<2)|0);
         $464 = ((($348)) + 28|0);
         HEAP32[$464>>2] = $$0360$i;
         $465 = ((($348)) + 16|0);
         $466 = ((($465)) + 4|0);
         HEAP32[$466>>2] = 0;
         HEAP32[$465>>2] = 0;
         $467 = 1 << $$0360$i;
         $468 = $469 & $467;
         $470 = ($468|0)==(0);
         if ($470) {
          $471 = $469 | $467;
          HEAP32[(40796)>>2] = $471;
          HEAP32[$463>>2] = $348;
          $472 = ((($348)) + 24|0);
          HEAP32[$472>>2] = $463;
          $473 = ((($348)) + 12|0);
          HEAP32[$473>>2] = $348;
          $474 = ((($348)) + 8|0);
          HEAP32[$474>>2] = $348;
          break;
         }
         $475 = HEAP32[$463>>2]|0;
         $476 = ((($475)) + 4|0);
         $477 = HEAP32[$476>>2]|0;
         $478 = $477 & -8;
         $479 = ($478|0)==($$4349$lcssa$i|0);
         L218: do {
          if ($479) {
           $$0343$lcssa$i = $475;
          } else {
           $480 = ($$0360$i|0)==(31);
           $481 = $$0360$i >>> 1;
           $482 = (25 - ($481))|0;
           $483 = $480 ? 0 : $482;
           $484 = $$4349$lcssa$i << $483;
           $$034217$i = $484;$$034316$i = $475;
           while(1) {
            $491 = $$034217$i >>> 31;
            $492 = (((($$034316$i)) + 16|0) + ($491<<2)|0);
            $487 = HEAP32[$492>>2]|0;
            $493 = ($487|0)==(0|0);
            if ($493) {
             break;
            }
            $485 = $$034217$i << 1;
            $486 = ((($487)) + 4|0);
            $488 = HEAP32[$486>>2]|0;
            $489 = $488 & -8;
            $490 = ($489|0)==($$4349$lcssa$i|0);
            if ($490) {
             $$0343$lcssa$i = $487;
             break L218;
            } else {
             $$034217$i = $485;$$034316$i = $487;
            }
           }
           $494 = HEAP32[(40808)>>2]|0;
           $495 = ($494>>>0)>($492>>>0);
           if ($495) {
            _abort();
            // unreachable;
           } else {
            HEAP32[$492>>2] = $348;
            $496 = ((($348)) + 24|0);
            HEAP32[$496>>2] = $$034316$i;
            $497 = ((($348)) + 12|0);
            HEAP32[$497>>2] = $348;
            $498 = ((($348)) + 8|0);
            HEAP32[$498>>2] = $348;
            break L200;
           }
          }
         } while(0);
         $499 = ((($$0343$lcssa$i)) + 8|0);
         $500 = HEAP32[$499>>2]|0;
         $501 = HEAP32[(40808)>>2]|0;
         $502 = ($501>>>0)<=($$0343$lcssa$i>>>0);
         $503 = ($501>>>0)<=($500>>>0);
         $504 = $503 & $502;
         if ($504) {
          $505 = ((($500)) + 12|0);
          HEAP32[$505>>2] = $348;
          HEAP32[$499>>2] = $348;
          $506 = ((($348)) + 8|0);
          HEAP32[$506>>2] = $500;
          $507 = ((($348)) + 12|0);
          HEAP32[$507>>2] = $$0343$lcssa$i;
          $508 = ((($348)) + 24|0);
          HEAP32[$508>>2] = 0;
          break;
         } else {
          _abort();
          // unreachable;
         }
        }
       } while(0);
       $509 = ((($$4$lcssa$i)) + 8|0);
       $$0 = $509;
       STACKTOP = sp;return ($$0|0);
      } else {
       $$0197 = $246;
      }
     }
    }
   }
  }
 } while(0);
 $510 = HEAP32[(40800)>>2]|0;
 $511 = ($510>>>0)<($$0197>>>0);
 if (!($511)) {
  $512 = (($510) - ($$0197))|0;
  $513 = HEAP32[(40812)>>2]|0;
  $514 = ($512>>>0)>(15);
  if ($514) {
   $515 = (($513) + ($$0197)|0);
   HEAP32[(40812)>>2] = $515;
   HEAP32[(40800)>>2] = $512;
   $516 = $512 | 1;
   $517 = ((($515)) + 4|0);
   HEAP32[$517>>2] = $516;
   $518 = (($513) + ($510)|0);
   HEAP32[$518>>2] = $512;
   $519 = $$0197 | 3;
   $520 = ((($513)) + 4|0);
   HEAP32[$520>>2] = $519;
  } else {
   HEAP32[(40800)>>2] = 0;
   HEAP32[(40812)>>2] = 0;
   $521 = $510 | 3;
   $522 = ((($513)) + 4|0);
   HEAP32[$522>>2] = $521;
   $523 = (($513) + ($510)|0);
   $524 = ((($523)) + 4|0);
   $525 = HEAP32[$524>>2]|0;
   $526 = $525 | 1;
   HEAP32[$524>>2] = $526;
  }
  $527 = ((($513)) + 8|0);
  $$0 = $527;
  STACKTOP = sp;return ($$0|0);
 }
 $528 = HEAP32[(40804)>>2]|0;
 $529 = ($528>>>0)>($$0197>>>0);
 if ($529) {
  $530 = (($528) - ($$0197))|0;
  HEAP32[(40804)>>2] = $530;
  $531 = HEAP32[(40816)>>2]|0;
  $532 = (($531) + ($$0197)|0);
  HEAP32[(40816)>>2] = $532;
  $533 = $530 | 1;
  $534 = ((($532)) + 4|0);
  HEAP32[$534>>2] = $533;
  $535 = $$0197 | 3;
  $536 = ((($531)) + 4|0);
  HEAP32[$536>>2] = $535;
  $537 = ((($531)) + 8|0);
  $$0 = $537;
  STACKTOP = sp;return ($$0|0);
 }
 $538 = HEAP32[10316]|0;
 $539 = ($538|0)==(0);
 if ($539) {
  HEAP32[(41272)>>2] = 4096;
  HEAP32[(41268)>>2] = 4096;
  HEAP32[(41276)>>2] = -1;
  HEAP32[(41280)>>2] = -1;
  HEAP32[(41284)>>2] = 0;
  HEAP32[(41236)>>2] = 0;
  $540 = $1;
  $541 = $540 & -16;
  $542 = $541 ^ 1431655768;
  HEAP32[10316] = $542;
  $546 = 4096;
 } else {
  $$pre$i210 = HEAP32[(41272)>>2]|0;
  $546 = $$pre$i210;
 }
 $543 = (($$0197) + 48)|0;
 $544 = (($$0197) + 47)|0;
 $545 = (($546) + ($544))|0;
 $547 = (0 - ($546))|0;
 $548 = $545 & $547;
 $549 = ($548>>>0)>($$0197>>>0);
 if (!($549)) {
  $$0 = 0;
  STACKTOP = sp;return ($$0|0);
 }
 $550 = HEAP32[(41232)>>2]|0;
 $551 = ($550|0)==(0);
 if (!($551)) {
  $552 = HEAP32[(41224)>>2]|0;
  $553 = (($552) + ($548))|0;
  $554 = ($553>>>0)<=($552>>>0);
  $555 = ($553>>>0)>($550>>>0);
  $or$cond1$i = $554 | $555;
  if ($or$cond1$i) {
   $$0 = 0;
   STACKTOP = sp;return ($$0|0);
  }
 }
 $556 = HEAP32[(41236)>>2]|0;
 $557 = $556 & 4;
 $558 = ($557|0)==(0);
 L257: do {
  if ($558) {
   $559 = HEAP32[(40816)>>2]|0;
   $560 = ($559|0)==(0|0);
   L259: do {
    if ($560) {
     label = 173;
    } else {
     $$0$i$i = (41240);
     while(1) {
      $561 = HEAP32[$$0$i$i>>2]|0;
      $562 = ($561>>>0)>($559>>>0);
      if (!($562)) {
       $563 = ((($$0$i$i)) + 4|0);
       $564 = HEAP32[$563>>2]|0;
       $565 = (($561) + ($564)|0);
       $566 = ($565>>>0)>($559>>>0);
       if ($566) {
        break;
       }
      }
      $567 = ((($$0$i$i)) + 8|0);
      $568 = HEAP32[$567>>2]|0;
      $569 = ($568|0)==(0|0);
      if ($569) {
       label = 173;
       break L259;
      } else {
       $$0$i$i = $568;
      }
     }
     $592 = (($545) - ($528))|0;
     $593 = $592 & $547;
     $594 = ($593>>>0)<(2147483647);
     if ($594) {
      $595 = ((($$0$i$i)) + 4|0);
      $596 = (_sbrk(($593|0))|0);
      $597 = HEAP32[$$0$i$i>>2]|0;
      $598 = HEAP32[$595>>2]|0;
      $599 = (($597) + ($598)|0);
      $600 = ($596|0)==($599|0);
      if ($600) {
       $601 = ($596|0)==((-1)|0);
       if ($601) {
        $$2234243136$i = $593;
       } else {
        $$723947$i = $593;$$748$i = $596;
        label = 190;
        break L257;
       }
      } else {
       $$2247$ph$i = $596;$$2253$ph$i = $593;
       label = 181;
      }
     } else {
      $$2234243136$i = 0;
     }
    }
   } while(0);
   do {
    if ((label|0) == 173) {
     $570 = (_sbrk(0)|0);
     $571 = ($570|0)==((-1)|0);
     if ($571) {
      $$2234243136$i = 0;
     } else {
      $572 = $570;
      $573 = HEAP32[(41268)>>2]|0;
      $574 = (($573) + -1)|0;
      $575 = $574 & $572;
      $576 = ($575|0)==(0);
      $577 = (($574) + ($572))|0;
      $578 = (0 - ($573))|0;
      $579 = $577 & $578;
      $580 = (($579) - ($572))|0;
      $581 = $576 ? 0 : $580;
      $spec$select49$i = (($581) + ($548))|0;
      $582 = HEAP32[(41224)>>2]|0;
      $583 = (($spec$select49$i) + ($582))|0;
      $584 = ($spec$select49$i>>>0)>($$0197>>>0);
      $585 = ($spec$select49$i>>>0)<(2147483647);
      $or$cond$i213 = $584 & $585;
      if ($or$cond$i213) {
       $586 = HEAP32[(41232)>>2]|0;
       $587 = ($586|0)==(0);
       if (!($587)) {
        $588 = ($583>>>0)<=($582>>>0);
        $589 = ($583>>>0)>($586>>>0);
        $or$cond2$i214 = $588 | $589;
        if ($or$cond2$i214) {
         $$2234243136$i = 0;
         break;
        }
       }
       $590 = (_sbrk(($spec$select49$i|0))|0);
       $591 = ($590|0)==($570|0);
       if ($591) {
        $$723947$i = $spec$select49$i;$$748$i = $570;
        label = 190;
        break L257;
       } else {
        $$2247$ph$i = $590;$$2253$ph$i = $spec$select49$i;
        label = 181;
       }
      } else {
       $$2234243136$i = 0;
      }
     }
    }
   } while(0);
   do {
    if ((label|0) == 181) {
     $602 = (0 - ($$2253$ph$i))|0;
     $603 = ($$2247$ph$i|0)!=((-1)|0);
     $604 = ($$2253$ph$i>>>0)<(2147483647);
     $or$cond7$i = $604 & $603;
     $605 = ($543>>>0)>($$2253$ph$i>>>0);
     $or$cond6$i = $605 & $or$cond7$i;
     if (!($or$cond6$i)) {
      $615 = ($$2247$ph$i|0)==((-1)|0);
      if ($615) {
       $$2234243136$i = 0;
       break;
      } else {
       $$723947$i = $$2253$ph$i;$$748$i = $$2247$ph$i;
       label = 190;
       break L257;
      }
     }
     $606 = HEAP32[(41272)>>2]|0;
     $607 = (($544) - ($$2253$ph$i))|0;
     $608 = (($607) + ($606))|0;
     $609 = (0 - ($606))|0;
     $610 = $608 & $609;
     $611 = ($610>>>0)<(2147483647);
     if (!($611)) {
      $$723947$i = $$2253$ph$i;$$748$i = $$2247$ph$i;
      label = 190;
      break L257;
     }
     $612 = (_sbrk(($610|0))|0);
     $613 = ($612|0)==((-1)|0);
     if ($613) {
      (_sbrk(($602|0))|0);
      $$2234243136$i = 0;
      break;
     } else {
      $614 = (($610) + ($$2253$ph$i))|0;
      $$723947$i = $614;$$748$i = $$2247$ph$i;
      label = 190;
      break L257;
     }
    }
   } while(0);
   $616 = HEAP32[(41236)>>2]|0;
   $617 = $616 | 4;
   HEAP32[(41236)>>2] = $617;
   $$4236$i = $$2234243136$i;
   label = 188;
  } else {
   $$4236$i = 0;
   label = 188;
  }
 } while(0);
 if ((label|0) == 188) {
  $618 = ($548>>>0)<(2147483647);
  if ($618) {
   $619 = (_sbrk(($548|0))|0);
   $620 = (_sbrk(0)|0);
   $621 = ($619|0)!=((-1)|0);
   $622 = ($620|0)!=((-1)|0);
   $or$cond5$i = $621 & $622;
   $623 = ($619>>>0)<($620>>>0);
   $or$cond8$i = $623 & $or$cond5$i;
   $624 = $620;
   $625 = $619;
   $626 = (($624) - ($625))|0;
   $627 = (($$0197) + 40)|0;
   $628 = ($626>>>0)>($627>>>0);
   $spec$select9$i = $628 ? $626 : $$4236$i;
   $or$cond8$not$i = $or$cond8$i ^ 1;
   $629 = ($619|0)==((-1)|0);
   $not$$i = $628 ^ 1;
   $630 = $629 | $not$$i;
   $or$cond50$i = $630 | $or$cond8$not$i;
   if (!($or$cond50$i)) {
    $$723947$i = $spec$select9$i;$$748$i = $619;
    label = 190;
   }
  }
 }
 if ((label|0) == 190) {
  $631 = HEAP32[(41224)>>2]|0;
  $632 = (($631) + ($$723947$i))|0;
  HEAP32[(41224)>>2] = $632;
  $633 = HEAP32[(41228)>>2]|0;
  $634 = ($632>>>0)>($633>>>0);
  if ($634) {
   HEAP32[(41228)>>2] = $632;
  }
  $635 = HEAP32[(40816)>>2]|0;
  $636 = ($635|0)==(0|0);
  L294: do {
   if ($636) {
    $637 = HEAP32[(40808)>>2]|0;
    $638 = ($637|0)==(0|0);
    $639 = ($$748$i>>>0)<($637>>>0);
    $or$cond11$i = $638 | $639;
    if ($or$cond11$i) {
     HEAP32[(40808)>>2] = $$748$i;
    }
    HEAP32[(41240)>>2] = $$748$i;
    HEAP32[(41244)>>2] = $$723947$i;
    HEAP32[(41252)>>2] = 0;
    $640 = HEAP32[10316]|0;
    HEAP32[(40828)>>2] = $640;
    HEAP32[(40824)>>2] = -1;
    HEAP32[(40844)>>2] = (40832);
    HEAP32[(40840)>>2] = (40832);
    HEAP32[(40852)>>2] = (40840);
    HEAP32[(40848)>>2] = (40840);
    HEAP32[(40860)>>2] = (40848);
    HEAP32[(40856)>>2] = (40848);
    HEAP32[(40868)>>2] = (40856);
    HEAP32[(40864)>>2] = (40856);
    HEAP32[(40876)>>2] = (40864);
    HEAP32[(40872)>>2] = (40864);
    HEAP32[(40884)>>2] = (40872);
    HEAP32[(40880)>>2] = (40872);
    HEAP32[(40892)>>2] = (40880);
    HEAP32[(40888)>>2] = (40880);
    HEAP32[(40900)>>2] = (40888);
    HEAP32[(40896)>>2] = (40888);
    HEAP32[(40908)>>2] = (40896);
    HEAP32[(40904)>>2] = (40896);
    HEAP32[(40916)>>2] = (40904);
    HEAP32[(40912)>>2] = (40904);
    HEAP32[(40924)>>2] = (40912);
    HEAP32[(40920)>>2] = (40912);
    HEAP32[(40932)>>2] = (40920);
    HEAP32[(40928)>>2] = (40920);
    HEAP32[(40940)>>2] = (40928);
    HEAP32[(40936)>>2] = (40928);
    HEAP32[(40948)>>2] = (40936);
    HEAP32[(40944)>>2] = (40936);
    HEAP32[(40956)>>2] = (40944);
    HEAP32[(40952)>>2] = (40944);
    HEAP32[(40964)>>2] = (40952);
    HEAP32[(40960)>>2] = (40952);
    HEAP32[(40972)>>2] = (40960);
    HEAP32[(40968)>>2] = (40960);
    HEAP32[(40980)>>2] = (40968);
    HEAP32[(40976)>>2] = (40968);
    HEAP32[(40988)>>2] = (40976);
    HEAP32[(40984)>>2] = (40976);
    HEAP32[(40996)>>2] = (40984);
    HEAP32[(40992)>>2] = (40984);
    HEAP32[(41004)>>2] = (40992);
    HEAP32[(41000)>>2] = (40992);
    HEAP32[(41012)>>2] = (41000);
    HEAP32[(41008)>>2] = (41000);
    HEAP32[(41020)>>2] = (41008);
    HEAP32[(41016)>>2] = (41008);
    HEAP32[(41028)>>2] = (41016);
    HEAP32[(41024)>>2] = (41016);
    HEAP32[(41036)>>2] = (41024);
    HEAP32[(41032)>>2] = (41024);
    HEAP32[(41044)>>2] = (41032);
    HEAP32[(41040)>>2] = (41032);
    HEAP32[(41052)>>2] = (41040);
    HEAP32[(41048)>>2] = (41040);
    HEAP32[(41060)>>2] = (41048);
    HEAP32[(41056)>>2] = (41048);
    HEAP32[(41068)>>2] = (41056);
    HEAP32[(41064)>>2] = (41056);
    HEAP32[(41076)>>2] = (41064);
    HEAP32[(41072)>>2] = (41064);
    HEAP32[(41084)>>2] = (41072);
    HEAP32[(41080)>>2] = (41072);
    HEAP32[(41092)>>2] = (41080);
    HEAP32[(41088)>>2] = (41080);
    $641 = (($$723947$i) + -40)|0;
    $642 = ((($$748$i)) + 8|0);
    $643 = $642;
    $644 = $643 & 7;
    $645 = ($644|0)==(0);
    $646 = (0 - ($643))|0;
    $647 = $646 & 7;
    $648 = $645 ? 0 : $647;
    $649 = (($$748$i) + ($648)|0);
    $650 = (($641) - ($648))|0;
    HEAP32[(40816)>>2] = $649;
    HEAP32[(40804)>>2] = $650;
    $651 = $650 | 1;
    $652 = ((($649)) + 4|0);
    HEAP32[$652>>2] = $651;
    $653 = (($$748$i) + ($641)|0);
    $654 = ((($653)) + 4|0);
    HEAP32[$654>>2] = 40;
    $655 = HEAP32[(41280)>>2]|0;
    HEAP32[(40820)>>2] = $655;
   } else {
    $$024372$i = (41240);
    while(1) {
     $656 = HEAP32[$$024372$i>>2]|0;
     $657 = ((($$024372$i)) + 4|0);
     $658 = HEAP32[$657>>2]|0;
     $659 = (($656) + ($658)|0);
     $660 = ($$748$i|0)==($659|0);
     if ($660) {
      label = 199;
      break;
     }
     $661 = ((($$024372$i)) + 8|0);
     $662 = HEAP32[$661>>2]|0;
     $663 = ($662|0)==(0|0);
     if ($663) {
      break;
     } else {
      $$024372$i = $662;
     }
    }
    if ((label|0) == 199) {
     $664 = ((($$024372$i)) + 4|0);
     $665 = ((($$024372$i)) + 12|0);
     $666 = HEAP32[$665>>2]|0;
     $667 = $666 & 8;
     $668 = ($667|0)==(0);
     if ($668) {
      $669 = ($656>>>0)<=($635>>>0);
      $670 = ($$748$i>>>0)>($635>>>0);
      $or$cond51$i = $670 & $669;
      if ($or$cond51$i) {
       $671 = (($658) + ($$723947$i))|0;
       HEAP32[$664>>2] = $671;
       $672 = HEAP32[(40804)>>2]|0;
       $673 = (($672) + ($$723947$i))|0;
       $674 = ((($635)) + 8|0);
       $675 = $674;
       $676 = $675 & 7;
       $677 = ($676|0)==(0);
       $678 = (0 - ($675))|0;
       $679 = $678 & 7;
       $680 = $677 ? 0 : $679;
       $681 = (($635) + ($680)|0);
       $682 = (($673) - ($680))|0;
       HEAP32[(40816)>>2] = $681;
       HEAP32[(40804)>>2] = $682;
       $683 = $682 | 1;
       $684 = ((($681)) + 4|0);
       HEAP32[$684>>2] = $683;
       $685 = (($635) + ($673)|0);
       $686 = ((($685)) + 4|0);
       HEAP32[$686>>2] = 40;
       $687 = HEAP32[(41280)>>2]|0;
       HEAP32[(40820)>>2] = $687;
       break;
      }
     }
    }
    $688 = HEAP32[(40808)>>2]|0;
    $689 = ($$748$i>>>0)<($688>>>0);
    if ($689) {
     HEAP32[(40808)>>2] = $$748$i;
     $753 = $$748$i;
    } else {
     $753 = $688;
    }
    $690 = (($$748$i) + ($$723947$i)|0);
    $$124471$i = (41240);
    while(1) {
     $691 = HEAP32[$$124471$i>>2]|0;
     $692 = ($691|0)==($690|0);
     if ($692) {
      label = 207;
      break;
     }
     $693 = ((($$124471$i)) + 8|0);
     $694 = HEAP32[$693>>2]|0;
     $695 = ($694|0)==(0|0);
     if ($695) {
      break;
     } else {
      $$124471$i = $694;
     }
    }
    if ((label|0) == 207) {
     $696 = ((($$124471$i)) + 12|0);
     $697 = HEAP32[$696>>2]|0;
     $698 = $697 & 8;
     $699 = ($698|0)==(0);
     if ($699) {
      HEAP32[$$124471$i>>2] = $$748$i;
      $700 = ((($$124471$i)) + 4|0);
      $701 = HEAP32[$700>>2]|0;
      $702 = (($701) + ($$723947$i))|0;
      HEAP32[$700>>2] = $702;
      $703 = ((($$748$i)) + 8|0);
      $704 = $703;
      $705 = $704 & 7;
      $706 = ($705|0)==(0);
      $707 = (0 - ($704))|0;
      $708 = $707 & 7;
      $709 = $706 ? 0 : $708;
      $710 = (($$748$i) + ($709)|0);
      $711 = ((($690)) + 8|0);
      $712 = $711;
      $713 = $712 & 7;
      $714 = ($713|0)==(0);
      $715 = (0 - ($712))|0;
      $716 = $715 & 7;
      $717 = $714 ? 0 : $716;
      $718 = (($690) + ($717)|0);
      $719 = $718;
      $720 = $710;
      $721 = (($719) - ($720))|0;
      $722 = (($710) + ($$0197)|0);
      $723 = (($721) - ($$0197))|0;
      $724 = $$0197 | 3;
      $725 = ((($710)) + 4|0);
      HEAP32[$725>>2] = $724;
      $726 = ($635|0)==($718|0);
      L317: do {
       if ($726) {
        $727 = HEAP32[(40804)>>2]|0;
        $728 = (($727) + ($723))|0;
        HEAP32[(40804)>>2] = $728;
        HEAP32[(40816)>>2] = $722;
        $729 = $728 | 1;
        $730 = ((($722)) + 4|0);
        HEAP32[$730>>2] = $729;
       } else {
        $731 = HEAP32[(40812)>>2]|0;
        $732 = ($731|0)==($718|0);
        if ($732) {
         $733 = HEAP32[(40800)>>2]|0;
         $734 = (($733) + ($723))|0;
         HEAP32[(40800)>>2] = $734;
         HEAP32[(40812)>>2] = $722;
         $735 = $734 | 1;
         $736 = ((($722)) + 4|0);
         HEAP32[$736>>2] = $735;
         $737 = (($722) + ($734)|0);
         HEAP32[$737>>2] = $734;
         break;
        }
        $738 = ((($718)) + 4|0);
        $739 = HEAP32[$738>>2]|0;
        $740 = $739 & 3;
        $741 = ($740|0)==(1);
        if ($741) {
         $742 = $739 & -8;
         $743 = $739 >>> 3;
         $744 = ($739>>>0)<(256);
         L325: do {
          if ($744) {
           $745 = ((($718)) + 8|0);
           $746 = HEAP32[$745>>2]|0;
           $747 = ((($718)) + 12|0);
           $748 = HEAP32[$747>>2]|0;
           $749 = $743 << 1;
           $750 = (40832 + ($749<<2)|0);
           $751 = ($746|0)==($750|0);
           do {
            if (!($751)) {
             $752 = ($753>>>0)>($746>>>0);
             if ($752) {
              _abort();
              // unreachable;
             }
             $754 = ((($746)) + 12|0);
             $755 = HEAP32[$754>>2]|0;
             $756 = ($755|0)==($718|0);
             if ($756) {
              break;
             }
             _abort();
             // unreachable;
            }
           } while(0);
           $757 = ($748|0)==($746|0);
           if ($757) {
            $758 = 1 << $743;
            $759 = $758 ^ -1;
            $760 = HEAP32[10198]|0;
            $761 = $760 & $759;
            HEAP32[10198] = $761;
            break;
           }
           $762 = ($748|0)==($750|0);
           do {
            if ($762) {
             $$pre16$i$i = ((($748)) + 8|0);
             $$pre$phi17$i$iZ2D = $$pre16$i$i;
            } else {
             $763 = ($753>>>0)>($748>>>0);
             if ($763) {
              _abort();
              // unreachable;
             }
             $764 = ((($748)) + 8|0);
             $765 = HEAP32[$764>>2]|0;
             $766 = ($765|0)==($718|0);
             if ($766) {
              $$pre$phi17$i$iZ2D = $764;
              break;
             }
             _abort();
             // unreachable;
            }
           } while(0);
           $767 = ((($746)) + 12|0);
           HEAP32[$767>>2] = $748;
           HEAP32[$$pre$phi17$i$iZ2D>>2] = $746;
          } else {
           $768 = ((($718)) + 24|0);
           $769 = HEAP32[$768>>2]|0;
           $770 = ((($718)) + 12|0);
           $771 = HEAP32[$770>>2]|0;
           $772 = ($771|0)==($718|0);
           do {
            if ($772) {
             $782 = ((($718)) + 16|0);
             $783 = ((($782)) + 4|0);
             $784 = HEAP32[$783>>2]|0;
             $785 = ($784|0)==(0|0);
             if ($785) {
              $786 = HEAP32[$782>>2]|0;
              $787 = ($786|0)==(0|0);
              if ($787) {
               $$3$i$i = 0;
               break;
              } else {
               $$1290$i$i$ph = $786;$$1292$i$i$ph = $782;
              }
             } else {
              $$1290$i$i$ph = $784;$$1292$i$i$ph = $783;
             }
             $$1290$i$i = $$1290$i$i$ph;$$1292$i$i = $$1292$i$i$ph;
             while(1) {
              $788 = ((($$1290$i$i)) + 20|0);
              $789 = HEAP32[$788>>2]|0;
              $790 = ($789|0)==(0|0);
              if ($790) {
               $791 = ((($$1290$i$i)) + 16|0);
               $792 = HEAP32[$791>>2]|0;
               $793 = ($792|0)==(0|0);
               if ($793) {
                break;
               } else {
                $$1290$i$i$be = $792;$$1292$i$i$be = $791;
               }
              } else {
               $$1290$i$i$be = $789;$$1292$i$i$be = $788;
              }
              $$1290$i$i = $$1290$i$i$be;$$1292$i$i = $$1292$i$i$be;
             }
             $794 = ($753>>>0)>($$1292$i$i>>>0);
             if ($794) {
              _abort();
              // unreachable;
             } else {
              HEAP32[$$1292$i$i>>2] = 0;
              $$3$i$i = $$1290$i$i;
              break;
             }
            } else {
             $773 = ((($718)) + 8|0);
             $774 = HEAP32[$773>>2]|0;
             $775 = ($753>>>0)>($774>>>0);
             if ($775) {
              _abort();
              // unreachable;
             }
             $776 = ((($774)) + 12|0);
             $777 = HEAP32[$776>>2]|0;
             $778 = ($777|0)==($718|0);
             if (!($778)) {
              _abort();
              // unreachable;
             }
             $779 = ((($771)) + 8|0);
             $780 = HEAP32[$779>>2]|0;
             $781 = ($780|0)==($718|0);
             if ($781) {
              HEAP32[$776>>2] = $771;
              HEAP32[$779>>2] = $774;
              $$3$i$i = $771;
              break;
             } else {
              _abort();
              // unreachable;
             }
            }
           } while(0);
           $795 = ($769|0)==(0|0);
           if ($795) {
            break;
           }
           $796 = ((($718)) + 28|0);
           $797 = HEAP32[$796>>2]|0;
           $798 = (41096 + ($797<<2)|0);
           $799 = HEAP32[$798>>2]|0;
           $800 = ($799|0)==($718|0);
           do {
            if ($800) {
             HEAP32[$798>>2] = $$3$i$i;
             $cond$i$i = ($$3$i$i|0)==(0|0);
             if (!($cond$i$i)) {
              break;
             }
             $801 = 1 << $797;
             $802 = $801 ^ -1;
             $803 = HEAP32[(40796)>>2]|0;
             $804 = $803 & $802;
             HEAP32[(40796)>>2] = $804;
             break L325;
            } else {
             $805 = HEAP32[(40808)>>2]|0;
             $806 = ($805>>>0)>($769>>>0);
             if ($806) {
              _abort();
              // unreachable;
             } else {
              $807 = ((($769)) + 16|0);
              $808 = HEAP32[$807>>2]|0;
              $809 = ($808|0)==($718|0);
              $810 = ((($769)) + 20|0);
              $$sink326 = $809 ? $807 : $810;
              HEAP32[$$sink326>>2] = $$3$i$i;
              $811 = ($$3$i$i|0)==(0|0);
              if ($811) {
               break L325;
              } else {
               break;
              }
             }
            }
           } while(0);
           $812 = HEAP32[(40808)>>2]|0;
           $813 = ($812>>>0)>($$3$i$i>>>0);
           if ($813) {
            _abort();
            // unreachable;
           }
           $814 = ((($$3$i$i)) + 24|0);
           HEAP32[$814>>2] = $769;
           $815 = ((($718)) + 16|0);
           $816 = HEAP32[$815>>2]|0;
           $817 = ($816|0)==(0|0);
           do {
            if (!($817)) {
             $818 = ($812>>>0)>($816>>>0);
             if ($818) {
              _abort();
              // unreachable;
             } else {
              $819 = ((($$3$i$i)) + 16|0);
              HEAP32[$819>>2] = $816;
              $820 = ((($816)) + 24|0);
              HEAP32[$820>>2] = $$3$i$i;
              break;
             }
            }
           } while(0);
           $821 = ((($815)) + 4|0);
           $822 = HEAP32[$821>>2]|0;
           $823 = ($822|0)==(0|0);
           if ($823) {
            break;
           }
           $824 = HEAP32[(40808)>>2]|0;
           $825 = ($824>>>0)>($822>>>0);
           if ($825) {
            _abort();
            // unreachable;
           } else {
            $826 = ((($$3$i$i)) + 20|0);
            HEAP32[$826>>2] = $822;
            $827 = ((($822)) + 24|0);
            HEAP32[$827>>2] = $$3$i$i;
            break;
           }
          }
         } while(0);
         $828 = (($718) + ($742)|0);
         $829 = (($742) + ($723))|0;
         $$0$i16$i = $828;$$0286$i$i = $829;
        } else {
         $$0$i16$i = $718;$$0286$i$i = $723;
        }
        $830 = ((($$0$i16$i)) + 4|0);
        $831 = HEAP32[$830>>2]|0;
        $832 = $831 & -2;
        HEAP32[$830>>2] = $832;
        $833 = $$0286$i$i | 1;
        $834 = ((($722)) + 4|0);
        HEAP32[$834>>2] = $833;
        $835 = (($722) + ($$0286$i$i)|0);
        HEAP32[$835>>2] = $$0286$i$i;
        $836 = $$0286$i$i >>> 3;
        $837 = ($$0286$i$i>>>0)<(256);
        if ($837) {
         $838 = $836 << 1;
         $839 = (40832 + ($838<<2)|0);
         $840 = HEAP32[10198]|0;
         $841 = 1 << $836;
         $842 = $840 & $841;
         $843 = ($842|0)==(0);
         do {
          if ($843) {
           $844 = $840 | $841;
           HEAP32[10198] = $844;
           $$pre$i17$i = ((($839)) + 8|0);
           $$0294$i$i = $839;$$pre$phi$i18$iZ2D = $$pre$i17$i;
          } else {
           $845 = ((($839)) + 8|0);
           $846 = HEAP32[$845>>2]|0;
           $847 = HEAP32[(40808)>>2]|0;
           $848 = ($847>>>0)>($846>>>0);
           if (!($848)) {
            $$0294$i$i = $846;$$pre$phi$i18$iZ2D = $845;
            break;
           }
           _abort();
           // unreachable;
          }
         } while(0);
         HEAP32[$$pre$phi$i18$iZ2D>>2] = $722;
         $849 = ((($$0294$i$i)) + 12|0);
         HEAP32[$849>>2] = $722;
         $850 = ((($722)) + 8|0);
         HEAP32[$850>>2] = $$0294$i$i;
         $851 = ((($722)) + 12|0);
         HEAP32[$851>>2] = $839;
         break;
        }
        $852 = $$0286$i$i >>> 8;
        $853 = ($852|0)==(0);
        do {
         if ($853) {
          $$0295$i$i = 0;
         } else {
          $854 = ($$0286$i$i>>>0)>(16777215);
          if ($854) {
           $$0295$i$i = 31;
           break;
          }
          $855 = (($852) + 1048320)|0;
          $856 = $855 >>> 16;
          $857 = $856 & 8;
          $858 = $852 << $857;
          $859 = (($858) + 520192)|0;
          $860 = $859 >>> 16;
          $861 = $860 & 4;
          $862 = $861 | $857;
          $863 = $858 << $861;
          $864 = (($863) + 245760)|0;
          $865 = $864 >>> 16;
          $866 = $865 & 2;
          $867 = $862 | $866;
          $868 = (14 - ($867))|0;
          $869 = $863 << $866;
          $870 = $869 >>> 15;
          $871 = (($868) + ($870))|0;
          $872 = $871 << 1;
          $873 = (($871) + 7)|0;
          $874 = $$0286$i$i >>> $873;
          $875 = $874 & 1;
          $876 = $875 | $872;
          $$0295$i$i = $876;
         }
        } while(0);
        $877 = (41096 + ($$0295$i$i<<2)|0);
        $878 = ((($722)) + 28|0);
        HEAP32[$878>>2] = $$0295$i$i;
        $879 = ((($722)) + 16|0);
        $880 = ((($879)) + 4|0);
        HEAP32[$880>>2] = 0;
        HEAP32[$879>>2] = 0;
        $881 = HEAP32[(40796)>>2]|0;
        $882 = 1 << $$0295$i$i;
        $883 = $881 & $882;
        $884 = ($883|0)==(0);
        if ($884) {
         $885 = $881 | $882;
         HEAP32[(40796)>>2] = $885;
         HEAP32[$877>>2] = $722;
         $886 = ((($722)) + 24|0);
         HEAP32[$886>>2] = $877;
         $887 = ((($722)) + 12|0);
         HEAP32[$887>>2] = $722;
         $888 = ((($722)) + 8|0);
         HEAP32[$888>>2] = $722;
         break;
        }
        $889 = HEAP32[$877>>2]|0;
        $890 = ((($889)) + 4|0);
        $891 = HEAP32[$890>>2]|0;
        $892 = $891 & -8;
        $893 = ($892|0)==($$0286$i$i|0);
        L410: do {
         if ($893) {
          $$0288$lcssa$i$i = $889;
         } else {
          $894 = ($$0295$i$i|0)==(31);
          $895 = $$0295$i$i >>> 1;
          $896 = (25 - ($895))|0;
          $897 = $894 ? 0 : $896;
          $898 = $$0286$i$i << $897;
          $$028711$i$i = $898;$$028810$i$i = $889;
          while(1) {
           $905 = $$028711$i$i >>> 31;
           $906 = (((($$028810$i$i)) + 16|0) + ($905<<2)|0);
           $901 = HEAP32[$906>>2]|0;
           $907 = ($901|0)==(0|0);
           if ($907) {
            break;
           }
           $899 = $$028711$i$i << 1;
           $900 = ((($901)) + 4|0);
           $902 = HEAP32[$900>>2]|0;
           $903 = $902 & -8;
           $904 = ($903|0)==($$0286$i$i|0);
           if ($904) {
            $$0288$lcssa$i$i = $901;
            break L410;
           } else {
            $$028711$i$i = $899;$$028810$i$i = $901;
           }
          }
          $908 = HEAP32[(40808)>>2]|0;
          $909 = ($908>>>0)>($906>>>0);
          if ($909) {
           _abort();
           // unreachable;
          } else {
           HEAP32[$906>>2] = $722;
           $910 = ((($722)) + 24|0);
           HEAP32[$910>>2] = $$028810$i$i;
           $911 = ((($722)) + 12|0);
           HEAP32[$911>>2] = $722;
           $912 = ((($722)) + 8|0);
           HEAP32[$912>>2] = $722;
           break L317;
          }
         }
        } while(0);
        $913 = ((($$0288$lcssa$i$i)) + 8|0);
        $914 = HEAP32[$913>>2]|0;
        $915 = HEAP32[(40808)>>2]|0;
        $916 = ($915>>>0)<=($$0288$lcssa$i$i>>>0);
        $917 = ($915>>>0)<=($914>>>0);
        $918 = $917 & $916;
        if ($918) {
         $919 = ((($914)) + 12|0);
         HEAP32[$919>>2] = $722;
         HEAP32[$913>>2] = $722;
         $920 = ((($722)) + 8|0);
         HEAP32[$920>>2] = $914;
         $921 = ((($722)) + 12|0);
         HEAP32[$921>>2] = $$0288$lcssa$i$i;
         $922 = ((($722)) + 24|0);
         HEAP32[$922>>2] = 0;
         break;
        } else {
         _abort();
         // unreachable;
        }
       }
      } while(0);
      $1059 = ((($710)) + 8|0);
      $$0 = $1059;
      STACKTOP = sp;return ($$0|0);
     }
    }
    $$0$i$i$i = (41240);
    while(1) {
     $923 = HEAP32[$$0$i$i$i>>2]|0;
     $924 = ($923>>>0)>($635>>>0);
     if (!($924)) {
      $925 = ((($$0$i$i$i)) + 4|0);
      $926 = HEAP32[$925>>2]|0;
      $927 = (($923) + ($926)|0);
      $928 = ($927>>>0)>($635>>>0);
      if ($928) {
       break;
      }
     }
     $929 = ((($$0$i$i$i)) + 8|0);
     $930 = HEAP32[$929>>2]|0;
     $$0$i$i$i = $930;
    }
    $931 = ((($927)) + -47|0);
    $932 = ((($931)) + 8|0);
    $933 = $932;
    $934 = $933 & 7;
    $935 = ($934|0)==(0);
    $936 = (0 - ($933))|0;
    $937 = $936 & 7;
    $938 = $935 ? 0 : $937;
    $939 = (($931) + ($938)|0);
    $940 = ((($635)) + 16|0);
    $941 = ($939>>>0)<($940>>>0);
    $942 = $941 ? $635 : $939;
    $943 = ((($942)) + 8|0);
    $944 = ((($942)) + 24|0);
    $945 = (($$723947$i) + -40)|0;
    $946 = ((($$748$i)) + 8|0);
    $947 = $946;
    $948 = $947 & 7;
    $949 = ($948|0)==(0);
    $950 = (0 - ($947))|0;
    $951 = $950 & 7;
    $952 = $949 ? 0 : $951;
    $953 = (($$748$i) + ($952)|0);
    $954 = (($945) - ($952))|0;
    HEAP32[(40816)>>2] = $953;
    HEAP32[(40804)>>2] = $954;
    $955 = $954 | 1;
    $956 = ((($953)) + 4|0);
    HEAP32[$956>>2] = $955;
    $957 = (($$748$i) + ($945)|0);
    $958 = ((($957)) + 4|0);
    HEAP32[$958>>2] = 40;
    $959 = HEAP32[(41280)>>2]|0;
    HEAP32[(40820)>>2] = $959;
    $960 = ((($942)) + 4|0);
    HEAP32[$960>>2] = 27;
    ;HEAP32[$943>>2]=HEAP32[(41240)>>2]|0;HEAP32[$943+4>>2]=HEAP32[(41240)+4>>2]|0;HEAP32[$943+8>>2]=HEAP32[(41240)+8>>2]|0;HEAP32[$943+12>>2]=HEAP32[(41240)+12>>2]|0;
    HEAP32[(41240)>>2] = $$748$i;
    HEAP32[(41244)>>2] = $$723947$i;
    HEAP32[(41252)>>2] = 0;
    HEAP32[(41248)>>2] = $943;
    $962 = $944;
    while(1) {
     $961 = ((($962)) + 4|0);
     HEAP32[$961>>2] = 7;
     $963 = ((($962)) + 8|0);
     $964 = ($963>>>0)<($927>>>0);
     if ($964) {
      $962 = $961;
     } else {
      break;
     }
    }
    $965 = ($942|0)==($635|0);
    if (!($965)) {
     $966 = $942;
     $967 = $635;
     $968 = (($966) - ($967))|0;
     $969 = HEAP32[$960>>2]|0;
     $970 = $969 & -2;
     HEAP32[$960>>2] = $970;
     $971 = $968 | 1;
     $972 = ((($635)) + 4|0);
     HEAP32[$972>>2] = $971;
     HEAP32[$942>>2] = $968;
     $973 = $968 >>> 3;
     $974 = ($968>>>0)<(256);
     if ($974) {
      $975 = $973 << 1;
      $976 = (40832 + ($975<<2)|0);
      $977 = HEAP32[10198]|0;
      $978 = 1 << $973;
      $979 = $977 & $978;
      $980 = ($979|0)==(0);
      if ($980) {
       $981 = $977 | $978;
       HEAP32[10198] = $981;
       $$pre$i$i = ((($976)) + 8|0);
       $$0211$i$i = $976;$$pre$phi$i$iZ2D = $$pre$i$i;
      } else {
       $982 = ((($976)) + 8|0);
       $983 = HEAP32[$982>>2]|0;
       $984 = HEAP32[(40808)>>2]|0;
       $985 = ($984>>>0)>($983>>>0);
       if ($985) {
        _abort();
        // unreachable;
       } else {
        $$0211$i$i = $983;$$pre$phi$i$iZ2D = $982;
       }
      }
      HEAP32[$$pre$phi$i$iZ2D>>2] = $635;
      $986 = ((($$0211$i$i)) + 12|0);
      HEAP32[$986>>2] = $635;
      $987 = ((($635)) + 8|0);
      HEAP32[$987>>2] = $$0211$i$i;
      $988 = ((($635)) + 12|0);
      HEAP32[$988>>2] = $976;
      break;
     }
     $989 = $968 >>> 8;
     $990 = ($989|0)==(0);
     if ($990) {
      $$0212$i$i = 0;
     } else {
      $991 = ($968>>>0)>(16777215);
      if ($991) {
       $$0212$i$i = 31;
      } else {
       $992 = (($989) + 1048320)|0;
       $993 = $992 >>> 16;
       $994 = $993 & 8;
       $995 = $989 << $994;
       $996 = (($995) + 520192)|0;
       $997 = $996 >>> 16;
       $998 = $997 & 4;
       $999 = $998 | $994;
       $1000 = $995 << $998;
       $1001 = (($1000) + 245760)|0;
       $1002 = $1001 >>> 16;
       $1003 = $1002 & 2;
       $1004 = $999 | $1003;
       $1005 = (14 - ($1004))|0;
       $1006 = $1000 << $1003;
       $1007 = $1006 >>> 15;
       $1008 = (($1005) + ($1007))|0;
       $1009 = $1008 << 1;
       $1010 = (($1008) + 7)|0;
       $1011 = $968 >>> $1010;
       $1012 = $1011 & 1;
       $1013 = $1012 | $1009;
       $$0212$i$i = $1013;
      }
     }
     $1014 = (41096 + ($$0212$i$i<<2)|0);
     $1015 = ((($635)) + 28|0);
     HEAP32[$1015>>2] = $$0212$i$i;
     $1016 = ((($635)) + 20|0);
     HEAP32[$1016>>2] = 0;
     HEAP32[$940>>2] = 0;
     $1017 = HEAP32[(40796)>>2]|0;
     $1018 = 1 << $$0212$i$i;
     $1019 = $1017 & $1018;
     $1020 = ($1019|0)==(0);
     if ($1020) {
      $1021 = $1017 | $1018;
      HEAP32[(40796)>>2] = $1021;
      HEAP32[$1014>>2] = $635;
      $1022 = ((($635)) + 24|0);
      HEAP32[$1022>>2] = $1014;
      $1023 = ((($635)) + 12|0);
      HEAP32[$1023>>2] = $635;
      $1024 = ((($635)) + 8|0);
      HEAP32[$1024>>2] = $635;
      break;
     }
     $1025 = HEAP32[$1014>>2]|0;
     $1026 = ((($1025)) + 4|0);
     $1027 = HEAP32[$1026>>2]|0;
     $1028 = $1027 & -8;
     $1029 = ($1028|0)==($968|0);
     L451: do {
      if ($1029) {
       $$0207$lcssa$i$i = $1025;
      } else {
       $1030 = ($$0212$i$i|0)==(31);
       $1031 = $$0212$i$i >>> 1;
       $1032 = (25 - ($1031))|0;
       $1033 = $1030 ? 0 : $1032;
       $1034 = $968 << $1033;
       $$02065$i$i = $1034;$$02074$i$i = $1025;
       while(1) {
        $1041 = $$02065$i$i >>> 31;
        $1042 = (((($$02074$i$i)) + 16|0) + ($1041<<2)|0);
        $1037 = HEAP32[$1042>>2]|0;
        $1043 = ($1037|0)==(0|0);
        if ($1043) {
         break;
        }
        $1035 = $$02065$i$i << 1;
        $1036 = ((($1037)) + 4|0);
        $1038 = HEAP32[$1036>>2]|0;
        $1039 = $1038 & -8;
        $1040 = ($1039|0)==($968|0);
        if ($1040) {
         $$0207$lcssa$i$i = $1037;
         break L451;
        } else {
         $$02065$i$i = $1035;$$02074$i$i = $1037;
        }
       }
       $1044 = HEAP32[(40808)>>2]|0;
       $1045 = ($1044>>>0)>($1042>>>0);
       if ($1045) {
        _abort();
        // unreachable;
       } else {
        HEAP32[$1042>>2] = $635;
        $1046 = ((($635)) + 24|0);
        HEAP32[$1046>>2] = $$02074$i$i;
        $1047 = ((($635)) + 12|0);
        HEAP32[$1047>>2] = $635;
        $1048 = ((($635)) + 8|0);
        HEAP32[$1048>>2] = $635;
        break L294;
       }
      }
     } while(0);
     $1049 = ((($$0207$lcssa$i$i)) + 8|0);
     $1050 = HEAP32[$1049>>2]|0;
     $1051 = HEAP32[(40808)>>2]|0;
     $1052 = ($1051>>>0)<=($$0207$lcssa$i$i>>>0);
     $1053 = ($1051>>>0)<=($1050>>>0);
     $1054 = $1053 & $1052;
     if ($1054) {
      $1055 = ((($1050)) + 12|0);
      HEAP32[$1055>>2] = $635;
      HEAP32[$1049>>2] = $635;
      $1056 = ((($635)) + 8|0);
      HEAP32[$1056>>2] = $1050;
      $1057 = ((($635)) + 12|0);
      HEAP32[$1057>>2] = $$0207$lcssa$i$i;
      $1058 = ((($635)) + 24|0);
      HEAP32[$1058>>2] = 0;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   }
  } while(0);
  $1060 = HEAP32[(40804)>>2]|0;
  $1061 = ($1060>>>0)>($$0197>>>0);
  if ($1061) {
   $1062 = (($1060) - ($$0197))|0;
   HEAP32[(40804)>>2] = $1062;
   $1063 = HEAP32[(40816)>>2]|0;
   $1064 = (($1063) + ($$0197)|0);
   HEAP32[(40816)>>2] = $1064;
   $1065 = $1062 | 1;
   $1066 = ((($1064)) + 4|0);
   HEAP32[$1066>>2] = $1065;
   $1067 = $$0197 | 3;
   $1068 = ((($1063)) + 4|0);
   HEAP32[$1068>>2] = $1067;
   $1069 = ((($1063)) + 8|0);
   $$0 = $1069;
   STACKTOP = sp;return ($$0|0);
  }
 }
 $1070 = (___errno_location()|0);
 HEAP32[$1070>>2] = 12;
 $$0 = 0;
 STACKTOP = sp;return ($$0|0);
}
function _free($0) {
 $0 = $0|0;
 var $$0211$i = 0, $$0211$in$i = 0, $$0381438 = 0, $$0382$lcssa = 0, $$0382437 = 0, $$0394 = 0, $$0401 = 0, $$1 = 0, $$1380 = 0, $$1385 = 0, $$1385$be = 0, $$1385$ph = 0, $$1388 = 0, $$1388$be = 0, $$1388$ph = 0, $$1396 = 0, $$1396$be = 0, $$1396$ph = 0, $$1400 = 0, $$1400$be = 0;
 var $$1400$ph = 0, $$2 = 0, $$3 = 0, $$3398 = 0, $$pre = 0, $$pre$phi444Z2D = 0, $$pre$phi446Z2D = 0, $$pre$phiZ2D = 0, $$pre443 = 0, $$pre445 = 0, $$sink = 0, $$sink456 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0;
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0;
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0;
 var $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0;
 var $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0;
 var $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0;
 var $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0;
 var $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0;
 var $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0;
 var $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0;
 var $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0;
 var $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0;
 var $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0;
 var $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0;
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0;
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0;
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond419 = 0, $cond420 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0);
 if ($1) {
  return;
 }
 $2 = ((($0)) + -8|0);
 $3 = HEAP32[(40808)>>2]|0;
 $4 = ($2>>>0)<($3>>>0);
 if ($4) {
  _abort();
  // unreachable;
 }
 $5 = ((($0)) + -4|0);
 $6 = HEAP32[$5>>2]|0;
 $7 = $6 & 3;
 $8 = ($7|0)==(1);
 if ($8) {
  _abort();
  // unreachable;
 }
 $9 = $6 & -8;
 $10 = (($2) + ($9)|0);
 $11 = $6 & 1;
 $12 = ($11|0)==(0);
 L10: do {
  if ($12) {
   $13 = HEAP32[$2>>2]|0;
   $14 = ($7|0)==(0);
   if ($14) {
    return;
   }
   $15 = (0 - ($13))|0;
   $16 = (($2) + ($15)|0);
   $17 = (($13) + ($9))|0;
   $18 = ($16>>>0)<($3>>>0);
   if ($18) {
    _abort();
    // unreachable;
   }
   $19 = HEAP32[(40812)>>2]|0;
   $20 = ($19|0)==($16|0);
   if ($20) {
    $105 = ((($10)) + 4|0);
    $106 = HEAP32[$105>>2]|0;
    $107 = $106 & 3;
    $108 = ($107|0)==(3);
    if (!($108)) {
     $$1 = $16;$$1380 = $17;$114 = $16;
     break;
    }
    $109 = (($16) + ($17)|0);
    $110 = ((($16)) + 4|0);
    $111 = $17 | 1;
    $112 = $106 & -2;
    HEAP32[(40800)>>2] = $17;
    HEAP32[$105>>2] = $112;
    HEAP32[$110>>2] = $111;
    HEAP32[$109>>2] = $17;
    return;
   }
   $21 = $13 >>> 3;
   $22 = ($13>>>0)<(256);
   if ($22) {
    $23 = ((($16)) + 8|0);
    $24 = HEAP32[$23>>2]|0;
    $25 = ((($16)) + 12|0);
    $26 = HEAP32[$25>>2]|0;
    $27 = $21 << 1;
    $28 = (40832 + ($27<<2)|0);
    $29 = ($24|0)==($28|0);
    if (!($29)) {
     $30 = ($3>>>0)>($24>>>0);
     if ($30) {
      _abort();
      // unreachable;
     }
     $31 = ((($24)) + 12|0);
     $32 = HEAP32[$31>>2]|0;
     $33 = ($32|0)==($16|0);
     if (!($33)) {
      _abort();
      // unreachable;
     }
    }
    $34 = ($26|0)==($24|0);
    if ($34) {
     $35 = 1 << $21;
     $36 = $35 ^ -1;
     $37 = HEAP32[10198]|0;
     $38 = $37 & $36;
     HEAP32[10198] = $38;
     $$1 = $16;$$1380 = $17;$114 = $16;
     break;
    }
    $39 = ($26|0)==($28|0);
    if ($39) {
     $$pre445 = ((($26)) + 8|0);
     $$pre$phi446Z2D = $$pre445;
    } else {
     $40 = ($3>>>0)>($26>>>0);
     if ($40) {
      _abort();
      // unreachable;
     }
     $41 = ((($26)) + 8|0);
     $42 = HEAP32[$41>>2]|0;
     $43 = ($42|0)==($16|0);
     if ($43) {
      $$pre$phi446Z2D = $41;
     } else {
      _abort();
      // unreachable;
     }
    }
    $44 = ((($24)) + 12|0);
    HEAP32[$44>>2] = $26;
    HEAP32[$$pre$phi446Z2D>>2] = $24;
    $$1 = $16;$$1380 = $17;$114 = $16;
    break;
   }
   $45 = ((($16)) + 24|0);
   $46 = HEAP32[$45>>2]|0;
   $47 = ((($16)) + 12|0);
   $48 = HEAP32[$47>>2]|0;
   $49 = ($48|0)==($16|0);
   do {
    if ($49) {
     $59 = ((($16)) + 16|0);
     $60 = ((($59)) + 4|0);
     $61 = HEAP32[$60>>2]|0;
     $62 = ($61|0)==(0|0);
     if ($62) {
      $63 = HEAP32[$59>>2]|0;
      $64 = ($63|0)==(0|0);
      if ($64) {
       $$3 = 0;
       break;
      } else {
       $$1385$ph = $63;$$1388$ph = $59;
      }
     } else {
      $$1385$ph = $61;$$1388$ph = $60;
     }
     $$1385 = $$1385$ph;$$1388 = $$1388$ph;
     while(1) {
      $65 = ((($$1385)) + 20|0);
      $66 = HEAP32[$65>>2]|0;
      $67 = ($66|0)==(0|0);
      if ($67) {
       $68 = ((($$1385)) + 16|0);
       $69 = HEAP32[$68>>2]|0;
       $70 = ($69|0)==(0|0);
       if ($70) {
        break;
       } else {
        $$1385$be = $69;$$1388$be = $68;
       }
      } else {
       $$1385$be = $66;$$1388$be = $65;
      }
      $$1385 = $$1385$be;$$1388 = $$1388$be;
     }
     $71 = ($3>>>0)>($$1388>>>0);
     if ($71) {
      _abort();
      // unreachable;
     } else {
      HEAP32[$$1388>>2] = 0;
      $$3 = $$1385;
      break;
     }
    } else {
     $50 = ((($16)) + 8|0);
     $51 = HEAP32[$50>>2]|0;
     $52 = ($3>>>0)>($51>>>0);
     if ($52) {
      _abort();
      // unreachable;
     }
     $53 = ((($51)) + 12|0);
     $54 = HEAP32[$53>>2]|0;
     $55 = ($54|0)==($16|0);
     if (!($55)) {
      _abort();
      // unreachable;
     }
     $56 = ((($48)) + 8|0);
     $57 = HEAP32[$56>>2]|0;
     $58 = ($57|0)==($16|0);
     if ($58) {
      HEAP32[$53>>2] = $48;
      HEAP32[$56>>2] = $51;
      $$3 = $48;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   } while(0);
   $72 = ($46|0)==(0|0);
   if ($72) {
    $$1 = $16;$$1380 = $17;$114 = $16;
   } else {
    $73 = ((($16)) + 28|0);
    $74 = HEAP32[$73>>2]|0;
    $75 = (41096 + ($74<<2)|0);
    $76 = HEAP32[$75>>2]|0;
    $77 = ($76|0)==($16|0);
    do {
     if ($77) {
      HEAP32[$75>>2] = $$3;
      $cond419 = ($$3|0)==(0|0);
      if ($cond419) {
       $78 = 1 << $74;
       $79 = $78 ^ -1;
       $80 = HEAP32[(40796)>>2]|0;
       $81 = $80 & $79;
       HEAP32[(40796)>>2] = $81;
       $$1 = $16;$$1380 = $17;$114 = $16;
       break L10;
      }
     } else {
      $82 = HEAP32[(40808)>>2]|0;
      $83 = ($82>>>0)>($46>>>0);
      if ($83) {
       _abort();
       // unreachable;
      } else {
       $84 = ((($46)) + 16|0);
       $85 = HEAP32[$84>>2]|0;
       $86 = ($85|0)==($16|0);
       $87 = ((($46)) + 20|0);
       $$sink = $86 ? $84 : $87;
       HEAP32[$$sink>>2] = $$3;
       $88 = ($$3|0)==(0|0);
       if ($88) {
        $$1 = $16;$$1380 = $17;$114 = $16;
        break L10;
       } else {
        break;
       }
      }
     }
    } while(0);
    $89 = HEAP32[(40808)>>2]|0;
    $90 = ($89>>>0)>($$3>>>0);
    if ($90) {
     _abort();
     // unreachable;
    }
    $91 = ((($$3)) + 24|0);
    HEAP32[$91>>2] = $46;
    $92 = ((($16)) + 16|0);
    $93 = HEAP32[$92>>2]|0;
    $94 = ($93|0)==(0|0);
    do {
     if (!($94)) {
      $95 = ($89>>>0)>($93>>>0);
      if ($95) {
       _abort();
       // unreachable;
      } else {
       $96 = ((($$3)) + 16|0);
       HEAP32[$96>>2] = $93;
       $97 = ((($93)) + 24|0);
       HEAP32[$97>>2] = $$3;
       break;
      }
     }
    } while(0);
    $98 = ((($92)) + 4|0);
    $99 = HEAP32[$98>>2]|0;
    $100 = ($99|0)==(0|0);
    if ($100) {
     $$1 = $16;$$1380 = $17;$114 = $16;
    } else {
     $101 = HEAP32[(40808)>>2]|0;
     $102 = ($101>>>0)>($99>>>0);
     if ($102) {
      _abort();
      // unreachable;
     } else {
      $103 = ((($$3)) + 20|0);
      HEAP32[$103>>2] = $99;
      $104 = ((($99)) + 24|0);
      HEAP32[$104>>2] = $$3;
      $$1 = $16;$$1380 = $17;$114 = $16;
      break;
     }
    }
   }
  } else {
   $$1 = $2;$$1380 = $9;$114 = $2;
  }
 } while(0);
 $113 = ($114>>>0)<($10>>>0);
 if (!($113)) {
  _abort();
  // unreachable;
 }
 $115 = ((($10)) + 4|0);
 $116 = HEAP32[$115>>2]|0;
 $117 = $116 & 1;
 $118 = ($117|0)==(0);
 if ($118) {
  _abort();
  // unreachable;
 }
 $119 = $116 & 2;
 $120 = ($119|0)==(0);
 if ($120) {
  $121 = HEAP32[(40816)>>2]|0;
  $122 = ($121|0)==($10|0);
  if ($122) {
   $123 = HEAP32[(40804)>>2]|0;
   $124 = (($123) + ($$1380))|0;
   HEAP32[(40804)>>2] = $124;
   HEAP32[(40816)>>2] = $$1;
   $125 = $124 | 1;
   $126 = ((($$1)) + 4|0);
   HEAP32[$126>>2] = $125;
   $127 = HEAP32[(40812)>>2]|0;
   $128 = ($$1|0)==($127|0);
   if (!($128)) {
    return;
   }
   HEAP32[(40812)>>2] = 0;
   HEAP32[(40800)>>2] = 0;
   return;
  }
  $129 = HEAP32[(40812)>>2]|0;
  $130 = ($129|0)==($10|0);
  if ($130) {
   $131 = HEAP32[(40800)>>2]|0;
   $132 = (($131) + ($$1380))|0;
   HEAP32[(40800)>>2] = $132;
   HEAP32[(40812)>>2] = $114;
   $133 = $132 | 1;
   $134 = ((($$1)) + 4|0);
   HEAP32[$134>>2] = $133;
   $135 = (($114) + ($132)|0);
   HEAP32[$135>>2] = $132;
   return;
  }
  $136 = $116 & -8;
  $137 = (($136) + ($$1380))|0;
  $138 = $116 >>> 3;
  $139 = ($116>>>0)<(256);
  L111: do {
   if ($139) {
    $140 = ((($10)) + 8|0);
    $141 = HEAP32[$140>>2]|0;
    $142 = ((($10)) + 12|0);
    $143 = HEAP32[$142>>2]|0;
    $144 = $138 << 1;
    $145 = (40832 + ($144<<2)|0);
    $146 = ($141|0)==($145|0);
    if (!($146)) {
     $147 = HEAP32[(40808)>>2]|0;
     $148 = ($147>>>0)>($141>>>0);
     if ($148) {
      _abort();
      // unreachable;
     }
     $149 = ((($141)) + 12|0);
     $150 = HEAP32[$149>>2]|0;
     $151 = ($150|0)==($10|0);
     if (!($151)) {
      _abort();
      // unreachable;
     }
    }
    $152 = ($143|0)==($141|0);
    if ($152) {
     $153 = 1 << $138;
     $154 = $153 ^ -1;
     $155 = HEAP32[10198]|0;
     $156 = $155 & $154;
     HEAP32[10198] = $156;
     break;
    }
    $157 = ($143|0)==($145|0);
    if ($157) {
     $$pre443 = ((($143)) + 8|0);
     $$pre$phi444Z2D = $$pre443;
    } else {
     $158 = HEAP32[(40808)>>2]|0;
     $159 = ($158>>>0)>($143>>>0);
     if ($159) {
      _abort();
      // unreachable;
     }
     $160 = ((($143)) + 8|0);
     $161 = HEAP32[$160>>2]|0;
     $162 = ($161|0)==($10|0);
     if ($162) {
      $$pre$phi444Z2D = $160;
     } else {
      _abort();
      // unreachable;
     }
    }
    $163 = ((($141)) + 12|0);
    HEAP32[$163>>2] = $143;
    HEAP32[$$pre$phi444Z2D>>2] = $141;
   } else {
    $164 = ((($10)) + 24|0);
    $165 = HEAP32[$164>>2]|0;
    $166 = ((($10)) + 12|0);
    $167 = HEAP32[$166>>2]|0;
    $168 = ($167|0)==($10|0);
    do {
     if ($168) {
      $179 = ((($10)) + 16|0);
      $180 = ((($179)) + 4|0);
      $181 = HEAP32[$180>>2]|0;
      $182 = ($181|0)==(0|0);
      if ($182) {
       $183 = HEAP32[$179>>2]|0;
       $184 = ($183|0)==(0|0);
       if ($184) {
        $$3398 = 0;
        break;
       } else {
        $$1396$ph = $183;$$1400$ph = $179;
       }
      } else {
       $$1396$ph = $181;$$1400$ph = $180;
      }
      $$1396 = $$1396$ph;$$1400 = $$1400$ph;
      while(1) {
       $185 = ((($$1396)) + 20|0);
       $186 = HEAP32[$185>>2]|0;
       $187 = ($186|0)==(0|0);
       if ($187) {
        $188 = ((($$1396)) + 16|0);
        $189 = HEAP32[$188>>2]|0;
        $190 = ($189|0)==(0|0);
        if ($190) {
         break;
        } else {
         $$1396$be = $189;$$1400$be = $188;
        }
       } else {
        $$1396$be = $186;$$1400$be = $185;
       }
       $$1396 = $$1396$be;$$1400 = $$1400$be;
      }
      $191 = HEAP32[(40808)>>2]|0;
      $192 = ($191>>>0)>($$1400>>>0);
      if ($192) {
       _abort();
       // unreachable;
      } else {
       HEAP32[$$1400>>2] = 0;
       $$3398 = $$1396;
       break;
      }
     } else {
      $169 = ((($10)) + 8|0);
      $170 = HEAP32[$169>>2]|0;
      $171 = HEAP32[(40808)>>2]|0;
      $172 = ($171>>>0)>($170>>>0);
      if ($172) {
       _abort();
       // unreachable;
      }
      $173 = ((($170)) + 12|0);
      $174 = HEAP32[$173>>2]|0;
      $175 = ($174|0)==($10|0);
      if (!($175)) {
       _abort();
       // unreachable;
      }
      $176 = ((($167)) + 8|0);
      $177 = HEAP32[$176>>2]|0;
      $178 = ($177|0)==($10|0);
      if ($178) {
       HEAP32[$173>>2] = $167;
       HEAP32[$176>>2] = $170;
       $$3398 = $167;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $193 = ($165|0)==(0|0);
    if (!($193)) {
     $194 = ((($10)) + 28|0);
     $195 = HEAP32[$194>>2]|0;
     $196 = (41096 + ($195<<2)|0);
     $197 = HEAP32[$196>>2]|0;
     $198 = ($197|0)==($10|0);
     do {
      if ($198) {
       HEAP32[$196>>2] = $$3398;
       $cond420 = ($$3398|0)==(0|0);
       if ($cond420) {
        $199 = 1 << $195;
        $200 = $199 ^ -1;
        $201 = HEAP32[(40796)>>2]|0;
        $202 = $201 & $200;
        HEAP32[(40796)>>2] = $202;
        break L111;
       }
      } else {
       $203 = HEAP32[(40808)>>2]|0;
       $204 = ($203>>>0)>($165>>>0);
       if ($204) {
        _abort();
        // unreachable;
       } else {
        $205 = ((($165)) + 16|0);
        $206 = HEAP32[$205>>2]|0;
        $207 = ($206|0)==($10|0);
        $208 = ((($165)) + 20|0);
        $$sink456 = $207 ? $205 : $208;
        HEAP32[$$sink456>>2] = $$3398;
        $209 = ($$3398|0)==(0|0);
        if ($209) {
         break L111;
        } else {
         break;
        }
       }
      }
     } while(0);
     $210 = HEAP32[(40808)>>2]|0;
     $211 = ($210>>>0)>($$3398>>>0);
     if ($211) {
      _abort();
      // unreachable;
     }
     $212 = ((($$3398)) + 24|0);
     HEAP32[$212>>2] = $165;
     $213 = ((($10)) + 16|0);
     $214 = HEAP32[$213>>2]|0;
     $215 = ($214|0)==(0|0);
     do {
      if (!($215)) {
       $216 = ($210>>>0)>($214>>>0);
       if ($216) {
        _abort();
        // unreachable;
       } else {
        $217 = ((($$3398)) + 16|0);
        HEAP32[$217>>2] = $214;
        $218 = ((($214)) + 24|0);
        HEAP32[$218>>2] = $$3398;
        break;
       }
      }
     } while(0);
     $219 = ((($213)) + 4|0);
     $220 = HEAP32[$219>>2]|0;
     $221 = ($220|0)==(0|0);
     if (!($221)) {
      $222 = HEAP32[(40808)>>2]|0;
      $223 = ($222>>>0)>($220>>>0);
      if ($223) {
       _abort();
       // unreachable;
      } else {
       $224 = ((($$3398)) + 20|0);
       HEAP32[$224>>2] = $220;
       $225 = ((($220)) + 24|0);
       HEAP32[$225>>2] = $$3398;
       break;
      }
     }
    }
   }
  } while(0);
  $226 = $137 | 1;
  $227 = ((($$1)) + 4|0);
  HEAP32[$227>>2] = $226;
  $228 = (($114) + ($137)|0);
  HEAP32[$228>>2] = $137;
  $229 = HEAP32[(40812)>>2]|0;
  $230 = ($$1|0)==($229|0);
  if ($230) {
   HEAP32[(40800)>>2] = $137;
   return;
  } else {
   $$2 = $137;
  }
 } else {
  $231 = $116 & -2;
  HEAP32[$115>>2] = $231;
  $232 = $$1380 | 1;
  $233 = ((($$1)) + 4|0);
  HEAP32[$233>>2] = $232;
  $234 = (($114) + ($$1380)|0);
  HEAP32[$234>>2] = $$1380;
  $$2 = $$1380;
 }
 $235 = $$2 >>> 3;
 $236 = ($$2>>>0)<(256);
 if ($236) {
  $237 = $235 << 1;
  $238 = (40832 + ($237<<2)|0);
  $239 = HEAP32[10198]|0;
  $240 = 1 << $235;
  $241 = $239 & $240;
  $242 = ($241|0)==(0);
  if ($242) {
   $243 = $239 | $240;
   HEAP32[10198] = $243;
   $$pre = ((($238)) + 8|0);
   $$0401 = $238;$$pre$phiZ2D = $$pre;
  } else {
   $244 = ((($238)) + 8|0);
   $245 = HEAP32[$244>>2]|0;
   $246 = HEAP32[(40808)>>2]|0;
   $247 = ($246>>>0)>($245>>>0);
   if ($247) {
    _abort();
    // unreachable;
   } else {
    $$0401 = $245;$$pre$phiZ2D = $244;
   }
  }
  HEAP32[$$pre$phiZ2D>>2] = $$1;
  $248 = ((($$0401)) + 12|0);
  HEAP32[$248>>2] = $$1;
  $249 = ((($$1)) + 8|0);
  HEAP32[$249>>2] = $$0401;
  $250 = ((($$1)) + 12|0);
  HEAP32[$250>>2] = $238;
  return;
 }
 $251 = $$2 >>> 8;
 $252 = ($251|0)==(0);
 if ($252) {
  $$0394 = 0;
 } else {
  $253 = ($$2>>>0)>(16777215);
  if ($253) {
   $$0394 = 31;
  } else {
   $254 = (($251) + 1048320)|0;
   $255 = $254 >>> 16;
   $256 = $255 & 8;
   $257 = $251 << $256;
   $258 = (($257) + 520192)|0;
   $259 = $258 >>> 16;
   $260 = $259 & 4;
   $261 = $260 | $256;
   $262 = $257 << $260;
   $263 = (($262) + 245760)|0;
   $264 = $263 >>> 16;
   $265 = $264 & 2;
   $266 = $261 | $265;
   $267 = (14 - ($266))|0;
   $268 = $262 << $265;
   $269 = $268 >>> 15;
   $270 = (($267) + ($269))|0;
   $271 = $270 << 1;
   $272 = (($270) + 7)|0;
   $273 = $$2 >>> $272;
   $274 = $273 & 1;
   $275 = $274 | $271;
   $$0394 = $275;
  }
 }
 $276 = (41096 + ($$0394<<2)|0);
 $277 = ((($$1)) + 28|0);
 HEAP32[$277>>2] = $$0394;
 $278 = ((($$1)) + 16|0);
 $279 = ((($$1)) + 20|0);
 HEAP32[$279>>2] = 0;
 HEAP32[$278>>2] = 0;
 $280 = HEAP32[(40796)>>2]|0;
 $281 = 1 << $$0394;
 $282 = $280 & $281;
 $283 = ($282|0)==(0);
 L197: do {
  if ($283) {
   $284 = $280 | $281;
   HEAP32[(40796)>>2] = $284;
   HEAP32[$276>>2] = $$1;
   $285 = ((($$1)) + 24|0);
   HEAP32[$285>>2] = $276;
   $286 = ((($$1)) + 12|0);
   HEAP32[$286>>2] = $$1;
   $287 = ((($$1)) + 8|0);
   HEAP32[$287>>2] = $$1;
  } else {
   $288 = HEAP32[$276>>2]|0;
   $289 = ((($288)) + 4|0);
   $290 = HEAP32[$289>>2]|0;
   $291 = $290 & -8;
   $292 = ($291|0)==($$2|0);
   L200: do {
    if ($292) {
     $$0382$lcssa = $288;
    } else {
     $293 = ($$0394|0)==(31);
     $294 = $$0394 >>> 1;
     $295 = (25 - ($294))|0;
     $296 = $293 ? 0 : $295;
     $297 = $$2 << $296;
     $$0381438 = $297;$$0382437 = $288;
     while(1) {
      $304 = $$0381438 >>> 31;
      $305 = (((($$0382437)) + 16|0) + ($304<<2)|0);
      $300 = HEAP32[$305>>2]|0;
      $306 = ($300|0)==(0|0);
      if ($306) {
       break;
      }
      $298 = $$0381438 << 1;
      $299 = ((($300)) + 4|0);
      $301 = HEAP32[$299>>2]|0;
      $302 = $301 & -8;
      $303 = ($302|0)==($$2|0);
      if ($303) {
       $$0382$lcssa = $300;
       break L200;
      } else {
       $$0381438 = $298;$$0382437 = $300;
      }
     }
     $307 = HEAP32[(40808)>>2]|0;
     $308 = ($307>>>0)>($305>>>0);
     if ($308) {
      _abort();
      // unreachable;
     } else {
      HEAP32[$305>>2] = $$1;
      $309 = ((($$1)) + 24|0);
      HEAP32[$309>>2] = $$0382437;
      $310 = ((($$1)) + 12|0);
      HEAP32[$310>>2] = $$1;
      $311 = ((($$1)) + 8|0);
      HEAP32[$311>>2] = $$1;
      break L197;
     }
    }
   } while(0);
   $312 = ((($$0382$lcssa)) + 8|0);
   $313 = HEAP32[$312>>2]|0;
   $314 = HEAP32[(40808)>>2]|0;
   $315 = ($314>>>0)<=($$0382$lcssa>>>0);
   $316 = ($314>>>0)<=($313>>>0);
   $317 = $316 & $315;
   if ($317) {
    $318 = ((($313)) + 12|0);
    HEAP32[$318>>2] = $$1;
    HEAP32[$312>>2] = $$1;
    $319 = ((($$1)) + 8|0);
    HEAP32[$319>>2] = $313;
    $320 = ((($$1)) + 12|0);
    HEAP32[$320>>2] = $$0382$lcssa;
    $321 = ((($$1)) + 24|0);
    HEAP32[$321>>2] = 0;
    break;
   } else {
    _abort();
    // unreachable;
   }
  }
 } while(0);
 $322 = HEAP32[(40824)>>2]|0;
 $323 = (($322) + -1)|0;
 HEAP32[(40824)>>2] = $323;
 $324 = ($323|0)==(0);
 if (!($324)) {
  return;
 }
 $$0211$in$i = (41248);
 while(1) {
  $$0211$i = HEAP32[$$0211$in$i>>2]|0;
  $325 = ($$0211$i|0)==(0|0);
  $326 = ((($$0211$i)) + 8|0);
  if ($325) {
   break;
  } else {
   $$0211$in$i = $326;
  }
 }
 HEAP32[(40824)>>2] = -1;
 return;
}
function _calloc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0);
 if ($2) {
  $$0 = 0;
 } else {
  $3 = Math_imul($1, $0)|0;
  $4 = $1 | $0;
  $5 = ($4>>>0)>(65535);
  if ($5) {
   $6 = (($3>>>0) / ($0>>>0))&-1;
   $7 = ($6|0)==($1|0);
   $spec$select = $7 ? $3 : -1;
   $$0 = $spec$select;
  } else {
   $$0 = $3;
  }
 }
 $8 = (_malloc($$0)|0);
 $9 = ($8|0)==(0|0);
 if ($9) {
  return ($8|0);
 }
 $10 = ((($8)) + -4|0);
 $11 = HEAP32[$10>>2]|0;
 $12 = $11 & 3;
 $13 = ($12|0)==(0);
 if ($13) {
  return ($8|0);
 }
 (_memset(($8|0),0,($$0|0))|0);
 return ($8|0);
}
function _realloc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0|0)==(0|0);
 if ($2) {
  $3 = (_malloc($1)|0);
  $$1 = $3;
  return ($$1|0);
 }
 $4 = ($1>>>0)>(4294967231);
 if ($4) {
  $5 = (___errno_location()|0);
  HEAP32[$5>>2] = 12;
  $$1 = 0;
  return ($$1|0);
 }
 $6 = ($1>>>0)<(11);
 $7 = (($1) + 11)|0;
 $8 = $7 & -8;
 $9 = $6 ? 16 : $8;
 $10 = ((($0)) + -8|0);
 $11 = (_try_realloc_chunk($10,$9)|0);
 $12 = ($11|0)==(0|0);
 if (!($12)) {
  $13 = ((($11)) + 8|0);
  $$1 = $13;
  return ($$1|0);
 }
 $14 = (_malloc($1)|0);
 $15 = ($14|0)==(0|0);
 if ($15) {
  $$1 = 0;
  return ($$1|0);
 }
 $16 = ((($0)) + -4|0);
 $17 = HEAP32[$16>>2]|0;
 $18 = $17 & -8;
 $19 = $17 & 3;
 $20 = ($19|0)==(0);
 $21 = $20 ? 8 : 4;
 $22 = (($18) - ($21))|0;
 $23 = ($22>>>0)<($1>>>0);
 $24 = $23 ? $22 : $1;
 (_memcpy(($14|0),($0|0),($24|0))|0);
 _free($0);
 $$1 = $14;
 return ($$1|0);
}
function _try_realloc_chunk($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$1271 = 0, $$1271$be = 0, $$1271$ph = 0, $$1274 = 0, $$1274$be = 0, $$1274$ph = 0, $$2 = 0, $$3 = 0, $$pre = 0, $$pre$phiZ2D = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0;
 var $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0;
 var $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0;
 var $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0;
 var $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0;
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0;
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0;
 var $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0, $or$cond$not = 0, $or$cond5 = 0, $storemerge = 0, $storemerge3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ((($0)) + 4|0);
 $3 = HEAP32[$2>>2]|0;
 $4 = $3 & -8;
 $5 = (($0) + ($4)|0);
 $6 = HEAP32[(40808)>>2]|0;
 $7 = ($6>>>0)<=($0>>>0);
 $8 = $3 & 3;
 $9 = ($8|0)!=(1);
 $or$cond$not = $9 & $7;
 $10 = ($5>>>0)>($0>>>0);
 $or$cond5 = $or$cond$not & $10;
 if (!($or$cond5)) {
  _abort();
  // unreachable;
 }
 $11 = ((($5)) + 4|0);
 $12 = HEAP32[$11>>2]|0;
 $13 = $12 & 1;
 $14 = ($13|0)==(0);
 if ($14) {
  _abort();
  // unreachable;
 }
 $15 = ($8|0)==(0);
 if ($15) {
  $16 = ($1>>>0)<(256);
  if ($16) {
   $$2 = 0;
   return ($$2|0);
  }
  $17 = (($1) + 4)|0;
  $18 = ($4>>>0)<($17>>>0);
  if (!($18)) {
   $19 = (($4) - ($1))|0;
   $20 = HEAP32[(41272)>>2]|0;
   $21 = $20 << 1;
   $22 = ($19>>>0)>($21>>>0);
   if (!($22)) {
    $$2 = $0;
    return ($$2|0);
   }
  }
  $$2 = 0;
  return ($$2|0);
 }
 $23 = ($4>>>0)<($1>>>0);
 if (!($23)) {
  $24 = (($4) - ($1))|0;
  $25 = ($24>>>0)>(15);
  if (!($25)) {
   $$2 = $0;
   return ($$2|0);
  }
  $26 = (($0) + ($1)|0);
  $27 = $3 & 1;
  $28 = $27 | $1;
  $29 = $28 | 2;
  HEAP32[$2>>2] = $29;
  $30 = ((($26)) + 4|0);
  $31 = $24 | 3;
  HEAP32[$30>>2] = $31;
  $32 = HEAP32[$11>>2]|0;
  $33 = $32 | 1;
  HEAP32[$11>>2] = $33;
  _dispose_chunk($26,$24);
  $$2 = $0;
  return ($$2|0);
 }
 $34 = HEAP32[(40816)>>2]|0;
 $35 = ($34|0)==($5|0);
 if ($35) {
  $36 = HEAP32[(40804)>>2]|0;
  $37 = (($36) + ($4))|0;
  $38 = ($37>>>0)>($1>>>0);
  $39 = (($37) - ($1))|0;
  $40 = (($0) + ($1)|0);
  if (!($38)) {
   $$2 = 0;
   return ($$2|0);
  }
  $41 = $39 | 1;
  $42 = ((($40)) + 4|0);
  $43 = $3 & 1;
  $44 = $43 | $1;
  $45 = $44 | 2;
  HEAP32[$2>>2] = $45;
  HEAP32[$42>>2] = $41;
  HEAP32[(40816)>>2] = $40;
  HEAP32[(40804)>>2] = $39;
  $$2 = $0;
  return ($$2|0);
 }
 $46 = HEAP32[(40812)>>2]|0;
 $47 = ($46|0)==($5|0);
 if ($47) {
  $48 = HEAP32[(40800)>>2]|0;
  $49 = (($48) + ($4))|0;
  $50 = ($49>>>0)<($1>>>0);
  if ($50) {
   $$2 = 0;
   return ($$2|0);
  }
  $51 = (($49) - ($1))|0;
  $52 = ($51>>>0)>(15);
  if ($52) {
   $53 = (($0) + ($1)|0);
   $54 = (($0) + ($49)|0);
   $55 = $3 & 1;
   $56 = $55 | $1;
   $57 = $56 | 2;
   HEAP32[$2>>2] = $57;
   $58 = ((($53)) + 4|0);
   $59 = $51 | 1;
   HEAP32[$58>>2] = $59;
   HEAP32[$54>>2] = $51;
   $60 = ((($54)) + 4|0);
   $61 = HEAP32[$60>>2]|0;
   $62 = $61 & -2;
   HEAP32[$60>>2] = $62;
   $storemerge = $53;$storemerge3 = $51;
  } else {
   $63 = $3 & 1;
   $64 = $63 | $49;
   $65 = $64 | 2;
   HEAP32[$2>>2] = $65;
   $66 = (($0) + ($49)|0);
   $67 = ((($66)) + 4|0);
   $68 = HEAP32[$67>>2]|0;
   $69 = $68 | 1;
   HEAP32[$67>>2] = $69;
   $storemerge = 0;$storemerge3 = 0;
  }
  HEAP32[(40800)>>2] = $storemerge3;
  HEAP32[(40812)>>2] = $storemerge;
  $$2 = $0;
  return ($$2|0);
 }
 $70 = $12 & 2;
 $71 = ($70|0)==(0);
 if (!($71)) {
  $$2 = 0;
  return ($$2|0);
 }
 $72 = $12 & -8;
 $73 = (($72) + ($4))|0;
 $74 = ($73>>>0)<($1>>>0);
 if ($74) {
  $$2 = 0;
  return ($$2|0);
 }
 $75 = (($73) - ($1))|0;
 $76 = $12 >>> 3;
 $77 = ($12>>>0)<(256);
 L49: do {
  if ($77) {
   $78 = ((($5)) + 8|0);
   $79 = HEAP32[$78>>2]|0;
   $80 = ((($5)) + 12|0);
   $81 = HEAP32[$80>>2]|0;
   $82 = $76 << 1;
   $83 = (40832 + ($82<<2)|0);
   $84 = ($79|0)==($83|0);
   if (!($84)) {
    $85 = ($6>>>0)>($79>>>0);
    if ($85) {
     _abort();
     // unreachable;
    }
    $86 = ((($79)) + 12|0);
    $87 = HEAP32[$86>>2]|0;
    $88 = ($87|0)==($5|0);
    if (!($88)) {
     _abort();
     // unreachable;
    }
   }
   $89 = ($81|0)==($79|0);
   if ($89) {
    $90 = 1 << $76;
    $91 = $90 ^ -1;
    $92 = HEAP32[10198]|0;
    $93 = $92 & $91;
    HEAP32[10198] = $93;
    break;
   }
   $94 = ($81|0)==($83|0);
   if ($94) {
    $$pre = ((($81)) + 8|0);
    $$pre$phiZ2D = $$pre;
   } else {
    $95 = ($6>>>0)>($81>>>0);
    if ($95) {
     _abort();
     // unreachable;
    }
    $96 = ((($81)) + 8|0);
    $97 = HEAP32[$96>>2]|0;
    $98 = ($97|0)==($5|0);
    if ($98) {
     $$pre$phiZ2D = $96;
    } else {
     _abort();
     // unreachable;
    }
   }
   $99 = ((($79)) + 12|0);
   HEAP32[$99>>2] = $81;
   HEAP32[$$pre$phiZ2D>>2] = $79;
  } else {
   $100 = ((($5)) + 24|0);
   $101 = HEAP32[$100>>2]|0;
   $102 = ((($5)) + 12|0);
   $103 = HEAP32[$102>>2]|0;
   $104 = ($103|0)==($5|0);
   do {
    if ($104) {
     $114 = ((($5)) + 16|0);
     $115 = ((($114)) + 4|0);
     $116 = HEAP32[$115>>2]|0;
     $117 = ($116|0)==(0|0);
     if ($117) {
      $118 = HEAP32[$114>>2]|0;
      $119 = ($118|0)==(0|0);
      if ($119) {
       $$3 = 0;
       break;
      } else {
       $$1271$ph = $118;$$1274$ph = $114;
      }
     } else {
      $$1271$ph = $116;$$1274$ph = $115;
     }
     $$1271 = $$1271$ph;$$1274 = $$1274$ph;
     while(1) {
      $120 = ((($$1271)) + 20|0);
      $121 = HEAP32[$120>>2]|0;
      $122 = ($121|0)==(0|0);
      if ($122) {
       $123 = ((($$1271)) + 16|0);
       $124 = HEAP32[$123>>2]|0;
       $125 = ($124|0)==(0|0);
       if ($125) {
        break;
       } else {
        $$1271$be = $124;$$1274$be = $123;
       }
      } else {
       $$1271$be = $121;$$1274$be = $120;
      }
      $$1271 = $$1271$be;$$1274 = $$1274$be;
     }
     $126 = ($6>>>0)>($$1274>>>0);
     if ($126) {
      _abort();
      // unreachable;
     } else {
      HEAP32[$$1274>>2] = 0;
      $$3 = $$1271;
      break;
     }
    } else {
     $105 = ((($5)) + 8|0);
     $106 = HEAP32[$105>>2]|0;
     $107 = ($6>>>0)>($106>>>0);
     if ($107) {
      _abort();
      // unreachable;
     }
     $108 = ((($106)) + 12|0);
     $109 = HEAP32[$108>>2]|0;
     $110 = ($109|0)==($5|0);
     if (!($110)) {
      _abort();
      // unreachable;
     }
     $111 = ((($103)) + 8|0);
     $112 = HEAP32[$111>>2]|0;
     $113 = ($112|0)==($5|0);
     if ($113) {
      HEAP32[$108>>2] = $103;
      HEAP32[$111>>2] = $106;
      $$3 = $103;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   } while(0);
   $127 = ($101|0)==(0|0);
   if (!($127)) {
    $128 = ((($5)) + 28|0);
    $129 = HEAP32[$128>>2]|0;
    $130 = (41096 + ($129<<2)|0);
    $131 = HEAP32[$130>>2]|0;
    $132 = ($131|0)==($5|0);
    do {
     if ($132) {
      HEAP32[$130>>2] = $$3;
      $cond = ($$3|0)==(0|0);
      if ($cond) {
       $133 = 1 << $129;
       $134 = $133 ^ -1;
       $135 = HEAP32[(40796)>>2]|0;
       $136 = $135 & $134;
       HEAP32[(40796)>>2] = $136;
       break L49;
      }
     } else {
      $137 = HEAP32[(40808)>>2]|0;
      $138 = ($137>>>0)>($101>>>0);
      if ($138) {
       _abort();
       // unreachable;
      } else {
       $139 = ((($101)) + 16|0);
       $140 = HEAP32[$139>>2]|0;
       $141 = ($140|0)==($5|0);
       $142 = ((($101)) + 20|0);
       $$sink = $141 ? $139 : $142;
       HEAP32[$$sink>>2] = $$3;
       $143 = ($$3|0)==(0|0);
       if ($143) {
        break L49;
       } else {
        break;
       }
      }
     }
    } while(0);
    $144 = HEAP32[(40808)>>2]|0;
    $145 = ($144>>>0)>($$3>>>0);
    if ($145) {
     _abort();
     // unreachable;
    }
    $146 = ((($$3)) + 24|0);
    HEAP32[$146>>2] = $101;
    $147 = ((($5)) + 16|0);
    $148 = HEAP32[$147>>2]|0;
    $149 = ($148|0)==(0|0);
    do {
     if (!($149)) {
      $150 = ($144>>>0)>($148>>>0);
      if ($150) {
       _abort();
       // unreachable;
      } else {
       $151 = ((($$3)) + 16|0);
       HEAP32[$151>>2] = $148;
       $152 = ((($148)) + 24|0);
       HEAP32[$152>>2] = $$3;
       break;
      }
     }
    } while(0);
    $153 = ((($147)) + 4|0);
    $154 = HEAP32[$153>>2]|0;
    $155 = ($154|0)==(0|0);
    if (!($155)) {
     $156 = HEAP32[(40808)>>2]|0;
     $157 = ($156>>>0)>($154>>>0);
     if ($157) {
      _abort();
      // unreachable;
     } else {
      $158 = ((($$3)) + 20|0);
      HEAP32[$158>>2] = $154;
      $159 = ((($154)) + 24|0);
      HEAP32[$159>>2] = $$3;
      break;
     }
    }
   }
  }
 } while(0);
 $160 = ($75>>>0)<(16);
 if ($160) {
  $161 = $3 & 1;
  $162 = $161 | $73;
  $163 = $162 | 2;
  HEAP32[$2>>2] = $163;
  $164 = (($0) + ($73)|0);
  $165 = ((($164)) + 4|0);
  $166 = HEAP32[$165>>2]|0;
  $167 = $166 | 1;
  HEAP32[$165>>2] = $167;
  $$2 = $0;
  return ($$2|0);
 } else {
  $168 = (($0) + ($1)|0);
  $169 = $3 & 1;
  $170 = $169 | $1;
  $171 = $170 | 2;
  HEAP32[$2>>2] = $171;
  $172 = ((($168)) + 4|0);
  $173 = $75 | 3;
  HEAP32[$172>>2] = $173;
  $174 = (($0) + ($73)|0);
  $175 = ((($174)) + 4|0);
  $176 = HEAP32[$175>>2]|0;
  $177 = $176 | 1;
  HEAP32[$175>>2] = $177;
  _dispose_chunk($168,$75);
  $$2 = $0;
  return ($$2|0);
 }
 return (0)|0;
}
function _dispose_chunk($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$041722 = 0, $$0418$lcssa = 0, $$041821 = 0, $$0429 = 0, $$0436 = 0, $$1 = 0, $$1416 = 0, $$1424 = 0, $$1424$be = 0, $$1424$ph = 0, $$1427 = 0, $$1427$be = 0, $$1427$ph = 0, $$1431 = 0, $$1431$be = 0, $$1431$ph = 0, $$1435 = 0, $$1435$be = 0, $$1435$ph = 0, $$2 = 0;
 var $$3 = 0, $$3433 = 0, $$pre = 0, $$pre$phi28Z2D = 0, $$pre$phi30Z2D = 0, $$pre$phiZ2D = 0, $$pre27 = 0, $$pre29 = 0, $$sink = 0, $$sink41 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0;
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0;
 var $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0;
 var $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0;
 var $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0;
 var $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0;
 var $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0;
 var $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0;
 var $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0;
 var $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0;
 var $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0;
 var $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0;
 var $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0;
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0;
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0;
 var $cond17 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (($0) + ($1)|0);
 $3 = ((($0)) + 4|0);
 $4 = HEAP32[$3>>2]|0;
 $5 = $4 & 1;
 $6 = ($5|0)==(0);
 L1: do {
  if ($6) {
   $7 = HEAP32[$0>>2]|0;
   $8 = $4 & 3;
   $9 = ($8|0)==(0);
   if ($9) {
    return;
   }
   $10 = (0 - ($7))|0;
   $11 = (($0) + ($10)|0);
   $12 = (($7) + ($1))|0;
   $13 = HEAP32[(40808)>>2]|0;
   $14 = ($11>>>0)<($13>>>0);
   if ($14) {
    _abort();
    // unreachable;
   }
   $15 = HEAP32[(40812)>>2]|0;
   $16 = ($15|0)==($11|0);
   if ($16) {
    $101 = ((($2)) + 4|0);
    $102 = HEAP32[$101>>2]|0;
    $103 = $102 & 3;
    $104 = ($103|0)==(3);
    if (!($104)) {
     $$1 = $11;$$1416 = $12;
     break;
    }
    $105 = ((($11)) + 4|0);
    $106 = $12 | 1;
    $107 = $102 & -2;
    HEAP32[(40800)>>2] = $12;
    HEAP32[$101>>2] = $107;
    HEAP32[$105>>2] = $106;
    HEAP32[$2>>2] = $12;
    return;
   }
   $17 = $7 >>> 3;
   $18 = ($7>>>0)<(256);
   if ($18) {
    $19 = ((($11)) + 8|0);
    $20 = HEAP32[$19>>2]|0;
    $21 = ((($11)) + 12|0);
    $22 = HEAP32[$21>>2]|0;
    $23 = $17 << 1;
    $24 = (40832 + ($23<<2)|0);
    $25 = ($20|0)==($24|0);
    if (!($25)) {
     $26 = ($13>>>0)>($20>>>0);
     if ($26) {
      _abort();
      // unreachable;
     }
     $27 = ((($20)) + 12|0);
     $28 = HEAP32[$27>>2]|0;
     $29 = ($28|0)==($11|0);
     if (!($29)) {
      _abort();
      // unreachable;
     }
    }
    $30 = ($22|0)==($20|0);
    if ($30) {
     $31 = 1 << $17;
     $32 = $31 ^ -1;
     $33 = HEAP32[10198]|0;
     $34 = $33 & $32;
     HEAP32[10198] = $34;
     $$1 = $11;$$1416 = $12;
     break;
    }
    $35 = ($22|0)==($24|0);
    if ($35) {
     $$pre29 = ((($22)) + 8|0);
     $$pre$phi30Z2D = $$pre29;
    } else {
     $36 = ($13>>>0)>($22>>>0);
     if ($36) {
      _abort();
      // unreachable;
     }
     $37 = ((($22)) + 8|0);
     $38 = HEAP32[$37>>2]|0;
     $39 = ($38|0)==($11|0);
     if ($39) {
      $$pre$phi30Z2D = $37;
     } else {
      _abort();
      // unreachable;
     }
    }
    $40 = ((($20)) + 12|0);
    HEAP32[$40>>2] = $22;
    HEAP32[$$pre$phi30Z2D>>2] = $20;
    $$1 = $11;$$1416 = $12;
    break;
   }
   $41 = ((($11)) + 24|0);
   $42 = HEAP32[$41>>2]|0;
   $43 = ((($11)) + 12|0);
   $44 = HEAP32[$43>>2]|0;
   $45 = ($44|0)==($11|0);
   do {
    if ($45) {
     $55 = ((($11)) + 16|0);
     $56 = ((($55)) + 4|0);
     $57 = HEAP32[$56>>2]|0;
     $58 = ($57|0)==(0|0);
     if ($58) {
      $59 = HEAP32[$55>>2]|0;
      $60 = ($59|0)==(0|0);
      if ($60) {
       $$3 = 0;
       break;
      } else {
       $$1424$ph = $59;$$1427$ph = $55;
      }
     } else {
      $$1424$ph = $57;$$1427$ph = $56;
     }
     $$1424 = $$1424$ph;$$1427 = $$1427$ph;
     while(1) {
      $61 = ((($$1424)) + 20|0);
      $62 = HEAP32[$61>>2]|0;
      $63 = ($62|0)==(0|0);
      if ($63) {
       $64 = ((($$1424)) + 16|0);
       $65 = HEAP32[$64>>2]|0;
       $66 = ($65|0)==(0|0);
       if ($66) {
        break;
       } else {
        $$1424$be = $65;$$1427$be = $64;
       }
      } else {
       $$1424$be = $62;$$1427$be = $61;
      }
      $$1424 = $$1424$be;$$1427 = $$1427$be;
     }
     $67 = ($13>>>0)>($$1427>>>0);
     if ($67) {
      _abort();
      // unreachable;
     } else {
      HEAP32[$$1427>>2] = 0;
      $$3 = $$1424;
      break;
     }
    } else {
     $46 = ((($11)) + 8|0);
     $47 = HEAP32[$46>>2]|0;
     $48 = ($13>>>0)>($47>>>0);
     if ($48) {
      _abort();
      // unreachable;
     }
     $49 = ((($47)) + 12|0);
     $50 = HEAP32[$49>>2]|0;
     $51 = ($50|0)==($11|0);
     if (!($51)) {
      _abort();
      // unreachable;
     }
     $52 = ((($44)) + 8|0);
     $53 = HEAP32[$52>>2]|0;
     $54 = ($53|0)==($11|0);
     if ($54) {
      HEAP32[$49>>2] = $44;
      HEAP32[$52>>2] = $47;
      $$3 = $44;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   } while(0);
   $68 = ($42|0)==(0|0);
   if ($68) {
    $$1 = $11;$$1416 = $12;
   } else {
    $69 = ((($11)) + 28|0);
    $70 = HEAP32[$69>>2]|0;
    $71 = (41096 + ($70<<2)|0);
    $72 = HEAP32[$71>>2]|0;
    $73 = ($72|0)==($11|0);
    do {
     if ($73) {
      HEAP32[$71>>2] = $$3;
      $cond = ($$3|0)==(0|0);
      if ($cond) {
       $74 = 1 << $70;
       $75 = $74 ^ -1;
       $76 = HEAP32[(40796)>>2]|0;
       $77 = $76 & $75;
       HEAP32[(40796)>>2] = $77;
       $$1 = $11;$$1416 = $12;
       break L1;
      }
     } else {
      $78 = HEAP32[(40808)>>2]|0;
      $79 = ($78>>>0)>($42>>>0);
      if ($79) {
       _abort();
       // unreachable;
      } else {
       $80 = ((($42)) + 16|0);
       $81 = HEAP32[$80>>2]|0;
       $82 = ($81|0)==($11|0);
       $83 = ((($42)) + 20|0);
       $$sink = $82 ? $80 : $83;
       HEAP32[$$sink>>2] = $$3;
       $84 = ($$3|0)==(0|0);
       if ($84) {
        $$1 = $11;$$1416 = $12;
        break L1;
       } else {
        break;
       }
      }
     }
    } while(0);
    $85 = HEAP32[(40808)>>2]|0;
    $86 = ($85>>>0)>($$3>>>0);
    if ($86) {
     _abort();
     // unreachable;
    }
    $87 = ((($$3)) + 24|0);
    HEAP32[$87>>2] = $42;
    $88 = ((($11)) + 16|0);
    $89 = HEAP32[$88>>2]|0;
    $90 = ($89|0)==(0|0);
    do {
     if (!($90)) {
      $91 = ($85>>>0)>($89>>>0);
      if ($91) {
       _abort();
       // unreachable;
      } else {
       $92 = ((($$3)) + 16|0);
       HEAP32[$92>>2] = $89;
       $93 = ((($89)) + 24|0);
       HEAP32[$93>>2] = $$3;
       break;
      }
     }
    } while(0);
    $94 = ((($88)) + 4|0);
    $95 = HEAP32[$94>>2]|0;
    $96 = ($95|0)==(0|0);
    if ($96) {
     $$1 = $11;$$1416 = $12;
    } else {
     $97 = HEAP32[(40808)>>2]|0;
     $98 = ($97>>>0)>($95>>>0);
     if ($98) {
      _abort();
      // unreachable;
     } else {
      $99 = ((($$3)) + 20|0);
      HEAP32[$99>>2] = $95;
      $100 = ((($95)) + 24|0);
      HEAP32[$100>>2] = $$3;
      $$1 = $11;$$1416 = $12;
      break;
     }
    }
   }
  } else {
   $$1 = $0;$$1416 = $1;
  }
 } while(0);
 $108 = HEAP32[(40808)>>2]|0;
 $109 = ($2>>>0)<($108>>>0);
 if ($109) {
  _abort();
  // unreachable;
 }
 $110 = ((($2)) + 4|0);
 $111 = HEAP32[$110>>2]|0;
 $112 = $111 & 2;
 $113 = ($112|0)==(0);
 if ($113) {
  $114 = HEAP32[(40816)>>2]|0;
  $115 = ($114|0)==($2|0);
  if ($115) {
   $116 = HEAP32[(40804)>>2]|0;
   $117 = (($116) + ($$1416))|0;
   HEAP32[(40804)>>2] = $117;
   HEAP32[(40816)>>2] = $$1;
   $118 = $117 | 1;
   $119 = ((($$1)) + 4|0);
   HEAP32[$119>>2] = $118;
   $120 = HEAP32[(40812)>>2]|0;
   $121 = ($$1|0)==($120|0);
   if (!($121)) {
    return;
   }
   HEAP32[(40812)>>2] = 0;
   HEAP32[(40800)>>2] = 0;
   return;
  }
  $122 = HEAP32[(40812)>>2]|0;
  $123 = ($122|0)==($2|0);
  if ($123) {
   $124 = HEAP32[(40800)>>2]|0;
   $125 = (($124) + ($$1416))|0;
   HEAP32[(40800)>>2] = $125;
   HEAP32[(40812)>>2] = $$1;
   $126 = $125 | 1;
   $127 = ((($$1)) + 4|0);
   HEAP32[$127>>2] = $126;
   $128 = (($$1) + ($125)|0);
   HEAP32[$128>>2] = $125;
   return;
  }
  $129 = $111 & -8;
  $130 = (($129) + ($$1416))|0;
  $131 = $111 >>> 3;
  $132 = ($111>>>0)<(256);
  L99: do {
   if ($132) {
    $133 = ((($2)) + 8|0);
    $134 = HEAP32[$133>>2]|0;
    $135 = ((($2)) + 12|0);
    $136 = HEAP32[$135>>2]|0;
    $137 = $131 << 1;
    $138 = (40832 + ($137<<2)|0);
    $139 = ($134|0)==($138|0);
    if (!($139)) {
     $140 = ($108>>>0)>($134>>>0);
     if ($140) {
      _abort();
      // unreachable;
     }
     $141 = ((($134)) + 12|0);
     $142 = HEAP32[$141>>2]|0;
     $143 = ($142|0)==($2|0);
     if (!($143)) {
      _abort();
      // unreachable;
     }
    }
    $144 = ($136|0)==($134|0);
    if ($144) {
     $145 = 1 << $131;
     $146 = $145 ^ -1;
     $147 = HEAP32[10198]|0;
     $148 = $147 & $146;
     HEAP32[10198] = $148;
     break;
    }
    $149 = ($136|0)==($138|0);
    if ($149) {
     $$pre27 = ((($136)) + 8|0);
     $$pre$phi28Z2D = $$pre27;
    } else {
     $150 = ($108>>>0)>($136>>>0);
     if ($150) {
      _abort();
      // unreachable;
     }
     $151 = ((($136)) + 8|0);
     $152 = HEAP32[$151>>2]|0;
     $153 = ($152|0)==($2|0);
     if ($153) {
      $$pre$phi28Z2D = $151;
     } else {
      _abort();
      // unreachable;
     }
    }
    $154 = ((($134)) + 12|0);
    HEAP32[$154>>2] = $136;
    HEAP32[$$pre$phi28Z2D>>2] = $134;
   } else {
    $155 = ((($2)) + 24|0);
    $156 = HEAP32[$155>>2]|0;
    $157 = ((($2)) + 12|0);
    $158 = HEAP32[$157>>2]|0;
    $159 = ($158|0)==($2|0);
    do {
     if ($159) {
      $169 = ((($2)) + 16|0);
      $170 = ((($169)) + 4|0);
      $171 = HEAP32[$170>>2]|0;
      $172 = ($171|0)==(0|0);
      if ($172) {
       $173 = HEAP32[$169>>2]|0;
       $174 = ($173|0)==(0|0);
       if ($174) {
        $$3433 = 0;
        break;
       } else {
        $$1431$ph = $173;$$1435$ph = $169;
       }
      } else {
       $$1431$ph = $171;$$1435$ph = $170;
      }
      $$1431 = $$1431$ph;$$1435 = $$1435$ph;
      while(1) {
       $175 = ((($$1431)) + 20|0);
       $176 = HEAP32[$175>>2]|0;
       $177 = ($176|0)==(0|0);
       if ($177) {
        $178 = ((($$1431)) + 16|0);
        $179 = HEAP32[$178>>2]|0;
        $180 = ($179|0)==(0|0);
        if ($180) {
         break;
        } else {
         $$1431$be = $179;$$1435$be = $178;
        }
       } else {
        $$1431$be = $176;$$1435$be = $175;
       }
       $$1431 = $$1431$be;$$1435 = $$1435$be;
      }
      $181 = ($108>>>0)>($$1435>>>0);
      if ($181) {
       _abort();
       // unreachable;
      } else {
       HEAP32[$$1435>>2] = 0;
       $$3433 = $$1431;
       break;
      }
     } else {
      $160 = ((($2)) + 8|0);
      $161 = HEAP32[$160>>2]|0;
      $162 = ($108>>>0)>($161>>>0);
      if ($162) {
       _abort();
       // unreachable;
      }
      $163 = ((($161)) + 12|0);
      $164 = HEAP32[$163>>2]|0;
      $165 = ($164|0)==($2|0);
      if (!($165)) {
       _abort();
       // unreachable;
      }
      $166 = ((($158)) + 8|0);
      $167 = HEAP32[$166>>2]|0;
      $168 = ($167|0)==($2|0);
      if ($168) {
       HEAP32[$163>>2] = $158;
       HEAP32[$166>>2] = $161;
       $$3433 = $158;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $182 = ($156|0)==(0|0);
    if (!($182)) {
     $183 = ((($2)) + 28|0);
     $184 = HEAP32[$183>>2]|0;
     $185 = (41096 + ($184<<2)|0);
     $186 = HEAP32[$185>>2]|0;
     $187 = ($186|0)==($2|0);
     do {
      if ($187) {
       HEAP32[$185>>2] = $$3433;
       $cond17 = ($$3433|0)==(0|0);
       if ($cond17) {
        $188 = 1 << $184;
        $189 = $188 ^ -1;
        $190 = HEAP32[(40796)>>2]|0;
        $191 = $190 & $189;
        HEAP32[(40796)>>2] = $191;
        break L99;
       }
      } else {
       $192 = HEAP32[(40808)>>2]|0;
       $193 = ($192>>>0)>($156>>>0);
       if ($193) {
        _abort();
        // unreachable;
       } else {
        $194 = ((($156)) + 16|0);
        $195 = HEAP32[$194>>2]|0;
        $196 = ($195|0)==($2|0);
        $197 = ((($156)) + 20|0);
        $$sink41 = $196 ? $194 : $197;
        HEAP32[$$sink41>>2] = $$3433;
        $198 = ($$3433|0)==(0|0);
        if ($198) {
         break L99;
        } else {
         break;
        }
       }
      }
     } while(0);
     $199 = HEAP32[(40808)>>2]|0;
     $200 = ($199>>>0)>($$3433>>>0);
     if ($200) {
      _abort();
      // unreachable;
     }
     $201 = ((($$3433)) + 24|0);
     HEAP32[$201>>2] = $156;
     $202 = ((($2)) + 16|0);
     $203 = HEAP32[$202>>2]|0;
     $204 = ($203|0)==(0|0);
     do {
      if (!($204)) {
       $205 = ($199>>>0)>($203>>>0);
       if ($205) {
        _abort();
        // unreachable;
       } else {
        $206 = ((($$3433)) + 16|0);
        HEAP32[$206>>2] = $203;
        $207 = ((($203)) + 24|0);
        HEAP32[$207>>2] = $$3433;
        break;
       }
      }
     } while(0);
     $208 = ((($202)) + 4|0);
     $209 = HEAP32[$208>>2]|0;
     $210 = ($209|0)==(0|0);
     if (!($210)) {
      $211 = HEAP32[(40808)>>2]|0;
      $212 = ($211>>>0)>($209>>>0);
      if ($212) {
       _abort();
       // unreachable;
      } else {
       $213 = ((($$3433)) + 20|0);
       HEAP32[$213>>2] = $209;
       $214 = ((($209)) + 24|0);
       HEAP32[$214>>2] = $$3433;
       break;
      }
     }
    }
   }
  } while(0);
  $215 = $130 | 1;
  $216 = ((($$1)) + 4|0);
  HEAP32[$216>>2] = $215;
  $217 = (($$1) + ($130)|0);
  HEAP32[$217>>2] = $130;
  $218 = HEAP32[(40812)>>2]|0;
  $219 = ($$1|0)==($218|0);
  if ($219) {
   HEAP32[(40800)>>2] = $130;
   return;
  } else {
   $$2 = $130;
  }
 } else {
  $220 = $111 & -2;
  HEAP32[$110>>2] = $220;
  $221 = $$1416 | 1;
  $222 = ((($$1)) + 4|0);
  HEAP32[$222>>2] = $221;
  $223 = (($$1) + ($$1416)|0);
  HEAP32[$223>>2] = $$1416;
  $$2 = $$1416;
 }
 $224 = $$2 >>> 3;
 $225 = ($$2>>>0)<(256);
 if ($225) {
  $226 = $224 << 1;
  $227 = (40832 + ($226<<2)|0);
  $228 = HEAP32[10198]|0;
  $229 = 1 << $224;
  $230 = $228 & $229;
  $231 = ($230|0)==(0);
  if ($231) {
   $232 = $228 | $229;
   HEAP32[10198] = $232;
   $$pre = ((($227)) + 8|0);
   $$0436 = $227;$$pre$phiZ2D = $$pre;
  } else {
   $233 = ((($227)) + 8|0);
   $234 = HEAP32[$233>>2]|0;
   $235 = HEAP32[(40808)>>2]|0;
   $236 = ($235>>>0)>($234>>>0);
   if ($236) {
    _abort();
    // unreachable;
   } else {
    $$0436 = $234;$$pre$phiZ2D = $233;
   }
  }
  HEAP32[$$pre$phiZ2D>>2] = $$1;
  $237 = ((($$0436)) + 12|0);
  HEAP32[$237>>2] = $$1;
  $238 = ((($$1)) + 8|0);
  HEAP32[$238>>2] = $$0436;
  $239 = ((($$1)) + 12|0);
  HEAP32[$239>>2] = $227;
  return;
 }
 $240 = $$2 >>> 8;
 $241 = ($240|0)==(0);
 if ($241) {
  $$0429 = 0;
 } else {
  $242 = ($$2>>>0)>(16777215);
  if ($242) {
   $$0429 = 31;
  } else {
   $243 = (($240) + 1048320)|0;
   $244 = $243 >>> 16;
   $245 = $244 & 8;
   $246 = $240 << $245;
   $247 = (($246) + 520192)|0;
   $248 = $247 >>> 16;
   $249 = $248 & 4;
   $250 = $249 | $245;
   $251 = $246 << $249;
   $252 = (($251) + 245760)|0;
   $253 = $252 >>> 16;
   $254 = $253 & 2;
   $255 = $250 | $254;
   $256 = (14 - ($255))|0;
   $257 = $251 << $254;
   $258 = $257 >>> 15;
   $259 = (($256) + ($258))|0;
   $260 = $259 << 1;
   $261 = (($259) + 7)|0;
   $262 = $$2 >>> $261;
   $263 = $262 & 1;
   $264 = $263 | $260;
   $$0429 = $264;
  }
 }
 $265 = (41096 + ($$0429<<2)|0);
 $266 = ((($$1)) + 28|0);
 HEAP32[$266>>2] = $$0429;
 $267 = ((($$1)) + 16|0);
 $268 = ((($$1)) + 20|0);
 HEAP32[$268>>2] = 0;
 HEAP32[$267>>2] = 0;
 $269 = HEAP32[(40796)>>2]|0;
 $270 = 1 << $$0429;
 $271 = $269 & $270;
 $272 = ($271|0)==(0);
 if ($272) {
  $273 = $269 | $270;
  HEAP32[(40796)>>2] = $273;
  HEAP32[$265>>2] = $$1;
  $274 = ((($$1)) + 24|0);
  HEAP32[$274>>2] = $265;
  $275 = ((($$1)) + 12|0);
  HEAP32[$275>>2] = $$1;
  $276 = ((($$1)) + 8|0);
  HEAP32[$276>>2] = $$1;
  return;
 }
 $277 = HEAP32[$265>>2]|0;
 $278 = ((($277)) + 4|0);
 $279 = HEAP32[$278>>2]|0;
 $280 = $279 & -8;
 $281 = ($280|0)==($$2|0);
 L189: do {
  if ($281) {
   $$0418$lcssa = $277;
  } else {
   $282 = ($$0429|0)==(31);
   $283 = $$0429 >>> 1;
   $284 = (25 - ($283))|0;
   $285 = $282 ? 0 : $284;
   $286 = $$2 << $285;
   $$041722 = $286;$$041821 = $277;
   while(1) {
    $293 = $$041722 >>> 31;
    $294 = (((($$041821)) + 16|0) + ($293<<2)|0);
    $289 = HEAP32[$294>>2]|0;
    $295 = ($289|0)==(0|0);
    if ($295) {
     break;
    }
    $287 = $$041722 << 1;
    $288 = ((($289)) + 4|0);
    $290 = HEAP32[$288>>2]|0;
    $291 = $290 & -8;
    $292 = ($291|0)==($$2|0);
    if ($292) {
     $$0418$lcssa = $289;
     break L189;
    } else {
     $$041722 = $287;$$041821 = $289;
    }
   }
   $296 = HEAP32[(40808)>>2]|0;
   $297 = ($296>>>0)>($294>>>0);
   if ($297) {
    _abort();
    // unreachable;
   }
   HEAP32[$294>>2] = $$1;
   $298 = ((($$1)) + 24|0);
   HEAP32[$298>>2] = $$041821;
   $299 = ((($$1)) + 12|0);
   HEAP32[$299>>2] = $$1;
   $300 = ((($$1)) + 8|0);
   HEAP32[$300>>2] = $$1;
   return;
  }
 } while(0);
 $301 = ((($$0418$lcssa)) + 8|0);
 $302 = HEAP32[$301>>2]|0;
 $303 = HEAP32[(40808)>>2]|0;
 $304 = ($303>>>0)<=($$0418$lcssa>>>0);
 $305 = ($303>>>0)<=($302>>>0);
 $306 = $305 & $304;
 if (!($306)) {
  _abort();
  // unreachable;
 }
 $307 = ((($302)) + 12|0);
 HEAP32[$307>>2] = $$1;
 HEAP32[$301>>2] = $$1;
 $308 = ((($$1)) + 8|0);
 HEAP32[$308>>2] = $302;
 $309 = ((($$1)) + 12|0);
 HEAP32[$309>>2] = $$0418$lcssa;
 $310 = ((($$1)) + 24|0);
 HEAP32[$310>>2] = 0;
 return;
}
function _memalign($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0>>>0)<(9);
 if ($2) {
  $3 = (_malloc($1)|0);
  $$0 = $3;
  return ($$0|0);
 } else {
  $4 = (_internal_memalign($0,$1)|0);
  $$0 = $4;
  return ($$0|0);
 }
 return (0)|0;
}
function _internal_memalign($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0100 = 0, $$099 = 0, $$1 = 0, $$198 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($0>>>0)>(16);
 $spec$select = $2 ? $0 : 16;
 $3 = (($spec$select) + -1)|0;
 $4 = $3 & $spec$select;
 $5 = ($4|0)==(0);
 if ($5) {
  $$1 = $spec$select;
 } else {
  $$099 = 16;
  while(1) {
   $6 = ($$099>>>0)<($spec$select>>>0);
   $7 = $$099 << 1;
   if ($6) {
    $$099 = $7;
   } else {
    $$1 = $$099;
    break;
   }
  }
 }
 $8 = (-64 - ($$1))|0;
 $9 = ($8>>>0)>($1>>>0);
 if (!($9)) {
  $10 = (___errno_location()|0);
  HEAP32[$10>>2] = 12;
  $$198 = 0;
  return ($$198|0);
 }
 $11 = ($1>>>0)<(11);
 $12 = (($1) + 11)|0;
 $13 = $12 & -8;
 $14 = $11 ? 16 : $13;
 $15 = (($14) + 12)|0;
 $16 = (($15) + ($$1))|0;
 $17 = (_malloc($16)|0);
 $18 = ($17|0)==(0|0);
 if ($18) {
  $$198 = 0;
  return ($$198|0);
 }
 $19 = ((($17)) + -8|0);
 $20 = $17;
 $21 = (($$1) + -1)|0;
 $22 = $21 & $20;
 $23 = ($22|0)==(0);
 do {
  if ($23) {
   $$0100 = $19;$72 = $19;
  } else {
   $24 = (($17) + ($$1)|0);
   $25 = ((($24)) + -1|0);
   $26 = $25;
   $27 = (0 - ($$1))|0;
   $28 = $26 & $27;
   $29 = $28;
   $30 = ((($29)) + -8|0);
   $31 = $30;
   $32 = $19;
   $33 = (($31) - ($32))|0;
   $34 = ($33>>>0)>(15);
   $35 = (($30) + ($$1)|0);
   $36 = $34 ? $30 : $35;
   $37 = $36;
   $38 = (($37) - ($32))|0;
   $39 = ((($17)) + -4|0);
   $40 = HEAP32[$39>>2]|0;
   $41 = $40 & -8;
   $42 = (($41) - ($38))|0;
   $43 = $40 & 3;
   $44 = ($43|0)==(0);
   if ($44) {
    $45 = HEAP32[$19>>2]|0;
    $46 = (($45) + ($38))|0;
    HEAP32[$36>>2] = $46;
    $47 = ((($36)) + 4|0);
    HEAP32[$47>>2] = $42;
    $$0100 = $36;$72 = $36;
    break;
   } else {
    $48 = ((($36)) + 4|0);
    $49 = HEAP32[$48>>2]|0;
    $50 = $49 & 1;
    $51 = $42 | $50;
    $52 = $51 | 2;
    HEAP32[$48>>2] = $52;
    $53 = (($36) + ($42)|0);
    $54 = ((($53)) + 4|0);
    $55 = HEAP32[$54>>2]|0;
    $56 = $55 | 1;
    HEAP32[$54>>2] = $56;
    $57 = HEAP32[$39>>2]|0;
    $58 = $57 & 1;
    $59 = $38 | $58;
    $60 = $59 | 2;
    HEAP32[$39>>2] = $60;
    $61 = HEAP32[$48>>2]|0;
    $62 = $61 | 1;
    HEAP32[$48>>2] = $62;
    _dispose_chunk($19,$38);
    $$0100 = $36;$72 = $36;
    break;
   }
  }
 } while(0);
 $63 = ((($$0100)) + 4|0);
 $64 = HEAP32[$63>>2]|0;
 $65 = $64 & 3;
 $66 = ($65|0)==(0);
 if (!($66)) {
  $67 = $64 & -8;
  $68 = (($14) + 16)|0;
  $69 = ($67>>>0)>($68>>>0);
  if ($69) {
   $70 = (($67) - ($14))|0;
   $71 = (($72) + ($14)|0);
   $73 = $64 & 1;
   $74 = $14 | $73;
   $75 = $74 | 2;
   HEAP32[$63>>2] = $75;
   $76 = ((($71)) + 4|0);
   $77 = $70 | 3;
   HEAP32[$76>>2] = $77;
   $78 = (($72) + ($67)|0);
   $79 = ((($78)) + 4|0);
   $80 = HEAP32[$79>>2]|0;
   $81 = $80 | 1;
   HEAP32[$79>>2] = $81;
   _dispose_chunk($71,$70);
  }
 }
 $82 = ((($72)) + 8|0);
 $$198 = $82;
 return ($$198|0);
}
function ___stdio_close($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $1 = ((($0)) + 60|0);
 $2 = HEAP32[$1>>2]|0;
 $3 = (_dummy_734($2)|0);
 HEAP32[$vararg_buffer>>2] = $3;
 $4 = (___syscall6(6,($vararg_buffer|0))|0);
 $5 = (___syscall_ret($4)|0);
 STACKTOP = sp;return ($5|0);
}
function ___stdio_write($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $$04756 = 0, $$04855 = 0, $$04954 = 0, $$051 = 0, $$1 = 0, $$150 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0;
 var $vararg_ptr6 = 0, $vararg_ptr7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $3 = sp + 32|0;
 $4 = ((($0)) + 28|0);
 $5 = HEAP32[$4>>2]|0;
 HEAP32[$3>>2] = $5;
 $6 = ((($3)) + 4|0);
 $7 = ((($0)) + 20|0);
 $8 = HEAP32[$7>>2]|0;
 $9 = (($8) - ($5))|0;
 HEAP32[$6>>2] = $9;
 $10 = ((($3)) + 8|0);
 HEAP32[$10>>2] = $1;
 $11 = ((($3)) + 12|0);
 HEAP32[$11>>2] = $2;
 $12 = (($9) + ($2))|0;
 $13 = ((($0)) + 60|0);
 $14 = HEAP32[$13>>2]|0;
 $15 = $3;
 HEAP32[$vararg_buffer>>2] = $14;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $15;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = 2;
 $16 = (___syscall146(146,($vararg_buffer|0))|0);
 $17 = (___syscall_ret($16)|0);
 $18 = ($12|0)==($17|0);
 L1: do {
  if ($18) {
   label = 3;
  } else {
   $$04756 = 2;$$04855 = $12;$$04954 = $3;$27 = $17;
   while(1) {
    $26 = ($27|0)<(0);
    if ($26) {
     break;
    }
    $35 = (($$04855) - ($27))|0;
    $36 = ((($$04954)) + 4|0);
    $37 = HEAP32[$36>>2]|0;
    $38 = ($27>>>0)>($37>>>0);
    $39 = ((($$04954)) + 8|0);
    $$150 = $38 ? $39 : $$04954;
    $40 = $38 << 31 >> 31;
    $$1 = (($$04756) + ($40))|0;
    $41 = $38 ? $37 : 0;
    $$0 = (($27) - ($41))|0;
    $42 = HEAP32[$$150>>2]|0;
    $43 = (($42) + ($$0)|0);
    HEAP32[$$150>>2] = $43;
    $44 = ((($$150)) + 4|0);
    $45 = HEAP32[$44>>2]|0;
    $46 = (($45) - ($$0))|0;
    HEAP32[$44>>2] = $46;
    $47 = HEAP32[$13>>2]|0;
    $48 = $$150;
    HEAP32[$vararg_buffer3>>2] = $47;
    $vararg_ptr6 = ((($vararg_buffer3)) + 4|0);
    HEAP32[$vararg_ptr6>>2] = $48;
    $vararg_ptr7 = ((($vararg_buffer3)) + 8|0);
    HEAP32[$vararg_ptr7>>2] = $$1;
    $49 = (___syscall146(146,($vararg_buffer3|0))|0);
    $50 = (___syscall_ret($49)|0);
    $51 = ($35|0)==($50|0);
    if ($51) {
     label = 3;
     break L1;
    } else {
     $$04756 = $$1;$$04855 = $35;$$04954 = $$150;$27 = $50;
    }
   }
   $28 = ((($0)) + 16|0);
   HEAP32[$28>>2] = 0;
   HEAP32[$4>>2] = 0;
   HEAP32[$7>>2] = 0;
   $29 = HEAP32[$0>>2]|0;
   $30 = $29 | 32;
   HEAP32[$0>>2] = $30;
   $31 = ($$04756|0)==(2);
   if ($31) {
    $$051 = 0;
   } else {
    $32 = ((($$04954)) + 4|0);
    $33 = HEAP32[$32>>2]|0;
    $34 = (($2) - ($33))|0;
    $$051 = $34;
   }
  }
 } while(0);
 if ((label|0) == 3) {
  $19 = ((($0)) + 44|0);
  $20 = HEAP32[$19>>2]|0;
  $21 = ((($0)) + 48|0);
  $22 = HEAP32[$21>>2]|0;
  $23 = (($20) + ($22)|0);
  $24 = ((($0)) + 16|0);
  HEAP32[$24>>2] = $23;
  $25 = $20;
  HEAP32[$4>>2] = $25;
  HEAP32[$7>>2] = $25;
  $$051 = $2;
 }
 STACKTOP = sp;return ($$051|0);
}
function ___stdio_seek($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$pre = 0, $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 20|0;
 $4 = ((($0)) + 60|0);
 $5 = HEAP32[$4>>2]|0;
 $6 = $3;
 HEAP32[$vararg_buffer>>2] = $5;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = 0;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $1;
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0);
 HEAP32[$vararg_ptr3>>2] = $6;
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0);
 HEAP32[$vararg_ptr4>>2] = $2;
 $7 = (___syscall140(140,($vararg_buffer|0))|0);
 $8 = (___syscall_ret($7)|0);
 $9 = ($8|0)<(0);
 if ($9) {
  HEAP32[$3>>2] = -1;
  $10 = -1;
 } else {
  $$pre = HEAP32[$3>>2]|0;
  $10 = $$pre;
 }
 STACKTOP = sp;return ($10|0);
}
function ___syscall_ret($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0>>>0)>(4294963200);
 if ($1) {
  $2 = (0 - ($0))|0;
  $3 = (___errno_location()|0);
  HEAP32[$3>>2] = $2;
  $$0 = -1;
 } else {
  $$0 = $0;
 }
 return ($$0|0);
}
function ___errno_location() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (41352|0);
}
function _dummy_734($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return ($0|0);
}
function ___stdout_write($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 16|0;
 $4 = ((($0)) + 36|0);
 HEAP32[$4>>2] = 111;
 $5 = HEAP32[$0>>2]|0;
 $6 = $5 & 64;
 $7 = ($6|0)==(0);
 if ($7) {
  $8 = ((($0)) + 60|0);
  $9 = HEAP32[$8>>2]|0;
  $10 = $3;
  HEAP32[$vararg_buffer>>2] = $9;
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
  HEAP32[$vararg_ptr1>>2] = 21523;
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
  HEAP32[$vararg_ptr2>>2] = $10;
  $11 = (___syscall54(54,($vararg_buffer|0))|0);
  $12 = ($11|0)==(0);
  if (!($12)) {
   $13 = ((($0)) + 75|0);
   HEAP8[$13>>0] = -1;
  }
 }
 $14 = (___stdio_write($0,$1,$2)|0);
 STACKTOP = sp;return ($14|0);
}
function _tolower($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_isupper($0)|0);
 $2 = ($1|0)==(0);
 $3 = $0 | 32;
 $$0 = $2 ? $0 : $3;
 return ($$0|0);
}
function _isupper($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (($0) + -65)|0;
 $2 = ($1>>>0)<(26);
 $3 = $2&1;
 return ($3|0);
}
function _toupper($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_islower($0)|0);
 $2 = ($1|0)==(0);
 $3 = $0 & 95;
 $$0 = $2 ? $0 : $3;
 return ($$0|0);
}
function _islower($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (($0) + -97)|0;
 $2 = ($1>>>0)<(26);
 $3 = $2&1;
 return ($3|0);
}
function _cosh($0) {
 $0 = +$0;
 var $$0 = 0.0, $1 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $2 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = $2 & 2147483647;
 HEAP32[tempDoublePtr>>2] = $1;HEAP32[tempDoublePtr+4>>2] = $3;$4 = +HEAPF64[tempDoublePtr>>3];
 $5 = ($3>>>0)<(1072049730);
 do {
  if ($5) {
   $6 = ($3>>>0)<(1045430272);
   if ($6) {
    $$0 = 1.0;
   } else {
    $7 = (+_expm1($4));
    $8 = $7 * $7;
    $9 = $7 + 1.0;
    $10 = $9 * 2.0;
    $11 = $8 / $10;
    $12 = $11 + 1.0;
    $$0 = $12;
   }
  } else {
   $13 = ($3>>>0)<(1082535490);
   if ($13) {
    $14 = (+Math_exp((+$4)));
    $15 = 1.0 / $14;
    $16 = $14 + $15;
    $17 = $16 * 0.5;
    $$0 = $17;
    break;
   } else {
    $18 = (+___expo2($4));
    $$0 = $18;
    break;
   }
  }
 } while(0);
 return (+$$0);
}
function _sinh($0) {
 $0 = +$0;
 var $$0 = 0.0, $1 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0.0, $21 = 0.0, $22 = 0.0, $3 = 0, $4 = 0, $5 = 0.0, $6 = 0;
 var $7 = 0.0, $8 = 0, $9 = 0, $spec$select = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = ($2|0)<(0);
 $spec$select = $3 ? -0.5 : 0.5;
 $4 = $2 & 2147483647;
 HEAP32[tempDoublePtr>>2] = $1;HEAP32[tempDoublePtr+4>>2] = $4;$5 = +HEAPF64[tempDoublePtr>>3];
 $6 = ($4>>>0)<(1082535490);
 do {
  if ($6) {
   $7 = (+_expm1($5));
   $8 = ($4>>>0)<(1072693248);
   if (!($8)) {
    $16 = $7 + 1.0;
    $17 = $7 / $16;
    $18 = $7 + $17;
    $19 = $spec$select * $18;
    $$0 = $19;
    break;
   }
   $9 = ($4>>>0)<(1045430272);
   if ($9) {
    $$0 = $0;
   } else {
    $10 = $7 * 2.0;
    $11 = $7 * $7;
    $12 = $7 + 1.0;
    $13 = $11 / $12;
    $14 = $10 - $13;
    $15 = $spec$select * $14;
    $$0 = $15;
   }
  } else {
   $20 = $spec$select * 2.0;
   $21 = (+___expo2($5));
   $22 = $20 * $21;
   $$0 = $22;
  }
 } while(0);
 return (+$$0);
}
function _expm1($0) {
 $0 = +$0;
 var $$0 = 0.0, $$0105 = 0, $$0106 = 0.0, $$0107 = 0.0, $$0109 = 0.0, $$0110 = 0.0, $$0111 = 0.0, $$1 = 0, $$1108 = 0.0, $$sink = 0.0, $$sink113 = 0.0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0;
 var $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0, $25 = 0.0, $26 = 0.0, $27 = 0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0;
 var $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0.0, $41 = 0.0, $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0.0, $5 = 0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0;
 var $54 = 0.0, $55 = 0, $56 = 0.0, $57 = 0.0, $58 = 0.0, $59 = 0.0, $6 = 0, $60 = 0.0, $61 = 0.0, $62 = 0.0, $63 = 0.0, $64 = 0.0, $65 = 0.0, $66 = 0, $67 = 0.0, $68 = 0.0, $69 = 0.0, $7 = 0, $70 = 0.0, $71 = 0.0;
 var $72 = 0.0, $73 = 0, $74 = 0, $75 = 0, $76 = 0.0, $77 = 0, $78 = 0.0, $79 = 0.0, $8 = 0, $80 = 0, $81 = 0.0, $82 = 0.0, $83 = 0.0, $84 = 0.0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0.0, $9 = 0;
 var $90 = 0.0, $91 = 0.0, $92 = 0.0, $93 = 0.0, $94 = 0.0, $95 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = $2 & 2147483647;
 $4 = (_bitshift64Lshr(($1|0),($2|0),63)|0);
 $5 = tempRet0;
 $6 = ($3>>>0)>(1078159481);
 do {
  if ($6) {
   $7 = (___DOUBLE_BITS_261($0)|0);
   $8 = tempRet0;
   $9 = $8 & 2147483647;
   $10 = ($9>>>0)>(2146435072);
   $11 = ($7>>>0)>(0);
   $12 = ($9|0)==(2146435072);
   $13 = $12 & $11;
   $14 = $10 | $13;
   if ($14) {
    $$0 = $0;
   } else {
    $15 = ($4|0)==(0);
    if ($15) {
     $16 = $0 > 709.78271289338397;
     if ($16) {
      $17 = $0 * 8.9884656743115795E+307;
      $$0 = $17;
     } else {
      label = 11;
     }
    } else {
     $$0 = -1.0;
    }
   }
  } else {
   $18 = ($3>>>0)>(1071001154);
   if (!($18)) {
    $35 = ($3>>>0)<(1016070144);
    if ($35) {
     $$0 = $0;
     break;
    } else {
     $$0106 = $0;$$0111 = 0.0;$$1 = 0;
     label = 14;
     break;
    }
   }
   $19 = ($3>>>0)<(1072734898);
   if ($19) {
    $20 = ($4|0)==(0);
    if ($20) {
     $21 = $0 + -0.69314718036912382;
     $$0105 = 1;$$0109 = $21;$$0110 = 1.9082149292705877E-10;
     label = 12;
     break;
    } else {
     $22 = $0 + 0.69314718036912382;
     $$0105 = -1;$$0109 = $22;$$0110 = -1.9082149292705877E-10;
     label = 12;
     break;
    }
   } else {
    label = 11;
   }
  }
 } while(0);
 if ((label|0) == 11) {
  $23 = $0 * 1.4426950408889634;
  $24 = ($4|0)==(0);
  $25 = $24 ? 0.5 : -0.5;
  $26 = $23 + $25;
  $27 = (~~(($26)));
  $28 = (+($27|0));
  $29 = $28 * 0.69314718036912382;
  $30 = $0 - $29;
  $31 = $28 * 1.9082149292705877E-10;
  $$0105 = $27;$$0109 = $30;$$0110 = $31;
  label = 12;
 }
 if ((label|0) == 12) {
  $32 = $$0109 - $$0110;
  $33 = $$0109 - $32;
  $34 = $33 - $$0110;
  $$0106 = $32;$$0111 = $34;$$1 = $$0105;
  label = 14;
 }
 L18: do {
  if ((label|0) == 14) {
   $36 = $$0106 * 0.5;
   $37 = $$0106 * $36;
   $38 = $37 * 2.0109921818362437E-7;
   $39 = 4.0082178273293624E-6 - $38;
   $40 = $37 * $39;
   $41 = $40 + -7.9365075786748794E-5;
   $42 = $37 * $41;
   $43 = $42 + 0.0015873015872548146;
   $44 = $37 * $43;
   $45 = $44 + -0.033333333333333132;
   $46 = $37 * $45;
   $47 = $46 + 1.0;
   $48 = $36 * $47;
   $49 = 3.0 - $48;
   $50 = $47 - $49;
   $51 = $$0106 * $49;
   $52 = 6.0 - $51;
   $53 = $50 / $52;
   $54 = $37 * $53;
   $55 = ($$1|0)==(0);
   if ($55) {
    $56 = $$0106 * $54;
    $57 = $56 - $37;
    $58 = $$0106 - $57;
    $$0 = $58;
    break;
   }
   $59 = $54 - $$0111;
   $60 = $$0106 * $59;
   $61 = $60 - $$0111;
   $62 = $61 - $37;
   switch ($$1|0) {
   case -1:  {
    $63 = $$0106 - $62;
    $64 = $63 * 0.5;
    $65 = $64 + -0.5;
    $$0 = $65;
    break L18;
    break;
   }
   case 1:  {
    $66 = $$0106 < -0.25;
    if ($66) {
     $67 = $$0106 + 0.5;
     $68 = $62 - $67;
     $69 = $68 * -2.0;
     $$0 = $69;
     break L18;
    } else {
     $70 = $$0106 - $62;
     $71 = $70 * 2.0;
     $72 = $71 + 1.0;
     $$0 = $72;
     break L18;
    }
    break;
   }
   default: {
    $73 = (($$1) + 1023)|0;
    $74 = (_bitshift64Shl(($73|0),0,52)|0);
    $75 = tempRet0;
    HEAP32[tempDoublePtr>>2] = $74;HEAP32[tempDoublePtr+4>>2] = $75;$76 = +HEAPF64[tempDoublePtr>>3];
    $77 = ($$1>>>0)>(56);
    if ($77) {
     $78 = $$0106 - $62;
     $79 = $78 + 1.0;
     $80 = ($$1|0)==(1024);
     $81 = $79 * 2.0;
     $82 = $81 * 8.9884656743115795E+307;
     $83 = $79 * $76;
     $$0107 = $80 ? $82 : $83;
     $84 = $$0107 + -1.0;
     $$0 = $84;
     break L18;
    }
    $85 = (1023 - ($$1))|0;
    $86 = (_bitshift64Shl(($85|0),0,52)|0);
    $87 = tempRet0;
    $88 = ($$1|0)<(20);
    if ($88) {
     $89 = $$0106 - $62;
     HEAP32[tempDoublePtr>>2] = $86;HEAP32[tempDoublePtr+4>>2] = $87;$90 = +HEAPF64[tempDoublePtr>>3];
     $91 = 1.0 - $90;
     $$sink = $91;$$sink113 = $89;
    } else {
     HEAP32[tempDoublePtr>>2] = $86;HEAP32[tempDoublePtr+4>>2] = $87;$92 = +HEAPF64[tempDoublePtr>>3];
     $93 = $62 + $92;
     $94 = $$0106 - $93;
     $$sink = $94;$$sink113 = 1.0;
    }
    $95 = $$sink + $$sink113;
    $$1108 = $95 * $76;
    $$0 = $$1108;
    break L18;
   }
   }
  }
 } while(0);
 return (+$$0);
}
function ___expo2($0) {
 $0 = +$0;
 var $1 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0 + -1416.0996898839683;
 $2 = (+Math_exp((+$1)));
 $3 = $2 * 2.2471164185778949E+307;
 $4 = $3 * 2.2471164185778949E+307;
 return (+$4);
}
function ___DOUBLE_BITS_261($0) {
 $0 = +$0;
 var $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 tempRet0 = ($2);
 return ($1|0);
}
function _strcmp($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$011 = 0, $$0710 = 0, $$lcssa = 0, $$lcssa8 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond9 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $2 = HEAP8[$0>>0]|0;
 $3 = HEAP8[$1>>0]|0;
 $4 = ($2<<24>>24)!=($3<<24>>24);
 $5 = ($2<<24>>24)==(0);
 $or$cond9 = $5 | $4;
 if ($or$cond9) {
  $$lcssa = $3;$$lcssa8 = $2;
 } else {
  $$011 = $1;$$0710 = $0;
  while(1) {
   $6 = ((($$0710)) + 1|0);
   $7 = ((($$011)) + 1|0);
   $8 = HEAP8[$6>>0]|0;
   $9 = HEAP8[$7>>0]|0;
   $10 = ($8<<24>>24)!=($9<<24>>24);
   $11 = ($8<<24>>24)==(0);
   $or$cond = $11 | $10;
   if ($or$cond) {
    $$lcssa = $9;$$lcssa8 = $8;
    break;
   } else {
    $$011 = $7;$$0710 = $6;
   }
  }
 }
 $12 = $$lcssa8&255;
 $13 = $$lcssa&255;
 $14 = (($12) - ($13))|0;
 return ($14|0);
}
function _memcmp($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$01318 = 0, $$01417 = 0, $$019 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)==(0);
 L1: do {
  if ($3) {
   $14 = 0;
  } else {
   $$01318 = $0;$$01417 = $2;$$019 = $1;
   while(1) {
    $4 = HEAP8[$$01318>>0]|0;
    $5 = HEAP8[$$019>>0]|0;
    $6 = ($4<<24>>24)==($5<<24>>24);
    if (!($6)) {
     break;
    }
    $7 = (($$01417) + -1)|0;
    $8 = ((($$01318)) + 1|0);
    $9 = ((($$019)) + 1|0);
    $10 = ($7|0)==(0);
    if ($10) {
     $14 = 0;
     break L1;
    } else {
     $$01318 = $8;$$01417 = $7;$$019 = $9;
    }
   }
   $11 = $4&255;
   $12 = $5&255;
   $13 = (($11) - ($12))|0;
   $14 = $13;
  }
 } while(0);
 return ($14|0);
}
function _strncmp($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$01823 = 0, $$01925 = 0, $$01925$in = 0, $$020 = 0, $$024 = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0;
 var $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond21 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = ($2|0)==(0);
 if ($3) {
  $$020 = 0;
 } else {
  $4 = HEAP8[$0>>0]|0;
  $5 = ($4<<24>>24)==(0);
  L3: do {
   if ($5) {
    $$0$lcssa = $1;$$lcssa = 0;
   } else {
    $$01823 = $0;$$01925$in = $2;$$024 = $1;$10 = $4;
    while(1) {
     $$01925 = (($$01925$in) + -1)|0;
     $6 = HEAP8[$$024>>0]|0;
     $7 = ($6<<24>>24)!=(0);
     $8 = ($$01925|0)!=(0);
     $or$cond = $8 & $7;
     $9 = ($10<<24>>24)==($6<<24>>24);
     $or$cond21 = $9 & $or$cond;
     if (!($or$cond21)) {
      $$0$lcssa = $$024;$$lcssa = $10;
      break L3;
     }
     $11 = ((($$01823)) + 1|0);
     $12 = ((($$024)) + 1|0);
     $13 = HEAP8[$11>>0]|0;
     $14 = ($13<<24>>24)==(0);
     if ($14) {
      $$0$lcssa = $12;$$lcssa = 0;
      break;
     } else {
      $$01823 = $11;$$01925$in = $$01925;$$024 = $12;$10 = $13;
     }
    }
   }
  } while(0);
  $15 = $$lcssa&255;
  $16 = HEAP8[$$0$lcssa>>0]|0;
  $17 = $16&255;
  $18 = (($15) - ($17))|0;
  $$020 = $18;
 }
 return ($$020|0);
}
function ___lockfile($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0;
}
function ___unlockfile($0) {
 $0 = $0|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return;
}
function _strerror($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (___pthread_self_107()|0);
 $2 = ((($1)) + 188|0);
 $3 = HEAP32[$2>>2]|0;
 $4 = (___strerror_l($0,$3)|0);
 return ($4|0);
}
function _pthread_self() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (7700|0);
}
function ___pthread_self_107() {
 var $0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_pthread_self()|0);
 return ($0|0);
}
function ___strerror_l($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$012$lcssa = 0, $$01214 = 0, $$016 = 0, $$113 = 0, $$115 = 0, $$115$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $$016 = 0;
 while(1) {
  $2 = (38172 + ($$016)|0);
  $3 = HEAP8[$2>>0]|0;
  $4 = $3&255;
  $5 = ($4|0)==($0|0);
  if ($5) {
   label = 4;
   break;
  }
  $6 = (($$016) + 1)|0;
  $7 = ($6|0)==(87);
  if ($7) {
   $$115$ph = 87;
   label = 5;
   break;
  } else {
   $$016 = $6;
  }
 }
 if ((label|0) == 4) {
  $8 = ($$016|0)==(0);
  if ($8) {
   $$012$lcssa = 38260;
  } else {
   $$115$ph = $$016;
   label = 5;
  }
 }
 if ((label|0) == 5) {
  $$01214 = 38260;$$115 = $$115$ph;
  while(1) {
   $$113 = $$01214;
   while(1) {
    $9 = HEAP8[$$113>>0]|0;
    $10 = ($9<<24>>24)==(0);
    $11 = ((($$113)) + 1|0);
    if ($10) {
     break;
    } else {
     $$113 = $11;
    }
   }
   $12 = (($$115) + -1)|0;
   $13 = ($12|0)==(0);
   if ($13) {
    $$012$lcssa = $11;
    break;
   } else {
    $$01214 = $11;$$115 = $12;
   }
  }
 }
 $14 = ((($1)) + 20|0);
 $15 = HEAP32[$14>>2]|0;
 $16 = (___lctrans($$012$lcssa,$15)|0);
 return ($16|0);
}
function ___lctrans($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = (___lctrans_impl($0,$1)|0);
 return ($2|0);
}
function ___lctrans_impl($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0|0);
 if ($2) {
  $$0 = 0;
 } else {
  $3 = HEAP32[$1>>2]|0;
  $4 = ((($1)) + 4|0);
  $5 = HEAP32[$4>>2]|0;
  $6 = (___mo_lookup($3,$5,$0)|0);
  $$0 = $6;
 }
 $7 = ($$0|0)==(0|0);
 $8 = $7 ? $0 : $$0;
 return ($8|0);
}
function ___mo_lookup($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$090 = 0, $$094 = 0, $$191 = 0, $$195 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0;
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond102 = 0, $or$cond104 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $3 = HEAP32[$0>>2]|0;
 $4 = (($3) + 1794895138)|0;
 $5 = ((($0)) + 8|0);
 $6 = HEAP32[$5>>2]|0;
 $7 = (_swapc($6,$4)|0);
 $8 = ((($0)) + 12|0);
 $9 = HEAP32[$8>>2]|0;
 $10 = (_swapc($9,$4)|0);
 $11 = ((($0)) + 16|0);
 $12 = HEAP32[$11>>2]|0;
 $13 = (_swapc($12,$4)|0);
 $14 = $1 >>> 2;
 $15 = ($7>>>0)<($14>>>0);
 L1: do {
  if ($15) {
   $16 = $7 << 2;
   $17 = (($1) - ($16))|0;
   $18 = ($10>>>0)<($17>>>0);
   $19 = ($13>>>0)<($17>>>0);
   $or$cond = $18 & $19;
   if ($or$cond) {
    $20 = $13 | $10;
    $21 = $20 & 3;
    $22 = ($21|0)==(0);
    if ($22) {
     $23 = $10 >>> 2;
     $24 = $13 >>> 2;
     $$090 = 0;$$094 = $7;
     while(1) {
      $25 = $$094 >>> 1;
      $26 = (($$090) + ($25))|0;
      $27 = $26 << 1;
      $28 = (($27) + ($23))|0;
      $29 = (($0) + ($28<<2)|0);
      $30 = HEAP32[$29>>2]|0;
      $31 = (_swapc($30,$4)|0);
      $32 = (($28) + 1)|0;
      $33 = (($0) + ($32<<2)|0);
      $34 = HEAP32[$33>>2]|0;
      $35 = (_swapc($34,$4)|0);
      $36 = ($35>>>0)<($1>>>0);
      $37 = (($1) - ($35))|0;
      $38 = ($31>>>0)<($37>>>0);
      $or$cond102 = $36 & $38;
      if (!($or$cond102)) {
       $$4 = 0;
       break L1;
      }
      $39 = (($35) + ($31))|0;
      $40 = (($0) + ($39)|0);
      $41 = HEAP8[$40>>0]|0;
      $42 = ($41<<24>>24)==(0);
      if (!($42)) {
       $$4 = 0;
       break L1;
      }
      $43 = (($0) + ($35)|0);
      $44 = (_strcmp($2,$43)|0);
      $45 = ($44|0)==(0);
      if ($45) {
       break;
      }
      $62 = ($$094|0)==(1);
      $63 = ($44|0)<(0);
      if ($62) {
       $$4 = 0;
       break L1;
      }
      $$191 = $63 ? $$090 : $26;
      $64 = (($$094) - ($25))|0;
      $$195 = $63 ? $25 : $64;
      $$090 = $$191;$$094 = $$195;
     }
     $46 = (($27) + ($24))|0;
     $47 = (($0) + ($46<<2)|0);
     $48 = HEAP32[$47>>2]|0;
     $49 = (_swapc($48,$4)|0);
     $50 = (($46) + 1)|0;
     $51 = (($0) + ($50<<2)|0);
     $52 = HEAP32[$51>>2]|0;
     $53 = (_swapc($52,$4)|0);
     $54 = ($53>>>0)<($1>>>0);
     $55 = (($1) - ($53))|0;
     $56 = ($49>>>0)<($55>>>0);
     $or$cond104 = $54 & $56;
     if ($or$cond104) {
      $57 = (($0) + ($53)|0);
      $58 = (($53) + ($49))|0;
      $59 = (($0) + ($58)|0);
      $60 = HEAP8[$59>>0]|0;
      $61 = ($60<<24>>24)==(0);
      $spec$select = $61 ? $57 : 0;
      $$4 = $spec$select;
     } else {
      $$4 = 0;
     }
    } else {
     $$4 = 0;
    }
   } else {
    $$4 = 0;
   }
  } else {
   $$4 = 0;
  }
 } while(0);
 return ($$4|0);
}
function _swapc($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $spec$select = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1|0)==(0);
 $3 = (_llvm_bswap_i32(($0|0))|0);
 $spec$select = $2 ? $0 : $3;
 return ($spec$select|0);
}
function _isalpha($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0 | 32;
 $2 = (($1) + -97)|0;
 $3 = ($2>>>0)<(26);
 $4 = $3&1;
 return ($4|0);
}
function _isblank($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(32);
 $2 = ($0|0)==(9);
 $3 = $1 | $2;
 $4 = $3&1;
 return ($4|0);
}
function _close($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $spec$store$select = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $1 = (_dummy_734($0)|0);
 HEAP32[$vararg_buffer>>2] = $1;
 $2 = (___syscall6(6,($vararg_buffer|0))|0);
 $3 = ($2|0)==(-4);
 $spec$store$select = $3 ? 0 : $2;
 $4 = (___syscall_ret($spec$store$select)|0);
 STACKTOP = sp;return ($4|0);
}
function _fstat($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer6 = 0, $vararg_ptr1 = 0, $vararg_ptr5 = 0, $vararg_ptr9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer6 = sp + 40|0;
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 $2 = $1;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $2;
 $3 = (___syscall197(197,($vararg_buffer|0))|0);
 $4 = ($3|0)==(-9);
 if ($4) {
  HEAP32[$vararg_buffer2>>2] = $0;
  $vararg_ptr5 = ((($vararg_buffer2)) + 4|0);
  HEAP32[$vararg_ptr5>>2] = 1;
  $5 = (___syscall221(221,($vararg_buffer2|0))|0);
  $6 = ($5|0)<(0);
  if ($6) {
   label = 3;
  } else {
   ___procfdname($vararg_buffer2,$0);
   $8 = $vararg_buffer2;
   HEAP32[$vararg_buffer6>>2] = $8;
   $vararg_ptr9 = ((($vararg_buffer6)) + 4|0);
   HEAP32[$vararg_ptr9>>2] = $2;
   $9 = (___syscall195(195,($vararg_buffer6|0))|0);
   $10 = (___syscall_ret($9)|0);
   $$0 = $10;
  }
 } else {
  label = 3;
 }
 if ((label|0) == 3) {
  $7 = (___syscall_ret($3)|0);
  $$0 = $7;
 }
 STACKTOP = sp;return ($$0|0);
}
function _fcntl($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $$0 = 0, $$2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0;
 var $arglist_current = 0, $arglist_next = 0, $expanded = 0, $expanded2 = 0, $expanded4 = 0, $expanded5 = 0, $expanded6 = 0, $spec$select = 0, $vararg_buffer = 0, $vararg_buffer13 = 0, $vararg_buffer18 = 0, $vararg_buffer23 = 0, $vararg_buffer28 = 0, $vararg_buffer3 = 0, $vararg_buffer31 = 0, $vararg_buffer36 = 0, $vararg_buffer41 = 0, $vararg_buffer46 = 0, $vararg_buffer8 = 0, $vararg_ptr1 = 0;
 var $vararg_ptr11 = 0, $vararg_ptr12 = 0, $vararg_ptr16 = 0, $vararg_ptr17 = 0, $vararg_ptr2 = 0, $vararg_ptr21 = 0, $vararg_ptr22 = 0, $vararg_ptr26 = 0, $vararg_ptr27 = 0, $vararg_ptr34 = 0, $vararg_ptr35 = 0, $vararg_ptr39 = 0, $vararg_ptr40 = 0, $vararg_ptr44 = 0, $vararg_ptr45 = 0, $vararg_ptr49 = 0, $vararg_ptr50 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 192|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(192|0);
 $vararg_buffer46 = sp + 152|0;
 $vararg_buffer41 = sp + 136|0;
 $vararg_buffer36 = sp + 120|0;
 $vararg_buffer31 = sp + 104|0;
 $vararg_buffer28 = sp + 96|0;
 $vararg_buffer23 = sp + 80|0;
 $vararg_buffer18 = sp + 64|0;
 $vararg_buffer13 = sp + 48|0;
 $vararg_buffer8 = sp + 32|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $2 = sp + 176|0;
 $3 = sp + 168|0;
 HEAP32[$2>>2] = $varargs;
 $arglist_current = HEAP32[$2>>2]|0;
 $4 = $arglist_current;
 $5 = ((0) + 4|0);
 $expanded2 = $5;
 $expanded = (($expanded2) - 1)|0;
 $6 = (($4) + ($expanded))|0;
 $7 = ((0) + 4|0);
 $expanded6 = $7;
 $expanded5 = (($expanded6) - 1)|0;
 $expanded4 = $expanded5 ^ -1;
 $8 = $6 & $expanded4;
 $9 = $8;
 $10 = HEAP32[$9>>2]|0;
 $arglist_next = ((($9)) + 4|0);
 HEAP32[$2>>2] = $arglist_next;
 $11 = ($1|0)==(4);
 $12 = $10 | 32768;
 $spec$select = $11 ? $12 : $10;
 L1: do {
  switch ($1|0) {
  case 14:  {
   HEAP32[$vararg_buffer>>2] = $0;
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
   HEAP32[$vararg_ptr1>>2] = 14;
   $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
   HEAP32[$vararg_ptr2>>2] = $spec$select;
   $13 = (___syscall221(221,($vararg_buffer|0))|0);
   $14 = (___syscall_ret($13)|0);
   $$2 = $14;
   break;
  }
  case 9:  {
   $15 = $3;
   HEAP32[$vararg_buffer3>>2] = $0;
   $vararg_ptr6 = ((($vararg_buffer3)) + 4|0);
   HEAP32[$vararg_ptr6>>2] = 16;
   $vararg_ptr7 = ((($vararg_buffer3)) + 8|0);
   HEAP32[$vararg_ptr7>>2] = $15;
   $16 = (___syscall221(221,($vararg_buffer3|0))|0);
   switch ($16|0) {
   case -22:  {
    HEAP32[$vararg_buffer8>>2] = $0;
    $vararg_ptr11 = ((($vararg_buffer8)) + 4|0);
    HEAP32[$vararg_ptr11>>2] = 9;
    $vararg_ptr12 = ((($vararg_buffer8)) + 8|0);
    HEAP32[$vararg_ptr12>>2] = $spec$select;
    $17 = (___syscall221(221,($vararg_buffer8|0))|0);
    $$0 = $17;
    break;
   }
   case 0:  {
    $19 = HEAP32[$3>>2]|0;
    $20 = ($19|0)==(2);
    $21 = ((($3)) + 4|0);
    $22 = HEAP32[$21>>2]|0;
    $23 = (0 - ($22))|0;
    $24 = $20 ? $23 : $22;
    $$0 = $24;
    break;
   }
   default: {
    $18 = (___syscall_ret($16)|0);
    $$0 = $18;
   }
   }
   $$2 = $$0;
   break;
  }
  case 1030:  {
   HEAP32[$vararg_buffer13>>2] = $0;
   $vararg_ptr16 = ((($vararg_buffer13)) + 4|0);
   HEAP32[$vararg_ptr16>>2] = 1030;
   $vararg_ptr17 = ((($vararg_buffer13)) + 8|0);
   HEAP32[$vararg_ptr17>>2] = $spec$select;
   $25 = (___syscall221(221,($vararg_buffer13|0))|0);
   $26 = ($25|0)==(-22);
   if (!($26)) {
    $27 = ($25|0)>(-1);
    if ($27) {
     HEAP32[$vararg_buffer18>>2] = $25;
     $vararg_ptr21 = ((($vararg_buffer18)) + 4|0);
     HEAP32[$vararg_ptr21>>2] = 2;
     $vararg_ptr22 = ((($vararg_buffer18)) + 8|0);
     HEAP32[$vararg_ptr22>>2] = 1;
     (___syscall221(221,($vararg_buffer18|0))|0);
    }
    $28 = (___syscall_ret($25)|0);
    $$2 = $28;
    break L1;
   }
   HEAP32[$vararg_buffer23>>2] = $0;
   $vararg_ptr26 = ((($vararg_buffer23)) + 4|0);
   HEAP32[$vararg_ptr26>>2] = 1030;
   $vararg_ptr27 = ((($vararg_buffer23)) + 8|0);
   HEAP32[$vararg_ptr27>>2] = 0;
   $29 = (___syscall221(221,($vararg_buffer23|0))|0);
   $30 = ($29|0)==(-22);
   if ($30) {
    HEAP32[$vararg_buffer31>>2] = $0;
    $vararg_ptr34 = ((($vararg_buffer31)) + 4|0);
    HEAP32[$vararg_ptr34>>2] = 0;
    $vararg_ptr35 = ((($vararg_buffer31)) + 8|0);
    HEAP32[$vararg_ptr35>>2] = $spec$select;
    $33 = (___syscall221(221,($vararg_buffer31|0))|0);
    $34 = ($33|0)>(-1);
    if ($34) {
     HEAP32[$vararg_buffer36>>2] = $33;
     $vararg_ptr39 = ((($vararg_buffer36)) + 4|0);
     HEAP32[$vararg_ptr39>>2] = 2;
     $vararg_ptr40 = ((($vararg_buffer36)) + 8|0);
     HEAP32[$vararg_ptr40>>2] = 1;
     (___syscall221(221,($vararg_buffer36|0))|0);
    }
    $35 = (___syscall_ret($33)|0);
    $$2 = $35;
    break L1;
   } else {
    $31 = ($29|0)>(-1);
    if ($31) {
     HEAP32[$vararg_buffer28>>2] = $29;
     (___syscall6(6,($vararg_buffer28|0))|0);
    }
    $32 = (___syscall_ret(-22)|0);
    $$2 = $32;
    break L1;
   }
   break;
  }
  case 15: case 16: case 12: case 13:  {
   HEAP32[$vararg_buffer41>>2] = $0;
   $vararg_ptr44 = ((($vararg_buffer41)) + 4|0);
   HEAP32[$vararg_ptr44>>2] = $1;
   $vararg_ptr45 = ((($vararg_buffer41)) + 8|0);
   HEAP32[$vararg_ptr45>>2] = $spec$select;
   $36 = (___syscall221(221,($vararg_buffer41|0))|0);
   $37 = (___syscall_ret($36)|0);
   $$2 = $37;
   break;
  }
  default: {
   HEAP32[$vararg_buffer46>>2] = $0;
   $vararg_ptr49 = ((($vararg_buffer46)) + 4|0);
   HEAP32[$vararg_ptr49>>2] = $1;
   $vararg_ptr50 = ((($vararg_buffer46)) + 8|0);
   HEAP32[$vararg_ptr50>>2] = $spec$select;
   $38 = (___syscall221(221,($vararg_buffer46|0))|0);
   $39 = (___syscall_ret($38)|0);
   $$2 = $39;
  }
  }
 } while(0);
 STACKTOP = sp;return ($$2|0);
}
function ___procfdname($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$02324 = 0, $$027 = 0, $$126 = 0, $$225 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0;
 var label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 dest=$0; src=40064; stop=dest+15|0; do { HEAP8[dest>>0]=HEAP8[src>>0]|0; dest=dest+1|0; src=src+1|0; } while ((dest|0) < (stop|0));
 $2 = ($1|0)==(0);
 if ($2) {
  $3 = ((($0)) + 14|0);
  HEAP8[$3>>0] = 48;
  $4 = ((($0)) + 15|0);
  HEAP8[$4>>0] = 0;
 } else {
  $$027 = $1;$$126 = 14;
  while(1) {
   $5 = (($$027>>>0) / 10)&-1;
   $6 = (($$126) + 1)|0;
   $7 = ($$027>>>0)<(10);
   if ($7) {
    break;
   } else {
    $$027 = $5;$$126 = $6;
   }
  }
  $8 = (($0) + ($6)|0);
  HEAP8[$8>>0] = 0;
  $$02324 = $1;$$225 = $6;
  while(1) {
   $9 = (($$02324>>>0) / 10)&-1;
   $10 = ($9*10)|0;
   $11 = (($$02324) - ($10))|0;
   $12 = $11 | 48;
   $13 = $12&255;
   $14 = (($$225) + -1)|0;
   $15 = (($0) + ($14)|0);
   HEAP8[$15>>0] = $13;
   $16 = ($$02324>>>0)<(10);
   if ($16) {
    break;
   } else {
    $$02324 = $9;$$225 = $14;
   }
  }
 }
 return;
}
function _open($0,$1,$varargs) {
 $0 = $0|0;
 $1 = $1|0;
 $varargs = $varargs|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $arglist_current = 0, $arglist_next = 0;
 var $expanded = 0, $expanded2 = 0, $expanded4 = 0, $expanded5 = 0, $expanded6 = 0, $or$cond14 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $2 = sp + 32|0;
 $3 = $1 & 4194368;
 $4 = ($3|0)==(0);
 if ($4) {
  $$0 = 0;
 } else {
  HEAP32[$2>>2] = $varargs;
  $arglist_current = HEAP32[$2>>2]|0;
  $5 = $arglist_current;
  $6 = ((0) + 4|0);
  $expanded2 = $6;
  $expanded = (($expanded2) - 1)|0;
  $7 = (($5) + ($expanded))|0;
  $8 = ((0) + 4|0);
  $expanded6 = $8;
  $expanded5 = (($expanded6) - 1)|0;
  $expanded4 = $expanded5 ^ -1;
  $9 = $7 & $expanded4;
  $10 = $9;
  $11 = HEAP32[$10>>2]|0;
  $arglist_next = ((($10)) + 4|0);
  HEAP32[$2>>2] = $arglist_next;
  $$0 = $11;
 }
 $12 = $0;
 $13 = $1 | 32768;
 HEAP32[$vararg_buffer>>2] = $12;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $13;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $$0;
 $14 = (___syscall5(5,($vararg_buffer|0))|0);
 $15 = ($14|0)<(0);
 $16 = $1 & 524288;
 $17 = ($16|0)==(0);
 $or$cond14 = $17 | $15;
 if (!($or$cond14)) {
  HEAP32[$vararg_buffer3>>2] = $14;
  $vararg_ptr6 = ((($vararg_buffer3)) + 4|0);
  HEAP32[$vararg_ptr6>>2] = 2;
  $vararg_ptr7 = ((($vararg_buffer3)) + 8|0);
  HEAP32[$vararg_ptr7>>2] = 1;
  (___syscall221(221,($vararg_buffer3|0))|0);
 }
 $18 = (___syscall_ret($14)|0);
 STACKTOP = sp;return ($18|0);
}
function _lseek($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $3 = sp + 20|0;
 $4 = $3;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = 0;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $1;
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0);
 HEAP32[$vararg_ptr3>>2] = $4;
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0);
 HEAP32[$vararg_ptr4>>2] = $2;
 $5 = (___syscall140(140,($vararg_buffer|0))|0);
 $6 = (___syscall_ret($5)|0);
 $7 = ($6|0)==(0);
 $8 = HEAP32[$3>>2]|0;
 $9 = $7 ? $8 : -1;
 STACKTOP = sp;return ($9|0);
}
function _strlen($0) {
 $0 = $0|0;
 var $$0 = 0, $$014 = 0, $$015$lcssa = 0, $$01518 = 0, $$1$lcssa = 0, $$pn = 0, $$pn29 = 0, $$pre = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0;
 var $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = $0;
 $2 = $1 & 3;
 $3 = ($2|0)==(0);
 L1: do {
  if ($3) {
   $$015$lcssa = $0;
   label = 5;
  } else {
   $$01518 = $0;$22 = $1;
   while(1) {
    $4 = HEAP8[$$01518>>0]|0;
    $5 = ($4<<24>>24)==(0);
    if ($5) {
     $$pn = $22;
     break L1;
    }
    $6 = ((($$01518)) + 1|0);
    $7 = $6;
    $8 = $7 & 3;
    $9 = ($8|0)==(0);
    if ($9) {
     $$015$lcssa = $6;
     label = 5;
     break;
    } else {
     $$01518 = $6;$22 = $7;
    }
   }
  }
 } while(0);
 if ((label|0) == 5) {
  $$0 = $$015$lcssa;
  while(1) {
   $10 = HEAP32[$$0>>2]|0;
   $11 = (($10) + -16843009)|0;
   $12 = $10 & -2139062144;
   $13 = $12 ^ -2139062144;
   $14 = $13 & $11;
   $15 = ($14|0)==(0);
   $16 = ((($$0)) + 4|0);
   if ($15) {
    $$0 = $16;
   } else {
    break;
   }
  }
  $17 = $10&255;
  $18 = ($17<<24>>24)==(0);
  if ($18) {
   $$1$lcssa = $$0;
  } else {
   $$pn29 = $$0;
   while(1) {
    $19 = ((($$pn29)) + 1|0);
    $$pre = HEAP8[$19>>0]|0;
    $20 = ($$pre<<24>>24)==(0);
    if ($20) {
     $$1$lcssa = $19;
     break;
    } else {
     $$pn29 = $19;
    }
   }
  }
  $21 = $$1$lcssa;
  $$pn = $21;
 }
 $$014 = (($$pn) - ($1))|0;
 return ($$014|0);
}
function ___munmap($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = $0;
 HEAP32[$vararg_buffer>>2] = $2;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $1;
 $3 = (___syscall91(91,($vararg_buffer|0))|0);
 $4 = (___syscall_ret($3)|0);
 STACKTOP = sp;return ($4|0);
}
function ___strchrnul($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$029$lcssa = 0, $$02936 = 0, $$030$lcssa = 0, $$03039 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond33 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1 & 255;
 $3 = ($2|0)==(0);
 L1: do {
  if ($3) {
   $4 = (_strlen($0)|0);
   $5 = (($0) + ($4)|0);
   $$0 = $5;
  } else {
   $6 = $0;
   $7 = $6 & 3;
   $8 = ($7|0)==(0);
   if ($8) {
    $$030$lcssa = $0;
   } else {
    $9 = $1&255;
    $$03039 = $0;
    while(1) {
     $10 = HEAP8[$$03039>>0]|0;
     $11 = ($10<<24>>24)==(0);
     $12 = ($10<<24>>24)==($9<<24>>24);
     $or$cond = $11 | $12;
     if ($or$cond) {
      $$0 = $$03039;
      break L1;
     }
     $13 = ((($$03039)) + 1|0);
     $14 = $13;
     $15 = $14 & 3;
     $16 = ($15|0)==(0);
     if ($16) {
      $$030$lcssa = $13;
      break;
     } else {
      $$03039 = $13;
     }
    }
   }
   $17 = Math_imul($2, 16843009)|0;
   $18 = HEAP32[$$030$lcssa>>2]|0;
   $19 = (($18) + -16843009)|0;
   $20 = $18 & -2139062144;
   $21 = $20 ^ -2139062144;
   $22 = $21 & $19;
   $23 = ($22|0)==(0);
   L10: do {
    if ($23) {
     $$02936 = $$030$lcssa;$25 = $18;
     while(1) {
      $24 = $25 ^ $17;
      $26 = (($24) + -16843009)|0;
      $27 = $24 & -2139062144;
      $28 = $27 ^ -2139062144;
      $29 = $28 & $26;
      $30 = ($29|0)==(0);
      if (!($30)) {
       $$029$lcssa = $$02936;
       break L10;
      }
      $31 = ((($$02936)) + 4|0);
      $32 = HEAP32[$31>>2]|0;
      $33 = (($32) + -16843009)|0;
      $34 = $32 & -2139062144;
      $35 = $34 ^ -2139062144;
      $36 = $35 & $33;
      $37 = ($36|0)==(0);
      if ($37) {
       $$02936 = $31;$25 = $32;
      } else {
       $$029$lcssa = $31;
       break;
      }
     }
    } else {
     $$029$lcssa = $$030$lcssa;
    }
   } while(0);
   $38 = $1&255;
   $$1 = $$029$lcssa;
   while(1) {
    $39 = HEAP8[$$1>>0]|0;
    $40 = ($39<<24>>24)==(0);
    $41 = ($39<<24>>24)==($38<<24>>24);
    $or$cond33 = $40 | $41;
    $42 = ((($$1)) + 1|0);
    if ($or$cond33) {
     $$0 = $$1;
     break;
    } else {
     $$1 = $42;
    }
   }
  }
 } while(0);
 return ($$0|0);
}
function _dummy() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return;
}
function _strcpy($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (___stpcpy($0,$1)|0);
 return ($0|0);
}
function ___stpcpy($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0$lcssa = 0, $$025$lcssa = 0, $$02536 = 0, $$026$lcssa = 0, $$02642 = 0, $$027$lcssa = 0, $$02741 = 0, $$030 = 0, $$037 = 0, $$1 = 0, $$128 = 0, $$22934 = 0, $$235 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0;
 var $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0;
 var $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $1;
 $3 = $0;
 $4 = $2 ^ $3;
 $5 = $4 & 3;
 $6 = ($5|0)==(0);
 L1: do {
  if ($6) {
   $7 = $2 & 3;
   $8 = ($7|0)==(0);
   if ($8) {
    $$026$lcssa = $1;$$027$lcssa = $0;
   } else {
    $$02642 = $1;$$02741 = $0;
    while(1) {
     $9 = HEAP8[$$02642>>0]|0;
     HEAP8[$$02741>>0] = $9;
     $10 = ($9<<24>>24)==(0);
     if ($10) {
      $$030 = $$02741;
      break L1;
     }
     $11 = ((($$02642)) + 1|0);
     $12 = ((($$02741)) + 1|0);
     $13 = $11;
     $14 = $13 & 3;
     $15 = ($14|0)==(0);
     if ($15) {
      $$026$lcssa = $11;$$027$lcssa = $12;
      break;
     } else {
      $$02642 = $11;$$02741 = $12;
     }
    }
   }
   $16 = HEAP32[$$026$lcssa>>2]|0;
   $17 = (($16) + -16843009)|0;
   $18 = $16 & -2139062144;
   $19 = $18 ^ -2139062144;
   $20 = $19 & $17;
   $21 = ($20|0)==(0);
   if ($21) {
    $$02536 = $$027$lcssa;$$037 = $$026$lcssa;$24 = $16;
    while(1) {
     $22 = ((($$037)) + 4|0);
     $23 = ((($$02536)) + 4|0);
     HEAP32[$$02536>>2] = $24;
     $25 = HEAP32[$22>>2]|0;
     $26 = (($25) + -16843009)|0;
     $27 = $25 & -2139062144;
     $28 = $27 ^ -2139062144;
     $29 = $28 & $26;
     $30 = ($29|0)==(0);
     if ($30) {
      $$02536 = $23;$$037 = $22;$24 = $25;
     } else {
      $$0$lcssa = $22;$$025$lcssa = $23;
      break;
     }
    }
   } else {
    $$0$lcssa = $$026$lcssa;$$025$lcssa = $$027$lcssa;
   }
   $$1 = $$0$lcssa;$$128 = $$025$lcssa;
   label = 10;
  } else {
   $$1 = $1;$$128 = $0;
   label = 10;
  }
 } while(0);
 if ((label|0) == 10) {
  $31 = HEAP8[$$1>>0]|0;
  HEAP8[$$128>>0] = $31;
  $32 = ($31<<24>>24)==(0);
  if ($32) {
   $$030 = $$128;
  } else {
   $$22934 = $$128;$$235 = $$1;
   while(1) {
    $33 = ((($$235)) + 1|0);
    $34 = ((($$22934)) + 1|0);
    $35 = HEAP8[$33>>0]|0;
    HEAP8[$34>>0] = $35;
    $36 = ($35<<24>>24)==(0);
    if ($36) {
     $$030 = $34;
     break;
    } else {
     $$22934 = $34;$$235 = $33;
    }
   }
  }
 }
 return ($$030|0);
}
function _acosh($0) {
 $0 = +$0;
 var $$0 = 0.0, $1 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0.0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $3 = 0, $4 = 0;
 var $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = (_bitshift64Lshr(($1|0),($2|0),52)|0);
 $4 = tempRet0;
 $5 = $3 & 2047;
 $6 = ($5>>>0)<(1024);
 do {
  if ($6) {
   $7 = $0 + -1.0;
   $8 = $7 * $7;
   $9 = $7 * 2.0;
   $10 = $8 + $9;
   $11 = (+Math_sqrt((+$10)));
   $12 = $7 + $11;
   $13 = (+_log1p($12));
   $$0 = $13;
  } else {
   $14 = ($5>>>0)<(1049);
   if ($14) {
    $15 = $0 * 2.0;
    $16 = $0 * $0;
    $17 = $16 + -1.0;
    $18 = (+Math_sqrt((+$17)));
    $19 = $18 + $0;
    $20 = 1.0 / $19;
    $21 = $15 - $20;
    $22 = (+Math_log((+$21)));
    $$0 = $22;
    break;
   } else {
    $23 = (+Math_log((+$0)));
    $24 = $23 + 0.69314718055994529;
    $$0 = $24;
    break;
   }
  }
 } while(0);
 return (+$$0);
}
function _log1p($0) {
 $0 = +$0;
 var $$081 = 0.0, $$1 = 0.0, $$183 = 0.0, $$185 = 0.0, $$2 = 0.0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0.0;
 var $23 = 0.0, $24 = 0.0, $25 = 0.0, $26 = 0.0, $27 = 0.0, $28 = 0, $29 = 0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0.0;
 var $41 = 0.0, $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0.0, $5 = 0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0.0, $57 = 0.0, $58 = 0.0, $59 = 0.0;
 var $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0, $or$cond = 0, $phitmp = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = ($2>>>0)<(1071284858);
 $4 = ($2|0)<(0);
 $or$cond = $4 | $3;
 do {
  if ($or$cond) {
   $5 = ($2>>>0)>(3220176895);
   if ($5) {
    $6 = $0 == -1.0;
    if ($6) {
     $$081 = -inf;
     break;
    }
    $7 = $0 - $0;
    $8 = $7 / 0.0;
    $$081 = $8;
    break;
   } else {
    $9 = (_bitshift64Shl(($2|0),0,1)|0);
    $10 = tempRet0;
    $11 = ($9>>>0)<(2034237440);
    if ($11) {
     $$081 = $0;
     break;
    }
    $12 = ($2>>>0)<(3218259653);
    if ($12) {
     $$1 = 0.0;$$183 = $0;$$2 = 0.0;
     label = 11;
     break;
    } else {
     label = 8;
     break;
    }
   }
  } else {
   $13 = ($2>>>0)>(2146435071);
   if ($13) {
    $$081 = $0;
   } else {
    label = 8;
   }
  }
 } while(0);
 if ((label|0) == 8) {
  $14 = $0 + 1.0;
  HEAPF64[tempDoublePtr>>3] = $14;$15 = HEAP32[tempDoublePtr>>2]|0;
  $16 = HEAP32[tempDoublePtr+4>>2]|0;
  $17 = (($16) + 614242)|0;
  $18 = $17 >>> 20;
  $19 = (($18) + -1023)|0;
  $20 = ($17>>>0)<(1129316352);
  if ($20) {
   $21 = ($17>>>0)>(1074790399);
   $22 = $14 - $0;
   $23 = 1.0 - $22;
   $24 = $14 + -1.0;
   $25 = $0 - $24;
   $26 = $21 ? $23 : $25;
   $27 = $26 / $14;
   $$185 = $27;
  } else {
   $$185 = 0.0;
  }
  $28 = $17 & 1048575;
  $29 = (($28) + 1072079006)|0;
  HEAP32[tempDoublePtr>>2] = $15;HEAP32[tempDoublePtr+4>>2] = $29;$30 = +HEAPF64[tempDoublePtr>>3];
  $31 = $30 + -1.0;
  $phitmp = (+($19|0));
  $$1 = $phitmp;$$183 = $31;$$2 = $$185;
  label = 11;
 }
 if ((label|0) == 11) {
  $32 = $$183 * 0.5;
  $33 = $$183 * $32;
  $34 = $$183 + 2.0;
  $35 = $$183 / $34;
  $36 = $35 * $35;
  $37 = $36 * $36;
  $38 = $37 * 0.15313837699209373;
  $39 = $38 + 0.22222198432149784;
  $40 = $37 * $39;
  $41 = $40 + 0.39999999999409419;
  $42 = $37 * $41;
  $43 = $37 * 0.14798198605116586;
  $44 = $43 + 0.1818357216161805;
  $45 = $37 * $44;
  $46 = $45 + 0.28571428743662391;
  $47 = $37 * $46;
  $48 = $47 + 0.66666666666667351;
  $49 = $36 * $48;
  $50 = $42 + $49;
  $51 = $33 + $50;
  $52 = $35 * $51;
  $53 = $$1 * 1.9082149292705877E-10;
  $54 = $$2 + $53;
  $55 = $54 + $52;
  $56 = $55 - $33;
  $57 = $$183 + $56;
  $58 = $$1 * 0.69314718036912382;
  $59 = $58 + $57;
  $$081 = $59;
 }
 return (+$$081);
}
function _asinh($0) {
 $0 = +$0;
 var $$0 = 0.0, $1 = 0, $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0.0, $26 = 0.0;
 var $27 = 0.0, $28 = 0, $29 = 0.0, $3 = 0, $30 = 0.0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = (_bitshift64Lshr(($1|0),($2|0),52)|0);
 $4 = tempRet0;
 $5 = $3 & 2047;
 $6 = $2 & 2147483647;
 HEAP32[tempDoublePtr>>2] = $1;HEAP32[tempDoublePtr+4>>2] = $6;$7 = +HEAPF64[tempDoublePtr>>3];
 $8 = ($5>>>0)>(1048);
 do {
  if ($8) {
   $9 = (+Math_log((+$7)));
   $10 = $9 + 0.69314718055994529;
   $$0 = $10;
  } else {
   $11 = ($5>>>0)>(1023);
   if ($11) {
    $12 = $7 * 2.0;
    $13 = $7 * $7;
    $14 = $13 + 1.0;
    $15 = (+Math_sqrt((+$14)));
    $16 = $15 + $7;
    $17 = 1.0 / $16;
    $18 = $12 + $17;
    $19 = (+Math_log((+$18)));
    $$0 = $19;
    break;
   }
   $20 = ($5>>>0)>(996);
   if ($20) {
    $21 = $7 * $7;
    $22 = $21 + 1.0;
    $23 = (+Math_sqrt((+$22)));
    $24 = $23 + 1.0;
    $25 = $21 / $24;
    $26 = $25 + $7;
    $27 = (+_log1p($26));
    $$0 = $27;
   } else {
    $$0 = $7;
   }
  }
 } while(0);
 $28 = ($2|0)<(0);
 $29 = - $$0;
 $30 = $28 ? $29 : $$0;
 return (+$30);
}
function _atanh($0) {
 $0 = +$0;
 var $$0 = 0.0, $$sink19 = 0.0, $1 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0.0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = (_bitshift64Lshr(($1|0),($2|0),52)|0);
 $4 = tempRet0;
 $5 = $3 & 2047;
 $6 = $2 & 2147483647;
 HEAP32[tempDoublePtr>>2] = $1;HEAP32[tempDoublePtr+4>>2] = $6;$7 = +HEAPF64[tempDoublePtr>>3];
 $8 = ($5>>>0)<(1022);
 if ($8) {
  $9 = ($5>>>0)<(991);
  if ($9) {
   $$0 = $7;
  } else {
   $10 = $7 * 2.0;
   $11 = $10 * $7;
   $12 = 1.0 - $7;
   $13 = $11 / $12;
   $14 = $10 + $13;
   $$sink19 = $14;
   label = 5;
  }
 } else {
  $15 = 1.0 - $7;
  $16 = $7 / $15;
  $17 = $16 * 2.0;
  $$sink19 = $17;
  label = 5;
 }
 if ((label|0) == 5) {
  $18 = (+_log1p($$sink19));
  $19 = $18 * 0.5;
  $$0 = $19;
 }
 $20 = ($2|0)<(0);
 $21 = - $$0;
 $22 = $20 ? $21 : $$0;
 return (+$22);
}
function _tanh($0) {
 $0 = +$0;
 var $$0 = 0.0, $1 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0, $2 = 0, $20 = 0.0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0.0;
 var $27 = 0.0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $0;$1 = HEAP32[tempDoublePtr>>2]|0;
 $2 = HEAP32[tempDoublePtr+4>>2]|0;
 $3 = $2 & 2147483647;
 HEAP32[tempDoublePtr>>2] = $1;HEAP32[tempDoublePtr+4>>2] = $3;$4 = +HEAPF64[tempDoublePtr>>3];
 $5 = ($3>>>0)>(1071748074);
 do {
  if ($5) {
   $6 = ($3>>>0)>(1077149696);
   if ($6) {
    $7 = 0.0 / $4;
    $8 = 1.0 - $7;
    $$0 = $8;
    break;
   } else {
    $9 = $4 * 2.0;
    $10 = (+_expm1($9));
    $11 = $10 + 2.0;
    $12 = 2.0 / $11;
    $13 = 1.0 - $12;
    $$0 = $13;
    break;
   }
  } else {
   $14 = ($3>>>0)>(1070618798);
   if ($14) {
    $15 = $4 * 2.0;
    $16 = (+_expm1($15));
    $17 = $16 + 2.0;
    $18 = $16 / $17;
    $$0 = $18;
    break;
   }
   $19 = ($3>>>0)>(1048575);
   if ($19) {
    $20 = $4 * -2.0;
    $21 = (+_expm1($20));
    $22 = - $21;
    $23 = $21 + 2.0;
    $24 = $22 / $23;
    $$0 = $24;
   } else {
    $$0 = $4;
   }
  }
 } while(0);
 $25 = ($2|0)<(0);
 $26 = - $$0;
 $27 = $25 ? $26 : $$0;
 return (+$27);
}
function _write($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $3 = $1;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $3;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $2;
 $4 = (___syscall4(4,($vararg_buffer|0))|0);
 $5 = (___syscall_ret($4)|0);
 STACKTOP = sp;return ($5|0);
}
function _read($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $3 = $1;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $3;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $2;
 $4 = (___syscall3(3,($vararg_buffer|0))|0);
 $5 = (___syscall_ret($4)|0);
 STACKTOP = sp;return ($5|0);
}
function _stat($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = $0;
 $3 = $1;
 HEAP32[$vararg_buffer>>2] = $2;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $3;
 $4 = (___syscall195(195,($vararg_buffer|0))|0);
 $5 = (___syscall_ret($4)|0);
 STACKTOP = sp;return ($5|0);
}
function _getcwd($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $$06 = 0, $$07 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 4112|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(4112|0);
 $vararg_buffer = sp;
 $2 = sp + 8|0;
 $3 = ($0|0)==(0|0);
 if ($3) {
  $$0 = 4096;$$06 = $2;
  label = 4;
 } else {
  $4 = ($1|0)==(0);
  if ($4) {
   $5 = (___errno_location()|0);
   HEAP32[$5>>2] = 22;
   $$07 = 0;
  } else {
   $$0 = $1;$$06 = $0;
   label = 4;
  }
 }
 if ((label|0) == 4) {
  $6 = $$06;
  HEAP32[$vararg_buffer>>2] = $6;
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
  HEAP32[$vararg_ptr1>>2] = $$0;
  $7 = (___syscall183(183,($vararg_buffer|0))|0);
  $8 = (___syscall_ret($7)|0);
  $9 = ($8|0)<(0);
  if ($9) {
   $$07 = 0;
  } else {
   $10 = ($$06|0)==($2|0);
   if ($10) {
    $11 = (___strdup($2)|0);
    $$07 = $11;
   } else {
    $$07 = $$06;
   }
  }
 }
 STACKTOP = sp;return ($$07|0);
}
function ___strdup($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = (_strlen($0)|0);
 $2 = (($1) + 1)|0;
 $3 = (_malloc($2)|0);
 $4 = ($3|0)==(0|0);
 if ($4) {
  $$0 = 0;
 } else {
  $5 = (_memcpy(($3|0),($0|0),($2|0))|0);
  $$0 = $5;
 }
 return ($$0|0);
}
function _getpid() {
 var $0 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $0 = (___syscall20(20,($vararg_buffer|0))|0);
 STACKTOP = sp;return ($0|0);
}
function ___ofl_lock() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 ___lock((41356|0));
 return (41364|0);
}
function ___ofl_unlock() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 ___unlock((41356|0));
 return;
}
function _fflush($0) {
 $0 = $0|0;
 var $$0 = 0, $$023 = 0, $$02325 = 0, $$02327 = 0, $$024$lcssa = 0, $$02426 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0;
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ($0|0)==(0|0);
 do {
  if ($1) {
   $8 = HEAP32[1924]|0;
   $9 = ($8|0)==(0|0);
   if ($9) {
    $29 = 0;
   } else {
    $10 = HEAP32[1924]|0;
    $11 = (_fflush($10)|0);
    $29 = $11;
   }
   $12 = (___ofl_lock()|0);
   $$02325 = HEAP32[$12>>2]|0;
   $13 = ($$02325|0)==(0|0);
   if ($13) {
    $$024$lcssa = $29;
   } else {
    $$02327 = $$02325;$$02426 = $29;
    while(1) {
     $14 = ((($$02327)) + 76|0);
     $15 = HEAP32[$14>>2]|0;
     $16 = ($15|0)>(-1);
     if ($16) {
      $17 = (___lockfile($$02327)|0);
      $26 = $17;
     } else {
      $26 = 0;
     }
     $18 = ((($$02327)) + 20|0);
     $19 = HEAP32[$18>>2]|0;
     $20 = ((($$02327)) + 28|0);
     $21 = HEAP32[$20>>2]|0;
     $22 = ($19>>>0)>($21>>>0);
     if ($22) {
      $23 = (___fflush_unlocked($$02327)|0);
      $24 = $23 | $$02426;
      $$1 = $24;
     } else {
      $$1 = $$02426;
     }
     $25 = ($26|0)==(0);
     if (!($25)) {
      ___unlockfile($$02327);
     }
     $27 = ((($$02327)) + 56|0);
     $$023 = HEAP32[$27>>2]|0;
     $28 = ($$023|0)==(0|0);
     if ($28) {
      $$024$lcssa = $$1;
      break;
     } else {
      $$02327 = $$023;$$02426 = $$1;
     }
    }
   }
   ___ofl_unlock();
   $$0 = $$024$lcssa;
  } else {
   $2 = ((($0)) + 76|0);
   $3 = HEAP32[$2>>2]|0;
   $4 = ($3|0)>(-1);
   if (!($4)) {
    $5 = (___fflush_unlocked($0)|0);
    $$0 = $5;
    break;
   }
   $6 = (___lockfile($0)|0);
   $phitmp = ($6|0)==(0);
   $7 = (___fflush_unlocked($0)|0);
   if ($phitmp) {
    $$0 = $7;
   } else {
    ___unlockfile($0);
    $$0 = $7;
   }
  }
 } while(0);
 return ($$0|0);
}
function ___fflush_unlocked($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $1 = ((($0)) + 20|0);
 $2 = HEAP32[$1>>2]|0;
 $3 = ((($0)) + 28|0);
 $4 = HEAP32[$3>>2]|0;
 $5 = ($2>>>0)>($4>>>0);
 if ($5) {
  $6 = ((($0)) + 36|0);
  $7 = HEAP32[$6>>2]|0;
  (FUNCTION_TABLE_iiii[$7 & 127]($0,0,0)|0);
  $8 = HEAP32[$1>>2]|0;
  $9 = ($8|0)==(0|0);
  if ($9) {
   $$0 = -1;
  } else {
   label = 3;
  }
 } else {
  label = 3;
 }
 if ((label|0) == 3) {
  $10 = ((($0)) + 4|0);
  $11 = HEAP32[$10>>2]|0;
  $12 = ((($0)) + 8|0);
  $13 = HEAP32[$12>>2]|0;
  $14 = ($11>>>0)<($13>>>0);
  if ($14) {
   $15 = $11;
   $16 = $13;
   $17 = (($15) - ($16))|0;
   $18 = ((($0)) + 40|0);
   $19 = HEAP32[$18>>2]|0;
   (FUNCTION_TABLE_iiii[$19 & 127]($0,$17,1)|0);
  }
  $20 = ((($0)) + 16|0);
  HEAP32[$20>>2] = 0;
  HEAP32[$3>>2] = 0;
  HEAP32[$1>>2] = 0;
  HEAP32[$12>>2] = 0;
  HEAP32[$10>>2] = 0;
  $$0 = 0;
 }
 return ($$0|0);
}
function _lstat($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = $0;
 $3 = $1;
 HEAP32[$vararg_buffer>>2] = $2;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $3;
 $4 = (___syscall196(196,($vararg_buffer|0))|0);
 $5 = (___syscall_ret($4)|0);
 STACKTOP = sp;return ($5|0);
}
function _access($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = $0;
 HEAP32[$vararg_buffer>>2] = $2;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $1;
 $3 = (___syscall33(33,($vararg_buffer|0))|0);
 $4 = (___syscall_ret($3)|0);
 STACKTOP = sp;return ($4|0);
}
function _readlink($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $3 = $0;
 $4 = $1;
 HEAP32[$vararg_buffer>>2] = $3;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $4;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $2;
 $5 = (___syscall85(85,($vararg_buffer|0))|0);
 $6 = (___syscall_ret($5)|0);
 STACKTOP = sp;return ($6|0);
}
function ___mmap($0,$1,$2,$3,$4,$5) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 $4 = $4|0;
 $5 = $5|0;
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0;
 var $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, $vararg_ptr5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $6 = ($5|0)<(0);
 $7 = $6 << 31 >> 31;
 $8 = $5 & 4095;
 $9 = $7 & -4096;
 $10 = ($8|0)==(0);
 $11 = ($9|0)==(0);
 $12 = $10 & $11;
 do {
  if ($12) {
   $14 = ($1>>>0)>(2147483646);
   if ($14) {
    $15 = (___errno_location()|0);
    HEAP32[$15>>2] = 12;
    $$0 = (-1);
    break;
   }
   $16 = $3 & 16;
   $17 = ($16|0)==(0);
   if (!($17)) {
   }
   $18 = $0;
   $19 = $5 >> 12;
   HEAP32[$vararg_buffer>>2] = $18;
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
   HEAP32[$vararg_ptr1>>2] = $1;
   $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
   HEAP32[$vararg_ptr2>>2] = $2;
   $vararg_ptr3 = ((($vararg_buffer)) + 12|0);
   HEAP32[$vararg_ptr3>>2] = $3;
   $vararg_ptr4 = ((($vararg_buffer)) + 16|0);
   HEAP32[$vararg_ptr4>>2] = $4;
   $vararg_ptr5 = ((($vararg_buffer)) + 20|0);
   HEAP32[$vararg_ptr5>>2] = $19;
   $20 = (___syscall192(192,($vararg_buffer|0))|0);
   $21 = (___syscall_ret($20)|0);
   $22 = $21;
   $$0 = $22;
  } else {
   $13 = (___errno_location()|0);
   HEAP32[$13>>2] = 22;
   $$0 = (-1);
  }
 } while(0);
 STACKTOP = sp;return ($$0|0);
}
function _unlink($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $1 = $0;
 HEAP32[$vararg_buffer>>2] = $1;
 $2 = (___syscall10(10,($vararg_buffer|0))|0);
 $3 = (___syscall_ret($2)|0);
 STACKTOP = sp;return ($3|0);
}
function _strncpy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (___stpncpy($0,$1,$2)|0);
 return ($0|0);
}
function ___stpncpy($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0$lcssa = 0, $$037$lcssa = 0, $$03754 = 0, $$038$lcssa = 0, $$03867 = 0, $$039$lcssa = 0, $$03966 = 0, $$042$lcssa = 0, $$04265 = 0, $$055 = 0, $$1$lcssa = 0, $$140 = 0, $$143 = 0, $$153 = 0, $$2 = 0, $$24147 = 0, $$24446 = 0, $$345 = 0, $$348 = 0, $$4 = 0;
 var $$lcssa = 0, $$pr = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0;
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond64 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $3 = $1;
 $4 = $0;
 $5 = $3 ^ $4;
 $6 = $5 & 3;
 $7 = ($6|0)==(0);
 L1: do {
  if ($7) {
   $8 = $3 & 3;
   $9 = ($8|0)!=(0);
   $10 = ($2|0)!=(0);
   $or$cond64 = $10 & $9;
   if ($or$cond64) {
    $$03867 = $2;$$03966 = $1;$$04265 = $0;
    while(1) {
     $11 = HEAP8[$$03966>>0]|0;
     HEAP8[$$04265>>0] = $11;
     $12 = ($11<<24>>24)==(0);
     if ($12) {
      $$345 = $$04265;$$4 = $$03867;
      break L1;
     }
     $13 = (($$03867) + -1)|0;
     $14 = ((($$03966)) + 1|0);
     $15 = ((($$04265)) + 1|0);
     $16 = $14;
     $17 = $16 & 3;
     $18 = ($17|0)!=(0);
     $19 = ($13|0)!=(0);
     $or$cond = $19 & $18;
     if ($or$cond) {
      $$03867 = $13;$$03966 = $14;$$04265 = $15;
     } else {
      $$038$lcssa = $13;$$039$lcssa = $14;$$042$lcssa = $15;$$lcssa = $19;
      break;
     }
    }
   } else {
    $$038$lcssa = $2;$$039$lcssa = $1;$$042$lcssa = $0;$$lcssa = $10;
   }
   if ($$lcssa) {
    $$pr = HEAP8[$$039$lcssa>>0]|0;
    $20 = ($$pr<<24>>24)==(0);
    if ($20) {
     $$345 = $$042$lcssa;$$4 = $$038$lcssa;
    } else {
     $21 = ($$038$lcssa>>>0)>(3);
     L11: do {
      if ($21) {
       $$03754 = $$042$lcssa;$$055 = $$039$lcssa;$$153 = $$038$lcssa;
       while(1) {
        $22 = HEAP32[$$055>>2]|0;
        $23 = (($22) + -16843009)|0;
        $24 = $22 & -2139062144;
        $25 = $24 ^ -2139062144;
        $26 = $25 & $23;
        $27 = ($26|0)==(0);
        if (!($27)) {
         $$0$lcssa = $$055;$$037$lcssa = $$03754;$$1$lcssa = $$153;
         break L11;
        }
        HEAP32[$$03754>>2] = $22;
        $28 = (($$153) + -4)|0;
        $29 = ((($$055)) + 4|0);
        $30 = ((($$03754)) + 4|0);
        $31 = ($28>>>0)>(3);
        if ($31) {
         $$03754 = $30;$$055 = $29;$$153 = $28;
        } else {
         $$0$lcssa = $29;$$037$lcssa = $30;$$1$lcssa = $28;
         break;
        }
       }
      } else {
       $$0$lcssa = $$039$lcssa;$$037$lcssa = $$042$lcssa;$$1$lcssa = $$038$lcssa;
      }
     } while(0);
     $$140 = $$0$lcssa;$$143 = $$037$lcssa;$$2 = $$1$lcssa;
     label = 13;
    }
   } else {
    $$345 = $$042$lcssa;$$4 = 0;
   }
  } else {
   $$140 = $1;$$143 = $0;$$2 = $2;
   label = 13;
  }
 } while(0);
 L17: do {
  if ((label|0) == 13) {
   $32 = ($$2|0)==(0);
   if ($32) {
    $$345 = $$143;$$4 = 0;
   } else {
    $$24147 = $$140;$$24446 = $$143;$$348 = $$2;
    while(1) {
     $33 = HEAP8[$$24147>>0]|0;
     HEAP8[$$24446>>0] = $33;
     $34 = ($33<<24>>24)==(0);
     if ($34) {
      $$345 = $$24446;$$4 = $$348;
      break L17;
     }
     $35 = (($$348) + -1)|0;
     $36 = ((($$24147)) + 1|0);
     $37 = ((($$24446)) + 1|0);
     $38 = ($35|0)==(0);
     if ($38) {
      $$345 = $37;$$4 = 0;
      break;
     } else {
      $$24147 = $36;$$24446 = $37;$$348 = $35;
     }
    }
   }
  }
 } while(0);
 (_memset(($$345|0),0,($$4|0))|0);
 return ($$345|0);
}
function _fchmod($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer6 = 0, $vararg_ptr1 = 0, $vararg_ptr5 = 0, $vararg_ptr9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer6 = sp + 40|0;
 $vararg_buffer2 = sp + 8|0;
 $vararg_buffer = sp;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $1;
 $2 = (___syscall94(94,($vararg_buffer|0))|0);
 $3 = ($2|0)==(-9);
 if ($3) {
  HEAP32[$vararg_buffer2>>2] = $0;
  $vararg_ptr5 = ((($vararg_buffer2)) + 4|0);
  HEAP32[$vararg_ptr5>>2] = 1;
  $4 = (___syscall221(221,($vararg_buffer2|0))|0);
  $5 = ($4|0)<(0);
  if ($5) {
   label = 3;
  } else {
   ___procfdname($vararg_buffer2,$0);
   $7 = $vararg_buffer2;
   HEAP32[$vararg_buffer6>>2] = $7;
   $vararg_ptr9 = ((($vararg_buffer6)) + 4|0);
   HEAP32[$vararg_ptr9>>2] = $1;
   $8 = (___syscall15(15,($vararg_buffer6|0))|0);
   $9 = (___syscall_ret($8)|0);
   $$0 = $9;
  }
 } else {
  label = 3;
 }
 if ((label|0) == 3) {
  $6 = (___syscall_ret($2)|0);
  $$0 = $6;
 }
 STACKTOP = sp;return ($$0|0);
}
function _mkdir($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = $0;
 HEAP32[$vararg_buffer>>2] = $2;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $1;
 $3 = (___syscall39(39,($vararg_buffer|0))|0);
 $4 = (___syscall_ret($3)|0);
 STACKTOP = sp;return ($4|0);
}
function _strcspn($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $$01823 = 0, $$019$lcssa$sink = 0, $$01920 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $2 = sp;
 $3 = HEAP8[$1>>0]|0;
 $4 = ($3<<24>>24)==(0);
 L1: do {
  if ($4) {
   label = 3;
  } else {
   $5 = ((($1)) + 1|0);
   $6 = HEAP8[$5>>0]|0;
   $7 = ($6<<24>>24)==(0);
   if ($7) {
    label = 3;
   } else {
    (_memset(($2|0),0,32)|0);
    $10 = HEAP8[$1>>0]|0;
    $11 = ($10<<24>>24)==(0);
    if (!($11)) {
     $$01823 = $1;$13 = $10;
     while(1) {
      $12 = $13&255;
      $14 = $12 & 31;
      $15 = 1 << $14;
      $16 = $12 >>> 5;
      $17 = (($2) + ($16<<2)|0);
      $18 = HEAP32[$17>>2]|0;
      $19 = $18 | $15;
      HEAP32[$17>>2] = $19;
      $20 = ((($$01823)) + 1|0);
      $21 = HEAP8[$20>>0]|0;
      $22 = ($21<<24>>24)==(0);
      if ($22) {
       break;
      } else {
       $$01823 = $20;$13 = $21;
      }
     }
    }
    $23 = HEAP8[$0>>0]|0;
    $24 = ($23<<24>>24)==(0);
    if ($24) {
     $$019$lcssa$sink = $0;
    } else {
     $$01920 = $0;$26 = $23;
     while(1) {
      $25 = $26&255;
      $27 = $25 >>> 5;
      $28 = (($2) + ($27<<2)|0);
      $29 = HEAP32[$28>>2]|0;
      $30 = $25 & 31;
      $31 = 1 << $30;
      $32 = $29 & $31;
      $33 = ($32|0)==(0);
      if (!($33)) {
       $$019$lcssa$sink = $$01920;
       break L1;
      }
      $34 = ((($$01920)) + 1|0);
      $35 = HEAP8[$34>>0]|0;
      $36 = ($35<<24>>24)==(0);
      if ($36) {
       $$019$lcssa$sink = $34;
       break;
      } else {
       $$01920 = $34;$26 = $35;
      }
     }
    }
   }
  }
 } while(0);
 if ((label|0) == 3) {
  $8 = $3 << 24 >> 24;
  $9 = (___strchrnul($0,$8)|0);
  $$019$lcssa$sink = $9;
 }
 $37 = $$019$lcssa$sink;
 $38 = $0;
 $39 = (($37) - ($38))|0;
 STACKTOP = sp;return ($39|0);
}
function _geteuid() {
 var $0 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $0 = (___syscall201(201,($vararg_buffer|0))|0);
 STACKTOP = sp;return ($0|0);
}
function _fchown($0,$1,$2) {
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 var $$0 = 0, $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_buffer7 = 0, $vararg_ptr1 = 0, $vararg_ptr10 = 0, $vararg_ptr11 = 0, $vararg_ptr2 = 0, $vararg_ptr6 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 64|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(64|0);
 $vararg_buffer7 = sp + 48|0;
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = $1;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $2;
 $3 = (___syscall207(207,($vararg_buffer|0))|0);
 $4 = ($3|0)==(-9);
 if ($4) {
  HEAP32[$vararg_buffer3>>2] = $0;
  $vararg_ptr6 = ((($vararg_buffer3)) + 4|0);
  HEAP32[$vararg_ptr6>>2] = 1;
  $5 = (___syscall221(221,($vararg_buffer3|0))|0);
  $6 = ($5|0)<(0);
  if ($6) {
   label = 3;
  } else {
   ___procfdname($vararg_buffer3,$0);
   $8 = $vararg_buffer3;
   HEAP32[$vararg_buffer7>>2] = $8;
   $vararg_ptr10 = ((($vararg_buffer7)) + 4|0);
   HEAP32[$vararg_ptr10>>2] = $1;
   $vararg_ptr11 = ((($vararg_buffer7)) + 8|0);
   HEAP32[$vararg_ptr11>>2] = $2;
   $9 = (___syscall212(212,($vararg_buffer7|0))|0);
   $10 = (___syscall_ret($9)|0);
   $$0 = $10;
  }
 } else {
  label = 3;
 }
 if ((label|0) == 3) {
  $7 = (___syscall_ret($3)|0);
  $$0 = $7;
 }
 STACKTOP = sp;return ($$0|0);
}
function _fsync($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 HEAP32[$vararg_buffer>>2] = $0;
 $1 = (___syscall118(118,($vararg_buffer|0))|0);
 $2 = (___syscall_ret($1)|0);
 STACKTOP = sp;return ($2|0);
}
function _ftruncate($0,$1) {
 $0 = $0|0;
 $1 = $1|0;
 var $2 = 0, $3 = 0, $4 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $2 = $1 >> 31;
 HEAP32[$vararg_buffer>>2] = $0;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = 0;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $1;
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0);
 HEAP32[$vararg_ptr3>>2] = $2;
 $3 = (___syscall194(194,($vararg_buffer|0))|0);
 $4 = (___syscall_ret($3)|0);
 STACKTOP = sp;return ($4|0);
}
function _rmdir($0) {
 $0 = $0|0;
 var $1 = 0, $2 = 0, $3 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $1 = $0;
 HEAP32[$vararg_buffer>>2] = $1;
 $2 = (___syscall40(40,($vararg_buffer|0))|0);
 $3 = (___syscall_ret($2)|0);
 STACKTOP = sp;return ($3|0);
}
function _sleep($0) {
 $0 = $0|0;
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $1 = sp;
 HEAP32[$1>>2] = $0;
 $2 = ((($1)) + 4|0);
 HEAP32[$2>>2] = 0;
 $3 = (_nanosleep(($1|0),($1|0))|0);
 $4 = ($3|0)==(0);
 $5 = HEAP32[$1>>2]|0;
 $$0 = $4 ? 0 : $5;
 STACKTOP = sp;return ($$0|0);
}
function ___emscripten_environ_constructor() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 ___buildEnvironment((41384|0));
 return;
}
function __get_tzname() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (41368|0);
}
function __get_daylight() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (41376|0);
}
function __get_timezone() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (41380|0);
}
function __get_environ() {
 var label = 0, sp = 0;
 sp = STACKTOP;
 return (41384|0);
}
function runPostSets() {
}
function _i64Add(a, b, c, d) {
    /*
      x = a + b*2^32
      y = c + d*2^32
      result = l + h*2^32
    */
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a + c)>>>0;
    h = (b + d + (((l>>>0) < (a>>>0))|0))>>>0; // Add carry from low word to high word on overflow.
    return ((tempRet0 = h,l|0)|0);
}
function _i64Subtract(a, b, c, d) {
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a - c)>>>0;
    h = (b - d)>>>0;
    h = (b - d - (((c>>>0) > (a>>>0))|0))>>>0; // Borrow one from high word to low word on underflow.
    return ((tempRet0 = h,l|0)|0);
}
function _llvm_cttz_i32(x) { // Note: Currently doesn't take isZeroUndef()
    x = x | 0;
    return (x ? (31 - (Math_clz32((x ^ (x - 1))) | 0) | 0) : 32) | 0;
}
function ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    $rem = $rem | 0;
    var $n_sroa_0_0_extract_trunc = 0, $n_sroa_1_4_extract_shift$0 = 0, $n_sroa_1_4_extract_trunc = 0, $d_sroa_0_0_extract_trunc = 0, $d_sroa_1_4_extract_shift$0 = 0, $d_sroa_1_4_extract_trunc = 0, $4 = 0, $17 = 0, $37 = 0, $49 = 0, $51 = 0, $57 = 0, $58 = 0, $66 = 0, $78 = 0, $86 = 0, $88 = 0, $89 = 0, $91 = 0, $92 = 0, $95 = 0, $105 = 0, $117 = 0, $119 = 0, $125 = 0, $126 = 0, $130 = 0, $q_sroa_1_1_ph = 0, $q_sroa_0_1_ph = 0, $r_sroa_1_1_ph = 0, $r_sroa_0_1_ph = 0, $sr_1_ph = 0, $d_sroa_0_0_insert_insert99$0 = 0, $d_sroa_0_0_insert_insert99$1 = 0, $137$0 = 0, $137$1 = 0, $carry_0203 = 0, $sr_1202 = 0, $r_sroa_0_1201 = 0, $r_sroa_1_1200 = 0, $q_sroa_0_1199 = 0, $q_sroa_1_1198 = 0, $147 = 0, $149 = 0, $r_sroa_0_0_insert_insert42$0 = 0, $r_sroa_0_0_insert_insert42$1 = 0, $150$1 = 0, $151$0 = 0, $152 = 0, $154$0 = 0, $r_sroa_0_0_extract_trunc = 0, $r_sroa_1_4_extract_trunc = 0, $155 = 0, $carry_0_lcssa$0 = 0, $carry_0_lcssa$1 = 0, $r_sroa_0_1_lcssa = 0, $r_sroa_1_1_lcssa = 0, $q_sroa_0_1_lcssa = 0, $q_sroa_1_1_lcssa = 0, $q_sroa_0_0_insert_ext75$0 = 0, $q_sroa_0_0_insert_ext75$1 = 0, $q_sroa_0_0_insert_insert77$1 = 0, $_0$0 = 0, $_0$1 = 0;
    $n_sroa_0_0_extract_trunc = $a$0;
    $n_sroa_1_4_extract_shift$0 = $a$1;
    $n_sroa_1_4_extract_trunc = $n_sroa_1_4_extract_shift$0;
    $d_sroa_0_0_extract_trunc = $b$0;
    $d_sroa_1_4_extract_shift$0 = $b$1;
    $d_sroa_1_4_extract_trunc = $d_sroa_1_4_extract_shift$0;
    if (($n_sroa_1_4_extract_trunc | 0) == 0) {
      $4 = ($rem | 0) != 0;
      if (($d_sroa_1_4_extract_trunc | 0) == 0) {
        if ($4) {
          HEAP32[$rem >> 2] = ($n_sroa_0_0_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
          HEAP32[$rem + 4 >> 2] = 0;
        }
        $_0$1 = 0;
        $_0$0 = ($n_sroa_0_0_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      } else {
        if (!$4) {
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        HEAP32[$rem >> 2] = $a$0 & -1;
        HEAP32[$rem + 4 >> 2] = $a$1 & 0;
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
    }
    $17 = ($d_sroa_1_4_extract_trunc | 0) == 0;
    do {
      if (($d_sroa_0_0_extract_trunc | 0) == 0) {
        if ($17) {
          if (($rem | 0) != 0) {
            HEAP32[$rem >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
            HEAP32[$rem + 4 >> 2] = 0;
          }
          $_0$1 = 0;
          $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        if (($n_sroa_0_0_extract_trunc | 0) == 0) {
          if (($rem | 0) != 0) {
            HEAP32[$rem >> 2] = 0;
            HEAP32[$rem + 4 >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_1_4_extract_trunc >>> 0);
          }
          $_0$1 = 0;
          $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_1_4_extract_trunc >>> 0) >>> 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        $37 = $d_sroa_1_4_extract_trunc - 1 | 0;
        if (($37 & $d_sroa_1_4_extract_trunc | 0) == 0) {
          if (($rem | 0) != 0) {
            HEAP32[$rem >> 2] = 0 | $a$0 & -1;
            HEAP32[$rem + 4 >> 2] = $37 & $n_sroa_1_4_extract_trunc | $a$1 & 0;
          }
          $_0$1 = 0;
          $_0$0 = $n_sroa_1_4_extract_trunc >>> ((_llvm_cttz_i32($d_sroa_1_4_extract_trunc | 0) | 0) >>> 0);
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        $49 = Math_clz32($d_sroa_1_4_extract_trunc | 0) | 0;
        $51 = $49 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
        if ($51 >>> 0 <= 30) {
          $57 = $51 + 1 | 0;
          $58 = 31 - $51 | 0;
          $sr_1_ph = $57;
          $r_sroa_0_1_ph = $n_sroa_1_4_extract_trunc << $58 | $n_sroa_0_0_extract_trunc >>> ($57 >>> 0);
          $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($57 >>> 0);
          $q_sroa_0_1_ph = 0;
          $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $58;
          break;
        }
        if (($rem | 0) == 0) {
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        HEAP32[$rem >> 2] = 0 | $a$0 & -1;
        HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      } else {
        if (!$17) {
          $117 = Math_clz32($d_sroa_1_4_extract_trunc | 0) | 0;
          $119 = $117 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
          if ($119 >>> 0 <= 31) {
            $125 = $119 + 1 | 0;
            $126 = 31 - $119 | 0;
            $130 = $119 - 31 >> 31;
            $sr_1_ph = $125;
            $r_sroa_0_1_ph = $n_sroa_0_0_extract_trunc >>> ($125 >>> 0) & $130 | $n_sroa_1_4_extract_trunc << $126;
            $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($125 >>> 0) & $130;
            $q_sroa_0_1_ph = 0;
            $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $126;
            break;
          }
          if (($rem | 0) == 0) {
            $_0$1 = 0;
            $_0$0 = 0;
            return (tempRet0 = $_0$1, $_0$0) | 0;
          }
          HEAP32[$rem >> 2] = 0 | $a$0 & -1;
          HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        $66 = $d_sroa_0_0_extract_trunc - 1 | 0;
        if (($66 & $d_sroa_0_0_extract_trunc | 0) != 0) {
          $86 = (Math_clz32($d_sroa_0_0_extract_trunc | 0) | 0) + 33 | 0;
          $88 = $86 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
          $89 = 64 - $88 | 0;
          $91 = 32 - $88 | 0;
          $92 = $91 >> 31;
          $95 = $88 - 32 | 0;
          $105 = $95 >> 31;
          $sr_1_ph = $88;
          $r_sroa_0_1_ph = $91 - 1 >> 31 & $n_sroa_1_4_extract_trunc >>> ($95 >>> 0) | ($n_sroa_1_4_extract_trunc << $91 | $n_sroa_0_0_extract_trunc >>> ($88 >>> 0)) & $105;
          $r_sroa_1_1_ph = $105 & $n_sroa_1_4_extract_trunc >>> ($88 >>> 0);
          $q_sroa_0_1_ph = $n_sroa_0_0_extract_trunc << $89 & $92;
          $q_sroa_1_1_ph = ($n_sroa_1_4_extract_trunc << $89 | $n_sroa_0_0_extract_trunc >>> ($95 >>> 0)) & $92 | $n_sroa_0_0_extract_trunc << $91 & $88 - 33 >> 31;
          break;
        }
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = $66 & $n_sroa_0_0_extract_trunc;
          HEAP32[$rem + 4 >> 2] = 0;
        }
        if (($d_sroa_0_0_extract_trunc | 0) == 1) {
          $_0$1 = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
          $_0$0 = 0 | $a$0 & -1;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        } else {
          $78 = _llvm_cttz_i32($d_sroa_0_0_extract_trunc | 0) | 0;
          $_0$1 = 0 | $n_sroa_1_4_extract_trunc >>> ($78 >>> 0);
          $_0$0 = $n_sroa_1_4_extract_trunc << 32 - $78 | $n_sroa_0_0_extract_trunc >>> ($78 >>> 0) | 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
      }
    } while (0);
    if (($sr_1_ph | 0) == 0) {
      $q_sroa_1_1_lcssa = $q_sroa_1_1_ph;
      $q_sroa_0_1_lcssa = $q_sroa_0_1_ph;
      $r_sroa_1_1_lcssa = $r_sroa_1_1_ph;
      $r_sroa_0_1_lcssa = $r_sroa_0_1_ph;
      $carry_0_lcssa$1 = 0;
      $carry_0_lcssa$0 = 0;
    } else {
      $d_sroa_0_0_insert_insert99$0 = 0 | $b$0 & -1;
      $d_sroa_0_0_insert_insert99$1 = $d_sroa_1_4_extract_shift$0 | $b$1 & 0;
      $137$0 = _i64Add($d_sroa_0_0_insert_insert99$0 | 0, $d_sroa_0_0_insert_insert99$1 | 0, -1, -1) | 0;
      $137$1 = tempRet0;
      $q_sroa_1_1198 = $q_sroa_1_1_ph;
      $q_sroa_0_1199 = $q_sroa_0_1_ph;
      $r_sroa_1_1200 = $r_sroa_1_1_ph;
      $r_sroa_0_1201 = $r_sroa_0_1_ph;
      $sr_1202 = $sr_1_ph;
      $carry_0203 = 0;
      while (1) {
        $147 = $q_sroa_0_1199 >>> 31 | $q_sroa_1_1198 << 1;
        $149 = $carry_0203 | $q_sroa_0_1199 << 1;
        $r_sroa_0_0_insert_insert42$0 = 0 | ($r_sroa_0_1201 << 1 | $q_sroa_1_1198 >>> 31);
        $r_sroa_0_0_insert_insert42$1 = $r_sroa_0_1201 >>> 31 | $r_sroa_1_1200 << 1 | 0;
        _i64Subtract($137$0 | 0, $137$1 | 0, $r_sroa_0_0_insert_insert42$0 | 0, $r_sroa_0_0_insert_insert42$1 | 0) | 0;
        $150$1 = tempRet0;
        $151$0 = $150$1 >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1;
        $152 = $151$0 & 1;
        $154$0 = _i64Subtract($r_sroa_0_0_insert_insert42$0 | 0, $r_sroa_0_0_insert_insert42$1 | 0, $151$0 & $d_sroa_0_0_insert_insert99$0 | 0, ((($150$1 | 0) < 0 ? -1 : 0) >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1) & $d_sroa_0_0_insert_insert99$1 | 0) | 0;
        $r_sroa_0_0_extract_trunc = $154$0;
        $r_sroa_1_4_extract_trunc = tempRet0;
        $155 = $sr_1202 - 1 | 0;
        if (($155 | 0) == 0) {
          break;
        } else {
          $q_sroa_1_1198 = $147;
          $q_sroa_0_1199 = $149;
          $r_sroa_1_1200 = $r_sroa_1_4_extract_trunc;
          $r_sroa_0_1201 = $r_sroa_0_0_extract_trunc;
          $sr_1202 = $155;
          $carry_0203 = $152;
        }
      }
      $q_sroa_1_1_lcssa = $147;
      $q_sroa_0_1_lcssa = $149;
      $r_sroa_1_1_lcssa = $r_sroa_1_4_extract_trunc;
      $r_sroa_0_1_lcssa = $r_sroa_0_0_extract_trunc;
      $carry_0_lcssa$1 = 0;
      $carry_0_lcssa$0 = $152;
    }
    $q_sroa_0_0_insert_ext75$0 = $q_sroa_0_1_lcssa;
    $q_sroa_0_0_insert_ext75$1 = 0;
    $q_sroa_0_0_insert_insert77$1 = $q_sroa_1_1_lcssa | $q_sroa_0_0_insert_ext75$1;
    if (($rem | 0) != 0) {
      HEAP32[$rem >> 2] = 0 | $r_sroa_0_1_lcssa;
      HEAP32[$rem + 4 >> 2] = $r_sroa_1_1_lcssa | 0;
    }
    $_0$1 = (0 | $q_sroa_0_0_insert_ext75$0) >>> 31 | $q_sroa_0_0_insert_insert77$1 << 1 | ($q_sroa_0_0_insert_ext75$1 << 1 | $q_sroa_0_0_insert_ext75$0 >>> 31) & 0 | $carry_0_lcssa$1;
    $_0$0 = ($q_sroa_0_0_insert_ext75$0 << 1 | 0 >>> 31) & -2 | $carry_0_lcssa$0;
    return (tempRet0 = $_0$1, $_0$0) | 0;
}
function ___divdi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $1$0 = 0, $1$1 = 0, $2$0 = 0, $2$1 = 0, $4$0 = 0, $4$1 = 0, $6$0 = 0, $7$0 = 0, $7$1 = 0, $8$0 = 0, $10$0 = 0;
    $1$0 = $a$1 >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
    $1$1 = (($a$1 | 0) < 0 ? -1 : 0) >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
    $2$0 = $b$1 >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
    $2$1 = (($b$1 | 0) < 0 ? -1 : 0) >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
    $4$0 = _i64Subtract($1$0 ^ $a$0 | 0, $1$1 ^ $a$1 | 0, $1$0 | 0, $1$1 | 0) | 0;
    $4$1 = tempRet0;
    $6$0 = _i64Subtract($2$0 ^ $b$0 | 0, $2$1 ^ $b$1 | 0, $2$0 | 0, $2$1 | 0) | 0;
    $7$0 = $2$0 ^ $1$0;
    $7$1 = $2$1 ^ $1$1;
    $8$0 = ___udivmoddi4($4$0, $4$1, $6$0, tempRet0, 0) | 0;
    $10$0 = _i64Subtract($8$0 ^ $7$0 | 0, tempRet0 ^ $7$1 | 0, $7$0 | 0, $7$1 | 0) | 0;
    return $10$0 | 0;
}
function ___muldsi3($a, $b) {
    $a = $a | 0;
    $b = $b | 0;
    var $1 = 0, $2 = 0, $3 = 0, $6 = 0, $8 = 0, $11 = 0, $12 = 0;
    $1 = $a & 65535;
    $2 = $b & 65535;
    $3 = Math_imul($2, $1) | 0;
    $6 = $a >>> 16;
    $8 = ($3 >>> 16) + (Math_imul($2, $6) | 0) | 0;
    $11 = $b >>> 16;
    $12 = Math_imul($11, $1) | 0;
    return (tempRet0 = (($8 >>> 16) + (Math_imul($11, $6) | 0) | 0) + ((($8 & 65535) + $12 | 0) >>> 16) | 0, 0 | ($8 + $12 << 16 | $3 & 65535)) | 0;
}
function ___muldi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $x_sroa_0_0_extract_trunc = 0, $y_sroa_0_0_extract_trunc = 0, $1$0 = 0, $1$1 = 0, $2 = 0;
    $x_sroa_0_0_extract_trunc = $a$0;
    $y_sroa_0_0_extract_trunc = $b$0;
    $1$0 = ___muldsi3($x_sroa_0_0_extract_trunc, $y_sroa_0_0_extract_trunc) | 0;
    $1$1 = tempRet0;
    $2 = Math_imul($a$1, $y_sroa_0_0_extract_trunc) | 0;
    return (tempRet0 = ((Math_imul($b$1, $x_sroa_0_0_extract_trunc) | 0) + $2 | 0) + $1$1 | $1$1 & 0, 0 | $1$0 & -1) | 0;
}
function ___remdi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $rem = 0, $1$0 = 0, $1$1 = 0, $2$0 = 0, $2$1 = 0, $4$0 = 0, $4$1 = 0, $6$0 = 0, $10$0 = 0, $10$1 = 0, __stackBase__ = 0;
    __stackBase__ = STACKTOP;
    STACKTOP = STACKTOP + 16 | 0;
    $rem = __stackBase__ | 0;
    $1$0 = $a$1 >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
    $1$1 = (($a$1 | 0) < 0 ? -1 : 0) >> 31 | (($a$1 | 0) < 0 ? -1 : 0) << 1;
    $2$0 = $b$1 >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
    $2$1 = (($b$1 | 0) < 0 ? -1 : 0) >> 31 | (($b$1 | 0) < 0 ? -1 : 0) << 1;
    $4$0 = _i64Subtract($1$0 ^ $a$0 | 0, $1$1 ^ $a$1 | 0, $1$0 | 0, $1$1 | 0) | 0;
    $4$1 = tempRet0;
    $6$0 = _i64Subtract($2$0 ^ $b$0 | 0, $2$1 ^ $b$1 | 0, $2$0 | 0, $2$1 | 0) | 0;
    ___udivmoddi4($4$0, $4$1, $6$0, tempRet0, $rem) | 0;
    $10$0 = _i64Subtract(HEAP32[$rem >> 2] ^ $1$0 | 0, HEAP32[$rem + 4 >> 2] ^ $1$1 | 0, $1$0 | 0, $1$1 | 0) | 0;
    $10$1 = tempRet0;
    STACKTOP = __stackBase__;
    return (tempRet0 = $10$1, $10$0) | 0;
}
function ___udivdi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $1$0 = 0;
    $1$0 = ___udivmoddi4($a$0, $a$1, $b$0, $b$1, 0) | 0;
    return $1$0 | 0;
}
function ___uremdi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $rem = 0, __stackBase__ = 0;
    __stackBase__ = STACKTOP;
    STACKTOP = STACKTOP + 16 | 0;
    $rem = __stackBase__ | 0;
    ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) | 0;
    STACKTOP = __stackBase__;
    return (tempRet0 = HEAP32[$rem + 4 >> 2] | 0, HEAP32[$rem >> 2] | 0) | 0;
}
function _bitshift64Ashr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = (high|0) < 0 ? -1 : 0;
    return (high >> (bits - 32))|0;
}
function _bitshift64Lshr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >>> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = 0;
    return (high >>> (bits - 32))|0;
}
function _bitshift64Shl(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = (high << bits) | ((low&(ander << (32 - bits))) >>> (32 - bits));
      return low << bits;
    }
    tempRet0 = low << (bits - 32);
    return 0;
}
function _llvm_bswap_i32(x) {
    x = x|0;
    return (((x&0xff)<<24) | (((x>>8)&0xff)<<16) | (((x>>16)&0xff)<<8) | (x>>>24))|0;
}
function _memcpy(dest, src, num) {
    dest = dest|0; src = src|0; num = num|0;
    var ret = 0;
    var aligned_dest_end = 0;
    var block_aligned_dest_end = 0;
    var dest_end = 0;
    // Test against a benchmarked cutoff limit for when HEAPU8.set() becomes faster to use.
    if ((num|0) >=
      8192
    ) {
      return _emscripten_memcpy_big(dest|0, src|0, num|0)|0;
    }

    ret = dest|0;
    dest_end = (dest + num)|0;
    if ((dest&3) == (src&3)) {
      // The initial unaligned < 4-byte front.
      while (dest & 3) {
        if ((num|0) == 0) return ret|0;
        HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
        dest = (dest+1)|0;
        src = (src+1)|0;
        num = (num-1)|0;
      }
      aligned_dest_end = (dest_end & -4)|0;
      block_aligned_dest_end = (aligned_dest_end - 64)|0;
      while ((dest|0) <= (block_aligned_dest_end|0) ) {
        HEAP32[((dest)>>2)]=((HEAP32[((src)>>2)])|0);
        HEAP32[(((dest)+(4))>>2)]=((HEAP32[(((src)+(4))>>2)])|0);
        HEAP32[(((dest)+(8))>>2)]=((HEAP32[(((src)+(8))>>2)])|0);
        HEAP32[(((dest)+(12))>>2)]=((HEAP32[(((src)+(12))>>2)])|0);
        HEAP32[(((dest)+(16))>>2)]=((HEAP32[(((src)+(16))>>2)])|0);
        HEAP32[(((dest)+(20))>>2)]=((HEAP32[(((src)+(20))>>2)])|0);
        HEAP32[(((dest)+(24))>>2)]=((HEAP32[(((src)+(24))>>2)])|0);
        HEAP32[(((dest)+(28))>>2)]=((HEAP32[(((src)+(28))>>2)])|0);
        HEAP32[(((dest)+(32))>>2)]=((HEAP32[(((src)+(32))>>2)])|0);
        HEAP32[(((dest)+(36))>>2)]=((HEAP32[(((src)+(36))>>2)])|0);
        HEAP32[(((dest)+(40))>>2)]=((HEAP32[(((src)+(40))>>2)])|0);
        HEAP32[(((dest)+(44))>>2)]=((HEAP32[(((src)+(44))>>2)])|0);
        HEAP32[(((dest)+(48))>>2)]=((HEAP32[(((src)+(48))>>2)])|0);
        HEAP32[(((dest)+(52))>>2)]=((HEAP32[(((src)+(52))>>2)])|0);
        HEAP32[(((dest)+(56))>>2)]=((HEAP32[(((src)+(56))>>2)])|0);
        HEAP32[(((dest)+(60))>>2)]=((HEAP32[(((src)+(60))>>2)])|0);
        dest = (dest+64)|0;
        src = (src+64)|0;
      }
      while ((dest|0) < (aligned_dest_end|0) ) {
        HEAP32[((dest)>>2)]=((HEAP32[((src)>>2)])|0);
        dest = (dest+4)|0;
        src = (src+4)|0;
      }
    } else {
      // In the unaligned copy case, unroll a bit as well.
      aligned_dest_end = (dest_end - 4)|0;
      while ((dest|0) < (aligned_dest_end|0) ) {
        HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
        HEAP8[(((dest)+(1))>>0)]=((HEAP8[(((src)+(1))>>0)])|0);
        HEAP8[(((dest)+(2))>>0)]=((HEAP8[(((src)+(2))>>0)])|0);
        HEAP8[(((dest)+(3))>>0)]=((HEAP8[(((src)+(3))>>0)])|0);
        dest = (dest+4)|0;
        src = (src+4)|0;
      }
    }
    // The remaining unaligned < 4 byte tail.
    while ((dest|0) < (dest_end|0)) {
      HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
      dest = (dest+1)|0;
      src = (src+1)|0;
    }
    return ret|0;
}
function _memmove(dest, src, num) {
    dest = dest|0; src = src|0; num = num|0;
    var ret = 0;
    if (((src|0) < (dest|0)) & ((dest|0) < ((src + num)|0))) {
      // Unlikely case: Copy backwards in a safe manner
      ret = dest;
      src = (src + num)|0;
      dest = (dest + num)|0;
      while ((num|0) > 0) {
        dest = (dest - 1)|0;
        src = (src - 1)|0;
        num = (num - 1)|0;
        HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
      }
      dest = ret;
    } else {
      _memcpy(dest, src, num) | 0;
    }
    return dest | 0;
}
function _memset(ptr, value, num) {
    ptr = ptr|0; value = value|0; num = num|0;
    var end = 0, aligned_end = 0, block_aligned_end = 0, value4 = 0;
    end = (ptr + num)|0;

    value = value & 0xff;
    if ((num|0) >= 67 /* 64 bytes for an unrolled loop + 3 bytes for unaligned head*/) {
      while ((ptr&3) != 0) {
        HEAP8[((ptr)>>0)]=value;
        ptr = (ptr+1)|0;
      }

      aligned_end = (end & -4)|0;
      block_aligned_end = (aligned_end - 64)|0;
      value4 = value | (value << 8) | (value << 16) | (value << 24);

      while((ptr|0) <= (block_aligned_end|0)) {
        HEAP32[((ptr)>>2)]=value4;
        HEAP32[(((ptr)+(4))>>2)]=value4;
        HEAP32[(((ptr)+(8))>>2)]=value4;
        HEAP32[(((ptr)+(12))>>2)]=value4;
        HEAP32[(((ptr)+(16))>>2)]=value4;
        HEAP32[(((ptr)+(20))>>2)]=value4;
        HEAP32[(((ptr)+(24))>>2)]=value4;
        HEAP32[(((ptr)+(28))>>2)]=value4;
        HEAP32[(((ptr)+(32))>>2)]=value4;
        HEAP32[(((ptr)+(36))>>2)]=value4;
        HEAP32[(((ptr)+(40))>>2)]=value4;
        HEAP32[(((ptr)+(44))>>2)]=value4;
        HEAP32[(((ptr)+(48))>>2)]=value4;
        HEAP32[(((ptr)+(52))>>2)]=value4;
        HEAP32[(((ptr)+(56))>>2)]=value4;
        HEAP32[(((ptr)+(60))>>2)]=value4;
        ptr = (ptr + 64)|0;
      }

      while ((ptr|0) < (aligned_end|0) ) {
        HEAP32[((ptr)>>2)]=value4;
        ptr = (ptr+4)|0;
      }
    }
    // The remaining bytes.
    while ((ptr|0) < (end|0)) {
      HEAP8[((ptr)>>0)]=value;
      ptr = (ptr+1)|0;
    }
    return (end-num)|0;
}
function _pthread_mutex_lock(x) {
    x = x | 0;
    return 0;
}
function _pthread_mutex_trylock(x) {
    x = x | 0;
    return 0;
}
function _pthread_mutex_unlock(x) {
    x = x | 0;
    return 0;
}
function _sbrk(increment) {
    increment = increment|0;
    var oldDynamicTop = 0;
    var oldDynamicTopOnChange = 0;
    var newDynamicTop = 0;
    var totalMemory = 0;
    oldDynamicTop = HEAP32[DYNAMICTOP_PTR>>2]|0;
    newDynamicTop = oldDynamicTop + increment | 0;

    if (((increment|0) > 0 & (newDynamicTop|0) < (oldDynamicTop|0)) // Detect and fail if we would wrap around signed 32-bit int.
      | (newDynamicTop|0) < 0) { // Also underflow, sbrk() should be able to be used to subtract.
      abortOnCannotGrowMemory()|0;
      ___setErrNo(12);
      return -1;
    }

    HEAP32[DYNAMICTOP_PTR>>2] = newDynamicTop;
    totalMemory = getTotalMemory()|0;
    if ((newDynamicTop|0) > (totalMemory|0)) {
      if ((enlargeMemory()|0) == 0) {
        HEAP32[DYNAMICTOP_PTR>>2] = oldDynamicTop;
        ___setErrNo(12);
        return -1;
      }
    }
    return oldDynamicTop|0;
}

  
function dynCall_di(index,a1) {
  index = index|0;
  a1=a1|0;
  return +FUNCTION_TABLE_di[index&127](a1|0);
}


function jsCall_di_0(a1) {
  a1=a1|0;
  return +jsCall_di(0,a1|0);
}



function jsCall_di_1(a1) {
  a1=a1|0;
  return +jsCall_di(1,a1|0);
}



function jsCall_di_2(a1) {
  a1=a1|0;
  return +jsCall_di(2,a1|0);
}



function jsCall_di_3(a1) {
  a1=a1|0;
  return +jsCall_di(3,a1|0);
}



function jsCall_di_4(a1) {
  a1=a1|0;
  return +jsCall_di(4,a1|0);
}



function jsCall_di_5(a1) {
  a1=a1|0;
  return +jsCall_di(5,a1|0);
}



function jsCall_di_6(a1) {
  a1=a1|0;
  return +jsCall_di(6,a1|0);
}



function jsCall_di_7(a1) {
  a1=a1|0;
  return +jsCall_di(7,a1|0);
}



function jsCall_di_8(a1) {
  a1=a1|0;
  return +jsCall_di(8,a1|0);
}



function jsCall_di_9(a1) {
  a1=a1|0;
  return +jsCall_di(9,a1|0);
}



function jsCall_di_10(a1) {
  a1=a1|0;
  return +jsCall_di(10,a1|0);
}



function jsCall_di_11(a1) {
  a1=a1|0;
  return +jsCall_di(11,a1|0);
}



function jsCall_di_12(a1) {
  a1=a1|0;
  return +jsCall_di(12,a1|0);
}



function jsCall_di_13(a1) {
  a1=a1|0;
  return +jsCall_di(13,a1|0);
}



function jsCall_di_14(a1) {
  a1=a1|0;
  return +jsCall_di(14,a1|0);
}



function jsCall_di_15(a1) {
  a1=a1|0;
  return +jsCall_di(15,a1|0);
}



function jsCall_di_16(a1) {
  a1=a1|0;
  return +jsCall_di(16,a1|0);
}



function jsCall_di_17(a1) {
  a1=a1|0;
  return +jsCall_di(17,a1|0);
}



function jsCall_di_18(a1) {
  a1=a1|0;
  return +jsCall_di(18,a1|0);
}



function jsCall_di_19(a1) {
  a1=a1|0;
  return +jsCall_di(19,a1|0);
}



function jsCall_di_20(a1) {
  a1=a1|0;
  return +jsCall_di(20,a1|0);
}



function jsCall_di_21(a1) {
  a1=a1|0;
  return +jsCall_di(21,a1|0);
}



function jsCall_di_22(a1) {
  a1=a1|0;
  return +jsCall_di(22,a1|0);
}



function jsCall_di_23(a1) {
  a1=a1|0;
  return +jsCall_di(23,a1|0);
}



function jsCall_di_24(a1) {
  a1=a1|0;
  return +jsCall_di(24,a1|0);
}



function jsCall_di_25(a1) {
  a1=a1|0;
  return +jsCall_di(25,a1|0);
}



function jsCall_di_26(a1) {
  a1=a1|0;
  return +jsCall_di(26,a1|0);
}



function jsCall_di_27(a1) {
  a1=a1|0;
  return +jsCall_di(27,a1|0);
}



function jsCall_di_28(a1) {
  a1=a1|0;
  return +jsCall_di(28,a1|0);
}



function jsCall_di_29(a1) {
  a1=a1|0;
  return +jsCall_di(29,a1|0);
}



function jsCall_di_30(a1) {
  a1=a1|0;
  return +jsCall_di(30,a1|0);
}



function jsCall_di_31(a1) {
  a1=a1|0;
  return +jsCall_di(31,a1|0);
}



function jsCall_di_32(a1) {
  a1=a1|0;
  return +jsCall_di(32,a1|0);
}



function jsCall_di_33(a1) {
  a1=a1|0;
  return +jsCall_di(33,a1|0);
}



function jsCall_di_34(a1) {
  a1=a1|0;
  return +jsCall_di(34,a1|0);
}



function jsCall_di_35(a1) {
  a1=a1|0;
  return +jsCall_di(35,a1|0);
}



function jsCall_di_36(a1) {
  a1=a1|0;
  return +jsCall_di(36,a1|0);
}



function jsCall_di_37(a1) {
  a1=a1|0;
  return +jsCall_di(37,a1|0);
}



function jsCall_di_38(a1) {
  a1=a1|0;
  return +jsCall_di(38,a1|0);
}



function jsCall_di_39(a1) {
  a1=a1|0;
  return +jsCall_di(39,a1|0);
}



function jsCall_di_40(a1) {
  a1=a1|0;
  return +jsCall_di(40,a1|0);
}



function jsCall_di_41(a1) {
  a1=a1|0;
  return +jsCall_di(41,a1|0);
}



function jsCall_di_42(a1) {
  a1=a1|0;
  return +jsCall_di(42,a1|0);
}



function jsCall_di_43(a1) {
  a1=a1|0;
  return +jsCall_di(43,a1|0);
}



function jsCall_di_44(a1) {
  a1=a1|0;
  return +jsCall_di(44,a1|0);
}



function jsCall_di_45(a1) {
  a1=a1|0;
  return +jsCall_di(45,a1|0);
}



function jsCall_di_46(a1) {
  a1=a1|0;
  return +jsCall_di(46,a1|0);
}



function jsCall_di_47(a1) {
  a1=a1|0;
  return +jsCall_di(47,a1|0);
}



function jsCall_di_48(a1) {
  a1=a1|0;
  return +jsCall_di(48,a1|0);
}



function jsCall_di_49(a1) {
  a1=a1|0;
  return +jsCall_di(49,a1|0);
}



function jsCall_di_50(a1) {
  a1=a1|0;
  return +jsCall_di(50,a1|0);
}



function jsCall_di_51(a1) {
  a1=a1|0;
  return +jsCall_di(51,a1|0);
}



function jsCall_di_52(a1) {
  a1=a1|0;
  return +jsCall_di(52,a1|0);
}



function jsCall_di_53(a1) {
  a1=a1|0;
  return +jsCall_di(53,a1|0);
}



function jsCall_di_54(a1) {
  a1=a1|0;
  return +jsCall_di(54,a1|0);
}



function jsCall_di_55(a1) {
  a1=a1|0;
  return +jsCall_di(55,a1|0);
}



function jsCall_di_56(a1) {
  a1=a1|0;
  return +jsCall_di(56,a1|0);
}



function jsCall_di_57(a1) {
  a1=a1|0;
  return +jsCall_di(57,a1|0);
}



function jsCall_di_58(a1) {
  a1=a1|0;
  return +jsCall_di(58,a1|0);
}



function jsCall_di_59(a1) {
  a1=a1|0;
  return +jsCall_di(59,a1|0);
}



function jsCall_di_60(a1) {
  a1=a1|0;
  return +jsCall_di(60,a1|0);
}



function jsCall_di_61(a1) {
  a1=a1|0;
  return +jsCall_di(61,a1|0);
}



function jsCall_di_62(a1) {
  a1=a1|0;
  return +jsCall_di(62,a1|0);
}



function jsCall_di_63(a1) {
  a1=a1|0;
  return +jsCall_di(63,a1|0);
}



function dynCall_dii(index,a1,a2) {
  index = index|0;
  a1=a1|0; a2=a2|0;
  return +FUNCTION_TABLE_dii[index&127](a1|0,a2|0);
}


function jsCall_dii_0(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(0,a1|0,a2|0);
}



function jsCall_dii_1(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(1,a1|0,a2|0);
}



function jsCall_dii_2(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(2,a1|0,a2|0);
}



function jsCall_dii_3(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(3,a1|0,a2|0);
}



function jsCall_dii_4(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(4,a1|0,a2|0);
}



function jsCall_dii_5(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(5,a1|0,a2|0);
}



function jsCall_dii_6(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(6,a1|0,a2|0);
}



function jsCall_dii_7(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(7,a1|0,a2|0);
}



function jsCall_dii_8(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(8,a1|0,a2|0);
}



function jsCall_dii_9(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(9,a1|0,a2|0);
}



function jsCall_dii_10(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(10,a1|0,a2|0);
}



function jsCall_dii_11(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(11,a1|0,a2|0);
}



function jsCall_dii_12(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(12,a1|0,a2|0);
}



function jsCall_dii_13(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(13,a1|0,a2|0);
}



function jsCall_dii_14(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(14,a1|0,a2|0);
}



function jsCall_dii_15(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(15,a1|0,a2|0);
}



function jsCall_dii_16(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(16,a1|0,a2|0);
}



function jsCall_dii_17(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(17,a1|0,a2|0);
}



function jsCall_dii_18(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(18,a1|0,a2|0);
}



function jsCall_dii_19(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(19,a1|0,a2|0);
}



function jsCall_dii_20(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(20,a1|0,a2|0);
}



function jsCall_dii_21(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(21,a1|0,a2|0);
}



function jsCall_dii_22(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(22,a1|0,a2|0);
}



function jsCall_dii_23(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(23,a1|0,a2|0);
}



function jsCall_dii_24(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(24,a1|0,a2|0);
}



function jsCall_dii_25(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(25,a1|0,a2|0);
}



function jsCall_dii_26(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(26,a1|0,a2|0);
}



function jsCall_dii_27(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(27,a1|0,a2|0);
}



function jsCall_dii_28(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(28,a1|0,a2|0);
}



function jsCall_dii_29(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(29,a1|0,a2|0);
}



function jsCall_dii_30(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(30,a1|0,a2|0);
}



function jsCall_dii_31(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(31,a1|0,a2|0);
}



function jsCall_dii_32(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(32,a1|0,a2|0);
}



function jsCall_dii_33(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(33,a1|0,a2|0);
}



function jsCall_dii_34(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(34,a1|0,a2|0);
}



function jsCall_dii_35(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(35,a1|0,a2|0);
}



function jsCall_dii_36(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(36,a1|0,a2|0);
}



function jsCall_dii_37(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(37,a1|0,a2|0);
}



function jsCall_dii_38(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(38,a1|0,a2|0);
}



function jsCall_dii_39(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(39,a1|0,a2|0);
}



function jsCall_dii_40(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(40,a1|0,a2|0);
}



function jsCall_dii_41(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(41,a1|0,a2|0);
}



function jsCall_dii_42(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(42,a1|0,a2|0);
}



function jsCall_dii_43(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(43,a1|0,a2|0);
}



function jsCall_dii_44(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(44,a1|0,a2|0);
}



function jsCall_dii_45(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(45,a1|0,a2|0);
}



function jsCall_dii_46(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(46,a1|0,a2|0);
}



function jsCall_dii_47(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(47,a1|0,a2|0);
}



function jsCall_dii_48(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(48,a1|0,a2|0);
}



function jsCall_dii_49(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(49,a1|0,a2|0);
}



function jsCall_dii_50(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(50,a1|0,a2|0);
}



function jsCall_dii_51(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(51,a1|0,a2|0);
}



function jsCall_dii_52(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(52,a1|0,a2|0);
}



function jsCall_dii_53(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(53,a1|0,a2|0);
}



function jsCall_dii_54(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(54,a1|0,a2|0);
}



function jsCall_dii_55(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(55,a1|0,a2|0);
}



function jsCall_dii_56(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(56,a1|0,a2|0);
}



function jsCall_dii_57(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(57,a1|0,a2|0);
}



function jsCall_dii_58(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(58,a1|0,a2|0);
}



function jsCall_dii_59(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(59,a1|0,a2|0);
}



function jsCall_dii_60(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(60,a1|0,a2|0);
}



function jsCall_dii_61(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(61,a1|0,a2|0);
}



function jsCall_dii_62(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(62,a1|0,a2|0);
}



function jsCall_dii_63(a1,a2) {
  a1=a1|0; a2=a2|0;
  return +jsCall_dii(63,a1|0,a2|0);
}



function dynCall_i(index) {
  index = index|0;
  
  return FUNCTION_TABLE_i[index&127]()|0;
}


function jsCall_i_0() {
  
  return jsCall_i(0)|0;
}



function jsCall_i_1() {
  
  return jsCall_i(1)|0;
}



function jsCall_i_2() {
  
  return jsCall_i(2)|0;
}



function jsCall_i_3() {
  
  return jsCall_i(3)|0;
}



function jsCall_i_4() {
  
  return jsCall_i(4)|0;
}



function jsCall_i_5() {
  
  return jsCall_i(5)|0;
}



function jsCall_i_6() {
  
  return jsCall_i(6)|0;
}



function jsCall_i_7() {
  
  return jsCall_i(7)|0;
}



function jsCall_i_8() {
  
  return jsCall_i(8)|0;
}



function jsCall_i_9() {
  
  return jsCall_i(9)|0;
}



function jsCall_i_10() {
  
  return jsCall_i(10)|0;
}



function jsCall_i_11() {
  
  return jsCall_i(11)|0;
}



function jsCall_i_12() {
  
  return jsCall_i(12)|0;
}



function jsCall_i_13() {
  
  return jsCall_i(13)|0;
}



function jsCall_i_14() {
  
  return jsCall_i(14)|0;
}



function jsCall_i_15() {
  
  return jsCall_i(15)|0;
}



function jsCall_i_16() {
  
  return jsCall_i(16)|0;
}



function jsCall_i_17() {
  
  return jsCall_i(17)|0;
}



function jsCall_i_18() {
  
  return jsCall_i(18)|0;
}



function jsCall_i_19() {
  
  return jsCall_i(19)|0;
}



function jsCall_i_20() {
  
  return jsCall_i(20)|0;
}



function jsCall_i_21() {
  
  return jsCall_i(21)|0;
}



function jsCall_i_22() {
  
  return jsCall_i(22)|0;
}



function jsCall_i_23() {
  
  return jsCall_i(23)|0;
}



function jsCall_i_24() {
  
  return jsCall_i(24)|0;
}



function jsCall_i_25() {
  
  return jsCall_i(25)|0;
}



function jsCall_i_26() {
  
  return jsCall_i(26)|0;
}



function jsCall_i_27() {
  
  return jsCall_i(27)|0;
}



function jsCall_i_28() {
  
  return jsCall_i(28)|0;
}



function jsCall_i_29() {
  
  return jsCall_i(29)|0;
}



function jsCall_i_30() {
  
  return jsCall_i(30)|0;
}



function jsCall_i_31() {
  
  return jsCall_i(31)|0;
}



function jsCall_i_32() {
  
  return jsCall_i(32)|0;
}



function jsCall_i_33() {
  
  return jsCall_i(33)|0;
}



function jsCall_i_34() {
  
  return jsCall_i(34)|0;
}



function jsCall_i_35() {
  
  return jsCall_i(35)|0;
}



function jsCall_i_36() {
  
  return jsCall_i(36)|0;
}



function jsCall_i_37() {
  
  return jsCall_i(37)|0;
}



function jsCall_i_38() {
  
  return jsCall_i(38)|0;
}



function jsCall_i_39() {
  
  return jsCall_i(39)|0;
}



function jsCall_i_40() {
  
  return jsCall_i(40)|0;
}



function jsCall_i_41() {
  
  return jsCall_i(41)|0;
}



function jsCall_i_42() {
  
  return jsCall_i(42)|0;
}



function jsCall_i_43() {
  
  return jsCall_i(43)|0;
}



function jsCall_i_44() {
  
  return jsCall_i(44)|0;
}



function jsCall_i_45() {
  
  return jsCall_i(45)|0;
}



function jsCall_i_46() {
  
  return jsCall_i(46)|0;
}



function jsCall_i_47() {
  
  return jsCall_i(47)|0;
}



function jsCall_i_48() {
  
  return jsCall_i(48)|0;
}



function jsCall_i_49() {
  
  return jsCall_i(49)|0;
}



function jsCall_i_50() {
  
  return jsCall_i(50)|0;
}



function jsCall_i_51() {
  
  return jsCall_i(51)|0;
}



function jsCall_i_52() {
  
  return jsCall_i(52)|0;
}



function jsCall_i_53() {
  
  return jsCall_i(53)|0;
}



function jsCall_i_54() {
  
  return jsCall_i(54)|0;
}



function jsCall_i_55() {
  
  return jsCall_i(55)|0;
}



function jsCall_i_56() {
  
  return jsCall_i(56)|0;
}



function jsCall_i_57() {
  
  return jsCall_i(57)|0;
}



function jsCall_i_58() {
  
  return jsCall_i(58)|0;
}



function jsCall_i_59() {
  
  return jsCall_i(59)|0;
}



function jsCall_i_60() {
  
  return jsCall_i(60)|0;
}



function jsCall_i_61() {
  
  return jsCall_i(61)|0;
}



function jsCall_i_62() {
  
  return jsCall_i(62)|0;
}



function jsCall_i_63() {
  
  return jsCall_i(63)|0;
}



function dynCall_ii(index,a1) {
  index = index|0;
  a1=a1|0;
  return FUNCTION_TABLE_ii[index&255](a1|0)|0;
}


function jsCall_ii_0(a1) {
  a1=a1|0;
  return jsCall_ii(0,a1|0)|0;
}



function jsCall_ii_1(a1) {
  a1=a1|0;
  return jsCall_ii(1,a1|0)|0;
}



function jsCall_ii_2(a1) {
  a1=a1|0;
  return jsCall_ii(2,a1|0)|0;
}



function jsCall_ii_3(a1) {
  a1=a1|0;
  return jsCall_ii(3,a1|0)|0;
}



function jsCall_ii_4(a1) {
  a1=a1|0;
  return jsCall_ii(4,a1|0)|0;
}



function jsCall_ii_5(a1) {
  a1=a1|0;
  return jsCall_ii(5,a1|0)|0;
}



function jsCall_ii_6(a1) {
  a1=a1|0;
  return jsCall_ii(6,a1|0)|0;
}



function jsCall_ii_7(a1) {
  a1=a1|0;
  return jsCall_ii(7,a1|0)|0;
}



function jsCall_ii_8(a1) {
  a1=a1|0;
  return jsCall_ii(8,a1|0)|0;
}



function jsCall_ii_9(a1) {
  a1=a1|0;
  return jsCall_ii(9,a1|0)|0;
}



function jsCall_ii_10(a1) {
  a1=a1|0;
  return jsCall_ii(10,a1|0)|0;
}



function jsCall_ii_11(a1) {
  a1=a1|0;
  return jsCall_ii(11,a1|0)|0;
}



function jsCall_ii_12(a1) {
  a1=a1|0;
  return jsCall_ii(12,a1|0)|0;
}



function jsCall_ii_13(a1) {
  a1=a1|0;
  return jsCall_ii(13,a1|0)|0;
}



function jsCall_ii_14(a1) {
  a1=a1|0;
  return jsCall_ii(14,a1|0)|0;
}



function jsCall_ii_15(a1) {
  a1=a1|0;
  return jsCall_ii(15,a1|0)|0;
}



function jsCall_ii_16(a1) {
  a1=a1|0;
  return jsCall_ii(16,a1|0)|0;
}



function jsCall_ii_17(a1) {
  a1=a1|0;
  return jsCall_ii(17,a1|0)|0;
}



function jsCall_ii_18(a1) {
  a1=a1|0;
  return jsCall_ii(18,a1|0)|0;
}



function jsCall_ii_19(a1) {
  a1=a1|0;
  return jsCall_ii(19,a1|0)|0;
}



function jsCall_ii_20(a1) {
  a1=a1|0;
  return jsCall_ii(20,a1|0)|0;
}



function jsCall_ii_21(a1) {
  a1=a1|0;
  return jsCall_ii(21,a1|0)|0;
}



function jsCall_ii_22(a1) {
  a1=a1|0;
  return jsCall_ii(22,a1|0)|0;
}



function jsCall_ii_23(a1) {
  a1=a1|0;
  return jsCall_ii(23,a1|0)|0;
}



function jsCall_ii_24(a1) {
  a1=a1|0;
  return jsCall_ii(24,a1|0)|0;
}



function jsCall_ii_25(a1) {
  a1=a1|0;
  return jsCall_ii(25,a1|0)|0;
}



function jsCall_ii_26(a1) {
  a1=a1|0;
  return jsCall_ii(26,a1|0)|0;
}



function jsCall_ii_27(a1) {
  a1=a1|0;
  return jsCall_ii(27,a1|0)|0;
}



function jsCall_ii_28(a1) {
  a1=a1|0;
  return jsCall_ii(28,a1|0)|0;
}



function jsCall_ii_29(a1) {
  a1=a1|0;
  return jsCall_ii(29,a1|0)|0;
}



function jsCall_ii_30(a1) {
  a1=a1|0;
  return jsCall_ii(30,a1|0)|0;
}



function jsCall_ii_31(a1) {
  a1=a1|0;
  return jsCall_ii(31,a1|0)|0;
}



function jsCall_ii_32(a1) {
  a1=a1|0;
  return jsCall_ii(32,a1|0)|0;
}



function jsCall_ii_33(a1) {
  a1=a1|0;
  return jsCall_ii(33,a1|0)|0;
}



function jsCall_ii_34(a1) {
  a1=a1|0;
  return jsCall_ii(34,a1|0)|0;
}



function jsCall_ii_35(a1) {
  a1=a1|0;
  return jsCall_ii(35,a1|0)|0;
}



function jsCall_ii_36(a1) {
  a1=a1|0;
  return jsCall_ii(36,a1|0)|0;
}



function jsCall_ii_37(a1) {
  a1=a1|0;
  return jsCall_ii(37,a1|0)|0;
}



function jsCall_ii_38(a1) {
  a1=a1|0;
  return jsCall_ii(38,a1|0)|0;
}



function jsCall_ii_39(a1) {
  a1=a1|0;
  return jsCall_ii(39,a1|0)|0;
}



function jsCall_ii_40(a1) {
  a1=a1|0;
  return jsCall_ii(40,a1|0)|0;
}



function jsCall_ii_41(a1) {
  a1=a1|0;
  return jsCall_ii(41,a1|0)|0;
}



function jsCall_ii_42(a1) {
  a1=a1|0;
  return jsCall_ii(42,a1|0)|0;
}



function jsCall_ii_43(a1) {
  a1=a1|0;
  return jsCall_ii(43,a1|0)|0;
}



function jsCall_ii_44(a1) {
  a1=a1|0;
  return jsCall_ii(44,a1|0)|0;
}



function jsCall_ii_45(a1) {
  a1=a1|0;
  return jsCall_ii(45,a1|0)|0;
}



function jsCall_ii_46(a1) {
  a1=a1|0;
  return jsCall_ii(46,a1|0)|0;
}



function jsCall_ii_47(a1) {
  a1=a1|0;
  return jsCall_ii(47,a1|0)|0;
}



function jsCall_ii_48(a1) {
  a1=a1|0;
  return jsCall_ii(48,a1|0)|0;
}



function jsCall_ii_49(a1) {
  a1=a1|0;
  return jsCall_ii(49,a1|0)|0;
}



function jsCall_ii_50(a1) {
  a1=a1|0;
  return jsCall_ii(50,a1|0)|0;
}



function jsCall_ii_51(a1) {
  a1=a1|0;
  return jsCall_ii(51,a1|0)|0;
}



function jsCall_ii_52(a1) {
  a1=a1|0;
  return jsCall_ii(52,a1|0)|0;
}



function jsCall_ii_53(a1) {
  a1=a1|0;
  return jsCall_ii(53,a1|0)|0;
}



function jsCall_ii_54(a1) {
  a1=a1|0;
  return jsCall_ii(54,a1|0)|0;
}



function jsCall_ii_55(a1) {
  a1=a1|0;
  return jsCall_ii(55,a1|0)|0;
}



function jsCall_ii_56(a1) {
  a1=a1|0;
  return jsCall_ii(56,a1|0)|0;
}



function jsCall_ii_57(a1) {
  a1=a1|0;
  return jsCall_ii(57,a1|0)|0;
}



function jsCall_ii_58(a1) {
  a1=a1|0;
  return jsCall_ii(58,a1|0)|0;
}



function jsCall_ii_59(a1) {
  a1=a1|0;
  return jsCall_ii(59,a1|0)|0;
}



function jsCall_ii_60(a1) {
  a1=a1|0;
  return jsCall_ii(60,a1|0)|0;
}



function jsCall_ii_61(a1) {
  a1=a1|0;
  return jsCall_ii(61,a1|0)|0;
}



function jsCall_ii_62(a1) {
  a1=a1|0;
  return jsCall_ii(62,a1|0)|0;
}



function jsCall_ii_63(a1) {
  a1=a1|0;
  return jsCall_ii(63,a1|0)|0;
}



function dynCall_iii(index,a1,a2) {
  index = index|0;
  a1=a1|0; a2=a2|0;
  return FUNCTION_TABLE_iii[index&255](a1|0,a2|0)|0;
}


function jsCall_iii_0(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(0,a1|0,a2|0)|0;
}



function jsCall_iii_1(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(1,a1|0,a2|0)|0;
}



function jsCall_iii_2(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(2,a1|0,a2|0)|0;
}



function jsCall_iii_3(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(3,a1|0,a2|0)|0;
}



function jsCall_iii_4(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(4,a1|0,a2|0)|0;
}



function jsCall_iii_5(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(5,a1|0,a2|0)|0;
}



function jsCall_iii_6(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(6,a1|0,a2|0)|0;
}



function jsCall_iii_7(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(7,a1|0,a2|0)|0;
}



function jsCall_iii_8(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(8,a1|0,a2|0)|0;
}



function jsCall_iii_9(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(9,a1|0,a2|0)|0;
}



function jsCall_iii_10(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(10,a1|0,a2|0)|0;
}



function jsCall_iii_11(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(11,a1|0,a2|0)|0;
}



function jsCall_iii_12(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(12,a1|0,a2|0)|0;
}



function jsCall_iii_13(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(13,a1|0,a2|0)|0;
}



function jsCall_iii_14(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(14,a1|0,a2|0)|0;
}



function jsCall_iii_15(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(15,a1|0,a2|0)|0;
}



function jsCall_iii_16(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(16,a1|0,a2|0)|0;
}



function jsCall_iii_17(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(17,a1|0,a2|0)|0;
}



function jsCall_iii_18(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(18,a1|0,a2|0)|0;
}



function jsCall_iii_19(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(19,a1|0,a2|0)|0;
}



function jsCall_iii_20(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(20,a1|0,a2|0)|0;
}



function jsCall_iii_21(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(21,a1|0,a2|0)|0;
}



function jsCall_iii_22(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(22,a1|0,a2|0)|0;
}



function jsCall_iii_23(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(23,a1|0,a2|0)|0;
}



function jsCall_iii_24(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(24,a1|0,a2|0)|0;
}



function jsCall_iii_25(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(25,a1|0,a2|0)|0;
}



function jsCall_iii_26(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(26,a1|0,a2|0)|0;
}



function jsCall_iii_27(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(27,a1|0,a2|0)|0;
}



function jsCall_iii_28(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(28,a1|0,a2|0)|0;
}



function jsCall_iii_29(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(29,a1|0,a2|0)|0;
}



function jsCall_iii_30(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(30,a1|0,a2|0)|0;
}



function jsCall_iii_31(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(31,a1|0,a2|0)|0;
}



function jsCall_iii_32(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(32,a1|0,a2|0)|0;
}



function jsCall_iii_33(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(33,a1|0,a2|0)|0;
}



function jsCall_iii_34(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(34,a1|0,a2|0)|0;
}



function jsCall_iii_35(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(35,a1|0,a2|0)|0;
}



function jsCall_iii_36(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(36,a1|0,a2|0)|0;
}



function jsCall_iii_37(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(37,a1|0,a2|0)|0;
}



function jsCall_iii_38(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(38,a1|0,a2|0)|0;
}



function jsCall_iii_39(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(39,a1|0,a2|0)|0;
}



function jsCall_iii_40(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(40,a1|0,a2|0)|0;
}



function jsCall_iii_41(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(41,a1|0,a2|0)|0;
}



function jsCall_iii_42(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(42,a1|0,a2|0)|0;
}



function jsCall_iii_43(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(43,a1|0,a2|0)|0;
}



function jsCall_iii_44(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(44,a1|0,a2|0)|0;
}



function jsCall_iii_45(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(45,a1|0,a2|0)|0;
}



function jsCall_iii_46(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(46,a1|0,a2|0)|0;
}



function jsCall_iii_47(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(47,a1|0,a2|0)|0;
}



function jsCall_iii_48(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(48,a1|0,a2|0)|0;
}



function jsCall_iii_49(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(49,a1|0,a2|0)|0;
}



function jsCall_iii_50(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(50,a1|0,a2|0)|0;
}



function jsCall_iii_51(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(51,a1|0,a2|0)|0;
}



function jsCall_iii_52(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(52,a1|0,a2|0)|0;
}



function jsCall_iii_53(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(53,a1|0,a2|0)|0;
}



function jsCall_iii_54(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(54,a1|0,a2|0)|0;
}



function jsCall_iii_55(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(55,a1|0,a2|0)|0;
}



function jsCall_iii_56(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(56,a1|0,a2|0)|0;
}



function jsCall_iii_57(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(57,a1|0,a2|0)|0;
}



function jsCall_iii_58(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(58,a1|0,a2|0)|0;
}



function jsCall_iii_59(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(59,a1|0,a2|0)|0;
}



function jsCall_iii_60(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(60,a1|0,a2|0)|0;
}



function jsCall_iii_61(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(61,a1|0,a2|0)|0;
}



function jsCall_iii_62(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(62,a1|0,a2|0)|0;
}



function jsCall_iii_63(a1,a2) {
  a1=a1|0; a2=a2|0;
  return jsCall_iii(63,a1|0,a2|0)|0;
}



function dynCall_iiid(index,a1,a2,a3) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=+a3;
  return FUNCTION_TABLE_iiid[index&127](a1|0,a2|0,+a3)|0;
}


function jsCall_iiid_0(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(0,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_1(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(1,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_2(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(2,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_3(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(3,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_4(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(4,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_5(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(5,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_6(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(6,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_7(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(7,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_8(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(8,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_9(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(9,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_10(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(10,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_11(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(11,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_12(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(12,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_13(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(13,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_14(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(14,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_15(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(15,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_16(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(16,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_17(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(17,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_18(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(18,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_19(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(19,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_20(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(20,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_21(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(21,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_22(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(22,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_23(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(23,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_24(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(24,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_25(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(25,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_26(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(26,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_27(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(27,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_28(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(28,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_29(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(29,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_30(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(30,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_31(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(31,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_32(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(32,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_33(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(33,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_34(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(34,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_35(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(35,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_36(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(36,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_37(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(37,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_38(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(38,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_39(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(39,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_40(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(40,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_41(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(41,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_42(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(42,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_43(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(43,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_44(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(44,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_45(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(45,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_46(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(46,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_47(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(47,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_48(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(48,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_49(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(49,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_50(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(50,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_51(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(51,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_52(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(52,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_53(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(53,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_54(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(54,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_55(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(55,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_56(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(56,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_57(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(57,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_58(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(58,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_59(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(59,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_60(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(60,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_61(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(61,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_62(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(62,a1|0,a2|0,+a3)|0;
}



function jsCall_iiid_63(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=+a3;
  return jsCall_iiid(63,a1|0,a2|0,+a3)|0;
}



function dynCall_iiii(index,a1,a2,a3) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0;
  return FUNCTION_TABLE_iiii[index&127](a1|0,a2|0,a3|0)|0;
}


function jsCall_iiii_0(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(0,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_1(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(1,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_2(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(2,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_3(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(3,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_4(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(4,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_5(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(5,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_6(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(6,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_7(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(7,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_8(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(8,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_9(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(9,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_10(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(10,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_11(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(11,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_12(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(12,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_13(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(13,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_14(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(14,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_15(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(15,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_16(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(16,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_17(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(17,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_18(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(18,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_19(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(19,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_20(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(20,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_21(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(21,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_22(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(22,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_23(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(23,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_24(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(24,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_25(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(25,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_26(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(26,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_27(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(27,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_28(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(28,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_29(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(29,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_30(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(30,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_31(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(31,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_32(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(32,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_33(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(33,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_34(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(34,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_35(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(35,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_36(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(36,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_37(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(37,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_38(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(38,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_39(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(39,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_40(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(40,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_41(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(41,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_42(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(42,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_43(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(43,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_44(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(44,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_45(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(45,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_46(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(46,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_47(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(47,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_48(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(48,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_49(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(49,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_50(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(50,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_51(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(51,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_52(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(52,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_53(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(53,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_54(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(54,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_55(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(55,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_56(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(56,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_57(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(57,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_58(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(58,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_59(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(59,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_60(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(60,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_61(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(61,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_62(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(62,a1|0,a2|0,a3|0)|0;
}



function jsCall_iiii_63(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  return jsCall_iiii(63,a1|0,a2|0,a3|0)|0;
}



function dynCall_iiiii(index,a1,a2,a3,a4) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return FUNCTION_TABLE_iiiii[index&127](a1|0,a2|0,a3|0,a4|0)|0;
}


function jsCall_iiiii_0(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(0,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_1(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(1,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_2(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(2,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_3(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(3,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_4(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(4,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_5(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(5,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_6(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(6,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_7(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(7,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_8(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(8,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_9(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(9,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_10(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(10,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_11(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(11,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_12(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(12,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_13(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(13,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_14(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(14,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_15(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(15,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_16(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(16,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_17(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(17,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_18(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(18,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_19(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(19,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_20(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(20,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_21(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(21,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_22(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(22,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_23(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(23,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_24(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(24,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_25(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(25,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_26(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(26,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_27(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(27,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_28(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(28,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_29(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(29,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_30(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(30,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_31(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(31,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_32(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(32,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_33(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(33,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_34(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(34,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_35(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(35,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_36(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(36,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_37(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(37,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_38(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(38,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_39(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(39,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_40(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(40,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_41(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(41,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_42(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(42,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_43(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(43,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_44(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(44,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_45(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(45,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_46(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(46,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_47(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(47,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_48(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(48,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_49(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(49,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_50(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(50,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_51(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(51,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_52(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(52,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_53(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(53,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_54(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(54,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_55(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(55,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_56(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(56,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_57(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(57,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_58(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(58,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_59(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(59,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_60(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(60,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_61(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(61,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_62(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(62,a1|0,a2|0,a3|0,a4|0)|0;
}



function jsCall_iiiii_63(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return jsCall_iiiii(63,a1|0,a2|0,a3|0,a4|0)|0;
}



function dynCall_iiiiii(index,a1,a2,a3,a4,a5) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return FUNCTION_TABLE_iiiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}


function jsCall_iiiiii_0(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_1(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_2(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_3(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_4(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_5(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_6(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_7(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_8(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_9(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_10(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_11(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_12(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_13(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_14(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_15(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_16(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_17(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_18(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_19(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_20(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_21(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_22(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_23(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_24(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_25(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_26(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_27(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_28(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_29(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_30(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_31(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_32(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_33(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_34(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_35(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_36(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_37(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_38(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_39(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_40(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_41(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_42(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_43(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_44(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_45(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_46(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_47(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_48(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_49(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_50(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_51(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_52(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_53(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_54(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_55(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_56(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_57(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_58(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_59(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_60(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_61(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_62(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function jsCall_iiiiii_63(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  return jsCall_iiiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0)|0;
}



function dynCall_iiiiiii(index,a1,a2,a3,a4,a5,a6) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return FUNCTION_TABLE_iiiiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}


function jsCall_iiiiiii_0(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_1(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_2(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_3(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_4(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_5(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_6(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_7(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_8(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_9(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_10(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_11(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_12(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_13(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_14(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_15(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_16(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_17(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_18(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_19(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_20(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_21(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_22(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_23(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_24(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_25(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_26(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_27(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_28(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_29(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_30(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_31(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_32(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_33(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_34(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_35(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_36(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_37(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_38(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_39(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_40(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_41(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_42(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_43(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_44(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_45(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_46(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_47(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_48(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_49(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_50(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_51(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_52(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_53(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_54(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_55(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_56(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_57(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_58(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_59(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_60(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_61(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_62(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function jsCall_iiiiiii_63(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  return jsCall_iiiiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0)|0;
}



function dynCall_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return FUNCTION_TABLE_iiiiiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}


function jsCall_iiiiiiii_0(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_1(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_2(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_3(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_4(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_5(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_6(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_7(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_8(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_9(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_10(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_11(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_12(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_13(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_14(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_15(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_16(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_17(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_18(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_19(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_20(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_21(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_22(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_23(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_24(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_25(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_26(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_27(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_28(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_29(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_30(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_31(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_32(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_33(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_34(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_35(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_36(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_37(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_38(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_39(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_40(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_41(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_42(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_43(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_44(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_45(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_46(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_47(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_48(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_49(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_50(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_51(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_52(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_53(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_54(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_55(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_56(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_57(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_58(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_59(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_60(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_61(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_62(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function jsCall_iiiiiiii_63(a1,a2,a3,a4,a5,a6,a7) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0;
  return jsCall_iiiiiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0)|0;
}



function dynCall_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return FUNCTION_TABLE_iiiiiiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}


function jsCall_iiiiiiiii_0(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_1(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_2(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_3(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_4(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_5(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_6(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_7(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_8(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_9(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_10(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_11(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_12(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_13(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_14(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_15(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_16(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_17(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_18(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_19(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_20(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_21(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_22(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_23(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_24(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_25(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_26(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_27(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_28(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_29(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_30(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_31(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_32(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_33(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_34(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_35(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_36(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_37(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_38(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_39(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_40(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_41(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_42(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_43(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_44(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_45(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_46(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_47(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_48(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_49(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_50(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_51(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_52(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_53(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_54(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_55(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_56(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_57(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_58(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_59(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_60(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_61(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_62(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function jsCall_iiiiiiiii_63(a1,a2,a3,a4,a5,a6,a7,a8) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0;
  return jsCall_iiiiiiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0)|0;
}



function dynCall_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return FUNCTION_TABLE_iiiiiiiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}


function jsCall_iiiiiiiiii_0(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_1(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_2(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_3(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_4(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_5(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_6(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_7(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_8(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_9(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_10(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_11(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_12(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_13(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_14(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_15(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_16(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_17(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_18(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_19(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_20(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_21(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_22(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_23(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_24(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_25(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_26(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_27(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_28(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_29(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_30(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_31(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_32(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_33(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_34(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_35(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_36(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_37(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_38(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_39(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_40(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_41(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_42(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_43(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_44(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_45(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_46(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_47(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_48(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_49(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_50(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_51(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_52(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_53(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_54(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_55(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_56(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_57(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_58(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_59(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_60(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_61(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_62(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function jsCall_iiiiiiiiii_63(a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0; a7=a7|0; a8=a8|0; a9=a9|0;
  return jsCall_iiiiiiiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0,a7|0,a8|0,a9|0)|0;
}



function dynCall_v(index) {
  index = index|0;
  
  FUNCTION_TABLE_v[index&127]();
}


function jsCall_v_0() {
  
  jsCall_v(0);
}



function jsCall_v_1() {
  
  jsCall_v(1);
}



function jsCall_v_2() {
  
  jsCall_v(2);
}



function jsCall_v_3() {
  
  jsCall_v(3);
}



function jsCall_v_4() {
  
  jsCall_v(4);
}



function jsCall_v_5() {
  
  jsCall_v(5);
}



function jsCall_v_6() {
  
  jsCall_v(6);
}



function jsCall_v_7() {
  
  jsCall_v(7);
}



function jsCall_v_8() {
  
  jsCall_v(8);
}



function jsCall_v_9() {
  
  jsCall_v(9);
}



function jsCall_v_10() {
  
  jsCall_v(10);
}



function jsCall_v_11() {
  
  jsCall_v(11);
}



function jsCall_v_12() {
  
  jsCall_v(12);
}



function jsCall_v_13() {
  
  jsCall_v(13);
}



function jsCall_v_14() {
  
  jsCall_v(14);
}



function jsCall_v_15() {
  
  jsCall_v(15);
}



function jsCall_v_16() {
  
  jsCall_v(16);
}



function jsCall_v_17() {
  
  jsCall_v(17);
}



function jsCall_v_18() {
  
  jsCall_v(18);
}



function jsCall_v_19() {
  
  jsCall_v(19);
}



function jsCall_v_20() {
  
  jsCall_v(20);
}



function jsCall_v_21() {
  
  jsCall_v(21);
}



function jsCall_v_22() {
  
  jsCall_v(22);
}



function jsCall_v_23() {
  
  jsCall_v(23);
}



function jsCall_v_24() {
  
  jsCall_v(24);
}



function jsCall_v_25() {
  
  jsCall_v(25);
}



function jsCall_v_26() {
  
  jsCall_v(26);
}



function jsCall_v_27() {
  
  jsCall_v(27);
}



function jsCall_v_28() {
  
  jsCall_v(28);
}



function jsCall_v_29() {
  
  jsCall_v(29);
}



function jsCall_v_30() {
  
  jsCall_v(30);
}



function jsCall_v_31() {
  
  jsCall_v(31);
}



function jsCall_v_32() {
  
  jsCall_v(32);
}



function jsCall_v_33() {
  
  jsCall_v(33);
}



function jsCall_v_34() {
  
  jsCall_v(34);
}



function jsCall_v_35() {
  
  jsCall_v(35);
}



function jsCall_v_36() {
  
  jsCall_v(36);
}



function jsCall_v_37() {
  
  jsCall_v(37);
}



function jsCall_v_38() {
  
  jsCall_v(38);
}



function jsCall_v_39() {
  
  jsCall_v(39);
}



function jsCall_v_40() {
  
  jsCall_v(40);
}



function jsCall_v_41() {
  
  jsCall_v(41);
}



function jsCall_v_42() {
  
  jsCall_v(42);
}



function jsCall_v_43() {
  
  jsCall_v(43);
}



function jsCall_v_44() {
  
  jsCall_v(44);
}



function jsCall_v_45() {
  
  jsCall_v(45);
}



function jsCall_v_46() {
  
  jsCall_v(46);
}



function jsCall_v_47() {
  
  jsCall_v(47);
}



function jsCall_v_48() {
  
  jsCall_v(48);
}



function jsCall_v_49() {
  
  jsCall_v(49);
}



function jsCall_v_50() {
  
  jsCall_v(50);
}



function jsCall_v_51() {
  
  jsCall_v(51);
}



function jsCall_v_52() {
  
  jsCall_v(52);
}



function jsCall_v_53() {
  
  jsCall_v(53);
}



function jsCall_v_54() {
  
  jsCall_v(54);
}



function jsCall_v_55() {
  
  jsCall_v(55);
}



function jsCall_v_56() {
  
  jsCall_v(56);
}



function jsCall_v_57() {
  
  jsCall_v(57);
}



function jsCall_v_58() {
  
  jsCall_v(58);
}



function jsCall_v_59() {
  
  jsCall_v(59);
}



function jsCall_v_60() {
  
  jsCall_v(60);
}



function jsCall_v_61() {
  
  jsCall_v(61);
}



function jsCall_v_62() {
  
  jsCall_v(62);
}



function jsCall_v_63() {
  
  jsCall_v(63);
}



function dynCall_vi(index,a1) {
  index = index|0;
  a1=a1|0;
  FUNCTION_TABLE_vi[index&127](a1|0);
}


function jsCall_vi_0(a1) {
  a1=a1|0;
  jsCall_vi(0,a1|0);
}



function jsCall_vi_1(a1) {
  a1=a1|0;
  jsCall_vi(1,a1|0);
}



function jsCall_vi_2(a1) {
  a1=a1|0;
  jsCall_vi(2,a1|0);
}



function jsCall_vi_3(a1) {
  a1=a1|0;
  jsCall_vi(3,a1|0);
}



function jsCall_vi_4(a1) {
  a1=a1|0;
  jsCall_vi(4,a1|0);
}



function jsCall_vi_5(a1) {
  a1=a1|0;
  jsCall_vi(5,a1|0);
}



function jsCall_vi_6(a1) {
  a1=a1|0;
  jsCall_vi(6,a1|0);
}



function jsCall_vi_7(a1) {
  a1=a1|0;
  jsCall_vi(7,a1|0);
}



function jsCall_vi_8(a1) {
  a1=a1|0;
  jsCall_vi(8,a1|0);
}



function jsCall_vi_9(a1) {
  a1=a1|0;
  jsCall_vi(9,a1|0);
}



function jsCall_vi_10(a1) {
  a1=a1|0;
  jsCall_vi(10,a1|0);
}



function jsCall_vi_11(a1) {
  a1=a1|0;
  jsCall_vi(11,a1|0);
}



function jsCall_vi_12(a1) {
  a1=a1|0;
  jsCall_vi(12,a1|0);
}



function jsCall_vi_13(a1) {
  a1=a1|0;
  jsCall_vi(13,a1|0);
}



function jsCall_vi_14(a1) {
  a1=a1|0;
  jsCall_vi(14,a1|0);
}



function jsCall_vi_15(a1) {
  a1=a1|0;
  jsCall_vi(15,a1|0);
}



function jsCall_vi_16(a1) {
  a1=a1|0;
  jsCall_vi(16,a1|0);
}



function jsCall_vi_17(a1) {
  a1=a1|0;
  jsCall_vi(17,a1|0);
}



function jsCall_vi_18(a1) {
  a1=a1|0;
  jsCall_vi(18,a1|0);
}



function jsCall_vi_19(a1) {
  a1=a1|0;
  jsCall_vi(19,a1|0);
}



function jsCall_vi_20(a1) {
  a1=a1|0;
  jsCall_vi(20,a1|0);
}



function jsCall_vi_21(a1) {
  a1=a1|0;
  jsCall_vi(21,a1|0);
}



function jsCall_vi_22(a1) {
  a1=a1|0;
  jsCall_vi(22,a1|0);
}



function jsCall_vi_23(a1) {
  a1=a1|0;
  jsCall_vi(23,a1|0);
}



function jsCall_vi_24(a1) {
  a1=a1|0;
  jsCall_vi(24,a1|0);
}



function jsCall_vi_25(a1) {
  a1=a1|0;
  jsCall_vi(25,a1|0);
}



function jsCall_vi_26(a1) {
  a1=a1|0;
  jsCall_vi(26,a1|0);
}



function jsCall_vi_27(a1) {
  a1=a1|0;
  jsCall_vi(27,a1|0);
}



function jsCall_vi_28(a1) {
  a1=a1|0;
  jsCall_vi(28,a1|0);
}



function jsCall_vi_29(a1) {
  a1=a1|0;
  jsCall_vi(29,a1|0);
}



function jsCall_vi_30(a1) {
  a1=a1|0;
  jsCall_vi(30,a1|0);
}



function jsCall_vi_31(a1) {
  a1=a1|0;
  jsCall_vi(31,a1|0);
}



function jsCall_vi_32(a1) {
  a1=a1|0;
  jsCall_vi(32,a1|0);
}



function jsCall_vi_33(a1) {
  a1=a1|0;
  jsCall_vi(33,a1|0);
}



function jsCall_vi_34(a1) {
  a1=a1|0;
  jsCall_vi(34,a1|0);
}



function jsCall_vi_35(a1) {
  a1=a1|0;
  jsCall_vi(35,a1|0);
}



function jsCall_vi_36(a1) {
  a1=a1|0;
  jsCall_vi(36,a1|0);
}



function jsCall_vi_37(a1) {
  a1=a1|0;
  jsCall_vi(37,a1|0);
}



function jsCall_vi_38(a1) {
  a1=a1|0;
  jsCall_vi(38,a1|0);
}



function jsCall_vi_39(a1) {
  a1=a1|0;
  jsCall_vi(39,a1|0);
}



function jsCall_vi_40(a1) {
  a1=a1|0;
  jsCall_vi(40,a1|0);
}



function jsCall_vi_41(a1) {
  a1=a1|0;
  jsCall_vi(41,a1|0);
}



function jsCall_vi_42(a1) {
  a1=a1|0;
  jsCall_vi(42,a1|0);
}



function jsCall_vi_43(a1) {
  a1=a1|0;
  jsCall_vi(43,a1|0);
}



function jsCall_vi_44(a1) {
  a1=a1|0;
  jsCall_vi(44,a1|0);
}



function jsCall_vi_45(a1) {
  a1=a1|0;
  jsCall_vi(45,a1|0);
}



function jsCall_vi_46(a1) {
  a1=a1|0;
  jsCall_vi(46,a1|0);
}



function jsCall_vi_47(a1) {
  a1=a1|0;
  jsCall_vi(47,a1|0);
}



function jsCall_vi_48(a1) {
  a1=a1|0;
  jsCall_vi(48,a1|0);
}



function jsCall_vi_49(a1) {
  a1=a1|0;
  jsCall_vi(49,a1|0);
}



function jsCall_vi_50(a1) {
  a1=a1|0;
  jsCall_vi(50,a1|0);
}



function jsCall_vi_51(a1) {
  a1=a1|0;
  jsCall_vi(51,a1|0);
}



function jsCall_vi_52(a1) {
  a1=a1|0;
  jsCall_vi(52,a1|0);
}



function jsCall_vi_53(a1) {
  a1=a1|0;
  jsCall_vi(53,a1|0);
}



function jsCall_vi_54(a1) {
  a1=a1|0;
  jsCall_vi(54,a1|0);
}



function jsCall_vi_55(a1) {
  a1=a1|0;
  jsCall_vi(55,a1|0);
}



function jsCall_vi_56(a1) {
  a1=a1|0;
  jsCall_vi(56,a1|0);
}



function jsCall_vi_57(a1) {
  a1=a1|0;
  jsCall_vi(57,a1|0);
}



function jsCall_vi_58(a1) {
  a1=a1|0;
  jsCall_vi(58,a1|0);
}



function jsCall_vi_59(a1) {
  a1=a1|0;
  jsCall_vi(59,a1|0);
}



function jsCall_vi_60(a1) {
  a1=a1|0;
  jsCall_vi(60,a1|0);
}



function jsCall_vi_61(a1) {
  a1=a1|0;
  jsCall_vi(61,a1|0);
}



function jsCall_vi_62(a1) {
  a1=a1|0;
  jsCall_vi(62,a1|0);
}



function jsCall_vi_63(a1) {
  a1=a1|0;
  jsCall_vi(63,a1|0);
}



function dynCall_vid(index,a1,a2) {
  index = index|0;
  a1=a1|0; a2=+a2;
  FUNCTION_TABLE_vid[index&127](a1|0,+a2);
}


function jsCall_vid_0(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(0,a1|0,+a2);
}



function jsCall_vid_1(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(1,a1|0,+a2);
}



function jsCall_vid_2(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(2,a1|0,+a2);
}



function jsCall_vid_3(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(3,a1|0,+a2);
}



function jsCall_vid_4(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(4,a1|0,+a2);
}



function jsCall_vid_5(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(5,a1|0,+a2);
}



function jsCall_vid_6(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(6,a1|0,+a2);
}



function jsCall_vid_7(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(7,a1|0,+a2);
}



function jsCall_vid_8(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(8,a1|0,+a2);
}



function jsCall_vid_9(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(9,a1|0,+a2);
}



function jsCall_vid_10(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(10,a1|0,+a2);
}



function jsCall_vid_11(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(11,a1|0,+a2);
}



function jsCall_vid_12(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(12,a1|0,+a2);
}



function jsCall_vid_13(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(13,a1|0,+a2);
}



function jsCall_vid_14(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(14,a1|0,+a2);
}



function jsCall_vid_15(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(15,a1|0,+a2);
}



function jsCall_vid_16(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(16,a1|0,+a2);
}



function jsCall_vid_17(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(17,a1|0,+a2);
}



function jsCall_vid_18(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(18,a1|0,+a2);
}



function jsCall_vid_19(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(19,a1|0,+a2);
}



function jsCall_vid_20(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(20,a1|0,+a2);
}



function jsCall_vid_21(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(21,a1|0,+a2);
}



function jsCall_vid_22(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(22,a1|0,+a2);
}



function jsCall_vid_23(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(23,a1|0,+a2);
}



function jsCall_vid_24(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(24,a1|0,+a2);
}



function jsCall_vid_25(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(25,a1|0,+a2);
}



function jsCall_vid_26(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(26,a1|0,+a2);
}



function jsCall_vid_27(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(27,a1|0,+a2);
}



function jsCall_vid_28(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(28,a1|0,+a2);
}



function jsCall_vid_29(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(29,a1|0,+a2);
}



function jsCall_vid_30(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(30,a1|0,+a2);
}



function jsCall_vid_31(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(31,a1|0,+a2);
}



function jsCall_vid_32(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(32,a1|0,+a2);
}



function jsCall_vid_33(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(33,a1|0,+a2);
}



function jsCall_vid_34(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(34,a1|0,+a2);
}



function jsCall_vid_35(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(35,a1|0,+a2);
}



function jsCall_vid_36(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(36,a1|0,+a2);
}



function jsCall_vid_37(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(37,a1|0,+a2);
}



function jsCall_vid_38(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(38,a1|0,+a2);
}



function jsCall_vid_39(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(39,a1|0,+a2);
}



function jsCall_vid_40(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(40,a1|0,+a2);
}



function jsCall_vid_41(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(41,a1|0,+a2);
}



function jsCall_vid_42(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(42,a1|0,+a2);
}



function jsCall_vid_43(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(43,a1|0,+a2);
}



function jsCall_vid_44(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(44,a1|0,+a2);
}



function jsCall_vid_45(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(45,a1|0,+a2);
}



function jsCall_vid_46(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(46,a1|0,+a2);
}



function jsCall_vid_47(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(47,a1|0,+a2);
}



function jsCall_vid_48(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(48,a1|0,+a2);
}



function jsCall_vid_49(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(49,a1|0,+a2);
}



function jsCall_vid_50(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(50,a1|0,+a2);
}



function jsCall_vid_51(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(51,a1|0,+a2);
}



function jsCall_vid_52(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(52,a1|0,+a2);
}



function jsCall_vid_53(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(53,a1|0,+a2);
}



function jsCall_vid_54(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(54,a1|0,+a2);
}



function jsCall_vid_55(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(55,a1|0,+a2);
}



function jsCall_vid_56(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(56,a1|0,+a2);
}



function jsCall_vid_57(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(57,a1|0,+a2);
}



function jsCall_vid_58(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(58,a1|0,+a2);
}



function jsCall_vid_59(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(59,a1|0,+a2);
}



function jsCall_vid_60(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(60,a1|0,+a2);
}



function jsCall_vid_61(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(61,a1|0,+a2);
}



function jsCall_vid_62(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(62,a1|0,+a2);
}



function jsCall_vid_63(a1,a2) {
  a1=a1|0; a2=+a2;
  jsCall_vid(63,a1|0,+a2);
}



function dynCall_vii(index,a1,a2) {
  index = index|0;
  a1=a1|0; a2=a2|0;
  FUNCTION_TABLE_vii[index&127](a1|0,a2|0);
}


function jsCall_vii_0(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(0,a1|0,a2|0);
}



function jsCall_vii_1(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(1,a1|0,a2|0);
}



function jsCall_vii_2(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(2,a1|0,a2|0);
}



function jsCall_vii_3(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(3,a1|0,a2|0);
}



function jsCall_vii_4(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(4,a1|0,a2|0);
}



function jsCall_vii_5(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(5,a1|0,a2|0);
}



function jsCall_vii_6(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(6,a1|0,a2|0);
}



function jsCall_vii_7(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(7,a1|0,a2|0);
}



function jsCall_vii_8(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(8,a1|0,a2|0);
}



function jsCall_vii_9(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(9,a1|0,a2|0);
}



function jsCall_vii_10(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(10,a1|0,a2|0);
}



function jsCall_vii_11(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(11,a1|0,a2|0);
}



function jsCall_vii_12(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(12,a1|0,a2|0);
}



function jsCall_vii_13(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(13,a1|0,a2|0);
}



function jsCall_vii_14(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(14,a1|0,a2|0);
}



function jsCall_vii_15(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(15,a1|0,a2|0);
}



function jsCall_vii_16(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(16,a1|0,a2|0);
}



function jsCall_vii_17(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(17,a1|0,a2|0);
}



function jsCall_vii_18(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(18,a1|0,a2|0);
}



function jsCall_vii_19(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(19,a1|0,a2|0);
}



function jsCall_vii_20(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(20,a1|0,a2|0);
}



function jsCall_vii_21(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(21,a1|0,a2|0);
}



function jsCall_vii_22(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(22,a1|0,a2|0);
}



function jsCall_vii_23(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(23,a1|0,a2|0);
}



function jsCall_vii_24(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(24,a1|0,a2|0);
}



function jsCall_vii_25(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(25,a1|0,a2|0);
}



function jsCall_vii_26(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(26,a1|0,a2|0);
}



function jsCall_vii_27(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(27,a1|0,a2|0);
}



function jsCall_vii_28(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(28,a1|0,a2|0);
}



function jsCall_vii_29(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(29,a1|0,a2|0);
}



function jsCall_vii_30(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(30,a1|0,a2|0);
}



function jsCall_vii_31(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(31,a1|0,a2|0);
}



function jsCall_vii_32(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(32,a1|0,a2|0);
}



function jsCall_vii_33(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(33,a1|0,a2|0);
}



function jsCall_vii_34(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(34,a1|0,a2|0);
}



function jsCall_vii_35(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(35,a1|0,a2|0);
}



function jsCall_vii_36(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(36,a1|0,a2|0);
}



function jsCall_vii_37(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(37,a1|0,a2|0);
}



function jsCall_vii_38(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(38,a1|0,a2|0);
}



function jsCall_vii_39(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(39,a1|0,a2|0);
}



function jsCall_vii_40(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(40,a1|0,a2|0);
}



function jsCall_vii_41(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(41,a1|0,a2|0);
}



function jsCall_vii_42(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(42,a1|0,a2|0);
}



function jsCall_vii_43(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(43,a1|0,a2|0);
}



function jsCall_vii_44(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(44,a1|0,a2|0);
}



function jsCall_vii_45(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(45,a1|0,a2|0);
}



function jsCall_vii_46(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(46,a1|0,a2|0);
}



function jsCall_vii_47(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(47,a1|0,a2|0);
}



function jsCall_vii_48(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(48,a1|0,a2|0);
}



function jsCall_vii_49(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(49,a1|0,a2|0);
}



function jsCall_vii_50(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(50,a1|0,a2|0);
}



function jsCall_vii_51(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(51,a1|0,a2|0);
}



function jsCall_vii_52(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(52,a1|0,a2|0);
}



function jsCall_vii_53(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(53,a1|0,a2|0);
}



function jsCall_vii_54(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(54,a1|0,a2|0);
}



function jsCall_vii_55(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(55,a1|0,a2|0);
}



function jsCall_vii_56(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(56,a1|0,a2|0);
}



function jsCall_vii_57(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(57,a1|0,a2|0);
}



function jsCall_vii_58(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(58,a1|0,a2|0);
}



function jsCall_vii_59(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(59,a1|0,a2|0);
}



function jsCall_vii_60(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(60,a1|0,a2|0);
}



function jsCall_vii_61(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(61,a1|0,a2|0);
}



function jsCall_vii_62(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(62,a1|0,a2|0);
}



function jsCall_vii_63(a1,a2) {
  a1=a1|0; a2=a2|0;
  jsCall_vii(63,a1|0,a2|0);
}



function dynCall_viii(index,a1,a2,a3) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0;
  FUNCTION_TABLE_viii[index&255](a1|0,a2|0,a3|0);
}


function jsCall_viii_0(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(0,a1|0,a2|0,a3|0);
}



function jsCall_viii_1(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(1,a1|0,a2|0,a3|0);
}



function jsCall_viii_2(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(2,a1|0,a2|0,a3|0);
}



function jsCall_viii_3(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(3,a1|0,a2|0,a3|0);
}



function jsCall_viii_4(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(4,a1|0,a2|0,a3|0);
}



function jsCall_viii_5(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(5,a1|0,a2|0,a3|0);
}



function jsCall_viii_6(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(6,a1|0,a2|0,a3|0);
}



function jsCall_viii_7(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(7,a1|0,a2|0,a3|0);
}



function jsCall_viii_8(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(8,a1|0,a2|0,a3|0);
}



function jsCall_viii_9(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(9,a1|0,a2|0,a3|0);
}



function jsCall_viii_10(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(10,a1|0,a2|0,a3|0);
}



function jsCall_viii_11(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(11,a1|0,a2|0,a3|0);
}



function jsCall_viii_12(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(12,a1|0,a2|0,a3|0);
}



function jsCall_viii_13(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(13,a1|0,a2|0,a3|0);
}



function jsCall_viii_14(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(14,a1|0,a2|0,a3|0);
}



function jsCall_viii_15(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(15,a1|0,a2|0,a3|0);
}



function jsCall_viii_16(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(16,a1|0,a2|0,a3|0);
}



function jsCall_viii_17(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(17,a1|0,a2|0,a3|0);
}



function jsCall_viii_18(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(18,a1|0,a2|0,a3|0);
}



function jsCall_viii_19(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(19,a1|0,a2|0,a3|0);
}



function jsCall_viii_20(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(20,a1|0,a2|0,a3|0);
}



function jsCall_viii_21(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(21,a1|0,a2|0,a3|0);
}



function jsCall_viii_22(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(22,a1|0,a2|0,a3|0);
}



function jsCall_viii_23(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(23,a1|0,a2|0,a3|0);
}



function jsCall_viii_24(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(24,a1|0,a2|0,a3|0);
}



function jsCall_viii_25(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(25,a1|0,a2|0,a3|0);
}



function jsCall_viii_26(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(26,a1|0,a2|0,a3|0);
}



function jsCall_viii_27(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(27,a1|0,a2|0,a3|0);
}



function jsCall_viii_28(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(28,a1|0,a2|0,a3|0);
}



function jsCall_viii_29(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(29,a1|0,a2|0,a3|0);
}



function jsCall_viii_30(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(30,a1|0,a2|0,a3|0);
}



function jsCall_viii_31(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(31,a1|0,a2|0,a3|0);
}



function jsCall_viii_32(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(32,a1|0,a2|0,a3|0);
}



function jsCall_viii_33(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(33,a1|0,a2|0,a3|0);
}



function jsCall_viii_34(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(34,a1|0,a2|0,a3|0);
}



function jsCall_viii_35(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(35,a1|0,a2|0,a3|0);
}



function jsCall_viii_36(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(36,a1|0,a2|0,a3|0);
}



function jsCall_viii_37(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(37,a1|0,a2|0,a3|0);
}



function jsCall_viii_38(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(38,a1|0,a2|0,a3|0);
}



function jsCall_viii_39(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(39,a1|0,a2|0,a3|0);
}



function jsCall_viii_40(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(40,a1|0,a2|0,a3|0);
}



function jsCall_viii_41(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(41,a1|0,a2|0,a3|0);
}



function jsCall_viii_42(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(42,a1|0,a2|0,a3|0);
}



function jsCall_viii_43(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(43,a1|0,a2|0,a3|0);
}



function jsCall_viii_44(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(44,a1|0,a2|0,a3|0);
}



function jsCall_viii_45(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(45,a1|0,a2|0,a3|0);
}



function jsCall_viii_46(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(46,a1|0,a2|0,a3|0);
}



function jsCall_viii_47(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(47,a1|0,a2|0,a3|0);
}



function jsCall_viii_48(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(48,a1|0,a2|0,a3|0);
}



function jsCall_viii_49(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(49,a1|0,a2|0,a3|0);
}



function jsCall_viii_50(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(50,a1|0,a2|0,a3|0);
}



function jsCall_viii_51(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(51,a1|0,a2|0,a3|0);
}



function jsCall_viii_52(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(52,a1|0,a2|0,a3|0);
}



function jsCall_viii_53(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(53,a1|0,a2|0,a3|0);
}



function jsCall_viii_54(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(54,a1|0,a2|0,a3|0);
}



function jsCall_viii_55(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(55,a1|0,a2|0,a3|0);
}



function jsCall_viii_56(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(56,a1|0,a2|0,a3|0);
}



function jsCall_viii_57(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(57,a1|0,a2|0,a3|0);
}



function jsCall_viii_58(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(58,a1|0,a2|0,a3|0);
}



function jsCall_viii_59(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(59,a1|0,a2|0,a3|0);
}



function jsCall_viii_60(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(60,a1|0,a2|0,a3|0);
}



function jsCall_viii_61(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(61,a1|0,a2|0,a3|0);
}



function jsCall_viii_62(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(62,a1|0,a2|0,a3|0);
}



function jsCall_viii_63(a1,a2,a3) {
  a1=a1|0; a2=a2|0; a3=a3|0;
  jsCall_viii(63,a1|0,a2|0,a3|0);
}



function dynCall_viiii(index,a1,a2,a3,a4) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  FUNCTION_TABLE_viiii[index&127](a1|0,a2|0,a3|0,a4|0);
}


function jsCall_viiii_0(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(0,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_1(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(1,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_2(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(2,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_3(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(3,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_4(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(4,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_5(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(5,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_6(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(6,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_7(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(7,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_8(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(8,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_9(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(9,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_10(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(10,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_11(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(11,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_12(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(12,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_13(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(13,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_14(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(14,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_15(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(15,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_16(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(16,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_17(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(17,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_18(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(18,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_19(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(19,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_20(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(20,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_21(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(21,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_22(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(22,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_23(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(23,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_24(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(24,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_25(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(25,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_26(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(26,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_27(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(27,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_28(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(28,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_29(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(29,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_30(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(30,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_31(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(31,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_32(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(32,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_33(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(33,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_34(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(34,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_35(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(35,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_36(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(36,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_37(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(37,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_38(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(38,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_39(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(39,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_40(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(40,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_41(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(41,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_42(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(42,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_43(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(43,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_44(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(44,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_45(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(45,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_46(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(46,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_47(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(47,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_48(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(48,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_49(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(49,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_50(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(50,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_51(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(51,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_52(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(52,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_53(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(53,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_54(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(54,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_55(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(55,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_56(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(56,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_57(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(57,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_58(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(58,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_59(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(59,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_60(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(60,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_61(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(61,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_62(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(62,a1|0,a2|0,a3|0,a4|0);
}



function jsCall_viiii_63(a1,a2,a3,a4) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  jsCall_viiii(63,a1|0,a2|0,a3|0,a4|0);
}



function dynCall_viiiii(index,a1,a2,a3,a4,a5) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  FUNCTION_TABLE_viiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0);
}


function jsCall_viiiii_0(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_1(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_2(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_3(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_4(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_5(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_6(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_7(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_8(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_9(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_10(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_11(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_12(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_13(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_14(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_15(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_16(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_17(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_18(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_19(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_20(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_21(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_22(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_23(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_24(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_25(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_26(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_27(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_28(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_29(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_30(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_31(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_32(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_33(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_34(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_35(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_36(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_37(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_38(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_39(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_40(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_41(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_42(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_43(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_44(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_45(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_46(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_47(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_48(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_49(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_50(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_51(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_52(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_53(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_54(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_55(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_56(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_57(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_58(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_59(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_60(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_61(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_62(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function jsCall_viiiii_63(a1,a2,a3,a4,a5) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0;
  jsCall_viiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0);
}



function dynCall_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  FUNCTION_TABLE_viiiiii[index&127](a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}


function jsCall_viiiiii_0(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(0,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_1(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(1,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_2(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(2,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_3(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(3,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_4(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(4,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_5(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(5,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_6(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(6,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_7(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(7,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_8(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(8,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_9(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(9,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_10(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(10,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_11(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(11,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_12(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(12,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_13(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(13,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_14(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(14,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_15(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(15,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_16(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(16,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_17(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(17,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_18(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(18,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_19(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(19,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_20(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(20,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_21(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(21,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_22(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(22,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_23(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(23,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_24(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(24,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_25(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(25,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_26(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(26,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_27(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(27,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_28(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(28,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_29(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(29,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_30(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(30,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_31(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(31,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_32(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(32,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_33(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(33,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_34(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(34,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_35(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(35,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_36(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(36,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_37(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(37,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_38(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(38,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_39(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(39,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_40(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(40,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_41(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(41,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_42(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(42,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_43(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(43,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_44(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(44,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_45(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(45,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_46(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(46,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_47(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(47,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_48(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(48,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_49(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(49,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_50(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(50,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_51(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(51,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_52(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(52,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_53(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(53,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_54(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(54,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_55(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(55,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_56(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(56,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_57(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(57,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_58(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(58,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_59(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(59,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_60(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(60,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_61(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(61,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_62(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(62,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}



function jsCall_viiiiii_63(a1,a2,a3,a4,a5,a6) {
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0; a5=a5|0; a6=a6|0;
  jsCall_viiiiii(63,a1|0,a2|0,a3|0,a4|0,a5|0,a6|0);
}


function b0(p0) {
 p0 = p0|0; nullFunc_di(0);return +0;
}
function b1(p0,p1) {
 p0 = p0|0;p1 = p1|0; nullFunc_dii(1);return +0;
}
function b2() {
 ; nullFunc_i(2);return 0;
}
function b3(p0) {
 p0 = p0|0; nullFunc_ii(3);return 0;
}
function b4(p0,p1) {
 p0 = p0|0;p1 = p1|0; nullFunc_iii(4);return 0;
}
function b5(p0,p1,p2) {
 p0 = p0|0;p1 = p1|0;p2 = +p2; nullFunc_iiid(5);return 0;
}
function b6(p0,p1,p2) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0; nullFunc_iiii(6);return 0;
}
function b7(p0,p1,p2,p3) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0; nullFunc_iiiii(7);return 0;
}
function b8(p0,p1,p2,p3,p4) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0; nullFunc_iiiiii(8);return 0;
}
function b9(p0,p1,p2,p3,p4,p5) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0;p5 = p5|0; nullFunc_iiiiiii(9);return 0;
}
function b10(p0,p1,p2,p3,p4,p5,p6) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0;p5 = p5|0;p6 = p6|0; nullFunc_iiiiiiii(10);return 0;
}
function b11(p0,p1,p2,p3,p4,p5,p6,p7) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0;p5 = p5|0;p6 = p6|0;p7 = p7|0; nullFunc_iiiiiiiii(11);return 0;
}
function b12(p0,p1,p2,p3,p4,p5,p6,p7,p8) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0;p5 = p5|0;p6 = p6|0;p7 = p7|0;p8 = p8|0; nullFunc_iiiiiiiiii(12);return 0;
}
function b13() {
 ; nullFunc_v(13);
}
function b14(p0) {
 p0 = p0|0; nullFunc_vi(14);
}
function b15(p0,p1) {
 p0 = p0|0;p1 = +p1; nullFunc_vid(15);
}
function b16(p0,p1) {
 p0 = p0|0;p1 = p1|0; nullFunc_vii(16);
}
function b17(p0,p1,p2) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0; nullFunc_viii(17);
}
function b18(p0,p1,p2,p3) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0; nullFunc_viiii(18);
}
function b19(p0,p1,p2,p3,p4) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0; nullFunc_viiiii(19);
}
function b20(p0,p1,p2,p3,p4,p5) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0;p4 = p4|0;p5 = p5|0; nullFunc_viiiiii(20);
}

// EMSCRIPTEN_END_FUNCS
var FUNCTION_TABLE_di = [b0,jsCall_di_0,jsCall_di_1,jsCall_di_2,jsCall_di_3,jsCall_di_4,jsCall_di_5,jsCall_di_6,jsCall_di_7,jsCall_di_8,jsCall_di_9,jsCall_di_10,jsCall_di_11,jsCall_di_12,jsCall_di_13,jsCall_di_14,jsCall_di_15,jsCall_di_16,jsCall_di_17,jsCall_di_18,jsCall_di_19,jsCall_di_20,jsCall_di_21,jsCall_di_22,jsCall_di_23,jsCall_di_24,jsCall_di_25,jsCall_di_26,jsCall_di_27
,jsCall_di_28,jsCall_di_29,jsCall_di_30,jsCall_di_31,jsCall_di_32,jsCall_di_33,jsCall_di_34,jsCall_di_35,jsCall_di_36,jsCall_di_37,jsCall_di_38,jsCall_di_39,jsCall_di_40,jsCall_di_41,jsCall_di_42,jsCall_di_43,jsCall_di_44,jsCall_di_45,jsCall_di_46,jsCall_di_47,jsCall_di_48,jsCall_di_49,jsCall_di_50,jsCall_di_51,jsCall_di_52,jsCall_di_53,jsCall_di_54,jsCall_di_55,jsCall_di_56,jsCall_di_57
,jsCall_di_58,jsCall_di_59,jsCall_di_60,jsCall_di_61,jsCall_di_62,jsCall_di_63,_sqlite3_value_double,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0
,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0
,b0,b0,b0,b0,b0,b0,b0,b0,b0];
var FUNCTION_TABLE_dii = [b1,jsCall_dii_0,jsCall_dii_1,jsCall_dii_2,jsCall_dii_3,jsCall_dii_4,jsCall_dii_5,jsCall_dii_6,jsCall_dii_7,jsCall_dii_8,jsCall_dii_9,jsCall_dii_10,jsCall_dii_11,jsCall_dii_12,jsCall_dii_13,jsCall_dii_14,jsCall_dii_15,jsCall_dii_16,jsCall_dii_17,jsCall_dii_18,jsCall_dii_19,jsCall_dii_20,jsCall_dii_21,jsCall_dii_22,jsCall_dii_23,jsCall_dii_24,jsCall_dii_25,jsCall_dii_26,jsCall_dii_27
,jsCall_dii_28,jsCall_dii_29,jsCall_dii_30,jsCall_dii_31,jsCall_dii_32,jsCall_dii_33,jsCall_dii_34,jsCall_dii_35,jsCall_dii_36,jsCall_dii_37,jsCall_dii_38,jsCall_dii_39,jsCall_dii_40,jsCall_dii_41,jsCall_dii_42,jsCall_dii_43,jsCall_dii_44,jsCall_dii_45,jsCall_dii_46,jsCall_dii_47,jsCall_dii_48,jsCall_dii_49,jsCall_dii_50,jsCall_dii_51,jsCall_dii_52,jsCall_dii_53,jsCall_dii_54,jsCall_dii_55,jsCall_dii_56,jsCall_dii_57
,jsCall_dii_58,jsCall_dii_59,jsCall_dii_60,jsCall_dii_61,jsCall_dii_62,jsCall_dii_63,_sqlite3_column_double,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1
,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1,b1
,b1,b1,b1,b1,b1,b1,b1,b1,b1];
var FUNCTION_TABLE_i = [b2,jsCall_i_0,jsCall_i_1,jsCall_i_2,jsCall_i_3,jsCall_i_4,jsCall_i_5,jsCall_i_6,jsCall_i_7,jsCall_i_8,jsCall_i_9,jsCall_i_10,jsCall_i_11,jsCall_i_12,jsCall_i_13,jsCall_i_14,jsCall_i_15,jsCall_i_16,jsCall_i_17,jsCall_i_18,jsCall_i_19,jsCall_i_20,jsCall_i_21,jsCall_i_22,jsCall_i_23,jsCall_i_24,jsCall_i_25,jsCall_i_26,jsCall_i_27
,jsCall_i_28,jsCall_i_29,jsCall_i_30,jsCall_i_31,jsCall_i_32,jsCall_i_33,jsCall_i_34,jsCall_i_35,jsCall_i_36,jsCall_i_37,jsCall_i_38,jsCall_i_39,jsCall_i_40,jsCall_i_41,jsCall_i_42,jsCall_i_43,jsCall_i_44,jsCall_i_45,jsCall_i_46,jsCall_i_47,jsCall_i_48,jsCall_i_49,jsCall_i_50,jsCall_i_51,jsCall_i_52,jsCall_i_53,jsCall_i_54,jsCall_i_55,jsCall_i_56,jsCall_i_57
,jsCall_i_58,jsCall_i_59,jsCall_i_60,jsCall_i_61,jsCall_i_62,jsCall_i_63,_geteuid,_unixGetpagesize,_sqlite3_libversion,_sqlite3_libversion_number,_sqlite3_memory_used,_sqlite3_threadsafe,_sqlite3_sourceid,_noopMutexInit,_noopMutexEnd,_pthreadMutexInit,_pthreadMutexEnd,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2
,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2
,b2,b2,b2,b2,b2,b2,b2,b2,b2];
var FUNCTION_TABLE_ii = [b3,jsCall_ii_0,jsCall_ii_1,jsCall_ii_2,jsCall_ii_3,jsCall_ii_4,jsCall_ii_5,jsCall_ii_6,jsCall_ii_7,jsCall_ii_8,jsCall_ii_9,jsCall_ii_10,jsCall_ii_11,jsCall_ii_12,jsCall_ii_13,jsCall_ii_14,jsCall_ii_15,jsCall_ii_16,jsCall_ii_17,jsCall_ii_18,jsCall_ii_19,jsCall_ii_20,jsCall_ii_21,jsCall_ii_22,jsCall_ii_23,jsCall_ii_24,jsCall_ii_25,jsCall_ii_26,jsCall_ii_27
,jsCall_ii_28,jsCall_ii_29,jsCall_ii_30,jsCall_ii_31,jsCall_ii_32,jsCall_ii_33,jsCall_ii_34,jsCall_ii_35,jsCall_ii_36,jsCall_ii_37,jsCall_ii_38,jsCall_ii_39,jsCall_ii_40,jsCall_ii_41,jsCall_ii_42,jsCall_ii_43,jsCall_ii_44,jsCall_ii_45,jsCall_ii_46,jsCall_ii_47,jsCall_ii_48,jsCall_ii_49,jsCall_ii_50,jsCall_ii_51,jsCall_ii_52,jsCall_ii_53,jsCall_ii_54,jsCall_ii_55,jsCall_ii_56,jsCall_ii_57
,jsCall_ii_58,jsCall_ii_59,jsCall_ii_60,jsCall_ii_61,jsCall_ii_62,jsCall_ii_63,_dotlockClose,_unixSectorSize,_unixDeviceCharacteristics,_close,_unlink,_rmdir,_nolockClose,_unixClose,_pcache1Init,_pcache1Pagecount,_sqlite3MemMalloc,_sqlite3MemSize,_sqlite3MemRoundup,_sqlite3MemInit,_sqlite3_aggregate_count,_sqlite3_bind_parameter_count,_sqlite3_changes,_sqlite3_close,_sqlite3_column_count,_sqlite3_complete,_sqlite3_complete16,_sqlite3_data_count,_sqlite3_db_handle,_sqlite3_enable_shared_cache
,_sqlite3_errcode,_sqlite3_errmsg,_sqlite3_errmsg16,_sqlite3_expired,_sqlite3_finalize,_sqlite3_get_autocommit,_sqlite3_last_insert_rowid,_sqlite3_malloc,_sqlite3_reset,_sqlite3_step,_sqlite3_total_changes,_sqlite3_user_data,_sqlite3_value_blob,_sqlite3_value_bytes,_sqlite3_value_bytes16,_sqlite3_value_int,_sqlite3_value_int64,_sqlite3_value_numeric_type,_sqlite3_value_text,_sqlite3_value_text16,_sqlite3_value_text16be,_sqlite3_value_text16le,_sqlite3_value_type,_sqlite3_clear_bindings,_sqlite3_blob_bytes,_sqlite3_blob_close,_sqlite3_memory_highwater,_sqlite3_mutex_alloc,_sqlite3_mutex_try,_sqlite3_release_memory
,_sqlite3_sleep,_sqlite3_vfs_find,_sqlite3_vfs_unregister,_sqlite3_context_db_handle,_sqlite3_sql,_sqlite3_backup_finish,_sqlite3_backup_pagecount,_sqlite3_backup_remaining,_sqlite3_compileoption_get,_sqlite3_compileoption_used,_sqlite3_db_mutex,_sqlite3_extended_errcode,_sqlite3_vtab_on_conflict,_sqlite3_close_v2,_sqlite3_db_release_memory,_sqlite3_errstr,_sqlite3_stmt_busy,_sqlite3_stmt_readonly,_sqlite3_auto_extension,_sqlite3_cancel_auto_extension,_sqlite3_msize,_sqlite3_value_dup,_sqlite3_value_subtype,_sqlite3_db_cacheflush,_sqlite3_system_errno,_sqlite3_expanded_sql,_sqlite3_vtab_nochange,_sqlite3_value_nochange,_memjrnlClose,_pragmaVtabDisconnect
,_pragmaVtabClose,_pragmaVtabNext,_pragmaVtabEof,_noopMutexAlloc,_noopMutexTry,_pthreadMutexAlloc,_pthreadMutexTry,___stdio_close,_sqlite3MallocSize,_btreeInvokeBusyHandler,_vdbeSorterFlushThread,_vdbeIncrPopulateThread,_vdbePmaReaderBgIncrInit,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3];
var FUNCTION_TABLE_iii = [b4,jsCall_iii_0,jsCall_iii_1,jsCall_iii_2,jsCall_iii_3,jsCall_iii_4,jsCall_iii_5,jsCall_iii_6,jsCall_iii_7,jsCall_iii_8,jsCall_iii_9,jsCall_iii_10,jsCall_iii_11,jsCall_iii_12,jsCall_iii_13,jsCall_iii_14,jsCall_iii_15,jsCall_iii_16,jsCall_iii_17,jsCall_iii_18,jsCall_iii_19,jsCall_iii_20,jsCall_iii_21,jsCall_iii_22,jsCall_iii_23,jsCall_iii_24,jsCall_iii_25,jsCall_iii_26,jsCall_iii_27
,jsCall_iii_28,jsCall_iii_29,jsCall_iii_30,jsCall_iii_31,jsCall_iii_32,jsCall_iii_33,jsCall_iii_34,jsCall_iii_35,jsCall_iii_36,jsCall_iii_37,jsCall_iii_38,jsCall_iii_39,jsCall_iii_40,jsCall_iii_41,jsCall_iii_42,jsCall_iii_43,jsCall_iii_44,jsCall_iii_45,jsCall_iii_46,jsCall_iii_47,jsCall_iii_48,jsCall_iii_49,jsCall_iii_50,jsCall_iii_51,jsCall_iii_52,jsCall_iii_53,jsCall_iii_54,jsCall_iii_55,jsCall_iii_56,jsCall_iii_57
,jsCall_iii_58,jsCall_iii_59,jsCall_iii_60,jsCall_iii_61,jsCall_iii_62,jsCall_iii_63,_unixDlOpen,_unixSleep,_unixCurrentTime,_unixCurrentTimeInt64,_unixGetSystemCall,_unixNextSystemCall,_posixIoFinderImpl,_nolockIoFinderImpl,_dotlockIoFinderImpl,_unixSync,_unixFileSize,_dotlockLock,_dotlockUnlock,_dotlockCheckReservedLock,_unixShmUnmap,_access,_getcwd,_stat,_fstat,_ftruncate,_fchmod,_openDirectory,_mkdir,___munmap
,_lstat,_nolockLock,_nolockUnlock,_nolockCheckReservedLock,_unixLock,_unixUnlock,_unixCheckReservedLock,_sqlite3MemRealloc,_sqlite3_aggregate_context,_sqlite3_bind_null,_sqlite3_bind_parameter_index,_sqlite3_bind_parameter_name,_sqlite3_busy_timeout,_sqlite3_column_blob,_sqlite3_column_bytes,_sqlite3_column_bytes16,_sqlite3_column_decltype,_sqlite3_column_decltype16,_sqlite3_column_int,_sqlite3_column_int64,_sqlite3_column_name,_sqlite3_column_name16,_sqlite3_column_text,_sqlite3_column_text16,_sqlite3_column_type,_sqlite3_column_value,_sqlite3_declare_vtab,_sqlite3_get_auxdata,_sqlite3_mprintf,_sqlite3_open
,_sqlite3_open16,_sqlite3_realloc,_sqlite3_transfer_bindings,_sqlite3_vmprintf,_sqlite3_vfs_register,_sqlite3_test_control,_sqlite3_extended_result_codes,_sqlite3_next_stmt,_sqlite3_backup_step,_sqlite3_soft_heap_limit64,_sqlite3_wal_autocheckpoint,_sqlite3_wal_checkpoint,_sqlite3_db_filename,_sqlite3_db_readonly,_sqlite3_stricmp,_sqlite3_uri_parameter,_sqlite3_malloc64,_sqlite3_strglob,_sqlite3_value_pointer,_sqlite3_vtab_collation,_memjrnlSync,_memjrnlFileSize,_pragmaVtabBestIndex,_pragmaVtabOpen,_pragmaVtabRowid,_int_cmp,_double_cmp,_sqliteDefaultBusyCallback,_cellSizePtr,_cellSizePtrNoPayload
,_pagerStress,_sqlite3ExprWalkNoop,_convertCompoundSelectToSubquery,_selectExpander,_resolveExprStep,_resolveSelectStep,_sqlite3SelectWalkNoop,_incrAggDepth,_exprSrcCount,_exprNodeIsConstant,_sqlite3SelectWalkFail,_exprNodeIsDeterministic,_whereIndexExprTransNode,_exprIdxCover,_checkConstraintExprNode,_sqlite3BtreeNext,_sqlite3BtreePrevious,_havingToWhereExprCb,_analyzeAggregate,_analyzeAggregatesInSelect,_exprNodeIsConstantOrGroupBy,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4];
var FUNCTION_TABLE_iiid = [b5,jsCall_iiid_0,jsCall_iiid_1,jsCall_iiid_2,jsCall_iiid_3,jsCall_iiid_4,jsCall_iiid_5,jsCall_iiid_6,jsCall_iiid_7,jsCall_iiid_8,jsCall_iiid_9,jsCall_iiid_10,jsCall_iiid_11,jsCall_iiid_12,jsCall_iiid_13,jsCall_iiid_14,jsCall_iiid_15,jsCall_iiid_16,jsCall_iiid_17,jsCall_iiid_18,jsCall_iiid_19,jsCall_iiid_20,jsCall_iiid_21,jsCall_iiid_22,jsCall_iiid_23,jsCall_iiid_24,jsCall_iiid_25,jsCall_iiid_26,jsCall_iiid_27
,jsCall_iiid_28,jsCall_iiid_29,jsCall_iiid_30,jsCall_iiid_31,jsCall_iiid_32,jsCall_iiid_33,jsCall_iiid_34,jsCall_iiid_35,jsCall_iiid_36,jsCall_iiid_37,jsCall_iiid_38,jsCall_iiid_39,jsCall_iiid_40,jsCall_iiid_41,jsCall_iiid_42,jsCall_iiid_43,jsCall_iiid_44,jsCall_iiid_45,jsCall_iiid_46,jsCall_iiid_47,jsCall_iiid_48,jsCall_iiid_49,jsCall_iiid_50,jsCall_iiid_51,jsCall_iiid_52,jsCall_iiid_53,jsCall_iiid_54,jsCall_iiid_55,jsCall_iiid_56,jsCall_iiid_57
,jsCall_iiid_58,jsCall_iiid_59,jsCall_iiid_60,jsCall_iiid_61,jsCall_iiid_62,jsCall_iiid_63,_sqlite3_bind_double,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5];
var FUNCTION_TABLE_iiii = [b6,jsCall_iiii_0,jsCall_iiii_1,jsCall_iiii_2,jsCall_iiii_3,jsCall_iiii_4,jsCall_iiii_5,jsCall_iiii_6,jsCall_iiii_7,jsCall_iiii_8,jsCall_iiii_9,jsCall_iiii_10,jsCall_iiii_11,jsCall_iiii_12,jsCall_iiii_13,jsCall_iiii_14,jsCall_iiii_15,jsCall_iiii_16,jsCall_iiii_17,jsCall_iiii_18,jsCall_iiii_19,jsCall_iiii_20,jsCall_iiii_21,jsCall_iiii_22,jsCall_iiii_23,jsCall_iiii_24,jsCall_iiii_25,jsCall_iiii_26,jsCall_iiii_27
,jsCall_iiii_28,jsCall_iiii_29,jsCall_iiii_30,jsCall_iiii_31,jsCall_iiii_32,jsCall_iiii_33,jsCall_iiii_34,jsCall_iiii_35,jsCall_iiii_36,jsCall_iiii_37,jsCall_iiii_38,jsCall_iiii_39,jsCall_iiii_40,jsCall_iiii_41,jsCall_iiii_42,jsCall_iiii_43,jsCall_iiii_44,jsCall_iiii_45,jsCall_iiii_46,jsCall_iiii_47,jsCall_iiii_48,jsCall_iiii_49,jsCall_iiii_50,jsCall_iiii_51,jsCall_iiii_52,jsCall_iiii_53,jsCall_iiii_54,jsCall_iiii_55,jsCall_iiii_56,jsCall_iiii_57
,jsCall_iiii_58,jsCall_iiii_59,jsCall_iiii_60,jsCall_iiii_61,jsCall_iiii_62,jsCall_iiii_63,_unixDelete,_unixDlSym,_unixRandomness,_unixGetLastError,_unixSetSystemCall,_unixTruncate,_unixFileControl,_posixOpen,_fcntl,_read,_write,_fchown,_readlink,_pcache1Create,_pcache1Fetch,_sqlite3_bind_int,_sqlite3_bind_value,_sqlite3_busy_handler,_sqlite3_collation_needed,_sqlite3_collation_needed16,_sqlite3_commit_hook,_sqlite3_profile,_sqlite3_rollback_hook,_sqlite3_set_authorizer
,_sqlite3_trace,_sqlite3_update_hook,_sqlite3_overload_function,_sqlite3_bind_zeroblob,_sqlite3_limit,_sqlite3_db_config,_sqlite3_stmt_status,_sqlite3_strnicmp,_sqlite3_wal_hook,_sqlite3_blob_reopen,_sqlite3_vtab_config,_sqlite3_uri_boolean,_sqlite3_realloc64,_sqlite3_result_zeroblob64,_sqlite3_strlike,_memjrnlTruncate,_pragmaVtabColumn,___stdout_write,___stdio_seek,_sqlite3VdbeRecordCompare,_vdbeRecordCompareInt,_vdbeRecordCompareString,___stdio_write,b6,b6,b6,b6,b6,b6,b6
,b6,b6,b6,b6,b6,b6,b6,b6,b6];
var FUNCTION_TABLE_iiiii = [b7,jsCall_iiiii_0,jsCall_iiiii_1,jsCall_iiiii_2,jsCall_iiiii_3,jsCall_iiiii_4,jsCall_iiiii_5,jsCall_iiiii_6,jsCall_iiiii_7,jsCall_iiiii_8,jsCall_iiiii_9,jsCall_iiiii_10,jsCall_iiiii_11,jsCall_iiiii_12,jsCall_iiiii_13,jsCall_iiiii_14,jsCall_iiiii_15,jsCall_iiiii_16,jsCall_iiiii_17,jsCall_iiiii_18,jsCall_iiiii_19,jsCall_iiiii_20,jsCall_iiiii_21,jsCall_iiiii_22,jsCall_iiiii_23,jsCall_iiiii_24,jsCall_iiiii_25,jsCall_iiiii_26,jsCall_iiiii_27
,jsCall_iiiii_28,jsCall_iiiii_29,jsCall_iiiii_30,jsCall_iiiii_31,jsCall_iiiii_32,jsCall_iiiii_33,jsCall_iiiii_34,jsCall_iiiii_35,jsCall_iiiii_36,jsCall_iiiii_37,jsCall_iiiii_38,jsCall_iiiii_39,jsCall_iiiii_40,jsCall_iiiii_41,jsCall_iiiii_42,jsCall_iiiii_43,jsCall_iiiii_44,jsCall_iiiii_45,jsCall_iiiii_46,jsCall_iiiii_47,jsCall_iiiii_48,jsCall_iiiii_49,jsCall_iiiii_50,jsCall_iiiii_51,jsCall_iiiii_52,jsCall_iiiii_53,jsCall_iiiii_54,jsCall_iiiii_55,jsCall_iiiii_56,jsCall_iiiii_57
,jsCall_iiiii_58,jsCall_iiiii_59,jsCall_iiiii_60,jsCall_iiiii_61,jsCall_iiiii_62,jsCall_iiiii_63,_unixAccess,_unixFullPathname,_unixShmLock,_unixUnfetch,_sqlite3_bind_int64,_sqlite3_create_module,_sqlite3_snprintf,_sqlite3_blob_read,_sqlite3_blob_write,_sqlite3_file_control,_sqlite3_open_v2,_sqlite3_status,_sqlite3_backup_init,_sqlite3_uri_int64,_sqlite3_vsnprintf,_sqlite3_load_extension,_sqlite3_bind_zeroblob64,_sqlite3_status64,_sqlite3_trace_v2,_sqlite3_get_table_cb,_sqlite3BtreePayloadChecked,_sqlite3BtreePutData,_sqlite3WalDefaultHook,_getPageError
,_getPageNormal,_sqlite3InitCallback,_analysisLoader,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7
,b7,b7,b7,b7,b7,b7,b7,b7,b7];
var FUNCTION_TABLE_iiiiii = [b8,jsCall_iiiiii_0,jsCall_iiiiii_1,jsCall_iiiiii_2,jsCall_iiiiii_3,jsCall_iiiiii_4,jsCall_iiiiii_5,jsCall_iiiiii_6,jsCall_iiiiii_7,jsCall_iiiiii_8,jsCall_iiiiii_9,jsCall_iiiiii_10,jsCall_iiiiii_11,jsCall_iiiiii_12,jsCall_iiiiii_13,jsCall_iiiiii_14,jsCall_iiiiii_15,jsCall_iiiiii_16,jsCall_iiiiii_17,jsCall_iiiiii_18,jsCall_iiiiii_19,jsCall_iiiiii_20,jsCall_iiiiii_21,jsCall_iiiiii_22,jsCall_iiiiii_23,jsCall_iiiiii_24,jsCall_iiiiii_25,jsCall_iiiiii_26,jsCall_iiiiii_27
,jsCall_iiiiii_28,jsCall_iiiiii_29,jsCall_iiiiii_30,jsCall_iiiiii_31,jsCall_iiiiii_32,jsCall_iiiiii_33,jsCall_iiiiii_34,jsCall_iiiiii_35,jsCall_iiiiii_36,jsCall_iiiiii_37,jsCall_iiiiii_38,jsCall_iiiiii_39,jsCall_iiiiii_40,jsCall_iiiiii_41,jsCall_iiiiii_42,jsCall_iiiiii_43,jsCall_iiiiii_44,jsCall_iiiiii_45,jsCall_iiiiii_46,jsCall_iiiiii_47,jsCall_iiiiii_48,jsCall_iiiiii_49,jsCall_iiiiii_50,jsCall_iiiiii_51,jsCall_iiiiii_52,jsCall_iiiiii_53,jsCall_iiiiii_54,jsCall_iiiiii_55,jsCall_iiiiii_56,jsCall_iiiiii_57
,jsCall_iiiiii_58,jsCall_iiiiii_59,jsCall_iiiiii_60,jsCall_iiiiii_61,jsCall_iiiiii_62,jsCall_iiiiii_63,_unixOpen,_unixRead,_unixWrite,_unixFetch,_unixShmMap,_sqlite3_bind_blob,_sqlite3_bind_text,_sqlite3_bind_text16,_sqlite3_create_collation,_sqlite3_create_collation16,_sqlite3_exec,_sqlite3_prepare,_sqlite3_prepare16,_sqlite3_prepare_v2,_sqlite3_prepare16_v2,_sqlite3_create_module_v2,_sqlite3_db_status,_sqlite3_wal_checkpoint_v2,_sqlite3_bind_pointer,_memjrnlRead,_memjrnlWrite,_pragmaVtabFilter,_binCollFunc,_nocaseCollatingFunc
,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8
,b8,b8,b8,b8,b8,b8,b8,b8,b8];
var FUNCTION_TABLE_iiiiiii = [b9,jsCall_iiiiiii_0,jsCall_iiiiiii_1,jsCall_iiiiiii_2,jsCall_iiiiiii_3,jsCall_iiiiiii_4,jsCall_iiiiiii_5,jsCall_iiiiiii_6,jsCall_iiiiiii_7,jsCall_iiiiiii_8,jsCall_iiiiiii_9,jsCall_iiiiiii_10,jsCall_iiiiiii_11,jsCall_iiiiiii_12,jsCall_iiiiiii_13,jsCall_iiiiiii_14,jsCall_iiiiiii_15,jsCall_iiiiiii_16,jsCall_iiiiiii_17,jsCall_iiiiiii_18,jsCall_iiiiiii_19,jsCall_iiiiiii_20,jsCall_iiiiiii_21,jsCall_iiiiiii_22,jsCall_iiiiiii_23,jsCall_iiiiiii_24,jsCall_iiiiiii_25,jsCall_iiiiiii_26,jsCall_iiiiiii_27
,jsCall_iiiiiii_28,jsCall_iiiiiii_29,jsCall_iiiiiii_30,jsCall_iiiiiii_31,jsCall_iiiiiii_32,jsCall_iiiiiii_33,jsCall_iiiiiii_34,jsCall_iiiiiii_35,jsCall_iiiiiii_36,jsCall_iiiiiii_37,jsCall_iiiiiii_38,jsCall_iiiiiii_39,jsCall_iiiiiii_40,jsCall_iiiiiii_41,jsCall_iiiiiii_42,jsCall_iiiiiii_43,jsCall_iiiiiii_44,jsCall_iiiiiii_45,jsCall_iiiiiii_46,jsCall_iiiiiii_47,jsCall_iiiiiii_48,jsCall_iiiiiii_49,jsCall_iiiiiii_50,jsCall_iiiiiii_51,jsCall_iiiiiii_52,jsCall_iiiiiii_53,jsCall_iiiiiii_54,jsCall_iiiiiii_55,jsCall_iiiiiii_56,jsCall_iiiiiii_57
,jsCall_iiiiiii_58,jsCall_iiiiiii_59,jsCall_iiiiiii_60,jsCall_iiiiiii_61,jsCall_iiiiiii_62,jsCall_iiiiiii_63,___mmap,_sqlite3_get_table,_sqlite3_create_collation_v2,_sqlite3_bind_blob64,_sqlite3_prepare_v3,_sqlite3_prepare16_v3,_pragmaVtabConnect,_vdbeSorterCompare,_vdbeSorterCompareText,_vdbeSorterCompareInt,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9];
var FUNCTION_TABLE_iiiiiiii = [b10,jsCall_iiiiiiii_0,jsCall_iiiiiiii_1,jsCall_iiiiiiii_2,jsCall_iiiiiiii_3,jsCall_iiiiiiii_4,jsCall_iiiiiiii_5,jsCall_iiiiiiii_6,jsCall_iiiiiiii_7,jsCall_iiiiiiii_8,jsCall_iiiiiiii_9,jsCall_iiiiiiii_10,jsCall_iiiiiiii_11,jsCall_iiiiiiii_12,jsCall_iiiiiiii_13,jsCall_iiiiiiii_14,jsCall_iiiiiiii_15,jsCall_iiiiiiii_16,jsCall_iiiiiiii_17,jsCall_iiiiiiii_18,jsCall_iiiiiiii_19,jsCall_iiiiiiii_20,jsCall_iiiiiiii_21,jsCall_iiiiiiii_22,jsCall_iiiiiiii_23,jsCall_iiiiiiii_24,jsCall_iiiiiiii_25,jsCall_iiiiiiii_26,jsCall_iiiiiiii_27
,jsCall_iiiiiiii_28,jsCall_iiiiiiii_29,jsCall_iiiiiiii_30,jsCall_iiiiiiii_31,jsCall_iiiiiiii_32,jsCall_iiiiiiii_33,jsCall_iiiiiiii_34,jsCall_iiiiiiii_35,jsCall_iiiiiiii_36,jsCall_iiiiiiii_37,jsCall_iiiiiiii_38,jsCall_iiiiiiii_39,jsCall_iiiiiiii_40,jsCall_iiiiiiii_41,jsCall_iiiiiiii_42,jsCall_iiiiiiii_43,jsCall_iiiiiiii_44,jsCall_iiiiiiii_45,jsCall_iiiiiiii_46,jsCall_iiiiiiii_47,jsCall_iiiiiiii_48,jsCall_iiiiiiii_49,jsCall_iiiiiiii_50,jsCall_iiiiiiii_51,jsCall_iiiiiiii_52,jsCall_iiiiiiii_53,jsCall_iiiiiiii_54,jsCall_iiiiiiii_55,jsCall_iiiiiiii_56,jsCall_iiiiiiii_57
,jsCall_iiiiiiii_58,jsCall_iiiiiiii_59,jsCall_iiiiiiii_60,jsCall_iiiiiiii_61,jsCall_iiiiiiii_62,jsCall_iiiiiiii_63,_sqlite3_bind_text64,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10
,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10,b10
,b10,b10,b10,b10,b10,b10,b10,b10,b10];
var FUNCTION_TABLE_iiiiiiiii = [b11,jsCall_iiiiiiiii_0,jsCall_iiiiiiiii_1,jsCall_iiiiiiiii_2,jsCall_iiiiiiiii_3,jsCall_iiiiiiiii_4,jsCall_iiiiiiiii_5,jsCall_iiiiiiiii_6,jsCall_iiiiiiiii_7,jsCall_iiiiiiiii_8,jsCall_iiiiiiiii_9,jsCall_iiiiiiiii_10,jsCall_iiiiiiiii_11,jsCall_iiiiiiiii_12,jsCall_iiiiiiiii_13,jsCall_iiiiiiiii_14,jsCall_iiiiiiiii_15,jsCall_iiiiiiiii_16,jsCall_iiiiiiiii_17,jsCall_iiiiiiiii_18,jsCall_iiiiiiiii_19,jsCall_iiiiiiiii_20,jsCall_iiiiiiiii_21,jsCall_iiiiiiiii_22,jsCall_iiiiiiiii_23,jsCall_iiiiiiiii_24,jsCall_iiiiiiiii_25,jsCall_iiiiiiiii_26,jsCall_iiiiiiiii_27
,jsCall_iiiiiiiii_28,jsCall_iiiiiiiii_29,jsCall_iiiiiiiii_30,jsCall_iiiiiiiii_31,jsCall_iiiiiiiii_32,jsCall_iiiiiiiii_33,jsCall_iiiiiiiii_34,jsCall_iiiiiiiii_35,jsCall_iiiiiiiii_36,jsCall_iiiiiiiii_37,jsCall_iiiiiiiii_38,jsCall_iiiiiiiii_39,jsCall_iiiiiiiii_40,jsCall_iiiiiiiii_41,jsCall_iiiiiiiii_42,jsCall_iiiiiiiii_43,jsCall_iiiiiiiii_44,jsCall_iiiiiiiii_45,jsCall_iiiiiiiii_46,jsCall_iiiiiiiii_47,jsCall_iiiiiiiii_48,jsCall_iiiiiiiii_49,jsCall_iiiiiiiii_50,jsCall_iiiiiiiii_51,jsCall_iiiiiiiii_52,jsCall_iiiiiiiii_53,jsCall_iiiiiiiii_54,jsCall_iiiiiiiii_55,jsCall_iiiiiiiii_56,jsCall_iiiiiiiii_57
,jsCall_iiiiiiiii_58,jsCall_iiiiiiiii_59,jsCall_iiiiiiiii_60,jsCall_iiiiiiiii_61,jsCall_iiiiiiiii_62,jsCall_iiiiiiiii_63,_sqlite3_create_function,_sqlite3_create_function16,_sqlite3_blob_open,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11
,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11
,b11,b11,b11,b11,b11,b11,b11,b11,b11];
var FUNCTION_TABLE_iiiiiiiiii = [b12,jsCall_iiiiiiiiii_0,jsCall_iiiiiiiiii_1,jsCall_iiiiiiiiii_2,jsCall_iiiiiiiiii_3,jsCall_iiiiiiiiii_4,jsCall_iiiiiiiiii_5,jsCall_iiiiiiiiii_6,jsCall_iiiiiiiiii_7,jsCall_iiiiiiiiii_8,jsCall_iiiiiiiiii_9,jsCall_iiiiiiiiii_10,jsCall_iiiiiiiiii_11,jsCall_iiiiiiiiii_12,jsCall_iiiiiiiiii_13,jsCall_iiiiiiiiii_14,jsCall_iiiiiiiiii_15,jsCall_iiiiiiiiii_16,jsCall_iiiiiiiiii_17,jsCall_iiiiiiiiii_18,jsCall_iiiiiiiiii_19,jsCall_iiiiiiiiii_20,jsCall_iiiiiiiiii_21,jsCall_iiiiiiiiii_22,jsCall_iiiiiiiiii_23,jsCall_iiiiiiiiii_24,jsCall_iiiiiiiiii_25,jsCall_iiiiiiiiii_26,jsCall_iiiiiiiiii_27
,jsCall_iiiiiiiiii_28,jsCall_iiiiiiiiii_29,jsCall_iiiiiiiiii_30,jsCall_iiiiiiiiii_31,jsCall_iiiiiiiiii_32,jsCall_iiiiiiiiii_33,jsCall_iiiiiiiiii_34,jsCall_iiiiiiiiii_35,jsCall_iiiiiiiiii_36,jsCall_iiiiiiiiii_37,jsCall_iiiiiiiiii_38,jsCall_iiiiiiiiii_39,jsCall_iiiiiiiiii_40,jsCall_iiiiiiiiii_41,jsCall_iiiiiiiiii_42,jsCall_iiiiiiiiii_43,jsCall_iiiiiiiiii_44,jsCall_iiiiiiiiii_45,jsCall_iiiiiiiiii_46,jsCall_iiiiiiiiii_47,jsCall_iiiiiiiiii_48,jsCall_iiiiiiiiii_49,jsCall_iiiiiiiiii_50,jsCall_iiiiiiiiii_51,jsCall_iiiiiiiiii_52,jsCall_iiiiiiiiii_53,jsCall_iiiiiiiiii_54,jsCall_iiiiiiiiii_55,jsCall_iiiiiiiiii_56,jsCall_iiiiiiiiii_57
,jsCall_iiiiiiiiii_58,jsCall_iiiiiiiiii_59,jsCall_iiiiiiiiii_60,jsCall_iiiiiiiiii_61,jsCall_iiiiiiiiii_62,jsCall_iiiiiiiiii_63,_sqlite3_table_column_metadata,_sqlite3_create_function_v2,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12
,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12
,b12,b12,b12,b12,b12,b12,b12,b12,b12];
var FUNCTION_TABLE_v = [b13,jsCall_v_0,jsCall_v_1,jsCall_v_2,jsCall_v_3,jsCall_v_4,jsCall_v_5,jsCall_v_6,jsCall_v_7,jsCall_v_8,jsCall_v_9,jsCall_v_10,jsCall_v_11,jsCall_v_12,jsCall_v_13,jsCall_v_14,jsCall_v_15,jsCall_v_16,jsCall_v_17,jsCall_v_18,jsCall_v_19,jsCall_v_20,jsCall_v_21,jsCall_v_22,jsCall_v_23,jsCall_v_24,jsCall_v_25,jsCall_v_26,jsCall_v_27
,jsCall_v_28,jsCall_v_29,jsCall_v_30,jsCall_v_31,jsCall_v_32,jsCall_v_33,jsCall_v_34,jsCall_v_35,jsCall_v_36,jsCall_v_37,jsCall_v_38,jsCall_v_39,jsCall_v_40,jsCall_v_41,jsCall_v_42,jsCall_v_43,jsCall_v_44,jsCall_v_45,jsCall_v_46,jsCall_v_47,jsCall_v_48,jsCall_v_49,jsCall_v_50,jsCall_v_51,jsCall_v_52,jsCall_v_53,jsCall_v_54,jsCall_v_55,jsCall_v_56,jsCall_v_57
,jsCall_v_58,jsCall_v_59,jsCall_v_60,jsCall_v_61,jsCall_v_62,jsCall_v_63,_sqlite3_thread_cleanup,_sqlite3_reset_auto_extension,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13
,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13
,b13,b13,b13,b13,b13,b13,b13,b13,b13];
var FUNCTION_TABLE_vi = [b14,jsCall_vi_0,jsCall_vi_1,jsCall_vi_2,jsCall_vi_3,jsCall_vi_4,jsCall_vi_5,jsCall_vi_6,jsCall_vi_7,jsCall_vi_8,jsCall_vi_9,jsCall_vi_10,jsCall_vi_11,jsCall_vi_12,jsCall_vi_13,jsCall_vi_14,jsCall_vi_15,jsCall_vi_16,jsCall_vi_17,jsCall_vi_18,jsCall_vi_19,jsCall_vi_20,jsCall_vi_21,jsCall_vi_22,jsCall_vi_23,jsCall_vi_24,jsCall_vi_25,jsCall_vi_26,jsCall_vi_27
,jsCall_vi_28,jsCall_vi_29,jsCall_vi_30,jsCall_vi_31,jsCall_vi_32,jsCall_vi_33,jsCall_vi_34,jsCall_vi_35,jsCall_vi_36,jsCall_vi_37,jsCall_vi_38,jsCall_vi_39,jsCall_vi_40,jsCall_vi_41,jsCall_vi_42,jsCall_vi_43,jsCall_vi_44,jsCall_vi_45,jsCall_vi_46,jsCall_vi_47,jsCall_vi_48,jsCall_vi_49,jsCall_vi_50,jsCall_vi_51,jsCall_vi_52,jsCall_vi_53,jsCall_vi_54,jsCall_vi_55,jsCall_vi_56,jsCall_vi_57
,jsCall_vi_58,jsCall_vi_59,jsCall_vi_60,jsCall_vi_61,jsCall_vi_62,jsCall_vi_63,_stdevFinalize,_varianceFinalize,_modeFinalize,_medianFinalize,_lower_quartileFinalize,_upper_quartileFinalize,_unixShmBarrier,_pcache1Shutdown,_pcache1Destroy,_pcache1Shrink,_sqlite3MemFree,_sqlite3MemShutdown,_minMaxFinalize,_sumFinalize,_totalFinalize,_avgFinalize,_countFinalize,_groupConcatFinalize,_sqlite3_free,_sqlite3_free_table,_sqlite3_interrupt,_sqlite3_result_null,_sqlite3_mutex_enter,_sqlite3_mutex_free
,_sqlite3_mutex_leave,_sqlite3_result_error_nomem,_sqlite3_result_error_toobig,_sqlite3_soft_heap_limit,_sqlite3_value_free,_noopMutexFree,_noopMutexEnter,_noopMutexLeave,_pthreadMutexFree,_pthreadMutexEnter,_pthreadMutexLeave,_sqlite3NoopDestructor,_pageReinit,_stat4Destructor,_sqlite3SchemaClear,b14,b14,b14,b14,b14,b14,b14,b14,b14,b14,b14,b14,b14,b14,b14
,b14,b14,b14,b14,b14,b14,b14,b14,b14];
var FUNCTION_TABLE_vid = [b15,jsCall_vid_0,jsCall_vid_1,jsCall_vid_2,jsCall_vid_3,jsCall_vid_4,jsCall_vid_5,jsCall_vid_6,jsCall_vid_7,jsCall_vid_8,jsCall_vid_9,jsCall_vid_10,jsCall_vid_11,jsCall_vid_12,jsCall_vid_13,jsCall_vid_14,jsCall_vid_15,jsCall_vid_16,jsCall_vid_17,jsCall_vid_18,jsCall_vid_19,jsCall_vid_20,jsCall_vid_21,jsCall_vid_22,jsCall_vid_23,jsCall_vid_24,jsCall_vid_25,jsCall_vid_26,jsCall_vid_27
,jsCall_vid_28,jsCall_vid_29,jsCall_vid_30,jsCall_vid_31,jsCall_vid_32,jsCall_vid_33,jsCall_vid_34,jsCall_vid_35,jsCall_vid_36,jsCall_vid_37,jsCall_vid_38,jsCall_vid_39,jsCall_vid_40,jsCall_vid_41,jsCall_vid_42,jsCall_vid_43,jsCall_vid_44,jsCall_vid_45,jsCall_vid_46,jsCall_vid_47,jsCall_vid_48,jsCall_vid_49,jsCall_vid_50,jsCall_vid_51,jsCall_vid_52,jsCall_vid_53,jsCall_vid_54,jsCall_vid_55,jsCall_vid_56,jsCall_vid_57
,jsCall_vid_58,jsCall_vid_59,jsCall_vid_60,jsCall_vid_61,jsCall_vid_62,jsCall_vid_63,_sqlite3_result_double,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15
,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15
,b15,b15,b15,b15,b15,b15,b15,b15,b15];
var FUNCTION_TABLE_vii = [b16,jsCall_vii_0,jsCall_vii_1,jsCall_vii_2,jsCall_vii_3,jsCall_vii_4,jsCall_vii_5,jsCall_vii_6,jsCall_vii_7,jsCall_vii_8,jsCall_vii_9,jsCall_vii_10,jsCall_vii_11,jsCall_vii_12,jsCall_vii_13,jsCall_vii_14,jsCall_vii_15,jsCall_vii_16,jsCall_vii_17,jsCall_vii_18,jsCall_vii_19,jsCall_vii_20,jsCall_vii_21,jsCall_vii_22,jsCall_vii_23,jsCall_vii_24,jsCall_vii_25,jsCall_vii_26,jsCall_vii_27
,jsCall_vii_28,jsCall_vii_29,jsCall_vii_30,jsCall_vii_31,jsCall_vii_32,jsCall_vii_33,jsCall_vii_34,jsCall_vii_35,jsCall_vii_36,jsCall_vii_37,jsCall_vii_38,jsCall_vii_39,jsCall_vii_40,jsCall_vii_41,jsCall_vii_42,jsCall_vii_43,jsCall_vii_44,jsCall_vii_45,jsCall_vii_46,jsCall_vii_47,jsCall_vii_48,jsCall_vii_49,jsCall_vii_50,jsCall_vii_51,jsCall_vii_52,jsCall_vii_53,jsCall_vii_54,jsCall_vii_55,jsCall_vii_56,jsCall_vii_57
,jsCall_vii_58,jsCall_vii_59,jsCall_vii_60,jsCall_vii_61,jsCall_vii_62,jsCall_vii_63,_unixDlClose,_pcache1Cachesize,_pcache1Truncate,_sqlite3_result_int,_sqlite3_result_value,_sqlite3_result_zeroblob,_sqlite3_result_error_code,_sqlite3_randomness,_sqlite3_result_subtype,_selectPopWith,_selectAddSubqueryTypeInfo,_analyzeAggregatesInSelectEnd,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16
,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16
,b16,b16,b16,b16,b16,b16,b16,b16,b16];
var FUNCTION_TABLE_viii = [b17,jsCall_viii_0,jsCall_viii_1,jsCall_viii_2,jsCall_viii_3,jsCall_viii_4,jsCall_viii_5,jsCall_viii_6,jsCall_viii_7,jsCall_viii_8,jsCall_viii_9,jsCall_viii_10,jsCall_viii_11,jsCall_viii_12,jsCall_viii_13,jsCall_viii_14,jsCall_viii_15,jsCall_viii_16,jsCall_viii_17,jsCall_viii_18,jsCall_viii_19,jsCall_viii_20,jsCall_viii_21,jsCall_viii_22,jsCall_viii_23,jsCall_viii_24,jsCall_viii_25,jsCall_viii_26,jsCall_viii_27
,jsCall_viii_28,jsCall_viii_29,jsCall_viii_30,jsCall_viii_31,jsCall_viii_32,jsCall_viii_33,jsCall_viii_34,jsCall_viii_35,jsCall_viii_36,jsCall_viii_37,jsCall_viii_38,jsCall_viii_39,jsCall_viii_40,jsCall_viii_41,jsCall_viii_42,jsCall_viii_43,jsCall_viii_44,jsCall_viii_45,jsCall_viii_46,jsCall_viii_47,jsCall_viii_48,jsCall_viii_49,jsCall_viii_50,jsCall_viii_51,jsCall_viii_52,jsCall_viii_53,jsCall_viii_54,jsCall_viii_55,jsCall_viii_56,jsCall_viii_57
,jsCall_viii_58,jsCall_viii_59,jsCall_viii_60,jsCall_viii_61,jsCall_viii_62,jsCall_viii_63,_acosFunc,_asinFunc,_atanFunc,_atn2Func,_acoshFunc,_asinhFunc,_atanhFunc,_differenceFunc,_rad2degFunc,_deg2radFunc,_cosFunc,_sinFunc,_tanFunc,_cotFunc,_coshFunc,_sinhFunc,_tanhFunc,_cothFunc,_expFunc,_logFunc,_log10Func,_powerFunc,_signFunc,_sqrtFunc
,_squareFunc,_ceilFunc,_floorFunc,_piFunc,_replicateFunc,_charindexFunc,_leftFunc,_rightFunc,_reverseFunc,_properFunc,_padlFunc,_padrFunc,_padcFunc,_strfilterFunc,_varianceStep,_modeStep,_unixDlError,_pcache1Unpin,_loadExt,_compileoptionusedFunc,_compileoptiongetFunc,_versionFunc,_trimFunc,_minmaxFunc,_minmaxStep,_typeofFunc,_lengthFunc,_instrFunc,_printfFunc,_unicodeFunc
,_charFunc,_absFunc,_roundFunc,_upperFunc,_lowerFunc,_hexFunc,_randomFunc,_randomBlob,_nullifFunc,_sourceidFunc,_errlogFunc,_quoteFunc,_last_insert_rowid,_changes,_total_changes,_replaceFunc,_zeroblobFunc,_substrFunc,_sumStep,_countStep,_groupConcatStep,_likeFunc,_sqlite3_result_error,_sqlite3_result_error16,_sqlite3_result_int64,_sqlite3_log,_sqlite3_set_last_insert_rowid,_statInit,_statPush,_statGet
,_detachFunc,_attachFunc,_juliandayFunc,_dateFunc,_timeFunc,_datetimeFunc,_strftimeFunc,_ctimeFunc,_ctimestampFunc,_cdateFunc,_renameTableFunc,_renameTriggerFunc,_renameParentFunc,_sqlite3InvalidFunction,_btreeParseCellPtrIndex,_btreeParseCellPtr,_btreeParseCellPtrNoPayload,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17
,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17
,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17
,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17,b17];
var FUNCTION_TABLE_viiii = [b18,jsCall_viiii_0,jsCall_viiii_1,jsCall_viiii_2,jsCall_viiii_3,jsCall_viiii_4,jsCall_viiii_5,jsCall_viiii_6,jsCall_viiii_7,jsCall_viiii_8,jsCall_viiii_9,jsCall_viiii_10,jsCall_viiii_11,jsCall_viiii_12,jsCall_viiii_13,jsCall_viiii_14,jsCall_viiii_15,jsCall_viiii_16,jsCall_viiii_17,jsCall_viiii_18,jsCall_viiii_19,jsCall_viiii_20,jsCall_viiii_21,jsCall_viiii_22,jsCall_viiii_23,jsCall_viiii_24,jsCall_viiii_25,jsCall_viiii_26,jsCall_viiii_27
,jsCall_viiii_28,jsCall_viiii_29,jsCall_viiii_30,jsCall_viiii_31,jsCall_viiii_32,jsCall_viiii_33,jsCall_viiii_34,jsCall_viiii_35,jsCall_viiii_36,jsCall_viiii_37,jsCall_viiii_38,jsCall_viiii_39,jsCall_viiii_40,jsCall_viiii_41,jsCall_viiii_42,jsCall_viiii_43,jsCall_viiii_44,jsCall_viiii_45,jsCall_viiii_46,jsCall_viiii_47,jsCall_viiii_48,jsCall_viiii_49,jsCall_viiii_50,jsCall_viiii_51,jsCall_viiii_52,jsCall_viiii_53,jsCall_viiii_54,jsCall_viiii_55,jsCall_viiii_56,jsCall_viiii_57
,jsCall_viiii_58,jsCall_viiii_59,jsCall_viiii_60,jsCall_viiii_61,jsCall_viiii_62,jsCall_viiii_63,_pcache1Rekey,_sqlite3_progress_handler,_sqlite3_result_blob,_sqlite3_result_text,_sqlite3_result_text16,_sqlite3_result_text16be,_sqlite3_result_text16le,_sqlite3_set_auxdata,_sqlite3_result_pointer,_modeIterate,_medianIterate,_sqlite3ExprIfFalse,_sqlite3ExprIfTrue,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18
,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18,b18
,b18,b18,b18,b18,b18,b18,b18,b18,b18];
var FUNCTION_TABLE_viiiii = [b19,jsCall_viiiii_0,jsCall_viiiii_1,jsCall_viiiii_2,jsCall_viiiii_3,jsCall_viiiii_4,jsCall_viiiii_5,jsCall_viiiii_6,jsCall_viiiii_7,jsCall_viiiii_8,jsCall_viiiii_9,jsCall_viiiii_10,jsCall_viiiii_11,jsCall_viiiii_12,jsCall_viiiii_13,jsCall_viiiii_14,jsCall_viiiii_15,jsCall_viiiii_16,jsCall_viiiii_17,jsCall_viiiii_18,jsCall_viiiii_19,jsCall_viiiii_20,jsCall_viiiii_21,jsCall_viiiii_22,jsCall_viiiii_23,jsCall_viiiii_24,jsCall_viiiii_25,jsCall_viiiii_26,jsCall_viiiii_27
,jsCall_viiiii_28,jsCall_viiiii_29,jsCall_viiiii_30,jsCall_viiiii_31,jsCall_viiiii_32,jsCall_viiiii_33,jsCall_viiiii_34,jsCall_viiiii_35,jsCall_viiiii_36,jsCall_viiiii_37,jsCall_viiiii_38,jsCall_viiiii_39,jsCall_viiiii_40,jsCall_viiiii_41,jsCall_viiiii_42,jsCall_viiiii_43,jsCall_viiiii_44,jsCall_viiiii_45,jsCall_viiiii_46,jsCall_viiiii_47,jsCall_viiiii_48,jsCall_viiiii_49,jsCall_viiiii_50,jsCall_viiiii_51,jsCall_viiiii_52,jsCall_viiiii_53,jsCall_viiiii_54,jsCall_viiiii_55,jsCall_viiiii_56,jsCall_viiiii_57
,jsCall_viiiii_58,jsCall_viiiii_59,jsCall_viiiii_60,jsCall_viiiii_61,jsCall_viiiii_62,jsCall_viiiii_63,_sqlite3_result_blob64,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19
,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19,b19
,b19,b19,b19,b19,b19,b19,b19,b19,b19];
var FUNCTION_TABLE_viiiiii = [b20,jsCall_viiiiii_0,jsCall_viiiiii_1,jsCall_viiiiii_2,jsCall_viiiiii_3,jsCall_viiiiii_4,jsCall_viiiiii_5,jsCall_viiiiii_6,jsCall_viiiiii_7,jsCall_viiiiii_8,jsCall_viiiiii_9,jsCall_viiiiii_10,jsCall_viiiiii_11,jsCall_viiiiii_12,jsCall_viiiiii_13,jsCall_viiiiii_14,jsCall_viiiiii_15,jsCall_viiiiii_16,jsCall_viiiiii_17,jsCall_viiiiii_18,jsCall_viiiiii_19,jsCall_viiiiii_20,jsCall_viiiiii_21,jsCall_viiiiii_22,jsCall_viiiiii_23,jsCall_viiiiii_24,jsCall_viiiiii_25,jsCall_viiiiii_26,jsCall_viiiiii_27
,jsCall_viiiiii_28,jsCall_viiiiii_29,jsCall_viiiiii_30,jsCall_viiiiii_31,jsCall_viiiiii_32,jsCall_viiiiii_33,jsCall_viiiiii_34,jsCall_viiiiii_35,jsCall_viiiiii_36,jsCall_viiiiii_37,jsCall_viiiiii_38,jsCall_viiiiii_39,jsCall_viiiiii_40,jsCall_viiiiii_41,jsCall_viiiiii_42,jsCall_viiiiii_43,jsCall_viiiiii_44,jsCall_viiiiii_45,jsCall_viiiiii_46,jsCall_viiiiii_47,jsCall_viiiiii_48,jsCall_viiiiii_49,jsCall_viiiiii_50,jsCall_viiiiii_51,jsCall_viiiiii_52,jsCall_viiiiii_53,jsCall_viiiiii_54,jsCall_viiiiii_55,jsCall_viiiiii_56,jsCall_viiiiii_57
,jsCall_viiiiii_58,jsCall_viiiiii_59,jsCall_viiiiii_60,jsCall_viiiiii_61,jsCall_viiiiii_62,jsCall_viiiiii_63,_sqlite3_result_text64,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20
,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20
,b20,b20,b20,b20,b20,b20,b20,b20,b20];

  return { _RegisterExtensionFunctions: _RegisterExtensionFunctions, ___divdi3: ___divdi3, ___emscripten_environ_constructor: ___emscripten_environ_constructor, ___errno_location: ___errno_location, ___muldi3: ___muldi3, ___remdi3: ___remdi3, ___udivdi3: ___udivdi3, ___uremdi3: ___uremdi3, __get_daylight: __get_daylight, __get_environ: __get_environ, __get_timezone: __get_timezone, __get_tzname: __get_tzname, _bitshift64Ashr: _bitshift64Ashr, _bitshift64Lshr: _bitshift64Lshr, _bitshift64Shl: _bitshift64Shl, _fflush: _fflush, _free: _free, _i64Add: _i64Add, _i64Subtract: _i64Subtract, _llvm_bswap_i32: _llvm_bswap_i32, _malloc: _malloc, _memalign: _memalign, _memcpy: _memcpy, _memmove: _memmove, _memset: _memset, _pthread_mutex_lock: _pthread_mutex_lock, _pthread_mutex_trylock: _pthread_mutex_trylock, _pthread_mutex_unlock: _pthread_mutex_unlock, _sbrk: _sbrk, _sqlite3_bind_blob: _sqlite3_bind_blob, _sqlite3_bind_double: _sqlite3_bind_double, _sqlite3_bind_int: _sqlite3_bind_int, _sqlite3_bind_parameter_index: _sqlite3_bind_parameter_index, _sqlite3_bind_text: _sqlite3_bind_text, _sqlite3_changes: _sqlite3_changes, _sqlite3_clear_bindings: _sqlite3_clear_bindings, _sqlite3_close_v2: _sqlite3_close_v2, _sqlite3_column_blob: _sqlite3_column_blob, _sqlite3_column_bytes: _sqlite3_column_bytes, _sqlite3_column_double: _sqlite3_column_double, _sqlite3_column_name: _sqlite3_column_name, _sqlite3_column_text: _sqlite3_column_text, _sqlite3_column_type: _sqlite3_column_type, _sqlite3_create_function_v2: _sqlite3_create_function_v2, _sqlite3_data_count: _sqlite3_data_count, _sqlite3_errmsg: _sqlite3_errmsg, _sqlite3_exec: _sqlite3_exec, _sqlite3_finalize: _sqlite3_finalize, _sqlite3_free: _sqlite3_free, _sqlite3_open: _sqlite3_open, _sqlite3_prepare_v2: _sqlite3_prepare_v2, _sqlite3_reset: _sqlite3_reset, _sqlite3_result_double: _sqlite3_result_double, _sqlite3_result_null: _sqlite3_result_null, _sqlite3_result_text: _sqlite3_result_text, _sqlite3_step: _sqlite3_step, _sqlite3_value_blob: _sqlite3_value_blob, _sqlite3_value_bytes: _sqlite3_value_bytes, _sqlite3_value_double: _sqlite3_value_double, _sqlite3_value_int: _sqlite3_value_int, _sqlite3_value_text: _sqlite3_value_text, _sqlite3_value_type: _sqlite3_value_type, dynCall_di: dynCall_di, dynCall_dii: dynCall_dii, dynCall_i: dynCall_i, dynCall_ii: dynCall_ii, dynCall_iii: dynCall_iii, dynCall_iiid: dynCall_iiid, dynCall_iiii: dynCall_iiii, dynCall_iiiii: dynCall_iiiii, dynCall_iiiiii: dynCall_iiiiii, dynCall_iiiiiii: dynCall_iiiiiii, dynCall_iiiiiiii: dynCall_iiiiiiii, dynCall_iiiiiiiii: dynCall_iiiiiiiii, dynCall_iiiiiiiiii: dynCall_iiiiiiiiii, dynCall_v: dynCall_v, dynCall_vi: dynCall_vi, dynCall_vid: dynCall_vid, dynCall_vii: dynCall_vii, dynCall_viii: dynCall_viii, dynCall_viiii: dynCall_viiii, dynCall_viiiii: dynCall_viiiii, dynCall_viiiiii: dynCall_viiiiii, establishStackSpace: establishStackSpace, getTempRet0: getTempRet0, runPostSets: runPostSets, setTempRet0: setTempRet0, setThrew: setThrew, stackAlloc: stackAlloc, stackRestore: stackRestore, stackSave: stackSave };
})
// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg, Module.asmLibraryArg, buffer);

var real__RegisterExtensionFunctions = asm["_RegisterExtensionFunctions"]; asm["_RegisterExtensionFunctions"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__RegisterExtensionFunctions.apply(null, arguments);
};

var real____divdi3 = asm["___divdi3"]; asm["___divdi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____divdi3.apply(null, arguments);
};

var real____emscripten_environ_constructor = asm["___emscripten_environ_constructor"]; asm["___emscripten_environ_constructor"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____emscripten_environ_constructor.apply(null, arguments);
};

var real____errno_location = asm["___errno_location"]; asm["___errno_location"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____errno_location.apply(null, arguments);
};

var real____muldi3 = asm["___muldi3"]; asm["___muldi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____muldi3.apply(null, arguments);
};

var real____remdi3 = asm["___remdi3"]; asm["___remdi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____remdi3.apply(null, arguments);
};

var real____udivdi3 = asm["___udivdi3"]; asm["___udivdi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____udivdi3.apply(null, arguments);
};

var real____uremdi3 = asm["___uremdi3"]; asm["___uremdi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____uremdi3.apply(null, arguments);
};

var real___get_daylight = asm["__get_daylight"]; asm["__get_daylight"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real___get_daylight.apply(null, arguments);
};

var real___get_environ = asm["__get_environ"]; asm["__get_environ"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real___get_environ.apply(null, arguments);
};

var real___get_timezone = asm["__get_timezone"]; asm["__get_timezone"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real___get_timezone.apply(null, arguments);
};

var real___get_tzname = asm["__get_tzname"]; asm["__get_tzname"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real___get_tzname.apply(null, arguments);
};

var real__bitshift64Ashr = asm["_bitshift64Ashr"]; asm["_bitshift64Ashr"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__bitshift64Ashr.apply(null, arguments);
};

var real__bitshift64Lshr = asm["_bitshift64Lshr"]; asm["_bitshift64Lshr"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__bitshift64Lshr.apply(null, arguments);
};

var real__bitshift64Shl = asm["_bitshift64Shl"]; asm["_bitshift64Shl"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__bitshift64Shl.apply(null, arguments);
};

var real__fflush = asm["_fflush"]; asm["_fflush"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__fflush.apply(null, arguments);
};

var real__free = asm["_free"]; asm["_free"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__free.apply(null, arguments);
};

var real__i64Add = asm["_i64Add"]; asm["_i64Add"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__i64Add.apply(null, arguments);
};

var real__i64Subtract = asm["_i64Subtract"]; asm["_i64Subtract"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__i64Subtract.apply(null, arguments);
};

var real__llvm_bswap_i32 = asm["_llvm_bswap_i32"]; asm["_llvm_bswap_i32"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__llvm_bswap_i32.apply(null, arguments);
};

var real__malloc = asm["_malloc"]; asm["_malloc"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__malloc.apply(null, arguments);
};

var real__memalign = asm["_memalign"]; asm["_memalign"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__memalign.apply(null, arguments);
};

var real__memmove = asm["_memmove"]; asm["_memmove"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__memmove.apply(null, arguments);
};

var real__pthread_mutex_lock = asm["_pthread_mutex_lock"]; asm["_pthread_mutex_lock"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__pthread_mutex_lock.apply(null, arguments);
};

var real__pthread_mutex_trylock = asm["_pthread_mutex_trylock"]; asm["_pthread_mutex_trylock"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__pthread_mutex_trylock.apply(null, arguments);
};

var real__pthread_mutex_unlock = asm["_pthread_mutex_unlock"]; asm["_pthread_mutex_unlock"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__pthread_mutex_unlock.apply(null, arguments);
};

var real__sbrk = asm["_sbrk"]; asm["_sbrk"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sbrk.apply(null, arguments);
};

var real__sqlite3_bind_blob = asm["_sqlite3_bind_blob"]; asm["_sqlite3_bind_blob"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_bind_blob.apply(null, arguments);
};

var real__sqlite3_bind_double = asm["_sqlite3_bind_double"]; asm["_sqlite3_bind_double"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_bind_double.apply(null, arguments);
};

var real__sqlite3_bind_int = asm["_sqlite3_bind_int"]; asm["_sqlite3_bind_int"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_bind_int.apply(null, arguments);
};

var real__sqlite3_bind_parameter_index = asm["_sqlite3_bind_parameter_index"]; asm["_sqlite3_bind_parameter_index"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_bind_parameter_index.apply(null, arguments);
};

var real__sqlite3_bind_text = asm["_sqlite3_bind_text"]; asm["_sqlite3_bind_text"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_bind_text.apply(null, arguments);
};

var real__sqlite3_changes = asm["_sqlite3_changes"]; asm["_sqlite3_changes"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_changes.apply(null, arguments);
};

var real__sqlite3_clear_bindings = asm["_sqlite3_clear_bindings"]; asm["_sqlite3_clear_bindings"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_clear_bindings.apply(null, arguments);
};

var real__sqlite3_close_v2 = asm["_sqlite3_close_v2"]; asm["_sqlite3_close_v2"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_close_v2.apply(null, arguments);
};

var real__sqlite3_column_blob = asm["_sqlite3_column_blob"]; asm["_sqlite3_column_blob"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_column_blob.apply(null, arguments);
};

var real__sqlite3_column_bytes = asm["_sqlite3_column_bytes"]; asm["_sqlite3_column_bytes"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_column_bytes.apply(null, arguments);
};

var real__sqlite3_column_double = asm["_sqlite3_column_double"]; asm["_sqlite3_column_double"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_column_double.apply(null, arguments);
};

var real__sqlite3_column_name = asm["_sqlite3_column_name"]; asm["_sqlite3_column_name"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_column_name.apply(null, arguments);
};

var real__sqlite3_column_text = asm["_sqlite3_column_text"]; asm["_sqlite3_column_text"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_column_text.apply(null, arguments);
};

var real__sqlite3_column_type = asm["_sqlite3_column_type"]; asm["_sqlite3_column_type"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_column_type.apply(null, arguments);
};

var real__sqlite3_create_function_v2 = asm["_sqlite3_create_function_v2"]; asm["_sqlite3_create_function_v2"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_create_function_v2.apply(null, arguments);
};

var real__sqlite3_data_count = asm["_sqlite3_data_count"]; asm["_sqlite3_data_count"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_data_count.apply(null, arguments);
};

var real__sqlite3_errmsg = asm["_sqlite3_errmsg"]; asm["_sqlite3_errmsg"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_errmsg.apply(null, arguments);
};

var real__sqlite3_exec = asm["_sqlite3_exec"]; asm["_sqlite3_exec"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_exec.apply(null, arguments);
};

var real__sqlite3_finalize = asm["_sqlite3_finalize"]; asm["_sqlite3_finalize"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_finalize.apply(null, arguments);
};

var real__sqlite3_free = asm["_sqlite3_free"]; asm["_sqlite3_free"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_free.apply(null, arguments);
};

var real__sqlite3_open = asm["_sqlite3_open"]; asm["_sqlite3_open"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_open.apply(null, arguments);
};

var real__sqlite3_prepare_v2 = asm["_sqlite3_prepare_v2"]; asm["_sqlite3_prepare_v2"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_prepare_v2.apply(null, arguments);
};

var real__sqlite3_reset = asm["_sqlite3_reset"]; asm["_sqlite3_reset"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_reset.apply(null, arguments);
};

var real__sqlite3_result_double = asm["_sqlite3_result_double"]; asm["_sqlite3_result_double"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_result_double.apply(null, arguments);
};

var real__sqlite3_result_null = asm["_sqlite3_result_null"]; asm["_sqlite3_result_null"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_result_null.apply(null, arguments);
};

var real__sqlite3_result_text = asm["_sqlite3_result_text"]; asm["_sqlite3_result_text"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_result_text.apply(null, arguments);
};

var real__sqlite3_step = asm["_sqlite3_step"]; asm["_sqlite3_step"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_step.apply(null, arguments);
};

var real__sqlite3_value_blob = asm["_sqlite3_value_blob"]; asm["_sqlite3_value_blob"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_value_blob.apply(null, arguments);
};

var real__sqlite3_value_bytes = asm["_sqlite3_value_bytes"]; asm["_sqlite3_value_bytes"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_value_bytes.apply(null, arguments);
};

var real__sqlite3_value_double = asm["_sqlite3_value_double"]; asm["_sqlite3_value_double"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_value_double.apply(null, arguments);
};

var real__sqlite3_value_int = asm["_sqlite3_value_int"]; asm["_sqlite3_value_int"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_value_int.apply(null, arguments);
};

var real__sqlite3_value_text = asm["_sqlite3_value_text"]; asm["_sqlite3_value_text"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_value_text.apply(null, arguments);
};

var real__sqlite3_value_type = asm["_sqlite3_value_type"]; asm["_sqlite3_value_type"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sqlite3_value_type.apply(null, arguments);
};

var real_establishStackSpace = asm["establishStackSpace"]; asm["establishStackSpace"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_establishStackSpace.apply(null, arguments);
};

var real_getTempRet0 = asm["getTempRet0"]; asm["getTempRet0"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_getTempRet0.apply(null, arguments);
};

var real_setTempRet0 = asm["setTempRet0"]; asm["setTempRet0"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_setTempRet0.apply(null, arguments);
};

var real_setThrew = asm["setThrew"]; asm["setThrew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_setThrew.apply(null, arguments);
};

var real_stackAlloc = asm["stackAlloc"]; asm["stackAlloc"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_stackAlloc.apply(null, arguments);
};

var real_stackRestore = asm["stackRestore"]; asm["stackRestore"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_stackRestore.apply(null, arguments);
};

var real_stackSave = asm["stackSave"]; asm["stackSave"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_stackSave.apply(null, arguments);
};
var _RegisterExtensionFunctions = Module["_RegisterExtensionFunctions"] = asm["_RegisterExtensionFunctions"];
var ___divdi3 = Module["___divdi3"] = asm["___divdi3"];
var ___emscripten_environ_constructor = Module["___emscripten_environ_constructor"] = asm["___emscripten_environ_constructor"];
var ___errno_location = Module["___errno_location"] = asm["___errno_location"];
var ___muldi3 = Module["___muldi3"] = asm["___muldi3"];
var ___remdi3 = Module["___remdi3"] = asm["___remdi3"];
var ___udivdi3 = Module["___udivdi3"] = asm["___udivdi3"];
var ___uremdi3 = Module["___uremdi3"] = asm["___uremdi3"];
var __get_daylight = Module["__get_daylight"] = asm["__get_daylight"];
var __get_environ = Module["__get_environ"] = asm["__get_environ"];
var __get_timezone = Module["__get_timezone"] = asm["__get_timezone"];
var __get_tzname = Module["__get_tzname"] = asm["__get_tzname"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _fflush = Module["_fflush"] = asm["_fflush"];
var _free = Module["_free"] = asm["_free"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _llvm_bswap_i32 = Module["_llvm_bswap_i32"] = asm["_llvm_bswap_i32"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _memalign = Module["_memalign"] = asm["_memalign"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _memset = Module["_memset"] = asm["_memset"];
var _pthread_mutex_lock = Module["_pthread_mutex_lock"] = asm["_pthread_mutex_lock"];
var _pthread_mutex_trylock = Module["_pthread_mutex_trylock"] = asm["_pthread_mutex_trylock"];
var _pthread_mutex_unlock = Module["_pthread_mutex_unlock"] = asm["_pthread_mutex_unlock"];
var _sbrk = Module["_sbrk"] = asm["_sbrk"];
var _sqlite3_bind_blob = Module["_sqlite3_bind_blob"] = asm["_sqlite3_bind_blob"];
var _sqlite3_bind_double = Module["_sqlite3_bind_double"] = asm["_sqlite3_bind_double"];
var _sqlite3_bind_int = Module["_sqlite3_bind_int"] = asm["_sqlite3_bind_int"];
var _sqlite3_bind_parameter_index = Module["_sqlite3_bind_parameter_index"] = asm["_sqlite3_bind_parameter_index"];
var _sqlite3_bind_text = Module["_sqlite3_bind_text"] = asm["_sqlite3_bind_text"];
var _sqlite3_changes = Module["_sqlite3_changes"] = asm["_sqlite3_changes"];
var _sqlite3_clear_bindings = Module["_sqlite3_clear_bindings"] = asm["_sqlite3_clear_bindings"];
var _sqlite3_close_v2 = Module["_sqlite3_close_v2"] = asm["_sqlite3_close_v2"];
var _sqlite3_column_blob = Module["_sqlite3_column_blob"] = asm["_sqlite3_column_blob"];
var _sqlite3_column_bytes = Module["_sqlite3_column_bytes"] = asm["_sqlite3_column_bytes"];
var _sqlite3_column_double = Module["_sqlite3_column_double"] = asm["_sqlite3_column_double"];
var _sqlite3_column_name = Module["_sqlite3_column_name"] = asm["_sqlite3_column_name"];
var _sqlite3_column_text = Module["_sqlite3_column_text"] = asm["_sqlite3_column_text"];
var _sqlite3_column_type = Module["_sqlite3_column_type"] = asm["_sqlite3_column_type"];
var _sqlite3_create_function_v2 = Module["_sqlite3_create_function_v2"] = asm["_sqlite3_create_function_v2"];
var _sqlite3_data_count = Module["_sqlite3_data_count"] = asm["_sqlite3_data_count"];
var _sqlite3_errmsg = Module["_sqlite3_errmsg"] = asm["_sqlite3_errmsg"];
var _sqlite3_exec = Module["_sqlite3_exec"] = asm["_sqlite3_exec"];
var _sqlite3_finalize = Module["_sqlite3_finalize"] = asm["_sqlite3_finalize"];
var _sqlite3_free = Module["_sqlite3_free"] = asm["_sqlite3_free"];
var _sqlite3_open = Module["_sqlite3_open"] = asm["_sqlite3_open"];
var _sqlite3_prepare_v2 = Module["_sqlite3_prepare_v2"] = asm["_sqlite3_prepare_v2"];
var _sqlite3_reset = Module["_sqlite3_reset"] = asm["_sqlite3_reset"];
var _sqlite3_result_double = Module["_sqlite3_result_double"] = asm["_sqlite3_result_double"];
var _sqlite3_result_null = Module["_sqlite3_result_null"] = asm["_sqlite3_result_null"];
var _sqlite3_result_text = Module["_sqlite3_result_text"] = asm["_sqlite3_result_text"];
var _sqlite3_step = Module["_sqlite3_step"] = asm["_sqlite3_step"];
var _sqlite3_value_blob = Module["_sqlite3_value_blob"] = asm["_sqlite3_value_blob"];
var _sqlite3_value_bytes = Module["_sqlite3_value_bytes"] = asm["_sqlite3_value_bytes"];
var _sqlite3_value_double = Module["_sqlite3_value_double"] = asm["_sqlite3_value_double"];
var _sqlite3_value_int = Module["_sqlite3_value_int"] = asm["_sqlite3_value_int"];
var _sqlite3_value_text = Module["_sqlite3_value_text"] = asm["_sqlite3_value_text"];
var _sqlite3_value_type = Module["_sqlite3_value_type"] = asm["_sqlite3_value_type"];
var establishStackSpace = Module["establishStackSpace"] = asm["establishStackSpace"];
var getTempRet0 = Module["getTempRet0"] = asm["getTempRet0"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var setTempRet0 = Module["setTempRet0"] = asm["setTempRet0"];
var setThrew = Module["setThrew"] = asm["setThrew"];
var stackAlloc = Module["stackAlloc"] = asm["stackAlloc"];
var stackRestore = Module["stackRestore"] = asm["stackRestore"];
var stackSave = Module["stackSave"] = asm["stackSave"];
var dynCall_di = Module["dynCall_di"] = asm["dynCall_di"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiid = Module["dynCall_iiid"] = asm["dynCall_iiid"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vid = Module["dynCall_vid"] = asm["dynCall_vid"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
;



// === Auto-generated postamble setup entry stuff ===

Module['asm'] = asm;

if (!Module["intArrayFromString"]) Module["intArrayFromString"] = function() { abort("'intArrayFromString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["intArrayToString"]) Module["intArrayToString"] = function() { abort("'intArrayToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["ccall"]) Module["ccall"] = function() { abort("'ccall' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
Module["cwrap"] = cwrap;
if (!Module["setValue"]) Module["setValue"] = function() { abort("'setValue' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getValue"]) Module["getValue"] = function() { abort("'getValue' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["allocate"]) Module["allocate"] = function() { abort("'allocate' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getMemory"]) Module["getMemory"] = function() { abort("'getMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["Pointer_stringify"]) Module["Pointer_stringify"] = function() { abort("'Pointer_stringify' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["AsciiToString"]) Module["AsciiToString"] = function() { abort("'AsciiToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToAscii"]) Module["stringToAscii"] = function() { abort("'stringToAscii' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF8ArrayToString"]) Module["UTF8ArrayToString"] = function() { abort("'UTF8ArrayToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF8ToString"]) Module["UTF8ToString"] = function() { abort("'UTF8ToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF8Array"]) Module["stringToUTF8Array"] = function() { abort("'stringToUTF8Array' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF8"]) Module["stringToUTF8"] = function() { abort("'stringToUTF8' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["lengthBytesUTF8"]) Module["lengthBytesUTF8"] = function() { abort("'lengthBytesUTF8' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF16ToString"]) Module["UTF16ToString"] = function() { abort("'UTF16ToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF16"]) Module["stringToUTF16"] = function() { abort("'stringToUTF16' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["lengthBytesUTF16"]) Module["lengthBytesUTF16"] = function() { abort("'lengthBytesUTF16' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF32ToString"]) Module["UTF32ToString"] = function() { abort("'UTF32ToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF32"]) Module["stringToUTF32"] = function() { abort("'stringToUTF32' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["lengthBytesUTF32"]) Module["lengthBytesUTF32"] = function() { abort("'lengthBytesUTF32' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["allocateUTF8"]) Module["allocateUTF8"] = function() { abort("'allocateUTF8' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stackTrace"]) Module["stackTrace"] = function() { abort("'stackTrace' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnPreRun"]) Module["addOnPreRun"] = function() { abort("'addOnPreRun' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnInit"]) Module["addOnInit"] = function() { abort("'addOnInit' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnPreMain"]) Module["addOnPreMain"] = function() { abort("'addOnPreMain' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnExit"]) Module["addOnExit"] = function() { abort("'addOnExit' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnPostRun"]) Module["addOnPostRun"] = function() { abort("'addOnPostRun' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["writeStringToMemory"]) Module["writeStringToMemory"] = function() { abort("'writeStringToMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["writeArrayToMemory"]) Module["writeArrayToMemory"] = function() { abort("'writeArrayToMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["writeAsciiToMemory"]) Module["writeAsciiToMemory"] = function() { abort("'writeAsciiToMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addRunDependency"]) Module["addRunDependency"] = function() { abort("'addRunDependency' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["removeRunDependency"]) Module["removeRunDependency"] = function() { abort("'removeRunDependency' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS"]) Module["FS"] = function() { abort("'FS' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["FS_createFolder"]) Module["FS_createFolder"] = function() { abort("'FS_createFolder' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createPath"]) Module["FS_createPath"] = function() { abort("'FS_createPath' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createDataFile"]) Module["FS_createDataFile"] = function() { abort("'FS_createDataFile' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createPreloadedFile"]) Module["FS_createPreloadedFile"] = function() { abort("'FS_createPreloadedFile' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createLazyFile"]) Module["FS_createLazyFile"] = function() { abort("'FS_createLazyFile' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createLink"]) Module["FS_createLink"] = function() { abort("'FS_createLink' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createDevice"]) Module["FS_createDevice"] = function() { abort("'FS_createDevice' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_unlink"]) Module["FS_unlink"] = function() { abort("'FS_unlink' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["GL"]) Module["GL"] = function() { abort("'GL' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["staticAlloc"]) Module["staticAlloc"] = function() { abort("'staticAlloc' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["dynamicAlloc"]) Module["dynamicAlloc"] = function() { abort("'dynamicAlloc' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["warnOnce"]) Module["warnOnce"] = function() { abort("'warnOnce' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["loadDynamicLibrary"]) Module["loadDynamicLibrary"] = function() { abort("'loadDynamicLibrary' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["loadWebAssemblyModule"]) Module["loadWebAssemblyModule"] = function() { abort("'loadWebAssemblyModule' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getLEB"]) Module["getLEB"] = function() { abort("'getLEB' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getFunctionTables"]) Module["getFunctionTables"] = function() { abort("'getFunctionTables' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["alignFunctionTables"]) Module["alignFunctionTables"] = function() { abort("'alignFunctionTables' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["registerFunctions"]) Module["registerFunctions"] = function() { abort("'registerFunctions' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addFunction"]) Module["addFunction"] = function() { abort("'addFunction' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["removeFunction"]) Module["removeFunction"] = function() { abort("'removeFunction' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getFuncWrapper"]) Module["getFuncWrapper"] = function() { abort("'getFuncWrapper' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["prettyPrint"]) Module["prettyPrint"] = function() { abort("'prettyPrint' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["makeBigInt"]) Module["makeBigInt"] = function() { abort("'makeBigInt' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["dynCall"]) Module["dynCall"] = function() { abort("'dynCall' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getCompilerSetting"]) Module["getCompilerSetting"] = function() { abort("'getCompilerSetting' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
Module["stackSave"] = stackSave;
Module["stackRestore"] = stackRestore;
Module["stackAlloc"] = stackAlloc;if (!Module["ALLOC_NORMAL"]) Object.defineProperty(Module, "ALLOC_NORMAL", { get: function() { abort("'ALLOC_NORMAL' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
if (!Module["ALLOC_STACK"]) Object.defineProperty(Module, "ALLOC_STACK", { get: function() { abort("'ALLOC_STACK' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
if (!Module["ALLOC_STATIC"]) Object.defineProperty(Module, "ALLOC_STATIC", { get: function() { abort("'ALLOC_STATIC' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
if (!Module["ALLOC_DYNAMIC"]) Object.defineProperty(Module, "ALLOC_DYNAMIC", { get: function() { abort("'ALLOC_DYNAMIC' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
if (!Module["ALLOC_NONE"]) Object.defineProperty(Module, "ALLOC_NONE", { get: function() { abort("'ALLOC_NONE' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });

if (memoryInitializer) {
  if (!isDataURI(memoryInitializer)) {
    if (typeof Module['locateFile'] === 'function') {
      memoryInitializer = Module['locateFile'](memoryInitializer);
    } else if (Module['memoryInitializerPrefixURL']) {
      memoryInitializer = Module['memoryInitializerPrefixURL'] + memoryInitializer;
    }
  }
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, GLOBAL_BASE);
  } else {
    addRunDependency('memory initializer');
    var applyMemoryInitializer = function(data) {
      if (data.byteLength) data = new Uint8Array(data);
      for (var i = 0; i < data.length; i++) {
        assert(HEAPU8[GLOBAL_BASE + i] === 0, "area for memory initializer should not have been touched before it's loaded");
      }
      HEAPU8.set(data, GLOBAL_BASE);
      // Delete the typed array that contains the large blob of the memory initializer request response so that
      // we won't keep unnecessary memory lying around. However, keep the XHR object itself alive so that e.g.
      // its .status field can still be accessed later.
      if (Module['memoryInitializerRequest']) delete Module['memoryInitializerRequest'].response;
      removeRunDependency('memory initializer');
    }
    function doBrowserLoad() {
      Module['readAsync'](memoryInitializer, applyMemoryInitializer, function() {
        throw 'could not load memory initializer ' + memoryInitializer;
      });
    }
    if (Module['memoryInitializerRequest']) {
      // a network request has already been created, just use that
      function useRequest() {
        var request = Module['memoryInitializerRequest'];
        var response = request.response;
        if (request.status !== 200 && request.status !== 0) {
            // If you see this warning, the issue may be that you are using locateFile or memoryInitializerPrefixURL, and defining them in JS. That
            // means that the HTML file doesn't know about them, and when it tries to create the mem init request early, does it to the wrong place.
            // Look in your browser's devtools network console to see what's going on.
            console.warn('a problem seems to have happened with Module.memoryInitializerRequest, status: ' + request.status + ', retrying ' + memoryInitializer);
            doBrowserLoad();
            return;
        }
        applyMemoryInitializer(response);
      }
      if (Module['memoryInitializerRequest'].response) {
        setTimeout(useRequest, 0); // it's already here; but, apply it asynchronously
      } else {
        Module['memoryInitializerRequest'].addEventListener('load', useRequest); // wait for it
      }
    } else {
      // fetch it from the network ourselves
      doBrowserLoad();
    }
  }
}


// Modularize mode returns a function, which can be called to
// create instances. The instances provide a then() method,
// must like a Promise, that receives a callback. The callback
// is called when the module is ready to run, with the module
// as a parameter. (Like a Promise, it also returns the module
// so you can use the output of .then(..)).
Module['then'] = function(func) {
  // We may already be ready to run code at this time. if
  // so, just queue a call to the callback.
  if (Module['calledRun']) {
    func(Module);
  } else {
    // we are not ready to call then() yet. we must call it
    // at the same time we would call onRuntimeInitialized.
    var old = Module['onRuntimeInitialized'];
    Module['onRuntimeInitialized'] = function() {
      if (old) old();
      func(Module);
    };
  }
  return Module;
};

/**
 * @constructor
 * @extends {Error}
 * @this {ExitStatus}
 */
function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun']) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}





/** @type {function(Array=)} */
function run(args) {
  args = args || Module['arguments'];

  if (runDependencies > 0) {
    return;
  }

  writeStackCookie();

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    if (ABORT) return;

    ensureInitRuntime();

    preMain();

    if (Module['onRuntimeInitialized']) Module['onRuntimeInitialized']();

    assert(!Module['_main'], 'compiled without a main, but one is present. if you added it from JS, use Module["onRuntimeInitialized"]');

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      doRun();
    }, 1);
  } else {
    doRun();
  }
  checkStackCookie();
}
Module['run'] = run;

function checkUnflushedContent() {
  // Compiler settings do not allow exiting the runtime, so flushing
  // the streams is not possible. but in ASSERTIONS mode we check
  // if there was something to flush, and if so tell the user they
  // should request that the runtime be exitable.
  // Normally we would not even include flush() at all, but in ASSERTIONS
  // builds we do so just for this check, and here we see if there is any
  // content to flush, that is, we check if there would have been
  // something a non-ASSERTIONS build would have not seen.
  // How we flush the streams depends on whether we are in NO_FILESYSTEM
  // mode (which has its own special function for this; otherwise, all
  // the code is inside libc)
  var print = Module['print'];
  var printErr = Module['printErr'];
  var has = false;
  Module['print'] = Module['printErr'] = function(x) {
    has = true;
  }
  try { // it doesn't matter if it fails
    var flush = Module['_fflush'];
    if (flush) flush(0);
    // also flush in the JS FS layer
    var hasFS = true;
    if (hasFS) {
      ['stdout', 'stderr'].forEach(function(name) {
        var info = FS.analyzePath('/dev/' + name);
        if (!info) return;
        var stream = info.object;
        var rdev = stream.rdev;
        var tty = TTY.ttys[rdev];
        if (tty && tty.output && tty.output.length) {
          has = true;
        }
      });
    }
  } catch(e) {}
  Module['print'] = print;
  Module['printErr'] = printErr;
  if (has) {
    warnOnce('stdio streams had content in them that was not flushed. you should set NO_EXIT_RUNTIME to 0 (see the FAQ), or make sure to emit a newline when you printf etc.');
  }
}

function exit(status, implicit) {
  checkUnflushedContent();

  // if this is just main exit-ing implicitly, and the status is 0, then we
  // don't need to do anything here and can just leave. if the status is
  // non-zero, though, then we need to report it.
  // (we may have warned about this earlier, if a situation justifies doing so)
  if (implicit && Module['noExitRuntime'] && status === 0) {
    return;
  }

  if (Module['noExitRuntime']) {
    // if exit() was called, we may warn the user if the runtime isn't actually being shut down
    if (!implicit) {
      Module.printErr('exit(' + status + ') called, but NO_EXIT_RUNTIME is set, so halting execution but not exiting the runtime or preventing further async execution (build with NO_EXIT_RUNTIME=0, if you want a true shutdown)');
    }
  } else {

    ABORT = true;
    EXITSTATUS = status;
    STACKTOP = initialStackTop;

    exitRuntime();

    if (Module['onExit']) Module['onExit'](status);
  }

  if (ENVIRONMENT_IS_NODE) {
    process['exit'](status);
  }
  Module['quit'](status, new ExitStatus(status));
}
Module['exit'] = exit;

var abortDecorators = [];

function abort(what) {
  if (Module['onAbort']) {
    Module['onAbort'](what);
  }

  if (what !== undefined) {
    Module.print(what);
    Module.printErr(what);
    what = JSON.stringify(what)
  } else {
    what = '';
  }

  ABORT = true;
  EXITSTATUS = 1;

  var extra = '';
  var output = 'abort(' + what + ') at ' + stackTrace() + extra;
  if (abortDecorators) {
    abortDecorators.forEach(function(decorator) {
      output = decorator(output, what);
    });
  }
  throw output;
}
Module['abort'] = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}


Module["noExitRuntime"] = true;

run();

// {{POST_RUN_ADDITIONS}}





// {{MODULE_ADDITIONS}}



//# sourceMappingURL=sql-debug.js.map

  return SQL;
};
if (typeof exports === 'object' && typeof module === 'object')
    module.exports = SQL;
  else if (typeof define === 'function' && define['amd'])
    define([], function() { return SQL; });
  else if (typeof exports === 'object')
    exports["SQL"] = SQL;
  